systemheader:(PA    )#                                                  PA     1
######################################################################  PA     2
#                                                                    #  PA     3
#                       **** PREABS ****                             #  PA     4
#                                                                    #  PA     5
#  PREABS MARK I:  The intent was to take a series of scanning 
#  electron microscope slides, of known rotation about some 
#  pseudo known axis, and then refine two angles describing the
#  misorientation of the axis with respect to the camera/photographic
#  axes, and then optimise a model of the crystal shape, specified
#  in terms of crystal vertices. They were then used to determine 
#  face planes abcd and hkl miller indices.
#  This actually worked quite well.
#  Unfortunately the math was way more complicated than it aught to
#  have been. 
#                        D. du boulay 1993 
#                                                                       PA     8
######################################################################  PA     9
#                                                                       PA    10
include:(XMACRO)#                                                       PA    11
macro:(postm:,CALL PA04($1,$2,$3))#                                     PA    12
macro:(mmult:,CALL PA05($1,$2,$3))#                                     PA    13
macro:(triple:,CALL PA06($1,$2,$3))#                                    PA    14
macro:(invert:,CALL PA08($1,$2))#                                       PA    15
macro:(sg:,ifelse:(mxbtwd:,32,SNGL($1),$1))#                            PA    16
#                                                                       PA    17
#                                                                       PA    18
extrude:(PACOMN)#                                                       PA    19
INTEGER PPKT#                          Projection packet size           PA    20
INTEGER VPKT#                          Vertex packet size               PA    21
INTEGER FPKT#                          Reduced face  packet size        PA    22
INTEGER VMAX#                          Number of crystal vertices       PA    23
INTEGER PNUM#                          Number of projections            PA    24
INTEGER FACES#                         Number of crystal faces          PA    25
INTEGER RFACES#                        Reduced num of crystl faces      PA    26
INTEGER SEM#                           Scanning microscope type         PA    27
INTEGER METHOD#                        Photos=2 digi image=1            PA    28
INTEGER STEREO#                        Stereo plot                      PA    29
INTEGER OLDSUB#                                                         PA    30
INTEGER IPCH#                                                           PA    31
INTEGER ICOS#                                                           PA    32
INTEGER RELTV#                                                          PA    33
INTEGER NPAIR#                         Num of pairs of photos           PA    34
INTEGER PROJDT#                        Qx space for projectn data       PA    35
INTEGER LSDRAB#                        Qx least square derivs alf bet   PA    36
INTEGER LSABDT#                        Qx least square alf bet data     PA    37
INTEGER DTPK#                          Alf bet data packet size         PA    38
INTEGER DRAB#                          Num of derivs of alfa beta       PA    39
INTEGER RELCOM#                        Qx relative coordinate matrice   PA    40
INTEGER WRKSPC#                        Qx workspace pointer             PA    41
INTEGER VC1D#                                                           PA    42
INTEGER MX2D#                                                           PA    43
INTEGER VCX#                                                            PA    44
INTEGER VCSG#                                                           PA    45
INTEGER FACE#                                                           PA    46
INTEGER RFACE#                         Reduced set of faces             PA    47
INTEGER EDGES#                                                          PA    48
INTEGER REDGES#                        Reduced set of edges             PA    49
INTEGER VERTC#                                                          PA    50
INTEGER DVERT#                                                          PA    51
INTEGER ATEST#                                                          PA    52
INTEGER DTEST#                                                          PA    53
INTEGER NTEST#                                                          PA    54
INTEGER PHROT#
#                                                                       PA    55
REAL OMIN,OMAX#                                                         PA    56
REAL DSCAL#                                                             PA    57
REAL XSCAL#                                                             PA    58
REAL YSCAL#                                                             PA    59
REAL CVOL#                                                              PA    60
REAL ROT(5)#                                                            PA    61
REAL TC(3,3)#                                                           PA    62
REAL PHI90#                                                             PA    63
REAL UB(3,3)#                                                           PA    64
REAL UINV(3,3)#                                                         PA    65
REAL TRANS(3,3)#                                                        PA    66
REAL UB1(3,3)#                         Inverse of ub                    PA    67
REAL MT(9)#                                                             PA    68
REAL PI#                                                                PA    69
REAL FUDG#                             Least square fudge factor        PA    70
REAL ALF#                              Rotation angle alpha             PA    71
REAL BET#                              Rotation angle beta              PA    72
REAL ADELT#                                                             PA    73
REAL DDELT#                                                             PA    74
REAL NDELT#                                                             PA    75
REAL PHMIN
REAL PHMAX
REAL PHSTP
REAL PHISH#                                                             PA10  42
#                                                                       PA    76
#                                                                       PA    77
COMMON/COMFPA/OMIN,OMAX,DSCAL,XSCAL,YSCAL,CVOL,UB1,TRANS,$#             PA    78
ROT,TC,PHI90,UB,UINV,MT,PI,FUDG,ALF,BET,ADELT,DDELT,NDELT,$#
PHMIN,PHMAX,PHSTP,PHISH# 
#                                                                       PA    80
#                                                                       PA    81
COMMON/COMIPA/PPKT,VPKT,PNUM,ATEST,DTEST,NTEST,$# Integer common stor   PA    82
SEM,METHOD,STEREO,OLDSUB,IPCH,ICOS,RELTV,VMAX,RFACES,FPKT,$#            PA    83
VC1D,MX2D,VCX,VCSG,FACE,EDGES,VERTC,FACES,RFACE,REDGE,$#                PA    84
NPAIR,PROJDT,LSDRAB,LSABDT,DRAB,RELCOM,WRKSPC,DTPK,$#                   PA    85
DVERT,PHROT#
#                                                                       PA    87
#                                                                       PA    88
endext:#                                                                PA    89
#                                                                       PA    90
systemheader:(PA00)#                                                    PA00   1
#################################################################       PA00   2
#                                                               #       PA00   3
#                             PA00                              #       PA00   4
#                                                               #       PA00   5
#################################################################       PA00   6
SUBROUTINE PA00#                                                        PA00   7
include:(AACOMN)#                                                       PA00   8
include:(PACOMN)#                                                       PA00   9
#                                                                       PA00  10
FILEXT(IOUNIT(5))='ABS'#               Output plot file of xtal shape   PA00  11
#                                                                       PA00  12
CALL PA10#                                                              PA00  13
IF(METHOD==2)#                         If not spherical                 PA00  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA00  15
CALL PA51#                             Load in vertices                 PA00  16
CALL PA53#                             Refine angles alpha beta         PA00  17
CALL PA54#                             Determn relatve coord matrix     PA00  18
CALL PA55#                             Refine absolute coords           PA00  19
CALL PA56#                             Determine triangular faces       PA00  20
CALL PA61#                             Reduce face set                  PA00  21
CALL PA63#                             Miller indices                   PA00  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA00  23
IF(METHOD==1)#                         Digitized pictures??             PA00  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA00  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA00  26
#                                                                       PA00  27
RETURN#                                                                 PA00  28
END#                                                                    PA00  29
#                                                                       PA00  30
systemheader:(PA01)#                                                    PA01   1
###################################################################     PA01   2
#                                                                 #     PA01   3
#                             PA01                                #     PA01   4
#                                                                 #     PA01   5
###################################################################     PA01   6
SUBROUTINE PA01(H1,H2,T)#                                               PA01   7
#                                                                       PA01   8
## COMPUTE NORMALIZED CROSS PRODUCT                                     PA01   9
## XRAY PROGRAM BY H.L. AMMON, SEPTEMBER 1971                           PA01  10
## XTAL PROGRAM BY J.M. STEWART, NOVEMBER 1980                          PA01  11
#                                                                       PA01  12
REAL H1(3)#                            First vector                     PA01  13
REAL H2(3)#                            Second vector                    PA01  14
REAL S#                                Normalization factor             PA01  15
REAL T(3)#                             Cross product                    PA01  16
INTEGER N#                                                              PA01  17
#                                                                       PA01  18
T(1)=H1(2)*H2(3)-H1(3)*H2(2)#          First element                    PA01  19
T(2)=H1(3)*H2(1)-H1(1)*H2(3)#          Second element                   PA01  20
T(3)=H1(1)*H2(2)-H1(2)*H2(1)#          Third element                    PA01  21
S=1.0/SQRT(T(1)**2+T(2)**2+T(3)**2)#   Normalization factor             PA01  22
T(1)=T(1)*S ; T(2)=T(2)*S ; T(3)=T(3)*S# Normalize                      PA01  23
#                                                                       PA01  24
RETURN#                                                                 PA01  25
END#                                                                    PA01  26
systemheader:(PA04)#                                                    PA04   1
####################################################################    PA04   2
#                                                                  #    PA04   3
#                              PA04                                #    PA04   4
#                                                                  #    PA04   5
####################################################################    PA04   6
SUBROUTINE PA04(A,B,C)#                                                 PA04   7
#                                                                       PA04   8
REAL A(3,3)#                           Matrix                           PA04   9
REAL B(3)#                             Vector                           PA04  10
REAL C(3)#                             New vector c=a*b                 PA04  11
#                                                                       PA04  12
C(1)=A(1,1)*B(1)+A(1,2)*B(2)+A(1,3)*B(3)# First element                 PA04  13
C(2)=A(2,1)*B(1)+A(2,2)*B(2)+A(2,3)*B(3)# Second element                PA04  14
C(3)=A(3,1)*B(1)+A(3,2)*B(2)+A(3,3)*B(3)# Third element                 PA04  15
RETURN#                                                                 PA04  16
END#                                                                    PA04  17
systemheader:(PA05)#                                                    PA05   1
#################################################################       PA05   2
#                                                               #       PA05   3
#                            PA05                               #       PA05   4
#                                                               #       PA05   5
#################################################################       PA05   6
SUBROUTINE PA05(A,B,C)#                                                 PA05   7
#                                                                       PA05   8
## 3X3 MATRIX MULTIPLY                                                  PA05   9
## H.L. AMMON, 1971                                                     PA05  10
## FORSYTH, 1973                                                        PA05  11
## J.M. STEWART, 1980                                                   PA05  12
#                                                                       PA05  13
REAL A(3,3)#                           First matrix                     PA05  14
REAL B(3,3)#                           Second matrix                    PA05  15
REAL C(3,3)#                           Product matrix                   PA05  16
INTEGER I#                             Loop index                       PA05  17
INTEGER J#                             Loop index                       PA05  18
INTEGER K#                             Loop index                       PA05  19
#                                                                       PA05  20
DO I=1,3#                              Loop over 3 elements             PA05  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA05  22
DO J=1,3#                              Loop over 3 elements             PA05  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA05  24
C(I,J)=0.0#                            Initialize output element        PA05  25
DO K=1,3#                              Sum of element products          PA05  26
C(I,J)=C(I,J)+A(I,K)*B(K,J)#           Product element                  PA05  27
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA05  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA05  29
#                                                                       PA05  30
RETURN#                                                                 PA05  31
END#                                                                    PA05  32
systemheader:(PA06)#                                                    PA06   1
##################################################################      PA06   2
#                                                                #      PA06   3
#                            PA06                                #      PA06   4
#                                                                #      PA06   5
##################################################################      PA06   6
SUBROUTINE PA06(H1,H2,T)#                                               PA06   7
#                                                                       PA06   8
## FORM A RIGHT-HANDED UNIT VECTOR TRIPLE                               PA06   9
## H.L. AMMON, SEPTEMBER 1971                                           PA06  10
## J.M. STEWART, NOVEMBER 1980                                          PA06  11
#                                                                       PA06  12
REAL H1(3)#                            First input vector               PA06  13
REAL H2(3)#                            Second input vector              PA06  14
REAL S#                                Normalization factor             PA06  15
REAL T(3,3)#                           Vector triple (columns)          PA06  16
REAL TEMP(3)#                          Temporary storage                PA06  17
REAL TEMP1(3)#                         Temporary storage                PA06  18
#                                                                       PA06  19
S=1.0/SQRT(H1(1)**2+H1(2)**2+H1(3)**2)# Normalization factor            PA06  20
T(1,1)=H1(1)*S#                        First element vector 1           PA06  21
T(2,1)=H1(2)*S#                        Second                           PA06  22
T(3,1)=H1(3)*S#                        Third                            PA06  23
#                                                                       PA06  24
CALL PA01(H1,H2,TEMP)#                 Vector 3                         PA06  25
T(1,3)=TEMP(1)#                        First element                    PA06  26
T(2,3)=TEMP(2)#                        Second                           PA06  27
T(3,3)=TEMP(3)#                        Third                            PA06  28
#                                                                       PA06  29
CALL PA01(TEMP,H1,TEMP1)#              Vector 2                         PA06  30
T(1,2)=TEMP1(1)#                       First element                    PA06  31
T(2,2)=TEMP1(2)#                       Second                           PA06  32
T(3,2)=TEMP1(3)#                       Third                            PA06  33
#                                                                       PA06  34
RETURN#                                                                 PA06  35
END#                                                                    PA06  36
#                                                                       PA06  37
systemheader:(PA08)#                                                    PA08   1
####################################################################    PA08   2
#                                                                  #    PA08   3
#  MATRIX INVERSION                                                     PA08   4
#                                                                  #    PA08   5
####################################################################    PA08   6
SUBROUTINE PA08(A,B)#                                                   PA08   7
#                                                                       PA08   8
REAL A(3,3)#                                                            PA08   9
REAL B(3,3)#                                                            PA08  10
REAL DETERM#                                                            PA08  11
#                                                                       PA08  12
DETERM=A(1,1)*A(2,2)*A(3,3)-A(1,1)*A(2,3)*A(3,2)+$#                     PA08  13
A(1,3)*A(2,1)*A(3,2)-A(1,3)*A(2,2)*A(3,1)+$#                            PA08  14
A(1,2)*A(2,3)*A(3,1)-A(1,2)*A(2,1)*A(3,3)#                              PA08  15
#                                                                       PA08  16
B(1,1)=(A(2,2)*A(3,3)-A(3,2)*A(2,3))/DETERM#                            PA08  17
B(1,2)=-(A(1,2)*A(3,3)-A(3,2)*A(1,3))/DETERM#                           PA08  18
B(1,3)=(A(1,2)*A(2,3)-A(2,2)*A(1,3))/DETERM#                            PA08  19
B(2,1)=-(A(2,1)*A(3,3)-A(3,1)*A(2,3))/DETERM#                           PA08  20
B(2,2)=(A(1,1)*A(3,3)-A(3,1)*A(1,3))/DETERM#                            PA08  21
B(2,3)=-(A(1,1)*A(2,3)-A(2,1)*A(1,3))/DETERM#                           PA08  22
B(3,1)=(A(2,1)*A(3,2)-A(3,1)*A(2,2))/DETERM#                            PA08  23
B(3,2)=-(A(1,1)*A(3,2)-A(3,1)*A(1,2))/DETERM#                           PA08  24
B(3,3)=(A(1,1)*A(2,2)-A(2,1)*A(1,2))/DETERM#                            PA08  25
#                                                                       PA08  26
RETURN#                                                                 PA08  27
END#                                                                    PA08  28
#                                                                       PA08  29
systemheader:(PA10)#                                                    PA10   1
################################################################        PA10   2
#                                                              #        PA10   3
#                            PA10                              #        PA10   4
#                                                              #        PA10   5
################################################################        PA10   6
SUBROUTINE PA10#                                                        PA10   7
include:(AACOMN)#                                                       PA10   8
include:(PACOMN)#                                                       PA10   9
#                                                                       PA10  10
## J.M. STEWART, NOVEMBER 1980                                          PA10  11
## G. DAVENPORT, JANUARY 1982                                           PA10  12
## T. MASLEN, JANUARY 1984                                              PA10  13
## N. SPADACCINI, MARCH 1989 - PSI SCANS INCLUDED                       PA10  14
#                                                                       PA10  15
INTEGER I#                             Loop index                       PA10  16
INTEGER IP#                            Packet pointer                   PA10  17
INTEGER IPP#                           Pointer                          PA10  18
INTEGER IREL(4)#                       Relative pointers                PA10  19
INTEGER IWANT(3)#                      Want list for indexpkt           PA10  20
INTEGER J#                             Loop index                       PA10  21
INTEGER JP#                            Pointer                          PA10  22
INTEGER KEY(4)#                        Keys for indexpkt                PA10  23
INTEGER M#                             Start of string                  PA10  24
INTEGER N#                             End of string                    PA10  25
INTEGER PSIZE#                         Packet size                      PA10  26
INTEGER IWAV#                          Wave length index                PA10  27
INTEGER INDX#                          Table index for mua-ta           PA10  28
INTEGER IDXMU#                         Key for emu-source               PA10  29
INTEGER NSF#                           (number of atom types)           PA10  30
INTEGER KEY1#                                                           PA10  31
#                                                                       PA10  32
REAL CHI#                              Chi                              PA10  33
REAL PHI#                              Phi                              PA10  34
REAL TCTRAN(3,3)#                      Tc transpose                     PA10  35
REAL TRAN(3,3)#                                                         PA10  36
REAL TPHI(3,3)#                        Vector triple                    PA10  37
REAL U(3,3)#                           Rotation matrix                  PA10  38
REAL VEC(10)#                          Orref vectors                    PA10  39
REAL B(3,3)#                                                            PA10  40
REAL BINV(3,3)#                        Inverse of b                     PA10  41
REAL PHISHF(3,3)#                                                       PA10  43
#                                                                       PA10  44
string:(ACH,108)#                      Char store for atom types        PA10  45
#                                                                       PA10  46
chardata:(PA101,DIGI PHOT SCAL MAGN PHI  $#                             PA10  47
STER PROJ DCOS PCH  )#                                                  PA10  48
chardata:(PA102,DIFF   ORIENT ROTATE END     )#
chardata:(PA103,AC  DIGI IMAGE PHOTOGRAPH  YES NO     SPHERICAL)#       PA10  50
chardata:(PA104, DETERMINATION FROM      PHOTOGRAPHS)#
chardata:(PA10B, PHOTO HORIZONTAL SCALE FACTOR      )#
chardata:(PA10C, PHOTO VERTICAL   SCALE FACTOR      )#
chardata:(PA10D, CALCULATE DIRECTION COSINES  YES)#                     PA10  60
chardata:(PA10E, PUNCH REFLECTION CARDS WITH  FREL  TBAR  DIR.COSINES)# PA10  61
chardata:(PA10F,(INPUT)     (CALCULATED)(DEFAULT)   )#                  PA10  62
chardata:(PA10H, PLOT CRYSTAL VIEWS IN PROJECTION )#                    PA10  64
chardata:(PA10I,STEREO    PROJECTION)#                                  PA10  65
chardata:(PA10J, ROTATION SENSES  THETA/CHI/PHI             C C C    )# PA10  66
chardata:(PA10K,/OMEGA/PSI  )#                                          PA10  67
#                                                                       PA10  68
#                                                                       PA10  69
realdata:(FM,[210303.,350403.,521042.])#                                PA10  70
realdata:(WV,[1.54179,0.7106])#                                         PA10  71
datastuff:#                                                             PA10  72
#                                                                       PA10  73
# SET UP INPUT AND OUTPUT FILE BUFFERS                                  PA10  74
# ------------------------------------                                  PA10  75
#                                                                       PA10  76
IOMARK(1)=QXSTR#                       Start of input buffer            PA10  77
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of output buffer           PA10  78
IOMARK(3)=IOMARK(2)+bdfbuf:#           Start plot buffer                PA10  79
incrqx:(PROJDT,IOMARK(3)+bdfbuf:,PA1001)# Start of face array           PA10  80
OMIN=-.837758 ; OMAX=1.01229#          Default omega limits - syntex    PA10  81
#                                                                       PA10  82
# INTERPRET THE ABSORB LINE                                             PA10  83
# -------------------------                                             PA10  84
#                                                                       PA10  85
METHOD=1#                              Default gaussian                 PA10  86
ICOS=0#                                No direction cosines             PA10  87
IPNCH=0#                               No punch                         PA10  88
STEREO=no:#                            Assume projection plots          PA10  89
OLDSUB=-1#                             But if stereo set color          PA10  90
SCALE=1.0#                                                              PA10  91
XSCAL=1.0#                                                              PA10  92
YSCAL=1.0#                                                              PA10  93
SEM=505#                                                                PA10  94
PI=3.1415927#                                                           PA10  95
PHISH=0.0#                                                              PA10  96
PHIROT=no:
RELTV=2#                               Relative coords                  PA10  97
#                                                                       PA10  98
#                                                                       PA10  99
DO I=1,mxfdim:#                        Loop over rest of fields         PA10 100
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA10 101
IF(BUFIN(I)>=voidflg:) NEXT#           Next on void                     PA10 102
stringlim:(I,M,N)#                     Get string limits                PA10 103
compchar:(CHRIN,M,PA101,1,4,5,NPA101,KEY1)# Identify string             PA10 104
IF     (KEY1==0) NEXT#                 Unidentified code                PA10 105
ELSE IF(KEY1<3)  METHOD=KEY1#          Calculation method               PA10 106
ELSE IF(KEY1==3)#                                                       PA10 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA10 108
IF ((BUFIN(I+1)>0)&(BUFIN(I+2)>0))#                                     PA10 109
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA10 110
XSCAL=BUFIN(I+1);YSCAL=BUFIN(I+2);I=I+2#                                PA10 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA10 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA10 113
ELSE IF(KEY1==4)#                                                       PA10 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA10 115
MAGN=BUFIN(I+1) ; I=I+1#                                                PA10 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA10 117
ELSE IF (KEY1==5)#                                                      PA10 118
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA10 119
PHISH=BUFIN(I+1)*PI/180.; I=I+1#                                        PA10 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA10 121
ELSE IF(KEY1==6) STEREO=yes:#          Vset for stereo views            PA10 122
ELSE IF(KEY1==8) ICOS=6#               Output dir. cosines              PA10 123
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA10 124
copyfile:(1,2,1,decr:(lrcell:))#       Copy up to lrcell                PA10 125
#                                                                       PA10 126
# OUTPUT FOR USER                                                       PA10 127
# ---------------                                                       PA10 128
#                                                                       PA10 129
IF(METHOD==1) movechar:(PA103, 5,PA104,26,10,0)# Print digi image
IF(METHOD==2) movechar:(PA103,16,PA104,26,10,0)# Print photograph
writeline:(1,PA104,NPA104,3,3)#                                         PA10 132
movechar:(PA10I,11,PA10H,24,10,0)#     Default projection views         PA10 133
IF(STEREO==yes:) movechar:(PA10I,1,PA10H,24,10,0)# Stereo views         PA10 134
writeline:(0,PA10H,NPA10H,3,3)#                                         PA10 135
IF (ICOS>0) writeline:(0,PA10D,NPA10D,3,3)#                             PA10 136
ncodefld:(XSCAL,1,PA10B,360622.,1)#                                     PA10 137
writeline:(0,PA10B,NPA10B,3,3)#                                         PA10 138
ncodefld:(YSCAL,1,PA10C,360622.,1)#                                     PA10 139
writeline:(0,PA10C,NPA10C,3,3)#                                         PA10 140
#                                                                       PA10 141
# GET THE B MATRIX FROM LRCELL:                                         PA10 142
# -----------------------------                                         PA10 143
#                                                                       PA10 144
DO K=1,10#                             Loop over lrcell packets         PA10 145
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA10 146
readwpkt:(1,lrcell:,PSIZE,IP,0)#       Point to next lrcell pkt         PA10 147
IF(IP<=0) BREAK#                       Exit after last packet           PA10 148
writepkt:(2,lrcell:,PSIZE,IPP)#                                         PA10 149
movereal:(QX,IP+1,QX,IPP+1,PSIZE,1)#                                    PA10 150
IF(K==5)#                              Skip unless trans matrix         PA10 151
DO I=1,3;  DO J=1,3#                   Loop over columns & rows         PA10 152
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA10 153
JP=IP+3*I-3+J#                         Point into qx                    PA10 154
B(J,I)=QX(JP)#                         Store element                    PA10 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA10 156
IF(K==6) CVOL=QX(IP+1)#                Get cell volume                  PA10 157
IF(K==8)#                              Test if inv metric tensor        PA10 158
DO I=1,9; MT(I)=QX(IP+I)#              Store metric tensor              PA10 159
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA10 160
#                                                                       PA10 161
#                                                                       PA10 162
copyfile:(1,2,incr:(lrexpl:),decr:(lrrefl:))# Copy up to lrrefl:        PA10 163
#                                                                       PA10 164
# READ DIFF AND ORIENT LINES                                            PA10 165
# -------------------------                                             PA10 166
#                                                                       PA10 167
IF(METHOD!=3)#                         For gaussian and analytical      PA10 168
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PA10 169
PHI90=0.0#                             Default 0.0                      PA10 170
DO J=1,5; ROT(J)=1.0#                  Default clockwise                PA10 171
DO K=1,3#                              Loop over input lines            PA10 172
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PA10 173
readline:(PA102,-NPA102)#               Read control line                PA10 174
#                                                                       PA10 175
# DIFF LINE                                                             PA10 176
# ---------                                                             PA10 177
#                                                                       PA10 178
IF(LINID==1)#                          Diff line                        PA10 179
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PA10 180
DO J=1,3#                              Loop over compulsory fields 1-   PA10 181
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PA10 182
ifnm:(BUFIN(J)) iquit:(PA1002)#        Character field                  PA10 183
stringlim:(J,M,N)#                     Get string limits                PA10 184
compchar:(CHRIN,M,PA103,1,1,1,2,N)#    Identify string                  PA10 185
IF(N==0) iquit:(PA1002)#               Default clockwise                PA10 186
IF(N==1)#                              Anticlockwise                    PA10 187
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PA10 188
ROT(J)=-1.0#                           Store rotation element           PA10 189
movechar:(PA103,1,PA10J,45+(J-1)*2,1,0)# Rotation sense output          PA10 190
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PA10 191
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PA10 192
DO J=4,5#                                                               PA10 193
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PA10 194
ifvo:(BUFIN(J)) NEXT#                  If not there - next              PA10 195
movechar:(PA10K,1+(J-4)*6,PA10J,32+(J-4)*6,6,0)# Title                  PA10 196
stringlim:(J,M,N)#                     Get string limits                PA10 197
compchar:(CHRIN,M,PA103,1,1,1,2,N)#    Identify string                  PA10 198
IF(N==0) iquit:(PA1002)#               Default clockwise                PA10 199
IF(N==1)#                                                               PA10 200
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PA10 201
ROT(J)=-1#                                                              PA10 202
movechar:(PA103,1,PA10J,45+(J-1)*2,1,0)#                                PA10 203
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PA10 204
ELSE movechar:(PA103,2,PA10J,45+(J-1)*2,1,0)#                           PA10 205
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PA10 206
writeline:(0,PA10J,NPA10J,3,3)#                                         PA10 207
ifnm:(BUFIN(6)) PHI90=BUFIN(6)*.017453# Phi at chi=90                   PA10 208
ELSE     PHI90=0.0#                    Default 0.0                      PA10 209
ifnm:(BUFIN(7)) OMIN=BUFIN(7)/57.29578# Omega min in radians            PA10 210
ifnm:(BUFIN(8)) OMAX=BUFIN(8)/57.29578# Omega max in radians            PA10 211
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PA10 212
#                                                                       PA10 213
# ORIENT LINE                                                           PA10 214
# -----------                                                           PA10 215
#                                                                       PA10 216
ELSE IF(LINID==2)#                     Orient line                      PA10 217
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PA10 218
DO I=1,10#                             Loop over fields                 PA10 219
IF(BUFIN(I)<=voidflg:) iquit:(PA1003)# Non-numeric, so quit             PA10 220
postm:(B,BUFIN,VEC)#                   B x hkl                          PA10 221
postm:(B,BUFIN(6),VEC(4))#             B x hkl                          PA10 222
triple:(VEC,VEC(4),TC)#                Form vector triple               PA10 223
#                                                                       PA10 224
CHI=0.01745329*BUFIN(4)#               Chi                              PA10 225
PHI=0.01745329*BUFIN(5)#               Phi                              PA10 226
VEC(1)=ROT(1)*COS(CHI)*COS(PHI)#       Element 1                        PA10 227
VEC(2)=ROT(1)*ROT(3)*COS(CHI)*SIN(PHI)# Element 2                       PA10 228
VEC(3)=ROT(1)*ROT(2)*SIN(CHI)#         Element 3                        PA10 229
#                                                                       PA10 230
CHI=0.01745329*BUFIN(9)#               Chi                              PA10 231
PHI=0.01745329*BUFIN(10)#              Phi                              PA10 232
VEC(4)=ROT(1)*COS(CHI)*COS(PHI)#       Element 1                        PA10 233
VEC(5)=ROT(1)*ROT(3)*COS(CHI)*SIN(PHI)# Element 2                       PA10 234
VEC(6)=ROT(1)*ROT(2)*SIN(CHI)#         Element 3                        PA10 235
#                                                                       PA10 236
triple:(VEC,VEC(4),TPHI)#              Form vector triple               PA10 237
#                                                                       PA10 238
DO I=1,3#                                                               PA10 239
DO J=1,3#                                                               PA10 240
TCTRAN(I,J)=TC(J,I)#                                                    PA10 241
mmult:(TPHI,TCTRAN,U)#                 Matrix multiply                  PA10 242
#                                                                       PA10 243
DO I=1,3#                                                               PA10 244
DO J=1,3#                                                               PA10 245
UINV(I,J)=U(J,I)#                                                       PA10 246
#                                                                       PA10 247
BINV(1,1)=1/B(1,1)#                                                     PA10 248
BINV(2,1)=0.0#                                                          PA10 249
BINV(3,1)=0.0#                                                          PA10 250
BINV(1,2)=-B(1,2)/B(1,1)/B(2,2)#                                        PA10 251
BINV(2,2)=1/B(2,2)#                                                     PA10 252
BINV(3,2)=0.0#                                                          PA10 253
BINV(1,3)=(B(1,2)*B(2,3)-B(1,3)*B(2,2))/(B(1,1)*B(2,2)*B(3,3))#         PA10 254
BINV(2,3)=-B(2,3)/B(2,2)/B(3,3)#                                        PA10 255
BINV(3,3)=1/B(3,3)#                                                     PA10 256
#                                                                       PA10 257
#                                                                       PA10 258
mmult:(U,B,UB)#                        Matrix multiply                  PA10 259
mmult:(BINV,UINV,UB1)#                 Matrix multiply                  PA10 260
#                                                                       PA10 261
DO IROW=1,3#                                                            PA10 262
DO JCOL=1,3 ;TRAN(IROW,JCOL)=0.0#                                       PA10 263
TRAN(2,2)=1.0 ;TRAN(1,3)=1.0 ; TRAN(3,1)=-1.0#                          PA10 264
PHISHF(1,1)=COS(PHISH) ; PHISHF(1,2)=SIN(PHISH); PHISHF(1,3)=0.0#       PA10 265
PHISHF(2,1)=-SIN(PHISH); PHISHF(2,2)=COS(PHISH); PHISHF(2,3)=0.0#       PA10 266
PHISHF(3,1)=0.0        ; PHISHF(3,2)=0.0       ; PHISHF(3,3)=1.0#       PA10 267
mmult:(PHISHF,TRAN,TRANS)#                                              PA10 268
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PA10 269
#
#
#
#
ELSE IF(LINID==3)#                     Multiple rotations about phi
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PA10 218
PHrot=yes:
ifnm:(BUFIN(1)) PHmin=BUFIN(1)*.017453-phish#
ELSE     PHmin=0.0-phish#              Default 0.0                      PA10 209
ifnm:(BUFIN(2)) PHmax=BUFIN(2)*.017453-phish#
ELSE     PHmax=360.0-phish#            Default 0.0                      PA10 209
ifnm:(BUFIN(3)) PHstp=BUFIN(3)*.017453#
ELSE     PHstp=360.0#                  Default 0.0                      PA10 209
$)
ELSE iF(LINID==0&K==3) BREAK
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PA10 270
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PA10 271
#                                                                       PA10 272
#                                                                       PA10 273
copyfile:(1,2,incr:(lrrefl:),endrecord:)#                               PA10 274
#                                                                       PA10 275
RETURN#                                                                 PA10 276
END#                                                                    PA10 277
systemheader:(PA51)#                                                    PA51   1
####################################################################    PA51   2
#                                                                  #    PA51   3
#                    LOAD IN THE VERTICES                          #    PA51   4
#                                                                  #    PA51   5
####################################################################    PA51   6
SUBROUTINE PA51#                                                        PA51   7
include:(AACOMN)#                                                       PA51   8
include:(PACOMN)#                                                       PA51   9
#                                                                       PA51  10
# QX FORMAT       PROJPKT;VERTXPKT;VETXPKT;VERTXPKT...PROJPKT           PA51  11
#   PROJPKT                                                             PA51  12
#          PROJECTION   ROTATN TILT   ABSOLUTE  NUMBER OF   XAVE  YAVE  PA51  13
#           NUMBER      ANGLE  ANGLE   ANGLE    VERTICES                PA51  14
#VERTEXPKT                                                              PA51  15
#          VERTEX ID    X    Y   Z1,Z2,Z3...
#                                                                       PA51  17
#                                                                       PA51  18
## READ IN LINES DEFINING THE CRYSTAL  vertices                         PA51  19
#                                                                       PA51  20
INTEGER MARKA,MARKB#                                                    PA51  21
INTEGER STOPA,STOPB#                                                    PA51  22
INTEGER LINID1#                                                         PA51  23
INTEGER VNUM#                                                           PA51  24
INTEGER N#                                                              PA51  25
INTEGER PROJ#                                                           PA51  26
INTEGER SWAP#                                                           PA51  27
REAL ABSANG#                                                            PA51  28
REAL TEMP(50,2)#                                                        PA51  29
REAL TMP(2)#                                                            PA51  30
#                                                                       PA51  31
chardata:(PA511,PROJ VERT END  )#                                       PA51  32
datastuff:#                                                             PA51  33
#                                                                       PA51  34
PPKT= 10#                              Size of projection packet        PA51  35
VPKT= 10#                              Size of vertex packe             PA51  36
STOPA=PROJDT#                          Beginning of input data          PA51  37
readline:(PA511,NPA511)#               Get first projct line            PA51  38
LINID1=LINID#                          Memorize the option used         PA51  39
PNUM=0#                                                                 PA51  40
VMAX=0#                                                                 PA51  41
#                                                                       PA51  42
REPEAT#                                Loop over remaining input line   PA51  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA51  44
IF(LINID!=1) BREAK#                    End line                         PA51  45
PNUM=PNUM+1#                                                            PA51  46
MARKA=STOPA#                                                            PA51  47
incrqx:(STOPA,MARKA+PPKT,PA5101)#      Get memory  for projection dir   PA51  48
ifnm:(BUFIN(1)) QX(MARKA+6)=BUFIN(1)#  Photonumber                      PA51  49
ifnm:(BUFIN(2)) QX(MARKA+2)=BUFIN(2)#  Sem phi angle a - manual rotn    PA51  50
ifnm:(BUFIN(3)) QX(MARKA+3)=BUFIN(3)#  Sem phi angle b - tilt angle     PA51  51
ifnm:(BUFIN(4))QX(MARKA+9)=BUFIN(4)#   Alpha angle input                PA51  52
ELSE QX(MARKA+9)=0.0#                  Default alpha                    PA51  53
ifnm:(BUFIN(5))QX(MARKA+10)=BUFIN(5)#  Beta angle input                 PA51  54
ELSE QX(MARKA+10)=0.0#                 Default beta                     PA51  55
QX(MARKA+1)=FLOAT(PNUM)#               Order number of photo            PA51  56
#                                                                       PA51  57
IF (SEM== 505)#                        If philips505 in default mode    PA51  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA51  59
ABSANG= (BUFIN(2)-BUFIN(3))*PI/180.#   Absolute phi coordinate          PA51  60
IF (ABSANG<0) ABSANG=ABSANG+2.*PI#     Phi in radians                   PA51  61
QX(MARKA+4)=ABSANG#                                                     PA51  62
WRITE(6,*)"ang",ABSANG*180/PI,"photo numb ",BUFIN(1)#                   PA51  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA51  64
#                                                                       PA51  65
#      GET VERTICES COMMON TO PHOTO                                     PA51  66
#      ----------------------------                                     PA51  67
#                                                                       PA51  68
VNUM=0#                                Initialize vertex number         PA51  69
REPEAT#                                                                 PA51  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA51  71
readline:(PA511,NPA511)#                                                PA51  72
IF(LINID!=2) BREAK#                    Vertex line                      PA51  73
VNUM=VNUM+1#                           Increment vertex counter         PA51  74
incrqx:(STOPA,STOPA+VPKT,PA5101)#      Get memory for vertex file       PA51  75
ifnm:(BUFIN(1))QX(STOPA+1-VPKT)=BUFIN(1)# Vertex identity               PA51  76
VMAX=MAX(VMAX,NINT(BUFIN(1)))#                                          PA51  77
ifnm:(BUFIN(2))QX(STOPA+2-VPKT)=BUFIN(2)*XSCAL# X position of vertex    PA51  78
ifnm:(BUFIN(3))QX(STOPA+3-VPKT)=-BUFIN(3)*YSCAL# Y position of vertex   PA51  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA51  80
QX(MARKA + 5)=FLOAT(VNUM)#             No of vertices counted           PA51  81
TEMP(PNUM,1)=FLOAT(PNUM)#                                               PA51  82
TEMP(PNUM,2)=ABSANG#                                                    PA51  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA51  84
incrqx:(WRKSPC,STOPA+2*(PPKT+VMAX*VPKT),PA5104)#                        PA51  85
#                                                                       PA51  86
#   ORDER THE POINTERS                                                  PA51  87
#   ------------------                                                  PA51  88
#                                                                       PA51  89
REPEAT#                                                                 PA51  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA51  91
SWAP=no:#                                                               PA51  92
DO PROJ=1,PNUM-1#                                                       PA51  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA51  94
IF (TEMP(PROJ,2)>TEMP(PROJ+1,2))#                                       PA51  95
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA51  96
TMP(1)=TEMP(PROJ,1); TMP(2)=TEMP(PROJ,2)#                               PA51  97
TEMP(PROJ,1)=TEMP(PROJ+1,1);TEMP(PROJ,2)=TEMP(PROJ+1,2)#                PA51  98
TEMP(PROJ+1,1)=TMP(1);TEMP(PROJ+1,2)=TMP(2)#                            PA51  99
SWAP=yes:#                                                              PA51 100
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA51 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA51 102
IF (SWAP==no:)BREAK#                                                    PA51 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA51 104
DO J=1,2#                              Copy first two projns to end     PA51 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA51 106
DO I=1,2 ;TEMP(PNUM+J,I)=TEMP(J,I)#                                     PA51 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA51 108
PNUM=PNUM+2#                                                            PA51 109
#                                                                       PA51 110
#   ORDER THE PROJECTIONS                                               PA51 111
#   ---------------------                                               PA51 112
#                                                                       PA51 113
MARKA=PROJDT#                          P                                PA51 114
MARKB=WRKSPC#                                                           PA51 115
DO PROJ=1,PNUM#                                                         PA51 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PA51 117
REPEAT#                                                                 PA51 118
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PA51 119
N=NINT(QX(MARKA+5))#                   Number of vertices in pic        PA51 120
ifeq:(QX(MARKA+1),TEMP(PROJ,1))#                                        PA51 121
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PA51 122
incrqx:(STOPB,MARKB+PPKT,PA5101)#      Get memory  for projection dir   PA51 123
movereal:(QX,MARKA+1,QX,MARKB+1,PPKT,1)# Directory packet               PA51 124
incrqx:(STOPB,STOPB+N*VPKT,PA5101)#    Get memory  for vertex files     PA51 125
movereal:(QX,MARKA+PPKT+1,QX,MARKB+PPKT+1,VPKT*N,1)# All files          PA51 126
MARKA= PROJDT#                                                          PA51 127
BREAK#                                                                  PA51 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PA51 129
ELSE MARKA= MARKA+PPKT +N*VPKT#                                         PA51 130
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PA51 131
CALL PA52(MARKB)#                      Get average                      PA51 132
MARKB=STOPB#                           Update pntr for next proj        PA51 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PA51 134
movereal:(QX,WRKSPC+1,QX,PROJDT+1,STOPB-WRKSPC,1)# Copy projdt back     PA51 135
WRKSPC=PROJDT+STOPB-WRKSPC#                                             PA51 136
#                                                                       PA51 137
#                                                                       PA51 138
RETURN#                                                                 PA51 139
END#                                                                    PA51 140
systemheader:(PA52)#                                                    PA52   1
####################################################################    PA52   2
#                                                                  #    PA52   3
#                    FIND AVERAGE FOR EACH PROJECTION                   PA52   4
#                                                                  #    PA52   5
####################################################################    PA52   6
SUBROUTINE PA52(CMARK)#                                                 PA52   7
include:(AACOMN)#                                                       PA52   8
include:(PACOMN)#                                                       PA52   9
#                                                                       PA52  10
#  FIND THE BOUNDARY POINTS OF THE DEFINED SHAPE                        PA52  11
# FROM THE VERTICES AND THEN FIND AVERAGE X AND Y                       PA52  12
#                                                                       PA52  13
INTEGER CMARK#                         Point to vertex drectry          PA52  14
INTEGER I,J,K#                                                          PA52  15
INTEGER NV#                                                             PA52  16
INTEGER MARKC#                                                          PA52  17
INTEGER VLOG(50)#                                                       PA52  18
INTEGER NEWPT#                                                          PA52  19
REAL X1,X2,Y1,Y2#                                                       PA52  20
REAL DELX,DELY#                                                         PA52  21
REAL NEWX,NEWY#                                                         PA52  22
REAL XAVE,YAVE#                                                         PA52  23
REAL A,B#                              Quadrant pointers                PA52  24
REAL MNGRAD#                                                            PA52  25
#                                                                       PA52  26
datastuff:#                                                             PA52  27
#                                                                       PA52  28
NV=NINT(QX(CMARK+5))#                  Number of vertices in pic        PA52  29
MARKC=CMARK+PPKT#                      First vertex                     PA52  30
IF(NV==0)RETURN#                                                        PA52  31
#                                                                       PA52  32
#   START FROM MINIMUM Y                                                PA52  33
#   --------------------                                                PA52  34
#                                                                       PA52  35
Y1=9.9E+20#                                                             PA52  36
DO I=1,NV#                                                              PA52  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA52  38
Y1=MIN(Y1,QX(MARKC+(I-1)*VPKT+3))#     Find min y point                 PA52  39
ifeq:(Y1,QX(MARKC+(I-1)*VPKT+3))#                                       PA52  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA52  41
X1=QX(MARKC+(I-1)*VPKT+2)#             Store x for future               PA52  42
VLOG(1)=I#                             Log first vertex                 PA52  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA52  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA52  45
XAVE=0.0;YAVE=0.0;J=1#                 Initialize variables             PA52  46
#                                                                       PA52  47
#   FIND BOUNDARY CURVE OF CRYSTAL                                      PA52  48
#   FROM VERTICES BY FINDING MINIMUM GRADIENT                           PA52  49
#                                                                       PA52  50
DO K=1,4#                              Loop over four quadrants         PA52  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA52  52
IF (K>2)A=-1.0#                                                         PA52  53
ELSE A=1.0#                                                             PA52  54
IF ((K<2)\(K>3))B=1.0#                                                  PA52  55
ELSE B=-1.0#                                                            PA52  56
REPEAT#                                Until no points in quad          PA52  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA52  58
NEWPT=no:#                                                              PA52  59
MNGRAD=9.9E+20#                                                         PA52  60
DO I=1,NV#                             Cycle thru all vertices          PA52  61
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA52  62
IF(I==VLOG(J)) NEXT#                                                    PA52  63
X2=QX(MARKC+(I-1)*VPKT+2)#             Second x                         PA52  64
Y2=QX(MARKC+(I-1)*VPKT+3)#             Second y                         PA52  65
DELX=X1-X2#                            Delta x                          PA52  66
DELY=Y1-Y2#                            Delta y                          PA52  67
IF ((A*DELY>0.0)\(B*DELX>0.0))NEXT#    Wrong quadrant                   PA52  68
ifeq:(DELX,0.0)#                       Infinite gradiant                PA52  69
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA52  70
IF (NEWPT==yes:) NEXT#                 Test for a previous value        PA52  71
DELX=-1.0E-15#                         Make gradiant very large         PA52  72
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA52  73
MNGRAD=MIN(DELY/DELX,MNGRAD)#                                           PA52  74
ifeq:(MNGRAD,DELY/DELX)#               If the minimum gradiant          PA52  75
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA52  76
VLOG(J+1)=I#                           Log the vertex                   PA52  77
NEWX=X2;NEWY=Y2#                       Save the coords                  PA52  78
NEWPT=yes:#                            A value has been found           PA52  79
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA52  80
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA52  81
IF(NEWPT==no:)BREAK#                                                    PA52  82
J=J+1#                                 Increment vertex counter         PA52  83
X1=NEWX;Y1=NEWY#                       Set new initial points           PA52  84
XAVE=XAVE+X1;YAVE=YAVE+Y1#             Accumulate average               PA52  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA52  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA52  87
QX(CMARK+7)=XAVE/FLOAT(J-1)#           Store average x coord            PA52  88
QX(CMARK+8)=YAVE/FLOAT(J-1)#           Store average y coord            PA52  89
#                                                                       PA52  90
RETURN#                                                                 PA52  91
END#                                                                    PA52  92
systemheader:(PA53)#                                                    PA53   1
####################################################################    PA53   2
#                                                                  #    PA53   3
# LOOP OVER ALL PHOTO PAIRS TO DETERMINE ALPHA AND BETA            #    PA53   4
#                                                                  #    PA53   5
####################################################################    PA53   6
SUBROUTINE PA53#                                                        PA53   7
include:(AACOMN)#                                                       PA53   8
include:(PACOMN)#                                                       PA53   9
#                                                                       PA53  10
INTEGER II,I,J,K,L,M,N#                                                 PA53  11
INTEGER MARKC,MARKD,MARKE,STOPE#                                        PA53  12
INTEGER FMARK,FMARK1#                                                   PA53  13
INTEGER NV1,NV2,NPED#                                                   PA53  14
INTEGER NCV#                                                            PA53  15
INTEGER COMON#                                                          PA53  16
REAL XI,XJ,AIJ,SI#                                                      PA53  17
REAL SUM#                                                               PA53  18
REAL VERT1A,VERT1B#                                                     PA53  19
REAL RIJ(3)#                                                            PA53  20
REAL DIFF Z1A,Z2A#                                                      PA53  21
REAL DALF,DBET#                        Alpha beta and shifts            PA53  22
REAL NUM1,NUM2,DEN#                    Least square numerator denom     PA53  23
REAL R,RA,RB,RAA,RAB,RBB#              Least square sums                PA53  24
REAL SXKA,SXKB,SYKA,SYKB,SZKA,SZKB#                                     PA53  25
REAL KA,KB,DKA,DKB,RKA,RKB,R2KA,R2KB#                                   PA53  26
REAL XKA,XKB,YKA,YKB#                                                   PA53  27
REAL VARA, VARB,tst#
datastuff:#                                                             PA53  28
#                                                                       PA53  29
LSDRAB=WRKSPC#                                                          PA53  30
DRAB=50#                                                                PA53  31
FUDG=1.0#                                                               PA53  32
COMON=yes:#                                                             PA53  33
MARKC=PROJDT#                          Loop over all pairs of projns    PA53  34
incrqx:(LSABDT,LSDRAB+DRAB,PA5301)#                                     PA53  35
MARKE=LSABDT#                                                           PA53  36
DTPK=5#                                                                 PA53  37
#                                                                       PA53  38
NPAIR=0#                                                                PA53  39
DO II=1,PNUM-2#                                                         PA53  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA53  41
NV1=NINT(QX(MARKC+5))#                 Num vertices proj 1              PA53  42
MARKD=MARKC+PPKT+NV1*VPKT#             Next projection                  PA53  43
NV2=NINT(QX(MARKD+5))#                 Num vertices proj 2              PA53  44
IF (COMON==yes:)#                                                       PA53  45
ifne:(QX(MARKC+2),QX(MARKD+2))#                                         PA53  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA53  47
MARKC=MARKD#                                                            PA53  48
NEXT#                                                                   PA53  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA53  50
NPAIR=NPAIR+1#                                                          PA53  51
WRITE(6,*)"photo pair, photo numbers ",II,QX(MARKC+6),QX(MARKD+6)#      PA53  52
#                                                                       PA53  53
incrqx:(STOPE,MARKE+DTPK,PA5302)#                                       PA53  54
#ALF=QX(MARKC+9);BET=QX(MARKC+10)#     GET ALPHA AND BETA IF KNOWN      PA53  55
QX(MARKE+2)=QX(MARKC+9)#                                                PA53  56
QX(MARKE+3)=QX(MARKC+10)#                                               PA53  57
QX(MARKE+4)=QX(MARKC+4)#                                                PA53  58
QX(MARKE+5)=QX(MARKD+4)#                                                PA53  59
NCV=0#                                 Number of common points          PA53  60
DO I=1,NV1#                            Get all vertex numbers           PA53  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA53  62
VERT1A=QX(MARKC+PPKT+(I-1)*VPKT+1)#    Vertex id                        PA53  63
DO J=1,NV2#                            Get all vertex numbers           PA53  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA53  65
VERT1B=QX(MARKD+PPKT+(J-1)*VPKT+1)#    Vertex id                        PA53  66
ifeq:(VERT1A,VERT1B)#                  Common point                     PA53  67
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA53  68
NCV=NCV+1#                             Count common points              PA53  69
incrqx:(STOPE,STOPE+DTPK,PA5302)#                                       PA53  70
QX(STOPE-DTPK+1)=VERT1A#               Store common point id            PA53  71
QX(STOPE-DTPK+2)=QX(MARKC+PPKT+(I-1)*VPKT+2)# X coordinate point fram   PA53  72
QX(STOPE-DTPK+3)=QX(MARKC+PPKT+(I-1)*VPKT+3)# Y coordinate point fram   PA53  73
QX(STOPE-DTPK+4)=QX(MARKD+PPKT+(J-1)*VPKT+2)# X coordinate point fram   PA53  74
QX(STOPE-DTPK+5)=QX(MARKD+PPKT+(J-1)*VPKT+3)# Y coordinate point fram   PA53  75
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA53  76
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA53  77
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA53  78
QX(MARKE+1)=FLOAT(NCV)#                                                 PA53  79
MARKE=STOPE#                                                            PA53  80
MARKC=MARKD#                                                            PA53  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA53  82
WRKSPC=STOPE#                                                           PA53  83
#                                                                       PA53  84
ALF =0.0 ; BET = 0.0#                                                   PA53  85
DO LOOP= 1,10#                         Least squares iteration loop     PA53  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA53  87
movereal:(0.0,1,QX,LSDRAB+1,DRAB,2)#   Initialise shift sums to 0.0     PA53  88
MARKE=LSABDT#                                                           PA53  89
NCV=QX(MARKE+1)#                       Number of entries in packet      PA53  90
DO I=1,NPAIR#                          Loop over data packets           PA53  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA53  92
CALL PA57(NCV,MARKE)#                  Accumulate sums                  PA53  93
MARKE=MARKE+(NCV+1)*DTPK#              Point to next data packet        PA53  94
NCV=QX(MARKE+1)#                       Number of entries in packet      PA53  95
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA53  96
#                                                                       PA53  97
R=QX(LSDRAB+1)#                        Sum    r                         PA53  98
RA=QX(LSDRAB+2)#                       Sum  d r/d alpha                 PA53  99
RB=QX(LSDRAB+3)#                       Sum  d r/d beta                  PA53 100
RAA=QX(LSDRAB+4)#                      Sum d2 r/d2 alpha                PA53 101
RBB=QX(LSDRAB+5)#                      Sum d2 r/d2 beta                 PA53 102
RAB=QX(LSDRAB+6)#                      Sum d2 r/d alpha d beta          PA53 103
RKA=QX(LSDRAB+7)#                                                       PA53 104
RKB=QX(LSDRAB+8)#                                                       PA53 105
R2KA=QX(LSDRAB+9)#                                                      PA53 106
R2KB=QX(LSDRAB+10)#                                                     PA53 107
#                                                                       PA53 108
DEN=RAA*RBB-RAB*RAB#                                                    PA53 109
DALF=(RAB*RB-RBB*RA)/DEN#              Shift in alpha                   PA53 110
DBET=(RAB*RA-RAA*RB)/DEN#              Shift in beta                    PA53 111
vara=rbb/den ; varb=raa/den
DKA=-(RKA/R2KA)#                                                        PA53 112
DKB=-(RKB/R2KB)#                                                        PA53 113
#IF (LOOP >5) KB=KB+DKB#                                                PA53 114
#IF (LOOP >5) KA=KA+DKA#                                                PA53 115
ALF=ALF+FUDG*DALF#                                                      PA53 116
BET=BET+FUDG*DBET#                                                      PA53 117
tst=(abs(dalf)+abs(dbet))/sqrt(vara+varb)
WRITE(6,*)" minimization criteria",R#                                   PA53 118
WRITE(6,*)" alph shft beta shft  ",DALF,DBET
WRITE(6,*)" alpha and beta       ",ALF,BET#
write(6,*)" shifts / esd         ",tst
if (tst<0.0001) break
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA53 121
write(6,*)" "
write(6,*)"Final alpha and beta angles"
write(6,*)"alpha  ",ALF*180./PI," beta  ",bet*180./PI
write(6,*)"sig(a) ",sqrt(vara)*180./PI," sig(b) ",sqrt(varb)*180./PI
write(6,*)" "
#                                                                       PA53 122
#                                                                       PA53 123
RETURN#                                                                 PA53 124
END#                                                                    PA53 125
#                                                                       PA53 126
systemheader:(PA54)#                                                    PA54   1
####################################################################    PA54   2
#                                                                  #    PA54   3
#   DETERMINE RELATIVE COORDINATE MATRICES X Y AND Z               #    PA54   4
#                                                                  #    PA54   5
####################################################################    PA54   6
SUBROUTINE PA54#                                                        PA54   7
#                                                                       PA54   8
include:(AACOMN)#                                                       PA54   9
include:(PACOMN)#                                                       PA54  10
#                                                                       PA54  11
INTEGER I,J,K#                                                          PA54  12
INTEGER MARKE#                                                          PA54  13
INTEGER NPED#                                                           PA54  14
INTEGER NCV#                           Pa54                             PA54  15
#                                                                       PA54  16
datastuff:#                                                             PA54  17
#                                                                       PA54  18
RELCOM=WRKSPC#                                                          PA54  19
NPED=VMAX*(VMAX-1)/2#                                                   PA54  20
incrqx:(WRKSPC,RELCOM+NPED*4,PA5402)#                                   PA54  21
MARKE=LSABDT#                                                           PA54  22
DO K=1,NPAIR#                                                           PA54  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA54  24
movereal:(0.0,1,QX,RELCOM+1,NPED*4,2)#                                  PA54  25
NCV=QX(MARKE+1)#                                                        PA54  26
CALL PA58(NCV,MARKE)#                                                   PA54  27
MARKE=MARKE+(NCV+1)*DTPK#                                               PA54  28
DO I= 1,NPED#                          Average                          PA54  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA54  30
IF (QX(RELCOM+I+3*NPED)> 0.0)#                                          PA54  31
DO J=0,2 ;QX(RELCOM+I+J*NPED)=QX(RELCOM+I+J*NPED )/2.0#                 PA54  32
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA54  33
#CALL PA59(RELCOM,VMAX-1,3,1)#          PRINT                           PA54  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA54  35
#                                                                       PA54  36
#                                                                       PA54  37
movereal:(0.0,1,QX,RELCOM+1,NPED*4,2)#                                  PA54  38
MARKE=LSABDT#                                                           PA54  39
DO I=1,NPAIR#                                                           PA54  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA54  41
NCV=QX(MARKE+1)#                                                        PA54  42
CALL PA58(NCV,MARKE)#                                                   PA54  43
MARKE=MARKE+(NCV+1)*DTPK#                                               PA54  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA54  45
DO I= 1,NPED#                          Average                          PA54  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA54  47
IF (QX(RELCOM+I+3*NPED)>0.0)#                                           PA54  48
DO J=0,2#                                                               PA54  49
QX(RELCOM+I+J*NPED)=QX(RELCOM+I+J*NPED)/QX(RELCOM+I+3*NPED)#            PA54  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA54  51
#CALL PA59(RELCOM,VMAX-1,4,1)#          PRINT                           PA54  52
#                                                                       PA54  53
RETURN#                                                                 PA54  54
END#                                                                    PA54  55
#                                                                       PA54  56
systemheader:(PA55)#                                                    PA55   1
####################################################################    PA55   2
#                                                                  #    PA55   3
#  REFINE ABSOLUTE COORDINATES FROM RELATIVE COORD MATRICES        #    PA55   4
#                                                                  #    PA55   5
####################################################################    PA55   6
SUBROUTINE PA55#                                                        PA55   7
#                                                                       PA55   8
include:(AACOMN)#                                                       PA55   9
include:(PACOMN)#                                                       PA55  10
#                                                                       PA55  11
INTEGER I,J,M#                                                          PA55  12
INTEGER DIAG,AIJPOS#                                                    PA55  13
INTEGER MXIJ#                                                           PA55  14
INTEGER RELAR,XYZ#                                                      PA55  15
REAL XI,XJ,AIJ,SI#                                                      PA55  16
REAL XAVE,YAVE,ZAVE#                                                    PA55  17
REAL SUM#                                                               PA55  18
REAL VC1(3),VC2(3)#                                                     PA55  19
#                                                                       PA55  20
datastuff:#                                                             PA55  21
#                                                                       PA55  22
VCX=WRKSPC#                                                             PA55  23
incrqx:(VC1D,VCX+VMAX,PA5503)#         Qx coordinate vector             PA55  24
incrqx:(MX2D,VC1D+VMAX,PA5503)#        Qx first derivative vector       PA55  25
incrqx:(VCSG,MX2D+(VMAX)*(VMAX),PA5503)# Qx second deriv matrix         PA55  26
incrqx:(VERTC,VCSG+VMAX,PA5503)#       Qx sigma vector                  PA55  27
incrqx:(DVERT,VERTC+VMAX*3,PA5503)#    Qx stored vertex coords          PA55  28
incrqx:(WRKSPC,DVERT+VMAX*3,PA5503)#   Qx stored vertex coords          PA55  29
#                                                                       PA55  30
# REFINE COORDS                                                         PA55  31
# -------------                                                         PA55  32
#                                                                       PA55  33
DO XYZ=0,2#                            Refine each relatv component     PA55  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA55  35
RELAR=RELCOM+XYZ*VMAX*(VMAX-1)/2#                                       PA55  36
DO I=1,VMAX ; QX(VCX+I)=0.0#                                            PA55  37
DO M=1,2#                              Loop 4 times                     PA55  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA55  40
movereal:(0.0,1,QX,MX2D+1,(VMAX)*(VMAX)-1,2)#                           PA55  41
movereal:(0.0,1,QX,VC1D+1,VMAX,2)#                                      PA55  42
movereal:(0.0,1,QX,VCSG+1,VMAX,2)#                                      PA55  42
#                                                                       PA55  43
# CONSTRUCT 2D MATRIX AND 1D VECTOR                                     PA55  44
# ---------------------------------                                     PA55  45
#                                                                       PA55  46
SUM=0.0#                                                                PA55  47
DO I=1,VMAX-1#                                                          PA55  48
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA55  49
DO J=I+1,VMAX#                                                          PA55  50
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA55  51
AIJPOS=(I-1)*(VMAX-1)+J-1-I*(I-1)/2#                                    PA55  52
AIJ=QX(RELAR+AIJPOS)#                                                   PA55  53
ifeq:(AIJ,0.0) NEXT#                                                    PA55  54
XI=QX(VCX+I) ; XJ=QX(VCX+J)#                                            PA55  55
SI=XI-XJ-AIJ#                                                           PA55  56
QX(VC1D+I)=QX(VC1D+I)+SI#                                               PA55  57
QX(VC1D+J)=QX(VC1D+J)-SI#                                               PA55  58
SUM=SUM+2.*SI**2.#                                                      PA55  59
IF (I>1)#                                                               PA55  60
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA55  61
DIAG=(I-2)*(VMAX-1)+I-1-(I-1)*(I-2)/2# Diagonal element                 PA55  62
QX(MX2D+DIAG)=QX(MX2D+DIAG)-1.0#       Sum of terms in row              PA55  63
MXIJ=(I-2)*(VMAX-1)+J-1-(I-1)*(I-2)/2# Diagonal element                 PA55  64
QX(MX2D+MXIJ)=1.0#                                                      PA55  65
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA55  66
DIAG=(J-2)*(VMAX-1)+J-1-(J-1)*(J-2)/2# Diagonal element                 PA55  67
QX(MX2D+DIAG)=QX(MX2D+DIAG)-1.0#       Sum of terms in row              PA55  68
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA55  69
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA55  70
#                                                                       PA55  71
# REDUCE TO UPPER DIAGONAL FORM                                         PA55  72
# -----------------------------                                         PA55  73
#                                                                       PA55  74
CALL PA60(MX2D,VC1D+1,VCSG+1,VMAX-1,1)#                                 PA55  75
#                                                                       PA55  76
WRITE(6,*)"min criteria ",xyz+1,SUM# 
DO I=2,VMAX ; QX(VCX+I)=QX(VCX+I)+QX(VC1D+I)#                         PA55  78
#DO I=1,VMAX ; WRITE(6,*)" varin",I,QX(VC1D+I),QX(VCX+I)#               PA55  79
DO I=1,VMAX ; QX(VERTC+I+VMAX*XYZ)=QX(VCX+I)#                           PA55  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA55  81
#                                                                       PA55  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA55  83
WRITE(6,*)" "
WRITE(6,*)" Least squares sigmas on vertices - both x,y and z"
DO I=2,VMAX ; WRITE(6,*)" sigmas",I,QX(VCSG+I)
WRITE(6,*)" "
#                                                                       PA55  84
#  SHIFT ORIGIN INTERNAL AND TRANSFORM TO DIFFRACTOMETER AXES 
#  ----------------------------------------------------------
#                                                                       PA55  87
XAVE=0.0 ; YAVE=0.0 ; ZAVE= 0.0#                                        PA55  88
DO I=1,VMAX#                                                            PA55  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA55  90
XAVE=XAVE+QX(VERTC+I)#                                                  PA55  91
YAVE=YAVE+QX(VERTC+I+VMAX)#                                             PA55  92
ZAVE=ZAVE+QX(VERTC+I+2*VMAX)#                                           PA55  93
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA55  94
XAVE=XAVE/FLOAT(VMAX)#                                                  PA55  95
YAVE=YAVE/FLOAT(VMAX)#                                                  PA55  96
ZAVE=ZAVE/FLOAT(VMAX)#                                                  PA55  97
DO I=1,VMAX#                                                            PA55  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA55  99
VC1(1)= QX(VERTC+I)-XAVE#                                               PA55 100
VC1(2)= QX(VERTC+I+VMAX)-YAVE#                                          PA55 101
VC1(3)= QX(VERTC+I+2*VMAX)-ZAVE#                                        PA55 102
postm:(TRANS,VC1,VC2)#                                                  PA55 103
DO J=1,3 ; QX(VERTC+I+(J-1)*VMAX)=VC1(J)#                               PA55 104
DO J=1,3 ; QX(DVERT+I+(J-1)*VMAX)=VC2(J)#                               PA55 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA55 106
#
WRITE(6,*) " VERTEX POSITION AT ",PHISH*180./PI,"DEGREES PHI"
DO I=1,VMAX#                                                            PA55 108
WRITE(6,2000) QX(DVERT+I),QX(DVERT+I+VMAX),QX(DVERT+I+2*VMAX)#
WRITE(6,*) " "
2000 FORMAT(' {',1X,F7.2,' , ',1X,F7.2,' , ',1X,F7.2,' } ')#  
#                                                                       PA55 110
RETURN#                                                                 PA55 111
END#                                                                    PA55 112
#                                                                       PA55 113
systemheader:(PA56)#                                                    PA56   1
####################################################################    PA56   2
#                                                                  #    PA56   3
#  DETERMINE ALL TRIANGULAR CRYSTAL FACES                          #    PA56   4
#                                                                  #    PA56   5
####################################################################    PA56   6
SUBROUTINE PA56#                                                        PA56   7
include:(AACOMN)#                                                       PA56   8
include:(PACOMN)#                                                       PA56   9
#                                                                       PA56  10
INTEGER II,I,J,K,L,M,N#                                                 PA56  11
INTEGER MARKF,MARKG,MARKG1#                                             PA56  12
INTEGER STARTF,NFACE#                                                   PA56  13
INTEGER PED,FPKT1#                                                      PA56  14
INTEGER IJPOS,IKPOS,JKPOS#                                              PA56  15
INTEGER MINUS,PLUS,MAXF#                                                PA56  16
INTEGER COPY#                                                           PA56  17
REAL VERT1A,VERT1B#                                                     PA56  18
REAL V1(3),V2(3),V3(3),V4(3)#                                           PA56  19
REAL AREA,BASE,HIGHT#                                                   PA56  20
REAL MXAREA#                           P                                PA56  21
REAL P1,P2,DL#                                                          PA56  22
REAL A,B,C,D,D1,DELTA#                                                  PA56  23
REAL X1,X2,X3,Y1,Y2,Y3,Z1,Z2,Z3#                                        PA56  24
REAL VX1,VX2,VY1,VY2,VZ1,VZ2#                                           PA56  25
datastuff:#                                                             PA56  26
#                                                                       PA56  27
EDGES=WRKSPC#                                                           PA56  28
PED=VMAX*(VMAX-1)/2#                   Possible edges                   PA56  29
incrqx:(FACE,EDGES+PED*3,PA5601)#                                       PA56  30
movereal:(0.0,1,QX,EDGES+1,PED*3,2)#                                    PA56  31
NFACE=FACE#                                                             PA56  32
M=0#                                                                    PA56  33
DELTA=0.3#                                                              PA56  34
#                                                                       PA56  35
# FIND EQUATIONS ALL FACES                                              PA56  36
# ------------------------                                              PA56  37
#                                                                       PA56  38
DO I=1,VMAX-2#                                                          PA56  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA56  40
X1=QX(DVERT+I)#                                                         PA56  41
Y1=QX(DVERT+I+VMAX*1)#                                                  PA56  42
Z1=QX(DVERT+I+VMAX*2)#                                                  PA56  43
DO J=I+1,VMAX-1#                                                        PA56  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA56  45
IJPOS=(I-1)*VMAX+J-I*(I+1)/2#                                           PA56  46
X2=QX(DVERT+J)#                                                         PA56  47
Y2=QX(DVERT+J+VMAX*1)#                                                  PA56  48
Z2=QX(DVERT+J+VMAX*2)#                                                  PA56  49
DO K=J+1,VMAX#                                                          PA56  50
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA56  51
incrqx:(FMARK,NFACE+11,PA5503)#                                         PA56  52
IKPOS=(I-1)*VMAX+K-I*(I+1)/2#                                           PA56  53
JKPOS=(J-1)*VMAX+K-J*(J+1)/2#                                           PA56  54
X3=QX(DVERT+K)#                                                         PA56  55
Y3=QX(DVERT+K+VMAX*1)#                                                  PA56  56
Z3=QX(DVERT+K+VMAX*2)#                                                  PA56  57
V1(1)=(X1-X2) ; V2(1)=(X1-X3)#                                          PA56  58
V1(2)=(Y1-Y2) ; V2(2)=(Y1-Y3)#                                          PA56  59
V1(3)=(Z1-Z2) ; V2(3)=(Z1-Z3)#                                          PA56  60
CALL PA01(V1,V2,V3)#                   Find normal                      PA56  61
CALL PA01(V3,V1,V4)#                   Parrallel to plane               PA56  62
HIGHT =0.0 ; BASE=0.0#                                                  PA56  63
DO L=1,3 ; HIGHT=HIGHT+V4(L)*V2(L)#                                     PA56  64
DO L=1,3 ; BASE=BASE+V1(L)*V1(L)#                                       PA56  65
AREA=SQRT(HIGHT*BASE)/2.0#             Large area large weight          PA56  66
DL=0.02#                                                                PA56  67
P1=X1**2.+Y1**2.+Z1**2.#                                                PA56  68
P2=(X1+DL*V3(1))**2.+(Y1+DL*V3(2))**2.+(Z1+DL*V3(3))**2.#               PA56  69
IF (P2<P1) DO L=1,3 ;V3(L)=-V3(L)#                                      PA56  70
D=V3(1)*X1+V3(2)*Y1+V3(3)*Z1#          Equation of plane                PA56  71
MINUS=no: ; PLUS=no:#                                                   PA56  72
DO L=1,VMAX#                                                            PA56  73
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA56  74
IF (L==I\L==J\L==K) NEXT#                                               PA56  75
D1=V3(1)*QX(DVERT+L)+V3(2)*QX(DVERT+L+VMAX*1)+V3(3)*QX(DVERT+L+VMAX*2)# PA56  76
IF (D1<D) MINUS=yes:#                                                   PA56  77
ELSE PLUS=yes:#                                                         PA56  78
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA56  79
IF(MINUS==no:\PLUS==no:)#              Then an external plane           PA56  80
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA56  81
M=M+1#                                 Increment plane number           PA56  82
QX(NFACE+1)=M#                                                          PA56  83
QX(NFACE+2)=V3(1)#                     Plane definition a               PA56  84
QX(NFACE+3)=V3(2)#                     Plane definition b               PA56  85
QX(NFACE+4)=V3(3)#                     Plane definition c               PA56  86
QX(NFACE+5)=D#                         Plane definition d               PA56  87
QX(NFACE+6)=AREA#                      Triangular plane area            PA56  88
QX(NFACE+7)=3.0#                       Increment plane vertex count     PA56  89
QX(NFACE+8)=FLOAT(I)#                  First vertex                     PA56  90
QX(NFACE+9)=FLOAT(J)#                  Second vertex                    PA56  91
QX(NFACE+10)=FLOAT(K)#                 Third vertex                     PA56  92
QX(NFACE+11)=FLOAT(I)#                 First vertex                     PA56  93
QX(EDGES+IJPOS)=QX(EDGES+IJPOS)+1.0#   Update array connctd edges       PA56  94
QX(EDGES+IKPOS)=QX(EDGES+IKPOS)+1.0#   Update array connctd edges       PA56  95
QX(EDGES+JKPOS)=QX(EDGES+JKPOS)+1.0#   Update array connctd edges       PA56  96
QX(EDGES+IJPOS+PED*NINT(QX(EDGES+IJPOS)))=M# Store plane numbers#       PA56  97
QX(EDGES+IKPOS+PED*NINT(QX(EDGES+IKPOS)))=M# Store plane numbers#       PA56  98
QX(EDGES+JKPOS+PED*NINT(QX(EDGES+JKPOS)))=M# Store plane numbers#       PA56  99
NFACE=FMARK#                                                            PA56 100
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA56 101
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA56 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA56 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA56 104
FACES=M#                                                                PA56 105
#                                                                       PA56 106
# SORT FACES IN TERMS OF AREA                                           PA56 107
# ---------------------------                                           PA56 108
#                                                                       PA56 109
MARKG=NFACE#                           New faces                        PA56 110
REPEAT#                                                                 PA56 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA56 112
MARKF=FACE#                            Old faces                        PA56 113
MXAREA=-9.9E+10#                       P                                PA56 114
DO I=1,FACES#                                                           PA56 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA56 116
AREA=QX(MARKF+6)#                                                       PA56 117
IF (AREA >MXAREA)#                     P                                PA56 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PA56 119
MXAREA=AREA; MAXF=MARKF#               P                                PA56 120
FPKT1=8+NINT(QX(MARKF+7))#                                              PA56 121
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PA56 122
MARKF=MARKF+FPKT1#                                                      PA56 123
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA56 124
IF (MXAREA <0.0)BREAK#                 Pa                               PA56 125
incrqx:(MARKG1,MARKG+FPKT1,PA5601)#                                     PA56 126
movereal:(QX,MAXF+1,QX,MARKG+1,FPKT1,1)#                                PA56 127
MARKG=MARKG1#                                                           PA56 128
QX(MAXF+6)=-QX(MAXF+6)#                                                 PA56 129
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA56 130
movereal:(QX,NFACE+1,QX,FACE+1,MARKG-NFACE,1)# Copy back over           PA56 131
#                                                                       PA56 132
# LIST ALL EDGES                                                        PA56 133
# --------------                                                        PA56 134
#                                                                       PA56 135
WRITE(6,*)"TRIANGULAR FACE EDGES"#                                      PA56 136
DO I=1,VMAX-1#                                                          PA56 137
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PA56 138
DO J=I+1,VMAX#                                                          PA56 139
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PA56 140
IJPOS=(I-1)*VMAX+J-I*(I+1)/2#                                           PA56 141
ifeq:(QX(EDGES+ IJPOS),2.0)#                                            PA56 142
WRITE (6,2005)I,J#                                                      PA56 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PA56 144
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PA56 145
2005 FORMAT(' {',1X,I3,' , ',1X,I3,' }, ')#                             PA56 146
#CALL PA59(EDGES,VMAX-1,3,1)#           PRINT                           PA56 147
WRKSPC=NFACE#                                                           PA56 148
#                                                                       PA56 149
RETURN#                                                                 PA56 150
END#                                                                    PA56 151
#                                                                       PA56 152
systemheader:(PA57)#                                                    PA57   1
####################################################################    PA57   2
#                                                                  #    PA57   3
# LEAST SQUARES DETERMINATION PHOTO OFFSET ANGLES ALPHA AND BETA   #    PA57   4
#                                                                  #    PA57   5
####################################################################    PA57   6
SUBROUTINE PA57(NCV,MARKE)#                                             PA57   7
include:(AACOMN)#                                                       PA57   8
include:(PACOMN)#                                                       PA57   9
#                                                                       PA57  10
INTEGER II,I,J,K,L,M,N#                                                 PA57  11
INTEGER ROW,COL,ROWI,COLJ#                                              PA57  12
INTEGER MARKE,NCV#                     Pa57                             PA57  13
REAL DIFF Z1A,Z2A#                                                      PA57  14
REAL RIJ(3)#                                                            PA57  15
REAL DALF,DBET#                        Alpha beta and shifts            PA57  16
REAL GA,GB#                                                             PA57  17
REAL SGA,CGA,SGB,CGB#                  Sin cos of gamma in frame a,b    PA57  18
REAL X1A,Y1A,X2A,Y2A#                  Points 1,2 frame a               PA57  19
REAL X1B,Y1B,X2B,Y2B#                  Points 1,2 frame b               PA57  20
REAL XA,XB,YA,YB,XAB,YAB#                                               PA57  21
REAL XSAB,YSAB,XCAB,YCAB#                                               PA57  22
REAL NUM1,NUM2,DEN#                    Least square numerator denom     PA57  23
REAL R,RA,RB,RAA,RAB,RBB#              Least square sums                PA57  24
REAL NM,NMA,NMB,NMAA,NMAB,NMBB#        Temporary numerator &derivs      PA57  25
REAL DN,DNA,DNB,DNAA,DNAB,DNBB#        Temporary denomin   &derivs      PA57  26
REAL SX,SXA,SXB,SXAA,SXAB,SXBB#        Static frame x1-x2               PA57  27
REAL SY,SYA,SYB,SYAA,SYAB,SYBB#        Static frame y1-y2               PA57  28
REAL SZ,SZA,SZB,SZAA,SZAB,SZBB#        Static frame z1-z2               PA57  29
REAL Z,ZA,ZB,ZAA,ZAB,ZBB#              Fnctns of unknown phot z coord   PA57  30
REAL ZS,ZSA,ZSB,ZSAA,ZSAB,ZSBB#        Sin unknown z coords             PA57  31
REAL ZC,ZCA,ZCB,ZCAA,ZCAB,ZCBB#        Cos unknown z coords             PA57  32
REAL AZ,AZA,AZB,AZAA,AZAB,AZBB#        Unknown z frame a                PA57  33
REAL BZ,BZA,BZB,BZAA,BZAB,BZBB#        Unknown z frame b                PA57  34
REAL D1,D1A,D1B,D1AA,D1AB,D1BB#                                         PA57  35
REAL D2,D2A,D2B,D2AA,D2AB,D2BB#                                         PA57  36
REAL E1,E1A,E1B,E1AA,E1AB,E1BB#                                         PA57  37
REAL E2,E2A,E2B,E2AA,E2AB,E2BB#                                         PA57  38
REAL DL1,DL1A,DL1B,DL1AA,DL1AB,DL1BB#  Delta prime  and derivs          PA57  39
REAL DL2,DL2A,DL2B,DL2AA,DL2AB,DL2BB#  Delta prime  and derivs          PA57  40
REAL SXKA,SXKB,SYKA,SYKB,SZKA,SZKB#                                     PA57  41
REAL KA,KB,DKA,DKB,RKA,RKB,R2KA,R2KB#                                   PA57  42
REAL XKA,XKB,YKA,YKB#                                                   PA57  43
datastuff:#                                                             PA57  44
#                                                                       PA57  45
KA=1.00#                                                                PA57  46
KB=1.00#                                                                PA57  47
GA= QX(MARKE+4)#                                                        PA57  48
GB= QX(MARKE+5)#                                                        PA57  49
SGA=SIN(GA) ; CGA=COS(GA)#                                              PA57  50
SGB=SIN(GB) ; CGB=COS(GB)#                                              PA57  51
SA=SIN(ALF) ; CA=COS(ALF)#                                              PA57  52
SB=SIN(BET) ; CB=COS(BET)#                                              PA57  53
#                                                                       PA57  54
D1=CB*SGA-SA*SB*CGA#                   Definition of d                  PA57  55
D1A=-CA*SB*CGA#                        Derivative  d d/d alpha          PA57  56
D1B=-SB*SGA-SA*CB*CGA#                 Derivative  d d/d beta           PA57  57
D1AA=SA*SB*CGA#                        Derivative  d2d/d alfa d beta    PA57  58
D1BB=-CB*SGA+SA*SB*CGA#                Derivative  d2d/d beta d beta    PA57  59
D1AB=-CA*CB*CGA#                       Derivative  d2d/d alfa d beta    PA57  60
D2=CB*CGA+SA*SB*SGA#                   Definition of d                  PA57  61
D2A= CA*SB*SGA#                        Derivative  d d/d alpha          PA57  62
D2B=-SB*CGA+SA*CB*SGA#                 Derivative  d d/d beta           PA57  63
D2AA=-SA*SB*SGA#                       Derivative  d2d/d alfa d beta    PA57  64
D2BB=-CB*CGA-SA*SB*SGA#                Derivative  d2d/d beta d beta    PA57  65
D2AB= CA*CB*SGA#                       Derivative  d2d/d alfa d beta    PA57  66
#                                                                       PA57  67
E1=CB*SGB-SA*SB*CGB#                   Definition of e                  PA57  68
E1A=-CA*SB*CGB#                        Derivative  d e/d alpha          PA57  69
E1B=-SB*SGB-SA*CB*CGB#                 Derivative  d e/d beta           PA57  70
E1AA=SA*SB*CGB#                        Derivative  d2e/d alfa d alfa    PA57  71
E1BB=-CB*SGB+SA*SB*CGB#                Derivative  d2e/d beta d beta    PA57  72
E1AB=-CA*CB*CGB#                       Derivative  d2e/d alfa d beta    PA57  73
E2=CB*CGB+SA*SB*SGB#                   Definition of e                  PA57  74
E2A= CA*SB*SGB#                        Derivative  d e/d alpha          PA57  75
E2B=-SB*CGB+SA*CB*SGB#                 Derivative  d e/d beta           PA57  76
E2AA=-SA*SB*SGB#                       Derivative  d2e/d alfa d alfa    PA57  77
E2BB=-CB*CGB-SA*SB*SGB#                Derivative  d2e/d beta d beta    PA57  78
E2AB= CA*CB*SGB#                       Derivative  d2e/d alfa d beta    PA57  79
#                                                                       PA57  80
DN=D1*E2-D2*E1#                                                         PA57  81
DNA=D1A*E2+D1*E2A-D2A*E1-D2*E1A#                                        PA57  82
DNB=D1B*E2+D1*E2B-D2B*E1-D2*E1B#                                        PA57  83
DNAA=D1AA*E2+2.*D1A*E2A+D1*E2AA-D2AA*E1-2.*D2A*E1A-D2*E1AA#             PA57  84
DNBB=D1BB*E2+2.*D1B*E2B+D1*E2BB-D2BB*E1-2.*D2B*E1B-D2*E1BB#             PA57  85
DNAB=D1AB*E2+D1B*E2A+D1A*E2B+D1*E2AB-     $#                            PA57  86
D2AB*E1-D2B*E1A-D2A*E1B-D2*E1AB#                                        PA57  87
#                                                                       PA57  88
DO COL = 1,NCV-1#                      Loop over first common points    PA57  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA57  90
DO ROW = COL+1,NCV#                    Loop over second common point    PA57  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA57  92
#                                                                       PA57  93
#   GET TWO POINTS IN TWO PHOTOS                                        PA57  94
#   ----------------                                                    PA57  95
#                                                                       PA57  96
ROWI=NINT(QX(MARKE+COL*DTPK+1));COLJ=NINT(QX(MARKE+ROW*DTPK+1))#        PA57  97
X1A=QX(MARKE+COL*DTPK+2) ; X1B=QX(MARKE+COL*DTPK+4)#                    PA57  98
Y1A=QX(MARKE+COL*DTPK+3) ; Y1B=QX(MARKE+COL*DTPK+5)#                    PA57  99
X2A=QX(MARKE+ROW*DTPK+2) ; X2B=QX(MARKE+ROW*DTPK+4)#                    PA57 100
Y2A=QX(MARKE+ROW*DTPK+3) ; Y2B=QX(MARKE+ROW*DTPK+5)#                    PA57 101
#                                                                       PA57 102
#   GUTS                                                                PA57 103
#   ----                                                                PA57 104
#                                                                       PA57 105
XA=KA*(X1A-X2A) ; XB=KB*(X1B-X2B)#                                      PA57 106
YA=KA*(Y1A-Y2A) ; YB=KB*(Y1B-Y2B)#                                      PA57 107
XAB=XA-XB  ; YAB=YA-YB#                                                 PA57 108
XSAB=SGA*XA - SGB*XB ; YSAB=SGA*YA - SGB*YB#                            PA57 109
XCAB=CGA*XA - CGB*XB ; YCAB=CGA*YA - CGB*YB#                            PA57 110
#                                                                       PA57 111
DL1=-CB*SA*XCAB-SB*XSAB+CA*YCAB#                                        PA57 112
DL1A=-CB*CA*XCAB-SA*YCAB#                                               PA57 113
DL1B=SB*SA*XCAB-CB*XSAB#                                                PA57 114
DL1AA=CB*SA*XCAB-CA*YCAB#                                               PA57 115
DL1BB=CB*SA*XCAB+SB*XSAB#                                               PA57 116
DL1AB=SB*CA*XCAB#                                                       PA57 117
DL2= CB*SA*XSAB-SB*XCAB-CA*YSAB#                                        PA57 118
DL2A= CB*CA*XSAB+SA*YSAB#                                               PA57 119
DL2B=-SB*SA*XSAB-CB*XCAB#                                               PA57 120
DL2AA=-CB*SA*XSAB+CA*YSAB#                                              PA57 121
DL2BB=-CB*SA*XSAB+SB*XCAB#                                              PA57 122
DL2AB=-SB*CA*XSAB#                                                      PA57 123
#                                                                       PA57 124
NM=DL2*E1-DL1*E2#                                                       PA57 125
NMA=DL2A*E1+DL2*E1A-DL1A*E2-DL1*E2A#                                    PA57 126
NMB=DL2B*E1+DL2*E1B-DL1B*E2-DL1*E2B#                                    PA57 127
NMAA=DL2AA*E1+2.*DL2A*E1A+DL2*E1AA-DL1AA*E2-2.*DL1A*E2A-DL1*E2AA#       PA57 128
NMBB=DL2BB*E1+2.*DL2B*E1B+DL2*E1BB-DL1BB*E2-2.*DL1B*E2B-DL1*E2BB#       PA57 129
NMAB=DL2AB*E1+DL2B*E1A+DL2A*E1B+DL2*E1AB-  $#                           PA57 130
DL1AB*E2-DL1B*E2A-DL1A*E2B-DL1*E2AB#                                    PA57 131
#                                                                       PA57 132
AZ=NM/DN#                                                               PA57 133
AZA=(NMA*DN-NM*DNA)/DN**2.#                                             PA57 134
AZB=(NMB*DN-NM*DNB)/DN**2.#                                             PA57 135
AZAA=(NMAA*DN-NM*DNAA-AZA*2.*DN*DNA)/DN**2.#                            PA57 136
AZBB=(NMBB*DN-NM*DNAA-AZB*2.*DN*DNB)/DN**2.#                            PA57 137
AZAB=((NMAB*DN+NMB*DNA-NMA*DNB-NM*DNAB)-AZB*2.*DN*DNA)/DN**2.#          PA57 138
#                                                                       PA57 139
NM=DL2+D2*AZ#                                                           PA57 140
NMA=DL2A+D2A*AZ+D2*AZA#                                                 PA57 141
NMB=DL2B+D2B*AZ+D2*AZB#                                                 PA57 142
NMAA=DL2AA+D2AA*AZ+2.*D2A*AZA+D2*AZAA#                                  PA57 143
NMBB=DL2BB+D2BB*AZ+2.*D2B*AZB+D2*AZBB#                                  PA57 144
NMAB=DL2AB+D2AB*AZ+D2B*AZA+D2A*AZB+D2*AZAB#                             PA57 145
#                                                                       PA57 146
BZ=NM/E2#                              Sign and magn soln (z1b-z2b)     PA57 147
BZA=(NMA*E2-NM*E2A)/E2**2.#                                             PA57 148
BZB=(NMB*E2-NM*E2B)/E2**2.#                                             PA57 149
BZAA=(NMAA*E2-NM*E2AA-BZA*2.*E2*E2A)/E2**2.#                            PA57 150
BZBB=(NMBB*E2-NM*E2AA-BZB*2.*E2*E2B)/E2**2.#                            PA57 151
BZAB=((NMAB*E2+NMB*E2A-NMA*E2B-NM*E2AB)-BZB*2.*E2*E2A)/E2**2.#          PA57 152
#                                                                       PA57 153
Z = AZ-BZ#                             Difference                       PA57 154
ZA=AZA-BZA#                                                             PA57 155
ZB=AZB-BZB#                                                             PA57 156
ZAA=AZAA-BZAA#                                                          PA57 157
ZAB=AZAB-BZAB#                                                          PA57 158
ZBB=AZBB-BZBB#                                                          PA57 159
ZS=SGA*AZ - SGB*BZ#                    Sin of difference                PA57 160
ZSA=SGA*AZA-SGB*BZA#                                                    PA57 161
ZSB=SGA*AZB-SGB*BZB#                                                    PA57 162
ZSAA=SGA*AZAA-SGB*BZAA#                                                 PA57 163
ZSAB=SGA*AZAB-SGB*BZAB#                                                 PA57 164
ZSBB=SGA*AZBB-SGB*BZBB#                                                 PA57 165
ZC=CGA*AZ - CGB*BZ#                    Cos of difference                PA57 166
ZCA=CGA*AZA-CGB*BZA#                                                    PA57 167
ZCB=CGA*AZB-CGB*BZB#                                                    PA57 168
ZCAA=CGA*AZAA-CGB*BZAA#                                                 PA57 169
ZCAB=CGA*AZAB-CGB*BZAB#                                                 PA57 170
ZCBB=CGA*AZBB-CGB*BZBB#                                                 PA57 171
SX=CA*CB*XAB+SA*YAB+CA*SB*Z#           Static frame (x1-x2)-(x1-x2)     PA57 172
SXA=-SA*CB*XAB+CA*YAB-SA*SB*Z+CA*SB*ZA#                                 PA57 173
SXB=-CA*SB*XAB+CA*CB*Z+CA*SB*ZB#                                        PA57 174
SXAA=-CA*CB*XAB-SA*YAB-CA*SB*Z-2.*SA*SB*ZA+CA*SB*ZAA#                   PA57 175
SXBB=-CA*CB*XAB-CA*SB*Z+2.*CA*CB*ZB+CA*SB*ZBB#                          PA57 176
SXAB=SA*SB*XAB-SA*CB*Z+CA*CB*ZA-SA*SB*ZB+CA*SB*ZAB#                     PA57 177
SY= -CB*SA*XCAB-SB*XSAB+CA*YCAB-SA*SB*ZC+CB*ZS# Static frame (y1-y2)-   PA57 178
SYA=-CB*CA*XCAB-SA*YCAB-CA*SB*ZC-SA*SB*ZCA+CB*ZSA#                      PA57 179
SYB=SB*SA*XCAB-CB*XSAB-SA*CB*ZC-SA*SB*ZCB-SB*ZS+CB*ZSB#                 PA57 180
SYAA=CB*SA*XCAB-CA*YCAB+SA*SB*ZC-2.*CA*SB*ZCA-SA*SB*ZCAA+CB*ZSAA#       PA57 181
SYBB=CB*SA*XCAB+SB*XSAB+SA*SB*ZC-2.*SA*CB*ZCB-SA*SB*ZCBB-$#             PA57 182
CB*ZS-2.*SB*ZSB+CB*ZSBB#                                                PA57 183
SYAB=SB*CA*XCAB-CA*CB*ZC-SA*CB*ZCA-CA*SB*ZCB-SA*SB*ZCAB-$#              PA57 184
SB*ZSA+CB*ZSAB#                                                         PA57 185
SZ= CB*SA*XSAB-SB*XCAB-CA*YSAB+SA*SB*ZS+CB*ZC# Static frame (z1-z2)-    PA57 186
SZA=CB*CA*XSAB+SA*YSAB+CA*SB*ZS+SA*SB*ZSA+CB*ZCA#                       PA57 187
SZB=-SB*SA*XSAB-CB*XCAB+SA*CB*ZS+SA*SB*ZSB-SB*ZC+CB*ZCB#                PA57 188
SZAA=-CB*SA*XSAB+CA*YSAB-SA*SB*ZS+2.*CA*SB*ZSA+SA*SB*ZSAA+CB*ZCAA#      PA57 189
SZBB=-CB*SA*XSAB+SB*XCAB-SA*SB*ZS+2.*SA*CB*ZSB+SA*SB*ZSBB-$#            PA57 190
CB*ZC-2.*SB*ZCB+CB*ZCBB#                                                PA57 191
SZAB=-SB*CA*XSAB+CA*CB*ZS+SA*CB*ZSA+CA*SB*ZSB+SA*SB*ZSAB-$#             PA57 192
SB*ZCA+CB*ZCAB#                                                         PA57 193
#                                                                       PA57 194
# SCALE FACTOR DERIVS                                                   PA57 195
# -------------------                                                   PA57 196
#                                                                       PA57 197
XKA=(X1A-X2A) ; XKB=(X1B-X2B)#                                          PA57 198
YKA=(Y1A-Y2A) ; YKB=(Y1B-Y2B)#                                          PA57 199
SXKA= CA*CB*XKA+SA*YKA#                                                 PA57 200
SXKB=-CA*CB*XKB-SA*YKB#                                                 PA57 201
SYKA=-CB*SA*CGA*XKA-SB*SGA*XKA+CA*CGA*YKA#                              PA57 202
SYKB= CB*SA*CGB*XKB+SB*SGB*XKB-CA*CGA*YKB#                              PA57 203
SZKA= CB*SA*SGA*XKA-SB*CGA*XKA-CA*SGA*YKA#                              PA57 204
SZKB=-CB*SA*SGB*XKB+SB*CGB*XKB+CA*SGB*YKB#                              PA57 205
#                                                                       PA57 206
# ACCUMULATE SUMS                                                       PA57 207
# ---------------                                                       PA57 208
#                                                                       PA57 209
QX(LSDRAB+1)= QX(LSDRAB+1)+ SX**2.+SY**2.+SZ**2.# R                     PA57 210
QX(LSDRAB+2)= QX(LSDRAB+2)+ 2.*(SX*SXA+SY*SYA+SZ*SZA)# Ra               PA57 211
QX(LSDRAB+3)= QX(LSDRAB+3)+ 2.*(SX*SXB+SY*SYB+SZ*SZB)# Rb               PA57 212
QX(LSDRAB+4)=QX(LSDRAB+4)+2.*(SXA**2.+SX*SXAA+SYA**2.+SY*SYAA+$#        PA57 213
SZA**2.+SZ*SZAA)#                      Raa                              PA57 214
QX(LSDRAB+5)=QX(LSDRAB+5)+ 2.*(SXB**2.+SX*SXBB+SYB**2.+SY*SYBB+$#       PA57 215
SZB**2.+SZ*SZBB)#                      Rbb                              PA57 216
QX(LSDRAB+6)=QX(LSDRAB+6)+ 2.*(SXB*SXA+SX*SXAB+SYB*SYA+SY*SYAB+$#       PA57 217
SZB*SZA+SZ*SZAB)#                      Rab                              PA57 218
QX(LSDRAB+7)=QX(LSDRAB+7)+2.*(SX*SXKA+SY*SYKA+SZ*SZKA)# Rka             PA57 219
QX(LSDRAB+8)=QX(LSDRAB+8)+2.*(SX*SXKB+SY*SYKB+SZ*SZKB)# Rkb             PA57 220
QX(LSDRAB+9)=QX(LSDRAB+9)+2.*(SXKA**2.+SYKA**2.+SZKA**2.)# R2ka         PA57 221
QX(LSDRAB+10)=QX(LSDRAB+10)+2.*(SXKB**2.+SYKB**2.+SZKB**2.)# R2kb       PA57 222
#                                                                       PA57 223
100 CONTINUE#                                                           PA57 224
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA57 225
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA57 226
#                                                                       PA57 227
RETURN#                                                                 PA57 228
END#                                                                    PA57 229
#                                                                       PA57 230
systemheader:(PA58)#                                                    PA58   1
####################################################################    PA58   2
#                                                                  #    PA58   3
# CALCULATE RELATIVE POSITION MATRICES                                  PA58   4
#                                                                  #    PA58   5
####################################################################    PA58   6
SUBROUTINE PA58(NCV,MARKE)#                                             PA58   7
include:(AACOMN)#                                                       PA58   8
include:(PACOMN)#                                                       PA58   9
#                                                                       PA58  10
INTEGER II,I,J,K,L,M,N#                                                 PA58  11
INTEGER ROW,COL#                                                        PA58  12
INTEGER V2,ROWI,COLJ,POS#                                               PA58  13
INTEGER MARKE,NCV#                     Pa58                             PA58  14
INTEGER TMP#                                                            PA58  15
REAL DIFF Z1A,Z2A#                                                      PA58  16
REAL RIJ(3)#                                                            PA58  17
REAL GA,GB#                                                             PA58  18
REAL SGA,CGA,SGB,CGB#                  Sin cos of gamma in frame a,b    PA58  19
REAL X1A,Y1A,X2A,Y2A#                  Points 1,2 frame a               PA58  20
REAL X1B,Y1B,X2B,Y2B#                  Points 1,2 frame b               PA58  21
REAL XA,XB,YA,YB,XAB,YAB#                                               PA58  22
REAL XSAB,YSAB,XCAB,YCAB#                                               PA58  23
REAL XSA,XSB,XCA,XCB#                                                   PA58  24
REAL YSA,YSB,YCA,YCB#                                                   PA58  25
REAL SN,DET#                                                            PA58  26
REAL NM,DN#                                                             PA58  27
REAL SX,SY,SZ,R#                                                        PA58  28
REAL Z,ZS,ZC#                                                           PA58  29
REAL ZA,ZB,ZSA,ZSB,ZCA,ZCB#                                             PA58  30
REAL SXA,SXB,SYA,SYB,SZA,SZB#                                           PA58  31
REAL D,E,DL#                                                            PA58  32
REAL KA,KB#                                                             PA58  33
REAL DL1,E1,D1,ZA1#                                                     PA58  34
datastuff:#                                                             PA58  35
#                                                                       PA58  36
KA=1.00#                                                                PA58  37
KB=1.00#                                                                PA58  38
GA= QX(MARKE+4)#                                                        PA58  39
GB= QX(MARKE+5)#                                                        PA58  40
SGA=SIN(GA) ; CGA=COS(GA)#                                              PA58  41
SGB=SIN(GB) ; CGB=COS(GB)#                                              PA58  42
SA=SIN(ALF) ; CA=COS(ALF)#                                              PA58  43
SB=SIN(BET) ; CB=COS(BET)#                                              PA58  44
#                                                                       PA58  45
D=CB*CGA+SA*SB*SGA#                    Definition of d                  PA58  46
D1=CB*SGA-SA*SB*CGA#                                                    PA58  47
E=CB*CGB+SA*SB*SGB#                    Definition of e                  PA58  48
E1=CB*SGB-SA*SB*CGB#                                                    PA58  49
#                                                                       PA58  50
DO ROW = 1,NCV-1#                      Loop over first common points    PA58  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA58  52
DO COL = ROW+1,NCV#                    Loop over second common point    PA58  53
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA58  54
#                                                                       PA58  55
#   GET TWO POINTS IN TWO PHOTOS                                        PA58  56
#   ----------------                                                    PA58  57
#                                                                       PA58  58
ROWI=NINT(QX(MARKE+ROW*DTPK+1));COLJ=NINT(QX(MARKE+COL*DTPK+1))#        PA58  59
X1A=QX(MARKE+ROW*DTPK+2) ; X1B=QX(MARKE+ROW*DTPK+4)#                    PA58  60
Y1A=QX(MARKE+ROW*DTPK+3) ; Y1B=QX(MARKE+ROW*DTPK+5)#                    PA58  61
X2A=QX(MARKE+COL*DTPK+2) ; X2B=QX(MARKE+COL*DTPK+4)#                    PA58  62
Y2A=QX(MARKE+COL*DTPK+3) ; Y2B=QX(MARKE+COL*DTPK+5)#                    PA58  63
XA=KA*(X1A-X2A) ; XB=KB*(X1B-X2B)#                                      PA58  64
YA=KA*(Y1A-Y2A) ; YB=KB*(Y1B-Y2B)#                                      PA58  65
XAB=XA-XB  ; YAB=YA-YB#                                                 PA58  66
XSAB=SGA*XA - SGB*XB ; YSAB=SGA*YA - SGB*YB#                            PA58  67
XCAB=CGA*XA - CGB*XB ; YCAB=CGA*YA - CGB*YB#                            PA58  68
DL= CB*SA*XSAB-SB*XCAB-CA*YSAB#                                         PA58  69
DL1=-CB*SA*XCAB-SB*XSAB+CA*YCAB#                                        PA58  70
ZA=(DL*E1-DL1*E)/(D1*E-D*E1)#                                           PA58  71
ZB=(DL+D*ZA)/E#                        Sign and magn soln (z1b-z2b)     PA58  72
#                                                                       PA58  73
XSA=SGA*XA ; XSB=SGB*XB#                                                PA58  74
XCA=CGA*XA ; XCB=CGB*XB#                                                PA58  75
YSA=SGA*YA ; YSB=SGB*YB#                                                PA58  76
YCA=CGA*YA ; YCB=CGB*YB#                                                PA58  77
ZSA=SGA*ZA ; ZSB=SGB*ZB#                                                PA58  78
ZCA=CGA*ZA ; ZCB=CGB*ZB#                                                PA58  79
SXA=CA*CB*XA+SA*YA+CA*SB*ZA#           Static frame (x1-x2)frame a      PA58  80
SXB=CA*CB*XB+SA*YB+CA*SB*ZB#           Static frame (x1-x2)frame b      PA58  81
SYA=-CB*SA*XCA-SB*XSA+CA*YCA-SA*SB*ZCA+CB*ZSA# Static frame (y1-y2)a    PA58  82
SYB=-CB*SA*XCB-SB*XSB+CA*YCB-SA*SB*ZCB+CB*ZSB# Static frame (y1-y2)b    PA58  83
SZA= CB*SA*XSA-SB*XCA-CA*YSA+SA*SB*ZSA+CB*ZCA# Static frame (z1-z2)a    PA58  84
SZB= CB*SA*XSB-SB*XCB-CA*YSB+SA*SB*ZSB+CB*ZCB# Static frame (z1-z2)b    PA58  85
#                                                                       PA58  86
V2=VMAX*(VMAX-1)/2#                                                     PA58  87
IF (ROWI>COLJ)#                        Low half of antisymtrc matrix    PA58  88
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA58  89
SXA=-SXA;SXB=-SXB#                     Convert xj-xi to xi-xj           PA58  90
SYA=-SYA;SYB=-SYB#                     Convert yj-yi to yi-yj           PA58  91
SZA=-SZA;SZB=-SZB#                     Convert zj-zi to zi-zj           PA58  92
TMP=ROWI;ROWI=COLJ;COLJ=TMP#           Convert j to i and i to j        PA58  93
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA58  94
POS=(ROWI-1)*VMAX+COLJ-ROWI*(ROWI+1)/2# Positn in upper diag matrix     PA58  95
QX(RELCOM+POS     )=QX(RELCOM+POS     )+SXA+SXB# Relatv coords xi-xj    PA58  96
QX(RELCOM+POS+  V2)=QX(RELCOM+POS+  V2)+SYA+SYB# Relatv coords yi-yj    PA58  97
QX(RELCOM+POS+2*V2)=QX(RELCOM+POS+2*V2)+SZA+SZB# Relatv coords zi-zj    PA58  98
QX(RELCOM+POS+3*V2)=QX(RELCOM+POS+3*V2)+2.0#                            PA58  99
#                                                                       PA58 100
100 CONTINUE#                                                           PA58 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA58 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA58 103
#                                                                       PA58 104
RETURN#                                                                 PA58 105
END#                                                                    PA58 106
#                                                                       PA58 107
systemheader:(PA59)#                                                    PA59   1
####################################################################    PA59   2
#                                                                  #    PA59   3
# PRINT RELATIVE POSITION MATRICES                                 #    PA59   4
#                                                                  #    PA59   5
####################################################################    PA59   6
SUBROUTINE PA59(EMARK,DIM,NUM,TYPE)#                                    PA59   7
include:(AACOMN)#                                                       PA59   8
include:(PACOMN)#                                                       PA59   9
INTEGER I,J,K,POS,V2#                                                   PA59  10
INTEGER EMARK,DIM,NUM,TYPE#                                             PA59  11
realdata:(FM2,[70622.,140622.,210622.,280622.,350622.,420622.,$#        PA59  12
490622.,560622.,630622.,700622.,7700622.,840622.,910622.])#             PA59  13
chardata:(XT502,"  (i-2)  (i-3)  (i-4)  (i-5)  (i-6)  (i-7)  $#         PA59  14
(i-8)  (i-9)  (i-10) (i-11) (i-12)")#                                   PA59  15
datastuff:#                                                             PA59  16
#                                                                       PA59  17
WRITE(6,*)" "#                                                          PA59  18
WRITE(6,*)" "#                                                          PA59  19
IF (TYPE==1)#                                                           PA59  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA59  21
V2=DIM*(DIM+1)/2#                      Pa                               PA59  22
DO K=0,NUM-1#                                                           PA59  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA59  24
WRITE(6,*)"matrix number (1=x,2=y,3=z) : ",K+1#                         PA59  25
writeline:(0,XT502,NXT502,3,3)#        Write to outfile                 PA59  26
POS=1#                                                                  PA59  27
DO I=1,DIM#                            Pa5                              PA59  28
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA59  29
DO J=0,I-1 ;BUFOT(J)=0.0#                                               PA59  30
DO J=I,DIM#                            Pa5                              PA59  31
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA59  32
BUFOT(J)=QX(EMARK+POS+K*V2)#                                            PA59  33
POS=POS+1#                                                              PA59  34
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA59  35
ncodefld:(BUFOT,1,CHROT,FM2,DIM)#      Pa5                              PA59  36
writeline:(0,XT502,NXT502,1,3)#        Write to outfile                 PA59  37
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA59  38
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA59  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA59  40
ELSEIF (TYPE==2)#                                                       PA59  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA59  42
DO I=1,DIM#                            Pa5                              PA59  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA59  44
DO J=1,DIM#                            Pa5                              PA59  45
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA59  46
BUFOT(J)=QX(EMARK+(I-1)*DIM+J)#                                         PA59  47
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA59  48
ncodefld:(BUFOT,1,CHROT,FM2,DIM)#      Pa5                              PA59  49
writeline:(0,XT502,NXT502,1,3)#        Write to outfile                 PA59  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA59  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA59  52
#                                                                       PA59  53
RETURN#                                                                 PA59  54
END#                                                                    PA59  55
#                                                                       PA59  56
systemheader:(PA60)#                   Matrix inversion                 PA60   1
# ####################################################################  PA60   2
#                                                                       PA60   3
#                               CR30                                    PA60   4
#                                                                       PA60   5
# ####################################################################  PA60   6
SUBROUTINE PA60(LL11,L12,L13,VARBLK,ICYCLE)#  R.olthof   august 1980
#                                      May 1985                         PA60   8
include:(AACOMN)#                                                       PA60   9
include:(PACOMN)#                                                       PA60  10
#                                                                       PA60  11
REAL    FACT#      ## FACTOR FOR ST.DEV.                                PA60  12
INTEGER I,J,K,P#   ##                                                   PA60  13
INTEGER L8#        ## POINTER IN MARK8 ARRAY                            PA60  14
INTEGER LL11,L11,L11K,L11P,L11KK,L11KP,L11KJ,L11PP,L11PJ#             
INTEGER L12,L12K,L12P,L13#                                              PA60  16
INTEGER NBLK#      ## NUMBER OF BLOCKS                                  PA60  17
REAL    Q#         ##                                                   PA60  18
INTEGER VARBLK#    ## NO. OF VARIABLES IN A BLOCK                       PA60  19
INTEGER ICYCLE,NCYCLE#                                                  PA60  20
datastuff:#                                                             PA60  21
#                                                                       PA60  22
#       MATRIX INVERSION                                                PA60  23
#       ----------------                                                PA60  24
#                                                                       PA60  25
NCYCLE=2#                                                               PA60  26
#                                                                       PA60  27
#                                                                       PA60  28
L11=LL11
L11K=L11#                                                               PA60  29
DO K=1,VARBLK#                         Loop over variables in 1 blo     PA60  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA60  31
L11KK=L11K+K;L12K=L12+K#                                                PA60  32
L11P=L11#                                                               PA60  33
FOR(P=1;P<K;P=P+1)#                    Loop over 1 row                  PA60  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA60  35
L11PP=L11P+P;L11PK=L11P+K;L12P=L12+P#                                   PA60  36
Q=QX(L11PK)*QX(L11PP)#                                                  PA60  37
DO J=K,VARBLK#                                                          PA60  38
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA60  39
L11KJ=L11K+J;L11PJ=L11P+J#                                              PA60  40
QX(L11KJ)=QX(L11KJ)-Q*QX(L11PJ)#       Pa                               PA60  41
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA60  42
QX(L12K)=QX(L12K)-Q*QX(L12P)#                                           PA60  43
L11P=L11P+VARBLK-P#                                                     PA60  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA60  45
ifne:(QX(L11KK),0.) QX(L11KK)=1./QX(L11KK)#                             PA60  46
L11K=L11K+VARBLK-K#                                                     PA60  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA60  48
#                                                                       PA60  49
#                                                                       PA60  50
L11=L11K#                                                               PA60  53
FOR(K=VARBLK;K>=1;K=K-1)#                                               PA60  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA60  55
L11KK=L11K+K;L12K=L12+K#                                                PA60  56
QX(L12K)=QX(L12K)*QX(L11KK)#                                            PA60  57
L11P=L11#                                                               PA60  58
FOR(P=VARBLK;P>K;P=P-1)#                                                PA60  59
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA60  60
L11PP=L11P+P;L11KP=L11K+P#                                              PA60  61
L12P=L12+P;L13P=L13+P#                                                  PA60  62
QX(L13P)=QX(L11KK)*QX(L11KP)#                                           PA60  63
QX(L12K)=QX(L12K)-QX(L13P)*QX(L12P)#                                    PA60  64
IF(ICYCLE!=(NCYCLE-1)) NEXT#           Inversion only in last cycle     PA60  65
QX(L11KP)=-QX(L13P)*QX(L11PP)#                                          PA60  66
FOR(J=P+1;J<=VARBLK;J=J+1)#                                             PA60  67
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA60  68
L11PJ=L11P+J;L11KJ=L11K+J;L13J=L13+J#                                   PA60  69
QX(L11KP)=QX(L11KP)-QX(L13J)*QX(L11PJ)#                                 PA60  70
QX(L11KJ)=QX(L11KJ)-QX(L13P)*QX(L11PJ)#                                 PA60  71
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA60  72
L11P=L11P-VARBLK+P-1#                                                   PA60  73
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA60  74
IF(ICYCLE==(NCYCLE-1))#                Inverted diag.el. in last c.     PA60  75
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PA60  76
FOR(J=K+1;J<=VARBLK;J=J+1)#                                             PA60  77
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PA60  78
L11KJ=L11K+J;L13J=L13+J#                                                PA60  79
QX(L11KK)=QX(L11KK)-QX(L13J)*QX(L11KJ)#                                 PA60  80
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PA60  81
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PA60  82
L11K=L11K-VARBLK+K-1#                                                   PA60  83
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA60  84
#                                                                       PA60  85
#                                                                       PA64 155
FACT=1.0
L11=LL11+1;L13=L13+1
DO K=1,VARBLK#                         Standard deviation 
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR30 117
QX(L13)=SQRT(ABS(QX(L11)*FACT))#                                      CR30 118
L11=L11+VARBLK-K+1;L13=L13+1#                                           CR30 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR30 120
#
RETURN#                                                                 PA60  87
END#                                                                    PA60  88
#                                                                       PA60  89
systemheader:(PA61)#                                                    PA61   1
####################################################################    PA61   2
#                                                                  #    PA61   3
#  REDUCED CRYSTAL FACES                                           #    PA61   4
#                                                                  #    PA61   5
####################################################################    PA61   6
SUBROUTINE PA61#                                                        PA61   7
include:(AACOMN)#                                                       PA61   8
include:(PACOMN)#                                                       PA61   9
#                                                                       PA61  10
INTEGER I,J,K,L#                                                        PA61  11
INTEGER II,JJ,IJ,KI,KJ,KK#                                              PA61  12
INTEGER MARKF,MARKF1,MARKG,MARKH,MARKH1#                                PA61  13
INTEGER MARKA,MARKB#                                                    PA61  14
INTEGER PED,FPKT1#                                                      PA61  15
INTEGER NV1,NV2,NVA,NVB#                                                PA61  16
INTEGER VA,VB,JA,JB#                                                    PA61  17
INTEGER IJPOS#                                                          PA61  18
INTEGER TEST#                                                           PA61  19
INTEGER A,B,C,D,STP#                                                    PA61  20
INTEGER F1,F2#                                                          PA61  21
#                                                                       PA61  22
REAL NDIFF,HYP#                                                         PA61  23
REAL XA,XB,YA,YB,ZA,ZB#                                                 PA61  24
REAL A1,B1,C1,D1,DB#                                                    PA61  25
datastuff:#                                                             PA61  26
#                                                                       PA61  27
PED=VMAX*(VMAX-1)/2#                   Num of possible edges            PA61  28
FPKT=8+VMAX#                           New size of a face packet        PA61  29
REDGES=WRKSPC#                         Location of reduced edge set     PA61  30
incrqx:(RFACE,REDGES+3*PED,PA6101)#                                     PA61  31
movereal:(QX,EDGES+1,QX,REDGES+1,3*PED,1)# Reduced edge list            PA61  32
MARKF=RFACE#                                                            PA61  33
MARKG=FACE#                                                             PA61  34
DO I=1,FACES#                          Copy face list to new list       PA61  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA61  36
incrqx:(MARKF1,MARKF+FPKT,PA6101)#                                      PA61  37
FPKT1=8+NINT(QX(MARKG+7))#             Length of original               PA61  38
movereal:(QX,MARKG+1,QX,MARKF+1,FPKT1,1)# Reduced edge list             PA61  39
movereal:(0.0,1,QX,MARKF+FPKT1+1,FPKT-FPKT1,2)# Space to grow           PA61  40
MARKG=MARKG+FPKT1#                     Update triang face pointer       PA61  41
MARKF=MARKF1#                          Update reduced face pointer      PA61  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA61  43
WRKSPC=MARKF#                          Limit of current use             PA61  44
#                                                                       PA61  45
#                                                                       PA61  46
#                                                                       PA61  47
#                                                                       PA61  48
MARKF=RFACE#                                                            PA61  49
MARKH=WRKSPC#                                                           PA61  50
incrqx:(MARKH1,MARKH+FPKT,PA5603)#     New face packet from face m      PA61  51
DO L=1,FACES#                                                           PA61  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA61  53
I=1#                                   Count vertices                   PA61  54
F1=NINT(QX(MARKF+1))#                                                   PA61  55
IF (F1==0) GOTO 100#                                                    PA61  56
REPEAT#                                Loop over the vertices           PA61  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA61  58
NV1=QX(MARKF+7)#                       Number of vertices on face       PA61  59
II=NINT(QX(MARKF+7+I))#                First vertex                     PA61  60
JJ=NINT(QX(MARKF+7+I+1))#              Second vertex                    PA61  61
IJPOS=(II-1)*VMAX+JJ-II*(II+1)/2#      Position of edge between 1 2     PA61  62
IF (II>JJ) IJPOS=(JJ-1)*VMAX+II-JJ*(JJ+1)/2# New position               PA61  63
ifeq:(QX(REDGES+IJPOS+PED),QX(REDGES+IJPOS+PED*2))#                     PA61  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA61  65
I=I+1#                                                                  PA61  66
GOTO 100#                                                               PA61  67
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA61  68
IF    (NINT(QX(REDGES+IJPOS+PED))==F1)F2=NINT(QX(REDGES+IJPOS+PED*2))#  PA61  69
ELSEIF(NINT(QX(REDGES+IJPOS+2*PED))==F1)F2=NINT(QX(REDGES+IJPOS+PED))#  PA61  70
ELSE BREAK#                            Next face                        PA61  71
MARKG=RFACE#                           Begin at start of face list      PA61  72
REPEAT#                                Find face f2                     PA61  73
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA61  74
IF (NINT(QX(MARKG+1))==F2) BREAK#      Face f2 is found so quit         PA61  75
MARKG=MARKG+FPKT#                      Increment face pointer           PA61  76
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA61  77
IF (QX(MARKG+6)>QX(MARKF+6))#          Test areas                       PA61  78
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA61  79
MARKA=MARKG ;MARKB=MARKF#              Face two is larger than one      PA61  80
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA61  81
ELSE#                                  Face one is larger than two      PA61  82
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA61  83
MARKB=MARKG ;MARKA=MARKF#              Adjust pointrs for face tests    PA61  84
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA61  85
#                                                                       PA61  86
#  TEST NORMALS                                                         PA61  87
#                                                                       PA61  88
NTEST=no: ;DTEST=no: ; ATEST=yes:#                                      PA61  89
NDELT=0.20 ;DDELT=0.4 ; ADELT=0.25#                                     PA61  90
TEST=yes:#                                                              PA61  91
IF (NTEST==yes:)#                                                       PA61  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PA61  93
XA=QX(MARKA+2) ; XB=QX(MARKB+2)#                                        PA61  94
YA=QX(MARKA+3) ; YB=QX(MARKB+3)#                                        PA61  95
ZA=QX(MARKA+4) ; ZB=QX(MARKB+4)#                                        PA61  96
NDIFF=SQRT((XA-XB)**2.+(YA-YB)**2.+(ZA-ZB)**2.)#                        PA61  97
IF (NDIFF>NDELT) TEST=no:#                                              PA61  98
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PA61  99
#                                                                       PA61 100
#  TEST DISTANCES                                                       PA61 101
#                                                                       PA61 102
IF (DTEST==yes:)#                                                       PA61 103
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PA61 104
A1=QX(MARKA+2) ; B1=QX(MARKA+3)#                                        PA61 105
C1=QX(MARKA+4) ; D1=QX(MARKA+5)#                                        PA61 106
NV=NINT(QX(MARKB+7))#                                                   PA61 107
DO J=1,NV#                                                              PA61 108
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PA61 109
VB=NINT(QX(MARKB+7+J))#                                                 PA61 110
IF ((VB==II)\(VB==JJ)) NEXT#           Skip coz ok                      PA61 111
X1=QX(DVERT+VB)#                                                        PA61 112
Y1=QX(DVERT+VB+VMAX)#                                                   PA61 113
Z1=QX(DVERT+VB+VMAX*2)#                                                 PA61 114
DB=A1*X1+B1*Y1+C1*Z1#                                                   PA61 115
IF (ABS(DB-D1)>DDELT) TEST=no:#                                         PA61 116
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PA61 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PA61 118
#                                                                       PA61 119
#  TEST PLANE-VERTEX ANGLES                                             PA61 120
#                                                                       PA61 121
IF (ATEST==yes:)#                                                       PA61 122
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PA61 123
A1=QX(MARKA+2) ; B1=QX(MARKA+3)#                                        PA61 124
C1=QX(MARKA+4) ; D1=QX(MARKA+5)#                                        PA61 125
NVA=NINT(QX(MARKA+7))#                                                  PA61 126
NVB=NINT(QX(MARKB+7))#                                                  PA61 127
DO JA=1,NVA#                                                            PA61 128
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PA61 129
VA=NINT(QX(MARKA+7+JA))#                                                PA61 130
XA=QX(DVERT+VA)#                                                        PA61 131
YA=QX(DVERT+VA+VMAX)#                                                   PA61 132
ZA=QX(DVERT+VA+VMAX*2)#                                                 PA61 133
DO JB=1,NVB#                                                            PA61 134
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PA61 135
VB=NINT(QX(MARKB+7+JB))#                                                PA61 136
IF ((VB==II)\(VB==JJ)) NEXT#           Skip coz ok                      PA61 137
IF (VA==VB)NEXT#                                                        PA61 138
XB=QX(DVERT+VB)#                                                        PA61 139
YB=QX(DVERT+VB+VMAX)#                                                   PA61 140
ZB=QX(DVERT+VB+VMAX*2)#                                                 PA61 141
DB=A1*XB+B1*YB+C1*ZB#                  Perpend dist from plane          PA61 142
HYP=SQRT((XA-XB)**2.+(YA-YB)**2.+(ZA-ZB)**2.)#                          PA61 143
IF (ABS((DB-D1)/HYP)> ADELT) TEST=no:#                                  PA61 144
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PA61 145
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PA61 146
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PA61 147
#                                                                       PA61 148
#                                                                       PA61 149
#                                                                       PA61 150
#                                                                       PA61 151
IF (TEST==yes:)#                       Face 2 is coplanar               PA61 152
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PA61 153
NV2=NINT(QX(MARKG+7))#                                                  PA61 154
DO J=1,NV2#                                                             PA61 155
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PA61 156
KK=NINT(QX(MARKG+7+J))#                                                 PA61 157
IF (KK==II)KI=J#                                                        PA61 158
IF (KK==JJ)KJ=J#                                                        PA61 159
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PA61 160
IF (KI-KJ>1)KJ=KI+1#                   Not consecutive so at            PA61 161
IF (KI-KJ<-1)KI=KJ+1#                  End of edge list                 PA61 162
IF (KI>KJ)#                                                             PA61 163
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PA61 164
A=MARKG+7+KI ; B=MARKG+7+NV2+1#                                         PA61 165
C=MARKG+7+1  ; D=MARKG+7+KJ ;STP=1#                                     PA61 166
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PA61 167
ELSE#                                                                   PA61 168
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PA61 169
A=MARKG+7+KI    ; B=MARKG+7+1#                                          PA61 170
C=MARKG+7+NV2+1 ; D=MARKG+7+KJ ;STP=-1#                                 PA61 171
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PA61 172
movereal:(QX,MARKF+1,QX,MARKH+1,7+I,1)# Copy from face f1               PA61 173
MARKH1=MARKH+7+I#                                                       PA61 174
QX(MARKH+6)=QX(MARKH+6)+QX(MARKG+6)#   Update area from facef2          PA61 175
QX(MARKH+7)=NV1+NV2-2#                 Update num vert from facef2      PA61 176
DO K=A,B,STP ;QX(MARKH1+ABS(K-A))=QX(K)# Add first part of face 2       PA61 177
DO K=C,D,STP ;QX(MARKH1+ABS(K-C)+ABS(B-A))=QX(K)# Add second part       PA61 178
MARKH1=MARKH1+NV2-2#                                                    PA61 179
movereal:(QX,MARKF+7+I+1,QX,MARKH1+1,NV1-I+1,1)# Copy from face f1      PA61 180
movereal:(QX,MARKH+1,QX,MARKF+1,FPKT,1)# Copy back to face list         PA61 181
movereal:(0.0,1,QX,MARKH+1,FPKT,2)#                                     PA61 182
QX(REDGES+IJPOS)=-QX(REDGES+IJPOS)#    Mark edge for rejection          PA61 183
DO K=1,NV2#                            Reset face pointers to new fac   PA61 184
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PA61 185
KI=QX(MARKG+7+K)#                      First vertex                     PA61 186
KJ=QX(MARKG+7+K+1)#                    Second vertex                    PA61 187
IJPOS=(KI-1)*VMAX+KJ-KI*(KI+1)/2#      Position in matrix               PA61 188
IF (KI>KJ) IJPOS=(KJ-1)*VMAX+KI-KJ*(KJ+1)/2# Position in matrix         PA61 189
IF (NINT(QX(REDGES+IJPOS+PED))==F2) QX(REDGES+IJPOS+PED)=FLOAT(F1)#     PA61 190
ELSE QX(REDGES+IJPOS+PED*2)=FLOAT(F1)# Reset face pointer               PA61 191
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PA61 192
movereal:(0.0,1,QX,MARKG+1,FPKT,2)#    Erase face                       PA61 193
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PA61 194
ELSE I=I+1#                            Increment vertex counter         PA61 195
100 CONTINUE#                                                           PA61 196
NV1=QX(MARKF+7)#                                                        PA61 197
IF (I==NV1+1) BREAK#                                                    PA61 198
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA61 199
MARKF=MARKF+FPKT#                                                       PA61 200
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA61 201
#                                                                       PA61 202
# REDUCED FACE SET                                                      PA61 203
# ----------------                                                      PA61 204
#                                                                       PA61 205
MARKF=RFACE#                                                            PA61 206
MARKF1=MARKF#                                                           PA61 207
RFACES=0#                                                               PA61 208
REPEAT#                                                                 PA61 209
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PA61 210
REPEAT#                                                                 PA61 211
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PA61 212
IF (MARKF1>=RFACE+FACES*FPKT)BREAK#                                     PA61 213
ifne:(QX(MARKF1+1),0.0)BREAK#                                           PA61 214
MARKF1=MARKF1+FPKT#                                                     PA61 215
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PA61 216
IF (MARKF1>=RFACE+FACES*FPKT)BREAK#                                     PA61 217
movereal:(QX,MARKF1+1,QX,MARKF+1,FPKT,1)# Copy back to face list        PA61 218
CALL PA64(MARKF)#  
RFACES=RFACES+1#                                                        PA61 220
MARKF=MARKF+FPKT#                                                       PA61 221
MARKF1=MARKF1+FPKT#                                                     PA61 222
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PA61 223
WRITE(6,*)"reduced num of faces is ",RFACES#                            PA61 224
WRKSPC=MARKF#                                                           PA61 225
#                                                                       PA61 226
# LIST ALL EDGES                                                        PA61 227
# --------------                                                        PA61 228
#                                                                       PA61 229
WRITE(6,*)"REDUCED FACE EDGES"#                                         PA61 230
DO I=1,VMAX-1#                                                          PA61 231
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PA61 232
DO J=I+1,VMAX#                                                          PA61 233
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PA61 234
IJPOS=(I-1)*VMAX+J-I*(I+1)/2#                                           PA61 235
ifeq:(QX(REDGES+IJPOS),2.0) WRITE (6,2005)I,J#                          PA61 236
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PA61 237
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PA61 238
2005 FORMAT(' {',1X,I3,' , ',1X,I3,' }, ')#                             PA61 239
#CALL PA59(REDGES,VMAX-1,3,1)#          PRINT                           PA61 240
#                                                                       PA61 241
RETURN#                                                                 PA61 242
END#                                                                    PA61 243
#                                                                       PA61 244
systemheader:(PA63)#                                                    PA63   1
####################################################################    PA63   2
#                                                                  #    PA63   3
#  MILLER INDICES                                                  #    PA63   4
#                                                                  #    PA63   5
####################################################################    PA63   6
SUBROUTINE PA63#                                                        PA63   7
include:(AACOMN)#                                                       PA63   8
include:(PACOMN)#                                                       PA63   9
#                                                                       PA63  10
INTEGER I,H,K,L#                                                        PA63  11
INTEGER MARKF
INTEGER STP
REAL VC1(3),VC2(3)#                                                     PA63  12
REAL FI,PHISHF(3,3)
REAL DIST#                                                              PA63  13
REAL TTH,OME,PHI,CHI#                                                   PA63  14
#                                                                       PA63  15
datastuff:#                                                             PA63  16
#                                                                       PA63  17
DO I=1,RFACES#                                                          PA63  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA63  19
WRITE(6,*)"   "#                                                        PA63  20
WRITE(6,*)"   "#                                                        PA63  21
WRITE(6,*)" FACE NUMBER      ",I#                                       PA63  22
MARKF=RFACE+(I-1)*FPKT
VC1(1)=QX(MARKF +2)#
VC1(2)=QX(MARKF +3)#
VC1(3)=QX(MARKF +4)#
PHI= 180/PI*(ATAN(VC1(1)/VC1(2)))#                      
CHI=180/PI*(ATAN(VC1(3)/(SQRT(VC1(1)**2.+VC1(2)**2.))))# 
DIST= QX(RFACE+(I-1)*FPKT +5)/SQRT(VC1(1)**2.+VC1(2)**2.+VC1(3)**2.)#   PA63  28
WRITE(6,3005) PHI,CHI#                                                  PA63  29
postm:(UB1,VC1,VC2)#                                                    PA63  30
H=NINT(VC2(1))#                                                         PA63  31
K=NINT(VC2(2))#                                                         PA63  32
L=NINT(VC2(3))#                                                         PA63  33
WRITE(6,3010) H,K,L,VC2(1),VC2(2),VC2(3)#                               PA63  34
WRITE(6,3015)VC1(1),VC1(2),VC1(3),DIST#                                 PA63  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA63  36
#
#
#
#
IF (PHROT==yes:)
$(
STP=NINT((PHMax-PHMin)/PHSTP)
PHI=PHMIN
PHISHF(1,3)=0.0  ; PHISHF(2,3)=0.0
PHISHF(3,1)=0.0  ; PHISHF(3,2)=0.0  ; PHISHF(3,3)=1.0# 
Do J=1,stp
$(
PHISHF(1,1)=COS(PHI) ; PHISHF(1,2)=SIN(PHI)
PHISHF(2,1)=-SIN(PHI); PHISHF(2,2)=COS(PHI)
DO I=1,RFACES#                                                          PA63  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA63  19
WRITE(6,*)"   "#                                                        PA63  20
WRITE(6,*)" PHI ANGLE        ",PHI*180./PI# 
WRITE(6,*)" FACE NUMBER      ",I#                                       PA63  22
MARKF=RFACE+(I-1)*FPKT
VC1(1)=QX(MARKF +2)#
VC1(2)=QX(MARKF +3)#
VC1(3)=QX(MARKF +4)#
postm:(phishf,vc1,vc2)
FI= 180/PI*(ATAN(VC2(1)/VC2(2)))#                      
CHI=180/PI*(ATAN(VC2(3)/(SQRT(VC2(1)**2.+VC2(2)**2.))))# 
DIST= QX(RFACE+(I-1)*FPKT +5)/SQRT(VC2(1)**2.+VC2(2)**2.+VC2(3)**2.)#   PA63  28
WRITE(6,3005) FI,CHI#                                                  PA63  29
postm:(UB1,VC2,VC1)#                                                    PA63  30
H=NINT(VC1(1))#                                                         PA63  31
K=NINT(VC1(2))#                                                         PA63  32
L=NINT(VC1(3))#                                                         PA63  33
WRITE(6,3010) H,K,L,VC1(1),VC1(2),VC1(3)#                               PA63  34
WRITE(6,3015)VC2(1),VC2(2),VC2(3),DIST#                                 PA63  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA63  36
PHI=phi+phstp
$)
$)
3005 FORMAT('Phi and Chi    ',25X,2F7.3)#                               PA63  37
3010 FORMAT('miller indices ',1X,3I5,5X,3F8.2)#                         PA63  38
3015 FORMAT('plane a b c d  ',1X,4F8.3)#                                PA63  39
#                                                                       PA63  40
#                                                                       PA63  41
RETURN#                                                                 PA63  42
END#                                                                    PA63  43
#                                                                       PA63  44
systemheader:(PA64)#                                                    PA64   1
####################################################################    PA64   2
#                                                                  #    PA64   3
#  LEAST SQUARES FACE PLANE                                        #    PA64   4
#                                                                  #    PA64   5
####################################################################    PA64   6
SUBROUTINE PA64(MARKF)#                                                 PA64   7
include:(AACOMN)#                                                       PA64   8
include:(PACOMN)#                                                       PA64   9
#                                                                       PA64  10
INTEGER I,J,K,N#                                                        PA64  11
INTEGER JE,J1,J2,JJ(3)#                                                 PA64  12
INTEGER JATM(12)#                                                       PA64  13
INTEGER MARKF,MARKG,MARKG1#                                             PA64  14
REAL C(3,3),CI(3,3),DROTI(3,3)#                                         PA64  15
REAL DD,S,DP(4),DPJ(3),A#                                               PA64  16
REAL H(3),HMAX,SUMP,SC#                                                 PA64  17
REAL PLN,POLD(4),PSQ,PQ(4)#                                             PA64  18
REAL Q(3),QSQ,TEMP#                                                     PA64  19
REAL WX(3),YY(3),YWD(3)#                                                PA64  20
#                                                                       PA64  21
datastuff:#                                                             PA64  22
#                                                                       PA64  23
#     LOOP OVER FACE VERTICES                                           PA64  24
#     ------------------------                                          PA64  25
#                                                                       PA64  26
MARKG=WRKSPC#                                                           PA64  27
MARKG1=MARKG#                                                           PA64  28
XAVE=0.0 ; YAVE=0.0 ; ZAVE=0.0#                                         PA64  29
NV=NINT(QX(MARKF+7))#                                                   PA64  30
DO I=1,NV#                                                              PA64  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA64  32
incrqx:(MARKG1,MARKG1+5,PA64)#                                          PA64  33
VPOS=NINT(QX(MARKF+7+I))#                                               PA64  34
QX(MARKG1-2)=QX(DVERT+VPOS)#           X coord                          PA64  35
QX(MARKG1-1)=QX(DVERT+VPOS+VMAX)#      Y coord                          PA64  36
QX(MARKG1  )=QX(DVERT+VPOS+2*VMAX)#    Z coord                          PA64  37
JATM(I)=MARKG1-5#                                                       PA64  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA64  39
#                                                                       PA64  40
#     PERFORM LS CALCULATION                                            PA64  41
#     ----------------------                                            PA64  42
#                                                                       PA64  43
DO I=1,3; DO J=1,3 ; C(I,J)=0.0#       Reset arrays                     PA64  44
DO I=1,3; WX(I)=0.0#                   Reset arrays                     PA64  45
#                                                                       PA64  46
DO I=1,NV#                             Loop over plane defining atoms   PA64  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA64  48
L=JATM(I)#                             Get atom list pointer            PA64  49
DO J=1,3#                              Loop over fract coords           PA64  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA64  51
WX(J)=WX(J)+sg:(QX(L+J+2)+1.0)#                                         PA64  52
DO K=1,3; C(J,K)=C(J,K)+sg:(QX(L+J+2)+1.0)*sg:(QX(L+K+2)+1.0)#          PA64  53
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA64  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA64  55
invert:(C,CI)#                         Invert c store in ci             PA64  56
#                                                                       PA64  57
DO I=1,3#                              Least squares solution           PA64  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA64  59
Q(I)=0.0#                                                               PA64  60
DO J=1,3; Q(I)=Q(I)+CI(I,J)*WX(J)#                                      PA64  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA64  62
QSQ=0.0#                               P from q                         PA64  63
#DO I=1,3; DO J=1,3; QSQ=QSQ+Q(I)*RMET(I,J)*Q(J)#                       PA64  64
DO I=1,3;  QSQ=QSQ+Q(I)*Q(I)#          Pg55  95                         PA64  65
PQ(4)=1.0/SQRT(QSQ); TEMP=PQ(4)#                                        PA64  66
DO I=1,3#                                                               PA64  67
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA64  68
PQ(I)=TEMP*Q(I);  PQ(4)=PQ(4)-PQ(I)#                                    PA64  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA64  70
#                                                                       PA64  71
# GET PLANE EQUATION PQ() BY ITERATION                                  PA64  72
# ------------------------------------                                  PA64  73
#                                                                       PA64  74
DO IC=1,100#                           Loop over 1000 iterations        PA64  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA64  76
DO I=1,3; H(I)=0.0E+01#                                                 PA64  77
#DO I=1,3; DO J=1,3; H(I)=H(I)+PQ(J)*RMET(I,J)#                         PA64  78
DO I=1,3;  H(I)=H(I)+PQ(I)#                                             PA64  79
HMAX=ABS(H(1))#                                                         PA64  80
JE=1#                                                                   PA64  81
DO I=2,3#                                                               PA64  82
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA64  83
IF(ABS(H(I))<=HMAX) NEXT#                                               PA64  84
JE=I#                                                                   PA64  85
HMAX=ABS(H(I))#                                                         PA64  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA64  87
IF(JE==1)#                                                              PA64  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PA64  89
J1=2; J2=3#                                                             PA64  90
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PA64  91
ELSE IF(JE==2)#                                                         PA64  92
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PA64  93
J1=3; J2=1#                                                             PA64  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PA64  95
ELSE#                                                                   PA64  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PA64  97
J1=1; J2=2#                                                             PA64  98
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PA64  99
JJ(1)=J1; JJ(2)=J2; JJ(3)=4#                                            PA64 100
Q(1)=-H(J1)/H(JE); Q(2)=-H(J2)/H(JE)#                                   PA64 101
#                                                                       PA64 102
# ACCUMULATE LEAST SQUARES SUMS                                         PA64 103
# -----------------------------                                         PA64 104
#                                                                       PA64 105
DO I=1,3; YWD(I)=0.0#                  Zero least squares sums          PA64 106
DO I=1,3; DO J=1,3; C(I,J)=0.0#        Zero least squares sums          PA64 107
S=0.0; YY(3)=-1.0#                                                      PA64 108
DO N=1,NV#                             Loop over plane defining atoms   PA64 109
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PA64 110
L=JATM(N)#                                                              PA64 111
D=-PQ(4)#                              Pq(4) eqs dist of plane to ori   PA64 112
DO I=1,3 ; D=D+PQ(I)*sg:(QX(L+I+2))#   Calculate distance from plane    PA64 113
S=S+D**2#                              Sum distance**2                  PA64 114
YY(1)=sg:(QX(L+J1+2))+Q(1)*sg:(QX(L+JE+2))# Least squares sum           PA64 115
YY(2)=sg:(QX(L+J2+2))+Q(2)*sg:(QX(L+JE+2))# Least squares sum           PA64 116
DO I=1,3#                                                               PA64 117
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PA64 118
YWD(I)=YWD(I)+YY(I)*D#                 Least squares sums               PA64 119
DO J=1,3 ; C(I,J)=C(I,J)+YY(I)*YY(J)#  Least squares sums               PA64 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PA64 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PA64 122
#                                                                       PA64 123
invert:(C,CI)#                         Pg                               PA64 124
DO I=1,3#                                                               PA64 125
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PA64 126
DPJ(I)=0.0#                                                             PA64 127
DO J=1,3; DPJ(I)=DPJ(I)+CI(I,J)*YWD(J)#                                 PA64 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PA64 129
#                                                                       PA64 130
DO I=1,3; DP(JJ(I))=DPJ(I)#                                             PA64 131
DP(JE)=Q(1)*DPJ(1)+Q(2)*DPJ(2)#                                         PA64 132
DO I=1,4#                                                               PA64 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PA64 134
POLD(I)=PQ(I)#                                                          PA64 135
PQ(I)=PQ(I)-DP(I)#                                                      PA64 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PA64 137
PSQ=0.0#                                                                PA64 138
#DO I=1,3; DO J=1,3; PSQ=PSQ+PQ(I)*RMET(I,J)*PQ(J)#                     PA64 139
DO I=1,3;  PSQ=PSQ+PQ(I)*PQ(I)#                                         PA64 140
PLN=SQRT(PSQ)#                                                          PA64 141
DO I=1,3; PQ(I)=PQ(I)/PLN#                                              PA64 142
DO I=1,4; DP(I)=POLD(I)-PQ(I)#                                          PA64 143
IF(ABS(DP(4))<0.000001) BREAK#                                          PA64 144
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA64 145
#                                                                       PA64 146
#WRITE(6,3015) PQ(1),PQ(2),PQ(3),PQ(4)#                                 PA64 147
#3015 FORMAT('LSplane a b c d  ',1X,4F8.3)#                            
DO I=1,4 ; QX(MARKF+1+I)=PQ(I)#                                         PA64 149
#                                                                       PA64 150
RETURN#                                                                 PA64 151
END#                                                                    PA64 152
#                                                                       PA64 153
pmacro:([no:])#                                                         PA64 154
