PLTPAT write-up for Reference Manual
------------------------------------

PLTPAT: Plot Powder Pattern

Authors: Gert Kruger

PLTPAT generates powder diffraction patterns created by the powder pattern 
reader ADDPAT or the powder least squares program RIETVD. Powder pattern plot 
instructions are written to the PPP file for input to PLOT or PLOTX.

Description.
------------
Powder patterns can be plotted as any combination of the folowing:

Observed pattern
Calculated pattern
Background pattern
Difference pattern (Obs - Cal)
Reflection Markers (one row for each contributing phase)

An optional grid may be plotted.
The calculated pattern may be shifted up so as not to cover the observed
pattern.

The intensity may be plotted on a linear, a square root or a log scale.

Sections of the pattern may be displayed on the plot may selection of the
mininmum and maximum angles and intensities required.

The input and output file extension may be selected on the PLTPAT line.

FILE ASSIGNMENTS

Reads powder pattern data from powder bdf's PAT or POT
Writes powder pattern plot instructions to the PPP file


PLTPAT write-up for User Guide
------------------------------

PLTPAT: Plot a Powder Pattern

pltlim   select pattern plot limits
displa   select data and style to be displayed
scale    select intensity data scale type
xlabel   x axis label
ylabel   y axis label


PLTPAT   option                        code           Default

         input field extension         INP  ext       PP1
         output field extension        out  ext       PPP


pltlim   plot items followed by limiting values of display

         two theta angle minimum       tmin x
         two theta angle maximum       tmax x
         intensity minimum             ymin x
         intensity maximum             ymax x

displa   data options followed by color and line type options

         select observed pattern        OBS col ltp   OBS 1 1
         select calculated pattern      CAL               2 2
         select background pattern      BAC               3 2
         select difference pattern      DIF               4 1
         display reflection markers     HKL               5 2
         display grid lines             GRI               6 3
         shift calculated pattern up    SHI 

scale    intensity scale type
         
         linear scale                   LIN            LIN
         log scale                      LOG
         square root scale              SQR

xlabel   x axis label

         30 character angle axis label starting in col 8

ylabel   y axis label

         12 character intensity axis label starting in col 8



INPUT EXAMPLES
--------------

title  Philips data Obs only Sqrt scale
compid philip
master no
pltpat inp bpf out plt
pltlim tmin 40.0 tmax 48.0
displa grid 4
scale sqr
end
plotx vga    plt
params .95 .95
end
finish


title  MnO2 full house
compid mno2
master no
pltpat
pltlim 100 ymin -1000
displa obs cal bac dif 6 hkl shi grid 5
scale lin
xlabel        Grade 2 Theta      
ylabel Intensiteit
end
plotx vga    ppp
params .99 .99
end
finish

