/*---------------------------------------------------------------------
    @(#) siemcvt.h Novemeber 1995

    Header file for the siemcvt program.

    Author:  T.P. Vaalsta
    Date:    October 1995
---------------------------------------------------------------------*/
#ifndef SIEMCVT_H
#define SIEMCVT_H

#ifdef SIEMCVT_C

/* Local system headers */

#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <math.h>
#include <string.h>

#ifdef __unix
#include <sys/uio.h>
#else  /* MS DOS C version 6.00 */
#include <io.h>
#endif /* __unix */

/* Local Macros */

#define TRUE 1
#define FALSE 0

/* Loacl data structures */

static int nbtr = 248;               /* Number of bytes to read in a block */
static float *rn;                    /* A pointer to a floating point number */
static unsigned short *un;           /* A pointer to an unsigned integer */
static char cbuf[257],temp[257];     /* Buffers */
static char *progname = "siemcvt";
static int itype;

/* Function Prototypes */

static void extract(int fd, FILE *fout);        /* extract information */
static unsigned short chgbytes(unsigned short); /* swap bytes */
static float dgfloat(float r);                  /* translate to IEEE */
static int packit(unsigned short *val, char *buf);

#else  /* not SIEMCVT_C */

#endif /* SIEMCVT_C */
#endif /* SIEMCVT_H */
