<!DOCTYPE style-sheet PUBLIC "-//James Clark//DTD DSSSL Style Sheet//EN" [
<!ENTITY % html "IGNORE">
<![%html;[
<!ENTITY % print "INCLUDE">
<!ENTITY docbook.dsl PUBLIC "-//Norman Walsh//DOCUMENT DocBook HTML Stylesheet//EN" CDATA dsssl>
]]>
<!ENTITY % print "IGNORE">
<![%print;[
<!ENTITY docbook.dsl PUBLIC "-//Norman Walsh//DOCUMENT DocBook Print Stylesheet//EN" CDATA dsssl>
]]>
]>

<style-sheet>

<style-specification id="xtal-common" use="docbook">
<style-specification-body> 

(define %cals-cell-before-row-margin% 3pt)
(define %cals-cell-after-row-margin% 3pt)
(define %table-before-row-border% #f)
(define %table-after-row-border% #f)
(define %table-before-column-border% #f)
(define %table-after-column-border% #f)
(define %table-head-body-border% #f)
(define %table-cell-after-column-border% #f)
(define %table-cell-after-row-border% #f)

;; define some table styles 
(define (apply-table-width-style string)
   (case string
      ((normalize "progsubsum")   "75%" )
      ((normalize "progarg6col")  "90%" )
      ((normalize "progarg7col")  "95%" )
      ((normalize "subcomsimple") "95%" )
      ((normalize "subcomopt")    "90%" )
      ((normalize "archivedata")  "100%" )
      ((normalize "bt-calcat")    "90%" )
      (else "100%" )))
;;      (else ($table-width$) )))

(define %graphic-extensions%
  ;; graphic extensions allowed
  '("gif" "eps" "png" "jpg" "jpeg" "tif" "tiff" "epsf" ))

(element cmdsynopsis (process-children))

(define     %arg-choice-opt-open-str%  " ")
(define     %arg-choice-opt-close-str% " ")

(element (cmdsynopsis command)
  (make sequence
;;    (if (first-sibling? (current-node))
;;        (empty-sosofo)
;;        (make empty-element gi: "BR")
;;     )
    (next-match)
    (literal " ")))

(element (cmdsynopsis arg)
  (make sequence
    (next-match)
    (literal " ")))

</style-specification-body>
</style-specification>

<style-specification id="print" use="xtal-common">
<style-specification-body> 

;; ==============================
;; customize the print stylesheet
;; ==============================

(declare-characteristic preserve-sdata?
  ;; this is necessary because right now jadetex does not understand
  ;; symbolic entities, whereas things work well with numeric entities.
  "UNREGISTERED::James Clark//Characteristic::preserve-sdata?"
  #f)

(declare-characteristic heading-level
  "UNREGISTERED::James Clark//Characteristic::heading-level" 2)

(declare-flow-object-class formatting-instruction
  "UNREGISTERED::James Clark//Flow Object Class::formatting-instruction")

(define default-backend 'tex)
(define tex-backend #t)

(define %generate-partintro-on-titlepage% #f)

(define %graphic-default-extension% 
  "eps")

(define %generate-article-toc%
  ;; Should a Table of Contents be produced for Articles?
  #t)

(define (toc-depth nd)
  2)

(define %generate-article-titlepage-on-separate-page%
  ;; Should the article title page be on a separate page?
  #t)

(define %section-autolabel%
  ;; Are sections enumerated?
  #t)

(define %footnote-ulinks%
  ;; Generate footnotes for ULinks?
  #f)

(define %bop-footnotes%
  ;; Make "bottom-of-page" footnotes?
  #t)

(define %body-start-indent%
  ;; Default indent of body text
  0pi)

(define %para-indent-firstpara%
  ;; First line start-indent for the first paragraph
  0pt)

(define %para-indent%
  ;; First line start-indent for paragraphs (other than the first)
  0pt)

(define %block-start-indent%
  ;; Extra start-indent for block-elements
  0pt)

(define formal-object-float
  ;; Do formal objects float?
  #t)

(define %hyphenation%
  ;; Allow automatic hyphenation?
  #t)

(define %admon-graphics%
  ;; Use graphics in admonitions?
  #f)
(define %bf-size% 11pt)

(define %verbatim-size-factor% 0.8)

(define %paper-type%
  ;; Name of paper type
  ;; "A4"
  "A4")

;;(define %footnote-field-width%  20mm )

(define %page-width% 210mm)
(define %page-height% 297mm)

(define %left-margin% 20mm)
(define %right-margin% 20mm)
(define %top-margin% 20mm)
(define %bottom-margin% 15mm)

(define %header-margin% 10mm)
(define %footer-margin% 10mm)

(define %line-spacing-factor%  1.3)
(define %head-before-factor%  0.75)
(define %head-after-factor%   0.5)
(define %para-sep% (/ %bf-size% 2.0))
(define %block-sep% (* %para-sep% 1.0))


(define %visual-acuity% "normal")
(define %hsize-bump-factor% 1.1)
(define %default-quadding% 'justify)

(define %two-side% #t)

(define %cals-cell-before-row-margin% 1pt)
(define %cals-cell-after-row-margin% 1pt)
(define %cals-cell-before-column-margin% 1pt)
(define %cals-cell-after-column-margin% 1pt)


(element command ($bold-mono-seq$))

(define ($bold-mono-seq$ #!optional (sosofo (process-children)))
  (make sequence
    font-family-name: %mono-font-family%
    font-weight: 'bold
     font-size: (* (inherited-font-size) 0.9 )
    sosofo))

(define verbatim-style
  (style
      font-family-name: %mono-font-family%
      font-size:        (* (inherited-font-size)
                           (if %verbatim-size-factor%
                               %verbatim-size-factor%
                               1.0))
      font-weight:      'medium
      font-posture:     'upright
      line-spacing:     (* (* (* (inherited-font-size)
                              (if %verbatim-size-factor%
                                  %verbatim-size-factor%
                                  0.2))
                           %line-spacing-factor%) 0.8 )
      first-line-start-indent: 0pt
      lines: 'asis
      input-whitespace-treatment: 'preserve))

(define %arg-choice-opt-close-str% "" )
(define %arg-choice-opt-open-str% "" )
(define %arg-rep-def-str% "" )

(element arg
  (let ((choice (attribute-string (normalize "choice")))
        (rep    (attribute-string (normalize "rep")))
        (sepchar (if (inherited-attribute-string (normalize "sepchar"))
                     (inherited-attribute-string (normalize "sepchar"))
                     " "))
        (default-arg (if (and (attribute-string (normalize "role"))
                     (equal? (attribute-string (normalize "role")) "default"))
                      1  #f ) ) )
      (make sequence
;;        font-posture: (if default-arg 'oblique   'upright )
        font-family-name: %mono-font-family%
        font-weight: 'bold 
        font-size: (* (inherited-font-size) 0.8 )
         (if default-arg
            (make formatting-instruction  data: "\\underline{" )
            (empty-sosofo) )
;;        (if (equal? (absolute-child-number (current-node)) 1)
;;            (empty-sosofo)
;;            (literal sepchar))
        (cond
         ((equal? choice (normalize "plain"))
          (literal %arg-choice-plain-open-str%))
         ((equal? choice (normalize "req")) (literal %arg-choice-req-open-str%))
         ((equal? choice (normalize "opt")) (literal %arg-choice-opt-open-str%))
         (else (literal %arg-choice-def-open-str%))
          )
        (process-children-trim)
        (cond
         ((equal? rep (normalize "repeat")) (literal %arg-rep-repeat-str%))
         ((equal? rep (normalize "norepeat")) (literal %arg-rep-norepeat-str%))
         (else (literal %arg-rep-def-str%))
          )
        (cond
         ((equal? choice (normalize "plain")) (literal %arg-choice-plain-close-str%))
         ((equal? choice (normalize "req")) (literal %arg-choice-req-close-str%))
         ((equal? choice (normalize "opt")) (literal %arg-choice-opt-close-str%))
         (else (literal %arg-choice-def-close-str%))
       )
         (if default-arg
            (make formatting-instruction  data: "}" )
            (empty-sosofo) )
      )))


(element tgroup
  (let* ((frame-attribute (if (inherited-attribute-string (normalize "frame"))
			     (inherited-attribute-string (normalize "frame"))
			     ($cals-frame-default$)))
        (wrapper   (parent (current-node)))
        (tabstyle  (attribute-string (normalize "tabstyle") wrapper))
        (pgwide    (attribute-string (normalize "pgwide") wrapper)) ) 
    (make table
      lines:  'wrap
;;      table-width:  (if (equal? pgwide "1") '"100%"
;;                         (apply-table-width-style tabstyle) )
      ;; These values are used for the outer edges well, the top, bottom
      ;; and left edges for sure; I think the right edge actually comes
      ;; from the cells in the last column
      before-row-border:  (if (cond
	       ((equal? frame-attribute (normalize "all")) #t)
	       ((equal? frame-attribute (normalize "sides")) #f)
	       ((equal? frame-attribute (normalize "top")) #t)
	       ((equal? frame-attribute (normalize "bottom")) #f)
	       ((equal? frame-attribute (normalize "topbot")) #t)
	       ((equal? frame-attribute (normalize "none")) #f)
	       (else #f))
	      calc-table-before-row-border #f)
      after-row-border:   (if (cond
	       ((equal? frame-attribute (normalize "all")) #t)
	       ((equal? frame-attribute (normalize "sides")) #f)
	       ((equal? frame-attribute (normalize "top")) #f)
	       ((equal? frame-attribute (normalize "bottom")) #t)
	       ((equal? frame-attribute (normalize "topbot")) #t)
	       ((equal? frame-attribute (normalize "none")) #f)
	       (else #f))
	      calc-table-after-row-border #f)
      before-column-border: (if (cond
		 ((equal? frame-attribute (normalize "all")) #t)
		 ((equal? frame-attribute (normalize "sides")) #t)
		 ((equal? frame-attribute (normalize "top")) #f)
		 ((equal? frame-attribute (normalize "bottom")) #f)
		 ((equal? frame-attribute (normalize "topbot")) #f)
		 ((equal? frame-attribute (normalize "none")) #f)
		 (else #f))
		calc-table-before-column-border #f)
      after-column-border:  (if (cond
		 ((equal? frame-attribute (normalize "all")) #t)
		 ((equal? frame-attribute (normalize "sides")) #t)
		 ((equal? frame-attribute (normalize "top")) #f)
		 ((equal? frame-attribute (normalize "bottom")) #f)
		 ((equal? frame-attribute (normalize "topbot")) #f)
		 ((equal? frame-attribute (normalize "none")) #f)
		 (else #f))
		calc-table-after-column-border #f)
      display-alignment: %cals-display-align%
      (make table-part
	content-map: '((thead header)
		       (tbody #f)
		       (tfoot footer))
	($process-colspecs$ (current-node))
	(process-children)
	(make-table-endnotes)))) )


(define ($process-cell$ entry preventry row overhang)
  (let* ((colnum    (cell-column-number entry overhang))
	 (lastcellcolumn (if (node-list-empty? preventry)
			     0
			     (- (+ (cell-column-number preventry overhang)
				   (hspan preventry))
				1)))
	 (lastcolnum (if (> lastcellcolumn 0)
			 (overhang-skip overhang lastcellcolumn)
			 0))
	 (font-name (if (have-ancestor? (normalize "thead") entry)
			%title-font-family%
			%body-font-family%))
	 (weight    (if (have-ancestor? (normalize "thead") entry)
			'bold
			'medium))
	 (align     (cell-align entry colnum)))

    (make sequence
      ;; This is a little bit complicated.  We want to output empty cells
      ;; to skip over missing data.  We start count at the column number
      ;; arrived at by adding 1 to the column number of the previous entry
      ;; and skipping over any MOREROWS overhanging entrys.  Then for each
      ;; iteration, we add 1 and skip over any overhanging entrys.
      (let loop ((count (overhang-skip overhang (+ lastcolnum 1))))
	(if (>= count colnum)
	    (empty-sosofo)
	    (make sequence
	      ($process-empty-cell$ count row)
	      (loop (overhang-skip overhang (+ count 1))))))

      ;; Now we've output empty cells for any missing entries, so we 
      ;; are ready to output the cell for this entry...
      (make table-cell 
	column-number: colnum
	n-columns-spanned: (hspan entry)
	n-rows-spanned: (vspan entry)

	cell-row-alignment: (cell-valign entry colnum)

	cell-after-column-border: (if (cell-colsep entry colnum)
				      calc-table-cell-after-column-border
				      #f)

	cell-after-row-border: (if (cell-rowsep entry colnum)
				   (if (last-sibling? (parent entry))
				       calc-table-head-body-border
				       calc-table-cell-after-row-border)
				   #f)

	cell-before-row-margin: %cals-cell-before-row-margin%
	cell-after-row-margin: %cals-cell-after-row-margin%
	cell-before-column-margin: %cals-cell-before-column-margin%
	cell-after-column-margin: %cals-cell-after-column-margin%

	;; If there is some additional indentation (because we're in a list,
	;; for example) make sure that gets passed along, but don't add
	;; the normal body-start-indent.
	start-indent: (+ (- (inherited-start-indent) %body-start-indent%)
			 %cals-cell-content-start-indent%)
	end-indent: %cals-cell-content-end-indent%
	(if (equal? (gi entry) (normalize "entrytbl"))
	    (make paragraph 
	      (literal "ENTRYTBL not supported."))
	    (make paragraph
	      font-family-name: font-name
	      font-weight: weight
	      quadding: align
	      lines: 'wrap
	      (process-node-list (children entry))))))))

(define (make-table-endnote-header)
  (make paragraph
    font-family-name: %body-font-family%
    font-weight: 'medium
    font-size:  (* %bf-size% 0.8 )
    line-spacing:    (* (* (* %bf-size% 0.8)
                           %line-spacing-factor%) 0.6 )
    start-indent: 0pt
    quadding: 'start
    (literal (gentext-table-endnotes))))


(mode table-footnote-mode
  (element footnote
    (make display-group
      font-family-name: %body-font-family%
      font-weight: 'medium
      font-size:  (* %bf-size% 0.8 )
      line-spacing:    (* (* (* %bf-size% 0.8)
                           %line-spacing-factor%) 0.6 )
;;      min-post-line-spacing: 0
      start-indent: 0pt
      quadding: 'start
      (process-children)))

  (element (footnote para)
    (let ((fnnum (table-footnote-number (parent (current-node)))))
      (if (= (child-number) 1)
          (make paragraph
;;            line-spacing:    (* (* (* %bf-size% 0.8)
 ;;                          %line-spacing-factor%) 0.6 )
            start-indent: %footnote-field-width%
            first-line-start-indent: (- %footnote-field-width%)
            (make line-field
              field-width: %footnote-field-width%
              (literal fnnum
                       (gentext-label-title-sep (normalize "footnote"))))
            (process-children-trim))
          (make paragraph
;;            line-spacing:    (* (* (* %bf-size% 0.8)
;;                           %line-spacing-factor%) 0.6 )
            start-indent: %footnote-field-width%
            (process-children-trim))))))





(element ulink
  (let ((type (attribute-string (normalize "type"))))
    (if (equal? type "htmlonly")
      (sosofo-append
        (process-children)                ;; Wrote the text
      )
      (sosofo-append
        (make formatting-instruction  data: "\\href{" )
        (make formatting-instruction  
            data:  (attribute-string (normalize "url")) )
;;        (literal (attribute-string (normalize "url")) )
        (make formatting-instruction  data: "}{" )
        (process-children) ;; Wrote the text with its format (HTML anchor) 
        (make formatting-instruction  data: "}" ) )
    )
  )
)


</style-specification-body>
</style-specification>


<!--
;; ===================================================
;; customize the html stylesheet; borrowed from Cygnus
;; at http://sourceware.cygnus.com/ (cygnus-both.dsl)
;; ===================================================
-->

<style-specification id="html" use="xtal-common">
<style-specification-body> 

(declare-characteristic preserve-sdata?
  ;; this is necessary because right now jadetex does not understand
  ;; symbolic entities, whereas things work well with numeric entities.
  "UNREGISTERED::James Clark//Characteristic::preserve-sdata?"
  #f)

(define %generate-legalnotice-link%
  ;; put the legal notice in a separate file
  #t)

(define %admon-graphics-path%
  ;; use graphics in admonitions, set their
  "../images/")

(define %admon-graphics%
  #t)

(define %funcsynopsis-decoration%
  ;; make funcsynopsis look pretty
  #t)

(define %html-ext%
  ;; when producing HTML files, use this extension
  ".html")

(define %generate-book-toc%
  ;; Should a Table of Contents be produced for books?
  #t)

(define %generate-article-toc% 
  ;; Should a Table of Contents be produced for articles?
  #t)

(define %generate-part-toc%
  ;; Should a Table of Contents be produced for parts?
  #t)

(define %generate-book-titlepage%
  ;; produce a title page for books
  #t)

(define %generate-article-titlepage%
  ;; produce a title page for articles
  #t)

(define (chunk-skip-first-element-list)
  ;; forces the Table of Contents on separate page
  '())

(define (list-element-list)
  ;; fixes bug in Table of Contents generation
  '())

(define %root-filename%
  ;; The filename of the root HTML document (e.g, "index").
  "index")

(define %shade-verbatim%
  ;; verbatim sections will be shaded if t(rue)
  #t)

(define %use-id-as-filename%
  ;; Use ID attributes as name for component HTML files?
  #t)


(define %graphic-default-extension% 
  "gif")

(define %section-autolabel%
  ;; For enumerated sections (1.1, 1.1.1, 1.2, etc.)
  #t)

(define (toc-depth nd)
  ;; more depth (2 levels) to toc; instead of flat hierarchy
  ;; 2)
  1)


(element arg
  (let ((choice (attribute-string (normalize "choice")))
        (rep    (attribute-string (normalize "rep")))
        (sepchar (if (inherited-attribute-string (normalize "sepchar"))
                     (inherited-attribute-string (normalize "sepchar"))
                     " ")))
    (make sequence
      (if (equal? (absolute-child-number (current-node)) 1)
          (empty-sosofo)
          (literal sepchar))
      (cond
       ((equal? choice (normalize "plain"))
        (literal %arg-choice-plain-open-str%))
       ((equal? choice (normalize "req")) (literal %arg-choice-req-open-str%))
       ((equal? choice (normalize "opt")) (literal %arg-choice-opt-open-str%))
       (else (literal %arg-choice-def-open-str%)))

      (if (and (attribute-string (normalize "role"))
               (equal? (attribute-string (normalize "role")) "default"))
          (make element gi: "FONT" attributes: '(("COLOR" "RED"))
              (make element gi: "STRONG" (process-children)))
          (make element gi: "STRONG" (process-children)))

      (cond
       ((equal? rep (normalize "repeat")) (literal %arg-rep-repeat-str%))
       ((equal? rep (normalize "norepeat")) (literal %arg-rep-norepeat-str%))
       (else (literal %arg-rep-def-str%)))
      (cond
       ((equal? choice (normalize "plain")) (literal %arg-choice-plain-close-str%))
       ((equal? choice (normalize "req")) (literal %arg-choice-req-close-str%))
       ((equal? choice (normalize "opt")) (literal %arg-choice-opt-close-str%))
       (else (literal %arg-choice-def-close-str%))))))




(define (book-titlepage-recto-elements)
  ;; elements on a book's titlepage
  ;; note: added revhistory to the default list
  (list (normalize "title")
        (normalize "subtitle")
        (normalize "graphic")
        (normalize "mediaobject")
        (normalize "corpauthor")
        (normalize "authorgroup")
        (normalize "author")
        (normalize "editor")
        (normalize "copyright")
        (normalize "revhistory")
        (normalize "abstract")
        (normalize "legalnotice")))

(define (article-titlepage-recto-elements)
  ;; elements on an article's titlepage
  ;; note: added othercredit to the default list
  (list (normalize "title")
        (normalize "subtitle")
        (normalize "authorgroup")
        (normalize "author")
        (normalize "othercredit")
        (normalize "releaseinfo")
        (normalize "copyright")
        (normalize "pubdate")
        (normalize "revhistory")
        (normalize "abstract")))

(mode article-titlepage-recto-mode

 (element contrib
  ;; print out with othercredit information; for translators, etc.
  (make sequence
    (make element gi: "SPAN"
          attributes: (list (list "CLASS" (gi)))
          (process-children))))

 (element othercredit
  ;; print out othercredit information; for translators, etc.
  (let ((author-name  (author-string))
        (author-contrib (select-elements (children (current-node))
                                          (normalize "contrib"))))
    (make element gi: "P"
         attributes: (list (list "CLASS" (gi)))
         (make element gi: "B"  
              (literal author-name)
              (literal " - "))
         (process-node-list author-contrib))))
)

(define (article-title nd)
  (let* ((artchild  (children nd))
         (artheader (select-elements artchild (normalize "artheader")))
         (artinfo   (select-elements artchild (normalize "articleinfo")))
         (ahdr (if (node-list-empty? artheader)
                   artinfo
                   artheader))
         (ahtitles  (select-elements (children ahdr)
                                     (normalize "title")))
         (artitles  (select-elements artchild (normalize "title")))
         (titles    (if (node-list-empty? artitles)
                        ahtitles
                        artitles)))
    (if (node-list-empty? titles)
        ""
        (node-list-first titles))))


;; Redefinition of $verbatim-display$
;; Origin: dbverb.dsl
;; Different foreground and background colors for verbatim elements
;; Author: Philippe Martin (feloy@free.fr) 2001-04-07

(define ($verbatim-display$ indent line-numbers?)
  (let ((verbatim-element (gi))
        (content (make element gi: "PRE"
                       attributes: (list
                                    (list "CLASS" (gi)))
                       (if (or indent line-numbers?)
                           ($verbatim-line-by-line$ indent line-numbers?)
                           (process-children)))))
    (if %shade-verbatim%
        (make element gi: "TABLE"
              attributes: (shade-verbatim-attr-element verbatim-element)
              (make element gi: "TR"
                    (make element gi: "TD"
                          (make element gi: "FONT" 
                                attributes: (list
                                             (list "COLOR" (car (shade-verbatim-element-colors
                                                                 verbatim-element))))
                                content))))
        content)))

;;
;; Customize this function
;; to change the foreground and background colors
;; of the different verbatim elements
;; Return (list "foreground color" "background color")
;;
(define (shade-verbatim-element-colors element)
  (case element
    (("SYNOPSIS") (list "#000000" "#6495ED"))
    ;; ...
    ;; Add your verbatim elements here
    ;; ...
    (else (list "#000000" "#E0E0E0"))))

(define (shade-verbatim-attr-element element)
  (list
   (list "BORDER" 
	(cond
		((equal? element (normalize "SCREEN")) "1")
		(else "0")))
   (list "BGCOLOR" (car (cdr (shade-verbatim-element-colors element))))
   (list "WIDTH" ($table-width$))))

;; End of $verbatim-display$ redefinition


(element tgroup
  (let* ((wrapper   (parent (current-node)))
         (frameattr (attribute-string (normalize "frame") wrapper))
         (pgwide    (attribute-string (normalize "pgwide") wrapper))
         (tabstyle  (attribute-string (normalize "tabstyle") wrapper))
         (footnotes (select-elements (descendants (current-node))
                                     (normalize "footnote")))
         (border (if (equal? frameattr (normalize "none"))
                     '(("BORDER" "0"))
                     '(("BORDER" "0"))))
         (head (select-elements (children (current-node)) (normalize "thead")))
         (body (select-elements (children (current-node)) (normalize "tbody")))
         (feet (select-elements (children (current-node)) (normalize "tfoot"))))
    (make element gi: "TABLE"
          attributes: (append
                       border
                       (if (equal? pgwide "1") 
                           (list (list "WIDTH"  ($table-width$)))
                           (list (list "WIDTH" 
                                (apply-table-width-style tabstyle) ) ) )
                       (if %cals-table-class%
                           (list (list "CLASS" %cals-table-class%))
                           '()))
          (process-node-list head)
          (process-node-list body)
          (process-node-list feet)
          (make-table-endnotes))))


(define %footnote-size-factor% "-2" )

(define (make-table-endnotes)
  (let* ((footnotes (select-elements (descendants (current-node))
                                     (normalize "footnote")))
         (tgroup (ancestor-member (current-node) (list (normalize "tgroup"))))
         (cols   (string->number (attribute-string (normalize "cols") tgroup))))
    (if (node-list-empty? footnotes)
        (empty-sosofo)
        (make element gi: "TR"
          (make element gi: "TD"
                attributes: (list
                             (list "COLSPAN" (number->string cols)))
                (make element gi: "FONT"
                    attributes: (list
                              (list "SIZE" %footnote-size-factor%))
                   (make-table-endnote-header)
                   (with-mode table-footnote-mode
                    (process-node-list footnotes))))))) )





;; from common/dbcommon.dsl

(define (element-title-nosublink-sosofo #!optional (nd (current-node)))
  (if (node-list-empty? nd)
      (empty-sosofo)
      (cond
       ;; Use a seperately defined assoc list?
       ((equal? (gi nd) (normalize "appendix")) (appendix-title-sosofo nd ))
       ((equal? (gi nd) (normalize "article")) (article-title-sosofo nd))
       ((equal? (gi nd) (normalize "bibliography")) (bibliography-title-sosofo nd))
       ((equal? (gi nd) (normalize "book")) (book-title-sosofo nd))
       ((equal? (gi nd) (normalize "chapter")) (chapter-title-sosofo nd))
       ((equal? (gi nd) (normalize "dedication")) (dedication-title-sosofo nd))
       ((equal? (gi nd) (normalize "glossary")) (glossary-title-sosofo nd))
       ((equal? (gi nd) (normalize "index")) (index-title-sosofo nd))
       ((equal? (gi nd) (normalize "colophon")) (colophon-title-sosofo nd))
       ((equal? (gi nd) (normalize "setindex")) (index-title-sosofo nd))
       ((equal? (gi nd) (normalize "part")) (part-title-sosofo nd))
       ((equal? (gi nd) (normalize "preface")) (preface-title-sosofo nd))
       ((equal? (gi nd) (normalize "refentry")) (refentry-title-sosofo nd))
       ((equal? (gi nd) (normalize "reference")) (reference-title-sosofo nd))
       ((equal? (gi nd) (normalize "refsect1")) (refsection-title-sosofo nd))
       ((equal? (gi nd) (normalize "refsect2")) (refsection-title-sosofo nd))
       ((equal? (gi nd) (normalize "refsect3")) (refsection-title-sosofo nd))
       ((equal? (gi nd) (normalize "refsynopsisdiv")) (refsynopsisdiv-title-sosofo nd))
       ((equal? (gi nd) (normalize "sect1")) (section-title-sosofo nd 'supress))
       ((equal? (gi nd) (normalize "sect2")) (section-title-sosofo nd 'supress))
       ((equal? (gi nd) (normalize "sect3")) (section-title-sosofo nd 'supress))       ((equal? (gi nd) (normalize "sect4")) (section-title-sosofo nd 'supress))
       ((equal? (gi nd) (normalize "sect5")) (section-title-sosofo nd 'supress))
       ((equal? (gi nd) (normalize "set")) (set-title-sosofo nd))
       (else (block-title-sosofo nd)))))


(define (section-title-sosofo nd #!optional supress-link )
  (let ((title (section-title nd)))
    (if (string? title)
        (empty-sosofo)
        (if supress-link
            (with-mode title-nosublink-sosofo-mode
               (process-node-list title))
            (with-mode title-sosofo-mode
               (process-node-list title))))))


(mode title-nosublink-sosofo-mode
  (element title
    (process-children-trim))

  (element citetitle
    (process-children-trim))

  (element xref
    (xref-supress-link))

  (element refname
    (process-children-trim))

  (element refentrytitle
    (process-children-trim)))





;; from html/dbautoc.dsl

(define (toc-entry tocentry)
  (make element gi: "DT"
        (make sequence
          (if (equal? (element-label tocentry) "")
              (empty-sosofo)
              (make sequence
                (literal (element-label tocentry))
                (literal (gentext-label-title-sep
                          (gi tocentry)))))

          ;; If the tocentry isn't in its own
          ;; chunk, don't make a link...
          (if (and #f (not (chunk? tocentry)))
              (element-title-sosofo tocentry)
              (make element gi: "A"
                    attributes: (list
                                 (list "HREF"
                                       (href-to tocentry)))
                    (element-title-nosublink-sosofo tocentry)))

          ;; Maybe annotate...
          (if (and %annotate-toc%
                   (equal? (gi tocentry) (normalize "refentry")))
              (make sequence
                (dingbat-sosofo "nbsp");
                (dingbat-sosofo "em-dash");
                (dingbat-sosofo "nbsp");
                (toc-annotation tocentry))
              (empty-sosofo)))))


;; /html/dblink.dsl

(element xref
  (let* ((endterm   (attribute-string (normalize "endterm")))
	 (linkend   (attribute-string (normalize "linkend")))
	 (target    (element-with-id linkend))
	 (xreflabel (if (node-list-empty? target)
			#f
			(attribute-string (normalize "xreflabel") target))))
    (if (node-list-empty? target)
	(error (string-append "XRef LinkEnd to missing ID '" linkend "'"))
	(make element gi: "A"
	      attributes: (list
			   (list "HREF" (href-to target)))
	      (if xreflabel
		  (literal xreflabel)
		  (xref-endterm target endterm))) )))

(define (xref-supress-link)
  (let* ((endterm   (attribute-string (normalize "endterm")))
	 (linkend   (attribute-string (normalize "linkend")))
	 (target    (element-with-id linkend))
	 (xreflabel (if (node-list-empty? target)
			#f
			(attribute-string (normalize "xreflabel") target))))
    (if (node-list-empty? target)
	(error (string-append "XRef LinkEnd to missing ID '" linkend "'"))
	(if xreflabel
	  (literal xreflabel)
	  (xref-endterm target endterm)) )))
     


(define (xref-endterm target endterm)
   (if endterm
      (if (node-list-empty? (element-with-id endterm))
	  (error (string-append
			  "XRef EndTerm to missing ID '" 
			  endterm "'"))
	  (with-mode xref-endterm-mode
		    (process-node-list (element-with-id endterm))))
      (cond ((or (equal? (gi target) (normalize "biblioentry"))
	    (equal? (gi target) (normalize "bibliomixed")))
		;; xref to the bibliography is a special case
		(xref-biblioentry target))
       ((equal? (gi target) (normalize "co"))
		;; callouts are a special case
		($callout-mark$ target #f))
       ((equal? (gi target) (normalize "listitem"))
		;; listitems are a special case
		(if (equal? (gi (parent target)) (normalize "orderedlist"))
		    (literal (orderedlist-listitem-label-recursive target))
		    (error (string-append "XRef to LISTITEM only supported in ORDEREDLISTs"))))
       ((equal? (gi target) (normalize "varlistentry"))
		(xref-varlistentry target))
       ((equal? (gi target) (normalize "question"))
		;; questions and answers are (yet another) special case
		(make sequence
		  (literal (gentext-element-name target))
		  (literal (gentext-label-title-sep target))
		  (literal (question-answer-label target))))
       ((equal? (gi target) (normalize "answer"))
		;; questions and answers are (yet another) special case
		(make sequence
		  (literal (gentext-element-name target))
		  (literal (gentext-label-title-sep target))
		  (literal (question-answer-label target))))
       ((equal? (gi target) (normalize "refentry"))
		;; so are refentrys
		(xref-refentry target))
       ((equal? (gi target) (normalize "refnamediv"))
		;; and refnamedivs
		(xref-refnamediv target))
       ((equal? (gi target) (normalize "glossentry"))
		;; as are glossentrys
		(xref-glossentry target))
       ((equal? (gi target) (normalize "author"))
		;; and authors
		(xref-author target))
       ((equal? (gi target) (normalize "authorgroup"))
		;; and authorgroups
			(xref-authorgroup target))
; this doesn't really work very well yet
;      ((equal? (gi target) (normalize "substeps"))
;		;; and substeps
;		(xref-substeps target))
       (else 
		(xref-general target))))  )



</style-specification-body>
</style-specification>

<external-specification id="docbook" document="docbook.dsl">

</style-sheet>

