systemheader:(RFU   )#                                                  RFU    1
####################################################################### RFU    2
#                                                                     # RFU    3
#                           *** RFU ***                               # RFU    4
#                                                                     # RFU    5
#         APPLY UPDATES TO A SEQUENCE OF RATMAC PROGRAMS.             # RFU    6
#                                                                     # RFU    7
####################################################################### RFU    8
#                                                                       RFU    9
## >>> Installers note that the device numbers and filenames are often  RFU   10
##     compiler dependent. According to how the Xtal source file        RFU   11
##     are named and referenced, the filename prefixes and extensions   RFU   12
##     can differ from site to site. Three macros (dev:, exti:, exto:)  RFU   13
##     are supplied to handle these local references globally.          RFU   14
##     The default definitions are for a typical Unix environment where RFU   15
##     the input ratmac source filename has the extension '.r' and the  RFU   16
##     updated output source filename has the extension '.new'. For an  RFU   17
##     IBM3090 the filename macros will need to changed to:-            RFU   18
##     macro:(dev:,'P'//)#                                              RFU   19
##     macro:(exti:,'R')#                                               RFU   20
##     macro:(exto:,'N')#                                               RFU   21
#                                                                       RFU   22
#                                                                       RFU   23
macro:(head:,' RFU --- Ratmac Updater (3.2/Oct92)')#                    RFU   24
#                                                                       RFU   25
macro:(ufile:,1)#                      Update file with corrections     RFU   26
macro:(ifile:,2)#                      Input ratmac source file         RFU   27
macro:(ofile:,3)#                      Output ratmac source file        RFU   28
macro:(lfile:,6)#                      List device for errors           RFU   29
#                                                                       RFU   30
macro:(dev:,)#                         Prefix to ip and op filenames    RFU   31
macro:(exti:,'.r')#                    Extension ip source filename     RFU   32
macro:(exto:,'.new')#                  Extension op source filename     RFU   33
#                                                                       RFU   34
macro:(openu:,OPEN(ufile:,#            Open update file                 RFU   35
STATUS='OLD',FILE='UPDATE');REWIND(ufile:))#                            RFU   36
macro:(openi:,OPEN(ifile:,#            Open input file                  RFU   37
STATUS='OLD',FILE=$1);REWIND(ifile:))#                                  RFU   38
macro:(openo:,OPEN(ofile:,#            Open output file                 RFU   39
STATUS='UNKNOWN',FILE=$1);REWIND(ofile:))#                              RFU   40
macro:(close:,CLOSE($1))#              Close file                       RFU   41
macro:(inquir:,INQUIRE(FILE=$1,EXIST=$2))# Inquire file exists          RFU   42
macro:(openl:,)#                       Open list file or device         RFU   43
macro:(closel:,)#                      Close list file or device        RFU   44
#                                                                       RFU   45
#                                                                       RFU   46
macro:(read:,READ($1,'(A)',END=$2)$3)# Read a line                      RFU   47
macro:(write:,WRITE($1,'(A)')$2)#      Write a line                     RFU   48
macro:(error:,CALL ERROR($1,UCNT,ICNT,$# Error exit                     RFU   49
                         OCNT,PCODE,C1,C2))#                            RFU   50
#                                                                       RFU   51
systemheader:(UPDA)#                                                    UPDA   1
####################################################################### UPDA   2
#                                                                     # UPDA   3
#                               UPDATE                                # UPDA   4
#                                                                     # UPDA   5
####################################################################### UPDA   6
PROGRAM UPDATE#                                                         UPDA   7
#     G.S.D. KING FEB 1987  AND  S.R.HALL MAY 1987                      UPDA   8
CHARACTER*80 BUF(2),IBUF#                                               UPDA   9
CHARACTER CHR,CODE*2,PCODE*6,UCODE*5,TAG*8,QCODE*6,CCODE*5#             UPDA  10
CHARACTER C1*16,C2*16#                                                  UPDA  11
INTEGER ICNT,OCNT,UCNT,IP,CHEK,CASE#                                    UPDA  12
INTEGER STATUS,NB,MB,I,FIRST#                                           UPDA  13
LOGICAL FILEXS#                                                         UPDA  14
#                                                                       UPDA  15
8 FORMAT(head:/)#                                                       UPDA  16
9 FORMAT(1X,A6,I4,' updates',I8,' lines ',A16,I6,' lines ',A16)#        UPDA  17
10 FORMAT(1X,A6,' No input source file of name ',A16)#                  UPDA  18
12 FORMAT(1X,A6,' *Warning* overwriting existing file  ',A16)#          UPDA  19
#                                                                       UPDA  20
#   INITIALIZE VARIABLES                                                UPDA  21
#   --------------------                                                UPDA  22
#                                                                       UPDA  23
openu:;   openl:#                      Open update and list files       UPDA  24
FILEXS=.TRUE.#                         Ok for ip source file            UPDA  25
WRITE(lfile:,8)#                       Write out program header         UPDA  26
NB=1;  MB=2;  STATUS=0#                Set double buffer pointers       UPDA  27
CHEK=no:#                              Default check flag is off        UPDA  28
CASE=ICHAR('a')-ICHAR('A')#            Set case difference number       UPDA  29
ICNT=0; OCNT=0; UCNT=0#                Reset line counters              UPDA  30
PCODE=' '; C1=' ';C2=' '#              Reset program codes              UPDA  31
read:(ufile:,250,BUF(MB))#             Read line from update file       UPDA  32
#                                                                       UPDA  33
#    ENTER UPDATE LINES                                                 UPDA  34
#    ==================                                                 UPDA  35
#                                                                       UPDA  36
REPEAT#                                Loop over update lines           UPDA  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  UPDA  38
NB=3-NB;   MB=3-MB#                    Reset buffer pointers            UPDA  39
read:(ufile:,250,BUF(MB))#             Read line from update file       UPDA  40
CODE=BUF(NB)(1^2)#                     Store control characters         UPDA  41
#                                                                       UPDA  42
#   TEST FOR CONTROL LINES                                              UPDA  43
#   ----------------------                                              UPDA  44
#                                                                       UPDA  45
IF(CODE=='**')#                        Test for control line code       UPDA  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  UPDA  47
CHR=BUF(NB)(4^4)#                      Store chr1 of control name       UPDA  48
#                                                                       UPDA  49
IF(CHR=='P')#                          ********** program ***********   UPDA  50
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  UPDA  51
IF(STATUS==3)#                         Test if program set already      UPDA  52
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  UPDA  53
WRITE(lfile:,9) PCODE,UCNT,ICNT,C1,OCNT,C2# Print program status        UPDA  54
close:(ifile:); close:(ofile:)#        Close old & new source files     UPDA  55
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  UPDA  56
PCODE(1^6)=BUF(NB)(12^17)#             Store program code               UPDA  57
FOR(IP=6;IP>0;IP=IP-1) IF(PCODE(IP^IP)!=' ') BREAK# First non-blank     UPDA  58
IF(IP==0) error:(8)#                   Program name missing             UPDA  59
DO I=1,IP#                             Loop over program name           UPDA  60
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  UPDA  61
IF(PCODE(I^I)>='A'&PCODE(I^I)<='Z')#   If character is upper case       UPDA  62
QCODE(I^I)=CHAR(ICHAR(PCODE(I^I))+CASE)# Convert to lower case          UPDA  63
ELSE QCODE(I^I)=PCODE(I^I)#            Do not convert numbers           UPDA  64
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  UPDA  65
C2=dev: QCODE(1^IP)//exto:#            Output source filename           UPDA  66
inquir:(C2,FILEXS)#                    Find out if output source file   UPDA  67
IF(FILEXS) WRITE(lfile:,12) PCODE,C2#  Warn user that 'new' file ther   UPDA  68
C1=dev: QCODE(1^IP)//exti:#            Input source filename            UPDA  69
inquir:(C1,FILEXS)#                    Find out if input source file    UPDA  70
IF(FILEXS)#                            Input source there - use it      UPDA  71
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  UPDA  72
openi:(C1)#                            Open ip source file              UPDA  73
read:(ifile:,150,IBUF); ICNT=ICNT+1#   Read the first line              UPDA  74
openo:(C2)#                            Open op source file              UPDA  75
write:(ofile:,IBUF);   OCNT=OCNT+1#    Output source line               UPDA  76
IBUF='##   version: '//UCODE#          Insert update header             UPDA  77
write:(ofile:,IBUF);   OCNT=OCNT+1#    Output source line               UPDA  78
IF(STATUS==0) STATUS=1#                Reset to program only            UPDA  79
IF(STATUS==2) STATUS=3#                Reset to program+update          UPDA  80
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  UPDA  81
ELSE#                                  No ip source file - skip updat   UPDA  82
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  UPDA  83
WRITE(lfile:,10) PCODE,C1#             Say there is no source files     UPDA  84
IF(STATUS==1) STATUS=0#                Reset to no program or update    UPDA  85
IF(STATUS==3) STATUS=2#                Reset to update only             UPDA  86
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  UPDA  87
150 CONTINUE#                          Dummy exit for eof               UPDA  88
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  UPDA  89
#                                                                       UPDA  90
ELSE IF(CHR=='U')#                     ********** update ************   UPDA  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  UPDA  92
UCODE=BUF(NB)(11^15)#                  Store 5-letter update code       UPDA  93
IF(UCODE=='     ') error:(6)#          Line id cannot be blank          UPDA  94
IF(STATUS==0) STATUS=2#                Reset to update only             UPDA  95
IF(STATUS==1) STATUS=3#                Reset to update+program          UPDA  96
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  UPDA  97
#                                                                       UPDA  98
ELSE IF(CHR=='C')#                     ********** checkx ************   UPDA  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  UPDA 100
CCODE=BUF(NB)(11^15)#                  Store 5-letter update code       UPDA 101
IF(CCODE=='     ') error:(6)#          Line id cannot be blank          UPDA 102
CHEK=yes:#                             Switch on the current flag       UPDA 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  UPDA 104
#                                                                       UPDA 105
ELSE IF(BUF(MB)(1^2)=='**')#           ******* eof program **********   UPDA 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 UPDA 107
IF(FILEXS)#                            Only if ip source file is ther   UPDA 108
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 UPDA 109
IF(STATUS!=4) error:(2)#               Update file out of sequence      UPDA 110
REPEAT#                                Loop over input source           UPDA 111
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 UPDA 112
read:(ifile:,100,IBUF)#                Read input source line           UPDA 113
write:(ofile:,IBUF)#                   Output source line               UPDA 114
ICNT=ICNT+1#                           Incr input source counter        UPDA 115
OCNT=OCNT+1#                           Incr output source counter       UPDA 116
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 UPDA 117
100 STATUS=2#                          Input eof breakpoint             UPDA 118
WRITE(lfile:,9) PCODE,UCNT,ICNT,C1,OCNT,C2# Print program status        UPDA 119
close:(ifile:); close:(ofile:)#        Close ip and op source files     UPDA 120
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 UPDA 121
FILEXS=.TRUE.#                         Ip source file ok                UPDA 122
ICNT=0; OCNT=0; UCNT=0#                Reset line counters              UPDA 123
PCODE=' '; C1=' ';C2=' '#              Reset program codes              UPDA 124
BUF(MB)(1^2)='  '#                     Blank out program eof code       UPDA 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 UPDA 126
#                                                                       UPDA 127
ELSE IF (FILEXS)#                      ********** block ***********     UPDA 128
#                                      Treat only if ip source ok       UPDA 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 UPDA 130
IF(STATUS<3) error:(3)#                Program+update not in yet        UPDA 131
FIRST=yes:; STATUS=4#                  Reset first line & block         UPDA 132
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 UPDA 133
NEXT#                                  Skip to next update line         UPDA 134
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  UPDA 135
IF(STATUS<=3) NEXT#                    Skip to new update line          UPDA 136
#                                                                       UPDA 137
#   PROCESS FIRST BOUNDARY LINE                                         UPDA 138
#   ---------------------------                                         UPDA 139
#                                                                       UPDA 140
IF(FIRST==yes:)#                       Test if first line of block      UPDA 141
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 UPDA 142
TAG=BUF(NB)(73^80)#                    Store first line id tag          UPDA 143
IF(TAG=='        ') error:(7)#         Line id cannot be blank          UPDA 144
REPEAT#                                Loop over input source           UPDA 145
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 UPDA 146
read:(ifile:,200,IBUF)#                Read input source line           UPDA 147
write:(ofile:,IBUF)#                   Output source line               UPDA 148
ICNT=ICNT+1#                           Incr input source counter        UPDA 149
OCNT=OCNT+1#                           Incr output source counter       UPDA 150
IF(TAG==IBUF(73^80)) BREAK#            Exit when match found            UPDA 151
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 UPDA 152
IF(BUF(NB)!=IBUF) error:(5)#           Whole line doesn't match         UPDA 153
FIRST=no:;    NEXT#                    Skip to next update line         UPDA 154
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 UPDA 155
#                                                                       UPDA 156
#    PROCESS LAST BOUNDARY LINE                                         UPDA 157
#    --------------------------                                         UPDA 158
#                                                                       UPDA 159
IF(BUF(MB)(1^2)=='**')#                Look ahead for end delimiter     UPDA 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 UPDA 161
TAG=BUF(NB)(73^80)#                    Store last line id tag           UPDA 162
IF(TAG=='        ') error:(7)#         Line id cannot be blank          UPDA 163
REPEAT#                                Loop over input source           UPDA 164
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 UPDA 165
read:(ifile:,200,IBUF)#                Skip input source lines          UPDA 166
ICNT=ICNT+1#                           Incr input source counter        UPDA 167
IF(TAG==IBUF(73^80)) BREAK#            Exit when match found            UPDA 168
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 UPDA 169
IF(BUF(NB)!=IBUF) error:(5)#           Whole line doesn't match         UPDA 170
OCNT=OCNT+1#                           Incr output source counter       UPDA 171
write:(ofile:,IBUF)#                   Output source line               UPDA 172
NEXT#                                  Reset to outside update block    UPDA 173
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 UPDA 174
#                                                                       UPDA 175
#   INSERT UPDATE LINES                                                 UPDA 176
#   -------------------                                                 UPDA 177
#                                                                       UPDA 178
IF(BUF(NB)(73^77)==UCODE(1^5))UCNT=UCNT+1# Incr update counter          UPDA 179
OCNT=OCNT+1#                           Incr output source count         UPDA 180
write:(ofile:,BUF(NB))#                Output update into source        UPDA 181
#                                                                       UPDA 182
#   IS THE XMACRO UPDATE VERSION CHECKED                                UPDA 183
#   ------------------------------------                                UPDA 184
#                                                                       UPDA 185
IF(CHEK==no:\PCODE(1^6)!='XMACRO')NEXT# Test for xmacro update          UPDA 186
read:(ifile:,200,IBUF); ICNT=ICNT+1#   Read the update line             UPDA 187
IF(CCODE!=IBUF(16^20)) error:(9)#      Signal current update wrong      UPDA 188
CHEK=no:#                              Switch off update check          UPDA 189
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  UPDA 190
#                                                                       UPDA 191
200 error:(4)#                         Unexpected eof ip source file    UPDA 192
250 CONTINUE#                          Expected eof detected            UPDA 193
IF(STATUS==4) error:(1)#               Unexpected eof on update file    UPDA 194
closel:; close:(ufile:)#               Close list & update files        UPDA 195
STOP#                                  Finish off                       UPDA 196
END#                                                                    UPDA 197
systemheader:(ERRO)#                   Output error messages            ERRO   1
####################################################################### ERRO   2
#                                                                     # ERRO   3
#                               ERROR                                 # ERRO   4
#                                                                     # ERRO   5
####################################################################### ERRO   6
SUBROUTINE ERROR(IE,NU,NI,NO,PC,C1,C2)#                                 ERRO   7
#                                                                       ERRO   8
INTEGER IE,NU,NI,NO#                                                    ERRO   9
CHARACTER   PC*6,C1*16,C2*16#                                           ERRO  10
1 FORMAT(' ERROR >>>> Unexpected end-of-file on update input')#         ERRO  11
2 FORMAT(' ERROR >>>> Update file sequence is illegal')#                ERRO  12
3 FORMAT(' ERROR >>>> PROGRAM and/or UPDATE line(s) missing')#          ERRO  13
4 FORMAT(' ERROR >>>> EOF input source -- check update sequence')#      ERRO  14
5 FORMAT(' ERROR >>>> Boundary line does not match identically')#       ERRO  15
6 FORMAT(' ERROR >>>> UPDATE or CHECKX date cannot be blank')#          ERRO  16
7 FORMAT(' ERROR >>>> Boundary line identifier code cannot be blank')#  ERRO  17
8 FORMAT(' ERROR >>>> Program name is missing from PROGRAM line')#      ERRO  18
9 FORMAT(' ERROR >>>> update: in XMACRO different to CHECKX date')#     ERRO  19
10 FORMAT(1X,A6,I4,' updates',I8,' lines ',A16,I6,' lines ',A16)#       ERRO  20
#                                                                       ERRO  21
WRITE(lfile:,10) PC,NU,NI,C1,NO,C2#    Print error location             ERRO  22
IF(IE==1) WRITE(lfile:,1)#             Print error message 1            ERRO  23
IF(IE==2) WRITE(lfile:,2)#             Print error message 2            ERRO  24
IF(IE==3) WRITE(lfile:,3)#             Print error message 3            ERRO  25
IF(IE==4) WRITE(lfile:,4)#             Print error message 4            ERRO  26
IF(IE==5) WRITE(lfile:,5)#             Print error message 5            ERRO  27
IF(IE==6) WRITE(lfile:,6)#             Print error message 6            ERRO  28
IF(IE==7) WRITE(lfile:,7)#             Print error message 7            ERRO  29
IF(IE==8) WRITE(lfile:,8)#             Print error message 8            ERRO  30
IF(IE==9) WRITE(lfile:,9)#             Print error message 9            ERRO  31
close:(ifile:); close:(ofile:)#        Close ip and op source files     ERRO  32
closel:;        close:(ufile:)#        Close list and update files      ERRO  33
IF(IE>0) STOP#                         Fool some compilers              ERRO  34
RETURN#                                                                 ERRO  35
END#                                                                    ERRO  36
