systemheader:(RFX   )#                                                  RFX    1
##   version: Dec94                                                             
####################################################################### RFX    2
#                                                                     # RFX    3
#                          *** RFX ***                                # RFX    4
#                                                                     # RFX    5
#   PROGRAM TO EXTRACT FLAGGED UPDATES FROM A RATMAC FILE.            # RFX    6
#                                                                     # RFX    7
####################################################################### RFX    8
#                                                                       RFX    9
macro:(scode:,'^')#                    Designated search flag           RFX   10
#                                                                       RFX   11
macro:(ifile:,1)#                      Input ratmac source              RFX   12
macro:(ufile:,2)#                      Output update file               RFX   13
#                                                                       RFX   14
macro:(openi:,OPEN(ifile:,#            Open input source file           RFX   15
STATUS='OLD',FILE='RFXPRG');REWIND(ifile:))#                            RFX   16
macro:(openu:,OPEN(ufile:,#            Open update file                 RFX   17
STATUS='NEW',FILE='RFXUPD');REWIND(ufile:))#                            RFX   18
macro:(close:,CLOSE($1))#              Close file                       RFX   19
#                                                                       RFX   20
macro:(read:,READ(ifile:,'(A)',END=100)BUF($1))# Read input line        RFX   21
macro:(write:,WRITE(ufile:,'(A)')$1)#  Write update line                RFX   22
#                                                                       RFX   23
systemheader:(XTRA)#                   Extract update lines             XTRA   1
####################################################################### XTRA   2
#                                                                     # XTRA   3
#                            XTRACT                                   # XTRA   4
#                                                                     # XTRA   5
####################################################################### XTRA   6
PROGRAM XTRACT#                                                         XTRA   7
##                G.S.D. King Jan 87   S.R. Hall May 87                 XTRA   8
#                                                                       XTRA   9
CHARACTER*80 BUF(2)#                   Line buffers                     XTRA  10
CHARACTER TAG*8,DIG*10,SCODE*2#        Program code                     XTRA  11
CHARACTER NAME*20#                     Program name                     Dec94001
INTEGER NB,MB,I,J,FLAG,UCNT#                                            XTRA  12
INTEGER FIRST#                                                          Dec94002
DATA DIG/'0123456789'/#                                                 XTRA  13
#                                                                       XTRA  14
#   INITIALIZE                                                          XTRA  15
#   ----------                                                          XTRA  16
#                                                                       XTRA  17
openi:; FIRST=0; TAG(1^5)='Feb97'#     Open input file                  @@@@@003
NB=1;  MB=2;  FLAG=0;  UCNT=0#         Set buffer pointers & flag       XTRA  19
SCODE=scode://scode:#                  Form dual search code            XTRA  20
read:(1)#                              Read first source line           XTRA  21
NAME=BUF(1)(1^20)#                      Save program name               Dec94004
IF(NAME(1^12)!='systemheader') GOTO 150# Test if systemheader           Dec94005
#                                                                       Dec94006
#                                                                       XTRA  26
#   SEARCH SOURCE FOR UPDATE CODE                                       XTRA  27
#   -----------------------------                                       XTRA  28
#                                                                       XTRA  29
REPEAT#                                Loop over all source lines       XTRA  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  XTRA  31
NB=3-NB;   MB=3-MB#                    Reset buffer pointers            XTRA  32
read:(NB)#                             Read next line                   XTRA  33
#                                                                       XTRA  34
FOR(I=80;I>1;I=I-1)#                   Search line characters           XTRA  35
IF(BUF(NB)(I-1^I)==SCODE) BREAK#       Exit if scode detected           XTRA  36
#                                                                       XTRA  37
IF(I>1)#                               Test if scode found              XTRA  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  XTRA  39
IF(FIRST==0)#                                                           Dec94007
$(#                                                                     Dec94008
FIRST=1#                                                                Dec94009
openu:#                                Open the update file             Dec94010
write:('** UPDATE '//TAG(1^5))#        Write update line                Dec94011
write:('** PROGRAM '//NAME(15^20))#    Write program line               Dec94012
write:('**  .................................................')#        Dec94013
$)#                                                                     Dec94014
IF(FLAG==0) write:(BUF(MB))#           Output first boundary line       XTRA  40
IF(FLAG==1)#                           Line in block without scode      XTRA  41
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  XTRA  42
IF(BUF(MB)(73^80)=='        ')#        Use existing tag if present      XTRA  43
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  XTRA  44
UCNT=UCNT+1#                           Set flag as active block         XTRA  45
J=MOD(UCNT/100,10); TAG(6^6)=DIG(J+1^)# Insert 100's digit              XTRA  46
J=MOD(UCNT/10 ,10); TAG(7^7)=DIG(J+1^)# Insert  10's digit              XTRA  47
J=MOD(UCNT    ,10); TAG(8^8)=DIG(J+1^)# Insert   1's digit              XTRA  48
BUF(MB)(73^80)=TAG(1^8)#               Insert update tag                XTRA  49
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  XTRA  50
write:(BUF(MB))#                       Output update line               XTRA  51
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  XTRA  52
FLAG=2#                                Flag that scode found            XTRA  53
UCNT=UCNT+1#                           Set flag as active block         XTRA  54
BUF(NB)(I-1^I)='  '#                   Blank out search code            XTRA  55
I=MOD(UCNT/100,10); TAG(6^6)=DIG(I+1^)# Insert 100's digit              XTRA  56
I=MOD(UCNT/10 ,10); TAG(7^7)=DIG(I+1^)# Insert  10's digit              XTRA  57
I=MOD(UCNT    ,10); TAG(8^8)=DIG(I+1^)# Insert   1's digit              XTRA  58
BUF(NB)(73^80)=TAG(1^8)#               Insert update tag                XTRA  59
write:(BUF(NB))#                       Output update line               XTRA  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  XTRA  61
#                                                                       XTRA  62
ELSE IF(FLAG==2) FLAG=1#               No scode but inside block        XTRA  63
#                                                                       XTRA  64
ELSE IF(FLAG==1)#                      Update block finished            XTRA  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  XTRA  66
FLAG=0#                                Switch off update flag           XTRA  67
write:(BUF(MB))#                       Output update line               XTRA  68
write:('**  .................................................')#        XTRA  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  XTRA  70
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  XTRA  71
#                                                                       XTRA  72
100 close:(ifile:)#                    Close input file                 Dec94015
IF(FIRST==0) GOTO 200#                 Only close file if it was opened Dec94016
write:('** EOF')#                      End of updates                   Dec94017
DO I=1,8; write:(' ')#                 Blank lines at end               Dec94018
close:(ufile:)#                        Close update file                Dec94019
GOTO 200#                                                               XTRA  75
150 WRITE(6,'(49h *error* systemheader: must be first source line.)')#  XTRA  76
200 STOP#                                                               XTRA  77
END#                                                                    XTRA  78
