systemheader:(AD    )#                                                  AD     1
####################################################################### AD     2
##      Copyright (C) 2000, The Xtal System, The University of        # AD     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # AD     4
## Distributed under the GNU General Public Licence as published by   # AD     5
## the Free Software Foundation, in the hope that it will be useful   # AD     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # AD     7
## for more details.                                                  # AD     8
#                                                                     # AD     9
#                            *** ADDATM ***                           # AD    10
#                                                                     # AD    11
#    PROGRAM TO LOAD ATOM PARAMETERS IN THE BDF RECORD LRATOM:        # AD    12
#                                                                     # AD    13
####################################################################### AD    14
#                                                                       AD    15
include:(XMACRO)#                                                       AD    16
macro:(mxwd4c:,incr:(arith:( 3,/,mxchwd:)))#                            AD    17
macro:(mxwd8c:,incr:(arith:( 7,/,mxchwd:)))#                            AD    17
macro:(mxwd24:,incr:(arith:(23,/,mxchwd:)))#                            AD    18
macro:(atomlist:,[ifelse:($1,,M,$1)])# Define atom list pointer
macro:(irel:,STOPY2)# discrete relative pointer
macro:(saveid:,$1(STOPY3,$2)=1.0)# A macro to run a macro!
macro:(stateid:,NINT($1(STOPY3,$2)))# what is status of the id number 
macro:(aref:,NINT(QX(irel:+$1)))# discrete relative pointer
macro:(bref:,NINT(QX(irel:+$1+($2-1))))# Relative pointer
macro:(cref:,NINT(QX(irel:+$1+($2-1)*2)))# Relative pairwise pointer
macro:(na:,   [QX(atomlist:($1)+aref:(1))])# Define start of atom name
macro:(xif:,  [QX(atomlist:($1)+bref:(2,$2))])# Define frac x coord
macro:(uis:,  [QX(atomlist:($1)+aref:(5))])# U isotropic
macro:(pop:,  [QX(atomlist:($1)+aref:(6))])# population
macro:(sxif:, [QX(atomlist:($1)+bref:(7,$2))])# sigma xi fract
macro:(suis:, [QX(atomlist:($1)+aref:(10))])# sigma uiso
macro:(spop:, [QX(atomlist:($1)+aref:(11))])# sigma pop
macro:(dset:, [QX(atomlist:($1)+aref:(12))])# dset
macro:(mult:, [QX(atomlist:($1)+aref:(13))])# multiplicity
macro:(scat:, [QX(atomlist:($1)+aref:(14))])# Scatering factor ptr
macro:(adp:,  [QX(atomlist:($1)+aref:(15))])# ADP type 0/1/2
macro:(uij:,  [QX(atomlist:($1)+bref:(16,$2))])# Define Uij
macro:(suij:, [QX(atomlist:($1)+bref:(22,$2))])# Sigma Uij
macro:(ltype:,[QX(atomlist:($1)+aref:(28))])# calcat link type
macro:(ldist:,[QX(atomlist:($1)+aref:(29))])# calcat link dist
macro:(lalf1:,[QX(atomlist:($1)+aref:(30))])# calcat link angle1
macro:(lalf2:,[QX(atomlist:($1)+aref:(31))])# calcat link angle2
macro:(lspec:,[QX(atomlist:($1)+cref:(32,$2))])# calcat parent label
macro:(lssym:,[QX(atomlist:($1)+cref:(33,$2))])# calcat parent symm
macro:(lsame:,[QX(atomlist:($1)+bref:(40,$2))])# calcat Co-created sites 
#                                                                       AD    20
extrude:(ADCOMN)#                                                       AD    21
INTEGER DSETN#     ## Current data set number                           AD    22
INTEGER INATOM#    ## Count of number of atoms loaded during run        AD    23
INTEGER ICENT#     ## Centrosymmetric flag                              AD    24
INTEGER IGRAF#     ## Input graf flag                                   AD    25
INTEGER INVERT#    ## Request to change enantiomorph-polarity           AD    26
INTEGER UPDAT#     ## Update mode flag                                  AD    27
INTEGER LTYPE#     ## Crystal lattice type signal                       AD    28
INTEGER MARKA#     ## Start of atom parameter storage in qx array       AD    29
INTEGER MARKX#     ## Constraint array                                  AD    30
INTEGER MARKY#     ## Symmetry operations                               AD    31
INTEGER NAME#      ## Maximum number of words to hold 24 chrs           AD    32
INTEGER NSFTOT#    ## Total number of scattering factor types           AD    33
INTEGER POLSPG(3)# ## Polar space group signals                         AD    34
INTEGER PSIZ#      ## packet size of lrec                               AD    35
INTEGER PRINT#     ## Signal to tell if atoms are to be printed         AD    36
INTEGER STEPA#     ## Number of words per atom in qx array              AD    37
INTEGER STEPX#     ## constraint array                                  AD    38
INTEGER STEPY#     ## symops array                                      AD    39
INTEGER STOPA#     ## End of atom qx array                              AD    40
INTEGER STOPX#     ## End of special position constraints               AD    41
INTEGER STOPY#     ## End of symop array                                AD    42
INTEGER STOPY1#    ## End of output lratom: header
INTEGER STOPY2#    ## End of input lratom: header
INTEGER STOPY3#    ## End of lratom IREL pointer data 
INTEGER STOPY4#    ## End of lratom item useage counts; start defaults
INTEGER SPECPO#    ## Signal for spec pos processing                    AD    43
INTEGER DPTYPE#    ## tf Signal 0=uov;1=isou;2=anisou;3=mixed           AD    44
INTEGER PLINK#     ## Signal to purge all existing link information #   AD    45
#                                                                       AD    46
REAL   ATWTS(16)#  ## Atomic weights for density calc.                  AD    47
REAL   ACNTS(16)#  ## Nuber of atoms of type                            AD    48
REAL   CELLP(6)#   ## Direct unit cell parameters                       AD    49
REAL   CELLR(6)#   ## Reciprocal unit cell parameters                   AD    50
REAL   UEQU(6)#    ## Convert Uij to Uequiv                             AD    51
REAL   CDENS#      ## Current unit cell density                         AD    52
REAL   CONV(6)#    ## conversion factors u to uij                       AD    53
REAL   CVOL#       ## Unit cell volume                                  AD    54
REAL   EXT(17)#    ## Extinction parameters                             AD    55
REAL   GRID(3)#    ## Number of grid divisions on fourier maps          AD    56
REAL   ODENS#      ## Observed unit cell density from bdf               AD    57
REAL   ROT(9)#     ## Graf rotation matrix molecule                     AD    58
REAL   RO2(9)#     ## Graf rotation matrix cell                         AD    59
REAL   SCAL(64)#   ## Frel scale factors by group                       AD    60
REAL   SHIFT(6)#   ## Shift of atom coords                              AD    61
REAL   SYMFAC#     ## Scale cell contents..nsym*cell type               AD    62
REAL   TATOMS(16)# ## Total atoms of each type in whole cell            AD    63
REAL   TDENS#      ## Theoretical unit cell density                     AD    64
REAL   UOV#        ## overall dp u                                      AD    65
REAL   XABS#       ## absolute structure parameter                      AD    66
REAL   ZMOLES#     ## Number of molecules per unit cell                 AD    67
#                                                                       AD    68
string:(SFNAME,128)## Array of scat factor names 8ch/name               AD    69
string:(CURID,24)# ## Holding array for id of atoms being               AD    70
string:(NEWID,24)# ## Holding array for next atom name                  AD    71
#                                                                       AD    72
COMMON/COMIAD/NSFTOT,MARKA,DSETN,STEPA,INATOM,NAME,PRINT,POLSPG,PSIZ,#  AD    73
DPTYPE,STOPA,STOPX,ICENT,STOPY,LTYPE,MARKX,MARKY,STEPX,STEPY,SPECPO,#   AD    74
UPDAT,IGRAF,INVERT,PLINK,STOPY1,STOPY2,STOPY3,STOPY4
#                                                                       AD    76
COMMON/COMFAD/CELLP,GRID,ATWTS,CDENS,TDENS,ODENS,SYMFAC,TATOMS,CVOL,#   AD    77
UEQU,CELLR,CONV,SCAL,EXT,SHIFT,UOV,XABS,ROT,RO2,ZMOLES,ACNTS#           AD    78
#                                                                       AD    79
COMMON/COMCAD/CURID,NEWID,SFNAME#                                       AD    80
endext:#                                                                AD    81
#                                                                       AD    82
systemheader:(AD00)#                                                    AD00   1
# ################################################################## #  AD00   2
#                                                                    #  AD00   3
#                               AD00                                 #  AD00   4
#                                                                    #  AD00   5
# ################################################################## #  AD00   6
SUBROUTINE AD00#                       J.m. stewart 1981                AD00   7
include:(AACOMN)#                      S.r. hall 1990                   AD00   8
include:(ADCOMN)#                                                       AD00   9
#                                                                       AD00  10
CALL AD01#                             Process lines & copy bdf         AD00  11
CALL AD02#                             Load bdf cell, sym., ...         AD00  12
CALL AD03#                             Read atom, u, uij, lines         AD00  13
CALL AD04#                             Read stack, delete, edit lines   AD00  14
CALL AD05#                             Check special positions          AD00  15
CALL AD06#                             Write bdf lratom: & print pa     AD00  16
CALL AD07#                             Finish loading bdf               AD00  17
CALL AD10#                             Update lrmole:                   AD00  18
CALL AD09#                             Reentrant streamer to startx     AD00  19
#                                                                       AD00  20
RETURN#                                                                 AD00  21
END#                                                                    AD00  22
systemheader:(AD01)#                   Load atoms into bdf              AD01   1
# ################################################################## #  AD01   2
#                                                                    #  AD01   3
#                               AD01                                 #  AD01   4
#                                                                    #  AD01   5
# ################################################################## #  AD01   6
SUBROUTINE AD01#                                                        AD01   7
include:(AACOMN)#                                                       AD01   8
include:(ADCOMN)#                                                       AD01   9
#                                                                       AD01  10
INTEGER I,K,L,M,N,KEY#                                                  AD01  11
chardata:(AD10, SHIFT SCALE EXTINC UOV XABS GRAF INVERT $#              AD01  12
GRID ATOM ATOMG U UIJ SUIJ LINK END STACK DELETE EDITU RENAME )#        AD01  13
chardata:(AD11, ZACH TYP1 TYP2 GEN  ISO  ANIS GAUS LORE )#              AD01  14
chardata:(AD12,OVE ISO ANI MIX PRI NOP DSE UPD PLI )#                   AD01  15
chardata:(AD19," Thermal displacement type        xxxxxxxxxxxx")#       AD01  16
chardata:(AD22," ADDATM Parameters-")#                                  AD01  17
chardata:(AD23," overall U  isotropic U anisotr Uij mixed U/Uij  ")#    AD01  18
datastuff:#                                                             AD01  19
#                                                                       AD01  20
DO I=1,3;   SHIFT(I  )=0.#             Zero xyz shifts                  AD01  21
DO I=1,3;   SHIFT(I+3)=1.#             Set xyz multipliers              AD01  22
DO I=1,9;   ROT(I)=0.;    IGRAF=no:#   Set graf rotation matrix         AD01  23
ROT(1)=1.;  ROT(5)=1.;   ROT(9)=1.#    Set graf rotation matrix         AD01  24
DO I=1,9;   RO2(I)=ROT(I)#             Set graf rotation matrix         AD01  25
DPTYPE=3#                              Set the default to mixed tf      AD01  26
PRINT=yes:#                            Set to print atom list           AD01  27
UPDAT=no:#                             Set default as ab initio         AD01  28
DSETN=1#                               Default data set number          AD01  29
ODENS=0.#                              Set observed density             AD01  30
INVERT=0#                              No entantiomorph change          AD01  31
PLINK=0#                               Retain all link information      AD01  32
NAME=incr:(arith:(23,/,mxchwd:))#      Words for atom name              AD01  33
#                                                                       AD01  34
#    SCAN THE ADDATM LINE FOR INSTRUCTIONS                              AD01  35
#    -------------------------------------                              AD01  36
#                                                                       AD01  37
DO K=1,20#                             Loop over input fields           AD01  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AD01  39
ifvo:(BUFIN(K)) BREAK#                 Stop at end of input             AD01  40
IF(BUFIN(K)>voidflg:) NEXT#            Skip numeric                     AD01  41
stringlim:(K,N,M)#                     Pick out the string              AD01  42
compchar:(CHRIN,N,AD12,1,3,4,NAD12,KEY)# Look for a match in the lis    AD01  43
IF(KEY==0) iquit:(AD0104,K)#           Not recognised                   AD01  44
IF     (KEY<=4)  DPTYPE=KEY-1#         Set thermal parameter type       AD01  45
ELSE IF(KEY==6)  PRINT=no:#            Shut off the printing            AD01  46
ELSE IF(KEY==7)  DSETN=NINT(BUFIN(K+1))# Set data set number            AD01  47
ELSE IF(KEY==8)  UPDAT=yes:#           Switch on site update mode       AD01  48
ELSE IF(KEY==9)  PLINK=-1#             Purge all link information       AD01  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AD01  50
#                                                                       AD01  51
IOMARK(1)=QXSTR#                       Start of filea buffer            AD01  52
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of fileb buffer            AD01  53
MARKY    =IOMARK(2)+bdfbuf:#           Start of symmetry data           AD01  54
incrqx:(I,MARKY,AD0102)#               Expand qx.........ad0102         AD01  55
#                                                                       AD01  56
#     PRINT OUT THE SUMMARY OF CALCULATION TO BE DONE                   AD01  57
#    ------------------------------------------------                   AD01  58
#                                                                       AD01  59
copyfile:(1,2,1,decr:(lrcell:))#       Copy history rec and lrcell:     AD01  60
movechar:(AD22,NAD22,CHROT,2,NAD22-2,1)# Insert underline               AD01  61
writeline:(1,AD22,NAD22-1,2,3)#        Print header                     AD01  62
movechar:(AD23,DPTYPE*12+1,AD19,35,12,0)# Insert dp type                AD01  63
writeline:(0,AD19,NAD19,3,3)#          Print dp type                    AD01  64
#                                                                       AD01  65
#   PROCESS OTHER INPUT LINES                                           AD01  66
#   -------------------------                                           AD01  67
#                                                                       AD01  68
DO I=1,17; EXT(I)=0.;   EXT(1)=-1.#    Default no extinction            AD01  69
DO I=1,64; SCAL(I)=0.#                 Default scale is zero            AD01  70
UOV=-999.;      XABS=-999.#            Store default u & xabs           AD01  71
REPEAT#                                Loop over global input           AD01  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AD01  73
readline:(AD10,NAD10)#                 Process next input line          AD01  74
#                                                                       AD01  75
IF(LINID>7) BREAK#                     Exit if finished                 AD01  76
#                                                                       AD01  77
IF(LINID==1)#                          ******** shift *************     AD01  78
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AD01  79
DO I=1,6#                              Loop over shift fields           AD01  80
ifnv:(BUFIN(I)) SHIFT(I)=BUFIN(I)#     Store general xyz shift          AD01  81
INVERT=-1#                             Don't allow an invert line       AD01  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AD01  83
#                                                                       AD01  84
ELSE IF(LINID==2)#                     ********** scale ***********     AD01  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AD01  86
IF(BUFIN(2)>small:) K=NINT(BUFIN(2))#  Enter scale group number         AD01  87
ELSE                K=1#               Default scale                    AD01  88
IF(BUFIN(1)>small:) SCAL(K)=BUFIN(1)#  Enter frel scale                 AD01  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AD01  90
#                                                                       AD01  91
ELSE IF(LINID==3)#                     ******** extinct ************    AD01  92
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AD01  93
ifch:(BUFIN(1))#                       Extinction type                  AD01  94
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AD01  95
stringlim:(1,K,L);L=MIN0(4,L-K)#       What type of extinction?         AD01  96
compchar:(CHRIN,K,AD11,2,L,5,20,I)#    Compare ext. types               AD01  97
IF(I==0) iquit:(AD0108)#               Wrong type                       AD01  98
EXT(1)=FLOAT(I-1)#                     0/1/2/3=zach/bc1/bc2/bcgen       AD01  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AD01 100
ifch:(BUFIN(2))#                       Iso or aniso                     AD01 101
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AD01 102
stringlim:(2,K,L);L=MIN0(4,L-K)#       Read field 2                     AD01 103
compchar:(CHRIN,K,AD11,22,L,5,10,I)#   Iso or aniso                     AD01 104
IF(I==0) iquit:(AD0108)#               Wrong code                       AD01 105
IF(I==2)#                              Anisotropic types                AD01 106
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AD01 107
EXT(1)=EXT(1)+3.#                      Anisotropic type flag            AD01 108
K=1-NINT(ABS(EXT(1)-5.))#              Pointer to anisotropic array     AD01 109
DO I=1,6; EXT(I+4+6*K)=BUFIN(I+6)#     Store aniso terms                AD01 110
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AD01 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AD01 112
ifch:(BUFIN(3))#                       Gauss or lorentz                 AD01 113
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AD01 114
stringlim:(3,K,L);L=MIN0(4,L-K)#       Read field 3                     AD01 115
compchar:(CHRIN,K,AD11,32,L,5,10,I)#   Gauss or lorentz                 AD01 116
IF(I==0) iquit:(AD0108)#               Wrong code                       AD01 117
EXT(2)=FLOAT(I-1)#                     Distribution type                AD01 118
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AD01 119
ifnm:(BUFIN(4)) EXT(3)=BUFIN(4)#       Store away iso g ext value       AD01 120
ifnm:(BUFIN(5)) EXT(4)=BUFIN(5)#       Store away iso rho ext value     AD01 121
ifnm:(BUFIN(6)) EXT(17)=BUFIN(6)#      Store away mean t bar value      AD01 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AD01 123
#                                                                       AD01 124
ELSE IF(LINID==4)#                     ********** uov **************    AD01 125
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AD01 126
IF(BUFIN(1)>=0.0) UOV=BUFIN(1)#        Take other values                AD01 127
IF(UOV>1.) iquit:(AD0112)#             Bov entered instead of uov       AD01 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AD01 129
#                                                                       AD01 130
ELSE IF(LINID==5)#                     ********** xabs *************    AD01 131
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AD01 132
ifnm:(BUFIN(1)) XABS=MIN(1.,MAX(BUFIN(1),0.0))# Ensure realistic        AD01 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AD01 134
#                                                                       AD01 135
ELSE IF(LINID==6)#                     ********** graf *************    AD01 136
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AD01 137
IF(IGRAF==no:)#                        First entry is mole orient       AD01 138
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AD01 139
DO I=1,9; ifnv:(BUFIN(I)) ROT(I)=BUFIN(I)# Store graf rotation matrix   AD01 140
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AD01 141
ELSE#                                  Second entry is cell orient      AD01 142
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AD01 143
DO I=1,9; ifnv:(BUFIN(I)) RO2(I)=BUFIN(I)# Store graf rotation matrix   AD01 144
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AD01 145
IGRAF=yes:#                            Graf matrix entered              AD01 146
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AD01 147
#                                                                       AD01 148
ELSE IF(LINID==7&INVERT==0)#           ********** invert ************   AD01 149
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AD01 150
INVERT=1#                              Do invert if no shift line       AD01 151
DO I=4,6; SHIFT(I)=-1.0#               Multplier of inversion           AD01 152
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AD01 153
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AD01 154
#                                                                       AD01 155
RETURN#                                                                 AD01 156
END#                                                                    AD01 157
systemheader:(AD02)#                   Process bdf & input lines        AD02   1
#################################################################       AD02   2
#                                                               #       AD02   3
#                        AD02                                   #       AD02   4
#                                                               #       AD02   5
#################################################################       AD02   6
SUBROUTINE AD02#                                                        AD02   7
include:(AACOMN)#                                                       AD02   8
include:(ADCOMN)#                                                       AD02   9
#                                                                       AD02  10
INTEGER IP,IPP,J,K,I,M,N,JJ,KB,KS,KE#                                   AD02  11
INTEGER I1,I2,I3,OKALL,OK#                                              AD02  12
INTEGER IWANT(90)#         
INTEGER IREL(91)#          
INTEGER KEY(4)#                                                         AD02  15
INTEGER NSYM,IPR,LPAK,IQ#                                               AD02  16
REAL    TEST(3)#                                                        AD02  17
INTEGER ITEMCC(15)
INTEGER NPURGE,PURGE(50)#
intdata:(IDNUM,[14,1,2,3,4,11,101,102,103,104,111,17,21,22,23,# 
5,6,7,8,9,10,105,106,107,108,109,110,#                                  AD02  19
300,301,302,303,310,311,312,313,314,315,316,317,320,321,322,323])#      AD02  20
intdata:(BRST,[ 2, 8,1, 7,7,10,13])#                                    AD02  21
intdata:(BREND,[1,10,6,15,9,12,15])#                                    AD02  22
realdata:(DEFAUL,[0.,0.,0.,.035,1.,0.,0.,0.,0.,0.,1.,1.,1.,1.,#         AD02  23
.035,.035,.035,0.,0.,0.,0.,0.,0.,0.,0.,0.,#
.0,.0,.0,.0,.0,.0,.0])#                Default numeric data 
realdata:(BRAV,[0.3333333,0.6666667,0.6666667,0.6666667,$#              AD02  25
0.3333333,0.3333333,0.0,0.5,0.5,0.5,0.0,0.5,0.5,0.5,0.0])#              AD02  26
chardata:(AD24," New x = X.XXXXX + x * X.XXXXX")#                       AD02  27
chardata:(AD25,"xyz")#                                                  AD02  28
chardata:(AD26," Atomic coordinates being transformed by")#             AD02  29
chardata:(BLNK," ")#                                                    AD02  30
realdata:(FMT,[160752.,300752.])#                                       AD02  31
intdata:(NCITEM,[14,15,16,18,19,55,#
300,310,312,314,316,320,321,322,323])
datastuff:#                                                             AD02  32
DATA ITEMCC/mxwd24:,mxwd4c:,mxwd4c:,mxwd4c:,mxwd4c:,mxwd8c:,#
mxwd8c:,mxwd24:,mxwd24:,mxwd24:,mxwd24:,mxwd24:,mxwd24:,#
mxwd24:,mxwd24:/
IF(PLINK==-1)#                         Purge old link info if requested
$(
NPURGE=16
DO I=1,NPURGE;PURGE(I)=IDNUM(27+I)
PLINK=0#                               Reset link info flag
$)
IF(DPTYPE==1)
$(
DO I=1,12;PURGE(NPURGE+I)=IDNUM(15+I)
NPURGE=NPURGE+12
$)
NCITEMS=15#
NIITEMS=43#                            Number of intended items
#                                                                       AD02  33
#    PICK UP UNIT CELL PARAMETERS FOR T.F. CONVERSIONS LATER ON         AD02  34
#    ---------------------------------------------------------          AD02  35
#                                                                       AD02  36
DO J=1,10#                             Loop over lrcell:                AD02  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AD02  38
readwpkt:(1,lrcell:,PSIZ,IP,0)#                                         AD02  39
IF(IP==0) BREAK#                                                        AD02  40
writepkt:(2,lrcell:,PSIZ,IPP)#                                          AD02  41
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#                                     AD02  42
#                                                                       AD02  43
IF(J==1)#                              Direct cell parameters           AD02  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AD02  45
movereal:(QX,IP+1,CELLP,1,6,0)#        Direct cell parameters           AD02  46
DO I=1,3; GRID(I)=3.*CELLP(I)#         Convert to grid values           AD02  47
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AD02  48
ELSE IF(J==3)#                         Reciprocal cell parameters       AD02  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AD02  50
movereal:(QX,IP+1,CELLR,1,6,0)#        Reciprocal cell parameters       AD02  51
CONV(1)=1.;  CONV(2)=1.;  CONV(3)=1.#  Convert u to u11, u22, u33       AD02  52
CONV(4)=QX(IPP+6)#                     Convert u to u12                 AD02  53
CONV(5)=QX(IPP+5)#                     Convert u to u13                 AD02  54
CONV(6)=QX(IPP+4)#                     Convert u to u23                 AD02  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AD02  56
ELSE IF(J==6) CVOL=QX(IP+1)#           Pick up cell volume              AD02  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AD02  58
DO I=1,3; UEQU(I)=(CELLP(I)*CELLR(I))**2/3.# U(ii) to uequiv            AD02  59
UEQU(4)=2.*CELLP(1)*CELLR(1)*CELLP(2)*CELLR(2)*CELLP(6)/3.# U(12)       AD02  60
UEQU(5)=2.*CELLP(1)*CELLR(1)*CELLP(3)*CELLR(3)*CELLP(5)/3.# U(13)       AD02  61
UEQU(6)=2.*CELLP(2)*CELLR(2)*CELLP(3)*CELLR(3)*CELLP(4)/3.# U(23)       AD02  62
#                                                                       AD02  63
#    ENTER SYMMETRY INFORMATION                                         AD02  64
#    --------------------------                                         AD02  65
#                                                                       AD02  66
DO I=1,3; POLSPG(I)=0#                 Reset polar space group          AD02  67
copyfile:(1,2,incr:(lrcell:),decr:(lrsymm:))#                           AD02  68
readwpkt:(1,lrsymm:,PSIZ,IP,0)#                                         AD02  69
writepkt:(2,lrsymm:,PSIZ,IPP)#                                          AD02  70
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Move the packet to output        AD02  71
LTYPE=NINT(QX(IP+1))#                  Get out the lattice type         AD02  72
ICENT=NINT(QX(IP+2))#                  Centrosymmetric c=0 n=1          AD02  73
SYMFAC=QX(IP+3)#                       Total number equiv.pos.          AD02  74
NSYM=NINT(QX(IP+4))#                   Number equiv.pos. stored         AD02  75
ZMOLES=NINT(QX(IP+8))#                 Formula units z as input         AD02  76
I=NSYM*(2-ICENT)#                      No. of symops incl inver         AD02  77
IF(LTYPE>7) LTYPE=LTYPE-7#             Remove centrosymmetric bias      AD02  78
incrqx:(STOPY,MARKY+I*12,AD0201)#      Expand qx.......ad0201           AD02  79
STEPY=12#                              Set matrix step size             AD02  80
FOR(J=MARKY;J<STOPY;J=J+STEPY)#        Loop over symop matrices         AD02  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AD02  82
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Point to lrsymm packet           AD02  83
IF(IP<=0) BREAK#                       Exit on last symop               AD02  84
movereal:(QX,IP+1,QX,J+1,PSIZ,1)#      Save the symop in memory         AD02  85
IF(ICENT==0) NEXT#                     Check noncentrosymmetric         AD02  86
POLSPG(1)=POLSPG(1)+NINT(QX(IP+1))#    For polar axes                   AD02  87
POLSPG(2)=POLSPG(2)+NINT(QX(IP+5))#    For polar axes                   AD02  88
POLSPG(3)=POLSPG(3)+NINT(QX(IP+9))#    For polar axes                   AD02  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AD02  90
JJ=J#                                  Save current limit in marky      AD02  91
#                                      Set up change in enantiomorph    AD02  92
IF((INVERT>0)&(ICENT==1))#             Might change the space group!    AD02  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AD02  94
KS=BRST(LTYPE);KE=BREND(LTYPE)#        Set bravais lattice pointers     AD02  95
FOR(I1=0;I1<=6;I1=I1+1)#               X trial coordinate of i point    AD02  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AD02  97
SHIFT(1)=REAL(I1)/24.0#                                                 AD02  98
FOR(I2=0;I2<=6;I2=I2+1)#               Y trial coordinate of i point    AD02  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AD02 100
SHIFT(2)=REAL(I2)/24.0#                                                 AD02 101
FOR(I3=0;I3<=6;I3=I3+1)#               Z trial coordinate of i point    AD02 102
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AD02 103
SHIFT(3)=REAL(I3)/24.0#                                                 AD02 104
OKALL=yes:#                            Current trial - assume success   AD02 105
FOR(J=MARKY;J<JJ;J=J+STEPY)#           Loop over symop matrices         AD02 106
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AD02 107
OK=yes:#                               Set it passed the test           AD02 108
DO K=1,3#                              Primitive cell coordinates       AD02 109
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AD02 110
TEST(K)=AMOD(10.0001+2.0*(QX(J+K+9)+QX(J+K)*SHIFT(1)+$# Test product    AD02 111
QX(J+K+3)*SHIFT(2)+QX(J+K+6)*SHIFT(3)-SHIFT(K)),1.0)#                   AD02 112
IF(TEST(K)>0.0002) OK=no:#             It fails primitive               AD02 113
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AD02 114
IF(OK==yes:) NEXT#                     Success in primitive             AD02 115
DO KB=KS,KE,3#                         Loop over non-p translations     AD02 116
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AD02 117
OK=yes:#                               Set it passed the test           AD02 118
DO K=1,3;IF(AMOD((2.0+TEST(K)+BRAV(KB+K-1)),1.0)>0.0002) OK=no:#        AD02 119
IF(OK==yes:) BREAK#                    It passed the three tests        AD02 120
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AD02 121
IF(OK==yes:) NEXT#                     Success in centred lattice       AD02 122
OKALL=no:; BREAK#                      Quit this trial i point          AD02 123
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AD02 124
IF(OKALL==yes:) BREAK#                 Got a good i point               AD02 125
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AD02 126
IF(OKALL==yes:) BREAK#                 Got a good i point               AD02 127
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AD02 128
IF(OKALL==yes:) BREAK#                 Got a good i point               AD02 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AD02 130
IF(OKALL==yes:)#                       Got a solution                   AD02 131
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AD02 132
DO K=1,3; SHIFT(K)=2.0*SHIFT(K)#       Change point to shift            AD02 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AD02 134
ELSE#                                  No solution - change space g     AD02 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AD02 136
INVERT=2#                              Mark to run startx               AD02 137
DO K=1,3; SHIFT(K)=0.0#                I point is the origin            AD02 138
FOR(J=MARKY;J<JJ;J=J+STEPY)#           Loop over symop matrices         AD02 139
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AD02 140
DO K=10,12; QX(J+K)=AMOD((2.0-QX(J+K)),1.0)# Negate the translations    AD02 141
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AD02 142
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AD02 143
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AD02 144
FOR(J=MARKY;J<JJ;J=J+STEPY)#           Loop over symop matrices         AD02 145
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AD02 146
writepkt:(2,lrsymm:,PSIZ,IPP)#         Point to op packet               AD02 147
movereal:(QX,J+1,QX,IPP+1,PSIZ,1)#     Transfer symops to output        AD02 148
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AD02 149
DO I=1,3; POLSPG(I)=POLSPG(I)/NSYM#    Divide by number of matrices     AD02 150
K=J-MARKY#                             Length of input symop array      AD02 151
DO I=J+1,STOPY; QX(I)=-QX(I-K)#        Invert all symops                AD02 152
#                                                                       AD02 153
#    PICK UP THE SCATTERING FACTOR NAMES FROM LRSCAT:                   AD02 154
#    ------------------------------------------------                   AD02 155
#                                                                       AD02 156
copyfile:(1,2,incr:(lrsymm:),decr:(lrscat:))# Copy to lrscat:           AD02 157
NSFTOT=0#                              Set count of sf types to zer     AD02 158
IWANT(1)=11;IWANT(2)=1;IWANT(3)=2#     Set requests for lrscat:         AD02 159
KEY(1)=1; KEY(2)=3; KEY(3)=0; KEY(4)=0# Set search limits               AD02 160
indexpkt:(1,lrscat:,PSIZ,IP,2,KEY,IWANT,IREL)# Directory lrscat         AD02 161
IF(KEY(4)<=0) iquit:(AD0202)#          No form factors....ad0202.       AD02 162
REPEAT#                                Read all of them                 AD02 163
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AD02 164
readwpkt:(1,lrscat:,PSIZ,IP,0)#                                         AD02 165
IF(IP<=0) BREAK#                                                        AD02 166
writepkt:(2,lrscat:,PSIZ,IPP)#         Move packet to output on nfb     AD02 167
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Move the contents across         AD02 168
NSFTOT=NSFTOT+1#                       Count up s.f. types              AD02 169
IPR=IP+IREL(1)#                        Point to sf type symbol          AD02 170
movertoc:(QX(IPR),1,SFNAME,NSFTOT*8-7,8,0)# Store symbol in table       AD02 171
IPR=IP+IREL(2)#                        Find pointer to numatom count    AD02 172
IF(IPR>IP) TATOMS(NSFTOT)=QX(IPR)#     Pull out count by atom type      AD02 173
ELSE       TATOMS(NSFTOT)=0.#          Set it to zero if none           AD02 174
IPR=IP+IREL(3)#                        Find pointer to at wts.          AD02 175
IF(IPR>IP) ATWTS(NSFTOT)=QX(IPR)#      Pull out atomic weight           AD02 176
ELSE       ATWTS(NSFTOT)=0.#           Or zero if nothing there         AD02 177
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AD02 178
#                                                                       AD02 179
#   UPDATE SCALE FACTORS IN LREXPL:                                     AD02 180
#   -------------------------------                                     AD02 181
#                                                                       AD02 182
copyfile:(1,2,incr:(lrscat:),decr:(lrexpl:))#                           AD02 183
IWANT(1)=1; IWANT(2)=100#              Set datset and sclg idnums       AD02 184
DO I=1,64 ; IWANT(I+2)=100+I#          Set scale idnums                 AD02 185
IWANT(67)=85#                          Get measured density             AD02 186
KEY(1)=1; KEY(2)=67; KEY(3)=0; KEY(4)=0# Set indexpkt params            AD02 187
indexpkt:(1,lrexpl:,PSIZ,IP,2,KEY,IWANT,IREL)#                          AD02 188
IF(IP<=0\KEY(4)<=0) iquit:(AD0210)#    Data set number missing          AD02 189
IF(IREL(2)==0)      iquit:(AD0211)#    Scale factor missing             AD02 190
REPEAT#                                                                 AD02 191
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 AD02 192
readwpkt:(1,lrexpl:,PSIZ,IP,0)#        Read packets dataset by data     AD02 193
IF(IP<=0) BREAK#                                                        AD02 194
writepkt:(2,lrexpl:,KEY(4),IPP,0)#                                      AD02 195
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Move the existing stuff          AD02 196
K=IP+IREL(1)#                          Find dataset pointer             AD02 197
IF(DSETN!=NINT(QX(K))) NEXT#           Test correct data set            AD02 198
LINRM=3#                               Set up to list scales            AD02 199
IF(IREL(67)>0) ODENS=QX(IP+IREL(67))#  Get measured density             AD02 200
DO K=1,64#                             Loop over stored scale facto     AD02 201
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 AD02 202
J=IPP+IREL(K+2); IF(IPP==J) NEXT#      Skip if not present              AD02 203
ifne:(SCAL(K),0.) QX(J)=SCAL(K)#       Put scale factor into op buf     AD02 204
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 AD02 205
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 AD02 206
copyfile:(1,2,incr:(lrexpl:),decr:(lrdset:))# Copy to lrdset:           AD02 207
#                                                                       AD02 208
#    UPDATE LOGICAL RECORD LRDSET:                                      AD02 209
#    ----------------------------                                       AD02 210
#                                                                       AD02 211
IWANT(1)=1#                            Get dataset id num               AD02 212
IWANT(2)=2;      IWANT(20)=3#          Set uov xabs id num              AD02 213
DO J=1,17; IWANT(J+2)=100+J#           Set extinc idnums                AD02 214
KEY(1)=1; KEY(2)=0; KEY(3)=20; KEY(4)=0# Set search keys                AD02 215
indexpkt:(1,lrdset:,PSIZ,IP,2,KEY,IWANT,IREL)# Find the pointers        AD02 216
IF(IP<=0) iquit:(AD0212)#              Die if no record on file         AD02 217
LINRM =3#                              Set up heading                   AD02 218
REPEAT#                                Loop over lrdset packets         AD02 219
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 AD02 220
readwpkt:(1,lrdset:,PSIZ,IP,0)#        Read next lrdset                 AD02 221
IF(IP<=0) BREAK#                       Exit when finished               AD02 222
writepkt:(2,lrdset:,KEY(4),IPP,0)#     Point to next op packet          AD02 223
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Move the existing stuff          AD02 224
DO I=PSIZ+1,KEY(4); QX(IPP+I)=0.#      Zero the new additions           AD02 225
K=IREL(1)+IP#                          Get data set and pointer         AD02 226
IF(DSETN!=NINT(QX(K))) NEXT#           Skip unless match                AD02 227
J=IPP+IREL( 2); IF(UOV>-1.) QX(J)=UOV# Store input uov                  AD02 228
ifeq:(QX(J),0.) QX(J)=0.035#           Set default uov                  AD02 229
J=IPP+IREL(20)#                        Point to xabs                    AD02 230
IF(INVERT>0) ifnm:(QX(J)) QX(J)=1.0-QX(J)# Invert xabs on request       AD02 231
IF(XABS>-1.) QX(J)=XABS#               Store line input xabs            AD02 232
IF(EXT(1)<0.)#                         If extinction not input          AD02 233
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 AD02 234
J=IPP+IREL(3)#                         Point to extinction terms on b   AD02 235
IF(QX(J+2)+QX(J+3)>0.)DO I=1,17;EXT(I)=QX(J+I-1)# Get exist values      AD02 236
ELSE  EXT(1)=0.#                       Assume zachariasen               AD02 237
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 AD02 238
DO I=1,17#                             Loop ext terms                   AD02 239
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 AD02 240
J=IPP+IREL(I+2); QX(J)=EXT(I)#         Store input values               AD02 241
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 AD02 242
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 AD02 243
copyfile:(1,2,incr:(lrdset:),decr:(lrgraf:))# Copy to lrgraf:           AD02 244
#                                                                       AD02 245
#    ENTER GRAF ROTATION MATRIX                                         AD02 246
#    --------------------------                                         AD02 247
#                                                                       AD02 248
IF(IGRAF==yes:)#                       If new rotation matrix entered   AD02 249
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 AD02 250
DO I=1,9; IWANT(I)=I+20#               Rotation matrix mole             AD02 251
DO I=1,9; IWANT(I+9)=I+120#            Rotation matrix cell             AD02 252
KEY(1)=0;KEY(2)=0; KEY(3)=18; KEY(4)=0# Set search keys                 AD02 253
indexpkt:(1,lrgraf:,LPAK,IP,0,KEY,IWANT,IREL)# Test for wanted items    AD02 254
IF(IP<=0\KEY(4)<=0)#                   If lrgraf record missing or      AD02 255
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 AD02 256
PSIZ=18#                               Set op buffer record length      AD02 257
writepkt:(2,lrgraf:,PSIZ,IQ)#          Get op buffer pointer            AD02 258
DO I=1,18;QX(IQ+I)=FLOAT(IWANT(I))#    Store directory packet           AD02 259
writepkt:(2,lrgraf:,PSIZ,IQ)#          Get op buffer pointer            AD02 260
DO I=1,9; QX(IQ+I  )=ROT(I)#           Saved rotation matrix mole       AD02 261
DO I=1,9; QX(IQ+I+9)=RO2(I)#           Saved rotation matrix cell       AD02 262
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 AD02 263
ELSE#                                  Updating existing record         AD02 264
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 AD02 265
PSIZ=KEY(4)#                           Output packet expanded           AD02 266
writepkt:(2,lrgraf:,PSIZ,IQ)#          Get op buffer pointer            AD02 267
movereal:(QX,IP+1,QX,IQ+1,LPAK,1)#     Transfer existing pointers       AD02 268
DO I=1,18; QX(IQ+IREL(I))=FLOAT(IWANT(I))# Ration indices               AD02 269
readwpkt:(1,lrgraf:,LPAK,IP,0)#        Get ip buffer pointer            AD02 270
writepkt:(2,lrgraf:,PSIZ,IQ)#          Get op buffer pointer            AD02 271
movereal:(QX,IP+1,QX,IQ+1,LPAK,1)#     Transfer all data                AD02 272
DO I=1,9; QX(IQ+IREL(I))=ROT(I)#       Saved rotation matrix mole       AD02 273
DO I=1,9; QX(IQ+IREL(I+9))=RO2(I)#     Saved rotation matrix cell       AD02 274
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 AD02 275
copyfile:(1,2,incr:(lrgraf:),decr:(lratom:))# Copy to lratom:           AD02 276
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 AD02 277
ELSE copyfile:(1,2,incr:(lrdset:),decr:(lratom:))# Copy to lratom:      AD02 278
#                                                                       AD02 279
#  WRITE OUT SHIFT DATA                                                 AD02 280
#                                                                       AD02 281
writeline:(1,AD26,NAD26,3,3)#          Output the header                AD02 282
DO I=1,3#                              3 lines                          AD02 283
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 AD02 284
movechar:(AD25,I,AD24,6,1,0)#          Coordinate                       AD02 285
movechar:(AD25,I,AD24,20,1,0)#         Coordinate                       AD02 286
ncodefld:(SHIFT,I,AD24,FMT(1),1)#      Value                            AD02 287
ncodefld:(SHIFT,I+3,AD24,FMT(2),1)#    Value                            AD02 288
writeline:(0,AD24,NAD24,3,3)#          Output the line                  AD02 289
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 AD02 290
writeline:(0,0,0,1,3)#                 Blank line                       AD02 291
#                                                                       AD02 292
#    ENTER EXISTING LRATOM: DATA                                        AD02 293
#    ---------------------------                                        AD02 294
#                                                                       AD02 295
readwpkt:(1,lratom:,PSIZ,IP,0)#        Read the directory
IF(IP<0)PSIZ=0#
incrqx:(II,STOPY+PSIZ,AD0201)#         space for new dir header
movereal:(QX,IP+1,QX,STOPY+1,PSIZ,1)#  Copy directory IDnums
DO I=1,NIITEMS#                        Loop for new intended
$(
DO J=1,PSIZ; IF(IDNUM(I)==NINT(QX(IP+J))) BREAK # intended exists
IF(J<=PSIZ) IREL(I)=J#                 save pointer to requested
ELSE#                                  alloc space for intended 
$(
IREL(I)=II-STOPY+1#                          Pointer to new
K=1#                                   Default item size
DO J=1,NCITEMS;IF(NCITEM(J)==IDNUM(I)) K=ITEMCC(J)# found a char item
incrqx:(IX,II+K,AD0201)#               space for new dir header
DO J=1,K;QX(II+J)=IDNUM(I)#            stash intended idnumber
II=IX
$)
$)
STOPY1=IX
STEPA=STOPY1-STOPY#                    ADDATOM Atom packet size
#
# Build envisaged output dir header 
#
#
# Build reverse input dir pointers#   probably redundant but ...
#
incrqx:(irel:,STOPY1+PSIZ,AD0201)#    space for input atom dir
DO I=1,PSIZ
$(
QX(STOPY1+I)=FLOAT(I)#               order in == order out
DO J=1,NPURG#
IF(PURGE(J)==NINT(QX(IP+I))) QX(STOPY1+I)=0.0# purge input idnum
$)
#
# copy IREL pointers for general attribute access
#
incrqx:(STOPY3,irel:+NIITEMS,AD0201)# space for IREL record
DO I=1,NIITEMS
QX(irel:+I)=FLOAT(IREL(I))#           copy pointer to na:
#
# Make item counters
#
incrqx:(STOPY4,STOPY3+STEPA,AD0201)# space for requ item flags
Do I=1,STEPA ; QX(STOPY3+I)=0.#      init requ to zero count
saveid:([dset:])#                      should always save
saveid:([adp:])#                      should always save
saveid:([uis:])#                      should always save
#
# Build default packet
#
IF(UOV>0.) DEFAUL(4)=UOV#              Default uiso is uov              AD03  30
ELSE       DEFAUL(4)=0.035#            Unless not available             AD03  31
incrqx:(MARKA,STOPY4+STEPA,AD0201)#  space for new total record
movereal:(voidflg:,1,QX,STOPY4+1,STEPA,2)# Initialize all defs void
K=0
DO I=1,NIITEMS#                        Loop intended defaults
$(
DO J=1,NCITEMS;IF(NCITEM(J)==IDNUM(I))BREAK# found a char item
if(J<=NCITEMS) 
movector:(BLANK,1,QX(STOPY4+IREL(I)),1,ITEMCC(J)*mxchwd:,0)
ELSE
$(
K=K+1#
QX(STOPY4+IREL(I))= DEFAUL(K)#        copy defaults
$)
$)
#
# Read input bdf atom data
#
#
INATOM=0
STOPA=MARKA#                           Set atom list step               AD02 332
IF(UPDAT==yes:)#                       If in update mode                AD02 333
FOR(M=MARKA;IP>0;M=STOPA)#             Loop atom records                AD02 334
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 AD02 335
readwpkt:(1,lratom:,PSIZ,IP,0)#        Read the next packet             AD02 336
IF(IP<=0) BREAK#                       Exit from the loop               AD02 337
INATOM=INATOM+1#                       Count input atoms                AD02 338
incrqx:(STOPA,M+STEPA,AD0201)#         Increment atom list              AD02 339
movereal:(QX,STOPY4+1,QX,M+1,STEPA,1)# copy defaults
Do I=1,PSIZ#                           copy old in
$(
J=NINT(QX(STOPY1+I))#                  get reverse pointer
IF(J==0)NEXT#                          skip purged items
movepakwd:(QX(IP+I),QX(M+J))# 
ifnv:(QX(IP+I)) QX(STOPY3+J)=1.0#      count-non void
$)
movertoc:(na:(M),1,NEWID,1,24,0)#      Store label in temp area         AD02 341
label:(NEWID,J,K)#                     Process atom label               AD02 342
#                                      Apply shifts                     AD02 364
DO I=1,3; xif:(M,I)= xif:(M,I)*SHIFT(I+3)+SHIFT(I)# fractional shifts
DO I=1,3;sxif:(M,I)=sxif:(M,I)*ABS(SHIFT(I-2))# esd fractional shifts
IF(adp:(M)>1)#                         Is the atom anisotropic?         AD02 370
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 AD02 371
uij:(M,1)=uij:(M,1)*SHIFT(4)*SHIFT(4)# Apply rotation
uij:(M,2)=uij:(M,2)*SHIFT(5)*SHIFT(5)# Apply rotation
uij:(M,3)=uij:(M,3)*SHIFT(6)*SHIFT(6)# Apply rotation
uij:(M,4)=uij:(M,4)*SHIFT(4)*SHIFT(5)# Apply rotation
uij:(M,5)=uij:(M,5)*SHIFT(4)*SHIFT(6)# Apply rotation
uij:(M,6)=uij:(M,6)*SHIFT(5)*SHIFT(6)# Apply rotation
ifnv:(suij:(M,1))suij:(M,1)=suij:(M,1)*ABS(SHIFT(4)*SHIFT(4))#Apply rot
ifnv:(suij:(M,2))suij:(M,2)=suij:(M,2)*ABS(SHIFT(5)*SHIFT(5))#Apply rot
ifnv:(suij:(M,3))suij:(M,3)=suij:(M,3)*ABS(SHIFT(6)*SHIFT(6))#Apply rot
ifnv:(suij:(M,4))suij:(M,4)=suij:(M,4)*ABS(SHIFT(4)*SHIFT(5))#Apply rot
ifnv:(suij:(M,5))suij:(M,5)=suij:(M,5)*ABS(SHIFT(4)*SHIFT(6))#Apply rot
ifnv:(suij:(M,6))suij:(M,6)=suij:(M,6)*ABS(SHIFT(5)*SHIFT(6))#Apply rot
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 AD02 384
IF(DPTYPE==1&NINT(adp:(M))==2)#        Change aniso to iso u            AD02 385
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 AD02 386
adp:(M)=1.; uis:(M)=0.; suis:(M)=0.#   Set as isotropic u               AD02 387
saveid:([uis:]);saveid:([suis:])#
DO I=1,6; uis:(M)= uis:(M)+ uij:(M,I)*UEQU(I)# Calc u equivalent        AD02 388
DO I=1,6;suis:(M)=suis:(M)+suij:(M,I)*UEQU(I)# Calc su equivalent       AD02 389
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 AD02 390
ELSE IF(DPTYPE==2&J==1)#               Convert iso to aniso u           AD02 391
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 AD02 392
adp:(M)=2.#                            Set as anisotropic u             AD02 393
DO I=1,6;$( uij:(M,I)= uis:(M)*CONV(I);saveid:([uij:],I)$)# Store uij 
DO I=1,6;$(suij:(M,I)=suis:(M)*CONV(I);saveid:([suij:],I)$)# Store suij
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 AD02 396
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 AD02 397
#                                                                       AD02 399
RETURN#                                                                 AD02 400
END#                                                                    AD02 401
systemheader:(AD03)#                   Process atom, u, uij lines       AD03   1
#################################################################       AD03   2
#                                                               #       AD03   3
#                        AD03                                   #       AD03   4
#                                                               #       AD03   5
#################################################################       AD03   6
SUBROUTINE AD03#                                                        AD03   7
include:(AACOMN)#                                                       AD03   8
include:(ADCOMN)#                                                       AD03   9
#                                                                       AD03  10
INTEGER H,I,J,K,M,N#                                                    AD03  11
INTEGER NUMIN,NUMOT,CALTYP#                                             AD03  12
#                                                                       AD03  13
chardata:(AD11, SHIFT SCALE EXTINC UOV XABS GRAF INVERT $#              AD03  14
GRID ATOM ATOMG U UIJ SUIJ LINK END STACK DELETE EDITU RENAME )#        AD03  15
chardata:(AD12, LINEAR TRIGON TETCHN TETERM SQRPLN OCTHED HEXGNL $#     AD03  16
GENRAL METHYN TRTERM MEDIAN )#                                          AD03  17
intdata:(CALIN,[2,3,3,3,3,3,3,3,4,3,4])#                                AD03  18
intdata:(CALOT,[1,1,2,3,2,4,3,1,1,2,1])#                                AD03  19
chardata:(BLNK," ")#                                                    AD03  22
string:(LABEL,24)#                                                      AD03  23
datastuff:#                                                             AD03  24
#                                                                       AD03  25
#   OUTPUT LRATOM: DIRECTORY PACKET                                     AD03  26
#   -------------------------------                                     AD03  27
#                                                                       AD03  28
CURID=' '#                             Blank current id                 AD03  29
#                                                                       AD03  32
#    READ GRID/ATOM/U/UIJ/SUIJ LINES                                    AD03  33
#    ===============================                                    AD03  34
#                                                                       AD03  35
REPEAT#                                Loop over control lines          AD03  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AD03  37
IF(LINID>=15) BREAK#                   ***** end,stack,delete******     AD03  38
#                                                                       AD03  39
IF(LINID<8)   iquit:(AD0301)#          Lines out of order               AD03  40
#                                                                       AD03  41
IF(LINID==8)#                          ********** grid ************     AD03  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AD03  43
DO J=1,3; IF(BUFIN(J)>0.) GRID(J)=BUFIN(J)# Store new grid value        AD03  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AD03  45
#                                                                       AD03  46
ELSE#                                  *** atom/atomg/u/uij/suij ****   AD03  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AD03  48
ifnm:(BUFIN(1)) iquit:(AD0305)#        Label must be present            AD03  49
stringlim:(1,J,K)#                     Get label string limits          AD03  50
NEWID=CHRIP(J^K-1)#                    Get atom label                   AD03  51
IF(NEWID!=CURID)#                      If a new atom name               AD03  52
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AD03  53
IF(LINID>10) iquit:(AD0302)#           Cannot be u/uij/suij             AD03  54
label:(NEWID,J,K,SFNAME,N)#            Get sf name number               AD03  55
IF(N==0) iquit:(AD0315)#               No ff for this atom              AD03  56
FOR(M=MARKA;M<STOPA;M=M+STEPA)#        Loop over existing atoms         AD03  57
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AD03  58
movertoc:(na:(M),1,CURID,1,24,0)#      Get atom label                   AD03  59
IF(NEWID==CURID) BREAK#                Test for duplicate name          AD03  60
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AD03  61
IF(M==STOPA)#                          No match was found - new atom    AD03  62
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AD03  63
incrqx:(STOPA,M+STEPA,AD0310)#         Get more memory                  AD03  64
movereal:(QX,STOPY4+1,QX,M+1,STEPA,1)# copy defaults
INATOM=INATOM+1#                       Count input atoms                AD03  76
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AD03  77
ELSE IF(UPDAT==no:) iquit:(AD0303)#    Unexpected duplicate label       AD03  78
movector:(NEWID,1,na:(M),1,24,0)#      Store atom label                 AD03  79
J=STOPY3
saveid:([na:])#                        Set used flag on name
DO I=1,3
ifnv:(BUFIN(1+I))$(xif:(M,I)=BUFIN(1+I); saveid:([xif:],I)$) 
ifnv:(BUFIN(5))  $(uis:(M)=BUFIN(5) ;    saveid:([uis:])$)
ifnv:(BUFIN(6))  $(pop:(M)=BUFIN(6) ;    saveid:([pop:])$)
DO I=1,3 
ifnv:(BUFIN(6+I))$(sxif:(M,I)=BUFIN(6+I);saveid:([sxif:],I)$) 
ifnv:(BUFIN(10)) $(suis:(M)=BUFIN(10);   saveid:([suis:])$) 
ifnv:(BUFIN(11)) $(spop:(M)=BUFIN(11);   saveid:([spop:])$)
IF(uis:(M)>1.) iquit:(AD0312)#         B entered instead of u           AD03  87
IF(pop:(M)>1.1)iquit:(AD0313)#         Occupancy greater than 1.0       AD03  88
IF(LINID==10) DO I=1,3; xif:(M,I)=xif:(M,I)/GRID(I)# Grid to fractional
DO I=1,3#                              Loop over cell axes              AD03  90
xif:(M,I)=xif:(M,I)*SHIFT(I+3)+SHIFT(I)# Apply fractional shifts       
dset:(M)=DSETN;        saveid:([dset:])# Store data set number         
mult:(M)=1.;           saveid:([mult:])# Store temp multiplicity       
scat:(M)=FLOAT(N);     saveid:([scat:])# Store scat type number        
adp:(M) =FLOAT(DPTYPE);saveid:([adp:])# Dptype ov=0;iso=1;an=2;mix=3   
IF     (DPTYPE==3) adp:(M)=1.#         Mixed so store as isou           AD03  96
ELSE IF(DPTYPE==2)#                    If aniso force uij               AD03  97
DO I=1,6
$(
uij:(M,I) = uis:(M)*CONV(I);saveid:([uij:], I)# Store u into uij 
suij:(M,I)=suis:(M)*CONV(I);saveid:([suij:],I)# Store su into suij 
$)
CURID=NEWID#                           Reset atom label                 AD03  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AD03 101
ELSE IF(LINID==11)#                    U line entered                   AD03 102
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AD03 103
J=STOPY3
ifnv:(BUFIN(2))$( uis:(M)=BUFIN(2);saveid:([uis:])$)# Set input u 
ifnv:(BUFIN(3))$(suis:(M)=BUFIN(3);saveid:([suis:])$)# Set input suij 
IF(DPTYPE==2)#                         If aniso force uij               AD03 108
DO I=1,6;$(uij:(M,I)=uis:(M)*CONV(I);saveid:([uij:],I)$)# u into uij 
ELSE adp:(M)=1.#                       Store as isotropic u             AD03 110
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AD03 111
ELSE IF(LINID==12)#                    Test if uij/suij                 AD03 112
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AD03 113
J=STOPY3
IF(DPTYPE>1) adp:(M)=2.#               Set dp type as aniso             AD03 114
uis:(M)=0. ; saveid:([uis:])#
DO I=1,6#                              Loop over uij fields             AD03 118
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AD03 119
ifvo:(BUFIN(I+1)) NEXT#                Skip void fields                 AD03 121
uij:(M,I)=BUFIN(I+1) #                 Enter input value 
uis:(M)=uis:(M)+BUFIN(I+1)*UEQU(I)#    Calc u/su equivalent    
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AD03 124
BUFOT(1)=  SHIFT(4)*SHIFT(4)*uij:(M,1)# Apply rotation               
BUFOT(2)=  SHIFT(5)*SHIFT(5)*uij:(M,2)# Apply rotation               
BUFOT(3)=  SHIFT(6)*SHIFT(6)*uij:(M,3)# Apply rotation               
BUFOT(4)=  SHIFT(4)*SHIFT(5)*uij:(M,4)# Apply rotation               
BUFOT(5)=  SHIFT(4)*SHIFT(6)*uij:(M,5)# Apply rotation               
BUFOT(6)=  SHIFT(5)*SHIFT(6)*uij:(M,6)# Apply rotation               
DO I=1,6; uij:(M,I)=BUFOT(I)#          Save transformed uij             AD03 134
DO I=1,3; IF(BUFOT(I)<small:) iquit:(AD0320)# Zero or -ve uii           AD03 133
IF(DPTYPE>=2)DO I=1,6;saveid:([uij:],I)# Store uij 
$)
ELSE IF(LINID==13)#                    Test if suij              
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AD03 113
J=STOPY3
IF(DPTYPE>1) adp:(M)=2.#               Set dp type as aniso             AD03 114
suis:(M)=0. ; saveid:([suis:])#        Zero u/su for uequiv calc        AD03 117
DO I=1,6#                              Loop over uij fields             AD03 118
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AD03 119
ifvo:(BUFIN(I+1)) NEXT#                Skip void fields                 AD03 121
suij:(M,I)=BUFIN(I+1)#                 Enter input value 
suis:(M)=suis:(M)+BUFIN(I+1)*UEQU(I)#  Calc u/su equivalent     
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AD03 124
BUFOT(1)=  SHIFT(4)*SHIFT(4)*suij:(M,1)# Apply rotation                 AD03 125
BUFOT(2)=  SHIFT(5)*SHIFT(5)*suij:(M,2)# Apply rotation                 AD03 126
BUFOT(3)=  SHIFT(6)*SHIFT(6)*suij:(M,3)# Apply rotation                 AD03 127
BUFOT(4)=  SHIFT(4)*SHIFT(5)*suij:(M,4)# Apply rotation                 AD03 128
BUFOT(5)=  SHIFT(4)*SHIFT(6)*suij:(M,5)# Apply rotation                 AD03 129
BUFOT(6)=  SHIFT(5)*SHIFT(6)*suij:(M,6)# Apply rotation                 AD03 130
DO I=1,6; suij:(M,I)=ABS(BUFOT(I))#    Save transformed suij            AD03 134
IF(DPTYPE>=2)DO I=1,6;saveid:([suij:],I)# Store suij 
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AD03 141
#                                                                       AD03 142
ELSEIF(LINID==14&PLINK>=0)#            *********** link ************    AD03 143
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AD03 144
IA=STOPY3
ifnm:(BUFIN(2)) iquit:(AD0322)#        Require calcat type string       AD03 146
stringlim:(2,J,K)#                     Get label string limits          AD03 147
compchar:(CHRIN,J,AD12,2,6,7,NAD12,CALTYP)# Identify calc type          AD03 148
IF(CALTYP<=0)   iquit:(AD0323)#        Unidentified so quit             AD03 149
NUMIN=CALIN(CALTYP); NUMOT=CALOT(CALTYP)# Get atoms in and out          AD03 150
LABEL=' '#                             Erase label                      AD03 152
locase:(CHRIP(J^K),LABEL(1^J-K+1),6)#  Copy as lower case               AD03 153
movector:(LABEL,1,ltype:(M),1,8,0)#    Save calcat type                 AD03 154
saveid:([ltype:])#
#                                                                       AD03 155
#  PROCESS THE CALCAT LINE                                              AD03 156
#  _______________________                                              AD03 157
#                                                                       AD03 158
ifnm:(BUFIN(3)) ldist:(M)=BUFIN(3)#    Set attachment distance          AD03 160
ELSE  iquit:(AD0324)#                  Missing bond length              AD03 161
saveid:([ldist:])#
N=4#                                                                    AD03 163
DO K=1,NUMIN#                          Get parent geometry atoms        AD03 164
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AD03 165
ifvo:(BUFIN(N))iquit:(AD0325)#         Can't be void                    AD03 166
ifnm:(BUFIN(N))iquit:(AD0325)#         Can't be a number                AD03 167
stringlim:(N,I,J)#                     Get label string limits          AD03 168
LABEL=' '#                             Erase label                      AD03 169
LABEL(1^J-I+1)=CHRIP(I^J)#             Store atom label                 AD03 170
movector:(LABEL,1,lspec:(M,K),1,24,0)# Save parent atom label           AD03 171
saveid:([lspec:],K)#
N=N+1#                                 Step to next bufin item          AD03 173
ifnm:(BUFIN(N))#                       Test for symop present           AD03 174
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 AD03 175
lssym:(M,K)=BUFIN(N)#                  Save symop                       AD03 176
saveid:([lssym:],K)#
N=N+1#                                 Step to next bufin item          AD03 177
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 AD03 178
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AD03 180
#                                                                       AD03 182
DO K=1,NUMOT#                          Get ouput atoms                  AD03 183
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 AD03 184
ifvo:(BUFIN(N))iquit:(AD0326)#         Can't be void                    AD03 185
ifnm:(BUFIN(N))iquit:(AD0326)#         Can't be a number                AD03 186
stringlim:(N,I,J)#                     Get label string limits          AD03 187
LABEL=' '#                             Erase label                      AD03 188
LABEL(1^J-I+1)=CHRIP(I^J)#             Store atom label                 AD03 189
movector:(LABEL,1,lsame:(M,K),1,24,0)# Save the label here              AD03 190
saveid:([lsame:],K)#
N=N+1#                                 Step to next bufin item          AD03 192
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 AD03 193
IF(CALTYP==4\CALTYP==8\CALTYP==1)#     Teterm or genral or linear       AD03 195
ifnm:(BUFIN(N))#                                                        AD03 196
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 AD03 197
lalf1:(M)=BUFIN(N); saveid:([lalf1:])# Save angle 1                     AD03 198
IF(CALTYP==8)#                         Identified else ignore           AD03 199
ifnm:(BUFIN(N+1)) $(lalf2:(M)=BUFIN(N+1); saveid:([lalf2:])$)#
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 AD03 201
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AD03 202
#                                                                       AD03 203
ELSE iquit:(AD0303)#                   Duplicate atom detected          AD03 204
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AD03 205
readline:(AD11,NAD11)#                 Read in the next line            AD03 206
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AD03 207
#                                                                       AD03 208
RETURN#                                                                 AD03 209
END#                                                                    AD03 210
systemheader:(AD04)#                   Process atom edit lines          AD04   1
#################################################################       AD04   2
#                                                               #       AD04   3
#                        AD04                                   #       AD04   4
#                                                               #       AD04   5
#################################################################       AD04   6
SUBROUTINE AD04#                                                        AD04   7
include:(AACOMN)#                                                       AD04   8
include:(ADCOMN)#                                                       AD04   9
#                                                                       AD04  10
INTEGER I,J,K,L,N,M#                                                    AD04  11
INTEGER IALL,ISTK#                                                      AD04  12
REAL    UNEW#                                                           AD04  13
CHARACTER*32 STACK(100)#                                                AD04  14
#                                                                       AD04  15
chardata:(AD11, SHIFT SCALE EXTINC UOV XABS GRAF INVERT $#              AD04  16
GRID ATOM ATOMG U UIJ SUIJ LINK END STACK DELETE EDITU RENAME )#        AD04  17
chardata:(AD12,ISO ANI )#                                               AD04  18
datastuff:#                                                             AD04  19
#                                                                       AD04  20
#    PROCESS STACK, DELETE, EDITU AND RENAME LINES                      AD04  21
#    --------------------------------------------                       AD04  22
#                                                                       AD04  23
ISTK=0#                                Reset stack counter              AD04  24
WHILE(LINID>15)#                       Loop the edit commands           AD04  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AD04  26
#                                                                       AD04  27
IF(LINID==16)#                         ********** stack ************    AD04  28
DO I=1,mxfdim:#                        Loop over input fields           AD04  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AD04  30
ifvo:(BUFIN(I)) BREAK#                 Exit if void field               AD04  31
ifnm:(BUFIN(I)) iquit:(AD0405)#        Illegal number entered           AD04  32
stringlim:(I,J,K)#                     Get string limits                AD04  33
ISTK=ISTK+1; IF(ISTK>100) iquit:(AD0410)# Count the stack entry         AD04  34
STACK(ISTK)=CHRIP(J^K-1)#              Store label in stack list        AD04  35
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AD04  36
#                                                                       AD04  37
IF(LINID==17)#                         ********** delete ********       AD04  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AD04  39
DO I=1,mxfdim:#                        Loop over input fields           AD04  40
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AD04  41
ifvo:(BUFIN(I)) BREAK#                 Exit if void field               AD04  42
ifnm:(BUFIN(I)) iquit:(AD0415)#        Illegal number entered           AD04  43
stringlim:(I,J,K)#                     Get string limits                AD04  44
NEWID=CHRIP(J^K-1)#                    Store delete label               AD04  45
label:(NEWID,J,K,SFNAME,N)#            Identify atom label              AD04  46
IF(N==0) iquit:(AD0420)#               Scat factor not in bdf           AD04  47
FOR(M=MARKA;M<STOPA;M=M+STEPA)#        Loop over atom list              AD04  48
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AD04  49
movertoc:(na:(M),1,CURID,1,24,0)#      Get atom label                   AD04  50
IF(J==K&N!=NINT(scat:(M))) NEXT#       Flag atom for deletion           AD04  51
ELSE IF(J>K&NEWID!=CURID)       NEXT#  Test if labels match             AD04  52
uis:(M)=-99999.#                       Flag atom for deletion           AD04  53
IF(J>K) BREAK#                         Finished search if full label    AD04  54
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AD04  55
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AD04  56
N=MARKA#                               Set current pointer              AD04  57
FOR(M=MARKA;M<STOPA;M=M+STEPA)#        Loop over atom list              AD04  58
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AD04  59
IF(uis:(M)<-99998.) NEXT#              Skip deleted atoms               AD04  60
IF(N<M) movereal:(QX,M+1,QX,N+1,STEPA,0)# Shuffle non-deleted atoms     AD04  61
N=N+STEPA#                             Incr the final list pointer      AD04  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AD04  63
STOPA=N; INATOM=(N-MARKA)/STEPA#       Reset the atom list limit        AD04  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AD04  65
#                                                                       AD04  66
IF(LINID==18)#                         ********* editu ***********      AD04  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AD04  68
FOR(I=1;I>0;I=I+1)#                    Loop over input fields           AD04  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AD04  70
ifvo:(BUFIN(I)) BREAK#                 Exit if void field               AD04  71
ifnm:(BUFIN(I)) iquit:(AD0425)#        Illegal number entered           AD04  72
stringlim:(I,J,K)#                     Get string limits                AD04  73
IF(CHRIN(J^J+2)=='ALL') IALL=-1#       All atoms involved               AD04  74
ELSE#                                  Specific to label or atom-type   AD04  75
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AD04  76
IALL=no:; NEWID=CHRIP(J^K-1)#          Store editu label                AD04  77
label:(NEWID,J,K,SFNAME,N)#            Identify atom label              AD04  78
IF(N==0) iquit:(AD0430)#               Scat factor not in bdf           AD04  79
IF(J==K) IALL=N#                       Store scat fact type             AD04  80
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AD04  81
I=I+1#                                 Incr field pointer               AD04  82
ifvo:(BUFIN(I)) iquit:(AD0435)#        Illegal construction             AD04  83
ifnm:(BUFIN(I))#                       Test for thermal parameter       AD04  84
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AD04  85
UNEW=BUFIN(I);  N=0#                   Store new u value                AD04  86
IF(UNEW>1.) iquit:(AD0440)#            B has been entered               AD04  87
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AD04  88
ELSE#                                  This is a dp flag                AD04  89
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AD04  90
stringlim:(I,J,K)#                     Get string limits                AD04  91
compchar:(CHRIN,J,AD12,1,3,4,8,N)#     Identify u flag 1=iso/2=ani      AD04  92
IF(N==0) iquit:(AD0445)#               Illegal u code                   AD04  93
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AD04  94
FOR(M=MARKA;M<STOPA;M=M+STEPA)#        Loop over atom list              AD04  95
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AD04  96
movertoc:(na:(M),1,CURID,1,24,0)#     Get atom label                   AD04  97
IF(IALL==0&NEWID!=CURID) NEXT#         Test each atom label             AD04  99
ELSE IF(IALL>0&IALL!=NINT(scat:(M))) NEXT# Test atom type               AD04 100
IF(N==0)#                              Test if iso u entered            AD04 101
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AD04 102
uis:(M)=UNEW; suis:(M)=1.#             Store isotropic value            AD04 103
uis:(STOPY3)=1.;suis:(STOPY3)=1.#      set flags
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AD04 104
ELSE IF(N==1)#                         Test if iso conversion           AD04 105
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AD04 106
adp:(M)=1.; uis:(M)=0.; suis:(M)=0.#   Set as isotropic u               AD04 107
DO K=1,6; uis:(M) = uis:(M)+ uij:(M,K)*UEQU(K)# Calc u equivalent         AD04 108
DO K=1,6; suis:(M)=suis:(M)+suij:(M,K)*UEQU(K)# Calc su equivalent        AD04 109
uis:(STOPY3)=1.;suis:(STOPY3)=1.#      set flags
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AD04 110
ELSE#                                  Convert iso to aniso u           AD04 111
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AD04 112
adp:(M)=2.#                           Set as anisotropic u             AD04 113
DO K=1,6;$( uij:(M,K)=uis:(M)*CONV(K); uij:(STOPY3,K)=1.$)# Store uij
DO K=1,6;$(suij:(M,K)=suis:(M)*CONV(K);suij:(STOPY3,K)=1.$)#Store suij
IF(NEWID==CURID) BREAK#                Test for duplicate name          AD04 116
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AD04 117
IF(IALL==0) BREAK#                     Exit if single atom              AD04 118
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AD04 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AD04 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AD04 121
#                                                                       AD04 122
IF(LINID==19)#                         ********** rename ********       AD04 123
FOR(I=1;I>0;I=I+1)#                    Loop over input fields           AD04 124
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AD04 125
ifvo:(BUFIN(I)) BREAK#                 Exit if void field               AD04 126
ifnm:(BUFIN(I)) iquit:(AD0450)#        Illegal number entered           AD04 127
stringlim:(I,J,K)#                     Get string limits                AD04 128
NEWID=CHRIP(J^K-1)#                    Store delete label               AD04 129
label:(NEWID,J,K,SFNAME,N)#            Identify atom label              AD04 130
IF(N==0) iquit:(AD0455)#               Scat factor not in bdf           AD04 131
FOR(M=MARKA;M<STOPA;M=M+STEPA)#        Loop over atom list              AD04 132
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 AD04 133
movertoc:(na:(M),1,CURID,1,24,0)#     Get atom label                   AD04 134
IF(NEWID==CURID) BREAK#                Exit if labels match             AD04 135
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 AD04 136
IF(M==STOPA) iquit:(AD0460)#           Label not found                  AD04 137
I=I+1#                                 Incr input field index           AD04 138
IF(BUFIN(I)>=voidflg:) iquit:(AD0465)# Must be character                AD04 139
stringlim:(I,J,K)#                     Get string limits                AD04 140
NEWID=CHRIP(J^K-1)#                    Store delete label               AD04 141
label:(NEWID,J,K,SFNAME,N)#            Identify atom label              AD04 142
IF(N==0) iquit:(AD0455)#               Scat factor not in bdf           AD04 143
movector:(NEWID,1,na:(M),1,24,0)#     Store new atom label             AD04 144
scat:(M)=FLOAT(N)#                Store scat factor type           AD04 145
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AD04 146
readline:(AD11,NAD11)#                 Read the next line               AD04 147
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AD04 148
#                                                                       AD04 149
#    APPLY STACK COMMAND IF PRESENT                                     AD04 150
#    ------------------------------                                     AD04 151
#                                                                       AD04 152
DO I=ISTK,1,-1#                        Loop stack order                 AD04 153
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 AD04 154
NEWID=STACK(I); L=MARKA#               Set stack pointer                AD04 155
label:(NEWID,J,K,SFNAME,N)#            Identify atom label              AD04 156
IF(N==0) iquit:(AD0475)#               Scat factor not in bdf           AD04 157
FOR(M=MARKA;M<STOPA;M=M+STEPA)#        Loop over atom list              AD04 158
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 AD04 159
IF(J>K)#                               Test for full atom label         AD04 160
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 AD04 161
movertoc:(na:(M),1,CURID,1,24,0)#     Get atom label                   AD04 162
IF(NEWID!=CURID) NEXT#                 Skip if no match                 AD04 163
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 AD04 164
ELSE IF(N!=NINT(scat:(M))) NEXT#  Skip if no match                 AD04 165
movereal:(QX,M+1,QX,STOPA+1,STEPA,0)#  Store this atom in temp          AD04 166
movereal:(QX,L+1,QX,L+STEPA+1,M-L,1)#  Shuffle atom list down           AD04 167
movereal:(QX,STOPA+1,QX,L+1,STEPA,0)#  Store this atom in slot          AD04 168
IF(J>K) BREAK#                         Exit if single label             AD04 169
L=L+STEPA#                             Incr stack pointer               AD04 170
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 AD04 171
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 AD04 172
#                                                                       AD04 173
RETURN#                                                                 AD04 174
END#                                                                    AD04 175
systemheader:(AD05)#                   Detect special positions         AD05   1
# ################################################################## #  AD05   2
#                                                                    #  AD05   3
#                               AD05                                 #  AD05   4
#                                                                    #  AD05   5
# ################################################################## #  AD05   6
SUBROUTINE AD05#                                                        AD05   7
include:(AACOMN)#                                                       AD05   8
include:(ADCOMN)#                                                       AD05   9
#                                                                       AD05  10
REAL    AMATCH#                                                         AD05  11
REAL    EQUPOS(54)#                                                     AD05  12
INTEGER I,J#                                                            AD05  13
INTEGER II,JJ,LL,NN#                                                    AD05  14
INTEGER PARPNT(9)#  ## Related parameter pointer 1 to 9 for x to u23    AD05  15
REAL    PARSCL(9)#  ## Parameter scale factors                          AD05  16
INTEGER STATUS(9)#  ## Parameter status as search unfolds               AD05  17
INTEGER TRSTAR#     ## Start of lattice translations in array trans     AD05  18
INTEGER TRSTOP#     ## End of lattice translations in array trans       AD05  19
REAL  X(3),Y(3),Z(3)## Positional parameters derived from symmetry      AD05  20
INTEGER K,L,M,JREF,KK#                                                  AD05  21
REAL    DIAG,DIF,DIFDUM#                                                AD05  22
REAL ZZZ#                                                               AD05  23
#                                                                       AD05  24
realdata:(RESOLU,0.0005)#                                               AD05  25
intdata:(REFPNT,[1,8,15,19,26,33,40,47,54])#                            AD05  26
intdata:(TRPOIN,[1,3,4,9,10,18,19,30,31,36,37,42,43,48])#               AD05  27
realdata:(TRANS,[$#                    Transformation matrices          AD05  28
0.0,0.0,0.0,#                                                           AD05  29
0.0,0.0,0.0,#                          I cells                          AD05  30
0.5,0.5,0.5,#                                                           AD05  31
0.0,0.0,0.0,#                          R cells                          AD05  32
0.333333,0.666667,0.666667,#                                            AD05  33
0.666667,0.333333,0.333333,#                                            AD05  34
0.0,0.0,0.0,#                          F cells                          AD05  35
0.0,0.5,0.5,#                                                           AD05  36
0.5,0.0,0.5,#                                                           AD05  37
0.5,0.5,0.0,#                                                           AD05  38
0.0,0.0,0.0,#                          A cells                          AD05  39
0.0,0.5,0.5,#                                                           AD05  40
0.0,0.0,0.0,#                          B cells                          AD05  41
0.5,0.0,0.5,#                                                           AD05  42
0.0,0.0,0.0,#                          C cells                          AD05  43
0.5,0.5,0.0])#                                                          AD05  44
datastuff:#                                                             AD05  45
#                                                                       AD05  46
#   DEFINE CONSTRAINT LIST                                              AD05  47
#   ----------------------                                              AD05  48
#                                                                       AD05  49
MARKX=STOPA+1;  STEPX=7;  STOPX=MARKX# Start constraint list            AD05  50
I=(LTYPE-1)*2#                         Set up for lattice translati     AD05  51
TRSTAR=TRPOIN(I+1)#                    Set start in trans array         AD05  52
TRSTOP=TRPOIN(I+2)#                    Set end in trans array           AD05  53
#                                                                       AD05  54
#   LOOP OVER ATOMS LIST                                                AD05  55
#   --------------------                                                AD05  56
#                                                                       AD05  57
FOR(M=MARKA;M<STOPA;M=M+STEPA)#        Loop over atoms list             AD05  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AD05  59
DO I=1,3; X(I)=xif:(M,I)#           Extract x,y,z                    AD05  60
AMATCH=0.#                             Zero count of coincidences       AD05  61
DO I=1,9#                              Loop over atom parameters        AD05  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AD05  63
STATUS(I)=0; PARPNT(I)=0; PARSCL(I)=0.# Reset stat, point & scl         AD05  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AD05  65
#                                                                       AD05  66
#   LOOP OVER SYMMMETRY MATRICES                                        AD05  67
#   ----------------------------                                        AD05  68
#                                                                       AD05  69
FOR(J=MARKY;J<STOPY;J=J+STEPY)#        Loop over bdf symops             AD05  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AD05  71
Y(1)=X(1)*QX(J+1)+X(2)*QX(J+4)+X(3)*QX(J+7)+QX(J+10)# Get x             AD05  72
Y(2)=X(1)*QX(J+2)+X(2)*QX(J+5)+X(3)*QX(J+8)+QX(J+11)# Get y             AD05  73
Y(3)=X(1)*QX(J+3)+X(2)*QX(J+6)+X(3)*QX(J+9)+QX(J+12)# Get z             AD05  74
#                                                                       AD05  75
FOR(K=TRSTAR;K<=TRSTOP;K=K+3)#         Loop over lattice centres        AD05  76
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AD05  77
Z(1)=Y(1)+TRANS(K  )#                  Translate x                      AD05  78
Z(2)=Y(2)+TRANS(K+1)#                  Translate y                      AD05  79
Z(3)=Y(3)+TRANS(K+2)#                  Translate z                      AD05  80
#                                                                       AD05  81
#   TEST FOR SPECIAL POSITION                                           AD05  82
#   -------------------------                                           AD05  83
#                                                                       AD05  84
DO I=1,3#                              Loop over coordinates            AD05  85
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AD05  86
DIF=X(I)-Z(I);  DIFDUM=DIF#            Get diff in coordinate           AD05  87
DIF=DIF-FLOAT(NINT(DIFDUM))#           Get smallest difference          AD05  88
IF(ABS(DIF)>RESOLU) GOTO 100#          Skip to next symop               AD05  89
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AD05  90
#                                                                       AD05  91
#   SPECIAL POSITION DETECTED - BUILD 6X9 MATRIX                        AD05  92
#   --------------------------------------------                        AD05  93
#                                                                       AD05  94
AMATCH=AMATCH+1.0#                     Count atom multiplicity          AD05  95
KK=0#                                  Reset the equpos pointer         AD05  96
DO II=1,3#                             Loop over x,y,z,u11,u22,u33      AD05  97
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AD05  98
L=J+II-1#                              Point to symops                  AD05  99
EQUPOS(KK+1)=QX(L+1)#                  Store r11 (r21, r31)             AD05 100
EQUPOS(KK+2)=QX(L+4)#                  Store r12 (r22, r32)             AD05 101
EQUPOS(KK+3)=QX(L+7)#                  Store r13 (r23, r33)             AD05 102
EQUPOS(KK+4)=0.0#                      Not used                         AD05 103
EQUPOS(KK+5)=0.0#                      Not used                         AD05 104
EQUPOS(KK+6)=0.0#                      Not used                         AD05 105
EQUPOS(KK+19)= QX(L+1)*QX(L+1)#        Store r11**2(r21**2, r31**2 )   AD05 106
EQUPOS(KK+20)= QX(L+4)*QX(L+4)#        Store r12**2(r22**2, r32**2 )   AD05 107
EQUPOS(KK+21)= QX(L+7)*QX(L+7)#        Store r13**2(r23**2, r33**2 )   AD05 108
EQUPOS(KK+22)= QX(L+1)*QX(L+4)*2.#     Store r11*r12*2                  AD05 109
EQUPOS(KK+23)= QX(L+1)*QX(L+7)*2.#     Store r11*r13*2                  AD05 110
EQUPOS(KK+24)= QX(L+4)*QX(L+7)*2.#     Store r12*r13*2                  AD05 111
KK=KK+6#                               Incr equpos pointer              AD05 112
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AD05 113
KK=36#                                 Reset equpos pointer             AD05 114
DO II=1,2#                             Loop over u12, u13 rows          AD05 115
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AD05 116
L=J+II-1#                              Get symop pointer                AD05 117
EQUPOS(KK+1)=QX(J+1)*QX(L+2)#          Store r11*r21 ...                AD05 118
EQUPOS(KK+2)=QX(J+4)*QX(L+5)#          Store r12*r22 ...                AD05 119
EQUPOS(KK+3)=QX(J+7)*QX(L+8)#          Store r13*r23 ...                AD05 120
EQUPOS(KK+4)=QX(J+4)*QX(L+2)+QX(J+1)*QX(L+5)# Store r12*r21+r11*r22     AD05 121
EQUPOS(KK+5)=QX(J+7)*QX(L+2)+QX(J+1)*QX(L+8)# Store r13*r21+r11*r23     AD05 122
EQUPOS(KK+6)=QX(J+7)*QX(L+5)+QX(J+4)*QX(L+8)# Store r13*r22+r12*r23     AD05 123
KK=KK+6#                               Incr equpos pointer              AD05 124
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AD05 125
EQUPOS(49)=QX(J+2)*QX(J+3)#            Store r21*r31                    AD05 126
EQUPOS(50)=QX(J+5)*QX(J+6)#            Store r22*r32                    AD05 127
EQUPOS(51)=QX(J+8)*QX(J+9)#            Store r23*r33                    AD05 128
EQUPOS(52)=QX(J+3)*QX(J+5)+QX(J+2)*QX(J+6)# Store r31*r22+r21*32        AD05 129
EQUPOS(53)=QX(J+3)*QX(J+8)+QX(J+2)*QX(J+9)# Store r31*r23+r21*r33       AD05 130
EQUPOS(54)=QX(J+6)*QX(J+8)+QX(J+5)*QX(J+9)# Store r32*r23+r22*r33       AD05 131
#                                                                       AD05 132
#   SCAN MATRIX FOR CONSTRAINTS                                         AD05 133
#   ---------------------------                                         AD05 134
#                                                                       AD05 135
#     STATUS        MEANING                                             AD05 136
#      -1            REFINABLE WITH SITES CONSTRAINED TO IT             AD05 137
#       0            UNDETERMINED OR REFINABLE                          AD05 138
#       1            CONSTRAINED                                        AD05 139
#       2            CONSTRAINED OR INVARIANT DEPENDING REF PARAM.      AD05 140
#       3            INVARIANT                                          AD05 141
#                                                                       AD05 142
#     AFTER ALL PROCESSING ONLY STATUS 1 AND STATUS 3 CAN SURVIVE       AD05 143
#                                                                       AD05 144
DO II=1,9#                             Loop x,y,z,u11,...u23            AD05 145
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AD05 146
KK=(II-1)*6#                           Point to first row element       AD05 147
JREF=-1#                               Reset element pointer            AD05 148
LL=REFPNT(II);    DIAG=EQUPOS(LL)#     Point to diagonal element        AD05 149
DO JJ=1,6#                             Loop along row elements          AD05 150
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AD05 151
NN=KK+JJ#                              Point to equpos elements         AD05 152
IF(NN==LL) NEXT#                       Skip diagonal elements           AD05 153
ifeq:(EQUPOS(NN),0.) NEXT#             Skip zero elements               AD05 154
JREF=JJ#                               Save element pointer             AD05 155
BREAK#                                 And cease and desist             AD05 156
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AD05 157
#                                                                       AD05 158
IF(DIAG<(-small:) & JREF<0) STATUS(II)=3# Parameter invariant           AD05 159
#                                                                       AD05 160
ELSE IF(JREF<0) NEXT#                  Skip if no constraint            AD05 161
#                                                                       AD05 162
ELSE IF(DIAG<(-small:) & STATUS(II)<=1)# Reference parameter            AD05 163
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AD05 164
STATUS(II)=2;  PARSCL(II)=2.#          Set constrained flags            AD05 165
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AD05 166
#                                                                       AD05 167
ELSE IF(ABS(DIAG)<small: & STATUS(II)==1)# If diagonal at zero          AD05 168
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AD05 169
I=KK+JREF#                             Make the reference indirect      AD05 170
IF(EQUPOS(I)<(-small:))PARSCL(II)=EQUPOS(I)# If element negative        AD05 171
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AD05 172
ELSE IF(ABS(DIAG)<small: & STATUS(II)<1)# Diag element zero             AD05 173
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AD05 174
I=KK+JREF#                             Point to ref element             AD05 175
STATUS(II)=1#                          Set as constrained               AD05 176
PARSCL(II)=EQUPOS(I)#                  Store scale factor               AD05 177
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AD05 178
JREF=MAX0(JREF,1)#                     -1 means parameter 1             AD05 179
IF(II<=3) PARPNT(II)=JREF#             A positional parameter           AD05 180
ELSE      PARPNT(II)=JREF+3#           A thermal parameter              AD05 181
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AD05 182
100 CONTINUE#                          Branchpoint                      AD05 183
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AD05 184
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AD05 185
mult:(M)=1.0/AMATCH#                   Calculate site multiplicity      AD05 186
saveid:([mult:])#                      should always save
#                                                                       AD05 187
#    PROCESS SITE WITH STATUS 2                                         AD05 188
#    --------------------------                                         AD05 189
#                                                                       AD05 190
DO II=1,9#                             Loop over x,y,z,u11,.....u23     AD05 191
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AD05 192
IF(STATUS(II)!=2) NEXT#                Skip unless status 2             AD05 193
JJ=PARPNT(II)#                         Pick up the reference param      AD05 194
IF(STATUS(JJ)==1)#                     If 1 param is doubly depende     AD05 195
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AD05 196
KK=PARPNT(JJ)#                         Point to ref parameter           AD05 197
STATUS(KK)=1#                          Set parameter constrained        AD05 198
PARSCL(KK)=2.0#                        Set dependency as 2.0            AD05 199
PARPNT(KK)=II#                         Point to current parameter       AD05 200
STATUS(II)=1#                          Set parameter as constrained     AD05 201
PARSCL(II)=1.0#                        Set dependency as 1.             AD05 202
PARSCL(JJ)=2.0#                        Set dependency as 2.             AD05 203
PARPNT(JJ)=II#                         Set pointer to current           AD05 204
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AD05 205
ELSE IF(STATUS(JJ)<1)#                 Test if refinable                AD05 206
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AD05 207
STATUS(II)=1#                          Set as constrained               AD05 208
PARSCL(II)=1.0#                        Set dependency as 1.             AD05 209
STATUS(JJ)=1#                          Set parameter constrained        AD05 210
PARSCL(JJ)=2.0#                        Set dependency as 2.             AD05 211
PARPNT(JJ)=II#                         Point to current site            AD05 212
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AD05 213
ELSE STATUS(II)=3#                     If the reference parameter       AD05 214
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AD05 215
#                                                                       AD05 216
#   RESOLVE PARAMETER DEPENDENCIES                                      AD05 217
#   ------------------------------                                      AD05 218
#                                                                       AD05 219
DO II=1,9#                             Loop over x,y,z,u11,.....u23     AD05 220
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AD05 221
KK=PARPNT(II)#                         Pick up reference parameter      AD05 222
ifeq:(ABS(PARSCL(II)),1.)#             Test for dependency of 1.        AD05 223
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 AD05 224
IF(STATUS(KK)>=1)#                     Test if the reference param      AD05 225
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 AD05 226
JJ=PARPNT(KK)#                         Point to dependent site          AD05 227
IF(STATUS(JJ)>=0 & STATUS(KK)<3)#      Test parameter status            AD05 228
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 AD05 229
STATUS(II)=-1#                         Refinable with sites depende     AD05 230
PARPNT(KK)=II#                         Store site address               AD05 231
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 AD05 232
ELSE IF(STATUS(JJ)<0)#                 If refinable site                AD05 233
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 AD05 234
PARPNT(II)=PARPNT(KK)#                 Replace site pointer             AD05 235
PARSCL(II)=PARSCL(II)*PARSCL(KK)#      Change site dependency           AD05 236
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 AD05 237
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 AD05 238
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 AD05 239
#                                                                       AD05 240
ELSE ifeq:(ABS(PARSCL(II)),2.)#        If dependence scale is 2.        AD05 241
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 AD05 242
ifeq:(ABS(PARSCL(KK)),2.)#             If dependency scale is 2.        AD05 243
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 AD05 244
STATUS(II)=3;  STATUS(KK)=3#           If so both are invariant         AD05 245
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 AD05 246
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 AD05 247
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AD05 248
#                                                                       AD05 249
#    STORE CONSTRAINTS READY FOR LRCONS:                                AD05 250
#    -----------------------------------                                AD05 251
#                                                                       AD05 252
DO II=1,9#                             Loop over x,y,z,u11,...u23       AD05 253
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 AD05 254
IF(STATUS(II)<1) NEXT#                 Test if param is special         AD05 255
IF(STATUS(II)==3) PARSCL(II)=0#        For fixed param scale is zero    AD05 256
incrqx:(KK,STOPX+STEPX,AD0501)#        Get more core if needed          AD05 257
QX(STOPX+1)=FLOAT((M-MARKA)/STEPA+1)#  Store subject atom pointer       AD05 258
QX(STOPX+2)=FLOAT(II)#                 Store subject param number       AD05 259
QX(STOPX+3)=FLOAT(STATUS(II))#         Store subject status flag        AD05 260
QX(STOPX+4)=FLOAT(PARPNT(II))#         Store refer param pointer        AD05 261
QX(STOPX+5)=PARSCL(II)#                Store ref-sub param scale        AD05 262
QX(STOPX+6)=1.#                        Store factor                     AD05 263
QX(STOPX+7)=0.#                        Store default constant           AD05 264
IF(II<4)#                              For coordinates only             AD05 265
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 AD05 266
JJ=PARPNT(II)#                         Get parameter pointer            AD05 267
QX(STOPX+7)=X(II)-PARSCL(II)*X(JJ)#    Q constant                       AD05 268
#                                                                       AD05 269
# BUG FIX TO CATCH SPEC POS. PROBS IN P 21 3                            AD05 270
#                                                                       AD05 271
ZZZ=12.*QX(STOPX+7)#                   Convert fractions to integers    AD05 272
ifne:(ANINT(ZZZ),ZZZ,0.00005)#         If not a rational fraction       AD05 273
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 AD05 274
ZZZ=(X(II)+PARSCL(II)*X(JJ))#          Get alternate q constant         AD05 275
ifeq:(ANINT(ZZZ*12.),ZZZ*12.,0.00005)# Test if alternate is ok          AD05 276
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 AD05 277
QX(STOPX+7)=ZZZ#                       Store q constant                 AD05 278
QX(STOPX+5)=-QX(STOPX+5)#              Store ref-sub param scale        AD05 279
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 AD05 280
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 AD05 281
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 AD05 282
STOPX=KK#                              Update list pointer              AD05 283
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 AD05 284
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AD05 285
#                                                                       AD05 286
RETURN#                                                                 AD05 287
END#                                                                    AD05 288
systemheader:(AD06)#                   Put params in bdf & print        AD06   1
# ################################################################## #  AD06   2
#                                                                    #  AD06   3
#                               AD06                                 #  AD06   4
#                                                                    #  AD06   5
# ################################################################## #  AD06   6
SUBROUTINE AD06#                                                        AD06   7
include:(AACOMN)#                                                       AD06   8
include:(ADCOMN)#                                                       AD06   9
#                                                                       AD06  10
INTEGER I,J,K,M,II,IX,JPT#                                              AD06  11
INTEGER NATM#                                                           AD06  12
INTEGER PSIZ2#                                                          AD06  13
string:(CH,8)#                                                          AD06  14
chardata:(AD12," Number of atoms loaded                 ")#             AD06  15
chardata:(AD13," Parameters output to bdf  lab X Y Z U Pop sX sY sZ $#  AD06  16
sU sP dsN mul sfN dpN")#                                                AD06  17
chardata:(AD14,"                           U11 U22 U33 U12 U13 U23 $#   AD06  18
sU11 sU22 sU33 sU12 sU13 sU23")#                                        AD06  19
chardata:(AD15," X      Y      Z     U    Pop    sX     sY     sZ$#     AD06  20
    sU   sP  ds  mul sf dp")#                                           AD06  21
chardata:(AD16," U11   U22   U33   U12   U13   U23  sU11$#              AD06  22
  sU22  sU33  sU12  sU13  sU23")#                                       AD06  23
chardata:(AD20," Atoms Loaded-")#                                       AD06  24
realdata:(FMT2,[742.,742.,742.,632.,522.,742.,742.,742.,632.,522.,$#    AD06  25
313.,522.,313.,313.])#                                                  AD06  26
realdata:(FMT3,[632.,632.,632.,632.,632.,632.,632.,632.,632.,632.,$#    AD06  27
632.,632.])#                                                            AD06  28
datastuff:#                                                             AD06  29
#                                                                       AD06  30
#   PRINT ATOM PARAMETER SUMMARY                                        AD06  31
#   ----------------------------                                        AD06  32
#                                                                       AD06  33
ncodefld:(FLOAT(INATOM),1,AD12,400513.,1)# Format number of atoms       AD06  34
writeline:(0,AD12,NAD12,3,3)#          Number of atoms                  AD06  35
writeline:(0,AD13,NAD13,3,3)#          Print parameters                 AD06  36
IF(DPTYPE>1) writeline:(0,AD14,NAD14,3,3)# Print uij parameters         AD06  37
IF(PRINT==yes:)#                       If print requested               AD06  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AD06  39
movechar:(AD20,NAD20,CHROT,2,NAD20-2,1)# Insert underline               AD06  40
writeline:(1,AD20,NAD20-1,2,3)#        Write atom header data           AD06  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AD06  42
LINRM=6#                               Force space                      AD06  43
HEADOT=' '; HEADOT(LABMAX+8^)=AD15#    Insert header                    AD06  44
#                                                                       AD06  45
#  REDUCE OUTPUT LRATOM RECORD SIZE
#  --------------------------------
#                                                                       AD06  48
PSIZ=0
FOR(I=1;I<=STEPA;I=I+1)
$(
J=NINT(QX(STOPY+I))#                  Id number or 0
Do N=I,STEPA#                         loop over identical char items
if (NINT(QX(STOPY+N))!=ABS(J)) break# stop on different item
ELSE if(J<0) QX(STOPY+N)=0.0#         erase all same type items
IF(J>0)#                              Not explicitly deleted
$(
IF(NINT(QX(STOPY3+I))!=0) PSIZ=PSIZ+(N-I)# first item has data
ELSE DO J=I,N-1 ; QX(STOPY+J)=0.0#    Erase all of same type
$)
I=N-1
$)
#                                                              
#  BUILD OUTPUT LRATOM DIR HEADER
#  ------------------------------ 
#                                                               
writepkt:(2,lratom:,PSIZ,JPT)#         Point to new dir packet
K=1#
FOR(I=1;I<=STEPA;I=I+1)#               Populate with IDNUMS
IF(NINT(QX(STOPY+I))!=0)#              But only non zero idnums
$(
QX(JPT+K)=QX(STOPY+I)#                 store the idnum
K=K+1
$)
#                                                                       AD06  45
#  OUTPUT LRATOM PACKETS                                                AD06  46
#  ---------------------                                                AD06  47
#                                                                       AD06  48
DO I=1,NSFTOT;ACNTS(I)=0.0#            Initialise atom counts           AD06  49
CDENS=0.; NATM=0#                      Set up for special positions     AD06  50
FOR(IX=MARKA;IX<STOPA;IX=IX+STEPA)#    Loop over atom list              AD06  60
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AD06  61
writepkt:(2,lratom:,PSIZ,JPT)#         Point to next op packet          AD06  62
K=1#
FOR(I=1;I<=STEPA;I=I+1)
IF(NINT(QX(STOPY+I))!=0)
$(
movepakwd:(QX(IX+I),QX(JPT+K))# transfer
K=K+1
$)
#
J=NINT(scat:(IX))#                  Get s.f. type number       
ACNTS(J)=ACNTS(J)+   pop:(IX)*mult:(IX)# Count atoms of type
ifnv:(ATWTS(J))CDENS=CDENS+ATWTS(J)*pop:(IX)*mult:(IX)# Build density               AD06  68
IF(PRINT==no:) NEXT#                   Skip if no printout              AD06  69
#                                                                       AD06  70
#  PRINT ATOMS LIST                                                     AD06  71
#  ----------------                                                     AD06  72
#                                                                       AD06  73
NATM=NATM+1#                           Count number of atoms            AD06  74
movertoc:(na:(IX),1,CHROT,2,24,0)#     Store atom label      
LCHROT=LABMAX+4#                       Set format pointer               AD06  76
DO I=1,3;BUFOT(0+I) = xif:(IX,I)
BUFOT(4) = uis:(IX)
BUFOT(5) = pop:(IX)
DO I=1,3;BUFOT(5+I) =sxif:(IX,I)
BUFOT(9) =suis:(IX)
BUFOT(10)=spop:(IX)
BUFOT(11)=dset:(IX)
BUFOT(12)=mult:(IX)
BUFOT(13)=scat:(IX)
BUFOT(14)= adp:(IX)
ncodefld:(BUFOT,1,CHROT,FMT2,14)#       Format atom data      
FOR(II=MARKX;II<STOPX;II=II+STEPX)#    Loop over spec posn info         AD06  78
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AD06  79
IF(NINT(QX(II+1))!=NATM) NEXT#         Test if special constraints      AD06  80
DO I=1,3#                              Loop over x,y,z spec. pos.       AD06  81
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AD06  82
IF(NINT(QX(II+2))!=I) NEXT#            Skip until parameter match       AD06  83
CALL AD08(IX,II,CH)#                   Format special position          AD06  84
movechar:(CH,2,CHROT,I*7+LABMAX-2,7,0)# Insert special format           AD06  85
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AD06  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AD06  87
writeline:(0,HEADOT,100,1,3)#          Print parameter heading          AD06  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AD06  89
#                                                                       AD06  90
#  PRINT UIJ'S SEPARATELY                                               AD06  91
#  ----------------------                                               AD06  92
#                                                                       AD06  93
IF(PRINT==yes:&DPTYPE>1)#              Print aniso parameters           AD06  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AD06  95
writeline:(0,0,0,1,3)#                 Insert spacer                    AD06  96
LINRM=6;  NATM=0#                      Set up for special positions     AD06  97
HEADOT=' '; HEADOT(LABMAX+7^)=AD16#    Insert header                    AD06  98
FOR(IX=MARKA;IX<STOPA;IX=IX+STEPA)#    Loop over atom list              AD06  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AD06 100
NATM=NATM+1#                           Count number of atoms            AD06 101
if(NINT(adp:(IX))!=2) NEXT#            Skip if not aniso
movertoc:(na:(IX),1,CHROT,2,24,0)#     Store atom label                 AD06 103
LCHROT=LABMAX+4#                       Set format pointer               AD06 104
DO I=1,6;$(BUFOT(I)=uij:(IX,I);BUFOT(6+I)=suij:(IX,I)$)#
ncodefld:(BUFOT,1,CHROT,FMT3,12)#      Format atom data      
FOR(II=MARKX;II<STOPX;II=II+STEPX)#    Loop over spec posn info         AD06 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AD06 107
IF(NINT(QX(II+1))!=NATM) NEXT#         Test if special constraints      AD06 108
DO I=4,9#                              Loop over uij's                  AD06 109
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AD06 110
IF(NINT(QX(II+2))!=I) NEXT#            Skip until parameter match       AD06 111
CALL AD08(IX,II,CH)#                   Format special position          AD06 112
movechar:(CH,2,CHROT,(I-3)*6+LABMAX,5,0)# Insert special format         AD06 113
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AD06 114
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AD06 115
writeline:(0,HEADOT,100,1,3)#          Print parameter heading          AD06 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AD06 117
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AD06 118
#                                                                       AD06 119
RETURN#                                                                 AD06 120
END#                                                                    AD06 121
systemheader:(AD07)#                   Output constraints to bdf        AD07   1
# ################################################################## #  AD07   2
#                                                                    #  AD07   3
#                               AD07                                 #  AD07   4
#                                                                    #  AD07   5
# ################################################################## #  AD07   6
SUBROUTINE AD07#                                                        AD07   7
include:(AACOMN)#                                                       AD07   8
include:(ADCOMN)#                                                       AD07   9
#                                                                       AD07  10
#    AT THIS POINT, IF THERE ARE ATOMS IN SPECIAL POSITIONS, THE        AD07  11
# RESTRICTIONS MUST BE WRITTEN INTO LRCONS:.  THEY WILL BE WRITTEN      AD07  12
# ON A ONE PARAMETER PER PACKET BASIS, REPEATING THE ATOM IDENT         AD07  13
# OVER AND OVER AS REQUIRED.  THE STRUCTURE OF THE PACKETS IS.....      AD07  14
#                                                                       AD07  15
#  PACKET INDEX   CONTENTS                                              AD07  16
#        1        LABEL OF ATOM WITH RESTRICTIONS                       AD07  17
#        2        POINTER TO RESTRICTED PARAMETER AS 1 - 9 FOR X - U23  AD07  18
#        3        MULTIPLICATION FACTOR FOR UNRESTRICTED PARAMETER AS   AD07  19
#                 SPECIFIED FOR GENERAL EQUATION SHOWN IN PROGRAMMERS   AD07  20
#                 MANUAL FOR LRCONS:   SET TO 1.0 IN THIS PROGRAM.      AD07  21
#        4        ADDITION FACTOR AS PER LRCONS:  SET TO 0.0 HERE.      AD07  22
#        5        NATURE OF THE RESTRICTION 1 = CONSTRAINED; 3= FIXED   AD07  23
#       11        LABEL OF ATOM WITH UNRESTRICTED PARAMETER.            AD07  24
#                 IN THIS PROGRAM, BECAUSE OF THE NATURE                AD07  25
#                 OF SPECIAL POSITIONS, IT WILL ALWAYS BE THE SAME AS   AD07  26
#                 WORDS OF PACKET INDEX 1.                              AD07  27
#       12        POINTER TO THE UNRESTRICTED PARAMETER WHICH GOVERNS   AD07  28
#                 THE VALUE OF THE RESTRICTED PARAMETER.                AD07  29
#       13        MULTIPLIER TO CONVERT THE UNRESTRICTED PARAMETER      AD07  30
#                 INTO THE RESTRICTED ONE. 4 AND 5 ONLY APPLY WHEN 3 IS AD07  31
#                                                                       AD07  32
#    THE INFORMATION WHICH IS STANDING IN CORE IS IN THE MARKX ARRAY    AD07  33
#                                                                       AD07  34
#    MARKX   CONTENTS                                                   AD07  35
#    +1      MARKA POINTER TO ATOM LABEL TO WHICH RESTRICTION APPLIES.  AD07  36
#    +2      POINTER TO RESTRICTED PARAMETER.                           AD07  37
#    +3      NATURE OF RESTRICTION AS 1=CONSTRAINED; 3=FIXED.           AD07  38
#    +4      POINTER TO THE UNRESTRICTED PARAMETER.                     AD07  39
#    +5      MULTIPLICATION FACTOR TO CONVERT THE UNRESTRICTED          AD07  40
#            PARAMETER INTO THE RESTRICTED ONE.                         AD07  41
#                                                                       AD07  42
INTEGER I,K,KK,J#                      Little indices for pointing      AD07  43
INTEGER JPT#                           Packet pointer for write         AD07  44
INTEGER PKSIZE#                        Lrcons: packet size              AD07  45
INTEGER IX#                                                             AD07  46
REAL    PAKHED(20)#                    Lrcons: packet header packet     AD07  47
#                                                                       AD07  48
chardata:(AD1," Density calc. from input atoms         ")#              AD07  49
chardata:(AD2," Density calc. from celcon data         ")#              AD07  50
chardata:(AD3," Density obs. from experimental         ")#              AD07  51
chardata:(AD4," Space group axis A is polar")#                          AD07  52
chardata:(AD5,ABC)#                                                     AD07  53
realdata:(PAKNUM,[2.,5.,12.,13.,3.,4.])#                                AD07  54
datastuff:#                                                             AD07  55
#                                                                       AD07  56
#   PROCESS DENSITIES                                                   AD07  57
#   -----------------                                                   AD07  58
#                                                                       AD07  59
TDENS=0.0#                             Set up to calc theor.dens.       AD07  60
DO J=1,NSFTOT#                         Accumulate masses   
ifnv:(ATWTS(J))TDENS=TDENS+ATWTS(J)*TATOMS(J)# Accumulate masses        AD07  61
TDENS=(TDENS/CVOL)*1.6603#             Scale to g/cc                    AD07  62
CDENS=(CDENS/CVOL)*1.6603*SYMFAC#      Scale current to g/cc            AD07  63
ncodefld:(CDENS,1,AD1,400832.,1)#      Current density                  AD07  64
writeline:(2,AD1,NAD1,3,3)#            Current density                  AD07  65
ncodefld:(TDENS,1,AD2,400832.,1)#      Celcon density                   AD07  66
writeline:(0,AD2,NAD2,3,3)#            Celcon density                   AD07  67
ncodefld:(ODENS,1,AD3,400832.,1)#      Observed density                 AD07  68
IF(ODENS>0.) writeline:(0,AD3,NAD3,3,3)# Observed density               AD07  69
#                                                                       AD07  70
#   OUTPUT LRCONS: DIRECTORY                                            AD07  71
#   ------------------------                                            AD07  72
#                                                                       AD07  73
copyfile:(1,2,incr:(lratom:),decr:(lrcons:))# Copy between              AD07  74
IF(STOPX>MARKX\POLSPG(1)==1\POLSPG(2)==1\POLSPG(3)==1)# If needed       AD07  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AD07  76
DO I=1,mxwd24:; PAKHED(I       )=1.0#     Subject atom                     AD07  77
DO I=1,mxwd24:; PAKHED(I+mxwd24:  )=11.0#    Atom to which it is related      AD07  78
DO I=1,6;    PAKHED(I+mxwd24:*2)=PAKNUM(I)# Put away the index numbers     AD07  79
PKSIZE=2*mxwd24:+6#                       Start count of packet size       AD07  80
writepkt:(2,lrcons:,PKSIZE,JPT)#       Get a packet pointer             AD07  81
movereal:(PAKHED,1,QX,JPT+1,PKSIZE,0)# Store directory                  AD07  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AD07  83
#                                                                       AD07  84
#    OUTPUT CONSTRAINTS TO LRCONS:                                      AD07  85
#    -----------------------------                                      AD07  86
#                                                                       AD07  87
FOR(J=MARKX;J<STOPX;J=J+STEPX)#        Loop over all spec pos info      AD07  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AD07  89
writepkt:(2,lrcons:,PKSIZE,JPT)#       Get spec pos packet              AD07  90
K=JPT+2*mxwd24:#                          Point beyond atom names    
movereal:(QX,J+2,QX,K+1,6,1)#          Move the restriction informa     AD07  92
IX=MARKA+NINT(QX(J+1)-1.)*STEPA#       Point to atom list               AD07  93
movereal:(na:(IX),1,QX,JPT+1     ,mxwd24:,1)# Move atom label         
movereal:(na:(IX),1,QX,JPT+1+mxwd24:,mxwd24:,1)# Move second atom name 
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AD07  96
#                                                                       AD07  97
#    OUTPUT POLAR AXIS CONSTRAINTS                                      AD07  98
#    -----------------------------                                      AD07  99
#                                                                       AD07 100
IF(ICENT==1)#                          Test for noncentrosymmetric      AD07 101
DO K=1,3#                              Loop over a, b, and c            AD07 102
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AD07 103
IF(POLSPG(K)!=1) NEXT#                 If it is one it is polar         AD07 104
writepkt:(2,lrcons:,PKSIZE,JPT)#       Write another packet             AD07 105
DO I=1,PKSIZE; QX(JPT+I)=0.#           Zero the packet                  AD07 106
movector:(BLANK,1,QX(JPT+1     ),1,24,1)# Put blanks for name           AD07 107
movector:(BLANK,1,QX(JPT+mxwd24:+1),1,24,1)# Blanks again       
KK=JPT+mxwd24:*2#                         And jump again         
QX(KK+1)=FLOAT(K)#                     Set axis for parameter           AD07 110
QX(KK+2)=4.0#                          Set polar axis signal            AD07 111
movechar:(AD5,K,AD4,19,1,0)#           Move axis symbol                 AD07 112
writeline:(1,AD4,NAD4,3,3)#            Tell about polar axis            AD07 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AD07 114
RETURN#                                                                 AD07 115
END#                                                                    AD07 116
systemheader:(AD08)#                   Format the constraints           AD08   1
# ################################################################## #  AD08   2
#                                                                    #  AD08   3
#                               AD08                                 #  AD08   4
#                                                                    #  AD08   5
# ################################################################## #  AD08   6
SUBROUTINE AD08(IX,II,CH)#                                              AD08   7
include:(AACOMN)#                                                       AD08   8
include:(ADCOMN)#                                                       AD08   9
#                                                                       AD08  10
string:(CH,8)#                                                          AD08  11
REAL A,B#                                                               AD08  12
INTEGER IX,II,I,J,K#                                                    AD08  13
INTEGER IPAR#                                                           AD08  14
chardata:(AD01," warning: Input parameter PPP NNNNNNNNNNNNNNNN $#       AD08  15
does not match constraints")#                                           AD08  16
chardata:(AD15,  0   1/24 1/12 1/8  1/6  5/24 1/4  7/24 1/3  3/8 $#     AD08  17
 5/1211/24 1/2 13/24 7/12 5/8  2/3 17/24 3/4 19/24 5/6  7/8 11/12$#     AD08  18
23/24  1  25/2413/12 9/8  7/6 29/24 5/4 31/24 4/3  11/817/1235/24$#     AD08  19
 3/2 37/2419/12 13/8 5/3 41/24 7/4 43/24 11/6 15/823/1247/24  2  )#     AD08  20
chardata:(AD17,X  Y  Z  U11U22U33U12U13U23)#                            AD08  21
datastuff:#                                                             AD08  22
#                                                                       AD08  23
CH=' '#                                Blank the spec pos buffer        AD08  24
IPAR=NINT(QX(II+2))#                   Pick up the parameter            AD08  25
#                                                                       AD08  26
#    TEST IF INPUT PARAMETER MATCHES CONSTRAINT                         AD08  27
#    ------------------------------------------                         AD08  28
#                                                                       AD08  29
IF(QX(II+3)<2.0)#                      Is this related parameter        AD08  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AD08  31
K=NINT(QX(II+4)); I=IPAR;  J=K#        Find reference parameter         AD08  32
IF(IPAR>3) $(A= uij:(IX,I-3); B=uij:(IX,J-3)$)
ELSE       $(A= xif:(IX,I  ); B=xif:(IX,J  )$)
A=MOD(A+10.,1.)#                       Reduce param to +modulo 1.  
B=MOD(B*QX(II+5)+QX(II+7)+10.,1.)#     Constr +mod 1.          
ifne:(A,B,0.0001)#                     These should be equal            AD08  36
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AD08  37
movechar:(AD17,IPAR*3-2,AD01,27,3,0)#  Insert parameter type            AD08  38
movertoc:(na:(IX),1,AD01,31,16,0)#     Insert atom label                AD08  39
writeline:(1,AD01,NAD01,2,3)#          Print warning message            AD08  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AD08  41
#                                                                       AD08  42
#    PREPARE CONSTRAINT DATA FOR OUTPUT                                 AD08  43
#    ----------------------------------                                 AD08  44
#                                                                       AD08  45
movechar:(AD17,K*3-2,CH,4,3,0)#        Insert ref param chrs 'x' etc    AD08  46
IF(ABS(QX(II+5))>1.0)#                 If /multiplier/ > 2. insert      AD08  47
ncodefld:(QX(II+5),1,CH,30213.,1)#     Format spec. posn.               AD08  48
ELSE IF(QX(II+5)<0.0) CH(3^3)='-'#     Check for -1. multiplier         AD08  49
ELSE IF(QX(II+5)>0.&QX(II+5)<1.)#      Positive decimal                 AD08  50
ncodefld:(QX(II+5),1,CH,30212.,1)#     Format value                     AD08  51
ifne:(QX(II+7),0.)#                    Constant is not zero             AD08  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AD08  53
K=NINT(ABS(QX(II+7))*24.)#             Convert to base 24               AD08  54
movechar:(AD15,K*5+2,CH,6,3,0)#        Insert fraction                  AD08  55
IF(QX(II+7)>.1) CH(5^5)='+'#           Inset + fraction                 AD08  56
ELSE            CH(5^5)='-'#           Inset - fraction                 AD08  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AD08  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AD08  59
ELSE#                                  Make fixed values fractions      AD08  60
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AD08  61
IF(IPAR>3) A= uij:(IX,IPAR-3)
ELSE       A= xif:(IX,IPAR  )
K=NINT(ABS(A)*24.)#                    Convert to base 24               AD08  62
movechar:(AD15,K*5+1,CH,3,5,0)#        Insert fraction                  AD08  63
IF(A<0.) CH(2^2)='-'#                  Insert if negative value   
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AD08  65
#                                                                       AD08  66
RETURN#                                                                 AD08  67
END#                                                                    AD08  68
systemheader:(AD09)#                   Rentrant streamer to sx          AD09   1
# ################################################################## #  AD09   2
#                                                                    #  AD09   3
#                               AD09                                 #  AD09   4
#                                                                    #  AD09   5
# ################################################################## #  AD09   6
SUBROUTINE AD09#                                                        AD09   7
include:(AACOMN)#                                                       AD09   8
include:(ADCOMN)#                                                       AD09   9
string:(LINE,80)#                                                       AD09  10
#                                                                       AD09  11
#     OUTPUT STARTX LINE AND FORCE EXECUTION                            AD09  12
#     ---------------------------------------                           AD09  13
#                                                                       AD09  14
IF(INVERT==2)#                         Here goes                        AD09  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AD09  16
FILEXT(iofm1:)='sxi'#                  Define fmt as atom line file     AD09  17
openfmt:(iofm1:,' ')#                  Open line file                   AD09  18
LINE='STARTX UPD'#                     Reset line buffer                AD09  19
writefmt:(iofm1:,'(A)',LINE(1^10))#    Write startx header to file      AD09  20
IF((CHRIN(1^4)!='END ')&(CHREOF!=1))#  If next input line is not end    AD09  21
#                                      And not an eof                   AD09  22
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AD09  23
LINFLG=1; LINE=CHRIP#                  Ensure this line not lost        AD09  24
writefmt:(iofm1:,'(A)',LINE(1^44))#    Write header to file             AD09  25
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AD09  26
closefmt:(iofm1:)#                     Shut down the line file          AD09  27
linestream:('sxi')#                    Insert lines into line stream    AD09  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AD09  29
#                                                                       AD09  30
RETURN#                                                                 AD09  31
END#                                                                    AD09  32
systemheader:(AD10)#                   Update lrmole                    AD10   1
# ################################################################## #  AD10   2
#                                                                    #  AD10   3
#                               AD10                                 #  AD10   4
#                                                                    #  AD10   5
# ################################################################## #  AD10   6
SUBROUTINE AD10#                                                        AD10   7
include:(AACOMN)#                                                       AD10   8
include:(ADCOMN)#                                                       AD10   9
#                                                                       AD10  10
macro:(w72c:,incr:(arith:(71,/,mxchwd:)))#                              AD10  11
macro:(pre:,3)#                        Fractional component precision   AD10  12
#                                                                       AD10  13
INTEGER IWANT(104)#                                                     AD10  14
INTEGER IREL(105)#                                                      AD10  15
INTEGER KEY(4)#                                                         AD10  16
INTEGER ADDED,I,J,K,PNT(2),PNT1,NAMLEN#                                 AD10  17
INTEGER II,JJ,I1,I2,J1,J2,NLEN#                                         AD10  18
INTEGER PRECIS#                                                         AD10  19
INTEGER ALORD(16)#                     Alphabetical atom type list      AD10  20
INTEGER IP,IPP#                                                         AD10  21
REAL    VAL,NVAL,UNITS,DPNT#           Ad10                             AD10  22
REAL    PRE,FMT#                                                        AD10  23
REAL MLWGHT(2)#                                                         AD10  24
string:(FORSUM(2),72)#                                                  AD10  25
string:(UPSF,128)#                                                      AD10  26
chardata:(AD1," Z molecules per cell - CELMOL          ")#              AD10  27
chardata:(AD2," Chemical formula weight STARTX         ")#              AD10  28
chardata:(AD3," Chemical formula sum    STARTX          $#              AD10  29
                                       ")#                              AD10  30
chardata:(AD4," Chemical formula weight ADDATM         ")#              AD10  31
chardata:(AD5," Chemical formula sum    ADDATM          $#              AD10  32
                                       ")#                              AD10  33
chardata:(ALST," ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789+-")#              AD10  34
datastuff:#                                                             AD10  35
##                                                                      AD10  36
copyfile:(1,2,incr:(lrcons:),decr:(lrmole:))# Copy all the rest of bd   AD10  37
#                                                                       AD10  38
upcase:(SFNAME,UPSF,128)#              Convert to upper case            AD10  39
DO I=1,NSFTOT;ALORD(I)=I#              The nonalphabetic input order    AD10  40
K=1#                                                                    AD10  41
DO I=1,NSFTOT#                         Search for c types               AD10  42
IF('C '==UPSF(I*8-7^I*8-6))#           Found c atom type                AD10  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AD10  44
ALORD(1)=I;ALORD(I)=1;K=K+1;BREAK#     Put c first and shift first ou   AD10  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AD10  46
DO II=1,NSFTOT#                        Search for h type                AD10  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AD10  48
I=ALORD(II)#                                                            AD10  49
IF('H '==UPSF(I*8-7^I*8-6))#           Found h atom type                AD10  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AD10  51
I=ALORD(2);ALORD(2)=ALORD(II);ALORD(II)=I;K=K+1;BREAK# Put h 2nd        AD10  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AD10  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AD10  54
IF(K<3)K=1#                                                             AD10  55
#                                                                       AD10  56
DO II=K,NSFTOT-1#                      Sort the rest into alphabetic    AD10  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AD10  58
K=II#                                  Initialize the lowest pointer    AD10  59
I=ALORD(II)#                           Get next type in sequence        AD10  60
I1=INDEX(ALST,UPSF(I*8-7^I*8-7))#      Get first char pointer           AD10  61
I2=INDEX(ALST,UPSF(I*8-6^I*8-6))#      Get seond char pointer           AD10  62
DO JJ=II+1,NSFTOT#                     Loop for smallest residual ele   AD10  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AD10  64
J=ALORD(JJ)#                           Get indexed sequence             AD10  65
J1=INDEX(ALST,UPSF(J*8-7^J*8-7))#      Get first char pointer           AD10  66
J2=INDEX(ALST,UPSF(J*8-6^J*8-6))#      Get second char pointer          AD10  67
IF(J1>I1\ (J1==I1 &J2>=I2))NEXT#       Same or out of order             AD10  68
K=JJ;I1=J1;I2=J2#                      Save pointers to lowest          AD10  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AD10  70
IF(K==II)NEXT#                         Already in sequence              AD10  71
I=ALORD(II);ALORD(II)=ALORD(K);ALORD(K)=I# Swap the order               AD10  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AD10  73
#                                                                       AD10  74
PRE=10.**(-pre:)#                      Precision                        AD10  75
DO K=1,2#                              Loop for startx and addatm ato   AD10  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AD10  77
DO I=1,72;FORSUM(K)(I^I)=' '#          Initialise startx formula sum    AD10  78
PNT(K)=1#                              Index to forsum string           AD10  79
MLWGHT(K)=0.0#                         Initialize startx molecular we   AD10  80
DO II=1,NSFTOT#                        Cycle over all atom types        AD10  81
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AD10  82
I=ALORD(II)#                           Get sequence report order        AD10  83
ifvo:(ATWTS(I))     NEXT#              dummy site. skip
ifeq:(ATWTS(I),0.0) NEXT#              dummy site. skip
IF (K==1)VAL=TATOMS(I)/ZMOLES#         Startx atom count value          AD10  84
ELSE     VAL=ACNTS(I)*SYMFAC/ZMOLES#   Addatm atom count value          AD10  85
MLWGHT(K)=MLWGHT(K)+VAL*ATWTS(I)#      Accumulate the molecular weigh   AD10  86
IF(VAL<PRE)NEXT#                       0 atoms of this type -skip       AD10  87
NVAL=VAL/PRE#                          Calculate new value              AD10  88
DPNT=1.0#                              Assume decimal point required    AD10  89
DO PRECIS=pre:+1,1,-1#                 Cycle through precisions         AD10  90
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AD10  91
ifne:(NVAL,FLOAT(NINT(NVAL)),0.09999) BREAK# Nval is not integral       AD10  92
NVAL=NVAL/10.#                         Decrease nval by factor of 10    AD10  93
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AD10  94
IF(PRECIS==0)DPNT=0.0#                 No dp required as integral       AD10  95
IF(VAL<1.0) UNITS=0.#                  No unit places to consider       AD10  96
ELSE UNITS=1.+ AINT(LOG10(VAL))#       Calc num of unit digits          AD10  97
NLEN=UNITS+DPNT+FLOAT(PRECIS)#         Length of encoded number         AD10  98
IF(PRECIS==0) FMT=UNITS*100.+UNITS*10+3.# Format integers               AD10  99
ELSE   FMT=NLEN*100.+FLOAT(PRECIS)*10+2.# Format decimals               AD10 100
#                                                                       AD10 101
PNT1=I*8-7#                            Pointer to sfname                AD10 102
DO J=PNT1,PNT1+7; IF(SFNAME(J^J)==' ') BREAK#                           AD10 103
NAMLEN=J-PNT1#                         Length of name in table          AD10 104
FORSUM(K)(PNT(K)^PNT(K)+NAMLEN)=SFNAME(PNT1^PNT1+7)# Copy atom type     AD10 105
PNT(K)=PNT(K)+NAMLEN+NLEN+1#                                            AD10 106
FMT=FMT+ FLOAT(PNT(K)-2)*10000.#                                        AD10 107
ncodefld:(VAL,1,FORSUM(K),FMT,1)#                                       AD10 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AD10 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AD10 110
#                                                                       AD10 111
#                                                                       AD10 112
IWANT(1)=1#                            Data set number                  AD10 113
IWANT(2)=12#                           Molecular formula mass           AD10 114
IWANT(3)=13#                           Formula units per cell z         AD10 115
DO I=1,w72c:;IWANT(3+I)=11#            Get space for 72 characters  ^   AD10 116
DO I=1,w72c:;IWANT(3+I+w72c:)=10#      Get space for 72 characters      AD10 117
KEY(1)=0;KEY(2)=0;KEY(3)=3+2*w72c:;KEY(4)=0# Set search keys            AD10 118
indexpkt:(1,lrmole:,PSIZ,IP,2,KEY,IWANT,IREL)# Get pointers             AD10 119
IF(IP<=0\KEY(4)<=0)#                   If lrmole: record missing        AD10 120
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AD10 121
# AT THIS POINT PSIZ==0 AND IREL(1..N)==0 AND KEY(4)==0                 AD10 122
PSIZ=3+2*w72c:#                        Set op buffer record length      AD10 123
writepkt:(2,lrmole:,PSIZ,IPP)#         Get op buffer pointer            AD10 124
DO I=1,3+2*w72c:;QX(IPP+I)=FLOAT(IWANT(I))# Store directory packet      AD10 125
writepkt:(2,lrmole:,PSIZ,IPP)#         Get op buffer pointer            AD10 126
QX(IPP+1)=FLOAT(DSETN)#                Install data set number          AD10 127
QX(IPP+2)=MLWGHT(2)#                   Molecular formula mass           AD10 128
QX(IPP+3)=ZMOLES#                      Formula units per cell z         AD10 129
movector:(FORSUM(2),1,QX(IPP+4),1,72,0)# Copy formula sum string        AD10 130
I=IPP+4+w72c:#                         Point to first word              AD10 131
movector:(FORSUM(1),1,QX(I),1,72,0)#   Copy formula sum                 AD10 132
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AD10 133
#                                                                       AD10 134
ELSE#                                  Lrmole: record allready exists   AD10 135
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AD10 136
ADDED=no:#                             Initialise flag                  AD10 137
REPEAT#                                Loop for all data set packets    AD10 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AD10 139
readwpkt:(1,lrmole:,PSIZ,IP,2)#        Read the input packet            AD10 140
IF(IP<=0)BREAK#                        Hit end of directory             AD10 141
writepkt:(2,lrmole:,KEY(4),IPP)#       Prepare for new packet           AD10 142
## this only works because PSIZ refers to the original packet           AD10 143
movereal:(voidflg:,1,QX,IPP+1,KEY(4),2)# Set all to void                AD10 144
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Move the existing stuff          AD10 145
K=IPP+IREL(1)#                         Find dataset pointer             AD10 146
ifnv:(QX(K))IF(NINT(QX(K))!=0)#        No dataset number                AD10 147
IF(DSETN!=NINT(QX(K))) NEXT#           Test correct data set            AD10 148
QX(IPP+IREL(1))=FLOAT(DSETN)#          Install data set number          AD10 149
QX(IPP+IREL(2))=MLWGHT(2)#             Molecular formula mass           AD10 150
QX(IPP+IREL(3))=ZMOLES#                Formula units per cell z         AD10 151
movector:(FORSUM(2),1,QX(IPP+IREL(4)),1,72,0)# Copy formula sum strin   AD10 152
I=IPP+IREL(4+w72c:)#                   Point to location                AD10 153
movector:(FORSUM(1),1,QX(I),1,72,0)#   Copy formula sum                 AD10 154
ADDED=yes:#                                                             AD10 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AD10 156
IF(ADDED==no:)#                        Append the data set at rec end   AD10 157
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AD10 158
writepkt:(2,lrmole:,PSIZ,IPP)#         Get op buffer pointer            AD10 159
QX(IPP+IREL(1))=FLOAT(DSETN)#          Install data set number          AD10 160
QX(IPP+IREL(2))=MLWGHT(2)#             Molecular formula mass           AD10 161
QX(IPP+IREL(3))=ZMOLES#                Formula units per cell z         AD10 162
movector:(FORSUM(2),1,QX(IPP+IREL(4)),1,72,0)# Copy formula sum strin   AD10 163
I=IPP+IREL(4+w72c:)#                   Point to location                AD10 164
movector:(FORSUM(1),1,QX(I),1,72,0)#   Copy formula sum                 AD10 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AD10 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AD10 167
#                                                                       AD10 168
ifeq:(ZMOLES,FLOAT(NINT(ZMOLES)))FMT=400813.# Assumed integral          AD10 169
ELSE FMT=400832.#                      Might be fractional              AD10 170
ncodefld:(ZMOLES,1,AD1,FMT,1)#         Number of moles per cell         AD10 171
writeline:(1,AD1,NAD1,3,3)#            Number of moles per cell         AD10 172
ncodefld:(MLWGHT(1),1,AD2,400832.,1)#  Startx molecular formula mass    AD10 173
writeline:(0,AD2,NAD2,3,3)#            Molecular formula mass           AD10 174
AD3(41^80)=FORSUM(1)(1^40)#            Startx encode the formula sum    AD10 175
writeline:(0,AD3,NAD3,3,3)#            Formula sum string               AD10 176
ncodefld:(MLWGHT(2),1,AD4,400832.,1)#  Addatm molecular formula mass    AD10 177
writeline:(0,AD4,NAD4,3,3)#            Molecular formula mass           AD10 178
AD5(41^80)=FORSUM(2)(1^40)#            Addatm encode the formula sum    AD10 179
writeline:(0,AD5,NAD5,3,3)#            Formula sum string               AD10 180
#                                                                       AD10 181
copyfile:(1,2,incr:(lrmole:),endrecord:)# Copy all the rest of the bd   AD10 182
#                                                                       AD10 183
RETURN#                                                                 AD10 184
END#                                                                    AD10 185
pmacro:([no:])#                        Purge xtal system macros         AD10 186
