systemheader:(AL    )#                                                  AL     1
######################################################################  AL     2
#                                                                    #  AL     3
#                         *** ADDMUL ***                             #  AL     4
#                                                                    #  AL     5
#   PROGRAM FOR READING XENGEN PRODUCED MULIST FILE                  #  AL     6
#                       KEITH D. WATENPAUGH                          #  AL     7
#                                                                    #  AL     8
######################################################################  AL     9
#                                                                       AL    10
include:(XMACRO)#                                                       AL    11
#                                                                       AL    12
systemheader:(AL00)#                   Convert the input file           AL00   1
######################################################################  AL00   2
#                                                                    #  AL00   3
#                             AL00                                   #  AL00   4
#                                                                    #  AL00   5
######################################################################  AL00   6
SUBROUTINE AL00#                       K.d.w. august,  89               AL00   7
include:(AACOMN)#                                                       AL00   8
#                                                                       AL00   9
INTEGER ACENT#                                                          AL00  10
INTEGER JP#                                                             AL00  11
INTEGER MEAN,BOTH,PLUS,MINUS#                                           AL00  12
INTEGER I,J#                                                            AL00  13
INTEGER ITRF#                          Transform h,k,l                  AL00  14
INTEGER SEPPKT#                        Friedel in separate  packets     AL00  15
INTEGER SWITCH#                        Switch friedel mates             AL00  16
INTEGER PASS#                                                           AL00  17
INTEGER WANT(8),NWANT#                                                  AL00  18
REAL AHKL(4)#                          Hkl and sin(t)/l for current     AL00  19
REAL ALIMIT(5)#                        Hkl and sint/l limits            AL00  20
REAL DATUM(8)#                                                          AL00  21
REAL DATMIN(8)#                                                         AL00  22
REAL DATMAX(8)#                                                         AL00  23
REAL MAXHKL(4),MINHKL(4)#              Max/min hkl and sin(t)/l         AL00  24
REAL NDATUM(6)#                                                         AL00  25
REAL DELF,DELS#                                                         AL00  26
REAL REFIN, REFOUT#                                                     AL00  27
REAL TM(9)#                                                             AL00  28
#                                                                       AL00  29
chardata:(AL0, END    MAXHKL REJECT RCODE  TRANSF DELETE )#             AL00  30
chardata:(AL01,F  F2 ME PL MI BO PA SE SW )#                            AL00  31
chardata:(AL02,[ F(SQUARE) WILL BE EXTRACTED FROM MULIST DATA])#        AL00  32
chardata:(AL03, F VALUES WILL BE EXTRACTED FROM MULIST DATA)#           AL00  33
chardata:(AL04, MEAN VALUES WILL BE EXTRACTED)#                         AL00  34
chardata:(AL05, POSITIVE FRIEDEL REFLECTION WILL BE EXTRACTED)#         AL00  35
chardata:(AL06, NEGATIVE FRIEDEL REFLECTION WILL BE EXTRACTED)#         AL00  36
chardata:(AL07, FRIEDEL MATES WILL BE EXTRACTED)#                       AL00  37
chardata:(AL08, LRREFL OUTPUT ITEMS)#                                   AL00  38
chardata:(AL09,[ HKLSNTLF2RLSGF2FRELSIGFRCOD$#                          AL00  39
F2FRSF2FFFRISFFRRCDF])#                                                 AL00  40
chardata:(AL10, REFLECTIONS LESS THEN        *SIGMA CODED UNOBSERVED)#  AL00  41
chardata:(AL11, FRIEDEL REFLECTIONS STORED IN SAME PACKET)#             AL00  42
chardata:(AL12, FRIEDEL REFLECTIONS STORED IN SEPARATE PACKETS)#        AL00  43
chardata:(AL13, TRANSFORMATION FOR INDICES)#                            AL00  44
chardata:(AL14, FRIEDEL MATES WILL BE SWITCHED)#                        AL00  45
chardata:(AL15, REFLECTION LESS THEN          MAGNITUDE DELETED)#       AL00  46
chardata:(AL16, REFLECTION LESS THEN         *SIGMA DELETED)#           AL00  47
chardata:(AL20, TOTAL REFLECTION PACKETS  INPUT   OUTPUT  )#            AL00  48
chardata:(AL24, SIN(T)/L                                         )#     AL00  49
chardata:(AL25, MEAN REFL.                                       )#     AL00  50
chardata:(AL26, POS. REFL.                                       )#     AL00  51
chardata:(AL27, NEG. REFL.                                       )#     AL00  52
chardata:(AL30,                 TOTAL OBSERVED  MINIMUM   MAXIMUM)#     AL00  53
intdata:(IZERO,[0])#                   A zero for clearing packed h     AL00  54
realdata:(FMT1,[101013.,201013.,301013.,401013.,501013.,601013.,$#      AL00  55
701013.,801013.])#                                                      AL00  56
realdata:(FMT2,[220913.,310913.,400922.,501022.])#                      AL00  57
realdata:(FMT3,[200513.,250513.,300513.])#                              AL00  58
realdata:(ITEM,[1.,2.,1302.,1303.,1304.,1305.,1308.,$#                  AL00  59
1312.,1313.,1314.,1315.,1318.])#                                        AL00  60
datastuff:#                                                             AL00  61
#                                                                       AL00  62
#                                                                       AL00  63
#   SET DEFAULT FLAGS                                                   AL00  64
#   -----------------                                                   AL00  65
#                                                                       AL00  66
MEAN = no:#                            Do not use the mean value        AL00  67
BOTH = yes:#                           Use both pos and neg.            AL00  68
PLUS = no:#                            Use the positive friedel         AL00  69
MINUS = no:#                           Use the negative friedel         AL00  70
FSQ = yes:#                            F(square) input                  AL00  71
ITRF = no:#                            No h,k,l transformation          AL00  72
RCODE = voidflg:#                      Set rcode for no unobserved      AL00  73
SEPPKT = yes:#                         Store friedels in separate p     AL00  74
SWITCH = no:#                          Do not switch friedels           AL00  75
DELF = voidflg:#                       Minimum f or f2 to keep          AL00  76
DELS = voidflg:#                       Minimum k*sig to keep            AL00  77
ALIMIT(1)=1000. ; ALIMIT(2)=1000. ; ALIMIT(3)=1000.#                    AL00  78
ALIMIT(4)=0.0 ; ALIMIT(5)=2.0#                                          AL00  79
REFIN = 0.0#                                                            AL00  80
REFOUT = 0.0#                                                           AL00  81
DO I=1,8#                                                               AL00  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AL00  83
DATMAX(I) = 0.0#                                                        AL00  84
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AL00  85
DO I=1,8#                                                               AL00  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AL00  87
DATMIN(I) = 99999999.#                                                  AL00  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AL00  89
DO I=1,6#                                                               AL00  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AL00  91
NDATUM(I) = 0.0#                                                        AL00  92
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AL00  93
#                                                                       AL00  94
#    SET IO BUFFERS FOR FILES A AND B                                   AL00  95
#    --------------------------------                                   AL00  96
#                                                                       AL00  97
IOMARK(1)=QXSTR#                       Start of buffer for file a       AL00  98
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of buffer for file b       AL00  99
incrqx:(MARK,IOMARK(2)+bdfbuf:,AL0001)# Incr memory.....                AL00 100
copyfile:(1,2,1,decr:(lrrefl:))#       Copy to refl records             AL00 101
#                                                                       AL00 102
#   READ INFORMATION FROM THE =ADDMUL= LINE                             AL00 103
#   -----------------------------                                       AL00 104
#                                                                       AL00 105
FOR (I=1; BUFIN(I)<voidflg:; I=I+1)#                                    AL00 106
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AL00 107
stringlim:(I,IC1,IC2)#                                                  AL00 108
NCH = MIN0(IC2-IC1,2)#                                                  AL00 109
compchar:(CHRIN,IC1,AL01,1,2,3,NAL01,KEY)#                              AL00 110
IF (KEY == 1) FSQ = no:#                                                AL00 111
IF (KEY == 2) FSQ = yes:#                                               AL00 112
IF (KEY == 3) $(MEAN = yes:; PLUS = no: ; MINUS = no: ; BOTH = no: $)#  AL00 113
IF (KEY == 4) $(MEAN = no: ; PLUS = yes:; MINUS = no: ; BOTH = no: $)#  AL00 114
IF (KEY == 5) $(MEAN = no: ; PLUS = no: ; MINUS = yes:; BOTH = no: $)#  AL00 115
IF (KEY == 6) $(MEAN = no: ; PLUS = no: ; MINUS = no: ; BOTH = yes:$)#  AL00 116
IF (KEY == 7) SEPPKT = no:#                                             AL00 117
IF (KEY == 8) SEPPKT = yes:#                                            AL00 118
IF (KEY == 9) SWITCH = yes:#                                            AL00 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AL00 120
# WRITE OUT THE OPTIONS SELECTED                                        AL00 121
IF(FSQ==yes:) writeline:(1,AL02,NAL02,3,3)#                             AL00 122
ELSE          writeline:(1,AL03,NAL03,3,3)#                             AL00 123
IF (MEAN==yes:)       writeline:(1,AL04,NAL04,3,3)#                     AL00 124
ELSE IF (PLUS==yes:)  writeline:(1,AL05,NAL05,3,3)#                     AL00 125
ELSE IF (MINUS==yes:) writeline:(1,AL06,NAL06,3,3)#                     AL00 126
ELSE                  writeline:(1,AL07,NAL07,3,3)#                     AL00 127
IF (SEPPKT==no:) writeline:(1,AL11,NAL11,3,3)# Friedel same packet      AL00 128
ELSE writeline:(1,AL12,NAL12,3,3)#     Friedel separate packet          AL00 129
IF (SWITCH==yes:)     writeline:(1,AL14,NAL14,3,3)#                     AL00 130
#                                                                       AL00 131
# SET UP THE WANT ITEMS TO OUT LRREFL BDF                               AL00 132
IF (FSQ!=no:) FSQ = 2#                                                  AL00 133
WANT(1) = 1#                                                            AL00 134
WANT(2) = 2#                                                            AL00 135
NWANT = 2#                                                              AL00 136
IF (MEAN==yes:\PLUS==yes:\MINUS==yes:\SEPPKT==yes:)#                    AL00 137
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AL00 138
WANT(3)=1304-FSQ; WANT(4)=1305-FSQ; WANT(5)=1308#                       AL00 139
NWANT=NWANT+3#                                                          AL00 140
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AL00 141
ELSE#                                  Use f(+/-)                       AL00 142
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AL00 143
WANT(3)=1304-FSQ; WANT(4)=1305-FSQ; WANT(5)=1308#                       AL00 144
WANT(6)=1314-FSQ; WANT(7)=1315-FSQ; WANT(8)=1318#                       AL00 145
NWANT=NWANT+6#                                                          AL00 146
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AL00 147
writepkt:(2,lrrefl:,NWANT,JP)#         Write header record              AL00 148
DO I=1,NWANT#                          Loop over all items              AL00 149
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AL00 150
QX(JP+I)=FLOAT(WANT(I))#               Set id numbers                   AL00 151
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AL00 152
# TELL USER THE ITEMS OUTPUT TO LRREFL:                                 AL00 153
writeline:(1,AL08,NAL08,3,3)#          Write items title                AL00 154
ncodefld:(QX(JP+1),1,CHROT,FMT1,NWANT)#                                 AL00 155
writeline:(0,0,0,1,3)#                 Write line                       AL00 156
DO I=1,NWANT#                                                           AL00 157
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AL00 158
DO J=1,12#                             Dimension of item                AL00 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AL00 160
IF (QX(JP+I)!=ITEM(J)) NEXT#                                            AL00 161
movechar:(AL09,(J-1)*4+1,CHROT,(I-1)*10+7,4,0)# Move message            AL00 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AL00 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AL00 164
writeline:(0,0,0,1,3)#                 Write line                       AL00 165
#                                                                       AL00 166
PASS = 0#                              Set no. of pass thru loop        AL00 167
REPEAT#                                Loop over all input line         AL00 168
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AL00 169
readline:(AL0,-NAL0)#                  Read each line into chrin        AL00 170
LINFLG=1#                              Reset new read flag              AL00 171
#                                                                       AL00 172
IF(LINID==1) BREAK#                                                     AL00 173
ELSE IF (LINID==2)#                    Maxhkl and sint/l line           AL00 174
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AL00 175
DO I=1,5#                                                               AL00 176
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AL00 177
ifnv:(BUFIN(I)) ALIMIT(I)=BUFIN(I)#                                     AL00 178
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AL00 179
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AL00 180
ELSE IF (LINID==3)#                    Reject line                      AL00 181
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 AL00 182
# NOTHING HERE YET!                                                     AL00 183
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 AL00 184
ELSE IF (LINID==4)#                    Rcode line                       AL00 185
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 AL00 186
RCODE = 2.0#                                                            AL00 187
ifnv:(BUFIN(1)) RCODE = BUFIN(1)#                                       AL00 188
ifnv:(RCODE) $( ncodefld:(RCODE,1,AL10,300822.,1); $#                   AL00 189
writeline:(1,AL10,NAL10,3,3) $)#                                        AL00 190
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 AL00 191
#                                                                       AL00 192
ELSE IF(LINID==5)#                     Transf line                      AL00 193
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 AL00 194
DO I=1,9#                              Loop over fields                 AL00 195
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 AL00 196
ifnm:(BUFIN(I)) TM(I)=BUFIN(I)#        Numeric field                    AL00 197
ELSE iquit:(AL0002)#                   Bad field                        AL00 198
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 AL00 199
ITRF=yes:#                             Transform hkl                    AL00 200
writeline:(1,AL13,NAL13,3,3)#                                           AL00 201
DO I=1,9,3#                            Write out transformation         AL00 202
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 AL00 203
ncodefld:(TM(I),1,CHROT,FMT3,3)#                                        AL00 204
writeline:(1,0,0,1,3)#                                                  AL00 205
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 AL00 206
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 AL00 207
#                                                                       AL00 208
ELSE IF (LINID==6)#                    Delete line                      AL00 209
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 AL00 210
ifnv:(BUFIN(1))#                                                        AL00 211
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 AL00 212
DELF = BUFIN(1)#                       Minimum f of f2                  AL00 213
ncodefld:(DELF,1,AL15,300822.,1)#                                       AL00 214
writeline:(1,AL15,NAL15,3,3)#                                           AL00 215
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 AL00 216
ifnv:(BUFIN(2))#                                                        AL00 217
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 AL00 218
DELS = BUFIN(2)#                       Minimum k*sigma                  AL00 219
ncodefld:(DELS,1,AL16,300822.,1)#                                       AL00 220
writeline:(1,AL16,NAL16,3,3)#                                           AL00 221
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 AL00 222
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 AL00 223
#                                                                       AL00 224
ELSE IF(LINID==0)#                     Hkl line                         AL00 225
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 AL00 226
CHRCOL=1;   dcodefld:#                 Convert char to numeric          AL00 227
IF (PASS==0) REFIN = REFIN + 1.0#                                       AL00 228
IF (PASS==0&SEPPKT==yes:&BOTH==yes:)#  1st pass of separate packets     AL00 229
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 AL00 230
PLUS=yes:#                                                              AL00 231
MINUS=no:#                                                              AL00 232
LINFLG=0#                                                               AL00 233
PASS=1#                                                                 AL00 234
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 AL00 235
ELSE IF (PASS==1&SEPPKT==yes:&BOTH==yes:)# 2nd pass of separate packe   AL00 236
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 AL00 237
PLUS=no:#                                                               AL00 238
MINUS=yes:#                                                             AL00 239
LINFLG=1#                                                               AL00 240
PASS=0#                                                                 AL00 241
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 AL00 242
IFLAG = NINT(BUFIN(11))#                                                AL00 243
intpak:(IFLAG,BUFIN(11),0,32)#                                          AL00 244
intunpak:(BUFIN(11),ACENT,0,1)#                                         AL00 245
DO I=1,4; AHKL(I)=BUFIN(I)#            Get integer hkl and sint/l       AL00 246
IF(ITRF==yes:)#                        Transform hkl                    AL00 247
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 AL00 248
X=AHKL(1) ; Y=AHKL(2) ; Z=AHKL(3)#     Store temporary                  AL00 249
AHKL(1)=X*TM(1)+Y*TM(2)+Z*TM(3)#       Transformed h'                   AL00 250
AHKL(2)=X*TM(4)+Y*TM(5)+Z*TM(6)#       Transformed k'                   AL00 251
AHKL(3)=X*TM(7)+Y*TM(8)+Z*TM(9)#       Transformed l'                   AL00 252
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 AL00 253
IF (SWITCH==yes:)#                     Switch friedel mates             AL00 254
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 AL00 255
X = BUFIN(7) ; Y = BUFIN(8)#                                            AL00 256
BUFIN(7) = BUFIN(9) ; BUFIN(8) = BUFIN(10)#                             AL00 257
BUFIN(9) = X ; BUFIN(10) = Y#                                           AL00 258
intunpak:(BUFIN(11),I,1,1)#            Switch flag bits                 AL00 259
intunpak:(BUFIN(11),J,2,1)#                                             AL00 260
intpak:(I,BUFIN(11),2,1)#                                               AL00 261
intpak:(J,BUFIN(11),1,1)#                                               AL00 262
intunpak:(BUFIN(11),I,4,1)#                                             AL00 263
intunpak:(BUFIN(11),J,5,1)#                                             AL00 264
intpak:(I,BUFIN(11),5,1)#                                               AL00 265
intpak:(J,BUFIN(11),4,1)#                                               AL00 266
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 AL00 267
IF (MINUS==yes:)#                      Change signs on reflections      AL00 268
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 AL00 269
DO I=1,3 $( AHKL(I)= -AHKL(I) $)##                                      AL00 270
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 AL00 271
IF (AHKL(1)>ALIMIT(1)\AHKL(2)>ALIMIT(2)\AHKL(3)>ALIMIT(3)$#             AL00 272
   \AHKL(4)<ALIMIT(4)\AHKL(4)>ALIMIT(5)) NEXT# Reject this refl         AL00 273
# PACK UP H,K,L                                                         AL00 274
# -------------                                                         AL00 275
#                                                                       AL00 276
intpak:(IZERO,DATUM(1),0,mxbtwd:)#     Zero out the packed hkl          AL00 277
DO I=1,3#                              Loop over h,k and l              AL00 278
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 AL00 279
MAXHKL(I)=AMAX1(MAXHKL(I),AHKL(I))#    Store max/min hkl                AL00 280
MINHKL(I)=AMIN1(MINHKL(I),AHKL(I))#                                     AL00 281
M=NINT(AHKL(4-I))#                     Make an integer out of index     AL00 282
N=0#                                   Clear sign bit                   AL00 283
IF(M<0)#                               For negative miller index        AL00 284
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 AL00 285
M=IABS(M)#                             Get magnitude                    AL00 286
N=1#                                   And set sign bit                 AL00 287
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 AL00 288
intpak:(N,DATUM(1),I-1,1)#             Pack up the sign bit             AL00 289
intpak:(M,DATUM(1),(I-1)*9+3,9)#       Pack up the mag of h, k, or      AL00 290
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 AL00 291
DATUM(2) = AHKL(4)#                    Get sint/l                       AL00 292
DATMAX(2)=AMAX1(DATMAX(2),DATUM(2))#   Keep stats                       AL00 293
DATMIN(2)=AMIN1(DATMIN(2),DATUM(2))#                                    AL00 294
#                                                                       AL00 295
IF (MEAN==yes:)#                       Store the mean                   AL00 296
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 AL00 297
DATUM(3) = BUFIN(5)#                                                    AL00 298
DATUM(4) = BUFIN(6)#                                                    AL00 299
DATUM(5) = 1.0#                                                         AL00 300
NDATUM(1) = NDATUM(1)+1.#                                               AL00 301
DATMAX(3)=AMAX1(DATMAX(3),DATUM(3))#   Keep stats                       AL00 302
DATMIN(3)=AMIN1(DATMIN(3),DATUM(3))#                                    AL00 303
ifnv:(RCODE)#                                                           AL00 304
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 AL00 305
IF (DATUM(3)<RCODE*DATUM(4)) DATUM(5)=2.0#                              AL00 306
NDATUM(2)=NDATUM(2)+1.#                Count number unobserved          AL00 307
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 AL00 308
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 AL00 309
ELSE IF (PLUS==yes:)#                  Store only positive reflecti     AL00 310
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 AL00 311
intunpak:(BUFIN(11),IFLAG,1,1)#                                         AL00 312
IF (IFLAG==yes:&ACENT==0) NEXT#        No i+ measurement                AL00 313
DATUM(3) = BUFIN(7)#                                                    AL00 314
DATUM(4) = BUFIN(8)#                                                    AL00 315
IF (DATUM(3) <= DELF) NEXT#            Reflection too small             AL00 316
ifnv:(DELS) $(IF(DATUM(3)<=DATUM(4)*DELS) NEXT$)#                       AL00 317
DATUM(5) = 1.0#                                                         AL00 318
NDATUM(3) = NDATUM(3)+1.#                                               AL00 319
DATMAX(3)=AMAX1(DATMAX(3),DATUM(3))#   Keep stats                       AL00 320
DATMIN(3)=AMIN1(DATMIN(3),DATUM(3))#                                    AL00 321
ifnv:(RCODE)#                                                           AL00 322
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 AL00 323
IF (DATUM(3)<RCODE*DATUM(4))#                                           AL00 324
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 AL00 325
DATUM(5)=2.0#                                                           AL00 326
NDATUM(4)=NDATUM(4)+1.#                Count number unobserved          AL00 327
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 AL00 328
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 AL00 329
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 AL00 330
ELSE IF (MINUS==yes:)#                 Store only negitive reflecti     AL00 331
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 AL00 332
intunpak:(BUFIN(11),IFLAG,2,1)#                                         AL00 333
IF (IFLAG==yes:&ACENT==0) NEXT#        No i- measurement                AL00 334
DATUM(3) = BUFIN(9)#                                                    AL00 335
DATUM(4) = BUFIN(10)#                                                   AL00 336
IF (DATUM(3) <= DELF) NEXT#            Reflection too small             AL00 337
ifnv:(DELS) $(IF(DATUM(3)<=DATUM(4)*DELS) NEXT$)#                       AL00 338
DATUM(5) = 1.0#                                                         AL00 339
NDATUM(5) = NDATUM(5)+1.#                                               AL00 340
DATMAX(6)=AMAX1(DATMAX(6),DATUM(3))#   Keep stats                       AL00 341
DATMIN(6)=AMIN1(DATMIN(6),DATUM(3))#                                    AL00 342
ifnv:(RCODE)#                                                           AL00 343
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 AL00 344
IF (DATUM(3)<RCODE*DATUM(4))#                                           AL00 345
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 AL00 346
DATUM(5)=2.0#                                                           AL00 347
NDATUM(6)=NDATUM(6)+1.#                Count number unobserved          AL00 348
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 AL00 349
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 AL00 350
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 AL00 351
ELSE IF (BOTH==yes:)#                  Store both +/- reflections       AL00 352
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 AL00 353
DATUM(3) = BUFIN(7)#                                                    AL00 354
DATUM(4) = BUFIN(8)#                                                    AL00 355
DATUM(5) = 1.0#                                                         AL00 356
NDATUM(3) = NDATUM(3)+1.#                                               AL00 357
DATUM(6) = BUFIN(9)#                                                    AL00 358
DATUM(7) = BUFIN(10)#                                                   AL00 359
DATUM(8) = 1.0#                                                         AL00 360
NDATUM(5) = NDATUM(5)+1.#                                               AL00 361
IF (ACENT==0)#                         Acentric reflection              AL00 362
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 AL00 363
intunpak:(BUFIN(11),IFLAG,1,1)#                                         AL00 364
IF (IFLAG==yes:)#                      No i+ measurement                AL00 365
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 AL00 366
DATUM(3) = voidflg:#                                                    AL00 367
DATUM(4) = voidflg:#                                                    AL00 368
DATUM(5) = 4.#                                                          AL00 369
NDATUM(3) = NDATUM(3)-1.#                                               AL00 370
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 AL00 371
intunpak:(BUFIN(11),IFLAG,2,1)#                                         AL00 372
IF (IFLAG==yes:)#                      No i- measurement                AL00 373
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 AL00 374
DATUM(6) = voidflg:#                                                    AL00 375
DATUM(7) = voidflg:#                                                    AL00 376
DATUM(8) = 4.#                                                          AL00 377
NDATUM(5) = NDATUM(5)-1.#                                               AL00 378
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 AL00 379
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 AL00 380
ifnv:(DATUM(3))#                                                        AL00 381
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 AL00 382
DATMAX(3)=AMAX1(DATMAX(3),DATUM(3))#   Keep stats                       AL00 383
DATMIN(3)=AMIN1(DATMIN(3),DATUM(3))#                                    AL00 384
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 AL00 385
ifnv:(DATUM(6))#                                                        AL00 386
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 AL00 387
DATMAX(6)=AMAX1(DATMAX(6),DATUM(6))#   Keep stats                       AL00 388
DATMIN(6)=AMIN1(DATMIN(6),DATUM(6))#                                    AL00 389
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 AL00 390
ifnv:(RCODE)#                          Reset obs/unobs code as need     AL00 391
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 AL00 392
ifnv:(DATUM(3))#                                                        AL00 393
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 AL00 394
IF (DATUM(3)<RCODE*DATUM(4))#                                           AL00 395
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 AL00 396
DATUM(5)=2.0#                                                           AL00 397
NDATUM(4)=NDATUM(4)+1.#                Count number unobserved          AL00 398
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 AL00 399
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 AL00 400
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 AL00 401
ifnv:(DATUM(6))#                                                        AL00 402
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 AL00 403
IF (DATUM(6)<RCODE*DATUM(7))#                                           AL00 404
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 AL00 405
DATUM(8)=2.0#                                                           AL00 406
NDATUM(6)=NDATUM(6)+1.#                Count number unobserved          AL00 407
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 AL00 408
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 AL00 409
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 AL00 410
writepkt:(2,lrrefl:,NWANT,JP)#                                          AL00 411
REFOUT = REFOUT+1.0#                                                    AL00 412
movepakwd:(DATUM(1),QX(JP+1))#         Save packed hkl                  AL00 413
movereal:(DATUM(2),1,QX(JP+2),1,NWANT-1,0)#                             AL00 414
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 AL00 415
#                                                                       AL00 416
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AL00 417
#     FINISH OFF THE BDF FILE                                           AL00 418
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Finish off copy               AL00 419
#                                                                       AL00 420
# TELL WHAT HAPPENED                                                    AL00 421
LINRM=8;writeline:(2,AL20,NAL20,1,3)#  Write packet totals              AL00 422
ncodefld:(REFIN,1,CHROT,320913.,1)#                                     AL00 423
ncodefld:(REFOUT,1,CHROT,410913.,1)#                                    AL00 424
writeline:(0,0,0,1,3)#                                                  AL00 425
writeline:(1,AL30,NAL30,3,3)#                                           AL00 426
LINRM=4#                                                                AL00 427
DO I=1,3#                              Loop over hkl                    AL00 428
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 AL00 429
movechar:(AL09,I+1,CHROT,10,1,0)#      Move mnemonic                    AL00 430
ncodefld:(MINHKL(I),1,CHROT,401013.,1)#                                 AL00 431
ncodefld:(MAXHKL(I),1,CHROT,501013.,1)#                                 AL00 432
writeline:(0,0,0,1,3)#                                                  AL00 433
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 AL00 434
ncodefld:(DATMIN(2),1,AL24,401042.,1)# Write min/max sint/l             AL00 435
ncodefld:(DATMAX(2),1,AL24,501042.,1)#                                  AL00 436
writeline:(0,AL24,NAL24,3,3)#                                           AL00 437
LINRM=4#                                                                AL00 438
# WRITE OUT REST OF DATA STATISTICS                                     AL00 439
IF (MEAN==yes:)#                                                        AL00 440
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 57 AL00 441
NDATUM(2) = NDATUM(1)-NDATUM(2)#       Get no. observ from unobs.       AL00 442
ncodefld:(NDATUM(1),1,AL25,FMT2(1),2)#                                  AL00 443
ncodefld:(DATMIN(3),1,AL25,FMT2(3),1)#                                  AL00 444
ncodefld:(DATMAX(3),1,AL25,FMT2(4),1)#                                  AL00 445
writeline:(0,AL25,NAL25,3,3)#                                           AL00 446
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 57 AL00 447
ELSE IF (BOTH==yes:)#                                                   AL00 448
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 58 AL00 449
NDATUM(4) = NDATUM(3)-NDATUM(4)#       Get no. observ from unobs.       AL00 450
ncodefld:(NDATUM(3),1,AL26,FMT2(1),2)#                                  AL00 451
ncodefld:(DATMIN(3),1,AL26,FMT2(3),1)#                                  AL00 452
ncodefld:(DATMAX(3),1,AL26,FMT2(4),1)#                                  AL00 453
writeline:(0,AL26,NAL26,3,3)#                                           AL00 454
NDATUM(6) = NDATUM(5)-NDATUM(6)#       Get no. observ from unobs.       AL00 455
ncodefld:(NDATUM(5),1,AL27,FMT2(1),2)#                                  AL00 456
ncodefld:(DATMIN(6),1,AL27,FMT2(3),1)#                                  AL00 457
ncodefld:(DATMAX(6),1,AL27,FMT2(4),1)#                                  AL00 458
writeline:(0,AL27,NAL27,3,3)#                                           AL00 459
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 58 AL00 460
ELSE IF (PLUS==yes:)#                                                   AL00 461
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 59 AL00 462
NDATUM(4) = NDATUM(3)-NDATUM(4)#       Get no. observ from unobs.       AL00 463
ncodefld:(NDATUM(3),1,AL26,FMT2(1),2)#                                  AL00 464
ncodefld:(DATMIN(3),1,AL26,FMT2(3),1)#                                  AL00 465
ncodefld:(DATMAX(3),1,AL26,FMT2(4),1)#                                  AL00 466
writeline:(0,AL26,NAL26,3,3)#                                           AL00 467
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 59 AL00 468
ELSE IF (MINUS==yes:)#                                                  AL00 469
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 60 AL00 470
NDATUM(6) = NDATUM(5)-NDATUM(6)#       Get no. observ from unobs.       AL00 471
ncodefld:(NDATUM(5),1,AL27,FMT2(1),2)#                                  AL00 472
ncodefld:(DATMIN(6),1,AL27,FMT2(3),1)#                                  AL00 473
ncodefld:(DATMAX(6),1,AL27,FMT2(4),1)#                                  AL00 474
writeline:(0,AL27,NAL27,3,3)#                                           AL00 475
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 60 AL00 476
#                                                                       AL00 477
RETURN#                                                                 AL00 478
END#                                                                    AL00 479
pmacro:([no:])#                                                         AL00 480
#                                      #                                AL00 481
