systemheader:(AM    )#                                                  AM     1
####################################################################    AM     2
#                                                                  #    AM     3
#                            *** AM ***                            #    AM     4
#                                                                  #    AM     5
#    THE PROGRAM APMASK, AM, IS USED TO APPLY A MASKING MAP,CREATED#    AM     6
#    BY MKMASK, TO A FOURIER MAP, CREATED BY FOURR. ANY REGION OF  #    AM     7
#    THE MASKING MAP OCCUPIED BY VALUE >= 0 WILL CAUSE THE CORRES- #    AM     8
#    PONDING VALUE IN THE FOURIER MAP TO REMAIN; ALL OTHER VALUES  #    AM     9
#    OF THE FOURIER MAP WILL BE REPLACED WITH A  ZERO. IN EFFECT,  #    AM    10
#    ONLY THE FOURIER MAP REPRESENTING THE MOLECULE (IE. REGION OF #    AM    11
#    DEFINITE ELECTRON DENSITY DUE TO SCATTERING ATOMS) WILL BE    #    AM    12
#    LEFT IN MAP AFTER APPLYING APMASK.                            #    AM    13
#                                                                  #    AM    14
####################################################################    AM    15
#                                                                       AM    16
include:(XMACRO)#                                                       AM    17
#                                                                       AM    18
macro:(mxrec:,128)#                    Max packet size on msk file      AM    19
macro:(maxmap:,700000)#                Maximum mask map row             AM    20
macro:(makereal:,[DO I=1,$2; BUFOT(I)=$1(ISUM2(I))])#                   AM    21
#                                                                       AM    22
extrude:(AMCOMN)#                                                       AM    23
INTEGER AVGDEN#                ## =yes: if average sol density          AM    24
INTEGER INCX1(3)#              ## STEP SIZE IN MAP COORS                AM    25
INTEGER INCX2(3)#              ## STEP SIZE IN MAP COORS                AM    26
INTEGER IORGX2(3)#             ## ORIGIN OF FOURIER MAP                 AM    27
INTEGER IREL(12)#              ## POINTERS TO ITEMS IN BDF BUFFER       AM    28
INTEGER ISUM1(3)#              ## summation order                       AM    29
INTEGER ISUM2(3)#              ## summation order                       AM    30
INTEGER IWNT(12)#              ## ITEMS WANTED FROM BDF                 AM    31
INTEGER JSUM1(3)#                                                       AM    32
INTEGER JSUM2(3)#                                                       AM    33
INTEGER KEY(4)#                ## FLAGS INDICATING HOW TO READ BDF      AM    34
INTEGER MAPSIZ#                ## size of total unit cel map            AM    35
INTEGER MARK3#                 ## START OF SCRATCH BUFFER IF NEEDED     AM    36
INTEGER NONEG#                 ## =yes:,neg molec dens not allowed      AM    37
INTEGER NP2(3)#                ## GRID FINENESS IN GRID UNITS           AM    38
INTEGER NG1(3)#                ## GRID FINENESS IN GRID UNITS           AM    39
INTEGER NG2(3)#                ## GRID FINENESS IN GRID UNITS           AM    40
INTEGER PRINT#                 ## yes: if mask to be printed            AM    41
INTEGER XDIR#                  ## INDEX FOR X ACTIVITY                  AM    42
INTEGER YDIR#                  ## INDEX FOR Y ACTIVITY                  AM    43
INTEGER ZDIR#                  ## INDEX FOR Z ACTIVITY                  AM    44
#                                                                       AM    45
COMMON /COMIAM/$#                                                       AM    46
AVGDEN,INCX1, INCX2, IORGX2,IREL,  ISUM1, ISUM2, IWNT,  JSUM1, $#       AM    47
JSUM2, KEY,   MARK3, NG1,   NG2,   NP2,   MAPSIZ,NONEG, $#              AM    48
PRINT, XDIR,  YDIR,  ZDIR#                                              AM    49
#                                                                       AM    50
REAL FZOVOL#                   ## F zero over volume offset for dens    AM    51
REAL PRTSKL#                   ## scale for map values                  AM    52
REAL CELL(6)#                  ## CELL DIMENSIONS                       AM    53
REAL RHOMIN#                                                            AM    54
REAL RHOMAX#                                                            AM    55
REAL SCALE#                    ## Scale for molec dens                  AM    56
REAL SOLDEN#                   ## Constant solv dens value              AM    57
REAL SRATIO#                   ## CALCULATED OFFSET FOR DENSITY         AM    58
COMMON /COMFAM/$#                                                       AM    59
CELL, FZOVOL,  PRTSKL, RHOMIN, RHOMAX, SCALE, SOLDEN, SRATIO#           AM    60
endext:#                                                                AM    61
#                                                                       AM    62
systemheader:(AM00)#                   Applying mask to fourier map     AM00   1
# ################################################################## #  AM00   2
#                                                                    #  AM00   3
#                               AM00                                 #  AM00   4
#                                                                    #  AM00   5
# ################################################################## #  AM00   6
SUBROUTINE AM00#                       D.r.holland 1987                 AM00   7
#                                                                       AM00   8
include:(AACOMN)#                                                       AM00   9
include:(AMCOMN)#                                                       AM00  10
#                                                                       AM00  11
#  INITIALIZE MAP LAYOUT PARAMETERS                                     AM00  12
#  --------------------------------                                     AM00  13
#                                                                       AM00  14
FZOVOL = 0.0#                          No additive offset to density    AM00  15
SCALE = 1.0#                           No multiplic. offset to dens     AM00  16
SOLDEN = 0.0#                          Default, solv dens = 0           AM00  17
AVGDEN = no:#                          Default not average solv dens    AM00  18
NONEG  = no:#                          Default allow neg dens in mol    AM00  19
PRTSKL = 1.0#                                                           AM00  20
SRATIO = voidflg:#                     Default,don't calc additive      AM00  21
#                                                                       AM00  22
CALL AM01#                             Read control cards               AM00  23
CALL AM02#                             Read fourier and mask maps       AM00  24
CALL AM04#                             Apply mask to map                AM00  25
CALL AM05#                             Write out map                    AM00  26
#                                                                       AM00  27
RETURN#                                                                 AM00  28
END#                                                                    AM00  29
systemheader:(AM01)#                   Read controls                    AM01   1
# ####################################################################  AM01   2
#                                                                       AM01   3
#                                AM01                                   AM01   4
#                                                                       AM01   5
# ####################################################################  AM01   6
SUBROUTINE AM01#                                                        AM01   7
include:(AACOMN)#                                                       AM01   8
include:(AMCOMN)#                                                       AM01   9
#                                                                       AM01  10
INTEGER I,J,K#                         Working indices                  AM01  11
#                                                                       AM01  12
chardata:(AM21, END    FZOVOL SCALE  SOLDEN SRATIO  )#                  AM01  13
chardata:(AM24,PRINT  AVGDEN NONEG  )#                                  AM01  14
chardata:(AM25,options:  )#                                             AM01  15
chardata:(AM26,  PRINT MASK                  XX )#                      AM01  16
chardata:(AM27,  AVERAGE SOLVENT DENSITY     XX )#                      AM01  17
chardata:(AM28,  REPLACE NEG ATOMIC DENSITY  XX )#                      AM01  18
chardata:(AM29,  FZOVOL           =   X.XX)#                            AM01  19
chardata:(AM30,  SCALE            =   X.XX)#                            AM01  20
chardata:(AM31,  SOLVENT DENSITY  =   X.XX)#                            AM01  21
chardata:(AM32,  SRATIO  VALUE    =   X.XX)#                            AM01  22
chardata:(AM33,  CALCULATE DENSITY OFFSET    XX )#                      AM01  23
chardata:(YESNO,YESNO )#                                                AM01  24
realdata:(FMT,270722.)#                                                 AM01  25
datastuff:#                                                             AM01  26
#                                                                       AM01  27
#   ENTER CONTROL LINES                                                 AM01  28
#   -------------------                                                 AM01  29
#                                                                       AM01  30
FOR(I=1;I<10;I=I+1)#                   Loop over input fields           AM01  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AM01  32
ifvo:(BUFIN(I)) BREAK#                 Exit after last field            AM01  33
stringlim:(I,J,K)#                     Find limits of the field         AM01  34
compchar:(CHRIN,J,AM24,1,6,7,NAM24,K)# Find what's there                AM01  35
IF(K==0) iquit:(AM0101,I)#             Dud flag.......50101             AM01  36
ELSE IF (K==1) PRINT=yes:#                                              AM01  37
ELSE IF (K==2)#                                                         AM01  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AM01  39
AVGDEN=yes:#                           Avg dens for solvent region      AM01  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AM01  41
ELSE IF (K==3) NONEG=yes:#             Check for neg dens in molecul    AM01  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AM01  43
#                                                                       AM01  44
REPEAT#                                Loop over control lines          AM01  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AM01  46
readline:(AM21,NAM21)#                 Process control line             AM01  47
#                                                                       AM01  48
IF(LINID==1) BREAK#                    ****** end   *******             AM01  49
IF(LINID==2)#                          ****** fzovol*******             AM01  50
ifnv:(BUFIN(1)) FZOVOL = BUFIN(1)#                                      AM01  51
IF(LINID==3)#                          ****** scale *******             AM01  52
ifnv:(BUFIN(1)) SCALE = BUFIN(1)#                                       AM01  53
IF(LINID==4)#                          ****** solden *******            AM01  54
ifnv:(BUFIN(1)) SOLDEN = BUFIN(1)#                                      AM01  55
IF(LINID==5)#                          ****** sratio *******            AM01  56
ifnv:(BUFIN(1)) SRATIO = BUFIN(1)#                                      AM01  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AM01  58
#                                                                       AM01  59
#   PRINT OPTIONS                                                       AM01  60
#   -------------                                                       AM01  61
#                                                                       AM01  62
writeline:(2,AM25,NAM25,3,3)#          Report options                   AM01  63
IF(PRINT==yes:) IYN = 1#                                                AM01  64
ELSE IYN = 4#                                                           AM01  65
movechar:(YESNO,IYN,AM26,30,3,0)#      Print                            AM01  66
writeline:(1,AM26,NAM26,3,3)#                                           AM01  67
IF(AVGDEN==yes:) IYN = 1#                                               AM01  68
ELSE IYN = 4#                                                           AM01  69
movechar:(YESNO,IYN,AM27,30,3,0)#      Avgden                           AM01  70
writeline:(1,AM27,NAM27,3,3)#                                           AM01  71
IF(NONEG==yes:) IYN = 1#                                                AM01  72
ELSE IYN = 4#                                                           AM01  73
movechar:(YESNO,IYN,AM28,30,3,0)#      Noneg                            AM01  74
writeline:(1,AM28,NAM28,3,3)#                                           AM01  75
IF(SRATIO==voidflg:) IYN = 4#                                           AM01  76
ELSE IYN = 1#                                                           AM01  77
movechar:(YESNO,IYN,AM33,30,3,0)#      Calculate offset                 AM01  78
writeline:(1,AM33,NAM33,3,3)#                                           AM01  79
ncodefld:(FZOVOL,1,AM29,FMT,1)#        Fzovol                           AM01  80
writeline:(1,AM29,NAM29,3,3)#                                           AM01  81
ncodefld:(SCALE,1,AM30,FMT,1)#         Scale                            AM01  82
writeline:(1,AM30,NAM30,3,3)#                                           AM01  83
ncodefld:(SOLDEN,1,AM31,FMT,1)#        Solden                           AM01  84
writeline:(1,AM31,NAM31,3,3)#                                           AM01  85
ncodefld:(SRATIO,1,AM32,FMT,1)#        Sratio                           AM01  86
ifnv:(SRATIO) writeline:(1,AM32,NAM32,3,3)#                             AM01  87
#                                                                       AM01  88
RETURN#                                                                 AM01  89
END#                                                                    AM01  90
systemheader:(AM02)#                   Determine map layout             AM02   1
########################################################                AM02   2
#                                                                       AM02   3
#                      AM02                                             AM02   4
#                                                                       AM02   5
########################################################                AM02   6
SUBROUTINE AM02#                                                        AM02   7
#                                                                       AM02   8
#----------------------------------------------------------             AM02   9
#                                                                       AM02  10
#  NOTE: NGRID, IORGX, INCX  ORDERED AS LAYER, DOWN, ACROSS             AM02  11
#                                                                       AM02  12
#----------------------------------------------------------             AM02  13
include:(AACOMN)#                                                       AM02  14
include:(AMCOMN)#                                                       AM02  15
#                                                                       AM02  16
chardata:(XYZ,[XYZ])#                                                   AM02  17
chardata:(AM00A,[CELL DIMENSIONS ])#                                    AM02  18
chardata:(AM00B,[  A     : AMAMAMAMX   B    : AMAMAMAMAM$#              AM02  19
   C     : AMAMAMAMAM ])#                                               AM02  20
chardata:(AM00C,[  ALPHA : AMAMAMAMX   BETA : AMAMAMAMAM$#              AM02  21
   GAMMA : AMAMAMAMAM ])#                                               AM02  22
chardata:(AM00E,[REC 21 INFORMATION])#                                  AM02  23
chardata:(AM0E1,[  ORIGIN])#                                            AM02  24
chardata:(AM0E2,[  X :    X    Y :    X    Z :    X ])#                 AM02  25
chardata:(AM0E3,[  INCREMENT])#                                         AM02  26
chardata:(AM0E4,[  GRID FINENESS])#                                     AM02  27
chardata:(AM0E5,[  NUMBER OF POINTS SUMMED])#                           AM02  28
chardata:(AM0E6,[  MAP LAYOUT])#                                        AM02  29
chardata:(AM0E7,[    across:    down:    page:   ])#                    AM02  30
chardata:(AM0E8,[  SUMMATION ORDER])#                                   AM02  31
chardata:(AM0E9,[    slow:      med:     fast:   ])#                    AM02  32
chardata:(AM00F,[MASK MAP INFORMATION])#                                AM02  33
realdata:(FMTCLL,[191052.,391052.,601052.])# Format to ncodefld above   AM02  34
realdata:(FMTCL2,[191051.,391051.,601051.])# Format to ncodefld above   AM02  35
realdata:(FMTR21,[100513.,220513.,340513.])# Format for rec21 data      AM02  36
chardata:(AM00D,[     x: AMAMX      y:  AMAMX        z: AMAMX ])#       AM02  37
datastuff:#                                                             AM02  38
#                                                                       AM02  39
#                                                                       AM02  40
FILEXT(IOUNIT(3))='MAP'#               Map from fourr program           AM02  41
FILEXT(IOUNIT(4))='MSK'#               Mask from mkmask program         AM02  42
FILEXT(IOUNIT(5))='MMP'#               Masked map from this program     AM02  43
FILEXT(IOUNIT(6))='XX1'#               Scrath map for multiple pass     AM02  44
#                                                                       AM02  45
#   ASSIGN BDF INPUT BUFFER                                             AM02  46
#   --------------------------                                          AM02  47
#                                                                       AM02  48
IOMARK(3)=QXSTR#                       Buffer for original fourier      AM02  49
IOMARK(4)=IOMARK(3)+bdfbuf:#           Buffer for mask file             AM02  50
IOMARK(5)=IOMARK(4)+bdfbuf:#           Buffer for output map file       AM02  51
IOMARK(6)=IOMARK(5)+bdfbuf:#           Buffer for scratch map file      AM02  52
MARK3=IOMARK(6)+bdfbuf:#               Set start of mask storage        AM02  53
incrqx:(I,MARK3+1,AM0201)#             Get the memory                   AM02  54
#                                                                       AM02  55
#  READ CELL DIMENSIONS                                                 AM02  56
#  ---------------------------------------                              AM02  57
#                                                                       AM02  58
copyfile:(3,6,1,decr:(lrcell:))#                                        AM02  59
readwpkt:(3,lrcell:,PSIZ,IP,0)#        Read in cell record              AM02  60
IF(IP<=0) iquit:(AM0202)#              Exit on last record              AM02  61
writepkt:(6,lrcell:,PSIZ,JPT)#                                          AM02  62
movereal:(QX,IP+1,QX,JPT+1,PSIZ,1)#                                     AM02  63
movereal:(QX,IP+1,CELL,1,3,0)#         Save real cell constants         AM02  64
movereal:(QX,IP+7,CELL,4,3,0)#         Save real cell constants         AM02  65
CELL(4) = CELL(4) * 360.#              Cycles to degrees                AM02  66
CELL(5) = CELL(5) * 360.#              Cycles to degrees                AM02  67
CELL(6) = CELL(6) * 360.#              Cycles to degrees                AM02  68
#                                                                       AM02  69
#  WRITE CELL DIMENSIONS                                                AM02  70
#  ----------------------                                               AM02  71
#                                                                       AM02  72
writeline:(1,AM00A,NAM00A,3,3)#        Write out cell dimensions        AM02  73
ncodefld:(CELL,1,AM00B,FMTCLL,3)#                                       AM02  74
writeline:(0,AM00B,NAM00B,3,3)#                                         AM02  75
ncodefld:(CELL,4,AM00C,FMTCL2,3)#                                       AM02  76
writeline:(0,AM00C,NAM00C,3,3)#                                         AM02  77
### isum2(1) points to what x does                                      AM02  78
### isum2(2) points to what y does                                      AM02  79
### isum2(3) points to what z does                                      AM02  80
#                                                                       AM02  81
#   READ BOTH MAP LAYOUTS                                               AM02  82
#   ----------------                                                    AM02  83
#                                                                       AM02  84
CALL AM03#                                                              AM02  85
#                                                                       AM02  86
#  WRITE MASK MAP DATA                                                  AM02  87
#  ----------------                                                     AM02  88
#                                                                       AM02  89
writeline:(2,AM00E,NAM00F,3,3)#                                         AM02  90
writeline:(1,AM0E6,NAM0E6,3,3)#        Write out summation order in     AM02  91
movechar:(XYZ,JSUM1(3),AM0E7,13,1,0)#                                   AM02  92
movechar:(XYZ,JSUM1(2),AM0E7,22,1,0)#                                   AM02  93
movechar:(XYZ,JSUM1(1),AM0E7,31,1,0)#                                   AM02  94
writeline:(0,AM0E7,NAM0E7,3,3)#                                         AM02  95
writeline:(0,AM0E3,NAM0E3,3,3)#        Write out increment              AM02  96
makereal:(INCX1,3)#                    Real-ize integer array           AM02  97
ncodefld:(BUFOT,1,AM0E2,FMTR21,3)#                                      AM02  98
writeline:(0,AM0E2,NAM0E2,3,3)#                                         AM02  99
writeline:(0,AM0E4,NAM0E4,3,3)#        Write out grid fineness          AM02 100
makereal:(NG1,3)#                      Real-ize integer array           AM02 101
ncodefld:(BUFOT,1,AM0E2,FMTR21,3)#                                      AM02 102
writeline:(0,AM0E2,NAM0E5,3,3)#        Write out no. points summed      AM02 103
#                                                                       AM02 104
#  WRITE REC 21   DATA                                                  AM02 105
#  -------------------                                                  AM02 106
#                                                                       AM02 107
writeline:(2,AM00F,NAM00E,3,3)#                                         AM02 108
writeline:(0,AM0E8,NAM0E8,3,3)#        Write out summation order in     AM02 109
movechar:(XYZ,JSUM2(1),AM0E9,13,1,0)#                                   AM02 110
movechar:(XYZ,JSUM2(2),AM0E9,22,1,0)#                                   AM02 111
movechar:(XYZ,JSUM2(3),AM0E9,31,1,0)#                                   AM02 112
writeline:(0,AM0E9,NAM0E9,3,3)#                                         AM02 113
writeline:(1,AM0E6,NAM0E6,3,3)#        Write out summation order in     AM02 114
movechar:(XYZ,JSUM2(3),AM0E7,13,1,0)#                                   AM02 115
movechar:(XYZ,JSUM2(2),AM0E7,22,1,0)#                                   AM02 116
movechar:(XYZ,JSUM2(1),AM0E7,31,1,0)#                                   AM02 117
writeline:(0,AM0E7,NAM0E7,3,3)#                                         AM02 118
writeline:(0,AM0E1,NAM0E1,3,3)#        Write out origin                 AM02 119
makereal:(IORGX2,3)#                   Real-ize integer array           AM02 120
ncodefld:(BUFOT,1,AM0E2,FMTR21,3)#                                      AM02 121
writeline:(0,AM0E2,NAM0E2,3,3)#                                         AM02 122
writeline:(0,AM0E5,NAM0E5,3,3)#        Write out no. points summed      AM02 123
makereal:(NP2,3)#                      Real-ize integer array           AM02 124
ncodefld:(BUFOT,1,AM0E2,FMTR21,3)#                                      AM02 125
writeline:(0,AM0E2,NAM0E2,3,3)#                                         AM02 126
#                                                                       AM02 127
#                                                                       AM02 128
RETURN#                                                                 AM02 129
END#                                                                    AM02 130
systemheader:(AM03)#                   Determine layout for both maps   AM03   1
# ####################################################################  AM03   2
#                                                                       AM03   3
#                                AM03                                   AM03   4
#                                                                       AM03   5
# ####################################################################  AM03   6
SUBROUTINE AM03#                                                        AM03   7
include:(AACOMN)#                                                       AM03   8
include:(AMCOMN)#                                                       AM03   9
#                                                                       AM03  10
INTEGER I#                                                              AM03  11
INTEGER IP#                            Input buffer pointer             AM03  12
#                                                                       AM03  13
copyfile:(3,6,incr:(lrcell:),20)#      Copy other records to scratch    AM03  14
#                                                                       AM03  15
#  READ REC21 INFO                                                      AM03  16
#  ---------------                                                      AM03  17
#                                                                       AM03  18
CALL AM21#                                                              AM03  19
#                                                                       AM03  20
#  READ FIRST RECORDS OF MASK MAP TO GET ITS LAYOUT                     AM03  21
#  ------------------------------------------------                     AM03  22
#                                                                       AM03  23
readwpkt:(4,21,PSIZ,IP,0)#                                              AM03  24
DO I=1,3 ; NG1(I)=NINT(QX(IP+I))#                                       AM03  25
readwpkt:(4,21,PSIZ,IP,0)#                                              AM03  26
DO I=1,3 ; INCX1(I)=NINT(QX(IP+I))#                                     AM03  27
readwpkt:(4,21,PSIZ,IP,0)#                                              AM03  28
DO I=1,3 ; ISUM1(I)=NINT(QX(IP+I))#                                     AM03  29
readwpkt:(4,21,PSIZ,IP,0)#                                              AM03  30
DO I=1,3 ; JSUM1(I)=NINT(QX(IP+I))#                                     AM03  31
#                                                                       AM03  32
#  IS LAYOUT OF INPUT MAP SAME AS MASK MAP LAYOUT?                      AM03  33
#  -----------------------------------------------                      AM03  34
#                                                                       AM03  35
DO ITEST=1,3#                                                           AM03  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AM03  37
IF (NG1(ITEST)!=NG2(ITEST))     iquit:(AM0301)#                         AM03  38
IF (IORGX2(ITEST)!=0)           iquit:(AM0301)#                         AM03  39
IF (NP2(ITEST)!=NG2(ITEST))     iquit:(AM0301)#                         AM03  40
IF (INCX1(ITEST)!=INCX2(ITEST)) iquit:(AM0301)#                         AM03  41
IF (JSUM1(ITEST)!=JSUM2(ITEST)) iquit:(AM0301)#                         AM03  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AM03  43
MAPSIZ = NG1(1)/INCX1(1) * NG1(2)/INCX1(2) * NG1(3)/INCX1(3)#           AM03  44
incrqx:(MARK4,MARK3+(MAPSIZ/mxchwd:)+1,AM0302)# Expand mem.....0301     AM03  45
#                                                                       AM03  46
RETURN#                                                                 AM03  47
END#                                                                    AM03  48
systemheader:(AM04)#                   Compare fourier and mask maps    AM04   1
# ####################################################################  AM04   2
#                                                                       AM04   3
#                               AM04                                    AM04   4
#                                                                       AM04   5
# ####################################################################  AM04   6
SUBROUTINE AM04#                                                        AM04   7
include:(AACOMN)#                                                       AM04   8
include:(AMCOMN)#                                                       AM04   9
#                                                                       AM04  10
INTEGER I,J#                           Working indices                  AM04  11
INTEGER PSIZE#                                                          AM04  12
REAL BITIN(mxrec:)#                    Input record for mask map        AM04  13
REAL MINOUT#                           Min masked density value         AM04  14
REAL MAXOUT#                           Max masked density value         AM04  15
REAL AVGOUT#                           Avg masked density value         AM04  16
REAL MAXALL#                           Max density for entire map       AM04  17
REAL MININ#                            Min unmasked density value       AM04  18
REAL MAXIN#                            Max unmasked density value       AM04  19
REAL AVGIN#                            Avg unmasked density value       AM04  20
REAL VALIN#                            Sum of unmasked density          AM04  21
REAL VALOUT#                           Sum of masked density            AM04  22
INTEGER NOUT#                          Number masked density            AM04  23
INTEGER NIN#                           Number unmasked density          AM04  24
#                                                                       AM04  25
chardata:(AM04A,[STATISTICS FOR SCALED INPUT MAP...])#                  AM04  26
chardata:(AM04B,[STATISTICS FOR SCALED/OFFSET OUTPUT MAP...])#          AM04  27
chardata:(AM041,[  AVERAGE DENSITY IN MOLECULE REGION    = XXXX.XXX])#  AM04  28
chardata:(AM042,[  MINIMUM DENSITY IN MOLECULE REGION    = XXXX.XXX])#  AM04  29
chardata:(AM043,[  MAXIMUM DENSITY IN MOLECULE REGION    = XXXX.XXX])#  AM04  30
chardata:(AM044,[  NUMBER OF DENSITIES IN MOLECULE REGION= XXXXXXXX])#  AM04  31
chardata:(AM045,[  AVERAGE DENSITY IN SOLVENT REGION     = XXXX.XXX])#  AM04  32
chardata:(AM046,[  MINIMUM DENSITY IN SOLVENT REGION     = XXXX.XXX])#  AM04  33
chardata:(AM047,[  MAXIMUM DENSITY IN SOLVENT REGION     = XXXX.XXX])#  AM04  34
chardata:(AM048,[  NUMBER OF DENSITIES IN SOLVENT REGION = XXXXXXXX])#  AM04  35
chardata:(AM049,[  OFFSET ADDED TO ALL DENSITIES         = XXXXXXXX])#  AM04  36
realdata:(FMT,500832.)#                                                 AM04  37
realdata:(FMT2,500813.)#                                                AM04  38
datastuff:#                                                             AM04  39
#                                                                       AM04  40
#                                                                       AM04  41
# READ MASK MAP FROM BINARY FILE                                        AM04  42
# ------------------------------                                        AM04  43
#                                                                       AM04  44
IREC=0#                                                                 AM04  45
REPEAT#                                                                 AM04  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AM04  47
readwpkt:(4,22,IRECL,IPP,0)#           Read next packet of mask         AM04  48
IF(IREC==0)#                           See if first packet              AM04  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AM04  50
ILEFT = IRECL*mxbtwd: + MAPSIZ#        If so set counts                 AM04  51
IFIRST=-IRECL#                         512 record/ values per wrd       AM04  52
IGET = IRECL*mxbtwd:#                  No. bits per rec                 AM04  53
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AM04  54
ILEFT = ILEFT - IGET#                                                   AM04  55
IFIRST = IFIRST + IRECL#               16 words per 512 bits            AM04  56
IF (ILEFT <= 0) BREAK#                                                  AM04  57
IF (ILEFT < IGET) IGET = ILEFT#        Less than full record left       AM04  58
IREC = IREC+1#                                                          AM04  59
###DO IY=1,IRECL ; movereal:(QX(IPP+IY),BITIN(IY))# Move mask to memor  AM04  60
movereal:(QX,IPP+1,BITIN,1,IRECL,0)#   Move mask to memory              AM04  61
DO I=1,IGET#                                                            AM04  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AM04  63
ILOC = MOD(I-1,mxbtwd:)#               Bit position in bit array        AM04  64
IWRD = INT((I-1)/mxbtwd:)+1#           Word of bit array                AM04  65
intunpak:(BITIN(IWRD),ITEMP,ILOC,1)#   Get mask bit                     AM04  66
intpak:(ITEMP,QX(MARK3+IWRD+IFIRST),ILOC,1)# Put into display ma        AM04  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AM04  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AM04  69
#                                                                       AM04  70
#   SET UP FOR PASS THRU FOURIER MAP                                    AM04  71
#   ----------------------------------                                  AM04  72
#                                                                       AM04  73
VALIN=0.0; VALOUT=0.0#                                                  AM04  74
NIN=0; NOUT=0#                                                          AM04  75
MININ=99999.0; MAXIN=-99999.0#                                          AM04  76
MINOUT=99999.0; MAXOUT=-99999.0#                                        AM04  77
IPAG = 1#                              First page of mask               AM04  78
IROW = 0#                              First row of mask                AM04  79
ILOC=0#                                                                 AM04  80
#                                                                       AM04  81
#   PASS THRU FOURIER MAP TO GET DATA STATISTICS                        AM04  82
#   --------------------------------------------                        AM04  83
#   TEMP MAP IS OUTPUT TO SCRATCH FILE = F                              AM04  84
#                                                                       AM04  85
REPEAT#                                Loop thru rec 22's               AM04  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AM04  87
readwpkt:(3,22,PSIZE,IPT,0)#           Read 1 map row                   AM04  88
IF(IPT<=0) BREAK#                      No more rec 22's                 AM04  89
writepkt:(6,22,PSIZE,JPT)#             Write scratch file               AM04  90
IROW = IROW + 1#                       New mask row                     AM04  91
IF (IROW>NG1(2))#                      New page yet??                   AM04  92
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AM04  93
IROW = 1#                              New row                          AM04  94
IPAG = IPAG+1#                         Yes, new page                    AM04  95
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AM04  96
DO J=1,NG2(3)#                         Scan thru row of densities       AM04  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AM04  98
ILOC = ILOC+1#                                                          AM04  99
IBIT = MOD(ILOC-1,mxbtwd:)#            Bit position in qx word          AM04 100
IWRD = INT((ILOC-1)/mxbtwd:)+1#        Qx word holding mask bit         AM04 101
intunpak:(QX(MARK3+IWRD),ITEST,IBIT,1)# Get mask bit to use             AM04 102
SCADEN = QX(IPT+J)*SCALE#              Apply scale factor to all data   AM04 103
#                                                                       AM04 104
#....MOLECULAR REGION OF MAP                                            AM04 105
#                                                                       AM04 106
IF (ITEST>0)#                          Molecule region density...       AM04 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AM04 108
QX(JPT+J)=SCADEN#                      Output density as read           AM04 109
NIN=NIN+1#                                                              AM04 110
VALIN=VALIN+QX(JPT+J)#                 Total density                    AM04 111
IF(QX(JPT+J)>MAXIN) MAXIN=QX(JPT+J)#   Update maximum                   AM04 112
ELSE IF(QX(JPT+J)<MININ) MININ=QX(JPT+J)# Update minimum                AM04 113
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AM04 114
#                                                                       AM04 115
#....SOLVENT REGION OF MAP                                              AM04 116
#                                                                       AM04 117
ELSE#                                  Solvent region of density...     AM04 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AM04 119
NOUT=NOUT+1#                                                            AM04 120
QX(JPT+J)=voidflg:#                    Density assigned on pass 2       AM04 121
VALOUT=VALOUT+QX(IPT+J)#               Total density for average        AM04 122
IF(QX(IPT+J)>MAXOUT) MAXOUT=QX(IPT+J)# Update maximum sol density       AM04 123
ELSE IF(QX(IPT+J)<MINOUT) MINOUT=QX(IPT+J)# Update minimum              AM04 124
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AM04 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AM04 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AM04 127
copyfile:(3,6,23,endrecord:)#          Close input & scratch files      AM04 128
#                                                                       AM04 129
MAXALL = AMAX1(MAXIN,MAXOUT)#          Maximim dens value of all map    AM04 130
IF(NIN!=0) AVGIN = VALIN/NIN#          Average density for molec        AM04 131
IF(NOUT!=0) AVGOUT= VALOUT/NOUT#       Average density for solv regio   AM04 132
#                                                                       AM04 133
#  WRITE STATISTICS FOR FIRST PASS                                      AM04 134
#  ===============================                                      AM04 135
#                                                                       AM04 136
writeline:(2,AM04A,NAM04A,3,3)#        Title                            AM04 137
ncodefld:(AVGIN,1,AM041,FMT,1)#                                         AM04 138
writeline:(1,AM041,NAM041,3,3)#        Average unmasked                 AM04 139
ncodefld:(MININ,1,AM042,FMT,1)#                                         AM04 140
writeline:(0,AM042,NAM042,3,3)#        Min unmasked                     AM04 141
ncodefld:(MAXIN,1,AM043,FMT,1)#                                         AM04 142
writeline:(0,AM043,NAM043,3,3)#        Max unmasked                     AM04 143
ncodefld:(FLOAT(NIN),1,AM044,FMT2,1)#                                   AM04 144
writeline:(0,AM044,NAM044,3,3)#        Number unmasked                  AM04 145
ncodefld:(AVGOUT,1,AM045,FMT,1)#                                        AM04 146
writeline:(1,AM045,NAM045,3,3)#        Average masked                   AM04 147
ncodefld:(MINOUT,1,AM046,FMT,1)#                                        AM04 148
writeline:(0,AM046,NAM046,3,3)#        Min masked                       AM04 149
ncodefld:(MAXOUT,1,AM047,FMT,1)#                                        AM04 150
writeline:(0,AM047,NAM047,3,3)#        Max masked                       AM04 151
ncodefld:(FLOAT(NOUT),1,AM048,FMT2,1)#                                  AM04 152
writeline:(0,AM048,NAM048,3,3)#        Number masked                    AM04 153
#                                                                       AM04 154
#  PREPARE FOR SECOND PASS THRU DATA                                    AM04 155
#  ---------------------------------                                    AM04 156
#                                                                       AM04 157
IF(SRATIO!=voidflg:) OFFSET = (SRATIO*MAXALL-AVGOUT)/(1.0-SRATIO)#      AM04 158
ELSE OFFSET = FZOVOL#                                                   AM04 159
IF(AVGDEN==yes:) SDENS=AVGOUT+OFFSET#                                   AM04 160
ELSE SDENS = SOLDEN#                                                    AM04 161
VALIN=0.0; VALOUT=0.0#                                                  AM04 162
MININ=99999.0; MAXIN=-99999.0#                                          AM04 163
MINOUT=99999.0; MAXOUT=-99999.0#                                        AM04 164
copyfile:(6,5,1,21)#                   Copy prologue to file 'mmp'      AM04 165
#                                                                       AM04 166
#  SECOND PASS THRU DATA IF SOLV DENS TO BE SET TO AVERAGE VALUE        AM04 167
#  -------------------------------------------------------------        AM04 168
#                                                                       AM04 169
REPEAT#                                Loop thru rec 22's               AM04 170
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AM04 171
readwpkt:(6,22,PSIZE,IPT,0)#           Read 1 map row                   AM04 172
IF(IPT<=0) BREAK#                      No more rec 22's                 AM04 173
writepkt:(5,22,PSIZE,JPT)#                                              AM04 174
DO I=1,NG2(3)#                         Look thru row for solvent dens   AM04 175
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AM04 176
IF(QX(IPT+I)==voidflg:) QX(JPT+I)=SDENS# Assign solvent region densit   AM04 177
ELSE#                                                                   AM04 178
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AM04 179
QX(JPT+I)=QX(IPT+I)+OFFSET#            Only store noneg densities       AM04 180
IF(NONEG==yes: & QX(JPT+I)<0) QX(JPT+I)=0.0# Not allow neg density      AM04 181
VALIN=VALIN+QX(JPT+I)#                 Total density                    AM04 182
IF(QX(JPT+I)>MAXIN) MAXIN=QX(JPT+I)#   Update maximum                   AM04 183
ELSE IF(QX(JPT+I)<MININ) MININ=QX(JPT+I)# Update minimum                AM04 184
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AM04 185
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AM04 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AM04 187
AVGIN = VALIN/NIN#                                                      AM04 188
copyfile:(6,5,23,endrecord:)#          Close scratch and mmp files      AM04 189
#                                                                       AM04 190
#  WRITE STSTISTICS                                                     AM04 191
#  ================                                                     AM04 192
#                                                                       AM04 193
writeline:(2,AM04B,NAM04B,3,3)#        Title                            AM04 194
ncodefld:(OFFSET,1,AM049,FMT,1)#                                        AM04 195
writeline:(1,AM049,NAM049,3,3)#        Offset value                     AM04 196
ncodefld:(AVGIN,1,AM041,FMT,1)#                                         AM04 197
writeline:(1,AM041,NAM041,3,3)#        Average unmasked                 AM04 198
ncodefld:(MININ,1,AM042,FMT,1)#                                         AM04 199
writeline:(0,AM042,NAM042,3,3)#        Min unmasked                     AM04 200
ncodefld:(MAXIN,1,AM043,FMT,1)#                                         AM04 201
writeline:(0,AM043,NAM043,3,3)#        Max unmasked                     AM04 202
ncodefld:(SDENS,1,AM045,FMT,1)#                                         AM04 203
writeline:(1,AM045,NAM045,3,3)#        Average masked                   AM04 204
#                                                                       AM04 205
#                                                                       AM04 206
RETURN#                                                                 AM04 207
END#                                                                    AM04 208
systemheader:(AM21)#                   Read rec 21, set limits          AM21   1
#######################################################                 AM21   2
#                                                                       AM21   3
#                      AM21                                             AM21   4
#                                                                       AM21   5
#######################################################                 AM21   6
SUBROUTINE AM21#                                                        AM21   7
#                                                                       AM21   8
include:(AACOMN)#                                                       AM21   9
include:(AMCOMN)#                                                       AM21  10
#                                                                       AM21  11
INTEGER IPT#                                                            AM21  12
INTEGER IIP#                                                            AM21  13
INTEGER PSIZE#          ## REC 21 PACKET SIZE                           AM21  14
#                                                                       AM21  15
#   READ REC 21 DATA                                                    AM21  16
#   ----------------                                                    AM21  17
#                                                                       AM21  18
#*** REC21 CONTENTS *******************                                 AM21  19
#                                                                       AM21  20
# NOTE: IORGX,INCX,NG AND NP ARE ALL ORDERED SO THAT 1 IS PAGE TO PAGE, AM21  21
#       2 IS DOWN PAGE AND 3 IS ACROSS PAGE                             AM21  22
#                                                                       AM21  23
#       IORGX IS THE ORIGIN IN EACH DIRECTION                           AM21  24
# INCX IS THE INCREMENT IN EACH DIRECTION                               AM21  25
# NG IS THE GRID "FINENESS"                                             AM21  26
# NP IS THE NUAMER OF POINTS IN A DIRECTION THAT ARE TO BE SUMMED       AM21  27
#         OVER                                                          AM21  28
# ISUM IS THE COMPUTATIONAL VARIABLE CORRESPONDING TO THE CRYSTAL       AM21  29
#       VARIABLE                                                        AM21  30
# JSUM IS THE CRYSTAL VARIABLE CORRESPONDING TO THE COMPUTATIONAL       AM21  31
#         VARIABLE                                                      AM21  32
#***********************************                                    AM21  33
#                                                                       AM21  34
readwpkt:(3,21,PSIZE,IPT,0)#                                            AM21  35
IF(IPT < 0) iquit:(AM2101)#            No rec 21 in bdf#                AM21  36
writepkt:(6,21,PSIZE,JPT)#                                              AM21  37
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#                                   AM21  38
DO K=1,3#                                                               AM21  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AM21  40
IIP = IPT + K#                                                          AM21  41
IORGX2(K)=NINT(QX(IIP))#               Pick up origins                  AM21  42
INCX2(K)=NINT(QX(IIP+3))#              Increments along axes            AM21  43
NG2(K)=NINT(QX(IIP+6)/INCX2(K))#       No. of grid points               AM21  44
NP2(K)=NINT(QX(IIP+9))#                Calculated points                AM21  45
ISUM2(K)=NINT(QX(IIP+12))#             Correlations between crystal     AM21  46
JSUM2(K)=NINT(QX(IIP+15))#             Axes and calculation axes        AM21  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AM21  48
#                                                                       AM21  49
#   INITIALIZE E.D. MAP                                                 AM21  50
#   -------------------                                                 AM21  51
#                                                                       AM21  52
MAPSIZ = NG2(1)*NG2(2)*NG2(3)#                                          AM21  53
#                                                                       AM21  54
#                                                                       AM21  55
RETURN#                                                                 AM21  56
END#                                                                    AM21  57
systemheader:(AM05)#                   Write out mask map               AM05   1
#######################################################                 AM05   2
#                                                                       AM05   3
#                      AM05                                             AM05   4
#                                                                       AM05   5
#######################################################                 AM05   6
SUBROUTINE AM05#                                                        AM05   7
#                                                                       AM05   8
include:(AACOMN)#                                                       AM05   9
include:(AMCOMN)#                                                       AM05  10
#                                                                       AM05  11
chardata:(AM052, Y ACROSS IN   THS          X DOWN IN   THS         $#  AM05  12
Z LAYER=   /   THS)#                                                    AM05  13
chardata:(XYZ,XYZ.)#                                                    AM05  14
realdata:(STARTF,0.); realdata:(HEADF,0.)#                              AM05  15
datastuff:#                                                             AM05  16
#                                                                       AM05  17
#   PRINT MAP LINE IF REQUESTED                                         AM05  18
#   ---------------------------                                         AM05  19
#        #                                                              AM05  20
IF(PRINT==yes:)#                                                        AM05  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AM05  22
LINPNT = 0#                                                             AM05  23
IPAGE =  1#                            Page, x=1,y=2,3=z                AM05  24
IDOWN =  2#                                                             AM05  25
IACRS =  3#                            Across x=1,y=2,3=z               AM05  26
DO IZ=1,NG2(IPAGE)#                                                     AM05  27
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AM05  28
LINCT = 0#                             Force top of page                AM05  29
IZZ = IZ * INCX2(IPAGE)#                                                AM05  30
movechar:(XYZ,JSUM2(3),AM052,2,1,0)#                                    AM05  31
ncodefld:(FLOAT(NG2(IACRS)),1,AM052,150313.,1)#                         AM05  32
movechar:(XYZ,JSUM2(2),AM052,29,1,0)#                                   AM05  33
ncodefld:(FLOAT(NG2(IDOWN)),1,AM052,400313.,1)#                         AM05  34
movechar:(XYZ,JSUM2(1),AM052,53,1,0)#                                   AM05  35
ncodefld:(FLOAT(IZZ),1,AM052,630313.,1)#                                AM05  36
ncodefld:(FLOAT(NG2(IPAGE)),1,AM052,670313.,1)#                         AM05  37
writeline:(0,AM052,NAM052,3,3)#        Move the line to the printer     AM05  38
#                                                                       AM05  39
#  ENCODE COLUMN HEADERS                                                AM05  40
#  --------------------                                                 AM05  41
FMT = 70213.#                                                           AM05  42
IFIT = (NG2(3)/70)#                                                     AM05  43
IF(MOD(NG2(3),70)!=0) IFIT=IFIT+1#     Skip factor to make map fit      AM05  44
DO II=1,NG2(3),IFIT#                                                    AM05  45
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AM05  46
A= FLOAT(II*INCX2(IACRS))#                                              AM05  47
ncodefld:(A,1,CHROT,FMT,1)#                                             AM05  48
FMT=FMT+20000.#                                                         AM05  49
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AM05  50
writeline:(2,0,0,1,3)#                 Move the line to the printer     AM05  51
#                                                                       AM05  52
#  ENCODE ROW    VALUES                                                 AM05  53
#  --------------------                                                 AM05  54
DO IX=1,NG2(IDOWN)#                                                     AM05  55
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AM05  56
IXX= IX*INCX2(IDOWN)#                  Encode line coordinate           AM05  57
STARTF = 40213.#                                                        AM05  58
ncodefld:(FLOAT(IXX),1,CHROT,40213.,1)#                                 AM05  59
FMT=STARTF+20000.#                     Set up format for first co       AM05  60
DO IYY=1,NG2(IACRS),IFIT#              Move the fourier to the outp     AM05  61
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AM05  62
ILOC=(IYY+(IX-1)*NG2(3)+(IZ-1)*NG2(2)*NG2(3))#                          AM05  63
IBIT = MOD(ILOC-1,32)#                 Bit position in qx word          AM05  64
IWRD = INT((ILOC-1)/32)+1#             Qx word holding map value        AM05  65
intunpak:(QX(MARK3+IWRD),IA,IBIT,1)#   Get mask bit to use              AM05  66
A=FLOAT(IA)*PRTSKL#                    Display map value                AM05  67
#                                                                       AM05  68
# REPLACE 0'S WITH DOTS                                                 AM05  69
#                                                                       AM05  70
IF(A==0.0) movechar:(' .',1,CHROT,INT(FMT/10000)-1,2,0)#                AM05  71
ELSE ncodefld:(A,1,CHROT,FMT,1)#                                        AM05  72
FMT=FMT+20000.#                                                         AM05  73
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AM05  74
writeline:(LINPNT,0,0,1,3)#            Move the line to the printer     AM05  75
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AM05  76
LINCT=0#                               Reset line count                 AM05  77
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AM05  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AM05  79
readwpkt:(4,endrecord:,PSIZ,IPP,0)#    Close out mask file              AM05  80
RETURN#                                                                 AM05  81
END#                                                                    AM05  82
pmacro:([no:])#                        Purge xtal system macros         AM05  83
