systemheader:(AP    )#                                                  AP     1
# ############################################################## #      AP     2
##      Copyright (C) 2000, The Xtal System, The University of        # AP     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # AP     4
## Distributed under the GNU General Public Licence as published by   # AP     5
## the Free Software Foundation, in the hope that it will be useful   # AP     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # AP     7
## for more details.                                                  # AP     8
#                                                                #      AP     9
#                         *** ADDPAT ***                         #      AP    10
#                                                                #      AP    11
#     PROGRAM TO CREATE A BINARY POWDER PATTERN FILE             #      AP    12
#                                                                #      AP    13
# ############################################################## #      AP    14
##   version: 17/02/2000  last change ddb                               AP    15
#                                                                       AP    16
include:(XMACRO)#                                                       AP    17
#                                                                       AP    18
macro:(maxpha:,10)#                                                     AP    19
macro:(lrppha:,3)#                                                      AP    20
macro:(lrpwav:,4)#                                                      AP    21
macro:(lrplim:,5)#                                                      AP    22
macro:(lrppat:,6)#                                                      AP    23
macro:(mxwdim:,incr:(arith:(decr:(mxchim:),/,mxchwd:)))#                AP    24
#                                                                       AP    25
extrude:(APCOMN)#                                                       AP    26
string:(LABEL,80)#                     Label info store                 AP    27
CHARACTER PHASE(maxpha:)*6#            Phase names                      AP    28
INTEGER FTYPE#                         Input format type                AP    29
INTEGER NLABEL#                        Label store length               AP    30
INTEGER NPHASE#                        Number of phases                 AP    31
INTEGER LPCOR#                         Lpcorrected no/yes               AP    32
INTEGER DIVERG#                        Diverg slit 0/1 fixed/var        AP    33
INTEGER RADTYP#                        0/1 xray/neutron radiation       AP    34
REAL LAMDA1,LAMDA2#                    Wavelenth alpha1,2               AP    35
REAL LAMRAT#                           Int ratio alpha2/alpha1          AP    36
REAL POLRAT#                           Polarisation ratio               AP    37
COMMON/COMIAP/NLABEL,FTYPE,LPCOR,DIVERG,RADTYP#                         AP    38
COMMON/COMCAP/LABEL#                                                    AP    39
COMMON/COMCFAP/LAMDA1,LAMDA2,LAMRAT,POLRAT#                             AP    40
endext:#                                                                AP    41
#                                                                       AP    42
systemheader:(AP00)#                   Main program                     AP00   1
# ################################################################ #    AP00   2
#                                                                  #    AP00   3
#                                 AP00                             #    AP00   4
#                                                                  #    AP00   5
# ################################################################ #    AP00   6
SUBROUTINE AP00#                                                        AP00   7
#                                                                       AP00   8
include:(AACOMN)#                                                       AP00   9
include:(APCOMN)#                                                       AP00  10
INTEGER IP#                                                             AP00  11
#                                                                       AP00  12
CALL AP10#                             Read control parameters          AP00  13
#                                                                       AP00  14
IF(FTYPE==1) CALL AP21#                Process philips input data       AP00  15
IF(FTYPE==2) CALL AP22#                Process rawdata input data       AP00  16
IF(FTYPE==3) CALL AP23#                Process wyriet  input data       AP00  17
IF(FTYPE==4) CALL AP24#                Process pc-apd  input data       AP00  18
IF(FTYPE==5) CALL AP25#                Process uxd     input data       AP00  19
IF(FTYPE==6) CALL AP26#                Process rietan  input data  
#                                                                       AP00  20
SYNTXF=0;  CHRIN=LABEL#                Set syntax checking on           AP00  21
writepkt:(3,endrecord:,1,IP)#          Close the output binary file     AP00  22
closefmt:(iofm1:)#                     Close the input data file        AP00  23
#                                                                       AP00  24
RETURN#                                                                 AP00  25
END#                                                                    AP00  26
systemheader:(AP10)#                   Enter control options            AP10   1
# ################################################################ #    AP10   2
#                                                                  #    AP10   3
#                                 AP10                             #    AP10   4
#                                                                  #    AP10   5
# ################################################################ #    AP10   6
SUBROUTINE AP10#                                                        AP10   7
#                                                                       AP10   8
include:(AACOMN)#                                                       AP10   9
include:(APCOMN)#                                                       AP10  10
INTEGER I,M,N,L,J#                                                      AP10  11
INTEGER IP#                                                             AP10  12
#                                                                       AP10  13
string:(CH,8)#                                                          AP10  14
chardata:(AP1,END LABEL BACKGR PHASES WAVLEN )#                         AP10  15
chardata:(AP2,PHI RAW WYR APD UXD TAN )# 
chardata:(AP3,"Philips   Raw data  Wyriet    PC-APD    Unvrsl XRD $#
Rietan2k    ")
chardata:(AP4,INP OUT TYP )#                                            AP10  18
chardata:(AP5,' ADDPAT Control Parameters-')#                           AP10  19
chardata:(AP6,' Input file extension            ')#                     AP10  20
chardata:(AP7,' Output bdf extension            ')#                     AP10  21
chardata:(AP8,' Input file type                       ')#               AP10  22
datastuff:#                                                             AP10  23
#                                                                       AP10  24
#   SET DEFAULT VALUES                                                  AP10  25
#   ------------------                                                  AP10  26
#                                                                       AP10  27
FILEXT(iofm1:)='POW'#                  Default ext for input file       AP10  28
FILEXT(IOUNIT(3))='PAT'#               Default ext of output file       AP10  29
IOMARK(3)=QXSTR#                       Start of output bdf buffer       AP10  30
incrqx:(I,IOMARK(3)+bdfbuf:,AP1005)#   Start of data array              AP10  31
FTYPE=1#                               Def file type is philips         AP10  32
NLABEL=0#                              Default is no label input        AP10  33
PHASE(1)=COMPID#                       , compid default phase name      AP10  34
NPHASE=1#                              Default number of phases         AP10  35
LAMDA1=1.540598#                       Wavelength alpha1                AP10  36
LAMDA2=0.#                             Default wavelength alpha2        AP10  37
LAMRAT=0.#                             Default alpha2/1 int ratio       AP10  38
POLRAT=.915#                           Default polarisation ratio       AP10  39
RADTYP=3#                              Default xrays                    AP10  40
DIVERG=0#                              Default fixed diverg slit        AP10  41
LPCOR=no:#                             Default not lp corrected         AP10  42
#                                                                       AP10  43
#   PROCESS PROGRAM LINE                                                AP10  44
#   --------------------                                                AP10  45
#                                                                       AP10  46
FOR(I=1;BUFIN(I)<voidflg:;I=I+1)#      Loop input options               AP10  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AP10  48
stringlim:(I,M,N)#                     Get string position              AP10  49
compchar:(CHRIN,M,AP4,1,3,4,NAP4,L)#   Identify string                  AP10  50
IF(L==0) iquit:(AP1001)#               Unidentifiable control           AP10  51
#                                                                       AP10  52
IF(L==1)#                              Input file extension             AP10  53
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AP10  54
I=I+1; stringlim:(I,M,N)#              Get ext limits                   AP10  55
FILEXT(iofm1:)=CHRIN(M^M+N-1)#         File ext max 3 char              AP10  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AP10  57
IF(L==2)#                              Output file extension            AP10  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AP10  59
I=I+1; stringlim:(I,M,N)#              Get ext limits                   AP10  60
FILEXT(IOUNIT(3))=CHRIN(M^M+N-1)#      File ext max 3 char #            AP10  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AP10  62
IF(L==3)#                              Format type                      AP10  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AP10  64
I=I+1; stringlim:(I,M,N)#              Get string limits                AP10  65
compchar:(CHRIN,M,AP2,1,3,4,NAP2,J)#   Identify string                  AP10  66
IF(J==0) iquit:(AP1002)#               Unidentifiable type              AP10  67
FTYPE=J#                               Store file type                  AP10  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AP10  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AP10  70
#                                                                       AP10  71
#      PROCESS CONTROL LINES                                            AP10  72
#      ---------------------                                            AP10  73
#                                                                       AP10  74
REPEAT#                                Loop over input lines            AP10  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AP10  76
readline:(AP1,NAP1)#                   Read next input line             AP10  77
#                                                                       AP10  78
IF(LINID==1) BREAK#                    End line so all finished         AP10  79
#                                                                       AP10  80
IF(LINID==2)#                          ******** label line *********    AP10  81
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AP10  82
LABEL=CHRIP(7^80);  NLABEL=CHRMAX#     Store label label length         AP10  83
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AP10  84
#                                                                       AP10  85
IF(LINID==3) ;#                        ******** backgr line ********    AP10  86
#                                                                       AP10  87
IF(LINID==4)#                          ******** phases line *********   AP10  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AP10  89
NPHASE=0#                              Total number of phases           AP10  90
FOR(I=1;BUFIN(I)<voidflg:;I=I+1)#      Loop over names                  AP10  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AP10  92
NPHASE=NPHASE+1#                       Count another phase              AP10  93
stringlim:(I,M,N)#                     Get string position              AP10  94
PHASE(I)=CHRIN(M^M+N-1)#               Store phase name                 AP10  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AP10  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AP10  97
#                                                                       AP10  98
IF(LINID==5)#                          ******** wavlen line *********   AP10  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AP10 100
ifnv:(BUFIN(1)) LAMDA1=BUFIN(1)#       Wavelength alpha1                AP10 101
ifnv:(BUFIN(2)) LAMDA2=BUFIN(2)#       Wavelength alpha2                AP10 102
ifnv:(BUFIN(3)) LAMRAT=BUFIN(3)#       Alpha1/2 int ratio               AP10 103
ifnv:(BUFIN(4)) POLRAT=BUFIN(4)#       Polarisation ratio               AP10 104
ifch:(BUFIN(5))#                                                        AP10 105
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AP10 106
stringlim:(I,M,N)#                     Get string position              AP10 107
IF(CHRIN(M^M+1)=='X')      RADTYP=3#   Xrays                            AP10 108
ELSE IF(CHRIN(M^M+1)=='E') RADTYP=2#   Electrons                        AP10 109
ELSE IF(CHRIN(M^M+1)=='N') RADTYP=1#   Neutrons                         AP10 110
ELSE                       RADTYP=4#   Synchrotron x-rays               AP10 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AP10 112
ifnv:(BUFIN(6)) DIVERG=NINT(BUFIN(6))# Fix/var diverg slit              AP10 113
ifnv:(BUFIN(7)) LPCOR=NINT(BUFIN(7))#  No/yes lp corrected              AP10 114
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AP10 115
#                                                                       AP10 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AP10 117
#                                                                       AP10 118
#      PRINT CONTROL PARAMETERS                                         AP10 119
#      ------------------------                                         AP10 120
#                                                                       AP10 121
movechar:(AP5,NAP5,CHROT,2,NAP5-2,2)#  Insert header under line         AP10 122
writeline:(1,AP5,NAP5-1,2,3)#          Print controls header            AP10 123
movechar:(FILEXT(iofm1:),1,AP6,30,3,0)# Insert input file ext           AP10 124
writeline:(0,AP6,NAP6,3,3)#            Print input file ext             AP10 125
movechar:(FILEXT(IOUNIT(3)),1,AP7,30,3,0)# Insert output file ext       AP10 126
writeline:(0,AP7,NAP7,3,3)#            Print output file ext            AP10 127
movechar:(AP3,FTYPE*10-9,AP8,30,10,0)# Insert input file type           AP10 128
writeline:(0,AP8,NAP8,3,3)#            Print input file type            AP10 129
writeline:(1,AP5,1,3,3)#               Print blank line                 AP10 130
openfmt:(iofm1:,' ')#                  Open the input data              AP10 131
#                                                                       AP10 132
#                                                                       AP10 133
#      START OUTPUT BINARY FILE                                         AP10 134
#      ------------------------                                         AP10 135
#                                                                       AP10 136
#WRITEPKT:(3,1,3,IP)#                   RECORD 1: FOR PROG, DATE, TIME  AP10 137
writepkt:(3,lrlabl:,mxwdim:,IP)#       Lrlabl: for date and time        AP10 138
movector:(BLANK,1,QX(IP+1),1,mxchim:,1)# Blank out packet               AP10 139
movector:(TITLE,18,QX(IP+1),1,8,0)#    Insert current date              AP10 140
gettime:(CH)#                          Get current time                 AP10 141
movector:(CH,1,QX(IP+1),10,8,0)#       Insert current time              AP10 142
writepkt:(3,lrlabl:,mxwdim:,IP)#       **** writepkt ****               AP10 143
movector:(BLANK,1,QX(IP+1),1,mxchim:,1)# Blank out packet               AP10 144
movector:(TITLE,59,QX(IP+1),1,72,0)#   Creation header line             AP10 145
IF(NLABEL>=1)#                         Label info in store              AP10 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AP10 147
writepkt:(3,lrlabl:,mxwdim:,IP)#       **** writepkt ****               AP10 148
movector:(BLANK,1,QX(IP+1),1,mxchim:,1)# Blank out packet               AP10 149
movector:(LABEL,1,QX(IP+1),1,NLABEL,0)# Move in label image             AP10 150
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AP10 151
#                                                                       AP10 152
writepkt:(3,lrppha:,10,IP)#            Prepare phase rec packet         AP10 153
QX(IP+1)=FLOAT(NPHASE)#                Number of phases                 AP10 154
DO I=1,NPHASE#                         All phases                       AP10 155
movector:(PHASE,I,QX(IP+1+I),1,6,0)#   Phase names                      AP10 156
DO I=NPHASE+1,10#                                                       AP10 157
movector:(BLANK,1,QX(IP+1+I),1,6,0)#   Blank out packet                 AP10 158
LABEL=CHRIN; CHRCOL=1; CHRMAX=79#      Save the current line image      AP10 159
#                                                                       AP10 160
RETURN#                                                                 AP10 161
END#                                                                    AP10 162
systemheader:(AP21)#                   Process philips diffr data       AP21   1
# ################################################################ #    AP21   2
#                                                                  #    AP21   3
#                                 AP21                             #    AP21   4
#                                                                  #    AP21   5
# ################################################################ #    AP21   6
SUBROUTINE AP21#                                                        AP21   7
#                                                                       AP21   8
include:(AACOMN)#                                                       AP21   9
include:(APCOMN)#                                                       AP21  10
INTEGER LINE,IDATA,IP,I#                                                AP21  11
REAL TTMIN,TTMAX,TTSTEP,YMAX,STEP,ANGLE#                                AP21  12
chardata:(AP6," Number of steps         xxxxxx")#                       AP21  13
datastuff:#                                                             AP21  14
#                                                                       AP21  15
#    LOOP THE INPUT LINES                                               AP21  16
#    --------------------                                               AP21  17
#                                                                       AP21  18
SYNTXF=1;    LINE=0#                   Switch off syntax checking       AP21  19
IDATA=no:;   CHRIN=' '#                Blank out input file             AP21  20
REPEAT#                                Read up to angle line before d   AP21  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AP21  22
readfmt:(iofm1:,'(a)',100,[CHRIN(2^75)])# Read character line           AP21  23
LINE=LINE+1#                           Count input lines                AP21  24
#                                                                       AP21  25
IF(LINE>3&LINE<22) writeline:(0,CHRIN,75,3,3)# Echo input lines         AP21  26
#                                                                       AP21  27
IF(CHRIN(7^11)=='angle')#              ******** angle **************    AP21  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AP21  29
CHRIN(26^26)=' ';  dcodefld:#          Decode the line                  AP21  30
TTMIN=BUFIN(4);   TTMAX=BUFIN(6)#      Extract 2theta min/max           AP21  31
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AP21  32
#                                                                       AP21  33
IF(CHRIN(2^5)=='Step')#                ********* step **************    AP21  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AP21  35
CHRIN(26^26)=' ';  dcodefld:#          Decode the line                  AP21  36
TTSTEP=BUFIN(5)#                       Extract 2theta step              AP21  37
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AP21  38
#                                                                       AP21  39
IF(CHRIN(2^4)=='Max')#                 *********** max *************    AP21  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AP21  41
CHRIN(26^26)=' ';  dcodefld:#          Decode the line                  AP21  42
YMAX=BUFIN(3)#                         Extract maximum counts           AP21  43
#                                                                       AP21  44
writepkt:(3,lrpwav:,7,IP)#             Prepare pat wavlen rec packet    AP21  45
QX(IP+1)=FLOAT(RADTYP)#                Xray/neutron                     AP21  46
QX(IP+2)=LAMDA1#                       Alpha1                           AP21  47
QX(IP+3)=LAMDA2#                       Alpha2                           AP21  48
QX(IP+4)=LAMRAT#                       Int ratio 2/1                    AP21  49
QX(IP+5)=POLRAT#                       Polarisation ratio               AP21  50
QX(IP+6)=FLOAT(LPCOR)#                 No/yes lp corrected              AP21  51
QX(IP+7)=FLOAT(DIVERG)#                Fixed/var divergence slit        AP21  52
#                                                                       AP21  53
writepkt:(3,lrplim:,7,IP)#             Prepare pat limits rec packet    AP21  54
QX(IP+1)=TTMIN#                        Min 2 theta                      AP21  55
QX(IP+2)=TTMAX#                        Max 2 theta                      AP21  56
QX(IP+3)=TTSTEP#                       Step size, 2 theta               AP21  57
QX(IP+4)=0.#                           Min obs counts                   AP21  58
QX(IP+5)=YMAX#                         Max obs counts                   AP21  59
QX(IP+6)=0.#                           Min calc counts                  AP21  60
QX(IP+7)=0.#                           Max calc counts                  AP21  61
STEP=0.#                               Zero step count                  AP21  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AP21  63
#                                                                       AP21  64
IF(IDATA==yes:)#                       ********** counts ***********    AP21  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AP21  66
dcodefld:#                             Decode the line                  AP21  67
FOR(I=2;BUFIN(I)>voidflg:;I=I+1)#      Loop input intensity fields      AP21  68
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AP21  69
writepkt:(3,lrppat:,7,IP)#             Point to o/p packet              AP21  70
ANGLE=TTMIN+TTSTEP*STEP#               Calculate two theta              AP21  71
QX(IP+1)=ANGLE#                        Store two theta                  AP21  72
QX(IP+2)=BUFIN(I)#                     Store obs step counts, yobs      AP21  73
QX(IP+3)=1.#                           Store sigma                      AP21  74
QX(IP+4)=1.#                           Store weight                     AP21  75
QX(IP+5)=0.#                           Store default ycalc              AP21  76
QX(IP+6)=0.#                           Store default background         AP21  77
QX(IP+7)=0.#                           Store default hkl\phase code     AP21  78
STEP=STEP+1.#                          Count steps                      AP21  79
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AP21  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AP21  81
#                                                                       AP21  82
IF(CHRIN(2^4)=='---'&LINE>20) IDATA=yes:# Detect start of data          AP21  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AP21  84
#                                                                       AP21  85
100 CONTINUE#                          Read breakpoint                  AP21  86
ifne:(ANGLE,TTMAX) iquit:(AP2105)#     Angle miscount                   AP21  87
#                                                                       AP21  88
ncodefld:(STEP,1,AP6,310613.,1)#       Format number steps              AP21  89
writeline:(0,AP6,NAP6,3,3)#            Print steps                      AP21  90
RETURN#                                                                 AP21  91
END#                                                                    AP21  92
systemheader:(AP22)#                   Process raw data file            AP22   1
# ################################################################ #    AP22   2
#                                                                  #    AP22   3
#                                 AP22                             #    AP22   4
#                                                                  #    AP22   5
# ################################################################ #    AP22   6
SUBROUTINE AP22#                                                        AP22   7
#                                                                       AP22   8
include:(AACOMN)#                                                       AP22   9
include:(APCOMN)#                                                       AP22  10
INTEGER LINE,I,IP#                                                      AP22  11
REAL TTMIN,TTMAX,TTSTEP,YMAX,STEP#                                      AP22  12
REAL YMIN#                                                              AP22  13
#                                                                       AP22  14
chardata:(AP3," Two theta min max      xxx.xxx  xxx.xxx")#              AP22  15
chardata:(AP4," Two theta step size      x.xxx")#                       AP22  16
chardata:(AP5," Yobs min max            xxxxxx  xxxxxxx")#              AP22  17
chardata:(AP6," Number of steps         xxxxxx")#                       AP22  18
datastuff:#                                                             AP22  19
#                                                                       AP22  20
TTMAX=0.;  YMIN=100000.;  YMAX=0.#     Set initial count limits         AP22  21
LINE=0; SYNTXF=1; CHRIN=' '; STEP=0.#  Set line count                   AP22  22
#                                                                       AP22  23
#    FIRST SCAN INPUT FILE FOR LIMITS                                   AP22  24
#    --------------------------------                                   AP22  25
#                                                                       AP22  26
REPEAT#                                Loop data one angle/line         AP22  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AP22  28
readfmt:(iofm1:,'(a)',100,[CHRIN(2^80)])# Read angle and intensity      AP22  29
dcodefld:#                             Extract numerical entries        AP22  30
#                                                                       AP22  31
FOR(I=1;BUFIN(I)>voidflg:;I=I+3)#      Loop over triplets               AP22  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AP22  33
LINE=LINE+1#                           Count input lines                AP22  34
IF(LINE==1) TTMIN=BUFIN(I)#            First 2theta is min              AP22  35
IF(LINE==2) TTSTEP=(BUFIN(I)-TTMIN)#   Get 2theta step size             AP22  36
IF(TTMAX>BUFIN(I)) iquit:(AP2205)#     Two thetas out of order          AP22  37
TTMAX=BUFIN(I)#                        Last 2theta is maximum           AP22  38
YMIN=MIN(YMIN,BUFIN(I+1))#             Minimum count                    AP22  39
YMAX=MAX(YMAX,BUFIN(I+1))#             Maximum count                    AP22  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AP22  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AP22  42
#                                                                       AP22  43
#    PRINT SUMMARY OF DATA                                              AP22  44
#    ---------------------                                              AP22  45
#                                                                       AP22  46
100 REWIND(iofm1:)#                    Rewind the formatted file        AP22  47
ncodefld:(TTMIN,1,AP3,310932.,1)#      Format 2theta min                AP22  48
ncodefld:(TTMAX,1,AP3,400932.,1)#      Format 2theta max                AP22  49
writeline:(1,AP3,NAP3,3,3)#            Print 2theta limits              AP22  50
ncodefld:(TTSTEP,1,AP4,310932.,1)#     Format 2theta step               AP22  51
writeline:(0,AP4,NAP4,3,3)#            Print 2theta step                AP22  52
ncodefld:(YMIN,1,AP5,310913.,1)#       Format yobs min                  AP22  53
ncodefld:(YMAX,1,AP5,400913.,1)#       Format yobs max                  AP22  54
writeline:(0,AP5,NAP5,3,3)#            Print yobs limits                AP22  55
#                                                                       AP22  56
writepkt:(3,lrpwav:,7,IP)#             Wavlen rec packet                AP22  57
QX(IP+1)=FLOAT(RADTYP)#                Xray/neutron                     AP22  58
QX(IP+2)=LAMDA1#                       Alpha1                           AP22  59
QX(IP+3)=LAMDA2#                       Alpha2                           AP22  60
QX(IP+4)=LAMRAT#                       Int ratio 2/1                    AP22  61
QX(IP+5)=POLRAT#                       Polarisation ratio               AP22  62
QX(IP+6)=FLOAT(LPCOR)#                 No/yes lp corrected              AP22  63
QX(IP+7)=FLOAT(DIVERG)#                Fixed/var divergence slit        AP22  64
#                                                                       AP22  65
writepkt:(3,lrplim:,7,IP)#             Limits rec packet                AP22  66
QX(IP+1)=TTMIN#                        Min 2 theta                      AP22  67
QX(IP+2)=TTMAX#                        Max 2 theta                      AP22  68
QX(IP+3)=TTSTEP#                       Step size, 2 theta               AP22  69
QX(IP+4)=YMIN#                         Min obs counts                   AP22  70
QX(IP+5)=YMAX#                         Max obs counts                   AP22  71
QX(IP+6)=0.#                           Min calc counts                  AP22  72
QX(IP+7)=0.#                           Max calc counts                  AP22  73
#                                                                       AP22  74
#    READ DATA FOR SECOND TIME                                          AP22  75
#    -------------------------                                          AP22  76
#                                                                       AP22  77
REPEAT#                                Read to end of file              AP22  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AP22  79
CHRIN=' '#                                                              AP22  80
readfmt:(iofm1:,'(a)',200,[CHRIN(2^80)])# Read angle and intensity      AP22  81
dcodefld:#                             Extract numerical entries        AP22  82
#                                                                       AP22  83
FOR(I=1;BUFIN(I)>voidflg:;I=I+3)#      Loop over triplets               AP22  84
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AP22  85
writepkt:(3,lrppat:,7,IP)#             Point to o/p packet              AP22  86
QX(IP+1)=BUFIN(I  )#                   Write two theta                  AP22  87
QX(IP+2)=BUFIN(I+1)#                   Write obs step counts, yobs      AP22  88
QX(IP+3)=BUFIN(I+2)#                   Write sigma                      AP22  89
QX(IP+4)=1.#                           Write weight                     AP22  90
QX(IP+5)=0.#                           Write default ycalc              AP22  91
QX(IP+6)=0.#                           Write default background         AP22  92
QX(IP+7)=0.#                           Write default hkl\phase code     AP22  93
STEP=STEP+1.#                          Count steps                      AP22  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AP22  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AP22  96
#                                                                       AP22  97
200 ncodefld:(STEP,1,AP6,310613.,1)#   Format number steps              AP22  98
writeline:(0,AP6,NAP6,3,3)#            Print steps                      AP22  99
RETURN#                                                                 AP22 100
END#                                                                    AP22 101
systemheader:(AP23)#                   Process wyriet input file        AP23   1
# ################################################################ #    AP23   2
#                                                                  #    AP23   3
#                                 AP23                             #    AP23   4
#                                                                  #    AP23   5
# ################################################################ #    AP23   6
SUBROUTINE AP23#                                                        AP23   7
#                                                                       AP23   8
include:(AACOMN)#                                                       AP23   9
include:(APCOMN)#                                                       AP23  10
INTEGER LINE,I,IP#                                                      AP23  11
REAL TTMIN,TTMAX,TTSTEP,STEP,ANGLE#                                     AP23  12
REAL YMIN,YMAX#                                                         AP23  13
#                                                                       AP23  14
chardata:(AP3," Two theta min max      xxx.xxx  xxx.xxx")#              AP23  15
chardata:(AP4," Two theta step size      x.xxx")#                       AP23  16
chardata:(AP5," Yobs min max            xxxxxx  xxxxxxx")#              AP23  17
chardata:(AP6," Number of steps         xxxxxx")#                       AP23  18
datastuff:#                                                             AP23  19
#                                                                       AP23  20
TTMAX=0.;  YMIN=100000.;  YMAX=0.#     Set initial count limits         AP23  21
LINE=0;   SYNTXF=1;   CHRIN=' '#       Set line count                   AP23  22
#                                                                       AP23  23
#    FIRST SCAN INPUT FILE FOR LIMITS                                   AP23  24
#    --------------------------------                                   AP23  25
#                                                                       AP23  26
readfmt:(iofm1:,'(a)',100,[CHRIN(2^80)])# Read angle and intensity      AP23  27
dcodefld:#                             Extract numerical entries        AP23  28
TTMIN=BUFIN(1)#                        Min 2theta                       AP23  29
TTSTEP=BUFIN(2)#                       2theta step size                 AP23  30
TTMAX=TTMIN-TTSTEP#                    Ready to add steps               AP23  31
writeline:(0,CHRIN,80,3,3)#            Echo input line                  AP23  32
#                                                                       AP23  33
REPEAT#                                Loop data one angle/line         AP23  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AP23  35
readfmt:(iofm1:,'(a)',100,[CHRIN(2^80)])# Read angle and intensity      AP23  36
dcodefld:#                             Extract numerical entries        AP23  37
#                                                                       AP23  38
FOR(I=1;I<9&BUFIN(I)>voidflg:;I=I+1)#  Loop over 8 intensities          AP23  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AP23  40
YMIN=MIN(YMIN,BUFIN(I))#               Minimum count                    AP23  41
YMAX=MAX(YMAX,BUFIN(I))#               Maximum count                    AP23  42
TTMAX=TTSTEP+TTMAX#                    Add one more step                AP23  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AP23  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AP23  45
#                                                                       AP23  46
#    PRINT SUMMARY OF DATA                                              AP23  47
#    ---------------------                                              AP23  48
#                                                                       AP23  49
100 REWIND(iofm1:)#                    Rewind the formatted file        AP23  50
ncodefld:(TTMIN,1,AP3,310932.,1)#      Format 2theta min                AP23  51
ncodefld:(TTMAX,1,AP3,400932.,1)#      Format 2theta max                AP23  52
writeline:(1,AP3,NAP3,3,3)#            Print 2theta limits              AP23  53
ncodefld:(TTSTEP,1,AP4,310932.,1)#     Format 2theta step               AP23  54
writeline:(0,AP4,NAP4,3,3)#            Print 2theta step                AP23  55
ncodefld:(YMIN,1,AP5,310913.,1)#       Format yobs min                  AP23  56
ncodefld:(YMAX,1,AP5,400913.,1)#       Format yobs max                  AP23  57
writeline:(0,AP5,NAP5,3,3)#            Print yobs limits                AP23  58
#                                                                       AP23  59
writepkt:(3,lrpwav:,7,IP)#             Wavlen rec packet                AP23  60
QX(IP+1)=FLOAT(RADTYP)#                Xray/neutron                     AP23  61
QX(IP+2)=LAMDA1#                       Alpha1                           AP23  62
QX(IP+3)=LAMDA2#                       Alpha2                           AP23  63
QX(IP+4)=LAMRAT#                       Int ratio 2/1                    AP23  64
QX(IP+5)=POLRAT#                       Polarisation ratio               AP23  65
QX(IP+6)=FLOAT(LPCOR)#                 No/yes lp corrected              AP23  66
QX(IP+7)=FLOAT(DIVERG)#                Fixed/var divergence slit        AP23  67
#                                                                       AP23  68
writepkt:(3,lrplim:,7,IP)#             Limits rec packet                AP23  69
QX(IP+1)=TTMIN#                        Min 2 theta                      AP23  70
QX(IP+2)=TTMAX#                        Max 2 theta                      AP23  71
QX(IP+3)=TTSTEP#                       Step size, 2 theta               AP23  72
QX(IP+4)=YMIN#                         Min obs counts                   AP23  73
QX(IP+5)=YMAX#                         Max obs counts                   AP23  74
QX(IP+6)=0.#                           Min calc counts                  AP23  75
QX(IP+7)=0.#                           Max calc counts                  AP23  76
#                                                                       AP23  77
#    READ DATA FOR SECOND TIME                                          AP23  78
#    -------------------------                                          AP23  79
#                                                                       AP23  80
STEP=0.#                               Zero step count                  AP23  81
readfmt:(iofm1:,'(a)',200,[CHRIN(2^75)])# Read min step max line        AP23  82
REPEAT#                                Read to end of file              AP23  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AP23  84
readfmt:(iofm1:,'(a)',200,[CHRIN(2^75)])# Read angle and intensity      AP23  85
dcodefld:#                             Extract numerical entries        AP23  86
#                                                                       AP23  87
FOR(I=1;I<9&BUFIN(I)>voidflg:;I=I+1)#  Loop over 8 intensities          AP23  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AP23  89
writepkt:(3,lrppat:,7,IP)#             Point to o/p packet              AP23  90
ANGLE=TTMIN+TTSTEP*STEP#               Calculate two theta              AP23  91
QX(IP+1)=ANGLE#                        Store two theta                  AP23  92
QX(IP+2)=BUFIN(I)#                     Write obs step counts, yobs      AP23  93
QX(IP+3)=1.#                           Write sigma                      AP23  94
QX(IP+4)=1.#                           Write weight                     AP23  95
QX(IP+5)=0.#                           Write default ycalc              AP23  96
QX(IP+6)=0.#                           Write default background         AP23  97
QX(IP+7)=0.#                           Write default hkl\phase code     AP23  98
STEP=STEP+1.#                          Count steps                      AP23  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AP23 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AP23 101
#                                                                       AP23 102
200 ncodefld:(STEP,1,AP6,310613.,1)#   Format number steps              AP23 103
writeline:(0,AP6,NAP6,3,3)#            Print steps                      AP23 104
RETURN#                                                                 AP23 105
END#                                                                    AP23 106
systemheader:(AP24)#                   Process pc-apd data file         AP24   1
# ################################################################ #    AP24   2
#                                                                  #    AP24   3
#                                 AP24                             #    AP24   4
#                                                                  #    AP24   5
# ################################################################ #    AP24   6
SUBROUTINE AP24#                                                        AP24   7
#                                                                       AP24   8
include:(AACOMN)#                                                       AP24   9
include:(APCOMN)#                                                       AP24  10
#                                                                       AP24  11
INTEGER LINE,I,IP#                                                      AP24  12
REAL TTMIN,TTMAX,TTSTEP,STEP,ANGLE#                                     AP24  13
REAL YMIN,YMAX#                                                         AP24  14
#                                                                       AP24  15
chardata:(AP3," Two theta min max      xxx.xxx  xxx.xxx")#              AP24  16
chardata:(AP4," Two theta step size      x.xxx")#                       AP24  17
chardata:(AP5," Yobs min max            xxxxxx  xxxxxxx")#              AP24  18
chardata:(AP6," Number of steps         xxxxxx")#                       AP24  19
datastuff:#                                                             AP24  20
#                                                                       AP24  21
#    LOOP THE INPUT LINES                                               AP24  22
#    --------------------                                               AP24  23
#                                                                       AP24  24
TTMAX=0.;  YMIN=100000.;  YMAX=0.#     Set initial count limits         AP24  25
LINE=0;   SYNTXF=1;   CHRIN=' '#       Set line count                   AP24  26
REPEAT#                                Read up to angle line before d   AP24  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AP24  28
readfmt:(iofm1:,'(a)',100,[CHRIN(1^75)])# Read character line           AP24  29
dcodefld:#                             Decode the line                  AP24  30
LINE=LINE+1#                           Count input lines                AP24  31
#                                                                       AP24  32
IF(LINE>0&LINE<20)#                    Header lines only                AP24  33
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AP24  34
movechar:(CHRIN,1,CHROT,2,75,0)#       Leave col 1 blank                AP24  35
writeline:(0,CHROT,76,3,3)#            Echo input lines                 AP24  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AP24  37
#                                                                       AP24  38
IF(CHRIN(1^14)=='DataAngleRange')#     ******** angle **************    AP24  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AP24  40
CHRIN(15^15)=' '; CHRIN(25^25)=' '; CHRIN(35^35)=' '# Comma to space    AP24  41
TTMIN=BUFIN(2);   TTMAX=BUFIN(3)#      Extract 2theta min/max           AP24  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AP24  43
#                                                                       AP24  44
IF(CHRIN(1^12)=='ScanStepSize')#       ********* step **************    AP24  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AP24  46
CHRIN(13^13)=' '; CHRIN(22^22)=' '; dcodefld:# Decode the line          AP24  47
TTSTEP=BUFIN(2)#                       Extract 2theta step              AP24  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AP24  49
#                                                                       AP24  50
IF(CHRIN(1^11)=='LabdaAlpha1')#        ********* lamda1 ************    AP24  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AP24  52
CHRIN(12^12)=' '; CHRIN(21^21)=' '; dcodefld:# Decode the line          AP24  53
LAMDA1=BUFIN(2)#                       Alpha1                           AP24  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AP24  55
#                                                                       AP24  56
IF(CHRIN(1^11)=='LabdaAlpha2')#        ********* lamda2 ************    AP24  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AP24  58
CHRIN(12^12)=' '; CHRIN(21^21)=' '; dcodefld:# Decode the line          AP24  59
LAMDA2=BUFIN(2)#                       Alpha2                           AP24  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AP24  61
#                                                                       AP24  62
IF(CHRIN(1^12)=='RatioAlpha21')#       ********* lamrat ************    AP24  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AP24  64
CHRIN(13^13)=' '; CHRIN(24^24)=' '; dcodefld:# Decode the line          AP24  65
LAMRAT=BUFIN(2)#                       Int ratio alpha2/alpha1          AP24  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AP24  67
#                                                                       AP24  68
IF(CHRIN(1^14)=='DivergenceSlit')#     ********* diverg ************    AP24  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AP24  70
CHRIN(15^15)=' '; CHRIN(25^25)=' '; dcodefld:# Decode the line          AP24  71
IF(CHRIN(16^20)=='Fixed') DIVERG=0#    Fixed                            AP24  72
ELSE                      DIVERG=1#    Var                              AP24  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AP24  74
IF(CHRIN(1^7)=='RawScan') BREAK#       ******** data start *********    AP24  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AP24  76
#                                                                       AP24  77
#    FIRST SCAN INPUT FILE FOR LIMITS                                   AP24  78
#    --------------------------------                                   AP24  79
#                                                                       AP24  80
100 STEP=0.#                                                            AP24  81
REPEAT#                                                                 AP24  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AP24  83
readfmt:(iofm1:,'(a)',200,[CHRIN(1^71)])# Read character line           AP24  84
DO I=9,63,9; CHRIN(I^I)=' '#           Clear commas                     AP24  85
dcodefld:#                             Extract numerical entries        AP24  86
#                                                                       AP24  87
FOR(I=1;BUFIN(I)>voidflg:;I=I+1)#      Loop over 8 intensities          AP24  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AP24  89
ifch:(BUFIN(I)) NEXT#                                                   AP24  90
YMIN=MIN(YMIN,BUFIN(I))#               Minimum count                    AP24  91
YMAX=MAX(YMAX,BUFIN(I))#               Maximum count                    AP24  92
ANGLE=TTMIN+TTSTEP*STEP#               Calculate two theta              AP24  93
STEP=STEP+1.#                          Count steps                      AP24  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AP24  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AP24  96
#                                                                       AP24  97
#    PRINT SUMMARY OF DATA                                              AP24  98
#    ---------------------                                              AP24  99
#                                                                       AP24 100
200 ifne:(ANGLE,TTMAX) iquit:(AP2405)# Angle miscount                   AP24 101
REWIND(iofm1:)#                        Rewind the formatted file        AP24 102
ncodefld:(TTMIN,1,AP3,310932.,1)#      Format 2theta min                AP24 103
ncodefld:(TTMAX,1,AP3,400932.,1)#      Format 2theta max                AP24 104
writeline:(1,AP3,NAP3,3,3)#            Print 2theta limits              AP24 105
ncodefld:(TTSTEP,1,AP4,310932.,1)#     Format 2theta step               AP24 106
writeline:(0,AP4,NAP4,3,3)#            Print 2theta step                AP24 107
ncodefld:(YMIN,1,AP5,310913.,1)#       Format yobs min                  AP24 108
ncodefld:(YMAX,1,AP5,400913.,1)#       Format yobs max                  AP24 109
writeline:(0,AP5,NAP5,3,3)#            Print yobs limits                AP24 110
#                                                                       AP24 111
writepkt:(3,lrpwav:,7,IP)#             Wavlen rec packet                AP24 112
QX(IP+1)=FLOAT(RADTYP)#                Xray/neutron                     AP24 113
QX(IP+2)=LAMDA1#                       Alpha1                           AP24 114
QX(IP+3)=LAMDA2#                       Alpha2                           AP24 115
QX(IP+4)=LAMRAT#                       Int ratio 2/1                    AP24 116
QX(IP+5)=POLRAT#                       Polarisation ratio               AP24 117
QX(IP+6)=FLOAT(LPCOR)#                 No/yes lp corrected              AP24 118
QX(IP+7)=FLOAT(DIVERG)#                Fixed/var divergence slit        AP24 119
#                                                                       AP24 120
writepkt:(3,lrplim:,7,IP)#             Limits rec packet                AP24 121
QX(IP+1)=TTMIN#                        Min 2 theta                      AP24 122
QX(IP+2)=TTMAX#                        Max 2 theta                      AP24 123
QX(IP+3)=TTSTEP#                       Step size, 2 theta               AP24 124
QX(IP+4)=YMIN#                         Min obs counts                   AP24 125
QX(IP+5)=YMAX#                         Max obs counts                   AP24 126
QX(IP+6)=0.#                           Min calc counts                  AP24 127
QX(IP+7)=0.#                           Max calc counts                  AP24 128
#                                                                       AP24 129
#    READ DATA FOR SECOND TIME                                          AP24 130
#    -------------------------                                          AP24 131
#                                                                       AP24 132
REPEAT#                                Read up to angle line before d   AP24 133
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AP24 134
readfmt:(iofm1:,'(a)',300,[CHRIN(1^75)])# Read character line           AP24 135
IF(CHRIN(1^7)=='RawScan') BREAK#       ******** data start *********    AP24 136
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AP24 137
STEP=0.#                               Zero step count                  AP24 138
REPEAT#                                                                 AP24 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AP24 140
readfmt:(iofm1:,'(a)',300,[CHRIN(1^71)])# Read character line           AP24 141
DO I=9,63,9; CHRIN(I^I)=' '#           Clear commas                     AP24 142
dcodefld:#                             Extract numerical entries        AP24 143
#                                                                       AP24 144
LINE=LINE+1#                           Count input lines                AP24 145
#                                                                       AP24 146
FOR(I=1;BUFIN(I)>voidflg:;I=I+1)#      Loop over 8 intensities          AP24 147
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AP24 148
ifch:(BUFIN(I)) NEXT#                                                   AP24 149
writepkt:(3,lrppat:,7,IP)#             Point to o/p packet              AP24 150
ANGLE=TTMIN+TTSTEP*STEP#               Calculate two theta              AP24 151
QX(IP+1)=ANGLE#                        Store two theta                  AP24 152
QX(IP+2)=BUFIN(I)#                     Store obs step counts, yobs      AP24 153
QX(IP+3)=1.#                           Store sigma                      AP24 154
QX(IP+4)=1.#                           Store weight                     AP24 155
QX(IP+5)=0.#                           Store default ycalc              AP24 156
QX(IP+6)=0.#                           Store default background         AP24 157
QX(IP+7)=0.#                           Store default hkl\phase code     AP24 158
STEP=STEP+1.#                          Count steps                      AP24 159
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AP24 160
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AP24 161
300 CONTINUE#                          Read breakpoint                  AP24 162
#                                                                       AP24 163
ncodefld:(STEP,1,AP6,310613.,1)#       Format number steps              AP24 164
writeline:(0,AP6,NAP6,3,3)#            Print steps                      AP24 165
RETURN#                                                                 AP24 166
END#                                                                    AP24 167
systemheader:(AP25)#                   Process uxd data file            AP25   1
# ################################################################ #    AP25   2
#                                                                  #    AP25   3
#                                 AP25                             #    AP25   4
#                                                                  #    AP25   5
# ################################################################ #    AP25   6
SUBROUTINE AP25#                       D. du boulay dec 99              AP25   7
#                                                                       AP25   8
include:(AACOMN)#                                                       AP25   9
include:(APCOMN)#                                                       AP25  10
#                                                                       AP25  11
INTEGER LINE,I,IP,J,K,M,N,LCT#                                          AP25  12
REAL LAMDA3#                                                            AP25  13
REAL TTMIN,TTMAX,TTSTEP,STEP,ANGLE#                                     AP25  14
REAL YMIN,YMAX#                                                         AP25  15
#                                                                       AP25  16
chardata:(AP3," Two theta min max      xxx.xxx  xxx.xxx")#              AP25  17
chardata:(AP4," Two theta step size      x.xxx")#                       AP25  18
chardata:(AP5," Yobs min max            xxxxxx  xxxxxxx")#              AP25  19
chardata:(AP6," Number of steps         xxxxxx")#                       AP25  20
datastuff:#                                                             AP25  21
#                                                                       AP25  22
#    LOOP THE INPUT LINES                                               AP25  23
#    --------------------                                               AP25  24
#                                                                       AP25  25
TTMAX=0.;  YMIN=100000.;  YMAX=0.#     Set initial count limits         AP25  26
LINE=0;   SYNTXF=1;   CHRIN=' '#       Set line count                   AP25  27
REPEAT#                                Read up to angle line before d   AP25  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AP25  29
readfmt:(iofm1:,'(a)',100,CHRIN)#      Read character line              AP25  30
LINE=LINE+1#                           Count lines                      AP25  31
IF(CHRIN(1^1)==';') NEXT#              Ignore comments                  AP25  32
IF(CHRIN(1^1)=='_') CHRIN(1^1)=' '#    Replace with blank               AP25  33
DO I=1,40;IF(CHRIN(I^I)=='=')#                                          AP25  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AP25  35
CHRIN(I^I)=' '#                                                         AP25  36
BREAK#                                                                  AP25  37
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AP25  38
#                                                                       AP25  39
dcodefld:#                             Decode the line                  AP25  40
#                                                                       AP25  41
I=1#                                   Point to first field             AP25  42
stringlim:(I,M,N)#                     Get string position              AP25  43
IF(CHRIN(M^N-1)=='WL1')#                                                AP25  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AP25  45
ifnm:(BUFIN(2))LAMDA1=BUFIN(2)#        Alpha1                           AP25  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AP25  47
IF(CHRIN(M^N-1)=='WL2')#                                                AP25  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AP25  49
ifnm:(BUFIN(2))LAMDA2=BUFIN(2)#        Alpha2                           AP25  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AP25  51
IF(CHRIN(M^N-1)=='WL3')#                                                AP25  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AP25  53
ifnm:(BUFIN(2))LAMDA3=BUFIN(2)#        Beta 1 ??                        AP25  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AP25  55
IF(CHRIN(M^N-1)=='WLRATIO')#                                            AP25  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AP25  57
ifnm:(BUFIN(2)) LAMRAT=BUFIN(2)#       Int ratio alpha2/alpha1          AP25  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AP25  59
IF(CHRIN(M^N-1)=='DIVERGENCE')#                                         AP25  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AP25  61
#IFNM:(BUFIN(2)) LAMRAT=BUFIN(2)#       INT RATIO ALPHA2/ALPHA1         AP25  62
#IF(CHRIN(16^20)=='FIXED') DIVERG=0#    FIXED                           AP25  63
#ELSE                      DIVERG=1#    VAR                             AP25  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AP25  65
IF(CHRIN(M^N-1)=='STEPSIZE')#                                           AP25  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AP25  67
ifnm:(BUFIN(2)) TTSTEP=BUFIN(2)#       Int ratio alpha2/alpha1          AP25  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AP25  69
IF(CHRIN(M^N-1)=='START')#                                              AP25  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AP25  71
ifnm:(BUFIN(2)) TTMIN=BUFIN(2)#        Int ratio alpha2/alpha1          AP25  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AP25  73
IF(CHRIN(M^N-1)=='2THETA')#                                             AP25  74
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AP25  75
ifnm:(BUFIN(2)) TTMIN=BUFIN(2)#        Int ratio alpha2/alpha1          AP25  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AP25  77
#                                                                       AP25  78
#                                                                       AP25  79
#                                                                       AP25  80
IF(CHRIN(2^13)=='2THETACOUNTS')BREAK#  ******** data start *********    AP25  81
#                                                                       AP25  82
# DUMP HEADER DETAILS                                                   AP25  83
movechar:(CHRIN,1,CHROT,2,75,0)#       Leave col 1 blank                AP25  84
writeline:(0,CHROT,76,3,3)#            Echo input lines                 AP25  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AP25  86
#                                                                       AP25  87
#    FIRST SCAN INPUT FILE FOR LIMITS                                   AP25  88
#    --------------------------------                                   AP25  89
#                                                                       AP25  90
100 STEP=0.#                                                            AP25  91
REPEAT#                                                                 AP25  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AP25  93
readfmt:(iofm1:,'(a)',200,CHRIN)#      Read character line              AP25  94
dcodefld:#                             Extract numerical entries        AP25  95
#                                                                       AP25  96
ifch:(BUFIN(1))#                                                        AP25  97
I=1#                                                                    AP25  98
stringlim:(I,J,K)#                                                      AP25  99
ifch:(BUFIN(1)) NEXT#                                                   AP25 100
TTMAX=MAX(TTMIN,BUFIN(1))#             Get maximum angle                AP25 101
YMIN=MIN(YMIN,BUFIN(2))#               Minimum count                    AP25 102
YMAX=MAX(YMAX,BUFIN(2))#               Maximum count                    AP25 103
ANGLE=TTMIN+TTSTEP*STEP#               Calculate two theta              AP25 104
STEP=STEP+1.#                          Count steps                      AP25 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AP25 106
#                                                                       AP25 107
#    PRINT SUMMARY OF DATA                                              AP25 108
#    ---------------------                                              AP25 109
#                                                                       AP25 110
200 ifne:(ANGLE,TTMAX) iquit:(AP2405)# Angle miscount                   AP25 111
REWIND(iofm1:)#                        Rewind the formatted file        AP25 112
ncodefld:(TTMIN,1,AP3,310932.,1)#      Format 2theta min                AP25 113
ncodefld:(TTMAX,1,AP3,400932.,1)#      Format 2theta max                AP25 114
writeline:(1,AP3,NAP3,3,3)#            Print 2theta limits              AP25 115
ncodefld:(TTSTEP,1,AP4,310932.,1)#     Format 2theta step               AP25 116
writeline:(0,AP4,NAP4,3,3)#            Print 2theta step                AP25 117
ncodefld:(YMIN,1,AP5,310913.,1)#       Format yobs min                  AP25 118
ncodefld:(YMAX,1,AP5,400913.,1)#       Format yobs max                  AP25 119
writeline:(0,AP5,NAP5,3,3)#            Print yobs limits                AP25 120
#                                                                       AP25 121
writepkt:(3,lrpwav:,7,IP)#             Wavlen rec packet                AP25 122
QX(IP+1)=FLOAT(RADTYP)#                Xray/neutron                     AP25 123
QX(IP+2)=LAMDA1#                       Alpha1                           AP25 124
QX(IP+3)=LAMDA2#                       Alpha2                           AP25 125
QX(IP+4)=LAMRAT#                       Int ratio 2/1                    AP25 126
QX(IP+5)=POLRAT#                       Polarisation ratio               AP25 127
QX(IP+6)=FLOAT(LPCOR)#                 No/yes lp corrected              AP25 128
QX(IP+7)=FLOAT(DIVERG)#                Fixed/var divergence slit        AP25 129
#                                                                       AP25 130
writepkt:(3,lrplim:,7,IP)#             Limits rec packet                AP25 131
QX(IP+1)=TTMIN#                        Min 2 theta                      AP25 132
QX(IP+2)=TTMAX#                        Max 2 theta                      AP25 133
QX(IP+3)=TTSTEP#                       Step size, 2 theta               AP25 134
QX(IP+4)=YMIN#                         Min obs counts                   AP25 135
QX(IP+5)=YMAX#                         Max obs counts                   AP25 136
QX(IP+6)=0.#                           Min calc counts                  AP25 137
QX(IP+7)=0.#                           Max calc counts                  AP25 138
#                                                                       AP25 139
#    READ DATA FOR SECOND TIME                                          AP25 140
#    -------------------------                                          AP25 141
#                                                                       AP25 142
LCT=0#                                                                  AP25 143
REPEAT#                                Read up to angle line before d   AP25 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AP25 145
readfmt:(iofm1:,'(a)',300,CHRIN)#      Read character line              AP25 146
LCT=LCT+1#                                                              AP25 147
IF(LCT==LINE)BREAK#                    ******** data start *********    AP25 148
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AP25 149
STEP=0.#                               Zero step count                  AP25 150
LINE=0#                                                                 AP25 151
REPEAT#                                                                 AP25 152
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AP25 153
readfmt:(iofm1:,'(a)',300,CHRIN)#      Read character line              AP25 154
dcodefld:#                             Extract numerical entries        AP25 155
#                                                                       AP25 156
LINE=LINE+1#                           Count input lines                AP25 157
#                                                                       AP25 158
ifch:(BUFIN(I)) NEXT#                                                   AP25 159
writepkt:(3,lrppat:,7,IP)#             Point to o/p packet              AP25 160
QX(IP+1)=BUFIN(1)#                     Store two theta                  AP25 161
QX(IP+2)=BUFIN(2)#                     Store obs step counts, yobs      AP25 162
QX(IP+3)=1.#                           Store sigma                      AP25 163
QX(IP+4)=1.#                           Store weight                     AP25 164
QX(IP+5)=0.#                           Store default ycalc              AP25 165
QX(IP+6)=0.#                           Store default background         AP25 166
QX(IP+7)=0.#                           Store default hkl\phase code     AP25 167
STEP=STEP+1.#                          Count steps                      AP25 168
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AP25 169
300 CONTINUE#                          Read breakpoint                  AP25 170
#                                                                       AP25 171
ncodefld:(STEP,1,AP6,310613.,1)#       Format number steps              AP25 172
writeline:(0,AP6,NAP6,3,3)#            Print steps                      AP25 173
RETURN#                                                                 AP25 174
END#                                                                    AP25 175
systemheader:(AP26)#                   Process Rietan2000 input file 
# ################################################################ #    AP26   2
#                                                                  #    AP26   3
#                                 AP26                             #    AP26   4
#                                                                  #    AP26   5
# ################################################################ #    AP26   6
SUBROUTINE AP26#                       D. du boulay Nov 02              AP26   7
#                                                                       AP26   8
include:(AACOMN)#                                                       AP26   9
include:(APCOMN)#                                                       AP26  10
#                                                                       AP26  11
INTEGER LINE,I,IP,J,K,M,N,LCT#                                          AP26  12
REAL LAMDA3#                                                            AP26  13
REAL TTMIN,TTMAX,TTSTEP,STEP,ANGLE#                                     AP26  14
REAL YMIN,YMAX#                                                         AP26  15
#                                                                       AP26  16
string:(CHRIN2,mxchim:)
chardata:(AP1, STEP STOP START $#       readline only handles 6char
SAMPLE COMMEN FILENA GONIOM ATTACH $#   codes
MONOCH SCANNI SCANNI X-RAY DIVSLI $#    
DIVH.L SCTSLI RECSLI MONOCH )#          known data lines
#SAMPLE COMMENTS FILENAME GONIOMETER ATTACHMENT $#
#MONOCHROMATER SCANNINGMODE SCANNINGTYPE X-RAY DIVSLIT $#
#DIVH.L.SLIT SCTSLIT RECSLIT MONOCHRO )# known data lines
chardata:(AP3," Two theta min max      xxx.xxx  xxx.xxx")#              AP26  17
chardata:(AP4," Two theta step size      x.xxx")#                       AP26  18
chardata:(AP5," Yobs min max            xxxxxx  xxxxxxx")#              AP26  19
chardata:(AP6," Number of steps         xxxxxx")#                       AP26  20
datastuff:#                                                             AP26  21
#                                                                       AP26  22
#    LOOP THE INPUT LINES                                               AP26  23
#    --------------------                                               AP26  24
#                                                                       AP26  25
CHRIN2=CHRIN
TTMAX=0.;  YMIN=100000.;  YMAX=0.#     Set initial count limits         AP26  26
LINE=0;   SYNTXF=1;   CHRIN=' ' ;LINFLG=1# Set line count     
IOSAVE=ioinp:
ioinp:=iofm1:
REPEAT#                                First pass. Get ymin/ymax
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AP26  29
readline:(AP1,-NAP1)
LINFLG=1#               
IF    (LINID==1)TTSTEP=BUFIN(1)# 
ELSEIF(LINID==2)TTMAX =BUFIN(1)# 
ELSEIF(LINID==3)TTMIN =BUFIN(1)# 
# DUMP HEADER DETAILS                                                   AP26  83
movechar:(CHRIP,1,CHROT,2,75,0)#       Leave col 1 blank                AP26  84
writeline:(0,CHROT,76,3,3)#            Echo input lines                 AP26  85
LINE=LINE+1#                           count header lines
IF(LINID==0\TTSTEP>1.0E-7) BREAK#      Assume the last header line
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AP26  86
ioinp:=IOSAVE#                         Revert to standard input 
IF(LINID==0)iquit:(AP2601)#            Dont recognize the line!
#                                                                       AP26  87
#    FIRST SCAN INPUT FILE FOR LIMITS                                   AP26  88
#    --------------------------------                                   AP26  89
#                                                                       AP26  90
STEP=0.;CHRCOL=1#
REPEAT#                                                                 AP26  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AP26  93
readfmt:(iofm1:,'(a)',200,CHRIN)#      Read character line              AP26  94
dcodefld:#                             Extract numerical entries        AP26  95
#                                                                       AP26  96
ifch:(BUFIN(1))iquit:(AP2602)#         Only numbers expected
ANG=BUFIN(1)#                          Get maximum angle                AP26 101
YMIN=MIN(YMIN,BUFIN(2))#               Minimum count                    AP26 102
YMAX=MAX(YMAX,BUFIN(2))#               Maximum count                    AP26 103
ANGLE=TTMIN+TTSTEP*STEP#               Calculate two theta              AP26 104
STEP=STEP+1.#                          Count steps                      AP26 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AP26 106
#                                                                       AP26 107
#    PRINT SUMMARY OF DATA                                              AP26 108
#    ---------------------                                              AP26 109
#                                                                       AP26 110
200 CONTINUE
ifne:(ANGLE,TTMAX) iquit:(AP2605)#     Angle miscount     
ifne:(ANGLE,ANG)   iquit:(AP2605)#     Angle miscount     
REWIND(iofm1:)#                        Rewind the formatted file        AP26 112
ncodefld:(TTMIN,1,AP3,310932.,1)#      Format 2theta min                AP26 113
ncodefld:(TTMAX,1,AP3,400932.,1)#      Format 2theta max                AP26 114
writeline:(1,AP3,NAP3,3,3)#            Print 2theta limits              AP26 115
ncodefld:(TTSTEP,1,AP4,310932.,1)#     Format 2theta step               AP26 116
writeline:(0,AP4,NAP4,3,3)#            Print 2theta step                AP26 117
ncodefld:(YMIN,1,AP5,310913.,1)#       Format yobs min                  AP26 118
ncodefld:(YMAX,1,AP5,400913.,1)#       Format yobs max                  AP26 119
writeline:(0,AP5,NAP5,3,3)#            Print yobs limits                AP26 120
#                                                                       AP26 121
writepkt:(3,lrpwav:,7,IP)#             Wavlen rec packet                AP26 122
QX(IP+1)=FLOAT(RADTYP)#                Xray/neutron                     AP26 123
QX(IP+2)=LAMDA1#                       Alpha1                           AP26 124
QX(IP+3)=LAMDA2#                       Alpha2                           AP26 125
QX(IP+4)=LAMRAT#                       Int ratio 2/1                    AP26 126
QX(IP+5)=POLRAT#                       Polarisation ratio               AP26 127
QX(IP+6)=FLOAT(LPCOR)#                 No/yes lp corrected              AP26 128
QX(IP+7)=FLOAT(DIVERG)#                Fixed/var divergence slit        AP26 129
#                                                                       AP26 130
writepkt:(3,lrplim:,7,IP)#             Limits rec packet                AP26 131
QX(IP+1)=TTMIN#                        Min 2 theta                      AP26 132
QX(IP+2)=TTMAX#                        Max 2 theta                      AP26 133
QX(IP+3)=TTSTEP#                       Step size, 2 theta               AP26 134
QX(IP+4)=YMIN#                         Min obs counts                   AP26 135
QX(IP+5)=YMAX#                         Max obs counts                   AP26 136
QX(IP+6)=0.#                           Min calc counts                  AP26 137
QX(IP+7)=0.#                           Max calc counts                  AP26 138
#                                                                       AP26 139
#    READ DATA FOR SECOND TIME                                          AP26 140
#    -------------------------                                          AP26 141
#                                                                       AP26 142
LCT=0#                                                                  AP26 143
REPEAT#                                Read up to angle line before d   AP26 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AP26 145
readfmt:(iofm1:,'(a)',300,CHRIN)#      Read character line              AP26 146
LCT=LCT+1#                                                              AP26 147
IF(LCT==LINE)BREAK#                    ******** data start *********    AP26 148
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AP26 149
STEP=0.#                               Zero step count                  AP26 150
LINE=0#                                                                 AP26 151
REPEAT#                                                                 AP26 152
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AP26 153
readfmt:(iofm1:,'(a)',300,CHRIN)#      Read character line              AP26 154
dcodefld:#                             Extract numerical entries        AP26 155
#                                                                       AP26 156
LINE=LINE+1#                           Count input lines                AP26 157
#                                                                       AP26 158
ifch:(BUFIN(I)) NEXT#                                                   AP26 159
writepkt:(3,lrppat:,7,IP)#             Point to o/p packet              AP26 160
QX(IP+1)=BUFIN(1)#                     Store two theta                  AP26 161
QX(IP+2)=BUFIN(2)#                     Store obs step counts, yobs      AP26 162
QX(IP+3)=1.#                           Store sigma                      AP26 163
QX(IP+4)=1.#                           Store weight                     AP26 164
QX(IP+5)=0.#                           Store default ycalc              AP26 165
QX(IP+6)=0.#                           Store default background         AP26 166
QX(IP+7)=0.#                           Store default hkl\phase code     AP26 167
STEP=STEP+1.#                          Count steps                      AP26 168
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AP26 169
300 CONTINUE#                          Read breakpoint                  AP26 170
#                                                                       AP26 171
ncodefld:(STEP,1,AP6,310613.,1)#       Format number steps              AP26 172
writeline:(0,AP6,NAP6,3,3)#            Print steps                      AP26 173
LINFLG=0
CHRIN=CHRIN2
RETURN#                                                                 AP26 174
END#                                                                    AP26 175
pmacro:([no:])#                        Purge xtal system macros         AP26 176
#                                                                       AP26 177
