systemheader:(AY    )#                                                  AY     1
####################################################################### AY     2
##      Copyright (C) 2000, The Xtal System, The University of        # AY     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # AY     4
## Distributed under the GNU General Public Licence as published by   # AY     5
## the Free Software Foundation, in the hope that it will be useful   # AY     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # AY     7
## for more details.                                                  # AY     8
#                                                                     # AY     9
#                             *** ADDRES ***                          # AY    10
#                                                                     # AY    11
# RESTRAINT EDITOR WRITTEN BY E.BLANC                                 # AY    12
#                                                                     # AY    13
####################################################################### AY    14
#                                                                       AY    15
include:(XMACRO)#                                                       AY    16
#                                                                       AY    17
macro:(mxwd8c:,incr:(arith:(7,/,mxchwd:)))# 8 chars                     AY    18
macro:(mxwd24c:,incr:(arith:(23,/,mxchwd:)))# 24 chars                  AY    19
macro:(lens:,8)#                       Scattering factor name length    AY    20
macro:(lena:,24)#                      Atom name length                 AY    21
macro:(sfmax:,16)#                     Max : 16 scattering factors      AY    22
macro:(pi:,3.1415926)#                 Pi                               AY    23
macro:(pisq2:,19.7392088)#             2 pi**2                          AY    24
macro:(utob:,78.9568352)#              8 pi**2                          AY    25
macro:(paklen:,arith:(arith:(arith:(17,+,mxwd24c:),*,4),+,5))#          AY    26
#                                                                       AY    27
macro:(gunsi:,CALL AY01($1,$2))#       Get unsigned integer             AY    28
macro:(ifpr:,[IF((IREL($1)>0)& $#                                       AY    29
(ABS(voidflg:-QX(IPI+IREL($1)))>1.0E arith:(mxsgfp:,-,20)))])#          AY    30
#                                                                       AY    31
macro:(stepm:,12)#                     Matrix length                    AY    32
macro:(incrm:,$1=$1+stepm:)#                                            AY    33
#                                                                       AY    34
macro:(stepc:,mxwd8c:)#                Sf name length in words          AY    35
macro:(incrc:,$1=$1+stepc:)#                                            AY    36
#                                                                       AY    37
macro:(stepa:,arith:(11,+,mxwd24c:))#                                   AY    38
macro:(incra:,$1=$1+stepa:)#                                            AY    39
macro:(atomn:,QX($1+12))#                                               AY    40
macro:(atompos:,QX($1))#                                                AY    41
macro:(atomx:,QX($1+1))#                                                AY    42
macro:(atomy:,QX($1+2))#                                                AY    43
macro:(atomz:,QX($1+3))#                                                AY    44
macro:(atomiso:,QX($1+4))#                                              AY    45
macro:(atomani:,QX($1+3))#                                              AY    46
macro:(atomu11:,QX($1+4))#                                              AY    47
macro:(atomu22:,QX($1+5))#                                              AY    48
macro:(atomu33:,QX($1+6))#                                              AY    49
macro:(atomu12:,QX($1+7))#                                              AY    50
macro:(atomu13:,QX($1+8))#                                              AY    51
macro:(atomu23:,QX($1+9))#                                              AY    52
macro:(atomsft:,QX($1+10))#                                             AY    53
macro:(atomdft:,QX($1+11))#                                             AY    54
#                                                                       AY    55
macro:(steps:,arith:(14,+,mxwd24c:))#                                   AY    56
macro:(incrs:,$1=$1+steps:)#                                            AY    57
macro:(symname:,QX($1+15))#                                             AY    58
macro:(symptr:,QX($1+1))#                                               AY    59
macro:(symmat:,QX($1+1))#                                               AY    60
macro:(symvec:,QX($1+10))#                                              AY    61
macro:(symop:,QX($1+14))#                                               AY    62
#                                                                       AY    63
macro:(recl:,15)#                      6 words/record                   AY    64
macro:(incrr:,$1=$1+$2*recl:+8)#                                        AY    65
macro:(resobs:,QX($1+1))#                                               AY    66
macro:(resd:,QX($1+4))#                                                 AY    67
macro:(resw:,QX($1+5))#                                                 AY    68
macro:(rescal:,QX($1+6))#                                               AY    69
macro:(resptr:,QX($1+($2-1)*recl:+9))#                                  AY    70
macro:(resvec:,QX($1+($2-1)*recl:+18+$3))#                              AY    71
macro:(resm:,[ifelse:($4,,QX($1+($2-1)*recl:+$3+9),$#                   AY    72
QX($1+($2-1)*recl:+3*($4-1)+$3+9))])#                                   AY    73
macro:(resop:,QX($1+($2-1)*recl:+22))#                                  AY    74
macro:(rescel:,QX($1+($2-1)*recl:+23))#                                 AY    75
#                                                                       AY    76
extrude:(AYCOMN)#                                                       AY    77
INTEGER MARKM,STOPM#                   Matrix pointers                  AY    78
INTEGER MARKC,STOPC#                   Sf names list pointers           AY    79
INTEGER MARKA,STOPA#                   Atom pointers                    AY    80
INTEGER MARKS,STOPS#                   Symeq atoms pointers             AY    81
INTEGER MARKR(4),STOPR(4)#             Restraint pointers               AY    82
#                                                                       AY    83
INTEGER UPD#                           Update/apriori flag              AY    84
INTEGER LIST#                          List some reflections            AY    85
INTEGER CENT#                          Centricity                       AY    86
INTEGER LATICE#                        Lattice                          AY    87
INTEGER NSF#                           Scattering factor counter        AY    88
#                                                                       AY    89
REAL MT(3,3),MTINV(3,3)#               Metric tensor and its inverse    AY    90
REAL VOL#                              Cell volume                      AY    91
#                                                                       AY    92
INTEGER PSIZI,IPI,PSIZO,IPO#           I/o packet pointers              AY    93
INTEGER IWANT(paklen:),IREL(incr:(paklen:)),KEY(4)# Indexpkt: variabl   AY    94
#                                                                       AY    95
COMMON/COMIAY/ MARKM,STOPM,MARKC,STOPC,MARKA,STOPA,MARKS,STOPS,#        AY    96
MARKR,STOPR,#                                                           AY    97
UPD,LIST,CENT,LATICE,NSF,#                                              AY    98
PSIZI,IPI,PSIZO,IPO,IWANT,IREL,KEY#                                     AY    99
#                                                                       AY   100
COMMON/COMFAY/ MT,MTINV,VOL#                                            AY   101
endext:#                                                                AY   102
#                                                                       AY   103
systemheader:(AY00)#                                                    AY00   1
####################################################################### AY00   2
#                                                                     # AY00   3
#                               AY00                                  # AY00   4
#                                                                     # AY00   5
####################################################################### AY00   6
SUBROUTINE AY00#                                                        AY00   7
#                                                                       AY00   8
include:(AACOMN)#                                                       AY00   9
include:(AYCOMN)#                                                       AY00  10
#                                                                       AY00  11
CALL AY10#                             Read addres line, bdf symetrie   AY00  12
CALL AY20#                             Read symeq & restr & delres li   AY00  13
CALL AY30#                             Write output bdf                 AY00  14
RETURN#                                                                 AY00  15
END#                                                                    AY00  16
#                                                                       AY00  17
systemheader:(AY01)#                   Get unsigned integer from chri   AY01   1
####################################################################### AY01   2
#                                                                     # AY01   3
#                               AY01                                  # AY01   4
#                                                                     # AY01   5
####################################################################### AY01   6
SUBROUTINE AY01(I,N)#                                                   AY01   7
#                                                                       AY01   8
include:(AACOMN)#                                                       AY01   9
include:(AYCOMN)#                                                       AY01  10
#                                                                       AY01  11
INTEGER I#                             Character pointer                AY01  12
INTEGER MATCH#                         Used in string comparision       AY01  13
INTEGER N#                             Unsigned integer (returned val   AY01  14
#                                                                       AY01  15
chardata:(AY011,[0123456789])#                                          AY01  16
datastuff:#                                                             AY01  17
#                                                                       AY01  18
N=0#                                   Clear returned value             AY01  19
REPEAT#                                Loop over digits                 AY01  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AY01  21
compchar:(CHRIN,I,AY011,1,1,1,NAY011,MATCH)# Compare with digits        AY01  22
IF(MATCH==0)BREAK#                     Exit if not                      AY01  23
N=10*N+MATCH-1#                        Update returned value            AY01  24
I=I+1#                                 Increment char pointer           AY01  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AY01  26
RETURN#                                                                 AY01  27
END#                                                                    AY01  28
#                                                                       AY01  29
systemheader:(AY02)#                                                    AY02   1
####################################################################### AY02   2
#                                                                     # AY02   3
#                               AY02                                  # AY02   4
#                                                                     # AY02   5
####################################################################### AY02   6
SUBROUTINE AY02(MAT,VEC,N)#                                             AY02   7
#                                                                       AY02   8
include:(AACOMN)#                                                       AY02   9
include:(AYCOMN)#                                                       AY02  10
#                                                                       AY02  11
INTEGER I,J,L#                         Loop indices                     AY02  12
INTEGER MM#                            Symop pointer                    AY02  13
REAL MAT(3,3),VEC(3),LVEC(3)#          Matrix & vector & local vector   AY02  14
INTEGER N#                             Returned pointer                 AY02  15
#                                                                       AY02  16
FOR(MM=MARKM;MM<STOPM;incrm:(MM))#     Loop over symop                  AY02  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AY02  18
DO I=1,3#                              First loop                       AY02  19
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AY02  20
DO J=1,3;ifne:(QX(MM+3*(J-1)+I),MAT(I,J))BREAK#                         AY02  21
IF(J<=3)BREAK#                         Exit if no match                 AY02  22
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AY02  23
IF(I>3)BREAK#                          Exit if match                    AY02  24
IF(CENT==yes:)#                        Center of symetry present        AY02  25
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AY02  26
DO I=1,3#                              First loop                       AY02  27
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AY02  28
DO J=1,3;ifne:(QX(MM+3*(J-1)+I),-MAT(I,J))BREAK#                        AY02  29
IF(J<=3)BREAK#                         Exit if no match                 AY02  30
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AY02  31
IF(I>3)#                                                                AY02  32
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AY02  33
MM=-MM;BREAK#                          Exit if match                    AY02  34
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AY02  35
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AY02  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AY02  37
IF(IABS(MM)<STOPM)#                    Test vector                      AY02  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AY02  39
L=MOD(LATICE-1,7)#                     Treat centric & acentric cells   AY02  40
IF(L !=1)J=0#                          Set flag for matching translat   AY02  41
ELSE J=3#                                                               AY02  42
DO I=1,3#                              Loop over coordinates            AY02  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AY02  44
LVEC(I)=VEC(I)-QX(IABS(MM)+9+I)#       Diff between card & symop        AY02  45
IF(LVEC(I)<-small:)LVEC(I)=1.0-AMOD(-LVEC(I),1.0)#                      AY02  46
ELSE LVEC(I)=AMOD(LVEC(I),1.0)#                                         AY02  47
IF((L==1)&(ABS(0.5-LVEC(I))<small:))#  I                                AY02  48
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AY02  49
J=J-1;NEXT#                                                             AY02  50
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AY02  51
IF(L==2)#                              R                                AY02  52
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AY02  53
IF(I>1)LVEC(I)=LVEC(I)+LVEC(1)#                                         AY02  54
ELSE IF(ABS(6.0*ABS(LVEC(1)-0.5)-1.0)<small:)NEXT#                      AY02  55
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AY02  56
IF((L>2)&(ABS(0.5-LVEC(I))<small:))#   F, a, b or c                     AY02  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AY02  58
J=1-J;IF(L-I !=3)NEXT#                                                  AY02  59
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AY02  60
IF((LVEC(I)>small:)&(ABS(LVEC(I)-1.0)>small:))#                         AY02  61
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AY02  62
J=1;BREAK#                             Exit with non-matching           AY02  63
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AY02  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AY02  65
IF((J !=0)&(J !=3))MM=STOPM#           Vector don't match               AY02  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AY02  67
IF(MM==STOPM)N=0#                      Symop not found                  AY02  68
ELSE#                                  Symop found in list              AY02  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AY02  70
IF(MM<0)N=1+(-MM-MARKM)/stepm:#                                         AY02  71
ELSE N=1+(MM-MARKM)/stepm:#                                             AY02  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AY02  73
RETURN#                                                                 AY02  74
END#                                                                    AY02  75
#                                                                       AY02  76
systemheader:(AY10)#                                                    AY10   1
####################################################################### AY10   2
#                                                                     # AY10   3
#                               AY10                                  # AY10   4
#                                                                     # AY10   5
####################################################################### AY10   6
SUBROUTINE AY10#                                                        AY10   7
#                                                                       AY10   8
include:(AACOMN)#                                                       AY10   9
include:(AYCOMN)#                                                       AY10  10
#                                                                       AY10  11
CALL AY11#                             Read addres line                 AY10  12
CALL AY12#                             Read bdf up to lratom:           AY10  13
RETURN#                                                                 AY10  14
END#                                                                    AY10  15
#                                                                       AY10  16
systemheader:(AY11)#                                                    AY11   1
####################################################################### AY11   2
#                                                                     # AY11   3
#                               AY11                                  # AY11   4
#                                                                     # AY11   5
####################################################################### AY11   6
SUBROUTINE AY11#                                                        AY11   7
#                                                                       AY11   8
include:(AACOMN)#                                                       AY11   9
include:(AYCOMN)#                                                       AY11  10
#                                                                       AY11  11
INTEGER FIELD#                         Field number                     AY11  12
INTEGER I,J,LEN,MATCH#                 Character comparaision           AY11  13
#                                                                       AY11  14
chardata:(AY111," Program mode                       Update")#          AY11  15
chardata:(AY112," List restraints (for each type)       All")#          AY11  16
chardata:(AY114,[UPDATE  APRIORI LIST    ])#                            AY11  17
chardata:(AY115,"Apriori Update")#                                      AY11  18
datastuff:#                                                             AY11  19
#                                                                       AY11  20
# INITIALIZATIONS                                                       AY11  21
# ---------------                                                       AY11  22
#                                                                       AY11  23
IOMARK(1)=QXSTR#                       Start of file 1 buffer           AY11  24
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of file 2 buffer           AY11  25
incrqx:(MARKM,IOMARK(2)+bdfbuf:,AY1101)# Get memory                     AY11  26
UPD=yes:;LIST=0#                       Update mode, no list of restra   AY11  27
NSF=0#                                 No scattering factors read       AY11  28
#                                                                       AY11  29
# READ ADDRES LINE                                                      AY11  30
# ----------------                                                      AY11  31
#                                                                       AY11  32
FIELD=1#                               Set field number                 AY11  33
REPEAT#                                Loop over fields                 AY11  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AY11  35
IF(BUFIN(FIELD)>=voidflg:)BREAK#       Exit if last                     AY11  36
stringlim:(FIELD,I,J)#                 Extract field limits             AY11  37
LEN=J-I#                               Length of string                 AY11  38
compchar:(CHRIN,I,AY114,1,LEN,8,NAY114,MATCH)# Look for option code     AY11  39
IF(MATCH==0)iquit:(AY1102)#            Option code not in list          AY11  40
IF(MATCH==2)UPD=no:#                   A-priori mode                    AY11  41
IF(MATCH==3)#                          List restraints                  AY11  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AY11  43
LIST=100000#                           Large number of restraints to    AY11  44
ifnm:(BUFIN(FIELD+1))#                 Numerical field after            AY11  45
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AY11  46
FIELD=FIELD+1#                         Take next field                  AY11  47
LIST=NINT(BUFIN(FIELD))#               Number of restraints to print    AY11  48
IF(LIST<=0)iquit:(AY1103)#             Exit if not positive             AY11  49
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AY11  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AY11  51
FIELD=FIELD+1#                         Increment field counter          AY11  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AY11  53
#                                                                       AY11  54
# WRITE FOR USER                                                        AY11  55
# --------------                                                        AY11  56
#                                                                       AY11  57
IF(UPD==no:)movechar:(AY115,1,AY111,36,7,0)# Move "apriori"             AY11  58
ELSE movechar:(AY115,8,AY111,36,7,0)#  Move "update"                    AY11  59
writeline:(1,AY111,NAY111,3,3)#        Print line                       AY11  60
IF(LIST>0)#                            List some restraints             AY11  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AY11  62
IF(LIST<=99999)ncodefld:(FLOAT(LIST),1,AY112,420513.,1)# Encode list    AY11  63
writeline:(0,AY112,NAY112,3,3)#        Print line                       AY11  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AY11  65
RETURN#                                                                 AY11  66
END#                                                                    AY11  67
#                                                                       AY11  68
systemheader:(AY12)#                                                    AY12   1
####################################################################### AY12   2
#                                                                     # AY12   3
#                               AY12                                  # AY12   4
#                                                                     # AY12   5
####################################################################### AY12   6
SUBROUTINE AY12#                                                        AY12   7
#                                                                       AY12   8
include:(AACOMN)#                                                       AY12   9
include:(AYCOMN)#                                                       AY12  10
#                                                                       AY12  11
INTEGER I,J,K#                         Loop indexes                     AY12  12
INTEGER NSYM#                          Symop number                     AY12  13
INTEGER AA#                            Atom pointer                     AY12  14
INTEGER CC#                            Atom type pointer                AY12  15
INTEGER DFT#                           Dispalcement factor type         AY12  16
INTEGER MM#                            Symop pointer                    AY12  17
INTEGER NSFNM#                         Actual sfnames length            AY12  18
INTEGER SFT#                           Scattering factor type           AY12  19
string:(NAME,lena:)#                   Atom name                        AY12  20
string:(SFNM,arith:(sfmax:,*,lens:))#  Sfnames                          AY12  21
#                                                                       AY12  22
chardata:(AY121," Atom                          ill-defined")#          AY12  23
datastuff:#                                                             AY12  24
#                                                                       AY12  25
# READ METRIC TENSOR AND INVERSE                                        AY12  26
# ------------------------------                                        AY12  27
#                                                                       AY12  28
copyfile:(1,2,1,decr:(lrcell:))#       Copy up to lrcell:               AY12  29
I=1#                                   Packet counter                   AY12  30
REPEAT#                                Loop over lrcell: packets        AY12  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AY12  32
readwpkt:(1,lrcell:,PSIZI,IPI,0)#      Read one packet                  AY12  33
IF(IPI<=0)BREAK#                       Exit if last                     AY12  34
writepkt:(2,lrcell:,PSIZI,IPO)#        Write one packet                 AY12  35
movereal:(QX,IPI+1,QX,IPO+1,PSIZI,0)#  Copy buffer                      AY12  36
IF(I==7)#                                                               AY12  37
DO J=1,3;DO K=1,3;MT(J,K)=QX(IPI+(J-1)*3+K)#                            AY12  38
IF(I==8)#                                                               AY12  39
DO J=1,3;DO K=1,3;MTINV(J,K)=QX(IPI+(J-1)*3+K)#                         AY12  40
I=I+1#                                 Increment packet counter         AY12  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AY12  42
IF(I<=8)iquit:(AY1201)#                Missing lrcell: packets on bdf   AY12  43
VOL=MT(1,1)*MT(2,2)*MT(3,3)+2.0*MT(1,2)*MT(2,3)*MT(3,1)-$#              AY12  44
MT(1,1)*MT(2,3)**2-MT(2,2)*MT(3,1)**2-MT(3,3)*MT(1,2)**2# Det           AY12  45
VOL=SQRT(VOL)#                         Cell volume                      AY12  46
#                                                                       AY12  47
# READ SYMETRY OPERATORS                                                AY12  48
# ----------------------                                                AY12  49
#                                                                       AY12  50
copyfile:(1,2,incr:(lrcell:),decr:(lrsymm:))# Copy up to lrsymm:        AY12  51
readwpkt:(1,lrsymm:,PSIZI,IPI,0)#      Read first lrsymm: packet        AY12  52
IF(IPI<=0)iquit:(AY1202)#              No lrcell: on bdf                AY12  53
writepkt:(2,lrsymm:,PSIZI,IPO)#        Write first lrsymm: packet       AY12  54
movereal:(QX,IPI+1,QX,IPO+1,PSIZI,0)#  Copy packet                      AY12  55
LATICE=NINT(QX(IPI+1))#                See instructions p. 394          AY12  56
IF(NINT(QX(IPI+2))==0)CENT=yes:#       Store centricity                 AY12  57
ELSE CENT=no:#                                                          AY12  58
NSYM=NINT(QX(IPI+4))#                  Number of matrices               AY12  59
MM=MARKM;STOPM=MARKM#                  Set symop pointers               AY12  60
DO I=1,NSYM#                                                            AY12  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AY12  62
readwpkt:(1,lrsymm:,PSIZI,IPI,0)#      Read one symetry packet          AY12  63
IF(IPI<=0)iquit:(AY1203)#              Lrsymm: ended too soon           AY12  64
writepkt:(2,lrsymm:,PSIZI,IPO)#        Write one symmetry packet        AY12  65
movereal:(QX,IPI+1,QX,IPO+1,PSIZI,0)#  Copy packet                      AY12  66
incrqx:(STOPM,STOPM+stepm:,AY1204)#    Get memory                       AY12  67
movereal:(QX,IPI+1,QX,MM+1,stepm:,0)#  Store symop                      AY12  68
incrm:(MM)#                            Increment symop pointer          AY12  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AY12  70
REPEAT#                                Loop over remaining lrsymm: pa   AY12  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AY12  72
readwpkt:(1,lrsymm:,PSIZI,IPI,0)#      Read one packet                  AY12  73
IF(IPI<=0)BREAK#                       Exit if last                     AY12  74
writepkt:(2,lrsymm:,PSIZI,IPO)#        Write one packet                 AY12  75
movereal:(QX,IPI+1,QX,IPO+1,PSIZI,0)#  Copy packet                      AY12  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AY12  77
#                                                                       AY12  78
# READ SCATTERNING FACTOR NAMES                                         AY12  79
# -----------------------------                                         AY12  80
#                                                                       AY12  81
copyfile:(1,2,incr:(lrsymm:),decr:(lrscat:))# Copy up to lrscat:        AY12  82
DO I=1,mxwd8c:;IWANT(I)=11#            Scattering factor name           AY12  83
KEY(1)=mxwd8c:;KEY(2)=0;KEY(3)=0;KEY(4)=0# Update mode                  AY12  84
indexpkt:(1,lrscat:,PSIZI,IPI,2,KEY,IWANT,IREL)# Read directory         AY12  85
IF(IPI<=0)iquit:(AY1206)#              Lrscat: not on bdf               AY12  86
IF(KEY(4)<0)iquit:(AY1207)#            Missing mandatory items (name)   AY12  87
NSFNM=0;MARKC=STOPM;STOPC=MARKC;CC=MARKC# Set list c pointers           AY12  88
REPEAT#                                Loop over lrscat: packets        AY12  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AY12  90
readwpkt:(1,lrscat:,PSIZI,IPI,0)#      Read one packet                  AY12  91
IF(IPI<=0)BREAK#                       Exit on last                     AY12  92
writepkt:(2,lrscat:,PSIZI,IPO)#        Write one packet                 AY12  93
movereal:(QX,IPI+1,QX,IPO+1,PSIZI,0)#  Copy packet                      AY12  94
incrqx:(STOPC,STOPC+stepc:,AY1205)#    Get mem for sfnames              AY12  95
movereal:(QX,IPI+IREL(1),QX,CC+1,mxwd8c:,0)# Copy sf name in list c     AY12  96
incrc:(CC);NSF=NSF+1;NSFNM=NSFNM+lens:# Increment scat fact counter     AY12  97
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AY12  98
movertoc:(QX(MARKC+1),1,SFNM,1,NSF*lens:,0)# Copy list c to sfnames     AY12  99
#                                                                       AY12 100
# READ LRATOM: DIRECTORY                                                AY12 101
# ----------------------                                                AY12 102
#                                                                       AY12 103
copyfile:(1,2,incr:(lrscat:),decr:(lratom:))# Copy up to lratom:        AY12 104
MARKA=STOPC;STOPA=MARKA;AA=MARKA#      Set atom list pointers           AY12 105
IWANT(1)=14#                           Atom name                        AY12 106
DO J=1,10;IWANT(J+1)=J#                Position and displ fact          AY12 107
IWANT(12)=22#                          Sf type                          AY12 108
IWANT(13)=23#                          Displ fact type                  AY12 109
KEY(1)=1;KEY(2)=13;KEY(3)=0;KEY(4)=0#  Update mode                      AY12 110
indexpkt:(1,lratom:,PSIZI,IPI,2,KEY,IWANT,IREL)# Read directory         AY12 111
IF(IPI<=0)iquit:(AY1208)#              Lratom: not on bdf               AY12 112
IF(KEY(4)<0)iquit:(AY1209)#            Mandatory items are missing (a   AY12 113
#                                                                       AY12 114
# READ ATOMS                                                            AY12 115
# ----------                                                            AY12 116
#                                                                       AY12 117
REPEAT#                                                                 AY12 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AY12 119
readwpkt:(1,lratom:,PSIZI,IPI,0)#      Read one packet                  AY12 120
IF(IPI<=0)BREAK#                       Exit if last                     AY12 121
writepkt:(2,lratom:,PSIZI,IPO)#        Write one packet                 AY12 122
movereal:(QX,IPI+1,QX,IPO+1,PSIZI,0)#  Copy packet                      AY12 123
movertoc:(QX(IPI+IREL(1)),1,NAME,1,lena:,0)# Save atom name             AY12 124
label:(NAME,J,K,SFNM,SFT)#             Check atom name                  AY12 125
IF(IREL(13)>0)DFT=NINT(QX(IPI+IREL(13)))# Displ fact type               AY12 126
ELSE DFT=0#                            Default: overall                 AY12 127
IF((DFT<0)\(DFT>2))#                   Check dft for error              AY12 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AY12 129
movechar:(NAME,1,AY121,7,lena:,0)#     Encode atom name                 AY12 130
writeline:(0,AY121,NAY121,3,3)#        Print warning                    AY12 131
NEXT#                                                                   AY12 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AY12 133
IF(IREL(12)>0)#                                                         AY12 134
IF((SFT==0)\(SFT !=NINT(QX(IPI+IREL(12)))))#                            AY12 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AY12 136
movechar:(NAME,1,AY121,7,lena:,0)#     Encode atom name                 AY12 137
writeline:(0,AY121,NAY121,3,3)#        Print warning                    AY12 138
NEXT#                                                                   AY12 139
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AY12 140
incrqx:(STOPA,STOPA+stepa:,AY1210)#    Get mem                          AY12 141
movector:(NAME,1,atomn:(AA),1,lena:,0)# Save atom name                  AY12 142
atomsft:(AA)=FLOAT(SFT);atomdft:(AA)=FLOAT(DFT)# Store pointers         AY12 143
DO J=1,3#                                                               AY12 144
IF(IREL(J+1)>0)atompos:(AA+J)=QX(IPI+IREL(J+1))#                        AY12 145
ELSE atompos:(AA+J)=voidflg:#                                           AY12 146
IF(DFT==1)#                            Atom isotropic                   AY12 147
IF(IREL(5)>0)atomiso:(AA)=QX(IPI+IREL(5))#                              AY12 148
ELSE atomiso:(AA)=voidflg:#                                             AY12 149
IF(DFT==2)#                            Atom anisotropic                 AY12 150
DO J=1,6#                                                               AY12 151
IF(IREL(J+5)>0)atomani:(AA+J)=QX(IPI+IREL(J+5))#                        AY12 152
ELSE atomani:(AA+J)=voidflg:#                                           AY12 153
incra:(AA)#                            Increment atom pointer           AY12 154
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AY12 155
RETURN#                                                                 AY12 156
END#                                                                    AY12 157
#                                                                       AY12 158
systemheader:(AY20)#                                                    AY20   1
####################################################################### AY20   2
#                                                                     # AY20   3
#                               AY20                                  # AY20   4
#                                                                     # AY20   5
####################################################################### AY20   6
SUBROUTINE AY20#                                                        AY20   7
#                                                                       AY20   8
include:(AACOMN)#                                                       AY20   9
include:(AYCOMN)#                                                       AY20  10
#                                                                       AY20  11
CALL AY21#                             Read symeq cards                 AY20  12
copyfile:(1,2,incr:(lratom:),decr:(lrbond:))# Copy up to restraints l   AY20  13
IF(UPD==yes:)CALL AY22#                Read bdf restraints              AY20  14
CALL AY24#                             Read restr & delres cards        AY20  15
CALL AY25#                             Compute restraints               AY20  16
IF(MARKR(4)<STOPR(4))CALL AY26#        Compute rigid bond restraints    AY20  17
RETURN#                                                                 AY20  18
END#                                                                    AY20  19
#                                                                       AY20  20
systemheader:(AY21)#                                                    AY21   1
####################################################################### AY21   2
#                                                                     # AY21   3
#                               AY21                                  # AY21   4
#                                                                     # AY21   5
####################################################################### AY21   6
SUBROUTINE AY21#                                                        AY21   7
#                                                                       AY21   8
include:(AACOMN)#                                                       AY21   9
include:(AYCOMN)#                                                       AY21  10
#                                                                       AY21  11
INTEGER AA,AA1#                        Atom pointers                    AY21  12
INTEGER I,J,LEN#                       Field delimieters                AY21  13
INTEGER FIELD#                         Field counter                    AY21  14
INTEGER MATCH#                         Used in string comparision       AY21  15
INTEGER N#                             Symop number                     AY21  16
INTEGER NUM,DEN#                       Numerator and denominator of f   AY21  17
INTEGER SS,SS1#                        Symeq pointers                   AY21  18
REAL DET#                              Determinant of mat               AY21  19
REAL FRAC#                             Fractional part of real number   AY21  20
REAL MAT(3,3),VEC(3)#                  Matrix & vector from symeq car   AY21  21
REAL SIGN#                             Sign of fraction                 AY21  22
string:(NAME,lena:)#                   Temporary atom name              AY21  23
string:(NAME1,lena:)#                  Root atom name                   AY21  24
string:(NAME2,lena:)#                  Symeq atom name                  AY21  25
#                                                                       AY21  26
chardata:(AY211,SYMEQ RESTR DELRES END)#                                AY21  27
chardata:(AY212," WARNING- Root atom xxxxxxxxxxxxxxxxxxxxxxxx is $#     AY21  28
not in atom list-symeq card skipped")#                                  AY21  29
chardata:(AY213," WARNING- Symeq atom xxxxxxxxxxxxxxxxxxxxxxxx is $#    AY21  30
already in atom list-symeq card skipped")#                              AY21  31
chardata:(AY214," WARNING- Determinant of the matrix on the former $#   AY21  32
symeq card is not equal to 1")#                                         AY21  33
chardata:(AY215," WARNING- Symeq atom xxxxxxxxxxxxxxxxxxxxxxxx is $#    AY21  34
not related to root atom xxxxxxxxxxxxxxxxxxxxxxxx by group symop")#     AY21  35
chardata:(AY216,[0123456789+-/XYZ])#                                    AY21  36
datastuff:#                                                             AY21  37
#                                                                       AY21  38
MARKS=STOPA;STOPS=MARKS;SS=MARKS#      Set symeq pointers               AY21  39
REPEAT#                                Loop over input cards            AY21  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AY21  41
readline:(AY211,NAY211)#               Read one card                    AY21  42
IF(LINID !=1)BREAK#                    Exit if not symeq                AY21  43
#                                                                       AY21  44
# COMPARAISION WITH ROOT ATOM NAME                                      AY21  45
# --------------------------------                                      AY21  46
#                                                                       AY21  47
IF(BUFIN(1)>=voidflg:)iquit:(AY2101)#  Root atom name is missing        AY21  48
movechar:(BLANK,1,NAME1,1,lena:,1)#    Clear root atom name             AY21  49
stringlim:(1,I,J);LEN=MIN0(J-I,lena:)# Extract string limits            AY21  50
movechar:(CHRIN,I,NAME1,1,LEN,0)#      Copy root atom name              AY21  51
DO AA=MARKA,STOPA-stepa:,stepa:#       Loop over atoms                  AY21  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AY21  53
movertoc:(atomn:(AA),1,NAME,1,lena:,0)# Copy atom name                  AY21  54
upcase:(NAME,NAME,lena:)#              Convert to upper case            AY21  55
compchar:(NAME,1,NAME1,1,lena:,lena:,lena:,MATCH)# Compare names        AY21  56
IF(MATCH !=0)BREAK#                    Match found                      AY21  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AY21  58
IF(AA>=STOPA)#                         Root atom name not in list       AY21  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AY21  60
movechar:(NAME1,1,AY212,21,lena:,0)#   Move name in warning             AY21  61
writeline:(0,AY212,NAY212,3,3)#        Print warning                    AY21  62
NEXT#                                                                   AY21  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AY21  64
#                                                                       AY21  65
# COMPARAISION WITH SYMEQ ATOM NAME                                     AY21  66
# ---------------------------------                                     AY21  67
#                                                                       AY21  68
IF(BUFIN(2)>=voidflg:)iquit:(AY2102)#  Symeq atom name is missing       AY21  69
movechar:(BLANK,1,NAME2,1,lena:,1)#    Clear symeq atom name            AY21  70
stringlim:(2,I,J);LEN=MIN0(J-I,lena:)# Extract string limits            AY21  71
movechar:(CHRIN,I,NAME2,1,LEN,0)#      Copy symeq atom name             AY21  72
DO AA1=MARKA,STOPA-stepa:,stepa:#      Loop over atoms                  AY21  73
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AY21  74
movertoc:(atomn:(AA1),1,NAME,1,lena:,0)# Copy atom name                 AY21  75
upcase:(NAME,NAME,lena:)#              Convert to upper case            AY21  76
compchar:(NAME,1,NAME2,1,lena:,lena:,lena:,MATCH)# Compare names        AY21  77
IF(MATCH !=0)BREAK#                    Match found                      AY21  78
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AY21  79
DO SS1=MARKS,SS-steps:,steps:#                                          AY21  80
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AY21  81
movertoc:(symname:(SS1),1,NAME,1,lena:,0)# Copy symeq atom name         AY21  82
upcase:(NAME,NAME,lena:)#              Convert to upper case            AY21  83
compchar:(NAME,1,NAME2,1,lena:,lena:,lena:,MATCH)# Compare names        AY21  84
IF(MATCH !=0)BREAK#                    Match found                      AY21  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AY21  86
IF((AA1<STOPA)\(SS1<SS))#              Symeq atom name in list          AY21  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AY21  88
movechar:(NAME2,1,AY213,22,lena:,0)#   Move name in warning             AY21  89
writeline:(0,AY213,NAY213,3,3)#        Print warning                    AY21  90
NEXT#                                                                   AY21  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AY21  92
#                                                                       AY21  93
# INPUT OF MATRIX                                                       AY21  94
# ---------------                                                       AY21  95
#                                                                       AY21  96
DO FIELD=3,5#                          Loop over coordinates            AY21  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AY21  98
ifvo:(BUFIN(FIELD))iquit:(AY2110)#     One coordinate is missing        AY21  99
VEC(FIELD-2)=0.0;DO J=1,3;MAT(FIELD-2,J)=0.0# Clear coord               AY21 100
stringlim:(FIELD,I,J);LEN=J-I#         Extract string limits            AY21 101
NUM=0;DEN=0;FRAC=0.0;SIGN=1.0#                                          AY21 102
REPEAT#                                Loop over field                  AY21 103
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AY21 104
compchar:(CHRIN,I,AY216,1,1,1,NAY216,MATCH)# Compare current char       AY21 105
IF(MATCH==0)iquit:(AY2111)#            Syntax error in field            AY21 106
IF(MATCH<=10)#                         Number encountered               AY21 107
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AY21 108
gunsi:(I,NUM)#                         Get numerator                    AY21 109
IF(I==J)#                              Last char                        AY21 110
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AY21 111
VEC(FIELD-2)=SIGN*FLOAT(NUM);BREAK#    Store number & exit              AY21 112
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AY21 113
compchar:(CHRIN,I,AY216,11,1,1,NAY216,MATCH)# Compare without nb        AY21 114
IF(MATCH==0)iquit:(AY2111)#            Syntax error in field            AY21 115
IF(MATCH<3)#                           + or -                           AY21 116
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AY21 117
VEC(FIELD-2)=SIGN*FLOAT(NUM)#          Store vector                     AY21 118
IF(MATCH==1)SIGN=1.0#                  Set sign                         AY21 119
ELSE SIGN=-1.0#                                                         AY21 120
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AY21 121
ELSE IF(MATCH==3)#                     /                                AY21 122
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AY21 123
I=I+1;compchar:(CHRIN,I,AY216,1,1,1,10,MATCH)# Comp only nb             AY21 124
IF(MATCH==0)iquit:(AY2112)#            Must be nb after /               AY21 125
gunsi:(I,DEN);FRAC=SIGN*FLOAT(NUM)/FLOAT(DEN)# Get fraction             AY21 126
IF(I==J)#                                                               AY21 127
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AY21 128
VEC(FIELD-2)=FRAC;BREAK#               Store fraction & exit            AY21 129
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AY21 130
compchar:(CHRIN,I,AY216,11,1,1,NAY216,MATCH)# Comp with +-/xyz          AY21 131
IF(MATCH==3)iquit:(AY2113)#            Not two fraction (x/y/z)         AY21 132
IF(MATCH<3)#                           + or -                           AY21 133
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AY21 134
VEC(FIELD-2)=FRAC#                     Store fraction                   AY21 135
IF(MATCH==1)SIGN=1.0#                  Set sign                         AY21 136
ELSE SIGN=-1.0#                                                         AY21 137
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AY21 138
ELSE#                                  Coordinate                       AY21 139
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AY21 140
MAT(FIELD-2,MATCH-3)=FRAC;SIGN=1.0#    Store frac & reset sign          AY21 141
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AY21 142
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AY21 143
ELSE#                                  Coordinate                       AY21 144
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AY21 145
MAT(FIELD-2,MATCH-3)=SIGN*FLOAT(NUM);SIGN=1.0# Store frac & reset sig   AY21 146
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AY21 147
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AY21 148
ELSE#                                  Not a number                     AY21 149
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 AY21 150
IF(MATCH==13)iquit:(AY2114)#           No / without a number before i   AY21 151
IF(MATCH<13)#                          + or -                           AY21 152
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 AY21 153
IF(MATCH==11)SIGN=1.0#                 Set sign                         AY21 154
ELSE SIGN=-1.0#                                                         AY21 155
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 AY21 156
ELSE#                                  Coordinate                       AY21 157
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 AY21 158
MAT(FIELD-2,MATCH-13)=SIGN#            Store +- 1                       AY21 159
SIGN=1.0#                              Reset sign                       AY21 160
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 AY21 161
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 AY21 162
I=I+1#                                 Take next char                   AY21 163
IF(I==J)BREAK#                         Exit if end-of-field reached     AY21 164
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AY21 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AY21 166
incrqx:(STOPS,STOPS+steps:,AY2115)#    Get memory                       AY21 167
symptr:(SS)=FLOAT(AA)#                 Save root atom pointer           AY21 168
movector:(NAME2,1,symname:(SS),1,lena:,0)# Save symeq name              AY21 169
DO I=1,3#                              Loop over coordinates            AY21 170
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 AY21 171
symvec:(SS+I)=VEC(I)#                  Save translation                 AY21 172
DO J=1,3;symmat:(SS+(I-1)*3+J)=MAT(J,I)# Save matrix                    AY21 173
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 AY21 174
#                                                                       AY21 175
# TEST MATRIX AGAINST SYMOP AND STORE CELL NB                           AY21 176
# -------------------------------------------                           AY21 177
#                                                                       AY21 178
CALL AY02(MAT,VEC,N)#                  Get symop pointer (0 if not fo   AY21 179
symop:(SS)=FLOAT(N)#                   Save symop                       AY21 180
IF(N==0)#                              Matrix not in symop list         AY21 181
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 AY21 182
movertoc:(symname:(SS),1,AY215,22,lena:,0)# Move symeq name             AY21 183
movertoc:(atomn:(AA),1,AY215,75,lena:,0)# Move root atom name           AY21 184
writeline:(0,AY215,NAY215,3,3)#        Print warning                    AY21 185
DET=MAT(1,1)*MAT(2,2)*MAT(3,3)+MAT(1,2)*MAT(2,3)*MAT(3,1)+$#            AY21 186
MAT(1,3)*MAT(3,2)*MAT(2,1)-MAT(1,1)*MAT(2,3)*MAT(3,2)-$#                AY21 187
MAT(2,2)*MAT(3,1)*MAT(1,3)-MAT(3,3)*MAT(1,2)*MAT(2,1)#                  AY21 188
ifne:(ABS(DET),1.0)writeline:(0,AY214,NAY214,3,3)# Print warning        AY21 189
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 AY21 190
incrs:(SS)#                            Take next symeq                  AY21 191
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AY21 192
IF((LINID==4)\(LINID==0))iquit:(AY2120)# Exit on end or unrecognized    AY21 193
RETURN#                                                                 AY21 194
END#                                                                    AY21 195
#                                                                       AY21 196
systemheader:(AY22)#                                                    AY22   1
####################################################################### AY22   2
#                                                                     # AY22   3
#                               AY22                                  # AY22   4
#                                                                     # AY22   5
####################################################################### AY22   6
SUBROUTINE AY22#                                                        AY22   7
#                                                                       AY22   8
include:(AACOMN)#                                                       AY22   9
include:(AYCOMN)#                                                       AY22  10
#                                                                       AY22  11
INTEGER AA#                            Atom pointer                     AY22  12
INTEGER I,J,K,L,M#                     Loop indexes                     AY22  13
INTEGER MATCH#                         Used in string comparisions      AY22  14
INTEGER MM#                            Symop pointer                    AY22  15
INTEGER RR#                            Restraint pointer                AY22  16
INTEGER TYPE#                          Type of restraint                AY22  17
REAL MAT(3,3),VEC(3)#                  Matrix & vector (local)          AY22  18
string:(NAME1,lena:)#                  Name from bdf restraint          AY22  19
string:(NAME2,lena:)#                  Name from atom list              AY22  20
#                                                                       AY22  21
intdata:(LEN,[2,3,4,2])#                                                AY22  22
intdata:(LRRES,[40,42,43,44])#  ## lrbond: lrangl: lrdihe: lrrigi:      AY22  23
chardata:(AY221," WARNING- Atom xxxxxxxxxxxxxxxxxxxxxxx not found in $# AY22  24
atom list- restraint skipped")#                                         AY22  25
chardata:(AY222,[" WARNING- No symmetry operation for atom $#           AY22  26
xxxxxxxxxxxxxxxxxxxxxxxx, restraint skipped"])#                         AY22  27
chardata:(AY223,[" WARNING- Matrix and symop have different values"])#  AY22  28
datastuff:#                                                             AY22  29
#                                                                       AY22  30
MARKR(1)=STOPS;STOPR(1)=MARKR(1);RR=MARKR(1)# Set restraint pointers    AY22  31
DO TYPE=1,4#                           Loop over restraint types        AY22  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AY22  33
IF(TYPE>1)#                            Set pointers                     AY22  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AY22  35
MARKR(TYPE)=STOPR(TYPE-1);STOPR(TYPE)=MARKR(TYPE);RR=MARKR(TYPE)#       AY22  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AY22  37
#                                                                       AY22  38
# READ LOGICAL RECORDS DIRECTORIES                                      AY22  39
# --------------------------------                                      AY22  40
#                                                                       AY22  41
I=1#                                   First item in iwant/irel array   AY22  42
DO K=10,10*LEN(TYPE),10#               Loop over atoms                  AY22  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AY22  44
IWANT(I)=K+1;I=I+1#                                                     AY22  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AY22  46
IWANT(I)=93;I=I+1#                     Store observed value             AY22  47
IWANT(I)=94;I=I+1#                     Store esd of obs                 AY22  48
KEY(1)=I-1#                            End of mandatory inputs          AY22  49
IWANT(I)=95;I=I+1#                     Store weight                     AY22  50
DO K=10,10*LEN(TYPE),10#               Loop over atoms                  AY22  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AY22  52
DO J=1,12#                                                              AY22  53
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AY22  54
IWANT(I)=10*K+J;I=I+1#                 Store matrix & vector            AY22  55
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AY22  56
IWANT(I)=K+5;I=I+1#                    Store symop nb                   AY22  57
IWANT(I)=K+6;I=I+1#                    Store cell nb                    AY22  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AY22  59
KEY(2)=I-1;KEY(3)=I-1;KEY(4)=0#        Update mode                      AY22  60
indexpkt:(1,LRRES(TYPE),PSIZI,IPI,0,KEY,IWANT,IREL)# Read directory     AY22  61
IF(IPI<=0)NEXT#                        Logical record containing this   AY22  62
IF(KEY(4)<0)#                          Missing mandatory items          AY22  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AY22  64
IF(TYPE==1)iquit:(AY2201)#             Distance                         AY22  65
IF(TYPE==2)iquit:(AY2202)#             Angle                            AY22  66
IF(TYPE==3)iquit:(AY2203)#             Torsion                          AY22  67
IF(TYPE==4)iquit:(AY2204)#             Bond                             AY22  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AY22  69
REPEAT#                                                                 AY22  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AY22  71
#                                                                       AY22  72
# READ ONE RESTRAINT                                                    AY22  73
# ------------------                                                    AY22  74
#                                                                       AY22  75
readwpkt:(1,LRRES(TYPE),PSIZI,IPI,0)#  Read one packet                  AY22  76
IF(IPI<=0)BREAK#                       Exit if last                     AY22  77
incrqx:(STOPR(TYPE),STOPR(TYPE)+LEN(TYPE)*recl:+8,AY2205)# Get memory   AY22  78
I=0;J=LEN(TYPE)+3#                     Reset directory pointer          AY22  79
DO K=1,LEN(TYPE)#                      Loop over atoms                  AY22  80
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AY22  81
#                                                                       AY22  82
# CHECK ATOM NAME                                                       AY22  83
# ---------------                                                       AY22  84
#                                                                       AY22  85
movertoc:(QX(IPI+IREL(I+1)),1,NAME1,1,lena:,0)# Move name               AY22  86
DO AA=MARKA,STOPA-stepa:,stepa:#       Test atom names                  AY22  87
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AY22  88
movertoc:(atomn:(AA),1,NAME2,1,lena:,0)# Move atom name                 AY22  89
compchar:(NAME1,1,NAME2,1,lena:,lena:,lena:,MATCH)# Compare             AY22  90
IF(MATCH !=0)BREAK#                    Exit if match                    AY22  91
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AY22  92
IF(AA>=STOPA)#                         Name not found in atom list      AY22  93
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AY22  94
movechar:(NAME1,1,AY221,16,lena:,0)#   Move to warning                  AY22  95
writeline:(0,AY221,NAY221,3,3)#        Print warning                    AY22  96
STOPR(TYPE)=RR#                        Discard this restraint           AY22  97
BREAK#                                 Take next restraint              AY22  98
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AY22  99
#                                                                       AY22 100
# STORE RESTRAINT                                                       AY22 101
# ---------------                                                       AY22 102
#                                                                       AY22 103
resptr:(RR,K)=FLOAT(AA)#               Save atom pointer                AY22 104
ifpr:(J+1)movereal:(QX,IPI+IREL(J+1),resm:(RR,K,1),1,12,0)# Copy code   AY22 105
ELSE movereal:(voidflg:,1,resm:(RR,K,1),1,12,2)#                        AY22 106
ifpr:(J+13)movereal:(QX,IPI+IREL(J+13),resop:(RR,K),1,1,0)#             AY22 107
ELSE movereal:(voidflg:,1,resop:(RR,K),1,1,0)#                          AY22 108
IF((resm:(RR,K,1)==voidflg:)&(resop:(RR,K)==voidflg:))# No symmetry     AY22 109
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AY22 110
movertoc:(atomn:(AA),1,AY222,42,lena:,0)# Copy atom name                AY22 111
writeline:(1,AY222,NAY222,3,3)#        Print warning                    AY22 112
BREAK#                                 Exit of atom loop                AY22 113
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AY22 114
ifnm:(resm:(RR,K,1))#                  Matrix present in list           AY22 115
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AY22 116
DO L=1,3#                              Loop over coordinates            AY22 117
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AY22 118
VEC(L)=resvec:(RR,K,L)#                                                 AY22 119
DO M=1,3;MAT(L,M)=resm:(RR,K,L,M)#     Local matrix                     AY22 120
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AY22 121
CALL AY02(MAT,VEC,L)#                                                   AY22 122
ifnm:(resop:(RR,K))#                   Symop already present            AY22 123
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AY22 124
IF(NINT(resop:(RR,K))!=L)writeline:(1,AY223,NAY223,3,3)# Print warnin   AY22 125
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AY22 126
resop:(RR,K)=FLOAT(L)#                 Save symop nb                    AY22 127
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AY22 128
ELSE#                                  Matrix is void, test symop       AY22 129
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AY22 130
MM=NINT(resop:(RR,K))#                 Get symop                        AY22 131
IF(MM==0)#                             No matrix given                  AY22 132
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AY22 133
NEXT#                                  Take next restraint              AY22 134
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AY22 135
IF(MM>0)#                              No center of symmetry            AY22 136
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 AY22 137
MM=MARKM+(MM-1)*stepm:#                Get symop address                AY22 138
movereal:(QX,MM+1,resm:(RR,K,1),1,12,0)# Copy matrix & vector           AY22 139
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 AY22 140
ELSE#                                  Center of symmetry               AY22 141
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 AY22 142
MM=MARKM+(-MM-1)*stepm:#               Get symop address                AY22 143
DO L=1,12;resm:(RR,K,L)=-QX(-MM+L)#    Store inverse                    AY22 144
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 AY22 145
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AY22 146
I=I+1;J=J+14#                          Update directory pointer         AY22 147
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AY22 148
IF(K<=LEN(TYPE))NEXT#                  Take next restraint              AY22 149
resobs:(RR)=QX(IPI+IREL(I+1))#         Observed value                   AY22 150
resd:(RR)=QX(IPI+IREL(I+2))#           Esd of obs                       AY22 151
IF((IREL(I+3)>0)&(QX(IPI+IREL(3))!=voidflg:))# Weight on bdf            AY22 152
resw:(RR)=QX(IPI+IREL(I+3))#           Weight                           AY22 153
ELSE resw:(RR)=1.0/resd:(RR)**2#       Default: 1/sigma**2              AY22 154
incrr:(RR,LEN(TYPE))#                  Increment restraint pointer      AY22 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AY22 156
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AY22 157
RETURN#                                                                 AY22 158
END#                                                                    AY22 159
#                                                                       AY22 160
systemheader:(AY24)#                                                    AY24   1
####################################################################### AY24   2
#                                                                     # AY24   3
#                               AY24                                  # AY24   4
#                                                                     # AY24   5
####################################################################### AY24   6
SUBROUTINE AY24#                                                        AY24   7
#                                                                       AY24   8
include:(AACOMN)#                                                       AY24   9
include:(AYCOMN)#                                                       AY24  10
#                                                                       AY24  11
INTEGER AA#                            Atom pointer                     AY24  12
INTEGER I,J,K,L,ILEN#                  String limits & loop index       AY24  13
INTEGER MATCH#                         Used in string comparaision      AY24  14
INTEGER RANGE#                         Number of words to move          AY24  15
INTEGER TYPE#                          Type of restraint                AY24  16
INTEGER RR#                            Restraint pointer                AY24  17
INTEGER SS#                            Symeq pointer                    AY24  18
INTEGER APTR(4)#                       Root atom pointers               AY24  19
REAL MAT(4,12)#                        Matrices for each atom in rest   AY24  20
string:(NAME1,lena:);string:(NAME2,lena:)#                              AY24  21
#                                                                       AY24  22
intdata:(LEN,[2,3,4,2])#                                                AY24  23
intdata:(LRRES,[40,42,43,44])#         Logical record numbres           AY24  24
chardata:(AY241,SYMEQ RESTR DELRES END)#                                AY24  25
chardata:(AY242,ALL   DIST  ANGLE TORS  DIHE  BOND  )#                  AY24  26
chardata:(AY243," WARNING- Symeq card follwing restr or delres cards- $#AY24  27
all following cards will be discarded")#                                AY24  28
datastuff:#                                                             AY24  29
#                                                                       AY24  30
IF(UPD==no:)#                                                           AY24  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AY24  32
MARKR(1)=STOPS;STOPR(1)=MARKR(1)#                                       AY24  33
MARKR(2)=STOPR(1);STOPR(2)=MARKR(2)#                                    AY24  34
MARKR(3)=STOPR(2);STOPR(3)=MARKR(3)#                                    AY24  35
MARKR(4)=STOPR(3);STOPR(4)=MARKR(4)#                                    AY24  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AY24  37
REPEAT#                                Loop over cards                  AY24  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AY24  39
IF((LINID<2)\(LINID==4))BREAK#         Exit if not restr or delres      AY24  40
IF(BUFIN(1)>=voidflg:)iquit:(AY2401)#  Syntax error                     AY24  41
#                                                                       AY24  42
# TEST TYPE OF RESTRAINT                                                AY24  43
# ----------------------                                                AY24  44
#                                                                       AY24  45
stringlim:(1,I,J);ILEN=J-I#            Extract string limits            AY24  46
compchar:(CHRIN,I,AY242,1,ILEN,6,NAY242,TYPE)# Get type                 AY24  47
IF(TYPE==0)iquit:(AY2402)#             Unknown restraint type           AY24  48
TYPE=TYPE-1#                           Type is the restraint type nb    AY24  49
IF(TYPE>3)TYPE=TYPE-1#                 Synonym for torsion              AY24  50
IF((TYPE==0)&(LINID==2))iquit:(AY2403)# Restr all forbidden             AY24  51
IF((LINID==3)&(TYPE==0))#              Delres all                       AY24  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AY24  53
STOPR(1)=MARKR(1)#                     Stop pointer  = start pointer    AY24  54
MARKR(2)=STOPR(1);STOPR(2)=MARKR(2)#                                    AY24  55
MARKR(3)=STOPR(2);STOPR(3)=MARKR(3)#                                    AY24  56
MARKR(4)=STOPR(3);STOPR(4)=MARKR(4)#                                    AY24  57
readline:(AY241,NAY241)#               Take next card                   AY24  58
NEXT#                                  Take next card                   AY24  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AY24  60
#                                                                       AY24  61
# CHECK ATOM NAME FOR ROOT OR SYMEQ                                     AY24  62
# ---------------------------------                                     AY24  63
#                                                                       AY24  64
DO I=1,LEN(TYPE)#                      Loop over atom names             AY24  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AY24  66
APTR(I)=0#                             Clear pointer                    AY24  67
ifvo:(BUFIN(I+1))BREAK#                Exit if void field               AY24  68
ifnm:(BUFIN(I+1))iquit:(AY2405)#       Numerical field forbidden here   AY24  69
stringlim:(I+1,J,K);ILEN=MIN0(lena:,K-J)# Extract string limits         AY24  70
compchar:(CHRIN,J,AY242,1,ILEN,6,6,MATCH)# Compare with all             AY24  71
IF(MATCH !=0)NEXT#                     Exit if field is all             AY24  72
movechar:(BLANK,1,NAME1,1,lena:,2)#    Clear name1                      AY24  73
movechar:(CHRIN,J,NAME1,1,ILEN,0)#     Copy atom name                   AY24  74
DO K=1,12;MAT(I,K)=0.0#                Clear matrix                     AY24  75
MAT(I,1)=1.0;MAT(I,5)=1.0;MAT(I,9)=1.0# Identity matrix                 AY24  76
DO AA=MARKA,STOPA-stepa:,stepa:#       Loop over atoms                  AY24  77
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AY24  78
movertoc:(atomn:(AA),1,NAME2,1,lena:,0)# Atom name                      AY24  79
upcase:(NAME2,NAME2,lena:)#            Convert to upper case            AY24  80
compchar:(NAME1,1,NAME2,1,lena:,lena:,lena:,MATCH)# Compare             AY24  81
IF(MATCH !=0)BREAK#                    Exit if found in list            AY24  82
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AY24  83
IF(AA>=STOPA)#                         Not in atom list, try symeq li   AY24  84
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AY24  85
DO SS=MARKS,STOPS-steps:,steps:#       Loop over symeq                  AY24  86
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AY24  87
movertoc:(symname:(SS),1,NAME2,1,lena:,0)# Symeq name                   AY24  88
upcase:(NAME2,NAME2,lena:)#            Convert to upper case            AY24  89
compchar:(NAME1,1,NAME2,1,ILEN,lena:,lena:,MATCH)# Compare              AY24  90
IF(MATCH !=0)BREAK#                    Exit if found in list            AY24  91
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AY24  92
IF(SS>=STOPS)iquit:(AY2406)#           Name not found                   AY24  93
AA=-NINT(symptr:(SS))#                 Save root atom pointer           AY24  94
DO K=1,12;MAT(I,K)=symmat:(SS+K)#      Store matrix & vector            AY24  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AY24  96
APTR(I)=AA#                            Save atom pointer                AY24  97
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AY24  98
I=I-1#                                 Last atom name field             AY24  99
J=yes:;DO K=1,LEN(TYPE);IF(APTR(K)==0)J=no:# Set 0 if all used          AY24 100
IF(((I<LEN(TYPE))\(J==no:))&(LINID==2))iquit:(AY2404)# Missing atom n   AY24 101
#                                                                       AY24 102
# CHECK IF ALREADY KNOWN RESTRAINT                                      AY24 103
# --------------------------------                                      AY24 104
#                                                                       AY24 105
IF(UPD==yes:)#                         Used to have more than one res   AY24 106
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AY24 107
FOR(RR=MARKR(TYPE);RR<STOPR(TYPE);incrr:(RR,LEN(TYPE)))# Loop over re   AY24 108
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AY24 109
IF(I<LEN(TYPE))#                       Select every card with i atom    AY24 110
DO J=1,I#                              Loop over all card atoms         AY24 111
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AY24 112
DO K=1,LEN(TYPE)#                      Loop over restraint's atoms      AY24 113
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AY24 114
IF(NINT(resptr:(RR,K))==IABS(APTR(J)))# Matching atoms                  AY24 115
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AY24 116
IF(APTR(J)<0)#                         Test symop                       AY24 117
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AY24 118
DO L=1,12;ifne:(resm:(RR,J,L),MAT(J,L))BREAK# Check symop               AY24 119
IF(L>12)BREAK#                         Match: same symop                AY24 120
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AY24 121
ELSE BREAK#                            No symop test                    AY24 122
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AY24 123
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AY24 124
IF(K>LEN(TYPE))BREAK#                  Not the desired restraint        AY24 125
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AY24 126
ELSE#                                  Select every card with ordered   AY24 127
DO J=1,LEN(TYPE)#                      Loop over card atom names        AY24 128
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AY24 129
IF(APTR(J)==0)NEXT#                    No check if all                  AY24 130
IF(NINT(resptr:(RR,J))==IABS(APTR(J)))# Test atoms                      AY24 131
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AY24 132
IF(APTR(J)<0)#                         Test symop                       AY24 133
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AY24 134
DO K=1,12;ifne:(resm:(RR,J,K),MAT(J,K))BREAK# Check symop               AY24 135
IF(K<=12)BREAK#                        No match                         AY24 136
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AY24 137
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AY24 138
ELSE BREAK#                            No matching                      AY24 139
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AY24 140
IF(J<=I)NEXT#                          Not the same restraint           AY24 141
IF(LINID==3)#                          Delete this restraint            AY24 142
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 AY24 143
RANGE=STOPR(4)-(RR+LEN(TYPE)*recl:+8)#                                  AY24 144
movereal:(QX,RR+LEN(TYPE)*recl:+8+1,QX,RR+1,RANGE,1)# Krunch list       AY24 145
STOPR(TYPE)=STOPR(TYPE)-(LEN(TYPE)*recl:+8)# Reset stop pointer         AY24 146
RR=RR-(LEN(TYPE)*recl:+8)#             Reset restraint pointer          AY24 147
DO J=TYPE+1,4#                         Update remaining pointers        AY24 148
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 AY24 149
MARKR(J)=STOPR(J-1);STOPR(J)=STOPR(J)-(LEN(TYPE)*recl:+8)#              AY24 150
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 AY24 151
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 AY24 152
ELSE#                                  Update                           AY24 153
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 AY24 154
ifnm:(BUFIN(I+2))resobs:(RR)=BUFIN(I+2)# Update restraint               AY24 155
ELSE iquit:(AY2408)#                   Missing obs val or esd           AY24 156
ifnm:(BUFIN(I+3))resd:(RR)=BUFIN(I+3)#                                  AY24 157
ELSE iquit:(AY2408)#                                                    AY24 158
ifnm:(BUFIN(I+4))resw:(RR)=BUFIN(I+4)#                                  AY24 159
ELSE resw:(RR)=1.0/resd:(RR)**2#       Default : weight = 1/sigma**2    AY24 160
BREAK#                                 Exit if restraint matched        AY24 161
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 AY24 162
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AY24 163
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AY24 164
ELSE RR=STOPR(TYPE)#                   Last of its type                 AY24 165
#                                                                       AY24 166
# INSERT NEW RESTRAINT                                                  AY24 167
# --------------------                                                  AY24 168
#                                                                       AY24 169
IF((LINID==2)&(RR>=STOPR(TYPE)))#      Insert restraint                 AY24 170
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 AY24 171
incrqx:(STOPR(4),STOPR(4)+LEN(TYPE)*recl:+8,AY2409)# Get mem            AY24 172
RANGE=STOPR(4)-RR#                                                      AY24 173
movereal:(QX,RR+1,QX,RR+LEN(TYPE)*recl:+8+1,RANGE,1)# Insertion         AY24 174
DO J=TYPE+1,4#                         Update remaining pointers        AY24 175
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 AY24 176
incrr:(MARKR(J),LEN(TYPE));incrr:(STOPR(J-1),LEN(TYPE))#                AY24 177
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 AY24 178
ifnm:(BUFIN(I+2))resobs:(RR)=BUFIN(I+2)# Update restraint               AY24 179
ELSE iquit:(AY2408)#                   Missing obs val or esd           AY24 180
ifnm:(BUFIN(I+3))resd:(RR)=BUFIN(I+3)#                                  AY24 181
ELSE iquit:(AY2408)#                                                    AY24 182
ifnm:(BUFIN(I+4))resw:(RR)=BUFIN(I+4)#                                  AY24 183
ELSE resw:(RR)=1.0/resd:(RR)**2#       Default : weight = 1/sigma**2    AY24 184
#                                                                       AY24 185
# STORE NAME & POSITION                                                 AY24 186
# ---------------------                                                 AY24 187
#                                                                       AY24 188
DO I=1,LEN(TYPE)#                      Loop over atoms                  AY24 189
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 AY24 190
resptr:(RR,I)=FLOAT(IABS(APTR(I)))#    Store atom pointer               AY24 191
DO J=1,12;resm:(RR,I,J)=MAT(I,J)#      Store matrix & vector            AY24 192
resop:(RR,I)=voidflg:#                 Unknown symop                    AY24 193
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 AY24 194
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 AY24 195
readline:(AY241,NAY241)#               Take next card                   AY24 196
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AY24 197
IF(LINID==1)#                          Symeq card                       AY24 198
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 AY24 199
writeline:(0,AY243,NAY243,3,3)#        Print warning                    AY24 200
WHILE(LINID !=0)readline:(AY243,NAY243)# Discard following input card   AY24 201
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 AY24 202
RETURN#                                                                 AY24 203
END#                                                                    AY24 204
#                                                                       AY24 205
systemheader:(AY25)#                                                    AY25   1
####################################################################### AY25   2
#                                                                     # AY25   3
#                               AY25                                  # AY25   4
#                                                                     # AY25   5
####################################################################### AY25   6
SUBROUTINE AY25#                                                        AY25   7
#                                                                       AY25   8
include:(AACOMN)#                                                       AY25   9
include:(AYCOMN)#                                                       AY25  10
#                                                                       AY25  11
INTEGER AA#                            Atom pointer                     AY25  12
REAL C0,C1,C2#                         Used to compute dihedral angle   AY25  13
INTEGER CELL#                          Used to pack cell                AY25  14
INTEGER I,J,K#                         Loop indices                     AY25  15
INTEGER NRES#                          Restraint counter                AY25  16
INTEGER RR#                            Restraint pointer                AY25  17
INTEGER TYPE#                          Type of the restraint            AY25  18
REAL X(4,3)#                           Coordinates of atoms             AY25  19
REAL D(3,3)#                           Distances between atoms          AY25  20
REAL A(2,3)#                           Cross-product between atoms      AY25  21
#                                                                       AY25  22
intdata:(LEN,[2,3,4])#                                                  AY25  23
chardata:(AY251,[" Restraint type xxxxxxxxxxxxx"])#                     AY25  24
chardata:(AY252,DISTANCE     BOND ANGLE   TORSION ANGLE)#               AY25  25
chardata:(AY253,[" Atom                        Starting  Symetry $#     AY25  26
operation                  Translation      Restraint"])#               AY25  27
chardata:(AY255,[" Observed value xx.xxxx   Calculated value $#         AY25  28
xx.xxxx     E.s.d. xx.xxxx   Weight x.xxxxx+xx"])#                      AY25  29
chardata:(AY254,[" xxxxx restraints of type xxxxxxxxxxxxx have $#       AY25  30
been loaded"])#                                                         AY25  31
realdata:(FMT,[370852.,480852.,580852.,680852.,850852.,1000852.])#      AY25  32
realdata:(FORM,[230742.,500742.,690742.,891051.])#                      AY25  33
datastuff:#                                                             AY25  34
#                                                                       AY25  35
DO TYPE=1,3#                           Loop over restraint type         AY25  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AY25  37
IF((MARKR(TYPE)<STOPR(TYPE))&(LIST>0))# Print header                    AY25  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AY25  39
movechar:(AY252,13*(TYPE-1)+1,AY251,17,13,0)# Copy type                 AY25  40
writeline:(3,AY251,NAY251,3,3)#        Print title                      AY25  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AY25  42
NRES=0#                                Reset restraint counter          AY25  43
FOR(RR=MARKR(TYPE);RR<STOPR(TYPE);incrr:(RR,LEN(TYPE)))# Loop over re   AY25  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AY25  45
#                                                                       AY25  46
# COMPUTE DISTANCES AND NORMALS TO 3-ATOMS PLANES                       AY25  47
# -----------------------------------------------                       AY25  48
#                                                                       AY25  49
NRES=NRES+1#                           Increment restraint counter      AY25  50
DO K=1,LEN(TYPE)#                      Loop over atoms                  AY25  51
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AY25  52
IF((K==1)&(NRES<=LIST))writeline:(1,AY253,NAY253,3,3)# Print title li   AY25  53
AA=NINT(resptr:(RR,K))#                Get atom pointer                 AY25  54
IF(NRES<=LIST)movertoc:(atomn:(AA),1,CHROT,2,lena:,0)# Move atom name   AY25  55
DO I=1,3#                              Loop over coordinates            AY25  56
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AY25  57
X(K,I)=resvec:(RR,K,I)#                Translation part                 AY25  58
DO J=1,3#                              Matrix multiplication            AY25  59
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AY25  60
X(K,I)=X(K,I)+resm:(RR,K,I,J)*atompos:(AA+J)#                           AY25  61
IF(NRES<=LIST)ncodefld:(resm:(RR,K,I,J),1,CHROT,FMT(J+1),1)# Encode v   AY25  62
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AY25  63
IF(NRES<=LIST)#                        Is this restraint to be listed   AY25  64
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AY25  65
ncodefld:(atompos:(AA+I),1,CHROT,FMT(1),1)# Encode starting values      AY25  66
ncodefld:(resvec:(RR,K,I),1,CHROT,FMT(5),1)# Encode translation         AY25  67
ncodefld:(X(K,I),1,CHROT,FMT(6),1)#    Encode resulting coord           AY25  68
writeline:(0,AY253,NAY253,1,3)#        Print line                       AY25  69
movechar:(BLANK,1,CHROT,2,lena:,1)#    Clear atom name                  AY25  70
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AY25  71
IF(X(K,I)>=0.0)CELL=5+INT(X(K,I))#     Store cell nb                    AY25  72
ELSE CELL=4-INT(-X(K,I))#                                               AY25  73
intpak:(CELL,rescel:(RR,K),10*(I-1),10)# Encode cell nb                 AY25  74
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AY25  75
IF(K==1)NEXT#                          Exit first pass                  AY25  76
DO J=1,3;D(K-1,J)=X(K,J)-X(K-1,J)#     Store distance                   AY25  77
IF(K==2)NEXT#                          Exit second pass                 AY25  78
A(K-2,1)=D(K-2,2)*D(K-1,3)-D(K-2,3)*D(K-1,2)# Normal to planes          AY25  79
A(K-2,2)=D(K-2,3)*D(K-1,1)-D(K-2,1)*D(K-1,3)#                           AY25  80
A(K-2,3)=D(K-2,1)*D(K-1,2)-D(K-2,2)*D(K-1,1)#                           AY25  81
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AY25  82
#                                                                       AY25  83
# COMPUTE RESTRAINT                                                     AY25  84
# -----------------                                                     AY25  85
#                                                                       AY25  86
IF(TYPE==1)#                           Distance                         AY25  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AY25  88
rescal:(RR)=0.0#                       Clear distance                   AY25  89
DO J=1,3;DO K=1,3;rescal:(RR)=rescal:(RR)+D(1,J)*MT(J,K)*D(1,K)# Norm   AY25  90
rescal:(RR)=SQRT(AMAX1(0.0,rescal:(RR)))# Get distance                  AY25  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AY25  92
IF(TYPE==2)#                           Bond angle                       AY25  93
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AY25  94
X(1,1)=0.0;X(1,2)=0.0;X(1,3)=0.0#      Clear norms & scalar product     AY25  95
DO J=1,3;DO K=1,3#                     Sums                             AY25  96
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AY25  97
X(1,1)=X(1,1)+D(1,J)*MT(J,K)*D(1,K)#                                    AY25  98
X(1,2)=X(1,2)+D(2,J)*MT(J,K)*D(2,K)#                                    AY25  99
X(1,3)=X(1,3)+D(1,J)*MT(J,K)*D(2,K)#                                    AY25 100
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AY25 101
rescal:(RR)=SQRT(AMAX1(0.0,X(1,1)*X(1,2)))# Product of norms            AY25 102
ifeq:(rescal:(RR),0.0)rescal:(RR)=voidflg:# Not defined                 AY25 103
ELSE rescal:(RR)=ACOS(-X(1,3)/rescal:(RR))*180.0/pi:# Compute angle     AY25 104
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AY25 105
IF(TYPE==3)#                           Dihedral angle                   AY25 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AY25 107
C0=0.0;C1=0.0;C2=0.0#                  Clear cos & sin of angle         AY25 108
DO I=1,3#                              Dot products                     AY25 109
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AY25 110
DO J=1,3#                                                               AY25 111
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AY25 112
C1=C1+A(1,I)*MTINV(I,J)*A(2,J)#        Dot between normals              AY25 113
C0=C0+D(2,I)*MT(I,J)*D(2,J)#           Norm of 2nd vector               AY25 114
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AY25 115
C2=C2+D(3,I)*A(1,I)#                   Volume (triple product)          AY25 116
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AY25 117
C2=C2*SQRT(C0)/VOL#                    Same denom as cos                AY25 118
rescal:(RR)=ATAN2(C2,C1)*180.0/pi:#    Angle in degrees                 AY25 119
IF(rescal:(RR)<0.0)rescal:(RR)=rescal:(RR)+360.0# Always positive       AY25 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AY25 121
IF(NRES<=LIST)#                        Is this restraint to be listed   AY25 122
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AY25 123
ncodefld:(resobs:(RR),1,AY255,FORM(1),1)# Encode observed value         AY25 124
ncodefld:(rescal:(RR),1,AY255,FORM(2),1)# Encode calc value             AY25 125
ncodefld:(resd:(RR),1,AY255,FORM(3),1)# Encode esd                      AY25 126
ncodefld:(resw:(RR),1,AY255,FORM(4),1)# Encode weight                   AY25 127
writeline:(0,AY255,NAY255,3,3)#        Print line                       AY25 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AY25 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AY25 130
movechar:(AY252,13*(TYPE-1)+1,AY254,27,13,0)# Copy type                 AY25 131
ncodefld:(FLOAT(NRES),1,AY254,60513.,1)# Enocde number                  AY25 132
writeline:(2,AY254,NAY254,3,3)#        Print line                       AY25 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AY25 134
RETURN#                                                                 AY25 135
END#                                                                    AY25 136
#                                                                       AY25 137
systemheader:(AY26)#                                                    AY26   1
####################################################################### AY26   2
#                                                                     # AY26   3
#                               AY26                                  # AY26   4
#                                                                     # AY26   5
####################################################################### AY26   6
SUBROUTINE AY26#                                                        AY26   7
#                                                                       AY26   8
include:(AACOMN)#                                                       AY26   9
include:(AYCOMN)#                                                       AY26  10
#                                                                       AY26  11
INTEGER AA#                            Atom pointer                     AY26  12
INTEGER CELL#                          Used to pack cell                AY26  13
INTEGER I,J,K,II,JJ#                   Loop indices                     AY26  14
INTEGER NRES#                          Restraint counter                AY26  15
INTEGER RR#                            Restraint pointer                AY26  16
INTEGER DFT#                           Atom displ fact type             AY26  17
REAL X(2,3)#                           Coordinates of atoms             AY26  18
REAL U(2)#                             Mean square displ                AY26  19
REAL RCELL(3)#                         Reciprocal cell length           AY26  20
REAL TENU(3,3,3),TENB(3,3,3)#          Displ tensors                    AY26  21
REAL Y#                                Temp var                         AY26  22
REAL D(4)#                             Distances between atoms & norm   AY26  23
#                                                                       AY26  24
intdata:(LEN,[2])#                                                      AY26  25
chardata:(AY261,[" Restraint type RIGID BOND   "])#                     AY26  26
chardata:(AY263,[" Atom                        Starting  Symetry $#     AY26  27
operation                  Translation      Restraint"])#               AY26  28
chardata:(AY264,[" xxxxx restraints of type RIGID BOND    have $#       AY26  29
been loaded"])#                                                         AY26  30
chardata:(AY265,[" Observed value xx.xxxx   Calculated value $#         AY26  31
xx.xxxx     E.s.d. xx.xxxx   Weight x.xxxxx+xx"])#                      AY26  32
realdata:(FMT,[370852.,480852.,580852.,680852.,850852.,1000852.])#      AY26  33
realdata:(FORM,[230742.,500742.,690742.,891051.])#                      AY26  34
realdata:(FMU,[170852.,270852.,370852.,800852.,900852.,1000852.])#      AY26  35
datastuff:#                                                             AY26  36
#                                                                       AY26  37
DO K=1,3;RCELL(K)=SQRT(MTINV(K,K))#    Reciprocal cell length           AY26  38
IF(LIST>0)writeline:(3,AY261,NAY261,3,3)# Print title                   AY26  39
NRES=0#                                Clear restraint counter          AY26  40
FOR(RR=MARKR(4);RR<STOPR(4);incrr:(RR,LEN))# Loop over restraints       AY26  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AY26  42
#                                                                       AY26  43
# COMPUTE DISTANCES AND NORMALS TO 3-ATOMS PLANES                       AY26  44
# -----------------------------------------------                       AY26  45
#                                                                       AY26  46
NRES=NRES+1#                           Increment restraint counter      AY26  47
DO K=1,LEN#                            Loop over atoms                  AY26  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AY26  49
IF((K==1)&(NRES<=LIST))writeline:(1,AY263,NAY263,3,3)# Print title li   AY26  50
AA=NINT(resptr:(RR,K))#                Get atom pointer                 AY26  51
DFT=NINT(atomdft:(AA))#                Get displ fact type              AY26  52
IF(NRES<=LIST)movertoc:(atomn:(AA),1,CHROT,2,lena:,0)# Move atom name   AY26  53
DO I=1,3#                              Loop over coordinates            AY26  54
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AY26  55
X(K,I)=resvec:(RR,K,I)#                Translation part                 AY26  56
DO J=1,3#                              Matrix multiplication            AY26  57
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AY26  58
X(K,I)=X(K,I)+resm:(RR,K,I,J)*atompos:(AA+J)#                           AY26  59
IF(NRES<=LIST)ncodefld:(resm:(RR,K,I,J),1,CHROT,FMT(J+1),1)# Encode v   AY26  60
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AY26  61
IF(NRES<=LIST)#                        Is this restraint to be listed   AY26  62
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AY26  63
ncodefld:(atompos:(AA+I),1,CHROT,FMT(1),1)# Encode starting values      AY26  64
ncodefld:(resvec:(RR,K,I),1,CHROT,FMT(5),1)# Encode translation         AY26  65
ncodefld:(X(K,I),1,CHROT,FMT(6),1)#    Encode resulting coord           AY26  66
writeline:(0,AY263,NAY263,1,3)#        Print line                       AY26  67
movechar:(BLANK,1,CHROT,2,lena:,1)#    Clear atom name                  AY26  68
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AY26  69
IF(X(K,I)>=0.0)CELL=5+INT(X(K,I))#     Store cell nb                    AY26  70
ELSE CELL=4-INT(-X(K,I))#                                               AY26  71
intpak:(CELL,rescel:(RR,K),10*(I-1),10)# Encode cell nb                 AY26  72
TENU(K,I,I)=atomani:(AA+I)#            Store diag terms                 AY26  73
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AY26  74
IF(DFT==2)#                            Aniso                            AY26  75
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AY26  76
U(K)=0.0#                              Clear depl                       AY26  77
TENU(K,1,2)=atomu12:(AA);TENU(K,2,1)=TENU(K,1,2)#                       AY26  78
TENU(K,1,3)=atomu13:(AA);TENU(K,3,1)=TENU(K,1,3)#                       AY26  79
TENU(K,2,3)=atomu23:(AA);TENU(K,3,2)=TENU(K,2,3)#                       AY26  80
DO I=1,3;DO J=1,3#                     To betas                         AY26  81
TENB(K,I,J)=TENU(K,I,J)*RCELL(I)*RCELL(J)*pisq2:#                       AY26  82
DO I=1,3;DO J=1,3#                     Transform betas                  AY26  83
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AY26  84
TENB(3,I,J)=0.0#                       Clear component                  AY26  85
DO II=1,3;DO JJ=1,3#                   Multiplication                   AY26  86
TENB(3,I,J)=TENB(3,I,J)+$#                                              AY26  87
resm:(RR,K,I,II)*resm:(RR,K,J,JJ)*TENB(K,II,JJ)#                        AY26  88
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AY26  89
DO I=1,3;DO J=1,3#                     Return to us                     AY26  90
TENU(3,I,J)=TENB(3,I,J)/(RCELL(I)*RCELL(J)*pisq2:)#                     AY26  91
IF(NRES<=LIST)#                        Is this restraint to be listed   AY26  92
DO I=1,3#                              Print tensors                    AY26  93
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AY26  94
DO J=1,3#                              One line                         AY26  95
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AY26  96
ncodefld:(TENU(K,I,J)*100.0,1,CHROT,FMU(J),1)# Encode 100uij            AY26  97
ncodefld:(TENU(3,I,J)*100.0,1,CHROT,FMU(J+3),1)# Encode 100uij          AY26  98
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AY26  99
writeline:(0,AY263,NAY263,1,3)#        Print line                       AY26 100
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AY26 101
DO I=1,3;DO J=1,3#                     Reciprocal of tensor             AY26 102
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AY26 103
TENB(K,I,J)=0.0#                       Clear component                  AY26 104
DO II=1,3;DO JJ=1,3#                   Multiplication                   AY26 105
TENB(K,I,J)=TENB(K,I,J)+MT(I,II)*MT(J,JJ)*TENB(3,II,JJ)#                AY26 106
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AY26 107
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AY26 108
ELSE#                                                                   AY26 109
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AY26 110
U(K)=atomiso:(AA)#                                                      AY26 111
DO I=1,3;DO J=1,3;TENB(K,I,J)=0.0#                                      AY26 112
IF(NRES<=LIST)#                        Is this restraint to be listed   AY26 113
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AY26 114
ncodefld:(100.0*U(K),1,CHROT,FMT(6),1)# Encode 100u                     AY26 115
writeline:(0,AY263,NAY263,1,3)#        Print line                       AY26 116
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AY26 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AY26 118
IF(K==1)NEXT#                          Exit first pass                  AY26 119
DO J=1,3;D(J)=X(K,J)-X(K-1,J)#         Store distance                   AY26 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AY26 121
#                                                                       AY26 122
# COMPUTE RESTRAINT                                                     AY26 123
# -----------------                                                     AY26 124
#                                                                       AY26 125
D(4)=0.0#                              Clear norm                       AY26 126
DO I=1,3;DO J=1,3;D(4)=D(4)+D(I)*MT(I,J)*D(J)#                          AY26 127
DO K=1,2#                              Loop over both atoms             AY26 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AY26 129
Y=0.0#                                 Clear                            AY26 130
DO I=1,3;DO J=1,3;Y=Y+D(I)*TENB(K,I,J)*D(J)#                            AY26 131
U(K)=U(K)+Y/(pisq2:*D(4))#                                              AY26 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AY26 133
rescal:(RR)=U(2)-U(1)#                 Calculated rigid bond            AY26 134
IF(NRES<=LIST)#                        Is this restraint to be listed   AY26 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AY26 136
ncodefld:(resobs:(RR),1,AY265,FORM(1),1)# Encode obs                    AY26 137
ncodefld:(rescal:(RR),1,AY265,FORM(2),1)# Encode calc                   AY26 138
ncodefld:(resd:(RR),1,AY265,FORM(3),1)# Encode esd                      AY26 139
ncodefld:(resw:(RR),1,AY265,FORM(4),1)# Encode weight                   AY26 140
writeline:(0,AY265,NAY265,3,3)#        Print line                       AY26 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AY26 142
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AY26 143
ncodefld:(FLOAT(NRES),1,AY264,60513.,1)# Enocde number                  AY26 144
writeline:(2,AY264,NAY264,3,3)#        Print line                       AY26 145
RETURN#                                                                 AY26 146
END#                                                                    AY26 147
#                                                                       AY26 148
systemheader:(AY30)#                                                    AY30   1
####################################################################### AY30   2
#                                                                     # AY30   3
#                               AY30                                  # AY30   4
#                                                                     # AY30   5
####################################################################### AY30   6
SUBROUTINE AY30#                                                        AY30   7
#                                                                       AY30   8
include:(AACOMN)#                                                       AY30   9
include:(AYCOMN)#                                                       AY30  10
#                                                                       AY30  11
CALL AY32#                             Write restraints lr & print re   AY30  12
RETURN#                                                                 AY30  13
END#                                                                    AY30  14
#                                                                       AY30  15
systemheader:(AY32)#                                                    AY32   1
####################################################################### AY32   2
#                                                                     # AY32   3
#                               AY32                                  # AY32   4
#                                                                     # AY32   5
####################################################################### AY32   6
SUBROUTINE AY32#                                                        AY32   7
#                                                                       AY32   8
include:(AACOMN)#                                                       AY32   9
include:(AYCOMN)#                                                       AY32  10
#                                                                       AY32  11
INTEGER AA#                            Atom pointer                     AY32  12
INTEGER I,J,K#                         Loop index                       AY32  13
INTEGER RR#                            Restraint pointer                AY32  14
INTEGER TYPE#                          Type of the restraint            AY32  15
#                                                                       AY32  16
intdata:(LEN,[2,3,4,2])#                                                AY32  17
intdata:(LR,[40,42,43,44])#    ## lrbond: lrangl: lrdihe: lrrigi:       AY32  18
datastuff:#                                                             AY32  19
#                                                                       AY32  20
DO TYPE=1,4#                           Loop over type                   AY32  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AY32  22
IF(MARKR(TYPE)>=STOPR(TYPE))NEXT#      Exit if none of this type        AY32  23
#                                                                       AY32  24
# CREATE DIRECTORY                                                      AY32  25
# ----------------                                                      AY32  26
#                                                                       AY32  27
PSIZO=0#                               Clear output packet length       AY32  28
DO K=1,LEN(TYPE)#                      Loop over atoms                  AY32  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AY32  30
DO J=1,mxwd24c:#                       Loop over atom name              AY32  31
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AY32  32
PSIZO=PSIZO+1;IWANT(PSIZO)=10*K+1#                                      AY32  33
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AY32  34
DO J=2,6#                              Loop over coord & symop & code   AY32  35
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AY32  36
PSIZO=PSIZO+1;IWANT(PSIZO)=10*K+J#                                      AY32  37
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AY32  38
DO J=1,12#                             Loop over matrix & vector        AY32  39
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AY32  40
PSIZO=PSIZO+1;IWANT(PSIZO)=100*K+J#                                     AY32  41
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AY32  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AY32  43
DO J=1,5#                              Loop over calc, esd(c), obs, e   AY32  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AY32  45
PSIZO=PSIZO+1;IWANT(PSIZO)=90+J#                                        AY32  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AY32  47
writepkt:(2,LR(TYPE),PSIZO,IPO)#       Write directory packet           AY32  48
DO I=1,PSIZO;QX(IPO+I)=FLOAT(IWANT(I))# Put directory numbers           AY32  49
#                                                                       AY32  50
# STORE AND PRINT RESTRAINTS                                            AY32  51
# --------------------------                                            AY32  52
#                                                                       AY32  53
FOR(RR=MARKR(TYPE);RR<STOPR(TYPE);incrr:(RR,LEN(TYPE)))# Loop over on   AY32  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AY32  55
writepkt:(2,LR(TYPE),PSIZO,IPO)#       Set output pointer               AY32  56
I=0#                                   Offset in bdf output buffer      AY32  57
DO K=1,LEN(TYPE)#                                                       AY32  58
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AY32  59
AA=NINT(resptr:(RR,K))#                Get atom pointer                 AY32  60
movereal:(atomn:(AA),1,QX(IPO+I+1),1,mxwd24c:,0)# Copy name to bdf      AY32  61
I=I+mxwd24c:#                          Increment offset                 AY32  62
DO J=1,3;QX(IPO+I+J)=atompos:(AA+J)#   Copy pos to bdf                  AY32  63
I=I+3#                                 Increment offset                 AY32  64
QX(IPO+I+1)=resop:(RR,K);I=I+1#        Save matrix nb                   AY32  65
QX(IPO+I+1)=rescel:(RR,K);I=I+1#       Save cell nb                     AY32  66
movereal:(resm:(RR,K,1),1,QX,IPO+I+1,12,0)# Copy matrix & vector        AY32  67
I=I+12#                                Increment offset                 AY32  68
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AY32  69
QX(IPO+I+3)=resobs:(RR)#                                                AY32  70
QX(IPO+I+1)=rescal:(RR)#                                                AY32  71
QX(IPO+I+2)=voidflg:#                                                   AY32  72
QX(IPO+I+4)=resd:(RR)#                                                  AY32  73
QX(IPO+I+5)=resw:(RR)#                                                  AY32  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AY32  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AY32  76
copyfile:(1,2,LR(4)+1,endrecord:)#     Copy rest of the file            AY32  77
RETURN#                                                                 AY32  78
END#                                                                    AY32  79
#                                                                       AY32  80
pmacro:([no:])#                        Purge macro                      AY32  81
