systemheader:(BF    )#                                                  BF     1
####################################################################### BF     2
#                                                                       BF     3
#                           *** BFOURR ***                            # BF     4
#                                                                     # BF     5
#    THE BFOURR PROGRAM PREPARES A BDF WHICH CONTAINS IN RECORD       # BF     6
#     LRREFL: COEFFICIENTS AND PHASES NECESSARY FOR CALCULATING A     # BF     7
#     FOURIER.  COEFFICIENTS FOR ISOMORPHOUS FOURIER, COMBINED        # BF     8
#     FOURIER(ISOMORPH AND ANOMOL), BIJVOET DIFFERENCE MAY BE FORMED. # BF     9
#                                                                     # BF    10
####################################################################### BF    11
#                                                                       BF    12
include:(XMACRO)#                                                       BF    13
#                                                                       BF    14
macro:(rejfaz:,[$#                     Macro to decide if a reflec.     BF    15
IPTR = IPT + $1#                       Should be rejected because       BF    16
ifvo:(QX(IPTR))$(#                     Of missing phase data            BF    17
NREJPH = NREJPH + 1.#                  Count rejections                 BF    18
NEXT $)])#                                                              BF    19
macro:(bigf:,1000000.)#                Largest magnitude of f allow     BF    20
macro:(chtotl:,[arith:(12,*,maxset:)])# Max characters in dset array    BF    21
macro:(fnmb:,1304.)#                   Lrrefl: idnum for frel           BF    22
#                                                                       BF    23
# INDICES TO INPUT LRREFL: WANT LIST AND OFFSET ARRAYS                  BF    24
# ** MUST READ ALL POSSIBLE FORMS OF F AND SIG(F) **                    BF    25
macro:(indxwt:,4)#                     Weight (centroid, etc.)          BF    26
macro:(indxf11:,5)#                    F(+) data set one                BF    27
macro:(indxf12:,6)#                    F(-) data set one                BF    28
macro:(indxf21:,7)#                    F(+) data set two                BF    29
macro:(indxf22:,8)#                    F(-) data set two                BF    30
macro:(indxf11s:,9)#                   F(+)**2  data set one            BF    31
macro:(indxf12s:,10)#                  F(-)**2  data set one            BF    32
macro:(indxf21s:,11)#                  F(+)**2  data set two            BF    33
macro:(indxf22s:,12)#                  F(-)**2  data set two            BF    34
macro:(indxcos:,13)#                   Cos of phase angle               BF    35
macro:(indxsin:,14)#                   Sin of phase angle               BF    36
macro:(indxsg11:,15)#                  Sigma((f+)) data set one         BF    37
macro:(indxsg12:,16)#                  Sigma((f-)) data set one         BF    38
macro:(indxsg21:,17)#                  Sigma((f+)) data set two         BF    39
macro:(indxsg22:,18)#                  Sigma((f-)) data set two         BF    40
macro:(indxss11:,19)#                  Sigma((f+)**2) data set one      BF    41
macro:(indxss12:,20)#                  Sigma((f-)**2) data set one      BF    42
macro:(indxss21:,21)#                  Sigma((f+)**2) data set two      BF    43
macro:(indxss22:,22)#                  Sigma((f-)**2) data set two      BF    44
macro:(indxfc:,23)#                    F(calc)                          BF    45
macro:(indxfaz:,24)#                   Phase angle (cycles)             BF    46
#                                                                       BF    47
macro:(lphazwd:,28)#                   No. chars in phase descripto     BF    48
macro:(maxset:,20)#                    Maximum no. data sets on bdf     BF    49
macro:(maxwant:,24)#                   Max. number of required          BF    50
#                                         Lrrefl: items.                BF    51
macro:(nmbfp:,304)#                    F(+) catalog no.                 BF    52
macro:(nmbfm:,314)#                    F(-) catalog no.                 BF    53
macro:(nmbsigm:,313)#                  Sigma(f(+)**2) catalog no.       BF    54
macro:(nmbsigp:,303)#                  Sigma(f(+)**2) catalog no.       BF    55
macro:(phnmbcos:,1801.)#               Idnums for cos(phase)            BF    56
macro:(phnmbsin:, 1802.)#              Idnums for sin(phase)            BF    57
macro:(phnmbfaz:,1700.)#               Idnums for phase (cycles)        BF    58
macro:(phnmbfc:, 1800.)#               Idnums for fc                    BF    59
#                                                                       BF    60
extrude:(BFCOMN)#                                                       BF    61
COMMON/COMIBF/ BIGIH, ENDSYM,$#                                         BF    62
FAZNUM, FAZYN, FTYPE, FSQD,   FSQP, LMOD,$#                             BF    63
NSET1,  NSET2, PHNMBR,  SMALIH, STARTS,$##                              BF    64
TOTCHR, WTPTR#                                                          BF    65
#                                                                       BF    66
INTEGER BIGIH(3)#                      Maximum hkl limits               BF    67
INTEGER ENDSYM#                        Last indx in symops 'array'      BF    68
INTEGER FAZNUM#                        Data set number for source o     BF    69
#                                         Fc phases.                    BF    70
INTEGER FAZYN#                         Yes: if phase line used          BF    71
INTEGER FSQD#                          Yes: if deriv f**2 in dbf        BF    72
INTEGER FSQP#                          Yes: if parent f**2 in dbf       BF    73
INTEGER FTYPE#                         1 /2 /3  for                     BF    74
#                                         Bijvoet/isomor./combined      BF    75
INTEGER LMOD#                          Print every lmod reflection      BF    76
INTEGER NSET1#                         Data set key for 1st data se     BF    77
INTEGER NSET2#                         Data set key for 2nd data se     BF    78
INTEGER PHNMBR(4)#                     Lrrefl: idnum for phase          BF    79
INTEGER SMALIH(3)#                     Minimum hkl limits               BF    80
INTEGER STARTS#                        Start indx of symops 'array'     BF    81
INTEGER TOTCHR#                        Number of characters in all      BF    82
#                                         The data set names on the bdf BF    83
INTEGER WTPTR#                         Pointer to weight (centroid,     BF    84
#                                         Etc.).                        BF    85
#                                                                       BF    86
COMMON/COMFBF/ BIGCO, BIGF1, BIGF2, BIGST,$#                            BF    87
COEFAV, COEFMN, COEFMX,$#                                               BF    88
DBBDF,DB1,   DB2   ,KBDF  , K1   ,K2    ,$#                             BF    89
MATTB1,MATTB2,MATTK1,MATTK2,MBBDF,MKBDF,$#                              BF    90
NREJCO,NREJF1,NREJF2, NREJH,NREJPH,$#                                   BF    91
NREJSC,NREJSF,NREJST,NREJV1,NREJV2, NRFIN,$#                            BF    92
NRFOUT, SCALE,SIGKCO, SIGKF, SITOL,SMALCO,$#                            BF    93
SMALF1,SMALF2,SMALST, WT1, WT2#                                         BF    94
#                                                                       BF    95
REAL    BIGCO#                         Maximum coefficient limit        BF    96
REAL    BIGF1#                         Maximum limit on f for data      BF    97
#                                         Set 1.                        BF    98
REAL    BIGF2#                         Maximum limit on f for data      BF    99
#                                         Set 2.                        BF   100
REAL    BIGST#                         Maximum sitol limit              BF   101
REAL    COEFAV#                        Average coefficient value        BF   102
REAL    COEFMN#                        Minimum coefficient value        BF   103
REAL    COEFMX#                        Maximum coefficient value        BF   104
REAL    DBBDF(maxset:)#                Delta-b from bdf                 BF   105
REAL    DB1#                           Delta-b for data set one         BF   106
REAL    DB2#                           Delta-b for data set two         BF   107
REAL    KBDF(maxset:)#                 Relative k from bdf              BF   108
REAL    K1#                            Scale for data set one           BF   109
REAL    K2#                            Scale for data set two           BF   110
REAL    MATTB1#                        Matthew b for data set 1         BF   111
REAL    MATTB2#                        Matthew b for data set 2         BF   112
REAL    MATTK1#                        Matthew ratio for data set 1     BF   113
REAL    MATTK2#                        Matthew ratio for data set 2     BF   114
REAL    MBBDF(maxset:)#                Matthew b from bdf               BF   115
REAL    MKBDF(maxset:)#                Matthew ratio from bdf           BF   116
REAL    NREJCO#                        No. rejected refls.,             BF   117
#                                                       Coeff. range    BF   118
REAL    NREJF1#                        F-range, set 1                   BF   119
REAL    NREJF2#                        F-range, set 2                   BF   120
REAL    NREJH#                         H,k,l range                      BF   121
REAL    NREJPH#                        Void phase                       BF   122
REAL    NREJSC#                        K*sigma, coeff.                  BF   123
REAL    NREJSF#                        K*sigma, fobs                    BF   124
REAL    NREJST#                        Sitol range                      BF   125
REAL    NREJV1#                        F void, set 1                    BF   126
REAL    NREJV2#                        F void, set 2                    BF   127
REAL    NRFIN#                         No. refls. on input bdf          BF   128
REAL    NRFOUT#                        No. refls. on output bdf         BF   129
REAL    SCALE#                         Overall scale for coefficien     BF   130
REAL    SIGKCO#                        K in k*sigma(coef) limit         BF   131
REAL    SIGKF#                         K in k*sigma(f) limit            BF   132
REAL    SITOL#                         Sine(theta)/lambda               BF   133
REAL    SMALCO#                        Minimum coefficient limit        BF   134
REAL    SMALF1#                        Minimum limit on f-rel for       BF   135
#                                         Data set 1.                   BF   136
REAL    SMALF2#                        Minimum limit on f-rel for       BF   137
#                                         Data set 2.                   BF   138
REAL    SMALST#                        Minimum sitol limit              BF   139
REAL    WT1#                           Weight based on reliability      BF   140
#                                         Of anomalous data set 1       BF   141
REAL    WT2#                           Weight based on reliability      BF   142
#                                         Of anomalous data set 2       BF   143
#                                                                       BF   144
COMMON/COMCBF/DSETID, IDFAZ,IDSET1,IDSET2,  IDWT,PHAZWD#                BF   145
#                                                                       BF   146
string:(DSETID,chtotl:)#               Data set id's from bdf           BF   147
string:(IDFAZ,12)#                     Data set id for fc phase         BF   148
#                                         Source.                       BF   149
string:(IDSET1,12)#                    Id for data set one              BF   150
string:(IDSET2,12)#                    Id for data set two              BF   151
string:(IDWT,12)#                      Weight identifier word           BF   152
string:(PHAZWD,lphazwd:)#              Phase description words          BF   153
endext:#                                                                BF   154
#                                                                       BF   155
systemheader:(BF00)#                                                    BF00   1
####################################################################### BF00   2
#                                                                     # BF00   3
#                              BF00                                   # BF00   4
#                                                                     # BF00   5
####################################################################### BF00   6
SUBROUTINE BF00#                                                        BF00   7
#                                                                       BF00   8
#   SUBROUTINE          FUNCTION                                        BF00   9
#       BF00    ROOT SEGMENT, CALLS BF01,BF02,BF03,BF04                 BF00  10
#       BF01    PROCESS BDF LOGICAL RECORDS UP TO LRREFL:               BF00  11
#       BF02    READ ALL LINE INPUT                                     BF00  12
#       BF03    CALL COEFFICIENT ROUTINES (ACCORDING TO FTYPE)          BF00  13
#       BF04    SUMMARIZE, CLOSE BDF                                    BF00  14
#       BF21    PROCESS COEFF LINE                                      BF00  15
#       BF23    PROCESS PHASE LINE                                      BF00  16
#       BF24    PROCESS KDB LINE                                        BF00  17
#       BF25    PROCESS SCALE LINE                                      BF00  18
#       BF26    PROCESS WEIGHT LINE                                     BF00  19
#       BF27    PROCESS LIMHKL, LIMSTL, LIMD, LIMCO, AND LIMF  LINES    BF00  20
#       BF41    CALCULATE  BIJVOET-DIFFERENCE COEFFICIENTS              BF00  21
#       BF42    CALCULATE F(1)-F(2) DIFFERENCE COEFFICIENTS             BF00  22
#       BF51    GET K AND DB                                            BF00  23
#       BF52    APPLY SITOL AND HKL LIMITS                              BF00  24
#       BF53    GET MEAN F                                              BF00  25
#       BF54    LIST REFLECTION COUNTS                                  BF00  26
#       BF56    LIST REFLECTIONS TO OUTPUT LOG                          BF00  27
#       BF99    ADHOC...PHASER INPUT EXAMPLE                            BF00  28
#                                                                       BF00  29
# TO ADD ADDITIONAL FUNCTIONS, MAKE PROVISIONS FOR SPECIFYING THEM      BF00  30
#  ON THE LINE INPUT EITHER IN ROUTINE BF21 OR IN A NEW ROUTINE,        BF00  31
#  BF22.  IN EITHER CASE, SET THE VARIABLE FTYPE ACCORDINGLY.           BF00  32
#  CHANGE ROUTINE BF03 TO BRANCH APPROPRIATELY ON FTYPE.  THE           BF00  33
#  NEW COEFFICIENT CODE CAN BE INSTALLED IN BF41 IF IT DEPENDS ONLY     BF00  34
#  ON A SINGLE DATA SET, OR IN BF42 IF IT DEPENDS ON TWO DATA SETS.     BF00  35
#  OR,IN THE INTEREST OF MODULARITY, THE CODE COULD BE PUT IN A         BF00  36
#  NEW ROUTINE BF4X.                                                    BF00  37
#                                                                       BF00  38
include:(AACOMN)#                                                       BF00  39
include:(BFCOMN)#                                                       BF00  40
#                                                                       BF00  41
CALL BF01#                             Input bdf to lrrefl:             BF00  42
CALL BF02#                             Read line input                  BF00  43
CALL BF03#                             Make coefficients                BF00  44
CALL BF04#                             Summary                          BF00  45
#                                                                       BF00  46
RETURN#                                                                 BF00  47
END#                                                                    BF00  48
systemheader:(BF01)#                   Process records up to lrrefl     BF01   1
####################################################################### BF01   2
#                                                                     # BF01   3
#                              BF01                                   # BF01   4
#                                                                     # BF01   5
####################################################################### BF01   6
SUBROUTINE BF01#                                                        BF01   7
include:(AACOMN)#                                                       BF01   8
include:(BFCOMN)#                                                       BF01   9
#                                                                       BF01  10
INTEGER I,J,K#                         An index                         BF01  11
INTEGER IPT#                           Pointer to qx for bdf input      BF01  12
INTEGER KDATA#                         Yes: if k/delta b in bdf         BF01  13
INTEGER JPT#                           Pointer to qx for bdf output     BF01  14
INTEGER MDATA#                         Yes: if matthew data in bdf      BF01  15
INTEGER NCENT#                         Centric/acentric = 0/1           BF01  16
INTEGER NROT#                          Number of rotat. matrices        BF01  17
INTEGER PSIZE#                         Input packet size                BF01  18
INTEGER RELPT(6)#                      Relative address for lrdset:     BF01  19
#                                                                       BF01  20
intdata:(IWANT,[1,30,31,36,37])#       Lrdset: id numbers               BF01  21
intdata:(KEY,[1,5,0,0])#               Key array for indexpkt:          BF01  22
datastuff:#                                                             BF01  23
#                                                                       BF01  24
# LAY OUT STORAGE                                                       BF01  25
# ---------------                                                       BF01  26
#                                                                       BF01  27
IOMARK(1) = QXSTR#                     Buffer for input bdf             BF01  28
IOMARK(2) = IOMARK(1) + bdfbuf:#       Buffer for output bdf            BF01  29
incrqx:(STARTS,IOMARK(2)+bdfbuf:,BF0101)# Mark end of i/o buffers       BF01  30
#                                                                       BF01  31
# COPY UP TO LRSYMM:                                                    BF01  32
# ------------------                                                    BF01  33
#                                                                       BF01  34
copyfile:(1,2,1,decr:(lrsymm:))#                                        BF01  35
readwpkt:(1,lrsymm:,PSIZE,IPT,0)#      Read index packet for symm.      BF01  36
writepkt:(2,lrsymm:,PSIZE,JPT)#        Write index packet for symm.     BF01  37
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#  Copy ip to op buffer             BF01  38
NCENT = NINT(QX(IPT+2))#               Centric/acentric = 0/1           BF01  39
NROT = NINT(QX(IPT+4))#                Get number of rotat. matrice     BF01  40
incrqx:(ENDSYM,STARTS+NROT*12*(2-NCENT),$# Bf                           BF01  41
        BF0101)#                       Expand qx to hold symops         BF01  42
FOR (J=STARTS; J>0; J=J+12)#           Loop over symops                 BF01  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF01  44
readwpkt:(1,lrsymm:,PSIZE,IPT,0)#      Read next symm packet            BF01  45
IF (IPT<=0 ) BREAK#                    Jump out after last packet       BF01  46
writepkt:(2,lrsymm:,PSIZE,JPT)#        Write index packet for symm.     BF01  47
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#  Copy ip to op buffer             BF01  48
movereal:(QX,IPT+1,QX,J+1,PSIZE,1)#    Store the symops                 BF01  49
IF (NCENT==0)#                         Center symmetry?                 BF01  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BF01  51
K = J#                                                                  BF01  52
FOR (I=STARTS; I<J; I=I+1)#                                             BF01  53
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BF01  54
K=K+1; QX(K)= -QX(I+1)#                Generate thru center             BF01  55
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BF01  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BF01  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF01  58
#                                                                       BF01  59
# COPY UP TO LRDDEF:                                                    BF01  60
# ------------------                                                    BF01  61
#                                                                       BF01  62
copyfile:(1,2,incr:(lrsymm:),decr:(lrddef:))# Soak up the rest          BF01  63
TOTCHR = 0#                            Number of characters in data     BF01  64
movechar:(BLANK,1,DSETID,1,chtotl:,1)## Initialize id's to blanks       BF01  65
I=-11#                                                                  BF01  66
#                                                                       BF01  67
# PROCESS LRDDEF: DATA (READ IN DATA SET NAMES)                         BF01  68
# ---------------------------------------------                         BF01  69
#                                                                       BF01  70
REPEAT#                                                                 BF01  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BF01  72
I=I+12#                                                                 BF01  73
readwpkt:(1,lrddef:,PSIZE,IPT,0)#                                       BF01  74
IF(IPT <= 0)  BREAK#                                                    BF01  75
writepkt:(2,lrddef:,PSIZE,JPT)#        Copy to output                   BF01  76
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#                                   BF01  77
TOTCHR = TOTCHR + 12#                  Increment character counter      BF01  78
movertoc:(QX(IPT+1),1,DSETID,I,12,0)#  Collect all data set id's        BF01  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BF01  80
#                                                                       BF01  81
copyfile:(1,2,incr:(lrddef:),decr:(lrdset:))#                           BF01  82
#                                                                       BF01  83
# PROCESS LRDSET: INDEX INFORMATION                                     BF01  84
# ---------------------------------                                     BF01  85
#                                                                       BF01  86
indexpkt:(1,lrdset:,PSIZE,IPT,0,KEY,IWANT,RELPT)# Lr lrdset: direc      BF01  87
KDATA = yes:#                          Assume k/dbk in bdf              BF01  88
MDATA = yes:#                          Assume matthew in bdf            BF01  89
IF (RELPT(2) == 0)#                    No k and delta k in file         BF01  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BF01  91
KDATA = no:#                           Flag this fact                   BF01  92
FOR(I=1; I <= maxset:; I=I+1)#                                          BF01  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BF01  94
KBDF(I)  = voidflg:#                                                    BF01  95
DBBDF(I) = voidflg:#                                                    BF01  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BF01  97
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BF01  98
IF (RELPT(4) == 0)$#                   No matthew k in file             BF01  99
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BF01 100
MDATA = no:#                           Flag this fact                   BF01 101
FOR(I=1; I <= maxset:; I=I+1)#                                          BF01 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BF01 103
MBBDF(I) = voidflg:#                                                    BF01 104
MKBDF(I) = voidflg:#                                                    BF01 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BF01 106
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BF01 107
IF(KDATA == yes: \ MDATA == yes:)#     Data in lrdset: to get?          BF01 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BF01 109
writepkt:(2,lrdset:,PSIZE,JPT)#        Copy directory to output         BF01 110
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#                                   BF01 111
I = 0#                                                                  BF01 112
#                                                                       BF01 113
# READ LRDSET: RECORDS - SAVE SCALING DATA                              BF01 114
# --------------------                                                  BF01 115
#                                                                       BF01 116
REPEAT#                                                                 BF01 117
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BF01 118
readwpkt:(1,lrdset:,PSIZE,IPT,0)#                                       BF01 119
IF(IPT <= 0)  BREAK#                                                    BF01 120
writepkt:(2,lrdset:,PSIZE,JPT)#        Copy lrdset: to output           BF01 121
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#                                   BF01 122
I = I + 1#                             Pick up from each lrdset: ..     BF01 123
IF( KDATA == yes: )#                                                    BF01 124
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BF01 125
KBDF(I)=QX(IPT+RELPT(2))#              Relative scale                   BF01 126
DBBDF(I)=QX(IPT+RELPT(3))#             Delta b                          BF01 127
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BF01 128
IF( MDATA == yes:)#                                                     BF01 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BF01 130
MKBDF(I)=QX(IPT+RELPT(4))#             Matthew ratio                    BF01 131
MBBDF(I)=QX(IPT+RELPT(5))#             Matthew b                        BF01 132
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BF01 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BF01 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BF01 135
# COPY UP TO LRREFL:                                                    BF01 136
# ------------------                                                    BF01 137
#                                                                       BF01 138
copyfile:(1,2,incr:(lrdset:),decr:(lrrefl:))#                           BF01 139
#                                                                       BF01 140
RETURN#                                                                 BF01 141
END#                                                                    BF01 142
systemheader:(BF02)#                                                    BF02   1
####################################################################### BF02   2
#                                                                     # BF02   3
#                              BF02                                   # BF02   4
#                                                                     # BF02   5
####################################################################### BF02   6
SUBROUTINE BF02#                       Input and call processing        BF02   7
include:(AACOMN)#                                                       BF02   8
include:(BFCOMN)#                                                       BF02   9
#                                                                       BF02  10
INTEGER I#                             Loop index                       BF02  11
#                                                                       BF02  12
chardata:(BF021,1.0         )#                                          BF02  13
chardata:(BF022, COEFF  FOURR  ADHOC  )# *change* for new options       BF02  14
chardata:(BF023, END    PHASE  KDB    SCALE  WEIGHT LIMHKL $#           BF02  15
LIMSTL LIMD   LIMCO  LIMF   MATTW    )#                                 BF02  16
chardata:(BF024,[* PRINT EVERY    -TH REFLECTION])#                     BF02  17
chardata:(BF025,[LIST ])#                                               BF02  18
datastuff:#                                                             BF02  19
#                                                                       BF02  20
# INITIALIZATION                                                        BF02  21
# --------------                                                        BF02  22
#                                                                       BF02  23
BIGCO  =  bigf:#                       Set coeff limits very big        BF02  24
FAZYN  =  no:#                         Assume no phase line used        BF02  25
SMALCO = -BIGCO#                                                        BF02  26
SIGKCO =  voidflg:#                    K*sigma limits off               BF02  27
SIGKF  =  voidflg:#                                                     BF02  28
K1     =  voidflg:#                                                     BF02  29
K2     =  voidflg:#                                                     BF02  30
MATTB1 =  voidflg:#                                                     BF02  31
MATTB2 =  voidflg:#                                                     BF02  32
MATTK1 =  voidflg:#                                                     BF02  33
MATTK2 =  voidflg:#                                                     BF02  34
WT1    =  1.0#                                                          BF02  35
WT2    =  1.0#                                                          BF02  36
COEFAV = 0.0#                          Coefficient statistics           BF02  37
COEFMN = 99999.0#                                                       BF02  38
COEFMX = -99999.0#                                                      BF02  39
LMOD = 0#                              Default, print every 100 refl    BF02  40
#                                                                       BF02  41
DO I=1,3#                              Hkl limits                       BF02  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF02  43
BIGIH(I) =   1000#                                                      BF02  44
SMALIH(I) = -1000#                                                      BF02  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF02  46
SMALST = 0.#                           Sine(theta)/lambda limits        BF02  47
BIGST  = 1.#                                                            BF02  48
SMALF1 = 0.#                           F-rel range limits               BF02  49
BIGF1  = bigf:#                                                         BF02  50
SMALF2 = 0.#                                                            BF02  51
BIGF2  = bigf:#                                                         BF02  52
SCALE  = 1.0#                          Overall scale                    BF02  53
WTPTR  = 0#                            Weighting turned off             BF02  54
movechar:(BF021,1,IDWT,1,12,0)#        Set weight word for line out     BF02  55
#                                                                       BF02  56
# REFLECTION COUNTS                                                     BF02  57
NREJCO = 0.#                                                            BF02  58
NREJH  = 0.#                                                            BF02  59
NREJF1 = 0.#                                                            BF02  60
NREJF2 = 0.#                                                            BF02  61
NREJPH = 0.#                                                            BF02  62
NREJV1 = 0.#                                                            BF02  63
NREJV2 = 0.#                                                            BF02  64
NREJST = 0.#                                                            BF02  65
NREJSC = 0.#                                                            BF02  66
NREJSF = 0.#                                                            BF02  67
NRFIN  = 0.#                                                            BF02  68
NRFOUT = 0.#                                                            BF02  69
#                                                                       BF02  70
# DECIPHER BFOURR LINE                                                  BF02  71
# ---------------                                                       BF02  72
#                                                                       BF02  73
ifnv:(BUFIN(1))#                       Look for list parameter          BF02  74
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BF02  75
stringlim:(1,J,K)#                     Find limits of the field         BF02  76
compchar:(CHRIN,J,BF025,1,4,5,NBF025,K)# Find what's there              BF02  77
IF(K==0) iquit:(BF0202,1)#             Dud flag.......bf0202            BF02  78
IF(BUFIN(2)>voidflg:) LMOD=INT(BUFIN(2))# List option                   BF02  79
ELSE                  LMOD=1#          List every reflection            BF02  80
ncodefld:(FLOAT(LMOD),1,BF024,170313.,2)# Report list request           BF02  81
writeline:(3,BF024,NBF024,3,3)#                                         BF02  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BF02  83
#                                                                       BF02  84
# READ LINE INPUT                                                       BF02  85
# ---------------                                                       BF02  86
#                                                                       BF02  87
readline:(BF022,NBF022)#                                                BF02  88
IF(LINID == 3)CALL BF99#               Ad hoc routine                   BF02  89
ELSE          CALL BF21#               Coeff or fourr line              BF02  90
#                                                                       BF02  91
REPEAT#                                                                 BF02  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BF02  93
readline:(BF023,NBF023)#                                                BF02  94
IF(LINID == 1)  BREAK#                 End line                         BF02  95
ELSE  IF(LINID == 2)  CALL BF23#       Phase                            BF02  96
ELSE  IF(LINID == 3)  CALL BF24#       Kdb                              BF02  97
ELSE  IF(LINID == 4)  CALL BF25#       Scale                            BF02  98
ELSE  IF(LINID == 5)  CALL BF26#       Weight                           BF02  99
ELSE  IF(LINID == 6)  CALL BF27#       Limhkl                           BF02 100
ELSE  IF(LINID == 7)  CALL BF27#       Limstl                           BF02 101
ELSE  IF(LINID == 8)  CALL BF27#       Limd                             BF02 102
ELSE  IF(LINID == 9)  CALL BF27#       Limco                            BF02 103
ELSE  IF(LINID == 10) CALL BF27#       Limf                             BF02 104
#ELSE  IF(LINID == 11) CALL BF28#        MATTW                          BF02 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BF02 106
#                                                                       BF02 107
RETURN#                                                                 BF02 108
END#                                                                    BF02 109
systemheader:(BF03)#                   Coefficient making routines      BF03   1
####################################################################### BF03   2
#                                                                     # BF03   3
#                              BF03                                   # BF03   4
#                                                                     # BF03   5
####################################################################### BF03   6
SUBROUTINE BF03#                                                        BF03   7
include:(AACOMN)#                                                       BF03   8
include:(BFCOMN)#                                                       BF03   9
#                                                                       BF03  10
# IN THE IF..ELSE CHAIN BELOW AS YET ONLY FTYPES IN THE RANGE 1 - 4     BF03  11
#  ARE PROCESSED.  ANY OTHER VALUE RESULTS IN NO ACTION.  THIS PROTECTS BF03  12
#  AGAINST AD HOC FUNCTIONS WHICH SET FTYPE TO 99........               BF03  13
#                                                                       BF03  14
# THE CURRENT VALUES FOR FTYPE AND THEIR MEANINGS ARE:                  BF03  15
#                                                                       BF03  16
#   1  BIJVOET DIFFERENCE MAP                                           BF03  17
#   2  ISOMORHOUS DIFFERENCE MAP                                        BF03  18
#   3  COMBINED ISOMORPHOUS AND ANOMOLOUS MAP                           BF03  19
#                                                                       BF03  20
IF(FTYPE == 1)CALL BF41#               Bijvoet difference map           BF03  21
ELSE  IF(FTYPE <  4)  CALL BF42#       Difference maps (ftype=2/3)      BF03  22
#                                                                       BF03  23
RETURN#                                                                 BF03  24
END#                                                                    BF03  25
systemheader:(BF04)#                   Close the output bdf             BF04   1
####################################################################### BF04   2
#                                                                     # BF04   3
#                              BF04                                   # BF04   4
#                                                                     # BF04   5
####################################################################### BF04   6
SUBROUTINE BF04#                                                        BF04   7
include:(AACOMN)#                                                       BF04   8
include:(BFCOMN)#                                                       BF04   9
#                                                                       BF04  10
INTEGER IPT#                           Input packet pointer             BF04  11
INTEGER JPT#                           Output packet pointer            BF04  12
INTEGER PSIZE#                         Packet size                      BF04  13
#                                                                       BF04  14
CALL BF54#                             List reflection counts           BF04  15
#                                                                       BF04  16
readwpkt:(1,endrecord:,PSIZE,IPT,0)#   Finish input bdf                 BF04  17
writepkt:(2,endrecord:,1,JPT)#         Write eof logical record         BF04  18
#                                                                       BF04  19
RETURN#                                                                 BF04  20
END#                                                                    BF04  21
systemheader:(BF21)#                                                    BF21   1
####################################################################### BF21   2
#                                                                     # BF21   3
#                              BF21                                   # BF21   4
#                                                                     # BF21   5
####################################################################### BF21   6
SUBROUTINE BF21#                       Subroutine to process coeff      BF21   7
#                                            Line input.                BF21   8
#                                        ** must change routine if add  BF21   9
#                                        ** options to coeff line.      BF21  10
include:(AACOMN)#                                                       BF21  11
include:(BFCOMN)#                                                       BF21  12
#                                                                       BF21  13
INTEGER FIRST#                         Pointer to initial character     BF21  14
#                                         In an input line field.       BF21  15
INTEGER LASTP1#                        Pointer to final character       BF21  16
#                                         Plus 1 in an input line field BF21  17
INTEGER NCHAR#                         No. characters in input fiel     BF21  18
chardata:(BF211,BIISCO)#               The first 2 characters from      BF21  19
#                                         An input line.                BF21  20
intdata:(NTYPE,[8])#                   Total characters in idtyp        BF21  21
datastuff:#                                                             BF21  22
#                                                                       BF21  23
movechar:(BLANK,1,IDSET1,1,12,1)#      Blank out data set id's          BF21  24
movechar:(BLANK,1,IDSET2,1,12,1)#                                       BF21  25
stringlim:(1,FIRST,LASTP1)#            Read field 1                     BF21  26
#                                                                       BF21  27
# CHECK TYPE OF COEFFICIENT REQUESTED                                   BF21  28
# -----------------------------------                                   BF21  29
#                                                                       BF21  30
compchar:(CHRIN,FIRST,BF211,1,2,2,NTYPE,FTYPE)#                         BF21  31
IF(FTYPE == 0)  iquit:(-BF2101,1)#     Illegal fourier specificatio     BF21  32
#                                                                       BF21  33
# PARSE DATASET 1 GIVEN AS ARGUMENT                                     BF21  34
# -----------------------------------                                   BF21  35
#                                                                       BF21  36
stringlim:(2,FIRST,LASTP1)#            Read first data set name         BF21  37
NCHAR = MIN0((LASTP1-FIRST),12)#                                        BF21  38
movechar:(CHRIN,FIRST,IDSET1,1,NCHAR,0)#                                BF21  39
compchar:(IDSET1,1,DSETID,1,NCHAR,12,TOTCHR,NSET1)#                     BF21  40
#                                                                       BF21  41
# PARSE DATASET 2 GIVEN AS ARGUMENT                                     BF21  42
# -----------------------------------                                   BF21  43
#                                                                       BF21  44
IF(NSET1 == 0)  iquit:(-BF2102,2)#                                      BF21  45
IF(FTYPE < 2)  NSET2 = 0#              Ftype=1 only need 1 dataset      BF21  46
ELSE#                                  Ftype>1 need 2 datasets          BF21  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF21  48
stringlim:(3,FIRST,LASTP1)#            Read next field and first se     BF21  49
NCHAR = MIN0((LASTP1-FIRST),12)#       If it's a data set name.         BF21  50
movechar:(CHRIN,FIRST,IDSET2,1,NCHAR,0)#                                BF21  51
compchar:(IDSET2,1,DSETID,1,NCHAR,12,TOTCHR,NSET2)#                     BF21  52
IF(NSET2 == 0)  iquit:(-BF2103,3)#     Data set 2 name missing          BF21  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF21  54
#                                                                       BF21  55
RETURN#                                                                 BF21  56
END#                                                                    BF21  57
systemheader:(BF23)#                                                    BF23   1
####################################################################### BF23   2
#                                                                     # BF23   3
#                              BF23                                   # BF23   4
#                                                                     # BF23   5
####################################################################### BF23   6
SUBROUTINE BF23#                       Subroutine to process phase      BF23   7
#                                         Line input.                   BF23   8
#                                        Called from bf02               BF23   9
include:(AACOMN)#                                                       BF23  10
include:(BFCOMN)#                                                       BF23  11
#                                                                       BF23  12
INTEGER FIRST#                         Pointer to first character       BF23  13
#                                         In an input line field.       BF23  14
INTEGER LASTP1#                        Pointer to last character        BF23  15
#                                         Plus 1 in an input line field BF23  16
INTEGER MATCH#                         Result of field comparison       BF23  17
INTEGER NCHAR#                         No. characters in input fiel     BF23  18
#                                                                       BF23  19
# THE FIRST 2 CHARACTERS FROM PHASE WORDS FOR 4 POSSIBLE PHASE SOURCES  BF23  20
chardata:(BF231,CEPRFCDE)#                                              BF23  21
chardata:(BF232,$#                                                      BF23  22
CENTROID                    $#                                          BF23  23
MOST PROBABLE               $#                                          BF23  24
CALCULATED STRUCTURE FACTORS$#                                          BF23  25
DENSITY MODIFICATION        )#                                          BF23  26
intdata:(NUMBER,[701,702,703,704,801,802,706,707,#                      BF23  27
510,511,800,700])#                                                      BF23  28
datastuff:#                                                             BF23  29
#                                                                       BF23  30
FAZYN = yes:#                          Flag phase line use              BF23  31
FAZNUM = 0#                            Initialize data set number       BF23  32
#                                         For fc phases.                BF23  33
stringlim:(1,FIRST,LASTP1)#            Get phase source,  compare       BF23  34
compchar:(CHRIN,FIRST,BF231,1,2,2,NBF231,MATCH)#                        BF23  35
#                                                                       BF23  36
movechar:(BF232,28*MATCH-27,PHAZWD,1,28,0)# Phase descriptor to co      BF23  37
IF(MATCH == 0)  iquit:(-BF2301)#       Check for illegal phase type     BF23  38
#                                                                       BF23  39
ELSE  IF(MATCH == 3)#                  If fc phases specified, then     BF23  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF23  41
movechar:(BLANK,1,IDFAZ,1,12,1)#       The data set name for them       BF23  42
stringlim:(2,FIRST,LASTP1)#            Must be present.                 BF23  43
NCHAR = MIN0((LASTP1-FIRST),12)#                                        BF23  44
movechar:(CHRIN,FIRST,IDFAZ,1,NCHAR,0)#                                 BF23  45
compchar:(IDFAZ,1,DSETID,1,NCHAR,12,TOTCHR,FAZNUM)#                     BF23  46
IF(FAZNUM == 0)  iquit:(-BF2302,2)#                                     BF23  47
MATCH = MATCH + MATCH - 1#             Adjust pointer                   BF23  48
#                                                                       BF23  49
#  SET UP ITEMS TO RETRIEVE FROM BDF                                    BF23  50
PHNMBR(1) = NUMBER(MATCH)   + 1000*FAZNUM#                              BF23  51
PHNMBR(2) = NUMBER(MATCH+1) + 1000*FAZNUM#                              BF23  52
PHNMBR(3) = NUMBER(MATCH+6) + 1000*FAZNUM#                              BF23  53
PHNMBR(4) = NUMBER(MATCH+7) + 1000*FAZNUM#                              BF23  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF23  55
ELSE#                                                                   BF23  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BF23  57
MATCH = MATCH + MATCH - 1#             Adjust pointer                   BF23  58
#                                                                       BF23  59
#  SET UP ITEMS TO RETRIEVE FROM BDF                                    BF23  60
PHNMBR(1) = NUMBER(MATCH)#                                              BF23  61
PHNMBR(2) = NUMBER(MATCH+1)#                                            BF23  62
PHNMBR(3) = 0#                                                          BF23  63
PHNMBR(4) = 0#                                                          BF23  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BF23  65
#                                                                       BF23  66
RETURN#                                                                 BF23  67
END#                                                                    BF23  68
systemheader:(BF24)#                                                    BF24   1
####################################################################### BF24   2
#                                                                     # BF24   3
#                              BF24                                   # BF24   4
#                                                                     # BF24   5
####################################################################### BF24   6
SUBROUTINE BF24#                       Subroutine to read kdb line      BF24   7
#                                        Called from bf02               BF24   8
include:(AACOMN)#                                                       BF24   9
include:(BFCOMN)#                                                       BF24  10
#                                                                       BF24  11
INTEGER FIRST#                         Pointer to first character       BF24  12
#                                         In an input line field.       BF24  13
INTEGER LASTP1#                        Pointer to last character        BF24  14
#                                         Plus 1 in an input line field BF24  15
INTEGER MATCH#                         Results of field comparison      BF24  16
INTEGER NCHAR#                         Number of characters in fiel     BF24  17
datastuff:#                                                             BF24  18
#                                                                       BF24  19
stringlim:(1,FIRST,LASTP1)#            Get data set name                BF24  20
NCHAR = MIN0((LASTP1-FIRST),12)#       Just the first 12 characters     BF24  21
#                                                                       BF24  22
# SEE IF IT'S THE SAME AS THE FIRST DATA SET NAME                       BF24  23
#                                                                       BF24  24
compchar:(CHRIN,FIRST,IDSET1,1,NCHAR,12,12,MATCH)#                      BF24  25
#                                                                       BF24  26
IF(MATCH == 0)#                        No, well, maybe it's the sam     BF24  27
#                                         As the second data set name.  BF24  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF24  29
compchar:(CHRIN,FIRST,IDSET2,1,NCHAR,12,12,MATCH)#                      BF24  30
IF(MATCH == 1)  MATCH = 2#             If so, make sure it points       BF24  31
#                                         To it.                        BF24  32
ELSE#                                  Maybe it's allowed to say 'f     BF24  33
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BF24  34
iquit:(-BF2401,1)#                                                      BF24  35
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BF24  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF24  37
#                                                                       BF24  38
# GET THE SCALE AND/OR MATTHEW K.                                       BF24  39
# -------------------------------                                       BF24  40
#                                                                       BF24  41
#                                                                       BF24  42
# SAVE VALUES FROM KDB LINE FOR DATASET 1                               BF24  43
# ---------------------------------------                               BF24  44
#                                                                       BF24  45
IF(MATCH == 1)#                        For first data set               BF24  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BF24  47
ifnv:(BUFIN(2)) K1  = BUFIN(2)#                                         BF24  48
ifnv:(BUFIN(3)) DB1 = BUFIN(3)#                                         BF24  49
ifnv:(BUFIN(4)) MATTK1 = BUFIN(4)#                                      BF24  50
ifnv:(BUFIN(5)) MATTB1 = BUFIN(5)#                                      BF24  51
ifnv:(BUFIN(6)) WT1 = BUFIN(6)#        Data set 1 anomolous wt          BF24  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BF24  53
#                                                                       BF24  54
# SAVE VALUES FROM KDB LINE FOR DATASET 2                               BF24  55
# ---------------------------------------                               BF24  56
#                                                                       BF24  57
ELSE#                                                                   BF24  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BF24  59
ifnv:(BUFIN(2)) K2  = BUFIN(2)#                                         BF24  60
ifnv:(BUFIN(3)) DB2 = BUFIN(3)#                                         BF24  61
ifnv:(BUFIN(4)) MATTK2 = BUFIN(4)#                                      BF24  62
ifnv:(BUFIN(5)) MATTB2 = BUFIN(5)#                                      BF24  63
ifnv:(BUFIN(6)) WT2 = BUFIN(6)#        Data set 1 anomolous wt          BF24  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BF24  65
#                                                                       BF24  66
RETURN#                                                                 BF24  67
END#                                                                    BF24  68
systemheader:(BF25)#                                                    BF25   1
####################################################################### BF25   2
#                                                                     # BF25   3
#                              BF25                                   # BF25   4
#                                                                     # BF25   5
####################################################################### BF25   6
SUBROUTINE BF25#                       Subroutine to process scale      BF25   7
#                                         Line input.                   BF25   8
include:(AACOMN)#                                                       BF25   9
include:(BFCOMN)#                                                       BF25  10
#                                                                       BF25  11
#                                                                       BF25  12
SCALE = BUFIN(1)#                                                       BF25  13
IF(SCALE <= 0.)  iquit:(-BF2501)#                                       BF25  14
#                                                                       BF25  15
RETURN#                                                                 BF25  16
END#                                                                    BF25  17
systemheader:(BF26)#                                                    BF26   1
####################################################################### BF26   2
#                                                                     # BF26   3
#                              BF26                                   # BF26   4
#                                                                     # BF26   5
####################################################################### BF26   6
SUBROUTINE BF26#                       Subroutine to process weight     BF26   7
#                                         Line input.                   BF26   8
include:(AACOMN)#                                                       BF26   9
include:(BFCOMN)#                                                       BF26  10
#                                                                       BF26  11
INTEGER FIRST#                         Pointer to first character       BF26  12
#                                         In an input line field.       BF26  13
INTEGER LASTP1#                        Pointer to last character        BF26  14
#                                         Plus 1 in an input line field BF26  15
INTEGER MATCH#                         Results of char. comparison      BF26  16
chardata:(BF261,CENTROID)#             Weight descriptor  'centroid     BF26  17
datastuff:#                                                             BF26  18
#                                                                       BF26  19
stringlim:(1,FIRST,LASTP1)#            Read field 1                     BF26  20
compchar:(CHRIN,FIRST,BF261,1,2,2,2,MATCH)#                             BF26  21
#                                                                       BF26  22
IF(MATCH == 0)  iquit:(-BF2601,1)#                                      BF26  23
ELSE#                                                                   BF26  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF26  25
WTPTR = 700#                                                            BF26  26
movechar:(BF261,1,IDWT,1,NBF261,0)#    Set weight identifier to         BF26  27
#                                         'centroid'.                   BF26  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF26  29
#                                                                       BF26  30
RETURN#                                                                 BF26  31
END#                                                                    BF26  32
systemheader:(BF27)#                                                    BF27   1
####################################################################### BF27   2
#                                                                     # BF27   3
#                              BF27                                   # BF27   4
#                                                                     # BF27   5
####################################################################### BF27   6
SUBROUTINE BF27#                       Subroutine to process limhkl     BF27   7
#                                         Limstl, limd, limco, or       BF27   8
#                                         Limf lines.                   BF27   9
include:(AACOMN)#                                                       BF27  10
include:(BFCOMN)#                                                       BF27  11
#                                                                       BF27  12
INTEGER I#                             Loop index                       BF27  13
INTEGER J#                             Another loop index               BF27  14
chardata:(INFIN,INFINITY)#                                              BF27  15
chardata:(NONE,      NONE)#                                             BF27  16
chardata:(BF271, HKL--LIMITS)#                                          BF27  17
chardata:(BF272,   MIN   MAX)#                                          BF27  18
chardata:(BF273, H          )#                                          BF27  19
chardata:(BF274, SIN(THETA)/LAMBDA LIMITS     RESOLUTION LIMITS)#       BF27  20
chardata:(BF275,       MIN        MAX              MAX      MIN)#       BF27  21
chardata:(BF276,  COEFFICIENT LIMITS)##                                 BF27  22
chardata:(BF277,   REJECT REF IF ABS(COEF) LT   0.0 * SIGMA(COEF))#     BF27  23
chardata:(BF278,   F-OBSERVED LIMITS)##                                 BF27  24
chardata:(BF279,   REJECT REF IF ONE FOBS  LT   0.0 * SIGMA(FOBS))#     BF27  25
chardata:(BF27A,       MIN       MAX)##                                 BF27  26
realdata:(FMT271,[60313.,120313.,100752.,380632.,#                      BF27  27
210752.,470632.,100912.,200912.])#     Hkl limit formats                BF27  28
realdata:(FMT272,[350612.])#           K*sigma limit format             BF27  29
datastuff:#                                                             BF27  30
# HKL LIMITS                                                            BF27  31
#                                                                       BF27  32
IF(LINID == 6)#                        Limhkl line                      BF27  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF27  34
LINRM = 6#                             Output hkl limits                BF27  35
writeline:(1,BF271,NBF271,3,3)#                                         BF27  36
writeline:(0,BF272,NBF272,3,3)#                                         BF27  37
FOR(I=1; I <= 3; I=I+1)#                                                BF27  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BF27  39
J = 2*(I-1) + 1#                                                        BF27  40
ifnv:(BUFIN(J))    SMALIH(I) = NINT(BUFIN(J))#                          BF27  41
ifnv:(BUFIN(J+1))  BIGIH(I)  = NINT(BUFIN(J+1))#                        BF27  42
IF(BIGIH(I) <= SMALIH(I))  iquit:(-BF2701)#                             BF27  43
movechar:(BF271,I+1,BF273,2,1,0)#      H or k or l to format            BF27  44
BUFOT(1) = FLOAT(SMALIH(I))#                                            BF27  45
BUFOT(2) = FLOAT(BIGIH(I))#                                             BF27  46
ncodefld:(BUFOT,1,BF273,FMT271(1),2)#  The limits to the output         BF27  47
writeline:(0,BF273,NBF273,3,3)#                                         BF27  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BF27  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF27  50
#                                                                       BF27  51
# SINE(THETA)/LAMBDA LIMITS                                             BF27  52
#                                                                       BF27  53
ELSE  IF(LINID == 7)#                  Limstl line                      BF27  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BF27  55
LINRM = 4#                             Output the limits                BF27  56
writeline:(1,BF274,NBF274,3,3)#                                         BF27  57
ifnv:(BUFIN(1))#                                                        BF27  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BF27  59
SMALST = BUFIN(1)#                                                      BF27  60
BUFOT(1) = SMALST#                                                      BF27  61
BUFOT(2) = 0.5/AMAX1(small:,SMALST)#                                    BF27  62
ncodefld:(BUFOT,1,CHROT,FMT271(3),2)##                                  BF27  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BF27  64
ifnv:(BUFIN(2))#                                                        BF27  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BF27  66
BIGST = BUFIN(2)#                                                       BF27  67
BUFOT(1) = BIGST#                                                       BF27  68
BUFOT(2) = 0.5/AMAX1(small:,BIGST)#                                     BF27  69
ncodefld:(BUFOT,1,CHROT,FMT271(5),2)##                                  BF27  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BF27  71
IF(SMALST < 0. \ BIGST < 0.)  iquit:(-BF2702)#                          BF27  72
IF(SMALST >= BIGST)  iquit:(-BF2702)#                                   BF27  73
IF(SMALST < small:)  movechar:(INFIN,1,CHROT,31,8,0)#                   BF27  74
writeline:(0,BF275,NBF275,2,3)#                                         BF27  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BF27  76
#                                                                       BF27  77
# RESOLUTION LIMITS                                                     BF27  78
#                                                                       BF27  79
ELSE  IF(LINID == 8)#                  Limd line                        BF27  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BF27  81
writeline:(1,BF274,NBF274,3,3)#                                         BF27  82
ifnv:(BUFIN(1))#                                                        BF27  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BF27  84
BUFOT(1) = BUFIN(1)#                                                    BF27  85
BIGST = 0.5/AMAX1(BUFIN(1),small:)#                                     BF27  86
BUFOT(2) = BIGST#                                                       BF27  87
ncodefld:(BUFOT,1,CHROT,FMT271(5),2)##                                  BF27  88
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BF27  89
ifnv:(BUFIN(2))#                                                        BF27  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BF27  91
BUFOT(1) = BUFIN(2)#                                                    BF27  92
SMALST = 0.5/AMAX1(BUFIN(2),small:)#                                    BF27  93
BUFOT(2) = SMALST#                                                      BF27  94
ncodefld:(BUFOT,1,CHROT,FMT271(3),2)##                                  BF27  95
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BF27  96
IF(SMALST >= BIGST)  iquit:(-BF2703)#                                   BF27  97
IF(SMALST < 0. \ BIGST < 0.)  iquit:(-BF2703)#                          BF27  98
IF(SMALST < small:)  movechar:(INFIN,1,CHROT,31,8,0)#                   BF27  99
writeline:(0,BF275,NBF275,2,3)#                                         BF27 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BF27 101
#                                                                       BF27 102
# COEFFICIENT LIMITS                                                    BF27 103
#                                                                       BF27 104
ELSE  IF(LINID == 9)#                  Limco line                       BF27 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BF27 106
writeline:(1,BF276,NBF276,3,3)#                                         BF27 107
writeline:(0,BF27A,NBF27A,3,3)#                                         BF27 108
ifnv:(BUFIN(1))  SMALCO = BUFIN(1)#                                     BF27 109
ifnv:(BUFIN(2))  BIGCO = BUFIN(2)#                                      BF27 110
BUFOT(1) = SMALCO#                                                      BF27 111
BUFOT(2) = BIGCO#                                                       BF27 112
IF(SMALCO >= BIGCO)#                                                    BF27 113
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BF27 114
ifnv:(SMALCO)#                                                          BF27 115
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BF27 116
ifnv:(BIGCO)  iquit:(-BF2704)#                                          BF27 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BF27 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BF27 119
ncodefld:(BUFOT,1,CHROT,FMT271(7),2)##                                  BF27 120
ifvo:(BUFOT(1))  movechar:(NONE,1,CHROT,1,10,0)#                        BF27 121
ifvo:(BUFOT(2))  movechar:(NONE,1,CHROT,11,10,0)#                       BF27 122
writeline:(0,BF272,NBF272,1,3)#                                         BF27 123
ifnv:(BUFIN(3))#                       K*sigma(coef) limit              BF27 124
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BF27 125
SIGKCO = BUFIN(3)#                                                      BF27 126
IF(SIGKCO < small:)  iquit:(-BF2705)#                                   BF27 127
movechar:(BF277,1,CHROT,1,NBF277,0)#                                    BF27 128
BUFOT(1) = SIGKCO#                                                      BF27 129
ncodefld:(BUFOT,1,CHROT,FMT272,1)##                                     BF27 130
writeline:(1,0,0,1,3)#                                                  BF27 131
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BF27 132
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BF27 133
#                                                                       BF27 134
# F-OBSERVED LIMITS                                                     BF27 135
#                                                                       BF27 136
#  NOTE..AT PRESENT ONLY LIMITS ON DATA SET ONE ARE IMPLEMENTED         BF27 137
#   THUS SMALF1 AND BIGF1, ONLY ARE SET.    OCT 1981 (STF)...           BF27 138
#                                                                       BF27 139
ELSE  IF(LINID == 10)#                 Limf line                        BF27 140
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BF27 141
writeline:(1,BF278,NBF278,3,3)#                                         BF27 142
writeline:(0,BF27A,NBF27A,3,3)#                                         BF27 143
ifnv:(BUFIN(1))  SMALF1 = BUFIN(1)#                                     BF27 144
ifnv:(BUFIN(2))  BIGF1 = BUFIN(2)#                                      BF27 145
BUFOT(1) = SMALF1#                                                      BF27 146
BUFOT(2) = BIGF1#                                                       BF27 147
IF(SMALF1 >= BIGF1)#                                                    BF27 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BF27 149
ifnv:(SMALF1)#                                                          BF27 150
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BF27 151
ifnv:(BIGF1)  iquit:(-BF2706)#                                          BF27 152
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BF27 153
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BF27 154
ncodefld:(BUFOT,1,CHROT,FMT271(7),2)##                                  BF27 155
ifvo:(BUFOT(1))  movechar:(NONE,1,CHROT,1,10,0)#                        BF27 156
ifvo:(BUFOT(2))  movechar:(NONE,1,CHROT,11,10,0)#                       BF27 157
writeline:(0,BF272,NBF272,1,3)#                                         BF27 158
ifnv:(BUFIN(3))#                       K*sigma(coef) limit              BF27 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 BF27 160
SIGKF = BUFIN(3)#                                                       BF27 161
IF(SIGKF < small:)  iquit:(-BF2707)#                                    BF27 162
movechar:(BF279,1,CHROT,1,NBF279,0)#                                    BF27 163
BUFOT(1) = SIGKF#                                                       BF27 164
ncodefld:(BUFOT,1,CHROT,FMT272,1)#                                      BF27 165
writeline:(1,0,0,1,3)#                                                  BF27 166
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 BF27 167
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BF27 168
#                                                                       BF27 169
RETURN#                                                                 BF27 170
END#                                                                    BF27 171
systemheader:(BF41)#                                                    BF41   1
####################################################################### BF41   2
#                                                                     # BF41   3
#                              BF41                                   # BF41   4
#                                                                     # BF41   5
####################################################################### BF41   6
SUBROUTINE BF41#                       Subroutine to calculate          BF41   7
#                                         Fo, fc, or bijvoet            BF41   8
#                                         Difference coefficients.      BF41   9
include:(AACOMN)#                                                       BF41  10
include:(BFCOMN)#                                                       BF41  11
#                                                                       BF41  12
INTEGER CENREF#                        Yes: if centric reflection       BF41  13
INTEGER CHPTR#                         Character position pointer       BF41  14
INTEGER FSQAR#                         Yes: if f**2 in bdf              BF41  15
INTEGER GETSIG#                        Yes:, if sigma's needed          BF41  16
INTEGER I#                             Loop index                       BF41  17
INTEGER IH(3)#                         H,k,l as unpacked by b452        BF41  18
INTEGER IPT#                           Input packet pointer             BF41  19
INTEGER IPTR#                          Pointer to a particular inpu     BF41  20
#                                         Packet.                       BF41  21
INTEGER IWANT(maxwant:)#               Catalogue numbers, lrrefl:       BF41  22
#                                         Want list.                    BF41  23
INTEGER JPT#                           Output packet pointer            BF41  24
INTEGER KEY(4)#                        Signal array for indexpkt:       BF41  25
INTEGER OFFSET(incr:(maxwant:))#       Offsets for lrrefl: items        BF41  26
INTEGER PSIZE1#                        Input packet size                BF41  27
INTEGER PSIZE2#                        Output packet size               BF41  28
INTEGER PTF11#                         Pointer to f+, set 1             BF41  29
INTEGER PTF12#                         Pointer to f-, set 1             BF41  30
INTEGER PTFAZ#                         Pointer to phase angle           BF41  31
INTEGER PTFC#                          Pointer to f(calc)               BF41  32
INTEGER PTSG11#                        Pointer to sig(f**2) +           BF41  33
INTEGER PTSG12#                        Pointer to sig(f**2) -           BF41  34
INTEGER PTWT#                          Pointer to weight; if zero,      BF41  35
#                                         Do not weight coefficients.   BF41  36
INTEGER REJECT#                        Bf52 arg, yes: for reject re     BF41  37
INTEGER SSQAR#                         Yes: if sig(f**2) in bdf         BF41  38
REAL COEF#                             Coefficient                      BF41  39
REAL F#                                A structure amplitude            BF41  40
REAL FP#                               F(h,k,l)                         BF41  41
REAL FM#                               F(-h,-k,-l)                      BF41  42
REAL SIGP#                             Sigma(f+)                        BF41  43
REAL SIGM#                             Sigma(f-)                        BF41  44
#                                                                       BF41  45
chardata:(BF411, TRANSFORM TYPE. . .)##                                 BF41  46
chardata:(BF412, FC)#                                                   BF41  47
chardata:(BF413, BIJVOET DIFFERENCE)#                                   BF41  48
chardata:(BF414, FOURIER)#                                              BF41  49
chardata:(BF416, PHASE SOURCE. . . .)##                                 BF41  50
chardata:(BF417, NONE -- LAUE SYMMETRY)#                                BF41  51
chardata:(BF418, COEFFICIENT . . . . SCALE * WT * )#                    BF41  52
chardata:(BF419, FO)#                                                   BF41  53
chardata:(BF41A,[/ F(+) - F(-) /])#                                     BF41  54
chardata:(BF41B,FOR DATA SET....)#                                      BF41  55
chardata:(BF41C,      SCALE =       )##                                 BF41  56
chardata:(BF41D,     WEIGHT =         )#                                BF41  57
intdata:(PTCOS,[0])#                   Pointer to cos(phase)            BF41  58
intdata:(PTSIN,[0])#                   Pointer to sin(phase)            BF41  59
realdata:(FMT411,[200842.])#           Format                           BF41  60
DATA KEY(1),KEY(2),KEY(3),KEY(4)/3,maxwant:,0,0/#                       BF41  61
datastuff:#                                                             BF41  62
#                                                                       BF41  63
# MAKE LRREFL: WANT LIST                                                BF41  64
# ---------------------                                                 BF41  65
#                                                                       BF41  66
DO I=1,maxwant:#                       Set want list for hkl,           BF41  67
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF41  68
IF(I <=  3)  IWANT(I) = I#             Sitol, and eps/mult.             BF41  69
ELSE  IWANT(I) = 0#                    Set the rest to zero             BF41  70
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF41  71
#                                                                       BF41  72
# SEE IF SIGMAS ARE NEEDED                                              BF41  73
# ------------------------                                              BF41  74
#                                                                       BF41  75
IF(SIGKCO > 0. \ SIGKF > 0.)  GETSIG = yes:#                            BF41  76
ELSE  GETSIG = no:#                                                     BF41  77
#                                                                       BF41  78
# ADD TO WANT LIST                                                      BF41  79
# ----------------                                                      BF41  80
#                                                                       BF41  81
IF(WTPTR != 0)  IWANT(indxwt:) = WTPTR## Add weight to want list        BF41  82
#                                                                       BF41  83
IWANT(indxf11:) = 1000*NSET1 + nmbfp:# F+ for set one                   BF41  84
IWANT(indxf12:) = 1000*NSET1 + nmbfm:# F- for set one                   BF41  85
IWANT(indxf11s:) = 1000*NSET1 + nmbfp: - 2# F+ **2 for set one          BF41  86
IWANT(indxf12s:) = 1000*NSET1 + nmbfm: - 2# F- **2 for set two          BF41  87
IF(GETSIG == yes:)#                    See if sigma(f**2) needed        BF41  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BF41  89
IWANT(indxss11:) = 1000*NSET1 + nmbsigp: + 2#                           BF41  90
IWANT(indxss12:) = 1000*NSET1 + nmbsigm: + 2#                           BF41  91
IWANT(indxsg11:) = 1000*NSET1 + nmbsigp:#                               BF41  92
IWANT(indxsg12:) = 1000*NSET1 + nmbsigm:#                               BF41  93
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BF41  94
#                                                                       BF41  95
# CHECK TO SEE THAT A PHASE LINE WAS READ                               BF41  96
# ---------------------------------------                               BF41  97
#                                                                       BF41  98
IF( FAZYN == yes:)#                                                     BF41  99
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BF41 100
IF(PHNMBR(1) == 0 \ PHNMBR(2) == 0)  iquit:(-BF4101)#                   BF41 101
IWANT(indxcos:) = PHNMBR(1)#                                            BF41 102
IWANT(indxsin:) = PHNMBR(2)#                                            BF41 103
IWANT(indxfc:) = PHNMBR(3)#                                             BF41 104
IWANT(indxfaz:) = PHNMBR(4)#                                            BF41 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BF41 106
#                                                                       BF41 107
# LRREFL: DIRECTORY READ/WRITE                                          BF41 108
# ----------------------------                                          BF41 109
#                                                                       BF41 110
indexpkt:(1,lrrefl:,PSIZE1,IPT,0,KEY,IWANT,OFFSET)#                     BF41 111
IF (KEY(4) < 0)  iquit:(BF4102)#       Missing data                     BF41 112
PSIZE2 = 4#                            Get size of output directory     BF41 113
IF(FAZYN == yes:) PSIZE2 = PSIZE2 + 2# Output phases if needed          BF41 114
writepkt:(2,lrrefl:,PSIZE2,JPT)#       Get pointer to output            BF41 115
#                                         Sequence numbers of basic     BF41 116
#                                         Quantities.                   BF41 117
DO I=1,3#                                                               BF41 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BF41 119
QX(JPT+I)=FLOAT(IWANT(I))#                                              BF41 120
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BF41 121
#                                                                       BF41 122
# CHECK TO SEE IF THE REQUIRED F'S ARE PRESENT                          BF41 123
# ---------------------------------------------                         BF41 124
#                                                                       BF41 125
PTF11 = OFFSET(indxf11:)#              Get f-rel offsets                BF41 126
PTF12 = OFFSET(indxf12:)#                                               BF41 127
FSQAR = no:#                           Assume f-rel in bdf              BF41 128
IF (PTF11 == 0 & PTF12 == 0)#                                           BF41 129
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BF41 130
PTF11 = OFFSET(indxf11s:)#             Get f-rel**2 offsets             BF41 131
PTF12 = OFFSET(indxf12s:)#                                              BF41 132
IF (PTF11 == 0 & PTF12 == 0) iquit:(-BF4103)#                           BF41 133
FSQAR = yes:#                          Learn that f-rel**2 in bdf       BF41 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BF41 135
IF(PTF11 == 0)  PTF11 = PTF12#         Work with f data existing        BF41 136
IF(PTF12 == 0)  PTF12 = PTF11#                                          BF41 137
#                                                                       BF41 138
IF(GETSIG == yes:)#                    If sigmas are needed ...         BF41 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BF41 140
PTSG11 = OFFSET(indxsg11:)#            Get sigma(f**2) offsets          BF41 141
PTSG12 = OFFSET(indxsg12:)#                                             BF41 142
SSQAR = yes:#                          Assume sig(f**2) on bdf          BF41 143
IF (PTSG11 == 0 & PTSG12 == 0)#                                         BF41 144
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BF41 145
PTSG11 = OFFSET(indxss11:)#            Get sigma(f) offsets             BF41 146
PTSG12 = OFFSET(indxss12:)#                                             BF41 147
IF (PTSG11 == 0 & PTSG12 == 0) iquit:(-BF4106)#                         BF41 148
SSQAR = no:#                           Learn sig(f) in bdf              BF41 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BF41 150
IF(PTSG11 == 0)  PTSG11 = PTSG12#      That they are on the bdf.        BF41 151
IF(PTSG12 == 0)  PTSG12 = PTSG11#                                       BF41 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BF41 153
QX(JPT+4) = fnmb:#                     F id for output directory        BF41 154
#                                                                       BF41 155
# NO PHASES IS AN ERROR IF PHASE REQUIRED IN PHASE LINE                 BF41 156
# -----------------------------------------------------                 BF41 157
#                                                                       BF41 158
IF(FAZYN == yes:)#                                                      BF41 159
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BF41 160
IF(OFFSET(indxfaz:)!=0)#               Item 1700/1800 in bdf            BF41 161
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BF41 162
QX(JPT+5) = phnmbfc:#                                                   BF41 163
QX(JPT+6) = phnmbfaz:#                                                  BF41 164
OFFSET(indxcos:)=0#                                                     BF41 165
OFFSET(indxsin:)=0#                                                     BF41 166
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BF41 167
ELSE#                                                                   BF41 168
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BF41 169
IF(OFFSET(indxcos:)==0 \ OFFSET(indxsin:)==0) iquit:(-BF4104)#          BF41 170
QX(JPT+5) = phnmbcos:#                 Phase id numbers for output      BF41 171
QX(JPT+6) = phnmbsin:#                 Directory.                       BF41 172
OFFSET(indxfaz:)=0##                                                    BF41 173
OFFSET(indxfc:)=0##                                                     BF41 174
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BF41 175
PTCOS = OFFSET(indxcos:)#              Offset for cos(phase)            BF41 176
PTSIN = OFFSET(indxsin:)#              Offset for sin(phase)            BF41 177
PTFAZ = OFFSET(indxfaz:)#              Offset for phase(cycles)         BF41 178
PTFC  = OFFSET(indxfc:)#               Offset for fc                    BF41 179
JPT=JPT+2#                             Add 2 entries to output          BF41 180
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BF41 181
#                                                                       BF41 182
IF(WTPTR != 0)#                        Check weights                    BF41 183
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BF41 184
PTWT = OFFSET(indxwt:)#                They are to be used, therefo     BF41 185
IF(PTWT == 0)  iquit:(-BF4105)#        They have to be on the bdf.      BF41 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BF41 187
ELSE  PTWT = 0#                        Weights are not to be used       BF41 188
#                                                                       BF41 189
# WRITE COEFFICIENT DESCRIPTION ON LINE OUTPUT                          BF41 190
# --------------------------------------------                          BF41 191
#                                                                       BF41 192
movechar:(BF411,1,CHROT,1,NBF411,0)#   Beginning of lead line           BF41 193
I = NBF411#                            Character count for lead lin     BF41 194
movechar:(BF413,1,CHROT,I+1,NBF413,0)## Insert 'bijvoet differenc       BF41 195
I = I + NBF413#                                                         BF41 196
movechar:(BF414,1,CHROT,I+1,NBF414,0)## Insert 'fourier'                BF41 197
writeline:(2,0,0,1,3)#                 Write out lead line              BF41 198
#                                                                       BF41 199
IF( FAZYN == yes:)#                                                     BF41 200
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BF41 201
movechar:(BF416,1,CHROT,1,NBF416,0)#   Assemble phase line              BF41 202
movechar:(PHAZWD,1,CHROT,NBF416+2,lphazwd:,0)#                          BF41 203
IF(FAZNUM > 0 )#                       If fc phases, list data          BF41 204
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BF41 205
CHPTR = NBF416 + lphazwd: + 3#         Set name for the phases.         BF41 206
movechar:(BF41B,1,CHROT,CHPTR,NBF41B,0)#                                BF41 207
CHPTR = CHPTR + NBF41B + 1#                                             BF41 208
movechar:(IDFAZ,1,CHROT,CHPTR,12,0)#                                    BF41 209
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BF41 210
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BF41 211
#                                                                       BF41 212
writeline:(1,0,0,1,3)#                 Write out phase line             BF41 213
movechar:(BF418,1,CHROT,1,NBF418,0)#   Assemble coefficient line        BF41 214
movechar:(BF41A,1,CHROT,NBF418+1,NBF41A,0)#                             BF41 215
writeline:(1,0,0,1,3)#                                                  BF41 216
#                                                                       BF41 217
# LINE FOR SOURCE OF F                                                  BF41 218
movechar:(BF419,1,CHROT,1,3,0)#                                         BF41 219
movechar:(BF41B,1,CHROT,5,NBF41B,0)#                                    BF41 220
movechar:(IDSET1,1,CHROT,NBF41B+6,12,0)#                                BF41 221
writeline:(1,0,0,1,3)#                                                  BF41 222
#                                                                       BF41 223
BUFOT(1) = SCALE#                                                       BF41 224
ncodefld:(BUFOT,1,BF41C,FMT411,1)#     Scale line                       BF41 225
writeline:(0,BF41C,NBF41C,3,3)#                                         BF41 226
#                                                                       BF41 227
movechar:(IDWT,1,BF41D,15,12,0)#       Weight line                      BF41 228
writeline:(0,BF41D,NBF41D,3,3)#                                         BF41 229
#                                                                       BF41 230
# IF ANY ERRORS HAVE BEEN ENCOUNTERED, DIE HERE....                     BF41 231
# ------------------------------------------------                      BF41 232
#                                                                       BF41 233
IF(QUITF(1^1)!=' ')   iquit:(BF4199)#                                   BF41 234
#                                                                       BF41 235
# BEGIN LOOP TO READ REFLECTIONS                                        BF41 236
# ------------------------------                                        BF41 237
#                                                                       BF41 238
IF(LMOD!=0) LINCT = 0#                 Force new page                   BF41 239
REPEAT#                                                                 BF41 240
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BF41 241
readwpkt:(1,lrrefl:,PSIZE1,IPT,0)#                                      BF41 242
IF(IPT <= 0)  BREAK#                                                    BF41 243
NRFIN = NRFIN + 1.#                    Count input reflections          BF41 244
#                                                                       BF41 245
# CHECK FOR CENTRIC REFLECTION                                          BF41 246
# ----------------------------                                          BF41 247
# NOTE: STARTS, ENDSYM FROM COMMON                                      BF41 248
#                                                                       BF41 249
CALL BF55(IPT+OFFSET(1),STARTS,ENDSYM,CENREF)#                          BF41 250
#                                                                       BF41 251
IPTR = IPT + OFFSET(2)#                                                 BF41 252
SITOL = QX(IPTR)#                      Sine(theta)/lambda               BF41 253
IPTR = IPT + OFFSET(1)#                Pointer to packed hkl            BF41 254
CALL BF52(QX(IPTR),IH,REJECT)#         Check for refl. rejection        BF41 255
IF(REJECT == yes: ) NEXT#              Bf41 254                         BF41 256
#                                                                       BF41 257
#   GET STRUCTURE AMPLITUDES AND CHECK FOR REJECTION                    BF41 258
#   ------------------------------------------------                    BF41 259
#                                                                       BF41 260
IPTR = IPT + PTF11#                                                     BF41 261
FP = QX(IPTR)#                         Get value of f+rel               BF41 262
IPTR = IPT + PTF12#                                                     BF41 263
FM = QX(IPTR)#                         Get value of f-rel               BF41 264
IF(FP < 0. \ FM < 0.)#                 Check for input f void and       BF41 265
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BF41 266
NREJV1 = NREJV1 + 1.#                  Count rejected reflection.       BF41 267
NEXT#                                  Skip to next reflection          BF41 268
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BF41 269
IF (FM == 0. & CENREF == yes:) FP = FM#                                 BF41 270
IF (FSQAR == yes:)#                    If f**2 from bdf ...             BF41 271
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 BF41 272
FP = SQRT( FP )#                       F+ = sqrt( f+rel**2 )            BF41 273
FM = SQRT( FM )#                       F- = sqrt( f-rel**2 )            BF41 274
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 BF41 275
#                                                                       BF41 276
F = 0.5*(FP+FM)#                       To pass f range test,            BF41 277
IF(GETSIG == yes:)#                    Get sigma(f), if needed.         BF41 278
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 BF41 279
IPTR = IPT + PTSG11#                                                    BF41 280
SIGP = QX(IPTR)#                       Get sig(f) value                 BF41 281
IPTR = IPT + PTSG12#                                                    BF41 282
SIGM = QX(IPTR)#                       Get sig(f) value                 BF41 283
# ALL MUST BE (+)                                                       BF41 284
#     IF(FP == 0 \ FM == 0 \ SIGP == 0 \ SIGM == 0) #                   BF41 285
IF((ABS(FP) < small:) \ (ABS(FM) < small:) \ (ABS(SIGP) < small:) \ $#  BF41 286
(ABS(SIGM) < small:))#                                                  BF41 287
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 BF41 288
NREJSF = NREJSF + 1.#                  Count as f/sigma deletion        BF41 289
NEXT#                                                                   BF41 290
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 BF41 291
IF (SSQAR == yes:)#                    If sig(f)**2 from bdf ...        BF41 292
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 BF41 293
SIGP = SIGP/(2.*FP)#                   Compute sigma(f+)                BF41 294
SIGM = SIGM/(2.*FM)#                   Compute sigma(f-)                BF41 295
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 BF41 296
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 BF41 297
#                                                                       BF41 298
# USE LIMIT CHECKS TO REJECT                                            BF41 299
# --------------------------                                            BF41 300
#                                                                       BF41 301
IF(FP < SMALF1 \ FM < SMALF1 \ FP > BIGF1 \ FM > BIGF1)#                BF41 302
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 BF41 303
NREJF1 = NREJF1 + 1#                                                    BF41 304
NEXT#                                                                   BF41 305
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 BF41 306
#                                                                       BF41 307
ifnv:(SIGKF)#                          F/sigma ratio rejection          BF41 308
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 BF41 309
IF(FP < SIGKF*SIGP \ FM < SIGKF*SIGM)#                                  BF41 310
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 BF41 311
NREJSF = NREJSF + 1.#                                                   BF41 312
NEXT#                                                                   BF41 313
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 BF41 314
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 BF41 315
#                                                                       BF41 316
IF(F < SMALF1 \ F > BIGF1)#            Check range of f                 BF41 317
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 BF41 318
NREJF1 = NREJF1 + 1.#                                                   BF41 319
NEXT#                                                                   BF41 320
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 BF41 321
#                                                                       BF41 322
IF( FAZYN == yes: )#                                                    BF41 323
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 BF41 324
IF(PTFAZ!=0)#                          Using fc/phase info from file    BF41 325
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 BF41 326
rejfaz:(PTFAZ)#                        Reject reflec. because of        BF41 327
rejfaz:(PTFC)#                         Missing phase info?              BF41 328
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 BF41 329
ELSE#                                  Using sin/cos phase info         BF41 330
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 BF41 331
rejfaz:(PTCOS)#                        Reject reflec. because of        BF41 332
rejfaz:(PTSIN)#                        Missing phase info?              BF41 333
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 BF41 334
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 BF41 335
#                                                                       BF41 336
# CALCULATE COEFFICIENT                                                 BF41 337
# ---------------------                                                 BF41 338
#                                                                       BF41 339
COEF = (FP - FM)#                                                       BF41 340
ifnv:(SIGKCO)#                         Rejection on ratio               BF41 341
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 BF41 342
IF(ABS(COEF) < SIGKCO*SQRT(SIGP**2+SIGM**2))# Coef/sigma(coef).         BF41 343
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 BF41 344
NREJSC = NREJSC + 1.#                                                   BF41 345
NEXT#                                                                   BF41 346
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 BF41 347
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 BF41 348
#                                                                       BF41 349
COEF = SCALE*COEF#                     Scale the coefficient            BF41 350
IF(WTPTR != 0)#                        And apply weight, if so          BF41 351
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 BF41 352
IPTR = IPT + PTWT#                     Requested.                       BF41 353
IF(QX(IPTR) < 0.)  COEF = 0.#          Weight is void                   BF41 354
ELSE  COEF = QX(IPTR)*COEF#            Apply weight                     BF41 355
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 BF41 356
#                                                                       BF41 357
ifnv:(SMALCO)#                                                          BF41 358
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 BF41 359
IF(ABS(COEF) < SMALCO)#                                                 BF41 360
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 BF41 361
NREJCO = NREJCO + 1.#                  Count out of range refl. and     BF41 362
NEXT#                                  Skip to next reflection.         BF41 363
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 BF41 364
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 BF41 365
ifnv:(BIGCO)#                                                           BF41 366
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 BF41 367
IF(ABS(COEF) > BIGCO)#                                                  BF41 368
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 BF41 369
NREJCO = NREJCO + 1.#                  Count out of range refl. and     BF41 370
NEXT#                                  Skip to next reflection.         BF41 371
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 BF41 372
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 BF41 373
#                                                                       BF41 374
# FIND STATS ON COEFFICIENTS                                            BF41 375
# --------------------------                                            BF41 376
#                                                                       BF41 377
COEFAV = COEFAV + 0.5*ABS(COEF)#       Running sum of coefficients      BF41 378
COEFMN = AMIN1(COEFMN,0.5*ABS(COEF))#  Minimum coefficient              BF41 379
COEFMX = AMAX1(COEFMX,0.5*ABS(COEF))#  Maximum coefficient              BF41 380
#                                                                       BF41 381
# FILL OUTPUT BUFFER                                                    BF41 382
# ------------------                                                    BF41 383
#                                                                       BF41 384
NRFOUT = NRFOUT + 1.#                  Count output reflection          BF41 385
writepkt:(2,lrrefl:,PSIZE2,JPT)#       And write it.                    BF41 386
JPTHLD = JPT+1#                        Hold first qx output index       BF41 387
#                                                                       BF41 388
FOR(I=1; I <= 3 ; I=I+1)#              Copy basic quantities to         BF41 389
#                                         Output.                       BF41 390
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 BF41 391
JPT = JPT + 1#                         Bump output pointer              BF41 392
IPTR = OFFSET(I) + IPT#                Pointer to corresp input ite     BF41 393
QX(JPT) = QX(IPTR)#                    Load output buffer               BF41 394
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 BF41 395
JPT = JPT + 1#                         Bump output pointer              BF41 396
NEGFLG=0#                              Assume coeff not neg.            BF41 397
IF(COEF<0.) NEGFLG=1#                  Neg. coef needs special trmt     BF41 398
QX(JPT) = ABS(COEF)#                   Pos. coefficient to output       BF41 399
IF( FAZYN == yes: )#                   Output phase info if needed      BF41 400
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 BF41 401
IF(PTCOS!=0)#                          Put cos/sin phases in output     BF41 402
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 BF41 403
IPTR = IPT + PTSIN#                                                     BF41 404
QX(JPT+1) = QX(IPTR)*(-1)**NEGFLG#     Note: negate sin/cos only if     BF41 405
IPTR = IPT + PTCOS#                    Neg coeff value                  BF41 406
QX(JPT+2) = QX(IPTR)*(-1)**NEGFLG#                                      BF41 407
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 BF41 408
ELSE#                                                                   BF41 409
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 BF41 410
QX(JPT+1) = QX(IPT+PTFC)#              Put phase/fc to output           BF41 411
QX(JPT+2) = AMOD(QX(IPT+PTFAZ)+(0.5*NEGFLG),1.0)#                       BF41 412
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 BF41 413
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 BF41 414
QX(JPT) = 0.5*QX(JPT)#                                                  BF41 415
#                                       #                               BF41 416
IF(LMOD>0)#                            List option active               BF41 417
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 BF41 418
IF(MOD(INT(NRFOUT),LMOD)==0)#          List reflections requested       BF41 419
CALL BF56(JPTHLD,JPTHLD+3)#                                             BF41 420
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 BF41 421
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BF41 422
#                                                                       BF41 423
RETURN#                                                                 BF41 424
END#                                                                    BF41 425
systemheader:(BF42)#                                                    BF42   1
####################################################################### BF42   2
#                                                                     # BF42   3
#                              BF42                                   # BF42   4
#                                                                     # BF42   5
####################################################################### BF42   6
SUBROUTINE BF42#                       Subroutine to calculate          BF42   7
#                                         Isomorphous and combined      BF42   8
#                                         Coefficients.                 BF42   9
# NOTE: THIS ROUTINE HANDLES 2 COEFFICIENTS CALCULATIONS SINCE          BF42  10
#       THE PROCEDURES AND DATA NEEDED FROM BDF IS SO SIMILAR.          BF42  11
#                                                                       BF42  12
include:(AACOMN)#                                                       BF42  13
include:(BFCOMN)#                                                       BF42  14
#                                                                       BF42  15
INTEGER CENREF#                        Yes: if centric reflection       BF42  16
INTEGER CHPTR#                         Character position pointer       BF42  17
INTEGER I#                             Loop index                       BF42  18
INTEGER IH(3)#                         H,k,l as unpacked by b452        BF42  19
INTEGER IPT#                           Input packet pointer             BF42  20
INTEGER IPTR#                          Pointer to a particular inpu     BF42  21
#                                         Quantity.                     BF42  22
INTEGER IWANT(maxwant:)#               Catalogue numbers, lrrefl:       BF42  23
#                                         Want list.                    BF42  24
INTEGER JPT#                           Output packet pointer            BF42  25
INTEGER KEY(4)#                        Signal array for indexpkt:       BF42  26
INTEGER OFFSET(incr:(maxwant:))#       Offsets for lrrefl: items        BF42  27
INTEGER PSIZE1#                        Input packet size                BF42  28
INTEGER PSIZE2#                        Output packet size               BF42  29
INTEGER PTF11#                         Pointer to f+, set 1             BF42  30
INTEGER PTF12#                         Pointer to f-, set 1             BF42  31
INTEGER PTF21#                         Pointer to f+, set 2             BF42  32
INTEGER PTF22#                         Pointer to f-, set 2             BF42  33
INTEGER PTFAZ#                         Pointer to phase angle           BF42  34
INTEGER PTFC#                          Pointer to f(calc)               BF42  35
INTEGER PTWT#                          Pointer to weight; if zero,      BF42  36
#                                         Do not weight coefficients.   BF42  37
INTEGER REJECT#                        Bf52 arg, yes: for reject re     BF42  38
#                                                                       BF42  39
REAL COEF#                             Coefficient                      BF42  40
REAL F1#                               Mean f for 1st coefficient       BF42  41
REAL F2#                               Mean f for 2nd coefficient       BF42  42
REAL F11#                              F(+) parent                      BF42  43
REAL F12#                              F(-) parent                      BF42  44
REAL F21#                              F(+) derivative                  BF42  45
REAL F22#                              F(-) derivative                  BF42  46
REAL MPROD#                            Partial product for comb coe     BF42  47
REAL MPROD2#                           Partial product for comb coe     BF42  48
REAL STOLSQ#                           (sine(theta)/lambda)**2          BF42  49
chardata:(BF421, TRANSFORM TYPE. . .)##                                 BF42  50
chardata:(BF422, ISOMORPHOUS FOURIER)#                                  BF42  51
chardata:(BF423, COMBINED FOURIER)#                                     BF42  52
chardata:(BF424, PHASE SOURCE. . . .)##                                 BF42  53
chardata:(BF426, COEFFICIENT . . . . SCALE * WT * $#                    BF42  54
\(K1 * EXP(+B1*S) * F1  -  K2 * EXP(+B2*S) * F2)\)#                     BF42  55
chardata:(BF42Z, COEFFICIENT . . . . SCALE * WT * $#                    BF42  56
SQRT(F1**2+F2**2-2*F1*F2*(1-(WT2*MK*(F2(+)-F2(-))/2*F1)**2)**.5))#      BF42  57
chardata:(BF42Y,[               $#                                      BF42  58
        WHERE,  MK = MATK2 * EXP(MATB2*S)])#                            BF42  59
chardata:(BF427,    F1 FOR              )#                              BF42  60
chardata:(BF428,    F2 FOR              )#                              BF42  61
chardata:(BF429,     SCALE =       )#                                   BF42  62
chardata:(BF42A,    WEIGHT =            )#                              BF42  63
chardata:(BF42B,        K1 =       )#                                   BF42  64
chardata:(BF42C,        B1 =       )#                                   BF42  65
chardata:(BF42D,        K2 =       )#                                   BF42  66
chardata:(BF42E,        B2 =       )#                                   BF42  67
chardata:(BF42H,   MATT K1 =       )#                                   BF42  68
chardata:(BF42I,   MATT B1 =       )#                                   BF42  69
chardata:(BF42J,   MATT K2 =       )#                                   BF42  70
chardata:(BF42K,   MATT B2 =       )#                                   BF42  71
chardata:(BF42L,ANOMAL WT1 =       )#                                   BF42  72
chardata:(BF42M,ANOMAL WT2 =       )#                                   BF42  73
chardata:(BF42F,         S = (SIN(THETA)/LAMBDA)**2)#                   BF42  74
chardata:(BF42G,FOR DATA SET)#                                          BF42  75
intdata:(PTCOS,[0])#                   Pointer to cos(phase)            BF42  76
intdata:(PTSIN,[0])#                   Pointer to sin(phase)            BF42  77
realdata:(FMT421,[200842.])#           Formats                          BF42  78
realdata:(FMT422,[200822.])#           Formats                          BF42  79
DATA KEY(1),KEY(2),KEY(3),KEY(4)/3,maxwant:,0,0/#                       BF42  80
datastuff:#                                                             BF42  81
#                                                                       BF42  82
# BRING IN K, DELTA B/ MATTHEW K, MATTHEW B                             BF42  83
# -----------------------------------------                             BF42  84
#                                                                       BF42  85
CALL BF51#                             Bring in k and delta-b           BF42  86
#                                                                       BF42  87
# MAKE LRREFL: WANT LIST                                                BF42  88
# ----------------------                                                BF42  89
#                                                                       BF42  90
DO I=1,maxwant:#                       Set want list for hkl, sitol     BF42  91
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF42  92
IF(I <=  3)  IWANT(I) = I#             And eps/mult.                    BF42  93
ELSE  IWANT(I) = 0#                    Set the rest to zero.            BF42  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF42  95
#                                                                       BF42  96
IF(WTPTR != 0)  IWANT(indxwt:) = WTPTR## Add weight to want list        BF42  97
IWANT(indxf11:) = 1000*NSET1 + nmbfp:# F+ for set one                   BF42  98
IWANT(indxf12:) = 1000*NSET1 + nmbfm:# F- for set one                   BF42  99
IWANT(indxf11s:) = 1000*NSET1 + nmbfp: - 2# F+ **2 for set one          BF42 100
IWANT(indxf12s:) = 1000*NSET1 + nmbfm: - 2# F- **2 for set one          BF42 101
#                                                                       BF42 102
IWANT(indxf21:) = 1000*NSET2 + nmbfp:# F+ for set two                   BF42 103
IWANT(indxf22:) = 1000*NSET2 + nmbfm:# F- for set two                   BF42 104
IWANT(indxf21s:) = 1000*NSET2 + nmbfp: - 2# F+ **2 for set two          BF42 105
IWANT(indxf22s:) = 1000*NSET2 + nmbfm: - 2# F- **2 for set two          BF42 106
#                                                                       BF42 107
# CHECK TO SEE THAT PHASE LINE WAS ZERO                                 BF42 108
# -------------------------------------                                 BF42 109
#                                                                       BF42 110
IF( FAZYN == yes: )#                                                    BF42 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BF42 112
IF(PHNMBR(1) == 0 \ PHNMBR(2) == 0)  iquit:(-BF4201)#                   BF42 113
IWANT(indxcos:) = PHNMBR(1)#                                            BF42 114
IWANT(indxsin:) = PHNMBR(2)#                                            BF42 115
IWANT(indxfc:) = PHNMBR(3)#                                             BF42 116
IWANT(indxfaz:) = PHNMBR(4)#                                            BF42 117
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BF42 118
#                                                                       BF42 119
# LRREFL: DIRECTORY READ/WRITE                                          BF42 120
# ----------------------------                                          BF42 121
#                                                                       BF42 122
indexpkt:(1,lrrefl:,PSIZE1,IPT,0,KEY,IWANT,OFFSET)#                     BF42 123
IF(KEY(4) < 0)  iquit:(-BF4202)#                                        BF42 124
PSIZE2 = 4#                            Get size of output directory     BF42 125
IF( FAZYN == yes:) PSIZE2 = PSIZE2 + 2## Only output phase if needed    BF42 126
writepkt:(2,lrrefl:,PSIZE2,JPT)#       Write directory packet           BF42 127
DO I=1,3#                                                               BF42 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BF42 129
QX(JPT+I)=FLOAT(IWANT(I))#             Move catalogue numbers           BF42 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BF42 131
#                                                                       BF42 132
# GET F REL VALUES                                                      BF42 133
# ----------------                                                      BF42 134
#                                                                       BF42 135
# ## PARENT DATA ##                                                     BF42 136
#                                                                       BF42 137
PTF11 = OFFSET(indxf11:)#              Get f-rel offsets                BF42 138
PTF12 = OFFSET(indxf12:)#                                               BF42 139
IF(PTF11 == 0)  PTF11 = PTF12#                                          BF42 140
IF(PTF12 == 0)  PTF12 = PTF11#                                          BF42 141
FSQP = no:#                            Assume f in bdf                  BF42 142
IF(PTF11 == 0 & PTF12 == 0)#           Else check for f**2 in bdf       BF42 143
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BF42 144
PTF11 = OFFSET(indxf11s:)#             Get f-rel**2 offsets             BF42 145
PTF12 = OFFSET(indxf12s:)#                                              BF42 146
IF(PTF11 == 0)  PTF11 = PTF12#                                          BF42 147
IF(PTF12 == 0)  PTF12 = PTF11#                                          BF42 148
IF(PTF11 == 0 & PTF12 == 0) iquit:(-BF4203)# No set 1 f's is error      BF42 149
FSQP = yes:#                                                            BF42 150
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BF42 151
#                                                                       BF42 152
# ## DERIVATIVE DATA ##                                                 BF42 153
#                                                                       BF42 154
PTF21 = OFFSET(indxf21:)#              Get f-rel offsets                BF42 155
PTF22 = OFFSET(indxf22:)#                                               BF42 156
IF(PTF21 == 0)  PTF21 = PTF22#                                          BF42 157
IF(PTF22 == 0)  PTF22 = PTF21#                                          BF42 158
FSQD = no:#                            Assume f in bdf                  BF42 159
IF(PTF21 == 0 & PTF22 == 0)#           Else check for f**2 in bdf       BF42 160
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BF42 161
PTF21 = OFFSET(indxf21s:)#             Get f-rel**2 offsets             BF42 162
PTF22 = OFFSET(indxf22s:)#                                              BF42 163
IF(PTF21 == 0)  PTF21 = PTF22#                                          BF42 164
IF(PTF22 == 0)  PTF22 = PTF21#                                          BF42 165
IF(PTF21 == 0 & PTF22 == 0) iquit:(-BF4204)# No set 2 f's is error      BF42 166
FSQD = yes:#                                                            BF42 167
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BF42 168
QX(JPT+4) = fnmb:#                     F id for output directory        BF42 169
#                                                                       BF42 170
# NO PHASES IS AN ERROR IF PHASE LINE USED                              BF42 171
# ----------------------------------------                              BF42 172
#                                                                       BF42 173
IF( FAZYN == yes: )#                                                    BF42 174
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BF42 175
IF(OFFSET(indxfaz:)!=0)#               Item 1700/1800 in bdf            BF42 176
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BF42 177
QX(JPT+5) = phnmbfc:#                                                   BF42 178
QX(JPT+6) = phnmbfaz:#                                                  BF42 179
OFFSET(indxcos:)=0##                                                    BF42 180
OFFSET(indxsin:)=0##                                                    BF42 181
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BF42 182
ELSE#                                                                   BF42 183
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BF42 184
IF(OFFSET(indxcos:)==0 \ OFFSET(indxsin:)==0) iquit:(-BF4104)#          BF42 185
QX(JPT+5) = phnmbcos:#                 Phase id numbers for output      BF42 186
QX(JPT+6) = phnmbsin:#                 Directory.                       BF42 187
OFFSET(indxfaz:)=0##                                                    BF42 188
OFFSET(indxfc:)=0##                                                     BF42 189
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BF42 190
PTCOS = OFFSET(indxcos:)#              Offset for cos(phase)            BF42 191
PTSIN = OFFSET(indxsin:)#              Offset for sin(phase)            BF42 192
PTFAZ = OFFSET(indxfaz:)#              Offset for phase(cycles)         BF42 193
PTFC  = OFFSET(indxfc:)#               Offset for fc                    BF42 194
JPT=JPT+2#                             Add 2 entries to output          BF42 195
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BF42 196
#                                                                       BF42 197
IF(WTPTR != 0)#                        Check weights                    BF42 198
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BF42 199
PTWT = OFFSET(indxwt:)#                They are to be used, therefo     BF42 200
IF(PTWT == 0)  iquit:(-BF4206)#        They have to be on the bdf.      BF42 201
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BF42 202
ELSE  PTWT = 0#                        Weights are not to be used       BF42 203
#                                                                       BF42 204
# WRITE COEFFICIENT DESCRIPTION ON LINE OUTPUT                          BF42 205
# --------------------------------------------                          BF42 206
# ** SOME OUTPUT IS DEPENDENT ON FTYPE = 2/3                            BF42 207
# --------------------------------------------                          BF42 208
#                                                                       BF42 209
movechar:(BF421,1,CHROT,1,NBF421,0)#   Beginning of lead line           BF42 210
IF(FTYPE==2) movechar:(BF422,1,CHROT,NBF421+1,NBF422,0)#                BF42 211
IF(FTYPE==3) movechar:(BF423,1,CHROT,NBF421+1,NBF423,0)#                BF42 212
#MOVECHAR:(BF423,1,CHROT,NBF421+1,NBF423,0)#                            BF42 213
writeline:(1,0,0,1,3)#                 Write out lead line              BF42 214
#                                                                       BF42 215
IF( FAZYN == yes: )#                                                    BF42 216
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BF42 217
movechar:(BF424,1,CHROT,1,NBF424,0)#   Assemble phase line              BF42 218
movechar:(PHAZWD,1,CHROT,NBF424+2,lphazwd:,0)#                          BF42 219
IF(FAZNUM > 0)#                                                         BF42 220
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BF42 221
CHPTR = NBF424 + lphazwd: + 3#         Get the right column             BF42 222
movechar:(BF42G,1,CHROT,CHPTR,NBF42G,0)#                                BF42 223
CHPTR = CHPTR + NBF42G + 1#                                             BF42 224
movechar:(IDFAZ,1,CHROT,CHPTR,12,0)#                                    BF42 225
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BF42 226
writeline:(1,0,0,1,3)#                 Write out phase line             BF42 227
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BF42 228
#                                                                       BF42 229
IF(FTYPE == 2)#                                                         BF42 230
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BF42 231
movechar:(BF426,1,CHROT,1,NBF426,0)#   Describe isomorphous coeff       BF42 232
writeline:(1,0,0,1,3)#                                                  BF42 233
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BF42 234
ELSE#                                                                   BF42 235
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BF42 236
movechar:(BF42Z,1,CHROT,1,NBF42Z,0)#   Describe combined coeff          BF42 237
writeline:(1,0,0,1,3)#                                                  BF42 238
movechar:(BF42Y,1,CHROT,1,NBF42Y,0)#                                    BF42 239
writeline:(0,0,0,1,3)#                                                  BF42 240
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BF42 241
#                                                                       BF42 242
movechar:(IDSET1,1,BF427,13,12,0)#     Data set for f1                  BF42 243
writeline:(1,BF427,NBF427,3,3)#                                         BF42 244
#                                                                       BF42 245
movechar:(BF428,1,CHROT,1,NBF428,0)#   Data set for f2                  BF42 246
movechar:(IDSET2,1,CHROT,13,12,0)#                                      BF42 247
writeline:(1,0,0,1,3)#                                                  BF42 248
#                                                                       BF42 249
BUFOT(1) = SCALE#                                                       BF42 250
ncodefld:(BUFOT,1,BF429,FMT421,1)#     Scale                            BF42 251
writeline:(1,BF429,NBF429,3,3)#                                         BF42 252
#                                                                       BF42 253
movechar:(IDWT,1,BF42A,14,12,0)#       Weight                           BF42 254
writeline:(0,BF42A,NBF42A,3,3)#                                         BF42 255
#                                                                       BF42 256
BUFOT(1) = K1#                                                          BF42 257
ncodefld:(BUFOT,1,BF42B,FMT421,1)#     K1                               BF42 258
writeline:(0,BF42B,NBF42B,3,3)#                                         BF42 259
#                                                                       BF42 260
BUFOT(1) = DB1#                                                         BF42 261
ncodefld:(BUFOT,1,BF42C,FMT421,1)#     Db1                              BF42 262
writeline:(0,BF42C,NBF42C,3,3)#                                         BF42 263
#                                                                       BF42 264
BUFOT(1) = K2#                                                          BF42 265
ncodefld:(BUFOT,1,BF42D,FMT421,1)#     K2                               BF42 266
writeline:(0,BF42D,NBF42D,3,3)#                                         BF42 267
#                                                                       BF42 268
BUFOT(1) = DB2#                                                         BF42 269
ncodefld:(BUFOT,1,BF42E,FMT421,1)#     Db2                              BF42 270
writeline:(0,BF42E,NBF42E,3,3)#                                         BF42 271
IF(FTYPE==3)#                                                           BF42 272
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BF42 273
BUFOT(1) = MATTK1#                                                      BF42 274
ncodefld:(BUFOT,1,BF42H,FMT421,1)#     Matthew k1                       BF42 275
writeline:(1,BF42H,NBF42H,3,3)#                                         BF42 276
#                                                                       BF42 277
BUFOT(1) = MATTB1#                                                      BF42 278
ncodefld:(BUFOT,1,BF42I,FMT421,1)#     Matthew db1                      BF42 279
writeline:(0,BF42I,NBF42I,3,3)#                                         BF42 280
#                                                                       BF42 281
BUFOT(1) = WT1#                                                         BF42 282
ncodefld:(BUFOT,1,BF42L,FMT421,1)#     Anomalous wt                     BF42 283
writeline:(0,BF42L,NBF42L,3,3)#                                         BF42 284
#                                                                       BF42 285
BUFOT(1) = MATTK2#                                                      BF42 286
ncodefld:(BUFOT,1,BF42J,FMT421,1)#     K2                               BF42 287
writeline:(0,BF42J,NBF42J,3,3)#                                         BF42 288
#                                                                       BF42 289
BUFOT(1) = MATTB2#                                                      BF42 290
ncodefld:(BUFOT,1,BF42K,FMT421,1)#     Db2                              BF42 291
writeline:(0,BF42K,NBF42K,3,3)#                                         BF42 292
#                                                                       BF42 293
BUFOT(1) = WT2#                                                         BF42 294
ncodefld:(BUFOT,1,BF42M,FMT421,1)#     Anomalous wt                     BF42 295
writeline:(0,BF42M,NBF42M,3,3)#                                         BF42 296
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BF42 297
#                                                                       BF42 298
writeline:(1,BF42F,NBF42F,3,3)#        Sitol                            BF42 299
#                                                                       BF42 300
# IF ANY ERRORS HAVE BEEN ENCOUNTERED, DIE HERE                         BF42 301
# ---------------------------------------------                         BF42 302
#                                                                       BF42 303
IF(QUITF(1^1)!=' ')   iquit:(BF4299)#                                   BF42 304
#                                                                       BF42 305
# BEGIN LOOP TO READ REFLECTIONS                                        BF42 306
# ------------------------------                                        BF42 307
#                                                                       BF42 308
IF(LMOD!=0) LINCT = 0#                 Force new page                   BF42 309
REPEAT#                                                                 BF42 310
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BF42 311
readwpkt:(1,lrrefl:,PSIZE1,IPT,0)#                                      BF42 312
IF(IPT <= 0)  BREAK#                                                    BF42 313
NRFIN = NRFIN + 1.#                    Count input reflections          BF42 314
#                                                                       BF42 315
# CHECK FOR CENTRIC REFLECTION                                          BF42 316
# ----------------------------                                          BF42 317
# NOTE STARTS, ENDREF FROM COMMON                                       BF42 318
#                                                                       BF42 319
CALL BF55(IPT+OFFSET(1),STARTS,ENDSYM,CENREF)#                          BF42 320
#                                                                       BF42 321
#                                                                       BF42 322
IPTR = IPT + OFFSET(2)#                                                 BF42 323
SITOL = QX(IPTR)#                      Sine(theta)/lambda               BF42 324
IPTR = IPT + OFFSET(1)#                Pointer to packed hkl            BF42 325
CALL BF52(QX(IPTR),IH,REJECT)#         Check for refl. rejection        BF42 326
IF(REJECT == yes:) NEXT#                                                BF42 327
#                                                                       BF42 328
# CALCULATE F FOR PARENT                                                BF42 329
# ----------------------                                                BF42 330
#                                                                       BF42 331
CALL BF53(IPT,PTF11,PTF12,F1,F11,F12,CENREF,FSQP)#                      BF42 332
#                                                                       BF42 333
# CHECK FOR REJECTION                                                   BF42 334
# -------------------                                                   BF42 335
#                                                                       BF42 336
IF(F1 <= 0.)#                          Check for all input f missing    BF42 337
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 BF42 338
NREJV1 = NREJV1 + 1.#                  And count rejected refls.        BF42 339
NEXT#                                  Skip to next reflection          BF42 340
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 BF42 341
#                                                                       BF42 342
IF(F1 < SMALF1 \ F1 > BIGF1)#          Check for f1 in range            BF42 343
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 BF42 344
NREJF1 = NREJF1 + 1.#                  Count out of range ref and       BF42 345
NEXT#                                  Skip to next refl.               BF42 346
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 BF42 347
#                                                                       BF42 348
# CALCULATE F FOR DERIVATIVE                                            BF42 349
# ----------------------                                                BF42 350
#                                                                       BF42 351
CALL BF53(IPT,PTF21,PTF22,F2,F21,F22,CENREF,FSQD)#                      BF42 352
#                                                                       BF42 353
# CHECK REFLECTION FOR REJECTION                                        BF42 354
# ------------------------------                                        BF42 355
#                                                                       BF42 356
IF(F2 <= 0.)#                          Check for all input f missing    BF42 357
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 BF42 358
NREJV2 = NREJV2 + 1.#                  And count rejected reflectio     BF42 359
NEXT#                                  Skip to next reflection          BF42 360
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 BF42 361
#                                                                       BF42 362
IF(F2 < SMALF2 \ F2 > BIGF2)#          Check for f in range             BF42 363
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 BF42 364
NREJF2 = NREJF2 + 1.#                  It's out, count it and skip      BF42 365
NEXT#                                  To next refl.                    BF42 366
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 BF42 367
#                                                                       BF42 368
IF( FAZYN == yes: )#                   Check phase info if needed       BF42 369
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 BF42 370
IF(PTFAZ!=0)#                          Using fc/phase info from file    BF42 371
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 BF42 372
rejfaz:(PTFAZ)#                        Reject reflec. because of        BF42 373
rejfaz:(PTFC)#                         Missing phase info?              BF42 374
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 BF42 375
ELSE#                                  Using sin/cos phase info         BF42 376
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 BF42 377
rejfaz:(PTCOS)#                        Reject reflec. because of        BF42 378
rejfaz:(PTSIN)#                        Missing phase info?              BF42 379
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 BF42 380
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 BF42 381
#                                                                       BF42 382
STOLSQ = SITOL**2#                     Construct the coefficient        BF42 383
#                                                                       BF42 384
### CALCULATE ISOMORPHOUS COEFF                                         BF42 385
#   ---------------------------                                         BF42 386
#                                                                       BF42 387
IF(FTYPE==2)#                                                           BF42 388
COEF = (SCALE*(K1*EXP(DB1*STOLSQ)*F1-K2*EXP(DB2*STOLSQ)*F2))#           BF42 389
#                                                                       BF42 390
### CALCULATE COMBINED    COEFF                                         BF42 391
#   ---------------------------                                         BF42 392
#                                                                       BF42 393
IF(FTYPE==3)#                                                           BF42 394
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 BF42 395
S1 = K1 * EXP(DB1*STOLSQ)#             Scaling for parent to derivati   BF42 396
S2 = K2 * EXP(DB2*STOLSQ)#             Scaling for derivative to pare   BF42 397
MPROD = MATTK2*EXP(MATTB2*STOLSQ)#     Partial product                  BF42 398
MPROD2 = 1.0-(WT2*MPROD*(F21*S2-F22*S2)/(2*F1*S1))**2#                  BF42 399
IF (MPROD2 < 0.0)#                     Negative radican                 BF42 400
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 BF42 401
NREJCO = NREJCO + 1.0#                 Reject as illegal coeff          BF42 402
NEXT#                                                                   BF42 403
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 BF42 404
MPROD2 = MPROD2 ** .5#                                                  BF42 405
COEF = ((F1*S1)**2+(F2*S2)**2-2.0*(F1*S1)*(F2*S2)*MPROD2)#              BF42 406
IF(COEF < 0.0)#                                                         BF42 407
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 BF42 408
NREJCO = NREJCO + 1.0#                                                  BF42 409
NEXT#                                  Neg coeff. skip reflection       BF42 410
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 BF42 411
COEF = SCALE * (COEF ** .5)#           Apply overall scale factor       BF42 412
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 BF42 413
#                                                                       BF42 414
IF(WTPTR != 0)#                        Apply weight, if so requeste     BF42 415
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 BF42 416
IPTR = IPT + PTWT#                                                      BF42 417
IF(QX(IPTR) < 0.)  COEF = 0.#          Weight is void                   BF42 418
ELSE  COEF = QX(IPTR)*COEF#            Apply weight                     BF42 419
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 BF42 420
#                                                                       BF42 421
# CHECK FOR REJECTIONS                                                  BF42 422
# ----------------------                                                BF42 423
#                                                                       BF42 424
ifnv:(SMALCO)#                                                          BF42 425
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 BF42 426
IF(ABS(COEF) < SMALCO)#                                                 BF42 427
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 BF42 428
NREJCO = NREJCO + 1.#                  Count out of range refl. and     BF42 429
NEXT#                                  Skip to next refl.               BF42 430
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 BF42 431
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 BF42 432
#                                                                       BF42 433
ifnv:(BIGCO)#                                                           BF42 434
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 BF42 435
IF(ABS(COEF) > BIGCO)#                                                  BF42 436
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 BF42 437
NREJCO = NREJCO + 1.#                  Count out of range refl. and     BF42 438
NEXT#                                  Skip to next refl.               BF42 439
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 BF42 440
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 BF42 441
#                                                                       BF42 442
# FIND STATS ON COEFFICIENTS                                            BF42 443
# --------------------------                                            BF42 444
#                                                                       BF42 445
COEFAV = COEFAV + ABS(COEF)#           Running sum of coefficients      BF42 446
COEFMN = AMIN1(COEFMN,ABS(COEF))#      Minimum coefficient              BF42 447
COEFMX = AMAX1(COEFMX,ABS(COEF))#      Maximum coefficient              BF42 448
#                                                                       BF42 449
# FILL LRREFL: OUTPUT BUFFER                                            BF42 450
# --------------------------                                            BF42 451
#                                                                       BF42 452
NRFOUT = NRFOUT + 1.#                  Count output reflection          BF42 453
writepkt:(2,lrrefl:,PSIZE2,JPT)#       And write it.                    BF42 454
JPTHLD = JPT + 1#                      Index of first output value      BF42 455
#                                                                       BF42 456
FOR(I=1; I <= 3; I=I+1)#               Copy basic quantities to         BF42 457
#                                         Output.                       BF42 458
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 BF42 459
JPT = JPT + 1#                         Bump output pointer              BF42 460
IPTR = OFFSET(I) + IPT#                Pointer to corresp input ite     BF42 461
QX(JPT) = QX(IPTR)#                    Load output buffer               BF42 462
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 BF42 463
JPT = JPT + 1#                         Bump output pointer              BF42 464
NEGFLG = 0#                            Assume coef not negative         BF42 465
IF (COEF<0.) NEGFLG=1#                 Neg. coef needs special trmt     BF42 466
QX(JPT) = ABS(COEF)#                   Coefficient to output            BF42 467
IF( FAZYN == yes:)#                    Output phase info if needed      BF42 468
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 BF42 469
IF(PTCOS!=0)#                          Output sin/cos phases            BF42 470
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 BF42 471
IPTR = IPT + PTCOS#                                                     BF42 472
QX(JPT+1) = QX(IPTR)*(-1)**NEGFLG#     Note: negate sin/cos only        BF42 473
IPTR = IPT + PTSIN#                    If coeff is neg.                 BF42 474
QX(JPT+2) = QX(IPTR)*(-1)**NEGFLG#                                      BF42 475
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 BF42 476
ELSE#                                  Output phases in cycles          BF42 477
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 BF42 478
QX(JPT+1) = QX(IPT+PTFC)#                                               BF42 479
QX(JPT+2) = AMOD(QX(IPT+PTFAZ)+(NEGFLG*0.5),1.)#                        BF42 480
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 BF42 481
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 BF42 482
IF(LMOD>0)#                            List option active               BF42 483
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 BF42 484
IF(MOD(INT(NRFOUT),LMOD)==0)#          List requested reflections       BF42 485
CALL BF56(JPTHLD,JPTHLD+3)#                                             BF42 486
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 BF42 487
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BF42 488
#                                                                       BF42 489
RETURN#                                                                 BF42 490
END#                                                                    BF42 491
systemheader:(BF51)#                                                    BF51   1
####################################################################### BF51   2
#                                                                     # BF51   3
#                              BF51                                   # BF51   4
#                                                                     # BF51   5
####################################################################### BF51   6
SUBROUTINE BF51#                       Subroutine to get k/db  or       BF51   7
#                                         Matthew k/db (if ftype=3)     BF51   8
#                                         Either from the bdf lrrefl:   BF51   9
#                                         Or from a previously          BF51  10
#                                         Read kbd line.                BF51  11
include:(AACOMN)#                                                       BF51  12
include:(BFCOMN)#                                                       BF51  13
#                                                                       BF51  14
# GET SCALE AND DELTA B                                                 BF51  15
# ----------------------                                                BF51  16
#                                                                       BF51  17
ifvo:(K1)#                             Only if the scale is vo will     BF51  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF51  19
K1  =  KBDF(NSET1)#                    The values for k and db need     BF51  20
DB1 = DBBDF(NSET1)#                    Be brought in from the bdf.      BF51  21
ifvo:(K1) K1 = 1.0#                                                     BF51  22
ifvo:(DB1) DB1 = 0.0#                                                   BF51  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF51  24
#                                                                       BF51  25
ifvo:(K2)#                                                              BF51  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BF51  27
K2  =  KBDF(NSET2)#                                                     BF51  28
DB2 = DBBDF(NSET2)#                                                     BF51  29
ifvo:(K2) K2 = 1.0#                                                     BF51  30
ifvo:(DB2) DB2 = 0.0#                                                   BF51  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BF51  32
#                                                                       BF51  33
# GET MATTHEW SCALE AND DELTA B FOR COMBINED COEFF                      BF51  34
# ------------------------------------------------                      BF51  35
#                                                                       BF51  36
IF (FTYPE==3)#                                                          BF51  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BF51  38
ifvo:(MATTK1)#                         Check parent matt data           BF51  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BF51  40
MATTK1  =  MKBDF(NSET1)#               If no kdb line, use bdf          BF51  41
MATTB1 = MBBDF(NSET1)#                                                  BF51  42
ifvo:(MATTK1)#                         Are bdf values void too?         BF51  43
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BF51  44
MATTK1 = 1.0#                          Yes, use default values          BF51  45
MATTB1 = 0.0#                                                           BF51  46
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BF51  47
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BF51  48
#                                                                       BF51  49
ifvo:(MATTK2)#                         Check deriv matthew data         BF51  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BF51  51
MATTK2  =  MKBDF(NSET2)#               If no kdb line, use bdf          BF51  52
MATTB2 = MBBDF(NSET2)#                                                  BF51  53
ifvo:(MATTK2) iquit:(-BF5101)#         Are bdf values void too?         BF51  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BF51  55
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BF51  56
#                                                                       BF51  57
RETURN#                                                                 BF51  58
END#                                                                    BF51  59
systemheader:(BF52)#                                                    BF52   1
####################################################################### BF52   2
#                                                                     # BF52   3
#                              BF52                                   # BF52   4
#                                                                     # BF52   5
####################################################################### BF52   6
SUBROUTINE BF52(HKL,IH,REJECT)#        Subroutine to check              BF52   7
#                                         Sin theta and hkl limits.     BF52   8
include:(AACOMN)#                                                       BF52   9
include:(BFCOMN)#                                                       BF52  10
#                                                                       BF52  11
INTEGER IH(3)#                         Reflection indices               BF52  12
INTEGER K#                             Loop index                       BF52  13
INTEGER N#                             Bit index                        BF52  14
INTEGER REJECT#                        Set to yes: for rejects          BF52  15
REAL HKL#                              Packed hkl from qx array         BF52  16
#                                                                       BF52  17
REJECT = no:#                                                           BF52  18
# EXTRACT HKL                                                           BF52  19
#                                                                       BF52  20
DO K=1,3#                              Loop over h,k,l                  BF52  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF52  22
N = (3-K)*9 + 3#                       Set bit index                    BF52  23
intunpak:(HKL,IH(K),N,9)#              Get out each index               BF52  24
intunpak:(HKL,N,3-K,1)#                Pick out sign of each index      BF52  25
IF(N != 0)  IH(K) = -IH(K)#            Flip the sign                    BF52  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF52  27
#                                                                       BF52  28
DO K=1,3#                              Check hkl limits                 BF52  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BF52  30
IF(IH(K) < SMALIH(K) \ IH(K) > BIGIH(K))#                               BF52  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BF52  32
NREJH = NREJH + 1.#                                                     BF52  33
REJECT = yes:#                                                          BF52  34
BREAK#                                                                  BF52  35
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BF52  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BF52  37
#                                                                       BF52  38
IF(REJECT == no:)#                     If hkl limits ok, check sito     BF52  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BF52  40
IF(SITOL < SMALST \ SITOL > BIGST)#                                     BF52  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BF52  42
NREJST = NREJST + 1.#                                                   BF52  43
REJECT = yes:#                                                          BF52  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BF52  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BF52  46
#                                                                       BF52  47
RETURN#                                                                 BF52  48
END#                                                                    BF52  49
systemheader:(BF53)#                   Get the mean                     BF53   1
####################################################################### BF53   2
#                                                                     # BF53   3
#                              BF53                                   # BF53   4
#                                                                     # BF53   5
####################################################################### BF53   6
SUBROUTINE BF53(IPT,PTF1,PTF2,F,FP,FM,CR,SQAR)#                         BF53   7
include:(AACOMN)#                                                       BF53   8
include:(BFCOMN)#                                                       BF53   9
#                                                                       BF53  10
INTEGER CR#                            Yes: if centric reflection       BF53  11
INTEGER IPT#                           Input packet pointer             BF53  12
INTEGER IPTR#                          Pointer to a particular f        BF53  13
INTEGER PTF1#                          Offset for f1                    BF53  14
INTEGER PTF2#                          Offset for f2                    BF53  15
INTEGER SQAR#                          Flag for squared f values        BF53  16
REAL F#                                Output mean f                    BF53  17
REAL FP#                               F(+)                             BF53  18
REAL FM#                               F(-)                             BF53  19
#                                                                       BF53  20
### ASSUME F(+) PRESENT                                                 BF53  21
IPTR = IPT + PTF1#                     Index for first f (f+)           BF53  22
F = QX(IPTR)#                                                           BF53  23
IF (SQAR == yes: & F >= 0.0) F = SQRT(F)#                               BF53  24
FP = F#                                                                 BF53  25
IF(PTF2 != 0)#                         Zero pointer means only 1 f      BF53  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF53  27
IPTR = IPT + PTF2#                     Index for second f (f-)          BF53  28
#                                                                       BF53  29
#### F(+) VOID; SET F(+) = F(-)                                         BF53  30
IF(F < 0.)#                                                             BF53  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BF53  32
F = QX(IPTR)#                          If f1 void, set to f2            BF53  33
IF (SQAR == yes: & F >= 0.) F = SQRT(F)#                                BF53  34
FP = F#                                                                 BF53  35
FM = F#                                                                 BF53  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BF53  37
#                                                                       BF53  38
#### TWO F'S; SET F TO THEIR MEAN                                       BF53  39
ELSE  IF(QX(IPTR) >= 0.  &  CR == no:)#                                 BF53  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BF53  41
IF (SQAR == no:) FM = QX(IPTR)#                                         BF53  42
ELSE FM = SQRT( QX(IPTR) )#                                             BF53  43
F = 0.5*(F+FM)#                                                         BF53  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BF53  45
#                                                                       BF53  46
### F(-) = 0                                                            BF53  47
ELSE FM = FP#                                                           BF53  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF53  49
#                                                                       BF53  50
RETURN#                                                                 BF53  51
END#                                                                    BF53  52
systemheader:(BF54)#                                                    BF54   1
####################################################################### BF54   2
#                                                                     # BF54   3
#                              BF54                                   # BF54   4
#                                                                     # BF54   5
####################################################################### BF54   6
SUBROUTINE BF54#                       Subroutine to list               BF54   7
#                                         Reflection counts.            BF54   8
include:(AACOMN)#                                                       BF54   9
include:(BFCOMN)#                                                       BF54  10
#                                                                       BF54  11
chardata:(BF54E,         = MINIMUM COEFFICIENT)#                        BF54  12
chardata:(BF54F,         = MAXIMUM COEFFICIENT)#                        BF54  13
chardata:(BF54G,         = AVERAGE COEFFICIENT)#                        BF54  14
chardata:(BF541,        REFLECTIONS INPUT.)#                            BF54  15
chardata:(BF542,        REFLECTIONS OUTPUT.)#                           BF54  16
chardata:(BF543, OUT-OF-RANGE REFLECTION REJECTION COUNTS)#             BF54  17
chardata:(BF544,        SIN(THETA)/LAMBDA)#                             BF54  18
chardata:(BF545,        H$,K$,L)#                                       BF54  19
chardata:(BF546,        COEFFICIENT)#                                   BF54  20
chardata:(BF547,        F FOR DATA SET 1)#                              BF54  21
chardata:(BF548,        REFLECTIONS NOT USED BECAUSE OF MISSING F $#    BF54  22
IN DATA SET 1)#                                                         BF54  23
chardata:(BF549,        REFLECTIONS NOT USED BECAUSE OF MISSING $#      BF54  24
PHASES)#                                                                BF54  25
chardata:(BF54A,        F < K*SIGMA(F))#                                BF54  26
chardata:(BF54B,        COEF < K*SIGMA(COEF))#                          BF54  27
realdata:(NUMBER,[1.,2.])#             Real data set numbers            BF54  28
realdata:(FMT541,[70613.,240113.,630113.])# Formats                     BF54  29
datastuff:#                                                             BF54  30
#                                                                       BF54  31
COEFAV = COEFAV/ NRFOUT#               Average value for coeff          BF54  32
#                                                                       BF54  33
ncodefld:(COEFMN,1,BF54E,80832.,1)#    Minimum value for coeff          BF54  34
writeline:(3,BF54E,NBF54E,3,3)#                                         BF54  35
ncodefld:(COEFMX,1,BF54F,80832.,1)#    Maximum value for coeff          BF54  36
writeline:(0,BF54F,NBF54F,3,3)#                                         BF54  37
ncodefld:(COEFAV,1,BF54G,80832.,1)#    Average value for coeff          BF54  38
writeline:(0,BF54G,NBF54G,3,3)#                                         BF54  39
#                                                                       BF54  40
BUFOT(1) = NRFIN#                                                       BF54  41
ncodefld:(BUFOT,1,BF541,FMT541(1),1)#                                   BF54  42
writeline:(1,BF541,NBF541,3,3)#                                         BF54  43
BUFOT(1) = NRFOUT#                                                      BF54  44
ncodefld:(BUFOT,1,BF542,FMT541(1),1)#                                   BF54  45
writeline:(0,BF542,NBF542,3,3)#                                         BF54  46
writeline:(1,BF543,NBF543,3,3)#                                         BF54  47
BUFOT(1) = NREJST#                                                      BF54  48
ncodefld:(BUFOT,1,BF544,FMT541(1),1)#                                   BF54  49
writeline:(0,BF544,NBF544,3,3)#                                         BF54  50
BUFOT(1) = NREJH#                                                       BF54  51
ncodefld:(BUFOT,1,BF545,FMT541(1),1)#                                   BF54  52
writeline:(0,BF545,NBF545,3,3)#                                         BF54  53
BUFOT(1) = NREJCO#                                                      BF54  54
ncodefld:(BUFOT,1,BF546,FMT541(1),1)#                                   BF54  55
writeline:(0,BF546,NBF546,3,3)#                                         BF54  56
BUFOT(1) = NREJF1#                                                      BF54  57
ncodefld:(BUFOT,1,BF547,FMT541(1),1)#                                   BF54  58
ncodefld:(NUMBER,1,BF547,FMT541(2),1)#                                  BF54  59
writeline:(0,BF547,NBF547,3,3)#                                         BF54  60
BUFOT(1) = NREJSF#                                                      BF54  61
ncodefld:(BUFOT,1,BF54A,FMT541(1),1)#                                   BF54  62
writeline:(0,BF54A,NBF54A,3,3)#                                         BF54  63
BUFOT(1) = NREJSC#                                                      BF54  64
ncodefld:(BUFOT,1,BF54B,FMT541(1),1)#                                   BF54  65
writeline:(0,BF54B,NBF54B,3,3)#                                         BF54  66
#                                                                       BF54  67
IF(FTYPE == 2 \ FTYPE == 3)#           Difference maps                  BF54  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF54  69
BUFOT(1) = NREJF2#                                                      BF54  70
ncodefld:(BUFOT,1,BF547,FMT541(1),1)#                                   BF54  71
ncodefld:(NUMBER,2,BF547,FMT541(2),1)#                                  BF54  72
writeline:(0,BF547,NBF547,3,3)#                                         BF54  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF54  74
#                                                                       BF54  75
ncodefld:(NUMBER,1,BF548,FMT541(3),1)#                                  BF54  76
BUFOT(1) = NREJV1#                                                      BF54  77
ncodefld:(BUFOT,1,BF548,FMT541(1),1)#                                   BF54  78
writeline:(1,BF548,NBF548,3,3)#                                         BF54  79
#                                                                       BF54  80
IF(FTYPE == 2 \ FTYPE == 3)#           2 possible data sets             BF54  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BF54  82
ncodefld:(NUMBER,2,BF548,FMT541(3),1)#                                  BF54  83
BUFOT(1) = NREJV2#                                                      BF54  84
ncodefld:(BUFOT,1,BF548,FMT541(1),1)#                                   BF54  85
writeline:(0,BF548,NBF548,3,3)#                                         BF54  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BF54  87
#                                                                       BF54  88
BUFOT(1) = NREJPH#                                                      BF54  89
ncodefld:(BUFOT,1,BF549,FMT541(1),1)#                                   BF54  90
writeline:(1,BF549,NBF549,3,3)#                                         BF54  91
#                                                                       BF54  92
RETURN#                                                                 BF54  93
END#                                                                    BF54  94
systemheader:(BF55)#                   Find centric reflections         BF55   1
####################################################################### BF55   2
#                                                                     # BF55   3
#                               BF55                                  # BF55   4
#                                                                     # BF55   5
####################################################################### BF55   6
SUBROUTINE BF55(IPT,IS,IE,CFLG)#       J.m. stewart june 1986           BF55   7
# ROUTINE TO DETERMINE WHICH REFLECTIONS ARE 'CENTRIC'  I.E. HAVE       BF55   8
# STRUCTURE FACTORS IN  WHICH THE IMAGINARY TERM IS ZERO BY SYMMETRY.   BF55   9
include:(AACOMN)#                                                       BF55  10
#                                                                       BF55  11
INTEGER  IPT#         ## Pointer to packed hkl in qx                    BF55  12
INTEGER  IS#          ## Start of symops in qx array                    BF55  13
INTEGER  IE#          ## End of symops in qx array                      BF55  14
INTEGER  J#           ## Loop index                                     BF55  15
INTEGER  CFLG#        ## Flag to be set yes:/no:                        BF55  16
#                     ##   CENTRIC/NON CENTRIC                          BF55  17
REAL     HKL(3)#      ## Miller indices of current reflection           BF55  18
REAL     HKLP(3)#     ## Miller indices of generated reflection         BF55  19
#                                                                       BF55  20
gethkl:(IPT,HKL)#                      Unpact hkl                       BF55  21
CFLG = no:#                            Assume not centric               BF55  22
DO  J= IS, IE, 12#                     Loop over all symops             BF55  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF55  24
HKLP(1) = HKL(1)*QX(J+1) $#            Transform h                      BF55  25
          + HKL(2)*QX(J+2) $#                                           BF55  26
          + HKL(3)*QX(J+3)#                                             BF55  27
ifne:((HKLP(1)+HKL(1)),0.0) NEXT#      Not possible - try next          BF55  28
HKLP(2) = HKL(1)*QX(J+4) $#            Transform k                      BF55  29
          + HKL(2)*QX(J+5) $#                                           BF55  30
          + HKL(3)*QX(J+6)#                                             BF55  31
ifne:((HKLP(2)+HKL(2)),0.0) NEXT#      Not possible - try next          BF55  32
HKLP(3) = HKL(1)*QX(J+7) $#            Transform l                      BF55  33
          + HKL(2)*QX(J+8) $#                                           BF55  34
          + HKL(3)*QX(J+9)#                                             BF55  35
ifne:((HKLP(3)+HKL(3)),0.0) NEXT#      Not possible - try next          BF55  36
CFLG = yes:#                           If here, reflection centric      BF55  37
BREAK#                                 No need to search more           BF55  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF55  39
RETURN#                                                                 BF55  40
END#                                                                    BF55  41
systemheader:(BF56)#                   List output reflections          BF56   1
####################################################################### BF56   2
#                                                                     # BF56   3
#                               BF56                                  # BF56   4
#                                                                     # BF56   5
####################################################################### BF56   6
SUBROUTINE BF56(VPTR1,VPTR2)#          D.r. holland nov 1986            BF56   7
# ROUTINE TO LIST OUTPUT REFLECTIONS AS SPECIFIED BY LIST PARAMETER     BF56   8
include:(AACOMN)#                                                       BF56   9
include:(BFCOMN)#                                                       BF56  10
#                                                                       BF56  11
INTEGER VPTR1,VPTR2#  ## Points to first element in qx to output        BF56  12
REAL HKL(3)#          ## Hold hlk                                       BF56  13
realdata:(FMTOT,[50313.,100313.,150313.,260831.])#                      BF56  14
chardata:(MSG1,[    H    K    L     COEF    ])#                         BF56  15
datastuff:#                                                             BF56  16
#                                                                       BF56  17
gethkl:(VPTR1,HKL)#                    Unpack hkl values                BF56  18
#                                                                       BF56  19
ncodefld:(HKL,1,CHROT,FMTOT(1),3)#                                      BF56  20
ncodefld:(QX,VPTR2,CHROT,FMTOT(4),1)#                                   BF56  21
writeline:(0,MSG1,NMSG1,1,3)#          Output to log                    BF56  22
#                                                                       BF56  23
RETURN#                                                                 BF56  24
END#                                                                    BF56  25
systemheader:(BF99)#                                                    BF99   1
####################################################################### BF99   2
#                                                                     # BF99   3
#                              BF99                                   # BF99   4
#                                                                     # BF99   5
####################################################################### BF99   6
SUBROUTINE BF99#                       Subroutine to calculate          BF99   7
#                                         Difference coefficients       BF99   8
#                                         From ad hoc phaser output.    BF99   9
#  FORMAT OF ADHOC LINE                                                 BF99  10
#                                                                       BF99  11
#    <FIELD> <VALUE>        <DESCRIPTION>                               BF99  12
#       1       1       SPECIFIES FUNCTION                              BF99  13
#                          1 ==> DIFFERENCE FOURIER                     BF99  14
#                          2 ==> FPH(OBS)-FPH(CALC) DIFF FOURIER        BF99  15
#                          3 ==> FPH(OBS) FOURIER                       BF99  16
#                          4 ==> CENTROID WEIGHTED FPH(OBS) FOURIER     BF99  17
#                          5 ==> BDF WITH F,CENTRD, PHCNT,PHPROB        BF99  18
#       2       1/2     CENTROID/MOST PROBABLE PHASES                   BF99  19
#       3       NS1     INTEGER 1-5, A DATA SET NUMBER FOR SET 1        BF99  20
#       4       NS2     DATA SET NUMBER FOR SET 2.                      BF99  21
#       5       K1      SCALE FOR DATA SET 1 (MUST BE > 0)              BF99  22
#       6       K2      SCALE FOR DATA SET 2, IF K2 < 0, IT'S SET TO 1. BF99  23
#                                                                       BF99  24
# DIFFERENCE FUNCTIONS: K1*F(SET1) - K2F(*SET2)                         BF99  25
#                                                                       BF99  26
include:(AACOMN)#                                                       BF99  27
include:(BFCOMN)#                                                       BF99  28
#                                                                       BF99  29
INTEGER I#                             Loop index                       BF99  30
INTEGER IH(3)#                         Miller indices                   BF99  31
INTEGER INTD(5)#                       Delta f's from phaser file       BF99  32
INTEGER INTF(5)#                       Mean f's from phaser file        BF99  33
INTEGER INTS(5)#                       Mean sigma's from phaser fil     BF99  34
INTEGER IPLACE#                        Bit position for unpacking a     BF99  35
#                                         Hkl.                          BF99  36
INTEGER J#                             Unpacking index                  BF99  37
INTEGER JPT#                           Output packet pointer            BF99  38
INTEGER JUNK#                          Location holding unwanted da     BF99  39
#                                         From phaser file.             BF99  40
INTEGER PSIZE#                         Packet size                      BF99  41
#                                                                       BF99  42
REAL AC#                               Acalc                            BF99  43
REAL AH(5)#                            Ahcalc                           BF99  44
REAL BC#                               Bcalc                            BF99  45
REAL BH(5)#                            Bhcalc                           BF99  46
REAL CENTRD#                           Centroid                         BF99  47
REAL DELTAF(5)#                        Delta f's from phaser file       BF99  48
REAL FBAR(5)#                          F's from phaser file             BF99  49
REAL FC#                               Fcalc                            BF99  50
REAL FCSQ#                             (fcalc)**2                       BF99  51
REAL HH(3)#                            Miller indices                   BF99  52
REAL PCOS#                             Cosa                             BF99  53
REAL PHASE(2)#                         Centroid and most probable       BF99  54
#                                         Phases (in degrees) from      BF99  55
#                                         Phaser file.                  BF99  56
REAL PROBC,PROBS#                                                       BF99  57
REAL PSIN#                             Sina                             BF99  58
REAL RADIAN#                           Conversion factor                BF99  59
chardata:(ID,TRIPARI3TRIZ4ITRZ PTRIAZCLDHFR)#                           BF99  60
chardata:(PHTYP,CENTROID     MOST PROBABLE)#                            BF99  61
chardata:(BF991, PHASES WILL BE)#                                       BF99  62
chardata:(BF992, D I F F E R E N C E   F O U R I E R)#                  BF99  63
chardata:(BF993, FPH(OBSERVED) - FPH(CALCULATED)$#                      BF99  64
DIFFERENCE FOURIER)#                                                    BF99  65
chardata:(BF994, FPH(OBSERVED) FOURIER)#                                BF99  66
chardata:(BF995, USE CENTROID WEIGHTS)#                                 BF99  67
chardata:(BF996, FO FOR DATA SET )#                                     BF99  68
chardata:(BF997, ID FOR SET 1$,       $,  K1 =)#                        BF99  69
chardata:(BF998, ID FOR SET 2$,       $,  K2 =)#                        BF99  70
chardata:(BF999, FOURIER CALCULATED FOR DATA SET)#                      BF99  71
chardata:(BF99A, OUTPUT BDF HAS FO$, CNTRD$COS/SIN(CNTRD)$,$#           BF99  72
COS/SIN(PROB) PHASES)#                                                  BF99  73
realdata:(FMT991,[360842.])#                                            BF99  74
realdata:(COEF,[0.0])#                                                  BF99  75
intdata:(TYPE,[0])#                    The type of fnct. to be calu     BF99  76
intdata:(NPH,[0])#                     Signal indicating phase type     BF99  77
intdata:(NS1,[0])#                     Data set 1 number                BF99  78
intdata:(NS2,[0])#                     Data set 2 number                BF99  79
intdata:(ONE,[1])#                     The integer 1                    BF99  80
realdata:(PI,[3.14159265])#                                             BF99  81
datastuff:#                                                             BF99  82
#                                                                       BF99  83
# SOME INITIALIZATION                                                   BF99  84
#                                                                       BF99  85
RADIAN = PI/180.#                                                       BF99  86
FTYPE = 99#                            Set ftype unreasonable, no       BF99  87
IF(LMOD!=0) LINCT = 0#                 Force new page                   BF99  88
#                                         Other coefficient.            BF99  89
#                                                                       BF99  90
# READ ADHOC LINE                                                       BF99  91
#                                                                       BF99  92
IF(BUFIN(1) < 0.)  iquit:(-BF9901,1)#                                   BF99  93
ELSE#                                                                   BF99  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BF99  95
TYPE = NINT(BUFIN(1))#                                                  BF99  96
IF(TYPE < 1 \ TYPE > 5)  iquit:(-BF9901,1)#                             BF99  97
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BF99  98
#                                                                       BF99  99
IF(TYPE < 5)#                          Types 1 through 4                BF99 100
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BF99 101
IF(BUFIN(2) < 0.)  iquit:(-BF9901,2)#                                   BF99 102
NPH = NINT(BUFIN(2))#                                                   BF99 103
IF(NPH < 1 \ NPH > 2)  iquit:(-BF9901,2)#                               BF99 104
movechar:(BF991,1,CHROT,1,NBF991,0)#                                    BF99 105
J = (NPH-1)*13 + 1#                                                     BF99 106
movechar:(PHTYP,J,CHROT,NBF991+2,13,0)#                                 BF99 107
writeline:(1,0,0,1,3)#                                                  BF99 108
#                                                                       BF99 109
IF(BUFIN(3) < 0.)  iquit:(-BF9901,3)#                                   BF99 110
ELSE#                                                                   BF99 111
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BF99 112
NS1 = NINT(BUFIN(3))#                                                   BF99 113
IF(NS1 < 1 \ NS1 > 5)  iquit:(-BF9901,3)#                               BF99 114
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BF99 115
#                                                                       BF99 116
IF(TYPE == 1)#                         Need 2 data sets for diff fu     BF99 117
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BF99 118
writeline:(1,BF992,NBF992,3,3)#                                         BF99 119
IF(BUFIN(4) < 0.)  iquit:(-BF9901,4)#                                   BF99 120
ELSE#                                                                   BF99 121
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BF99 122
NS2 = NINT(BUFIN(4))#                                                   BF99 123
IF(NS2 < 1 \ NS2 > 5)  iquit:(-BF9901,5)#                               BF99 124
IF(BUFIN(6) < small:)  K2 = 1.#        Get k2 for diff. functions       BF99 125
ELSE  K2 = BUFIN(6)#                                                    BF99 126
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BF99 127
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BF99 128
#                                                                       BF99 129
ELSE  IF(TYPE == 2)#                   Fph obs - calc fourier           BF99 130
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BF99 131
writeline:(1,BF993,NBF993,3,3)#                                         BF99 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BF99 133
ELSE  IF(TYPE == 3 \ TYPE == 4)#                                        BF99 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BF99 135
writeline:(1,BF994,NBF994,3,3)#                                         BF99 136
IF(TYPE == 4)  writeline:(0,BF995,NBF995,3,3)#                          BF99 137
movechar:(BF996,1,CHROT,1,NBF996,0)#                                    BF99 138
J = (NS1-1)*6 + 1#                                                      BF99 139
movechar:(ID,J,CHROT,NBF996+1,6,0)#                                     BF99 140
writeline:(0,0,0,1,3)#                                                  BF99 141
IF(K1 <= 0.)  K1 = 1.0#                                                 BF99 142
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BF99 143
#                                                                       BF99 144
# GET K1                                                                BF99 145
IF(BUFIN(5) < small:)  iquit:(-BF9901,5)#                               BF99 146
ELSE  K1 = BUFIN(5)#                                                    BF99 147
#                                                                       BF99 148
# IF ANY ERRORS HAVE BEEN ENCOUNTERED, DIE HERE....                     BF99 149
#                                                                       BF99 150
IF(QUITF(1^1)!=' ')   iquit:(BF9999)#                                   BF99 151
#                                                                       BF99 152
IF(TYPE == 1)#                                                          BF99 153
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BF99 154
movechar:(BF997,1,CHROT,1,NBF997,0)#                                    BF99 155
J = (NS1-1)*6 + 1#                                                      BF99 156
movechar:(ID,J,CHROT,16,6,0)#                                           BF99 157
BUFOT(1) = K1#                                                          BF99 158
ncodefld:(BUFOT,1,CHROT,FMT991,1)##                                     BF99 159
writeline:(1,0,0,1,3)#                                                  BF99 160
#                                                                       BF99 161
movechar:(BF998,1,CHROT,1,NBF998,0)#                                    BF99 162
J = (NS2-1)*6 + 1#                                                      BF99 163
movechar:(ID,J,CHROT,16,6,0)#                                           BF99 164
BUFOT(1) = K2#                                                          BF99 165
ncodefld:(BUFOT,1,CHROT,FMT991,1)##                                     BF99 166
writeline:(1,0,0,1,3)#                                                  BF99 167
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BF99 168
#                                                                       BF99 169
ELSE  IF(TYPE == 2)#                                                    BF99 170
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BF99 171
movechar:(BF999,1,CHROT,1,NBF999,0)#                                    BF99 172
J = (NS1-1)*6 + 1#                                                      BF99 173
movechar:(ID,J,CHROT,NBF999+2,6,0)#                                     BF99 174
writeline:(1,0,0,1,3)#                                                  BF99 175
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BF99 176
#                                                                       BF99 177
# WRITE DIRECTORY FOR LRREFL:                                           BF99 178
#                                                                       BF99 179
IF (FAZYN == yes:) PSIZE = 4#          Only include phase output if     BF99 180
ELSE PSIZE = 2#                        Phase line used.                 BF99 181
writepkt:(2,lrrefl:,PSIZE,JPT)#                                         BF99 182
QX(JPT+1) = 1.#                                                         BF99 183
QX(JPT+2) = 1304.#                                                      BF99 184
QX(JPT+3) = phnmbcos:#                                                  BF99 185
QX(JPT+4) = phnmbsin:#                                                  BF99 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BF99 187
#                                                                       BF99 188
ELSE  IF(TYPE == 5)#                                                    BF99 189
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BF99 190
writeline:(1,BF99A,NBF99A,3,3)#                                         BF99 191
NPH = 1#                               Pull off centroid phases         BF99 192
#                                                                       BF99 193
rewindbdf:(1)#                         Rewind bdf and then copy         BF99 194
rewindbdf:(2)#                         Lr up to lrrefl:.                BF99 195
copyfile:(1,2,1,decr:(lrrefl:))#                                        BF99 196
#                                                                       BF99 197
PSIZE = 7#                             Write lrrefl: directory          BF99 198
writepkt:(2,lrrefl:,PSIZE,JPT)#                                         BF99 199
#                                                                       BF99 200
QX(JPT+1) = 1.#                                                         BF99 201
QX(JPT+2) = 1304.#                                                      BF99 202
QX(JPT+3) = 700.#                                                       BF99 203
QX(JPT+4) = 701.#                                                       BF99 204
QX(JPT+5) = 702.#                                                       BF99 205
QX(JPT+6) = 703.#                                                       BF99 206
QX(JPT+7) = 704.#                                                       BF99 207
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BF99 208
#                                                                       BF99 209
# LOOP TO READ REFLECTIONS, MAKE COEFFICIENTS, OUTPUT REFLECTIONS       BF99 210
#                                                                       BF99 211
READ(1)#                               Skip blank title record          BF99 212
#                                                                       BF99 213
REPEAT#                                                                 BF99 214
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BF99 215
READ(1,END=100)HH,PHASE,CENTRD,INTF(1),INTS(1),JUNK,(INTF(I),INTD(I),#  BF99 216
INTS(I),JUNK,AH(I),BH(I),I=2,5)#                                        BF99 217
#                                                                       BF99 218
NRFIN = NRFIN + 1.#                    Count input reflections          BF99 219
DO I=1,5#                                                               BF99 220
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BF99 221
FBAR(I) = FLOAT(INTF(I))#                                               BF99 222
DELTAF(I) = FLOAT(INTD(I))#                                             BF99 223
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BF99 224
#                                                                       BF99 225
ifeq:(PHASE(NPH),1000.)  NEXT#         Check input phase                BF99 226
PCOS = COS(RADIAN*PHASE(NPH))#                                          BF99 227
PSIN = SIN(RADIAN*PHASE(NPH))#                                          BF99 228
PROBC = COS(RADIAN*PHASE(2))#                                           BF99 229
PROBS = SIN(RADIAN*PHASE(2))#                                           BF99 230
#                                                                       BF99 231
DO I=1,3#                                                               BF99 232
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BF99 233
IH(I) = NINT(HH(I))#                   Get integer indices              BF99 234
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BF99 235
IF(IH(2) == 0)#                        For centric reflections,         BF99 236
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BF99 237
PSIN = 0.#                             Make phase exactly 0. or 180     BF99 238
PCOS = FLOAT(NINT(PCOS))#                                               BF99 239
PROBS = 0.#                                                             BF99 240
PROBC = FLOAT(NINT(PROBC))#                                             BF99 241
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BF99 242
#                                                                       BF99 243
IF(TYPE == 1)#                                                          BF99 244
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BF99 245
# SKIP, IF NO OBSERVED F'S                                              BF99 246
ifeq:(FBAR(NS1),0.)  NEXT#                                              BF99 247
ifeq:(FBAR(NS2),0.)  NEXT#                                              BF99 248
COEF = SCALE*(K1*FBAR(NS1)-K2*FBAR(NS2))#                               BF99 249
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BF99 250
#                                                                       BF99 251
ELSE  IF(TYPE ==2)#                    Fph obs-calc diff fourier        BF99 252
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 BF99 253
ifeq:(FBAR(NS1),0.) NEXT#              Skip if no f for isomorph.       BF99 254
AC = FBAR(1)*PCOS + AH(NS1)#                                            BF99 255
BC = FBAR(1)*PSIN + BH(NS1)#                                            BF99 256
FCSQ = AC**2 + BC**2#                                                   BF99 257
IF(FCSQ > 0.)  FC = SQRT(FCSQ)#                                         BF99 258
ELSE  NEXT#                                                             BF99 259
COEF = SCALE*(K1*FBAR(NS1)-FC)#                                         BF99 260
PCOS = AC/FC#                                                           BF99 261
PSIN = BC/FC#                                                           BF99 262
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 BF99 263
#                                                                       BF99 264
ELSE  IF(TYPE == 3 \ TYPE == 4)#                                        BF99 265
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 BF99 266
COEF = SCALE*K1*FBAR(NS1)#                                              BF99 267
IF(TYPE == 4)  COEF = CENTRD*COEF#                                      BF99 268
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 BF99 269
#                                                                       BF99 270
ELSE  IF(TYPE == 5)  COEF = FBAR(1)#                                    BF99 271
#                                                                       BF99 272
NRFOUT = NRFOUT + 1.#                  Count output reflection          BF99 273
#                                                                       BF99 274
# FIND STATS ON COEFFICIENTS                                            BF99 275
# --------------------------                                            BF99 276
#                                                                       BF99 277
COEFAV = COEFAV + COEF#                Running sum of coefficients      BF99 278
COEFMN = AMIN1(COEFMN,COEF)#           Minimum coefficient              BF99 279
COEFMX = AMAX1(COEFMX,COEF)#           Maximum coefficient              BF99 280
#                                                                       BF99 281
writepkt:(2,lrrefl:,PSIZE,JPT)#        And write it out.                BF99 282
JPTHLD = JPT+1#                                                         BF99 283
QX(JPT+1) = 0.#                        Initialize output word           BF99 284
DO I=1,3#                              Pack hkl and put it out          BF99 285
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 BF99 286
J = 3 - I#                             Reverse indices for packing      BF99 287
IPLACE = 3 + 9*J#                                                       BF99 288
intpak:(IABS(IH(I)),QX(JPT+1),IPLACE,9)#                                BF99 289
IF(IH(I) < 0)  intpak:(ONE,QX(JPT+1),J,1)#                              BF99 290
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 BF99 291
#                                                                       BF99 292
QX(JPT+2) = COEF#                                                       BF99 293
QX(JPT+3) = PCOS#                                                       BF99 294
QX(JPT+4) = PSIN#                                                       BF99 295
IF(TYPE == 5)#                                                          BF99 296
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 BF99 297
QX(JPT+3) = CENTRD#                                                     BF99 298
QX(JPT+4) = PCOS#                                                       BF99 299
QX(JPT+5) = PSIN#                                                       BF99 300
QX(JPT+6) = PROBC#                                                      BF99 301
QX(JPT+7) = PROBS#                                                      BF99 302
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 BF99 303
#                                                                       BF99 304
IF(LMOD>0)#                            List option active               BF99 305
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 BF99 306
IF(MOD(INT(NRFOUT),LMOD)==0)#                                           BF99 307
CALL BF56(JPTHLD,JPTHLD+1)#                                             BF99 308
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 BF99 309
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BF99 310
#                                                                       BF99 311
100 CONTINUE#                                                           BF99 312
RETURN#                                                                 BF99 313
END#                                                                    BF99 314
pmacro:([no:])#                        Purge xtal system macros         BF99 315
