/*#                                                                     UNXL   3
flagon:(R)#                            Prevent tidying                          
*/                                                                              
/* The following C routines are callable from FORTRAN and provide               
 * access to Unix bitwise functions.                                            
 * The routines emulate the f77 library functions IAND,ISHFT and IEOR.          
 * James Hester July 94                                                         
*/                                                                              
                                                                                
/*C Code to implement fortran functions IAND, ISHFT and IEOR*/                  
                                                                                
int                                                                             
iand_(first,second)                                                             
int *first,*second;    /*fortran passes pointers to variables*/                 
   {                                                                            
    return(*first&*second);                                                     
   }                                                                            
                                                                                
int                                                                             
ieor_(first,second)                                                             
int *first,*second;    /*fortran passes pointers to variables*/                 
   {                                                                            
    return((*first|*second)&~(*first&*second));                                 
   }                                                                            
                                                                                
int                                                                             
ishft_(first,nshfts)                                                            
int *first,*nshfts;   /*fortran passes pointers to variables*/                  
     {                                                                          
     if(*nshfts>=0)                                                             
     {                                                                          
      return(*first<<*nshfts);                                                  
     }                                                                          
     else                                                                       
     {                                                                          
      return(*first>>-(*nshfts));                                               
     }                                                                          
     }                                                                          
