systemheader:(BY     )#                                                 BY     1
######################################################################  BY     2
##      Copyright (C) 2000, The Xtal System, The University of        # BY     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # BY     4
## Distributed under the GNU General Public Licence as published by   # BY     5
## the Free Software Foundation, in the hope that it will be useful   # BY     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # BY     7
## for more details.                                                  # BY     8
#                                                                       BY     9
#                            *** BAYEST ***                             BY    10
#                                                                       BY    11
#    BAYESIAN ESTIMATION OF TRUE INTENSITY AND STRUCTURE FACTORS        BY    12
#    THE BAYEST PROGRAM DETERMINES A POSTERIOR MEAN INTENSITY AND       BY    13
#    STRUCTURE FACTOR MODULUS FOR ANY GIVEN INTENSITY AND STANDARD      BY    14
#    DEVIATION IN INTENSITY.  ALGORITHM OF FRENCH AND WILSON            BY    15
#    (ACTA CRYST A34 517-525)                                           BY    16
#                                                                       BY    17
##################################################################      BY    18
#                                                                       BY    19
include:(XMACRO)#                                                       BY    20
#                                                                       BY    21
systemheader:(BY00)#                                                    BY00   1
#####################################################################   BY00   2
#                                                                       BY00   3
#                        BY00                                           BY00   4
#                                                                       BY00   5
#####################################################################   BY00   6
SUBROUTINE BY00#                                                        BY00   7
include:(AACOMN)#                                                       BY00   8
#                                                                       BY00   9
INTEGER BEGIN#                         Lower field limit                BY00  10
INTEGER CENT#                          Centricity 0(=c) 1(=nc)          BY00  11
INTEGER IEND#                          End char string                  BY00  12
INTEGER EPSI#                          Epsilon in integer               BY00  13
INTEGER FIELD#                         Field pointer                    BY00  14
INTEGER IN#                            Analysis on fsqrd/frel           BY00  15
INTEGER INPUT#                         Statistics based on i/f2/f (     BY00  16
INTEGER IPT#                           Input buffer pointer             BY00  17
INTEGER IREL(11)#                      Indexpkt return pointers         BY00  18
INTEGER IWNT(10)#                      Indexpkt request                 BY00  19
INTEGER JPT#                           Output buffer pointer            BY00  20
INTEGER MARKS#                         Marks end of output qx           BY00  21
INTEGER MATCH#                         Pointer to character match       BY00  22
INTEGER NREF#                          Number of reflections            BY00  23
INTEGER PACKET#                        Packet counter                   BY00  24
INTEGER PRINT#                         Flag for printing                BY00  25
INTEGER PSIZE#                         Packet size                      BY00  26
INTEGER R1,R2,R3,R4,R5,R6#             Pointers                         BY00  27
INTEGER R7,R8,R9,R10#                  Pointers                         BY00  28
INTEGER RANGE#                         Number of shells in sint/l       BY00  29
INTEGER SIGNAL(4)#                     Indexpkt parameters              BY00  30
INTEGER I,NR#                                                           BY00  31
REAL PART,SIGMA,TEMP#                                                   BY00  32
#                                                                       BY00  33
REAL AH(3)#                            Hkl                              BY00  34
REAL EPS#                              Epsilon (real)                   BY00  35
REAL ESDI#                             Esd fsqrd                        BY00  36
REAL ESDJ#                             Postrior esd of fsqrd            BY00  37
REAL FRLJ#                             Bayes corrected f(rel)           BY00  38
REAL ITEN#                             Fsqrd                            BY00  39
REAL JTEN#                             Postrior fsqrd                   BY00  40
REAL REND#                             End of (s(t)/l)**2 interval      BY00  41
REAL RSTRT#                            Begin of (s(t)/l)**2 interva     BY00  42
REAL SIGFJ#                            Bayes corrected sigma(frel)      BY00  43
REAL STL2#                             (s(t)/l)**2                      BY00  44
REAL STLINC#                           (s(t)/l)**2 interval width       BY00  45
REAL STLMIN#                           Minimum (s(t)/l)**2              BY00  46
REAL STLMAX#                           Maximum (s(t)/l)**2              BY00  47
REAL STLRNG#                           (s(t)/l)**2 range                BY00  48
REAL SUMI(52)#                         Sum of intensity in shell        BY00  49
REAL SUME(52)#                         Sum of epsilon in shell          BY00  50
#                                                                       BY00  51
chardata:(BY001,NR IN FR PR NP )#                                       BY00  52
chardata:(BY002,[ (SINT/L)**2    NO. OF OBS    $#                       BY00  53
MEAN FSQRD])#                                                           BY00  54
chardata:(BY003, NUMBER OF REFLECTIONS PROCESSED)#                      BY00  55
chardata:(BY004,                          ----------I N P U T    $#     BY00  56
I T E M S-----------         ----------O U T P U T   $#                 BY00  57
I T E M S----------)#                                                   BY00  58
chardata:(BY005,    H   K   L SINT/L            INT   SIGI    FSQR$#    BY00  59
D SIGF2   FREL SIGF               INT   SIGI    FSQRD SIGF2   FREL $#   BY00  60
SIGF)#                                                                  BY00  61
chardata:(BY006, END   )#                                               BY00  62
chardata:(BY007, BAYEST CONTROL PARAMETERS)#                            BY00  63
chardata:(BY008,[ NUMBER OF SIN(TH)/L RANGES             ])#            BY00  64
chardata:(BY009, APPLY ANALYSIS TO                INT/FSQRD)#           BY00  65
chardata:(BY00A, PRINT LIST OF REFLECTIONS        NO   )#               BY00  66
chardata:(BY00B, YES FREL       -)#                                     BY00  67
realdata:(FMT001,[60532.,20532.,260513.,401222.])#                      BY00  68
realdata:(FMT002,400513.)#                                              BY00  69
realdata:(FMT003,[50413.,90413.,130413.,200642.])#                      BY00  70
realdata:(FMT004,[510812.,570512.,1030812.,1090512.,#                   BY00  71
350912.,420612.,870912.,940612.,640612.,690412.,1160612.,1210412.])#    BY00  72
realdata:(FMT005,360203.)#                                              BY00  73
datastuff:#                                                             BY00  74
#                                                                       BY00  75
#        SET DEFAULTS                                                   BY00  76
#                                                                       BY00  77
DO I=1,51#                                                              BY00  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BY00  79
SUMI(I)=0.0#                                                            BY00  80
SUME(I)=0.0#                                                            BY00  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BY00  82
IN=1#                                  Assume analysis on fsqrd         BY00  83
RANGE=50#                              Assume maximum ranges            BY00  84
NREF=0#                                                                 BY00  85
PRINT=no:#                             Don't print reflections          BY00  86
#                                                                       BY00  87
FOR(FIELD=1;FIELD>0;FIELD=FIELD+1)#    Loop over input fields           BY00  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BY00  89
ifvo:(BUFIN(FIELD)) BREAK#             Break at first void              BY00  90
stringlim:(FIELD,BEGIN,IEND)#          Find field limits                BY00  91
compchar:(CHRIN,BEGIN,BY001,1,2,3,NBY001,MATCH)#                        BY00  92
IF(MATCH==1)#                                                           BY00  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BY00  94
IF(BUFIN(FIELD+1)<=voidflg:) iquit:(BY0005)# Real after nr              BY00  95
RANGE=BUFIN(FIELD+1)#                  Number of ranges                 BY00  96
FIELD=FIELD+1#                         Point to numeric field           BY00  97
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BY00  98
ELSE IF(MATCH==2) IN=1#                Analysis on fsqrd                BY00  99
ELSE IF(MATCH==3) IN=2#                Analysis on frelative            BY00 100
ELSE IF(MATCH==4) PRINT=yes:#          Print reflections                BY00 101
ELSE IF(MATCH==5) PRINT=no:#           Print no reflections             BY00 102
ELSE iquit:(BY0010)#                   No match found                   BY00 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BY00 104
readline:(BY006,NBY006)#               Read end card                    BY00 105
#                                                                       BY00 106
#        REQUEST MEMORY FOR I/O BUFFERS                                 BY00 107
#        ------------------------------                                 BY00 108
#                                                                       BY00 109
IOMARK(1)=QXSTR#                       Mark begin of input buffer       BY00 110
incrqx:(MARKS,IOMARK(1)+bdfbuf:,BY0015)# Request input space            BY00 111
IOMARK(2)=MARKS#                       Mark begin of output buffer      BY00 112
incrqx:(MARKS,IOMARK(2)+bdfbuf:,BY0020)# Request output space           BY00 113
#                                                                       BY00 114
PACKET=1#                                                               BY00 115
REPEAT#                                                                 BY00 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BY00 117
readwpkt:(1,lrsymm:,PSIZE,IPT,0)#                                       BY00 118
IF(IPT<=0) BREAK#                      End of record                    BY00 119
IF(PACKET==1)#                                                          BY00 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BY00 121
CENT=NINT(QX(IPT+2))#                  Centricity 0/1 for c/nc          BY00 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BY00 123
PACKET=PACKET+1#                                                        BY00 124
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BY00 125
#                                                                       BY00 126
IWNT(1)=14#                            Stl min                          BY00 127
IWNT(2)=15#                            Stl max                          BY00 128
SIGNAL(1)=2 ; SIGNAL(2)=0#             All items mandatory              BY00 129
SIGNAL(3)=0 ; SIGNAL(4)=0#             No additions or deletions        BY00 130
indexpkt:(1,lrdset:,PSIZE,IPT,0,SIGNAL,IWNT,IREL)#                      BY00 131
IF(IPT<0) iquit:(BY0025)#              No lrdset record                 BY00 132
IF(SIGNAL(4)<=0) iquit:(BY0030)#       Mandatory items missing          BY00 133
R1=IREL(1) ; R2=IREL(2)#                                                BY00 134
PACKET=1#                                                               BY00 135
REPEAT#                                                                 BY00 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BY00 137
readwpkt:(1,lrdset:,PSIZE,IPT,0)#                                       BY00 138
IF(IPT<=0) BREAK#                      End of record                    BY00 139
IF(PACKET==1)#                                                          BY00 140
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BY00 141
STLMIN=(QX(IPT+R1))**2#                Minimum (sin(th)/l)**2           BY00 142
STLMAX=(QX(IPT+R2))**2+0.0000001#      Maximum (sin(th)/l)**2           BY00 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BY00 144
PACKET=PACKET+1#                                                        BY00 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BY00 146
#                                                                       BY00 147
STLRNG=STLMAX-STLMIN#                  Range in (sin(th)/l)**2          BY00 148
STLINC=STLRNG/FLOAT(RANGE)#            Increment in (sin(th)/l)**2      BY00 149
#                                                                       BY00 150
#       READ REFLECTION RECORD AND DETERMINE THE                        BY00 151
#       WILSON PARAMETER, SIGMA, BASED ON THE                           BY00 152
#       MEAN INTENSITY FOR VARIOUS SHELLS OF                            BY00 153
#       (SIN(TH)/L)**2...                                               BY00 154
#                                                                       BY00 155
IWNT(1)=2#                             Sin(th)/l                        BY00 156
IWNT(2)=3#                             Epsilon                          BY00 157
IWNT(3)=1#                             H k l                            BY00 158
IWNT(4)=1302#                          F sqrd                           BY00 159
IWNT(5)=1303#                          Sigma(f sqrd)                    BY00 160
IWNT(6)=1300#                          Intensity                        BY00 161
IWNT(7)=1301#                          Sigma(i)                         BY00 162
IWNT(8)=1204#                          1/lp                             BY00 163
IWNT(9)=1304#                          Frel                             BY00 164
IWNT(10)=1305#                         Sigma(frel)                      BY00 165
SIGNAL(1)=3 ; SIGNAL(2)=10#            3 items mandatory &&&&           BY00 166
SIGNAL(3)=0 ; SIGNAL(4)=0#             Na additions or deletions        BY00 167
indexpkt:(1,lrrefl:,PSIZE,IPT,0,SIGNAL,IWNT,IREL)# Search direcyory     BY00 168
IF(IPT<0) iquit:(BY0035)#              Lrecord missing                  BY00 169
IF(SIGNAL(4)<=0) iquit:(BY0040)#       Mandatory item missing           BY00 170
R1=IREL(1) ; R2=IREL(2) ; R3=IREL(3)#                                   BY00 171
R4=IREL(4) ; R5=IREL(5) ; R6=IREL(6)#                                   BY00 172
R7=IREL(7) ; R8=IREL(8) ; R9=IREL(9)#                                   BY00 173
R10=IREL(10)#                                                           BY00 174
#                                                                       BY00 175
# CHECK FOR PRESENCE OF SIGMAS                                          BY00 176
#                                                                       BY00 177
IF(IN==1&R7==0&R8==0&R5==0) iquit:(BY0045)#                             BY00 178
IF(IN==2&R10==0) iquit:(BY0050)#                                        BY00 179
#                                                                       BY00 180
IF(R4!=0) INPUT=1#                     Based on fsqrd                   BY00 181
ELSE IF(R6!=0&R8!=0) INPUT=2#          Based on intensity               BY00 182
ELSE IF(R9!=0) INPUT=3#                Based on frel                    BY00 183
ELSE iquit:(BY0055)#                                                    BY00 184
#                                                                       BY00 185
REPEAT#                                                                 BY00 186
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BY00 187
readwpkt:(1,lrrefl:,PSIZE,IPT,0)#      Read packet                      BY00 188
IF(IPT==0) BREAK#                      End of record                    BY00 189
IF(INPUT==1) ITEN=QX(IPT+R4)#                                           BY00 190
ELSE IF(INPUT==2) ITEN=QX(IPT+R6)*QX(IPT+R8)#                           BY00 191
ELSE IF(INPUT==3) ITEN=(QX(IPT+R9))**2#                                 BY00 192
STL2=(QX(IPT+R1))**2#                  (sin(th)/l)**2                   BY00 193
intunpak:(QX(IPT+R2),EPSI,5,7)#        Unpack epsilon                   BY00 194
EPS=FLOAT(EPSI)#                       Epsilon as real                  BY00 195
NR=INT((STL2-STLMIN)/STLINC)+2#        Find appropriate shell           BY00 196
#                                                                       BY00 197
#       SHELLS NR=1 AND NR=RANGE+2 ARE RESERVED FOR                     BY00 198
#       THE ENDS OF THE DISTRIBUTION AND ARE DETERMINED                 BY00 199
#       BY LINEAR INTERPOLATION                                         BY00 200
#                                                                       BY00 201
SUMI(NR)=SUMI(NR)+ITEN#                Sum of intensities for shell     BY00 202
SUME(NR)=SUME(NR)+EPS#                 Sum of epsilons for shell        BY00 203
NREF=NREF+1#                                                            BY00 204
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BY00 205
#                                                                       BY00 206
#       CALCULATE MEAN INTENSITY OF EACH RANGE                          BY00 207
#                                                                       BY00 208
DO I=2,RANGE+1#                        Loop over shells                 BY00 209
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BY00 210
IF(SUME(I)!=0.)#                                                        BY00 211
SUMI(I)=SUMI(I)/SUME(I)#               Average for shell                BY00 212
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BY00 213
#                                                                       BY00 214
#       OUTPUT CONTROL INFORMATION                                      BY00 215
#                                                                       BY00 216
movechar:(BY00B,NBY00B,CHROT,2,NBY007-1,2)# Uderline heading            BY00 217
writeline:(2,BY007,NBY007,2,3)#        Output header                    BY00 218
ncodefld:(FLOAT(RANGE),1,BY008,FMT005,1)# Number of ranges              BY00 219
writeline:(1,BY008,NBY008,3,3)#                                         BY00 220
IF(IN==2)#                                                              BY00 221
movechar:(BY00B,6,BY009,35,10,0)#      Applied to frel                  BY00 222
writeline:(1,BY009,NBY009,3,3)#                                         BY00 223
IF(PRINT==yes:)#                                                        BY00 224
movechar:(BY00B,2,BY00A,35,4,0)#       Yes,print                        BY00 225
writeline:(1,BY00A,NBY00A,3,3)#                                         BY00 226
#                                                                       BY00 227
#       OUTPUT AVERAGES AND DISTRIBUTION                                BY00 228
#                                                                       BY00 229
movechar:(BY00B,NBY00B,CHROT,2,NBY002-1,1)# Write table heading         BY00 230
writeline:(2,BY002,NBY002,2,3)#                                         BY00 231
#                                                                       BY00 232
RSTRT=STLMIN#                                                           BY00 233
DO I=2,RANGE+1#                                                         BY00 234
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BY00 235
REND=RSTRT+STLINC#                                                      BY00 236
ncodefld:(RSTRT,1,CHROT,FMT001(1),1)#  Encode limit of range            BY00 237
ncodefld:(-REND,1,CHROT,FMT001(2),1)#  Encode limit of range            BY00 238
ncodefld:(SUME(I),1,CHROT,FMT001(3),1)# Encode observations             BY00 239
ncodefld:(SUMI(I),1,CHROT,FMT001(4),1)# Encode averages                 BY00 240
writeline:(0,0,0,1,3)#                                                  BY00 241
RSTRT=REND#                                                             BY00 242
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BY00 243
movechar:(BY003,1,CHROT,1,NBY003,0)#   Write reflection num.            BY00 244
ncodefld:(FLOAT(NREF),1,CHROT,FMT002,1)# Encode num of refs.            BY00 245
writeline:(1,0,0,1,3)#                                                  BY00 246
#                                                                       BY00 247
#       DETERMINE END POINTS OF DISTRIBUTION                            BY00 248
#                                                                       BY00 249
SUMI(1)=2.0*SUMI(2)-SUMI(3)#           Beginning of distribution        BY00 250
TEMP=2.0*SUMI(RANGE+1)-SUMI(RANGE)#                                     BY00 251
IF(TEMP<0) TEMP=0.#                                                     BY00 252
SUMI(RANGE+2)=TEMP#                    End of distribution              BY00 253
#                                                                       BY00 254
#        APPLY BAYESIAN STATISTICS                                      BY00 255
#                                                                       BY00 256
rewindbdf:(1)#                         Rewind file for 2nd pass         BY00 257
copyfile:(1,2,1,decr:(lrrefl:))#       Copy to lrrefl:                  BY00 258
#                                                                       BY00 259
#       SET UP PAGE HEADERS                                             BY00 260
#                                                                       BY00 261
IF(PRINT==yes:)#                                                        BY00 262
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BY00 263
LINCT=0#                               New page                         BY00 264
writeline:(1,BY004,NBY004,3,3)#                                         BY00 265
writeline:(0,0,0,1,3)#                                                  BY00 266
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BY00 267
IWNT(1)=2#                             Sin(th)/l                        BY00 268
IWNT(2)=3#                             Epsilon                          BY00 269
IWNT(3)=1#                             Hkl                              BY00 270
IWNT(4)=1302#                          F sqrd                           BY00 271
IWNT(5)=1303#                          Sigma(f sqrd)                    BY00 272
IWNT(6)=1300#                          Intensity                        BY00 273
IWNT(7)=1301#                          Sigma(i)                         BY00 274
IWNT(8)=1204#                          1/lp                             BY00 275
IWNT(9)=1304#                          Frel                             BY00 276
IWNT(10)=1305#                         Sigma(frel)                      BY00 277
SIGNAL(1)=2 ; SIGNAL(2)=10#            3 items mandatory &&&&&&         BY00 278
SIGNAL(3)=0 ; SIGNAL(4)=0#             Na additions or deletions        BY00 279
indexpkt:(1,lrrefl:,PSIZE,IPT,2,SIGNAL,IWNT,IREL)# Search direcyory     BY00 280
R1=IREL(1) ; R2=IREL(2) ; R3=IREL(3)#                                   BY00 281
R4=IREL(4) ; R5=IREL(5) ; R6=IREL(6)#                                   BY00 282
R7=IREL(7) ; R8=IREL(8) ; R9=IREL(9)#                                   BY00 283
R10=IREL(10)#                                                           BY00 284
#                                                                       BY00 285
LINRM=1#                                                                BY00 286
#                                                                       BY00 287
REPEAT#                                                                 BY00 288
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BY00 289
readwpkt:(1,lrrefl:,PSIZE,IPT,0)#      Read packet                      BY00 290
IF(IPT==0) BREAK#                      End of record                    BY00 291
writepkt:(2,lrrefl:,PSIZE,JPT)#        Output pointer                   BY00 292
movereal:(QX,IPT,QX,JPT,PSIZE,1)#      Move contents whole              BY00 293
STL2=(QX(IPT+R1))**2#                  (sin(th)/l)**2                   BY00 294
intunpak:(QX(IPT+R2),EPSI,5,7)#        Unpack epsilon                   BY00 295
EPS=FLOAT(EPSI)#                       Epsilon as real                  BY00 296
NR=INT((STL2-STLMIN)/STLINC)+2#        Find appropriate shell           BY00 297
PART=((STL2-STLMIN)/STLINC)-FLOAT(NR)# Determine fraction               BY00 298
NR=NR+2#                               S(t)/l shell number              BY00 299
IF(PART<=0.5)#                                                          BY00 300
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BY00 301
SIGMA=(0.5+PART)*SUMI(NR)+(0.5-PART)*SUMI(NR-1)# Interpolate            BY00 302
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BY00 303
ELSE#                                                                   BY00 304
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BY00 305
SIGMA=(1.5-PART)*SUMI(NR)+(PART-0.5)*SUMI(NR+1)# Interpolate            BY00 306
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BY00 307
SIGMA=EPS*SIGMA#                       Wilson parameter                 BY00 308
#                                                                       BY00 309
#       HAVING DETERMINED THE WILSON PARAMETER(SIGMA)                   BY00 310
#       WE CAN APPLY A BAYESIAN ANALYSIS ON I OR F                      BY00 311
#       WITH THE APPROPRIATE CORRECTIO0NS FOR EITHER                    BY00 312
#       A CENTRIC OR ACENTRIC INTENSITY DISTRIBUTION                    BY00 313
#                                                                       BY00 314
IF(PRINT==yes:)#                                                        BY00 315
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BY00 316
gethkl:(IPT+R3,AH)#                    Extract hkl                      BY00 317
ncodefld:(AH,1,CHROT,FMT003,3)#        Encode hkl                       BY00 318
ncodefld:(QX,IPT+R1,CHROT,FMT003(4),1)# Encode st/l                     BY00 319
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BY00 320
IF(INPUT==1)#                          If fsqrd on file                 BY00 321
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 BY00 322
ITEN=QX(IPT+R4)#                       Fsqrd                            BY00 323
ESDI=QX(IPT+R5)#                       Esd in fsqrd                     BY00 324
IF(CENT==0) CALL BY22(ITEN,ESDI,SIGMA,JTEN,ESDJ,FRLJ,SIGFJ,IN)#         BY00 325
ELSE CALL BY21(ITEN,ESDI,SIGMA,JTEN,ESDJ,FRLJ,SIGFJ,IN)#                BY00 326
IF(PRINT==yes:)#                                                        BY00 327
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 BY00 328
ncodefld:(QX,IPT+R4,CHROT,FMT004(1),1)# Encode old f2                   BY00 329
ncodefld:(QX,IPT+R5,CHROT,FMT004(2),1)# Encode old sigf2                BY00 330
ncodefld:(QX,IPT+R4,CHROT,FMT004(3),1)# Encode new f2(unchanged)        BY00 331
ncodefld:(QX,IPT+R5,CHROT,FMT004(4),1)# Encode new sigf2(unchanged)     BY00 332
IF(R6!=0)#                                                              BY00 333
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 BY00 334
ncodefld:(QX,IPT+R6,CHROT,FMT004(5),1)# Encode old int.                 BY00 335
ncodefld:(QX,IPT+R7,CHROT,FMT004(6),1)# Encode old sigi                 BY00 336
ncodefld:(QX,IPT+R6,CHROT,FMT004(7),1)# Encode new int.(unchanged)      BY00 337
ncodefld:(QX,IPT+R7,CHROT,FMT004(8),1)# Encode new sigi(unchanged)      BY00 338
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 BY00 339
IF(R9!=0)#                                                              BY00 340
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 BY00 341
ncodefld:(QX,IPT+R9,CHROT,FMT004(9),1)# Encode old frel                 BY00 342
ncodefld:(QX,IPT+R10,CHROT,FMT004(10),1)# Encode old sigf               BY00 343
ncodefld:(QX,IPT+R9,CHROT,FMT004(11),1)# Encode new sigf(unchanged)     BY00 344
ncodefld:(QX,IPT+R10,CHROT,FMT004(12),1)# Encode new sigf(unchanged)    BY00 345
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 BY00 346
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 BY00 347
IF(IN==1)#                             Apply to fsqrd                   BY00 348
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 BY00 349
QX(JPT+R4)=JTEN#                       Bayes corrected fsqrd            BY00 350
QX(JPT+R5)=ESDJ#                       Bayes corrected sigf2            BY00 351
IF(PRINT==yes:)#                                                        BY00 352
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 BY00 353
ncodefld:(QX,JPT+R4,CHROT,FMT004(3),1)# Adjusted f2                     BY00 354
ncodefld:(QX,JPT+R5,CHROT,FMT004(4),1)# Adjusted sigf2                  BY00 355
IF(R6!=0)#                             Intensity present                BY00 356
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 BY00 357
QX(JPT+R6)=JTEN/QX(IPT+R8)#            Bayes corrected int              BY00 358
QX(JPT+R7)=ESDJ/QX(IPT+R8)#            Bayes corrected sigi             BY00 359
ncodefld:(QX,JPT+R6,CHROT,FMT004(7),1)# Adjusted int.                   BY00 360
ncodefld:(QX,JPT+R7,CHROT,FMT004(8),1)# Adjusted sigi                   BY00 361
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 BY00 362
IF(R9!=0)#                             Frel present                     BY00 363
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 BY00 364
QX(JPT+R9)=SQRT(JTEN)#                 Bayes corrected frel             BY00 365
QX(JPT+R10)=ESDJ/(2.0*SQRT(JTEN))#     Bayes corrected sigf             BY00 366
ncodefld:(QX,JPT+R9,CHROT,FMT004(11),1)# Adjusted frel                  BY00 367
ncodefld:(QX,JPT+R10,CHROT,FMT004(12),1)# Adjusted sigf                 BY00 368
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 BY00 369
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 BY00 370
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 BY00 371
ELSE IF(IN==2)#                        Apply to frel                    BY00 372
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 BY00 373
QX(JPT+R9)=FRLJ#                       Bayes correced frel              BY00 374
QX(JPT+R10)=SIGFJ#                     Bayes correced sigf              BY00 375
IF(PRINT==yes:)#                                                        BY00 376
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 BY00 377
ncodefld:(QX,JPT+R9,CHROT,FMT004(11),1)# Adjusted frel                  BY00 378
ncodefld:(QX,JPT+R10,CHROT,FMT004(12),1)# Adjusted sigf                 BY00 379
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 BY00 380
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 BY00 381
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 BY00 382
ELSE IF(INPUT==2)#                     Analysis based on int            BY00 383
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 BY00 384
ITEN=QX(IPT+R6)*QX(IPT+R8)#            Intensity by (1/lp)              BY00 385
ESDI=QX(IPT+R7)*QX(IPT+R8)#            Sigma(i) by (1/lp)               BY00 386
IF(CENT==0) CALL BY22(ITEN,ESDI,SIGMA,JTEN,ESDJ,FRLJ,SIGFJ,IN)#         BY00 387
ELSE CALL BY21(ITEN,ESDI,SIGMA,JTEN,ESDJ,FRLJ,SIGFJ,IN)#                BY00 388
IF(PRINT==yes:)#                                                        BY00 389
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 BY00 390
ncodefld:(QX,IPT+R6,CHROT,FMT004(5),1)# Encode old int.                 BY00 391
ncodefld:(QX,IPT+R7,CHROT,FMT004(6),1)# Encode old sigi                 BY00 392
ncodefld:(QX,IPT+R6,CHROT,FMT004(7),1)# Encode new int.(unchanged)      BY00 393
ncodefld:(QX,IPT+R7,CHROT,FMT004(8),1)# Encode new sigi(unchanged)      BY00 394
IF(R9!=0)#                             If frel present                  BY00 395
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 BY00 396
ncodefld:(QX,IPT+R9,CHROT,FMT004(9),1)# Encode old frel                 BY00 397
ncodefld:(QX,IPT+R10,CHROT,FMT004(10),1)# Encode old sigf               BY00 398
ncodefld:(QX,IPT+R9,CHROT,FMT004(11),1)# Encode new sigf(unchanged)     BY00 399
ncodefld:(QX,IPT+R10,CHROT,FMT004(12),1)# Encode new sigf(unchanged)    BY00 400
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 BY00 401
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 BY00 402
IF(IN==1)#                             Apply to intensity               BY00 403
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 BY00 404
QX(JPT+R6)=JTEN/QX(IPT+R8)#            Bayes correced int               BY00 405
QX(JPT+R7)=ESDJ/QX(IPT+R8)#            Bayes corrected sigi             BY00 406
IF(PRINT==yes:)#                                                        BY00 407
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 BY00 408
ncodefld:(QX,JPT+R6,CHROT,FMT004(7),1)# Adjusted int.                   BY00 409
ncodefld:(QX,JPT+R7,CHROT,FMT004(8),1)# Adjusted sigi                   BY00 410
IF(R9!=0)#                             Frel present                     BY00 411
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 BY00 412
QX(JPT+R9)=SQRT(JTEN)#                 Bayes corrected frel             BY00 413
QX(JPT+R10)=ESDJ/(2.0*SQRT(JTEN))#     Bayes corrected sigf             BY00 414
ncodefld:(QX,JPT+R9,CHROT,FMT004(11),1)# Adjusted frel                  BY00 415
ncodefld:(QX,JPT+R10,CHROT,FMT004(12),1)# Adjusted sigf                 BY00 416
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 BY00 417
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 BY00 418
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 BY00 419
ELSE IF(IN==2)#                        Apply frel                       BY00 420
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 BY00 421
QX(JPT+R9)=FRLJ#                       Bayes corrected frel             BY00 422
QX(JPT+R10)=SIGFJ#                     Bayes corrected sigf             BY00 423
IF(PRINT==yes:)#                                                        BY00 424
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 BY00 425
ncodefld:(QX,JPT+R9,CHROT,FMT004(11),1)# Adjusted frel                  BY00 426
ncodefld:(QX,JPT+R10,CHROT,FMT004(12),1)# Adjusted sigf                 BY00 427
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 BY00 428
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 BY00 429
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 BY00 430
ELSE IF(INPUT==3)#                     Based on frel                    BY00 431
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 BY00 432
ITEN=QX(IPT+R9)**2#                    (f)**2                           BY00 433
ESDI=2.0*QX(IPT+R9)*QX(IPT+R10)#       Sigf2                            BY00 434
IF(CENT==0) CALL BY22(ITEN,ESDI,SIGMA,JTEN,ESDJ,FRLJ,SIGFJ,IN)#         BY00 435
ELSE CALL BY21(ITEN,ESDI,SIGMA,JTEN,ESDJ,FRLJ,SIGFJ,IN)#                BY00 436
QX(JPT+R9)=FRLJ#                       Bayes corrected frel             BY00 437
QX(JPT+R10)=SIGFJ#                     Bayes corrected sigf             BY00 438
IF(PRINT==yes:)#                                                        BY00 439
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 BY00 440
ncodefld:(QX,JPT+R9,CHROT,FMT004(11),1)# Adjusted frel                  BY00 441
ncodefld:(QX,JPT+R10,CHROT,FMT004(12),1)# Adjusted sigf                 BY00 442
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 BY00 443
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 BY00 444
IF(PRINT==yes:)#                                                        BY00 445
writeline:(0,BY005,NBY005,1,3)#                                         BY00 446
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BY00 447
#                                                                       BY00 448
#       WRITE ENDRECORD                                                 BY00 449
#                                                                       BY00 450
readwpkt:(1,endrecord:,PSIZE,IPT,0)#                                    BY00 451
writepkt:(2,endrecord:,PSIZE,JPT)#                                      BY00 452
RETURN#                                                                 BY00 453
END#                                                                    BY00 454
#                                                                       BY00 455
systemheader:(BY21)#                   Acentric case                    BY21   1
############################################################            BY21   2
#                                                                       BY21   3
#                                 BY21                                  BY21   4
#                                                                       BY21   5
##############################################################          BY21   6
SUBROUTINE BY21 (XI,SDI,SIGMA,XJ,SDJ,XF,SDF,IREJ)#                      BY21   7
#                                                                       BY21   8
#     GIVEN AN OBSERVED INTENSITY AND ITS ASSOCIATED STANDARD           BY21   9
#     DEVIATION, THE SUBROUTINE CALCULATES AND RETURNS THE              BY21  10
#     POSTERIOR MEAN AND STANDARD DEVIATION OF BOTH THE TRUE            BY21  11
#     INTENSITY AND THE TRUE STRUCTURE FACTOR MODULUS.                  BY21  12
#                                                                       BY21  13
#     THE PRIOR DISTRIBUTION USED IS WILSON'S DISTRIBUTION              BY21  14
#     FOR AN ACENTRIC REFLECTION.  FOR EXACT FORM SEE FRENCH            BY21  15
#     AND WILSON (1977) EQUATION (2.2)                                  BY21  16
#                                                                       BY21  17
#     ARGUMENTS:                                                        BY21  18
#     XI    - OBSERVED FSQRD                                            BY21  19
#     SDI   - S.D. OF OBSERVATION                                       BY21  20
#     SIGMA - PARAMETER FOR WILSON'S DISTRIBUTION                       BY21  21
#     XJ    - POSTERIOR MEAN FOR THE TRUE FSQRD                         BY21  22
#     SDJ   - POSTERIOR S.D. FOR THE TRUE FSQRD                         BY21  23
#     XF    - POSTERIOR MEAN FOR THE TRUE STRUCTURE FACTOR MODULUS      BY21  24
#     SDF   - POSTERIOR S.D. FOR THE TRUE STRUCTURE FACTOR MODULUS      BY21  25
#     IREJ  - ON ENTRY:  =  2   IF ONLY XF AND SDF REQUIRED.            BY21  26
#                        =  1   IF ONLY XJ AND SDJ REQUIRED.            BY21  27
#                                                                       BY21  28
#     A REFLECTION IS CONSIDERED IMPOSSIBLE IF:                         BY21  29
#                                                                       BY21  30
#     (1)  XI < -3.0*SDI                                                BY21  31
#     (2)  (XI-SDI**2/SIGMA) < -4.0*SDI                                 BY21  32
#                                                                       BY21  33
#                                                                       BY21  34
#     ARRAYS ZJ,ZJSD,ZF,ZFSD CONTAIN THE TABULATED VALUES OF XJ,SDJ,    BY21  35
#     XF,SDF, FOR XI = -4.0(0.1)3.0                                     BY21  36
#     LINEAR INTERPOLATION IS USED IN THESE TABLES.                     BY21  37
#                                                                       BY21  38
INTEGER IH,IHP1#                       Table pointers                   BY21  39
INTEGER IQUIT#                         Flag(=0,refl. impossible)        BY21  40
INTEGER IREJ#                          Aplly correction int(=1),fre     BY21  41
REAL A,B,H#                                                             BY21  42
REAL SDF#                                                               BY21  43
REAL SDI#                                                               BY21  44
REAL SDJ#                                                               BY21  45
REAL SIGMA#                                                             BY21  46
REAL XF#                                                                BY21  47
REAL XI#                                                                BY21  48
REAL XJ#                                                                BY21  49
realdata:(ZJ,[0.226,.23,.235,#                                          BY21  50
.24,.246,.25,.257,.263,.27,.276,#                                       BY21  51
.483,.29,.30,.306,.314,.323,.332,#                                      BY21  52
.34,.35,.362,.373,.385,.397,.41,#                                       BY21  53
.424,.44,.454,.47,.487,.505,.525,#                                      BY21  54
.545,.567,.59,.615,.64,.668,.698,#                                      BY21  55
.73,.762,.798,.835,.875,.917,.962,#                                     BY21  56
1.01,1.06,1.112,1.167,1.226,1.287,1.352,#                               BY21  57
1.42,1.49,1.563,1.64,1.717,1.798,1.882,#                                BY21  58
1.967,2.055,2.145,2.236,2.33,2.422,2.518,#                              BY21  59
2.614,2.71,2.808,2.906,3.004])#                                         BY21  60
realdata:(ZJSD,[.217,.22,.226,#                                         BY21  61
.23,.235,.24,.245,.25,.255,.26,#                                        BY21  62
.267,.273,.28,.286,.292,.3,.307,#                                       BY21  63
.314,.322,.33,.34,.348,.357,.367,#                                      BY21  64
.377,.387,.398,.41,.42,.433,.446,#                                      BY21  65
.46,.473,.488,.503,.518,.535,.55,#                                      BY21  66
.568,.586,.604,.622,.64,.66,.68,#                                       BY21  67
.698,.718,.737,.757,.776,.795,.813,#                                    BY21  68
.83,.848,.865,.88,.895,.91,.92,#                                        BY21  69
.933,.943,.953,.96,.968,.974,.98,#                                      BY21  70
.984,.988,.99,.994,.996])#                                              BY21  71
realdata:(ZF,[.423,.428,.432,#                                          BY21  72
.437,.442,.447,.453,.458,.464,.47,#                                     BY21  73
.475,.482,.488,.495,.502,.51,.516,#                                     BY21  74
.524,.532,.54,.549,.557,.567,.576,#                                     BY21  75
.586,.597,.608,.62,.63,.643,.656,#                                      BY21  76
.670,.684,.7,.714,.73,.747,.765,#                                       BY21  77
.783,.802,.822,.843,.865,.887,.91,#                                     BY21  78
.935,.96,.987,1.014,1.042,1.07,1.1,#                                    BY21  79
1.13,1.16,1.192,1.224,1.257,1.29,1.322,#                                BY21  80
1.355,1.388,1.42,1.454,1.487,1.52,1.55,#                                BY21  81
1.583,1.615,1.646,1.676,1.706])#                                        BY21  82
realdata:(ZFSD,[.216,.218,.22,#                                         BY21  83
.222,.224,.226,.23,.23,.234,.236,#                                      BY21  84
.24,.242,.244,.247,.25,.253,.256,#                                      BY21  85
.26,.262,.266,.269,.272,.276,.28,#                                      BY21  86
.283,.287,.29,.295,.298,.302,.307,#                                     BY21  87
.31,.315,.32,.324,.328,.332,.337,#                                      BY21  88
.34,.345,.35,.353,.357,.36,.364,#                                       BY21  89
.367,.37,.372,.374,.375,.376,.377,#                                     BY21  90
.377,.377,.376,.374,.372,.37,.366,#                                     BY21  91
.362,.358,.353,.348,.343,.338,.332,#                                    BY21  92
.327,.32,.315,.31,.304])#                                               BY21  93
datastuff:#                                                             BY21  94
#                                                                       BY21  95
#     IS OBSERVATION POSSIBLE?                                          BY21  96
#                                                                       BY21  97
IQUIT=0#                                                                BY21  98
H=XI/SDI#                                                               BY21  99
IF (H<-3.0) IQUIT=1#                                                    BY21 100
#                                                                       BY21 101
H=H-SDI/SIGMA#                                                          BY21 102
IF (H<-4.0) IQUIT=1#                                                    BY21 103
#                                                                       BY21 104
IF(IQUIT==1)#                                                           BY21 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BY21 106
IF(IREJ==1)#                                                            BY21 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BY21 108
XJ=0.0#                                                                 BY21 109
SDJ=1.0#                                                                BY21 110
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BY21 111
ELSE IF(IREJ==2)#                                                       BY21 112
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BY21 113
XF=0.0#                                                                 BY21 114
SDF=1.0#                                                                BY21 115
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BY21 116
RETURN#                                                                 BY21 117
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BY21 118
#                                                                       BY21 119
#       IS RELECTION BEYOND UPPER LIMIT                                 BY21 120
#       OF TABLE, IF SO CONSIDER AS                                     BY21 121
#       GAUSSIAN WITH MEAN = (XI-SDI**2/SIGMA)                          BY21 122
#                                                                       BY21 123
IF (H>=2.999999)#                                                       BY21 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BY21 125
H=H*SDI#                                                                BY21 126
IF(IREJ==1)#                                                            BY21 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BY21 128
XJ=H#                                                                   BY21 129
SDJ=SDI#                                                                BY21 130
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BY21 131
ELSE IF(IREJ==2)#                                                       BY21 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BY21 133
XF=SQRT(H)#                                                             BY21 134
SDF=SDI*0.5/XF#                                                         BY21 135
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BY21 136
RETURN#                                                                 BY21 137
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BY21 138
#                                                                       BY21 139
#     ELSE LOCATE XI IN THE TABLES                                      BY21 140
#                                                                       BY21 141
H=H+4.0#                                                                BY21 142
IH=H*10.0#                                                              BY21 143
A=(H-IH*0.1)*10.0#                                                      BY21 144
B=1.0-A#                                                                BY21 145
IH=IH+1#                                                                BY21 146
IHP1=IH+1#                                                              BY21 147
#                                                                       BY21 148
#     INTERPOLATE IN THE TABLES                                         BY21 149
#                                                                       BY21 150
IF(IREJ==1)#                                                            BY21 151
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BY21 152
XJ=(A*ZJ(IHP1)+B*ZJ(IH))*SDI#                                           BY21 153
SDJ=(A*ZJSD(IHP1)+B*ZJSD(IH))*SDI#                                      BY21 154
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BY21 155
ELSE IF(IREJ==2)#                                                       BY21 156
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BY21 157
SDF=SQRT(SDI)#                                                          BY21 158
XF=(A*ZF(IHP1)+B*ZF(IH))*SDF#                                           BY21 159
SDF=(A*ZFSD(IHP1)+B*ZFSD(IH))*SDF#                                      BY21 160
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BY21 161
RETURN#                                                                 BY21 162
END#                                                                    BY21 163
#                                                                       BY21 164
systemheader:(BY22)#                   Centric case                     BY22   1
############################################################            BY22   2
#                                                                       BY22   3
#                                                                       BY22   4
#                               BY22                                    BY22   5
#                                                                       BY22   6
#                                                                       BY22   7
############################################################            BY22   8
SUBROUTINE BY22 (XI,SDI,SIGMA,XJ,SDJ,XF,SDF,IREJ)#                      BY22   9
#                                                                       BY22  10
#     GIVEN AN OBSERVED INTENSITY AND ITS ASSOCIATED STANDARD           BY22  11
#     DEVIATION, THE SUBROUTINE CALCULATES AND RETURNS THE              BY22  12
#     POSTERIOR MEAN AND STANDARD DEVIATION OF BOTH THE TRUE            BY22  13
#     INTENSITY AND THE TRUE STRUCTURE FACTOR MODULUS.                  BY22  14
#                                                                       BY22  15
#     THE PRIOR DISTRIBUTION USED IS WILSON'S DISTRIBUTION              BY22  16
#     FOR A CENTRIC REFLECTION.  FOR EXACT FORM SEE FRENCH              BY22  17
#     AND WILSON (1977) EQUATION (2.3)                                  BY22  18
#                                                                       BY22  19
#                                                                       BY22  20
#     ARGUMENTS:                                                        BY22  21
#     XI    - OBSERVED FSQRD                                            BY22  22
#     SDI   - S.D. OF OBSERVATION                                       BY22  23
#     SIGMA - PARAMETER FOR WILSON'S DISTRIBUTION                       BY22  24
#     XJ    - POSTERIOR MEAN FOR THE TRUE FSQRD                         BY22  25
#     SDJ   - POSTERIOR S.D. FOR THE TRUE FSQRD                         BY22  26
#     XF    - POSTERIOR MEAN FOR THE TRUE STRUCTURE FACTOR MODULUS      BY22  27
#     SDF   - POSTERIOR S.D. FOR THE TRUE STRUCTURE FACTOR MODULUS      BY22  28
#     IREJ  - ON ENTRY:  =  2   IF ONLY XF AND SDF REQUIRED.            BY22  29
#                        =  1   IF ONLY XJ AND SDJ REQUIRED.            BY22  30
#                                                                       BY22  31
#     A REFLECTION IS CONSIDERED IMPOSSIBLE IF:                         BY22  32
#                                                                       BY22  33
#     (1)  XI < -3.0*SDI                                                BY22  34
#     (2)  (XI-SDI**2/SIGMA) < -4.0*SDI                                 BY22  35
#                                                                       BY22  36
#                                                                       BY22  37
#     ARRAYS ZJ,ZJSD,ZF,ZFSD CONTAIN THE TABULATED VALUES OF XJ,SDJ,    BY22  38
#     XF,SDF, FOR XI = -4.0(0.1)4.0                                     BY22  39
#     LINEAR INTERPOLATION IS USED IN THESE TABLES.                     BY22  40
#                                                                       BY22  41
#                                                                       BY22  42
#                                                                       BY22  43
INTEGER IH,IHP1#                       Table pointers                   BY22  44
INTEGER IQUIT#                         Flag(=0,refl. impossible)        BY22  45
INTEGER IREJ#                          Aplly correction int(=1),fre     BY22  46
REAL A,B,H#                                                             BY22  47
REAL SDF#                                                               BY22  48
REAL SDI#                                                               BY22  49
REAL SDJ#                                                               BY22  50
REAL SIGMA#                                                             BY22  51
REAL XF#                                                                BY22  52
REAL XI#                                                                BY22  53
REAL XJ#                                                                BY22  54
REAL XI2,XI4,XXF,XSDF#                                                  BY22  55
#                                                                       BY22  56
realdata:(ZJ,[$#                                                        BY22  57
.114,.116,.12,.12,.124,.13,.13,#                                        BY22  58
.134,.137,.14,.145,.15,.15,.16,#                                        BY22  59
.16,.166,.17,.177,.18,.19,.195,#                                        BY22  60
.2,.21,.22,.225,.234,.24,.25,#                                          BY22  61
.26,.275,.29,.3,.314,.33,.345,#                                         BY22  62
.36,.38,.4,.425,.45,.475,.5,#                                           BY22  63
.534,.57,.603,.64,.684,.73,.78,#                                        BY22  64
.83,.89,.95,1.02,1.09,1.164,1.244,#                                     BY22  65
1.33,1.416,1.51,1.6,1.7,1.805,1.91,#                                    BY22  66
2.015,2.12,2.23,2.34,2.45,2.564,2.674,#                                 BY22  67
2.784,2.894,3.,3.11,3.22,3.33,3.435,#                                   BY22  68
3.54,3.65,3.75,3.96])#                                                  BY22  69
realdata:(ZJSD,[$#                                                      BY22  70
.16,.16,.165,.17,.17,.176,.18,#                                         BY22  71
.184,.19,.19,.197,.2,.207,.21,#                                         BY22  72
.22,.224,.23,.236,.243,.25,.257,#                                       BY22  73
.265,.273,.28,.29,.3,.31,.32,#                                          BY22  74
.33,.343,.355,.37,.38,.397,.41,#                                        BY22  75
.43,.445,.463,.48,.5,.52,.543,#                                         BY22  76
.565,.59,.613,.64,.664,.69,.72,#                                        BY22  77
.745,.773,.8,.83,.855,.88,.906,#                                        BY22  78
.93,.95,.97,.99,1.004,1.02,1.03,#                                       BY22  79
1.04,1.044,1.05,1.05,1.054,1.054,1.053,#                                BY22  80
1.05,1.05,1.047,1.044,1.04,1.04,1.036,#                                 BY22  81
1.034,1.03,1.03,1.03])#                                                 BY22  82
realdata:(ZF,[$#                                                        BY22  83
.27,.27,.276,.28,.283,.286,.29,#                                        BY22  84
.293,.297,.3,.305,.31,.314,.32,#                                        BY22  85
.323,.33,.333,.339,.344,.35,.356,#                                      BY22  86
.363,.37,.377,.384,.39,.4,.41,#                                         BY22  87
.42,.427,.44,.45,.46,.47,.484,#                                         BY22  88
.5,.51,.527,.543,.56,.58,.597,#                                         BY22  89
.62,.64,.66,.687,.713,.74,.77,#                                         BY22  90
.8,.83,.866,.9,.94,.976,1.016,#                                         BY22  91
1.057,1.1,1.14,1.183,1.227,1.27,1.313,#                                 BY22  92
1.356,1.4,1.44,1.48,1.52,1.56,1.595,#                                   BY22  93
1.63,1.667,1.7,1.735,1.767,1.8,1.83,#                                   BY22  94
1.86,1.89,1.917,1.945])#                                                BY22  95
realdata:(ZFSD,[$#                                                      BY22  96
.203,.205,.207,.21,.21,.214,.216,#                                      BY22  97
.229,.22,.224,.227,.23,.233,.236,#                                      BY22  98
.239,.243,.246,.25,.253,.257,.26,#                                      BY22  99
.265,.27,.273,.28,.283,.29,.293,#                                       BY22 100
.3,.303,.31,.314,.32,.327,.333,#                                        BY22 101
.34,.346,.353,.36,.37,.375,.383,#                                       BY22 102
.39,.4,.405,.413,.42,.427,.433,#                                        BY22 103
.44,.445,.45,.454,.457,.46,.46,#                                        BY22 104
.46,.46,.455,.45,.445,.44,.43,#                                         BY22 105
.42,.41,.4,.39,.38,.37,.36,#                                            BY22 106
.35,.34,.33,.32,.31,.304,.297,#                                         BY22 107
.29,.284,.28,.27])#                                                     BY22 108
datastuff:#                                                             BY22 109
#                                                                       BY22 110
#     IS OBSERVATION POSSIBLE?                                          BY22 111
#                                                                       BY22 112
IQUIT=0#                                                                BY22 113
H=XI/SDI#                                                               BY22 114
IF (H<-3.0) IQUIT=1#                                                    BY22 115
#                                                                       BY22 116
H=H-SDI/SIGMA*0.5#                                                      BY22 117
IF (H<-4.0) IQUIT=1#                                                    BY22 118
#                                                                       BY22 119
IF(IQUIT==1)#                                                           BY22 120
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BY22 121
IF(IREJ==1)#                                                            BY22 122
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BY22 123
XJ=0.0#                                                                 BY22 124
SDJ=1.0#                                                                BY22 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BY22 126
ELSE IF(IREJ==2)#                                                       BY22 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BY22 128
XF=0.0#                                                                 BY22 129
SDF=1.0#                                                                BY22 130
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BY22 131
RETURN#                                                                 BY22 132
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BY22 133
#                                                                       BY22 134
#       IF REFLECTION IS OUTSIDE THE UPPER LIMIT                        BY22 135
#       OF THE TABLR RANGE, MAKE AN APPROXIMATION.                      BY22 136
#                                                                       BY22 137
IF (H>=3.999999)#                                                       BY22 138
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BY22 139
XI2=1.0/(H*H)#                                                          BY22 140
XI4=XI2*XI2#                                                            BY22 141
XXF=SQRT(H)*(1.0-0.375*XI2-0.6796875*XI4)#                              BY22 142
XSDF=SQRT(H*(0.25*XI2+0.46875*XI4))#                                    BY22 143
IF(IREJ==1)#                                                            BY22 144
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BY22 145
XJ=H*(1.0-0.5*XI2-0.75*XI4)#                                            BY22 146
SDJ=SDI*XSDF*2.0*SQRT(XJ)#                                              BY22 147
XJ=XJ*SDI#                                                              BY22 148
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BY22 149
ELSE IF(IREJ==2)#                                                       BY22 150
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BY22 151
SDF=SQRT(SDI)#                                                          BY22 152
XF=XXF*SDF#                                                             BY22 153
SDF=XSDF*SDF#                                                           BY22 154
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BY22 155
RETURN#                                                                 BY22 156
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BY22 157
#                                                                       BY22 158
#                                                                       BY22 159
#     ELSE LOCATE XI IN THE TABLES                                      BY22 160
#                                                                       BY22 161
H=H+4.0#                                                                BY22 162
IH=H*10.0#                                                              BY22 163
A=(H-IH*0.1)*10.0#                                                      BY22 164
B=1.0-A#                                                                BY22 165
IH=IH+1#                                                                BY22 166
IHP1=IH+1#                                                              BY22 167
#                                                                       BY22 168
#     INTERPOLATE IN THE TABLES                                         BY22 169
#                                                                       BY22 170
IF(IREJ==1)#                                                            BY22 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BY22 172
XJ=(A*ZJ(IHP1)+B*ZJ(IH))*SDI#                                           BY22 173
SDJ=(A*ZJSD(IHP1)+B*ZJSD(IH))*SDI#                                      BY22 174
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BY22 175
ELSE IF(IREJ==2)#                                                       BY22 176
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BY22 177
SDF=SQRT(SDI)#                                                          BY22 178
XF=(A*ZF(IHP1)+B*ZF(IH))*SDF#                                           BY22 179
SDF=(A*ZFSD(IHP1)+B*ZFSD(IH))*SDF#                                      BY22 180
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BY22 181
RETURN#                                                                 BY22 182
END#                                                                    BY22 183
pmacro:([no:])#                        Purge xtal system macros         BY22 184
