systemheader:(CG    )#                                                  CG     1
####################################################################    CG     2
##      Copyright (C) 2000, The Xtal System, The University of        # CG     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # CG     4
## Distributed under the GNU General Public Licence as published by   # CG     5
## the Free Software Foundation, in the hope that it will be useful   # CG     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # CG     7
## for more details.                                                  # CG     8
#                                                                  #    CG     9
#                           *** CHARGE ***                         #    CG    10
#                                                                  #    CG    11
#      THE PROGRAM CG IS USED TO CALCULATE CHARGES FROM            #    CG    12
#      THE DIFFERENCE FOURIER ACCORDING THE HIRSHFELD              #    CG    13
#      PARTITIONING. WEIGHTS ARE DETERMINED FROM THE               #    CG    14
#      PROMOLECULAR DENSITY OR POTENTIAL.                          #    CG    15
#                                                                  #    CG    16
####################################################################    CG    17
#                                                                       CG    18
include:(XMACRO)#                                                       CG    19
#                                                                       CG    20
macro:(rmax:,6.0)#                     Maximum radius, adjustable       CG    21
macro:(name:,incr:(arith:(23,/,mxchwd:)))# Words for 24 char's          CG    22
#                                                                       CG    23
extrude:(CGCOMN)#                                                       CG    24
INTEGER NUM#                           Number of atom types             CG    25
INTEGER PROF#                          Profile type 1=den,2=pot         CG    26
REAL  PROFIL(15,44)#                   Atomic profiles                  CG    27
REAL ATMRD(15)#                        Atomic radii                     CG    28
REAL VOL#                              Cell volume                      CG    29
#                                                                       CG    30
COMMON /COMICG/ NUM,PROF#                                               CG    31
COMMON /COMFCG/ PROFIL,ATMRD,VOL#                                       CG    32
endext:#                                                                CG    33
#                                                                       CG    34
systemheader:(CG00)#                   Calculate charges                CG00   1
#####################################################################   CG00   2
#                                                                   #   CG00   3
#                          CG00                                     #   CG00   4
#                                                                   #   CG00   5
#####################################################################   CG00   6
SUBROUTINE CG00#                       Nick spadaccini mar87            CG00   7
#                                      V. streltsov 1992                CG00   8
include:(AACOMN)#                      Include aa common                CG00   9
include:(CGCOMN)#                      Include cg common                CG00  10
#                                                                       CG00  11
FILEXT(ioda1:)='XXD'#                  Direct access binary file        CG00  12
FILEXT(IOUNIT(3))='MAP'#               Ext of input fourr map           CG00  13
#                                                                       CG00  14
CALL CG10#                             Call main routine                CG00  15
#                                                                       CG00  16
RETURN#                                                                 CG00  17
END#                                                                    CG00  18
systemheader:(CG10)#                   First line controls.             CG10   1
#####################################################################   CG10   2
#                                                                   #   CG10   3
#                               CG10                                #   CG10   4
#                                                                   #   CG10   5
#####################################################################   CG10   6
SUBROUTINE CG10#                                                        CG10   7
include:(AACOMN)#                      Include aa common.               CG10   8
include:(CGCOMN)#                      Include cg common.               CG10   9
#                                                                       CG10  10
INTEGER I,II,I1,I2,IM#                 Working indices                  CG10  11
INTEGER J,JJ,J1,J2,J3#                 Working indices                  CG10  12
INTEGER K,M1#                          Working indices                  CG10  13
INTEGER BEGIN,IEND#                    Limits of input fields.          CG10  14
INTEGER FIELD,MATCH#                   Pointers                         CG10  15
INTEGER PACKET#                        Current bdf packet               CG10  16
INTEGER LATYP,ICENT,TOTSYM,NSYM#       Symops parameters                CG10  17
INTEGER IP,PSIZE#                      Bdf packet pointers              CG10  18
INTEGER MARKS,MARK2,MARK3,MARK4#       Qx array markers                 CG10  19
INTEGER STEPS,STEP2,STEP3#             Step size in qx array            CG10  20
INTEGER IWNT(10),IREL(11),KEY(4)#      Directory info                   CG10  21
INTEGER IPTS(3)#                       Num. of points lay/dow/acr       CG10  22
INTEGER ISUM1,ISUM2,ISUM3,JSUM1,JSUM2,JSUM3# Axial permutations         CG10  23
INTEGER POINT#                         General pointer                  CG10  24
INTEGER NSCL#                          Number of sg                     CG10  25
INTEGER SCGRP#                         Sg number                        CG10  26
INTEGER IMUL#                          Reflection mult.                 CG10  27
INTEGER IDISC#                         Rejection flag                   CG10  28
INTEGER IR1,IR2,IR3,IR4,IR5#           Buffer pointers                  CG10  29
INTEGER IPT1,IPT2,IPT3#                Number of l/d/a points           CG10  30
#                                                                       CG10  31
INTEGER KK#                                                             CG10  32
REAL ARAD,SIGC#                                                         CG10  33
REAL BORDER,BORDR2#                    Border distance and square       CG10  34
REAL CONTCT,CONTC2#                    Contact distance and square      CG10  35
REAL RAD(44)#                          Profile points                   CG10  36
REAL CELL(9)#                          Cell parameters                  CG10  37
REAL VOLP#                             Pixel volume                     CG10  38
REAL R(9)#                             Metric tensor                    CG10  39
REAL ORGX(3)#                          Xyz origin in frac               CG10  40
REAL INCX(3)#                          Xyz increment in grids           CG10  41
REAL GRIDX(3)#                         Xyz grids                        CG10  42
REAL PTX(3)#                           Xyz points                       CG10  43
REAL ENDX(3)#                          Xyz end in frac                  CG10  44
REAL XNEW(3),YNEW(3),DIF(3)#           Temporary coords                 CG10  45
REAL DIST#                             Distance                         CG10  46
REAL P#                                Interpolation parameter          CG10  47
REAL ORGS(3)#                          L/d/a origin in grids            CG10  48
REAL INCS(3)#                          L/d/a increment in grids         CG10  49
REAL GRIDS(3)#                         L/d/a/ grids                     CG10  50
REAL ORG1,ORG2,ORG3#                   L/d/a origin in frac             CG10  51
REAL INC1,INC2,INC3#                   L/d/a increment in frac          CG10  52
REAL RAD2(25)#                         Error profile points             CG10  53
REAL ERR(25)#                          Error profile                    CG10  54
REAL ADD#                              Summation term                   CG10  55
REAL STL#                              Sin(theta)/lamda                 CG10  56
REAL SIG2#                             Sig(f)**2                        CG10  57
REAL AMUL#                             Reflection mult.                 CG10  58
REAL FPI#                              4pi                              CG10  59
REAL SR#                               Stl*r                            CG10  60
REAL SKAL(65),SCALE#                   Scale factors                    CG10  61
REAL IJ(3)#                            Cell translations                CG10  62
REAL RHO#                              Difference density value         CG10  63
REAL TOTRHO#                           Promolecular density             CG10  64
REAL PRHO#                             Atomic density                   CG10  65
REAL SUMRHO#                           Total charge of input            CG10  66
REAL WT1,WT2,WT3#                      Density point weights            CG10  67
#                                                                       CG10  68
chardata:(CG101,DEN POT BOR CON )#                                      CG10  69
chardata:(CG102, END   )#                                               CG10  70
chardata:(CG103, CHARGE CONTROL PARAMETERS)#                            CG10  71
chardata:(CG104, BORDER DISTANCE          ANGSTROMS)#                   CG10  72
chardata:(CG105, CONTACT DISTANCE         ANGSTROMS)#                   CG10  73
chardata:(CG106, PARTITIONING WEIGHTS ON  DENSITY      )#               CG10  74
chardata:(CG107, LAYOUT OF INPUT MAP)#                                  CG10  75
chardata:(CG108, X DIRECTION FROM        TO          )#                 CG10  76
chardata:(CG109, VOLUME OF DENSITY POINT             )#                 CG10  77
chardata:(CG10A, TOTAL CHARGE IN INPUT MAP           )#                 CG10  78
chardata:(CG10B, ATOMIC CHARGES)#                                       CG10  79
chardata:(CG10C, CONTRIBUTIONS     CHARGE SIG       RADIUS)#            CG10  80
chardata:(CG10D, X Y Z POTENTIAL -)#                                    CG10  81
chardata:(CG10E, ERROR PROFILE     RADIUS         SIG)#                 CG10  82
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              CG10  83
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              CG10  84
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              CG10  85
realdata:(TR21,[.3333333,.5])#                                          CG10  86
realdata:(TR22,[.6666667,0.])#                                          CG10  87
realdata:(TR23,[.6666667,.5])#                                          CG10  88
realdata:(ANG,[0.529177])#             Conversion ang to bohr           CG10  89
datastuff:#                                                             CG10  90
#                                                                       CG10  91
#     SET DEFAULTS                                                      CG10  92
#     ------------                                                      CG10  93
#                                                                       CG10  94
PROF=1#                                Assume density profile           CG10  95
CONTCT=rmax:#                          Contact distance in ang.         CG10  96
BORDER=rmax:#                          Border extension in ang.         CG10  97
STEPS=12#                              Trans matrix size                CG10  98
#                                                                       CG10  99
RAD(1)=0.0#                            Initial point in profile         CG10 100
DO J=2,44 ; RAD(J)=(RAD(J-1)+0.01)*1.15# Determine profile points       CG10 101
DO J=1,44 ; RAD(J)=(RAD(J)*ANG)**2#    Convert to r**2 in ang           CG10 102
#                                                                       CG10 103
FOR(FIELD=1;BUFIN(FIELD)<voidflg:;FIELD=FIELD+1)# Loop fields           CG10 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CG10 105
stringlim:(FIELD,BEGIN,IEND)#          Find field limits                CG10 106
compchar:(CHRIN,BEGIN,CG101,1,3,4,NCG101,MATCH)#                        CG10 107
IF (MATCH==1) PROF=1#                  Use density profiles             CG10 108
ELSE IF (MATCH==2) PROF=2#             Use potential profiles           CG10 109
ELSE IF (MATCH==3)#                    Border distance                  CG10 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CG10 111
FIELD=FIELD+1#                         Increment field pointer          CG10 112
IF (BUFIN(FIELD)>voidflg:) BORDER=BUFIN(FIELD)# Read distance           CG10 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CG10 114
ELSE IF (MATCH==4)#                    Contact distance                 CG10 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CG10 116
FIELD=FIELD+1#                         Increment field pointer          CG10 117
IF (BUFIN(FIELD)>voidflg:) CONTCT=BUFIN(FIELD)# Read distance           CG10 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CG10 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CG10 120
#                                                                       CG10 121
BORDR2=BORDER**2#                      Border distance squared          CG10 122
CONTC2=CONTCT**2#                      Contact distance squared         CG10 123
readline:(CG102,NCG102)#               Read end line                    CG10 124
#                                                                       CG10 125
IOMARK(1)=QXSTR#                       Start of i/o buffer 1            CG10 126
incrqx:(IOMARK(3),IOMARK(1)+bdfbuf:,CG1005)# Request buffer 1           CG10 127
incrqx:(MARKS,IOMARK(3)+bdfbuf:,CG1010)# Request buffer 3               CG10 128
#                                                                       CG10 129
#    READ CELL INFORMATION                                              CG10 130
#    ---------------------                                              CG10 131
#                                                                       CG10 132
PACKET=0#                              Initial packet                   CG10 133
REPEAT#                                Read in cell information         CG10 134
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CG10 135
readwpkt:(1,lrcell:,PSIZE,IP,0)#       Read packet                      CG10 136
IF(IP<=0) BREAK#                       End of logical record            CG10 137
PACKET=PACKET+1#                       Increment packet pointer         CG10 138
IF(PACKET==1) movereal:(QX,IP+1,CELL,1,9,0)# Store cell dimensions      CG10 139
IF(PACKET==6) movereal:(QX,IP+1,VOL,1,1,0)# Store cell volume           CG10 140
IF(PACKET==7) movereal:(QX,IP+1,R,1,9,0)# Store metric tensor           CG10 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CG10 142
#                                                                       CG10 143
#     EXTRACT SYMMETRY INFORMATION FROM BDF                             CG10 144
#     -------------------------------------                             CG10 145
#                                                                       CG10 146
readwpkt:(1,lrsymm:,PSIZE,IP,0)#       First packet                     CG10 147
IF(IP<=0) iquit:(CG1015)#              Non-existant.....631015          CG10 148
LATYP=NINT(QX(IP+1))#                  Lattice type                     CG10 149
IF(LATYP>7) LATYP=LATYP-7#             Remove centricity                CG10 150
ICENT=NINT(QX(IP+2))#                  Centre flag (c=0,nc=1)           CG10 151
NSYM=NINT(QX(IP+4))#                   Number of matrices on bdf        CG10 152
TOTSYM=NINT(QX(IP+3))*STEPS#           Initial memory requirements      CG10 153
incrqx:(I,MARKS+TOTSYM,CG1020)#        Symops memory....631020          CG10 154
#                                                                       CG10 155
#     READ IN SYMOPS                                                    CG10 156
#     --------------                                                    CG10 157
#                                                                       CG10 158
FOR (J=MARKS;J>0;J=J+STEPS)#           Loop over symops in bdf          CG10 159
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CG10 160
readwpkt:(1,lrsymm:,PSIZE,IP,0)#       Read in buffer                   CG10 161
IF(IP<=0) BREAK#                       End of record                    CG10 162
movereal:(QX,IP+1,QX,J+1,PSIZE,1)#     Move contents                    CG10 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CG10 164
#                                                                       CG10 165
#     EXPAND SYMOP TABLE TO ALL OPERATIONS                              CG10 166
#     ------------------------------------                              CG10 167
#                                                                       CG10 168
K=MARKS+NSYM*STEPS ; I=K#              Point to end of symops           CG10 169
IF(ICENT==0)#                          If centrosymmetric               CG10 170
FOR (J=MARKS;J<I;J=J+1)#               Loop over current symops         CG10 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CG10 172
K=K+1#                                 Increment pointer                CG10 173
QX(K)=-QX(J+1)#                        Store inverse                    CG10 174
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CG10 175
I=K#                                   Current end pointer              CG10 176
IF(LATYP>1)#                           Apply centering translations     CG10 177
FOR (J=MARKS;J<I;J=J+STEPS)#           Loop over current symops         CG10 178
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CG10 179
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rotation elements       CG10 180
QX(K+10)=QX(J+10)+TR11(LATYP-1)#       Transfer t1                      CG10 181
QX(K+11)=QX(J+11)+TR12(LATYP-1)#       Transfer t2                      CG10 182
QX(K+12)=QX(J+12)+TR13(LATYP-1)#       Transfer t3                      CG10 183
K=K+STEPS#                             Increment pointer                CG10 184
IF((LATYP==2)\(LATYP>4)) NEXT#         Skip if not rhom or f-centre     CG10 185
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rotation elements       CG10 186
QX(K+10)=QX(J+10)+TR21(LATYP-2)#       Transfer t1                      CG10 187
QX(K+11)=QX(J+11)+TR22(LATYP-2)#       Transfer t2                      CG10 188
QX(K+12)=QX(J+12)+TR23(LATYP-2)#       Transfer t3                      CG10 189
K=K+STEPS#                             Increment pointer                CG10 190
IF(LATYP!=4) NEXT#                     Skip if not f-centre             CG10 191
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rotation elements       CG10 192
QX(K+10)=QX(J+10)+0.5#                 Transfer t1                      CG10 193
QX(K+11)=QX(J+11)+0.5#                 Transfer t2                      CG10 194
QX(K+12)=QX(J+12)+0.0#                 Transfer t3                      CG10 195
K=K+STEPS#                             Increment pointer                CG10 196
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CG10 197
MARK2=K#                               Symops end marker                CG10 198
#                                                                       CG10 199
CALL CG11#                             Get profile                      CG10 200
#                                                                       CG10 201
#     READ SCALE FACTOR                                                 CG10 202
#     -----------------                                                 CG10 203
#                                                                       CG10 204
IWNT(1)=1 ; IWNT(2)=100#               Data set and num scales          CG10 205
KEY(1)=1 ; KEY(2)=2 ; KEY(3)=0 ; KEY(4)=0#                              CG10 206
indexpkt:(1,lrexpl:,PSIZE,IP,0,KEY,IWNT,IREL)#                          CG10 207
IF(IP<=0) iquit:(CG1025)#              Lrexpl: missing....631025.       CG10 208
IF(KEY(4)<=0) iquit:(CG1030)#          Item missing....631030.          CG10 209
NSCL=1 ; SKAL(1)=0.#                   Default 1 scale only             CG10 210
FOR(I=IP+1;I<=IP+PSIZE;I=I+1)#                                          CG10 211
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CG10 212
IF((QX(I)<100.9)\(QX(I)>164.1)) NEXT#                                   CG10 213
J=NINT(QX(I))-100#                                                      CG10 214
SKAL(J)=FLOAT(I-IP)#                                                    CG10 215
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CG10 216
REPEAT#                                                                 CG10 217
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CG10 218
readwpkt:(1,lrexpl:,PSIZE,IP,0)#                                        CG10 219
IF(IP<=0) BREAK#                                                        CG10 220
I=IP+IREL(1)#                                                           CG10 221
IF(NINT(QX(I))!=1) NEXT#               Only one data set allowed        CG10 222
I=IP+IREL(2) ; IF(I>IP) NSCL=NINT(QX(I))#                               CG10 223
DO I=1,NSCL#                                                            CG10 224
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CG10 225
J=IP+NINT(SKAL(I))#                                                     CG10 226
IF(J>IP) SKAL(I)=QX(J)#                                                 CG10 227
ELSE SKAL(I)=1.0#                                                       CG10 228
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CG10 229
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CG10 230
#                                                                       CG10 231
#     READ ATOM COORDS FROM BDF                                         CG10 232
#     -------------------------                                         CG10 233
#                                                                       CG10 234
STEP2=12#                              Atom xyz,pointer,charge,name     CG10 235
IWNT(1)=1 ; IWNT(2)=2#                 X and y coords                   CG10 236
IWNT(3)=3 ; IWNT(4)=14#                Z and atom name                  CG10 237
IWNT(5)=22#                            Scat/profile pointer             CG10 238
KEY(1)=5 ; KEY(2)=0#                   All mandatory                    CG10 239
KEY(3)=0 ; KEY(4)=0#                                                    CG10 240
indexpkt:(1,lratom:,PSIZE,IP,0,KEY,IWNT,IREL)# Search directory         CG10 241
IF(IP<=0) iquit:(CG1035)#              Lratom: missing....631035        CG10 242
IF(KEY(4)<=0) iquit:(CG1040)#          Item missing....631040           CG10 243
IR1=IREL(1) ; IR2=IREL(2)#             Store pointers                   CG10 244
IR3=IREL(3) ; IR4=IREL(4)#                                              CG10 245
IR5=IREL(5)#                                                            CG10 246
J=MARK2#                               Pointer to atom list             CG10 247
REPEAT#                                                                 CG10 248
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CG10 249
readwpkt:(1,lratom:,PSIZE,IP,0)#       Read buffer                      CG10 250
IF(IP<=0) BREAK#                       End of atom record               CG10 251
incrqx:(MARK3,J+STEP2,CG1045)#         Request space....631045.         CG10 252
QX(J+1)=QX(IP+IR1)#                    Store x                          CG10 253
QX(J+2)=QX(IP+IR2)#                    Store y                          CG10 254
QX(J+3)=QX(IP+IR3)#                    Store z                          CG10 255
QX(J+4)=QX(IP+IR5)#                    Sf/profile pointer               CG10 256
movereal:(QX,IP+IR4,QX,J+7,name:,1)#   Store atom name as real          CG10 257
J=J+STEP2#                             Increment pointer                CG10 258
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CG10 259
MARK3=J#                               End of atom list                 CG10 260
#                                                                       CG10 261
#     READ LAYOUT OF DIFFERENCE DENSITY MAP FROM X3                     CG10 262
#     ---------------------------------------------                     CG10 263
#                                                                       CG10 264
readwpkt:(3,21,PSIZE,IP,0)#            Read lr21                        CG10 265
DO I=1,3#                                                               CG10 266
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CG10 267
ORGS(I)=QX(IP+1)#                      Origins                          CG10 268
INCS(I)=QX(IP+4)#                      Increments                       CG10 269
GRIDS(I)=QX(IP+7)#                     Grids                            CG10 270
IPTS(I)=NINT(QX(IP+10))#               Points along axes                CG10 271
IP=IP+1#                                                                CG10 272
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CG10 273
ISUM1=NINT(QX(IP+10))#                 Summation order indices          CG10 274
ISUM2=NINT(QX(IP+11))#                                                  CG10 275
ISUM3=NINT(QX(IP+12))#                                                  CG10 276
JSUM1=NINT(QX(IP+13))#                 Summation order permutation      CG10 277
JSUM2=NINT(QX(IP+14))#                                                  CG10 278
JSUM3=NINT(QX(IP+15))#                                                  CG10 279
#                                                                       CG10 280
#     DETERMINE THE MAP LIMITS IN XYZ ORDER                             CG10 281
#     AND IN FRACTIONS OF THE UNIT CELL                                 CG10 282
#     -------------------------------------                             CG10 283
#                                                                       CG10 284
GRIDX(1)=GRIDS(ISUM1)#                 Number of grids in x             CG10 285
GRIDX(2)=GRIDS(ISUM2)#                 Number of grids in y             CG10 286
GRIDX(3)=GRIDS(ISUM3)#                 Number of grids in z             CG10 287
PTX(1)=FLOAT(IPTS(ISUM1))#             Number of points in x            CG10 288
PTX(2)=FLOAT(IPTS(ISUM2))#             Number of points in y            CG10 289
PTX(3)=FLOAT(IPTS(ISUM3))#             Number of points in z            CG10 290
INCX(1)=INCS(ISUM1)#                   Increment in x                   CG10 291
INCX(2)=INCS(ISUM2)#                   Increment in y                   CG10 292
INCX(3)=INCS(ISUM3)#                   Increment in z                   CG10 293
ORGX(1)=ORGS(ISUM1)/GRIDX(1)#          X origin in frac coords          CG10 294
ORGX(2)=ORGS(ISUM2)/GRIDX(2)#          Y origin in frac coords          CG10 295
ORGX(3)=ORGS(ISUM3)/GRIDX(3)#          Z origin in frac coords          CG10 296
ENDX(1)=ORGX(1)+(PTX(1)-1.)*INCX(1)/GRIDX(1)# X end in frac coords      CG10 297
ENDX(2)=ORGX(2)+(PTX(2)-1.)*INCX(2)/GRIDX(2)# Y end in frac coords      CG10 298
ENDX(3)=ORGX(3)+(PTX(3)-1.)*INCX(3)/GRIDX(3)# Z end in frac coords      CG10 299
ORG1=ORGS(1)/GRIDS(1)#                 Layer origin in frac             CG10 300
ORG2=ORGS(2)/GRIDS(2)#                 Down origin in frac              CG10 301
ORG3=ORGS(3)/GRIDS(3)#                 Across origin in frac            CG10 302
INC1=INCS(1)/GRIDS(1)#                 Layer increment in frac          CG10 303
INC2=INCS(2)/GRIDS(2)#                 Down increment in frac           CG10 304
INC3=INCS(3)/GRIDS(3)#                 Across increment in frac         CG10 305
#                                                                       CG10 306
VOLP=VOL/(GRIDX(1)*GRIDX(2)*GRIDX(3))# Volume of each pixel             CG10 307
#                                                                       CG10 308
#     DETERMINE FULL ARRAY OF ATOMS CONTRIBUTING                        CG10 309
#     TO THE CHARGE CALCULATION                                         CG10 310
#     ------------------------------------------                        CG10 311
#                                                                       CG10 312
M1=MARK3#                              Current atom marker              CG10 313
JJ=MARK3#                              Marker for array                 CG10 314
STEP3=6#                               6 words required                 CG10 315
IM=1#                                  Initial atom pointer             CG10 316
FOR(J=MARK2;J<MARK3;J=J+STEP2)#        Loop over bdf atoms              CG10 317
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CG10 318
FOR(K=MARKS;K<MARK2;K=K+STEPS)#        Loop over symops                 CG10 319
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CG10 320
DO I1=1,3#                             Loop over bdf atom xyz           CG10 321
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CG10 322
XNEW(I1)=0.#                           Zero coords                      CG10 323
DO I2=1,3#                             Coord symop                      CG10 324
XNEW(I1)=XNEW(I1)+QX(J+I2)*QX(K+I1+(I2-1)*3)# Rotation matrix           CG10 325
XNEW(I1)=XNEW(I1)+QX(K+9+I1)#          Translation                      CG10 326
WHILE(XNEW(I1)<ORGX(I1)) XNEW(I1)=XNEW(I1)+1.# Move towards origin      CG10 327
WHILE(XNEW(I1)>ORGX(I1)) XNEW(I1)=XNEW(I1)-1.# Move towards origin      CG10 328
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CG10 329
DO J1=1,4#                             Upto 4 cells                     CG10 330
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CG10 331
IJ(1)=FLOAT(J1-1)#                     Cell translations                CG10 332
DO J2=1,4#                             Upto 4 cells                     CG10 333
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CG10 334
IJ(2)=FLOAT(J2-1)#                     Cell translations                CG10 335
DO J3=1,4#                             Upto 4 cells                     CG10 336
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CG10 337
IJ(3)=FLOAT(J3-1)#                     Cell translations                CG10 338
DIST=0.#                               Zerorize                         CG10 339
IDISC=no:#                             Set discard to no                CG10 340
DO I=1,3#                              Loop over new xyz                CG10 341
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CG10 342
YNEW(I)=XNEW(I)+IJ(I)#                 Apply cell translations          CG10 343
IF(YNEW(I)<ORGX(I)) DIF(I)=YNEW(I)-ORGX(I)# Frac coord beyond edge      CG10 344
ELSE IF(YNEW(I)>ENDX(I)) DIF(I)=YNEW(I)-ENDX(I)# Ditto                  CG10 345
ELSE DIF(I)=0.#                        Within region                    CG10 346
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CG10 347
#                                                                       CG10 348
DO I1=1,3 ; DO I2=1,3#                 Distance from point to atom      CG10 349
DIST=DIST+DIF(I1)*R((I1-1)*3+I2)*DIF(I2)# Distance squared              CG10 350
IF(DIST>BORDR2) NEXT#                  Outside limits                   CG10 351
#                                                                       CG10 352
FOR(II=M1;II<JJ;II=II+STEP3)#          Ensure atom isn't repeated       CG10 353
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CG10 354
IF(ABS(YNEW(1)-QX(II+1))>.001) NEXT#   If xyz differences are all >.0   CG10 355
IF(ABS(YNEW(2)-QX(II+2))>.001) NEXT#   Then the atom is unique. else    CG10 356
IF(ABS(YNEW(3)-QX(II+3))>.001) NEXT#   It is already stored             CG10 357
ELSE#                                  Atom is a repeat                 CG10 358
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CG10 359
IDISC=yes:#                            Discard it                       CG10 360
BREAK#                                 Break from the search loop       CG10 361
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CG10 362
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CG10 363
IF(IDISC==yes:) NEXT#                  Donot store                      CG10 364
incrqx:(MARK4,JJ+STEP3,CG1045)#        Request space....631045          CG10 365
DO I=1,3#                              Loop over xyz                    CG10 366
QX(JJ+I)=YNEW(I)#                      Store xyz                        CG10 367
QX(JJ+4)=IM#                           Store atom name pointer          CG10 368
movereal:(QX,J+4,QX,JJ+5,2,1)#         Profile pointer and charge       CG10 369
QX(J+6)=QX(J+6)+1.#                    One more contributor             CG10 370
JJ=JJ+STEP3#                           Increment qx                     CG10 371
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CG10 372
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CG10 373
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CG10 374
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CG10 375
M1=JJ#                                 New atom marker                  CG10 376
IM=IM+1#                               Next bdf atom                    CG10 377
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CG10 378
MARK4=JJ#                              End of contributors array        CG10 379
#                                                                       CG10 380
#     READ IN DELRHO POINT BY POINT AND DETERMINE                       CG10 381
#     THE CONTRIBUTION OF EACH ATOM                                     CG10 382
#     -------------------------------------------                       CG10 383
#                                                                       CG10 384
IPT1=IPTS(1)#                          Points in layer                  CG10 385
IPT2=IPTS(2)#                          Points down                      CG10 386
IPT3=IPTS(3)#                          Points across                    CG10 387
SUMRHO=0.#                             Zero                             CG10 388
DO I=1,IPT1#                           Loop over layers                 CG10 389
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CG10 390
WT1=1.0#                               Weight is 1.                     CG10 391
IF((I==1)\(I==IPT1)) WT1=.5#           On an edge, down weight          CG10 392
XNEW(JSUM1)=ORG1+FLOAT(I-1)*INC1#      Coord of density point           CG10 393
DO J=1,IPT2#                           Down direction                   CG10 394
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CG10 395
WT2=WT1#                               Set weight                       CG10 396
IF((J==1)\(J==IPT2)) WT2=WT1*.5#       Also an edge, further down wei   CG10 397
XNEW(JSUM2)=ORG2+FLOAT(J-1)*INC2#      Coord of density point           CG10 398
readwpkt:(3,22,PSIZE,IP,0)#            Read packet of rho               CG10 399
IF(IP==0) BREAK#                       End of lr22                      CG10 400
DO K=1,IPT3#                           Across direction                 CG10 401
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CG10 402
WT3=WT2#                               Set weight                       CG10 403
IF((K==1)\(K==IPT3)) WT3=WT2*.5#       An edge, further down weight     CG10 404
XNEW(JSUM3)=ORG3+FLOAT(K-1)*INC3#      Coord of density point           CG10 405
TOTRHO=0.#                             Zero promolecular density        CG10 406
RHO=QX(IP+K)*WT3#                      Value of rho                     CG10 407
SUMRHO=SUMRHO+RHO#                     Sum density of input map         CG10 408
FOR(JJ=MARK3;JJ<MARK4;JJ=JJ+STEP3)#    Loop over contributors           CG10 409
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CG10 410
DIST=0.0#                              Zero distance                    CG10 411
DO II=1,3#                                                              CG10 412
DIF(II)=XNEW(II)-QX(JJ+II)#            Atom-point distance              CG10 413
DO I1=1,3 ; DO I2=1,3#                                                  CG10 414
DIST=DIST+DIF(I1)*R((I1-1)*3+I2)*DIF(I2)# Dist**2 in angstroms          CG10 415
IF(DIST>CONTC2) QX(JJ+6)=0.#           Too far                          CG10 416
ELSE#                                  Partition the point              CG10 417
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CG10 418
DO KK=1,44#                                                             CG10 419
IF((RAD(KK)<=DIST)&(RAD(KK+1)>DIST)) BREAK# Limits of interpolation     CG10 420
POINT=NINT(QX(JJ+5))#                  Profile pointer                  CG10 421
P=(DIST-RAD(KK))/(RAD(KK+1)-RAD(KK))#  Interpol. parameter              CG10 422
PRHO=(1.-P)* PROFIL(POINT,KK)+P* PROFIL(POINT,KK+1)# Atomic density     CG10 423
QX(JJ+6)=PRHO#                         Store atomic density             CG10 424
TOTRHO=TOTRHO+PRHO#                    Total promol. density            CG10 425
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CG10 426
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CG10 427
ifne:(TOTRHO,.0) TOTRHO=RHO/TOTRHO#                                     CG10 428
FOR(JJ=MARK3;JJ<MARK4;JJ=JJ+STEP3)#    Loop over contributors           CG10 429
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CG10 430
POINT=MARK2+(NINT(QX(JJ+4))-1)*STEP2+5# Point to original atom          CG10 431
QX(POINT)=QX(POINT)+QX(JJ+6)*TOTRHO#   Store weighted contribution      CG10 432
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CG10 433
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CG10 434
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CG10 435
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CG10 436
#                                                                       CG10 437
SUMRHO=-SUMRHO*VOLP#                   Total charge of input map        CG10 438
FOR(JJ=MARK2;JJ<MARK3;JJ=JJ+STEP2)#    Loop over bdf atoms              CG10 439
QX(JJ+5)=-QX(JJ+5)*VOLP#               Convert to electrons             CG10 440
#                                                                       CG10 441
#                                                                       CG10 442
#     ERRORS IN CHARGES. ASSUME CENTRIC DISTRIBUTION                    CG10 443
#     OF REFLECTIONS                                                    CG10 444
#     ----------------------------------------------                    CG10 445
#                                                                       CG10 446
FPI=12.56637#                          Four pi                          CG10 447
DO I=1,25 ; RAD2(I)=FLOAT(I)/10.#      Set error points                 CG10 448
#                                                                       CG10 449
IWNT(1)=2 ; IWNT(2)=3 ; IWNT(3)=1305 ; IWNT(4)=1309# Stl,mult,sigf,sg   CG10 450
KEY(1)=3 ; KEY(2)=0 ; KEY(3)=0 ; KEY(4)=0# First 3 mandatory            CG10 451
indexpkt:(1,lrrefl:,PSIZE,IP,0,KEY,IWNT,IREL)# Read lrrefl:             CG10 452
IF(IP<=0) iquit:(CG1055)#              Lrrefl: missing....631055        CG10 453
IF(KEY(4)<=0) iquit:(CG1060)#          Item(s) missing....631060        CG10 454
IR1=IREL(1) ; IR2=IREL(2) ; IR3=IREL(3) ; IR4=IREL(4)# Store pointers   CG10 455
IF(IR4<=0) SCALE=SKAL(1)#              No sg number, default=1          CG10 456
REPEAT#                                                                 CG10 457
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CG10 458
readwpkt:(1,lrrefl:,PSIZE,IP,0)#       Read logical record              CG10 459
IF(IP<=0) BREAK#                       End of lr                        CG10 460
STL=QX(IP+IR1)*FPI#                    4pi*stl                          CG10 461
IF(IR4>0)#                             Sg number there                  CG10 462
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CG10 463
SCGRP=NINT(QX(IP+IR4))#                Sg number                        CG10 464
SCALE=SKAL(SCGRP)#                     Scale factor                     CG10 465
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CG10 466
intunpak:(QX(IP+IR2),IMUL,0,5)#        Unpack the reflection mult.      CG10 467
AMUL=FLOAT(IMUL)#                      Reflection multiplicity          CG10 468
SIG2=(SCALE*QX(IP+IR3))**2#            Sig(fo)**2                       CG10 469
DO I=1,25#                             Loop over error points           CG10 470
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CG10 471
SR=STL*RAD2(I)#                        4pi*stl*r                        CG10 472
ADD=((SIN(SR)-SR*COS(SR))/SR**3)**2#   Trig term                        CG10 473
ERR(I)=ERR(I)+AMUL*SIG2*ADD#           Sum error terms                  CG10 474
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CG10 475
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CG10 476
DO I=1,25#                             Loop over error points           CG10 477
ERR(I)=FPI*(RAD2(I)**3)*SQRT(ERR(I))/VOL# Sig(q)                        CG10 478
#                                                                       CG10 479
#     TELL USER EVERYTHING                                              CG10 480
#     --------------------                                              CG10 481
#                                                                       CG10 482
movechar:(CG10D,NCG10D,CHROT,2,NCG103-1,1)# Underline header            CG10 483
writeline:(2,CG103,NCG103,2,3)#        Output header                    CG10 484
IF(PROF==2) movechar:(CG10D,8,CG106,26,9,0)# Potential used             CG10 485
writeline:(0,CG106,NCG106,3,3)#        Output profile type              CG10 486
ncodefld:(BORDER,1,CG104,250422.,1)#   Encode border                    CG10 487
writeline:(0,CG104,NCG104,3,3)#                                         CG10 488
ncodefld:(CONTCT,1,CG105,250422.,1)#   Encode contact                   CG10 489
writeline:(0,CG105,NCG105,3,3,)#                                        CG10 490
movechar:(CG10D,NCG10D,CHROT,2,NCG107-1,1)# Underline                   CG10 491
writeline:(1,CG107,NCG107,2,3)#        Layout header                    CG10 492
DO I=1,3#                                                               CG10 493
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CG10 494
ncodefld:(ORGX(I),1,CG108,240632.,1)#  Encode xyz origins               CG10 495
ncodefld:(ENDX(I),1,CG108,340632.,1)#  Encode xyz ends                  CG10 496
movechar:(CG10D,2*I,CG108,2,1,0)#      Encode directions xyz            CG10 497
writeline:(0,CG108,NCG108,3,3)#                                         CG10 498
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CG10 499
ncodefld:(VOLP,1,CG109,340752.,1)#     Encode pixel volume              CG10 500
writeline:(0,CG109,NCG109,3,3)#                                         CG10 501
ncodefld:(SUMRHO,1,CG10A,340752.,1)#   Encode input map charge          CG10 502
writeline:(0,CG10A,NCG10A,3,3)#                                         CG10 503
movechar:(CG10D,NCG10D,CHROT,2,NCG10B-1,1)# Underline                   CG10 504
writeline:(1,CG10B,NCG10B,2,3); LINRM=5# Charges header                 CG10 505
HEADOT=' '; HEADOT(LABMAX+4^)=CG10C#   Store header line                CG10 506
#                                                                       CG10 507
FOR(JJ=MARK2;JJ<MARK3;JJ=JJ+STEP2)#    Bdf atoms list                   CG10 508
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 CG10 509
LCHROT=LABMAX+4#                       Set format pointer               CG10 510
movertoc:(QX(JJ+7),1,CHROT,2,24,0)#    Encode atom name                 CG10 511
ncodefld:(QX,JJ+6,CHROT,513.,1)#       Number of contributions          CG10 512
ncodefld:(QX,JJ+5,CHROT,1552.,1)#      Charge                           CG10 513
POINT=NINT(QX(JJ+4))#                  Profile pointer                  CG10 514
ARAD=ATMRD(POINT)#                     Atomic radius                    CG10 515
DO I=1,25#                                                              CG10 516
IF((RAD2(I)<=ARAD)&(RAD2(I+1)>ARAD)) BREAK# Limits of interpolation     CG10 517
P=(ARAD-RAD2(I))/(RAD2(I+1)-RAD2(I))#  Interpol. parameter              CG10 518
SIGC=(1.-P)*ERR(I)+P*ERR(I+1)#         Sig(q) at this radius            CG10 519
LCHROT=LABMAX+26#                      Set format pointer               CG10 520
ncodefld:(SIGC,1,CHROT,732.,1)#        Encode sig(q)                    CG10 521
ncodefld:(ARAD,1,CHROT,1222.,1)#       Encode radius                    CG10 522
writeline:(0,HEADOT,100,1,3)#                                           CG10 523
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CG10 524
movechar:(CG10D,NCG10D,CHROT,2,13,1)#  Partial underline                CG10 525
writeline:(1,CG10E,NCG10E,2,3)#        Error profile header             CG10 526
DO I=1,25#                                                              CG10 527
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 CG10 528
ncodefld:(RAD2,I,CHROT,240422.,1)#     Encode radii                     CG10 529
ncodefld:(ERR,I,CHROT,360432.,1)#      Encode sig(q)                    CG10 530
writeline:(0,0,0,1,3)#                                                  CG10 531
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 CG10 532
#                                                                       CG10 533
readwpkt:(3,endrecord:,PSIZE,IP,0)#    Close map file                   CG10 534
readwpkt:(1,endrecord:,PSIZE,IP,0)#    Close input bdf                  CG10 535
RETURN#                                                                 CG10 536
END#                                                                    CG10 537
#                                                                       CG10 538
systemheader:(CG11)#                   Determine density profile        CG11   1
#####################################################################   CG11   2
#                                                                   #   CG11   3
#                              CG11                                 #   CG11   4
#                                                                   #   CG11   5
#####################################################################   CG11   6
SUBROUTINE  CG11#                                                       CG11   7
#                                                                       CG11   8
include:(AACOMN)#                                                       CG11   9
include:(CGCOMN)#                                                       CG11  10
#                                                                       CG11  11
INTEGER LNBLNK# ## function returning integer                           CG11  12
INTEGER I#                                                              CG11  13
INTEGER IWNT(2),IREL(3),KEY(4)#        Lr information                   CG11  14
INTEGER IR1,IR2#                       Buffer pointers                  CG11  15
INTEGER IP,PSIZE#                      Packet information               CG11  16
INTEGER KK,LL,MM#                      Working index                    CG11  17
CHARACTER LINE(80)#                                                     CG11  18
#                                                                       CG11  19
REAL VOLR#                             Volume of atoms                  CG11  20
REAL CONT#                             Atomic cell contents             CG11  21
REAL RATIO#                            Vol of atoms/ cell vol           CG11  22
REAL SCAT#                                                              CG11  23
#                                                                       CG11  24
VOLR=0.#                               Zero the value                   CG11  25
CONT=0.#                               Zero the value                   CG11  26
RATIO=1.#                              Default                          CG11  27
IWNT(1)=3 ; IWNT(2)=1#                 Sf pointer & contents            CG11  28
KEY(1)=2 ; KEY(2)=0 ; KEY(3)=0 ; KEY(4)=0#                              CG11  29
indexpkt:(1,lrscat:,PSIZE,IP,0,KEY,IWNT,IREL)#                          CG11  30
IF(IP<=0) iquit:(CG1105)#              Lr missing....631105             CG11  31
IF(KEY(4)<=0) iquit:(CG1110)#          Item missing....631110           CG11  32
IR1=IREL(1) ; IR2=IREL(2)#             Store pointers                   CG11  33
NUM=1#                                 First atom type                  CG11  34
openfmt:(iofm1:,profile:)#             Open profile database            CG11  35
opendac:(ioda1:,1,80,' ')#             Open direct access profile       CG11  36
KK=1#                                                                   CG11  37
REPEAT#                                                                 CG11  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CG11  39
readfmt:(iofm1:,'(80A1)',100,LINE)#    Read database                    CG11  40
writedac:(ioda1:,['(80A1)',],KK,LINE)# Write direc-access record        CG11  41
KK=KK+1#                               Record number                    CG11  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CG11  43
100 closefmt:(iofm1:)#                                                  CG11  44
REPEAT#                                                                 CG11  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CG11  46
readwpkt:(1,lrscat:,PSIZE,IP,0)#                                        CG11  47
IF(IP<=0) BREAK#                       End of lr                        CG11  48
SCAT=QX(IP+IR1)#                       Atomic number                    CG11  49
CONT=QX(IP+IR2)#                       Number atoms in cell             CG11  50
KK=NINT(24.*(SCAT-1.)+1.)#             Record number atoms radius       CG11  51
readdac:(ioda1:,['(30X,F5.3)',],KK,ATMRD(NUM))# Get relative radius     CG11  52
VOLR=VOLR+CONT*ATMRD(NUM)**3#          Relative volume                  CG11  53
IF(NINT(SCAT)>74) iquit:(CG1115)#      Non-existant....631115           CG11  54
IF(PROF==1) KK=NINT(24.*(SCAT-1.)+2.)# Record no. density profile       CG11  55
ELSE        KK=NINT(24.*(SCAT-1.)+14.)# Potential profile               CG11  56
DO MM=0,10#                            Loop over records                CG11  57
readdac:(ioda1:,['(4F15.7)',],KK+MM,( PROFIL(NUM,LL),$# Get points      CG11  58
LL=MM*4+1,MM*4+4))#                    Profil                           CG11  59
NUM=NUM+1#                                                              CG11  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CG11  61
closedac:(ioda1:)#                     Close database                   CG11  62
VOLR=4.18879*VOLR#                     Volume of all atoms              CG11  63
RATIO=(VOL/VOLR)**.333333#             Scale relative radii             CG11  64
DO I=1,NUM; ATMRD(I)=ATMRD(I)*RATIO#                                    CG11  65
RETURN#                                                                 CG11  66
END#                                                                    CG11  67
pmacro:([no:])#                                                         CG11  68
