systemheader:(CM    )#                                                  CM     1
####################################################################### CM     2
##      Copyright (C) 2000, The Xtal System, The University of        # CM     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # CM     4
## Distributed under the GNU General Public Licence as published by   # CM     5
## the Free Software Foundation, in the hope that it will be useful   # CM     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # CM     7
## for more details.                                                  # CM     8
##                                                                    # CM     9
##                           *** SCATOM ***                           # CM    10
##                                                                    # CM    11
##   Given an ABINIT ground state VALENCE electron density            # CM    12
##   distribution, obtained for a monatomic crystal comprised of      # CM    13
##   non-interacting spherically symmetric atoms, IF we read          # CM    14
##   the density into XTAL and reverse fourier transform the density  # CM    15
##   to structure factors, THEN here we should be able to             # CM    16
##   deconvolute the structure factor into the scattering factor      # CM    17
##   function of (Sin theta)/lamda. Ideally we could then             # CM    18
##   determine analogues of the Cromer-Mann coefficients of the       # CM    19
##   scattering factor expansion F(s)=a1Exp(-b1s^2)+...+c             # CM    20
##   This would permit convenient spherical valence density           # CM    21
##   subtraction from the ABINIT maps for comparison with actual      # CM    22
##   measured electron densities. In principle .....                  # CM    23
##   Currently we just calculate the form factor at various points    # CM    24
##   And interpolate to a grid of values                              # CM    25
##                                                                    # CM    26
##   Hacked from FC by ddb@r3401.msl.titech.ac.jp   Dec 2001          # CM    27
##                Ignore most of the FC specific remnant code.        # CM    28
##                It needs cleaning up, but that would imply that it  # CM    29
##                was worthwhile and deserved it ...                  # CM    30
####################################################################### CM    31
#                                                                       CM    32
include:(XMACRO)#                                                       CM    33
macro:(aitkeninterp:,CM07($1,$2,$3,$4))# Aitken interpolation func      CM    34
macro:(atomlist:,[ifelse:($1,,M,$1)])# Define atom list pointer         CM    35
macro:(scat:,[QX(atomlist:($1)+1)])#                                    CM    36
macro:(xif:, [QX(atomlist:($1)+1+$2)])#                                 CM    37
macro:(pmul:,[QX(atomlist:($1)+5)])#                                    CM    38
macro:(bis:, [QX(atomlist:($1)+6)])#                                    CM    39
macro:(bij:, [QX(atomlist:($1)+5+$2)])#                                 CM    40
macro:(mxat:,16)#                                                       CM    41
#                                                                       CM    42
extrude:(CMCOMN)#                                                       CM    43
REAL ARCH(20)#                         Archive list                     CM    44
REAL ADI(mxat:),ADR(mxat:)#            Anomalous dispersion terms       CM    45
REAL ATA(mxat:)#                       Number of atoms in unit cell     CM    46
REAL ATP(mxat:)#                       And in a partial structure       CM    47
REAL ATZ(mxat:)#                       Atomic numbers                   CM    48
REAL BOVL#                             Overall tf                       CM    49
INTEGER CENT#                          Centro flag                      CM    50
INTEGER DISP#                          Dispersion flag                  CM    51
REAL DLIS#                             List > fdiff value               CM    52
REAL DSTL#                             Delta st/l for ff table          CM    53
REAL DSNM#                             Data set number                  CM    54
REAL ELIM#                             Limit of e value                 CM    55
REAL FMUL#                             S.f. multiplicity                CM    56
INTEGER IATM#                          Atom list increment              CM    57
INTEGER ICORE#                         Calculate frel from core+...     CM    58
INTEGER IEXT#                          Extinction flag                  CM    59
INTEGER IFFF#                          Refl form factor flag            CM    60
INTEGER IP,JP#                         Working ip/op pointers           CM    61
INTEGER ISEL#                          Select flag: 1 select/2 omit     CM    62
INTEGER ISCF#                          Step in ff name list             CM    63
INTEGER ISIM#                          Sim weight flag                  CM    64
INTEGER ISIN#                          Sin/cos lookup flag              CM    65
INTEGER ITEM#                          Number of archive items          CM    66
INTEGER IREL(67)#                      Relative packet pointers         CM    67
INTEGER IRF,IRH,IRJ,IRL,IRS,IRX,IEV#   Relative pointers                CM    68
INTEGER IPH,IFA,IFB,IRFO#              Relative pointers                CM    69
INTEGER IWNT(66)#                      Want list of idnums              CM    70
INTEGER KEY(4)#                        Indexpkt control signals         CM    71
INTEGER LPAK#                          Input packet length              CM    72
INTEGER MARK1#                         Start-1 of sym matrices          CM    73
INTEGER MARK2#                         Start-1 of ff name list          CM    74
INTEGER MARK3#                         Start-1 of scatfac table         CM    75
INTEGER MARK4#                         Start-1 of scale list            CM    76
INTEGER MARK5#                         Start-1 of select list           CM    77
INTEGER MARK6#                         Start-1 of atoms list            CM    78
INTEGER MARK7#                         Start-1 of sin/cos table         CM    79
INTEGER MARK8#                                                          CM    80
INTEGER STOP8#                                                          CM    81
REAL MAXH,MAXK,MAXL#                   Maximum /h/,/k/,/l/              CM    82
INTEGER NAME#                          Qx step for select list          CM    83
INTEGER NATM#                          Count number of atoms            CM    84
INTEGER IRAD#                          Radiation type flag              CM    85
INTEGER NDEL#                          Extra items in op packet         CM    86
INTEGER NMDS#                          Data set number *1000            CM    87
INTEGER NPAK#                          Output packet length             CM    88
INTEGER NROT#                          Number of rotation matrices      CM    89
INTEGER NSCF#                          Length of ff table               CM    90
INTEGER NSCL#                          Number of scale groups           CM    91
INTEGER NTYP#                          Number of atom types             CM    92
INTEGER OFF(mxat:)#                    Ff table offsets                 CM    93
REAL REJF#                             Reject code flag                 CM    94
REAL SMAX,SMIN#                        Max/min st/l limits              CM    95
REAL SUMC(2,6),SUMD(2,6),SUMN(2,6),SUMR(2,6)# Statistics sums           CM    96
REAL UTOB#                             8*pi**2                          CM    97
REAL UTOBET(6)#                        Convert uij to beta ij           CM    98
INTEGER TYPE#                          Temp. factor type                CM    99
#                                                                       CM   100
COMMON /COMICM/$#                                                       CM   101
CENT,DISP,IATM,IEXT,IFFF,IP,JP,ITEM,ISCF,ISIN,$#                        CM   102
IREL,IWNT,KEY,LPAK,MARK1,MARK2,MARK3,MARK4,ISIM,IEV,$#                  CM   103
MARK5,MARK6,MARK7,NAME,NATM,TYPE,IRF,IRH,IRJ,IRL,IRS,IRX,$#             CM   104
IRAD,NDEL,NMDS,NPAK,NROT,NSCF,NSCL,NTYP,OFF,ISEL,ICORE,$#               CM   105
IPH,IFA,IFB,IRFO,MARK8,STOP8#                                           CM   106
#                                                                       CM   107
COMMON /COMFCM/$#                                                       CM   108
ARCH,ADI,ADR,BOVL,DLIS,DSNM,DSTL,FMUL,$#                                CM   109
MAXH,MAXK,MAXL,REJF,SMIN,SMAX,ATP,ATA,ATZ,$#                            CM   110
SUMC,SUMD,SUMN,SUMR,UTOB,UTOBET,ELIM#                                   CM   111
endext:#                                                                CM   112
#                                                                       CM   113
systemheader:(CM00)#                   Structure factor calculation     CM00   1
# ################################################################## #  CM00   2
#                                                                    #  CM00   3
#                               CM00                                 #  CM00   4
#                                                                    #  CM00   5
# ################################################################## #  CM00   6
SUBROUTINE CM00#                       
include:(AACOMN)#                      
include:(CMCOMN)#                      
#                                                                       CM00  13
CALL CM01#                                                              CM00  14
CALL CM02#                                                              CM00  15
CALL CM03#                                                              CM00  16
CALL CM04#                                                              CM00  17
CALL CM05#                                                              CM00  18
CALL CM06#                                                              CM00  19
#                                                                       CM00  20
RETURN#                                                                 CM00  21
END#                                                                    CM00  22
systemheader:(CM01)#                   Read bdf lrsymm: to lrdset:      CM01   1
# ####################################################################  CM01   2
#                                                                       CM01   3
#                                CM01                                   CM01   4
#                                                                       CM01   5
# ####################################################################  CM01   6
SUBROUTINE CM01#                                                        CM01   7
include:(AACOMN)#                                                       CM01   8
include:(CMCOMN)#                                                       CM01   9
#                                                                       CM01  10
REAL    CELL#                          Cell volume                      CM01  11
INTEGER I,J,K,L#                       Working indices                  CM01  12
INTEGER IDS#                           Compound pointer and offset      CM01  13
INTEGER IPO#                           Pointer to output buffer         CM01  14
INTEGER J2#                            Index for sf names in mark2      CM01  15
#                                                                       CM01  16
chardata:(CM11,SCT NOS OVE ISO ANI MIX POP NOP DIS NOD $#               CM01  17
EXT NOE XRA NEU DSE LIS REJ NLI NRE SIM EGT FRT FRC )#                  CM01  18
datastuff:#                                                             CM01  19
#                                                                       CM01  20
#---------------------------------------------------------------------- CM01  21
#                                                                       CM01  22
# THE CM INPUT LINE CONTAINS CODES TO DIRECT THE SETTING OF THE FOLLOWI CM01  23
# VARIABLES.                                                            CM01  24
#                                                                       CM01  25
# VARIABLE  POSSIBLE  VALUE OF  MEANING                                 CM01  26
#   NAME     CODES    VARIABLE                                          CM01  27
#                                                                       CM01  28
#  ISIN      SCT       YES:    CALC A & B WITH SIN TABLE 0-0/1/449 DEGR CM01  29
#            NOS       NO:     CALC A & B WITH LIBRARY SUBROUTINE       CM01  30
#                                                                       CM01  31
#  TYPE      OVE        2      OVERALL TEMPERATURE FACTOR               CM01  32
#            ISO        3      INDIVIDUAL ISOTROPIC TEMP. FACTORS       CM01  33
#            ANI        4      INDIVIDUAL ANISOTROPIC TEMP. FACTORS     CM01  34
#            MIX        4      MIXED TEMPERATURE FACTORS                CM01  35
#                                                                       CM01  36
#  DISP      DIS       YES:    APPLY ANOMALOUS DISPERSION CORRECTION    CM01  37
#            NOD       NO:     DO NOT APPLY DISPERSION CORRECTION       CM01  38
#                                                                       CM01  39
#  IEXT      EXT       YES:    APPLY EXTINCTION CORRECTION              CM01  40
#            NOE       NO:     DO NOT APPLY EXTINCTION CORRECTION       CM01  41
#                                                                       CM01  42
#  DSNM      DSE       INPUT   DATASET FLAG PRECEDES NUMERIC VALUE THAT CM01  43
#                              FOLLOWS. IF NO VALUE ENTERED SET AT 1.   CM01  44
#                                                                       CM01  45
#  DLIS      LIS       YES:    LIST CM'S IF FDIFF > VALUE FOLLOWING     CM01  46
#            NLI               THIS FLAG. IF NO VALUE INPUT - LIST ALL. CM01  47
#                                                                       CM01  48
#  REJF      REJ       YES:    REJECT REFLN IF JCODE >= VALUE FOLLOWING CM01  49
#            NRE               THIS FLAG.  IF NO VALUE: REJECT > 0.     CM01  50
#                                                                       CM01  51
#  ISIM      SIM       YES:    SIM WEIGHT FOR PARTIAL STRUCTURE         CM01  52
#                      NO:     DEFAULT                                  CM01  53
#                                                                       CM01  54
#---------------------------------------------------------------------- CM01  55
#                                                                       CM01  56
#                                                                       CM01  57
#    DECODE =CM= LINE PARAMETERS                                        CM01  58
#    ---------------------------                                        CM01  59
#                                                                       CM01  60
ISIN=no:#                              Set default parameters           CM01  61
IRAD=3#                                Set default rad as xrays         CM01  62
TYPE=4#                                Set default parameters           CM01  63
ELIM=-1.#                              Set default parameters           CM01  64
DISP=yes:#                             Set default parameters           CM01  65
IFFF=0#                                Set default parameters           CM01  66
IEXT=yes:#                             Set default parameters           CM01  67
DSNM=1.#                               Set default parameters           CM01  68
DLIS=999999.#                          Set default parameters           CM01  69
REJF=6.#                               Set default parameters           CM01  70
ISIM=no:#                              Set default parameters           CM01  71
UTOB=78.9568#                          8*pi**2                          CM01  72
ICORE=0#                               Don't calculate for the core     CM01  73
#                                                                       CM01  74
FOR(I=1;I<30;I=I+1)#                   Loop over input fields           CM01  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CM01  76
ifvo:(BUFIN(I)) BREAK#                 Exit after last field            CM01  77
stringlim:(I,J,K)#                     Find limits of the field         CM01  78
compchar:(CHRIN,J,CM11,1,3,4,NCM11,K)# Find what's there                CM01  79
IF(K==0) iquit:(CM0101,I)#             Dud flag.......fc101             CM01  80
ELSE IF(K==1)  ISIN=yes:#              Do not use lookup table          CM01  81
ELSE IF(K==3)  TYPE=2#                 Overall tf                       CM01  82
ELSE IF(K==4)  TYPE=3#                 Individual isotropic tf          CM01  83
ELSE IF(K==5)  TYPE=4#                 Anisotropic or mixed tf          CM01  84
ELSE IF(K==6)  TYPE=4#                 Anisotropic or mixed tf          CM01  85
ELSE IF(K==10) DISP=no:#               Don't apply disper corr.         CM01  86
ELSE IF(K==12) IEXT=no:#               No extinction corr.              CM01  87
ELSE IF(K==15)#                        Data set number to follow        CM01  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CM01  89
IF(BUFIN(I+1)>voidflg:)#               Should be numeric dsetnum        CM01  90
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CM01  91
DSNM=NINT(BUFIN(I+1))#                 Get dataset number               CM01  92
I=I+1#                                 Advance field counter            CM01  93
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CM01  94
ELSE DSNM=1.#                          Default dataset is 1             CM01  95
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CM01  96
ELSE IF(K==16)#                        Test for list flag               CM01  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CM01  98
IF(BUFIN(I+1)>voidflg:)#               Test if diff limit follows       CM01  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CM01 100
DLIS=NINT(BUFIN(I+1))#                 Extract diff list limit          CM01 101
I=I+1#                                 Advance field counter            CM01 102
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CM01 103
ELSE DLIS=-1.#                         Force all to be listed           CM01 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CM01 105
ELSE IF(K==17)#                        Test for reject refln flag       CM01 106
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CM01 107
IF(BUFIN(I+1)>voidflg:)#               Is reject limit following        CM01 108
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CM01 109
REJF=BUFIN(I+1)-0.5#                   Set up reject limit              CM01 110
I=I+1#                                 Advance field counter            CM01 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CM01 112
ELSE REJF=1.5#                         Default reject all but 1.        CM01 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CM01 114
ELSE IF(K==20) ISIM=yes:#              Apply sim weight                 CM01 115
ELSE IF(K==21)#                        Set limit for e values           CM01 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CM01 117
I=I+1; ELIM=1.5#                       Incr field pointer               CM01 118
IF(BUFIN(I)>voidflg:) ELIM=BUFIN(I)#   Input e limit                    CM01 119
ELSE  I=I-1#                           Assume default of 1.5            CM01 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CM01 121
ELSE IF(K==22) ICORE=1#                Calculate frel from core+valen   CM01 122
ELSE IF(K==23) ICORE=2#                Calculate frel from core         CM01 123
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CM01 124
#                                                                       CM01 125
NMDS=NINT(DSNM)*1000#                  Form dataset offset              CM01 126
#                                                                       CM01 127
#   ASSIGN BDF BUFFERS 1 AND 2                                          CM01 128
#   --------------------------                                          CM01 129
#                                                                       CM01 130
IOMARK(1)=QXSTR#                       Set start of io buffer1          CM01 131
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of buffer2                 CM01 132
incrqx:(MARK1,IOMARK(2)+bdfbuf:,CM0104)# Expand mem.....fc0104          CM01 133
copyfile:(1,2,1,decr:(lrcell:))#       Copy to cell record              CM01 134
#                                                                       CM01 135
#   EXTRACT CELL INFORMATION                                            CM01 136
#   ------------------------                                            CM01 137
#                                                                       CM01 138
DO I=1,100#                            Loop over cell packets           CM01 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CM01 140
readwpkt:(1,lrcell:,LPAK,IP,0)#        Read  1st packet of lrcell       CM01 141
IF(IP<=0) BREAK#                       Exit when finished               CM01 142
writepkt:(2,lrcell:,LPAK,IPO)#         Write 1st packet of lrcell       CM01 143
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Transfer data to output          CM01 144
IF(I!=3) NEXT#                         Skip all but recip constants     CM01 145
UTOBET(1)=19.739209*QX(IP+1)*QX(IP+1)# 2*pi**2*astar**2                 CM01 146
UTOBET(2)=19.739209*QX(IP+2)*QX(IP+2)# 2*pi**2*bstar**2                 CM01 147
UTOBET(3)=19.739209*QX(IP+3)*QX(IP+3)# 2*pi**2*cstar**2                 CM01 148
UTOBET(4)=19.739209*QX(IP+1)*QX(IP+2)# 2*pi**2*astar*bstar              CM01 149
UTOBET(5)=19.739209*QX(IP+1)*QX(IP+3)# 2*pi**2*astar*cstar              CM01 150
UTOBET(6)=19.739209*QX(IP+2)*QX(IP+3)# 2*pi**2*bstar*cstar              CM01 151
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CM01 152
#                                                                       CM01 153
#   EXTRACT SYMMETRY CODES & MATRICES (LRSYMM:)                         CM01 154
#   ---------------------------------------                             CM01 155
#                                                                       CM01 156
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Read first packet of lr lrsy     CM01 157
writepkt:(2,lrsymm:,LPAK,IPO)#         Copy to output file              CM01 158
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#                                     CM01 159
CENT=NINT(QX(IP+2))#                   Centric=0 / acentric=1           CM01 160
NROT=NINT(QX(IP+4))#                   Get number rotation matrices     CM01 161
FMUL=QX(IP+6)#                         Get reflection multiplicity      CM01 162
incrqx:(MARK2,MARK1+NROT*LPAK,CM0105)# Expand qx......fc105             CM01 163
FOR(J=MARK1;J>0;J=J+LPAK)#             Loop over symm matrices          CM01 164
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CM01 165
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Get packet pointer               CM01 166
IF(IP<=0) BREAK#                       Exit after last packet           CM01 167
writepkt:(2,lrsymm:,LPAK,IPO)#         Get pointer to o/p buffer        CM01 168
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    And copy the packet              CM01 169
movereal:(QX,IP+1,QX,J+1,LPAK,1)#      Save the symop for later         CM01 170
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CM01 171
copyfile:(1,2,incr:(lrsymm:),decr:(lrscat:))# Copy to scatt. rec.       CM01 172
#                                                                       CM01 173
#   ENTER SCATT. FACTOR & ATOM SUMMARY (LR LRSCAT:)                     CM01 174
#   ---------------------------------------                             CM01 175
#                                                                       CM01 176
incrqx:(MARK3,MARK2+32,CM0106)#        Save room for 16 sf types        CM01 177
ISCF=incr:(arith:(7,/,mxchwd:))#       Allow for 8 char. per name       CM01 178
J2=MARK2#                              Set marker for first sf name     CM01 179
IWNT(1)=NINT(DSNM+20.);  IWNT(3)=100#  Set real ad & ff idnums          CM01 180
IWNT(2)=NINT(DSNM+60.);  IWNT(4)=10#   Set imag ad & neut ff            CM01 181
IWNT(5)=11 ;  IWNT(6)=7#               Set sf name idnum                CM01 182
IWNT(7)=1#                             Set atom number idnum            CM01 183
IWNT(8)=3#                             Set atom number idnum            CM01 184
KEY(1)=0;  KEY(2)=8;  KEY(3)=0#        Set search delimiters            CM01 185
KEY(4) = 0#                                                             CM01 186
indexpkt:(1,lrscat:,LPAK,IP,2,KEY,IWNT,IREL)# Get packet pointers       CM01 187
IF((IREL(1)==0)&(IREL(2)==0)) DISP=no:# No dispersion values            CM01 188
IF((ISIM==yes:)&(IREL(7)==0))iquit:(CM0110)# No atom number             CM01 189
#                                                                       CM01 190
FOR(I=IP+IREL(3);I<=IP+LPAK;I=I+1)#    Loop over ff list                CM01 191
IF((QX(I)<99.5)\(QX(I)>299.5)) BREAK#  Exit after last ff               CM01 192
IF(IREL(3)>0)  NSCF=I-IP-IREL(3)#      Count contiguous ff              CM01 193
ELSE           NSCF=0#                 Ff table present                 CM01 194
IF(IREL(4)>0)  NSCF=1#                 Count neutron ff                 CM01 195
IF(IREL(3)>0) DSTL=(QX(I-1)-QX(I-2))*.01# Set st/l interval             CM01 196
#                                                                       CM01 197
NTYP=0#                                Zero count of atom types         CM01 198
FOR(J=MARK3;J>0;J=J+NSCF)#             Loop over each atom type         CM01 199
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CM01 200
readwpkt:(1,lrscat:,LPAK,IP,0)#        Get packet pointer               CM01 201
IF(IP<=0) BREAK#                       Exit after last packet           CM01 202
writepkt:(2,lrscat:,LPAK,IPO)#         Get output pointer               CM01 203
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy packet                      CM01 204
L=IP+IREL(5)#                          Set pointer for sf name          CM01 205
movereal:(QX,L,QX,J2+1,ISCF,1)#        Move sf name to mark2 array      CM01 206
J2=J2+ISCF#                            Advance sf name pointer          CM01 207
incrqx:(MARK4,J+NSCF,CM0108)#          Expand qx.......fc108            CM01 208
NTYP=NTYP+1#                           Count atom types                 CM01 209
ADR(NTYP)=0.;   ADI(NTYP)=0.#          Zero dispersion values           CM01 210
I=IP+IREL(1); IF(I>IP) ifnv:(QX(I)) ADR(NTYP)=QX(I)# Get real disp      CM01 211
I=IP+IREL(2); IF(I>IP) ifnv:(QX(I)) ADI(NTYP)=QX(I)# Get imag disp      CM01 212
I=IP+IREL(6); IF(I>IP) IFFF=NINT(QX(I))# Get refl ff flag               CM01 213
I=IP+IREL(7); IF(I>IP) ATA(NTYP)=QX(I)# Get total atom number           CM01 214
I=IP+IREL(8); IF(I>IP) ATZ(NTYP)=QX(I)# Get atomic number               CM01 215
I=IP+IREL(4); IF(I>IP) QX(MARK4)=QX(I)# Store neutron ff                CM01 216
ELSE IF(IREL(3)>0)#                    If xray or electron ff present   CM01 217
FOR(I=J;I<MARK4;I=I+1)#                Loop over sf data points         CM01 218
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CM01 219
K=IP+IREL(3)+I-J#                      Point to each ff value           CM01 220
QX(I+1)=QX(K)#                         Store each ff value              CM01 221
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CM01 222
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CM01 223
copyfile:(1,2,incr:(lrscat:),decr:(lrexpl:))# Copy to experm. rec.      CM01 224
#                                                                       CM01 225
#   ENTER SCALE INFORMATION (LR LREXPL:)                                CM01 226
#   ------------------------------                                      CM01 227
#                                                                       CM01 228
IWNT(1)=1;    IWNT(2)=100#             Set data set & nscl idnums       CM01 229
IWNT(3)=94;   IWNT(4)=22#              Set rad type & cell volume       CM01 230
KEY(1)=1; KEY(2)=4; KEY(3)=0; KEY(4)=0# Set search delimiters           CM01 231
indexpkt:(1,lrexpl:,LPAK,IP,2,KEY,IWNT,IREL)# Get packet pointers       CM01 232
incrqx:(MARK5,MARK4+64,CM0109)#        Expand qx.......fc109            CM01 233
NSCL=1;   QX(MARK4+1)=1.#              Default group & rel pointer&     CM01 234
FOR(I=IP+1;I<=IP+LPAK;I=I+1)#          Loop over directory              CM01 235
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CM01 236
IF((QX(I)<100.9)\(QX(I)>164.1)) NEXT#  Skip if not scale idnm           CM01 237
J=MARK4+NINT(QX(I))-100#               Get group number of scale        CM01 238
QX(J)=FLOAT(I-IP)#                     Store relative position          CM01 239
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CM01 240
REPEAT#                                Loop over data sets              CM01 241
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CM01 242
readwpkt:(1,lrexpl:,LPAK,IP,0)#        Get packet pointer               CM01 243
IF(IP<=0) BREAK#                       Exit after last packet           CM01 244
writepkt:(2,lrexpl:,LPAK,IPO)#         Get o/p buffer pointer           CM01 245
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy the packet                  CM01 246
I=IP+IREL(1); IF(I==IP) NEXT#          Get index of data set no.        CM01 247
ifne:(DSNM,QX(I)) NEXT#                Skip unwanted data set           CM01 248
I=IP+IREL(2); IF(I>IP) NSCL=NINT(QX(I))# Number of scales               CM01 249
FOR(I=MARK4;I<MARK4+NSCL;I=I+1)#       Loop over scale factors          CM01 250
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CM01 251
J=IP+NINT(QX(I+1))#                    Point to scale location          CM01 252
IF(J>IP) QX(I+1)=QX(J)#                Store scale in table             CM01 253
ELSE     QX(I+1)=1.#                   Default scale is 1.              CM01 254
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CM01 255
I=IP+IREL(3); IF(I>IP) IRAD=NINT(QX(I))# Radiation (1=n,2=e;3=x)        CM01 256
I=IP+IREL(4); IF(I>IP) CELL=QX(I)/47.878# Cell volume for elect rad     CM01 257
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CM01 258
IF(IREL(4)==0&IRAD==2) iquit:(CM0102)# Cell volume missing              CM01 259
IF(IRAD==2) FMUL=FMUL/CELL#            Scale structure factor volts     CM01 260
MARK5=MARK4+NSCL#                      Reset mark5 for true nscl        CM01 261
#                                                                       CM01 262
#   ENTER DATA SET INFORMATION (LR LRDSET:)                             CM01 263
#   ---------------------------------                                   CM01 264
#                                                                       CM01 265
IWNT(1)=2;  IWNT(7)=1#                 Request ovb, dataset number      CM01 266
DO I=2,6;   IWNT(I)=I+9#               Request maxhkl, max&min stol     CM01 267
KEY(1)=0;  KEY(2)=7; KEY(3)=0#         Set search delimiters            CM01 268
indexpkt:(1,lrdset:,LPAK,IP,2,KEY,IWNT,IREL)# Search rel pointers       CM01 269
BOVL=0.; SMIN=0.; SMAX=2.#             Set default parameters           CM01 270
MAXH=256.; MAXK=256.; MAXL=256.#       Set default parameters           CM01 271
IF (IP>0) $#                           If there was a directory         CM01 272
REPEAT#                                Loop over data sets              CM01 273
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CM01 274
readwpkt:(1,lrdset:,LPAK,IP,0)#                                         CM01 275
IF(IP<=0) BREAK#                                                        CM01 276
writepkt:(2,lrdset:,LPAK,IPO)#         Get o/p buffer pointer           CM01 277
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy the packet                  CM01 278
IDS=IP+IREL(7)#                        Make pointer to dataset no.      CM01 279
ifne:(DSNM,QX(IDS)) NEXT#              Skip unwanted datasets           CM01 280
I=IP+IREL(1); IF(I>IP) BOVL=QX(I)*UTOB# Get active b overall            CM01 281
I=IP+IREL(2); IF(I>IP) MAXH=QX(I)#     Get active max /h/               CM01 282
I=IP+IREL(3); IF(I>IP) MAXK=QX(I)#     Get active max /k/               CM01 283
I=IP+IREL(4); IF(I>IP) MAXL=QX(I)#     Get active max /l/               CM01 284
I=IP+IREL(5); IF(I>IP) SMIN=QX(I)#     Get active smin                  CM01 285
I=IP+IREL(6); IF(I>IP) SMAX=QX(I)#     Get active smax                  CM01 286
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CM01 287
#                                                                       CM01 288
RETURN#                                                                 CM01 289
END#                                                                    CM01 290
systemheader:(CM02)#                   Read controls                    CM02   1
# ####################################################################  CM02   2
#                                                                       CM02   3
#                                CM02                                   CM02   4
#                                                                       CM02   5
# ####################################################################  CM02   6
SUBROUTINE CM02#                                                        CM02   7
include:(AACOMN)#                                                       CM02   8
include:(CMCOMN)#                                                       CM02   9
#                                                                       CM02  10
INTEGER IARC#                          Archive input flag               CM02  11
INTEGER I,J,K,M#                       Working indices                  CM02  12
#                                                                       CM02  13
chardata:(CM21, SCALE MAXHKL SELECT OMIT ARCHIV END    )#               CM02  14
chardata:(CM22,        )#                                               CM02  15
datastuff:#                                                             CM02  16
#                                                                       CM02  17
#   ENTER CONTROL LINES                                                 CM02  18
#   -------------------                                                 CM02  19
#                                                                       CM02  20
MARK6=MARK5#                           Set select atom marker           CM02  21
NAME=incr:(arith:(23,/,mxchwd:))#      Calc atom name length            CM02  22
DO I=1,7;  ARCH(I)=-FLOAT(NMDS+I+799)# Generate archive list            CM02  23
ARCH(8)=-FLOAT(NMDS+700)#              Generate archive list            CM02  24
ARCH(9)=-FLOAT(NMDS+701)#              Archive ad-correct frel          CM02  25
ARCH(10)=-FLOAT(NMDS+910)#             Sim weight                       CM02  26
ARCH(11)=-FLOAT(NMDS+820)#             Full f calc                      CM02  27
ARCH(12)= FLOAT(NMDS+304)#             To stash frel in outpacket       CM02  28
IARC=0;   ITEM=11;    ISEL=0#          Reset archive parameters         CM02  29
#                                                                       CM02  30
REPEAT#                                Loop over control lines          CM02  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CM02  32
readline:(CM21,NCM21)#                 Process control line             CM02  33
#                                                                       CM02  34
IF(LINID==1)#                          ****** scale *******             CM02  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CM02  36
ifvo:(BUFIN(1)) NEXT#                  Skip if void scale               CM02  37
ifvo:(BUFIN(2)) I=1#                   Default scale group              CM02  38
ELSE             I=NINT(BUFIN(2))#     Enter scale group                CM02  39
QX(MARK4+I)=BUFIN(1)#                  Store scale value                CM02  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CM02  41
#                                                                       CM02  42
ELSE IF(LINID==2)#                     ****** maxhkl *******            CM02  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CM02  44
ifnv:(BUFIN(1)) MAXH=BUFIN(1)#         Set active max /h/               CM02  45
ifnv:(BUFIN(2)) MAXK=BUFIN(2)#         Set active max /k/               CM02  46
ifnv:(BUFIN(3)) MAXL=BUFIN(3)#         Set active max /l/               CM02  47
ifnv:(BUFIN(4)) SMIN=BUFIN(4)#         Set active min st/l              CM02  48
ifnv:(BUFIN(5)) SMAX=BUFIN(5)#         Set active max st/l              CM02  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CM02  50
#                                                                       CM02  51
ELSE IF(LINID==3\LINID==4)#            ****** select/omit *******       CM02  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CM02  53
IF(ISEL==1&LINID==4) iquit:(CM0201)#   Select and omit lines mixed      CM02  54
IF(ISEL==2&LINID==3) iquit:(CM0201)#   Select and omit lines mixed      CM02  55
ISEL=LINID-2#                          Select=1; omit=2                 CM02  56
DO I=1,30#                             Loop over select fields          CM02  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CM02  58
ifvo:(BUFIN(I)) BREAK#                 Exit first inactive field        CM02  59
M=MARK6+1#                             Point to next name               CM02  60
incrqx:(MARK6,MARK6+NAME,CM0202)#      Expand qx......fc202             CM02  61
stringlim:(I,J,K)#                     Extract string limits            CM02  62
K=MIN0(K-J,24)#                        Limit to 24 characters           CM02  63
movector:(CM22,1,QX(M),1,24,1)#        Blank out qx region              CM02  64
movector:(CHRIP,J,QX(M),1,K,0)#        Store name in qx                 CM02  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CM02  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CM02  67
#                                                                       CM02  68
ELSE IF(LINID==5)#                     ***** archiv ******              CM02  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CM02  70
IARC=1#                                Set archive ip flag              CM02  71
DO J=1,30#                             Loop over input fields           CM02  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CM02  73
ifvo:(BUFIN(J)) BREAK#                 Exit after last idnum            CM02  74
FOR(I=1;I<=ITEM;I=I+1)#                Loop over archive list           CM02  75
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CM02  76
ifeq:(BUFIN(J),ARCH(I)) BREAK#         Exit if delete on list           CM02  77
ifne:(BUFIN(J),(-ARCH(I))) NEXT#       Exit if not reverse              CM02  78
ARCH(I)=-ARCH(I)#                      Change delete to add             CM02  79
BREAK#                                 Exit after update                CM02  80
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CM02  81
IF((I<=ITEM)\(BUFIN(J)>0.)) NEXT#      Set if preset or illegal         CM02  82
ITEM=ITEM+1#                           Incr archive list                CM02  83
ARCH(ITEM)=BUFIN(J)#                   Add delete to archive            CM02  84
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CM02  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CM02  86
#                                                                       CM02  87
ELSE BREAK#                            ****** end *******               CM02  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CM02  89
IF(IARC==0)#                           Test if archive input            CM02  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CM02  91
ARCH(1)=-ARCH(1);  ARCH(8)=-ARCH(8)#   Set default add items            CM02  92
ARCH(11)=-ARCH(11)#                    Keep full fcalc                  CM02  93
IF(DISP==yes:) ARCH(9)=-ARCH(9)#       Save ad-corrected frel           CM02  94
IF(ISIM==yes:) ARCH(10)=-ARCH(10)#     Save sim weight                  CM02  95
IF(ICORE!=0)#                                                           CM02  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CM02  97
ARCH(11)=-ABS(ARCH(11));ARCH(1)=-ABS(ARCH(1))# Corrupt so remove them   CM02  98
ARCH(9)=ABS(ARCH(9))#                  Save regardless of disp option   CM02  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CM02 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CM02 101
#                                                                       CM02 102
RETURN#                                                                 CM02 103
END#                                                                    CM02 104
systemheader:(CM03)#                   Get atom parameters from lra     CM03   1
# ####################################################################  CM03   2
#                                                                       CM03   3
#                               CM03                                    CM03   4
#                                                                       CM03   5
# ####################################################################  CM03   6
SUBROUTINE CM03#                                                        CM03   7
include:(AACOMN)#                                                       CM03   8
include:(CMCOMN)#                                                       CM03   9
#                                                                       CM03  10
INTEGER I,J,K,L,M,N#                   Working indices                  CM03  11
INTEGER IPO#                           O/p buffer pointer               CM03  12
INTEGER LIST#                          Number of list items             CM03  13
INTEGER NAT#                           Atom name point                  CM03  14
INTEGER NSTEP#                         Step size per atom in mark6      CM03  15
REAL SMUL#                             Site muliplicity                 CM03  16
REAL POPP#                             Population parameter             CM03  17
REAL X,Y,Z#                            Coordinate storage               CM03  18
#                                                                       CM03  19
string:(NAME1,24)#                     Atom name from bdf               CM03  20
string:(NAME2,24)#                     Selected part atom name          CM03  21
string:(NAME3,24)#                     Atom name left part              CM03  22
chardata:(CM31," x/a    y/b    z/c   $#                                 CM03  23
pp*ml    U11     U22     U33     U12     U13     U23")#                 CM03  24
realdata:(FMT,[742.,742.,742.,622.,842.,842.,842.,842.,842.,842.])#     CM03  25
realdata:(B11,0.); realdata:(B22,0.); realdata:(B33,0.)#                CM03  26
realdata:(B12,0.); realdata:(B13,0.); realdata:(B23,0.)#                CM03  27
datastuff:#                                                             CM03  28
#                                                                       CM03  29
copyfile:(1,2,incr:(lrdset:),decr:(lratom:))# Copy to atom rec.         CM03  30
#                                                                       CM03  31
#--------------------------------------------------------------------   CM03  32
##### LAYOUT OF ATOM PARAMETER STORAGE                                  CM03  33
# RELATIVE ADDRESS                                                      CM03  34
# IN QX ARRAY                                                           CM03  35
#      1                SCAT. FACTOR POINTER                            CM03  36
#      2                X                                               CM03  37
#      3                Y                                               CM03  38
#      4                Z                                               CM03  39
#      5                ATOM MULTIPLICITY * POPULATION                  CM03  40
#      6                BETA11 (OR B)                                   CM03  41
#      7                BETA22 (OR SIGNAL TO B IN 6)                    CM03  42
#      8                BETA 33                                         CM03  43
#      9                BETA 12                                         CM03  44
#     10                BETA 13                                         CM03  45
#     11                BETA 23                                         CM03  46
#---------------------------------------------------------------------- CM03  47
#                                                                       CM03  48
#   LOCATE REQUIRED PARAMETERS IN LR LRATOM:                            CM03  49
#   ----------------------------------                                  CM03  50
#                                                                       CM03  51
IWNT(1)=22; IWNT(14)=21#               Set nscf, mult, tf idnums        CM03  52
IWNT(2)=14; IWNT(13)=11#               Set atom name, neut-flag idnum   CM03  53
DO I=1,3;   IWNT(I+2)=I#               Set x to z idnums                CM03  54
DO I=4,10;  IWNT(I+2)=I#               Set displ. params u uij          CM03  55
IWNT(15)=26#                                                            CM03  56
KEY(1)=5;  KEY(2)=15;  KEY(3)=0#       Set search delimiters            CM03  57
KEY(4)=0#                              Copy mode for indexpkt:          CM03  58
indexpkt:(1,lratom:,LPAK,IP,2,KEY,IWNT,IREL)# Get relative pointers     CM03  59
IF(KEY(4)<0) iquit:(CM0301)#           Data missing.....fc301           CM03  60
#                                                                       CM03  61
IF((TYPE==4)&(IREL(7)<=0)) TYPE=3#     Type 4 needs aniso               CM03  62
IF((TYPE==3)&(IREL(6)<=0)) TYPE=2#     Type 3 calc needs iso b          CM03  63
IF((TYPE==2)&(BOVL<0.)) iquit:(CM0301)# Type 2 needs overall tf         CM03  64
IF((ICORE!=0)&IREL(15)<=0) iquit:(CM0302)# Need core val type           CM03  65
#                                                                       CM03  66
#    RESERVE QX ARRAY FOR ATOM PARAMETERS                               CM03  67
#    ------------------------------------                               CM03  68
#                                                                       CM03  69
IF     (TYPE==1) IATM=5#               Allow for ff,x,y,z,m             CM03  70
ELSE IF(TYPE==2) IATM=5#               Allow for ff,x,y,z,pp            CM03  71
ELSE IF(TYPE==3) IATM=6#               Allow for ff,x,y,z,pp,b          CM03  72
ELSE             IATM=11#              Allow for ff,x,y,z,pp,bij        CM03  73
NSTEP=NROT*IATM#                       Figure step size for each at     CM03  74
HEADOT=' '; HEADOT(14^)=CM31#          Set atom list header             CM03  75
#                                                                       CM03  76
#   EXTRACT ATOM PARAMETERS FROM LR LRATOM:                             CM03  77
#   ---------------------------------                                   CM03  78
#                                                                       CM03  79
writeline:(0,0,0,1,3);  LINRM=4#       Prepare for list header          CM03  80
NATM=0#                                Zero count of selected atoms     CM03  81
DO I=1,mxat:; ATP(I)=0.#               Zero count of atom number        CM03  82
K=MARK6#                               Start atom list pointer          CM03  83
REPEAT#                                Loop over atom packets           CM03  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CM03  85
readwpkt:(1,lratom:,LPAK,IP,0)#        Get packet pointer               CM03  86
IF(IP<=0) BREAK#                       Exit after last packet           CM03  87
writepkt:(2,lratom:,LPAK,IPO)#         Get o/p buffer pointer           CM03  88
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy the packet                  CM03  89
LIST=IATM-1#                           Set number list items            CM03  90
#                                                                       CM03  91
N=IP+IREL(2)#                          Make pointer to atom name        CM03  92
movertoc:(QX(N),1,NAME1,1,24,0)#       Move name to character array     CM03  93
label:(NAME1,I,J)#                     Get max label length             CM03  94
NAME2=NAME1(1^J)#                      Extract scatt fact symbol        CM03  95
FOR(I=MARK5;I<MARK6;I=I+NAME)#         Loop over selected atoms         CM03  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CM03  97
movertoc:(QX(I+1),1,NAME3,1,24,0)#     Move name of selected atom       CM03  98
IF(NAME1==NAME3\NAME2==NAME3) BREAK#   Test atom label or type symbol   CM03  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CM03 100
IF(I>=MARK6&ISEL==1) NEXT#             Skip unselected atoms            CM03 101
IF(I<MARK6&ISEL==2)  NEXT#             Skip omitted atoms               CM03 102
NATM=NATM+1#                           Increment count of found ato     CM03 103
incrqx:(MARK7,K+NSTEP,CM0302)#         Expand qx......fc302             CM03 104
MARK8=MARK7#                                                            CM03 105
#                                                                       CM03 106
I=IP+IREL(1); scat:(K)=QX(I); NAT=NINT(QX(I))# Get sf number pointer    CM03 107
I=IP+IREL(3); X=QX(I)#                 Store x coordinate               CM03 108
I=IP+IREL(4); Y=QX(I)#                 Store y coordinate               CM03 109
I=IP+IREL(5); Z=QX(I)#                 Store z coordinate               CM03 110
I=IP+IREL(13); IF(I>IP) POPP=QX(I)#    Store pop parameter              CM03 111
ELSE POPP=1.#                          Else set to one                  CM03 112
I=IP+IREL(14); IF(I>IP) SMUL=QX(I)#    Store site mult.                 CM03 113
ELSE SMUL=1.#                          Else set to one                  CM03 114
IF (ICORE!=0)#                                                          CM03 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CM03 116
I=IP+IREL(15) ; IF(I>IP) ZCORE=ATZ(NAT)-QX(I)# Store core z             CM03 117
ELSE iquit:(CM0310)#                                                    CM03 118
DO I=1,NTYP; ifeq:(ATZ(I),ZCORE) BREAK#                                 CM03 119
IF(I>NTYP) iquit:(CM0311)#             No matching scattering factors   CM03 120
scat:(K)=FLOAT(I)#                     Use core atom type instead       CM03 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CM03 122
POPP=POPP*SMUL#                        Store combined m*pp              CM03 123
B11=0.#                                Initialize b11                   CM03 124
IF(TYPE>2)#                            Test if more data needed         CM03 125
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CM03 126
I=IP+IREL(6); IF(I>IP) bis:(K)=QX(I)*UTOB# Store isotropic b            CM03 127
ELSE                   bis:(K)=BOVL#   Else store overall b             CM03 128
IF(TYPE==4)#                           Test if more data needed         CM03 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CM03 130
I=IP+IREL(7); IF(I>IP) B11=QX(I)*UTOBET(1)# Extract beta11              CM03 131
IF(B11>0.)#                            Test if aniso or iso tf          CM03 132
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CM03 133
I=IP+IREL(8); B22=QX(I)*UTOBET(2)#     Extract beta22                   CM03 134
I=IP+IREL(9); B33=QX(I)*UTOBET(3)#     Extract beta33                   CM03 135
I=IP+IREL(10); B12=QX(I)*UTOBET(4)#    Extract beta12                   CM03 136
I=IP+IREL(11); B13=QX(I)*UTOBET(5)#    Extract beta13                   CM03 137
I=IP+IREL(12); B23=QX(I)*UTOBET(6)#    Extract beta23                   CM03 138
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CM03 139
ELSE LIST=5#                           Reset list to isotropic          CM03 140
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CM03 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CM03 142
#                                                                       CM03 143
#                                                                       CM03 144
#   GENERATE EQUIVALENT POSITIONS                                       CM03 145
#   -----------------------------                                       CM03 146
#                                                                       CM03 147
M=K-5#                                 Set init betaij test pt to fai   CM03 148
FOR(N=MARK1;N<MARK2;N=N+12)#           Loop over rot matrices           CM03 149
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CM03 150
DO I=1,3#                              Rowxcolumn marix multiply        CM03 151
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CM03 152
J=N+I;   L=K+I+1#                      Increment pointers               CM03 153
xif:(K,I)=X*QX(J)+Y*QX(J+3)+Z*QX(J+6)+QX(J+9)# Matrix multiply          CM03 154
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CM03 155
pmul:(K)=POPP#                         Store site population            CM03 156
#                                                                       CM03 157
IF(B11>0.)#                            Test if aniso needed             CM03 158
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CM03 159
#                                        Calculate beta11               CM03 160
bij:(K,1)= QX(N+1)*QX(N+1)*B11 $#                                       CM03 161
+          QX(N+4)*QX(N+4)*B22 $#                                       CM03 162
+          QX(N+7)*QX(N+7)*B33 $#                                       CM03 163
+    2.0 *(QX(N+1)*QX(N+4)*B12 $#                                       CM03 164
+          QX(N+1)*QX(N+7)*B13 $#                                       CM03 165
+          QX(N+4)*QX(N+7)*B23)#                                        CM03 166
#                                        Calculate beta22               CM03 167
bij:(K,2)= QX(N+2)*QX(N+2)*B11 $#                                       CM03 168
+          QX(N+5)*QX(N+5)*B22 $#                                       CM03 169
+          QX(N+8)*QX(N+8)*B33 $#                                       CM03 170
+    2.0 *(QX(N+2)*QX(N+5)*B12 $#                                       CM03 171
+          QX(N+2)*QX(N+8)*B13 $#                                       CM03 172
+          QX(N+5)*QX(N+8)*B23)#                                        CM03 173
#                                        Calculate beta33               CM03 174
bij:(K,3)= QX(N+3)*QX(N+3)*B11 $#                                       CM03 175
+          QX(N+6)*QX(N+6)*B22 $#                                       CM03 176
+          QX(N+9)*QX(N+9)*B33 $#                                       CM03 177
+    2.0 *(QX(N+3)*QX(N+6)*B12 $#                                       CM03 178
+          QX(N+3)*QX(N+9)*B13 $#                                       CM03 179
+          QX(N+6)*QX(N+9)*B23)#                                        CM03 180
#                                        Calculate beta12               CM03 181
bij:(K,4)=  QX(N+1)*QX(N+2)*B11 $#                                      CM03 182
+           QX(N+4)*QX(N+5)*B22 $#                                      CM03 183
+           QX(N+7)*QX(N+8)*B33 $#                                      CM03 184
+          (QX(N+2)*QX(N+4)     $#                                      CM03 185
+           QX(N+1)*QX(N+5))*B12$#                                      CM03 186
+          (QX(N+2)*QX(N+7)     $#                                      CM03 187
+           QX(N+1)*QX(N+8))*B13$#                                      CM03 188
+          (QX(N+5)*QX(N+7)     $#                                      CM03 189
+           QX(N+4)*QX(N+8))*B23#                                       CM03 190
#                                        Calculate beta13               CM03 191
bij:(K,5)=  QX(N+1)*QX(N+3)*B11 $#                                      CM03 192
+           QX(N+4)*QX(N+6)*B22 $#                                      CM03 193
+           QX(N+7)*QX(N+9)*B33 $#                                      CM03 194
+          (QX(N+3)*QX(N+4)     $#                                      CM03 195
+           QX(N+1)*QX(N+6))*B12$#                                      CM03 196
+          (QX(N+3)*QX(N+7)     $#                                      CM03 197
+           QX(N+1)*QX(N+9))*B13$#                                      CM03 198
+          (QX(N+6)*QX(N+7)     $#                                      CM03 199
+           QX(N+4)*QX(N+9))*B23#                                       CM03 200
#                                        Calculate beta23               CM03 201
bij:(K,6)=  QX(N+2)*QX(N+3)*B11 $#                                      CM03 202
+           QX(N+5)*QX(N+6)*B22 $#                                      CM03 203
+           QX(N+8)*QX(N+9)*B33 $#                                      CM03 204
+          (QX(N+3)*QX(N+5)     $#                                      CM03 205
+           QX(N+2)*QX(N+6))*B12$#                                      CM03 206
+          (QX(N+3)*QX(N+8)     $#                                      CM03 207
+           QX(N+2)*QX(N+9))*B13$#                                      CM03 208
+          (QX(N+6)*QX(N+8)     $#                                      CM03 209
+           QX(N+5)*QX(N+9))*B23#                                       CM03 210
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CM03 211
#                                                                       CM03 212
#    LIST INPUT ATOMS                                                   CM03 213
#    ----------------                                                   CM03 214
#                                                                       CM03 215
IF(PPRIOR>=4\(DLIS<99999.&N==MARK1))#  Dump atom list at pr=5           CM03 216
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CM03 217
IF(N==MARK1)#                          Test if input atom site          CM03 218
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CM03 219
movechar:(NAME1,1,CHROT,2,24,0)#       Get current atom name            CM03 220
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CM03 221
ELSE IF(B11<.00001) LIST=3#            Reset for equiv. site            CM03 222
movereal:(xif:(K,1),1,BUFOT,1,LIST,0)# Copy to bufot for editing        CM03 223
IF(LIST==5) BUFOT(5)=BUFOT(5)/UTOB#    Print u for isotropic dp         CM03 224
ELSE IF(LIST==10)#                     Anisotropic dp                   CM03 225
DO I=1,6; BUFOT(I+4)=BUFOT(I+4)/UTOBET(I)# Uij                          CM03 226
LCHROT=11#                             Start op formats                 CM03 227
ncodefld:(BUFOT,1,CHROT,FMT,LIST)#     Format stored items              CM03 228
writeline:(0,HEADOT,100,1,3)#          Print equivalent sites           CM03 229
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CM03 230
#                                                                       CM03 231
#   ACCOUNT FOR REPETITIVE DATA                                         CM03 232
#   ---------------------------                                         CM03 233
#                                                                       CM03 234
IF(B11>0.)#                            Test if betaij calculated        CM03 235
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CM03 236
I=0#                                   Set identical betaij frag        CM03 237
FOR(L=1;L<7;L=L+1)#                    Loop over betaij elements        CM03 238
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CM03 239
IF(L>3) bij:(K,L)=2.*bij:(K,L)#        Apply 2*beta(i!=j) now           CM03 240
ifne:(bij:(K,L),bij:(M,L)) I=1#        Flag if betaij different         CM03 241
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CM03 242
IF(I==1) M=K#                          Diff so reset betaij test poin   CM03 243
ELSE     bij:(K,2)=0.#                 Use u22 as flag for identical    CM03 244
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CM03 245
pmul:(K)=pmul:(K)*FMUL#                Apply sym multipicity now        CM03 246
K=K+IATM#                              Incr atom list pointer           CM03 247
ATP(NAT)=ATP(NAT)+FMUL*SMUL#           Atom number of partial structu   CM03 248
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CM03 249
#                                                                       CM03 250
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CM03 251
#                                                                       CM03 252
RETURN#                                                                 CM03 253
END#                                                                    CM03 254
systemheader:(CM04)#                   Prepare lr lrrefl: & copy fi     CM04   1
# ####################################################################  CM04   2
#                                                                       CM04   3
#                                CM04                                   CM04   4
#                                                                       CM04   5
# ####################################################################  CM04   6
SUBROUTINE CM04#                                                        CM04   7
include:(AACOMN)#                                                       CM04   8
include:(CMCOMN)#                                                       CM04   9
#                                                                       CM04  10
INTEGER I,J#                           Working indices                  CM04  11
chardata:(CM41,-NO YESXRAYNEUTSCATREFLOVERALL  $#                       CM04  12
ISOTROPICMIXED    ALL)#                                                 CM04  13
chardata:(CM42, CM CALCULATION PARAMETERS)#                             CM04  14
chardata:(CM43, DATA SET NUMBER USED     )#                             CM04  15
chardata:(CM4A, STRUCTURE FACTOR UNITS            )#                    CM04  16
chardata:(CM44, DISPL. PARAM. U X100                      )#            CM04  17
chardata:(CM45, EXTINCTION CORRECTION                )#                 CM04  18
chardata:(CM46, ANOMALOUS DISPERSION       )#                           CM04  19
chardata:(CM47, SIN/COS LOOKUP TABLE       )#                           CM04  20
chardata:(CM48, REFLN CODES REJECTED          )#                        CM04  21
chardata:(CM49, LIST REFLNS ABOVE DF              )#                    CM04  22
chardata:(CM410, RADIATION TYPE USED              )#                    CM04  23
chardata:(CM411, SOURCE OF SCAT.FACTOR LR           )#                  CM04  24
chardata:(CM412, MAXIMUM H K L USED              )#                     CM04  25
chardata:(CM413, MIN/MAX ST/L USED               )#                     CM04  26
chardata:(CM414, NUMBER OF ATOM SITES          )#                       CM04  27
chardata:(CM415, FREL SCALE FOR GROUP   1         )#                    CM04  28
chardata:(CM416,[ EXTINCTION NOT APPLIED (FACTOR NOT ON BDF)])#         CM04  29
chardata:(CM417, SIM WEIGHT IS ADDED TO BDF)#                           CM04  30
chardata:(CM418,NEUTRON ELECTRONXRAYS   )#                              CM04  31
chardata:(CM419,PICO-CMS VOLTS    ELECTRONS)#                           CM04  32
datastuff:#                                                             CM04  33
#                                                                       CM04  34
#    LIST CALCULATION PARAMETERS                                        CM04  35
#    ---------------------------                                        CM04  36
#                                                                       CM04  37
LINRM=10#                              Force parameter header           CM04  38
movechar:(CM41,1,CHROT,2,NCM42-1,2)#   Underline header                 CM04  39
writeline:(1,CM42,NCM42,1,3)#          Print calculation header         CM04  40
#                                                                       CM04  41
I=MIN(IRAD,3)#                         Modification for mo,cu,ag,sync   CM04  42
movechar:(CM419,I*9-8,CM4A,25,9,0)#    Insert sf units                  CM04  43
writeline:(0,CM4A,NCM4A,3,3)#          Print sf units                   CM04  44
#                                                                       CM04  45
movechar:(CM418,I*8-7,CM410,25,8,0)#   Insert radiation type            CM04  46
writeline:(0,CM410,NCM410,3,3)#        Print radiation type             CM04  47
#                                                                       CM04  48
ncodefld:(DSNM,1,CM43,250513.,1)#      Format dataset number            CM04  49
writeline:(0,CM43,NCM43,3,3)#          Print dataset number             CM04  50
#                                                                       CM04  51
movechar:(CM41,(TYPE-2)*9+24,CM44,25,9,0)# Insert dp type               CM04  52
IF(TYPE==2)#                                                            CM04  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CM04  54
BUFOT(1)=100.*BOVL/UTOB#               Output 100* uoverall             CM04  55
ncodefld:(BUFOT(1),1,CM44,420532.,1)#  Insert value in buffer           CM04  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CM04  57
writeline:(0,CM44,NCM44,3,3)#          Print tf type                    CM04  58
#                                                                       CM04  59
IF(ISIM==yes:)#                        Test if apply sim weight         CM04  60
writeline:(0,CM417,NCM417,3,3)#        Print sim weight                 CM04  61
#                                                                       CM04  62
movechar:(CM41,IEXT*3+2,CM45,25,3,0)#  Insert no/yes for ext.           CM04  63
writeline:(0,CM45,NCM45,3,3)#          Print ext. parameters            CM04  64
#                                                                       CM04  65
movechar:(CM41,DISP*3+2,CM46,25,3,0)#  Insert no/yes for a.d.           CM04  66
writeline:(0,CM46,NCM46,3,3)#          Print dispersion                 CM04  67
#                                                                       CM04  68
movechar:(CM41,ISIN*3+2,CM47,25,3,0)#  Insert no/yes s/c table          CM04  69
writeline:(0,CM47,NCM47,3,3)#          Print s/c table status           CM04  70
#                                                                       CM04  71
ifeq:(REJF,6.)I=no:; ELSE I=yes:#      Test for rejections              CM04  72
movechar:(CM41,I*3+2,CM48,25,3,0)#     Insert no/yes rejects            CM04  73
IF(I==yes:)#                           Test if reject active            CM04  74
ncodefld:(REJF+.5,1,CM48,300113.,1)#   Format reject flag               CM04  75
writeline:(0,CM48,NCM48,3,3)#          Print reject conditions          CM04  76
#                                                                       CM04  77
IF(DLIS<9998.)I=yes:; ELSE I=no:#      Test if list expected            CM04  78
movechar:(CM41,I*3+2,CM49,25,3,0)#     Insert no/yes list               CM04  79
IF(DLIS<0.)movechar:(CM41,NCM41-2,CM49,30,3,0)# Insert 'all'            CM04  80
ELSE IF(I==yes:)#                      Test if partial list             CM04  81
ncodefld:(DLIS,1,CM49,350822.,1)#      Format list limit                CM04  82
writeline:(0,CM49,NCM49,3,3)#          Print list parameters            CM04  83
#                                                                       CM04  84
DSTL=.02#                              Set default ff incr              CM04  85
IF(IFFF==0)#                           Test if ff in lrrefl             CM04  86
ncodefld:(DSTL,1,CM411,350522.,1)#     Add stol interval to o/p         CM04  87
movechar:(CM41,IFFF*4+16,CM411,26,4,0)# Insert lr number                CM04  88
writeline:(0,CM411,NCM411,3,3)#        Print scat.fac. source           CM04  89
#                                                                       CM04  90
ncodefld:(MAXH,1,CM412,250413.,1)#     Format max/h/                    CM04  91
ncodefld:(MAXK,1,CM412,290413.,1)#     Format max/k/                    CM04  92
ncodefld:(MAXL,1,CM412,330413.,1)#     Format max/l/                    CM04  93
writeline:(0,CM412,NCM412,3,3)#        Print max hkl                    CM04  94
#                                                                       CM04  95
ncodefld:(SMIN,1,CM413,270532.,1)#     Format min st/l                  CM04  96
ncodefld:(SMAX,1,CM413,330532.,1)#     Format max st/l                  CM04  97
writeline:(0,CM413,NCM413,3,3)#        Print st/l min/max               CM04  98
#                                                                       CM04  99
ncodefld:(FLOAT(NATM),1,CM414,260413.,1)# Format atom count             CM04 100
writeline:(0,CM414,NCM414,3,3)#        Print atom count                 CM04 101
#                                                                       CM04 102
ncodefld:(QX,MARK4+1,CM415,340732.,1)# Format scale 1                   CM04 103
writeline:(0,CM415,NCM415,3,3)#        Print scale 1                    CM04 104
FOR(I=2;I<=NSCL;I=I+1)#                Loop over scale groups           CM04 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CM04 106
ncodefld:(FLOAT(I),1,CHROT,250213.,1)## Format scale group              CM04 107
ncodefld:(QX,MARK4+I,CHROT,340732.,1)## Format scale value              CM04 108
writeline:(0,0,0,1,3)#                 Print scales only                CM04 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CM04 110
#                                                                       CM04 111
#                                                                       CM04 112
#   SEARCH LR LRREFL: POINTERS & CONSTRUCT O/P                          CM04 113
#   -------------------------------------------                         CM04 114
#                                                                       CM04 115
copyfile:(1,2,incr:(lratom:),decr:(lrrefl:))# Copy to refl rec.         CM04 116
DO I=1,NTYP;  IWNT(I)=500+I#           Set scat.fac. idnums             CM04 117
IWNT(NTYP+1)=NMDS+304#                 Set frel idnum                   CM04 118
IWNT(NTYP+2)=NMDS+308#                 Set jcode idnum                  CM04 119
IWNT(NTYP+3)=NMDS+309#                 Set nscl idnum                   CM04 120
IWNT(NTYP+4)=NMDS+202#                 Set extf idnum                   CM04 121
IWNT(NTYP+5)=1 ;IWNT(NTYP+6)=2#        Set hkl and stol idnums          CM04 122
IWNT(NTYP+7)=NMDS+600#                 Set normalised sf e1             CM04 123
DO I=1,ITEM#                           Loop over archive list           CM04 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CM04 125
J=NTYP+7+I#                            Get want pointer                 CM04 126
IWNT(J)=NINT(ARCH(I))#                 Store archive list               CM04 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CM04 128
KEY(1)=0;     KEY(2)=NTYP+7+ITEM#      Set search delimiters            CM04 129
KEY(4)=0;     KEY(3)=0#                Set search delimiters            CM04 130
indexpkt:(1,lrrefl:,LPAK,IP,2,KEY,IWNT,IREL)# Search rel pointers       CM04 131
NPAK=KEY(4)#                           Set output paksize               CM04 132
#                                                                       CM04 133
IF(NSCF==0)#                           Test if scatfac table exist      CM04 134
DO I=1,NTYP#                           Loop over atom types             CM04 135
IF(IREL(I)==0) iquit:(CM0401)#         No ff......fc401                 CM04 136
#                                                                       CM04 137
DO I=1,ITEM;  IWNT(I)=NINT(ARCH(I))#   Relocate archive list            CM04 138
FOR(I=KEY(2);I<KEY(3);I=I+1)#          Loop over irel deletes           CM04 139
IF(IREL(I+1)>9999) BREAK#              Exit no more                     CM04 140
NDEL=MAX0(0,NPAK-LPAK+I-KEY(2))#       Diff i/p to o/p packet           CM04 141
DO I=1,NTYP;OFF(I)=MARK3+(I-1)*NSCF+1# Setup ff table offsets           CM04 142
#                                                                       CM04 143
IRF=IREL(NTYP+1);  IRJ=IREL(NTYP+2)#   Frel & jcode pointers            CM04 144
IRS=IREL(NTYP+3);  IRX=IREL(NTYP+4)#   Scale & ext pointers             CM04 145
IRH=IREL(NTYP+5);  IRL=IREL(NTYP+6)#   Hkl and stol pointers            CM04 146
IEV=IREL(NTYP+7)#                      Point to e1                      CM04 147
IPH=IREL(NTYP+8)#                      Iphi                             CM04 148
IFA=IREL(NTYP+9);  IFB=IREL(NTYP+10)#  Prev acal,bcal                   CM04 149
WRITE(6,*) "AAAAAAAAAAA",IFA,IFB#                                       CM04 150
IF(ICORE!=0 & IFA<=0) iquit:(CM0499)#  Can't continue without it        CM04 151
IRFO=0#                                                                 CM04 152
DO I=1,NPAK;IF(NINT(QX(IP+I))==NMDS+304)IRFO=I#                         CM04 153
IF(IRX==0)#                            Ext. consts not on bdf           CM04 154
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CM04 155
writeline:(1,CM416,NCM416,3,3)#        Tell user ext. turned off        CM04 156
IEXT=no:#                              Turn off extinction              CM04 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CM04 158
#                                                                       CM04 159
DO I=1,2;    DO J=1,6#                 Loop over refln codes            CM04 160
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CM04 161
SUMR(I,J)=0.;  SUMC(I,J)=0.#           Zeroize stats sums               CM04 162
SUMN(I,J)=0.;  SUMD(I,J)=0.#           Zeroize stats sums               CM04 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CM04 164
writeline:(0,0,0,1,3);  LINRM=4#       Prepare for fc listing           CM04 165
DO I=1,NTYP; ATP(I)=MAX(0.0,ATA(I)-ATP(I))# Get unknown atom number     CM04 166
#                                                                       CM04 167
#   SETUP SIN/COS TABLE IF NEEDED                                       CM04 168
#   -----------------------------                                       CM04 169
#                                                                       CM04 170
IF(ISIN==yes:)#                        Test if table requested          CM04 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CM04 172
IF(MARK7+452<=QXMAX)#                  Check if enough memory           CM04 173
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CM04 174
incrqx:(MARK8,MARK7+452,-CM0402)#      Expand qx......fc402             CM04 175
FOR(I=MARK7;I<MARK8;I=I+1)#            Loop over degree intervals       CM04 176
QX(I+1)=SIN(FLOAT(I-MARK7)*.0174532925)# Sine 0/s/449                   CM04 177
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CM04 178
ELSE ISIN=no:#                         Shutoff table lookup             CM04 179
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CM04 180
ifeq:(REJF,6.) REJF=3.5#               Reject rcodes 4 and 5            CM04 181
#                                                                       CM04 182
RETURN#                                                                 CM04 183
END#                                                                    CM04 184
systemheader:(CM05)#                   Calculate structure factors      CM05   1
# ####################################################################  CM05   2
#                                                                       CM05   3
#                                CM05                                   CM05   4
#                                                                       CM05   5
# ####################################################################  CM05   6
SUBROUTINE CM05#                                                        CM05   7
include:(AACOMN)#                                                       CM05   8
include:(CMCOMN)#                                                       CM05   9
#                                                                       CM05  10
REAL A,ATOT,ADIS,ANOD,ACAL(mxat:)#     Real s.f. components             CM05  11
REAL B,BTOT,BDIS,BNOD,BCAL(mxat:)#     Imag s.f. components             CM05  12
REAL CMAL,FREL,FDIF,FRND,CMND#         Structure factors                CM05  13
REAL H(3)#                             Miller indices & products        CM05  14
REAL SCPA,WSIM,XAP#                    For calc sim weight              CM05  15
INTEGER I,J,K,L,M#                     Working indices                  CM05  16
INTEGER JCOD#                          Current refln code               CM05  17
REAL PHI,ANG#                          Phase components                 CM05  18
REAL STOL,S2L2#                        St/l & s2t/l2 values             CM05  19
#                                                                       CM05  20
chardata:(CM51,    H   K   L   ST/L RC SG    FREL    CMAL   $#          CM05  21
ADSP   BDSP    EXTF   FRNDNE   CMNDNE   PHI   DELTA)#                   CM05  22
realdata:(FMT,[$#                                                       CM05  23
50413.,90413.,130413.,200642.,230203.,260203.,340822.,420822.,#         CM05  24
490612.,560612.,640822.,730922.,820922.,880613.,960822.])#              CM05  25
realdata:(PI2,6.2831853)#                                               CM05  26
realdata:(AH,0.); realdata:(AK,0.); realdata:(AL,0.)#                   CM05  27
realdata:(HH,0.); realdata:(KK,0.); realdata:(LL,0.)#                   CM05  28
realdata:(HK,0.); realdata:(HL,0.); realdata:(KL,0.)#                   CM05  29
realdata:(FACT,0.); realdata:(ANOX,0.); realdata:(BNOX,0.)#             CM05  30
realdata:(TEMP,0.); realdata:(CODE,0.); intdata:(ISCG,0)#               CM05  31
realdata:(EXTFAC,1.)#                  Ext. factor for fcals            CM05  32
datastuff:#                                                             CM05  33
#                                                                       CM05  34
#  LOOP OVER REFLECTION PACKETS (LRREFL:)                               CM05  35
#  ===================================                                  CM05  36
#                                                                       CM05  37
IA8=MARK8#                                                              CM05  38
REPEAT#                                Loop over refln packets          CM05  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CM05  40
readwpkt:(1,lrrefl:,LPAK,IP,0)#        Point to input packet            CM05  41
IF(IP<=0) BREAK#                       Ifexit after last packet         CM05  42
#                                                                       CM05  43
#    SETUP OUTPUT PACKET                                                CM05  44
#    -------------------                                                CM05  45
#                                                                       CM05  46
writepkt:(2,lrrefl:,LPAK,JP)#          Point to output packet           CM05  47
movereal:(QX,IP+1,QX,JP+1,LPAK,1)#                                      CM05  48
#                                                                       CM05  73
#    EXTRACT REQUIRED REFLN DATA                                        CM05  74
#    ---------------------------                                        CM05  75
#                                                                       CM05  76
STOL=QX(IP+IRL)#                       Extract st/l                     CM05  77
IF((STOL<SMIN)\(STOL>SMAX)) NEXT#      Skip if outside s limits         CM05  78
S2L2=STOL**2#                          Get (st/l) squared               CM05  79
#                                                                       CM05  80
#  EXTRACT & SCALE F-RELATIVE                                           CM05  81
#  -------------------------                                            CM05  82
#                                                                       CM05  83
IF(IRF==0) FREL=0.#                    Default value for frel           CM05  84
ELSE FREL=QX(IP+IRF)#                  Frel is on bdisf                 CM05  85
J=IP+IRS#                              Point to scale group             CM05  86
IF(IRS==0) ISCG=MARK4+1#               Point to scale one               CM05  87
ELSE       ISCG=MARK4+NINT(QX(J))#     Point to scale group             CM05  88
FREL=FREL*QX(ISCG)#                    Scale measured s.f.              CM05  89
IF(IRJ>0) CODE=QX(IP+IRJ)#             Extract reflection code          CM05  90
IF(CODE>REJF) NEXT#                    Skip rejected reflections        CM05  91
ifvo:(CODE) NEXT#                      Skip if rcode is void            CM05  92
gethkl:(IP+IRH,H)#                     Extract signed h,k,l             CM05  93
AH=H(1); AK=H(2); AL=H(3)#             Make hkl local variables         CM05  94
IF(AH>MAXH) NEXT#                      Skip if /h/ too big              CM05  95
IF(AK>MAXK) NEXT#                      Skip if /k/ too big              CM05  96
IF(AL>MAXL) NEXT#                      Skip if /l/ too big              CM05  97
IF(TYPE==4)#                           Test if aniso tf possible        CM05  98
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CM05  99
HH=AH**2;  KK=AK**2;  LL=AL**2#        Calc index products              CM05 100
HK=AH*AK;  HL=AH*AL;  KL=AK*AL#        Calc index products              CM05 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CM05 102
ELSE IF(TYPE<3) TEMP=EXP(-BOVL*S2L2)#  Calc overall temp factor         CM05 103
DO I=1,NTYP#                           Loop over atom types             CM05 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CM05 105
ACAL(I)=0.;   BCAL(I)=0.#              Zeroize s.f. components          CM05 106
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CM05 107
#                                                                       CM05 108
#    LOOP OVER ATOMS LIST                                               CM05 109
#    --------------------                                               CM05 110
#                                                                       CM05 111
FOR(M=MARK6;M<MARK7;M=M+IATM)#         Loop over atoms list             CM05 112
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CM05 113
#                                                                       CM05 114
IF(scat:(M)>0.5)#                      Test if equivalent site          CM05 115
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CM05 116
L=NINT(scat:(M))#                      Extract sf sequence              CM05 117
IF(TYPE<3) FACT=pmul:(M)*TEMP#         Calc factor for overall b        CM05 118
ELSE FACT=pmul:(M)*EXP(-bis:(M)*S2L2)# Get s.f.product                  CM05 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CM05 120
IF((TYPE==4)&(bij:(M,2)>0.))#          Test for aniso tf                CM05 121
FACT=pmul:(M)*EXP(-HH*bij:(M,1)-KK*bij:(M,2)$# Calc s.f. product        CM05 122
-LL*bij:(M,3)-HK*bij:(M,4)-HL*bij:(M,5)-KL*bij:(M,6))# Calc s.f. prod   CM05 123
#                                                                       CM05 124
#   CALC A & B FOR EACH ATOM TYPE                                       CM05 125
#   -----------------------------                                       CM05 126
#                                                                       CM05 127
ANG=AH*xif:(M,1)+AK*xif:(M,2)+AL*xif:(M,3)# Calc phase component        CM05 128
IF(ISIN==yes:)#                        Test for sin/cos table           CM05 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CM05 130
IF(ANG<0.)#                            Test if angle negative           CM05 131
I=INT((1.+AMOD(ANG,1.))*360.+.5)+MARK7## Point to sin/cos table         CM05 132
ELSE#                                  If angle is positive             CM05 133
I=INT(AMOD(ANG,1.)*360.+.5)+MARK7#     Point to sin/cos table           CM05 134
ACAL(L)=ACAL(L)+FACT*QX(I+91)#         Calc real s.f. component         CM05 135
IF(CENT==1)#                           Test if centrosymmetric          CM05 136
BCAL(L)=BCAL(L)+FACT*QX(I+1)#          Calc imag s.f. component         CM05 137
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CM05 138
ELSE#                                  Else use fortran lib sin/cos     CM05 139
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CM05 140
ACAL(L)=ACAL(L)+FACT*COS(ANG*PI2)#     Calc real s.f. component         CM05 141
IF(CENT==1)#                           Test if centrosymmetric          CM05 142
BCAL(L)=BCAL(L)+FACT*SIN(ANG*PI2)#     Calc imag s.f. component         CM05 143
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CM05 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CM05 145
#                                                                       CM05 146
#   CALC TOTAL COMPONENTS A & B                                         CM05 147
#   ---------------------------                                         CM05 148
#                                                                       CM05 149
ANOD=0.;  BNOD=0.;  ADIS=0.;  BDIS=0.# Reset a & b sums                 CM05 150
SCPA=0.#                               Reset ff for unknown atoms       CM05 151
DO L=1,NTYP#                           Loop over scat. factors          CM05 152
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CM05 153
IF(IRAD==1) J=OFF(L)#                  Point to neutron ff              CM05 154
ELSE IF(IREL(L)>0) J=IP+IREL(L)#       Get ff pointers to buffer        CM05 155
ELSE          J=NINT(STOL/DSTL)+OFF(L)# Point to ff curves              CM05 156
IF(ISIM==yes:) SCPA=SCPA+ATP(L)*QX(J)*QX(J)# Sum ff for unknown atoms   CM05 157
ANOD=ANOD+ACAL(L)*QX(J)#               Sum total real s.f.              CM05 158
IF(CENT==1)#                           Test if centrosymmetric          CM05 159
BNOD=BNOD+BCAL(L)*QX(J)#               Sum total imag s.f.              CM05 160
IF(DISP==yes:)#                        Is dispersion applied            CM05 161
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CM05 162
A=ACAL(L)*ADR(L)-BCAL(L)*ADI(L)#       Apply anom.disp. factors         CM05 163
B=BCAL(L)*ADR(L)+ACAL(L)*ADI(L)#       Apply anom.disp. factors         CM05 164
ADIS=ADIS+A#                           Sum real contributions           CM05 165
BDIS=BDIS+B#                           Sum imag contributions           CM05 166
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CM05 167
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CM05 168
#                                                                       CM05 169
IF(ICORE==1)#                          Only for total=core+valence      CM05 170
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CM05 171
ANOD=ANOD+QX(IP+IFA);BNOD=BNOD+QX(IP+IFB)# Add contrib from valence m   CM05 172
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CM05 173
ATOT=ANOD+ADIS;  BTOT=BNOD+BDIS#       Include dispersion terms         CM05 174
#                                                                       CM05 175
#   APPLY EXTINCTION IF REQUESTED                                       CM05 176
#   -----------------------------                                       CM05 177
#                                                                       CM05 178
IF(IEXT==yes:)#                        Test for extinction              CM05 179
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CM05 180
ANOX=ATOT;  BNOX=BTOT#                 Set extinction free a,b          CM05 181
J=IP+IRX#                              Point to extinction term         CM05 182
EXTFAC=SQRT(QX(J))#                    Get extinction factor            CM05 183
ATOT=ATOT*EXTFAC;  BTOT=BTOT*EXTFAC#   Apply extinct. to a,b            CM05 184
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CM05 185
#                                                                       CM05 186
#   CALCULATE TOTAL STRUCTURE FACTOR                                    CM05 187
#   --------------------------------                                    CM05 188
#                                                                       CM05 189
FVAL= FREL/ACAL(1)#                    Fvalence scattering factor       CM05 190
IF(QX(IP+IFA)<0.) FVAL=-FVAL#          Its negative                     CM05 191
incrqx:(STOP8,IA8+2,CM0510)#                                            CM05 192
QX(IA8+1)=STOL#                                                         CM05 193
QX(IA8+2)=FVAL#                                                         CM05 194
IA8=STOP8#                                                              CM05 195
#                                                                       CM05 196
IF((ABS(ANOD)<.01)&(ABS(BNOD)<.01))ANOD=.01# Test indeterminency        CM05 197
PHI=AMOD(ATAN2(BNOD,ANOD)/PI2+1.000001,1.)# Get phase in cycles         CM05 198
CMAL=SQRT(ATOT*ATOT+BTOT*BTOT)#        Calculate s.f.                   CM05 199
ADIS=QX(IP+IFA);BDIS=QX(IP+IFB)#                                        CM05 200
IF(ICORE!=0) FREL=CMAL#                                                 CM05 201
FRND=FREL/EXTFAC;  CMND=CMAL/EXTFAC#   Correct for extinc.              CM05 202
IF(DISP==yes:)#                        Test for dispersion              CM05 203
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CM05 204
CMND=SQRT(ANOD*ANOD+BNOD*BNOD)#        Calculate fc (without disp)      CM05 205
A=(ADIS*BNOD-BDIS*ANOD)/CMND#          Calc disp correction a           CM05 206
B=(ADIS*ANOD+BDIS*BNOD)/CMND#          Calc disp correction b           CM05 207
A=AMAX1(0.,FRND*FRND-A*A)#             Get +ve diff f2-a2               CM05 208
FRND=AMAX1(0.,SQRT(A)-B)#              Calc corrected frel              CM05 209
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CM05 210
FDIF=FRND-CMND#                        Calculate s.f. difference        CM05 211
WSIM=0.0#                                                               CM05 212
IF(ISIM==yes:)#                        Test if apply sim weight         CM05 213
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CM05 214
IF(SCPA>0.) XAP=2.0*CMND*FREL/SCPA#    Calc factor for i1(x)/i0(x)      CM05 215
ELSE        XAP=100.#                  Force sim weight to be 1.0       CM05 216
WSIM=XAP*(XAP+.4807)/(XAP*(XAP+.8636)+1.3943)# Calc sim weight          CM05 217
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CM05 218
#                                                                       CM05 219
#    SETUP OUTPUT ARCHIVE LIST                                          CM05 220
#    -------------------------                                          CM05 221
#                                                                       CM05 222
ARCH(1)=CMND#                          Archive calculated s.f.          CM05 223
ARCH(2)=ANOD#                          Archive real fc (no disp)        CM05 224
ARCH(3)=BNOD#                          Archive imag fc (no disp)        CM05 225
ARCH(4)=ADIS#                          Archive real disp only           CM05 226
ARCH(5)=BDIS#                          Archive imag disp only           CM05 227
ARCH(6)=ANOX#                          Archive real fc (no ext.)        CM05 228
ARCH(7)=BNOX#                          Archive imag fc (no ext.)        CM05 229
ARCH(8)=PHI#                           Archive phase in cycles          CM05 230
ARCH(9)=FRND/QX(ISCG)#                 Archive corrected frel           CM05 231
ARCH(10)=WSIM#                         Archive sim weight               CM05 232
ARCH(11)=CMAL#                         Archive full fcalc               CM05 233
IF(ICORE!=0)#                          Hijacked procedure               CM05 234
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CM05 235
ADIS=QX(IP+IFA);BDIS=QX(IP+IFB)#                                        CM05 236
FREL=CMAL#                                                              CM05 237
ARCH(9)=CMAL#                          This is really an frel           CM05 238
IF(IRFO!=0) QX(JP+IRFO)=CMAL#          Beyond doubt                     CM05 239
ARCH(11)=0.0#                          For emphasis, fcal=0.0           CM05 240
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CM05 241
#DO I=1,ITEM#                           LOOP OVER ARCHIVE LIST          CM05 242
#$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1 CM05 243
#IF(IWNT(I)<0) NEXT#                    SKIP DELETE ITEMS               CM05 244
#QX(K)=ARCH(I)#                         STORE ADD ITEMS                 CM05 245
#K=K+1#                                 INCR OP PACKET POINTER          CM05 246
#$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1 CM05 247
#                                                                       CM05 248
#    ACCUMULATE STATISTICS                                              CM05 249
#    ---------------------                                              CM05 250
#                                                                       CM05 251
JCOD=INT(CODE+1.5)#                    Convert refln code               CM05 252
SUMN(1,JCOD)=SUMN(1,JCOD)+1.#          Sum number of reflns             CM05 253
SUMR(1,JCOD)=SUMR(1,JCOD)+FRND#        Sum measured s.f.                CM05 254
SUMC(1,JCOD)=SUMC(1,JCOD)+CMND#        Sum calculated s.f.              CM05 255
SUMD(1,JCOD)=SUMD(1,JCOD)+ABS(FDIF)#   Sum f difference                 CM05 256
SUMN(2,JCOD)=SUMN(2,JCOD)+1.#          Sum number of reflns             CM05 257
SUMR(2,JCOD)=SUMR(2,JCOD)+FREL#        Sum measured s.f.                CM05 258
SUMC(2,JCOD)=SUMC(2,JCOD)+CMAL#        Sum calculated s.f.              CM05 259
SUMD(2,JCOD)=SUMD(2,JCOD)+ABS(FREL-CMAL)# Sum f difference              CM05 260
#                                                                       CM05 261
#    LIST REFLECTIONS IF REQUESTED                                      CM05 262
#    -----------------------------                                      CM05 263
#                                                                       CM05 264
IF(ABS(FDIF)<DLIS) NEXT#               List if abs(fdiff) > dlist       CM05 265
BUFOT(1)=STOL#                         Store sin theta/lambda           CM05 266
BUFOT(2)=CODE#                         Store refln code                 CM05 267
BUFOT(3)=FLOAT(ISCG-MARK4)#            Float scale group                CM05 268
BUFOT(4)=FREL#                         Store measured s.f.              CM05 269
BUFOT(5)=CMAL#                         Store total fc                   CM05 270
BUFOT(6)=ADIS#                         Store real dispersion term       CM05 271
BUFOT(7)=BDIS#                         Store imag dispersion term       CM05 272
BUFOT(8)=EXTFAC#                       Store extin. factor              CM05 273
BUFOT(9)=FRND#                         Store disp-free frel             CM05 274
BUFOT(10)=CMND#                        Store disp-free fcal             CM05 275
BUFOT(11)=PHI*360.#                    Store disp-free phase            CM05 276
BUFOT(12)=FDIF#                        Store disp-free fdiff            CM05 277
ncodefld:(H,     1,CHROT,FMT,3)#       Format h,k,l                     CM05 278
ncodefld:(BUFOT,1,CHROT,FMT(4),12)#    Format s,jc,is,frel              CM05 279
writeline:(0,CM51,NCM51,1,1)#          Print all data                   CM05 280
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CM05 281
#                                                                       CM05 282
FOR(IA=MARK8+1;IA<STOP8-1;IA=IA+2)#    Ultra slow inplace sort          CM05 283
FOR(IB=IA+2;IB<STOP8+1;IB=IB+2)#                                        CM05 284
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CM05 285
IF(QX(IB)>QX(IA)) NEXT#                                                 CM05 286
XS=QX(IA);XF=QX(IA+1);#                                                 CM05 287
QX(IA)=QX(IB);QX(IA+1)=QX(IB+1)#                                        CM05 288
QX(IB)=XS;QX(IB+1)=XF#                                                  CM05 289
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CM05 290
#                                                                       CM05 291
# STRIP REDUNDANTS                                                      CM05 292
#                                                                       CM05 293
ID=MARK8#                                                               CM05 294
FOR(IA=MARK8;IA<STOP8;IA=IA+2)#                                         CM05 295
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CM05 296
SUM=QX(IA+2);CNT=1.#                                                    CM05 297
FOR(IB=IA+2;IB<STOP8;IB=IB+2)#                                          CM05 298
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CM05 299
ifne:(QX(IB+1),QX(IA+1))BREAK#                                          CM05 300
SUM=SUM+QX(IB+2);CNT=CNT+1.#                                            CM05 301
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CM05 302
QX(ID+1)=QX(IA+1)#                     Stol                             CM05 303
QX(ID+2)=SUM/CNT#                                                       CM05 304
IA=IB-2#                                                                CM05 305
ID=ID+2#                                                                CM05 306
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CM05 307
STOP8=ID#                                                               CM05 308
#                                                                       CM05 309
DS=QX(STOP8-1)/200.#                                                    CM05 310
X1=QX(MARK8+1);Y1=QX(MARK8+2)#                                          CM05 311
X2=QX(MARK8+3);Y2=QX(MARK8+4)#                                          CM05 312
B=FLOAT(NINT((Y1*(X2-X1)-X1*(Y2-Y1))/(X2-X1)))#                         CM05 313
WRITE(6,*) "Linearly extrapolated F000 is ",B#                          CM05 314
#                                                                       CM05 315
#                                                                       CM05 316
LEN=(STOP8-MARK8)/2+1#                 Half length of (x,y) data pts    CM05 317
incrqx:(ID,STOP8+2*LEN,CM0512)#        Get memory to duplicate          CM05 318
QX(STOP8+1)=0.0; QX(STOP8+1+LEN)=B#    Origin point                     CM05 319
K=STOP8+2#                                                              CM05 320
FOR(IA=MARK8;IA<STOP8;IA=IA+2)#        Split into two arrays            CM05 321
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CM05 322
QX(K)    =QX(IA+1)#                    Save sin theta/lamda here        CM05 323
QX(K+LEN)=QX(IA+2)#                                                     CM05 324
K=K+1#                                                                  CM05 325
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CM05 326
#                                                                       CM05 327
S=DS#                                                                   CM05 328
WRITE(6,*) 0.0,B#                      First point at 0.0 compulsory    CM05 329
DO I=1,199#                            200 points maximum               CM05 330
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CM05 331
F=aitkeninterp:(S,QX(STOP8+1),QX(STOP8+1+LEN),LEN)#                     CM05 332
WRITE(6,*) S,F#                                                         CM05 333
S=S+DS#                                                                 CM05 334
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CM05 335
#                                                                       CM05 336
RETURN#                                                                 CM05 337
END#                                                                    CM05 338
systemheader:(CM06)#                   Print structure factor stats     CM06   1
# ####################################################################  CM06   2
#                                                                       CM06   3
#                                CM06                                   CM06   4
#                                                                       CM06   5
# ####################################################################  CM06   6
SUBROUTINE CM06#                                                        CM06   7
include:(AACOMN)#                                                       CM06   8
include:(CMCOMN)#                                                       CM06   9
#                                                                       CM06  10
INTEGER I,K#                           Working indices                  CM06  11
chardata:(CM61,[ REFLECTION STATISTICS   (DISPERSION/EXTINCTION $#      CM06  12
UNCORRECTED)])#                                                         CM06  13
chardata:(CM62,CODE0CODE1CODE2CODE3CODE4TOTAL)#                         CM06  14
chardata:(CM63,           NREF   AV FREL   AV CMAL   AV DIFF   $#       CM06  15
RFACTOR   SCALE)#                                                       CM06  16
chardata:(CM64,UN  )#                                                   CM06  17
realdata:(FMT,[150513.,250622.,350622.,450622.,550632.,630842.])#       CM06  18
datastuff:#                                                             CM06  19
#                                                                       CM06  20
#   CALCULATE STATISTICS                                                CM06  21
#   -------------------                                                 CM06  22
#                                                                       CM06  23
DO K=2,1,-1#                           Loop over disp., extn.           CM06  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CM06  25
DO I=1,5#                              Loop over refln codes            CM06  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CM06  27
SUMN(K,6)=SUMN(K,6)+SUMN(K,I)#         Sum total refln count            CM06  28
SUMR(K,6)=SUMR(K,6)+SUMR(K,I)#         Sum total frel                   CM06  29
SUMC(K,6)=SUMC(K,6)+SUMC(K,I)#         Sum total fcal                   CM06  30
SUMD(K,6)=SUMD(K,6)+SUMD(K,I)#         Sum total /diff/                 CM06  31
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CM06  32
#                                                                       CM06  33
writeline:(1,CM61,NCM61,3,3); LINRM=3# Print stats header               CM06  34
DO I=1,6#                              Loop over refln codes            CM06  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CM06  36
ifeq:(SUMN(K,I),0.) NEXT#              Skip null sums                   CM06  37
movechar:(CM62,I*5-4,CHROT,3,5,0)#     Put in side header               CM06  38
BUFOT(1)=SUMN(K,I)#                    Store number of reflns           CM06  39
BUFOT(2)=SUMR(K,I)/SUMN(K,I)#          Store mean frel                  CM06  40
BUFOT(3)=SUMC(K,I)/SUMN(K,I)#          Store mean fcal                  CM06  41
BUFOT(4)=SUMD(K,I)/SUMN(K,I)#          Store mean diff                  CM06  42
BUFOT(5)=SUMD(K,I)/AMAX1(1.,SUMR(K,I))# Store r-factor                  CM06  43
BUFOT(6)=SUMC(K,I)/AMAX1(1.,SUMR(K,I))# Store scale                     CM06  44
ncodefld:(BUFOT,1,CHROT,FMT,6)#        Format statistics                CM06  45
writeline:(0,CM63,NCM63,1,3)#          Print statistics                 CM06  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CM06  47
movechar:(CM64,K*2-1,CM61,49,2,0)#     Reset heading                    CM06  48
IF(DISP==no: & IEXT==no:)  BREAK#      Exit if no disp., extinc.        CM06  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CM06  50
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Finish off file               CM06  61
#                                                                       CM06  62
RETURN#                                                                 CM06  63
END#                                                                    CM06  64
#                                                                       CM06  65
systemheader:(CM07)#                                                    CM07   1
####################################################################### CM07   2
#                                                                       CM07   3
#                                CM07                                   CM07   4
#                                                                       CM07   5
####################################################################### CM07   6
REAL FUNCTION CM07(XT,X,Y,N)#                                           CM07   7
macro:(funcnam:,CM07)#                                                  CM07   8
#---- AITKEN-S SIX POINT INTERPOLATION SCHEME                           CM07   9
#---- XT = COORD OF DESIRED FUNCTION VALUE                              CM07  10
#---- X = TOTAL X-AXIS ARRAY                                            CM07  11
#---- Y = TOTAL Y-AXIS ARRAY                                            CM07  12
#---- N = # OF POINTS IN X,Y ARRAYS                                     CM07  13
REAL X,Y,XT,P1,P2,YT,D0,D1,D2,D3,D4,D5,$#                               CM07  14
F0,F1,F2,F3,F4,F21,F31,F41,F51,F32,F42,F52,F43,F53#                     CM07  15
DIMENSION X(1),Y(1)#                                                    CM07  16
#                                                                       CM07  17
IF (N < 6) $(funcnam:=0.0;RETURN $)#   Not enough points                CM07  18
#                                                                       CM07  19
K=N-1#                                                                  CM07  20
DO I=1,K#                              Loop over points                 CM07  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CM07  22
P1=XT-X(I)#                                                             CM07  23
P2=XT-X(I+1)#                                                           CM07  24
IF (P1 == 0) $(funcnam:=Y(I);RETURN $)#                                 CM07  25
ELSEIF (P1 < 0)#                                                        CM07  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CM07  27
IF (P2 < 0) NEXT#                                                       CM07  28
IF (P2 == 0)$(funcnam:=Y(I+1);RETURN $)#                                CM07  29
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CM07  30
ELSEIF (P1 > 0)#                                                        CM07  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CM07  32
IF (P2 > 0) NEXT#                                                       CM07  33
IF (P2 == 0) $(funcnam:=Y(I+1);RETURN $)#                               CM07  34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CM07  35
IF     (I < 2) IS=I#                                                    CM07  36
ELSEIF (I == 2) IS=I-1#                                                 CM07  37
ELSEIF (I > 2)#                                                         CM07  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CM07  39
IF     (I  < K-1) IS=I-2#                                               CM07  40
ELSEIF (I == K-1)IS=I-3#                                                CM07  41
ELSE             IS=I-4#                                                CM07  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CM07  43
BREAK#                                                                  CM07  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CM07  45
#                                                                       CM07  46
IF(I>K) $(funcnam:=0.0; RETURN $)#     No valid range                   CM07  47
#                                                                       CM07  48
IS1=IS+1#                                                               CM07  49
IS2=IS+2#                                                               CM07  50
IS3=IS+3#                                                               CM07  51
IS4=IS+4#                                                               CM07  52
IS5=IS+5#                                                               CM07  53
D0=X(IS)-XT#                                                            CM07  54
D1=X(IS1)-XT#                                                           CM07  55
D2=X(IS2)-XT#                                                           CM07  56
D3=X(IS3)-XT#                                                           CM07  57
D4=X(IS4)-XT#                                                           CM07  58
D5=X(IS5)-XT#                                                           CM07  59
F0=(Y(IS)*D1-Y(IS1)*D0)/(X(IS1)-X(IS))#                                 CM07  60
F1=(Y(IS)*D2-Y(IS2)*D0)/(X(IS2)-X(IS))#                                 CM07  61
F2=(Y(IS)*D3-Y(IS3)*D0)/(X(IS3)-X(IS))#                                 CM07  62
F3=(Y(IS)*D4-Y(IS4)*D0)/(X(IS4)-X(IS))#                                 CM07  63
F4=(Y(IS)*D5-Y(IS5)*D0)/(X(IS5)-X(IS))#                                 CM07  64
F21=(F0*D2-F1*D1)/(X(IS2)-X(IS1))#                                      CM07  65
F31=(F0*D3-F2*D1)/(X(IS3)-X(IS1))#                                      CM07  66
F41=(F0*D4-F3*D1)/(X(IS4)-X(IS1))#                                      CM07  67
F51=(F0*D5-F4*D1)/(X(IS5)-X(IS1))#                                      CM07  68
F32=(F21*D3-F31*D2)/(X(IS3)-X(IS2))#                                    CM07  69
F42=(F21*D4-F41*D2)/(X(IS4)-X(IS2))#                                    CM07  70
F52=(F21*D5-F51*D2)/(X(IS5)-X(IS2))#                                    CM07  71
F43=(F32*D4-F42*D3)/(X(IS4)-X(IS3))#                                    CM07  72
F53=(F32*D5-F52*D3)/(X(IS5)-X(IS3))#                                    CM07  73
funcnam:=(F43*D5-F53*D4)/(X(IS5)-X(IS4))#                               CM07  74
RETURN#                                                                 CM07  75
END#                                                                    CM07  76
pmacro:([no:])#                        Purge xtal system macros         CM07  77
