systemheader:(CQ    )#                                                  CQ     1
####################################################################### CQ     2
#                                                                     # CQ     3
#                           *** CRITIQ ***                            # CQ     4
#                                                                     # CQ     5
#  THE PROGRAM CRITIQ IS USED TO EXAMINE MULTIPLY OBSERVED INTENSITY  # CQ     6
#   DATA AND PICK OUT THE MOST VARIABLE REFLECTIONS.                  # CQ     7
#                                                                     # CQ     8
####################################################################### CQ     9
#                                                                       CQ    10
include:(XMACRO)#                                                       CQ    11
#                                                                       CQ    12
macro:(exchange4:,[$(#                 Exchange the 4 parts of          CQ    13
JJ = J#                                The ith and jth entries          CQ    14
FOR(IJ=I; IJ <= I+3; IJ=IJ+1)$(#       In the stack.                    CQ    15
movepakwd:(NUM(IJ),TEMP)#                                               CQ    16
movepakwd:(NUM(JJ),NUM(IJ))#                                            CQ    17
movepakwd:(TEMP,NUM(JJ))#                                               CQ    18
JJ = JJ + 1$)$)])#                                                      CQ    19
macro:(fsort42:,[CQ33($1,$2)])#        Sort 4-word tables               CQ    20
macro:(max:,1500)#                     Maximum obs./refl. allowed       CQ    21
macro:(maxshifts:,64)#                 Maximum number of shifts         CQ    22
#                                                                       CQ    23
extrude:(CQCOMN)#                                                       CQ    24
COMMON/COMICQ/ALLOWD,  DPTR,  FPTR,HISHFT, HKLNOW, HKLNXT, $#           CQ    25
IMERGE,   ISW, LOLIM,LOSHFT,  MAXR, MORDER, MOST, MOST4, $#             CQ    26
NOBS, NSHIFT,   OBS, OBSBY,OBSKIP, OBSSG, ORDNL, $#                     CQ    27
RANKS, REFBY, REFSG, $#                                                 CQ    28
RFBOTH, SCPTR, SHPTR, SIGNOW, SIGNXT, $#                                CQ    29
TBYOBS,TOBSKP,TOTOBS,TOTREF,TSGOBS, UPLIM#                              CQ    30
#                                                                       CQ    31
INTEGER ALLOWD#                        Maximum number of obs./refl.     CQ    32
#                                         Allowed.                      CQ    33
INTEGER DPTR#                          Pointer to start of first        CQ    34
#                                         Discrepancy table.            CQ    35
INTEGER FPTR#                          Pointer to initial f**2 in       CQ    36
#                                         Buffer.                       CQ    37
INTEGER HISHFT#                        Max. shift number to be          CQ    38
#                                         Included in listing.          CQ    39
INTEGER HKLNOW#                        Packed hkl found on lr lrref     CQ    40
INTEGER HKLNXT#                        Packed hkl for next reflecti     CQ    41
#                                         On the bdf.                   CQ    42
INTEGER IMERGE#                        If zero, merge space group a     CQ    43
#                                         Bijvoet observations.         CQ    44
INTEGER ISW#                           Flag; = yes: if refl. might      CQ    45
#                                         Useable.                      CQ    46
INTEGER LOLIM#                         The min. no. of obs./refl.       CQ    47
#                                         Required for the refl. to be  CQ    48
#                                         Listed.                       CQ    49
INTEGER LOSHFT#                        Min. shift number to be          CQ    50
#                                         Included in listing.          CQ    51
INTEGER MAXR#                          The max. no. of unranked obs     CQ    52
#                                         That will be listed for a     CQ    53
#                                         Reflection.                   CQ    54
INTEGER MORDER(3)#                     Sort order of hkl                CQ    55
INTEGER MOST#                          The number of worst              CQ    56
#                                         Observations to be listed.    CQ    57
INTEGER MOST4#                         4 times most                     CQ    58
INTEGER NOBS#                          Number of observ of current      CQ    59
#                                          Space group                  CQ    60
INTEGER NSHIFT#                        Number of scale groups           CQ    61
INTEGER OBS#                           Total observations for curre     CQ    62
#                                         Reflection.                   CQ    63
INTEGER OBSBY#                         Total bijvoet obs. for curre     CQ    64
#                                         Reflection.                   CQ    65
INTEGER OBSKIP#                        Obs. skipped for current ref     CQ    66
INTEGER OBSSG#                         Total space group obs. for       CQ    67
#                                         Current reflection.           CQ    68
INTEGER ORDNL#                         Ordinal number of current re     CQ    69
INTEGER RANKS(4)#                      The 4 rankings for a ranked      CQ    70
#                                         Observation.                  CQ    71
INTEGER REFBY#                         Number of refls. with bijvoet    CQ    72
#                                         Only obs.                     CQ    73
INTEGER REFSG#                         Number of refls. with space      CQ    74
#                                         Group only obs.               CQ    75
INTEGER RFBOTH#                        Number of refls. with both       CQ    76
#                                         Space group and bijvoet obs.  CQ    77
INTEGER SCPTR#                         Pointer to first scale facto     CQ    78
INTEGER SHPTR#                         Pointer to first shift numbe     CQ    79
INTEGER SIGNOW#                        Signs of current indices         CQ    80
INTEGER SIGNXT#                        Signs of next indices            CQ    81
INTEGER TBYOBS#                        Total number of bijvoet obs.     CQ    82
#                                         On the bdf.                   CQ    83
INTEGER TOBSKP#                        Total number of obs. skipped     CQ    84
#                                         Because of insufficient room. CQ    85
INTEGER TOTOBS#                        Total number of obs on the b     CQ    86
INTEGER TOTREF#                        Total number of refls.           CQ    87
#                                         Processed.                    CQ    88
INTEGER TSGOBS#                        Total number of space group      CQ    89
#                                         Obs. on the bdf.              CQ    90
INTEGER UPLIM#                         Max. no. of obs./refl. allow     CQ    91
#                                         Before rejecting reflection.  CQ    92
#                                                                       CQ    93
COMMON/COMFCQ/AVGFSQ,   FSQ,FSQMIN, HRANK, HRAW, $#                     CQ    94
SHRIFT,SIGFSQ, SIGMA, $#                                                CQ    95
SITOL,  SMAX,  SMIN,    WT, HKL, HKLBY#                                 CQ    96
#                                                                       CQ    97
REAL AVGFSQ#                           Mean f**2 for a reflection       CQ    98
REAL FSQ#                              Current f**2                     CQ    99
REAL FSQMIN#                           Minimum observational f**2       CQ   100
#                                         That will be listed.          CQ   101
REAL HKL#                              Packed hkl, space group          CQ   102
REAL HKLBY#                            Packed hkl, bijvoet              CQ   103
REAL HRANK#                            Current packed hkl (without      CQ   104
#                                         Bijvoet bit) to be listed.    CQ   105
REAL HRAW#                             Current packed hkl to be         CQ   106
#                                         Listed.                       CQ   107
REAL SHRIFT#                           Current shift number             CQ   108
REAL SIGFSQ#                           Mean sigma(f**2) for a refl.     CQ   109
REAL SIGMA#                            Current sigma(f**2)              CQ   110
REAL SITOL#                            Sine(theta)/lambda               CQ   111
REAL SMAX#                             Maximum sine(theta)/lambda f     CQ   112
#                                         Inclusion.                    CQ   113
REAL SMIN#                             Minimum sine(theta)/lambda f     CQ   114
#                                         Inclusion.                    CQ   115
REAL WT#                               Current weight                   CQ   116
endext:#                                                                CQ   117
#                                                                       CQ   118
systemheader:(CQ00)#                                                    CQ00   1
# ################################################################## #  CQ00   2
#                                                                    #  CQ00   3
#                               CQ00                                 #  CQ00   4
#                                                                    #  CQ00   5
# ################################################################## #  CQ00   6
SUBROUTINE CQ00#                       Critique all observations        CQ00   7
#                                        Oct 1979  r.a. alden           CQ00   8
#                                        Extensive rewrite              CQ00   9
#                                        June 1985 k.d.watenpaugh       CQ00  10
#                                        Modified nov,1986, kdw         CQ00  11
#                                                                       CQ00  12
include:(AACOMN)#                                                       CQ00  13
include:(CQCOMN)#                                                       CQ00  14
#                                                                       CQ00  15
CALL CQ11#                             Process input images and bdf     CQ00  16
#                                         Log. recs. through lrexpl:.   CQ00  17
#                                                                       CQ00  18
CALL CQ21#                             Prepare discrepancy tables       CQ00  19
#                                                                       CQ00  20
CALL CQ31#                             List all ranked reflections      CQ00  21
#                                         In hkl order.                 CQ00  22
#                                                                       CQ00  23
RETURN#                                                                 CQ00  24
END#                                                                    CQ00  25
systemheader:(CQ01)#                                                    CQ01   1
# ################################################################## #  CQ01   2
#                                                                    #  CQ01   3
#                               CQ01                                 #  CQ01   4
#                                                                    #  CQ01   5
# ################################################################## #  CQ01   6
SUBROUTINE CQ01(NREP)#                 Process a single reflection      CQ01   7
#                                         Calculating its average f**2  CQ01   8
#                                         And sigma(f**2).              CQ01   9
#                                        Oct 1979  r.a. alden           CQ01  10
include:(AACOMN)#                                                       CQ01  11
include:(CQCOMN)#                                                       CQ01  12
#                                                                       CQ01  13
INTEGER FPT#                           Pointer to current f**2          CQ01  14
INTEGER I#                             Observation loop index           CQ01  15
INTEGER J#                             Shift number loop index          CQ01  16
INTEGER NREP#                          Number of replicates of          CQ01  17
#                                         Current reflection.           CQ01  18
INTEGER SCPT#                          Ptr for a particular scale       CQ01  19
INTEGER SHPT#                          Ptr to current shift no.         CQ01  20
#                                                                       CQ01  21
REAL DEN#                              Sum of the weights for the       CQ01  22
#                                         Current reflection.           CQ01  23
REAL NUM#                              Sum of the weights x f**2        CQ01  24
REAL SCALE#                            Current scale factor             CQ01  25
#                                                                       CQ01  26
ISW  = no:#                            Initializations.........         CQ01  27
NREP = 0#                                                               CQ01  28
NUM  = 0.#                                                              CQ01  29
DEN  = 0.#                                                              CQ01  30
FPT = FPTR - 4#                                                         CQ01  31
#                                                                       CQ01  32
FOR(I=1; I <= OBS; I=I+1)#             Loop over the observations       CQ01  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CQ01  34
FPT = FPT + 4#                         Point to next f**2               CQ01  35
SIGMA = QX(FPT+2)#                     Pick up sigma and                CQ01  36
SHRIFT = QX(FPT+3)#                    Shift number.                    CQ01  37
#                                                                       CQ01  38
QX(FPT+4) = 0.#                        Initialize weight                CQ01  39
IF(SIGMA < 1.)  NEXT#                  Skip zero sigmas                 CQ01  40
#                                                                       CQ01  41
FOR(J=1; J <= NSHIFT; J=J+1)#          Look up shift number             CQ01  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CQ01  43
SHPT = SHPTR + J#                                                       CQ01  44
ifeq:(SHRIFT,QX(SHPT))  BREAK#                                          CQ01  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CQ01  46
IF(J > NSHIFT)  NEXT#                  Skip if shift not wanted         CQ01  47
NREP = NREP + 1#                       Count replicates                 CQ01  48
#                                                                       CQ01  49
SCPT = SCPTR + J#                      Point to proper scale factor     CQ01  50
SCALE = QX(SCPT)#                      And pick it up.                  CQ01  51
FSQ = SCALE*QX(FPT+1)#                 Scale f**2 and                   CQ01  52
SIGMA = SCALE*SIGMA#                   Sigma.                           CQ01  53
WT = 1./SIGMA**2#                      Calculate weight                 CQ01  54
#                                                                       CQ01  55
NUM = NUM + WT*FSQ#                                                     CQ01  56
DEN = DEN + WT#                                                         CQ01  57
#                                                                       CQ01  58
QX(FPT+1) = FSQ#                       Return scaled values             CQ01  59
QX(FPT+2) = SIGMA#                     And                              CQ01  60
QX(FPT+4) = WT#                        Weight.                          CQ01  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CQ01  62
#                                                                       CQ01  63
IF(NREP > 0)#                                                           CQ01  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CQ01  65
AVGFSQ = NUM/DEN#                      Mean f**2                        CQ01  66
SIGFSQ = SQRT(1./DEN)#                 Mean sigma(f**2)                 CQ01  67
IF(AVGFSQ > FSQMIN)  ISW = yes:#       Set flag if this reflection      CQ01  68
#                                         Useable.                      CQ01  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CQ01  70
#                                                                       CQ01  71
RETURN#                                                                 CQ01  72
END#                                                                    CQ01  73
systemheader:(CQ02)#                                                    CQ02   1
# ################################################################## #  CQ02   2
#                                                                    #  CQ02   3
#                               CQ02                                 #  CQ02   4
#                                                                    #  CQ02   5
# ################################################################## #  CQ02   6
SUBROUTINE CQ02(IPOINT)#                                                CQ02   7
#                                                                       CQ02   8
# SUPPLY ALL OBSERVATIONS FOR ONE REFLECTION                            CQ02   9
#                                        Mar 1983  r.a. alden           CQ02  10
#                                        June 1985 k.d.watenpaugh       CQ02  11
#                                                                       CQ02  12
include:(AACOMN)#                                                       CQ02  13
include:(CQCOMN)#                                                       CQ02  14
#                                                                       CQ02  15
INTEGER FSPTR#                         Pointer to start fsq             CQ02  16
INTEGER I#                             Whatever                         CQ02  17
INTEGER IPOINT#                        Location pointer to store        CQ02  18
INTEGER IPT#                           Input packet pointer             CQ02  19
INTEGER J#                             Another whatever                 CQ02  20
INTEGER PSIZE#                         Packet size                      CQ02  21
INTEGER PT20(6)#                       Flag and pointers to lrrefl:     CQ02  22
intdata:(KEY,[4,5,5,0])#               Keys for indexpkt:               CQ02  23
intdata:(NEED20,[1,2,1302,1303,1309])# Required idnums for lrrefl:      CQ02  24
datastuff:#                                                             CQ02  25
# ################################################################## #  CQ02  26
#                                                                       CQ02  27
IF (IPOINT == 0)#                      First time called                CQ02  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CQ02  29
KEY(4) = 0#                            Look for lrrefl: directory a     CQ02  30
indexpkt:(1,lrrefl:,PSIZE,IPT,0,KEY,NEED20,PT20)# Required idnum        CQ02  31
IF(IPT < 0 \ KEY(4) < 0)  iquit:(CQ0201)#                               CQ02  32
#                                                                       CQ02  33
readwpkt:(1,lrrefl:,PSIZE,IPT,0)#      Read first reflection            CQ02  34
IF(IPT <= 0)  iquit:(CQ0202)#          Something's wrong no refls       CQ02  35
#                                                                       CQ02  36
intunpak:(QX(IPT+1),HKLNXT,3,27)#      Get packed indices               CQ02  37
intunpak:(QX(IPT+1),SIGNXT,0,3)#       Get sign info.                   CQ02  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CQ02  39
#                                                                       CQ02  40
ELSE#                                                                   CQ02  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CQ02  42
OBSKIP = 0#                            Clear obs. skipped counter       CQ02  43
NOBS = 0#                              Clear observation counter        CQ02  44
#                                                                       CQ02  45
HKLNOW = HKLNXT#                       Convert next hkl to current      CQ02  46
SIGNOW = SIGNXT#                       Including sign info.             CQ02  47
#                                        Process current reflection     CQ02  48
J = IPT + PT20(2)#                                                      CQ02  49
SITOL = QX(J)#                         Save sine(theta)/lambda          CQ02  50
FSPTR = -4#                            Initialize f**2 pointer          CQ02  51
#                                                                       CQ02  52
WHILE(HKLNXT == HKLNOW $#              Find all the observations fo     CQ02  53
& SIGNXT == SIGNOW)#                   The current reflection.          CQ02  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CQ02  55
IF(NOBS < ALLOWD)#                     Don't allow overflow             CQ02  56
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CQ02  57
NOBS = NOBS + 1#                       Count obs. processed             CQ02  58
FSPTR = FSPTR + 4#                     Point to next f**s               CQ02  59
DO I=1,2#                              Transfer f**2 and sigma          CQ02  60
#                                                                       CQ02  61
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CQ02  62
J = IPT + PT20(I+2)#                                                    CQ02  63
K = IPOINT + FSPTR + I-1#                                               CQ02  64
QX(K) = QX(J)#                                                          CQ02  65
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CQ02  66
K = IPOINT + FSPTR + 2#                Set pointer to store shift n     CQ02  67
QX(K) = 1.0#                           Set to first                     CQ02  68
IF (PT20(5) > 0)#                      Check if shift no. on bdf        CQ02  69
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CQ02  70
J = IPT + PT20(5)#                     Transfer real shift number       CQ02  71
QX(K) = QX(J)#                                                          CQ02  72
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CQ02  73
#                                                                       CQ02  74
readwpkt:(1,lrrefl:,PSIZE,IPT,0)#      Read next observation            CQ02  75
HKLNXT = 0#                            Clear packed hkl                 CQ02  76
IF(IPT == 0)  BREAK#                   Leave, if end of lrrefl:         CQ02  77
J = IPT + PT20(1)#                                                      CQ02  78
intunpak:(QX(J),HKLNXT,3,27)#          Otherwise save new packed hk     CQ02  79
intunpak:(QX(J),SIGNXT,0,3)#           And the signs                    CQ02  80
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CQ02  81
ELSE  OBSKIP = OBSKIP + 1#             Count skipped obs.               CQ02  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CQ02  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CQ02  84
#                                                                       CQ02  85
RETURN#                                                                 CQ02  86
END#                                                                    CQ02  87
systemheader:(CQ05)#                                                    CQ05   1
# ################################################################## #  CQ05   2
#                                                                    #  CQ05   3
#                               CQ05                                 #  CQ05   4
#                                                                    #  CQ05   5
# ################################################################## #  CQ05   6
SUBROUTINE CQ05(WHICH)#                Routine for reading logical      CQ05   7
#                                         Record lrrefl:.  buffers in   CQ05   8
#                                         One hkl's-worth of            CQ05   9
#                                         Observations and, possibly,   CQ05  10
#                                         The observations for its      CQ05  11
#                                         Bijvoet hkl.                  CQ05  12
#                                        Mar 1979  r.a. alden           CQ05  13
#                                        Updated oct 1979  r. alden     CQ05  14
#                                        Revised mar 1983  r.a. alden   CQ05  15
#                                        June 1985 k.d.watenpaugh       CQ05  16
#                                        Nov 1986, kdw                  CQ05  17
#                                                                       CQ05  18
include:(AACOMN)#                                                       CQ05  19
include:(CQCOMN)#                                                       CQ05  20
#                                                                       CQ05  21
INTEGER I#                             Local integer                    CQ05  22
INTEGER IBY#                           For getting bijvoet              CQ05  23
INTEGER IH(3)#                         Index for checking zero          CQ05  24
INTEGER JP#                            Pointer to current fsq           CQ05  25
INTEGER WHICH#                         Flag denoting which part of      CQ05  26
REAL TEMP#                             Word for exchanging bijvoet      CQ05  27
#                                         Routine is being executed.    CQ05  28
#                                                                       CQ05  29
intdata:(IP,[0])#                      Pointer to start of space        CQ05  30
# # GROUP FSQ STORAGE.                                                  CQ05  31
#                                                                       CQ05  32
datastuff:#                                                             CQ05  33
IF(WHICH == 0)#                                                         CQ05  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CQ05  35
IP = FPTR + 1#                         Start of space group fsq's       CQ05  36
#                                                                       CQ05  37
TOTREF = 0#                            Clear                            CQ05  38
REFSG  = 0#                                                             CQ05  39
REFBY  = 0#                            Various                          CQ05  40
RFBOTH = 0#                                                             CQ05  41
TSGOBS = 0#                            Counts                           CQ05  42
TBYOBS = 0#                                                             CQ05  43
TOTOBS = 0#                                                             CQ05  44
TOBSKP = 0#                                                             CQ05  45
#                                                                       CQ05  46
HKLNXT = 0#                            Clear next hkl                   CQ05  47
SIGNXT = 0#                            And its signs                    CQ05  48
#                                                                       CQ05  49
CALL CQ02(0)#                          Initial call for indexpkt:       CQ05  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CQ05  51
#                                                                       CQ05  52
ELSE#                                                                   CQ05  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CQ05  54
# UPON RETURN...........                                                CQ05  55
#   HKL CONTAINS THE SPACE GROUP INDICES CORRESPONDING TO HKLNOW        CQ05  56
#   HKLBY  "      "     BIJVOET     "          "        "    "          CQ05  57
#   HKLNOW ARE THE MAGNITUDES INDICES FOUND ON THE BDF                  CQ05  58
#   SIGNOW ARE THE SIGNS                                                CQ05  59
#   HKLNXT  "   "  MAGNITUDES INDICES FOR THE NEXT REFLECTION           CQ05  60
#   SIGNXT  "   "  SIGNS FOR THE INDICES                                CQ05  61
#                                                                       CQ05  62
# THE WAY TO KNOW WHAT IS SITTING IN THE REFLECTION RECORD IS TO        CQ05  63
#   CHECK OBSSG AND OBSBY.                                              CQ05  64
#                                                                       CQ05  65
OBSSG = 0#                             Clear space group obs. count     CQ05  66
OBSBY = 0#                             Likewise for bijvoet obs.        CQ05  67
#                                                                       CQ05  68
# TEST THE NEXT PACKED HKL.  IT IS ALREADY SITTING IN HKLNXT            CQ05  69
#                                                                       CQ05  70
IF(HKLNXT != 0)#                       An hklnxt of 0 signals the       CQ05  71
#                                         End of all reflections.       CQ05  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CQ05  73
HKLNOW = HKLNXT#                                                        CQ05  74
SIGNOW = SIGNXT#                                                        CQ05  75
#                                                                       CQ05  76
# SINCE A VALID HKL IS PRESENT, READ IN ITS DATA                        CQ05  77
CALL CQ02(IP)#                                                          CQ05  78
#                                                                       CQ05  79
TOTOBS = TOTOBS + OBSKIP + NOBS#       Increment counters               CQ05  80
TOBSKP = TOBSKP + OBSKIP#                                               CQ05  81
#                                                                       CQ05  82
intpak:(HKLNOW,HKL,3,27)#              Move packed indices              CQ05  83
movepakwd:(HKL,HKLBY)#                                                  CQ05  84
intpak:(SIGNOW,HKL,0,3)#               Move in sign bits                CQ05  85
intpak:(7-SIGNOW,HKLBY,0,3)#                                            CQ05  86
DO I=1,3#                              Filter out signs on zeros        CQ05  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CQ05  88
intunpak:(HKL,IH(I),30-I*9,9)#         Get index                        CQ05  89
IF (IH(I) == 0)#                       Zero index, get rid of sign      CQ05  90
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CQ05  91
intpak:(0,HKL,3-I,1)#                                                   CQ05  92
intpak:(0,HKLBY,3-I,1)#                                                 CQ05  93
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CQ05  94
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CQ05  95
#                                                                       CQ05  96
intunpak:(HKL,IH(1),0,3)#              Get packed isgns of major        CQ05  97
intunpak:(HKLBY,IBY,0,3)#              Get packed signs of bijvoet      CQ05  98
IF(IH(1)>IBY)#                         Reverse bijvoet refl             CQ05  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CQ05 100
movepakwd:(HKL,TEMP)#                                                   CQ05 101
movepakwd:(HKLBY,HKL)#                                                  CQ05 102
movepakwd:(TEMP,HKLBY)#                                                 CQ05 103
IBY = IH(1)#                                                            CQ05 104
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CQ05 105
#                                                                       CQ05 106
IF (IBY == SIGNOW)#                    Check if bijvoet refl            CQ05 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CQ05 108
OBSBY = NOBS#                          Save the count                   CQ05 109
REFBY = REFBY + 1#                     Increment refby                  CQ05 110
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CQ05 111
ELSE#                                  Space group reflection           CQ05 112
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CQ05 113
OBSSG = NOBS#                          Save the count                   CQ05 114
REFSG = REFSG + 1#                     Increment refsg                  CQ05 115
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CQ05 116
# IF SPACE GROUP AND BIJVOET OBSERVATIONS ARE TO BE MERGED, THEN        CQ05 117
#  THE NEXT REFLECTION MUST NOW BE CHECKED. THE FOLLOWING               CQ05 118
#  POSSIBILITIES EXIST:                                                 CQ05 119
#  IF THE LAST REFLECTION WAS A SPACE GROUP ONE, THE NEXT ONE MAY       CQ05 120
#  BE                                                                   CQ05 121
#   1) THE BIJVOET OF THAT,                                             CQ05 122
#   2) A NEW SPACE GROUP ONE,                                           CQ05 123
#   3) A NEW BIJVOET ONE, OR                                            CQ05 124
#   4) NOTHING AT ALL (END OF LOGICAL RECORD).                          CQ05 125
#  IF THE LAST REFLECTION WAS A BIJVOET ONE WITH NO CORRESPONDING       CQ05 126
#   SPACE GROUP ONE, THE NEXT ONE MAY BE                                CQ05 127
#   1) A NEW SPACE GROUP ONE,                                           CQ05 128
#   2) A NEW BIJVOET ONE, OR                                            CQ05 129
#   3) NOTHING AT ALL, BUT CANNOT BE THE CORRESPONDING SPACE GROUP      CQ05 130
#      ONE.                                                             CQ05 131
#                                                                       CQ05 132
# IF NO MERGING IS TO BE DONE, THEN WE DON'T CARE ABOUT THE NEXT        CQ05 133
#  REFLECTION YET.                                                      CQ05 134
#                                                                       CQ05 135
IF(IMERGE == 0)#                                                        CQ05 136
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CQ05 137
#                                                                       CQ05 138
# ONCE AGAIN THE NEXT HKL IS PRESENT IN HKLNXT.  ITS VALUE CAN          CQ05 139
#  BE CHECKED TO DETERMINE IF IT IS THE BIJVOET OF THE CURRENT          CQ05 140
#  REFLECTION.  IF IT IS, THEN THE BIJVOET DATA WILL BE MERGED          CQ05 141
#  WITH THAT FOR THE SPACE GROUP, CURRENTLY RESIDING IN THE             CQ05 142
#  BUFFER.                                                              CQ05 143
#                                                                       CQ05 144
IF (HKLNOW == HKLNXT)#                 Check if friedel                 CQ05 145
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CQ05 146
IF (IBY == SIGNXT)#                    Now and next are friedels        CQ05 147
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CQ05 148
JP = IP + 4*NOBS#                      Point to next storage            CQ05 149
#                                         Location of f**2              CQ05 150
#                                                                       CQ05 151
# READ IN THE DATA FOR THE BIJVOET REFLECTION TO BE MERGED              CQ05 152
#                                                                       CQ05 153
CALL CQ02(JP)#                                                          CQ05 154
#                                                                       CQ05 155
TOTOBS = TOTOBS + OBSKIP + NOBS#       Increment counts                 CQ05 156
TOBSKP = TOBSKP + OBSKIP#                                               CQ05 157
#                                                                       CQ05 158
OBSBY = NOBS#                          Save the count                   CQ05 159
REFSG = REFSG - 1#                     Decrement space group only       CQ05 160
#                                         Counter.                      CQ05 161
RFBOTH = RFBOTH + 1#                   Increment rfboth                 CQ05 162
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CQ05 163
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CQ05 164
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CQ05 165
#                                                                       CQ05 166
OBS = OBSSG + OBSBY#                   Total obs. for this refl.        CQ05 167
TOTREF = REFSG + REFBY + RFBOTH#       Increment total refl. counte     CQ05 168
TSGOBS = TSGOBS + OBSSG#               Total space group obs.           CQ05 169
TBYOBS = TBYOBS + OBSBY#               Total bijvoet obs.               CQ05 170
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CQ05 171
ELSE SITOL = -1.#                      Put out a negative sitol to      CQ05 172
#                                         Signal the end of lrrefl:.    CQ05 173
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CQ05 174
#                                                                       CQ05 175
RETURN#                                                                 CQ05 176
END#                                                                    CQ05 177
systemheader:(CQ11)#                                                    CQ11   1
# ################################################################## #  CQ11   2
#                                                                    #  CQ11   3
#                               CQ11                                 #  CQ11   4
#                                                                    #  CQ11   5
# ################################################################## #  CQ11   6
SUBROUTINE CQ11#                       Read lrexpl: & process scales    CQ11   7
#                                        Oct 1979  r.a. alden           CQ11   8
#                                        June 1985 k.d.watenpaugh       CQ11   9
#                                                                       CQ11  10
include:(AACOMN)#                                                       CQ11  11
include:(CQCOMN)#                                                       CQ11  12
#                                                                       CQ11  13
INTEGER FIRST#                         Column of initial character      CQ11  14
INTEGER INDX,NCHAR#                                                     CQ11  15
INTEGER LAST#                          Final column + 1 of an ascii     CQ11  16
INTEGER LIMIT#                         Limit on the number of           CQ11  17
#                                         Obs./refl. for acceptance or  CQ11  18
#                                         Rejection.                    CQ11  19
INTEGER NBAD#                          The number of worst              CQ11  20
#                                         Discrepancies requested for   CQ11  21
#                                         Listing.                      CQ11  22
string:(WORD,6)#                       Ascii characters in input        CQ11  23
#                                         Image field 7.                CQ11  24
#                                                                       CQ11  25
chardata:(WHICH,ACCEPTREJECT)#                                          CQ11  26
chardata:(CQ011,BIJVOET OBSERVATIONS      BE MERGED WITH SPACE $#       CQ11  27
GROUP ONES)#                                                            CQ11  28
chardata:(CQ012,WILLWONT)#                                              CQ11  29
chardata:(CQ013,THE      LARGEST DISCREPANCIES IN EACH OF FOUR $#       CQ11  30
CATEGORIES WILL BE ACCUMULATED)#                                        CQ11  31
chardata:(CQ014,ONLY REFLECTIONS FOR WHICH THE AVERAGE SCALED F**2 $#   CQ11  32
EXCEEDS         WILL BE USED)#                                          CQ11  33
chardata:(CQ015,OBSERVATIONS IN SCALE GROUPS      THRU      $#          CQ11  34
INCLUSIVE WILL BE RANKED)#                                              CQ11  35
chardata:(CQ016,FOR RANKING$,        THOSE REFLECTIONS WITH MORE $#     CQ11  36
THAN      OBSERVATIONS)#                                                CQ11  37
chardata:(CQ017,SINGLY OBSERVED REFLECTIONS LYING IN THE $#             CQ11  38
SINE(THETA)/LAMBDA RANGE OF         TO         WILL BE LISTED $#        CQ11  39
SEPARATELY)#                                                            CQ11  40
chardata:(CQ018, SCALE  END    )#                                       CQ11  41
chardata:(CQ019,REFLECTIONS ON THE INPUT BDF ARE SORTED IN     ORDER)#  CQ11  42
chardata:(CQ01A,NO MORE THAN      UNRANKED OBSERVATIONS WILL BE $#      CQ11  43
LISTED FOR ANY ONE REFLECTION)#                                         CQ11  44
realdata:(FMT011,[340413.,440413.])#                                    CQ11  45
realdata:(FMT012,[880722.,770722.])#                                    CQ11  46
realdata:(FMT013,[180413.,90413.,670722.,580413.])#                     CQ11  47
datastuff:#                                                             CQ11  48
#                                                                       CQ11  49
IOMARK(1) = QXSTR#                     Start of input buffer            CQ11  50
SHPTR = IOMARK(1) + bdfbuf:#           Start of shift numbers           CQ11  51
incrqx:(FPTR,SHPTR+arith:(2,*,maxshifts:),CQ1101)# C                    CQ11  52
#                                                                       CQ11  53
# INITIALLY THE SHIFTS ARRAY ALLOWS FOR MAXSHIFTS: SHIFT NUMBERS        CQ11  54
#  AND SCALE FACTORS.  HOWEVER, ONCE THE ACTUAL NUMBER OF SHIFT         CQ11  55
#  NUMBERS HAS BEEN DETERMINED, THE ARRAY WILL BE REDUCED DOWN          CQ11  56
#  TO THE NUMBER OF LOCATIONS ACTUALLY REQUIRED.                        CQ11  57
#                                                                       CQ11  58
ALLOWD = max:#                         Allow max: obs./refl.            CQ11  59
#                                                                       CQ11  60
# READ AND PROCESS CRITIQ IMAGE.  THE FIELDS ARE DEFINED AS FOLLOWS:    CQ11  61
#                                                                       CQ11  62
#  FIELD                DEFINITION                          DEFAULT     CQ11  63
#  -----                ----------                          -------     CQ11  64
#    1          IMERGE;  0/1 MERGE/DO NOT MERGE BIJVOET         0       CQ11  65
#                        PAIRS.                                         CQ11  66
#    2          THE MOST WORST DISCREPANCIES IN EACH OF       100       CQ11  67
#                        4 CATEGORIES WILL BE LISTED.                   CQ11  68
#    3          FSQMIN;  ONLY OBSERVATIONS WITH FSQ > FSQMIN    0.      CQ11  69
#                        WILL BE LISTED.                                CQ11  70
#    4          LOSHFT;  RANK OBSERVATIONS IN SHIFTS L(I),      1       CQ11  71
#    5          HISHFT;  WHERE LOSHFT<=L(I)<=HISHFT.         4095       CQ11  72
#    6          'ACCEPT' IF ONLY REFLECTIONS WITH MORE THAN             CQ11  73
#                        LIMIT OBSERVATIONS ARE TO BE RANKED.           CQ11  74
#               'REJECT' IF REFLECTIONS WITH MORE THAN LIMIT            CQ11  75
#                        OBSERVATIONS ARE TO BE REJECTED FOR            CQ11  76
#                        RANKING PURPOSES.                              CQ11  77
#    7          LIMIT;   IF THE 'ACCEPT'/'REJECT' AND LIMIT   100       CQ11  78
#                        FIELDS ARE VOID, ALL REFLECTIONS               CQ11  79
#                        WITH MULTIPLE OBSERVATIONS WILL BE             CQ11  80
#                        RANKED.                                        CQ11  81
#    8          SMIN;    THESE 2 FIELDS CONTROL LISTING OF      0.      CQ11  82
#    9          SMAX;    SINGLY OBSERVED REFLECTIONS.  IF BOTH          CQ11  83
#                        FIELDS ARE 0 OR VOID, NONE WILL BE             CQ11  84
#                        LISTED.                                        CQ11  85
#   10          MAXR;    NO MORE THAN MAX UNRANKED OBSER-      20       CQ11  86
#                        VATIONS WILL BE LISTED FOR ANY                 CQ11  87
#                        GIVEN REFLECTION.                              CQ11  88
#                                                                       CQ11  89
# GET MERGE FLAG;  DEFAULT IS MERGE.                                    CQ11  90
ifvo:(BUFIN(1))  BUFIN(1) = 0.#                                         CQ11  91
IMERGE = NINT(BUFIN(1))#                                                CQ11  92
#                                                                       CQ11  93
# NUMBER OF WORST TO BE LISTED;  DEFAULT = 100; MAXIMUM = 1000.         CQ11  94
IF(BUFIN(2) <= 0.)  BUFIN(2) = 100.#                                    CQ11  95
NBAD = NINT(BUFIN(2))#                                                  CQ11  96
MOST = MIN0(NBAD,1000)#                                                 CQ11  97
MOST4 = 4*MOST#                                                         CQ11  98
#                                                                       CQ11  99
IF(BUFIN(3) <= 0.)  BUFIN(3) = 0.#     Minimum fsq to be listed;        CQ11 100
FSQMIN = BUFIN(3)#                     Default = 0.                     CQ11 101
#                                                                       CQ11 102
# SHIFT NUMBERS TO BE INCLUDED IN LISTING;  DEFAULT IS ALL OF THEM.     CQ11 103
IF(BUFIN(4) <= 0. \ BUFIN(4) > 4095.)  BUFIN(4) = 1.#                   CQ11 104
LOSHFT = NINT(BUFIN(4))#                                                CQ11 105
IF(BUFIN(5) <= 0. \ BUFIN(5) > 4095.)  BUFIN(5) = 4095.#                CQ11 106
HISHFT = NINT(BUFIN(5))#                                                CQ11 107
IF(LOSHFT > HISHFT)  iquit:(-CQ1102,5)#                                 CQ11 108
#                                                                       CQ11 109
stringlim:(6,FIRST,LAST)#              Look for 'accept' or 'reject     CQ11 110
NCHAR = LAST - FIRST#                                                   CQ11 111
movechar:(CHRIN,FIRST,WORD,1,NCHAR,0)#                                  CQ11 112
compchar:(WORD,1,WHICH,1,6,6,12,INDX)#                                  CQ11 113
#                                                                       CQ11 114
LOLIM = 0#                                                              CQ11 115
UPLIM = 9999#                                                           CQ11 116
#                                                                       CQ11 117
IF(BUFIN(7) <= 0.)  BUFIN(7) = 100.#   Number of observations for       CQ11 118
LIMIT = NINT(BUFIN(7))#                'accept'/'reject' test;          CQ11 119
#                                         Default = 100.                CQ11 120
#                                                                       CQ11 121
IF(INDX == 1)  LOLIM = LIMIT#          Acceptance lower bound           CQ11 122
IF(INDX == 2)  UPLIM = LIMIT#          Rejection  upper bound           CQ11 123
#                                                                       CQ11 124
SMIN = BUFIN(8)#                       Get minimum and maximum sito     CQ11 125
SMAX = BUFIN(9)#                       Defaults are both 0.             CQ11 126
IF(SMIN <= 0.)  SMIN = 0.#                                              CQ11 127
IF(SMAX <= 0.)  SMAX = 0.#                                              CQ11 128
IF(SMAX > 0.7)  SMAX = 0.7#                                             CQ11 129
IF(SMIN > SMAX)  iquit:(-CQ1103,9)#                                     CQ11 130
#                                                                       CQ11 131
# MAXIMUM NUMBER OF UNRANKED OBSERVATIONS TO BE LISTED PER REFLECTION;  CQ11 132
ifvo:(BUFIN(10))  BUFIN(10) = 20.#                                      CQ11 133
MAXR= NINT(BUFIN(10))#                                                  CQ11 134
IF(MAXR<= 0)  MAXR= 20#                Default = 20.                    CQ11 135
#                                                                       CQ11 136
movechar:(CQ01A,1,CHROT,2,NCQ01A,0)#                                    CQ11 137
ncodefld:(BUFIN,11,CHROT,FMT013(1),1)#                                  CQ11 138
writeline:(1,0,0,1,3)#                                                  CQ11 139
#                                                                       CQ11 140
movechar:(CQ011,1,CHROT,2,NCQ011,0)#                                    CQ11 141
IF(IMERGE == 0)  movechar:(CQ012,1,CHROT,23,4,0)#                       CQ11 142
ELSE             movechar:(CQ012,5,CHROT,23,4,0)#                       CQ11 143
writeline:(1,0,0,1,3)#                                                  CQ11 144
#                                                                       CQ11 145
movechar:(CQ013,1,CHROT,2,NCQ013,0)#                                    CQ11 146
ncodefld:(BUFIN,3,CHROT,FMT013(2),1)##                                  CQ11 147
writeline:(1,0,0,1,3)#                                                  CQ11 148
#                                                                       CQ11 149
movechar:(CQ014,1,CHROT,2,NCQ014,0)#                                    CQ11 150
ncodefld:(BUFIN,4,CHROT,FMT013(3),1)##                                  CQ11 151
writeline:(1,0,0,1,3)#                                                  CQ11 152
#                                                                       CQ11 153
IF(QUITF(1^1)!=' ')iquit:(CQ1199)#     Quit, if any errors so far       CQ11 154
#                                                                       CQ11 155
movechar:(CQ015,1,CHROT,2,NCQ015,0)#                                    CQ11 156
ncodefld:(BUFIN,5,CHROT,FMT011(1),2)#                                   CQ11 157
writeline:(1,0,0,1,3)#                                                  CQ11 158
#                                                                       CQ11 159
IF(INDX > 0)#                                                           CQ11 160
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CQ11 161
movechar:(CQ016,1,CHROT,2,NCQ016,0)#                                    CQ11 162
movechar:(WORD,1,CHROT,15,6,0)#                                         CQ11 163
ncodefld:(BUFIN,8,CHROT,FMT013(4),1)##                                  CQ11 164
writeline:(1,0,0,1,3)#                                                  CQ11 165
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CQ11 166
#                                                                       CQ11 167
movechar:(CQ017,1,CHROT,2,NCQ017,0)#                                    CQ11 168
BUFOT(1) = SMAX#                                                        CQ11 169
BUFOT(2) = SMIN#                                                        CQ11 170
ncodefld:(BUFOT,1,CHROT,FMT012(1),2)##                                  CQ11 171
writeline:(1,0,0,1,3)#                                                  CQ11 172
#                                                                       CQ11 173
CALL CQ12#                             Process scales                   CQ11 174
#                                                                       CQ11 175
SCPTR = SHPTR + NSHIFT#                                                 CQ11 176
FPTR = SCPTR + NSHIFT#                 Re-adjust beginning of f**2      CQ11 177
#                                                                       CQ11 178
RETURN#                                                                 CQ11 179
END#                                                                    CQ11 180
systemheader:(CQ12)#                                                    CQ12   1
# ################################################################## #  CQ12   2
#                                                                    #  CQ12   3
#                               CQ12                                 #  CQ12   4
#                                                                    #  CQ12   5
# ################################################################## #  CQ12   6
SUBROUTINE CQ12#                       Process either scale images      CQ12   7
#                                         Or logical record lrexpl: and CQ12   8
#                                         Build a table of shift        CQ12   9
#                                         Numbers and their correspond- CQ12  10
#                                         Ing scale factors.            CQ12  11
#                                        Jun 1979  r.a. alden           CQ12  12
#                                        Re-written jan 1983  r. alden  CQ12  13
include:(AACOMN)#                                                       CQ12  14
include:(CQCOMN)#                                                       CQ12  15
#                                                                       CQ12  16
INTEGER NEED11(arith:(2,+,maxshifts:))#                                 CQ12  17
INTEGER I#                             Loop index                       CQ12  18
INTEGER PSIZE#                         Logical record size              CQ12  19
INTEGER PT11(arith:(3,+,maxshifts:))#  Lrexpl: offsets                  CQ12  20
INTEGER SCPT#                          Pointer to current scale fac     CQ12  21
INTEGER SHFTIN#                        Number of scale groups on        CQ12  22
REAL SCALE#                            Initial scale factor             CQ12  23
chardata:(CQ101, SCALE  END    )#                                       CQ12  24
chardata:(CQ102, SHIFT NUMBER   SCALE FACTOR)#                          CQ12  25
intdata:(SHPT,[0])#                    Pointer to new location of       CQ12  26
realdata:(FMT101,[110413.,261252.])#                                    CQ12  27
intdata:(KEY,[1,0,0,0])#                                                CQ12  28
datastuff:#                                                             CQ12  29
#                                                                       CQ12  30
KEY(2)=arith:(1,+,maxshifts:)#                                          CQ12  31
KEY(3)=KEY(2)#                                                          CQ12  32
NSHIFT = 0#                            Initial no. of shifts 0          CQ12  33
NEED11(1)=12;NEED11(2)=100#                                             CQ12  34
DO I=1,maxshifts:#                                                      CQ12  35
NEED11(I+2) = 100 + I#                 Set up scale direct no.          CQ12  36
#                                                                       CQ12  37
# SKIP DOWN TO LOGICAL RECORD  LREXPL:                                  CQ12  38
indexpkt:(1,lrexpl:,PSIZE,IPT,0,KEY,NEED11,PT11)#                       CQ12  39
#                                                                       CQ12  40
# SET OF SHIFT NUMBERS MUST BE PRESENT                                  CQ12  41
IF((KEY(4) < 0) \ (IPT <= 0))  iquit:(CQ1202)#                          CQ12  42
#                                                                       CQ12  43
readwpkt:(1,lrexpl:,PSIZE,IPT,0)#      Read next packet                 CQ12  44
SHPT = IPT + PT11(1)#                  Get order sorted                 CQ12  45
MORDER(1) = NINT(QX(SHPT)/100)#        Major sort index                 CQ12  46
QX(SHPT) = QX(SHPT) - 100.*FLOAT(MORDER(1))# Remove major sort index    CQ12  47
MORDER(2) = NINT(QX(SHPT)/10)#         Medium sort index                CQ12  48
QX(SHPT) = QX(SHPT) -10.*FLOAT(MORDER(2))# Remove medium sort index     CQ12  49
MORDER(3) = NINT(QX(SHPT))#                                             CQ12  50
SHPT = IPT + PT11(2)#                                                   CQ12  51
SHFTIN = NINT(QX(SHPT))#               Number of scale groups prese     CQ12  52
SCPTR = SHPTR + SHFTIN#                Point to scale factors           CQ12  53
#                                                                       CQ12  54
readline:(CQ101,NCQ101)#               Get the first image              CQ12  55
WHILE(LINID == 1)#                     Loop over the scale images       CQ12  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CQ12  57
ifvo:(BUFIN(1))  iquit:(CQ1201,1)#                                      CQ12  58
IF(BUFIN(1) < 1.) iquit:(CQ1201,1)#                                     CQ12  59
I = NINT(BUFIN(1))#                                                     CQ12  60
IF (I > SHFTIN) iquit:(CQ1201,1)#      Shift number too large           CQ12  61
NSHIFT = NSHIFT + 1#                   Increment shift counter          CQ12  62
IF(NSHIFT > maxshifts:)  iquit:(CQ1203)# Too many scale lines           CQ12  63
#                                                                       CQ12  64
# PICK UP THE SHIFT NUMBER AND ITS SCALE FACTOR                         CQ12  65
movereal:(BUFIN,1,QX,SHPTR+NSHIFT,1,0)#                                 CQ12  66
ifvo:(BUFIN(2))#                       If no scale provided,            CQ12  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CQ12  68
SCPT = IPT + PT11(I+2)#                Then get it off of the bdf.      CQ12  69
SCALE = QX(SCPT)#                                                       CQ12  70
ifvo:(SCALE)  SCALE = 1.#              If it's also void, then set      CQ12  71
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CQ12  72
ELSE  SCALE = BUFIN(2)#                Otherwise, use value on line     CQ12  73
IF(SCALE < 0.)  iquit:(-CQ1204)#       Must be greater than zero        CQ12  74
BUFOT(1) = SCALE#                                                       CQ12  75
QX(SCPTR+NSHIFT) = SCALE#                                               CQ12  76
readline:(CQ101,NCQ101)#               Get the next image               CQ12  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CQ12  78
#                                                                       CQ12  79
# IF THERE WERE NO SCALE IMAGES, THEN READ THE SHIFT NUMBERS FROM       CQ12  80
#  LOGICAL RECORD LREXPL:.                                              CQ12  81
#                                                                       CQ12  82
IF(NSHIFT == 0)#                                                        CQ12  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CQ12  84
NSHIFT = SHFTIN#                       Number of shifts                 CQ12  85
DO I=1,NSHIFT#                         Transfer scales from bdf         CQ12  86
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CQ12  87
SCPT = IPT + PT11(I+2)#                                                 CQ12  88
QX(SHPTR+I) = I#                       Store "shift" no.                CQ12  89
IF (SCPT != IPT) QX(SCPTR+I) = QX(SCPT)# Scale is present               CQ12  90
ELSE QX(SCPTR+I) = 1.0#                Default to 1.0                   CQ12  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CQ12  92
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CQ12  93
#                                                                       CQ12  94
# WRITE THE TABLE HEADING                                               CQ12  95
#                                                                       CQ12  96
writeline:(1,CQ102,NCQ102,3,3)#                                         CQ12  97
DO I=1,NSHIFT#                         Loop over input shift number     CQ12  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CQ12  99
ncodefld:(QX,SHPTR+I,CHROT,FMT101(1),1)#                                CQ12 100
ncodefld:(QX,SCPTR+I,CHROT,FMT101(2),1)#                                CQ12 101
writeline:(0,CQ102,NCQ102,1,3)#                                         CQ12 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CQ12 103
#                                                                       CQ12 104
IF(QUITF(1^1)!=' ')iquit:(CQ1299)#     Any errors so far?               CQ12 105
SCPT = SHPTR + NSHIFT#                 Point to the new location of     CQ12 106
#                                         The scale factors and move    CQ12 107
movereal:(QX,SCPTR+1,QX,SCPT+1,NSHIFT,1)#                               CQ12 108
#                                                                       CQ12 109
RETURN#                                                                 CQ12 110
END#                                                                    CQ12 111
systemheader:(CQ21)#                                                    CQ21   1
# ################################################################## #  CQ21   2
#                                                                    #  CQ21   3
#                               CQ21                                 #  CQ21   4
#                                                                    #  CQ21   5
# ################################################################## #  CQ21   6
#                                         Compile discrepancy tables.   CQ21   7
SUBROUTINE CQ21#                       List singly observed             CQ21   8
#                                         Reflections, if requested.    CQ21   9
#                                        List discrepancy tables.       CQ21  10
#                                        Oct 1979  r.a. alden           CQ21  11
include:(AACOMN)#                                                       CQ21  12
include:(CQCOMN)#                                                       CQ21  13
#                                                                       CQ21  14
INTEGER ENDPTR#                        Pointer to end of current        CQ21  15
#                                         Discrepancy table.            CQ21  16
INTEGER FPT#                           Pointer to current f**2          CQ21  17
INTEGER I#                             Loop index                       CQ21  18
INTEGER IH(3)#                         Miller indices                   CQ21  19
INTEGER IORD#                          Ordinal number of observatio     CQ21  20
INTEGER ISHIFT#                        Current shift number             CQ21  21
INTEGER J#                             Loop index                       CQ21  22
INTEGER LINE(24)#                      One line of a rank-ordered       CQ21  23
#                                         Table.                        CQ21  24
INTEGER M#                                                              CQ21  25
INTEGER MAJCOL#                        Loop index over major column     CQ21  26
#                                         Per page.                     CQ21  27
INTEGER MAXL#                          Number of singly observed hk     CQ21  28
#                                         That can be printed on a line CQ21  29
INTEGER MOBS#                          Number of obs. which pass al     CQ21  30
#                                         Criteria tests.               CQ21  31
INTEGER MREFS#                         Number of refls. which pass      CQ21  32
#                                         Criteria tests.               CQ21  33
INTEGER NAMPTR#                        Pointer to current discrepan     CQ21  34
#                                         Table name.                   CQ21  35
INTEGER NCOL#                          Column pointer                   CQ21  36
INTEGER NL#                            Loop index over lines per pa     CQ21  37
INTEGER NLPAGE#                        Number of lines remaining on     CQ21  38
#                                         Page.                         CQ21  39
INTEGER NLTOTL#                        Number of lines required for     CQ21  40
#                                         Complete listing of           CQ21  41
#                                         Rank-ordered table.           CQ21  42
INTEGER NREP#                          Number of replicates for the     CQ21  43
#                                         Current refl.                 CQ21  44
INTEGER NSINGL#                        Number of singly observed        CQ21  45
#                                         Refls.                        CQ21  46
INTEGER ROOM#                          Number of words needed to        CQ21  47
#                                         Store an observation and,     CQ21  48
#                                         Possibly, its bijvoet.        CQ21  49
INTEGER RPTR#                          Pointer to discrepancy -         CQ21  50
#                                           (1-(avgfsq/(scale*fsq)))**2 CQ21  51
INTEGER TBLPTR#                        Pointer to entry in current      CQ21  52
#                                         Discrepancy table.            CQ21  53
INTEGER WDPTR#                         Pointer to discrepancy -         CQ21  54
#                                           Abs(scale*fsq-avgfsq)/sigma CQ21  55
INTEGER WIDTH#                         Number of characters that wi     CQ21  56
#                                         Fit on a line.                CQ21  57
INTEGER YWDPTR#                        Pointer to discrepancy -         CQ21  58
#                                           (scale*fsq-avgfsq)/sigfsq   CQ21  59
#                                                                       CQ21  60
REAL ADISC1#                           Abs(i-y)                         CQ21  61
REAL D#                                Abs(i-y)/y                       CQ21  62
REAL DISC1#                            I-y                              CQ21  63
REAL DISC2#                            (1-y/i)**2                       CQ21  64
REAL FMT021(4)#                                                         CQ21  65
REAL H(4)#                             H,k,l, and sitol for listing     CQ21  66
REAL KEY(2)#                           Packed hkl and ordinal/shift     CQ21  67
#                                         Number.                       CQ21  68
REAL OUT(21)#                          One line of a rank-ordered       CQ21  69
#                                         Table.                        CQ21  70
REAL R#                                Sum(sigma(f**2))/sum(f**2)       CQ21  71
REAL RDEN#                             Sum(y)                           CQ21  72
REAL RNUM#                             Sum(abs(i-y))                    CQ21  73
REAL SUMFSQ#                           Sum(f**2)                        CQ21  74
REAL SUMSIG#                           Sum(sigma(f**2))                 CQ21  75
REAL WD#                               Sum(wt*(abs(i-y)**2))/           CQ21  76
#                                         Sum(wt*y*y)                   CQ21  77
REAL WRDEN#                            Sum(wt*y*y)                      CQ21  78
REAL WRNUM#                            Sum(wt*(abs(i-y)**2))            CQ21  79
#                                                                       CQ21  80
string:(LINBUF,mxchln:)#               A line of singly observed        CQ21  81
#                                         Reflection indices.           CQ21  82
#                                                                       CQ21  83
chardata:(CQ021, HKL AND S=SINE(THETA)/LAMBDA FOR REFLECTIONS $#        CQ21  84
WITH ONLY ONE OBSERVATION AND S BETWEEN         AND        )#           CQ21  85
chardata:(CQ022,NUMBER OF SINGLY-OBSERVED REFLECTIONS =     )#          CQ21  86
chardata:(CQ023, REFLECTIONS     OBSERVATIONS)#                         CQ21  87
chardata:(CQ024,ON BDF PROCESSED)#                                      CQ21  88
chardata:(CQ025,SUMS RATIOS)#                                           CQ21  89
chardata:(CQ026,ABS(I-Y) ((I-Y)/SIG(I))**2 $#                           CQ21  90
(Y/SIG(I))**2 SIG(Y))#                                                  CQ21  91
chardata:(CQ027,                                               $#       CQ21  92
LISTED IN DECREASING ORDER OF ABS(D)              )#                    CQ21  93
chardata:(CQ028,H  K  L ORD SHIFT      D     RANK)#                     CQ21  94
chardata:(CQ029,           D=I-Y    D=(1-Y/I)**2$#                      CQ21  95
D=(I-Y)/SIGMA(Y)D=(I-Y)/SIGMA(I))#                                      CQ21  96
chardata:(CQ02A,(CONTINUED))#                                           CQ21  97
intdata:(OBSPTR,[0])#                  Pointer to current observ.       CQ21  98
realdata:(FMT022,[60313.,90313.,120313.,200852.])#                      CQ21  99
realdata:(FMT023,[930752.,1050752.])#                                   CQ21 100
realdata:(FMT024,[40313.,70313.,100313.,150513.,#                       CQ21 101
200513.,300922.,350513.,460313.,490313.,520313.,#                       CQ21 102
570513.,620513.,720922.,770513.,880313.,910313.,#                       CQ21 103
940313.,990513.,1040513.,1140922.,1190513.])#                           CQ21 104
realdata:(FMT025,[450513.,90713.,260713.,331581.,##                     CQ21 105
631581.,751232.])#                                                      CQ21 106
datastuff:#                                                             CQ21 107
#                                                                       CQ21 108
IF(IMERGE == 0)  ROOM = 8#             Compute space factor             CQ21 109
ELSE             ROOM = 4#                                              CQ21 110
#                                                                       CQ21 111
# POINTERS TO DISCREPANCIES IN RANKING TABLES                           CQ21 112
DPTR = FPTR + ROOM*ALLOWD#             Scale*fsq - avgfsq               CQ21 113
RPTR = DPTR + MOST4#                   (1-(avgfsq/(scale*fsq)))**2      CQ21 114
YWDPTR = RPTR + MOST4#                 (scale*fsq-avgfsq)/sigfsq        CQ21 115
WDPTR = YWDPTR + MOST4#                Abs(scale*fsq-avgfsq)/sigma      CQ21 116
#                                                                       CQ21 117
incrqx:(J,WDPTR+MOST4,CQ2101)#         Request memory                   CQ21 118
#                                                                       CQ21 119
IF(SMAX > 0.)#                                                          CQ21 120
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CQ21 121
BUFOT(1) = SMIN#                                                        CQ21 122
BUFOT(2) = SMAX#                                                        CQ21 123
ncodefld:(BUFOT,1,CQ021,FMT023(1),2)#                                   CQ21 124
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CQ21 125
#                                                                       CQ21 126
CALL CQ05(0)#                          Initialize reflection readin     CQ21 127
#                                                                       CQ21 128
RNUM   = 0.#                           Initializations........          CQ21 129
RDEN   = 0.#                                                            CQ21 130
WRNUM  = 0.#                                                            CQ21 131
WRDEN  = 0.#                                                            CQ21 132
SUMFSQ = 0.#                                                            CQ21 133
SUMSIG = 0.#                                                            CQ21 134
MOBS   = 0#                                                             CQ21 135
MREFS  = 0#                                                             CQ21 136
NSINGL = 0#                                                             CQ21 137
NCOL   = 0#                                                             CQ21 138
#                                                                       CQ21 139
BUFOT(1) = 0.#                                                          CQ21 140
movereal:(BUFOT,1,QX,DPTR+1,4*MOST4,2)#                                 CQ21 141
#                                                                       CQ21 142
movechar:(BLANK,1,LINBUF,1,mxchln:,1)## Blank out the output line       CQ21 143
#                                         Buffer.                       CQ21 144
movereal:(FMT022,1,FMT021,1,4,0)#                                       CQ21 145
MAXL = prtcmax:/20#                    Maximum number of quantities     CQ21 146
WIDTH = 20*MAXL#                       Number of characters per lin     CQ21 147
#                                                                       CQ21 148
# REFLECTION READING LOOP                                               CQ21 149
FOR(CALL CQ05(1); SITOL > 0.; CALL CQ05(1))#                            CQ21 150
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CQ21 151
CALL CQ01(NREP)#                       Get avgfsq and sigfsq            CQ21 152
#                                                                       CQ21 153
# IF MULTIPLY OBSERVED, MAKE SURE THERE AREN'T TOO MANY OR TOO FEW      CQ21 154
#  OBSERVATIONS.                                                        CQ21 155
#                                                                       CQ21 156
IF(NREP > 1)#                                                           CQ21 157
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CQ21 158
IF(NREP > UPLIM \ NREP < LOLIM)  NEXT#                                  CQ21 159
IF(ISW == 0)  NEXT#                    Skip if avgfsq < fsqmin          CQ21 160
MREFS = MREFS + 1#                     Count the reflection and         CQ21 161
MOBS = MOBS + NREP#                    The observations used.           CQ21 162
SUMFSQ = SUMFSQ + AVGFSQ#                                               CQ21 163
SUMSIG = SUMSIG + SIGFSQ#                                               CQ21 164
FPT = FPTR - 4#                        Initialize f**2 pointer          CQ21 165
#                                                                       CQ21 166
# LOOP OVER ALL THE OBSERVATIONS FOR THIS REFLECTION                    CQ21 167
#                                                                       CQ21 168
FOR(I=1; I <= OBS; I=I+1)#                                              CQ21 169
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CQ21 170
FPT = FPT + 4#                         Point to next f**2               CQ21 171
ifeq:(QX(FPT+4),0.)  NEXT#             Ignore those rejected by cq1     CQ21 172
#                                         And outside requested shift   CQ21 173
FSQ = QX(FPT+1)#                       Pick up scaled f**2,             CQ21 174
SIGMA = QX(FPT+2)#                     Scaled sigma(f**2),              CQ21 175
ISHIFT = NINT(QX(FPT+3))#              Shift number, and                CQ21 176
WT = QX(FPT+4)#                        Weight.                          CQ21 177
IF(ISHIFT < LOSHFT \ ISHIFT > HISHFT)  NEXT#                            CQ21 178
DISC1 = FSQ - AVGFSQ#                  1st discrepancy                  CQ21 179
ADISC1 = ABS(DISC1)#                   Abs(i-y)                         CQ21 180
RNUM = RNUM + ADISC1#                  Accumulate sums for              CQ21 181
WD = ADISC1*ADISC1*WT#                 Statistics.                      CQ21 182
WRNUM = WRNUM + WD#                                                     CQ21 183
ifeq:(AVGFSQ,0.)  NEXT#                Go no further if avgfsq too      CQ21 184
#                                         Small.                        CQ21 185
RDEN = RDEN + AVGFSQ#                                                   CQ21 186
WRDEN = WRDEN + AVGFSQ*AVGFSQ*WT#                                       CQ21 187
DISC2 = 0.#                                                             CQ21 188
IF(FSQ > 0.1)  DISC2 = (1.-AVGFSQ/FSQ)**2#                              CQ21 189
IF(I > OBSSG)#                                                          CQ21 190
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CQ21 191
movepakwd:(HKLBY,KEY(1))#              This is a bijvoet observatio     CQ21 192
IORD = I - OBSSG#                      Get the right ordinal number     CQ21 193
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CQ21 194
ELSE#                                                                   CQ21 195
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CQ21 196
movepakwd:(HKL,KEY(1))#                A space group observation        CQ21 197
IORD = I#                              Ordinal number                   CQ21 198
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CQ21 199
intpak:(ISHIFT,KEY(2),0,16)#           Pack up ordinal and shift        CQ21 200
#                                         Number.                       CQ21 201
intpak:(IORD,KEY(2),16,arith:(mxbtwd:,-,16))#                           CQ21 202
#                                                                       CQ21 203
# EACH OF THE TABLES IS FILLED UP WITH THE CURRENT SMALLEST             CQ21 204
#  DISCREPANCY IN THE 1ST WORD OF THE TABLE.  WORD 2 IS THE             CQ21 205
#  PACKED HKL AND WORD 3 CONSISTS OF THE ORDINAL NUMBER IN              CQ21 206
#  BITS 0-19 AND THE SHIFT NUMBER IN BITS 20-31.  WORD 4 IS             CQ21 207
#  ZERO FOR NOW.  SUBROUTINE CQ12 KEEPS EXPANDING THE TABLE.            CQ21 208
#  WHEN IT IS FULL AND NEEDS TO INSERT ANOTHER OBSERVATION,             CQ21 209
#  IT DOES SO BY DISCARDING THE FIRST 4 WORDS, OPENING UP               CQ21 210
#  A 4-WORD SLOT AT THE APPROPRIATE PLACE (SHIFTING 4-WORD              CQ21 211
#  GROUPS DOWN TOWARD THE FRONT), AND INSERTING THE NEW                 CQ21 212
#  WORDS.                                                               CQ21 213
#                                                                       CQ21 214
# 1ST DISCREPANCY                                                       CQ21 215
IF(ADISC1 > ABS(QX(DPTR+1)))    CALL CQ22(QX(DPTR+1),MOST,DISC1,KEY)#   CQ21 216
# 2ND DISCREPANCY                                                       CQ21 217
IF(DISC2 > ABS(QX(RPTR+1)))     CALL CQ22(QX(RPTR+1),MOST,DISC2,KEY)#   CQ21 218
# 3RD DISCREPANCY                                                       CQ21 219
R = DISC1/SIGFSQ#                                                       CQ21 220
IF(ABS(R) > ABS(QX(YWDPTR+1)))  CALL CQ22(QX(YWDPTR+1),MOST,R,KEY)#     CQ21 221
# 4TH DISCREPANCY                                                       CQ21 222
R = DISC1/SIGMA#                                                        CQ21 223
IF(ABS(R) > ABS(QX(WDPTR+1)))   CALL CQ22(QX(WDPTR+1),MOST,R,KEY)#      CQ21 224
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CQ21 225
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CQ21 226
#                                                                       CQ21 227
# SINGLY OBSERVED REFLECTIONS COME HERE                                 CQ21 228
#                                                                       CQ21 229
ELSE#                                                                   CQ21 230
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CQ21 231
# IF OUTSIDE OF SITOL RANGE, GET NEXT REFLECTION                        CQ21 232
IF(NREP == 0 \ SITOL < SMIN \ SITOL > SMAX)  NEXT#                      CQ21 233
NSINGL = NSINGL + 1#                   Count singles                    CQ21 234
#                                        Break out hkl and sitol for    CQ21 235
DO I=1,3#                              Listing                          CQ21 236
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CQ21 237
intunpak:(HKL,IH(I),30-I*9,9)#                                          CQ21 238
intunpak:(HKL,J,3-I,1)#                                                 CQ21 239
IF (J != 0) IH(I) = -IH(I)#                                             CQ21 240
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CQ21 241
DO J=1,3#                                                               CQ21 242
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CQ21 243
H(J) = FLOAT(IH(J))#                                                    CQ21 244
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CQ21 245
H(4) = SITOL#                                                           CQ21 246
ncodefld:(H,1,LINBUF,FMT021(1),4)#     Start encoding each              CQ21 247
#                                         Reflection into line buffer.  CQ21 248
NCOL = NCOL + 20#                      Move over column counter         CQ21 249
IF(NCOL >= WIDTH)#                                                      CQ21 250
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CQ21 251
#                                                                       CQ21 252
# IF LINE IS FULL, FOR FIRST LINE, PUT OUT HEADING                      CQ21 253
IF(NSINGL <= MAXL)  writeline:(1,CQ021,NCQ021,3,3)#                     CQ21 254
movechar:(LINBUF,1,CHROT,1,mxchln:,0)##                                 CQ21 255
writeline:(0,CQ021,NCQ021,1,3)#        Write the line                   CQ21 256
NCOL = 0#                              Reset the column pointer         CQ21 257
FOR(J=1; J <= 4; J=J+1)#               And formats for h, k, l, and     CQ21 258
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CQ21 259
FMT021(J) = FMT022(J)#                 Sitol.                           CQ21 260
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CQ21 261
# BLANK OUT LINE BUFFER                                                 CQ21 262
movechar:(BLANK,1,LINBUF,1,mxchln:,1)##                                 CQ21 263
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CQ21 264
#                                                                       CQ21 265
ELSE#                                  Line not full yet                CQ21 266
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CQ21 267
FOR(J=1; J <= 4; J=J+1)#               Move formats over by 20          CQ21 268
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CQ21 269
FMT021(J) = FMT021(J) + 200000.#       Columns.                         CQ21 270
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CQ21 271
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CQ21 272
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CQ21 273
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CQ21 274
#                                                                       CQ21 275
rewindbdf:(1)#                         Rewind input                     CQ21 276
IF(NCOL > 0)#                          Finish off singly observed       CQ21 277
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CQ21 278
movechar:(LINBUF,1,CHROT,1,mxchln:,0)## Listing.                        CQ21 279
writeline:(0,CQ021,NCQ021,1,3)#                                         CQ21 280
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CQ21 281
#                                                                       CQ21 282
IF(NSINGL != 0)#                       Tell number of singly            CQ21 283
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CQ21 284
movechar:(CQ022,1,CHROT,2,NCQ022,0)#   Observeds.                       CQ21 285
BUFOT(1) = FLOAT(NSINGL)#                                               CQ21 286
ncodefld:(BUFOT,1,CHROT,FMT025(1),1)##                                  CQ21 287
writeline:(1,0,0,1,3)#                                                  CQ21 288
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CQ21 289
#                                                                       CQ21 290
D = RNUM/RDEN#                         Get statistics                   CQ21 291
WD = SQRT(WRNUM/WRDEN)#                                                 CQ21 292
R = SUMSIG/SUMFSQ#                                                      CQ21 293
#                                                                       CQ21 294
# PUT OUT PERTINENT RESULTS                                             CQ21 295
writeline:(1,CQ023,NCQ023,3,3)#                                         CQ21 296
#                                                                       CQ21 297
movechar:(CQ024,1,CHROT,13,7,0)#                                        CQ21 298
BUFOT(1) = FLOAT(TOTREF)#                                               CQ21 299
BUFOT(2) = FLOAT(TOTOBS)#                                               CQ21 300
ncodefld:(BUFOT,1,CHROT,FMT025(2),2)##                                  CQ21 301
writeline:(1,0,0,1,3)#                                                  CQ21 302
#                                                                       CQ21 303
movechar:(CQ024,8,CHROT,11,9,0)#                                        CQ21 304
BUFOT(1) = FLOAT(MREFS)#                                                CQ21 305
BUFOT(2) = FLOAT(MOBS)#                                                 CQ21 306
ncodefld:(BUFOT,1,CHROT,FMT025(2),2)##                                  CQ21 307
writeline:(0,0,0,1,3)#                                                  CQ21 308
#                                                                       CQ21 309
movechar:(CQ025,1,CHROT,2,4,0)#                                         CQ21 310
movechar:(CQ025,6,CHROT,71,6,0)#                                        CQ21 311
writeline:(1,0,0,1,3)#                                                  CQ21 312
#                                                                       CQ21 313
movechar:(CQ026,1,CHROT,11,8,0)#                                        CQ21 314
movechar:(CQ026,7,CHROT,48,1,0)#                                        CQ21 315
BUFOT(1) = RNUM#                                                        CQ21 316
BUFOT(2) = RDEN#                                                        CQ21 317
ncodefld:(BUFOT,1,CHROT,FMT025(4),2)##                                  CQ21 318
BUFOT(1) = D#                                                           CQ21 319
ncodefld:(BUFOT,1,CHROT,FMT025(6),1)##                                  CQ21 320
writeline:(1,0,0,1,3)#                                                  CQ21 321
#                                                                       CQ21 322
movechar:(CQ026,10,CHROT,2,17,0)#                                       CQ21 323
movechar:(CQ026,28,CHROT,36,13,0)#                                      CQ21 324
movechar:(CQ026,24,CHROT,76,3,0)#                                       CQ21 325
BUFOT(1) = WRNUM#                                                       CQ21 326
BUFOT(2) = WRDEN#                                                       CQ21 327
ncodefld:(BUFOT,1,CHROT,FMT025(4),2)##                                  CQ21 328
BUFOT(1) = WD#                                                          CQ21 329
ncodefld:(BUFOT,1,CHROT,FMT025(6),1)##                                  CQ21 330
writeline:(0,0,0,1,3)#                                                  CQ21 331
#                                                                       CQ21 332
movechar:(CQ026,42,CHROT,13,6,0)#                                       CQ21 333
movechar:(CQ026,7,CHROT,48,1,0)#                                        CQ21 334
BUFOT(1) = SUMSIG#                                                      CQ21 335
BUFOT(2) = SUMFSQ#                                                      CQ21 336
ncodefld:(BUFOT,1,CHROT,FMT025(4),2)##                                  CQ21 337
BUFOT(1) = R#                                                           CQ21 338
ncodefld:(BUFOT,1,CHROT,FMT025(6),1)##                                  CQ21 339
writeline:(0,0,0,1,3)#                                                  CQ21 340
#                                                                       CQ21 341
# NOW IT'S TIME TO PUT OUT THE TABLES LISTING EACH OF THE DISCREPANCIES CQ21 342
#  IN DECREASING ORDER.  THERE WILL BE 3 COLUMNS (CONSISTING OF H, K,   CQ21 343
#  L, SHIFT, ORDINAL, DISCREPANCY, AND RANK) PER LINE.                  CQ21 344
#                                                                       CQ21 345
movechar:(BLANK,1,LINBUF,1,mxchln:,1)## Create column heading           CQ21 346
FOR(I=4; I <= 120; I=I+42)#                                             CQ21 347
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CQ21 348
movechar:(CQ028,1,LINBUF,I,NCQ028,0)#                                   CQ21 349
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CQ21 350
#                                                                       CQ21 351
NAMPTR = 1#                            Pointer to current               CQ21 352
#                                         Discrepancy in cq29.          CQ21 353
ENDPTR = MOST4 + DPTR#                 Pointer to end of current        CQ21 354
#                                         Discrepancy table.            CQ21 355
FOR(I=1; I <= 4; I=I+1)#               Loop over each table             CQ21 356
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CQ21 357
NLTOTL = (MOST + 2)/3#                 Number of lines needed for       CQ21 358
TBLPTR = ENDPTR#                       Listing.                         CQ21 359
movechar:(BLANK,1,CQ027,87,NCQ02A,1)#  Blank end of heading format      CQ21 360
movechar:(CQ029,NAMPTR,CQ027,31,16,0)# Insert name of discrepancy       CQ21 361
#                                                                       CQ21 362
REPEAT#                                Do a page                        CQ21 363
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CQ21 364
LINCT = 0#                             New page forced                  CQ21 365
writeline:(0,CQ027,NCQ027,3,3)#        Write out overall heading        CQ21 366
writeline:(1,LINBUF,mxchln:,3,3)#      Write out column headings        CQ21 367
NLPAGE = MIN0(NLTOTL,LINCT)#           Find number of lines             CQ21 368
#                                         Remaining on page.            CQ21 369
FOR(NL=1; NL <= NLPAGE; NL=NL+1)#      Loop over lines                  CQ21 370
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CQ21 371
TBLPTR = TBLPTR - 4#                   Move down table                  CQ21 372
OBSPTR = TBLPTR#                                                        CQ21 373
M = 0#                                 Minor column pointer             CQ21 374
# LOOP OVER NUMBER OF MAJOR COLUMNS PER LINE                            CQ21 375
FOR(MAJCOL=1; MAJCOL <= 3; MAJCOL=MAJCOL+1)#                            CQ21 376
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CQ21 377
LINE(M+7) = (ENDPTR-OBSPTR)/4#         Calculate rank                   CQ21 378
IF(LINE(M+7) > MOST)  BREAK#           Make sure there's an             CQ21 379
#                                         Observation there.            CQ21 380
OUT(M+7) = FLOAT(LINE(M+7))#           Float the rank                   CQ21 381
OUT(M+6) = QX(OBSPTR+1)#               Get the discrepancy,             CQ21 382
#                                         The ordinal,                  CQ21 383
intunpak:(QX(OBSPTR+3),LINE(M+5),0,16)##                                CQ21 384
#                                         The shift number, and         CQ21 385
intunpak:(QX(OBSPTR+3),LINE(M+4),16,arith:(mxbtwd:,-,16))#              CQ21 386
#                                         H, k, and l.                  CQ21 387
movepakwd:(QX(OBSPTR+2),HKL)#                                           CQ21 388
#                                        Break out hkl and sitol for    CQ21 389
DO I=1,3#                              Listing                          CQ21 390
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CQ21 391
intunpak:(HKL,LINE(M+I),(3-I)*9+3,9)#                                   CQ21 392
intunpak:(HKL,J,3-I,1)#                                                 CQ21 393
IF (J != 0) LINE(M+I) = -LINE(M+I)#                                     CQ21 394
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CQ21 395
#                                                                       CQ21 396
FOR(J=M+1; J <= M+5; J=J+1)#                                            CQ21 397
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CQ21 398
OUT(J) = FLOAT(LINE(J))#                                                CQ21 399
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CQ21 400
#                                                                       CQ21 401
M = M + 7#                             Go to start of next minor co     CQ21 402
OBSPTR = OBSPTR - 4*NLPAGE#            Point to next observation        CQ21 403
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CQ21 404
ncodefld:(OUT,1,CHROT,FMT024(1),M)#                                     CQ21 405
writeline:(0,0,0,1,3)#                 Write out line                   CQ21 406
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CQ21 407
#                                                                       CQ21 408
TBLPTR = OBSPTR + 4*NLPAGE#            Point to 1st observation on      CQ21 409
#                                         Next page, if any.            CQ21 410
NLTOTL = NLTOTL - NLPAGE#              Number of lines left to do       CQ21 411
movechar:(CQ02A,1,CQ027,87,NCQ02A,0)#  Add (continued) to heading       CQ21 412
IF(NLTOTL <= 0) BREAK#                                                  CQ21 413
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CQ21 414
#                                                                       CQ21 415
#                                         For each table.               CQ21 416
#                                                                       CQ21 417
ENDPTR = ENDPTR + MOST4#               Point to next table              CQ21 418
NAMPTR = NAMPTR + 16#                  Point to next discrepancy        CQ21 419
#                                         Name in cq29.                 CQ21 420
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CQ21 421
#                                                                       CQ21 422
RETURN#                                                                 CQ21 423
END#                                                                    CQ21 424
systemheader:(CQ22)#                                                    CQ22   1
# ################################################################## #  CQ22   2
#                                                                    #  CQ22   3
#                               CQ22                                 #  CQ22   4
#                                                                    #  CQ22   5
# ################################################################## #  CQ22   6
SUBROUTINE CQ22(TABLE,SIZE,DELTA,PACK)## Put a new observation int      CQ22   7
#                                         Ranking table.  table is      CQ22   8
#                                         Arranged in increasing order  CQ22   9
#                                         Of deltas.                    CQ22  10
#                                        Oct 1979  r.a. alden           CQ22  11
include:(AACOMN)#                                                       CQ22  12
#                                                                       CQ22  13
INTEGER I#                             Loop index                       CQ22  14
INTEGER J#                             Another loop index               CQ22  15
INTEGER SIZE#                          Number of entries in table       CQ22  16
#                                                                       CQ22  17
REAL ABSDEL#                           Abs(delta)                       CQ22  18
REAL DELTA#                            Discrepancy                      CQ22  19
REAL PACK(2)#                          Packed hkl and ordinal/shift     CQ22  20
REAL TABLE(1)#                         Table of discrepancies           CQ22  21
#                                                                       CQ22  22
ABSDEL = ABS(DELTA)#                                                    CQ22  23
FOR(I=4*SIZE-3; I > 0; I=I-4)#         Find out where in the table      CQ22  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CQ22  25
IF(ABSDEL > ABS(TABLE(I)))#            This entry belongs.              CQ22  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CQ22  27
FOR(J=1; J <= I-1; J=J+1)#                                              CQ22  28
TABLE(J) = TABLE(J+4)#                                                  CQ22  29
BREAK#                                                                  CQ22  30
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CQ22  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CQ22  32
#                                                                       CQ22  33
TABLE(I) = DELTA#                      Insert the entry                 CQ22  34
movepakwd:(PACK(1),TABLE(I+1))#                                         CQ22  35
movepakwd:(PACK(2),TABLE(I+2))#                                         CQ22  36
#                                                                       CQ22  37
RETURN#                                                                 CQ22  38
END#                                                                    CQ22  39
systemheader:(CQ31)#                                                    CQ31   1
# ################################################################## #  CQ31   2
#                                                                    #  CQ31   3
#                               CQ31                                 #  CQ31   4
#                                                                    #  CQ31   5
# ################################################################## #  CQ31   6
#                                         Ranked observations in        CQ31   7
SUBROUTINE CQ31#                       Sorting order.                   CQ31   8
#                                        Oct 1979  r.a. alden           CQ31   9
#                                        June 1985 k.d.watenpaugh       CQ31  10
include:(AACOMN)#                                                       CQ31  11
include:(CQCOMN)#                                                       CQ31  12
#                                                                       CQ31  13
INTEGER BITPOS#                        Least significant bit marker     CQ31  14
INTEGER BYFRST#                        Flag to indicate whether         CQ31  15
#                                         Bijvoet hkl already listed.   CQ31  16
INTEGER FPT#                           Pointer to current f**2          CQ31  17
INTEGER I#                             Loop index                       CQ31  18
INTEGER IH(3)#                         Miller indices to be listed      CQ31  19
INTEGER II#                            Loop index                       CQ31  20
INTEGER IORD#                          Ordinal number                   CQ31  21
INTEGER IPT#                           Input packet pointer             CQ31  22
INTEGER IX#                            Pointer to current rank-         CQ31  23
#                                         Ordered entry in table.       CQ31  24
INTEGER J#                             Pointer to start of qx worki     CQ31  25
#                                         Area and loop index           CQ31  26
INTEGER J1#                            Pointer to end of 1st            CQ31  27
#                                         Rank-ordered table.           CQ31  28
INTEGER J2#                            Pointer to beginning of next     CQ31  29
#                                         Rank-ordered table.           CQ31  30
INTEGER M#                             Pointer to current position      CQ31  31
#                                         Rank-ordered tables.          CQ31  32
INTEGER NGOOD#                         Counter of unranked obs./ref     CQ31  33
INTEGER NOP#                           Total number of unique obs.      CQ31  34
#                                         Be listed.                    CQ31  35
INTEGER NREP#                          Number of replicates for a       CQ31  36
#                                         Reflection.                   CQ31  37
INTEGER NRP#                           Number of reflections listed     CQ31  38
INTEGER PSIZE#                         Logical record lrrefl: packe     CQ31  39
#                                         Size.                         CQ31  40
INTEGER RANKPT#                        Rank number                      CQ31  41
INTEGER SAME#                          Check of equivalent indices      CQ31  42
#                                                                       CQ31  43
REAL HEAD(8)#                          Buffer to hold initial listi     CQ31  44
#                                         Line.                         CQ31  45
REAL HKLIN#                            Current packed hkl               CQ31  46
REAL HPREV#                            Packed hkl processed             CQ31  47
#                                         Immediately prior to current  CQ31  48
#                                         One.                          CQ31  49
REAL OUT(24)#                          Buffer to hold listing line      CQ31  50
REAL R#                                Sigma(i)/i                       CQ31  51
#                                                                       CQ31  52
chardata:(CQ031,   H  K  L  SIN(T)/L     Y     $#                       CQ31  53
SIG(Y) SIG(Y)/Y NREP)#                                                  CQ31  54
chardata:(CQ032,          ORD SHIFT      I     SIG(I) SIG(I)/$#         CQ31  55
I     (I-Y)    RANK (1-Y/I)**2   RANK (I-Y)/SIG(Y)  RANK $#             CQ31  56
(I-Y)/SIG(I)  RANK)#                                                    CQ31  57
chardata:(CQ033,REFLECTIONS WERE LISTED$, WITH       OBSERVATIONS $#    CQ31  58
RANKED)#                                                                CQ31  59
chardata:(CQ034,(CONTINUED))#                                           CQ31  60
EQUIVALENCE(OUT(17),HEAD(1))#                                           CQ31  61
realdata:(FMT031,[40313.,70313.,100313.,190852.,#                       CQ31  62
290922.,370722.,450732.,500413.])#                                      CQ31  63
realdata:(FMT032,[130513.,190513.,#                                     CQ31  64
290922.,370722.,450732.,581222.,#                                       CQ31  65
751442.,951222.,1141422.,640503.,#                                      CQ31  66
820503.,1010503.,1200503.])#                                            CQ31  67
realdata:(FMT033,[60513.,420613.])#                                     CQ31  68
datastuff:#                                                             CQ31  69
#                                                                       CQ31  70
RANKPT = MOST + 1#                     Rank pointer                     CQ31  71
J1 = MOST4 + DPTR#                     End of 1st table                 CQ31  72
#                                                                       CQ31  73
# WHAT WILL HAPPEN NOW IS THE CONSTRUCTION OF ONE LARGE TABLE EACH      CQ31  74
#  ELEMENT OF WHICH CONSISTS OF 4 WORDS.                                CQ31  75
# WORD 1  -  PACKED HKL                                                 CQ31  76
#      2  -  PACKED ORDINAL/SHIFT NUMBER                                CQ31  77
#      3  -  TWO PACKED RANKS; BITS 12-31 CONTAIN RANK FOR 4TH          CQ31  78
#               DISCREPANCY; BITS 0-11 CONTAIN RANK FOR 3RD DISCREPANCY CQ31  79
#               ZERO IF NO RANK.                                        CQ31  80
#      4  -  TWO MORE PACKED RANKS; BITS 12-31 CONTAIN RANK FOR 2ND     CQ31  81
#               DISCREPANCY; BITS 0-11 CONTAIN RANK FOR 1ST DISCREPANCY CQ31  82
#                                                                       CQ31  83
FOR(I=DPTR+4; I <= J1; I=I+4)#         Rearrange the table              CQ31  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CQ31  85
movepakwd:(QX(I-2),QX(I-3))#           The 4 words will now look        CQ31  86
movepakwd:(QX(I-1),QX(I-2))#           Like:                            CQ31  87
RANKPT = RANKPT - 1#                   1 - packed hkl                   CQ31  88
intpak:(0,QX(I-1),0,mxbtwd:)#          2 - packed ordinal/shift no.     CQ31  89
intpak:(RANKPT,QX(I),0,mxbtwd:)#       3 - 0                            CQ31  90
#                                         4 - rank                      CQ31  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CQ31  92
#                                                                       CQ31  93
M = MOST4 + DPTR#                      End of 1st table                 CQ31  94
BITPOS = 12#                           Set bit packing position         CQ31  95
#                                                                       CQ31  96
J1 = M + 1#                                                             CQ31  97
FOR(I=1; I <= 3; I=I+1)#               Loop over each of the            CQ31  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CQ31  99
J2 = J1#                               Remaining 3 tables.              CQ31 100
RANKPT = MOST + 1#                                                      CQ31 101
FOR(II=1; II <= MOST; II = II+1)#      Loop over number of              CQ31 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CQ31 103
RANKPT = RANKPT - 1#                   Discrepancies.                   CQ31 104
#                                                                       CQ31 105
# SEE IF BOTH HKL AND THE ORDINAL/SHIFT NUMBER ARE IDENTICAL TO         CQ31 106
#  THOSE OF A PREVIOUSLY SAVED OBSERVATION.                             CQ31 107
#                                                                       CQ31 108
FOR(J=DPTR+1; J <= M; J=J+4)#                                           CQ31 109
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CQ31 110
compakwd:(QX(J2+1),NE,QX(J),NEXT)#                                      CQ31 111
compakwd:(QX(J2+2),EQ,QX(J+1),BREAK)#                                   CQ31 112
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CQ31 113
IF(J <= M)#                            Got a match                      CQ31 114
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CQ31 115
#                                                                       CQ31 116
# INSERT RANK IN THIRD WORD                                             CQ31 117
IF(I == 1)  intpak:(RANKPT,QX(J+3),BITPOS,12)#                          CQ31 118
#                                                                       CQ31 119
ELSE        intpak:(RANKPT,QX(J+2),BITPOS,12)#                          CQ31 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CQ31 121
ELSE#                                  This is a new observation        CQ31 122
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CQ31 123
M = M + 4#                             Expand table and                 CQ31 124
movepakwd:(QX(J2+1),QX(M-3))#          Fill it up.                      CQ31 125
movepakwd:(QX(J2+2),QX(M-2))#                                           CQ31 126
intpak:(0,QX(M-1),0,mxbtwd:)#                                           CQ31 127
intpak:(0,QX(M),0,mxbtwd:)#                                             CQ31 128
IF(I == 1)  intpak:(RANKPT,QX(M),BITPOS,12)#                            CQ31 129
ELSE        intpak:(RANKPT,QX(M-1),BITPOS,12)#                          CQ31 130
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CQ31 131
J2 = J2 + 4#                                                            CQ31 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CQ31 133
J1 = J1 + MOST4#                                                        CQ31 134
IF(I == 1)  BITPOS = 0#                Set bit postions for 3rd and     CQ31 135
ELSE        BITPOS = 12#               4th times through.               CQ31 136
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CQ31 137
#                                                                       CQ31 138
# CALCULATE TOTAL NUMBER OF UNIQUE OBSERVATIONS IN TABLE                CQ31 139
NOP = (M-DPTR)/4#                                                       CQ31 140
#                                                                       CQ31 141
CALL fsort42:(QX(DPTR+1),NOP)#         Sort obs. in hkl order           CQ31 142
#                                                                       CQ31 143
LINCT = 0#                             New page                         CQ31 144
IX = DPTR#                             Point to start of table          CQ31 145
NRP = 0#                                                                CQ31 146
intpak:(NRP,HPREV,0,mxbtwd:)#          Clear previous hkl               CQ31 147
#                                                                       CQ31 148
CALL CQ05(0)#                          Initialize logical record        CQ31 149
#                                         Lrrefl: read.                 CQ31 150
#                                                                       CQ31 151
CALL CQ32(IX)#                         Unpack 1st ranked observatio     CQ31 152
#                                                                       CQ31 153
# READ REFLECTIONS AGAIN                                                CQ31 154
FOR(CALL CQ05(1); SITOL > 0.; CALL CQ05(1))#                            CQ31 155
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CQ31 156
SAME = 0#                                                               CQ31 157
compakwd:(HKL,EQ,HPREV,SAME=1)#        If this reflection is not        CQ31 158
compakwd:(HKL,EQ,HRANK,SAME=SAME+1)#   Ranked, go to the next one.      CQ31 159
IF (SAME == 0) NEXT#                                                    CQ31 160
CALL CQ01(NREP)#                       Get fsq and sigfsq               CQ31 161
IF(AVGFSQ > 0.)  R = SIGFSQ/AVGFSQ#                                     CQ31 162
ELSE  R = 0.#                                                           CQ31 163
IF(OBSSG == 0)#                                                         CQ31 164
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CQ31 165
DO II=1,3#                                                              CQ31 166
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CQ31 167
intunpak:(HKLBY,IH(II),30-II*9,9)#     Unpack hkl according to          CQ31 168
intunpak:(HKLBY,J,3-II,1)#             Whether it's positive or         CQ31 169
IF (J!=0) IH(II) = -IH(II)#            Negative bijvoet                 CQ31 170
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CQ31 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CQ31 172
ELSE#                                                                   CQ31 173
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CQ31 174
DO II=1,3#                                                              CQ31 175
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CQ31 176
intunpak:(HKL,IH(II),30-II*9,9)#       Unpack hkl according to          CQ31 177
intunpak:(HKL,J,3-II,1)#               Whether it's positive or         CQ31 178
IF (J!=0) IH(II) = -IH(II)#            Negative bijvoet                 CQ31 179
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CQ31 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CQ31 181
#                                         Or bijvoet observation.       CQ31 182
#                                                                       CQ31 183
IF(LINCT < 4)#                         Write 2 page headings            CQ31 184
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CQ31 185
LINCT = 0#                                                              CQ31 186
writeline:(0,CQ031,NCQ031,3,3)#                                         CQ31 187
writeline:(0,CQ032,NCQ032,3,3)#                                         CQ31 188
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CQ31 189
DO I = 1,3#                            Float h, k, and l                CQ31 190
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CQ31 191
HEAD(I) = FLOAT(IH(I))#                                                 CQ31 192
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CQ31 193
HEAD(4) = SITOL#                       Stuff hkl line                   CQ31 194
HEAD(5) = AVGFSQ#                                                       CQ31 195
HEAD(6) = SIGFSQ#                                                       CQ31 196
HEAD(7) = R#                                                            CQ31 197
HEAD(8) = FLOAT(OBS)#                                                   CQ31 198
ncodefld:(HEAD,1,CHROT,FMT031(1),8)#                                    CQ31 199
writeline:(1,0,0,1,3)#                 Write out line containing hk     CQ31 200
#                                                                       CQ31 201
NGOOD = 0#                                                              CQ31 202
movepakwd:(HKL,HKLIN)#                 Current packed hkl               CQ31 203
BYFRST = no:#                          Clear bijvoet printer pointe     CQ31 204
FPT = FPTR - 4#                        Initialize f**2 pointer          CQ31 205
#                                                                       CQ31 206
FOR(I=1; I <= OBS; I=I+1)#             Loop over observations for       CQ31 207
#                                         This reflection.              CQ31 208
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CQ31 209
FPT = FPT + 4#                         Point to next f**2               CQ31 210
FSQ = QX(FPT+1)#                       Pick up f**2,                    CQ31 211
SIGMA = QX(FPT+2)#                     Sigma,                           CQ31 212
SHRIFT = QX(FPT+3)#                    Shift number, and                CQ31 213
WT = QX(FPT+4)#                        Weight.                          CQ31 214
#                                                                       CQ31 215
ifeq:(WT,0.) NEXT#                     Skip this observation            CQ31 216
IF(I > OBSSG)#                         If a bijvoet observation,        CQ31 217
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CQ31 218
IORD = I - OBSSG#                      Change ordinal number and        CQ31 219
movepakwd:(HKLBY,HKLIN)#               Current packed hkl.              CQ31 220
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CQ31 221
ELSE  IORD = I#                        Set space group ordinal no.      CQ31 222
#                                                                       CQ31 223
SAME = 0#                                                               CQ31 224
compakwd:(HKLIN,EQ,HRAW,SAME=1)#                                        CQ31 225
IF(SAME == 1 & IORD == ORDNL)#         See if this observation is a     CQ31 226
#                                         Ranked one.                   CQ31 227
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CQ31 228
FOR(II=13; II <= 16; II=II+1)#         Get rank(s)                      CQ31 229
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CQ31 230
OUT(II) = FLOAT(RANKS(II-12))#                                          CQ31 231
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CQ31 232
movepakwd:(HKL,HPREV)#                 Note that this reflection is     CQ31 233
#                                         Currently being processed.    CQ31 234
IX = IX + 4#                           Index to next ranked obs.        CQ31 235
# UNPACK IT                                                             CQ31 236
IF(IX < M)  CALL CQ32(IX)#                                              CQ31 237
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CQ31 238
ELSE#                                  This is an unranked obs.         CQ31 239
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CQ31 240
NGOOD = NGOOD + 1#                     Count it                         CQ31 241
IF(NGOOD > MAXR)  NEXT#                If this makes too many           CQ31 242
DO II = 13,16#                         Unranked observations being      CQ31 243
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CQ31 244
OUT(II) = 0.#                          Listed, skip it; otherwise       CQ31 245
#                                         Zero out the ranks.           CQ31 246
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CQ31 247
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CQ31 248
#                                                                       CQ31 249
OUT(8) = 0.#                           Stuff discrepancies for          CQ31 250
OUT(10) = 0.#                          Listing.                         CQ31 251
#                                                                       CQ31 252
OUT(9) = FSQ - AVGFSQ#                                                  CQ31 253
IF(FSQ > 0.1)#                         Keep ridiculous discrepancie     CQ31 254
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CQ31 255
OUT(8) = SIGMA/FSQ#                    From messing up the listing.     CQ31 256
OUT(10) = (1.-AVGFSQ/FSQ)**2#                                           CQ31 257
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CQ31 258
OUT(11) = OUT(9)/SIGFSQ#                                                CQ31 259
OUT(12) = OUT(9)/SIGMA#                                                 CQ31 260
#                                                                       CQ31 261
IF(LINCT < 2)#                         If not enough room left on       CQ31 262
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CQ31 263
LINCT = 0#                             Page, set a new page and put     CQ31 264
writeline:(0,CQ031,NCQ031,3,3)#        Out heading lines.               CQ31 265
writeline:(0,CQ032,NCQ032,3,3)#                                         CQ31 266
ncodefld:(HEAD,1,CHROT,FMT031(1),8)#                                    CQ31 267
movechar:(CQ034,1,CHROT,55,11,0)#                                       CQ31 268
writeline:(1,0,0,1,3)#                                                  CQ31 269
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CQ31 270
OUT(4) = FLOAT(IORD)#                  Stuff rest of line               CQ31 271
OUT(5) = SHRIFT#                                                        CQ31 272
OUT(6) = FSQ#                                                           CQ31 273
OUT(7) = SIGMA#                                                         CQ31 274
#                                                                       CQ31 275
ncodefld:(OUT,4,CHROT,FMT032(1),13)#   Encode the whole line            CQ31 276
#                                                                       CQ31 277
# DO WE NEED TO PUT OUT THE BIJVOET HKL?                                CQ31 278
IF(I > OBSSG & BYFRST == no: & IMERGE == no:)#                          CQ31 279
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CQ31 280
DO II=1,3#                                                              CQ31 281
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CQ31 282
intunpak:(HKLBY,IH(II),30-II*9,9)#     Unpack hkl according to          CQ31 283
intunpak:(HKLBY,J,3-II,1)#             Whether it's positive or         CQ31 284
IF (J!=0) IH(II) = -IH(II)#            Negative bijvoet                 CQ31 285
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CQ31 286
FOR(II=1; II <= 3; II=II+1)#                                            CQ31 287
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CQ31 288
OUT(II) = FLOAT(IH(II))#                                                CQ31 289
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CQ31 290
ncodefld:(OUT,1,CHROT,FMT031(1),3)#                                     CQ31 291
BYFRST = yes:#                         Bijvoet hkl already listed       CQ31 292
DO II = 1,3#                           Fill header line in case         CQ31 293
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CQ31 294
HEAD(II) = FLOAT(IH(II))#              Bijvoet is split between         CQ31 295
#                                         Pages.                        CQ31 296
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CQ31 297
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CQ31 298
writeline:(0,0,0,1,3)#                                                  CQ31 299
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CQ31 300
NRP = NRP + 1#                         Count number of reflections      CQ31 301
#                                         Listed.                       CQ31 302
IF(IX == M)  BREAK#                    Quit if no ranked                CQ31 303
#                                         Observations left.            CQ31 304
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CQ31 305
#                                                                       CQ31 306
movechar:(BLANK,1,CHROT,1,mxchln:,1)##                                  CQ31 307
movechar:(CQ033,1,CHROT,8,NCQ033,0)#                                    CQ31 308
BUFOT(1) = FLOAT(NRP)#                                                  CQ31 309
BUFOT(2) = FLOAT(NOP)#                                                  CQ31 310
ncodefld:(BUFOT,1,CHROT,FMT033(1),2)##                                  CQ31 311
writeline:(1,0,0,1,3)#                                                  CQ31 312
#                                                                       CQ31 313
readwpkt:(1,endrecord:,PSIZE,IPT,0)#   Finish reading the bdf           CQ31 314
#                                                                       CQ31 315
IF(IX != M)  iquit:(CQ3101)#           If anything left in              CQ31 316
#                                         Discrepancy table at this     CQ31 317
#                                         Point, something's wrong.     CQ31 318
RETURN#                                                                 CQ31 319
END#                                                                    CQ31 320
systemheader:(CQ32)#                                                    CQ32   1
# ################################################################## #  CQ32   2
#                                                                    #  CQ32   3
#                               CQ32                                 #  CQ32   4
#                                                                    #  CQ32   5
# ################################################################## #  CQ32   6
SUBROUTINE CQ32(IX)#                   Unpack one observation at a      CQ32   7
#                                         Time from table of            CQ32   8
#                                         Discrepancies.                CQ32   9
#                                        Oct 1979  r.a. alden           CQ32  10
#                                        June 1985 k.d.watenpaugh       CQ32  11
#                                        Nov 1986 kdw                   CQ32  12
include:(AACOMN)#                                                       CQ32  13
include:(CQCOMN)#                                                       CQ32  14
INTEGER IH(3)#                         H,k,l abs indices                CQ32  15
INTEGER IX#                            Pointer to current packed hk     CQ32  16
INTEGER SIGN(3)#                       Sorted hkl sign info.            CQ32  17
REAL TEMP#                                                              CQ32  18
#                                                                       CQ32  19
movepakwd:(QX(IX+1),HRAW)#             Get stored hkl                   CQ32  20
intunpak:(HRAW,SIGN(1),0,3)#           Get signs of hkl                 CQ32  21
intpak:(7-SIGN(1),TEMP,0,mxbtwd:)#     Get signs of bijvoet             CQ32  22
DO I=1,3#                              Unpack sign and hkl              CQ32  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CQ32  24
intunpak:(HRAW,IH(I),30-I*9,9)#                                         CQ32  25
intunpak:(TEMP,SIGN(I),3-I,1)#         Get signs                        CQ32  26
IF (IH(I) == 0) SIGN(I) = 0#           If zero index remove any neg     CQ32  27
intunpak:(HRAW,IH(I),3-I,1)#                                            CQ32  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CQ32  29
SIGN(1) = SIGN(1)*4 + SIGN(2)*2 + SIGN(3)#                              CQ32  30
IH(1)   = IH(1)*4   + IH(2)*2   + IH(3)#                                CQ32  31
movepakwd:(HRAW,HRANK)#                Store major bijvoet indices      CQ32  32
IF (SIGN(1) < IH(1))#                  We have bijvoet                  CQ32  33
#                                    # Convert to major bijvoet indices CQ32  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CQ32  35
intpak:(SIGN(1),HRANK,0,3)#                                             CQ32  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CQ32  37
intunpak:(QX(IX+2),ORDNL,16,12)#       Get ordinal                      CQ32  38
#                                                                       CQ32  39
intunpak:(QX(IX+4),RANKS(1),0,12)#     Break out 4 ranks                CQ32  40
intunpak:(QX(IX+4),RANKS(2),12,12)#                                     CQ32  41
intunpak:(QX(IX+3),RANKS(3),0,12)#                                      CQ32  42
intunpak:(QX(IX+3),RANKS(4),12,12)#                                     CQ32  43
#                                                                       CQ32  44
RETURN#                                                                 CQ32  45
END#                                                                    CQ32  46
systemheader:(CQ33)#                                                    CQ33   1
# ################################################################## #  CQ33   2
#                                                                    #  CQ33   3
#                              FSORT42:                              #  CQ33   4
#                                                                    #  CQ33   5
# ################################################################## #  CQ33   6
SUBROUTINE CQ33(NUM,NO)#                                                CQ33   7
#                                                                       CQ33   8
# QUICKSORT OF 'NO' 4-WORD REAL VARIABLES                               CQ33   9
#  BASED ON CODE FOUND IN SOFTWARE TOOLS.                               CQ33  10
#                                        May 1979  r.a. alden           CQ33  11
INTEGER I#                             Lower partition index            CQ33  12
INTEGER IJ#                            Exchange index                   CQ33  13
INTEGER J#                             Upper partition index            CQ33  14
INTEGER JJ#                            Exchange pointer                 CQ33  15
INTEGER LV(20)#                        Lower partition points           CQ33  16
INTEGER NO#                            Number of 4-word reals to        CQ33  17
#                                         Be sorted.                    CQ33  18
INTEGER P#                             Stack pointer                    CQ33  19
INTEGER UV(20)#                        Upper partitions points          CQ33  20
#                                                                       CQ33  21
REAL NUM(1)#                           Table of 4-word real variabl     CQ33  22
#                                         To be sorted.                 CQ33  23
REAL PIVPT(2)#                         Current pivot pointers           CQ33  24
REAL TEMP#                             Scratch storage during           CQ33  25
#                                         Interchange.                  CQ33  26
#                                                                       CQ33  27
LV(1) = 1#                             Set lower partition              CQ33  28
UV(1) = 4*NO - 3#                      Set upper partition              CQ33  29
P = 1#                                 Stack pointer for simulated      CQ33  30
#                                         Recursion.                    CQ33  31
WHILE(P > 0)#                                                           CQ33  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CQ33  33
IF(LV(P) >= UV(P))  P = P - 1#         If subset has only one           CQ33  34
#                                         Element, pop the stack.       CQ33  35
ELSE#                                  Do partitioning                  CQ33  36
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CQ33  37
I = LV(P) - 4#                         The elements are rearranged      CQ33  38
J = UV(P)#                             Entirely within the subset       CQ33  39
movepakwd:(NUM(J),PIVPT(1))#           Of num between the upper         CQ33  40
movepakwd:(NUM(J+1),PIVPT(2))#         And lower limits.                CQ33  41
WHILE(I < J)#                                                           CQ33  42
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CQ33  43
REPEAT#                                                                 CQ33  44
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CQ33  45
I = I + 4#                                                              CQ33  46
compakwd:(NUM(I),GT,PIVPT(1),BREAK)#                                    CQ33  47
compakwd:(NUM(I),LT,PIVPT(1),NEXT)#                                     CQ33  48
compakwd:(NUM(I+1),GE,PIVPT(2),BREAK)#                                  CQ33  49
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CQ33  50
FOR(J=J-4; J > I; J=J-4)#              Decrease j                       CQ33  51
#                                                                       CQ33  52
# AT THIS POINT, EITHER I AND J HAVE MET OR WE HAVE AN                  CQ33  53
#  OUT-OF-ORDER PAIR.                                                   CQ33  54
#                                                                       CQ33  55
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CQ33  56
compakwd:(NUM(J),LT,PIVPT(1),BREAK)#                                    CQ33  57
compakwd:(NUM(J),GT,PIVPT(1),NEXT)#                                     CQ33  58
compakwd:(NUM(J+1),LE,PIVPT(2),BREAK)#                                  CQ33  59
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CQ33  60
IF(I < J)  exchange4:#                 Exchange out-of-order pair       CQ33  61
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CQ33  62
#                                                                       CQ33  63
# I AND J HAVE MET.  MOVE THE PIVOT ELEMENT TO THE "MIDDLE"             CQ33  64
#                                                                       CQ33  65
J = UV(P)#                                                              CQ33  66
exchange4:#                            Exchange num(i) and last pt.     CQ33  67
IF(I-LV(P) < UV(P) -I)#                Stack so short partition don     CQ33  68
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CQ33  69
LV(P+1) = LV(P)#                       First.                           CQ33  70
UV(P+1) = I - 4#                                                        CQ33  71
LV(P) = I + 4#                                                          CQ33  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CQ33  73
ELSE#                                                                   CQ33  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CQ33  75
LV(P+1) = I + 4#                                                        CQ33  76
UV(P+1) = UV(P)#                                                        CQ33  77
UV(P) = I - 4#                                                          CQ33  78
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CQ33  79
P = P + 1#                             Push onto stack                  CQ33  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CQ33  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CQ33  82
RETURN#                                                                 CQ33  83
END#                                                                    CQ33  84
pmacro:([no:])#                        Purge xtal system macros         CQ33  85
