systemheader:(CU    )#                                                  CU     1
####################################################################### CU     2
##      Copyright (C) 2000, The Xtal System, The University of        # CU     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # CU     4
## Distributed under the GNU General Public Licence as published by   # CU     5
## the Free Software Foundation, in the hope that it will be useful   # CU     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # CU     7
## for more details.                                                  # CU     8
##                                                                    # CU     9
##                          *** CREDUC ***                            # CU    10
##                                                                    # CU    11
##   CREDUC - Cell reduction and twin law generation programme        # CU    12
##   This program finds the conventional representation of a lattice  # CU    13
##   input as cell parameters and a latice mode, assuming that metric # CU    14
##   relations in the lattice correspond to the symmetry.             # CU    15
##   Pseudo-symmetry in the primitive lattice is also detected        # CU    16
##                                                                    # CU    17
####################################################################### CU    18
#                                      Y. le page 1981                  CU    19
#                                      H.d. flack 1992                  CU    20
#                                                                       CU    21
include:(XMACRO)#                                                       CU    22
#                                                                       CU    23
extrude:(CUCOMN)#                                                       CU    24
REAL    AA(3,3)#                                                        CU    25
REAL    AANG(80)#                                                       CU    26
REAL    AINV(3,3)#                                                      CU    27
REAL    ANGBDF(3)#                     Alpha, beta, gamma on bdf        CU    28
REAL    ANGMAX#                        Maximum accceptable obliquity    CU    29
REAL    ANPRIM(3)#                     Primitive/ b reduced cell angl   CU    30
REAL    ATM1(3,3)#                                                      CU    31
REAL    ATM2(3,3)#                                                      CU    32
REAL    CELBDF(3)#                     A, b, c on bdf                   CU    33
REAL    DAR#                           Degrees to angles                CU    34
REAL    HH(3,80)#                                                       CU    35
REAL    HI(3)#                         Orthogonal components of row     CU    36
REAL    HX(3,83)#                                                       CU    37
INTEGER IHX(3,83)#                                                      CU    38
INTEGER IMAX#                          Maximum dot for multiple cells   CU    39
INTEGER IMAX1#                                                          CU    40
INTEGER IMAX2#                                                          CU    41
INTEGER ISYS#                          Crystal system of cell           CU    42
INTEGER ITOT#                          Total number of rows generated   CU    43
INTEGER LTYP#                          Lattice code 1 to 7              CU    44
INTEGER NH(3,80)#                                                       CU    45
INTEGER N2#                                                             CU    46
REAL    PRIM(3)#                       Primitive/ b reduced cell cons   CU    47
REAL    TRANS(3,3)#                    Accumulated transformation mat   CU    48
#                                                                       CU    49
INTEGER ISTOP, MARK2, STEP2, STOP2#    Qx array markers                 CU    50
#                                                                       CU    51
COMMON/COMICU/IHX,IMAX,IMAX1,IMAX2,ITOT,NH,N2,ISTOP,$#                  CU    52
ISYS,LTYP,MARK2,STEP2,STOP2#                                            CU    53
COMMON/COMFCU/AA,AANG,AINV,ANGBDF,ANGMAX,ANPRIM,ATM1,ATM2,$#            CU    54
CELBDF,DAR,HI,HH,HX,PRIM,TRANS#                                         CU    55
#                                                                       CU    56
endext:#                                                                CU    57
#                                                                       CU    58
systemheader:(CU00)#                                                    CU00   1
#*********************************************************************# CU00   2
#                                                                     # CU00   3
#                                CU00                                 # CU00   4
#                                                                     # CU00   5
#*********************************************************************# CU00   6
SUBROUTINE CU00#                                                        CU00   7
include:(AACOMN)#                                                       CU00   8
include:(CUCOMN)#                                                       CU00   9
#                                                                       CU00  10
CALL CU10#                             Process input lines              CU00  11
CALL CU20#                             Read the bdf                     CU00  12
CALL CU25#                             Burger reduction on p cell       CU00  13
CALL CU30#                             Cell reduction                   CU00  14
CALL CU40#                             Find the crystal system          CU00  15
CALL CU50#                             (pseudo) merohedral twin laws    CU00  16
#                                                                       CU00  17
RETURN#                                                                 CU00  18
END#                                                                    CU00  19
systemheader:(CU10)#                   Process the input lines          CU10   1
#********************************************************************** CU10   2
#                                                                       CU10   3
#                                CU10                                   CU10   4
#                                                                       CU10   5
#********************************************************************** CU10   6
SUBROUTINE CU10#                                                        CU10   7
include:(AACOMN)#                                                       CU10   8
include:(CUCOMN)#                                                       CU10   9
#                                                                       CU10  10
INTEGER CLEF,I,J,K#                                                     CU10  11
#                                                                       CU10  12
chardata:(CU101, AMAX MULT )#                                           CU10  13
chardata:(CU102," Maximum acceptable obliquity: X.X degrees")#          CU10  14
chardata:(CU103," Maximum multiple cell index:  XXX")#                  CU10  15
chardata:(CU104, END     )#                                             CU10  16
datastuff:#                                                             CU10  17
#                                                                       CU10  18
#                                                                       CU10  19
# SET DEFAULT OPTIONS                                                   CU10  20
# -------------------                                                   CU10  21
#                                                                       CU10  22
DAR=0.01745329#                        Convert degrees to angles        CU10  23
ANGMAX=3.0#                            Default maximum obliquity        CU10  24
IMAX=2#                                Default maximum dot              CU10  25
#                                                                       CU10  26
#    LOOP OVER CREDUC FIELDS                                            CU10  27
#    -----------------------                                            CU10  28
#                                                                       CU10  29
FOR(K=1;K<=mxfdim:;K=K+1)#             Loop over newcel line fields     CU10  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CU10  31
ifvo:(BUFIN(K)) BREAK#                 Quit on first void field         CU10  32
IF (BUFIN(K)>voidflg:) NEXT#           Check for alphabetics            CU10  33
stringlim:(K,I,J)#                     Get limits of character field    CU10  34
compchar:(CHRIN,I,CU101,2,4,5,NCU101,CLEF)# Identify key                CU10  35
IF(CLEF==0) iquit:(CU1001,K)#          Unrecognizable input field       CU10  36
ELSE IF(CLEF==1)#                      Maximum obliquity                CU10  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CU10  38
K=K+1#                                                                  CU10  39
ifnm:(BUFIN(K)) ANGMAX=BUFIN(K)#                                        CU10  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CU10  41
ELSE IF(CLEF==2)#                      Multiple cells                   CU10  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CU10  43
K=K+1#                                                                  CU10  44
ifnm:(BUFIN(K)) IMAX=NINT(BUFIN(K))#                                    CU10  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CU10  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CU10  47
#                                                                       CU10  48
#     WRITE OUT VALUES                                                  CU10  49
#                                                                       CU10  50
ncodefld:(ANGMAX,1,CU102,340312.,1)#   Maxmimum obliquity               CU10  51
writeline:(1,CU102,NCU102,3,3)#                                         CU10  52
ncodefld:(REAL(IMAX),1,CU103,340313.,1)# Maxmimum multiple cell         CU10  53
writeline:(0,CU103,NCU103,3,3)#                                         CU10  54
#                                                                       CU10  55
#    CONVERT VALUES                                                     CU10  56
#                                                                       CU10  57
ANGMAX=DAR*ANGMAX; ANGMAX=(SIN(ANGMAX)/COS(ANGMAX))**2#                 CU10  58
#                                                                       CU10  59
# READ INPUT LINES                                                      CU10  60
# ----------------                                                      CU10  61
#                                                                       CU10  62
REPEAT#                                Loop over input lines            CU10  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CU10  64
readline:(CU104,NCU104)#               Read the next input line         CU10  65
IF(LINID==1) BREAK#                    Exit end                         CU10  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CU10  67
#                                                                       CU10  68
RETURN#                                                                 CU10  69
END#                                                                    CU10  70
systemheader:(CU20)#                   Treat bdf                        CU20   1
#********************************************************************** CU20   2
#                                                                       CU20   3
#                                CU20                                   CU20   4
#                                                                       CU20   5
#********************************************************************** CU20   6
SUBROUTINE CU20#                       H.d.flack jan 1992               CU20   7
include:(AACOMN)#                                                       CU20   8
include:(CUCOMN)#                                                       CU20   9
#                                                                       CU20  10
INTEGER   ICNT#                        0/1 non- centrosymmetric         CU20  11
INTEGER   I,J,II#                      Odd temporary variables          CU20  12
INTEGER   NROT#                        Number of rotation matrices      CU20  13
INTEGER   NSYM#                        Number of symmetry matrices      CU20  14
INTEGER   IPP,OPP,PSIZE#               Bdf handling variables           CU20  15
#                                                                       CU20  16
chardata:(CU201," Input cell:")#                                        CU20  17
chardata:(CU202,"       Lattice mode: Z")#                              CU20  18
realdata:(FMT1,[121032.,221032.,321032.,421032.,521032.,621032.])#      CU20  19
chardata:(CU203,[PIRFABC])#                                             CU20  20
datastuff:#                                                             CU20  21
#                                                                       CU20  22
# SET UP I/O BUFFER FOR BDF AND ASK FOR MEMORY                          CU20  23
# --------------------------------------------                          CU20  24
#                                                                       CU20  25
IOMARK(1)=QXSTR#                       Save buffer for input bdf        CU20  26
IOMARK(2)=IOMARK(1)+bdfbuf:#           Save buffer for output bdf       CU20  27
incrqx:(ISTOP,IOMARK(2)+bdfbuf:,CU2001)# Mark end of current mem        CU20  28
#                                                                       CU20  29
copyfile:(1,2,lrhist:,decr:(lrcell:))# Start up the bdf copy            CU20  30
#                                                                       CU20  31
#   TREAT LRCELL:                                                       CU20  32
# ---------------                                                       CU20  33
#                                                                       CU20  34
DO I=1,8#                              Read lrcell: packets             CU20  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CU20  36
readwpkt:(1,lrcell:,PSIZE,IPP,0)#      Read packet                      CU20  37
IF(IPP<=0) BREAK#                      Break at end of lrcell:          CU20  38
writepkt:(2,lrcell:,PSIZE,OPP)#        Write packet                     CU20  39
movereal:(QX,IPP+1,QX,OPP+1,PSIZE,1)#  Copy across                      CU20  40
IF(I==1)#                                                               CU20  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CU20  42
movereal:(QX,IPP+1,CELBDF,1,3,0)#      Direct cell parameters           CU20  43
DO J=1,3; ANGBDF(J)=360.0*QX(IPP+6+J)# Direct cell angles               CU20  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CU20  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CU20  46
#                                                                       CU20  47
#   TREAT LRSYMM:                                                       CU20  48
#  --------------                                                       CU20  49
#                                                                       CU20  50
MARK2=ISTOP;STEP2=12#                  Pick up current end of mem       CU20  51
readwpkt:(1,lrsymm:,PSIZE,IPP,0)#      Read packet                      CU20  52
IF(IPP<=0) iquit:(CU2002)#             Quit if pkt not there            CU20  53
writepkt:(2,lrsymm:,PSIZE,OPP)#        Write packet                     CU20  54
movereal:(QX,IPP+1,QX,OPP+1,PSIZE,1)#  Copy across                      CU20  55
ICNT=1-NINT(QX(IPP+2))#                Centrosymmetry n=0   c=1         CU20  56
LTYP=NINT(QX(IPP+1))-7*ICNT#           Lattice code                     CU20  57
NSYM=NINT(QX(IPP+3))#                  Total no. symmetry matrices      CU20  58
NROT=NINT(QX(IPP+4))#                  No. of rotation matrices         CU20  59
#                                                                       CU20  60
# GET SYMMETRY EQUIVALENT POSITIONS                                     CU20  61
# ---------------------------------                                     CU20  62
#                                                                       CU20  63
incrqx:(STOP2,MARK2+NROT*STEP2,CU2003)# Request memory rotation symop   CU20  64
FOR(II=MARK2;II<STOP2;II=II+STEP2)#    Loop over symmetry matrices      CU20  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CU20  66
readwpkt:(1,lrsymm:,PSIZE,IPP,0)#      Read packet                      CU20  67
IF(IPP<=0) BREAK#                      Break at end                     CU20  68
writepkt:(2,lrsymm:,PSIZE,OPP)#        Write packet                     CU20  69
movereal:(QX,IPP+1,QX,OPP+1,PSIZE,1)#  Copy across                      CU20  70
movereal:(QX,IPP+1,QX,II+1,STEP2,1)#   Transfer packet                  CU20  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CU20  72
ISTOP=STOP2#                           Current end of memory            CU20  73
#                                                                       CU20  74
writeline:(1,CU201,NCU201,3,3)#                                         CU20  75
ncodefld:(CELBDF,1,CHROT,FMT1,3)#      Cell lengths                     CU20  76
ncodefld:(ANGBDF,1,CHROT,FMT1(4),3)#   Cell angles                      CU20  77
writeline:(0,0,0,1,3)#                                                  CU20  78
movechar:(CU203,LTYP,CU202,22,1,0)#                                     CU20  79
writeline:(0,CU202,NCU202,3,3)#        Lattice mode                     CU20  80
#                                                                       CU20  81
copyfile:(1,2,incr:(lrsymm:),decr:(lrtwin:))# Move file forward         CU20  82
#                                                                       CU20  83
RETURN#                                                                 CU20  84
END#                                                                    CU20  85
systemheader:(CU25)#                   Make burger reduction on p cel   CU25   1
#********************************************************************** CU25   2
#                                                                       CU25   3
#                                CU25                                   CU25   4
#                                                                       CU25   5
#********************************************************************** CU25   6
SUBROUTINE CU25#                       H.d.flack jan 1992               CU25   7
include:(AACOMN)#                                                       CU25   8
include:(CUCOMN)#                                                       CU25   9
#                                                                       CU25  10
REAL    CRAP(3,3),COSNG, H(3,3)#                                        CU25  11
INTEGER I,J,K,N#                                                        CU25  12
INTEGER II,IS,IS1,ISIGN,NN,NUM#                                         CU25  13
REAL    SAVE,V,VAR,VMIN#                                                CU25  14
#                                                                       CU25  15
intdata:(INUM,0)#                                                       CU25  16
chardata:(CU351," A Buerger cell:")#                                    CU25  17
chardata:(CU352," The input-to-Buerger cell matrix:")#                  CU25  18
realdata:(FMT1,[121032.,221032.,321032.,421032.,521032.,621032.])#      CU25  19
realdata:(FMT2,[120612.,180612.,240612.])#                              CU25  20
realdata:(TRANSD,[1.,0.,0.,0.,1.,0.,0.,0.,1.,$# P transforms to p cel   CU25  21
.5,.5,.5,0.,1.,0.,0.,0.,1.,$#          I centred                        CU25  22
.666667,.333333,.333333,  -.333333,.333333,.333333,$# R                 CU25  23
 -.333333,-.666667,.333333,$#          R centred part 2                 CU25  24
.5,.5,0.,0.,.5,.5,.5,0.,.5,$#          F centred                        CU25  25
1.,0.,0.,0.,.5,.5,0.,0.,1.,$#          A centred                        CU25  26
.5,0.,.5,0.,1.,0.,0.,0.,1.,$#          B centred                        CU25  27
.5,.5,0.,0.,1.,0.,0.,0.,1.])#          C centred                        CU25  28
datastuff:#                                                             CU25  29
#                                                                       CU25  30
#    TRANSFORM TO A PRIMITIVE CELL                                      CU25  31
#                                                                       CU25  32
CALL CU31(CELBDF,ANGBDF,AA,CRAP,7)#                                     CU25  33
DO N=1,3; CALL CU31(AA,TRANSD(3*N+9*LTYP-11),H(1,N),CRAP,3)#            CU25  34
DO N=1,3#                                                               CU25  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CU25  36
CALL CU31(AA,TRANSD(3*N+9*LTYP-11),PRIM(N),CRAP,6)#                     CU25  37
J=MOD(N,3)+1; K=6-N-J#                                                  CU25  38
CALL CU31(H(1,J),H(1,K),COSNG,CRAP,5)#                                  CU25  39
ANPRIM(N)=ACOS(COSNG)/DAR#                                              CU25  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CU25  41
DO N=1,3; DO NN=1,3; TRANS(NN,N)=TRANSD(N+3*NN+9*LTYP-12)#              CU25  42
#                                                                       CU25  43
#    PRODUCE BUERGER REDUCED CELL                                       CU25  44
#                                                                       CU25  45
DO I=1,3; DO J=1,3#                    Form the matrix of dot product   CU25  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CU25  47
IF(I==J) AA(I,J)=PRIM(I)*PRIM(I)#                                       CU25  48
IF(I!=J) AA(I,J)=PRIM(I)*PRIM(J)*COS(DAR*ANPRIM(6-I-J))#                CU25  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CU25  50
#                                                                       CU25  51
REPEAT#                                Find shorter trans in cell fac   CU25  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CU25  53
NUM=0#                                                                  CU25  54
DO I=1,3#                                                               CU25  55
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CU25  56
DO J=1,3#                                                               CU25  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CU25  58
IF(J==I) NEXT#                                                          CU25  59
IS=1; IF(AA(I,J)>0.) IS=-1#                                             CU25  60
IS1=IS; VMIN=0.#                                                        CU25  61
REPEAT#                                                                 CU25  62
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CU25  63
V=AA(I,J)*2.*REAL(IS1)+AA(J,J)*REAL(IS1**2)#                            CU25  64
IF(V>=VMIN) BREAK#                                                      CU25  65
VMIN=V; IS1=IS1+IS#                                                     CU25  66
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CU25  67
IS1=IS1-IS#                                                             CU25  68
IF(IS1!=0)#                            There is a shorter translation   CU25  69
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CU25  70
NUM=NUM+1; INUM=INUM+1#                                                 CU25  71
DO K=1,3#                              Transform the old-new indices    CU25  72
TRANS(I,K)=TRANS(I,K)+REAL(IS1)*TRANS(J,K)#                             CU25  73
AA(I,I)=AA(I,I)+AA(I,J)*2.*REAL(IS1)+AA(J,J)*REAL(IS1**2)# Modify the   CU25  74
AA(I,J)=AA(I,J)+REAL(IS1)*AA(J,J)#     Matrix of dot products           CU25  75
AA(J,I)=AA(I,J); K=6-I-J#                                               CU25  76
AA(I,K)=AA(I,K)+REAL(IS1)*AA(J,K); AA(K,I)=AA(I,K)#                     CU25  77
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CU25  78
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CU25  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CU25  80
IF(NUM==0) BREAK#                      Found all transformations        CU25  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CU25  82
REPEAT#                                                                 CU25  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CU25  84
VAR=ABS(AA(1,2))+ABS(AA(1,3))+ABS(AA(2,3))# Are the cross-terms of a    CU25  85
IF(ABS(ABS(AA(1,2)+AA(1,3)+AA(2,3))-VAR)>.0001*VAR)#                    CU25  86
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CU25  87
ISIGN=1#                               No, find the odd sign            CU25  88
IF(AA(1,2)*AA(1,3)*AA(2,3)<0.) ISIGN=-1#                                CU25  89
DO I=1,2#                                                               CU25  90
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CU25  91
K=I+1#                                                                  CU25  92
DO J=K,3#                                                               CU25  93
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CU25  94
IF(AA(I,J)*REAL(ISIGN)>0.)#            Make the cell triacute or trio   CU25  95
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CU25  96
K=6-I-J#                               Modify the indices and the dot   CU25  97
DO II=1,3; TRANS(I,II)=-TRANS(I,II)#                                    CU25  98
DO II=1,3; TRANS(J,II)=-TRANS(J,II)#                                    CU25  99
AA(K,J)=-AA(K,J); AA(J,K)=-AA(J,K)#                                     CU25 100
AA(K,I)=-AA(K,I); AA(I,K)=-AA(I,K)#                                     CU25 101
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CU25 102
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CU25 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CU25 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CU25 105
INUM=0#                                Order the diagonal terms         CU25 106
REPEAT#                                In increasing values             CU25 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CU25 108
NUM=0#                                                                  CU25 109
DO I=1,2#                                                               CU25 110
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CU25 111
IF((AA(I,I)-AA(I+1,I+1))<=0.) NEXT#                                     CU25 112
NUM=NUM+1; INUM=INUM+1#                                                 CU25 113
DO J=1,3#                                                               CU25 114
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CU25 115
SAVE=AA(I,J); AA(I,J)=AA(I+1,J); AA(I+1,J)=SAVE#                        CU25 116
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CU25 117
DO J=1,3#                                                               CU25 118
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CU25 119
SAVE=AA(J,I); AA(J,I)=AA(J,I+1); AA(J,I+1)=SAVE#                        CU25 120
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CU25 121
DO K=1,3#                                                               CU25 122
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CU25 123
SAVE=TRANS(I,K); TRANS(I,K)=TRANS(I+1,K); TRANS(I+1,K)=SAVE#            CU25 124
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CU25 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CU25 126
IF(NUM==0)BREAK#                                                        CU25 127
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CU25 128
IF(MOD(INUM,2)!=0)#                    Cell left-handed, reverse all    CU25 129
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CU25 130
DO I=1,3; DO J=1,3; TRANS(I,J)=-TRANS(I,J)#                             CU25 131
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CU25 132
#                                                                       CU25 133
#  IF 111 IS SHORTER THAN C, CALL IT C AND RE-REDUCE THE CELL           CU25 134
#                                                                       CU25 135
IF(AA(1,1)+AA(2,2)<-2.*(AA(1,2)+AA(1,3)+AA(2,3)))#                      CU25 136
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CU25 137
AA(3,3)=AA(3,3)+2.*AA(3,1)+AA(1,1); AA(3,1)=AA(3,1)+AA(1,1)#            CU25 138
AA(1,3)=AA(3,1); AA(3,2)=AA(3,2)+AA(1,2)#                               CU25 139
AA(2,3)=AA(3,2); AA(3,3)=AA(3,3)+2.*AA(3,2)+AA(2,2)#                    CU25 140
AA(3,2)=AA(3,2)+AA(2,2); AA(2,3)=AA(3,2)#                               CU25 141
AA(3,1)=AA(3,1)+AA(1,2); AA(1,3)=AA(3,1)#                               CU25 142
DO J=1,3; TRANS(3,J)=TRANS(1,J)+TRANS(2,J)+TRANS(3,J)#                  CU25 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CU25 144
ELSE BREAK#                                                             CU25 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CU25 146
#                                                                       CU25 147
#  GET THE BUERGER CELL PARAMETERS                                      CU25 148
#                                                                       CU25 149
DO I=1,3; PRIM(I)=SQRT(AA(I,I))#                                        CU25 150
DO I=1,3#                                                               CU25 151
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CU25 152
J=MOD(I,3)+1; K=MOD(J,3)+1#                                             CU25 153
ANPRIM(I)=ACOS(AA(J,K)/(PRIM(J)*PRIM(K)))/DAR#                          CU25 154
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CU25 155
writeline:(1,CU351,NCU351,3,3)#                                         CU25 156
ncodefld:(PRIM,1,CHROT,FMT1,3)#        Cell lengths                     CU25 157
ncodefld:(ANPRIM,1,CHROT,FMT1(4),3)#   Cell angles                      CU25 158
writeline:(0,0,0,1,3)#                                                  CU25 159
writeline:(1,CU352,NCU352,3,3)#                                         CU25 160
DO I=1,3#                                                               CU25 161
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CU25 162
DO J=1,3;ncodefld:(TRANS(I,J),1,CHROT,FMT2(J),1)#                       CU25 163
writeline:(0,0,0,1,3)#                                                  CU25 164
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CU25 165
#                                                                       CU25 166
RETURN#                                                                 CU25 167
END#                                                                    CU25 168
systemheader:(CU30)#                                                    CU30   1
#*********************************************************************# CU30   2
#                                                                     # CU30   3
#                                CU30                                 # CU30   4
#                                                                     # CU30   5
#*********************************************************************# CU30   6
SUBROUTINE CU30#                                                        CU30   7
#                                                                       CU30   8
include:(AACOMN)#                                                       CU30   9
include:(CUCOMN)#                                                       CU30  10
#                                                                       CU30  11
REAL        ANMAX#                                                      CU30  12
REAL        CRAP(3,3)#                 Dummy empty matrix               CU30  13
INTEGER     I,J#                                                        CU30  14
INTEGER     IA,IB,IC,JA,KA#                                             CU30  15
INTEGER     IH(3)#                                                      CU30  16
INTEGER     ISAVE#                                                      CU30  17
INTEGER     MAXJI#                                                      CU30  18
REAL        SAVE#                                                       CU30  19
#                                                                       CU30  20
chardata:(CU301," Possible 2-fold axes:")#                              CU30  21
chardata:(CU302,"              Rows                    Products")#      CU30  22
chardata:(CU303,"       Direct      Reciprocal       Dot    Vector")#   CU30  23
datastuff:#                                                             CU30  24
#                                                                       CU30  25
IMAX1=IMAX+1; IMAX2=2*IMAX+1#                                           CU30  26
#                                                                       CU30  27
writeline:(1,CU301,NCU301,3,3)#        Possible 2-fold axes:            CU30  28
writeline:(0,CU302,NCU302,3,3)#        Rows/products                    CU30  29
writeline:(0,CU303,NCU303,3,3)#        Direct/reciprocal/dot/vector     CU30  30
#                                                                       CU30  31
#   GET THE ORTHOGONAL REPRESENTATION OF THE PRIMITIVE UNIT VECTORS     CU30  32
#                                                                       CU30  33
CALL CU31(PRIM,ANPRIM,AA,CRAP,7)#                                       CU30  34
CALL CU31(AA,AINV,CRAP,CRAP,1)#                                         CU30  35
#                                                                       CU30  36
#  GENERATE ROW MILLER INDICES NO LARGER THAN IMAX                      CU30  37
#                                                                       CU30  38
ITOT=0; N2=0#                                                           CU30  39
DO IA=1,IMAX1#                         Generate all index combination   CU30  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CU30  41
IH(1)=IA-1#                                                             CU30  42
DO IB=1,IMAX2#                                                          CU30  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CU30  44
IH(2)=IB-IMAX-1#                                                        CU30  45
DO IC=1,IMAX2#                                                          CU30  46
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CU30  47
IH(3)=IC-IMAX-1#                                                        CU30  48
CALL CU34(IH,KA,IMAX)#                 Reject the ones that are not c   CU30  49
IF(KA!=0) NEXT#                                                         CU30  50
IF((IABS(IH(1))+IABS(IH(2))+IABS(IH(3)))==5&IMAX==2) NEXT#              CU30  51
ITOT=ITOT+1#                                                            CU30  52
HI(1)=IH(1); HI(2)=IH(2); HI(3)=IH(3)# Get the orthogonal components    CU30  53
CALL CU31(AA,HI,HX(1,ITOT),CRAP,9)#                                     CU30  54
DO JA=1,3; IHX(JA,ITOT)=IH(JA)#                                         CU30  55
IF(ITOT>=83) CALL CU39#                Generate planes                  CU30  56
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CU30  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CU30  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CU30  59
#                                                                       CU30  60
CALL CU39#                             Finish plane generation          CU30  61
#                                                                       CU30  62
#  ORDER THE ROWS ON THE ANGLE WITH THE NORMAL TO THE PLANE             CU30  63
#                                                                       CU30  64
IF(N2>=2)#                                                              CU30  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CU30  66
DO I=1,N2-1#                                                            CU30  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CU30  68
ANMAX=AANG(I); MAXJI=I#                                                 CU30  69
DO J=I+1,N2#                                                            CU30  70
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CU30  71
IF(AANG(J)>=ANMAX) NEXT#                                                CU30  72
ANMAX=AANG(J); MAXJI=J#                                                 CU30  73
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CU30  74
DO J=1,3#                                                               CU30  75
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CU30  76
ISAVE=NH(J,I); NH(J,I)=NH(J,MAXJI)#                                     CU30  77
NH(J,MAXJI)=ISAVE; SAVE=HH(J,I)#                                        CU30  78
HH(J,I)=HH(J,MAXJI); HH(J,MAXJI)=SAVE#                                  CU30  79
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CU30  80
AANG(MAXJI)=AANG(I); AANG(I)=ANMAX#                                     CU30  81
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CU30  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CU30  83
#                                                                       CU30  84
RETURN#                                                                 CU30  85
END#                                                                    CU30  86
systemheader:(CU31)#                   Matrix library                   CU31   1
#********************************************************************** CU31   2
#                                                                       CU31   3
#                                CU31                                   CU31   4
#                                                                       CU31   5
#********************************************************************** CU31   6
SUBROUTINE CU31(A,B,C,D,WHAT)#                                          CU31   7
include:(AACOMN)#                                                       CU31   8
#                                                                       CU31   9
INTEGER I,J,K,WHAT#                                                     CU31  10
REAL    A(3,3),B(3,3),C(3,3),D(3,3),E(3,3),V(3)#                        CU31  11
REAL    DMAT, VMOD, SINGAS, COSGAS#                                     CU31  12
realdata:(DAR,0.01745329)#                                              CU31  13
datastuff:#                                                             CU31  14
#                                                                       CU31  15
#  WHAT == 1  INVERT, WHAT == 2  MATMUL, WHAT == 3  MATVEC,             CU31  16
#  WHAT == 4  VECMAT, WHAT == 5  SCALPR, WHAT == 6  LENGTH,             CU31  17
#  WHAT == 7  ORTHOG, WHAT == 8  DETERM, WHAT == 9  MVMULT,             CU31  18
#  WHAT == 10 VMMULT, WHAT == 11 TRNSPS                                 CU31  19
IF(WHAT==1)#                           Invert 3x3 a, put result in b    CU31  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CU31  21
E(1,1)=A(2,2)*A(3,3)-A(2,3)*A(3,2)#                                     CU31  22
E(2,1)=-(A(2,1)*A(3,3)-A(2,3)*A(3,1))#                                  CU31  23
E(3,1)=A(2,1)*A(3,2)-A(2,2)*A(3,1)#                                     CU31  24
E(1,2)=-(A(1,2)*A(3,3)-A(1,3)*A(3,2))#                                  CU31  25
E(2,2)=A(1,1)*A(3,3)-A(1,3)*A(3,1)#                                     CU31  26
E(3,2)=-(A(1,1)*A(3,2)-A(1,2)*A(3,1))#                                  CU31  27
E(1,3)=A(1,2)*A(2,3)-A(1,3)*A(2,2)#                                     CU31  28
E(2,3)=-(A(1,1)*A(2,3)-A(1,3)*A(2,1))#                                  CU31  29
E(3,3)=A(1,1)*A(2,2)-A(1,2)*A(2,1)#                                     CU31  30
DMAT=A(1,1)*E(1,1)+A(1,2)*E(2,1)+A(1,3)*E(3,1)#                         CU31  31
DO I=1,3; DO J=1,3; B(I,J)=E(I,J)/DMAT#                                 CU31  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CU31  33
ELSE IF(WHAT==2)#                      Multiply 3x3 a and b, store in   CU31  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CU31  35
DO I=1,3; DO J=1,3; C(I,J)=0.0#                                         CU31  36
DO I=1,3; DO J=1,3; DO K=1,3; C(I,J)=C(I,J)+A(I,K)*B(K,J)#              CU31  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CU31  38
ELSE IF(WHAT==3)#                      Multiply 3x3 a by vector b,      CU31  39
#                                      Store cosines of result in c     CU31  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CU31  41
DO I=1,3; V(I)=0.#                                                      CU31  42
DO I=1,3; DO J=1,3; V(I)=V(I)+A(I,J)*B(J,1)#                            CU31  43
VMOD=SQRT(V(1)**2+V(2)**2+V(3)**2)#                                     CU31  44
DO I=1,3; C(I,1)=V(I)/VMOD#                                             CU31  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CU31  46
ELSE IF(WHAT==4)#                      Multiply vector a by matrix b,   CU31  47
#                                      Direction cosines of result in c CU31  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CU31  49
DO I=1,3; V(I)=0.#                                                      CU31  50
DO I=1,3; DO J=1,3; V(I)=V(I)+B(J,I)*A(J,1)#                            CU31  51
VMOD=SQRT(V(1)**2+V(2)**2+V(3)**2)#                                     CU31  52
DO I=1,3; C(I,1)=V(I)/VMOD#                                             CU31  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CU31  54
ELSE IF(WHAT==5)#                      Scalar product of vectors a an   CU31  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CU31  56
C(1,1)=0.#                                                              CU31  57
DO I=1,3; C(1,1)=C(1,1)+A(I,1)*B(I,1)#                                  CU31  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CU31  59
ELSE IF(WHAT==6)#                      Length of vector b when a is t   CU31  60
#                                      Metric matrix                    CU31  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CU31  62
DO I=1,3; V(I)=0.#                                                      CU31  63
DO I=1,3; DO J=1,3; V(I)=V(I)+A(I,J)*B(J,1)#                            CU31  64
C(1,1)=SQRT(V(1)**2+V(2)**2+V(3)**2)#                                   CU31  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CU31  66
ELSE IF(WHAT==7)#                      Get the metric matrix c corres   CU31  67
#                                      To cell edges a and angles b     CU31  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CU31  69
COSGAS=(COS(DAR*B(1,1))*COS(DAR*B(2,1))-COS(DAR*B(3,1)))#               CU31  70
COSGAS=COSGAS/(SIN(DAR*B(1,1))*SIN(DAR*B(2,1)))#                        CU31  71
SINGAS=SQRT(1.-COSGAS**2)#                                              CU31  72
C(1,1)=A(1,1)*SIN(DAR*B(2,1))*SINGAS#                                   CU31  73
C(1,2)=0.; C(1,3)=0.#                                                   CU31  74
C(2,1)=-A(1,1)*SIN(DAR*B(2,1))*COSGAS#                                  CU31  75
C(2,2)=A(2,1)*SIN(DAR*B(1,1)); C(2,3)=0.#                               CU31  76
C(3,1)=A(1,1)*COS(DAR*B(2,1))#                                          CU31  77
C(3,2)=A(2,1)*COS(DAR*B(1,1))#                                          CU31  78
C(3,3)=A(3,1)#                                                          CU31  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CU31  80
ELSE IF(WHAT==8)#                      Get determinant d of vectors a   CU31  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CU31  82
D(1,1)=0.#                                                              CU31  83
DO I=1,3#                                                               CU31  84
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CU31  85
J=I+1#                                                                  CU31  86
IF(J==4) J=1#                                                           CU31  87
K=6-I-J#                                                                CU31  88
D(1,1)=D(1,1)+A(I,1)*(B(J,1)*C(K,1)-B(K,1)*C(J,1))#                     CU31  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CU31  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CU31  91
ELSE IF(WHAT==9)#                      Multiply matrix a by vector b    CU31  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CU31  93
DO I=1,3; C(I,1)=0.#                                                    CU31  94
DO I=1,3; DO J=1,3; C(I,1)=C(I,1)+A(I,J)*B(J,1)#                        CU31  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CU31  96
ELSE IF(WHAT==10)#                     Multiply vector a by matrix b    CU31  97
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CU31  98
DO I=1,3; C(I,1)=0.#                                                    CU31  99
DO I=1,3; DO J=1,3; C(I,1)=C(I,1)+A(J,1)*B(J,I)#                        CU31 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CU31 101
ELSE IF(WHAT==11)#                     Transpose a and put it in b      CU31 102
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CU31 103
DO I=1,3; DO J=1,3; B(I,J)=A(J,I)#                                      CU31 104
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CU31 105
#                                                                       CU31 106
RETURN#                                                                 CU31 107
END#                                                                    CU31 108
systemheader:(CU32)#                   Latmod subroutine                CU32   1
#********************************************************************** CU32   2
#                                                                       CU32   3
#                                CU32                                   CU32   4
#                                                                       CU32   5
#********************************************************************** CU32   6
SUBROUTINE CU32(LAT,MODE)#                                              CU32   7
#                                                                       CU32   8
include:(AACOMN)#                                                       CU32   9
#                                                                       CU32  10
REAL     DET#                                                           CU32  11
REAL     LAT(3,3)#                                                      CU32  12
INTEGER  I,J,K,L,N#                                                     CU32  13
INTEGER  IFLK,ISUM#                                                     CU32  14
INTEGER  M(3)#                                                          CU32  15
string:(MODE,1)#                                                        CU32  16
INTEGER  IDET#                                                          CU32  17
#                                                                       CU32  18
CALL CU31(LAT(1,1),LAT(1,2),LAT(1,3),DET,8)#                            CU32  19
IDET=ABS(DET)+.1; MODE=' '#                                             CU32  20
IF(IDET==1) MODE='P'#                                                   CU32  21
ELSE IF(IDET==3) MODE='R'#                                              CU32  22
ELSE IF(IDET==4) MODE='F'#                                              CU32  23
ELSE IF(IDET==2)#                                                       CU32  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CU32  25
DO I=0,1#                                                               CU32  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CU32  27
M(1)=I#                                                                 CU32  28
DO J=0,1#                                                               CU32  29
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CU32  30
M(2)=J#                                                                 CU32  31
DO K=0,1#                                                               CU32  32
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CU32  33
M(3)=K#                                                                 CU32  34
IF(M(1)+M(2)+M(3)<2) NEXT#                                              CU32  35
IFLK=0#                                                                 CU32  36
DO L=1,3#                                                               CU32  37
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CU32  38
ISUM=0#                                                                 CU32  39
DO N=1,3; ISUM=ISUM+M(N)*INT(ABS(LAT(L,N)))#                            CU32  40
IF(MOD(ISUM,2)==0)IFLK=IFLK+1#                                          CU32  41
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CU32  42
IF(IFLK==3)#                                                            CU32  43
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CU32  44
MODE='I'#                                                               CU32  45
IF(M(1)==0)MODE='A'#                                                    CU32  46
IF(M(2)==0)MODE='B'#                                                    CU32  47
IF(M(3)==0)MODE='C'#                                                    CU32  48
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CU32  49
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CU32  50
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CU32  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CU32  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CU32  53
#                                                                       CU32  54
RETURN#                                                                 CU32  55
END#                                                                    CU32  56
systemheader:(CU34)#                   Coprime subroutine               CU34   1
#********************************************************************** CU34   2
#                                                                       CU34   3
#                                CU34                                   CU34   4
#                                                                       CU34   5
#********************************************************************** CU34   6
SUBROUTINE CU34(I,K,IMAXX)#                                             CU34   7
include:(AACOMN)#                                                       CU34   8
#                                                                       CU34   9
INTEGER I(3)#                                                           CU34  10
INTEGER K,J#                                                            CU34  11
INTEGER IMAXX#                                                          CU34  12
#                                                                       CU34  13
K=0; J=0#                                                               CU34  14
IF((I(1)==0)&(I(2)<0)) K=1#                                             CU34  15
ELSE IF((I(1)==0)&(I(2)==0)&(I(3)!=1)) K=1#                             CU34  16
ELSE IF((MOD(I(1),2)==0)&(MOD(I(2),2)==0)&(MOD(I(3),2)==0)) K=1#        CU34  17
ELSE IF(IMAXX<3) J=J#                                                   CU34  18
ELSE IF((MOD(I(1),3)==0)&(MOD(I(2),3)==0)&(MOD(I(3),3)==0)) K=1#        CU34  19
ELSE IF(IMAXX<5) J=J#                                                   CU34  20
ELSE IF((MOD(I(1),5)==0)&(MOD(I(2),5)==0)&(MOD(I(3),5)==0)) K=1#        CU34  21
ELSE IF(IMAXX<7) J=J#                                                   CU34  22
ELSE IF((MOD(I(1),7)==0)&(MOD(I(2),7)==0)&(MOD(I(3),7)==0)) K=1#        CU34  23
#                                                                       CU34  24
RETURN#                                                                 CU34  25
END#                                                                    CU34  26
systemheader:(CU39)#                   Plane generation                 CU39   1
#*********************************************************************# CU39   2
#                                                                     # CU39   3
#                                CU39                                 # CU39   4
#                                                                     # CU39   5
#*********************************************************************# CU39   6
SUBROUTINE CU39#                                                        CU39   7
#                                                                       CU39   8
include:(AACOMN)#                                                       CU39   9
include:(CUCOMN)#                                                       CU39  10
#                                                                       CU39  11
REAL        ANG#                                                        CU39  12
REAL        CRAP(3,3)#                 Dummy empty matrix               CU39  13
REAL        HMOD#                                                       CU39  14
INTEGER     I,J,K,KA,L,NX#                                              CU39  15
INTEGER     MULT#                                                       CU39  16
INTEGER     IP(3)#                                                      CU39  17
REAL        P(3)#                                                       CU39  18
#                                                                       CU39  19
realdata:(FMT,[60413.,100413.,140413.,200413.,240413.,280413.,$#        CU39  20
381013.,481032.])#                                                      CU39  21
datastuff:#                                                             CU39  22
#                                                                       CU39  23
#  GENERATE TRICLINIC MILLER INDICES FOR PLANES                         CU39  24
#                                                                       CU39  25
WHILE(ITOT!=0)#                                                         CU39  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CU39  27
DO I=1,IMAX1#                                                           CU39  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CU39  29
IP(1)=I-1#                                                              CU39  30
DO J=1,IMAX2#                                                           CU39  31
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CU39  32
IP(2)=J-IMAX-1#                                                         CU39  33
DO K=1,IMAX2#                                                           CU39  34
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CU39  35
IP(3)=K-IMAX-1#                                                         CU39  36
CALL CU34(IP,KA,IMAX)#                                                  CU39  37
IF((IABS(IP(1))+IABS(IP(2))+IABS(IP(3)))==5&IMAX==2) NEXT#              CU39  38
IF(KA!=0) NEXT#                                                         CU39  39
DO L=1,3; HI(L)=REAL(IP(L))#           Get the orthogonal components    CU39  40
CALL CU31(HI,AINV,P,CRAP,10)#          Of the normal to the plane       CU39  41
DO L=1,ITOT#                           Get one row                      CU39  42
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CU39  43
#                                                                       CU39  44
#  CALCULATE THE MULTIPLICITY OF THE CELL DEFINED BY THE MESH ON THE    CU39  45
#  PLANE AND THE TRANSLATION ALONG THE ROW                              CU39  46
#                                                                       CU39  47
MULT=IABS(IHX(1,L)*IP(1)+IHX(2,L)*IP(2)+IHX(3,L)*IP(3))#                CU39  48
IF(MULT==0\MULT>IMAX) NEXT#                                             CU39  49
#  CALCULATE THE ANGLE BETWEEN THE ROW AND THE NORMAL TO THE PLANE      CU39  50
ANG=(P(1)*HX(2,L)-P(2)*HX(1,L))**2+(P(2)*HX(3,L)-P(3)*HX(2,L))$#        CU39  51
**2+(P(3)*HX(1,L)-P(1)*HX(3,L))**2#                                     CU39  52
ANG=ANG/REAL(MULT*MULT)#                                                CU39  53
IF(ANG>ANGMAX) NEXT#                                                    CU39  54
ANG=ATAN(SQRT(ANG))/DAR#                                                CU39  55
# THIS IS A POTENTIAL EVEN-ORDER AXIS, WE PRINT IT AND SAVE IT          CU39  56
BUFOT(1)=REAL(IHX(1,L));BUFOT(2)=REAL(IHX(2,L))#                        CU39  57
BUFOT(3)=REAL(IHX(3,L));BUFOT(4)=REAL(IP(1))#                           CU39  58
BUFOT(5)=REAL(IP(2));BUFOT(6)=REAL(IP(3))#                              CU39  59
BUFOT(7)=REAL(MULT);BUFOT(8)=ANG#                                       CU39  60
ncodefld:(BUFOT,1,CHROT,FMT,8)#                                         CU39  61
writeline:(0,0,0,1,3)#                                                  CU39  62
#                                                                       CU39  63
HMOD=SQRT(HX(1,L)**2+HX(2,L)**2+HX(3,L)**2); N2=N2+1#                   CU39  64
DO NX=1,3#                                                              CU39  65
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CU39  66
NH(NX,N2)=IHX(NX,L)#                                                    CU39  67
HH(NX,N2)=HX(NX,L)/HMOD; AANG(N2)=ANG#                                  CU39  68
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CU39  69
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CU39  70
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CU39  71
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CU39  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CU39  73
ITOT=0#                                Done these rows                  CU39  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CU39  75
#                                                                       CU39  76
RETURN#                                                                 CU39  77
END#                                                                    CU39  78
systemheader:(CU40)#                   Find sys subroutine              CU40   1
#********************************************************************** CU40   2
#                                                                       CU40   3
#                                CU40                                   CU40   4
#                                                                       CU40   5
#********************************************************************** CU40   6
SUBROUTINE CU40#                                                        CU40   7
#                                                                       CU40   8
include:(AACOMN)#                                                       CU40   9
include:(CUCOMN)#                                                       CU40  10
#                                                                       CU40  11
REAL    ALP(3)#                                                         CU40  12
REAL    BEST#                                                           CU40  13
REAL    CRAP(3,3)#                     Dummy empty matrix               CU40  14
REAL    DET,DET1,DET2#                                                  CU40  15
REAL    ENGTH(3,2)#                                                     CU40  16
REAL    GTH#                                                            CU40  17
REAL    H(3)#                                                           CU40  18
REAL    HAND1,HAND2#                                                    CU40  19
INTEGER I,J,K,L,N#                                                      CU40  20
INTEGER I1,I2,I3,II1#                                                   CU40  21
INTEGER JJ,JA,KA,JB#                                                    CU40  22
INTEGER IAX,IFLAK,ITEST#                                                CU40  23
INTEGER IANY#                                                           CU40  24
INTEGER IH(3)#                                                          CU40  25
INTEGER IP,IS,ISG,ISAVE#                                                CU40  26
INTEGER IPRIM,IFIRST,ISEC,ITWO#                                         CU40  27
INTEGER IPERM,ITRY#                                                     CU40  28
REAL    LATIC(3,9,5)#                                                   CU40  29
REAL    MAT(3,3,2)#                                                     CU40  30
INTEGER MATMAX#                                                         CU40  31
INTEGER MATCH(20)#                                                      CU40  32
string:(MODE,1)#                                                        CU40  33
INTEGER NAX#                                                            CU40  34
INTEGER NPSUDO#                                                         CU40  35
REAL    PROCAL,PRODOB#                                                  CU40  36
REAL    PROC1,PROC2,PROD1,PROD2#                                        CU40  37
REAL    RESULT(3)#                                                      CU40  38
REAL    SAVE#                                                           CU40  39
REAL    SCAL1,SCAL2,SAL1,SAL2,SCAL,SCALI#                               CU40  40
REAL    TOT(2)#                                                         CU40  41
REAL    VEC(3,3,2)#                                                     CU40  42
#                                                                       CU40  43
intdata:(NDIR,[9,7,3,5,3])#            Number of even-order axes,       CU40  44
intdata:(NAMBI,[0,1,0,1,0])#           Of orientation ambiguities,      CU40  45
intdata:(NIND,[2,3,1,2,1])#            Of symmetry-unrelated axes       CU40  46
intdata:(MAXES,[1,3,4, 0,0,0,   1,5,3, 2,6,3,   1,3,4, 0,0,0,$#         CU40  47
1,4,2, 5,3,2,   1,2,3, 0,0,0])#        Possible conventional axes       CU40  48
#                                                                       CU40  49
#  DIRECTION COSINES OF THE EVEN-ORDER AXES IN THE SYSTEM               CU40  50
#                                                                       CU40  51
realdata:(CUBIC,[1.,0.,0., .707,.707,0., 0.,1.,0., 0.,0.,1.,$#          CU40  52
.707,0.,.707, 0.,.707,.707, .707,-.707,0., .707,0.,-.707,$#             CU40  53
0.,.707,-.707])#                                                        CU40  54
realdata:(HEXAG,[.5,-.866,0., .866,-.5,0., 0.,0.,1., .866,.5,0.,$#      CU40  55
.5,.866,0., 0.,1.,0., 1.,0.,0.])#                                       CU40  56
realdata:(RHOMB,[.866,-.5,0., .866,.5,0., 0.,1.,0., 0.,0.,1.])#         CU40  57
realdata:(TETRAG,[1.,0.,0., 0.,0.,1., .707,.707,0., 0.,1.,0.,$#         CU40  58
.707,-.707,0.])#                                                        CU40  59
realdata:(ORTHO,[1.,0.,0., 0.,1.,0., 0.,0.,1.])#                        CU40  60
#                                                                       CU40  61
realdata:(ACCEPT,.06)#                                                  CU40  62
realdata:(EXPER,.1)#                                                    CU40  63
realdata:(TEST,[.666667,.333333,.333333])#                              CU40  64
#                                                                       CU40  65
chardata:(CU401," A =  XX.X XX.X XX.X XXXX.XXXX  Alpha= XXXXX.XXX$#     CU40  66
  A* = XXX.XXX XXX.XXX XXX.XXX")#                                       CU40  67
chardata:(CU402," B =  XX.X XX.X XX.X XXXX.XXXX  Beta = XXXXX.XXX$#     CU40  68
  B* = XXX.XXX XXX.XXX XXX.XXX")#                                       CU40  69
chardata:(CU403," C =  XX.X XX.X XX.X XXXX.XXXX  Gamma= XXXXX.XXX$#     CU40  70
  C* = XXX.XXX XXX.XXX XXX.XXX")#                                       CU40  71
realdata:(FMT,[100512.,150512.,200512.,301042.,481032.,$#               CU40  72
620832.,700832.,780832.])#                                              CU40  73
chardata:(PSUDX," Metrically      Pseudo ")#                            CU40  74
chardata:(SYSTM,"cubic       hexagonal   hexagonal   $#                 CU40  75
tetragonal  orthorhombicmonoclinic  triclinic   ")#                     CU40  76
chardata:(DELTA,"Max delta")#                                           CU40  77
datastuff:#                                                             CU40  78
#                                                                       CU40  79
DO I=1,3; DO J=1,9; LATIC(I,J,1)=CUBIC(3*J+I-3)# Fill latic             CU40  80
DO I=1,3; DO J=1,7; LATIC(I,J,2)=HEXAG(3*J+I-3)#                        CU40  81
DO I=1,3; DO J=1,4; LATIC(I,J,3)=RHOMB(3*J+I-3)#                        CU40  82
DO I=1,3; DO J=1,5; LATIC(I,J,4)=TETRAG(3*J+I-3)#                       CU40  83
DO I=1,3; DO J=1,3; LATIC(I,J,5)=ORTHO(3*J+I-3)#                        CU40  84
NPSUDO=N2;ISYS=1#                      Get the psudo value              CU40  85
#                                                                       CU40  86
REPEAT#                                                                 CU40  87
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CU40  88
#                                                                       CU40  89
IF((NPSUDO>=3)&(ISYS!=6))#                                              CU40  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CU40  91
DO ISYS=1,5#                           Consider the c,h,r,t and o sys   CU40  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CU40  93
DO IPRIM=1,NPSUDO#                     Rows in turn and call them pri   CU40  94
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CU40  95
IF(NPSUDO<IPRIM+NDIR(ISYS)-1) BREAK#   If not enough rows are left,     CU40  96
#                                      No solution can be found, skip.  CU40  97
DO IFIRST=1,NIND(ISYS)#                Consider symmetry-unrelated pr   CU40  98
#                                      Axes to be matched with the prim CU40  99
#                                      Row.                             CU40 100
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CU40 101
DO ISEC=IPRIM+1,NPSUDO#                Pick up a secondary row          CU40 102
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CU40 103
IF(NPSUDO<ISEC+NDIR(ISYS)-2) BREAK#    If not enough rows are left, s   CU40 104
CALL CU31(HH(1,IPRIM),HH(1,ISEC),PRODOB,CRAP,5)# Get the angle betwee   CU40 105
#                                      The two selected rows.           CU40 106
DO ITWO=1,NDIR(ISYS)#                  Pick up a secondary even-order   CU40 107
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CU40 108
IF(ITWO==IFIRST)NEXT#                                                   CU40 109
#   CALCULATE THE ANGLE BETWEEN THE PRIMARY AND SECONDARY AXES          CU40 110
CALL CU31(LATIC(1,IFIRST,ISYS),LATIC(1,ITWO,ISYS),PROCAL,CRAP,5)#       CU40 111
IF(PRODOB*PROCAL<0.)#                  Try to match obs and calc angl   CU40 112
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CU40 113
DO I=1,3#                                                               CU40 114
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CU40 115
NH(I,ISEC)=-NH(I,ISEC);HH(I,ISEC)=-HH(I,ISEC)#                          CU40 116
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CU40 117
PRODOB=-PRODOB#                                                         CU40 118
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CU40 119
IF(ABS(PRODOB-PROCAL)>ACCEPT) NEXT#                                     CU40 120
#                                                                       CU40 121
#   THE ANGLES MATCH, TRY TO ASSOCIATE AN OBS ROW                       CU40 122
#   WITH EACH AXIS IN THE SYSTEM.                                       CU40 123
#                                                                       CU40 124
DO IANY=1,NDIR(ISYS)#                                                   CU40 125
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CU40 126
CALL CU31(LATIC(1,IFIRST,ISYS),LATIC(1,ITWO,ISYS),LATIC(1,IANY,$#       CU40 127
ISYS),HAND1,8)#                        Get the hand of ifirst, itwo,    CU40 128
#  CALCULATE ANGLE OF TRY AXIS WITH PRIMARY AND SECONDARY AXES          CU40 129
CALL CU31(LATIC(1,IFIRST,ISYS),LATIC(1,IANY,ISYS),PROC1,CRAP,5)#        CU40 130
CALL CU31(LATIC(1,ITWO,ISYS),LATIC(1,IANY,ISYS),PROC2,CRAP,5)#          CU40 131
DO ITRY=1,NPSUDO#                      Find a row that matches this a   CU40 132
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CU40 133
#                                      Get the hand of iprim, isec, itr CU40 134
CALL CU31(HH(1,IPRIM),HH(1,ISEC),HH(1,ITRY),HAND2,8)#                   CU40 135
CALL CU31(HH(1,ITRY),HH(1,IPRIM),PROD1,CRAP,5)#                         CU40 136
CALL CU31(HH(1,ITRY),HH(1,ISEC),PROD2,CRAP,5)#                          CU40 137
IF((ABS(PROC1-PROD1)<ACCEPT)&(ABS(PROC2-PROD2)<ACCEPT)$#                CU40 138
&(ABS(HAND2-HAND1)<.1))#                                                CU40 139
$(#                                    9>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CU40 140
MATCH(IANY)=ITRY; BREAK#               This row is ok, remember it      CU40 141
$)#                                    9<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CU40 142
IF((ABS(PROC1+PROD1)<ACCEPT)&(ABS(PROC2+PROD2)<ACCEPT)$#                CU40 143
&(ABS(HAND2+HAND1)<.1))#                                                CU40 144
$(#                                    9>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CU40 145
MATCH(IANY)=-ITRY; BREAK#              This row is ok, remember it      CU40 146
$)#                                    9<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CU40 147
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CU40 148
IF(ITRY==NPSUDO+1) BREAK#                                               CU40 149
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CU40 150
#                                                                       CU40 151
#   WE WERE ABLE TO ASSOCIATE A ROW WITH EACH AXIS IN THE SYSTEM        CU40 152
#                                                                       CU40 153
IF(IANY==1+NDIR(ISYS))#                                                 CU40 154
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CU40 155
#                                                                       CU40 156
MATMAX=0#                              Find the worst-fitting row       CU40 157
DO I=1,NDIR(ISYS); IF(ABS(MATCH(I))>MATMAX)MATMAX=ABS(MATCH(I))#        CU40 158
IP=2#                                                                   CU40 159
IF(AANG(MATMAX)<EXPER)IP=1#            Fit within experimental accura   CU40 160
#                                                                       CU40 161
#   FIND THE CONVENTIONAL REFERENCE AXES AMONG THE SYMMETRY AXES        CU40 162
#                                                                       CU40 163
DO I=1,NAMBI(ISYS)+1#                                                   CU40 164
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CU40 165
DO J=1,3#                                                               CU40 166
$(#                                    9>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CU40 167
IAX=MAXES(J+3*I+6*ISYS-9)#                                              CU40 168
#                                                                       CU40 169
#   FIND THE Z AXIS IN HEXAGONAL R                                      CU40 170
#                                                                       CU40 171
IF(IAX>NDIR(ISYS))#                                                     CU40 172
$(#                                    *>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CU40 173
CALL CU31(LATIC(1,IAX,ISYS),LATIC(1,IFIRST,ISYS),SAL1,CRAP,5)#          CU40 174
CALL CU31(LATIC(1,IAX,ISYS),LATIC(1,ITWO,ISYS),SAL2,CRAP,5)#            CU40 175
BEST=2.#                                                                CU40 176
DO I1=1,4#                                                              CU40 177
$(#                                    *>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CU40 178
IH(1)=I1-1#                                                             CU40 179
DO I2=1,7#                                                              CU40 180
$(#                                    *>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CU40 181
IH(2)=I2-4#                                                             CU40 182
DO I3=1,7#                                                              CU40 183
$(#                                    *>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CU40 184
IH(3)=I3-4#                                                             CU40 185
CALL CU34(IH,KA,3)#                                                     CU40 186
IF(KA!=0) NEXT#                                                         CU40 187
HI(1) = IH(1); HI(2)=IH(2); HI(3)=IH(3)#                                CU40 188
CALL CU31(AA,HI,H,CRAP,3)#                                              CU40 189
CALL CU31(H,HH(1,IPRIM),SCAL1,CRAP,5)#                                  CU40 190
CALL CU31(H,HH(1,ISEC),SCAL2,CRAP,5)#                                   CU40 191
IS=1#                                                                   CU40 192
IF(ABS(SCAL2)>ABS(SCAL1)) IF(SAL2*SCAL2<0)IS=-1#                        CU40 193
ELSE IF(SAL1*SCAL1<0)IS=-1#                                             CU40 194
IF(ABS(SAL1-IS*SCAL1)>BEST) NEXT#                                       CU40 195
IF(ABS(SAL2-IS*SCAL2)>BEST) NEXT#                                       CU40 196
BEST=ABS(SAL1-IS*SCAL1)#                                                CU40 197
IF(ABS(SAL2-IS*SCAL2)>BEST)BEST=ABS(SAL2-IS*SCAL2)#                     CU40 198
ISG=IS#                                                                 CU40 199
DO II1=1,3; HH(II1,NPSUDO+1)=H(II1)#                                    CU40 200
DO II1=1,3; NH(II1,NPSUDO+1)=IH(II1)#                                   CU40 201
$)#                                    *<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CU40 202
$)#                                    *<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CU40 203
$)#                                    *<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CU40 204
CALL CU31(LATIC(1,IFIRST,ISYS),LATIC(1,ITWO,ISYS),$#                    CU40 205
LATIC(1,IAX,ISYS),DET1,8)#                                              CU40 206
CALL CU31(HH(1,IPRIM),HH(1,ISEC),HH(1,NPSUDO+1),DET2,8)#                CU40 207
IF(ABS(SAL1)<(.01)&ABS(SAL2)<(.01)&$#                                   CU40 208
ABS(DET1-ISG*DET2)>(0.1))ISG=-ISG#                                      CU40 209
MATCH(IAX)=(NPSUDO+1)*ISG#                                              CU40 210
#                                                                       CU40 211
$)#                                    *<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CU40 212
#                                                                       CU40 213
NAX=IABS(MATCH(IAX)); IS=1#                                             CU40 214
IF(MATCH(IAX)<0)IS=-1#                                                  CU40 215
#   STORE THE DIRECTION COSINES AND THE PRIMITIVE INDICES               CU40 216
#   OF THE CONVENTIONAL AXES.                                           CU40 217
DO K=1,3#                                                               CU40 218
$(#                                    *>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CU40 219
VEC(K,J,I)=IS*HH(K,NAX);MAT(K,J,I)=IS*NH(K,NAX)#                        CU40 220
$)#                                    *<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CU40 221
CALL CU31(AA,MAT(1,J,I),ENGTH(J,I),CRAP,6)# Length convential cell ed   CU40 222
$)#                                    9<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CU40 223
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CU40 224
TOT(2)=1.E6#                           Keep the solution with the       CU40 225
DO I=1,NAMBI(ISYS)+1#                  Shortest cell edges.             CU40 226
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CU40 227
TOT(I)=0#                                                               CU40 228
DO J=1,3; TOT(I)=TOT(I)+ENGTH(J,I)#                                     CU40 229
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CU40 230
I=1; IF(TOT(2)<TOT(1))I=2#                                              CU40 231
#                                                                       CU40 232
#  RANK THE ORTHORHOMBIC AXES A<B<C                                     CU40 233
#                                                                       CU40 234
IF(ISYS==5)#                                                            CU40 235
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CU40 236
REPEAT#                                                                 CU40 237
$(#                                    9>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CU40 238
IPERM=0#                                                                CU40 239
DO J=1,2#                                                               CU40 240
$(#                                    *>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CU40 241
IF(ENGTH(J,I)<=ENGTH(J+1,I)) NEXT#                                      CU40 242
IPERM=1; SAVE=ENGTH(J,I)#                                               CU40 243
ENGTH(J,I)=ENGTH(J+1,I); ENGTH(J+1,I)=SAVE#                             CU40 244
DO KA=1,3#                                                              CU40 245
$(#                                    *>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CU40 246
ISAVE=MAT(KA,J,I); MAT(KA,J,I)=MAT(KA,J+1,I)#                           CU40 247
MAT(KA,J+1,I)=ISAVE; SAVE=VEC(KA,J,I)#                                  CU40 248
VEC(KA,J,I)=VEC(KA,J+1,I); VEC(KA,J+1,I)=SAVE#                          CU40 249
MAT(KA,5-2*J,I)=-MAT(KA,5-2*J,I)#                                       CU40 250
VEC(KA,5-2*J,I)=-VEC(KA,5-2*J,I)#                                       CU40 251
$)#                                    *<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CU40 252
$)#                                    *<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CU40 253
IF(IPERM==0)BREAK#                                                      CU40 254
$)#                                    9<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CU40 255
#                                                                       CU40 256
GO TO 152#                                                              CU40 257
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CU40 258
#                                                                       CU40 259
#   PUT THE RHOMBOHEDRAL LATTICE IN THE OBVERSE SETTING                 CU40 260
#                                                                       CU40 261
IF(ISYS!=3)GO TO 152#                                                   CU40 262
CALL CU31(MAT(1,1,I),MAT(1,2,I),MAT(1,3,I),DET,8)#                      CU40 263
IF(ABS(3.-DET)<0.1)#                                                    CU40 264
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CU40 265
DO JJ=1,2#                                                              CU40 266
$(#                                    9>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CU40 267
CALL CU31(MAT(1,1,I),ATM1,CRAP,CRAP,11)#                                CU40 268
CALL CU31(TEST,ATM1,RESULT,CRAP,10)#                                    CU40 269
IFLAK=0#                                                                CU40 270
DO J=1,3#                                                               CU40 271
$(#                                    *>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CU40 272
ITEST=ABS(RESULT(J))+.1#                                                CU40 273
IF(ABS(ITEST-ABS(RESULT(J)))>.1)#                                       CU40 274
$(#                                    *>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CU40 275
IFLAK=1#                                                                CU40 276
DO JA=1,2; DO JB=1,3; MAT(JB,JA,I)=-MAT(JB,JA,I)#                       CU40 277
$)#                                    *<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CU40 278
$)#                                    *<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CU40 279
IF (IFLAK==0)GO TO 152#                                                 CU40 280
$)#                                    9<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CU40 281
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CU40 282
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CU40 283
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CU40 284
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CU40 285
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CU40 286
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CU40 287
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CU40 288
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CU40 289
#                                                                       CU40 290
#   MONOCLINC AND TRICLINIC ARE TREATED SEPARATELY BECAUSE THEIR        CU40 291
#   CONVENTIONAL AXES ARE NOT DETERMINED BY SYMMETRY.                   CU40 292
#                                                                       CU40 293
IF(NPSUDO>=1)#                         Monoclinic                       CU40 294
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CU40 295
ISYS=6; NPSUDO=1#                                                       CU40 296
ENGTH(1,1)=10000; ENGTH(3,1)=10000#                                     CU40 297
N=NPSUDO; SCALI=SIN(DAR*AANG(N))+.05#                                   CU40 298
MATMAX=N; IP=2#                                                         CU40 299
IF(AANG(N)<EXPER)IP=1#                                                  CU40 300
DO KA=1,3#                                                              CU40 301
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 CU40 302
MAT(KA,2,1)=NH(KA,N); VEC(KA,2,1)=HH(KA,N)#                             CU40 303
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CU40 304
CALL CU31(AA,MAT(1,2,1),ENGTH(2,1),CRAP,6)#                             CU40 305
DO I1=1,3#                                                              CU40 306
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 CU40 307
IH(1)=I1-1#                                                             CU40 308
DO I2=1,5#                                                              CU40 309
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 CU40 310
IH(2)=I2-3#                                                             CU40 311
DO I3=1,5#                                                              CU40 312
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 CU40 313
IH(3)=I3-3#                                                             CU40 314
CALL CU34(IH,KA,2)#                                                     CU40 315
IF(KA!=0) NEXT#                                                         CU40 316
HI(1)=IH(1); HI(2)=IH(2); HI(3)=IH(3)#                                  CU40 317
CALL CU31(AA,HI,H,CRAP,3)#                                              CU40 318
CALL CU31(H,VEC(1,2,1),SCAL,CRAP,5)#                                    CU40 319
IF(ABS(SCAL)>SCALI) NEXT#                                               CU40 320
CALL CU31(AA,HI,GTH,CRAP,6)#                                            CU40 321
IF((GTH>ENGTH(1,1))\(ENGTH(3,1)>ENGTH(1,1)))#                           CU40 322
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 CU40 323
IF(GTH>ENGTH(3,1)) NEXT#                                                CU40 324
K=3#                                                                    CU40 325
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 CU40 326
ELSE#                                                                   CU40 327
K=1#                                                                    CU40 328
#                                                                       CU40 329
DO KA=1,3#                                                              CU40 330
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 CU40 331
MAT(KA,K,1)=IH(KA); VEC(KA,K,1)=H(KA)#                                  CU40 332
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 CU40 333
ENGTH(K,1)=GTH#                                                         CU40 334
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 CU40 335
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 CU40 336
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 CU40 337
IF(ENGTH(3,1)<ENGTH(1,1))#             Convention a shorter than c      CU40 338
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 CU40 339
DO KA=1,3#                                                              CU40 340
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 CU40 341
ISAVE=MAT(KA,1,1); MAT(KA,1,1)=MAT(KA,3,1)#                             CU40 342
MAT(KA,3,1)=ISAVE; SAVE=VEC(KA,1,1)#                                    CU40 343
VEC(KA,1,1)=VEC(KA,3,1); VEC(KA,3,1)=SAVE#                              CU40 344
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 CU40 345
SAVE=ENGTH(1,1); ENGTH(1,1)=ENGTH(3,1)#                                 CU40 346
ENGTH(3,1)=SAVE#                                                        CU40 347
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 CU40 348
CALL CU31(VEC(1,1,1),VEC(1,3,1),SCAL,CRAP,5)#                           CU40 349
IF(SCAL>0.)#                                                            CU40 350
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 CU40 351
DO KA=1,3#                                                              CU40 352
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 CU40 353
MAT(KA,1,1)=-MAT(KA,1,1)#                                               CU40 354
VEC(KA,1,1)=-VEC(KA,1,1)#                                               CU40 355
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 CU40 356
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 CU40 357
CALL CU31(VEC(1,1,1),VEC(1,2,1),VEC(1,3,1),DET,8)#                      CU40 358
IF(DET<=0.)#                                                            CU40 359
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 CU40 360
DO KA=1,3#                                                              CU40 361
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 CU40 362
VEC(KA,2,1)=-VEC(KA,2,1)#                                               CU40 363
MAT(KA,2,1)=-MAT(KA,2,1)#                                               CU40 364
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 CU40 365
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 CU40 366
I=1;    GO TO 152#                                                      CU40 367
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CU40 368
#                                                                       CU40 369
#  TRICLINIC                                                            CU40 370
#                                                                       CU40 371
ISYS=7; IP=1; I=1; MATMAX=20; AANG(20)=0#                               CU40 372
DO N=1,3#                                                               CU40 373
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 CU40 374
DO J=1,3; MAT(J,N,1)=0#                                                 CU40 375
MAT(N,N,1)=1#                                                           CU40 376
CALL CU31(AA,MAT(1,N,1),VEC(1,N,1),CRAP,3)#                             CU40 377
CALL CU31(AA,MAT(1,N,1),ENGTH(N,1),CRAP,6)#                             CU40 378
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 CU40 379
GO TO 152#                                                              CU40 380
#                                                                       CU40 381
#                                                                       CU40 382
#  CALCULATE CELL ANGLES, LATTICE MODE AND OUTPUT                       CU40 383
#                                                                       CU40 384
152     CONTINUE#                                                       CU40 385
#                                                                       CU40 386
DO J=1,3#                                                               CU40 387
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 CU40 388
L=MOD(J,3)+1#                                                           CU40 389
CALL CU31(VEC(1,L,I),VEC(1,6-J-L,I),SCAL,CRAP,5)#                       CU40 390
ALP(J)=ACOS(SCAL)/DAR#                                                  CU40 391
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 CU40 392
CALL CU32(MAT(1,1,I),MODE)#            Get lattice mode of convent ce   CU40 393
movechar:(PSUDX,12*IP-11,CHROT,2,12,0)# Pseudo/metrically               CU40 394
movechar:(SYSTM,12*ISYS-11,CHROT,14,12,0)# System                       CU40 395
movechar:(MODE,1,CHROT,28,1,0)#        Lattice mode                     CU40 396
movechar:(DELTA,1,CHROT,33,9,0)#       Max delta                        CU40 397
ncodefld:(AANG(MATMAX),1,CHROT,521032.,1)#                              CU40 398
writeline:(1,0,0,1,3)#                                                  CU40 399
#                                                                       CU40 400
CALL CU31(MAT(1,1,I),ATM1,CRAP,CRAP,11)# Get the original axes of       CU40 401
CALL CU31(ATM1,TRANS,ATM2,CRAP,2)#     The conventional cell            CU40 402
CALL CU31(ATM2,ATM1,CRAP,CRAP,1)#      Original indices of con recip    CU40 403
DO J=1,3#                                                               CU40 404
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 CU40 405
DO K=1,3; BUFOT(K)=ATM2(J,K)#                                           CU40 406
BUFOT(4)=ENGTH(J,I);BUFOT(5)=ALP(J)#                                    CU40 407
DO K=1,3; BUFOT(K+5)=ATM1(K,J)#                                         CU40 408
IF (J==1) movechar:(CU401,1,CHROT,1,NCU401,0)#                          CU40 409
IF (J==2) movechar:(CU402,1,CHROT,1,NCU402,0)#                          CU40 410
IF (J==3) movechar:(CU403,1,CHROT,1,NCU403,0)#                          CU40 411
ncodefld:(BUFOT,1,CHROT,FMT,8)#                                         CU40 412
writeline:(0,0,0,1,3)#                                                  CU40 413
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 CU40 414
IF(IP==1) BREAK#                       Stop after finding exact soln    CU40 415
NPSUDO=MATMAX-1#                       Search for a better solution     CU40 416
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CU40 417
#                                                                       CU40 418
RETURN#                                                                 CU40 419
END#                                                                    CU40 420
systemheader:(CU50)#                   (pseudo) merohedral twin laws    CU50   1
#********************************************************************** CU50   2
#                                                                       CU50   3
#                                CU50                                   CU50   4
#                                                                       CU50   5
#********************************************************************** CU50   6
SUBROUTINE CU50#                                                        CU50   7
include:(AACOMN)#                                                       CU50   8
include:(CUCOMN)#                                                       CU50   9
#                                                                       CU50  10
REAL    CRAP(3,3)#                     Dummy variable                   CU50  11
REAL    DET#                           Determinant                      CU50  12
REAL    HD(3,3)#                                                        CU50  13
REAL    HKLLAW(288)#                   Twin law on hkl's                CU50  14
INTEGER I,J,K,L#                       Odd integer variables            CU50  15
INTEGER IFLKP,IFLKN#                   Positive/negative acceptance m   CU50  16
INTEGER MMERX#                                                          CU50  17
INTEGER NMERX#                         No. of lattice symm ops          CU50  18
INTEGER NMERO#                         Count of twin operators          CU50  19
REAL    TEST(9)#                       Test vector                      CU50  20
REAL    TWINLW(288)#                   Space twin law operations        CU50  21
INTEGER USEDHL(24)#                    Status of holohedral ops         CU50  22
INTEGER   OPP,PSIZE#                   Bdf handling variables           CU50  23
#                                                                       CU50  24
intdata:(IHOLST,[1,217,217,1,1,1,1])#  Limits for first transfer        CU50  25
intdata:(JHOLST,[0,0,289,91,0,0,0])#   Limits for second transfer       CU50  26
intdata:(NMHOL,[24,12,6,8,4,2,1])#     No. of holohedral symm ops       CU50  27
intdata:(NFHOL,[24,12,4,6,4,2,1])#     Limiting counter                 CU50  28
chardata:(CU104," (Pseudo-)Merohedral Twinning Operations=")#           CU50  29
chardata:(CU105," If the space group is non-centrosymmetric $#          CU50  30
each operation below implies")#                                         CU50  31
chardata:(CU106," two - i.e. the given operation multiplied by $#       CU50  32
+1 and -1")#                                                            CU50  33
chardata:(CU107," Twin x = (XXX.XX   XXX.XX   XXX.XX)x ;    $#          CU50  34
Twin h = (XXX.XX   XXX.XX   XXX.XX)h")#                                 CU50  35
chardata:(CU108,"xyzhkl")#                                              CU50  36
realdata:(FMT,[170622.,260622.,350622.,590622.,680622.,770622.])#       CU50  37
realdata:(SHOLO,[1.,0.,0.,  0.,1.,0.,  0.,0.,1.,$#                      CU50  38
-1.,0.,0.,  0.,1.,0.,   0.,0.,-1.,$#                                    CU50  39
-1.,0.,0.,  0.,-1.,0.,  0.,0.,1.,$#                                     CU50  40
1.,0.,0.,   0.,-1.,0.,  0.,0.,-1.,$#                                    CU50  41
0.,1.,0.,   1.,0.,0.,   0.,0.,-1.,$#                                    CU50  42
0.,-1.,0.,  -1.,0.,0.,  0.,0.,-1.,$#                                    CU50  43
-1.,0.,0.,  0.,0.,1.,   0.,1.,0.,$#                                     CU50  44
-1.,0.,0.,  0.,0.,-1.,  0.,-1.,0.,$#                                    CU50  45
0.,0.,1.,   0.,-1.,0.,  1.,0.,0.,$#                                     CU50  46
0.,0.,-1.,  0.,-1.,0.,  -1.,0.,0.,$#                                    CU50  47
0.,1.,0.,   -1.,0.,0.,  0.,0.,1.,$#                                     CU50  48
0.,-1.,0.,  1.,0.,0.,   0.,0.,1.,$#                                     CU50  49
0.,1.,0.,   0.,0.,1.,   1.,0.,0.,$#                                     CU50  50
0.,-1.,0.,  0.,0.,-1.,  1.,0.,0.,$#                                     CU50  51
0.,-1.,0.,  0.,0.,1.,   -1.,0.,0.,$#                                    CU50  52
0.,1.,0.,   0.,0.,-1.,  -1.,0.,0.,$#                                    CU50  53
0.,0.,1.,   1.,0.,0.,   0.,1.,0.,$#                                     CU50  54
0.,0.,-1.,  -1.,0.,0.,  0.,1.,0.,$#                                     CU50  55
0.,0.,-1.,  1.,0.,0.,   0.,-1.,0.,$#                                    CU50  56
0.,0.,1.,   -1.,0.,0.,  0.,-1.,0.,$#                                    CU50  57
1.,0.,0.,   0.,0.,-1.,  0.,1.,0.,$#                                     CU50  58
1.,0.,0.,   0.,0.,1.,   0.,-1.,0.,$#                                    CU50  59
0.,0.,-1.,  0.,1.,0.,   1.,0.,0.,$#                                     CU50  60
0.,0.,1.,   0.,1.,0.,   -1.,0.,0.,$#                                    CU50  61
1.,0.,0.,   0.,1.,0.,   0.,0.,1.,$#                                     CU50  62
0.,1.,0.,   1.,0.,0.,   0.,0.,-1.,$#                                    CU50  63
1.,0.,0.,   -1.,-1.,0., 0.,0.,-1.,$#                                    CU50  64
-1.,-1.,0., 0.,1.,0.,   0.,0.,-1.,$#                                    CU50  65
-1.,0.,0.,  0.,-1.,0.,  0.,0.,1.,$#                                     CU50  66
0.,-1.,0.,  -1.,0.,0.,  0.,0.,-1.,$#                                    CU50  67
-1.,0.,0.,  1.,1.,0.,   0.,0.,-1.,$#                                    CU50  68
1.,1.,0.,   0.,-1.,0.,  0.,0.,-1.,$#                                    CU50  69
0.,1.,0.,   -1.,-1.,0., 0.,0.,1.,$#                                     CU50  70
-1.,-1.,0., 1.,0.,0.,   0.,0.,1.,$#                                     CU50  71
0.,-1.,0.,  1.,1.,0.,   0.,0.,1.,$#                                     CU50  72
1.,1.,0.,   -1.,0.,0.,  0.,0.,1.])#                                     CU50  73
datastuff:#                                                             CU50  74
#                                                                       CU50  75
# ON ENTRY ISYS HAS 1, CUBIC; 2, HEXAGONAL; 3, RHOMBOHEDRAL             CU50  76
# (ON HEXAGONAL AXES); 4, TETRAGONAL; 5, ORTHORHOMBIC;                  CU50  77
# 6, MONOCLINIC; 7, TRICLINIC.                                          CU50  78
#                                                                       CU50  79
# COPY THE ELEMENTS OF THE HOLOHEDRAL CLASS INTO HOLOLW IN THE          CU50  80
# CONVENTIONAL ORIENTATION AND INCLUDE THE SPACE FOR THE TRANSLATIONAL  CU50  81
# PARTS WHICH WE DON'T NEED FOR TREATING TWINNING BUT WILL BECOME       CU50  82
# IMPORTANT IN THE SYMMETRY TESTING AND DISORDER.                       CU50  83
#                                                                       CU50  84
DO I=1,288; TWINLW(I)=0.0#             Clear away the twin law ops      CU50  85
NMERX=NMHOL(ISYS)#                     Number of holohedral operation   CU50  86
MMERX=NFHOL(ISYS)#                     Limiting counting                CU50  87
DO I=1,NMERX; USEDHL(I)=no:#           Mark holohedral ops as useable   CU50  88
K=0;J=IHOLST(ISYS)-1#                  Initialise counters for transf   CU50  89
DO I=1,MMERX#                          First set to copy                CU50  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CU50  91
USEDHL(I)=yes:#                        Its here and unused              CU50  92
DO L=1,9#                              9 elements per operation         CU50  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CU50  94
K=K+1;J=J+1;TWINLW(K)=SHOLO(J)#        Transfer elements                CU50  95
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CU50  96
K=K+3#                                 Leave space for translations     CU50  97
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CU50  98
J=JHOLST(ISYS)-1#                      Initialise counters for transf   CU50  99
DO I=MMERX+1,NMERX#                    Second set to copy               CU50 100
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CU50 101
USEDHL(I)=yes:#                        Its here and unused              CU50 102
DO L=1,9#                              9 elements per operation         CU50 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CU50 104
K=K+1;J=J+1;TWINLW(K)=SHOLO(J)#        Transfer elements                CU50 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CU50 106
K=K+3#                                 Leave space for translations     CU50 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CU50 108
CALL CU31(ATM2,HD,CRAP,CRAP,11)#       Prepare matrices for transform   CU50 109
CALL CU31(ATM1,ATM2,CRAP,CRAP,11)#     Of sym ops from conventional t   CU50 110
#                                      Input basis.                     CU50 111
DO I=1,NMERX#                          Transform the sym ops of the     CU50 112
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CU50 113
CALL CU31(HD,TWINLW(12*I-11),ATM1,CRAP,2)# Holohedral group from the    CU50 114
CALL CU31(ATM1,ATM2,TWINLW(12*I-11),CRAP,2)# Conven to input system.    CU50 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CU50 116
#                                                                       CU50 117
#  NOW CARRY OUT A LEFT COSET DECOMPOSITION OF THE HOLOHEDRAL           CU50 118
#  GROUP AGAINST THE ROTATIONAL PART OF THE DECLARED SPACE GROUP        CU50 119
#  SYMMETRY. ONCE AN OPERATOR IN THE HOLOHEDRAL CLASS HAS BEEN          CU50 120
#  ASSIGNED TO A COSET, IT USEDHL MARKER IS SET TO NO:                  CU50 121
#                                                                       CU50 122
DO I=1,NMERX#                          Run through the holohedral cla   CU50 123
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CU50 124
IF (USEDHL(I)==yes:)#                  Using unassigned operators.      CU50 125
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CU50 126
# THE OPERATOR POINTED TO BY I WILL BE ONE OF THE COSET REPRESENTATIVES CU50 127
# MARK THE OTHER ONES IN THIS COSET AS DELETED FROM THE HOLOHEDRAL GROU CU50 128
FOR(K=MARK2;K<STOP2;K=K+STEP2)#        Loop over symmetry matrices      CU50 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CU50 130
CALL CU31(TWINLW(12*I-11),QX(K+1),TEST,CRAP,2)#                         CU50 131
DO J=I+1,NMERX#                                                         CU50 132
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CU50 133
IF(USEDHL(J)==yes:)#                                                    CU50 134
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CU50 135
IFLKP=no:;IFLKN=no:#                   Positive/negative acceptance m   CU50 136
DO L=1,9; IF(ABS(TEST(L)-TWINLW(12*J+L-12))>0.01) IFLKP=yes:#           CU50 137
DO L=1,9; IF(ABS(TEST(L)+TWINLW(12*J+L-12))>0.01) IFLKN=yes:#           CU50 138
IF((IFLKP==no:)\(IFLKN==no:)) USEDHL(J)=no:#                            CU50 139
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CU50 140
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CU50 141
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CU50 142
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CU50 143
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CU50 144
NMERO=1#                               Set twin law count               CU50 145
DO I=2,NMERX#                          Loop to remove deleted operato   CU50 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CU50 147
IF (USEDHL(I)==yes:)#                  Twin law operator                CU50 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CU50 149
NMERO=NMERO+1#                         Count it                         CU50 150
movereal:(TWINLW,12*I-11,TWINLW,12*NMERO-11,9,1)# Copy it across        CU50 151
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CU50 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CU50 153
DO I=1,NMERO#                          Force determinant to +1          CU50 154
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CU50 155
CALL CU31(TWINLW(12*I-11),TWINLW(12*I-8),TWINLW(12*I-5),DET,8)#         CU50 156
IF(DET<0.0) DO J=1,9; TWINLW(12*I+J-12)=-TWINLW(12*I+J-12)#             CU50 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CU50 158
#                                                                       CU50 159
#  PRINT AND UPDATE THE BDF WITH THE TWIN LAWS                          CU50 160
#                                                                       CU50 161
PSIZE=13#                                                               CU50 162
writeline:(1,CU104,NCU104-1,3,3)#                                       CU50 163
movechar:(CU104,NCU104,CU104,2,NCU104-2,1)#                             CU50 164
writeline:(0,CU104,NCU104-1,3,3)#                                       CU50 165
writeline:(1,CU105,NCU105,3,3)#                                         CU50 166
writeline:(0,CU106,NCU106,3,3)#                                         CU50 167
DO I=1,NMERO#                                                           CU50 168
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CU50 169
CALL CU31(TWINLW(12*I-11),HKLLAW(12*I-11),CRAP,CRAP,1)# Get hkl law     CU50 170
writepkt:(2,lrtwin:,PSIZE,OPP)#        Write packet                     CU50 171
movereal:(HKLLAW,12*I-11,QX,OPP+1,9,0)# Put out twin law into bdf       CU50 172
DO J=1,4; QX(OPP+J+9)=0.0#             Volume fractions and esd's       CU50 173
IF (I==1) QX(OPP+10)=1.0#              Vol fract of parent component    CU50 174
#                                                                       CU50 175
writeline:(0,0,0,1,3)#                                                  CU50 176
DO J=1,3#                                                               CU50 177
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CU50 178
BUFOT(1)=TWINLW(12*I+J-12)#                                             CU50 179
BUFOT(2)=TWINLW(12*I+J-9)#                                              CU50 180
BUFOT(3)=TWINLW(12*I+J-6)#                                              CU50 181
DO K=1,3; BUFOT(K+3)=HKLLAW(12*I+3*J+K-15)#                             CU50 182
movechar:(CU108,J,CU107,7,1,0)#                                         CU50 183
movechar:(CU108,J,CU107,37,1,0)#                                        CU50 184
movechar:(CU108,J+3,CU107,49,1,0)#                                      CU50 185
movechar:(CU108,J+3,CU107,79,1,0)#                                      CU50 186
ncodefld:(BUFOT,1,CU107,FMT,6)#                                         CU50 187
writeline:(0,CU107,NCU107,3,3)#                                         CU50 188
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CU50 189
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CU50 190
#                                                                       CU50 191
copyfile:(1,2,incr:(lrtwin:),endrecord:)# Finish off file               CU50 192
#                                                                       CU50 193
RETURN#                                                                 CU50 194
END#                                                                    CU50 195
pmacro:([no:])#                                                         CU50 196
