systemheader:(CV    )#                                                  CV     1
####################################################################### CV     2
#                                                                     # CV     3
#                           *** CONVOL ***                            # CV     4
#                                                                     # CV     5
#     CONVOL PREPARES A BDF WHICH CONTAINS IN RECORD LRREFL:          # CV     6
#     COEFFICIENTS AND PHASES NECESSARY FOR CALCULATING A FOURIER.    # CV     7
#                                                                     # CV     8
####################################################################### CV     9
#                                                                       CV    10
include:(XMACRO)#                                                       CV    11
#                                                                       CV    12
macro:(rejfaz:,[$#                     Macro to decide if a reflec.     CV    13
IPTR = IPT + $1#                       Should be rejected because       CV    14
ifvo:(QX(IPTR))$(#                     Of missing phase data            CV    15
NREJPH = NREJPH + 1.#                  Count rejections                 CV    16
NEXT $)])#                                                              CV    17
macro:(bigf:,1000000.)#                Largest magnitude of f allow     CV    18
macro:(chtotl:,[arith:(12,*,maxset:)])# Max characters in dset array    CV    19
macro:(fnmb:,1304.)#                   Lrrefl: idnum for frel           CV    20
#                                                                       CV    21
# INDICES TO INPUT LRREFL: WANT LIST AND OFFSET ARRAYS                  CV    22
# ** MUST READ ALL POSSIBLE FORMS OF F AND SIG(F) **                    CV    23
macro:(indxf11:,4)#                    F(+) data set one                CV    24
macro:(indxf11s:,5)#                   F(+)**2  data set one            CV    25
macro:(indxcos:,6)#                    Cos of phase angle               CV    26
macro:(indxsin:,7)#                    Sin of phase angle               CV    27
macro:(indxsg11:,8)#                   Sigma((f+)) data set one         CV    28
macro:(indxss11:,9)#                   Sigma((f+)**2) data set one      CV    29
macro:(indxfc:,10)#                    F(calc)                          CV    30
macro:(indxfaz:,11)#                   Phase angle (cycles)             CV    31
#                                                                       CV    32
macro:(maxset:,20)#                    Maximum no. data sets on bdf     CV    33
macro:(maxwant:,11)#                   Max. number of required          CV    34
#                                         Lrrefl: items.                CV    35
macro:(nmbfp:,304)#                    F(+) catalog no.                 CV    36
macro:(nmbsigp:,303)#                  Sigma(f(+)**2) catalog no.       CV    37
macro:(nmbfc:,800)#                    F(calc) catalog no.              CV    38
macro:(nmbfaz:,700)#                   Phase catalog no.                CV    39
macro:(phnmbcos:,1801.)#               Idnums for cos(phase)            CV    40
macro:(phnmbsin:, 1802.)#              Idnums for sin(phase)            CV    41
macro:(phnmbfaz:,1700.)#               Idnums for phase (cycles)        CV    42
macro:(phnmbfc:, 1800.)#               Idnums for fc                    CV    43
#                                                                       CV    44
extrude:(CVCOMN)#                                                       CV    45
COMMON/COMICV/ BIGIH, ENDSYM,$#                                         CV    46
FTYPE, FSQD,   FSQP,$#                                                  CV    47
IH1, IH2, IH3, LMOD,$#                                                  CV    48
NSET1, SMALIH, STARTS,$#                                                CV    49
TOTCHR, USEFAZ#                                                         CV    50
#                                                                       CV    51
INTEGER BIGIH(3)#                      Maximum hkl limits               CV    52
INTEGER ENDSYM#                        Last indx in symops 'array'      CV    53
INTEGER FSQD#                          Yes: if deriv f**2 in dbf        CV    54
INTEGER FSQP#                          Yes: if parent f**2 in dbf       CV    55
INTEGER FTYPE#                         1 - 7 depending on specified     CV    56
#                                         Function type                 CV    57
INTEGER IH1, IH2, IH3#                 Permutation order of hkl         CV    58
INTEGER LMOD#                          Print every lmod reflection      CV    59
INTEGER NSET1#                         Data set key for 1st data se     CV    60
INTEGER SMALIH(3)#                     Minimum hkl limits               CV    61
INTEGER STARTS#                        Start indx of symops 'array'     CV    62
INTEGER TOTCHR#                        Number of characters in all      CV    63
#                                         The data set names on the bdf CV    64
INTEGER USEFAZ#                        Yes: if phase is on bdf          CV    65
#                                                                       CV    66
COMMON/COMFCV/ A, AINP, AOUT, B,$#                                      CV    67
BINP, BOUT, BIGF1, BIGST,$#                                             CV    68
FAZINP, FAZOUT, FCINP, FCOUT, H,$#                                      CV    69
NREJF1,NREJH,NREJPH,$#                                                  CV    70
NREJSC,NREJSF,NREJST,NREJV1,NRFIN,$#                                    CV    71
NRFOUT, PI ,SCALE, SIGKF, SITOL,$#                                      CV    72
SMALF1,SMALST, X0#                                                      CV    73
#                                                                       CV    74
REAL    A#                             Constant used in functions       CV    75
REAL    AINP#                          A(calc) input into function      CV    76
REAL    AOUT#                          A(calc) output from function     CV    77
REAL    B(3)#                          Constants used in functions      CV    78
REAL    BIGF1#                         Maximum limit on f for data      CV    79
#                                         Set 1.                        CV    80
REAL    BIGST#                         Maximum sitol limit              CV    81
REAL    BINP#                          B(calc) input into function      CV    82
REAL    BOUT#                          B(calc) output from function     CV    83
REAL    FAZINP#                        Phase input into function        CV    84
REAL    FAZOUT#                        Phase output from function       CV    85
REAL    FCINP#                         F(calc) input into function      CV    86
REAL    FCOUT#                         F(calc) output from function     CV    87
REAL    H(3)#                          H, k, l                          CV    88
#                                                       Coeff. range    CV    89
REAL    NREJF1#                        F-range, set 1                   CV    90
REAL    NREJH#                         H,k,l range                      CV    91
REAL    NREJPH#                        Void phase                       CV    92
REAL    NREJSC#                        K*sigma, coeff.                  CV    93
REAL    NREJSF#                        K*sigma, fobs                    CV    94
REAL    NREJST#                        Sitol range                      CV    95
REAL    NREJV1#                        F void, set 1                    CV    96
REAL    NRFIN#                         No. refls. on input bdf          CV    97
REAL    NRFOUT#                        No. refls. on output bdf         CV    98
REAL    PI#                            Constant pi                      CV    99
REAL    SCALE#                         Overall scale for coefficien     CV   100
REAL    SIGKF#                         K in k*sigma(f) limit            CV   101
REAL    SITOL#                         Sine(theta)/lambda               CV   102
REAL    SMALF1#                        Minimum limit on f-rel for       CV   103
#                                         Data set 1.                   CV   104
REAL    SMALST#                        Minimum sitol limit              CV   105
REAL     X0(3)#                        User supplied origin             CV   106
#                                                                       CV   107
COMMON/COMCCV/DSETID, IDSET1#                                           CV   108
#                                                                       CV   109
string:(DSETID,chtotl:)#               Data set id's from bdf           CV   110
string:(IDSET1,12)#                    Id for data set one              CV   111
endext:#                                                                CV   112
#                                                                       CV   113
systemheader:(CV00)#                                                    CV00   1
####################################################################### CV00   2
#                                                                     # CV00   3
#                              CV00                                   # CV00   4
#                                                                     # CV00   5
####################################################################### CV00   6
SUBROUTINE CV00#                                                        CV00   7
#                                                                       CV00   8
#   SUBROUTINE          FUNCTION                                        CV00   9
#       CV00    ROOT SEGMENT, CALLS CV10,CV20,CV30,CV40                 CV00  10
#       CV10    PROCESS BDF LOGICAL RECORDS UP TO LRREFL:               CV00  11
#       CV20    READ ALL LINE INPUT                                     CV00  12
#       CV21    PROCESS FUNCTION LINES                                  CV00  13
#       CV25    PROCESS SCALE LINE                                      CV00  14
#       CV27    PROCESS LIMHKL, LIMSTL, LIMD, AND LIMF  LINES           CV00  15
#       CV30    CALL FUNCTION ROUTINES (ACCORDING TO FTYPE)             CV00  16
#               AND CALCULATE COEFFICIENTS                              CV00  17
#       CV31    APPLY FUNCTION 1.2                                      CV00  18
#       CV32    APPLY FUNCTION 2.2                                      CV00  19
#       CV33    APPLY FUNCTION 3.1                                      CV00  20
#       CV34    APPLY FUNCTION 3.2                                      CV00  21
#       CV35    APPLY FUNCTION 3.3                                      CV00  22
#       CV36    APPLY FUNCTION 4                                        CV00  23
#       CV37    APPLY FUNCTION 5                                        CV00  24
#       CV40    SUMMARIZE, CLOSE BDF                                    CV00  25
#       CV52    APPLY SITOL AND HKL LIMITS                              CV00  26
#       CV54    LIST REFLECTION COUNTS                                  CV00  27
#       CV55    FIND CENTRIC REFLECTIONS                                CV00  28
#       CV56    LIST REFLECTIONS TO OUTPUT LOG                          CV00  29
#                                                                       CV00  30
# TO ADD ADDITIONAL FUNCTIONS, MAKE PROVISIONS FOR SPECIFYING THEM      CV00  31
#  ON THE LINE INPUT EITHER IN ROUTINE CV21 OR IN A NEW ROUTINE,        CV00  32
#  CV22.  IN EITHER CASE, SET THE VARIABLE FTYPE ACCORDINGLY.           CV00  33
#  CHANGE ROUTINE CV30 TO BRANCH APPROPRIATELY ON FTYPE.                CV00  34
#                                                                       CV00  35
include:(AACOMN)#                                                       CV00  36
include:(CVCOMN)#                                                       CV00  37
#                                                                       CV00  38
CALL CV10#                             Reserve storage, input           CV00  39
#                                         Logical records 1 to lrrefl:. CV00  40
CALL CV20#                             Read line input                  CV00  41
CALL CV30#                             Make coefficients                CV00  42
CALL CV40#                             Summary                          CV00  43
RETURN#                                                                 CV00  44
END#                                                                    CV00  45
systemheader:(CV10)#                   Process records up to lrrefl     CV10   1
####################################################################### CV10   2
#                                                                     # CV10   3
#                              CV10                                   # CV10   4
#                                                                     # CV10   5
####################################################################### CV10   6
SUBROUTINE CV10#                                                        CV10   7
include:(AACOMN)#                                                       CV10   8
include:(CVCOMN)#                                                       CV10   9
#                                                                       CV10  10
INTEGER I,J,K#                         An index                         CV10  11
INTEGER IPT#                           Pointer to qx for bdf input      CV10  12
INTEGER JPT#                           Pointer to qx for bdf output     CV10  13
INTEGER NCENT#                         Centric/acentric = 0/1           CV10  14
INTEGER NROT#                          Number of rotat. matrices        CV10  15
INTEGER PSIZE#                         Input packet size                CV10  16
#                                                                       CV10  17
# LAY OUT STORAGE                                                       CV10  18
# ---------------                                                       CV10  19
#                                                                       CV10  20
IOMARK(1) = QXSTR#                     Buffer for input bdf             CV10  21
IOMARK(2) = IOMARK(1) + bdfbuf:#       Buffer for output bdf            CV10  22
STARTS    = IOMARK(2) + bdfbuf:#       Mark end of i/o buffers          CV10  23
incrqx:(I,STARTS+1,CV1001)#            Die if there is not enough.      CV10  24
#                                                                       CV10  25
# COPY UP TO LRSYMM:                                                    CV10  26
# ------------------                                                    CV10  27
#                                                                       CV10  28
copyfile:(1,2,1,decr:(lrsymm:))#                                        CV10  29
readwpkt:(1,lrsymm:,PSIZE,IPT,0)#      Read index packet for symm.      CV10  30
writepkt:(2,lrsymm:,PSIZE,JPT)#        Write index packet for symm.     CV10  31
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#  Copy ip to op buffer             CV10  32
NCENT = NINT(QX(IPT+2))#               Centric/acentric = 0/1           CV10  33
NROT = NINT(QX(IPT+4))#                Get number of rotat. matrice     CV10  34
incrqx:(ENDSYM,STARTS+NROT*12*(2-NCENT),$# Bf                           CV10  35
        CV1001)#                       Expand qx to hold symops         CV10  36
FOR (J=STARTS; J>0; J=J+12)#           Loop over symops                 CV10  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CV10  38
readwpkt:(1,lrsymm:,PSIZE,IPT,0)#      Read next symm packet            CV10  39
IF (IPT<=0 ) BREAK#                    Jump out after last packet       CV10  40
writepkt:(2,lrsymm:,PSIZE,JPT)#        Write index packet for symm.     CV10  41
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#  Copy ip to op buffer             CV10  42
movereal:(QX,IPT+1,QX,J+1,PSIZE,1)#    Store the symops                 CV10  43
IF (NCENT==0)#                         Center symmetry?                 CV10  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CV10  45
K = J#                                                                  CV10  46
FOR (I=STARTS; I<J; I=I+1)#                                             CV10  47
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CV10  48
K=K+1; QX(K)= -QX(I+1)#                Generate thru center             CV10  49
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CV10  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CV10  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CV10  52
#                                                                       CV10  53
# COPY UP TO LRDDEF:                                                    CV10  54
# ------------------                                                    CV10  55
#                                                                       CV10  56
copyfile:(1,2,incr:(lrsymm:),decr:(lrddef:))# Soak up the rest          CV10  57
TOTCHR = 0#                            Number of characters in data     CV10  58
movechar:(BLANK,1,DSETID,1,chtotl:,1)## Initialize id's to blanks       CV10  59
I=-11#                                                                  CV10  60
#                                                                       CV10  61
# PROCESS LRDDEF: DATA (READ IN DATA SET NAMES)                         CV10  62
# ---------------------------------------------                         CV10  63
#                                                                       CV10  64
REPEAT#                                                                 CV10  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CV10  66
I=I+12#                                                                 CV10  67
readwpkt:(1,lrddef:,PSIZE,IPT,0)#                                       CV10  68
IF(IPT <= 0)  BREAK#                                                    CV10  69
writepkt:(2,lrddef:,PSIZE,JPT)#        Copy to output                   CV10  70
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#                                   CV10  71
TOTCHR = TOTCHR + 12#                  Increment character counter      CV10  72
movertoc:(QX(IPT+1),1,DSETID,I,12,0)#  Collect all data set id's        CV10  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CV10  74
#                                                                       CV10  75
# COPY UP TO LRREFL:                                                    CV10  76
# -------------------                                                   CV10  77
#                                                                       CV10  78
copyfile:(1,2,incr:(lrddef:),decr:(lrrefl:))#                           CV10  79
#                                                                       CV10  80
RETURN#                                                                 CV10  81
END#                                                                    CV10  82
systemheader:(CV20)#                                                    CV20   1
####################################################################### CV20   2
#                                                                     # CV20   3
#                              CV20                                   # CV20   4
#                                                                     # CV20   5
####################################################################### CV20   6
SUBROUTINE CV20#                       Input and call processing        CV20   7
include:(AACOMN)#                                                       CV20   8
include:(CVCOMN)#                                                       CV20   9
#                                                                       CV20  10
INTEGER I#                             Loop index                       CV20  11
INTEGER FIRST#                         Pointer to initial char          CV20  12
INTEGER LASTP1#                        Pointer to final char plus 1     CV20  13
INTEGER NCHAR#                         No. char in input field          CV20  14
#                                                                       CV20  15
chardata:(CV202, F1.2   F2.2   F3.1   F3.2   $#                         CV20  16
F3.3   F4     F5      )#                                                CV20  17
chardata:(CV203, END    SCALE  LIMHKL $#                                CV20  18
LIMSTL LIMD   LIMF     )#                                               CV20  19
chardata:(CV204,[* PRINT EVERY    -TH REFLECTION])#                     CV20  20
chardata:(CV205,[LIST ])#                                               CV20  21
datastuff:#                                                             CV20  22
#                                                                       CV20  23
# INITIALIZATION                                                        CV20  24
# --------------                                                        CV20  25
#                                                                       CV20  26
SIGKF  =  voidflg:#                                                     CV20  27
LMOD = 0#                              Default, print every 100 refl    CV20  28
#                                                                       CV20  29
DO I=1,3#                              Hkl limits                       CV20  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CV20  31
BIGIH(I) =   1000#                                                      CV20  32
SMALIH(I) = -1000#                                                      CV20  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CV20  34
SMALST = 0.#                           Sine(theta)/lambda limits        CV20  35
BIGST  = 1.#                                                            CV20  36
SMALF1 = 0.#                           F-rel range limits               CV20  37
BIGF1  = bigf:#                                                         CV20  38
SCALE  = 1.0#                          Overall scale                    CV20  39
#                                                                       CV20  40
# REFLECTION COUNTS                                                     CV20  41
NREJH  = 0.#                                                            CV20  42
NREJF1 = 0.#                                                            CV20  43
NREJPH = 0.#                                                            CV20  44
NREJV1 = 0.#                                                            CV20  45
NREJST = 0.#                                                            CV20  46
NREJSC = 0.#                                                            CV20  47
NREJSF = 0.#                                                            CV20  48
NRFIN  = 0.#                                                            CV20  49
NRFOUT = 0.#                                                            CV20  50
#                                                                       CV20  51
# DECIPHER CONVOL LINE                                                  CV20  52
# ---------------                                                       CV20  53
#                                                                       CV20  54
movechar:(BLANK,1,IDSET1,1,12,1)#      Blank out data set id            CV20  55
#                                                                       CV20  56
# PARSE DATA SET 1 GIVEN AS ARGUMENT                                    CV20  57
#                                                                       CV20  58
stringlim:(1,FIRST,LASTP1)#                                             CV20  59
NCHAR=MIN0((LASTP1-FIRST),12)#                                          CV20  60
movechar:(CHRIN,FIRST,IDSET1,1,NCHAR,0)#                                CV20  61
compchar:(IDSET1,1,DSETID,1,NCHAR,12,TOTCHR,NSET1)#                     CV20  62
IF(NSET1==0) iquit:(-CV2003)#                                           CV20  63
#                                                                       CV20  64
ifnv:(BUFIN(2))#                       Look for list parameter          CV20  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CV20  66
stringlim:(2,J,K)#                     Find limits of the field         CV20  67
compchar:(CHRIN,J,CV205,1,4,5,NCV205,K)# Find what's there              CV20  68
IF(K==0) iquit:(CV2002,2)#             Dud flag.......762002            CV20  69
ELSE IF(K==1)#                         List parameter                   CV20  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CV20  71
IF(BUFIN(3)>voidflg:) LMOD = INT(BUFIN(3))#                             CV20  72
ELSE                  LMOD = 1#        List every reflection            CV20  73
ncodefld:(FLOAT(LMOD),1,CV204,170313.,2)# Report list request           CV20  74
writeline:(3,CV204,NCV204,3,3)#                                         CV20  75
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CV20  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CV20  77
#                                                                       CV20  78
# READ LINE INPUT                                                       CV20  79
# ---------------                                                       CV20  80
#                                                                       CV20  81
readline:(CV202,NCV202)#                                                CV20  82
IF(LINID == 1)CALL CV21#               Function routine                 CV20  83
ELSE IF(LINID==2)CALL CV21#            A function line is mandatory     CV20  84
ELSE IF(LINID==3)CALL CV21#                                             CV20  85
ELSE IF(LINID==4)CALL CV21#                                             CV20  86
ELSE IF(LINID==5)CALL CV21#                                             CV20  87
ELSE IF(LINID==6)CALL CV21#                                             CV20  88
ELSE IF(LINID==7)CALL CV21#                                             CV20  89
#                                                                       CV20  90
#                                                                       CV20  91
REPEAT#                                                                 CV20  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CV20  93
readline:(CV203,NCV203)#                                                CV20  94
IF(LINID == 1)  BREAK#                 End line                         CV20  95
ELSE  IF(LINID == 2)  CALL CV25#       Scale                            CV20  96
ELSE  IF(LINID == 3)  CALL CV27#       Limhkl                           CV20  97
ELSE  IF(LINID == 4)  CALL CV27#       Limstl                           CV20  98
ELSE  IF(LINID == 5)  CALL CV27#       Limd                             CV20  99
ELSE  IF(LINID == 6) CALL CV27#        Limf                             CV20 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CV20 101
#                                                                       CV20 102
RETURN#                                                                 CV20 103
END#                                                                    CV20 104
systemheader:(CV21)#                                                    CV21   1
####################################################################### CV21   2
#                                                                     # CV21   3
#                              CV21                                   # CV21   4
#                                                                     # CV21   5
####################################################################### CV21   6
SUBROUTINE CV21#                       Subroutine to process function   CV21   7
#                                            Line input.                CV21   8
#                                        ** must change routine if add  CV21   9
#                                        ** options to function line    CV21  10
include:(AACOMN)#                                                       CV21  11
include:(CVCOMN)#                                                       CV21  12
#                                                                       CV21  13
INTEGER N,I,J#                         Loop indices                     CV21  14
INTEGER FIRST#                         Pointer to initial character     CV21  15
#                                         In an input line field.       CV21  16
INTEGER LASTP1#                        Pointer to final character       CV21  17
#                                         Plus 1 in an input line field CV21  18
INTEGER ERFLAG(4)#                     Flag for x0 coordinate errors    CV21  19
REAL XP(3)#                            Hold x0 primes                   CV21  20
#                                                                       CV21  21
chardata:(CV211,ABC)#                  Chars from input line which      CV21  22
#                                        Specify hkl order              CV21  23
chardata:(CV212,A TRANSLATION OF X.XXXX FOR THE   DIRECTION $#          CV21  24
IS NOT ALLOWED UNDER THIS SPACE GROUP SYMMETRY.)#                       CV21  25
chardata:(CV213,[FUNCTION     FROM THE INTERNATIONAL TABLES, $#         CV21  26
VOLUME II, PAGE 72.])#                                                  CV21  27
chardata:(CV214,1.2 2.2 3.1 3.2 3.3 4   5   )#                          CV21  28
chardata:(CV215,X01 =       X02 =       X03 =       )#                  CV21  29
chardata:(CV216,B1 =        B2 =        B3 =        )#                  CV21  30
chardata:(CV217,A =       )#                                            CV21  31
chardata:(CV218,[PERMUTATION ORDER IS   ,   ,   ])#                     CV21  32
realdata:(FMT21A,[110642.,230642.,350642.])#                            CV21  33
#                                                                       CV21  34
datastuff:#                                                             CV21  35
PI=3.1415#                                                              CV21  36
#                                                                       CV21  37
#  SET UP DEFAULTS                                                      CV21  38
#                                                                       CV21  39
X0(1)=0.0; X0(2)=0.0; X0(3)=0.0#       Origin at (0,0,0)                CV21  40
B(1)=0.2; B(2)=0.2; B(3)=0.2#          Constant b set to 0.2            CV21  41
IH1=1; IH2=2; IH3=3#                   Permutation order is hkl         CV21  42
#                                                                       CV21  43
#  GET INFO OFF FUNCTION LINE                                           CV21  44
#                                                                       CV21  45
#  FUNCTION 1.2                                                         CV21  46
#                                                                       CV21  47
IF (LINID==1)#                                                          CV21  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CV21  49
FTYPE=1#                                                                CV21  50
DO I=1,3#                                                               CV21  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CV21  52
ifnv:(BUFIN(I)) X0(I) = BUFIN(I)#      Get x0 values                    CV21  53
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CV21  54
#                                                                       CV21  55
#  ECHO BACK INPUT VALUES                                               CV21  56
#                                                                       CV21  57
movechar:(CV214,1,CV213,10,3,0)#                                        CV21  58
writeline:(1,CV213,NCV213,3,3)#        Identify function                CV21  59
DO I=1,3#                                                               CV21  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CV21  61
BUFOT(1)=X0(I)#                                                         CV21  62
ncodefld:(BUFOT,1,CV215,FMT21A(I),1)#                                   CV21  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CV21  64
writeline:(1,CV215,NCV215,3,3)#        Echo x0 values                   CV21  65
#                                                                       CV21  66
#  TEST FOR ACCEPTABLE TRANSLATIONS                                     CV21  67
#                                                                       CV21  68
DO I=1,4; ERFLAG(I) = no:#                                              CV21  69
FOR(N=STARTS;N<ENDSYM;N=N+12)#         Loop over symops                 CV21  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CV21  71
DO I=1,3#                              Perform matrix multiplication    CV21  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CV21  73
# ROTATION MATRIX TIMES X0 VECTOR PLUS TRANSLATION VECTOR               CV21  74
J=N+I#                                                                  CV21  75
XP(I)=X0(1)*QX(J) + X0(2)*QX(J+3) + X0(3)*QX(J+6) + QX(J+9)#            CV21  76
ifne:(XP(I),X0(I)) ERFLAG(I) = yes:#   They must be equal               CV21  77
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CV21  78
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CV21  79
DO I=1,3#                                                               CV21  80
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CV21  81
IF(ERFLAG(I) == yes:)#                 Bad coordinate was given         CV21  82
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CV21  83
ERFLAG(4) = yes:#                      Print iquit message              CV21  84
movechar:(CV211,I,CV212,33,1,0)#                                        CV21  85
BUFOT(1)=X0(I)#                                                         CV21  86
ncodefld:(BUFOT,1,CV212,230642.,1)#                                     CV21  87
writeline:(1,CV212,NCV212,3,3)#        Write out bad x0                 CV21  88
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CV21  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CV21  90
IF(ERFLAG(4) == yes:) iquit:(CV2101)#                                   CV21  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CV21  92
#                                                                       CV21  93
#  FUNCTION 2.2                                                         CV21  94
#                                                                       CV21  95
ELSE IF(LINID==2)#                                                      CV21  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CV21  97
FTYPE=2#                                                                CV21  98
DO I=1,3#                                                               CV21  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CV21 100
ifnv:(BUFIN(I)) B(I) = BUFIN(I)#       Get b values                     CV21 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CV21 102
#  ECHO BACK INPUT                                                      CV21 103
movechar:(CV214,5,CV213,10,3,0)#                                        CV21 104
writeline:(1,CV213,NCV213,3,3)#        Identify function                CV21 105
DO I=1,3#                                                               CV21 106
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CV21 107
BUFOT(1)=B(I)#                                                          CV21 108
ncodefld:(BUFOT,1,CV216,FMT21A(I),1)#                                   CV21 109
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CV21 110
writeline:(1,CV216,NCV216,3,3)#        Write out b values               CV21 111
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CV21 112
#                                                                       CV21 113
#  FUNCTION 3.1                                                         CV21 114
#                                                                       CV21 115
ELSE IF(LINID==3)#                                                      CV21 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CV21 117
FTYPE=3#                                                                CV21 118
DO I=1,3#                                                               CV21 119
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CV21 120
ifnv:(BUFIN(I)) B(I) = BUFIN(I)#       Get b values                     CV21 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CV21 122
A = 1.0/(8.0*B(1)*B(2)*B(3))#          Calculate default a value        CV21 123
ifnv:(BUFIN(4)) A=BUFIN(4)#            Store a value if supplied        CV21 124
#  ECHO BACK INPUT                                                      CV21 125
movechar:(CV214,9,CV213,10,3,0)#                                        CV21 126
writeline:(1,CV213,NCV213,3,3)#        Identify function                CV21 127
DO I=1,3#                                                               CV21 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CV21 129
BUFOT(1)=B(I)#                                                          CV21 130
ncodefld:(BUFOT,1,CV216,FMT21A(I),1)#                                   CV21 131
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CV21 132
writeline:(1,CV216,NCV216,3,3)#        Write out b values               CV21 133
BUFOT(1)=A#                                                             CV21 134
ncodefld:(BUFOT,1,CV217,100642.,1)#                                     CV21 135
writeline:(1,CV217,NCV217,3,3)#        Write out a value                CV21 136
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CV21 137
#                                                                       CV21 138
#  FUNCTION 3.2                                                         CV21 139
#                                                                       CV21 140
ELSE IF(LINID==4)#                                                      CV21 141
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CV21 142
FTYPE=4#                                                                CV21 143
DO I=1,3#                                                               CV21 144
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CV21 145
ifnv:(BUFIN(I)) B(I) = BUFIN(I)#       Get b values                     CV21 146
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CV21 147
A=1.0/(4.0*PI*B(1)*B(2)*B(3))#         Calculate default a value        CV21 148
ifnv:(BUFIN(4)) A=BUFIN(4)#            Store a value if supplied        CV21 149
# GET PERMUTATION ORDER OF HKL                                          CV21 150
ifnv:(BUFIN(5))#                                                        CV21 151
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CV21 152
stringlim:(5,FIRST,LASTP1)#            Get first direction              CV21 153
compchar:(CHRIN,FIRST,CV211,1,1,1,NCV211,IH1)#                          CV21 154
IF(IH1==0) iquit:(-CV2103)#                                             CV21 155
#  CV2103--MUST SPECIFY A,B, OR C AS PERMUTATION ORDER                  CV21 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CV21 157
ifnv:(BUFIN(6))#                                                        CV21 158
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CV21 159
stringlim:(6,FIRST,LASTP1)#            Get second direction             CV21 160
compchar:(CHRIN,FIRST,CV211,1,1,1,NCV211,IH2)#                          CV21 161
IF(IH2==0) iquit:(-CV2103)#            C                                CV21 162
#  CV2103--MUST SPECIFY A,B, OR C AS PERMUTATION ORDER                  CV21 163
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CV21 164
IH3=6/(IH1*IH2)#                       Calculate third direction        CV21 165
#  ECHO BACK INPUT                                                      CV21 166
movechar:(CV214,13,CV213,10,3,0)#                                       CV21 167
writeline:(1,CV213,NCV213,3,3)#        Identify function                CV21 168
DO I=1,3#                                                               CV21 169
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CV21 170
BUFOT(1)=B(I)#                                                          CV21 171
ncodefld:(BUFOT,1,CV216,FMT21A(I),1)#                                   CV21 172
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CV21 173
writeline:(1,CV216,NCV216,3,3)#        Write out b values               CV21 174
BUFOT(1)=A#                                                             CV21 175
ncodefld:(BUFOT,1,CV217,100642.,1)#                                     CV21 176
writeline:(1,CV217,NCV217,3,3)#        Write out a value                CV21 177
movechar:(CV211,IH1,CV218,22,1,0)#                                      CV21 178
movechar:(CV211,IH2,CV218,26,1,0)#                                      CV21 179
movechar:(CV211,IH3,CV218,30,1,0)#                                      CV21 180
writeline:(1,CV218,NCV218,3,3)#        Write out permutation order      CV21 181
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CV21 182
#                                                                       CV21 183
#  FUNCTION 3.3                                                         CV21 184
#                                                                       CV21 185
ELSE IF(LINID==5)#                                                      CV21 186
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CV21 187
FTYPE=5#                                                                CV21 188
DO I=1,3#                                                               CV21 189
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CV21 190
ifnv:(BUFIN(I)) B(I) = BUFIN(I)#       Get b values                     CV21 191
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CV21 192
A=3.0/(4.0*PI*B(1)*B(2)*B(3))#         Calculate default a value        CV21 193
ifnv:(BUFIN(4)) A=BUFIN(4)#            Store a value if supplied        CV21 194
#  ECHO BACK INPUT                                                      CV21 195
movechar:(CV214,17,CV213,10,3,0)#                                       CV21 196
writeline:(1,CV213,NCV213,3,3)#        Identify function                CV21 197
DO I=1,3#                                                               CV21 198
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CV21 199
BUFOT(1)=B(I)#                                                          CV21 200
ncodefld:(BUFOT,1,CV216,FMT21A(I),1)#                                   CV21 201
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CV21 202
writeline:(1,CV216,NCV216,3,3)#        Write out b values               CV21 203
BUFOT(1)=A#                                                             CV21 204
ncodefld:(BUFOT,1,CV217,100642.,1)#                                     CV21 205
writeline:(1,CV217,NCV217,3,3)#        Write out a value                CV21 206
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CV21 207
#                                                                       CV21 208
#  FUNCTION 4                                                           CV21 209
#                                                                       CV21 210
ELSE  IF(LINID==6)#                                                     CV21 211
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CV21 212
FTYPE=6#                                                                CV21 213
DO I=1,3#                                                               CV21 214
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CV21 215
ifnv:(BUFIN(I)) B(I) = BUFIN(I)#       Get b values                     CV21 216
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CV21 217
A=3.0/(PI*B(1)*B(2)*B(3))#             Calculate default a value        CV21 218
ifnv:(BUFIN(4)) A=BUFIN(4)#            Store a value if supplied        CV21 219
#  ECHO BACK INPUT                                                      CV21 220
movechar:(CV214,21,CV213,10,3,0)#                                       CV21 221
writeline:(1,CV213,NCV213,3,3)#        Identify function                CV21 222
DO I=1,3#                                                               CV21 223
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CV21 224
BUFOT(1)=B(I)#                                                          CV21 225
ncodefld:(BUFOT,1,CV216,FMT21A(I),1)#                                   CV21 226
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CV21 227
writeline:(1,CV216,NCV216,3,3)#        Write out b values               CV21 228
BUFOT(1)=A#                                                             CV21 229
ncodefld:(BUFOT,1,CV217,100642.,1)#                                     CV21 230
writeline:(1,CV217,NCV217,3,3)#        Write out a value                CV21 231
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CV21 232
#                                                                       CV21 233
#  FUNCTION 5                                                           CV21 234
#                                                                       CV21 235
ELSE IF(LINID==7)#                                                      CV21 236
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CV21 237
FTYPE=7#                                                                CV21 238
DO I=1,3#                                                               CV21 239
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CV21 240
ifnv:(BUFIN(I)) B(I) = BUFIN(I)#       Get b values                     CV21 241
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CV21 242
A=15.0/(8.0*PI*B(1)*B(2)*B(3))#        Calculate default a value        CV21 243
ifnv:(BUFIN(4)) A=BUFIN(4)#            Store a value if supplied        CV21 244
#  ECHO BACK INPUT                                                      CV21 245
movechar:(CV214,25,CV213,10,3,0)#                                       CV21 246
writeline:(1,CV213,NCV213,3,3)#        Identify function                CV21 247
DO I=1,3#                                                               CV21 248
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CV21 249
BUFOT(1)=B(I)#                                                          CV21 250
ncodefld:(BUFOT,1,CV216,FMT21A(I),1)#                                   CV21 251
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CV21 252
writeline:(1,CV216,NCV216,3,3)#        Write out b values               CV21 253
BUFOT(1)=A#                                                             CV21 254
ncodefld:(BUFOT,1,CV217,100642.,1)#                                     CV21 255
writeline:(1,CV217,NCV217,3,3)#        Write out a value                CV21 256
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CV21 257
#                                                                       CV21 258
RETURN#                                                                 CV21 259
END#                                                                    CV21 260
systemheader:(CV25)#                                                    CV25   1
####################################################################### CV25   2
#                                                                     # CV25   3
#                              CV25                                   # CV25   4
#                                                                     # CV25   5
####################################################################### CV25   6
SUBROUTINE CV25#                       Subroutine to process scale      CV25   7
#                                         Line input.                   CV25   8
include:(AACOMN)#                                                       CV25   9
include:(CVCOMN)#                                                       CV25  10
#                                                                       CV25  11
#                                                                       CV25  12
SCALE = BUFIN(1)#                                                       CV25  13
IF(SCALE <= 0.)  iquit:(-CV2501)#                                       CV25  14
#                                                                       CV25  15
RETURN#                                                                 CV25  16
END#                                                                    CV25  17
systemheader:(CV27)#                                                    CV27   1
####################################################################### CV27   2
#                                                                     # CV27   3
#                              CV27                                   # CV27   4
#                                                                     # CV27   5
####################################################################### CV27   6
SUBROUTINE CV27#                       Subroutine to process limhkl     CV27   7
#                                         Limstl, limd, or              CV27   8
#                                         Limf lines.                   CV27   9
include:(AACOMN)#                                                       CV27  10
include:(CVCOMN)#                                                       CV27  11
#                                                                       CV27  12
INTEGER I#                             Loop index                       CV27  13
INTEGER J#                             Another loop index               CV27  14
chardata:(INFIN,INFINITY)#                                              CV27  15
chardata:(NONE,      NONE)#                                             CV27  16
chardata:(CV271, HKL--LIMITS)#                                          CV27  17
chardata:(CV272,   MIN   MAX)#                                          CV27  18
chardata:(CV273, H          )#                                          CV27  19
chardata:(CV274, SIN(THETA)/LAMBDA LIMITS     RESOLUTION LIMITS)#       CV27  20
chardata:(CV275,       MIN        MAX              MAX      MIN)#       CV27  21
chardata:(CV278,   F-OBSERVED LIMITS)##                                 CV27  22
chardata:(CV279,   REJECT REF IF ONE FOBS  LT   0.0 * SIGMA(FOBS))#     CV27  23
chardata:(CV27A,       MIN       MAX)##                                 CV27  24
realdata:(FMT271,[60313.,120313.,100752.,380632.,#                      CV27  25
210752.,470632.,100912.,200912.])#     Hkl limit formats                CV27  26
realdata:(FMT272,[350612.])#           K*sigma limit format             CV27  27
datastuff:#                                                             CV27  28
# HKL LIMITS                                                            CV27  29
#                                                                       CV27  30
IF(LINID == 3)#                        Limhkl line                      CV27  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CV27  32
LINRM = 6#                             Output hkl limits                CV27  33
writeline:(1,CV271,NCV271,3,3)#                                         CV27  34
writeline:(0,CV272,NCV272,3,3)#                                         CV27  35
FOR(I=1; I <= 3; I=I+1)#                                                CV27  36
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CV27  37
J = 2*(I-1) + 1#                                                        CV27  38
ifnv:(BUFIN(J))    SMALIH(I) = NINT(BUFIN(J))#                          CV27  39
ifnv:(BUFIN(J+1))  BIGIH(I)  = NINT(BUFIN(J+1))#                        CV27  40
IF(BIGIH(I) <= SMALIH(I))  iquit:(-CV2701)#                             CV27  41
movechar:(CV271,I+1,CV273,2,1,0)#      H or k or l to format            CV27  42
BUFOT(1) = FLOAT(SMALIH(I))#                                            CV27  43
BUFOT(2) = FLOAT(BIGIH(I))#                                             CV27  44
ncodefld:(BUFOT,1,CV273,FMT271(1),2)#  The limits to the output         CV27  45
writeline:(0,CV273,NCV273,3,3)#                                         CV27  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CV27  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CV27  48
#                                                                       CV27  49
# SINE(THETA)/LAMBDA LIMITS                                             CV27  50
#                                                                       CV27  51
ELSE  IF(LINID == 4)#                  Limstl line                      CV27  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CV27  53
LINRM = 4#                             Output the limits                CV27  54
writeline:(1,CV274,NCV274,3,3)#                                         CV27  55
ifnv:(BUFIN(1))#                                                        CV27  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CV27  57
SMALST = BUFIN(1)#                                                      CV27  58
BUFOT(1) = SMALST#                                                      CV27  59
BUFOT(2) = 0.5/AMAX1(small:,SMALST)#                                    CV27  60
ncodefld:(BUFOT,1,CHROT,FMT271(3),2)##                                  CV27  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CV27  62
ifnv:(BUFIN(2))#                                                        CV27  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CV27  64
BIGST = BUFIN(2)#                                                       CV27  65
BUFOT(1) = BIGST#                                                       CV27  66
BUFOT(2) = 0.5/AMAX1(small:,BIGST)#                                     CV27  67
ncodefld:(BUFOT,1,CHROT,FMT271(5),2)##                                  CV27  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CV27  69
IF(SMALST < 0. \ BIGST < 0.)  iquit:(-CV2702)#                          CV27  70
IF(SMALST >= BIGST)  iquit:(-CV2702)#                                   CV27  71
IF(SMALST < small:)  movechar:(INFIN,1,CHROT,31,8,0)#                   CV27  72
writeline:(0,CV275,NCV275,2,3)#                                         CV27  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CV27  74
#                                                                       CV27  75
# RESOLUTION LIMITS                                                     CV27  76
#                                                                       CV27  77
ELSE  IF(LINID == 5)#                  Limd line                        CV27  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CV27  79
writeline:(1,CV274,NCV274,3,3)#                                         CV27  80
ifnv:(BUFIN(1))#                                                        CV27  81
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CV27  82
BUFOT(1) = BUFIN(1)#                                                    CV27  83
BIGST = 0.5/AMAX1(BUFIN(1),small:)#                                     CV27  84
BUFOT(2) = BIGST#                                                       CV27  85
ncodefld:(BUFOT,1,CHROT,FMT271(5),2)##                                  CV27  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CV27  87
ifnv:(BUFIN(2))#                                                        CV27  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CV27  89
BUFOT(1) = BUFIN(2)#                                                    CV27  90
SMALST = 0.5/AMAX1(BUFIN(2),small:)#                                    CV27  91
BUFOT(2) = SMALST#                                                      CV27  92
ncodefld:(BUFOT,1,CHROT,FMT271(3),2)##                                  CV27  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CV27  94
IF(SMALST >= BIGST)  iquit:(-CV2703)#                                   CV27  95
IF(SMALST < 0. \ BIGST < 0.)  iquit:(-CV2703)#                          CV27  96
IF(SMALST < small:)  movechar:(INFIN,1,CHROT,31,8,0)#                   CV27  97
writeline:(0,CV275,NCV275,2,3)#                                         CV27  98
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CV27  99
#                                                                       CV27 100
#                                                                       CV27 101
# F-OBSERVED LIMITS                                                     CV27 102
#                                                                       CV27 103
#  NOTE..AT PRESENT ONLY LIMITS ON DATA SET ONE ARE IMPLEMENTED         CV27 104
#   THUS SMALF1 AND BIGF1, ONLY ARE SET.    OCT 1981 (STF)...           CV27 105
#                                                                       CV27 106
ELSE  IF(LINID == 6)#                  Limf line                        CV27 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CV27 108
writeline:(1,CV278,NCV278,3,3)#                                         CV27 109
writeline:(0,CV27A,NCV27A,3,3)#                                         CV27 110
ifnv:(BUFIN(1))  SMALF1 = BUFIN(1)#                                     CV27 111
ifnv:(BUFIN(2))  BIGF1 = BUFIN(2)#                                      CV27 112
BUFOT(1) = SMALF1#                                                      CV27 113
BUFOT(2) = BIGF1#                                                       CV27 114
IF(SMALF1 >= BIGF1)#                                                    CV27 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CV27 116
ifnv:(SMALF1)#                                                          CV27 117
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CV27 118
ifnv:(BIGF1)  iquit:(-CV2706)#                                          CV27 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CV27 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CV27 121
ncodefld:(BUFOT,1,CHROT,FMT271(7),2)##                                  CV27 122
ifvo:(BUFOT(1))  movechar:(NONE,1,CHROT,1,10,0)#                        CV27 123
ifvo:(BUFOT(2))  movechar:(NONE,1,CHROT,11,10,0)#                       CV27 124
writeline:(0,CV272,NCV272,1,3)#                                         CV27 125
ifnv:(BUFIN(3))#                       K*sigma(coef) limit              CV27 126
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CV27 127
SIGKF = BUFIN(3)#                                                       CV27 128
IF(SIGKF < small:)  iquit:(-CV2707)#                                    CV27 129
movechar:(CV279,1,CHROT,1,NCV279,0)#                                    CV27 130
BUFOT(1) = SIGKF#                                                       CV27 131
ncodefld:(BUFOT,1,CHROT,FMT272,1)##                                     CV27 132
writeline:(1,0,0,1,3)#                                                  CV27 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CV27 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CV27 135
#                                                                       CV27 136
RETURN#                                                                 CV27 137
END#                                                                    CV27 138
systemheader:(CV30)#                                                    CV30   1
####################################################################### CV30   2
#                                                                     # CV30   3
#                              CV30                                   # CV30   4
#                                                                     # CV30   5
####################################################################### CV30   6
SUBROUTINE CV30#                       Subroutine to calculate          CV30   7
#                                      New phase, fcalc, acalc          CV30   8
#                                      Or bcalc.                        CV30   9
include:(AACOMN)#                                                       CV30  10
include:(CVCOMN)#                                                       CV30  11
#                                                                       CV30  12
INTEGER CENREF#                        Yes: if centric reflection       CV30  13
INTEGER FSQAR#                         Yes: if f**2 in bdf              CV30  14
INTEGER GETSIG#                        Yes:, if sigma's needed          CV30  15
INTEGER I#                             Loop index                       CV30  16
INTEGER IH(3)#                         H,k,l as unpacked by cv52        CV30  17
INTEGER IPT#                           Input packet pointer             CV30  18
INTEGER IPTR#                          Pointer to a particular inpu     CV30  19
#                                         Packet.                       CV30  20
INTEGER IWANT(maxwant:)#               Catalogue numbers, lrrefl:       CV30  21
#                                         Want list.                    CV30  22
INTEGER JPT#                           Output packet pointer            CV30  23
INTEGER KEY(4)#                        Signal array for indexpkt:       CV30  24
INTEGER OFFSET(incr:(maxwant:))#       Offsets for lrrefl: items        CV30  25
INTEGER PSIZE1#                        Input packet size                CV30  26
INTEGER PSIZE2#                        Output packet size               CV30  27
INTEGER PTF11#                         Pointer to f+, set 1             CV30  28
INTEGER PTFAZ#                         Pointer to phase angle           CV30  29
INTEGER PTFC#                          Pointer to f(calc)               CV30  30
INTEGER PTSG11#                        Pointer to sig(f**2) +           CV30  31
#                                         Do not weight coefficients.   CV30  32
INTEGER REJECT#                        Cv52 arg, yes: for reject re     CV30  33
INTEGER SSQAR#                         Yes: if sig(f**2) in bdf         CV30  34
REAL FP#                               F(h,k,l)                         CV30  35
REAL SIGP#                             Sigma(f+)                        CV30  36
#                                                                       CV30  37
chardata:(CV309, FO)#                                                   CV30  38
chardata:(CV30B,FOR DATA SET....)#                                      CV30  39
chardata:(CV30C,      SCALE =       )##                                 CV30  40
intdata:(PTCOS,[0])#                   Pointer to cos(phase)            CV30  41
intdata:(PTSIN,[0])#                   Pointer to sin(phase)            CV30  42
realdata:(FM5301,[200842.])#           Format                           CV30  43
DATA KEY(1),KEY(2),KEY(3),KEY(4)/3,maxwant:,0,0/#                       CV30  44
datastuff:#                                                             CV30  45
#                                                                       CV30  46
# MAKE LRREFL: WANT LIST                                                CV30  47
# ---------------------                                                 CV30  48
#                                                                       CV30  49
DO I=1,maxwant:#                       Set want list for hkl,           CV30  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CV30  51
IF(I <=  3)  IWANT(I) = I#             Sitol, and eps/mult.             CV30  52
ELSE  IWANT(I) = 0#                    Set the rest to zero             CV30  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CV30  54
#                                                                       CV30  55
# SEE IF SIGMAS ARE NEEDED                                              CV30  56
# ------------------------                                              CV30  57
#                                                                       CV30  58
IF(SIGKF > 0.)  GETSIG = yes:#                                          CV30  59
ELSE  GETSIG = no:#                                                     CV30  60
#                                                                       CV30  61
# ADD TO WANT LIST                                                      CV30  62
# ----------------                                                      CV30  63
#                                                                       CV30  64
IWANT(indxf11:) = 1000*NSET1 + nmbfp:# F+ for set one                   CV30  65
IWANT(indxf11s:) = 1000*NSET1 + nmbfp: - 2# F+ **2 for set one          CV30  66
IF(GETSIG == yes:)#                    See if sigma(f**2) needed        CV30  67
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CV30  68
IWANT(indxss11:) = 1000*NSET1 + nmbsigp: + 2#                           CV30  69
IWANT(indxsg11:) = 1000*NSET1 + nmbsigp:#                               CV30  70
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CV30  71
#                                                                       CV30  72
# GET PHASE INFORMATION                                                 CV30  73
# ---------------------------------------                               CV30  74
#                                                                       CV30  75
IWANT(indxcos:) = 1000*NSET1 + nmbfc: + 1# A(calc)                      CV30  76
IWANT(indxsin:) = 1000*NSET1 + nmbfc: + 2# B(calc)                      CV30  77
IWANT(indxfc:) = 1000*NSET1 + nmbfc:#  F(calc)                          CV30  78
IWANT(indxfaz:) = 1000*NSET1 + nmbfaz:# Phase                           CV30  79
#                                                                       CV30  80
# LRREFL: DIRECTORY READ/WRITE                                          CV30  81
# ----------------------------                                          CV30  82
#                                                                       CV30  83
indexpkt:(1,lrrefl:,PSIZE1,IPT,0,KEY,IWANT,OFFSET)#                     CV30  84
IF (KEY(4) < 0)  iquit:(CV3002)#       Missing data                     CV30  85
PSIZE2 = 6#                            Get size of output directory     CV30  86
writepkt:(2,lrrefl:,PSIZE2,JPT)#       Get pointer to output            CV30  87
#                                         Sequence numbers of basic     CV30  88
#                                         Quantities.                   CV30  89
DO I=1,3#                                                               CV30  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CV30  91
QX(JPT+I)=FLOAT(IWANT(I))#                                              CV30  92
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CV30  93
#                                                                       CV30  94
# CHECK TO SEE IF THE REQUIRED F'S ARE PRESENT                          CV30  95
# ---------------------------------------------                         CV30  96
#                                                                       CV30  97
PTF11 = OFFSET(indxf11:)#              Get f-rel offsets                CV30  98
FSQAR = no:#                           Assume f-rel in bdf              CV30  99
IF (PTF11 == 0)#                                                        CV30 100
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CV30 101
PTF11 = OFFSET(indxf11s:)#             Get f-rel**2 offsets             CV30 102
IF (PTF11 == 0) iquit:(-CV3003)#                                        CV30 103
FSQAR = yes:#                          Learn that f-rel**2 in bdf       CV30 104
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CV30 105
#                                                                       CV30 106
IF(GETSIG == yes:)#                    If sigmas are needed ...         CV30 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CV30 108
PTSG11 = OFFSET(indxsg11:)#            Get sigma(f**2) offsets          CV30 109
SSQAR = yes:#                          Assume sig(f**2) on bdf          CV30 110
IF (PTSG11 == 0)#                                                       CV30 111
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CV30 112
PTSG11 = OFFSET(indxss11:)#            Get sigma(f) offsets             CV30 113
IF (PTSG11 == 0) iquit:(-CV3006)#                                       CV30 114
SSQAR = no:#                           Learn sig(f) in bdf              CV30 115
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CV30 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CV30 117
QX(JPT+4) = fnmb:#                     F id for output directory        CV30 118
#                                                                       CV30 119
# IF THERE ARE NO PHASES, IT  IS AN ERROR                               CV30 120
# -----------------------------------------------------                 CV30 121
#                                                                       CV30 122
IF(OFFSET(indxfaz:)!=0)#               Item 1700/1800 in bdf            CV30 123
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CV30 124
QX(JPT+5) = phnmbfc:#                                                   CV30 125
QX(JPT+6) = phnmbfaz:#                                                  CV30 126
OFFSET(indxcos:)=0#                                                     CV30 127
OFFSET(indxsin:)=0#                                                     CV30 128
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CV30 129
ELSE#                                                                   CV30 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CV30 131
IF(OFFSET(indxcos:)==0 \ OFFSET(indxsin:)==0) iquit:(-CV3004)#          CV30 132
QX(JPT+5) = phnmbcos:#                 Phase id numbers for output      CV30 133
QX(JPT+6) = phnmbsin:#                 Directory.                       CV30 134
OFFSET(indxfaz:)=0##                                                    CV30 135
OFFSET(indxfc:)=0##                                                     CV30 136
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CV30 137
PTCOS = OFFSET(indxcos:)#              Offset for cos(phase)            CV30 138
PTSIN = OFFSET(indxsin:)#              Offset for sin(phase)            CV30 139
PTFAZ = OFFSET(indxfaz:)#              Offset for phase(cycles)         CV30 140
PTFC  = OFFSET(indxfc:)#               Offset for fc                    CV30 141
JPT=JPT+2#                             Add 2 entries to output          CV30 142
#                                                                       CV30 143
# WRITE DESCRIPTION ON LINE OUTPUT                                      CV30 144
# --------------------------------------------                          CV30 145
#                                                                       CV30 146
#                                                                       CV30 147
# LINE FOR SOURCE OF F                                                  CV30 148
movechar:(CV309,1,CHROT,1,3,0)#                                         CV30 149
movechar:(CV30B,1,CHROT,5,NCV30B,0)#                                    CV30 150
movechar:(IDSET1,1,CHROT,NCV30B+6,12,0)#                                CV30 151
writeline:(1,0,0,1,3)#                                                  CV30 152
#                                                                       CV30 153
BUFOT(1) = SCALE#                                                       CV30 154
ncodefld:(BUFOT,1,CV30C,FM5301,1)#     Scale line                       CV30 155
writeline:(0,CV30C,NCV30C,3,3)#                                         CV30 156
#                                                                       CV30 157
# IF ANY ERRORS HAVE BEEN ENCOUNTERED, DIE HERE....                     CV30 158
# ------------------------------------------------                      CV30 159
#                                                                       CV30 160
IF(QUITF(1^1)!=' ')   iquit:(CV3099)#                                   CV30 161
#                                                                       CV30 162
# BEGIN LOOP TO READ REFLECTIONS                                        CV30 163
# ------------------------------                                        CV30 164
#                                                                       CV30 165
IF(LMOD!=0) LINCT = 0#                 Force new page                   CV30 166
REPEAT#                                                                 CV30 167
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CV30 168
readwpkt:(1,lrrefl:,PSIZE1,IPT,0)#                                      CV30 169
IF(IPT <= 0)  BREAK#                                                    CV30 170
NRFIN = NRFIN + 1.#                    Count input reflections          CV30 171
#                                                                       CV30 172
# CHECK FOR CENTRIC REFLECTION                                          CV30 173
# ----------------------------                                          CV30 174
# NOTE: STARTS, ENDSYM FROM COMMON                                      CV30 175
#                                                                       CV30 176
CALL CV55(IPT+OFFSET(1),STARTS,ENDSYM,CENREF)#                          CV30 177
#                                                                       CV30 178
IPTR = IPT + OFFSET(2)#                                                 CV30 179
SITOL = QX(IPTR)#                      Sine(theta)/lambda               CV30 180
IPTR = IPT + OFFSET(1)#                Pointer to packed hkl            CV30 181
CALL CV52(QX(IPTR),IH,REJECT)#         Check for refl. rejection        CV30 182
IF(REJECT == yes: ) NEXT#              Cv41 254                         CV30 183
#                                                                       CV30 184
#   GET STRUCTURE AMPLITUDES AND CHECK FOR REJECTION                    CV30 185
#   ------------------------------------------------                    CV30 186
#                                                                       CV30 187
IPTR = IPT + PTF11#                                                     CV30 188
FP = QX(IPTR)#                         Get value of f+rel               CV30 189
IF(FP < 0.)#                           Check for input f void and       CV30 190
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CV30 191
NREJV1 = NREJV1 + 1.#                  Count rejected reflection.       CV30 192
NEXT#                                  Skip to next reflection          CV30 193
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CV30 194
IF (FSQAR == yes:)#                    If f**2 from bdf ...             CV30 195
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CV30 196
FP = SQRT( FP )#                       F+ = sqrt( f+rel**2 )            CV30 197
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CV30 198
#                                                                       CV30 199
IF(GETSIG == yes:)#                    Get sigma(f), if needed.         CV30 200
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CV30 201
IPTR = IPT + PTSG11#                                                    CV30 202
SIGP = QX(IPTR)#                       Get sig(f) value                 CV30 203
# ALL MUST BE (+)                                                       CV30 204
#     IF(FP == 0 \ SIGP == 0) #                                         CV30 205
IF((ABS(FP) < small:) \ (ABS(SIGP) < small:))#                          CV30 206
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CV30 207
NREJSF = NREJSF + 1.#                  Count as f/sigma deletion        CV30 208
NEXT#                                                                   CV30 209
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CV30 210
IF (SSQAR == yes:)#                    If sig(f)**2 from bdf ...        CV30 211
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CV30 212
SIGP = SIGP/(2.*FP)#                   Compute sigma(f+)                CV30 213
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CV30 214
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CV30 215
#                                                                       CV30 216
# USE LIMIT CHECKS TO REJECT                                            CV30 217
# --------------------------                                            CV30 218
#                                                                       CV30 219
IF((FP < SMALF1) \ (FP > BIGF1))#                                       CV30 220
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CV30 221
NREJF1 = NREJF1 + 1#                                                    CV30 222
NEXT#                                                                   CV30 223
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CV30 224
#                                                                       CV30 225
ifnv:(SIGKF)#                          F/sigma ratio rejection          CV30 226
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CV30 227
IF(FP < SIGKF*SIGP)#                                                    CV30 228
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CV30 229
NREJSF = NREJSF + 1.#                                                   CV30 230
NEXT#                                                                   CV30 231
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CV30 232
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CV30 233
#                                                                       CV30 234
IF(PTFAZ!=0)#                          Using fc/phase info from file    CV30 235
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CV30 236
rejfaz:(PTFAZ)#                        Reject reflec. because of        CV30 237
rejfaz:(PTFC)#                         Missing phase info?              CV30 238
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CV30 239
ELSE#                                  Using sin/cos phase info         CV30 240
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CV30 241
rejfaz:(PTCOS)#                        Reject reflec. because of        CV30 242
rejfaz:(PTSIN)#                        Missing phase info?              CV30 243
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CV30 244
#                                                                       CV30 245
# CALCULATE FUNCTION                                                    CV30 246
# ------------------                                                    CV30 247
#                                                                       CV30 248
# FIRST  PULL OUT NECESSARY VALUES                                      CV30 249
#                                                                       CV30 250
IPTR=IPT+OFFSET(1)#                    Pointer to hkl                   CV30 251
gethkl:(IPTR,H)#                       Put hkl into h(3)                CV30 252
IF (PTFAZ !=0)#                        If phase & fc exist, use them    CV30 253
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CV30 254
IPTR=IPT+PTFAZ#                                                         CV30 255
FAZINP=QX(IPTR)#                       Get phase                        CV30 256
FCINP=FP#                              F(calc) input is f(rel)          CV30 257
USEFAZ=yes:#                           Use f and phase                  CV30 258
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CV30 259
ELSE#                                                                   CV30 260
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CV30 261
IPTR=IPT+PTCOS#                                                         CV30 262
AINP=QX(IPTR)#                         Get acalc                        CV30 263
IPTR=IPT+PTSIN#                                                         CV30 264
BINP=QX(IPTR)#                         Get bcalc                        CV30 265
USEFAZ=no:#                            Use b(calc) and a(calc)          CV30 266
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CV30 267
#                                                                       CV30 268
# PERFORM CALCULATION                                                   CV30 269
#                                                                       CV30 270
IF (FTYPE==1) CALL CV31#               Function 1.2                     CV30 271
ELSE IF(FTYPE==2) CALL CV32#           Function 2.2                     CV30 272
ELSE IF(FTYPE==3) CALL CV33#           Function 3.1                     CV30 273
ELSE IF(FTYPE==4) CALL CV34#           Function 3.2                     CV30 274
ELSE IF(FTYPE==5) CALL CV35#           Function 3.3                     CV30 275
ELSE IF(FTYPE==6) CALL CV36#           Function 4                       CV30 276
ELSE IF(FTYPE==7) CALL CV37#           Function 5                       CV30 277
#                                                                       CV30 278
#                                                                       CV30 279
# FILL OUTPUT BUFFER                                                    CV30 280
# ------------------                                                    CV30 281
#                                                                       CV30 282
NRFOUT = NRFOUT + 1.#                  Count output reflection          CV30 283
writepkt:(2,lrrefl:,PSIZE2,JPT)#       And write it.                    CV30 284
JPTHLD = JPT+1#                        Hold first qx output index       CV30 285
#                                                                       CV30 286
FOR(I=1; I <= 3 ; I=I+1)#              Copy basic quantities to         CV30 287
#                                         Output.                       CV30 288
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CV30 289
JPT = JPT + 1#                         Bump output pointer              CV30 290
IPTR = OFFSET(I) + IPT#                Pointer to corresp input ite     CV30 291
QX(JPT) = QX(IPTR)#                    Load output buffer               CV30 292
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CV30 293
JPT = JPT + 1#                         Bump output pointer              CV30 294
QX(JPT)=FP#                            Put f(rel) in unchanged          CV30 295
IF(PTCOS!=0)#                          Put cos/sin phases in output     CV30 296
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CV30 297
QX(JPT+1) = BOUT*SCALE#                Put in new b(calc)               CV30 298
QX(JPT+2) = AOUT*SCALE#                Put in new a(calc)               CV30 299
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CV30 300
ELSE#                                                                   CV30 301
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CV30 302
QX(JPT+1) = FCOUT*SCALE#               Put in new f(calc)               CV30 303
QX(JPT+2) = FAZOUT*SCALE#              Put in new phase                 CV30 304
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CV30 305
#                                       #                               CV30 306
IF(LMOD>0)#                            List option active               CV30 307
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CV30 308
IF(MOD(INT(NRFOUT),LMOD)==0)#          List reflections requested       CV30 309
CALL CV56(JPTHLD,JPTHLD+3)#                                             CV30 310
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CV30 311
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CV30 312
#                                                                       CV30 313
RETURN#                                                                 CV30 314
END#                                                                    CV30 315
systemheader:(CV31)#                                                    CV31   1
####################################################################### CV31   2
#                                                                     # CV31   3
#                              CV31                                   # CV31   4
#                                                                     # CV31   5
####################################################################### CV31   6
SUBROUTINE CV31#                       Apply function 1.2               CV31   7
#                                      From the international tables,   CV31   8
#                                      Vol. ii, p. 72.                  CV31   9
include:(AACOMN)#                                                       CV31  10
include:(CVCOMN)#                                                       CV31  11
#                                                                       CV31  12
REAL ACONV#                            Intermediate stage in calc       CV31  13
REAL BCONV#                            Intermediate stage in calc       CV31  14
REAL TWOPI#                            Two times pi                     CV31  15
REAL UDOTX#                            H,k,l times vector x0            CV31  16
#                                                                       CV31  17
PI=3.1415#                                                              CV31  18
TWOPI=2.0*PI#                                                           CV31  19
UDOTX=H(1)*X0(1) + H(2)*X0(2) + H(3)*X0(3)# H,k,l * vector x0           CV31  20
#                                                                       CV31  21
IF(USEFAZ == yes:)#                                                     CV31  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CV31  23
FCOUT=FCINP#                           Magnitude of f doesn't change    CV31  24
FAZOUT=AMOD(FAZINP + UDOTX,1.0)#       Shift phase by udotx             CV31  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CV31  26
ELSE#                                  Use acalc and bcalc              CV31  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CV31  28
ACONV=COS(TWOPI*UDOTX)#                                                 CV31  29
BCONV=SIN(TWOPI*UDOTX)#                                                 CV31  30
AOUT=AINP*ACONV - BINP*BCONV#                                           CV31  31
BOUT=AINP*BCONV + BINP*ACONV#                                           CV31  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CV31  33
#                                                                       CV31  34
RETURN#                                                                 CV31  35
END#                                                                    CV31  36
systemheader:(CV32)#                                                    CV32   1
####################################################################### CV32   2
#                                                                     # CV32   3
#                              CV32                                   # CV32   4
#                                                                     # CV32   5
####################################################################### CV32   6
SUBROUTINE CV32#                       Apply function 2.2               CV32   7
#                                      From the international tables,   CV32   8
#                                      Vol. ii, p. 72.                  CV32   9
include:(AACOMN)#                                                       CV32  10
include:(CVCOMN)#                                                       CV32  11
#                                                                       CV32  12
REAL F2DOT2#                           Function to be mult. by values   CV32  13
REAL RSQR#                             Radius squared                   CV32  14
#                                                                       CV32  15
PI=3.1415#                                                              CV32  16
RSQR=H(1)*H(1)*B(1)*B(1) + H(2)*H(2)*B(2)*B(2) + $#                     CV32  17
H(3)*H(3)*B(3)*B(3)#                                                    CV32  18
F2DOT2 = EXP((-1.0)*PI*RSQR)#                                           CV32  19
#                                                                       CV32  20
IF(USEFAZ == yes:)#                                                     CV32  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CV32  22
FCOUT=FCINP*F2DOT2#                    Alter f(calc)                    CV32  23
FAZOUT=FAZINP#                         Phase doesn't change             CV32  24
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CV32  25
ELSE#                                                                   CV32  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CV32  27
AOUT=AINP*F2DOT2#                      Alter a(calc)                    CV32  28
BOUT=BINP*F2DOT2#                      Alter b(calc)                    CV32  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CV32  30
#                                                                       CV32  31
RETURN#                                                                 CV32  32
END#                                                                    CV32  33
systemheader:(CV33)#                                                    CV33   1
####################################################################### CV33   2
#                                                                     # CV33   3
#                              CV33                                   # CV33   4
#                                                                     # CV33   5
####################################################################### CV33   6
SUBROUTINE CV33#                       Apply function 3.1               CV33   7
#                                      From the international tables,   CV33   8
#                                      Vol. ii, p. 72.                  CV33   9
include:(AACOMN)#                                                       CV33  10
include:(CVCOMN)#                                                       CV33  11
#                                                                       CV33  12
REAL F3DOT1#                           Function to be mult. by values   CV33  13
REAL TEMP#                             Intermediate stage of calc       CV33  14
REAL TERM1,TERM2,TERM3#                Intermediate stage of calc       CV33  15
REAL TWOPI#                            Two times pi                     CV33  16
#                                                                       CV33  17
PI=3.1415#                                                              CV33  18
TWOPI=2.0*PI#                                                           CV33  19
TEMP=TWOPI*H(1)*B(1)#                                                   CV33  20
TERM1=SIN(TEMP)/TEMP#                                                   CV33  21
TEMP=TWOPI*H(2)*B(2)#                                                   CV33  22
TERM2=SIN(TEMP)/TEMP#                                                   CV33  23
TEMP=TWOPI*H(3)*B(3)#                                                   CV33  24
TERM3=SIN(TEMP)/TEMP#                                                   CV33  25
F3DOT1=8.0*A*B(1)*B(2)*B(3)*TERM1*TERM2*TERM3#                          CV33  26
#                                                                       CV33  27
IF(USEFAZ == yes:)#                                                     CV33  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CV33  29
FCOUT=FCINP*F3DOT1#                    Alter f(calc)                    CV33  30
FAZOUT=FAZINP#                         Phase doesn't change             CV33  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CV33  32
ELSE#                                                                   CV33  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CV33  34
AOUT=AINP*F3DOT1#                      Alter a(calc)                    CV33  35
BOUT=BINP*F3DOT1#                      Alter b(calc)                    CV33  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CV33  37
#                                                                       CV33  38
RETURN#                                                                 CV33  39
END#                                                                    CV33  40
systemheader:(CV34)#                                                    CV34   1
####################################################################### CV34   2
#                                                                     # CV34   3
#                              CV34                                   # CV34   4
#                                                                     # CV34   5
####################################################################### CV34   6
SUBROUTINE CV34#                       Apply function 3.2               CV34   7
#                                      From the international tables,   CV34   8
#                                      Vol. ii, p. 72.                  CV34   9
include:(AACOMN)#                                                       CV34  10
include:(CVCOMN)#                                                       CV34  11
#                                                                       CV34  12
REAL F3DOT2#                           Function to be mult. by values   CV34  13
REAL FSUB1#                            Intermediate stage of calc       CV34  14
REAL J#                                Result of first order bessel     CV34  15
#                                      Function applied to 2*pi*r       CV34  16
REAL RECIPJ#                           Reciprocal of j                  CV34  17
REAL S#                                Variable s from page 72          CV34  18
REAL TEMP#                             Intermediate stage of calc       CV34  19
REAL TERM1,TERM2#                      Intermediate stage of calc       CV34  20
REAL TSUB1#                            Intermediate stage of calc       CV34  21
REAL THRX#                             Three over x                     CV34  22
REAL TWOPI#                            Two * pi                         CV34  23
REAL X#                                Value applied to bessel functi   CV34  24
#                                        I.e. j(x)                      CV34  25
REAL X3#                               X over 3                         CV34  26
#                                                                       CV34  27
# CALCULATION OF THE BESSEL FUNCTION HAS BEEN SIMPLIFIED                CV34  28
# BY USING THE APPROXIMATIONS GIVEN IN "THE HANDBOOK OF                 CV34  29
# MATHEMATICAL FUNCTIONS", ED. BY M. ABRAMOWITZ AND                     CV34  30
# I.A. STEGUN, 1965, DOVER PUBLICATIONS, P.370.                         CV34  31
#                                                                       CV34  32
realdata:(F1,[.79788456, .00000156, .01659667, .00017105,$#             CV34  33
.00249511, .00113653, .00020033])#                                      CV34  34
realdata:(T1,[2.35619449, .12499612, .0005650, .00637879, $#            CV34  35
.00074348, .00079824, .00029166])#                                      CV34  36
realdata:(J1,[.5, .56249985, .21093573, .03954289, $#                   CV34  37
.00443319, .00031761, .00001109])#                                      CV34  38
datastuff:#                                                             CV34  39
#                                                                       CV34  40
PI=3.1415#                                                              CV34  41
TWOPI=2.0*PI#                                                           CV34  42
S=SQRT((H(IH2)**2)*(B(2)**2) + (H(IH3)**2)*(B(3)**2))#                  CV34  43
X=TWOPI*S#                                                              CV34  44
#                                                                       CV34  45
# CALCULATE J TERM, FIRST ORDER BESSEL FUNCTION                         CV34  46
#                                                                       CV34  47
# USE EQUATION 9.4.4 FROM THE HANDBOOK OF MATHEMATICAL FUNCTIONS        CV34  48
# IF THE VALUE TO BE APPLIED TO THE BESSEL FUNCTION IS BETWEEN          CV34  49
# NEGATIVE THREE AND POSITIVE THREE.                                    CV34  50
#                                                                       CV34  51
#                                                                       CV34  52
IF((X >= -3) & (X <= 3))#                                               CV34  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CV34  54
X3=X/3.0#                                                               CV34  55
RECIPJ=J1(1) - J1(2)*(X3)**2 + J1(3)*(X3)**4 - J1(4)*(X3)**6 + $#       CV34  56
J1(5)*(X3)**8 - J1(6)*(X3)**10 + J1(7)*(X3)**12#                        CV34  57
J= RECIPJ * X#                                                          CV34  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CV34  59
#                                                                       CV34  60
# USE EQUATION 9.4.6 FROM THE HANDBOOK OF MATHEMATICAL FUNCTIONS        CV34  61
# IF THE VALUE TO BE APPLIED TO THE BESSEL FUNCTION IS GREATER          CV34  62
# THAN POSITIVE 3.                                                      CV34  63
#                                                                       CV34  64
ELSE IF(X >= 3)#                                                        CV34  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CV34  66
THRX = 3.0/X#                                                           CV34  67
FSUB1 = F1(1) + F1(2)*THRX + F1(3)*THRX**2 + F1(4)*THRX**3 - $#         CV34  68
F1(5)*THRX**4 + F1(6)*THRX**5 - F1(7)*THRX**6#                          CV34  69
TSUB1 = X - T1(1) + T1(2)*THRX + T1(3)*THRX**2 - $#                     CV34  70
T1(4)*THRX**3 + T1(5)*THRX**4 + T1(6)*THRX**5 - T1(7)*THRX**6#          CV34  71
J= X**(-0.5)*FSUB1*COS(TSUB1)#                                          CV34  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CV34  73
#                                                                       CV34  74
J=AMAX1(J,0.0)#                        Set negative values to zero      CV34  75
TEMP=TWOPI*H(IH1)*B(1)#                                                 CV34  76
TERM1=SIN(TEMP)/TEMP#                                                   CV34  77
TERM2= J/X#                                                             CV34  78
F3DOT2 = 2.0*TWOPI*A*B(1)*B(2)*B(3)*TERM1*TERM2#                        CV34  79
#                                                                       CV34  80
IF(USEFAZ == yes:)#                                                     CV34  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CV34  82
FCOUT = FCINP*F3DOT2#                  Alter f(calc)                    CV34  83
FAZOUT=FAZINP#                         Phase doesn't change             CV34  84
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CV34  85
ELSE#                                                                   CV34  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CV34  87
AOUT = AINP*F3DOT2#                    Alter a(calc)                    CV34  88
BOUT = BINP*F3DOT2#                    Alter b(calc)                    CV34  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CV34  90
#                                                                       CV34  91
RETURN#                                                                 CV34  92
END#                                                                    CV34  93
systemheader:(CV35)#                                                    CV35   1
####################################################################### CV35   2
#                                                                     # CV35   3
#                              CV35                                   # CV35   4
#                                                                     # CV35   5
####################################################################### CV35   6
SUBROUTINE CV35#                       Apply function 3.3               CV35   7
#                                      From the international tables,   CV35   8
#                                      Vol. ii, p. 72.                  CV35   9
include:(AACOMN)#                                                       CV35  10
include:(CVCOMN)#                                                       CV35  11
#                                                                       CV35  12
REAL F3DOT3#                           Function to be mult. by values   CV35  13
REAL R#                                Radius                           CV35  14
REAL TERM1,TERM2#                      Intermediate stage of calc       CV35  15
REAL TWOPIR#                           Two * pi * radius                CV35  16
#                                                                       CV35  17
PI=3.1415#                                                              CV35  18
R=SQRT((H(1)**2)*(B(1)**2) + (H(2)**2)*(B(2)**2) + $#                   CV35  19
(H(3)**2)*(B(3)**2))#                                                   CV35  20
TWOPIR = 2.0*PI*R#                                                      CV35  21
TERM1=(4.0*PI*A*B(1)*B(2)*B(3))/3.0#                                    CV35  22
TERM2=3.0*(SIN(TWOPIR) - TWOPIR*COS(TWOPIR))/(TWOPIR**3)#               CV35  23
F3DOT3=TERM1*TERM2#                                                     CV35  24
#                                                                       CV35  25
IF(USEFAZ == yes:)#                                                     CV35  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CV35  27
FCOUT = FCINP*F3DOT3#                  Alter f(calc)                    CV35  28
FAZOUT=FAZINP#                         Phase doesn't change             CV35  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CV35  30
ELSE#                                                                   CV35  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CV35  32
AOUT = AINP*F3DOT3#                    Alter a(calc)                    CV35  33
BOUT = BINP*F3DOT3#                    Alter b(calc)                    CV35  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CV35  35
#                                                                       CV35  36
RETURN#                                                                 CV35  37
END#                                                                    CV35  38
systemheader:(CV36)#                                                    CV36   1
####################################################################### CV36   2
#                                                                     # CV36   3
#                              CV36                                   # CV36   4
#                                                                     # CV36   5
####################################################################### CV36   6
SUBROUTINE CV36#                       Apply function 4                 CV36   7
#                                      From the international tables,   CV36   8
#                                      Vol. ii, p. 72.                  CV36   9
include:(AACOMN)#                                                       CV36  10
include:(CVCOMN)#                                                       CV36  11
#                                                                       CV36  12
REAL F4#                               Function to be mult. by values   CV36  13
REAL R#                                Radius                           CV36  14
REAL TERM1,TERM2,TERM3#                Intermediate stage of calc       CV36  15
REAL TWOPIR#                           Two * pi * radius                CV36  16
#                                                                       CV36  17
PI=3.1415#                                                              CV36  18
R=SQRT((H(1)**2)*(B(1)**2) + (H(2)**2)*(B(2)**2) + $#                   CV36  19
(H(3)**2)*(B(3)**2))#                                                   CV36  20
TWOPIR=2.0*PI*R#                                                        CV36  21
TERM1=(PI*A*B(1)*B(2)*B(3))/3.0#                                        CV36  22
TERM2=12.0/(TWOPIR**4)#                                                 CV36  23
TERM3=2.0*(1.0-COS(TWOPIR)) - TWOPIR*SIN(TWOPIR)#                       CV36  24
F4=TERM1*TERM2*TERM3#                                                   CV36  25
#                                                                       CV36  26
IF(USEFAZ == yes:)#                                                     CV36  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CV36  28
FCOUT = FCINP*F4#                      Alter f(calc)                    CV36  29
FAZOUT=FAZINP#                         Phase doesn't change             CV36  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CV36  31
ELSE#                                                                   CV36  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CV36  33
AOUT = AINP*F4#                        Alter a(calc)                    CV36  34
BOUT = BINP*F4#                        Alter b(calc)                    CV36  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CV36  36
#                                                                       CV36  37
RETURN#                                                                 CV36  38
END#                                                                    CV36  39
systemheader:(CV37)#                                                    CV37   1
####################################################################### CV37   2
#                                                                     # CV37   3
#                              CV37                                   # CV37   4
#                                                                     # CV37   5
####################################################################### CV37   6
SUBROUTINE CV37#                       Apply function 5                 CV37   7
#                                      From the international tables,   CV37   8
#                                      Vol. ii, p. 72.                  CV37   9
include:(AACOMN)#                                                       CV37  10
include:(CVCOMN)#                                                       CV37  11
#                                                                       CV37  12
REAL F5#                               Function to be mult. by values   CV37  13
REAL R#                                Radius                           CV37  14
REAL TERM1,TERM2,TERM3#                Intermediate stage of calc       CV37  15
REAL TWOPIR#                           Two * pi * radius                CV37  16
#                                                                       CV37  17
PI=3.1415#                                                              CV37  18
R=SQRT((H(1)**2)*(B(1)**2) + (H(2)**2)*(B(2)**2) + $#                   CV37  19
(H(3)**2)*(B(3)**2))#                                                   CV37  20
TWOPIR=2.0*PI*R#                                                        CV37  21
TERM1=8.0*PI*A*B(1)*B(2)*B(3)/15.0#                                     CV37  22
TERM2=15.0/(TWOPIR**5)#                                                 CV37  23
TERM3=(3.0 - TWOPIR**2)*SIN(TWOPIR) - 3.0*TWOPIR*COS(TWOPIR)#           CV37  24
F5=TERM1*TERM2*TERM3#                                                   CV37  25
#                                                                       CV37  26
IF(USEFAZ == yes:)#                                                     CV37  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CV37  28
FCOUT = FCINP*F5#                      Alter f(calc)                    CV37  29
FAZOUT=FAZINP#                         Phase doesn't change             CV37  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CV37  31
ELSE#                                                                   CV37  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CV37  33
AOUT = AINP*F5#                        Alter a(calc)                    CV37  34
BOUT = BINP*F5#                        Alter b(calc)                    CV37  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CV37  36
#                                                                       CV37  37
RETURN#                                                                 CV37  38
END#                                                                    CV37  39
systemheader:(CV40)#                   Close the output bdf             CV40   1
####################################################################### CV40   2
#                                                                     # CV40   3
#                              CV40                                   # CV40   4
#                                                                     # CV40   5
####################################################################### CV40   6
SUBROUTINE CV40#                                                        CV40   7
include:(AACOMN)#                                                       CV40   8
include:(CVCOMN)#                                                       CV40   9
#                                                                       CV40  10
INTEGER IPT#                           Input packet pointer             CV40  11
INTEGER JPT#                           Output packet pointer            CV40  12
INTEGER PSIZE#                         Packet size                      CV40  13
#                                                                       CV40  14
CALL CV54#                             List reflection counts           CV40  15
#                                                                       CV40  16
readwpkt:(1,endrecord:,PSIZE,IPT,0)#   Finish input bdf                 CV40  17
writepkt:(2,endrecord:,1,JPT)#         Write eof logical record         CV40  18
#                                                                       CV40  19
RETURN#                                                                 CV40  20
END#                                                                    CV40  21
systemheader:(CV52)#                                                    CV52   1
####################################################################### CV52   2
#                                                                     # CV52   3
#                              CV52                                   # CV52   4
#                                                                     # CV52   5
####################################################################### CV52   6
SUBROUTINE CV52(HKL,IH,REJECT)#        Subroutine to check              CV52   7
#                                         Sin theta and hkl limits.     CV52   8
include:(AACOMN)#                                                       CV52   9
include:(CVCOMN)#                                                       CV52  10
#                                                                       CV52  11
INTEGER IH(3)#                         Reflection indices               CV52  12
INTEGER K#                             Loop index                       CV52  13
INTEGER N#                             Bit index                        CV52  14
INTEGER REJECT#                        Set to yes: for rejects          CV52  15
REAL HKL#                              Packed hkl from qx array         CV52  16
#                                                                       CV52  17
REJECT = no:#                                                           CV52  18
# EXTRACT HKL                                                           CV52  19
#                                                                       CV52  20
DO K=1,3#                              Loop over h,k,l                  CV52  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CV52  22
N = (3-K)*9 + 3#                       Set bit index                    CV52  23
intunpak:(HKL,IH(K),N,9)#              Get out each index               CV52  24
intunpak:(HKL,N,3-K,1)#                Pick out sign of each index      CV52  25
IF(N != 0)  IH(K) = -IH(K)#            Flip the sign                    CV52  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CV52  27
#                                                                       CV52  28
DO K=1,3#                              Check hkl limits                 CV52  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CV52  30
IF(IH(K) < SMALIH(K) \ IH(K) > BIGIH(K))#                               CV52  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CV52  32
NREJH = NREJH + 1.#                                                     CV52  33
REJECT = yes:#                                                          CV52  34
BREAK#                                                                  CV52  35
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CV52  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CV52  37
#                                                                       CV52  38
IF(REJECT == no:)#                     If hkl limits ok, check sito     CV52  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CV52  40
IF(SITOL < SMALST \ SITOL > BIGST)#                                     CV52  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CV52  42
NREJST = NREJST + 1.#                                                   CV52  43
REJECT = yes:#                                                          CV52  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CV52  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CV52  46
#                                                                       CV52  47
RETURN#                                                                 CV52  48
END#                                                                    CV52  49
systemheader:(CV54)#                                                    CV54   1
####################################################################### CV54   2
#                                                                     # CV54   3
#                              CV54                                   # CV54   4
#                                                                     # CV54   5
####################################################################### CV54   6
SUBROUTINE CV54#                       Subroutine to list               CV54   7
#                                         Reflection counts.            CV54   8
include:(AACOMN)#                                                       CV54   9
include:(CVCOMN)#                                                       CV54  10
#                                                                       CV54  11
chardata:(CV541,        REFLECTIONS INPUT.)#                            CV54  12
chardata:(CV542,        REFLECTIONS OUTPUT.)#                           CV54  13
chardata:(CV543, OUT-OF-RANGE REFLECTION REJECTION COUNTS)#             CV54  14
chardata:(CV544,        SIN(THETA)/LAMBDA)#                             CV54  15
chardata:(CV545,        H$,K$,L)#                                       CV54  16
chardata:(CV547,        F FOR DATA SET 1)#                              CV54  17
chardata:(CV548,        REFLECTIONS NOT USED BECAUSE OF MISSING F $#    CV54  18
IN DATA SET 1)#                                                         CV54  19
chardata:(CV549,        REFLECTIONS NOT USED BECAUSE OF MISSING $#      CV54  20
PHASES)#                                                                CV54  21
chardata:(CV54A,        F < K*SIGMA(F))#                                CV54  22
chardata:(CV54B,        COEF < K*SIGMA(COEF))#                          CV54  23
realdata:(NUMBER,[1.,2.])#             Real data set numbers            CV54  24
realdata:(FMT541,[70613.,240113.,630113.])# Formats                     CV54  25
datastuff:#                                                             CV54  26
#                                                                       CV54  27
BUFOT(1) = NRFIN#                                                       CV54  28
ncodefld:(BUFOT,1,CV541,FMT541(1),1)#                                   CV54  29
writeline:(1,CV541,NCV541,3,3)#                                         CV54  30
BUFOT(1) = NRFOUT#                                                      CV54  31
ncodefld:(BUFOT,1,CV542,FMT541(1),1)#                                   CV54  32
writeline:(0,CV542,NCV542,3,3)#                                         CV54  33
writeline:(1,CV543,NCV543,3,3)#                                         CV54  34
BUFOT(1) = NREJST#                                                      CV54  35
ncodefld:(BUFOT,1,CV544,FMT541(1),1)#                                   CV54  36
writeline:(0,CV544,NCV544,3,3)#                                         CV54  37
BUFOT(1) = NREJH#                                                       CV54  38
ncodefld:(BUFOT,1,CV545,FMT541(1),1)#                                   CV54  39
writeline:(0,CV545,NCV545,3,3)#                                         CV54  40
BUFOT(1) = NREJF1#                                                      CV54  41
ncodefld:(BUFOT,1,CV547,FMT541(1),1)#                                   CV54  42
ncodefld:(NUMBER,1,CV547,FMT541(2),1)#                                  CV54  43
writeline:(0,CV547,NCV547,3,3)#                                         CV54  44
BUFOT(1) = NREJSF#                                                      CV54  45
ncodefld:(BUFOT,1,CV54A,FMT541(1),1)#                                   CV54  46
writeline:(0,CV54A,NCV54A,3,3)#                                         CV54  47
BUFOT(1) = NREJSC#                                                      CV54  48
ncodefld:(BUFOT,1,CV54B,FMT541(1),1)#                                   CV54  49
writeline:(0,CV54B,NCV54B,3,3)#                                         CV54  50
#                                                                       CV54  51
#                                                                       CV54  52
ncodefld:(NUMBER,1,CV548,FMT541(3),1)#                                  CV54  53
BUFOT(1) = NREJV1#                                                      CV54  54
ncodefld:(BUFOT,1,CV548,FMT541(1),1)#                                   CV54  55
writeline:(1,CV548,NCV548,3,3)#                                         CV54  56
#                                                                       CV54  57
BUFOT(1) = NREJPH#                                                      CV54  58
ncodefld:(BUFOT,1,CV549,FMT541(1),1)#                                   CV54  59
writeline:(1,CV549,NCV549,3,3)#                                         CV54  60
#                                                                       CV54  61
RETURN#                                                                 CV54  62
END#                                                                    CV54  63
systemheader:(CV55)#                   Find centric reflections         CV55   1
####################################################################### CV55   2
#                                                                     # CV55   3
#                               CV55                                  # CV55   4
#                                                                     # CV55   5
####################################################################### CV55   6
SUBROUTINE CV55(IPT,IS,IE,CFLG)#       J.m. stewart june 1986           CV55   7
# ROUTINE TO DETERMINE WHICH REFLECTIONS ARE 'CENTRIC'  I.E. HAVE       CV55   8
# STRUCTURE FACTORS IN  WHICH THE IMAGINARY TERM IS ZERO BY SYMMETRY.   CV55   9
include:(AACOMN)#                                                       CV55  10
#                                                                       CV55  11
INTEGER  IPT#         ## Pointer to packed hkl in qx                    CV55  12
INTEGER  IS#          ## Start of symops in qx array                    CV55  13
INTEGER  IE#          ## End of symops in qx array                      CV55  14
INTEGER  J#           ## Loop index                                     CV55  15
INTEGER  CFLG#        ## Flag to be set yes:/no:                        CV55  16
#                     ##   CENTRIC/NON CENTRIC                          CV55  17
REAL     HKL(3)#      ## Miller indices of current reflection           CV55  18
REAL     HKLP(3)#     ## Miller indices of generated reflection         CV55  19
#                                                                       CV55  20
gethkl:(IPT,HKL)#                      Unpact hkl                       CV55  21
CFLG = no:#                            Assume not centric               CV55  22
DO  J= IS, IE, 12#                     Loop over all symops             CV55  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CV55  24
HKLP(1) = HKL(1)*QX(J+1) $#            Transform h                      CV55  25
          + HKL(2)*QX(J+2) $#                                           CV55  26
          + HKL(3)*QX(J+3)#                                             CV55  27
ifne:((HKLP(1)+HKL(1)),0.0) NEXT#      Not possible - try next          CV55  28
HKLP(2) = HKL(1)*QX(J+4) $#            Transform k                      CV55  29
          + HKL(2)*QX(J+5) $#                                           CV55  30
          + HKL(3)*QX(J+6)#                                             CV55  31
ifne:((HKLP(2)+HKL(2)),0.0) NEXT#      Not possible - try next          CV55  32
HKLP(3) = HKL(1)*QX(J+7) $#            Transform l                      CV55  33
          + HKL(2)*QX(J+8) $#                                           CV55  34
          + HKL(3)*QX(J+9)#                                             CV55  35
ifne:((HKLP(3)+HKL(3)),0.0) NEXT#      Not possible - try next          CV55  36
CFLG = yes:#                           If here, reflection centric      CV55  37
BREAK#                                 No need to search more           CV55  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CV55  39
RETURN#                                                                 CV55  40
END#                                                                    CV55  41
systemheader:(CV56)#                   List output reflections          CV56   1
####################################################################### CV56   2
#                                                                     # CV56   3
#                               CV56                                  # CV56   4
#                                                                     # CV56   5
####################################################################### CV56   6
SUBROUTINE CV56(VPTR1,VPTR2)#          D.r. holland nov 1986            CV56   7
# ROUTINE TO LIST OUTPUT REFLECTIONS AS SPECIFIED BY LIST PARAMETER     CV56   8
include:(AACOMN)#                                                       CV56   9
include:(CVCOMN)#                                                       CV56  10
#                                                                       CV56  11
INTEGER VPTR1,VPTR2#  ## Points to first element in qx to output        CV56  12
REAL HKL(3)#          ## Hold hlk                                       CV56  13
realdata:(FMTOT,[50313.,100313.,150313.,260831.])#                      CV56  14
chardata:(MSG1,[    H    K    L     COEF    ])#                         CV56  15
datastuff:#                                                             CV56  16
#                                                                       CV56  17
gethkl:(VPTR1,HKL)#                    Unpack hkl values                CV56  18
#                                                                       CV56  19
ncodefld:(HKL,1,CHROT,FMTOT(1),3)#                                      CV56  20
ncodefld:(QX,VPTR2,CHROT,FMTOT(4),1)#                                   CV56  21
writeline:(0,MSG1,NMSG1,1,3)#          Output to log                    CV56  22
#                                                                       CV56  23
RETURN#                                                                 CV56  24
END#                                                                    CV56  25
pmacro:([no:])#                        Purge xtal system macros         CV56  26
