systemheader:(EB    )#                                                  EB     1
####################################################################    EB     2
#                                                                  #    EB     3
#                           *** EDTBDF ***                         #    EB     4
#                                                                  #    EB     5
#    PROGRAM FOR EDITING THE CONTENTS OF THE BDF.                  #    EB     6
#                                                                  #    EB     7
####################################################################    EB     8
#                                                                       EB     9
include:(XMACRO)#                                                       EB    10
#                                                                       EB    11
macro:(lim:,100)#                      Max changes per record type      EB    12
macro:(bdfendrec:,43)#                 Maximum allowable record num     EB    13
#                                                                       EB    14
extrude:(EBCOMN)#                                                       EB    15
INTEGER DIRREC(bdfendrec:)#   ## Specifies which records have direcs    EB    16
INTEGER IDCOND(bdfendrec:,lim:)## ITEM USED IN CONDITIONAL              EB    17
INTEGER IDNUM(bdfendrec:,lim:)## IDNUM to be changed                    EB    18
INTEGER NCHNG(bdfendrec:,20)# ## Number changes PER REQUEST             EB    19
INTEGER NRQST(bdfendrec:)#    ## Number requests for each record        EB    20
INTEGER NCOND(bdfendrec:)#    ## NUMBER CONDITIONALS REQUESTED/REC      EB    21
INTEGER NCREC#                ## NUMBER RECORDS CHANGED                 EB    22
INTEGER PRINT#                ## yes: if changed records to log         EB    23
REAL GECOND(bdfendrec:,lim:)# ## UPPER LIMIT FOR CONDITIONAL            EB    24
REAL LECOND(bdfendrec:,lim:)# ## LOWER LIMIT FOR CONDITIONAL            EB    25
REAL NEWVAL(bdfendrec:,lim:)# ## VALUE TO BE CHANGED TO                 EB    26
REAL WORK(512)#               ## TEMPORARY OUTPUT BUFFER                EB    27
COMMON/COMIEB/DIRREC, IDCOND, IDNUM, NRQST, NCOND,$#                    EB    28
NCHNG,NCREC, PRINT#                                                     EB    29
COMMON/COMFEB/GECOND,LECOND,NEWVAL,WORK#                                EB    30
endext:#                                                                EB    31
#                                                                       EB    32
systemheader:(EB00)#                   Mod hkl patch                    EB00   1
# ################################################################## #  EB00   2
#                                                                    #  EB00   3
#                               EB00                                 #  EB00   4
#                                                                    #  EB00   5
# ################################################################## #  EB00   6
SUBROUTINE EB00#                       K.d.watenpaugh                   EB00   7
include:(EBCOMN)#                                                       EB00   8
include:(AACOMN)#                                                       EB00   9
#                                                                       EB00  10
INTEGER I,J,K,JP#                                                       EB00  11
INTEGER IDINX(lim:)#                                                    EB00  12
INTEGER CNDINX(lim:)#                                                   EB00  13
INTEGER NRCHNG#                        Number of records changed        EB00  14
INTEGER NVCHNG#                        Number of values changed         EB00  15
INTEGER HEAD#                                                           EB00  16
#                                                                       EB00  17
chardata:(EB001,CHANGED RECORDS                        )#               EB00  18
chardata:(EB002,CHANGED VALUES                         )#               EB00  19
chardata:(EB003,results:)#                                              EB00  20
chardata:(EB004,[=======])#                                             EB00  21
chardata:(EB005,' **        NOT ON RECORD - CANNOT USE FOR RENAME')#    EB00  22
chardata:(EB006,' **        ALREADY ON RECORD - CANNOT USE FOR RENAME')#EB00  23
chardata:(EB007,' **        NOT IN RECORD - CANNOT BE DELETED')#        EB00  24
chardata:(EB008,' **        ALREADY IN RECORD - NOT ADDED')#            EB00  25
datastuff:#                                                             EB00  26
#                                                                       EB00  27
# INITIALIZE - MARK THE RECORDS WHICH HAVE DIRECTORIES                  EB00  28
# ---------------------------------------                               EB00  29
#                                                                       EB00  30
DO I=1,bdfendrec:; DO J=1,20; NCHNG(I,J)=0#                             EB00  31
DO J=1,bdfendrec:; DIRREC(J)=no:#      'not a directory-type' recor     EB00  32
#                                                                       EB00  33
DIRREC(lrscat:)=yes:#                  These all have directories       EB00  34
DIRREC(lrexpl:)=yes:#                                                   EB00  35
DIRREC(lrdset:)=yes:#                                                   EB00  36
DIRREC(lrdict:)=yes:#                                                   EB00  37
DIRREC(lratom:)=yes:#                                                   EB00  38
DIRREC(lrcons:)=yes:#                                                   EB00  39
DIRREC(lrrefl:)=yes:#                                                   EB00  40
NVCHNG=0#                                                               EB00  41
NRCHNG=0#                                                               EB00  42
#                                                                       EB00  43
# READ INPUT CARDS                                                      EB00  44
# ----------------                                                      EB00  45
#                                                                       EB00  46
CALL EB01#                                                              EB00  47
#                                                                       EB00  48
#    SET IO BUFFERS                                                     EB00  49
#    --------------                                                     EB00  50
#                                                                       EB00  51
IOMARK(1)=QXSTR#                       Start of buffer for file a       EB00  52
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of buffer for file b       EB00  53
qxmemory:(IOMARK(2))#                                                   EB00  54
#                                                                       EB00  55
#    READ RECORDS LOOKING FOR CHANGES TO BE MADE                        EB00  56
#    -------------------------------------------                        EB00  57
copyfile:(1,2,1,1)#                    Copy history record              EB00  58
DO IREC=2,bdfendrec:#                  For all records in file ...      EB00  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  EB00  60
PACK=0.0#                              Number of packets                EB00  61
REPEAT#                                Read packets of logical reco     EB00  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  EB00  63
readwpkt:(1,IREC,ISIZE,IPT,0)#         Read next packet                 EB00  64
IF(IPT <= 0)  BREAK#                   Sense end of logical record      EB00  65
IF(IREC==1)#                           Print after history printed      EB00  66
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  EB00  67
writeline:(2,EB003,NEB003,3,3)#        Header for results               EB00  68
writeline:(0,EB004,NEB004,3,3)#        Header for results               EB00  69
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  EB00  70
HEAD=IOLRHD(1)#                        Save logical record head         EB00  71
BUFOT(1)=FLOAT(IOUNIT(1))#             Place unit number in op buff     EB00  72
BUFOT(2)=FLOAT(IOPRCT(1))#             Find current physical record     EB00  73
#                                         Number.                       EB00  74
BUFOT(3)=QX(HEAD+2)#                   Pick up current logical reco     EB00  75
PACK=PACK+1.0#                         Count the packet                 EB00  76
IF(NRQST(IREC)==0)#                    No changes to record             EB00  77
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  EB00  78
writepkt:(2,IREC,ISIZE,JP)#            Point to op packet               EB00  79
movereal:(QX(IPT+1),1,QX(JP+1),1,ISIZE,0)#                              EB00  80
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  EB00  81
ELSE#                                  Changes for this record          EB00  82
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  EB00  83
#                                                                       EB00  84
#----- DIRECTORY-DRIVEN RECORDS -------------                           EB00  85
#                                                                       EB00  86
IF(DIRREC(IREC)==yes:)#                Does record have a directory     EB00  87
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  EB00  88
movereal:(QX(IPT+1),1,WORK(1),1,ISIZE,0)# Working header buffer         EB00  89
#                                                                       EB00  90
# ANALYZE DIRECTORY RECORD FOR EXPECTED IDNUMS                          EB00  91
#                                                                       EB00  92
IF(PACK<1.5)#                          Directory record                 EB00  93
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  EB00  94
JSIZE=ISIZE#                           Output size = input size         EB00  95
#                                                                       EB00  96
# CHECK UP ON EXISTENCE OF ITEMS IN ADD/DELETE/RENAME REQUESTS          EB00  97
#                                                                       EB00  98
FOR(K=1; K <= NRQST(IREC); K=K+1)#     Loop over required ids for r     EB00  99
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  EB00 100
IF(IDNUM(IREC,K)==99999)#                                               EB00 101
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  EB00 102
NCHNG(IREC,K)=NCHNG(IREC,K)+1#                                          EB00 103
NEXT#                                  Delete record request            EB00 104
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  EB00 105
ELSE IF(IDNUM(IREC,K)>30000)#          Decided its a rename             EB00 106
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 EB00 107
ID=IDNUM(IREC,K)-30000#                True id value (without flag)     EB00 108
IFOUND=0#                              Assume item not in direc         EB00 109
DO II=1,JSIZE; IF(WORK(II)==FLOAT(ID)) IFOUND=II# Item in record?       EB00 110
IF(IFOUND==0)#                         Item already in directory        EB00 111
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 EB00 112
IDNUM(IREC,K)=-IDNUM(IREC,K)#          Dont use this edit               EB00 113
ncodefld:(FLOAT(ID),1,EB005,100513.,1)# Format idnum                    EB00 114
writeline:(1,EB005,NEB005,2,3)#        Print missing id nume            EB00 115
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 EB00 116
ID2=NINT(NEWVAL(IREC,K))#              True id value (without flag)     EB00 117
IFOND2=0#                              Assume item not in direc         EB00 118
DO II=1,JSIZE; IF(WORK(II)==FLOAT(ID2)) IFOND2=II# Item in record?      EB00 119
IF(IFOND2!=0)#                         Item already in directory        EB00 120
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 EB00 121
IDNUM(IREC,K)=-IDNUM(IREC,K)#          Dont use this edit               EB00 122
ncodefld:(FLOAT(ID2),1,EB006,100513.,1)# Format idnum                   EB00 123
writeline:(1,EB006,NEB006,2,3)#        Print missing id nume            EB00 124
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 EB00 125
# ITEMS ARE IN IN DIRECTORY                                             EB00 126
IF(IFOUND>0 & IFOND2==0)#                                               EB00 127
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 EB00 128
IFLAG=1#                               Change id num in record          EB00 129
WORK(IFOUND)=ID2#                      New item name                    EB00 130
IDNUM(IREC,K)=-IDNUM(IREC,K)#          Flag request as done             EB00 131
NCHNG(IREC,K)=NCHNG(IREC,K)+1#         Number changes per request       EB00 132
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 EB00 133
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 EB00 134
#--                                                                     EB00 135
ELSE IF(IDNUM(IREC,K)>20000)#          Decided its a deletion           EB00 136
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 EB00 137
ID=IDNUM(IREC,K)-20000#                True id value (without flag)     EB00 138
IFOUND=0#                              Assume item not in direc         EB00 139
DO II=1,JSIZE; IF(WORK(II)==FLOAT(ID)) IFOUND=II# Item in record?       EB00 140
IF(IFOUND==0)#                         Item not in directory            EB00 141
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 EB00 142
IDNUM(IREC,K)=-IDNUM(IREC,K)#          Dont use this edit               EB00 143
ncodefld:(FLOAT(ID),1,EB007,100513.,1)# Format idnum                    EB00 144
writeline:(1,EB007,NEB007,2,3)#        Print missing id nume            EB00 145
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 EB00 146
ELSE#                                  Item in directory                EB00 147
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 EB00 148
IFLAG=1#                               Change to record                 EB00 149
IDINX(K)=IFOUND*(-1)#                  Flag deletion                    EB00 150
DO II=IFOUND,JSIZE-1; WORK(II)=WORK(II+1)# All item slide down one      EB00 151
JSIZE=JSIZE-1#                         Reflect deletion in pkt sz       EB00 152
NCHNG(IREC,K)=NCHNG(IREC,K)+1#         Number changes per request       EB00 153
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 EB00 154
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 EB00 155
#--                                                                     EB00 156
ELSE IF(IDNUM(IREC,K)>10000)#          Decided its an addition          EB00 157
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 EB00 158
ID=IDNUM(IREC,K)-10000#                True id value (without flag)     EB00 159
IFOUND=0#                              Delete pckt not found            EB00 160
DO J=1,JSIZE;IF(ID==NINT(WORK(J))) IFOUND=J# Look thru packets          EB00 161
IF(IFOUND>0)#                                                           EB00 162
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 EB00 163
IDNUM(IREC,K)=-IDNUM(IREC,K)#          Dont use this edit               EB00 164
ncodefld:(FLOAT(ID),1,EB008,100513.,1)# Format idnum                    EB00 165
writeline:(1,EB008,NEB008,2,3)#        Print missing id nume            EB00 166
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 EB00 167
ELSE#                                  Item not found in directory      EB00 168
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 EB00 169
IFLAG=1#                               Record changed                   EB00 170
JSIZE=JSIZE+1#                         Extend record length             EB00 171
WORK(JSIZE)=FLOAT(ID)#                 Put new item into record hea     EB00 172
IDINX(K)=JSIZE#                        Location of new item in head     EB00 173
NCHNG(IREC,K)=NCHNG(IREC,K)+1#         Number changes per re            EB00 174
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 EB00 175
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 EB00 176
#                                                                       EB00 177
# CHECK UP ON EXISTENCE OF ITEMS IN CHANGE REQUESTS                     EB00 178
#                                                                       EB00 179
#--                                                                     EB00 180
ELSE#                                                                   EB00 181
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 EB00 182
ITMPOS=0#                              Assume item not in record        EB00 183
IT2POS=0#                              Assume cond id not in rec        EB00 184
FOR(I=1; I <= JSIZE; I=I+1)#           Loop over catalogue numbers      EB00 185
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 EB00 186
N=I#                                   Get buffer pointer               EB00 187
ID=NINT(WORK(N))#                      Td0                              EB00 188
IF(IDNUM(IREC,K)==ID) ITMPOS=I#        Hold on to id position in re     EB00 189
#                                                                       EB00 190
IF(IDCOND(IREC,K)==ID) IT2POS=I#       Hold on to id position           EB00 191
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 EB00 192
IF(ITMPOS==0)#                         Found non-existent id in rec     EB00 193
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 EB00 194
WRITE(6,*)#                                                             EB00 195
WRITE(6,*) '** ID= ',IDNUM(IREC,K),' NOT FOUND FOR RECORD=',IREC#       EB00 196
WRITE(6,*) '** Change ignored'#                                         EB00 197
IDNUM(IREC,K)=IDNUM(IREC,K)*(-1)#      Flag id as not found in reco     EB00 198
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 EB00 199
ELSE#                                  Id found in record               EB00 200
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 EB00 201
IDINX(K)=ITMPOS#                       Record id position in direct     EB00 202
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 EB00 203
IF(IT2POS==0 & IDCOND(IREC,K)>0)#      Found non-existent cond id       EB00 204
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 EB00 205
WRITE(6,*) '** id=',ID,' not found for record=',IREC#                   EB00 206
WRITE(6,*) 'CONDITION WILL NOT BE USED'#                                EB00 207
IDCOND(IREC,K)=IDCOND(IREC,K)* (-1)#   Flag id as not found in reco     EB00 208
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 EB00 209
ELSE#                                  Id found in record               EB00 210
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 EB00 211
CNDINX(K)=IT2POS#                      Record id position in direct     EB00 212
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 EB00 213
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 EB00 214
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  EB00 215
#                                                                       EB00 216
# PREPARE OUTPUT BUFFER                                                 EB00 217
#                                                                       EB00 218
writepkt:(2,IREC,JSIZE,JP)#            Point to op packet               EB00 219
movereal:(WORK(1),1,QX(JP+1),1,JSIZE,0)# Eb                             EB00 220
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  EB00 221
#                                                                       EB00 222
# NON-DIRECTORY DATA RECORD                                             EB00 223
#                                                                       EB00 224
ELSE#                                  Data records, look for chang     EB00 225
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 EB00 226
IFLAG=0#                               Not a changes record yet         EB00 227
FOR(K=1; K <= NRQST(IREC); K=K+1)#     Loop over required ids for r     EB00 228
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 EB00 229
IF(IDNUM(IREC,K)<0) NEXT#              Already done request             EB00 230
IVALID=0#                              Assume  record fails conditi     EB00 231
IF(IDCOND(IREC,K)==0) IVALID=1#        If no cond, then change reco     EB00 232
ELSE IF(IDCOND(IREC,K)<0)#             Conditional packet numbers       EB00 233
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 EB00 234
IF(PACK<=LECOND(IREC,K) & $#                                            EB00 235
   PACK>=GECOND(IREC,K) )  IVALID=1#   Yes, record passes condition     EB00 236
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 EB00 237
ELSE#                                  Check out condition for chan     EB00 238
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 EB00 239
N=IPT+CNDINX(K)#                       Get condition id index           EB00 240
IF(QX(N)<=LECOND(IREC,K) & $#                                           EB00 241
   QX(N)>=GECOND(IREC,K) )  IVALID=1#  Yes, record passes condition     EB00 242
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 EB00 243
IF(IVALID==1)#                         Record meets conditional?        EB00 244
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 EB00 245
IF(IDNUM(IREC,K)>0)#                   Positive id means found in d     EB00 246
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 EB00 247
IF(IDNUM(IREC,K)==99999)#              Delete record?                   EB00 248
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 EB00 249
NCHNG(IREC,K)=NCHNG(IREC,K)+1#                                          EB00 250
NEXT#                                  Yes, don't write out packet      EB00 251
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 EB00 252
ELSE IF(IDINX(K)<0)#                   Negative id,itm deletion         EB00 253
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 EB00 254
IFLAG=1#                               Change to record                 EB00 255
DO II=IABS(IDINX(K)),511; WORK(II)=WORK(II+1)# Items move over          EB00 256
NCHNG(IREC,K)=NCHNG(IREC,K)+1#         Number changes per request       EB00 257
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 EB00 258
ELSE#                                  Addition or change               EB00 259
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 EB00 260
N=IDINX(K)#                            Pointer to item to be change     EB00 261
WORK(N)=NEWVAL(IREC,K)#                Update record as requested       EB00 262
NVCHNG=NVCHNG+1#                       Keep track of values changed     EB00 263
IFLAG=1#                               Note record changed              EB00 264
NCHNG(IREC,K)=NCHNG(IREC,K)+1#         Number changes per request       EB00 265
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 EB00 266
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 EB00 267
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 EB00 268
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 EB00 269
#                                                                       EB00 270
# PREPARE OUTPUT BUFFER                                                 EB00 271
#                                                                       EB00 272
writepkt:(2,IREC,JSIZE,JP)#            Point to op packet               EB00 273
movereal:(WORK(1),1,QX(JP+1),1,JSIZE,0)# Eb                             EB00 274
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 EB00 275
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  EB00 276
#                                                                       EB00 277
#----- NOT DIRECTORY-DRIVEN RECORDS -------------                       EB00 278
#                                                                       EB00 279
ELSE#                                                                   EB00 280
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 EB00 281
#                                                                       EB00 282
# CONDUCT CHANGES TO DATA RECORDS                                       EB00 283
#                                                                       EB00 284
IFLAG=0#                                                                EB00 285
FOR(K=1; K <= NRQST(IREC); K=K+1)#     Loop over required ids for r     EB00 286
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 EB00 287
IVALID=0#                              Assume  record will fail con     EB00 288
IF(IDCOND(IREC,K)==0) IVALID=1#        If no cond, then change reco     EB00 289
ELSE IF(IDCOND(IREC,K)<0)#             Conditional packet numbers       EB00 290
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 EB00 291
IF(PACK<=LECOND(IREC,K) & $#                                            EB00 292
   PACK>=GECOND(IREC,K) )  IVALID=1#   Yes, record passes condition     EB00 293
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 EB00 294
ELSE#                                  Evaluate condition on change     EB00 295
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 EB00 296
N=IPT+IDCOND(IREC,K)#                  Get condition id index           EB00 297
IF(QX(N)<=LECOND(IREC,K) & $#                                           EB00 298
   QX(N)>=GECOND(IREC,K) )  IVALID=1#  Yes, record passes condition     EB00 299
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 EB00 300
IF(IVALID==1)#                         Actually make change             EB00 301
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 EB00 302
IF(IDNUM(IREC,K)==99999)#              Delete record                    EB00 303
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 EB00 304
IFLAG=99999#                           Note record changed              EB00 305
NCHNG(IREC,K)=1+NCHNG(IREC,K)#                                          EB00 306
BREAK#                                 Don't write out record           EB00 307
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 EB00 308
ELSE#                                  Record must be changed           EB00 309
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 EB00 310
N=IPT+IDNUM(IREC,K)#                   Pointer to item to be change     EB00 311
QX(N)=NEWVAL(IREC,K)#                  Update record as requested       EB00 312
NCHNG(IREC,K)=NCHNG(IREC,K)+1#         Number changes per re            EB00 313
NVCHNG=NVCHNG+1#                       Keep track of values changed     EB00 314
IFLAG=1#                               Note record changed              EB00 315
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 EB00 316
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 EB00 317
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 EB00 318
#                                                                       EB00 319
IF (IFLAG!=99999)#                     If not a current delpkt          EB00 320
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 EB00 321
writepkt:(2,IREC,ISIZE,JP)#            Point to op packet               EB00 322
movereal:(QX(IPT+1),1,QX(JP+1),1,ISIZE,0)# Transfer input to output     EB00 323
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 EB00 324
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 EB00 325
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  EB00 326
IF(IFLAG!=0) NRCHNG=NRCHNG+1#          Keep track of any rec change     EB00 327
IFLAG=0#                                                                EB00 328
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  EB00 329
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  EB00 330
copyfile:(1,2,endrecord:,endrecord:)#  Copy last record close files     EB00 331
#                                                                       EB00 332
# REPORT RESULTS                                                        EB00 333
# --------------                                                        EB00 334
#                                                                       EB00 335
WRITE(6,*) 'LOGICAL RECORD      REQUEST NO.       NO. CHANGES'#         EB00 336
DO J=1,bdfendrec:#                     For all records                  EB00 337
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 EB00 338
IF(NRQST(J)==0) NEXT#                  No requests for this record      EB00 339
DO I=1,NRQST(J)#                                                        EB00 340
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 EB00 341
WRITE(6,*) J,I,NCHNG(J,I)#                                              EB00 342
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 EB00 343
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 EB00 344
ncodefld:(FLOAT(NRCHNG),1,EB001,251013.,1)#                             EB00 345
writeline:(1,EB001,NEB001,3,3)#        Write changes to log             EB00 346
ncodefld:(FLOAT(NVCHNG),1,EB002,251013.,1)#                             EB00 347
writeline:(0,EB002,NEB002,3,3)#        Write changes to log             EB00 348
#                                                                       EB00 349
RETURN#                                                                 EB00 350
END#                                                                    EB00 351
systemheader:(EB01)#                   Read input cards                 EB01   1
#######################################################                 EB01   2
#                                                                       EB01   3
#                      MEB01                                            EB01   4
#                                                                       EB01   5
#######################################################                 EB01   6
SUBROUTINE EB01#                                                        EB01   7
#                                                                       EB01   8
include:(AACOMN)#                                                       EB01   9
include:(EBCOMN)#                                                       EB01  10
chardata:(VOID,[VOID])#                Allowed character fields         EB01  11
chardata:(PACKET,[PACKALL     ])#      On change card                   EB01  12
chardata:(EB10,NONE LABL NONE CELL SYMM NONE NONE$#                     EB01  13
 SCAT SEQU DDEF EXPL DSET DICT NONE NONE ATOM$#                         EB01  14
 CONS SLAV NONE REFL NONE NONE )#                                       EB01  15
chardata:(EB11, END    CHANGE ADDITM DELITM RENAME DELPKT  )#           EB01  16
chardata:(EB12,PRI)#                   First 3 letters from options     EB01  17
chardata:(EB13,EDITS requested:)#                                       EB01  18
chardata:(EB14,[===============])#                                      EB01  19
chardata:(EB15,                                        CONDITIONAL$#    EB01  20
     )#                                                                 EB01  21
chardata:(EB151,                                ------------------$#    EB01  22
-----)#                                                                 EB01  23
chardata:(EB152,--------------------------------------------------$#    EB01  24
---------------)#                                                       EB01  25
chardata:(EB17,RECORD   ITEM   NEW VALUE       ITEM       <=    >=$#    EB01  26
        TYPE   )#                                                       EB01  27
chardata:(EB18,warnings:)#                                              EB01  28
datastuff:#                                                             EB01  29
#                                                                       EB01  30
PRINT=no:#                                                              EB01  31
#                                                                       EB01  32
#  DECIPHER REST OF EDTBDF LINE                                         EB01  33
#  ----------------------------                                         EB01  34
#                                                                       EB01  35
J=1; REPEAT#                           Loop over input fields           EB01  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  EB01  37
J=J+1 ; ifvo:(BUFIN(J)) BREAK#         Quit at first void field         EB01  38
IF(BUFIN(J)<voidflg:)#                 Must be characters               EB01  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  EB01  40
stringlim:(J,I1,I2)#                   Get position of parameter        EB01  41
compchar:(CHRIN,I1,EB12,1,3,3,NEB12,MODE)# Check for expected param     EB01  42
IF(MODE==1) PRINT = yes:#              Print changed records to out     EB01  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  EB01  44
ELSE iquit:(EB0102)#                   Illegal parameter on card        EB01  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  EB01  46
#                                                                       EB01  47
#  INITIALIZE VALUES SET BY INPUT CARDS                                 EB01  48
#  ------------------------------------                                 EB01  49
#                                                                       EB01  50
DO I=1,bdfendrec:#                     Initialize for all records       EB01  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  EB01  52
NRQST(I)=0#                            No changes for each record       EB01  53
DO J=1,lim:#                           Initialize for all changes       EB01  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  EB01  55
IDCOND(I,J)=0#                                                          EB01  56
LECOND(I,J)=mnfpnbr:#                  Lower condition limit            EB01  57
GECOND(I,J)=(-1.0) * mnfpnbr:#         Upper condition limit            EB01  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  EB01  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  EB01  60
#                                                                       EB01  61
#  READ INPUT CARDS                                                     EB01  62
#  ----------------                                                     EB01  63
#                                                                       EB01  64
writeline:(2,EB13,NEB13,3,3)#          Write changes to log             EB01  65
writeline:(0,EB14,NEB14,3,3)#          Write changes to log             EB01  66
writeline:(1,EB15,NEB15,3,3)#          Write changes to log             EB01  67
writeline:(0,EB151,NEB151,3,3)#        Write changes to log             EB01  68
writeline:(0,EB17,NEB17,3,3)#          Write changes to log             EB01  69
writeline:(0,EB151,NEB151,3,3)#        Write changes to log             EB01  70
REPEAT#                                Loop to read cards               EB01  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  EB01  72
readline:(EB11,NEB11)#                 Get next input line              EB01  73
#                                                                       EB01  74
#  CHANGE/ADDITM/DELITM/RENAME/DELPKT  CARDS                            EB01  75
#  ---------------------------                                          EB01  76
#                                                                       EB01  77
IF (LINID >= 2 & LINID <=6)#           All options need rec design      EB01  78
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  EB01  79
# ** ** ** GET FIELD 1 = REC # ** ** **                                 EB01  80
#                                                                       EB01  81
ifvo:(BUFIN(1)) iquit:(EB0101)#        Missing rec, id, newval          EB01  82
IF(BUFIN(1)<=voidflg:)#                Rec value is character           EB01  83
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  EB01  84
stringlim:(1,I,J)#                     Get position of parameter        EB01  85
compchar:(CHRIN,I,EB10,1,4,5,NEB10,K)# Check for record name            EB01  86
IF(K!=0)#                              Found record name                EB01  87
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  EB01  88
IREC=K#                                Assign appropriate rec no.       EB01  89
IWHICH=5*(K-1)+1#                      Position in name list            EB01  90
movechar:(EB10,IWHICH,CHROT,2,4,0)#    Report character parameter       EB01  91
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  EB01  92
ELSE#                                  Illegal rec name                 EB01  93
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  EB01  94
WRITE(6,*) CHRIN(I^J),' NOT RECORD NAME - EDIT IGNORED'#                EB01  95
NEXT#                                  Skip edit                        EB01  96
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  EB01  97
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  EB01  98
ELSE ifnv:(BUFIN(1))#                                                   EB01  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 EB01 100
IREC=NINT(BUFIN(1))#                   Record number for change         EB01 101
IWHICH=5*(IREC-1)+1#                   Position in name list            EB01 102
movechar:(EB10,IWHICH,CHROT,2,4,0)#    Report character parameter       EB01 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 EB01 104
IF(IREC>bdfendrec:)#                   Record number too large          EB01 105
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 EB01 106
WRITE(6,*) IREC ,' NOT LEGAL RECORD  - EDIT IGNORED'#                   EB01 107
NEXT#                                  Skip edit                        EB01 108
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 EB01 109
IF(LINID>2 & LINID<6 & DIRREC(IREC)!=yes:)# Repl/add/del dir rec        EB01 110
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 EB01 111
WRITE(6,*) '**',IREC,' not INDEXED record,cannot add,replace,delete'#   EB01 112
NEXT#                                  Skip impossible request          EB01 113
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 EB01 114
NRQST(IREC)=NRQST(IREC)+1#             Update no. changes per recor     EB01 115
INEXT=NRQST(IREC)#                     Pointer to new info              EB01 116
IF(INEXT>lim:) iquit:(EB0110)#         Requests cannot exceed limit     EB01 117
#                                                                       EB01 118
# ** ** ** GET FIELD 2 = ID NUM TO CHANGE ** ** **                      EB01 119
#                                                                       EB01 120
IF(LINID==6)#                          Delete record opt                EB01 121
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 EB01 122
IDNUM(IREC,INEXT)=99999#               Flag delpkt option with 9999     EB01 123
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 EB01 124
ELSE#                                                                   EB01 125
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 EB01 126
ifvo:(BUFIN(2)) iquit:(EB0103)#        Must have item number            EB01 127
IDNUM(IREC,INEXT)=NINT(BUFIN(2))#      Item number change               EB01 128
IF(LINID==3) IDNUM(IREC,INEXT)=IDNUM(IREC,INEXT)+10000# Flag add        EB01 129
IF(LINID==4) IDNUM(IREC,INEXT)=IDNUM(IREC,INEXT)+20000# Flag delitm     EB01 130
IF(LINID==5) IDNUM(IREC,INEXT)=IDNUM(IREC,INEXT)+30000# Flag delpkt     EB01 131
ncodefld:(BUFIN(2),1,CHROT,110513.,1)# Put out id number                EB01 132
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 EB01 133
# ** ** ** GET FIELD 3 = NEW VALUE ** ** **                             EB01 134
#                                                                       EB01 135
IF(LINID>=2 & LINID<=3)#               Change or add                    EB01 136
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 EB01 137
ifvo:(BUFIN(3)) iquit:(EB0104)#        Must have new value              EB01 138
NEWVAL(IREC,INEXT)=BUFIN(3)#           New item value                   EB01 139
IF(NEWVAL(IREC,INEXT)<=voidflg:)#      New value is character           EB01 140
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 EB01 141
stringlim:(3,I,J)#                     Get position of parameter        EB01 142
compchar:(CHRIN,I,VOID,1,4,4,4,K)#     Check for void param       m     EB01 143
IF(K!=0)  NEWVAL(IREC,INEXT)=voidflg:# Void                             EB01 144
ELSE#                                                                   EB01 145
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 EB01 146
movector:(BLANK,1,NEWVAL(IREC,INEXT),1,4,1)# Put char value into real   EB01 147
movector:(CHRIN,I,NEWVAL(IREC,INEXT),1,J-1,0)# Put char value into re   EB01 148
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 EB01 149
movechar:(CHRIN,I,CHROT,20,J-I,0)#     Report character parameter       EB01 150
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 EB01 151
ELSE ncodefld:(BUFIN(3),1,CHROT,241032.,1)# Non-char parameter          EB01 152
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 EB01 153
#                                                                       EB01 154
# ** ** ** GET FIELD 4 = COMPARISON ITEM ** ** **                       EB01 155
#                                                                       EB01 156
IF(LINID==2 \ LINID==6)#               Selectivity of change|delpkt     EB01 157
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 EB01 158
ifvo:(BUFIN(4))#                                                        EB01 159
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 EB01 160
WRITE(6,*) ' ** Need qualifier on change/delpkt card'#                  EB01 161
WRITE(6,*) ' REC= ',IREC,'ITEM= ',IDNUM(IREC,INEXT),'   Ignored'#       EB01 162
NRQST(IREC)=NRQST(IREC)-1#             Forget this change               EB01 163
NEXT#                                                                   EB01 164
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 EB01 165
ifnv:(BUFIN(4))#                       Conditional is described ...     EB01 166
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 EB01 167
IF(BUFIN(4)<voidflg:)#                 Character value in field 4?      EB01 168
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 EB01 169
stringlim:(4,I,J)#                     Get position of character va     EB01 170
compchar:(CHRIN,I,PACKET,1,4,4,NPACKET,K)# Check for packet param       EB01 171
IF(K==0)#                              Illegal character value          EB01 172
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 EB01 173
WRITE(6,*) ' ** Illegal character value in field 4 '# Eb01 119          EB01 174
WRITE(6,*) ' REC= ',IREC,'ITEM= ',IDNUM(IREC,INEXT),'   Ignored'#       EB01 175
NRQST(IREC)=NRQST(IREC)-1#             Forget this change               EB01 176
NEXT#                                                                   EB01 177
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 EB01 178
ELSE IF(K==1)#                                                          EB01 179
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 EB01 180
IDCOND(IREC,INEXT)=-1#                 Flag packet conditional          EB01 181
movechar:(CHRIN,I,CHROT,28,J-I,0)#     Report character parameter       EB01 182
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 EB01 183
ELSE IF(K==2)#                                                          EB01 184
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 EB01 185
movechar:(CHRIN,I,CHROT,28,J-I,0)#     Report character parameter       EB01 186
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 EB01 187
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 EB01 188
ELSE#                                  Item number in field 4           EB01 189
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 EB01 190
ncodefld:(BUFIN(4),1,CHROT,300513.,1)# Non-char value                   EB01 191
IDCOND(IREC,INEXT)=NINT(BUFIN(4))#     Store id number as integer       EB01 192
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 EB01 193
#                                                                       EB01 194
# ** ** ** GET FIELD 5 = LOW COMPARISON VALUE ** ** **                  EB01 195
#                                                                       EB01 196
ifnv:(BUFIN(5))#                                                        EB01 197
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 EB01 198
LECOND(IREC,INEXT)=BUFIN(5)#           Get conditional comparison v     EB01 199
IF(LECOND(IREC,INEXT)<voidflg:)#       Void/string value                EB01 200
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 EB01 201
stringlim:(5,I,J)#                     Get position of parameter        EB01 202
compchar:(CHRIN,I,VOID,1,4,4,4,K)#     Check for void param       m     EB01 203
IF(K!=0)  LECOND(IREC,INEXT)=voidflg:# Void requested                   EB01 204
ELSE#                                  Character new value              EB01 205
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 EB01 206
movector:(BLANK,1,LECOND(IREC,INEXT),1,4,1)# Put char value into real   EB01 207
movector:(CHRIN,I,LECOND(IREC,INEXT),1,J-I,0)# Put char value into re   EB01 208
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 EB01 209
movechar:(CHRIN,I,CHROT,41,J-I,0)#     Report character parameter       EB01 210
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 EB01 211
ELSE ncodefld:(BUFIN(5),1,CHROT,451032.,1)# Non-char value              EB01 212
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 EB01 213
#                                                                       EB01 214
# ** ** ** GET FIELD 6 = UPPER COMPARISON VALUE ** ** **                EB01 215
#                                                                       EB01 216
ifnv:(BUFIN(6))#                                                        EB01 217
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 EB01 218
GECOND(IREC,INEXT)=BUFIN(6)#           Get conditional comparison v     EB01 219
IF(GECOND(IREC,INEXT)<voidflg:)#       Void/string value                EB01 220
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 EB01 221
stringlim:(6,I,J)#                     Get position of parameter        EB01 222
compchar:(CHRIN,I,VOID,1,4,4,4,K)#     Check for void param       m     EB01 223
IF(K!=0)  GECOND(IREC,INEXT)=voidflg:# Void requested                   EB01 224
ELSE#                                  Character new value              EB01 225
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 EB01 226
movector:(BLANK,1,GECOND(IREC,INEXT),1,4,1)# Put char value into real   EB01 227
movector:(CHRIN,I,GECOND(IREC,INEXT),1,J-I,0)# Put char value into re   EB01 228
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 EB01 229
movechar:(CHRIN,I,CHROT,53,J-I,0)#     Report character parameter       EB01 230
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 EB01 231
ELSE ncodefld:(BUFIN(6),1,CHROT,571032.,1)# Non-char value              EB01 232
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 EB01 233
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 EB01 234
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 EB01 235
# WRITE INPUTTED VALUES TO OUTPUT LOG FOR VERIFICATION                  EB01 236
# ----------------------------------------------------                  EB01 237
IF(LINID==2) movechar:('CHANGE',1,CHROT,64,6,0)# Change card            EB01 238
ELSE IF(LINID==3) movechar:('ADD   ',1,CHROT,64,6,0)# Additm card       EB01 239
ELSE IF(LINID==4) movechar:('DELETE',1,CHROT,64,6,0)# Delitm card       EB01 240
ELSE IF(LINID==5) movechar:('RENAME',1,CHROT,64,6,0)# Rename card       EB01 241
ELSE movechar:('DELPKT',1,CHROT,64,6,0)# Delpkt card                    EB01 242
writeline:(0,0,0,1,3)#                 Write changes to log             EB01 243
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  EB01 244
ELSE IF (LINID==1) BREAK#              End card found                   EB01 245
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  EB01 246
RETURN#                                                                 EB01 247
END#                                                                    EB01 248
pmacro:([no:])#                        Purge xtal system macros         EB01 249
