systemheader:(ED    )#                                                  ED     1
####################################################################### ED     2
##            Copyright (C) 2001, The GNU Xtal System                 # ED     3
## Distributed under the GNU General Public Licence as published by   # ED     4
## the Free Software Foundation, in the hope that it will be useful   # ED     5
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # ED     6
## for more details.                                                  # ED     7
##                                                                    # ED     8
##                        *** EXPAND ***                              # ED     9
##                                                                    # ED    10
##   Expand or contract atom site list to total list of sites in      # ED    11
##   the unit cell(s)                                                 # ED    12
##                                                                    # ED    13
##          D. du Boulay Nov 2001 ddb@R3401.msl.titec.ac.jp           # ED    14
##                                                                    # ED    15
####################################################################### ED    16
##                                                                      ED    17
include:(XMACRO)#                                                       ED    18
##                                                                      ED    19
macro:(atomlist:,[ifelse:($1,,IA,$1)])# Define atom list pointer        ED    20
macro:(na:,[QX(atomlist:($1)+ IREL(1))])# Define start of atom name     ED    21
macro:(ty:,[QX(atomlist:($1)+ IREL(2))])# Define atom type number       ED    22
macro:(xf:,[QX(atomlist:($1)+ IREL(3))])# Define frac x coord           ED    23
macro:(yf:,[QX(atomlist:($1)+ IREL(4))])# Define frac y coord           ED    24
macro:(zf:,[QX(atomlist:($1)+ IREL(5))])# Define frac z coord           ED    25
macro:(uij:,[QX(atomlist:($1)+IREL(7))])# Define u11                    ED    26
##                                                                      ED    27
extrude:(EDCOMN)#                                                       ED    28
#                                                                       ED    29
INTEGER MARKA,STEPA,STOPA#                                              ED    30
INTEGER MARKB,STEPB,STOPB#                                              ED    31
INTEGER MARKS,STEPS,STOPS#                                              ED    32
INTEGER NCELL#                                                          ED    33
INTEGER ISTRIP#                                                         ED    34
INTEGER IREL(20)#                                                       ED    35
REAL    TOLC#                       distance test tolerance
REAL    SSTOLC#                     site symmetry test tolerance
REAL    G1,G2,G3,G4,G5,G6
#                                                                       ED    36
COMMON/COMIED/MARKA,STEPA,STOPA,MARKB,STEPB,STOPB,$#                    ED    37
MARKS,STEPS,STOPS,NCELL,ISTRIP,IREL#                                    ED    38
#
COMMON/COMFED/G1,G2,G3,G4,G5,G6,TOLC,SSTOLC#
#                                                                       ED    39
endext:#                                                                ED    40
systemheader:(ED00)#                                                    ED00   1
####################################################################### ED00   2
#                                                                     # ED00   3
#                          ED00                                       # ED00   4
#                                                                     # ED00   5
####################################################################### ED00   6
SUBROUTINE ED00#                                                        ED00   7
include:(AACOMN)#                                                       ED00   8
include:(EDCOMN)#                                                       ED00   9
#                                                                       ED00  10
CALL ED10#                             Read archive bdf                 ED00  11
IF(NCELL!=0) CALL ED15#                Expand cell contents             ED00  12
ELSE         CALL ED20#                Reduce to independents           ED00  13
CALL ED17#                             Process cells lines              ED00  14
CALL ED25#                             Write old archive bdf            ED00  15
#                                                                       ED00  16
RETURN#                                                                 ED00  17
END#                                                                    ED00  18
systemheader:(ED10)#                                                    ED10   1
####################################################################### ED10   2
#                                                                     # ED10   3
#                          ED10                                       # ED10   4
#                                                                     # ED10   5
####################################################################### ED10   6
SUBROUTINE ED10#                                                        ED10   7
include:(AACOMN)#                                                       ED10   8
include:(EDCOMN)#                                                       ED10   9
#                                                                       ED10  10
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              ED10  11
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              ED10  12
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              ED10  13
realdata:(TR21,[.3333333,.5])#                                          ED10  14
realdata:(TR22,[.6666667,0.])#                                          ED10  15
realdata:(TR23,[.6666667,.5])#                                          ED10  16
INTEGER IWNT(20),KEY(5)#                                                ED10  17
INTEGER PSIZ#                                                           ED10  18
#                                                                       ED10  19
chardata:(ED10A,NOT NOS CEL TOL STO )#   
chardata:(ED41,-)#                                                      ED10  21
chardata:(ED42, EXPAND CONTROL PARAMETERS)#                             ED10  22
chardata:(ED10C," Eliminating redundant atom sites")#                   ED10  23
chardata:(ED10D," Expanding atom sites to cell level N")#               ED10  24
datastuff:#                                                             ED10  25
#                                                                       ED10  26
#      SET MEMORY FOR IO BUFFERS                                        ED10  27
#      -------------------------                                        ED10  28
#                                                                       ED10  29
IOMARK(1)=QXSTR#                       Start of file a buffer           ED10  30
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of file b buffer           ED10  31
incrqx:(MARKS,QXSTR+2*bdfbuf:,ED1025)# Expand buffer qx                 ED10  32
copyfile:(1,2,1,decr:(lrcell:))#                                        ED10  33
#                                                                       ED10  34
#      READ EXPAND LINE                                                 ED10  35
#      ----------------                                                 ED10  36
#                                                                       ED10  37
TOLC=0.01#                             0.1 Angstroms squared
SSTOLC=0.16#                           0.4 Angstroms squared  
NCELL=1#                                                                ED10  38
ISTRIP=1#                              Strip label fields on not!       ED10  39
FOR(K=1;BUFIN(K)!=voidflg:;K=K+1)#     Loop over input fields           ED10  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  ED10  41
stringlim:(K,I,J)#                     Find string limits               ED10  42
compchar:(CHRIN,I,ED10A,1,3,4,NED10A,L)# Search for match               ED10  43
IF    (L==1) NCELL=0#                  **** not! option  *****          ED10  44
ELSEIF(L==2) ISTRIP=0#                 **** no strip option ******      ED10  45
ELSEIF(L==3)#                          **** cells option ******         ED10  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  ED10  47
ifnm:(BUFIN(K+1))NCELL=NINT(BUFIN(K+1))# How many cells?                ED10  48
ELSE iquit:(ED1001)#                                                    ED10  49
IF(NCELL<0\NCELL>4) iquit:(ED1001)#                                     ED10  50
K=K+1#                                                                  ED10  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  ED10  52
ELSEIF(L==4)#                          **** TOLC option ******       
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2 
ifnm:(BUFIN(K+1)) TOLC=Min(10.,Max(0.0,BUFIN(K+1)))# valid range
ELSE iquit:(ED1003)#                                                   
TOLC=TOLC*TOLC#                        squared for testing purposes
K=K+1#                                                                 
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2 
ELSEIF(L==5)#                          **** STOLC option ******       
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2 
ifnm:(BUFIN(K+1)) SSTOLC=Min(10.,Max(-1.0,BUFIN(K+1)))# valid range
ELSE iquit:(ED1003)#                                                   
SSTOLC=SSTOLC*SSTOLC#                  squared for testing purposes
K=K+1#                                                                 
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2 
ELSE iquit:(ED1002)#                                                    ED10  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  ED10  54
#                                                                       ED10  55
#    LIST CALCULATION PARAMETERS                                        ED10  56
#    ---------------------------                                        ED10  57
#                                                                       ED10  58
LINRM=10#                              Force parameter header           ED10  59
movechar:(ED41,1,CHROT,2,NED42-1,2)#   Underline header                 ED10  60
writeline:(1,ED42,NED42,1,3)#          Print calculation header         ED10  61
#                                                                       ED10  62
IF(NCELL<1) writeline:(0,ED10C,NED10C,3,3)# Reducing cell content       ED10  63
ELSE#                                                                   ED10  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  ED10  65
ncodefld:(FLOAT(NCELL),1,ED10D,370113.,1)# Format cell level            ED10  66
writeline:(0,ED10D,NED10D,3,3)#        Expanding cell content           ED10  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  ED10  68
#                                                                       
#      READ REAL CELL PARAMETERS FROM LRCELL                            
#      -------------------------------------                            
#                                                                       
DO I=1,8#                              Loop over lrcell: packets        
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Read the next pkt                
IF(IP<=0) BREAK#                       End of logical record            
writepkt:(2,lrcell:,PSIZ,IPP)#         Copy sym. rel. rotat             
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Transfer symm. rel. rotations    
IF(I==7)#                              Test if metric tensor            
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 
G1=QX(IP+1)#                           A**2                             
G2=QX(IP+5)#                           B**2                             
G3=QX(IP+9)#                           C**2                             
G4=QX(IP+2)*2.#                        2 a b cosg                       
G5=QX(IP+3)*2.#                        2 a c cosb                       
G6=QX(IP+6)*2.#                        2 b c cosa                       
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 
$)
#                                                                       ED10  69
#      READ SYMMETRY INFORMATION FROM LRSYMM                            ED10  70
#      -------------------------------------                            ED10  71
#                                                                       ED10  72
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Read the 1st sym pkt             ED10  73
writepkt:(2,lrsymm:,PSIZ,IPP)#         Copy sym. rel. rotat             ED10  74
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Transfer symm. rel. rotations    ED10  75
LATYP=NINT(QX(IP+1))#                  Lattice type                     ED10  76
NCENT=NINT(QX(IP+2))#                  Centric / acentric  0/1          ED10  77
NOSYM=NINT(QX(IP+3))#                  Total no of symm. rel. rot.      ED10  78
ZMOLE=QX(IP+3)#                        Number of moles/cell             ED10  79
incrqx:(MARK0,MARKS+NOSYM*PSIZ,ED1028)# Memory for symop table          ED10  80
FOR(J=MARKS;J>0;J=J+PSIZ)#             Loop thro. symm. rec.            ED10  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  ED10  82
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Read sym. rel. rotat             ED10  83
IF(IP<=0) BREAK#                       Finished                         ED10  84
writepkt:(2,lrsymm:,PSIZ,IPP)#         Copy sym. rel. rotat             ED10  85
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Transfer symm. rel. rotations    ED10  86
movereal:(QX,IP+1,QX,J+1,PSIZ,1)#      Store symm. rel. rotations       ED10  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  ED10  88
STEPS=PSIZ#                            Step through sym. rec.           ED10  89
STOPS=J#                               End of sym. rec. read in         ED10  90
N=STOPS-MARKS#                         Number of elements               ED10  91
IF(NCENT==0)#                          In case of centrosymmetry    ^   ED10  92
DO J=1,N; QX(STOPS+J)=-QX(MARKS+J)#    Set centro elements          ^   ED10  93
STOPS=STOPS+(1-NCENT)*N#               Reset current upper limit        ED10  94
IF(LATYP>7) LATYP=LATYP-7#             Reduce to centrosymmetric        ED10  95
K=STOPS#                               Store temp end marker        ^   ED10  96
IF(LATYP>1)#                           Add symmops if non-primitive     ED10  97
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symm matrices          ED10  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  ED10  99
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            ED10 100
QX(K+10)=QX(J+10)+TR11(LATYP-1)#       Transfer t1                      ED10 101
QX(K+11)=QX(J+11)+TR12(LATYP-1)#       Transfer t2                      ED10 102
QX(K+12)=QX(J+12)+TR13(LATYP-1)#       Transfer t3                      ED10 103
K=K+STEPS#                             Incr storage pointer             ED10 104
IF((LATYP==2)\(LATYP>4)) NEXT#         Skip if not r or f               ED10 105
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            ED10 106
QX(K+10)=QX(J+10)+TR21(LATYP-2)#       Transfer t1                      ED10 107
QX(K+11)=QX(J+11)+TR22(LATYP-2)#       Transfer t2                      ED10 108
QX(K+12)=QX(J+12)+TR23(LATYP-2)#       Transfer t3                      ED10 109
K=K+STEPS#                             Incr storage pointer             ED10 110
IF(LATYP!=4) NEXT#                     Skip if not f-centre             ED10 111
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            ED10 112
QX(K+10)=QX(J+10)+0.5#                 Transfer t1                      ED10 113
QX(K+11)=QX(J+11)+0.5#                 Transfer t2                      ED10 114
QX(K+12)=QX(J+12)+0.0#                 Transfer t3                      ED10 115
K=K+STEPS#                             Incr storage pointer             ED10 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  ED10 117
STOPS=MARK0#                           End of symops.                   ED10 118
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symmetry matrices      ED10 119
DO I=10,12; QX(J+I)=MOD(5.+QX(J+I),1.)# Store translation modulo 1.     ED10 120
MARKA=STOPS#                                                            ED10 121
STOPA=MARKA#                                                            ED10 122
copyfile:(1,2,incr:(lrsymm:),decr:(lratom:))# Copy archive              ED10 123
#                                                                       ED10 124
#  ENTER ATOM DATA FROM LRATOM                                          ED10 125
#  ---------------------------                                          ED10 126
#                                                                       ED10 127
IWNT(1)=14;      IWNT(2)=22#           Request name and sfnum           ED10 128
DO I=1,10;  IWNT(I+ 2)=I#              Request x,y,z,u,uij              ED10 129
DO I=1,3;   IWNT(I+12)=I+100#          Request sigma x,y,z              ED10 130
IWNT(16)=23; IWNT(17)=11; IWNT(18)=21# Request dp-switch, pp, mult      ED10 131
KEY(1)=5; KEY(2)=18; KEY(3)=0; KEY(4)=0# Search parameters              ED10 132
indexpkt:(1,lratom:,STEPA,IP,2,KEY,IWNT,IREL)# Search atom record       ED10 133
IF(KEY(4)<0\IP<0) iquit:(BN2103)#      Atom record missing              ED10 134
FOR(IA=STOPA;IA>0;IA=STOPA)#           Loop over atom record            ED10 135
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  ED10 136
readwpkt:(1,lratom:,PSIZ,IP,0)#        Read atom record - no copy       ED10 137
IF(IP<=0) BREAK#                       Exit if no more                  ED10 138
incrqx:(STOPA,IA+STEPA,PG1040)#        Expand qx for one atom + eigen   ED10 139
movereal:(QX,IP+1,QX,IA+1,STEPA,1)#    Store whole record               ED10 140
#WRITE(6,*) LABEL, TY:,XF:,YF:,ZF:                                      ED10 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  ED10 142
MARKB=STOPA#                                                            ED10 143
STOPB=MARKB#                                                            ED10 144
STEPB=STEPA#                                                            ED10 145
#                                                                       ED10 146
RETURN#                                                                 ED10 147
END#                                                                    ED10 148
systemheader:(ED15)#                   Expand sites to all in cell      ED15   1
####################################################################### ED15   2
#                                                                     # ED15   3
#                          ED15                                       # ED15   4
#                                                                     # ED15   5
####################################################################### ED15   6
SUBROUTINE ED15#                                                        ED15   7
include:(AACOMN)#                                                       ED15   8
include:(EDCOMN)#                                                       ED15   9
#                                                                       ED15  10
string:(LABX,5)#                                                        ED15  11
string:(LABEL,24)#                                                      ED15  12
REAL UOUT(6)#                                                           ED15  13
datastuff:#                                                             ED15  14
#                                                                       ED15  15
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over originals              ED15  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  ED15  17
MX=STOPB#                                                               ED15  18
A=xf:;B=yf:;C=zf:#                                                      ED15  19
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symops                 ED15  20
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  ED15  21
X=A*QX(J+1)+B*QX(J+4)+C*QX(J+7)+QX(J+10)# Get x                         ED15  22
Y=A*QX(J+2)+B*QX(J+5)+C*QX(J+8)+QX(J+11)# Get y                         ED15  23
Z=A*QX(J+3)+B*QX(J+6)+C*QX(J+9)+QX(J+12)# Get z                         ED15  24
X=MOD(99.+X,1.)#                       Transform to first cell          ED15  25
Y=MOD(99.+Y,1.)#                       Transform to first cell          ED15  26
Z=MOD(99.+Z,1.)#                       Transform to first cell          ED15  27
#                                                                       ED15  28
FOR(IB=MX;IB<STOPB;IB=IB+STEPA)#       Loop over transformed            ED15  29
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  ED15  30
ifne:(xf:(IB),X,.001) NEXT#            No match                         ED15  31
ifne:(yf:(IB),Y,.001) NEXT#                                             ED15  32
ifne:(zf:(IB),Z,.001) NEXT#                                             ED15  33
GOTO 99#                               Site is repeated no copy         ED15  34
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  ED15  35
# NO MATCH SO COPY                                                      ED15  36
incrqx:(IB,STOPB+STEPB,ED1040)#        Expand qx for one atom           ED15  37
movereal:(QX,IA+1,QX,STOPB+1,STEPA,1)# Store whole record               ED15  38
xf:(STOPB)=X;yf:(STOPB)=Y;zf:(STOPB)=Z#                                 ED15  39
IF(IREL(7)>0)ifnv:(uij:(STOPB))#                                        ED15  40
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  ED15  41
CALL ED16(J,STOPB+IREL(7),UOUT)#       Transform uij                    ED15  42
DO I=1,6; QX(STOPB+IREL(6+I))=UOUT(I)# Replace                          ED15  43
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  ED15  44
#                                                                       ED15  45
# IGNORE SIGUIJ - THIS IS A TRANSIENT PROGRAM STEP.                     ED15  46
#                                                                       ED15  47
# BUILD A NEW UNIQUE LABEL I.E._*SYM_TRANS                              ED15  48
#                                                                       ED15  49
LABX="_*xxx";#                                                          ED15  50
ncodefld:(FLOAT(1+(J-MARKS)/STEPS),1,LABX,050333.,1)#                   ED15  51
movertoc:(na:,1,LABEL,1,24,0)#         Get prev atom label              ED15  52
DO I=1,15; IF(LABEL(I^I)==' ')BREAK#                                    ED15  53
LABEL(I^I+4)=LABX#                                                      ED15  54
movector:(LABEL,1,na:(STOPB),1,24,0)#  Set new atom label               ED15  55
#WRITE(6,*)"NEW SITE ",LABEL, XF:(STOPB),YF:(STOPB),ZF:(STOPB)          ED15  56
STOPB=IB#                                                               ED15  57
#                                                                       ED15  58
99 CONTINUE#                                                            ED15  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  ED15  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  ED15  61
#                                                                       ED15  62
RETURN#                                                                 ED15  63
END#                                                                    ED15  64
systemheader:(ED16)#                   Transform uij and sig uij        ED16   1
####################################################################    ED16   2
#                                                                  #    ED16   3
#                               ED16                               #    ED16   4
#                                                                  #    ED16   5
####################################################################    ED16   6
SUBROUTINE ED16(N,JP,TEMP)#            S.r. hall 1991                   ED16   7
include:(AACOMN)#                                                       ED16   8
#                                                                       ED16   9
INTEGER N,JP#                                                           ED16  10
REAL    TEMP(6)#                                                        ED16  11
#                                                                       ED16  12
TEMP(1) =  QX(N+1)*QX(N+1)*QX(JP  ) $#                                  ED16  13
+          QX(N+4)*QX(N+4)*QX(JP+1) $#                                  ED16  14
+          QX(N+7)*QX(N+7)*QX(JP+2) $#                                  ED16  15
+      2.*(QX(N+1)*QX(N+4)*QX(JP+3) $#                                  ED16  16
+          QX(N+1)*QX(N+7)*QX(JP+4) $#                                  ED16  17
+          QX(N+4)*QX(N+7)*QX(JP+5))#                                   ED16  18
TEMP(2) =  QX(N+2)*QX(N+2)*QX(JP  ) $#                                  ED16  19
+          QX(N+5)*QX(N+5)*QX(JP+1) $#                                  ED16  20
+          QX(N+8)*QX(N+8)*QX(JP+2) $#                                  ED16  21
+      2.*(QX(N+2)*QX(N+5)*QX(JP+3) $#                                  ED16  22
+          QX(N+2)*QX(N+8)*QX(JP+4) $#                                  ED16  23
+          QX(N+5)*QX(N+8)*QX(JP+5))#                                   ED16  24
TEMP(3) =  QX(N+3)*QX(N+3)*QX(JP  ) $#                                  ED16  25
+          QX(N+6)*QX(N+6)*QX(JP+1) $#                                  ED16  26
+          QX(N+9)*QX(N+9)*QX(JP+2) $#                                  ED16  27
+      2.*(QX(N+3)*QX(N+6)*QX(JP+3) $#                                  ED16  28
+          QX(N+3)*QX(N+9)*QX(JP+4) $#                                  ED16  29
+          QX(N+6)*QX(N+9)*QX(JP+5))#                                   ED16  30
TEMP(4) =  QX(N+1)*QX(N+2)*QX(JP  ) $#                                  ED16  31
+          QX(N+4)*QX(N+5)*QX(JP+1) $#                                  ED16  32
+          QX(N+7)*QX(N+8)*QX(JP+2) $#                                  ED16  33
+         (QX(N+2)*QX(N+4)+QX(N+1)*QX(N+5))*QX(JP+3) $#                 ED16  34
+         (QX(N+2)*QX(N+7)+QX(N+1)*QX(N+8))*QX(JP+4) $#                 ED16  35
+         (QX(N+5)*QX(N+7)+QX(N+4)*QX(N+8))*QX(JP+5)#                   ED16  36
TEMP(5) =  QX(N+1)*QX(N+3)*QX(JP  ) $#                                  ED16  37
+          QX(N+4)*QX(N+6)*QX(JP+1) $#                                  ED16  38
+          QX(N+7)*QX(N+9)*QX(JP+2) $#                                  ED16  39
+         (QX(N+3)*QX(N+4)+QX(N+1)*QX(N+6))*QX(JP+3) $#                 ED16  40
+         (QX(N+3)*QX(N+7)+QX(N+1)*QX(N+9))*QX(JP+4) $#                 ED16  41
+         (QX(N+6)*QX(N+7)+QX(N+4)*QX(N+9))*QX(JP+5)#                   ED16  42
TEMP(6) =  QX(N+2)*QX(N+3)*QX(JP  ) $#                                  ED16  43
+          QX(N+5)*QX(N+6)*QX(JP+1) $#                                  ED16  44
+          QX(N+8)*QX(N+9)*QX(JP+2) $#                                  ED16  45
+         (QX(N+3)*QX(N+5)+QX(N+2)*QX(N+6))*QX(JP+3) $#                 ED16  46
+         (QX(N+3)*QX(N+8)+QX(N+2)*QX(N+9))*QX(JP+4) $#                 ED16  47
+         (QX(N+6)*QX(N+8)+QX(N+5)*QX(N+9))*QX(JP+5)#                   ED16  48
RETURN#                                                                 ED16  49
END#                                                                    ED16  50
systemheader:(ED17)#                   Expand over multiple cells       ED17   1
####################################################################### ED17   2
#                                                                     # ED17   3
#                          ED17                                       # ED17   4
#                                                                     # ED17   5
####################################################################### ED17   6
SUBROUTINE ED17#                                                        ED17   7
include:(AACOMN)#                                                       ED17   8
include:(EDCOMN)#                                                       ED17   9
#                                                                       ED17  10
INTEGER IH,IK,IL#                                                       ED17  11
REAL CELL#                                                              ED17  12
INTEGER ICEL#                                                           ED17  13
INTEGER IACNT#                                                          ED17  14
string:(LABX,4)#                                                        ED17  15
string:(LABEL,24)#                                                      ED17  16
chardata:(ED17A, CELLS END )#                                           ED17  17
chardata:(ED17B," Original atom sites in archive bdf            ")#     ED17  18
chardata:(ED17C," Extra unit cells added to archive             ")#     ED17  19
chardata:(ED17D," Redundant atom sites added to archive         ")#     ED17  20
datastuff:#                                                             ED17  21
#                                                                       ED17  22
IF(NCELL<1) RETURN#                    Expanding here - not reducing    ED17  23
#                                                                       ED17  24
ICEL=0#                                                                 ED17  25
IACNT=0#                                                                ED17  26
IF(NCELL>=1)#                                                           ED17  27
FOR(IH=6-NCELL;IH<=4+NCELL;IH=IH+1)#                                    ED17  28
FOR(IK=6-NCELL;IK<=4+NCELL;IK=IK+1)#                                    ED17  29
FOR(IL=6-NCELL;IL<=4+NCELL;IL=IL+1)#                                    ED17  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  ED17  31
ICEL=ICEL+1#                                                            ED17  32
CELL  =FLOAT(IH)*100.+FLOAT(IK)*10.+FLOAT(IL)#                          ED17  33
LABX="_";#                                                              ED17  34
ncodefld:(CELL,1,LABX,040333.,1)#                                       ED17  35
FOR(IA=MARKB;IA<STOPB;IA=IA+STEPB)#                                     ED17  36
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  ED17  37
writepkt:(2,lratom:,STEPA,IP)#                                          ED17  38
movereal:(QX,IA+1,QX,IP+1,STEPA,1)#    Copy originals                   ED17  39
xf:(IP)=xf:(IP)-FLOAT(5-IH)#           Apply cell translate             ED17  40
yf:(IP)=yf:(IP)-FLOAT(5-IK)#           Apply cell translate             ED17  41
zf:(IP)=zf:(IP)-FLOAT(5-IL)#           Apply cell translate             ED17  42
movertoc:(na:,1,LABEL,1,24,0)#         Get prev atom label              ED17  43
DO I=1,24; IF(LABEL(I^I)==' ')BREAK#                                    ED17  44
LABEL(I^I+3)=LABX#                                                      ED17  45
movector:(LABEL,1,na:(IP),1,24,0)#     Set new atom label               ED17  46
#WRITE(6,*)" ",LABEL, XF:(IP),YF:(IP),ZF:(IP)                           ED17  47
IACNT=IACNT+1#                                                          ED17  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  ED17  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  ED17  50
#                                                                       ED17  51
#                                                                       ED17  52
#                                                                       ED17  53
#                                                                       ED17  54
REPEAT#                                Loop over input lines            ED17  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  ED17  56
readline:(EP0A,NEP0A)#                 Read next input line             ED17  57
IF (LINID!=1) BREAK#                                                    ED17  58
IF(NCELL!=1)NEXT#                      Ignore this line                 ED17  59
FOR(K=1;K>0;K=K+1)#                                                     ED17  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  ED17  61
ifvo:(BUFIN(K)) BREAK#                 Exit on first void               ED17  62
ifch:(BUFIN(K)) iquit:(ED1601)#        Bad cell format                  ED17  63
NUM=NINT(BUFIN(K))#                                                     ED17  64
IH=NUM/100#                                                             ED17  65
IK=(NUM-IH*100)/10#                                                     ED17  66
IL=(NUM-IH*100-IK*10)#                                                  ED17  67
IF(IH<=0\IH>=10) iquit:(ED1601)#       Bad cell format                  ED17  68
IF(IK<=0\IK>=10) iquit:(ED1601)#       Bad cell format                  ED17  69
IF(IL<=0\IL>=10) iquit:(ED1601)#       Bad cell format                  ED17  70
#                                                                       ED17  71
ICEL=ICEL+1#                                                            ED17  72
CELL  =FLOAT(IH)*100.+FLOAT(IK)*10.+FLOAT(IL)#                          ED17  73
LABX="_";#                                                              ED17  74
ncodefld:(CELL,1,LABX,040333.,1)#                                       ED17  75
FOR(IA=MARKB;IA<STOPB;IA=IA+STEPB)#                                     ED17  76
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  ED17  77
writepkt:(2,lratom:,STEPA,IP)#                                          ED17  78
movereal:(QX,IA+1,QX,IP+1,STEPA,1)#    Copy originals                   ED17  79
xf:(IP)=xf:(IP)+FLOAT(5-IH)#           Apply cell translate             ED17  80
yf:(IP)=yf:(IP)+FLOAT(5-IK)#           Apply cell translate             ED17  81
zf:(IP)=zf:(IP)+FLOAT(5-IL)#           Apply cell translate             ED17  82
movertoc:(na:,1,LABEL,1,24,0)#         Get prev atom label              ED17  83
DO I=1,24; IF(LABEL(I^I)==' ')BREAK#                                    ED17  84
LABEL(I^I+4)=LABX#                                                      ED17  85
movector:(LABEL,1,na:(IP),1,24,0)#     Set new atom label               ED17  86
IACNT=IACNT+1#                                                          ED17  87
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  ED17  88
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  ED17  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  ED17  90
#                                                                       ED17  91
#   DUMP STATISTICS                                                     ED17  92
#   ---------------                                                     ED17  93
#                                                                       ED17  94
IATOLD=(STOPA-MARKA)/STEPA#                                             ED17  95
ncodefld:(FLOAT(IATOLD),1,ED17B,470613.,1)#                             ED17  96
writeline:(1,ED17B,NED17B,3,3)#                                         ED17  97
ncodefld:(FLOAT(ICEL),1,ED17C,470613.,1)#                               ED17  98
writeline:(0,ED17C,NED17C,3,3)#                                         ED17  99
ncodefld:(FLOAT(IACNT-IATOLD),1,ED17D,470613.,1)#                       ED17 100
writeline:(0,ED17D,NED17D,3,3)#                                         ED17 101
#                                                                       ED17 102
RETURN#                                                                 ED17 103
END#                                                                    ED17 104
systemheader:(ED20)#                   Expand not! shrink to independ   ED20   1
####################################################################### ED20   2
#                                                                     # ED20   3
#                          ED20                                       # ED20   4
#                                                                     # ED20   5
####################################################################### ED20   6
SUBROUTINE ED20#                                                        ED20   7
include:(AACOMN)#                                                       ED20   8
include:(EDCOMN)#                                                       ED20   9
#                                                                       ED20  10
string:(LABEL,24)#                                                      ED20  11
string:(LABEL1,24)#                                                     ED20  12
INTEGER IATOLD#                                                         ED20  13
INTEGER IATNEW#                                                         ED20  14
INTEGER H,H1,I,J,K#                                                     ED20  15
REAL TYP1,TYP2#                                                         ED20  16
REAL A,B,C,D,E,F,X,Y,Z,U,V,W#   
chardata:(CDAT,'abcdefghijklmnopqrstuvwxyz')#                           ED20  18
chardata:(NUMC,'0123456789')#                                           ED20  19
chardata:(ED20A," Original atom sites in archive bdf            ")#     ED20  20
chardata:(ED20B," Redundant atom sites culled from archive      ")#     ED20  21
chardata:(ED20C," Current atom sites in archive bdf             ")#     ED20  22
chardata:(ED20D," Redundant sites reduced to this independent set")#    ED20  23
chardata:(ED20E,NAME                    X        Y        Z)#           ED20  24
realdata:(FMT,[361052.,460952.,550952.])#                               ED20  25
datastuff:#                                                             ED20  26
#                                                                       ED20  27
#                                                                       ED20  28
IATNEW=0#                                                               ED20  29
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over originals              ED20  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  ED20  31
TYP1=ty:#                                                               ED20  32
IF(NINT(TYP1)==0) NEXT#                Ignore erased                    ED20  33
A=MOD(99.+xf:,1.)#                                                      ED20  34
B=MOD(99.+yf:,1.)#                                                      ED20  35
C=MOD(99.+zf:,1.)#                                                      ED20  36
xf:=A;yf:=B;zf:=C#                                                      ED20  37
#                                                                      
#  CHECK FOR NEAR-MISS SPECIAL POSITIONS                               
#  -------------------------------------                               
#                                                                      
NM=0
D=0.;E=0.;F=0.#
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symops                
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3 
X=A*QX(J+1)+B*QX(J+4)+C*QX(J+7)+QX(J+10)# Get x                        
Y=A*QX(J+2)+B*QX(J+5)+C*QX(J+8)+QX(J+11)# Get y                        
Z=A*QX(J+3)+B*QX(J+6)+C*QX(J+9)+QX(J+12)# Get z                        
U=MOD(99.5+X-A,1.0)-0.5#               Get closest to bonded atom      
V=MOD(99.5+Y-B,1.0)-0.5#               Get closest to bonded atom      
W=MOD(99.5+Z-C,1.0)-0.5#               Get closest to bonded atom      
DIST=G1*U*U+G2*V*V+G3*W*W+G4*U*V+G5*U*W+G6*V*W# Get distance squared 
IF(DIST<SSTOLC)#                       Sym related site <0.5a          
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4 
NM=NM+1#                               Increment near miss count       
D=D+(A+U)#
E=E+(B+V)#
F=F+(C+W)#
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4 
$)
IF(NM>1)#                              now average and hope its closer
$(
A=D/FLOAT(NM)
B=E/FLOAT(NM)
C=F/FLOAT(NM)
IF(IREL(7)>0) ifnv:(uij:)#             reset off diagonal components
$(
ifne:(A,xf:)$(QX(IA+IREL(10))=0.;QX(IA+IREL(11))=0.$)# in case
ifne:(B,yf:)$(QX(IA+IREL(10))=0.;QX(IA+IREL(12))=0.$)# in case
ifne:(C,yf:)$(QX(IA+IREL(11))=0.;QX(IA+IREL(12))=0.$)# in case
$)
$)
xf:=A;yf:=B;zf:=C#                                                      ED20  37
FOR(IB=IA+STEPA;IB<STOPA;IB=IB+STEPA)# Loop over transformed            ED20  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  ED20  39
TYP2=ty:(IB)#                                                           ED20  40
IF(NINT(TYP1)!=NINT(TYP2)) NEXT#       Get another ib                   ED20  41
D=MOD(99.+xf:(IB),1.)#                                                  ED20  42
E=MOD(99.+yf:(IB),1.)#                                                  ED20  43
F=MOD(99.+zf:(IB),1.)#                                                  ED20  44
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symops                 ED20  45
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  ED20  46
X=A*QX(J+1)+B*QX(J+4)+C*QX(J+7)+QX(J+10)# Get x                         ED20  47
Y=A*QX(J+2)+B*QX(J+5)+C*QX(J+8)+QX(J+11)# Get y                         ED20  48
Z=A*QX(J+3)+B*QX(J+6)+C*QX(J+9)+QX(J+12)# Get z                         ED20  49
#X=MOD(99.+X,1.)#                       Transform to first cell          ED20  50
#Y=MOD(99.+Y,1.)#                       Transform to first cell          ED20  51
#Z=MOD(99.+Z,1.)#                       Transform to first cell          ED20  52
U=MOD(99.5+X-D,1.0)-0.5#               Get closest to bonded atom       PG20 187
V=MOD(99.5+Y-E,1.0)-0.5#               Get closest to bonded atom       PG20 188
W=MOD(99.5+Z-F,1.0)-0.5#               Get closest to bonded atom       PG20 189
#U=D-X;V=E-Y;W=F-Z#                     fract vector difference 
DIST=G1*U*U+G2*V*V+G3*W*W+G4*U*V+G5*U*W+G6*V*W# Get distance squared 
IF(DIST<=TOLC) ty:(IB)=0.0#             Erase this site
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  ED20  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  ED20  58
#                                                                       ED20  59
#WRITEPKT:(2,LRATOM:,STEPA,IP)#                                         ED20  60
#MOVEREAL:(QX,IA+1,QX,IP+1,STEPA,1)# COPY ORIGINALS                     ED20  61
IF(ISTRIP!=0)#                                                          ED20  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  ED20  63
movertoc:(na:,1,LABEL,1,24,0)#         Get prev atom label              ED20  64
DO I=1,23; IF(LABEL(I^I+1)=='_*')BREAK#                                 ED20  65
DO J=I,24; LABEL(J^J)=' '#             Replace junk                     ED20  66
#MOVECTOR:(LABEL,1,NA:(IP),1,24,0)# SET NEW ATOM LABEL                  ED20  67
movector:(LABEL,1,na:,1,24,0)#         Set new for reporting            ED20  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  ED20  69
IATNEW=IATNEW+1#                                                        ED20  70
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  ED20  71
#                                                                       ED20  72
#   SORT SITES BY LABEL                                                 ED20  73
#   -------------------                                                 ED20  74
#                                                                       ED20  75
incrqx:(MARKB,STOPA+STEPA,ED2001)#     Swap buffer                      ED20  76
IMX=STOPA#                             Last possible                    ED20  77
IF(ISTRIP!=0)#                         Only if labels stripped          ED20  78
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over originals              ED20  79
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  ED20  80
TYP1=ty:#                                                               ED20  81
IB=IA#                                                                  ED20  82
IF(NINT(TYP1)<=0)#                     Ia is deleted                    ED20  83
FOR(IB=IB+STEPA ;IB<IMX;IB=IB+STEPA)#  Find next undeleted              ED20  84
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  ED20  85
TYP2=ty:(IB)#                                                           ED20  86
IF(NINT(TYP2)<=0) NEXT#                Ignore erased                    ED20  87
movereal:(QX,IB+1,QX,IA+1,STEPA,1)#    Copy back                        ED20  88
ty:(IB)=0.0#                           Clobber original                 ED20  89
TYP1=TYP2#                                                              ED20  90
BREAK#                                                                  ED20  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  ED20  92
IF(IB>=STOPA) BREAK#                   No undeleted so finish           ED20  93
#                                                                       ED20  94
movertoc:(na:,1,LABEL,1,24,0)#         Get last atom label              ED20  95
#WRITE(6,*) LABEL                                                       ED20  96
FOR(IB=IB+STEPA;IB<STOPA;IB=IB+STEPA)# Loop over transformed            ED20  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  ED20  98
TYP2=ty:(IB)#                                                           ED20  99
IF(NINT(TYP2)<=0) NEXT#                Ignore erased                    ED20 100
IF(NINT(TYP1)!=NINT(TYP2)) NEXT#       Get another ib                   ED20 101
# SAME TYPE - COMPARE LABELS                                            ED20 102
movertoc:(na:(IB),1,LABEL1,1,24,0)#    Get prev atom label              ED20 103
#WRITE(6,*) "    ",LABEL1                                               ED20 104
IF(LABEL1!=LABEL)NEXT#                 No label match                   ED20 105
#WRITE(6,*) "   MATCH "                                                 ED20 106
# ELSE A LABEL MATCH                                                    ED20 107
IF(IB==IA+STEPA) BREAK#                No need to copy                  ED20 108
movereal:(QX,IA+STEPA+1,QX,STOPA+1,STEPA,1)# Copy to temp               ED20 109
movereal:(QX,IB+1,QX,IA+STEPA+1,STEPA,1)# Copy back                     ED20 110
movereal:(QX,STOPA+1,QX,IB+1,STEPA,1)# Replace forward                  ED20 111
BREAK#                                                                  ED20 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  ED20 113
#IF(IB>=IMX) BREAK#                    NO UNDELETED SO FINISH           ED20 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  ED20 115
#                                                                       ED20 116
#  DUMP AND MODIFY INDEP LABELS                                         ED20 117
#                                                                       ED20 118
#                                                                       ED20 119
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over originals              ED20 120
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  ED20 121
TYP1=ty:#                                                               ED20 122
IF(NINT(TYP1)<=0)#                     Deleted site                     ED20 123
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  ED20 124
IF(ISTRIP!=0) BREAK#                   Finished if extensions gone      ED20 125
NEXT#                                  Else keep looking                ED20 126
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  ED20 127
movertoc:(na:,1,LABEL,1,24,0)#         Get last atom label              ED20 128
MATCH=0#                                                                ED20 129
FOR(IB=IA+STEPA ;IB<STOPA;IB=IB+STEPA)# Loop over subsequent            ED20 130
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 ED20 131
TYP2=ty:(IB)#                                                           ED20 132
IF(NINT(TYP1)!=NINT(TYP2)) BREAK#      No match                         ED20 133
movertoc:(na:(IB),1,LABEL1,1,24,0)#    Get next atom label              ED20 134
IF(LABEL!=LABEL1)BREAK#                                                 ED20 135
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 ED20 136
NUM=1+(IB-STEPA-IA)/STEPA#             Number of identical sites        ED20 137
IC=IB#                                                                  ED20 138
DO I=1,24; IF(LABEL(I^I)==' ') BREAK#  First blank                      ED20 139
I=I-1#                                                                  ED20 140
IF(I==1\(I==2&INDEX(NUMC,LABEL(I^I))==0))#                              ED20 141
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 ED20 142
I=I+1;LABEL(I^I)='_'#                                                   ED20 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 ED20 144
H=0#                                                                    ED20 145
NL=1+INT(LOG(FLOAT(NUM))/LOG(26.))#    Alphabetic digits                ED20 146
FOR(IB=IA ;IB<IC;IB=IB+STEPA)#         Loop over subsequent             ED20 147
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 ED20 148
H=H+1#                                                                  ED20 149
H1=H#                                                                   ED20 150
IF(NUM>1)#                                                              ED20 151
DO J=1,NL#                                                              ED20 152
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 ED20 153
K1= INT(26.**(NL-J))#                                                   ED20 154
K=((H1-1)/K1)#                                                          ED20 155
H1=H1-K*K1#                                                             ED20 156
LABEL(I+J^I+J)=CDAT(K+1^K+1)#                                           ED20 157
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 ED20 158
movector:(LABEL,1,na:(IB),1,24,0)#     Set new for reporting            ED20 159
writepkt:(2,lratom:,STEPA,IP)#                                          ED20 160
movereal:(QX,IB+1,QX,IP+1,STEPA,1)#    Copy originals                   ED20 161
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 ED20 162
IA=IC-STEPA#                                                            ED20 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  ED20 164
#                                                                       ED20 165
#   DUMP STATISTICS                                                     ED20 166
#   ---------------                                                     ED20 167
#                                                                       ED20 168
IATOLD=(STOPA-MARKA)/STEPA#                                             ED20 169
ncodefld:(FLOAT(IATOLD),1,ED20A,470613.,1)#                             ED20 170
writeline:(1,ED20A,NED20A,3,3)#                                         ED20 171
ncodefld:(FLOAT(IATOLD-IATNEW),1,ED20B,470613.,1)#                      ED20 172
writeline:(0,ED20B,NED20B,3,3)#                                         ED20 173
ncodefld:(FLOAT(IATNEW),1,ED20C,470613.,1)#                             ED20 174
writeline:(0,ED20C,NED20C,3,3)#                                         ED20 175
#                                                                       ED20 176
writeline:(1,ED20D,NED20D,3,3)#        Header                           ED20 177
#WRITELINE:(0,0,0,1,3);                                                 ED20 178
LINRM=4#                               Prepare for list header          ED20 179
HEADOT=' '; HEADOT(10^)=ED20E#                                          ED20 180
writeline:(0,HEADOT,70,3,3)#                                            ED20 181
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over originals              ED20 182
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 ED20 183
IF(NINT(ty:)<=0) NEXT#                 Ignore erased                    ED20 184
movertoc:(na:,1,CHROT,4,28,0)#         Get prev atom label              ED20 185
ncodefld:(xf:,1,CHROT,FMT,3)#                                           ED20 186
writeline:(0,0,0,1,3)#                 Print all data                   ED20 187
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 ED20 188
#                                                                       ED20 189
RETURN#                                                                 ED20 190
END#                                                                    ED20 191
systemheader:(ED25)#                   Finish off archive writing       ED25   1
####################################################################### ED25   2
#                                                                     # ED25   3
#                          ED25                                       # ED25   4
#                                                                     # ED25   5
####################################################################### ED25   6
SUBROUTINE ED25#                                                        ED25   7
include:(AACOMN)#                                                       ED25   8
include:(EDCOMN)#                                                       ED25   9
#                                                                       ED25  10
copyfile:(1,2,incr:(lratom:),endrecord:)# Close off new and old         ED25  11
#                                                                       ED25  12
RETURN#                                                                 ED25  13
END#                                                                    ED25  14
