systemheader:(FC    )#                                                  FC     1
####################################################################    FC     2
##      Copyright (C) 2000, The Xtal System, The University of        # FC     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # FC     4
## Distributed under the GNU General Public Licence as published by   # FC     5
## the Free Software Foundation, in the hope that it will be useful   # FC     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # FC     7
## for more details.                                                  # FC     8
#                                                                  #    FC     9
#                            *** FC ***                            #    FC    10
#                                                                  #    FC    11
#    THE PROGRAM FC IS USED TO CALCULATE STRUCTURE FACTORS WHEN    #    FC    12
#    NO REFINEMENT OF ATOMIC PARAMETERS IS TO BE DONE.             #    FC    13
####################################################################    FC    14
#                                                                       FC    15
include:(XMACRO)#                                                       FC    16
macro:(atomlist:,[ifelse:($1,,M,$1)])# Define atom list pointer
macro:(scat:,[QX(atomlist:($1)+1)])
macro:(xif:, [QX(atomlist:($1)+1+$2)])
macro:(pmul:,[QX(atomlist:($1)+5)])
macro:(bis:, [QX(atomlist:($1)+6)])
macro:(bij:, [QX(atomlist:($1)+5+$2)])
macro:(mxat:,16)
#                                                                       FC    17
extrude:(FCCOMN)#                                                       FC    18
REAL ARCH(20)#                         Archive list                     FC    19
REAL ADI(mxat:),ADR(mxat:)#            Anomalous dispersion terms       FC    20
REAL ATA(mxat:)#                       Number of atoms in unit cell     FC    21
REAL ATP(mxat:)#                       And in a partial structure       FC    22
REAL ATZ(mxat:)#                       Atomic numbers
REAL BOVL#                             Overall tf                       FC    23
INTEGER CENT#                          Centro flag                      FC    24
INTEGER DISP#                          Dispersion flag                  FC    25
REAL DLIS#                             List > fdiff value               FC    26
REAL DSTL#                             Delta st/l for ff table          FC    27
REAL DSNM#                             Data set number                  FC    28
REAL ELIM#                             Limit of e value                 FC    29
REAL FMUL#                             S.f. multiplicity                FC    30
INTEGER IATM#                          Atom list increment              FC    31
INTEGER ICORE#                         Calculate Frel from core+...
INTEGER IEXT#                          Extinction flag                  FC    32
INTEGER IFFF#                          Refl form factor flag            FC    33
INTEGER IP,JP#                         Working ip/op pointers           FC    34
INTEGER ISEL#                          Select flag: 1 select/2 omit     FC    35
INTEGER ISCF#                          Step in ff name list             FC    36
INTEGER ISIM#                          Sim weight flag                  FC    37
INTEGER ISIN#                          Sin/cos lookup flag              FC    38
INTEGER ITEM#                          Number of archive items          FC    39
INTEGER IREL(67)#                      Relative packet pointers         FC    40
INTEGER IRF,IRH,IRJ,IRL,IRS,IRX,IEV#   Relative pointers                FC    41
INTEGER IFA,IFB,IRFO#                  Relative pointers     
INTEGER IWNT(66)#                      Want list of idnums              FC    42
INTEGER KEY(4)#                        Indexpkt control signals         FC    43
INTEGER LPAK#                          Input packet length              FC    44
INTEGER MARK1#                         Start-1 of sym matrices          FC    45
INTEGER MARK2#                         Start-1 of ff name list          FC    46
INTEGER MARK3#                         Start-1 of scatfac table         FC    47
INTEGER MARK4#                         Start-1 of scale list            FC    48
INTEGER MARK5#                         Start-1 of select list           FC    49
INTEGER MARK6#                         Start-1 of atoms list            FC    50
INTEGER MARK7#                         Start-1 of sin/cos table         FC    51
REAL MAXH,MAXK,MAXL#                   Maximum /h/,/k/,/l/              FC    52
INTEGER NAME#                          Qx step for select list          FC    53
INTEGER NATM#                          Count number of atoms            FC    54
INTEGER IRAD#                          Radiation type flag              FC    55
INTEGER NDEL#                          Extra items in op packet         FC    56
INTEGER NMDS#                          Data set number *1000            FC    57
INTEGER NPAK#                          Output packet length             FC    58
INTEGER NROT#                          Number of rotation matrices      FC    59
INTEGER NSCF#                          Length of ff table               FC    60
INTEGER NSCL#                          Number of scale groups           FC    61
INTEGER NTYP#                          Number of atom types             FC    62
INTEGER OFF(mxat:)#                    Ff table offsets                 FC    63
REAL REJF#                             Reject code flag                 FC    64
REAL SMAX,SMIN#                        Max/min st/l limits              FC    65
REAL SUMC(2,6),SUMD(2,6),SUMN(2,6),SUMR(2,6)# Statistics sums           FC    66
REAL UTOB#                             8*pi**2                          FC    67
REAL UTOBET(6)#                        Convert uij to beta ij           FC    68
INTEGER TYPE#                          Temp. factor type                FC    69
#                                                                       FC    70
COMMON /COMIFC/$#                                                       FC    71
CENT,DISP,IATM,IEXT,IFFF,IP,JP,ITEM,ISCF,ISIN,$#                        FC    72
IREL,IWNT,KEY,LPAK,MARK1,MARK2,MARK3,MARK4,ISIM,IEV,$#                  FC    73
MARK5,MARK6,MARK7,NAME,NATM,TYPE,IRF,IRH,IRJ,IRL,IRS,IRX,$#             FC    74
IRAD,NDEL,NMDS,NPAK,NROT,NSCF,NSCL,NTYP,OFF,ISEL,ICORE,IFA,IFB,IRFO#
#                                                                       FC    76
COMMON /COMFFC/$#                                                       FC    77
ARCH,ADI,ADR,BOVL,DLIS,DSNM,DSTL,FMUL,$#                                FC    78
MAXH,MAXK,MAXL,REJF,SMIN,SMAX,ATP,ATA,ATZ,$#                            FC    79
SUMC,SUMD,SUMN,SUMR,UTOB,UTOBET,ELIM#                                   FC    80
endext:#                                                                FC    81
#                                                                       FC    82
systemheader:(FC00)#                   Structure factor calculation     FC00   1
# ################################################################## #  FC00   2
#                                                                    #  FC00   3
#                               FC00                                 #  FC00   4
#                                                                    #  FC00   5
# ################################################################## #  FC00   6
SUBROUTINE FC00#                       J.m.stewart & d.high 1960        FC00   7
#                                      R.braun & j.m.stewart 1965       FC00   8
#                                      F.a.kundell 1970                 FC00   9
include:(AACOMN)#                      J.m.stewart & j.r.holden 1980    FC00  10
include:(FCCOMN)#                      S.r.hall december 1981           FC00  11
#                                      R.m.doherty december 1981        FC00  12
#                                                                       FC00  13
CALL FC01#                                                              FC00  14
CALL FC02#                                                              FC00  15
CALL FC03#                                                              FC00  16
CALL FC04#                                                              FC00  17
CALL FC05#                                                              FC00  18
CALL FC06#                                                              FC00  19
#                                                                       FC00  20
RETURN#                                                                 FC00  21
END#                                                                    FC00  22
systemheader:(FC01)#                   Read bdf lrsymm: to lrdset:      FC01   1
# ####################################################################  FC01   2
#                                                                       FC01   3
#                                FC01                                   FC01   4
#                                                                       FC01   5
# ####################################################################  FC01   6
SUBROUTINE FC01#                                                        FC01   7
include:(AACOMN)#                                                       FC01   8
include:(FCCOMN)#                                                       FC01   9
#                                                                       FC01  10
REAL    CELL#                          Cell volume                      FC01  11
INTEGER I,J,K,L#                       Working indices                  FC01  12
INTEGER IDS#                           Compound pointer and offset      FC01  13
INTEGER IPO#                           Pointer to output buffer         FC01  14
INTEGER J2#                            Index for sf names in mark2      FC01  15
#                                                                       FC01  16
chardata:(FC11,SCT NOS OVE ISO ANI MIX POP NOP DIS NOD $#               FC01  17
EXT NOE XRA NEU DSE LIS REJ NLI NRE SIM EGT FRT FRC )#          
datastuff:#                                                             FC01  19
#                                                                       FC01  20
#---------------------------------------------------------------------- FC01  21
#                                                                       FC01  22
# THE FC INPUT LINE CONTAINS CODES TO DIRECT THE SETTING OF THE FOLLOWI FC01  23
# VARIABLES.                                                            FC01  24
#                                                                       FC01  25
# VARIABLE  POSSIBLE  VALUE OF  MEANING                                 FC01  26
#   NAME     CODES    VARIABLE                                          FC01  27
#                                                                       FC01  28
#  ISIN      SCT       YES:    CALC A & B WITH SIN TABLE 0-0/1/449 DEGR FC01  29
#            NOS       NO:     CALC A & B WITH LIBRARY SUBROUTINE       FC01  30
#                                                                       FC01  31
#  TYPE      OVE        2      OVERALL TEMPERATURE FACTOR               FC01  32
#            ISO        3      INDIVIDUAL ISOTROPIC TEMP. FACTORS       FC01  33
#            ANI        4      INDIVIDUAL ANISOTROPIC TEMP. FACTORS     FC01  34
#            MIX        4      MIXED TEMPERATURE FACTORS                FC01  35
#                                                                       FC01  36
#  DISP      DIS       YES:    APPLY ANOMALOUS DISPERSION CORRECTION    FC01  37
#            NOD       NO:     DO NOT APPLY DISPERSION CORRECTION       FC01  38
#                                                                       FC01  39
#  IEXT      EXT       YES:    APPLY EXTINCTION CORRECTION              FC01  40
#            NOE       NO:     DO NOT APPLY EXTINCTION CORRECTION       FC01  41
#                                                                       FC01  42
#  DSNM      DSE       INPUT   DATASET FLAG PRECEDES NUMERIC VALUE THAT FC01  43
#                              FOLLOWS. IF NO VALUE ENTERED SET AT 1.   FC01  44
#                                                                       FC01  45
#  DLIS      LIS       YES:    LIST FC'S IF FDIFF > VALUE FOLLOWING     FC01  46
#            NLI               THIS FLAG. IF NO VALUE INPUT - LIST ALL. FC01  47
#                                                                       FC01  48
#  REJF      REJ       YES:    REJECT REFLN IF JCODE >= VALUE FOLLOWING FC01  49
#            NRE               THIS FLAG.  IF NO VALUE: REJECT > 0.     FC01  50
#                                                                       FC01  51
#  ISIM      SIM       YES:    SIM WEIGHT FOR PARTIAL STRUCTURE         FC01  52
#                      NO:     DEFAULT                                  FC01  53
#                                                                       FC01  54
#---------------------------------------------------------------------- FC01  55
#                                                                       FC01  56
#                                                                       FC01  57
#    DECODE =FC= LINE PARAMETERS                                        FC01  58
#    ---------------------------                                        FC01  59
#                                                                       FC01  60
ISIN=no:#                              Set default parameters           FC01  61
IRAD=3#                                Set default rad as xrays         FC01  62
TYPE=4#                                Set default parameters           FC01  63
ELIM=-1.#                              Set default parameters           FC01  64
DISP=yes:#                             Set default parameters           FC01  65
IFFF=0#                                Set default parameters           FC01  66
IEXT=yes:#                             Set default parameters           FC01  67
DSNM=1.#                               Set default parameters           FC01  68
DLIS=999999.#                          Set default parameters           FC01  69
REJF=6.#                               Set default parameters           FC01  70
ISIM=no:#                              Set default parameters           FC01  71
UTOB=78.9568#                          8*pi**2                          FC01  72
ICORE=0#                               don't calculate for the core
#                                                                       FC01  73
FOR(I=1;I<30;I=I+1)#                   Loop over input fields           FC01  74
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FC01  75
ifvo:(BUFIN(I)) BREAK#                 Exit after last field            FC01  76
stringlim:(I,J,K)#                     Find limits of the field         FC01  77
compchar:(CHRIN,J,FC11,1,3,4,NFC11,K)# Find what's there                FC01  78
IF(K==0) iquit:(FC0101,I)#             Dud flag.......fc101             FC01  79
ELSE IF(K==1)  ISIN=yes:#              Do not use lookup table          FC01  80
ELSE IF(K==3)  TYPE=2#                 Overall tf                       FC01  81
ELSE IF(K==4)  TYPE=3#                 Individual isotropic tf          FC01  82
ELSE IF(K==5)  TYPE=4#                 Anisotropic or mixed tf          FC01  83
ELSE IF(K==6)  TYPE=4#                 Anisotropic or mixed tf          FC01  84
ELSE IF(K==10) DISP=no:#               Don't apply disper corr.         FC01  85
ELSE IF(K==12) IEXT=no:#               No extinction corr.              FC01  86
ELSE IF(K==15)#                        Data set number to follow        FC01  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FC01  88
IF(BUFIN(I+1)>voidflg:)#               Should be numeric dsetnum        FC01  89
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FC01  90
DSNM=NINT(BUFIN(I+1))#                 Get dataset number               FC01  91
I=I+1#                                 Advance field counter            FC01  92
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FC01  93
ELSE DSNM=1.#                          Default dataset is 1             FC01  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FC01  95
ELSE IF(K==16)#                        Test for list flag               FC01  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FC01  97
IF(BUFIN(I+1)>voidflg:)#               Test if diff limit follows       FC01  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FC01  99
DLIS=NINT(BUFIN(I+1))#                 Extract diff list limit          FC01 100
I=I+1#                                 Advance field counter            FC01 101
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FC01 102
ELSE DLIS=-1.#                         Force all to be listed           FC01 103
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FC01 104
ELSE IF(K==17)#                        Test for reject refln flag       FC01 105
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FC01 106
IF(BUFIN(I+1)>voidflg:)#               Is reject limit following        FC01 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FC01 108
REJF=BUFIN(I+1)-0.5#                   Set up reject limit              FC01 109
I=I+1#                                 Advance field counter            FC01 110
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FC01 111
ELSE REJF=1.5#                         Default reject all but 1.        FC01 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FC01 113
ELSE IF(K==20) ISIM=yes:#              Apply sim weight                 FC01 114
ELSE IF(K==21)#                        Set limit for e values           FC01 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FC01 116
I=I+1; ELIM=1.5#                       Incr field pointer               FC01 117
IF(BUFIN(I)>voidflg:) ELIM=BUFIN(I)#   Input e limit                    FC01 118
ELSE  I=I-1#                           Assume default of 1.5            FC01 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FC01 120
ELSE IF(K==22) ICORE=1#                Calculate Frel from core+valen
ELSE IF(K==23) ICORE=2#                Calculate Frel from core
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FC01 121
#                                                                       FC01 122
NMDS=NINT(DSNM)*1000#                  Form dataset offset              FC01 123
#                                                                       FC01 124
#   ASSIGN BDF BUFFERS 1 AND 2                                          FC01 125
#   --------------------------                                          FC01 126
#                                                                       FC01 127
IOMARK(1)=QXSTR#                       Set start of io buffer1          FC01 128
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of buffer2                 FC01 129
incrqx:(MARK1,IOMARK(2)+bdfbuf:,FC0104)# Expand mem.....fc0104          FC01 130
copyfile:(1,2,1,decr:(lrcell:))#       Copy to cell record              FC01 131
#                                                                       FC01 132
#   EXTRACT CELL INFORMATION                                            FC01 133
#   ------------------------                                            FC01 134
#                                                                       FC01 135
DO I=1,100#                            Loop over cell packets           FC01 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FC01 137
readwpkt:(1,lrcell:,LPAK,IP,0)#        Read  1st packet of lrcell       FC01 138
IF(IP<=0) BREAK#                       Exit when finished               FC01 139
writepkt:(2,lrcell:,LPAK,IPO)#         Write 1st packet of lrcell       FC01 140
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Transfer data to output          FC01 141
IF(I!=3) NEXT#                         Skip all but recip constants     FC01 142
UTOBET(1)=19.739209*QX(IP+1)*QX(IP+1)# 2*pi**2*astar**2                 FC01 143
UTOBET(2)=19.739209*QX(IP+2)*QX(IP+2)# 2*pi**2*bstar**2                 FC01 144
UTOBET(3)=19.739209*QX(IP+3)*QX(IP+3)# 2*pi**2*cstar**2                 FC01 145
UTOBET(4)=19.739209*QX(IP+1)*QX(IP+2)# 2*pi**2*astar*bstar              FC01 146
UTOBET(5)=19.739209*QX(IP+1)*QX(IP+3)# 2*pi**2*astar*cstar              FC01 147
UTOBET(6)=19.739209*QX(IP+2)*QX(IP+3)# 2*pi**2*bstar*cstar              FC01 148
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FC01 149
#                                                                       FC01 150
#   EXTRACT SYMMETRY CODES & MATRICES (LRSYMM:)                         FC01 151
#   ---------------------------------------                             FC01 152
#                                                                       FC01 153
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Read first packet of lr lrsy     FC01 154
writepkt:(2,lrsymm:,LPAK,IPO)#         Copy to output file              FC01 155
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#                                     FC01 156
CENT=NINT(QX(IP+2))#                   Centric=0 / acentric=1           FC01 157
NROT=NINT(QX(IP+4))#                   Get number rotation matrices     FC01 158
FMUL=QX(IP+6)#                         Get reflection multiplicity      FC01 159
incrqx:(MARK2,MARK1+NROT*LPAK,FC0105)# Expand qx......fc105             FC01 160
FOR(J=MARK1;J>0;J=J+LPAK)#             Loop over symm matrices          FC01 161
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FC01 162
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Get packet pointer               FC01 163
IF(IP<=0) BREAK#                       Exit after last packet           FC01 164
writepkt:(2,lrsymm:,LPAK,IPO)#         Get pointer to o/p buffer        FC01 165
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    And copy the packet              FC01 166
movereal:(QX,IP+1,QX,J+1,LPAK,1)#      Save the symop for later         FC01 167
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FC01 168
copyfile:(1,2,incr:(lrsymm:),decr:(lrscat:))# Copy to scatt. rec.       FC01 169
#                                                                       FC01 170
#   ENTER SCATT. FACTOR & ATOM SUMMARY (LR LRSCAT:)                     FC01 171
#   ---------------------------------------                             FC01 172
#                                                                       FC01 173
incrqx:(MARK3,MARK2+32,FC0106)#        Save room for 16 sf types        FC01 174
ISCF=incr:(arith:(7,/,mxchwd:))#       Allow for 8 char. per name       FC01 175
J2=MARK2#                              Set marker for first sf name     FC01 176
IWNT(1)=NINT(DSNM+20.);  IWNT(3)=100#  Set real ad & ff idnums          FC01 177
IWNT(2)=NINT(DSNM+60.);  IWNT(4)=10#   Set imag ad & neut ff            FC01 178
IWNT(5)=11 ;  IWNT(6)=7#               Set sf name idnum                FC01 179
IWNT(7)=1#                             Set atom number idnum            FC01 180
IWNT(8)=3#                             Set atom number idnum            FC01 180
KEY(1)=0;  KEY(2)=8;  KEY(3)=0#        Set search delimiters            FC01 181
KEY(4) = 0#                                                             FC01 182
indexpkt:(1,lrscat:,LPAK,IP,2,KEY,IWNT,IREL)# Get packet pointers       FC01 183
IF((IREL(1)==0)&(IREL(2)==0)) DISP=no:# No dispersion values            FC01 184
IF((ISIM==yes:)&(IREL(7)==0))iquit:(FC0110)# No atom number             FC01 185
#                                                                       FC01 186
FOR(I=IP+IREL(3);I<=IP+LPAK;I=I+1)#    Loop over ff list                FC01 187
IF((QX(I)<99.5)\(QX(I)>299.5)) BREAK#  Exit after last ff               FC01 188
IF(IREL(3)>0)  NSCF=I-IP-IREL(3)+1#    Count contiguous ff    ^^ddb
ELSE           NSCF=0#                 Ff table present                 FC01 190
IF(IREL(4)>0)  NSCF=1#                 Count neutron ff                 FC01 191
IF(IREL(3)>0) DSTL=(QX(I-1)-QX(I-2))*.01# Set st/l interval             FC01 192
#                                                                       FC01 193
NTYP=0#                                Zero count of atom types         FC01 194
FOR(J=MARK3;J>0;J=J+NSCF)#             Loop over each atom type         FC01 195
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FC01 196
readwpkt:(1,lrscat:,LPAK,IP,0)#        Get packet pointer               FC01 197
IF(IP<=0) BREAK#                       Exit after last packet           FC01 198
writepkt:(2,lrscat:,LPAK,IPO)#         Get output pointer               FC01 199
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy packet                      FC01 200
L=IP+IREL(5)#                          Set pointer for sf name          FC01 201
movereal:(QX,L,QX,J2+1,ISCF,1)#        Move sf name to mark2 array      FC01 202
J2=J2+ISCF#                            Advance sf name pointer          FC01 203
incrqx:(MARK4,J+NSCF,FC0108)#          Expand qx.......fc108            FC01 204
NTYP=NTYP+1#                           Count atom types                 FC01 205
ADR(NTYP)=0.;   ADI(NTYP)=0.#          Zero dispersion values           FC01 206
I=IP+IREL(1); IF(I>IP) ifnv:(QX(I)) ADR(NTYP)=QX(I)# Get real disp      FC01 207
I=IP+IREL(2); IF(I>IP) ifnv:(QX(I)) ADI(NTYP)=QX(I)# Get imag disp      FC01 208
I=IP+IREL(6); IF(I>IP) IFFF=NINT(QX(I))# Get refl ff flag               FC01 209
I=IP+IREL(7); IF(I>IP) ATA(NTYP)=QX(I)# Get total atom number           FC01 210
I=IP+IREL(8); IF(I>IP) ATZ(NTYP)=QX(I)# Get atomic number  
I=IP+IREL(4); IF(I>IP) QX(MARK4)=QX(I)# Store neutron ff                FC01 211
ELSE IF(IREL(3)>0)#                    If xray or electron ff present   FC01 212
FOR(I=J;I<MARK4;I=I+1)#                Loop over sf data points         FC01 213
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FC01 214
K=IP+IREL(3)+I-J#                      Point to each ff value           FC01 215
QX(I+1)=QX(K)#                         Store each ff value              FC01 216
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FC01 217
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FC01 218
copyfile:(1,2,incr:(lrscat:),decr:(lrexpl:))# Copy to experm. rec.      FC01 219
#                                                                       FC01 220
#   ENTER SCALE INFORMATION (LR LREXPL:)                                FC01 221
#   ------------------------------                                      FC01 222
#                                                                       FC01 223
IWNT(1)=1;    IWNT(2)=100#             Set data set & nscl idnums       FC01 224
IWNT(3)=94;   IWNT(4)=22#              Set rad type & cell volume       FC01 225
KEY(1)=1; KEY(2)=4; KEY(3)=0; KEY(4)=0# Set search delimiters           FC01 226
indexpkt:(1,lrexpl:,LPAK,IP,2,KEY,IWNT,IREL)# Get packet pointers       FC01 227
incrqx:(MARK5,MARK4+64,FC0109)#        Expand qx.......fc109            FC01 228
NSCL=1;   QX(MARK4+1)=1.#              Default group & rel pointer&     FC01 229
FOR(I=IP+1;I<=IP+LPAK;I=I+1)#          Loop over directory              FC01 230
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FC01 231
IF((QX(I)<100.9)\(QX(I)>164.1)) NEXT#  Skip if not scale idnm           FC01 232
J=MARK4+NINT(QX(I))-100#               Get group number of scale        FC01 233
QX(J)=FLOAT(I-IP)#                     Store relative position          FC01 234
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FC01 235
REPEAT#                                Loop over data sets              FC01 236
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FC01 237
readwpkt:(1,lrexpl:,LPAK,IP,0)#        Get packet pointer               FC01 238
IF(IP<=0) BREAK#                       Exit after last packet           FC01 239
writepkt:(2,lrexpl:,LPAK,IPO)#         Get o/p buffer pointer           FC01 240
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy the packet                  FC01 241
I=IP+IREL(1); IF(I==IP) NEXT#          Get index of data set no.        FC01 242
ifne:(DSNM,QX(I)) NEXT#                Skip unwanted data set           FC01 243
I=IP+IREL(2); IF(I>IP) NSCL=NINT(QX(I))# Number of scales               FC01 244
FOR(I=MARK4;I<MARK4+NSCL;I=I+1)#       Loop over scale factors          FC01 245
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FC01 246
J=IP+NINT(QX(I+1))#                    Point to scale location          FC01 247
IF(J>IP) QX(I+1)=QX(J)#                Store scale in table             FC01 248
ELSE     QX(I+1)=1.#                   Default scale is 1.              FC01 249
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FC01 250
I=IP+IREL(3); IF(I>IP) IRAD=NINT(QX(I))# Radiation (1=n,2=e;3=x)        FC01 251
I=IP+IREL(4); IF(I>IP) CELL=QX(I)/47.878# Cell volume for elect rad     FC01 252
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FC01 253
IF(IREL(4)==0&IRAD==2) iquit:(FC0102)# Cell volume missing              FC01 254
IF(IRAD==2) FMUL=FMUL/CELL#            Scale structure factor volts     FC01 255
MARK5=MARK4+NSCL#                      Reset mark5 for true nscl        FC01 256
#                                                                       FC01 257
#   ENTER DATA SET INFORMATION (LR LRDSET:)                             FC01 258
#   ---------------------------------                                   FC01 259
#                                                                       FC01 260
IWNT(1)=2;  IWNT(7)=1#                 Request ovb, dataset number      FC01 261
DO I=2,6;   IWNT(I)=I+9#               Request maxhkl, max&min stol     FC01 262
KEY(1)=0;  KEY(2)=7; KEY(3)=0#         Set search delimiters            FC01 263
indexpkt:(1,lrdset:,LPAK,IP,2,KEY,IWNT,IREL)# Search rel pointers       FC01 264
BOVL=0.; SMIN=0.; SMAX=2.#             Set default parameters           FC01 265
MAXH=256.; MAXK=256.; MAXL=256.#       Set default parameters           FC01 266
IF (IP>0) $#                           If there was a directory         FC01 267
REPEAT#                                Loop over data sets              FC01 268
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FC01 269
readwpkt:(1,lrdset:,LPAK,IP,0)#                                         FC01 270
IF(IP<=0) BREAK#                                                        FC01 271
writepkt:(2,lrdset:,LPAK,IPO)#         Get o/p buffer pointer           FC01 272
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy the packet                  FC01 273
IDS=IP+IREL(7)#                        Make pointer to dataset no.      FC01 274
ifne:(DSNM,QX(IDS)) NEXT#              Skip unwanted datasets           FC01 275
I=IP+IREL(1); IF(I>IP) BOVL=QX(I)*UTOB# Get active b overall            FC01 276
I=IP+IREL(2); IF(I>IP) MAXH=QX(I)#     Get active max /h/               FC01 277
I=IP+IREL(3); IF(I>IP) MAXK=QX(I)#     Get active max /k/               FC01 278
I=IP+IREL(4); IF(I>IP) MAXL=QX(I)#     Get active max /l/               FC01 279
I=IP+IREL(5); IF(I>IP) SMIN=QX(I)#     Get active smin                  FC01 280
I=IP+IREL(6); IF(I>IP) SMAX=QX(I)#     Get active smax                  FC01 281
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FC01 282
#                                                                       FC01 283
RETURN#                                                                 FC01 284
END#                                                                    FC01 285
systemheader:(FC02)#                   Read controls                    FC02   1
# ####################################################################  FC02   2
#                                                                       FC02   3
#                                FC02                                   FC02   4
#                                                                       FC02   5
# ####################################################################  FC02   6
SUBROUTINE FC02#                                                        FC02   7
include:(AACOMN)#                                                       FC02   8
include:(FCCOMN)#                                                       FC02   9
#                                                                       FC02  10
INTEGER IARC#                          Archive input flag               FC02  11
INTEGER I,J,K,M#                       Working indices                  FC02  12
#                                                                       FC02  13
chardata:(FC21, SCALE MAXHKL SELECT OMIT ARCHIV END    )#               FC02  14
chardata:(FC22,        )#                                               FC02  15
datastuff:#                                                             FC02  16
#                                                                       FC02  17
#   ENTER CONTROL LINES                                                 FC02  18
#   -------------------                                                 FC02  19
#                                                                       FC02  20
MARK6=MARK5#                           Set select atom marker           FC02  21
NAME=incr:(arith:(23,/,mxchwd:))#      Calc atom name length            FC02  22
DO I=1,7;  ARCH(I)=-FLOAT(NMDS+I+799)# Generate archive list            FC02  23
ARCH(8)=-FLOAT(NMDS+700)#              Generate archive list            FC02  24
ARCH(9)=-FLOAT(NMDS+701)#              Archive ad-correct frel          FC02  25
ARCH(10)=-FLOAT(NMDS+910)#             Sim weight                       FC02  26
ARCH(11)=-FLOAT(NMDS+820)#             Full f calc                      FC02  27
ARCH(12)= FLOAT(NMDS+304)#             To stash frel in outpacket
IARC=0;   ITEM=11;    ISEL=0#          Reset archive parameters         FC02  28
#                                                                       FC02  29
REPEAT#                                Loop over control lines          FC02  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FC02  31
readline:(FC21,NFC21)#                 Process control line             FC02  32
#                                                                       FC02  33
IF(LINID==1)#                          ****** scale *******             FC02  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FC02  35
ifvo:(BUFIN(1)) NEXT#                  Skip if void scale               FC02  36
ifvo:(BUFIN(2)) I=1#                   Default scale group              FC02  37
ELSE             I=NINT(BUFIN(2))#     Enter scale group                FC02  38
QX(MARK4+I)=BUFIN(1)#                  Store scale value                FC02  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FC02  40
#                                                                       FC02  41
ELSE IF(LINID==2)#                     ****** maxhkl *******            FC02  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FC02  43
ifnv:(BUFIN(1)) MAXH=BUFIN(1)#         Set active max /h/               FC02  44
ifnv:(BUFIN(2)) MAXK=BUFIN(2)#         Set active max /k/               FC02  45
ifnv:(BUFIN(3)) MAXL=BUFIN(3)#         Set active max /l/               FC02  46
ifnv:(BUFIN(4)) SMIN=BUFIN(4)#         Set active min st/l              FC02  47
ifnv:(BUFIN(5)) SMAX=BUFIN(5)#         Set active max st/l              FC02  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FC02  49
#                                                                       FC02  50
ELSE IF(LINID==3\LINID==4)#            ****** select/omit *******       FC02  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FC02  52
IF(ISEL==1&LINID==4) iquit:(FC0201)#   Select and omit lines mixed      FC02  53
IF(ISEL==2&LINID==3) iquit:(FC0201)#   Select and omit lines mixed      FC02  54
ISEL=LINID-2#                          Select=1; omit=2                 FC02  55
DO I=1,30#                             Loop over select fields          FC02  56
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FC02  57
ifvo:(BUFIN(I)) BREAK#                 Exit first inactive field        FC02  58
M=MARK6+1#                             Point to next name               FC02  59
incrqx:(MARK6,MARK6+NAME,FC0202)#      Expand qx......fc202             FC02  60
stringlim:(I,J,K)#                     Extract string limits            FC02  61
K=MIN0(K-J,24)#                        Limit to 24 characters           FC02  62
movector:(FC22,1,QX(M),1,24,1)#        Blank out qx region              FC02  63
movector:(CHRIP,J,QX(M),1,K,0)#        Store name in qx                 FC02  64
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FC02  65
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FC02  66
#                                                                       FC02  67
ELSE IF(LINID==5)#                     ***** archiv ******              FC02  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FC02  69
IARC=1#                                Set archive ip flag              FC02  70
DO J=1,30#                             Loop over input fields           FC02  71
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FC02  72
ifvo:(BUFIN(J)) BREAK#                 Exit after last idnum            FC02  73
FOR(I=1;I<=ITEM;I=I+1)#                Loop over archive list           FC02  74
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FC02  75
ifeq:(BUFIN(J),ARCH(I)) BREAK#         Exit if delete on list           FC02  76
ifne:(BUFIN(J),(-ARCH(I))) NEXT#       Exit if not reverse              FC02  77
ARCH(I)=-ARCH(I)#                      Change delete to add             FC02  78
BREAK#                                 Exit after update                FC02  79
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FC02  80
IF((I<=ITEM)\(BUFIN(J)>0.)) NEXT#      Set if preset or illegal         FC02  81
ITEM=ITEM+1#                           Incr archive list                FC02  82
ARCH(ITEM)=BUFIN(J)#                   Add delete to archive            FC02  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FC02  84
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FC02  85
#                                                                       FC02  86
ELSE BREAK#                            ****** end *******               FC02  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FC02  88
IF(IARC==0)#                           Test if archive input            FC02  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FC02  90
ARCH(1)=-ARCH(1);  ARCH(8)=-ARCH(8)#   Set default add items            FC02  91
ARCH(11)=-ARCH(11)#                    Keep full fcalc                  FC02  92
IF(DISP==yes:) ARCH(9)=-ARCH(9)#       Save ad-corrected frel           FC02  93
IF(ISIM==yes:) ARCH(10)=-ARCH(10)#     Save sim weight                  FC02  94
IF(ICORE!=0)
$(
ARCH(11)=-ABS(ARCH(11));ARCH(1)=-ABS(ARCH(1))# corrupt so remove them
ARCH(9)=ABS(ARCH(9))#                  save regardless of disp option
$)
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FC02  95
#                                                                       FC02  96
RETURN#                                                                 FC02  97
END#                                                                    FC02  98
systemheader:(FC03)#                   Get atom parameters from lra     FC03   1
# ####################################################################  FC03   2
#                                                                       FC03   3
#                               FC03                                    FC03   4
#                                                                       FC03   5
# ####################################################################  FC03   6
SUBROUTINE FC03#                                                        FC03   7
include:(AACOMN)#                                                       FC03   8
include:(FCCOMN)#                                                       FC03   9
#                                                                       FC03  10
INTEGER I,J,K,L,M,N#                   Working indices                  FC03  11
INTEGER IPO#                           O/p buffer pointer               FC03  12
INTEGER LIST#                          Number of list items             FC03  13
INTEGER NAT#                           Atom name point                  FC03  14
INTEGER NSTEP#                         Step size per atom in mark6      FC03  15
REAL SMUL#                             Site muliplicity                 FC03  16
REAL POPP#                             Population parameter             FC03  17
REAL X,Y,Z#                            Coordinate storage               FC03  18
#                                                                       FC03  19
string:(NAME1,24)#                     Atom name from bdf               FC03  20
string:(NAME2,24)#                     Selected part atom name          FC03  21
string:(NAME3,24)#                     Atom name left part              FC03  22
chardata:(FC31," x/a    y/b    z/c   $#                                 FC03  23
pp*ml    U11     U22     U33     U12     U13     U23")#                 FC03  24
realdata:(FMT,[742.,742.,742.,622.,842.,842.,842.,842.,842.,842.])#     FC03  25
realdata:(B11,0.); realdata:(B22,0.); realdata:(B33,0.)#                FC03  26
realdata:(B12,0.); realdata:(B13,0.); realdata:(B23,0.)#                FC03  27
datastuff:#                                                             FC03  28
#                                                                       FC03  29
copyfile:(1,2,incr:(lrdset:),decr:(lratom:))# Copy to atom rec.         FC03  30
#                                                                       FC03  31
#--------------------------------------------------------------------   FC03  32
##### LAYOUT OF ATOM PARAMETER STORAGE                                  FC03  33
# RELATIVE ADDRESS                                                      FC03  34
# IN QX ARRAY                                                           FC03  35
#      1                SCAT. FACTOR POINTER                            FC03  36
#      2                X                                               FC03  37
#      3                Y                                               FC03  38
#      4                Z                                               FC03  39
#      5                ATOM MULTIPLICITY * POPULATION                  FC03  40
#      6                BETA11 (OR B)                                   FC03  41
#      7                BETA22 (OR SIGNAL TO B IN 6)                    FC03  42
#      8                BETA 33                                         FC03  43
#      9                BETA 12                                         FC03  44
#     10                BETA 13                                         FC03  45
#     11                BETA 23                                         FC03  46
#---------------------------------------------------------------------- FC03  47
#                                                                       FC03  48
#   LOCATE REQUIRED PARAMETERS IN LR LRATOM:                            FC03  49
#   ----------------------------------                                  FC03  50
#                                                                       FC03  51
IWNT(1)=22; IWNT(14)=21#               Set nscf, mult, tf idnums        FC03  52
IWNT(2)=14; IWNT(13)=11#               Set atom name, neut-flag idnum   FC03  53
DO I=1,3;   IWNT(I+2)=I#               Set x to z idnums                FC03  54
DO I=4,10;  IWNT(I+2)=I#               Set displ. params u uij          FC03  55
IWNT(15)=26#                            
KEY(1)=5;  KEY(2)=15;  KEY(3)=0#       Set search delimiters            FC03  56
KEY(4)=0#                              Copy mode for indexpkt:          FC03  57
indexpkt:(1,lratom:,LPAK,IP,2,KEY,IWNT,IREL)# Get relative pointers     FC03  58
IF(KEY(4)<0) iquit:(FC0301)#           Data missing.....fc301           FC03  59
#                                                                       FC03  60
IF((TYPE==4)&(IREL(7)<=0)) TYPE=3#     Type 4 needs aniso               FC03  61
IF((TYPE==3)&(IREL(6)<=0)) TYPE=2#     Type 3 calc needs iso b          FC03  62
IF((TYPE==2)&(BOVL<0.)) iquit:(FC0301)# Type 2 needs overall tf         FC03  63
IF((ICORE!=0)&IREL(15)<=0) iquit:(FC0302)# need core val type
#                                                                       FC03  64
#    RESERVE QX ARRAY FOR ATOM PARAMETERS                               FC03  65
#    ------------------------------------                               FC03  66
#                                                                       FC03  67
IF     (TYPE==1) IATM=5#               Allow for ff,x,y,z,m             FC03  68
ELSE IF(TYPE==2) IATM=5#               Allow for ff,x,y,z,pp            FC03  69
ELSE IF(TYPE==3) IATM=6#               Allow for ff,x,y,z,pp,b          FC03  70
ELSE             IATM=11#              Allow for ff,x,y,z,pp,bij        FC03  71
NSTEP=NROT*IATM#                       Figure step size for each at     FC03  72
HEADOT=' '; HEADOT(14^)=FC31#          Set atom list header             FC03  73
#                                                                       FC03  74
#   EXTRACT ATOM PARAMETERS FROM LR LRATOM:                             FC03  75
#   ---------------------------------                                   FC03  76
#                                                                       FC03  77
writeline:(0,0,0,1,3);  LINRM=4#       Prepare for list header          FC03  78
NATM=0#                                Zero count of selected atoms     FC03  79
DO I=1,mxat:; ATP(I)=0.#                  Zero count of atom number        FC03  80
K=MARK6#                               Start atom list pointer          FC03  81
REPEAT#                                Loop over atom packets           FC03  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FC03  83
readwpkt:(1,lratom:,LPAK,IP,0)#        Get packet pointer               FC03  84
IF(IP<=0) BREAK#                       Exit after last packet           FC03  85
writepkt:(2,lratom:,LPAK,IPO)#         Get o/p buffer pointer           FC03  86
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy the packet                  FC03  87
LIST=IATM-1#                           Set number list items            FC03  88
#                                                                       FC03  89
N=IP+IREL(2)#                          Make pointer to atom name        FC03  90
movertoc:(QX(N),1,NAME1,1,24,0)#       Move name to character array     FC03  91
label:(NAME1,I,J)#                     Get max label length             FC03  92
NAME2=NAME1(1^J)#                      Extract scatt fact symbol        FC03  93
FOR(I=MARK5;I<MARK6;I=I+NAME)#         Loop over selected atoms         FC03  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FC03  95
movertoc:(QX(I+1),1,NAME3,1,24,0)#     Move name of selected atom       FC03  96
IF(NAME1==NAME3\NAME2==NAME3) BREAK#   Test atom label or type symbol   FC03  97
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FC03  98
IF(I>=MARK6&ISEL==1) NEXT#             Skip unselected atoms            FC03  99
IF(I<MARK6&ISEL==2)  NEXT#             Skip omitted atoms               FC03 100
NATM=NATM+1#                           Increment count of found ato     FC03 101
incrqx:(MARK7,K+NSTEP,FC0302)#         Expand qx......fc302             FC03 102
#                                                                       FC03 103
I=IP+IREL(1); scat:(K)=QX(I); NAT=NINT(QX(I))# Get sf number pointer 
I=IP+IREL(3); X=QX(I)#                 Store x coordinate               FC03 105
I=IP+IREL(4); Y=QX(I)#                 Store y coordinate               FC03 106
I=IP+IREL(5); Z=QX(I)#                 Store z coordinate               FC03 107
I=IP+IREL(13); IF(I>IP) POPP=QX(I)#    Store pop parameter              FC03 108
ELSE POPP=1.#                          Else set to one                  FC03 109
I=IP+IREL(14); IF(I>IP) SMUL=QX(I)#    Store site mult.                 FC03 110
ELSE SMUL=1.#                          Else set to one                  FC03 111
IF (ICORE!=0)
$(
I=IP+IREL(15) ; IF(I>IP) ZCORE=ATZ(NAT)-QX(I)#  Store core Z
ELSE iquit:(FC0310)#          
DO I=1,NTYP; ifeq:(ATZ(I),ZCORE) break# 
IF(I>NTYP) iquit:(FC0311)#             No matching scattering factors
scat:(K)=float(I)#                     use core atom type instead
$)
POPP=POPP*SMUL#                        Store combined m*pp              FC03 112
B11=0.#                                Initialize b11                   FC03 113
IF(TYPE>2)#                            Test if more data needed         FC03 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FC03 115
I=IP+IREL(6); IF(I>IP) bis:(K)=QX(I)*UTOB# Store isotropic b            FC03 116
ELSE                   bis:(K)=BOVL#   Else store overall b             FC03 117
IF(TYPE==4)#                           Test if more data needed         FC03 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FC03 119
I=IP+IREL(7); IF(I>IP) B11=QX(I)*UTOBET(1)# Extract beta11              FC03 120
IF(B11>0.)#                            Test if aniso or iso tf          FC03 121
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FC03 122
I=IP+IREL(8); B22=QX(I)*UTOBET(2)#     Extract beta22                   FC03 123
I=IP+IREL(9); B33=QX(I)*UTOBET(3)#     Extract beta33                   FC03 124
I=IP+IREL(10); B12=QX(I)*UTOBET(4)#    Extract beta12                   FC03 125
I=IP+IREL(11); B13=QX(I)*UTOBET(5)#    Extract beta13                   FC03 126
I=IP+IREL(12); B23=QX(I)*UTOBET(6)#    Extract beta23                   FC03 127
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FC03 128
ELSE LIST=5#                           Reset list to isotropic          FC03 129
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FC03 130
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FC03 131
#                                                                       FC03 132
#                                                                       FC03 133
#   GENERATE EQUIVALENT POSITIONS                                       FC03 134
#   -----------------------------                                       FC03 135
#                                                                       FC03 136
M=K-5#                                 Set init betaij test pt to fail
FOR(N=MARK1;N<MARK2;N=N+12)#           Loop over rot matrices           FC03 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FC03 139
DO I=1,3#                              Rowxcolumn marix multiply        FC03 140
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FC03 141
J=N+I;   L=K+I+1#                      Increment pointers               FC03 142
xif:(K,I)=X*QX(J)+Y*QX(J+3)+Z*QX(J+6)+QX(J+9)# Matrix multiply    
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FC03 144
pmul:(K)=POPP#                         Store site population  
#                                                                       FC03 146
IF(B11>0.)#                            Test if aniso needed             FC03 147
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FC03 148
#                                        Calculate beta11               FC03 149
bij:(K,1)= QX(N+1)*QX(N+1)*B11 $#                                       FC03 150
+          QX(N+4)*QX(N+4)*B22 $#                                       FC03 151
+          QX(N+7)*QX(N+7)*B33 $#                                       FC03 152
+    2.0 *(QX(N+1)*QX(N+4)*B12 $#                                       FC03 153
+          QX(N+1)*QX(N+7)*B13 $#                                       FC03 154
+          QX(N+4)*QX(N+7)*B23)#                                        FC03 155
#                                        Calculate beta22               FC03 156
bij:(K,2)= QX(N+2)*QX(N+2)*B11 $#                                       FC03 157
+          QX(N+5)*QX(N+5)*B22 $#                                       FC03 158
+          QX(N+8)*QX(N+8)*B33 $#                                       FC03 159
+    2.0 *(QX(N+2)*QX(N+5)*B12 $#                                       FC03 160
+          QX(N+2)*QX(N+8)*B13 $#                                       FC03 161
+          QX(N+5)*QX(N+8)*B23)#                                        FC03 162
#                                        Calculate beta33               FC03 163
bij:(K,3)= QX(N+3)*QX(N+3)*B11 $#                                       FC03 164
+          QX(N+6)*QX(N+6)*B22 $#                                       FC03 165
+          QX(N+9)*QX(N+9)*B33 $#                                       FC03 166
+    2.0 *(QX(N+3)*QX(N+6)*B12 $#                                       FC03 167
+          QX(N+3)*QX(N+9)*B13 $#                                       FC03 168
+          QX(N+6)*QX(N+9)*B23)#                                        FC03 169
#                                        Calculate beta12               FC03 170
bij:(K,4)=  QX(N+1)*QX(N+2)*B11 $#                                      FC03 171
+           QX(N+4)*QX(N+5)*B22 $#                                      FC03 172
+           QX(N+7)*QX(N+8)*B33 $#                                      FC03 173
+          (QX(N+2)*QX(N+4)     $#                                      FC03 174
+           QX(N+1)*QX(N+5))*B12$#                                      FC03 175
+          (QX(N+2)*QX(N+7)     $#                                      FC03 176
+           QX(N+1)*QX(N+8))*B13$#                                      FC03 177
+          (QX(N+5)*QX(N+7)     $#                                      FC03 178
+           QX(N+4)*QX(N+8))*B23#                                       FC03 179
#                                        Calculate beta13               FC03 180
bij:(K,5)=  QX(N+1)*QX(N+3)*B11 $#                                      FC03 181
+           QX(N+4)*QX(N+6)*B22 $#                                      FC03 182
+           QX(N+7)*QX(N+9)*B33 $#                                      FC03 183
+          (QX(N+3)*QX(N+4)     $#                                      FC03 184
+           QX(N+1)*QX(N+6))*B12$#                                      FC03 185
+          (QX(N+3)*QX(N+7)     $#                                      FC03 186
+           QX(N+1)*QX(N+9))*B13$#                                      FC03 187
+          (QX(N+6)*QX(N+7)     $#                                      FC03 188
+           QX(N+4)*QX(N+9))*B23#                                       FC03 189
#                                        Calculate beta23               FC03 190
bij:(K,6)=  QX(N+2)*QX(N+3)*B11 $#                                      FC03 191
+           QX(N+5)*QX(N+6)*B22 $#                                      FC03 192
+           QX(N+8)*QX(N+9)*B33 $#                                      FC03 193
+          (QX(N+3)*QX(N+5)     $#                                      FC03 194
+           QX(N+2)*QX(N+6))*B12$#                                      FC03 195
+          (QX(N+3)*QX(N+8)     $#                                      FC03 196
+           QX(N+2)*QX(N+9))*B13$#                                      FC03 197
+          (QX(N+6)*QX(N+8)     $#                                      FC03 198
+           QX(N+5)*QX(N+9))*B23#                                       FC03 199
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FC03 200
#                                                                       FC03 201
#    LIST INPUT ATOMS                                                   FC03 202
#    ----------------                                                   FC03 203
#                                                                       FC03 204
IF(PPRIOR>=4\(DLIS<99999.&N==MARK1))#  Dump atom list at pr=5           FC03 205
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FC03 206
IF(N==MARK1)#                          Test if input atom site          FC03 207
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FC03 208
movechar:(NAME1,1,CHROT,2,24,0)#       Get current atom name            FC03 209
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FC03 210
ELSE IF(B11<.00001) LIST=3#            Reset for equiv. site            FC03 211
movereal:(xif:(K,1),1,BUFOT,1,LIST,0)# Copy to bufot for editing   
IF(LIST==5) BUFOT(5)=BUFOT(5)/UTOB#    Print u for isotropic dp         FC03 213
ELSE IF(LIST==10)#                     Anisotropic dp                   FC03 214
DO I=1,6; BUFOT(I+4)=BUFOT(I+4)/UTOBET(I)# Uij                          FC03 215
LCHROT=11#                             Start op formats                 FC03 216
ncodefld:(BUFOT,1,CHROT,FMT,LIST)#     Format stored items              FC03 217
writeline:(0,HEADOT,100,1,3)#          Print equivalent sites           FC03 218
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FC03 219
#                                                                       FC03 220
#   ACCOUNT FOR REPETITIVE DATA                                         FC03 221
#   ---------------------------                                         FC03 222
#                                                                       FC03 223
IF(B11>0.)#                            Test if betaij calculated        FC03 224
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FC03 225
I=0#                                   Set identical betaij frag        FC03 226
FOR(L=1;L<7;L=L+1)#                    Loop over betaij elements        FC03 227
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FC03 228
IF(L>3) bij:(K,L)=2.*bij:(K,L)#        Apply 2*beta(i!=j) now           FC03 230
ifne:(bij:(K,L),bij:(M,L)) I=1#        Flag if betaij different         FC03 231
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FC03 232
IF(I==1) M=K#                          diff so Reset betaij test pointer 
ELSE     bij:(K,2)=0.#                 Use u22 as Flag for identical
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FC03 235
pmul:(K)=pmul:(K)*FMUL#                Apply sym multipicity now        FC03 236
K=K+IATM#                              Incr atom list pointer           FC03 237
ATP(NAT)=ATP(NAT)+FMUL*SMUL#           Atom number of partial structu   FC03 238
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FC03 239
#                                                                       FC03 240
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FC03 241
#                                                                       FC03 242
RETURN#                                                                 FC03 243
END#                                                                    FC03 244
systemheader:(FC04)#                   Prepare lr lrrefl: & copy fi     FC04   1
# ####################################################################  FC04   2
#                                                                       FC04   3
#                                FC04                                   FC04   4
#                                                                       FC04   5
# ####################################################################  FC04   6
SUBROUTINE FC04#                                                        FC04   7
include:(AACOMN)#                                                       FC04   8
include:(FCCOMN)#                                                       FC04   9
#                                                                       FC04  10
INTEGER I,J#                           Working indices                  FC04  11
chardata:(FC41,-NO YESXRAYNEUTSCATREFLOVERALL  $#                       FC04  12
ISOTROPICMIXED    ALL)#                                                 FC04  13
chardata:(FC42, FC CALCULATION PARAMETERS)#                             FC04  14
chardata:(FC43, DATA SET NUMBER USED     )#                             FC04  15
chardata:(FC4A, STRUCTURE FACTOR UNITS            )#                    FC04  16
chardata:(FC44, DISPL. PARAM. U X100                      )#            FC04  17
chardata:(FC45, EXTINCTION CORRECTION                )#                 FC04  18
chardata:(FC46, ANOMALOUS DISPERSION       )#                           FC04  19
chardata:(FC47, SIN/COS LOOKUP TABLE       )#                           FC04  20
chardata:(FC48, REFLN CODES REJECTED          )#                        FC04  21
chardata:(FC49, LIST REFLNS ABOVE DF              )#                    FC04  22
chardata:(FC410, RADIATION TYPE USED              )#                    FC04  23
chardata:(FC411, SOURCE OF SCAT.FACTOR LR           )#                  FC04  24
chardata:(FC412, MAXIMUM H K L USED              )#                     FC04  25
chardata:(FC413, MIN/MAX ST/L USED               )#                     FC04  26
chardata:(FC414, NUMBER OF ATOM SITES          )#                       FC04  27
chardata:(FC415, FREL SCALE FOR GROUP   1         )#                    FC04  28
chardata:(FC416,[ EXTINCTION NOT APPLIED (FACTOR NOT ON BDF)])#         FC04  29
chardata:(FC417, SIM WEIGHT IS ADDED TO BDF)#                           FC04  30
chardata:(FC418,NEUTRON ELECTRONXRAYS   )#                              FC04  31
chardata:(FC419,PICO-CMS VOLTS    ELECTRONS)#                           FC04  32
datastuff:#                                                             FC04  33
#                                                                       FC04  34
#    LIST CALCULATION PARAMETERS                                        FC04  35
#    ---------------------------                                        FC04  36
#                                                                       FC04  37
LINRM=10#                              Force parameter header           FC04  38
movechar:(FC41,1,CHROT,2,NFC42-1,2)#   Underline header                 FC04  39
writeline:(1,FC42,NFC42,1,3)#          Print calculation header         FC04  40
#                                                                       FC04  41
I=MIN(IRAD,3)#                         Modification for mo,cu,ag,sync   FC04  42
movechar:(FC419,I*9-8,FC4A,25,9,0)#    Insert sf units                  FC04  43
writeline:(0,FC4A,NFC4A,3,3)#          Print sf units                   FC04  44
#                                                                       FC04  45
movechar:(FC418,I*8-7,FC410,25,8,0)#   Insert radiation type            FC04  46
writeline:(0,FC410,NFC410,3,3)#        Print radiation type             FC04  47
#                                                                       FC04  48
ncodefld:(DSNM,1,FC43,250513.,1)#      Format dataset number            FC04  49
writeline:(0,FC43,NFC43,3,3)#          Print dataset number             FC04  50
#                                                                       FC04  51
movechar:(FC41,(TYPE-2)*9+24,FC44,25,9,0)# Insert dp type               FC04  52
IF(TYPE==2)#                                                            FC04  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FC04  54
BUFOT(1)=100.*BOVL/UTOB#               Output 100* uoverall             FC04  55
ncodefld:(BUFOT(1),1,FC44,420532.,1)#  Insert value in buffer           FC04  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FC04  57
writeline:(0,FC44,NFC44,3,3)#          Print tf type                    FC04  58
#                                                                       FC04  59
IF(ISIM==yes:)#                        Test if apply sim weight         FC04  60
writeline:(0,FC417,NFC417,3,3)#        Print sim weight                 FC04  61
#                                                                       FC04  62
movechar:(FC41,IEXT*3+2,FC45,25,3,0)#  Insert no/yes for ext.           FC04  63
writeline:(0,FC45,NFC45,3,3)#          Print ext. parameters            FC04  64
#                                                                       FC04  65
movechar:(FC41,DISP*3+2,FC46,25,3,0)#  Insert no/yes for a.d.           FC04  66
writeline:(0,FC46,NFC46,3,3)#          Print dispersion                 FC04  67
#                                                                       FC04  68
movechar:(FC41,ISIN*3+2,FC47,25,3,0)#  Insert no/yes s/c table          FC04  69
writeline:(0,FC47,NFC47,3,3)#          Print s/c table status           FC04  70
#                                                                       FC04  71
ifeq:(REJF,6.)I=no:; ELSE I=yes:#      Test for rejections              FC04  72
movechar:(FC41,I*3+2,FC48,25,3,0)#     Insert no/yes rejects            FC04  73
IF(I==yes:)#                           Test if reject active            FC04  74
ncodefld:(REJF+.5,1,FC48,300113.,1)#   Format reject flag               FC04  75
writeline:(0,FC48,NFC48,3,3)#          Print reject conditions          FC04  76
#                                                                       FC04  77
IF(DLIS<9998.)I=yes:; ELSE I=no:#      Test if list expected            FC04  78
movechar:(FC41,I*3+2,FC49,25,3,0)#     Insert no/yes list               FC04  79
IF(DLIS<0.)movechar:(FC41,NFC41-2,FC49,30,3,0)# Insert 'all'            FC04  80
ELSE IF(I==yes:)#                      Test if partial list             FC04  81
ncodefld:(DLIS,1,FC49,350822.,1)#      Format list limit                FC04  82
writeline:(0,FC49,NFC49,3,3)#          Print list parameters            FC04  83
#                                                                       FC04  84
DSTL=.02#                              Set default ff incr              FC04  85
IF(IFFF==0)#                           Test if ff in lrrefl             FC04  86
ncodefld:(DSTL,1,FC411,350522.,1)#     Add stol interval to o/p         FC04  87
movechar:(FC41,IFFF*4+16,FC411,26,4,0)# Insert lr number                FC04  88
writeline:(0,FC411,NFC411,3,3)#        Print scat.fac. source           FC04  89
#                                                                       FC04  90
ncodefld:(MAXH,1,FC412,250413.,1)#     Format max/h/                    FC04  91
ncodefld:(MAXK,1,FC412,290413.,1)#     Format max/k/                    FC04  92
ncodefld:(MAXL,1,FC412,330413.,1)#     Format max/l/                    FC04  93
writeline:(0,FC412,NFC412,3,3)#        Print max hkl                    FC04  94
#                                                                       FC04  95
ncodefld:(SMIN,1,FC413,270532.,1)#     Format min st/l                  FC04  96
ncodefld:(SMAX,1,FC413,330532.,1)#     Format max st/l                  FC04  97
writeline:(0,FC413,NFC413,3,3)#        Print st/l min/max               FC04  98
#                                                                       FC04  99
ncodefld:(FLOAT(NATM),1,FC414,260413.,1)# Format atom count             FC04 100
writeline:(0,FC414,NFC414,3,3)#        Print atom count                 FC04 101
#                                                                       FC04 102
ncodefld:(QX,MARK4+1,FC415,340732.,1)# Format scale 1                   FC04 103
writeline:(0,FC415,NFC415,3,3)#        Print scale 1                    FC04 104
FOR(I=2;I<=NSCL;I=I+1)#                Loop over scale groups           FC04 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FC04 106
ncodefld:(FLOAT(I),1,CHROT,250213.,1)## Format scale group              FC04 107
ncodefld:(QX,MARK4+I,CHROT,340732.,1)## Format scale value              FC04 108
writeline:(0,0,0,1,3)#                 Print scales only                FC04 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FC04 110
#                                                                       FC04 111
#                                                                       FC04 112
#   SEARCH LR LRREFL: POINTERS & CONSTRUCT O/P                          FC04 113
#   -------------------------------------------                         FC04 114
#                                                                       FC04 115
copyfile:(1,2,incr:(lratom:),decr:(lrrefl:))# Copy to refl rec.         FC04 116
DO I=1,NTYP;  IWNT(I)=500+I#           Set scat.fac. idnums             FC04 117
IWNT(NTYP+1)=NMDS+304#                 Set frel idnum                   FC04 118
IWNT(NTYP+2)=NMDS+308#                 Set jcode idnum                  FC04 119
IWNT(NTYP+3)=NMDS+309#                 Set nscl idnum                   FC04 120
IWNT(NTYP+4)=NMDS+202#                 Set extf idnum                   FC04 121
IWNT(NTYP+5)=1 ;IWNT(NTYP+6)=2#        Set hkl and stol idnums          FC04 122
IWNT(NTYP+7)=NMDS+600#                 Set normalised sf e1             FC04 123
DO I=1,ITEM#                           Loop over archive list           FC04 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FC04 125
J=NTYP+7+I#                            Get want pointer                 FC04 126
IWNT(J)=NINT(ARCH(I))#                 Store archive list               FC04 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FC04 128
KEY(1)=0;     KEY(2)=NTYP+7#           Set search delimiters            FC04 129
KEY(4)=1;     KEY(3)=NTYP+7+ITEM#      Set search delimiters            FC04 130
indexpkt:(1,lrrefl:,LPAK,IP,2,KEY,IWNT,IREL)# Search rel pointers       FC04 131
NPAK=KEY(4)#                           Set output paksize               FC04 132
#                                                                       FC04 133
IF(NSCF==0)#                           Test if scatfac table exist      FC04 134
DO I=1,NTYP#                           Loop over atom types             FC04 135
IF(IREL(I)==0) iquit:(FC0401)#         No ff......fc401                 FC04 136
#                                                                       FC04 137
DO I=1,ITEM;  IWNT(I)=NINT(ARCH(I))#   Relocate archive list            FC04 138
FOR(I=KEY(2);I<KEY(3);I=I+1)#          Loop over irel deletes           FC04 139
IF(IREL(I+1)>9999) BREAK#              Exit no more                     FC04 140
NDEL=MAX0(0,NPAK-LPAK+I-KEY(2))#       Diff i/p to o/p packet           FC04 141
DO I=1,NTYP;OFF(I)=MARK3+(I-1)*NSCF+1# Setup ff table offsets           FC04 142
#                                                                       FC04 143
IRF=IREL(NTYP+1);  IRJ=IREL(NTYP+2)#   Frel & jcode pointers            FC04 144
IRS=IREL(NTYP+3);  IRX=IREL(NTYP+4)#   Scale & ext pointers             FC04 145
IRH=IREL(NTYP+5);  IRL=IREL(NTYP+6)#   Hkl and stol pointers            FC04 146
IEV=IREL(NTYP+7)#                      Point to e1                      FC04 147
IFA=IREL(NTYP+9);  IFB=IREL(NTYP+10)#  Prev Acal,Bcal  
IF(ICORE!=0 & IFA<=0) iquit:(FC0499)# can't continue without it
IRFO=0
DO I=1,NPAK;IF(NINT(QX(IP+I))==NMDS+304)IRFO=I#
IF(IRX==0)#                            Ext. consts not on bdf           FC04 148
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FC04 149
writeline:(1,FC416,NFC416,3,3)#        Tell user ext. turned off        FC04 150
IEXT=no:#                              Turn off extinction              FC04 151
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FC04 152
#                                                                       FC04 153
DO I=1,2;    DO J=1,6#                 Loop over refln codes            FC04 154
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FC04 155
SUMR(I,J)=0.;  SUMC(I,J)=0.#           Zeroize stats sums               FC04 156
SUMN(I,J)=0.;  SUMD(I,J)=0.#           Zeroize stats sums               FC04 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FC04 158
writeline:(0,0,0,1,3);  LINRM=4#       Prepare for fc listing           FC04 159
DO I=1,NTYP; ATP(I)=MAX(0.0,ATA(I)-ATP(I))# Get unknown atom number     FC04 160
#                                                                       FC04 161
#   SETUP SIN/COS TABLE IF NEEDED                                       FC04 162
#   -----------------------------                                       FC04 163
#                                                                       FC04 164
IF(ISIN==yes:)#                        Test if table requested          FC04 165
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FC04 166
IF(MARK7+452<=QXMAX)#                  Check if enough memory           FC04 167
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FC04 168
incrqx:(J,MARK7+452,-FC0402)#          Expand qx......fc402             FC04 169
FOR(I=MARK7;I<J;I=I+1)#                Loop over degree intervals       FC04 170
QX(I+1)=SIN(FLOAT(I-MARK7)*.0174532925)# Sine 0/s/449                   FC04 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FC04 172
ELSE ISIN=no:#                         Shutoff table lookup             FC04 173
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FC04 174
ifeq:(REJF,6.) REJF=3.5#               Reject rcodes 4 and 5            FC04 175
#                                                                       FC04 176
RETURN#                                                                 FC04 177
END#                                                                    FC04 178
systemheader:(FC05)#                   Calculate structure factors      FC05   1
# ####################################################################  FC05   2
#                                                                       FC05   3
#                                FC05                                   FC05   4
#                                                                       FC05   5
# ####################################################################  FC05   6
SUBROUTINE FC05#                                                        FC05   7
include:(AACOMN)#                                                       FC05   8
include:(FCCOMN)#                                                       FC05   9
#                                                                       FC05  10
REAL A,ATOT,ADIS,ANOD,ACAL(mxat:)#     Real s.f. components             FC05  11
REAL B,BTOT,BDIS,BNOD,BCAL(mxat:)#     Imag s.f. components             FC05  12
REAL FCAL,FREL,FDIF,FRND,FCND#         Structure factors                FC05  13
REAL H(3)#                             Miller indices & products        FC05  14
REAL SCPA,WSIM,XAP#                    For calc sim weight              FC05  15
INTEGER I,J,K,L,M#                     Working indices                  FC05  16
INTEGER JCOD#                          Current refln code               FC05  17
REAL PHI,ANG#                          Phase components                 FC05  18
REAL STOL,S2L2#                        St/l & s2t/l2 values             FC05  19
#                                                                       FC05  20
chardata:(FC51,    H   K   L   ST/L RC SG    FREL    FCAL   $#          FC05  21
ADSP   BDSP    EXTF   FRNDNE   FCNDNE   PHI   DELTA)#                   FC05  22
realdata:(FMT,[$#                                                       FC05  23
50413.,90413.,130413.,200642.,230203.,260203.,340822.,420822.,#         FC05  24
490612.,560612.,640822.,730922.,820922.,880613.,960822.])#              FC05  25
realdata:(PI2,6.2831853)#                                               FC05  26
realdata:(AH,0.); realdata:(AK,0.); realdata:(AL,0.)#                   FC05  27
realdata:(HH,0.); realdata:(KK,0.); realdata:(LL,0.)#                   FC05  28
realdata:(HK,0.); realdata:(HL,0.); realdata:(KL,0.)#                   FC05  29
realdata:(FACT,0.); realdata:(ANOX,0.); realdata:(BNOX,0.)#             FC05  30
realdata:(TEMP,0.); realdata:(CODE,0.); intdata:(ISCG,0)#               FC05  31
realdata:(EXTFAC,1.)#                  Ext. factor for fcals            FC05  32
datastuff:#                                                             FC05  33
#                                                                       FC05  34
#  LOOP OVER REFLECTION PACKETS (LRREFL:)                               FC05  35
#  ===================================                                  FC05  36
#                                                                       FC05  37
REPEAT#                                Loop over refln packets          FC05  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FC05  39
readwpkt:(1,lrrefl:,LPAK,IP,0)#        Point to input packet            FC05  40
IF(IP<=0) BREAK#                       Ifexit after last packet         FC05  41
#                                                                       FC05  42
#    SETUP OUTPUT PACKET                                                FC05  43
#    -------------------                                                FC05  44
#                                                                       FC05  45
writepkt:(2,lrrefl:,NPAK,JP)#          Point to output packet           FC05  46
K=JP+1;   L=KEY(2)+1#                  +1# set initial pointers         FC05  47
DO I=1,LPAK#                           Loop over input packet           FC05  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FC05  49
J=IP+I#                                Point to output items            FC05  50
movepakwd:(QX(J),QX(K))#               Move i/p to o/p                  FC05  51
IF(IREL(L)==I) L=L+1#                  Delete item & incr               FC05  52
ELSE           K=K+1#                  Tranfer item & incr              FC05  53
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FC05  54
#                                                                       FC05  55
#    TEST IF E-VALUE LIMITED                                            FC05  56
#    -----------------------                                            FC05  57
#                                                                       FC05  58
IF(ELIM>0.&IEV>0)#                     Is test requested                FC05  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FC05  60
movereal:(voidflg:,1,QX,K,NDEL,2)#     Zero add-on area                 FC05  61
IF(QX(IP+IEV)<ELIM) NEXT#              Skip if below limit              FC05  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FC05  63
IF(ICORE!=0)#                          Is test requested                FC05  59
ifvo:(QX(IP+IFA))
$(
movereal:(voidflg:,1,QX,K,NDEL,2)#     Zero add-on area                 FC05  61
NEXT
$)
movereal:(0.0,1,QX,K,NDEL,2)#          Zero add-on area                 FC05  64
#                                                                       FC05  65
#    EXTRACT REQUIRED REFLN DATA                                        FC05  66
#    ---------------------------                                        FC05  67
#                                                                       FC05  68
STOL=QX(IP+IRL)#                       Extract st/l                     FC05  69
IF((STOL<SMIN)\(STOL>SMAX)) NEXT#      Skip if outside s limits         FC05  70
S2L2=STOL**2#                          Get (st/l) squared               FC05  71
#                                                                       FC05  72
#  EXTRACT & SCALE F-RELATIVE                                           FC05  73
#  -------------------------                                            FC05  74
#                                                                       FC05  75
IF(IRF==0) FREL=0.#                    Default value for frel           FC05  76
ELSE FREL=QX(IP+IRF)#                  Frel is on bdisf                 FC05  77
J=IP+IRS#                              Point to scale group             FC05  78
IF(IRS==0) ISCG=MARK4+1#               Point to scale one               FC05  79
ELSE       ISCG=MARK4+NINT(QX(J))#     Point to scale group             FC05  80
FREL=FREL*QX(ISCG)#                    Scale measured s.f.              FC05  81
IF(IRJ>0) CODE=QX(IP+IRJ)#             Extract reflection code          FC05  82
IF(CODE>REJF) NEXT#                    Skip rejected reflections        FC05  83
ifvo:(CODE) NEXT#                      Skip if rcode is void            FC05  84
gethkl:(IP+IRH,H)#                     Extract signed h,k,l             FC05  85
AH=H(1); AK=H(2); AL=H(3)#             Make hkl local variables         FC05  86
IF(AH>MAXH) NEXT#                      Skip if /h/ too big              FC05  87
IF(AK>MAXK) NEXT#                      Skip if /k/ too big              FC05  88
IF(AL>MAXL) NEXT#                      Skip if /l/ too big              FC05  89
IF(TYPE==4)#                           Test if aniso tf possible        FC05  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FC05  91
HH=AH**2;  KK=AK**2;  LL=AL**2#        Calc index products              FC05  92
HK=AH*AK;  HL=AH*AL;  KL=AK*AL#        Calc index products              FC05  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FC05  94
ELSE IF(TYPE<3) TEMP=EXP(-BOVL*S2L2)#  Calc overall temp factor         FC05  95
DO I=1,NTYP#                           Loop over atom types             FC05  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FC05  97
ACAL(I)=0.;   BCAL(I)=0.#              Zeroize s.f. components          FC05  98
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FC05  99
#                                                                       FC05 100
#    LOOP OVER ATOMS LIST                                               FC05 101
#    --------------------                                               FC05 102
#                                                                       FC05 103
FOR(M=MARK6;M<MARK7;M=M+IATM)#         Loop over atoms list             FC05 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FC05 105
#                                                                       FC05 106
IF(scat:(M)>0.5)#                      Test if equivalent site          FC05 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FC05 108
L=NINT(scat:(M))#                      Extract sf sequence              FC05 109
IF(TYPE<3) FACT=pmul:(M)*TEMP#         Calc factor for overall b        FC05 110
ELSE FACT=pmul:(M)*EXP(-bis:(M)*S2L2)# Get s.f.product                  FC05 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FC05 112
IF((TYPE==4)&(bij:(M,2)>0.))#            Test for aniso tf         
FACT=pmul:(M)*EXP(-HH*bij:(M,1)-KK*bij:(M,2)$# Calc s.f. product    
-LL*bij:(M,3)-HK*bij:(M,4)-HL*bij:(M,5)-KL*bij:(M,6))# Calc s.f. produ
#                                                                       FC05 116
#   CALC A & B FOR EACH ATOM TYPE                                       FC05 117
#   -----------------------------                                       FC05 118
#                                                                       FC05 119
ANG=AH*xif:(M,1)+AK*xif:(M,2)+AL*xif:(M,3)# Calc phase component 
IF(ISIN==yes:)#                        Test for sin/cos table           FC05 121
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FC05 122
IF(ANG<0.)#                            Test if angle negative           FC05 123
I=INT((1.+AMOD(ANG,1.))*360.+.5)+MARK7## Point to sin/cos table         FC05 124
ELSE#                                  If angle is positive             FC05 125
I=INT(AMOD(ANG,1.)*360.+.5)+MARK7#     Point to sin/cos table           FC05 126
ACAL(L)=ACAL(L)+FACT*QX(I+91)#         Calc real s.f. component         FC05 127
IF(CENT==1)#                           Test if centrosymmetric          FC05 128
BCAL(L)=BCAL(L)+FACT*QX(I+1)#          Calc imag s.f. component         FC05 129
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FC05 130
ELSE#                                  Else use fortran lib sin/cos     FC05 131
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FC05 132
ACAL(L)=ACAL(L)+FACT*COS(ANG*PI2)#     Calc real s.f. component         FC05 133
IF(CENT==1)#                           Test if centrosymmetric          FC05 134
BCAL(L)=BCAL(L)+FACT*SIN(ANG*PI2)#     Calc imag s.f. component         FC05 135
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FC05 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FC05 137
#                                                                       FC05 138
#   CALC TOTAL COMPONENTS A & B                                         FC05 139
#   ---------------------------                                         FC05 140
#                                                                       FC05 141
ANOD=0.;  BNOD=0.;  ADIS=0.;  BDIS=0.# Reset a & b sums                 FC05 142
SCPA=0.#                               Reset ff for unknown atoms       FC05 143
DO L=1,NTYP#                           Loop over scat. factors          FC05 144
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FC05 145
IF(IRAD==1) J=OFF(L)#                  Point to neutron ff              FC05 146
ELSE IF(IREL(L)>0) J=IP+IREL(L)#       Get ff pointers to buffer        FC05 147
ELSE          J=NINT(STOL/DSTL)+OFF(L)# Point to ff curves              FC05 148
IF(ISIM==yes:) SCPA=SCPA+ATP(L)*QX(J)*QX(J)# Sum ff for unknown atoms   FC05 149
ANOD=ANOD+ACAL(L)*QX(J)#               Sum total real s.f.              FC05 150
IF(CENT==1)#                           Test if centrosymmetric          FC05 151
BNOD=BNOD+BCAL(L)*QX(J)#               Sum total imag s.f.              FC05 152
IF(DISP==yes:)#                        Is dispersion applied            FC05 153
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FC05 154
A=ACAL(L)*ADR(L)-BCAL(L)*ADI(L)#       Apply anom.disp. factors         FC05 155
B=BCAL(L)*ADR(L)+ACAL(L)*ADI(L)#       Apply anom.disp. factors         FC05 156
ADIS=ADIS+A#                           Sum real contributions           FC05 157
BDIS=BDIS+B#                           Sum imag contributions           FC05 158
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FC05 159
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FC05 160
#                                                                       FC05 161
IF(ICORE==1)#                          Only for total=core+valence
$(
ANOD=ANOD+QX(IP+IFA);BNOD=BNOD+QX(IP+IFB)# add contrib from valence map
$)
ATOT=ANOD+ADIS;  BTOT=BNOD+BDIS#       Include dispersion terms         FC05 162
#                                                                       FC05 163
#   APPLY EXTINCTION IF REQUESTED                                       FC05 164
#   -----------------------------                                       FC05 165
#                                                                       FC05 166
IF(IEXT==yes:)#                        Test for extinction              FC05 167
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FC05 168
ANOX=ATOT;  BNOX=BTOT#                 Set extinction free a,b          FC05 169
J=IP+IRX#                              Point to extinction term         FC05 170
EXTFAC=SQRT(QX(J))#                    Get extinction factor            FC05 171
ATOT=ATOT*EXTFAC;  BTOT=BTOT*EXTFAC#   Apply extinct. to a,b            FC05 172
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FC05 173
#                                                                       FC05 174
#   CALCULATE TOTAL STRUCTURE FACTOR                                    FC05 175
#   --------------------------------                                    FC05 176
#                                                                       FC05 177
IF((ABS(ANOD)<.01)&(ABS(BNOD)<.01))ANOD=.01# Test indeterminency        FC05 178
PHI=AMOD(ATAN2(BNOD,ANOD)/PI2+1.000001,1.)# Get phase in cycles         FC05 179
FCAL=SQRT(ATOT*ATOT+BTOT*BTOT)#        Calculate s.f.                   FC05 180
IF(ICORE!=0) FREL=FCAL#
FRND=FREL/EXTFAC;  FCND=FCAL/EXTFAC#   Correct for extinc.              FC05 181
IF(DISP==yes:)#                        Test for dispersion              FC05 182
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FC05 183
FCND=SQRT(ANOD*ANOD+BNOD*BNOD)#        Calculate fc (without disp)      FC05 184
A=(ADIS*BNOD-BDIS*ANOD)/FCND#          Calc disp correction a           FC05 185
B=(ADIS*ANOD+BDIS*BNOD)/FCND#          Calc disp correction b           FC05 186
A=AMAX1(0.,FRND*FRND-A*A)#             Get +ve diff f2-a2               FC05 187
FRND=AMAX1(0.,SQRT(A)-B)#              Calc corrected frel              FC05 188
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FC05 189
FDIF=FRND-FCND#                        Calculate s.f. difference        FC05 190
WSIM=0.0#                                                               FC05 191
IF(ISIM==yes:)#                        Test if apply sim weight         FC05 192
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FC05 193
IF(SCPA>0.) XAP=2.0*FCND*FREL/SCPA#    Calc factor for i1(x)/i0(x)      FC05 194
ELSE        XAP=100.#                  Force sim weight to be 1.0       FC05 195
WSIM=XAP*(XAP+.4807)/(XAP*(XAP+.8636)+1.3943)# Calc sim weight          FC05 196
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FC05 197
#                                                                       FC05 198
#    SETUP OUTPUT ARCHIVE LIST                                          FC05 199
#    -------------------------                                          FC05 200
#                                                                       FC05 201
ARCH(1)=FCND#                          Archive calculated s.f.          FC05 202
ARCH(2)=ANOD#                          Archive real fc (no disp)        FC05 203
ARCH(3)=BNOD#                          Archive imag fc (no disp)        FC05 204
ARCH(4)=ADIS#                          Archive real disp only           FC05 205
ARCH(5)=BDIS#                          Archive imag disp only           FC05 206
ARCH(6)=ANOX#                          Archive real fc (no ext.)        FC05 207
ARCH(7)=BNOX#                          Archive imag fc (no ext.)        FC05 208
ARCH(8)=PHI#                           Archive phase in cycles          FC05 209
ARCH(9)=FRND/QX(ISCG)#                 Archive corrected frel           FC05 210
ARCH(10)=WSIM#                         Archive sim weight               FC05 211
ARCH(11)=FCAL#                         Archive full fcalc               FC05 212
IF(ICORE!=0)#                          Hijacked procedure
$( 
ADIS=QX(IP+IFA);BDIS=QX(IP+IFB)#
FREL=FCAL
ARCH(9)=FCAL#                          This is really an Frel
IF(IRFO!=0) QX(JP+IRFO)=FCAL#          beyond doubt 
ARCH(11)=0.0#                          For emphasis, Fcal=0.0
$)
DO I=1,ITEM#                           Loop over archive list           FC05 213
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FC05 214
IF(IWNT(I)<0) NEXT#                    Skip delete items                FC05 215
QX(K)=ARCH(I)#                         Store add items                  FC05 216
K=K+1#                                 Incr op packet pointer           FC05 217
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FC05 218
#                                                                       FC05 219
#    ACCUMULATE STATISTICS                                              FC05 220
#    ---------------------                                              FC05 221
#                                                                       FC05 222
JCOD=INT(CODE+1.5)#                    Convert refln code               FC05 223
SUMN(1,JCOD)=SUMN(1,JCOD)+1.#          Sum number of reflns             FC05 224
SUMR(1,JCOD)=SUMR(1,JCOD)+FRND#        Sum measured s.f.                FC05 225
SUMC(1,JCOD)=SUMC(1,JCOD)+FCND#        Sum calculated s.f.              FC05 226
SUMD(1,JCOD)=SUMD(1,JCOD)+ABS(FDIF)#   Sum f difference                 FC05 227
SUMN(2,JCOD)=SUMN(2,JCOD)+1.#          Sum number of reflns             FC05 228
SUMR(2,JCOD)=SUMR(2,JCOD)+FREL#        Sum measured s.f.                FC05 229
SUMC(2,JCOD)=SUMC(2,JCOD)+FCAL#        Sum calculated s.f.              FC05 230
SUMD(2,JCOD)=SUMD(2,JCOD)+ABS(FREL-FCAL)# Sum f difference              FC05 231
#                                                                       FC05 232
#    LIST REFLECTIONS IF REQUESTED                                      FC05 233
#    -----------------------------                                      FC05 234
#                                                                       FC05 235
IF(ABS(FDIF)<DLIS) NEXT#               List if abs(fdiff) > dlist       FC05 236
BUFOT(1)=STOL#                         Store sin theta/lambda           FC05 237
BUFOT(2)=CODE#                         Store refln code                 FC05 238
BUFOT(3)=FLOAT(ISCG-MARK4)#            Float scale group                FC05 239
BUFOT(4)=FREL#                         Store measured s.f.              FC05 240
BUFOT(5)=FCAL#                         Store total fc                   FC05 241
BUFOT(6)=ADIS#                         Store real dispersion term       FC05 242
BUFOT(7)=BDIS#                         Store imag dispersion term       FC05 243
BUFOT(8)=EXTFAC#                       Store extin. factor              FC05 244
BUFOT(9)=FRND#                         Store disp-free frel             FC05 245
BUFOT(10)=FCND#                        Store disp-free fcal             FC05 246
BUFOT(11)=PHI*360.#                    Store disp-free phase            FC05 247
BUFOT(12)=FDIF#                        Store disp-free fdiff            FC05 248
ncodefld:(H,     1,CHROT,FMT,3)#       Format h,k,l                     FC05 249
ncodefld:(BUFOT,1,CHROT,FMT(4),12)#    Format s,jc,is,frel              FC05 250
writeline:(0,FC51,NFC51,1,1)#          Print all data                   FC05 251
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FC05 252
#                                                                       FC05 253
RETURN#                                                                 FC05 254
END#                                                                    FC05 255
systemheader:(FC06)#                   Print structure factor stats     FC06   1
# ####################################################################  FC06   2
#                                                                       FC06   3
#                                FC06                                   FC06   4
#                                                                       FC06   5
# ####################################################################  FC06   6
SUBROUTINE FC06#                                                        FC06   7
include:(AACOMN)#                                                       FC06   8
include:(FCCOMN)#                                                       FC06   9
#                                                                       FC06  10
INTEGER I,K#                           Working indices                  FC06  11
chardata:(FC61,[ REFLECTION STATISTICS   (DISPERSION/EXTINCTION $#      FC06  12
UNCORRECTED)])#                                                         FC06  13
chardata:(FC62,CODE0CODE1CODE2CODE3CODE4TOTAL)#                         FC06  14
chardata:(FC63,           NREF   AV FREL   AV FCAL   AV DIFF   $#       FC06  15
RFACTOR   SCALE)#                                                       FC06  16
chardata:(FC64,UN  )#                                                   FC06  17
realdata:(FMT,[150513.,250622.,350622.,450622.,550632.,630842.])#       FC06  18
datastuff:#                                                             FC06  19
#                                                                       FC06  20
#   CALCULATE STATISTICS                                                FC06  21
#   -------------------                                                 FC06  22
#                                                                       FC06  23
DO K=2,1,-1#                           Loop over disp., extn.           FC06  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FC06  25
DO I=1,5#                              Loop over refln codes            FC06  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FC06  27
SUMN(K,6)=SUMN(K,6)+SUMN(K,I)#         Sum total refln count            FC06  28
SUMR(K,6)=SUMR(K,6)+SUMR(K,I)#         Sum total frel                   FC06  29
SUMC(K,6)=SUMC(K,6)+SUMC(K,I)#         Sum total fcal                   FC06  30
SUMD(K,6)=SUMD(K,6)+SUMD(K,I)#         Sum total /diff/                 FC06  31
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FC06  32
#                                                                       FC06  33
writeline:(1,FC61,NFC61,3,3); LINRM=3# Print stats header               FC06  34
DO I=1,6#                              Loop over refln codes            FC06  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FC06  36
ifeq:(SUMN(K,I),0.) NEXT#              Skip null sums                   FC06  37
movechar:(FC62,I*5-4,CHROT,3,5,0)#     Put in side header               FC06  38
BUFOT(1)=SUMN(K,I)#                    Store number of reflns           FC06  39
BUFOT(2)=SUMR(K,I)/SUMN(K,I)#          Store mean frel                  FC06  40
BUFOT(3)=SUMC(K,I)/SUMN(K,I)#          Store mean fcal                  FC06  41
BUFOT(4)=SUMD(K,I)/SUMN(K,I)#          Store mean diff                  FC06  42
BUFOT(5)=SUMD(K,I)/AMAX1(1.,SUMR(K,I))# Store r-factor                  FC06  43
BUFOT(6)=SUMC(K,I)/AMAX1(1.,SUMR(K,I))# Store scale                     FC06  44
ncodefld:(BUFOT,1,CHROT,FMT,6)#        Format statistics                FC06  45
writeline:(0,FC63,NFC63,1,3)#          Print statistics                 FC06  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FC06  47
movechar:(FC64,K*2-1,FC61,49,2,0)#     Reset heading                    FC06  48
IF(DISP==no: & IEXT==no:)  BREAK#      Exit if no disp., extinc.        FC06  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FC06  50
## test re-entrant stream                                               FC06  51
##addcomm:('pig')                                                       FC06  52
##addcomm:('end')                                                       FC06  53
##inscomm:('pig')                                                       FC06  54
##inscomm:('end')                                                       FC06  55
##endcomm:#                                                             FC06  56
##rewindbdf:(1)#                                                        FC06  57
##bdfclose:(1)# close input bdf                                         FC06  58
##rewindbdf:(2)#                                                        FC06  59
##bdfclose:(2)# close input bdf                                         FC06  60
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Finish off file               FC06  61
#                                                                       FC06  62
RETURN#                                                                 FC06  63
END#                                                                    FC06  64
pmacro:([no:])#                        Purge xtal system macros         FC06  65
