systemheader:(FG    )#                                                  FG     1
##   version: Nov93                                                             
####################################################################### FG     2
#                                                                     # FG     3
#                           *** FOGNU ***                             # FG     4
#                                                                     # FG     5
#   THE PROGRAM, FOGNU, CALCULATES AN ARBITRARILY LARGE FOURIER       # FG     6
#   MAP OR ANY PORTION OF A FOURIER MAP FROM AN INPUT FOURIER MAP     # FG     7
#   CONTAINING AT LEAST THE UNIT CELL.                                # FG     8
#                                                                     # FG     9
####################################################################### FG    10
include:(XMACRO)#                                                       FG    11
#                                                                       FG    12
extrude:(FGCOMN)#                                                       FG    13
INTEGER CTYPE#                         Type of fourier calculated       FG    14
INTEGER DELTAY#                        Storage locations between ea     FG    15
INTEGER DELTAZ#                        Y and each z in qx array         FG    16
INTEGER FORMAT#                        Print norm=1,pack=2,shad=3       FG    17
INTEGER IGNORE#                        Ignore origin restriction ?      Nov93001
INTEGER INCS(3)#                       Grid increments in input order   FG    18
INTEGER INCX(3)#                       In xyz order                     FG    19
INTEGER IORGS(3)#                      Grid origin in input order       FG    20
INTEGER IORGX(3)#                      In xyz order                     FG    21
INTEGER IPT#                           Input packet pointer             FG    22
INTEGER ISUM1#                         Indicates first sum axis         FG    23
INTEGER ISUM2#                         Second sum axis                  FG    24
INTEGER ISUM3#                         Third sum axis                   FG    25
INTEGER IX(3)#                         Current point in xyz order       FG    26
INTEGER JPT#                           Output packet pointer            FG    27
INTEGER JSUM1#                         Summation order permutation      FG    28
INTEGER JSUM2#                         Indices.                         FG    29
INTEGER JSUM3#                                                          FG    30
INTEGER MAPEND(3)#                     Input map end in xyz order       FG    31
INTEGER MAPORG(3)#                     Input map origin in xyz order    FG    32
INTEGER MARKS#                         Pointer to symops                FG    33
INTEGER MARK2#                         Pointer to input map in qx       FG    34
INTEGER MARK3#                         Pointer to output map sectio     FG    35
INTEGER MARK4#                         Pointer to third sum grid ax     FG    36
INTEGER NCOLM#                         Number of printer columns pe     FG    37
INTEGER NEWX(3)#                       Symopped value of current gr     FG    38
INTEGER NGS(3)#                        Grids in input order             FG    39
INTEGER NGX(3)#                        In xyz order                     FG    40
INTEGER NPTS(3)#                       Total grid points-input order    FG    41
INTEGER NPTX(3)#                       In xyz order                     FG    42
INTEGER NSTEP2#                        Increment pointers in qx array   FG    43
INTEGER NSTEP3#                                                         FG    44
INTEGER NSTEP4#                                                         FG    45
INTEGER NSTOP2#                                                         FG    46
INTEGER NSTOP3#                                                         FG    47
INTEGER NSTOP4#                                                         FG    48
INTEGER OUTINC(3)#                     Output map incr. (xyz order)     FG    49
INTEGER OUTINS(3)#                     Output map incr (input order)    FG    50
INTEGER OUTNGS(3)#                     Output map grids (input order)   FG    51
INTEGER OUTNPT(3)#                     Output map points (input order   FG    52
INTEGER OUTNPX(3)#                     Output map points (xyz order)    FG    53
INTEGER OUTORG(3)#                     Output map origins (xyz order)   FG    54
INTEGER OUTORS(3)#                     Output map origins (input orde   FG    55
INTEGER PATT#                          = 0, if map computed with f'     FG    56
INTEGER PRINT#                         1/0, print/do not print output   FG    57
INTEGER PSIZE#                         Logical record packet size       FG    58
INTEGER SFILE#                         0/1, no output bdf/output bdf    FG    59
INTEGER SHEETS#                        Number of sheets/section         FG    60
INTEGER SPACE#                         Blank lines between map lines    FG    61
INTEGER STEPS#                         Number of words/symop            FG    62
REAL F000#                             Fzero                            FG    63
REAL FORSCL#                           Scale when shaded format use     FG    64
REAL LOLIM#                            Lower limit in map values        FG    65
REAL PASSES#                           Number of fourier passes         FG    66
REAL SKAL#                             Scale to output map              FG    67
REAL UPLIM#                            Upper limit to map values        FG    68
string:(MAPCHR,1)#                     Character used in printing       FG    69
#                                                                       FG    70
COMMON/COMIFG/ CTYPE,DELTAY,DELTAZ,FORMAT,IGNORE,INCS,INCX,$#           Nov93002
IORGS,IORGX,IPT,ISUM1,ISUM2,ISUM3,IX,JPT,$#                             FG    72
JSUM1,JSUM2,JSUM3,MAPEND,MAPORG,MARKS,MARK2,$#                          FG    73
MARK3,MARK4,NCOLM,NEWX,NGS,NGX,$#                                       FG    74
NPTS,NPTX,NSTEP2,NSTEP3,NSTEP4,NSTOP2,$#                                FG    75
NSTOP3,NSTOP4,$#                                                        FG    76
OUTINC,OUTINS,OUTNGS,OUTNPT,OUTNPX,$#                                   FG    77
OUTORG,OUTORS,PATT,PRINT,$#                                             FG    78
PSIZE,SFILE,SHEETS,SPACE,STEPS,#                                        FG    79
#                                                                       FG    80
COMMON/COMFFG/ F000,FORSCL,LOLIM,PASSES,SKAL,UPLIM#                     FG    81
#                                                                       FG    82
COMMON/COMCFG/ MAPCHR#                                                  FG    83
#                                                                       FG    84
endext:#                                                                FG    85
#                                                                       FG    86
systemheader:(FG00)#                   Arbitrary map from input map     FG00   1
# ################################################################## #  FG00   2
#                                                                    #  FG00   3
#                               FG00                                 #  FG00   4
#                                                                    #  FG00   5
# ################################################################## #  FG00   6
SUBROUTINE FG00#                       Feb 1982  r.a. alden             FG00   7
include:(AACOMN)#                      Feb 1988  n. spadaccini          FG00   8
include:(FGCOMN)#                      Aug 1988  t. norden              FG00   9
#                                                                       FG00  10
FILEXT(IOUNIT(3))='MAP'#               Input small map                  FG00  11
FILEXT(IOUNIT(4))='MAG'#               Output expanded map              FG00  12
#                                                                       FG00  13
CALL FG10#                             Process through to lrsymm:       FG00  14
CALL FG20#                             Read map and store in xyz orde   FG00  15
CALL FG30#                             Process layout and print lines   FG00  16
CALL FG40#                             Generate new map                 FG00  17
#                                                                       FG00  18
RETURN#                                                                 FG00  19
END#                                                                    FG00  20
systemheader:(FG10)#                   Read input, generate symops      FG10   1
# ################################################################## #  FG10   2
#                                                                    #  FG10   3
#                               FG10                                 #  FG10   4
#                                                                    #  FG10   5
# ################################################################## #  FG10   6
SUBROUTINE FG10#                       Feb 1982  r.a. alden             FG10   7
include:(AACOMN)#                      Feb 1988  n. spadaccini          FG10   8
include:(FGCOMN)#                      Aug 1988  t. norden              FG10   9
#                                                                       FG10  10
INTEGER BEGIN#                         Current field's starting col     FG10  11
INTEGER ENDD#                          Current field's final column     FG10  12
INTEGER FIELD#                         Current field number             FG10  13
INTEGER MATCH#                         Indicates which character        FG10  14
#                                                                       FG10  15
chardata:(FG011,SF NS PR NP IG )#                                       Nov93003
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])# Translation vectors for      FG10  17
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])# Generation of symops         FG10  18
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              FG10  19
realdata:(TR21,[.3333333,.5])#                                          FG10  20
realdata:(TR22,[.6666667,0.])#                                          FG10  21
realdata:(TR23,[.6666667,.5])#                                          FG10  22
datastuff:#                                                             FG10  23
#                                                                       FG10  24
#           SET DEFAULTS                                                FG10  25
#           ------------                                                FG10  26
#                                                                       FG10  27
SFILE=yes:#                            Write a new bdf                  FG10  28
PRINT=no:#                             Assume no print out              FG10  29
IGNORE=no:#                            Input maps must start at 0,0,0   Nov93004
SKAL=1.#                               No map scaling                   FG10  30
STEPS=12#                              Twelve words per symop           FG10  31
#                                                                       FG10  32
FOR(FIELD=1;FIELD>0;FIELD=FIELD+1)#    Loop over image fields           FG10  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FG10  34
ifvo:(BUFIN(FIELD))  BREAK#            Stop at first blank field        FG10  35
stringlim:(FIELD,BEGIN,ENDD)#          Find field limits                FG10  36
compchar:(CHRIN,BEGIN,FG011,1,2,3,NFG011,MATCH)#                        FG10  37
IF(MATCH==0) iquit:(FG1005)#           Unrecognised input               FG10  38
IF     (MATCH==1)  SFILE=yes:#         Write new bdf                    FG10  39
ELSE IF(MATCH==2)  SFILE=no:#          Don't write new bdf              FG10  40
ELSE IF(MATCH==3)  PRINT=yes:#         Print output                     FG10  41
ELSE IF(MATCH==4)  PRINT=no:#          No printout                      FG10  42
ELSE IF(MATCH==5)  IGNORE=yes:#        Origin of input be anywhere      Nov93005
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FG10  43
#                                                                       FG10  44
#      REQUEST MEMORY FOR I/O BUFFERS                                   FG10  45
#      ------------------------------                                   FG10  46
#                                                                       FG10  47
IOMARK(3)=QXSTR#                       Set up input bdf buffer          FG10  48
incrqx:(MARK2,IOMARK(3)+bdfbuf:,FG1010)# Insufficient memory..bu        FG10  49
IF(SFILE==yes:)#                       If there is an output bdf,       FG10  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FG10  51
IOMARK(4)=MARK2#                       Set up buffer for file c.        FG10  52
incrqx:(MARK2,IOMARK(4)+bdfbuf:,FG1015)# Insufficient memory..bu        FG10  53
copyfile:(3,4,1,decr:(21))#            Copy upto lrsymm:                FG10  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FG10  55
#                                                                       FG10  56
RETURN#                                                                 FG10  57
END#                                                                    FG10  58
systemheader:(FG20)#                   Determine map size and           FG20   1
# ################################################################## #  FG20   2
#                                                                    #  FG20   3
#                               FG20                                 #  FG20   4
#                                                                    #  FG20   5
# ################################################################## #  FG20   6
SUBROUTINE FG20#                       Copy into memory                 FG20   7
include:(AACOMN)#                      Feb 1982  r.a. alden             FG20   8
include:(FGCOMN)#                      Feb 1988  n. spadaccini          FG20   9
#                                      Aug 1988 t. norden               FG20  10
INTEGER I#                             Loop index                       FG20  11
REAL TOTPTS#                           Total number of map points       FG20  12
#                                                                       FG20  13
readwpkt:(3,21,PSIZE,IPT,0)#           Reads logical record 21          FG20  14
DO I=1,3#                              Items in input order             FG20  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FG20  16
IORGS(I)=NINT(QX(IPT+1))#              Origins                          FG20  17
INCS(I)=NINT(QX(IPT+4))#               Increments                       FG20  18
IF(INCS(I)!=1)  iquit:(FG2005)#        Illegal increment size           FG20  19
NGS(I)=NINT(QX(IPT+7))#                Grids                            FG20  20
NPTS(I)=NINT(QX(IPT+10))#              Points along axes                FG20  21
IPT=IPT+1#                             Increment pointer                FG20  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FG20  23
ISUM1=NINT(QX(IPT+10))#                Summation order indices          FG20  24
ISUM2=NINT(QX(IPT+11))#                                                 FG20  25
ISUM3=NINT(QX(IPT+12))#                                                 FG20  26
JSUM1=NINT(QX(IPT+13))#                Summation order permutation      FG20  27
JSUM2=NINT(QX(IPT+14))#                Indices.                         FG20  28
JSUM3=NINT(QX(IPT+15))#                                                 FG20  29
CTYPE=NINT(QX(IPT+18))#                Calculation type                 FG20  30
F000=QX(IPT+19)#                       F000                             FG20  31
PASSES=QX(IPT+20)#                     Number of passes required        FG20  32
NGX(1)=NGS(ISUM1)#                     Grids in x direction         2   FG20  33
NGX(2)=NGS(ISUM2)#                     Grids in y direction             FG20  34
NGX(3)=NGS(ISUM3)#                     Grids in z direction             FG20  35
IORGX(1)=IORGS(ISUM1)#                 Origin in x direction            FG20  36
IORGX(2)=IORGS(ISUM2)#                 Origin in y direction            FG20  37
IORGX(3)=IORGS(ISUM3)#                 Origin in z direction            FG20  38
DO I=1,3#                              Screen for nonzero origins       FG20  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FG20  40
IF(IORGX(I)!=0&IGNORE==no:) iquit:(FG2001)#                             Nov93006
# IORGX MUST BE ZERO IN THE INPUT MAP                                   FG20  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FG20  43
NPTX(1)=NPTS(ISUM1)#                   Points in x direction            FG20  44
NPTX(2)=NPTS(ISUM2)#                   Points in y direction            FG20  45
NPTX(3)=NPTS(ISUM3)#                   Points in z direction            FG20  46
DO I=1,3#                              Screen for ngx(i) != nptx(i)     FG20  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FG20  48
IF(NGX(I) != NPTX(I)) iquit:(FG2002)#                                   FG20  49
# NUMBER OF GRID PTS MUST BE EQUAL TO NUMBER OF POINTS                  FG20  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FG20  51
INCX(1)=INCS(ISUM1)#                   Increment in x direction         FG20  52
INCX(2)=INCS(ISUM2)#                   Increment in y direction         FG20  53
INCX(3)=INCS(ISUM3)#                   Increment in z direction         FG20  54
DO I=1,3; IF(INCX(I)!=1) iquit:(FG2003)#                                FG20  55
TOTPTS=FLOAT(NPTS(2)*NPTS(3))#         Pts in one layer of input map    FG20  56
NSTEP2=NPTS(ISUM1)#                    Number of pts in x direction     FG20  57
NSTOP2=MARK2+NINT(TOTPTS)#             End of map                       FG20  58
incrqx:(I,NSTOP2+1,FG2010)#            Request memory complete map      FG20  59
#                                                                       FG20  60
RETURN#                                                                 FG20  61
END#                                                                    FG20  62
systemheader:(FG30)#                   Determine map layout required    FG30   1
# ################################################################## #  FG30   2
#                                                                    #  FG30   3
#                               FG30                                 #  FG30   4
#                                                                    #  FG30   5
# ################################################################## #  FG30   6
SUBROUTINE FG30#                       Feb 1982  r.a. alden             FG30   7
include:(AACOMN)#                      Feb 1988  n. spadaccini          FG30   8
include:(FGCOMN)#                      Aug 1988 t. norden               FG30   9
#                                                                       FG30  10
INTEGER BEGIN#                         Start of character field         FG30  11
INTEGER DIR(3)#                        User supplied directions         FG30  12
INTEGER ENDD#                          End of character field           FG30  13
INTEGER ERFLAG(2)#                     Flag error in direction & incr   FG30  14
INTEGER ISPACE#                        Number of print lines per        FG30  15
INTEGER I,JPTR#                                                         FG30  16
INTEGER J#                             Loop index                       FG30  17
INTEGER K#                             Scratch location                 FG30  18
INTEGER MATCH#                         Indicates which character        FG30  19
INTEGER REV(3)#                        Same as the jsums/isums          FG30  20
#                                                                       FG30  21
chardata:(FG031, LAYOUT PRINT  END   )#                                 FG30  22
chardata:(FG032,LA DO AC )#                                             FG30  23
chardata:(FG033,.NO PA SH )#                                            FG30  24
chardata:(FG034, FOGNU CONTROL PARAMETERS)#                             FG30  25
chardata:(FG035, [>>> LAYOUT OF INPUT MAP <<<])#                        FG30  26
chardata:(FG036, [<<< LAYOUT OF OUTPUT MAP >>>])#                       FG30  27
chardata:(FG037, ORIENTATION OF    AXIS           WITH GRID    )#       FG30  28
chardata:(FG038, MAP BOUNDARY IN    GRID        TO       INCR.=    )#   FG30  29
chardata:(FG039,XYZLAYER DOWN  ACROSS-)#                                FG30  30
chardata:(FG03A, PRINTER DENSITY FORMAT                       )#        FG30  31
chardata:(FG03B, PRINTER DENSITY LIMITS                   )#            FG30  32
chardata:(FG03C, PRINTER DENSITY SCALE                    )#            FG30  33
chardata:(FG03D, PRINTER COL/PT LINE/PT                   )#            FG30  34
chardata:(FG03E,NORMALPACKEDSHADED INCR.)#                              FG30  35
#                                                                       FG30  36
realdata:(FMT1,[300313.,380313.,510313.])#                              FG30  37
realdata:(FMT2,[280213.,340213.])#                                      FG30  38
datastuff:#                                                             FG30  39
#                                                                       FG30  40
#   TELL USER ABOUT THE INPUT MAP                                       FG30  41
#   -----------------------------                                       FG30  42
#                                                                       FG30  43
movechar:(FG039,22,CHROT,2,NFG034-1,2)# Underline header                FG30  44
writeline:(2,FG034,NFG034,2,3)#        Output header                    FG30  45
movechar:(FG039,15,CHROT,2,NFG035-1,2)# Blank out chrot                 FG30  46
writeline:(1,FG035,NFG035,2,3)#        Input map layout                 FG30  47
REV(1)=ISUM1 ; REV(2)=ISUM2 ; REV(3)=ISUM3# Store directions in array   FG30  48
DO I=1,3#                                                               FG30  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FG30  50
movechar:(FG039,I,FG037,18,1,0)#       Encode x,y,z                     FG30  51
movechar:(FG039,(REV(I)-1)*6+4,FG037,27,6,0)# Encode direction          FG30  52
ncodefld:(FLOAT(NGX(I)),1,FG037,470313.,1)# Encode grid number          FG30  53
writeline:(0,FG037,NFG037,3,3)#        Print input orientation          FG30  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FG30  55
DO I=1,3#                                                               FG30  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FG30  57
movechar:(FG039,I,FG038,19,1,0)#       Encode x,y,z                     FG30  58
BUFOT(1)=FLOAT(IORGX(I))#              Origins                          FG30  59
BUFOT(2)=FLOAT(IORGX(I)+NPTX(I)-1)#    End points                       FG30  60
BUFOT(3)=FLOAT(INCX(I))#               Increments                       FG30  61
ncodefld:(BUFOT,1,FG038,FMT1,3)#       Encode                           FG30  62
writeline:(0,FG038,NFG038,3,3)#        Output                           FG30  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FG30  64
DO J=1,3#                              Initialize output layout....     FG30  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FG30  66
OUTINC(J)=1; OUTORG(J)=0; OUTNPX(J)=0# Increments, origin & points      FG30  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FG30  68
PRINT=no:#                             Print                            FG30  69
ISPACE=2#                              Double spacing                   FG30  70
NCOLM=4#                               4 columns per point              FG30  71
UPLIM=0.#                              Default accept all               FG30  72
LOLIM=0.#                                                               FG30  73
FORMAT=1#                              Normal                           FG30  74
FORSCL=10.#                            Shade format scale               FG30  75
movechar:(FG033,1,MAPCHR,1,1,0)#       Default map char. is (.)         FG30  76
#                                                                       FG30  77
# READ FROM INPUT LINES                                                 FG30  78
#                                                                       FG30  79
REPEAT#                                Loop over input lines            FG30  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FG30  81
readline:(FG031,NFG031)#                                                FG30  82
IF(LINID==1)#                          Layout line                      FG30  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FG30  84
DO I=1,3; DIR(I)=0#                    Initialize directions            FG30  85
DO I=1,2; ERFLAG(I)=no:#               Initialize error status          FG30  86
DO J=1,3#                              Loop over a,b,c directions       FG30  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FG30  88
IF(BUFIN(J)<voidflg:)#                 Test for direction string        FG30  89
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FG30  90
stringlim:(J,BEGIN,ENDD)#              Get string limits                FG30  91
compchar:(CHRIN,BEGIN,FG032,1,2,3,NFG032,MATCH)#                        FG30  92
DIR(J)=MATCH#                                                           FG30  93
IF(REV(J) != DIR(J)) ERFLAG(1)=yes:#                                    FG30  94
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FG30  95
IF(BUFIN(J+3)>(-.1)) OUTNPX(J)=NINT(BUFIN(J+3))# Number of points       FG30  96
ifnv:(BUFIN(J+6)) OUTORG(J)=NINT(BUFIN(J+6))# Origin                    FG30  97
IF(BUFIN(J+9)>(-.1)) OUTINC(J)=NINT(BUFIN(J+9))# Increment              FG30  98
IF (INCX(J) != 1) ERFLAG(2)=yes:#                                       FG30  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FG30 100
IF(ERFLAG(1) == yes:) iquit:(FG3001)#  F                                FG30 101
IF(ERFLAG(2) == yes:) iquit:(FG3002)#  F                                FG30 102
IF(OUTNPX(3) > bdfbuf:) iquit:(FG3003)# F                               FG30 103
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FG30 104
ELSE IF(LINID==2)#                     Print line                       FG30 105
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FG30 106
PRINT=yes:#                            Printed output required          FG30 107
IF(BUFIN(1)<voidflg:)#                 Field 1 specifies printing       FG30 108
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FG30 109
stringlim:(1,BEGIN,ENDD)#              Get the string limits            FG30 110
compchar:(CHRIN,BEGIN,FG033,2,2,3,NFG033,MATCH)# Search strings         FG30 111
IF(MATCH==0)  iquit:(FG3010)#          Illegal print request            FG30 112
FORMAT=MATCH#                          Normal=1,packed=2,shaded=3       FG30 113
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FG30 114
IF(BUFIN(2)>0.) SKAL=BUFIN(2)#         Printer scale                    FG30 115
IF(BUFIN(3)>voidflg:) UPLIM=BUFIN(3)#  Upper limit to printing          FG30 116
IF(BUFIN(4)>voidflg:) LOLIM=BUFIN(4)#  Lower limit to printing          FG30 117
IF(BUFIN(5)>small:) FORSCL=BUFIN(5)#   Format shade scale               FG30 118
IF((BUFIN(7)>0.)&(BUFIN(7)<=5.)) NCOLM=NINT(BUFIN(7))# Col/pt           FG30 119
IF((BUFIN(8)>0.)&(BUFIN(8)<=3.)) ISPACE=NINT(BUFIN(8))# Spaces/line     FG30 120
IF(BUFIN(11)<voidflg:)#                Test for map character           FG30 121
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FG30 122
stringlim:(11,BEGIN,ENDD)#             Find character postion           FG30 123
movechar:(CHRIN,BEGIN,MAPCHR,1,1,0)#   Save it                          FG30 124
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FG30 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FG30 126
ELSE  BREAK#                           End line                         FG30 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FG30 128
#                                                                       FG30 129
IF(PRINT==no:&SFILE==no:) iquit:(FG3015)# No output has been reques     FG30 130
SPACE=ISPACE-1#                        Number of blanks between lines   FG30 131
IF(ISUM1+ISUM2+ISUM3!=6) iquit:(FG3005)# Nonsense summation order       FG30 132
IF(ISUM1*ISUM2*ISUM3!=6) iquit:(FG3005)# Nonsense summation order       FG30 133
#                                                                       FG30 134
IF(IGNORE==yes:)#                      If ignoring 0,0,0 origin requir  Nov93007
$(#                                                                     Nov93008
DO J=1,3 ; OUTORG(J)=OUTORG(J)+IORGX(J)# Shift origin of input map      Nov93009
$)#                                                                     Nov93010
REV(ISUM1)=1 ; REV(ISUM2)=2 ; REV(ISUM3)=3# Summation order             FG30 135
JSUM1=REV(1) ; JSUM2=REV(2) ; JSUM3=REV(3)# Permutation indices         FG30 136
DO J=1,3#                              Create output scanning order     FG30 137
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FG30 138
K=REV(J)#                              Scanning order                   FG30 139
OUTNPT(J)=OUTNPX(K)#                   Points                           FG30 140
OUTORS(J)=OUTORG(K)#                   Origins                          FG30 141
OUTINS(J)=OUTINC(K)#                   Increments                       FG30 142
OUTNGS(J)=NGX(K)#                      Grids                            FG30 143
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FG30 144
#                                                                       FG30 145
IF(SFILE==yes:)#                       Make new lr21 corresponding      FG30 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FG30 147
writepkt:(4,21,23,JPT)#                Write to filed                   FG30 148
DO J=1,3#                                                               FG30 149
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FG30 150
JPTR=JPT+J#                            Increment pointer                FG30 151
QX(JPTR)=FLOAT(OUTORS(J))#             Origins in scanning order        FG30 152
QX(JPTR+3)=FLOAT(OUTINS(J))#           Increments in scanning order     FG30 153
QX(JPTR+6)=FLOAT(OUTNGS(J))#           Grids in scanning order          FG30 154
QX(JPTR+9)=FLOAT(OUTNPT(J))#           Points in scanning order         FG30 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FG30 156
QX(JPT+13)=FLOAT(ISUM1)#               Summation order indices          FG30 157
QX(JPT+14)=FLOAT(ISUM2)#                                                FG30 158
QX(JPT+15)=FLOAT(ISUM3)#                                                FG30 159
QX(JPT+16)=FLOAT(JSUM1)#               Permutation indices              FG30 160
QX(JPT+17)=FLOAT(JSUM2)#                                                FG30 161
QX(JPT+18)=FLOAT(JSUM3)#                                                FG30 162
QX(JPT+19)=UPLIM#                      Upper limit for map output       FG30 163
QX(JPT+20)=LOLIM#                      Lower limit for map output       FG30 164
QX(JPT+21)=FLOAT(CTYPE)#               Type of map                      FG30 165
QX(JPT+22)=F000#                       F000                             FG30 166
QX(JPT+23)=PASSES#                     Number of passes required        FG30 167
QX(JPT+24)=SKAL#                       Scale for output map             FG30 168
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FG30 169
#                                                                       FG30 170
#         TELL THE USER EVERYTHING                                      FG30 171
#         ------------------------                                      FG30 172
#                                                                       FG30 173
movechar:(FG039,15,CHROT,2,NFG036-1,2)# Blank out chrot                 FG30 174
writeline:(1,FG036,NFG036,2,3)#        Output map layout                FG30 175
REV(1)=ISUM1 ; REV(2)=ISUM2 ; REV(3)=ISUM3# Store directions in array   FG30 176
DO I=1,3#                                                               FG30 177
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FG30 178
movechar:(FG039,I,FG037,18,1,0)#       Encode x,y,z                     FG30 179
movechar:(FG039,(REV(I)-1)*6+4,FG037,27,6,0)# Encode direction          FG30 180
ncodefld:(FLOAT(NGX(I)),1,FG037,470313.,1)# Encode grid number          FG30 181
writeline:(0,FG037,NFG037,3,3)#        Print output orientation         FG30 182
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FG30 183
DO I=1,3#                                                               FG30 184
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FG30 185
movechar:(FG039,I,FG038,19,1,0)#       Encode x,y,z                     FG30 186
BUFOT(1)=FLOAT(OUTORG(I))#             Origins                          FG30 187
BUFOT(2)=FLOAT(OUTORG(I)+OUTNPX(I)-1)# End points                       FG30 188
BUFOT(3)=FLOAT(OUTINC(I))#             Increments                       FG30 189
ncodefld:(BUFOT,1,FG038,FMT1,3)#       Encode                           FG30 190
writeline:(0,FG038,NFG038,3,3)#        Output                           FG30 191
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FG30 192
IF(PRINT==yes:)#                                                        FG30 193
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FG30 194
movechar:(FG03E,FORMAT*6-5,FG03A,28,6,0)# Print type                    FG30 195
IF(FORMAT==3)#                         If shaded                        FG30 196
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FG30 197
movechar:(FG03E,20,FG03A,36,5,0)#      Move 'incr.' across              FG30 198
ncodefld:(FORSCL,1,FG03A,440413.,1)#   Encode increment                 FG30 199
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FG30 200
writeline:(1,FG03A,NFG03A,3,3)#        Output print format              FG30 201
BUFOT(1)=FLOAT(NCOLM)#                 Col/pt                           FG30 202
BUFOT(2)=FLOAT(ISPACE)#                Line/pt                          FG30 203
ncodefld:(BUFOT,1,FG03D,FMT2,2)#       Encode col/pt line/pt            FG30 204
writeline:(0,FG03D,NFG03D,3,3)#        Write col/pt line/pt             FG30 205
ncodefld:(SKAL,1,FG03C,380832.,1)#     Encode print scale               FG30 206
writeline:(0,FG03C,NFG03C,3,3)#        Output printer scale             FG30 207
ncodefld:(UPLIM,1,FG03B,350702.,1)#    Encode density upper limit       FG30 208
ncodefld:(LOLIM,1,FG03B,430702.,1)#    Encode density lower limit       FG30 209
writeline:(0,FG03B,NFG03B,3,3)#        Output density limits            FG30 210
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FG30 211
RETURN#                                                                 FG30 212
END#                                                                    FG30 213
systemheader:(FG40)#                   Generate new map and output      FG40   1
# ################################################################## #  FG40   2
#                                                                    #  FG40   3
#                               FG40                                 #  FG40   4
#                                                                    #  FG40   5
# ################################################################## #  FG40   6
SUBROUTINE FG40#                       Feb 1982  r.a. alden             FG40   7
include:(AACOMN)#                      Feb 1988  n. spadaccini          FG40   8
include:(FGCOMN)#                      Aug 1988  t. norden              FG40   9
#                                                                       FG40  10
INTEGER ACROSS#                        Counter for points/line reques   FG40  11
INTEGER BIGSEC#                        Big multiple of no. of section   FG40  12
INTEGER BIGLN#                         Big multiple of no. of lines     FG40  13
INTEGER BIGPT#                         Big multiple of no. of points/   FG40  14
INTEGER DELTA(2)#                      Number of storage locations      FG40  15
INTEGER I#                             First scanning order index       FG40  16
INTEGER J#                             Second scanning order index      FG40  17
INTEGER K#                             Third scanning order index       FG40  18
INTEGER M#                             Subscript for output qx          FG40  19
INTEGER NPPL#                          Maximum number of pnts/line ou   FG40  20
INTEGER NSECTS#                        Number of sections to output     FG40  21
INTEGER WIDTH#                         Number of points per line        FG40  22
REAL AVEDEN#                           Average density on map           FG40  23
REAL MAXDEN#                           Maximum electron density on      FG40  24
REAL MINDEN#                           Minimum                          FG40  25
#                                                                       FG40  26
chardata:(FG041, LOWEST DENSITY VALUE  =              )#                FG40  27
chardata:(FG042, HIGHEST DENSITY VALUE =              )#                FG40  28
chardata:(FG043, AVERAGE DENSITY VALUE =              )#                FG40  29
realdata:(FMT1,[350922.])#                                              FG40  30
realdata:(FMT2,[430413.,470413.,510413.])# F                            FG40  31
realdata:(FMT043,[230942.,650942.])#                                    FG40  32
datastuff:#                                                             FG40  33
#                                                                       FG40  34
MAXDEN = -1.E10#                       Maximum density map value        FG40  35
MINDEN =  1.E10#                       Minimum density map value        FG40  36
AVEDEN = 0.0#                          Average density value            FG40  37
NP1 = NPTS(1)#                         Max points in layer              FG40  38
NP2 = NPTS(2)#                         Max points down                  FG40  39
NP3 = NPTS(3)#                         Max points across                FG40  40
BIGSEC = NP1*100#                                                       FG40  41
BIGLN = NP2*100#                                                        FG40  42
BIGPT = NP3*100#                                                        FG40  43
MARK3=NSTOP2+1#                        Pointer to start of output map   FG40  44
NSTEP3=OUTNPT(3)#                      Number of words for output map   FG40  45
NSTOP3=MARK3+OUTNPT(3)#                Pointer to end of output map     FG40  46
incrqx:(I,NSTOP3+1,FG4005)#            Request memory complete map      FG40  47
#                                                                       FG40  48
NPPL=(prtcmax:-7)/NCOLM#               Max cols/per page                FG40  49
SHEETS=(OUTNPT(3)-1)/NPPL+1#           Number sheets/section            FG40  50
IF(PRINT==yes:)  CALL FG41(0)#         Initialize printing routine      FG40  51
#                                                                       FG40  52
NSECTS = OUTNPT(1)#                    Number of sections requested     FG40  53
NPLS = OUTNPT(2)#                      Number of lines/section reques   FG40  54
WIDTH = OUTNPT(3)#                     Number of points/line requeste   FG40  55
#                                                                       FG40  56
IX(1) = MOD((OUTORS(1) + BIGSEC),NP1) + 1# Get the section number       Nov93011
# SKIP TO THE CORRECT SECTION                                           FG40  58
SKIP = (IX(1)-1)*NP2#                  Number of lines to skip          FG40  59
# # TO GET TO THE CORRECT SECTION                                       FG40  60
IF(SKIP > 0)#                                                           FG40  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FG40  62
FOR(I=1;I<=SKIP;I=I+1)#                                                 FG40  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FG40  64
readwpkt:(3,22,PSIZE,IPT,0)#           Skip leading layers              FG40  65
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FG40  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FG40  67
#  COPY EACH LAYER INTO QX ONE LAYER AT A TIME THEN PROCESS             FG40  68
#  EACH LAYER, ONE LAYER AT A TIME TO OUTPUT CORRECT POINTS & LINES     FG40  69
DO K=1,NSECTS#                         Loop over the sections           FG40  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FG40  71
DELTA(2)=1#                            Separation in x                  Nov93012
DELTA(1)=NP3#                          Separation in y                  Nov93013
LOC2 = MARK2 - DELTA(2) + 1#           Pointers to start of stored ma   FG40  74
LOC1 = LOC2#                                                            FG40  75
DO J=1,NP2#                            Loop over input lines            FG40  76
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FG40  77
readwpkt:(3,22,PSIZE,IPT,0)#           Read in a line                   FG40  78
IF(IPT <= 0) BREAK#                                                     FG40  79
DO I=1,NP3#                            Loop over input points           FG40  80
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FG40  81
LOC2=LOC2 + DELTA(2)#                  Increment storage ptr            FG40  82
IPTR = IPT + I#                                                         FG40  83
QX(LOC2)=QX(IPTR)#                                                      FG40  84
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FG40  85
LOC1=LOC1+DELTA(1)#                    Increment line ptr               FG40  86
LOC2=LOC1#                                                              FG40  87
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FG40  88
# FIND THE CORRECT LINE AND POINT IN THE QX ARRAY AND WRITE             FG40  89
# THEM TO OUTPUT                                                        FG40  90
IX(2)=MOD((OUTORS(2)+BIGLN),NP2)+1#    Get line number                  Nov93014
DO J=1,NPLS#                                                            FG40  92
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FG40  93
START= MARK2 + (IX(2) - 1)*NP3 + 1#    Location of first pt            JNov93015
JPT = MARK3#                           Beginning of output map          FG40  96
IF(SFILE == yes:)#                                                      FG40  97
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FG40  98
writepkt:(4,22,WIDTH,JPT)#                                              FG40  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FG40 100
M=JPT#                                                                  FG40 101
DO I=1,WIDTH#                                                           Nov93016
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FG40 104
M=M+1#                                                                  FG40 105
IPTR=MOD((OUTORS(3)+I+BIGPT-1),NP3)+START# Get point number             Nov93017
QX(M)=QX(IPTR)#                                                         Nov93018
MAXDEN=AMAX1(QX(M),MAXDEN)#                                             FG40 108
MINDEN=AMIN1(QX(M),MINDEN)#                                             FG40 109
AVEDEN=AVEDEN+QX(M)#                                                    FG40 110
ACROSS=ACROSS + 1#                                                      FG40 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FG40 112
IX(2)=MOD((IX(2) + BIGLN),NP2) + 1#    Increment line number            FG40 113
IF(PRINT == yes:) CALL FG41(1)#        Line complete, print             FG40 114
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FG40 115
IX(1)=IX(1) + OUTINC(1)#               Get next layer number            FG40 116
IF(IX(1) > NP1)#                       Reached end of file              FG40 117
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FG40 118
rewindbdf:(3)#                         Rewind the file                  FG40 119
IX(1)=1#                               Set it back to position 1        FG40 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FG40 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FG40 122
#                                                                       FG40 123
#          ALL DONE.  TIDY THINGS UP                                    FG40 124
#          -------------------------                                    FG40 125
#                                                                       FG40 126
AVEDEN= AVEDEN/(FLOAT(NP1*NP2*NP3))#                                    FG40 127
BUFOT(1)=MINDEN#                                                        FG40 128
ncodefld:(BUFOT,1,FG041,FMT1,1)#                                        FG40 129
writeline:(1,FG041,NFG041,3,3)#                                         FG40 130
BUFOT(1)=MAXDEN#                                                        FG40 131
ncodefld:(BUFOT,1,FG042,FMT1,1)#                                        FG40 132
writeline:(0,FG042,NFG042,3,3)#                                         FG40 133
BUFOT(1)=AVEDEN#                                                        FG40 134
ncodefld:(BUFOT,1,FG043,FMT1,1)#                                        FG40 135
writeline:(1,FG043,NFG043,3,3)#                                         FG40 136
#                                                                       FG40 137
readwpkt:(3,endrecord:,PSIZE,IPT,0)#                                    FG40 138
IF(SFILE==yes:)  writepkt:(4,endrecord:,1,JPT)#                         FG40 139
RETURN#                                                                 FG40 140
END#                                                                    FG40 141
systemheader:(FG41)#                   Print output-across page tear    FG41   1
# ################################################################## #  FG41   2
#                                                                    #  FG41   3
#                               FG41                                 #  FG41   4
#                                                                    #  FG41   5
# ################################################################## #  FG41   6
SUBROUTINE FG41(FLAG)#                 Feb 1982  r.a. alden             FG41   7
include:(AACOMN)#                      Feb 1988  n. spadaccini          FG41   8
include:(FGCOMN)#                                                       FG41   9
#                                                                       FG41  10
INTEGER AXIS#                          Axis pointer                     FG41  11
INTEGER CHRPTR#                        Shaded character pointer         FG41  12
INTEGER COLM#                          Pointer to next heading          FG41  13
INTEGER COLPTR#                        Pointer to current column        FG41  14
INTEGER FLAG#                          =0 initialize routine,=1 print   FG41  15
INTEGER HED#                           Column heading                   FG41  16
INTEGER I#                             Loop index of layer              FG41  17
INTEGER IPTS3#                         Number of points across          FG41  18
INTEGER J#                             Loop index down a sheet          FG41  19
INTEGER K#                             Loop index across a sheet        FG41  20
INTEGER LINE#                          Current line number              FG41  21
INTEGER NCHARS#                        Number of characters needed      FG41  22
INTEGER NP3#                           Number of points across page     FG41  23
INTEGER NWORDS#                        Number of words to hold ncha     FG41  24
INTEGER ORD#                           Pointer to current ordinal       FG41  25
INTEGER PTR#                           Pointer to current start of      FG41  26
INTEGER QXPTR#                         Pointer to current point bei     FG41  27
INTEGER STARTL#                        Ptr. to start of stored line     FG41  28
INTEGER WIDTH#                         Number of points across the      FG41  29
REAL FMT131(1)#                        Formats                          FG41  30
REAL VALUE#                            Scaled output point value        FG41  31
#                                                                       FG41  32
string:(HEDING,70)#                    Lead line on each sheet          FG41  33
chardata:(COL,     )#                                                   FG41  34
chardata:(FG131, X =     IN      S       Y DOWN IN      S       $#      FG41  35
Z ACROSS IN      S)#                                                    FG41  36
chardata:(FG132,XYZUVW)#                                                FG41  37
chardata:(FG133,THSTNDRDTHTHTHTHTHTH)##                                 FG41  38
chardata:(FG134,@ZYX-.+ABC*)#                                           FG41  39
intdata:(IPTS2,[0])#                   Number of lines per section      FG41  40
intdata:(DELTA,[0])#                   Number of points across a        FG41  41
realdata:(STARTF,[0.0])#               Format for 1st point on          FG41  42
realdata:(INCF,[0.0])#                 Format incrementer across li     FG41  43
realdata:(FMT132,[150413.,380413.,630413.])#                            FG41  44
realdata:(FMT133,[80413.,40313.])#                                      FG41  45
datastuff:#                                                             FG41  46
#                                                                       FG41  47
IF(FLAG == 0)#                                                          FG41  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FG41  49
NCHARS=OUTNPT(3)*NCOLM#                Chars for full heading           FG41  50
MARK4=NSTOP3+1#                        Pointer to heading location      FG41  51
NSTEP4=1#                              Qx increment                     FG41  52
NWORDS=(NCHARS-1)/mxchwd:+1#           Number of words                  FG41  53
NCHARS=NWORDS*mxchwd:#                                                  FG41  54
NSTOP4=MARK4+NWORDS#                                                    FG41  55
incrqx:(I,NSTOP4+1,FG4105)#            Request memory complete map      FG41  56
movector:(BLANK,1,QX(MARK4+1),1,NCHARS,1)# Blank column heading         FG41  57
FMT131(1)=FLOAT(NCOLM)*10100.+13.#     Format                           FG41  58
HED=OUTORS(3)-OUTINS(3)#                                                FG41  59
COLM=1#                                                                 FG41  60
#                                                                       FG41  61
NP3 = OUTNPT(3)#                       Move to unsubscripted variab     FG41  62
DO I=1,NP3#                            Create the column heading        FG41  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FG41  64
HED=HED+OUTINS(3)#                                                      FG41  65
movechar:(BLANK,1,COL,1,NCOLM,1)#                                       FG41  66
BUFOT(1)=FLOAT(HED)#                                                    FG41  67
ncodefld:(BUFOT,1,COL,FMT131(1),1)#                                     FG41  68
movector:(COL,1,QX(MARK4+1),COLM,NCOLM,0)#                              FG41  69
COLM=COLM+NCOLM#                                                        FG41  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FG41  71
#                                                                       FG41  72
movechar:(FG131,1,HEDING,1,NFG131,0)#  Pick up the bare sheet headi     FG41  73
DO I=1,3#                              Stuff in the grids               FG41  74
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FG41  75
BUFOT(I)=FLOAT(OUTNGS(I))#                                              FG41  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FG41  77
ncodefld:(BUFOT,1,HEDING,FMT132(1),3)#                                  FG41  78
#                                                                       FG41  79
AXIS=JSUM1+PATT#                       Get proper axes names            FG41  80
movechar:(FG132,AXIS,HEDING,2,1,0)#    Patt=3, get uvw                  FG41  81
AXIS=JSUM2+PATT#                       Otherwise xyz                    FG41  82
movechar:(FG132,AXIS,HEDING,26,1,0)#                                    FG41  83
AXIS=JSUM3+PATT#                                                        FG41  84
movechar:(FG132,AXIS,HEDING,49,1,0)#                                    FG41  85
#                                                                       FG41  86
IF((OUTNGS(1)>10)&(OUTNGS(1)<14)) ORD=1# Ordinal suffixes               FG41  87
ELSE ORD=MOD(OUTNGS(1),10)*2+1#                                         FG41  88
movechar:(FG133,ORD,HEDING,16,2,0)#                                     FG41  89
IF((OUTNGS(2)>10)&(OUTNGS(2)<14)) ORD=1#                                FG41  90
ELSE ORD=MOD(OUTNGS(2),10)*2+1#                                         FG41  91
movechar:(FG133,ORD,HEDING,39,2,0)#                                     FG41  92
IF((OUTNGS(3)>10)&(OUTNGS(3)<14)) ORD=1#                                FG41  93
ELSE  ORD=MOD(OUTNGS(3),10)*2+1#                                        FG41  94
movechar:(FG133,ORD,HEDING,64,2,0)#                                     FG41  95
#                                                                       FG41  96
IPTS2=OUTNPT(2)#                       Number of lines per sheet        FG41  97
DELTA=OUTNPT(3)#                       Number of points per section     FG41  98
IF(FORMAT==2)  STARTF=70116.#          Packed output format             FG41  99
ELSE  STARTF=FLOAT(NCOLM)*100.+70013.# Normal output format             FG41 100
INCF=FLOAT(NCOLM)*10000.#              Format incrementer               FG41 101
movechar:(MAPCHR,1,FG134,6,1,0)#       Save map character               FG41 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FG41 103
ELSE#                                  Process a section                FG41 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FG41 105
IPTS3=OUTNPT(3)#                       Number of points per section     FG41 106
PTR=1#                                 Initialize column heading pt     FG41 107
STARTL=MARK3#                          Start of section in qx           FG41 108
#                                                                       FG41 109
movechar:(BLANK,1,HEDING,5,4,1)#       Blank out                        FG41 110
BUFOT(1)=FLOAT(IX(JSUM1))#                                              FG41 111
ncodefld:(BUFOT,1,HEDING,FMT133(1),1)# Encode section number            FG41 112
#                                                                       FG41 113
FOR(I=SHEETS;I>0;I=I-1)#               Loop over the sheets             FG41 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FG41 115
LINE=OUTORS(2)-OUTINS(2)#              Initialize line number           FG41 116
WIDTH=(IPTS3-1)/I+1#                   Number of points on this lin     FG41 117
LINCT=0#                               Force a new sheet                FG41 118
writeline:(1,HEDING,NFG131,3,3)#       Write first heading              FG41 119
NCHARS=WIDTH*NCOLM#                    Chars in current column          FG41 120
movertoc:(QX(MARK4+1),PTR,CHROT,8,NCHARS,0)#                            FG41 121
writeline:(1,0,0,1,3)#                 Column heading                   FG41 122
LINCT=10000#                           Force write over tear            FG41 123
#                                                                       FG41 124
DO J=1,IPTS2#                          Loop over lines per sheet        FG41 125
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FG41 126
LINE=LINE+OUTINS(2)#                   Current line number              FG41 127
BUFOT(1)=FLOAT(LINE)#                                                   FG41 128
ncodefld:(BUFOT,1,CHROT,FMT133(2),1)#                                   FG41 129
FMT131(1)=STARTF#                      Initialize format                FG41 130
COLPTR=7#                                                               FG41 131
QXPTR=STARTL#                          Point to 1st point on line       FG41 132
DO K=1,WIDTH#                          Loop over points                 FG41 133
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FG41 134
QXPTR=QXPTR+1#                         Increment storage pointer        FG41 135
FMT131(1)=FMT131(1)+INCF#              Increment format                 FG41 136
COLPTR=COLPTR+NCOLM#                   And column pointer.              FG41 137
#                                                                       FG41 138
VALUE=QX(QXPTR)*SKAL#                  Scale value                      FG41 139
IF(VALUE>UPLIM\VALUE<LOLIM)#           Encode if required               FG41 140
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FG41 141
IF(FORMAT<3)#                          Normal or packed output          FG41 142
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FG41 143
BUFOT(1)=VALUE#                                                         FG41 144
ncodefld:(BUFOT,1,CHROT,FMT131(1),1)#                                   FG41 145
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FG41 146
ELSE#                                  Shaded output wanted             FG41 147
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FG41 148
IF(VALUE>UPLIM) CHRPTR=MIN0(NINT((VALUE-UPLIM)/FORSCL)+7,11)#           FG41 149
ELSE CHRPTR=MAX0(NINT((VALUE-LOLIM)/FORSCL)+5,1)#                       FG41 150
movechar:(FG134,CHRPTR,CHROT,COLPTR,1,0)# Insert chars in buffer        FG41 151
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FG41 152
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FG41 153
ELSE  movechar:(FG134,6,CHROT,COLPTR,1,0)# Insert map character         FG41 154
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FG41 155
writeline:(SPACE,0,0,1,3)#             Write the line                   FG41 156
STARTL=STARTL+DELTA#                                                    FG41 157
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FG41 158
#                                                                       FG41 159
movertoc:(QX(MARK4+1),PTR,CHROT,8,NCHARS,0)#                            FG41 160
writeline:(1,0,0,1,3)#                                                  FG41 161
PTR=PTR+NCHARS#                                                         FG41 162
STARTL=MARK3+WIDTH#                                                     FG41 163
IPTS3=IPTS3-WIDTH#                                                      FG41 164
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FG41 165
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FG41 166
#                                                                       FG41 167
RETURN#                                                                 FG41 168
END#                                                                    FG41 169
pmacro:([no:])#                        Purge xtal system macros         FG41 170
