systemheader:(FM    )#                                                  FM     1
####################################################################### FM     2
#                                                                       FM     3
#                            ** FOMERG **                               FM     4
#                                                                       FM     5
#      THE PROGRAM FOMERG MERGES TWO FOURIER MAPS INTO ONE IN THE       FM     6
#      FOLLOWING WAY.  ALL THE POINTS IN EACH MAP ARE SCREENED BY       FM     7
#      A THRESHOLD CHECK. IF THE ELECTRON DENSITY IS BELOW THE MAP      FM     8
#      THRESHOLD SPECIFIED BY THE USER THE POINT IS SET TO THE VALUE    FM     9
#      SPECIFIED BY THE USER.  THE TWO MAPS ARE ADDED TOGETHER WITH     FM    10
#      EACH POINT WEIGHTED AS SPECIFIED BY THE USER. THE RESULTING MAP  FM    11
#      IS WRITTEN TO OUTPUT AS THE SUM OF THE TWO SCREENED, WEIGHTED    FM    12
#      INPUT MAPS.  THE PURPOSE OF THIS PROGRAM IS TO ALLOW THE         FM    13
#      ADDITION OF MISSING FRAGMENTS TO A PARTIAL STRUCTURE.  THE       FM    14
#      OUTPUT MAP MAY THEN BE USED TO CALCULATE STRUCTURE FACTORS BY    FM    15
#      MEANS OF THE PROGRAM RFOURR.  THIS LINK WAS WRITTEN AT THE       FM    16
#      SUGGESTION OF J. KARLE FOR USE WITH THE PROGRAM WEAKIN           FM    17
#                                                                       FM    18
#                                      J. m. stewart  october  1988     FM    19
#                                                                       FM    20
####################################################################### FM    21
#                                                                       FM    22
include:(XMACRO)#                                                       FM    23
#                                                                       FM    24
extrude:(FMCOMN)#                                                       FM    25
INTEGER IN(3)#      ## Grid point increment on input map                FM    26
INTEGER ISUM(3)#    ## Summation order correlation between              FM    27
INTEGER JSUM(3)#    ## Crystal axes and map axes                        FM    28
INTEGER MARKP#      ## Start of storage of el dens map                  FM    29
INTEGER NG(3)#      ## Number of grid points in map                     FM    30
INTEGER NP(3)#      ## Actual number of points in map                   FM    31
INTEGER NPIX#       ## Total pixels in input fourier map                FM    32
INTEGER OG(3)#      ## Grid values of the origin of the map             FM    33
INTEGER PRINTL#     ## Flag to control printing                         FM    34
REAL TH1,TH2#       ## Thresholds for input electron densities          FM    35
REAL WT1,WT2#       ## Weights for input electron densities             FM    36
#                                                                       FM    37
COMMON/COMIFM/$#                                                        FM    38
IN    ,ISUM  ,JSUM  ,MARKP ,$#                                          FM    39
NG    ,NP    ,NPIX  ,$#                                                 FM    40
OG    ,PRINTL,WRDBLK#                                                   FM    41
COMMON/COMFFM/$#                                                        FM    42
TH1,TH2,WT1,WT2#                                                        FM    43
endext:#                                                                FM    44
#                                                                       FM    45
systemheader:(FM00)#                                                    FM00   1
# ################################################################## #  FM00   2
#                                                                       FM00   3
#                               FM00                                 #  FM00   4
#                                                                    #  FM00   5
# ################################################################## #  FM00   6
SUBROUTINE FM00#                       J.m.stewart oct 1988             FM00   7
include:(AACOMN)#                                                       FM00   8
include:(FMCOMN)#                                                       FM00   9
#                                                                       FM00  10
CALL FM10#                             Bdf input and startup            FM00  11
CALL FM70#                             Merge maps                       FM00  12
#                                                                       FM00  13
RETURN#                                                                 FM00  14
END#                                                                    FM00  15
systemheader:(FM10)## bdf input and initialization                      FM10   1
# ################################################################## #  FM10   2
#                                                                    #  FM10   3
#                               FM10                                 #  FM10   4
#                                                                    #  FM10   5
# ################################################################## #  FM10   6
SUBROUTINE FM10#                       J.m.stewart oct 1988             FM10   7
include:(AACOMN)#                                                       FM10   8
include:(FMCOMN)#                                                       FM10   9
#                                                                       FM10  10
chardata:(FM10A, END    )#             Input lines allowed              FM10  11
chardata:(FM10B,PR  TH1 TH2 WT1 WT2 )# Control commands                 FM10  12
chardata:(FM10D,XYZ)#                                                   FM10  13
chardata:(FM10G, MAP TRANSFORMATION    X FIRST Y SEC Z THIRD )#         FM10  14
chardata:(FM10J,YESNO )#                                                FM10  15
chardata:(FM10K, PROCESS TWO ELECTRON DENSITY MAPS TO PRODUCE $#        FM10  16
AN ELECTRON DENSITY MAP WHICH IS THE WEIGHTED SUM OF BOTH.)#            FM10  17
chardata:(FM10L, DIRECTIVES GIVEN OR IMPLIED BY THE FOMERG LINE...)#    FM10  18
chardata:(FM10N, PRINT        SAMPLES OF MODIFIED MAP PER LAYER)#       FM10  19
chardata:(FM10O, SCRATCH FILE ON H             )#                       FM10  20
chardata:(FM10Q, MAXIMUM ELECTRON DENSITY IN FILE             $#        FM10  21
AND DETERMINED BY SCAN OF MAP           )#                              FM10  22
chardata:(FM10W,FROM MAP ON FILE C)#                                    FM10  23
chardata:(FM10X,FROM MAP ON FILE D)#                                    FM10  24
chardata:(FM10Y,TO MODIFIED ON FILE E)#                                 FM10  25
chardata:(FM10Z, THIS IS SIMPLY A WARNING IN CASE $#                    FM10  26
FUTURE CALCULATIONS ARE TO BE DONE WITH RFOURR PROGRAM.)#               FM10  27
#                                                                       FM10  28
#------  ALLOWED VALUES OF NX IN FOURIER GRIDS                          FM10  29
#        (RANGE FROM 2 TO 5040) ONLY MXGRID IMPLEMENTED                 FM10  30
realdata:(FMFM,[450931.,850931.])#                                      FM10  31
intdata:(ND,[$#                                                         FM10  32
   2,   3,   4,   5,   6,   7,   8,   9,#                               FM10  33
10,  12,  14,  15,  16,  18,  20,  21,#                                 FM10  34
24,  28,  30,  35,  36,  40,  42,  45,#                                 FM10  35
48,  56,  60,  63,  70,  72,  80,  84,#                                 FM10  36
90, 105, 112, 120, 126, 140, 144, 168,#                                 FM10  37
180, 210, 240, 252, 280, 315, 336, 360,#                                FM10  38
420, 504, 560, 630, 720, 840,1008,1260,#                                FM10  39
1680,2520,5040])#                                                       FM10  40
intdata:(MXGRID,[57])##                                                 FM10  41
realdata:(FMNX,[110413.,170413.,270413.])# Format for grid error        FM10  42
chardata:(FM7A, ONE OR MORE SUMMATION DIRECTIONS ARE NOT IN $#          FM10  43
GRID DIVISIONS HANDLED BY FFT SUBROUTINES.)#                            FM10  44
chardata:(FM7B,[ GIVEN     ,     , AND     .   ACCEPTIBLE.......])#     FM10  45
chardata:(FM7C, THRESHOLD = XXXX.XXX  WEIGHT = XX.XX FOR MAP X )#       FM10  46
chardata:(FM7S, INSUFFICIENT IMMEDIATE ACCESS MEMORY FOR WHOLE MAP.  $# FM10  47
SCRATCH FILE WILL BE WRITTEN ON H)#                                     FM10  48
#                                                                       FM10  49
INTEGER I,J,K,L,N#                     Local indices                    FM10  50
INTEGER PSIZ,PSIZD,IP,IPD,IIP,IIPP,JP# Bdf reading parameters           FM10  51
INTEGER NDIV1,NDIV2,NDIV3#             Fourier grid divisions           FM10  52
datastuff:#                                                             FM10  53
#                                                                       FM10  54
PRINTL=0#                              Suppress refl print              FM10  55
WT1=1.0 ; WT2=1.0 ; TH1=0.001 ; TH2=0.001# Set defaults                 FM10  56
#                                                                       FM10  57
FOR(K=1;K>0;K=K+1)#                    Loop over input fields           FM10  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FM10  59
IF(BUFIN(K)>=voidflg:) BREAK#          Go to first non-alpha field      FM10  60
stringlim:(K,I,J) ; L=MIN0(3,J-K)#     Find characters in input         FM10  61
compchar:(CHRIN,I,FM10B,1,L,4,NFM10B,J)# Search list of options         FM10  62
IF(J==0) iquit:(FM1001)#               It must be valid                 FM10  63
ELSE IF(J==1)#                         Test reflection print control    FM10  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FM10  65
IF(BUFIN(K+1)>0.0)#                                                     FM10  66
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FM10  67
K=K+1 ; PRINTL=NINT(BUFIN(K))#                                          FM10  68
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FM10  69
ELSE PRINTL=10#                                                         FM10  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FM10  71
ELSE IF(J==2)#                         Test threshold 1 value           FM10  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FM10  73
IF(BUFIN(K+1)>=-1000.)#                                                 FM10  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FM10  75
K=K+1 ; TH1=BUFIN(K)#                  Accept threshold value           FM10  76
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FM10  77
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FM10  78
ELSE IF(J==3)#                         Test threshold 2 value           FM10  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FM10  80
IF(BUFIN(K+1)>=-1000.)#                                                 FM10  81
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FM10  82
K=K+1 ; TH2=BUFIN(K)#                  Accept threshold value           FM10  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FM10  84
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FM10  85
ELSE IF(J==4)#                         Test weight 1 value              FM10  86
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FM10  87
IF(BUFIN(K+1)>0.)#                                                      FM10  88
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FM10  89
K=K+1 ; WT1=BUFIN(K)#                  Accept weight value              FM10  90
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FM10  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FM10  92
ELSE IF(J==5)#                         Test weigt 2 value               FM10  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FM10  94
IF(BUFIN(K+1)>0.)#                                                      FM10  95
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FM10  96
K=K+1 ; WT2=BUFIN(K)#                  Accept weight value              FM10  97
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FM10  98
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FM10  99
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FM10 100
#                                                                       FM10 101
# WRITE OUT A SUMMARY OF INSTRUCTIONS                                   FM10 102
# -----------------------------------                                   FM10 103
#                                                                       FM10 104
LINRM=12 ; writeline:(1,FM10K,NFM10K,3,3)# Heading                      FM10 105
writeline:(1,FM10L,NFM10L,3,3)#                                         FM10 106
BUFOT(1)=FLOAT(PRINTL) ; ncodefld:(BUFOT,1,FM10N,130513.,1)#            FM10 107
writeline:(1,FM10N,NFM10N,3,3)#                                         FM10 108
ncodefld:(TH1,1,FM7C,210832.,1) ; ncodefld:(WT1,1,FM7C,370522.,1)#      FM10 109
ncodefld:(1.0,1,FM7C,470113.,1) ; writeline:(1,FM7C,NFM7C,3,3)#         FM10 110
ncodefld:(TH2,1,FM7C,210832.,1) ; ncodefld:(WT2,1,FM7C,370522.,1)#      FM10 111
ncodefld:(2.0,1,FM7C,470113.,1) ; writeline:(1,FM7C,NFM7C,3,3)#         FM10 112
#                                                                       FM10 113
# TAKE IN ANY OTHER INPUT LINES                                         FM10 114
# -----------------------------                                         FM10 115
#                                                                       FM10 116
REPEAT#                                Loop over lines                  FM10 117
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FM10 118
readline:(FM10A,NFM10A)#                                                FM10 119
IF(LINID==1) BREAK#                    Stop reading when end line       FM10 120
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FM10 121
#                                                                       FM10 122
# SET UP I/O BUFFERS FOR THREE FILES                                    FM10 123
# ----------------------------------                                    FM10 124
#                                                                       FM10 125
FILEXT(IOUNIT(3))='MAP'#               Input first density map          FM10 126
FILEXT(IOUNIT(4))='MPP'#               Input second density map         FM10 127
FILEXT(IOUNIT(5))='MPN'#               Output new density map           FM10 128
IOMARK(3)=QXSTR#                       Set up electron density in/p1    FM10 129
IOMARK(4)=IOMARK(3)+bdfbuf:#           Set up electron density in/p2    FM10 130
IOMARK(5)=IOMARK(4)+bdfbuf:#           Set up electron density out/p    FM10 131
incrqx:(MARKP,IOMARK(5)+bdfbuf:,FM1005)# Pointer to stored density      FM10 132
#                                                                       FM10 133
copyfile:(3,5,1,20)#                   Move lead records                FM10 134
#                                                                       FM10 135
# RETRIEVE THE MAP PARAMETERS FROM LR 21 OF FILE C & D                  FM10 136
# AND START BUILDING THE MERGED ELECTRON DENSITY MAP ON FILE E          FM10 137
# ------------------------------------------------------------          FM10 138
#                                                                       FM10 139
readwpkt:(3,21,PSIZ,IP,0)#                                              FM10 140
readwpkt:(4,21,PSIZD,IPD,0)#                                            FM10 141
writepkt:(5,21,PSIZ,JP) ; movereal:(QX,IP+1,QX,JP+1,PSIZ,0)#            FM10 142
DO K=1,3#                                                               FM10 143
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FM10 144
IIP=IP+K ; IIPP=IPD+K#                                                  FM10 145
OG(K)=NINT(QX(IIP))#                   Pick up origins                  FM10 146
IF(NINT(QX(IIP))!=NINT(QX(IIPP))) iquit:(FM1010)# Origins do not matc   FM10 147
IN(K)=NINT(QX(IIP+3))#                 Increments along axes            FM10 148
IF(NINT(QX(IIP+3))!=NINT(QX(IIPP+3))) iquit:(FM1011)# Grid mismatch     FM10 149
NG(K)=NINT(QX(IIP+6))#                 No. of grid points               FM10 150
IF(NINT(QX(IIP+6))!=NINT(QX(IIPP+6))) iquit:(FM1012)# Grids mismatch    FM10 151
NP(K)=NINT(QX(IIP+9))#                 Calculated points                FM10 152
IF(NINT(QX(IIP+9))!=NINT(QX(IIPP+9))) iquit:(FM1013)# Grids mismatch    FM10 153
ISUM(K)=NINT(QX(IIP+12))#              Correlations between crystal     FM10 154
IF(NINT(QX(IIP+12))!=NINT(QX(IIPP+12))) iquit:(FM1014)# Sum order mis   FM10 155
JSUM(K)=NINT(QX(IIP+15))#              Axes and calculation axes        FM10 156
IF(NINT(QX(IIP+15))!=NINT(QX(IIPP+15))) iquit:(FM1015)# Sum order mis   FM10 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FM10 158
#                                                                       FM10 159
movechar:(FM10D,JSUM(3),FM10G,24,1,0)# Change to correct axis           FM10 160
movechar:(FM10D,JSUM(2),FM10G,32,1,0)# Change to correct axis           FM10 161
movechar:(FM10D,JSUM(1),FM10G,38,1,0)# Change to correct axis           FM10 162
writeline:(1,FM10G,NFM10G,3,3)#                                         FM10 163
#                                                                       FM10 164
# MAKE SURE GRID SIZES ARE POSSIBLE TO DO                               FM10 165
# ---------------------------------------                               FM10 166
#                                                                       FM10 167
NDIV1=0;NDIV2=0;NDIV3=0#               Set grid size pointers           FM10 168
DO J=1,MXGRID#                         Loop over possible grids         FM10 169
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FM10 170
IF(NG(1)==ND(J)) NDIV1=J#              Set layer divisions              FM10 171
IF(NG(2)==ND(J)) NDIV2=J#              Set down layer divisions         FM10 172
IF(NG(3)==ND(J)) NDIV3=J#              Set across layer divisions       FM10 173
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FM10 174
IF((NDIV1==0)\(NDIV2==0)\(NDIV3==0))#  Test that all o.k.               FM10 175
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FM10 176
BUFOT(1)=FLOAT(NG(1));BUFOT(2)=FLOAT(NG(2));BUFOT(3)=FLOAT(NG(3))#      FM10 177
writeline:(1,FM7A,NFM7A,3,1)#                                           FM10 178
ncodefld:(BUFOT,1,FM7B,FMNX,3)#                                         FM10 179
writeline:(0,FM7B,NFM7B,3,1)#                                           FM10 180
K=0; FOR(J=1;J<=4;J=J+1)#              Dump all possible grids          FM10 181
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FM10 182
IF(J<4) N=15#                          15 items per line for three li   FM10 183
ELSE N=14#                             14 on the last                   FM10 184
FMT=413.#                              Start building the format        FM10 185
DO L=1,N#                                                               FM10 186
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FM10 187
K=K+1 ; FMT=FMT+50000. ; BUFOT(1)=FLOAT(ND(K))#                         FM10 188
ncodefld:(BUFOT,1,CHROT,FMT,1)#                                         FM10 189
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FM10 190
writeline:(0,0,0,1,1)#                                                  FM10 191
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FM10 192
writeline:(1,FM10Z,NFM10Z,3,3)#        Warn user of possible glitch     FM10 193
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FM10 194
#                                                                       FM10 195
RETURN#                                                                 FM10 196
END#                                                                    FM10 197
systemheader:(FM70)#                   Map merging                      FM70   1
# ################################################################## #  FM70   2
#                                                                    #  FM70   3
#                               FM70                                 #  FM70   4
#                                                                    #  FM70   5
# ################################################################## #  FM70   6
SUBROUTINE FM70## J.M.stewart Oct 1988                                  FM70   7
include:(AACOMN)##                                                      FM70   8
include:(FMCOMN)#                                                       FM70   9
#                                                                       FM70  10
# THIS ROUTINE SCREENS, WEIGHTS AND MERGES ELECTRON DENSITY MAPS        FM70  11
# RHO(OUT) = AMAX1(TH1,RHO(1))*WT1 + AMAX1(TH2,RHO(2))*WT2              FM70  12
# WHERE "TH1" IS A THRESHOLD, SO ALL VALUES OF RHO1 BELOW               FM70  13
# A VALUE, TH1, ARE SET TO TH1.                                         FM70  14
#--------------------------------------+------------------------------- FM70  15
#                                                                       FM70  16
INTEGER I,J,L,M#     ## Local indices for loops etc.                    FM70  17
INTEGER PRINTP#      ## Electron density dumping control                FM70  18
INTEGER PSIZ,PSIZD,IP,IPD,JP## I/o pointers                             FM70  19
REAL ED1LIM(3)#      ## El-dens statistics from file c                  FM70  20
REAL ED2LIM(3)#      ## El-dens statistics from file d                  FM70  21
REAL EDNLIM(3)#      ## El-dens statistics from file E                  FM70  22
REAL NEWELD,ELD1,ELD2## Electron densities during processing            FM70  23
chardata:(FM7G, PRINT A SAMPLE OF INPUT AND OUTPUT ELECTRON DENSITY)#   FM70  24
chardata:(FM7H,  POINT NO.    INPUT RHO  OUTPUT RHO    NEW RHO)#        FM70  25
realdata:(FMT7,[341031.,631031.])#                                      FM70  26
realdata:(FMT8,[421031.,681013.])#                                      FM70  27
realdata:(FMTL,[390852.,520852.])#                                      FM70  28
realdata:(FMTO,[110813.,241041.,361041.,481041.])#                      FM70  29
realdata:(FMTST,[370931.,570931.,780931.])#                             FM70  30
chardata:(FM7Q,   MAP 1 DENSITY MAXIMUM =             $#                FM70  31
MINIMUM =           AVERAGE =           )#                              FM70  32
chardata:(FM7R,   MAP 2 DENSITY MAXIMUM =             $#                FM70  33
MINIMUM =           AVERAGE =           )#                              FM70  34
chardata:(FM7S,   NEW   DENSITY MAXIMUM =             $#                FM70  35
MINIMUM =           AVERAGE =           )#                              FM70  36
datastuff:#                                                             FM70  37
#                                                                       FM70  38
# INITIALIZE COUNTS, NUMBERS OF POINTS IN SUMMATIONS AND PRINT OUT      FM70  39
# ----------------------------------------------------------------      FM70  40
#                                                                       FM70  41
NPIX=0#                                Zero numper of points            FM70  42
ED1LIM(1)=-99999. ; ED1LIM(2)=99999. ; ED1LIM(3)=0.0# El-den stats      FM70  43
ED2LIM(1)=-99999. ; ED2LIM(2)=99999. ; ED2LIM(3)=0.0# El-den stats      FM70  44
EDNLIM(1)=-99999. ; EDNLIM(2)=99999. ; EDNLIM(3)=0.0# El-den stats      FM70  45
PRINTP=PRINTL ; LINRM=6; IF(PRINTL>0)#                                  FM70  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FM70  47
writeline:(1,FM7G,NFM7G,3,3)#                                           FM70  48
writeline:(0,0,0,1,3) ; LINRM=10#      Assure heading on sample o/p     FM70  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FM70  50
#                                                                       FM70  51
# TOP OF LOOP OVER PACKETS (LINES) TO PROCESS ELECTRON DENSITY          FM70  52
# ------------------------------------------------------------          FM70  53
#                                                                       FM70  54
REPEAT#                                Loop over layers                 FM70  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FM70  56
readwpkt:(3,22,PSIZ,IP,0)#             Read next line on file c         FM70  57
readwpkt:(4,22,PSIZD,IPD,0)#           Read next line on file d         FM70  58
IF(IP<=0\IPD<=0) BREAK#                Quit if an end-of-file is hit    FM70  59
writepkt:(5,22,PSIZ,JP)#               Write a packet for holding e.d   FM70  60
I=IP ; L=IPD ; M=JP#                   Set pointers to el-density       FM70  61
DO J=1,PSIZ#                           Loop across line                 FM70  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FM70  63
I=I+1 ; L=L+1 ; M=M+1#                 Move ahead in line buffer        FM70  64
NPIX=NPIX+1#                           Count up all points              FM70  65
ELD1=QX(I) ; ELD2=QX(L)#               Take input electron densities    FM70  66
ED1LIM(3)=ED1LIM(3)+ELD1#              Build statistics                 FM70  67
ED1LIM(1)=AMAX1(ELD1,ED1LIM(1)) ; ED1LIM(2)=AMIN1(ELD1,ED1LIM(2))#      FM70  68
ED2LIM(3)=ED2LIM(3)+ELD2#              Build statistics                 FM70  69
ED2LIM(1)=AMAX1(ELD2,ED2LIM(1)) ; ED2LIM(2)=AMIN1(ELD2,ED2LIM(2))#      FM70  70
#                                                                       FM70  71
#  FORM THE NEW ELECTRON DENSITY FROM THE INPUT ELECTRON DENSITIES      FM70  72
#  ---------------------------------------------------------------      FM70  73
#                                                                       FM70  74
NEWELD=WT1*AMAX1(TH1,ELD1)+WT2*AMAX1(TH2,ELD2)# Combine densities       FM70  75
#                                                                       FM70  76
EDNLIM(3)=EDNLIM(3)+NEWELD#            Build statistics                 FM70  77
EDNLIM(1)=AMAX1(NEWELD,EDNLIM(1));EDNLIM(2)=AMIN1(NEWELD,EDNLIM(2))#    FM70  78
#                                                                       FM70  79
QX(M)=NEWELD#                          Electron dens to o/p buffer      FM70  80
IF(PRINTP>0)#                          See if dumping a sample          FM70  81
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FM70  82
BUFOT(1)=FLOAT(NPIX)#                                                   FM70  83
BUFOT(2)=QX(I) ; BUFOT(3)=QX(L)#       Get electron densities           FM70  84
BUFOT(4)=QX(M)#                                                         FM70  85
ncodefld:(BUFOT,1,CHROT,FMTO,4) ; writeline:(0,FM7H,NFM7H,1,3)#         FM70  86
PRINTP=PRINTP-1#                       Decrement ouput lines            FM70  87
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FM70  88
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FM70  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FM70  90
#                                                                       FM70  91
# AT THE END OF READING THE WHOLE MAP GIVE EL-DENS STATS                FM70  92
# ------------------------------------------------------                FM70  93
#                                                                       FM70  94
ED1LIM(3)=ED1LIM(3)/FLOAT(NPIX)#       Find ave medens el-dens          FM70  95
ncodefld:(ED1LIM,1,FM7Q,FMTST,3) ; writeline:(1,FM7Q,NFM7Q,3,3)#        FM70  96
ED2LIM(3)=ED2LIM(3)/FLOAT(NPIX)#       Find ave difference el-dens      FM70  97
ncodefld:(ED2LIM,1,FM7R,FMTST,3) ; writeline:(1,FM7R,NFM7R,3,3)#        FM70  98
EDNLIM(3)=EDNLIM(3)/FLOAT(NPIX)#       Find ave difference el-dens      FM70  99
ncodefld:(EDNLIM,1,FM7S,FMTST,3) ; writeline:(1,FM7S,NFM7S,3,3)#        FM70 100
#                                                                       FM70 101
#                                                                       FM70 102
# FINISH OFF ALL BDFS AND QUIT                                          FM70 103
# ----------------------------                                          FM70 104
#                                                                       FM70 105
readwpkt:(3,endrecord:,PSIZ,IP,0)#     End off old el-dens file c       FM70 106
readwpkt:(4,endrecord:,PSIZ,IP,0)#     End off old el-dens file d       FM70 107
writepkt:(5,endrecord:,3,IP)#          End off new el-dens file e       FM70 108
#                                                                       FM70 109
RETURN#                                                                 FM70 110
END#                                                                    FM70 111
#        FOMERG    *****FM*****                                         FM70 112
#0531001 THERE IS AN INVALID OPTION CODE ON THE FOMERG LINE.            FM70 113
#0531005 INSUFFICIENT STORAGE FOR ELECTRON DENSITY FILES C,D&E BUFFERS. FM70 114
#0531006 THE RFOURR PROGRAM IS RESTRICTED TO CERTAIN GRID DIVISIONS.    FM70 115
#0531006 THE INPUT ELECTRON DENSITY MAP DOES NOT MEET THE RESTRICTIONS. FM70 116
#0531010 THE ORIGINS ON THE TWO FOURIER MAPS DO NOT MATCH.              FM70 117
#0531011 THE GRID INCREMENTS ON THE TWO FOURIER MAPS DO NOT MATCH.      FM70 118
#0531012 THE GRIDS ON THE TWO FOURIER MAPS DO NOT MATCH.                FM70 119
#0531013 THE NUMBER OF GRID POINTS ON THE TWO FOURIER MAPS DO NOT MATCH FM70 120
#0531014 THE SUMMATION ORDER ON THE TWO FOURIER MAPS DOES NOT MATCH.    FM70 121
#0531015 THE SUMMATION ORDER ON THE TWO FOURIER MAPS DOES NOT MATCH.    FM70 122
#0531016 THE MAXIMUM ELECTRON DENSITY ON INPUT FILE C, THE CONSTRAINED  FM70 123
#0531016 EXPONENTIAL DENSITY, IS LESS THAN 0.01. WHY?                   FM70 124
pmacro:([no:])#                        Purge xtal system macros         FM70 125
