systemheader:(FO    )#                                                  FO     1
####################################################################### FO     2
#                                                                     # FO     3
#                           *** FOGEN ***                             # FO     4
#                                                                     # FO     5
#   FOGEN CALCULATES AN ARBITRARILY LARGE FOURIER MAP FROM AN         # FO     6
#   INPUT FOURIER MAP CONTAINING AT LEAST THE ASYMMETRIC UNIT.        # FO     7
#                                                                     # FO     8
####################################################################### FO     9
include:(XMACRO)#                                                       FO    10
#                                                                       FO    11
extrude:(FOCOMN)#                                                       FO    12
INTEGER CTYPE#                         Type of fourier calculated       FO    13
INTEGER DELTAY#                        Storage locations between ea     FO    14
INTEGER DELTAZ#                        Y and each z in qx array         FO    15
INTEGER FORMAT#                        Print norm=1,pack=2,shad=3       FO    16
INTEGER INCS(3)#                       Grid increments in input order   FO    17
INTEGER INCX(3)#                       In xyz order                     FO    18
INTEGER IORGS(3)#                      Grid origin in input order       FO    19
INTEGER IORGX(3)#                      In xyz order                     FO    20
INTEGER IPT#                           Input packet pointer             FO    21
INTEGER ISUM1#                         Indicates first sum axis         FO    22
INTEGER ISUM2#                         Second sum axis                  FO    23
INTEGER ISUM3#                         Third sum axis                   FO    24
INTEGER IX(3)#                         Current point in xyz order       FO    25
INTEGER JPT#                           Output packet pointer            FO    26
INTEGER JSUM1#                         Summation order permutation      FO    27
INTEGER JSUM2#                         Indices.                         FO    28
INTEGER JSUM3#                                                          FO    29
INTEGER MAPEND(3)#                     Input map end in xyz order       FO    30
INTEGER MAPORG(3)#                     Input map origin in xyz order    FO    31
INTEGER MARKS#                         Pointer to symops                FO    32
INTEGER MARK2#                         Pointer to input map in qx       FO    33
INTEGER MARK3#                         Pointer to output map sectio     FO    34
INTEGER MARK4#                         Pointer to third sum grid ax     FO    35
INTEGER NCOLM#                         Number of printer columns pe     FO    36
INTEGER NEWX(3)#                       Symopped value of current gr     FO    37
INTEGER NGS(3)#                        Grids in input order             FO    38
INTEGER NGX(3)#                        In xyz order                     FO    39
INTEGER NPTS(3)#                       Total grid points-input order    FO    40
INTEGER NPTX(3)#                       In xyz order                     FO    41
INTEGER NSTEP2#                        Increment pointers in qx array   FO    42
INTEGER NSTEP3#                                                         FO    43
INTEGER NSTEP4#                                                         FO    44
INTEGER NSTOP2#                                                         FO    45
INTEGER NSTOP3#                                                         FO    46
INTEGER NSTOP4#                                                         FO    47
INTEGER PATT#                          = 0, if map computed with f'     FO    48
INTEGER PRINT#                         1/0, print/do not print output   FO    49
INTEGER PSIZE#                         Logical record packet size       FO    50
INTEGER SFILE#                         0/1, no output bdf/output bdf    FO    51
INTEGER SHEETS#                        Number of sheets/section         FO    52
INTEGER SPACE#                         Blank lines between map lines    FO    53
INTEGER STEPS#                         Number of words/symop            FO    54
REAL F000#                             Fzero                            FO    55
REAL FORSCL#                           Scale when shaded format use     FO    56
REAL LOLIM#                            Lower limit in map values        FO    57
REAL PASSES#                           Number of fourier passes         FO    58
REAL SKAL#                             Scale to output map              FO    59
REAL UPLIM#                            Upper limit to map values        FO    60
string:(MAPCHR,1)#                     Character used in printing       FO    61
#                                                                       FO    62
COMMON/COMIFO/ CTYPE,DELTAY,DELTAZ,FORMAT,INCS,INCX,$#                  FO    63
IORGS,IORGX,IPT,ISUM1,ISUM2,ISUM3,IX,JPT,$#                             FO    64
JSUM1,JSUM2,JSUM3,MAPEND,MAPORG,MARKS,MARK2,$#                          FO    65
MARK3,MARK4,NCOLM,NEWX,NGS,NGX,$#                                       FO    66
NPTS,NPTX,NSTEP2,NSTEP3,NSTEP4,NSTOP2,$#                                FO    67
NSTOP3,NSTOP4,PATT,PRINT,$#                                             FO    68
PSIZE,SFILE,SHEETS,SPACE,STEPS,#                                        FO    69
#                                                                       FO    70
COMMON/COMFFO/ F000,FORSCL,LOLIM,PASSES,SKAL,UPLIM#                     FO    71
#                                                                       FO    72
COMMON/COMCFO/ MAPCHR#                                                  FO    73
#                                                                       FO    74
endext:#                                                                FO    75
#                                                                       FO    76
systemheader:(FO00)#                   Arbitrary map from input map     FO00   1
# ################################################################## #  FO00   2
#                                                                    #  FO00   3
#                               FO00                                 #  FO00   4
#                                                                    #  FO00   5
# ################################################################## #  FO00   6
SUBROUTINE FO00#                       Feb 1982  r.a. alden             FO00   7
include:(AACOMN)#                      Feb 1988  n. spadaccini          FO00   8
include:(FOCOMN)#                                                       FO00   9
#                                                                       FO00  10
FILEXT(IOUNIT(3))='MAP'#               Ext of input fourr map           FO00  11
FILEXT(IOUNIT(4))='MAG'#               Ext of output map                FO00  12
#                                                                       FO00  13
CALL FO10#                             Process through to lrsymm:       FO00  14
CALL FO20#                             Read map and store in xyz orde   FO00  15
CALL FO30#                             Process layout and print lines   FO00  16
CALL FO40#                             Generate new map                 FO00  17
#                                                                       FO00  18
RETURN#                                                                 FO00  19
END#                                                                    FO00  20
systemheader:(FO10)#                   Read input, generate symops      FO10   1
# ################################################################## #  FO10   2
#                                                                    #  FO10   3
#                               FO10                                 #  FO10   4
#                                                                    #  FO10   5
# ################################################################## #  FO10   6
SUBROUTINE FO10#                       Feb 1982  r.a. alden             FO10   7
include:(AACOMN)#                      Feb 1988  n. spadaccini          FO10   8
include:(FOCOMN)#                                                       FO10   9
#                                                                       FO10  10
INTEGER BEGIN#                         Current field's starting col     FO10  11
INTEGER ENDD#                          Current field's final column     FO10  12
INTEGER FIELD#                         Current field number             FO10  13
INTEGER ICENT#                         Centro/noncentro = 0/1           FO10  14
INTEGER LATYP#                         Lattice type                     FO10  15
INTEGER MATCH#                         Indicates which character        FO10  16
INTEGER NSYM#                          Number of symops on bdf          FO10  17
INTEGER TOTSYM#                        Qx requirements for all symops   FO10  18
#                                                                       FO10  19
chardata:(FO011,SF NS PR NP )#                                          FO10  20
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])# Translation vectors for      FO10  21
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])# Generation of symops         FO10  22
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              FO10  23
realdata:(TR21,[.3333333,.5])#                                          FO10  24
realdata:(TR22,[.6666667,0.])#                                          FO10  25
realdata:(TR23,[.6666667,.5])#                                          FO10  26
datastuff:#                                                             FO10  27
#                                                                       FO10  28
#           SET DEFAULTS                                                FO10  29
#           ------------                                                FO10  30
#                                                                       FO10  31
SFILE=yes:#                            Write a new bdf                  FO10  32
PRINT=no:#                             Assume no print out              FO10  33
SKAL=1.#                               No map scaling                   FO10  34
STEPS=12#                              Twelve words per symop           FO10  35
#                                                                       FO10  36
FOR(FIELD=1;FIELD>0;FIELD=FIELD+1)#    Loop over image fields           FO10  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FO10  38
ifvo:(BUFIN(FIELD))  BREAK#            Stop at first blank field        FO10  39
stringlim:(FIELD,BEGIN,ENDD)#          Find field limits                FO10  40
compchar:(CHRIN,BEGIN,FO011,1,2,3,NFO011,MATCH)#                        FO10  41
IF(MATCH==0) iquit:(FO1005)#           Unrecognised input               FO10  42
IF     (MATCH==1)  SFILE=yes:#         Write new bdf                    FO10  43
ELSE IF(MATCH==2)  SFILE=no:#          Don't write new bdf              FO10  44
ELSE IF(MATCH==3)  PRINT=yes:#         Print output                     FO10  45
ELSE IF(MATCH==4)  PRINT=no:#          No printout                      FO10  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FO10  47
#                                                                       FO10  48
#      REQUEST MEMORY FOR I/O BUFFERS                                   FO10  49
#      ------------------------------                                   FO10  50
#                                                                       FO10  51
IOMARK(3)=QXSTR#                       Set up input bdf buffer          FO10  52
incrqx:(MARKS,IOMARK(3)+bdfbuf:,FO1010)# Insufficient memory..buf       FO10  53
IF(SFILE==yes:)#                       If there is an output bdf,       FO10  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FO10  55
IOMARK(4)=MARKS#                       Set up buffer for file c.        FO10  56
incrqx:(MARKS,IOMARK(4)+bdfbuf:,FO1015)# Insufficient memory..buf       FO10  57
copyfile:(3,4,1,decr:(lrsymm:))#       Copy upto lrsymm:                FO10  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FO10  59
#                                                                       FO10  60
#         EXTRACT SYMMETRY INFORMATION FROM BDF                         FO10  61
#         -------------------------------------                         FO10  62
#                                                                       FO10  63
readwpkt:(3,lrsymm:,PSIZE,IPT,0)#      Read first packet lrsymm.        FO10  64
IF(IPT<=0) iquit:(FO1020)#             Non-existant logical record      FO10  65
LATYP=NINT(QX(IPT+1))#                 Lattice type                     FO10  66
IF(LATYP>7) LATYP=LATYP-7#             Remove centricity                FO10  67
ICENT=NINT(QX(IPT+2))#                 Centre flag (c=0,nc=1)           FO10  68
NSYM=NINT(QX(IPT+4))#                  Number of matrices on bdf        FO10  69
TOTSYM=NINT(QX(IPT+3))*STEPS#          Memory requirements              FO10  70
incrqx:(M,MARKS+TOTSYM,FO1025)#        Insufficient memory..symops      FO10  71
IF(SFILE==yes:)#                       Copy out if required             FO10  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FO10  73
writepkt:(4,lrsymm:,PSIZE,JPT)#        Write buffer                     FO10  74
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#  Move packet to output buffer     FO10  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FO10  76
#                                                                       FO10  77
#         READ IN SYMOPS                                                FO10  78
#         --------------                                                FO10  79
#                                                                       FO10  80
FOR(J=MARKS;J>0;J=J+STEPS)#            Loop over symops                 FO10  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FO10  82
readwpkt:(3,lrsymm:,PSIZE,IPT,0)#      Read in matrix                   FO10  83
IF(IPT<=0) BREAK#                      End of symops                    FO10  84
movereal:(QX,IPT+1,QX,J+1,PSIZE,1)#    Move contents                    FO10  85
IF(SFILE==yes:)#                       Output if required               FO10  86
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FO10  87
writepkt:(4,lrsymm:,PSIZE,JPT)#        Write buffer                     FO10  88
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#  Move matrices to output buffer   FO10  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FO10  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FO10  91
#                                                                       FO10  92
#          EXPAND SYMOP TABLE TO ALL OPERATIONS                         FO10  93
#          ------------------------------------                         FO10  94
#                                                                       FO10  95
K=MARKS+NSYM*STEPS ; N=K#              Point to end of symops           FO10  96
IF(ICENT==0)#                          If centrosymmetric               FO10  97
FOR(J=MARKS;J<N;J=J+1)#                Loop over input symops           FO10  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FO10  99
K=K+1#                                 Increment pointer                FO10 100
QX(K)=-QX(J+1)#                        Store inverse                    FO10 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FO10 102
N=K#                                   Store new end marker             FO10 103
IF(LATYP>1)#                           Centering translations           FO10 104
FOR(J=MARKS;J<N;J=J+STEPS)#            Loop over input symops           FO10 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FO10 106
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            FO10 107
QX(K+10)=QX(J+10)+TR11(LATYP-1)#       Transfer t1                      FO10 108
QX(K+11)=QX(J+11)+TR12(LATYP-1)#       Transfer t2                      FO10 109
QX(K+12)=QX(J+12)+TR13(LATYP-1)#       Transfer t3                      FO10 110
K=K+STEPS#                             Incr storage pointer             FO10 111
IF((LATYP==2)\(LATYP>4)) NEXT#         Skip if not r or f               FO10 112
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            FO10 113
QX(K+10)=QX(J+10)+TR21(LATYP-2)#       Transfer t1                      FO10 114
QX(K+11)=QX(J+11)+TR22(LATYP-2)#       Transfer t2                      FO10 115
QX(K+12)=QX(J+12)+TR23(LATYP-2)#       Transfer t3                      FO10 116
K=K+STEPS#                             Incr storage pointer             FO10 117
IF(LATYP!=4) NEXT#                     Skip if not f-centre             FO10 118
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            FO10 119
QX(K+10)=QX(J+10)+0.5#                 Transfer t1                      FO10 120
QX(K+11)=QX(J+11)+0.5#                 Transfer t2                      FO10 121
QX(K+12)=QX(J+12)+0.0#                 Transfer t3                      FO10 122
K=K+STEPS#                             Incr storage pointer             FO10 123
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FO10 124
MARK2=K#                               Symops end marker                FO10 125
IF(SFILE==yes:)#                                                        FO10 126
copyfile:(3,4,incr:(lrsymm:),decr:(21))# Copy to lr21                   FO10 127
#                                                                       FO10 128
RETURN#                                                                 FO10 129
END#                                                                    FO10 130
systemheader:(FO20)#                   Determine map size and           FO20   1
# ################################################################## #  FO20   2
#                                                                    #  FO20   3
#                               FO20                                 #  FO20   4
#                                                                    #  FO20   5
# ################################################################## #  FO20   6
SUBROUTINE FO20#                       Copy into memory                 FO20   7
include:(AACOMN)#                      Feb 1982  r.a. alden             FO20   8
include:(FOCOMN)#                      Feb 1988  n. spadaccini          FO20   9
#                                                                       FO20  10
INTEGER I#                             Loop index                       FO20  11
REAL TOTPTS#                           Total number of map points       FO20  12
#                                                                       FO20  13
readwpkt:(3,21,PSIZE,IPT,0)#           Reads logical record 21          FO20  14
DO I=1,3#                              Items in input order             FO20  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FO20  16
IORGS(I)=NINT(QX(IPT+1))#              Origins                          FO20  17
INCS(I)=NINT(QX(IPT+4))#               Increments                       FO20  18
IF(INCS(I)!=1)  iquit:(FO2005)#        Illegal increment size           FO20  19
NGS(I)=NINT(QX(IPT+7))#                Grids                            FO20  20
NPTS(I)=NINT(QX(IPT+10))#              Points along axes                FO20  21
IPT=IPT+1#                             Increment pointer                FO20  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FO20  23
ISUM1=NINT(QX(IPT+10))#                Summation order indices          FO20  24
ISUM2=NINT(QX(IPT+11))#                                                 FO20  25
ISUM3=NINT(QX(IPT+12))#                                                 FO20  26
JSUM1=NINT(QX(IPT+13))#                Summation order permutation      FO20  27
JSUM2=NINT(QX(IPT+14))#                Indices.                         FO20  28
JSUM3=NINT(QX(IPT+15))#                                                 FO20  29
CTYPE=NINT(QX(IPT+18))#                Calculation type                 FO20  30
F000=QX(IPT+19)#                       F000                             FO20  31
PASSES=QX(IPT+20)#                     Number of passes required        FO20  32
NGX(1)=NGS(ISUM1)#                     Grids in x direction         2   FO20  33
NGX(2)=NGS(ISUM2)#                     Grids in y direction             FO20  34
NGX(3)=NGS(ISUM3)#                     Grids in z direction             FO20  35
IORGX(1)=IORGS(ISUM1)#                 Origin in x direction            FO20  36
IORGX(2)=IORGS(ISUM2)#                 Origin in y direction            FO20  37
IORGX(3)=IORGS(ISUM3)#                 Origin in z direction            FO20  38
NPTX(1)=NPTS(ISUM1)#                   Points in x direction            FO20  39
NPTX(2)=NPTS(ISUM2)#                   Points in y direction            FO20  40
NPTX(3)=NPTS(ISUM3)#                   Points in z direction            FO20  41
INCX(1)=INCS(ISUM1)#                   Increment in x direction         FO20  42
INCX(2)=INCS(ISUM2)#                   Increment in y direction         FO20  43
INCX(3)=INCS(ISUM3)#                   Increment in z direction         FO20  44
TOTPTS=FLOAT(NPTS(1)*NPTS(2)*NPTS(3))# Number of points in input map    FO20  45
NSTEP2=NPTS(ISUM1)#                    Number of pts in x direction     FO20  46
NSTOP2=MARK2+NINT(TOTPTS)#             End of map                       FO20  47
incrqx:(I,NSTOP2+1,FO2010)#            Memory for complete map          FO20  48
#                                                                       FO20  49
# THE ENTIRE INPUT MAP WILL BE STORED BY THE ROUTINE FO21.  IT WILL     FO20  50
# ALWAYS BE STORED IN ZYX (WVU) ORDER.  THAT IS, EACH X VALUE WILL      FO20  51
# BE SEPARATED BY ONE STORAGE UNIT, EACH Y BY THE NUMBER OF X POINTS    FO20  52
# ACROSS LINE, AND EACH Z BY THE NUMBER OF POINTS ON A PAGE.            FO20  53
#                                                                       FO20  54
CALL FO21#                             Store map                        FO20  55
#                                                                       FO20  56
RETURN#                                                                 FO20  57
END#                                                                    FO20  58
systemheader:(FO21)#                   Store input map in memory in     FO21   1
######################################################################  FO21   2
#                                                                    #  FO21   3
#                               FO21                                 #  FO21   4
#                                                                    #  FO21   5
######################################################################  FO21   6
SUBROUTINE FO21#                       Xyz order always                 FO21   7
include:(AACOMN)#                      Feb 1982  r.a. alden             FO21   8
include:(FOCOMN)#                      Feb 1988  n. spadaccini          FO21   9
#                                                                       FO21  10
INTEGER DELTA(3)#                      Number of storage locations      FO21  11
INTEGER I,J,K#                         Scanning order loop indices      FO21  12
INTEGER IPTR#                          Pointer to next point on inp     FO21  13
INTEGER LOC1#                          Location pointer                 FO21  14
INTEGER LOC2#                          Same for next line               FO21  15
INTEGER LOC3#                          Same for next point              FO21  16
INTEGER MAPPTS(3)#                     Number of grid points in xyz     FO21  17
INTEGER NP1#                           Points in 1st sum direction      FO21  18
INTEGER NP2#                           Same in 2nd sum direction        FO21  19
INTEGER NP3#                           Same in 3rd sum direction        FO21  20
#                                                                       FO21  21
DELTA(ISUM1)=1#                        Calculate the separation in x    FO21  22
DELTA(ISUM2)=NPTS(ISUM1)#              Calculate the separation in y    FO21  23
DELTA(ISUM3)=NPTS(ISUM1)*NPTS(ISUM2)## Calculate the separation in z    FO21  24
NP2=NPTS(2)#                           Points in 2nd sum direction      FO21  25
NP3=NPTS(3)#                           Points in 3rd sum direction      FO21  26
LOC3=MARK2-DELTA(3)+1#                 Pointers to start of stored ma   FO21  27
LOC2=LOC3#                                                              FO21  28
LOC1=LOC2#                                                              FO21  29
NP1=NPTS(1)#                           Points in 1st sum direction      FO21  30
#                                                                       FO21  31
DO K=1,NP1#                            Loop over input sections         FO21  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FO21  33
DO J=1,NP2#                            Loop over input lines            FO21  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FO21  35
readwpkt:(3,22,PSIZE,IPT,0)#           Read in a line                   FO21  36
IF(IPT<=0)  BREAK#                     Break if logical record end      FO21  37
DO I=1,NP3#                            Loop over points                 FO21  38
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FO21  39
LOC3=LOC3+DELTA(3)#                    Increment storage pointer        FO21  40
IPTR=IPT+I#                                                             FO21  41
QX(LOC3)=QX(IPTR)#                     Store point                      FO21  42
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FO21  43
LOC2=LOC2+DELTA(2)#                    Increment line pointer           FO21  44
LOC3=LOC2#                                                              FO21  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FO21  46
LOC1=LOC1+DELTA(1)#                    Increment section pointer        FO21  47
LOC2=LOC1#                                                              FO21  48
LOC3=LOC2#                                                              FO21  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FO21  50
MAPORG(1)=IORGS(ISUM1)#                Map origin in x direction        FO21  51
MAPORG(2)=IORGS(ISUM2)#                Map origin in y direction        FO21  52
MAPORG(3)=IORGS(ISUM3)#                Map origin in z direction        FO21  53
MAPPTS(1)=NPTS(ISUM1)#                 Points in x direction            FO21  54
MAPPTS(2)=NPTS(ISUM2)#                 Points in y direction            FO21  55
MAPPTS(3)=NPTS(ISUM3)#                 Points in z direction            FO21  56
#                                                                       FO21  57
DO I=1,3#                              Get map termini in xyz order     FO21  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FO21  59
MAPEND(I)=MAPORG(I)+MAPPTS(I)-1#       End of map in grids              FO21  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FO21  61
DELTAY=MAPPTS(1)#                      Number of points in x directio   FO21  62
DELTAZ=MAPPTS(1)*MAPPTS(2)#            Number of points in y directio   FO21  63
RETURN#                                                                 FO21  64
END#                                                                    FO21  65
systemheader:(FO30)#                   Determine map layout required    FO30   1
# ################################################################## #  FO30   2
#                                                                    #  FO30   3
#                               FO30                                 #  FO30   4
#                                                                    #  FO30   5
# ################################################################## #  FO30   6
SUBROUTINE FO30#                       Feb 1982  r.a. alden             FO30   7
include:(AACOMN)#                      Feb 1988  n. spadaccini          FO30   8
include:(FOCOMN)#                                                       FO30   9
#                                                                       FO30  10
INTEGER BEGIN#                         Start of character field         FO30  11
INTEGER ENDD#                          End of character field           FO30  12
INTEGER ISPACE#                        Number of print lines per        FO30  13
INTEGER I,JPTR#                                                         FO30  14
INTEGER J#                             Loop index                       FO30  15
INTEGER K#                             Scratch location                 FO30  16
INTEGER MATCH#                         Indicates which character        FO30  17
INTEGER REV(3)#                        Same as the jsums/isums          FO30  18
#                                                                       FO30  19
chardata:(FO031, LAYOUT PRINT  END   )#                                 FO30  20
chardata:(FO032,LA DO AC )#                                             FO30  21
chardata:(FO033,.NO PA SH )#                                            FO30  22
chardata:(FO034, FOGEN CONTROL PARAMETERS)#                             FO30  23
chardata:(FO035, [>>> LAYOUT OF INPUT MAP <<<])#                        FO30  24
chardata:(FO036, [<<< LAYOUT OF OUTPUT MAP >>>])#                       FO30  25
chardata:(FO037, ORIENTATION OF    AXIS           WITH GRID    )#       FO30  26
chardata:(FO038, MAP BOUNDARY IN    GRID        TO       INCR.=    )#   FO30  27
chardata:(FO039,XYZLAYER DOWN  ACROSS-)#                                FO30  28
chardata:(FO03A, PRINTER DENSITY FORMAT                       )#        FO30  29
chardata:(FO03B, PRINTER DENSITY LIMITS                   )#            FO30  30
chardata:(FO03C, PRINTER DENSITY SCALE                    )#            FO30  31
chardata:(FO03D, PRINTER COL/PT LINE/PT                   )#            FO30  32
chardata:(FO03E,NORMALPACKEDSHADED INCR.)#                              FO30  33
#                                                                       FO30  34
realdata:(FMT1,[300313.,380313.,510313.])#                              FO30  35
realdata:(FMT2,[280213.,340213.])#                                      FO30  36
datastuff:#                                                             FO30  37
#                                                                       FO30  38
#   TELL USER ABOUT THE INPUT MAP                                       FO30  39
#   -----------------------------                                       FO30  40
#                                                                       FO30  41
movechar:(FO039,22,CHROT,2,NFO034-1,2)# Underline header                FO30  42
writeline:(2,FO034,NFO034,2,3)#        Output header                    FO30  43
movechar:(FO039,15,CHROT,2,NFO035-1,2)# Blank out chrot                 FO30  44
writeline:(1,FO035,NFO035,2,3)#        Input map layout                 FO30  45
REV(1)=ISUM1 ; REV(2)=ISUM2 ; REV(3)=ISUM3# Store directions in array   FO30  46
DO I=1,3#                                                               FO30  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FO30  48
movechar:(FO039,I,FO037,18,1,0)#       Encode x,y,z                     FO30  49
movechar:(FO039,(REV(I)-1)*6+4,FO037,27,6,0)# Encode direction          FO30  50
ncodefld:(FLOAT(NGX(I)),1,FO037,470313.,1)# Encode grid number          FO30  51
writeline:(0,FO037,NFO037,3,3)#        Print input orientation          FO30  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FO30  53
DO I=1,3#                                                               FO30  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FO30  55
movechar:(FO039,I,FO038,19,1,0)#       Encode x,y,z                     FO30  56
BUFOT(1)=FLOAT(IORGX(I))#              Origins                          FO30  57
BUFOT(2)=FLOAT(IORGX(I)+NPTX(I)-1)#    End points                       FO30  58
BUFOT(3)=FLOAT(INCX(I))#               Increments                       FO30  59
ncodefld:(BUFOT,1,FO038,FMT1,3)#       Encode                           FO30  60
writeline:(0,FO038,NFO038,3,3)#        Output                           FO30  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FO30  62
DO J=1,3#                              Initialize output layout....     FO30  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FO30  64
INCX(J)=0 ; IORGX(J)=0 ; NPTX(J)=0#    Increments, origin & points      FO30  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FO30  66
ISUM1=0 ; ISUM2=0 ; ISUM3=0#           Output summation order           FO30  67
PRINT=no:#                             Print                            FO30  68
ISPACE=2#                              Double spacing                   FO30  69
NCOLM=4#                               4 columns per point              FO30  70
UPLIM=0.#                              Default accept all               FO30  71
LOLIM=0.#                                                               FO30  72
FORMAT=1#                              Normal                           FO30  73
FORSCL=10.#                            Shade format scale               FO30  74
movechar:(FO033,1,MAPCHR,1,1,0)#       Default map char. is (.)         FO30  75
#                                                                       FO30  76
REPEAT#                                Loop over input lines            FO30  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FO30  78
readline:(FO031,NFO031)#                                                FO30  79
IF(LINID==1)#                          Layout line                      FO30  80
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FO30  81
DO J=1,3#                              Loop over a,b,c directions       FO30  82
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FO30  83
IF(BUFIN(J)<voidflg:)#                 Test for direction string        FO30  84
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FO30  85
stringlim:(J,BEGIN,ENDD)#              Get string limits                FO30  86
compchar:(CHRIN,BEGIN,FO032,1,2,3,NFO032,MATCH)#                        FO30  87
IF(J==1)  ISUM1=MATCH#                 Store summation orders           FO30  88
ELSE IF(J==2)  ISUM2=MATCH#                                             FO30  89
ELSE IF(J==3)  ISUM3=MATCH#                                             FO30  90
ELSE iquit:(FO3005)#                   Illegal summation order          FO30  91
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FO30  92
IF(BUFIN(J+3)>(-.1)) NPTX(J)=NINT(BUFIN(J+3))# Number of points         FO30  93
ifnv:(BUFIN(J+6)) IORGX(J)=NINT(BUFIN(J+6))# Origin                     FO30  94
IF(BUFIN(J+9)>(-.1)) INCX(J)=NINT(BUFIN(J+9))# Increment                FO30  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FO30  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FO30  97
ELSE IF(LINID==2)#                     Print line                       FO30  98
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FO30  99
PRINT=yes:#                            Printed output required          FO30 100
IF(BUFIN(1)<voidflg:)#                 Field 1 specifies printing       FO30 101
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FO30 102
stringlim:(1,BEGIN,ENDD)#              Get the string limits            FO30 103
compchar:(CHRIN,BEGIN,FO033,2,2,3,NFO033,MATCH)# Search strings         FO30 104
IF(MATCH==0)  iquit:(FO3010)#          Illegal print request            FO30 105
FORMAT=MATCH#                          Normal=1,packed=2,shaded=3       FO30 106
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FO30 107
IF(BUFIN(2)>0.) SKAL=BUFIN(2)#         Printer scale                    FO30 108
IF(BUFIN(3)>voidflg:) UPLIM=BUFIN(3)#  Upper limit to printing          FO30 109
IF(BUFIN(4)>voidflg:) LOLIM=BUFIN(4)#  Lower limit to printing          FO30 110
IF(BUFIN(5)>small:) FORSCL=BUFIN(5)#   Format shade scale               FO30 111
IF((BUFIN(7)>0.)&(BUFIN(7)<=5.)) NCOLM=NINT(BUFIN(7))# Col/pt           FO30 112
IF((BUFIN(8)>0.)&(BUFIN(8)<=3.)) ISPACE=NINT(BUFIN(8))# Spaces/line     FO30 113
IF(BUFIN(11)<voidflg:)#                Test for map character           FO30 114
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FO30 115
stringlim:(11,BEGIN,ENDD)#             Find character postion           FO30 116
movechar:(CHRIN,BEGIN,MAPCHR,1,1,0)#   Save it                          FO30 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FO30 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FO30 119
ELSE  BREAK#                           End line                         FO30 120
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FO30 121
#                                                                       FO30 122
IF(PRINT==no:&SFILE==no:) iquit:(FO3015)# No output has been request    FO30 123
SPACE=ISPACE-1#                        Number of blanks between lines   FO30 124
IF(ISUM1+ISUM2+ISUM3!=6) iquit:(FO3005)# Nonsense summation order       FO30 125
IF(ISUM1*ISUM2*ISUM3!=6) iquit:(FO3005)# Nonsense summation order       FO30 126
#                                                                       FO30 127
REV(ISUM1)=1 ; REV(ISUM2)=2 ; REV(ISUM3)=3# Summation order             FO30 128
JSUM1=REV(1) ; JSUM2=REV(2) ; JSUM3=REV(3)# Permutation indices         FO30 129
DO J=1,3#                              Create output scanning order     FO30 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FO30 131
K=REV(J)#                              Scanning order                   FO30 132
NPTS(J)=NPTX(K)#                       Points                           FO30 133
IORGS(J)=IORGX(K)#                     Origins                          FO30 134
INCS(J)=INCX(K)#                       Increments                       FO30 135
NGS(J)=NGX(K)#                         Grids                            FO30 136
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FO30 137
#                                                                       FO30 138
IF(SFILE==yes:)#                       Make new lr21 corresponding      FO30 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FO30 140
writepkt:(4,21,23,JPT)#                Write to filed                   FO30 141
DO J=1,3#                                                               FO30 142
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FO30 143
JPTR=JPT+J#                            Increment pointer                FO30 144
QX(JPTR)=FLOAT(IORGS(J))#              Origins in scanning order        FO30 145
QX(JPTR+3)=FLOAT(INCS(J))#             Increments in scanning order     FO30 146
QX(JPTR+6)=FLOAT(NGS(J))#              Grids in scanning order          FO30 147
QX(JPTR+9)=FLOAT(NPTS(J))#             Points in scanning order         FO30 148
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FO30 149
QX(JPT+13)=FLOAT(ISUM1)#               Summation order indices          FO30 150
QX(JPT+14)=FLOAT(ISUM2)#                                                FO30 151
QX(JPT+15)=FLOAT(ISUM3)#                                                FO30 152
QX(JPT+16)=FLOAT(JSUM1)#               Permutation indices              FO30 153
QX(JPT+17)=FLOAT(JSUM2)#                                                FO30 154
QX(JPT+18)=FLOAT(JSUM3)#                                                FO30 155
QX(JPT+19)=UPLIM#                      Upper limit for map output       FO30 156
QX(JPT+20)=LOLIM#                      Lower limit for map output       FO30 157
QX(JPT+21)=FLOAT(CTYPE)#               Type of map                      FO30 158
QX(JPT+22)=F000#                       F000                             FO30 159
QX(JPT+23)=PASSES#                     Number of passes required        FO30 160
QX(JPT+24)=SKAL#                       Scale for output map             FO30 161
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FO30 162
#                                                                       FO30 163
#         TELL THE USER EVERYTHING                                      FO30 164
#         ------------------------                                      FO30 165
#                                                                       FO30 166
movechar:(FO039,15,CHROT,2,NFO036-1,2)# Blank out chrot                 FO30 167
writeline:(1,FO036,NFO036,2,3)#        Output map layout                FO30 168
REV(1)=ISUM1 ; REV(2)=ISUM2 ; REV(3)=ISUM3# Store directions in array   FO30 169
DO I=1,3#                                                               FO30 170
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FO30 171
movechar:(FO039,I,FO037,18,1,0)#       Encode x,y,z                     FO30 172
movechar:(FO039,(REV(I)-1)*6+4,FO037,27,6,0)# Encode direction          FO30 173
ncodefld:(FLOAT(NGX(I)),1,FO037,470313.,1)# Encode grid number          FO30 174
writeline:(0,FO037,NFO037,3,3)#        Print output orientation         FO30 175
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FO30 176
DO I=1,3#                                                               FO30 177
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FO30 178
movechar:(FO039,I,FO038,19,1,0)#       Encode x,y,z                     FO30 179
BUFOT(1)=FLOAT(IORGX(I))#              Origins                          FO30 180
BUFOT(2)=FLOAT(IORGX(I)+NPTX(I)-1)#    End points                       FO30 181
BUFOT(3)=FLOAT(INCX(I))#               Increments                       FO30 182
ncodefld:(BUFOT,1,FO038,FMT1,3)#       Encode                           FO30 183
writeline:(0,FO038,NFO038,3,3)#        Output                           FO30 184
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FO30 185
IF(PRINT==yes:)#                                                        FO30 186
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FO30 187
movechar:(FO03E,FORMAT*6-5,FO03A,28,6,0)# Print type                    FO30 188
IF(FORMAT==3)#                         If shaded                        FO30 189
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FO30 190
movechar:(FO03E,20,FO03A,36,5,0)#      Move 'incr.' across              FO30 191
ncodefld:(FORSCL,1,FO03A,440413.,1)#   Encode increment                 FO30 192
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FO30 193
writeline:(1,FO03A,NFO03A,3,3)#        Output print format              FO30 194
BUFOT(1)=FLOAT(NCOLM)#                 Col/pt                           FO30 195
BUFOT(2)=FLOAT(ISPACE)#                Line/pt                          FO30 196
ncodefld:(BUFOT,1,FO03D,FMT2,2)#       Encode col/pt line/pt            FO30 197
writeline:(0,FO03D,NFO03D,3,3)#        Write col/pt line/pt             FO30 198
ncodefld:(SKAL,1,FO03C,380832.,1)#     Encode print scale               FO30 199
writeline:(0,FO03C,NFO03C,3,3)#        Output printer scale             FO30 200
ncodefld:(UPLIM,1,FO03B,350702.,1)#    Encode density upper limit       FO30 201
ncodefld:(LOLIM,1,FO03B,430702.,1)#    Encode density lower limit       FO30 202
writeline:(0,FO03B,NFO03B,3,3)#        Output density limits            FO30 203
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FO30 204
RETURN#                                                                 FO30 205
END#                                                                    FO30 206
systemheader:(FO40)#                   Generate new map and output      FO40   1
# ################################################################## #  FO40   2
#                                                                    #  FO40   3
#                               FO40                                 #  FO40   4
#                                                                    #  FO40   5
# ################################################################## #  FO40   6
SUBROUTINE FO40#                       Feb 1982  r.a. alden             FO40   7
include:(AACOMN)#                      Feb 1988  n. spadaccini          FO40   8
include:(FOCOMN)#                                                       FO40   9
#                                                                       FO40  10
INTEGER DENPTR#                        Pointer to current density i     FO40  11
INTEGER GRID#                          Current number of grids          FO40  12
INTEGER I#                             First scanning order index       FO40  13
INTEGER J#                             Second scanning order index      FO40  14
INTEGER K#                             Third scanning order index       FO40  15
INTEGER L#                             Loop index                       FO40  16
INTEGER NLPS#                          Number of lines per section      FO40  17
INTEGER NPPL#                          Maximum number of pnts/line ou   FO40  18
INTEGER NPTR#                          Pointer to density value on      FO40  19
INTEGER NSECTS#                        Number of sections to output     FO40  20
INTEGER SL31#                          Point exists/doesn't yes:/no:    FO40  21
INTEGER QXPTR#                         Pointer to storage location      FO40  22
INTEGER WIDTH#                         Number of points per line        FO40  23
REAL EMAX#                             Maximum electron density on      FO40  24
REAL EMIN#                             Minimum                          FO40  25
REAL FGX(3)#                           Number of grids (real)           FO40  26
REAL FX(3)#                            Current point in map (real)      FO40  27
REAL HKLMAX(3)#                        Coordinates of max map pt        FO40  28
REAL HKLMIN(3)#                        Min map point                    FO40  29
REAL TEST#                             Current new point                FO40  30
REAL VALUE#                            Density of current point         FO40  31
#                                                                       FO40  32
chardata:(FO041, LOWEST SCALED VALUE  =              AT              )# FO40  33
chardata:(FO042, HIGHEST SCALED VALUE =              AT              )# FO40  34
#                                                                       FO40  35
realdata:(FMT1,[340922.])#                                              FO40  36
realdata:(FMT2,[430413.,470413.,510413.])# F                            FO40  37
realdata:(FMT043,[230942.,650942.])#                                    FO40  38
datastuff:#                                                             FO40  39
#                                                                       FO40  40
EMAX = -1.E10#                         Maximum scaled map value         FO40  41
EMIN =  1.E10#                         Minimum scaled map value         FO40  42
MARK3=NSTOP2+1#                        Pointer to start of output map   FO40  43
NSTEP3=NPTS(3)#                        Number of words for output map   FO40  44
NSTOP3=MARK3+NPTS(3)*NPTS(2)#          Pointer to end of output map     FO40  45
incrqx:(I,NSTOP3+1,FO4005)#            Memory for one section           FO40  46
#                                                                       FO40  47
NPPL=(prtcmax:-7)/NCOLM#               Max cols/per page                FO40  48
SHEETS=(NPTS(3)-1)/NPPL+1#             Number sheets/section            FO40  49
IF(PRINT==yes:)  CALL FO41(0)#         Initialize printing routine      FO40  50
#                                                                       FO40  51
NSECTS=NPTS(1)#                        Number of sections,              FO40  52
NLPS=NPTS(2)#                          Lines per section,               FO40  53
WIDTH=NPTS(3)#                         And points per line.             FO40  54
IX(JSUM1)=IORGX(JSUM1)#                Get the section number           FO40  55
#                                                                       FO40  56
DO I=1,NSECTS#                         Loop over the sections           FO40  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FO40  58
QXPTR=MARK3#                           Point to start of output pag     FO40  59
NPTR=QXPTR#                                                             FO40  60
IX(JSUM2)=IORGX(JSUM2)#                Get the line number              FO40  61
DO J=1,NLPS#                           Loop over the lines              FO40  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FO40  63
IX(JSUM3)=IORGX(JSUM3)#                Get the line origin              FO40  64
DO K=1,WIDTH#                          Loop over the points per lin     FO40  65
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FO40  66
DO II=1,3#                                                              FO40  67
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FO40  68
FX(II)=FLOAT(IX(II))#                  Float grid co-ord                FO40  69
FGX(II)=FLOAT(NGX(II))#                Float number of grids            FO40  70
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FO40  71
FOR(JJ=MARKS;JJ<MARK2;JJ=JJ+STEPS)#    Loop over symops                 FO40  72
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FO40  73
NEWX(1)=INT(QX(JJ+1)*FX(1)+QX(JJ+4)*FX(2)+$#                            FO40  74
QX(JJ+7)*FX(3)+QX(JJ+10)*FGX(1))#                                       FO40  75
NEWX(2)=INT(QX(JJ+2)*FX(1)+QX(JJ+5)*FX(2)+$#                            FO40  76
QX(JJ+8)*FX(3)+QX(JJ+11)*FGX(2))#                                       FO40  77
NEWX(3)=INT(QX(JJ+3)*FX(1)+QX(JJ+6)*FX(2)+$#                            FO40  78
QX(JJ+9)*FX(3)+QX(JJ+12)*FGX(3))#                                       FO40  79
SL31 = yes:#                           Presume it will be found         FO40  80
DO II=1,3#                             Loop over x, y, and z            FO40  81
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FO40  82
TEST=NEWX(II)#                         Save point                       FO40  83
GRID=NGX(II)#                          Pick up grid                     FO40  84
#                                                                       FO40  85
#          TRY TO SHIFT THE POINT INTO THE MAP VOLUME STORED            FO40  86
#          -------------------------------------------------            FO40  87
#                                                                       FO40  88
FOR( ;TEST<MAPORG(II);TEST=TEST+GRID)#                                  FO40  89
;#                                                                      FO40  90
FOR( ;TEST>MAPEND(II);TEST=TEST-GRID)#                                  FO40  91
;#                                                                      FO40  92
IF(TEST<MAPORG(II))#                   If it can't be found,            FO40  93
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FO40  94
SL31=no:#                                                               FO40  95
BREAK#                                                                  FO40  96
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FO40  97
NEWX(II)=TEST#                         Re-set the coordinate            FO40  98
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FO40  99
IF(SL31==yes:) BREAK#                  Point found                      FO40 100
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FO40 101
IF(SL31==no:) iquit:(FO4010)#          Point not there                  FO40 102
DENPTR=MARK2+(NEWX(1)-MAPORG(1)) $##                                    FO40 103
+(NEWX(2)-MAPORG(2))*DELTAY $#                                          FO40 104
+(NEWX(3)-MAPORG(3))*DELTAZ+1#                                          FO40 105
QXPTR=QXPTR+1#                         Increment the storage pointe     FO40 106
VALUE=QX(DENPTR)#                      Get the density (unscaled)       FO40 107
QX(QXPTR)=VALUE#                                                        FO40 108
IF(VALUE>EMAX)#                        Keep track of the maximum        FO40 109
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FO40 110
EMAX=VALUE#                                                             FO40 111
DO L=1,3#                                                               FO40 112
HKLMAX(L)=FLOAT(IX(L))#                                                 FO40 113
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FO40 114
#                                                                       FO40 115
IF(VALUE<EMIN)#                        Also of the minimum              FO40 116
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FO40 117
EMIN=VALUE#                                                             FO40 118
DO L=1,3#                                                               FO40 119
HKLMIN(L)=FLOAT(IX(L))#                                                 FO40 120
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FO40 121
IX(JSUM3)=IX(JSUM3)+INCX(JSUM3)#       Get the next point               FO40 122
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FO40 123
IF(SFILE==yes:)#                       If requested, put the line       FO40 124
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FO40 125
writepkt:(4,22,WIDTH,JPT)#                                              FO40 126
movereal:(QX,NPTR+1,QX,JPT+1,WIDTH,1)#                                  FO40 127
NPTR=QXPTR#                                                             FO40 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FO40 129
IX(JSUM2)=IX(JSUM2)+INCX(JSUM2)#       Get the next line number         FO40 130
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FO40 131
IF(PRINT==yes:)  CALL FO41(1)#         Section complete, print          FO40 132
IX(JSUM1)=IX(JSUM1)+INCX(JSUM1)#       Get the next section number      FO40 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FO40 134
#                                                                       FO40 135
#          ALL DONE.  TIDY THINGS UP                                    FO40 136
#          -------------------------                                    FO40 137
#                                                                       FO40 138
BUFOT(1)=EMIN*SKAL#                                                     FO40 139
ncodefld:(BUFOT,1,FO041,FMT1,1)#                                        FO40 140
ncodefld:(HKLMIN,1,FO041,FMT2,3)#                                       FO40 141
writeline:(1,FO041,NFO041,3,3)#                                         FO40 142
BUFOT(1)=EMAX*SKAL#                                                     FO40 143
ncodefld:(BUFOT,1,FO042,FMT1,1)#                                        FO40 144
ncodefld:(HKLMAX,1,FO042,FMT2,3)#                                       FO40 145
writeline:(0,FO042,NFO042,3,3)#                                         FO40 146
#                                                                       FO40 147
readwpkt:(3,endrecord:,PSIZE,IPT,0)#                                    FO40 148
IF(SFILE==yes:)  writepkt:(4,endrecord:,1,JPT)#                         FO40 149
RETURN#                                                                 FO40 150
END#                                                                    FO40 151
systemheader:(FO41)#                   Print output-across page tear    FO41   1
# ################################################################## #  FO41   2
#                                                                    #  FO41   3
#                               FO41                                 #  FO41   4
#                                                                    #  FO41   5
# ################################################################## #  FO41   6
SUBROUTINE FO41(FLAG)#                 Feb 1982  r.a. alden             FO41   7
include:(AACOMN)#                      Feb 1988  n. spadaccini          FO41   8
include:(FOCOMN)#                                                       FO41   9
#                                                                       FO41  10
INTEGER AXIS#                          Axis pointer                     FO41  11
INTEGER CHRPTR#                        Shaded character pointer         FO41  12
INTEGER COLM#                          Pointer to next heading          FO41  13
INTEGER COLPTR#                        Pointer to current column        FO41  14
INTEGER FLAG#                          =0 initialize routine,=1 print   FO41  15
INTEGER HED#                           Column heading                   FO41  16
INTEGER I#                             Loop index of layer              FO41  17
INTEGER IPTS3#                         Number of points across          FO41  18
INTEGER J#                             Loop index down a sheet          FO41  19
INTEGER K#                             Loop index across a sheet        FO41  20
INTEGER LINE#                          Current line number              FO41  21
INTEGER NCHARS#                        Number of characters needed      FO41  22
INTEGER NP3#                           Number of points across page     FO41  23
INTEGER NWORDS#                        Number of words to hold ncha     FO41  24
INTEGER ORD#                           Pointer to current ordinal       FO41  25
INTEGER PTR#                           Pointer to current start of      FO41  26
INTEGER QXPTR#                         Pointer to current point bei     FO41  27
INTEGER STARTL#                        Ptr. to start of stored line     FO41  28
INTEGER WIDTH#                         Number of points across the      FO41  29
REAL FMT131(1)#                        Formats                          FO41  30
REAL VALUE#                            Scaled output point value        FO41  31
#                                                                       FO41  32
string:(HEDING,70)#                    Lead line on each sheet          FO41  33
chardata:(COL,     )#                                                   FO41  34
chardata:(FO131, X =     IN      S       Y DOWN IN      S       $#      FO41  35
Z ACROSS IN      S)#                                                    FO41  36
chardata:(FO132,XYZUVW)#                                                FO41  37
chardata:(FO133,THSTNDRDTHTHTHTHTHTH)##                                 FO41  38
chardata:(FO134,@ZYX-.+ABC*)#                                           FO41  39
intdata:(IPTS2,[0])#                   Number of lines per section      FO41  40
intdata:(DELTA,[0])#                   Number of points across a        FO41  41
realdata:(STARTF,[0.0])#               Format for 1st point on          FO41  42
realdata:(INCF,[0.0])#                 Format incrementer across li     FO41  43
realdata:(FMT132,[150413.,380413.,630413.])#                            FO41  44
realdata:(FMT133,[80413.,40313.])#                                      FO41  45
datastuff:#                                                             FO41  46
#                                                                       FO41  47
IF(FLAG == 0)#                                                          FO41  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FO41  49
NCHARS=NPTS(3)*NCOLM#                  Chars for full heading           FO41  50
MARK4=NSTOP3+1#                        Pointer to heading location      FO41  51
NSTEP4=1#                              Qx increment                     FO41  52
NWORDS=(NCHARS-1)/mxchwd:+1#           Number of words                  FO41  53
NCHARS=NWORDS*mxchwd:#                                                  FO41  54
NSTOP4=MARK4+NWORDS#                                                    FO41  55
incrqx:(I,NSTOP4+1,FO4105)#            Reserve space for heading        FO41  56
movector:(BLANK,1,QX(MARK4+1),1,NCHARS,1)# Blank column heading         FO41  57
FMT131(1)=FLOAT(NCOLM)*10100.+13.#     Format                           FO41  58
HED=IORGS(3)-INCS(3)#                                                   FO41  59
COLM=1#                                                                 FO41  60
#                                                                       FO41  61
NP3 = NPTS(3)#                         Move to unsubscripted variab     FO41  62
DO I=1,NP3#                            Create the column heading        FO41  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FO41  64
HED=HED+INCS(3)#                                                        FO41  65
movechar:(BLANK,1,COL,1,NCOLM,1)#                                       FO41  66
BUFOT(1)=FLOAT(HED)#                                                    FO41  67
ncodefld:(BUFOT,1,COL,FMT131(1),1)#                                     FO41  68
movector:(COL,1,QX(MARK4+1),COLM,NCOLM,0)#                              FO41  69
COLM=COLM+NCOLM#                                                        FO41  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FO41  71
#                                                                       FO41  72
movechar:(FO131,1,HEDING,1,NFO131,0)#  Pick up the bare sheet headi     FO41  73
DO I=1,3#                              Stuff in the grids               FO41  74
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FO41  75
BUFOT(I)=FLOAT(NGS(I))#                                                 FO41  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FO41  77
ncodefld:(BUFOT,1,HEDING,FMT132(1),3)#                                  FO41  78
#                                                                       FO41  79
AXIS=JSUM1+PATT#                       Get proper axes names            FO41  80
movechar:(FO132,AXIS,HEDING,2,1,0)#    Patt=3, get uvw                  FO41  81
AXIS=JSUM2+PATT#                       Otherwise xyz                    FO41  82
movechar:(FO132,AXIS,HEDING,26,1,0)#                                    FO41  83
AXIS=JSUM3+PATT#                                                        FO41  84
movechar:(FO132,AXIS,HEDING,49,1,0)#                                    FO41  85
#                                                                       FO41  86
IF((NGS(1)>10)&(NGS(1)<14)) ORD=1#     Ordinal suffixes                 FO41  87
ELSE ORD=MOD(NGS(1),10)*2+1#                                            FO41  88
movechar:(FO133,ORD,HEDING,16,2,0)#                                     FO41  89
IF((NGS(2)>10)&(NGS(2)<14)) ORD=1#                                      FO41  90
ELSE ORD=MOD(NGS(2),10)*2+1#                                            FO41  91
movechar:(FO133,ORD,HEDING,39,2,0)#                                     FO41  92
IF((NGS(3)>10)&(NGS(3)<14)) ORD=1#                                      FO41  93
ELSE  ORD=MOD(NGS(3),10)*2+1#                                           FO41  94
movechar:(FO133,ORD,HEDING,64,2,0)#                                     FO41  95
#                                                                       FO41  96
IPTS2=NPTS(2)#                         Number of lines per sheet        FO41  97
DELTA=NPTS(3)#                         Number of points per section     FO41  98
IF(FORMAT==2)  STARTF=70116.#          Packed output format             FO41  99
ELSE  STARTF=FLOAT(NCOLM)*100.+70013.# Normal output format             FO41 100
INCF=FLOAT(NCOLM)*10000.#              Format incrementer               FO41 101
movechar:(MAPCHR,1,FO134,6,1,0)#       Save map character               FO41 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FO41 103
ELSE#                                  Process a section                FO41 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FO41 105
IPTS3=NPTS(3)#                         Number of points per section     FO41 106
PTR=1#                                 Initialize column heading pt     FO41 107
STARTL=MARK3#                          Start of section in qx           FO41 108
#                                                                       FO41 109
movechar:(BLANK,1,HEDING,5,4,1)#       Blank out                        FO41 110
BUFOT(1)=FLOAT(IX(JSUM1))#                                              FO41 111
ncodefld:(BUFOT,1,HEDING,FMT133(1),1)# Encode section number            FO41 112
#                                                                       FO41 113
FOR(I=SHEETS;I>0;I=I-1)#               Loop over the sheets             FO41 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FO41 115
LINE=IORGS(2)-INCS(2)#                 Initialize line number           FO41 116
WIDTH=(IPTS3-1)/I+1#                   Number of points on this lin     FO41 117
LINCT=0#                               Force a new sheet                FO41 118
writeline:(1,HEDING,NFO131,3,3)#       Write first heading              FO41 119
NCHARS=WIDTH*NCOLM#                    Chars in current column          FO41 120
movertoc:(QX(MARK4+1),PTR,CHROT,8,NCHARS,0)#                            FO41 121
writeline:(1,0,0,1,3)#                 Column heading                   FO41 122
LINCT=10000#                           Force write over tear            FO41 123
#                                                                       FO41 124
DO J=1,IPTS2#                          Loop over lines per sheet        FO41 125
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FO41 126
LINE=LINE+INCS(2)#                     Current line number              FO41 127
BUFOT(1)=FLOAT(LINE)#                                                   FO41 128
ncodefld:(BUFOT,1,CHROT,FMT133(2),1)#                                   FO41 129
FMT131(1)=STARTF#                      Initialize format                FO41 130
COLPTR=7#                                                               FO41 131
QXPTR=STARTL#                          Point to 1st point on line       FO41 132
DO K=1,WIDTH#                          Loop over points                 FO41 133
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FO41 134
QXPTR=QXPTR+1#                         Increment storage pointer        FO41 135
FMT131(1)=FMT131(1)+INCF#              Increment format                 FO41 136
COLPTR=COLPTR+NCOLM#                   And column pointer.              FO41 137
#                                                                       FO41 138
VALUE=QX(QXPTR)*SKAL#                  Scale value                      FO41 139
IF(VALUE>UPLIM\VALUE<LOLIM)#           Encode if required               FO41 140
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FO41 141
IF(FORMAT<3)#                          Normal or packed output          FO41 142
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FO41 143
BUFOT(1)=VALUE#                                                         FO41 144
ncodefld:(BUFOT,1,CHROT,FMT131(1),1)#                                   FO41 145
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FO41 146
ELSE#                                  Shaded output wanted             FO41 147
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FO41 148
IF(VALUE>UPLIM) CHRPTR=MIN0(NINT((VALUE-UPLIM)/FORSCL)+7,11)#           FO41 149
ELSE CHRPTR=MAX0(NINT((VALUE-LOLIM)/FORSCL)+5,1)#                       FO41 150
movechar:(FO134,CHRPTR,CHROT,COLPTR,1,0)# Insert chars in buffer        FO41 151
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FO41 152
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FO41 153
ELSE  movechar:(FO134,6,CHROT,COLPTR,1,0)# Insert map character         FO41 154
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FO41 155
writeline:(SPACE,0,0,1,3)#             Write the line                   FO41 156
STARTL=STARTL+DELTA#                                                    FO41 157
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FO41 158
#                                                                       FO41 159
movertoc:(QX(MARK4+1),PTR,CHROT,8,NCHARS,0)#                            FO41 160
writeline:(1,0,0,1,3)#                                                  FO41 161
PTR=PTR+NCHARS#                                                         FO41 162
STARTL=MARK3+WIDTH#                                                     FO41 163
IPTS3=IPTS3-WIDTH#                                                      FO41 164
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FO41 165
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FO41 166
#                                                                       FO41 167
RETURN#                                                                 FO41 168
END#                                                                    FO41 169
pmacro:([no:])#                        Purge xtal system macros         FO41 170
