systemheader:(FT    )#                                                  FT     1
####################################################################### FT     2
#                                                                     # FT     3
#                            *** FOSTAT ***                           # FT     4
#                                                                     # FT     5
# THE PROGRAM FOSTAT PRODUCES STATISTICS ON THE DISTRIBUTION OF       # FT     6
#  INTENSITIES IN A FOURIER MAP.  THE MAIN USE OF THIS PROGRAM IS TO  # FT     7
#  PROVIDE INFORMATION THAT MAY SUBSEQUENTLY BE USED TO DETERMINE     # FT     8
#  APPROPRIATE SCALING FACTORS AND PRINT SUPPRESSION LIMITS FOR A     # FT     9
#  MAP.  INFORMATION MAY ALSO BE USED TO SET LIMITS FOR PEKPIK.       # FT    10
#                                                                     # FT    11
####################################################################### FT    12
#                                                                       FT    13
include:(XMACRO)#                                                       FT    14
#                                                                       FT    15
systemheader:(FT00)#                                                    FT00   1
# ################################################################## #  FT00   2
#                                                                    #  FT00   3
#                               FT00                                 #  FT00   4
#                                                                    #  FT00   5
# ################################################################## #  FT00   6
SUBROUTINE FT00#                       Mar 1982  r.a. alden             FT00   7
include:(AACOMN)#                                                       FT00   8
#                                                                       FT00   9
INTEGER DENPTR#                        Pointer to current electron      FT00  10
#                                         Density value.                FT00  11
INTEGER I#                             Loop index                       FT00  12
INTEGER IPT#                           Input packet pointer             FT00  13
INTEGER MARK1#                         Pointer to start of statisti     FT00  14
#                                         Table.                        FT00  15
INTEGER MXSLOT#                        Total number of slots to hol     FT00  16
#                                         Statistics.                   FT00  17
INTEGER NSLOT#                         Slot to which current densit     FT00  18
#                                         Belongs.                      FT00  19
INTEGER NSLOTS#                        Number of slots to divide        FT00  20
#                                         Densities into.               FT00  21
INTEGER NSTOP1#                        Pointer to end of statistics     FT00  22
#                                         Table.                        FT00  23
INTEGER PSIZE#                         Input packet size                FT00  24
INTEGER PTR#                           Pointer into statistics tabl     FT00  25
REAL ABOVE#                            Number of points above the       FT00  26
#                                         Current density.              FT00  27
REAL AVG#                              Mean scaled electron density     FT00  28
REAL PCT#                              Factor for converting to         FT00  29
#                                         Percentage.                   FT00  30
REAL PERCNT#                           Per cent of points in curren     FT00  31
#                                         Slot and above.               FT00  32
REAL PT#                               Number of values in current      FT00  33
#                                         Slot.                         FT00  34
REAL PTS#                              Total number of points in ma     FT00  35
REAL RHO#                              Current scaled electron dens     FT00  36
REAL RMS#                              Rms std. dev. of a single pt     FT00  37
REAL SIG#                              Std. dev. of the mean pt. va     FT00  38
REAL START#                            Lowest electron density valu     FT00  39
#                                         Considered.                   FT00  40
REAL SUM#                              Sum of scaled electron           FT00  41
#                                         Densities.                    FT00  42
REAL VALUE#                            Biased electron density          FT00  43
REAL WIDTH#                            Width of each slot               FT00  44
REAL MAXDEN,MINDEN#                    Max/min densities                FT00  45
#                                                                       FT00  46
chardata:(FT001, END    )#                                              FT00  47
chardata:(FT002,[ THERE WILL BE      SLOTS OF WIDTH      , $#           FT00  48
BEGINNING AT A VALUE OF])#                                              FT00  49
chardata:(FT003, THE INPUT ELECTRON DENSITY WILL BE SCALED BY)#         FT00  50
chardata:(FT004,100.)#                                                  FT00  51
chardata:(FT005, THE TOTAL NO. OF POINTS CONSIDERED WAS)#               FT00  52
chardata:(FT006, THE MEAN POINT VALUE IS)#                              FT00  53
chardata:(FT007, RMS STANDARD DEVIATION OF A SINGLE POINT   =)#         FT00  54
chardata:(FT008, STANDARD DEVIATION OF THE MEAN POINT VALUE =)#         FT00  55
chardata:(FT009, THE MINIMUM DENSITY VALUE IS)#                         FT00  56
chardata:(FT010, THE MAXIMUM DENSITY VALUE IS)#                         FT00  57
realdata:(FMT001,[190513.,400622.,#                                     FT00  58
730822.,540942.])#                                                      FT00  59
realdata:(FMT002,[250613.,380713.])#                                    FT00  60
realdata:(FMT003,[50513.,171212.,#                                      FT00  61
250813.,380713.,501222.])#                                              FT00  62
realdata:(FMT004,[470813.,360932.,530732.])#                            FT00  63
realdata:(NUL,[0.0])#                  Holds zero                       FT00  64
datastuff:#                                                             FT00  65
#                                                                       FT00  66
FILEXT(IOUNIT(3))='MAP'#               Default ext for input map        FT00  67
#                                                                       FT00  68
IOMARK(3)=QXSTR#                       Input bdf buffer                 FT00  69
MARK1=IOMARK(3)+bdfbuf:#                                                FT00  70
#                                                                       FT00  71
#   PROCESS INPUT PARAMETERS                                            FT00  72
#   ------------------------                                            FT00  73
#                                                                       FT00  74
ifvo:(BUFIN(1))  BUFIN(1)=1000.#       Slots for densities              FT00  75
NSLOTS=NINT(BUFIN(1))#                                                  FT00  76
IF(NSLOTS<1 \ NSLOTS>1000) NSLOTS=1000#                                 FT00  77
ifvo:(BUFIN(2))  BUFIN(2)=1.#          Span of each slot                FT00  78
WIDTH=BUFIN(2)#                                                         FT00  79
IF(WIDTH<0.01 \ WIDTH>FLOAT(NSLOTS))  WIDTH=1.#                         FT00  80
ifvo:(BUFIN(3))  BUFIN(3)=-500.#                                        FT00  81
START=BUFIN(3)#                                                         FT00  82
ifnv:(BUFIN(4)) SCALE=BUFIN(4)#                                         FT00  83
ELSE#                                                                   FT00  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FT00  85
readwpkt:(3,21,PSIZE,IPT,0)#           Read scale from bdf              FT00  86
IF(IPT<=0) iquit:(FT0001)#             Record missing                   FT00  87
SCALE=1.#                                                               FT00  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FT00  89
IF(SCALE <= 0.)  iquit:(FT0002)#                                        FT00  90
#                                                                       FT00  91
movechar:(FT002,1,CHROT,1,NFT002,0)#                                    FT00  92
BUFOT(1)=FLOAT(NSLOTS)#                                                 FT00  93
BUFOT(2)=WIDTH#                                                         FT00  94
BUFOT(3)=START#                                                         FT00  95
ncodefld:(BUFOT,1,CHROT,FMT001(1),3)##                                  FT00  96
writeline:(1,0,0,1,3)#                                                  FT00  97
#                                                                       FT00  98
ifne:(SCALE,1.)#                                                        FT00  99
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FT00 100
movechar:(FT003,1,CHROT,1,NFT003,0)#                                    FT00 101
ncodefld:(SCALE,1,CHROT,FMT001(4),1)##                                  FT00 102
writeline:(1,0,0,1,3)#                                                  FT00 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FT00 104
#                                                                       FT00 105
# ALLOW AN EXTRA SLOT AT EACH END OF THE TABLE TO HOLD THOSE            FT00 106
#  ELECTRON DENSITY VALUES WHICH ARE NOT IN THE REQUESTED RANGE.        FT00 107
#                                                                       FT00 108
MXSLOT=NSLOTS+2#                                                        FT00 109
SUM=0.#                                Initializations                  FT00 110
PTS=0.; MAXDEN=-1000000.; MINDEN=1000000.#                              FT00 111
NSTOP1=MARK1+MXSLOT#                                                    FT00 112
incrqx:(I,NSTOP1+1,FT0003)#            Request the space                FT00 113
movereal:(NUL,1,QX,MARK1+1,MXSLOT,2)#                                   FT00 114
readline:(FT001,NFT001)#               Read the end line                FT00 115
#                                                                       FT00 116
#     READ THE MAP                                                      FT00 117
#     ------------                                                      FT00 118
#                                                                       FT00 119
REPEAT#                                Read in the map first time       FT00 120
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FT00 121
readwpkt:(3,22,PSIZE,IPT,0)#                                            FT00 122
IF(IPT <= 0)  BREAK#                                                    FT00 123
DENPTR=IPT#                                                             FT00 124
DO I=1,PSIZE#                          Sum up densities                 FT00 125
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FT00 126
DENPTR=DENPTR+1#                                                        FT00 127
SUM=SUM+QX(DENPTR)#                                                     FT00 128
MAXDEN=MAX(MAXDEN,QX(DENPTR))#         Get max density                  FT00 129
MINDEN=MIN(MINDEN,QX(DENPTR))#         Get min density                  FT00 130
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FT00 131
PTS=PTS+FLOAT(PSIZE)#                  Increment point count            FT00 132
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FT00 133
#                                                                       FT00 134
AVG=SCALE*SUM/PTS#                     Mean point value                 FT00 135
MAXDEN=MAXDEN*SCALE;  MINDEN=MINDEN*SCALE# Scale max/min                FT00 136
rewindbdf:(3)#                         Reset to start for 2nd read      FT00 137
SUM=0.#                                Initialize rms sum               FT00 138
#                                                                       FT00 139
#    READ THE MAP AGAIN                                                 FT00 140
#    ------------------                                                 FT00 141
#                                                                       FT00 142
REPEAT#                                Read map a second time           FT00 143
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FT00 144
readwpkt:(3,22,PSIZE,IPT,0)#                                            FT00 145
IF(IPT <= 0)  BREAK#                                                    FT00 146
DENPTR=IPT#                                                             FT00 147
DO I=1,PSIZE#                          Fill up the table                FT00 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FT00 149
DENPTR=DENPTR+1#                                                        FT00 150
RHO=SCALE*QX(DENPTR)#                  Scaled density                   FT00 151
SUM=SUM+(RHO-AVG)**2#                  Sum for rms std. deviation       FT00 152
VALUE=RHO-START#                       Biased density                   FT00 153
IF(VALUE<0.)  NSLOT=1#                 If off top end of table          FT00 154
ELSE#                                                                   FT00 155
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FT00 156
NSLOT=NINT(VALUE/WIDTH)+2#             Find proper slot                 FT00 157
IF(NSLOT>MXSLOT)  NSLOT=MXSLOT#        If off bottom end of table.      FT00 158
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FT00 159
PTR=MARK1+NSLOT#                       Table pointer                    FT00 160
QX(PTR)=QX(PTR)+1.#                    Increment count                  FT00 161
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FT00 162
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FT00 163
#                                                                       FT00 164
PCT=100./PTS#                          Percentage factor                FT00 165
#                                                                       FT00 166
CALL FT01#                             Print heading                    FT00 167
#                                                                       FT00 168
PTR=MARK1+1#                           Point to start of table          FT00 169
PT=QX(PTR)#                            Any points off top of table      FT00 170
ifne:(PT,0.)#                          Get printed first.               FT00 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FT00 172
BUFOT(1)=PT#                                                            FT00 173
BUFOT(2)=PTS#                                                           FT00 174
ncodefld:(BUFOT,1,CHROT,FMT002(1),2)##                                  FT00 175
movechar:(FT004,1,CHROT,45,NFT004,0)#                                   FT00 176
writeline:(0,0,0,1,3)#                                                  FT00 177
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FT00 178
#                                                                       FT00 179
DO I=1,NSLOTS#                         Loop through table proper        FT00 180
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FT00 181
PTR=PTR+1#                                                              FT00 182
IF(QX(PTR)>0.)#                        Print only those slots with      FT00 183
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FT00 184
ABOVE=PTS-PT#                          Number of points in this slo     FT00 185
PT=PT+QX(PTR)#                         And above and the                FT00 186
PERCNT=ABOVE*PCT#                      Percentage.                      FT00 187
IF(LINCT<2)  CALL FT01#                Print new heading, if needed     FT00 188
BUFOT(1)=FLOAT(I)#                                                      FT00 189
BUFOT(2)=START#                                                         FT00 190
BUFOT(3)=QX(PTR)#                                                       FT00 191
BUFOT(4)=ABOVE#                                                         FT00 192
BUFOT(5)=PERCNT#                                                        FT00 193
ncodefld:(BUFOT,1,CHROT,FMT003(1),5)##                                  FT00 194
writeline:(0,0,0,1,3)#                                                  FT00 195
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FT00 196
#                                                                       FT00 197
START=START+WIDTH#                     Next slot density                FT00 198
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FT00 199
#                                                                       FT00 200
PTR=MARK1+MXSLOT#                      Values off bottom of table       FT00 201
IF(QX(PTR)>0.)#                                                         FT00 202
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FT00 203
PERCNT=QX(PTR)*PCT#                                                     FT00 204
IF(LINCT<2)  CALL FT01#                Print heading, if needed         FT00 205
BUFOT(1)=START#                                                         FT00 206
BUFOT(2)=QX(PTR)#                                                       FT00 207
BUFOT(3)=QX(PTR)#                                                       FT00 208
BUFOT(4)=PERCNT#                                                        FT00 209
ncodefld:(BUFOT,1,CHROT,FMT003(2),4)##                                  FT00 210
writeline:(0,0,0,1,3)#                                                  FT00 211
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FT00 212
#                                                                       FT00 213
LINRM=6#                               Enough room for summary          FT00 214
movechar:(FT005,1,CHROT,1,NFT005,0)#   Total number of points           FT00 215
ncodefld:(PTS  ,1,CHROT,FMT004(1),1)##                                  FT00 216
writeline:(1,0,0,1,3)#                                                  FT00 217
#                                                                       FT00 218
movechar:(FT006,1,CHROT,1,NFT006,0)#   Mean scaled electron density     FT00 219
ncodefld:(AVG  ,1,CHROT,FMT004(2),1)##                                  FT00 220
writeline:(0,0,0,1,3)#                                                  FT00 221
#                                                                       FT00 222
movechar:(FT009,1,CHROT,1,NFT009,0)#   Min scaled electron density      FT00 223
ncodefld:(MINDEN,1,CHROT,FMT004(2),1)##                                 FT00 224
writeline:(0,0,0,1,3)#                                                  FT00 225
#                                                                       FT00 226
movechar:(FT010,1,CHROT,1,NFT010,0)#   Max scaled electron density      FT00 227
ncodefld:(MAXDEN,1,CHROT,FMT004(2),1)##                                 FT00 228
writeline:(0,0,0,1,3)#                                                  FT00 229
#                                                                       FT00 230
RMS=SQRT(SUM/PTS)#                     Rms standard deviation           FT00 231
movechar:(FT007,1,CHROT,1,NFT007,0)#                                    FT00 232
ncodefld:(RMS  ,1,CHROT,FMT004(3),1)##                                  FT00 233
writeline:(1,0,0,1,3)#                                                  FT00 234
#                                                                       FT00 235
SIG=SQRT(SUM/(PTS*(PTS-1)))#           Standard deviation of mean       FT00 236
movechar:(FT008,1,CHROT,1,NFT008,0)#                                    FT00 237
ncodefld:(SIG  ,1,CHROT,FMT004(3),1)##                                  FT00 238
writeline:(0,0,0,1,3)#                                                  FT00 239
readwpkt:(3,endrecord:,PSIZE,IPT,0)#   Finish off second read           FT00 240
#                                                                       FT00 241
RETURN#                                                                 FT00 242
END#                                                                    FT00 243
systemheader:(FT01)#                                                    FT01   1
# ################################################################## #  FT01   2
#                                                                    #  FT01   3
#                               FT01                                 #  FT01   4
#                                                                    #  FT01   5
# ################################################################## #  FT01   6
SUBROUTINE FT01#                       Print a 3-line heading           FT01   7
#                                        Mar 1982  r.a. alden           FT01   8
include:(AACOMN)#                                                       FT01   9
#                                                                       FT01  10
chardata:(FT011,MIN.                 NO. IN    PER CENT)#               FT01  11
chardata:(FT012,SLOT       SLOT    NO. IN      SLOT AND     OF)#        FT01  12
chardata:(FT013,NO.       VALUE    SLOT        ABOVE      TOTAL)#       FT01  13
datastuff:#                                                             FT01  14
#                                                                       FT01  15
LINRM=3#                                                                FT01  16
movechar:(FT011,1,CHROT,13,NFT011,0)#                                   FT01  17
writeline:(1,0,0,1,3)#                                                  FT01  18
movechar:(FT012,1,CHROT,2,NFT012,0)#                                    FT01  19
writeline:(0,0,0,1,3)#                                                  FT01  20
movechar:(FT013,1,CHROT,3,NFT013,0)#                                    FT01  21
writeline:(0,0,0,1,3)#                                                  FT01  22
#                                                                       FT01  23
RETURN#                                                                 FT01  24
END#                                                                    FT01  25
pmacro:([no:])#                        Purge xtal system macros         FT01  26
