systemheader:(GE    )#                                                  GE     1
####################################################################### GE     2
##      Copyright (C) 2000, The Xtal System, The University of        # GE     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # GE     4
## Distributed under the GNU General Public Licence as published by   # GE     5
## the Free Software Foundation, in the hope that it will be useful   # GE     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # GE     7
## for more details.                                                  # GE     8
#                                                                     # GE     9
#                            *** GENEV ***                            # GE    10
#                                                                     # GE    11
#     GENEV CALCULATES NORMALIZED STRUCTURE FACTORS (E'S)             # GE    12
#     FROM FREL'S.  IT IS ALSO USED TO CALCULATE OVERAL FREL          # GE    13
#     SCALE AND OVERALL ISOTROPIC TEMPERATURE FACTORS.                # GE    14
####################################################################### GE    15
#                                                                       GE    16
include:(XMACRO)#                                                       GE    17
#                                                                       GE    18
extrude:(GECOMN)#                                                       GE    19
REAL B1#                               Estimate of overall tf for e     GE    20
REAL B2#                               Estimate for overall tf for      GE    21
REAL BOVL#                             Input overall t.f.               GE    22
REAL DELB#                             Variance of t.f.                 GE    23
REAL DELS#                             Variance (scale) over k**2       GE    24
REAL DELX#                             Covariance (b,k)                 GE    25
REAL DSNM#                             Data set number                  GE    26
REAL E1#                               Normalized sf 1                  GE    27
REAL E2#                               Normalized sf 2                  GE    28
REAL E1MIN#                            Minimum |e1|                     GE    29
REAL E2MIN#                            Minimum |e2|                     GE    30
REAL ELST#                             Minimum e to be listed           GE    31
REAL FREL#                             F relative                       GE    32
REAL FRAG#                             Packed fragment information      GE    33
REAL FMUL#                             Frel multiplicity                GE    34
REAL FTHR#                             Frel threshold for filling       GE    35
REAL GRID(3)#                          Atom grid intervals              GE    36
REAL H(3)#                             Current h,k,l indices            GE    37
INTEGER EOUT#                          Flag for outputting e to bdf     GE    38
INTEGER I1,I2,I3#                      Start-1 of io buffer 1,2,3       GE    39
INTEGER IBDF#                          Indicates if e1 & e2 sums on     GE    40
INTEGER IBAY#                          Indicates if bayesian stats      GE    41
INTEGER ICNT#                          Cent/noncent flag (1/0)          GE    42
INTEGER ICRV#                          Indicates if curve or linear     GE    43
INTEGER IDSN#                          Data set number as integer       GE    44
INTEGER IFIL#                          Indicates if range filling a     GE    45
INTEGER IRAD#                          Radiation flag 0=xray/1=neut     GE    46
INTEGER IR(41)#                        Relative pointer array           GE    47
INTEGER ISCL#                          Current index scale group        GE    48
INTEGER ITEM#                          Number of items to be update     GE    49
INTEGER IW(40)#                        Want idnum seq array             GE    50
INTEGER IZ(30)#                        Archival update list of idnu     GE    51
INTEGER KEY(4)#                        Indexpkt control signals         GE    52
INTEGER M0#                            Start-1 of overlapped wilson     GE    53
INTEGER M1#                            Start-1 of seitz matrix tabl     GE    54
INTEGER M2#                            Start-1 of celcon table          GE    55
INTEGER M3#                            Start-1 of fragment table        GE    56
INTEGER M4#                            Start-1 of index scale table     GE    57
INTEGER M5#                            Start   of sin/cos lookup ta     GE    58
INTEGER N0#                            End of initial wilson table      GE    59
INTEGER N1#                            Start-1 of ff & scale curves     GE    60
INTEGER N2#                            Start-1 of group scale facto     GE    61
INTEGER N3#                            Start-1 of frag 3 interatom      GE    62
INTEGER NFRG#                          Number of fragments              GE    63
INTEGER NINF#                          Number of inflection points      GE    64
INTEGER NINK#                          Number of index scale groups     GE    65
INTEGER NSCL#                          Number of frel scale groups      GE    66
INTEGER NSCF#                          Number of scattering factors     GE    67
INTEGER NSFF#                          Number stored curves (nscf+2     GE    68
INTEGER NREC#                          Number of words /record of f     GE    69
REAL ORIGIN(3)#                        Current origin of fragment c     GE    70
REAL Q1#                               Population count for rescale     GE    71
REAL Q2#                               Population count for rescale     GE    72
REAL R1#                               Rescale value for e1             GE    73
REAL R2#                               Rescale value for e2             GE    74
REAL RMUL#                             Current reflection multiplic     GE    75
REAL ROTM#                             Number of seitz matrices         GE    76
REAL RVOL#                             Reciprocal cell volume           GE    77
REAL S1#                               Frel scale estimate for e1       GE    78
REAL S2#                               Frel scale estimate for e2       GE    79
REAL FLX1#                             S2 value of inflexion point      GE    80
REAL FLX2#                             S2 value of inflexion point      GE    81
REAL S2L2#                             Current s2t/l2 value             GE    82
REAL S2MX#                             Maximum s2t/l2 processed         GE    83
REAL S2IN#                             S2t/l2 interval (=s2mx/40.)      GE    84
REAL SOVL#                             Input frel scale                 GE    85
REAL SIGF#                             Frel standard deviation          GE    86
REAL STMX#                             Maximum st/l processed           GE    87
REAL STIN#                             St/l interval (=stmx/100.)       GE    88
REAL TOTR#                             Total reflections used           GE    89
#                                                                       GE    90
string:(FFTAB,100)#                    Array to store name string       GE    91
#                                                                       GE    92
COMMON /COMIGE/ I1,I2,I3,M0,M1,M2,M3,M4,M5,N0,N1,N2,N3,#                GE    93
IBDF,IBAY,ICRV,IFIL,ISCL,ITEM,ICNT,IDSN,#                               GE    94
NFRG,NSCF,NSFF,NSCL,NINF,NINK,NREC,EOUT,#                               GE    95
IR,IW,IZ,KEY,IRAD#                                                      GE    96
#                                                                       GE    97
COMMON /COMFGE/ BOVL,FREL,FMUL,FRAG,ELST,DSNM,GRID,ORIGIN,H,#           GE    98
B1,B2,E1,E2,E1MIN,E2MIN,S1,S2,R1,R2,Q1,Q2,DELB,DELS,DELX,#              GE    99
FLX1,FLX2,S2L2,S2MX,S2IN,STMX,STIN,SIGF,SOVL,#                          GE   100
ROTM,RVOL,RMUL,FTHR,TOTR#                                               GE   101
#                                                                       GE   102
COMMON /COMCGE/ FFTAB#                                                  GE   103
endext:#                                                                GE   104
#                                                                       GE   105
systemheader:(GE00)#                   Normalize structure factors      GE00   1
####################################################################    GE00   2
#                                                                  #    GE00   3
#                             GE00                                 #    GE00   4
#                                                                  #    GE00   5
####################################################################    GE00   6
SUBROUTINE GE00#                       S.r.hall  nov 80                 GE00   7
include:(AACOMN)#                                                       GE00   8
include:(GECOMN)#                                                       GE00   9
#                                                                       GE00  10
FILEXT(IOUNIT(3))='XX1'#               Extension for scratch file       GE00  11
#                                                                       GE00  12
CALL GE01#                             Read controls and input bdf      GE00  13
CALL GE02#                             List controls & gen frag vecto   GE00  14
CALL GE03#                             Read refln data from bdf         GE00  15
CALL GE05#                             Calc and graph wilson plot       GE00  16
CALL GE06#                             Calc and output e-values         GE00  17
#                                                                       GE00  18
RETURN#                                                                 GE00  19
END#                                                                    GE00  20
systemheader:(GE01)#                   Image and bdf inputter           GE01   1
####################################################################    GE01   2
#                                                                  #    GE01   3
#                             GE01                                 #    GE01   4
#                                                                  #    GE01   5
####################################################################    GE01   6
SUBROUTINE GE01#                       S.r.hall  nov 80                 GE01   7
include:(AACOMN)#                                                       GE01   8
include:(GECOMN)#                                                       GE01   9
#                                                                       GE01  10
INTEGER I,J,K,M,N,IP,NP#                                                GE01  11
INTEGER IARC,IFR4,IFRG,J2,JBDF,L,MFRG,NTYP3#                            GE01  12
REAL FRGM,S#                                                            GE01  13
REAL A,B#                                                               GE01  14
INTEGER SCLF#                                                           GE01  15
string:(LABEL,24)#                                                      GE01  16
chardata:(EV1, FRAG SITE SITEG SITEA GRID INDEXK END )#                 GE01  17
chardata:(EV2, W R O P B F )#                                           GE01  18
#CHARDATA:(EV3,0123456789)#                                             GE01  19
chardata:(EV4, SMAX DSET LIST FIXU FIXK DIN1 DIN2 $#                    GE01  20
FILL BAYE PROF BEXP NSCL BSCL NLIS NEXP EOUT ENOT )#                    GE01  21
datastuff:#                                                             GE01  22
#                                                                       GE01  23
#   SET DEFAULT PARAMETERS                                              GE01  24
#   ----------------------                                              GE01  25
#                                                                       GE01  26
STMX=2.#                               Default st/l is 2.0              GE01  27
DSNM=1.#                               Default data set is 1.           GE01  28
IBDF=0#                                Default is no bdf in             GE01  29
SCLF=0#                                Default is on                    GE01  30
ELST=100000.#                          Default elist limit              GE01  31
SOVL=0.#                               Default overall scale            GE01  32
BOVL=0.#                               Default overall u value          GE01  33
ICRV=0;      IFIL=0;      IBAY=0#      Default parameters               GE01  34
NINK=0;      ISCL=0;      FTHR=-1.#    Default parameters               GE01  35
GRID(1)=1.;  GRID(2)=1.;  GRID(3)=1.#  Default parameters               GE01  36
FLX1=0.15;   FLX2=0.26#                Default parameters               GE01  37
FRAG=0.0;    FRGM=1.;     IARC=0#      Default parameters               GE01  38
NFRG=0; intpak:(NFRG,FRAG,0,32)#       Default parameters               GE01  39
EOUT=yes:#                             Default output e to bdf          GE01  40
#                                                                       GE01  41
#   EXTRACT GENEV LINE PARAMETERS                                       GE01  42
#   -----------------------------                                       GE01  43
#                                                                       GE01  44
FOR(N=1;N>0;N=N+1)#                    Loop over all input images       GE01  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GE01  46
ifvo:(BUFIN(N)) BREAK#                 Exit no more parameters          GE01  47
ifnm:(BUFIN(N)) iquit:(GE0101,N)#      Must be alpha field first        GE01  48
stringlim:(N,I,J)#                     Get chr string limits            GE01  49
compchar:(CHRIN,I,EV4,2,4,5,NEV4,J)#   Identify input string (wrop)     GE01  50
IF(J<8) N=N+1#                         Incr field pointer               GE01  51
IF(J==0) iquit:(GE0102,N)#             Option not recognised            GE01  52
IF(J==1) STMX=BUFIN(N)#                Extract max st/l for run         GE01  53
IF(J==2) DSNM=BUFIN(N)#                Extract data set number          GE01  54
IF(J==3) ELST=BUFIN(N)#                Extract elist e minimum          GE01  55
IF(J==4) BOVL=BUFIN(N)*79.#            Extract overall u fixed          GE01  56
IF(J==5) SOVL=BUFIN(N)#                Extract overall k fixed          GE01  57
IF(J==6) FLX1=BUFIN(N)#                Extract inflexion pt 1           GE01  58
IF(J==7) FLX2=BUFIN(N)#                Extract inflexion pt 2           GE01  59
IF(J==8) IFIL=1#                       Set fill average on              GE01  60
IF(J==9) IBAY=1#                       Set bayesian  average on         GE01  61
IF(J==10)ICRV=1#                       Set profile interpolation on     GE01  62
IF(J==11)EOUT=1#                       Bdf string entered set fl        GE01  63
IF(J==12)SCLF=1#                       Switch off bdf scales            GE01  64
IF(J==17)EOUT=no:#                     Switch off e output to bdf       GE01  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GE01  66
IF(BOVL>0.\SOVL>0.) ICRV=-1#           Set interpolation to linear      GE01  67
#                                                                       GE01  68
#       ASSIGN BUFFERS AND SET MARKERS                                  GE01  69
#       ----------------------------------                              GE01  70
#                                                                       GE01  71
I1=QXSTR#                              Start buffer at start of qx      GE01  72
IOMARK(1)=I1+1#                        Mark start of buffer1            GE01  73
IOMARK(2)=IOMARK(1)+bdfbuf:#           Mark start of buffer2            GE01  74
IOMARK(3)=IOMARK(2)+bdfbuf:#           Mark start of buffer3            GE01  75
IOMARK(4)=IOMARK(3)+bdfbuf:#           Mark end   of buffer3            GE01  76
I2=IOMARK(2)#                          Set additional buffer2 point     GE01  77
I3=IOMARK(3)#                          Set additional buffer3 point     GE01  78
M0=IOMARK(4)#                          Start of overlapped wilson t     GE01  79
incrqx:(M1,M0+410,GE0105)#             Expand qx ........... 200105     GE01  80
#                                                                       GE01  81
#        READ PARAMETERS FROM BDF                                       GE01  82
#       ----------------------------                                    GE01  83
#                                                                       GE01  84
#                                        ****  cell volume ****         GE01  85
DO I=1,6#                              Skip to sixth packet of lr4      GE01  86
readwpkt:(1,lrcell:,NP,IP,0)#          Point to each packet             GE01  87
RVOL=1./QX(IP+1)#                      Extract cell volume as recip     GE01  88
#                                                                       GE01  89
#                                        **** lrsymm symmetry ****      GE01  90
readwpkt:(1,lrsymm:,NP,IP,0)#          Read record symm: (symmetry)     GE01  91
ICNT=NINT(QX(IP+2))-1#                 Extract centre flag              GE01  92
IF(ICNT!=0) ICNT=1#                    Make centre flag conform to      GE01  93
ROTM=QX(IP+4)#                         Extract num seitz matrices       GE01  94
FMUL=QX(IP+6)#                         Extract s.f. multiplicity        GE01  95
K=M1#                                  Point to start of symmetry t     GE01  96
REPEAT#                                Loop over all matrix package     GE01  97
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GE01  98
readwpkt:(1,lrsymm:,NP,IP,0)#          Point to next packet             GE01  99
IF(IP<=0) BREAK#                       Exit when no more                GE01 100
incrqx:(K,K+NP,GE0112)#                Expand qx ........... 200112     GE01 101
movereal:(QX,IP+1,QX,K-NP+1,NP,1)#     Store in symmetry matrix tab     GE01 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GE01 103
M2=K#                                  Mark start of celcon table       GE01 104
incrqx:(N1,M2+50,GE0112)#              Expand qx .......... 200112      GE01 105
#                                                                       GE01 106
#                                        **** lrscat form factors ****  GE01 107
IW(1)=1; IW(2)=3; IW(3)=11; IW(4)=10#  Want atcon,atnum,ff(0),fn        GE01 108
KEY(1)=0; KEY(2)=4; KEY(3)=0; KEY(4)=0# Set idnum delimiters            GE01 109
indexpkt:(1,lrscat:,NP,IP,0,KEY,IW,IR)# Extract sequence numbers        GE01 110
IF(IR(4)>0) IRAD=1#                    Set radiation to neutron         GE01 111
ELSE        IRAD=0#                    Set radiation to xradiation      GE01 112
J=I2;   A=STMX+.05#                    Set temp store & ff smax         GE01 113
IF(IRAD==0)#                           If xray ff used                  GE01 114
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GE01 115
FOR(I=IP+1;I<=IP+NP;I=I+1)#            Loop over lrscat directory       GE01 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GE01 117
IF((QX(I)<99.9)\(QX(I)>299.1)) NEXT#   Skip non-form factors            GE01 118
QX(J+1)=FLOAT(I-IP)#                   Store rel. pointer to ff         GE01 119
QX(J+2)=(QX(I)-100.)/100.#             Convert to st/l                  GE01 120
J=J+2#                                 Incr storage pointer             GE01 121
IF(QX(J)>A) BREAK#                     Exit if s limit reached          GE01 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GE01 123
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GE01 124
ELSE#                                  Else use neutron scatlen         GE01 125
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GE01 126
IF(IR(4)==0) iquit:(GE0116)#           Quit if no neutron ff            GE01 127
L=NINT(A*100.)+5#                      Set limit of data                GE01 128
DO K=0,L,5#                            Loop in incr of .o5 st/l         GE01 129
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GE01 130
QX(J+2)=K;    J=J+2#                   Store st/l*100 in ff table       GE01 131
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GE01 132
IR(2)=IR(4)#                           Atnum becomes neut ff            GE01 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GE01 134
J2=J#                                  Mark start of ff storage         GE01 135
#                                                                       GE01 136
FOR(NSCF=0;NSCF<10;NSCF=NSCF+1)#       Loop over ff types               GE01 137
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GE01 138
readwpkt:(1,lrscat:,NP,IP,0)#          Point to next packet             GE01 139
IF(IP<=0) BREAK#                       Exit if no more                  GE01 140
I=IP+IR(1)#                            Point to atoms per cell          GE01 141
IF(I>IP) QX(NSCF+M2+21)=QX(I)#         Extract atoms per cell           GE01 142
I=IP+IR(2)#                            Point to atomic number           GE01 143
IF(I>IP) QX(NSCF+M2+31)=QX(I)#         Extract atomic number            GE01 144
ELSE#                                  If not there try ff curve        GE01 145
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GE01 146
I=IP+NINT(QX(I2+1))#                   Extract ff(s=0)                  GE01 147
QX(NSCF+M2+31)=QX(I)#                  Extract ff at s=0                GE01 148
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GE01 149
I=IP+IR(3)#                            Point to ff name                 GE01 150
IF(I>IP) movertoc:(QX(I),1,FFTAB,NSCF*8+1,8,0)# Extract the ff name     GE01 151
ELSE     iquit:(GE0113)#               No name......200113              GE01 152
FOR(I=I2;I<J2;I=I+2)#                  Loop over stored points & s      GE01 153
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GE01 154
K=IP+NINT(QX(I+1)); J=J+1#             Extract ff pointers              GE01 155
IF(IRAD==0) QX(J)=QX(K)#               Extract ff & store temp          GE01 156
ELSE        QX(J)=QX(NSCF+M2+31)#      Store neutron ff                 GE01 157
IF(J>=M0) BREAK#                       Exit if temp buffer full         GE01 158
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GE01 159
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GE01 160
NSFF=NSCF+2#                           Count ff curves plus scaling     GE01 161
incrqx:(N2,N1+NSFF*101,GE0114)#        Expand qx .......... 200114      GE01 162
#                                                                       GE01 163
#                                      **** expl group scales ****      GE01 164
incrqx:(I,N2+64,GE0115)#               Expand qx ........... 200115     GE01 165
NSCL=1; QX(N2+1)=1.#                   Set default scale values         GE01 166
IW(1)=1; IW(2)=100; IW(3)=101#         Idnums for dsnm,nscl,scl1        GE01 167
KEY(1)=0; KEY(2)=3; KEY(3)=0; KEY(4)=0# Set want list limits            GE01 168
indexpkt:(1,lrexpl:,NP,IP,0,KEY,IW,IR)# Get sequence of scales          GE01 169
IF(IR(2)>0)#                           If scales exist on bdf           GE01 170
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GE01 171
FOR(I=IP+1;I<=IP+NP;I=I+1)#            Loop over directory packet       GE01 172
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GE01 173
IF((QX(I)<100.9)\(QX(I)>164.1)) NEXT#  Skip if not scale pointer        GE01 174
J=N2+NINT(QX(I))-100#                  Get group number of scale        GE01 175
QX(J)=FLOAT(I-IP)#                     Store relative pointer:          GE01 176
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GE01 177
REPEAT#                                Loop over all lr11 packets       GE01 178
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GE01 179
readwpkt:(1,lrexpl:,NP,IP,0)#          Point to next packet             GE01 180
IF(IP<=0) BREAK#                       Exit if no more                  GE01 181
I=IP+IR(1); ifne:(DSNM,QX(I)) NEXT#    Skip if not requested dsnm       GE01 182
I=IP+IR(2); IF(I>IP) NSCL=NINT(QX(I))# Extract no. scale groups         GE01 183
I=IP+IR(3); IF(I>IP)#                  Test if scale present            GE01 184
FOR(I=N2;I<N2+NSCL;I=I+1)#             Loop over scale groups           GE01 185
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GE01 186
J=IP+NINT(QX(I+1))#                    Point to scale                   GE01 187
IF((J>IP)&(SCLF==0)) QX(I+1)=QX(J)#    Store scale in table             GE01 188
ELSE                 QX(I+1)=1.#       Else store as 1.                 GE01 189
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GE01 190
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GE01 191
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GE01 192
M3=N2+NSCL#                            Mark end of group scales         GE01 193
#                                                                       GE01 194
#                                      **** max sin t/lambda ****       GE01 195
B=STMX#                                Set default maximum value        GE01 196
IW(1)=1;  IW(2)=15;  IW(3)=10#         Idnums for dsnm,smax,fragn       GE01 197
KEY(1)=0 ;KEY(2)=3; KEY(3)=0; KEY(4)=0# Set want list limits            GE01 198
indexpkt:(1,lrdset:,NP,IP,0,KEY,IW,IR)# Get sequ number of st/l         GE01 199
REPEAT#                                Loop over all lr12 packets       GE01 200
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GE01 201
readwpkt:(1,lrdset:,NP,IP,0)#          Point to next packet             GE01 202
IF(IP<=0) BREAK#                       Exit if no more                  GE01 203
I=IP+IR(1); ifne:(DSNM,QX(I)) NEXT#    Test if dataset requested        GE01 204
I=IP+IR(2); IF(I>IP) B=QX(I)+.001#     Store st/l max value             GE01 205
I=IP+IR(3); IF(I>IP)#                  Test if frag present             GE01 206
intunpak:(QX(I),MFRG,0,4)#             Unpack frag count                GE01 207
ELSE MFRG=0#                           Set frag count to zero           GE01 208
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GE01 209
STMX=AMIN1(STMX,B)#                    Ensure st/l max correct          GE01 210
#                                                                       GE01 211
#                                                                       GE01 212
#  FILL FF TABLE WITH INTERPOLATED FORMFACTORS                          GE01 213
#  -------------------------------------------                          GE01 214
#                                                                       GE01 215
STIN=STMX/100.;  J=(J2-I2)/2#          St/l incr & stored intervals     GE01 216
DO I=1,NSCF#                           Loop over all atom types         GE01 217
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GE01 218
S=0.#                                  Current st/l value               GE01 219
N=I2+2;  M=J2+J*(I-1)+1#               +1# set start s & ff values      GE01 220
FOR(K=N1+I;K<N2;K=K+NSFF)#             Loop over 101 st/l values        GE01 221
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GE01 222
WHILE(S>=QX(N+2))#                     Find low pt of input st/l        GE01 223
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GE01 224
N=N+2;   M=M+1#                        Incr s & ff pointers             GE01 225
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GE01 226
QX(K)=QX(M)+(QX(M+1)-QX(M))*(S-QX(N)) $# Calculate ff value             GE01 227
/(QX(N+2)-QX(N))#                      By linear interpolation          GE01 228
S=S+STIN#                              Increment st/l                   GE01 229
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GE01 230
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GE01 231
#                                                                       GE01 232
#          ENTER INPUT IMAGES                                           GE01 233
#         ======================                                        GE01 234
#                                                                       GE01 235
K=M3; M4=M3;  NREC=7#                  Set fragment table pointers      GE01 236
ITEM=MFRG+6#                           Set record20 delete list         GE01 237
DO I=1,30;IZ(I)=-NINT(DSNM)*1000-599-I# Set record20 delete list        GE01 238
NTYP3=0#                               Zero orient frag count           GE01 239
#                                                                       GE01 240
REPEAT#                                Loop over all input images       GE01 241
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GE01 242
readline:(EV1,NEV1)#                   Process next input image         GE01 243
#                                                                       GE01 244
#                                      **** frag image ****             GE01 245
IF(LINID==1)#                          Test if frag image detected      GE01 246
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 GE01 247
IFRG=0;  IFR4=0;  JBDF=no:#            Reset fragment type              GE01 248
DO N=1,2#                              Loop over input fields           GE01 249
IF(BUFIN(N)<voidflg:)#                 Test for active field            GE01 250
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 GE01 251
stringlim:(N,I,J)#                     Get chr string limits            GE01 252
compchar:(CHRIN,I,EV2,2,1,2,NEV2,J)#   Identify input string (wrop)     GE01 253
IF(J==0)    iquit:(GE0118)#            No match .......... 200118       GE01 254
IF(J==IFR4) iquit:(GE0120)#            2x frag4 .......... 200120       GE01 255
IF(J<5)       IFRG=J#                  Test if fragment type set        GE01 256
ELSE IF(J==5) JBDF=yes:#               Atom data from bdf               GE01 257
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 GE01 258
IF(IFRG==0) IFRG=4#                    Default fragment type is 4       GE01 259
IF(IFRG==4) IFR4=4#                    Set fragment 4 flag              GE01 260
IF(IFRG==3) NTYP3=NTYP3+NINT(ROTM)-1#  Count additional f3 wds          GE01 261
NFRG=NFRG+1#                           Count number of fragments        GE01 262
intpak:(NFRG,FRAG,0,4)#                Pack frag count into bits 3-     GE01 263
I=IFRG-1;  J=NFRG*2+2#                 Set packing values               GE01 264
intpak:(I,FRAG,J,2)#                   Pack frag type in bit slice      GE01 265
IF(IFRG==3) NREC=NREC+NINT(ROTM)#      Expand scratch file3 record      GE01 266
ELSE        NREC=NREC+1#               Expand scratch file3 record      GE01 267
QX(M4+1)=FLOAT(K); M4=K#               Reset fragment table pointer     GE01 268
incrqx:(K,K+3,GE0125)#                 Incr qx  .......... 200125       GE01 269
QX(K-1)=FLOAT(IFRG)#                   Store fragment type in table     GE01 270
QX(K  )=BUFIN(3)#                      Store fragment mult. in tabl     GE01 271
IF(QX(K)>1.1&IFRG==3) iquit:(GE0127)#  Illegal.......200127.            GE01 272
IF(QX(K)<small:) QX(K)=1.#             Default multiplicity is 1.       GE01 273
FRGM=QX(K)#                            Save fragment multiplicity       GE01 274
DO N=1,3#                              Loop over each coordinate        GE01 275
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 GE01 276
ORIGIN(N)=BUFIN(N+3)#                  Extract origin from buffer       GE01 277
IF(ORIGIN(N)<=voidflg:) ORIGIN(N)=0.#  Default origin is 0.             GE01 278
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 GE01 279
IF(JBDF==yes:)#                        Test for bdf atoms input         GE01 280
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 GE01 281
IF(IFRG==2) iquit:(GE0130)#            No frag 2 ......... 200130       GE01 282
IW(1)=1;IW(2)=2;IW(3)=3;IW(4)=21;IW(5)=22# Want x,y,z,atmul,ffseq       GE01 283
KEY(1)=5; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set want list limits            GE01 284
indexpkt:(1,lratom:,NP,IP,0,KEY,IW,IR)# Get seq. nos from lrlratom      GE01 285
IF(KEY(4)<0) iquit:(GE0132)#           Iw missing ......... 200132      GE01 286
REPEAT#                                Loop over  lr16  packets         GE01 287
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 GE01 288
readwpkt:(1,lratom:,NP,IP,0)#          Point to next packet             GE01 289
IF(IP<=0) BREAK#                       Exit if no more                  GE01 290
incrqx:(K,K+5,GE0135)#                 Incr qx  ........... 200135      GE01 291
DO N=1,5#                              Loop over x,y,z,atmul,ffpoin     GE01 292
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 GE01 293
I=IP+IR(N);  J=K+N-5#                  Point to buffer and table        GE01 294
QX(J)=QX(I)#                           Transfer each item               GE01 295
IF(N<4) QX(J)=QX(J)-ORIGIN(N)#         Adjust x,y,z for origin          GE01 296
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 GE01 297
I=NINT(QX(K))+M2+40#                   Point to celcon table            GE01 298
QX(I)=QX(I)+ROTM*FMUL*FRGM*QX(J-1)#    Sum frag atoms by atom type      GE01 299
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 GE01 300
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 GE01 301
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 GE01 302
#                                                                       GE01 303
ELSE IF(LINID>=2&LINID<=4)#            **** atom* images ****           GE01 304
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 GE01 305
IF(IFRG==0)          iquit:(GE0140)#   No frag type                     GE01 306
IF(IFRG==2&LINID!=4) iquit:(GE0145)#   Frag2 require atoma input        GE01 307
IF(LINID==5&ABS(GRID(1)-1.)<.001)iquit:(GE0150)# Atomg require grid     GE01 308
stringlim:(1,I,J)#                     Define atom name string          GE01 309
LABEL=CHRIP(I^J)#                      Store atom label                 GE01 310
label:(LABEL,I,J,FFTAB,N)#             Identify atom type               GE01 311
IF(N==0) iquit:(GE0155)#               Atom type symbol missing         GE01 312
incrqx:(K,K+5,GE0160)#                 Incr qx  .......... 200160       GE01 313
QX(K)=FLOAT(N)#                        Store ff pointer in table        GE01 314
QX(K-1)=BUFIN(6)#                      Store atom pp in table           GE01 315
IF(QX(K-1)<=voidflg:) QX(K-1)=1.#      Default atom pp is one           GE01 316
DO I=1,3#                              Loop over atom coords            GE01 317
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 GE01 318
J=K+I-5#                               Point to fragment table          GE01 319
ifvo:(BUFIN(I+1)) BUFIN(I+1)=0.#       Default coord is zero            GE01 320
QX(J)=BUFIN(I+1)/GRID(I)-ORIGIN(I)#    Store atom coord                 GE01 321
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 GE01 322
I=M2+N+40#                             Point to celcon table            GE01 323
QX(I)=QX(I)+ROTM*FMUL*FRGM*QX(K-1)#    Count frag atoms by ff type      GE01 324
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 GE01 325
#                                                                       GE01 326
#                                      **** grid image ****             GE01 327
ELSE IF(LINID==5)#                     Test if grid image input         GE01 328
movereal:(BUFIN,1,GRID,1,3,0)#         Store grid values                GE01 329
#                                                                       GE01 330
#                                      **** indexk image ****           GE01 331
ELSE IF(LINID==6)#                     Test if indexk image input       GE01 332
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 GE01 333
NINK=NINK+1#                           Count index scale group          GE01 334
J=I2+(NINK-1)*17;  A=0.#               Point to temp store in buff2     GE01 335
DO I=1,17#                             Loop over possible fields        GE01 336
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 GE01 337
N=J+I#                                 Incr storage pointer             GE01 338
QX(N)=BUFIN(I)#                        Store index scale parameter      GE01 339
IF(QX(N)<=voidflg:) QX(N)=0.#          Set default as 0.                GE01 340
A=AMAX1(A,QX(N))#                      Test for all void fields         GE01 341
IF(MOD(I+1,5)==0) QX(N)=AMAX1(1.,QX(N))# Modulus cannot be zero         GE01 342
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 GE01 343
IF(QX(J+16)>small:) QX(J+17)=-2.#      Flag groups with input scale     GE01 344
IF(A<small:) NINK=100#                 Flag to generate default gro     GE01 345
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 GE01 346
#                                                                       GE01 347
ELSE IF(LINID==7) BREAK#               **** end image ****              GE01 348
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GE01 349
#                                                                       GE01 350
#     IF ARCHIV OR END FOUND TEST IF FRAG DATA COMPLETE                 GE01 351
#     ---------------------------------------------------               GE01 352
#                                                                       GE01 353
IF(IARC==0&NFRG>0)#                    Ensure frags define all atoms    GE01 354
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 GE01 355
I=0#                                   Set initialize flag              GE01 356
FOR(J=M2+21;J<M2+31;J=J+1)#            Loop over all atom types         GE01 357
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 GE01 358
IF(QX(J+20)>QX(J)+0.1) iquit:(GE0175)# Atm diff.........200175          GE01 359
IF(ABS(QX(J)-QX(J+20))<0.1)NEXT#       Ignore if numbers match          GE01 360
IF(I==0)#                              Test if first encounter          GE01 361
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 GE01 362
I=1#                                   Reset initial flag               GE01 363
QX(M4+1)=FLOAT(K);  M4=K#              Store end current frag           GE01 364
incrqx:(K,K+3,GE0180)#                 Incr qx  .......... 200180       GE01 365
QX(K-1)=1.#                            Store frag type as 1             GE01 366
QX(K  )=1.#                            Store frag mult as 1.            GE01 367
NFRG=NFRG+1#                           Count new fragment               GE01 368
intpak:(NFRG,FRAG,0,4)#                Pack frag count into bits 3-     GE01 369
NREC=NREC+1#                           Expand scratch file3 record      GE01 370
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 GE01 371
incrqx:(K,K+5,GE0185)#                 Incr qx  ......... 200185        GE01 372
QX(K-1)=(QX(J)-QX(J+20))/(FMUL*ROTM)#  Store diff as site mult.         GE01 373
QX(K  )=FLOAT(J-M2-20)#                Store ff pointer in table        GE01 374
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 GE01 375
NFRG=NFRG+NTYP3#                       Add additional frag3 wds         GE01 376
ITEM=MAX0(NFRG,MFRG)+6#                Specify length of update lis     GE01 377
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 GE01 378
#                                                                       GE01 379
IF(IARC==0)#                           Test if archiv data entered      GE01 380
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 GE01 381
IZ(1)=IABS(IZ(1));  IZ(3)=IABS(IZ(3))# Add |e1| & sige1 by default      GE01 382
IZ(2)=IABS(IZ(2));  IZ(4)=IABS(IZ(4))# Add |e2| & sige2 by default      GE01 383
IZ(5)=IABS(IZ(5));  IZ(6)=IABS(IZ(6))# Add in the expectation values    GE01 384
FOR(I=1;I<=NFRG;I=I+1)#                Loop over prev fragments         GE01 385
IZ(I+6)=IABS(IZ(I+6))#                 Add new frag data by default     GE01 386
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 GE01 387
#                                                                       GE01 388
QX(M4+1)=FLOAT(K) ; M4=K;  I=0#        Finish off fragment table        GE01 389
IF(ABS(ICRV)+NINK+NFRG==0) NINK=100#   Force index scale as default     GE01 390
#                                                                       GE01 391
RETURN#                                                                 GE01 392
END#                                                                    GE01 393
systemheader:(GE02)#                   Input lister and vectors         GE02   1
####################################################################    GE02   2
#                                                                  #    GE02   3
#                             GE02                                 #    GE02   4
#                                                                  #    GE02   5
####################################################################    GE02   6
SUBROUTINE GE02#                       S.r.hall  nov 80                 GE02   7
include:(AACOMN)#                                                       GE02   8
include:(GECOMN)#                                                       GE02   9
#                                                                       GE02  10
INTEGER I,J,K,L,M,N,II,JJ,KK,M6#                                        GE02  11
REAL A,S,E000,F000,PP,VEC#                                              GE02  12
chardata:(EV1,-YES PROFILE NO    )#                                     GE02  13
chardata:(EV2, UNIT CELL CONTENTS)#                                     GE02  14
chardata:(EV3, ATOM TYPE ATOM/CELL NEUTRON)#                            GE02  15
chardata:(EV4,[ F(0,0,0) =          E(0,0,0) =         ])#              GE02  16
chardata:(EV5, FRAGMENT CONTENTS PER ASYMMETRIC UNIT)#                  GE02  17
chardata:(EV6, FRAGMENT     TYPE    MULT. =          )#                 GE02  18
chardata:(EV7,    ATOM      X       Y       Z      SITE MULT.)#         GE02  19
chardata:(EV8, OUTPUT |E|S TO THE BDF  NO  )#                           GE02  20
chardata:(EV10, CONTROL PARAMETERS)#                                    GE02  21
chardata:(EV11, PROCESS BDF DATA SET       )#                           GE02  22
chardata:(EV12, MAX SINT/L PROCESSED        )#                          GE02  23
chardata:(EV13, USE FF**2 SUMS ON BDF   NO  )#                          GE02  24
chardata:(EV14, APPLY BAYESIAN STATS.   NO  )#                          GE02  25
chardata:(EV15, FILL IN MISSING FRELS   NO        )#                    GE02  26
chardata:(EV16, SCALE PRESET FOR |E2|   NO        )#                    GE02  27
chardata:(EV17, UOVER PRESET FOR |E2|   NO        )#                    GE02  28
chardata:(EV18, SCALING MODE FOR |E2|   LINEAR )#                       GE02  29
chardata:(EV19, HKL RESCALES FOR |E2|   NO  )#                          GE02  30
chardata:(EV20, LIST HKL F |E|S ESDS    NO        )#                    GE02  31
chardata:(EV21, LS INFLEXN. PTS. S2 =             )#                    GE02  32
chardata:(EV22, BDF FREL SCALE APPLIED                  )#              GE02  33
realdata:(FMT,[170642.,250642.,330642.,440632.])#                       GE02  34
realdata:(FM1,[280213.,380842.])#                                       GE02  35
realdata:(PI4,12.56637062);   realdata:(SCON,0.)#                       GE02  36
datastuff:#                                                             GE02  37
#                                                                       GE02  38
#    TRANSFER INDEX SCALE TABLE FROM BUFFER2                            GE02  39
#    ---------------------------------------                            GE02  40
#                                                                       GE02  41
IF(NINK==100)#                         Is indexk active in default      GE02  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GE02  43
NINK=8;  I=NINK*17; N=I2#              Set default parameters           GE02  44
movereal:(0.,1,QX,I2+1,I,2)#           Zeroize area in buffer2          GE02  45
DO I=1,8#                              Loop over default index grou     GE02  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GE02  47
QX(N+1)=1.;QX(N+7)=1.;QX(N+13)=1.#     Set default hkl constants        GE02  48
QX(N+4)=2.;QX(N+9)=2.;QX(N+14)=2.#     Set default moduli               GE02  49
IF(MOD(I,2)>=1) QX(N+5 )=1.#           Set default residuals            GE02  50
IF(MOD(I,4)>=2) QX(N+10)=1.#           Set default residuals            GE02  51
IF(MOD(I,8)>=4) QX(N+15)=1.#           Set default residuals            GE02  52
N=N+17#                                Incr buffer pointer              GE02  53
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GE02  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GE02  55
N=NINK*17#                             Total words in indexk table      GE02  56
incrqx:(N3,M4+N,GE0220)#               Expand qx .......... 200220      GE02  57
IF(NINK>0)#                            If indexk values exit            GE02  58
movereal:(QX,I2+1,QX,M4+1,N,1)#        Move them out of buffer2         GE02  59
M5=N3#                                 Set default end frag2 vector     GE02  60
#                                                                       GE02  61
#                                                                       GE02  62
#      PRINT GENEV CONTROL PARAMETERS                                   GE02  63
#      =================================                                GE02  64
#                                                                       GE02  65
movechar:(EV1,1,CHROT,2,NEV10-1,2)#    Put underline in buffer          GE02  66
writeline:(1,EV10,NEV10,2,3)#          Print control heading            GE02  67
ncodefld:(DSNM,1,EV11,270213.,1)#      Put dataset no. in line          GE02  68
writeline:(0,EV11,NEV11,3,3)#          Print datset line                GE02  69
ncodefld:(STMX,1,EV12,270532.,1)#      Put st/l max into line           GE02  70
writeline:(0,EV12,NEV12,3,3)#          Print st/l maximum               GE02  71
movechar:(EV1,14,EV8,26,3,0)#          Insert yes in message            GE02  72
IF(EOUT==yes:)#                        If e's output to bdf             GE02  73
movechar:(EV1,2,EV8,26,3,0)#           Overwrite *no with *yes          GE02  74
writeline:(0,EV8,NEV8,3,3)#            Print e output status            GE02  75
movechar:(EV1,14,EV13,26,3,0)#                                          GE02  76
IF(IBDF>0)#                            If ff**2 sums on bdf             GE02  77
movechar:(EV1,2,EV13,26,3,0)#          Overwrite *no with *yes          GE02  78
writeline:(0,EV13,NEV13,3,3)#          Print ff**2 sum status           GE02  79
movechar:(EV1,14,EV14,26,3,0)#                                          GE02  80
IF(IBAY>0)#                            If bayesian stats requested      GE02  81
movechar:(EV1,2,EV14,26,3,0)#          Overwrite *no with *yes          GE02  82
writeline:(0,EV14,NEV14,3,3)#          Print bayesian stats status      GE02  83
movechar:(EV1,14,EV15,26,3,0)#                                          GE02  84
IF(IFIL>0)#                            If range filling requested       GE02  85
movechar:(EV1,2,EV15,26,3,0)#          Overwrite *no with *yes          GE02  86
IF(FTHR>=0.)#                          Test for input f-threshold       GE02  87
ncodefld:(FTHR,1,EV15,340622.,1)#      Put threshold in buffer          GE02  88
writeline:(0,EV15,NEV15,3,3)#          Print range filling status       GE02  89
movechar:(EV1,14,EV16,26,3,0)#                                          GE02  90
IF(SOVL>small:)#                       If scale has been input          GE02  91
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GE02  92
movechar:(EV1,2,EV16,26,3,0)#          Overwrite *no with *yes          GE02  93
ncodefld:(SOVL,1,EV16,340632.,1)#      Put scale into line              GE02  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GE02  95
writeline:(0,EV16,NEV16,3,3)#          Print input scale status         GE02  96
movechar:(EV1,14,EV17,26,3,0)#                                          GE02  97
IF(BOVL>small:)#                       If bovl has been input           GE02  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GE02  99
movechar:(EV1,2,EV17,26,3,0)#          Overwrite *no with *yes          GE02 100
ncodefld:(BOVL/79.,1,EV17,340642.,1)#  Put bovl into line               GE02 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GE02 102
writeline:(0,EV17,NEV17,3,3)#          Print input bovl status          GE02 103
IF(ICRV>0)#                            If profile fit requested         GE02 104
movechar:(EV1,6,EV18,26,7,0)#          Overwrite with profile           GE02 105
writeline:(0,EV18,NEV18,3,3)#          Print interpolation method       GE02 106
movechar:(EV1,14,EV19,26,3,0)#                                          GE02 107
IF(NINK>0)#                            If index scaling requested       GE02 108
movechar:(EV1,2,EV19,26,3,0)#          Overwrite *no with *yes          GE02 109
writeline:(0,EV19,NEV19,3,3)#          Print index scale status         GE02 110
movechar:(EV1,14,EV20,26,3,0)#                                          GE02 111
IF(ELST<99999.)#                       If liste value specified         GE02 112
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GE02 113
movechar:(EV1,2,EV20,26,3,0)#          Overwrite *no with *yes          GE02 114
ncodefld:(ELST,1,EV20,340622.,1)#      Put liste value in line          GE02 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GE02 116
writeline:(0,EV20,NEV20,3,3)#          Print liste status               GE02 117
ncodefld:(FLX1,1,EV21,280622.,1)#      Put inflex pt 1 into line        GE02 118
ncodefld:(FLX2,1,EV21,340622.,1)#      Put inflex pt 2 into line        GE02 119
writeline:(0,EV21,NEV21,3,3)#          Print inflexion points           GE02 120
#                                                                       GE02 121
FOR(I=N2;I<M3;I=I+1)#                  Loop over scale groups           GE02 122
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GE02 123
BUFOT(1)=FLOAT(I-N2+1)#                Store scale group                GE02 124
BUFOT(2)=QX(I+1)#                      Store frel scale                 GE02 125
ncodefld:(BUFOT,1,EV22,FM1,2)#         Format items                     GE02 126
writeline:(0,EV22,NEV22,3,3)#          Print scales                     GE02 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GE02 128
#                                                                       GE02 129
movechar:(EV1,1,CHROT,2,NEV2-1,1)#     Put header underline in buff     GE02 130
writeline:(1,EV2,NEV2,2,3)#            Print parameter heading          GE02 131
movechar:(EV3,1,CHROT,1,10,0)#         Place atom type header           GE02 132
DO I=1,NSCF#                           Loop over all atom types         GE02 133
movechar:(FFTAB,I*8-7,CHROT,I*7+8,8,0)# Put atom type in buffer         GE02 134
writeline:(0,0,0,1,3)#                 Print atom type info             GE02 135
F000=0.;  E000=0.#                     Initialize 000 sums              GE02 136
movechar:(EV3,11,CHROT,1,10,0)#        Place atoms/cell header          GE02 137
J=M2+21   ;A=150513.#                  Set pointer and format           GE02 138
DO I=1,NSCF#                           Loop over all atom types         GE02 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GE02 140
ncodefld:(QX(J),1,CHROT,A,1)#          Put values in buffer             GE02 141
F000 =F000 +QX(J)*QX(J+10)#            Accumulate f000                  GE02 142
E000 =E000 +QX(J)*QX(J+10)*QX(J+10)#   Accumulate e000                  GE02 143
J=J+1    ;A=A+70000.#                  Incr pointer & format            GE02 144
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GE02 145
writeline:(0,0,0,1,3)#                 Print atoms/cell header          GE02 146
ifeq:(F000,0.) iquit:(GE0230)#         No atoms.......200230            GE02 147
E000=F000/SQRT(E000)#                  Calculate e(0,0,0) value         GE02 148
ncodefld:(F000 ,1,EV4,180802.,1)#      Put f000  in header              GE02 149
ncodefld:(E000 ,1,EV4,380822.,1)#      Put e000  in header              GE02 150
writeline:(1,EV4,NEV4,2,3)#            Print zero header                GE02 151
#                                                                       GE02 152
#                                      Fragment output summary          GE02 153
IF(NFRG>0)#                            If fragments exist               GE02 154
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GE02 155
movechar:(EV1,1,CHROT,2,NEV5-1,2)#     Underline frag list heading      GE02 156
writeline:(1,EV5,NEV5,2,3)#            Print fragment header            GE02 157
A=1.     ;K=M3#                        Set frag count & pointer         GE02 158
WHILE(K<M4)#                           Loop over all fragments          GE02 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GE02 160
M=NINT(QX(K+1))#                       Set end of atom list             GE02 161
ncodefld:(A,1,EV6,110213.,1)#          Insert frag count in buff        GE02 162
ncodefld:(QX,K+2,EV6,200113.,1)#       Insert frag type  in buff        GE02 163
ncodefld:(QX,K+3,EV6,370632.,1)#       Insert frag mult. in buff        GE02 164
writeline:(0,EV6,NEV6,2,3)#            Print frag sub-header            GE02 165
K=K+3   ;A=A+1.;   LINRM=4#            Incr fragment info               GE02 166
FOR(;K<M;K=K+5)#                       Loop over atoms list             GE02 167
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GE02 168
I=NINT(QX(K+5))*8-7#                   Extract atom type pointer        GE02 169
movechar:(FFTAB,I,CHROT,6,6,0)#        Put atom type in buff            GE02 170
ncodefld:(QX,K+1,CHROT, FMT,4)#        Put x,y,z,mult in buff           GE02 171
writeline:(0,EV7,NEV7,1,3)#            Print atom data with header      GE02 172
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GE02 173
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GE02 174
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GE02 175
#                                                                       GE02 176
#                                                                       GE02 177
#   GENERATE SIN/COS TABLES IF FRAGMENTS PRESENT                        GE02 178
#   --------------------------------------------                        GE02 179
#                                                                       GE02 180
IF(NFRG>0)#                            If fragment table active         GE02 181
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GE02 182
SCON=PI4*STIN/FLOAT(NSFF)#             St/l conversion for frag 2       GE02 183
incrqx:(M6,M5+450,GE0235)#             Expand qx ......... 200230       GE02 184
FOR(I=M5;I<M6;I=I+1)#                  Loop over 0-449 degrees          GE02 185
QX(I+1)=SIN(FLOAT(I-M5)*.0174532925 )# Store sine(0 to 449 degrees)     GE02 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GE02 187
#                                                                       GE02 188
#                                                                       GE02 189
#   FOR FRAG2 ATOMS GENERATE INTERATOMIC VECTORS                        GE02 190
#   --------------------------------------------                        GE02 191
#                                                                       GE02 192
IF(NFRG>0)#                            If any fragments exist           GE02 193
FOR(K=M3;K<M4;K=M)#                    Loop over fragment packets       GE02 194
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GE02 195
M=NINT(QX(K+1))#                       Extract end pointer of frag      GE02 196
IF(ABS(QX(K+2)-2.)>0.5) NEXT#          Ignore all but frag2             GE02 197
K=K+3#                                 Reset table pointers             GE02 198
FOR(I=K;I<M;I=I+5)#                    Outer atom loop for frag2        GE02 199
FOR(J=I;J<M;J=J+5)#                    Inner atom loop for frag2        GE02 200
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GE02 201
VEC=SQRT((QX(I+1)-QX(J+1))**2 $#       Calc interatomic vector          GE02 202
+        (QX(I+2)-QX(J+2))**2 $#       Calc interatomic vector          GE02 203
+        (QX(I+3)-QX(J+3))**2)#        Calc interatomic vector          GE02 204
II=NINT(QX(I+5));  JJ=NINT(QX(J+5))#   Extract ff pointers              GE02 205
PP=2.*QX(I+4)*QX(J+4)#                 Calc population product          GE02 206
IF(I==J) PP=0.5*PP#                    Reduce diagonal sum              GE02 207
FOR(L=N1;L<N2;)#                       Loop over sin t table            GE02 208
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GE02 209
S=VEC*SCON*FLOAT(L-N1)#                Calc 4pi*st/l*d(i,j)             GE02 210
KK=MOD(NINT(S*57.295779),360)+M5#      Convert o degrees                GE02 211
IF(S>0.005)#                           Test if assymtopic value         GE02 212
A=QX(L+II)*QX(L+JJ)*PP*QX(KK+1)/S#     Calc ff*ff*sync(4pi*s*d)         GE02 213
ELSE A=QX(L+II)*QX(L+JJ)*PP#           Also for d=0                     GE02 214
L=L+NSFF#                              Point to position in table       GE02 215
QX(L)=QX(L)+A#                         Sum in contribution              GE02 216
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GE02 217
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GE02 218
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GE02 219
#                                                                       GE02 220
#                                                                       GE02 221
#   GENERATE WILSON CURVE FOR 101 ST/L VALUES                           GE02 222
#   -----------------------------------------                           GE02 223
#                                                                       GE02 224
FOR(I=N1;I<N2;I=I+NSFF)#               Loop over 101 st/l values        GE02 225
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GE02 226
L=I+NSCF+1;   M=M2+20#                 Point to ff and celcon table     GE02 227
FOR(J=I+1;J<L;J=J+1)#                  Loop over ff types               GE02 228
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GE02 229
M=M+1#                                 Incr pointer to atoms/cell       GE02 230
QX(L)=QX(L)+QX(M)*QX(J)*QX(J)#         Sum nat*ff**2                    GE02 231
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GE02 232
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GE02 233
#                                                                       GE02 234
#                                                                       GE02 235
#   PREPARE WILSON TABLE FOR SUMMATIONS (BUFFER2 AND M0-M1)             GE02 236
#   -------------------------------------------------------             GE02 237
#                                                                       GE02 238
S2MX=STMX**2;  S2IN=S2MX/40.#          S2t/l2 max and range interva     GE02 239
movereal:(0.,1,QX,I2+1,410,2)#         Zero wilson table in buffer      GE02 240
A=S2IN;  J=I2;  N0=I2+410#             Set s2t/l2 and buff pointer      GE02 241
FOR(K=M0;K<M1;K=K+10)#                 Loop over 40 ranges              GE02 242
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GE02 243
QX(K+1)=A;  QX(J+1)=A#                 Set s2t/l2 range limits          GE02 244
QX(J+8)=1000000.#                      Initialize min frel**2           GE02 245
J=J+10;  A=A+S2IN#                     Incr buff and s2t/l2             GE02 246
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GE02 247
#                                                                       GE02 248
RETURN#                                                                 GE02 249
END#                                                                    GE02 250
systemheader:(GE03)#                   Read reflection data from bdf    GE03   1
####################################################################    GE03   2
#                                                                  #    GE03   3
#                             GE03                                 #    GE03   4
#                                                                  #    GE03   5
####################################################################    GE03   6
SUBROUTINE GE03#                       S.r.hall  nov 80                 GE03   7
include:(AACOMN)#                                                       GE03   8
include:(GECOMN)#                                                       GE03   9
#                                                                       GE03  10
INTEGER I,J,K,M,N,NP,IP,FRIEDM,JJ,JF,MODE#                              GE03  11
INTEGER IS,LF,MS,NF#                                                    GE03  12
REAL D,EPSL,F2,FM,SIGI,STOL,X,Y,Z#                                      GE03  13
REAL A,B,C,G2,SLMX,FRELF,SIGFF,SCALF#                                   GE03  14
#                                                                       GE03  15
chardata:(EV1,[ ACTUAL ST/L(MAX)        TOO FAR FROM PRESET        ])#  GE03  16
realdata:(RLPF,0.);  realdata:(CNTI,0.);  realdata:(SCAL,1.)#           GE03  17
realdata:(SM,[0.,0.,0.,0.,0.,0.,0.,0.,0.])#                             GE03  18
realdata:(BAYF,[.47,.49,.52,.55,.58,.61,.65,.70,.76,.81,#               GE03  19
.89,.97,1.06,1.17,1.27,1.37,1.48,1.59,1.69,1.80,#                       GE03  20
.30,.32,.34,.36,.38,.41,.43,.48,.52,.57,#                               GE03  21
.65,.74,.82,.95,1.08,1.21,1.34,1.48,1.62,1.73])#                        GE03  22
realdata:(BAYS,[.24,.25,.26,.27,.28,.29,.31,.32,.33,.35,#               GE03  23
.36,.37,.38,.38,.37,.36,.34,.32,.31,.29,#                               GE03  24
.23,.24,.25,.26,.27,.29,.31,.33,.35,.37,#                               GE03  25
.39,.41,.44,.46,.46,.45,.42,.39,.35,.31])#                              GE03  26
datastuff:#                                                             GE03  27
#                                                                       GE03  28
#   GET SEQUENCE NUMBERS OF ITEMS REQUIRED                              GE03  29
#   --------------------------------------                              GE03  30
#                                                                       GE03  31
IDSN=NINT(DSNM)*1000#                  Integerize dataset number        GE03  32
IW(1)=1;  IW(2)=2;  IW(3)=3#           Want hkl, st/l, e:m              GE03  33
IW(4)=IDSN+304;  IW(5)=IDSN+305#       Want frel and sigma frel         GE03  34
IW(6)=IDSN+302;  IW(7)=IDSN+303#       Want f**2 and sigma f**2         GE03  35
IW(8)=IDSN+300;  IW(9)=IDSN+301#       Want irel and sigma irel         GE03  36
IW(10)=IDSN+314;  IW(11)=IDSN+315#     Friedel frel and sigma frel      GE03  37
IW(12)=IDSN+312;  IW(13)=IDSN+313#     Friedel f**2 and sigma f**2      GE03  38
IW(14)=IDSN+310;  IW(15)=IDSN+311#     Friedel irel and sigma irel      GE03  39
IW(16)=IDSN+309;  IW(17)=IDSN+319#     Scale group numbers              GE03  40
IW(18)=IDSN+604;  IW(19)=IDSN+605#     Want wilson f2 sum & grp f2      GE03  41
IW(20)=IDSN+204#                       Lp factor                        GE03  42
KEY(1)=3; KEY(2)=20; KEY(3)=0; KEY(4)=0# Set want list limits           GE03  43
indexpkt:(1,lrrefl:,NP,IP,0,KEY,IW,IR)# Get seq. nos of wanted items    GE03  44
IF(KEY(4)<=0) iquit:(GE0301)#          Missing essentials               GE03  45
IF     (IR(4)>0)         MODE=1#       Use frel data for plot           GE03  46
ELSE IF(IR(6)>0)         MODE=2#       Use f**2 data for plot           GE03  47
ELSE IF(IR(8)>0&IR(20)>0)MODE=3#       Use irel data for plot           GE03  48
ELSE         iquit:(GE0302)#           No data to apply in plot         GE03  49
IF(IR(10)+IR(12)+IR(14)>0) FRIEDM=2#   Prepare to get friedel mates     GE03  50
ELSE                       FRIEDM=1#   But only if there are any        GE03  51
FRELF=voidflg:#                        Default frel of --- refln        GE03  52
MS=M5+1#                               Set sin/cos table pointer        GE03  53
G2=0.;   SLMX=0.;  TOTR=0.#            Initialize group s.f. sum        GE03  54
#                                                                       GE03  55
#                                                                       GE03  56
#    READ REFLECTION DATA FROM BDF                                      GE03  57
#    =============================                                      GE03  58
#                                                                       GE03  59
REPEAT#                                Loop over all reflections        GE03  60
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GE03  61
readwpkt:(1,lrrefl:,NP,IP,0)#          Point to next packet             GE03  62
IF(IP<=0) BREAK#                       Exit loop if no more             GE03  63
I=IP+IR(2); STOL=QX(I)#                Extract st/l                     GE03  64
IF(STOL>STMX) NEXT#                    Ignore data above st/l max       GE03  65
TOTR=TOTR+1.#                          Count reflections used           GE03  66
I=IP+IR(1); gethkl:(I,H)#              Extract h,k,l                    GE03  67
SLMX=AMAX1(SLMX,STOL)#                 Find actual sint/l maximum       GE03  68
I=IP+IR(3)#                            Point packed e:m                 GE03  69
intunpak:(QX(I),J,0,5)#                Unpack refl. multiplicity        GE03  70
intunpak:(QX(I),K,5,7)#                Unpack reinforc. factor          GE03  71
RMUL=FLOAT(J); EPSL=FLOAT(K)#          Make floating point              GE03  72
#                                                                       GE03  73
JJ=1 ; SIGF=0.1;  FREL=voidflg:#       Assume sc grp & sigma f          GE03  74
IF(MODE==1)#                           If frel to be input              GE03  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GE03  76
I=IP+IR(4); FREL=QX(I)#                Extract frel                     GE03  77
I=IP+IR(5); IF(I>IP) ifnv:(QX(I)) SIGF=QX(I)# Extract sig(f)            GE03  78
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GE03  79
ELSE IF(MODE==2)#                      If f**2 to be input              GE03  80
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GE03  81
I=IP+IR(6); ifnv:(QX(I)) FREL=SQRT(ABS(QX(I)))# Extract frel            GE03  82
I=IP+IR(7); IF(I>IP) ifnv:(QX(I)) SIGF=SQRT(QX(I))# Sig(f)              GE03  83
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GE03  84
ELSE IF(MODE==3)#                      If irel to be input              GE03  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GE03  86
I=IP+IR(20); RLPF=QX(I)#               Extract lp factor                GE03  87
I=IP+IR(8);  ifnv:(QX(I)) FREL=SQRT(ABS(QX(I)*RLPF))# Extract frel      GE03  88
I=IP+IR(9); IF(I>IP) ifnv:(QX(I)) SIGF=SQRT(QX(I)*RLPF)# Sig(f)         GE03  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GE03  90
I=IP+IR(16); IF(I>IP) JJ=NINT(QX(I))#  Extract scale group no.          GE03  91
SCAL=QX(N2+JJ)#                        Extract scale from table         GE03  92
#                                                                       GE03  93
IF(FRIEDM==2)#                         For friedel data                 GE03  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GE03  95
JF=1 ; SIGFF=0.1; FRELF=voidflg:#      Default sc grp & sigma f         GE03  96
IF(MODE==1)#                           If frel to be input              GE03  97
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GE03  98
I=IP+IR(10); FRELF=QX(I)#              Extract frel                     GE03  99
I=IP+IR(11); IF(I>IP) ifnv:(QX(I)) SIGFF=QX(I)# Extract sig(f)          GE03 100
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GE03 101
ELSE IF(MODE==2)#                      If f**2 to be input              GE03 102
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GE03 103
I=IP+IR(12); ifnv:(QX(I)) FRELF=SQRT(ABS(QX(I)))# Extract frel          GE03 104
I=IP+IR(13); IF(I>IP) ifnv:(QX(I)) SIGFF=SQRT(QX(I))# Extract sig(f)    GE03 105
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GE03 106
ELSE IF(MODE==3)#                      If irel to be input              GE03 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GE03 108
I=IP+IR(20); RLPF=QX(I)#               Extract lp factor                GE03 109
I=IP+IR(14); ifnv:(QX(I)) FRELF=SQRT(ABS(QX(I)*RLPF))# Extract frel     GE03 110
I=IP+IR(15); IF(I>IP) ifnv:(QX(I)) SIGFF=SQRT(QX(I)*RLPF)# Sig(f)       GE03 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GE03 112
I=IP+IR(17); IF(I>IP) JF=NINT(QX(I))#  Extract scale group no.          GE03 113
SCALF=QX(N2+JF)#                       Extract scale from table         GE03 114
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GE03 115
#                                                                       GE03 116
ifvo:(FREL)#                           Do not use void data!            GE03 117
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GE03 118
ifnv:(FRELF)#                          See if the enantiomorph there    GE03 119
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GE03 120
FREL=FRELF ; SIGF=SIGFF ; SCAL=SCALF#  Let the --- carry the load       GE03 121
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GE03 122
ELSE FREL=0.0#                         If both are void use zero        GE03 123
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GE03 124
ELSE IF(FRIEDM==2)#                    +++ not void & --- is there      GE03 125
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GE03 126
ifnv:(FRELF)#                          And enantiomorph not void        GE03 127
FREL=0.5*(FREL+FRELF*SCALF/SCAL)#      Average the f relatives          GE03 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GE03 129
#                                                                       GE03 130
#     CORRECT WEAK FRELS ACCORDING TO BAYESIAN STATS                    GE03 131
#     ----------------------------------------------                    GE03 132
#                                                                       GE03 133
IF((IBAY>0)&(FREL<(6.*SIGF)))#         Is bayesian stats required       GE03 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GE03 135
I=IP+IR(20); IF(I>IP) RLPF=QX(I)#      Extract lp factor                GE03 136
ELSE iquit:(GE0305)#                   Rlpf missing ......... 20030     GE03 137
I=IP+IR(8); IF(I>IP) CNTI=QX(I)#       Extract net intensity            GE03 138
ELSE iquit:(GE0310)#                   Int missing .......... 20031     GE03 139
I=IP+IR(9); IF(I>IP) SIGI=QX(I)#       Extract sigma(i)                 GE03 140
ELSE SIGI=SQRT(4.*CNTI*SIGF**2/RLPF)#  Or calculate sigma(inet)         GE03 141
IF(SIGI<0.001) J=1#                    Protect against div/ofl          GE03 142
ELSE J=MAX0(1,NINT((CNTI/SIGI+3.)*3.)+1)+ICNT*20# Table pointer         GE03 143
FREL=BAYF(J)*SQRT(SIGI*RLPF)#          Estimate bayesian frel           GE03 144
SIGF=BAYS(J)*SQRT(SIGI*RLPF)#          Estimate bayesian sigf           GE03 145
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GE03 146
#                                                                       GE03 147
#    IS INDEX RESCALING REQUIRED LATER                                  GE03 148
#    ---------------------------------                                  GE03 149
#                                                                       GE03 150
IF(NINK>0)#                            Do index groups exist            GE03 151
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GE03 152
ISCL=0#                                Set index group counter          GE03 153
FOR(I=M4;I<N3;I=I+17)#                 Loop over index groups           GE03 154
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GE03 155
FOR(J=I;J<I+14;J=J+5)#                 Loop over index sets             GE03 156
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GE03 157
A=H(1)*QX(J+1)+H(2)*QX(J+2)+H(3)*QX(J+3)# Form index product            GE03 158
A=ABS(AMOD(A,QX(J+4)))#                Get modulus for group            GE03 159
IF(ABS(A-QX(J+5))>small:) BREAK#       Exit if condition fails          GE03 160
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GE03 161
IF(J<I+14) NEXT#                       Repeat if conditions not met     GE03 162
ISCL=(I-M4)/17+1#                      Set index scale group            GE03 163
BREAK#                                 Exit when all conditions met     GE03 164
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GE03 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GE03 166
#                                                                       GE03 167
#                                                                       GE03 168
#    ARE EXISTING E-SUMS ON BDF TO BE USED                              GE03 169
#    -------------------------------------                              GE03 170
#                                                                       GE03 171
IF(IBDF>0)#                            Are wilson and group sums on     GE03 172
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GE03 173
I=IP+IR(18); IF(I>IP) E1=QX(I)#        Extract wilson sum               GE03 174
ELSE iquit:(GE0315)#                   Sum missing .......... 20031     GE03 175
I=IP+IR(19); IF(I>IP) E2=QX(I)#        Extract group sf                 GE03 176
ELSE iquit:(GE0315)#                   Sum missing .......... 20031     GE03 177
E1=E1*E1;   G2=E2*E2#                  Squared values needed later      GE03 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GE03 179
#                                                                       GE03 180
#                                                                       GE03 181
#    ACCUMULATE NEW E-SUMS                                              GE03 182
#    ---------------------                                              GE03 183
#                                                                       GE03 184
ELSE#                                  Wilson and group sums to be      GE03 185
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GE03 186
IS=INT(STOL/STIN);  IS=IS*NSFF+N1#     Make st/l wilson pointer         GE03 187
J=IS+NSCF#                             Point to nat*ff**2 curve         GE03 188
E1=EPSL*QX(J+1)#                       Extract wilson sum               GE03 189
G2=E1#                                 Set default e2 as wilson als     GE03 190
#                                                                       GE03 191
#    IF FRAGMENTS ENTERED CALC GROUP S.F.                               GE03 192
#    ------------------------------------                               GE03 193
#                                                                       GE03 194
IF(NFRG>0)#                            Is group sum requested           GE03 195
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GE03 196
G2=0.#                                 Initialize group s.f. sum        GE03 197
FOR(M=M3;M<M4;M=LF)#                   Loop over fragment table         GE03 198
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 GE03 199
LF=NINT(QX(M+1))#                      Extract fragment lastword        GE03 200
NF=NINT(QX(M+2))#                      Extract fragment type            GE03 201
FM=     QX(M+3)#                       Extract fragment scale           GE03 202
M=M+3  ;A=0.  ;B=0.#                   Incr frag list pointer           GE03 203
#                                                                       GE03 204
IF(NF==1)#                             If *random atom* fragment        GE03 205
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 GE03 206
FOR(;M<LF;M=M+5)#                      Loop over all atoms              GE03 207
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 GE03 208
I=IS+NINT(QX(M+5))#                    Extract scatfac pointer          GE03 209
A=A+QX(M+4)*QX(I)*QX(I)#               Sum scale*ff**2                  GE03 210
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 GE03 211
C=A*FM*EPSL*FMUL*ROTM#                 Asymmetric part of gsf           GE03 212
G2=G2+C#                               Sum random atom component        GE03 213
CALL GE04(A,B,C,1)#                    Put values on file3              GE03 214
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 GE03 215
#                                                                       GE03 216
ELSE IF(NF==2)#                        If *random group* fragment       GE03 217
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 GE03 218
I=NSFF+IS#                             Point to start of ff table       GE03 219
C=QX(I)*FM*EPSL*FMUL*ROTM#             Calc rot average                 GE03 220
G2=G2+C#                               Sum random group component       GE03 221
CALL GE04(A,B,C,1)#                    Put values on file3              GE03 222
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 GE03 223
#                                                                       GE03 224
ELSE IF(NF==3)#                        If *oriented group* fragment     GE03 225
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 GE03 226
FOR(K=M1;K<M2;K=K+12)#                 Loop over seitz matrices         GE03 227
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 GE03 228
movereal:(QX,K+1,SM,1,9,0)#            Store rot matrix in array        GE03 229
A=0.   ;B=0.#                          Zeroize sf parts                 GE03 230
FOR(J=M;J<LF;J=J+5)#                   Loop over atoms list             GE03 231
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 GE03 232
I=IS+NINT(QX(J+5))#                    Point to scatfac list            GE03 233
C=(QX(J+1)*SM(1)+QX(J+2)*SM(4)+QX(J+3)*SM(7))*H(1)$# Calculate group    GE03 234
+ (QX(J+1)*SM(2)+QX(J+2)*SM(5)+QX(J+3)*SM(8))*H(2)$# Calculate group    GE03 235
+ (QX(J+1)*SM(3)+QX(J+2)*SM(6)+QX(J+3)*SM(9))*H(3)# Calculate group     GE03 236
N=MOD(36000+NINT(C*360.),360)+MS#      Point to sin/cos table           GE03 237
C=QX(J+4)*QX(I)#                       Precalc mult*ff                  GE03 238
A=A+C*QX(N+90)#                        Sum real part gsf                GE03 239
B=B+C*QX(N   )#                        Sum imag part gsf                GE03 240
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 GE03 241
C=(A*A+B*B)*FM*FM*FMUL*EPSL#           Calc asymmetric gsf              GE03 242
G2=G2+C#                               Sum orient group component       GE03 243
CALL GE04(A,B,C,1)#                    Put gsf onto file3               GE03 244
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 GE03 245
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 GE03 246
#                                                                       GE03 247
ELSE#                                  If *positioned atom* fragmen     GE03 248
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 GE03 249
FOR(;M<LF;M=M+5)#                      Loop over atoms list             GE03 250
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 GE03 251
I=IS+NINT(QX(M+5))#                    Extract scatfac pointer          GE03 252
X=QX(M+1); Y=QX(M+2); Z=QX(M+3)#       Prepare x,y,z                    GE03 253
C=QX(M+4)*QX(I)#                       Calc scale*ff                    GE03 254
FOR(K=M1;K<M2;K=K+12)#                 Loop over seitz matrices         GE03 255
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 GE03 256
D=((X*QX(K+1)+Y*QX(K+4)+Z*QX(K+7)+QX(K+10))*H(1) $# Calc gsf            GE03 257
+  (X*QX(K+2)+Y*QX(K+5)+Z*QX(K+8)+QX(K+11))*H(2) $# Calc gsf            GE03 258
+  (X*QX(K+3)+Y*QX(K+6)+Z*QX(K+9)+QX(K+12))*H(3))# Calc gsf             GE03 259
N=MOD(36000+NINT(D*360.),360)+MS#      Point to sin/cos table           GE03 260
IF(ICNT==0) B=B+C*QX(N   )#            Sum imag part of gsf             GE03 261
A=A+C*QX(N+90)#                        Sum real part of gsf             GE03 262
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 GE03 263
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 GE03 264
C=(A*A+B*B)*FM*FM*FMUL*FMUL#           Asymmetric part of gsf           GE03 265
G2=G2+C#                               Sum position group s.f.          GE03 266
CALL GE04(A,B,C,1)#                    Put type4 gsf into file3         GE03 267
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 GE03 268
#                                                                       GE03 269
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 GE03 270
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GE03 271
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GE03 272
#                                                                       GE03 273
FREL=FREL*SCAL#                        Scale frel with group scale      GE03 274
SIGF=SIGF*SCAL#                        Scale sigf with group scale      GE03 275
S2L2=STOL*STOL#                        Calculate s2t/l2                 GE03 276
E2=G2#                                 Store total group s.f.           GE03 277
CALL GE04(A,B,C,0)#                    Put final gsf info on file3      GE03 278
#                                                                       GE03 279
#                                                                       GE03 280
#   ACCUMULATE SUMS FOR S**2 RANGE AVERAGES                             GE03 281
#   ---------------------------------------                             GE03 282
#                                                                       GE03 283
F2=FREL*FREL#                          Calculate frel**2                GE03 284
J=INT(S2L2/S2IN);  J=J*10+I2#          Point to wilson sums b           GE03 285
QX(J+2)=QX(J+2)+RMUL#                  Sum refln multiplicity           GE03 286
QX(J+3)=QX(J+3)+RMUL*F2#               Sum frel**2                      GE03 287
QX(J+4)=QX(J+4)+RMUL*S2L2#             Sum s2t/l2                       GE03 288
QX(J+5)=QX(J+5)+RMUL*E1#               Sum wilson ff**2                 GE03 289
QX(J+6)=QX(J+6)+RMUL*E2#               Sum group  ff**2                 GE03 290
QX(J+7)=QX(J+7)+1.#                    Sum contributions                GE03 291
IF(IFIL>0)#                            Exit if no range filling         GE03 292
QX(J+8)=AMIN1(QX(J+8),F2)#             Find min frel**2 for range       GE03 293
#                                                                       GE03 294
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GE03 295
#                                                                       GE03 296
#                                                                       GE03 297
readwpkt:(1,endrecord:,I,I,0)#         Finish off reading file1         GE03 298
writepkt:(3,endrecord:,4,I)#           Finish off writing file3         GE03 299
#                                                                       GE03 300
IF(SLMX<0.8*STMX)#                     Test if actual st/l max ok       GE03 301
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 GE03 302
ncodefld:(SLMX,1,EV1,240532.,1)#       Encode actual st/l max           GE03 303
ncodefld:(STMX,1,EV1,500532.,1)#       Encode preset st/l max           GE03 304
writeline:(1,EV1,NEV1,2,3)#            Print warning message            GE03 305
iquit:(GE0330)#                        Hi stlmax ...........200330      GE03 306
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 GE03 307
#                                                                       GE03 308
RETURN#                                                                 GE03 309
END#                                                                    GE03 310
systemheader:(GE04)#                   Write scratch file               GE04   1
####################################################################    GE04   2
#                                                                  #    GE04   3
#                             GE04                                 #    GE04   4
#                                                                  #    GE04   5
####################################################################    GE04   6
SUBROUTINE GE04(A,B,C,M)#                                               GE04   7
include:(AACOMN)#                      S.r.hall  nov 80                 GE04   8
include:(GECOMN)#                                                       GE04   9
#                                                                       GE04  10
REAL A,B,C,D#                                                           GE04  11
INTEGER IP,M,I#                                                         GE04  12
intdata:(N,0)#                                                          GE04  13
SAVE IP,N#                                                              GE04  14
datastuff:#                                                             GE04  15
#                                                                       GE04  16
IF(N==0)#                              Has packet pointer been set      GE04  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GE04  18
writepkt:(3,2,NREC,IP)#                Get packet pointer               GE04  19
N=IP+8#                                Adjust buffer position           GE04  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GE04  21
#                                                                       GE04  22
IF(M>0)#                               If fragment information          GE04  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GE04  24
IF((ABS(A)<0.01)&(ABS(B)<0.01))A=1.#   If a & b small phi=0             GE04  25
D=ATAN2(B,A)*57.295779#                Calc phi in 360ths               GE04  26
I=MOD(NINT(D)+360,360)#                Intergerize phi                  GE04  27
intpak:(I,QX(N),0,9)#                  Pack in bits 8-0                 GE04  28
I=MIN0(65535,NINT(SQRT(ABS(C))+.5))#   Convert sqrt(gsf) to integer     GE04  29
intpak:(I,QX(N),9,arith:(mxbtwd:,-,9))# Pack in bits **-9               GE04  30
N=N+1#                                 Incr output buffer               GE04  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GE04  32
#                                                                       GE04  33
ELSE#                                  Output reflection info           GE04  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GE04  35
N=0#                                   Reset next packet flag           GE04  36
QX(IP+1)=FREL#                         Put frel in buffer               GE04  37
QX(IP+2)=SIGF#                         Put sigf in buffer               GE04  38
QX(IP+3)=FLOAT(ISCL)#                  Put index scl grp in buffer      GE04  39
QX(IP+4)=S2L2#                         Put s2t/l2 in buffer             GE04  40
QX(IP+5)=RMUL#                         Put refln mult in buffer         GE04  41
QX(IP+6)=SQRT(ABS(E1))#                Put sqrt wilson ff**2 in buf     GE04  42
QX(IP+7)=SQRT(ABS(E2))#                Put sqrt group ff**2 in buff     GE04  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GE04  44
#                                                                       GE04  45
RETURN#                                                                 GE04  46
END#                                                                    GE04  47
systemheader:(GE05)#                   Calc and graph wilson plot       GE05   1
####################################################################    GE05   2
#                                                                  #    GE05   3
#                             GE05                                 #    GE05   4
#                                                                  #    GE05   5
####################################################################    GE05   6
SUBROUTINE GE05#                       S.r.hall  nov 80                 GE05   7
include:(AACOMN)#                                                       GE05   8
include:(GECOMN)#                                                       GE05   9
#                                                                       GE05  10
REAL A,B,C,D,S#                                                         GE05  11
REAL CEPT,CEPT1,CEPT2,SLOP,SLOP1,SLOP2##                                GE05  12
REAL BOT,FR,RM,SL,TOP#                                                  GE05  13
INTEGER II,IP,IS,JJ,LL,NP#                                              GE05  14
INTEGER I,J,K,L,M,N#                                                    GE05  15
chardata:(EV1,[ LINEAR LEAST SQUARES FIT OF LN(I(OBS)$#                 GE05  16
/I(EXP)) .VS. S**2])#                                                   GE05  17
chardata:(EV2,-)#                                                       GE05  18
chardata:(EV3, ADJUST WILSON PLOT FOR MISSING DATA)#                    GE05  19
chardata:(EV4,[ RANGE  MAXS2   SUMRM   FTHR2  SUMRM(FILLED)])#          GE05  20
chardata:(EV5, RANGE  SET S2  SUMRM  FREL2   AV.S2  F2/FF2  $#          GE05  21
F2/GF2  LN F2/FF2 LN F2/GF2)#                                           GE05  22
chardata:(EV6,[ SCALE (K)  O=E1 DATA .=E1 LINE *=E2 DATA +=E2 LINE @$#  GE05  23
=INFL.PT.])#                                                            GE05  24
chardata:(EV7,[ .........I SIN(THETA)/LAMBDA SQUARED])#                 GE05  25
realdata:(FM1,[120842.,200813.,290802.,360642.,440822.,520822.,#        GE05  26
620832.,720832.])#                                                      GE05  27
datastuff:#                                                             GE05  28
#                                                                       GE05  29
#    IS RANGE FILLING REQUESTED (ALLOW FOR ABSENT RFLNS)                GE05  30
#    ---------------------------------------------------                GE05  31
#                                                                       GE05  32
IF(IFIL>0)#                            Has fill flag been set           GE05  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GE05  34
movechar:(EV2,1,CHROT,2,NEV3-1,2)#     Underline range fill heading     GE05  35
writeline:(1,EV3,NEV3,2,3)#            Print range fill heading         GE05  36
IF(ICNT==0) FMUL=2.*FMUL#              Allow for centosymmetric         GE05  37
RVOL=32.*3.14159/(RVOL*FMUL*3.)#       Calc recip. vol factor           GE05  38
A=0.;   LINRM=4#                       Set s3t/l3 counter               GE05  39
FOR(I=I2;I<N0;I=I+10)#                 Loop over all ranges             GE05  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GE05  41
S=QX(I+1)**1.5#                        Calc s3t/l3 max of range         GE05  42
C=FTHR*FTHR#                           Default range threshold          GE05  43
D=QX(I+2)#                             Extract range population         GE05  44
IF(D>small:)#                          Ignore void ranges               GE05  45
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GE05  46
A=(S-A)*RVOL#                          Calc expected pop of range       GE05  47
B=A-D#                                 Calc difference from actual      GE05  48
IF(FTHR<0.) C=QX(I+8)*.5#              Set range threshold              GE05  49
IF(B>small:)#                          Test if range deficient          GE05  50
QX(I+3)=(QX(I+3)+B*C)*D/A#             Adjust sum of frel**2            GE05  51
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GE05  52
A=AMAX1(D,A)#                          Get effective range pop.         GE05  53
B=FLOAT((I-I2)/10+1)#                  Get range number from pointe     GE05  54
ncodefld:(B,1,CHROT,40213.,1)#         Put range number in buffer       GE05  55
ncodefld:(QX,I+1,CHROT,120842.,1)#     Put max s2 value in buffer       GE05  56
ncodefld:(D,1,CHROT,200813.,1)#        Put unfilled nref in buffer      GE05  57
ncodefld:(C,1,CHROT,290822.,1)#        Put fthr for range in buffer     GE05  58
ncodefld:(A,1,CHROT,360813.,1)#        Put filled nref in buffer        GE05  59
writeline:(0,EV4,NEV4,1,3)#            Print range fill values          GE05  60
A=S#                                   Reset s3t/l3 for next range      GE05  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GE05  62
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GE05  63
#                                                                       GE05  64
#                                                                       GE05  65
#   CALCULATE AVERAGE RATIO F2/<F2> FOR WILSON SUMS                     GE05  66
#   ----------------------------------------------                      GE05  67
#                                                                       GE05  68
FOR(I=I2;I<N0;I=I+10)#                 Loop over all s2 ranges          GE05  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GE05  70
IF(QX(I+2)<0.5) NEXT#                  Skip void ranges                 GE05  71
QX(I+5)=QX(I+2)*QX(I+3)/QX(I+5)#       Ratio for e1                     GE05  72
QX(I+6)=QX(I+2)*QX(I+3)/QX(I+6)#       Ratio for e2                     GE05  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GE05  74
#                                                                       GE05  75
#                                                                       GE05  76
#    OVERLAP S2T/L2 RANGES TO SMOOTH CURVE                              GE05  77
#    -------------------------------------                              GE05  78
#                                                                       GE05  79
L=10*MIN0(4,NINT(200./(QX(I2+207)+.5))/2)# Est degree of overlap        GE05  80
L=MAX0(L,10);   LL=M0-9#               Ensure overlap - start targe     GE05  81
FOR(I=I2+1;I<N0;I=I+10)#               Loop over origin s2t/l2 rang     GE05  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GE05  83
LL=LL+10#                              Incr target range                GE05  84
IF(QX(I+1)<0.5) NEXT#                  Ignore void ranges               GE05  85
II=MAX0(I2+1,I-L)#                     Get lowest overlap range         GE05  86
JJ=MIN0(N0-9,I+L)#                     Get highest overlap range        GE05  87
K=MIN0(I-II,JJ-I)#                     Ensure ranges balanced           GE05  88
FOR(II=I-K;II<=I+K;II=II+10)#          Loop over overlap ranges         GE05  89
DO J=1,5#                              Loop over origin sums            GE05  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GE05  91
N=LL+J;   M=II+J#                      Point to origin /target rang     GE05  92
QX(N)=QX(N)+QX(M)#                     Sum ls sums                      GE05  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GE05  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GE05  95
#                                                                       GE05  96
#                                                                       GE05  97
#  GET 5 HIGHEST RATIOS FOR INFLEXION PT. L.S.                          GE05  98
#  --------------------------------------------                         GE05  99
#                                                                       GE05 100
movereal:(0.,1,QX,I2+1,100,2)#         Zeroize part of buffer2          GE05 101
FOR(I=M0;I<M1;I=I+10)#                 Loop over overlapped ranges      GE05 102
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GE05 103
IF(QX(I+2)<0.5) NEXT#                                                   GE05 104
A=QX(I+5)/QX(I+2)#                     Get mean e1 ratio for range      GE05 105
FOR(J=I2+1;J<=I2+5;J=J+1)#             Loop 5 possible points           GE05 106
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GE05 107
IF(A<=QX(J+20)) NEXT#                  Sort out biggest ratios          GE05 108
IF(J<I2+5)#                            If not last sorted value         GE05 109
FOR(K=I2+4;K>=J;K=K-1)#                Reverse loop sorted ratios       GE05 110
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GE05 111
QX(K+21)=QX(K+20); QX(K+41)=QX(K+40)#  Make space for new value         GE05 112
QX(K+61)=QX(K+60); QX(K+81)=QX(K+80)#  Make space for new value         GE05 113
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GE05 114
QX(J+20)=A#                            Store new e1 ratio               GE05 115
QX(J+40)=QX(I+4)/QX(I+2)#              Store new mean s2t/l2            GE05 116
QX(J+60)=QX(I+2)#                      Store new range population       GE05 117
QX(J+80)=FLOAT(I)#                     Store graph seq number           GE05 118
BREAK#                                 Jump to next ratio               GE05 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GE05 120
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GE05 121
#                                                                       GE05 122
#                                                                       GE05 123
# FIND 5 DATA POINTS AT INFLEXION S2 VALUES                             GE05 124
# -----------------------------------------                             GE05 125
#                                                                       GE05 126
I=FLX1/S2IN+.001;  I=I*10+M0-20#       Point to start of range 1        GE05 127
J=FLX2/S2IN+.001;  J=J*10+M0-20#       Point to start of range 2        GE05 128
NINF=5#                                Set inflexion point count        GE05 129
FOR(K=I2+1;K<=I2+5;K=K+1)#             Loop over 5 points               GE05 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GE05 131
IF((I<=M1-10)&(QX(I+2)>0.5))#          Ignore void ranges               GE05 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GE05 133
QX(K+25)=QX(I+5)/QX(I+2)#              Store e1 ratio                   GE05 134
QX(K+45)=QX(I+4)/QX(I+2)#              Store mean s2t/l2                GE05 135
QX(K+65)=QX(I+2)#                      Store range population           GE05 136
QX(K+85)=FLOAT(I)#                     Store graph seq number           GE05 137
NINF=NINF+1#                           Count inflexion points           GE05 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GE05 139
IF((J<=M1-10)&(QX(J+2)>0.5))#          Ignore void ranges               GE05 140
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GE05 141
QX(K+30)=QX(J+5)/QX(J+2)#              Store e1 ratio                   GE05 142
QX(K+50)=QX(J+4)/QX(J+2)#              Store mean s2t/l2                GE05 143
QX(K+70)=QX(J+2)#                      Store range population           GE05 144
QX(K+90)=FLOAT(J)#                     Store graph seq number           GE05 145
NINF=NINF+1#                           Count inflexion points           GE05 146
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GE05 147
I=I+10;  J=J+10#                       Incr to next range               GE05 148
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GE05 149
#                                                                       GE05 150
#                                                                       GE05 151
#         ACCUMULATE LEAST SQUARES SUMS                                 GE05 152
#        ---------------------------------                              GE05 153
#                                                                       GE05 154
S=S2MX/80.#                            Incr to change range max to      GE05 155
writeline:(0,0,0,1,3);  LINRM=4#       Force blank lines for dump       GE05 156
FOR(M=M0;M<M1;M=M+10)#                 Loop over all ranges             GE05 157
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GE05 158
QX(M+1)=QX(M+1)-S#                     Convert st2/l2 max to centre     GE05 159
IF(QX(M+2)<0.5) NEXT#                  Ignore void ranges               GE05 160
IF(QX(M+3)<.01) NEXT#                  Also where f2sum is zero         GE05 161
A=QX(M+2)#                             Extract range population         GE05 162
QX(M+3)=QX(M+3)/A#                     Calc mean frel2                  GE05 163
QX(M+4)=QX(M+4)/A#                     Calc mean s2t/l2                 GE05 164
QX(M+5)=QX(M+5)/A#                     Calc mean e1 ratio               GE05 165
QX(M+6)=QX(M+6)/A#                     Calc mean e2 ratio               GE05 166
QX(M+7)= ALOG(QX(M+5))#                Store ln(e1 ratio)               GE05 167
QX(M+8)= ALOG(QX(M+6))#                Store ln(e2 ratio)               GE05 168
B=-QX(M+7)#                            Make ready for ls sums           GE05 169
C=-QX(M+8)#                            Make ready for ls sums           GE05 170
D= QX(M+4)#                            Make ready for ls sums           GE05 171
QX(I2+1)=QX(I2+1)+  1.#                Sum population                   GE05 172
QX(I2+2)=QX(I2+2)+  D#                 Sum s**2                         GE05 173
QX(I2+3)=QX(I2+3)+  D*D#               Sum (s**2)**2                    GE05 174
QX(I2+4)=QX(I2+4)+  B#                 Sum ln random                    GE05 175
QX(I2+5)=QX(I2+5)+  B*D#               Sum ln random*s**2               GE05 176
QX(I2+6)=QX(I2+6)+  C#                 Sum ln ordered                   GE05 177
QX(I2+7)=QX(I2+7)+  C*D#               Sum ln ordered*s**2              GE05 178
QX(I2+8)=QX(I2+8)-  B#                 Sum random ln                    GE05 179
QX(I2+9)=QX(I2+9)+  1.#                Sum intervals used               GE05 180
QX(I2+10)=QX(I2+10)+B*B#               Sum ln random sqd                GE05 181
#                                                                       GE05 182
IF(PPRIOR<5) NEXT#                     Test for dump of overlapped      GE05 183
A=FLOAT((M-M0)/10+1)#                  Get range number from pointe     GE05 184
ncodefld:(A,1,CHROT,40313.,1)#         Put range number into buffer     GE05 185
ncodefld:(QX,M+1,CHROT,FM1,8)#         Put wilson values into buffe     GE05 186
writeline:(0,EV5,NEV5,1,3)#            Print wilson values + head       GE05 187
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GE05 188
#                                                                       GE05 189
A=1./(QX(I2+1)*QX(I2+3)-QX(I2+2)*QX(I2+2))# Calc ls denominator         GE05 190
B1=A*(QX(I2+1)*QX(I2+5)-QX(I2+2)*QX(I2+4))# Random overall b            GE05 191
B2=A*(QX(I2+1)*QX(I2+7)-QX(I2+2)*QX(I2+6))# Ordered overall b           GE05 192
S1=A*(QX(I2+3)*QX(I2+4)-QX(I2+2)*QX(I2+5))# Random ln(scale)            GE05 193
S2=A*(QX(I2+3)*QX(I2+6)-QX(I2+2)*QX(I2+7))# Ordered ln(scale)           GE05 194
A=A*(S1*S1*QX(I2+1)+2.*B1*S1*QX(I2+2)$## Calculate chisqr/n-m           GE05 195
+B1*B1*QX(I2+3)-2.*S1*QX(I2+4)$#       Calculate chisqr/n-m             GE05 196
-2.*B1*QX(I2+5)+QX(I2+10))/39.#        Calculate chisqr/n-m             GE05 197
DELS=A*QX(I2+3)/2.#                    %**2 of wilson scale             GE05 198
DELX=A*QX(I2+2)#                       Covariance (b,s)                 GE05 199
DELB=A*QX(I2+1)/2.#                    Esd**2 of overall t.f.           GE05 200
S1=EXP(S1/2.)      ;S2=EXP(S2/2.)#     Convert to f-scales              GE05 201
B1=B1/2.           ;B2=B2/2.#          Convert to t.f.                  GE05 202
S=100000000.;   B=0.#                  Set inflexion default values     GE05 203
#                                                                       GE05 204
#                                                                       GE05 205
#   INFLEXION POINT LEAST SQUARES                                       GE05 206
#   ------------------------------                                      GE05 207
#                                                                       GE05 208
IF(NINF>5)#                            If sufficient inflexion poin     GE05 209
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GE05 210
FOR(I=I2+1;I<I2+15;I=I+1)#             Loop over inflexion points       GE05 211
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GE05 212
IF(QX(I+60)<0.5) NEXT#                 Ignore void ranges               GE05 213
A=-ALOG(QX(I+20))#                     Calc ln(e1 ratio)                GE05 214
B=      QX(I+40)#                      Extract mean s2t/l2              GE05 215
C=      QX(I+60)#                      Extract population acs weigh     GE05 216
J= ABS(QX(I+80))+.001#                 Extract graph seq number         GE05 217
QX(J+9)=-1.#                           Mark wilson range as infl.pt     GE05 218
QX(I2+11)=QX(I2+11)+C#                 Sum weights                      GE05 219
QX(I2+12)=QX(I2+12)+C*B#               Sum weighted s2t/l2              GE05 220
QX(I2+13)=QX(I2+13)+C*B*B#             Sum weighted (s2t/l2)**2         GE05 221
QX(I2+14)=QX(I2+14)+C*A#               Sum weighted ln ratio            GE05 222
QX(I2+15)=QX(I2+15)+C*A*B#             Sum weighted ln*s2t/l2           GE05 223
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GE05 224
A=1./(QX(I2+11)*QX(I2+13)-QX(I2+12)*QX(I2+12))# Calc ls denominator     GE05 225
B= A*(QX(I2+11)*QX(I2+15)-QX(I2+12)*QX(I2+14))# Calc b estimate         GE05 226
C= A*(QX(I2+13)*QX(I2+14)-QX(I2+12)*QX(I2+15))# Calc k estimate         GE05 227
S=EXP(C/2.);   B=B/2.#                 Inflexion f-scale & t.f.         GE05 228
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GE05 229
#                                                                       GE05 230
S1=AMIN1(S,S1) ;   B1=AMAX1(B,B1)#     Select optimum values of b &     GE05 231
IF(NFRG==0) S2=S1#                     For no frags set 2=1             GE05 232
IF(NFRG==0) B2=B1#                     For no frags set 2=1             GE05 233
IF(BOVL>small:) B2=BOVL#               If b input set for e2            GE05 234
IF(SOVL>small:) S2=SOVL#               If k input set for e2            GE05 235
#                                                                       GE05 236
#                                                                       GE05 237
#   PREPARE INTERPOLATED SCALE CURVES                                   GE05 238
#   ---------------------------------                                   GE05 239
#                                                                       GE05 240
QX(M0+1)=0.;  QX(M1-9)=S2MX+small:#    Force limits of curve            GE05 241
A=0.;  S=S2MX/100.#                    Set s2t/l2 counters              GE05 242
FOR(I=N1+NSCF;I<N2;I=I+NSFF)#          Loop over 101 s2t/l2 ranges      GE05 243
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GE05 244
QX(I+1)=S1*EXP(B1*A)#                  Calc curve for e1                GE05 245
QX(I+2)=S2*EXP(B2*A)#                  Calc curve for e2                GE05 246
IF(ICRV>0)#                            If profile fit requested         GE05 247
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GE05 248
J=INT(A/S2IN);  J=J*10+M0;  K=J+10#    Point to closest wilson ra       GE05 249
WHILE(QX(J+2)<small:) J=J-10#          Move down from void range        GE05 250
WHILE(QX(K+2)<small:) K=K+10#          Move up   from void range        GE05 251
IF((J>=M0)&(K<=M1))#                   If within upper & lower boun     GE05 252
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GE05 253
C=(A-QX(J+1))/(QX(K+1)-QX(J+1))#       Calc interpolation fraction      GE05 254
B=QX(I+2)#                             Store |e2| linear scale          GE05 255
QX(I+2)=1./SQRT(QX(J+6)+C*(QX(K+6)-QX(J+6)))# Calc curve for e2         GE05 256
QX(I)=(B/QX(I+2)-1.)**2#               Estimate %**2 for |e2| curve     GE05 257
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GE05 258
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GE05 259
A=A+S#                                 Incr s2t/l2 value                GE05 260
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GE05 261
#                                                                       GE05 262
#                                                                       GE05 263
#   CALCULATE RESCALING FACTORS                                         GE05 264
#   ---------------------------                                         GE05 265
#                                                                       GE05 266
R1=0.; R2=0.; Q1=0.; Q2=0.#            Zero scaling sums                GE05 267
E1MIN=10.;   E2MIN=10.#                Initialize |e| minima            GE05 268
N=N1+NSCF;  S=S2MX/100.#               Set s2t/l2 counters              GE05 269
REPEAT#                                Loop over reflns in scratch      GE05 270
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 GE05 271
readwpkt:(3,2,NP,IP,0)#                Point to next refln packet       GE05 272
IF(IP<=0) BREAK#                       Exit loop if no more             GE05 273
FR=QX(IP+1);  IS=NINT(QX(IP+3))#       Extract frel2 & index group      GE05 274
SL=QX(IP+4);  RM=QX(IP+5)#             Extract slt/l2 & refln mult.     GE05 275
I=INT(SL/S);  I=I*NSFF+N#              Point to scale cur               GE05 276
E1=(FR*QX(I+1)/QX(IP+6))**2#           Calc norm s.f. 1                 GE05 277
E2=(FR*QX(I+2)/QX(IP+7))**2#           Calc norm s.f. 2                 GE05 278
E1MIN=AMIN1(E1MIN,E1)#                 Find minimum |e1|**2             GE05 279
E2MIN=AMIN1(E2MIN,E2)#                 Find minimum |e2|**2             GE05 280
R1=R1+RM*E1#                           Sum weighted |e1|**2             GE05 281
Q1=Q1+RM#                              Sum weights                      GE05 282
IF(IS==0)#                             Test if index scale requeste     GE05 283
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 GE05 284
R2=R2+RM*E2#                           Sum weighted (e2)**2             GE05 285
Q2=Q2+RM#                              Sum weights                      GE05 286
NEXT#                                  Get the next hkl                 GE05 287
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 GE05 288
J=(IS-1)*17+M4#                        Point to index scale table       GE05 289
IF(QX(J+17)<(-1.)) NEXT#               Test if scales preset            GE05 290
QX(J+16)=QX(J+16)+RM*E2#               Sum weighted (e2)**2             GE05 291
QX(J+17)=QX(J+17)+RM#                  Sum weights                      GE05 292
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 GE05 293
readwpkt:(3,endrecord:,NP,IP,0)#       Finish off reading file3         GE05 294
R1=SQRT(Q1/R1)*S1#                     Calc overall rescale |e1|        GE05 295
IF(R2>0.) R2=SQRT(Q2/R2)*S2#           Calc overall rescale |e2|        GE05 296
ELSE      R2=S2#                       If not used set as scale 2       GE05 297
IF(NINK>0)#                            If index rescaling required      GE05 298
FOR(I=M4;I<N3;I=I+17)#                 Loop thru index groups           GE05 299
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 GE05 300
IF(QX(I+17)<small:) NEXT#              Skip void sums                   GE05 301
QX(I+16)=SQRT(QX(I+17)/QX(I+16))*S2#   Calculate index rescale 2        GE05 302
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 GE05 303
IF(SOVL>0) R2=SOVL#                    Ensure input scale retained      GE05 304
#                                                                       GE05 305
#          PREPARE TO GRAPH WILSON PLOT                                 GE05 306
#         --------------------------------                              GE05 307
#                                                                       GE05 308
CEPT1=-2.*ALOG(S1)#                    E1 intercept at s**2=0           GE05 309
CEPT2=-2.*ALOG(S2)#                    E2 intercept at s**2=0           GE05 310
SLOP1= 2.*B1#                          E1 slope of ls line              GE05 311
SLOP2= 2.*B2#                          E2 slope of ls line              GE05 312
CEPT =AMAX1(CEPT1,CEPT2)#              Get highest cept                 GE05 313
SLOP =AMAX1(SLOP1,SLOP2)#              Get highest slope                GE05 314
#                                                                       GE05 315
IF(PPRIOR>=3)#                         Is graph to be output            GE05 316
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 GE05 317
A=0.;  B=QX(I2+8)/QX(I2+9)#            Set diff sum and graph mean      GE05 318
FOR(L=M0;L<M1;L=L+10)#                 Loop all wilson ranges           GE05 319
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 GE05 320
QX(L+3)=-SLOP1*QX(L+1)+CEPT1#          Store e1 line ln                 GE05 321
QX(L+4)=-SLOP2*QX(L+1)+CEPT2#          Store e2 line ln                 GE05 322
QX(L+10)=FLOAT((L-M0)/5+1)#            Store interval number            GE05 323
IF(QX(L+2)<small:) NEXT#               Test null interval               GE05 324
A=A+ABS(QX(L+7)-B)#                    Sum mean difference              GE05 325
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 GE05 326
#                                                                       GE05 327
TOP=B+3.*A/QX(I2+9)#                   Estimate top ln                  GE05 328
BOT=B-3.*A/QX(I2+9)#                   Estimate bot ln                  GE05 329
A=-SLOP*S2MX+CEPT#                     Check high s**2                  GE05 330
TOP=AMAX1(TOP,CEPT+.1)#                Allow for intercept              GE05 331
BOT=AMIN1(BOT,A+.1)#                   Allow for high s**2              GE05 332
L=MIN0(prtlmax:-10,40)#                Permissible lines down           GE05 333
BOT=(TOP-BOT)/FLOAT(L-3)#              Calc interval for ln             GE05 334
A=TOP+.5*BOT#                          Initialize ln top                GE05 335
B=TOP#                                 Initialize ln centre             GE05 336
C=TOP-.5*BOT#                          Initialize ln bottom             GE05 337
#                                                                       GE05 338
movechar:(EV1,1,CHROT,20,NEV1,0)#      Put graph heading in buffer      GE05 339
LINRM=L+10; writeline:(1,0,0,1,3)#     Print graph heading              GE05 340
movechar:(EV2, 1,CHROT,21,NEV1-1,1)#   Put underline in buffer          GE05 341
writeline:(1,0,0,1,3)#                 Print heading underline          GE05 342
movechar:(EV6,1,CHROT,1,10,0)#         Put scale heading in buffer      GE05 343
movechar:(EV6,12,CHROT,24,NEV6-11,0)#  Put graph key in buffer          GE05 344
writeline:(0,0,0,1,3)#                 Print at top of graph            GE05 345
#                                                                       GE05 346
DO N=1,L#                              Loop over lines down             GE05 347
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 GE05 348
IF((N==1)\(N==L))#                     For top and bot borders          GE05 349
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 GE05 350
movechar:(EV7,11,CHROT,8,1,0)#         Put .i in border                 GE05 351
FOR(I=9;I<89;I=I+10)#                  Loop along the border            GE05 352
movechar:(EV7,2,CHROT,I,10,0)#         Put ........i in buff            GE05 353
writeline:(0,0,0,1,3)#                 Print horiz. border              GE05 354
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 GE05 355
ELSE#                                  For all other lines              GE05 356
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 GE05 357
FOR(I=M0;I<M1;I=I+10)#                 Loop over wilson ranges          GE05 358
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 GE05 359
M=NINT(QX(I+10))+7#                    Extract interval number          GE05 360
IF(M==7) NEXT#                         Skip null interval               GE05 361
IF(M>89) NEXT#                         Skip overflow                    GE05 362
IF(MOD(M  ,4)==0)#                     Filter e1-line points            GE05 363
IF((QX(I+3)<=A)&(QX(I+3)>=C))#         Is e1-line point eligible        GE05 364
movechar:(EV6,23,CHROT,M,1,1)#         Put (.) into buffer              GE05 365
IF(MOD(M-2,4)==0)#                     Filter e2-line points            GE05 366
IF((QX(I+4)<=A)&(QX(I+4)>=C))#         Is e2-line point eligible        GE05 367
movechar:(EV6,43,CHROT,M,1,1)#         Put (+) into buffer              GE05 368
IF(QX(I+2)>small:)#                    Plot only active ranges          GE05 369
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 GE05 370
IF((QX(I+8)<=A)&(QX(I+8)>=C))#         Is e2-data point eligible        GE05 371
movechar:(EV6,33,CHROT,M,1,1)#         Put (*) into buffer              GE05 372
IF((QX(I+7)<=A)&(QX(I+7)>=C))#         Is e1-data point eligible        GE05 373
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 GE05 374
IF(QX(I+9)>=0.) J=13#                  Test if inflexion pt.            GE05 375
ELSE              J=53#                Yes output as (@)                GE05 376
movechar:(EV6, J,CHROT,M,1,1)#         Put (o) into buffer              GE05 377
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 GE05 378
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 GE05 379
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 GE05 380
IF(MOD(N-2,5)==0)#                     For every 5th line               GE05 381
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 GE05 382
D=EXP(-B*.5)#                          Calculate the scale              GE05 383
ncodefld:(D,1,CHROT,60522.,1)#         Put scale into buffer            GE05 384
movechar:(EV2, 1,CHROT,  7,1,1)#       Put (-) in left border           GE05 385
movechar:(EV2, 1,CHROT, 89,1,1)#       Put (-) in right border          GE05 386
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 GE05 387
ELSE#                                  For other four lines             GE05 388
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 GE05 389
movechar:(EV6,23,CHROT,  7,1,1)#       Put (.) in left border           GE05 390
movechar:(EV6,23,CHROT, 89,1,1)#       Put (.) in right border          GE05 391
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 GE05 392
writeline:(0,0,0,1,3)#                 Print graph line                 GE05 393
A=A-BOT#                               Decrement range top              GE05 394
B=B-BOT#                               Decrement range mid              GE05 395
C=C-BOT#                               Decrement range bot              GE05 396
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 GE05 397
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 GE05 398
#                                                                       GE05 399
FOR(I=0;I<9;I=I+1)#                    Loop over 9 s**2 labels          GE05 400
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 GE05 401
A= 90532.+100000.*FLOAT(I);  J=I*50+2# Generate format                  GE05 402
ncodefld:(QX(M0),J,CHROT,A,1)#         Put s**2 values in buff          GE05 403
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 GE05 404
writeline:(0,0,0,1,3)#                 Print s**2 values                GE05 405
movechar:(EV7,13,CHROT,35,25,0)#       Put s**2 heading in buf          GE05 406
writeline:(0,0,0,1,3)#                 Print s**2 heading               GE05 407
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 GE05 408
#                                                                       GE05 409
#                                                                       GE05 410
RETURN#                                                                 GE05 411
END#                                                                    GE05 412
systemheader:(GE06)#                   Calc and output e-values         GE06   1
####################################################################    GE06   2
#                                                                  #    GE06   3
#                             GE06                                 #    GE06   4
#                                                                  #    GE06   5
####################################################################    GE06   6
SUBROUTINE GE06#                       S.r.hall  nov 80                 GE06   7
include:(AACOMN)#                                                       GE06   8
include:(GECOMN)#                                                       GE06   9
#                                                                       GE06  10
REAL A,B,S#                                                             GE06  11
REAL BUF(8)#                                                            GE06  12
REAL SCIN,SIGK,SIGS,STOL#                                               GE06  13
INTEGER IP,JP,L,MP,NADD,NP#                                             GE06  14
INTEGER I,J,K,N,M#                                                      GE06  15
chardata:(EV1,-)#                                                       GE06  16
chardata:(EV2,[ FOR I(EXP) ESTIMATED            U(OV)  SCALE])#         GE06  17
chardata:(EV3, FOR |E1| ESTIMATE)#                                      GE06  18
chardata:(EV4, FOR |E2| ESTIMATE)#                                      GE06  19
chardata:(EV5, INDEX GROUP SCALES)#                                     GE06  20
chardata:(EV6,[ GROUP (H+K+L)MOD=N   (H+K+L)MOD=N   (H+K+L$#            GE06  21
)MOD=N    FOR |E2|  SUMRM])#                                            GE06  22
chardata:(EV7, THEORY RANDOM P1B)#                                      GE06  23
chardata:(EV8, THEORY RANDOM P1)#                                       GE06  24
chardata:(EV9, E-STATISTICS MEAN |E|       |E**2|    |E**2-1|$#         GE06  25
   |E**2-1|2   |E**2-1|3)#                                              GE06  26
chardata:(EV10, E-DISTRIBUTION PERCENTAGES |E|>)#                       GE06  27
chardata:(EV11,     H   K   L     FREL   SIGF  ISG  S2/L2   $#          GE06  28
|E1|  SIGE1   |E2|  SIGE2)#                                             GE06  29
chardata:(EV12, LINEAR L.S. FIT OF WILSON PLOT)#                        GE06  30
chardata:(EV13, FROM CELCON ATOMS )#                                    GE06  31
chardata:(EV14, FROM FRAGMENT ATOMS  FOR |E2|)#                         GE06  32
chardata:(EV15, RENORMALIZED OR INPUT SCALES)#                          GE06  33
chardata:(EV16, OVERALL SCALES  FOR |E1|    SUMRM    FOR |E2|$#         GE06  34
    SUMRM)#                                                             GE06  35
chardata:(EV17, POPULATION)#                                            GE06  36
chardata:(EV18, MEAN ESD    |E|>)#                                      GE06  37
chardata:(EV19, FROM INPUT B AND K   FOR |E2|)#                         GE06  38
chardata:(EV20, MEAN ESD    S2/L2 =)#                                   GE06  39
chardata:(EV21, STANDARD DEVIATIONS)#                                   GE06  40
chardata:(EV22, FREL SCALE STORED ON BDF               )#               GE06  41
realdata:(ESTAT,[.798,1.,.968,2.,8.,.886,1.,.736,1.,2.])#               GE06  42
realdata:(EDIST,[.0, 1.0, 1.2, 1.4, 1.6, 1.8, 2.0, 2.5, 3.0,#           GE06  43
100.0,31.73,23.01,16.15,10.96, 7.19, 4.55, 1.24, 0.27,#                 GE06  44
100.0,36.79,23.69,14.09, 7.73, 3.92, 1.83, 0.19, 0.01])#                GE06  45
realdata:(FM1,[60413.,100413.,140413.,230822.,300522.,340203.,#         GE06  46
410642.,490822.,550622.,630822.,690622.])#                              GE06  47
realdata:(FM2,[250632.,370632.,490632.,610632.,730632.])#               GE06  48
realdata:(FM3,[250622.,320622.,390622.,460622.,530622.,600622.,#        GE06  49
670622.,740622.,810622.])#                                              GE06  50
realdata:(FM4,[250613.,320613.,390613.,460613.,530613.,600613.,#        GE06  51
670613.,740613.,810613.])#                                              GE06  52
realdata:(FM5,[90203.,110203.,130203.,160213.,190213.,#                 GE06  53
240203.,260203.,280203.,310213.,340213.,#                               GE06  54
390203.,410203.,430203.,460213.,490213.,#                               GE06  55
590842.,670513.])#                                                      GE06  56
realdata:(FM6,[250632.,320632.,390632.,460632.,530632.,600632.,#        GE06  57
670632.,740632.,810632.])#                                              GE06  58
realdata:(FM7,[340642.,400213.])#                                       GE06  59
datastuff:#                                                             GE06  60
#                                                                       GE06  61
#    OUTPUT ESTIMATED T.F. AND SCALE                                    GE06  62
#    -------------------------------                                    GE06  63
#                                                                       GE06  64
LINRM=6; writeline:(1,0,0,1,3)#        Force new page for |e|s          GE06  65
movechar:(EV1,1,CHROT,2,NEV12-1,2)#    Underline ls b/k heading         GE06  66
writeline:(0,EV12,NEV12,2,3)#          Print ls b/k heading             GE06  67
writeline:(0,EV2,NEV2,3,3)#            Print b/k subheading             GE06  68
movechar:(EV13,1,CHROT,1,NEV13,0)#     Put celcon heading in buffer     GE06  69
ncodefld:(B1/79.,1,CHROT,370642.,1)#   Put tf estimate 1 in buffer      GE06  70
ncodefld:(S1,1,CHROT,450842.,1)#       Put ls scale est 1 in buffer     GE06  71
writeline:(0,0,0,1,3)#                 Print celcon k & b values        GE06  72
IF(BOVL+SOVL>small:)#                  Test for input b and/or k        GE06  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GE06  74
movechar:(EV19,1,CHROT,1,NEV19,0)#     Put subheading in buffer         GE06  75
ncodefld:(B2/79.,1,CHROT,370642.,1)#   Put t.f. 2 in buffer             GE06  76
ncodefld:(S2,1,CHROT,450842.,1)#       Put scale 2 in buffer            GE06  77
writeline:(0,0,0,1,3)#                 Print input b,k values           GE06  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GE06  79
ELSE IF(NFRG>0)#                       If fragment atoms entered        GE06  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GE06  81
movechar:(EV14,1,CHROT,1,NEV14,0)#     Put fragmt heading in buffer     GE06  82
ncodefld:(B2/79.,1,CHROT,370642.,1)#   Put tf estimate 2 in buffer      GE06  83
ncodefld:(S2,1,CHROT,450842.,1)#       Put ls scale est 2 in buffer     GE06  84
writeline:(0,0,0,1,3)#                 Print fragmt k & b values        GE06  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GE06  86
A=S1*SQRT(DELS);  B=SQRT(DELB)#        Calc esds for printing           GE06  87
movechar:(EV21,1,CHROT,1,NEV21,0)#     Put esd subheading in buffer     GE06  88
ncodefld:(B/79.,1,CHROT,370642.,1)#    Put t.f. esd in buffer           GE06  89
ncodefld:(A,1,CHROT,450842.,1)#        Put scale esd in buffer          GE06  90
writeline:(0,0,0,1,3)#                 Print esd information            GE06  91
#                                                                       GE06  92
movechar:(EV1,1,CHROT,2,NEV15-1,2)#    Underline renorm scale headi     GE06  93
writeline:(1,EV15,NEV15,2,3)#          Print renorm scale heading       GE06  94
ncodefld:(R1,1,CHROT,230842.,1)#       Put rescale 1 in buffer          GE06  95
ncodefld:(Q1,1,CHROT,330813.,1)#       Put population in buffer         GE06  96
IF(Q2>small:)#                         If oval rescale 2 exists         GE06  97
ncodefld:(R2,1,CHROT,440842.,1)#       Put rescale 2 in buffer          GE06  98
ncodefld:(Q2,1,CHROT,540803.,1)#       Put population in buffer         GE06  99
writeline:(0,EV16,NEV16,2,3)#          Print head + rescale values      GE06 100
R1=R1/S1;   R2=R2/S2#                  Reset scales for e calculati     GE06 101
E1MIN=R1*SQRT(E1MIN)#                  Scale minimum |e1|               GE06 102
E2MIN=R2*SQRT(E2MIN)#                  Scale minimum |e2|               GE06 103
IF(NINK>0)#                            Test if index scales to be l     GE06 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GE06 105
writeline:(1,EV5,NEV5,3,3)#            Print index scale heading        GE06 106
LINRM=4#                               Ensure space and force head      GE06 107
FOR(I=M4;I<N3;I=I+17)#                 Loop over index group table      GE06 108
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GE06 109
A=FLOAT((I-M4)/17+1)#                  Convert pointer to index gro     GE06 110
ncodefld:(A,1,CHROT,40213.,1)#         Put index group no. in buffe     GE06 111
ncodefld:(QX,I+1,CHROT,FM5,17)#        Deposit scales in buffer         GE06 112
writeline:(0,EV6,NEV6,1,3)#            Write index scale info           GE06 113
ifeq:(QX(I+16),0.) NEXT#               Skip scale if null               GE06 114
QX(I+16)=QX(I+16)/S2#                  Reset index scale for |e2|       GE06 115
QX(I+17)=(R1/QX(I+16)-1.)**2#          Estimate %**2 for rescales       GE06 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GE06 117
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GE06 118
#                                                                       GE06 119
#                                                                       GE06 120
#      INPUT BINARY DATA FILE 1 & COPY/UPDATE TO FILE 2                 GE06 121
#      ------------------------------------------------                 GE06 122
#                                                                       GE06 123
copyfile:(1,2,1,decr:(lrscat:))#       Copy records to lrscat           GE06 124
#                                                                       GE06 125
#                                        ****** lrscat atn *********    GE06 126
IW(1)=1;  IW(2)=3#                     Set at/cell & atn idnums         GE06 127
KEY(1)=0; KEY(2)=0; KEY(3)=2; KEY(4)=0# Set search limits               GE06 128
indexpkt:(1,lrscat:,NP,IP,2,KEY,IW,IR)# Get packet seq numbers          GE06 129
MP=KEY(4)#                             Set output packet length         GE06 130
FOR(I=M2+20;I>0;I=I+1)#                Loop over atom contents          GE06 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GE06 132
readwpkt:(1,lrscat:,NP,IP,0)#          Point to input packet            GE06 133
IF(IP<=0) BREAK#                       Exit after last packet           GE06 134
writepkt:(2,lrscat:,MP,JP)#            Point to output packet           GE06 135
movereal:(QX,IP+1,QX,JP+1,NP,1)#       Transfer existing items          GE06 136
J=JP+IR(1); QX(J)=QX(I+1)#             Store at/cell word               GE06 137
J=JP+IR(2); QX(J)=QX(I+11)#            Store atomic number              GE06 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GE06 139
copyfile:(1,2,incr:(lrscat:),decr:(lrexpl:))# Copy to lrexpl            GE06 140
#                                                                       GE06 141
#                                        **** lrexpl scales ****        GE06 142
IW(1)=1#                               Set idnm for dsnm                GE06 143
FOR(I=0;I<=NSCL;I=I+1) IW(I+2)=100+I#  Setup scale want list            GE06 144
KEY(1)=1; KEY(2)=0; KEY(3)=I+1; KEY(4)=0# Set output controls           GE06 145
indexpkt:(1,lrexpl:,NP,IP,2,KEY,IW,IR)# Get scale group seq. num.       GE06 146
MP=KEY(4)#                             Set output packet length         GE06 147
writeline:(0,0,0,1,3)#                 Insert spacer                    GE06 148
REPEAT#                                Loop over all lr11 packets       GE06 149
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GE06 150
readwpkt:(1,lrexpl:,NP,IP,0)#          Point to next expl: packet       GE06 151
IF(IP<=0) BREAK#                       Exit loop if no more             GE06 152
writepkt:(2,lrexpl:,MP,JP)#            Point to output buffer           GE06 153
movereal:(0.,1,QX,JP+1,MP,2)#          Zeroize o/p packet               GE06 154
movereal:(QX,IP+1,QX,JP+1,NP,1)#       Copy existing information        GE06 155
ifne:(DSNM,QX(IP+IR(1))) NEXT#         Select correct data set          GE06 156
I=JP+IR(2); QX(I)=FLOAT(NSCL)#         Store scale group                GE06 157
DO I=1,NSCL#                           Loop over all scales             GE06 158
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GE06 159
J=JP+IR(I+2); K=N2+I#                  Point to op scale                GE06 160
QX(J)=QX(K)*S1*R1#                     Deposit new scales               GE06 161
BUFOT(2)=FLOAT(I)#                     Store scale group                GE06 162
BUFOT(1)=QX(J)#                        Store new frel scale             GE06 163
ncodefld:(BUFOT,1,EV22,FM7,2)#         Format items                     GE06 164
writeline:(0,EV22,NEV22,3,3)#          Print scale                      GE06 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GE06 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GE06 167
copyfile:(1,2,incr:(lrexpl:),decr:(lrdset:))# Copy to lrdset            GE06 168
#                                                                       GE06 169
#                                        **** lrdset b & frag ****      GE06 170
IW(1)=1;   IW(2)=2;   IW(3)=10#        Set dsnm, overall u ,frag        GE06 171
IW(4)=16;  IW(5)=17;  IW(6)=18#        Set min e1 & e2 & all ref        GE06 172
KEY(1)=1; KEY(2)=0; KEY(3)=6; KEY(4)=0# Set op packet controls          GE06 173
indexpkt:(1,lrdset:,NP,IP,2,KEY,IW,IR)# Get seqnums of want items       GE06 174
MP=KEY(4)#                             Get op packet size               GE06 175
REPEAT#                                Loop over all lr12 packets       GE06 176
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GE06 177
readwpkt:(1,lrdset:,NP,IP,0)#          Point to next dset: packet       GE06 178
IF(IP<=0) BREAK#                       Exit loop if no more             GE06 179
writepkt:(2,lrdset:,MP,JP)#            Point to start o/p packet        GE06 180
movereal:(0.,1,QX,JP+1,MP,2)#          Zeroize op packet                GE06 181
movereal:(QX,IP+1,QX,JP+1,NP,1)#       Copy existing lr12 words         GE06 182
ifne:(DSNM,QX(IP+IR(1))) NEXT#         Select correct data set          GE06 183
A=B1/79.#                              Convert ovb to ovu               GE06 184
I=JP+IR(2);  QX(I)=A#                  Store new tf                     GE06 185
I=JP+IR(3); movepakwd:(FRAG,QX(I))#    Pack frag data                   GE06 186
I=JP+IR(4);  QX(I)=E1MIN#              Store min |e1|                   GE06 187
I=JP+IR(5);  QX(I)=E2MIN#              Store min |e2|                   GE06 188
I=JP+IR(6);  QX(I)=TOTR#               Store total ref used             GE06 189
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GE06 190
#                                                                       GE06 191
IF(EOUT==no:) copyfile:(1,2,incr:(lrdset:),endrecord:)# No bdf e's      GE06 192
ELSE#                                  Output the e's to the bdf        GE06 193
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GE06 194
copyfile:(1,2,incr:(lrdset:),decr:(lrrefl:))# Copy to lrrefl:           GE06 195
#                                                                       GE06 196
#                                      **** update lrrefl ****          GE06 197
IW(1)=2;  IW(2)=3#                     Set s, e:m                       GE06 198
DO I=1,ITEM;  IW(I+2)=IZ(I)#           Insert output idnums             GE06 199
KEY(1)=2;  KEY(2)=0;   KEY(3)=ITEM+2#  Set idnum delimiters             GE06 200
KEY(4)=1#                              **** delete & add items          GE06 201
indexpkt:(1,lrrefl:,NP,IP,2,KEY,IW,IR)# Index ip/op directory           GE06 202
IF(KEY(4)<0) iquit:(GE0610)#           Exit if 2 or 3 missing           GE06 203
MP=KEY(4);   NADD=0#                   Store length op packet           GE06 204
DO I=1,ITEM; IF(IZ(I)>0) NADD=NADD+1#  Count number add items           GE06 205
#                                                                       GE06 206
#                                                                       GE06 207
#   BDF LOOP OVER ALL REFLECTIONS                                       GE06 208
#   -----------------------------                                       GE06 209
#                                                                       GE06 210
IF(ELST<10.)#                          Test if e's listed               GE06 211
writeline:(0,0,0,1,3); LINRM=10#       Prepare for e listing            GE06 212
movereal:(0.,1,QX,M0+1,110,2)#         Zero area for stats sums         GE06 213
N=N1+NSCF;   S=S2MX/100.;  B=S2MX/9.#  Set interpolation pointers       GE06 214
SIGK=0.;  SIGS=0.#                     Zero |e2| %**2 values            GE06 215
REPEAT#                                Loop over all refln packets      GE06 216
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GE06 217
readwpkt:(1,lrrefl:,NP,IP,0)#          Point to next refl: packet       GE06 218
IF(IP<=0) BREAK#                       Exit loop if no more             GE06 219
writepkt:(2,lrrefl:,MP,JP)#            Point to start o/p packet        GE06 220
K=3;  L=JP+1#                          Set archive & opbuff pnt         GE06 221
DO I=1,NP#                             Loop over input packet           GE06 222
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GE06 223
J=IP+I#                                Incr ip packet pointer           GE06 224
movepakwd:(QX(J),QX(L))#               Transfer ip to op packet         GE06 225
IF(IR(K)==I) K=K+1#                    Test if delete item              GE06 226
ELSE         L=L+1#                    Else no on delete list           GE06 227
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GE06 228
movereal:(voidflg:,1,QX,L,NADD,2)#     Void addon area in packet        GE06 229
#                                                                       GE06 230
I=IP+IR(1);  STOL=QX(I)#               Point to st/l value              GE06 231
IF(STOL>STMX) NEXT#                    Skip reflns over st/l limit      GE06 232
I=IP+IR(2)#                            Point to eps/mult word           GE06 233
#                                                                       GE06 234
readwpkt:(3,2,K,M,0)#                  Point to refln pkt file3         GE06 235
movereal:(QX,M+1,BUF,1,4,0)#           Put values in print buffer       GE06 236
FREL=QX(M+1)#                          Extract frel value               GE06 237
SIGF=(QX(M+2)/AMAX1(1.,FREL))**2#      Extract sigf & calc % error      GE06 238
SCIN=QX(M+3)#                          Extract index scale group        GE06 239
S2L2=QX(M+4)#                          Extract s2t/l2 value             GE06 240
RMUL=QX(M+5)#                          Extract reflection mult.         GE06 241
I=INT(S2L2/S);  I=I*NSFF+N#            Convert s2t/l2 to curve          GE06 242
E1=R1*FREL*QX(I+1)/QX(M+6)#            Calculate e1 value               GE06 243
E2=R2*FREL*QX(I+2)/QX(M+7)#            Calculate e2 value               GE06 244
IF(SCIN>small:)#                       Test if index rescales neede     GE06 245
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GE06 246
K=NINT(SCIN)*17-17+M4#                 Point index scale table          GE06 247
E2=E2*QX(K+16)/R2;  SIGS=QX(K+17)/2.#  Calc |e2| and %**2               GE06 248
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GE06 249
QX(M+2)=E1;  QX(M+3)=E2#               Store temp in scratch buffer     GE06 250
IF(ICRV>0) SIGK=QX(I)/2.#              If profile used for k-curve      GE06 251
A=SIGF+DELS+DELX*S2L2+DELB*S2L2*S2L2#  Sum error contributions          GE06 252
QX(M+4)=E1*SQRT(A)#                    Store esd of e1 for bdf          GE06 253
QX(M+5)=E2*SQRT(A+SIGS+SIGK)#          Store esd of e2 for bdf          GE06 254
K=M+1#                                 Set stored data pointer          GE06 255
DO I=1,ITEM#                           Loop over update list            GE06 256
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GE06 257
K=K+1#                                 Incr. update list pointer        GE06 258
IF(IZ(I)<0) NEXT#                      Skip delete only items           GE06 259
movepakwd:(QX(K),QX(L))#               Append new item to packet        GE06 260
L=L+1#                                 Incr. packet  pointer            GE06 261
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GE06 262
#                                                                       GE06 263
#                                        **** sum e-statistics ****     GE06 264
A=ABS(E1*E1-1.)#                       Precalc ((e1)**2-1)              GE06 265
QX(M0+1)=QX(M0+1)+RMUL*E1#             Sum e1                           GE06 266
QX(M0+2)=QX(M0+2)+RMUL*E1*E1#          Sum (e1)**2                      GE06 267
QX(M0+3)=QX(M0+3)+RMUL*A#              Sum (e1)**2-1                    GE06 268
QX(M0+4)=QX(M0+4)+RMUL*A*A#            Sum ((e1)**2-1)**2               GE06 269
QX(M0+5)=QX(M0+5)+RMUL*A*A*A#          Sum ((e1)**2-1)**3               GE06 270
A=ABS(E2**2-1.)#                       Precalc ((e2)**2-1)              GE06 271
QX(M0+6)=QX(M0+6)+RMUL*E2#             Sum e2                           GE06 272
QX(M0+7)=QX(M0+7)+RMUL*E2*E2#          Sum (e2)**2                      GE06 273
QX(M0+8)=QX(M0+8)+RMUL*A#              Sum ((e2)**2-1)                  GE06 274
QX(M0+9)=QX(M0+9)+RMUL*A*A#            Sum ((e2)**2-1)**2               GE06 275
QX(M0+10)=QX(M0+10)+RMUL*A*A*A#        Sum ((e2)**2-1)**3               GE06 276
DO I=1,9#                              Loop over distibution ranges     GE06 277
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GE06 278
IF(E1>=EDIST(I))#                      If e1 value above limit          GE06 279
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GE06 280
J=I+M0+10#                             Point to distribution range      GE06 281
QX(J   )=QX(J   )+RMUL#                Sum percentages                  GE06 282
QX(J+20)=QX(J+20)+1.#                  Sum population                   GE06 283
QX(J+40)=QX(J+40)+QX(M+4)#             Sum esds                         GE06 284
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GE06 285
IF(E2>=EDIST(I))#                      If e2 value above limit          GE06 286
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GE06 287
J=I+M0+20#                             Point to distribution range      GE06 288
QX(J   )=QX(J   )+RMUL#                Sum percentages                  GE06 289
QX(J+20)=QX(J+20)+1.#                  Sum population                   GE06 290
QX(J+40)=QX(J+40)+QX(M+5)#             Sum esds                         GE06 291
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GE06 292
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GE06 293
I=NINT(S2L2/B)+M0#                     Point to s**2 range for esds     GE06 294
QX(I+71)=QX(I+71)+QX(M+4)#             Sum esds for |e1|                GE06 295
QX(I+81)=QX(I+81)+QX(M+5)#             Sum esds for |e2|                GE06 296
QX(I+91)=QX(I+91)+S2L2#                Sum s2/l2                        GE06 297
QX(I+101)=QX(I+101)+1.#                Count range population           GE06 298
#                                                                       GE06 299
#                                        **** list reflection data **** GE06 300
IF((E1<ELST)&(E2<ELST)) NEXT#          Skip reflns below limit          GE06 301
BUF(5)=QX(M+2);   BUF(6)=QX(M+4)#      Put e1 & e2 in print buffer      GE06 302
BUF(7)=QX(M+3);   BUF(8)=QX(M+5)#      Put sige1 & sige2 in buffer      GE06 303
gethkl:(IP+1,H)#                       Unpack signed h,k,l              GE06 304
ncodefld:(H,1,CHROT,FM1,3)#            Format h,k,l for listing         GE06 305
ncodefld:(BUF,1,CHROT,FM1(4),8)#       Format frel,sigf,s2l2,indk       GE06 306
writeline:(0,EV11,NEV11,1,3)#          Print all these goodies          GE06 307
#                                                                       GE06 308
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GE06 309
#                                                                       GE06 310
#   PRINT E-STATS AND DISTRIBUTION                                      GE06 311
#   ------------------------------                                      GE06 312
#                                                                       GE06 313
A=QX(M0+11);   QX(M0+10)=QX(M0+10)/A#  Prepare to scale stats & dis     GE06 314
FOR(I=M0+1 ;I<M0+10;I=I+1)#            Loop over percentages            GE06 315
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GE06 316
QX(I)=QX(I)/A#                         Calculate mean values            GE06 317
QX(I+10)=QX(I+10)*100./A#              Calculate e1 distribution        GE06 318
QX(I+20)=QX(I+20)*100./A#              Calculate e2 distribution        GE06 319
IF(QX(I+30)>small:)#                   Provided values exist            GE06 320
QX(I+50)=QX(I+50)/QX(I+30)#            Calculate mean esd e1            GE06 321
IF(QX(I+40)>small:)#                   Provided values exist            GE06 322
QX(I+60)=QX(I+60)/QX(I+40)#            Calculate mean esd e2            GE06 323
IF(QX(I+100)<small:) NEXT#             Skip void s**2 ranges            GE06 324
QX(I+70)=QX(I+70)/QX(I+100)#           Calc mean |e1| esd               GE06 325
QX(I+80)=QX(I+80)/QX(I+100)#           Calc mean |e2| esd               GE06 326
QX(I+90)=QX(I+90)/QX(I+100)#           Calc mean s2/l2 for range        GE06 327
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GE06 328
movechar:(EV1,1,CHROT,2,12,1)#         Put underline in buffer          GE06 329
writeline:(1,EV9,13,2,3)#              Print e-stats heading            GE06 330
movechar:(EV9,14,CHROT,17,NEV9-13,0)#  Put subheading in buffer         GE06 331
writeline:(0,0,0,1,3)#                 Print stats subheading           GE06 332
movechar:(EV7,1,CHROT,1,NEV7,0)#       Put sideline in buffer           GE06 333
ncodefld:(ESTAT,1,CHROT,FM2,5)#        Format theoretical stats         GE06 334
writeline:(0,0,0,1,3)#                 Print with heading               GE06 335
movechar:(EV8,1,CHROT,1,NEV8,0)#       Put sideline in buffer           GE06 336
ncodefld:(ESTAT,6,CHROT,FM2,5)#        Format theoretical stats         GE06 337
writeline:(0,0,0,1,3)#                 Print noncentric values          GE06 338
movechar:(EV3,1,CHROT,1,NEV3,0)#       Put sideline in buffer           GE06 339
ncodefld:(QX,M0+1,CHROT,FM2,5)#        Format experimental values       GE06 340
writeline:(0,0,0,1,3)#                 Print e1 statistics              GE06 341
movechar:(EV4,1,CHROT,1,NEV4,0)#       Put sideline in buffer           GE06 342
ncodefld:(QX,M0+6,CHROT,FM2,5)#        Format experimental values       GE06 343
writeline:(0,0,0,1,3)#                 Print e2 statistics              GE06 344
#                                                                       GE06 345
movechar:(EV1,1,CHROT,2,14,1)#         Put underline in buffer          GE06 346
writeline:(1,EV10,15,2,3)#             Print e-distr. heading           GE06 347
movechar:(EV10,16,CHROT, 2,NEV10-15,0)# Put subheading in buffer        GE06 348
ncodefld:(EDIST,1,CHROT,FM3,9)#        Put % limits in subheading       GE06 349
writeline:(0,0,0,1,3)#                 Print stats subheading           GE06 350
movechar:(EV7,1,CHROT,1,NEV7,0)#       Put sideline in buffer           GE06 351
ncodefld:(EDIST,10,CHROT,FM3,9)#       Format theoretical distr.        GE06 352
writeline:(0,0,0,1,3)#                 Print values with heading        GE06 353
movechar:(EV8,1,CHROT,1,NEV8,0)#       Put sideline in buffer           GE06 354
ncodefld:(EDIST,19,CHROT,FM3,9)#       Format theoretical distr.        GE06 355
writeline:(0,0,0,1,3)#                 Print non-centric values         GE06 356
movechar:(EV3,1,CHROT,1,NEV3,0)#       Put sideline in buffer           GE06 357
ncodefld:(QX,M0+11,CHROT,FM3,9)#       Format experimental values       GE06 358
writeline:(0,0,0,1,3)#                 Print e1 percentages             GE06 359
movechar:(EV4,1,CHROT,1,NEV4,0)#       Put sideline in buffer           GE06 360
ncodefld:(QX,M0+21,CHROT,FM3,9)#       Format experimental values       GE06 361
writeline:(0,0,0,1,3)#                 Print e2 percentages             GE06 362
writeline:(0,EV17,NEV17,3,3)#          Print population heading         GE06 363
movechar:(EV3,1,CHROT,1,NEV3,0)#       Put sideline in buffer           GE06 364
ncodefld:(QX,M0+31,CHROT,FM4,9)#       Format experimental values       GE06 365
writeline:(0,0,0,1,3)#                 Print e1 populations             GE06 366
movechar:(EV4,1,CHROT,1,NEV4,0)#       Put sideline in buffer           GE06 367
ncodefld:(QX,M0+41,CHROT,FM4,9)#       Format experimental values       GE06 368
writeline:(0,0,0,1,3)#                 Print e2 populations             GE06 369
#                                                                       GE06 370
movechar:(EV1,1,CHROT,2,NEV21-1,1)#    Put underline in buffer          GE06 371
writeline:(1,EV21,NEV21,2,3)#          Print esd heading                GE06 372
movechar:(EV18,1,CHROT,1,NEV18,0)#     Put sideline in buffer           GE06 373
ncodefld:(EDIST,1,CHROT,FM3,9)#        Put |e| limits in buffer         GE06 374
writeline:(0,0,0,1,3)#                 Print esd subheading             GE06 375
movechar:(EV3,1,CHROT,1,NEV3,0)#       Put sideline in buffer           GE06 376
ncodefld:(QX,M0+51,CHROT,FM3,9)#       Format experimental esds         GE06 377
writeline:(0,0,0,1,3)#                 Print e1 esds                    GE06 378
movechar:(EV4,1,CHROT,1,NEV4,0)#       Put sideline in buffer           GE06 379
ncodefld:(QX,M0+61,CHROT,FM3,9)#       Format experimental esds         GE06 380
writeline:(0,0,0,1,3)#                 Print e2 esds                    GE06 381
movechar:(EV20,1,CHROT,1,NEV20,0)#     Put s**2 subhead in buffer       GE06 382
ncodefld:(QX,M0+91,CHROT,FM6,9)#       Put s**2 values in buffer        GE06 383
writeline:(1,0,0,1,3)#                 Print s**2 values for ranges     GE06 384
movechar:(EV3,1,CHROT,1,NEV3,0)#       Put sideline in buffer           GE06 385
ncodefld:(QX,M0+71,CHROT,FM3,9)#       Format |e1| esd values           GE06 386
writeline:(0,0,0,1,3)#                 Print |e1| esds                  GE06 387
movechar:(EV4,1,CHROT,1,NEV4,0)#       Put sideline in buffer           GE06 388
ncodefld:(QX,M0+81,CHROT,FM3,9)#       Format |e2| esds                 GE06 389
writeline:(0,0,0,1,3)#                 Print |e2| esds                  GE06 390
#                                        **** copy lr21 -end ****       GE06 391
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Copy file 1 to file 2         GE06 392
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GE06 393
readwpkt:(3,endrecord:,I,J,0)#         Finish off scratch file 3        GE06 394
#                                                                       GE06 395
RETURN#                                                                 GE06 396
END#                                                                    GE06 397
pmacro:([no:])#                                                         GE06 398
