systemheader:(KB    )#                                                  KB     1
##   version: Aug93                                                             
##   version: Jan93                                                             
####################################################################### KB     2
#                                                                     # KB     3
#                           *** FINDKB ***                            # KB     4
#                                                                     # KB     5
#   FINDKB CALCULATES BY LEAST SQUARES THE LINEAR SCALE, K, AND THE   # KB     6
#     EXPONENTIAL SCALE, DBDNEW, TO PLACE ONE DATA SET ON THE SAME    # KB     7
#     RELATIVE SCALE AS ANOTHER AS IN THE EXPRESSION...               # KB     8
#       F(1) = K*EXP(+DBDNEW*S)*F(2), WHERE                           # KB     9
#         S = (SIN(THETA)/LAMBDA)**2 AND                              # KB    10
#         F(1) AND F(2) MAY BE F-RELATIVE, F-RELATIVE**2, F(+),       # KB    11
#         F(+)**2, F(-), F(-)**2, OR ANY OTHER TWO QUANTITIES         # KB    12
#         SPECIFIED BY PACKET NUMBER ON THE PROGRAM INITIATION LINE.  # KB    13
#         SUBSCRIPTS (1) AND (2) REFER TO DATA SET 1 AND DATA         # KB    14
#         SET 2, RESPECTIVELY.  THE (+) AND (-) SUBSCRIPTS            # KB    15
#         INDICATE (H,K,L) AND THE FRIEDEL-RELATED (-H,-K,-L).        # KB    16
#    THE PROGRAM CONTAINS THE METHOD OF SINGH AND RAMESESHAN FOR      # KB    17
#    SCALING PARENT (NATIVE) TO ISOMORPHOUS DATA.  THERE IS ALSO      # KB    18
#    PROVISION FOR OBTAINING MATHEWS RATIO OF REAL TO ANOMALOUS       # KB    19
#    SCATTERING.                                                      # KB    20
#                                                                     # KB    21
####################################################################### KB    22
#                                                                       KB    23
include:(XMACRO)#                                                       KB    24
#                                                                       KB    25
macro:(maxref:,50000)#                 Maximum number of reflection     KB    26
#                                                                       KB    27
extrude:(KBCOMN)#                                                       KB    28
INTEGER ANOM#      ## Signal yes:/no: anomolus scatter from dirivativ   KB    29
INTEGER CALL13#    ## Count of calls to subroutine kb13                 KB    30
INTEGER CENREF#    ## Centric reflection signal                         KB    31
INTEGER CENTST#    ## Signal 'centric' test in stats yes:/no:           KB    32
INTEGER LINEAR#    ## Signal 'linear' test in stats yes:/no:            KB    33
INTEGER LT1,LT2#   ## Rcodes for parent and derivative f values         KB    34
INTEGER NDIV#      ## Number of divisions                               KB    35
INTEGER SUMMIN#    ## Signals that summing is in progress               KB    36
#                                                                       KB    37
REAL DEL#          ## (stolmax**3-stolmin**3)/ndiv                      KB    38
REAL DELBP#        ## Temp factor of parent                             KB    39
REAL DBDNEW#       ## New delta b from kb13 routine                     KB    40
REAL DELBD#        ## Temp factor of derivative                         KB    41
REAL F1#           ## Average factor for parent                         KB    42
REAL F21#          ## F(+), data set of selected derivative             KB    43
REAL F22#          ## F(-), data set of selected derivative             KB    44
REAL MATTWK#       ## Mattthews acta(1966) k from page 233 vol 20       KB    45
REAL MATTWB#       ## Slope of plot that gives matthews k               KB    46
REAL SCALED#       ## Derivative data scale factor                      KB    47
REAL SCALEP#       ## Parent data scale                                 KB    48
REAL SCANEW#       ## New scale factor from kb13 routine                KB    49
REAL SCMIN#        ## Minimum stol**3                                   KB    50
REAL SSTOLS#       ## Stol**2                                           KB    51
REAL SCTOLC#       ## Stol**3                                           KB    52
REAL SIGFP#        ## Sigma f of avg f(+)(-) parent                     KB    53
REAL SIGF1#        ## Sigma f(+) derivative                             KB    54
REAL SIGF2#        ## Sigma f(-) derivative                             KB    55
REAL XNDIV#        ## Divisions of stol for wilson stats                KB    56
#                                                                       KB    57
COMMON/COMIKB/ANOM,CALL13,CENREF,CENTST,LINEAR,LT1,LT2,NDIV,SUMMIN#     KB    58
COMMON/COMFKB/DEL,DELBP,DBDNEW,DELBD,F1,F21,F22,$#                      KB    59
MATTWK,MATTWB,SCALED,SCALEP,$#                                          KB    60
SCANEW,SCTOLC,SSTOLS,SCMAX,$#                                           KB    61
SCMIN,SIGFP,SIGF1,SIGF2,XNDIV#                                          KB    62
endext:#                                                                KB    63
#                                                                       KB    64
systemheader:(KB00)#                                                    KB00   1
####################################################################### KB00   2
#                                                                     # KB00   3
#                               KB00                                  # KB00   4
#                                                                     # KB00   5
####################################################################### KB00   6
SUBROUTINE KB00#                       Jul 1980  s.t. freer             KB00   7
#                                                                       KB00   8
include:(AACOMN)#                                                       KB00   9
#..................UPDATE LOG....................                       KB00  10
# 25 FEB 1981  RAA & STF  CORRECTED CODE FOR CASE WHERE F+ OR F- ONLY   KB00  11
#                         WAS MEASURED FOR AN ENTIRE DATA SET.          KB00  12
#  8 APR 1981  STF        ADDED CODE FOR SIN(THETA) OR D-SPACING LIMITS KB00  13
#                                                                       KB00  14
# 22 FEB 1982  RMD       CORRECT TO USE UPDATED NUCLEUS ROUTINES        KB00  15
#                                                                       KB00  16
# 10 JUN 1986  JMS-DRH   UPDATED TO INCLUDE METHOD OF SINGH AND         KB00  17
#                        RAMESESHAN FOR SCALING NATIVE TO DERIVATIVE    KB00  18
#                                                                       KB00  19
CALL KB01#                             Read the bdf and compute         KB00  20
#                                         K and b.                      KB00  21
RETURN#                                                                 KB00  22
END#                                                                    KB00  23
systemheader:(KB01)#                                                    KB01   1
####################################################################### KB01   2
#                                                                     # KB01   3
#                               KB01                                  # KB01   4
#                                                                     # KB01   5
####################################################################### KB01   6
SUBROUTINE KB01#                                                        KB01   7
#                                        Jul 1980  s.t. freer           KB01   8
#                                        Jun 1986  j.m. stewart         KB01   9
#                                        Jun 1986  d.h. holland         KB01  10
include:(AACOMN)#                                                       KB01  11
include:(KBCOMN)#                                                       KB01  12
#                                                                       KB01  13
INTEGER ENDSYM#     ## End of symop string                              KB01  14
INTEGER FIRST#      ## Pointer to beginning of  character string.       KB01  15
INTEGER FSQUAD#    ## Signal if f derivative are as square              KB01  16
INTEGER FSQUAP#    ## Signal if f parent are as square                  KB01  17
INTEGER I#         ## Do loop and for loop index                        KB01  18
INTEGER IDN(2)#    ## Relative location of data se on input bdf.        KB01  19
INTEGER IPT#       ## Input packet pointer                              KB01  20
INTEGER J#         ## For loop index                                    KB01  21
INTEGER JPT#       ## Output packet pointer                             KB01  22
INTEGER K#         ## For loop index                                    KB01  23
INTEGER KEY(4)#    ## Keys for indexpkt                                 KB01  24
INTEGER KEYDS(4)#  ## Lrdset keys for indexpkt                          KB01  25
INTEGER LASTP1#    ## Pointer to last+1 character string.               KB01  26
INTEGER NCENT#     ## Centric/acentric space group as 0/1               KB01  27
INTEGER NCHAR#     ## Number of characters in stri                      KB01  28
INTEGER NCY#       ## Cycle counter statistics for s and r method       KB01  29
INTEGER NR#        ## Counter for reflections actually used.            KB01  30
INTEGER NREF#      ## Counter for reflections on input bdf.             KB01  31
INTEGER NREJST#    ## Number of reflections beyond sinth limits.        KB01  32
INTEGER NRJF1L#    ## Rejection count for Fobs1 < lower limit           KB01  33
INTEGER NRJF1U#    ## Rejection count for Fobs1 > upper limit           KB01  34
INTEGER NRJF2L#    ## Rejection count for Fobs2 < lower limit           KB01  35
INTEGER NRJF2U#    ## Rejection count for Fobs2 > upper limit           KB01  36
INTEGER NRJS1L#    ## Rejection count for Fobs1 < k*sig(f)              KB01  37
INTEGER NRJS1U#    ## Rejection count for Fobs1 > k*sig(f)              KB01  38
INTEGER NRJS2L#    ## Rejection count for Fobs2 < k*sig(f)              KB01  39
INTEGER NRJS2U#    ## Rejection count for Fobs2 > k*sig(f)              KB01  40
INTEGER NROT#      ## Number of symmetry rotations                      KB01  41
INTEGER NSET#      ## Number of data sets on the b                      KB01  42
INTEGER OFFSET(24)# ## Rel. offset to lrrefl: items                     KB01  43
INTEGER PACKST#    ## Packet number for stol                            KB01  44
INTEGER PACK11#    ## Packet number for f1 or f1(+                      KB01  45
INTEGER PACK12#    ## Packet number for f1 or f1(-                      KB01  46
INTEGER PACK21#    ## Packet number for f2 or f2(+                      KB01  47
INTEGER PACK22#    ## Packet number for f2 or f2(-                      KB01  48
INTEGER PSIZE#     ## Logical record packet size                        KB01  49
INTEGER PTF1#      ## Pointer to f1 storage in qx                       KB01  50
INTEGER PTF2#      ## Pointer to f2 storage in qx                       KB01  51
INTEGER PTS#       ## Pointer to sinth**2 in qx                         KB01  52
INTEGER RCOD11#    ## Rcode for parent f(+)                             KB01  53
INTEGER RCOD12#    ## Rcode for parent f(-)                             KB01  54
INTEGER RCOD21#    ## Rcode for dirivative f(+)                         KB01  55
INTEGER RCOD22#    ## Rcode for dirivative f(-)                         KB01  56
INTEGER SANDR#     ## Signal s and r method yes:/no:                    KB01  57
INTEGER STARF1#    ## Pointer to f1 storage in qx                       KB01  58
INTEGER STARF2#    ## Pointer to f2 storage in qx                       KB01  59
INTEGER STARSY#    ## Pointer to symops                                 KB01  60
INTEGER STARST#    ## Pointer to sinth storage in                       KB01  61
INTEGER WANT20(23)## Idnums requested                                   KB01  62
REAL A11#          ## Normal equation matrix                            KB01  63
REAL A12#          ##                                                   KB01  64
REAL A12D#         ## A12/determinant                                   KB01  65
REAL A22#          ##                                                   KB01  66
REAL BIGST#        ## Upper sine(theta)/lambda lim                      KB01  67
REAL BSINTH#       ## Exp(dbdnew*(sin(theta)/lambda)**2                 KB01  68
REAL C1#           ## Normal equation vector                            KB01  69
REAL C2#           ##                                                   KB01  70
REAL DELTAK#       ## Refinement shift for scale                        KB01  71
REAL DET#          ## Determinant of n.e. matrix                        KB01  72
REAL F2#           ## Mean f, data set two                              KB01  73
REAL F11#          ## F(+), data set one                                KB01  74
REAL F12#          ## F(-), data set one                                KB01  75
REAL RDEN#         ## R-factor denominator                              KB01  76
REAL RFACTR#       ## R-factor                                          KB01  77
REAL RNUM#         ## R-factor numerator                                KB01  78
REAL RZB#          ## Partial deriv. wrt delta-b                        KB01  79
REAL RZIDUL#       ## The residual being minimized                      KB01  80
REAL RZK#          ## Partial deriv. wrt scale                          KB01  81
REAL SMALST#       ## Lower sine(theta)/lambda lim                      KB01  82
REAL SIGK1#        ## K used for lower k*sig(fobs) limit                KB01  83
REAL SIGK2#        ## K used for upper k*sig(fobs) limit                KB01  84
REAL SMALF#        ## Lower Fobs limit                                  KB01  85
REAL BIGF#         ## Upper Fobs limit                                  KB01  86
REAL STOL#         ## Sin theta over lambda                             KB01  87
REAL SUMF1#        ##                                                   KB01  88
REAL SUMF2#        ##                                                   KB01  89
#                                                                       KB01  90
string:(ID,24)#    ## Identifiers for data sets                         KB01  91
string:(IDUC,24)#  ## Identifiers for data sets in upper case           Jan93001
string:(CH,12)#    ## Temporary storage for id                          KB01  92
string:(CHUC,12)#  ## Temporary storage for id in upper case            Jan93002
string:(MYD,3)#    ## Storage for options check                         KB01  93
#                                                                       KB01  94
chardata:(BDF,BDF)#                                                     KB01  95
chardata:(SQ1,SQ)#                                                      KB01  96
chardata:(KB011, LIMSTL LIMD   SANDR  LIMF   END    )#                  KB01  97
chardata:(KB012,       REFLECTIONS IN INPUT BDF)#                       KB01  98
chardata:(KB013,       REFLECTIONS USED)#                               KB01  99
chardata:(KB014,       INITIAL SCALE = SUM(F1)/SUM(F2))#                KB01 100
chardata:(KB015, K AND DBDNEW ARE USED IN THE EXPRESSION  F(1) = $#     KB01 101
K * EXP(+DBDNEW*SINTH**2) * F(2))#                                      KB01 102
chardata:(KB016, CYCLE       K    DBDNEW     R)#                        KB01 103
chardata:(KB017, INDEX   REFERS TO THE DATA SET CALLED             )#   KB01 104
chardata:(KB018, SCALING ON F**2)#                                      KB01 105
chardata:(KB019, INDEX   REFERS TO DATA WITH PACKET ID CATALOGUE $#     KB01 106
NUMBER      )#                                                          KB01 107
chardata:(KB01A,       REFLECTIONS OUT OF RANGE ON SIN(THETA))#         KB01 108
chardata:(KB01B, MINIMUM STOL = X.XXX  MAXIMUM STOL = X.XXX USED IN $#  KB01 109
FINDKB RUN.)#                                                           KB01 110
chardata:(KB01C, ACCOUNT OF REJECTED REFLECTIONS)#                      KB01 111
chardata:(KB01D,[          SCALED F1 < LOWER F LIMIT])#                 KB01 112
chardata:(KB01E,[          SCALED F1 > UPPER F LIMIT])#                 KB01 113
chardata:(KB01F,[          SCALED F2 < LOWER F LIMIT])#                 KB01 114
chardata:(KB01G,[          SCALED F2 > UPPER F LIMIT])#                 KB01 115
chardata:(KB01H,[          F1 < K1 * SIGMA(F)])#                        KB01 116
chardata:(KB01I,[          F1 > K2 * SIGMA(F)])#                        KB01 117
chardata:(KB01J,[          F2 < K1 * SIGMA(F)])#                        KB01 118
chardata:(KB01K,[          F2 > K2 * SIGMA(F)])#                        KB01 119
chardata:(KB01Z,[--> SANDR CYCLE XXX <--])#                             KB01 120
#                                                                       KB01 121
EQUIVALENCE (WANT20(2),PACKST),(WANT20(3),PACK11),(WANT20(4),PACK12)#   KB01 122
EQUIVALENCE (WANT20(5),PACK21),(WANT20(6),PACK22)#                      KB01 123
#                                                                       KB01 124
intdata:(BDFOUT,[0])#                  = yes: to write a bdf            KB01 125
intdata:(SQUARE,[0])#                  Set to yes:, if computation      KB01 126
realdata:(FMT011,[60513.,140742.,#                                      KB01 127
220722.,300722.])#                     Format                           KB01 128
realdata:(FMT012,[80113.,610413.])#                                     KB01 129
intdata:(WANT12,[1,30,31,36,37])#      Want list for lrdset:            KB01 130
intdata:(WANTDS,[1,14,15,30,31])#      Want list for lrdset:            KB01 131
intdata:(OFFDS,[0,0,0,0,0,0])#                                          KB01 132
datastuff:#                                                             KB01 133
#                                                                       KB01 134
# SET UP ASSUMPTIONS ABOUT PARENT DERIVITIVE SCALES AND DELTA B FACTORS KB01 135
#                                                                       KB01 136
SCALED = 1.0;SCALEP = 1.0#                                              KB01 137
DELBP = 0.0;DELBD = 0.0#                                                KB01 138
MATTWK = 1.0 ; MATTWB = 0.0#                                            KB01 139
NCYS = 3#                              Number of sandr cycles           KB01 140
NDIV = 6#                                                               KB01 141
CENREF = no:#                          Assume reflection all 3d         KB01 142
SIGF2 = 1.0; SIGF1 = 1.0; SIGFP = 1.0# Default sigma fs                 KB01 143
RCOD11=1;RCOD12=1;RCOD21=1;RCOD22=1#   Default rcodes for f obs         KB01 144
CENTST = yes:#                         Assume centric test              KB01 145
LINEAR = no:#                          Not assume linear test           KB01 146
SUMMIN = yes:#                         Assume summation in progress     KB01 147
ANOM = yes:#                           "  derivative has anomolus       KB01 148
CALL13 = 0#                            Zero calls to kb13               KB01 149
SMALF = 0.#                            Lower limit for f                KB01 150
BIGF  = 1000000.#                      Upper limit for f                KB01 151
SIGK1 = 0.#                            Lower limit for sigma            KB01 152
SIGK2 = 1000000.#                      Upper limit for sigma            KB01 153
NRJF1L= 0#                             No. refl s.t. f<lower limit      KB01 154
NRJF1U= 0#                             No. refl s.t. f>upper limit      KB01 155
NRJF2L= 0#                             No. refl s.t. f<lower limit      KB01 156
NRJF2U= 0#                             No. refl s.t. sig >lower limit   KB01 157
NRJS1U= 0#                             No. refl s.t. sig>upper lim      KB01 158
NRJS2L= 0#                                                              KB01 159
NRJS2U= 0#                                                              KB01 160
DO I=1,23; WANT20(I)=0#                                                 KB01 161
IDN(1) = 0#                                                             KB01 162
IDN(2) = 0#                                                             KB01 163
SANDR = no:#                           No singh & rameseshan method     KB01 164
#                                                                       KB01 165
# READ FINDKB LINE INPUT AND PROCESS SCALED QUANTITY IDENTIFIERS        KB01 166
#                                                                       KB01 167
ifvo:(BUFIN(1))  iquit:(KB0103,2)#     Data specifiers cannot           KB01 168
ifvo:(BUFIN(2))  iquit:(KB0103,3)#     Be void.                         KB01 169
#                                                                       KB01 170
# LAY OUT STORAGE FOR I/O BUFFERS                                       KB01 171
#                                                                       KB01 172
IOMARK(1) = QXSTR#                     Buffer for input bdf             KB01 173
IOMARK(2) = IOMARK(1) + bdfbuf:#       Output bdf buffer (not           KB01 174
incrqx:(STARSY,IOMARK(2)+bdfbuf:,KB0101)# Get memory                    KB01 175
#                                                                       KB01 176
# EXTRACT THE SYMMETRY CODES AND OPERATIONS FROM THE BDF                KB01 177
#                                                                       KB01 178
readwpkt:(1,lrsymm:,PSIZE,IPT,0)#      Read header packet               KB01 179
NCENT = NINT(QX(IPT+2))#               Centric/acentric = 0/1           KB01 180
NROT  = NINT(QX(IPT+4))#               Get number of rotation matri     KB01 181
incrqx:(ENDSYM,STARSY+NROT*12*(2-NCENT),KB0101)# Expand qx for symop    KB01 182
FOR (J=STARSY; J>0; J=J+12)#           Loop over symops                 KB01 183
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  KB01 184
readwpkt:(1,lrsymm:,PSIZE,IPT,0)#      Read the next packet             KB01 185
IF (IPT<=0) BREAK#                     Jump out when at end             KB01 186
movereal:(QX,IPT+1,QX,J+1,PSIZE,1)#    Save the symops                  KB01 187
IF(NCENT==0)#                          Check for center of symmetry     KB01 188
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  KB01 189
K = J#                                                                  KB01 190
FOR (I=STARSY; I<J; I=I+1)#            Loop back over symops            KB01 191
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  KB01 192
K=K+1; QX(K)= -QX(I+1)#                Generate through cen             KB01 193
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  KB01 194
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  KB01 195
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  KB01 196
#                                                                       KB01 197
# ARE THEY PACKET NUMBERS?                                              KB01 198
IF(BUFIN(1) > voidflg: \ BUFIN(2) > voidflg:)#                          KB01 199
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  KB01 200
WANT20(1)=1#                           Must have h,k and l.             KB01 201
PACKST=2#                              Must have stol                   KB01 202
WANT20(23)=3#                          Must phase code                  KB01 203
PACK11 = NINT(BUFIN(1))#               Save packet numbers              KB01 204
PACK12 = 0#                            Set other member to zero         KB01 205
PACK21 = NINT(BUFIN(2))#               In each pair.  the same          KB01 206
PACK22 = 0#                            For the other member.            KB01 207
IDN(1) = MAX0(INT(PACK11/1000),1)#     Data set num. of packet #'s      KB01 208
IDN(2) = MAX0(INT(PACK21/1000),1)#     Data set num. of packet #'s      KB01 209
IF(BDFOUT == yes:)  iquit:(KB0104)#    No output permitted when         KB01 210
#                                         Packet numbers are specified  KB01 211
#                                                                       KB01 212
# SPECIFY INDEX 1 AND ITS PACKET NUMBER AND WRITE IT OUT                KB01 213
BUFOT(1) = 1.#                                                          KB01 214
BUFOT(2) = BUFIN(1)#                                                    KB01 215
ncodefld:(BUFOT,1,KB019,FMT012(1),2)#                                   KB01 216
writeline:(1,KB019,NKB019,3,3)#                                         KB01 217
#                                                                       KB01 218
# SPECIFY INDEX 2 AND ITS PACKET NUMBER AND WRITE IT OUT                KB01 219
BUFOT(1) = 2.#                                                          KB01 220
BUFOT(2) = BUFIN(2)#                                                    KB01 221
ncodefld:(BUFOT,1,KB019,FMT012(1),2)#                                   KB01 222
writeline:(0,KB019,NKB019,3,3)#                                         KB01 223
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  KB01 224
#                                                                       KB01 225
ELSE#                                  Data set identifiers specifi     KB01 226
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  KB01 227
movechar:(BLANK,1,ID,1,24,1)#          Initialize identifiers           KB01 228
movechar:(BLANK,1,IDUC,1,24,1)#        Initialize identifiers u.c.      Jan93003
#                                         To blank.                     KB01 229
FOR(I=1; I <= 2; I=I+1)#               Loop over each named set         KB01 230
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  KB01 231
stringlim:(I,FIRST,LASTP1)#                                             KB01 232
NCHAR = MIN0((LASTP1-FIRST),12)#       Get length of name, 12           KB01 233
#                                         Characters maximum.           KB01 234
IF(NCHAR < 1)  iquit:(KB0105)#         There must be a name             KB01 235
movechar:(CHRIN,FIRST,ID,12*I-11,NCHAR,0)#                              KB01 236
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  KB01 237
upcase:(ID,IDUC,24)#                   Roll case to make compare        Jan93004
compchar:(IDUC,1,IDUC,13,12,12,12,K)#  If id's are the same it is       Jan93005
IF(K != 0)  iquit:(KB0106)#            An error.                        KB01 239
#                                                                       KB01 240
# NOW MAKE SURE THE SPECIFIED DATA SETS ARE ON THE BDF                  KB01 241
#                                                                       KB01 242
NSET=0#                                                                 KB01 243
REPEAT#                                                                 KB01 244
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  KB01 245
NSET=NSET+1#                                                            KB01 246
readwpkt:(1,lrddef:,PSIZE,IPT,0)#      On the input bdf.                KB01 247
IF(IPT <= 0)  BREAK#                                                    KB01 248
movertoc:(QX(IPT+1),1,CH,1,12,0)#      Is this one on the bdf?          KB01 249
upcase:(CH,CHUC,12)#                   Roll to upper case               Jan93006
FOR(I=1; I <= 2; I=I+1)#               Check both specified data se     KB01 250
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  KB01 251
compchar:(CHUC,1,IDUC,12*I-11,12,12,12,K)#                              Jan93007
IF(K != 0)  IDN(I) = NSET#             Found a match                    KB01 253
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  KB01 254
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  KB01 255
#                                                                       KB01 256
NSET = NSET - 1#                       Correct the data set count       KB01 257
#                                        2 data names must be on bdf    KB01 258
IF(IDN(1) == 0 \ IDN(2) == 0)  iquit:(KB0107)#                          KB01 259
#                                                                       KB01 260
# SET UP THE WANT LIST FOR THE REFLECTION RECORD.  THIS IS COMPLICATED  KB01 261
# BECAUSE THE FS AND SIGMA FS CAN COME IN SO MANY FORMS.                KB01 262
#                                                                       KB01 263
WANT20(1)=1#                           Must have h,k and l.             KB01 264
PACKST=2#                              Must have stol                   KB01 265
WANT20(23)=3#                          Must phase code                  KB01 266
PACK11 = 1000*IDN(1) + 304#            Compute the packet numbers       KB01 267
PACK12 = PACK11 + 10#                  For f(+) and f(-) for both       KB01 268
PACK21 = 1000*IDN(2) + 304#            Data sets.                       KB01 269
PACK22 = PACK21 + 10#                                                   KB01 270
WANT20(7) = PACK11 + 1#                Set up for sigma f11             KB01 271
WANT20(8) = PACK12 + 1#                Set up for sigma f12             KB01 272
WANT20(9) = PACK21 + 1#                Set up for sigma f21             KB01 273
WANT20(10) = PACK22 + 1#               Set up for sigma f22             KB01 274
WANT20(15) = PACK11 - 1#               Set up for sigma f11**2          KB01 275
WANT20(16) = PACK12 - 1#               Set up for sigma f12**2          KB01 276
WANT20(17) = PACK21 - 1#               Set up for sigma f21**2          KB01 277
WANT20(18) = PACK22 - 1#               Set up for sigma f22**2          KB01 278
WANT20(11)=PACK11+4;WANT20(12)=PACK12+4# Set up for rcodes              KB01 279
WANT20(13)=PACK21+4;WANT20(14)=PACK22+4# Set up for rcodes              KB01 280
WANT20(19)=PACK11-2#                   Possiblity of f(+)**2 parent     KB01 281
WANT20(20)=PACK12-2#                   Possiblity of f(-)**2 parent     KB01 282
WANT20(21)=PACK21-2#                   Possiblity of f(+)**2 deriv      KB01 283
WANT20(22)=PACK22-2#                   Possiblity of f(-)**2 deriv      KB01 284
#                                                                       KB01 285
# WRITE OUT SCALED DATA SETS                                            KB01 286
#                                                                       KB01 287
BUFOT(1) = 1.#                                                          KB01 288
ncodefld:(BUFOT,1,KB017,FMT012(1),1)#  Specify index 1 and              KB01 289
movechar:(ID,1,KB017,40,12,0)#         Its id and                       KB01 290
writeline:(1,KB017,NKB017,3,3)#        Write it out.                    KB01 291
BUFOT(1) = 2.#                         Write it out.                    KB01 292
ncodefld:(BUFOT,1,KB017,FMT012(1),1)#  Specify index 2 and              KB01 293
movechar:(ID,13,KB017,40,12,0)#        Its id and                       KB01 294
writeline:(0,KB017,NKB017,3,3)#        Write it out.                    KB01 295
#                                                                       KB01 296
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  KB01 297
#                                                                       KB01 298
# READ LRDSET: RECORD FOR MAX/MIN STOL, DELTA B AND SCALE FACTORS       KB01 299
#                                                                       KB01 300
SMALST = 10.0#                         Default for min stol             KB01 301
BIGST = voidflg:#                      Default for max stol             KB01 302
KEYDS(1) = 0#                                                           KB01 303
KEYDS(2) = 5#                                                           KB01 304
KEYDS(3) = 5#                                                           KB01 305
KEYDS(4) = 0#                                                           KB01 306
indexpkt:(1,lrdset:,PSIZE,IPT,0,KEYDS,WANTDS,OFFDS)#                    KB01 307
IF(KEYDS(4)<=0) iquit:(KB0113)#        Must get a record                KB01 308
REPEAT#                                Loop over all datasets           KB01 309
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  KB01 310
readwpkt:(1,lrdset:,PSIZE,IPT,0)#                                       KB01 311
IF(IPT <= 0) BREAK#                                                     KB01 312
J=IPT+OFFDS(1)#                        Get data set number              KB01 313
J=NINT(QX(J))#                         Change it into actual            KB01 314
IF(J==IDN(1)\J==IDN(2))#                                                KB01 315
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 KB01 316
IF(OFFDS(2) > 0) SMALST = AMIN1(SMALST,QX(IPT+OFFDS(2)))#               KB01 317
IF(OFFDS(3) > 0) BIGST = AMAX1(BIGST,QX(IPT+OFFDS(3)))#                 KB01 318
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 KB01 319
IF(J==IDN(1))#                         Is it parent?                    KB01 320
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 KB01 321
IF(OFFDS(4) > 0) SCALEP = QX(IPT+OFFDS(4))#                             KB01 322
ifvo:(SCALEP) SCALEP = 1.0#                                             KB01 323
IF(OFFDS(5) > 0) DELBP = QX(IPT+OFFDS(5))#                              KB01 324
ifvo:(DELBP) DELBP = 0.0#                                               KB01 325
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 KB01 326
ELSE IF(J==IDN(2))#                    Is it derivative?                KB01 327
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 KB01 328
IF(OFFDS(4) > 0) SCALED = QX(IPT+OFFDS(4))#                             KB01 329
ifvo:(SCALED) SCALED = 1.0#                                             KB01 330
IF(OFFDS(5) > 0) DELBD = QX(IPT+OFFDS(5))#                              KB01 331
ifvo:(DELBD) DELBD = 0.0#                                               KB01 332
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 KB01 333
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  KB01 334
ifeq:(SMALST,10.0) SMALST = 0.0#       Set default                      KB01 335
ifvo:(BIGST) BIGST = 0.333#            No information - assume 1.5      KB01 336
#                                        Angstrom resolution            KB01 337
# CHECK FOR BDF OUTPUT                                                  KB01 338
#                                                                       KB01 339
ifvo:(BUFIN(3))  BDFOUT = no:#         Switch to control                KB01 340
#                                         Generation of output bdf.     KB01 341
ELSE#                                                                   KB01 342
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 KB01 343
stringlim:(3,FIRST,LASTP1)#                                             KB01 344
NCHAR = LASTP1 - FIRST#                                                 KB01 345
IF(NCHAR != 3)  iquit:(KB0108,4)#      Only the 3 characters 'bdf'      KB01 346
#                                         Allowed.                      KB01 347
ELSE#                                                                   KB01 348
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 KB01 349
movechar:(CHRIN,FIRST,MYD,1,NCHAR,0)#                                   KB01 350
compchar:(MYD,1,BDF,1,3,3,3,K)#                                         KB01 351
IF(K != 1)  iquit:(KB0108,4)#          Must say 'bdf'                   KB01 352
ELSE  BDFOUT = yes:#                                                    KB01 353
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 KB01 354
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 KB01 355
#                                                                       KB01 356
# SHALL WE USE F OR F(SQUARED)?                                         KB01 357
#                                                                       KB01 358
ifvo:(BUFIN(4))  SQUARE = no:#         Scale on f                       KB01 359
ELSE#                                                                   KB01 360
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 KB01 361
stringlim:(4,FIRST,LASTP1)#            Field 5 must have at least       KB01 362
NCHAR = MIN0((FIRST-LASTP1),2)#        First 2 chars. of 'squared'.     KB01 363
movechar:(CHRIN,FIRST,MYD,1,NCHAR,0)#                                   KB01 364
compchar:(MYD,1,SQ1,1,2,2,2,K)#                                         KB01 365
IF(K != 0)  iquit:(KB0109,5)#          Must say at least 'sq'           KB01 366
ELSE#                                                                   KB01 367
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 KB01 368
SQUARE = yes:#                         Set switch and write             KB01 369
writeline:(1,KB018,NKB018,3,3)#        Message.                         KB01 370
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 KB01 371
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 KB01 372
#                                                                       KB01 373
# READ LIMIT, SANDR AND END LINES                                       KB01 374
# -------------------------------                                       KB01 375
#                                                                       KB01 376
REPEAT#                                                                 KB01 377
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 KB01 378
readline:(KB011,NKB011)#                                                KB01 379
IF (LINID==5) BREAK#                   If read end then quit            KB01 380
ELSE IF(LINID == 1 \ LINID == 2)#                                       KB01 381
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 KB01 382
CALL KB11(SMALST,BIGST)#                                                KB01 383
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 KB01 384
#                                                                       KB01 385
# CHECK FOR S AND R LINE                                                KB01 386
#                                                                       KB01 387
ELSE IF (LINID==3)#                                                     KB01 388
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 KB01 389
SANDR=yes:#                            Set for singh method             KB01 390
CENTST=yes:#                           Assume centric test              KB01 391
IF (BUFIN(1)>0.0) SCALEP=BUFIN(1)#     Parent scale factor              KB01 392
IF (BUFIN(2)> -100.0) DELBP=BUFIN(2)#  Parent temp factor               KB01 393
IF (BUFIN(3)>0.0) SCALED=BUFIN(3)#     Derivative scale factor          KB01 394
IF (BUFIN(4) > -100.0) DELBD=BUFIN(4)# Derivative temp factor           KB01 395
IF (BUFIN(5)>0)$#                                                       KB01 396
    NDIV=MIN0(NINT(BUFIN(5)),19)#      Divisions in wilson stats        KB01 397
ifnv:(BUFIN(6)) CENTST = no:#                                           KB01 398
ifnv:(BUFIN(7)) LINEAR = yes:#                                          KB01 399
ifnv:(BUFIN(8)) ANOM = no:#                                             KB01 400
IF (BUFIN(9) > 0.0) SMALST = BUFIN(9)# Set stolmin                      KB01 401
IF (BUFIN(10) > 0.0) BIGST = BUFIN(10)# Set stolmax                     KB01 402
IF (BIGST <= SMALST) iquit:(KB0121)#   Avoid nonsense                   KB01 403
IF (BUFIN(11) > 0.)#                                                    KB01 404
NCYS = MIN0(NINT(BUFIN(11)),10)#       Set no. cycles for sandr loo     KB01 405
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 KB01 406
ELSE IF (LINID==4)#                    Limf card                        KB01 407
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 KB01 408
CALL KB12(SMALF,BIGF,SIGK1,SIGK2)#                                      KB01 409
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 KB01 410
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 KB01 411
ncodefld:(SMALST,1,KB01B,210632.,1)#                                    KB01 412
ncodefld:(BIGST,1,KB01B,430632.,1)#                                     KB01 413
writeline:(1,KB01B,NKB01B,3,3)#                                         KB01 414
#                                                                       KB01 415
# DETERMINE MEMORY NEEDED                                               KB01 416
#                                                                       KB01 417
IF (SANDR == no:)#                                                      KB01 418
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 KB01 419
STARF1 = STARSY#                       Storage for parent f             KB01 420
STARF2 = STARF1+maxref:#               Storage for derivative f         KB01 421
STARST = STARF2+maxref:#               Storge for stol                  KB01 422
incrqx:(I,STARST+maxref:-1,KB0101)#    Request memory                   KB01 423
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 KB01 424
ELSE incrqx:(I,STARSY+1,KB0101)#                                        KB01 425
#                                                                       KB01 426
# SET UP LRREFL: READ                                                   KB01 427
#                                                                       KB01 428
KEY(1) = 2#                                                             KB01 429
KEY(2) = 23#                                                            KB01 430
KEY(3) = 23#                                                            KB01 431
KEY(4) = 0#                                                             KB01 432
indexpkt:(1,lrrefl:,PSIZE,IPT,0,KEY,WANT20,OFFSET)#                     KB01 433
IF(IPT <=  0)  iquit:(KB0110)#         There must be non-void lrref     KB01 434
IF(OFFSET(1)*OFFSET(2)*OFFSET(23)==0)iquit:(KB0111)# S, hkl & phase     KB01 435
#                                                                       KB01 436
# CHECK OFFSETS, MUST BE AT LEAST ONE F FOR EACH DATA SET.              KB01 437
# IF ONLY ONE F PRESENT, SET OFFSET OF MISSING F TO THE ONE PRESENT.    KB01 438
#  THIS TAKES CARE OF CASE WHERE PACKET NUMBERS ARE SPECIFIED, AS WELL. KB01 439
#                                                                       KB01 440
FSQUAP=no:#                            Assume frel not frel**2          KB01 441
FSQUAD=no:#                            Same for derivative              KB01 442
IF(OFFSET(3) == 0 & OFFSET(4) == 0)#                                    KB01 443
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 KB01 444
IF(OFFSET(19)==0&OFFSET(20)==0)  iquit:(KB0112)#                        KB01 445
FSQUAP=yes:#                           We've got f parent squares       KB01 446
IF(OFFSET(19)==0) OFFSET(19)=OFFSET(20)# But maybe not (+) & (-)        KB01 447
ELSE IF(OFFSET(20)==0) OFFSET(20)=OFFSET(19)# So take whatever          KB01 448
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 KB01 449
ELSE#                                                                   KB01 450
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 KB01 451
IF(OFFSET(3) == 0)  OFFSET(3) = OFFSET(4)#                              KB01 452
ELSE  IF(OFFSET(4) == 0)  OFFSET(4) = OFFSET(3)#                        KB01 453
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 KB01 454
IF(OFFSET(5) == 0 & OFFSET(6) == 0)#                                    KB01 455
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 KB01 456
IF(OFFSET(21)==0&OFFSET(22)==0)  iquit:(KB0115)#                        KB01 457
FSQUAD=yes:#                           Got f derivative squares         KB01 458
IF(OFFSET(21)==0) OFFSET(21)=OFFSET(22)# But maybe not (+) & (-)        KB01 459
ELSE IF(OFFSET(22)==0) OFFSET(22)=OFFSET(21)# So take whatever          KB01 460
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 KB01 461
ELSE#                                                                   KB01 462
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 KB01 463
IF(OFFSET(5) == 0)  OFFSET(5) = OFFSET(6)#                              KB01 464
ELSE  IF(OFFSET(6) == 0)  OFFSET(6) = OFFSET(5)#                        KB01 465
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 KB01 466
#                                                                       KB01 467
# READ REFLECTIONS AND STORE SOUGHT QUANTITIES.                         KB01 468
#                                                                       KB01 469
NREF   = 0#                            Initialize reflection            KB01 470
NR     = 0#                            Counters.                        KB01 471
NREJST = 0#                                                             KB01 472
SUMF1  = 0.#                           Initialize sums                  KB01 473
SUMF2  = 0.#                                                            KB01 474
SCMAX=BIGST**3#                                                         KB01 475
SCMIN=SMALST**3#                                                        KB01 476
XNDIV=FLOAT(NDIV)#                     Real version of ndiv             KB01 477
DEL=(SCMAX-SCMIN)/XNDIV#                                                KB01 478
NCY = 0#                               Init no. sandr loops done        KB01 479
#                                                                       KB01 480
# --- REITERATE SANDR LOOP SPECIFIED TIMES ---                          KB01 481
#                                                                       KB01 482
REPEAT#                                                                 KB01 483
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 KB01 484
NCY = NCY +1#                          Another time thru sandr loop     KB01 485
#                                                                       KB01 486
REPEAT#                                Begin loop over reflections      KB01 487
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 KB01 488
readwpkt:(1,lrrefl:,PSIZE,IPT,0)#      Read a reflection                KB01 489
IF(IPT <= 0)  BREAK#                   Stop when all are in             KB01 490
NREF = NREF + 1#                       Count all reflections read       KB01 491
K = IPT + OFFSET(2)#                   Check sine(theta) limits         KB01 492
STOL=QX(K)#                            Sin(theta) / lambda              KB01 493
SSTOLS=STOL**2#                        (sin(theta) / lambda)  ** 2      KB01 494
SCTOLC=SSTOLS*STOL#                    (sin(theta) / lambda)  ** 3      KB01 495
IF(STOL < SMALST \ STOL > BIGST)#                                       KB01 496
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 KB01 497
NREJST = NREJST + 1#                   Count rejected reflection        KB01 498
NEXT#                                                                   KB01 499
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 KB01 500
IF (CENTST==yes:)#                     Test for centric refs            KB01 501
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 KB01 502
intunpak:(QX(IPT+OFFSET(23)),CENREF,12,3)# Get phase code               KB01 503
IF(CENREF!=0) CENREF=yes:#                                              KB01 504
ELSE          CENREF=no:#                                               KB01 505
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 KB01 506
#                                                                       KB01 507
# SORT OUT THE VARIOUS SPECIES OF F RELATIVE WHICH MAY BE SUPPLIED      KB01 508
#                                                                       KB01 509
# SET-UP SIGMAS                                                         KB01 510
IF(OFFSET(10)>0)      SIGF2=QX(IPT+OFFSET(10))# Get sigma of f22        KB01 511
ELSE IF(OFFSET(18)>0) SIGF2=.5*QX(IPT+OFFSET(18))/MAX(F22,1.)#          KB01 512
IF(OFFSET(9)>0)       SIGF1=QX(IPT+OFFSET(9))# Get sigma of f21         KB01 513
ELSE IF(OFFSET(17)>0) SIGF1=.5*QX(IPT+OFFSET(17))/MAX(F21,1.)#          KB01 514
IF(OFFSET(7)>0)       SIGF11=QX(IPT+OFFSET(7))# Is sigma fp(+) in fil   KB01 515
ELSE IF(OFFSET(15)>0) SIGF11=.5*QX(IPT+OFFSET(15))/MAX(F11,1.)# Fp(+)   KB01 516
IF(OFFSET(8)>0)       SIGF12=QX(IPT+OFFSET(8))# Is sigma fp(-) in fil   KB01 517
ELSE IF(OFFSET(16)>0) SIGF12=.5*QX(IPT+OFFSET(16))/MAX(F12,1.)# Fp(-)   KB01 518
#                                                                       KB01 519
# SET-UP F'S                                                            KB01 520
IF(FSQUAP==no:)#                       Test for frel parent             KB01 521
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 KB01 522
K = IPT + OFFSET(3) ; F11 = QX(K)#                                      KB01 523
K = IPT + OFFSET(4) ; F12 = QX(K)#                                      KB01 524
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 KB01 525
ELSE#                                  Input fsq terms                  KB01 526
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 KB01 527
K = IPT + OFFSET(19) ; F11 = QX(K)#                                     KB01 528
K = IPT + OFFSET(20) ; F12 = QX(K)#                                     KB01 529
IF (F11>0.0) F11 = SQRT(F11)#          Convert fsq to f                 KB01 530
IF (F12>0.0) F12 = SQRT(F12)#          Convert fsg to f                 KB01 531
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 KB01 532
IF (F11<0.0&F12<0.0) NEXT#             No meaningful data               KB01 533
IF(F11 < 0.)#                          Set f1 to the one member         KB01 534
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 KB01 535
F11 = F12 ; F1 = F12#                                                   KB01 536
SIGFP = SIGF12#                                                         KB01 537
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 KB01 538
ELSE IF (F12 < 0.)#                                                     KB01 539
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 KB01 540
F12 = F11 ; F1 = F11#                                                   KB01 541
SIGFP = SIGF11#                                                         KB01 542
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 KB01 543
ELSE#                                                                   KB01 544
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 KB01 545
F1 = 0.5*(F11+F12)#                                                     KB01 546
SIGFP = 0.5*(SIGF11+SIGF12)#                                            KB01 547
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 KB01 548
#                                                                       KB01 549
IF(FSQUAD==no:)#                       Test if derivative f**2          KB01 550
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 KB01 551
K = IPT + OFFSET(5) ; F21 = QX(K)#                                      KB01 552
K = IPT + OFFSET(6) ; F22 = QX(K)#                                      KB01 553
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 KB01 554
ELSE#                                  Input fsq terms                  KB01 555
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 KB01 556
K = IPT + OFFSET(21) ; F21 = QX(K)#                                     KB01 557
K = IPT + OFFSET(22) ; F22 = QX(K)#                                     KB01 558
IF (F21>0.0) F21 = SQRT(F21)#          Convert fsq to f                 KB01 559
IF (F22>0.0) F22 = SQRT(F22)#          Convert fsq to f                 KB01 560
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 KB01 561
IF(F21<0.&F22<0.) NEXT#                No meaningful data               KB01 562
IF(SANDR==yes:&CENREF==no:)#           Check if missing friedel mate    KB01 563
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 KB01 564
IF(OFFSET(13)>0&OFFSET(14)>0)#                                          KB01 565
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 KB01 566
IF(QX(IPT+OFFSET(13))>2.) NEXT#                                         KB01 567
IF(QX(IPT+OFFSET(14))>2.) NEXT#                                         KB01 568
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 KB01 569
ifvo:(SIGF1) NEXT#                                                      KB01 570
ifvo:(SIGF2) NEXT#                                                      KB01 571
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 KB01 572
IF(F21<0.)#                                                             KB01 573
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 KB01 574
F2 = F22#                                                               KB01 575
SIGFD = SIGF2#                                                          KB01 576
IF (CENREF==yes:) F21 = F22#                                            KB01 577
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 KB01 578
ELSE IF (F22<0.)#                                                       KB01 579
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 KB01 580
F2 = F21#                                                               KB01 581
SIGFD = SIGF1#                                                          KB01 582
IF(SANDR==no:\CENREF==yes:)#                                            KB01 583
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 KB01 584
F22=F21#                                                                KB01 585
SIGF2=SIGF1#                                                            KB01 586
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 KB01 587
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 KB01 588
ELSE#                                                                   KB01 589
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 KB01 590
F2 = 0.5*(F21+F22)#                                                     KB01 591
SIGFD = 0.5*(SIGF1+SIGF2)#                                              KB01 592
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 KB01 593
#                                                                       KB01 594
###### TEST FOR ANY REJECTIONS ##########                               KB01 595
#                                                                       KB01 596
SF1=F11*SCALEP*EXP(DELBP*SSTOLS)#      Set scaled parent f(+)           KB01 597
SF2=F12*SCALEP*EXP(DELBP*SSTOLS)#      Set scaled parent f(-)           KB01 598
IF(SF1 < SMALF  \  SF2 < SMALF  )#     Data set 1 - check +/-           KB01 599
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 KB01 600
NRJF1L = NRJF1L + 1#                   Record fobs out of range         KB01 601
NEXT#                                                                   KB01 602
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 KB01 603
IF( SF2 > BIGF\ SF1 > BIGF)#           Data set 1 f > f limit           KB01 604
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 KB01 605
NRJF1U = NRJF1U + 1#                   Record fobs out of range         KB01 606
NEXT#                                                                   KB01 607
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 KB01 608
SF1=F21*SCALED*EXP(DELBD*SSTOLS)#      Set scaled derivative f(+)       KB01 609
SF2=F22*SCALED*EXP(DELBD*SSTOLS)#      Set scaled derivative f(-)       KB01 610
IF(SANDR==yes:)#                                                        KB01 611
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 KB01 612
IF(SF1 < SMALF  \  SF2 < SMALF  )#     Data set 2 - f < lower lim       KB01 613
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 KB01 614
NRJF2L = NRJF2L + 1#                   Record fobs out of range         KB01 615
NEXT#                                                                   KB01 616
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 KB01 617
IF( SF2 > BIGF\ SF1 > BIGF)#           Data set 2 - f > upper lim       KB01 618
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 KB01 619
NRJF2U = NRJF2U + 1#                   Record fobs out of range         KB01 620
NEXT#                                                                   KB01 621
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 KB01 622
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 KB01 623
IF(F1 < SIGFP*SIGK1)#                  Data set 1 - f < sigma lim       KB01 624
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 KB01 625
NRJS1L = NRJS1L + 1#                   Record fobs out of range         KB01 626
NEXT#                                                                   KB01 627
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 KB01 628
IF(F2 < SIGFD*SIGK1 )#                 Data set 2 - f < sigma limit     KB01 629
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 KB01 630
NRJS2L = NRJS2L + 1#                   Record fobs out of range         KB01 631
NEXT#                                                                   KB01 632
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 KB01 633
IF(F1 > SIGFP*SIGK2 )#                 Data set 1 - f > sigma lim       KB01 634
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 KB01 635
NRJS1U = NRJS1U + 1#                   Record fobs out of range         KB01 636
NEXT#                                                                   KB01 637
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 KB01 638
IF(F2 > SIGFD*SIGK2)#                  Data set 2 - f > sigma limit     KB01 639
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 KB01 640
NRJS2U = NRJS2U + 1#                   Record fobs out of range         KB01 641
NEXT#                                                                   KB01 642
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 KB01 643
#                                                                       KB01 644
IF(SQUARE == yes: & SANDR!=yes:)#      Square the f's if so desired     KB01 645
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 KB01 646
F1 = F1**2#                                                             KB01 647
F2 = F2**2#                                                             KB01 648
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 KB01 649
#                                                                       KB01 650
# **** SET UP RCODES FOR USE IN REFLECTION SCREENING                    KB01 651
#                                                                       KB01 652
IF(OFFSET(11)>0) RCOD11=NINT(AMIN1(5.,AMAX1(0.0,QX(IPT+OFFSET(11)))))#  KB01 653
IF(OFFSET(12)>0) RCOD12=NINT(AMIN1(5.,AMAX1(0.0,QX(IPT+OFFSET(12)))))#  KB01 654
IF(OFFSET(13)>0) RCOD21=NINT(AMIN1(5.,AMAX1(0.0,QX(IPT+OFFSET(13)))))#  KB01 655
IF(OFFSET(14)>0) RCOD22=NINT(AMIN1(5.,AMAX1(0.0,QX(IPT+OFFSET(14)))))#  KB01 656
LT1=3;LT2=3#                           Assume reflections useless       KB01 657
IF(RCOD11==1&(RCOD12==1\(RCOD12==4&CENREF==yes:))) LT1=1# If both obs   KB01 658
ELSE IF(RCOD11==2\RCOD12==2) LT1=2#    Set less-than                    KB01 659
ELSE IF(RCOD11==4\RCOD12==4) LT1=4#    Set less-than                    KB01 660
IF(RCOD21==1&(RCOD22==1\(RCOD22==4&CENREF==yes:))) LT2=1# If both obs   KB01 661
ELSE IF(RCOD21==2\RCOD22==2) LT2=2#    Set less-than                    KB01 662
ELSE IF(RCOD21==4\RCOD22==4) LT2=4#    Set less-than                    KB01 663
#                                                                       KB01 664
# IF METHOD OF SINGH AND RAMESEHAN CALL SUBROUTINE KB 13 TO DO SUMS     KB01 665
#                                                                       KB01 666
IF (SANDR == yes:)#                    Use s and r method               KB01 667
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 KB01 668
CALL KB13#                                                              KB01 669
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 KB01 670
ELSE#                                  Use orig method - not s & r      KB01 671
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 KB01 672
SUMF1 = SUMF1 + F1#                    Accumulate sums for initial      KB01 673
SUMF2 = SUMF2 + F2#                    Estimate of scale constant.      KB01 674
NR = NR + 1#                           Count used reflections           KB01 675
IF(NR > maxref:)  iquit:(KB0114)#      Too many                         KB01 676
J = STARST + NR#                       Store (sine(theta)/lambda)**     KB01 677
QX(J) = STOL**2#                                                        KB01 678
J = STARF1 + NR#                       Store the f's away               KB01 679
QX(J) = F1#                                                             KB01 680
J = STARF2 + NR#                                                        KB01 681
QX(J) = F2#                                                             KB01 682
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 KB01 683
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 KB01 684
IF (SANDR == yes:)#                    If using s and r method ...      KB01 685
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 KB01 686
SUMMIN = no:#                          No summing in progress           KB01 687
CALL KB13#                             Call routine for s and r met     KB01 688
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 KB01 689
ELSE#                                  If not using s and r method      KB01 690
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 KB01 691
#                                                                       KB01 692
# GET INITIAL SCALE AND WRITE OUT SOME THINGS                           KB01 693
#                                                                       KB01 694
# QUIT IF NO REFLECTIONS OR DATA                                        KB01 695
IF(SUMF1 < small: \ SUMF2 < small:)  iquit:(KB0116)#                    Aug93001
IF(NREF == 0 \ NR == 0)  iquit:(KB0116)#                                Aug93002
#                                                                       KB01 698
SCANEW = (SUMF1/SUMF2)*SCALED#         Initial scale...linear k         KB01 699
DBDNEW = DELBD#                        Initial delta-b from input       KB01 700
#                                                                       KB01 701
# OUTPUT RESULTS SO FAR                                                 KB01 702
#                                                                       KB01 703
BUFOT(1) = FLOAT(NREF)#                                                 KB01 704
ncodefld:(BUFOT,1,KB012,FMT011(1),1)#                                   KB01 705
writeline:(1,KB012,NKB012,3,4)#                                         KB01 706
BUFOT(1) = FLOAT(NR)#                                                   KB01 707
ncodefld:(BUFOT,1,KB013,FMT011(1),1)#                                   KB01 708
writeline:(0,KB013,NKB013,3,4)#                                         KB01 709
IF(NREJST != 0)#                                                        KB01 710
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 57 KB01 711
BUFOT(1) = FLOAT(NREJST)#                                               KB01 712
ncodefld:(BUFOT,1,KB01A,FMT011(1),1)#                                   KB01 713
writeline:(0,KB01A,NKB01A,3,4)#                                         KB01 714
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 57 KB01 715
#                                                                       KB01 716
BUFOT(1) = SCALED#                                                      KB01 717
ncodefld:(BUFOT,1,KB014,FMT012(2),1)#                                   KB01 718
writeline:(0,KB014,NKB014,3,4)#                                         KB01 719
writeline:(1,KB015,NKB015,3,4)#                                         KB01 720
writeline:(1,0,0,3,4)#                                                  KB01 721
LINRM = 3#                             Set up for cycle output          KB01 722
#                                                                       KB01 723
# TEN LEAST SQUARES CYCLES                                              KB01 724
#                                                                       KB01 725
FOR(NCY=1; NCY <= 10; NCY=NCY+1)#      Do ten refinement cycles         KB01 726
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 58 KB01 727
A11  = 0.#                                                              KB01 728
A12  = 0.#                                                              KB01 729
A22  = 0.#                                                              KB01 730
C1   = 0.#                                                              KB01 731
C2   = 0.#                                                              KB01 732
RNUM = 0.#                                                              KB01 733
RDEN = 0.#                                                              KB01 734
#                                                                       KB01 735
FOR(I=1; I <= NR; I=I+1)#              Loop over all used reflectio     KB01 736
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 59 KB01 737
PTS  = STARST + I#                     Get pointers to sinth and f      KB01 738
PTF1 = STARF1 + I#                                                      KB01 739
PTF2 = STARF2 + I#                                                      KB01 740
BSINTH = EXP(DBDNEW*QX(PTS))#                                           KB01 741
RZIDUL = QX(PTF1) - SCANEW*BSINTH*QX(PTF2)#                             KB01 742
RNUM = ABS(RZIDUL) + RNUM#                                              KB01 743
RDEN = QX(PTF1) + RDEN#                                                 KB01 744
RZK = BSINTH*QX(PTF2)#                                                  KB01 745
RZB = QX(PTS)*SCANEW*RZK#                                               KB01 746
A11 = RZK**2 + A11#                                                     KB01 747
A12 = RZK*RZB + A12#                                                    KB01 748
A22 = RZB**2 + A22#                                                     KB01 749
C1 = RZIDUL*RZK + C1#                                                   KB01 750
C2 = RZIDUL*RZB + C2#                                                   KB01 751
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 59 KB01 752
#                                                                       KB01 753
RFACTR = RNUM/RDEN#                                                     KB01 754
DET = A11*A22 - A12**2#                                                 KB01 755
A12D = A12/DET#                                                         KB01 756
DELTAK = A22*C1/DET - A12D*C2#                                          KB01 757
DELTAB = -A12D*C1 + A11*C2/DET#                                         KB01 758
DBDNEW = DELTAB+DBDNEW#                                                 KB01 759
IF(ABS(DELTAB)<.005) BREAK#            Quit cycle if accurate enoug     KB01 760
SCANEW = SCANEW + DELTAK#                                               KB01 761
BUFOT(1) = FLOAT(NCY)#                                                  KB01 762
BUFOT(2) = SCANEW#                                                      KB01 763
BUFOT(3) = DBDNEW#                                                      KB01 764
BUFOT(4) = 100.*RFACTR#                                                 KB01 765
ncodefld:(BUFOT,1,CHROT,FMT011(1),4)##                                  KB01 766
writeline:(0,KB016,NKB016,1,3)#                                         KB01 767
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 58 KB01 768
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 KB01 769
# --- STOP ITERATING SANDR LOOP? ---                                    KB01 770
#                                                                       KB01 771
IF(SANDR==no: \ NCY>=NCYS) BREAK#      Quit sandr looping               KB01 772
ELSE#                                                                   KB01 773
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 60 KB01 774
ncodefld:(FLOAT(NCY),1,KB01Z,190333.,1)# Print current sandr cycle no   KB01 775
writeline:(2,KB01Z,NKB01Z,3,3)#                                         KB01 776
readwpkt:(1,endrecord:,PSIZE,IPT,0)#   Read til end of file             KB01 777
readwpkt:(1,lrrefl:,PSIZE,IPT,0)#      Read reflection record           KB01 778
CALL13 = 0#                            Re-initialize summing accums     KB01 779
SUMMIN = yes:#                                                          KB01 780
SCALED = SCANEW#                       Save current scale factor        KB01 781
DELBD = DBDNEW#                        Save del from current loop       KB01 782
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 60 KB01 783
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 KB01 784
#                                                                       KB01 785
# OUTPUT A BDF IF SO REQUESTED                                          KB01 786
#                                                                       KB01 787
IF(BDFOUT == yes:)#                                                     KB01 788
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 61 KB01 789
rewindbdf:(1)#                         Rewind the file                  KB01 790
copyfile:(1,2,1,decr:(lrdset:))#       Copy up to lrdset:               KB01 791
#                                                                       KB01 792
# COPY LRDSET: DIRECTORY                                                KB01 793
KEYDS(1) = 1#                          Re-set keys for indexpkt:        KB01 794
KEYDS(2) = 1#                                                           KB01 795
KEYDS(3) = 5#                                                           KB01 796
KEYDS(4) = 0#                                                           KB01 797
#                                                                       KB01 798
indexpkt:(1,lrdset:,PSIZE,IPT,2,KEYDS,WANT12,OFFSET)#                   KB01 799
#                                                                       KB01 800
REPEAT#                                Now do all lrdset: packets       KB01 801
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 62 KB01 802
readwpkt:(1,lrdset:,PSIZE,IPT,0)#      Read lrdset:                     KB01 803
IF(IPT <= 0) BREAK#                                                     KB01 804
writepkt:(2,lrdset:,KEYDS(4),JPT)#     Write it                         KB01 805
BUFOT(1) = voidflg:#                                                    KB01 806
movereal:(BUFOT,1,QX,JPT+1,KEYDS(4),2)# Clear output packet to voids    KB01 807
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,0)#  Move record to output buf        KB01 808
J = IPT + OFFSET(1)#                   Get data set key                 KB01 809
IF(NINT(QX(J)) == IDN(2))#             And compare                      KB01 810
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 63 KB01 811
J = JPT + OFFSET(2)#                   With data set two.               KB01 812
QX(J) = SCANEW#                        Updated scale factor for der     KB01 813
J = JPT + OFFSET(3)#                                                    KB01 814
QX(J) = DBDNEW#                        Update delta b for derivativ     KB01 815
J = JPT + OFFSET(4)#                                                    KB01 816
QX(J) = MATTWK#                        And mathews k intercept          KB01 817
J = JPT + OFFSET(5)#                                                    KB01 818
QX(J) = MATTWB#                        And matthews pseudo b            KB01 819
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 63 KB01 820
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 62 KB01 821
copyfile:(1,2,incr:(lrdset:),endrecord:)# Copy rest of file             KB01 822
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 61 KB01 823
ELSE  readwpkt:(1,endrecord:,PSIZE,IPT,0)# Finish reading the input     KB01 824
#                                                                       KB01 825
#  PRINT REJECTION COUNTS                                               KB01 826
#                                                                       KB01 827
IF(NRJF1L+NRJF1U+NRJF2L+NRJF2U+NRJS1L+NRJS1U+NRJS2L+NRJS2U>0)#          KB01 828
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 64 KB01 829
writeline:(2,KB01C,NKB01C,3,4)#                                         KB01 830
ncodefld:(FLOAT(NRJF1L),1,KB01D,070613.,1)#                             KB01 831
writeline:(0,KB01D,NKB01D,3,4)#                                         KB01 832
ncodefld:(FLOAT(NRJF1U),1,KB01E,070613.,1)#                             KB01 833
writeline:(0,KB01E,NKB01E,3,4)#                                         KB01 834
ncodefld:(FLOAT(NRJF2L),1,KB01F,070613.,1)#                             KB01 835
writeline:(0,KB01F,NKB01F,3,4)#                                         KB01 836
ncodefld:(FLOAT(NRJF2U),1,KB01G,070613.,1)#                             KB01 837
writeline:(0,KB01G,NKB01G,3,4)#                                         KB01 838
ncodefld:(FLOAT(NRJS1L),1,KB01H,070613.,1)#                             KB01 839
writeline:(0,KB01H,NKB01H,3,4)#                                         KB01 840
ncodefld:(FLOAT(NRJS1U),1,KB01I,070613.,1)#                             KB01 841
writeline:(0,KB01I,NKB01I,3,4)#                                         KB01 842
ncodefld:(FLOAT(NRJS2L),1,KB01J,070613.,1)#                             KB01 843
writeline:(0,KB01J,NKB01J,3,4)#                                         KB01 844
ncodefld:(FLOAT(NRJS2U),1,KB01K,070613.,1)#                             KB01 845
writeline:(0,KB01K,NKB01K,3,4)#                                         KB01 846
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 64 KB01 847
RETURN#                                                                 KB01 848
#                                                                       KB01 849
END#                                                                    KB01 850
systemheader:(KB11)#                   Fourier coefficient preparer     KB11   1
####################################################################### KB11   2
#                                                                     # KB11   3
#                              KB11                                   # KB11   4
#                                                                     # KB11   5
####################################################################### KB11   6
SUBROUTINE KB11(SMALST,BIGST)#         Subroutine to process limhkl     KB11   7
#                                         Limstl, and limd line input.  KB11   8
include:(AACOMN)#                                                       KB11   9
#                                                                       KB11  10
REAL SMALST#                           Lower sitol limit                KB11  11
#                                                                       KB11  12
chardata:(INFIN,INFINITY)#                                              KB11  13
chardata:(KB111, SIN(THETA)/LAMBDA LIMITS     RESOLUTION LIMITS)#       KB11  14
chardata:(KB112,       MIN        MAX              MAX      MIN)#       KB11  15
realdata:(FMT111,[100752.,210752.,380632.,470632.])# Limit formats      KB11  16
datastuff:#                                                             KB11  17
#                                                                       KB11  18
#                                                                       KB11  19
IF(LINID == 1)#                                                         KB11  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  KB11  21
LINRM = 4#                             Output the limits                KB11  22
writeline:(1,KB111,NKB111,3,1)#                                         KB11  23
ifnv:(BUFIN(1))#                                                        KB11  24
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  KB11  25
SMALST = BUFIN(1)#                                                      KB11  26
ncodefld:(BUFIN,1,CHROT,FMT111(1),1)#                                   KB11  27
BUFOT(1) = 0.5/AMAX1(small:,SMALST)#                                    KB11  28
ncodefld:(BUFOT,1,CHROT,FMT111(3),1)#                                   KB11  29
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  KB11  30
ifnv:(BUFIN(2))#                                                        KB11  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  KB11  32
BIGST = BUFIN(2)#                                                       KB11  33
ncodefld:(BUFIN,2,CHROT,FMT111(2),1)#                                   KB11  34
BUFOT(1) = 0.5/AMAX1(small:,BIGST)#                                     KB11  35
ncodefld:(BUFOT,1,CHROT,FMT111(4),1)#                                   KB11  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  KB11  37
#                                                                       KB11  38
IF(SMALST < 0. \ BIGST < 0.)  iquit:(-KB1101)#                          KB11  39
IF(SMALST >= BIGST) iquit:(-KB1101)#                                    KB11  40
IF(SMALST < small:)  movechar:(INFIN,1,CHROT,31,8,0)#                   KB11  41
writeline:(0,KB112,NKB112,2,1)#                                         KB11  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  KB11  43
#                                                                       KB11  44
# RESOLUTION LIMITS                                                     KB11  45
#                                                                       KB11  46
ELSE  IF(LINID == 2)#                                                   KB11  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  KB11  48
writeline:(1,KB111,NKB111,3,1)#                                         KB11  49
ifnv:(BUFIN(1))#                                                        KB11  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  KB11  51
ncodefld:(BUFIN,1,CHROT,FMT111(4),1)#                                   KB11  52
BIGST = 0.5/AMAX1(BUFIN(1),small:)#                                     KB11  53
BUFOT(1) = BIGST#                                                       KB11  54
ncodefld:(BUFOT,1,CHROT,FMT111(2),1)#                                   KB11  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  KB11  56
ifnv:(BUFIN(2))#                                                        KB11  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  KB11  58
ncodefld:(BUFIN,2,CHROT,FMT111(3),1)#                                   KB11  59
SMALST = 0.5/AMAX1(BUFIN(2),small:)#                                    KB11  60
BUFOT(1) = SMALST#                                                      KB11  61
ncodefld:(SMALST,1,CHROT,FMT111(1),1)#                                  KB11  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  KB11  63
#                                                                       KB11  64
IF(SMALST >= BIGST)  iquit:(-KB1101)#                                   KB11  65
IF(SMALST < 0. \ BIGST < 0.)  iquit:(-KB1102)#                          KB11  66
IF(SMALST < small:)  movechar:(INFIN,1,CHROT,31,8,0)#                   KB11  67
writeline:(0,KB112,NKB112,2,1)#                                         KB11  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  KB11  69
#                                                                       KB11  70
RETURN#                                                                 KB11  71
END#                                                                    KB11  72
systemheader:(KB12)#                   Read limits on fobs              KB12   1
####################################################################### KB12   2
#                                                                     # KB12   3
#                              KB12                                   # KB12   4
#                                                                     # KB12   5
####################################################################### KB12   6
SUBROUTINE KB12(SMALF,BIGF,SIGK1,SIGK2)# Subroutine to process limf     KB12   7
include:(AACOMN)#                                                       KB12   8
#                                                                       KB12   9
chardata:(KB121,         F OBS LIMITS           SIGMA SCALE FACTORS)#   KB12  10
chardata:(KB122,       MIN        MAX              MAX      MIN)#       KB12  11
realdata:(FMT121,[100752.,210752.,380632.,470632.])# Limit formats      KB12  12
datastuff:#                                                             KB12  13
#                                                                       KB12  14
##################### ERROR MESSAGES #####################              KB12  15
# 491201   MAX/MIN F LIMITS BAD.                                        KB12  16
# 491202   MAX/MIN SIGMA K BAD.                                         KB12  17
##########################################################              KB12  18
#                                                                       KB12  19
# F OBS LIMITS                                                          KB12  20
#                                                                       KB12  21
LINRM = 4#                             Output the limits                KB12  22
writeline:(1,KB121,NKB121,3,1)#                                         KB12  23
ifnv:(BUFIN(1))#                                                        KB12  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  KB12  25
SMALF  = BUFIN(1)#                     Output lower f limit             KB12  26
BUFOT(1) = AMAX1(0.0,SMALF)#                                            KB12  27
ncodefld:(BUFOT,1,CHROT,FMT121(1),1)##                                  KB12  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  KB12  29
ifnv:(BUFIN(2))#                       Output upper f limit             KB12  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  KB12  31
BIGF = BUFIN(2)#                                                        KB12  32
BUFOT(1) = AMIN1(10000000.,BIGF)#                                       KB12  33
ncodefld:(BUFOT,1,CHROT,FMT121(2),1)##                                  KB12  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  KB12  35
IF(SMALF  < 0. \ BIGF < 0.)  iquit:(-KB1201)# Limits appropriate?       KB12  36
IF(SMALF >= BIGF) iquit:(-KB1201)#     K                                KB12  37
ifnv:(BUFIN(3))#                                                        KB12  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  KB12  39
SIGK1  = BUFIN(3)#                     Output lower sigma limit         KB12  40
ncodefld:(BUFIN,3,CHROT,FMT121(3),1)##                                  KB12  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  KB12  42
ifnv:(BUFIN(4))#                                                        KB12  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  KB12  44
SIGK2  = BUFIN(4)#                     Output upper sigma limit         KB12  45
ncodefld:(BUFIN,4,CHROT,FMT121(3),1)##                                  KB12  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  KB12  47
IF(SIGK1 > SIGK2 )  iquit:(-KB1202)#   Sigma limits appropriate?        KB12  48
writeline:(0,KB112,NKB112,2,1)#                                         KB12  49
#                                                                       KB12  50
RETURN#                                                                 KB12  51
#                                                                       KB12  52
END#                                                                    KB12  53
systemheader:(KB13)#                   S and r scale method             KB13   1
####################################################################### KB13   2
#                                                                     # KB13   3
#                               KB13                                  # KB13   4
#                                                                     # KB13   5
####################################################################### KB13   6
SUBROUTINE KB13#                       J.m.stewart june 1986            KB13   7
#                                        D.h.holland june 1986          KB13   8
# SUBROUTINE BASED ON THE METHOD OF SINGH AND RAMESESHAN FOR APPLYING   KB13   9
# WILSON STATISTICS TO GET SCALE AND DELTA B FACTORS FOR DERIVATIVES    KB13  10
# OF A PARENT PROTEIN. THE SUBROUTINE IS TAKEN FROM A PROGRAM WRITTEN   KB13  11
# BY J. HERRIOT, AS MODIFIED BY K. WATENPAUGH, E. ADMAN,                KB13  12
# A.J. SMITH AT U. WASH. SEATTLE                                        KB13  13
include:(AACOMN)#                                                       KB13  14
include:(KBCOMN)#                                                       KB13  15
INTEGER I#         ## Loop index                                        KB13  16
INTEGER NDD#       ##                                                   KB13  17
INTEGER NDP1#      ##                                                   KB13  18
REAL AINTER#       ##                                                   KB13  19
REAL APO#          ##                                                   KB13  20
REAL AVADSQ#       ##                                                   KB13  21
REAL AVFHSD#       ##                                                   KB13  22
REAL AVFHSQ#       ##                                                   KB13  23
REAL AVFHSZ#       ##                                                   KB13  24
REAL AVFPSD#       ##                                                   KB13  25
REAL AVFPSQ#       ##                                                   KB13  26
REAL AVFPSZ#       ##                                                   KB13  27
REAL AVID#         ##                                                   KB13  28
REAL AVIDSD#       ##                                                   KB13  29
REAL AVIDSQ#       ##                                                   KB13  30
REAL AVSIGH(20)#   ## Sum of all 'observed' scaled sigma f, derivativ   KB13  31
REAL AVSIGP(20)#   ## Sum of all 'observed' scaled sigma f, parent      KB13  32
REAL BRAK#         ##                                                   KB13  33
REAL DIFX2A#       ##                                                   KB13  34
REAL DIFX2O#                                                            KB13  35
REAL DIFXYA#                                                            KB13  36
REAL DIFXYO#                                                            KB13  37
REAL DIFY2A#                                                            KB13  38
REAL DIFY2O#                                                            KB13  39
REAL EKMAT#        ## Matthews k value from acta cryst(1966) 20,230     KB13  40
REAL EKMATT(20)#   ## Table of ekmat values at each stol**2             KB13  41
REAL ESTOL2(20)#   ## Table of stol**2 at center of each bin            KB13  42
REAL OINTER#       ##                                                   KB13  43
REAL RFPFMO(20)#   ## Sum of 'observed' 3d abs(f(+)-f(-)) derivative    KB13  44
REAL ROBS3D(20)#   ## Sum of 'observed' 3d abs(sfp-sfh)                 KB13  45
REAL ROBSA(20)#    ## Sum of all 'observed' abs(sfp-sfh)                KB13  46
REAL ROBSZ(20)#    ## Sum of 'observed' centric abs(sfh-sfp)            KB13  47
REAL RTOT3D(20)#   ## Sum of 3d abs(sfp-sfh)                            KB13  48
REAL RTOTA(20)#    ## Sum of abs(sfp-sfh)                               KB13  49
REAL RTOTZ(20)#    ## Sum of centric abs(sfp-sfh)                       KB13  50
REAL R1#           ## Min(stol**2) for printing tables                  KB13  51
REAL R2#           ## Max(stol**2) for printing tables                  KB13  52
REAL RAT1#         ##                                                   KB13  53
REAL RAT2#         ##                                                   KB13  54
REAL RATIO#        ##                                                   KB13  55
REAL RXYA#         ##                                                   KB13  56
REAL RXYO#         ##                                                   KB13  57
REAL SDAINT#       ##                                                   KB13  58
REAL SDOINT#       ##                                                   KB13  59
REAL SFH#          ## Scaled average of derivative f(+) f(-)            KB13  60
REAL SFP#          ## Scaled average of parent f(+) f(-)                KB13  61
REAL SF1#          ##                                                   KB13  62
REAL SF2#          ##                                                   KB13  63
REAL SLOPE#        ##                                                   KB13  64
REAL SLOPEA#                                                            KB13  65
REAL SLOPEO#                                                            KB13  66
REAL SLOSDA#                                                            KB13  67
REAL SLOSDO#                                                            KB13  68
REAL SMADSQ(20)#   ## Sum of 'observed' 3d (f(+)-f(-))**2 derivative    KB13  69
REAL SMFH(20)#     ## Sum of all f derivative                           KB13  70
REAL SMFH3D(20)#   ## Sum of 3d f derivative                            KB13  71
REAL SMFHO3(20)#   ## Sum of 'observed' 3d f derivative                 KB13  72
REAL SMFHSD(20)#   ## Sum of 3d f derivative squared                    KB13  73
REAL SMFHSQ(20)#   ## Sum of all f derivative squared                   KB13  74
REAL SMFHSZ(20)#   ## Sum of centric f derivative squared               KB13  75
REAL SMFHZ(20)#    ## Sum of centric f derivative                       KB13  76
REAL SMFP(20)#     ## Sum of all f parent                               KB13  77
REAL SMFP3D(20)#   ## Sum of all 3d f parent                            KB13  78
REAL SMFPO3(20)#   ## Sum of 'observed' 3d f average parent             KB13  79
REAL SMFPOA(20)#   ## Sum of all 'observed' f average parent            KB13  80
REAL SMFPOZ(20)#   ## Sum of 'observed' centric f parent                KB13  81
REAL SMFPSD(20)#   ## Sum of all 3d f parent squared                    KB13  82
REAL SMFPSQ(20)#   ## Sum of all f parent squared                       KB13  83
REAL SMFPSZ(20)#   ## Sum of all centric f parent squared               KB13  84
REAL SMFPZ(20)#    ## Sum of all centric f parent                       KB13  85
REAL SMFX2A(20)#   ## Sum of 3d f(+)**2 derivative                      KB13  86
REAL SMFX2O(20)#   ## Sum of 3d f(+)**2 derivative linear               KB13  87
REAL SMFXA(20)#    ## Sum of 3d f(+) derivative                         KB13  88
REAL SMFXO(20)#    ## Sum of 'observed' 3d f(+) derivative linear       KB13  89
REAL SMFXYA(20)#   ## Sum of 3d f(+)*f(-) derivative                    KB13  90
REAL SMFXYO(20)#   ## Sum of 3d f(+)*f(-) derivative linear             KB13  91
REAL SMFY2A(20)#   ## Sum of 3d f(-)**2 derivative                      KB13  92
REAL SMFY2O(20)#   ## Sum of 3d f(-)**2 derivative linear               KB13  93
REAL SMFYA(20)#    ## Sum of 3d f(-) derivative                         KB13  94
REAL SMFYO(20)#    ## Sum of 'observed' 3d f(-) derivative linear       KB13  95
REAL SMIDSD(20)#   ## Sum of 'observed' 3d (sfh-sfp)**2                 KB13  96
REAL SMIDSQ(20)#   ## Sum of all 'observed' (sfh-sfp)**2                KB13  97
REAL SMIDSZ(20)#   ## Sum of 'observed' centric (sfh-sfp)**2            KB13  98
REAL SMKDEN(20)#   ## Sum of 'observed' 3d abs(f(+)-f(-)) derivative    KB13  99
REAL SMKNUM(20)#   ## Sum of 'observed' 3d 2*abs(sfh-sfp)               KB13 100
REAL SMX2O(20)#    ## Sum of 'observed' 3d f(+)**2                      KB13 101
REAL SMXYO(20)#    ## Sum of 'observed' 3d f(+)*f(-) deravitive         KB13 102
REAL SMY20(20)#    ## Sum of 'observed' 3d f(-)**2                      KB13 103
REAL SRSCAL#       ##                                                   KB13 104
REAL SRS#          ##                                                   KB13 105
REAL SUM4(20)#     ## Sum of 'observed' 3d (sfh*sfp)**2                 KB13 106
REAL SUM5(20)#     ## Sum of 'observed' 3d (f(+)**2-f(-)**2)**2 deriv   KB13 107
REAL SUM6(20)#     ## Sum of 'observed' 3d spf**4                       KB13 108
REAL XI#           ##                                                   KB13 109
REAL XNUMRO(20)#   ## Count of all obsereved reflections                KB13 110
REAL XNUMRT(20)#   ## Count of all reflections                          KB13 111
REAL XO3D(20)#     ## Count of 'observed' 3d reflections                KB13 112
REAL XOZ(20)#      ## Count of 'observed' centric reflections           KB13 113
REAL XT3D(20)#     ## Count of all 3d reflections                       KB13 114
REAL XTZ(20)#      ## Count of all centric reflections                  KB13 115
REAL Y#            ##                                                   KB13 116
REAL YINTER#       ##                                                   KB13 117
REAL YWILS(20)#    ## Array to hold y coor for wilson graph             KB13 118
# *** SET UP DATA STMTS FOR WRITE FORMATS ***                           KB13 119
#                                                                       KB13 120
chardata:(KB13A, DERIVATIVE SCALED BY )#                                KB13 121
chardata:(KB13B, NATIVE SCALED BY )#                                    KB13 122
chardata:(KB13C,[ XXX.XXXX*EXP(XXX.XXX*STOL**2)])#                      KB13 123
chardata:(KB13D,[    <FPSQ>     <FDSQ>  <FD>/<FP>])#                    KB13 124
chardata:(KB13E,   RANGE OF STOL**2)#                                   KB13 125
chardata:(KB13F,[   (FPSQ)    (FHSQ)    AV(FP)  ])#                     KB13 126
chardata:(KB13G,ALL)#                                                   KB13 127
chardata:(KB13H,CENTRIC)#                                               KB13 128
chardata:(KB13I,3D)#                                                    KB13 129
chardata:(KB13J,TO)#                                                    KB13 130
chardata:(KB13K,OBS)#                                                   KB13 131
chardata:(KB13L,[(SIGH)])#                                              KB13 132
chardata:(KB13M,[(SIGP)])#                                              KB13 133
chardata:(KB13N,FMEAN)#                                                 KB13 134
chardata:(KB13O,[<SIG(FP)>])#                                           KB13 135
chardata:(KB13P,R F+-F-)#                                               KB13 136
chardata:(KB13Q,R NAT-DER)#                                             KB13 137
chardata:(KB13R,SLOPE  SD SLOPE INTERCEPT  SD INTER CORR COEFF)#        KB13 138
chardata:(KB13S,RANGE OF STOL**2)#                                      KB13 139
chardata:(KB13T,OBSERVED)#                                              KB13 140
chardata:(KB13U,TOTAL)#                                                 KB13 141
chardata:(KB13V,CHECK OF LINEARITY OF F+ VS. F-)#                       KB13 142
chardata:(KB13W, NEW SCALE = XXXX.XXXXX NEW DELTA B = XXXX.XXXXX )#     KB13 143
chardata:(KB13X, Y INTERCEPT = XXXX.XXXXX SLOPE = XXXX.XXXXX )#         KB13 144
chardata:(KB13Y,[ LINEAR LEAST SQUARES FIT OF$#                         KB13 145
 LOG(S & R SCALE) VS. STOL**2])#                                        KB13 146
chardata:(KB13Z,[ THE MATTHEWS SCALE, K, IS          AND THE MATTHEWS$# KB13 147
 DELTA B IS       .])#                                                  KB13 148
chardata:(KB14A,[RANGE OF STOL**2   <DFISQ>      (OBSERVED DATA)$#      KB13 149
   <DFASQ>    2DI/DFA     S & R])#                                      KB13 150
chardata:(KB14B,NUMBER)#                                                KB13 151
chardata:(KB14C,REFLS)#                                                 KB13 152
chardata:(KB131,[   note: FP IS PARENT <F(+),F(-)>$#                    KB13 153
       FD IS DERIVATIVE <F(+),F(-)>])#                                  KB13 154
chardata:(KB132,[   note: DFISQ = (FD-FP)**2$#                          KB13 155
       DFASQ = (F(+) - F(-))**2  FOR DERIVATIVE])#                      KB13 156
chardata:(KB133,[   note:  R NAT-DER = SUM(\FP-FD\)/SUM(FP)$#           KB13 157
       R F+-F- = SUM(\FD(+)-FD(-)\)/SUM(\FD\)])#                        KB13 158
chardata:(KB135,[ PLOT OF 2<ABS(FD-FP)>/<ABS(FD(+)-FD(-))> VS $#        KB13 159
STOL**2 MATTHEWS AC(1966)20,230])#                                      KB13 160
chardata:(KBF10,[ PLOT OF ALOG(SRSCAL) VS STOL**2    WILSON])#          KB13 161
chardata:(KBF15,[<SIG(FD)>])#                                           KB13 162
chardata:(KBF16,[RCODE 1&2])#                                           KB13 163
chardata:(KBF17,[RCODE 1])#                                             KB13 164
chardata:(KBF20,[SUMMARY OF ALL     ])#                                 KB13 165
#                                                                       KB13 166
realdata:(FMT1,[ 90752.,190752.,311022.,421022.,510832.,$#              KB13 167
                631022.,741022.,830832.,951022.,1061022.,$#             KB13 168
                1150832.])#                                             KB13 169
realdata:(FMT2,[ 90752.,190752.,321052.,421052.,521052.,$#              KB13 170
                621052.,721052.,821052.,880613.,960813.,$#              KB13 171
                1020613.,1100613.,1170613.,1260613.])#                  KB13 172
realdata:(FMT3,[110752.,220752.,321052.,421052.,521052.,$#              KB13 173
                621052.,721052.,821052.,921052.,1021052.,$#             KB13 174
                1121052.])#                                             KB13 175
realdata:(FMT4,[110752.,220752.,321062.,421062.,521062.,$#              KB13 176
                621062.,721062.,821062.,921062.,1021062.,$#             KB13 177
                1121062.])#                                             KB13 178
#                                                                       KB13 179
datastuff:#                                                             KB13 180
#                                                                       KB13 181
#  CHECK IF SUMS MUST BE INITIALIZED AND COUNT CALLS                    KB13 182
#                                                                       KB13 183
CALL13 = CALL13 + 1#                   Count each call                  KB13 184
IF(CALL13==1)#                         First time only, clear all       KB13 185
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  KB13 186
DO I=1,20#                             Initialize all group stats       KB13 187
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  KB13 188
AVSIGH(I)=0.;AVSIGP(I)=0.;RFPFMO(I)=0.;ROBS3D(I)=0.;ROBSA(I)=0.#        KB13 189
ROBSZ(I)=0.;RTOT3D(I)=0.;RTOTA(I)=0.;RTOTZ(I)=0.;SMADSQ(I)=0.#          KB13 190
SMFH(I)=0.;SMFH3D(I)=0.;SMFHO3(I)=0.;SMFHSD(I)=0.;SMFHSQ(I)=0.#         KB13 191
SMFHSZ(I)=0.;SMFHZ(I)=0.;SMFP(I)=0.;SMFP3D(I)=0.;SMFPO3(I)=0.#          KB13 192
SMFPOA(I)=0.;SMFPOZ(I)=0.;SMFPSD(I)=0.;SMFPSQ(I)=0.;SMFPSZ(I)=0.#       KB13 193
SMFPZ(I)=0.;SMFX2A(I)=0.;SMFX2O(I)=0.;SMFXA(I)=0.;SMFXO(I)=0.#          KB13 194
SMFXYA(I)=0.;SMFXYO(I)=0.;SMFY2A(I)=0.;SMFY2O(I)=0.;SMFYA(I)=0.#        KB13 195
SMFYO(I)=0.;SMIDSD(I)=0.;SMIDSQ(I)=0.;SMIDSZ(I)=0.;SMKDEN(I)=0.#        KB13 196
SMKNUM(I)=0.;SMX2O(I)=0.;SMXYO(I)=0.;SMY20(I)=0.;SUM4(I)=0.#            KB13 197
SUM5(I)=0.;SUM6(I)=0.;XNUMRO(I)=0.;XNUMRT(I)=0.;XO3D(I)=0.#             KB13 198
XOZ(I)=0.;XT3D(I)=0.;XTZ(I)=0.#                                         KB13 199
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  KB13 200
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  KB13 201
#                                                                       KB13 202
IF (SUMMIN == yes:)#                   Summing in progress              KB13 203
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  KB13 204
#                                                                       KB13 205
# ADJUST VALUES OF F'S FROM BDF WITH STARTING SCALE AND DELTA B'S       KB13 206
#                                                                       KB13 207
SFP=F1*SCALEP*EXP(DELBP*SSTOLS)#       Set parent <f(+),f(-)>           KB13 208
SF1=F21*SCALED*EXP(DELBD*SSTOLS)#      Set dirative f(+)                KB13 209
SF2=F22*SCALED*EXP(DELBD*SSTOLS)#      Set dirative f(-)                KB13 210
#                                                                       KB13 211
# CALCULATE THE 'BIN' (BASED ON STOL**3) INTO WHICH SUMS ARE TO BE MADE KB13 212
#                                                                       KB13 213
I = INT( 1.0+(SCTOLC-SCMIN)/DEL )#                                      KB13 214
SMFPSQ(I) = SMFPSQ(I)+SFP*SFP#         Sum of <f(parent)>**2            KB13 215
SMFP(I) = SMFP(I)+SFP#                 Sum of <f(parent)>               KB13 216
IF(CENTST==yes:&CENREF==yes:)#         Test if refl centric             KB13 217
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  KB13 218
# *** CENTRIC ONLY                                                      KB13 219
SMFPSZ(I) = SMFPSZ(I)+SFP*SFP#                                          KB13 220
SMFPZ(I) = SMFPZ(I)+SFP#                                                KB13 221
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  KB13 222
ELSE#                                                                   KB13 223
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  KB13 224
# ***  3D ONLY                                                          KB13 225
SMFPSD(I) = SMFPSD(I)+SFP*SFP#                                          KB13 226
SMFP3D(I) = SMFP3D(I)+SFP#                                              KB13 227
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  KB13 228
# *** NOW DO SAME FOR DERIVATIVES                                       KB13 229
IF (LT1>0&LT1<3&LT2>0&LT2<3)#                                           KB13 230
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  KB13 231
SFH = (SF1+SF2)*0.5#                   Calculate <f(derivative)>        KB13 232
RTOTA(I) = RTOTA(I)+ABS(SFP-SFH)#                                       KB13 233
IF(CENTST==yes:&CENREF==yes:)#         Test if centric refl             KB13 234
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  KB13 235
# ***  CENTRIC ONLY                                                     KB13 236
SMFHSZ(I) = SMFHSZ(I)+SFH*SFH#                                          KB13 237
SMFHZ(I) = SMFHZ(I)+SFH#                                                KB13 238
RTOTZ(I) = RTOTZ(I)+ABS(SFP-SFH)#                                       KB13 239
XTZ(I) = XTZ(I)+1.0#                   Count centric reflections        KB13 240
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  KB13 241
ELSE#                                                                   KB13 242
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  KB13 243
# *** 3D ONLY                                                           KB13 244
SMFHSD(I) = SMFHSD(I)+SFH*SFH#                                          KB13 245
SMFH3D(I) = SMFH3D(I)+SFH#                                              KB13 246
RTOT3D(I) = RTOT3D(I)+ABS(SFP-SFH)#                                     KB13 247
# *** CHECK LINEARITY OF F+ VS. F-                                      KB13 248
IF (LINEAR==yes:)#                                                      KB13 249
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  KB13 250
SMFXA(I) = SMFXA(I)+SF1#                                                KB13 251
SMFYA(I) = SMFYA(I)+SF2#                                                KB13 252
SMFXYA(I) = SMFXYA(I)+SF1*SF2#                                          KB13 253
SMFX2A(I) = SMFX2A(I)+SF1*SF1#                                          KB13 254
SMFY2A(I) = SMFY2A(I)+SF2*SF2#                                          KB13 255
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  KB13 256
XT3D(I) = XT3D(I)+1.0#                 Count 3d reflections             KB13 257
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  KB13 258
SMFHSQ(I) = SMFHSQ(I)+SFH*SFH#                                          KB13 259
SMFH(I) = SMFH(I)+SFH#                                                  KB13 260
XNUMRT(I) = XNUMRT(I)+1.0#             Count all reflections            KB13 261
# ***  ONLY USE OBSERVED REFLECTIONS IN FOLLOWING STATISTICS COUNT      KB13 262
IF (LT1==1&LT2==1)#                                                     KB13 263
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 KB13 264
IF(CENTST==yes:&CENREF==yes:)#                                          KB13 265
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 KB13 266
# ***  CENTRIC OBSERVED ONLY                                            KB13 267
XOZ(I) = XOZ(I)+1.0#                                                    KB13 268
SMIDSZ(I) = SMIDSZ(I)+(SFH-SFP)**2#                                     KB13 269
ROBSZ(I) = ROBSZ(I)+ABS(SFP-SFH)#                                       KB13 270
SMFPOZ(I) = SMFPOZ(I)+SFP#                                              KB13 271
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 KB13 272
ELSE#                                                                   KB13 273
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 KB13 274
# ***  3D OBSERVED ONLY                                                 KB13 275
SMIDSD(I) = SMIDSD(I)+(SFH-SFP)*(SFH-SFP)#                              KB13 276
# *** CHECK LINEARITY OF F+ VS. F-                                      KB13 277
IF (LINEAR==yes:)#                                                      KB13 278
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 KB13 279
SMFXO(I) = SMFXO(I)+SF1#                                                KB13 280
SMFYO(I) = SMFYO(I)+SF2#                                                KB13 281
SMFXYO(I) = SMFXYO(I)+SF1*SF2#                                          KB13 282
SMFX2O(I) = SMFX2O(I)+SF1*SF1#                                          KB13 283
SMFY2O(I) = SMFY2O(I)+SF2*SF2#                                          KB13 284
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 KB13 285
XO3D(I) = XO3D(I)+1.0#                                                  KB13 286
RFPFMO(I) = RFPFMO(I)+ABS(SF1-SF2)#                                     KB13 287
SMFHO3(I) = SMFHO3(I)+SFH#                                              KB13 288
SMADSQ(I) = SMADSQ(I)+(SF1-SF2)*(SF1-SF2)#                              KB13 289
SUM4(I) = SUM4(I)+((SFH*SFH)*SFP*SFP)#                                  KB13 290
SUM5(I) = SUM5(I)+(SF1*SF1-SF2*SF2)**2#                                 KB13 291
SUM6(I) = SUM6(I)+SFP**4#                                               KB13 292
SMKNUM(I) = SMKNUM(I)+2.0*ABS(SFH-SFP)#                                 KB13 293
SMKDEN(I) = SMKDEN(I)+ABS(SF1-SF2)#                                     KB13 294
ROBS3D(I) = ROBS3D(I)+ABS(SFP-SFH)#                                     KB13 295
SMFPO3(I) = SMFPO3(I)+SFP#                                              KB13 296
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 KB13 297
XNUMRO(I) = XNUMRO(I)+1.0#                                              KB13 298
SMIDSQ(I) = SMIDSQ(I)+(SFH-SFP)*(SFH-SFP)#                              KB13 299
ROBSA(I) = ROBSA(I)+ABS(SFP-SFH)#                                       KB13 300
SMFPOA(I) = SMFPOA(I)+SFP#                                              KB13 301
AVSIGP(I) = AVSIGP(I)+SIGFP*SCALEP*EXP(DELBP*SSTOLS)#                   KB13 302
AVSIGH(I) = AVSIGH(I)+SQRT((SIGF1**2+SIGF2**2)*.5)*$#                   KB13 303
SCALED*EXP(DELBD*SSTOLS)#                                               KB13 304
#                                                                       KB13 305
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 KB13 306
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  KB13 307
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  KB13 308
#                                                                       KB13 309
# **** WHAT FOLLOWS IS THE INTERPRETATION AND PRINTING OF RESULTS       KB13 310
#                                                                       KB13 311
ELSE#                                  No summation in progess          KB13 312
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 KB13 313
# ***  PRODUCE THE RESULTS OF THE SUMMATION  ***                        KB13 314
#                                                                       KB13 315
# PRINT ORIGINAL SCALE AND TEMP FACTORS                                 KB13 316
#                                                                       KB13 317
writeline:(2,KB13B,NKB13B,3,4)#                                         KB13 318
ncodefld:(DELBP,1,KB13C,210732.,1)#                                     KB13 319
ncodefld:(SCALEP,1,KB13C,90842.,1)#                                     KB13 320
writeline:(0,KB13C,NKB13C,3,4)#                                         KB13 321
ncodefld:(DELBD,1,KB13C,210732.,1)#                                     KB13 322
ncodefld:(SCALED,1,KB13C,90842.,1)#                                     KB13 323
writeline:(1,KB13A,NKB13A,3,4)#                                         KB13 324
writeline:(0,KB13C,NKB13C,3,4)#                                         KB13 325
LINRM=10#                              Top of next page                 KB13 326
#                                                                       KB13 327
# PRINT AVERAGES OF FPSQ FHSQ AND RATIO OF <FD>/<FP>                    KB13 328
#                                                                       KB13 329
writeline:(1,KB131,NKB131,3,4)#                                         KB13 330
movechar:(KB13E,1,CHROT,1,NKB13E,0)#                                    KB13 331
movechar:(KB13D,1,CHROT,21,NKB13D,0)#                                   KB13 332
movechar:(KB13D,1,CHROT,NKB13D+21,NKB13D,0)#                            KB13 333
movechar:(KB13D,1,CHROT,2*NKB13D+21,NKB13D,0)#                          KB13 334
writeline:(1,0,0,1,4)#                                                  KB13 335
movechar:(KB13G,1,CHROT,27,NKB13G,0)#                                   KB13 336
movechar:(KB13G,1,CHROT,38,NKB13G,0)#                                   KB13 337
movechar:(KB13G,1,CHROT,46,NKB13G,0)#                                   KB13 338
movechar:(KB13H,1,CHROT,57,NKB13H,0)#                                   KB13 339
movechar:(KB13H,1,CHROT,68,NKB13H,0)#                                   KB13 340
movechar:(KB13H,1,CHROT,76,NKB13H,0)#                                   KB13 341
movechar:(KB13I,1,CHROT,92,NKB13I,0)#                                   KB13 342
movechar:(KB13I,1,CHROT,103,NKB13I,0)#                                  KB13 343
movechar:(KB13I,1,CHROT,111,NKB13I,0)#                                  KB13 344
writeline:(0,0,0,1,4)#                                                  KB13 345
DO I=1,NDIV#                                                            KB13 346
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 KB13 347
XI = FLOAT(I)#                                                          KB13 348
R1 = ((XI-1.)*DEL+SCMIN)**.666667#                                      KB13 349
R2 = (SCMIN+XI*DEL)**.666667#                                           KB13 350
#                                                                       KB13 351
# CALCULATE AVERAGES AND RATIOS OF AVERAGES FOR 'ALL' REFLECTIONS       KB13 352
#                                                                       KB13 353
IF (XNUMRT(I) == 0.0) NEXT#                                             KB13 354
AVFPSQ = SMFPSQ(I)/AMAX1(0.01,XNUMRT(I))#                               KB13 355
AVFHSQ = SMFHSQ(I)/AMAX1(0.01,XNUMRT(I))#                               KB13 356
RATIO = SMFH(I)/AMAX1(0.01,SMFP(I))#                                    KB13 357
RAT1 = 0.0#                                                             KB13 358
AVFHSZ = 0.0#                                                           KB13 359
AVFPSZ = 0.0#                                                           KB13 360
#                                                                       KB13 361
# CALCULATE AVERAGES AND RATIOS OF AVERAGES FOR CENTRIC REFLECTIONS     KB13 362
#                                                                       KB13 363
IF ((CENTST == yes:) & (XTZ(I) > 0.))#                                  KB13 364
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 KB13 365
AVFHSZ = SMFHSZ(I)/AMAX1(0.01,XTZ(I))#                                  KB13 366
AVFPSZ = SMFPSZ(I)/AMAX1(0.01,XTZ(I))#                                  KB13 367
RAT1 = SMFHZ(I)/AMAX1(0.01,SMFPZ(I))#                                   KB13 368
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 KB13 369
#                                                                       KB13 370
# CALCULATE AVERAGES AND RATIOS OF AVERAGES FOR 3D REFLECTIONS          KB13 371
#                                                                       KB13 372
IF (XT3D(I) == 0.) NEXT#                                                KB13 373
AVFPSD = SMFPSD(I)/AMAX1(0.01,XT3D(I))#                                 KB13 374
AVFHSD = SMFHSD(I)/AMAX1(0.01,XT3D(I))#                                 KB13 375
RAT2 = SMFH3D(I)/AMAX1(0.01,SMFP3D(I))#                                 KB13 376
#                                                                       KB13 377
# WRITE OUT THE VALUES OF AVERAGES AND RATIOS                           KB13 378
#                                                                       KB13 379
movechar:(KB13J,1,CHROT,11,NKB13J,0)#                                   KB13 380
BUFOT(1) = R1;      BUFOT(2) = R2;#                                     KB13 381
BUFOT(3) = AVFPSQ;  BUFOT(4) = AVFHSQ;#                                 KB13 382
BUFOT(5) = RATIO;   BUFOT(6) = AVFPSZ;#                                 KB13 383
BUFOT(7) = AVFHSZ;  BUFOT(8) = RAT1;#                                   KB13 384
BUFOT(9) = AVFPSD;  BUFOT(10) = AVFHSD;#                                KB13 385
BUFOT(11) = RAT2;#                                                      KB13 386
ncodefld:(BUFOT,1,CHROT,FMT1,11)#                                       KB13 387
writeline:(0,0,0,1,4)#                                                  KB13 388
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 KB13 389
# WRITE OUT STATISTICS ON DIFFERENCE BETWEEN FD AND FP                  KB13 390
#                                                                       KB13 391
LINRM = 10#                            Only print on current page i     KB13 392
#                                        More than 10 lines             KB13 393
writeline:(1,KB132,NKB132,3,4)#                                         KB13 394
movechar:(KB13U,1,CHROT,88,NKB13U,0)#                                   KB13 395
movechar:(KB14B,1,CHROT,94,NKB14B,0)#                                   KB13 396
movechar:(KB14B,1,CHROT,113,NKB14B,0)#                                  KB13 397
movechar:(KB13K,1,CHROT,120,NKB13K,0)#                                  KB13 398
writeline:(2,0,0,1,4)#                                                  KB13 399
movechar:(KB14A,1,CHROT,5,NKB14A,0)#                                    KB13 400
movechar:(KB14C,1,CHROT,92,NKB14C,0)#                                   KB13 401
movechar:(KB14C,1,CHROT,116,NKB14C,0)#                                  KB13 402
writeline:(0,0,0,1,4)#                                                  KB13 403
movechar:(KB13G,1,CHROT,27,NKB13G,0)#  'all'                            KB13 404
movechar:(KB13H,1,CHROT,35,NKB13H,0)#  'centric'                        KB13 405
movechar:(KB13I,1,CHROT,48,NKB13I,0)#  '3d'                             KB13 406
movechar:(KB13I,1,CHROT,57,NKB13I,0)#  '3d'                             KB13 407
movechar:(KB13G,1,CHROT,86,NKB13G,0)#  'all'                            KB13 408
movechar:(KB13H,1,CHROT,90,NKB13H,0)#  'centric'                        KB13 409
movechar:(KB13I,1,CHROT,101,NKB13I,0)# '3d'                             KB13 410
movechar:(KB13G,1,CHROT,108,NKB13G,0)# 'all'                            KB13 411
movechar:(KB13H,1,CHROT,114,NKB13H,0)# 'centric'                        KB13 412
movechar:(KB13I,1,CHROT,125,NKB13I,0)# '3d'                             KB13 413
writeline:(0,0,0,1,4)#                                                  KB13 414
#                                                                       KB13 415
DO  I=1,NDIV#                                                           KB13 416
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 KB13 417
XI = I#                                                                 KB13 418
R1 = ((XI-1.)*DEL+SCMIN)**.666667#                                      KB13 419
R2 = (SCMIN+XI*DEL)**.666667#                                           KB13 420
ESTOL2(I)=0.5*(R1+R2)#                 Stol**2 at midpoint of bin       KB13 421
EKMATT(I)=0.0#                         Initialize matthews ratios       KB13 422
YWILS(I)=0.0#                          Initialize wilso stat            KB13 423
IF (XNUMRO(I) == 0.0) NEXT#                                             KB13 424
AVIDSQ = SMIDSQ(I)/AMAX1(0.01,XNUMRO(I))#                               KB13 425
AVID = 0.0#                                                             KB13 426
IF ((CENTST == yes:) & (XOZ(I) > 0.))#                                  KB13 427
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 KB13 428
AVID = SMIDSZ(I)/AMAX1(0.01,XOZ(I))#                                    KB13 429
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 KB13 430
#                                                                       KB13 431
## ASSUME APO AVADS & EKMAT ARE 0 IF CAN'T BE CALCULATED                KB13 432
#                                                                       KB13 433
AVIDSD = SMIDSD(I)/AMAX1(0.01,XO3D(I))#                                 KB13 434
APO=0.;AVADSQ=0.;EKMAT=0.#                                              KB13 435
IF (ANOM == yes:)#                                                      KB13 436
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 KB13 437
AVADSQ = SMADSQ(I)/AMAX1(0.01,XO3D(I))#                                 KB13 438
IF(SMKDEN(I)==0.)#                                                      KB13 439
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 KB13 440
#                                                                       KB13 441
# ****  REPORT OUT ANY REGIONS OF THETA WITH NOTHING IN THE SLOT        KB13 442
#                                                                       KB13 443
movechar:('  STOL SLOT       HAS NO ENTRIES',1,CHROT,1,32,0)#           KB13 444
BUFOT(1) = FLOAT(I)#                                                    KB13 445
ncodefld:(BUFOT,1,CHROT,160513.,1)#                                     KB13 446
writeline:(0,0,0,1,4)#                                                  KB13 447
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 KB13 448
ELSE#                                                                   KB13 449
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 KB13 450
EKMAT = SMKNUM(I)/AMAX1(0.01,SMKDEN(I))#                                KB13 451
EKMATT(I)=ALOG(EKMAT)#                 Save value of matthew's rati     KB13 452
APO = (EKMAT*EKMAT)*.5#                                                 KB13 453
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 KB13 454
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 KB13 455
#                                                                       KB13 456
BRAK = ABS(SUM4(I)*SUM4(I)-(APO*SUM5(I)*SUM6(I)))#                      KB13 457
SRS = (SUM4(I)+SQRT(BRAK))/AMAX1(0.01,(2.0*SUM6(I)))#                   KB13 458
IF (SRS <=0.0)#                        Do data in shell                 KB13 459
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 KB13 460
YWILS(I) = voidflg:#                                                    KB13 461
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 KB13 462
ELSE#                                                                   KB13 463
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 KB13 464
SRSCAL = 1.0/SQRT(SRS)#                                                 KB13 465
# *** CALCULATE SUMS FOR CORRECTION TO SCALE AND DELBD#                 KB13 466
Y = ALOG(SRSCAL)#                                                       KB13 467
YWILS(I) = Y#                          To be plotted on y axis          KB13 468
#                                                                       KB13 469
movechar:(KB13J,1,CHROT,11,NKB13J,0)#                                   KB13 470
BUFOT(1) = R1;      BUFOT(2) = R2;#                                     KB13 471
BUFOT(3) = AVIDSQ;  BUFOT(4) = AVID;#                                   KB13 472
BUFOT(5) = AVIDSD;  BUFOT(6) = AVADSQ;#                                 KB13 473
BUFOT(7) = EKMAT;   BUFOT(8) = SRSCAL;#                                 KB13 474
BUFOT(9) = XNUMRT(I); BUFOT(10) = XTZ(I);#                              KB13 475
BUFOT(11) = XT3D(I);  BUFOT(12) = XNUMRO(I);#                           KB13 476
BUFOT(13) = XOZ(I);   BUFOT(14) = XO3D(I);#                             KB13 477
ncodefld:(BUFOT,1,CHROT,FMT2,14)#                                       KB13 478
writeline:(0,0,0,1,4)#                                                  KB13 479
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 KB13 480
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 KB13 481
#                                                                       KB13 482
# *** CALCULATE R FACTORS                                               KB13 483
#                                                                       KB13 484
writeline:(2,KB133,NKB133,3,4)#                                         KB13 485
movechar:(KB13Q,1,CHROT,24,NKB13Q,0)#                                   KB13 486
movechar:(KB13Q,1,CHROT,34,NKB13Q,0)#                                   KB13 487
movechar:(KB13Q,1,CHROT,44,NKB13Q,0)#                                   KB13 488
movechar:(KB13Q,1,CHROT,54,NKB13Q,0)#                                   KB13 489
movechar:(KB13Q,1,CHROT,64,NKB13Q,0)#                                   KB13 490
movechar:(KB13Q,1,CHROT,74,NKB13Q,0)#                                   KB13 491
movechar:(KB13P,1,CHROT,84,NKB13P,0)#                                   KB13 492
writeline:(1,0,0,1,4)#                                                  KB13 493
movechar:(KB13G,1,CHROT,27,NKB13G,0)#                                   KB13 494
movechar:(KB13H,1,CHROT,36,NKB13H,0)#                                   KB13 495
movechar:(KB13I,1,CHROT,47,NKB13I,0)#                                   KB13 496
movechar:(KB13N,1,CHROT,57,NKB13N,0)#                                   KB13 497
movechar:(KB13M,1,CHROT,66,NKB13M,0)#                                   KB13 498
movechar:(KB13L,1,CHROT,76,NKB13L,0)#                                   KB13 499
movechar:(KB13O,1,CHROT,93,NKB13O,0)#  <sig(fp)>                        KB13 500
movechar:(KBF15,1,CHROT,103,NKBF15,0)# <sig(fd)>                        KB13 501
writeline:(1,0,0,1,4)#                                                  KB13 502
movechar:(KBF16,1,CHROT,24,NKBF16,0)#                                   KB13 503
movechar:(KBF16,1,CHROT,34,NKBF16,0)#                                   KB13 504
movechar:(KBF16,1,CHROT,44,NKBF16,0)#                                   KB13 505
movechar:(KBF17,1,CHROT,55,NKBF17,0)#                                   KB13 506
movechar:(KBF17,1,CHROT,66,NKBF17,0)#                                   KB13 507
movechar:(KBF17,1,CHROT,76,NKBF17,0)#                                   KB13 508
movechar:(KBF17,1,CHROT,85,NKBF17,0)#                                   KB13 509
movechar:(KBF17,1,CHROT,94,NKBF17,0)#                                   KB13 510
movechar:(KBF17,1,CHROT,104,NKBF17,0)#                                  KB13 511
writeline:(0,0,0,1,4)#                                                  KB13 512
#                                                                       KB13 513
NDP1 = NDIV+1#                                                          KB13 514
NDD = 0#                                                                KB13 515
DO I=1,NDP1#                                                            KB13 516
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 KB13 517
XI = I#                                                                 KB13 518
IF (I != NDP1)#                        Not summary stats                KB13 519
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 KB13 520
IF (XNUMRT(I) == 0.0) NEXT#                                             KB13 521
NDD = NDD+1#                                                            KB13 522
R1 = ((XI-1.)*DEL+SCMIN)**.666667#                                      KB13 523
R2 = (SCMIN+XI*DEL)**.666667#                                           KB13 524
RTOTA(NDP1) = RTOTA(NDP1)+RTOTA(I)#                                     KB13 525
RTOTZ(NDP1) = RTOTZ(NDP1)+RTOTZ(I)#                                     KB13 526
RTOT3D(NDP1) = RTOT3D(NDP1)+RTOT3D(I)#                                  KB13 527
ROBSA(NDP1) = ROBSA(NDP1)+ROBSA(I)#                                     KB13 528
ROBSZ(NDP1) = ROBSZ(NDP1)+ROBSZ(I)#                                     KB13 529
ROBS3D(NDP1) = ROBS3D(NDP1)+ROBS3D(I)#                                  KB13 530
RFPFMO(NDP1) = RFPFMO(NDP1)+RFPFMO(I)#                                  KB13 531
SMFP(NDP1) = SMFP(NDP1)+SMFP(I)#                                        KB13 532
SMFPZ(NDP1) = SMFPZ(NDP1)+SMFPZ(I)#                                     KB13 533
SMFP3D(NDP1) = SMFP3D(NDP1)+SMFP3D(I)#                                  KB13 534
SMFPOA(NDP1) = SMFPOA(NDP1)+SMFPOA(I)#                                  KB13 535
SMFPOZ(NDP1) = SMFPOZ(NDP1)+SMFPOZ(I)#                                  KB13 536
SMFPO3(NDP1) = SMFPO3(NDP1)+SMFPO3(I)#                                  KB13 537
SMFHO3(NDP1) = SMFHO3(NDP1)+SMFHO3(I)#                                  KB13 538
AVSIGP(NDP1) = AVSIGP(NDP1)+AVSIGP(I)#                                  KB13 539
AVSIGH(NDP1) = AVSIGH(NDP1)+AVSIGH(I)#                                  KB13 540
XNUMRT(NDP1) = XNUMRT(NDP1)+XNUMRT(I)#                                  KB13 541
XNUMRO(NDP1) = XNUMRO(NDP1)+XNUMRO(I)#                                  KB13 542
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 KB13 543
IF (XNUMRT(I) != 0.0)#                                                  KB13 544
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 KB13 545
RTOTA(I) = RTOTA(I)/AMAX1(0.01,SMFP(I))#                                KB13 546
IF (CENTST==yes:)#                                                      KB13 547
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 KB13 548
RTOTZ(I) = RTOTZ(I)/AMAX1(0.01,SMFPZ(I))#                               KB13 549
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 KB13 550
RTOT3D(I) = RTOT3D(I)/AMAX1(0.01,SMFP3D(I))#                            KB13 551
IF (XNUMRO(I) != 0.0)#                                                  KB13 552
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 KB13 553
ROBSA(I) = ROBSA(I)/AMAX1(0.01,SMFPOA(I))#                              KB13 554
IF (CENTST==yes:)#                                                      KB13 555
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 KB13 556
ROBSZ(I) = ROBSZ(I)/AMAX1(0.01,SMFPOZ(I))#                              KB13 557
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 KB13 558
ROBS3D(I) = ROBS3D(I)/AMAX1(0.01,SMFPO3(I))#                            KB13 559
RFPFMO(I) = RFPFMO(I)/AMAX1(0.01,SMFHO3(I))#                            KB13 560
AVSIGP(I) = AVSIGP(I)/AMAX1(0.01,XNUMRO(I))#                            KB13 561
AVSIGH(I) = AVSIGH(I)/AMAX1(0.01,XNUMRO(I))#                            KB13 562
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 KB13 563
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 KB13 564
movechar:(KB13J,1,CHROT,13,NKB13J,0)#                                   KB13 565
BUFOT(1) = R1;      BUFOT(2) = R2#                                      KB13 566
BUFOT(3) = RTOTA(I); BUFOT(4) = RTOTZ(I)#                               KB13 567
BUFOT(5) = RTOT3D(I);  BUFOT(6) = ROBSA(I)#                             KB13 568
BUFOT(7) = ROBSZ(I);   BUFOT(8) = ROBS3D(I)#                            KB13 569
BUFOT(9) = RFPFMO(I); BUFOT(10) = AVSIGP(I)#                            KB13 570
BUFOT(11) = AVSIGH(I)#                                                  KB13 571
ncodefld:(BUFOT,1,CHROT,FMT3,11)#                                       KB13 572
IF(I==NDP1)#                                                            KB13 573
movechar:(KBF20,1,CHROT,6,NKBF20,0)#                                    KB13 574
writeline:(0,0,0,1,4)#                                                  KB13 575
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 KB13 576
IF (I==NDP1) R1 = (SCMIN)**.666667#                                     KB13 577
#                                                                       KB13 578
# *** CHECK LINEARITY OF F+ VS. F-                                      KB13 579
#                                                                       KB13 580
IF (LINEAR==yes:)#                                                      KB13 581
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 KB13 582
#                                                                       KB13 583
# **** WRITE HEADING FOR OUTPUT OF STATS                                KB13 584
#                                                                       KB13 585
movechar:(KB13V,1,CHROT,5,NKB13V,0)#                                    KB13 586
movechar:(KB13U,1,CHROT,59,NKB13U,0)#                                   KB13 587
movechar:(KB13T,1,CHROT,107,NKB13T,0)#                                  KB13 588
writeline:(2,0,0,1,4)#                                                  KB13 589
movechar:(KB13S,1,CHROT,5,NKB13S,0)#                                    KB13 590
movechar:(KB13R,1,CHROT,27,NKB13R,0)#                                   KB13 591
movechar:(KB13R,1,CHROT,77,NKB13R,0)#                                   KB13 592
writeline:(0,0,0,1,4)#                                                  KB13 593
DO  I=1,NDP1#                                                           KB13 594
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 KB13 595
XI = FLOAT(I)#                                                          KB13 596
IF (I != NDP1)#                                                         KB13 597
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 KB13 598
R1 = ((XI-1.)*DEL+SCMIN)**.666667#                                      KB13 599
R2 = (SCMIN+XI*DEL)**.666667#                                           KB13 600
SMFXA(NDP1) = SMFXA(NDP1)+SMFXA(I)#                                     KB13 601
SMFYA(NDP1) = SMFYA(NDP1)+SMFYA(I)#                                     KB13 602
SMFXYA(NDP1) = SMFXYA(NDP1)+SMFXYA(I)#                                  KB13 603
SMFX2A(NDP1) = SMFX2A(NDP1)+SMFX2A(I)#                                  KB13 604
SMFY2A(NDP1) = SMFY2A(NDP1)+SMFY2A(I)#                                  KB13 605
XT3D(NDP1) = XT3D(NDP1)+XT3D(I)#                                        KB13 606
SMFXO(NDP1) = SMFXO(NDP1)+SMFXO(I)#                                     KB13 607
SMFYO(NDP1) = SMFYO(NDP1)+SMFYO(I)#                                     KB13 608
SMFXYO(NDP1) = SMFXYO(NDP1)+SMFXYO(I)#                                  KB13 609
SMFX2O(NDP1) = SMFX2O(NDP1)+SMFX2O(I)#                                  KB13 610
SMFY2O(NDP1) = SMFY2O(NDP1)+SMFY2O(I)#                                  KB13 611
XO3D(NDP1) = XO3D(NDP1)+XO3D(I)#                                        KB13 612
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 KB13 613
SLOPEA=0.;SLOSDA=0.;AINTER=0.;SDAINT=0.;RXYA=0.;SLOPEO=0.;SLOSDO=0.#    KB13 614
OINTER=0.;SDOINT=0.;RXYO=0.#                                            KB13 615
IF (XT3D(I)>0.0)#                                                       KB13 616
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 KB13 617
DIFX2A = (XT3D(I)*SMFX2A(I)-SMFXA(I)*SMFXA(I))#                         KB13 618
DIFY2A = (XT3D(I)*SMFY2A(I)-SMFYA(I)*SMFYA(I))#                         KB13 619
DIFXYA = (XT3D(I)*SMFXYA(I)-SMFXA(I)*SMFYA(I))#                         KB13 620
IF((XT3D(I)-2.0)>0.0001) DEGFRE = 1./(XT3D(I)-2.)#                      KB13 621
IF(DIFX2A>0.0001) SLOPEA = DIFXYA/DIFX2A#                               KB13 622
IF(XT3D(I)>0.0001)#                                                     KB13 623
AINTER = (SMFYA(I)/XT3D(I))-(SLOPEA*(SMFXA(I)/XT3D(I)))#                KB13 624
RXYA = DIFXYA/SQRT(ABS(DIFX2A*DIFY2A))#                                 KB13 625
SLOSDA = SQRT(ABS((DEGFRE*(1.-RXYA*RXYA)*DIFY2A)/DIFX2A))#              KB13 626
SDAINT = SQRT(ABS((SMFX2A(I)/XT3D(I))*SLOSDA*SLOSDA))#                  KB13 627
IF (XO3D(I) > 0.0)#                                                     KB13 628
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 KB13 629
DIFX2O = (XO3D(I)*SMFX2O(I)-SMFXO(I)*SMFXO(I))#                         KB13 630
DIFY2O = (XO3D(I)*SMFY2O(I)-SMFYO(I)*SMFYO(I))#                         KB13 631
DIFXYO = (XO3D(I)*SMFXYO(I)-SMFXO(I)*SMFYO(I))#                         KB13 632
IF((XO3D(I)-2.0)>0.0001) DEGFRE = 1./(XO3D(I)-2.)#                      KB13 633
IF(DIFX2O>0.0001) SLOPEO = DIFXYO/DIFX2O#                               KB13 634
IF(XO3D(I)>0.0001)#                                                     KB13 635
OINTER = (SMFYO(I)/XO3D(I))-(SLOPEO*(SMFXO(I)/XO3D(I)))#                KB13 636
RXYO = DIFXYO/SQRT(ABS(DIFX2O*DIFY2O))#                                 KB13 637
SLOSDO = SQRT(ABS((DEGFRE*(1.-RXYO*RXYO)*DIFY2O)/DIFX2O))#              KB13 638
SDOINT = SQRT(ABS((SMFX2O(I)/XO3D(I))*SLOSDO*SLOSDO))#                  KB13 639
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 KB13 640
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 KB13 641
IF (I == NDP1) R1 = (SCMIN)**.666667#                                   KB13 642
movechar:(KB13J,1,CHROT,13,NKB13J,0)#                                   KB13 643
BUFOT(1)=R1;BUFOT(2)=R2;BUFOT(3)=SLOPEA;BUFOT(4)=SLOSDA#                KB13 644
BUFOT(5)=AINTER;BUFOT(6)=SDAINT;BUFOT(7)=RXYA;BUFOT(8)=SLOPEO#          KB13 645
BUFOT(9)=SLOSDO;BUFOT(10)=OINTER;BUFOT(11)=SDOINT;BUFOT(12)=RXYO#       KB13 646
ncodefld:(BUFOT,1,CHROT,FMT4,12)#                                       KB13 647
writeline:(1,0,0,1,4)#                                                  KB13 648
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 KB13 649
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 KB13 650
#                                                                       KB13 651
# *** CALCULATE CORRECTION TO SCALE AND TEMPERATURE FACTOR              KB13 652
#                                                                       KB13 653
CALL KB16(NDIV,ESTOL2,YWILS,KBF10,NKBF10,SLOPE,YINTER,SCALED)#          KB13 654
SCANEW = SCALED*SQRT(EXP(YINTER))#     Place on scale of f not f**2     KB13 655
DBDNEW = DELBD+0.5*SLOPE#              Change b to b/2 for f            KB13 656
ncodefld:(SCANEW,1,KB13W,231052.,1)#                                    KB13 657
ncodefld:(DBDNEW,1,KB13W,481052.,1)#                                    KB13 658
writeline:(2,KB13W,NKB13W,3,3)#                                         KB13 659
#                                                                       KB13 660
# *** CALCULATE MATTHEWS' SLOPE AND INTERCEPT OF K                      KB13 661
# THAT IS THE THE MATTHEWS' FUNCTION AS PER ACTA CRYST(1966) 20,230     KB13 662
# EXCEPT IN THIS CASE USE THE ALOG(2|FP-FD|/|FD(+)-FD(-)|) DURING       KB13 663
# WILSON PLOTTING.                                                      KB13 664
#                                                                       KB13 665
IF(ANOM == yes:)#                      Anomalous scattering?            KB13 666
CALL KB16(NDIV,ESTOL2,EKMATT,KB135,NKB135,MATTWB,MATTWK,1.0)#           KB13 667
MATTWK = EXP(MATTWK)#                  Get intercept from log plot      KB13 668
ncodefld:(MATTWK,1,KB13Z,350842.,1)#                                    KB13 669
ncodefld:(MATTWB,1,KB13Z,700622.,1)#                                    KB13 670
writeline:(2,KB13Z,NKB13Z,3,3)#                                         KB13 671
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 KB13 672
#                                                                       KB13 673
RETURN#                                                                 KB13 674
END#                                                                    KB13 675
systemheader:(KB16)#                   Find a l/s line and plot it      KB16   1
####################################################################### KB16   2
#                                                                     # KB16   3
#                               KB16                                  # KB16   4
#                                                                     # KB16   5
####################################################################### KB16   6
SUBROUTINE KB16(NPTS,X,Y,TITL,NTITL,SLOPE,YCEPT,DELY)#                  KB16   7
#                                        J.m. stewart  june 1986        KB16   8
include:(AACOMN)#                      Get system common                KB16   9
REAL B#                                Intercept of the l/s line        KB16  10
REAL DELY#                             Y offset (log base e plot)       KB16  11
REAL DENOM#                            Denominator in l/s solution      KB16  12
REAL FMT#                              Format for fiduciaries           KB16  13
INTEGER I,K,L#                         Loop indices                     KB16  14
INTEGER IX,IY#                         X,y coordinates in graph         KB16  15
REAL M#                                Slope of the l/s line            KB16  16
REAL MAXX,MINX,MAXY,MINY#              Scope of data                    KB16  17
INTEGER NPTS#                          Number of x,y points supplie     KB16  18
INTEGER NTITL,NTITLL#                  Number of characters in titl     KB16  19
INTEGER PTX,PTY#                       Points in graph of x vs y        KB16  20
REAL SLOPE#                            B for publication                KB16  21
REAL SPANX,SPANY#                      Span of x and y coordinates      KB16  22
REAL STEPX,STEPY#                      Size of x and y increments       KB16  23
REAL SUMX,SUMX2,SUMXY,SUMY#            L/s summations                   KB16  24
string:(TITL,80)#                      Title of graph                   KB16  25
REAL X(1),Y(1)#                        Arrays of x,y data for plot      KB16  26
REAL XLIST,YLIST#                      Listing coordinates              KB16  27
REAL YCEPT#                            B for publication                KB16  28
realdata:(PTSX,[80.0])#                Points across x                  KB16  29
realdata:(PTSY,[40.0])#                Points across y                  KB16  30
chardata:(LHEAD,[LOG(K)])#             Header for log(k)                KB16  31
chardata:(KHEAD,[K VALUE])#            Plot underline character         KB16  32
chardata:(UNL,_)#                      Plot underline character         KB16  33
chardata:(BAR,\)#                      Plot bar character               KB16  34
chardata:(SYMB,*)#                     Plotter point raw data           KB16  35
chardata:(SYML,+)#                     Plotter point l/s line           KB16  36
chardata:(LINE,[ THE SLOPE IS          AND THE INTERCEPT$#              KB16  37
 IS         ])#                        Kb16  37                         KB16  38
chardata:(LEDGN, RAW DATA PLOTTED AS   L/S LINE AS   )#                 KB16  39
datastuff:#                                                             KB16  40
#                                                                       KB16  41
SLOPE=0.0;YCEPT=0.0#                   Default m and b                  KB16  42
NTITLL=MIN0(NTITL,80)#                 Keep title in bounds             KB16  43
IF(NPTS>2)#                            Make sure its worth while        KB16  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  KB16  45
IF(prtstat:>3) LINCT=0#                Force graph on new page          KB16  46
MAXX=-1.E9;MAXY=-1.E9;MINX=1.E9;MINY=1.E9# Set maxes and mins           KB16  47
SUMX=0.;SUMX2=0.;SUMXY=0.;SUMY=0.#     Zero l/s sums                    KB16  48
DO I=1,NPTS#                           Loop over all data points        KB16  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  KB16  50
ifvo:(Y(I)) NEXT#                      Skip if void data                KB16  51
MAXX=AMAX1(MAXX,X(I));MINX=AMIN1(MINX,X(I))#                            KB16  52
MAXY=AMAX1(MAXY,Y(I));MINY=AMIN1(MINY,Y(I))#                            KB16  53
SUMX=SUMX+X(I);SUMX2=SUMX2+X(I)**2#    Sum x and x**2                   KB16  54
SUMXY=SUMXY+X(I)*Y(I);SUMY=SUMY+Y(I)#  Sum x*y and y                    KB16  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  KB16  56
MINX=0.#                               Make esthetic space              KB16  57
MAXX=FLOAT(NINT(110.0*MAXX))*0.01#     Fill graph in x                  KB16  58
#MAXY=FLOAT(NINT(112.0*MAXY))*.01#      # FILL GRAPH IN Y               KB16  59
#MINY=FLOAT(INT(85.*MINY))*.01#                                         KB16  60
MINY=-3.0+AINT(MINY);MAXY=+3.0+AINT(MAXY)# From 20+ to .05-             KB16  61
#                                       # On log base e basis           KB16  62
SPANX=ABS(MAXX-MINX);STEPX=SPANX/PTSX# Get x plot limits                KB16  63
SPANY=ABS(MAXY-MINY);STEPY=SPANY/PTSY# Get y plot limits                KB16  64
DENOM=SUMX2*FLOAT(NPTS)-SUMX**2#       Get denominator of l/s           KB16  65
IF(ABS(DENOM)<0.00001) DENOM=SIGN(0.00001,DENOM)# Protect foot          KB16  66
M=(FLOAT(NPTS)*SUMXY-SUMX*SUMY)/DENOM# Get slope in y=mx+b              KB16  67
B=(SUMX2*SUMY-SUMX*SUMXY)/DENOM#       Get y intercept in y=mx+b        KB16  68
writeline:(2,TITL,NTITLL,2,4)#         Write title and line info        KB16  69
movechar:(SYMB,1,LEDGN,22,NSYMB,1)#    Form ledgend                     KB16  70
movechar:(SYML,1,LEDGN,36,NSYML,1)#    Form ledgend                     KB16  71
writeline:(0,LEDGN,NLEDGN,3,4)#        Write ledgend                    KB16  72
BUFOT(1)=M#                                                             KB16  73
ncodefld:(BUFOT,1,LINE,220842.,1)#     Encode slope                     KB16  74
BUFOT(1)=B#                                                             KB16  75
ncodefld:(BUFOT,1,LINE,520942.,1)#     Encode y intercept               KB16  76
writeline:(1,LINE,NLINE,3,4)#          Write equation                   KB16  77
#                                                                       KB16  78
PTX=INT(PTSX)+1#                       Set up for printing columns      KB16  79
PTY=INT(PTSY)+1#                       Set up for printing lines        KB16  80
FMT=10642.;XLIST=MINX-10.0*STEPX#      Set up x ledgend                 KB16  81
movechar:(KHEAD,1,CHROT,2,NKHEAD,0)#   Header for y axis                KB16  82
movechar:(LHEAD,1,CHROT,92,NLHEAD,0)#                                   KB16  83
writeline:(2,0,0,1,4)#                                                  KB16  84
DO I=1,PTX#                                                             KB16  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  KB16  86
IF(MOD(I-1,10)==0)#                    Tick every tenth                 KB16  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  KB16  88
XLIST=XLIST+10.0*STEPX;FMT=FMT+100000.0#                                KB16  89
ncodefld:(XLIST,1,CHROT,FMT,1)#        Write fiduciaries                KB16  90
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  KB16  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  KB16  92
writeline:(1,0,0,1,4)#                                                  KB16  93
K=0#                                   Make x ticks                     KB16  94
DO I=1,PTX#                            Loop across line                 KB16  95
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  KB16  96
IF(MOD(I-1,10)==0)#                                                     KB16  97
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  KB16  98
movechar:(BAR,1,CHROT,K*10+9,NBAR,1)#  X ticks                          KB16  99
K=K+1#                                                                  KB16 100
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  KB16 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  KB16 102
writeline:(0,0,0,1,4)#                                                  KB16 103
YLIST=MAXY+STEPY#                      Set listing coordinate           KB16 104
DO K=1,PTY#                            Loop down over plotted point     KB16 105
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  KB16 106
YLIST=YLIST-STEPY#                     Step down the graph              KB16 107
YCURR = NINT(PTSY*((YLIST-MINY)/SPANY))# Current graph y coor           KB16 108
XLIST = MINX - STEPX#                  Start x coor just before str     KB16 109
DO L=1,PTX#                            Loop across graph line           KB16 110
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  KB16 111
XLIST = XLIST + STEPX#                 New x coor                       KB16 112
IY = NINT(PTSY*((M*XLIST+B-MINY)/SPANY))# Calculate y plot coor         KB16 113
IF (IY == YCURR)#                      If y coor on current line?       KB16 114
movechar:(SYML,1,CHROT,L+10,NSYML,1)#  Store the ideal symbol           KB16 115
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  KB16 116
DO I=1,NPTS#                           Search thru data points          KB16 117
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  KB16 118
ifvo:(Y(I)) NEXT#                      Skip if void data                KB16 119
IY=NINT(PTSY*((Y(I)-MINY)/SPANY))#     Find line graph coordinate       KB16 120
IF(IY==YCURR)#                         See if it goes on current li     KB16 121
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 KB16 122
IX=NINT(PTSX*((X(I)-MINX)/SPANX))#     Find column graph coordinate     KB16 123
movechar:(SYMB,1,CHROT,IX+10,NSYMB,1)# Put symbol on line               KB16 124
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 KB16 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  KB16 126
IF(MOD(K-1,5)==0)#                     Y axis increments by 5           KB16 127
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 KB16 128
BUFOT(1)=DELY*EXP(YLIST)#              Change from log to linear        KB16 129
ncodefld:(BUFOT,1,CHROT,80742.,1)#     Put linear on left               KB16 130
ncodefld:(YLIST,1,CHROT,970732.,1)#    Log on right                     KB16 131
movechar:(UNL,1,CHROT,9,NUNL,1)#       Y ticks                          KB16 132
movechar:(UNL,1,CHROT,90,NUNL,1)#      Y ticks                          KB16 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 KB16 134
writeline:(0,0,0,1,4)#                 Write line of plot               KB16 135
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  KB16 136
K=0#                                   Make x ticks                     KB16 137
DO I=1,PTX#                            Loop across line                 KB16 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 KB16 139
IF(MOD(I-1,10)==0)#                                                     KB16 140
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 KB16 141
movechar:(BAR,1,CHROT,K*10+9,NBAR,1)#  X ticks                          KB16 142
K=K+1#                                                                  KB16 143
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 KB16 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 KB16 145
writeline:(0,0,0,1,4)#                                                  KB16 146
FMT=10642.;XLIST=MINX-10.0*STEPX#      Set up x ledgend                 KB16 147
DO I=1,PTX#                                                             KB16 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 KB16 149
IF(MOD(I-1,10)==0)#                    Tick every tenth                 KB16 150
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 KB16 151
XLIST=XLIST+10.0*STEPX;FMT=FMT+100000.0#                                KB16 152
ncodefld:(XLIST,1,CHROT,FMT,1)#        Write fiduciaries                KB16 153
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 KB16 154
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 KB16 155
writeline:(0,0,0,1,4)#                                                  KB16 156
SLOPE=M;YCEPT=B#                       Tell the world                   KB16 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  KB16 158
RETURN#                                                                 KB16 159
END#                                                                    KB16 160
pmacro:([no:])#                        Purge xtal system macros         KB16 161
