systemheader:(MB    )#                                                  MB     1
#####################################################################   MB     2
#                                                                   #   MB     3
#                        **** MAKBRK ****                           #   MB     4
#                                                                   #   MB     5
#   REWRITTEN VERSION OF UCSD' FRODO PROGRAM BY D R HOLLAND         #   MB     6
#   THIS PROGRAM READS AN ELECTRON DENSITY INFORMATION FROM A       #   MB     7
#   XTAL BDF USING RECORDS 21 AND 22.  THIS INFORMATION IS THEN     #   MB     8
#   WRITTEN TO A DIRECT ACCESS FILE IN A "BRICKED" FORMAT.          #   MB     9
#                                                                   #   MB    10
#####################################################################   MB    11
#                                                                       MB    12
include:(XMACRO)#                                                       MB    13
#                                                                       MB    14
extrude:(MBCOMN)#                                                       MB    15
INTEGER INCX(3)#                       Increment for fourier page, ro   MB    16
INTEGER IREC#                          Record pointer for index file    MB    17
INTEGER IORGX(3)#                      Origin for page, row, col        MB    18
INTEGER ISPG#                          Space group no. - intern table   MB    19
INTEGER XYZDIR(3)#                     Order of crystal axes            MB    20
INTEGER DIRXYZ(3)#                     Order of calculation axes        MB    21
INTEGER LBRICK(3)#                     Length of brick in  xyz dirs     MB    22
INTEGER LIMITS(6)#                     Limits in grid units in x,y,z    MB    23
INTEGER MARK#                          Qx array index for start of ma   MB    24
INTEGER NBRICK(3)#                     No. bricks in  x,y,z direction   MB    25
INTEGER NG(3)#                         Grid 'fineness' for page, row,   MB    26
INTEGER NP(3)#                         No. of map points page row col   MB    27
INTEGER PLUS#                          Packing scale factor             MB    28
INTEGER STEPPT#                        Number of bytes to hold one po   MB    29
INTEGER STEPLN#                        Number of words to hold one li   MB    30
INTEGER STEPLY#                        Number of words to hold one la   MB    31
INTEGER SWAP#                          Byte swapping signal on output   MB    32
#                                      =0 no swapping bytes:12345678    MB    33
#                                      =2 swap 2-byte units:21436587    MB    34
#                                      =4 swap 4-byte units:43218765    MB    35
INTEGER IFMT#                          =1 fmt1 frodo for ucsd brick     MB    36
#                                      =0 fmt2 frodo cambridge brick    MB    37
REAL CELL(6)#                          Cell dimensions from rec21       MB    38
REAL PROD#                                                              MB    39
REAL RHOAVG#                           Avg scaled density value of ma   MB    40
REAL RHORMS#                           Root mean square of rho values   MB    41
REAL RHOMIN#                           Min scaled density value of ma   MB    42
REAL RHOMAX#                           Max scaled density value of ma   MB    43
REAL SCALE#                            To scale map densities           MB    44
#                                                                       MB    45
COMMON/COMIMB/IFMT,INCX,IREC,IORGX,ISPG,#                               MB    46
XYZDIR,DIRXYZ,LBRICK,LIMITS,MARK,#                                      MB    47
NBRICK,NG,NP,#                                                          MB    48
PART,PLUS,STEPLN,STEPLY,STEPPT,SWAP#                                    MB    49
#                                                                       MB    50
COMMON/COMFMB/CELL,PROD,RHOAVG,RHORMS,RHOMIN,#                          MB    51
RHOMAX,SCALE#                                                           MB    52
endext:#                                                                MB    53
#                                                                       MB    54
systemheader:(MB00)#                   Main makbrk driver               MB00   1
######################################################################  MB00   2
#                                                                    #  MB00   3
#                             MB00                                   #  MB00   4
#                                                                    #  MB00   5
######################################################################  MB00   6
SUBROUTINE MB00#                       D.r. holland dec 1987            MB00   7
include:(AACOMN)#                                                       MB00   8
include:(MBCOMN)#                                                       MB00   9
#                                                                       MB00  10
FILEXT(IOUNIT(3))='MAP'#               Ext for fourr input map          MB00  11
FILEXT(ioda1:)   ='FRO'#               Ext for output frodo file        MB00  12
#                                                                       MB00  13
CALL MB01#                             Read input lines                 MB00  14
CALL MB11#                             Read fourr map bdf               MB00  15
CALL MB21#                             Write brick file                 MB00  16
#                                                                       MB00  17
RETURN#                                                                 MB00  18
END#                                                                    MB00  19
systemheader:(MB01)#                   Initializing routine             MB01   1
######################################################################  MB01   2
#                                                                    #  MB01   3
#                             MB01                                   #  MB01   4
#                                                                    #  MB01   5
######################################################################  MB01   6
SUBROUTINE MB01#                                                        MB01   7
include:(AACOMN)#                                                       MB01   8
include:(MBCOMN)#                                                       MB01   9
#----------------------------------------------------------             MB01  10
#  NOTE: LBRICK IS ORDERED IN X,Y,Z ORDER (UNLIKE IORGX, INCX ..)       MB01  11
#        LIMITS IS ORDERED IN X,Y,Z ORDER (UNLIKE IORGX, INCX ..)       MB01  12
#----------------------------------------------------------             MB01  13
chardata:(MB015, BYTE SWAPPING APPLIED BETWEEN      BYTES)#             MB01  14
chardata:(MB016, MAKBRK CONTROL PARAMETERS)#                            MB01  15
chardata:(MB018, FORMAT OF BRICK FILE OUTPUT      FMT-)#                MB01  16
chardata:(MB011, LIMITS BRICK  SCALE  END   )#                          MB01  17
chardata:(MB012,NOSWSWAPSWP4FMT1FMT2)#                                  MB01  18
datastuff:#                                                             MB01  19
#                                                                       MB01  20
#   SET DEFAULT PARAMETERS                                              MB01  21
#   ----------------------                                              MB01  22
#                                                                       MB01  23
SCALE=1.0#                                                              MB01  24
RHOMAX=-99999.0#                       Minimum scaled density           MB01  25
RHOMIN=99999.0#                        Maximum scaled density           MB01  26
RHOAVG=0.0#                                                             MB01  27
IREC=1#                                Position in output buffer        MB01  28
DO I=1,6; LIMITS(I)=-999999#           Assume no limits set             MB01  29
DO I=1,3; LBRICK(I)=8#                 Assume 8x8x8 defined bricks      MB01  30
SWAP=0;     IFMT=1#                    Default no swap; fmt1            MB01  31
#                                                                       MB01  32
IOMARK(3)=QXSTR#                       Buffer for fourr map bdf         MB01  33
incrqx:(MARK,IOMARK(3)+bdfbuf:,MB0103)# Get memory for buffer           MB01  34
readwpkt:(3,1,I,J,0)#                  Get the bdf history              MB01  35
#                                                                       MB01  36
#  DECIPHER REST OF MAKBRK LINE                                         MB01  37
#  ----------------------------                                         MB01  38
#                                                                       MB01  39
DO J=1,10#                             Loop over input fields           MB01  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MB01  41
ifvo:(BUFIN(J)) BREAK#                 Exit at first void field         MB01  42
IF(BUFIN(J)>voidflg:) iquit:(MB0101)#  Must be characters               MB01  43
stringlim:(J,I,K)#                     Get position of parameter        MB01  44
compchar:(CHRIN,I,MB012,1,4,4,NMB012,K)# Check for expected param       MB01  45
IF(K==0) iquit:(MB0102)#               Not either of expected param     MB01  46
ELSE IF(K==2) SWAP=2#                  Swap 2 btyes per word            MB01  47
ELSE IF(K==3) SWAP=4#                  Swap 4 bytes per word            MB01  48
ELSE IF(K==5) IFMT=0#                  Fmt2 formatted header type       MB01  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MB01  50
#                                                                       MB01  51
#  READ INPUT LINES                                                     MB01  52
#  ----------------                                                     MB01  53
#                                                                       MB01  54
REPEAT#                                Loop to read cards               MB01  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MB01  56
readline:(MB011,NMB011)#               Read next input line             MB01  57
IF(LINID==4) BREAK#                    Exit with end line               MB01  58
#                                                                       MB01  59
IF(LINID==1)#                          ******* limits *************     MB01  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MB01  61
DO I=1,6#                              Loop over limits                 MB01  62
ifnv:(BUFIN(I)) LIMITS(I)=INT(BUFIN(I))# Store xyz map limits           MB01  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MB01  64
#                                                                       MB01  65
ELSE IF(LINID==2)#                     ******** brick **************    MB01  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MB01  67
DO I=1,3#                              Loop over brick dimensions       MB01  68
IF(BUFIN(I)>0.0 & IFMT==0) LBRICK(I)=INT(BUFIN(I))# Store brick grid    MB01  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MB01  70
#                                                                       MB01  71
ELSE IF(LINID==3)#                     ******** scale *************     MB01  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MB01  73
IF(BUFIN(1)>0.0) SCALE=BUFIN(1)#       Get density scale                MB01  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MB01  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MB01  76
#                                                                       MB01  77
#   START PARAMETER PRINT                                               MB01  78
#   ---------------------                                               MB01  79
#                                                                       MB01  80
movechar:(MB018,NMB018,CHROT,2,NMB016-1,1)# Store underline             MB01  81
writeline:(1,MB016,NMB016,2,3)#        Print header                     MB01  82
ncodefld:(FLOAT(2-IFMT),1,MB018,380113.,1)# Format format number        MB01  83
writeline:(0,MB018,NMB018,3,3)#        Fmt1 format used                 MB01  84
ncodefld:(FLOAT(SWAP),1,MB015,350213.,1)# Format bytes swapped          MB01  85
writeline:(0,MB015,NMB015,3,3)#        Admit to swapping                MB01  86
#                                                                       MB01  87
RETURN#                                                                 MB01  88
END#                                                                    MB01  89
systemheader:(MB11)#                   Read bdf information             MB11   1
######################################################################  MB11   2
#                                                                    #  MB11   3
#                             MB11                                   #  MB11   4
#                                                                    #  MB11   5
######################################################################  MB11   6
SUBROUTINE MB11#                                                        MB11   7
include:(AACOMN)#                                                       MB11   8
include:(MBCOMN)#                                                       MB11   9
#----------------------------------------------------------             MB11  10
#  NOTE: NGRID IS ORDERED IN X,Y,Z ORDER (UNLIKE IORGX, INCX ..)        MB11  11
#        NBRICK IS ALSO ORDERED THIS WAY                                MB11  12
#----------------------------------------------------------             MB11  13
REAL ADJUST#                           Adjustment to scale factor       MB11  14
REAL RHOSQR#                           Sum of rho**2 values             MB11  15
REAL RHOX2#                            Sum of rho*2 values              MB11  16
INTEGER NTOT#                          Total number of density values   MB11  17
INTEGER PSIZE#                                                          MB11  18
chardata:(MB001, SIZE OF BRICKS FOR FRODO FILE                       )# MB11  19
chardata:(MB003, NUMBER OF BRICKS ALONG XYZ                          )# MB11  20
chardata:(MB004, MAP XYZ OUTPUT GRID MINIMUM                         )# MB11  21
chardata:(MB005, MAP XYZ OUTPUT GRID MAXIMUM                         )# MB11  22
chardata:(MB006, MAP XYZ INPUT  GRID MINIMUM                         )# MB11  23
chardata:(MB007, MAP XYZ INPUT  GRID MAXIMUM                         )# MB11  24
chardata:(MB009, RHORMS RHOAVG RHOMAX RHOMIN                         $# MB11  25
                        )#                                              MB11  26
chardata:(MB011, SCALE ADJUSTED BY                                   )# MB11  27
chardata:(MB010, FINAL SCALE USED                                    )# MB11  28
chardata:(MB012, DENSITY SCALE AND INCREMENT                         )# MB11  29
realdata:(FMT1,[350513.,400513.,450513.])#                              MB11  30
datastuff:#                                                             MB11  31
#                                                                       MB11  32
#  READ CELL DIMENSIONS                                                 MB11  33
#  ---------------------                                                MB11  34
#                                                                       MB11  35
readwpkt:(3,lrcell:,PSIZE,IP,0)#       Read in cell record              MB11  36
IF(IP<=0) iquit:(MB1101)#              Exit on last record              MB11  37
movereal:(QX,IP+1,CELL,1,3,0)#         Save real cell constants         MB11  38
movereal:(QX,IP+7,CELL,4,3,0)#         Save real cell constants         MB11  39
DO I=1,3; CELL(I+3)=CELL(I+3)*360.#    Cycles to degrees                MB11  40
#                                                                       MB11  41
#   READ MAP DIMENSIONS FROM BDF                                        MB11  42
#   ----------------------------                                        MB11  43
#                                                                       MB11  44
readwpkt:(3,21,PSIZE,IPT,0)#           Read rec21 map dimensions        MB11  45
IF(IPT < 0) iquit:(MB1201)#            No rec 21 in bdf                 MB11  46
DO K=1,3#                              Loop over map dimensions         MB11  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MB11  48
IIP=IPT+K#                             Incr packet pointer              MB11  49
IORGX(K)=NINT(QX(IIP))#                Pick up origins                  MB11  50
INCX(K)=NINT(QX(IIP+3))#               Increments along axes            MB11  51
NG(K)=NINT(QX(IIP+6))#                 No. of grid points               MB11  52
NP(K)=NINT(QX(IIP+9))#                 Calculated points                MB11  53
XYZDIR(K)=NINT(QX(IIP+12))#            Correlations between crystal     MB11  54
DIRXYZ(K)=NINT(QX(IIP+15))#            Axes and calculation axes        MB11  55
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MB11  56
#                                                                       MB11  57
#   SET CONTOUR LIMITS                                                  MB11  58
#   ------------------                                                  MB11  59
#                                                                       MB11  60
DO  I=1,3#                             Look at all limits               MB11  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MB11  62
J=I*2#                                 Set limits pointer               MB11  63
K=IORGX(XYZDIR(I))#                    Get min grid in order            MB11  64
L=K+INCX(XYZDIR(I))*(NP(XYZDIR(I))-1)# Get max grid in order            MB11  65
IF(LIMITS(J-1)==-999999) LIMITS(J-1)=K# Set lower limit to origin       MB11  66
IF(LIMITS(J  )==-999999) LIMITS(J  )=L# Set upper limit to default      MB11  67
IF(LIMITS(J-1)<K) iquit:(MB1202)#      Exit outside limits              MB11  68
IF(LIMITS(J  )>L) iquit:(MB1202)#      Exit outside limits              MB11  69
BUFOT(I+3)=FLOAT(K); BUFOT(I+6)=FLOAT(L)# Float for printing later      MB11  70
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MB11  71
#                                                                       MB11  72
#   CHECK BRICK SIZE                                                    MB11  73
#   ----------------                                                    MB11  74
#                                                                       MB11  75
DO  I=1,3#                             Loop brick dimensions            MB11  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MB11  77
NGRID=LIMITS(2*I)-LIMITS(2*I-1)+1#     No. of grid pts. in each di      MB11  78
IF(IFMT==1)#                           ...fmt1 brick file               MB11  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MB11  80
NBRICK(I)=NGRID/LBRICK(I)#             Number bricks in x,y,z           MB11  81
IF(MOD(NGRID,8)!=0) NBRICK(I)=NBRICK(I)+1# Account for partial brick    MB11  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MB11  83
ELSE#                                  ...fmt2 brick type               MB11  84
NBRICK(I)=(NGRID+LBRICK(I)-3)/(LBRICK(I)-1)# Number bricks in xyz       MB11  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MB11  86
#                                                                       MB11  87
#  PRINT MAP PARAMETERS                                                 MB11  88
#  --------------------                                                 MB11  89
#                                                                       MB11  90
ncodefld:(BUFOT,4,MB006,FMT1,3)#       Format input map min             MB11  91
writeline:(1,MB006,NMB006,3,3)#        Print input map min              MB11  92
ncodefld:(BUFOT,7,MB007,FMT1,3)#       Format input map max             MB11  93
writeline:(0,MB007,NMB007,3,3)#        Print input map max              MB11  94
DO I=1,3; BUFOT(I)=FLOAT(LIMITS(I*2-1))# Float map min                  MB11  95
ncodefld:(BUFOT,1,MB004,FMT1,3)#       Format map min                   MB11  96
writeline:(1,MB004,NMB004,3,3)#        Print map min                    MB11  97
DO I=1,3; BUFOT(I)=FLOAT(LIMITS(I*2))# Float map max                    MB11  98
ncodefld:(BUFOT,1,MB005,FMT1,3)#       Format map max                   MB11  99
writeline:(0,MB005,NMB005,3,3)#        Print map max                    MB11 100
DO I=1,3; BUFOT(I)=FLOAT(LBRICK(I))#   Float brick size                 MB11 101
ncodefld:(BUFOT,1,MB001,FMT1,3)#       Format brick size                MB11 102
writeline:(1,MB001,NMB001,3,3)#        Print brick size                 MB11 103
DO I=1,3; BUFOT(I)=FLOAT(NBRICK(I))#   Float brick number               MB11 104
ncodefld:(BUFOT,1,MB003,FMT1,3)#       Format brick size                MB11 105
writeline:(0,MB003,NMB003,3,3)#        Print brick size                 MB11 106
#                                                                       MB11 107
#  SCAN MAP POINTS FOR DENSITY SCALE                                    MB11 108
#  ---------------------------------                                    MB11 109
#                                                                       MB11 110
NTOT= NP(1)*NP(2)*NP(3)#               Number of scaled density value   MB11 111
RHOSQR=0.; RHOX2 =0.#                  Set initial rho values           MB11 112
REPEAT#                                Loop thru rec 22's               MB11 113
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MB11 114
readwpkt:(3,22,PSIZE,IPT,0)#           Read the map                     MB11 115
IF(IPT<=0) BREAK#                      No more rec 22's                 MB11 116
DO J=1,NP(3)#                          Scan thru row of densities       MB11 117
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MB11 118
SCLRHO=SCALE*QX(IPT+J)#                Use scale factor requested       MB11 119
RHOAVG=RHOAVG+SCLRHO#                  Accumulate scaled density        MB11 120
RHOSQR=SCLRHO*SCLRHO+RHOSQR#           Accumulate squared rho values    MB11 121
RHOX2 =SCLRHO*2+RHOX2#                 Accumulate 2*rho values          MB11 122
IF(RHOMAX<SCLRHO) RHOMAX=SCLRHO#       Check for max density            MB11 123
IF(RHOMIN>SCLRHO) RHOMIN=SCLRHO#       Check for min density            MB11 124
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MB11 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MB11 126
rewindbdf:(3)#                         Rewind the map file              MB11 127
#                                                                       MB11 128
#  FIGURE SCALE FACTOR AND THRESHOLD                                    MB11 129
#  ---------------------------------                                    MB11 130
#                                                                       MB11 131
ifeq:(RHOMAX,RHOMIN) iquit:(MB1102)#   All densities same - quit        MB11 132
#  DETERMINE MULTIPLICATIVE/ADDITIVE SCALE FACTORS USED TO STORE        MB11 133
#  DENSITIES INTO 1-BYTE INTEGER.                                       MB11 134
ILOOP=0#                               Get ready to loop                MB11 135
ADJUST=1.0#                            Assume packing factors ok        MB11 136
REPEAT#                                Loop until packink factors ok    MB11 137
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MB11 138
ILOOP=ILOOP+1#                         No. of cycles to satisfy         MB11 139
IF(ILOOP>10) BREAK#                    Finding pack factors is hopele   MB11 140
PROD=255./(ADJUST*(RHOMAX-RHOMIN))#    Figure scale factors             MB11 141
IF(IFMT==1) PLUS=IFIX(-PROD*RHOMIN*ADJUST)# Density increment           MB11 142
ELSE        PLUS=IFIX(127.0-PROD*RHOMAX*ADJUST)# Density increment      MB11 143
#                                                                       MB11 144
#   MULT/ADD PACKING FACTORS ARE STORED AS INT(FACTOR*100).             MB11 145
#   MUST CHECK THAT THIS CONVERSION DOESN'T PUT FACTOR VALUE OUT OF     MB11 146
#   INTEGER*2 VALUE RANGE.                                              MB11 147
#                                                                       MB11 148
IF(IFMT!=1) BREAK#                     Can values fit in int*2 words    MB11 149
IF(PROD>320.\PLUS>32000) ADJUST=ADJUST*10.# Incr dens/decr pack fact    MB11 150
ELSE IF(ABS(PROD)<.01)   ADJUST=ADJUST*.10# Decr dens/incr pack fact    MB11 151
ELSE BREAK#                            Packing factors are acceptable   MB11 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MB11 153
ifne:(ADJUST,1.0)#                     Update rho values with adjust    MB11 154
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MB11 155
SCALE=SCALE*ADJUST#                    Adjust scale factor              MB11 156
RHOSQR=RHOSQR*ADJUST*ADJUST#           New scale effects all rho vals   MB11 157
RHOX2=RHOX2*ADJUST#                                                     MB11 158
RHOAVG=RHOAVG*ADJUST#                                                   MB11 159
RHOMAX=RHOMAX*ADJUST#                                                   MB11 160
RHOMIN=RHOMIN*ADJUST#                                                   MB11 161
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MB11 162
RHOAVG=RHOAVG/FLOAT(NTOT)#             Average scaled density value     MB11 163
RHORMS=SQRT((RHOSQR-RHOAVG*RHOX2+NTOT*(RHOAVG**2))/FLOAT(NTOT))#        MB11 164
ncodefld:(RHORMS,1,MB009,401031.,1)#   Format rho value                 MB11 165
ncodefld:(RHOAVG,1,MB009,501031.,1)#   Format rho value                 MB11 166
ncodefld:(RHOMAX,1,MB009,601031.,1)#   Format rho value                 MB11 167
ncodefld:(RHOMIN,1,MB009,701031.,1)#   Format rho value                 MB11 168
writeline:(1,MB009,NMB009,3,3)#        Print rho values                 MB11 169
ncodefld:(PROD,1,MB012,401032.,1)#     Report scale factors             MB11 170
ncodefld:(FLOAT(PLUS),1,MB012,500513.,1)#                               MB11 171
writeline:(0,MB012,NMB012,3,3)#                                         MB11 172
ncodefld:(ADJUST,1,MB011,401032.,1)#   Report scale adjustment          MB11 173
writeline:(0,MB011,NMB011,3,3)#                                         MB11 174
ncodefld:(SCALE,1,MB010,401032.,1)#    Report final scale applied       MB11 175
writeline:(0,MB010,NMB010,3,3)#                                         MB11 176
IF(ILOOP>10) iquit:(MB1103)#           Can't pack densities into byte   MB11 177
#                                                                       MB11 178
#    OUTPUT HEADER FRODO (OUTPUT) FILE                                  MB11 179
#    ---------------------------------                                  MB11 180
#                                                                       MB11 181
IF(IFMT==1) CALL MB12#                 Start fmt1 file                  MB11 182
ELSE        CALL MB13#                 Start fmt2 file                  MB11 183
#                                                                       MB11 184
RETURN#                                                                 MB11 185
END#                                                                    MB11 186
systemheader:(MB12)#                   Create fmt1 brick header         MB12   1
######################################################################  MB12   2
#                                                                    #  MB12   3
#                             MB12                                   #  MB12   4
#                                                                    #  MB12   5
######################################################################  MB12   6
SUBROUTINE MB12#                                                        MB12   7
include:(AACOMN)#                                                       MB12   8
include:(MBCOMN)#                                                       MB12   9
#                                                                       MB12  10
INTEGER*2 FIRST(256),K2#               Hold first output record         MB12  11
INTEGER I1#                            Scale factor                     MB12  12
INTEGER I2#                            Scale factor                     MB12  13
INTEGER JNT(2)#                        For byte swapping                MB12  14
#                                                                       MB12  15
opendac:(ioda1:,3,512 ,' ')#           Fmt1 512 bytes long              MB12  16
DO I=1,256; FIRST(I)=0#                Zero unused record               MB12  17
I1=100; I2=100#                        Default scale factors            MB12  18
#                                                                       MB12  19
#   FILL UP FIRST RECORD                                                MB12  20
#   ---------------------                                               MB12  21
#                                                                       MB12  22
DO  I=1,3#                             Loop over axes                   MB12  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MB12  24
FIRST(I)=LIMITS(2*I-1)#                Lower limits for x, y, z         MB12  25
FIRST(I+3)=(LIMITS(2*I)-LIMITS(2*I-1))+1# Limit range for x,y,z         MB12  26
FIRST(I+6)=NG(XYZDIR(I))#              Number grid pts. in x,y,z        MB12  27
FIRST(I+9)=I1*CELL(I)#                 Cell dimensions in x,y,z         MB12  28
FIRST(I+12)=I1*CELL(I+3)#              Cell angles in x,y,z             MB12  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MB12  30
FIRST(16)=I2*PROD#                     Multiplicative scale of den      MB12  31
FIRST(17)=PLUS#                        Additive scale of den            MB12  32
FIRST(18)=I1#                          Store scale factor               MB12  33
FIRST(19)=I2#                          Store scale factor               MB12  34
#                                                                       MB12  35
IF(SWAP>0)#                            Test for byte swap               MB12  36
DO I=1,19#                             Loop over active words           MB12  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MB12  38
K=FIRST(I)#                            Store as full integer            MB12  39
DO J=1,2; intunpak:(K,JNT(J),16-J*8,8)# Extract bytes                   MB12  40
DO J=1,2; intpak:(JNT(3-J),K2,16-J*8,8)# Pack away byte                 MB12  41
FIRST(I)=K2#                           Store as half integer            MB12  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MB12  43
writedac:(ioda1:,,1,(FIRST(II),II=1,256))# Write header record          MB12  44
#                                                                       MB12  45
RETURN#                                                                 MB12  46
END#                                                                    MB12  47
systemheader:(MB13)#                   Create fmt2 brick header         MB13   1
######################################################################  MB13   2
#                                                                    #  MB13   3
#                             MB13                                   #  MB13   4
#                                                                    #  MB13   5
######################################################################  MB13   6
SUBROUTINE MB13#                                                        MB13   7
include:(AACOMN)#                                                       MB13   8
include:(MBCOMN)#                                                       MB13   9
#                                                                       MB13  10
INTEGER XYZ(3)#                        Hold common dirxyz values        MB13  11
INTEGER ISTART(3)#                     Lower limit of map to brick      MB13  12
INTEGER ILAST(3)#                      Upper limit of map to brick      MB13  13
INTEGER ILBRK(3)#                      Hold common lbrick value         MB13  14
INTEGER ISPGG#                         Hold common ispg value           MB13  15
INTEGER JNT(4)#                        Extracted swapped bytes          MB13  16
INTEGER MODE#                          Mode of brick storage (fmt2)     MB13  17
INTEGER NPTS(3)#                       No. pts in xyz to brick          MB13  18
INTEGER NGXYZ(3)#                      Grid intervals in xyz            MB13  19
REAL    FIRST(256)#                    Hold first output record         MB13  20
EQUIVALENCE (ISTART(1),FIRST(5)),$#                                     MB13  21
            (MODE,     FIRST(4)),$#                                     MB13  22
            (NGXYZ,    FIRST(8)),$#                                     MB13  23
            (NPTS(1),  FIRST(1)),$#                                     MB13  24
            (XYZ(1),   FIRST(17)),$#                                    MB13  25
            (ISPGG,    FIRST(23)),$#                                    MB13  26
            (ILBRK(1), FIRST(40))#                                      MB13  27
#                                                                       MB13  28
#   ALL INTEGER VALUES ARE EQUIVALENCED TO REAL*4 HEADER ARRAY          MB13  29
#    SINCE THEY ARE PICKED UP THIS WAY BY MRDBRK,MRDHDR IN FMT2         MB13  30
#                                                                       MB13  31
opendac:(ioda1:,3,1024,' ')#           Fmt2 1024 bytes long             MB13  32
DO I=1,256; FIRST(I)=0.#               Zero out unused record           MB13  33
ISPGG=ISPG; MODE=10#                   Mode=10, bricked 2-bytes         MB13  34
#                                                                       MB13  35
DO  I=1,3#                             Loop over axes                   MB13  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MB13  37
IDIR=4-I#                              =1 page, =2 down, =3 across      MB13  38
XYZ(I)=I#                              Order of output map is fixed     MB13  39
ISTART(I)=LIMITS(2*I-1)#               Lower limits for x, y, z         MB13  40
ILAST(I) =LIMITS(2*I)#                 Upper limits for x, y, z         MB13  41
NPTS(I)=(ILAST(I)-ISTART(I)+1)/INCX(IDIR)# No. map pts in current dir   MB13  42
NGXYZ(I)=NG(XYZDIR(I))#                Grid sampling along xyz          MB13  43
ILBRK(I)=LBRICK(I)#                                                     MB13  44
FIRST(I+10)=CELL(I)#                   Cell dimensions in x,y,z         MB13  45
FIRST(I+13)=CELL(I+3)#                 Cel angles in x,y,z              MB13  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MB13  47
FIRST(20)=RHOMIN#                      Minimun scaled density           MB13  48
FIRST(21)=RHOMAX#                      Maximum scaled density           MB13  49
FIRST(22)=RHOAVG#                      Average scaled density           MB13  50
FIRST(38)=PROD#                        Multipl term for packing         MB13  51
FIRST(39)=FLOAT(PLUS)#                 Additive term for packing        MB13  52
FIRST(55)=RHORMS#                      Rms value for density            MB13  53
#                                                                       MB13  54
IF(SWAP>0)#                            Test for byte swap               MB13  55
DO I=1,55#                             Loop over active words           MB13  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MB13  57
DO J=1,4; intunpak:(FIRST(I),JNT(J),32-J*8,8)# Extract bytes            MB13  58
DO J=1,4#                              Store bytes                      MB13  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MB13  60
K=J+SWAP-2*MOD(J-1,SWAP)-1#            Point to swapped position        MB13  61
intpak:(JNT(K),FIRST(I),32-J*8,8)#     Pack away byte                   MB13  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MB13  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MB13  64
writedac:(ioda1:,,1,(FIRST(II),II=1,256))# Write header record          MB13  65
#                                                                       MB13  66
RETURN#                                                                 MB13  67
END#                                                                    MB13  68
systemheader:(MB21)#                   Read map into memory             MB21   1
######################################################################  MB21   2
#                                                                    #  MB21   3
#                             MB21                                   #  MB21   4
#                                                                    #  MB21   5
######################################################################  MB21   6
SUBROUTINE MB21#                                                        MB21   7
include:(AACOMN)#                                                       MB21   8
include:(MBCOMN)#                                                       MB21   9
#                                                                       MB21  10
INTEGER BYTINX#                        Byte position for density in w   MB21  11
INTEGER IPT#                                                            MB21  12
INTEGER IPUTX#                         Position for x axis in frodo m   MB21  13
INTEGER IPUTY#                         Position for y axis in frodo m   MB21  14
INTEGER IPUTZ#                         Position for z axis in frodo m   MB21  15
INTEGER J,I#                           Loop indices                     MB21  16
INTEGER ILAYZ#                         Current z of entire map          MB21  17
INTEGER LLIMX#                         Lower x limit for storing map    MB21  18
INTEGER LLIMY#                         Lower y limit for storing map    MB21  19
INTEGER LLIMZ#                         Lower z limit for storing map    MB21  20
INTEGER NACROS#                        No. points across fourier map    MB21  21
INTEGER NLINE#                         No. points down fourier map      MB21  22
INTEGER NZPPAS#                        No. layers per storage pass      MB21  23
INTEGER PASSES#                        Number of passes needed to rea   MB21  24
INTEGER PSIZE#                                                          MB21  25
INTEGER TOTFOU#                        Number words needed to store f   MB21  26
INTEGER TOTMEM#                        Total words of memory availabl   MB21  27
INTEGER ULIMX#                         Upper x limit for storing map    MB21  28
INTEGER ULIMY#                         Upper y limit for storing map    MB21  29
INTEGER ULIMZ#                         Upper z limit for storing map    MB21  30
INTEGER WRDINX#                        Index in qx array to store den   MB21  31
INTEGER XDIR,$#                        Index to iorgx, incx, ...        MB21  32
        YDIR,$#                        Mapping xyz to uvw               MB21  33
        ZDIR#                                                           MB21  34
INTEGER XMAX#                          Number points in x dir of inpu   MB21  35
INTEGER YMAX#                          Number points in y dir of inpu   MB21  36
INTEGER ZMAX#                          Number points in z dir of inpu   MB21  37
INTEGER ZCURMN#                        Lower limit of current pass' s   MB21  38
INTEGER ZCURMX#                        Upper limit of current pass' s   MB21  39
INTEGER ZLIMDF#                        Z dimension in limitted map      MB21  40
#                                                                       MB21  41
#   DETERMINE LIMITS FOR STORING MAP                                    MB21  42
#   --------------------------------                                    MB21  43
#                                                                       MB21  44
XDIR=XYZDIR(1)#                        Index to iorgx, incx, limits     MB21  45
YDIR=XYZDIR(2)#                        Mapping xyz to uvw axes          MB21  46
ZDIR=XYZDIR(3)#                                                         MB21  47
LLIMX=(LIMITS(1)-IORGX(XDIR)+1)/INCX(XDIR)# Lower xyz grids pt to       MB21  48
LLIMY=(LIMITS(3)-IORGX(YDIR)+1)/INCX(YDIR)# Be output                   MB21  49
LLIMZ=(LIMITS(5)-IORGX(ZDIR)+1)/INCX(ZDIR)#                             MB21  50
ULIMX=(LIMITS(2)-IORGX(XDIR)+1)/INCX(XDIR)# Upper xyz grid pts to       MB21  51
ULIMY=(LIMITS(4)-IORGX(YDIR)+1)/INCX(YDIR)# Be output                   MB21  52
ULIMZ=(LIMITS(6)-IORGX(ZDIR)+1)/INCX(ZDIR)#                             MB21  53
ZLIMDF=ULIMZ - LLIMZ+1#                Z dimensiion in limted map       MB21  54
#                                                                       MB21  55
#   DEFINE MAP LAYOUT                                                   MB21  56
#   -----------------                                                   MB21  57
#                                                                       MB21  58
NACROS=NP(3)#                          Input dim in across direction    MB21  59
NLINE= NP(2)#                          Input dim in down direction      MB21  60
XMAX=NP(XDIR)#                         Input dim in x direction         MB21  61
YMAX=NP(YDIR)#                         Input dim in y direction         MB21  62
ZMAX=NP(ZDIR)#                         Input dim in z direction         MB21  63
STEPPT=1#                              1 byte per point                 MB21  64
STEPLN=1+(XMAX-1)/mxchwd:#             Words per line of map            MB21  65
STEPLY=STEPLN*YMAX#                    Words per layer of map           MB21  66
TOTFOU=STEPLY*ZLIMDF#                  Words needed for entire map      MB21  67
#                                                                       MB21  68
#   RESERVE QX ARRAY FOR MAP STORAGE                                    MB21  69
#   --------------------------------                                    MB21  70
#                                                                       MB21  71
IF(QXMAX<MARK+TOTFOU) TOTMEM=QXMAX-MARK# Take what we can get           MB21  72
ELSE                  TOTMEM=TOTFOU#   Or use what we requested         MB21  73
qxmemory:(MARK+TOTMEM)#                Request memory needed            MB21  74
#                                                                       MB21  75
#   FIGURE NUMBER OF Z BRICKS IN MEMORY                                 MB21  76
#   --------------------------------                                    MB21  77
#                                                                       MB21  78
NZPPAS=TOTMEM/STEPLY#                  No. z's per pass                 MB21  79
PASSES=1+((TOTFOU-1)/TOTMEM)#          Number of passes required        MB21  80
ZCURMN=LLIMZ-NZPPAS#                   Initialize min/max layers t      MB21  81
ZCURMX=LLIMZ#                          Be read into memory              MB21  82
ILAYZ=0#                               Current layer in entire map      MB21  83
#                                                                       MB21  84
#  READ IN DENSITIES AND STORE IN QX ARRAY ACCORDING TO SORT ORDER      MB21  85
#  ---------------------------------------------------------------      MB21  86
#                                                                       MB21  87
REPEAT#                                Loop over passes                 MB21  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MB21  89
DO I=1,TOTMEM; QX(I+MARK)=0.0#         For all memory, clear words      MB21  90
ZCURMN=ZCURMN+NZPPAS#                  Update screening limits on       MB21  91
ZCURMX=ZCURMX+NZPPAS#                  Crystalligraphic layers          MB21  92
IF(PASSES==0) BREAK#                   Completed required passes        MB21  93
IPUTX=0; IPUTY=0; IPUTZ=0#             Position in output map           MB21  94
#                                                                       MB21  95
#   LOOP OVER ROWS OF DENSITY MAP TO REORDER INPUT MAP TO               MB21  96
#   X=ACROSS Y=DOWN Z=PAGE                                              MB21  97
#   -----------------------------------------------------               MB21  98
#                                                                       MB21  99
REPEAT#                                                                 MB21 100
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MB21 101
readwpkt:(3,22,PSIZE,IPT,0)#           Read row of densities            MB21 102
IF(IPT<=0) BREAK#                      No more rec 22's                 MB21 103
#                                                                       MB21 104
# ***                                                                   MB21 105
IF(DIRXYZ(2)==1)#                      Test if x is down the page       MB21 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MB21 107
IF(MOD(IPUTX,XMAX)==0)#                Is x at begin/end of layer?      MB21 108
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MB21 109
IPUTX=1#                               Start iput count over            MB21 110
IF(DIRXYZ(1)==2) IPUTY=IPUTY+1#        If y the page to page axis?      MB21 111
ELSE IF(DIRXYZ(1)==3)#                 Is z the page to page axis?      MB21 112
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MB21 113
IPUTZ=IPUTZ+1#                         Next layer in this pass of m     MB21 114
ILAYZ=ILAYZ+1#                         Next layer in entire map         MB21 115
IF(ILAYZ<ZCURMN)NEXT#                  Layer below pass range           MB21 116
IF(ILAYZ>ZCURMX) BREAK#                Packet reading done for pass     MB21 117
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MB21 118
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MB21 119
ELSE IPUTX=IPUTX+1#                    Increment x position             MB21 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MB21 121
# ***                                                                   MB21 122
ELSE IF(DIRXYZ(2)==2)#                 Test if y is down the page       MB21 123
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MB21 124
IF(MOD(IPUTY,YMAX)==0)#                Is y at begin/end of layer?      MB21 125
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MB21 126
IPUTY=1#                               Start iput count over            MB21 127
IF(DIRXYZ(1)==1) IPUTX=IPUTX+1#        If x the page to page axis?      MB21 128
ELSE IF(DIRXYZ(1)==3)#                 Is z the page to page axis?      MB21 129
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MB21 130
IPUTZ=IPUTZ+1#                         Next layer in current pass       MB21 131
ILAYZ=ILAYZ+1#                         Next layer in entire map         MB21 132
IF(ILAYZ<ZCURMN)NEXT#                  Layer below pass range           MB21 133
IF(ILAYZ>ZCURMX) BREAK#                Packet reading done for pass     MB21 134
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MB21 135
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MB21 136
ELSE IPUTY=IPUTY+1#                    Increment y position             MB21 137
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MB21 138
# ***                                                                   MB21 139
ELSE IF(DIRXYZ(2)==3)#                 Test if z is down the page       MB21 140
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MB21 141
IF(MOD(IPUTZ,ZMAX)==0)#                Is z at begin/end of layer?      MB21 142
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MB21 143
IPUTZ=1#                               Start iput count over            MB21 144
IF(DIRXYZ(1)==1) IPUTX=IPUTX+1#        If x the page to page axis?      MB21 145
ELSE IF(DIRXYZ(1)==2) IPUTY=IPUTY+1#   If y the page to page axis?      MB21 146
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MB21 147
ELSE#                                                                   MB21 148
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MB21 149
IPUTZ=IPUTZ+1#                         Increment z position             MB21 150
IF(IPUTZ<ZCURMN \ IPUTZ>ZCURMX) NEXT#  Layer not in current pass ra     MB21 151
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MB21 152
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MB21 153
#                                                                       MB21 154
#   SCAN CURRENT ROW OF DENSITIES                                       MB21 155
#   ------------------------------                                      MB21 156
#                                                                       MB21 157
DO J=1,NACROS#                         For each density in row ...      MB21 158
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MB21 159
IF(DIRXYZ(3)==1)      IPUTX=MOD(IPUTX,XMAX)+1# Increment x position     MB21 160
ELSE IF(DIRXYZ(3)==2) IPUTY=MOD(IPUTY,YMAX)+1# Increment y position     MB21 161
ELSE IF(DIRXYZ(3)==3)#                 Z is across page                 MB21 162
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MB21 163
IPUTZ=MOD(IPUTZ,ZMAX)+1#               Increment z position             MB21 164
IF(IPUTZ<ZCURMN \ IPUTZ>ZCURMX) NEXT#  Only read layers for current     MB21 165
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MB21 166
WRDINX=(IPUTX-1)/mxchwd:+(IPUTY-1)*STEPLN+(IPUTZ-1)*STEPLY+1+MARK#      MB21 167
BYTINX=8*MOD(IPUTX-1,mxchwd:)#                                          MB21 168
IVALUE=INT(SCALE*QX(IPT+J)*PROD)+PLUS# Map density to [0,255]           MB21 169
intpak:(IVALUE,QX(WRDINX),BYTINX,8)#   Pack density into byte           MB21 170
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MB21 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MB21 172
IF(DIRXYZ(1)!=3) rewindbdf:(3)#        If first sum not z direction     MB21 173
#                                                                       MB21 174
#   BRICK DENSITIES STORED DURING THIS PASS                             MB21 175
#   ---------------------------------------                             MB21 176
#                                                                       MB21 177
CALL MB22(LLIMX,ULIMX,LLIMY,ULIMY,NZPPAS)# Brick the data from memor.   MB21 178
PASSES=PASSES-1#                       Completed current pass           MB21 179
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MB21 180
closedac:(ioda1:)#                                                      MB21 181
#                                                                       MB21 182
RETURN#                                                                 MB21 183
END#                                                                    MB21 184
systemheader:(MB22)#                   Write bricks to output file      MB22   1
######################################################################  MB22   2
#                                                                    #  MB22   3
#                             MB22                                   #  MB22   4
#                                                                    #  MB22   5
######################################################################  MB22   6
SUBROUTINE MB22(LX,UX,LY,UY,NZPPAS)#                                    MB22   7
include:(AACOMN)#                                                       MB22   8
include:(MBCOMN)#                                                       MB22   9
#                                                                       MB22  10
INTEGER IVALUE#                        Density retrieved from storage   MB22  11
INTEGER BYTINX#                        Bit position in word             MB22  12
INTEGER NWORD#                         Buffer word count                MB22  13
INTEGER NBIT,MBIT,IBIT#                Buffer bit pointers              MB22  14
INTEGER NCLUSZ#                        Inclusive bricks in z            MB22  15
INTEGER LRECL#                         Record length in words           MB22  16
INTEGER JX,JY,JZ#                      Loop indices                     MB22  17
INTEGER LX,UX,LY,UY#                   Loop indices                     MB22  18
INTEGER WRDINX#                        Index of dens. in storage arra   MB22  19
REAL    RECORD(256)#                   Bricked map output               MB22  20
#                                                                       MB22  21
#   SET UP OUTPUT PARAMETERS DEPENDING ON TYPE OF FILE FORMAT           MB22  22
#   --------------------------------------------------------            MB22  23
#                                                                       MB22  24
NBIT=0;   NWORD=0#                     Bit and word counters            MB22  25
IS=8*SWAP;   IW=mxbtwd:-IS#            Set bit increments               MB22  26
IF(IFMT==1)      LRECL=128#            Words per fmt1 output record     MB22  27
ELSE             LRECL=256#            Words per fmt2 output record     MB22  28
#                                                                       MB22  29
#   ESTABLISH XYZ PTS TO BE INCLUDED IN NEXT BRICK                      MB22  30
#   ----------------------------------------------                      MB22  31
#                                                                       MB22  32
IZST=1#                                                                 MB22  33
NCLUSZ=NZPPAS/LBRICK(3)#               Get inclusive bricks in z        MB22  34
IF(MOD(NCLUSZ,LBRICK(3))!=0) NCLUSZ=NCLUSZ+1# But get 'em all!          MB22  35
DO JZ=1,NCLUSZ#                        Loop over z bricks               MB22  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MB22  37
IZEND=IZST+LBRICK(3)-1#                Z pt to end next brick           MB22  38
IYST=LY#                               Y pt to start next brick         MB22  39
DO JY=1,NBRICK(2)#                     Loop thru bricks in y dir        MB22  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MB22  41
IYEND=IYST+LBRICK(2)-1#                Y pt to end next brick           MB22  42
IXST=LX#                               X pt to start next brick         MB22  43
DO JX=1,NBRICK(1)#                     Loop thru bricks in x dir        MB22  44
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MB22  45
IXEND=IXST+LBRICK(1)-1#                X pt to end next brick           MB22  46
#                                                                       MB22  47
#   FETCH BACK THE ELECTRON DENSITY FROM THE STORAGE ARRAY              MB22  48
#   ------------------------------------------------------              MB22  49
#                                                                       MB22  50
DO IZZ=IZST,IZEND#                     Extent of brick in z dir         MB22  51
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MB22  52
DO IYY=IYST,IYEND#                     Extent of brick in y dir         MB22  53
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MB22  54
DO IXX=IXST,IXEND#                     Extent of brick in x dir         MB22  55
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MB22  56
IF(IZZ>NZPPAS\IYY>UY\IXX>UX) IVALUE=0# Fill out unused rest of bric     MB22  57
ELSE#                                  If active density point          MB22  58
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MB22  59
WRDINX=(IXX-1)/mxchwd:+(IYY-1)*STEPLN+(IZZ-1)*STEPLY+1+MARK#            MB22  60
BYTINX= 8*MOD(IXX-1,mxchwd:)#          Point to byte in word            MB22  61
intunpak:(QX(WRDINX),IVALUE,BYTINX,8)# Pull out byte                    MB22  62
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MB22  63
#                                                                       MB22  64
#    WRITE FRODO RECORD                                                 MB22  65
#    ------------------                                                 MB22  66
#                                                                       MB22  67
IF(NWORD==LRECL&MBIT==arith:(mxbtwd:,-,mxbtch:))# Op buffer full?       MB22  68
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MB22  69
IREC=IREC+1#                           Incr record counter              MB22  70
writedac:(ioda1:,,IREC,(RECORD(II),II=1,LRECL))# O/p densities          MB22  71
NBIT=0;   NWORD=0#                     Restart buffer counters          MB22  72
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MB22  73
#                                                                       MB22  74
MBIT=MOD(NBIT,mxbtwd:)#                Get bit position modulo word     MB22  75
IF(MBIT==0) NWORD=NWORD+1#             Point to word buffer             MB22  76
IF(SWAP==0) IBIT=arith:(mxbtwd:,-,8)-MBIT# Pointer for no swap          MB22  77
ELSE        IBIT=IW-MBIT+2*MOD(NBIT,IS)# Swap pointer                   MB22  78
ifsel:(VMS,UNXDEC)#                    Dec uses different adress orde   MB22  79
IBIT=IBIT*(-1)+24#                     Reverse bytes for vax            MB22  80
endsel:#                                                                MB22  81
intpak:(IVALUE,RECORD(NWORD),IBIT,8)#  Store fetched value into buf     MB22  82
NBIT=NBIT+8#                           Count total bits in record       MB22  83
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MB22  84
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MB22  85
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MB22  86
IXST=IXEND+IFMT#                       Point to x pt in next brick      MB22  87
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MB22  88
IYST=IYEND+IFMT#                       Point to y of next brick         MB22  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MB22  90
IZST=IZEND+IFMT#                       Point to z of next brick         MB22  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MB22  92
writedac:(ioda1:,,IREC+1,(RECORD(II),II=1,LRECL))# O/p densities        MB22  93
#                                                                       MB22  94
RETURN#                                                                 MB22  95
END#                                                                    MB22  96
pmacro:([no:])#                                                         MB22  97
#                                                                       MB22  98
#                                                                       MB22  99
#                                                                       MB22 100
#                                                                       MB22 101
#                                                                       MB22 102
#                                                                       MB22 103
#                                                                       MB22 104
#                                                                       MB22 105
#                                                                       MB22 106
#                                                                       MB22 107
#                                                                       MB22 108
#                                                                       MB22 109
#                                                                       MB22 110
#                                                                       MB22 111
#                                                                       MB22 112
#                                                                       MB22 113
#                                                                       MB22 114
#                                                                       MB22 115
