systemheader:(MM    )#                                                  MM     1
######################################################################  MM     2
#                                                                    #  MM     3
#                        *** MKMASK ***                              #  MM     4
#                                                                    #  MM     5
#   THE PROGRAM MKMASK, MM, IS USED TO GENERATE A 'MAP' WHICH WILL   #  MM     6
#   SERVE AS A MASK FOR AN ALREADY-CREATED FOURIER MAP.              #  MM     7
#   THIS MASK WILL INDICATE ATOM SITES LOCATED IN THE EXISTING MAP   #  MM     8
#   BASED ON ATOM COORDINATES.  THE PROGRAM MUST BE USED IN          #  MM     9
#   CONJUNCTION WITH APMASK, AM, TO UPDATE THE FOURIER TO BE MASKED  #  MM    10
#                                                                    #  MM    11
######################################################################  MM    12
#                                                                       MM    13
include:(XMACRO)#                                                       MM    14
#####                                                                   MM    15
macro:(mxrec:,128)#                    Scratch file packet size         MM    16
macro:(maxmap:,7000000)#               Maximum mask map size            MM    17
macro:(makereal:,[DO I=1,$2; BUFOT(I)=$1(ISUM(I))])#                    MM    18
#                                                                       MM    19
extrude:(MMCOMN)#                                                       MM    20
INTEGER CENT#                  ## 0/1 centro/noncentro                  MM    21
INTEGER INCX(3)#               ## STEP SIZE IN MAP COORS                MM    22
INTEGER INVERT#                ## flags if map is to be inverted        MM    23
INTEGER IORGX(3)#                                                       MM    24
INTEGER IREL(12)#              ## POINTERS TO ITEMS IN BDF BUFFER       MM    25
INTEGER ISUM(3)#               ## summation order                       MM    26
INTEGER IWNT(12)#              ## ITEMS WANTED FROM BDF                 MM    27
INTEGER JSUM(3)#                                                        MM    28
INTEGER KEY(4)#                ## FLAGS INDICATING HOW TO READ BDF      MM    29
INTEGER LATT#                  ## cell lattice type                     MM    30
INTEGER LAYOUT#                ## YES: IF LAYOUT CARD SUPPLIED          MM    31
INTEGER MAPSIZ#                ## MASK MAP SIZE                         MM    32
INTEGER MARK1#                 ## START OF SYMM OP STORAGE              MM    33
INTEGER MARK2#                 ## START OF ELEC DENS STORAGE            MM    34
INTEGER MARK3#                 ## START OF ATOM SITE OFFSETS            MM    35
INTEGER NG(3)#                 ## GRID FINENESS IN GRID UNITS           MM    36
INTEGER NP(3)#                 ## NUMBER POINTS IN MAP                  MM    37
INTEGER NRANGE#                ## NUMBER RESIDUE RANGES ENTERED         MM    38
INTEGER NROT#                  ## NUMBER ROTATION MATRICES              MM    39
INTEGER PRINT#                 ## YES: IF MAP TO BE PRINTED             MM    40
INTEGER RANGE(10)#             ## RESIDUE RANGES (LOW,HIGH,LOW...)      MM    41
INTEGER READ21#                ## FLAG TO READ MAP LAYOUT FROM          MM    42
INTEGER SUM#                   ## YES IF MAP VALUES TO BE SUMMED        MM    43
INTEGER XDIR#                  ## INDEX FOR X ACTIVITY                  MM    44
INTEGER YDIR#                  ## INDEX FOR Y ACTIVITY                  MM    45
INTEGER ZDIR#                  ## INDEX FOR Z ACTIVITY                  MM    46
COMMON /COMIMM/$#                                                       MM    47
INCX, LAYOUT, MAPSIZ, MARK1, MARK2, MARK3, NG, NP, IORGX, READ21,$#     MM    48
SUM, PRINT, IREL, IWNT, KEY, XDIR, YDIR, ZDIR, ISUM, JSUM, NROT,$#      MM    49
NRANGE,RANGE,INVERT,LATT,CENT#                                          MM    50
#                              ##  REC 21                               MM    51
REAL EXTEND#                   ## ADDITION MAP OUTSIDE UNIT CELL        MM    52
REAL CELL(6)#                  ## CELL DIMENSIONS IN FRACT              MM    53
REAL SITSZA#                   ## RADIUS OF ATOM SITE IN ANG            MM    54
REAL TRANSF(9)#                ## TRANSFORMATION MTRX TO CONVERT        MM    55
#                              ##  FRACT COORDS TO ORTHOG COORDS        MM    56
REAL VOLUME(6)#                ## VOLUME TO BE MASKED                   MM    57
COMMON /COMFMM/$#                                                       MM    58
CELL, EXTEND, SITSZA, TRANSF, VOLUME#                                   MM    59
endext:#                                                                MM    60
#                                                                       MM    61
systemheader:(MM00)#                   Masking map calculation          MM00   1
# ################################################################## #  MM00   2
#                                                                    #  MM00   3
#                               MM00                                 #  MM00   4
#                                                                    #  MM00   5
# ################################################################## #  MM00   6
SUBROUTINE MM00#                       D.r.holland 1987                 MM00   7
#                                                                       MM00   8
include:(AACOMN)#                                                       MM00   9
include:(MMCOMN)#                                                       MM00  10
#                                                                       MM00  11
#  INITIALIZE MAP LAYOUT PARAMETERS                                     MM00  12
#  --------------------------------                                     MM00  13
#                                                                       MM00  14
INVERT = no:#                                                           MM00  15
SUM    = no:#                                                           MM00  16
LAYOUT = no:#                          Default, not read layout card    MM00  17
READ21 = no:#                          Default, don't read rec21        MM00  18
PRINT  = no:#                                                           MM00  19
SITSZA = 2.#                           Default 5 ang atom site          MM00  20
EXTEND=0.#                             Addition to unit cell bounds     MM00  21
NRANGE=0#                              No residue ranges                MM00  22
DO I=1,10; RANGE(I)=0#                 Indicates non-descript range     MM00  23
DO I=1,3#                                                               MM00  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MM00  25
ISUM(I) = I#                           Map parameters in x,y,z order    MM00  26
JSUM(I) = I#                           Layer,down,across order          MM00  27
INCX(I) = 1#                                                            MM00  28
VOLUME(2*I-1)=voidflg:#                                                 MM00  29
VOLUME(2*I)=voidflg:#                                                   MM00  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MM00  31
#                                                                       MM00  32
#   ASSIGN BDF BUFFERERS                                                MM00  33
#   --------------------                                                MM00  34
#                                                                       MM00  35
FILEXT(IOUNIT(3))='MAP'#               Original fourr 'map'             MM00  36
FILEXT(IOUNIT(4))='MSK'#               File to send mask to apmask      MM00  37
IOMARK(1)=QXSTR#                       Set start of input archive       MM00  38
IOMARK(3)=IOMARK(1)+bdfbuf:#           Set start of 'map' buffer        MM00  39
IOMARK(4)=IOMARK(3)+bdfbuf:#           Set start of 'msk' buffer        MM00  40
ISYMM    =IOMARK(4)+bdfbuf:#           Extend to start of symmetry      MM00  41
incrqx:(MARK1,ISYMM,MM0301)#           Expand mem.....0301              MM00  42
#                                                                       MM00  43
CALL MM01#                             Read control cards               MM00  44
CALL MM02#                             Initialize e.d. map with 0's     MM00  45
CALL MM03#                             Read symmetry operators          MM00  46
IF(VOLUME(1)==voidflg:) CALL MM04#     Read atom and place in map       MM00  47
ELSE                    CALL MM06#     Use volume specification         MM00  48
CALL MM05#                             Write out map                    MM00  49
#                                                                       MM00  50
RETURN#                                                                 MM00  51
END#                                                                    MM00  52
systemheader:(MM01)#                   Read controls                    MM01   1
# ####################################################################  MM01   2
#                                                                       MM01   3
#                                MM01                                   MM01   4
#                                                                       MM01   5
# ####################################################################  MM01   6
SUBROUTINE MM01#                                                        MM01   7
include:(AACOMN)#                                                       MM01   8
include:(MMCOMN)#                                                       MM01   9
#                                                                       MM01  10
INTEGER NX(3)#                                                          MM01  11
INTEGER I,J,K#                         Working indices                  MM01  12
#                                                                       MM01  13
chardata:(MM21, END    LAYOUT PARAM  RANGE  VOLUME  )#                  MM01  14
chardata:(MM22,LA DO AC )#                                              MM01  15
chardata:(MM23,* LAYOUT LINE IGNORED - INFORMATION TAKEN FROM REC21)#   MM01  16
chardata:(MM24,READ21 PRINT  SUM    INVERT )#                           MM01  17
chardata:(MM25,options:  )#                                             MM01  18
chardata:(MM2A,   READ21       XXX  )#                                  MM01  19
chardata:(MM2B,   INVERT MAP   XXX  )#                                  MM01  20
chardata:(MM26,   PRINT MAP    XXX  )#                                  MM01  21
chardata:(MM27,   SUM GRID     XXX  )#                                  MM01  22
chardata:(MM28, NO YES  )#                                              MM01  23
chardata:(MM29,[ATOM SITE RADIUS = XXX.XX ANGSTROMS]  )#                MM01  24
chardata:(MM30,[EXTENSION OF MAP = XXX.XX ANGSTROMS]  )#                MM01  25
chardata:(MM31,[ATOM RANGE  ALL                                    ])#  MM01  26
chardata:(MM32,[VOLUME TO BE MASKED                       $#            MM01  27
                             ])#                                        MM01  28
chardata:(MM33,[MASK WILL BE CREATED FROM MODEL])#                      MM01  29
chardata:(MM34,[MASK WILL BE CREATED FROM SPECIFIED VOLUME])#           MM01  30
realdata:(FMT1,[180631.,220431.,280631.,320431.,380631.,420431.,$#      MM01  31
480631.,520431.,580631.,620431.])#                                      MM01  32
realdata:(FMT2,[280622.,360622.,440622.,520622.,600622.,680622])#       MM01  33
datastuff:#                                                             MM01  34
#                                                                       MM01  35
#   ENTER CONTROL LINES                                                 MM01  36
#   -------------------                                                 MM01  37
#                                                                       MM01  38
FOR(I=1;I<10;I=I+1)#                   Loop over input fields           MM01  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MM01  40
ifvo:(BUFIN(I)) BREAK#                 Exit after last field            MM01  41
stringlim:(I,J,K)#                     Find limits of the field         MM01  42
compchar:(CHRIN,J,MM24,1,3,7,NMM24,K)# Find what's there                MM01  43
IF(K==0) iquit:(MM0101,I)#             Dud flag.......50101             MM01  44
ELSE IF(K==1)  READ21=yes:#            Map layout from rec21            MM01  45
ELSE IF(K==2)  PRINT =yes:#            Print mask map                   MM01  46
ELSE IF(K==3)  SUM   =yes:#            Print mask map                   MM01  47
ELSE IF(K==4)  INVERT=yes:#            Print mask map                   MM01  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MM01  49
REPEAT#                                Loop over control lines          MM01  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MM01  51
readline:(MM21,NMM21)#                 Process control line             MM01  52
#                                                                       MM01  53
IF(LINID==1) BREAK#                    ****** end   *******             MM01  54
#                                                                       MM01  55
#         ****** LAYOUT ********                                        MM01  56
#                                                                       MM01  57
ELSE IF(LINID==2)#                     Process layout line              MM01  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MM01  59
IF (READ21 == yes:)#                                                    MM01  60
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MM01  61
writeline:(0,MM23,NMM23,3,3)#          Report layout to be ignored      MM01  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MM01  63
ELSE#                                                                   MM01  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MM01  65
LAYOUT = yes:#                         Indicate layout card read        MM01  66
DO I=1,3#                              Loop over a,b,c directions       MM01  67
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MM01  68
IF(BUFIN(I)<voidflg:)#                 Test for direction string        MM01  69
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MM01  70
stringlim:(I,N,M)#                     Get string limits                MM01  71
compchar:(CHRIN,N,MM22,1,2,3,NMM22,M)# Search for string match          MM01  72
IF(M==0) iquit:(MM0102,I)#             No match........082002           MM01  73
JSUM(M)=I#                             Store layout order               MM01  74
ISUM(I)=M#                             Store layout order               MM01  75
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MM01  76
IF(BUFIN(I+3)>.5) NX(I)=NINT(BUFIN(I+3))# Store    grid value           MM01  77
IF(BUFIN(I+6)>(-.1)) INCX(I)=NINT(BUFIN(I+6))# Extract grid incr.       MM01  78
NX(I) = NX(I) / INCX(I)#               Number of map points             MM01  79
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MM01  80
DO I=1,3; NG(I)=NX(JSUM(I))#                                            MM01  81
MAPSIZ = NG(1)*NG(2)*NG(3)#            Storage needed for grid          MM01  82
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MM01  83
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MM01  84
#                                                                       MM01  85
#         ****** PARAM  ********                                        MM01  86
#                                                                       MM01  87
ELSE IF(LINID==3)#                                                      MM01  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MM01  89
ifnv:(BUFIN(1)) SITSZA=BUFIN(1)#       Store site size                  MM01  90
ifnv:(BUFIN(2)) EXTEND=BUFIN(2)#       Store extensions of cell bound   MM01  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MM01  92
#                                                                       MM01  93
#         ****** RANGE  ********                                        MM01  94
#                                                                       MM01  95
ELSE IF(LINID==4)#                                                      MM01  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MM01  97
DO I=1,10; ifnv:(BUFIN(I)) RANGE(I)=BUFIN(I)# Store ranges              MM01  98
DO I=1,5#                                                               MM01  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MM01 100
IF( RANGE(I*2-1)>RANGE(I*2)) iquit:(MM2003)# Are ranges reasonable?     MM01 101
ifnv:(RANGE(I*2-1))#                                                    MM01 102
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MM01 103
NRANGE=NRANGE+1#                       Number of ranges requested       MM01 104
ncodefld:(RANGE(I*2-1),1,MM31,FMT1(2*I-1),2)#                           MM01 105
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MM01 106
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MM01 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MM01 108
#                                                                       MM01 109
#         ****** VOLUME ********                                        MM01 110
#                                                                       MM01 111
ELSE IF(LINID==5)#                                                      MM01 112
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MM01 113
DO I=1,6#                                                               MM01 114
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MM01 115
ifvo:(BUFIN(I)) iquit:(MM2004)#        Store volume specification       MM01 116
VOLUME(I)=BUFIN(I)#                                                     MM01 117
ncodefld:(VOLUME(I),1,MM32,FMT2(I),1)#                                  MM01 118
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MM01 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MM01 120
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MM01 121
writeline:(2,MM25,NMM25,3,3)#          Report options                   MM01 122
IF (READ21==no:) IWHICH=1#                                              MM01 123
ELSE IWHICH=5#                                                          MM01 124
movechar:(MM28,IWHICH,MM2A,17,3,0)#                                     MM01 125
writeline:(1,MM2A,NMM2A,3,3)#                                           MM01 126
IF (INVERT==no:) IWHICH=1#                                              MM01 127
ELSE IWHICH=5#                                                          MM01 128
movechar:(MM28,IWHICH,MM2B,17,3,0)#                                     MM01 129
writeline:(1,MM2B,NMM2B,3,3)#                                           MM01 130
IF (PRINT==no:) IWHICH=1#                                               MM01 131
ELSE IWHICH=5#                                                          MM01 132
movechar:(MM28,IWHICH,MM26,17,3,0)#                                     MM01 133
writeline:(1,MM26,NMM26,3,3)#                                           MM01 134
IF (SUM==no:) IWHICH=1#                                                 MM01 135
ELSE IWHICH=5#                                                          MM01 136
movechar:(MM28,IWHICH,MM27,17,3,0)#                                     MM01 137
writeline:(1,MM27,NMM27,3,3)#                                           MM01 138
ifvo:(VOLUME(1))#                      Report about model mask          MM01 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MM01 140
ncodefld:(SITSZA,1,MM29,250622.,1)#                                     MM01 141
writeline:(1,MM33,NMM33,3,3)#                                           MM01 142
writeline:(1,MM31,NMM31,3,3)#                                           MM01 143
writeline:(1,MM29,NMM29,3,3)#                                           MM01 144
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MM01 145
ELSE#                                  Report about volume mask         MM01 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MM01 147
writeline:(0,MM34,NMM34,3,3)#                                           MM01 148
writeline:(0,MM32,NMM32,3,3)#                                           MM01 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MM01 150
ncodefld:(EXTEND,1,MM30,250622.,1)#                                     MM01 151
writeline:(0,MM30,NMM30,3,3)#                                           MM01 152
#                                                                       MM01 153
RETURN#                                                                 MM01 154
END#                                                                    MM01 155
systemheader:(MM02)#                   Read bdf rec 21 information      MM02   1
########################################################                MM02   2
#                                                                       MM02   3
#                      MM02                                             MM02   4
#                                                                       MM02   5
########################################################                MM02   6
SUBROUTINE MM02#                                                        MM02   7
#                                                                       MM02   8
#----------------------------------------------------------             MM02   9
#                                                                       MM02  10
#  NOTE: NG, IORGX, INCX , JSUM ARE IN LAYER, DOWN, ACROSS ORDER        MM02  11
#                                                                       MM02  12
#----------------------------------------------------------             MM02  13
include:(AACOMN)#                                                       MM02  14
include:(MMCOMN)#                                                       MM02  15
#                                                                       MM02  16
chardata:(XYZ,[XYZ])#                                                   MM02  17
chardata:(MM00A,[CELL DIMENSIONS ])#                                    MM02  18
chardata:(MM00B,[  A     : XXXXXXXXX   B    : XXXXXXXXXX$#              MM02  19
   C     : XXXXXXXXXX ])#                                               MM02  20
chardata:(MM00C,[  ALPHA : XXXXXXXXX   BETA : XXXXXXXXXX$#              MM02  21
   GAMMA : XXXXXXXXXX ])#                                               MM02  22
chardata:(MM00E,[REC 21 INFORMATION])#                                  MM02  23
chardata:(MM00F,[MAP PARAMTERS used:])#                                 MM02  24
chardata:(MM0E1,[  ORIGIN])#                                            MM02  25
chardata:(MM0E2,[  X :    X    Y :    X    Z :    X ])#                 MM02  26
chardata:(MM0E3,[  INCREMENT])#                                         MM02  27
chardata:(MM0E4,[  GRID FINENESS])#                                     MM02  28
chardata:(MM0E5,[  NUMBER OF POINTS SUMMED])#                           MM02  29
chardata:(MM0E6,[  MAP LAYOUT])#                                        MM02  30
chardata:(MM0E7,[    across:    down:    page:   ])#                    MM02  31
chardata:(MM0E8,[  SUMMATION ORDER])#                                   MM02  32
chardata:(MM100,[ * MAP DESCRIPTION SUPPLIED BY REC21 ON BDF])#         MM02  33
chardata:(MM101,[ * MAP DESCRIPTION SUPPLIED BY LAYOUT CARD])#          MM02  34
chardata:(MM102,[ * MAP DESCRIPTION SUPPLIED BY DEFAULT VALUES])#       MM02  35
chardata:(MM0E9,[    slow:      med:     fast:   ])#                    MM02  36
realdata:(FMTCLL,[191052.,391052.,601052.])# Format to ncodefld above   MM02  37
realdata:(FMTCL2,[191051.,391051.,601051.])# Format to ncodefld above   MM02  38
realdata:(FMTR21,[100513.,220513.,340513.])# Format for rec21 data      MM02  39
#                                                                       MM02  40
chardata:(MM00D,[     x: XXXXX      y:  XXXXX        z: XXXXX ])#       MM02  41
realdata:(FMTBRK,[130513.,280513.,440513.])# Format to ncodefld above   MM02  42
datastuff:#                                                             MM02  43
#                                                                       MM02  44
#  READ CELL DIMENSIONS                                                 MM02  45
#  --------------------                                                 MM02  46
#                                                                       MM02  47
copyfile:(3,4,1,decr:(lrcell:))#       Start the 'msk' file for apmas   MM02  48
#                                                                       MM02  49
FOR(K=1;;K=K+1)#                                                        MM02  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MM02  51
readwpkt:(3,lrcell:,PSIZ,IP,0)#        Read in cell record              MM02  52
IF(IP<=0) BREAK#                       Exit on last record              MM02  53
writepkt:(4,lrcell:,PSIZ,JP)#          Move data to 'msk' file          MM02  54
movereal:(QX,IP+1,QX,JP+1,PSIZ,0)#                                      MM02  55
IF(K==1)#                              Packet 1 holds cell dimensions   MM02  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MM02  57
movereal:(QX,IP+1,CELL,1,3,0)#         Save real cell constants         MM02  58
movereal:(QX,IP+7,CELL,4,3,0)#         Save real cell constants         MM02  59
CELL(4) = CELL(4) * 360.#              Cycles to degrees                MM02  60
CELL(5) = CELL(5) * 360.#              Cycles to degrees                MM02  61
CELL(6) = CELL(6) * 360.#              Cycles to degrees                MM02  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MM02  63
ELSE IF(K==4)#                                                          MM02  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MM02  65
movereal:(QX,IP+1,TRANSF,1,9,0)#       Save transformation mtrx         MM02  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MM02  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MM02  68
#                                                                       MM02  69
#  WRITE CELL DIMENSIONS                                                MM02  70
#  ----------------------                                               MM02  71
#                                                                       MM02  72
IF(K==0) iquit:(MM0201)#               No cell records on input         MM02  73
writeline:(1,MM00A,NMM00A,3,3)#        Write out cell dimensions        MM02  74
ncodefld:(CELL,1,MM00B,FMTCLL,3)#                                       MM02  75
writeline:(0,MM00B,NMM00B,3,3)#                                         MM02  76
ncodefld:(CELL,4,MM00C,FMTCL2,3)#                                       MM02  77
writeline:(0,MM00C,NMM00C,3,3)#                                         MM02  78
#                                                                       MM02  79
#   ARE VOLUME SPECIFICATIONS ALLOWABLE GIVEN CELL DIMENSIONS?          MM02  80
#   -----------------------------------------------------------         MM02  81
DO I=1,3; IF(VOLUME(2*I)>CELL(I)) iquit:(-MM0202)#                      MM02  82
#                                                                       MM02  83
#   READ REC 21 INFO                                                    MM02  84
#   ----------------                                                    MM02  85
#                                                                       MM02  86
IF (READ21 == yes:) CALL MM21#         Initialize contour/border        MM02  87
#                                                                       MM02  88
IF (NG(1)==voidflg:)#                  Default grid size                MM02  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MM02  90
NG(1) = NINT(CELL(1)*4+1)#                                              MM02  91
NG(2) = NINT(CELL(2)*4+1)#                                              MM02  92
NG(3) = NINT(CELL(3)*4+1)#                                              MM02  93
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MM02  94
#                                                                       MM02  95
#  WRITE REC21 DATA                                                     MM02  96
#  ----------------                                                     MM02  97
#                                                                       MM02  98
IF (READ21==yes:) writeline:(2,MM100,NMM100,3,3)#                       MM02  99
IF (LAYOUT==yes:) writeline:(2,MM101,NMM101,3,3)#                       MM02 100
IF (LAYOUT==no:&READ21==no:) writeline:(2,MM102,NMM102,3,3)#            MM02 101
writeline:(2,MM00F,NMM00F,3,3)#                                         MM02 102
writeline:(1,MM0E6,NMM0E6,3,3)#        Write out summation order in     MM02 103
movechar:(XYZ,JSUM(3),MM0E7,13,1,0)#                                    MM02 104
movechar:(XYZ,JSUM(2),MM0E7,22,1,0)#                                    MM02 105
movechar:(XYZ,JSUM(1),MM0E7,31,1,0)#                                    MM02 106
writeline:(0,MM0E7,NMM0E7,3,3)#                                         MM02 107
writeline:(0,MM0E3,NMM0E3,3,3)#        Write out increment              MM02 108
makereal:(INCX,3)#                     Real-ize integer array           MM02 109
ncodefld:(BUFOT,1,MM0E2,FMTR21,3)#                                      MM02 110
writeline:(0,MM0E2,NMM0E2,3,3)#                                         MM02 111
writeline:(0,MM0E4,NMM0E4,3,3)#        Write out grid fineness          MM02 112
makereal:(NG,3)#                       Real-ize integer array           MM02 113
ncodefld:(BUFOT,1,MM0E2,FMTR21,3)#                                      MM02 114
writeline:(0,MM0E2,NMM0E2,3,3)#                                         MM02 115
IF (READ21==yes:)#                                                      MM02 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MM02 117
writeline:(2,MM00E,NMM00E,3,3)#                                         MM02 118
writeline:(0,MM0E8,NMM0E8,3,3)#        Write out summation order in     MM02 119
movechar:(XYZ,JSUM(1),MM0E9,13,1,0)#                                    MM02 120
movechar:(XYZ,JSUM(2),MM0E9,22,1,0)#                                    MM02 121
movechar:(XYZ,JSUM(3),MM0E9,31,1,0)#                                    MM02 122
writeline:(0,MM0E9,NMM0E9,3,3)#                                         MM02 123
writeline:(0,MM0E1,NMM0E1,3,3)#        Write out origin                 MM02 124
makereal:(IORGX,3)#                    Real-ize integer array           MM02 125
ncodefld:(BUFOT,1,MM0E2,FMTR21,3)#                                      MM02 126
writeline:(0,MM0E2,NMM0E2,3,3)#                                         MM02 127
writeline:(0,MM0E5,NMM0E5,3,3)#        Write out no. points summed      MM02 128
makereal:(NP,3)#                       Real-ize integer array           MM02 129
ncodefld:(BUFOT,1,MM0E2,FMTR21,3)#                                      MM02 130
writeline:(0,MM0E2,NMM0E2,3,3)#                                         MM02 131
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MM02 132
#                                                                       MM02 133
RETURN#                                                                 MM02 134
END#                                                                    MM02 135
systemheader:(MM03)#                   Read bdf lrsymm: record          MM03   1
# ####################################################################  MM03   2
#                                                                       MM03   3
#                                MM03                                   MM03   4
#                                                                       MM03   5
# ####################################################################  MM03   6
SUBROUTINE MM03#                                                        MM03   7
include:(AACOMN)#                                                       MM03   8
include:(MMCOMN)#                                                       MM03   9
#                                                                       MM03  10
#                                                                       MM03  11
#   EXTRACT SYMMETRY CODES & MATRICES (LRSYMM:)                         MM03  12
#   ---------------------------------------                             MM03  13
#                                                                       MM03  14
copyfile:(3,4,incr:(lrcell:),decr:(lrsymm:))# Advance formation of 'm   MM03  15
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Read first packet of lrsymm:     MM03  16
writepkt:(4,lrsymm:,LPAK,JP)#          Move data to 'msk' file          MM03  17
movereal:(QX,IP+1,QX,JP+1,LPAK,0)#                                      MM03  18
LATT=NINT(QX(IP+1))#                   Lattice type                     MM03  19
CENT=NINT(QX(IP+2))#                   Centric=0 / acentric=1           MM03  20
NROT=NINT(QX(IP+4))#                   Get nummer rotation matrices     MM03  21
FMUL=QX(IP+6)#                         Get reflection multiplicity      MM03  22
incrqx:(MARK2,MARK1+NROT*LPAK,MM0302)# Expand qx......0302              MM03  23
J=MARK1#                               Start of symm storage            MM03  24
REPEAT#                                Loop over symm ooperators        MM03  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MM03  26
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Get packet pointer               MM03  27
IF(IP<=0) BREAK#                       Exit after last packet           MM03  28
writepkt:(4,lrsymm:,LPAK,JP)#          Move data to 'msk' file          MM03  29
movereal:(QX,IP+1,QX,JP+1,LPAK,0)#                                      MM03  30
movereal:(QX,IP+1,QX,J+1,LPAK,1)#      Save the symop for later         MM03  31
J=J+LPAK#                              Update symm storage pointer      MM03  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MM03  33
#                                                                       MM03  34
RETURN#                                                                 MM03  35
END#                                                                    MM03  36
systemheader:(MM04)#                   Get atom parameters from lra     MM04   1
# ####################################################################  MM04   2
#                                                                       MM04   3
#                               MM04                                    MM04   4
#                                                                       MM04   5
# ####################################################################  MM04   6
SUBROUTINE MM04#                                                        MM04   7
include:(AACOMN)#                                                       MM04   8
include:(MMCOMN)#                                                       MM04   9
#                                                                       MM04  10
INTEGER I,J#                           Working indices                  MM04  11
REAL AXYZ(3)#                                                           MM04  12
REAL LOCMAP(3)#                        Grid location of site            MM04  13
REAL GTOA(3)#                          Grid to angstroms conversion     MM04  14
INTEGER CURDIR#                        Xyz index for current directio   MM04  15
INTEGER CURDWN#                        Current index for down dir       MM04  16
INTEGER CURPAG#                        Current index for page dir       MM04  17
INTEGER MAPSIT(3)#                     Temp grid coordinates            MM04  18
INTEGER SITSZG(3)#                     Site size in grid units          MM04  19
INTEGER GRDXYZ(3)#                     Atom grid loc, xyz order         MM04  20
INTEGER EDGE1(3)#                      Low edge of map (grid units)     MM04  21
#                                        Generate atom site in grid     MM04  22
INTEGER EDGE2(3)#                      Upper edge of map (grid units)   MM04  23
INTEGER NOFFST#                        Number offsets                   MM04  24
REAL X,Y,Z#                            Coordinate storage               MM04  25
#                                                                       MM04  26
intdata:(LATPT,[1,2,4,7,11,13,15,17])#                                  MM04  27
intdata:(LATRN,[0,0,12,0,15,18,0,3,6,9,0,3,0,6,0,9])#                   MM04  28
realdata:(TRNS,[0.,0.,0.,0.,.5,.5,.5,.0,.5,.5,.5,.0,.5,.5,.5,$#         MM04  29
.33333333,.66666667,.66666667,.66666667,.33333333,.33333333])#          MM04  30
chardata:(TYPLAT,[PIRFABCPIRFABC])#                                     MM04  31
chardata:(XYZ,[XYZ])#                                                   MM04  32
chardata:(MM041,[ XXXX ATOMS READ FROM LRATOM RECORD])#                 MM04  33
chardata:(MM042,[ XXXX ATOMS SITES GENERATED IN MAP])#                  MM04  34
chardata:(MM043,[ XXXX SYMMETRY OPERATORS])#                            MM04  35
chardata:(MM044,[ 1 ANGSTROM  = XXX.XXX GRID POINTS])#                  MM04  36
chardata:(MM045,[ CELL LATTICE TYPE =  ])#                              MM04  37
datastuff:#                                                             MM04  38
#                                                                       MM04  39
#--------------------------------------------------------------------   MM04  40
##### LAYOUT OF ATOM PARAMETER STORAGE                                  MM04  41
# RELATIVE ADDRESS                                                      MM04  42
# IN QX ARRAY                                                           MM04  43
#      1                X                                               MM04  44
#      2                Y                                               MM04  45
#      3                Z                                               MM04  46
#      4                ATOM NAME                                       MM04  47
#---------------------------------------------------------------------- MM04  48
XDIR = ISUM(1)#                        Z index to map parameters        MM04  49
YDIR = ISUM(2)#                        Z index to map parameters        MM04  50
ZDIR = ISUM(3)#                        Z index to map parameters        MM04  51
#                                                                       MM04  52
#  DETERMINE ANGSTROM TO GRID CONVERSION                                MM04  53
#  -------------------------------------                                MM04  54
#                                                                       MM04  55
IL=1#                                                                   MM04  56
DO I=1,3#                                                               MM04  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MM04  58
GTOA(I) = NG(ISUM(I)) / CELL(I)#                                        MM04  59
IF (I>1) IL=0#                                                          MM04  60
ncodefld:(GTOA,I,MM044,210732.,1)#                                      MM04  61
movechar:(XYZ,I,MM044,1,1,0)#                                           MM04  62
writeline:(IL,MM044,NMM044,3,3)#       Print equivalent sites           MM04  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MM04  64
DO I=1,3#                              Map bounds in fract coors        MM04  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MM04  66
CURDIR = JSUM(I)#                      Current map direction            MM04  67
SITSZG(I) = NINT(SITSZA * GTOA(CURDIR))#                                MM04  68
#  NOTE: EDGE* IS IN LAYER, DOWN, ACROSS DIRECTION                      MM04  69
EDGE1(I) = NINT(1.-(EXTEND*GTOA(CURDIR)))#                              MM04  70
EDGE2(I) = NG(I)+NINT(EXTEND*GTOA(CURDIR))#                             MM04  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MM04  72
#                                                                       MM04  73
#  SET UP STORAGE FOR MASK GRID                                         MM04  74
#  ----------------------------                                         MM04  75
#                                                                       MM04  76
MAPSTO = FLOAT(NG(1)*NG(2)*NG(3))/mxchwd:+10# Storage needed for grid   MM04  77
incrqx:(MARK3,MARK2+MAPSTO,MM0401)#    Expand qx......2101              MM04  78
DO I=1,MAPSTO; QX(MARK2+I) = 0.#                                        MM04  79
#                                                                       MM04  80
#  SET UP OFFSET TABLE USED TO GENERATE ATOM SITE IN MAP                MM04  81
#  -----------------------------------------------------                MM04  82
#                                                                       MM04  83
MAXSIT = 3*(SITSZG(1)*2 * SITSZG(2)*2 * SITSZG(3)*2)# Max atom site s   MM04  84
incrqx:(MARK4,MARK3+MAXSIT,MM0403)#    Expand qx......0402              MM04  85
NOFFST=0#                                                               MM04  86
DO IZ = -SITSZG(1),SITSZG(1)#                                           MM04  87
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MM04  88
Z=(IZ/GTOA(3))/CELL(3)#                Grid to fractional coords        MM04  89
DO IY = -SITSZG(2),SITSZG(2)#                                           MM04  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MM04  91
Y=(IY/GTOA(2))/CELL(2)#                Grid to fractional coords        MM04  92
DO IX = -SITSZG(3),SITSZG(3)#                                           MM04  93
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MM04  94
X=(IX/GTOA(1))/CELL(1)#                Grid to fractional coords        MM04  95
DIST = SQRT((IZ/GTOA(3))**2 + (IY/GTOA(2))**2 + (IX/GTOA(1))**2)#       MM04  96
IF (DIST <= SITSZA)#                                                    MM04  97
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MM04  98
#  NON-ORTHOG TO ORTHOG COORDINATES                                     MM04  99
IXX = NINT(X*TRANSF(1) + Y*TRANSF(4) + Z*TRANSF(7))*GTOA(1)#            MM04 100
IYY = NINT(X*TRANSF(2) + Y*TRANSF(5) + Z*TRANSF(8))*GTOA(2)#            MM04 101
IZZ = NINT(X*TRANSF(3) + Y*TRANSF(6) + Z*TRANSF(9))*GTOA(3)#            MM04 102
NOFFST = NOFFST+1#                                                      MM04 103
QX(MARK3+NOFFST*3-2) = FLOAT(IXX)#     Offset in x direction            MM04 104
QX(MARK3+NOFFST*3-1) = FLOAT(IYY)#     Offset in y direction            MM04 105
QX(MARK3+NOFFST*3-0) = FLOAT(IZZ)#     Offset in z direction            MM04 106
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MM04 107
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MM04 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MM04 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MM04 110
#                                                                       MM04 111
#   LOCATE REQUIRED PARAMETERS IN LR LRATOM:                            MM04 112
#   ----------------------------------                                  MM04 113
#                                                                       MM04 114
DO I=1,3; IWNT(I)=I#                   Set x,y,z                        MM04 115
IWNT(4)=14#                            Set atom name                    MM04 116
KEY(1)=4;  KEY(2)=4;  KEY(3)=0#        Set search delimiters            MM04 117
KEY(4)=0#                              Copy mode for indexpkt:          MM04 118
indexpkt:(1,lratom:,LPAK,IP,0,KEY,IWNT,IREL)# Get relative pointers     MM04 119
IF(KEY(4)<0) iquit:(MM0404)#           Data missing.....50401           MM04 120
#                                                                       MM04 121
#   EXTRACT ATOM PARAMETERS FROM LR LRATOM:                             MM04 122
#   ---------------------------------                                   MM04 123
#                                                                       MM04 124
copyfile:(3,4,incr:(lrsymm:),decr:(lratom:))# Advance 'msk' file        MM04 125
NATM=0#                                Zero count of selected atoms     MM04 126
NATMAP = 0#                                                             MM04 127
ACENT1=1.;    ACENT2=1.#                                                MM04 128
IF(CENT==0) ACENT1=-1.#                Get centro atoms                 MM04 129
LAT1= LATPT(LATT)#                     Start of lattice operators       MM04 130
LAT2=LATPT(LATT+1)-1#                  End of lattice operators         MM04 131
REPEAT#                                Loop over lratom packets         MM04 132
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MM04 133
readwpkt:(1,lratom:,LPAK,IP,0)#        Get packet pointer               MM04 134
IF(IP<=0) BREAK#                       Exit after last packet           MM04 135
writepkt:(4,lratom:,LPAK,JP)#          Move data to 'msk' file          MM04 136
movereal:(QX,IP+1,QX,JP+1,LPAK,0)#     Save the atom info               MM04 137
#                                                                       MM04 138
I=IP+IREL(1); X=QX(I)#                 Store x coordinate               MM04 139
I=IP+IREL(2); Y=QX(I)#                 Store y coordinate               MM04 140
I=IP+IREL(3); Z=QX(I)#                 Store z coordinate               MM04 141
NATM = NATM + 1#                       Number of atoms input            MM04 142
#                                                                       MM04 143
#                                                                       MM04 144
#   GENERATE EQUIVALENT POSITIONS IN FRACT COORS                        MM04 145
#   --------------------------------------------                        MM04 146
#                                                                       MM04 147
FOR(N=MARK1;N<MARK2;N=N+12)#           Loop over rot matrices           MM04 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MM04 149
DO I=1,3#                              Rowxcolumn marix multiply        MM04 150
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MM04 151
J=N+I#                                                                  MM04 152
AXYZ(I) =X*QX(J)+Y*QX(J+3)+Z*QX(J+6)+QX(J+9)# Matrix multiply           MM04 153
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MM04 154
#                                                                       MM04 155
#  SHIFT POINT INTO UNIT CELL                                           MM04 156
#  --------------------------                                           MM04 157
#                                                                       MM04 158
FOR(AC=ACENT1;AC<=ACENT2;AC=AC+2.)#    Loop over centro symmetry        MM04 159
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MM04 160
DO LAT3=LAT1,LAT2#                     Loop over lattice ops            MM04 161
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MM04 162
M=LATRN(LAT3)#                         Get translation pointer          MM04 163
DO I=1,3; LOCMAP(I)=AXYZ(I)*AC+TRNS(M+I)# Add translations              MM04 164
DO I=1,3#                              Loop over axes                   MM04 165
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MM04 166
REPEAT#                                                                 MM04 167
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MM04 168
IF(LOCMAP(I)<0.0)      LOCMAP(I)=LOCMAP(I)+1.0#                         MM04 169
ELSE IF(LOCMAP(I)>1.0) LOCMAP(I)=LOCMAP(I)-1.0#                         MM04 170
ELSE                   BREAK#                                           MM04 171
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MM04 172
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MM04 173
#                                                                       MM04 174
#   MASK CURRENT ATOM SITE IN MAP                                       MM04 175
#   -----------------------------                                       MM04 176
#                                                                       MM04 177
NATMAP = NATMAP + 1#                                                    MM04 178
GRDXYZ(1)= NINT(LOCMAP(1)*(NG(XDIR)-1)+1)# X coor in grid units         MM04 179
GRDXYZ(2)= NINT(LOCMAP(2)*(NG(YDIR)-1)+1)# Y coor in grid units         MM04 180
GRDXYZ(3)= NINT(LOCMAP(3)*(NG(ZDIR)-1)+1)# Z coor in grid units         MM04 181
CURACR = GRDXYZ(JSUM(3))#              Across coor in grid units        MM04 182
CURDWN = GRDXYZ(JSUM(2))#              Down coor in grid units          MM04 183
CURPAG = GRDXYZ(JSUM(1))#              Page coor in grid units          MM04 184
#  DETERMINE POINTS IN ATOM SITE RELATIVE TO EXACT ATOM XYZ             MM04 185
#  NOTE: MAPSIT STORED IN ACROSS, DOWN, LAYER ORDER                     MM04 186
DO IOFF=1,NOFFST#                      Generate atom site               MM04 187
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MM04 188
MAPSIT(3)=CURPAG+INT(QX(MARK3+IOFF*3-0))# Pg grid pt of atom site       MM04 189
IF(MAPSIT(3)<EDGE1(1)) NEXT#           Atom site point outside extens   MM04 190
ELSE IF(MAPSIT(3)>EDGE2(1)) NEXT#                                       MM04 191
ELSE IF(MAPSIT(3)>=EDGE1(1)&MAPSIT(3)<1)# Atom site point in exten      MM04 192
MAPSIT(3)=MAPSIT(3)+NG(1)#                                              MM04 193
ELSE IF(MAPSIT(3)<=EDGE2(1) & MAPSIT(3)>NG(1))# Atom site point in e    MM04 194
MAPSIT(3)=MAPSIT(3)-NG(1)#                                              MM04 195
#                                                                       MM04 196
MAPSIT(2)=CURDWN+INT(QX(MARK3+IOFF*3-1))# Row grid pt of atom site      MM04 197
IF(MAPSIT(2)<EDGE1(2)) NEXT#           Atom site point outside extens   MM04 198
ELSE IF(MAPSIT(2)>EDGE2(2)) NEXT#                                       MM04 199
ELSE IF(MAPSIT(2)>=EDGE1(2)&MAPSIT(2)<1)# Atom site point in exten      MM04 200
MAPSIT(2)=MAPSIT(2)+NG(2)#                                              MM04 201
ELSE IF(MAPSIT(2)<=EDGE2(2)&MAPSIT(2)>NG(2))# Atom site point in e      MM04 202
MAPSIT(2)=MAPSIT(2)-NG(2)#                                              MM04 203
#                                                                       MM04 204
MAPSIT(1)=CURACR+INT(QX(MARK3+IOFF*3-2))# Col grid pt of atom site      MM04 205
IF(MAPSIT(1)<EDGE1(3)) NEXT#           Atom site point outside extens   MM04 206
ELSE IF(MAPSIT(1)>EDGE2(3)) NEXT#                                       MM04 207
ELSE IF(MAPSIT(1)>=EDGE1(3)&MAPSIT(1)<1)# Atom site point in exten      MM04 208
MAPSIT(1)=MAPSIT(1)+NG(3)#                                              MM04 209
ELSE IF(MAPSIT(1)<=EDGE2(3)&MAPSIT(1)>NG(3))# Atom site point in e      MM04 210
MAPSIT(1)=MAPSIT(1)-NG(3)#                                              MM04 211
#                                                                       MM04 212
ILOC = MAPSIT(1)+((MAPSIT(2)-1)*NG(3))+((MAPSIT(3)-1)*NG(2)*NG(3))#     MM04 213
IBIT = MOD(ILOC-1,mxchwd:)*mxbtch:#    Bit position in packed map       MM04 214
IWRD = ((ILOC-1)/mxchwd:)+1#           Word of packed map               MM04 215
#                                                                       MM04 216
#  UPDATE MASK MAP LOCATION TO REFLECT MAP SITE                         MM04 217
#  --------------------------------------------                         MM04 218
#                                                                       MM04 219
IF(SUM==yes:)#                                                          MM04 220
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MM04 221
intunpak:(QX(MARK2+IWRD),ITEST,IBIT,mxbtch:)# Get current map value     MM04 222
IF(ITEST<126) ITEST = ITEST+1#                                          MM04 223
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MM04 224
ELSE  ITEST=1#                                                          MM04 225
intpak:(ITEST,QX(MARK2+IWRD),IBIT,mxbtch:)# Update mask map             MM04 226
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MM04 227
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MM04 228
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MM04 229
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MM04 230
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MM04 231
movechar:(TYPLAT,LATT,MM045,22,1,1)#   Cell lattice type                MM04 232
writeline:(1,MM045,NMM045,3,3)#        Print lattice type               MM04 233
ncodefld:(FLOAT(NROT),1,MM043,50413.,1)# Number symm operators          MM04 234
writeline:(2,MM043,NMM043,3,3)#        Print equivalent sites           MM04 235
ncodefld:(FLOAT(NATM),1,MM041,60513.,1)# Format stored items            MM04 236
writeline:(0,MM041,NMM041,3,3)#        Print equivalent sites           MM04 237
ncodefld:(FLOAT(NATMAP),1,MM042,60513.,1)# Format stored items          MM04 238
writeline:(0,MM042,NMM042,3,3)#        Print equivalent sites           MM04 239
#                                                                       MM04 240
copybdf:(3,4,incr:(lratom:),21)#       Copy the recors up to the map    MM04 241
RETURN#                                                                 MM04 242
END#                                                                    MM04 243
systemheader:(MM06)#                   Create mask from volume          MM06   1
# ####################################################################  MM06   2
#                                                                       MM06   3
#                               MM06                                    MM06   4
#                                                                       MM06   5
# ####################################################################  MM06   6
SUBROUTINE MM06#                                                        MM06   7
include:(AACOMN)#                                                       MM06   8
include:(MMCOMN)#                                                       MM06   9
#                                                                       MM06  10
INTEGER I,J#                           Working indices                  MM06  11
INTEGER LOCMAP(3)#                     Grid location of site            MM06  12
REAL GTOA(3)#                          Grid to angstroms conversion     MM06  13
INTEGER CURDIR#                        Xyz index for current directio   MM06  14
INTEGER CURDWN#                        Current index for down dir       MM06  15
INTEGER CURPAG#                        Current index for page dir       MM06  16
INTEGER MAPSIT(3)#                     Temp grid coordinates            MM06  17
INTEGER EDGE1(3)#                      Low edge of map (grid units)     MM06  18
#                                        Generate atom site in grid     MM06  19
INTEGER EDGE2(3)#                      Upper edge of map (grid units)   MM06  20
#                                                                       MM06  21
realdata:(FMT,[340742.,400622.,480842.])#                               MM06  22
chardata:(XYZ,[XYZ])#                                                   MM06  23
chardata:(MM061,[ XXXX SYMMETRY OPERATORS])#                            MM06  24
chardata:(MM062,[ 1 ANGSTROM  = XXX.XXX GRID POINTS])#                  MM06  25
datastuff:#                                                             MM06  26
#                                                                       MM06  27
#                                                                       MM06  28
XDIR = ISUM(1)#                        Z index to map parameters        MM06  29
YDIR = ISUM(2)#                        Z index to map parameters        MM06  30
ZDIR = ISUM(3)#                        Z index to map parameters        MM06  31
#                                                                       MM06  32
#  DETERMINE ANGSTROM TO GRID CONVERSION                                MM06  33
#  -------------------------------------                                MM06  34
#                                                                       MM06  35
IL=1#                                                                   MM06  36
DO I=1,3#                                                               MM06  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MM06  38
GTOA(I) = NG(ISUM(I)) / CELL(I)#                                        MM06  39
IF (I>1) IL=0#                                                          MM06  40
ncodefld:(GTOA,I,MM062,220732.,1)#                                      MM06  41
movechar:(XYZ,I,MM062,1,1,0)#                                           MM06  42
writeline:(IL,MM062,NMM062,3,3)#       Print equivalent sites           MM06  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MM06  44
DO I=1,3#                              Map bounds in fract coors        MM06  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MM06  46
CURDIR = JSUM(I)#                      Current map direction            MM06  47
#  NOTE: EDGE* IS IN LAYER, DOWN, ACROSS DIRECTION                      MM06  48
EDGE1(I) = 1-NINT(EXTEND*GTOA(CURDIR))#                                 MM06  49
EDGE2(I) = NG(I)+NINT(EXTEND*GTOA(CURDIR))#                             MM06  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MM06  51
#                                                                       MM06  52
#  SET UP STORAGE FOR MASK GRID                                         MM06  53
#  ----------------------------                                         MM06  54
#                                                                       MM06  55
MAPSTO = FLOAT(NG(1)*NG(2)*NG(3))/mxchwd:+10# Storage needed for grid   MM06  56
incrqx:(MARK3,MARK2+MAPSTO,MM0401)#    Expand qx......2101              MM06  57
DO I=1,MAPSTO; QX(MARK2+I) = 0.#                                        MM06  58
#                                                                       MM06  59
#   LOOP OVER VOLUME TO BE MASKED                                       MM06  60
#   -----------------------------                                       MM06  61
#                                                                       MM06  62
IXG1 = INT(VOLUME(1)*GTOA(1))+SIGN(1.,VOLUME(1))#                       MM06  63
IXG2 = INT(VOLUME(2)*GTOA(1))+SIGN(1.,VOLUME(2))#                       MM06  64
IYG1 = INT(VOLUME(3)*GTOA(2))+SIGN(1.,VOLUME(3))#                       MM06  65
IYG2 = INT(VOLUME(4)*GTOA(2))+SIGN(1.,VOLUME(4))#                       MM06  66
IZG1 = INT(VOLUME(5)*GTOA(3))+SIGN(1.,VOLUME(5))#                       MM06  67
IZG2 = INT(VOLUME(6)*GTOA(3))+SIGN(1.,VOLUME(6))#                       MM06  68
#                                                                       MM06  69
DO IX=IXG1,IXG2#                       Move across x dir in volume      MM06  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MM06  71
DO IY=IYG1,IYG2#                       Move across y dir in volume      MM06  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MM06  73
DO IZ=IZG1,IZG2#                       Move across z dir in volume      MM06  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MM06  75
#                                                                       MM06  76
#   GENERATE EQUIVALENT POSITIONS IN FRACT COORS                        MM06  77
#   --------------------------------------------                        MM06  78
#                                                                       MM06  79
FOR(N=MARK1;N<MARK2;N=N+12)#           Loop over rot matrices           MM06  80
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MM06  81
DO I=1,3#                              Rowxcolumn marix multiply        MM06  82
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MM06  83
J=N+I#                                                                  MM06  84
TRANSL = INT(QX(J+9)*NG(ZDIR))+1#                                       MM06  85
LOCMAP(I) =NINT(IX*QX(J)+IY*QX(J+3)+IZ*QX(J+6)+TRANSL)# Matrix multip   MM06  86
#                                                                       MM06  87
#  SHIFT POINT INTO UNIT CELL                                           MM06  88
#  --------------------------                                           MM06  89
#                                                                       MM06  90
REPEAT#                                                                 MM06  91
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MM06  92
IF(LOCMAP(I)<1)          LOCMAP(I)=LOCMAP(I)+NG(ISUM(I))#               MM06  93
ELSE IF(LOCMAP(I)>NG(ISUM(I))) LOCMAP(I)=LOCMAP(I)-NG(ISUM(I))#         MM06  94
ELSE                   BREAK#                                           MM06  95
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MM06  96
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MM06  97
#                                                                       MM06  98
#   MASK CURRENT ATOM SITE IN MAP                                       MM06  99
#   -----------------------------                                       MM06 100
#                                                                       MM06 101
NATMAP = NATMAP + 1#                                                    MM06 102
CURACR = LOCMAP(JSUM(3))#              Across coor in grid units        MM06 103
CURDWN = LOCMAP(JSUM(2))#              Down coor in grid units          MM06 104
CURPAG = LOCMAP(JSUM(1))#              Page coor in grid units          MM06 105
#  DETERMINE POINTS IN ATOM SITE RELATIVE TO EXACT ATOM XYZ             MM06 106
#  NOTE: MAPSIT STORED IN ACROSS, DOWN, LAYER ORDER                     MM06 107
MAPSIT(3) = CURPAG#                                                     MM06 108
IF(MAPSIT(3)<EDGE1(1)) NEXT#           Atom site point outside extens   MM06 109
ELSE IF(MAPSIT(3)>EDGE2(1)) NEXT#                                       MM06 110
ELSE IF(MAPSIT(3)>=EDGE1(1) & MAPSIT(3)<1)$# Atom site point in exten   MM06 111
     MAPSIT(3) = MAPSIT(3)+NG(1)#                                       MM06 112
ELSE IF(MAPSIT(3)<=EDGE2(1) & MAPSIT(3)>NG(1))$# Atom site point in e   MM06 113
     MAPSIT(3) = MAPSIT(3)-NG(1)#                                       MM06 114
MAPSIT(2) = CURDWN#                                                     MM06 115
IF(MAPSIT(2)<EDGE1(2)) NEXT#           Atom site point outside extens   MM06 116
ELSE IF(MAPSIT(2)>EDGE2(2)) NEXT#                                       MM06 117
ELSE IF(MAPSIT(2)>=EDGE1(2) & MAPSIT(2)<1)$# Atom site point in exten   MM06 118
     MAPSIT(2) = MAPSIT(2)+NG(2)#                                       MM06 119
ELSE IF(MAPSIT(2)<=EDGE2(2) & MAPSIT(2)>NG(2))$# Atom site point in e   MM06 120
     MAPSIT(2) = MAPSIT(2)-NG(2)#                                       MM06 121
MAPSIT(1) = CURACR#                                                     MM06 122
IF(MAPSIT(1)<EDGE1(3)) NEXT#           Atom site point outside extens   MM06 123
ELSE IF(MAPSIT(1)>EDGE2(3)) NEXT#                                       MM06 124
ELSE IF(MAPSIT(1)>=EDGE1(3) & MAPSIT(1)<1)$# Atom site point in exten   MM06 125
     MAPSIT(1) = MAPSIT(1)+NG(3)#                                       MM06 126
ELSE IF(MAPSIT(1)<=EDGE2(3) & MAPSIT(1)>NG(3))$# Atom site point in e   MM06 127
     MAPSIT(1) = MAPSIT(1)-NG(3)#                                       MM06 128
ILOC = MAPSIT(1)+((MAPSIT(2)-1)*NG(3))+((MAPSIT(3)-1)*NG(2)*NG(3))#     MM06 129
IBIT = MOD(ILOC-1,mxchwd:)*mxbtch:#    Bit position in packed map       MM06 130
IWRD = ((ILOC-1)/mxchwd:)+1#           Word of packed map               MM06 131
#                                                                       MM06 132
#  UPDATE MASK MAP LOCATION TO REFLECT MAP SITE                         MM06 133
#  --------------------------------------------                         MM06 134
#                                                                       MM06 135
ITEST=1#                                                                MM06 136
intpak:(ITEST,QX(MARK2+IWRD),IBIT,mxbtch:)# Update mask map             MM06 137
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MM06 138
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MM06 139
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MM06 140
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MM06 141
ncodefld:(FLOAT(NROT),1,MM061,50413.,1)# Number symm operators          MM06 142
writeline:(2,MM061,NMM061,3,3)#        Print equivalent sites           MM06 143
#                                                                       MM06 144
RETURN#                                                                 MM06 145
END#                                                                    MM06 146
systemheader:(MM05)#                   Write out mask map               MM05   1
#######################################################                 MM05   2
#                                                                       MM05   3
#                      MM05                                             MM05   4
#                                                                       MM05   5
#######################################################                 MM05   6
SUBROUTINE MM05#                                                        MM05   7
#                                                                       MM05   8
include:(AACOMN)#                                                       MM05   9
include:(MMCOMN)#                                                       MM05  10
#                                                                       MM05  11
REAL BITOUT(128)#                      Output buffer                    MM05  12
INTEGER NMASK#                         No grid points masked            MM05  13
REAL PMASK#                            Percent grid masked              MM05  14
chardata:(MM052, Y ACROSS IN   THS          X DOWN IN   THS         $#  MM05  15
Z LAYER=   /   THS)#                                                    MM05  16
chardata:(MM053,[ XXX.XXX %  OF GRID HAS BEEN MASKED])#                 MM05  17
chardata:(XYZ,XYZ.)#                                                    MM05  18
intdata:(PRTSKL,1); realdata:(STARTF,0.); intdata:(IONE,1)#             MM05  19
datastuff:#                                                             MM05  20
#                                                                       MM05  21
#                                                                       MM05  22
#   WRITE OUT MASK FILE HEAD RECORD                                     MM05  23
#   -------------------------------                                     MM05  24
#                                                                       MM05  25
writepkt:(4,21,3,JP)#                                                   MM05  26
DO I=1,3 ; QX(JP+I)=FLOAT(NG(I))#      Save  for apmask                 MM05  27
writepkt:(4,21,3,JP)#                                                   MM05  28
DO I=1,3 ; QX(JP+I)=FLOAT(INCX(I))#    Save  for apmask                 MM05  29
writepkt:(4,21,3,JP)#                                                   MM05  30
DO I=1,3 ; QX(JP+I)=FLOAT(ISUM(I))#    Save  for apmask                 MM05  31
writepkt:(4,21,3,JP)#                                                   MM05  32
DO I=1,3 ; QX(JP+I)=FLOAT(JSUM(I))#    Save  for apmask                 MM05  33
IRECL = mxrec:#                        Number words/rec                 MM05  34
IPUT = mxbtwd:*IRECL#                  Number bits/128wrd-rec           MM05  35
ILEFT = IPUT + MAPSIZ#                 Total number bits in grid        MM05  36
NBYTES = IPUT#                                                          MM05  37
IFIRST = -NBYTES#                                                       MM05  38
NMASK = 0#                             No. masked grid points           MM05  39
#                                                                       MM05  40
#   WRITE OUT MASK GRID                                                 MM05  41
#   -------------------                                                 MM05  42
# NOTE: ORDER OF MAP ACCORDING TO JSUM INDICES                          MM05  43
#                                                                       MM05  44
IREC=0#                                                                 MM05  45
REPEAT#                                                                 MM05  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MM05  47
IFIRST = IFIRST + NBYTES#              Increment in display             MM05  48
ILEFT = ILEFT - IPUT#                                                   MM05  49
IF (ILEFT <= 0) BREAK#                                                  MM05  50
IF (ILEFT < IPUT) IPUT = ILEFT#                                         MM05  51
IREC = IREC+1#                                                          MM05  52
DO I=1,IRECL; BITOUT(I)=0.0#           128wrd/rec                       MM05  53
#                                                                       MM05  54
#  FILL 1 RECORD                                                        MM05  55
#  -------------                                                        MM05  56
#                                                                       MM05  57
DO I=1,IPUT#                           Max =iput map values in 1 rec    MM05  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MM05  59
ILOC = MOD(I-1,mxbtwd:)#               Position of mask value           MM05  60
IWRD = INT((I-1)/mxbtwd:)+1#           Word in output record            MM05  61
ILOC2 = MOD((IFIRST+I-1),mxchwd:)*mxbtch:# Bit position in display      MM05  62
IWRD2 = INT((IFIRST+I-1)/mxchwd:)+1#   Word in display                  MM05  63
intunpak:(QX(MARK2+IWRD2),ITEST,ILOC2,mxbtch:)# Get grid value          MM05  64
IF ((ITEST<=0 & INVERT==yes:) \#                                        MM05  65
(ITEST>0 & INVERT==no:))#              Masked map point                 MM05  66
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MM05  67
intpak:(IONE,BITOUT(IWRD),ILOC,1)#     Output unmasked flag             MM05  68
NMASK = NMASK+1#                       Determine no. points in grid m   MM05  69
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MM05  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MM05  71
writepkt:(4,22,IRECL,JP)#              Write a packet                   MM05  72
movereal:(BITOUT,1,QX,JP+1,IRECL,0)#   And stuff it with part of mask   MM05  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MM05  74
PMASK = 100*FLOAT(NMASK)/(NG(1)*NG(2)*NG(3))# Percent grid masked       MM05  75
ncodefld:(PMASK,1,MM053,080732.,1)#                                     MM05  76
writeline:(1,MM053,NMM053,3,3)#        Report percent grid unmasked     MM05  77
#                                                                       MM05  78
#   PRINT MAP LINE IF REQUESTED                                         MM05  79
#   ---------------------------                                         MM05  80
#        #                                                              MM05  81
IF(PRINT==yes:)#                                                        MM05  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MM05  83
LINPNT = 0#                                                             MM05  84
IPAGE =  1#                            Page, x=1,y=2,3=z                MM05  85
IDOWN =  2#                                                             MM05  86
IACRS =  3#                            Across x=1,y=2,3=z               MM05  87
DO IZ=1,NG(IPAGE)#                                                      MM05  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MM05  89
LINCT = 0#                             Force top of page                MM05  90
IZZ = (IZ-1) * INCX(IPAGE)#                                             MM05  91
movechar:(XYZ,JSUM(3),MM052,2,1,0)#                                     MM05  92
ncodefld:(FLOAT(NG(IACRS)),1,MM052,150313.,1)#                          MM05  93
movechar:(XYZ,JSUM(2),MM052,29,1,0)#                                    MM05  94
ncodefld:(FLOAT(NG(IDOWN)),1,MM052,400313.,1)#                          MM05  95
movechar:(XYZ,JSUM(1),MM052,53,1,0)#                                    MM05  96
ncodefld:(FLOAT(IZZ),1,MM052,630313.,1)#                                MM05  97
ncodefld:(FLOAT(NG(IPAGE)),1,MM052,670313.,1)#                          MM05  98
writeline:(0,MM052,NMM052,3,3)#        Move the line to the printer     MM05  99
#                                                                       MM05 100
#  ENCODE COLUMN HEADERS                                                MM05 101
#  --------------------                                                 MM05 102
FMT = 60213.#                                                           MM05 103
IFIT = (NG(3)/70)#                                                      MM05 104
IF(MOD(NG(3),70)!=0) IFIT=IFIT+1#      Skip factor to make map fit      MM05 105
DO II=1,NG(3),IFIT#                                                     MM05 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MM05 107
A= FLOAT((II-1)*INCX(IACRS))#                                           MM05 108
ncodefld:(A,1,CHROT,FMT,1)#                                             MM05 109
FMT=FMT+20000.#                                                         MM05 110
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MM05 111
writeline:(2,0,0,1,3)#                 Move the line to the printer     MM05 112
#                                                                       MM05 113
#  ENCODE ROW    VALUES                                                 MM05 114
#  --------------------                                                 MM05 115
DO IX=1,NG(IDOWN)#                                                      MM05 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MM05 117
IXX= (IX-1)*INCX(IDOWN)#               Encode line coordinate           MM05 118
STARTF = 40213.#                                                        MM05 119
ncodefld:(FLOAT(IXX),1,CHROT,40213.,1)#                                 MM05 120
FMT=STARTF+20000.;   IP=9#             Set up format for first co       MM05 121
DO IYY=1,NG(IACRS),IFIT#               Move the fourier to the outp     MM05 122
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MM05 123
ILOC=IYY+(IX-1)*NG(3)+(IZ-1)*NG(2)*NG(3)# Current map value             MM05 124
ILOC2 = MOD((ILOC-1),mxchwd:)*mxbtch:# Bit location of value            MM05 125
IWRD2 = INT((ILOC-1)/FLOAT(mxchwd:))+1# Word in qx array of value       MM05 126
intunpak:(QX(MARK2+IWRD2),IA,ILOC2,mxbtch:)# Get current mask value     MM05 127
A=FLOAT(IA)*PRTSKL#                    Ready mask value for output      MM05 128
#                                                                       MM05 129
# REPLACE UNMASKED AREA OF MAP WITH  DOTS                               MM05 130
#                                                                       MM05 131
IF((A==0.0 & INVERT==no:) \ (A>0.0 & INVERT==yes:))$#                   MM05 132
 movechar:(' .',1,CHROT,INT(FMT/10000)-1,2,0)# 0's in mask              MM05 133
ELSE IF(INVERT==yes:)#                 Change 0's to 1's in mask        MM05 134
ncodefld:(1.0,1,CHROT,FMT,1)#                                           MM05 135
ELSE#                                                                   MM05 136
ncodefld:(A,1,CHROT,FMT,1)#            Take mask as is - no invert      MM05 137
FMT=FMT+20000.#                                                         MM05 138
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MM05 139
writeline:(LINPNT,0,0,1,3)#            Move the line to the printer     MM05 140
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MM05 141
LINCT=0#                               Reset line count                 MM05 142
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MM05 143
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MM05 144
writepkt:(4,endrecord:,3,JP)#          Finish off 'msk' file            MM05 145
RETURN#                                                                 MM05 146
END#                                                                    MM05 147
systemheader:(MM21)#                   Read rec 21, set limits          MM21   1
#######################################################                 MM21   2
#                                                                       MM21   3
#                      MM21                                             MM21   4
#                                                                       MM21   5
#######################################################                 MM21   6
SUBROUTINE MM21#                                                        MM21   7
#                                                                       MM21   8
include:(AACOMN)#                                                       MM21   9
include:(MMCOMN)#                                                       MM21  10
#                                                                       MM21  11
INTEGER IPT#                                                            MM21  12
INTEGER IIP#                                                            MM21  13
INTEGER K#                                                              MM21  14
INTEGER PSIZE#          ## REC 21 PACKET SIZE                           MM21  15
#                                                                       MM21  16
intdata:(IEOF,0)#                                                       MM21  17
datastuff:#                                                             MM21  18
#                                                                       MM21  19
#   READ REC 21 DATA                                                    MM21  20
#   ----------------                                                    MM21  21
#                                                                       MM21  22
#*** REC21 CONTENTS *******************                                 MM21  23
#                                                                       MM21  24
# NOTE: IORGX,INCX,NG AND NP ARE ALL ORDERED SO THAT 1 IS PAGE TO PAGE, MM21  25
#               2 IS DOWN PAGE AND 3 IS ACROSS PAGE                     MM21  26
#                                                                       MM21  27
#       IORGX IS THE ORIGIN IN EACH DIRECTION                           MM21  28
#       INCX IS THE INCREMENT IN EACH DIRECTION                         MM21  29
#       NG IS THE GRID "FINENESS"                                       MM21  30
#       NP IS THE NUMBER OF POINTS IN A DIRECTION THAT ARE TO BE SUMMED MM21  31
#               OVER                                                    MM21  32
#       ISUM IS THE COMPUTATIONAL VARIABLE CORRESPONDING TO THE CRYSTAL MM21  33
#               VARIABLE                                                MM21  34
#       JSUM IS THE CRYSTAL VARIABLE CORRESPONDING TO THE COMPUTATIONAL MM21  35
#               VARIABLE                                                MM21  36
#                                                                       MM21  37
readwpkt:(3,21,PSIZE,IPT,0)#                                            MM21  38
IF(IPT < 0) iquit:(MM2101)#            No rec 21 in bdf#                MM21  39
DO K=1,3#                                                               MM21  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MM21  41
IIP = IPT + K#                                                          MM21  42
IORGX(K)=NINT(QX(IIP))#                Pick up origins                  MM21  43
INCX(K)=NINT(QX(IIP+3))#               Increments along axes            MM21  44
NG(K)=NINT(QX(IIP+6)/INCX(K))#         No. of grid points               MM21  45
NP(K)=NINT(QX(IIP+9))#                 Calculated points                MM21  46
ISUM(K)=NINT(QX(IIP+12))#              Correlations between crystal     MM21  47
JSUM(K)=NINT(QX(IIP+15))#              Axes and calculation axes        MM21  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MM21  49
rewindbdf:(3)#                         Go back to the beginning and g   MM21  50
#                                      The other prologue records       MM21  51
#                                                                       MM21  52
#   INITIALIZE MASK MAP                                                 MM21  53
#   -------------------                                                 MM21  54
#                                                                       MM21  55
MAPSIZ = NG(1)*NG(2)*NG(3)#            Storage needed for grid          MM21  56
#                                                                       MM21  57
RETURN#                                                                 MM21  58
END#                                                                    MM21  59
pmacro:([no:])#                        Purge xtal system macros         MM21  60
