systemheader:(MN    )#                                                  MN     1
####################################################################### MN     2
#                                                                     # MN     3
#                         *** MOGIN ***                               # MN     4
#                                                                     # MN     5
#     CREATE INPUT FILE FOR PROGRAM MOGLI (PSSHOW)                    # MN     6
#                                                                     # MN     7
####################################################################### MN     8
#                                                                       MN     9
include:(XMACRO)#                                                       MN    10
#                                                                       MN    11
systemheader:(MN00)#                                                    MN00   1
####################################################################### MN00   2
#                                                                     # MN00   3
#                          MN00                                       # MN00   4
#                                                                     # MN00   5
####################################################################### MN00   6
SUBROUTINE MN00#                       U. bartsch jun 88                MN00   7
include:(AACOMN)#                                                       MN00   8
#                                                                       MN00   9
INTEGER MXBC,MXNM#                     Max bond count, max char/atom    MN00  10
INTEGER NCELL,NCORN,NCUT#              Flags cell, corn. & cut mole.    MN00  11
INTEGER I,J,K,J1,J2,J3,J4#             Loop indices                     MN00  12
INTEGER LATYP,NCENT,NOA,NOSYM#         Latt, centro, atom & symm cnt.   MN00  13
INTEGER LPAK,IP#                       Pack. size, index                MN00  14
INTEGER IWNT(5)#                       Want list for indexpkt           MN00  15
INTEGER KEY(4)#                        Control functions for aa15       MN00  16
INTEGER RELPT(6)#                      Returned relative pointers       MN00  17
INTEGER ASTART,SSTART,ABEG#            Start of atom/sym./molec. inf.   MN00  18
INTEGER ASTEP,SSTEP#                   Step thro. ato/sym inf. in qx    MN00  19
INTEGER AEND,SEND,ASTOP#               End of atom/sym. inf. in qx      MN00  20
INTEGER NOLBL#                         No of radii modified             MN00  21
INTEGER NCOM(8)#                       Remember control parameters      MN00  22
#                                                                       MN00  23
REAL    CELL(6),RADII(20)#             Cell parameters, bond radii      MN00  24
REAL    ST,TT,UT#                      Calculated atomic pos.           MN00  25
REAL    U,V,W,X,Y,Z,P,Q,R#             Calculated atomic pos.           MN00  26
REAL    SX,SY,SZ,CX,CY,CZ#             Calc. distances in x,y,z         MN00  27
REAL    DIST,D#                        Calc. distances                  MN00  28
REAL    BNR1#                          Bond radii                       MN00  29
REAL    SP(3)#                         Center of molecule               MN00  30
REAL    RADMD(16)#                     Atomic radii modified            MN00  31
#                                                                       MN00  32
CHARACTER*2 LBL(16)#                   Changed radii atom types         MN00  33
#                                                                       MN00  34
string:(NAME,24)#                                                       MN00  35
chardata:(MHEAD," MOGIN Control Parameters")#                           MN00  36
chardata:(MFLD,BOND NAME EDGE CELL ACUT NOED MOLE MCUT )#               MN00  37
chardata:(MN1, RADII END )#                                             MN00  38
chardata:(PNT0,   1 E0      0.00000   0.00000   0.00000    2   3   4)#  MN00  39
chardata:(PNTA,   2 EA      1.00000   0.00000   0.00000    1   5   6)#  MN00  40
chardata:(PNTB,   3 EB      0.00000   1.00000   0.00000    1   5   7)#  MN00  41
chardata:(PNTC,   4 EC      0.00000   0.00000   1.00000    1   6   7)#  MN00  42
chardata:(PNT5,   5 E       1.00000   1.00000   0.00000    2   3   8)#  MN00  43
chardata:(PNT6,   6 E       1.00000   0.00000   1.00000    2   4   8)#  MN00  44
chardata:(PNT7,   7 E       0.00000   1.00000   1.00000    3   4   8)#  MN00  45
chardata:(PNT8,   8 E       1.00000   1.00000   1.00000    5   6   7)#  MN00  46
chardata:(MMBC," Max number of bonds              -")#                  MN00  47
chardata:(MMNM," Max atom name length              ")#                  MN00  48
chardata:(MEDGY," Draw unit cell edges           yes")#                 MN00  49
chardata:(MEDGN," Draw unit cell edges            no")#                 MN00  50
chardata:(MCELY," Draw entire cell               yes")#                 MN00  51
chardata:(MCELN," Draw entire cell                no")#                 MN00  52
chardata:(MCUTY," Extend past cell edge     one atom")#                 MN00  53
chardata:(MCUTN," Extend past cell edge     molecule")#                 MN00  54
chardata:(BCEXC," Exceeded bond count for atom                       ")#MN00  55
chardata:(ABCLN,[ REFERENCE STRUCTURE =   999   A,B,C =])#              MN00  56
chardata:(ARCLN,[   ALPHA,BETA,GAMMA =])#                               MN00  57
chardata:(NALN,[   0 CODEN=TEST])#                                      MN00  58
#                                                                       MN00  59
realdata:(CENT,[$#                                                      MN00  60
0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,#        Add for lattice type p           MN00  61
.5,.5,.5,0.,0.,0.,0.,0.,0.,1.,#        Add for lattice type i           MN00  62
.333333,.666667,.666667,.666667,.333333,.333333,0.,0.,0.,2.,# Type r    MN00  63
.0,.5,.5,.5,.0,.5,.5,.5,.0,3.,#        Add for lattice type f           MN00  64
.0,.5,.5,0.,0.,0.,0.,0.,0.,1.,#        Add for lattice type a           MN00  65
.5,.0,.5,0.,0.,0.,0.,0.,0.,1.,#        Add for lattice type b           MN00  66
.5,.5,.0,0.,0.,0.,0.,0.,0.,1.])#       Add for lattice type c           MN00  67
realdata:(FABC,[460832.,540832.,620832.])# First output line            MN00  68
realdata:(FARC,[290832.,370832.,450832.])# Second output line           MN00  69
realdata:(FXYZ,[201052.,301052.,401052.])# X,y,z output                 MN00  70
realdata:(FCON,[450403.,490403.,530403.,570403.,610403.,650403.,#       MN00  71
690403,730403.])#                                                       MN00  72
realdata:(FBCEX,[520503.])#            Bond count exceeded              MN00  73
datastuff:#                                                             MN00  74
#                                                                       MN00  75
IOMARK(1)=QXSTR#                       Set start of io buffer qx        MN00  76
incrqx:(SSTART,IOMARK(1)+bdfbuf:,MN0005)# Expand buffer qx              MN00  77
readwpkt:(1,1,LPAK,IP,0)#              Force to write list header       MN00  78
#                                                                       MN00  79
#              PROCESS MOGIN LINE                                       MN00  80
#              ------------------                                       MN00  81
#                                                                       MN00  82
MXBC =8#                               Max. bond count                  MN00  83
MXNM =4#                               Max. char. for atom name         MN00  84
NCORN=0#                               No cell edges                    MN00  85
NCELL=0#                               One single molec. set            MN00  86
NCUT =0#                               Molec. not cut at cell edges     MN00  87
DO I=1,8; NCOM(I)=0#                   Remember present control param   MN00  88
#                                                                       MN00  89
FOR(K=1;K<10;K=K+1)#                   Loop over mogin fields           MN00  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MN00  91
ifvo:(BUFIN(K)) BREAK#                 Exit on first void               MN00  92
stringlim:(K,I,J)#                     Find string limits               MN00  93
compchar:(CHRIN,I,MFLD,1,4,5,NMFLD,J)# Search for match                 MN00  94
IF(J==1)#                              Max. bond count                  MN00  95
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MN00  96
NCOM(1)=1#                             Bond count changed               MN00  97
K=K+1#                                 Incr field pointer               MN00  98
IF(BUFIN(K)<0.) iquit:(MN0015)#        No legal number                  MN00  99
MXBC=NINT(BUFIN(K))#                   Get max bond count               MN00 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MN00 101
ELSE IF(J==2)#                         Max. no. of char.                MN00 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MN00 103
NCOM(2)=1#                             Atom name length changed         MN00 104
K=K+1#                                 Incr field pointer               MN00 105
IF(BUFIN(K)<0.) iquit:(MN0020)#        No legal number                  MN00 106
MXNM=NINT(BUFIN(K))#                   Get max name length              MN00 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MN00 108
ELSE IF(J==3)#                         Draw cell edges                  MN00 109
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MN00 110
NCORN=8; NCOM(3)=1#                    Edge param. present              MN00 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MN00 112
ELSE IF(J==4)#                         Draw whole unit cell             MN00 113
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MN00 114
NCELL=1; NCOM(4)=1#                    Cell param. present              MN00 115
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MN00 116
ELSE IF(J==5)#                         Cut molecule at cell edges       MN00 117
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MN00 118
NCUT =1; NCOM(5)=1#                    Acut param. present              MN00 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MN00 120
ELSE NCOM(J)=1#                        Cut molecule at cell edges       MN00 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MN00 122
IF (NCOM(4)==1&NCOM(6)==0) NCORN=8#    Draw edges                       MN00 123
#                                                                       MN00 124
REPEAT#                                Loop over input lines            MN00 125
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MN00 126
readline:(MN1,NMN1)#                   Read next input line             MN00 127
#                                                                       MN00 128
#                                                                       MN00 129
#    PROCESS RADII LINE                                                 MN00 130
#    ------------------                                                 MN00 131
#                                                                       MN00 132
IF(LINID==1)#                          *********** radii line           MN00 133
NOLBL=0#                                                                MN00 134
FOR(K=1;K<30;K=K+1)#                   Loop over radii  fields          MN00 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MN00 136
ifvo:(BUFIN(K)) BREAK#                 Exit on first void               MN00 137
stringlim:(K,I,J)#                     Find string limits               MN00 138
IF (MOD(K,2)==1)#                                                       MN00 139
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MN00 140
NOLBL=NOLBL+1#                         New radii counter                MN00 141
LBL(NOLBL)=CHRIN(I^J-1)#               New type of atom                 MN00 142
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MN00 143
ELSE RADMD(NOLBL)=BUFIN(K)#            New radii                        MN00 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MN00 145
#                                                                       MN00 146
IF (LINID==2) BREAK#                   *********** end line             MN00 147
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MN00 148
#                                                                       MN00 149
#             PRINT MOGIN PARAMETERS                                    MN00 150
#             ----------------------                                    MN00 151
#                                                                       MN00 152
movechar:(MMBC,NMMBC,CHROT,2,NMHEAD-1,1)# Fill text into chrot          MN00 153
writeline:(1,MHEAD,NMHEAD,2,3)#        Print header                     MN00 154
movechar:(MMBC,1,CHROT,1,NMMBC,0)#     Fill text into chrot             MN00 155
ncodefld:(FLOAT(MXBC),1,CHROT,350303.,1)# Fill mxbc into chrot          MN00 156
writeline:(0,0,0,1,3)#                 Write line                       MN00 157
movechar:(MMNM,1,CHROT,1,NMMNM,0)#     Fill text into chrot             MN00 158
ncodefld:(FLOAT(MXNM),1,CHROT,350303.,1)# Fill mxnm into chrot          MN00 159
writeline:(0,0,0,1,3)#                 Write line                       MN00 160
IF(NCORN==0)#                                                           MN00 161
writeline:(0,MEDGN,NMEDGN,3,3)#        Write line out                   MN00 162
ELSE#                                                                   MN00 163
writeline:(0,MEDGY,NMEDGY,3,3)#        Write line out                   MN00 164
IF(NCELL==0)#                                                           MN00 165
writeline:(0,MCELN,NMCELN,3,3)#        Write line out                   MN00 166
ELSE#                                                                   MN00 167
writeline:(0,MCELY,NMCELY,3,3)#        Write line out                   MN00 168
IF(NCUT==0)#                                                            MN00 169
writeline:(0,MCUTN,NMCUTN,3,3)#        Write line out                   MN00 170
ELSE#                                                                   MN00 171
writeline:(0,MCUTY,NMCUTY,3,3)#        Write line out                   MN00 172
#                                                                       MN00 173
#              READ CELL CONSTANTS FROM LRCELL                          MN00 174
#              --------------------------------                         MN00 175
#                                                                       MN00 176
DO J=1,7#                              Loop over lrcell packets         MN00 177
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MN00 178
readwpkt:(1,lrcell:,LPAK,IP,0)#        Read the next packet             MN00 179
IF(IP<=0) BREAK#                       Test if finished yet             MN00 180
IF(J==1)#                              First packet                     MN00 181
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MN00 182
CELL(1)=QX(IP+1)#                      A                                MN00 183
CELL(2)=QX(IP+2)#                      B                                MN00 184
CELL(3)=QX(IP+3)#                      C                                MN00 185
CELL(4)=QX(IP+7)*360.#                 Alpha in degree                  MN00 186
CELL(5)=QX(IP+8)*360.#                 Beta                             MN00 187
CELL(6)=QX(IP+9)*360.#                 Gamma                            MN00 188
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MN00 189
ELSE IF(J==7)#                         Metric tensor packet             MN00 190
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MN00 191
G1=QX(IP+1)#                           A**2                             MN00 192
G2=QX(IP+5)#                           B**2                             MN00 193
G3=QX(IP+9)#                           C**2                             MN00 194
G4=QX(IP+2)*2.#                        2 a b cosg                       MN00 195
G5=QX(IP+3)*2.#                        2 a c cosb                       MN00 196
G6=QX(IP+6)*2.#                        2 b c cosa                       MN00 197
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MN00 198
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MN00 199
#                                                                       MN00 200
#              READ SYMMETRY INFORMATION FROM LRSYMM                    MN00 201
#              AND CALCULATE THE ADDITIONAL SYMMETRY                    MN00 202
#              OPERATIONS ACCORDING TO LATTICE TYPE                     MN00 203
#              AND CENTROSYMMETRY                                       MN00 204
#              -------------------------------------                    MN00 205
#                                                                       MN00 206
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Read the 1st sym pkt             MN00 207
LATYP=QX(IP+1)#                        Lattice type                     MN00 208
NCENT=QX(IP+2)#                        Centric / acentric  0/1          MN00 209
NOSYM=QX(IP+3)#                        Total no of symm. rel. rot.      MN00 210
incrqx:(ASTART,SSTART+NOSYM*LPAK,MN0025)# Memory for symop table        MN00 211
FOR(J=SSTART;J>0;J=J+LPAK)#            Loop thro. symm. rec.            MN00 212
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MN00 213
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Read sym. rel. rotations         MN00 214
IF(IP<=0) BREAK#                       Finished                         MN00 215
movereal:(QX,IP+1,QX,J+1,LPAK,1)#      Store symm. rel. rotations       MN00 216
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MN00 217
SSTEP=LPAK#                            Step through sym. rec.           MN00 218
SEND=J;    IP=SEND#                    End of sym. rec. read in         MN00 219
#                                                                       MN00 220
IF(LATYP>7) LATYP=LATYP-7#             Reduce to centrosymmetric        MN00 221
IF(LATYP>1)#                           Add symmops if non-primitive     MN00 222
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MN00 223
L =(LATYP-1)*10#                       Start in cent array              MN00 224
N =NINT(CENT(LATYP*10))*3#             No. of triples to add            MN00 225
DO K=0,N,3#                            Loop thro. cent array            MN00 226
FOR(J=SSTART;J<SEND;J=J+SSTEP)#        Loop thro. symm. rec.            MN00 227
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MN00 228
movereal:(QX,J+1,QX,IP+1,SSTEP,1)#     Rotation matrix equivalent       MN00 229
QX(IP+10)=QX(IP+10)+CENT(L+K+1)#       Add to translation in x          MN00 230
QX(IP+11)=QX(IP+11)+CENT(L+K+2)#       Add to translation in y          MN00 231
QX(IP+12)=QX(IP+12)+CENT(L+K+3)#       Add to translation in z          MN00 232
IP=IP+SSTEP#                           Set start of new symm. rec.      MN00 233
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MN00 234
SEND=IP#                               End of symmops.                  MN00 235
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MN00 236
#                                                                       MN00 237
N=SEND-SSTART+1#                       Number of elements               MN00 238
IF(NCENT==0)#                          In case of centrosymmetry        MN00 239
DO J=1,N; QX(SEND+J)=-QX(SSTART+J)#    Set centro elements              MN00 240
SEND=ASTART#                           End of symmops.                  MN00 241
#                                                                       MN00 242
#              LRSCAT REQUEST BOND RADIUS                               MN00 243
#              --------------------------                               MN00 244
#                                                                       MN00 245
IWNT(1)=5; IWNT(2)=11#                 Bond radius and atom name        MN00 246
KEY(1)=2; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search keys                 MN00 247
indexpkt:(1,lrscat:,LPAK,IP,0,KEY,IWNT,RELPT)# Test for wanted items    MN00 248
IF(KEY(4)<=0) iquit:(MN0030)#          Item not found-exit              MN00 249
DO I=1,20#                             Loop for atom types              MN00 250
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MN00 251
readwpkt:(1,lrscat:,LPAK,IP,0)#        Read atom type param.            MN00 252
IF(IP<=0) BREAK#                       Test for end of types            MN00 253
movertoc:(QX(IP+RELPT(2)),1,NAME,1,2,0)# Extract atom label             MN00 254
RADII(I)=QX(IP+RELPT(1))+0.1#          Store bond radius                MN00 255
FOR(K=1;K<=NOLBL;K=K+1)#               Search if radius change          MN00 256
IF(LBL(K)==NAME(1^2)) RADII(I)=RADMD(K)# Wanted                         MN00 257
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MN00 258
#                                                                       MN00 259
#              LRATOM REQUEST ATOMIC PARAMETERS                         MN00 260
#              --------------------------------                         MN00 261
#                                                                       MN00 262
IWNT(1)=1; IWNT(2)=2; IWNT(3)=3#       X,y,z                            MN00 263
IWNT(4)=22#                            Pointer to no of bond radius     MN00 264
IWNT(5)=14#                            Atom name (namln: words)         MN00 265
KEY(1)=5; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search keys                 MN00 266
indexpkt:(1,lratom:,LPAK,IP,0,KEY,IWNT,RELPT)# Test for wanted items    MN00 267
IF(KEY(4)<=0) iquit:(MN0035)#          If items not present-exit        MN00 268
#                                      Step thro. single atom inf. =    MN00 269
ASTEP=14+MXBC#                         Atom list+ bond count            MN00 270
FOR(K=ASTART;K>0;K=I)#                 Loop thro. atoms                 MN00 271
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MN00 272
incrqx:(I,K+ASTEP,MN0040)#             Expand qx for one atom           MN00 273
readwpkt:(1,lratom:,LPAK,IP,0)#        Read atom param.                 MN00 274
IF(IP<=0) BREAK#                       Test for end of atoms            MN00 275
QX(K+1)=QX(IP+RELPT(1))#               X frac.                          MN00 276
QX(K+2)=QX(IP+RELPT(2))#               Y frac.                          MN00 277
QX(K+3)=QX(IP+RELPT(3))#               Z frac.                          MN00 278
QX(K+4)=RADII(NINT(QX(IP+RELPT(4))))#  Atomic radius                    MN00 279
QX(K+8)=0.#                            Zero bond count                  MN00 280
movertoc:(QX(IP+RELPT(5)),1,NAME,1,24,0)# Store atom name               MN00 281
label:(NAME,J,J)#                      Process atom label               MN00 282
movector:(NAME,1,QX(K+9+MXBC),1,24,0)# Store atom name                  MN00 283
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MN00 284
AEND  =K#                              End of qx buffer                 MN00 285
#                                                                       MN00 286
#         BUILD CLUSTERS OF CONNECTED ATOMS                             MN00 287
#         ALWAYS MOVE THE ROOT ATOM AS CLOSE                            MN00 288
#         AS POSSIBLE TO THE BODY CENTRE                                MN00 289
#         ----------------------------------                            MN00 290
#                                                                       MN00 291
JJ=0#                                  Zero cluster counter             MN00 292
FOR(J4=ASTART;J4<AEND;J4=J4+ASTEP)#    Loop over input atoms            MN00 293
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MN00 294
IF(QX(J4+8)>0.5) NEXT#                 Skip if already positioned       MN00 295
JJ=JJ+1;   QX(J4+8)=FLOAT(JJ)#         Counter for cluster              MN00 296
DIST=999999.;   FNEW=yes:#             Set starting distance            MN00 297
FOR(J2=SSTART;J2<SEND;J2=J2+SSTEP)#    Loop over symops                 MN00 298
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MN00 299
X=QX(J2+1)*QX(J4+1)+QX(J2+4)*QX(J4+2)+QX(J2+7)*QX(J4+3)+QX(J2+10)#      MN00 300
Y=QX(J2+2)*QX(J4+1)+QX(J2+5)*QX(J4+2)+QX(J2+8)*QX(J4+3)+QX(J2+11)#      MN00 301
Z=QX(J2+3)*QX(J4+1)+QX(J2+6)*QX(J4+2)+QX(J2+9)*QX(J4+3)+QX(J2+12)#      MN00 302
U=MOD(99.+X,1.0)-0.5#                  Move close to body centre        MN00 303
V=MOD(99.+Y,1.0)-0.5#                  Move close to body centre        MN00 304
W=MOD(99.+Z,1.0)-0.5#                  Move close to body centre        MN00 305
D=G1*U*U+G2*V*V+G3*W*W+G4*U*V+G5*U*W+G6*V*W# Get distance squared       MN00 306
IF(D>=DIST) NEXT#                      New eq. pos. closer to center    MN00 307
P=U+.5; Q=V+.5; R=W+.5; DIST=D-0.01#   Save closest site                MN00 308
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MN00 309
QX(J4+1)=P; QX(J4+2)=Q; QX(J4+3)=R#    Store closest site               MN00 310
#                                                                       MN00 311
#       FIND ALL ATOMS CONNECTED TO ROOT ATOM                           MN00 312
#       -------------------------------------                           MN00 313
#                                                                       MN00 314
WHILE(FNEW==yes:)#                     Loop over all connected atoms    MN00 315
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MN00 316
FNEW=no:#                              Assume no connections            MN00 317
FOR(J3=ASTART;J3<AEND;J3=J3+ASTEP)#    Loop over input atoms            MN00 318
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MN00 319
IF(NINT(QX(J3+8))!=JJ) NEXT#           Process only this cluster        MN00 320
BNR1=QX(J3+4)#                         Bond radius                      MN00 321
P=QX(J3+1);  Q=QX(J3+2);  R=QX(J3+3)#  Get atom site                    MN00 322
#                                                                       MN00 323
FOR(J1=ASTART;J1<AEND;J1=J1+ASTEP)#    Loop over input atoms            MN00 324
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MN00 325
IF(QX(J1+8)>0.5) NEXT#                 Skip if atom already bonded      MN00 326
DIST=(BNR1+QX(J1+4))**2#               Get max bond distance            MN00 327
#                                                                       MN00 328
FOR(J2=SSTART;J2<SEND;J2=J2+SSTEP)#    Loop over symops                 MN00 329
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MN00 330
X=QX(J2+1)*QX(J1+1)+QX(J2+4)*QX(J1+2)+QX(J2+7)*QX(J1+3)+QX(J2+10)#      MN00 331
Y=QX(J2+2)*QX(J1+1)+QX(J2+5)*QX(J1+2)+QX(J2+8)*QX(J1+3)+QX(J2+11)#      MN00 332
Z=QX(J2+3)*QX(J1+1)+QX(J2+6)*QX(J1+2)+QX(J2+9)*QX(J1+3)+QX(J2+12)#      MN00 333
U=MOD(99.5+X-P,1.0)-0.5#               Move coord next to atom j3       MN00 334
V=MOD(99.5+Y-Q,1.0)-0.5#                                                MN00 335
W=MOD(99.5+Z-R,1.0)-0.5#                                                MN00 336
D=G1*U*U+G2*V*V+G3*W*W+G4*U*V+G5*U*W+G6*V*W# Get distance squared       MN00 337
IF(D<DIST) GOTO 100#                   Within bonding distance          MN00 338
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MN00 339
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MN00 340
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MN00 341
NEXT#                                  Skip if no connects              MN00 342
100 FNEW=yes:#                         New bonded atom                  MN00 343
QX(J1+1)=P+U#                          New x frac.                      MN00 344
QX(J1+2)=Q+V#                          New y frac.                      MN00 345
QX(J1+3)=R+W#                          New z frac.                      MN00 346
QX(J1+8)=FLOAT(JJ)#                    Flag atom as con. to root        MN00 347
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MN00 348
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MN00 349
#                                                                       MN00 350
#   EXTEND INPUT LIST TO INCLUDE ALL CONNECTIONS                        MN00 351
#   --------------------------------------------                        MN00 352
#                                                                       MN00 353
FOR(FNEW=yes:;FNEW==yes:;)#            Loop over all connected atoms    MN00 354
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MN00 355
FNEW=no:#                              Assume no connections            MN00 356
FOR(J3=ASTART;J3<AEND;J3=J3+ASTEP)#    Loop over input atoms            MN00 357
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MN00 358
IF(NINT(QX(J3+8))!=JJ) NEXT#           Process only this cluster        MN00 359
BNR1=QX(J3+4)#                         Bond radius                      MN00 360
#                                                                       MN00 361
FOR(J2=SSTART;J2<SEND;J2=J2+SSTEP)#    Loop over symops                 MN00 362
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MN00 363
U=QX(J2+1)*QX(J3+1)+QX(J2+4)*QX(J3+2)+QX(J2+7)*QX(J3+3)+QX(J2+10)#      MN00 364
V=QX(J2+2)*QX(J3+1)+QX(J2+5)*QX(J3+2)+QX(J2+8)*QX(J3+3)+QX(J2+11)#      MN00 365
W=QX(J2+3)*QX(J3+1)+QX(J2+6)*QX(J3+2)+QX(J2+9)*QX(J3+3)+QX(J2+12)#      MN00 366
#                                                                       MN00 367
FOR(J1=ASTART;J1<AEND;J1=J1+ASTEP)#    Loop over input atoms            MN00 368
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MN00 369
ifne:(QX(J3+8),QX(J1+8)) NEXT#         Process only this cluster        MN00 370
IF(J3==J1&J2==SSTART)    NEXT#         Avoid identical overlap          MN00 371
P=MOD(99.5+U-QX(J1+1),1.0)-0.5#        Move coord next to atom j3       MN00 372
Q=MOD(99.5+V-QX(J1+2),1.0)-0.5#                                         MN00 373
R=MOD(99.5+W-QX(J1+3),1.0)-0.5#                                         MN00 374
D=G1*P*P+G2*Q*Q+G3*R*R+G4*P*Q+G5*P*R+G6*Q*R# Get distance squared       MN00 375
IF(D<.1\D>(BNR1+QX(J1+4))**2) NEXT#    New eq. pos. closer to center    MN00 376
P=P+QX(J1+1); Q=Q+QX(J1+2); R=R+QX(J1+3)# Store new coords              MN00 377
#                                                                       MN00 378
FOR(J0=ASTART;J0<AEND;J0=J0+ASTEP)#    Loop over extended atom list     MN00 379
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MN00 380
ifne:(QX(J0+8),QX(J1+8)) NEXT#         Process only this cluster        MN00 381
IF(ABS(P-QX(J0+1))>.001) NEXT#         Skip if no overlap               MN00 382
IF(ABS(Q-QX(J0+2))>.001) NEXT#         Skip if no overlap               MN00 383
IF(ABS(R-QX(J0+3))<.001) BREAK#        Break if overlapped              MN00 384
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MN00 385
IF(J0<AEND) NEXT#                      Skip if overlapped site          MN00 386
FNEW=yes:#                             Flag new site found              MN00 387
incrqx:(AEND,AEND+ASTEP,MN0040)#       Expand list pointer              MN00 388
QX(J0+1)=P#                            New x frac.                      MN00 389
QX(J0+2)=Q#                            New y frac.                      MN00 390
QX(J0+3)=R#                            New z frac.                      MN00 391
QX(J0+4)=QX(J1+4)#                     Store atom radius                MN00 392
QX(J0+8)=QX(J1+8)#                     Flag atom as con. to root        MN00 393
movereal:(QX,J1+9+MXBC,QX,J0+9+MXBC,6,1)# New atom name                 MN00 394
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MN00 395
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MN00 396
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MN00 397
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MN00 398
#                                                                       MN00 399
#        PACK CENTRES CLOSE TOGETHER                                    MN00 400
#        --------------------------                                     MN00 401
#                                                                       MN00 402
DO J1=1,JJ#                            Loop over clusters               MN00 403
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 MN00 404
NO=0; DO I=1,3; SP(I)=0#               Zero coord sums                  MN00 405
FOR(J2=ASTART;J2<AEND;J2=J2+ASTEP)#    Loop over input atoms            MN00 406
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 MN00 407
IF(NINT(QX(J2+8))!=J1) NEXT#           Atom member of cur. cluster      MN00 408
DO I=1,3; SP(I)=SP(I)+QX(J2+I)#        Sum all coords                   MN00 409
NO=NO+1#                               Sum members                      MN00 410
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 MN00 411
DO I=1,3; SP(I)=SP(I)/FLOAT(NO)#       Calc cluster centre              MN00 412
IF (J1==1)#                                                             MN00 413
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 MN00 414
CX=SP(1); CY=SP(2); CZ=SP(3)#          Centre of root cluster           MN00 415
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 MN00 416
DIST=9999999.#                         Set starting distance            MN00 417
FOR(J2=SSTART;J2<SEND;J2=J2+SSTEP)#    Loop over symops                 MN00 418
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 MN00 419
X=QX(J2+1)*SP(1)+QX(J2+4)*SP(2)+QX(J2+7)*SP(3)+QX(J2+10)#               MN00 420
Y=QX(J2+2)*SP(1)+QX(J2+5)*SP(2)+QX(J2+8)*SP(3)+QX(J2+11)#               MN00 421
Z=QX(J2+3)*SP(1)+QX(J2+6)*SP(2)+QX(J2+9)*SP(3)+QX(J2+12)#               MN00 422
P=X-CX;  Q=Y-CY;  R=Z-CZ#              Get diff with centre 1           MN00 423
U=MOD(99.5+P,1.)-0.5#                  Get smallest difference          MN00 424
V=MOD(99.5+Q,1.)-0.5#                  Get smallest difference          MN00 425
W=MOD(99.5+R,1.)-0.5#                  Get smallest difference          MN00 426
D=G1*U*U+G2*V*V+G3*W*W+G4*U*V+G5*U*W+G6*V*W# Get distance squared       MN00 427
IF(D>=DIST) NEXT#                      New eq. pos. closer to center    MN00 428
SX=U-P;  SY=V-Q;  SZ=W-R;  JK=J2;  DIST=D-.01# Save closest distance    MN00 429
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 MN00 430
#                                                                       MN00 431
FOR(J3=ASTART;J3<AEND;J3=J3+ASTEP)#    Loop over input atoms            MN00 432
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 MN00 433
IF(NINT(QX(J3+8))!=J1) NEXT#           Atom is memb of cur. cluster     MN00 434
X=QX(JK+1)*QX(J3+1)+QX(JK+4)*QX(J3+2)+QX(JK+7)*QX(J3+3)+QX(JK+10)#      MN00 435
Y=QX(JK+2)*QX(J3+1)+QX(JK+5)*QX(J3+2)+QX(JK+8)*QX(J3+3)+QX(JK+11)#      MN00 436
Z=QX(JK+3)*QX(J3+1)+QX(JK+6)*QX(J3+2)+QX(JK+9)*QX(J3+3)+QX(JK+12)#      MN00 437
QX(J3+1)=X+SX#                         New x frac.                      MN00 438
QX(J3+2)=Y+SY#                         New y frac.                      MN00 439
QX(J3+3)=Z+SZ#                         New z frac.                      MN00 440
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 MN00 441
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 MN00 442
#                                                                       MN00 443
#        GET CENTRE OF INPUT ATOMS LIST                                 MN00 444
#        ------------------------------                                 MN00 445
#                                                                       MN00 446
DO I=1,3; SP(I)=0#                     Zero coord sums                  MN00 447
FOR(J1=ASTART;J1<AEND;J1=J1+ASTEP)#    Loop over input atoms            MN00 448
DO I=1,3; SP(I)=SP(I)+QX(J1+I)#        Sum all coords                   MN00 449
DO I=1,3#                              Loop over each coord             MN00 450
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 MN00 451
SP(I)=SP(I)/FLOAT((AEND-ASTART)/ASTEP)# Center of x-coords.             MN00 452
IF(SP(I)<0.)      SP(I)=+1.#           Centre out of cell               MN00 453
ELSE IF(SP(I)>1.) SP(I)=-1.#           Center out of cell               MN00 454
ELSE              SP(I)= 0.#           Center in cell                   MN00 455
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 MN00 456
FOR(J1=ASTART;J1<AEND;J1=J1+ASTEP)#    Loop over input atoms            MN00 457
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 MN00 458
DO I=1,3; QX(J1+I)=QX(J1+I)+SP(I)#     Move the centre                  MN00 459
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 MN00 460
#                                                                       MN00 461
#         EXPAND LIST FOR WHOLE CELL IF REQUESTED                       MN00 462
#         ---------------------------------------                       MN00 463
#                                                                       MN00 464
IF(NCELL==1)#                          Whole unit cell                  MN00 465
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 MN00 466
ASTOP=AEND#                            Keep end of current list         MN00 467
FOR(J2=SSTART+SSTEP;J2<SEND;J2=J2+SSTEP)# Loop over symops              MN00 468
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 MN00 469
ABEG=AEND#                             Reset new molecule flag          MN00 470
FOR(J1=ASTART;J1<ASTOP;J1=J1+ASTEP)#   Loop over exp. input atom list   MN00 471
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 MN00 472
ST=QX(J2+1)*QX(J1+1)+QX(J2+4)*QX(J1+2)+QX(J2+7)*QX(J1+3)+QX(J2+10)#     MN00 473
TT=QX(J2+2)*QX(J1+1)+QX(J2+5)*QX(J1+2)+QX(J2+8)*QX(J1+3)+QX(J2+11)#     MN00 474
UT=QX(J2+3)*QX(J1+1)+QX(J2+6)*QX(J1+2)+QX(J2+9)*QX(J1+3)+QX(J2+12)#     MN00 475
FOR(J4=ASTART;J4<AEND;J4=J4+ASTEP)#    Atom pos. already stored ?       MN00 476
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 MN00 477
ifne:(ST,QX(J4+1),.001) NEXT#          Skip if x different              MN00 478
ifne:(TT,QX(J4+2),.001) NEXT#          Skip if y different              MN00 479
ifeq:(UT,QX(J4+3),.001) BREAK#         Break if pos. equiv.             MN00 480
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 MN00 481
IF(J4<AEND) NEXT#                      Pos. not found-new atom          MN00 482
I=AEND#                                Save current end of list         MN00 483
incrqx:(AEND,AEND+ASTEP,MN0050)#       Incr. qx to store new atom inf   MN00 484
QX(I+1)=ST#                            New x frac.                      MN00 485
QX(I+2)=TT#                            New y frac.                      MN00 486
QX(I+3)=UT#                            New z frac.                      MN00 487
QX(I+4)=QX(J1+4)#                      Bond radius                      MN00 488
movereal:(QX,J1+9+MXBC,QX,I+9+MXBC,6,1)# New atom name                  MN00 489
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 MN00 490
NBACK=0#                               Keep this new mol.               MN00 491
FOR(J1=ABEG;J1<AEND;J1=J1+ASTEP)#      Loop over new atoms              MN00 492
IF(QX(J1+1)>=0.&QX(J1+2)>=0.&QX(J1+3)>=0.$# If one atom in cell         MN00 493
  &QX(J1+1)<=1.&QX(J1+2)<=1.&QX(J1+3)<=1.) BREAK# Keep this molec.      MN00 494
IF(J1==AEND) NBACK=1#                  Set endlist back, do not keep    MN00 495
#                                      Calc centre of new mol.          MN00 496
DO I=1,3; SP(I)=0#                     Zero coord sums                  MN00 497
FOR(J1=ABEG;J1<AEND;J1=J1+ASTEP)#      Loop over new atoms              MN00 498
DO I=1,3; SP(I)=SP(I)+QX(J1+I)#        Sum all coords                   MN00 499
DO I=1,3#                              Loop over each coord             MN00 500
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 MN00 501
SP(I)=SP(I)/FLOAT((AEND-ABEG)/ASTEP)#  Center of x-coords.              MN00 502
IF(SP(I)<0.)      SP(I)=+1.#           Centre out of cell               MN00 503
ELSE IF(SP(I)>1.) SP(I)=-1.#           Center out of cell               MN00 504
ELSE              SP(I)= 0.#           Center in cell                   MN00 505
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 MN00 506
ANEND=AEND#                            Keep end of new atom list        MN00 507
J5=ABEG#                               Do not keep new mol.             MN00 508
IF (NBACK==0&(SP(1)!=0\SP(2)!=0\SP(3)!=0)) J5=AEND# Keep new a          MN00 509
#                                       Keep translated one             MN00 510
FOR(J1=ABEG;J1<ANEND;J1=J1+ASTEP)#     Loop over new atoms              MN00 511
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 MN00 512
ST=QX(J1+1)+SP(1)#                     Translate new mol.               MN00 513
TT=QX(J1+2)+SP(2)#                     Translate new mol.               MN00 514
UT=QX(J1+3)+SP(3)#                     Translate new mol.               MN00 515
FOR(J4=ASTART;J4<ANEND;J4=J4+ASTEP)#   New atom pos. already stored ?   MN00 516
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 MN00 517
ifne:(ST,QX(J4+1),.001) NEXT#          Skip if x different              MN00 518
ifne:(TT,QX(J4+2),.001) NEXT#          Skip if y different              MN00 519
ifeq:(UT,QX(J4+3),.001) BREAK#         Break if pos. equiv.             MN00 520
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 MN00 521
IF(J4<ANEND) NEXT#                     If atom already stored           MN00 522
NBACK=0#                               Keep new mol.                    MN00 523
IF(J5!=J1) incrqx:(AEND,AEND+ASTEP,MN0050)# Incr. qx to store new a     MN00 524
QX(J5+1)=ST#                           Frac. pos. x                     MN00 525
QX(J5+2)=TT#                                                            MN00 526
QX(J5+3)=UT#                                                            MN00 527
QX(J5+4)=QX(J1+4)#                     Bond radius                      MN00 528
movereal:(QX,J1+9+MXBC,QX,J5+9+MXBC,6,1)# New atom name                 MN00 529
J5=J5+ASTEP#                                                            MN00 530
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 MN00 531
IF(NBACK==1) AEND=ABEG#                Set endlist back                 MN00 532
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 MN00 533
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 MN00 534
#                                                                       MN00 535
#         CALCULATE INITIAL BONDINGS                                    MN00 536
#         --------------------------                                    MN00 537
#                                                                       MN00 538
J=NCORN+1#                             Set pointer                      MN00 539
FOR(J1=ASTART;J1<AEND;J1=J1+ASTEP)#    Loop over stored atoms           MN00 540
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 MN00 541
BNR1=QX(J1+4)#                         Get origin atom radius           MN00 542
QX(J1+8)=0.#                           Zero bond count                  MN00 543
FOR(J2=ASTART;J2<AEND;J2=J2+ASTEP)#    Loop over stored atoms           MN00 544
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 MN00 545
IF(J1==J2) NEXT#                       Skip if same atom                MN00 546
U=QX(J2+1)-QX(J1+1)#                   Calc. x diff.                    MN00 547
V=QX(J2+2)-QX(J1+2)#                   Calc. y diff.                    MN00 548
W=QX(J2+3)-QX(J1+3)#                   Calc. z diff.                    MN00 549
D=SQRT(G1*U*U+G2*V*V+G3*W*W+G4*U*V+G5*U*W+G6*V*W)# Get distance         MN00 550
IF(D>BNR1+QX(J2+4)) NEXT#              Atoms are bonded                 MN00 551
I=NINT(QX(J1+8))+1#                    Get current bond count           MN00 552
IF(I>MXBC)#                            Bond max exceeded                MN00 553
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 MN00 554
movertoc:(QX(J1+9+MXBC),1,BCEXC,31,24,0)# Get atomic label              MN00 555
writeline:(1,BCEXC,NBCEXC,3,3)#        Write line out                   MN00 556
NEXT#                                                                   MN00 557
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 MN00 558
QX(J1+8)  =FLOAT(I)#                   Increse no. of bondings          MN00 559
QX(J1+8+I)=FLOAT(((J2-ASTART)/ASTEP)+J)# Sequ. no of connected atom     MN00 560
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 MN00 561
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 MN00 562
#                                                                       MN00 563
#              CUT CELL CORNERS                                         MN00 564
#              -----------------                                        MN00 565
#                                                                       MN00 566
IF(NCUT>0&NCELL>0)#                    Cut on cell corners if unit ce   MN00 567
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 MN00 568
FOR(J1=ASTART;J1<AEND;J1=J1+ASTEP)#    Loop over all atoms              MN00 569
DO I=1,3#                              Loop over x,y,z                  MN00 570
IF(QX(J1+I)<0.\QX(J1+I)>1.)#           Pos. outside the cell            MN00 571
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 MN00 572
QX(J1+4)=-QX(J1+4)#                    Set flags if outside cell        MN00 573
QX(J1+8)=-QX(J1+8)#                    Set flags if outside cell        MN00 574
BREAK#                                 Once is enough                   MN00 575
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 MN00 576
#                                                                       MN00 577
FOR(J1=ASTART;J1<AEND;J1=J1+ASTEP)#    Loop over all atoms              MN00 578
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 MN00 579
K=NINT(ABS(QX(J1+8)))#                 No of bondings                   MN00 580
IF(QX(J1+4)<0.&QX(J1+8)<0.)#           Pos. outside unit cell           MN00 581
DO I=1,K#                              Loop over bondings               MN00 582
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 MN00 583
J3=ASTART+(NINT(QX(J1+8+I))-J)*ASTEP#  Get addr of bonded atom          MN00 584
IF(QX(J3+4)>0.) QX(J1+8)=ABS(QX(J1+8))# Bonded to atom inside cell      MN00 585
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 MN00 586
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 MN00 587
#                                                                       MN00 588
FOR(J1=ASTART;J1<AEND;J1=J1+ASTEP)#    Loop over all atoms              MN00 589
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 MN00 590
IF(QX(J1+4)<0.) QX(J1+4)=ABS(QX(J1+4))# Flag no longer necessary        MN00 591
IF(QX(J1+8)<0.)#                       Atom will not be drawn           MN00 592
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 MN00 593
I=AEND-(J1+ASTEP)#                     No. of array elem. to move       MN00 594
movereal:(QX,J1+ASTEP,QX,J1,I,1)#      Move atom inf. astep left        MN00 595
AEND=AEND-ASTEP#                       Decrement aend by one atom inf   MN00 596
J1  =J1-ASTEP#                         Decrement j1 by astep            MN00 597
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 MN00 598
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 MN00 599
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 MN00 600
#                                                                       MN00 601
#         CALCULATE BONDINGS AGAIN                                      MN00 602
#         ------------------------                                      MN00 603
#                                                                       MN00 604
J=NCORN+1#                             Set pointer                      MN00 605
FOR(J1=ASTART;J1<AEND;J1=J1+ASTEP)#    Loop over stored atoms           MN00 606
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 MN00 607
BNR1=QX(J1+4)#                         Get origin atom radius           MN00 608
QX(J1+8)=0.#                           Zero bond count                  MN00 609
FOR(J2=ASTART;J2<AEND;J2=J2+ASTEP)#    Loop over stored atoms           MN00 610
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 MN00 611
IF(J1==J2) NEXT#                       Skip if same atom                MN00 612
U=QX(J2+1)-QX(J1+1)#                   Calc. x diff.                    MN00 613
V=QX(J2+2)-QX(J1+2)#                   Calc. y diff.                    MN00 614
W=QX(J2+3)-QX(J1+3)#                   Calc. z diff.                    MN00 615
D=SQRT(G1*U*U+G2*V*V+G3*W*W+G4*U*V+G5*U*W+G6*V*W)# Get distance         MN00 616
IF(D>BNR1+QX(J2+4)) NEXT#              Atoms are bonded                 MN00 617
I=NINT(QX(J1+8))+1#                    Get current bond count           MN00 618
IF(I>MXBC)#                            Bond max exceeded                MN00 619
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 MN00 620
movertoc:(QX(J1+9+MXBC),1,BCEXC,31,24,0)# Get atomic label              MN00 621
writeline:(1,BCEXC,NBCEXC,3,3)#        Write line out                   MN00 622
NEXT#                                                                   MN00 623
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 MN00 624
QX(J1+8)  =FLOAT(I)#                   Increse no. of bondings          MN00 625
QX(J1+8+I)=FLOAT(((J2-ASTART)/ASTEP)+J)# Sequ. no of connected atom     MN00 626
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 MN00 627
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 MN00 628
#                                                                       MN00 629
#              WRITE OUTPUT FILE                                        MN00 630
#              -----------------                                        MN00 631
#                                                                       MN00 632
NOA=(AEND-ASTART)/ASTEP#               No. of stored atoms              MN00 633
FNOA=FLOAT(NOA)+FLOAT(NCORN)#          Atoms plus cell corners          MN00 634
CHRIN(1^80)=' '#                       Clear chrin array                MN00 635
movechar:(ABCLN,1,CHRIN,1,NABCLN,0)#   Fill text into chrin             MN00 636
ncodefld:(CELL,1,CHRIN,FABC,3)#        Fill a,b,c into chrin            MN00 637
writepch:(CHRIN,80)#                   Punch 1th line (a,b,c)           MN00 638
#                                                                       MN00 639
CHRIN(1^80)=' '#                       Clear chrin array                MN00 640
movechar:(ARCLN,1,CHRIN,1,NARCLN,0)#   Fill text into chrin             MN00 641
ncodefld:(CELL,4,CHRIN,FARC,3)#        Fill al,be,ga into chrin         MN00 642
writepch:(CHRIN,80)#                   Punch 2nd line (al,be,ga)        MN00 643
#                                                                       MN00 644
CHRIN(1^80)=' '#                       Clear chrin array                MN00 645
ncodefld:(FNOA,1,CHRIN,40403.,1)#      Fill noa into chrin              MN00 646
movechar:(NALN,1,CHRIN,5,NNALN,0)#     Fill text into chrin             MN00 647
writepch:(CHRIN,80)#                   Punch 3rd line (no. of atoms)    MN00 648
#                                                                       MN00 649
CHRIN(1^80)=' '#                       Clear chrin array                MN00 650
writepch:(CHRIN,80)#                   Punch blank line                 MN00 651
#                                                                       MN00 652
IF(NCORN==8)#                                                           MN00 653
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 MN00 654
movechar:(PNT0,1,CHRIN,1,NPNT0,0)#     Fill text into chrin             MN00 655
writepch:(CHRIN,80)#                   Punch point 0                    MN00 656
movechar:(PNTA,1,CHRIN,1,NPNTA,0)#     Fill text into chrin             MN00 657
writepch:(CHRIN,80)#                   Punch point a                    MN00 658
movechar:(PNTB,1,CHRIN,1,NPNTB,0)#     Fill text into chrin             MN00 659
writepch:(CHRIN,80)#                   Punch point b                    MN00 660
movechar:(PNTC,1,CHRIN,1,NPNTC,0)#     Fill text into chrin             MN00 661
writepch:(CHRIN,80)#                   Punch point c                    MN00 662
movechar:(PNT5,1,CHRIN,1,NPNT5,0)#     Fill text into chrin             MN00 663
writepch:(CHRIN,80)#                   Punch point                      MN00 664
movechar:(PNT6,1,CHRIN,1,NPNT6,0)#     Fill text into chrin             MN00 665
writepch:(CHRIN,80)#                   Punch point                      MN00 666
movechar:(PNT7,1,CHRIN,1,NPNT7,0)#     Fill text into chrin             MN00 667
writepch:(CHRIN,80)#                   Punch point                      MN00 668
movechar:(PNT8,1,CHRIN,1,NPNT8,0)#     Fill text into chrin             MN00 669
writepch:(CHRIN,80)#                   Punch point                      MN00 670
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 MN00 671
CNT=FLOAT(NCORN)#                      Start the pkt count              MN00 672
FOR(J1=ASTART;J1<AEND;J1=J1+ASTEP)#    Loop over all atoms              MN00 673
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 MN00 674
CNT=CNT+1.#                            Incr the atom counter            MN00 675
N=NINT(ABS(QX(J1+8)))#                                                  MN00 676
CHRIN(1^80)=' '#                       Clear chrin array                MN00 677
ncodefld:(CNT,1,CHRIN,40403.,1)#       Seq. no. of atom                 MN00 678
movertoc:(QX(J1+9+MXBC),1,CHRIN,6,4,0)# Atomic name                     MN00 679
ncodefld:(QX,J1+1,CHRIN,FXYZ,3)#       Fractional positions             MN00 680
ncodefld:(QX,J1+9,CHRIN,FCON,N)#       Bond information                 MN00 681
writepch:(CHRIN,80)#                   Punch the atomic data            MN00 682
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 MN00 683
#                                                                       MN00 684
RETURN#                                                                 MN00 685
END#                                                                    MN00 686
pmacro:([no:])#                                                         MN00 687
