systemheader:(MO    )#                                                  MO     1
#####################################################################   MO     2
##                                                                   #  MO     3
##                     ***  MERGOB  ***                              #  MO     4
##                                                                   #  MO     5
##  Merge two bdf's containing coefficients with different scale     #  MO     6
##  groups  i.e. multiple observation data                           #  MO     7
##                                                                   #  MO     8
#####################################################################   MO     9
#                                                                       MO    10
include:(XMACRO)#                                                       MO    11
#                                                                       MO    12
systemheader:(MO00)#                   Merge multiple obs data          MO00   1
# ################################################################## #  MO00   2
#                                                                    #  MO00   3
#                               MO00                                 #  MO00   4
#                                                                    #  MO00   5
# ################################################################## #  MO00   6
SUBROUTINE MO00#                       May 1980  r.a. alden             MO00   7
include:(AACOMN)#                      Jan 1983  r.a. alden             MO00   8
#                                      Mar 1991  s.r. hall              MO00   9
INTEGER I,J,K#                                                          MO00  10
INTEGER IPT1,IPT3,JPT#                                                  MO00  11
INTEGER KEY(4)#                                                         MO00  12
INTEGER IWNT(11)#                                                       MO00  13
INTEGER REL1(12),REL3(12)#                                              MO00  14
INTEGER DIR1(500),DIR3(500)#                                            MO00  15
INTEGER NSC2,NSCL#                                                      MO00  16
INTEGER PSIZ1,PSIZ2,PSIZ3#                                              MO00  17
REAL    SCALE(100),GROUP(100)#                                          MO00  18
REAL    MAXGRP#                                                         MO00  19
#                                                                       MO00  20
chardata:(MO11,INT FSQ FRE )#                                           MO00  21
chardata:(MO12,' Merge coefficient is              INTENSITY ')#        MO00  22
chardata:(MO13,INTENSITY FSQUARED  FREL      )#                         MO00  23
chardata:(MO14, LABEL  END    )#                                        MO00  24
chardata:(MO15," Max hkl and min/max sint/lambda                $#      MO00  25
                     ")#                                                MO00  26
chardata:(MO16,' Scale groups on .MER offset by               ')#       MO00  27
chardata:(MO17," **** WARNING  coefficient INTENSITY changed to $#      MO00  28
INTENSITY ")#                                                           MO00  29
chardata:(MO18,' Scales and groups in output bdf')#                     MO00  30
chardata:(MO19,' Number of reflections from file .xxx          ')#      MO00  31
realdata:(FMT,[400513.,450513.,500513.,560532.,630632.])#               MO00  32
datastuff:#                                                             MO00  33
#                                                                       MO00  34
#      DEFINE INPUT BUFFERS                                             MO00  35
#      --------------------                                             MO00  36
#                                                                       MO00  37
FILEXT(IOUNIT(3))='MER'#               Ext of second merge bdf          MO00  38
IOMARK(1)=QXSTR#                       Primary input bdf a              MO00  39
IOMARK(2)=IOMARK(1)+bdfbuf:#           Output bdf b                     MO00  40
IOMARK(3)=IOMARK(2)+bdfbuf:#           Secondary input bdf .mer         MO00  41
incrqx:(I,IOMARK(3)+bdfbuf:,MO0001)#   Shift number table               MO00  42
copyfile:(1,2,1,1)#                    Update the history record        MO00  43
readwpkt:(3,1,PSIZ3,IPT3,0)#           Read mer bdf                     MO00  44
#                                                                       MO00  45
ICOEF=0#                               Default coeff is intensity       MO00  46
DATSET=1.#                             Default data set number          MO00  47
DO I=1,100; SCALE(I)=-10000.#          Set absurd scales                MO00  48
DO I=1,100; GROUP(I)=FLOAT(I)#         Set default groups               MO00  49
#                                                                       MO00  50
#   ENTER MERGOB CONTROLS                                               MO00  51
#   ---------------------                                               MO00  52
#                                                                       MO00  53
DO I=1,10#                             Loop over controls               MO00  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MO00  55
ifvo:(BUFIN(I)) BREAK#                 Exit when null field             MO00  56
ifnm:(BUFIN(I)) DATSET=BUFIN(I)#       Extract data set                 MO00  57
ELSE#                                  This is coeff string             MO00  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MO00  59
stringlim:(I,J,K)#                     Get string limits                MO00  60
compchar:(CHRIN,J,MO11,1,3,4,NMO11,K)# Match with option                MO00  61
IF(K==1) ICOEF=0#                      Coefficient is intensity         MO00  62
IF(K==2) ICOEF=2#                      Coefficient is f(squared)        MO00  63
IF(K==3) ICOEF=4#                      Coefficient is frel              MO00  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MO00  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MO00  66
movechar:(MO13,ICOEF*5+1,MO12,36,10,0)# Insert merge coeff              MO00  67
writeline:(2,MO12,NMO12,3,3)#          Print merge coeff                MO00  68
#                                                                       MO00  69
#   ENTER AND ADD LABEL LINES TO BDF                                    MO00  70
#   --------------------------------                                    MO00  71
#                                                                       MO00  72
REPEAT#                                Loop over bdf a labels           MO00  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MO00  74
readwpkt:(1,lrlabl:,PSIZ1,IPT1,0)#     Read bdf a                       MO00  75
IF(IPT1<=0)  BREAK#                    Exit when finished               MO00  76
writepkt:(2,lrlabl:,PSIZ1,JPT)#        Point to bdf b                   MO00  77
movereal:(QX,IPT1+1,QX,JPT+1,PSIZ1,1)# Transfer label                   MO00  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MO00  79
#                                                                       MO00  80
REPEAT#                                Loop over .mer labels            MO00  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MO00  82
readwpkt:(3,lrlabl:,PSIZ3,IPT3,0)#     Read mer bdf                     MO00  83
IF(IPT3 <=0)  BREAK#                   Exit when finished               MO00  84
writepkt:(2,lrlabl:,PSIZ1,JPT)#        Point to bdf b                   MO00  85
movereal:(QX,IPT3+1,QX,JPT+1,PSIZ1,1)# Transfer label                   MO00  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MO00  87
#                                                                       MO00  88
REPEAT#                                Loop over label lines            MO00  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MO00  90
readline:(MO014,NMO014)#               Read a new line                  MO00  91
IF(LINID!=1) BREAK#                    Exit on end                      MO00  92
writepkt:(2,lrlabl:,NCHAR,JPT)#        Put them on the file             MO00  93
movector:(BLANK,1,QX(JPT+1),1,80,1)#   Blank label record               MO00  94
movector:(CHRIP,1,QX(JPT+1),1,CHRMAX,0)# Transfer label                 MO00  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MO00  96
#                                                                       MO00  97
#     PROCESS SYMMETRY RECORD                                           MO00  98
#     -----------------------                                           MO00  99
#                                                                       MO00 100
copyfile:(1,2,incr:(lrlabl:),decr:(lrsymm:))# Copy to symmetry          MO00 101
REPEAT#                                Loop over symmetry packets       MO00 102
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MO00 103
readwpkt:(1,lrsymm:,PSIZ1,IPT1,0)#     Read and copy lr lrsymm:         MO00 104
IF(IPT1<=0) BREAK#                     Exit when finished               MO00 105
readwpkt:(3,lrsymm:,PSIZ3,IPT3,0)#     (symmetry info).                 MO00 106
writepkt:(2,lrsymm:,PSIZ1,JPT)#        Point to op packet               MO00 107
movereal:(QX,IPT1+1,QX,JPT+1,PSIZ1,1)# Transfer symmetry data           MO00 108
DO I=1,PSIZ1#                          Make sure both bdfs agree        MO00 109
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MO00 110
IPT1=IPT1+1; IPT3=IPT3+1#              Incr pointers                    MO00 111
ifne:(QX(IPT1),QX(IPT3))  iquit:(MO0104)# Test if identical             MO00 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MO00 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MO00 114
#                                                                       MO00 115
#   PREPARE NEW LREXPL: DIRECTORY                                       MO00 116
#   -----------------------------                                       MO00 117
#                                                                       MO00 118
copyfile:(1,2,incr:(lrsymm:),decr:(lrexpl:))# Copy to expl              MO00 119
IWNT(1)=1; IWNT(2)=100#                Get sort order and scale numbe   MO00 120
KEY(1)=2; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search keys                 MO00 121
indexpkt:(1,lrexpl:,PSIZ1,IPT1,0,KEY,IWNT,REL1)# Get pointers           MO00 122
DO I=1,PSIZ1; DIR1(I)=NINT(QX(IPT1+I))# Store directory                 MO00 123
KEY(1)=2; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search keys                 MO00 124
indexpkt:(3,lrexpl:,PSIZ3,IPT3,0,KEY,IWNT,REL3)# Get pointers           MO00 125
DO I=1,PSIZ3; DIR3(I)=NINT(QX(IPT3+I))# Store directory                 MO00 126
#                                                                       MO00 127
N1=0; M1=0; N3=0; M3=0#                Count of possible scale groups   MO00 128
DO I=1,PSIZ1#                          Primary bdf                      MO00 129
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MO00 130
IF(QX(IPT1+I)>100.&QX(IPT1+I)<200.) M1=M1+1# Count scales               MO00 131
IF(QX(IPT1+I)>200.&QX(IPT1+I)<300.) N1=N1+1# Count scale groups         MO00 132
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MO00 133
DO I=1,PSIZ3#                          Secondary bdf                    MO00 134
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MO00 135
IF(QX(IPT3+I)>100.&QX(IPT3+I)<200.) M3=M3+1# Count scales               MO00 136
IF(QX(IPT3+I)>200.&QX(IPT3+I)<300.) N3=N3+1# Count scale groups         MO00 137
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MO00 138
NSC2=MAX(N1,M1)+MAX(N3,M3)#            Get max total scale groups       MO00 139
IF(NSC2>64 )  iquit:(MO0008)#          Appear on the output bdf         MO00 140
PSIZ2=PSIZ1-N1-M1+2*NSC2#              Get op packet size               MO00 141
###write(6,'(8i4)') n1,m1,n3,m3,nsc2,psiz1,psiz2###################     MO00 142
#                                                                       MO00 143
writepkt:(2,lrexpl:,PSIZ2,JPT)#        Make a directory packet          MO00 144
J=0#                                   Zero op packet counter           MO00 145
DO I=1,PSIZ1#                          Primary bdf                      MO00 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MO00 147
IF(QX(IPT1+I)>99.&QX(IPT1+I)<300.) NEXT# Skip if scale idn              MO00 148
J=J+1;  QX(JPT+J)=QX(IPT1+I)#          Transfer idnum                   MO00 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MO00 150
J=J+1#                                 Incr op packet counter           MO00 151
QX(JPT+J)=100.#                        Set scale count idn              MO00 152
DO I=1,NSC2; QX(JPT+I+J)=FLOAT(100+I)# Set scale idnums                 MO00 153
J=J+NSC2#                              Incr op packet counter           MO00 154
DO I=1,NSC2; QX(JPT+I+J)=FLOAT(200+I)# Set scale group idnums           MO00 155
#                                                                       MO00 156
REPEAT#                                Loop over .mer lrexpl packets    MO00 157
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MO00 158
readwpkt:(3,lrexpl:,PSIZ3,IPT3,0)#     Read secondary bdf               MO00 159
IF(IPT3<=0) iquit:(MO0005)#            Data set not found               MO00 160
ifeq:(QX(IPT3+REL3(1)),DATSET) BREAK#  Exit if needed data set          MO00 161
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MO00 162
#                                                                       MO00 163
REPEAT#                                Loop over lrexpl packets         MO00 164
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MO00 165
readwpkt:(1,lrexpl:,PSIZ1,IPT1,0)#     Read primary bdf                 MO00 166
IF(IPT1<=0) iquit:(MO0006)#            Data set not found               MO00 167
ifne:(QX(IPT1+REL1(1)),DATSET) NEXT#   Skip if unneeded data set        MO00 168
#                                                                       MO00 169
writepkt:(2,lrexpl:,PSIZ2,JPT)#        Point to op packet               MO00 170
J=0#                                   Zero op packet counter           MO00 171
DO I=1,PSIZ1#                          Primary bdf                      MO00 172
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MO00 173
IF(DIR1(I)>100&DIR1(I)<300)#           If scale idn                     MO00 174
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MO00 175
K=DIR1(I)-100#                         Count the scale                  MO00 176
IF(DIR1(I)<200) SCALE(K)=QX(IPT1+I)#   Store the scale                  MO00 177
ELSE            GROUP(K-100)=QX(IPT1+I)# Store the group number         MO00 178
###write(6,'(4i5,2f10.4)') i,j,k,dir1(i),scale(k),group(k)############# MO00 179
NEXT#                                  Skip to next word                MO00 180
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MO00 181
IF(DIR1(I)==100) NEXT#                 Skip number of scales            MO00 182
J=J+1;  QX(JPT+J)=QX(IPT1+I)#          Transfer idnum                   MO00 183
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MO00 184
MAXGRP=1.;  NSCL=1#                    Set max group number             MO00 185
DO I=1,100; IF(SCALE(I)>0.) NSCL=I#    Get number of scales             MO00 186
DO I=1,NSCL; MAXGRP=MAX(MAXGRP,GROUP(I))# Get max group                 MO00 187
###write(6,'(5i5)') psiz1,nscl,nsc2,mscl#################               MO00 188
ncodefld:(MAXGRP,1,MO16,400513.,1)#    Format scl grp offset            MO00 189
writeline:(1,MO16,NMO16,3,3)#          Print scale grp offset           MO00 190
#                                                                       MO00 191
DO I=1,PSIZ3#                          Secondary bdf                    MO00 192
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MO00 193
IF(DIR3(I)<101\DIR3(I)>299) NEXT#      If scale idn                     MO00 194
K=DIR3(I)-100+NSCL#                    Count the scale                  MO00 195
IF(DIR3(I)<200) SCALE(K)=QX(IPT3+I)#   Store the scale                  MO00 196
ELSE            GROUP(K-100)=QX(IPT3+I)+MAXGRP# Store group number      MO00 197
###write(6,'(4i5,2f10.4)') i,j,k,dir3(i),scale(k),group(k)############# MO00 198
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MO00 199
DO I=1,100; IF(SCALE(I)>0.) MSCL=I#    Get number of scales             MO00 200
###write(6,'(4i5,f10.2)') psiz1,nscl,nsc2,mscl,maxgrp#################  MO00 201
QX(JPT+J+1)=FLOAT(MSCL)#               Store number of scales           MO00 202
J=J+1#                                 Incr op pointer                  MO00 203
DO I=1,MSCL; QX(JPT+J+I)=SCALE(I)#     Store scales                     MO00 204
J=J+NSC2#                              Incr op pointer                  MO00 205
DO I=1,MSCL; QX(JPT+J+I)=GROUP(I)#     Store scale groups               MO00 206
BREAK#                                 Exit when written                MO00 207
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MO00 208
writeline:(1,MO18,NMO18,3,3)#          Output header                    MO00 209
DO I=1,MSCL#                           Loop over all scales             MO00 210
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MO00 211
ncodefld:(SCALE,I,CHROT,450842.,1)#    Format scale                     MO00 212
ncodefld:(GROUP,I,CHROT,500413.,1)#    Format scale group               MO00 213
writeline:(0,0,0,1,3)#                 Print scales                     MO00 214
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MO00 215
copyfile:(1,2,incr:(lrexpl:),decr:(lrdset:))# Copy to lrdset:           MO00 216
#                                                                       MO00 217
#    PROCESS LRDSET: RECORDS                                            MO00 218
#    -----------------------                                            MO00 219
#                                                                       MO00 220
IWNT(1)=1#                             Get data set number              MO00 221
DO I=1,5; IWNT(I+1)=FLOAT(I+10)#       Get max hkl min/max s            MO00 222
KEY(1)=6; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search keys                 MO00 223
indexpkt:(1,lrdset:,PSIZ1,IPT1,0,KEY,IWNT,REL1)# Get primary pointers   MO00 224
KEY(1)=6; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search keys                 MO00 225
indexpkt:(3,lrdset:,PSIZ3,IPT3,0,KEY,IWNT,REL3)# Get secondary pointe   MO00 226
writepkt:(2,lrdset:,PSIZ1,JPT)#        Point to op directory            MO00 227
movereal:(QX,IPT1+1,QX,JPT+1,PSIZ1,1)# Copy the directory               MO00 228
#                                                                       MO00 229
REPEAT#                                Loop over .mer lrdset packets    MO00 230
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MO00 231
readwpkt:(3,lrdset:,PSIZ3,IPT3,0)#     Read secondary bdf               MO00 232
IF(IPT3<=0) iquit:(MO0010)#            Data set not found               MO00 233
ifeq:(QX(IPT3+REL3(1)),DATSET) BREAK#  Exit if needed data set          MO00 234
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MO00 235
#                                                                       MO00 236
REPEAT#                                Loop over lrdset packets         MO00 237
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MO00 238
readwpkt:(1,lrdset:,PSIZ1,IPT1,0)#     Read the next packet of          MO00 239
IF(IPT1<=0) iquit:(MO0011)#            Quit if data set not found       MO00 240
ifeq:(QX(IPT1+REL1(1)),DATSET) BREAK#  Skip if unneeded data set        MO00 241
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MO00 242
writepkt:(2,lrdset:,PSIZ1,JPT)#        Point to output packet           MO00 243
movereal:(QX,IPT1+1,QX,JPT+1,PSIZ1,1)# Move to output                   MO00 244
BUFOT(1)=MAX(QX(IPT1+REL1(2)),QX(IPT3+REL3(2)))# Max h                  MO00 245
BUFOT(2)=MAX(QX(IPT1+REL1(3)),QX(IPT3+REL3(3)))# Max k                  MO00 246
BUFOT(3)=MAX(QX(IPT1+REL1(4)),QX(IPT3+REL3(4)))# Max l                  MO00 247
BUFOT(4)=MIN(QX(IPT1+REL1(5)),QX(IPT3+REL3(5)))# Min s                  MO00 248
BUFOT(5)=MAX(QX(IPT1+REL1(6)),QX(IPT3+REL3(6)))# Max s                  MO00 249
DO I=1,5; QX(JPT+REL1(I+1))=BUFOT(I)#  Store op values                  MO00 250
copyfile:(1,2,incr:(lrdset:),decr:(lrrefl:))#                           MO00 251
#                                                                       MO00 252
#    PROCESS REFLECTION DATA                                            MO00 253
#    -----------------------                                            MO00 254
#                                                                       MO00 255
DO I=1,3; IWNT(I)=I#                   Get hkl, s, packed sym           MO00 256
DO I=1,6; IWNT(I+3)=1299+I#            Get possible coefficients        MO00 257
IWNT(10)=1308;  IWNT(11)=1309#         Get rcode & scale group          MO00 258
KEY(1)=3; KEY(2)=11; KEY(3)=0; KEY(4)=0# Set search keys                MO00 259
indexpkt:(1,lrrefl:,PSIZ1,IPT1,0,KEY,IWNT,REL1)# Get primary pointers   MO00 260
KEY(1)=3; KEY(2)=11; KEY(3)=0; KEY(4)=0# Set search keys                MO00 261
indexpkt:(3,lrrefl:,PSIZ3,IPT3,0,KEY,IWNT,REL3)# Get secondary pointe   MO00 262
IF(REL1(ICOEF+4)==0\REL3(ICOEF+4)==0)# Test if coefficients found       MO00 263
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MO00 264
DO I=0,4,2#                            Loop possible coefficients       MO00 265
IF(REL1(I+4)>0&REL3(I+4)>0) BREAK#     Test if coefficients found       MO00 266
IF(I>4) iquit:(MO0015)#                No coefficients found            MO00 267
movechar:(MO13,ICOEF*5+1,MO17,28,10,0)# Insert requested coeff          MO00 268
ICOEF=I#                               Replace with new coeff           MO00 269
movechar:(MO13,ICOEF*5+1,MO17,49,10,0)# Insert new coeff                MO00 270
writeline:(1,MO17,NMO17,3,3)#          Print warning message            MO00 271
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MO00 272
ncodefld:(BUFOT,1,MO15,FMT,5)#         Format max hkl min/max s         MO00 273
writeline:(1,MO15,NMO15,3,3)#          Print hkl limits                 MO00 274
#                                                                       MO00 275
PSIZ2=7; writepkt:(2,lrrefl:,PSIZ2,JPT)# Point to op directory          MO00 276
DO I=1,3; QX(JPT+I)=FLOAT(I)#          Idn's for hkl, s, pack           MO00 277
QX(JPT+4)=FLOAT(1300+ICOEF)#           Idn for coeff                    MO00 278
QX(JPT+5)=FLOAT(1301+ICOEF)#           Idn for coeff sigma              MO00 279
QX(JPT+6)=1308.#                       Idn for rcode                    MO00 280
QX(JPT+7)=1309.#                       Idn for scale group              MO00 281
REL1(4)=REL1(ICOEF+4);  REL3(4)=REL3(ICOEF+4)# Overstore pointers       MO00 282
REL1(5)=REL1(ICOEF+5);  REL3(5)=REL3(ICOEF+5)# Overstore pointers       MO00 283
REL1(6)=REL1(10);       REL3(6)=REL3(10)# Overstore pointers            MO00 284
#                                                                       MO00 285
J=0#                                   Reset reflection count           MO00 286
REPEAT#                                Loop over refln packets          MO00 287
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MO00 288
readwpkt:(1,lrrefl:,PSIZ1,IPT1,0)#     Read the next packet of          MO00 289
IF(IPT1<=0) BREAK#                     Exit when all finished           MO00 290
J=J+1#                                 Count reflections                MO00 291
writepkt:(2,lrrefl:,PSIZ2,JPT)#        Point to op directory            MO00 292
DO I=1,6; QX(JPT+I)=QX(IPT1+REL1(I))#  Transfer items                   MO00 293
IF(REL1(11)==0) QX(JPT+7)=1.#          Store default scale group        MO00 294
ELSE            QX(JPT+7)=QX(IPT1+REL1(11))# Get scale group            MO00 295
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MO00 296
ncodefld:(FLOAT(J),1,MO19,450613.,1)#  Format reflection count          MO00 297
movechar:(FILEXT(IOUNIT(1)),1,MO19,35,3,0)# Store file extension        MO00 298
writeline:(1,MO19,NMO19,3,3)#          Print relection count            MO00 299
#                                                                       MO00 300
J=0#                                   Reset reflection count           MO00 301
REPEAT#                                Loop over refln packets          MO00 302
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MO00 303
readwpkt:(3,lrrefl:,PSIZ3,IPT3,0)#     Read the next packet of          MO00 304
IF(IPT3<=0) BREAK#                     Exit when all finished           MO00 305
writepkt:(2,lrrefl:,PSIZ2,JPT)#        Point to op directory            MO00 306
J=J+1#                                 Count reflections                MO00 307
DO I=1,6; QX(JPT+I)=QX(IPT3+REL3(I))#  Transfer items                   MO00 308
IF(REL3(11)==0) QX(JPT+7)=FLOAT(NSCL+1)# Store default scale group      MO00 309
ELSE            QX(JPT+7)=FLOAT(NSCL)+QX(IPT3+REL3(11))# Scale group    MO00 310
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MO00 311
ncodefld:(FLOAT(J),1,MO19,450613.,1)#  Format reflection count          MO00 312
movechar:(FILEXT(IOUNIT(3)),1,MO19,35,3,0)# Store file extension        MO00 313
writeline:(0,MO19,NMO19,3,3)#          Print relection count            MO00 314
#                                                                       MO00 315
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Finish off a & b              MO00 316
readwpkt:(3,endrecord:,PSIZ3,IPT3,0)#  Finish off c                     MO00 317
#                                                                       MO00 318
RETURN#                                                                 MO00 319
END#                                                                    MO00 320
pmacro:([no:])#                                                         MO00 321
