systemheader:(MP    )#                                                  MP     1
#################################################################       MP     2
##      Copyright (C) 2000, The Xtal System, The University of        # MP     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # MP     4
## Distributed under the GNU General Public Licence as published by   # MP     5
## the Free Software Foundation, in the hope that it will be useful   # MP     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # MP     7
## for more details.                                                  # MP     8
##                                                              #       MP     9
##                   *** MAPLST ***                             #       MP    10
##                                                              #       MP    11
##    MAPLST inputs/outputs an ascii file containing electron   #       MP    12
##    density information.  The resulting output file is        #       MP    13
##    suitable for input to programs such as 'Mathematica'.     #       MP    14
##                                                              #       MP    15
#################################################################       MP    16
#                                                                       MP    17
include:(XMACRO)#                                                       MP    18
#                                                                       MP    19
systemheader:(MP00)#                                                    MP00   1
#################################################################       MP00   2
##                                                              #       MP00   3
##                            MP00                              #       MP00   4
##                                                              #       MP00   5
#################################################################       MP00   6
SUBROUTINE MP00#                       J. hester jun 1994               MP00   7
#                                                                       MP00   8
include:(AACOMN)#                                                       MP00   9
INTEGER PSIZE,IP,K,I,J,JJ,L,LL,M#      Integer m#                       MP00  10
INTEGER NLINES#                        Number of lines in section       MP00  11
INTEGER ROWSZE#                        Number of points in row          MP00  12
INTEGER NSECTS#                        Number of sections               MP00  13
INTEGER NCHR#                          Buffer pointer                   MP00  14
INTEGER INPFLG#                        Input/output flag                MP00  15
INTEGER FULL#                          Full format information input    MP00  16
INTEGER ORGX(3),INCX(3),NG(3)#         Format information               MP00  17
INTEGER IPROP,PTYPE#                   Type of information              MP00  18
string:(MBUF,80)#                      Output buffer                    MP00  19
string:(STRG,9)#                       Formatted value                  MP00  20
string:(IFMT,10)#                      Input number format              MP00  21
intdata:(NSTR,9)#                      Length of output number          MP00  22
realdata:(FMT,90952.)#                 Format of output number          MP00  23
chardata:(MP01,FILE ASCI ASCO FULL )#  Control options                  MP00  24
chardata:(MP02, END)#                  End line                         MP00  25
chardata:(MP003,'WARNING: xxxxxxx values expected, yyyyyyy written')#   MP00  26
datastuff:#                                                             MP00  27
#                                                                       MP00  28
##               SET DEFAULTS                                           MP00  29
##               ------------                                           MP00  30
#                                                                       MP00  31
FILEXT(IOUNIT(3))='MAP'#               Default input file extension     MP00  32
FILEXT(iofm1:)   ='ASC'#               Ascii file extension             MP00  33
INPFLG           =no:#                 Output by default                MP00  34
IFMT             ='(8F9.5)'#           Default input format             MP00  35
#                                                                       MP00  36
##               READ CONTROLS                                          MP00  37
##               -------------                                          MP00  38
##                                                                      MP00  39
#                                                                       MP00  40
FOR(I=1;BUFIN(I)<voidflg:;I=I+1)#      Loop over input fields           MP00  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MP00  42
stringlim:(I,J,K)#                     Get string limits                MP00  43
compchar:(CHRIN,J,MP01,1,4,5,NMP01,K)# Identify strings                 MP00  44
IF(K==0) iquit:(MP0001)#               Unknown symbol                   MP00  45
IF(K==1)#                              File extension specified         MP00  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MP00  47
I=I+1; stringlim:(I,J,K)#              Get position of extension        MP00  48
FILEXT(IOUNIT(3))=CHRIN(J^J+2)#        Install file extension           MP00  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MP00  50
IF(K==2) INPFLG=yes:#                  Input ascii file                 MP00  51
IF(K==3) INPFLG=no:#                   Output ascii file                MP00  52
IF(K==4) FULL=yes:#                    Input/output full format info    MP00  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MP00  54
readline:(MP02,NMP02)#                 Read end line                    MP00  55
#                                                                       MP00  56
#                                                                       MP00  57
IF(INPFLG==no:)#                       Output bdf file                  MP00  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MP00  59
#                                                                       MP00  60
#                READ AND WRITE MAP                                     MP00  61
#                ------------------                                     MP00  62
#                                                                       MP00  63
IOMARK(1)=QXSTR#                       Beginning of buffer              MP00  64
incrqx:(IOMARK(3),IOMARK(1)+bdfbuf:,630101.)# Make input buffer         MP00  65
#                                                                       MP00  66
openfmt:(iofm1:,' ')#                  Open line output device          MP00  67
writefmt:(iofm1:,'(A80)',[TITLE])#     Write title as header            MP00  68
readwpkt:(3,21,PSIZE,IP,0)#            Read layout information          MP00  69
NSECTS = NINT(QX(IP+10))#              Number of sections               MP00  70
NLINES = NINT(QX(IP+11))#              Find lines in section            MP00  71
ROWSZE = NINT(QX(IP+12))#              Find length of row               MP00  72
writefmt:(iofm1:,'(3I4)',[NSECTS,NLINES,ROWSZE])#                       MP00  73
movechar:(" ",1,MBUF,1,80,1)#          Clear mbuf                       MP00  74
IF(FULL==yes:)#                        Write all format info            MP00  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MP00  76
DO I=1,3#                              Loop over components             MP00  77
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MP00  78
ORGX(I)=NINT(QX(IP+I))#                Get origin                       MP00  79
INCX(I)=NINT(QX(IP+3+I))#              Get increment                    MP00  80
NG(I)=NINT(QX(IP+6+I))#                Get number grid points           MP00  81
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MP00  82
PTYPE=QX(IP+40)#                       Get property type                MP00  83
IPROP=QX(IP+41)#                       Get number of components         MP00  84
writefmt:(iofm1:,'(3I4)',[ORGX(1),ORGX(2),ORGX(3)])# Write origin       MP00  85
writefmt:(iofm1:,'(3I4)',[INCX(1),INCX(2),INCX(3)])# Write grid incr.   MP00  86
writefmt:(iofm1:,'(3I4)',[NG(1),NG(2),NG(3)])# Write grid parameters    MP00  87
writefmt:(iofm1:,'(1I4)',[PTYPE])#     Write property information       MP00  88
writefmt:(iofm1:,'(1I4)',[IPROP])#     Write property information       MP00  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MP00  90
REPEAT#                                Read and write routine           MP00  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MP00  92
readwpkt:(3,22,PSIZE,IP,0)#            Read packet of delrho            MP00  93
IF (IP == 0) BREAK#                    End of slant file                MP00  94
#                                                                       MP00  95
DO K=1,ROWSZE#                         Read all words in packet         MP00  96
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MP00  97
ncodefld:(QX(IP+K),1,STRG,FMT,1)#      Format map value                 MP00  98
IF(NCHR+NSTR >=81)#                    Test if buffer full              MP00  99
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MP00 100
writefmt:(iofm1:,'(A80)',(MBUF))#      Write to line output device      MP00 101
NCHR = 0#                              Initialise character pointer     MP00 102
movechar:(" ",1,MBUF,1,80,1)#          Clear mbuf                       MP00 103
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MP00 104
MBUF(NCHR+1^NCHR+NSTR)=STRG(1^NSTR)#   Add the string to the buffer     MP00 105
NCHR=NCHR+NSTR#                        Incr char pointer                MP00 106
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MP00 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MP00 108
writefmt:(iofm1:,'(A80)',(MBUF))#      Flush buffer                     MP00 109
closefmt:(iofm1:)#                     Close output file                MP00 110
readwpkt:(3,endrecord:,PSIZE,IP,0)#    Close map file                   MP00 111
#                                                                       MP00 112
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MP00 113
#                                                                       MP00 114
#     ELSE READ IN ASCII -- OUTPUT BDF                                  MP00 115
#     --------------------------------                                  MP00 116
#                                                                       MP00 117
ELSE#                                  Read in ascii file               MP00 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MP00 119
IOMARK(1)=QXSTR#                       Beginning of buffer              MP00 120
incrqx:(IOMARK(3),IOMARK(1)+bdfbuf:,630101.)# Make input buffer         MP00 121
#                                                                       MP00 122
#     COPY MISCELLANEOUS BDF INFORMATION                                MP00 123
#                                                                       MP00 124
openfmt:(iofm1:,' ')#                  Open line input device           MP00 125
copyfile:(1,3,1,1)#                    Store history on output bdf      MP00 126
copyfile:(1,3,lrcell:,lrsymm:)#        Store cell, symm info on outpu   MP00 127
copyfile:(1,3,lrscat:,lrscat:)#        Store scat fac info on output    MP00 128
copyfile:(1,3,lrddef:,lrddef:)#        Store dataset names              MP00 129
copyfile:(1,3,lratom:,lratom:)#        Store atom info on output bdf    MP00 130
#                                                                       MP00 131
#     PREPARE TO USE CHRIN                                              MP00 132
#     --------------------                                              MP00 133
#                                                                       MP00 134
movechar:(CHRIN,1,MBUF,1,80,0)#        Save chrin                       MP00 135
L=CHRCOL#                              Save begin col                   MP00 136
M=CHRMAX#                              Save end column                  MP00 137
CHRCOL=1#                              Reset for line input             MP00 138
CHRMAX=80#                             All columns necessary            MP00 139
#                                                                       MP00 140
#                                                                       MP00 141
#     READ AND WRITE LAYOUT FROM INPUT ASCII FILE                       MP00 142
#     -------------------------------------------                       MP00 143
#                                                                       MP00 144
readfmt:(iofm1:,'(A80)',50,[CHRIN])#   Read and discard header          MP00 145
readfmt:(iofm1:,'(A80)',50,[CHRIN])#   Get map parameters               MP00 146
dcodefld:#                             Extract values                   MP00 147
NSECTS=NINT(BUFIN(1))#                 Store number of sections         MP00 148
NLINES=NINT(BUFIN(2))#                 Store number of sections         MP00 149
ROWSZE=NINT(BUFIN(3))#                 Store number of sections         MP00 150
PSIZE=41#                              Set initial packet size          MP00 151
writepkt:(3,21,PSIZE,IP)#              Get buffer index                 MP00 152
movereal:(BUFIN,1,QX,IP+10,3,0)#       Write to output bdf              MP00 153
#                                                                       MP00 154
IF(FULL==yes:)#                        Full format information requir   MP00 155
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MP00 156
readfmt:(iofm1:,'(A80)',50,[CHRIN])#   Get origin line                  MP00 157
dcodefld:#                             Extract values                   MP00 158
DO J=1,3;ORGX(J)=NINT(BUFIN(J))#       Save origin                      MP00 159
readfmt:(iofm1:,'(A80)',50,[CHRIN])#   Get grid increment               MP00 160
dcodefld:#                             Extract values                   MP00 161
DO J=1,3;INCX(J)=NINT(BUFIN(J))#       Save increment                   MP00 162
readfmt:(iofm1:,'(A80)',50,[CHRIN])#   Get map parameters               MP00 163
dcodefld:#                             Extract values                   MP00 164
DO J=1,3;NG(J)=NINT(BUFIN(J))#         Save parameters                  MP00 165
readfmt:(iofm1:,'(A80)',50,[CHRIN])#   Get map parameters               MP00 166
dcodefld:#                             Extract values                   MP00 167
PTYPE=BUFIN(1)#                        Save property type               MP00 168
readfmt:(iofm1:,'(A80)',50,[CHRIN])#   Get map parameters               MP00 169
dcodefld:#                             Extract values                   MP00 170
IPROP=BUFIN(1)#                        Save component                   MP00 171
DO J=1,3#                              Loop over x,y,z                  MP00 172
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MP00 173
JJ=IP+J#                               Get buffer pointer               MP00 174
QX(JJ)=FLOAT(ORGX(J))#                 Store origin                     MP00 175
QX(JJ+3)=FLOAT(INCX(J))#               Store increment                  MP00 176
QX(JJ+6)=FLOAT(NG(J))#                 Store grid                       MP00 177
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MP00 178
QX(IP+40)=FLOAT(PTYPE)#                Store property type              MP00 179
QX(IP+41)=FLOAT(IPROP)#                Store number of components       MP00 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MP00 181
ELSE#                                  Store dummy information          MP00 182
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MP00 183
DO J=1,3; QX(IP+3+J)=1.#               Dummy increment                  MP00 184
DO J=1,3; QX(IP+6+J)=100.#             Dummy grid                       MP00 185
QX(IP+41)=1#                           Assume 1 component               MP00 186
IPROP=1#                               Set for later calcs              MP00 187
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MP00 188
DO J=1,3#                              Loop over coordinates            MP00 189
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MP00 190
QX(IP+12+J)=FLOAT(J)#                  Dummy order                      MP00 191
QX(IP+15+J)=FLOAT(J)#                  Dummy order                      MP00 192
QX(IP+25+J)=1.#                        Grid interval in angstroms       MP00 193
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MP00 194
QX(IP+28)=1.;QX(IP+35)=1.;QX(IP+39)=1.# Unit transformation matrix      MP00 195
QX(IP+33)=1.#                          Dummy value                      MP00 196
#                                                                       MP00 197
#     READ AND WRITE  MAP VALUES                                        MP00 198
#     --------------------------                                        MP00 199
#                                                                       MP00 200
PSIZE=IPROP*ROWSZE#                    Set packet size                  MP00 201
JJ=0#                                  Initialise data count            MP00 202
LL=0#                                  Initialise packet pointer        MP00 203
writepkt:(3,22,PSIZE,IP)#              Prepare write buffer             MP00 204
REPEAT#                                Loop until end                   MP00 205
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MP00 206
readfmt:(iofm1:,'(A80)',50,[CHRIN])#   Read one line                    MP00 207
dcodefld:#                             Convert to numerical form        MP00 208
I=0#                                   Initialise field pointer         MP00 209
REPEAT#                                Loop over input fields           MP00 210
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MP00 211
ifvo:(BUFIN(I+1)) BREAK#               Check for value                  MP00 212
I=I+1#                                 Count values                     MP00 213
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MP00 214
JJ=JJ+I#                               Count number of values           MP00 215
IF(LL+I>PSIZE)#                        Full packet?                     MP00 216
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MP00 217
movereal:(BUFIN,1,QX,IP+LL+1,PSIZE-LL,0)# Fill up packet                MP00 218
writepkt:(3,22,PSIZE,IP)#              Get new output packet            MP00 219
movereal:(BUFIN,PSIZE-LL+1,QX,IP+1,LL+I-PSIZE,0)# Move remaining fiel   MP00 220
LL=LL+I-PSIZE#                         Update packet pointer            MP00 221
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MP00 222
ELSE#                                  Not end of packet                MP00 223
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MP00 224
movereal:(BUFIN,1,QX,IP+LL+1,I,0)#     Transfer all                     MP00 225
LL=LL+I#                               Update packet pointer            MP00 226
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MP00 227
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MP00 228
50  writepkt:(3,endrecord:,3,IP)#      Close off output bdf             MP00 229
closefmt:(iofm1:)#                     Close input ascii file           MP00 230
CHRCOL=L#                              Restore start col value          MP00 231
CHRMAX=M#                              Restore end col value            MP00 232
movechar:(MBUF,1,CHRIN,1,80,0)#        Restore chrin                    MP00 233
#                                                                       MP00 234
IF(JJ!=PSIZE*NSECTS*NLINES)#           Check for consistency            MP00 235
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MP00 236
ncodefld:(FLOAT(PSIZE*NSECTS*NLINES),1,MP003,160713.,1)# Encode expec   MP00 237
ncodefld:(FLOAT(JJ),1,MP003,410713.,1)# Encode number written           MP00 238
writeline:(2,MP003,NMP003,3,3)#        Tell user                        MP00 239
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MP00 240
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MP00 241
RETURN#                                                                 MP00 242
END#                                                                    MP00 243
pmacro:([no:])#                                                         MP00 244
