systemheader:(MR    )#                                                  MR     1
####################################################################### MR     2
#                                                                     # MR     3
#                         ** MERUN **                                 # MR     4
#                                                                     # MR     5
#   THE PROGRAM MERUN PEPARES INPUT FOR THE RUNNING A                 # MR     6
#   MAXIMUM-ENTROPY ELECTRON DENSITY REFINEMENT CALCULATION USING     # MR     7
#   MEDENS THEN SEVERAL CYCLES OF RFOURR, FOURR, MEFFIT AND A         # MR     8
#   FINAL RFOURR TO PRODUCE THE MAXIMUM ENTROPY DENSITY REFINED       # MR     9
#   PHASES.  GIVEN REQUIRED FILES, MEDENS, MEFFIT, AND FOURR          # MR    10
#   INSTRUCTIONS THE INPUT STREAM FOR DRIVING THE PROGRAMS IS         # MR    11
#   GENERATED AND SENT TO THE INPUT STREAM.                           # MR    12
#                                                                     # MR    13
#                   D. M. COLLINS & J. M. STEWART  JULY 1988          # MR    14
#                                                                     # MR    15
####################################################################### MR    16
#                                                                       MR    17
include:(XMACRO)#                                                       MR    18
#                                                                       MR    19
macro:(mrlineout:,CALL MR19($1,$2))#   Print punch a line               MR    20
#                                                                       MR    21
extrude:(MRCOMN)#                                                       MR    22
REAL AFACT## Meffit acceleration factor                                 MR    23
REAL DSFACT## Starting value for d spacing stats in RFOURR              MR    24
REAL DSSTEP## Stepping value for volume of d space in RFOURR stats      MR    25
REAL SHFACT## Medens sharpening factor                                  MR    26
INTEGER CYCLES## Number of cycles of refinement requested               MR    27
INTEGER DSTAT## Signal that statistics by regions of d space in RFOUR   MR    28
INTEGER EMAPS## Signal what kind of e.d. maps are treated               MR    29
INTEGER GOGO## Signal whether job should be started                     MR    30
INTEGER LIMOUT## Signal if large cycling output to printer              MR    31
INTEGER MXHKL## Signal MAXHKL line to be put out for FOURR & RFOURR     MR    32
INTEGER NCYCLE## Current cycle number                                   MR    33
INTEGER ONWARD## Signal that run is to bypass MEDENS & go "onward"      MR    34
INTEGER PNCH## PUNCH flag for line output to input                      MR    35
INTEGER PRNT## Print flag for line output to printer                    MR    36
#                                                                       MR    37
string:(FOLIN,80)## IMAGE OF FOURR LINE                                 MR    38
string:(GRLIN,80)## IMAGE OF GRID LINE                                  MR    39
string:(LYLIN,80)## IMAGE OF LAYOUT LINE                                MR    40
string:(RFLIN,80)## IMAGE OF RFOURR LINE                                MR    41
string:(DSLIN,80)## IMAGE OF DSTAT LINE                                 MR    42
string:(COLIN,80)## IMAGE OF COEF LINE                                  MR    43
string:(MELIN,80)## IMAGE OF MEDENS LINE                                MR    44
string:(MFLIN,80)## IMAGE OF MEFFIT LINE                                MR    45
string:(MXLIN,80)## IMAGE OF MAXHKL LINE                                MR    46
string:(UNLIN,80)## IMAGE OF UNITS LINE                                 MR    47
#                                                                       MR    48
COMMON/COMCMR/$#                                                        MR    49
COLIN, FOLIN ,GRLIN ,LYLIN ,RFLIN ,MELIN ,MFLIN ,MXLIN ,UNLIN,DSLIN#    MR    50
COMMON/COMFMR/$#                                                        MR    51
AFACT ,DSFACT,DSSTEP,SHFACT#                                            MR    52
COMMON/COMIMR/$#                                                        MR    53
CYCLES,DSTAT,EMAPS ,GOGO  ,LIMOUT,MXHKL ,NCYCLE,ONWARD,PRNT,PNCH#       MR    54
#                                                                       MR    55
endext:#                                                                MR    56
#                                                                       MR    57
systemheader:(MR00)#                                                    MR00   1
# ################################################################## #  MR00   2
#                                                                       MR00   3
#                               MR00                                 #  MR00   4
#                                                                    #  MR00   5
# ################################################################## #  MR00   6
SUBROUTINE MR00## D.M.Collins,J.M.Stewart Feb 1988                      MR00   7
include:(AACOMN)#                                                       MR00   8
#                                                                       MR00   9
FILEXT(IOUNIT(3))='MAP'#               Input fourier map                MR00  10
FILEXT(iofm1:)='AUX'#                  Input auxilliary file            MR00  11
#                                                                       MR00  12
CALL MR10#                             Set up run stream & go, go, go   MR00  13
#                                                                       MR00  14
RETURN#                                                                 MR00  15
END#                                                                    MR00  16
systemheader:(MR10)## Set up run stream and return control to xtal      MR10   1
# ################################################################## #  MR10   2
#                                                                    #  MR10   3
#                               MR10                                 #  MR10   4
#                                                                    #  MR10   5
# ################################################################## #  MR10   6
SUBROUTINE MR10## J.M.Stewart D.M.Collins jul 1988                      MR10   7
include:(AACOMN)#                                                       MR10   8
include:(MRCOMN)#                                                       MR10   9
#                                                                       MR10  10
chardata:(MR10A, END    FOURR  GRID   LAYOUT RFOURR MEDENS MEFFIT $#    MR10  11
UNITS  COEF   MAXHKL )#                Input lines allowed              MR10  12
chardata:(MR10B,CY  PR  NO  A   SH  E   F   LI  NL  NS  SU  DS  ON  )#  MR10  13
chardata:(MR10G, THE BDF WITH REFINED PHASES WILL BE ON FILE $#         MR10  14
XXXXXX.XXX  )#                                                          MR10  15
chardata:(MR10K, PREPARE INPUT LINES TO CONTROL MEDENS/MEFFIT $#        MR10  16
PHASE REFINEMENT)#                                                      MR10  17
chardata:(MR10L, SET FOR XX CYCLES OF MEFFIT PHASE REFINEMENT)#         MR10  18
chardata:(MR10M, PRINT LINES PREPARED FOR RUNNING CALCULATION)#         MR10  19
chardata:(MR10N, SET UP AND SUBMIT LINES PREPARED FOR RUNNING $#        MR10  20
CALCULATION)#                                                           MR10  21
chardata:(MR10O, MEDENS SHARPENING FACTOR           )#                  MR10  22
chardata:(MR10P, MEFFIT ACCELERATION FACTOR         )#                  MR10  23
chardata:(MR10Q, PREPARE TO TREAT E MAPS)#                              MR10  24
chardata:(MR10R, PREPARE TO TREAT F MAPS)#                              MR10  25
chardata:(MR10S, PUT LINE PRINTER PRIORITY TO 2 DURING CYCLING)#        MR10  26
chardata:(MR10T, THE PREPARED RUN WILL NOT BE RUN)#                     MR10  27
chardata:(MR10U,DSTAT                                                 $#MR10  28
             )#                                                         MR10  29
chardata:(MR10V, DSTAT LINES WILL BE WRITTEN FOR RFOUR STATISTICS)#     MR10  30
chardata:(MR10W,[ START RUN WITH MEDENS CALCULATION. PROPER MAP $#      MR10  31
MUST BE ON .MAP FILE])#                                                 MR10  32
chardata:(MR10X,[ BYPASS MEDENS CALCULATION.  PROPER MAPS MUST $#       MR10  33
BE ON .MAP AND .MED FILES])#                                            MR10  34
chardata:(MR10Y, MAXHKL LINES WILL BE WRITTEN TO CONTROL RESOLUTION)#   MR10  35
chardata:(ACCF,A)#                     Key to go in meffit line         MR10  36
chardata:(SHFF,SH)#                    Key to go in medens line         MR10  37
realdata:(FMTS,[110522.,160522.,210522.,260522.,310522.,360522.,$#      MR10  38
410522.,460522.,510522.,560522.,610522.,660522.])#                      MR10  39
datastuff:#                                                             MR10  40
#                                                                       MR10  41
#                                                                       MR10  42
CYCLES=4 ; NCYCLE=0#                   Default cycles                   MR10  43
PRNT=no:  ; PNCH=yes:#                 Shut off print, turn on punch    MR10  44
AFACT=2.0 ; SHFACT=0.5#                Defaul meffit/medens factors     MR10  45
DSTAT=no: ; DSFACT=8.0 ; DSSTEP=1.0#   No statistics by d value         MR10  46
MXHKL=no:#                             Assume no maxhkl lines           MR10  47
EMAPS=no:#                             Assume f maps to be treated      MR10  48
LIMOUT=no:#                            Assume no print suppresion       MR10  49
GOGO=yes:#                             Assume run to be submitted       MR10  50
ONWARD=no:#                            Include medens & fostat start^   MR10  51
#                                                                       MR10  52
CALL MR11#                             Default the input lines          MR10  53
#                                                                       MR10  54
FOR(K=1;BUFIN(K)<voidflg:;K=K+1)#      Loop over input fields           MR10  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MR10  56
stringlim:(K,I,J)#                     Find characters in input         MR10  57
compchar:(CHRIN,I,MR10B,1,2,4,NMR10B,J)# Search list of options         MR10  58
IF(J==0) iquit:(MR1001)#               It must be valid                 MR10  59
ELSE IF(J==1)#                         Test for cycles of refinement    MR10  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MR10  61
IF(BUFIN(K+1)>0.0)#                                                     MR10  62
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MR10  63
K=K+1 ; CYCLES=MIN0(50,NINT(BUFIN(K)))# Save cycles to be used          MR10  64
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MR10  65
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MR10  66
ELSE IF(J==2) PRNT=yes:#               Print lines too                  MR10  67
ELSE IF(J==3)#                         Punch equals no                  MR10  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MR10  69
PNCH=no: ; PRNT=yes:#                  Give up punching but print       MR10  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MR10  71
ELSE IF(J==4)#                         Test for meffit factor           MR10  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MR10  73
IF(BUFIN(K+1)>0.0)#                                                     MR10  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MR10  75
K=K+1 ; AFACT=AMIN1(4.0,BUFIN(K))#     Save meffit acceleration fact    MR10  76
AFACT=AMAX1(AFACT,1.0)#                With care                        MR10  77
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MR10  78
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MR10  79
ELSE IF(J==5)#                         Medens sharpening factor?        MR10  80
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MR10  81
IF(BUFIN(K+1)>0.0)#                                                     MR10  82
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MR10  83
K=K+1 ; SHFACT=AMIN1(2.0,BUFIN(K))#    Save medens sharpening factor    MR10  84
SHFACT=AMAX1(SHFACT,0.2)#              With care                        MR10  85
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MR10  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MR10  87
ELSE IF(J==6) EMAPS=yes:#              Refinement on e maps             MR10  88
ELSE IF(J==8) LIMOUT=yes:#             Set limit print during cycles    MR10  89
ELSE IF(J==10) GOGO=no:#               Stop run being submitted         MR10  90
ELSE IF(J==12)#                        Rfourr statistics?               MR10  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MR10  92
IF(BUFIN(K+1)>0.0)#                    D value to start?                MR10  93
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MR10  94
K=K+1 ; DSFACT=AMIN1(8.0,BUFIN(K))#    Save rfourr d value              MR10  95
IF(BUFIN(K+1)>0.0)#                    Step in volume given?            MR10  96
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MR10  97
K=K+1 ; DSSTEP=AMIN1(3.0,BUFIN(K))#    Save rfourr d step value         MR10  98
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MR10  99
DSFACT=AMAX1(DSFACT,2.0) ; DSSTEP=AMAX1(DSSTEP,0.25)#                   MR10 100
DSTAT=yes:#                            With care                        MR10 101
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MR10 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MR10 103
ELSE IF(J==13) ONWARD=yes:#            Bypass the medens fostat steps   MR10 104
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MR10 105
movechar:(SHFF,1,MELIN,15,NSHFF,0)#    Put alpha code in medens line    MR10 106
ncodefld:(SHFACT,1,MELIN,240632.,1)#   Medens sharpening factor         MR10 107
movechar:(ACCF,1,MFLIN,15,NACCF,0)#    Put alpha code in meffit line    MR10 108
ncodefld:(AFACT,1,MFLIN,240632.,1)#    Meffit acceleration factor       MR10 109
IF(DSTAT==yes:)#                       Are dstat lines after rfourr?    MR10 110
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MR10 111
movechar:(BLANK,1,DSLIN,1,80,1)#       Set up the dstat line            MR10 112
BUFOT(1)=DSFACT#                       Set initial d value              MR10 113
DO K=2,12#                             Make 12 equal volume d regions   MR10 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MR10 115
BUFOT(K)=DSFACT*(DSSTEP*FLOAT(K))**(-0.3333333)# Start at spec'd d      MR10 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MR10 117
ncodefld:(BUFOT,1,MR10U,FMTS,12) ; movechar:(MR10U,1,DSLIN,1,NMR10U,0)# MR10 118
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MR10 119
#                                                                       MR10 120
# WRITE OUT A SUMMARY OF INSTRUCTIONS                                   MR10 121
# -----------------------------------                                   MR10 122
#                                                                       MR10 123
LINRM=12 ; writeline:(1,MR10K,NMR10K,3,3)# Heading                      MR10 124
ncodefld:(FLOAT(CYCLES),1,MR10L,110213.,1)# Tell cycles to set up       MR10 125
writeline:(1,MR10L,NMR10L,3,3)#                                         MR10 126
IF(PRNT==yes:) writeline:(1,MR10M,NMR10M,3,3)#                          MR10 127
IF(PNCH==yes:)#                        Is generated output used?        MR10 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MR10 129
writeline:(1,MR10N,NMR10N,3,3)#        Tell user its true               MR10 130
openfmt:(iofm1:,' ')#                  Open the aux input file          MR10 131
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MR10 132
ncodefld:(SHFACT,1,MR10O,360632.,1)#   Tell medens factor               MR10 133
writeline:(1,MR10O,NMR10O,3,3)#                                         MR10 134
ncodefld:(AFACT,1,MR10P,360632.,1)#    Tell meffit factor               MR10 135
writeline:(1,MR10P,NMR10P,3,3)#                                         MR10 136
IF(EMAPS==yes:) writeline:(1,MR10Q,NMR10Q,3,3)# Tell map type           MR10 137
ELSE writeline:(1,MR10R,NMR10R,3,3)#                                    MR10 138
IF(LIMOUT==yes:) writeline:(1,MR10S,NMR10S,3,3)# Tell print priority    MR10 139
IF(DSTAT==yes:) writeline:(1,MR10V,NMR10V,3,3)# Tell dstat stat         MR10 140
IF(GOGO==no:) writeline:(1,MR10T,NMR10T,3,3)# Tell run submission       MR10 141
IF(ONWARD==no:) writeline:(1,MR10W,NMR10W,3,3)# Tell run from medens    MR10 142
ELSE writeline:(1,MR10X,NMR10X,3,3)#   Tell run skipping medens         MR10 143
writeline:(1,0,0,1,3) ; LINRM=5#       Write a blank line               MR10 144
#                                                                       MR10 145
# TAKE IN ANY OTHER INPUT LINES                                         MR10 146
# -----------------------------                                         MR10 147
#                                                                       MR10 148
REPEAT#                                Loop over lines                  MR10 149
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MR10 150
readline:(MR10A,NMR10A)#                                                MR10 151
IF(LINID==1) BREAK#                    Stop reading when end line       MR10 152
IF     (LINID==2) FOLIN=CHRIP(1^CHRMAX)# Fourr input line read          MR10 153
ELSE IF(LINID==3) GRLIN=CHRIP(1^CHRMAX)# Grid input line read           MR10 154
ELSE IF(LINID==4) LYLIN=CHRIP(1^CHRMAX)# Layout input line read         MR10 155
ELSE IF(LINID==5) RFLIN=CHRIP(1^CHRMAX)# Rfourr input line read         MR10 156
ELSE IF(LINID==6) MELIN=CHRIP(1^CHRMAX)# Medens input line read         MR10 157
ELSE IF(LINID==7) MFLIN=CHRIP(1^CHRMAX)# Meffit input line read         MR10 158
ELSE IF(LINID==9)#                     Coeff  input line read           MR10 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MR10 160
COLIN=CHRIP(1^CHRMAX); EMAPS=yes:#     Signal coef line must go out     MR10 161
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MR10 162
ELSE IF(LINID==10)#                    Maxhkl input line read           MR10 163
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MR10 164
MXLIN=CHRIP(1^CHRMAX); MXHKL=yes:#     Clear line                       MR10 165
writeline:(1,MR10Y,NMR10Y,3,3)#        Report action                    MR10 166
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MR10 167
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MR10 168
#                                                                       MR10 169
#    BUILD THE RE-ENTRANT STREAM OF CONTROL LINES                       MR10 170
#    --------------------------------------------                       MR10 171
#                                                                       MR10 172
IF(ONWARD==no:) CALL MR12#             Build preliminary runstream      MR10 173
CALL MR13#                             Build cycling runstream          MR10 174
CALL MR14#                             Build concluding runstream       MR10 175
#                                                                       MR10 176
#    IF SO KEYED, SET UP AND SEND OFF THE INPUT FILE CREATED            MR10 177
#    -------------------------------------------------------            MR10 178
#                                                                       MR10 179
IF(PNCH==yes:)#                                                         MR10 180
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MR10 181
closefmt:(iofm1:)#                     Close the aux file               MR10 182
IF(GOGO==yes:) linestream:('aux')#     See if run is to be done         MR10 183
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MR10 184
I=IOUNIT(1)#                           Get what final phases file       MR10 185
movechar:(FILEXT(I),1,MR10G,53,3,0)#   Copy file extension              MR10 186
movechar:(COMPID,1,MR10G,46,6,0)#      Copy compound id                 MR10 187
writeline:(1,MR10G,NMR10G,3,3)#                                         MR10 188
#                                                                       MR10 189
RETURN#                                                                 MR10 190
END#                                                                    MR10 191
systemheader:(MR11)## Set up run default input line images              MR11   1
# ################################################################## #  MR11   2
#                                                                    #  MR11   3
#                               MR11                                 #  MR11   4
#                                                                    #  MR11   5
# ################################################################## #  MR11   6
SUBROUTINE MR11## J.M.Stewart D.M.Collins jul 1988                      MR11   7
include:(AACOMN)#                                                       MR11   8
include:(MRCOMN)#                                                       MR11   9
#                                                                       MR11  10
REAL ORIG(3)#                          Origins in fourier map           MR11  11
REAL GRID(3)#                          Grid specifications in fourier   MR11  12
REAL INCR(3)#                          Increments on axis in grid ste   MR11  13
INTEGER CTYPE#                         Fourier coefficient type         MR11  14
INTEGER ISUM(3)#                       Summation permutation table      MR11  15
INTEGER MARKP,IP,PSIZ,K,IIP#           Local variables fo i/o           MR11  16
#                                                                       MR11  17
chardata:(MR11A," layer  downacross")# Summation directions             MR11  18
chardata:(MR11D,"MEDENS  ")#                                            MR11  19
chardata:(MR11I,"RFOURR ft  0.25 ")#                                    MR11  20
chardata:(MR11J,"coeff 1600  -1  -1  1800  -1  -1  1801  1802  1700")#  MR11  21
chardata:(MR11M,"FOURR  fdif nw nb")#                                   MR11  22
chardata:(MR11Q,"grid              ")#                                  MR11  23
chardata:(MR11R,"layout XXXXXX XXXXXX XXXXXX  NN  NN  NN  NN  NN  $#    MR11  24
NN  NN  NN  NN ")#                                                      MR11  25
chardata:(MR11T,"MEFFIT  ")#                                            MR11  26
realdata:(FMTG,[90313.,130313.,170313.])#                               MR11  27
realdata:(FMTL,[310313.,350313.,390313.,430313.,470313.,510313.,$#      MR11  28
550313.,590313.,630313.])#                                              MR11  29
datastuff:#                                                             MR11  30
#                                                                       MR11  31
FOLIN=MR11M#                           Store fourr line                 MR11  32
GRLIN=MR11Q#                           Store grid  line                 MR11  33
LYLIN=MR11R#                           Store layot line                 MR11  34
RFLIN=MR11I#                           Store rfour line                 MR11  35
COLIN=MR11J#                           Store coeff line                 MR11  36
MELIN=MR11D#                           Store meden line                 MR11  37
MFLIN=MR11T#                           Store mefit line                 MR11  38
#                                                                       MR11  39
# SET UP I/O BUFFERS FOR ONE FILE                                       MR11  40
# -------------------------------                                       MR11  41
#                                                                       MR11  42
IOMARK(3)=QXSTR#                       Get fourier configuration        MR11  43
incrqx:(MARKP,IOMARK(3)+bdfbuf:,MR1005)# Dummy pointer                  MR11  44
#                                                                       MR11  45
# RETRIEVE THE MAP PARAMETERS FROM LR 21                                MR11  46
# --------------------------------------                                MR11  47
#                                                                       MR11  48
readwpkt:(3,21,PSIZ,IP,0)#             Get the map parameters           MR11  49
DO K=1,3#                              Loop over axes                   MR11  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MR11  51
IIP=IP+K#                                                               MR11  52
ORIG(K)=QX(IIP)#                       Pick up origins                  MR11  53
INCR(K)=QX(IIP+3)#                     Increments along axes            MR11  54
GRID(K)=QX(IIP+6)#                     No. of grid points               MR11  55
ISUM(K)=NINT(QX(IIP+12))#              Correlations between crystal     MR11  56
#                                      Axes and calculation axes        MR11  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MR11  58
CTYPE=NINT(QX(IP+21))#                 Get coefficient type for map ^   MR11  59
IF(CTYPE==4) EMAPS=yes:#               1-6 patt,e*f,vect,e,fo,fd,fc     MR11  60
readwpkt:(3,endrecord:,PSIZ,IP,0)#     That's all thats needed here     MR11  61
#                                                                       MR11  62
#                                                                       MR11  63
#    GRID AND SUMMATION DIRECTIONS IN THE GRID AND LAYOUT LINES         MR11  64
#    ----------------------------------------------------------         MR11  65
#                                                                       MR11  66
ncodefld:(GRID,ISUM(1),GRLIN,FMTG(1),1)# X grid values                  MR11  67
ncodefld:(GRID,ISUM(2),GRLIN,FMTG(2),1)# Y grid values                  MR11  68
ncodefld:(GRID,ISUM(3),GRLIN,FMTG(3),1)# Z grid values                  MR11  69
ncodefld:(GRID,ISUM(1),LYLIN,FMTL(1),1)# X grid values                  MR11  70
ncodefld:(GRID,ISUM(2),LYLIN,FMTL(2),1)# Y grid values                  MR11  71
ncodefld:(GRID,ISUM(3),LYLIN,FMTL(3),1)# Z grid values                  MR11  72
ncodefld:(ORIG,ISUM(1),LYLIN,FMTL(4),1)# X origin values                MR11  73
ncodefld:(ORIG,ISUM(2),LYLIN,FMTL(5),1)# Y origin values                MR11  74
ncodefld:(ORIG,ISUM(3),LYLIN,FMTL(6),1)# Z origin values                MR11  75
ncodefld:(INCR,ISUM(1),LYLIN,FMTL(7),1)# X increment values             MR11  76
ncodefld:(INCR,ISUM(2),LYLIN,FMTL(8),1)# Y increment values             MR11  77
ncodefld:(INCR,ISUM(3),LYLIN,FMTL(9),1)# Z increment values             MR11  78
movechar:(MR11A,(ISUM(1)-1)*6+1,LYLIN,8,6,0)# X direction scan          MR11  79
movechar:(MR11A,(ISUM(2)-1)*6+1,LYLIN,15,6,0)# Y direction scan         MR11  80
movechar:(MR11A,(ISUM(3)-1)*6+1,LYLIN,22,6,0)# Z direction scan         MR11  81
#                                                                       MR11  82
RETURN#                                                                 MR11  83
END#                                                                    MR11  84
systemheader:(MR12)## Set up prolog input line images for medens run    MR12   1
# ################################################################## #  MR12   2
#                                                                    #  MR12   3
#                               MR12                                 #  MR12   4
#                                                                    #  MR12   5
# ################################################################## #  MR12   6
SUBROUTINE MR12## J.M.Stewart D.M.Collins july 1988                     MR12   7
include:(AACOMN)#                                                       MR12   8
include:(MRCOMN)#                                                       MR12   9
#                                                                       MR12  10
chardata:(MR12F,'FOSTAT  20 1 -10')#                                    MR12  11
chardata:(MR12G,'copybdf med map')#                                     MR12  12
chardata:(MR123,'end')#                                                 MR12  13
chardata:(MR124,'reset psta 2 : limit printed output to priority 2')#   MR12  14
realdata:(FMTF,[110213.,140213.,170213.])#                              MR12  15
datastuff:#                                                             MR12  16
#                                                                       MR12  17
#   SET UP THE PRELIMINARY LINES FOR MEDENS AND WRITE TO OUTPUT         MR12  18
#   -----------------------------------------------------------         MR12  19
#                                                                       MR12  20
mrlineout:(MELIN,80)#                  Medens line                      MR12  21
mrlineout:(MR123,NMR123)#              End line                         MR12  22
mrlineout:(MR12G,NMR12G)#              Copybdf line                     MR12  23
mrlineout:(MR12F,NMR12F)#              Fostat line                      MR12  24
mrlineout:(MR123,NMR123)#              End line                         MR12  25
IF(LIMOUT==yes:) mrlineout:(MR124,NMR124)# Change priority to 2         MR12  26
#                                                                       MR12  27
RETURN#                                                                 MR12  28
END#                                                                    MR12  29
systemheader:(MR13)## Make input lines for rfourr/fourr/meffit cycles   MR13   1
# ################################################################## #  MR13   2
#                                                                    #  MR13   3
#                               MR13                                 #  MR13   4
#                                                                    #  MR13   5
# ################################################################## #  MR13   6
SUBROUTINE MR13## J.M.Stewart D.M.Collins jul 1988                      MR13   7
include:(AACOMN)#                                                       MR13   8
include:(MRCOMN)#                                                       MR13   9
#                                                                       MR13  10
chardata:(MR122,':       Cycle nn of RFOURR/FOURR/MEFFIT refinement')#  MR13  11
chardata:(MR123,'end')#                                                 MR13  12
chardata:(MR124,'copybdf mem map')#                                     MR13  13
chardata:(MR125,'copybdf mem med')#                                     MR13  14
datastuff:#                                                             MR13  15
#                                                                       MR13  16
#    SET UP THE SPECIFIED CYCLES OF REFINEMENT RFOURR/FOURR/MEFFIT      MR13  17
#    -------------------------------------------------------------      MR13  18
#                                                                       MR13  19
FOR(NCYCLE=1;NCYCLE<=CYCLES;NCYCLE=NCYCLE+1)#                           MR13  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MR13  21
ncodefld:(FLOAT(NCYCLE),1,MR122,160313.,1)# Format cycle number         MR13  22
mrlineout:(MR122,1)#                   Output header                    MR13  23
mrlineout:(MR122,NMR122)#              Output header                    MR13  24
mrlineout:(MR122,1)#                   Output header                    MR13  25
mrlineout:(RFLIN,80)#                  Rfourr line                      MR13  26
IF(MXHKL==yes:) mrlineout:(MXLIN,80)#  Dstat line                       MR13  27
IF(DSTAT==yes:) mrlineout:(DSLIN,80)#  Dstat line                       MR13  28
mrlineout:(FOLIN,80)#                  Fourr line                       MR13  29
IF(MXHKL==yes:) mrlineout:(MXLIN,80)#  Dstat line                       MR13  30
mrlineout:(GRLIN,80)#                  Grid line                        MR13  31
mrlineout:(LYLIN,80)#                  Layout line                      MR13  32
IF(EMAPS==yes:) mrlineout:(COLIN,80)#  Coef line                        MR13  33
mrlineout:(MFLIN,80)#                  Meffit line                      MR13  34
mrlineout:(MR123,NMR123)#              End line                         MR13  35
mrlineout:(MR124,NMR124)#              Copybdf line                     MR13  36
mrlineout:(MR125,NMR125)#              Copybdf line                     MR13  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MR13  38
#                                                                       MR13  39
RETURN#                                                                 MR13  40
END#                                                                    MR13  41
systemheader:(MR14)## Make input lines for running rfourr epilog        MR14   1
# ################################################################## #  MR14   2
#                                                                    #  MR14   3
#                               MR14                                 #  MR14   4
#                                                                    #  MR14   5
# ################################################################## #  MR14   6
SUBROUTINE MR14## J.M.Stewart D.M.Collins jul 1988                      MR14   7
include:(AACOMN)#                                                       MR14   8
include:(MRCOMN)#                                                       MR14   9
#                                                                       MR14  10
chardata:(MR14X,":       After  N cycles calculate phases from $#       MR14  11
refined max entropy map")#                                              MR14  12
chardata:(MR14E,'end')#                                                 MR14  13
chardata:(MR14A,'reset psta    ')#                                      MR14  14
datastuff:#                                                             MR14  15
#                                                                       MR14  16
#    SET UP THE FINAL PHASE CALCULATION BY RFOURR                       MR14  17
#    --------------------------------------------                       MR14  18
#                                                                       MR14  19
ncodefld:(FLOAT(CYCLES),1,MR14X,160213.,1)#                             MR14  20
mrlineout:(MR14X,1)#                   Title line                       MR14  21
mrlineout:(MR14X,NMR14X)#              Title line                       MR14  22
mrlineout:(MR14X,1)#                   Title line                       MR14  23
IF(LIMOUT==yes:)#                      Has print been limited           MR14  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MR14  25
ncodefld:(FLOAT(prtstat:),1,MR14A,140113.,1)# Set priority as it was    MR14  26
mrlineout:(MR14A,NMR14A)#              Reset print priority             MR14  27
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MR14  28
mrlineout:(RFLIN,80)#                  Rfourr line                      MR14  29
IF(MXHKL==yes:) mrlineout:(MXLIN,80)#  Dstat line                       MR14  30
IF(DSTAT==yes:) mrlineout:(DSLIN,80)#  Dstat line                       MR14  31
mrlineout:(MR14E,NMR14E)#              End line                         MR14  32
#                                                                       MR14  33
RETURN#                                                                 MR14  34
END#                                                                    MR14  35
systemheader:(MR19)## Output the instruction lines                      MR19   1
# ################################################################## #  MR19   2
#                                                                    #  MR19   3
#                               MR19                                 #  MR19   4
#                                                                    #  MR19   5
# ################################################################## #  MR19   6
SUBROUTINE MR19(STRG,NSTR)## J.M.Stewart D.M.Collins july 1988          MR19   7
include:(AACOMN)#                                                       MR19   8
include:(MRCOMN)#                                                       MR19   9
#                                                                       MR19  10
INTEGER NSTR#                                                           MR19  11
string:(STRG,80)#                                                       MR19  12
chardata:(HEAD,' Generated lines:    ')#                                MR19  13
datastuff:#                                                             MR19  14
#                                                                       MR19  15
#   'PUNCH' OUT THE INSTRUCTION LINE                                    MR19  16
#   --------------------------------                                    MR19  17
#                                                                       MR19  18
IF(PNCH==yes:) writefmt:(iofm1:,'(A)',STRG(1^NSTR))#                    MR19  19
IF(PRNT==yes:)#                        See if printing too              MR19  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MR19  21
CHROT=HEAD//STRG(1^NSTR)#                                               MR19  22
writeline:(0,0,0,1,3)#                                                  MR19  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MR19  24
#                                                                       MR19  25
RETURN#                                                                 MR19  26
END#                                                                    MR19  27
pmacro:([no:])#                        Purge xtal system macros         MR19  28
