systemheader:(MS    )#                                                  MS     1
####################################################################### MS     2
#                                                                     # MS     3
#                        *** MESTAR ***                               # MS     4
#                                                                     # MS     5
#     PROGRAM FOR SETTING PHASES OF STARTING REFLECTIONS IN A MEPHAS  # MS     6
#     PHASING RUN.  ALLOWS THE SPECIFICATION OF ORIGIN AND            # MS     7
#     ENANTIOMORPH REFLECTIONS PLUS ANY OTHER KNOWN REFLECTIONS.      # MS     8
#     FOR EACH H, K, L, PHI (OPTIONAL) & |FC| (OPTIONAL) INPUT IN PHI # MS     9
#     LINES  |FC| AND THE PHASE IN CYCLES ARE PUT OUT TO THE          # MS    10
#     REFLECTION RECORD IN THE OUTPUT BDF.                            # MS    11
#                                                                     # MS    12
####################################################################### MS    13
#                                                                       MS    14
include:(XMACRO)#                                                       MS    15
#                                                                       MS    16
systemheader:(MS00)## Place ODR/EDR phases in bdf                       MS00   1
# ################################################################## #  MS00   2
#                                                                    #  MS00   3
#                               MS00                                 #  MS00   4
#                                                                    #  MS00   5
# ################################################################## #  MS00   6
SUBROUTINE MS00## J.M. Stewart July  1990                               MS00   7
# IMPLICIT NONE;INTEGER JQJ,JQK,KQJ,KQK,KZJ#                            MS00   8
include:(AACOMN)#                                                       MS00   9
#                                                                       MS00  10
COMMON/COMFMS/COSCHK,SINCHK#                                            MS00  11
REAL    COSCHK(9)#                     Table of restricted coses        MS00  12
REAL    COSPH,SINPH#                   Hold cos(phi) sin(phi)           MS00  13
REAL    DETORA#                        Conversion degrees to radians    MS00  14
INTEGER DSET#                          Data set to be treated           MS00  15
REAL    FC#                            Fc from bdf lrrefl               MS00  16
REAL    H(3)#                          H, k, l for printing             MS00  17
INTEGER I,J,K,L,LL#                    Indices for loops and pointing   MS00  18
INTEGER IHIT,HITLIS#                   Control listing of sought refl   MS00  19
INTEGER IP,IIP,NPAK,OPAK#              Packet pointers                  MS00  20
INTEGER IR,IFC,IFR,IPH,IPR#            Pointers into lrrefl             MS00  21
INTEGER ISTAR#                         Point to column in input         MS00  22
INTEGER IWNT(10),IREL(12),KEY(4),NWNT#                                  MS00  23
INTEGER LIST#                          Number of refs to print          MS00  24
INTEGER MARK#                          Start storage beyond buffers     MS00  25
INTEGER NFOUND#                        Count as reflections are found   MS00  26
INTEGER NREF#                          Number of reflections treated    MS00  27
INTEGER NTOTR#                         Number of reflections treated    MS00  28
REAL    PHASE#                         Reflection phase in degrees      MS00  29
INTEGER PHASR#                         Phase restriction code,lrrefl:   MS00  30
REAL    RATODE#                        Conversion radians to degrees    MS00  31
REAL    SINCHK(9)#                     Table of restricted sines        MS00  32
INTEGER STEP#                          Items per reflection             MS00  33
INTEGER STOP#                          End of reflection storage        MS00  34
REAL    TEMP#                          Hold phase temporarily           MS00  35
REAL    TWOPI#                         Just that                        MS00  36
#                                                                       MS00  37
chardata:(MS01, END   PHI    )#                                         MS00  38
chardata:(MS03,DSE LIS )#              Refout line codes                MS00  39
chardata:(MS0B,  ID NUMBERS FOUND IN  AND REQUESTED FROM $#             MS00  40
REFLECTION PACKET)#                                                     MS00  41
chardata:(MS0C,[     H    K    L         FC     PHASE])#                MS00  42
realdata:(FMTC,[60513.,110513.,160513.,271051.,370513.])#               MS00  43
chardata:(MS0D,         REFLECTIONS PROCESSED.)#                        MS00  44
chardata:(MS0F,         TOTAL REFLECTIONS IN BDF.)#                     MS00  45
chardata:(MS0M,[ DATA SET TREATED                 ])#                   MS00  46
chardata:(MS0N,[ ])#                                                    MS00  47
chardata:(MS0Q,NOT PRESENT IN LRREFL)#                                  MS00  48
chardata:(MS0R,FOUND IN LRREFL)#                                        MS00  49
chardata:(MS0X,[VOID      VOID])#                                       MS00  50
chardata:(MS0Z,[ ****WARNING PHASE      REFLECTION                 $#   MS00  51
DOES NOT CONFORM TO SPACE GROUP RESTRICTION. SET TO DEFAULT.])#         MS00  52
realdata:(FMTZ,[390513.,440513.,490513.])#                              MS00  53
realdata:(RESPHA,[0.,0.,30.,45.,60.,90.,120.,135.,150.])# Centric pha   MS00  54
datastuff:#                                                             MS00  55
#                                                                       MS00  56
# RESTRICTED REFLECTION CHECKING AND PHASE MANIPULATION CONSTANTS       MS00  57
# ---------------------------------------------------------------       MS00  58
#                                                                       MS00  59
TWOPI=2.0*ACOS(-1.0)#                  Get local value of two pi        MS00  60
DETORA=TWOPI/360.0#                    Get degrees to radians           MS00  61
RATODE=1.0/DETORA#                     And back again to degrees        MS00  62
DO J=1,9#                              Set up table of exact centrics   MS00  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MS00  64
COSCHK(J)=COS(RESPHA(J)*DETORA)#       Cosine of centric phase angles   MS00  65
SINCHK(J)=SIN(RESPHA(J)*DETORA)#       Sine of centric phase angles     MS00  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MS00  67
COSCHK(1)=1.0 ; COSCHK(2)=1.0 ; COSCHK(6)=0.0# Make sure!               MS00  68
SINCHK(1)=0.0 ; SINCHK(2)=0.0 ; SINCHK(6)=1.0# Make really sure!        MS00  69
#                                                                       MS00  70
#    SET IO BUFFERS                                                     MS00  71
#    --------------                                                     MS00  72
#                                                                       MS00  73
IOMARK(1)=QXSTR#                       Start of buffer for file a       MS00  74
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of buffer for file d       MS00  75
incrqx:(MARK,IOMARK(2)+bdfbuf:,MS0005)# Incr memory.....ms0005          MS00  76
STEP=6 ; STOP=MARK#                    Items per reflection             MS00  77
#                                                                       MS00  78
#    SET DEFAULT VALUES FOR CONTROL PARAMETERS                          MS00  79
#    -----------------------------------------                          MS00  80
#                                                                       MS00  81
DSET=1#                                Default data set one             MS00  82
LIST=20 ; HITLIS=LIST#                 List the first 20 reflections    MS00  83
NREF=0 ; NTOTR=0#                      Count of reflections             MS00  84
#                                                                       MS00  85
#    SCAN REFOUT LINE FOR INSTRUCTIONS                                  MS00  86
#    ---------------------------------                                  MS00  87
#                                                                       MS00  88
FOR(J=1;BUFIN(J)<voidflg:;J=J+1)#      Loop until void or numerical     MS00  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MS00  90
stringlim:(J,ISTAR,I)#                 Find character string            MS00  91
compchar:(CHRIN,ISTAR,MS03,1,3,4,NMS03,I)# Check the list               MS00  92
IF(I<=0) iquit:(MS0001)#               Die for lack of nmemonic         MS00  93
ELSE IF(I==1&BUFIN(J+1)>=1.0&BUFIN(J+1)<=12.0)#                         MS00  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MS00  95
DSET=NINT(BUFIN(J+1)) ; J=J+1#                                          MS00  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MS00  97
ELSE IF(I==2&BUFIN(J+1)>0.0&BUFIN(J+1)<1000.0)#                         MS00  98
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MS00  99
LIST=NINT(BUFIN(J+1)) ; HITLIS=LIST ; J=J+1#                            MS00 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MS00 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MS00 102
#                                                                       MS00 103
#    ENTER CONTROL LINES                                                MS00 104
#    -------------------                                                MS00 105
#                                                                       MS00 106
REPEAT#                                                                 MS00 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MS00 108
readline:(MS01,NMS01)#                 Enter next line                  MS00 109
IF(LINID==1) BREAK#                    Quit at 'end' line               MS00 110
ELSE IF(LINID==2)#                     Treat 'phi' lines                MS00 111
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MS00 112
#                                                                       MS00 113
# READ IN 'PHI' LINES TO ESTABLISH REFLECTIONS TO BE PHASED IN RUN      MS00 114
# MUST BE NO DUPLICATES SINCE THAT WILL MAKE HESSIAN SINGULAR           MS00 115
# ----------------------------------------------------------------      MS00 116
#                                                                       MS00 117
FOR(K=MARK;K<STOP;K=K+STEP)#           Loop over those already loaded   MS00 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MS00 119
IF(QX(K+1)!=BUFIN(1)\QX(K+2)!=BUFIN(2)\QX(K+3)!=BUFIN(3)) NEXT# Diffe   MS00 120
iquit:(MS0021)#                        Die if a duplicate hit           MS00 121
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MS00 122
K=STOP ; incrqx:(STOP,STOP+STEP,MS0007)# Get more storage               MS00 123
QX(K+1)=BUFIN(1)#                      Get h                            MS00 124
QX(K+2)=BUFIN(2)#                      Get k                            MS00 125
QX(K+3)=BUFIN(3)#                      Get l                            MS00 126
IF(BUFIN(4)>-361.0&BUFIN(4)<361.0)#    Does it look like an angle?      MS00 127
QX(K+4)=AMOD(BUFIN(4)+720.0,360.0)#    Phase in degrees in temp. form   MS00 128
ELSE QX(K+4)=voidflg:#                 Phase from bdf or by default     MS00 129
IF(BUFIN(5)>0.0)#                      Does it look like an |fc|        MS00 130
QX(K+5)=BUFIN(5)#                      |fc| from user                   MS00 131
ELSE QX(K+5)=1.0E+12#                  By default make it big, big      MS00 132
NREF=NREF+1#                           Count it                         MS00 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MS00 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MS00 135
#                                                                       MS00 136
#     WRITE SUMMARY OF PROGRAM SETTINGS                                 MS00 137
#     ---------------------------------                                 MS00 138
#                                                                       MS00 139
BUFOT(1)=FLOAT(DSET)#                                                   MS00 140
ncodefld:(BUFOT,1,MS0M,340213.,1)#     Print data set number            MS00 141
writeline:(1,MS0M,NMS0M,3,3)#                                           MS00 142
#                                                                       MS00 143
#    SEARCH DIRECTORY OF LRREFL:                                        MS00 144
#    ---------------------------                                        MS00 145
#                                                                       MS00 146
copyfile:(1,2,1,decr:(lrrefl:))#       Copy lead records                MS00 147
DSET=DSET*1000#                        Get dset in right place          MS00 148
IWNT(1)=1 ;   IWNT(4)=DSET+700#        Request hkl & phase              MS00 149
IWNT(2)=3 ;   IWNT(5)=DSET+800#        Phase restriction code & fc      MS00 150
IWNT(3)=DSET+304 ; NWNT=5#             F relative                       MS00 151
KEY(1)=2; KEY(2)=2 ; KEY(3)=5; KEY(4)=0# Set search keys                MS00 152
indexpkt:(1,lrrefl:,NPAK,IP,2,KEY,IWNT,IREL)# Search lrrefl directory   MS00 153
OPAK=KEY(4)#                           Set updated packet size          MS00 154
LINRM=5 ; writeline:(3,0,0,1,3) ; LINRM=3#                              MS00 155
I=0 ; K=0#                             Get ready to loop over packet    MS00 156
REPEAT#                                Display packet id numbers        MS00 157
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MS00 158
I=I+1 ; K=K+1 ; IF(I>NPAK&K>NWNT) BREAK#                                MS00 159
IF(I<=NPAK)#                           Until packet is exhausted        MS00 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MS00 161
ncodefld:(QX(IP+I),1,CHROT,100513.,1)#                                  MS00 162
DO J=1,NWNT#                           Flag the wanted items            MS00 163
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MS00 164
IF(NINT(QX(IP+I))==IWNT(J))#           Test for active quantity         MS00 165
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MS00 166
movechar:(MS0N,1,CHROT,12,NMS0N,0) ; BREAK# Flag those that are         MS00 167
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MS00 168
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MS00 169
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MS00 170
IF(K<=NWNT)#                           And all wants are listed         MS00 171
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MS00 172
ncodefld:(FLOAT(IWNT(K)),1,CHROT,330513.,1)# Put out request            MS00 173
IF(IREL(K)>0) movechar:(MS0R,1,CHROT,35,NMS0R,0)# Mark it found         MS00 174
ELSE movechar:(MS0Q,1,CHROT,35,NMS0Q,0)# Mark it lost                   MS00 175
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MS00 176
writeline:(0,MS0B,NMS0B,1,3)#                                           MS00 177
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MS00 178
IF(KEY(4)<=0) iquit:(MS0015)#          Hkl, frel not found...           MS00 179
#                                                                       MS00 180
IR=IREL(1)#                            Store hkl, rcode                 MS00 181
IFC=IREL(5);   IPR=IREL(2)#            Store fc, phase restriction      MS00 182
IPH=IREL(4);   IFR=IREL(3)#            Store phase & f relative         MS00 183
#                                                                       MS00 184
LINRM=4#                               Prepare for reflection listing   MS00 185
#                                                                       MS00 186
#    ENTER LRREFL: BDF RECORDS                                          MS00 187
#    -------------------------                                          MS00 188
#                                                                       MS00 189
NFOUND=0 ; REPEAT#                     Loop over lrrefl records         MS00 190
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MS00 191
readwpkt:(1,lrrefl:,NPAK,IP,0)#        Point to ip packet               MS00 192
IF(IP<=0) BREAK#                       Exit reflection loop             MS00 193
writepkt:(2,lrrefl:,OPAK,IIP)#         Write new record                 MS00 194
movereal:(QX,IP+1,QX,IIP+1,NPAK,0)#    Copy the kept stuff in to out    MS00 195
gethkl:(IP+IR,H)#                      Extract h,k,l                    MS00 196
BUFOT(1)=H(1); BUFOT(2)=H(2); BUFOT(3)=H(3)# Hold for output            MS00 197
NTOTR=NTOTR+1 ; IHIT=no:#              Count all reflections            MS00 198
#                                                                       MS00 199
#    PICK OUT THE QUANTITIES NECESSARY FOR GENERATING DATA              MS00 200
#    ------------------------------------------------------             MS00 201
#                                                                       MS00 202
intunpak:(QX(IP+IPR),PHASR,12,4)#      Get refl. phase restriction      MS00 203
COSPH=COSCHK(PHASR+1) ; SINPH=SINCHK(PHASR+1)# Get phase restriction    MS00 204
#                                                                       MS00 205
# CLEAR OUT ANY OLD PHASES AND F CALCS                                  MS00 206
# ------------------------------------                                  MS00 207
#                                                                       MS00 208
QX(IIP+IFC)=voidflg: ; QX(IIP+IPH)=voidflg:#                            MS00 209
#                                                                       MS00 210
IF(NFOUND<NREF)#                       Search for odr/edr               MS00 211
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MS00 212
#                                                                       MS00 213
# LOOK FOR REFLECTION IN BDF TO SET UP FC AND PHASE FOR SELECTED REFS   MS00 214
# -------------------------------------------------------------------   MS00 215
#                                                                       MS00 216
FOR(K=MARK;K<STOP;K=K+STEP)#           Search loaded reflections        MS00 217
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MS00 218
IF(QX(K+1)!=H(1)\QX(K+2)!=H(2)\QX(K+3)!=H(3)) NEXT# No match?           MS00 219
L=(NFOUND)*STEP+MARK#                  Point to next refl in bdf orde   MS00 220
DO LL=1,STEP#                          Swap the found reflection        MS00 221
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MS00 222
TEMP=QX(L+LL) ; QX(L+LL)=QX(K+LL) ; QX(K+LL)=TEMP# Save everything      MS00 223
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MS00 224
NFOUND=NFOUND+1 ; TEMP=QX(L+4)#        Protect users phase value        MS00 225
IF(TEMP>=0.0&TEMP<360.)#               Take users phase if there        MS00 226
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MS00 227
COSPH=COS(DETORA*TEMP) ; SINPH=SIN(DETORA*TEMP)# Set cos & sin of phi   MS00 228
IF(PHASR>0)#                           Make sure restricted phases o.   MS00 229
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MS00 230
IF(ABS(ABS(COSPH)-ABS(COSCHK(PHASR+1)))>0.001\#                         MS00 231
ABS(ABS(SINPH)-ABS(SINCHK(PHASR+1)))>0.001)#                            MS00 232
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MS00 233
PHASE=AMOD(RATODE*ATAN2(SINPH,COSPH)+720.0,360.0)# Phase in degrees     MS00 234
ncodefld:(PHASE,1,MS0Z,230513.,1)#     Put phase to user                MS00 235
ncodefld:(H,1,MS0Z,FMTZ,3) ; writeline:(1,MS0Z,NMS0Z,3,2)#              MS00 236
COSPH=COSCHK(PHASR+1) ; SINPH=SINCHK(PHASR+1)# Get phase restriction    MS00 237
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MS00 238
#                                                                       MS00 239
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MS00 240
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MS00 241
CALL MS02(COSPH,SINPH)#                Keep centrics centric            MS00 242
IF(IFR>0) QX(IIP+IFC)=QX(IP+IFR)#      Set fc to f rel                  MS00 243
ELSE QX(IIP+IFC)=25.0#                 Make pseudo fc twenty five       MS00 244
PHASE=AMOD(RATODE*ATAN2(SINPH,COSPH)+720.0,360.0)# Phase in degrees     MS00 245
QX(IIP+IPH)=PHASE/360.0#               Phase in cycles for bdf          MS00 246
IF(HITLIS>0)#                          Treat found ones differently     MS00 247
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MS00 248
IHIT=yes: ; HITLIS=HITLIS-1#           So we get to see a sample        MS00 249
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MS00 250
BREAK#                                 Got this one look for next one   MS00 251
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MS00 252
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MS00 253
FC=QX(IIP+IFC)#                        Fc for printing                  MS00 254
#                                                                       MS00 255
#     LIST THE FIRST FEW REFLECTIONS IF SO DIRECTED                     MS00 256
#     ---------------------------------------------                     MS00 257
#                                                                       MS00 258
IF(LIST>0\IHIT==yes:)#                                                  MS00 259
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MS00 260
BUFOT(4)=FC ; BUFOT(5)=PHASE#                                           MS00 261
I=3 ; IF(IHIT==yes:) I=5#              For phased refls                 MS00 262
ELSE movechar:(MS0X,1,CHROT,23,NMS0X,0)# Tell about voids               MS00 263
ncodefld:(BUFOT,1,CHROT,FMTC,I)#       Encode the output quantities     MS00 264
writeline:(0,MS0C,NMS0C,1,3)#                                           MS00 265
LIST=LIST-1#                                                            MS00 266
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MS00 267
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MS00 268
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Finish off files              MS00 269
#                                                                       MS00 270
#     SUMMARIZE RESULTS PRINT STATS                                     MS00 271
#     -----------------------------                                     MS00 272
#                                                                       MS00 273
LINRM=8#                                                                MS00 274
BUFOT(1)=FLOAT(NTOTR)#                 Tell total refs on file          MS00 275
ncodefld:(BUFOT,1,MS0F,80613.,1)#                                       MS00 276
writeline:(1,MS0F,NMS0F,3,3)#                                           MS00 277
BUFOT(1)=FLOAT(NREF)#                  Tell refs actually punched       MS00 278
ncodefld:(BUFOT,1,MS0D,80613.,1)#                                       MS00 279
writeline:(1,MS0D,NMS0D,3,3)#                                           MS00 280
#                                                                       MS00 281
RETURN#                                                                 MS00 282
END#                                                                    MS00 283
systemheader:(MS02)#                   Set reflection exactly centric   MS02   1
#********************************************************************** MS02   2
#                                                                     # MS02   3
#                             MS02                                    # MS02   4
#                                                                     # MS02   5
#********************************************************************** MS02   6
SUBROUTINE MS02(C,S)## J.M. Stewart Jun 1990                            MS02   7
# IMPLICIT NONE#                                                        MS02   8
COMMON/COMFMS/COSCHK,SINCHK#                                            MS02   9
INTEGER J#                             Loop index                       MS02  10
REAL COSCHK(9),SINCHK(9)#              Restricted value tables          MS02  11
REAL C,S#                              The cosine and sine              MS02  12
REAL MAG#                              The modulus of vector            MS02  13
realdata:(THRESH,[0.01])#              Set minimum cos/sin              MS02  14
datastuff:#                                                             MS02  15
#                                                                       MS02  16
# THIS SUBROUTINE SETS THE A AND B TO A MODULUS 1 COSINE AND SINE       MS02  17
# FOR VALUES NEAR 0, 30, 45, 60, 90, 120, 135, 150, AND THEIR           MS02  18
# SUPPLEMENTS IT SETS THE VALUES 'EXACTLY' AS THE GIVEN MACHINE         MS02  19
# REGISTER ALLOWS.                                                      MS02  20
# -------------------------------------------------------------------   MS02  21
#                                                                       MS02  22
MAG=SQRT(C**2+S**2)#                   Find length of vector            MS02  23
IF(MAG<0.00001)#                       Protect against tiny ones        MS02  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MS02  25
C=1.0 ; S=0.0#                         Make phase zero                  MS02  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MS02  27
ELSE#                                                                   MS02  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MS02  29
C=C/MAG ; S=S/MAG#                     Normalise                        MS02  30
DO J=2,6#                                                               MS02  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MS02  32
#                                                                       MS02  33
# TEST IF THE TWO COMPONENTS ARE NEAR AN EXACT CENTRIC PHASE VALUE      MS02  34
# ----------------------------------------------------------------      MS02  35
#                                                                       MS02  36
IF(ABS(ABS(C)-COSCHK(J))<THRESH&ABS(ABS(S)-SINCHK(J))<THRESH)#          MS02  37
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MS02  38
C=SIGN(COSCHK(J),C)#                   Make real component 'exact'      MS02  39
S=SIGN(SINCHK(J),S)#                   Also imaginary component         MS02  40
BREAK#                                                                  MS02  41
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MS02  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MS02  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MS02  44
RETURN#                                                                 MS02  45
END#                                                                    MS02  46
pmacro:([no:])#                        Purge xtal system macros         MS02  47
