systemheader:(MT    )#                                                  MT     1
####################################################################### MT     2
##                                                                    # MT     3
##                        *** MIND ***                                # MT     4
##                                                                    # MT     5
## Generate a file for the molecular graphics display 'mindtool'.     # MT     6
## Mindtool is a public domain program written by Julian Tirado-Rives # MT     7
## and James Blake, Chemistry Department, Yale University.            # MT     8
##                                                                    # MT     9
####################################################################### MT    10
#                                                                       MT    11
include:(XMACRO)#                                                       MT    12
#                                                                       MT    13
macro:(atomlist:,[ifelse:($1,,IA,$1)])# Define atom list pointer        MT    14
macro:(na:,[QX(atomlist:($1)+ 1)])#    Define start of atom name        MT    15
macro:(xf:,[QX(atomlist:($1)+ 3)])#    Define frac x coord              MT    16
macro:(yf:,[QX(atomlist:($1)+ 4)])#    Define frac y coord              MT    17
macro:(zf:,[QX(atomlist:($1)+ 5)])#    Define frac z coord              MT    18
macro:(ty:,[QX(atomlist:($1)+ 6)])#    Define atom type number          MT    19
macro:(fr:,[QX(atomlist:($1)+ 7)])#    Define fragment flag             MT    20
macro:(bn:,[QX(atomlist:($1)+ 8)])#    Define number of bonds           MT    21
macro:(ia:,IA+8)#                                                       MT    22
#                                                                       MT    23
extrude:(MTCOMN)#                                                       MT    24
INTEGER MARKA,STEPA,STOPA,STOPC,STOPI# Atom list pointers               MT    25
INTEGER MARKS,STEPS,STOPS#             Symmetry list pointers           MT    26
INTEGER CELL#                          Include all cell flag            MT    27
INTEGER CUTA#                          Cut atom at cell flag            MT    28
INTEGER SYMM#                          Flag to extend input sites       MT    29
INTEGER MXBC#                          Max bond count, max char/atom    MT    30
INTEGER NTYP#                          Max atom types used              MT    31
INTEGER INRAD#                         No of radii input on radii       MT    32
#                                                                       MT    33
REAL G1,G2,G3,G4,G5,G6#                Metric tensor                    MT    34
REAL DISTMX#                           Max distance parameter           MT    35
REAL CNTR(3)#                          Coord centre values              MT    36
REAL ATNUM(10)#                        Atomic number                    MT    37
REAL RADII(10)#                        Atomic radii                     MT    38
REAL RADINP(10)#                       Atomic radii modified            MT    39
REAL FTOC(3,3)#                        Fract to cart transf matrix      MT    40
#                                                                       MT    41
CHARACTER*2 ATLAB(10),RADLAB(10)#                                       MT    42
string:(SFTAB,120)#                                                     MT    43
#                                                                       MT    44
COMMON/COMIMT/ MXBC,MARKA,STEPA,STOPA,STOPC,STOPI,#                     MT    45
MARKS,STEPS,STOPS,CELL,CUTA,SYMM,INRAD,NTYP#                            MT    46
#                                                                       MT    47
COMMON/COMFMT/ DISTMX,CNTR,ATNUM,RADII,RADINP,#                         MT    48
G1,G2,G3,G4,G5,G6,FTOC#                                                 MT    49
#                                                                       MT    50
COMMON/COMCMT/ATLAB,RADLAB,SFTAB#                                       MT    51
endext:#                                                                MT    52
#                                                                       MT    53
systemheader:(MT00)#                                                    MT00   1
####################################################################### MT00   2
#                                                                     # MT00   3
#                          MT00                                       # MT00   4
#                                                                     # MT00   5
####################################################################### MT00   6
SUBROUTINE MT00#                                                        MT00   7
include:(AACOMN)#                      S.r. hall  aug 91                MT00   8
include:(MTCOMN)#                                                       MT00   9
#                                                                       MT00  10
CALL MT10#                             Enter control and atom data      MT00  11
CALL MT20#                             Generate connected atom list     MT00  12
CALL MT30#                             Output the cartesian coords      MT00  13
#                                                                       MT00  14
RETURN#                                                                 MT00  15
END#                                                                    MT00  16
systemheader:(MT10)#                   Input controls and atoms list    MT10   1
####################################################################### MT10   2
#                                                                     # MT10   3
#                          MT10                                       # MT10   4
#                                                                     # MT10   5
####################################################################### MT10   6
SUBROUTINE MT10#                                                        MT10   7
include:(AACOMN)#                                                       MT10   8
include:(MTCOMN)#                                                       MT10   9
#                                                                       MT10  10
INTEGER I,J,K,L,N#                     Loop indices                     MT10  11
INTEGER LATYP,NCENT,NOSYM#             Latt, centro, atom & symm cnt.   MT10  12
INTEGER LPAK,IP#                       Pack. size, index                MT10  13
INTEGER IWNT(10)#                      Want list for indexpkt           MT10  14
INTEGER RELPT(11)#                     Returned relative pointers       MT10  15
INTEGER KEY(4)#                        Control functions for aa15       MT10  16
REAL CDIM(9)#                          Cell a,b,c & cos a b g           MT10  17
CHARACTER*2 NAME#                      Temporary atom label             MT10  18
#                                                                       MT10  19
chardata:(MT1," MIND Control Parameters-")#                             MT10  20
chardata:(MT2," Output only the sites on the bdf")#                     MT10  21
chardata:(MT3," Output molecule after clustering")#                     MT10  22
chardata:(MT4," Output unit cell after clustering")#                    MT10  23
chardata:(MT5," Extend molecule for internal symmetry")#                MT10  24
chardata:(MT7," Trucate molecule at cell edge")#                        MT10  25
chardata:(MT9," Atom Radii for Atom Types")#                            MT10  26
chardata:(MT110, RADII END )#                                           MT10  27
chardata:(MT120,INP MOL CEL NEX SEX MCU FUL )#                          MT10  28
realdata:(CENT,[$#                                                      MT10  29
0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,#        Add for lattice type p           MT10  30
.5,.5,.5,0.,0.,0.,0.,0.,0.,1.,#        Add for lattice type i           MT10  31
.333333,.666667,.666667,.666667,.333333,.333333,0.,0.,0.,2.,# Type r    MT10  32
.0,.5,.5,.5,.0,.5,.5,.5,.0,3.,#        Add for lattice type f           MT10  33
.0,.5,.5,0.,0.,0.,0.,0.,0.,1.,#        Add for lattice type a           MT10  34
.5,.0,.5,0.,0.,0.,0.,0.,0.,1.,#        Add for lattice type b           MT10  35
.5,.5,.0,0.,0.,0.,0.,0.,0.,1.])#       Add for lattice type c           MT10  36
intdata:(ASF,[1,1,1,1,1,1,1,1,1,1,1,1,1])# Aspect source flags          MT10  37
datastuff:#                                                             MT10  38
#                                                                       MT10  39
#              SET DEFAULTS                                             MT10  40
#              ------------                                             MT10  41
#                                                                       MT10  42
SYMM=-1#                               Unset site extension flag        MT10  43
CELL=no:#                              One single molec. set            MT10  44
CUTA=no:#                              Molec. not cut at cell edges     MT10  45
INRAD=0#                               Number of input radii            MT10  46
RLAP=0.4#                              Default overlap radius           MT10  47
#                                                                       MT10  48
#   PROCESS MIND LINE                                                   MT10  49
#   -----------------                                                   MT10  50
#                                                                       MT10  51
FOR(I=1;BUFIN(I)<voidflg:;I=I+1)#      Loop over input fields           MT10  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MT10  53
stringlim:(I,M,N)#                     Get string limits                MT10  54
compchar:(CHRIN,M,MT120,1,3,4,NMT120,K)# Match with device code         MT10  55
IF(K==0) iquit:(MT1001)#               Device unknown                   MT10  56
IF(K==1) CELL=-1#                      Output bdf atom list             MT10  57
IF(K==2) CELL=no:#                     Output clustered molecule        MT10  58
IF(K==3) CELL=yes:#                    Output generated cell            MT10  59
IF(K==4) SYMM=no:#                     No symmetry added atoms          MT10  60
IF(K==5) SYMM=yes:#                    Add symmetry related atoms       MT10  61
IF(K==6) CUTA=yes:#                    Cut atoms at cell edge           MT10  62
IF(K==7) CUTA=no:#                     Atoms not truncated              MT10  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MT10  64
#                                                                       MT10  65
#     PROCESS INPUT LINE OPTIONS                                        MT10  66
#     --------------------------                                        MT10  67
#                                                                       MT10  68
REPEAT#                                Loop over input lines            MT10  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MT10  70
readline:(MT110,NMT110)#               Read next input line             MT10  71
#                                                                       MT10  72
IF(LINID==1)#                          *********** radii line           MT10  73
FOR(K=1;K<30;K=K+1)#                   Loop over preset fields          MT10  74
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MT10  75
ifvo:(BUFIN(K)) BREAK#                 Exit on first void               MT10  76
IF(BUFIN(K)>voidflg:) iquit:(MT1005)#  Must be alpha code               MT10  77
stringlim:(K,I,J)#                     Find string limits               MT10  78
INRAD=INRAD+1#                         New radii counter                MT10  79
K=K+1; IF(BUFIN(K)<0.) iquit:(MT1006)# Must be numberic value           MT10  80
RADLAB(INRAD)=CHRIN(I^J-1)#            New type of atom                 MT10  81
RADINP(INRAD)=BUFIN(K)#                New radii                        MT10  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MT10  83
#                                                                       MT10  84
ELSE BREAK#                            *********** end line             MT10  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MT10  86
#                                                                       MT10  87
#      SET MEMORY FOR IO BUFFERS                                        MT10  88
#      -------------------------                                        MT10  89
#                                                                       MT10  90
IOMARK(1)=QXSTR#                       Start of file a buffer           MT10  91
incrqx:(MARKS,QXSTR+bdfbuf:,MT1025)#   Expand buffer qx                 MT10  92
readwpkt:(1,1,LPAK,IP,0)#              Force to write list header       MT10  93
#                                                                       MT10  94
#      READ REAL CELL PARAMETERS FROM LRCELL                            MT10  95
#      -------------------------------------                            MT10  96
#                                                                       MT10  97
DO I=1,8#                              Loop over lrcell: packets        MT10  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MT10  99
readwpkt:(1,lrcell:,LPAK,IP,0)#        Read the next pkt                MT10 100
IF(IP<=0) BREAK#                       End of logical record            MT10 101
#                                                                       MT10 102
IF(I==1) DO L=1,9; CDIM(L)=QX(IP+L)#   Real cell a,b,c & cos a,b,g      MT10 103
#                                                                       MT10 104
IF(I==7)#                              Test if metric tensor            MT10 105
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MT10 106
G1=QX(IP+1)#                           A**2                             MT10 107
G2=QX(IP+5)#                           B**2                             MT10 108
G3=QX(IP+9)#                           C**2                             MT10 109
G4=QX(IP+2)*2.#                        2 a b cosg                       MT10 110
G5=QX(IP+3)*2.#                        2 a c cosb                       MT10 111
G6=QX(IP+6)*2.#                        2 b c cosa                       MT10 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MT10 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MT10 114
##                                                                      MT10 115
##  CALC ORTHOGONAL TRANSF MATRIX (Cart x // cell a)                    MT10 116
##  ------------------------------------------------                    MT10 117
##                                                                      MT10 118
SING=SQRT(1.-CDIM(6)**2)#              Sin(gamma)                       MT10 119
H1=(CDIM(4)-CDIM(5)*CDIM(6))/SING#     (cos(a)-cos(b)*cos(g))/sin(g)    MT10 120
FTOC(1,1)=CDIM(1)#                     A                                MT10 121
FTOC(1,2)=CDIM(2)*CDIM(6)#             B*cos(g)                         MT10 122
FTOC(1,3)=CDIM(3)*CDIM(5)#             C*cos(b)                         MT10 123
FTOC(2,1)=0.#                          0.                               MT10 124
FTOC(2,2)=CDIM(2)*SING#                B*sin(g)                         MT10 125
FTOC(2,3)=CDIM(3)*H1#                  C*[h1]                           MT10 126
FTOC(3,1)=0.#                          0.                               MT10 127
FTOC(3,2)=0.#                          0.                               MT10 128
FTOC(3,3)=CDIM(3)*SQRT(1.-CDIM(5)**2-H1**2)# C*sqrt(...)                MT10 129
#                                                                       MT10 130
#      READ SYMMETRY INFORMATION FROM LRSYMM                            MT10 131
#      -------------------------------------                            MT10 132
#                                                                       MT10 133
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Read the 1st sym pkt             MT10 134
LATYP=NINT(QX(IP+1))#                  Lattice type                     MT10 135
NCENT=NINT(QX(IP+2))#                  Centric / acentric  0/1          MT10 136
NOSYM=NINT(QX(IP+3))#                  Total no of symm. rel. rot.      MT10 137
IF(SYMM<0&QX(IP+8)<QX(IP+3)) SYMM=yes:# If mole symm extend sites       MT10 138
ELSE IF(SYMM<0)              SYMM=no:# Only use input sites             MT10 139
incrqx:(MARKA,MARKS+NOSYM*LPAK,MT1028)# Memory for symop table          MT10 140
FOR(J=MARKS;J>0;J=J+LPAK)#             Loop thro. symm. rec.            MT10 141
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MT10 142
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Read sym. rel. rotations         MT10 143
IF(IP<=0) BREAK#                       Finished                         MT10 144
movereal:(QX,IP+1,QX,J+1,LPAK,1)#      Store symm. rel. rotations       MT10 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MT10 146
STEPS=LPAK#                            Step through sym. rec.           MT10 147
STOPS=J;    IP=STOPS#                  End of sym. rec. read in         MT10 148
IF(LATYP>7) LATYP=LATYP-7#             Reduce to centrosymmetric        MT10 149
IF(LATYP>1)#                           Add symmops if non-primitive     MT10 150
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MT10 151
L =(LATYP-1)*10#                       Start in cent array              MT10 152
N =NINT(CENT(LATYP*10))*3-1#           No. of triples to add            MT10 153
DO K=0,N,3#                            Loop thro. cent array            MT10 154
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop thro. symm. rec.            MT10 155
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MT10 156
movereal:(QX,J+1,QX,IP+1,STEPS,1)#     Rotation matrix equivalent       MT10 157
QX(IP+10)=MOD(QX(IP+10)+CENT(L+K+1),1.)# Add to translation in x        MT10 158
QX(IP+11)=MOD(QX(IP+11)+CENT(L+K+2),1.)# Add to translation in y        MT10 159
QX(IP+12)=MOD(QX(IP+12)+CENT(L+K+3),1.)# Add to translation in z        MT10 160
IP=IP+STEPS#                           Set start of new symm. rec.      MT10 161
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MT10 162
STOPS=IP#                              End of symmops.                  MT10 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MT10 164
N=STOPS-MARKS+1#                       Number of elements               MT10 165
IF(NCENT==0)#                          In case of centrosymmetry        MT10 166
DO J=1,N; QX(STOPS+J)=-QX(MARKS+J)#    Set centro elements              MT10 167
STOPS=MARKA#                           End of symops.                   MT10 168
STEPA=8+MXBC#                          Atom list step size              MT10 169
#                                                                       MT10 170
#        LRSCAT REQUEST BOND RADIUS                                     MT10 171
#        --------------------------                                     MT10 172
#                                                                       MT10 173
IWNT(1)=5; IWNT(2)=11; IWNT(3)=3#      Bond radius and atom name        MT10 174
KEY(1)=3; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search keys                 MT10 175
indexpkt:(1,lrscat:,LPAK,IP,0,KEY,IWNT,RELPT)# Test for wanted items    MT10 176
IF(KEY(4)<=0) iquit:(MT1030)#          Item not found-exit              MT10 177
A=0.;       SFTAB=' '#                 Zero max radius                  MT10 178
DO I=1,10#                             Loop for atom types              MT10 179
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MT10 180
readwpkt:(1,lrscat:,LPAK,IP,0)#        Read atom type param.            MT10 181
IF(IP<=0) BREAK#                       Test for end of types            MT10 182
movertoc:(QX(IP+RELPT(2)),1,NAME,1,2,0)# Extract atom type label        MT10 183
ATLAB(I)=NAME#                         Store atom type label            MT10 184
movechar:(NAME,1,SFTAB,I*8-7,2,0)#     Store scat factor table          MT10 185
RADII(I)=QX(IP+RELPT(1))+0.1#          Store bond radius and incr.      MT10 186
DO J=1,INRAD#                          Loop over input radii            MT10 187
IF(RADLAB(J)==NAME) RADII(I)=RADINP(J)# Store input radius              MT10 188
A=MAX(A,RADII(I))#                     Get largest possible radii       MT10 189
ATNUM(I)=QX(IP+RELPT(3))#              Extract the atomic number        MT10 190
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MT10 191
NTYP=I-1#                              Store total atom types           MT10 192
#                                                                       MT10 193
#       LRATOM REQUEST ATOMIC PARAMETERS                                MT10 194
#       --------------------------------                                MT10 195
#                                                                       MT10 196
STOPA=MARKA#                           There are no atoms on bdf        MT10 197
IWNT(1)=1;   IWNT(2)=2;   IWNT(3)=3#   X,y,z                            MT10 198
IWNT(4)=22;  IWNT(5)=14#               Atom name (namln: words)         MT10 199
KEY(1)=5; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search keys                 MT10 200
indexpkt:(1,lratom:,LPAK,IP,0,KEY,IWNT,RELPT)# Test for wanted items    MT10 201
IF(IP>0&KEY(4)>0)#                     If items present extract         MT10 202
FOR(IA=MARKA;IA>0;IA=STOPA)#           Loop thro. atoms                 MT10 203
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MT10 204
readwpkt:(1,lratom:,LPAK,IP,0)#        Read atom param.                 MT10 205
IF(IP<=0) BREAK#                       Test for end of atoms            MT10 206
incrqx:(STOPA,IA+STEPA,MT1040)#        Expand qx for one atom           MT10 207
movereal:(QX,IP+RELPT(5),na:,1,2,1)#   Store atom name                  MT10 208
xf:=QX(IP+RELPT(1))#                   Store x frac.                    MT10 209
yf:=QX(IP+RELPT(2))#                   Store y frac.                    MT10 210
zf:=QX(IP+RELPT(3))#                   Store z frac.                    MT10 211
ty:=QX(IP+RELPT(4))#                   Store atom type number           MT10 212
fr:=FLOAT(IA)#                         Save original atom table posn    MT10 213
bn:=0.#                                Store zero bond count            MT10 214
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MT10 215
readwpkt:(1,endrecord:,I,I,0)#         Finish off file a                MT10 216
#                                                                       MT10 217
#             PRINT MIND PARAMETERS                                     MT10 218
#             ---------------------                                     MT10 219
#                                                                       MT10 220
movechar:(MT1,NMT1,CHROT,2,NMT1-2,1)#  Fill text into chrot             MT10 221
writeline:(1,MT1,NMT1-1,2,3)#          Print header                     MT10 222
IF(CELL==-1)    writeline:(0,MT2,NMT2,3,3)# Print input only header     MT10 223
IF(CELL==no:)   writeline:(0,MT3,NMT3,3,3)# Print molecule header       MT10 224
IF(CELL==yes:)  writeline:(0,MT4,NMT4,3,3)# Print cell header           MT10 225
IF(SYMM==yes:)  writeline:(0,MT5,NMT5,3,3)# Print extension header      MT10 226
IF(CUTA==yes:)  writeline:(0,MT7,NMT7,3,3)# Write line out              MT10 227
writeline:(1,MT9,NMT9,3,3)#            Write line                       MT10 228
DO J=1,NTYP#                           Loop over input radii            MT10 229
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MT10 230
CHROT(5^6)=ATLAB(J)#                   Insert atom type label           MT10 231
ncodefld:(RADII,J,CHROT,200822.,1)#    Format atom radii                MT10 232
writeline:(0,0,0,1,3)#                 Write line                       MT10 233
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MT10 234
#                                                                       MT10 235
RETURN#                                                                 MT10 236
END#                                                                    MT10 237
systemheader:(MT20)#                   Generate atom connections list   MT20   1
####################################################################### MT20   2
#                                                                     # MT20   3
#                          MT20                                       # MT20   4
#                                                                     # MT20   5
####################################################################### MT20   6
SUBROUTINE MT20#                                                        MT20   7
include:(AACOMN)#                      S.r. hall aug 91                 MT20   8
include:(MTCOMN)#                                                       MT20   9
#                                                                       MT20  10
INTEGER I,J,K,N,M#                                                      MT20  11
INTEGER IA,JA,KA,LT#                                                    MT20  12
INTEGER FNEW#                                                           MT20  13
REAL    TC1(125),TC2(125),TC3(125)#                                     MT20  14
REAL    X,Y,Z,U,V,W,P,Q,R#                                              MT20  15
REAL    CX,CY,CZ,CN#                                                    MT20  16
REAL    DIST,RAD,D#                                                     MT20  17
REAL    SP(3)#                                                          MT20  18
#                                                                       MT20  19
string:(NAME,8)#                                                        MT20  20
realdata:(CORN,[$#                                                      MT20  21
2.,3.,5.,1.,4.,6.,1.,4.,7.,2.,3.,8.,#                                   MT20  22
1.,6.,7.,2.,5.,8.,3.,5.,8.,4.,6.,7.])#                                  MT20  23
datastuff:#                                                             MT20  24
#                                                                       MT20  25
#       SET UP THE UNIT CELL TRANSLATION TABLE                          MT20  26
#       --------------------------------------                          MT20  27
#                                                                       MT20  28
STOPC=STOPA#                           Set end of atom list             MT20  29
IF(CELL>=0)#                           For mole or cell                 MT20  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MT20  31
IF(CELL==yes:) N=2#                    Set maximum translations         MT20  32
ELSE           N=0#                    Set one cell translation         MT20  33
NTRAN=0#                               Set translation count            MT20  34
DO I=-N,N; DO J=-N,N; DO K=-N,N#       Loop over cell extensions        MT20  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MT20  36
NTRAN=NTRAN+1#                         Count cell translations          MT20  37
TC1(NTRAN)=FLOAT(I)#                   Cell translation along x         MT20  38
TC2(NTRAN)=FLOAT(J)#                   Cell translation along y         MT20  39
TC3(NTRAN)=FLOAT(K)#                   Cell translation along z         MT20  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MT20  41
#                                                                       MT20  42
#    PLACE SITES IN CLUSTERS ABOUT THE BODY CENTRE                      MT20  43
#    ---------------------------------------------                      MT20  44
#                                                                       MT20  45
NC=0;     STOPI=STOPA#                 Zero cluster counter             MT20  46
REPEAT#                                Loop until all atoms clustered   MT20  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MT20  48
DIST=9999999.;   FNEW=yes:#            Set starting distance            MT20  49
#                                                                       MT20  50
FOR(JA=MARKA;JA<STOPA;JA=JA+STEPA)#    Loop over input atoms            MT20  51
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MT20  52
IF(bn:(JA)>0.) NEXT#                   Skip if already positioned       MT20  53
A=xf:(JA);  B=yf:(JA);  C=zf:(JA)#     Store coordinates                MT20  54
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symops                 MT20  55
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MT20  56
X=A*QX(J+1)+B*QX(J+4)+C*QX(J+7)+QX(J+10)# Get symoped x                 MT20  57
Y=A*QX(J+2)+B*QX(J+5)+C*QX(J+8)+QX(J+11)# Get symoped y                 MT20  58
Z=A*QX(J+3)+B*QX(J+6)+C*QX(J+9)+QX(J+12)# Get symoped z                 MT20  59
U=MOD(99.+X,1.0)-0.5#                  Get closest to body centre       MT20  60
V=MOD(99.+Y,1.0)-0.5#                  Get closest to body centre       MT20  61
W=MOD(99.+Z,1.0)-0.5#                  Get closest to body centre       MT20  62
D=G1*U*U+G2*V*V+G3*W*W+G4*U*V+G5*U*W+G6*V*W# Get distance squared       MT20  63
IF(D>=DIST) NEXT#                      New eq. pos. closer to center    MT20  64
P=U+.5;  Q=V+.5;  R=W+.5#              Store coordinates                MT20  65
DIST=D-0.01;   IA=JA#                  Store dist. to cell center       MT20  66
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MT20  67
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MT20  68
IF(DIST>9999998.) BREAK#               Exit if all clustered            MT20  69
#                                                                       MT20  70
NC=NC+1;      bn:=FLOAT(NC)#           Counter for cluster              MT20  71
xf:=P;  yf:=Q;  zf:=R#                 Store new atom coords            MT20  72
#                                                                       MT20  73
WHILE(FNEW==yes:)#                     Loop over all connected atoms    MT20  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MT20  75
FNEW=no:#                              Assume no connections            MT20  76
FOR(JA=MARKA;JA<STOPA;JA=JA+STEPA)#    Loop over input atoms            MT20  77
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MT20  78
ifne:(bn:(JA),bn:) NEXT#               Process only new bonded atoms    MT20  79
RAD=RADII(NINT(ty:(JA)))#              Bond radius                      MT20  80
P=xf:(JA);  Q=yf:(JA);  R=zf:(JA)#     Store current x,y,z              MT20  81
#                                                                       MT20  82
FOR(KA=MARKA;KA<STOPA;KA=KA+STEPA)#    Loop over input atoms            MT20  83
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MT20  84
ifne:(bn:(KA),0.) NEXT#                Skip if atom already bonded      MT20  85
DIST=(RAD+RADII(NINT(ty:(KA))))**2#    Get max distance squared         MT20  86
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symops                 MT20  87
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MT20  88
X=xf:(KA)*QX(J+1)+yf:(KA)*QX(J+4)+zf:(KA)*QX(J+7)+QX(J+10)# Get x       MT20  89
Y=xf:(KA)*QX(J+2)+yf:(KA)*QX(J+5)+zf:(KA)*QX(J+8)+QX(J+11)# Get y       MT20  90
Z=xf:(KA)*QX(J+3)+yf:(KA)*QX(J+6)+zf:(KA)*QX(J+9)+QX(J+12)# Get x       MT20  91
U=MOD(99.5+X-P,1.0)-0.5#               Get closest to bonded atom       MT20  92
V=MOD(99.5+Y-Q,1.0)-0.5#               Get closest to bonded atom       MT20  93
W=MOD(99.5+Z-R,1.0)-0.5#               Get closest to bonded atom       MT20  94
D=G1*U*U+G2*V*V+G3*W*W+G4*U*V+G5*U*W+G6*V*W# Get distance squared       MT20  95
IF(D<DIST) GOTO 100#                   Contact found so exit            MT20  96
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MT20  97
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MT20  98
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MT20  99
NEXT#                                  Connect not found                MT20 100
100 FNEW=yes:;    bn:(KA)=bn:#         New bonded atom                  MT20 101
xf:(KA)=P+U; yf:(KA)=Q+V; zf:(KA)=R+W# Store new coordinates            MT20 102
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MT20 103
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MT20 104
#                                                                       MT20 105
#    EXTEND INPUT ATOM LIST TO INCLUDE ALL CONNECTIONS                  MT20 106
#    -------------------------------------------------                  MT20 107
#                                                                       MT20 108
FOR(FNEW=SYMM;FNEW==yes:;)#            Loop until no connections        MT20 109
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MT20 110
FNEW=no:#                              Assume no connections found      MT20 111
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over all sites              MT20 112
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MT20 113
RAD=RADII(NINT(ty:))#                  Bond radius                      MT20 114
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symops                 MT20 115
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MT20 116
U=xf:*QX(J+1)+yf:*QX(J+4)+zf:*QX(J+7)+QX(J+10)# New x'                  MT20 117
V=xf:*QX(J+2)+yf:*QX(J+5)+zf:*QX(J+8)+QX(J+11)# New y'                  MT20 118
W=xf:*QX(J+3)+yf:*QX(J+6)+zf:*QX(J+9)+QX(J+12)# New z'                  MT20 119
#                                                                       MT20 120
FOR(JA=MARKA;JA<STOPA;JA=JA+STEPA)#    Loop thro. all stored atoms      MT20 121
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MT20 122
ifne:(bn:,bn:(JA))  NEXT#              Skip if different cluster        MT20 123
IF(IA==JA&J==MARKS) NEXT#              Avoid identical overlap          MT20 124
P=MOD(99.5+U-xf:(JA),1.0)-0.5#         Get closest bonded atom          MT20 125
Q=MOD(99.5+V-yf:(JA),1.0)-0.5#         Get closest bonded atom          MT20 126
R=MOD(99.5+W-zf:(JA),1.0)-0.5#         Get closest bonded atom          MT20 127
D=G1*P*P+G2*Q*Q+G3*R*R+G4*P*Q+G5*P*R+G6*Q*R# Get distance squared       MT20 128
IF(D<.01\D>(RAD+RADII(NINT(ty:(JA))))**2) NEXT# Skip if not bond        MT20 129
P=P+xf:(JA); Q=Q+yf:(JA); R=R+zf:(JA)# Store new coords                 MT20 130
#                                                                       MT20 131
FOR(KA=MARKA;KA<STOPA;KA=KA+STEPA)#    Atom pos. already stored ?       MT20 132
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MT20 133
ifne:(bn:,bn:(KA))      NEXT#          Skip if different cluster        MT20 134
IF(ABS(MOD(99.5+P-xf:(KA),1.)-.5)>.001) NEXT# Skip if x coord diff      MT20 135
IF(ABS(MOD(99.5+Q-yf:(KA),1.)-.5)>.001) NEXT# Skip if y coord diff      MT20 136
IF(ABS(MOD(99.5+R-zf:(KA),1.)-.5)<.001) BREAK# Break if pos. equiv.     MT20 137
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MT20 138
IF(KA<STOPA) NEXT#                     Pos. not found-new atom          MT20 139
I=STOPA;       FNEW=yes:#              Save current end of list         MT20 140
incrqx:(STOPA,STOPA+STEPA,MT2005)#     Incr. qx to store new atom inf   MT20 141
xf:(I)=P;    yf:(I)=Q;    zf:(I)=R#    Store new coords                 MT20 142
bn:(I)=bn:;  ty:(I)=ty:;  fr:(I)=fr:#  Store cluster & atom type        MT20 143
movertoc:(na:,1,NAME,1,8,0)#           Get the atom name                MT20 144
DO K=1,8; IF(NAME(K^K)==' ') BREAK#    Get last blank                   MT20 145
IF(K<9) NAME(K^K)='*'#                 Flag name with an asterisk       MT20 146
movector:(NAME,1,na:(I),1,8,0)#        Store flagged atom label         MT20 147
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MT20 148
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MT20 149
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MT20 150
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MT20 151
#                                                                       MT20 152
#    PACK CLUSTERS CLOSE TOGETHER                                       MT20 153
#    ----------------------------                                       MT20 154
#                                                                       MT20 155
DO N=1,NC#                             Loop over clusters               MT20 156
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MT20 157
DO I=1,3; SP(I)=0;   CN=0.#            Zero coord sums                  MT20 158
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over input atoms            MT20 159
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MT20 160
IF(NINT(bn:)!=N) NEXT#                 Atom member of cur. cluster      MT20 161
DO I=1,3; SP(I)=SP(I)+QX(IA+I+2)#      Sum all coords                   MT20 162
CN=CN+1.;        bn:=-bn:#             Sum members and reset cluster    MT20 163
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MT20 164
DO I=1,3; SP(I)=SP(I)/CN#              Calc cluster centre              MT20 165
IF(N==1)#                              For first cluster                MT20 166
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MT20 167
CX=SP(1); CY=SP(2); CZ=SP(3); NEXT#    Centre of root cluster           MT20 168
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MT20 169
DIST=999999.#                          Set starting distance            MT20 170
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symops                 MT20 171
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MT20 172
X=QX(J+1)*SP(1)+QX(J+4)*SP(2)+QX(J+7)*SP(3)+QX(J+10)# Get centre x      MT20 173
Y=QX(J+2)*SP(1)+QX(J+5)*SP(2)+QX(J+8)*SP(3)+QX(J+11)# Get centre y      MT20 174
Z=QX(J+3)*SP(1)+QX(J+6)*SP(2)+QX(J+9)*SP(3)+QX(J+12)# Get centre z      MT20 175
P=X-CX;  Q=Y-CY;  R=Z-CZ#              Get diff with centre 1           MT20 176
U=MOD(99.5+P,1.)-0.5#                  Get smallest difference          MT20 177
V=MOD(99.5+Q,1.)-0.5#                  Get smallest difference          MT20 178
W=MOD(99.5+R,1.)-0.5#                  Get smallest difference          MT20 179
D=G1*U*U+G2*V*V+G3*W*W+G4*U*V+G5*U*W+G6*V*W# Get distance squared       MT20 180
IF(D>=DIST) NEXT#                      Skip if larger                   MT20 181
SX=U-P; SY=V-Q; SZ=W-R; K=J;  DIST=D-0.01# Closest to centre 1          MT20 182
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MT20 183
#                                                                       MT20 184
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over input atoms            MT20 185
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MT20 186
IF(NINT(-bn:)!=N) NEXT#                Select atom from this cluster    MT20 187
X=xf:*QX(K+1)+yf:*QX(K+4)+zf:*QX(K+7)+QX(K+10)# Get symoped x           MT20 188
Y=xf:*QX(K+2)+yf:*QX(K+5)+zf:*QX(K+8)+QX(K+11)# Get symoped y           MT20 189
Z=xf:*QX(K+3)+yf:*QX(K+6)+zf:*QX(K+9)+QX(K+12)# Get symoped z           MT20 190
xf:=X+SX;  yf:=Y+SY;  zf:=Z+SZ#        Store new atom coords            MT20 191
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MT20 192
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MT20 193
#                                                                       MT20 194
#    ENSURE CENTRE OF PACKED CLUSTERS INSIDE CELL                       MT20 195
#    --------------------------------------------                       MT20 196
#                                                                       MT20 197
DO I=1,3; SP(3)=0.;    CN=0.#          Set centre sums to zero          MT20 198
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over all sites              MT20 199
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MT20 200
CN=CN+1.#                              Count contributions              MT20 201
DO I=1,3; SP(I)=SP(I)+QX(IA+I+2)#      Sum all coords                   MT20 202
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MT20 203
DO I=1,3#                              Loop over coords                 MT20 204
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MT20 205
SP(I)=SP(I)/CN#                        Get average coord                MT20 206
IF     (SP(I)<0.) SP(I)=+1.#           Centre out of cell               MT20 207
ELSE IF(SP(I)>1.) SP(I)=-1.#           Centre out of cell               MT20 208
ELSE              SP(I)= 0.#           Centre in cell                   MT20 209
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MT20 210
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over all sites              MT20 211
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MT20 212
DO I=1,3; QX(IA+I+2)=QX(IA+I+2)+SP(I)# Move to new centre               MT20 213
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MT20 214
#                                                                       MT20 215
#    EXPAND LIST FOR CELL IF REQUESTED                                  MT20 216
#    ---------------------------------                                  MT20 217
#                                                                       MT20 218
IF(CUTA==yes:) T1=-.00001;ELSE T1=-1.# Set lower cell search limits     MT20 219
IF(CUTA==yes:) T2=1.00001;ELSE T2= 2.# Set upper cell search limits     MT20 220
IF(CELL==yes:)#                        Whole unit cell                  MT20 221
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MT20 222
N=STOPA#                               Keep end of current list         MT20 223
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symops                 MT20 224
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MT20 225
DO LT=1,NTRAN#                         Calc. all possible transl.       MT20 226
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MT20 227
M=STOPA#                               Reset new molecule start         MT20 228
FOR(IA=MARKA;IA<N;IA=IA+STEPA)#        Loop over current atom list      MT20 229
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MT20 230
P=xf:*QX(J+1)+yf:*QX(J+4)+zf:*QX(J+7)+QX(J+10)+TC1(LT)# New x'          MT20 231
IF(P<T1\P>T2) NEXT#                    Skip if outside cell limits      MT20 232
Q=xf:*QX(J+2)+yf:*QX(J+5)+zf:*QX(J+8)+QX(J+11)+TC2(LT)# New y'          MT20 233
IF(Q<T1\Q>T2) NEXT#                    Skip if outside cell limits      MT20 234
R=xf:*QX(J+3)+yf:*QX(J+6)+zf:*QX(J+9)+QX(J+12)+TC3(LT)# New z'          MT20 235
IF(R<T1\R>T2) NEXT#                    Skip if outside cell limits      MT20 236
#                                                                       MT20 237
FOR(JA=MARKA;JA<M;JA=JA+STEPA)#        Atom pos. already stored ?       MT20 238
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MT20 239
IF(ABS(P-xf:(JA))>.001) NEXT#          Skip if x coord different        MT20 240
IF(ABS(Q-yf:(JA))>.001) NEXT#          Skip if y coord different        MT20 241
IF(ABS(R-zf:(JA))<.001) BREAK#         Break if pos. equiv.             MT20 242
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MT20 243
IF(JA<M) NEXT#                         Exit if duplicate site found     MT20 244
incrqx:(M,M+STEPA,MT2005)#             Incr. qx to store new atom inf   MT20 245
xf:(JA)=P;    yf:(JA)=Q;    zf:(JA)=R# Store new coords                 MT20 246
bn:(JA)=bn:;  ty:(JA)=ty:;  fr:(JA)=fr:# Store cluster & atom type      MT20 247
movereal:(na:,1,na:(JA),1,2,0)#        New atom name                    MT20 248
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MT20 249
FOR(IA=STOPA;IA<M;IA=IA+STEPA)#        Loop over new atoms              MT20 250
IF(xf:>-.00001&yf:>-.00001&zf:>-.00001$# If one atom in cell            MT20 251
  &xf:<1.00001&yf:<1.00001&zf:<1.00001) BREAK# Keep this molec.         MT20 252
IF(IA<M) STOPA=M#                      Reset the list limit             MT20 253
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MT20 254
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MT20 255
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MT20 256
#                                                                       MT20 257
#    REMOVE SITES OUTSIDE CELL                                          MT20 258
#    -------------------------                                          MT20 259
#                                                                       MT20 260
IF(CUTA==yes:&CELL==yes:)#             Cut on cell corners if unit ce   MT20 261
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over all atoms              MT20 262
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MT20 263
IF(xf:>-.00001&yf:>-.00001&zf:>-.00001$# If one atom in cell            MT20 264
  &xf:<1.00001&yf:<1.00001&zf:<1.00001) NEXT# Keep this atom site       MT20 265
movereal:(QX,IA+STEPA,QX,IA,STOPA-IA,1)# Push back atom list a step     MT20 266
STOPA=STOPA-STEPA; IA=IA-STEPA#        Decrement by one atom            MT20 267
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MT20 268
STOPC=STOPA#                           Set end of atom list             MT20 269
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MT20 270
#                                                                       MT20 271
RETURN#                                                                 MT20 272
END#                                                                    MT20 273
systemheader:(MT30)#                   Store and transform coords.      MT30   1
####################################################################### MT30   2
#                                                                     # MT30   3
#                                MT30                                 # MT30   4
#                                                                     # MT30   5
####################################################################### MT30   6
SUBROUTINE MT30#                       S.r. hall aug 91                 MT30   7
include:(AACOMN)#                                                       MT30   8
include:(MTCOMN)#                                                       MT30   9
#                                                                       MT30  10
INTEGER I#                                                              MT30  11
REAL XC(4)#                                                             MT30  12
string:(LINE,50)#                                                       MT30  13
chardata:(XYZ,' 000 00Z 0Y0 0YZ X00 X0Z XY0 XYZ')#                      MT30  14
chardata:(CON,' 1 2 1 3 1 5 2 4 2 6 3 4 3 7 4 8 5 6 5 7 6 8 7 8 ')#     MT30  15
realdata:(FMT,[50513.,171252.,291252.,411252.])#                        MT30  16
datastuff:#                                                             MT30  17
#                                                                       MT30  18
#    OUTPUT MINDTOOL CONTROLS                                           MT30  19
#    ------------------------                                           MT30  20
#                                                                       MT30  21
FILEXT(iofm1:)='atm'#                  Define fmt as atom line file     MT30  22
openfmt:(iofm1:,' ')#                  Open atom line file              MT30  23
LINE='Mind  0.3  0.667'#               Set opening line                 MT30  24
writefmt:(iofm1:,'(A)',LINE(1^16))#    Write header to file             MT30  25
LINE='$set model ball'#                Set model type                   MT30  26
writefmt:(iofm1:,'(A)',LINE(1^15))#    Write header to file             MT30  27
LINE='$set bonds round'#               Set bonds type                   MT30  28
writefmt:(iofm1:,'(A)',LINE(1^16))#    Write header to file             MT30  29
LINE='$set label char'#                Set add atom labels              MT30  30
writefmt:(iofm1:,'(A)',LINE(1^15))#    Write header to file             MT30  31
N=0#                                   Set cell origin count            MT30  32
#                                                                       MT30  33
#   PUT CELL CORNERS INTO ATOM LIST                                     MT30  34
#   -------------------------------                                     MT30  35
#                                                                       MT30  36
IF(CELL==yes:)#                        Add cell corners or not          MT30  37
DO I=0,1; DO J=0,1; DO K=0,1#          Loop over cell edges             MT30  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MT30  39
N=N+1;   LINE='2'//XYZ(N*4-3^N*4)#     Store origin symbol              MT30  40
U=FLOAT(I);  V=FLOAT(J);  W=FLOAT(K)#  Set cell origins                 MT30  41
DO L=1,3; XC(L)=(U*FTOC(L,1)+V*FTOC(L,2)+W*FTOC(L,3))# Cart xyz         MT30  42
ncodefld:(XC,1,LINE,FMT(2),3)#         Format the cartesian coords      MT30  43
writefmt:(iofm1:,'(A)',LINE(1^50))#    Write addatm header to file      MT30  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MT30  45
#                                                                       MT30  46
#     OUTPUT CARTESIAN COORDINATES                                      MT30  47
#     ----------------------------                                      MT30  48
#                                                                       MT30  49
FOR(IA=MARKA;IA<STOPC;IA=IA+STEPA)#    Loop over stored atoms           MT30  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MT30  51
XC(1)=ATNUM(NINT(ty:))#                Get the atom number              MT30  52
U=xf:;   V=yf:;   W=zf:#               Get displacements                MT30  53
DO I=1,3; XC(I+1)=(U*FTOC(I,1)+V*FTOC(I,2)+W*FTOC(I,3))# Cart xyz       MT30  54
ncodefld:(XC,1,LINE,FMT,4)#            Format the cartesian coords      MT30  55
movertoc:(na:,1,LINE,45,4,0)#          Extract 4-char atom label        MT30  56
writefmt:(iofm1:,'(A)',LINE(1^50))#    Write addatm header to file      MT30  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MT30  58
#                                                                       MT30  59
#   PUT CELL CORNERS INTO ATOM LIST                                     MT30  60
#   -------------------------------                                     MT30  61
#                                                                       MT30  62
IF(CELL==yes:)#                        Add cell corners or not          MT30  63
DO I=1,12#                                                              MT30  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MT30  65
LINE='$add bond'//CON(I*4-3^I*4)#      Generate bond connection         MT30  66
writefmt:(iofm1:,'(A)',LINE(1^13))#    Write addatm header to file      MT30  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MT30  68
closefmt:(iofm1:)#                     Close atom line file             MT30  69
#                                                                       MT30  70
#   EXECUTE STANDALONE PROGRAM MINDTOOL                                 MT30  71
#   -----------------------------------                                 MT30  72
#                                                                       MT30  73
CALL SYSTEM('mindtool '//FILENM(iofm1:))# Excute sun system call        MT30  74
#                                                                       MT30  75
RETURN#                                                                 MT30  76
END#                                                                    MT30  77
pmacro:([no:])#                                                         MT30  78
