systemheader:(MU    )#                                                  MU     1
####################################################################### MU     2
#                                                                     # MU     3
#                           *** MULIST ***                            # MU     4
#                                                                     # MU     5
#    THE PROGRAM MULIST PRODUCES A NUMBER OF DIFFERENT LISTINGS OF    # MU     6
#     OBSERVATIONS AND REFLECTIONS FOUND ON A BDF CONTAINING MORE     # MU     7
#     THAN ONE OBSERVATION PER REFLECTION.  SUCH A FILE IS CREATED    # MU     8
#     BY MAKEF, SCALE1, EDITMO, OR MERGOB.                            # MU     9
####################################################################### MU    10
#                                                                       MU    11
include:(XMACRO)#                                                       MU    12
#                                                                       MU    13
macro:(max:,1500)#                     Max. number of obs./refl.        MU    14
macro:(maxshifts:,500)#                Maximum number of shifts tha     MU    15
macro:(maxslots:,80)#                  Max. number of slots allowed     MU    16
macro:(stuff:,[$(#                     Store away f**2, sigma(f**2)     MU    17
FPT = FPT + 3#                         And shift number for each        MU    18
movereal:(QX,FPT+1,BUFOT,LCT+1,3,0)#   Observation.                     MU    19
LCT = LCT + 3$)])#                     Increment the position count     MU    20
#                                                                       MU    21
extrude:(MUCOMN)#                                                       MU    22
INTEGER ALLOWD#                        Maximum number of obs./refl.     MU    23
#                                         Allowed.                      MU    24
INTEGER ENDPTR#                        Points to last index into th     MU    25
#                                         Qx currently used.            MU    26
INTEGER FPTR#                          Pointer to initial f**2 in       MU    27
#                                         Buffer.                       MU    28
INTEGER HKL#                           Packed hkl, space group          MU    29
INTEGER HKLBY#                         Packed hkl, bijvoet              MU    30
INTEGER HKLNOW#                        Packed hkl found on lrrefl:      MU    31
INTEGER HKLNXT#                        Packed hkl for next reflecti     MU    32
#                                         On the bdf.                   MU    33
INTEGER HPTR#                          Pointer to start of table of     MU    34
#                                         Packed hkls.                  MU    35
INTEGER IMERGE#                        If zero, merge space group a     MU    36
#                                         Bijvoet obs.                  MU    37
INTEGER MAXOBS#                        Maximum number of observatio     MU    38
#                                         To be listed.                 MU    39
INTEGER MAXRFS#                        Maximum number of reflection     MU    40
#                                         To be listed.                 MU    41
INTEGER MAXS#                          Number of sine(theta)/lambda     MU    42
#                                         Slots.                        MU    43
INTEGER MAXY#                          Number of f**2 slots             MU    44
INTEGER NREFS1(maxslots:)#             Number of refls. in each f**     MU    45
#                                         Slot.                         MU    46
INTEGER NREFS2(maxslots:)#             Number of refls. in each sit     MU    47
#                                         Slot.                         MU    48
INTEGER NREFS3(maxslots:)#             Number of refls. multiply        MU    49
#                                         Observed in each f**2 slot.   MU    50
INTEGER NREFS4(maxslots:)#             Number of refls. multiply        MU    51
#                                         Observed in each sitol slot.  MU    52
INTEGER NOREPS#                        Number of unreplicated refls     MU    53
INTEGER NSHIFT#                        Number of scale groups           MU    54
INTEGER OBS#                           Total obs. for current refl.     MU    55
INTEGER OBSBY#                         Total bijvoet obs. for curre     MU    56
#                                         Reflection.                   MU    57
INTEGER OBSKIP#                        Obs. skipped for current ref     MU    58
INTEGER OBSSG#                         Total space group obs. for       MU    59
#                                         Current refl.                 MU    60
INTEGER OPTION#                        The listing option selected      MU    61
INTEGER PGPTR#                         Pointer to start of page-ful     MU    62
#                                         Of hkls.                      MU    63
INTEGER REFBY#                         Number of refls. with bijvoe     MU    64
#                                         Only obs.                     MU    65
INTEGER REFSG#                         Number of refls. with space      MU    66
#                                         Group only obs.               MU    67
INTEGER RFBOTH#                        Number of refls. with both       MU    68
#                                         Space group and bijvoet obs.  MU    69
INTEGER SCPTR#                         Pointer to first scale facto     MU    70
INTEGER SHPTR#                         Pointer to first shift numbe     MU    71
INTEGER SLOTS#                         Number of slots to divide        MU    72
#                                         Statistical listings into.    MU    73
INTEGER STATS#                         Yes, if statistics are to be     MU    74
#                                         Listed.                       MU    75
INTEGER TBYOBS#                        Total number of bijvoet obs.     MU    76
#                                         On the bdf.                   MU    77
INTEGER TOBSKP#                        Total number of obs. skipped     MU    78
#                                         Because of insufficient room. MU    79
INTEGER TOTOBS#                        Total number of obs. on the      MU    80
#                                         Bdf.                          MU    81
INTEGER TOTREF#                        Total number of refls.           MU    82
#                                         Processed.                    MU    83
INTEGER TSGOBS#                        Total number of space group      MU    84
#                                         Obs. on the bdf.              MU    85
#                                                                       MU    86
COMMON/COMFMU/AVGFSQ,FSQINC,$#                                          MU    87
SIGFSQ,  SINC, SITOL,SMAVG1,SMAVG2,SMAVG3,$#                            MU    88
SMAVG4,  SMAX,  SMIN,SMSIG1,SMSIG2,SMSIG3,SMSIG4,   STH#                MU    89
#                                                                       MU    90
REAL AVGFSQ#                           Mean f**2 for a reflection       MU    91
REAL FSQINC#                           Reciprocal of f**2 slot          MU    92
#                                         Spacing.                      MU    93
REAL SIGFSQ#                           Mean sigma(f**2) for a refl.     MU    94
REAL SINC#                             Slotting increment for sitol     MU    95
REAL SITOL#                            Sine(theta)/lambda               MU    96
REAL SMAVG1(maxslots:)#                Sum of avgfsq for each f**2      MU    97
#                                         Slot.                         MU    98
REAL SMAVG2(maxslots:)#                Sum of avgfsq for each sitol     MU    99
#                                         Slot.                         MU   100
REAL SMAVG3(maxslots:)#                Sum of avgfsq for all            MU   101
#                                         Replicated refls. in each     MU   102
#                                         F**2 slot.                    MU   103
REAL SMAVG4(maxslots:)#                Sum of avgfsq for all            MU   104
#                                         Replicated refls. in each     MU   105
#                                         Sitol slot.                   MU   106
REAL SMAX#                             Maximum sitol for inclusion      MU   107
REAL SMIN#                             Minimum sitol for inclusion      MU   108
REAL SMSIG1(maxslots:)#                Sum of ave. sigma(f**2) for      MU   109
#                                         F**2 slot.                    MU   110
REAL SMSIG2(maxslots:)#                Sum of ave. sigma(f**2) for      MU   111
#                                         Each sitol slot.              MU   112
REAL SMSIG3(maxslots:)#                Sum of ave. sigma(f**2) for      MU   113
#                                         All replicated refls. in each MU   114
#                                         F**2 slot.                    MU   115
REAL SMSIG4(maxslots:)#                Sum of ave. sigma(f**2) for      MU   116
#                                         All replicated refls. in each MU   117
#                                         Sitol slot.                   MU   118
REAL STH#                              Used in calculating next sit     MU   119
#                                         Value for table headings      MU   120
COMMON/COMIMU/ALLOWD,ENDPTR,  FPTR,   HKL, HKLBY,HKLNOW,HKLNXT,$#       MU   121
HPTR,IMERGE,MAXOBS,MAXRFS,  MAXS,  MAXY,NREFS1,NREFS2,NREFS3,NREFS4,$#  MU   122
NOREPS,NSHIFT, OBS, OBSBY,OBSKIP, OBSSG,OPTION, PGPTR, REFBY, REFSG,$#  MU   123
RFBOTH, SCPTR, SHPTR, SLOTS, STATS,TBYOBS,TOBSKP,TOTOBS,$#              MU   124
TOTREF,TSGOBS#                                                          MU   125
endext:#                                                                MU   126
#                                                                       MU   127
systemheader:(MU00)#                                                    MU00   1
# ################################################################## #  MU00   2
#                                                                    #  MU00   3
#                               MU00                                 #  MU00   4
#                                                                    #  MU00   5
# ################################################################## #  MU00   6
SUBROUTINE MU00#                       Reflns with multiple obs.        MU00   7
include:(AACOMN)#                      Aug 1979  r.a. alden             MU00   8
include:(MUCOMN)#                                                       MU00   9
#                                                                       MU00  10
CALL MU10#                             Process input specs & scales     MU00  11
CALL MU20#                             Sort out options                 MU00  12
IF(STATS > 0)  CALL MU30#              List statistics                  MU00  13
readwpkt:(1,endrecord:,PSIZE,IPT,0)#   Complete input bdf               MU00  14
#                                                                       MU00  15
RETURN#                                                                 MU00  16
END#                                                                    MU00  17
systemheader:(MU01)#                                                    MU01   1
# ################################################################## #  MU01   2
#                                                                    #  MU01   3
#                               MU01                                 #  MU01   4
#                                                                    #  MU01   5
# ################################################################## #  MU01   6
SUBROUTINE MU01(WHICH)#                Routine for reading logical      MU01   7
#                                         Record lrrefl:.  buffers in   MU01   8
#                                         One hkl's-worth of            MU01   9
#                                         Observations and, possibly,   MU01  10
#                                         The observations for its      MU01  11
#                                         Bijvoet hkl.                  MU01  12
#                                        Mar 1979  r.a. alden           MU01  13
#                                        Updated oct 1979  r. alden     MU01  14
#                                        Revised mar 1983  r.a. alden   MU01  15
include:(AACOMN)#                                                       MU01  16
include:(MUCOMN)#                                                       MU01  17
#                                                                       MU01  18
INTEGER IBY#                           The bijvoet flag                 MU01  19
INTEGER IPT#                           Input packet pointer             MU01  20
INTEGER JP#                            Pointer to current fsq           MU01  21
INTEGER NOBS#                          Number of observation for        MU01  22
#                                         Current reflection.           MU01  23
INTEGER PSIZE#                         Packet size                      MU01  24
INTEGER PT20(6)#                       Flag and pointers to lrrefl:     MU01  25
INTEGER WHICH#                         Flag denoting which part of      MU01  26
#                                         Routine is being executed.    MU01  27
intdata:(IP,0)#                        Pointer to start of space        MU01  28
intdata:(KEY,[5,5,5,0])#               Signals for indexptk:            MU01  29
intdata:(NEED20,[1,2,1302,1303,1309])# Required idnums for lrrefl:      MU01  30
datastuff:#                                                             MU01  31
#                                                                       MU01  32
IF(WHICH == 0)#                                                         MU01  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MU01  34
IP = FPTR + 1#                         Start of space group fsq's       MU01  35
KEY(4) = 0#                            Look for lrrefl: directory a     MU01  36
indexpkt:(1,lrrefl:,PSIZE,IPT,0,KEY,NEED20,PT20)# Required idnu         MU01  37
IF(IPT < 0 \  KEY(4) < 0)  iquit:(MU0101)#                              MU01  38
#                                                                       MU01  39
TOTREF = 0#                            Clear                            MU01  40
REFSG  = 0#                                                             MU01  41
REFBY  = 0#                            Various                          MU01  42
RFBOTH = 0#                                                             MU01  43
TSGOBS = 0#                            Counts                           MU01  44
TBYOBS = 0#                                                             MU01  45
TOTOBS = 0#                                                             MU01  46
TOBSKP = 0#                                                             MU01  47
HKLNXT = 0#                            Clear next hkl                   MU01  48
readwpkt:(1,lrrefl:,PSIZE,IPT,0)#      Read first reflection            MU01  49
IF(IPT == 0)  iquit:(MU0102)#          Something's wrong                MU01  50
#                                                                       MU01  51
intunpak:(QX(IPT+1),HKLNXT,0,30)#      Get packed indices               MU01  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MU01  53
#                                                                       MU01  54
ELSE#                                                                   MU01  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MU01  56
# UPON RETURN...........                                                MU01  57
#   HKL CONTAINS THE SPACE GROUP INDICES CORRESPONDING TO HKLNOW        MU01  58
#   HKLBY  "      "     BIJVOET     "          "        "    "          MU01  59
#   HKLNOW ARE THE INDICES FOUND ON THE BDF                             MU01  60
#   HKLNXT  "   "     "    FOR THE NEXT REFLECTION TO BE PROCESSED      MU01  61
#                                                                       MU01  62
# THE WAY TO KNOW WHAT IS SITTING IN THE REFLECTION RECORD IS TO        MU01  63
#   CHECK OBSSG AND OBSBY.                                              MU01  64
#                                                                       MU01  65
OBSSG = 0#                             Clear space group obs. count     MU01  66
OBSBY = 0#                             Likewise for bijvoet obs.        MU01  67
#                                                                       MU01  68
# TEST THE NEXT PACKED HKL.  IT IS ALREADY SITTING IN HKLNXT            MU01  69
#                                                                       MU01  70
IF(HKLNXT != 0)#                       An hklnxt of 0 signals the       MU01  71
#                                         End of all reflections.       MU01  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MU01  73
HKLNOW = HKLNXT#                                                        MU01  74
#                                                                       MU01  75
# SINCE A VALID HKL IS PRESENT, READ IN ITS DATA                        MU01  76
CALL MU03(1,NOBS,QX(IP),OBSKIP,HKLNXT,SITOL,ALLOWD)#                    MU01  77
#                                                                       MU01  78
TOTOBS = TOTOBS + OBSKIP + NOBS#       Increment counters               MU01  79
TOBSKP = TOBSKP + OBSKIP#                                               MU01  80
#                                                                       MU01  81
HKL = (HKLNOW/2)*2#                    Get rid of any bijvoet bit       MU01  82
HKLBY = HKL+1#                         Put the bijvoet indices into     MU01  83
#                                         Hklby.                        MU01  84
IBY = MOD(HKLNOW,2)#                   Pick up the bijvoet bit          MU01  85
IF(IBY == 0)#                          Process all the space group      MU01  86
#                                         Observations.                 MU01  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MU01  88
OBSSG = NOBS#                          Save the count                   MU01  89
REFSG = REFSG + 1#                     Increment refsg                  MU01  90
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MU01  91
ELSE#                                  Process all the bijvoet obs.     MU01  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MU01  93
OBSBY = NOBS#                          Save the count                   MU01  94
REFBY = REFBY + 1#                     Increment refby                  MU01  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MU01  96
#                                                                       MU01  97
# IF SPACE GROUP AND BIJVOET OBSERVATIONS ARE TO BE MERGED, THEN        MU01  98
#  THE NEXT REFLECTION MUST NOW BE CHECKED. THE FOLLOWING               MU01  99
#  POSSIBILITIES EXIST:                                                 MU01 100
#  IF THE LAST REFLECTION WAS A SPACE GROUP ONE, THE NEXT ONE MAY       MU01 101
#  BE                                                                   MU01 102
#   1) THE BIJVOET OF THAT,                                             MU01 103
#   2) A NEW SPACE GROUP ONE,                                           MU01 104
#   3) A NEW BIJVOET ONE, OR                                            MU01 105
#   4) NOTHING AT ALL (END OF LOGICAL RECORD).                          MU01 106
#  IF THE LAST REFLECTION WAS A BIJVOET ONE WITH NO CORRESPONDING       MU01 107
#   SPACE GROUP ONE, THE NEXT ONE MAY BE                                MU01 108
#   1) A NEW SPACE GROUP ONE,                                           MU01 109
#   2) A NEW BIJVOET ONE, OR                                            MU01 110
#   3) NOTHING AT ALL, BUT CANNOT BE THE CORRESPONDING SPACE GROUP      MU01 111
#      ONE.                                                             MU01 112
#                                                                       MU01 113
# IF NO MERGING IS TO BE DONE, THEN WE DON'T CARE ABOUT THE NEXT        MU01 114
#  REFLECTION YET.                                                      MU01 115
#                                                                       MU01 116
IF(IMERGE == 0)#                                                        MU01 117
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MU01 118
#                                                                       MU01 119
# ONCE AGAIN THE NEXT HKL IS PRESENT IN HKLNXT.  ITS VALUE CAN          MU01 120
#  BE CHECKED TO DETERMINE IF IT IS THE BIJVOET OF THE CURRENT          MU01 121
#  REFLECTION.  IF IT IS, THEN THE BIJVOET DATA WILL BE MERGED          MU01 122
#  WITH THAT FOR THE SPACE GROUP, CURRENTLY RESIDING IN THE             MU01 123
#  BUFFER.                                                              MU01 124
#                                                                       MU01 125
IBY = MOD(HKLNXT,2)#                   Pick up the bijvoet bit          MU01 126
IF(IBY == 1)#                          Check if it's a bijvoet refl     MU01 127
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MU01 128
# PICK UP THE BIJVOET PART OF THE HKL FOR COMPARISON                    MU01 129
IF(HKLBY == HKLNXT)#                   By gum, i think we've got        MU01 130
#                                         A live one!                   MU01 131
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MU01 132
JP = IP + 3*NOBS#                      Point to next storage            MU01 133
#                                         Location of f**2              MU01 134
#                                                                       MU01 135
# READ IN THE DATA FOR THE BIJVOET REFLECTION TO BE MERGED              MU01 136
#                                                                       MU01 137
CALL MU03(1,NOBS,QX(JP),OBSKIP,HKLNXT,SITOL,ALLOWD)#                    MU01 138
#                                                                       MU01 139
TOTOBS = TOTOBS + OBSKIP + NOBS#       Increment counts                 MU01 140
TOBSKP = TOBSKP + OBSKIP#                                               MU01 141
#                                                                       MU01 142
OBSBY = NOBS#                          Save the count                   MU01 143
REFSG = REFSG - 1#                     Decrement space group only       MU01 144
#                                         Counter.                      MU01 145
RFBOTH = RFBOTH + 1#                   Increment rfboth                 MU01 146
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MU01 147
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MU01 148
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MU01 149
#                                                                       MU01 150
OBS = OBSSG + OBSBY#                   Total obs. for this refl.        MU01 151
TOTREF = REFSG + REFBY + RFBOTH#       Increment total refl. counte     MU01 152
TSGOBS = TSGOBS + OBSSG#               Total space group obs.           MU01 153
TBYOBS = TBYOBS + OBSBY#               Total bijvoet obs.               MU01 154
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MU01 155
ELSE SITOL = -1.#                      Put out a negative sitol to      MU01 156
#                                         Signal the end of lrrefl:.    MU01 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MU01 158
#                                                                       MU01 159
RETURN#                                                                 MU01 160
END#                                                                    MU01 161
systemheader:(MU02)#                                                    MU02   1
# ################################################################## #  MU02   2
#                                                                    #  MU02   3
#                               MU02                                 #  MU02   4
#                                                                    #  MU02   5
# ################################################################## #  MU02   6
SUBROUTINE MU02(WHICH,PAK,IH,ORDER,IFLAG)# Given a sorting order        MU02   7
#                                         Packed index transform the    MU02   8
#                                         Index into an hkl.            MU02   9
#                                        19 mar 1979  r.a. alden        MU02  10
INTEGER I,IFLAG#                       Loop index                       MU02  11
INTEGER IH(3)#                         Hkl in hkl order                 MU02  12
INTEGER IH1,IH2,IH3#                   Hkl in sorting order             MU02  13
INTEGER ISH1,ISH2,ISH3#                Signs of hkl                     MU02  14
INTEGER JX(3)#                         Triplet describing sorting       MU02  15
#                                         Order.                        MU02  16
INTEGER MATCH#                         Index corresponding to ascii     MU02  17
#                                         H,k, or l.                    MU02  18
INTEGER WHICH#                         If == 0, initialize, else do     MU02  19
#                                         Indexing.                     MU02  20
#                                                                       MU02  21
REAL PAK#                              Packed hkl                       MU02  22
#                                                                       MU02  23
string:(ORDER,3)#                      Ascii sorting order              MU02  24
#                                                                       MU02  25
chardata:(HKL,HKL)#                    Allow upper case only            MU02  26
#                                                                       MU02  27
EQUIVALENCE (JX1,JX(1)),(JX2,JX(2)),(JX3,JX(3))#                        MU02  28
#                                                                       MU02  29
intdata:(JX1,[0])#                                                      MU02  30
intdata:(JX2,[0])#                                                      MU02  31
intdata:(JX3,[0])#                                                      MU02  32
#                                                                       MU02  33
#                                                                       MU02  34
datastuff:#                                                             MU02  35
# FORTRAN CALLING SEQUENCES:                                            MU02  36
#                                                                       MU02  37
#  INITIALIZATION - CALL MU02(0,0,0,ORDER), WHERE ORDER IS A TYPE       MU02  38
#    CHARACTER: ARRAY, EACH ELEMENT CONTAINING ONE ASCII CHARACTER      MU02  39
#    OF THE SET H,K,L.  THE MAJOR SORT IS OVER ORDER(1:1), SECONDARY    MU02  40
#    SORT OVER ORDER(2:2), AND MINOR SORT OVER ORDER(3:3).  E.G., IF    MU02  41
#    ORDER(1:1) = 'L'  AND                                              MU02  42
#    ORDER(2:2) = 'H'  AND                                              MU02  43
#    ORDER(3:3) = 'K',                                                  MU02  44
#    THE SORTING ORDER WOULD BE LHK WITH THE MAJOR SORT BEING OVER L.   MU02  45
#                                                                       MU02  46
#  MAIN CALL - CALL MU02(1,PAK,IH,ORDER) WHERE IH(1) WILL BE LOCATION   MU02  47
#    OF THE INDEX H, IH(2) WILL BE LOCATION OF THE INDEX K, AND IH(3)   MU02  48
#    WILL BE THE LOCATION OF THE INDEX L OF THE MILLER INDICES HKL FOR  MU02  49
#    A REFLECTION.  PAK CONTAINS THE PACKED INDICES WHICH WILL BE       MU02  50
#    UNPACKED INTO THE ABOVE ARRAY.                                     MU02  51
#                                                                       MU02  52
#    PAK IS MADE UP AS FOLLOWS...                                       MU02  53
#                                                                       MU02  54
#    ZERO                                UNUSED HIGH ORDER BITS         MU02  55
#    MAGNITUDE OF MAJOR SORT INDEX       BITS 21-29                     MU02  56
#    MAGNITUDE OF SECONDARY SORT INDEX   BITS 12-20                     MU02  57
#    MAGNITUDE OF MINOR SORT INDEX       BITS  3-11                     MU02  58
#    SIGN OF SECONDARY SORT INDEX        BIT 2                          MU02  59
#    SIGN OF MINOR SORT INDEX            BIT 1                          MU02  60
#    SIGN OF MAJOR SORT INDEX            BIT 0    (BIJVOET BIT)         MU02  61
#                                                                       MU02  62
#    NOTE - WHEN THE BIJVOET BIT IS ZERO, THE SIGN OF THE MAJOR SORT    MU02  63
#      INDEX IS PLUS AND THE SIGNS OF THE OTHER TWO INDICES ARE AS      MU02  64
#      GIVEN (0:==A PLUS SIGN; 1:==A MINUS SIGN).  WHEN THE BIJVOET     MU02  65
#      BIT IS 1, THE SIGN OF THE MAJOR SORT INDEX IS MINUS, AND THE     MU02  66
#      SIGNS OF THE OTHER TWO INDICES ARE THE OPPOSITE OF THOSE GIVEN.  MU02  67
#                                                                       MU02  68
#  MU02  IS THE REVERSE OPERATION TO THE FUNCTION INDEX:.  THAT IS,     MU02  69
#    IT TAKES A PACKED WORD AND PRODUCES THE PROPER MILLER INDICES.     MU02  70
#                                                                       MU02  71
IF(WHICH == 0)#                                                         MU02  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MU02  73
IFLAG= 1#                              Indicator for a good return      MU02  74
#                                                                       MU02  75
FOR(I=1; I <= 3; I=I+1)#               Loop over sorting order          MU02  76
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MU02  77
JX(I) = 0#                             Clear found flag                 MU02  78
compchar:(ORDER,I,HKL,1,1,1,NHKL,MATCH)# Loop over possible chars.      MU02  79
IF(MATCH == 0)  BREAK#                 No match                         MU02  80
IF(MATCH > 3)  MATCH = MATCH - 3#      Get pointer in range 1-3         MU02  81
JX(I) = MATCH#                                                          MU02  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MU02  83
#                                                                       MU02  84
# 'H', 'K', AND 'L' MUST HAVE BEEN FOUND ONCE AND ONLY ONCE EACH.       MU02  85
#                                                                       MU02  86
IF(JX1+JX2+JX3 != 6 \  JX1*JX2*JX3 != 6)  IFLAG= 0#                     MU02  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MU02  88
#                                                                       MU02  89
ELSE#                                  Mu02                             MU02  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MU02  91
intunpak:(PAK,IH1,21,9)#               Unpack the 9-bit bytes which     MU02  92
intunpak:(PAK,IH2,12,9)#               Are the magnitudes of h, k,      MU02  93
intunpak:(PAK,IH3,3,9)#                And l.                           MU02  94
#                                                                       MU02  95
intunpak:(PAK,ISH1,0,1)#               Get sign of major sort index     MU02  96
intunpak:(PAK,ISH2,2,1)#               Secondary sort index,            MU02  97
intunpak:(PAK,ISH3,1,1)#               And minor sort index.            MU02  98
#                                                                       MU02  99
IF(ISH1 != 0)#                         Bijvoet bit is a 1               MU02 100
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MU02 101
IH1 = -IH1#                            Negate major sort index          MU02 102
IF(ISH2 == 0)  IH2 = -IH2#             Reverse sign of sec. sort        MU02 103
IF(ISH3 == 0)  IH3 = -IH3#             Reverse sign of minor sort       MU02 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MU02 105
ELSE#                                  Bijvoet bit is a 0               MU02 106
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MU02 107
IF(ISH2 != 0)  IH2 = -IH2#             Put sign on sec. sort            MU02 108
IF(ISH3 != 0)  IH3 = -IH3#             And minor sort, if needed.       MU02 109
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MU02 110
#                                                                       MU02 111
IH(JX1) = IH1#                         Put h, k, and l in their         MU02 112
IH(JX2) = IH2#                         Proper places.                   MU02 113
IH(JX3) = IH3#                                                          MU02 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MU02 115
#                                                                       MU02 116
RETURN#                                                                 MU02 117
END#                                                                    MU02 118
systemheader:(MU03)#                                                    MU03   1
# ################################################################## #  MU03   2
#                                                                    #  MU03   3
#                               MU03                                 #  MU03   4
#                                                                    #  MU03   5
# ################################################################## #  MU03   6
SUBROUTINE MU03(IDISC,NOBS,ADDR,OBSKIP,HKLNXT,SITOL,ALLOWD)#            MU03   7
#                                                                       MU03   8
# SUPPLY ALL OBSERVATIONS FOR ONE REFLECTION                            MU03   9
#                                        Mar 1983  r.a. alden           MU03  10
include:(AACOMN)#                                                       MU03  11
#                                                                       MU03  12
INTEGER ALLOWD#                        Maximum number of obs./refl.     MU03  13
#                                         Allowed.                      MU03  14
INTEGER FSPTR#                         Pointer to start of f**2         MU03  15
#                                         Storage.                      MU03  16
INTEGER HKLNOW#                        Current hkl                      MU03  17
INTEGER HKLNXT#                        The next hkl                     MU03  18
INTEGER IDISC#                         File being read                  MU03  19
INTEGER IPT#                           Input packet pointer             MU03  20
INTEGER NOBS#                          Obs. per refl. counter           MU03  21
INTEGER OBSKIP#                        Obs. skipped for current hkl     MU03  22
INTEGER PSIZE#                         Packet size                      MU03  23
#                                                                       MU03  24
REAL ADDR(1)#                          Location to store fsq, sigma     MU03  25
#                                         Shift number, in qx array.    MU03  26
REAL SITOL#                            Sine(theta)/lambda               MU03  27
#                                                                       MU03  28
OBSKIP = 0#                            Clear obs. skipped counter       MU03  29
NOBS = 0#                              Clear observation counter        MU03  30
#                                                                       MU03  31
HKLNOW = HKLNXT#                       Convert next hkl to current      MU03  32
#                                         Status.                       MU03  33
IPT = IOPKPT(IDISC)#                   Get pointer to packet now        MU03  34
#                                         Waiting to be processed.      MU03  35
SITOL=QX(IPT+2)#                       Save sine(theta)/lambda          MU03  36
FSPTR = -3#                            Initialize f**2 pointer          MU03  37
#                                                                       MU03  38
WHILE(HKLNXT == HKLNOW)#               Find all the observations fo     MU03  39
#                                         The current reflection.       MU03  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MU03  41
IF(NOBS < ALLOWD)#                     Don't allow overflow             MU03  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MU03  43
NOBS = NOBS + 1#                       Count obs. processed             MU03  44
FSPTR = FSPTR + 3#                     Point to next f**s               MU03  45
movereal:(QX,IPT+3,ADDR,FSPTR+1,3,0)#  Transfer f**2, sigma, and        MU03  46
#                                         Shift number.                 MU03  47
readwpkt:(IDISC,lrrefl:,PSIZE,IPT,0)#  Read next observation            MU03  48
HKLNXT = 0#                            Clear packed hkl                 MU03  49
IF(IPT == 0)  BREAK#                   Leave, if end of lrrefl:         MU03  50
intunpak:(QX(IPT+1),HKLNXT,0,30)#      Otherwise save new packed hk     MU03  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MU03  52
ELSE  OBSKIP = OBSKIP + 1#             Count skipped obs.               MU03  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MU03  54
#                                                                       MU03  55
RETURN#                                                                 MU03  56
END#                                                                    MU03  57
systemheader:(MU10)#                                                    MU10   1
# ################################################################## #  MU10   2
#                                                                    #  MU10   3
#                               MU10                                 #  MU10   4
#                                                                    #  MU10   5
# ################################################################## #  MU10   6
#                                                                       MU10   7
SUBROUTINE MU10#                       Process all of the image         MU10   8
#                                         Input.  start reading bdf.    MU10   9
#                                        Sep 1979  r.a. alden           MU10  10
include:(AACOMN)#                                                       MU10  11
include:(MUCOMN)#                                                       MU10  12
#                                                                       MU10  13
INTEGER I,IFLAG#                       Loop index                       MU10  14
INTEGER IPT#                           Input packet pointer             MU10  15
INTEGER J#                             Pointer to start of qx worki     MU10  16
#                                         Area.                         MU10  17
INTEGER MORDER#                        Sorting order on the bdf         MU10  18
INTEGER NPTR#                          Log. rec. lrexpl: pointer        MU10  19
INTEGER PSIZE#                         Input packet size                MU10  20
INTEGER PT11(3)#                       Offsets for log. rec. lrexpl     MU10  21
#                                                                       MU10  22
string:(SORTIN,3)#                     Input sorting order (ascii)      MU10  23
chardata:(ORDER,HKL)#                                                   MU10  24
chardata:(MU011, SCALE  END    )#                                       MU10  25
chardata:(MU012,REFLECTIONS ON THE INPUT BDF ARE SORTED IN     ORDER)#  MU10  26
intdata:(NEED11,[12,100])#             Two required catalogue no.       MU10  27
intdata:(KEY,[2,2,2,0])#               Signal array for indexpkt:       MU10  28
datastuff:#                                                             MU10  29
#                                                                       MU10  30
IOMARK(1) = QXSTR#                     Start of input buffer            MU10  31
SHPTR = IOMARK(1) + bdfbuf:#           Start of table of shift          MU10  32
incrqx:(FPTR,SHPTR+arith:(2,*,maxshifts:),MU1001)# M                    MU10  33
#                                                                       MU10  34
# READ AND PROCESS THE MULIST IMAGE.  THE FIELD DEFINITIONS ARE AS      MU10  35
#  FOLLOWS:                                                             MU10  36
#                                                                       MU10  37
#  FIELD                         DEFINITION                   DEFAULT   MU10  38
#  -----                         ----------                   -------   MU10  39
#    1          OPTION; MUST BE BETWEEN 1 AND 5 INCLUSIVE               MU10  40
#                       (SEE DESCRIPTIONS BELOW)                        MU10  41
#    2          SMIN  ; MINIMUM SINE(THETA)/LAMBDA FOR          0.00    MU10  42
#                       INCLUSION.                                      MU10  43
#    3          SMAX  ; MAXIMUM SINE(THETA)/LAMBDA              0.70    MU10  44
#    4          MAXOBS; MAXIMUM NUMBER OF OBSERVATIONS TO BE   10000    MU10  45
#                       LISTED (APPROXIMATE).                           MU10  46
#    5          MAXRFS; MAXIMUM NUMBER OF REFLECTIONS TO BE    10000    MU10  47
#                       LISTED.                                         MU10  48
#    6          STATS ; ARE STATISTICS TO BE LISTED?               1    MU10  49
#                       NO/YES = 0/1                                    MU10  50
#    7          NSLOTS; NUMBER OF SLOTS TO DIVIDE SINETOL         20    MU10  51
#                       INTO.                                           MU10  52
# THE VARIOUS OPTIONS ARE:                                              MU10  53
#                                                                       MU10  54
#  1  LIST REFLECTION INDICES ONLY                                      MU10  55
#       A) SINETOL LIMITS APPLICABLE                                    MU10  56
#       B) MAXRFS LIMITS                                                MU10  57
#       C) NO STATS                                                     MU10  58
#                                                                       MU10  59
#  2  LIST (HKL, <FSQ>, SIG(FSQ), AND NO. OF OBS.)/REFLECTION           MU10  60
#       A) SINETOL LIMITS APPLICABLE                                    MU10  61
#       B) MAXOBS AND MAXRFS LIMITS                                     MU10  62
#       C) NEED SCALE IMAGES                                            MU10  63
#       D) STATS OPTIONAL                                               MU10  64
#                                                                       MU10  65
#  3  LIST (HKL, <FSQ>, SIG(FSQ), AND INDIVIDUAL (SCALED) FSQ'S,        MU10  66
#       SIGMA'S AND SHIFT NUMBERS)/REFLECTION                           MU10  67
#       A) SINETOL LIMITS APPLICABLE                                    MU10  68
#       B) MAXOBS AND MAXRFS LIMITS                                     MU10  69
#       C) NEED SCALE IMAGES                                            MU10  70
#       D) STATS OPTIONAL                                               MU10  71
#                                                                       MU10  72
#  4  LIST (HKL, INDIVIDUAL (UNSCALED) FSQ'S AND SIGMA'S, AND SHIFTS    MU10  73
#       NUMBERS)/REFLECTION                                             MU10  74
#       A) SINETOL LIMITS APPLICABLE                                    MU10  75
#       B) MAXOBS AND MAXRFS LIMITS                                     MU10  76
#       C) NO SCALE IMAGES                                              MU10  77
#       D) NO STATS                                                     MU10  78
#                                                                       MU10  79
#  5  LIST STATISTICS ONLY                                              MU10  80
#       A) SINETOL LIMITS APPLICABLE                                    MU10  81
#       B) SCALE IMAGES REQUIRED                                        MU10  82
#       C) MAXOBS AND MAXRFS LIMITS                                     MU10  83
#                                                                       MU10  84
IF(BUFIN(1) <= 0. \  BUFIN(1) > 5.)  iquit:(MU1002)#                    MU10  85
OPTION = NINT(BUFIN(1))#                                                MU10  86
#                                                                       MU10  87
# SINE(THETA)/LAMBDA LIMITS                                             MU10  88
SMIN = BUFIN(2)#                                                        MU10  89
SMAX = BUFIN(3)#                                                        MU10  90
IF(SMIN < 0.0)  SMIN = 0.0#            Set defaults                     MU10  91
IF(SMAX < 0.0 \  SMAX > 0.7)  SMAX = 0.7#                               MU10  92
IF(SMIN >= SMAX)  iquit:(MU1003)#                                       MU10  93
#                                                                       MU10  94
# MAXIMUM NUMBER OF OBSERVATIONS TO BE LISTED                           MU10  95
ifvo:(BUFIN(4))  BUFIN(4) = 0.#                                         MU10  96
MAXOBS = NINT(BUFIN(4))#                                                MU10  97
IF(MAXOBS <= 0)  MAXOBS = 10000#       Set default                      MU10  98
#                                                                       MU10  99
# MAXIMUM NUMBER OF REFLECTIONS TO BE LISTED                            MU10 100
ifvo:(BUFIN(5))  BUFIN(5) = 0.#                                         MU10 101
MAXRFS = NINT(BUFIN(5))#                                                MU10 102
IF(MAXRFS <= 0)  MAXRFS = 10000#       Set default                      MU10 103
#                                                                       MU10 104
# WILL STATISTICS BE ACCUMULATED?                                       MU10 105
ifne:(BUFIN(6),0.)  STATS = 1#                                          MU10 106
ELSE  STATS = 0#                                                        MU10 107
#                                                                       MU10 108
# STATS = 0     NO STATISTICS                                           MU10 109
# STATS = 1     OPTIONS 2 AND 3 STATISTICS                              MU10 110
# STATS = 2     OPTION 5 STATISTICS                                     MU10 111
#                                                                       MU10 112
# NUMBER OF SLOTS TO DIVIDE STATISTICAL LISTINGS INTO (BASED ON         MU10 113
#  [SINE(THETA)/LAMBDA]**3)                                             MU10 114
ifvo:(BUFIN(7))  BUFIN(7) = 0.#                                         MU10 115
SLOTS = NINT(BUFIN(7))#                                                 MU10 116
IF(SLOTS <= 0)  SLOTS = 20#            Set default                      MU10 117
#                                                                       MU10 118
# READ THE BDF, SKIPPING DOWN TO THE DIRECTORY OF LOGICAL RECORD LREXPL MU10 119
KEY(4) = 0#                                                             MU10 120
indexpkt:(1,lrexpl:,PSIZE,IPT,0,KEY,NEED11,PT11)#                       MU10 121
IF(KEY(4) < 0)  iquit:(MU1004)#        A sorting order and set of       MU10 122
#                                         Shift numbers must be there.  MU10 123
readwpkt:(1,lrexpl:,PSIZE,IPT,0)#      Read next packet                 MU10 124
#                                                                       MU10 125
NPTR = IPT + PT11(1)#                                                   MU10 126
MORDER = NINT(QX(NPTR))#               Pick up sorting order            MU10 127
FOR(I=3; I > 0; I=I-1)#                Convert to characters            MU10 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MU10 129
J = MOD(MORDER,10)#                                                     MU10 130
movechar:(ORDER,J,SORTIN,I,1,0)#                                        MU10 131
MORDER = MORDER/10#                                                     MU10 132
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MU10 133
#                                                                       MU10 134
NPTR = IPT + PT11(2)#                  Pointer to no. of shift no.'     MU10 135
CALL MU02(0,0,0,SORTIN,IFLAG)#         Initialize mu02                  MU10 136
IF(IFLAG == 0)  iquit:(MU1005)#        Verify mu02                      MU10 137
movechar:(MU012,1,CHROT,2,NMU012,0)#   Tell user about sorting          MU10 138
movechar:(SORTIN,1,CHROT,45,3,0)#      Order found.                     MU10 139
writeline:(1,0,0,1,3)#                                                  MU10 140
NSHIFT = 0#                            Initialize shift counter         MU10 141
#                                                                       MU10 142
# FOR OPTIONS 1 AND 4 NO STATISTICS ARE PERMITTED                       MU10 143
#                                                                       MU10 144
IF(OPTION == 1 \  OPTION == 4)#                                         MU10 145
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MU10 146
STATS = 0#                                                              MU10 147
REPEAT#                                                                 MU10 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MU10 149
readline:(MU011,NMU011)#               In case any scale images wer     MU10 150
IF(LINID == 2) BREAK#                                                   MU10 151
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MU10 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MU10 153
ELSE#                                                                   MU10 154
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MU10 155
readline:(MU011,NMU011)#               For other options, read the      MU10 156
CALL MU11(NSHIFT,SHPTR,NPTR)#          Process any scale images         MU10 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MU10 158
#                                                                       MU10 159
SCPTR = SHPTR + NSHIFT#                                                 MU10 160
FPTR = SCPTR + NSHIFT#                 Start of f**2, sigma, shift      MU10 161
#                                         Number storage.               MU10 162
# GET ENOUGH ROOM                                                       MU10 163
incrqx:(HPTR,FPTR+arith:(3,*,max:),MU1001)#                             MU10 164
#                                                                       MU10 165
ALLOWD = max:#                         Maximum number of observatio     MU10 166
#                                         Permitted per reflection.     MU10 167
#                                                                       MU10 168
RETURN#                                                                 MU10 169
END#                                                                    MU10 170
systemheader:(MU11)#                                                    MU11   1
# ################################################################## #  MU11   2
#                                                                    #  MU11   3
#                               MU11                                 #  MU11   4
#                                                                    #  MU11   5
# ################################################################## #  MU11   6
SUBROUTINE MU11(NSHIFT,SHPTR,NPTR)#    Process either scale images      MU11   7
#                                         Or log. rec. lrexpl: and      MU11   8
#                                         Build a table of shift        MU11   9
#                                         Numbers and their correspond- MU11  10
#                                         Ing scale factors.            MU11  11
#                                        Jun 1979  r.a. alden           MU11  12
#                                        R.a. alden  jun 1979           MU11  13
#                                        Re-written jan 1983  r. alden  MU11  14
include:(AACOMN)#                                                       MU11  15
#                                                                       MU11  16
INTEGER I#                             Loop index                       MU11  17
INTEGER NPTR#                          Pointer to number of shifts      MU11  18
#                                         On the bdf.                   MU11  19
INTEGER NSHIFT#                        Number of shift numbers          MU11  20
INTEGER SCPT#                          Pointer to current scale fac     MU11  21
INTEGER SCPTR#                         Pointer to scale factors         MU11  22
INTEGER SHFTIN#                        Number of scale groups on        MU11  23
#                                         The bdf.                      MU11  24
INTEGER SHPTR#                         Pointer to location of scale     MU11  25
#                                         Factors in input buffer.      MU11  26
#                                                                       MU11  27
REAL SCALE#                            Initial scale factor             MU11  28
chardata:(MU101, SCALE  END    )#                                       MU11  29
chardata:(MU102, SHIFT NUMBER   SCALE FACTOR)#                          MU11  30
intdata:(SHPT,[0])#                    Ptr. to new location of          MU11  31
# # SCALE FACTORS                                                       MU11  32
realdata:(FMT101,[110413.,261252.])#                                    MU11  33
datastuff:#                                                             MU11  34
#                                                                       MU11  35
NSHIFT = 0#                            Clear the shift counter          MU11  36
SCPTR = SHPTR + maxshifts:#            Point to scale factors           MU11  37
SHFTIN = NINT(QX(NPTR))#               Number of scale groups prese     MU11  38
WHILE(LINID == 1)#                     Loop over the scale images       MU11  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MU11  40
ifvo:(BUFIN(1))  iquit:(MU1101,1)#                                      MU11  41
IF(BUFIN(1)< 1.) iquit:(MU1101,1)#                                      MU11  42
#                                                                       MU11  43
FOR(I=1; I <= SHFTIN; I=I+1)#          See if the requested shift       MU11  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MU11  45
SHPT = NPTR + I#                       Number is one found on           MU11  46
ifeq:(BUFIN(1),QX(SHPT))  BREAK#       The bdf.                         MU11  47
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MU11  48
#                                                                       MU11  49
IF(I > SHFTIN)#                        An error, if it's not there      MU11  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MU11  51
iquit:(-MU1102,1)#                                                      MU11  52
NEXT#                                                                   MU11  53
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MU11  54
#                                                                       MU11  55
NSHIFT = NSHIFT + 1#                   Increment shift counter          MU11  56
IF(NSHIFT > maxshifts:)  iquit:(MU1103)#                                MU11  57
#                                                                       MU11  58
# PICK UP THE SHIFT NUMBER AND ITS SCALE FACTOR                         MU11  59
movereal:(BUFIN,1,QX,SHPTR+NSHIFT,1,0)#                                 MU11  60
movereal:(BUFIN,1,QX,SCPTR+NSHIFT,1,0)#                                 MU11  61
ifvo:(BUFIN(2))#                       If no scale provided,            MU11  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MU11  63
SCPT = SHPT + SHFTIN#                  Then get it off of the bdf.      MU11  64
SCALE = QX(SCPT)#                                                       MU11  65
ifvo:(SCALE)  SCALE = 1.#              If it's also void, then set      MU11  66
#                                         To default (1.).              MU11  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MU11  68
ELSE  SCALE = BUFIN(2)#                Otherwise, use value on line     MU11  69
#                                                                       MU11  70
IF(SCALE < 0.)  iquit:(-MU1104)#       Must be greater than zero        MU11  71
#                                                                       MU11  72
BUFOT(1) = SCALE#                                                       MU11  73
movereal:(BUFOT,1,QX,SCPTR+NSHIFT,1,0)# Save the initial scale facto    MU11  74
#                                                                       MU11  75
readline:(MU101,NMU101)#               Get the next image               MU11  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MU11  77
#                                                                       MU11  78
# IF THERE WERE NO SCALE IMAGES, THEN READ THE SHIFT NUMBERS FROM       MU11  79
#  LOGICAL RECORD LREXPL:.                                              MU11  80
#                                                                       MU11  81
IF(NSHIFT == 0)#                                                        MU11  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MU11  83
NSHIFT = SHFTIN#                       Number of shifts                 MU11  84
movereal:(QX,NPTR+1,QX,SHPTR+1,NSHIFT,1)# Shift numbers                 MU11  85
movereal:(QX,NPTR+NSHIFT+1,QX,SCPTR+1,NSHIFT,1)# Scale factors          MU11  86
SCPT = SCPTR#                                                           MU11  87
DO I=1,NSHIFT#                         Check for void scales            MU11  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MU11  89
SCPT = SCPT + 1#                                                        MU11  90
ifvo:(QX(SCPT))  QX(SCPT) = 1.#        It necessary, set to default     MU11  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MU11  92
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MU11  93
#                                                                       MU11  94
# WRITE THE TABLE HEADING                                               MU11  95
#                                                                       MU11  96
writeline:(1,MU102,NMU102,3,3)#                                         MU11  97
#                                                                       MU11  98
DO I=1,NSHIFT#                         Loop over input shift number     MU11  99
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MU11 100
ncodefld:(QX,SHPTR+I,CHROT,FMT101(1),1)#                                MU11 101
ncodefld:(QX,SCPTR+I,CHROT,FMT101(2),1)#                                MU11 102
writeline:(0,MU102,NMU102,1,3)#                                         MU11 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MU11 104
#                                                                       MU11 105
IF(QUITF(1^1)!=' ')iquit:(MU1199)#     Any errors so far?               MU11 106
#                                                                       MU11 107
SCPT = SHPTR + NSHIFT#                 Point to the new location of     MU11 108
#                                         The scale factors and move    MU11 109
#                                         Them there.                   MU11 110
movereal:(QX,SCPTR+1,QX,SCPT+1,NSHIFT,1)#                               MU11 111
#                                                                       MU11 112
RETURN#                                                                 MU11 113
END#                                                                    MU11 114
systemheader:(MU20)#                                                    MU20   1
# ################################################################## #  MU20   2
#                                                                    #  MU20   3
#                               MU20                                 #  MU20   4
#                                                                    #  MU20   5
# ################################################################## #  MU20   6
SUBROUTINE MU20#                       Branch off to process the        MU20   7
#                                         Requests.                     MU20   8
#                                        Sep 1979  r.a. alden           MU20   9
include:(AACOMN)#                                                       MU20  10
include:(MUCOMN)#                                                       MU20  11
#                                                                       MU20  12
INTEGER MAXY4#                                                          MU20  13
chardata:(MU021, REFLECTION INDICES ONLY WILL BE LISTED)#               MU20  14
chardata:(MU022,ONLY REFLECTIONS WITHIN THE SIN(THETA)/LAMBDA $#        MU20  15
LIMITS OF        TO        WILL BE USED)#                               MU20  16
chardata:(MU023, HKL$, MEAN F**2$, SIGMA(F**2)$, AND THE NUMBER $#      MU20  17
OF OBSERVATIONS WILL BE LISTED FOR EACH REFLECTION)#                    MU20  18
chardata:(MU024,A MAXIMUM OF       REFLECTIONS  WILL BE LISTED)#        MU20  19
chardata:(MU025,OBSERVATIONS)#                                          MU20  20
chardata:(MU026, SUMMARY STATISTICS WILL BE LISTED)#                    MU20  21
chardata:(MU027, HKL$, MEAN F**2$, SIGMA(F**2)$, AND INDIVIDUAL $#      MU20  22
(SCALED) F**2$, SIGMA(F**2)$, AND SHIFT NUMBERS WILL BE LISTED $#       MU20  23
FOR EACH REFLECTION)#                                                   MU20  24
chardata:(MU028, HKL$, INDIVIDUAL (UNSCALED) F**2$, SIGMA(F**2)$#       MU20  25
$, AND SHIFT NUMBERS WILL BE LISTED FOR EACH REFLECTION)#               MU20  26
chardata:(MU029,ONLY)#                                                  MU20  27
chardata:(MU02A, THERE WILL BE NO LISTING OF SUMMARY STATISTICS)#       MU20  28
realdata:(FMT021,[730642.,630642.])#   /#                               MU20  29
realdata:(FMT022,[190513.])#                                            MU20  30
realdata:(NUL,[0.])#                   Holds zero                       MU20  31
datastuff:#                                                             MU20  32
#                                                                       MU20  33
IF(OPTION == 1)#                       Listing of reflection indice     MU20  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MU20  35
writeline:(1,MU021,NMU021,3,3)#        Only.                            MU20  36
STATS = 0#                             No statistics permitted          MU20  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MU20  38
IF(OPTION == 2)  writeline:(1,MU023,NMU023,3,3)#                        MU20  39
IF(OPTION == 3)  writeline:(1,MU027,NMU027,3,3)#                        MU20  40
IF(OPTION == 4)#                                                        MU20  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MU20  42
writeline:(1,MU028,NMU028,3,3)#        Unscaled observations            MU20  43
STATS = 0#                             No statistics permitted          MU20  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MU20  45
IF(OPTION == 5)#                       Statistics only                  MU20  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MU20  47
movechar:(MU029,1,CHROT,2,NMU029,0)#                                    MU20  48
movechar:(MU026,1,CHROT,6,NMU026,0)#                                    MU20  49
writeline:(1,0,0,1,3)#                                                  MU20  50
STATS = 2#                                                              MU20  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MU20  52
#                                                                       MU20  53
# SINE(THETA)/LAMBDA LIMITS                                             MU20  54
movechar:(MU022,1,CHROT,2,NMU022,0)#                                    MU20  55
ncodefld:(SMAX,1,CHROT,FMT021(1),2)#                                    MU20  56
writeline:(1,0,0,1,3)#                                                  MU20  57
#                                                                       MU20  58
# NUMBER OF REFLECTIONS (MAXIMUM) TO BE LISTED                          MU20  59
IF(OPTION < 5)#                                                         MU20  60
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MU20  61
movechar:(MU024,1,CHROT,2,NMU024,0)#                                    MU20  62
BUFOT(1) = FLOAT(MAXRFS)#                                               MU20  63
ncodefld:(BUFOT,1,CHROT,FMT022,1)##                                     MU20  64
writeline:(1,0,0,1,3)#                                                  MU20  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MU20  66
#                                                                       MU20  67
# NUMBER OF OBSERVATION (MAXIMUM) TO BE LISTED                          MU20  68
IF(OPTION > 1 & OPTION < 5)#                                            MU20  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MU20  70
movechar:(MU024,1,CHROT,2,NMU024,0)#                                    MU20  71
movechar:(MU025,1,CHROT,21,NMU025,0)#                                   MU20  72
BUFOT(1) = FLOAT(MAXOBS)#                                               MU20  73
ncodefld:(BUFOT,1,CHROT,FMT022,1)##                                     MU20  74
writeline:(0,0,0,1,3)#                                                  MU20  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MU20  76
#                                                                       MU20  77
IF(STATS == 1)  writeline:(1,MU026,NMU026,3,3)#                         MU20  78
ELSE  IF(STATS == 0)  writeline:(1,MU02A,NMU02A,3,3)#                   MU20  79
#                                                                       MU20  80
NOREPS = 0#                            Clear counter for number of      MU20  81
#                                         Unreplicated reflections.     MU20  82
MAXS = SLOTS#                          Number of slots for sitol        MU20  83
#                                         Statistics.                   MU20  84
MAXY = maxslots:#                      Number of slots for fsq stat     MU20  85
FSQINC = 0.020#                        Reciprocal of fsq slot width     MU20  86
IF(STATS > 0)#                         If statistics wanted, set        MU20  87
#                                         The slotting parameters for   MU20  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MU20  89
SINC = FLOAT(SLOTS)/((SMAX-SMIN)**3)#  Sitol.  hopefully this will      MU20  90
STH = SINC**3#                         Put the same number of           MU20  91
#                                         Reflections in each slot.     MU20  92
# ZERO OUT ALL OF THE STATISTICAL COUNTS AND SUMS.                      MU20  93
MAXY4 = 4*MAXY#                                                         MU20  94
movereal:(NUL,1,SMAVG1,1,MAXY4,2)#                                      MU20  95
movereal:(NUL,1,SMSIG1,1,MAXY4,2)#                                      MU20  96
DO I=1,MAXY4#                                                           MU20  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MU20  98
NREFS1(I) = 0#                                                          MU20  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MU20 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MU20 101
#                                                                       MU20 102
IMERGE = 1#                            No merging done                  MU20 103
#                                                                       MU20 104
# PREPARE TO LIST REFLECTION INDICES ONLY                               MU20 105
IF(OPTION == 1)  CALL MU21#                                             MU20 106
#                                                                       MU20 107
# OTHERWISE DO VARIOUS F**2-TYPE LISTINGS                               MU20 108
ELSE  CALL MU22#                                                        MU20 109
#                                                                       MU20 110
RETURN#                                                                 MU20 111
END#                                                                    MU20 112
systemheader:(MU21)#                                                    MU21   1
# ################################################################## #  MU21   2
#                                                                    #  MU21   3
#                               MU21                                 #  MU21   4
#                                                                    #  MU21   5
# ################################################################## #  MU21   6
SUBROUTINE MU21#                       Read in logical record lrref     MU21   7
#                                      And accumulate up to mxpage      MU21   8
#                                      Sets of indices per output       MU21   9
#                                      Sep 1979  r.a. alden             MU21  10
include:(AACOMN)#                                                       MU21  11
include:(MUCOMN)#                                                       MU21  12
#                                                                       MU21  13
INTEGER HPT#                           Pointer to current packed hk     MU21  14
INTEGER MXPAGE#                        Maximum number of indices pe     MU21  15
INTEGER NREFS#                         Count of reflections process     MU21  16
INTEGER ONPAGE#                        Number of indices on current     MU21  17
INTEGER TOTAL#                         Total number of indices list     MU21  18
chardata:(MU111,REFLECTIONS WERE LISTED)#                               MU21  19
realdata:(FMT111,[60513.])#                                             MU21  20
datastuff:#                                                             MU21  21
#                                                                       MU21  22
MXPAGE = (prtlmax:-4)*10#              Maximum number of indic          MU21  23
NREFS  = 0#                            Initializations.......           MU21  24
ONPAGE = 0#                                                             MU21  25
TOTAL  = 0#                                                             MU21  26
HPT = HPTR#                            Point to first packed hkl        MU21  27
PGPTR = HPTR + MXPAGE#                 Start of formatted output pa     MU21  28
incrqx:(ENDPTR,PGPTR+3*MXPAGE,MU2101)## Get space                       MU21  29
CALL MU01(0)#                          Prepare for reading              MU21  30
#                                                                       MU21  31
# READ LOG. REC. LRREFL:,  1 REFLECTION AT A TIME, GRABBING HKL         MU21  32
#                                                                       MU21  33
FOR(CALL MU01(1); SITOL >= 0.; CALL MU01(1))#                           MU21  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MU21  35
IF(SITOL <= SMIN \  SITOL >= SMAX)  NEXT#                               MU21  36
NREFS = NREFS + 1#                     Count the reflection             MU21  37
IF(NREFS > MAXRFS)  BREAK#             Stop if requested count          MU21  38
ONPAGE = ONPAGE + 1#                   Increment no. of indices on      MU21  39
IF(ONPAGE > MXPAGE)#                   If there are too many,           MU21  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MU21  41
CALL MU23(MXPAGE)#                     Print the page.                  MU21  42
TOTAL = TOTAL + MXPAGE#                Increment total listed           MU21  43
ONPAGE = 1#                            Start new page count             MU21  44
HPT = HPTR#                                                             MU21  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MU21  46
HPT = HPT + 1#                         Point to next packed hkl         MU21  47
intpak:(HKLNOW,QX(HPT),0,mxbtwd:)#     Save indices                     MU21  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MU21  49
#                                                                       MU21  50
IF(ONPAGE > 0)  CALL MU23(ONPAGE)#     Print partial last page          MU21  51
#                                                                       MU21  52
TOTAL = TOTAL + ONPAGE#                Total no. of indices listed      MU21  53
#                                                                       MU21  54
movechar:(MU111,1,CHROT,8,NMU111,0)#   Inform user of no. listed        MU21  55
BUFOT(1) = FLOAT(TOTAL)#                                                MU21  56
ncodefld:(BUFOT,1,CHROT,FMT111,1)##                                     MU21  57
writeline:(3,0,0,1,3)#                                                  MU21  58
#                                                                       MU21  59
RETURN#                                                                 MU21  60
END#                                                                    MU21  61
systemheader:(MU22)#                                                    MU22   1
# ################################################################## #  MU22   2
#                                                                    #  MU22   3
#                               MU22                                 #  MU22   4
#                                                                    #  MU22   5
# ################################################################## #  MU22   6
SUBROUTINE MU22#                       Process logical record lrref     MU22   7
#                                        For each reflection make       MU22   8
#                                         Listing according to option   MU22   9
#                                         Requested.                    MU22  10
#                                        Sep 1979  r.a. alden           MU22  11
include:(AACOMN)#                                                       MU22  12
include:(MUCOMN)#                                                       MU22  13
#                                                                       MU22  14
INTEGER FPT#                           Pointer to current f**2          MU22  15
INTEGER I#                             Loop index                       MU22  16
INTEGER IH(3)#                         Unpacked miller indices          MU22  17
INTEGER L#                             Location in output buffer of     MU22  18
#                                         Miller indices.               MU22  19
INTEGER LCT#                           Line position indicator          MU22  20
INTEGER NOBLST#                        Number of observations liste     MU22  21
INTEGER NOOSTH#                        Number of obs. outside sitol     MU22  22
#                                         Range.                        MU22  23
INTEGER NREP#                          Number of useable replicates     MU22  24
#                                         For a reflection.             MU22  25
INTEGER NRFLST#                        Number of reflections listed     MU22  26
INTEGER NROSTH#                        Number of refls. outside sit     MU22  27
#                                         Range.                        MU22  28
INTEGER NRP#                           Number of obs. to be listed      MU22  29
#                                         Current line.                 MU22  30
chardata:(MU121,[   H   K   L    F**2  SIG(F**2)  OBS      H   $#       MU22  31
K   L    F**2  SIG(F**2)  OBS      H   K   L    F**2  SIG(F**2) $#      MU22  32
OBS])#                                                                  MU22  33
chardata:(MU122,[   H   K   L  AVE(F**2)  SIG(F**2)       $#            MU22  34
F**2   SIGMA  GRP     F**2   SIGMA  GRP     F**2   SIGMA  GRP     $#    MU22  35
F**2   SIGMA  GRP])#                                                    MU22  36
chardata:(MU123,   H   K   L     F**2   SIGMA  GRP     F**2   $#        MU22  37
SIGMA  GRP     F**2   SIGMA  GRP     F**2   SIGMA  GRP     F**2   $#    MU22  38
SIGMA  GRP)#                                                            MU22  39
chardata:(MU124,THERE WERE       OBSERVATIONS OF       REFLECTIONS $#   MU22  40
LISTED)#                                                                MU22  41
chardata:(MU125,[OBSERVATIONS OF       REFLECTIONS WERE OUTSIDE OF $#   MU22  42
THE REQUESTED SINE(THETA)/LAMBDA RANGE])#                               MU22  43
chardata:(MU126,THERE WERE       REFLECTIONS WITH NO SCALED $#          MU22  44
REPLICATES)#                                                            MU22  45
realdata:(FMT121,[40313.,80313.,#                                       MU22  46
120313.,20712.,310712.,360413.,#                                        MU22  47
430313.,470313.,510313.,590712.,#                                       MU22  48
700712.,750413.,820313.,860313.,900313.,980712.,#                       MU22  49
1090712.,1140413.])#                                                    MU22  50
realdata:(FMT122,[40313.,80313.,#                                       MU22  51
120313.,230812.,340712.,450712.,#                                       MU22  52
530612.,580413.,670712.,750612.,#                                       MU22  53
800413.,890712.,970612.,1020413.,#                                      MU22  54
1110712.,1190612.,1240413.])#                                           MU22  55
realdata:(FMT123,[40313.,80313.,120313.,#                               MU22  56
210712.,290612.,340413.,#                                               MU22  57
430712.,510612.,560413.,650712.,#                                       MU22  58
730612.,780413.,870712.,950612.,#                                       MU22  59
1000413.,1090712.,1170612.,1220413.])#                                  MU22  60
realdata:(FMT124,[170513.,390513.])#                                    MU22  61
realdata:(FMT125,[60513.,280513.])#                                     MU22  62
datastuff:#                                                             MU22  63
#                                                                       MU22  64
# INITIALIZATIONS.....                                                  MU22  65
NROSTH = 0#                            No. of obs. ouside sitol ran     MU22  66
NOOSTH = 0#                            Same for refls.                  MU22  67
NRFLST = 0#                            No. of reflections               MU22  68
NOBLST = 0#                            And observations listed.         MU22  69
LINCT  = 0#                            Force new page                   MU22  70
LCT    = 0#                            Line position                    MU22  71
CALL MU01(0)#                          Prepare for reading              MU22  72
#                                                                       MU22  73
# PROCESS ONE REFLECTION AT A TIME                                      MU22  74
FOR(CALL MU01(1); SITOL >= 0.; CALL MU01(1))#                           MU22  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MU22  76
IF(SITOL <= SMIN \  SITOL >= SMAX)#    Make sure reflection is          MU22  77
#                                         Within sitol range.           MU22  78
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MU22  79
NOOSTH = NOOSTH + OBS#                 If not, count obs. and refls     MU22  80
NROSTH = NROSTH + 1#                   Which are outside.               MU22  81
NEXT#                                  Try another reflection           MU22  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MU22  83
#                                                                       MU22  84
CALL MU24(NREP)#                       Calculate average f**2 and       MU22  85
#                                         Its sigma.                    MU22  86
IF(NREP == 0)#                         If there were no replicated      MU22  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MU22  88
NOREPS = NOREPS + 1#                   Observations, count and go       MU22  89
NEXT#                                  To the next reflection.          MU22  90
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MU22  91
NRFLST = NRFLST + 1#                   Count reflections and            MU22  92
NOBLST = NOBLST + NREP#                Observations listed.             MU22  93
IF(NRFLST > MAXRFS \  NOBLST > MAXOBS)# If any of the listing limits    MU22  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MU22  95
NRFLST = NRFLST - 1#                   Has been reached, correct        MU22  96
NOBLST = NOBLST - OBS#                 The counts and stop any          MU22  97
BREAK#                                 Further processing.              MU22  98
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MU22  99
#                                                                       MU22 100
CALL MU02(1,HKLNOW,IH,'   ',0)#         Pick up the indices    ^^
#                                                                       MU22 102
DO I=1,3#                                                               MU22 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MU22 104
L = LCT + I#                                                            MU22 105
BUFOT(L) = FLOAT(IH(I))#                                                MU22 106
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MU22 107
#                                                                       MU22 108
FPT = FPTR - 3#                        Initialize f**2 pointer          MU22 109
#                                                                       MU22 110
IF(OPTION == 2)#                       Reflection based quantities      MU22 111
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MU22 112
BUFOT(LCT+4) = AVGFSQ#                                                  MU22 113
BUFOT(LCT+5) = SIGFSQ#                                                  MU22 114
BUFOT(LCT+6) = FLOAT(NREP)#                                             MU22 115
LCT = LCT + 6#                                                          MU22 116
#                                                                       MU22 117
IF(LCT >= 18)#                         Is the line full?                MU22 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MU22 119
ncodefld:(BUFOT,1,CHROT,FMT121(1),LCT)# Yes, print it.                  MU22 120
writeline:(0,MU121,NMU121,1,3)#                                         MU22 121
LCT = 0#                               Re-set line position pointer     MU22 122
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MU22 123
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MU22 124
#                                                                       MU22 125
ELSE  IF(OPTION == 3)#                 Scaled observational             MU22 126
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MU22 127
BUFOT(LCT+4) = AVGFSQ#                 Quantities.                      MU22 128
BUFOT(LCT+5) = SIGFSQ#                                                  MU22 129
LCT = 5#                               Update position pointer          MU22 130
NRP = MIN0(4,NREP)#                    Maximum number of replicates     MU22 131
FOR(I=1; I <= NRP; I=I+1)#             That can be listed on the        MU22 132
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MU22 133
stuff:#                                Current line.                    MU22 134
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MU22 135
#                                                                       MU22 136
ncodefld:(BUFOT,1,CHROT,FMT122(1),LCT)#                                 MU22 137
writeline:(0,MU122,NMU122,1,3)#        Write the line                   MU22 138
LCT = 0#                               Re-set pointer                   MU22 139
#                                                                       MU22 140
IF(NREP > 4)#                          Are there more replicates to     MU22 141
#                                         To be listed?                 MU22 142
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MU22 143
FOR(I=5; I <= NREP; I=I+1)#            Yes, continue listing them       MU22 144
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MU22 145
stuff:#                                A maximum of 4 per line.         MU22 146
IF(LCT >= 12)#                                                          MU22 147
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MU22 148
ncodefld:(BUFOT,1,CHROT,FMT122(6),LCT)#                                 MU22 149
writeline:(0,MU122,NMU122,1,3)#                                         MU22 150
LCT = 0#                                                                MU22 151
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MU22 152
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MU22 153
IF(LCT != 0)#                          Write final partial line         MU22 154
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MU22 155
ncodefld:(BUFOT,1,CHROT,FMT122(6),LCT)#                                 MU22 156
writeline:(0,MU122,NMU122,1,3)#                                         MU22 157
LCT = 0#                               Re-set pointer                   MU22 158
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MU22 159
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MU22 160
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MU22 161
#                                                                       MU22 162
ELSE  IF(OPTION == 4)#                 Unscaled observational           MU22 163
#                                         Quantities.                   MU22 164
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MU22 165
LCT = 3#                               Print them 5 to a line.          MU22 166
NRP = MIN0(5,NREP)#                    First line only contains hkl     MU22 167
FOR(I=1; I <= NRP; I=I+1)#                                              MU22 168
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MU22 169
stuff:#                                                                 MU22 170
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MU22 171
ncodefld:(BUFOT,1,CHROT,FMT123(1),LCT)#                                 MU22 172
writeline:(0,MU123,NMU123,1,3)#                                         MU22 173
LCT = 0#                                                                MU22 174
#                                                                       MU22 175
IF(NREP > 5)#                          Second and all subsequent        MU22 176
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MU22 177
FOR(I=6; I <= NREP; I=I+1)#            Lines come here.                 MU22 178
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MU22 179
stuff:#                                                                 MU22 180
IF(LCT >= 15)#                                                          MU22 181
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MU22 182
ncodefld:(BUFOT,1,CHROT,FMT123(4),LCT)#                                 MU22 183
writeline:(0,MU123,NMU123,1,3)#                                         MU22 184
LCT = 0#                                                                MU22 185
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MU22 186
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MU22 187
IF(LCT != 0)#                          Last partial line                MU22 188
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MU22 189
ncodefld:(BUFOT,1,CHROT,FMT123(4),LCT)#                                 MU22 190
writeline:(0,MU123,NMU123,1,3)#                                         MU22 191
LCT = 0#                                                                MU22 192
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MU22 193
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MU22 194
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MU22 195
#                                                                       MU22 196
IF(STATS > 0)  CALL MU25(NREP)#        If requested, accumulate         MU22 197
#                                         Statistics.                   MU22 198
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MU22 199
#                                                                       MU22 200
IF(OPTION == 2  &  LCT > 0)#           Finish off any partial last      MU22 201
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MU22 202
ncodefld:(BUFOT,1,CHROT,FMT121(1),LCT)# Line.                           MU22 203
writeline:(0,MU121,NMU121,1,3)#                                         MU22 204
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MU22 205
#                                                                       MU22 206
BUFOT(1) = FLOAT(NOBLST)#              Put out total reflection and     MU22 207
BUFOT(2) = FLOAT(NRFLST)#              Observation counts.              MU22 208
movechar:(MU124,1,CHROT,2,NMU124,0)#                                    MU22 209
ncodefld:(BUFOT,1,CHROT,FMT124(1),2)##                                  MU22 210
writeline:(2,0,0,1,3)#                                                  MU22 211
#                                                                       MU22 212
IF(NROSTH > 0)#                        List observations and            MU22 213
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MU22 214
BUFOT(1) = FLOAT(NOOSTH)#              Reflections that were outsid     MU22 215
BUFOT(2) = FLOAT(NROSTH)#              Of sine(theta)/lambda limits     MU22 216
movechar:(MU125,1,CHROT,8,NMU125,0)#                                    MU22 217
ncodefld:(BUFOT,1,CHROT,FMT125(1),2)##                                  MU22 218
writeline:(1,0,0,1,3)#                                                  MU22 219
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MU22 220
#                                                                       MU22 221
IF(NOREPS > 0)#                        List the number of               MU22 222
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MU22 223
movechar:(MU126,1,CHROT,2,NMU126,0)#   Unreplicated reflections.        MU22 224
BUFOT(1) = FLOAT(NOREPS)#                                               MU22 225
ncodefld:(BUFOT,1,CHROT,FMT124(1),1)##                                  MU22 226
writeline:(1,0,0,1,3)#                                                  MU22 227
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MU22 228
#                                                                       MU22 229
RETURN#                                                                 MU22 230
END#                                                                    MU22 231
systemheader:(MU23)#                                                    MU23   1
# ################################################################## #  MU23   2
#                                                                    #  MU23   3
#                               MU23                                 #  MU23   4
#                                                                    #  MU23   5
# ################################################################## #  MU23   6
SUBROUTINE MU23(NUM)#                  List an array of indices         MU23   7
#                                         In multi-column format.       MU23   8
#                                        Sep 1979  r.a. alden           MU23   9
include:(AACOMN)#                                                       MU23  10
include:(MUCOMN)#                                                       MU23  11
#                                                                       MU23  12
INTEGER COLPTR#                        Points to top of next column     MU23  13
INTEGER I#                             Loop index                       MU23  14
INTEGER IH(3)#                         The current unpacked hkl         MU23  15
INTEGER J#                             Another loop index               MU23  16
INTEGER LAST#                          Points to the end of the pag     MU23  17
#                                         Of unpacked indices.          MU23  18
INTEGER LEFT#                          Number of columns in final r     MU23  19
INTEGER NCOLS#                         Number of columns needed         MU23  20
INTEGER NROWS#                         Number of rows needed            MU23  21
INTEGER NUM#                           Number of indices to be list     MU23  22
#                                         On this page.                 MU23  23
INTEGER PAKHKL#                        Packed indices                   MU23  24
INTEGER PTR#                           Points to location of curren     MU23  25
#                                         Unpacked indices.             MU23  26
INTEGER ROW#                           Row number                       MU23  27
#                                                                       MU23  28
INTEGER HPT#                                                            MU23  29
REAL H(3)#                             Unpacked indices                 MU23  30
chardata:(MU201,     H  K  L)#                                          MU23  31
realdata:(FMT201,[60313.,90313.,120313.])#                              MU23  32
datastuff:#                                                             MU23  33
#                                                                       MU23  34
NROWS = ((NUM-1)/10) + 1#              Number of rows to be printed     MU23  35
IF(NUM < 10)  NCOLS = NUM#             Maximum number of columns to     MU23  36
ELSE          NCOLS = 10#              Be printed.                      MU23  37
#                                                                       MU23  38
# CREATE ENOUGH COLUMN FORMATS                                          MU23  39
FOR(I=4; I <= NCOLS*3; I=I+1)  FMT201(I) = FMT201(I-3) + 120000.#       MU23  40
#                                                                       MU23  41
ROW = 0#                               Initialize row number            MU23  42
#                                                                       MU23  43
COLPTR = PGPTR + 1#                    Start of table                   MU23  44
LAST = COLPTR + 3*NUM#                 End of table                     MU23  45
PTR = COLPTR - 30#                                                      MU23  46
#                                                                       MU23  47
FOR(I=1; I <= NUM; I=I+1)#             Process each index               MU23  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MU23  49
HPT = HPTR + I#                        Point to next packed index       MU23  50
ROW = ROW + 1#                         Increment row count for the      MU23  51
#                                         Current column.               MU23  52
PTR = PTR + 30#                        Point to next storage locati     MU23  53
IF(ROW > NROWS \  PTR >= LAST)#        Max. of nrows rows/column        MU23  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MU23  55
ROW = 1#                               Proceed to next column           MU23  56
PTR = COLPTR + 3#                                                       MU23  57
COLPTR = PTR#                                                           MU23  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MU23  59
intunpak:(QX(HPT),PAKHKL,0,mxbtwd:)#   Move packed word                 MU23  60
CALL MU02(1,PAKHKL,IH,'   ',0)#        Pick up indices    ^^
DO J=1,3#                              And float them.                  MU23  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MU23  63
H(J) = FLOAT(IH(J))#                                                    MU23  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MU23  65
movereal:(H,1,QX,PTR,3,0)#             Store them in page               MU23  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MU23  67
#                                                                       MU23  68
LINRM = NROWS + 2#                     Enough space for entire          MU23  69
#                                         Listing.                      MU23  70
#                                                                       MU23  71
FOR(J=0; J < NCOLS; J=J+1)#            Make proper number of headin     MU23  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MU23  73
movechar:(MU201,1,CHROT,12*J+1,12,0)#                                   MU23  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MU23  75
writeline:(1,0,0,1,3)#                                                  MU23  76
#                                                                       MU23  77
PTR = PGPTR - 29#                                                       MU23  78
FOR(J=1; J <= ROW; J=J+1)#             Print rows of maximum width      MU23  79
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MU23  80
PTR = PTR + 30#                                                         MU23  81
ncodefld:(QX,PTR,CHROT,FMT201(1),NCOLS*3)#                              MU23  82
writeline:(0,0,0,1,3)#                                                  MU23  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MU23  84
#                                                                       MU23  85
LEFT = NUM - (NROWS-1)*10#             Length of partial row            MU23  86
IF(NROWS > 1 & LEFT < 10)#                                              MU23  87
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MU23  88
PTR = PTR + 30#                                                         MU23  89
ncodefld:(QX,PTR,CHROT,FMT201(1),LEFT*3)#                               MU23  90
writeline:(0,0,0,1,3)#                 Print partial row                MU23  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MU23  92
#                                                                       MU23  93
RETURN#                                                                 MU23  94
END#                                                                    MU23  95
systemheader:(MU24)#                                                    MU24   1
# ################################################################## #  MU24   2
#                                                                    #  MU24   3
#                               MU24                                 #  MU24   4
#                                                                    #  MU24   5
# ################################################################## #  MU24   6
SUBROUTINE MU24(NREP)#                 Process a single reflection      MU24   7
#                                         Calculating its average f**2  MU24   8
#                                         And sigma(f**2).              MU24   9
#                                        Sep 1979  r.a. alden           MU24  10
include:(AACOMN)#                                                       MU24  11
include:(MUCOMN)#                                                       MU24  12
#                                                                       MU24  13
INTEGER FPT#                           Pointer to current f**2          MU24  14
INTEGER I#                             Loop index                       MU24  15
INTEGER J#                             Another loop index               MU24  16
INTEGER NREP#                          Number of replicates             MU24  17
INTEGER OUTPT#                         Pointer to re-stored f**2        MU24  18
INTEGER SCPT#                          Pointer to current scale fac     MU24  19
INTEGER SHPT#                          Pointer to current shift no.     MU24  20
REAL DEN#                              Sum of the weights               MU24  21
REAL FSQ#                              Current f**2                     MU24  22
REAL NUM#                              Sum of the weighted f**2         MU24  23
REAL SCALE#                            Current scale factor             MU24  24
REAL SHIFT#                            Current shift number             MU24  25
REAL SIGMA#                            And sigma.                       MU24  26
REAL WEIGHT#                           1/sigma**2                       MU24  27
#                                                                       MU24  28
NREP = 0#                              Initializations.....             MU24  29
NUM  = 0.#                                                              MU24  30
DEN  = 0.#                                                              MU24  31
FPT = FPTR - 3#                                                         MU24  32
OUTPT = FPT#                                                            MU24  33
IF(OPTION == 4)  NREP = OBS#           No scales to be applied          MU24  34
#                                                                       MU24  35
ELSE#                                                                   MU24  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MU24  37
FOR(I=1; I <= OBS; I=I+1)#             Loop over the observations       MU24  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MU24  39
FPT = FPT + 3#                         Point to next f**2               MU24  40
FSQ = QX(FPT+1)#                       Pick up f**2,                    MU24  41
SIGMA = QX(FPT+2)#                     Sigma(f**2), and                 MU24  42
SHIFT = QX(FPT+3)#                     The shift number.                MU24  43
#                                                                       MU24  44
FOR(J=1; J <= NSHIFT; J=J+1)#          Scaled observations              MU24  45
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MU24  46
SHPT = SHPTR + J#                                                       MU24  47
ifeq:(SHIFT,QX(SHPT))  BREAK#                                           MU24  48
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MU24  49
IF(J > NSHIFT)  NEXT#                  There must be a scale            MU24  50
SCPT = SCPTR + J#                                                       MU24  51
SCALE = QX(SCPTR+J)#                                                    MU24  52
NREP = NREP + 1#                       Count replicates                 MU24  53
OUTPT = OUTPT + 3#                     Point to where next output       MU24  54
#                                         F**2, etc., will be put.      MU24  55
FSQ = SCALE*FSQ#                       Scale f**2 and                   MU24  56
SIGMA = SCALE*SIGMA#                   Sigma.                           MU24  57
QX(OUTPT+1) = FSQ#                     Store back scaled values         MU24  58
QX(OUTPT+2) = SIGMA#                                                    MU24  59
QX(OUTPT+3) = SHIFT#                                                    MU24  60
#                                                                       MU24  61
IF(SIGMA < 0.001)  NEXT#                                                MU24  62
#                                                                       MU24  63
WEIGHT = 1./(SIGMA**2)#                                                 MU24  64
NUM = NUM + WEIGHT*FSQ#                                                 MU24  65
DEN = DEN + WEIGHT#                                                     MU24  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MU24  67
#                                                                       MU24  68
IF(NREP > 0)#                                                           MU24  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MU24  70
AVGFSQ = NUM/DEN#                      Mean f**2                        MU24  71
SIGFSQ = SQRT(1./DEN)#                                                  MU24  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MU24  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MU24  74
#                                                                       MU24  75
RETURN#                                                                 MU24  76
END#                                                                    MU24  77
systemheader:(MU25)#                                                    MU25   1
# ################################################################## #  MU25   2
#                                                                    #  MU25   3
#                               MU25                                 #  MU25   4
#                                                                    #  MU25   5
# ################################################################## #  MU25   6
SUBROUTINE MU25(NREP)#                 Accumulate statistics            MU25   7
#                                        Sep 1979  r.a. alden           MU25   8
include:(AACOMN)#                                                       MU25   9
include:(MUCOMN)#                                                       MU25  10
#                                                                       MU25  11
INTEGER FPT#                           Pointer to next f**2             MU25  12
INTEGER I#                             Loop index                       MU25  13
INTEGER M#                             Index for proper f**2 slot       MU25  14
INTEGER N#                             Index for proper sitol slot      MU25  15
INTEGER NREP#                          Number of replicates             MU25  16
REAL SIG#                              Calculated standard deviatio     MU25  17
realdata:(SIGHY,[0.0])#                Unbiased estimate of the         MU25  18
datastuff:#                                                             MU25  19
#                                                                       MU25  20
IF(NREP > 1)#                          Reflection must be multiply      MU25  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MU25  22
FPT = FPTR - 3#                        Initialize f**2 pointer          MU25  23
SIG = 0.#                              Get the unbiased estimate of     MU25  24
#                                         The standard deviation.       MU25  25
FOR(I=1; I <= NREP; I=I+1)#                                             MU25  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MU25  27
FPT = FPT + 3#                         Point to next f**2               MU25  28
SIG = SIG + ((QX(FPT+1)-AVGFSQ)/QX(FPT+2))**2#                          MU25  29
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MU25  30
SIGHY = SIGFSQ*SQRT(SIG/(FLOAT(NREP-1)))#                               MU25  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MU25  32
#                                                                       MU25  33
###### DO NOT CHANGE THIS  INT  TO NINT #####                           MU25  34
M =   INT(AVGFSQ*FSQINC) + 1#          Get proper f**2 slot             MU25  35
IF(M > MAXY)  M = MAXY#                                                 MU25  36
#                                                                       MU25  37
NREFS1(M) = NREFS1(M) + 1#             Count observation                MU25  38
SMAVG1(M) = SMAVG1(M) + AVGFSQ#        Accumulate the sums of f**2      MU25  39
SMSIG1(M) = SMSIG1(M) + SIGFSQ#        And sigma(f**2)                  MU25  40
#                                                                       MU25  41
###### DO NOT CHANGE THIS INT TO NINT #####                             MU25  42
N = INT((SITOL-SMIN)**3*SINC) + 1#     Get proper sine(theta)/lambd     MU25  43
IF(N > MAXS)  N = MAXS#                Slot.                            MU25  44
NREFS2(N) = NREFS2(N) + 1#             Count observation                MU25  45
SMAVG2(N) = SMAVG2(N) + AVGFSQ#        Etc.                             MU25  46
SMSIG2(N) = SMSIG2(N) + SIGFSQ#                                         MU25  47
#                                                                       MU25  48
IF(NREP > 1)#                                                           MU25  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MU25  50
NREFS3(M) = NREFS3(M) + 1#             Because this reflection has      MU25  51
SMAVG3(M) = SMAVG3(M) + AVGFSQ#        Been multiply observed,          MU25  52
SMSIG3(M) = SMSIG3(M) + SIGHY#         Sigma-hat statistics can be      MU25  53
#                                         Calculated.                   MU25  54
NREFS4(N) = NREFS4(N) + 1#                                              MU25  55
SMAVG4(N) = SMAVG4(N) + AVGFSQ#                                         MU25  56
SMSIG4(N) = SMSIG4(N) + SIGHY#                                          MU25  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MU25  58
#                                                                       MU25  59
RETURN#                                                                 MU25  60
END#                                                                    MU25  61
systemheader:(MU30)#                                                    MU30   1
# ################################################################## #  MU30   2
#                                                                    #  MU30   3
#                               MU30                                 #  MU30   4
#                                                                    #  MU30   5
# ################################################################## #  MU30   6
SUBROUTINE MU30#                       List statistics                  MU30   7
#                                        Sep 1979  r.a. alden           MU30   8
include:(AACOMN)#                                                       MU30   9
include:(MUCOMN)#                                                       MU30  10
#                                                                       MU30  11
INTEGER I#                             Loop index                       MU30  12
INTEGER J#                             Another loop index               MU30  13
INTEGER MSUM#                          Total number of reflections      MU30  14
INTEGER NSUM#                          Total number of replicated       MU30  15
REAL F0#                               Minimum f**2 for a slot          MU30  16
REAL F1#                               Maximumf**2 for a slot           MU30  17
REAL SUM1#                             Total sum of avgfsq              MU30  18
REAL SUM2#                             Total sum of sigma(f**2)         MU30  19
REAL SUM3#                             Total sum of avgfsq for          MU30  20
#                                         Replicated reflections.       MU30  21
REAL SUM4#                             Total sum of sigma(f**2) for     MU30  22
#                                         Replicated reflections.       MU30  23
REAL S1#                               Maximum sitol for a slot         MU30  24
REAL T#                                Scratch holding number of        MU30  25
#                                         Reflections.                  MU30  26
chardata:(MU031, STATISTICAL R-FACTORS)#                                MU30  27
chardata:(MU032,[ SUM SIGMA-HAT(F**2)/SUM(F**2)     SUM $#              MU30  28
SIGMA(F**2)/SUM(F**2)])#                                                MU30  29
chardata:(MU033,OVERALL MEAN VALUES FOR       REFLECTIONS)#             MU30  30
chardata:(MU034,[   F**2   SIGMA-HAT(F**2)   SIGMA(F**2)])#             MU30  31
chardata:(MU035,     SITOL RANGE    RESOLUTION      REFS    MEAN $#     MU30  32
F**2  MEAN SIGMA      R  REP REFS  MEAN SIGHAT      R)#                 MU30  33
chardata:(MU036,     F**2 RANGE      REFS    MEAN F**2  MEAN $#         MU30  34
SIGMA      R  REP REFS  MEAN SIGHAT      R)#                            MU30  35
realdata:(FMT031,[200632.,500632.])#                                    MU30  36
realdata:(FMT032,[80722.,200732.,340732.])#                             MU30  37
realdata:(FMT033,[80752.,180752.,#                                      MU30  38
300842.,400813.,530832.,650842.,#                                       MU30  39
720522.,820813.,950842.,1020522.])#                                     MU30  40
realdata:(FMT034,[60513.,150513.,#                                      MU30  41
250813.,380832.,500842.,570522.,#                                       MU30  42
670813.,800842.,870522.])#                                              MU30  43
realdata:(FMT035,300513.)#                                              MU30  44
datastuff:#                                                             MU30  45
#                                                                       MU30  46
SUM1 = 0.#                             Initialize sums                  MU30  47
SUM2 = 0.#                                                              MU30  48
SUM3 = 0.#                                                              MU30  49
SUM4 = 0.#                                                              MU30  50
MSUM = 0#                                                               MU30  51
NSUM = 0#                                                               MU30  52
#                                                                       MU30  53
FOR(I=1; I <= MAXY; I=I+1)#            Get grand sums                   MU30  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MU30  55
SUM1 = SUM1 + SMAVG1(I)#                                                MU30  56
SUM2 = SUM2 + SMSIG1(I)#                                                MU30  57
SUM3 = SUM3 + SMAVG3(I)#                                                MU30  58
SUM4 = SUM4 + SMSIG3(I)#                                                MU30  59
MSUM = MSUM + NREFS1(I)#                                                MU30  60
NSUM = NSUM + NREFS3(I)#                                                MU30  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MU30  62
#                                                                       MU30  63
LINRM = 10#                                                             MU30  64
writeline:(2,MU031,NMU031,3,3)#                                         MU30  65
writeline:(1,MU032,NMU032,3,3)#                                         MU30  66
BUFOT(1) = SUM4/SUM3#                  Sum sigma-hat(f**2)/sum(f**2     MU30  67
BUFOT(2) = SUM2/SUM1#                  Sum sigma(f**2)/sum(f**2)        MU30  68
ncodefld:(BUFOT,1,CHROT,FMT031(1),2)##                                  MU30  69
writeline:(0,0,0,1,3)#                                                  MU30  70
#                                                                       MU30  71
T = FLOAT(MSUM)#                       Reflection count                 MU30  72
movechar:(MU033,1,CHROT,2,NMU033,0)#                                    MU30  73
BUFOT(1) = T#                                                           MU30  74
ncodefld:(BUFOT,1,CHROT,FMT035,1)#                                      MU30  75
writeline:(1,0,0,1,3)#                                                  MU30  76
writeline:(0,MU034,NMU034,3,3)#                                         MU30  77
#                                                                       MU30  78
BUFOT(1) = SUM1/T#                     Mean f**2                        MU30  79
BUFOT(2) = SUM4/FLOAT(NSUM)#           Mean sigma-hat(f**2)             MU30  80
BUFOT(3) = SUM2/T#                     Mean sigma(f**2)                 MU30  81
ncodefld:(BUFOT,1,CHROT,FMT032(1),3)##                                  MU30  82
writeline:(0,0,0,1,3)#                                                  MU30  83
#                                                                       MU30  84
LINCT = 0#                             Force a new page                 MU30  85
writeline:(1,MU035,NMU035,3,3)#        Write heading line               MU30  86
S1 = SMIN#                             Minimum sitol for 1st slot       MU30  87
#                                                                       MU30  88
FOR(I=1; I <= MAXY; I=I+1)#            List statistics slotted          MU30  89
#                                         On sitol.                     MU30  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MU30  91
IF(NREFS2(I) != 0)#                    Skip if no contributions         MU30  92
#                                         To this slot.                 MU30  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MU30  94
DO J=8,10#                             In case there are no             MU30  95
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MU30  96
BUFOT(J) = 0.#                         Replicated reflections.          MU30  97
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MU30  98
T = FLOAT(NREFS2(I))#                  Number of reflections            MU30  99
BUFOT(4) = T#                                                           MU30 100
BUFOT(5) = SMAVG2(I)/T#                Mean f**2                        MU30 101
BUFOT(6) = SMSIG2(I)/T#                Mean sigma(f**2)                 MU30 102
IF(NREFS4(I) > 0)#                     If there were replicated dat     MU30 103
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MU30 104
BUFOT(8) = FLOAT(NREFS4(I))#           No. of replicated refls.         MU30 105
BUFOT(9) = SMSIG4(I)/BUFOT(8)#         Mean sigma-hat(f**2)             MU30 106
# CALCULATE R FACTOR = MEAN SIGMA-HAT(F**2)/MEAN F**2)                  MU30 107
BUFOT(10) = 100.*SMSIG4(I)/SMAVG4(I)#                                   MU30 108
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MU30 109
# CALCULATE R = MEAN SIGMA(F**2)/MEAN F**2                              MU30 110
ifne:(BUFOT(5),0.)  BUFOT(7) = 100.*BUFOT(6)/BUFOT(5)#                  MU30 111
ELSE  BUFOT(7) = 0.0#                                                   MU30 112
BUFOT(1) = S1#                         Minimum sitol for slot           MU30 113
S1 = SMIN + STH*(FLOAT(I)**(1./3.))#                                    MU30 114
BUFOT(2) = S1#                         Maximum (and minimum for nex     MU30 115
#                                         Slot).                        MU30 116
BUFOT(3) = 0.5/BUFOT(2)#               Maximum resolution for slot      MU30 117
#                                                                       MU30 118
ncodefld:(BUFOT,1,CHROT,FMT033(1),10)#                                  MU30 119
writeline:(0,MU035,NMU035,1,3)#                                         MU30 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MU30 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MU30 122
#                                                                       MU30 123
LINCT = 0#                             Force another new page           MU30 124
F0 = 0.#                               Minimum f**2 for 1st slot        MU30 125
F1 = 1./FSQINC#                        Maximum                          MU30 126
#                                                                       MU30 127
FOR(I=1; I <= MAXY; I=I+1)#            List statistics slotted on       MU30 128
#                                         F**2.                         MU30 129
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MU30 130
IF(NREFS1(I) != 0)#                    Skip listing if no               MU30 131
#                                         Reflections in this slot.     MU30 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MU30 133
DO J=7,9#                              In case there are no             MU30 134
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MU30 135
BUFOT(J) = 0.#                         Replicated reflections.          MU30 136
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MU30 137
T = FLOAT(NREFS1(I))#                  Number of reflections            MU30 138
BUFOT(3) = T#                                                           MU30 139
BUFOT(4) = SMAVG1(I)/T#                Mean f**2                        MU30 140
BUFOT(5) = SMSIG1(I)/T#                Mean sigma(f**2)                 MU30 141
IF(NREFS3(I) > 0)#                     For slots with replicated        MU30 142
#                                         Reflections.                  MU30 143
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MU30 144
BUFOT(7) = FLOAT(NREFS3(I))#           No. of replicated refls.         MU30 145
BUFOT(8) = SMSIG3(I)/BUFOT(7)#         Mean sigma-hat(f**2)             MU30 146
# CALCULATE R = MEAN SIGMA-HAT(F**2)/MEAN F**2                          MU30 147
BUFOT(9) = 100.*SMSIG3(I)/SMAVG3(I)#                                    MU30 148
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MU30 149
# CALCULATE R = MEAN SIGMA(F**2)/MEAN F**2                              MU30 150
ifne:(BUFOT(4),0.)  BUFOT(6) = 100.*BUFOT(5)/BUFOT(4)#                  MU30 151
ELSE  BUFOT(6) = 0.0#                                                   MU30 152
BUFOT(1) = F0#                         Minimum f**2 slot value          MU30 153
BUFOT(2) = F0 + F1#                    Maximum                          MU30 154
#                                                                       MU30 155
ncodefld:(BUFOT,1,CHROT,FMT034(1),9)##                                  MU30 156
writeline:(0,MU036,NMU036,1,3)#                                         MU30 157
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MU30 158
F0 = F0 + F1#                          Next minimum f**2 slot value     MU30 159
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MU30 160
#                                                                       MU30 161
RETURN#                                                                 MU30 162
END#                                                                    MU30 163
pmacro:([no:])#                        Purge xtal system macros         MU30 164
