systemheader:(MV    )#                                                  MV     1
######################################################################  MV     2
#                                                                    #  MV     3
#                         *** MOLVU ***                              #  MV     4
#                                                                    #  MV     5
#   PROGRAM FOR GENERATING MOLVIEW INPUT LINES TO PLOT ATOMS         #  MV     6
#                                                                    #  MV     7
######################################################################  MV     8
#                                                                       MV     9
include:(XMACRO)#                                                       MV    10
#                                                                       MV    11
macro:(put:,[writefmt:(iofm1:,'(a)',CHROT(1^$1));CHROT=' '])#           MV    12
#                                                                       MV    13
systemheader:(MV00)#                   Convert the input file           MV00   1
######################################################################  MV00   2
#                                                                    #  MV00   3
#                             MV00                                   #  MV00   4
#                                                                    #  MV00   5
######################################################################  MV00   6
SUBROUTINE MV00#                       S.r. hall oct. 91                MV00   7
include:(AACOMN)#                                                       MV00   8
#                                                                       MV00   9
INTEGER I,J,K,CELL#                                                     MV00  10
INTEGER MARKS,STOPS#                                                    MV00  11
INTEGER IWNT(2),IREL(3),KEY(4)#                                         MV00  12
#                                                                       MV00  13
chardata:(MV0, END )#                                                   MV00  14
chardata:(MV1,MOL CEL )#                                                MV00  15
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              MV00  16
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              MV00  17
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              MV00  18
realdata:(TR21,[.3333333,.5])#                                          MV00  19
realdata:(TR22,[.6666667,0.])#                                          MV00  20
realdata:(TR23,[.6666667,.5])#                                          MV00  21
realdata:(FMT1,[151042.,251042.,351042.,451032.,551032.,651032.])#      MV00  22
realdata:(FMT2,[281052.,381052.,481052.])#                              MV00  23
realdata:(FMT3,[100213.,300213.,500213.,130213.,330213.,530213.,#       MV00  24
160213.,360213.,560213.,250862.,450862.,650862.])#                      MV00  25
datastuff:#                                                             MV00  26
#                                                                       MV00  27
#    OPEN THE OUTPUT MOLVIEW FILE                                       MV00  28
#    ----------------------------                                       MV00  29
#                                                                       MV00  30
FILEXT(iofm1:)='M'#                    Ext of output molview file       MV00  31
openfmt:(iofm1:,' ')#                  Open xtal data file              MV00  32
IOMARK(1)=QXSTR#                       Define start of ip buffer        MV00  33
incrqx:(MARKS,IOMARK(1)+bdfbuf:,MV0002)# Get buffer memory              MV00  34
CELL=no:#                              Default is mole                  MV00  35
#                                                                       MV00  36
#     PROCESS THE MOLVU LINE                                            MV00  37
#     ----------------------                                            MV00  38
#                                                                       MV00  39
ifnv:(BUFIN(1))#                       If field 1 is active             MV00  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MV00  41
stringlim:(1,J,K)#                     Get the string limits            MV00  42
compchar:(CHRIN,J,MV1,1,3,4,8,K)#      See if mole or cell              MV00  43
IF(K==0) iquit:(MV0003)#               Unrecognised entry               MV00  44
CELL=K-1#                              Set cell mode                    MV00  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MV00  46
readline:(MV0,NMV0)#                   Read each line into chrin        MV00  47
#                                                                       MV00  48
#    READ AND OUTPUT CELL DATA                                          MV00  49
#    -------------------------                                          MV00  50
#                                                                       MV00  51
readwpkt:(1,lrcell:,NP,IP,0)#          Read the cell constants          MV00  52
CHROT='cell'#                          Store the cell header            MV00  53
DO I=4,6; QX(IP+I)=QX(IP+I+3)*360.#    Store angles as degrees          MV00  54
ncodefld:(QX,IP+1,CHROT,FMT1,6)#       Format the cell dimensions       MV00  55
put:(65)#                              Punch cell line                  MV00  56
CHROT=COMPID//TITLE(58^120)#           Insert identity                  MV00  57
put:(71)#                              Poutpur compid and title         MV00  58
IF(CELL==yes:)#                        Is cell output requested         MV00  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MV00  60
CHROT='localize'; put:(8)#             Output localize command          MV00  61
CHROT='showcell'; put:(8)#             Output show cell command         MV00  62
#                                                                       MV00  63
#    READ THE SYMMETRY DATA & EXPAND                                    MV00  64
#    -------------------------------                                    MV00  65
#                                                                       MV00  66
readwpkt:(1,lrsymm:,NP,IP,0)#          Read first sym packet            MV00  67
IF(IP<=0) iquit:(MV0001)#              Exit if missing                  MV00  68
LTYP=NINT(QX(IP+1))#                   Lattice flag                     MV00  69
ICNT=NINT(QX(IP+2))#                   Centre flag (c=0;nc=1)           MV00  70
NSYM=NINT(QX(IP+3))#                   Number of matrices on bdf        MV00  71
incrqx:(STOPS,MARKS+NSYM*12,MV0002)#   End of full symop table          MV00  72
FOR(J=MARKS;J>0;J=J+12)#               Loop over sym matrices           MV00  73
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MV00  74
readwpkt:(1,lrsymm:,NP,IP,0)#          Point next matrix                MV00  75
IF(IP<=0) BREAK#                       Exit when no more                MV00  76
movereal:(QX,IP+1,QX,J+1,12,1)#        Store matrix in qx array         MV00  77
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MV00  78
N=J#                                   Store limit of input matrices    MV00  79
IF(ICNT==0)#                           If centrosymmetric               MV00  80
FOR(K=MARKS;K<N;K=K+12)#               Loop over input matrices         MV00  81
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MV00  82
DO I=1,12; QX(J+I)=-QX(K+I)#           Store inverse element            MV00  83
J=J+12#                                Incr storage pointer             MV00  84
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MV00  85
IF(LTYP>7) LTYP=LTYP-7#                Remove centric part              MV00  86
N=J;  K=J#                             Store temp end marker            MV00  87
IF(LTYP>1)#                            Test if sg centered              MV00  88
FOR(J=MARKS;J<N;J=J+12)#               Loop over symm matrices          MV00  89
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MV00  90
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            MV00  91
QX(K+10)=QX(J+10)+TR11(LTYP-1)#        Transfer t1                      MV00  92
QX(K+11)=QX(J+11)+TR12(LTYP-1)#        Transfer t2                      MV00  93
QX(K+12)=QX(J+12)+TR13(LTYP-1)#        Transfer t3                      MV00  94
K=K+12#                                Incr storage pointer             MV00  95
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               MV00  96
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            MV00  97
QX(K+10)=QX(J+10)+TR21(LTYP-2)#        Transfer t1                      MV00  98
QX(K+11)=QX(J+11)+TR22(LTYP-2)#        Transfer t2                      MV00  99
QX(K+12)=QX(J+12)+TR23(LTYP-2)#        Transfer t3                      MV00 100
K=K+12#                                Incr storage pointer             MV00 101
IF(LTYP!=4) NEXT#                      Skip if not f-centre             MV00 102
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            MV00 103
QX(K+10)=QX(J+10)+0.5#                 Transfer t1                      MV00 104
QX(K+11)=QX(J+11)+0.5#                 Transfer t2                      MV00 105
QX(K+12)=QX(J+12)+0.0#                 Transfer t3                      MV00 106
K=K+12#                                Incr storage pointer             MV00 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MV00 108
FOR(J=MARKS;J<STOPS;J=J+12)#           Loop over symmetry matrices      MV00 109
DO I=10,12; QX(J+I)=MOD(5.+QX(J+I),1.)# Store translation modulo 1.     MV00 110
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MV00 111
#                                                                       MV00 112
#    OUTPUT ATOM SITE COORDS                                            MV00 113
#    -----------------------                                            MV00 114
#                                                                       MV00 115
IWNT(1)=14;  IWNT(2)=1#                Request atom label & x coord     MV00 116
KEY(1)=2; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search parameters           MV00 117
indexpkt:(1,lratom:,NP,IP,0,KEY,IWNT,IREL)# Get packet pointers         MV00 118
IF(IP<=0) iquit:(MV0004)#              Atoms data missing               MV00 119
DO I=1,100000#                         Loop over atoms list             MV00 120
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MV00 121
readwpkt:(1,lratom:,NP,IP,0)#          Read next atom packet            MV00 122
IF(IP<=0) BREAK#                       Exit when record finished        MV00 123
CHROT='atom'#                          Start atom output line           MV00 124
ncodefld:(FLOAT(I),1,CHROT,80313.,1)#  Format atom number               MV00 125
movertoc:(QX(IP+IREL(1)),1,CHROT,12,8,0)# Store atom label              MV00 126
label:(CHROT(12^13),J,K)#              Get atom label info              MV00 127
upcase:(CHROT(12^12),CHROT(12^12),1)#  Make first char upper case       MV00 128
IF(K>1) locase:(CHROT(13^),CHROT(13^),K-1)# Make 2nd char lc            MV00 129
ncodefld:(QX(IP+IREL(2)),1,CHROT,FMT2,3)# Format atom coordinates       MV00 130
put:(48)#                              Punch atom line                  MV00 131
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MV00 132
#                                                                       MV00 133
#    OUTPUT THE SYMM LINES                                              MV00 134
#    ---------------------                                              MV00 135
#                                                                       MV00 136
IF(CELL==yes:)#                        If cell data generated           MV00 137
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MV00 138
FOR(I=MARKS+12;I<STOPS;I=I+12)#        Loop over symmetry lines         MV00 139
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MV00 140
CHROT='sym'#                           Start symmetry line              MV00 141
ncodefld:(QX,I+1,CHROT,FMT3,12)#       Output symop elements            MV00 142
put:(65)#                              Punch atom line                  MV00 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MV00 144
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MV00 145
#                                                                       MV00 146
closefmt:(iofm1:)#                     Close the molview line file      MV00 147
readwpkt:(1,endrecord:,NP,IP,0)#       Close archive bdf                MV00 148
#                                                                       MV00 149
RETURN#                                                                 MV00 150
END#                                                                    MV00 151
pmacro:([no:])#                                                         MV00 152
