systemheader:(MX    )#                                                  MX     1
####################################################################### MX     2
##      Copyright (C) 2000, The Xtal System, The University of        # MX     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # MX     4
## Distributed under the GNU General Public Licence as published by   # MX     5
## the Free Software Foundation, in the hope that it will be useful   # MX     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # MX     7
## for more details.                                                  # MX     8
##                                                                    # MX     9
##                          *** MAPXCH ***                            # MX    10
##           FOURR Map Exchange with ABINIT/Wien2k                    # MX    11
##                                                                    # MX    12
##         Doug du Boulay  Nov 2001 ddb@R3401.msl.titech.ac.jp       #  MX    13
##                                                                    # MX    14
####################################################################### MX    15
##                                                                      MX    16
include:(XMACRO)#                                                       MX    17
#                                                                       MX    18
macro:(mxwdim:,incr:(arith:(decr:(mxchim:),/,mxchwd:)))#                MX    19
macro:(mw08dm:,incr:(arith:( 7,/,mxchwd:)))# No. words for  8 chars     MX    20
macro:(mw24dm:,incr:(arith:(23,/,mxchwd:)))# No. words for 23 chars     MX    21
macro:(mw40dm:,incr:(arith:(39,/,mxchwd:)))# No. words for 40 chars     MX    22
macro:(map2abi:,1)#                                                     MX    23
macro:(abi2map:,2)#                                                     MX    24
macro:(w2k2map:,3)#                                                     MX    25
macro:(map2txt:,4)#                                                     MX    26
macro:(map2ibm:,5)#                                                     MX    27
macro:(double:,DOUBLE PRECISION  )#                                     MX    28
macro:(intsz:,1)#                                                       MX    29
macro:(dpsz:,2)#                                                        MX    30
macro:(sg:, SNGL($1))#                                                  MX    31
macro:(db:, DBLE($1))#                                                  MX    32
macro:(bohr2ang:,0.5291772083)#                                         MX    33
macro:(bohr2ang3:,6.7483345942)#                                        MX    34
macro:(twopi:,6.283185308)#                                             MX    35
macro:(deg2pi:,0.017453292)#                                            MX    36
macro:(dblunpack:,CALL MX04($1,$2))#                                    MX    37
macro:(invert:,CALL MX06($1,$2))#                                       MX    38
macro:(mdotv:,[DO I=1,3#                                                MX    39
$($3(I)=0.0;DO J=1,3;$3(I)=$3(I)+$1(I,J)*$2(J)$)])#                     MX    40
##                                                                      MX    41
extrude:(MXCOMN)#                                                       MX    42
INTEGER MARKS#                                                          MX    43
INTEGER NKPT,NSPPOL,NSYM,NATOM,NTYPE,BANTOT#                            MX    44
INTEGER AUXF#                                                           MX    45
INTEGER NGFFT(3)#                                                       MX    46
INTEGER MODE#                                                           MX    47
INTEGER MTERM#                                                          MX    48
INTEGER NCHECK#                                                         MX    49
INTEGER LCF#                                                            MX    50
REAL    UOV#                                                            MX    51
REAL    SYMOP(3,4,196)#                                                 MX    52
REAL    MET(3,3)#                                                       MX    53
double: TR(3,3)#                       Transformation matrix            MX    54
double: TRI(3,3)#                      Inverse trans matrix             MX    55
double:  ACELL(3)#                                                      MX    56
string:(FILENAME,200)#                                                  MX    57
CHARACTER LATSTRC#                                                      MX    58
#                                                                       MX    59
COMMON/COMIMX/NKPT,NSPPOL,NSYM,NATOM,NTYPE,BANTOT,AUXF,NGFFT,#          MX    60
MODE,MTERM,NCHECK,LCF,MARKS#                                            MX    61
#                                                                       MX    62
COMMON/COMCMX/FILENAME,LATSTRC#                                         MX    63
#                                                                       MX    64
COMMON/COMFMX/UOV,SYMOP,MET#                                            MX    65
COMMON/COMDMX/ACELL,TR,TRI#                                             MX    66
#                                                                       MX    67
endext:#                                                                MX    68
#                                                                       MX    69
systemheader:(MX00)#                                                    MX00   1
####################################################################### MX00   2
#                                                                     # MX00   3
#                          MX00                                       # MX00   4
#                                                                     # MX00   5
####################################################################### MX00   6
SUBROUTINE MX00#                                                        MX00   7
include:(MXCOMN)#                                                       MX00   8
#                                                                       MX00   9
CALL MX10#                             Read control lines               MX00  10
IF(MODE==abi2map:)CALL MX20#           Read abinit                      MX00  11
IF(MODE==w2k2map:)CALL MX30#           Read wien2k                      MX00  12
IF(MODE==map2txt:)CALL MX40#           Write ascii text                 MX00  13
IF(MODE==map2ibm:)CALL MX50#           Write ibm data explorer          MX00  14
#                                                                       MX00  15
RETURN#                                                                 MX00  16
END#                                                                    MX00  17
#                                                                       MX00  18
systemheader:(MX05)#                   Transform symmetry element       MX05   1
#********************************************************************** MX05   2
#                                                                       MX05   3
#                                MX05                                   MX05   4
#                                                                       MX05   5
#********************************************************************** MX05   6
SUBROUTINE MX05(IPNT,DTR,DTRI)#        H.d. flack july 1991             MX05   7
#                                                                       MX05   8
include:(AACOMN)#                                                       MX05   9
include:(MXCOMN)#                                                       MX05  10
#                                                                       MX05  11
INTEGER IPNT#                          Pointer into qx of input symm    MX05  12
INTEGER I,J,K,L,IL#                                                     MX05  13
REAL    SYMOLD(12)#                    Save vector for input symm op    MX05  14
REAL    SYMNEW(12)#                    Vector for new symm op           MX05  15
REAL    TMI(9),TM(9)#                                                   MX05  16
double: DTR(3,3),DTRI(3,3)#                                             MX05  17
#                                                                       MX05  18
DO L=1,3;DO I=1,3#                                                      MX05  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MX05  20
IL=(L-1)*3+I#                                                           MX05  21
TM(IL) =sg:(DTR(I,L))#                                                  MX05  22
TMI(IL)=sg:(DTRI(I,L))#                                                 MX05  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MX05  24
movereal:(QX,IPNT,SYMOLD,1,12,0)#      Keep input symm op               MX05  25
DO I=1,3#                              Snew(tp)= t*sold(tp)*(t**-1)     MX05  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MX05  27
DO L=1,3#                                                               MX05  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MX05  29
IL=3*I+L-3;SYMNEW(IL)=0.0#             Zeroise term                     MX05  30
DO J=1,3; DO K=1,3#                    Two inner loops                  MX05  31
SYMNEW(IL)=SYMNEW(IL)+TM(3*I+J-3)*SYMOLD(3*J+K-3)*TMI(3*K+L-3)#         MX05  32
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MX05  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MX05  34
SYMNEW(10)=SYMOLD(10)*TMI(1)+SYMOLD(11)*TMI(4)+SYMOLD(12)*TMI(7)# Get   MX05  35
SYMNEW(11)=SYMOLD(10)*TMI(2)+SYMOLD(11)*TMI(5)+SYMOLD(12)*TMI(8)#       MX05  36
SYMNEW(12)=SYMOLD(10)*TMI(3)+SYMOLD(11)*TMI(6)+SYMOLD(12)*TMI(9)#       MX05  37
DO I=10,12; SYMNEW(I)=AMOD(10.0+SYMNEW(I),1.0)#                         MX05  38
movereal:(SYMNEW,1,QX,IPNT,12,0)#      Save the result                  MX05  39
#                                                                       MX05  40
RETURN#                                                                 MX05  41
END#                                                                    MX05  42
#                                                                       MX05  43
systemheader:(MX06)#                   Invert matrix                    MX06   1
####################################################################### MX06   2
#                                                                     # MX06   3
#                          MX06                                       # MX06   4
#                                                                     # MX06   5
####################################################################### MX06   6
SUBROUTINE MX06(DI,DA)#                                                 MX06   7
INTEGER I,J#                                                            MX06   8
REAL DI(3,3),DA(3,3),DD#                                                MX06   9
#                                                                       MX06  10
DA(1,1)=DI(2,2)*DI(3,3)-DI(2,3)*DI(3,2)# Calculate adjunct              MX06  11
DA(1,2)=DI(1,3)*DI(3,2)-DI(1,2)*DI(3,3)# Calculate adjunct              MX06  12
DA(1,3)=DI(1,2)*DI(2,3)-DI(1,3)*DI(2,2)# Calculate adjunct              MX06  13
DA(2,1)=DI(2,3)*DI(3,1)-DI(2,1)*DI(3,3)# Calculate adjunct              MX06  14
DA(2,2)=DI(1,1)*DI(3,3)-DI(1,3)*DI(3,1)# Calculate adjunct              MX06  15
DA(2,3)=DI(1,3)*DI(2,1)-DI(1,1)*DI(2,3)# Calculate adjunct              MX06  16
DA(3,1)=DI(2,1)*DI(3,2)-DI(3,1)*DI(2,2)# Calculate adjunct              MX06  17
DA(3,2)=DI(1,2)*DI(3,1)-DI(1,1)*DI(3,2)# Calculate adjunct              MX06  18
DA(3,3)=DI(1,1)*DI(2,2)-DI(1,2)*DI(2,1)# Calculate adjunct              MX06  19
DD=DI(1,1)*DA(1,1)+DI(2,1)*DA(1,2)+DI(3,1)*DA(1,3)# Get determinant     MX06  20
DO I=1,3; DO J=1,3; DA(I,J)=DA(I,J)/DD# Store as inverted matrix        MX06  21
RETURN#                                                                 MX06  22
END#                                                                    MX06  23
systemheader:(MX10)#                                                    MX10   1
####################################################################### MX10   2
#                                                                     # MX10   3
#                          MX10                                       # MX10   4
#                                                                     # MX10   5
####################################################################### MX10   6
SUBROUTINE MX10#                                                        MX10   7
include:(AACOMN)#                                                       MX10   8
include:(MXCOMN)#                                                       MX10   9
#                                                                       MX10  10
INTEGER I,J,K,L,NEXTF#                                                  MX10  11
chardata:(MXA," MAPXCH Control Parameters-")#                           MX10  12
chardata:(MXB,MAP2ABI ABI2MAP W2K2MAP NOTERM  NOLATCH INPFILE )#        MX10  13
chardata:(MXC,END UOV )#               Extra control lines              MX10  14
datastuff:#                                                             MX10  15
#                                                                       MX10  16
#                                                                       MX10  17
#      RERSERVE MEMORY FOR IO BUFFERS                                   MX10  18
#      ------------------------------                                   MX10  19
#                                                                       MX10  20
FILEXT(IOUNIT(3))='MAP'#                                                MX10  21
FILEXT(iofm1:)='MX0'#                  Re-entrant plotx fmt file        MX10  22
IOMARK(1)=QXSTR#                       Start of input file  buffer      MX10  23
IOMARK(3)=QXSTR#                       Start of input file  buffer      MX10  24
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of output file buffer      MX10  25
incrqx:(MARKS,QXSTR+bdfbuf:,MX0003)#   Expand buffer qx                 MX10  26
#                                                                       MX10  27
#   PROCESS MAPXCH LINE                                                 MX10  28
#   -------------------                                                 MX10  29
#                                                                       MX10  30
MTERM=1#                               Map termination 0/1              MX10  31
NEXTF=0#                                                                MX10  32
UOV=0.035#                             Standard default value           MX10  33
FOR(K=1;BUFIN(K)!=voidflg:;K=K+1)#     Loop over input fields           MX10  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MX10  35
stringlim:(K,I,J)#                     Find string limits               MX10  36
compchar:(CHRIN,I,MXB,1,7,8,NMXB,L)#   Search for match                 MX10  37
IF    (L==1) MODE=map2abi:#                                             MX10  38
ELSEIF(L==2) MODE=abi2map:#                                             MX10  39
ELSEIF(L==3) MODE=w2k2map:#                                             MX10  40
ELSEIF(L==4) MTERM=0#                  No terminal plane/line/pt        MX10  41
ELSEIF(L==5) NCHECK=1#                                                  MX10  42
ELSEIF(L==6) NEXTF=1#                                                   MX10  43
ELSEIF(L==0 &NEXTF==1) FILENAME=CHRIP(I^J)# Abinit density map file n   MX10  44
ELSE iquit:(MX0001)#                                                    MX10  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MX10  46
#                                                                       MX10  47
REPEAT#                                                                 MX10  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MX10  49
readline:(MXC,NMXC)#                   Read the next line and ignore    MX10  50
IF (LINID<=1) BREAK#                   End or not recognised            MX10  51
IF (LINID==2)#                                                          MX10  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MX10  53
ifnm:(BUFIN(1)) UOV=BUFIN(1)#                                           MX10  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MX10  55
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MX10  56
#                                                                       MX10  57
#  DUMP CONTROL PARAMS                                                  MX10  58
#  -------------------                                                  MX10  59
#                                                                       MX10  60
movechar:(MXA,24,CHROT,2,NMXA-2,1)#    Underline header                 MX10  61
writeline:(2,MXA,NMXA-1,2,3)#          Header                           MX10  62
#                                                                       MX10  63
RETURN#                                                                 MX10  64
END#                                                                    MX10  65
systemheader:(MX20)#                                                    MX20   1
####################################################################### MX20   2
#                                                                     # MX20   3
#                          MX20                                       # MX20   4
#                                                                     # MX20   5
####################################################################### MX20   6
SUBROUTINE MX20#                                                        MX20   7
include:(AACOMN)#                                                       MX20   8
include:(MXCOMN)#                                                       MX20   9
#                                                                       MX20  10
#                                                                       MX20  11
LOGICAL TEST#                                                           MX20  12
INTEGER P0,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10,P11,P12#                      MX20  13
INTEGER IP,PSIZE#                                                       MX20  14
INTEGER CSYS,NMAT,NCENT,LCODE#                                          MX20  15
INTEGER INDATM#                        Independent atoms                MX20  16
INTEGER TYP#                                                            MX20  17
INTEGER ATCNT(16)#                     Count atoms of type              MX20  18
INTEGER IZION(16)#                     Count electrons of type          MX20  19
INTEGER ORGX(3),INCX(3),NG(3),NP(3),IMAP(3),ICEL(3)#                    MX20  20
INTEGER CTYPE,PTYPE,IPROP,PASSES#                                       MX20  21
REAL    FUSE,SKAL,UPLIM,LOLIM#                                          MX20  22
REAL    X(3)#                          Atomic coords                    MX20  23
double: TM(3,3)#                       Temp                             MX20  24
double: RPRIMD(3,3)#                                                    MX20  25
#                                                                       MX20  26
CHARACTER*132  ATITLE#                                                  MX20  27
CHARACTER*6  CODVSN#                                                    MX20  28
INTEGER  HEADFORM,FFORM#                                                MX20  29
INTEGER  DATE,INTXC,IXC,NSPDEN#                                         MX20  30
INTEGER  NSPINOR,OCCOPT#                                                MX20  31
INTEGER  PSPSO,PSPDAT,PSPCOD,PSPXC,LMAX,LLOC,MMAX#                      MX20  32
double:  ECUT_EFF#                                                      MX20  33
double:  ZATOM,ZION#                                                    MX20  34
double:  RESIDM,ETOTAL,FERMIE#                                          MX20  35
# THE INPUT VARIABLE NSPDEN DESCRIBES THE NUMBER OF COMPONENTS OF THE D MX20  36
# THE FIRST COMPONENT (THE ONLY ONE PRESENT WHEN NSPDEN=1) IS ALWAYS TH MX20  37
# WHEN NSPDEN=2, THE SECOND COMPONENT IS THE DENSITY ASSOCIATED WITH SP MX20  38
# THE CASE NSPDEN=4 IS NOT YET IMPLEMENTED.                             MX20  39
# NOTE THAT THE MEANING OF THE DIFFERENT COMPONENTS OF THE DENSITY DIFF MX20  40
# FOR THE DENSITY ARRAY (RHOR) AND FOR THE DIFFERENT POTENTIAL ARRAYS ( MX20  41
# SEE SECTION  6.6 .                                                    MX20  42
#                                                                       MX20  43
string:(TYLAB,8)#                                                       MX20  44
string:(ATYLAB(16),8)#                                                  MX20  45
chardata:(MXD,H  HE LI BE B  C  N  O  F  NE NA MG AL SI P  S  CL $# S   MX20  46
AR K  CA SC TI V  CR MN FE CO NI CU ZN GA GE AS SE BR )#                MX20  47
chardata:(MXE,KR RB SR Y  ZR NB MO TC RU RH PD AG CD IN SN SB TE $# S   MX20  48
I  XE CS BA LA CE PR ND PM SM EU GD TB DY HO ER TM YB )#                MX20  49
chardata:(MXF,LU HF TA W  RE OS IR PT AU HG TL PB BI PO AT RN FR $# S   MX20  50
RA AC TH PA U  NP PU AM CM BK CF ES FM MD NO LR RF ?? )#                MX20  51
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              MX20  52
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              MX20  53
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              MX20  54
realdata:(TR21,[.3333333,.5])#                                          MX20  55
realdata:(TR22,[.6666667,0.])#                                          MX20  56
realdata:(TR23,[.6666667,.5])#                                          MX20  57
datastuff:#                                                             MX20  58
#                                                                       MX20  59
#  GET AN INPUT FILE                                                    MX20  60
#  -----------------                                                    MX20  61
#                                                                       MX20  62
INQUIRE(FILE=FILENAME,EXIST=TEST)#                                      MX20  63
IF(! TEST) iquit:(MX0002)#                                              MX20  64
AUXF=99#                                                                MX20  65
WRITE(6,*) "opening filename",FILENAME#                                 MX20  66
OPEN(UNIT=AUXF,FILE=FILENAME,ACCESS='SEQUENTIAL',$#                     MX20  67
STATUS='UNKNOWN',FORM='UNFORMATTED')#                                   MX20  68
#                                                                       MX20  69
# READ ABINI _DEN  FILE HEADER                                          MX20  70
# ----------------------------                                          MX20  71
#                                                                       MX20  72
READ(UNIT=AUXF) CODVSN,HEADFORM,FFORM#                                  MX20  73
READ(UNIT=AUXF) BANTOT,DATE,INTXC,IXC,NATOM,(NGFFT(H),H=1,3),$#         MX20  74
NKPT,NSPDEN,NSPINOR,NSPPOL,NSYM,NTYPE,OCCOPT,$#                         MX20  75
(ACELL(I),I=1,3),ECUT_EFF,((RPRIMD(J,K),J=1,3),K=1,3)#                  MX20  76
IF(NTYPE>16)iquit:(MX0007)#            Can't handle in xtal             MX20  77
P1=MARKS+1#                                                             MX20  78
P2=P1+NKPT*NSPPOL*intsz:#              Nband                            MX20  79
P3=P2+NKPT    *intsz:#                 Npwarr                           MX20  80
P4=P3+9*NSYM  *intsz:#                 Symrel                           MX20  81
P5=P4+1*NATOM *intsz:#                 Type                             MX20  82
P6=P5+1*NKPT  *intsz:#                 Istwfk                           MX20  83
P7=P6+3*NKPT  * dpsz:#                 Kpt                              MX20  84
P8=P7+1*BANTOT* dpsz:#                 Occ                              MX20  85
P9=P8+3*NSYM  * dpsz:#                 Tnons                            MX20  86
P10=P9+1*NTYPE * dpsz:#                Zatnum                           MX20  87
P11=P10+3*NATOM*dpsz:#                                                  MX20  88
incrqx:(STOPS,P11,MX0003)#             Expand buffer qx                 MX20  89
CALL MX21(QX(P1),QX(P2),QX(P3),QX(P4),QX(P5),QX(P6),$#                  MX20  90
QX(P7),QX(P8),QX(P9))#                                                  MX20  91
#                                                                       MX20  92
#  READ ATOM TYPE POTENTIAL INFORMATION                                 MX20  93
#                                                                       MX20  94
#                                                                       MX20  95
DO ITYPE=1,NTYPE#                      (ntype lines, 1 for each psp..   MX20  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MX20  97
READ(UNIT=AUXF) ATITLE,ZATOM,ZION,PSPSO,PSPDAT,PSPCOD,PSPXC,LMAX,$#     MX20  98
LLOC,MMAX#                                                              MX20  99
IZION(ITYPE)=NINT(sg:(ZION))#          Scat factor type                 MX20 100
WRITE(6,*) ATITLE#                                                      MX20 101
WRITE(6,*) "Atomic number ",ZATOM,ZION,LMAX,LLOC,MMAX#                  MX20 102
WRITE(6,*) "Potential info ",PSPO,PSPDAT,PSPCOD,PSPXC#                  MX20 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MX20 104
CALL MX22(RESIDM,QX(P10),ETOTAL,FERMIE)#                                MX20 105
#(FINAL RECORD: RESIDM, COORDINATES, TOTAL ENERGY, FERMI ENERGY)        MX20 106
#                                                                       MX20 107
# DUMP ABI DEN FILE DETAILS                                             MX20 108
# -------------------------                                             MX20 109
#                                                                       MX20 110
WRITE(6,*) "version", CODVSN#                                           MX20 111
WRITE(6,*) "headform", HEADFORM#                                        MX20 112
WRITE(6,*) "fform", FFORM#                                              MX20 113
WRITE(6,*) "bantot", BANTOT#                                            MX20 114
WRITE(6,*) "date", DATE#                                                MX20 115
WRITE(6,*) "intxc", INTXC#                                              MX20 116
WRITE(6,*) "ixc", IXC#                                                  MX20 117
WRITE(6,*) "natom", NATOM#                                              MX20 118
WRITE(6,*) "ngfft", NGFFT(1),NGFFT(2),NGFFT(3)#                         MX20 119
WRITE(6,*) "nkpt", NKPT#                                                MX20 120
WRITE(6,*) "nspden", NSPDEN#                                            MX20 121
WRITE(6,*) "nspinor", NSPINOR#                                          MX20 122
WRITE(6,*) "nsppol", NSPPOL#                                            MX20 123
WRITE(6,*) "nsym", NSYM#                                                MX20 124
WRITE(6,*) "ntype", NTYPE#                                              MX20 125
WRITE(6,*) "occopt", OCCOPT#                                            MX20 126
#                                                                       MX20 127
WRITE(6,*) "ecut_eff", OCCOPT#                                          MX20 128
WRITE(6,*) "cell",ACELL(1),ACELL(2),ACELL(3)#                           MX20 129
WRITE(6,*) "orthog",RPRIMD(1,1),RPRIMD(1,2),RPRIMD(1,3)#                MX20 130
WRITE(6,*) "orthog",RPRIMD(2,1),RPRIMD(2,2),RPRIMD(2,3)#                MX20 131
WRITE(6,*) "orthog",RPRIMD(3,1),RPRIMD(3,2),RPRIMD(3,3)#                MX20 132
#                                                                       MX20 133
#  UNPACK THE SYMOPS                                                    MX20 134
#  -----------------                                                    MX20 135
#                                                                       MX20 136
DO IS=1,NSYM#                                                           MX20 137
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MX20 138
DO J=1,3#                                                               MX20 139
DO I=1,3#                                                               MX20 140
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MX20 141
IJ=P3+(9*(IS-1)+3*(J-1)+I-1)*intsz:#   Pointer to component             MX20 142
intunpak:(QX(IJ),K,0,mxbtwd:)#                                          MX20 143
SYMOP(I,J,IS)=FLOAT(K)#                                                 MX20 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MX20 145
DO I=1,3#                                                               MX20 146
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MX20 147
IJ=P8+(3*(IS-1)+I-1)*dpsz:#            Pointer to component             MX20 148
dblunpack:(QX(IJ),SYMOP(I,4,IS))#                                       MX20 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MX20 150
#WRITE(6,*)'SYMOP',IS                                                   MX20 151
#DO I=1,3                                                               MX20 152
#WRITE(6,'(10X,4F6.3)')(SYMOP(I,J,IS),J=1,4)                            MX20 153
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MX20 154
#                                                                       MX20 155
#  GET METRIC TENSOR                                                    MX20 156
#  -----------------                                                    MX20 157
#                                                                       MX20 158
DO I=1,3 ; DO J=1,3;TR(I,J)=RPRIMD(I,J)# Basis vectors                  MX20 159
DO I=1,3 ; DO J=1,3;TRI(I,J)=0.0D0#    Initialize                       MX20 160
DO I=1,3;TRI(I,I)=1.0D0#               To identity                      MX20 161
DET=TR(1,1)*(TR(2,2)*TR(3,3)-TR(3,2)*TR(2,3)) -$#                       MX20 162
    TR(1,2)*(TR(1,2)*TR(3,3)-TR(3,1)*TR(2,3)) +$#                       MX20 163
    TR(1,3)*(TR(1,2)*TR(3,2)-TR(3,1)*TR(2,2))#                          MX20 164
DET=DET/(ACELL(1)*ACELL(2)*ACELL(3))#                                   MX20 165
WRITE(6,*) "DET RPRIM ",DET#                                            MX20 166
LCF=0#                                 Latice centering flag            MX20 167
ifeq:(1./DET,4.0)LCF=4#                Face centred 1/4 vol             MX20 168
ifeq:(1./DET,3.0)LCF=3#                Hexagonal 1/3 vol                MX20 169
ifeq:(1./DET,2.0)LCF=2#                A,b,c or i 1/2 vol               MX20 170
IF(LCF!=0)#                                                             MX20 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MX20 172
WRITE(6,*)"LCF = ",LCF#                                                 MX20 173
# IN THIS INSTANCE RPRIMD=ACELL*SUBCELL*BASIS0= *SUBCELL*ACELL*BASIS0   MX20 174
# BECAUSE ACELL IS DIAGONAL                                             MX20 175
# WHAT WE WANT IS ACELL*BASIS0 TO CONSTRUCT THE METRIC TENSOR           MX20 176
# SO WE NEED SUBCELL^-1 * RPRIMD TO RECOVER ORIGINAL BASIS              MX20 177
DO I=1,3;DO J=1,3;TR(I,J)=TR(I,J)/ACELL(I)#                             MX20 178
TRI(1,1)=TR(2,2)*TR(3,3)-TR(2,3)*TR(3,2)# Calculate adjunct             MX20 179
TRI(1,2)=TR(1,3)*TR(3,2)-TR(1,2)*TR(3,3)# Calculate adjunct             MX20 180
TRI(1,3)=TR(1,2)*TR(2,3)-TR(1,3)*TR(2,2)# Calculate adjunct             MX20 181
TRI(2,1)=TR(2,3)*TR(3,1)-TR(2,1)*TR(3,3)# Calculate adjunct             MX20 182
TRI(2,2)=TR(1,1)*TR(3,3)-TR(1,3)*TR(3,1)# Calculate adjunct             MX20 183
TRI(2,3)=TR(1,3)*TR(2,1)-TR(1,1)*TR(2,3)# Calculate adjunct             MX20 184
TRI(3,1)=TR(2,1)*TR(3,2)-TR(3,1)*TR(2,2)# Calculate adjunct             MX20 185
TRI(3,2)=TR(1,2)*TR(3,1)-TR(1,1)*TR(3,2)# Calculate adjunct             MX20 186
TRI(3,3)=TR(1,1)*TR(2,2)-TR(1,2)*TR(2,1)# Calculate adjunct             MX20 187
#DET=DET*(ACELL(1)*ACELL(2)*ACELL(3))#                                  MX20 188
DO I=1,3; DO J=1,3; TRI(I,J)=TRI(I,J)/DET#                              MX20 189
DO I=1,3 ; WRITE(6,*)"TR ",(TR(I,J),J=1,3)#                             MX20 190
DO I=1,3 ; WRITE(6,*)"TRI",(TRI(I,J),J=1,3)#                            MX20 191
#                                                                       MX20 192
DO I=1,3 ; DO J=1,3#                   Convert rprim to centred cell    MX20 193
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MX20 194
TM(I,J)=0.0#                                                            MX20 195
DO K=1,3; TM(I,J)=TM(I,J)+TRI(I,K)*RPRIMD(K,J)# Metric                  MX20 196
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MX20 197
DO I=1,3 ; DO J=1,3;RPRIMD(I,J)=TM(I,J)# Copy temp                      MX20 198
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MX20 199
#                                                                       MX20 200
DO I=1,3 ; DO J=1,3#                   Determine metric tensor          MX20 201
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MX20 202
MET(I,J)=0.0#                                                           MX20 203
DO K=1,3; MET(I,J)=MET(I,J)+sg:(RPRIMD(K,I)*RPRIMD(K,J))# Metric        MX20 204
MET(I,J)=MET(I,J)*bohr2ang:**2#        Angstroms                        MX20 205
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MX20 206
DO I=1,3; ACELL(I)=ACELL(I)*bohr2ang:# Get a,b,c in angstroms           MX20 207
#                                                                       MX20 208
#                                                                       MX20 209
#                                                                       MX20 210
#                                                                       MX20 211
CALL MX90#                             Dump lrhist to lrsymm: ...       MX20 212
#                                                                       MX20 213
#                                                                       MX20 214
#                                                                       MX20 215
# WRITE N PACKETS OF LOGICAL RECORD LRSCAT:                             MX20 216
# -----------------------------------------                             MX20 217
#                                                                       MX20 218
DO I=1,16;ATYLAB(I)=' '#                                                MX20 219
PSIZE= 4+mw08dm:#                                                       MX20 220
writepkt:(3,lrscat:,PSIZE,IP)#         Initialize a lrscat directory    MX20 221
QX(IP+1)=1.#                           Fudge number of atoms            MX20 222
QX(IP+2)=3.#                           Known z value                    MX20 223
QX(IP+3)=4.#                           Known z value                    MX20 224
QX(IP+4)=8.#                           Abinit valence band electrons    MX20 225
DO I=1,mw08dm:;QX(IP+4+I)=11.#         Scattering factor name (8 char   MX20 226
FOR(ISC=1;ISC<=2*NTYPE;ISC=ISC+1)#                                      MX20 227
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MX20 228
TN=0.0#                                Total num of atoms               MX20 229
IF(ISC<=NTYPE) IT=ISC#                 Pointer to scat factor           MX20 230
ELSE           IT=ISC-NTYPE#           Pointer to base scat factor      MX20 231
dblunpack:(QX(P9+(IT-1)*dpsz:),A)#     Get double precision z value     MX20 232
J=NINT(A)#                                                              MX20 233
IF(ISC>NTYPE)#                         Load scat factor for neutral c   MX20 234
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MX20 235
J=J-IZION(IT)#                         Pointer to core z                MX20 236
A=A-FLOAT(IZION(IT))#                                                   MX20 237
IF(J<=0) NEXT#                         Core has zero electrons; ignor   MX20 238
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MX20 239
ELSE#                                  Count atoms of type              MX20 240
DO I=1,NATOM#                          Loop for atom types              MX20 241
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MX20 242
intunpak:(QX(P4+(ISC-1)*intsz:),TYP,0,mxbtwd:)# Get integer z value     MX20 243
IF(TYP==ISC)TN=TN+1.#                                                   MX20 244
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MX20 245
B=A#                                                                    MX20 246
#                                                                       MX20 247
IF    (J<=0)  J=105#                                                    MX20 248
IF    (J<=35) K=1+(J-1)*3#                                              MX20 249
ELSEIF(J<=70) K=1+(J-36)*3#                                             MX20 250
ELSEIF(J<=104)K=1+(J-71)*3#                                             MX20 251
ELSE          K=34*3#                                                   MX20 252
TYLAB=' '#                                                              MX20 253
IF    (J<=35) TYLAB(1^2)=MXD(K^K+2)#                                    MX20 254
ELSEIF(J<=70) TYLAB(1^2)=MXE(K^K+2)#                                    MX20 255
ELSEIF(J<=105)TYLAB(1^2)=MXF(K^K+2)#                                    MX20 256
ELSE          TYLAB(1^2)='??'#                                          MX20 257
writepkt:(3,lrscat:,PSIZE,IP)#         Initialize a lrscat record       MX20 258
QX(IP+1)=TN#                           *nsym#                    its    MX20 259
QX(IP+2)=A#                            Atomic number                    MX20 260
QX(IP+3)=B#                            Num of electrons                 MX20 261
QX(IP+4)=IZION(IT)#                    Valence electrons                MX20 262
movector:(TYLAB,1,QX(IP+5),1,8,0)#                                      MX20 263
WRITE(6,*)"ATYPE ",ISC,TYP, TYLAB,QX(IP+1),QX(IP+2)#                    MX20 264
IF(ISC<=16) ATYLAB(ISC)=TYLAB#         Sixteen atom types max.          MX20 265
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MX20 266
#                                                                       MX20 267
# WRITE 1 PACKET OF LOGICAL RECORD LREXPL:                              MX20 268
#                                                                       MX20 269
PSIZE=2#                                                                MX20 270
writepkt:(3,lrexpl:,PSIZE,IP)#         Initialize a lrscat directory    MX20 271
QX(IP+1)=1.#                           Data set                         MX20 272
QX(IP+2)=2.#                           Mean wavelength                  MX20 273
writepkt:(3,lrexpl:,PSIZE,IP)#         Write one packet                 MX20 274
QX(IP+1)=1.#                           Data set 1                       MX20 275
QX(IP+2)=0.5#                          Wavelength in angstroms          MX20 276
#                                                                       MX20 277
# WRITE N PACKETS OF LOGICAL RECORD LRATOM:                             MX20 278
#                                                                       MX20 279
PSIZE= 6+mw24dm:#                                                       MX20 280
writepkt:(3,lratom:,PSIZE,IP)#         Initialize a lrscat directory    MX20 281
DO I=1,3; QX(IP+I)=FLOAT(I)#           X,y,z fract coords               MX20 282
QX(IP+4)=22.#                          Scat factor type (sequence)      MX20 283
QX(IP+5)=26.#                          Valence electrons of atom type   MX20 284
QX(IP+6)=4.#                           Valence electrons of atom type   MX20 285
DO I=1,mw24dm:;QX(IP+6+I)=14.#         Scattering factor name (8 char   MX20 286
DO I=1,16;ATCNT(I)=0#                  Init to zero                     MX20 287
DO IA=1,NATOM#                                                          MX20 288
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MX20 289
writepkt:(3,lratom:,PSIZE,IP)#         Initialize a lrscat directory    MX20 290
dblunpack:(QX(P10+(3*(IA-1)  )*dpsz:),X(1))# Get double precision z v   MX20 291
dblunpack:(QX(P10+(3*(IA-1)+1)*dpsz:),X(2))# Get double precision z v   MX20 292
dblunpack:(QX(P10+(3*(IA-1)+2)*dpsz:),X(3))# Get double precision z v   MX20 293
DO I=1,3#                              Transform coords                 MX20 294
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MX20 295
QX(IP+I)=0.0#                                                           MX20 296
DO J=1,3; QX(IP+I)=QX(IP+I)+sg:(TRI(I,J)*db:(X(J)))#                    MX20 297
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MX20 298
movector:(BLANK,1,QX(IP+7),1,24,1)#    Blank out packet                 MX20 299
intunpak:( QX(P4+(IA-1)*intsz:),TYP,0,mxbtwd:)# Get atom type int id    MX20 300
QX(IP+4)=FLOAT(TYP)#                   Save the scat factor sequ numb   MX20 301
QX(IP+5)=FLOAT(IZION(TYP))#            Save the scat factor sequ numb   MX20 302
QX(IP+6)=UOV#                          Store default uiso               MX20 303
IF(TYP>16) iquit:(MX0005)#             Too many atom types              MX20 304
ATCNT(TYP)=ATCNT(TYP)+1#               Increment                        MX20 305
TYLAB=ATYLAB(TYP)#                     Sixteen atom types max.          MX20 306
IF(TYLAB(2^2)==' ') A=1.#                                               MX20 307
ELSE                A=2.#                                               MX20 308
N=ATCNT(TYP)#                          Number                           MX20 309
B=1.+INT(ALOG10(FLOAT(N)))#            Number of digits                 MX20 310
FMT= 3.+(B*110.) + (A+B)*10000.#       Format for number                MX20 311
ncodefld:(FLOAT(N),1,TYLAB,FMT,1 )#    Encode it                        MX20 312
movector:(TYLAB,1,QX(IP+7),1,8,0)#     Add to atom list                 MX20 313
WRITE(6,*) "Atom label ",TYLAB, "   ",TYP,FMT,A,B#                      MX20 314
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MX20 315
#                                                                       MX20 316
#  PRECHECK FOR NON PRIMITVE LATTICE                                    MX20 317
#  ---------------------------------                                    MX20 318
#                                                                       MX20 319
ICEL(1)=3;ICEL(2)=2;ICEL(3)=1;#        Layer, down, across=z,y,x        MX20 320
IF(LCF!=0)#                                                             MX20 321
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MX20 322
DO I=1,3;NG(I)=NGFFT(ICEL(I))#         Interpolated grid                MX20 323
#  MAY BE NEEDED???                                                     MX20 324
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MX20 325
ELSE DO I=1,3;NG(I)=NGFFT(ICEL(I))#    Use input grid                   MX20 326
#                                                                       MX20 327
#  INITIALIZE THE MAP HEADER PARAMETERS                                 MX20 328
#  ------------------------------------                                 MX20 329
#                                                                       MX20 330
DO I=1,3#                                                               MX20 331
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MX20 332
ORGX(I)=0#                             Starts at origin                 MX20 333
INCX(I)=1#                             Only thing acceptible            MX20 334
# BASICALLY THESE NEXT THREE PARAMS  IMPLY THAT THE FFT MAP             MX20 335
# WAS CREATED IN THE Z,Y,X ORDER AND WILL BE WRITTEN OUT WITH           MX20 336
# X FASTEST, FOLLOWED BY Y ROWS FOR EACH Z PLANE.                       MX20 337
NP(I)  =NG(I)+MTERM#                   Number of points in actual map   MX20 338
IMAP(I)=4-I#                           Z, y, x                          MX20 339
#IMAP(I)=I #                          Z, Y, X                           MX20 340
#ICEL(I)=I#                             LAYER DOWN ACROSS ?             MX20 341
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MX20 342
#FUSE=F000 # FOR FMAP                                                   MX20 343
FUSE=0.0#                              For diff map                     MX20 344
SKAL=1.0#                                                               MX20 345
CTYPE=6#                                                                MX20 346
PTYPE=0#                                                                MX20 347
IPROP=1#                                                                MX20 348
UPLIM=-1.#                                                              MX20 349
LOLIM= 1.#                                                              MX20 350
PASSES=1#                                                               MX20 351
#                                                                       MX20 352
# WRITE 1 PACKET  OF MAP HEADER RECORD                                  MX20 353
#                                                                       MX20 354
PSIZE=41#                              Setup packet for misc data       MX20 355
writepkt:(3,21,PSIZE,IP)#              Point to op packet               MX20 356
DO J=1,3#                              Loop cell axes (1=x;2=y;3=z)     MX20 357
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MX20 358
JJ=IP+J#                               Point to op buffer               MX20 359
QX(JJ  )=FLOAT(ORGX(J))#               Start layer down across (zyx)    MX20 360
QX(JJ+3)=FLOAT(INCX(J))#               Incr layer y x                   MX20 361
QX(JJ+6)=FLOAT(NG  (J))#               Grid layer y x                   MX20 362
QX(JJ+9)=FLOAT(NP  (J))#               Points layer y x                 MX20 363
QX(JJ+12)=FLOAT(IMAP(J))#              Store map codes for x,y,z        MX20 364
QX(JJ+15)=FLOAT(ICEL(J))#              Store cell codes for l,d,a       MX20 365
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MX20 366
QX(IP+19)=UPLIM#                       Store upper print limit          MX20 367
QX(IP+20)=LOLIM#                       Store lower print limit          MX20 368
IF(CTYPE>7) QX(IP+21)=FLOAT(CTYPE-3)#  Store calc type for pekpik       MX20 369
ELSE        QX(IP+21)=FLOAT(CTYPE)#    Store calc type for pekpik       MX20 370
QX(IP+22)=FUSE#                        Store f000 term added            MX20 371
QX(IP+23)=FLOAT(IABS(PASSES))#         Store total passes               MX20 372
QX(IP+24)=SKAL#                        Store print scale                MX20 373
QX(IP+40)=FLOAT(PTYPE)#                Property 0=ed 1=ep 2=ef 3=eg     MX20 374
QX(IP+41)=FLOAT(IPROP)#                Number of components             MX20 375
#                                                                       MX20 376
# READ MAP DATA                                                         MX20 377
# -------------                                                         MX20 378
#                                                                       MX20 379
P12=P1+NGFFT(1)*NGFFT(2)*NGFFT(3)*dpsz:# Reuse previous space.          MX20 380
QXCUR=P1#                              Reset current pointer            MX20 381
incrqx:(STOPS,P12,MX0003)#             Expand buffer qx                 MX20 382
CALL MX23(QX(P1),NGFFT(1),NGFFT(2),NGFFT(3))# Read map into qx(p1+.)    MX20 383
#                                                                       MX20 384
#  CLOSE DOWN THE ABINI _DEN FILE                                       MX20 385
#  ------------------------------                                       MX20 386
#                                                                       MX20 387
CLOSE(UNIT=AUXF)#                                                       MX20 388
#                                                                       MX20 389
# WRITE Y*Z ROWS OF MAP TO RECORD 22                                    MX20 390
# ----------------------------------                                    MX20 391
#                                                                       MX20 392
PSIZE=NP(3)*IPROP#                     Size of output row               MX20 393
NROW= NGFFT(1)*NGFFT(2)#               Size of input grid               MX20 394
NNG1=10*NGFFT(1)#                      Shift to positive x primitive    MX20 395
NNG2=10*NGFFT(2)#                      Shift to positive y primitive    MX20 396
NNG3=10*NGFFT(3)#                      Shift to positive z primitive    MX20 397
FOR(IC=0;IC<NP(1);IC=IC+1)#            Loop for z layers                MX20 398
FOR(IB=0;IB<NP(2);IB=IB+1)#            Loop for y rows                  MX20 399
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MX20 400
writepkt:(3,22,PSIZE,IP )#             For later use by pekpik or e     MX20 401
FOR(IA=0;IA<NP(3);IA=IA+1)#            Loop for all x points in row     MX20 402
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MX20 403
IPA=MOD(NINT(TRI(1,1)*IA+TRI(1,2)*IB+TRI(1,3)*IC)+NNG1,NGFFT(1))#       MX20 404
IPB=MOD(NINT(TRI(2,1)*IA+TRI(2,2)*IB+TRI(2,3)*IC)+NNG2,NGFFT(2))#       MX20 405
IPC=MOD(NINT(TRI(3,1)*IA+TRI(3,2)*IB+TRI(3,3)*IC)+NNG3,NGFFT(3))#       MX20 406
IPT=(IPC*NROW +IPB*NGFFT(1)+IPA)*dpsz:# Serialized storage location     MX20 407
dblunpack:(QX(P1+IPT),A)#              Get real from double density     MX20 408
#WRITE(6,*) IA,IB,IC, IPA,IPB,IPC, IPT, A                               MX20 409
QX(IP+1+IA)=A*bohr2ang3:#              Convert bhor to angstrom cubed   MX20 410
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MX20 411
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MX20 412
#                                                                       MX20 413
#                                                                       MX20 414
CALL MX91#                                                              MX20 415
#                                                                       MX20 416
#                                                                       MX20 417
RETURN#                                                                 MX20 418
END#                                                                    MX20 419
systemheader:(MX21)#                                                    MX21   1
####################################################################    MX21   2
#                                                                  #    MX21   3
#                             MX21                                 #    MX21   4
#                                                                  #    MX21   5
####################################################################    MX21   6
# JUST A HACK TO READ A UNFORMATTED SEQUENTIAL F77 FILE RECORD          MX21   7
SUBROUTINE MX21(NBAND,NPWARR,SYMREL,TYPE,ISFK,KPT,OCC,TNONS,ZATNUM)#    MX21   8
include:(AACOMN)#                                                       MX21   9
include:(MXCOMN)#                                                       MX21  10
INTEGER NBAND(*),NPWARR(*),SYMREL(3,3,*),TYPE(*),ISFK(*)# Istwfk        MX21  11
double:  KPT(3,*),OCC(*),TNONS(3,*),ZATNUM(*)#                          MX21  12
#                                                                       MX21  13
READ(UNIT=AUXF) (NBAND(H),H=1,NKPT*NSPPOL), (NPWARR(H),H=1,NKPT),$#     MX21  14
(((SYMREL(H,I,J),H=1,3),I=1,3),J=1,NSYM),(TYPE(H),H=1,NATOM),$#         MX21  15
(ISFK(H),H=1,NKPT),$#                                                   MX21  16
((KPT(H,I),H=1,3),I=1,NKPT),(OCC(H),H=1,BANTOT),$#                      MX21  17
((TNONS(H,I),H=1,3),I=1,NSYM),(ZATNUM(H),H=1,NTYPE)#                    MX21  18
#                                                                       MX21  19
RETURN#                                                                 MX21  20
END#                                                                    MX21  21
systemheader:(MX22)#                                                    MX22   1
####################################################################    MX22   2
#                                                                  #    MX22   3
#                             MX22                                 #    MX22   4
#                                                                  #    MX22   5
####################################################################    MX22   6
# JUST A HACK TO READ A UNFORMATTED SEQUENTIAL F77 FILE RECORD          MX22   7
SUBROUTINE MX22(RESIDM,XRED,ETOTAL,FERMIE)#                             MX22   8
include:(AACOMN)#                                                       MX22   9
include:(MXCOMN)#                                                       MX22  10
double: RESIDM,ETOTAL,FERMIE#                                           MX22  11
double: XRED(3,*)#                                                      MX22  12
#                                                                       MX22  13
READ(UNIT=AUXF)RESIDM,((XRED(H,I),H=1,3),I=1,NATOM),ETOTAL,FERMIE#      MX22  14
#                                                                       MX22  15
RETURN#                                                                 MX22  16
END#                                                                    MX22  17
systemheader:(MX23)#                                                    MX23   1
####################################################################    MX23   2
#                                                                  #    MX23   3
#                             MX23                                 #    MX23   4
#                                                                  #    MX23   5
####################################################################    MX23   6
# JUST A HACK TO READ A UNFORMATTED SEQUENTIAL 3D GRID                  MX23   7
SUBROUTINE MX23(RHOR,IX,IY,IZ)#                                         MX23   8
include:(AACOMN)#                                                       MX23   9
include:(MXCOMN)#                                                       MX23  10
INTEGER IX,IY,IZ#                                                       MX23  11
double: RHOR(IX,IY,IZ)#                                                 MX23  12
#                                                                       MX23  13
# READ THE ABINI FFT DENSITY ON A GRID REFERRED TO THE PRIMITIVE        MX23  14
# CELL COORDINATES AND NOT THE ACTUAL UNIT CELL COORDINATES!            MX23  15
#                                                                       MX23  16
# WHERE RHOR IS THE ELECTRON DENSITY IN ELECTRONS/BOHR^3                MX23  17
# CPLEX IS THE NUMBER OF COMPLEX COMPONENTS OF THE DENSITY              MX23  18
# (CPLEX=1 FOR GS CALCULATIONS -THE DENSITY IS REAL-,                   MX23  19
#  AND CPLEX=1 OR 2 FOR RF).                                            MX23  20
# BUT FROM THE CUT3D PROTOTYPE - THERE IS NOT CPLEX!                    MX23  21
# GO FIGURE!                                                            MX23  22
#                                                                       MX23  23
READ(UNIT=AUXF)(((RHOR(H,I,J),H=1,IX),I=1,IY),J=1,IZ)#                  MX23  24
#                                                                       MX23  25
# THE FIRST ARRAY VALUE (IR=1) CORRESPONDS WITH THE FIRST GRID POINT    MX23  26
# WHICH IS AT THE ORIGIN OF THE UNIT CELL, (X=0, Y=0, Z=0).             MX23  27
# THE NEXT GRID POINT (IR=2) LIES ALONG THE FIRST PRIMITIVE TRANSLATION MX23  28
# AT THE NEXT FFT GRID POINT, WHICH IS (1/NGFFT(1))*ACELL(1)*RPRIM(MU,1 MX23  29
#  THIS IS 1/NGFFT(1) OF THE WAY ALONG THE FIRST PRIMITIVE TRANSLATION. MX23  30
# THE REST OF THE VALUES UP TO IR=NGFFT(1) LIE ALONG THIS VECTOR, AT    MX23  31
# (IR-1)/NGFFT(1) OF THE WAY ALONG THE FIRST PRIMITIVE TRANSLATION. THE MX23  32
# POINT AT IR=NGFFT(1)+1 LIES AT 1/NGFFT(2) ALONG THE SECOND PRIMITIVE  MX23  33
# THE NEXT POINTS UP TO IR=NGFFT(1)+NGFFT(1) ARE DISPLACED IN THE DIREC MX23  34
# OF THE SECOND PRIMITIVE TRANSLATION BY 1/NGFFT(2) AND IN THE FIRST    MX23  35
# TRANSLATION BY (IR-NGFFT(1)-1)/NGFFT(1).                              MX23  36
# THIS PATTERN CONTINUES UNTIL IR=NGFFT(1)*NGFFT(2).                    MX23  37
# THE NEXT POINT AFTER THAT IS DISPLACED ALONG THE THIRD PRIMITIVE      MX23  38
# TRANSLATION BY 1/NGFFT(3), AND SO                                     MX23  39
# FORTH UNTIL IR VARIES ALL THE WAY FROM 1 TO NGFFT(1)*NGFFT(2)*NGFFT(3 MX23  40
# THIS LAST POINT IS IN THE CORNER DIAGONALLY OPPOSITE FROM THE ORIGIN, MX23  41
# RIGHT ALONGSIDE THE ORIGIN IF THE WHOLE GRID IS VIEWED AS BEING PERIO MX23  42
#                                                                       MX23  43
RETURN#                                                                 MX23  44
END#                                                                    MX23  45
#                                                                       MX23  46
#                                                                       MX23  47
ifsel:(UNXDEC)#                                                         MX23  48
extrude:('mx30.r')#                    Unusual compile options!         MX23  49
include:(XMACRO)#                                                       MX23  50
macro:(mxwdim:,incr:(arith:(decr:(mxchim:),/,mxchwd:)))#                MX23  51
macro:(mw08dm:,incr:(arith:( 7,/,mxchwd:)))# No. words for  8 chars     MX23  52
macro:(mw24dm:,incr:(arith:(23,/,mxchwd:)))# No. words for 23 chars     MX23  53
macro:(mw40dm:,incr:(arith:(39,/,mxchwd:)))# No. words for 40 chars     MX23  54
macro:(map2abi:,1)#                                                     MX23  55
macro:(abi2map:,2)#                                                     MX23  56
macro:(w2k2map:,3)#                                                     MX23  57
macro:(map2txt:,4)#                                                     MX23  58
macro:(map2ibm:,5)#                                                     MX23  59
macro:(double:,DOUBLE PRECISION  )#                                     MX23  60
macro:(intsz:,1)#                                                       MX23  61
macro:(dpsz:,2)#                                                        MX23  62
macro:(sg:, SNGL($1))#                                                  MX23  63
macro:(db:, DBLE($1))#                                                  MX23  64
macro:(bohr2ang:,0.5291772083)#                                         MX23  65
macro:(bohr2ang3:,6.7483345942)#                                        MX23  66
macro:(twopi:,6.283185308)#                                             MX23  67
macro:(deg2pi:,0.017453292)#                                            MX23  68
macro:(dblunpack:,CALL MX04($1,$2))#                                    MX23  69
macro:(invert:,CALL MX06($1,$2))#                                       MX23  70
macro:(mdotv:,[DO I=1,3#                                                MX23  71
$($3(I)=0.0;DO J=1,3;$3(I)=$3(I)+$1(I,J)*$2(J)$)])#                     MX23  72
endsel:#                                                                MX23  73
#                                                                       MX23  74
systemheader:(MX30)#                   Read wien2k lapw5_3d case.tmp    MX30   1
####################################################################    MX30   2
#                                                                  #    MX30   3
#                             MX30   W2K2MAP:                      #    MX30   4
#                                                                  #    MX30   5
####################################################################    MX30   6
SUBROUTINE MX30#                                                        MX30   7
include:(AACOMN)#                                                       MX30   8
include:(MXCOMN)#                                                       MX30   9
#                                                                       MX30  10
LOGICAL TEST#                                                           MX30  11
INTEGER LNBLNK#                                                         MX30  12
INTEGER H(3,3)#                                                         MX30  13
INTEGER P0,P1,P2,P12#                                                   MX30  14
INTEGER NPX,NPY,NPZ#                                                    MX30  15
INTEGER IX,IY,IZ,JPNT,IPNT#                                             MX30  16
INTEGER CTYPE,PTYPE,IPROP,PASSES,ORGX(3)#                               MX30  17
INTEGER ICEL(3),INCX(3),NG(3),NP(3),IMAP(3)#                            MX30  18
INTEGER PSIZ,PSIZE,IP,IA#                                               MX30  19
REAL    VEC(3),FVEC(3)#                                                 MX30  20
REAL    A,B,C,ALF,BET,GAM,ALF1,BET1,GAM1#                               MX30  21
REAL    SHIFT(3)#                                                       MX30  22
REAL    ROTLOC(3,3)#                                                    MX30  23
REAL    BR(3,3),BRI(3,3)#                                               MX30  24
REAL    UPLIM,LOLIM,SKAL,FUSE#                                          MX30  25
double: RELX,RELY,RELZ#                                                 MX30  26
double: POS(3),CHGE#                                                    MX30  27
double: ACELL1(3)#                                                      MX30  28
string:(CLTYPE,4)#                                                      MX30  29
string:(SFTYPE,128)#                                                    MX30  30
string:(ATITLE,80)#                                                     MX30  31
string:(LABEL,24)#                                                      MX30  32
string:(ATNAM,10)#                                                      MX30  33
string:(RELMOD,4)#                                                      MX30  34
datastuff:#                                                             MX30  35
#                                                                       MX30  36
#                                                                       MX30  37
#  READ CASE.STRUCT                                                     MX30  38
#  -----------------                                                    MX30  39
#                                                                       MX30  40
DO I=200,1,-1; IF(FILENAME(I^I)!=' ')BREAK#                             MX30  41
LNBLNK=I#                                                               MX30  42
FILENAME(LNBLNK+1^)='.struct'#                                          MX30  43
INQUIRE(FILE=FILENAME,EXIST=TEST)#                                      MX30  44
IF(! TEST) iquit:(MX0002)#                                              MX30  45
AUXF=99#                                                                MX30  46
WRITE(6,*) "opening filename",FILENAME#                                 MX30  47
OPEN(AUXF,FILE=FILENAME,ACCESS='SEQUENTIAL',$#                          MX30  48
STATUS='UNKNOWN',FORM='FORMATTED')#                                     MX30  49
#                                                                       MX30  50
READ(AUXF,'(A80)') ATITLE#                                              MX30  51
WRITE(6,*) "title",ATITLE#                                              MX30  52
READ(AUXF,'(A4,24X,I2)')CLTYPE,NIAT#                                    MX30  53
READ(AUXF,'(13X,A4)')RELMOD#                                            MX30  54
READ(AUXF,'(6F10.6)')A,B,C,ALF,BET,GAM#                                 MX30  55
A=A*bohr2ang:;B=B*bohr2ang:;C=C*bohr2ang:#                              MX30  56
#                                      Metric tensor                    MX30  57
WRITE(6,*) A,B,C#                                                       MX30  58
WRITE(6,*) ALF,BET,GAM#                                                 MX30  59
ALF1=ALF;BET1=BET;GAM1=GAM#                                             MX30  60
ACELL1(1)=db:(A);ACELL1(2)=db:(B);ACELL1(3)=db:(C)#                     MX30  61
IF(CLTYPE(1^1)=='R')#                  Convert to primitive cell        MX30  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MX30  63
A=SQRT(3*B*B+C*C)/3.#                  Get rhombohedral a               MX30  64
ALF=2.*ASIN(3./2./SQRT(3.+(C/B)**2))/deg2pi:# Get rhombohedral alfa     MX30  65
B=A;C=A;BET=ALF;GAM=ALF#                                                MX30  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MX30  67
WRITE(6,*) A,B,C#                                                       MX30  68
WRITE(6,*) ALF,BET,GAM#                                                 MX30  69
#                                                                       MX30  70
ACELL(1)=db:(A);ACELL(2)=db:(B);ACELL(3)=db:(C)#                        MX30  71
MET(1,1)=A**2#                         A..2                             MX30  72
MET(1,2)=A*B*COS(GAM*deg2pi:)#         A.b.cos(gamma)                   MX30  73
MET(1,3)=A*C*COS(BET*deg2pi:)#         A.c.cos(beta)                    MX30  74
MET(2,1)=MET(1,2)#                     A.b.cos(gamma)                   MX30  75
MET(2,2)=B**2#                         B..2                             MX30  76
MET(2,3)=B*C*COS(ALF*deg2pi:)#         B.c.cos(alpha)                   MX30  77
MET(3,1)=MET(1,3)#                     A.c.cos(beta)                    MX30  78
MET(3,2)=MET(2,3)#                     B.c.cos(alpha)                   MX30  79
MET(3,3)=C**2#                         C..2                             MX30  80
#                                                                       MX30  81
#                                                                       MX30  82
#                                                                       MX30  83
# READ ATOM INFO                                                        MX30  84
# --------------                                                        MX30  85
#                                                                       MX30  86
NTYPE=0#                                                                MX30  87
PSIZE=4+mw08dm:#                                                        MX30  88
PSIZ=6+mw24dm:#                                                         MX30  89
P0=MARKS#                                                               MX30  90
incrqx:(P1,P0+16*PSIZE,MX3001)#        Reserve mem for 16 types         MX30  91
P2=P1#                                                                  MX30  92
DO NATM=1,NIAT#                                                         MX30  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MX30  94
# IAT CAN BE NEGATIVE                                                   MX30  95
READ(AUXF,'(5X,I3,4X,F10.8,3X,F10.8,3X,F10.8)')IAT,X,Y,Z#               MX30  96
READ(AUXF,'(15X,I2,17X,I2)')IMUL,ISPLIT#                                MX30  97
DO NSYMAT=1,IMUL-1#                    Skip sym related sites           MX30  98
READ(AUXF,'(5X,I3,4X,F10.8,3X,F10.8,3X,F10.8)')IAT,A,B,C#               MX30  99
READ(AUXF,'(A10,5X,I5,5X,F10.8,5X,F10.5,5X,F5.2)')$#                    MX30 100
ATNAM,NPT,R0,RMT,ZAT#                                                   MX30 101
LABEL=ATNAM(1^2);label:(LABEL,I,J,SFTYPE,K)# Test type                  MX30 102
IF(K==0)#                              Prepare the scat: packet         MX30 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MX30 104
IF(NTYPE+1>16) iquit:(MX0005)#         Too many atom types              MX30 105
KPT=P0+NTYPE*PSIZE#                                                     MX30 106
QX(KPT+1)=0.#                          Init type count                  MX30 107
QX(KPT+2)=ZAT#                         Set atomic number                MX30 108
QX(KPT+3)=ZAT#                         Set electron number              MX30 109
QX(KPT+4)=ZAT#                         Set valence band electrons       MX30 110
movector:(BLANK,1,QX(KPT+5),1,8,1)#    Blank out packet                 MX30 111
movector:(ATNAM,1,QX(KPT+5),1,2,0)#    Stash type                       MX30 112
SFTYPE((NTYPE)*8+1^)=LABEL(1^8)#       For the record                   MX30 113
NTYPE=NTYPE+1#                                                          MX30 114
K=NTYPE#                                                                MX30 115
WRITE(6,*) NTYPE ,ZAT, ATNAM(1^2)#                                      MX30 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MX30 117
#  MAKE THE  ATOM TYPE PACKET                                           MX30 118
KPT=P0+(K-1)*PSIZE#                                                     MX30 119
QX(KPT+1)=QX(KPT+1)+FLOAT(IMUL)#       Type count                       MX30 120
incrqx:(II,P2+PSIZ,MX3002)#                                             MX30 121
QX(P2+1)=X#                                                             MX30 122
QX(P2+2)=Y#                                                             MX30 123
QX(P2+3)=Z#                                                             MX30 124
QX(P2+4)=FLOAT(K)#                                                      MX30 125
QX(P2+5)=ZAT#                                                           MX30 126
QX(P2+6)=UOV#                             
movector:(BLANK,1,QX(P2+7),1,24,1)#    Blank out packet                 MX30 128
DO I=1,10 
$(
DO J=I,9; IF (ATNAM(J^J)!=' ')break
ATNAM(I^)=ATNAM(J^)
$)
movector:(ATNAM,1,QX(P2+7),1,8,0)#     Stash label       
P2=II#                                                                  MX30 131
WRITE(6,*) NTYPE ,X,Y,Z,K,ZAT,ATNAM(1^10)#                              MX30 132
DO K=1,3;READ(AUXF,'(20X,3F10.7)')(ROTLOC(I,K),I=1,3)#                  MX30 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MX30 134
#                                                                       MX30 135
# READ SYMOP INFO                                                       MX30 136
# ---------------                                                       MX30 137
#                                                                       MX30 138
READ(AUXF,'(I4)')NSYM#                                                  MX30 139
DO NSYMOP=1,NSYM#                                                       MX30 140
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MX30 141
DO I=1,3;READ(AUXF,'(3I2,F10.7)')(H(I,J),J=1,3),SHIFT(I)#               MX30 142
READ(AUXF,'(I8)')ISYM#                                                  MX30 143
DO I=1,3 ;DO J=1,3;SYMOP(I,J,NSYMOP)=FLOAT(H(I,J))#                     MX30 144
DO I=1,3 ;SYMOP(I,4,NSYMOP)=SHIFT(I)#                                   MX30 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MX30 146
CLOSE(AUXF)#                                                            MX30 147
#                                                                       MX30 148
#                                                                       MX30 149
#                                                                       MX30 150
#                                                                       MX30 151
CALL MX90#                             Dump lrhist to lrsymm: ...       MX30 152
#                                                                       MX30 153
#                                                                       MX30 154
#                                                                       MX30 155
#                                                                       MX30 156
# WRITE NTYPE PACKETS OF LOGICAL RECORD LRSCAT:                         MX30 157
# ---------------------------------------------                         MX30 158
#                                                                       MX30 159
PSIZE= 4+mw08dm:#                                                       MX30 160
writepkt:(3,lrscat:,PSIZE,IP)#         Initialize a lrscat directory    MX30 161
QX(IP+1)=1.#                           Fudge number of atoms            MX30 162
QX(IP+2)=3.#                           Known z value                    MX30 163
QX(IP+3)=4.#                           Known z value                    MX30 164
QX(IP+4)=8.#                           Abinit valence band electrons    MX30 165
DO I=1,mw08dm:;QX(IP+4+I)=11.#         Scattering factor name (8 char   MX30 166
IA=P0#                                                                  MX30 167
FOR(K=0;K<NTYPE;K=K+1)#                                                 MX30 168
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MX30 169
writepkt:(3,lrscat:,PSIZE,IP)#         Initialize a lrscat record       MX30 170
movereal:(QX,IA+1,QX,IP+1,PSIZE,1)#    Copy preformatted record acro    MX30 171
IA=IA+PSIZE#                                                            MX30 172
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MX30 173
#                                                                       MX30 174
# WRITE 1 PACKET OF LOGICAL RECORD LREXPL:                              MX30 175
#                                                                       MX30 176
#                                                                       MX30 177
PSIZE=2#                                                                MX30 178
writepkt:(3,lrexpl:,PSIZE,IP)#         Initialize a lrscat directory    MX30 179
QX(IP+1)=1.#                           Data set                         MX30 180
QX(IP+2)=2.#                           Mean wavelength                  MX30 181
writepkt:(3,lrexpl:,PSIZE,IP)#         Write one packet                 MX30 182
QX(IP+1)=1.#                           Data set 1                       MX30 183
QX(IP+2)=0.5#                          Wavelength in angstroms          MX30 184
#                                                                       MX30 185
# WRITE NIAT PACKETS OF LOGICAL RECORD LRATOM:                          MX30 186
# --------------------------------------------                          MX30 187
#                                                                       MX30 188
#                                                                       MX30 189
PSIZE= 6+mw24dm:#                                                       MX30 190
writepkt:(3,lratom:,PSIZE,IP)#         Initialize a lrscat directory    MX30 191
DO I=1,3; QX(IP+I)=FLOAT(I)#           X,y,z fract coords               MX30 192
QX(IP+4)=22.#                          Scat factor type (sequence)      MX30 193
QX(IP+5)=26.#                          Valence electrons of atom type   MX30 194
QX(IP+6)=4.#                           Valence electrons of atom type   MX30 195
DO I=1,mw24dm:;QX(IP+6+I)=14.#         Scattering factor name (8 char   MX30 196
FOR(IA=P1;IA<P2;IA=IA+PSIZE)#                                           MX30 197
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MX30 198
writepkt:(3,lratom:,PSIZE,IP)#         Initialize a lrscat record       MX30 199
movereal:(QX,IA+1,QX,IP+1,PSIZE,1)#    Copy preformatted record acro    MX30 200
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MX30 201
#                                                                       MX30 202
#                                                                       MX30 203
#  READ DENSITY FROM CASE.TMP                                           MX30 204
#  --------------------------                                           MX30 205
#                                                                       MX30 206
FILENAME(LNBLNK+1^)='.3dmap'#              
INQUIRE(FILE=FILENAME,EXIST=TEST)#                                      MX30 208
IF(!TEST) iquit:(MX3002)#                                               MX30 209
AUXF=99#                                                                MX30 210
WRITE(6,*) "opening filename",FILENAME#                                 MX30 211
OPEN(UNIT=AUXF,FILE=FILENAME,ACCESS='SEQUENTIAL',$#                     MX30 212
STATUS='UNKNOWN',FORM='UNFORMATTED')#                                   MX30 213
WRITE(6,*) "opened filename",FILENAME#                                  MX30 214
REWIND(AUXF)#                                                           MX30 215
READ(AUXF) NPX,NPY,NPZ,RELX,RELY,RELZ#                                  MX30 216
WRITE(6,*) NPX,NPY,NPZ#                                                 MX30 217
WRITE(6,*) RELX,RELY,RELZ#                                              MX30 218
STPX=1.0/FLOAT(NPX-1);STPY=1.0/FLOAT(NPY-1);STPZ=1.0/FLOAT(NPZ-1)# St   MX30 219
WRITE(6,*) STPX,STPY,STPZ#                                              MX30 220
DO I=1,3 ; ACELL1(I)=ACELL1(I)/bohr2ang:#                               MX30 221
CALL MX31(CLTYPE,ACELL1,ALF1,BET1,GAM1,BR)# Get wien2k bravais lattic   MX30 222
invert:(BR,BRI)#                       Invert matrix                    MX30 223
WRITE(6,*) "Bravais "#                                                  MX30 224
DO I=1,3;WRITE(6,*)(BR(I,J),J=1,3)#                                     MX30 225
WRITE(6,*) "Bravais inverse"#                                           MX30 226
DO I=1,3;WRITE(6,*)(BRI(I,J),J=1,3)#                                    MX30 227
#                                                                       MX30 228
# THERE IS NOT ENOUGH INFORMATION IN THE .TMP FILE TO                   MX30 229
# RECONSTRUCT AN XTAL .MAP FILE PERFECTLY                               MX30 230
# THE .TMP DATA CAN BE ANY PARALLELOID GRID OF DATA TAKEN FROM          MX30 231
# THE UNIT CELL CONTENTS. THERE IS NO DEFINITION OF ORIGIN              MX30 232
# OR MIN MAX POINTS !! NEED TO READ THE CASE.IN53D FILE FOR THAT!       MX30 233
# UNFORTUNATELY THAT IS NON-STANDARD NAMING!                            MX30 234
# OR WE COULD JUST ASSUME THAT ITS A WHOLE UNIT CELL!                   MX30 235
#                                                                       MX30 236
IPNT=NPX*NPY*NPZ#                      Total number of points           MX30 237
incrqx:(P3,P2+IPNT,MX3005)#            Get space to store lattice       MX30 238
#                                                                       MX30 239
DO IND=1,IPNT#                         Loop for every point in map      MX30 240
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MX30 241
READ(AUXF)(POS(I),I=1,3),CHGE#         Read coords and charge           MX30 242
DO I=1,3;VEC(I)=sg:(POS(I))#           Convert to real                  MX30 243
DO I=1,3#                              Matrix mult by inverse transpo   MX30 244
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MX30 245
FVEC(I)=0.0;DO J=1,3;FVEC(I)=FVEC(I)+BRI(J,I)*VEC(J)#                   MX30 246
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MX30 247
IX=NINT(FVEC(1)/STPX)#                                                  MX30 248
IY=NINT(FVEC(2)/STPY)#                                                  MX30 249
IZ=NINT(FVEC(3)/STPZ)#                                                  MX30 250
IF(IX<0\IX>NPX) IX=MOD(IX+10*NPX,NPX)#                                  MX30 251
IF(IY<0\IY>NPY) IY=MOD(IY+10*NPY,NPY)#                                  MX30 252
IF(IZ<0\IZ>NPZ) IZ=MOD(IZ+10*NPZ,NPZ)#                                  MX30 253
JPNT=P2+(IZ)*(NPY*NPX)+(IY)*NPX+IX+1#                                   MX30 254
QX(JPNT)=sg:(CHGE)#                    Save the charge                  MX30 255
#WRITE(6,'(3F9.4,F12.4,3I3,I12,3F7.3,I7)') POS(1),POS(2),POS(3),$#      MX30 256
#CHGE,IX,IY,IZ,JPNT,FVEC(1),FVEC(2),FVEC(3),IND                         MX30 257
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MX30 258
CMIN=QX(JPNT)#                         Set max/min init value           MX30 259
CMAX=CMIN#                                                              MX30 260
CLOSE(AUXF)#                                                            MX30 261
#                                                                       MX30 262
#  INITIALIZE THE MAP HEADER PARAMETERS                                 MX30 263
#  ------------------------------------                                 MX30 264
#                                                                       MX30 265
DO I=1,3;DO J=1,3;TRI(I,J)=0.0#                                         MX30 266
DO I=1,3;TRI(I,I)=1.0#                 Dummy transformation matrix      MX30 267
NGFFT(1)=NPX;NGFFT(2)=NPY;NGFFT(3)=NPZ# Save num grid points            MX30 268
#                                                                       MX30 269
ICEL(1)=3;ICEL(2)=2;ICEL(3)=1#         Layer, down, across=z,y,x        MX30 270
DO I=1,3;NG(I)=NGFFT(ICEL(I))-1#       Interpolated grid                MX30 271
#                                                                       MX30 272
DO I=1,3#                                                               MX30 273
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MX30 274
ORGX(I)=0#                             Starts at origin                 MX30 275
INCX(I)=1#                             Only thing acceptible            MX30 276
# BASICALLY THESE NEXT THREE PARAMS  IMPLY THAT THE FFT MAP             MX30 277
# WAS CREATED IN THE Z,Y,X ORDER AND WILL BE WRITTEN OUT WITH           MX30 278
# X FASTEST, FOLLOWED BY Y ROWS FOR EACH Z PLANE.                       MX30 279
NP(I)  =NG(I)+MTERM#                   Number of points in actual map   MX30 280
IMAP(I)=4-I#                           Z, y, x                          MX30 281
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MX30 282
#FUSE=F000 # FOR FMAP                                                   MX30 283
FUSE=0.0#                              For diff map                     MX30 284
SKAL=1.0#                                                               MX30 285
CTYPE=6#                                                                MX30 286
PTYPE=0#                                                                MX30 287
IPROP=1#                                                                MX30 288
UPLIM=-1.#                                                              MX30 289
LOLIM= 1.#                                                              MX30 290
PASSES=1#                                                               MX30 291
#                                                                       MX30 292
# WRITE 1 PACKET  OF MAP HEADER RECORD                                  MX30 293
#                                                                       MX30 294
PSIZE=41#                              Setup packet for misc data       MX30 295
writepkt:(3,21,PSIZE,IP)#              Point to op packet               MX30 296
DO J=1,3#                              Loop cell axes (1=x;2=y;3=z)     MX30 297
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MX30 298
JJ=IP+J#                               Point to op buffer               MX30 299
QX(JJ  )=FLOAT(ORGX(J))#               Start layer down across (zyx)    MX30 300
QX(JJ+3)=FLOAT(INCX(J))#               Incr layer y x                   MX30 301
QX(JJ+6)=FLOAT(NG  (J))#               Grid layer y x                   MX30 302
QX(JJ+9)=FLOAT(NP  (J))#               Points layer y x                 MX30 303
QX(JJ+12)=FLOAT(IMAP(J))#              Store map codes for x,y,z        MX30 304
QX(JJ+15)=FLOAT(ICEL(J))#              Store cell codes for l,d,a       MX30 305
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MX30 306
QX(IP+19)=UPLIM#                       Store upper print limit          MX30 307
QX(IP+20)=LOLIM#                       Store lower print limit          MX30 308
IF(CTYPE>7) QX(IP+21)=FLOAT(CTYPE-3)#  Store calc type for pekpik       MX30 309
ELSE        QX(IP+21)=FLOAT(CTYPE)#    Store calc type for pekpik       MX30 310
QX(IP+22)=FUSE#                        Store f000 term added            MX30 311
QX(IP+23)=FLOAT(IABS(PASSES))#         Store total passes               MX30 312
QX(IP+24)=SKAL#                        Store print scale                MX30 313
QX(IP+40)=FLOAT(PTYPE)#                Property 0=ed 1=ep 2=ef 3=eg     MX30 314
QX(IP+41)=FLOAT(IPROP)#                Number of components             MX30 315
#                                                                       MX30 316
# WRITE Y*Z ROWS OF MAP TO RECORD 22                                    MX30 317
# ----------------------------------                                    MX30 318
#                                                                       MX30 319
PSIZE=NP(3)*IPROP#                     Size of output row               MX30 320
NROW= NGFFT(1)*NGFFT(2)#               Size of input grid               MX30 321
NNG1=10*NGFFT(1)#                      Shift to positive x primitive    MX30 322
NNG2=10*NGFFT(2)#                      Shift to positive y primitive    MX30 323
NNG3=10*NGFFT(3)#                      Shift to positive z primitive    MX30 324
FOR(IC=0;IC<NP(1);IC=IC+1)#            Loop for z layers                MX30 325
FOR(IB=0;IB<NP(2);IB=IB+1)#            Loop for y rows                  MX30 326
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MX30 327
writepkt:(3,22,PSIZE,IP )#             For later use by pekpik or e     MX30 328
FOR(IA=0;IA<NP(3);IA=IA+1)#            Loop for all x points in row     MX30 329
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MX30 330
IPA=MOD(NINT(TRI(1,1)*IA+TRI(1,2)*IB+TRI(1,3)*IC)+NNG1,NGFFT(1))#       MX30 331
IPB=MOD(NINT(TRI(2,1)*IA+TRI(2,2)*IB+TRI(2,3)*IC)+NNG2,NGFFT(2))#       MX30 332
IPC=MOD(NINT(TRI(3,1)*IA+TRI(3,2)*IB+TRI(3,3)*IC)+NNG3,NGFFT(3))#       MX30 333
IPT=(IPC*NROW +IPB*NGFFT(1)+IPA)#      Serialized storage location      MX30 334
A=QX(P2+IPT+1)#                        Get value                        MX30 335
QX(IP+1+IA)=A#                         Save to .map file                MX30 336
IF(A<CMIN) CMIN=A#                     Set min value                    MX30 337
IF(A>CMAX) CMAX=A#                     Set max value                    MX30 338
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MX30 339
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MX30 340
#                                                                       MX30 341
WRITE(6,*) "CHARGE min/max ",CMIN,CMAX#                                 MX30 342
#                                                                       MX30 343
CALL MX91#                                                              MX30 344
#                                                                       MX30 345
#                                                                       MX30 346
RETURN#                                                                 MX30 347
END#                                                                    MX30 348
ifsel:(UNXDEC)#                                                         MX30 349
endext:#                               End of strange compile options   MX30 350
endsel:#                                                                MX30 351
systemheader:(MX31)#                   Wien2k bravais lattice           MX31   1
####################################################################    MX31   2
#                                                                  #    MX31   3
#                             MX31                                 #    MX31   4
#                                                                  #    MX31   5
####################################################################    MX31   6
SUBROUTINE MX31(LATTIC,A,ALPHA1,BETA1,GAMMA1,BR1)#                      MX31   7
#                                                                       MX31   8
LOGICAL ORTHO#                                                          MX31   9
double: A(3)#                                                           MX31  10
REAL    ALPHA1,BETA1,GAMMA1#                                            MX31  11
REAL    ALPHA,BETA,GAMMA,COSG1,GAMMA0#                                  MX31  12
REAL    BR1(3,3),BR2(3,3)#                                              MX31  13
string:(LATTIC,4)#                                                      MX31  14
datastuff:#                                                             MX31  15
#                                                                       MX31  16
ALPHA=ALPHA1*deg2pi:#                                                   MX31  17
BETA=BETA1*deg2pi:#                                                     MX31  18
GAMMA=GAMMA1*deg2pi:#                                                   MX31  19
WRITE(6,*) ALPHA,BETA,GAMMA#                                            MX31  20
WRITE(6,*) ALPHA1,BETA1,GAMMA1#                                         MX31  21
IF(LATTIC(1^1)=='S'\LATTIC(1^1)=='P')#                                  MX31  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MX31  23
COSG1=(COS(GAMMA)-COS(ALPHA)*COS(BETA))/SIN(ALPHA)/SIN(BETA)#           MX31  24
GAMMA0=ACOS(COSG1)#                                                     MX31  25
BR2(1,1)=A(1)*1.0D0*SIN(GAMMA0)*SIN(BETA)#                              MX31  26
BR2(1,2)=A(1)*1.0D0*COS(GAMMA0)*SIN(BETA)#                              MX31  27
BR2(1,3)=A(1)*1.0D0*COS(BETA)#                                          MX31  28
BR2(2,1)=0.0D0#                                                         MX31  29
BR2(2,2)=A(2)*1.0D0*SIN(ALPHA)#                                         MX31  30
BR2(2,3)=A(2)*1.0D0*COS(ALPHA)#                                         MX31  31
BR2(3,1)=0.0D0#                                                         MX31  32
BR2(3,2)=0.0D0#                                                         MX31  33
BR2(3,3)=A(3)*1.0D0#                                                    MX31  34
BR1(1,1)=A(1)*1.0D0*SIN(GAMMA0)*SIN(BETA)#                              MX31  35
BR1(1,2)=A(1)*1.0D0*COS(GAMMA0)*SIN(BETA)#                              MX31  36
BR1(1,3)=A(1)*1.0D0*COS(BETA)#                                          MX31  37
BR1(2,1)=0.0D0#                                                         MX31  38
BR1(2,2)=A(2)*1.0D0*SIN(ALPHA)#                                         MX31  39
BR1(2,3)=A(2)*1.0D0*COS(ALPHA)#                                         MX31  40
BR1(3,1)=0.0D0#                                                         MX31  41
BR1(3,2)=0.0D0#                                                         MX31  42
BR1(3,3)=A(3)*1.0D0#                                                    MX31  43
ORTHO=.TRUE.#                                                           MX31  44
IF(GAMMA1!=90.D0) ORTHO=.FALSE.#                                        MX31  45
IF(ALPHA1!=90.D0) ORTHO=.FALSE.#                                        MX31  46
IF(BETA1!=90.D0) ORTHO=.FALSE.#                                         MX31  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MX31  48
ELSE IF(LATTIC(1^1)=='F')#                                              MX31  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MX31  50
BR2(1,1)=0.5*A(1)#                                                      MX31  51
BR2(2,1)=0.5*A(1)#                                                      MX31  52
BR2(2,2)=0.5*A(2)#                                                      MX31  53
BR2(3,2)=0.5*A(2)#                                                      MX31  54
BR2(1,3)=0.5*A(3)#                                                      MX31  55
BR2(3,3)=0.5*A(3)#                                                      MX31  56
BR1(1,1)=A(1)#                                                          MX31  57
BR1(2,2)=A(2)#                                                          MX31  58
BR1(3,3)=A(3)#                                                          MX31  59
ORTHO=.TRUE.#                                                           MX31  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MX31  61
ELSE IF(LATTIC(1^1)=='B')#                                              MX31  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MX31  63
BR2(1,1)=-0.5*A(1)#                                                     MX31  64
BR2(2,1)=0.5*A(1)#                                                      MX31  65
BR2(3,1)=0.5*A(1)#                                                      MX31  66
BR2(1,2)=0.5*A(2)#                                                      MX31  67
BR2(2,2)=-0.5*A(2)#                                                     MX31  68
BR2(3,2)=0.5*A(2)#                                                      MX31  69
BR2(1,3)=0.5*A(3)#                                                      MX31  70
BR2(2,3)=0.5*A(3)#                                                      MX31  71
BR2(3,3)=-0.5*A(3)#                                                     MX31  72
BR1(1,1)=A(1)#                                                          MX31  73
BR1(2,2)=A(2)#                                                          MX31  74
BR1(3,3)=A(3)#                                                          MX31  75
ORTHO=.TRUE.#                                                           MX31  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MX31  77
ELSE IF(LATTIC(1^1)=='H')#                                              MX31  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MX31  79
BR1(1,1)=SQRT(3.)/2.*A(1)#                                              MX31  80
BR1(1,2)=-0.5*A(2)#                                                     MX31  81
BR1(2,2)=1.*A(2)#                                                       MX31  82
BR1(3,3)=1.*A(3)#                                                       MX31  83
BR2(1,1)=SQRT(3.)/2.*A(1)#                                              MX31  84
BR2(1,2)=-0.5*A(2)#                                                     MX31  85
BR2(2,2)=1.*A(2)#                                                       MX31  86
BR2(3,3)=1.*A(3)#                                                       MX31  87
ORTHO=.FALSE.#                                                          MX31  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MX31  89
ELSE IF(LATTIC(1^1)=='R')#                                              MX31  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MX31  91
BR1(1,1)=1./SQRT(3.)/2.*A(1)#                                           MX31  92
BR1(1,2)=-0.5*A(2)#                                                     MX31  93
BR1(1,3)=1./3.*A(3)#                                                    MX31  94
BR1(2,1)=1./SQRT(3.)/2.*A(1)#                                           MX31  95
BR1(2,2)=0.5*A(2)#                                                      MX31  96
BR1(2,3)=1./3.*A(3)#                                                    MX31  97
BR1(3,1)=-1./SQRT(3.)*A(1)#                                             MX31  98
BR1(3,2)=0.#                                                            MX31  99
BR1(3,3)=1./3.*A(3)#                                                    MX31 100
BR2(1,1)=1./SQRT(3.)/2.*A(1)#                                           MX31 101
BR2(1,2)=-0.5*A(2)#                                                     MX31 102
BR2(1,3)=1./3.*A(3)#                                                    MX31 103
BR2(2,1)=1./SQRT(3.)/2.*A(1)#                                           MX31 104
BR2(2,2)=0.5*A(2)#                                                      MX31 105
BR2(2,3)=1./3.*A(3)#                                                    MX31 106
BR2(3,1)=-1./SQRT(3.)*A(1)#                                             MX31 107
BR2(3,2)=0.#                                                            MX31 108
BR2(3,3)=1./3.*A(3)#                                                    MX31 109
ORTHO=.FALSE.#                                                          MX31 110
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MX31 111
ELSE IF(LATTIC(1^3)=='CXY')#                                            MX31 112
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MX31 113
BR2(1,1)=0.5*A(1)#                                                      MX31 114
BR2(2,1)=0.5*A(1)#                                                      MX31 115
BR2(3,1)=0.#                                                            MX31 116
BR2(1,2)=0.5*A(2)#                                                      MX31 117
BR2(2,2)=-0.5*A(2)#                                                     MX31 118
BR2(3,2)=0.#                                                            MX31 119
BR2(1,3)=0.#                                                            MX31 120
BR2(2,3)=0.#                                                            MX31 121
BR2(3,3)=A(3)#                                                          MX31 122
BR1(1,1)=A(1)#                                                          MX31 123
BR1(2,2)=A(2)#                                                          MX31 124
BR1(3,3)=A(3)#                                                          MX31 125
ORTHO=.TRUE.#                                                           MX31 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MX31 127
ELSE IF(LATTIC(1^3)=='CYZ')#                                            MX31 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MX31 129
BR2(1,1)=A(1)#                                                          MX31 130
BR2(2,1)=0.#                                                            MX31 131
BR2(3,1)=0.#                                                            MX31 132
BR2(1,2)=0.#                                                            MX31 133
BR2(2,2)=-0.5*A(2)#                                                     MX31 134
BR2(3,2)=0.5*A(2)#                                                      MX31 135
BR2(1,3)=0.#                                                            MX31 136
BR2(2,3)=0.5*A(3)#                                                      MX31 137
BR2(3,3)=0.5*A(3)#                                                      MX31 138
BR1(1,1)=A(1)#                                                          MX31 139
BR1(2,2)=A(2)#                                                          MX31 140
BR1(3,3)=A(3)#                                                          MX31 141
ORTHO=.TRUE.#                                                           MX31 142
#      ELSE IF(LATTIC(1:3).EQ.'CXZ'.AND.GAMMA1.NE.90.D0) THEN           MX31 143
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MX31 144
ELSE IF(LATTIC(1^3)=='CXZ')#                                            MX31 145
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MX31 146
BR2(1,1)=0.5D0*A(1)*SIN(GAMMA)#                                         MX31 147
BR2(1,2)=0.5D0*A(1)*COS(GAMMA)#                                         MX31 148
BR2(1,3)=-0.5D0*A(3)#                                                   MX31 149
BR2(2,2)=A(2)#                                                          MX31 150
BR2(3,1)=0.5D0*A(1)*SIN(GAMMA)#                                         MX31 151
BR2(3,2)=0.5D0*A(1)*COS(GAMMA)#                                         MX31 152
BR2(3,3)=0.5D0*A(3)#                                                    MX31 153
BR1(1,1)=1.*A(1)*SIN(GAMMA)#                                            MX31 154
BR1(1,2)=1.*A(1)*COS(GAMMA)#                                            MX31 155
BR1(2,2)=1.*A(2)#                                                       MX31 156
BR1(3,3)=1.*A(3)#                                                       MX31 157
ORTHO=.FALSE.#                                                          MX31 158
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MX31 159
ELSE iquit:(MX3101)#                                                    MX31 160
#                                                                       MX31 161
RETURN#                                                                 MX31 162
END#                                                                    MX31 163
systemheader:(MX40)#                   Write a text file                MX40   1
####################################################################    MX40   2
#                                                                  #    MX40   3
#                             MX40   MAP2TXT:                      #    MX40   4
#                                                                  #    MX40   5
####################################################################    MX40   6
SUBROUTINE MX40#                                                        MX40   7
include:(AACOMN)#                                                       MX40   8
include:(MXCOMN)#                                                       MX40   9
#                                                                       MX40  10
RETURN#                                                                 MX40  11
END#                                                                    MX40  12
systemheader:(MX50)#                   Write ibm data explorer file     MX50   1
####################################################################    MX50   2
#                                                                  #    MX50   3
#                             MX50   MAP2IBM:                      #    MX50   4
#                                                                  #    MX50   5
####################################################################    MX50   6
SUBROUTINE MX50#                                                        MX50   7
include:(AACOMN)#                                                       MX50   8
include:(MXCOMN)#                                                       MX50   9
#                                                                       MX50  10
RETURN#                                                                 MX50  11
END#                                                                    MX50  12
systemheader:(MX90)#                   Write xtal map file header rec   MX90   1
####################################################################    MX90   2
#                                                                  #    MX90   3
#                             MX90                                      MX90   4
#                                                                  #    MX90   5
####################################################################    MX90   6
SUBROUTINE MX90#                                                        MX90   7
include:(AACOMN)#                                                       MX90   8
include:(MXCOMN)#                                                       MX90   9
INTEGER IP#                                                             MX90  10
INTEGER CSYS#                                                           MX90  11
INTEGER NCENT#                                                          MX90  12
INTEGER NCHR#                                                           MX90  13
#                                                                       MX90  14
#                                                                       MX90  15
# NOW LETS WRITE OUT AN XTAL BDF PRECURSOR FOR THE .MAP FILE            MX90  16
# ----------------------------------------------------------            MX90  17
#                                                                       MX90  18
# WRITE PACKET 1 OF LOGICAL RECORD 1                                    MX90  19
#                                                                       MX90  20
writepkt:(3,lrhist:,3,IP)#             Point to history packet          MX90  21
#                                                                       MX90  22
# WRITE PACKET 1 OF LOGICAL RECORD LRLABL:                              MX90  23
#                                                                       MX90  24
NCHR=MIN0(mxchim:,72)#                 Protect against overwriting      MX90  25
writepkt:(3,lrlabl:,mxwdim:,IP)#       Point to creation packet         MX90  26
movector:(BLANK,1,QX(IP+1),1,mxchim:,1)# Blank out packet               MX90  27
movector:(TITLE,1,QX(IP+1),1,NCHR,0)#  Insert current title             MX90  28
#                                                                       MX90  29
# WRITE PACKET 2 OF LOGICAL RECORD LRLABL:                              MX90  30
#                                                                       MX90  31
writepkt:(3,lrlabl:,mxwdim:,IP)#       Point to title packet            MX90  32
movector:(BLANK,1,QX(IP+1),1,mxchim:,1)# Blank out packet               MX90  33
movector:(TITLE,40,QX(IP+1),1,NCHR,0)# Insert current title             MX90  34
#                                                                       MX90  35
# WRITE PACKET 3 OF LOGICAL RECORD LRLABL:                              MX90  36
#                                                                       MX90  37
NCHR=MIN0(mxchim:,74)#                 Protect against overwriting      MX90  38
writepkt:(3,lrlabl:,mxwdim:,IP)#       Point to label packet            MX90  39
movector:(BLANK,1,QX(IP+1),1,mxchim:,1)# Blank out packet               MX90  40
movector:(CHRIP,1,QX(IP+1),1,74,0)#    Place the current title          MX90  41
#                                                                       MX90  42
# WRITE 2 PACKETS OF LOGICAL RECORD LRCELL:                             MX90  43
#                                                                       MX90  44
writepkt:(3,lrcell:,9,IP)#             Initialize first lrcell packet   MX90  45
DO I=1,9; QX(IP+I)=voidflg:#           Void fill                        MX90  46
#                                                                       MX90  47
#WRITE(6,*) "CELL PARAMS", (ACELL(I),I=1,3)                             MX90  48
DO I=1,3; QX(IP+I)=sg:(ACELL(I))#                                       MX90  49
DO I=1,3 ; WRITE(6,*)"METric",(MET(I,J),J=1,3)#                         MX90  50
QX(IP+4)=MET(2,3)/ QX(IP+2)/QX(IP+3)#  Cos alpha                        MX90  51
QX(IP+5)=MET(1,3)/ QX(IP+1)/QX(IP+3)#  Cos beta                         MX90  52
QX(IP+6)=MET(1,2)/ QX(IP+1)/QX(IP+2)#  Cos gamma                        MX90  53
QX(IP+7)=ACOS(QX(IP+4))/twopi:#                                         MX90  54
QX(IP+8)=ACOS(QX(IP+5))/twopi:#                                         MX90  55
QX(IP+9)=ACOS(QX(IP+6))/twopi:#                                         MX90  56
WRITE(6,*) "cell params",  (QX(IP+I),I=1,3),$#                          MX90  57
(ACOS(QX(IP+3+I))*360./twopi:,I=1,3)#                                   MX90  58
DO I=1,3 ; QX(IP+I)=SQRT(MET(I,I))#                                     MX90  59
WRITE(6,*) "cell params",  (QX(IP+I),I=1,3),$#                          MX90  60
(ACOS(QX(IP+3+I))*360./twopi:,I=1,3)#                                   MX90  61
#                                                                       MX90  62
#  CHECK THE INCOMING CRYSTAL SYSTEM                                    MX90  63
#  ---------------------------------                                    MX90  64
#                                                                       MX90  65
K=0#                                   120 degree angle?                MX90  66
ifeq:(QX(IP+4),0.0)K=K+1#                                               MX90  67
ifeq:(QX(IP+5),0.0)K=K+1#                                               MX90  68
ifeq:(QX(IP+6),0.5)K=K+1#                                               MX90  69
L=0#                                   Count 90 degree angles           MX90  70
ifeq:(QX(IP+4),0.0)L=L+1#                                               MX90  71
ifeq:(QX(IP+5),0.0)L=L+1#                                               MX90  72
ifeq:(QX(IP+6),0.0)L=L+1#                                               MX90  73
M=0#                                   Count equal angles               MX90  74
ifeq:(QX(IP+1),QX(IP+2))M=M+1#                                          MX90  75
ifeq:(QX(IP+1),QX(IP+3))M=M+1#                                          MX90  76
ifeq:(QX(IP+2),QX(IP+3))M=M+1#                                          MX90  77
N=0#                                   Count equal lengths              MX90  78
ifeq:(QX(IP+4),QX(IP+5))N=N+1#                                          MX90  79
ifeq:(QX(IP+5),QX(IP+6))N=N+1#                                          MX90  80
ifeq:(QX(IP+6),QX(IP+4))N=N+1#                                          MX90  81
IF    (M==0)             CSYS=1#       Triclinic                        MX90  82
ELSEIF(M==3&N==3&L==3)   CSYS=8#       Cubic                            MX90  83
ELSEIF(M==3&N==3&L==0)   CSYS=6#       Rhombohedral or 5 trig ?         MX90  84
ELSEIF(M==3&N==1&L==3)   CSYS=4#       Tetragonal                       MX90  85
ELSEIF(M==3&N==0&L==3)   CSYS=3#       Orthorhombic                     MX90  86
ELSE#                                  Two angles equal                 MX90  87
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MX90  88
IF(K==1)                 CSYS=7#       Hexagonal                        MX90  89
ELSE                     CSYS=2#       Monoclinic                       MX90  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MX90  91
#                                                                       MX90  92
#                                                                       MX90  93
#                                                                       MX90  94
writepkt:(3,lrcell:,9,IP)#             Initialize sigma packet          MX90  95
DO I=1,3; QX(IP+I)=0.001#              Set sig(a),sig(b),sig(c)         MX90  96
DO I=1,3; QX(IP+3+I)=0.0001#           Set sig(cosa),sig(cosb),sig(co   MX90  97
DO I=1,3; QX(IP+6+I)=0.01#             Set sig(alf),sig(bet),sig(gam)   MX90  98
DO J=3,12#                             Create default empty packets     MX90  99
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MX90 100
writepkt:(3,lrcell:,9,IP)#             Initialize sigma packet          MX90 101
DO I=1,9; QX(IP+I)=voidflg:#           Void fill                        MX90 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MX90 103
#                                                                       MX90 104
#                                                                       MX90 105
#   TEST SYMOPS FOR CENTRE                                              MX90 106
#   ----------------------                                              MX90 107
#                                                                       MX90 108
NCENT=1#                               Test for centre of symmetry      MX90 109
LATSTRC="n"#                                                            MX90 110
DO IS=1,NSYM#                                                           MX90 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MX90 112
DO I=1,3#                                                               MX90 113
DO J=1,4#                                                               MX90 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MX90 115
IF(I==J)$(ifne:(SYMOP(I,J,IS),-1.) GOTO 98$)#                           MX90 116
ELSE      ifne:(SYMOP(I,J,IS),0.0) GOTO 98#                             MX90 117
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MX90 118
NCENT=0#                               Matched on the inversion symop   MX90 119
LATSTRC="c"#                                                            MX90 120
BREAK#                                                                  MX90 121
98 CONTINUE#                                                            MX90 122
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MX90 123
#                                                                       MX90 124
NMAT=NSYM#                                                              MX90 125
IF(NCENT==13)#                         Remove centred symops            MX90 126
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MX90 127
FOR(IS1=1;    IS1 <NMAT;IS1=IS1+1)#                                     MX90 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MX90 129
FOR(IS2=IS1+1;IS2<=NMAT;IS2=IS2+1)#                                     MX90 130
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MX90 131
DO I=1,3#                                                               MX90 132
DO J=1,4#                                                               MX90 133
ifne:(SYMOP(I,J,IS1),-1.*SYMOP(I,J,IS2)) GOTO 99#                       MX90 134
DO I=1,3#                                                               MX90 135
DO J=1,4#                                                               MX90 136
SYMOP(I,J,IS2)=SYMOP(I,J,NMAT)#                                         MX90 137
NMAT=NMAT-1#                                                            MX90 138
BREAK#                                                                  MX90 139
99 CONTINUE#                                                            MX90 140
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MX90 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MX90 142
WRITE(6,*)"NMAT ",NMAT#                                                 MX90 143
WRITE(6,*)"NSYM ",NSYM#                                                 MX90 144
IF(NMAT!=NSYM/2) iquit:(MX0004)#       Trouble there somewhere          MX90 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MX90 146
#                                                                       MX90 147
# STARTX UPD MODE SORTS OUT ALL THE LATTICE TYPE FROM SYMOPS            MX90 148
# ----------------------------------------------------------            MX90 149
#                                                                       MX90 150
#                                                                       MX90 151
# WRITE N PACKETS OF LOGICAL RECORD LRSYMM:                             MX90 152
#                                                                       MX90 153
writepkt:(3,lrsymm:,12,IP)#            Initialize first lrsymm packet   MX90 154
DO I=1,12; QX(IP+I)=voidflg:#          Void fill                        MX90 155
LCODE=1;#                                                               MX90 156
IF(LCF==4) LCODE=4#                                                     MX90 157
IF(LCF==3) LCODE=3#                                                     MX90 158
IF(NCENT==0)LCODE=LCODE+7#                                              MX90 159
QX(IP+1)=FLOAT(LCODE)#                 Lattice type                     MX90 160
QX(IP+2)=FLOAT(NCENT)#                 Noncentro code                   MX90 161
QX(IP+3)=FLOAT(NSYM)#                  Total symops                     MX90 162
QX(IP+4)=FLOAT(NMAT)#                  Total primitive symops           MX90 163
QX(IP+9)=FLOAT(CSYS)#                  Crystal system code              MX90 164
#WRITE(6,*) "DDB" ,LCODE,NCENT,NSYM,NMAT,CSYS,LCF                       MX90 165
DO IS=1,NMAT#                                                           MX90 166
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MX90 167
writepkt:(3,lrsymm:,12,IP)#            Initialize first lrsymm packet   MX90 168
DO I=1,3#                                                               MX90 169
DO J=1,4#                                                               MX90 170
QX(IP+(J-1)*3+I)=SYMOP(I,J,IS)#                                         MX90 171
IF(LCF!=0) CALL MX05(IP+1,TRI,TR)#     Last minute transformation       MX90 172
WRITE(6,*) "   ",IS#                                                    MX90 173
WRITE(6,*) "   ",QX(IP+1),QX(IP+4),QX(IP+7),QX(IP+10)#                  MX90 174
WRITE(6,*) "   ",QX(IP+2),QX(IP+5),QX(IP+8),QX(IP+11)#                  MX90 175
WRITE(6,*) "   ",QX(IP+3),QX(IP+6),QX(IP+9),QX(IP+12)#                  MX90 176
#                                                                       MX90 177
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MX90 178
#                                                                       MX90 179
# WRITE 2 PACKETS OF LOGICAL RECORD LRSGNM:                             MX90 180
#                                                                       MX90 181
writepkt:(3,lrsgnm:,mw40dm:,IP)#       Point to hall sgnm packet        MX90 182
DO I=1,mw40dm:; QX(IP+I)=voidflg:#     Void fill                        MX90 183
writepkt:(3,lrsgnm:,mw40dm:,IP)#       Point to h-m  sgnm packet        MX90 184
DO I=1,mw40dm:; QX(IP+I)=voidflg:#     Void fill                        MX90 185
#                                                                       MX90 186
#                                                                       MX90 187
RETURN#                                                                 MX90 188
END#                                                                    MX90 189
systemheader:(MX91)#                   Write xtal map file header rec   MX91   1
####################################################################    MX91   2
#                                                                  #    MX91   3
#                             MX91                                      MX91   4
#                                                                  #    MX91   5
####################################################################    MX91   6
SUBROUTINE MX91#                                                        MX91   7
include:(AACOMN)#                                                       MX91   8
include:(MXCOMN)#                                                       MX91   9
chardata:(LATSTR,"latice n p ncheck")#                                  MX91  10
datastuff:#                                                             MX91  11
#                                                                       MX91  12
#  CLOSE DOWN THE MAP FILE                                              MX91  13
#  -----------------------                                              MX91  14
#                                                                       MX91  15
writepkt:(3,endrecord:,1,IP)#          Close the new xtal map file      MX91  16
#                                                                       MX91  17
#                                                                       MX91  18
#                                                                       MX91  19
#                                                                       MX91  20
WRITE(6,*) "Spawning STARTX/EXPAND/ADDATM..."#                          MX91  21
#                 CREATING A NEW MAP FILE                               MX91  22
openfmt:(iofm1:,' ')#                  Open the file                    MX91  23
writefmt:(iofm1:,'(A)','copybdf map a')# Up to the user to save file    MX91  24
writefmt:(iofm1:,'(A)','startx upd ')# Validate lrsymm:                 MX91  25
LATSTR(8^8)=LATSTRC#                                                    MX91  26
#IF (NCHECK==1) WRITEFMT:(IOFM1:,'(A)',LATSTR)# IGNORE ERRANT SYMM      MX91  27
writefmt:(iofm1:,'(A)','EXPAND not')#  Reduce to indep sites            MX91  28
writefmt:(iofm1:,'(A)','ADDATM upd')#  Validate lratom:                 MX91  29
writefmt:(iofm1:,'(A)','end')#                                          MX91  30
writefmt:(iofm1:,'(A)','copybdf a map')#                                MX91  31
LINFLG=1#                              Force to read another line       MX91  32
IF((CHRIN(1^4)!='END ')&(CHREOF!=1))#  Next inpt line isn't end or eo   MX91  33
writefmt:(iofm1:,'(A)',CHRIP(1^80))#   Write header to file             MX91  34
closefmt:(iofm1:)#                     Close the file                   MX91  35
linestream:('MX0')#                                                     MX91  36
#                                                                       MX91  37
RETURN#                                                                 MX91  38
END#                                                                    MX91  39
systemheader:(MX04)#                                                    MX04   1
####################################################################    MX04   2
#                                                                  #    MX04   3
#                             MX04                                 #    MX04   4
#                                                                  #    MX04   5
####################################################################    MX04   6
# FUDGE TO EXTRACT DOUBLES FROM THE REAL QX ARRAY                       MX04   7
SUBROUTINE MX04(IDUB,OFLT)#                                             MX04   8
double: IDUB#                                                           MX04   9
REAL    OFLT#                                                           MX04  10
OFLT=sg:(IDUB)#                                                         MX04  11
RETURN#                                                                 MX04  12
END#                                                                    MX04  13
pmacro:([no:])##                                                        MX04  14
