systemheader:(NC    )#                                                  NC     1
####################################################################### NC     2
##      Copyright (C) 2000, The Xtal System, The University of        # NC     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # NC     4
## Distributed under the GNU General Public Licence as published by   # NC     5
## the Free Software Foundation, in the hope that it will be useful   # NC     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # NC     7
## for more details.                                                  # NC     8
##                                                                    # NC     9
##                          *** NEWCEL ***                            # NC    10
##                                                                    # NC    11
##   NEWCEL undertakes the transformation of information in the bdf   # NC    12
##   due to a change in the basis vectors of the direct cell.         # NC    13
##                                                                    # NC    14
####################################################################### NC    15
#                                      H.d. flack july 1991             NC    16
#                                                                       NC    17
include:(XMACRO)#                                                       NC    18
#                                                                       NC    19
extrude:(NCCOMN)#                                                       NC    20
REAL    CELLO(9)#                      Old direct cell parameters       NC    21
REAL    CELLN(9)#                      New direct cell parameters       NC    22
REAL    CELLOE(9)#                     Old direct cell esd's            NC    23
REAL    CELLOR(9)#                     Old recipr cell parameters       NC    24
REAL    CELLNE(9)#                     New direct cell esd's            NC    25
REAL    CENTR(3)#                      Old centring vector              NC    26
REAL    DET#                           Determinant of transformation    NC    27
REAL    DM(9)#                         New direct space metric tensor   NC    28
REAL    HKL(3)#                        Unpacked h,k,l                   NC    29
INTEGER GOOD#                          Keep/don't these reflection in   NC    30
INTEGER ICNT#                          Centrosymmetry non=0, cen=1      NC    31
INTEGER IP#                            Packet address                   NC    32
INTEGER IR(801)#                       Packet pointers for bdf          NC    33
INTEGER ISTOP#                         Stop of current memory           NC    34
INTEGER IWANT(800)#                    Wanted items from bdf            NC    35
INTEGER LATCON#                        Dont/do run latcon               NC    36
INTEGER KEY(4)#                        Index packet key                 NC    37
INTEGER MARK2#                         Region for symmetry storage      NC    38
INTEGER MAXHKL(3)#                     Maximum values of hkl            NC    39
INTEGER MINHKL(3)#                     Minimum values of hkl            NC    40
INTEGER NSYM#                          Total number of symmetry opera   NC    41
INTEGER OPP#                           Output packet pointers           NC    42
REAL    PSICR#                         Azimuthal angle                  NC    43
INTEGER PSIZE#                         Packet size for lrrefl:          NC    44
INTEGER REMOVE#                        Stop on/remove non-integer ind   NC    45
REAL    RM(9)#                         Reciprocal metric tensor         NC    46
REAL    SCELL(9)#                      Miscellaneous info               NC    47
INTEGER STEP2#                         Items per symmetry operation     NC    48
INTEGER STOP2#                         End of symmetry                  NC    49
REAL    TM(9)#                         Transformation matrix            NC    50
REAL    TMI(9)#                        Inverse of tm                    NC    51
REAL    VOL#                           Volume of new cell               NC    52
INTEGER XENTR(6)#                      Centring test vector             NC    53
#                                                                       NC    54
COMMON/COMINC/GOOD,ICNT,IP,IR,ISTOP,IWANT,KEY,LATCON,MARK2,#            NC    55
MAXHKL,MINHKL,NSYM,OPP,PSIZE,REMOVE,STEP2,STOP2,XENTR#                  NC    56
COMMON/COMFNC/CELLO,CELLN,CELLOE,CELLOR,CELLNE,CENTR,DET,DM,#           NC    57
HKL,PSICR,RM,SCELL,TM,TMI,VOL#                                          NC    58
#                                                                       NC    59
endext:#                                                                NC    60
#                                                                       NC    61
systemheader:(NC00)#                                                    NC00   1
#*********************************************************************# NC00   2
#                                                                     # NC00   3
#                                NC00                                 # NC00   4
#                                                                     # NC00   5
#*********************************************************************# NC00   6
SUBROUTINE NC00#                                                        NC00   7
include:(AACOMN)#                                                       NC00   8
include:(NCCOMN)#                      H.d.flack july 1991              NC00   9
#                                                                       NC00  10
CALL NC10#                             Process input lines              NC00  11
CALL NC20#                             Transformation part 1            NC00  12
CALL NC30#                             Transformation part 2            NC00  13
CALL NC40#                             Transformation second pass       NC00  14
CALL NC50#                             Force automatic sx/ad            NC00  15
#                                                                       NC00  16
RETURN#                                                                 NC00  17
END#                                                                    NC00  18
systemheader:(NC10)#                   Process the input lines          NC10   1
#********************************************************************** NC10   2
#                                                                       NC10   3
#                                NC10                                   NC10   4
#                                                                       NC10   5
#********************************************************************** NC10   6
SUBROUTINE NC10#                                                        NC10   7
include:(AACOMN)#                                                       NC10   8
include:(NCCOMN)#                      H.d. flack july 1991             NC10   9
#                                                                       NC10  10
INTEGER CLEF,I,J,K#                                                     NC10  11
#                                                                       NC10  12
chardata:(NC101, END   TRANSF  )#                                       NC10  13
chardata:(NC102," Direct axis transformation matrix: ")#                NC10  14
chardata:(NC103,"[ New a = (        ,         ,         ) a ]")#        NC10  15
chardata:(NC104,"abc")#                                                 NC10  16
chardata:(NC105,"[ Determinant =           ]")#                         NC10  17
chardata:(NC106, REMV )#                                                NC10  18
realdata:(FMT,[180842.,280842.,380842.])#                               NC10  19
datastuff:#                                                             NC10  20
#                                                                       NC10  21
#                                                                       NC10  22
# SET DEFAULT OPTIONS                                                   NC10  23
# -------------------                                                   NC10  24
#                                                                       NC10  25
DO I=1,3; MAXHKL(I)=-9999#             Maximum values of hkl            NC10  26
DO I=1,3; MINHKL(I)=+9999#             Minimum values of hkl            NC10  27
DO I=1,9; TM(I)=0.0#                   Default transformation matrix    NC10  28
TM(1)=1.0;TM(5)=1.0;TM(9)=1.0#                                          NC10  29
REMOVE=no:#                            Stop on non-integer indices      NC10  30
#                                                                       NC10  31
#    LOOP OVER NEWCEL FIELDS                                            NC10  32
#    -----------------------                                            NC10  33
#                                                                       NC10  34
FOR(K=1;K<=mxfdim:;K=K+1)#             Loop over newcel line fields     NC10  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NC10  36
ifvo:(BUFIN(K)) BREAK#                 Quit on first void field         NC10  37
IF (BUFIN(K)>voidflg:) NEXT#           Check for alphabetics            NC10  38
stringlim:(K,I,J)#                     Get limits of character field    NC10  39
compchar:(CHRIN,I,NC106,2,4,5,NNC106,CLEF)# Identify key                NC10  40
IF(CLEF==0) iquit:(NC1003,K)#          Unrecognizable input field       NC10  41
ELSE IF(CLEF==1) REMOVE=yes:#          Data set number                  NC10  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NC10  43
#                                                                       NC10  44
# READ INPUT LINES                                                      NC10  45
# ----------------                                                      NC10  46
#                                                                       NC10  47
REPEAT#                                Loop over input lines            NC10  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NC10  49
readline:(NC101,NNC101)#               Read the next input line         NC10  50
IF(LINID==1) BREAK#                    Exit end                         NC10  51
ELSEIF(LINID==2)#                                                       NC10  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  NC10  53
DO I=1,9#                              Loop over fields                 NC10  54
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  NC10  55
ifnm:(BUFIN(I)) TM(I)=BUFIN(I)#        Numeric field                    NC10  56
ELSE iquit:(NC1001)#                   Bad field                        NC10  57
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  NC10  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  NC10  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NC10  60
#                                                                       NC10  61
#  DEAL WITH THE TRANSFORMATION MATRIX                                  NC10  62
#  ===================================                                  NC10  63
#                                                                       NC10  64
writeline:(1,NC102,NNC102,3,3)#                                         NC10  65
DO I=1,3#                                                               NC10  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  NC10  67
movechar:(NC104,I,NC103,6,1,0)#        Insert abc                       NC10  68
movechar:(NC104,I,NC103,41,1,0)#       Insert abc                       NC10  69
ncodefld:(TM(3*I-2),1,NC103,FMT,3)#    Transformation terms             NC10  70
writeline:(0,NC103,NNC103,3,3)#                                         NC10  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  NC10  72
TMI(1) = +TM(5)*TM(9) - TM(8)*TM(6)#   Get tm**-1                       NC10  73
TMI(4) = -TM(4)*TM(9) + TM(7)*TM(6)#                                    NC10  74
TMI(7) = +TM(4)*TM(8) - TM(7)*TM(5)#                                    NC10  75
DET=TM(1)*TMI(1)+TM(2)*TMI(4)+TM(3)*TMI(7)#                             NC10  76
ncodefld:(DET,1,NC105,250742.,1)#      Format the determinant           NC10  77
writeline:(0,NC105,NNC105,3,3)#                                         NC10  78
ifeq:(DET,0.0) iquit:(NC1002)#         Die if singular                  NC10  79
IF(DET<0.0)#                           Make determinant positive        NC10  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  NC10  81
DET=ABS(DET)#                                                           NC10  82
DO I=1,9; TM(I)=-TM(I)#                                                 NC10  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  NC10  84
TMI(1) = TMI(1)/DET#                                                    NC10  85
TMI(4) = TMI(4)/DET#                                                    NC10  86
TMI(7) = TMI(7)/DET#                                                    NC10  87
TMI(2) = (-TM(2)*TM(9) + TM(8)*TM(3))/DET#                              NC10  88
TMI(5) = (+TM(1)*TM(9) - TM(7)*TM(3))/DET#                              NC10  89
TMI(8) = (-TM(1)*TM(8) + TM(7)*TM(2))/DET#                              NC10  90
TMI(3) = (+TM(2)*TM(6) - TM(5)*TM(3))/DET#                              NC10  91
TMI(6) = (-TM(1)*TM(6) + TM(4)*TM(3))/DET#                              NC10  92
TMI(9) = (+TM(1)*TM(5) - TM(4)*TM(2))/DET#                              NC10  93
#                                                                       NC10  94
RETURN#                                                                 NC10  95
END#                                                                    NC10  96
systemheader:(NC20)#                   Treat bdf lrhist: to lrdset:     NC20   1
#********************************************************************** NC20   2
#                                                                       NC20   3
#                                NC20                                   NC20   4
#                                                                       NC20   5
#********************************************************************** NC20   6
SUBROUTINE NC20#                       H.d.flack july 1990              NC20   7
include:(AACOMN)#                                                       NC20   8
include:(NCCOMN)#                                                       NC20   9
#                                                                       NC20  10
INTEGER LTYP#                          Lattice code                     NC20  11
INTEGER LTYPN#                         New lattice code                 NC20  12
INTEGER I,J,K#                         Odd temporary variables          NC20  13
INTEGER II,JJ,JP,NROT#                 Odd counters/pointers            NC20  14
#                                                                       NC20  15
realdata:(TR11,[0.,.5,.6666667,0.,0.,.5,.5])#                           NC20  16
realdata:(TR12,[0.,.5,.3333333,.5,.5,0.,.5])#                           NC20  17
realdata:(TR13,[0.,.5,.3333333,.5,.5,.5,0.])#                           NC20  18
realdata:(TR21,[.3333333,.5])#                                          NC20  19
realdata:(TR22,[.6666667,0.])#                                          NC20  20
realdata:(TR23,[.6666667,.5])#                                          NC20  21
datastuff:#                                                             NC20  22
#                                                                       NC20  23
# SET UP I/O BUFFER FOR BDF AND ASK FOR MEMORY                          NC20  24
# --------------------------------------------                          NC20  25
#                                                                       NC20  26
IOMARK(1)=QXSTR#                       Save buffer for input bdf        NC20  27
IOMARK(2)=IOMARK(1)+bdfbuf:#           Save buffer for output bdf       NC20  28
incrqx:(ISTOP,IOMARK(2)+bdfbuf:,NC2001)# Mark end of current mem        NC20  29
#                                                                       NC20  30
copyfile:(1,2,lrhist:,decr:(lrcell:))# Start up the bdf copy            NC20  31
#                                                                       NC20  32
#   TREAT LRCELL:                                                       NC20  33
# ---------------                                                       NC20  34
#                                                                       NC20  35
DO I=1,8#                              Read lrcell: packets             NC20  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NC20  37
readwpkt:(1,lrcell:,PSIZE,IP,0)#       Read packet                      NC20  38
IF(IP<=0) BREAK#                       Break at end of lrcell:          NC20  39
IF(I==1) movereal:(QX,IP+1,CELLO,1,9,0)# Direct cell parameters         NC20  40
ELSE IF(I==2) movereal:(QX,IP+1,CELLOE,1,9,0)# Esd direct cell parame   NC20  41
ELSE IF(I==3) movereal:(QX,IP+1,CELLOR,1,9,0)# Recipr. cell parameter   NC20  42
ELSE IF(I==6) movereal:(QX,IP+1,SCELL,1,9,0)# Miscellaneous info pack   NC20  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NC20  44
CALL NC25(yes:)#                       Transform the cell parameters    NC20  45
#                                      Keeping real and recip metric    NC20  46
DO I=1,8#                              Write lrcell: packets            NC20  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NC20  48
writepkt:(2,lrcell:,PSIZE,JP)#         Write packet                     NC20  49
IF(I==1) movereal:(CELLN,1,QX,JP+1,9,0)# Direct cell parameters         NC20  50
ELSE IF(I==2) movereal:(CELLNE,1,QX,JP+1,9,0)# Esd direct cell parame   NC20  51
ELSE IF(I==3) movereal:(voidflg:,1,QX,JP+1,9,2)# Reciprocal cell para   NC20  52
ELSE IF(I==4) movereal:(voidflg:,1,QX,JP+1,9,2)# Orthogonal coordinat   NC20  53
ELSE IF(I==5) movereal:(voidflg:,1,QX,JP+1,9,2)# Orthogonal hkl         NC20  54
ELSE IF(I==6) movereal:(SCELL,1,QX,JP+1,9,0)# Miscellaneous info        NC20  55
ELSE IF(I==7) movereal:(DM,1,QX,JP+1,9,0)# Metric tensor packet         NC20  56
ELSE IF(I==8) movereal:(RM,1,QX,JP+1,9,0)# Inverse metric tenso         NC20  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NC20  58
#                                                                       NC20  59
#   TREAT LRSYMM:                                                       NC20  60
#  --------------                                                       NC20  61
#                                                                       NC20  62
MARK2=ISTOP;STEP2=12#                  Pick up current end of mem       NC20  63
readwpkt:(1,lrsymm:,PSIZE,IP,0)#       Read packet                      NC20  64
IF(IP<=0) iquit:(NC2002)#              Quit if pkt not there            NC20  65
writepkt:(2,lrsymm:,PSIZE,OPP)#        Output 1st lrsymm: packet        NC20  66
movereal:(QX,IP+1,QX,OPP+1,STEP2,1)#   Copy 1st packet                  NC20  67
ICNT=1-NINT(QX(IP+2))#                 Centrosymmetry n=0   c=1         NC20  68
LTYP=NINT(QX(IP+1))-7*ICNT#            Lattice code                     NC20  69
NSYM=NINT(QX(IP+3))#                   Total symmetry matrices          NC20  70
NROT=NINT(QX(IP+4))*STEP2#             Limit of rotation matrices       NC20  71
#                                                                       NC20  72
#     DETERMINE NEW CENTRING MODE                                       NC20  73
#     ---------------------------                                       NC20  74
#                                                                       NC20  75
DO J=1,6; XENTR(J)=no:#                Test vector of centring hits     NC20  76
CENTR(1)=TR11(LTYP)#                   Transfer t1                      NC20  77
CENTR(2)=TR12(LTYP)#                   Transfer t2                      NC20  78
CENTR(3)=TR13(LTYP)#                   Transfer t3                      NC20  79
CALL NC26#                             Calculate and test               NC20  80
IF((LTYP==3)\(LTYP==4))#               Do only r or f                   NC20  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  NC20  82
CENTR(1)=TR21(LTYP-2)#                 Transfer t1                      NC20  83
CENTR(2)=TR22(LTYP-2)#                 Transfer t2                      NC20  84
CENTR(3)=TR23(LTYP-2)#                 Transfer t3                      NC20  85
CALL NC26#                             Calculate and test               NC20  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  NC20  87
IF(LTYP==4)#                           3rd condition of f               NC20  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  NC20  89
CENTR(1)=TR11(7)#                      Transfer t1                      NC20  90
CENTR(2)=TR12(7)#                      Transfer t2                      NC20  91
CENTR(3)=TR13(7)#                      Transfer t3                      NC20  92
CALL NC26#                             Calculate and test               NC20  93
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  NC20  94
LTYPN=1; J=0#                          New cell primitive by default    NC20  95
DO I=1,6; J=J+XENTR(I)#                Count number of centring hits    NC20  96
IF((J==1)&(XENTR(1)==yes:))LTYPN=2#    I                                NC20  97
IF((J==1)&(XENTR(2)==yes:))LTYPN=5#    A                                NC20  98
IF((J==1)&(XENTR(3)==yes:))LTYPN=6#    B                                NC20  99
IF((J==1)&(XENTR(4)==yes:))LTYPN=7#    C                                NC20 100
IF((J==2)&(XENTR(5)==yes:)&(XENTR(6)==yes:))LTYPN=3# R                  NC20 101
IF((J==3)&(XENTR(2)==yes:)&(XENTR(3)==yes:)&(XENTR(4)==yes:))LTYPN=4#   NC20 102
QX(OPP+1)=REAL(LTYPN+7*ICNT)#          New lattice code                 NC20 103
#                                                                       NC20 104
# GET SYMMETRY EQUIVALENT POSITIONS                                     NC20 105
# ---------------------------------                                     NC20 106
#                                                                       NC20 107
incrqx:(STOP2,MARK2+NSYM*STEP2,RF2003)# Request memory all symops       NC20 108
JJ=MARK2+NROT#                         Limit of rotation matrices       NC20 109
FOR(II=MARK2;II<JJ;II=II+STEP2)#       Loop over symmetry matrices      NC20 110
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  NC20 111
readwpkt:(1,lrsymm:,PSIZE,IP,0)#       Read packet                      NC20 112
IF(IP<=0) BREAK#                       Break at end                     NC20 113
writepkt:(2,lrsymm:,PSIZE,OPP)#        Output lrsymm: packet            NC20 114
movereal:(QX,IP+1,QX,OPP+1,STEP2,1)#   Transfer packet to output        NC20 115
CALL NC27(OPP+1)#                      Transform output element         NC20 116
movereal:(QX,IP+1,QX,II+1,STEP2,1)#    Transfer packet                  NC20 117
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  NC20 118
IF(ICNT==1)#                           If centrosymmetric               NC20 119
DO I=1,NROT; QX(JJ+I)=-QX(MARK2+I)#    Store inverse matrix             NC20 120
#                                                                       NC20 121
#     EXPAND SYMOP TABLE FOR CENTRING                                   NC20 122
#     -------------------------------                                   NC20 123
#                                                                       NC20 124
II=JJ+ICNT*NROT; ISTOP=II#             Store primitive marker           NC20 125
IF(LTYP>1)#                            Test if sg centered              NC20 126
FOR(J=MARK2;J<ISTOP;J=J+STEP2)#        Loop over symm matrices          NC20 127
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  NC20 128
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            NC20 129
QX(II+10)=QX(J+10)+TR11(LTYP)#         Transfer t1                      NC20 130
QX(II+11)=QX(J+11)+TR12(LTYP)#         Transfer t2                      NC20 131
QX(II+12)=QX(J+12)+TR13(LTYP)#         Transfer t3                      NC20 132
II=II+STEP2#                           Incr storage pointer             NC20 133
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               NC20 134
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            NC20 135
QX(II+10)=QX(J+10)+TR21(LTYP-2)#       Transfer t1                      NC20 136
QX(II+11)=QX(J+11)+TR22(LTYP-2)#       Transfer t2                      NC20 137
QX(II+12)=QX(J+12)+TR23(LTYP-2)#       Transfer t3                      NC20 138
II=II+STEP2#                           Incr storage pointer             NC20 139
IF(LTYP!=4) NEXT#                      Skip if not f-centre             NC20 140
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            NC20 141
QX(II+10)=QX(J+10)+0.5#                Transfer t1                      NC20 142
QX(II+11)=QX(J+11)+0.5#                Transfer t2                      NC20 143
QX(II+12)=QX(J+12)+0.0#                Transfer t3                      NC20 144
II=II+STEP2#                           Incr storage pointer             NC20 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  NC20 146
FOR(J=MARK2;J<STOP2;J=J+STEP2)#        Loop over all symm matrices      NC20 147
CALL NC27(J+1)#                        Transform the stored symmetry    NC20 148
ISTOP=STOP2#                           Current end of memory            NC20 149
#                                                                       NC20 150
#   TREAT LRSGNM:                                                       NC20 151
#   -------------                                                       NC20 152
#                                                                       NC20 153
# DON'T COPY IT ACROSS AS THE SYMBOL MIGHT NOW BE WRONG                 NC20 154
#                                                                       NC20 155
#   TREAT LRSCAT:                                                       NC20 156
#   -------------                                                       NC20 157
#                                                                       NC20 158
KEY(1)=0;KEY(2)=1;KEY(3)=0;KEY(4)=0#   Directory packet setup           NC20 159
IWANT(1)=1#                            Number of atoms per cell         NC20 160
indexpkt:(1,lrscat:,PSIZE,IP,2,KEY,IWANT,IR)#                           NC20 161
REPEAT#                                Loop over packets                NC20 162
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  NC20 163
readwpkt:(1,lrscat:,PSIZE,IP,0)#       Read and stop at end             NC20 164
IF(IP<=0)BREAK#                                                         NC20 165
writepkt:(2,lrscat:,PSIZE,OPP)#        Output packet                    NC20 166
movereal:(QX,IP+1,QX,OPP+1,PSIZE,1)#   Copy across                      NC20 167
IF(IR(1)>0) ifnm:(QX(IP+IR(1)))#                                        NC20 168
QX(OPP+IR(1)) = DET*QX(IP+IR(1))#      Up the number of atoms per cel   NC20 169
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  NC20 170
copyfile:(1,2,incr:(lrscat:),decr:(lrexpl:))# Copy across               NC20 171
#                                                                       NC20 172
#    TREAT LREXPL:                                                      NC20 173
#    ------------                                                       NC20 174
#                                                                       NC20 175
KEY(1)=0;KEY(2)=197;KEY(3)=0;KEY(4)=0# Directory packet setup           NC20 176
DO I=1,17 ; IWANT(I)=12+I#             Cell dimensions of data set      NC20 177
DO I=1,30#                                                              NC20 178
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  NC20 179
DO K=1,3; IWANT(3*I+K+14)=290+10*I+K#  Hkl of 30 faces                  NC20 180
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  NC20 181
DO I=1,90 ; IWANT(I+107)=609+I#        Hkl of 30 reference reflection   NC20 182
indexpkt:(1,lrexpl:,PSIZE,IP,2,KEY,IWANT,IR)#                           NC20 183
PSICR=voidflg:#                        No need for azimuth              NC20 184
REPEAT#                                Loop over packets                NC20 185
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  NC20 186
readwpkt:(1,lrexpl:,PSIZE,IP,0)#       Read and stop at end             NC20 187
IF(IP<=0)BREAK#                                                         NC20 188
writepkt:(2,lrexpl:,PSIZE,OPP)#        Output packet                    NC20 189
movereal:(QX,IP+1,QX,OPP+1,PSIZE,1)#   Copy across                      NC20 190
#                                      Treat cell dimensions            NC20 191
DO I=1,9; IF(IR(I)>0) movereal:(QX,IP+IR(I),CELLO,I,1,0)# Get cell di   NC20 192
DO I=11,13; IF(IR(I)>0) movereal:(QX,IP+IR(I),CELLOE,I-10,1,0)# Esd a   NC20 193
DO I=14,16; IF(IR(I)>0) movereal:(QX,IP+IR(I),CELLOE,I-7,1,0)# Esd an   NC20 194
IF(IR(10)>0) movereal:(QX,IP+IR(10),SCELL,1,1,0)# Volume                NC20 195
IF(IR(17)>0) movereal:(QX,IP+IR(17),SCELL,2,1,0)# Esd volume            NC20 196
CALL NC25(no:)#                        Convert - don't keep these met   NC20 197
DO I=1,9; IF(IR(I)>0) movereal:(CELLN,I,QX,OPP+IR(I),1,0)# Put cell d   NC20 198
DO I=11,13; IF(IR(I)>0) movereal:(CELLNE,I-10,QX,OPP+IR(I),1,0)# Esd    NC20 199
DO I=14,16; IF(IR(I)>0) movereal:(CELLNE,I-7,QX,OPP+IR(I),1,0)# Esd a   NC20 200
IF(IR(10)>0) movereal:(SCELL,1,QX,OPP+IR(10),1,0)# Volume               NC20 201
IF(IR(17)>0) movereal:(SCELL,2,QX,OPP+IR(17),1,0)# Esd volume           NC20 202
DO J=1,30#                             Crystal faces                    NC20 203
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 NC20 204
IF(IR(3*J+15)<=0) BREAK#               Stop if no more faces            NC20 205
DO K=1,3;HKL(K)=QX(IP+IR(3*J+K+14))#   Fetch indices                    NC20 206
CALL NC35#                             Transform the hkl                NC20 207
DO K=1,3;QX(OPP+IR(3*J+K+14))=HKL(K)#  Store indices                    NC20 208
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 NC20 209
DO J=1,30#                             Standard reflections             NC20 210
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 NC20 211
IF(IR(3*J+105)<=0) BREAK#              Stop if no more standards        NC20 212
DO K=1,3;HKL(K)=QX(IP+IR(3*J+K+104))#  Fetch indices                    NC20 213
CALL NC35#                             Transform the hkl                NC20 214
DO K=1,3;QX(OPP+IR(3*J+K+104))=HKL(K)# Store indices                    NC20 215
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 NC20 216
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  NC20 217
copyfile:(1,2,incr:(lrexpl:),decr:(lratom:))# Copy across               NC20 218
#                                                                       NC20 219
RETURN#                                                                 NC20 220
END#                                                                    NC20 221
systemheader:(NC25)#                   Convert cell dimensions          NC25   1
#********************************************************************** NC25   2
#                                                                       NC25   3
#                                NC25                                   NC25   4
#                                                                       NC25   5
#********************************************************************** NC25   6
SUBROUTINE NC25(SWITCH)#               H.d. flack july 1991             NC25   7
#                                                                       NC25   8
include:(AACOMN)#                                                       NC25   9
include:(NCCOMN)#                                                       NC25  10
#                                                                       NC25  11
INTEGER  SWITCH#                       Yes:/no: keep & calc dm & rm     NC25  12
REAL     DA(9)#                        Old metric tensor                NC25  13
REAL     DN(9)#                        New metric tensor                NC25  14
INTEGER  J,K,L,II,IL#                                                   NC25  15
realdata:(TWOPI,6.283185308)#                                           NC25  16
datastuff:#                                                             NC25  17
#                                                                       NC25  18
DO J=1,3; CELLO(J+3)=COS(TWOPI*CELLO(J+6))# Convert angles to cos       NC25  19
DA(1)=CELLO(1)**2;DA(5)=CELLO(2)**2;DA(9)=CELLO(3)**2# Diagonal term    NC25  20
DA(2)=CELLO(1)*CELLO(2)*CELLO(6);DA(4)=DA(2)# G12                       NC25  21
DA(3)=CELLO(1)*CELLO(3)*CELLO(5);DA(7)=DA(3)# G13                       NC25  22
DA(6)=CELLO(2)*CELLO(3)*CELLO(4);DA(8)=DA(6)# G23                       NC25  23
DO II=1,3#                             Gnew = t*g*t(transposed)         NC25  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NC25  25
DO L=1,3#                                                               NC25  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NC25  27
IL=3*II+L-3;DN(IL)=0.0#                Zeroise term                     NC25  28
DO J=1,3; DO K=1,3#                    Two inner loops                  NC25  29
DN(IL)=DN(IL)+TM(3*II+J-3)*TM(3*L+K-3)*DA(3*J+K-3)#                     NC25  30
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NC25  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NC25  32
CELLN(1)=SQRT(DN(1));CELLN(2)=SQRT(DN(5))# Get new a and b              NC25  33
CELLN(3)=SQRT(DN(9))#                  Get new c                        NC25  34
CELLN(4)=DN(6)/(CELLN(2)*CELLN(3))#    New cos alpha                    NC25  35
CELLN(5)=DN(3)/(CELLN(1)*CELLN(3))#    New cos beta                     NC25  36
CELLN(6)=DN(2)/(CELLN(1)*CELLN(2))#    New cos gamma                    NC25  37
DO J=1,3; CELLN(J+6)=ACOS(CELLN(J+3))/TWOPI#                            NC25  38
DO J=1,9; CELLNE(J)=0.0001*CELLN(J)#   Default cell esd's               NC25  39
ifnm:(SCELL(1))SCELL(1)=DET*SCELL(1)#  Up the volume                    NC25  40
ifnm:(SCELL(2))SCELL(2)=DET*SCELL(2)#  Up the esd volume                NC25  41
IF(SWITCH==yes:)#                      Keep dm and rm                   NC25  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  NC25  43
movereal:(DN,1,DM,1,9,0)#              Copy dn into dm                  NC25  44
RM(1) = +DM(5)*DM(9) - DM(8)*DM(6)#    Get dm**-1 = rm                  NC25  45
RM(4) = -DM(4)*DM(9) + DM(7)*DM(6)#                                     NC25  46
RM(7) = +DM(4)*DM(8) - DM(7)*DM(5)#                                     NC25  47
VOL=DM(1)*RM(1)+DM(2)*RM(4)+DM(3)*RM(7)#                                NC25  48
RM(1) = RM(1)/VOL#                                                      NC25  49
RM(4) = RM(4)/VOL#                                                      NC25  50
RM(7) = RM(7)/VOL#                                                      NC25  51
RM(2) = RM(4)#                                                          NC25  52
RM(5) = (+DM(1)*DM(9) - DM(7)*DM(3))/VOL#                               NC25  53
RM(8) = (-DM(1)*DM(8) + DM(7)*DM(2))/VOL#                               NC25  54
RM(3) = RM(7)#                                                          NC25  55
RM(6) = RM(8)#                                                          NC25  56
RM(9) = (+DM(1)*DM(5) - DM(4)*DM(2))/VOL#                               NC25  57
VOL=SQRT(VOL)#                                                          NC25  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  NC25  59
#                                                                       NC25  60
RETURN#                                                                 NC25  61
END#                                                                    NC25  62
systemheader:(NC26)#                   Test centring vector             NC26   1
#********************************************************************** NC26   2
#                                                                       NC26   3
#                                NC26                                   NC26   4
#                                                                       NC26   5
#********************************************************************** NC26   6
SUBROUTINE NC26#                       H.d. flack july 1991             NC26   7
#                                                                       NC26   8
include:(AACOMN)#                                                       NC26   9
include:(NCCOMN)#                                                       NC26  10
#                                                                       NC26  11
INTEGER I,J,K,L#                                                        NC26  12
REAL    OLDNOD(3)#                     Lattice node in old basis set    NC26  13
REAL    CENTRN(3)#                     New centring vector              NC26  14
realdata:(TR21,[.5,.0,.5,.5,.3333333,.6666667])#                        NC26  15
realdata:(TR22,[.5,.5,.0,.5,.6666667,.3333333])#                        NC26  16
realdata:(TR23,[.5,.5,.5,.0,.6666667,.3333333])#                        NC26  17
datastuff:#                                                             NC26  18
#                                                                       NC26  19
DO J=0,2#                              X component of node in old bas   NC26  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NC26  21
DO K=0,2#                              Y component of node in old bas   NC26  22
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NC26  23
DO L=0,2#                              Z component of node in old bas   NC26  24
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  NC26  25
OLDNOD(1) = CENTR(1) + REAL(J)#                                         NC26  26
OLDNOD(2) = CENTR(2) + REAL(K)#                                         NC26  27
OLDNOD(3) = CENTR(3) + REAL(L)#                                         NC26  28
CENTRN(1)=OLDNOD(1)*TMI(1)+OLDNOD(2)*TMI(4)+OLDNOD(3)*TMI(7)#           NC26  29
CENTRN(2)=OLDNOD(1)*TMI(2)+OLDNOD(2)*TMI(5)+OLDNOD(3)*TMI(8)#           NC26  30
CENTRN(3)=OLDNOD(1)*TMI(3)+OLDNOD(2)*TMI(6)+OLDNOD(3)*TMI(9)#           NC26  31
DO I=1,3; CENTRN(I)=AMOD((20.0+CENTRN(I)),1.0)#                         NC26  32
DO I=1,6#                                                               NC26  33
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  NC26  34
ifeq:(CENTRN(1),TR21(I),0.0001) ifeq:(CENTRN(2),TR22(I),0.0001) $#      NC26  35
ifeq:(CENTRN(3),TR23(I),0.0001) XENTR(I)=yes:#                          NC26  36
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  NC26  37
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  NC26  38
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NC26  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NC26  40
#                                                                       NC26  41
RETURN#                                                                 NC26  42
END#                                                                    NC26  43
systemheader:(NC27)#                   Transform symmetry element       NC27   1
#********************************************************************** NC27   2
#                                                                       NC27   3
#                                NC27                                   NC27   4
#                                                                       NC27   5
#********************************************************************** NC27   6
SUBROUTINE NC27(IPNT)#                 H.d. flack july 1991             NC27   7
#                                                                       NC27   8
include:(AACOMN)#                                                       NC27   9
include:(NCCOMN)#                                                       NC27  10
#                                                                       NC27  11
INTEGER IPNT#                          Pointer into qx of input symm    NC27  12
INTEGER I,J,K,L,IL#                                                     NC27  13
REAL    SYMOLD(12)#                    Save vector for input symm op    NC27  14
REAL    SYMNEW(12)#                    Vector for new symm op           NC27  15
#                                                                       NC27  16
movereal:(QX,IPNT,SYMOLD,1,12,0)#      Keep input symm op               NC27  17
DO I=1,3#                              Snew(tp)= t*sold(tp)*(t**-1)     NC27  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NC27  19
DO L=1,3#                                                               NC27  20
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NC27  21
IL=3*I+L-3;SYMNEW(IL)=0.0#             Zeroise term                     NC27  22
DO J=1,3; DO K=1,3#                    Two inner loops                  NC27  23
SYMNEW(IL)=SYMNEW(IL)+TM(3*I+J-3)*SYMOLD(3*J+K-3)*TMI(3*K+L-3)#         NC27  24
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NC27  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NC27  26
SYMNEW(10)=SYMOLD(10)*TMI(1)+SYMOLD(11)*TMI(4)+SYMOLD(12)*TMI(7)# Get   NC27  27
SYMNEW(11)=SYMOLD(10)*TMI(2)+SYMOLD(11)*TMI(5)+SYMOLD(12)*TMI(8)#       NC27  28
SYMNEW(12)=SYMOLD(10)*TMI(3)+SYMOLD(11)*TMI(6)+SYMOLD(12)*TMI(9)#       NC27  29
DO I=10,12; SYMNEW(I)=AMOD(10.0+SYMNEW(I),1.0)#                         NC27  30
movereal:(SYMNEW,1,QX,IPNT,12,0)#      Save the result                  NC27  31
#                                                                       NC27  32
RETURN#                                                                 NC27  33
END#                                                                    NC27  34
systemheader:(NC30)#                   Read/write lrdict: to endrecor   NC30   1
#********************************************************************** NC30   2
#                                                                       NC30   3
#                                NC30                                   NC30   4
#                                                                       NC30   5
#********************************************************************** NC30   6
SUBROUTINE NC30#                       H.d. flack november 1990         NC30   7
include:(AACOMN)#                                                       NC30   8
include:(NCCOMN)#                                                       NC30   9
REAL    A,B,C,D,Q#                     Rotated h,k,l & shift            NC30  10
REAL    EMUL#                          Epsilon and multiplicity         NC30  11
INTEGER EPS#                           Augment to epsilon               NC30  12
INTEGER I,J,K,L,M,JJ,KK,IJK#           Pointers                         NC30  13
INTEGER MUL#                           Multiplicity                     NC30  14
REAL    PAKHKL#                        Packed hkl                       NC30  15
INTEGER PRC#                           Phase restriction code           NC30  16
REAL    X,Y,Z#                         Floated indices                  NC30  17
REAL    XO(3),XN(3)#                   Old and new coordinates          NC30  18
REAL    UOLD(3,3),UNEW(3,3)#           Old and new uij                  NC30  19
#                                                                       NC30  20
intdata:(JPR,[1,0,2,3,4,0,5,0,6,7,8,0])#                                NC30  21
realdata:(TWOPI,6.283185308)#                                           NC30  22
datastuff:#                                                             NC30  23
#                                                                       NC30  24
#    TREAT LRATOM:                                                      NC30  25
#    -------------                                                      NC30  26
#                                                                       NC30  27
KEY(1)=0;KEY(2)=10;KEY(3)=0;KEY(4)=0#  Directory packet setup           NC30  28
DO I=1,10; IWANT(I)=I#                 X,y,z,u and aniso u              NC30  29
indexpkt:(1,lratom:,PSIZE,IP,2,KEY,IWANT,IR)#                           NC30  30
REPEAT#                                Loop over packets                NC30  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NC30  32
readwpkt:(1,lratom:,PSIZE,IP,0)#       Read and stop at end             NC30  33
IF(IP<=0)BREAK#                                                         NC30  34
writepkt:(2,lratom:,PSIZE,OPP)#        Output packet                    NC30  35
movereal:(QX,IP+1,QX,OPP+1,PSIZE,1)#   Copy across                      NC30  36
IF(IR(1)>0)#                           Transform coordinates            NC30  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NC30  38
DO I=1,3; movereal:(QX,IP+IR(I),XO,I,1,0)# Get old x,y,z                NC30  39
DO I=1,3#                                                               NC30  40
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  NC30  41
XN(I)=0.0#                                                              NC30  42
DO J=1,3; XN(I)=XN(I)+TMI(3*J+I-3)*XO(J)#                               NC30  43
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  NC30  44
DO I=1,3; movereal:(XN,I,QX,OPP+IR(I),1,0)# Put new x,y,z               NC30  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NC30  46
IF(IR(5)>0)#                           Transform aniso uij              NC30  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  NC30  48
Q=.5*TWOPI*TWOPI#                                                       NC30  49
DO I=1,3; UOLD(I,I)=QX(IP+IR(I+4))#    Get diagonal terms               NC30  50
UOLD(1,2)=QX(IP+IR(8));UOLD(2,1)=UOLD(1,2)#                             NC30  51
UOLD(1,3)=QX(IP+IR(9));UOLD(3,1)=UOLD(1,3)#                             NC30  52
UOLD(2,3)=QX(IP+IR(10));UOLD(3,2)=UOLD(2,3)#                            NC30  53
DO I=1,3;DO J=1,3; UOLD(I,J)=Q*UOLD(I,J)*CELLOR(I)*CELLOR(J)#           NC30  54
DO I=1,3#                              Unew = (t**-1)tp*u*(t**-1)       NC30  55
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  NC30  56
DO L=1,3#                                                               NC30  57
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  NC30  58
UNEW(I,L)=0.0#                         Zeroise term                     NC30  59
DO J=1,3; DO K=1,3#                    Two inner loops                  NC30  60
UNEW(I,L)=UNEW(I,L)+UOLD(J,K)*TMI(3*J+I-3)*TMI(3*K+L-3)#                NC30  61
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  NC30  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  NC30  63
DO I=1,3; QX(OPP+IR(I+4))=UNEW(I,I)#   Get diagonal terms               NC30  64
QX(OPP+IR(8))=UNEW(1,2)#                                                NC30  65
QX(OPP+IR(9))=UNEW(1,3)#                                                NC30  66
QX(OPP+IR(10))=UNEW(2,3)#                                               NC30  67
QX(OPP+IR(5))=QX(OPP+IR(5))/(Q*RM(1))#                                  NC30  68
QX(OPP+IR(6))=QX(OPP+IR(6))/(Q*RM(5))#                                  NC30  69
QX(OPP+IR(7))=QX(OPP+IR(7))/(Q*RM(9))#                                  NC30  70
QX(OPP+IR(8))=QX(OPP+IR(8))/(Q*SQRT(RM(1)*RM(5)))#                      NC30  71
QX(OPP+IR(9))=QX(OPP+IR(9))/(Q*SQRT(RM(1)*RM(9)))#                      NC30  72
QX(OPP+IR(10))=QX(OPP+IR(10))/(Q*SQRT(RM(5)*RM(9)))#                    NC30  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  NC30  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NC30  75
#                                                                       NC30  76
#    TREAT LRCONS:                                                      NC30  77
#    -------------                                                      NC30  78
#    LRCONS: IS ACHIEVED BY AN AUTOMATIC RUN OF STARTX AND ADDATM       NC30  79
copyfile:(1,2,incr:(lratom:),decr:(lrrefl:))# Copy across               NC30  80
#                                                                       NC30  81
#    TREAT LRREFL:                                                      NC30  82
#    -------------                                                      NC30  83
#                                                                       NC30  84
KEY(1)=0;KEY(2)=27;KEY(3)=0;KEY(4)=0#  Directory packet setup           NC30  85
IWANT(1)=1;IWANT(2)=3#                 Hkl, reflection symmetry         NC30  86
DO I=1,25; IWANT(I+2)=1000*I+11#       Azimuth for 25 data sets         NC30  87
indexpkt:(1,lrrefl:,PSIZE,IP,2,KEY,IWANT,IR)# Directory flags           NC30  88
#                                                                       NC30  89
#  LOOP OVER ALL REFLECTIONS                                            NC30  90
#  -------------------------                                            NC30  91
#                                                                       NC30  92
REPEAT#                                Loop over all data               NC30  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  NC30  94
readwpkt:(1,lrrefl:,PSIZE,IP,0)#       Read index record                NC30  95
IF(IP<=0) BREAK#                       Quit when done                   NC30  96
#                                                                       NC30  97
# PROCESS HKL INDICES                                                   NC30  98
# -------------------                                                   NC30  99
#                                                                       NC30 100
IF(IR(1)<=0)NEXT#                      No indices - no transformation   NC30 101
gethkl:(IP+IR(1),HKL);PSICR=voidflg:#  Unpack hkl, dummy azimuth        NC30 102
CALL NC35#                             Transform hkls                   NC30 103
IF(GOOD==no:) NEXT#                    Don't output non-integer indic   NC30 104
writepkt:(2,lrrefl:,PSIZE,OPP)#        Output packet                    NC30 105
movereal:(QX,IP+1,QX,OPP+1,PSIZE,1)#   Copy across                      NC30 106
DO I=1,3#                              Get min/max values hkl           NC30 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  NC30 108
MINHKL(I)=MIN(NINT(HKL(I)),MINHKL(I))#                                  NC30 109
MAXHKL(I)=MAX(NINT(HKL(I)),MAXHKL(I))#                                  NC30 110
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  NC30 111
intpak:(0,PAKHKL,0,mxbtwd:)#           Clear to pack hkl                NC30 112
DO JJ=1,3#                             Loop over h,k,l                  NC30 113
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  NC30 114
IJK=NINT(HKL(4-JJ));KK=0#              Integerize and sign of index     NC30 115
IF(IJK<0)#                             Negative index                   NC30 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 NC30 117
IJK=-IJK;KK=1#                         Make index positive and note n   NC30 118
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 NC30 119
intpak:(KK,PAKHKL,JJ-1,1)#             Pack the sign                    NC30 120
intpak:(IJK,PAKHKL,(JJ-1)*9+3,9)#      Pack the index                   NC30 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  NC30 122
movepakwd:(PAKHKL,QX(OPP+IR(1)))#      Store packed hkl in bdf          NC30 123
#                                                                       NC30 124
# DO EPSILON AND MULTIPLICITY                                           NC30 125
# ---------------------------                                           NC30 126
#                                                                       NC30 127
IF(IR(2)>0)#                           Eps/mult present on input        NC30 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 NC30 129
MUL=0;   EPS=0;   PRC=ICNT#            Reset hkl mult/epsilon/prc       NC30 130
X=HKL(1);  Y=HKL(2);  Z=HKL(3)#        Get h k l                        NC30 131
FOR(K=MARK2;K<STOP2;K=K+STEP2)#        Loop over symmetry matrices      NC30 132
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 NC30 133
A=X*QX(K+1)+Y*QX(K+2)+Z*QX(K+3)#       Generate h'                      NC30 134
B=X*QX(K+4)+Y*QX(K+5)+Z*QX(K+6)#       Generate k'                      NC30 135
C=X*QX(K+7)+Y*QX(K+8)+Z*QX(K+9)#       Generate l'                      NC30 136
D=X*QX(K+10)+Y*QX(K+11)+Z*QX(K+12)#    Generate shift                   NC30 137
M=MOD(NINT(12.*D)+120,12)#             Ensure d in 12ths of 2pi         NC30 138
ifeq:(A,X) ifeq:(B,Y) ifeq:(C,Z)#      H=h', k=k', l=l'                 NC30 139
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 NC30 140
MUL=MUL+1#                             Count equiv hkl                  NC30 141
IF(M==0) EPS=EPS+1#                    Count reinforcement factor       NC30 142
NEXT#                                  Next eq pos                      NC30 143
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 NC30 144
ifeq:(A,-X) ifeq:(B,-Y) ifeq:(C,-Z)#   H=-h', k=-k', l=-l'              NC30 145
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 NC30 146
MUL=MUL+1#                             Incr multiplicity counter        NC30 147
IF(PRC==0) PRC=JPR(M+1)#               Store phase restriction code     NC30 148
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 NC30 149
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 NC30 150
MUL=NSYM/MUL#                          Calculate hkl multiplicity       NC30 151
intpak:(0,EMUL,0,mxbtwd:)#             Clear word                       NC30 152
intpak:(MUL,EMUL,0,5)#                 Pack multiplicity                NC30 153
intpak:(EPS,EMUL,5,7)#                 Pack epsilon                     NC30 154
intpak:(PRC,EMUL,12,4)#                Pack phase restriction code      NC30 155
movepakwd:(EMUL,QX(OPP+IR(2)))#        Store packed eps/mult in bdf     NC30 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 NC30 157
#                                                                       NC30 158
#  PROCESS AZIMUTHS                                                     NC30 159
#                                                                       NC30 160
DO K =1, 25#                           Transform azimuths of 25 data    NC30 161
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 NC30 162
gethkl:(IP+IR(1),HKL)#                 Unpack hkl                       NC30 163
IF(IR(K+2)<=0) NEXT#                   Do non void azimuths             NC30 164
PSICR=QX(IP+IR(K+2))#                  Get azimuth                      NC30 165
CALL NC35#                             Transform hkl and azimuth        NC30 166
QX(OPP+IR(K+2))=PSICR#                 Store azimuth                    NC30 167
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 NC30 168
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  NC30 169
#                                                                       NC30 170
#  TRANSFORM INDICES IN LRTHET:                                         NC30 171
#  ----------------------------                                         NC30 172
#                                                                       NC30 173
LATCON=no:#                            Don't run latcon                 NC30 174
REPEAT#                                Loop over all data               NC30 175
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 NC30 176
readwpkt:(1,lrthet:,PSIZE,IP,0)#       Read packet                      NC30 177
IF(IP<=0) BREAK#                       Quit when done                   NC30 178
writepkt:(2,lrthet:,PSIZE,OPP)#        Write packet                     NC30 179
movereal:(QX,IP+1,QX,OPP+1,PSIZE,1)#   Copy across                      NC30 180
HKL(1)=QX(IP+2);HKL(2)=QX(IP+3);HKL(3)=QX(IP+4)# Get indices            NC30 181
PSICR=voidflg:;CALL NC35#              Transform hkl and azimuth        NC30 182
QX(OPP+2)=HKL(1);QX(OPP+3)=HKL(2);QX(OPP+4)=HKL(3)# Output indices      NC30 183
LATCON=yes:#                           Angles present - force latcon    NC30 184
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 NC30 185
#                                                                       NC30 186
copyfile:(1,2,incr:(lrthet:),endrecord:)# Copy all the rest             NC30 187
#                                                                       NC30 188
RETURN#                                                                 NC30 189
END#                                                                    NC30 190
systemheader:(NC35)#                   Transform hkl and azimuth        NC35   1
#********************************************************************** NC35   2
#                                                                       NC35   3
#                                NC35                                   NC35   4
#                                                                       NC35   5
#********************************************************************** NC35   6
SUBROUTINE NC35#                       H.d. flack october 1991          NC35   7
include:(AACOMN)#                                                       NC35   8
include:(NCCOMN)#                                                       NC35   9
REAL    COSDPS#                        Proportional to cos(delpsi)      NC35  10
REAL    HKLO(3)#                       Untransformed hkl                NC35  11
REAL    ON(3)#                         O new                            NC35  12
REAL    UN(3)#                         U new                            NC35  13
REAL    UO(3)#                         U old                            NC35  14
REAL    VN(3)#                         V new                            NC35  15
REAL    PARLL#                         Scale vn to hn                   NC35  16
REAL    SINDPS#                        Proportional to sin(delpsi)      NC35  17
INTEGER I#                                                              NC35  18
#                                                                       NC35  19
DO I=1,3; HKLO(I)=HKL(I)#              Keep untransformed hkl           NC35  20
HKL(1)=HKLO(1)*TM(1)+HKLO(2)*TM(2)+HKLO(3)*TM(3)# Transformed h'        NC35  21
HKL(2)=HKLO(1)*TM(4)+HKLO(2)*TM(5)+HKLO(3)*TM(6)# Transformed k'        NC35  22
HKL(3)=HKLO(1)*TM(7)+HKLO(2)*TM(8)+HKLO(3)*TM(9)# Transformed l'        NC35  23
GOOD=yes:#                             Set default decent indices       NC35  24
DO I=1,3; ifne:(ABS(HKL(I)-ANINT(HKL(I))),0.0,0.02) GOOD=no:# Flag      NC35  25
IF((REMOVE==no:)&(GOOD==no:)) iquit:(NC3501)# Die on non-integer indi   NC35  26
ifnm:(PSICR)#                          Transform azimuths               NC35  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NC35  28
UO(1)=HKLO(2)-HKLO(3)#                 U old                            NC35  29
UO(2)=HKLO(3)-HKLO(1)#                 U old                            NC35  30
UO(3)=HKLO(1)-HKLO(2)#                 U old                            NC35  31
ifeq:(UO(1),0.0) ifeq:(UO(2),0.0) ifeq:(UO(3),0.0)# Is it 0,0,0         NC35  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NC35  33
UO(1)=HKLO(1);UO(2)=-HKLO(1);UO(3)=0.0# Set special case                NC35  34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NC35  35
UN(1)=HKL(2)-HKL(3)#                   U new                            NC35  36
UN(2)=HKL(3)-HKL(1)#                   U new                            NC35  37
UN(3)=HKL(1)-HKL(2)#                   U new                            NC35  38
ifeq:(UN(1),0.0) ifeq:(UN(2),0.0) ifeq:(UN(3),0.0)# Is it 0,0,0         NC35  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  NC35  40
UN(1)=HKL(1);UN(2)=-HKL(1);UN(3)=0.0#  Set special case                 NC35  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  NC35  42
#                                                                       NC35  43
ON(1)=UO(1)*TMI(1)+UO(2)*TMI(4)+UO(3)*TMI(7)# O new                     NC35  44
ON(2)=UO(1)*TMI(2)+UO(2)*TMI(5)+UO(3)*TMI(8)# O new                     NC35  45
ON(3)=UO(1)*TMI(3)+UO(2)*TMI(6)+UO(3)*TMI(9)# O new                     NC35  46
#                                                                       NC35  47
VN(1)=ON(2)*UN(3)-ON(3)*UN(2)#         V new                            NC35  48
VN(2)=ON(3)*UN(1)-ON(1)*UN(3)#         V new                            NC35  49
VN(3)=ON(1)*UN(2)-ON(2)*UN(1)#         V new                            NC35  50
#                                                                       NC35  51
PARLL=VN(1)*HKL(1)+VN(2)*HKL(2)+VN(3)*HKL(3)# Proportional              NC35  52
COSDPS=ON(1)*UN(1)*DM(1)+ON(2)*UN(2)*DM(5)+$# Cos d psi                 NC35  53
ON(3)*UN(3)*DM(9)+(ON(1)*UN(2)+ON(2)*UN(1))*DM(2)+$#                    NC35  54
(ON(1)*UN(3)+ON(3)*UN(1))*DM(3)+$#                                      NC35  55
(ON(2)*UN(3)+ON(3)*UN(2))*DM(6)#                                        NC35  56
SINDPS=SIGN(VOL*SQRT(VN(1)*VN(1)*RM(1)+VN(2)*VN(2)*RM(5)+$# Sin d psi   NC35  57
VN(3)*VN(3)*RM(9)+2.0*(VN(1)*VN(2)*RM(2)+$#                             NC35  58
VN(1)*VN(3)*RM(3)+VN(2)*VN(3)*RM(6))),PARLL)#                           NC35  59
PSICR=PSICR+57.29577951*ATAN2(SINDPS,COSDPS)# Transformed psi           NC35  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NC35  61
RETURN#                                                                 NC35  62
END#                                                                    NC35  63
systemheader:(NC40)#                   2nd. read/write pass             NC40   1
#********************************************************************** NC40   2
#                                                                       NC40   3
#                                NC40                                   NC40   4
#                                                                       NC40   5
#********************************************************************** NC40   6
SUBROUTINE NC40#                       H.d. flack november 1990         NC40   7
include:(AACOMN)#                                                       NC40   8
include:(NCCOMN)#                                                       NC40   9
#                                                                       NC40  10
INTEGER I#                                                              NC40  11
#                                                                       NC40  12
#                                                                       NC40  13
#  LREXPL: NEEDS UPDATING FOR THE MINIMUM AND MAXIMUM                   NC40  14
#  VALUES OF HKL.                                                       NC40  15
#                                                                       NC40  16
copyfile:(1,2,lrhist:,decr:(lrexpl:))# Copy all the rest                NC40  17
KEY(1)=0;KEY(2)=6;KEY(3)=0;KEY(4)=0#   Directory packet setup           NC40  18
DO I=1,6; IWANT(I)=I+500#              Min/max hkl                      NC40  19
indexpkt:(1,lrexpl:,PSIZE,IP,2,KEY,IWANT,IR)#                           NC40  20
#                                                                       NC40  21
#  LOOP OVER ALL LREXPL: PACKETS                                        NC40  22
#  -----------------------------                                        NC40  23
#                                                                       NC40  24
REPEAT#                                Loop over all data               NC40  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NC40  26
readwpkt:(1,lrexpl:,PSIZE,IP,0)#       Read/write pkt                   NC40  27
IF(IP<=0) BREAK#                       Quit when done                   NC40  28
writepkt:(2,lrexpl:,PSIZE,OPP)#        Get ouput packet                 NC40  29
movereal:(QX,IP+1,QX,OPP+1,PSIZE,1)#   Move input to output             NC40  30
IF(IR(1)>0)#                           Is min/max there                 NC40  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NC40  32
#                                      Transfer min/max hkl to output   NC40  33
QX(OPP+IR(1))=REAL(MINHKL(1))#         Min h                            NC40  34
QX(OPP+IR(2))=REAL(MAXHKL(1))#         Max h                            NC40  35
QX(OPP+IR(3))=REAL(MINHKL(2))#         Min k                            NC40  36
QX(OPP+IR(4))=REAL(MAXHKL(2))#         Max k                            NC40  37
QX(OPP+IR(5))=REAL(MINHKL(3))#         Min l                            NC40  38
QX(OPP+IR(6))=REAL(MAXHKL(3))#         Max l                            NC40  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NC40  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NC40  41
copyfile:(1,2,incr:(lrexpl:),endrecord:)# Copy all the rest             NC40  42
#                                                                       NC40  43
RETURN#                                                                 NC40  44
END#                                                                    NC40  45
systemheader:(NC50)#                   Force sx / ad                    NC50   1
##*****************************************************************##   NC50   2
##                                                                 ##   NC50   3
##                           NC50                                  ##   NC50   4
##                                                                 ##   NC50   5
##*****************************************************************##   NC50   6
SUBROUTINE NC50#                                                        NC50   7
#                                                                       NC50   8
include:(AACOMN)#                                                       NC50   9
include:(NCCOMN)#                                                       NC50  10
#                                                                       NC50  11
string:(LINE,80)#                                                       NC50  12
#                                                                       NC50  13
#                                                                       NC50  14
#     OUTPUT STARTX ADDATM LATCON LINES AND FORCE EXECUTION             NC50  15
#     -----------------------------------------------------             NC50  16
#                                                                       NC50  17
FILEXT(iofm1:)='sxn'#                  Define fmt as re-entrant file    NC50  18
openfmt:(iofm1:,' ')#                  Open atom line file              NC50  19
IF(LATCON==yes:)#                      Angles present force latcon      NC50  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NC50  21
LINE='STARTX UPD'#                     Reset line buffer                NC50  22
writefmt:(iofm1:,'(A)',LINE(1^10))#    Write startx header to file      NC50  23
LINE='LATCON bi bo zf'#                Reset line buffer                NC50  24
writefmt:(iofm1:,'(A)',LINE(1^15))#    Write addatm header to file      NC50  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NC50  26
LINE='STARTX UPD'#                     Reset line buffer                NC50  27
writefmt:(iofm1:,'(A)',LINE(1^10))#    Write startx header to file      NC50  28
LINE='ADDATM UPD'#                     Reset line buffer                NC50  29
writefmt:(iofm1:,'(A)',LINE(1^10))#    Write addatm header to file      NC50  30
IF((CHRIN(1^4)!='END ')&(CHREOF!=1))#  If next input line is not end    NC50  31
#                                      And not an eof                   NC50  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NC50  33
LINFLG=1; LINE=CHRIP#                  Ensure this line not lost        NC50  34
writefmt:(iofm1:,'(A)',LINE(1^44))#    Write header to file             NC50  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NC50  36
closefmt:(iofm1:)#                     Shut down the line file          NC50  37
linestream:('sxn')#                    Insert file into line stream     NC50  38
#                                                                       NC50  39
RETURN#                                                                 NC50  40
END#                                                                    NC50  41
pmacro:([no:])#                                                         NC50  42
