systemheader:(NI    )#                                                  NI     1
####################################################################### NI     2
#                                                                     # NI     3
#                        *** NICNAK ***                               # NI     4
#                                                                     # NI     5
#     PROGRAM FOR PLACING DATA FROM THE NICOLET AS LRREFL: ON BDF     # NI     6
#                                                                     # NI     7
####################################################################### NI     8
#                                                                       NI     9
include:(XMACRO)#                                                       NI    10
#                                                                       NI    11
systemheader:(NI00)#                   Nicolet raw data processor       NI00   1
# ################################################################## #  NI00   2
#                                                                    #  NI00   3
#                               NI00                                 #  NI00   4
#                                                                    #  NI00   5
# ################################################################## #  NI00   6
SUBROUTINE NI00#                       J.m. stewart                     NI00   7
include:(AACOMN)#                                                       NI00   8
#                                                                       NI00   9
# THE FOLLOWING LIST OF DEFINED DATA IS IN NICOLET ORDER THE OUTPUT     NI00  10
# BDF WILL BE FORMED IN DIRECTORY INDEX NUMBER ORDER.                   NI00  11
# -----------------------------------------------------------------     NI00  12
# VARIABLE    CODE  IDNUM DESCRIPTION                                   NI00  13
#                                                                       NI00  14
REAL RFN#  ## Rfn   1027  reflection number on input contains rft       NI00  15
REAL RFT#  ## Rft   1018  reflection type 0/reg;1/std;etc.              NI00  16
REAL HKL(3)## Hkl      1  miller indices                                NI00  17
REAL TTH#  ## Tth   1008  two theta at max                              NI00  18
REAL OMG#  ## Omg   1007  omega at max                                  NI00  19
REAL PHI#  ## Phi   1005  phi for reflection                            NI00  20
REAL CHI#  ## Chi   1006  chi for reflection                            NI00  21
REAL SCR#  ## Scr   1009  scan range degrees two theta                  NI00  22
#          ## SCR   1010  SCAN RANGE DEGREES OMEGA                      NI00  23
REAL SPD#  ## Spd   1017  scan speed degrees/min                        NI00  24
REAL BG1#  ## Bg1   1023  low angle background counts                   NI00  25
REAL SCC#  ## Scc   1021  scan counts                                   NI00  26
REAL BG2#  ## Bg2   1024  high angle background counts                  NI00  27
REAL IRL#  ## Irl   1300  i rel, relative intensity of reflection       NI00  28
REAL SIR#  ## Sir   1301  sigma of i relative                           NI00  29
REAL EXP#  ## Exp   1014  exposure time in seconds;nicolet gives hour   NI00  30
REAL STP#  ## Stp   1100  number of steps in a step scan                NI00  31
REAL CNT(99)## 1101-1199 counts at each step in step scan               NI00  32
#                                                                       NI00  33
INTEGER APPEND#                        Signal if new data appended      NI00  34
#                                         To old                        NI00  35
REAL    BCKMAX#                        Max. ref. no. for rft='backgrn   NI00  36
REAL    BCKMIN#                        Min. ref. no. for rft='backgrn   NI00  37
REAL    CHIMAX#                        Maximum chi to accept            NI00  38
REAL    CHIMIN#                        Minimum chi to accept            NI00  39
REAL    COUNTR(3)#                     Reflect. counts on files a,b,d   NI00  40
INTEGER DATSET#                        Data set number for data         NI00  41
REAL    DATUM(115)#                    Array of nicolet input data      NI00  42
REAL    EXPHRS#                        Exposure time in hours           NI00  43
INTEGER FORCET#                        Signal of forced reflection ty   NI00  44
REAL    FORRFT#                        Value of forced refelction typ   NI00  45
INTEGER I,M,N#                         Loop pointers                    NI00  46
INTEGER IHIT#                          Character search signal          NI00  47
INTEGER IP,JP#                         Input and output pkt pointers    NI00  48
INTEGER IREL(116)#                     Packet offset pointers           NI00  49
INTEGER KEY(4)#                        Indexpkt keys                    NI00  50
INTEGER KY(4),WA(3),OFF(4),NP#         Setup for lrexpl:                NI00  51
INTEGER KLIST,RLIST#                   List reflection info             NI00  52
REAL    LSTRFN#                        Previous reflection number       NI00  53
REAL    MAXHKL(3),MINHKL(3)#           Stats on hkl's in new file       NI00  54
REAL    MAXITM(115),MINITM(115)#       Stats on ites in new file        NI00  55
REAL    NBCK#                          No. of bkgrnd calc. rfln.        NI00  56
REAL    NOBS#                          No. of normal rfln.              NI00  57
REAL    NMON#                          No. of monitor rfln.             NI00  58
REAL    NTAU#                          No. of absorp calc. rfln.        NI00  59
REAL    MONMAX#                        Refln. nos. for maximum and      NI00  60
REAL    MONMIN#                        Minimum monitor accepting        NI00  61
INTEGER NDEV#                          Input device = file d            NI00  62
INTEGER NSTP#                          Integer value of stp             NI00  63
REAL    OMGMAX#                        Maximum omega to accept          NI00  64
REAL    OMGMIN#                        Minimum omega to accept          NI00  65
REAL    PHIMAX#                        Maximum phi to accept            NI00  66
REAL    PHIMIN#                        Minimum phi to accept            NI00  67
REAL    RFNMAX#                        Reflection no. for maximum and   NI00  68
REAL    RFNMIN#                        Minimum for accepting rfln.      NI00  69
INTEGER SCNTYP#                        Signal for type of scan          NI00  70
INTEGER STATUS#                        Status of input nicolet data     NI00  71
#                                        =0 good record <0 end of file  NI00  72
#                                        >0 error in record             NI00  73
string:(TEST,6)#                       For testing input directives     NI00  74
REAL    TAUMAX#                        Reflection no. for maximum and   NI00  75
REAL    TAUMIN#                        Minimum for tau correction       NI00  76
REAL    TTHMAX#                        Maximum two-theta to accept      NI00  77
REAL    TTHMIN#                        Minimum two-theta to accept      NI00  78
INTEGER WNT(115)#                      Bdf lrrefl: packet               NI00  79
#                                                                       NI00  80
# SET UP THE EQUIVALENCE TABLE BETWEEN NICOLET INPUT AND BDF OUTPUT     NI00  81
# -----------------------------------------------------------------     NI00  82
#                                                                       NI00  83
EQUIVALENCE(DATUM(2),PHI)#                                              NI00  84
EQUIVALENCE(DATUM(3),CHI)#                                              NI00  85
EQUIVALENCE(DATUM(4),OMG)#                                              NI00  86
EQUIVALENCE(DATUM(5),TTH)#                                              NI00  87
EQUIVALENCE(DATUM(6),SCR)#                                              NI00  88
EQUIVALENCE(DATUM(7),EXP)#                                              NI00  89
EQUIVALENCE(DATUM(8),SPD)#                                              NI00  90
EQUIVALENCE(DATUM(9),RFT)#                                              NI00  91
EQUIVALENCE(DATUM(10),SCC)#                                             NI00  92
EQUIVALENCE(DATUM(11),BG1)#                                             NI00  93
EQUIVALENCE(DATUM(12),BG2)#                                             NI00  94
EQUIVALENCE(DATUM(13),RFN)#                                             NI00  95
EQUIVALENCE(DATUM(14),IRL)#                                             NI00  96
EQUIVALENCE(DATUM(15),SIR)#                                             NI00  97
EQUIVALENCE(DATUM(16),STP)#                                             NI00  98
EQUIVALENCE(DATUM(17),CNT(1))#                                          NI00  99
#                                                                       NI00 100
chardata:(NI01, END    RANGE  MONRFN TAURFN BKGRFN )#                   NI00 101
chardata:(NI03,T2T   WYC   OME   STEPS DATSETAPPENDNOAPPERFT   $#       NI00 102
LIST   )#                                                               NI00 103
chardata:(NI04,NO YES)#                                                 NI00 104
chardata:(NI05,THETA TWO THETAWYCKOFF        OMEGA          )#          NI00 105
chardata:(NI06, SCAN METHOD                     )#                      NI00 106
chardata:(NI07, NUMBER OF STEPS     )#                                  NI00 107
chardata:(NI08, DATA SET NUMBER    )#                                   NI00 108
chardata:(NI09, APPEND OLD REFL PKTS      )#                            NI00 109
chardata:(NI10, FORCE REFLECTION TYPE             )#                    NI00 110
chardata:(NI11, STATISTICS CONCERNING INPUT AND OUTPUT FILES.)#         NI00 111
chardata:(NI12, TOTAL REFLECTION PACKETS  FILE A  FILE B  FILE D)#      NI00 112
chardata:(NI13, NEW OP WRD  PKT HEADER  MINIMUM VALUE  MAXIMUM $#       NI00 113
VALUE  MNEMONIC)#                                                       NI00 114
chardata:(NI14,H  K  L  PHICHIOMGTTHSCREXPSPDRFTSCCBG1BG2RFNIRLSIR$#    NI00 115
STPCNT)#                                                                NI00 116
chardata:(NI15, TO     )#                                               NI00 117
chardata:(NI16, REFLECTION RANGE FOR TAU ABSORPTION IS       TO$#       NI00 118
       )#                                                               NI00 119
chardata:(NI17,    H    K    L  2THETA   OMEGA     CHI     PHI$#        NI00 120
     IRL     SIR   EXP RFT    RFN)#                                     NI00 121
chardata:(NI18, RELECTIONS OUT OF ORDER        TO           )#          NI00 122
chardata:(NI19, FIRST REFLECTION OUTPUT IS          )#                  NI00 123
chardata:(NI20, LAST REFLECTION OUTPUT IS           )#                  NI00 124
chardata:(NI21, REFLECTION RANGE FOR BACKGROUND IS           TO$#       NI00 125
       )#                                                               NI00 126
chardata:(NI22, REGULAR REFLECTIONS                             )#      NI00 127
chardata:(NI23, MONITOR REFLECTIONS                             )#      NI00 128
chardata:(NI24, ABSORPTION REFLECTIONS                          )#      NI00 129
chardata:(NI25, BACKGROUND REFLECTIONS                          )#      NI00 130
chardata:(NI26, REFLECTION RANGE FOR MONITORS IS             TO$#       NI00 131
       )#                                                               NI00 132
chardata:(NI30,                       MINIMUM  MAXIMUM)#                NI00 133
chardata:(NI31,REFLECTION NUMBER   TWO-THETA OMEGA     PHI       $#     NI00 134
CHI       )#                                                            NI00 135
chardata:(NI32,MONITOR REFLN. NO.   ABSORPTION REFLN. NO.$#             NI00 136
BACKGROUND REFLN. NO.)#                                                 NI00 137
#                                                                       NI00 138
# SET UP THE GENERAL WANT LIST TO BE LRREFL: PACKET HEADER              NI00 139
# --------------------------------------------------------              NI00 140
#                                                                       NI00 141
intdata:(NBASE,[15])#                  No. basic items in want          NI00 142
intdata:(NPOSS,[115])#                 Maximum poss. refl pkt s         NI00 143
intdata:(IZERO,[0])#                   A zero for clearing packed hkl   NI00 144
realdata:(HTOS,[3600.])#               Constant hours to seconds        NI00 145
realdata:(BIGNUM,[1.0E19])#            A big number for starting        NI00 146
realdata:(FMTFIL,[330813.,410813.,490813.])#                            NI00 147
realdata:(FMTMAX,[110513.,230513.,381422.,531422.,690313.,650313.])#    NI00 148
realdata:(FMTHKL,[110513.,230513.,380413.,530413.])#                    NI00 149
realdata:(FMTREF,[050513.,100513.,150513.])#                            NI00 150
#                                                                       NI00 151
DATA WNT(  1),WNT(  2),WNT(  3),WNT(  4),WNT(  5),WNT(  6),WNT(  7)$#   NI00 152
/           1,    1005,    1006,    1007,    1008,    1009,    1014/#   NI00 153
DATA WNT(  8),WNT(  9),WNT( 10),WNT( 11),WNT( 12),WNT( 13),WNT( 14)$#   NI00 154
/        1017,    1018,    1021,    1023,    1024,    1027,    1300/#   NI00 155
DATA WNT( 15),WNT( 16)$#                                                NI00 156
/        1301,    1100/#                                                NI00 157
datastuff:#                                                             NI00 158
#                                                                       NI00 159
#                                                                       NI00 160
FILEXT(IOUNIT(4))='NIC'#               Ext for nicolet ip file          NI00 161
#                                                                       NI00 162
# INITIALIZE DEFAULTS                                                   NI00 163
# -------------------                                                   NI00 164
#                                                                       NI00 165
STP=96.0#                              Set steps in stepscan            NI00 166
DATSET=1#                              Presume parent dataset           NI00 167
SCNTYP=1#                              Assume theta two theta scans     NI00 168
FORRFT = 0.0#                          Force reflection type "observe   NI00 169
FORCET = no:#                          But not unless asked             NI00 170
APPEND = yes:#                         Append unless asked not to       NI00 171
MONMAX = 32767.#                       Maximum refl. no. for monitor    NI00 172
MONMIN = 0.#                           Minimum refl. no. for monitor    NI00 173
RFNMAX = 32767.#                       Maximum refl. no. for refl.      NI00 174
RFNMIN = 0.#                           Minimum refl. no. for refl.      NI00 175
TTHMAX =  360.#                        Maximum two-theta                NI00 176
TTHMIN = -360.#                        Minimum two-theta                NI00 177
OMGMAX =  360.#                        Maximum omega                    NI00 178
OMGMIN = -360.#                        Minimum omega                    NI00 179
PHIMAX =  360.#                        Maximum phi                      NI00 180
PHIMIN = -360.#                        Minimum phi                      NI00 181
CHIMAX =  360.#                        Maximum chi                      NI00 182
CHIMIN = -360.#                        Minimum chi                      NI00 183
BCKMAX = -1.#                          Maximum refl. no. for backgrnd   NI00 184
BCKMIN = -1.#                          Minimum refl. no. for backgrnd   NI00 185
TAUMAX = 32100.#                       Maximum refl. no. for tau        NI00 186
TAUMIN = 32000.#                       Minimum refl. no. for tau        NI00 187
NOBS = 0.#                                                              NI00 188
NMON = 0.#                                                              NI00 189
NTAU = 0.#                                                              NI00 190
NBCK = 0.#                                                              NI00 191
RLIST = 0;KLIST=-1#                    Do not list reflections          NI00 192
#                                                                       NI00 193
# CLEAR STATISTICS REGISTERS FOR COUNTS, MAXIMA, AND MINIMA.            NI00 194
#                                                                       NI00 195
DO I=1,3#                                                               NI00 196
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NI00 197
MAXHKL(I)=-BIGNUM ; MINHKL(I)=BIGNUM ; COUNTR(I)=0.0#                   NI00 198
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NI00 199
DO I=1,NPOSS#                                                           NI00 200
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NI00 201
MAXITM(I)=-BIGNUM ; MINITM(I)=BIGNUM#                                   NI00 202
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NI00 203
#                                                                       NI00 204
#    SET IO BUFFERS FOR FILES A AND B                                   NI00 205
#    --------------------------------                                   NI00 206
#                                                                       NI00 207
IOMARK(1)=QXSTR#                       Start of buffer for file a       NI00 208
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of buffer for file b       NI00 209
incrqx:(MARK,IOMARK(2)+bdfbuf:,NI0005)# Incr memory.....ni0005          NI00 210
#                                                                       NI00 211
# SET UP FOR INPUT FROM NICOLET BINARY FILE WHICH HAS BEEN PREPROCESSED NI00 212
# TO BE IN LOCAL MACHINE FORMAT.                                        NI00 213
# --------------------------------------------------------------------- NI00 214
#                                                                       NI00 215
NDEV=IOUNIT(4)#                        Expect it on file d              NI00 216
bdfreadopen:(NDEV)#                    Attach file to run, if needed    NI00 217
#                                                                       NI00 218
# SCAN CALLING INPUT LINE FOR INSTRUCTIONS                              NI00 219
# ----------------------------------------                              NI00 220
#                                                                       NI00 221
FOR(I=1;I<=mxfdim:;I=I+1)#             Loop over input fields           NI00 222
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  NI00 223
IF(BUFIN(I)>=voidflg:) BREAK#          Until void encountered           NI00 224
stringlim:(I,M,N)#                     Delimit input characters         NI00 225
movechar:(BLANK,1,TEST,1,6,1)#         Blank out test                   NI00 226
N=MIN0(3,N-M)#                         Discard beyond third             NI00 227
movechar:(CHRIN,M,TEST,1,N,0)#         Move input string                NI00 228
compchar:(TEST,1,NI03,1,3,6,NNI03,IHIT)# Search for match               NI00 229
IF(IHIT==0) iquit:(NI0007)#            Unrecognized instruction         NI00 230
ELSE IF((IHIT>=1)&(IHIT<=3))#          Check for scanning method        NI00 231
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  NI00 232
SCNTYP=IHIT#                           Memorize scan method             NI00 233
IF(IHIT==3) WNT(5)=1010#               Reset omega for omega scans      NI00 234
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  NI00 235
ELSE IF(IHIT==4)#                      Check for number of step/scan    NI00 236
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  NI00 237
IF((BUFIN(I+1)<0.0)\(BUFIN(I+1)>99.0))# Protect range of arrays         NI00 238
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  NI00 239
iquit:(NI0009)#                        Impossible number steps/scan     NI00 240
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  NI00 241
STP=BUFIN(I+1)#                        Save number of steps/scan        NI00 242
I=I+1#                                 And skip field                   NI00 243
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  NI00 244
ELSE IF(IHIT==5)#                      Check for data set number        NI00 245
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  NI00 246
IF((BUFIN(I+1)<0.0)\(BUFIN(I+1)>9.0))# Check range of datasets          NI00 247
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  NI00 248
iquit:(NI0011)#                        Silly data set number            NI00 249
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  NI00 250
DATSET=NINT(BUFIN(I+1))#               Store data set number            NI00 251
I=I+1#                                 Advance input scan               NI00 252
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  NI00 253
ELSE IF (IHIT == 7) APPEND = no:#      Shut off appending               NI00 254
ELSE IF (IHIT == 8)#                   Test for forced rft type         NI00 255
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  NI00 256
IF ((BUFIN(I+1) < 0.0)\(BUFIN(I+1) > 2.0)) iquit:(NI0013)#              NI00 257
FORRFT = BUFIN(I+1)#                                                    NI00 258
I = I + 1#                                                              NI00 259
FORCET = yes:#                                                          NI00 260
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  NI00 261
ELSE IF (IHIT == 9)#                   Force tau refl. range            NI00 262
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 NI00 263
RLIST = 1#                                                              NI00 264
ifnv:(BUFIN(I+1))#                                                      NI00 265
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 NI00 266
RLIST=INT(BUFIN(I+1))#                                                  NI00 267
I = I + 1#                                                              NI00 268
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 NI00 269
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 NI00 270
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  NI00 271
#                                                                       NI00 272
# SET UP THE PACKET HEADER - WANT LIST BASED ON INPUT INSTRUCTIONS      NI00 273
# ----------------------------------------------------------------      NI00 274
#                                                                       NI00 275
KEY(1)=NBASE#                          Everything is mandatory          NI00 276
IF(STP>0.0)#                           Check for step scans             NI00 277
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 NI00 278
NSTP=NINT(STP)#                                                         NI00 279
KEY(1)=NSTP+NBASE+1#                   Provide for number of steps      NI00 280
DO I=1,NSTP#                                                            NI00 281
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 NI00 282
M=I+NBASE+1#                           Get offsets to step counts       NI00 283
WNT(M)=1100+I#                         Set up packet pointers           NI00 284
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 NI00 285
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 NI00 286
#                                                                       NI00 287
# RESET PACKET IDNUMS IF NOT PARENT DATA SET                            NI00 288
# ------------------------------------------                            NI00 289
#                                                                       NI00 290
IF(DATSET>1)#                                                           NI00 291
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 NI00 292
N=(DATSET-1)*1000#                                                      NI00 293
DO I=2,KEY(1) ; WNT(I)=WNT(I)+N#       Change packets                   NI00 294
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 NI00 295
#                                                                       NI00 296
#    ENTER CONTROL LINES                                                NI00 297
#    -------------------                                                NI00 298
#                                                                       NI00 299
REPEAT#                                                                 NI00 300
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 NI00 301
readline:(NI01,NNI01)#                                                  NI00 302
IF (LINID==1) BREAK#                                                    NI00 303
#                                                                       NI00 304
IF (LINID==2)#                         Enter regular refln. ranges      NI00 305
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 NI00 306
IF ((BUFIN(1) < 0.0)\(BUFIN(1)> BUFIN(2))) iquit:(NI0014)#              NI00 307
IF ((BUFIN(2) < BUFIN(1))\(BUFIN(2)> 66000.)) iquit:(NI0014)#           NI00 308
DO I=3,10,2#                                                            NI00 309
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 NI00 310
ifvo:(BUFIN(I)) BUFIN(I)=-360.#                                         NI00 311
ifvo:(BUFIN(I+1)) BUFIN(I+1)=360.#                                      NI00 312
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 NI00 313
ifnv:(BUFIN(1)) RFNMIN = BUFIN(1)#                                      NI00 314
ifnv:(BUFIN(2)) RFNMAX = BUFIN(2)#                                      NI00 315
IF  (BUFIN(3)>=-360.0) TTHMIN = BUFIN(3)#                               NI00 316
IF ((BUFIN(4)>=BUFIN(3)) & (BUFIN(4)<=360.)) TTHMAX = BUFIN(4)#         NI00 317
IF  (BUFIN(5)>=-360.0) OMGMIN = BUFIN(5)#                               NI00 318
IF ((BUFIN(6)>=BUFIN(5)) & (BUFIN(6)<=360.)) OMGMAX = BUFIN(6)#         NI00 319
IF  (BUFIN(7)>=-360.0) CHIMIN = BUFIN(7)#                               NI00 320
IF ((BUFIN(8)>=BUFIN(7)) & (BUFIN(8)<=360.)) CHIMAX = BUFIN(8)#         NI00 321
IF  (BUFIN(9)>=-360.0) PHIMIN = BUFIN(9)#                               NI00 322
IF ((BUFIN(10)>=BUFIN(9)) & (BUFIN(10)<=360.)) PHIMAX = BUFIN(10)#      NI00 323
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 NI00 324
#                                                                       NI00 325
IF (LINID==3)#                         Enter monitor refln. range       NI00 326
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 NI00 327
IF ((BUFIN(1) < 0.0)\(BUFIN(1)> BUFIN(2))) iquit:(NI0015)#              NI00 328
IF ((BUFIN(2) < BUFIN(1))\(BUFIN(2)> 32767.)) iquit:(NI0015)#           NI00 329
MONMIN = BUFIN(1)#                                                      NI00 330
MONMAX = BUFIN(2)#                                                      NI00 331
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 NI00 332
#                                                                       NI00 333
IF (LINID==4)#                         Enter absorption refln. range    NI00 334
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 NI00 335
IF ((BUFIN(1) < 0.0)\(BUFIN(1)> BUFIN(2))) iquit:(NI0016)#              NI00 336
IF ((BUFIN(2) < BUFIN(1))\(BUFIN(2)> 32767.)) iquit:(NI0016)#           NI00 337
TAUMIN = BUFIN(1)#                                                      NI00 338
TAUMAX = BUFIN(2)#                                                      NI00 339
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 NI00 340
#                                                                       NI00 341
IF (LINID==5)#                         Enter background refln. range    NI00 342
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 NI00 343
IF ((BUFIN(1) < 0.0)\(BUFIN(1)> BUFIN(2))) iquit:(NI0017)#              NI00 344
IF ((BUFIN(2) < BUFIN(1))\(BUFIN(2)> 66000.)) iquit:(NI0017)#           NI00 345
BCKMIN = BUFIN(1)#                                                      NI00 346
BCKMAX = BUFIN(2)#                                                      NI00 347
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 NI00 348
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 NI00 349
#                                                                       NI00 350
#    SUMMARIZE SPECIFICATIONS FOR THIS RUN                              NI00 351
#    -------------------------------------                              NI00 352
#                                                                       NI00 353
movechar:(NI05,(SCNTYP-1)*15+1,NI06,18,15,0)#                           NI00 354
movechar:(NI04,FORCET*3+1,NI10,24,3,0)#                                 NI00 355
movechar:(NI04,APPEND*3+1,NI09,24,3,0)#                                 NI00 356
BUFOT(1) = FLOAT(DATSET)#                                               NI00 357
ncodefld:(BUFOT,1,NI08,180213.,1)#                                      NI00 358
ncodefld:(STP,1,NI07,200313.,1)#                                        NI00 359
ncodefld:(FORRFT,1,NI15,70312.,1)#                                      NI00 360
IF (FORCET == yes:) movechar:(NI15,1,NI10,28,8,0)#                      NI00 361
writeline:(1,NI06,NNI06,3,3)#                                           NI00 362
writeline:(1,NI07,NNI07,3,3)#                                           NI00 363
writeline:(1,NI08,NNI08,3,3)#                                           NI00 364
writeline:(1,NI09,NNI09,3,3)#                                           NI00 365
writeline:(1,NI10,NNI10,3,3)#                                           NI00 366
writeline:(1,NI30,NNI30,3,3)#                                           NI00 367
movechar:(NI31,1,CHROT,2,20,0)#        Output min/max refln. no.        NI00 368
ncodefld:(RFNMIN,1,CHROT,300813.,1)#                                    NI00 369
ncodefld:(RFNMAX,1,CHROT,400813.,1)#                                    NI00 370
writeline:(0,0,0,1,3)#                                                  NI00 371
movechar:(NI31,21,CHROT,2,10,0)#       Output min/max two-theta         NI00 372
ncodefld:(TTHMIN,1,CHROT,300813.,1)#                                    NI00 373
ncodefld:(TTHMAX,1,CHROT,400813.,1)#                                    NI00 374
writeline:(0,0,0,1,3)#                                                  NI00 375
movechar:(NI31,31,CHROT,2,10,0)#       Output min/max omega             NI00 376
ncodefld:(OMGMIN,1,CHROT,300813.,1)#                                    NI00 377
ncodefld:(OMGMAX,1,CHROT,400813.,1)#                                    NI00 378
writeline:(0,0,0,1,3)#                                                  NI00 379
movechar:(NI31,41,CHROT,2,10,0)#       Output min/max phi               NI00 380
ncodefld:(PHIMIN,1,CHROT,300813.,1)#                                    NI00 381
ncodefld:(PHIMAX,1,CHROT,400813.,1)#                                    NI00 382
writeline:(0,0,0,1,3)#                                                  NI00 383
movechar:(NI31,51,CHROT,2,20,0)#       Output min/max chi               NI00 384
ncodefld:(CHIMIN,1,CHROT,300813.,1)#                                    NI00 385
ncodefld:(CHIMAX,1,CHROT,400813.,1)#                                    NI00 386
writeline:(0,0,0,1,3)#                                                  NI00 387
movechar:(NI32,1,CHROT,2,21,0)#        Output min/max ranges            NI00 388
ncodefld:(MONMIN,1,CHROT,300813.,1)#                                    NI00 389
ncodefld:(MONMAX,1,CHROT,400813.,1)#                                    NI00 390
writeline:(0,0,0,1,3)#                                                  NI00 391
movechar:(NI32,22,CHROT,2,21,0)#       Output min/max ranges            NI00 392
ncodefld:(TAUMIN,1,CHROT,300813.,1)#                                    NI00 393
ncodefld:(TAUMAX,1,CHROT,400813.,1)#                                    NI00 394
writeline:(0,0,0,1,3)#                                                  NI00 395
movechar:(NI32,43,CHROT,2,21,0)#       Output min/max ranges            NI00 396
ncodefld:(BCKMIN,1,CHROT,300813.,1)#                                    NI00 397
ncodefld:(BCKMAX,1,CHROT,400813.,1)#                                    NI00 398
writeline:(0,0,0,1,3)#                                                  NI00 399
#                                                                       NI00 400
#                                                                       NI00 401
#    UPDATE EXPL RECORD WITH SCAN TYPE AND STEPS                        NI00 402
#    -------------------------------------------                        NI00 403
#                                                                       NI00 404
copyfile:(1,2,1,decr:(lrexpl:))#       Copy to expl records             NI00 405
LSTRFN = -100000.#                                                      NI00 406
KY(1)=1 ; KY(2)=1 ; KY(3)=3 ; KY(4)=0#                                  NI00 407
WA(1)=1 ; WA(2)=35; WA(3)=36#                                           NI00 408
indexpkt:(1,lrexpl:,NP,IP,2,KY,WA,OFF)##                                NI00 409
IF (KY(4)<=0) iquit:(NI0021)#          No expl record, die              NI00 410
REPEAT#                                                                 NI00 411
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 NI00 412
readwpkt:(1,lrexpl:,NP,IP,0)#                                           NI00 413
IF (IP<=0) BREAK#                                                       NI00 414
writepkt:(2,lrexpl:,KY(4),JP)#                                          NI00 415
movereal:(voidflg:,1,QX,JP+1,KY(4),2)#                                  NI00 416
movereal:(QX,IP+1,QX,JP+1,NP,0)#                                        NI00 417
I = OFF(1) + IP#                       Point to data set number         NI00 418
IF (NINT(QX(I)) == DATSET)#            Check if set wanted              NI00 419
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 NI00 420
I = OFF(2) + JP#                       Store scan type                  NI00 421
QX(I) = FLOAT(SCNTYP)#                                                  NI00 422
I = OFF(3) + JP#                       Store number of steps            NI00 423
QX(I) = STP#                                                            NI00 424
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 NI00 425
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 NI00 426
copyfile:(1,2,incr:(lrexpl:),decr:(lrrefl:))#                           NI00 427
#                                                                       NI00 428
#    SEARCH DIRECTORY OF LRREFL:                                        NI00 429
#    ---------------------------                                        NI00 430
#                                                                       NI00 431
KEY(2)=0; KEY(3)=0; KEY(4)=0#          Set search keys                  NI00 432
indexpkt:(1,lrrefl:,NPAK,IP,0,KEY,WNT,IREL)# Search lrrefl directory    NI00 433
IF((KEY(4)<=0)\(APPEND==no:))#         No previous reflections          NI00 434
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 NI00 435
NPAK=KEY(1)#                           If no old reflections make new   NI00 436
writepkt:(2,lrrefl:,NPAK,JP)#          Get header pkt pointer           NI00 437
DO I=1,NPAK#                           Loop over all items              NI00 438
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 NI00 439
QX(JP+I)=FLOAT(WNT(I))#                Set id numbers                   NI00 440
IREL(I)=I#                             And make offsets for loading     NI00 441
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 NI00 442
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 NI00 443
ELSE#                                  If data already exists           NI00 444
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 NI00 445
writepkt:(2,lrrefl:,NPAK,JP)#          Point to op packet               NI00 446
movereal:(QX,IP+1,QX,JP+1,NPAK,0)#     Transfer pkt ip to op            NI00 447
#                                                                       NI00 448
#    ENTER LRREFL: BDF RECORDS                                          NI00 449
#    -------------------------                                          NI00 450
#                                                                       NI00 451
REPEAT#                                Loop over lrrefl records         NI00 452
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 NI00 453
readwpkt:(1,lrrefl:,NPAK,IP,0)#        Point to ip packet               NI00 454
IF(IP<=0) BREAK#                       Exit reflection loop             NI00 455
#                                                                       NI00 456
#    COPY LRREFL PACKET                                                 NI00 457
#    ------------------                                                 NI00 458
#                                                                       NI00 459
writepkt:(2,lrrefl:,NPAK,JP)#          Point to op packet               NI00 460
movereal:(QX,IP+1,QX,JP+1,NPAK,0)#     Transfer pkt ip to op            NI00 461
COUNTR(1)=COUNTR(1)+1.0;COUNTR(2)=COUNTR(2)+1# Keep stats               NI00 462
#                                                                       NI00 463
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 NI00 464
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 NI00 465
#                                                                       NI00 466
# READ THE NEW INPUT DATA FROM THE NICOLET                              NI00 467
# ----------------------------------------                              NI00 468
#                                                                       NI00 469
REPEAT#                                Loop till end of file on input   NI00 470
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 NI00 471
#                                                                       NI00 472
# THE INPUT DATA FILE CONSISTS OF DATA IN THE ORDER SHOWN               NI00 473
# IN THE DATA DECLARATION STATEMENTS AT THE TOP OF THE PROGRAM          NI00 474
# ------------------------------------------------------------          NI00 475
#                                                                       NI00 476
IF(NSTP>0)#                            Check if any step scans wanted   NI00 477
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 NI00 478
READ(NDEV,IOSTAT=STATUS)$#             Read transformed nicolet file    NI00 479
RFN,HKL,TTH,OMG,PHI,CHI,SCR,SPD,BG1,SCC,BG2,IRL,SIR,EXPHRS,$#           NI00 480
(CNT(N),N=1,NSTP)#                                                      NI00 481
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 NI00 482
ELSE#                                  Skip the step counts             NI00 483
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 NI00 484
READ(NDEV,IOSTAT=STATUS)$#             Read transformed nicolet file    NI00 485
RFN,HKL,TTH,OMG,PHI,CHI,SCR,SPD,BG1,SCC,BG2,IRL,SIR,EXPHRS#             NI00 486
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 NI00 487
IF(STATUS!=0)#                         Test for end of file             NI00 488
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 NI00 489
bdfclose:(NDEV)#                       Shut down file d, if need be     NI00 490
IF(STATUS>0) iquit:(NI0017)#           Error reading record             NI00 491
BREAK#                                 And leave off repeating          NI00 492
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 NI00 493
#                                                                       NI00 494
# CHECK IF IN RANGE FOR ACCEPTING                                       NI00 495
IF (ABS(RFN)<RFNMIN \ ABS(RFN)>RFNMAX) NEXT#                            NI00 496
IF (TTH<TTHMIN \ TTH>TTHMAX) NEXT#                                      NI00 497
IF (OMG<OMGMIN \ OMG>OMGMAX) NEXT#                                      NI00 498
IF (PHI<PHIMIN \ PHI>PHIMAX) NEXT#                                      NI00 499
IF (CHI<CHIMIN \ CHI>CHIMAX) NEXT#                                      NI00 500
writepkt:(2,lrrefl:,NPAK,JP)#          Set next packet pointer          NI00 501
COUNTR(3)=COUNTR(3)+1.0;COUNTR(2)=COUNTR(2)+1# Keep stats               NI00 502
#                                                                       NI00 503
# PACK UP H,K,L                                                         NI00 504
# -------------                                                         NI00 505
#                                                                       NI00 506
intpak:(IZERO,DATUM(1),0,mxbtwd:)#     Zero out the packed hkl          NI00 507
DO I=1,3#                              Loop over h,k and l              NI00 508
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 NI00 509
MAXHKL(I)=AMAX1(MAXHKL(I),HKL(I));MINHKL(I)=AMIN1(MINHKL(I),HKL(I))#    NI00 510
M=NINT(HKL(4-I))#                      Make an integer out of index     NI00 511
N=0#                                   Clear sign bit                   NI00 512
IF(M<0)#                               For negative miller index        NI00 513
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 NI00 514
M=IABS(M)#                             Get magnitude                    NI00 515
N=1#                                   And set sign bit                 NI00 516
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 NI00 517
intpak:(N,DATUM(1),I-1,1)#             Pack up the sign bit             NI00 518
intpak:(M,DATUM(1),(I-1)*9+3,9)#       Pack up the mag of h, k, or l    NI00 519
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 NI00 520
M=JP+IREL(1) ; movepakwd:(DATUM(1),QX(M))# Save packed hkl              NI00 521
#                                                                       NI00 522
# CONVERT EXPOSURE TIME TO SECONDS FROM HOURS                           NI00 523
# -------------------------------------------                           NI00 524
#                                                                       NI00 525
EXP=EXPHRS*HTOS#                                                        NI00 526
#                                                                       NI00 527
# SET UP STANDARDS FLAGS                                                NI00 528
# ----------------------                                                NI00 529
#                                                                       NI00 530
RFT=0.0#                               Set as regular reflection        NI00 531
IF(RFN<0.0)#                           Test for monitor reflections     NI00 532
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 NI00 533
RFN=ABS(RFN)#                                                           NI00 534
IF (RFN>=MONMIN & RFN<=MONMAX) RFT = 1.0#                               NI00 535
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 NI00 536
ELSE IF(RFN>=BCKMIN & RFN <=BCKMAX)#   Background calc. refn.           NI00 537
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 NI00 538
RFT=3.0#                                                                NI00 539
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 NI00 540
ELSE IF(RFN>=TAUMIN & RFN <=TAUMAX)#   Phi spin (tau) refn.             NI00 541
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 NI00 542
RFT=2.0 ; RFN=RFN-TAUMIN+1.#           Set tau refn.                    NI00 543
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 NI00 544
IF (FORCET==yes:) RFT = FORRFT#        Set forced reflection type       NI00 545
IF      (RFT==0.) NOBS=NOBS+1.#        Tabulate totals of rftype        NI00 546
ELSE IF (RFT==1.) NMON=NMON+1.#                                         NI00 547
ELSE IF (RFT==2.) NTAU=NTAU+1.#                                         NI00 548
ELSE IF (RFT==3.) NBCK=NBCK+1.#                                         NI00 549
#                                                                       NI00 550
# MOVE ALL THE REST OF THE DATA TO THE BDF OUTPUT PACKET                NI00 551
# ------------------------------------------------------                NI00 552
#                                                                       NI00 553
DO I=2,NPAK#                                                            NI00 554
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 NI00 555
M=JP+IREL(I)#                          Get offsety                      NI00 556
QX(M)=DATUM(I)#                                                         NI00 557
MAXITM(I)=AMAX1(MAXITM(I),DATUM(I))#   Keep stats                       NI00 558
MINITM(I)=AMIN1(MINITM(I),DATUM(I))#                                    NI00 559
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 NI00 560
#                                                                       NI00 561
IF (LSTRFN<=-100000.)#                 Output first reflection number   NI00 562
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 NI00 563
ncodefld:(RFN,1,NI19,370813.,1)#                                        NI00 564
writeline:(1,NI19,NNI19,3,3)#                                           NI00 565
LSTRFN = 0.0#                                                           NI00 566
LINCT = 0#                                                              NI00 567
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 NI00 568
ELSE IF (RFN != LSTRFN+1.0)#           Check on reflection sequence     NI00 569
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 NI00 570
ncodefld:(LSTRFN,1,NI18,310713.,1)#                                     NI00 571
ncodefld:(RFN,1,NI18,410713.,1)#                                        NI00 572
writeline:(0,NI18,NNI18,3,3)#                                           NI00 573
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 NI00 574
LSTRFN=RFN#                                                             NI00 575
IF (RLIST!=0)#                         Print reflection data            NI00 576
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 NI00 577
KLIST = KLIST + 1#                                                      NI00 578
IF (MOD(KLIST,RLIST)==0)#                                               NI00 579
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 NI00 580
ncodefld:(HKL,1,CHROT,FMTREF,3)#                                        NI00 581
ncodefld:(TTH,1,CHROT,230822.,1)#                                       NI00 582
ncodefld:(OMG,1,CHROT,310822.,1)#                                       NI00 583
ncodefld:(PHI,1,CHROT,390822.,1)#                                       NI00 584
ncodefld:(CHI,1,CHROT,470822.,1)#                                       NI00 585
ncodefld:(IRL,1,CHROT,550813.,1)#                                       NI00 586
ncodefld:(SIR,1,CHROT,630813.,1)#                                       NI00 587
ncodefld:(EXPHRS,1,CHROT,690422.,1)#                                    NI00 588
ncodefld:(RFT,1,CHROT,720313.,1)#                                       NI00 589
ncodefld:(RFN,1,CHROT,800813.,1)#                                       NI00 590
writeline:(0,NI17,NNI17,1,3)#                                           NI00 591
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 NI00 592
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 NI00 593
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 NI00 594
#                                                                       NI00 595
# TELL WHAT HAPPENED SO USER AND PROGRAMMER WILL BE REASSURED.          NI00 596
# ---------------------------------------------                         NI00 597
#                                                                       NI00 598
ncodefld:(RFN,1,NI20,370813.,1)#                                        NI00 599
writeline:(1,NI20,NNI20,3,3)#          Write last reflection number     NI00 600
LINRM=4;writeline:(3,NI11,NNI11,3,3)#  Write general heading            NI00 601
ncodefld:(COUNTR,1,CHROT,FMTFIL,3)#                                     NI00 602
LINRM=8;writeline:(2,NI12,NNI12,1,3)#  Write packet totals              NI00 603
writeline:(0,0,0,1,3)#                                                  NI00 604
ncodefld:(NOBS,1,NI22,490813.,1)#      Write total regular refln.       NI00 605
writeline:(0,NI22,NNI22,3,3)#                                           NI00 606
ncodefld:(NMON,1,NI23,490813.,1)#      Write total monitor refln.       NI00 607
writeline:(0,NI23,NNI23,3,3)#                                           NI00 608
ncodefld:(NTAU,1,NI24,490813.,1)#      Write absorp. refln.             NI00 609
writeline:(0,NI24,NNI24,3,3)#                                           NI00 610
ncodefld:(NBCK,1,NI25,490813.,1)#      Write bckgrnd refln.             NI00 611
writeline:(0,NI25,NNI25,3,3)#                                           NI00 612
LINRM=4;N=-2;FOR(I=1 ; I<=3 ; I=I+1)#  Loop over hkl                    NI00 613
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 NI00 614
N=N+3;movechar:(NI14,N,CHROT,58,3,0)#  Move mnemonic                    NI00 615
BUFOT(1)=1.0;BUFOT(2)=FLOAT(WNT(1))#   Op word ; offset                 NI00 616
BUFOT(3)=MINHKL(I);BUFOT(4)=MAXHKL(I)# Minimum ; maximum                NI00 617
ncodefld:(BUFOT,1,CHROT,FMTHKL,4)#                                      NI00 618
writeline:(0,NI13,NNI13,1,3)#                                           NI00 619
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 NI00 620
writeline:(0,0,0,1,3)#                                                  NI00 621
LINRM=4;M=0;FOR(I=2;I<=NPAK;I=I+1)#    Loop over rest of pkt            NI00 622
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 NI00 623
IF(I<=(NBASE+2))N=N+3#                 Up n until the step counts       NI00 624
IF(I>=(NBASE+2))#                      Change mnemonic, then number     NI00 625
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 NI00 626
M=M+1;BUFOT(6)=FLOAT(M);ncodefld:(BUFOT(6),1,CHROT,FMTMAX(6),1)#        NI00 627
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 NI00 628
movechar:(NI14,N,CHROT,58,3,0)#                                         NI00 629
BUFOT(1)=FLOAT(I);BUFOT(2)=FLOAT(WNT(I))#                               NI00 630
BUFOT(3)=MINITM(I);BUFOT(4)=MAXITM(I);BUFOT(5)=FLOAT(IREL(I))#          NI00 631
ncodefld:(BUFOT,1,CHROT,FMTMAX,5)#                                      NI00 632
writeline:(0,NI13,NNI13,1,4)#                                           NI00 633
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 NI00 634
#                                                                       NI00 635
#     FINISH OFF THE BDF FILE                                           NI00 636
#     -----------------------                                           NI00 637
#                                                                       NI00 638
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Finish off copy               NI00 639
#                                                                       NI00 640
RETURN#                                                                 NI00 641
END#                                                                    NI00 642
pmacro:([no:])#                        Purge xtal system macros         NI00 643
