systemheader:(NM    )#                                                  NM     1
# ############################################################## #      NM     2
##      Copyright (C) 2000, The Xtal System, The University of        # NM     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # NM     4
## Distributed under the GNU General Public Licence as published by   # NM     5
## the Free Software Foundation, in the hope that it will be useful   # NM     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # NM     7
## for more details.                                                  # NM     8
#                                                                #      NM     9
#                         *** NEWMAN ***                         #      NM    10
#                                                                #      NM    11
#     PROGRAM TO GENERATE NEWMAN PROJECTIONS ABOUT ANY BOND.     #      NM    12
#                                                                #      NM    13
# ############################################################## #      NM    14
#                                                                       NM    15
include:(XMACRO)#                                                       NM    16
#                                                                       NM    17
macro:(m72:,incr:(arith:(71,/,mxchwd:)))#                               NM    18
macro:(swap:,$(QIQ=$2;$2=$1;$1=QIQ$))#                                  NM    19
#                                                                       NM    20
extrude:(NMCOMN)#                                                       NM    21
REAL    A(9)#       ## Cell axes, angles, cosines                       NM    22
REAL    BXMN#       ## Min. value in bond table                         NM    23
string:(ATYPE,128)# ## Atomtype identifiers                             NM    24
INTEGER INCA,INCA1,INCB,INCD,INCN,INCP,INCS,INCT# Increments            NM    25
INTEGER MARKA#      ## Qx pointer: atoms                                NM    26
#                   ## QX(MA+1)    X                                    NM    27
#                   ## QX(MA+2)    Y                                    NM    28
#                   ## QX(MA+3)    Z                                    NM    29
#                   ## QX(MA+4)    ATOM TYPE                            NM    30
#                   ## QX(MA+5)    ATOM NR                              NM    31
#                   ## QX(MA+6)    LENGTH OF ATOM ID                    NM    32
#                   ## QX(MA+INCA1)ATOM ID                              NM    33
INTEGER MARKB#      ## Qx pointer: bonds array                          NM    34
#                   ## QX(MB+1)    ATOM POINTER                         NM    35
#                   ## QX(MB+2)    NR OF BONDS / DISTANCE TO CENTRAL AT NM    36
INTEGER MARKD#      ## Qx pointer: bond distance table                  NM    37
INTEGER MARKN#      ## Qx pointer: newman projection data               NM    38
#                   ## QX(MN+1)    PNTR TO PERIPHERAL ATOM (IN MARKB)   NM    39
#                   ## QX(MN+2)    1/2 BONDED TO FRST/SCND CENTR. ATOM  NM    40
#                   ## QX(MN+3)    X-COORD., NORMALIZED                 NM    41
#                   ## QX(MN+4)    Y-COORD., NORMALIZED                 NM    42
#                   ## QX(MN+5)    PHI IN NEWMAN PROJECTION             NM    43
#                   ## QX(MN+6)    DIHEDRAL ANGLE BETWEEN 2 PERIPH.ATOM NM    44
INTEGER MARKP#      ## Qx pointer: projection axis                      NM    45
#                   ## QX(MP+1)    POINTER TO CENTER ATOM 1             NM    46
#                   ## QX(MP+2)    POINTER TO CENTER ATOM 2             NM    47
INTEGER MARKR#      ## Qx pointer: atom radii                           NM    48
INTEGER MARKS#      ## Qx pointer: symmetry                             NM    49
#                   ## QX(MS+ 1) TO QX(MS+ 9) ROTATION MATRIX           NM    50
#                   ## QX(MS+10) TO QX(MS+12) TRANSLATION VECTOR        NM    51
INTEGER MARKT#      ## Qx pointer: plot data                            NM    52
#                   ## QX(MT+1)    NR OF PLOTS/PAGE                     NM    53
#                   ## QX(MT+2)    WIDTH OF PLOT                        NM    54
#                   ## QX(MT+3)    HEIGHT OF PLOT                       NM    55
#                   ## QX(MT+4)    HEIGHT OF CHEMICAL SYMBOLS           NM    56
#                   ## QX(MT+5)    HEIGHT OF ANGLE VALUES               NM    57
#                   ## QX(MT+6)    HEIGHT OF CHARACTERS IN SUBTITLE     NM    58
#                   ## QX(MT+7)    HEIGHT OF CHARACTERS IN REG TITLE    NM    59
#                   ## QX(MT+8)    ETC NUMBERS OF THE PLOTS             NM    60
INTEGER MXPLPG#     ## Max number of plots/page                         NM    61
INTEGER NATTYP#     ## Number of atom types                             NM    62
INTEGER NCH#        ## Length of ch array in char.                      NM    63
INTEGER PLOT#       ## No:/yes: plots are to be made                    NM    64
INTEGER PLOTP#      ## Flag for plot data                               NM    65
INTEGER PROJAX#     ## Flag for projection axis                         NM    66
REAL    RAD#        ## Radians                                          NM    67
REAL    R(3,3)#     ## Cruickshank transformation matrix                NM    68
INTEGER STEPR#      ##                                                  NM    69
INTEGER STOPA,STOPB,STOPN,STOPP,STOPR,STOPS,STOPT# End of arrays        NM    70
string:(PTEXT,72)#  ## Text to plot                                     NM    71
string:(TIT,72)#    ## Title                                            NM    72
REAL    WIDTH#      ## Width of plot                                    NM    73
REAL    X(3)#       ## Atom coordinates                                 NM    74
#                                                                       NM    75
COMMON/COMINM/INCA,INCA1,INCB,INCD,INCN,INCP,INCS,INCT,#                NM    76
MARKA,MARKB,MARKD,MARKN,MARKP,MARKR,MARKS,MARKT,#                       NM    77
MXPLPG,NATTYP,NCH,PLOT,PLOTP,PROJAX,#                                   NM    78
STEPR,STOPA,STOPB,STOPN,STOPP,STOPR,STOPS,STOPT#                        NM    79
COMMON/COMFNM/A,BXMN,RAD,R,WIDTH,X#                                     NM    80
COMMON/COMCNM/ATYPE,PTEXT,TIT#                                          NM    81
endext:#                                                                NM    82
#                                                                       NM    83
systemheader:(NM00)#                   Main program                     NM00   1
# ################################################################ #    NM00   2
#                                                                  #    NM00   3
#                                 NM00                             #    NM00   4
#                                                                  #    NM00   5
# ################################################################ #    NM00   6
SUBROUTINE NM00#                       R. olthof-hazekamp               NM00   7
#                                        December 1986                  NM00   8
include:(AACOMN)#                                                       NM00   9
include:(NMCOMN)#                                                       NM00  10
#                                                                       NM00  11
FILEXT(IOUNIT(5))='NWM'#               Ext for newman plot file         NM00  12
#                                                                       NM00  13
CALL NM11#                             Read input lines & bdf           NM00  14
CALL NM21#                             Read rest of input lines         NM00  15
CALL NM31#                             Newman projection                NM00  16
#                                                                       NM00  17
RETURN#                                                                 NM00  18
END#                                                                    NM00  19
systemheader:(NM01)#                   Apply symmetry                   NM01   1
# ################################################################## #  NM01   2
#                                                                    #  NM01   3
#                               NM01                                 #  NM01   4
#                                                                    #  NM01   5
# ################################################################## #  NM01   6
SUBROUTINE NM01(MB)#                   R. olthof-hazekamp               NM01   7
#                                         March 1993                    NM01   8
include:(AACOMN)#                                                       NM01   9
include:(NMCOMN)#                                                       NM01  10
#                                                                       NM01  11
INTEGER J#                                                              NM01  12
INTEGER MA,MS#      ## Pointers                                         NM01  13
INTEGER MB#         ## Pointer in bond array                            NM01  14
INTEGER S#          ## Symmetrie code rot. & trans.                     NM01  15
INTEGER TR(3)#      ## Cell translations                                NM01  16
#                                                                       NM01  17
MA=NINT(QX(MB+1));S=NINT(QX(MB+3))#    Get at.pntr.;nsym and trans      NM01  18
MS=MARKS+(S/1000-1)*INCS#              Pntr to rot. & transl.           NM01  19
TR(1)=MOD(S/100,10)#                   Get x translation                NM01  20
TR(2)=MOD(S/10,10)#                    Get y translation                NM01  21
TR(3)=MOD(S,10)#                       Get z translation                NM01  22
DO J=0,2#                              Loop over the coords             NM01  23
X(J+1)=QX(MS+J+1)*QX(MA+1)$#           Symm. eq. coords                 NM01  24
      +QX(MS+J+4)*QX(MA+2)$#                                            NM01  25
      +QX(MS+J+7)*QX(MA+3)$#                                            NM01  26
      +QX(MS+J+10)+FLOAT(TR(J+1)-5)#   Add translations                 NM01  27
RETURN#                                                                 NM01  28
END#                                                                    NM01  29
systemheader:(NM11)#                   Read input lines and bdf         NM11   1
# ############################################################# #       NM11   2
#                                                               #       NM11   3
#                                NM11                           #       NM11   4
#                                                               #       NM11   5
# ############################################################# #       NM11   6
SUBROUTINE NM11#                       R. olthof-hazekamp               NM11   7
#                                        December 1986, march 1993      NM11   8
include:(AACOMN)#                                                       NM11   9
include:(NMCOMN)#                                                       NM11  10
#                                                                       NM11  11
REAL    AT#         ## Count of atoms                                   NM11  12
INTEGER ATNR#       ## Number in atom identifier                        NM11  13
INTEGER ATLEN#      ## Number of char in atom identifier                NM11  14
INTEGER ATTYP#      ## Atom type in atom identifier                     NM11  15
string:(CH1,24)#    ## Scratch char. array                              NM11  16
string:(CH2,24)#    ## Scratch char. array                              NM11  17
string:(TEMP,8)#                                                        NM11  18
INTEGER I,J,K,L,M,N# ##                                                 NM11  19
INTEGER ICNT,LTYP,MS,NROT,NRSZ,NS,NSYM#                                 NM11  20
INTEGER IP#         ## Pointer in bdf array                             NM11  21
INTEGER IREL(5)#    ## Relative pointers in bdf                         NM11  22
INTEGER IWANT(4)#   ## Wanted items in bdf                              NM11  23
INTEGER JUNK#       ##                                                  NM11  24
INTEGER KEY(4)#     ## Key for indexpkt:                                NM11  25
INTEGER MARK#       ## Start of data array                              NM11  26
INTEGER MA#      ##                                                     NM11  27
INTEGER NA#      ##                                                     NM11  28
INTEGER PACK#       ## Packet size in bdf array                         NM11  29
INTEGER REL#        ## Pointer in bdf array                             NM11  30
INTEGER SELECT#     ## No:/yes: selected atoms are input                NM11  31
INTEGER SELFLG#     ## No:/yes: atom is seleceted                       NM11  32
#                                                                       NM11  33
chardata:(NM111, ATRAD  SELECT BONDIN PROJAX PLOTP PTITLE END   )#      NM11  34
chardata:(NM112,-BXMN NPLT PLOT WDTH )#                                 NM11  35
chardata:(NM113,"H       C       N       O       S       $#             NM11  36
CL      BR      ")#                                                     NM11  37
chardata:(NM114,UPD NEW )#                                              NM11  38
chardata:(NM115, CELL CONSTANTS)#                                       NM11  39
chardata:(NM116, ATOM  MAX BOND RADIUS)#                                NM11  40
chardata:(NM118, MINIMUM DISTANCE =      )#                             NM11  41
chardata:(NM119, ATOM SITES)#                                           NM11  42
chardata:(NM11A,    X       Y       Z)#                                 NM11  43
realdata:(FMT1,[90852.,190852.,290852.,390852.,490852.,590852.])#       NM11  44
realdata:(FMT3,[852.,852.,852.])#                                       NM11  45
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              NM11  46
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              NM11  47
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              NM11  48
realdata:(TR21,[.3333333,.5])#                                          NM11  49
realdata:(TR22,[.6666667,0.])#                                          NM11  50
realdata:(TR23,[.6666667,.5])#                                          NM11  51
datastuff:#                                                             NM11  52
#                                                                       NM11  53
#        INITIALIZATIONS                                                NM11  54
#        ---------------                                                NM11  55
#                                                                       NM11  56
BXMN=.25;  RAD=45./ATAN2(1.,1.)#       No bdf; bond minimum             NM11  57
PLOT=no:;   MXPLPG=0;  WIDTH=11.#      Plot initializations             NM11  58
#                                                                       NM11  59
#      DECODE NEWMAN LINE                                               NM11  60
#      ------------------                                               NM11  61
#                                                                       NM11  62
FOR(I=1;I<=mxfdim:;I=I+1)#             Loop over input fields           NM11  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NM11  64
ifvo:(BUFIN(I)) BREAK#                 Break if void field              NM11  65
stringlim:(I,K,N)#                     Get string limits                NM11  66
compchar:(CHRIN,K,NM112,2,4,5,NNM112,L)# Compare code                   NM11  67
IF(L<=0) iquit:(NM1101)#               Wrong code                       NM11  68
IF(L==1)#                              Min bond distance                NM11  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NM11  70
I=I+1; IF(BUFIN(I)<0.) iquit:(NM1102)# No value present                 NM11  71
BXMN=BUFIN(I)#                         Minimum bond distance            NM11  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NM11  73
IF(L==2) PLOT=no:#                     No plot output file              NM11  74
IF(L==3)#                              Plot file requested              NM11  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  NM11  76
PLOT=yes:#                             Plot file requested              NM11  77
IF(BUFIN(I+1)>0.)#                     Plots/page                       NM11  78
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  NM11  79
I=I+1;MXPLPG=NINT(BUFIN(I))#           Plots/page                       NM11  80
IF(MXPLPG!=1 & MXPLPG!=4) iquit:(NM1103)# Wrong nr plots/page           NM11  81
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  NM11  82
ELSE MXPLPG=1#                         Default nr plots/page            NM11  83
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  NM11  84
IF(L==4)#                              Wdth                             NM11  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  NM11  86
I=I+1#                                 Incr pointer                     NM11  87
ifnv:(BUFIN(I)) WIDTH=BUFIN(I)#        Plot width                       NM11  88
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  NM11  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NM11  90
#                                                                       NM11  91
#        SET MEMORY                                                     NM11  92
#        ----------                                                     NM11  93
#                                                                       NM11  94
MARK=QXSTR#                            Start of data array              NM11  95
IOMARK(1)=MARK#                        Start of input buffer            NM11  96
MARK=IOMARK(1)+bdfbuf:#                Start of data array              NM11  97
IF(PLOT==yes:)#                        Plot file requested              NM11  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  NM11  99
IOMARK(5)=MARK#                        Start of plot file buffer        NM11 100
MARK=IOMARK(5)+bdfbuf:#                Start of data array              NM11 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  NM11 102
incrqx:(I,MARK+100,NM1109)#            Get memory for buffers           NM11 103
#                                                                       NM11 104
#        READ CELL FROM BDF                                             NM11 105
#        -------------------                                            NM11 106
#                                                                       NM11 107
readwpkt:(1,lrcell:,PACK,IP,0)#        Read lrcell:                     NM11 108
IF(IP<=0) iquit:(NM1104)#              Lrcell: absent                   NM11 109
movereal:(QX(IP+1),1,A,1,3,0)#         Store cell axes                  NM11 110
DO I=1,3;A(I+3)=QX(IP+6+I)*360.#       Angles in degrees                NM11 111
movereal:(QX(IP+1),4,A,7,3,0)#         Cosines                          NM11 112
#                                                                       NM11 113
#   EXTRACT SYMMETRY INFORMATION (LRSYMM)                               NM11 114
#   ------------------------------------                                NM11 115
#                                                                       NM11 116
readwpkt:(1,lrsymm:,PACK,IP,0)#        Read first packet of lrsym       NM11 117
LTYP=NINT(QX(IP+1))#                   Get out lattice type             NM11 118
ICNT=NINT(QX(IP+2))#                   Get out centro flag (nc=1)       NM11 119
NSYM=NINT(QX(IP+3))#                   Get out total symop count        NM11 120
NROT=NINT(QX(IP+4))#                   Extract number of matrices       NM11 121
NRSZ=NINT(QX(IP+5))#                   Extract no. same pattern zer     NM11 122
LTYP=LTYP-(1-ICNT)*7#                  Reduce ltyp to modulo 7          NM11 123
MARKS=MARK#                            Start of symmetry data           NM11 124
incrqx:(MARKD,MARKS+NSYM*12,NM1109)#   Incr qx........fs1006            NM11 125
FOR(MS=MARKS;MS<MARKD;MS=MS+PACK)#     Loop over symop packets          NM11 126
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  NM11 127
readwpkt:(1,lrsymm:,PACK,IP,0)#        Point to next packet             NM11 128
IF(IP<=0) BREAK#                       Exit after last packet           NM11 129
movereal:(QX,IP+1,QX,MS+1,PACK,1)#     Store 12-element symops          NM11 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  NM11 131
STOPS=MS;INCS=PACK#                    Mark end & step of symmetry      NM11 132
NS=STOPS#                              Set symm matrix pointer          NM11 133
IF(ICNT==0)#                           Test if centrosymmetric          NM11 134
FOR(MS=MARKS;MS<STOPS;MS=MS+1)#        Loop over symm matrices          NM11 135
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  NM11 136
NS=NS+1#                               Incr storage pointer             NM11 137
QX(NS)=-QX(MS+1)#                      Store inverse element            NM11 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  NM11 139
STOPS=NS#                              Store temp end marker            NM11 140
IF(LTYP>1)#                            Test if sg centered              NM11 141
FOR(MS=MARKS;MS<STOPS;MS=MS+INCS)#     Loop over symm matrices          NM11 142
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  NM11 143
movereal:(QX,MS+1,QX,NS+1,9,1)#        Transfer rot elements            NM11 144
QX(NS+10)=QX(MS+10)+TR11(LTYP-1)#      Transfer t1                      NM11 145
QX(NS+11)=QX(MS+11)+TR12(LTYP-1)#      Transfer t2                      NM11 146
QX(NS+12)=QX(MS+12)+TR13(LTYP-1)#      Transfer t3                      NM11 147
NS=NS+INCS#                            Incr storage pointer             NM11 148
IF(LTYP==2\LTYP>4) NEXT#               Skip if not r or f               NM11 149
movereal:(QX,MS+1,QX,NS+1,9,1)#        Transfer rot elements            NM11 150
QX(NS+10)=QX(MS+10)+TR21(LTYP-2)#      Transfer t1                      NM11 151
QX(NS+11)=QX(MS+11)+TR22(LTYP-2)#      Transfer t2                      NM11 152
QX(NS+12)=QX(MS+12)+TR23(LTYP-2)#      Transfer t3                      NM11 153
NS=NS+INCS#                            Incr storage pointer             NM11 154
IF(LTYP!=4) NEXT#                      Skip if not f-centre             NM11 155
movereal:(QX,MS+1,QX,NS+1,9,1)#        Transfer rot elements            NM11 156
QX(MS+10)=QX(NS+10)+0.5#               Transfer t1                      NM11 157
QX(MS+11)=QX(NS+11)+0.5#               Transfer t2                      NM11 158
QX(MS+12)=QX(NS+12)+0.0#               Transfer t3                      NM11 159
NS=NS+INCS#                            Incr storage pointer             NM11 160
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  NM11 161
STOPS=NS#                                                               NM11 162
#                                                                       NM11 163
#  ENTER FF TYPES FROM LRSCAT                                           NM11 164
#  --------------------------                                           NM11 165
#                                                                       NM11 166
MARKR=STOPS; NATTYP=0; STEPR=1#        Start/step ff table 4            NM11 167
IWANT(1)=11; IWANT(2)=5#               Ff name, bond radius             NM11 168
KEY(1)=1; KEY(2)=2; KEY(3)=0; KEY(4)=0# Search parameters               NM11 169
indexpkt:(1,lrscat:,PACK,IP,0,KEY,IWANT,IREL)# Search ff parameters     NM11 170
IF(KEY(1)<=0) iquit:(NM1106)#          No ff.....                       NM11 171
FOR(J=MARKR;J>0;J=STOPR)#              Loop over ff table               NM11 172
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 NM11 173
readwpkt:(1,lrscat:,PACK,IP,0)#        Read next ff packet              NM11 174
IF(IP<=0) BREAK#                       Exit if no more                  NM11 175
incrqx:(STOPR,J+STEPR,BN2104)#         Get memory for ff table          NM11 176
NATTYP=NATTYP+1#                       Count ff types                   NM11 177
K=IP+IREL(1)#                          Point ff name                    NM11 178
movertoc:(QX(K),1,ATYPE,NATTYP*8-7,8,0)# Store ff name                  NM11 179
K=IP+IREL(2); IF(K>IP) QX(J+1)=QX(K)#  Get max bond radius              NM11 180
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 NM11 181
#                                                                       NM11 182
#        READ ATRAD LINES                                               NM11 183
#        ----------------                                               NM11 184
#                                                                       NM11 185
readline:(NM111,NNM111)#               Read next line                   NM11 186
IF(LINID==1)#                          =atrad=                          NM11 187
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 NM11 188
movechar:(BLANK,1,TEMP,1,8,1)#         Blank out ff name                NM11 189
stringlim:(1,M,N)#                     Pick up atom type                NM11 190
movechar:(CHRIN,M,TEMP,1,N-M,0)#       Store ff name                    NM11 191
label:(TEMP,I,J,ATYPE,K)#              Identify atom type               NM11 192
IF(K==0) iquit:(NM1112)#               No match with ff                 NM11 193
I=MARKR+(K-1)*STEPR#                   Point to ff table                NM11 194
ifnv:(BUFIN(3)) QX(I+1)=BUFIN(3)#      Store bond radius                NM11 195
readline:(NM111,NNM111)#               Read next line                   NM11 196
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 NM11 197
writeline:(1,NM116,NNM116,3,3)#        Radii to be used.                NM11 198
FOR(L=MARKR;L<STOPR;L=L+STEPR)#        Loop over all atom types         NM11 199
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 NM11 200
IF(QX(L+1)<=small:) QX(L+1)=0.90#      Default bond radius              NM11 201
I=8*(L-MARKR)/STEPR#                   Point to atom type number        NM11 202
CHROT(2^9)=ATYPE(I+1^I+8)#             Insert atom type code            NM11 203
ncodefld:(QX,L+1,CHROT,160532.,1)#     Move radii to output line        NM11 204
writeline:(0,0,0,1,3)#                 Print radii                      NM11 205
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 NM11 206
MARKD=MARKR#                           First null atom radius           NM11 207
MARKA=STOPR#                           Last atom radius                 NM11 208
#                                                                       NM11 209
#        READ ATOM SELECTION                                            NM11 210
#        -------------------                                            NM11 211
#                                                                       NM11 212
MA=MARKA; INCA1=7; INCA=INCA1+5#       Set pointer in atom array        NM11 213
SELECT=no:#                            Set atom selection flag          NM11 214
REPEAT#                                Loop over input lines            NM11 215
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 NM11 216
IF(LINID!=2) BREAK#                    =select=                         NM11 217
SELECT=yes:#                           Set atom selection flag          NM11 218
DO I=1,mxfdim:#                        Loop over input fields           NM11 219
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 NM11 220
IF(BUFIN(I)>=voidflg:) BREAK#          Break after void field           NM11 221
stringlim:(I,K,N) N=MIN0(24,N-K)#      Get string limits                NM11 222
incrqx:(JUNK,MA+INCA,NM1109)#          Incr memory                      NM11 223
movector:(BLANK,1,QX(MA+INCA1),1,24,1)# Move blanks                     NM11 224
movector:(CHRIP,K,QX(MA+INCA1),1,N,0)# Move atom id                     NM11 225
label:(CHRIN(K^),ATLEN,ATNR,ATYPE,ATTYP)# Identify atom type            NM11 226
IF(ATTYP==0)#                          Test if atom type radii          NM11 227
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 NM11 228
iquit:(-NM1119);  NEXT#                Skip if at type unknown          NM11 229
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 NM11 230
QX(MA+4)=FLOAT(ATTYP)#                 Store atom type                  NM11 231
QX(MA+5)=FLOAT(ATNR)#                  Store atom number                NM11 232
QX(MA+6)=FLOAT(ATLEN)#                 Store length of atom id          NM11 233
MA=MA+INCA#                            Adjust pointer                   NM11 234
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 NM11 235
readline:(NM111,NNM111)#               Read next line                   NM11 236
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 NM11 237
#                                                                       NM11 238
#        READ ATOMS FROM BDF                                            NM11 239
#        -------------------                                            NM11 240
#                                                                       NM11 241
IWANT(1)=14#                           Atom id                          NM11 242
IWANT(2)=1;IWANT(3)=2;IWANT(4)=3#      X,y,z                            NM11 243
KEY(1)=4;KEY(2)=0;KEY(3)=0;KEY(4)=0#   4 items mandatory                NM11 244
indexpkt:(1,lratom:,PACK,IP,0,KEY,IWANT,IREL)# Read index packet        NM11 245
REPEAT#                                Loop over atom packets           NM11 246
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 NM11 247
readwpkt:(1,lratom:,PACK,IP,0)#        Read a packet                    NM11 248
IF(IP<=0) BREAK#                       Last packet read                 NM11 249
REL=IREL(1);movertoc:(QX(IP+REL),1,CH1,1,24,0)# Move atom label         NM11 250
label:(CH1,ATLEN,ATNR,ATYPE,ATTYP)#    Identify atom type               NM11 251
IF(ATTYP==0)#                          Test if atom type radii          NM11 252
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 NM11 253
iquit:(-NM1119);  NEXT#                Skip if at type unknown          NM11 254
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 NM11 255
SELFLG=yes:;NA=MA#                     Set selected flag and pointe     NM11 256
IF(SELECT==yes:)#                      If select flag is on             NM11 257
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 NM11 258
FOR(NA=MARKA;NA<MA;NA=NA+INCA)#        Loop over selected atoms         NM11 259
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 NM11 260
movertoc:(QX(NA+INCA1),1,CH2,1,24,0)#  Store atom name                  NM11 261
IF(CH1==CH2) BREAK#                    Exit if labels match             NM11 262
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 NM11 263
IF(NA>=MA) SELFLG=no:#                 If no match, selected flag o     NM11 264
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 NM11 265
IF(SELFLG==yes:)#                      If atom selected                 NM11 266
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 NM11 267
IF(SELECT==no:)#                       If no atom selection             NM11 268
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 NM11 269
incrqx:(JUNK,MA+INCA,NM1109)#          Incr memory                      NM11 270
QX(MA+4)=FLOAT(ATTYP)#                 Store atom type                  NM11 271
QX(MA+5)=FLOAT(ATNR)#                  Store atom number                NM11 272
QX(MA+6)=FLOAT(ATLEN)#                 Store length of atom id          NM11 273
movector:(CH1,1,QX(MA+INCA1),1,24,0)#  Move atom id                     NM11 274
MA=MA+INCA#                            Adjust pointer                   NM11 275
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 NM11 276
DO I=1,3#                              Loop over coordinates            NM11 277
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 NM11 278
REL=IREL(I+1);QX(NA+I)=QX(IP+REL)#     Store coordinates                NM11 279
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 NM11 280
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 NM11 281
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 NM11 282
STOPA=MA-1;MARKB=MA#                   Start of bonds array             NM11 283
readwpkt:(1,endrecord:,I,IP,0)#        Close down the binary file       NM11 284
#                                                                       NM11 285
#        WRITE PROGRAM DATA                                             NM11 286
#        ------------------                                             NM11 287
#                                                                       NM11 288
movechar:(NM112,1,CHROT,2,NNM115-1,2)# Insert header underline          NM11 289
writeline:(1,NM115,NNM115,2,3)#        Write cell header                NM11 290
ncodefld:(A,1,CHROT,FMT1,6)#           Encode cell constants            NM11 291
LINRM=5#                               Ask for 5 lines                  NM11 292
writeline:(0,0,0,1,3)#                 Cell constants                   NM11 293
#                                                                       NM11 294
ncodefld:(BXMN,1,NM118,240422.,1)#     Minimum bond distance            NM11 295
writeline:(1,NM118,NNM118,3,3)#        Write the line                   NM11 296
#                                                                       NM11 297
LINRM=12#                              Ask for 12 lines                 NM11 298
movechar:(NM112,1,CHROT,2,NNM119-1,2)# Insert header underline          NM11 299
writeline:(1,NM119,NNM119,2,3)#        Atom parameter list              NM11 300
LINRM=10;   AT=1.#                     10 lines; atom count             NM11 301
HEADOT=' '; HEADOT(LABMAX+14^)=NM11A#  Store atom header                NM11 302
DO MA=MARKA,STOPA,INCA#                Loop over atoms                  NM11 303
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 NM11 304
ncodefld:(AT,1,CHROT,40303.,1)#        Atom nr                          NM11 305
movertoc:(QX(MA+INCA1),1,CHROT,7,24,0)# Atom label                      NM11 306
LCHROT=LABMAX+10#                      Set format pointer               NM11 307
ncodefld:(QX(MA+1),1,CHROT,FMT3,3)#    X,y,z                            NM11 308
writeline:(0,HEADOT,100,1,3)#          Write the line                   NM11 309
AT=AT+1.#                              Add up one atom                  NM11 310
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 NM11 311
#                                                                       NM11 312
IF(LINID<=2) iquit:(NM1108)#           Input lines in wrong order       NM11 313
#                                                                       NM11 314
BXMN=BXMN*BXMN#                        Store square of distance         NM11 315
RETURN#                                                                 NM11 316
END#                                                                    NM11 317
systemheader:(NM21)#                   Read rest of lines               NM21   1
# ################################################################## #  NM21   2
#                                                                    #  NM21   3
#                                 NM21                               #  NM21   4
#                                                                    #  NM21   5
# ################################################################## #  NM21   6
SUBROUTINE NM21#                       R. olthof-hazekamp               NM21   7
#                                         December 1986, march 1993     NM21   8
include:(AACOMN)#                                                       NM21   9
include:(NMCOMN)#                                                       NM21  10
#                                                                       NM21  11
REAL    AT#                                                             NM21  12
INTEGER BONDIN#    ## Flag for bondin line                              NM21  13
string:(CH1,24)#   ## Atom identifiers                                  NM21  14
string:(CH2,24)#   ## Atom identifiers                                  NM21  15
REAL    D#         ## Used in calc. of cr. transf. matrix               NM21  16
INTEGER I,K,L,N#   ##                                                   NM21  17
INTEGER IWIW,JUNK,MP,NB#                                                NM21  18
INTEGER MA,MB,MT#  ## Pointers in mark arrays                           NM21  19
INTEGER NA#        ##                                                   NM21  20
INTEGER NBOND#     ## Number of bonds                                   NM21  21
INTEGER NPLOT#     ## Count of plots                                    NM21  22
REAL    RADIUS#    ## Bond distance                                     NM21  23
REAL    SINA,SING# ## Sin alfa & gamma                                  NM21  24
#                                                                       NM21  25
chardata:(NM211, BONDIN PROJAX PLOTP PTITLE END -)#                     NM21  26
chardata:(NM213, BONDING MATRIX)#                                       NM21  27
chardata:(NM214, SITE ATOM      BONDED TO --)#                          NM21  28
chardata:(NM215, PLOT DATA)#                                            NM21  29
chardata:(NM216, PL/PG WIDTH   HGT  H(S)  H(A) H(ST) H(TI)$#            NM21  30
 NPLOT                                   TITLE)#                        NM21  31
realdata:(FMT2,[40303.])#                                               NM21  32
realdata:(FMT3,[60503.,120522.,180522.,240522.,300522.,360522.,#        NM21  33
420522.,450303.,480303.,510303.,540303.])#                              NM21  34
datastuff:#                                                             NM21  35
#                                                                       NM21  36
#         BONDIN LINE INPUT                                             NM21  37
#         -----------------                                             NM21  38
#                                                                       NM21  39
LINID=LINID-2#                         Reset linid                      NM21  40
BONDIN=no:;MARKB=STOPA+1;INCB=3;NB=MARKB# Flag, start,inc,pntr          NM21  41
REPEAT#                                Loop over input lines            NM21  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NM21  43
IF(LINID!=1) BREAK#                    Not =bondin= line                NM21  44
BONDIN=yes:#                           Set bondin flag                  NM21  45
I=1;MB=NB#                             Set pointers                     NM21  46
REPEAT#                                Loop over input fields           NM21  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NM21  48
ifvo:(BUFIN(I)) BREAK#                 Break in void field              NM21  49
stringlim:(I,K,N)#                     Get string limits                NM21  50
CH1=CHRIP(K^N)#                        Store atom label                 NM21  51
DO NA=MARKA,STOPA,INCA#                Loop over atom array             NM21  52
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  NM21  53
movertoc:(QX(NA+INCA1),1,CH2,1,24,0)#  Move atom label                  NM21  54
IF(CH1==CH2) BREAK#                    Exit if labels match             NM21  55
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  NM21  56
IF(NA>STOPA) iquit:(NM2101)#           Wrong atom id                    NM21  57
incrqx:(JUNK,NB+INCB,NM2104)#          Incr memory                      NM21  58
QX(NB+1)=FLOAT(NA)#                    Store pointer to atom            NM21  59
QX(NB+3)=1555.#                        Default symmetry code            NM21  60
I=I+1#                                 Adjust input pointer             NM21  61
ifnv:(BUFIN(I))#                       Break in void field              NM21  62
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  NM21  63
stringlim:(I,K,N)#                     Get string limits                NM21  64
IF(CHRIN(K^K)=='(')#                   If character is '('              NM21  65
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  NM21  66
CALL NM23(NB,3,K,N);I=I+1#             Read symmetry code               NM21  67
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  NM21  68
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  NM21  69
IF(NB!=MB)#                            Peripheral atom                  NM21  70
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  NM21  71
CALL NM22(MB,NB,RADIUS)#               Calculate distance               NM21  72
IF(RADIUS<0.) iquit:(NM2102)#          Outside limits                   NM21  73
QX(NB+2)=RADIUS#                       Store distance                   NM21  74
QX(MB+2)=QX(MB+2)+1.#                  Store number of connections      NM21  75
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  NM21  76
NB=NB+INCB#                            Adjust pointer                   NM21  77
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NM21  78
readline:(NM211,NNM211)#               Read next line                   NM21  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NM21  80
#                                                                       NM21  81
#        CALCULATION OF BONDING MATRIX                                  NM21  82
#        -----------------------------                                  NM21  83
#                                                                       NM21  84
IF(BONDIN==no:)#                       Not =bondin= input               NM21  85
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  NM21  86
DO MA=MARKA,STOPA,INCA#                Loop over atom array             NM21  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  NM21  88
incrqx:(JUNK,NB+2*INCB,NM2104)#        Get more memory                  NM21  89
MB=NB;NB=NB+INCB#                      Save and adjust pointer          NM21  90
QX(MB+1)=FLOAT(MA)#                    Store pointer to atom 1          NM21  91
QX(MB+3)=1555.#                        Default symmetry code            NM21  92
DO NA=MARKA,STOPA,INCA#                Loop over atoms                  NM21  93
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  NM21  94
IF(NA==MA) NEXT#                       Same atom                        NM21  95
QX(NB+1)=FLOAT(NA)#                    Store pointer to atom 2          NM21  96
QX(NB+3)=1555.#                        Default symmetry code            NM21  97
IF(MB!=NB) CALL NM22(MB,NB,RADIUS)#    Calculate distance               NM21  98
ELSE RADIUS=0.#                        Central atom                     NM21  99
IF(RADIUS<0.) NEXT#                    Outside limits                   NM21 100
QX(NB+2)=RADIUS#                       Store distance                   NM21 101
NB=NB+INCB#                            Adjust pointer                   NM21 102
incrqx:(JUNK,NB+INCB,NM2104)#          Incr memory                      NM21 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  NM21 104
QX(MB+2)=FLOAT((NB-MB)/INCB-1)#        Store nr of connections          NM21 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  NM21 106
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  NM21 107
STOPB=NB-1#                            End of bonding matrix            NM21 108
#                                                                       NM21 109
#        PROJAX LINE INPUT                                              NM21 110
#        -----------------                                              NM21 111
#                                                                       NM21 112
PROJAX=no:;MARKP=STOPB+1;INCP=4;MP=MARKP-INCP/2# Flag,start,inc,pntr    NM21 113
STOPP=MARKP+1#                         Default end                      NM21 114
REPEAT#                                Loop over input lines            NM21 115
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 NM21 116
IF(LINID!=2) BREAK#                    Not =projax=                     NM21 117
PROJAX=yes:#                           Set flag                         NM21 118
I=1#                                   Input fields                     NM21 119
REPEAT#                                Loop over input fields           NM21 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 NM21 121
ifvo:(BUFIN(I)) BREAK#                 Last field was read              NM21 122
stringlim:(I,K,N)#                     Get string limits                NM21 123
IF(CHRIN(K^K)!='(')#                   If character is '('              NM21 124
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 NM21 125
movechar:(CHRIN,K,CH1,1,N,0)#          Move atom label                  NM21 126
CH1=CHRIP(K^N)#                        Store atom label                 NM21 127
DO NA=MARKA,STOPA,INCA#                Loop over the atoms              NM21 128
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 NM21 129
movertoc:(QX(NA+INCA1),1,CH2,1,24,0)#  Move atom label                  NM21 130
IF(CH1==CH2) BREAK#                    Exit if labels match             NM21 131
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 NM21 132
IF(NA>STOPA) iquit:(NM2103)#           Wrong atom id                    NM21 133
MP=MP+INCP/2#                          Adjust pointer                   NM21 134
incrqx:(STOPP,MP+INCP,NM2104)#         Incr memory                      NM21 135
QX(MP+1)=FLOAT(NA)#                    Store pntr to atom               NM21 136
QX(MP+2)=1555.#                        Default symmetry code            NM21 137
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 NM21 138
ELSE CALL NM23(MP,2,K,N)#              Read symmetry code               NM21 139
I=I+1#                                 Incr pointer                     NM21 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 NM21 141
readline:(NM211,NNM211)#               Read next line                   NM21 142
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 NM21 143
STOPP=STOPP-1#                         End of projax array              NM21 144
#                                                                       NM21 145
#         PLOTP AND PTITLE LINE INPUT                                   NM21 146
#         ---------------------------                                   NM21 147
#                                                                       NM21 148
PLOTP=no:;MARKT=STOPP+1;INCT=11+m72:;MT=MARKT# Flag,start,inc,p         NM21 149
NPLOT=0#                               Nr of plots                      NM21 150
REPEAT#                                Loop over input lines            NM21 151
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 NM21 152
QX(MT+1)=FLOAT(MXPLPG)#                Default max plots/page           NM21 153
QX(MT+2)=WIDTH#                        Default width                    NM21 154
QX(MT+3)=WIDTH#                        Default height                   NM21 155
QX(MT+4)=.02*WIDTH#                    Default height of symbols        NM21 156
QX(MT+5)=.02*WIDTH#                    Default height of angles         NM21 157
QX(MT+6)=.02*WIDTH#                    Default height of title          NM21 158
QX(MT+7)=.02*WIDTH#                    Default height of t              NM21 159
FOR(I=8;I<=7+NINT(QX(MT+1));I=I+1)#    Loop over plots/pag              NM21 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 NM21 161
NPLOT=NPLOT+1#                         Count nr of plots                NM21 162
QX(MT+I)=FLOAT(NPLOT)#                 Next nr                          NM21 163
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 NM21 164
movechar:(BLANK,1,TIT,1,72,1)#         Move 72 blanks                   NM21 165
movechar:(COMPID,1,TIT,34,6,0)#        Move title                       NM21 166
IF(LINID!=3) BREAK#                    Not =plotp= line                 NM21 167
ifnv:(BUFIN(1)) QX(MT+1)=BUFIN(1)#     Nr of plots/page                 NM21 168
FOR(I=2;I<=7+NINT(QX(MT+1));I=I+1)#    Loop over input line             NM21 169
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 NM21 170
ifnv:(BUFIN(I))#                                                        NM21 171
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 NM21 172
QX(MT+I)=BUFIN(I)#                     Nr of the plot                   NM21 173
IF(I>7) PLOTP=yes:#                    Sequence number input            NM21 174
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 NM21 175
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 NM21 176
readline:(NM211,NNM211)#               Read next line                   NM21 177
IF(LINID==4)#                          =ptitle= line                    NM21 178
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 NM21 179
movechar:(CHRIN,8,TIT,1,72,0)#         Move title                       NM21 180
readline:(NM211,NNM211)#               Read next line                   NM21 181
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 NM21 182
MT=MT+INCT#                            Adjust pointer                   NM21 183
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 NM21 184
IF(PLOTP==no:) STOPT=MARKT+INCT-1#     Stop of plot data                NM21 185
ELSE           STOPT=MT-1#             Idem                             NM21 186
#                                                                       NM21 187
#        CALCULATION OF ORTHOGONALISATION MATRIX                        NM21 188
#        ---------------------------------------                        NM21 189
#                                                                       NM21 190
SINA=SQRT(1.-A(7)*A(7))#                                                NM21 191
SING=SQRT(1.-A(9)*A(9))#                                                NM21 192
D=(A(8)-A(7)*A(9))/SING#                                                NM21 193
R(1,1)=A(1)*SING;R(1,2)=0.;R(1,3)=A(3)*D#                               NM21 194
R(2,1)=A(1)*A(9);R(2,2)=A(2);R(2,3)=A(3)*A(7)#                          NM21 195
R(3,1)=0.;R(3,2)=0.;R(3,3)=A(3)*SQRT(SINA*SINA-D*D)#                    NM21 196
#                                                                       NM21 197
#        WRITE PROGRAM INFORMATION                                      NM21 198
#        -------------------------                                      NM21 199
#                                                                       NM21 200
LINRM=10#                              Ask for 10 lines                 NM21 201
movechar:(NM214,27,CHROT,2,NNM213-1,2)# Insert header underline         NM21 202
writeline:(1,NM213,NNM213,2,3)#        Bonding matrix                   NM21 203
AT=1.;  MB=MARKB#                      Count atoms; pntr in bond a.     NM21 204
REPEAT#                                Loop over bonds                  NM21 205
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 NM21 206
IF(MB>=MARKP) BREAK#                   Last bond output                 NM21 207
MA=NINT(QX(MB+1))#                     Pointer to central atom          NM21 208
NBOND=MIN0(NINT(QX(MB+2)),10)#         Nr of bonds                      NM21 209
ncodefld:(AT,1,CHROT,FMT2,1)#          Atom nr                          NM21 210
movertoc:(QX(MA+INCA1),1,CHROT,7,8,0)# Move atom id                     NM21 211
L=17#                                  Pointer in chrot                 NM21 212
FOR(I=1;I<=NBOND;I=I+1)#               Loop over the bonds              NM21 213
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 NM21 214
MB=MB+INCB#                            Adjust pointer                   NM21 215
MA=NINT(QX(MB+1))#                     Pointer to peripheral atom       NM21 216
movertoc:(QX(MA+INCA1),1,CHROT,L,8,0)# Move atom id                     NM21 217
L=L+10#                                Adjust pointer                   NM21 218
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 NM21 219
writeline:(0,NM214,NNM214,1,3)#        Write the line                   NM21 220
AT=AT+1.;   MB=MB+INCB#                Incr counts and pntr             NM21 221
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 NM21 222
#                                                                       NM21 223
IF(PLOT==yes:)#                        Plot file requested              NM21 224
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 NM21 225
LINRM=4#                               4 lines must be present          NM21 226
movechar:(NM214,27,CHROT,2,NNM215-1,2)# Insert header underline         NM21 227
writeline:(1,NM215,NNM215,2,3)#        Plot data                        NM21 228
DO MT=MARKT,STOPT,INCT#                Loop over plot data              NM21 229
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 NM21 230
IWIW=MIN(72,prtcmax:-56)#              Set max length of title          NM21 231
ifne:(QX(MT+8),-1)#                                                     NM21 232
ncodefld:(QX(MT+1),1,CHROT,FMT3,11)#   Encode the data                  NM21 233
ELSE#                                                                   NM21 234
ncodefld:(QX(MT+1),1,CHROT,FMT3,7)#    Encode the data                  NM21 235
movechar:(TIT,1,CHROT,56,IWIW,0)#      Title                            NM21 236
writeline:(0,NM216,NNM216,1,3)#        Write data                       NM21 237
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 NM21 238
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 NM21 239
#                                                                       NM21 240
RETURN#                                                                 NM21 241
END#                                                                    NM21 242
systemheader:(NM22)#                   Calculate distance               NM22   1
# ################################################################## #  NM22   2
#                                                                    #  NM22   3
#                               NM22                                 #  NM22   4
#                                                                    #  NM22   5
# ################################################################## #  NM22   6
SUBROUTINE NM22(MB,NB,RADIUS)#         R. olthof-hazekamp               NM22   7
#                                         December 1986, march 1993     NM22   8
include:(AACOMN)#                                                       NM22   9
include:(NMCOMN)#                                                       NM22  10
#                                                                       NM22  11
INTEGER ATTYP1#     ## Type of atom 1                                   NM22  12
INTEGER ATTYP2#     ## Type of atom 2                                   NM22  13
INTEGER MA#         ## Pointer to atom 1                                NM22  14
INTEGER NA#         ## Pointer to atom 2                                NM22  15
INTEGER MB,NB#                         Pointers                         NM22  16
REAL    BXMX#       ## Max bond distance**2                             NM22  17
REAL    RADIUS#     ## Distance                                         NM22  18
REAL    XN,YN,ZN#   ## Delta x,y,z (a)                                  NM22  19
#                                                                       NM22  20
CALL NM01(NB)#                         Calc equiv. position atom 2      NM22  21
XN=X(1);YN=X(2);ZN=X(3)#               (new) coordinates atom 2         NM22  22
CALL NM01(MB)#                         Calc eqiv. position atom 1       NM22  23
XN=A(1)*(XN-X(1))#                     Delta x (a)                      NM22  24
YN=A(2)*(YN-X(2))#                     Delta y (a)                      NM22  25
ZN=A(3)*(ZN-X(3))#                     Delta z (a)                      NM22  26
RADIUS=XN*XN+YN*YN+ZN*ZN+2*$#          Distance**2                      NM22  27
      (XN*YN*A(9)+XN*ZN*A(8)+YN*ZN*A(7))#                               NM22  28
MA=NINT(QX(MB+1));NA=NINT(QX(NB+1))#   Pntr to atom 1 and 2             NM22  29
ATTYP1=NINT(QX(MA+4))#                 Type of atom 1                   NM22  30
ATTYP2=NINT(QX(NA+4))#                 Type of atom 2                   NM22  31
BXMX=(QX(MARKD+ATTYP1)+QX(MARKD+ATTYP2)+0.15)**2# Max distance**2       NM22  32
IF(RADIUS>BXMX \ RADIUS<BXMN) RADIUS=-1.# Outside limits                NM22  33
ELSE RADIUS=SQRT(RADIUS)#                                               NM22  34
#                                                                       NM22  35
RETURN#                                                                 NM22  36
END#                                                                    NM22  37
systemheader:(NM23)#                   Read symmetry operation          NM23   1
# ################################################################## #  NM23   2
#                                                                    #  NM23   3
#                                 NM23                               #  NM23   4
#                                                                    #  NM23   5
# ################################################################## #  NM23   6
SUBROUTINE NM23(M,M1,K,N)#             R. olthof-hazekamp               NM23   7
#                                         March 1993                    NM23   8
include:(AACOMN)#                                                       NM23   9
include:(NMCOMN)#                                                       NM23  10
#                                                                       NM23  11
string:(C,1)#      ## One character from input string                   NM23  12
INTEGER K,L,N#     ##                                                   NM23  13
INTEGER M,M1#      ## Pointer & offset in mark array                    NM23  14
INTEGER NT#        ## Number of translation vectors                     NM23  15
INTEGER KEY#                                                            NM23  16
#                                                                       NM23  17
QX(M+M1)=0.;NT=0#                      Prepare for input symops         NM23  18
DO L=K+1,N-1#                          Loop over this string            NM23  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NM23  20
C=CHRIN(L^L)#                          Store current character          NM23  21
IF(C==' '\C==')') NEXT#                Skip blanks                      NM23  22
IF(C=='_')#                            Test for translation             NM23  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NM23  24
NT=1;NEXT#                             Count translation input          NM23  25
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NM23  26
KEY=INDEX('0123456789',C)#             Identify the number              NM23  27
IF(KEY==0) iquit:(NM2301)#             Only numbers allowed             NM23  28
IF(NT>0) NT=NT+1#                      Count translations               NM23  29
QX(M+M1)=10.*QX(M+M1)+FLOAT(KEY-1)#    Calculate symop nr               NM23  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NM23  31
IF(NT==0) QX(M+M1)=QX(M+M1)*1000.+555.# Add zero translation            NM23  32
ELSE IF(NT!=4) iquit:(NM2301)#         Illegal translation input        NM23  33
RETURN#                                                                 NM23  34
END#                                                                    NM23  35
systemheader:(NM31)#                   Newman projection                NM31   1
# ####################################################################  NM31   2
#                                                                       NM31   3
#                                     NM31                              NM31   4
#                                                                       NM31   5
# ####################################################################  NM31   6
SUBROUTINE NM31#                       R. olthof-hazekamp               NM31   7
#                                         December 1986, march 1993     NM31   8
include:(AACOMN)#                                                       NM31   9
include:(NMCOMN)#                                                       NM31  10
#                                                                       NM31  11
INTEGER JUNK#    ##                                                     NM31  12
INTEGER LB,KB,NB## Pointer in markb array                               NM31  13
INTEGER MB,MN,MP,MT## Pointers in mark array                            NM31  14
INTEGER MBOND,NBOND## Number of bonds to atoms 1 & 2                    NM31  15
INTEGER IPLOT#   ## Count of plots                                      NM31  16
INTEGER IPLPG#   ## Count of diagrams/plot                              NM31  17
INTEGER INB,IMB# ## Loop limits                                         NM31  18
#                                                                       NM31  19
MARKN=STOPT+1; INCN=6#                 Start & incr newman array        NM31  20
IF(PLOTP==no:) MT=MARKT#               Point to plot data               NM31  21
ELSE           MT=MARKT-INCT#          Idem                             NM31  22
IPLOT=0;   MXPLPG=NINT(QX(MARKT+1))#   Count of plots;plots/page        NM31  23
IPLPG=MXPLPG+1#                        Start count of plots/page        NM31  24
IF(PLOT==yes:) CALL NM34(0.,0.,0.,0.,0.,0.,1)# Init plot                NM31  25
#                                                                       NM31  26
#        SEARCH FOR CENTRAL AND PERIPHERAL ATOMS                        NM31  27
#        ---------------------------------------                        NM31  28
#                                                                       NM31  29
FOR(MP=MARKP;MP<=STOPP;MP=MP+INCP)#    Loop over newman plots           NM31  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NM31  31
FOR(MB=MARKB;MB<=STOPB;MB=IMB+INCB)#   Loop 1 over bonded sets          NM31  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NM31  33
MBOND=NINT(QX(MB+2)); IMB=MB+MBOND*INCB# Number of bonds                NM31  34
IF(MBOND<2) NEXT#                      Minimum is 2                     NM31  35
IF(PROJAX==yes:)#                      Projection axis is defined       NM31  36
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  NM31  37
ifne:(QX(MB+1),QX(MP+1)) NEXT#         Skip this bonding set            NM31  38
ifne:(QX(MB+3),QX(MP+2)) NEXT#         Skip this bonding set            NM31  39
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  NM31  40
#                                                                       NM31  41
FOR(NB=MARKB;NB<=STOPB;NB=INB+INCB)#   Loop 2 over the bonded sets      NM31  42
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  NM31  43
NBOND=NINT(QX(NB+2)); INB=NB+NBOND*INCB# Number of bonds                NM31  44
IF(NB==MB\NBOND<2) NEXT#               Same bonded set                  NM31  45
IF(PROJAX==yes:)#                      Proj. axis is defined            NM31  46
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  NM31  47
ifne:(QX(NB+1),QX(MP+3)) NEXT#         Skip this bonding set            NM31  48
ifne:(QX(NB+3),QX(MP+4)) NEXT#         Skip this bonding set            NM31  49
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  NM31  50
FOR(LB=NB+INCB;LB<=INB;LB=LB+INCB)#    Loop over the bonds              NM31  51
ifeq:(QX(MB+1),QX(LB+1))#              Exit if equal atoms              NM31  52
ifeq:(QX(MB+3),QX(LB+3)) BREAK#        And if equal symmetry code       NM31  53
FOR(KB=MB+INCB;KB<=IMB;KB=KB+INCB)#    Loop over the bonds              NM31  54
ifeq:(QX(NB+1),QX(KB+1))#              Exit if equal atoms              NM31  55
ifeq:(QX(NB+3),QX(KB+3)) BREAK#        Andif equal symmetry code        NM31  56
IF(LB>INB&KB>IMB) NEXT#                Not 2 central atoms found        NM31  57
IF(LB>INB\KB>IMB) iquit:(NM3101)#      Error in bonding matrix          NM31  58
#                                                                       NM31  59
MN=MARKN#                              Set pointer in newman array      NM31  60
FOR(LB=MB+INCB;LB<=IMB;LB=LB+INCB)#    Loop over the bonds              NM31  61
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  NM31  62
ifeq:(QX(NB+1),QX(LB+1)) NEXT#         Skip if same atom                NM31  63
incrqx:(JUNK,MN+INCN,NM3102)#          Incr memory                      NM31  64
QX(MN+1)=FLOAT(LB)#                    Store pointer to central at      NM31  65
QX(MN+2)=1.#                           Store 1.                         NM31  66
MN=MN+INCN#                            Adjust pointer                   NM31  67
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  NM31  68
FOR(LB=NB+INCB;LB<=INB;LB=LB+INCB)#    Loop over the bonds              NM31  69
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  NM31  70
ifeq:(QX(MB+1),QX(LB+1)) NEXT#         Skip if same atom                NM31  71
incrqx:(JUNK,MN+INCN,NM3102)#          Incr memory                      NM31  72
QX(MN+1)=FLOAT(LB)#                    Store pointer to central at      NM31  73
QX(MN+2)=2.#                           Store 2.                         NM31  74
MN=MN+INCN#                            Adjust pointer                   NM31  75
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  NM31  76
STOPN=MN-1#                            End of newman array              NM31  77
#                                                                       NM31  78
#    PRINT/PLOT THE NEWMAN PROJECTION                                   NM31  79
#    --------------------------------                                   NM31  80
#                                                                       NM31  81
IPLOT=IPLOT+1#                         Add up one plot                  NM31  82
CALL NM32(MB,NB,IPLOT)#                Calc and print projection        NM31  83
IF(PLOT>0)#                            Plot(s) wanted                   NM31  84
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  NM31  85
IF(IPLPG>MXPLPG)#                      Start a new plot                 NM31  86
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  NM31  87
IF(PLOTP==yes: & (MT+INCT)<STOPT)#     Plot data present                NM31  88
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 NM31  89
MT=MT+INCT#                            Incr pointer                     NM31  90
MXPLPG=NINT(QX(MT+1))#                 Max plots/page                   NM31  91
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 NM31  92
IPLPG=1#                               Reset nr of plots/page           NM31  93
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  NM31  94
IF(PLOTP==no: \ IPLOT==NINT(QX(MT+7+IPLPG)))# Plot requested            NM31  95
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 NM31  96
CALL NM33(MB,NB,MT,IPLOT,IPLPG)#       Draw the plot                    NM31  97
IPLPG=IPLPG+1#                         Add up 1 plot                    NM31  98
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 NM31  99
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  NM31 100
IF(PROJAX==yes:) BREAK#                Break from loop in bonding m     NM31 101
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  NM31 102
IF(PROJAX==yes:) BREAK#                Break from loop in bonding m     NM31 103
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NM31 104
IF(PROJAX==no: ) BREAK#                Break from loop in bonding m     NM31 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NM31 106
#                                                                       NM31 107
IF(PLOT==yes:) CALL NM34(0.,0.,0.,0.,0.,0.,10)# End the plot            NM31 108
#                                                                       NM31 109
RETURN#                                                                 NM31 110
END#                                                                    NM31 111
systemheader:(NM32)#                   Calc & print projection          NM32   1
# ################################################################## #  NM32   2
#                                                                    #  NM32   3
#                               NM32                                 #  NM32   4
#                                                                    #  NM32   5
# ################################################################## #  NM32   6
SUBROUTINE NM32(I1,I2,IPLOT)#          R. olthof-hazekamp               NM32   7
#                                         December 1986, march 1993     NM32   8
include:(AACOMN)#                                                       NM32   9
include:(NMCOMN)#                                                       NM32  10
#                                                                       NM32  11
REAL    ALFA(3)#    ##                                                  NM32  12
string:(CR(33),67)# ## <<<< THIS MAY EXCEED MAX FOR SOME MACHINES       NM32  13
REAL    COSP#       ## Cos(phi)#                                        NM32  14
REAL    DX(3)#      ## Delta x,y,z                                      NM32  15
REAL    DIST#       ## Distance                                         NM32  16
REAL    FACT#       ## Normalization factor                             NM32  17
REAL    FMT#        ## Output format                                    NM32  18
REAL    FORM(3,3)#  ##                                                  NM32  19
REAL ARG,DIST0,QIQ,Y#                                                   NM32  20
INTEGER IPLOT,JUNK,K1,K2,L,MB,NN#                                       NM32  21
INTEGER I,J,K#      ##                                                  NM32  22
INTEGER I1,I2#      ## Pointers to bond sets                            NM32  23
INTEGER IC1,IC2#    ## Pointers to central atoms                        NM32  24
INTEGER ISX#        ## Sign of ix                                       NM32  25
INTEGER IX,IY#      ##                                                  NM32  26
INTEGER IXA#        ## Abs. value of ix                                 NM32  27
INTEGER IY1#        ##                                                  NM32  28
INTEGER IYFLG#      ## Flag for y coord.                                NM32  29
INTEGER MA,MN#      ## Pointers in mark arrays                          NM32  30
REAL    OPT(3)#     ##                                                  NM32  31
REAL    ORTHO(3,3)# ##                                                  NM32  32
REAL    PHI#        ## Newman angle                                     NM32  33
REAL    PSI#        ## Bond angle                                       NM32  34
REAL    PROD#       ## Dist**2 in proj.                                 NM32  35
REAL    PROJ(3,3)#  ##                                                  NM32  36
REAL    SCL#        ## Scale to newman normalized newman coords         NM32  37
REAL    SH,SV#      ## Hor. and vert. scale factors                     NM32  38
REAL    SINP#       ## Sin(phi)                                         NM32  39
REAL    XNEW(3)#    ## Newman coordinates                               NM32  40
REAL    X1(3)#      ## Coordinates of atom 1                            NM32  41
REAL    Y1#         ##                                                  NM32  42
REAL    ZET#        ## Z-value                                          NM32  43
#                                                                       NM32  44
chardata:(NM321, TRANSFORMATION MATRIX (FRACTIONAL TO NEWMAN))#         NM32  45
chardata:(NM322, DISTANCE BETWEEN CENTRAL ATOMS)#                       NM32  46
chardata:(NM323, 1. 2. ANGSTROMS)#                                      NM32  47
chardata:(NM324, LENGTH OF THE ANGLE BETWEEN THE CENTRAL ATOM)#         NM32  48
chardata:(NM325, PERIPHERAL ATOMS NORMALIZED NEWMAN COORDINATES $#      NM32  49
PERIPHERAL BONDS)#                                                      NM32  50
chardata:(NM326, X= Y= LENGTH = ANGLE = DEGR AND)#                      NM32  51
chardata:(NM327, IS PROJECTED ON THE ORIGIN)#                           NM32  52
chardata:(NM328,+-0)#                                                   NM32  53
chardata:(NM329, DIHEDRAL ANGLE BETWEEN THE ATOMS)#                     NM32  54
chardata:(NM32A,    . PROJECTION ALONG THE          -           BOND)#  NM32  55
chardata:(NM32B, THIS NEWMAN PROJECTION HAS BEEN PLOTTED)#              NM32  56
realdata:(FMT1,[110952.,210952.,310952.])#                              NM32  57
realdata:(FMT2,[210852.,300852.,390852.,550642.,670642.,840522.,#       NM32  58
1030512.])#                                                             NM32  59
datastuff:#                                                             NM32  60
#                                                                       NM32  61
SCL=FLOAT(prtcpin:)/FLOAT(prtlpin:)#   Scale factor to newman coord     NM32  62
SH=AMIN1(32./SCL,32.)#                 Hor.  scale factor               NM32  63
SV=AMIN1(16.*SCL,16.)#                 Vert. scale factor               NM32  64
#                                                                       NM32  65
#         CREATION OF ORTHOGONAL BASIS                                  NM32  66
#         ----------------------------                                  NM32  67
#                                                                       NM32  68
IC1=NINT(QX(I1+1))#                    Pointer to central atom 1        NM32  69
IC2=NINT(QX(I2+1))#                    Pointer to central atom 2        NM32  70
CALL NM01(I1)#                         Calc equiv.pos. atom 1           NM32  71
DO I=1,3;X1(I)=X(I)#                   Save coordinates atom 1          NM32  72
CALL NM01(I2)#                         Calc equi.pos. atom 2            NM32  73
DO I=1,3;DX(I)=X(I)-X1(I)#             Dx,dy,dz                         NM32  74
DO I=1,3;DO J=1,3;ORTHO(I,J)=0.#       Init ortho                       NM32  75
DO I=1,3;DO J=1,3;ORTHO(I,3)=ORTHO(I,3)+R(I,J)*DX(J)#                   NM32  76
IF(ABS(ORTHO(1,3))<small: & ABS(ORTHO(2,3))<small:)#                    NM32  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NM32  78
ifeq:(ORTHO(3,3),0.) iquit:(NM3201)#   N                                NM32  79
DO I=1,3;DO J=1,3;PROJ(I,J)=R(I,J)#                                     NM32  80
ALFA(3)=1./ABS(ORTHO(3,3))#                                             NM32  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NM32  82
ELSE#                                                                   NM32  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NM32  84
ORTHO(1,1)=-ORTHO(2,3)#                                                 NM32  85
ORTHO(2,1)= ORTHO(1,3)#                                                 NM32  86
ORTHO(3,1)=0.#                                                          NM32  87
ORTHO(1,2)= ORTHO(1,3)*ORTHO(3,3)#                                      NM32  88
ORTHO(2,2)= ORTHO(3,3)*ORTHO(2,3)#                                      NM32  89
ORTHO(3,2)=-ORTHO(1,3)*ORTHO(1,3)-ORTHO(2,3)*ORTHO(2,3)#                NM32  90
DO I=1,3;OPT(I)=0.#                                                     NM32  91
DO I=1,3;DO J=1,3;OPT(I)=OPT(I)+ORTHO(J,I)*ORTHO(J,I)#                  NM32  92
DO I=1,3;ALFA(I)=1./SQRT(OPT(I))#                                       NM32  93
DO I=1,3;DO J=1,3;FORM(I,J)=ALFA(I)*ORTHO(J,I)#                         NM32  94
DO I=1,3;DO J=1,3;PROJ(I,J)=0.#                                         NM32  95
DO I=1,3;DO J=1,3;DO K=1,3;PROJ(I,J)=PROJ(I,J)+FORM(I,K)*R(K,J)#        NM32  96
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NM32  97
DIST0=1./ALFA(3)#                                                       NM32  98
#                                                                       NM32  99
#         PRINT TRANSFORMATION MATRIX AND CENTRAL ATOMS                 NM32 100
#         ---------------------------------------------                 NM32 101
#                                                                       NM32 102
LINRM=prtlmax:#                        New page                         NM32 103
writeline:(1,NM321,NNM321,3,3)#        Transf. matrix                   NM32 104
LINRM=0#                               Reset linrm                      NM32 105
DO I=1,3#                              Loop over the rows               NM32 106
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  NM32 107
ncodefld:(PROJ(1,I),1,CHROT,FMT1,3)#   Encode a row                     NM32 108
writeline:(0,0,0,1,3)#                 Write a row                      NM32 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  NM32 110
#                                                                       NM32 111
movechar:(NM322,19,CHROT,2,13,0)#      Central atoms                    NM32 112
movechar:(NM322,1,CHROT,71,NNM322,0)#  Dist. between central atoms      NM32 113
writeline:(1,0,0,1,3)#                 Write the line                   NM32 114
movechar:(NM323,2,CHROT,2,2,0)#        Move 1.                          NM32 115
movertoc:(QX(IC1+INCA1),1,CHROT,5,8,0)# Id of atom 1                    NM32 116
ncodefld:(X1(1),1,CHROT,FMT2,3)#       Encode x,y,z                     NM32 117
movechar:(NM322,2,CHROT,72,8,0)#       Distance                         NM32 118
ncodefld:(DIST0,1,CHROT,FMT2(6),1)#    Encode distance                  NM32 119
movechar:(NM323,8,CHROT,91,9,0)#       Angstroms                        NM32 120
writeline:(0,0,0,1,3)#                 Write the line                   NM32 121
movechar:(NM323,5,CHROT,2,2,0)#        Move 2.                          NM32 122
movertoc:(QX(IC2+INCA1),1,CHROT,5,8,0)# Id of central atom 2            NM32 123
ncodefld:(X(1),1,CHROT,FMT2,3)#        Encode x,y,z                     NM32 124
writeline:(0,0,0,1,3)#                 Write the line                   NM32 125
#                                                                       NM32 126
#         CALCULATE AND PRINT NEWMAN COORDINATES                        NM32 127
#         --------------------------------------                        NM32 128
#                                                                       NM32 129
movechar:(NM325,19,CHROT,48,10,0)#     Normalized                       NM32 130
movechar:(NM324,2,CHROT,72,13,0)#      Length of the                    NM32 131
movechar:(NM324,16,CHROT,91,25,0)#     Angle between the central        NM32 132
writeline:(1,0,0,1,3)#                 Write the line                   NM32 133
movechar:(NM325,2,CHROT,2,16,0)#       Peripheral atoms                 NM32 134
movechar:(NM325,30,CHROT,48,18,0)#     Newman coordinates               NM32 135
movechar:(NM325,49,CHROT,91,16,0)#     Peripheral bonds                 NM32 136
writeline:(0,0,0,1,3)#                 Write the line                   NM32 137
#                                                                       NM32 138
DO MN=MARKN,STOPN,INCN#                Loop over newman data            NM32 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  NM32 140
MB=NINT(QX(MN+1));MA=NINT(QX(MB+1))#   Pointer to atom                  NM32 141
CALL NM01(MB)#                         Calc equiv.pos. peripheral at.   NM32 142
DO I=1,3;DX(I)=X(I)-X1(I)#             Dx,dy,dz                         NM32 143
DO I=1,3;XNEW(I)=0.#                   Init newman coord                NM32 144
DO I=1,3;DO J=1,3;XNEW(I)=XNEW(I)+PROJ(I,J)*DX(J)#                      NM32 145
PROD=XNEW(1)*XNEW(1)+XNEW(2)*XNEW(2)#  Dist**2 in proj.                 NM32 146
ZET=XNEW(3)#                           Z coord                          NM32 147
IF(QX(MN+2)>1.) ZET=DIST0-ZET#         Z, rel to central atom 2         NM32 148
DIST=SQRT(ZET*ZET+PROD)#               Total atom distance              NM32 149
IF(PROD>0.)#                           Positive proj. dist.             NM32 150
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  NM32 151
ARG=ZET/DIST#                          Argument                         NM32 152
PSI=ACOS(ARG)*RAD#                     Bond angle                       NM32 153
FACT=1./SQRT(PROD)#                    Normalization factor             NM32 154
QX(MN+3)=FACT*XNEW(1)#                 X-newman                         NM32 155
QX(MN+4)=FACT*XNEW(2)#                 Y-newman                         NM32 156
QX(MN+5)=ATAN2(QX(MN+4),QX(MN+3))*RAD# Proj. angle                      NM32 157
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  NM32 158
movertoc:(QX(MA+INCA1),1,CHROT,2,8,0)# Id of periph. atom               NM32 159
ncodefld:(QX(MA+1),1,CHROT,FMT2,3)#    Encode x,y,z                     NM32 160
IF(QX(MN+2)<2.) movechar:(NM323,2,CHROT,42,2,0)# Move 1.                NM32 161
ELSE movechar:(NM323,5,CHROT,42,2,0)#  Move 2.                          NM32 162
IF(PROD>0.)#                           Positive distance                NM32 163
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  NM32 164
movechar:(NM326,2,CHROT,47,2,0)#       X=                               NM32 165
movechar:(NM326,5,CHROT,59,2,0)#       Y=                               NM32 166
ncodefld:(QX(MN+3),1,CHROT,FMT2(4),2)# X,y newman                       NM32 167
movechar:(NM326,8,CHROT,72,8,0)#       Length =                         NM32 168
ncodefld:(DIST,1,CHROT,FMT2(6),1)#     Encode distance                  NM32 169
movechar:(NM326,17,CHROT,86,1,0)#      A                                NM32 170
movechar:(NM326,17,CHROT,91,7,0)#      Angle =                          NM32 171
ncodefld:(PSI,1,CHROT,FMT2(7),1)#      Angle                            NM32 172
movechar:(NM326,25,CHROT,105,4,0)#     Degrees                          NM32 173
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  NM32 174
ELSE#                                  Projection on origin             NM32 175
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  NM32 176
QX(MN+5)=999.#                         Dummy value                      NM32 177
movechar:(NM327,1,CHROT,47,NNM327,0)#  Projection on origin             NM32 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  NM32 179
writeline:(0,0,0,1,3)#                 Write the line                   NM32 180
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  NM32 181
#                                                                       NM32 182
#         SORT THE PSI VALUES                                           NM32 183
#         -------------------                                           NM32 184
#                                                                       NM32 185
DO MN=MARKN,STOPN,INCN#                Loop over peripheral atoms       NM32 186
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  NM32 187
DO NN=MN,STOPN,INCN#                   Loop over rest of periph. at     NM32 188
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  NM32 189
IF(QX(MN+5)<=QX(NN+5)) NEXT#           Skip if second is larger         NM32 190
DO I=1,5;swap:(QX(MN+I),QX(NN+I))#     Swap the values                  NM32 191
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  NM32 192
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  NM32 193
WHILE(QX(STOPN+4)>360.) STOPN=STOPN-INCN# Max. 360 degr. is allowed     NM32 194
incrqx:(JUNK,STOPN+INCN,NM3202)#       Incr memory for one more rec     NM32 195
movereal:(QX(MARKN+1),1,QX(STOPN+2),1,INCN,0)# Move first atom to end   NM32 196
QX(STOPN+6)=QX(STOPN+6)+360.#          Add up 360 degr                  NM32 197
#                                                                       NM32 198
#         ENCODE LINES, ATOM ID'S AND ANGLES OF NEWMAN PROJECTION       NM32 199
#         -------------------------------------------------------       NM32 200
#                                                                       NM32 201
DO I=1,33#                                                              NM32 202
movechar:(BLANK,1,CR(I),1,67,1)#       Move blanks into cr              NM32 203
movechar:(NM328,3,CR(17),34,1,0)#      Move =o=                         NM32 204
DO MN=MARKN,STOPN,INCN#                Loop over periph. atoms          NM32 205
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 NM32 206
IX=NINT(QX(MN+3)*SH)#                  X position                       NM32 207
IY=NINT(QX(MN+4)*SV)#                  Y position                       NM32 208
IF(IX!=0) FACT=FLOAT(IY)/FLOAT(IX)#                                     NM32 209
IXA=IABS(IX)#                                                           NM32 210
IF(IX>0) ISX=1#                        Sign                             NM32 211
ELSE     ISX=-1#                                                        NM32 212
L=NINT(QX(MN+2))#                      1 or 2                           NM32 213
IYFLG=999#                                                              NM32 214
FOR(I=0;I<=IXA;I=I+1)#                 Loop over x positions            NM32 215
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 NM32 216
IF(IXA!=0)#                            Not first point                  NM32 217
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 NM32 218
IX=ISX*I#                              X position                       NM32 219
Y=FACT*FLOAT(IX)#                      Y coordinate                     NM32 220
IY=NINT(Y)#                            Y position                       NM32 221
Y1=FACT*FLOAT(IX+ISX)#                                                  NM32 222
IY1=NINT(Y1)#                                                           NM32 223
IF(IYFLG==IY1) NEXT#                                                    NM32 224
ELSE ifne:(FACT,0.) IYFLG=999#                                          NM32 225
IF(IY==IY1)#                                                            NM32 226
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 NM32 227
IF(ABS(Y-FLOAT(IY))>ABS(Y1-FLOAT(IY1))) NEXT#                           NM32 228
IYFLG=IY;I=I+1#                                                         NM32 229
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 NM32 230
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 NM32 231
K1=17+IY;K2=34+IX#                                                      NM32 232
movechar:(NM328,L,CR(K1),K2,1,0)#                                       NM32 233
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 NM32 234
#                                                                       NM32 235
MB=NINT(QX(MN+1))#                                                      NM32 236
MA=NINT(QX(MB+1));L=NINT(QX(MA+6))#                                     NM32 237
IF(IX>=0) K2=K2+2#                                                      NM32 238
ELSE K2=K2-L-1#                                                         NM32 239
movertoc:(QX(MA+INCA1),1,CR(K1),K2,L,0)#                                NM32 240
#                                                                       NM32 241
QX(MN+6)=QX(MN+INCN+5)-QX(MN+5)#                                        NM32 242
PHI=QX(MN+6)#                          Dihedral angle                   NM32 243
IF(QX(MN+INCN+2)>1.) QX(MN+6)=-QX(MN+6)#                                NM32 244
COSP=COS(.5*PHI/RAD);SINP=SIN(.5*PHI/RAD)#                              NM32 245
I=NINT((QX(MN+3)*COSP-QX(MN+4)*SINP)*.666667*SH)#                       NM32 246
J=NINT((QX(MN+3)*SINP+QX(MN+4)*COSP)*.666667*SV)#                       NM32 247
K1=17+J;K2=1#                                                           NM32 248
IF(PHI<10) L=34+I#                                                      NM32 249
ELSE       L=35+I#                                                      NM32 250
FMT=10000.*FLOAT(L)+303.#                                               NM32 251
ncodefld:(PHI,1,CR(K1)(K2^),FMT,1)#                                     NM32 252
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 NM32 253
QX(STOPN+7)=QX(MARKN+6)#                                                NM32 254
#                                                                       NM32 255
#         PRINT NEWMAN PROJECTION AND DIHEDRAL ANGLES                   NM32 256
#         -------------------------------------------                   NM32 257
#                                                                       NM32 258
movechar:(NM329,1,CHROT,71,NNM329,0)#                                   NM32 259
writeline:(1,0,0,1,3)#                                                  NM32 260
MN=MARKN#                                                               NM32 261
DO J=33,1,-1#                                                           NM32 262
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 NM32 263
movechar:(CR(J),1,CHROT,2,67,0)#                                        NM32 264
IF(MN<STOPN)#                                                           NM32 265
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 NM32 266
MB=NINT(QX(MN+1));MA=NINT(QX(MB+1))#   Point to atom array              NM32 267
movertoc:(QX(MA+INCA1),1,CHROT,72,8,0)# Move atom id 1                  NM32 268
movechar:(NM326,30,CHROT,79,3,0)#      And                              NM32 269
MB=NINT(QX(MN+INCN+1));MA=NINT(QX(MB+1))# Point to atom array           NM32 270
movertoc:(QX(MA+INCA1),1,CHROT,85,8,0)# Move atom id 2                  NM32 271
movechar:(NM326,23,CHROT,97,3,0)#      Angle                            NM32 272
ncodefld:(QX(MN+6),1,CHROT,FMT2(7),1)# Encode angle                     NM32 273
movechar:(NM326,25,CHROT,105,4,0)#     Degr                             NM32 274
MN=MN+INCN#                            Adjust pointer                   NM32 275
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 NM32 276
writeline:(0,0,0,1,3)#                 Write the line                   NM32 277
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 NM32 278
#                                                                       NM32 279
ncodefld:(FLOAT(IPLOT),1,NM32A,40303.,1)# Encode plot nr                NM32 280
movertoc:(QX(IC1+INCA1),1,NM32A,28,8,0)# Id of central atom 1           NM32 281
movertoc:(QX(IC2+INCA1),1,NM32A,39,8,0)# Id of central atom 2           NM32 282
writeline:(1,NM32A,NNM32A,3,3)#        Write the line                   NM32 283
IF(PLOT==yes:)#                        Plot file requested              NM32 284
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 NM32 285
movechar:(NM32B,1,CHROT,71,NNM32B,0)#  Newman proj has been plotted     NM32 286
writeline:(0,0,0,1,3)#                 Write the line                   NM32 287
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 NM32 288
STOPN=STOPN+INCN#                      Set final stop                   NM32 289
#                                                                       NM32 290
RETURN#                                                                 NM32 291
END#                                                                    NM32 292
systemheader:(NM33)#                   Generate the plot file           NM33   1
# ############################################################### #     NM33   2
#                                                                 #     NM33   3
#                                  NM33                           #     NM33   4
#                                                                 #     NM33   5
# ############################################################### #     NM33   6
SUBROUTINE NM33(MB,NB,MT,IPLOT,IPLPG)# R. olthof-hazekamp               NM33   7
#                                       December 1986, march 1993       NM33   8
include:(AACOMN)#                                                       NM33   9
include:(NMCOMN)#                                                       NM33  10
#                                                                       NM33  11
string:(CHA,72)#                                                        NM33  12
REAL    COSP#      ## Cos(phi)                                          NM33  13
REAL    COSPMN#    ## Cos(phimin)                                       NM33  14
REAL    F#         ## Factor                                            NM33  15
REAL    FH,FW#     ## Full height and width of plot                     NM33  16
INTEGER I#         ##                                                   NM33  17
INTEGER IPLOT#     ## Plot count                                        NM33  18
INTEGER IPLPG#     ## Nr of plot/page                                   NM33  19
INTEGER MA,MN#     ## Pointer in mark arrays                            NM33  20
INTEGER MB,MT,NA,NB,NP#                                                 NM33  21
REAL AA,D,FV,PSI#                                                       NM33  22
REAL    FMT#       ## Number format                                     NM33  23
REAL    PH,PW#     ## Height and width of diagram                       NM33  24
REAL    PHI#       ## Newman angle                                      NM33  25
REAL    PHIMIN#    ## Min. phi to keep angle value                      NM33  26
REAL    R1,R2,R3,R4## Radii for circle, angles-values, radii, atom id   NM33  27
INTEGER ROTB,ROTF# ## Rotate backwards, forwards                        NM33  28
REAL    RR#        ## Variable ri                                       NM33  29
REAL    SINP#      ## Sin(phi)                                          NM33  30
REAL    SINPMN#    ## Sin(phimin)                                       NM33  31
REAL    XP,YP#     ## Plot coordinates                                  NM33  32
REAL    XC,YC#     ## Coordinates of center                             NM33  33
#                                                                       NM33  34
chardata:(NM331,DOWN - )#                                               NM33  35
datastuff:#                                                             NM33  36
#                                                                       NM33  37
#         INITIALIZATIONS                                               NM33  38
#         ---------------                                               NM33  39
#                                                                       NM33  40
MXPLPG=NINT(QX(MT+1))#                 Max nr of plots/page             NM33  41
IF(MXPLPG==1) PW=QX(MT+2)#             Plot width                       NM33  42
ELSE          PW=.5*QX(MT+2)#          Idem                             NM33  43
IF(MXPLPG==1) PH=QX(MT+3)#             Plot height                      NM33  44
ELSE          PH=.5*QX(MT+3)#          Idem                             NM33  45
R1=AMIN1(PW,PH)/12.#                   Radius unit                      NM33  46
R2=2.*R1;  R3=3.*R1;  R4=4.*R1#        Radii                            NM33  47
XC=.5*PW;  YC=.5*PH#                   Plot centres                     NM33  48
IF(IPLPG==2 \ IPLPG==4) XC=XC+PW#      Right part of plot               NM33  49
IF(IPLPG>2)             YC=YC+PH#      Upper part of plot               NM33  50
PHIMIN=2.*ASIN(0.50*QX(MT+5)/R2)*RAD#  Min. torsion angle, 1 digit      NM33  51
COSPMN=COS(PHIMIN/RAD);SINPMN=SIN(PHIMIN/RAD)#                          NM33  52
#                                                                       NM33  53
#         SET PLOT SCALE                                                NM33  54
#         -----------                                                   NM33  55
#                                                                       NM33  56
IF(IPLPG==1)#                          First part of plot               NM33  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NM33  58
FW=QX(MT+2)#                           Full width                       NM33  59
FH=QX(MT+3)+2.*QX(MT+7)#               Full height                      NM33  60
IF(IPLOT!=NINT(QX(MARKT+8))) CALL NM34(0.,0.,0.,0.,0.,0.,2)# Frame      NM33  61
ELSE CALL NM34(FW,FH,1.,1.,0.,0.,6)#   Set plot scales                  NM33  62
#ELSE CALL NM34(FW,FH,1.,1.,FW,FH,6)#   SET PLOT SCALES                 NM33  63
#                                                                       NM33  64
#         DRAW REGULAR TITLE                                            NM33  65
#         ------------------                                            NM33  66
#                                                                       NM33  67
XP=.5*QX(MT+2)-216.*QX(MT+7)/7.#       X start of regular litle         NM33  68
YP=QX(MT+3)+.5*QX(MT+7)#               Y start of reg. title            NM33  69
movechar:(TIT,1,PTEXT,1,72,0)#         Title to plot                    NM33  70
CALL NM34(XP,YP,QX(MT+7),0.,72.,0.,5)# Regular title                    NM33  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NM33  72
#                                                                       NM33  73
#         DRAW DIAGRAM BORDERS                                          NM33  74
#         --------------------                                          NM33  75
IF(IPLPG==1 & MXPLPG==4)#              First of 4 plots                 NM33  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NM33  77
CALL NM34(PW,0.,0.,0.,0.,3.,3)#        Start vertical line              NM33  78
CALL NM34(PW,2.*PH,0.,0.,-6000.,2.,3)# End vertical line                NM33  79
CALL NM34(0.,PH,0.,0.,0.,3.,3)#        Start horizontal line            NM33  80
CALL NM34(2.*PW,PH,0.,0.,-6000.,2.,3)# End horizontal line              NM33  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NM33  82
#                                                                       NM33  83
#         DRAW SUBTITLE                                                 NM33  84
#         -------------                                                 NM33  85
#                                                                       NM33  86
MA=NINT(QX(MB+1));  NA=NINT(QX(NB+1))# Point to central atoms           NM33  87
movechar:(BLANK,1,CHA,1,72,1)#         Blank char buffer                NM33  88
movechar:(NM331,1,CHA,1,5,0)#          Insert 'down '                   NM33  89
movertoc:(QX(MA+INCA1),1,CHA,6,NINT(QX(MA+6)),0)# Id of atom 1          NM33  90
I=NINT(QX(MA+6))+7#                    Adjust pointer                   NM33  91
movechar:(NM331,6,CHA,I,2,0)#          Insert '- '                      NM33  92
I=I+2#                                 Adjust pointer                   NM33  93
movertoc:(QX(NA+INCA1),1,CHA,I,NINT(QX(NA+6)),0)# Id of atom 2          NM33  94
AA=FLOAT(I-1)+QX(NA+6)#                Adjust pointer                   NM33  95
XP=XC-3.*AA*QX(MT+6)/7.#               X start of title                 NM33  96
YP=YC-.5*PH+.5*QX(MT+6)#               Y start of title                 NM33  97
movechar:(CHA,1,PTEXT,1,NINT(AA),0)#   Move to real                     NM33  98
CALL NM34(XP,YP,QX(MT+6),0.,AA,0.,5)#                                   NM33  99
#                                                                       NM33 100
#         DRAW CIRCLE                                                   NM33 101
#         -----------                                                   NM33 102
#                                                                       NM33 103
CALL NM34(0.,R1,XC,YC,0.,3.,3)#        Start of circle                  NM33 104
DO I=10,360,10#                        Loop over degrees                NM33 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  NM33 106
XP=R1*SIN(FLOAT(I)/RAD);YP=R1*COS(FLOAT(I)/RAD)# X,y                    NM33 107
IF(ABS(XP)<=small:) XP=0.;IF(ABS(YP)<=small:) YP=0.#                    NM33 108
CALL NM34(XP,YP,XC,YC,1000.,2.,3)#     Plot circle                      NM33 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  NM33 110
#                                                                       NM33 111
#         DRAW RADII FOR ALL ATOMS                                      NM33 112
#         ------------------------                                      NM33 113
#                                                                       NM33 114
ROTF=no:#                                                               NM33 115
DO MN=MARKN,STOPN,INCN#                Loop over newman data            NM33 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  NM33 117
ROTB=ROTF;ROTF=no:#                                                     NM33 118
XP=0.;YP=0.#                           X,y start of radial line         NM33 119
ifeq:(QX(MN+2),2.)#                    Attached to second center at     NM33 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  NM33 121
XP=R1*QX(MN+3);YP=R1*QX(MN+4)#         X,y start of radial line         NM33 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  NM33 123
CALL NM34(XP,YP,XC,YC,0.,3.,3)#        Call plot                        NM33 124
XP=R3*QX(MN+3);YP=R3*QX(MN+4)#         X,y   end of radial line         NM33 125
CALL NM34(XP,YP,XC,YC,1000.,2.,3)#     Call plot                        NM33 126
#                                                                       NM33 127
#         DRAW ANGLE VALUE                                              NM33 128
#         ----------------                                              NM33 129
#                                                                       NM33 130
PHI=ABS(QX(MN+6))#                     Phi                              NM33 131
COSP=COS(.5*PHI/RAD);SINP=SIN(.5*PHI/RAD)# Cos; sin                     NM33 132
XP=R2*(QX(MN+3)*COSP-QX(MN+4)*SINP)#   X position of phi value          NM33 133
YP=R2*(QX(MN+3)*SINP+QX(MN+4)*COSP)#   Y position of phi value          NM33 134
IF(PHI>=100.)     NP=3#                Number of digits of phi value    NM33 135
ELSE IF(PHI>=10.) NP=2#                                                 NM33 136
ELSE              NP=1#                                                 NM33 137
FV=QX(MT+5);FH=FV*6./7.*NP#            Vert/hor word size               NM33 138
F=FV/7.#                               Char step size                   NM33 139
PSI=ATAN2(YP,XP)#                      Angle in proj.                   NM33 140
D=ABS(FH*SIN(PSI))+ABS(FV*COS(PSI))#   Length of value perp.radius      NM33 141
IF(.90*PHI/RAD*R2<D)#                  If small angle                   NM33 142
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  NM33 143
ROTF=yes:#                             Rotate atom id forwards          NM33 144
RR=R3+QX(MT+5)#                        New radius                       NM33 145
COSP=RR*COS(.5*PHI/RAD);SINP=RR*SIN(.5*PHI/RAD)# Cos; sin               NM33 146
XP=QX(MN+3)*COSP-QX(MN+4)*SINP#        New x                            NM33 147
YP=QX(MN+3)*SINP+QX(MN+4)*COSP#        New y                            NM33 148
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  NM33 149
IF(MN==MARKN) NEXT#                    Do not draw value/atom id        NM33 150
XP=XC+XP-3.0*FLOAT(NP)*F#              X                                NM33 151
YP=YC+YP-.5*QX(MT+5)#                  Y                                NM33 152
FMT=NP*10100+13#                                                        NM33 153
CALL NM34(XP,YP,QX(MT+5),PHI,0.,FMT,4)# Call plot                       NM33 154
#                                                                       NM33 155
#         DRAW ATOM IDENTIFIER                                          NM33 156
#         --------------------                                          NM33 157
#                                                                       NM33 158
MA=NINT(QX(MN+1));MA=NINT(QX(MA+1))#   Point to atom                    NM33 159
IF(ROTB==yes:)#                        If small torsion angle           NM33 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  NM33 161
XP=XC+R4*(QX(MN+3)*COSPMN-QX(MN+4)*SINPMN)# Rotate char. position       NM33 162
YP=YC+R4*(QX(MN+3)*SINPMN+QX(MN+4)*COSPMN)# X,y of center               NM33 163
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  NM33 164
ELSE IF(ROTF==yes:)#                   If small torsion angle           NM33 165
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  NM33 166
XP=XC+R4*(QX(MN+3)*COSPMN+QX(MN+4)*SINPMN)# Rotate forwards             NM33 167
YP=YC-R4*(QX(MN+3)*SINPMN-QX(MN+4)*COSPMN)# X,y of center of symbol     NM33 168
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  NM33 169
ELSE#                                  Large torsion angle              NM33 170
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  NM33 171
XP=XC+R4*QX(MN+3)#                     X center of symbol               NM33 172
YP=YC+R4*QX(MN+4)#                     Y center of symbol               NM33 173
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  NM33 174
XP=XP-3.*QX(MT+4)*QX(MA+6)/7.#         X start of symbol                NM33 175
YP=YP-.5*QX(MT+4)#                     Y start of symbol                NM33 176
movertoc:(QX(MA+INCA1),1,PTEXT,1,NINT(QX(MA+6)),0)# Name for plot       NM33 177
CALL NM34(XP,YP,QX(MT+4),0.,QX(MA+6),0.,5)# Call plot                   NM33 178
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  NM33 179
#                                                                       NM33 180
RETURN#                                                                 NM33 181
END#                                                                    NM33 182
systemheader:(NM34)#                   Write packet to plot file        NM34   1
# ############################################################### #     NM34   2
#                                                                 #     NM34   3
#                                  NM34                           #     NM34   4
#                                                                 #     NM34   5
# ############################################################### #     NM34   6
SUBROUTINE NM34(P1,P2,P3,P4,P5,P6,KEY)# R. olthof-hazekamp              NM34   7
#                                         December 1986                 NM34   8
include:(AACOMN)#                                                       NM34   9
include:(NMCOMN)#                                                       NM34  10
#                                                                       NM34  11
INTEGER I,L,M,N#  ##                                                    NM34  12
INTEGER IP#       ## Pointer in output buffer                           NM34  13
INTEGER KEY#      ## 1=start of plot                                    NM34  14
#                 ## 2=FRAME ADVANCE SIGNAL                             NM34  15
#                 ## 3=PEN MOVEMENT                                     NM34  16
#                 ## 4=DRAW NUMBER                                      NM34  17
#                 ## 5=DRAW CHARACTER STRING                            NM34  18
#                 ## 6=PLOT SCALE                                       NM34  19
#                 ## 10=END OF PLOT                                     NM34  20
REAL    P1,P2,P3,P4,P5,P6#          ## Parameters                       NM34  21
#                                                                       NM34  22
writepkt:(5,23,7,IP)#                  Init for new packet              NM34  23
QX(IP+1)=P1#                           Parameter 1                      NM34  24
QX(IP+2)=P2#                           Parameter 2                      NM34  25
QX(IP+3)=P3#                           Parameter 3                      NM34  26
QX(IP+4)=P4#                           Parameter 4                      NM34  27
QX(IP+5)=P5#                           Parameter 5                      NM34  28
QX(IP+6)=P6#                           Parameter 6                      NM34  29
QX(IP+7)=FLOAT(KEY)#                   Function key                     NM34  30
#                                                                       NM34  31
IF(KEY==5)#                            Character string                 NM34  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  NM34  33
QX(IP+6)=0.#                           Dummy                            NM34  34
N=NINT(P5);   M=arith:(7,*,mxchwd:)#   Nr of words in string            NM34  35
FOR(I=1;I<=N;I=I+M)#                   Loop over packets                NM34  36
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  NM34  37
writepkt:(5,23,7,IP)#                  Init for next packet             NM34  38
L=MIN0(M,N-I+1)#                       Length of packet                 NM34  39
movector:(PTEXT,1,QX(IP+1),1,L,0)#     Move buffer to packet            NM34  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  NM34  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  NM34  42
#                                                                       NM34  43
IF(KEY==10)#                           End plot                         NM34  44
writepkt:(5,endrecord:,3,IP)#          Write last record                NM34  45
#                                                                       NM34  46
RETURN#                                                                 NM34  47
END#                                                                    NM34  48
pmacro:([no:])#                                                         NM34  49
