systemheader:(OS    )#                                                  OS     1
####################################################################### OS     2
##              Copyright (C) 2002, The GNU Xtal System               # OS     3
##                                                                    # OS     4
## Distributed under the GNU General Public Licence as published by   # OS     5
## the Free Software Foundation, in the hope that it will be useful   # OS     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # OS     7
## for more details.                                                  # OS     8
##                                                                    # OS     9
##                        *** OUTSRC ***                              # OS    10
##                                                                    # OS    11
##             OUTSRC - OUTPUT VALRAY/SHELX/XD  CONTROL FILES         # OS    12
##                                                                    # OS    13
##          D. du Boulay Nov 2002 ddb@R3401.msl.titec.ac.jp           # OS    14
##                                                                    # OS    15
####################################################################### OS    16
#                                                                       OS    17
include:(XMACRO)#                                                       OS    18
#                                                                       OS    19
macro:(shelx:, 1)#                     Outsource mode                   OS    20
macro:(valray:,2)#                     Outsource mode                   OS    21
macro:(xd:,    3)#                     Outsource mode                   OS    22
#                                                                       OS    23
macro:(dump:,[CALL OS01($1)])#                                          OS    24
#                                                                       OS    25
macro:(atomlist:,[ifelse:($1,,IA,$1)])# Define atom list pointer        OS    26
macro:(scat:,[QX(atomlist:($1)+1)])#                                    OS    27
macro:(xif:, [QX(atomlist:($1)+1+$2)])#                                 OS    28
macro:(pmul:,[QX(atomlist:($1)+5)])#                                    OS    29
macro:(bis:, [QX(atomlist:($1)+6)])#                                    OS    30
macro:(bij:, [QX(atomlist:($1)+5+$2)])#                                 OS    31
macro:(mxat:,16)#                                                       OS    32
#                                                                       OS    33
extrude:(OSCOMN)#                                                       OS    34
REAL ADI(mxat:),ADR(mxat:)#            Anomalous dispersion terms       OS    36
REAL ATA(mxat:)#                       Number of atoms in unit cell     OS    37
REAL ATP(mxat:)#                       And in a partial structure       OS    38
REAL ATZ(mxat:)#                       Atomic numbers                   OS    39
REAL BOVL#                             Overall tf                       OS    40
INTEGER LATIS#                         Centering flag                   OS    41
INTEGER CENT#                          Centro flag                      OS    42
INTEGER DISP#                          Dispersion flag                  OS    43
REAL DLIS#                             List > fdiff value               OS    44
REAL DSTL#                             Delta st/l for ff table          OS    45
REAL DSNM#                             Data set number                  OS    46
REAL ELIM#                             Limit of e value                 OS    47
REAL FMUL#                             S.f. multiplicity                OS    48
INTEGER IATM#                          Atom list increment              OS    49
INTEGER ICORE#                         Calculate frel from core+...     OS    50
INTEGER IEXT#                          Extinction flag                  OS    51
INTEGER IOSRC#                         Output format flag               OS    52
INTEGER IFFF#                          Refl form factor flag            OS    53
INTEGER IP,JP#                         Working ip/op pointers           OS    54
INTEGER ISEL#                          Select flag: 1 select/2 omit     OS    55
INTEGER ISCF#                          Step in ff name list             OS    56
INTEGER ISIN#                          Sin/cos lookup flag              OS    57
INTEGER ITEM#                          Number of archive items          OS    58
INTEGER IREL(67)#                      Relative packet pointers         OS    59
INTEGER IRF,IRH,IRJ,IRL,IRS,IRX,IEV#   Relative pointers                OS    60
INTEGER IFA,IFB,IRFO#                  Relative pointers                OS    61
INTEGER IWNT(66)#                      Want list of idnums              OS    62
INTEGER KEY(4)#                        Indexpkt control signals         OS    63
INTEGER LPAK#                          Input packet length              OS    64
INTEGER MARK1#                         Start-1 of sym matrices          OS    65
INTEGER MARK2#                         Start-1 of ff name list          OS    66
INTEGER MARK3#                         Start-1 of scatfac table         OS    67
INTEGER MARK4#                         Start-1 of scale list            OS    68
INTEGER MARK5#                         Start-1 of select list           OS    69
INTEGER MARK6#                         Start-1 of atoms list            OS    70
INTEGER MARK7#                         Start-1 of lratom pointers
INTEGER MARK8#                         Start-1 of constraints 
REAL MAXH,MAXK,MAXL#                   Maximum /h/,/k/,/l/              OS    72
INTEGER NAME#                          Qx step for select list          OS    73
INTEGER NATM#                          Count number of atoms            OS    74
INTEGER IRAD#                          Radiation type flag              OS    75
INTEGER NDEL#                          Extra items in op packet         OS    76
INTEGER NMDS#                          Data set number *1000            OS    77
INTEGER NPAK#                          Output packet length             OS    78
INTEGER NROT#                          Number of rotation matrices      OS    79
INTEGER NSCF#                          Length of ff table               OS    80
INTEGER NSCL#                          Number of scale groups           OS    81
INTEGER NTYP#                          Number of atom types             OS    82
INTEGER OFF(mxat:)#                    Ff table offsets                 OS    83
REAL REJF#                             Reject code flag                 OS    84
REAL SMAX,SMIN#                        Max/min st/l limits              OS    85
REAL SUMC(2,6),SUMD(2,6),SUMN(2,6),SUMR(2,6)# Statistics sums           OS    86
REAL UTOB#                             8*pi**2                          OS    87
REAL UTOBET(6)#                        Convert uij to beta ij           OS    88
REAL WAVE#                             Wavelength                       OS    89
REAL MOLZ#                                                              OS    90
REAL F000#                                                              OS    91
REAL CELL(9)#                                                           OS    92
REAL CELLSD(9)#                                                         OS    93
INTEGER TYPE#                          Temp. factor type                OS    94
CHARACTER*256 OUTFIL#                  256 char filename                OS    95
CHARACTER*80 CBUF#                     Buffer                           OS    96
CHARACTER*8 NCMPID#                    New 8 char compid                OS    97
#                                                                       OS    98
COMMON /COMCOS/OUTFIL,CBUF,NCMPID#                                      OS    99
COMMON /COMIOS/$#                                                       OS   100
IOSRC,LATIS,#                                                           OS   101
CENT,DISP,IATM,IEXT,IFFF,IP,JP,ITEM,ISCF,ISIN,$#                        OS   102
IREL,IWNT,KEY,LPAK,MARK1,MARK2,MARK3,MARK4,IEV,$#                       OS   103
MARK5,MARK6,MARK7,MARK8,NAME,NATM,TYPE,IRF,IRH,IRJ,IRL,IRS,IRX,$#  
IRAD,NDEL,NMDS,NPAK,NROT,NSCF,NSCL,NTYP,OFF,ISEL,ICORE,IFA,IFB,IRFO#    OS   105
#                                                                       OS   106
COMMON /COMFOS/$#                                                       OS   107
ADI,ADR,BOVL,DLIS,DSNM,DSTL,FMUL,$#                               
MAXH,MAXK,MAXL,REJF,SMIN,SMAX,ATP,ATA,ATZ,$#                            OS   109
SUMC,SUMD,SUMN,SUMR,UTOB,UTOBET,ELIM,$#                                 OS   110
WAVE,MOLZ,F000,CELL,CELLSD#         
endext:#                                                                OS   112
#                                                                       OS   113
systemheader:(OS00)#                                                    OS00   1
# ################################################################## #  OS00   2
#                                                                    #  OS00   3
#                               OS00                                 #  OS00   4
#                                                                    #  OS00   5
# ################################################################## #  OS00   6
SUBROUTINE OS00#                       Out-source: for those rare :-/   OS00   7
include:(AACOMN)#                      Occasions when xtal just dont    OS00   8
include:(OSCOMN)#                      Cut the mustard.                 OS00   9
#                                      D. du boulay 2002                OS00  10
#                                                                       OS00  11
CALL OS10#                             Open archive/command line        OS00  12
CALL OS11#                             Control line reading             OS00  13
CALL OS12#                             Read and store lratom:           OS00  14
CALL OS02#                             Open files                       OS00  15
#                                                                       OS00  16
CALL OS15#                             Read and write lrrefl:           OS00  17
CALL OS20#                             Write preinit                    OS00  18
CALL OS30#                             Write cell                       OS00  19
CALL OS40#                             Write symm                       OS00  20
CALL OS50#                             Write scat                       OS00  21
CALL OS55#                             Write valray extras              OS00  22
CALL OS60#                             Write atoms                      OS00  23
CALL OS70#                             Write hkl out                    OS00  24
CALL OS80#                             Write refine                     OS00  25
CALL OS90#                             Close files                      OS00  26
#                                                                       OS00  27
RETURN#                                                                 OS00  28
END#                                                                    OS00  29
systemheader:(OS01)#                   Add string to fmt buffer         OS01   1
# ####################################################################  OS01   2
#                                                                       OS01   3
#                                OS01                                   OS01   4
#                                                                       OS01   5
# ####################################################################  OS01   6
SUBROUTINE OS01(STRG)#                                                  OS01   7
include:(AACOMN)#                                                       OS01   8
include:(OSCOMN)#                                                       OS01   9
#                                                                       OS01  10
INTEGER NSTRG#                         Length of string to be inserte   OS01  11
string:(STRG,*)#                                                        OS01  12
writefmt:(iofm1:,'(A)',STRG)#                                           OS01  13
#                                                                       OS01  14
RETURN#                                                                 OS01  15
END#                                                                    OS01  16
systemheader:(OS02)#                   Open output file                 OS02   1
# ####################################################################  OS02   2
#                                                                       OS02   3
#                                OS02                                   OS02   4
#                                                                       OS02   5
# ####################################################################  OS02   6
SUBROUTINE OS02#                                                        OS02   7
include:(AACOMN)#                                                       OS02   8
include:(OSCOMN)#                                                       OS02   9
INTEGER LNBLNK#                                                         OS02  10
INTEGER LNBL#                                                           OS02  11
#                                                                       OS02  12
LNBL=0#                                                                 OS02  13
LNBL=LNBLNK(OUTFIL)#                   Get last char of filename        OS02  14
# SHOULD STRIP BACK TO DIRECTORY FOR VALRAY.HKL                         OS02  15
# AND USE ENQUIREFILE !!!! FOR OVERWRITING                              OS02  16
IF(IOSRC==shelx:)#                                                      OS02  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS02  18
openfmt:(iofm1:,OUTFIL(1^LNBL)//'.ins')# Open new shelx .inp            OS02  19
openfmt:(iofm2:,OUTFIL(1^LNBL)//'.hkl')# Open new shelx .hkl            OS02  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS02  21
ELSE IF(IOSRC==valray:)#                                                OS02  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  OS02  23
openfmt:(iofm1:,OUTFIL(1^LNBL)//'.dat')# Open new valray .dat           OS02  24
openfmt:(iofm2:,OUTFIL(1^LNBL)//'.hkl')# Open new valray.hkl            OS02  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  OS02  26
ELSE IF(IOSRC==xd:)#                                                    OS02  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  OS02  28
openfmt:(iofm1:,OUTFIL(1^LNBL)//'.mas')# Open new xd.mas                OS02  29
openfmt:(iofm2:,OUTFIL(1^LNBL)//'.hkl')# Open new xd.hkl                OS02  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  OS02  31
#                                                                       OS02  32
RETURN#                                                                 OS02  33
END#                                                                    OS02  34
#                                                                       OS02  35
#                                                                       OS02  36
systemheader:(OS10)#                   Read bdf lrsymm: to lrdset:      OS10   1
# ####################################################################  OS10   2
#                                                                       OS10   3
#                                OS10                                   OS10   4
#                                                                       OS10   5
# ####################################################################  OS10   6
SUBROUTINE OS10#                                                        OS10   7
include:(AACOMN)#                                                       OS10   8
include:(OSCOMN)#                                                       OS10   9
#                                                                       OS10  10
REAL    CVOL#                          Cell volume                      OS10  11
INTEGER I,J,K,L#                       Working indices                  OS10  12
INTEGER IDS#                           Compound pointer and offset      OS10  13
INTEGER IPO#                           Pointer to output buffer         OS10  14
INTEGER J2#                            Index for sf names in mark2      OS10  15
#                                                                       OS10  16
chardata:(OS11,SHE VAL XD  DSE )#      Outsource to these programs      OS10  17
datastuff:#                                                             OS10  18
#                                                                       OS10  19
#---------------------------------------------------------------------- OS10  20
#                                                                       OS10  21
# THE OS INPUT LINE CONTAINS CODES TO DIRECT THE SETTING OF THE FOLLOWI OS10  22
# VARIABLES.                                                            OS10  23
#                                                                       OS10  24
# VARIABLE  POSSIBLE  VALUE OF  MEANING                                 OS10  25
#   NAME     CODES    VARIABLE                                          OS10  26
# IOSRC      SHE        SHELX:    OUTPUT SHELX  .INS FILE               OS10  27
#            VAL       VALRAY:    OUTPUT VALRAY .VAL FILE               OS10  28
#            XD          XD:      OUTPUT XD     .MAS FILE               OS10  29
#                                                                       OS10  30
#  DSNM      DSE       INPUT   DATASET FLAG PRECEDES NUMERIC VALUE THAT OS10  31
#                              FOLLOWS. IF NO VALUE ENTERED SET AT 1.   OS10  32
#                                                                       OS10  33
#---------------------------------------------------------------------- OS10  34
#                                                                       OS10  35
#                                                                       OS10  36
#    DECODE =OS= LINE PARAMETERS                                        OS10  37
#    ---------------------------                                        OS10  38
#                                                                       OS10  39
ISIN=no:#                              Set default parameters           OS10  40
IRAD=3#                                Set default rad as xrays         OS10  41
TYPE=4#                                Set default parameters           OS10  42
ELIM=-1.#                              Set default parameters           OS10  43
DISP=yes:#                             Set default parameters           OS10  44
IFFF=0#                                Set default parameters           OS10  45
IEXT=yes:#                             Set default parameters           OS10  46
DSNM=1.#                               Set default parameters           OS10  47
DLIS=999999.#                          Set default parameters           OS10  48
REJF=6.#                               Set default parameters           OS10  49
UTOB=78.9568#                          8*pi**2                          OS10  50
ICORE=0#                               Don't calculate for the core     OS10  51
IOSRC=0#                                                                OS10  52
NCMPID=' '#                            Initialize as blank              OS10  53
OUTFIL=' '#                            Initialize as blank              OS10  54
#                                                                       OS10  55
FOR(I=1;I<30;I=I+1)#                   Loop over input fields           OS10  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS10  57
ifvo:(BUFIN(I)) BREAK#                 Exit after last field            OS10  58
stringlim:(I,J,K)#                     Find limits of the field         OS10  59
compchar:(CHRIN,J,OS11,1,2,4,NOS11,L)# Find what's there                OS10  60
IF(L==0&IOSRC==0) iquit:(OS0101,I)#    Dud flag.......fc101             OS10  61
ELSE IF(L==4)#                         Data set number to follow        OS10  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  OS10  63
IF(BUFIN(I+1)>voidflg:)#               Should be numeric dsetnum        OS10  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  OS10  65
DSNM=NINT(BUFIN(I+1))#                 Get dataset number               OS10  66
I=I+1#                                 Advance field counter            OS10  67
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  OS10  68
ELSE DSNM=1.#                          Default dataset is 1             OS10  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  OS10  70
ELSE IF(L==0\(L<4&IOSRC!=0))#          First and last unknown is comp   OS10  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  OS10  72
OUTFIL(1^)=CHRIP(J^)#                                                   OS10  73
BREAK#                                 No more options from here        OS10  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  OS10  75
ELSE IOSRC=L#                          Output format requested          OS10  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS10  77
IF(OUTFIL(1^1)==' ')#                                                   OS10  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  OS10  79
IF(IOSRC==shelx:) OUTFIL='shx '#                                        OS10  80
IF(IOSRC==valray:)OUTFIL='val '#                                        OS10  81
IF(IOSRC==xd:)    OUTFIL='xd  '#                                        OS10  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  OS10  83
#                                                                       OS10  84
NMDS=NINT(DSNM)*1000#                  Form dataset offset              OS10  85
#                                                                       OS10  86
#   ASSIGN BDF BUFFERS 1 AND 2                                          OS10  87
#   --------------------------                                          OS10  88
#                                                                       OS10  89
IOMARK(1)=QXSTR#                       Set start of io buffer1          OS10  90
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of buffer2                 OS10  91
incrqx:(MARK1,IOMARK(2)+bdfbuf:,OS0104)# Expand mem.....fc0104          OS10  92
#                                                                       OS10  93
#   EXTRACT CELL INFORMATION                                            OS10  94
#   ------------------------                                            OS10  95
#                                                                       OS10  96
readwpkt:(1,lrhist:,LPAK,IP,0)#        Read  1st packet of lrcell       OS10  97
DO I=1,100#                            Loop over cell packets           OS10  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  OS10  99
readwpkt:(1,lrcell:,LPAK,IP,0)#        Read  1st packet of lrcell       OS10 100
IF(IP<=0) BREAK#                       Exit when finished               OS10 101
IF(I==1)#                                                               OS10 102
movereal:(QX,IP+1,CELL,1,LPAK,0)#                                       OS10 103
IF(I==2)#                                                               OS10 104
movereal:(QX,IP+1,CELLSD,1,LPAK,0)#                                     OS10 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  OS10 106
#                                                                       OS10 107
#   EXTRACT SYMMETRY CODES & MATRICES (LRSYMM:)                         OS10 108
#   ---------------------------------------                             OS10 109
#                                                                       OS10 110
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Read first packet of lr lrsy     OS10 111
LATIS=NINT(QX(IP+1))#                  Get centering condition          OS10 112
CENT=NINT(QX(IP+2))#                   Centric=0 / acentric=1           OS10 113
NROT=NINT(QX(IP+4))#                   Get number rotation matrices     OS10 114
FMUL=QX(IP+6)#                         Get reflection multiplicity      OS10 115
incrqx:(MARK2,MARK1+NROT*LPAK,OS0105)# Expand qx......fc105             OS10 116
FOR(J=MARK1;J>0;J=J+LPAK)#             Loop over symm matrices          OS10 117
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  OS10 118
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Get packet pointer               OS10 119
IF(IP<=0) BREAK#                       Exit after last packet           OS10 120
movereal:(QX,IP+1,QX,J+1,LPAK,1)#      Save the symop for later         OS10 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  OS10 122
#                                                                       OS10 123
#   ENTER SCATT. FACTOR & ATOM SUMMARY (LR LRSCAT:)                     OS10 124
#   ---------------------------------------                             OS10 125
#                                                                       OS10 126
incrqx:(MARK3,MARK2+32,OS0106)#        Save room for 16 sf types        OS10 127
ISCF=incr:(arith:(7,/,mxchwd:))#       Allow for 8 char. per name       OS10 128
J2=MARK2#                              Set marker for first sf name     OS10 129
IWNT(1)=NINT(DSNM+20.);  IWNT(3)=100#  Set real ad & ff idnums          OS10 130
IWNT(2)=NINT(DSNM+60.);  IWNT(4)=10#   Set imag ad & neut ff            OS10 131
IWNT(5)=11 ;  IWNT(6)=7#               Set sf name idnum                OS10 132
IWNT(7)=1#                             Set atom number idnum            OS10 133
IWNT(8)=3#                             Set atom number idnum            OS10 134
KEY(1)=0;  KEY(2)=8;  KEY(3)=0#        Set search delimiters            OS10 135
KEY(4) = 0#                                                             OS10 136
indexpkt:(1,lrscat:,LPAK,IP,0,KEY,IWNT,IREL)# Get packet pointers       OS10 137
IF((IREL(1)==0)&(IREL(2)==0)) DISP=no:# No dispersion values            OS10 138
#                                                                       OS10 139
FOR(I=IP+IREL(3);I<=IP+LPAK;I=I+1)#    Loop over ff list                OS10 140
IF((QX(I)<99.5)\(QX(I)>299.5)) BREAK#  Exit after last ff               OS10 141
IF(IREL(3)>0)  NSCF=I-IP-IREL(3)+1#    Count contiguous ff              OS10 142
ELSE           NSCF=0#                 Ff table present                 OS10 143
IF(IREL(4)>0)  NSCF=1#                 Count neutron ff                 OS10 144
IF(IREL(3)>0) DSTL=(QX(I-1)-QX(I-2))*.01# Set st/l interval             OS10 145
#                                                                       OS10 146
NTYP=0#                                Zero count of atom types         OS10 147
FOR(J=MARK3;J>0;J=J+NSCF)#             Loop over each atom type         OS10 148
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  OS10 149
readwpkt:(1,lrscat:,LPAK,IP,0)#        Get packet pointer               OS10 150
IF(IP<=0) BREAK#                       Exit after last packet           OS10 151
L=IP+IREL(5)#                          Set pointer for sf name          OS10 152
movereal:(QX,L,QX,J2+1,ISCF,1)#        Move sf name to mark2 array      OS10 153
J2=J2+ISCF#                            Advance sf name pointer          OS10 154
incrqx:(MARK4,J+NSCF,OS0108)#          Expand qx.......fc108            OS10 155
NTYP=NTYP+1#                           Count atom types                 OS10 156
ADR(NTYP)=0.;   ADI(NTYP)=0.#          Zero dispersion values           OS10 157
I=IP+IREL(1); IF(I>IP) ifnv:(QX(I)) ADR(NTYP)=QX(I)# Get real disp      OS10 158
I=IP+IREL(2); IF(I>IP) ifnv:(QX(I)) ADI(NTYP)=QX(I)# Get imag disp      OS10 159
I=IP+IREL(6); IF(I>IP) IFFF=NINT(QX(I))# Get refl ff flag               OS10 160
I=IP+IREL(7); IF(I>IP) ATA(NTYP)=QX(I)# Get total atom number           OS10 161
I=IP+IREL(8); IF(I>IP) ATZ(NTYP)=QX(I)# Get atomic number               OS10 162
I=IP+IREL(4); IF(I>IP) QX(MARK4)=QX(I)# Store neutron ff                OS10 163
ELSE IF(IREL(3)>0)#                    If xray or electron ff present   OS10 164
FOR(I=J;I<MARK4;I=I+1)#                Loop over sf data points         OS10 165
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  OS10 166
K=IP+IREL(3)+I-J#                      Point to each ff value           OS10 167
QX(I+1)=QX(K)#                         Store each ff value              OS10 168
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  OS10 169
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  OS10 170
#                                                                       OS10 171
#   ENTER SCALE INFORMATION (LR LREXPL:)                                OS10 172
#   ------------------------------                                      OS10 173
#                                                                       OS10 174
IWNT(1)=1;    IWNT(2)=100#             Set data set & nscl idnums       OS10 175
IWNT(3)=94;   IWNT(4)=22#              Set rad type & cell volume       OS10 176
IWNT(5)=2#                             Get rad wavelength               OS10 177
KEY(1)=1; KEY(2)=5; KEY(3)=0; KEY(4)=0# Set search delimiters           OS10 178
indexpkt:(1,lrexpl:,LPAK,IP,0,KEY,IWNT,IREL)# Get packet pointers       OS10 179
incrqx:(MARK5,MARK4+64,OS0109)#        Expand qx.......fc109            OS10 180
NSCL=1;   QX(MARK4+1)=1.#              Default group & rel pointer&     OS10 181
FOR(I=IP+1;I<=IP+LPAK;I=I+1)#          Loop over directory              OS10 182
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 OS10 183
IF((QX(I)<100.9)\(QX(I)>164.1)) NEXT#  Skip if not scale idnm           OS10 184
J=MARK4+NINT(QX(I))-100#               Get group number of scale        OS10 185
QX(J)=FLOAT(I-IP)#                     Store relative position          OS10 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 OS10 187
REPEAT#                                Loop over data sets              OS10 188
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 OS10 189
readwpkt:(1,lrexpl:,LPAK,IP,0)#        Get packet pointer               OS10 190
IF(IP<=0) BREAK#                       Exit after last packet           OS10 191
I=IP+IREL(1); IF(I==IP) NEXT#          Get index of data set no.        OS10 192
ifne:(DSNM,QX(I)) NEXT#                Skip unwanted data set           OS10 193
I=IP+IREL(2); IF(I>IP) NSCL=NINT(QX(I))# Number of scales               OS10 194
FOR(I=MARK4;I<MARK4+NSCL;I=I+1)#       Loop over scale factors          OS10 195
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 OS10 196
J=IP+NINT(QX(I+1))#                    Point to scale location          OS10 197
IF(J>IP) QX(I+1)=QX(J)#                Store scale in table             OS10 198
ELSE     QX(I+1)=1.#                   Default scale is 1.              OS10 199
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 OS10 200
I=IP+IREL(3); IF(I>IP) IRAD=NINT(QX(I))# Radiation (1=n,2=e;3=x)        OS10 201
I=IP+IREL(4); IF(I>IP) CVOL=QX(I)/47.878# Cell volume for elect rad     OS10 202
I=IP+IREL(5); IF(I>IP) WAVE=QX(I)#     Wavelength                       OS10 203
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 OS10 204
IF(IREL(4)==0&IRAD==2) iquit:(OS0102)# Cell volume missing              OS10 205
IF(IRAD==2) FMUL=FMUL/CVOL#            Scale structure factor volts     OS10 206
MARK5=MARK4+NSCL#                      Reset mark5 for true nscl        OS10 207
#                                                                       OS10 208
#   ENTER DATA SET INFORMATION (LR LRDSET:)                             OS10 209
#   ---------------------------------                                   OS10 210
#                                                                       OS10 211
IWNT(1)=2;  IWNT(7)=1#                 Request ovb, dataset number      OS10 212
DO I=2,6;   IWNT(I)=I+9#               Request maxhkl, max&min stol     OS10 213
KEY(1)=0;  KEY(2)=7; KEY(3)=0#         Set search delimiters            OS10 214
indexpkt:(1,lrdset:,LPAK,IP,0,KEY,IWNT,IREL)# Search rel pointers       OS10 215
BOVL=0.; SMIN=0.; SMAX=2.#             Set default parameters           OS10 216
MAXH=256.; MAXK=256.; MAXL=256.#       Set default parameters           OS10 217
IF (IP>0) $#                           If there was a directory         OS10 218
REPEAT#                                Loop over data sets              OS10 219
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 OS10 220
readwpkt:(1,lrdset:,LPAK,IP,0)#                                         OS10 221
IF(IP<=0) BREAK#                                                        OS10 222
IDS=IP+IREL(7)#                        Make pointer to dataset no.      OS10 223
ifne:(DSNM,QX(IDS)) NEXT#              Skip unwanted datasets           OS10 224
I=IP+IREL(1); IF(I>IP) BOVL=QX(I)*UTOB# Get active b overall            OS10 225
I=IP+IREL(2); IF(I>IP) MAXH=QX(I)#     Get active max /h/               OS10 226
I=IP+IREL(3); IF(I>IP) MAXK=QX(I)#     Get active max /k/               OS10 227
I=IP+IREL(4); IF(I>IP) MAXL=QX(I)#     Get active max /l/               OS10 228
I=IP+IREL(5); IF(I>IP) SMIN=QX(I)#     Get active smin                  OS10 229
I=IP+IREL(6); IF(I>IP) SMAX=QX(I)#     Get active smax                  OS10 230
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 OS10 231
#                                                                       OS10 232
RETURN#                                                                 OS10 233
END#                                                                    OS10 234
systemheader:(OS11)#                   Read controls                    OS11   1
# ####################################################################  OS11   2
#                                                                       OS11   3
#                                OS11                                   OS11   4
#                                                                       OS11   5
# ####################################################################  OS11   6
SUBROUTINE OS11#                                                        OS11   7
include:(AACOMN)#                                                       OS11   8
include:(OSCOMN)#                                                       OS11   9
#                                                                       OS11  10
INTEGER IARC#                          Archive input flag               OS11  11
INTEGER I,J,K,M#                       Working indices                  OS11  12
#                                                                       OS11  13
chardata:(OS21, SCALE MAXHKL SELECT OMIT END    )#               OS11  14
chardata:(OS22,        )#                                               OS11  15
datastuff:#                                                             OS11  16
#                                                                       OS11  17
#   ENTER CONTROL LINES                                                 OS11  18
#   -------------------                                                 OS11  19
#                                                                       OS11  20
MARK6=MARK5#                           Set select atom marker           OS11  21
NAME=incr:(arith:(23,/,mxchwd:))#      Calc atom name length            OS11  22
IARC=0;   ITEM=11;    ISEL=0#          Reset archive parameters         OS11  29
#                                                                       OS11  30
REPEAT#                                Loop over control lines          OS11  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS11  32
readline:(OS21,NOS21)#                 Process control line             OS11  33
#                                                                       OS11  34
IF(LINID==1)#                          ****** scale *******             OS11  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  OS11  36
ifvo:(BUFIN(1)) NEXT#                  Skip if void scale               OS11  37
ifvo:(BUFIN(2)) I=1#                   Default scale group              OS11  38
ELSE             I=NINT(BUFIN(2))#     Enter scale group                OS11  39
QX(MARK4+I)=BUFIN(1)#                  Store scale value                OS11  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  OS11  41
#                                                                       OS11  42
ELSE IF(LINID==2)#                     ****** maxhkl *******            OS11  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  OS11  44
ifnv:(BUFIN(1)) MAXH=BUFIN(1)#         Set active max /h/               OS11  45
ifnv:(BUFIN(2)) MAXK=BUFIN(2)#         Set active max /k/               OS11  46
ifnv:(BUFIN(3)) MAXL=BUFIN(3)#         Set active max /l/               OS11  47
ifnv:(BUFIN(4)) SMIN=BUFIN(4)#         Set active min st/l              OS11  48
ifnv:(BUFIN(5)) SMAX=BUFIN(5)#         Set active max st/l              OS11  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  OS11  50
#                                                                       OS11  51
ELSE IF(LINID==3\LINID==4)#            ****** select/omit *******       OS11  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  OS11  53
IF(ISEL==1&LINID==4) iquit:(OS0201)#   Select and omit lines mixed      OS11  54
IF(ISEL==2&LINID==3) iquit:(OS0201)#   Select and omit lines mixed      OS11  55
ISEL=LINID-2#                          Select=1; omit=2                 OS11  56
DO I=1,30#                             Loop over select fields          OS11  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  OS11  58
ifvo:(BUFIN(I)) BREAK#                 Exit first inactive field        OS11  59
M=MARK6+1#                             Point to next name               OS11  60
incrqx:(MARK6,MARK6+NAME,OS0202)#      Expand qx......fc202             OS11  61
stringlim:(I,J,K)#                     Extract string limits            OS11  62
K=MIN0(K-J,24)#                        Limit to 24 characters           OS11  63
movector:(OS22,1,QX(M),1,24,1)#        Blank out qx region              OS11  64
movector:(CHRIP,J,QX(M),1,K,0)#        Store name in qx                 OS11  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  OS11  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  OS11  67
#                                                                       OS11  68
#                                                                       OS11  87
ELSE BREAK#                            ****** end *******               OS11  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS11  89
MARK7=MARK6;MARK8=MARK7#
#                                                                       OS11  90
RETURN#                                                                 OS11  91
END#                                                                    OS11  92
systemheader:(OS12)#                   Get atom parameters from lra     OS12   1
# ####################################################################  OS12   2
#                                                                       OS12   3
#                               OS12                                    OS12   4
#                                                                       OS12   5
# ####################################################################  OS12   6
SUBROUTINE OS12#                                                        OS12   7
include:(AACOMN)#                                                       OS12   8
include:(OSCOMN)#                                                       OS12   9
#                                                                       OS12  10
INTEGER I,J,K,L,M,N#                   Working indices                  OS12  11
INTEGER IPO#                           O/p buffer pointer               OS12  12
INTEGER LIST#                          Number of list items             OS12  13
INTEGER NAT#                           Atom name point                  OS12  14
INTEGER NSTEP#                         Step size per atom in mark6      OS12  15
REAL SMUL#                             Site muliplicity                 OS12  16
REAL POPP#                             Population parameter             OS12  17
REAL X,Y,Z#                            Coordinate storage               OS12  18
#                                                                       OS12  19
string:(NAME1,24)#                     Atom name from bdf               OS12  20
string:(NAME2,24)#                     Selected part atom name          OS12  21
string:(NAME3,24)#                     Atom name left part              OS12  22
chardata:(OS31," x/a    y/b    z/c   $#                                 OS12  23
pp*ml    U11     U22     U33     U12     U13     U23")#                 OS12  24
realdata:(FMT,[742.,742.,742.,622.,842.,842.,842.,842.,842.,842.])#     OS12  25
datastuff:#                                                             OS12  26
#                                                                       OS12  27
#   LOCATE REQUIRED PARAMETERS IN LR LRATOM:                            OS12  28
#   ----------------------------------                                  OS12  29
#                                                                       OS12  30
IWNT(1)=22; IWNT(14)=21#               Set nscf, mult, tf idnums        OS12  31
IWNT(2)=14; IWNT(13)=11#               Set atom name, neut-flag idnum   OS12  32
DO I=1,3;   IWNT(I+2)=I#               Set x to z idnums                OS12  33
DO I=4,10;  IWNT(I+2)=I#               Set displ. params u uij          OS12  34
KEY(1)=5;  KEY(2)=14;  KEY(3)=0#       Set search delimiters            OS12  35
KEY(4)=0#                              Copy mode for indexpkt:          OS12  36
indexpkt:(1,lratom:,LPAK,IP,0,KEY,IWNT,IREL)# Get relative pointers     OS12  37
IF(KEY(4)<=0)RETURN#                   No atom sites!
#                                                                       OS12  39
NATM=0#                                Zero count of selected atoms     OS12  40
DO I=1,mxat:; ATP(I)=0.#               Zero count of atom number        OS12  41
K=MARK6#                               Start atom list pointer          OS12  42
REPEAT#                                Loop over atom packets           OS12  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS12  44
readwpkt:(1,lratom:,IATM,IP,0)#        Get packet pointer               OS12  45
IF(IP<=0) BREAK#                       Exit after last packet           OS12  46
#                                                                       OS12  47
N=IP+IREL(2)#                          Make pointer to atom name        OS12  48
movertoc:(QX(N),1,NAME1,1,24,0)#       Move name to character array     OS12  49
label:(NAME1,I,J)#                     Get max label length             OS12  50
NAME2=NAME1(1^J)#                      Extract scatt fact symbol        OS12  51
FOR(I=MARK5;I<MARK6;I=I+NAME)#         Loop over selected atoms         OS12  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  OS12  53
movertoc:(QX(I+1),1,NAME3,1,24,0)#     Move name of selected atom       OS12  54
IF(NAME1==NAME3\NAME2==NAME3) BREAK#   Test atom label or type symbol   OS12  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  OS12  56
IF(I>=MARK6&ISEL==1) NEXT#             Skip unselected atoms            OS12  57
IF(I<MARK6&ISEL==2)  NEXT#             Skip omitted atoms               OS12  58
NATM=NATM+1#                           Increment count of found ato     OS12  59
incrqx:(MARK7,K+IATM,OS0302)#          Expand qx......fc302             OS12  60
movereal:(QX,IP+1,QX,K+1,IATM,1)#      Copy atom data                   OS12  61
K=K+LPAK#                              Update qx pointer                OS12  62
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS12  63
#                                      Save pointer table               OS12  64
incrqx:(MARK8,MARK7+1+KEY(2),OS0302)#  Expand qx......fc302             OS12  65
QX(MARK7+1)=FLOAT(KEY(2))#             Save number of items             OS12  66
DO I=1,KEY(2);QX(MARK7+1+I)=FLOAT(IREL(I))#                             OS12  67
#                                                                       OS12  68
RETURN#                                                                 OS12  69
END#                                                                    OS12  70
systemheader:(OS15)#                   Get equivalents from  bdf        OS15   1
# ###################################################################   OS15   2
#                                                                   #   OS15   3
#                              OS15                                 #   OS15   4
#                                                                   #   OS15   5
# ################################################################# #   OS15   6
SUBROUTINE OS15#                                                        OS15   7
include:(AACOMN)#                                                       OS15   8
include:(OSCOMN)#                                                       OS15   9
#                                                                       OS15  10
INTEGER KK#                            Loop counters                    OS15  11
#INTEGER IP,PSIZ#                       PACKET POINTERS                 OS15  12
#INTEGER ICODE,LCODE,NCODE#             SORTING WORDS                   OS15  13
INTEGER NREC#                          Dac file refln counter           OS15  14
#INTEGER LPAK#                          LENGTH OF REFLN PKT             OS15  15
INTEGER I#                                                              OS15  16
INTEGER IH(3)#                         Miller indices                   OS15  17
INTEGER IRTYP,IRTYP1,IRTYP2,IR,IR1,IR2
REAL FF,SF#                                                             OS15  19
REAL CONS#                             Geometric constant?              OS15  20
REAL COST#                             Cos theta                        OS15  21
REAL SINT#                             Sin theta                        OS15  22
REAL SIN2T#                            Sin twotheta                     OS15  23
REAL COS2T#                            Cos twotheta                     OS15  24
REAL POLT#                             Polarisation term                OS15  25
REAL EXTP#                             Extinctn distbn and typ param    OS15  26
REAL GAMMA#                            Gamma                            OS15  27
REAL H(3)#                             Miller indices                   OS15  28
REAL TMIN,TMAX,TBAR#                   Min and max tbars                OS15  29
realdata:(FS1,[40413.,413.,413.,822.,822.])#                            OS15  31
realdata:(FV1,[40413.,413.,413.,213.,822.,822.,962.])#                  OS15  32
datastuff:#                                                             OS15  33
#                                                                       OS15  34
#    EXTRACT THE LRREFL: POINTERS                                       OS15  35
#    ----------------------------                                       OS15  36
#                                                                       OS15  37
IRTYP=3#                               Default use frel                 OS15  38
IRTYP1=IRTYP
IRTYP2=IRTYP
#                                                                       OS15  39
I=NINT(DSNM)*1000#                     To get data from the right pak   OS15  40
IWNT(1)=1#                             Hkl                              OS15  41
IWNT(2)=2#                             Sintheta/lambda                  OS15  42
IWNT(3)=I+200#                         Tbar                             OS15  43
IWNT(4)=I+204#                         Rlp                              OS15  47
IWNT(5)=I+300; IWNT(6)=I+301#          Irel & sigma irel                OS15  44
IWNT(7)=I+302; IWNT(8)=I+303#          F**2 & sigma f**2                OS15  45
IWNT(9)=I+304; IWNT(10)=I+305#         Frel & sigma frel                OS15  46
IWNT(11)=I+308#                        Rcode                            OS15  48
IWNT(12)=I+309#                        Scale factor                     OS15  49
IWNT(13)=I+310; IWNT(14)=I+311#        Friedel Irel & sigma irel   
IWNT(15)=I+312; IWNT(16)=I+313#        Friedel F**2 & sigma f**2    
IWNT(17)=I+314; IWNT(18)=I+315#        Friedel Frel & sigma frel     
IWNT(19)=I+318#                        Friedel Rcode                  
IWNT(20)=I+319#                        Friedel Scale factor            
KEY(1)=2; KEY(2)=20; KEY(3)=0; KEY(4)=0# Set search keys                OS15  50
indexpkt:(1,lrrefl:,LPAK,IP,0,KEY,IWNT,IREL)# Get packet pointers       OS15  51
IF(KEY(4)<=0) RETURN#                  Missing items on bdf             OS15  52
IR=IRTYP*2+3#                          Point to correct sf              OS15  53
IR1=IR
IR2=IRTYP*2+11#                        Point to correct sf              OS15  60
IF(IREL(IR1)==0\IREL(IR1+1)==0)#       Is the selected sf there?        OS15  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS15  55
IF     (IREL(7)*IREL(8)>0) IRTYP1=2#   Set f**2 as input sf             OS15  56
ELSE IF(IREL(9)*IREL(10)>0) IRTYP1=3#  Set frel as input sf             OS15  57
ELSE IF(IREL(5)*IREL(6)*IREL(4)>0) IRTYP1=1# Set irel as input sf       OS15  58
ELSE RETURN#                           Nothing there!                   OS15  59
IR1=IRTYP1*2+3#                        Point to correct sf              OS15  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS15  63
IF(IREL(IR2)==0\IREL(IR2+1)==0)#       Is the selected sf there?        OS15  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS15  55
IF     (IREL(15)*IREL(16)>0) IRTYP2=2# Set f**2 as input sf             OS15  56
ELSE IF(IREL(17)*IREL(18)>0) IRTYP2=3# Set frel as input sf             OS15  57
ELSE IF(IREL(13)*IREL(14)*IREL(4)>0) IRTYP2=1# Set irel as input sf     OS15  58
ELSE IRTYPE2=0
IR2=IRTYP2*2+11#                       Point to correct sf              OS15  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS15  63
NHKL=0#                                                                 OS15  64
#                                                                       OS15  65
#    LOOP REFLECTION DATA                                               OS15  66
#    --------------------                                               OS15  67
#                                                                       OS15  68
REPEAT#                                Loop over lrrefl and get refl    OS15  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  OS15  70
readwpkt:(1,lrrefl:,LPAK,IP,0)#        Read vital statistics            OS15  71
IF(IP<=0) BREAK#                       Exit when finished               OS15  72
I=IP+IREL(2); ifvo:(QX(I)) NEXT#                                        OS15  73
STOL=QX(I)#                                                             OS15  74
IF((STOL<SMIN)\(STOL>SMAX)) NEXT#      Skip if outside s limits         OS15  75
gethkl:(IP+IREL(1),H)#                 Unpack hkl into h(3)             OS15  76
IF(ABS(H(1))>MAXH) NEXT#               Skip if /h/ too big              OS15  77
IF(ABS(H(2))>MAXK) NEXT#               Skip if /k/ too big              OS15  78
IF(ABS(H(3))>MAXL) NEXT#               Skip if /l/ too big              OS15  79
#
IR=IR1
IRTYP=IRTYP1
#
DO IFR=0,1#                            loop for packed Friedel pairs
$(
RCODE=1.0#                                                              OS15  80
I=IP+IREL(11+IFR*8);IF(I>IP)#                                           OS15  81
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  OS15  82
IF(QX(I)>REJF) GOTO 99#                Skip rejected reflections        OS15  83
ifvo:(QX(I)) GOTO 99#                  Skip if rcode is void            OS15  84
RCODE=QX(I)#                           Save for dumping                 OS15  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  OS15  86
#                                                                       OS15  87
#                                                                       OS15  88
IF(IRTYP==0)GOTO 99#                   no data so skip
FF=QX(IP+IREL(IR));  SF=QX(IP+IREL(IR+1))# Get sf and sigma sf          OS15  89
ifvo:(FF)GOTO 99#                      skip reflection
ifvo:(SF)SF=1.0#                       fudge sigma
IF(IRTYP==1)#                          Is this intensity?               OS15  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  OS15  91
FF=FF*QX(IP+IREL(4)); SF=SF*QX(IP+IREL(4))# Get f**2 & sigma f**2     OS15  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  OS15  93
ELSE IF(IRTYP==3)#                     Is this frel?                    OS15  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  OS15  95
SF=2.*FF*SF;   FF=FF*FF#               Get f**2 & sigma f**2            OS15  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  OS15  97
#                                                                       OS15  98
IF(IAPSCF==yes:)#                                                       OS15  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  OS15 100
SKF=QX(MARK4+1)#                       Point to scale one               OS15 101
I=IP+IREL(12+IFR*8);IF(I>IP)#                                           OS15 102
ifnv:(QX(I)) SKF=QX(MARK4+NINT(QX(I)))# Point to scale group            OS15 103
FF=FF*SKF**2#                          Scale measured s.f2.             OS15 104
SF=SF*SKF**2#                          Scale measured sig.f2.           OS15 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  OS15 106
#                                                                       OS15 107
BUFOT(1)=H(1)#                                                          OS15 108
BUFOT(2)=H(2)#                                                          OS15 109
BUFOT(3)=H(3)#                                                          OS15 110
BUFOT(4)=FF#                           F2rel                            OS15 111
BUFOT(5)=SF#                           Sig f2rel                        OS15 112
CBUF=' '#                              Erase it                         OS15 113
IF    (IOSRC==shelx:) ncodefld:(BUFOT,1,CBUF,FS1,5)#                    OS15 114
ELSEIF(IOSRC==xd:)    ncodefld:(BUFOT,1,CBUF,FS1,5)#                    OS15 115
ELSEIF(IOSRC==valray:)#                                                 OS15 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  OS15 117
ncodefld:(BUFOT,1,CBUF,FV1,3)#                                          OS15 118
ncodefld:(RCODE,1,CBUF,FV1(4),1)#                                       OS15 119
ncodefld:(BUFOT,4,CBUF,FV1(5),2)#                                       OS15 120
I=IP+IREL(3); IF(I>IP)#                                                 OS15 121
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  OS15 122
TBAR=QX(I)#                                                             OS15 123
ifvo:(TBAR) NEXT#                                                       OS15 124
ncodefld:(TBAR/10.,1,CBUF,FV1(7),1)#   Convert mm to cm                 OS15 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  OS15 126
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  OS15 127
writefmt:(iofm2:,'(A)',CBUF)#                                           OS15 128
AH=H(1);AK=H(2);AL=H(3)#               Last ref for valray       
NHKL=NHKL+1#                           Increment reflection counter     OS15 129
99 CONTINUE
H(1)=-H(1);H(2)=-H(2);H(3)=-H(3)#      invert for Friedel
IR=IR2#                                use Friedel data
IRTYP=IRTYP2
$)
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  OS15 130
#                                                                       OS15 132
#                                                                       OS15 133
#                                                                       OS15 134
RETURN#                                                                 OS15 135
END#                                                                    OS15 136
systemheader:(OS20)#                   Preinit                          OS20   1
# ####################################################################  OS20   2
#                                                                       OS20   3
#                                OS20                                   OS20   4
#                                                                       OS20   5
# ####################################################################  OS20   6
SUBROUTINE OS20#                                                        OS20   7
include:(AACOMN)#                                                       OS20   8
include:(OSCOMN)#                                                       OS20   9
#                                                                       OS20  10
chardata:(OS090A,' Data supplied from XTAL-')#                          OS20  11
chardata:(OS090B,version:)#                                             OS20  12
chardata:(V1,"REMARK   1         2         3         4         5$#      OS20  13
         6         7")#                                                 OS20  14
chardata:(V2,"REMARK 8901234567890123456789012345678901234567890$#      OS20  15
123456789012345678901234567890")#                                       OS20  16
#                                                                       OS20  17
datastuff:#                                                             OS20  18
#                                                                       OS20  19
IF(IOSRC==shelx:)#                                                      OS20  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS20  21
CBUF="REM "//OS090A//OS090B#                                            OS20  22
dump:(CBUF)#                                                            OS20  23
CBUF="TITL "//TITLE(1^15)//TITLE(63^)#                                  OS20  24
dump:(CBUF)#                                                            OS20  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS20  26
ELSE IF(IOSRC==valray:)#                                                OS20  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  OS20  28
CBUF="REMARK "//OS090A//OS090B#                                         OS20  29
dump:(CBUF)#                                                            OS20  30
CBUF="TITLE "//TITLE(1^15)//TITLE(63^)#                                 OS20  31
dump:(CBUF)#                                                            OS20  32
dump:(V1)#                                                              OS20  33
dump:(V2)#                                                              OS20  34
CBUF="VALDAT "//NCMPID(1^6)//" 0 0 0 1 0  .71073    0.0"#               OS20  35
ncodefld:(WAVE,1,CBUF,310852.,1)#                                       OS20  36
dump:(CBUF)#                                                            OS20  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  OS20  38
ELSE IF(IOSRC==xd:)#                                                    OS20  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  OS20  40
CBUF='! '//OS090A//OS090B#                                              OS20  41
dump:(CBUF)#                                                            OS20  42
CBUF="TITLE  "//NCMPID//" "//TITLE(1^15)//TITLE(63^)#                   OS20  43
dump:(CBUF)#                                                            OS20  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  OS20  45
#                                                                       OS20  46
RETURN#                                                                 OS20  47
END#                                                                    OS20  48
systemheader:(OS30)#                   Cell                             OS30   1
# ####################################################################  OS30   2
#                                                                       OS30   3
#                                OS30                                   OS30   4
#                                                                       OS30   5
# ####################################################################  OS30   6
SUBROUTINE OS30#                                                        OS30   7
include:(AACOMN)#                                                       OS30   8
include:(OSCOMN)#                                                       OS30   9
#                                                                       OS30  10
realdata:(FV1,[210832.,290832.,370832.,$#                               OS30  11
460952.,550952.,640952.,710702.])#                                      OS30  12
realdata:(FV2,[210832.,290832.,370832.,$#                               OS30  13
460952.,550952.,640952.])#                                              OS30  14
realdata:(FV3,[170413.,210413.,250413.,330842.,410842.])#               OS30  15
realdata:(FS1,[140752.,210832.,290832.,370832.,$#                       OS30  16
460952.,550952.,640952.])#                                              OS30  17
realdata:(FS2,[140313.,210832.,290832.,370832.,$#                       OS30  18
460952.,550952.,640952.])#                                              OS30  19
realdata:(FD1,[210832.,290832.,370832.,$#                               OS30  20
460952.,550952.,640952.])#                                              OS30  21
realdata:(FD2,[210832.,290832.,370832.,$#                               OS30  22
460952.,550952.,640952.])#                                              OS30  23
realdata:(FD3,210832.)#                                                 OS30  24
datastuff:#                                                             OS30  25
#                                                                       OS30  26
DO I=1,3;BUFOT(I)=CELL(I)#                                              OS30  27
DO I=1,3;BUFOT(I+3)=CELL(6+I)*360.#                                     OS30  28
DO I=1,3;BUFOT(I+6)=CELLSD(I)#                                          OS30  29
DO I=1,3;BUFOT(I+9)=CELLSD(6+I)*360.#                                   OS30  30
BUFOT(13)=MAXH#                                                         OS30  31
BUFOT(14)=MAXK#                                                         OS30  32
BUFOT(15)=MAXL#                                                         OS30  33
BUFOT(16)=SMAX#                                                         OS30  34
BUFOT(17)=SMIN#                                                         OS30  35
#                                                                       OS30  36
#WAVE,MOLZ,F000                                                         OS30  37
MOLZ=4.#                                                                OS30  38
F000=326.#                                                              OS30  39
IF(IOSRC==shelx:)#                                                      OS30  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS30  41
CBUF='CELL '#                                                           OS30  42
ncodefld:(WAVE,1,CBUF,FS1,1)#                                           OS30  43
ncodefld:(BUFOT,1,CBUF,FS1(2),6)#                                       OS30  44
dump:(CBUF)#                                                            OS30  45
CBUF='ZERR   '#                                                         OS30  46
ncodefld:(MOLZ,1,CBUF,FS1,1)#                                           OS30  47
ncodefld:(BUFOT,7,CBUF,FS2(2),6)#                                       OS30  48
dump:(CBUF)#                                                            OS30  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS30  50
ELSE IF(IOSRC==valray:)#                                                OS30  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  OS30  52
CBUF='CELL '#                                                           OS30  53
ncodefld:(BUFOT,1,CBUF,FV1,6)#                                          OS30  54
ncodefld:(F000,1,CBUF,FV1(7),1)#                                        OS30  55
dump:(CBUF)#                                                            OS30  56
CBUF='CELLSD '#                                                         OS30  57
ncodefld:(BUFOT,7,CBUF,FV2,6)#                                          OS30  58
dump:(CBUF)#                                                            OS30  59
CBUF='MAXHKL '#                                                         OS30  60
ncodefld:(BUFOT,13,CBUF,FV3,5)#                                         OS30  61
dump:(CBUF)#                                                            OS30  62
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  OS30  63
ELSE IF(IOSRC==xd:)#                                                    OS30  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  OS30  65
CBUF='CELL '#                                                           OS30  66
ncodefld:(BUFOT,1,CBUF,FD1,6)#                                          OS30  67
dump:(CBUF)#                                                            OS30  68
CBUF='CELLSD  '#                                                        OS30  69
ncodefld:(BUFOT,7,CBUF,FD2,6)#                                          OS30  70
dump:(CBUF)#                                                            OS30  71
CBUF='WAVE    '#                                                        OS30  72
ncodefld:(WAVE,1,CBUF,FD3,1)#                                           OS30  73
dump:(CBUF)#                                                            OS30  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  OS30  75
#                                                                       OS30  76
RETURN#                                                                 OS30  77
END#                                                                    OS30  78
systemheader:(OS40)#                   Generate symmetry data           OS40   1
# ####################################################################  OS40   2
#                                                                       OS40   3
#                                OS40                                   OS40   4
#                                                                       OS40   5
# ####################################################################  OS40   6
SUBROUTINE OS40#                                                        OS40   7
include:(AACOMN)#                                                       OS40   8
include:(OSCOMN)#                                                       OS40   9
string:(LINE,80)#                                                       OS40  10
#                                                                       OS40  11
#                                                                       OS40  12
INTEGER I,J,K,L,M,N,IFLG#                                               OS40  13
INTEGER ICEN,ISYM,LS,LTYP,NSYM#                                         OS40  14
chardata:(FRAC,      1/61/41/3   1/2   2/33/45/6      )#                OS40  15
chardata:(XYZ,'-x-y-z+x+y+z')#                                          OS40  16
chardata:(CEN,'PIRFABC')#                                               OS40  17
chardata:(INV,'CA')#                                                    OS40  18
datastuff:#                                                             OS40  19
#                                                                       OS40  20
#                                                                       OS40  21
IF (LATIS>7)LATIS=LATIS-7#                                              OS40  22
IF      (IOSRC==shelx:)#                                                OS40  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS40  24
CBUF='LATT  '#                                                          OS40  25
IF (CENT==1)LATIS=-LATIS#                                               OS40  26
ncodefld:(FLOAT(LATIS),1,CBUF,120213.,1)#                               OS40  27
dump:(CBUF)#                                                            OS40  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS40  29
ELSE IF(IOSRC==valray:)#                                                OS40  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  OS40  31
CBUF='LATICE       '#                                                   OS40  32
CBUF(12^12)=CEN(LATIS^LATIS)#                                           OS40  33
CBUF(9^9)=INV(CENT+1^CENT+1)#                                           OS40  34
dump:(CBUF)#                                                            OS40  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  OS40  36
ELSE IF(IOSRC==xd:)#                                                    OS40  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  OS40  38
CBUF='LATT       '#                                                     OS40  39
CBUF(6^6)=INV(CENT+1^CENT+1)#                                           OS40  40
CBUF(8^8)=CEN(LATIS^LATIS)#                                             OS40  41
dump:(CBUF)#                                                            OS40  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  OS40  43
#                                                                       OS40  44
#                                                                       OS40  45
#                                                                       OS40  46
N=0#                                   Symop count                      OS40  47
FOR(LS=MARK1;LS<MARK2;LS=LS+12)#       Loop over symops                 OS40  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  OS40  49
K=1#                                   Reset char op pointer            OS40  50
DO L=1,3#                              Loop over symop matrix           OS40  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  OS40  52
I=LS+L#                                Point to row pointer             OS40  53
J=MOD(NINT(QX(I+9)*12.)+48,12)*3#      Get transln element              OS40  54
IF(J>0) LINE(K^K+2)=FRAC(J+1^J+3)#     Store transl fraction            OS40  55
IF(J>0) K=K+3#                         Incr op pointer                  OS40  56
DO M=1,3#                              Loop along row elements          OS40  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  OS40  58
J=NINT(QX(I+M*3-3))#                   Point to next element            OS40  59
IF(J==0) NEXT#                         Skip zero elements               OS40  60
LINE(K^K+1)=XYZ(J*3+2+M*2^); K=K+2#    Extract xyz string               OS40  61
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  OS40  62
IF(L<3) LINE(K^K)=',';  K=K+1#         Place comma between elements     OS40  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  OS40  64
IF(IOSRC==shelx:)IF(LS>MARK1) dump:('SYMM   '//LINE(1^K-2))# Skip ide   OS40  65
IF(IOSRC==valray:)dump:('SYMTRY '//LINE(1^K-2))#                        OS40  66
IF(IOSRC==xd:)    dump:('SYM    '//LINE(1^K-2))#                        OS40  67
N=N+1#                                                                  OS40  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  OS40  69
#                                                                       OS40  70
#                                                                       OS40  71
RETURN#                                                                 OS40  72
END#                                                                    OS40  73
systemheader:(OS50)#                   Scattering factor types          OS50   1
# ####################################################################  OS50   2
#                                                                       OS50   3
#                                OS50                                   OS50   4
#                                                                       OS50   5
# ####################################################################  OS50   6
SUBROUTINE OS50#                                                        OS50   7
include:(AACOMN)#                                                       OS50   8
include:(OSCOMN)#                                                       OS50   9
#                                                                       OS50  10
string:(SCFTYP,8)#                                                      OS50  11
intdata:(INM,[20,35,45])#                                               OS50  12
intdata:(ISTP,[1,2,5])#                                                 OS50  13
datastuff:#                                                             OS50  14
#                                                                       OS50  15
IF(IOSRC==shelx:)#                                                      OS50  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS50  17
CBUF='SFAC  '#                                                          OS50  18
INC=6#                                                                  OS50  19
DO I=1,NTYP#                                                            OS50  20
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  OS50  21
movertoc:(QX(MARK2+1+(I-1)*ISCF),1,SCFTYP,1,8,0)#                       OS50  22
DO J=1,8;   IF(SCFTYP(J^J)!=' ')BREAK#                                  OS50  23
DO K=8,1,-1;IF(SCFTYP(K^K)!=' ')BREAK#                                  OS50  24
CBUF(INC^)=SCFTYP(J^K)//' '#                                            OS50  25
INC=INC+MAX(K-J+2,4)#                                                   OS50  26
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  OS50  27
dump:(CBUF)#                                                            OS50  28
CBUF='REM DISP  '#                     shelxs dont like the disp line!
DO I=1,NTYP#                                                            OS50  30
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  OS50  31
movertoc:(QX(MARK2+1+(I-1)*ISCF),1,SCFTYP,1,8,0)#                       OS50  32
DO J=1,8;   IF(SCFTYP(J^J)!=' ')BREAK#                                  OS50  33
DO K=8,1,-1;IF(SCFTYP(K^K)!=' ')BREAK#                                  OS50  34
CBUF(10^)=SCFTYP(J^K)//' '#                  
ncodefld:(ADR(I),1,CBUF,190732.,1)#         
ncodefld:(ADI(I),1,CBUF,270732.,1)#        
dump:(CBUF)#                                                            OS50  38
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  OS50  39
CBUF='UNIT  '#                                                          OS50  40
LCHROT=7#                                                               OS50  41
DO I=1,NTYP; ncodefld:(ATA(I),1,CBUF,613.,1)#                           OS50  42
#                                                                       OS50  43
dump:(CBUF)#                                                            OS50  44
CBUF='REM  TREF     ! for direct methods structure solution '#          OS50  45
dump:(CBUF)#                                                            OS50  46
CBUF='REM  PATT     ! for Patterson method structure solution '#        OS50  47
dump:(CBUF)#                                                            OS50  48
CBUF='REM  TEXP     ! for partial structure expansion '#                OS50  49
dump:(CBUF)#                                                            OS50  50
CBUF='REM  L.S.  10 ! for 10 least squares cycles '#                    OS50  51
dump:(CBUF)#                                                            OS50  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS50  53
#                                                                       OS50  54
#                                                                       OS50  55
#                                                                       OS50  56
#                                                                       OS50  57
ELSE IF(IOSRC==valray:)#                                                OS50  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  OS50  59
CBUF='DISPER  '#                                                        OS50  60
DO I=1,NTYP#                                                            OS50  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  OS50  62
movertoc:(QX(MARK2+1+(I-1)*ISCF),1,SCFTYP,1,8,0)#                       OS50  63
DO J=1,8;   IF(SCFTYP(J^J)!=' ')BREAK#                                  OS50  64
DO K=8,1,-1;IF(SCFTYP(K^K)!=' ')BREAK#                                  OS50  65
CBUF(8^)=SCFTYP(J^J+1)//' '#                                            OS50  66
ncodefld:(ADR(I),1,CBUF,210732.,1)#                                     OS50  67
ncodefld:(ADI(I),1,CBUF,290732.,1)#                                     OS50  68
dump:(CBUF)#                                                            OS50  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  OS50  70
#FCORE  NB       2.00   5.689                                           OS50  71
#FVAL   NB       2.00 -4.800 FEXP                                       OS50  72
DO I=1,NTYP#                           For each scat factor type        OS50  73
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  OS50  74
movertoc:(QX(MARK2+1+(I-1)*ISCF),1,SCFTYP,1,8,0)#                       OS50  75
DO J=1,8;   IF(SCFTYP(J^J)!=' ')BREAK#                                  OS50  76
DO K=8,1,-1;IF(SCFTYP(K^K)!=' ')BREAK#                                  OS50  77
L0=MARK3+(I-1)*NSCF+1#                 Atom type scat table offset      OS50  78
IPT=1#                                                                  OS50  79
ICNT=0#                                Step change pointer              OS50  80
L=0#                                   Scat array pointer               OS50  81
WHILE(INM(IPT)-ICNT>=0)#               Convert 200 points into just 5   OS50  82
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  OS50  83
STOL=0.0+(L)*DSTL#                                                      OS50  84
FAC=QX(L0+L)#                                                           OS50  85
CBUF='FCORE '//SCFTYP(J^J+1)//' '#                                      OS50  86
ncodefld:(STOL,1,CBUF,200752.,1)#                                       OS50  87
ncodefld:(FAC ,1,CBUF,280832.,1)#                                       OS50  88
IF(ICNT==0) CBUF(33^)="IT Vol C. Table 6.1.1.4"#                        OS50  89
dump:(CBUF)#                                                            OS50  90
IF(INM(IPT)-ICNT==0&IPT<3) IPT=IPT+1#                                   OS50  91
L=L+ISTP(IPT)#                                                          OS50  92
ICNT=ICNT+1#                                                            OS50  93
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  OS50  94
#                                                                       OS50  95
CBUF='FVAL  '//SCFTYP(J^J+1)//' '#                                      OS50  96
ncodefld:(2.00,1,CBUF,200752.,1)#                                       OS50  97
ncodefld:(-4.8,1,CBUF,280832.,1)#                                       OS50  98
CBUF(29^32)='FEXP'#                                                     OS50  99
dump:(CBUF)#                                                            OS50 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  OS50 101
# IGNORE THESE, FOR NOW...                                              OS50 102
#FORMFX                                                                 OS50 103
#FLSHEL                                                                 OS50 104
#FDIPOL                                                                 OS50 105
#FQUAD                                                                  OS50 106
#FOCTAP                                                                 OS50 107
#FHEXAD                                                                 OS50 108
#FTRICO                                                                 OS50 109
#FHEXAC                                                                 OS50 110
#FHECTO                                                                 OS50 111
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  OS50 112
#                                                                       OS50 113
#                                                                       OS50 114
#                                                                       OS50 115
#                                                                       OS50 116
ELSE IF(IOSRC==xd:)#                                                    OS50 117
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  OS50 118
# NEEDS XD.BNK DATA BANK FILE                                           OS50 119
#SCAT                                                                   OS50 120
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  OS50 121
#                                                                       OS50 122
#                                                                       OS50 123
RETURN#                                                                 OS50 124
END#                                                                    OS50 125
systemheader:(OS55)#                   Valdat sundries                  OS55   1
# ####################################################################  OS55   2
#                                                                       OS55   3
#                                OS55                                   OS55   4
#                                                                       OS55   5
# ####################################################################  OS55   6
SUBROUTINE OS55#                                                        OS55   7
include:(AACOMN)#                                                       OS55   8
include:(OSCOMN)#                                                       OS55   9
chardata:(A1,$#                                                         OS55  10
'VECTOR 0.0     0.0     1.0     0 0.0     1.0     0.0     0')#          OS55  11
chardata:(A2,'ABSORB  1')#                                              OS55  12
chardata:(A3,'CONDIT         .71073 1.5000           1  9  2')#         OS55  13
chardata:(A4,'SCALE 1.0003301    1           1  1.0 0.020')#            OS55  14
chardata:(A5,'FORMAT(3I4,2F9.3,3X,F7.4)')#                              OS55  15
chardata:(A6,'REMARK now using fort.10 for the valray.hkl file')#       OS55  16
chardata:(A7,'REFIN  10     0  2511 18 18 18 IH IK IL FR FW TB')#       OS55  17
chardata:(A8,'END')#                                                    OS55  18
datastuff:#                                                             OS55  19
#                                                                       OS55  20
IF(IOSRC==valray:)#                                                     OS55  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS55  22
dump:(A1);dump:(A2)#                                                    OS55  23
dump:(A3);dump:(A4)#                                                    OS55  24
dump:(A5);dump:(A6)#                                                    OS55  25
dump:(A7);dump:(A8)#                                                    OS55  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS55  27
#                                                                       OS55  28
RETURN#                                                                 OS55  29
END#                                                                    OS55  30
systemheader:(OS60)#                   Atoms                            OS60   1
# ####################################################################  OS60   2
#                                                                       OS60   3
#                                OS60                                   OS60   4
#                                                                       OS60   5
# ####################################################################  OS60   6
SUBROUTINE OS60#                                                        OS60   7
include:(AACOMN)#                                                       OS60   8
include:(OSCOMN)#                                                       OS60   9
#                                                                       OS60  10
INTEGER I,J,K,L#                                                        OS60  11
INTEGER  ATCNT(mxat:)#                                                  OS60  12
string:(NAME1,24)#                     Atom name from bdf               OS60  13
realdata:(FV1,[110213.,231052.,1052.,1052.,1052.,1052.,1052.])#         OS60  14
realdata:(FS1,[100213.,1162.,1162.,1162.,1162.,1152.,1152.])#           OS60  15
realdata:(FS2,[161152.,1152.,1152.,1152.])#                             OS60  16
realdata:(FD1,[211162.,1162.,1162.])#                                   OS60  17
realdata:(FD2,[151162.,1162.,1162.,1162.,1162.,1162.])#                 OS60  18
chardata:(CH1,"1234567890abcdefghijklmnopqrstuvwxyz")#                  OS60  19
#TA1   2    0.357292    0.174411    0.437127    11.00000    0.00521     OS60  20
#                                                                       OS60  21
datastuff:#                                                             OS60  22
#                                                                       OS60  23
IF(MARK6>=MARK7)RETURN#                no atoms - no dump
NREL=QX(MARK7+1)#                      How many pointers?               OS60  24
DO I=1,NREL;IREL(I)=NINT(QX(MARK7+1+I))# Recover lratom: irel pointer   OS60  25
DO I=1,mxat:;ATCNT(I)=0#               Init type counts                 OS60  26
#                                                                       OS60  27
#                                                                       OS60  28
IF(IOSRC==shelx:)#                                                      OS60  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS60  30
CBUF="FVAR "#                                                           OS60  31
ifnv:(QX(MARK4+1))ncodefld:(QX(MARK4+1),1,CBUF,161052.,1)# Point to s   OS60  32
dump:(CBUF)#                                                            OS60  33
#                                                                       OS60  34
FOR(IP=MARK6;IP<MARK7;IP=IP+IATM)#                                      OS60  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  OS60  36
CBUF=" "#                                                               OS60  37
N=IP+IREL(2)#                          Make pointer to atom name        OS60  38
movertoc:(QX(N),1,NAME1,1,24,0)#       Move name to character array     OS60  39
CBUF(1^8)=NAME1(1^8)#                                                   OS60  40
IAT=1#                                 Initialize just in case          OS60  41
I=IP+IREL(1); IF(I>IP)ifnv:(QX(I)) BUFOT(1)=QX(I)# Scat type sequence   OS60  42
I=IP+IREL(3); IF(I>IP)ifnv:(QX(I)) BUFOT(2)=QX(I)# X                    OS60  43
I=IP+IREL(4); IF(I>IP)ifnv:(QX(I)) BUFOT(3)=QX(I)# Y                    OS60  44
I=IP+IREL(5); IF(I>IP)ifnv:(QX(I)) BUFOT(4)=QX(I)# Z                    OS60  45
I=IP+IREL(13);IF(I>IP) POPP=QX(I)#     Store pop parameter              OS60  46
ELSE POPP=1.#                          Else set to one                  OS60  47
I=IP+IREL(14);IF(I>IP) SMUL=QX(I)#     Store site mult.                 OS60  48
ELSE SMUL=1.#                          Else set to one                  OS60  49
BUFOT(5)=POPP*SMUL#                    Site occupancy factor???         OS60  50
ifeq:(POPP,1.0) BUFOT(5)=BUFOT(5)+10.# Fixed parameter                  OS60  51
IU=0#                                                                   OS60  52
J=IP+IREL(6);IF(J>IP) ifnv:(QX(J)) IU=1# Try for uiso                   OS60  53
I=IP+IREL(7);IF(I>IP) ifnv:(QX(I)) IU=2# Try for uij first              OS60  54
IF(IU==1)#                             Iso only                         OS60  55
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  OS60  56
BUFOT(6)=QX(J)#                        Get the uiso values              OS60  57
ncodefld:(BUFOT,1,CBUF,FS1,6)#                                          OS60  58
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  OS60  59
ELSE IF(IU==2)#                        Aniso                            OS60  60
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  OS60  61
DO K=0,5;BUFOT(6+K)=QX(I+K)#           Get the uij values               OS60  62
ncodefld:(BUFOT,1,CBUF,FS1,7)#                                          OS60  63
CBUF(78^78)='='#                       Continuation flag                OS60  64
dump:(CBUF)#                                                            OS60  65
CBUF=' '#                              Erase                            OS60  66
ncodefld:(BUFOT,8,CBUF,FS2,4)#                                          OS60  67
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  OS60  68
ELSE ncodefld:(BUFOT,1,CBUF,FS1,5)#    No adp info                      OS60  69
dump:(CBUF)#                                                            OS60  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  OS60  71
#  FINISH OF ATOM INFO                                                  OS60  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS60  73
#                                                                       OS60  74
#                                                                       OS60  75
#                                                                       OS60  76
#                                                                       OS60  77
ELSE IF(IOSRC==valray:)#                                                OS60  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  OS60  79
CBUF="LOADAT "//NCMPID(1^6)#           Do valray loadat header          OS60  80
dump:(CBUF)#                                                            OS60  81
CBUF="SCALE "#                                                          OS60  82
CBUF(20^20)="1"#                                                        OS60  83
ncodefld:(SCALE,1,CBUF,161042.,1)#                                      OS60  84
dump:(CBUF)#                                                            OS60  85
#                                                                       OS60  86
#                                                                       OS60  87
FOR(IP=MARK6;IP<MARK7;IP=IP+IATM)#                                      OS60  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  OS60  89
CBUF="ATOM "#                                                           OS60  90
IAT=1#                                 Initialize just in case          OS60  91
I=IP+IREL(1); IF(I>IP)ifnv:(QX(I)) IAT=QX(I)# Scat type sequence        OS60  92
#                                      Construct a unique 2char label   OS60  93
ATCNT(IAT)=ATCNT(IAT)+1#                                                OS60  94
J=1+MOD(ATCNT(IAT)-1,36)#                                               OS60  95
CBUF(13^13)=CH1(J^J)#                                                   OS60  96
K=(ATCNT(IAT)-J)/36#                                                    OS60  97
IF(K>1) CBUF(12^12)=CH1(K^K)#                                           OS60  98
#                                                                       OS60  99
BUFOT(1)=0.0#                          Polarized h atom ignore          OS60 100
I=IP+IREL(3); IF(I>IP)ifnv:(QX(I)) BUFOT(2)=QX(I)# X                    OS60 101
I=IP+IREL(4); IF(I>IP)ifnv:(QX(I)) BUFOT(3)=QX(I)# Y                    OS60 102
I=IP+IREL(5); IF(I>IP)ifnv:(QX(I)) BUFOT(4)=QX(I)# Z                    OS60 103
BUFOT(5)=0.0#                          B-iso ignore                     OS60 104
I=IP+IREL(13);IF(I>IP)ifnv:(QX(I)) BUFOT(6)=QX(I)# Popp                 OS60 105
N=IP+IREL(2)#                          Make pointer to atom name        OS60 106
movertoc:(QX(N),1,NAME1,1,24,0)#       Move name to character array     OS60 107
label:(NAME1,I,J)#                     Get max label length             OS60 108
CBUF(8^9)=NAME1(1^J)#                  Extract scatt fact symbol        OS60 109
ncodefld:(BUFOT,1,CBUF,FV1,6)#                                          OS60 110
dump:(CBUF)#                                                            OS60 111
#                                                                       OS60 112
IU=0#                                                                   OS60 113
J=IP+IREL(6);IF(J>IP) ifnv:(QX(J)) IU=1# Try for uiso                   OS60 114
I=IP+IREL(7);IF(I>IP) ifnv:(QX(I)) IU=2# Try for uij first              OS60 115
IF(IU==2)#                             Iso only                         OS60 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  OS60 117
CBUF(1^5)="UIJ  "#                                                      OS60 118
DO K=0,5;BUFOT(2+K)=QX(I+K)#           Get the uij values               OS60 119
ncodefld:(BUFOT,1,CBUF,FV1,7)#                                          OS60 120
dump:(CBUF)#                                                            OS60 121
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  OS60 122
ELSE IF(IU==1)#                                                         OS60 123
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  OS60 124
CBUF(1^5)="U    "#                                                      OS60 125
BUFOT(2)=QX(J)#                        Get the uiso values              OS60 126
ncodefld:(BUFOT,1,CBUF,FV1,2)#                                          OS60 127
dump:(CBUF)#                                                            OS60 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  OS60 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  OS60 130
CBUF="END  "#                                                           OS60 131
dump:(CBUF)#                                                            OS60 132
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  OS60 133
#                                                                       OS60 134
#                                                                       OS60 135
ELSE IF(IOSRC==xd:)#                                                    OS60 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  OS60 137
CBUF="LOADPAR "#                                                        OS60 138
IAT=(MARK7-MARK6)/IATM#                                                 OS60 139
ncodefld:(FLOAT(IAT),1,CBUF,160813.,1)#                                 OS60 140
dump:(CBUF)#                                                            OS60 141
#                                                                       OS60 142
#DO I=1,100 ; WRITE(6,*) I,IOSRC,"XXX",OUTFIL(1^10)                     OS60 143
#DO I=1,100 ; DUMP:(CBUF)                                               OS60 144
#                                                                       OS60 145
FOR(IP=MARK6;IP<MARK7;IP=IP+IATM)#                                      OS60 146
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 OS60 147
CBUF=" "#                                                               OS60 148
N=IP+IREL(2)#                          Make pointer to atom name        OS60 149
movertoc:(QX(N),1,NAME1,1,24,0)#       Move name to character array     OS60 150
CBUF(1^8)=NAME1(1^8)#                                                   OS60 151
IAT=1#                                 Initialize just in case          OS60 152
I=IP+IREL(1); IF(I>IP)ifnv:(QX(I)) BUFOT(1)=QX(I)# Scat type sequence   OS60 153
I=IP+IREL(3); IF(I>IP)ifnv:(QX(I)) BUFOT(2)=QX(I)# X                    OS60 154
I=IP+IREL(4); IF(I>IP)ifnv:(QX(I)) BUFOT(3)=QX(I)# Y                    OS60 155
I=IP+IREL(5); IF(I>IP)ifnv:(QX(I)) BUFOT(4)=QX(I)# Z                    OS60 156
I=IP+IREL(13);IF(I>IP) POPP=QX(I)#     Store pop parameter              OS60 157
ELSE POPP=1.#                          Else set to one                  OS60 158
I=IP+IREL(14);IF(I>IP) SMUL=QX(I)#     Store site mult.                 OS60 159
ELSE SMUL=1.#                          Else set to one                  OS60 160
BUFOT(5)=POPP*SMUL#                    Site occupancy factor???         OS60 161
ifeq:(POPP,1.0) BUFOT(5)=BUFOT(5)+10.# Fixed parameter                  OS60 162
IU=0#                                                                   OS60 163
J=IP+IREL(6);IF(J>IP) ifnv:(QX(J)) IU=1# Try for uiso                   OS60 164
I=IP+IREL(7);IF(I>IP) ifnv:(QX(I)) IU=2# Try for uij first              OS60 165
BUFOT(6)=QX(J)#                        Get the uiso values              OS60 166
ncodefld:(BUFOT,2,CBUF,FD1,3)#                                          OS60 167
dump:(CBUF)#                                                            OS60 168
IF(IU==2)#                             Aniso                            OS60 169
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 OS60 170
CBUF=' '#                              Erase                            OS60 171
DO K=1,6;BUFOT(5+K)=QX(I+K-1)#         Get the uij values               OS60 172
#WRITE(6,*)BUFOT(6),BUFOT(7),BUFOT(8),BUFOT(9),BUFOT(10),BUFOT(11)      OS60 173
ncodefld:(BUFOT,6,CBUF,FD2,6)#                                          OS60 174
dump:(CBUF)#                                                            OS60 175
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 OS60 176
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 OS60 177
#  FINISH OF ATOM INFO                                                  OS60 178
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  OS60 179
#                                                                       OS60 180
#                                                                       OS60 181
RETURN#                                                                 OS60 182
END#                                                                    OS60 183
systemheader:(OS70)#                   Output reflections               OS70   1
# ####################################################################  OS70   2
#                                                                       OS70   3
#                                OS70                                   OS70   4
#                                                                       OS70   5
# ####################################################################  OS70   6
SUBROUTINE OS70#                                                        OS70   7
include:(AACOMN)#                                                       OS70   8
include:(OSCOMN)#                                                       OS70   9
INTEGER LNBL, LNBLNK#                                                   OS70  10
#                                                                       OS70  11
#                                                                       OS70  12
IF(IOSRC==shelx:)#                                                      OS70  13
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS70  14
CBUF='HKLF 4 '#                                                         OS70  15
dump:(CBUF)#                                                            OS70  16
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS70  17
ELSE IF(IOSRC==valray:)#                                                OS70  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  OS70  19
#REFIN                                                                  OS70  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  OS70  21
ELSE IF(IOSRC==xd:)#                                                    OS70  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  OS70  23
LNBL=LNBLNK(OUTFIL)#                                                    OS70  24
CBUF='FILE '//OUTFIL(1^LNBL)//'.hkl'#  Xd.hkl file name                 OS70  25
dump:(CBUF)#                                                            OS70  26
CBUF='LOADREF  N   6'#                                                  OS70  27
dump:(CBUF)#                                                            OS70  28
CBUF='END '#                                                            OS70  29
dump:(CBUF)#                                                            OS70  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  OS70  31
#                                                                       OS70  32
#                                                                       OS70  33
RETURN#                                                                 OS70  34
END#                                                                    OS70  35
systemheader:(OS80)#                   Refine params                    OS80   1
# ####################################################################  OS80   2
#                                                                       OS80   3
#                                OS80                                   OS80   4
#                                                                       OS80   5
# ####################################################################  OS80   6
SUBROUTINE OS80#                                                        OS80   7
include:(AACOMN)#                                                       OS80   8
include:(OSCOMN)#                                                       OS80   9
#                                                                       OS80  10
IF(IOSRC==shelx:)#                                                      OS80  11
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS80  12
#OMIT 4 100                                                             OS80  13
#                                                                       OS80  14
#L.S. 10                                                                OS80  15
#BOND                                                                   OS80  16
#FMAP 2                                                                 OS80  17
#PLAN 40                                                                OS80  18
#TWIN -1 0 0   0 -1 0   0 0 -1   2                                      OS80  19
#REM ACTA                                                               OS80  20
#                                                                       OS80  21
#WGHT    0.051600  105.730492                                           OS80  22
#EXTI    0.002881                                                       OS80  23
#BASF   0.53700                                                         OS80  24
#                                                                       OS80  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS80  26
ELSE IF(IOSRC==valray:)#                                                OS80  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  OS80  28
#VALLSQ SRNBO  10  2  0  0  0  0  1  1                                  OS80  29
#REMARK   1         2         3         4         5         6         7 OS80  30
#REMARK 890123456789012345678901234567890123456789012345678901234567890 OS80  31
#REMARK  SET SHELL/CORE ELECTRON POPULATIONS                            OS80  32
#POPVAL SR   1  0  1    1.0  2    0.0  3    0.0                         OS80  33
#POPVAL SR   2  0  1    1.0  2    0.0  3    0.0                         OS80  34
#POPVAL NB   1  0  1    1.0  2    0.0  3    0.0                         OS80  35
#POPVAL NB   2  0  1    1.0  2    0.0  3    0.0                         OS80  36
#POPVAL O    1  0  1    1.0  2    0.0  3    0.0                         OS80  37
#POPVAL O    2  0  1    1.0  2    0.0  3    0.0                         OS80  38
#POPVAL O    3  0  1    1.0  2    0.0  3    0.0                         OS80  39
#POPVAL O    4  0  1    1.0  2    0.0  3    0.0                         OS80  40
#SCALE    0.99680                                                       OS80  41
#MAXHKL                                                                 OS80  42
#RADPRM                                                                 OS80  43
#REMARK  REFINING CUMULANTS                                             OS80  44
#CUMCOF SR   1 3 0.00000E-00 0.00000E-00 0.00000E-00 0.00000E-00 0.0000 OS80  45
#CUMCOF          0.00000E-00 0.00000E-00 0.00000E-00 0.00000E-00 0.0000 OS80  46
#CUMCOF SR   2 3 0.00000E-00 0.00000E-00 0.00000E-00 0.00000E-00 0.0000 OS80  47
#CUMCOF          0.00000E-00 0.00000E-00 0.00000E-00 0.00000E-00 0.0000 OS80  48
#CUMCOF NB   1 3 0.00000E-00 0.00000E-00 0.00000E-00 0.00000E-00 0.0000 OS80  49
#REF    SK                                                              OS80  50
#REF    SR   1B11B22B33B12                                              OS80  51
#REF    SR   1C1 C2 C3 C4 C5 C6 C7 C8 C9 C10                            OS80  52
#REF    SR   2Z  B11B22B33B12                                           OS80  53
#REF    SR   2C1 C2 C3 C4 C5 C6 C7 C8 C9 C10                            OS80  54
#REF    NB   1Z  B11B22B33B12                                           OS80  55
#REF    NB   1C1 C2 C3 C4 C5 C6 C7 C8 C9 C10                            OS80  56
#REF    NB   2Z  B11B22B33B12                                           OS80  57
#REF    NB   2C1 C2 C3 C4 C5 C6 C7 C8 C9 C10                            OS80  58
#REF    O    1X  Y  Z  B11B22B33B12B13B23                               OS80  59
#REMARK REF    O    1C1 C2 C3 C4 C5 C6 C7 C8 C9 C10                     OS80  60
#REF    O    2X  Y  Z  B11B22B33B12B13B23                               OS80  61
#REMARK REF    O    2C1 C2 C3 C4 C5 C6 C7 C8 C9 C10                     OS80  62
#REF    O    3Z  B11B22B33B12                                           OS80  63
#REMARK REF    O    3C1 C2 C3 C4 C5 C6 C7 C8 C9 C10                     OS80  64
#REF    O    4Z  B11B22B33B12                                           OS80  65
#REMARK REF    O    4C1 C2 C3 C4 C5 C6 C7 C8 C9 C10                     OS80  66
#NOREF                                                                  OS80  67
#CONSTR                                                                 OS80  68
#EXTINC                                                                 OS80  69
#FCALC                                                                  OS80  70
#ZERPOP                                                                 OS80  71
#LASTCY                                                                 OS80  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  OS80  73
ELSE IF(IOSRC==xd:)#                                                    OS80  74
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  OS80  75
#END XDINI                                                              OS80  76
#MODULE XDLSM                                                           OS80  77
#SELECT                                                                 OS80  78
#SAVE                                                                   OS80  79
#SOLVE                                                                  OS80  80
#SKIP                                                                   OS80  81
#PRINT                                                                  OS80  82
#SCAT                                                                   OS80  83
#ATOM                                                                   OS80  84
#GROUP                                                                  OS80  85
#KEEP                                                                   OS80  86
#WEIGHT                                                                 OS80  87
#DMSDA                                                                  OS80  88
#EXTCN                                                                  OS80  89
#FOUR                                                                   OS80  90
#CON                                                                    OS80  91
#KEY                                                                    OS80  92
#END XDLSM                                                              OS80  93
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  OS80  94
#                                                                       OS80  95
RETURN#                                                                 OS80  96
END#                                                                    OS80  97
systemheader:(OS90)#                   Finish off outsrc file           OS90   1
# ####################################################################  OS90   2
#                                                                       OS90   3
#                                OS90                                   OS90   4
#                                                                       OS90   5
# ####################################################################  OS90   6
SUBROUTINE OS90#                                                        OS90   7
include:(AACOMN)#                                                       OS90   8
include:(OSCOMN)#                                                       OS90   9
#                                                                       OS90  10
IF(IOSRC==shelx:)#                                                      OS90  11
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS90  12
CBUF='END '#                                                            OS90  13
dump:(CBUF)#                                                            OS90  14
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS90  15
#                                                                       OS90  16
readwpkt:(1,endrecord:,LPAK,IP,0)#                                      OS90  17
#                                                                       OS90  18
RETURN#                                                                 OS90  19
END#                                                                    OS90  20
pmacro:([no:])#                        Purge xtal system macros         OS90  21
