systemheader:(PF    )#                                                  PF     1
####################################################################### PF     2
##                                                                    # PF     3
##                       *** PERFAC ***                               # PF     4
##                                                                    # PF     5
##    Calculate monochromator perfection factor which is the ratio    # PF     6
##    of the dynamical to kinematic (perfect to imperfect) componen   # PF     7
##    used in the Lorentz-polarization factor. See the paper H. Hope  # PF     8
##    Acta Cryst. (1971) A27, 392.                                    # PF     9
##                                                                    # PF    10
####################################################################### PF    11
#                                                                       PF    12
include:(XMACRO)#                                                       PF    13
#                                                                       PF    14
systemheader:(PF00)#                                                    PF00   1
######################################################################  PF00   2
#                                                                    #  PF00   3
#                               PF00                                 #  PF00   4
#                                                                    #  PF00   5
######################################################################  PF00   6
SUBROUTINE    PF00#                    S.r. hall june 88                PF00   7
include:(AACOMN)#                                                       PF00   8
#                                                                       PF00   9
INTEGER I,J,IPAK,#                     General pointers                 PF00  10
IWNT(10),IREL(11),KEY(4)#              Indexpkt variables               PF00  11
INTEGER I1,I2,I3,#                     Pkt pointers files a b c         PF00  12
IH,IS,II,IJ,IR,#                       Lrrefl: pointers                 PF00  13
MARK1,STEP1,STOP1,#                    Qx bin list markers              PF00  14
NPER#                                  Number of perfacs applied        PF00  15
REAL SUMN,SUMF,SUMD(8)#                Summation variables              PF00  16
REAL FERP(8),THET,SUMM(8)#             Summation variables              PF00  17
REAL FF,FK,FD,FM#                      Frel variables                   PF00  18
REAL SMAX#                             Max st/l                         PF00  19
REAL TOT(10),#                         Total bin sums                   PF00  20
HKL1(3), HKL2(3),#                     Hkl arrays                       PF00  21
FTH,RTH,TTH,#                          Bin thresholds                   PF00  22
PERF(8),#                              Perfection factors               PF00  23
WLN,#                                  Wavelength used                  PF00  24
SCLF,SCLK,SCLD#                        Frel scales                      PF00  25
#                                                                       PF00  26
chardata:(PF1,"  Mean   hkl       F(mono)/F(filter) ratios for $#       PF00  27
the monochr. perfection factors")#                                      PF00  28
chardata:(PF2," Theta  Count                                    $#      PF00  29
                               ")#                                      PF00  30
chardata:(PF3," Reflection mismatch on fileA              and$#         PF00  31
 fileB            ")#                                                   PF00  32
chardata:(PF4, APPLY END )#                                             PF00  33
chardata:(PF5," PERFAC Control Parameters")#                            PF00  34
chardata:(PF6," Radiation wavelength                -")#                PF00  35
chardata:(PF7," Threshold of included Frels          ")#                PF00  36
chardata:(PF8," Theta limit of included data         ")#                PF00  37
chardata:(PF9," Threshold of included ratios         ")#                PF00  38
chardata:(PFA," Frel scale filter data               ")#                PF00  39
chardata:(PFB," Frel scale mono/kinLp data           ")#                PF00  40
chardata:(PFC," Frel scale mono/dynLp data           ")#                PF00  41
chardata:(PFD," Average ratios")#                                       PF00  42
chardata:(PFE," F(m)/F(f) scale")#                                      PF00  43
chardata:(PFF," M-to-F R-factor")#                                      PF00  44
chardata:(PFG," Number of reflections used           ")#                PF00  45
realdata:(FMT1,[240842.,320842.,400842.,#                               PF00  46
480842.,560842.,640842.,720842.,800842.])#                              PF00  47
realdata:(FMT2,[330413.,370413.,410413.,560413.,600413.,640413.])#      PF00  48
realdata:(FMT3,[60512.,130513.])#                                       PF00  49
realdata:(RTOD,57.29578)#                                               PF00  50
datastuff:#                                                             PF00  51
#                                                                       PF00  52
FILEXT(IOUNIT(1))='FIL'#               Input filter       bdf           PF00  53
FILEXT(IOUNIT(2))='MN0'#               Input monochrom. 0 bdf           PF00  54
FILEXT(IOUNIT(3))='MN1'#               Input monochrom. 1 bdf           PF00  55
#                                                                       PF00  56
#    SET IO BUFFERS                                                     PF00  57
#    --------------                                                     PF00  58
#                                                                       PF00  59
IOMARK(1)=QXSTR#                       Start buffer filea filter hkl    PF00  60
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start buffer fileb mono/k hkl    PF00  61
IOMARK(3)=IOMARK(2)+bdfbuf:#           Start buffer filec mono/d hkl    PF00  62
MARK1    =IOMARK(3)+bdfbuf:#           Start of bin storage             PF00  63
STEP1=10#                              Step of bin storage              PF00  64
incrqx:(STOP1,MARK1+20*STEP1,PF0005)#  Incr memory for bin storage      PF00  65
#                                                                       PF00  66
#    EXTRACT SCALES FROM LREXPL:                                        PF00  67
#   ----------------------------                                        PF00  68
#                                                                       PF00  69
IWNT(1)=101;  IWNT(2)=2#               Get scale & wln pointer          PF00  70
KEY(1)=2; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search keys                 PF00  71
indexpkt:(1,lrexpl:,IPAK,IP,0,KEY,IWNT,IREL)# Search lrexpl directory   PF00  72
IF(KEY(4)<=0) iquit:(PF0006)#          Item is missing                  PF00  73
readwpkt:(1,lrexpl:,IPAK,IP,0)#        Point to filea pkt               PF00  74
SCLF=QX(IP+IREL(1))#                   Get frel scale                   PF00  75
WLN= QX(IP+IREL(2))#                   Get wavelength                   PF00  76
readwpkt:(2,lrexpl:,IPAK,IP,0)#        Point to fileb pkt               PF00  77
readwpkt:(2,lrexpl:,IPAK,IP,0)#        Point to fileb pkt               PF00  78
SCLK=QX(IP+IREL(1))#                   Get frel scale                   PF00  79
readwpkt:(3,lrexpl:,IPAK,IP,0)#        Point to filec pkt               PF00  80
readwpkt:(3,lrexpl:,IPAK,IP,0)#        Point to filec pkt               PF00  81
SCLD=QX(IP+IREL(1))#                   Get frel scale                   PF00  82
#                                                                       PF00  83
#    EXTRACT MAX ST/L FROM LRDSET:                                      PF00  84
#   ------------------------------                                      PF00  85
#                                                                       PF00  86
IWNT(1)=15#                            Get max s pointer                PF00  87
KEY(1)=1; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search keys                 PF00  88
indexpkt:(1,lrdset:,IPAK,IP,0,KEY,IWNT,IREL)# Search lrrefl directory   PF00  89
IF(KEY(4)<=0) iquit:(PF0007)#          Item is missing                  PF00  90
readwpkt:(1,lrdset:,IPAK,IP,0)#        Point to filea pkt               PF00  91
SMAX=QX(IP+IREL(1))#                   Get s max                        PF00  92
readwpkt:(2,lrdset:,IPAK,IP,0)#        Point to fileb pkt               PF00  93
readwpkt:(2,lrdset:,IPAK,IP,0)#        Point to fileb pkt               PF00  94
SMAX=MIN(SMAX,QX(IP+IREL(1)))#         Get smallest s max               PF00  95
#                                                                       PF00  96
#   PROCESS THE PERFAC LINE                                             PF00  97
#   -----------------------                                             PF00  98
#                                                                       PF00  99
NPER=8#                                Number perfacs applied           PF00 100
PERF(1)=.0;  PERF(8)=1.#               Set default perfacs              PF00 101
PERF(2)=.1;  PERF(7)=.9#               Set default perfacs              PF00 102
PERF(3)=.25; PERF(6)=.75#              Set default perfacs              PF00 103
PERF(4)=.4;  PERF(5)=.6#               Set default perfacs              PF00 104
IF(BUFIN(1)>0.) FTH=BUFIN(1)#          Insert f-threshold               PF00 105
ELSE            FTH=5.#                Default f-threshold              PF00 106
IF(BUFIN(2)>0.) RTH=BUFIN(2)#          Insert ratio-threshold           PF00 107
ELSE            RTH=.1#                Default ratio-threshold          PF00 108
IF(BUFIN(3)>0.) TTH=BUFIN(3)#          Insert theta-threshold           PF00 109
ELSE            TTH=ASIN(SMAX*WLN)*RTOD-0.1# Default theta-threshold    PF00 110
#                                                                       PF00 111
#   PROCESS INPUT LINES                                                 PF00 112
#   -------------------                                                 PF00 113
#                                                                       PF00 114
REPEAT#                                Loop over input lines            PF00 115
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PF00 116
readline:(PF4,NPF4)#                   Read the next line               PF00 117
IF(LINID==2) BREAK#                    End line detected                PF00 118
#                                                                       PF00 119
DO I=1,8#                              Add up to 8 perfacs              PF00 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PF00 121
ifvo:(BUFIN(I)) BREAK#                 Test for last scale              PF00 122
NPER=I#                                Count scales entered             PF00 123
IF(BUFIN(I)<0.\BUFIN(I)>1.) iquit:(PF0008)# Illegal perfac entry        PF00 124
PERF(I)=BUFIN(I)#                      Store perfection factors         PF00 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PF00 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PF00 127
#                                                                       PF00 128
#   PRINT CONTROL PARAMETERS                                            PF00 129
#   ------------------------                                            PF00 130
#                                                                       PF00 131
movechar:(PF6,NPF6,CHROT,2,NPF5-1,1)#  Insert header underline          PF00 132
writeline:(1,PF5,NPF5,2,3)#            Print header                     PF00 133
ncodefld:(WLN,1,PF6,380752.,1)#        Format wavelength                PF00 134
writeline:(0,PF6,NPF6,3,3)#            Print wavelength                 PF00 135
ncodefld:(TTH,1,PF8,380732.,1)#        Format theta-threshold           PF00 136
writeline:(0,PF8,NPF8,3,3)#            Print theta-threshold            PF00 137
ncodefld:(FTH,1,PF7,380722.,1)#        Format f-threshold               PF00 138
writeline:(0,PF7,NPF7,3,3)#            Print f-threshold                PF00 139
ncodefld:(RTH,1,PF9,380742.,1)#        Format ratio-threshold           PF00 140
writeline:(0,PF9,NPF9,3,3)#            Print ratio-threshold            PF00 141
ncodefld:(SCLF,1,PFA,380732.,1)#       Format scale filter              PF00 142
writeline:(0,PFA,NPFA,3,3)#            Print scale filter               PF00 143
ncodefld:(SCLK,1,PFB,380732.,1)#       Format scale mono/kin            PF00 144
writeline:(0,PFB,NPFB,3,3)#            Print scale mono/kin             PF00 145
ncodefld:(SCLD,1,PFC,380732.,1)#       Format scale mono/dyn            PF00 146
writeline:(0,PFC,NPFC,3,3)#            Print scale mono/dyn             PF00 147
#                                                                       PF00 148
#    SEARCH DIRECTORY OF LRREFL:                                        PF00 149
#    ---------------------------                                        PF00 150
#                                                                       PF00 151
IWNT(1)=1;    IWNT(2)=2#               Request hkl & stl   idnum        PF00 152
IWNT(3)=1308; IWNT(4)=1300#            Request rcod & inten idnum       PF00 153
IWNT(5)=1304#                          Request frel       idnum         PF00 154
KEY(1)=5; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search keys                 PF00 155
indexpkt:(1,lrrefl:,IPAK,IP,0,KEY,IWNT,IREL)# Search lrrefl directory   PF00 156
IF(KEY(4)<=0) iquit:(PF0009)#          Item is missing                  PF00 157
IH=IREL(1);   IS=IREL(2)#              Store hkl/stl pointers           PF00 158
IR=IREL(3);   II=IREL(4)#              Store rcod/int pointers          PF00 159
IJ=IREL(5)#                            Store frel     pointers          PF00 160
readwpkt:(2,lrrefl:,IPAK,IP,0)#        Skip fileb directory             PF00 161
readwpkt:(3,lrrefl:,IPAK,IP,0)#        Skip filec directory             PF00 162
#                                                                       PF00 163
#    SETUP PARAMETERS                                                   PF00 164
#    ----------------                                                   PF00 165
#                                                                       PF00 166
SUMN=0.;  SUMF=0.#                     Zero summation values            PF00 167
DO I=1,8; SUMD(I)=0.#                  Zero summation values            PF00 168
DO I=1,10; TOT(I)=0.#                  Zero totals                      PF00 169
DO I=1,NPER; FERP(I)=1.-PERF(I)#       Get reverse perfac values        PF00 170
TTH=SIN(TTH/RTOD)/WLN#                 Calc stol threshold              PF00 171
#                                                                       PF00 172
#    ENTER LRREFL: BDF RECORDS                                          PF00 173
#    -------------------------                                          PF00 174
#                                                                       PF00 175
REPEAT#                                Loop over lrrefl records         PF00 176
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PF00 177
readwpkt:(1,lrrefl:,IPAK,I1,0)#        Point to hkl packet filter       PF00 178
IF(I1<=0) BREAK#                       Exit reflection loop             PF00 179
IF(QX(I1+IS)>TTH) NEXT#                Skip hkl above theta limit       PF00 180
100 CONTINUE#                                                           PF00 181
readwpkt:(2,lrrefl:,IPAK,I2,0)#        Point to hkl packet mono/k       PF00 182
IF(I2<=0) BREAK#                       Exit reflection loop             PF00 183
readwpkt:(3,lrrefl:,IPAK,I3,0)#        Point to hkl packet mono/d       PF00 184
IF(I3<=0) BREAK#                       Exit reflection loop             PF00 185
IF(QX(I3+IS)>TTH)GOTO 100#             Skip hkl above theta limit       PF00 186
#                                                                       PF00 187
compakwd:(QX(I1+IH),EQ,QX(I2+IH),GOTO 200)# Test hkl                    PF00 188
gethkl:(I1+IH,HKL1); gethkl:(I2+IH,HKL2)# Extract the h,k,l             PF00 189
ncodefld:(HKL1,1,PF3,FMT2,3)#          Format offending hkl's           PF00 190
ncodefld:(HKL2,1,PF3,FMT2(4),3)#       Format offending hkl's           PF00 191
writeline:(1,PF3,NPF3,3,3)#            Tell the user                    PF00 192
iquit:(PF0010)#                        And exit                         PF00 193
#                                                                       PF00 194
200 CONTINUE#                                                           PF00 195
ifne:(QX(I1+IR),1.) NEXT#              Skip if rcode > 1                PF00 196
ifne:(QX(I2+IR),1.) NEXT#              Skip if rcode > 1                PF00 197
ifne:(QX(I3+IR),1.) NEXT#              Skip if rcode > 1                PF00 198
IF(QX(I1+IJ)<FTH\QX(I2+IJ)<FTH\QX(I3+IJ)<FTH) NEXT# F-thresh            PF00 199
#                                                                       PF00 200
THET=ASIN(QX(I1+IS)*WLN)*RTOD#         Get theta in degrees             PF00 201
J=MARK1+STEP1*INT(THET/5.)#            Pointer as theta in 5deg         PF00 202
#                                                                       PF00 203
FF=SCLF*QX(I1+IJ)#                     Scale frel filter                PF00 204
FK=SCLK*QX(I2+IJ)#                     Scale frel mono/kin              PF00 205
FD=SCLD*QX(I3+IJ)#                     Scale frel mono/dyn              PF00 206
IF(ABS(1.-(FD+FK)/(FF+FF))>RTH) NEXT#  Skip bad data                    PF00 207
SUMN=SUMN+1.#                          Count all entries                PF00 208
SUMF=SUMF+FF#                          Sum filter frels                 PF00 209
DO I=1,NPER#                           Loop over perf factors           PF00 210
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PF00 211
FM=PERF(I)*FD+FERP(I)*FK#              Calc frel monochromator          PF00 212
SUMD(I)=SUMD(I)+ABS(FF-FM)#            Sum frel difference              PF00 213
SUMM(I)=SUMM(I)+FM#                    Sum frel monochromator           PF00 214
QX(J+I)=QX(J+I)+FM/FF#                 Sum ratio mono/filter            PF00 215
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PF00 216
QX(J+ 9)=QX(J+ 9)+THET#                Sum theta in degrees             PF00 217
QX(J+10)=QX(J+10)+1.#                  Count entries                    PF00 218
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PF00 219
#                                                                       PF00 220
#   LIST RATIOS                                                         PF00 221
#   -----------                                                         PF00 222
#                                                                       PF00 223
ncodefld:(SUMN,1,PFG,380813.,1)#       Format total hkl                 PF00 224
writeline:(0,PFG,NPFG,3,3)#            Print total hkl                  PF00 225
writeline:(1,PF1,NPF1,3,3)#            Print main header                PF00 226
ncodefld:(PERF,1,PF2,FMT1,NPER)#       Format perfacs                   PF00 227
writeline:(0,PF2,NPF2,2,3)#            Insert subheader                 PF00 228
FOR(J=MARK1;J<STOP1;J=J+STEP1)#        Loop all possible theta bins     PF00 229
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PF00 230
CNT=QX(J+10)#                          Store bin count                  PF00 231
ifeq:(CNT,0.) NEXT#                    Skip empty bins                  PF00 232
DO I=1,10; TOT(I)=TOT(I)+QX(J+I)#      Sum totals                       PF00 233
DO I=1, 9; BUFOT(I)=QX(J+I)/CNT#       Store averages                   PF00 234
ncodefld:(BUFOT,1,CHROT,FMT1,NPER)#    Format bin entries               PF00 235
BUFOT(10)=CNT#                         Store bin count for op           PF00 236
ncodefld:(BUFOT,9,CHROT,FMT3,2)#       Format theta & count             PF00 237
writeline:(0,PF2,NPF2,1,3)#            Print bin entries                PF00 238
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PF00 239
DO I=1,NPER; TOT(I)=TOT(I)/TOT(10)#    Get total averages               PF00 240
movechar:(PFD,1,CHROT,1,NPFD,0)#       Insert subheader                 PF00 241
ncodefld:(TOT,1,CHROT,FMT1,NPER)#      Format averages                  PF00 242
writeline:(1,PF2,NPF2,1,3)#            Print averages                   PF00 243
#                                                                       PF00 244
DO I=1,NPER; SUMD(I)=SUMD(I)/SUMF#     Calc agreement factor            PF00 245
DO I=1,NPER; SUMM(I)=SUMM(I)/SUMF#     Calc scale factor                PF00 246
movechar:(PFE,1,CHROT,1,NPFE,0)#       Insert subheader                 PF00 247
ncodefld:(SUMM,1,CHROT,FMT1,NPER)#     Format scales                    PF00 248
writeline:(1,PF2,NPF2,1,3)#            Print scales                     PF00 249
movechar:(PFF,1,CHROT,1,NPFC,0)#       Insert subheader                 PF00 250
ncodefld:(SUMD,1,CHROT,FMT1,NPER)#     Format r-factors                 PF00 251
writeline:(0,PF2,NPF2,1,3)#            Print r-factors                  PF00 252
#                                                                       PF00 253
readwpkt:(1,endrecord:,I,J,0)#         Close filea                      PF00 254
readwpkt:(2,endrecord:,I,J,0)#         Close fileb                      PF00 255
readwpkt:(3,endrecord:,I,J,0)#         Close filec                      PF00 256
#                                                                       PF00 257
RETURN#                                                                 PF00 258
END#                                                                    PF00 259
pmacro:([no:])#                                                         PF00 260
