systemheader:(PH    )#                                                  PH     1
####################################################################### PH     2
#                                                                     # PH     3
#                        *** PHONYD ***                               # PH     4
#                                                                     # PH     5
#     PROGRAM FOR GENERATING PHONEY DATA BY TRANSFERRING FC TO FREL   # PH     6
#     WITH THE ADDITION OF RANDOM ERRORS AT A SPECIFIED LEVEL.        # PH     7
#                                                                     # PH     8
####################################################################### PH     9
#                                                                       PH    10
include:(XMACRO)#                                                       PH    11
#                                                                       PH    12
systemheader:(PH00)#                   Generate phony f(rel)s           PH00   1
# ################################################################## #  PH00   2
#                                                                    #  PH00   3
#                               PH00                                 #  PH00   4
#                                                                    #  PH00   5
# ################################################################## #  PH00   6
SUBROUTINE PH00#                       J.m.stewart oct 1986             PH00   7
include:(AACOMN)#                                                       PH00   8
#                                                                       PH00   9
REAL ABSORB#                           Reflection absorption factor     PH00  10
REAL ATOT,BTOT#                        A & b parts of f calculated      PH00  11
REAL COUNT(6)#                         Ran num stats                    PH00  12
INTEGER DOIT#                          Counter for friedel mates        PH00  13
INTEGER DSET#                          Data set to be treated           PH00  14
REAL DUMIN,DUMAX#                      Min/max random numbers           PH00  15
REAL EIN,ZWI,DRI#                      Ran num group counts             PH00  16
REAL ERROR#                            Relative error for phoney f      PH00  17
REAL FC#                               Fc from bdf lrrefl               PH00  18
REAL FIMIN#                            Minimum intensity                PH00  19
REAL FOFX#                             Gaussian function of ran num     PH00  20
INTEGER FRIEDL#                        Process freidel pairs signal     PH00  21
REAL FREL#                             Phoney f relative                PH00  22
REAL FSQ#                              Calculated phoney intensity      PH00  23
REAL H(3)#                             H, k, l for printing             PH00  24
INTEGER I,J#                           Loop indices                     PH00  25
REAL    IDNM(250)#                     Lrrefl packet id numbers         PH00  26
INTEGER IP,JP,NPAK,JPAK#               Packet pointers                  PH00  27
INTEGER IR,IFC,ILP,IAB#                Pointers into lrrefl             PH00  28
INTEGER IANDIS,IBNDIS,IADISP,IBDISP#   Pointers into lrrefl             PH00  29
INTEGER IRCP,IFRP,IF2P,ISFP,IS2P,ISIP# Pointers into lrrefl             PH00  30
INTEGER IRCM,IFRM,IF2M,ISFM,IS2M,ISIM# Pointers into lrrefl             PH00  31
INTEGER ISTAR#                         Point to column in input         PH00  32
INTEGER ISTURT#                        Starting point for ran nums      PH00  33
INTEGER IWNT(25),IREL(26),KEY(4)#                                       PH00  34
INTEGER LIST#                          Number of refs to print          PH00  35
INTEGER NRAND,NTRY#                    Number of ran nums generated     PH00  36
INTEGER NREF#                          Number of reflections treated    PH00  37
REAL RANNUM#                           Generated random number          PH00  38
INTEGER RCODE#                         Reflection code 1/2/3/5          PH00  39
#                                        Obs/lessthan/extinct/sysabs    PH00  40
REAL RCPLP#                            1/lp from lrrefl of bdf          PH00  41
REAL SCAL#                             Frelative scale factor           PH00  42
REAL SIGMA#                            Standard deviation of ran num    PH00  43
REAL SMEAN#                            Mean of random numbers           PH00  44
REAL STATOU(4)#                        Output ran num stats             PH00  45
REAL SUMNUM#                           Real value of integer nrand      PH00  46
REAL SUMDUM,SUMDSQ#                    More of the same                 PH00  47
REAL SUMFR,SUMFD,RR#                   R value sums                     PH00  48
#                                                                       PH00  49
EQUIVALENCE(COUNT(1),EIN)#                                              PH00  50
EQUIVALENCE(COUNT(3),ZWI)#                                              PH00  51
EQUIVALENCE(COUNT(5),DRI)#                                              PH00  52
EQUIVALENCE(STATOU(1),SMEAN)#                                           PH00  53
EQUIVALENCE(STATOU(2),SIGMA)#                                           PH00  54
EQUIVALENCE(STATOU(3),DUMAX)#                                           PH00  55
EQUIVALENCE(STATOU(4),DUMIN)#                                           PH00  56
chardata:(LPAR,[(])#                                                    PH00  57
chardata:(RPAR,[)])#                                                    PH00  58
chardata:(PH01, END   )#                                                PH00  59
chardata:(PH02,ERRSCATHRLSTRANDATFRI)# Phonyd line codes                PH00  60
chardata:(PH0A, THE REFLECTION RECORD, REFL, WILL BE COPIED)#           PH00  61
chardata:(PH0B,[ NO.  ID NUMBER  IWANT  IREL])#                         PH00  62
chardata:(PH0C,[     H    K    L  PSEUDO F+++(REL)    F---(REL)])#      PH00  63
chardata:(PH0D,         REFLECTIONS PROCESSED.)#                        PH00  64
chardata:(PH0E,[ THE R VALUE FROM THE GENERATED F RELATIVES $#          PH00  65
IS            FOR THE *OBSERVED* REFLECTIONS.])#                        PH00  66
chardata:(PH0F,[ STATISTICS FOR THE       RANDOM NUMBERS GENERATED])#   PH00  67
chardata:(PH0G,[                MEAN  STANDARD DEVIATION             $# PH00  68
MAXIMUM             MINIMUM])#                                          PH00  69
chardata:(PH0H,[               LESS THAN 1.0     $#                     PH00  70
LESS THAN 2.0     GREATER THAN OR EQUAL TO 2.0])#                       PH00  71
chardata:(PH0I,[ GENERATED ERROR IN F(REL)        ])#                   PH00  72
chardata:(PH0J,[ F(REL) SCALE FACTOR              ])#                   PH00  73
chardata:(PH0K,[ MINIMUM INTENSITY                ])#                   PH00  74
chardata:(PH0L,[ RANDOM NUMBER GENERATION SET     ])#                   PH00  75
chardata:(PH0M,[ DATA SET TREATED                 ])#                   PH00  76
chardata:(PH0N,         TRIES REQUIRED TO GENERATE THE RANDOM NUMBERS)# PH00  77
chardata:(PH0P,[ ALSO GENERATE FRIEDEL MATES      ])#                   PH00  78
realdata:(FMT2,[221052.,421052.,621052.,821052.])#                      PH00  79
realdata:(FMT3,[200713.,280532.,380713.,460532.,560713.,640532.])#      PH00  80
intdata:(SEED,[1,101,1001,5001,10001,15001,25001,30001,45001,55555])#   PH00  81
realdata:(MINHAF,[-0.5])#              Minus one half                   PH00  82
realdata:(FMT,[60413.,110413.,160413.,311232.,451232.])#                PH00  83
datastuff:#                                                             PH00  84
#                                                                       PH00  85
#    SET IO BUFFERS                                                     PH00  86
#    --------------                                                     PH00  87
#                                                                       PH00  88
IOMARK(1)=QXSTR#                       Start of buffer for file a       PH00  89
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of buffer for file b       PH00  90
incrqx:(MARK,IOMARK(2)+bdfbuf:,PH0005)# Incr memory                     PH00  91
#                                                                       PH00  92
#    SET DEFAULT VALUES FOR CONTROL PARAMETERS                          PH00  93
#    -----------------------------------------                          PH00  94
#                                                                       PH00  95
SCAL=1.0#                              Frelative scale factor           PH00  96
FIMIN=0.0#                             Minimum observed intensity       PH00  97
ERROR=0.08#                            Relative error in phoney f(rel   PH00  98
RCPLP=1.0#                             1/lp if none in bdf              PH00  99
ABSORB=1.0#                            Absorption if none in bdf        PH00 100
RCODE=1#                               Reflection code if none in bdf   PH00 101
DSET=1#                                Default data set one             PH00 102
EIN=0.0;ZWI=0.0;DRI=0.0#               Random number counts             PH00 103
FRIEDL=no:#                            Assume no friedel pairs          PH00 104
LIST=20#                               List the first 20 reflections    PH00 105
NREF=0#                                Count of reflections             PH00 106
NTRY=0#                                Count tries at ran num generat   PH00 107
NRAND=0#                               Number of ran nums accepted      PH00 108
SUMDUM=0.0;SUMDSQ=0.0#                 Statistics sums                  PH00 109
DUMIN=9999.0;DUMAX=-9999.0#            Max & min random numbers         PH00 110
SUMFR=0.0;SUMFD=0.0#                   R value sums                     PH00 111
ISTURT=5#                              Default start number is 5        PH00 112
#                                                                       PH00 113
#    SCAN PHONYD LINE FOR INSTRUCTIONS                                  PH00 114
#    ---------------------------------                                  PH00 115
#                                                                       PH00 116
FOR(J=1;BUFIN(J)<voidflg:;J=J+1)#      Loop until void or numerical     PH00 117
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PH00 118
stringlim:(J,ISTAR,I)#                 Find character string            PH00 119
compchar:(CHRIN,ISTAR,PH02,1,3,3,NPH02,I)# Check the list               PH00 120
IF(I<=0) iquit:(PH0001)#               Die for lack of nmemonic         PH00 121
ELSE IF(I==1&BUFIN(J+1)>=0.0&BUFIN(J+1)<1.0) ERROR=BUFIN(J+1)#          PH00 122
ELSE IF(I==2&BUFIN(J+1)>=0.01&BUFIN(J+1)<100.0) SCAL=BUFIN(J+1)#        PH00 123
ELSE IF(I==3&BUFIN(J+1)>=0.0&BUFIN(J+1)<10.0) FIMIN=BUFIN(J+1)#         PH00 124
ELSE IF(I==4&BUFIN(J+1)>0.0) LIST=NINT(BUFIN(J+1))#                     PH00 125
ELSE IF(I==5) ISTURT=MOD(NINT(BUFIN(J+1)),10)#                          PH00 126
ELSE IF(I==6&BUFIN(J+1)>=1.0&BUFIN(J+1)<=12.0) DSET=NINT(BUFIN(J+1))#   PH00 127
ELSE IF(I==7) FRIEDL=yes:#             Do friedel pairs if possible     PH00 128
IF(BUFIN(J+1)>=0.0) J=J+2#             Two items from input             PH00 129
ELSE J=J+1#                            Only one                         PH00 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PH00 131
#                                                                       PH00 132
#    ENTER CONTROL LINES                                                PH00 133
#    -------------------                                                PH00 134
#                                                                       PH00 135
readline:(PH01,NPH01)#                 Enter end line                   PH00 136
#                                                                       PH00 137
#     WRITE SUMMARY OF PROGRAM SETTINGS                                 PH00 138
#     ---------------------------------                                 PH00 139
#                                                                       PH00 140
ncodefld:(ERROR,1,PH0I,340632.,1)#                                      PH00 141
writeline:(1,PH0I,NPH0I,3,3)#                                           PH00 142
ncodefld:(SCAL,1,PH0J,340632.,1)#                                       PH00 143
writeline:(1,PH0J,NPH0J,3,3)#                                           PH00 144
ncodefld:(FIMIN,1,PH0K,340632.,1)#                                      PH00 145
writeline:(1,PH0K,NPH0K,3,3)#                                           PH00 146
BUFOT(1)=FLOAT(ISTURT)#                                                 PH00 147
ncodefld:(BUFOT,1,PH0L,340213.,1)#                                      PH00 148
writeline:(1,PH0L,NPH0L,3,3)#                                           PH00 149
BUFOT(1)=FLOAT(DSET)#                                                   PH00 150
ncodefld:(BUFOT,1,PH0M,340213.,1)#                                      PH00 151
writeline:(1,PH0M,NPH0M,3,3)#                                           PH00 152
IF(FRIEDL==yes:)#                                                       PH00 153
writeline:(1,PH0P,NPH0P,3,3)#                                           PH00 154
#                                                                       PH00 155
copyfile:(1,2,1,decr:(lrrefl:))#       Copy to refl records             PH00 156
#                                                                       PH00 157
#    SEARCH DIRECTORY OF LRREFL:                                        PH00 158
#    ---------------------------                                        PH00 159
#                                                                       PH00 160
DSET=DSET*1000#                        Get dset in right place          PH00 161
IWNT(1)=1;    IWNT(2)=DSET+800#        Request hkl & f calc             PH00 162
IWNT(3)=DSET+801; IWNT(4)=DSET+802#    A & b without anom. dispersion   PH00 163
IWNT(5)=DSET+803; IWNT(6)=DSET+804#    A & b anom. part only            PH00 164
IWNT(7)=DSET+304; IWNT(8)=DSET+314#    F rel +++ & f rel ---            PH00 165
IWNT(9)=DSET+305; IWNT(10)=DSET+315#   Sigma of above                   PH00 166
IWNT(11)=DSET+302; IWNT(12)=DSET+312#  F**2 rel +++ & f**2 rel ---      PH00 167
IWNT(13)=DSET+303; IWNT(14)=DSET+313#  Sigma of above                   PH00 168
IWNT(15)=DSET+300; IWNT(16)=DSET+310#  I rel +++ & i rel ---            PH00 169
IWNT(17)=DSET+301; IWNT(18)=DSET+311#  Sigma of above                   PH00 170
IWNT(19)=DSET+308; IWNT(20)=DSET+318#  R codes of above                 PH00 171
IWNT(21)=DSET+201; IWNT(22)=DSET+204#  Absorption & 1/lp                PH00 172
KEY(1)=2 ; DOIT=1 ; IF(FRIEDL==yes:)#                                   PH00 173
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PH00 174
DOIT=2 ; KEY(1)=6#                     Set for friedel pairs            PH00 175
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PH00 176
KEY(2)=22 ; KEY(3)=0 ; KEY(4)=0#       Set search keys                  PH00 177
indexpkt:(1,lrrefl:,NPAK,IP,2,KEY,IWNT,IREL)# Search lrrefl directory   PH00 178
IF(KEY(4)<=0)#                                                          PH00 179
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PH00 180
LINRM=1 ; JPAK=KEY(4)#                                                  PH00 181
DO I=1,NPAK#                           Display packet id numbers        PH00 182
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PH00 183
ncodefld:(QX(IP+I),1,CHROT,100513.,1)#                                  PH00 184
writeline:(0,PH0B,NPH0B,1,3)#                                           PH00 185
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PH00 186
iquit:(PH0015)#                        Hkl, frel, & fc not found...     PH00 187
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PH00 188
DO I=1,NPAK; IDNM(I)=QX(IP+I)#         Store all lrrefl idnums          PH00 189
IR=IREL(1);    IFC=IREL(2)#            Store hkl, f calc                PH00 190
IANDIS=IREL(3);  IBNDIS=IREL(4)#       A & b with no dispersion         PH00 191
IADISP=IREL(5);  IBDISP=IREL(6)#       A & b dispersion factors         PH00 192
IFRP=IREL( 7);   IFRM=IREL( 8)#        Store f rel +++ & ---            PH00 193
ISFP=IREL( 9);   ISFM=IREL(10)#        Store sigma of above             PH00 194
IF2P=IREL(11);   IF2M=IREL(12)#        Store f**2 rel +++ & ---         PH00 195
IS2P=IREL(13);   IS2M=IREL(14)#        Store sigma of above             PH00 196
IIP=IREL(15);    IIM=IREL(16)#         Store i rel +++ & ---            PH00 197
ISIP=IREL(17);   ISIM=IREL(18)#        Store sigma of above             PH00 198
IRCP=IREL(19);   IRCM=IREL(20)#        Store 1/lp, absorption           PH00 199
ILP=IREL(22);    IAB=IREL(21)#         Store 1/lp, absorption           PH00 200
#                                                                       PH00 201
writeline:(3,0,0,1,3); LINRM=NPAK+2#   Force first header               PH00 202
writeline:(1,PH0A,NPH0A,3,3)#          Header                           PH00 203
LINRM=1#                                                                PH00 204
DO I=1,22#                             Display packet id numbers        PH00 205
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PH00 206
ncodefld:(FLOAT(I),1,CHROT,40313.,1)#                                   PH00 207
IF(I<=NPAK) ncodefld:(IDNM,I,CHROT,150513.,1)#                          PH00 208
ncodefld:(FLOAT(IWNT(I)),1,CHROT,220513.,1)#                            PH00 209
ncodefld:(FLOAT(IREL(I)),1,CHROT,280513.,1)#                            PH00 210
writeline:(0,PH0B,NPH0B,1,3)#                                           PH00 211
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PH00 212
LINRM=4#                                                                PH00 213
#                                                                       PH00 214
#    ENTER LRREFL: BDF RECORDS                                          PH00 215
#    -------------------------                                          PH00 216
#                                                                       PH00 217
REPEAT#                                Loop over lrrefl records         PH00 218
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PH00 219
readwpkt:(1,lrrefl:,NPAK,IP,0)#        Point to ip packet               PH00 220
IF(IP<=0) BREAK#                       Exit reflection loop             PH00 221
gethkl:(IP+IR,H)#                      Extract h,k,l                    PH00 222
NREF=NREF+1#                           Count it                         PH00 223
#                                                                       PH00 224
#    COPY LRREFL PACKET                                                 PH00 225
#    ------------------                                                 PH00 226
#                                                                       PH00 227
writepkt:(2,lrrefl:,JPAK,JP)#          Point to op packet               PH00 228
movereal:(QX,IP+1,QX,JP+1,NPAK,0)#     Transfer pkt ip to op            PH00 229
#                                                                       PH00 230
#    PICK OUT THE QUANTITIES NECESSARY FOR GENERATING DATA              PH00 231
#    ------------------------------------------------------             PH00 232
#                                                                       PH00 233
IF(IAB>0) ABSORB=QX(IP+IAB)#           Pick up absorption, if any       PH00 234
IF(ILP>0) RCPLP=QX(IP+ILP)#            Pick up 1/lp, if any             PH00 235
IF(IRCP>0) RCODE=NINT(QX(IP+IRCP))#    Pick up rcode, if any            PH00 236
IF(RCODE==5) NEXT#                     Don't mess with sys abs          PH00 237
#                                                                       PH00 238
#    NOW GENERATE A RANDOM NUMBER IN A POPULATION WITH A MEAN           PH00 239
#    OF ZERO AND A STANDARD DEVIATION OF ONE WITH A GAUSSIAN            PH00 240
#    DISTRIBUTION.                                                      PH00 241
#    THE RANDOM NUMBERS GENERATED ARE BETWEEN 0 AND 1.  TWO             PH00 242
#    DIFFERENT NUMBERS ARE GENERATED.  FROM ONE A GAUSSIAN              PH00 243
#    FUNCTION IS FURTHER GENERATED AND USED TO TEST THE                 PH00 244
#    VALUE OF THE FIRST NUMBER GENERATED.  WHEN COMPLIANCE IS           PH00 245
#    FOUND THE FIRST RANDOM NUMBER IS ACCEPTED AND USED. THIS           PH00 246
#    LEADS TO A POPULATION WITH A MEAN OF ZERO AND A SIGMA OF           PH00 247
#    ONE.  LIMIT + OR - 3.2                                             PH00 248
#    --------------------------------------------------------           PH00 249
#                                                                       PH00 250
I=ISTURT#                              Take starting place              PH00 251
FOR(J=1;J<=DOIT;J=J+1)#                One or two depending on friede   PH00 252
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PH00 253
IF(FRIEDL==no:)#                       If no friedel pairs then         PH00 254
FC=QX(IP+IFC)#                         Pick up calculated structure f   PH00 255
ELSE#                                  Must fix both +++ & ---          PH00 256
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PH00 257
IF(J==1)#                              F+++ is up                       PH00 258
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PH00 259
ifvo:(QX(IP+IANDIS)) FC=voidflg:#      Skip unknowns                    PH00 260
ELSE#                                  Calculate modulus +++ from par   PH00 261
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PH00 262
ATOT=QX(IP+IANDIS)+QX(IP+IADISP)#      A +++                            PH00 263
BTOT=QX(IP+IBNDIS)+QX(IP+IBDISP)#      B +++                            PH00 264
FC=SQRT(ATOT**2+BTOT**2)#              Get magnitude of f calc          PH00 265
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PH00 266
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PH00 267
ELSE#                                  F--- is up                       PH00 268
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PH00 269
ifvo:(QX(IP+IANDIS)) FC=voidflg:#      Skip unknowns                    PH00 270
ELSE#                                  Calculate modulus --- from par   PH00 271
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PH00 272
ATOT=QX(IP+IANDIS)-QX(IP+IADISP)#      A ---                            PH00 273
BTOT=-QX(IP+IBNDIS)+QX(IP+IBDISP)#     B ---                            PH00 274
FC=SQRT(ATOT**2+BTOT**2)#                                               PH00 275
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PH00 276
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PH00 277
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PH00 278
REPEAT#                                Loop to get gaussian             PH00 279
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PH00 280
NTRY=NTRY+2#                           Count number generated           PH00 281
#                                                                       PH00 282
#     BY SOME MEANS GENERATE A SET OF RANDOM NUMBERS WITH               PH00 283
#     A MEAN OF ZERO, A SPREAD OF 6.4, AND A GAUSSIAN SHAPE             PH00 284
#     -----------------------------------------------------             PH00 285
#                                                                       PH00 286
SEED(I)=MOD(SEED(I)*25173+13849,65536)# Generate random number          PH00 287
RANNUM=FLOAT(MOD(SEED(I),10000))*0.0001# Number 0. - 0.9999             PH00 288
RANNUM=(RANNUM-0.5)*6.4#               Number between -3.2 and +3.2     PH00 289
FOFX=0.39894*EXP(MINHAF*RANNUM**2)#    Generate the gaussian value      PH00 290
SEED(I)=MOD(SEED(I)*25173+13849,65536)# Generate random number          PH00 291
IF(FLOAT(MOD(SEED(I),10000))*0.0001<=FOFX) BREAK# Test distribution     PH00 292
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PH00 293
NRAND=NRAND+1#                         Count number used                PH00 294
SUMDUM=SUMDUM+RANNUM#                  Sum of ran nums                  PH00 295
SUMDSQ=SUMDSQ+RANNUM**2#               Sum of squares                   PH00 296
DUMAX=AMAX1(DUMAX,RANNUM)#             Save maximum ran num             PH00 297
DUMIN=AMIN1(DUMIN,RANNUM)#             Save minimum ran num             PH00 298
IF(ABS(RANNUM)<1.0) EIN=EIN+1.0#       Number less than 1.0             PH00 299
ELSE IF(ABS(RANNUM)<2.0) ZWI=ZWI+1.0#  Number between 1 and 2           PH00 300
ELSE DRI=DRI+1.0#                      Number over 2                    PH00 301
#                                                                       PH00 302
#     MAKE A PHONEY INTENSITY FROM THE FC IN THE FILE                   PH00 303
#     -----------------------------------------------                   PH00 304
#                                                                       PH00 305
ifvo:(FC)#                             Look out for undetermined fcs    PH00 306
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PH00 307
FREL=.01 ; FSQ=0.0001 ; RCODE=2#       Pass off as nothing              PH00 308
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PH00 309
ELSE#                                  For those that calculated        PH00 310
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PH00 311
FREL=ABS(FC*(1.0+ERROR*RANNUM))/SCAL#  Phoney f(rel)                    PH00 312
FSQ=FREL**2/(RCPLP*ABSORB)#            Make intensity                   PH00 313
IF(FC**2/(RCPLP*ABSORB)<FIMIN)#        Test for less-thans              PH00 314
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PH00 315
FREL=SQRT(FIMIN*RCPLP*ABSORB)/SCAL#    Make threshold                   PH00 316
RCODE=2#                                                                PH00 317
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PH00 318
ELSE RCODE=1#                          Declare observed                 PH00 319
SUMFR=SUMFR+FREL*SCAL#                 Denominator of r value           PH00 320
SUMFD=SUMFD+ABS(FREL*SCAL-ABS(FC))#    Numerator of r value             PH00 321
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PH00 322
#                                                                       PH00 323
#     REPLACE THE FIDDLED QUANTITIES IN THE BDF                         PH00 324
#      ----------------------------------------                         PH00 325
#                                                                       PH00 326
IF(J==1)#                              For +++ or no friedel refls      PH00 327
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PH00 328
IF(IIP>0)QX(JP+IIP)=FSQ#               Store intensity, if any          PH00 329
IF(IRCP>0)QX(JP+IRCP)=FLOAT(RCODE)#    Store rcode, if any              PH00 330
IF(ISFP>0)QX(JP+ISFP)=ABS(ERROR*FREL)# Store sigma(f), if any           PH00 331
IF(ISIP>0)QX(JP+ISIP)=ABS(2.0*ERROR*FSQ)# Store sigma(i), if any        PH00 332
IF(IFRP>0)QX(JP+IFRP)=ABS(FREL)#       Store f rel, if any              PH00 333
IF(IS2P>0)QX(JP+IS2P)=ABS(2.0*ERROR*FREL**2)# Store sigma f**2, if an   PH00 334
IF(IF2P>0)QX(JP+IF2P)=FREL**2#         Store f**2 rel, if any           PH00 335
ncodefld:(FREL,1,CHROT,FMT(4),1)#                                       PH00 336
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PH00 337
ELSE#                                  For --- reflections              PH00 338
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PH00 339
IF(IIM>0)QX(JP+IIM)=FSQ#               Store intensity, if any          PH00 340
IF(IRCM>0)QX(JP+IRCM)=FLOAT(RCODE)#    Store rcode, if any              PH00 341
IF(ISFM>0)QX(JP+ISFM)=ABS(ERROR*FREL)# Store sigma(f), if any           PH00 342
IF(ISIM>0)QX(JP+ISIM)=ABS(2.0*ERROR*FSQ)# Store sigma(i), if any        PH00 343
IF(IFRM>0)QX(JP+IFRM)=ABS(FREL)#       Store f rel, if any              PH00 344
IF(IS2M>0)QX(JP+IS2M)=ABS(2.0*ERROR*FREL**2)# Store sigma f**2, if an   PH00 345
IF(IF2M>0)QX(JP+IF2M)=FREL**2#         Store f**2 rel, if any           PH00 346
ncodefld:(FREL,1,CHROT,FMT(5),1)#                                       PH00 347
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PH00 348
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PH00 349
#                                                                       PH00 350
#     LIST THE FIRST FEW REFLECTIONS IF SO DIRECTED                     PH00 351
#     ---------------------------------------------                     PH00 352
#                                                                       PH00 353
IF(LIST>0)#                                                             PH00 354
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PH00 355
ncodefld:(H,1,CHROT,FMT,3)#                                             PH00 356
writeline:(0,PH0C,NPH0C,1,3)#                                           PH00 357
LIST=LIST-1#                                                            PH00 358
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PH00 359
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PH00 360
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Finish off copy               PH00 361
#                                                                       PH00 362
#     SUMMARIZE RESULTS PRINT STATS                                     PH00 363
#     -----------------------------                                     PH00 364
#                                                                       PH00 365
SUMNUM=FLOAT(NRAND)#                                                    PH00 366
LINRM=8#                                                                PH00 367
ncodefld:(SUMNUM,1,PH0F,250513.,1)#                                     PH00 368
writeline:(1,PH0F,NPH0F,3,3)#                                           PH00 369
RR=SUMFD/AMAX1(0.01,SUMFR)#            Calc r value                     PH00 370
SMEAN=SUMDUM/AMAX1(0.01,SUMNUM)#       Mean ran num                     PH00 371
SIGMA=SQRT((SUMDSQ-(2.0*SMEAN*SUMDUM)+(SMEAN**2))/$#                    PH00 372
AMAX1(0.01,SUMNUM))#                   Std. dev. ran nums               PH00 373
ncodefld:(STATOU,1,CHROT,FMT2,4)#                                       PH00 374
writeline:(1,PH0G,NPH0G,2,3)#                                           PH00 375
COUNT(2)=EIN/SUMNUM#                                                    PH00 376
COUNT(4)=ZWI/SUMNUM#                                                    PH00 377
COUNT(6)=DRI/SUMNUM#                                                    PH00 378
movechar:(LPAR,1,CHROT,23,NLPAR,1)#                                     PH00 379
movechar:(LPAR,1,CHROT,41,NLPAR,1)#                                     PH00 380
movechar:(LPAR,1,CHROT,59,NLPAR,1)#                                     PH00 381
movechar:(RPAR,1,CHROT,29,NRPAR,1)#                                     PH00 382
movechar:(RPAR,1,CHROT,47,NRPAR,1)#                                     PH00 383
movechar:(RPAR,1,CHROT,65,NRPAR,1)#                                     PH00 384
ncodefld:(COUNT,1,CHROT,FMT3,6)#                                        PH00 385
writeline:(1,PH0H,NPH0H,2,3)#                                           PH00 386
ncodefld:(RR,1,PH0E,571052.,1)#                                         PH00 387
writeline:(1,PH0E,NPH0E,3,3)#                                           PH00 388
BUFOT(1)=FLOAT(NREF)#                                                   PH00 389
ncodefld:(BUFOT,1,PH0D,80613.,1)#                                       PH00 390
writeline:(1,PH0D,NPH0D,3,3)#                                           PH00 391
BUFOT(1)=FLOAT(NTRY)#                                                   PH00 392
ncodefld:(BUFOT,1,PH0N,80713.,1)#                                       PH00 393
writeline:(1,PH0N,NPH0N,3,3)#                                           PH00 394
#                                                                       PH00 395
RETURN#                                                                 PH00 396
END#                                                                    PH00 397
pmacro:([no:])#                        Purge xtal system macros         PH00 398
