systemheader:(PI    )#                                                  PI     1
####################################################################### PI     2
#                                                                     # PI     3
#                            *** PEAKIN ***                           # PI     4
#                                                                     # PI     5
#     THE PROGRAM PEAKIN LOADS PEAK COORDINATES FOR THE PURPOSE       # PI     6
#     OF FEEDING THEM INTO THE MODEL PROGRAM.                         # PI     7
#     IT IS A SIMPLIFIED CLONE OF PEKPIK AND SERVES TO AVOID NEEDING  # PI     8
#     A FOURIER MAP AS INPUT.                                         # PI     9
#                                                                     # PI    10
####################################################################### PI    11
#                                                                       PI    12
include:(XMACRO)#                                                       PI    13
#                                                                       PI    14
macro:(name:,incr:(arith:(23,/,mxchwd:)))#                              PI    15
#                                                                       PI    16
macro:(permlist:,[ifelse:($1,,KP,$1)])# Define list pointer             PI    17
macro:(peakx:,[QX(permlist:($1)+1)])#  Define x coordinate              PI    18
macro:(peaky:,[QX(permlist:($1)+2)])#  Define y coordinate              PI    19
macro:(peakz:,[QX(permlist:($1)+3)])#  Define z coordinate              PI    20
macro:(peakh:,[QX(permlist:($1)+4)])#  Define peak height               PI    21
macro:(index:,[QX(permlist:($1)+5)])#  Define reliability index         PI    22
#                                                                       PI    23
extrude:(PICOMN)#                                                       PI    24
INTEGER CTYPE#     ## Fourier map type                                  PI    25
INTEGER ICNT#      ## Centre flag (c=1, nc=2)                           PI    26
INTEGER IN(3)#     ## Increments along the fourier axes                 PI    27
INTEGER LTYP#      ## Lattice type indicator                            PI    28
INTEGER MARK1,STEP1,STOP1## Marker,step,and end of symops               PI    29
INTEGER MARK2,STEP2,STOP2## Marker,step,and end of atom names           PI    30
INTEGER MARK3,STEP3,STOP3## Marker,step,and end of atom coordinates     PI    31
INTEGER MARK8,STEP8,STOP8## Marker,step,end of permanent peak array     PI    32
INTEGER NPEAKS#    ## No. of largest peaks to list in sorted order      PI    33
INTEGER NPTS#      ## No. of points in the permanent array              PI    34
INTEGER NSYM#      ## No. of symmetry operations                        PI    35
#                                                                       PI    36
REAL G1,G2,G3,G5,G6,G9## Terms for distance calculation                 PI    37
REAL GR1,GR2,GR3#  ## Real gr values                                    PI    38
REAL COORD(3)#     ## X, y, z coordinates from peak line                PI    39
REAL DENS#         ## Input density from peak line                      PI    40
REAL RES#          ## Resolution sphere squared                         PI    41
#                                                                       PI    42
COMMON/COMIPI/   IN  ,IPCH  ,#                                          PI    43
ICNT, STOP1, STOP2, STOP3,#                                             PI    44
STOP8, LTYP  ,MARK1 ,MARK2 ,#                                           PI    45
MARK3 ,MARK8 ,#                                                         PI    46
NPEAKS, NPTS  ,NP,  NG,#                                                PI    47
STEP1, STEP2, STEP3,STEP8,NSYM  ,CTYPE#                                 PI    48
#                                                                       PI    49
COMMON/COMFPI/ COORD, DENS  ,RES,#                                      PI    50
G1,G2,G3,G5,G6,G9,GR1,GR2,GR3#                                          PI    51
endext:#                                                                PI    52
#                                                                       PI    53
systemheader:(PI00)#                   Control events                   PI00   1
#********************************************************************#  PI00   2
#                                                                    #  PI00   3
#                                PI00                                #  PI00   4
#                                                                    #  PI00   5
#********************************************************************#  PI00   6
SUBROUTINE PI00#                       J.m.stewart oct 1986             PI00   7
include:(AACOMN)#                                                       PI00   8
include:(PICOMN)#                                                       PI00   9
#                                                                       PI00  10
FILEXT(IOUNIT(5))='PEK'#               Ext for op peak file             PI00  11
#                                                                       PI00  12
CALL PI01#                             Enter bdf                        PI00  13
CALL PI02#                             Enter peak list                  PI00  14
CALL PI05#                             Sort peaks & output list         PI00  15
#                                                                       PI00  16
RETURN#                                                                 PI00  17
END#                                                                    PI00  18
systemheader:(PI01)#                   Load bdf and set up job          PI01   1
#********************************************************************#  PI01   2
#                                                                    #  PI01   3
#                                PI01                                #  PI01   4
#                                                                    #  PI01   5
#********************************************************************** PI01   6
SUBROUTINE PI01#                       J.m.stewart oct 1986             PI01   7
include:(AACOMN)#                                                       PI01   8
include:(PICOMN)#                                                       PI01   9
#                                                                       PI01  10
INTEGER I,IK,K,J,IP,PSIZ#                                               PI01  11
INTEGER IWNT(8),IREL(8),KEY(4)#        Id nos. for x,y,z and name       PI01  12
REAL CD(9)#                                                             PI01  13
#                                                                       PI01  14
chardata:(PI101,PUN NOF SFI NOP HOL NOH )#                              PI01  15
chardata:(PI102, PLIMIT PEAK )#                                         PI01  16
chardata:(PI21, PEAKIN CONTROL PARAMETERS)#                             PI01  17
chardata:(PI25, MAXIMUM UNIQUE PEAKS OUTPUT       )#                    PI01  18
chardata:(PI28, NUMBER OF SYMOPS APPLIED          )#                    PI01  19
chardata:(PI2B,-)#                                                      PI01  20
realdata:(HLIM,[1.,10.,10.,2.,1.,.25,1.])#                              PI01  21
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              PI01  22
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              PI01  23
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              PI01  24
realdata:(TR21,[.3333333,.5])#                                          PI01  25
realdata:(TR22,[.6666667,0.])#                                          PI01  26
realdata:(TR23,[.6666667,.5])#                                          PI01  27
datastuff:#                                                             PI01  28
#                                                                       PI01  29
#    ENTER CONTROL LINES                                                PI01  30
#    -------------------                                                PI01  31
#                                                                       PI01  32
NPEAKS=10000#                          Number unique peaks expected     PI01  33
RES=.10#                               Desired resolution in angstr     PI01  34
#                                                                       PI01  35
REPEAT#                                Loop over input lines            PI01  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PI01  37
readline:(PI102,NPI102)#               Enter control line               PI01  38
IF(LINID==1)#                          Test if plimit line              PI01  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PI01  40
IF(BUFIN(1)>0.) NPEAKS=NINT(BUFIN(3))# Enter sorted peak max            PI01  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PI01  42
ELSE BREAK#                            End line detected                PI01  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PI01  44
#                                                                       PI01  45
#   ASSIGN MEMORY FOR FILE BUFFERS                                      PI01  46
#   ------------------------------                                      PI01  47
#                                                                       PI01  48
IOMARK(1)=QXSTR#                       Set buffer file a                PI01  49
IOMARK(5)=IOMARK(1)+bdfbuf:#           Set buffer file e                PI01  50
incrqx:(MARK1,IOMARK(5)+bdfbuf:,PI0107)# P                              PI01  51
copyfile:(1,5,1,1)#                    Copy header to new scratch f     PI01  52
#                                                                       PI01  53
# READ BDF AND CONSTRUCT TENSOR FOR THE CELL                            PI01  54
# ------------------------------------------                            PI01  55
#                                                                       PI01  56
DO III=1,7#                            Loop over cell packets           PI01  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PI01  58
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Read lr4-cell constants          PI01  59
IF(IP<=0) iquit:(PI0102)#              No cell dimensions               PI01  60
IF(III==1) movereal:(QX,IP+1,CD,1,6,0)#                                 PI01  61
writepkt:(5,4,PSIZ,IK)#                                                 PI01  62
movereal:(QX,IP+1,QX,IK+1,PSIZ,1)#                                      PI01  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PI01  64
G1=CD(1)*CD(1)#                        For distance calculation         PI01  65
G2=CD(1)*CD(2)*CD(6)*2.#               For distance calculation         PI01  66
G3=CD(1)*CD(3)*CD(5)*2.#               For distance calculation         PI01  67
G5=CD(2)*CD(2)#                        For distance calculation         PI01  68
G6=CD(2)*CD(3)*CD(4)*2.#               For distance calculation         PI01  69
G9=CD(3)*CD(3)#                        For distance calculation         PI01  70
#                                                                       PI01  71
# GET LATTICE AND SYMMETRY INFORMATION                                  PI01  72
# -------------------------------------                                 PI01  73
#                                                                       PI01  74
readwpkt:(1,lrsymm:,PSIZ,IP,0)#                                         PI01  75
IF(IP<=0) iquit:(PI0103)#              P                                PI01  76
writepkt:(5,5,PSIZ,IK)#                                                 PI01  77
movereal:(QX,IP+1,QX,IK+1,PSIZ,1)#                                      PI01  78
LTYP=NINT(QX(IP+1))#                   Get lattice type                 PI01  79
ICNT=NINT(QX(IP+2))+1#                 Get centro flag (nc=2)           PI01  80
NSYM=NINT(QX(IP+3))#                   Total number of equiv. pos.      PI01  81
#                                                                       PI01  82
IF(LTYP>7) LTYP=LTYP-7#                Reduce lat to modulo 7           PI01  83
incrqx:(STOP1,MARK1+12*NSYM,PI0104)#   Quit if no room for symops       PI01  84
IF(ICNT==2)#                           If noncentrosymmetric            PI01  85
incrqx:(STOP1,STOP1+12*NSYM,PI0104)#   Reserve space for p1b            PI01  86
STEP1=12#                              Set symop packet size            PI01  87
FOR(I=MARK1;;I=I+STEP1)#               Enter symops from bdf            PI01  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PI01  89
readwpkt:(1,lrsymm:,PSIZ,IP,0)#                                         PI01  90
IF(IP<=0) BREAK#                                                        PI01  91
writepkt:(5,5,PSIZ,IK)#                                                 PI01  92
movereal:(QX,IP+1,QX,IK+1,PSIZ,1)#                                      PI01  93
movereal:(QX,IP+1,QX,I+1,PSIZ,1)#      Store symop matrices             PI01  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PI01  95
NNN=I#                                 Remember number of symops        PI01  96
#                                                                       PI01  97
#   GET ATOMIC CONTENTS INFO                                            PI01  98
#   ------------------------                                            PI01  99
#                                                                       PI01 100
N=0;  IWNT(1)=1;  IWNT(2)=3#           Request at/cell & at no.         PI01 101
KEY(1)=0; KEY(2)=2; KEY(3)=0; KEY(4)=0# Set search limits               PI01 102
indexpkt:(1,lrscat:,PSIZ,IP,0,KEY,IWNT,IREL)# Search for idnums         PI01 103
IF(IREL(1)*IREL(2)>0)#                 Test if items found              PI01 104
REPEAT#                                Loop over lrscat packets         PI01 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PI01 106
readwpkt:(1,lrscat:,PSIZ,IP,0)#        Point to input packet            PI01 107
IF(IP<=0) BREAK#                       Exit after last packet           PI01 108
I=IP+IREL(1);   J=IP+IREL(2)#          Point to at/cell & at no.        PI01 109
IF(QX(J)>2.5) N=N+NINT(QX(I))#         Sum nonh atoms in cell           PI01 110
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PI01 111
#                                                                       PI01 112
#   EXTRACT ATOM COORDS IF PRESENT                                      PI01 113
#   ------------------------------                                      PI01 114
#                                                                       PI01 115
MARK2=STOP1+1; STEP2=1; STOP2=MARK2+100# Setup peak max profile         PI01 116
MARK3=STOP2;  STOP3=MARK3#             Start of atomic coordinates      PI01 117
STEP3=arith:(4,+,name:)#               Save x,y,z and name              PI01 118
IWNT(1)=1;    IWNT(2)=2#               Request xcoord & ycoord          PI01 119
IWNT(3)=3;    IWNT(4)=14#              Request zcoord & aname           PI01 120
KEY(1)=0; KEY(2)=4; KEY(3)=4; KEY(4)=0# Set search parameters           PI01 121
indexpkt:(1,lratom:,PSIZ,IP,0,KEY,IWNT,IREL)# Find x,y,z and name       PI01 122
IF(IP>0)#                              If there are any atoms...        PI01 123
FOR(I=MARK3;;I=STOP3)#                 Loop over atoms list             PI01 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PI01 125
readwpkt:(1,lratom:,PSIZ,IP,0)#        Read atom packet                 PI01 126
IF(IP<=0) BREAK#                       Exit after last packet           PI01 127
incrqx:(STOP3,I+STEP3,PI0105)#         Save room for next atom          PI01 128
J=IP+IREL(1);  QX(I+1)=QX(J)#          Get x coordinate                 PI01 129
J=IP+IREL(2);  QX(I+2)=QX(J)#          Get y coordinate                 PI01 130
J=IP+IREL(3);  QX(I+3)=QX(J)#          Get z coordinate                 PI01 131
QX(I+4)=0.;  J=IP+IREL(4)#             Reset match flag                 PI01 132
movereal:(QX,J,QX,I+5,name:,1)#        Pick up atom name                PI01 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PI01 134
#                                                                       PI01 135
#   ADJUST SYMOPS TO MAP TYPE                                           PI01 136
#   -------------------------                                           PI01 137
#                                                                       PI01 138
IF(CTYPE<3)#                           If patt or vector map            PI01 139
FOR(I=MARK1;I<NNN;I=I+STEP1)#          Loop over input symops           PI01 140
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PI01 141
QX(I+10)=0.; QX(I+11)=0.; QX(I+12)=0.# Remove all translations          PI01 142
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PI01 143
K=NNN#                                 Store temp end marker            PI01 144
IF(LTYP>1)#                            Test if sg centered              PI01 145
FOR(J=MARK1;J<NNN;J=J+STEP1)#          Loop over symm matrices          PI01 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PI01 147
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            PI01 148
QX(K+10)=QX(J+10)+TR11(LTYP-1)#        Transfer t1                      PI01 149
QX(K+11)=QX(J+11)+TR12(LTYP-1)#        Transfer t2                      PI01 150
QX(K+12)=QX(J+12)+TR13(LTYP-1)#        Transfer t3                      PI01 151
K=K+STEP1#                             Incr storage pointer             PI01 152
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               PI01 153
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            PI01 154
QX(K+10)=QX(J+10)+TR21(LTYP-2)#        Transfer t1                      PI01 155
QX(K+11)=QX(J+11)+TR22(LTYP-2)#        Transfer t2                      PI01 156
QX(K+12)=QX(J+12)+TR23(LTYP-2)#        Transfer t3                      PI01 157
K=K+STEP1#                             Incr storage pointer             PI01 158
IF(LTYP!=4) NEXT#                      Skip if not f-centre             PI01 159
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            PI01 160
QX(K+10)=QX(J+10)+0.5#                 Transfer t1                      PI01 161
QX(K+11)=QX(J+11)+0.5#                 Transfer t2                      PI01 162
QX(K+12)=QX(J+12)+0.0#                 Transfer t3                      PI01 163
K=K+STEP1#                             Incr storage pointer             PI01 164
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PI01 165
NNN=K#                                 Store current end of symops      PI01 166
IF((CTYPE<3)\(ICNT==1))#               Test if centro symops needed     PI01 167
FOR(J=MARK1;J<NNN;J=J+1)#              Loop over symm matrices          PI01 168
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PI01 169
K=K+1#                                 Incr storage pointer             PI01 170
QX(K)=-QX(J+1)#                        Store inverse element            PI01 171
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PI01 172
ELSE STOP1=MARK1+12*NSYM#              Reset symop limit                PI01 173
#                                                                       PI01 174
#    ASSIGN STORAGE FOR PEAK LISTS                                      PI01 175
#    -----------------------------                                      PI01 176
#                                                                       PI01 177
IF(NPEAKS>9999)  NPEAKS=100#           Default is 100 if no info        PI01 178
STEP8=5; MARK8=STOP3; STOP8=MARK8#     Initialize perm peak list        PI01 179
NPTS=0#                                Zero count of pts. in perm.      PI01 180
#                                                                       PI01 181
#    REPORT SEARCH PARAMETERS                                           PI01 182
#    ------------------------                                           PI01 183
#                                                                       PI01 184
movechar:(PI2B,1,CHROT,2,NPI21-1,2)#   Underline peakin header          PI01 185
writeline:(1,PI21,NPI21,2,3)#          Print peakin header              PI01 186
ncodefld:(FLOAT(NPEAKS),1,PI25,330413.,1)# Format peaks sought          PI01 187
writeline:(0,PI25,NPI25,3,3)#          Print peaks sought               PI01 188
ncodefld:(FLOAT(NSYM),1,PI28,330213.,1)# Format max symops              PI01 189
writeline:(0,PI28,NPI28,3,3)#          Print max symops                 PI01 190
readwpkt:(1,endrecord:,I,I,0)#         Close off fourr file a           PI01 191
#                                                                       PI01 192
RETURN#                                                                 PI01 193
END#                                                                    PI01 194
systemheader:(PI02)#                   Load peak coordinates            PI02   1
#********************************************************************** PI02   2
#                                                                       PI02   3
#                                PI02                                   PI02   4
#                                                                       PI02   5
#********************************************************************** PI02   6
SUBROUTINE PI02#                       J.m.stewart oct 1986             PI02   7
include:(AACOMN)#                                                       PI02   8
include:(PICOMN)#                                                       PI02   9
#                                                                       PI02  10
chardata:(P301, END PEAK )#                                             PI02  11
chardata:(P302,       PEAK LINES READ FROM INPUT )#                     PI02  12
intdata:(MP,0)#                                                         PI02  13
datastuff:#                                                             PI02  14
#                                                                       PI02  15
MP=0#                                  Set counts of peaks read         PI02  16
#                                                                       PI02  17
REPEAT#                                Until all peaks loaded           PI02  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PI02  19
DO J=1,3;   COORD(J)=BUFIN(J)#         Accept non void values           PI02  20
IF(BUFIN(4)>0.0) DENS=BUFIN(4)#        Accept density if given          PI02  21
ELSE             DENS=6.0#             Default 6 e/a**3                 PI02  22
MP=MP+1#                               Count it as read                 PI02  23
IF(MP>NPEAKS) NEXT#                    Skip unwanted peaks              PI02  24
CALL PI04(COORD,DENS)#                 Check if peak unique             PI02  25
readline:(P301,NP301)#                 Read another line                PI02  26
IF(LINID==1) BREAK#                    Stop at end line                 PI02  27
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PI02  28
#                                                                       PI02  29
BUFOT(1)=FLOAT(MP) ; ncodefld:(BUFOT,1,P302,60513.,1)#                  PI02  30
writeline:(1,P302,NP302,3,3)#                                           PI02  31
#                                                                       PI02  32
RETURN#                                                                 PI02  33
END#                                                                    PI02  34
systemheader:(PI04)#                   Check and file peaks             PI04   1
#******************************************************************#    PI04   2
#                                                                  #    PI04   3
#                                PI04                              #    PI04   4
#                                                                  #    PI04   5
#******************************************************************#    PI04   6
SUBROUTINE PI04(XN,PH)#                J.m. stewart oct 1986            PI04   7
include:(AACOMN)#                                                       PI04   8
include:(PICOMN)#                                                       PI04   9
#                                                                       PI04  10
INTEGER K#                                                              PI04  11
REAL A,B,C,X,Y,Z,U,V,W,DX,DY,DZ#                                        PI04  12
REAL XN(3),PH#                                                          PI04  13
intdata:(INDX,[3,2,3,2,1,2,3,2,3])#                                     PI04  14
datastuff:#                                                             PI04  15
#                                                                       PI04  16
#   LOOP OVER EXISTING PEAKS IN LIST                                    PI04  17
#   --------------------------------                                    PI04  18
#                                                                       PI04  19
A=XN(1) ; B=XN(2) ; C=XN(3)#           Pick up x, y, and z              PI04  20
FOR(KP=MARK8;KP<STOP8;KP=KP+STEP8)#    Loop over peaks list             PI04  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PI04  22
X=peakx:;  Y=peaky:;  Z=peakz:#        Store peak coords local          PI04  23
#                                                                       PI04  24
FOR(K=MARK1;K<STOP1;K=K+STEP1)#        Loop over all symops             PI04  25
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PI04  26
U=X*QX(K+1)+Y*QX(K+4)+Z*QX(K+7)+QX(K+10)# Generate equivalent x         PI04  27
V=X*QX(K+2)+Y*QX(K+5)+Z*QX(K+8)+QX(K+11)# Generate equivalent y         PI04  28
W=X*QX(K+3)+Y*QX(K+6)+Z*QX(K+9)+QX(K+12)# Generate equivalent z         PI04  29
DX=MOD(99.5+A-U,1.)-0.5#               Ensure x' close to x             PI04  30
DY=MOD(99.5+B-V,1.)-0.5#               Ensure x' close to x             PI04  31
DZ=MOD(99.5+C-W,1.)-0.5#               Ensure x' close to x             PI04  32
DD=G1*DX**2+G6*DY*DZ$#                 Calculate distance squared       PI04  33
+  G5*DY**2+G3*DX*DZ$#                 Calculate distance squared       PI04  34
+  G9*DZ**2+G2*DX*DY#                  Calculate distance squared       PI04  35
IF(DD<RES) GOTO 100#                   Exit if overlapped               PI04  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PI04  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PI04  38
STOP8=STOP8+STEP8#                     Expand table                     PI04  39
NPTS=NPTS+1#                           Count additional peak            PI04  40
peakx:=A#                              Store x coord                    PI04  41
peaky:=B#                              Store y coord                    PI04  42
peakz:=C#                              Store z coord                    PI04  43
peakh:=PH+.0001#                       Store peak height                PI04  44
100 CONTINUE#                                                           PI04  45
#                                                                       PI04  46
RETURN#                                                                 PI04  47
END#                                                                    PI04  48
systemheader:(PI05)#                                                    PI05   1
#*********************************************************************# PI05   2
#                                                                     # PI05   3
#                                PI05                                 # PI05   4
#                                                                     # PI05   5
#*********************************************************************# PI05   6
SUBROUTINE PI05#                                                        PI05   7
include:(AACOMN)#                                                       PI05   8
include:(PICOMN)#                                                       PI05   9
#                                                                       PI05  10
INTEGER I,J,K,M,N#                                                      PI05  11
INTEGER KP#                                                             PI05  12
REAL A,B,C,X,Y,Z,U,V,W,DX,DY,DZ#                                        PI05  13
chardata:(P1101, THE FOLLOWING ATOMS ARE NOT MATCHED WITH PEAKS)#       PI05  14
chardata:(P1102,  ATOM            X           Y           Z)#           PI05  15
chardata:(P1103, PEAKS UNMATCHED WITH ATOM LIST         )#              PI05  16
chardata:(P1106, ATOM/PEAK     X       Y       Z        MAX)#           PI05  17
realdata:(FMT,[220852.,340852.,460852.])#                               PI05  18
realdata:(FOM,[170742.,250742.,330742.,430732.])#                       PI05  19
datastuff:#                                                             PI05  20
#                                                                       PI05  21
#    SORT PERMANENT PEAK LIST                                           PI05  22
#    ------------------------                                           PI05  23
#                                                                       PI05  24
NPTS=MIN0(NPTS,NPEAKS)#                Set as smaller number            PI05  25
MARK7=STOP8;  NPEAKS=NPTS#             Get sort space                   PI05  26
incrqx:(STOP7,MARK7+2*NPTS,PI0501)#    P                                PI05  27
FOR(I=MARK7;I<STOP7;I=I+2)#            Loop over sort pointers          PI05  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PI05  29
A=0.;    K=MARK8#                      Initialize sort values           PI05  30
FOR(KP=MARK8;KP<STOP8;KP=KP+STEP8)#    Loop over perm peak list         PI05  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PI05  32
IF(A>peakh:) NEXT#                     Skip if smaller                  PI05  33
A=peakh:;   K=KP#                      Store largest peak               PI05  34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PI05  35
QX(I+1)=FLOAT(K)#                      Store addr sorted peak           PI05  36
QX(I+2)=0.#                            Reset for atom list              PI05  37
peakh:(K)=-peakh:(K)#                  Cull peak from sort              PI05  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PI05  39
#                                                                       PI05  40
#   CONNECT ATOMS LIST TO PEAK LIST                                     PI05  41
#   -------------------------------                                     PI05  42
#                                                                       PI05  43
FOR(N=MARK7;N<STOP7;N=N+2)#            Loop over sort pointers          PI05  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PI05  45
M=NINT(QX(N+1)); peakh:(M)=ABS(peakh:(M))# Extract peak list address    PI05  46
A=peakx:(M); B=peaky:(M); C=peakz:(M)# Get peak coords to local         PI05  47
FOR(KP=MARK3;KP<STOP3;KP=KP+STEP3)#    Loop over atoms list             PI05  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PI05  49
X=peakx:; Y=peaky:; Z=peakz:#          Store atom coords local          PI05  50
FOR(K=MARK1;K<STOP1;K=K+STEP1)#        Loop over all symops             PI05  51
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PI05  52
U=X*QX(K+1)+Y*QX(K+4)+Z*QX(K+7)+QX(K+10)# Generate equivalent x         PI05  53
V=X*QX(K+2)+Y*QX(K+5)+Z*QX(K+8)+QX(K+11)# Generate equivalent y         PI05  54
W=X*QX(K+3)+Y*QX(K+6)+Z*QX(K+9)+QX(K+12)# Generate equivalent z         PI05  55
DX=MOD(99.5+A-U,1.)-0.5#               Ensure x' close to x             PI05  56
DY=MOD(99.5+B-V,1.)-0.5#               Ensure x' close to x             PI05  57
DZ=MOD(99.5+C-W,1.)-0.5#               Ensure x' close to x             PI05  58
DD=G1*DX**2+G6*DY*DZ$#                 Calculate distance squared       PI05  59
+  G5*DY**2+G3*DX*DZ$#                 Calculate distance squared       PI05  60
+  G9*DZ**2+G2*DX*DY#                  Calculate distance squared       PI05  61
IF(DD>RES) NEXT#                       Skip if outside range            PI05  62
QX(N+2)=FLOAT(KP)#                     Store atom addr in sort list     PI05  63
peakh:=FLOAT(M)#                       Flag as matched                  PI05  64
NPTS=NPTS-1#                           Decr peak count                  PI05  65
GOTO 100#                              Exit search list                 PI05  66
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PI05  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PI05  68
100 CONTINUE#                                                           PI05  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PI05  70
#                                                                       PI05  71
#   LIST UNCONNECTED ATOMS                                              PI05  72
#   ----------------------                                              PI05  73
#                                                                       PI05  74
K=0#                                   Reset header flag                PI05  75
FOR(I=MARK3;I<STOP3;I=I+STEP3)#        Loop over atom list              PI05  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PI05  77
IF(QX(I+4)>.5) NEXT#                   Skip if atom connected           PI05  78
IF(K==0)#                              Is header needed                 PI05  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PI05  80
LINRM=8#                               Force header space               PI05  81
writeline:(1,P1101,NP1101,2,3)#        Print header                     PI05  82
LINRM=6;   K=1#                        Force header & flagoff           PI05  83
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PI05  84
movertoc:(QX(I+5),1,CHROT,2,8,0)#      Move name to output line         PI05  85
ncodefld:(QX,I+1,CHROT,FMT,3)#         X,y,z                            PI05  86
writeline:(0,P1102,NP1102,1,3)#        Print atom coords                PI05  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PI05  88
#                                                                       PI05  89
#   PRINT SORTED PEAKS                                                  PI05  90
#   ------------------                                                  PI05  91
#                                                                       PI05  92
writeline:(1,0,0,1,3)#                 Insert spacer                    PI05  93
LINRM=10;   N=0#                       Force first header               PI05  94
KP=NINT(QX(MARK7+1));  A=peakh:#       Get max peak height              PI05  95
FOR(I=MARK7;I<STOP7;I=I+2)#            Loop over sort list              PI05  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PI05  97
KP=NINT(QX(I+1))#                      Get peak list pointer            PI05  98
IP=NINT(QX(I+2))#                      Get atom list pointer            PI05  99
ncodefld:(QX,KP+1,CHROT,FOM,4)#        Get x,y,z and peak height        PI05 100
IF(IP>0)#                              This is a matched site           PI05 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PI05 102
peakh:=1000000.+peakh:#                Flag peak as matched             PI05 103
movertoc:(QX(IP+5),1,CHROT,2,8,0)#     Inset atom name                  PI05 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PI05 105
ELSE#                                  This is a peak                   PI05 106
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PI05 107
N=N+1#                                 Peak counter                     PI05 108
ncodefld:(FLOAT(N),1,CHROT,70313.,1)#  Format peak number               PI05 109
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PI05 110
writeline:(0,P1106,NP1106,1,3)#        Print peak coords                PI05 111
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PI05 112
#                                                                       PI05 113
#   OUTPUT FILE E FOR =MODEL=                                           PI05 114
#   -------------------------                                           PI05 115
#                                                                       PI05 116
writepkt:(5,21,STEP3,IP)#              Point to first packet            PI05 117
QX(IP+1)=FLOAT((STOP3-MARK3)/STEP3)#   Store atom count                 PI05 118
QX(IP+2)=FLOAT(NPTS)#                  Store peak count                 PI05 119
QX(IP+3)=RES#                          And resolution                   PI05 120
QX(IP+4)=FLOAT(NPEAKS)#                And expected peak count          PI05 121
FOR(I=MARK3;I<STOP3;I=I+STEP3)#        Loop over atoms list             PI05 122
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PI05 123
writepkt:(5,21,STEP3,IP)#              Point to next packet             PI05 124
QX(I+4)=MAX(A,5.)#                     Set atom peak height             PI05 125
movereal:(QX,I+1,QX,IP+1,STEP3,0)#     Put packet in scratch file b     PI05 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PI05 127
FOR(I=MARK7;I<STOP7;I=I+2)#            Loop over all peaks saved        PI05 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PI05 129
J=NINT(QX(I+1))#                       Get peaks in sort order          PI05 130
writepkt:(5,22,4,IP)#                  Point to next packet             PI05 131
movereal:(QX,J+1,QX,IP+1,4,1)#         Put packet in scratch file b     PI05 132
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PI05 133
writepkt:(5,endrecord:,1,IP)#          Finish off file properly         PI05 134
#                                                                       PI05 135
RETURN#                                                                 PI05 136
END#                                                                    PI05 137
pmacro:([no:])#                        Purge xtal system macros         PI05 138
