systemheader:(PN    )#                                                  PN     1
####################################################################    PN     2
##      Copyright (C) 2000, The Xtal System, The University of        # PN     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # PN     4
## Distributed under the GNU General Public Licence as published by   # PN     5
## the Free Software Foundation, in the hope that it will be useful   # PN     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # PN     7
## for more details.                                                  # PN     8
#                                                                  #    PN     9
#                           *** PARTN ***                          #    PN    10
#                                                                  #    PN    11
#      THE PROGRAM PN DETERMINES THE CONTRIBUTION OF A             #    PN    12
#      PARTICULAR ATOM TO A DENSITY MAP(FILEC) AND OUTPUTS         #    PN    13
#      THE FRAGMENT MAP(FILED). THE FRAGMENT IS GENERATED          #    PN    14
#      BY A HIRSHFELD PARTITIONING. THE WEIGHTS CAN BE BASED       #    PN    15
#      ON EITHER THE PROMOLECULAR DENSITY OR POTENTIAL.            #    PN    16
#                                                                  #    PN    17
####################################################################    PN    18
#                                                                       PN    19
include:(XMACRO)#                                                       PN    20
#                                                                       PN    21
macro:(rmax:,6.0)#                     Maximum radius, adjustable       PN    22
macro:(atname:,incr:(arith:(23,/,mxchwd:)))# Words for 24 char's        PN    23
#                                                                       PN    24
extrude:(PNCOMN)#                                                       PN    25
INTEGER NUM#                           Number of atom types             PN    26
INTEGER PROF#                          Profile type 1=den,2=pot         PN    27
REAL PROFIL(15,44)#                    Atomic profiles                  PN    28
#                                                                       PN    29
COMMON /COMIPN/ NUM,PROF#                                               PN    30
COMMON /COMFPN/ PROFIL#                                                 PN    31
endext:#                                                                PN    32
#                                                                       PN    33
systemheader:(PN00)#                   Calculate fragment               PN00   1
#####################################################################   PN00   2
#                                                                   #   PN00   3
#                          PN00                                     #   PN00   4
#                                                                   #   PN00   5
#####################################################################   PN00   6
SUBROUTINE PN00#                       Nick spadaccini may87            PN00   7
#                                      Victor streltsov 92              PN00   8
include:(AACOMN)#                      Include aa common                PN00   9
include:(PNCOMN)#                      Include pn common                PN00  10
#                                                                       PN00  11
FILEXT(ioda1:)='XX0'#                  Direct access binary file        PN00  12
FILEXT(IOUNIT(3))='MAP'#               Ext of input fourr map           PN00  13
FILEXT(IOUNIT(4))='PAR'#               Ext of output partn map          PN00  14
#                                                                       PN00  15
CALL PN10#                             Call main routine                PN00  16
#                                                                       PN00  17
RETURN#                                                                 PN00  18
END#                                                                    PN00  19
systemheader:(PN10)#                   First line controls.             PN10   1
#####################################################################   PN10   2
#                                                                   #   PN10   3
#                               PN10                                #   PN10   4
#                                                                   #   PN10   5
#####################################################################   PN10   6
SUBROUTINE PN10#                                                        PN10   7
include:(AACOMN)#                      Include aa common.               PN10   8
include:(PNCOMN)#                      Include pn common.               PN10   9
#                                                                       PN10  10
INTEGER I,II,I1,I2,IM#                 Working indices                  PN10  11
INTEGER J,JJ,J1,J2,J3#                 Working indices                  PN10  12
INTEGER JP,K,KK,M,M1,N#                Working indices                  PN10  13
INTEGER BEGIN,IEND#                    Limits of input fields.          PN10  14
INTEGER FIELD,MATCH#                   Pointers                         PN10  15
INTEGER PACKET#                        Current bdf packet               PN10  16
INTEGER LATYP,ICENT,TOTSYM,NSYM#       Symops parameters                PN10  17
INTEGER IP,PSIZE#                      Bdf packet pointers              PN10  18
INTEGER MARKS,MARK2,MARK3,MARK4#       Qx array markers                 PN10  19
INTEGER STEPS,STEP2,STEP3#             Step size in qx array            PN10  20
INTEGER IWNT(10),IREL(11),KEY(4)#      Directory info                   PN10  21
INTEGER IPTS(3)#                       Num. of points lay/dow/acr       PN10  22
INTEGER ISUM1,ISUM2,ISUM3,JSUM1,JSUM2,JSUM3# Axial permutations         PN10  23
INTEGER POINT#                         General pointer                  PN10  24
INTEGER IDISC#                         Rejection flag                   PN10  25
INTEGER IR1,IR2,IR3,IR4,IR5#           Buffer pointers                  PN10  26
INTEGER IPT1,IPT2,IPT3#                Number of l/d/a points           PN10  27
INTEGER MAP#                           Calculation type 1=frag,2=enti   PN10  28
INTEGER ATM#                           Atom card 1=present, 0=not       PN10  29
INTEGER ATMB#                          Beginning of partitioned atoms   PN10  30
INTEGER ATME#                          End of partitioned atoms         PN10  31
INTEGER ATMP#                          Fragment atom                    PN10  32
#                                                                       PN10  33
REAL VOL#                                                               PN10  34
REAL BORDER,BORDR2#                    Border distance and square       PN10  35
REAL CONTCT,CONTC2#                    Contact distance and square      PN10  36
REAL RAD(44)#                          Profile points                   PN10  37
REAL CELL(9)#                          Cell parameters                  PN10  38
REAL R(9)#                             Metric tensor                    PN10  39
REAL ORGX(3)#                          Xyz origin in frac               PN10  40
REAL INCX(3)#                          Xyz increment in grids           PN10  41
REAL GRIDX(3)#                         Xyz grids                        PN10  42
REAL PTX(3)#                           Xyz points                       PN10  43
REAL ENDX(3)#                          Xyz end in frac                  PN10  44
REAL XNEW(3),YNEW(3),DIF(3)#           Temporary coords                 PN10  45
REAL DIST#                             Distance                         PN10  46
REAL P#                                Interpolation parameter          PN10  47
REAL ORGS(3)#                          L/d/a origin in grids            PN10  48
REAL INCS(3)#                          L/d/a increment in grids         PN10  49
REAL GRIDS(3)#                         L/d/a/ grids                     PN10  50
REAL ORG1,ORG2,ORG3#                   L/d/a origin in frac             PN10  51
REAL INC1,INC2,INC3#                   L/d/a increment in frac          PN10  52
REAL IJ(3)#                            Cell translations                PN10  53
REAL RHO#                              Difference density value         PN10  54
REAL TOTRHO#                           Promolecular density             PN10  55
REAL PRHO#                             Atomic density                   PN10  56
REAL ATMX(3)#                          Fragment atoms coords            PN10  57
REAL PART#                             Fragment contrib. to promol. d   PN10  58
#                                                                       PN10  59
string:(ATMNM,24)#                     Fragment atom name               PN10  60
string:(NAME,24)#                      Holds current atom name          PN10  61
chardata:(PN101,DEN POT BOR CON FRA ENT )#                              PN10  62
chardata:(PN102, SITE   END   )#                                        PN10  63
chardata:(PN103, PARTN CONTROL PARAMETERS)#                             PN10  64
chardata:(PN104, BORDER DISTANCE          ANGSTROMS)#                   PN10  65
chardata:(PN105, CONTACT DISTANCE         ANGSTROMS)#                   PN10  66
chardata:(PN106, PARTITIONING WEIGHTS ON  DENSITY      )#               PN10  67
chardata:(PN107, LAYOUT OF INPUT MAP)#                                  PN10  68
chardata:(PN108, X DIRECTION FROM        TO          )#                 PN10  69
chardata:(PN109, FRAGMENT CONTRIBUTION OF ATOM                     $#   PN10  70
                      )#                                                PN10  71
chardata:(PN10A,  ENTIRE )#                                             PN10  72
chardata:(PN10D, X Y Z POTENTIAL -)#                                    PN10  73
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              PN10  74
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              PN10  75
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              PN10  76
realdata:(TR21,[.3333333,.5])#                                          PN10  77
realdata:(TR22,[.6666667,0.])#                                          PN10  78
realdata:(TR23,[.6666667,.5])#                                          PN10  79
realdata:(ANG,[0.529177])#             Conversion ang to bohr           PN10  80
datastuff:#                                                             PN10  81
#                                                                       PN10  82
#     SET DEFAULTS                                                      PN10  83
#     ------------                                                      PN10  84
#                                                                       PN10  85
PROF=1#                                Assume density profile           PN10  86
MAP=1#                                 Assume fragment calculation      PN10  87
ATM=no:#                               Assume no atom card              PN10  88
ATMB=0 ; ATME=0 ; ATMP=0#              Set pointers to zero             PN10  89
CONTCT=rmax:#                          Contact distance in ang.         PN10  90
BORDER=rmax:#                          Border extension in ang.         PN10  91
STEPS=12#                              Trans matrix size                PN10  92
#                                                                       PN10  93
RAD(1)=0.0#                            Initial point in profile         PN10  94
DO J=2,44 ; RAD(J)=(RAD(J-1)+0.01)*1.15# Determine profile points       PN10  95
DO J=1,44 ; RAD(J)=(RAD(J)*ANG)**2#    Convert to r**2 in ang           PN10  96
#                                                                       PN10  97
FOR(FIELD=1;BUFIN(FIELD)<voidflg:;FIELD=FIELD+1)# Loop input fields     PN10  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PN10  99
stringlim:(FIELD,BEGIN,IEND)#          Find field limits                PN10 100
compchar:(CHRIN,BEGIN,PN101,1,3,4,NPN101,MATCH)#                        PN10 101
IF(MATCH==0) iquit:(PN1001)#           Cannot identify                  PN10 102
IF      (MATCH==1) PROF=1#             Use density profiles             PN10 103
ELSE IF (MATCH==2) PROF=2#             Use potential profiles           PN10 104
ELSE IF (MATCH==3)#                    Border distance                  PN10 105
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PN10 106
IF (BUFIN(FIELD+1)>voidflg:) BORDER=BUFIN(FIELD+1)# Read distance       PN10 107
FIELD=FIELD+1#                         Increment field pointer          PN10 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PN10 109
ELSE IF (MATCH==4)#                    Contact distance                 PN10 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PN10 111
IF (BUFIN(FIELD+1)>voidflg:) CONTCT=BUFIN(FIELD+1)# Read distance       PN10 112
FIELD=FIELD+1#                         Increment field pointer          PN10 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PN10 114
ELSE IF(MATCH==5) MAP=1#               Fragment calculation             PN10 115
ELSE IF(MATCH==6) MAP=2#               Entire contribution              PN10 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PN10 117
#                                                                       PN10 118
BORDR2=BORDER**2#                      Border distance squared          PN10 119
CONTC2=CONTCT**2#                      Contact distance squared         PN10 120
REPEAT#                                Read remaining lines             PN10 121
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PN10 122
readline:(PN102,NPN102)#               Readline atom/end                PN10 123
IF(LINID==1)#                          ********* site *********         PN10 124
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PN10 125
ATM=yes:#                              Atom line present                PN10 126
IF(BUFIN(1)>=voidflg:) iquit:(PN1005)# No atom name                     PN10 127
IF((MAP==1)&(BUFIN(2)==voidflg:)) iquit:(PN1010)# No frag. coords       PN10 128
stringlim:(1,M,N)#                     Limits of atom name              PN10 129
ATMNM=CHRIP(M^N)#                      Get atom name                    PN10 130
DO K=1,3 ; ATMX(K)=BUFIN(K+1)#         Store fragment atom coords       PN10 131
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PN10 132
IF(LINID==2) BREAK#                    End line                         PN10 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PN10 134
IF(ATM==no:) iquit:(PN1015)#           No atom line present             PN10 135
#                                                                       PN10 136
IOMARK(1)=QXSTR#                       Start of i/o buffer 1            PN10 137
incrqx:(IOMARK(3),IOMARK(1)+bdfbuf:,PN1020)# Request buffer 1           PN10 138
incrqx:(IOMARK(4),IOMARK(3)+bdfbuf:,PN1025)# Request buffer 3           PN10 139
incrqx:(MARKS,IOMARK(4)+bdfbuf:,PN1030)# Request buffer 4               PN10 140
#                                                                       PN10 141
#    READ CELL INFORMATION                                              PN10 142
#    ---------------------                                              PN10 143
#                                                                       PN10 144
PACKET=0#                              Initial packet                   PN10 145
REPEAT#                                Read in cell information         PN10 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PN10 147
readwpkt:(1,lrcell:,PSIZE,IP,0)#       Read packet                      PN10 148
IF(IP<=0) BREAK#                       End of logical record            PN10 149
PACKET=PACKET+1#                       Increment packet pointer         PN10 150
IF(PACKET==1) movereal:(QX,IP+1,CELL,1,9,0)# Store cell dimensions      PN10 151
IF(PACKET==6) movereal:(QX,IP+1,VOL,1,1,0)# Store cell volume           PN10 152
IF(PACKET==7) movereal:(QX,IP+1,R,1,9,0)# Store metric tensor           PN10 153
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PN10 154
#                                                                       PN10 155
#     EXTRACT SYMMETRY INFORMATION FROM BDF                             PN10 156
#     -------------------------------------                             PN10 157
#                                                                       PN10 158
readwpkt:(1,lrsymm:,PSIZE,IP,0)#       First packet                     PN10 159
IF(IP<=0) iquit:(PN1035)#              Non-existant.....pn1015          PN10 160
LATYP=NINT(QX(IP+1))#                  Lattice type                     PN10 161
IF(LATYP>7) LATYP=LATYP-7#             Remove centricity                PN10 162
ICENT=NINT(QX(IP+2))#                  Centre flag (c=0,nc=1)           PN10 163
NSYM=NINT(QX(IP+4))#                   Number of matrices on bdf        PN10 164
TOTSYM=NINT(QX(IP+3))*STEPS#           Initial memory requirements      PN10 165
incrqx:(I,MARKS+TOTSYM,PN1040)#        Symops memory....pn1040          PN10 166
#                                                                       PN10 167
#     READ IN SYMOPS                                                    PN10 168
#     --------------                                                    PN10 169
#                                                                       PN10 170
FOR (J=MARKS;J>0;J=J+STEPS)#           Loop over symops in bdf          PN10 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PN10 172
readwpkt:(1,lrsymm:,PSIZE,IP,0)#       Read in buffer                   PN10 173
IF(IP<=0) BREAK#                       End of record                    PN10 174
movereal:(QX,IP+1,QX,J+1,PSIZE,1)#     Move contents                    PN10 175
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PN10 176
#                                                                       PN10 177
#     EXPAND SYMOP TABLE TO ALL OPERATIONS                              PN10 178
#     ------------------------------------                              PN10 179
#                                                                       PN10 180
K=MARKS+NSYM*STEPS ; I=K#              Point to end of symops           PN10 181
IF(ICENT==0)#                          If centrosymmetric               PN10 182
FOR (J=MARKS;J<I;J=J+1)#               Loop over current symops         PN10 183
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PN10 184
K=K+1#                                 Increment pointer                PN10 185
QX(K)=-QX(J+1)#                        Store inverse                    PN10 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PN10 187
I=K#                                   Current end pointer              PN10 188
IF(LATYP>1)#                           Apply centering translations     PN10 189
FOR (J=MARKS;J<I;J=J+STEPS)#           Loop over current symops         PN10 190
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PN10 191
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rotation elements       PN10 192
QX(K+10)=QX(J+10)+TR11(LATYP-1)#       Transfer t1                      PN10 193
QX(K+11)=QX(J+11)+TR12(LATYP-1)#       Transfer t2                      PN10 194
QX(K+12)=QX(J+12)+TR13(LATYP-1)#       Transfer t3                      PN10 195
K=K+STEPS#                             Increment pointer                PN10 196
IF((LATYP==2)\(LATYP>4)) NEXT#         Skip if not rhom or f-centre     PN10 197
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rotation elements       PN10 198
QX(K+10)=QX(J+10)+TR21(LATYP-2)#       Transfer t1                      PN10 199
QX(K+11)=QX(J+11)+TR22(LATYP-2)#       Transfer t2                      PN10 200
QX(K+12)=QX(J+12)+TR23(LATYP-2)#       Transfer t3                      PN10 201
K=K+STEPS#                             Increment pointer                PN10 202
IF(LATYP!=4) NEXT#                     Skip if not f-centre             PN10 203
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rotation elements       PN10 204
QX(K+10)=QX(J+10)+0.5#                 Transfer t1                      PN10 205
QX(K+11)=QX(J+11)+0.5#                 Transfer t2                      PN10 206
QX(K+12)=QX(J+12)+0.0#                 Transfer t3                      PN10 207
K=K+STEPS#                             Increment pointer                PN10 208
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PN10 209
MARK2=K#                               Symops end marker                PN10 210
#                                                                       PN10 211
CALL PN11#                             Get profile                      PN10 212
#                                                                       PN10 213
#     READ ATOM COORDS FROM BDF                                         PN10 214
#     -------------------------                                         PN10 215
#                                                                       PN10 216
STEP2=6+atname:#                       Atom xyz,pointer,charge,name     PN10 217
IWNT(1)=1 ; IWNT(2)=2#                 X and y coords                   PN10 218
IWNT(3)=3 ; IWNT(4)=14#                Z and atom name                  PN10 219
IWNT(5)=22#                            Scat/profile pointer             PN10 220
KEY(1)=5 ; KEY(2)=0#                   All mandatory                    PN10 221
KEY(3)=0 ; KEY(4)=0#                                                    PN10 222
indexpkt:(1,lratom:,PSIZE,IP,0,KEY,IWNT,IREL)# Search directory         PN10 223
IF(IP<=0) iquit:(PN1045)#              Lratom: missing....pn1045        PN10 224
IF(KEY(4)<=0) iquit:(PN1050)#          Item missing....pn1050           PN10 225
IR1=IREL(1) ; IR2=IREL(2)#             Store pointers                   PN10 226
IR3=IREL(3) ; IR4=IREL(4)#                                              PN10 227
IR5=IREL(5)#                                                            PN10 228
J=MARK2#                               Pointer to atom list             PN10 229
REPEAT#                                                                 PN10 230
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PN10 231
readwpkt:(1,lratom:,PSIZE,IP,0)#       Read buffer                      PN10 232
IF(IP<=0) BREAK#                       End of atom record               PN10 233
incrqx:(MARK3,J+STEP2,PN1055)#         Request space....pn1055.         PN10 234
QX(J+1)=QX(IP+IR1)#                    Store x                          PN10 235
QX(J+2)=QX(IP+IR2)#                    Store y                          PN10 236
QX(J+3)=QX(IP+IR3)#                    Store z                          PN10 237
QX(J+4)=QX(IP+IR5)#                    Sf/profile pointer               PN10 238
movereal:(QX,IP+IR4,QX,J+7,atname:,1)# Store atom name as real          PN10 239
J=J+STEP2#                             Increment pointer                PN10 240
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PN10 241
MARK3=J#                               End of atom list                 PN10 242
#                                                                       PN10 243
#     READ LAYOUT OF DIFFERENCE DENSITY MAP FROM X3                     PN10 244
#     ---------------------------------------------                     PN10 245
#                                                                       PN10 246
copyfile:(3,4,1,decr:(21))#            Copy upto lr21                   PN10 247
readwpkt:(3,21,PSIZE,IP,0)#            Read lr21                        PN10 248
writepkt:(4,21,PSIZE,JP)#              Output packet                    PN10 249
movereal:(QX,IP+1,QX,JP+1,PSIZE,1)#    Move to output buffer            PN10 250
DO I=1,3#                                                               PN10 251
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PN10 252
ORGS(I)=QX(IP+1)#                      Origins                          PN10 253
INCS(I)=QX(IP+4)#                      Increments                       PN10 254
GRIDS(I)=QX(IP+7)#                     Grids                            PN10 255
IPTS(I)=NINT(QX(IP+10))#               Points along axes                PN10 256
IP=IP+1#                                                                PN10 257
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PN10 258
ISUM1=NINT(QX(IP+10))#                 Summation order indices          PN10 259
ISUM2=NINT(QX(IP+11))#                                                  PN10 260
ISUM3=NINT(QX(IP+12))#                                                  PN10 261
JSUM1=NINT(QX(IP+13))#                 Summation order permutation      PN10 262
JSUM2=NINT(QX(IP+14))#                                                  PN10 263
JSUM3=NINT(QX(IP+15))#                                                  PN10 264
#                                                                       PN10 265
#     DETERMINE THE MAP LIMITS IN XYZ ORDER                             PN10 266
#     AND IN FRACTIONS OF THE UNIT CELL                                 PN10 267
#     -------------------------------------                             PN10 268
#                                                                       PN10 269
GRIDX(1)=GRIDS(ISUM1)#                 Number of grids in x             PN10 270
GRIDX(2)=GRIDS(ISUM2)#                 Number of grids in y             PN10 271
GRIDX(3)=GRIDS(ISUM3)#                 Number of grids in z             PN10 272
PTX(1)=FLOAT(IPTS(ISUM1))#             Number of points in x            PN10 273
PTX(2)=FLOAT(IPTS(ISUM2))#             Number of points in y            PN10 274
PTX(3)=FLOAT(IPTS(ISUM3))#             Number of points in z            PN10 275
INCX(1)=INCS(ISUM1)#                   Increment in x                   PN10 276
INCX(2)=INCS(ISUM2)#                   Increment in y                   PN10 277
INCX(3)=INCS(ISUM3)#                   Increment in z                   PN10 278
ORGX(1)=ORGS(ISUM1)/GRIDX(1)#          X origin in frac coords          PN10 279
ORGX(2)=ORGS(ISUM2)/GRIDX(2)#          Y origin in frac coords          PN10 280
ORGX(3)=ORGS(ISUM3)/GRIDX(3)#          Z origin in frac coords          PN10 281
ENDX(1)=ORGX(1)+(PTX(1)-1.)*INCX(1)/GRIDX(1)# X end in frac coords      PN10 282
ENDX(2)=ORGX(2)+(PTX(2)-1.)*INCX(2)/GRIDX(2)# Y end in frac coords      PN10 283
ENDX(3)=ORGX(3)+(PTX(3)-1.)*INCX(3)/GRIDX(3)# Z end in frac coords      PN10 284
ORG1=ORGS(1)/GRIDS(1)#                 Layer origin in frac             PN10 285
ORG2=ORGS(2)/GRIDS(2)#                 Down origin in frac              PN10 286
ORG3=ORGS(3)/GRIDS(3)#                 Across origin in frac            PN10 287
INC1=INCS(1)/GRIDS(1)#                 Layer increment in frac          PN10 288
INC2=INCS(2)/GRIDS(2)#                 Down increment in frac           PN10 289
INC3=INCS(3)/GRIDS(3)#                 Across increment in frac         PN10 290
#                                                                       PN10 291
#     DETERMINE FULL ARRAY OF ATOMS CONTRIBUTING                        PN10 292
#     TO THE CHARGE CALCULATION                                         PN10 293
#     ------------------------------------------                        PN10 294
#                                                                       PN10 295
M1=MARK3#                              Current atom marker              PN10 296
JJ=MARK3#                              Marker for array                 PN10 297
STEP3=6#                               6 words required                 PN10 298
IM=1#                                  Initial atom pointer             PN10 299
FOR(J=MARK2;J<MARK3;J=J+STEP2)#        Loop over bdf atoms              PN10 300
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PN10 301
movertoc:(QX(J+7),1,NAME,1,24,0)#      Move in current atom name        PN10 302
IF(NAME==ATMNM) ATMB=M1#               Mark begining of list            PN10 303
FOR(K=MARKS;K<MARK2;K=K+STEPS)#        Loop over symops                 PN10 304
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PN10 305
DO I1=1,3#                             Loop over bdf atom xyz           PN10 306
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PN10 307
XNEW(I1)=0.#                           Zero coords                      PN10 308
DO I2=1,3#                             Coord symop                      PN10 309
XNEW(I1)=XNEW(I1)+QX(J+I2)*QX(K+I1+(I2-1)*3)# Rotation matrix           PN10 310
XNEW(I1)=XNEW(I1)+QX(K+9+I1)#          Translation                      PN10 311
WHILE(XNEW(I1)<ORGX(I1)) XNEW(I1)=XNEW(I1)+1.# Move towards origin      PN10 312
WHILE(XNEW(I1)>ORGX(I1)) XNEW(I1)=XNEW(I1)-1.# Move towards origin      PN10 313
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PN10 314
DO J1=1,4#                             Upto 4 cells                     PN10 315
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PN10 316
IJ(1)=FLOAT(J1-1)#                     Cell translations                PN10 317
DO J2=1,4#                             Upto 4 cells                     PN10 318
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PN10 319
IJ(2)=FLOAT(J2-1)#                     Cell translations                PN10 320
DO J3=1,4#                             Upto 4 cells                     PN10 321
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PN10 322
IJ(3)=FLOAT(J3-1)#                     Cell translations                PN10 323
DIST=0.#                               Zerorize                         PN10 324
IDISC=no:#                             Set discard to no                PN10 325
DO I=1,3#                              Loop over new xyz                PN10 326
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PN10 327
YNEW(I)=XNEW(I)+IJ(I)#                 Apply cell translations          PN10 328
IF(YNEW(I)<ORGX(I)) DIF(I)=YNEW(I)-ORGX(I)# Frac coord beyond edge      PN10 329
ELSE IF(YNEW(I)>ENDX(I)) DIF(I)=YNEW(I)-ENDX(I)# Ditto                  PN10 330
ELSE DIF(I)=0.#                        Within region                    PN10 331
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PN10 332
#                                                                       PN10 333
DO I1=1,3 ; DO I2=1,3#                 Distance from point to atom      PN10 334
DIST=DIST+DIF(I1)*R((I1-1)*3+I2)*DIF(I2)# Distance squared              PN10 335
IF(DIST>BORDR2) NEXT#                  Outside limits                   PN10 336
#                                                                       PN10 337
FOR(II=M1;II<JJ;II=II+STEP3)#          Ensure atom isn't repeated       PN10 338
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PN10 339
IF(ABS(YNEW(1)-QX(II+1))>.001) NEXT#   If xyz differences are all >.0   PN10 340
IF(ABS(YNEW(2)-QX(II+2))>.001) NEXT#   Then the atom is unique. else    PN10 341
IF(ABS(YNEW(3)-QX(II+3))>.001) NEXT#   It is already stored             PN10 342
ELSE#                                  Atom is a repeat                 PN10 343
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PN10 344
IDISC=yes:#                            Discard it                       PN10 345
BREAK#                                 Break from the search loop       PN10 346
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PN10 347
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PN10 348
IF(IDISC==yes:) NEXT#                  Donot store                      PN10 349
#                                                                       PN10 350
IF((MAP==1)&(ATMB>0))#                 Search for fragment atom         PN10 351
IF(ABS(YNEW(1)-ATMX(1))<.001)#         If same x                        PN10 352
IF(ABS(YNEW(2)-ATMX(2))<.001)#         And same y                       PN10 353
IF(ABS(YNEW(3)-ATMX(3))<.001) ATMP=JJ# And same z, store pointer        PN10 354
incrqx:(MARK4,JJ+STEP3,PN1055)#        Request space....pn1055          PN10 355
DO I=1,3#                              Loop over xyz                    PN10 356
QX(JJ+I)=YNEW(I)#                      Store xyz                        PN10 357
QX(JJ+4)=IM#                           Store atom name pointer          PN10 358
movereal:(QX,J+4,QX,JJ+5,2,1)#         Profile pointer and charge       PN10 359
QX(J+6)=QX(J+6)+1.#                    One more contributor             PN10 360
JJ=JJ+STEP3#                           Increment qx                     PN10 361
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PN10 362
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PN10 363
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PN10 364
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PN10 365
IF(NAME==ATMNM) ATME=JJ#               Mark end of list                 PN10 366
M1=JJ#                                 New atom marker                  PN10 367
IM=IM+1#                               Next bdf atom                    PN10 368
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PN10 369
MARK4=JJ#                              End of contributors array        PN10 370
IF((ATMB==0)\(ATME==0)) iquit:(PN1065)# Atom name not matched           PN10 371
IF((MAP==1)&(ATMP==0)) iquit:(PN1070)# Fragment atom not matched        PN10 372
#                                                                       PN10 373
#     READ IN DELRHO POINT BY POINT AND DETERMINE                       PN10 374
#     THE CONTRIBUTION OF EACH ATOM                                     PN10 375
#     -------------------------------------------                       PN10 376
#                                                                       PN10 377
IPT1=IPTS(1)#                          Points in layer                  PN10 378
IPT2=IPTS(2)#                          Points down                      PN10 379
IPT3=IPTS(3)#                          Points across                    PN10 380
DO I=1,IPT1#                           Loop over layers                 PN10 381
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PN10 382
XNEW(JSUM1)=ORG1+FLOAT(I-1)*INC1#      Coord of density point           PN10 383
DO J=1,IPT2#                           Down direction                   PN10 384
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PN10 385
XNEW(JSUM2)=ORG2+FLOAT(J-1)*INC2#      Coord of density point           PN10 386
readwpkt:(3,22,PSIZE,IP,0)#            Read packet of rho               PN10 387
IF(IP==0) BREAK#                       End of lr22                      PN10 388
writepkt:(4,22,PSIZE,JP)#              Output fragment map              PN10 389
DO K=1,IPT3#                           Across direction                 PN10 390
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PN10 391
XNEW(JSUM3)=ORG3+FLOAT(K-1)*INC3#      Coord of density point           PN10 392
TOTRHO=0.#                             Zero promolecular density        PN10 393
RHO=QX(IP+K)#                          Value of rho                     PN10 394
PART=0.#                               Zero partition contribution      PN10 395
FOR(JJ=MARK3;JJ<MARK4;JJ=JJ+STEP3)#    Loop over contributors           PN10 396
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PN10 397
DIST=0.0#                              Zero distance                    PN10 398
DO II=1,3#                                                              PN10 399
DIF(II)=XNEW(II)-QX(JJ+II)#            Atom-point distance              PN10 400
DO I1=1,3 ; DO I2=1,3#                                                  PN10 401
DIST=DIST+DIF(I1)*R((I1-1)*3+I2)*DIF(I2)# Dist**2 in angstroms          PN10 402
IF(DIST>CONTC2) NEXT#                  Too far                          PN10 403
ELSE#                                  Partition the point              PN10 404
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PN10 405
DO KK=1,44#                                                             PN10 406
IF((RAD(KK)<=DIST)&(RAD(KK+1)>DIST)) BREAK# Limits of interpolation     PN10 407
POINT=NINT(QX(JJ+5))#                  Profile pointer                  PN10 408
P=(DIST-RAD(KK))/(RAD(KK+1)-RAD(KK))#  Interpol. parameter              PN10 409
PRHO=(1.-P)*PROFIL(POINT,KK)+P*PROFIL(POINT,KK+1)# Atomic density       PN10 410
IF((JJ>=ATMB)&(JJ<ATME))#              Partition atoms? yes.            PN10 411
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PN10 412
IF(MAP==2) PART=PART+PRHO#             Total atom contribution          PN10 413
ELSE IF(JJ==ATMP) PART=PRHO#           Else fragment only               PN10 414
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PN10 415
TOTRHO=TOTRHO+PRHO#                    Total promol. density            PN10 416
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PN10 417
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PN10 418
ifne:(TOTRHO,.0) TOTRHO=RHO/TOTRHO#                                     PN10 419
QX(JP+K)=PART*TOTRHO#                  Total/fragment contribution      PN10 420
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PN10 421
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PN10 422
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PN10 423
copyfile:(3,4,incr:(22),endrecord:)#   Copy the endrecord:              PN10 424
#                                                                       PN10 425
#                                                                       PN10 426
#     TELL USER EVERYTHING                                              PN10 427
#     --------------------                                              PN10 428
#                                                                       PN10 429
movechar:(PN10D,NPN10D,CHROT,2,NPN103-1,1)# Underline header            PN10 430
writeline:(2,PN103,NPN103,2,3)#        Output header                    PN10 431
IF(PROF==2) movechar:(PN10D,8,PN106,26,9,0)# Potential used             PN10 432
writeline:(0,PN106,NPN106,3,3)#        Output profile type              PN10 433
IF(MAP==2) movechar:(PN10A,2,PN109,2,8,0)# Total contribution           PN10 434
IF(MAP==1)#                            Fragment atom                    PN10 435
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PN10 436
ncodefld:(ATMX,1,PN109,480742.,1)#                                      PN10 437
ncodefld:(ATMX,2,PN109,570742.,1)#                                      PN10 438
ncodefld:(ATMX,3,PN109,660742.,1)#                                      PN10 439
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PN10 440
movechar:(ATMNM,1,PN109,32,8,0)#                                        PN10 441
writeline:(0,PN109,NPN109,3,3)#        Output partition type            PN10 442
ncodefld:(BORDER,1,PN104,250422.,1)#   Encode border                    PN10 443
writeline:(0,PN104,NPN104,3,3)#                                         PN10 444
ncodefld:(CONTCT,1,PN105,250422.,1)#   Encode contact                   PN10 445
writeline:(0,PN105,NPN105,3,3,)#                                        PN10 446
movechar:(PN10D,NPN10D,CHROT,2,NPN107-1,1)# Underline                   PN10 447
writeline:(1,PN107,NPN107,2,3)#        Layout header                    PN10 448
DO I=1,3#                                                               PN10 449
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 PN10 450
ncodefld:(ORGX(I),1,PN108,240632.,1)#  Encode xyz origins               PN10 451
ncodefld:(ENDX(I),1,PN108,340632.,1)#  Encode xyz ends                  PN10 452
movechar:(PN10D,2*I,PN108,2,1,0)#      Encode directions xyz            PN10 453
writeline:(0,PN108,NPN108,3,3)#                                         PN10 454
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 PN10 455
RETURN#                                                                 PN10 456
END#                                                                    PN10 457
#                                                                       PN10 458
systemheader:(PN11)#                   Determine density profile        PN11   1
#####################################################################   PN11   2
#                                                                   #   PN11   3
#                              PN11                                 #   PN11   4
#                                                                   #   PN11   5
#####################################################################   PN11   6
SUBROUTINE  PN11#                                                       PN11   7
#                                                                       PN11   8
include:(AACOMN)#                                                       PN11   9
include:(PNCOMN)#                                                       PN11  10
#                                                                       PN11  11
INTEGER LNBLNK#                        Function returning integer       PN11  12
REAL SCAT#                                                              PN11  13
INTEGER LL#                                                             PN11  14
INTEGER IWNT(2),IREL(3),KEY(4)#        Lr information                   PN11  15
INTEGER IR1,IR2#                       Buffer pointers                  PN11  16
INTEGER IP,PSIZE#                      Packet information               PN11  17
INTEGER KK#                            Working index                    PN11  18
CHARACTER LINE(80)#                                                     PN11  19
#                                                                       PN11  20
#                                                                       PN11  21
IWNT(1)=3 ; IWNT(2)=1#                 Sf pointer & contents            PN11  22
KEY(1)=1 ; KEY(2)=0 ; KEY(3)=0 ; KEY(4)=0#                              PN11  23
indexpkt:(1,lrscat:,PSIZE,IP,0,KEY,IWNT,IREL)#                          PN11  24
IF(IP<=0) iquit:(PN1105)#              Lr missing....pn1105             PN11  25
IF(KEY(4)<=0) iquit:(PN1110)#          Item missing....pn1110           PN11  26
IR1=IREL(1) ; IR2=IREL(2)#             Store pointers                   PN11  27
NUM=1#                                 First atom type                  PN11  28
openfmt:(iofm1:,profile:)#             Open profile database            PN11  29
opendac:(ioda1:,1,80,' ')#             Open direct access profile       PN11  30
KK=1#                                                                   PN11  31
REPEAT#                                                                 PN11  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PN11  33
readfmt:(iofm1:,'(80A1)',100,LINE)#    Read database                    PN11  34
writedac:(ioda1:,['(80A1)',],KK,LINE)# Write direc-access record        PN11  35
KK=KK+1#                               Record number                    PN11  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PN11  37
100 closefmt:(iofm1:)#                                                  PN11  38
REPEAT#                                                                 PN11  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PN11  40
readwpkt:(1,lrscat:,PSIZE,IP,0)#                                        PN11  41
IF(IP<=0) BREAK#                       End of lr                        PN11  42
SCAT=QX(IP+IR1)#                       Atomic number                    PN11  43
IF(PROF==1)            KK=NINT(24.*(SCAT-1.)+ 2.)# Density profile      PN11  44
ELSE IF(NINT(SCAT)<39) KK=NINT(24.*(SCAT-1.)+14.)# Potential profile    PN11  45
ELSE iquit:(PN1115)#                   Non-existent profile values      PN11  46
readdac:(ioda1:,['(4F15.6)',],KK,(PROFIL(NUM,LL),LL=1,44))# Profil      PN11  47
NUM=NUM+1#                                                              PN11  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PN11  49
closedac:(ioda1:)#                     Close database                   PN11  50
RETURN#                                                                 PN11  51
END#                                                                    PN11  52
pmacro:([no:])#                                                         PN11  53
