systemheader:(PS    )#                                                  PS     1
####################################################################### PS     2
#                                                                     # PS     3
#                           *** PHACMP ***                            # PS     4
#                                                                     # PS     5
#  THE PHACMP PROGRAM COMPARES THE PHASES FROM TWO SOURCES IN ORDER   # PS     6
#  TO ALLOW ONE TO COMPARE THE RESULTS OF TWO DIFFERENT PHASE         # PS     7
#  DETERMINATIONS.  IT REQUIRES, AS INPUT, CALCULATED STRUCTURE       # PS     8
#  FACTORS OR DIRECTLY DETERMINED PHASES OR MIR PHASES.               # PS     9
#  THE PHASE SETS MAY BE ON EITHER THE SAME BDF OR ON TWO DIFFERENT   # PS    10
#  BDFS.  BUT THE REFLECTION SET MUST BE IDENTICAL IF TWO BDFS ARE    # PS    11
#  USED.                                                              # PS    12
#                                            J.m. stewart june 1989   # PS    13
#                                                                     # PS    14
####################################################################### PS    15
#                                                                       PS    16
include:(XMACRO)#                                                       PS    17
#                                                                       PS    18
macro:(maxset:,20)#                    Maximum no. data sets on bdf     PS    19
macro:(maxwant:,16)#                   Max. number of required          PS    20
macro:(mxshl:,25)#                     Max. no. of shells in d space    PS    21
macro:(chtotl:,144)#                   Max no of chars in d. set name   PS    22
#                                                                       PS    23
extrude:(PSCOMN)#                                                       PS    24
INTEGER BIGIH(3)#                      Maximum hkl limits               PS    25
INTEGER H1,H2,H3#                      Permuted values of h,k,l         PS    26
INTEGER H1NEXT#                        Next packed hkl primary bdf      PS    27
INTEGER H1NOW#                         Current packed hkl primary bdf   PS    28
INTEGER H2NEXT#                        Next packed hkl second bdf       PS    29
INTEGER H2NOW#                         Current packed hkl second bdf    PS    30
INTEGER IPT1,IPT2#                     Input packet pointer             PS    31
INTEGER IREL1(incr:(maxwant:))#        Irel1s for refl items file a     PS    32
INTEGER IREL2(incr:(maxwant:))#        Irel1s for refl items file b     PS    33
INTEGER IWANT1(maxwant:)#              Catalogue numbers, lrrefl:       PS    34
INTEGER IWANT2(maxwant:)#              Catalogue numbers for file b     PS    35
INTEGER LMOD#                          Print every lmod reflection      PS    36
INTEGER MARKB,STOPB,STEPB#             Bin array in qx                  PS    37
INTEGER NBIN#                          Number of bins for statistics    PS    38
INTEGER NSET(2)#                       Data set key for phase sets      PS    39
INTEGER REJECT#                                                         PS    40
INTEGER PHASO(2)#                      Phase source for the two phase   PS    41
#                                      Sets as 1/fc 2/best 3/most prob  PS    42
#                                      4/density modification           PS    43
#                                      5/direct methods                 PS    44
INTEGER PS(2)#                         Pointer to phase set or estima   PS    45
INTEGER PSIZE1,PSIZE2#                 Input packet size                PS    46
INTEGER SETBDF#                        Copy file .000 to .aa2 on star   PS    47
INTEGER SHLNUM#                        No. of equal volumes in d spac   PS    48
INTEGER SMALIH(3)#                     Minimum hkl limits               PS    49
INTEGER SORT1,SORT2,SORT3#             Sort order for reflections       PS    50
INTEGER TOTCH1,TOTCH2#                 Number of characters in all th   PS    51
COMMON/COMIPS/BIGIH ,$#                                                 PS    52
H1    ,H2    ,H3    ,H1NOW ,H2NOW ,H1NEXT,H2NEXT,$#                     PS    53
REJECT,IPT1  ,IPT2  ,IREL1 ,IREL2 ,IWANT1,IWANT2,$#                     PS    54
LMOD  ,MARKB ,NBIN  ,NSET  ,PHASO  ,PS    ,PSIZE1,PSIZE2,SETBDF,$#      PS    55
SHLNUM,SMALIH,STEPB ,SORT1 ,SORT2 ,SORT3 ,STOPB ,TOTCH1,TOTCH2#         PS    56
#                                                                       PS    57
REAL    AVDEL(mxshl:),AVDEL2(mxshl:)#  Sum of phase differences and *   PS    58
REAL    AVWDE(mxshl:),AVWDE2(mxshl:)#  Sums for weighted deltas         PS    59
REAL    AVP1(mxshl:),AVP2(mxshl:)#     Sum of phase values              PS    60
REAL    BIGST#                         Maximum sitol limit              PS    61
REAL    BINSIZ#                        Size of each bin in degrees      PS    62
REAL    DELBIN#                        Reciprocal of binsiz             PS    63
REAL    DELP,WDELP#                    Delta(phase) for a reflection    PS    64
REAL    DELSHL(mxshl:)#                Delta(d space) for groups        PS    65
REAL    FAZ1,FAZ2#                     Phases of reflections; degrees   PS    66
REAL    H(3)#                          H, k, l                          PS    67
REAL    H1NOWD(3)#                     In unpacked form                 PS    68
REAL    H2NOWD(3)#                     In unpacked form                 PS    69
REAL    NRA#                           No. of reflections from file a   PS    70
REAL    NRB#                           No. of reflections from file b   PS    71
REAL    NREJH#                         H,k,l range                      PS    72
REAL    NREJPH#                        Void phase                       PS    73
REAL    NREJST#                        Sitol range                      PS    74
REAL    NRFIN#                         No. refls. on input bdf          PS    75
REAL    NRUSED(mxshl:)#                No. of refls used in statistic   PS    76
REAL    NRPRIN#                        No. of reflections printed       PS    77
REAL    PI2#                           Constant two pi                  PS    78
REAL    SITOL#                         Sine(theta)/lambda               PS    79
REAL    SMALST#                        Minimum sitol limit              PS    80
COMMON/COMFPS/AVDEL ,AVDEL2,AVP1  ,AVP2  ,AVWDE ,AVWDE2,$#              PS    81
BINSIZ,BIGST ,DELBIN,DELP  ,DELSHL,FAZ1  ,FAZ2  ,H     ,$#              PS    82
H1NOWD,H2NOWD,NRA   ,NRB   ,NREJH ,NREJPH,NREJST,$#                     PS    83
NRFIN ,NRPRIN,NRUSED,NUMATS,NUMELC,PI2   ,SITOL ,SMALST,SCATLN,WDELP#   PS    84
#                                                                       PS    85
string:(DSET1,chtotl:)#                Data set id's from file a        PS    86
string:(DSET2,chtotl:)#                Data set id's from file b        PS    87
string:(IDSET1,12)#                    Id for data set one              PS    88
string:(CID,6)#                        Compound id on file 2            PS    89
string:(EXT,3)#                        Filename extension file 2        PS    90
COMMON/COMCPS/DSET1 ,DSET2 ,IDSET1,CID,EXT#                             PS    91
endext:#                                                                PS    92
#                                                                       PS    93
systemheader:(PS00)#                   Control flow of events           PS00   1
####################################################################### PS00   2
#                                                                     # PS00   3
#                              PS00                                   # PS00   4
#                                                                     # PS00   5
####################################################################### PS00   6
SUBROUTINE PS00#                       J.m. stewart june 1989           PS00   7
#                                                                       PS00   8
#   SUBROUTINE          FUNCTION                                        PS00   9
#       PS00    ROOT SEGMENT, CALLS PS10,PS20,PS30,PS44                 PS00  10
#       PS20    READ ALL LINE INPUT                                     PS00  11
#       PS21    PROCESS BDF LOGICAL RECORDS UP TO LRREFL:               PS00  12
#       PS30    SELECT REFLECTIONS AND BUILD STATISTICS                 PS00  13
#       PS32    APPLY SITOL AND HKL LIMITS                              PS00  14
#       PS33    READ NEXT REFLECTION FROM FILE A                        PS00  15
#       PS34    READ NEXT REFLECTION FROM FILE B                        PS00  16
#       PS36    LIST REFLECTIONS, THEIR PHASES, AND PHASE DIFFERENCES   PS00  17
#       PS44    LIST REFLECTION COUNTS                                  PS00  18
#                                                                       PS00  19
include:(AACOMN)#                                                       PS00  20
include:(PSCOMN)#                                                       PS00  21
#                                                                       PS00  22
PI2=2.0*ACOS(-1.0)#                    Get local value of two pi        PS00  23
CALL PS20#                             Read line input                  PS00  24
CALL PS30#                             Read reflections/make statisti   PS00  25
CALL PS44#                             Summary                          PS00  26
#                                                                       PS00  27
RETURN#                                                                 PS00  28
END#                                                                    PS00  29
systemheader:(PS20)#                   Line input processing            PS20   1
####################################################################### PS20   2
#                                                                     # PS20   3
#                              PS20                                   # PS20   4
#                                                                     # PS20   5
####################################################################### PS20   6
SUBROUTINE PS20#                       J.m. stewart june 1989           PS20   7
include:(AACOMN)#                                                       PS20   8
include:(PSCOMN)#                                                       PS20   9
#                                                                       PS20  10
INTEGER I,J,K,L#                       Loop index                       PS20  11
#                                                                       PS20  12
chardata:(PS203, PHASO1 PHASO2 MAXHKL END    )#                         PS20  13
chardata:(PS204,[  PRINT REFLECTIONS MODULO       BASED ON $#           PS20  14
INPUT SEQUENCE COUNT])#                                                 PS20  15
chardata:(PS205,[LIST BIN  SHEL CID  EXT  ])#                           PS20  16
chardata:(PS206,[PARENT      ])#                                        PS20  17
chardata:(PS207,[ PHASE SOURCE- SET N FILE            $#                PS20  18
BDF PACKET ID NUMBER])#                                                 PS20  19
chardata:(PS209,[DS   FC   BEST MOST DENS DIR  ])#                      PS20  20
chardata:(PS210,[       .XXX TO BE USED FOR PHASE SET 1])#              PS20  21
chardata:(PS212,[       .XXX TO BE USED FOR PHASE SET 2])#              PS20  22
chardata:(PS211,[ COMPOUND ID ON SECOND FILE MUST BE       . ])#        PS20  23
chardata:(PS20A,[12])#                                                  PS20  24
chardata:(PS20B,[ F CALCULATED                        N801 AND N802 $#  PS20  25
OR N700])#                                                              PS20  26
chardata:(PS20C,[ "BEST" MIR PHASES                   701 AND 702])#    PS20  27
chardata:(PS20D,[ "MOST PROBABLE" MIR PHASES          703 AND 704])#    PS20  28
chardata:(PS20E,[ DENSITY MODIFICATION PHASES         N511])#           PS20  29
chardata:(PS20F,[ DIRECT METHODS PHASES               N6XX])#           PS20  30
chardata:(PS20G,[ SAMPLE IN   N EQUAL VOLUMES OF RECIPROCAL SPACE])#    PS20  31
datastuff:#                                                             PS20  32
#                                                                       PS20  33
# INITIALIZATION                                                        PS20  34
# --------------                                                        PS20  35
#                                                                       PS20  36
NSET(1)=1 ; NSET(2)=1#                 Default dataset numbers to 1     PS20  37
PS(1)=1 ; PS(2)=2#                     Default to phase sets 1 & 2      PS20  38
PHASO(1)=1 ; PHASO(2)=1#               Take f calc by def'lt both set   PS20  39
LMOD = 100#                            Default, print every 100 refl    PS20  40
#                                                                       PS20  41
DO I=1,3#                              Hkl limits                       PS20  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PS20  43
BIGIH(I) =   1000#                                                      PS20  44
SMALIH(I) = -1000#                                                      PS20  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PS20  46
BIGST=0.0#                             Set max sin(theta)/lambda to     PS20  47
DO J=1,mxshl:#                         Clear average sums               PS20  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PS20  49
AVP1(J)=0.0 ; AVP2(J)=0.0 ; AVDEL(J)=0.0# Averages and sigma(delp)      PS20  50
AVDEL2(J)=0.0 ; AVWDE(J)=0.0 ; AVWDE2(J)=0.0# And weighted ones         PS20  51
NRUSED(J)=0.0#                         Number used for statistics       PS20  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PS20  53
BINSIZ=45.0#                           Set statistics bin size; degre   PS20  54
SHLNUM=4#                              Default to 4 equal vol's in d    PS20  55
NREJH  = 0.#                           Rejected because of hkl limits   PS20  56
NREJPH = 0.#                           Rejected for missing phase       PS20  57
NREJST = 0.#                           Rejected as outside stol limit   PS20  58
NRFIN  = 0.#                           Total refls in bdfnrfout = 0.#   PS20  59
NRPRIN = 0.#                           Refls printed for viewing        PS20  60
NRA = 0.#                              Refls from file a                PS20  61
NRB = 0.#                              Refls from file b                PS20  62
movechar:(PS206,1,IDSET1,1,NPS206,0)#  Parent out data set i            PS20  63
CID=COMPID#                            Default compid                   PS20  64
EXT=FILEXT(IOUNIT(1))#                 Default extension                PS20  65
#                                                                       PS20  66
# DECIPHER PHACMP LINE                                                  PS20  67
# --------------------                                                  PS20  68
#                                                                       PS20  69
FOR(I=1;BUFIN(I)<voidflg:;I=I+1)#      Loop over phacmp line fields     PS20  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PS20  71
stringlim:(I,J,K); L=MIN0(K-J,4)#      Limits of the non-void field     PS20  72
compchar:(CHRIN,J,PS205,1,L,5,NPS205,K)# Find what's there              PS20  73
IF(K==0) iquit:(PS2002,I)#             Dud flag in input line           PS20  74
#                                                                       PS20  75
IF(K==1)#                              ************* list **********    PS20  76
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PS20  77
IF(BUFIN(I+1)>0.0)#                    List skip number may follow      PS20  78
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PS20  79
LMOD = INT(BUFIN(I+1)) ; I=I+1#        Store list skip number           PS20  80
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PS20  81
ELSE LMOD = 1#                         List every reflection            PS20  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PS20  83
#                                                                       PS20  84
ELSE IF(K==2)#                         *********** bin *************    PS20  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PS20  86
I=I+1#                                 Incr field pointer               PS20  87
IF(BUFIN(I)>0.0) BINSIZ=BUFIN(I)#      Store width of bins              PS20  88
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PS20  89
#                                                                       PS20  90
ELSE IF(K==3)#                         *********** shel *************   PS20  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PS20  92
I=I+1#                                 Incr field pointer               PS20  93
IF(BUFIN(I)>0.0&BUFIN(I)<mxshl:.) SHLNUM=NINT(BUFIN(I))# Shell n        PS20  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PS20  95
#                                                                       PS20  96
ELSE IF(K==4)#                         *********** cid *************    PS20  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PS20  98
I=I+1#                                 Incr field pointer               PS20  99
stringlim:(I,J,K); L=MIN0(K-J,6)#      Limits of the compid code        PS20 100
CID=CHRIN(J^J+L-1)#                    Store input compid code          PS20 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PS20 102
#                                                                       PS20 103
ELSE IF(K==5)#                         *********** ext *************    PS20 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PS20 105
I=I+1#                                 Incr field pointer               PS20 106
stringlim:(I,J,K); L=MIN0(K-J,6)#      Limits of filename extension     PS20 107
EXT=CHRIN(J^J+L-1)#                    Store input filename extension   PS20 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PS20 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PS20 110
#                                                                       PS20 111
# SET UP BINNING FOR STATISTICS                                         PS20 112
# -----------------------------                                         PS20 113
#                                                                       PS20 114
# THE BINS ARE LAID OUT IN THE QX ARRAY STARTING AT MARKB+1 IN THE      PS20 115
# FOLLOWING PATTERN.  STEPB IS 4*SHLNUM, THAT IS, FOUR TIMES THE        PS20 116
# NUMBER OF EQUAL VOLUMES IN RECIPROCAL SPACE.  THERE WILL BE           PS20 117
# NBIN*STEPB BINS IN ALL.  I.E. STOPB=MARKB+NBIN+STEPB.                 PS20 118
# FOR THE FIRST VOLUME OF RECIPROCAL SPACE:                             PS20 119
# QX(J+1)     COUNT OF PHASES IN FIRST PHI RANGE  SET 1                 PS20 120
# QX(J+2)     COUNT OF PHASES IN FIRST PHI RANGE  SET 2                 PS20 121
# QX(J+3)     COUNT OF PHASES IN FIRST PHI RANGE  DELTA(PHI)            PS20 122
# QX(J+4)     COUNT OF PHASES IN FIRST PHI RANGE  WEIGHTED DELTA(PHI)   PS20 123
# FOR THE SECOND VOLUME OF RECIPROCAL SPACE:                            PS20 124
# QX(J+5)     COUNT OF PHASES IN FIRST PHI RANGE  SET 1                 PS20 125
# QX(J+6)     COUNT OF PHASES IN FIRST PHI RANGE  SET 2                 PS20 126
# QX(J+7)     COUNT OF PHASES IN FIRST PHI RANGE  DELTA(PHI)            PS20 127
# QX(J+8)     COUNT OF PHASES IN FIRST PHI RANGE  WEIGHTED DELTA(PHI)   PS20 128
# ...................................................................   PS20 129
#                                                                       PS20 130
# FOR THE LAST VOLUME OF RECIPROCAL SPACE:                              PS20 131
# QX(J+STEPB-3) COUNT OF PHASES IN FIRST PHI RANGE  SET 1               PS20 132
# QX(J+STEPB-2) COUNT OF PHASES IN FIRST PHI RANGE  SET 2               PS20 133
# QX(J+STEPB-1) COUNT OF PHASES IN FIRST PHI RANGE  DELTA(PHI)          PS20 134
# QX(J+STEPB)   COUNT OF PHASES IN FIRST PHI RANGE  WEIGHTED DELTA(PHI) PS20 135
#                                                                       PS20 136
# THIS PATTERN THEN REPEATS FOR NBIN MORE TIMES TO ACCOMODATE ALL       PS20 137
# RANGES OF PHI OVER 360 DEGREES IN STEPS OF -BINSIZ/2 TO +BINSIZ/2.    PS20 138
#                                                                       PS20 139
BINSIZ=AMAX1(AMIN1(AMOD(BINSIZ,360.0),360.0),1.0)# Protect bin arrays   PS20 140
DELBIN=1.0/BINSIZ ; NBIN=NINT(360.0*DELBIN)#                            PS20 141
#                                                                       PS20 142
# START READING BDF(S)                                                  PS20 143
# --------------------                                                  PS20 144
#                                                                       PS20 145
CALL PS21#                             Data set names, start bdf inpu   PS20 146
#                                                                       PS20 147
ncodefld:(FLOAT(LMOD),1,PS204,320513.,3)# Format list request           PS20 148
writeline:(1,PS204,NPS204,3,3)#        Print the list request           PS20 149
#                                                                       PS20 150
# SET UP REGIONS OF SIN(THETA)/LAMBDA THAT CORRESPOND TO EQUAL          PS20 151
# VOLUMES IN RECIPROCAL SPACE                                           PS20 152
# ------------------------------------------------------------          PS20 153
#                                                                       PS20 154
VOL=BIGST**3/FLOAT(SHLNUM)#            Calculate proportion to volume   PS20 155
VOLP=VOL ; DO J=1,SHLNUM#                                               PS20 156
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PS20 157
DELSHL(J)=VOLP**0.3333333 ; VOLP=VOLP+VOL# Store next shell cutoff      PS20 158
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PS20 159
BUFOT(1)=FLOAT(SHLNUM) ; ncodefld:(BUFOT,1,PS20G,140313.,1)#            PS20 160
writeline:(1,PS20G,NPS20G,3,3)#        Report sampling scheme           PS20 161
#                                                                       PS20 162
# READ LINE INPUT                                                       PS20 163
# ---------------                                                       PS20 164
#                                                                       PS20 165
REPEAT#                                                                 PS20 166
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PS20 167
readline:(PS203,NPS203)#               Read another line                PS20 168
IF(LINID==4)  BREAK#                   End line so exit                 PS20 169
#                                                                       PS20 170
# DECIPHER PHASO1 OR PHASO2 LINE                                        PS20 171
# ------------------------------                                        PS20 172
#                                                                       PS20 173
ELSE IF(LINID==1\LINID==2)#            Phase source information line    PS20 174
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PS20 175
FOR(I=1;BUFIN(I)<voidflg:;I=I+1)#      Loop over phaso'n' line fields   PS20 176
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PS20 177
stringlim:(I,J,K); L=MIN0(K-J,4)#      Limits of the non-void field     PS20 178
compchar:(CHRIN,J,PS209,1,L,5,NPS209,K)# Find what's there              PS20 179
IF(K==0) iquit:(PS2003,2)#             Dud flag.......762002            PS20 180
#                                                                       PS20 181
IF(K==1)#                              ********** ds ************       PS20 182
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PS20 183
I=I+1#                                 Incr field pointer               PS20 184
IF(BUFIN(I)>=1.) NSET(LINID)=NINT(BUFIN(I))# Accept data set number     PS20 185
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PS20 186
#                                                                       PS20 187
ELSE#                                  ****** phase source ********     PS20 188
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PS20 189
PHASO(LINID)=K-1#                      Translate phase sources          PS20 190
IF(K==3\K==4\K==6)#                    For best most and dir choices    PS20 191
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PS20 192
IF(BUFIN(I+1)>=1.0&BUFIN(I+1)<33.0)#   Get sol'n number to be used      PS20 193
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PS20 194
PS(LINID)=NINT(BUFIN(I+1)) ; I=I+1#    Save number as pointer to sol'   PS20 195
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PS20 196
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PS20 197
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PS20 198
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PS20 199
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PS20 200
#                                                                       PS20 201
ELSE IF(LINID==3)#                     ******** maxhkl *************    PS20 202
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PS20 203
DO J=1,3#                              Loop over three fields           PS20 204
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PS20 205
IF(BUFIN(J)>=0.0) BIGIH(J)=NINT(BUFIN(J))# Store maximum h,k,l          PS20 206
IF(BUFIN(J+5)>=-200.0) SMALIH(J)=NINT(BUFIN(J+5))# Store minimum h,k,   PS20 207
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PS20 208
IF(BUFIN(4)>=0.0) SMALST=BUFIN(4)#     Low sin(theta)/lambda            PS20 209
IF(BUFIN(5)>=0.0) BIGST=BUFIN(5)#      High sin(theta)/lambda           PS20 210
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PS20 211
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PS20 212
#                                                                       PS20 213
#                                                                       PS20 214
# SET UP PRINTED EXPLANATION OF FIRST PHASE SOURCE                      PS20 215
# -------------------------------------------------                     PS20 216
#                                                                       PS20 217
movechar:(FILENM(IOUNIT(1)),1,PS207,27,10,0)# Filename for set 1        PS20 218
movechar:(PS20A,1,PS207,20,1,0)#       Tell that it is set 1            PS20 219
writeline:(1,PS207,NPS207,3,3)#        Write set 1 phase source         PS20 220
BUFOT(1)=FLOAT(NSET(1))#               Get data set no. for set 1       PS20 221
ncodefld:(BUFOT,1,PS20B,380113.,1)#    Put number in print line         PS20 222
ncodefld:(BUFOT,1,PS20E,380113.,1)#    Put number in print line         PS20 223
ncodefld:(BUFOT,1,PS20F,380113.,1)#    Put number in print line         PS20 224
ncodefld:(BUFOT,1,PS20B,470113.,1)#    Put number in print line         PS20 225
ncodefld:(BUFOT,1,PS20B,550113.,1)#    Put number in print line         PS20 226
BUFOT(1)=FLOAT((PS(1)-1)*2)+31.0#      Get pointer to solution subset   PS20 227
ncodefld:(BUFOT,1,PS20F,410223.,1)#    Put number in print line         PS20 228
IF     (PHASO(1)==1) writeline:(0,PS20B,NPS20B,3,3)#                    PS20 229
ELSE IF(PHASO(1)==2) writeline:(0,PS20C,NPS20C,3,3)#                    PS20 230
ELSE IF(PHASO(1)==3) writeline:(0,PS20D,NPS20D,3,3)#                    PS20 231
ELSE IF(PHASO(1)==4) writeline:(0,PS20E,NPS20E,3,3)#                    PS20 232
ELSE IF(PHASO(1)==5) writeline:(0,PS20F,NPS20F,3,3)#                    PS20 233
#                                                                       PS20 234
# SET UP PRINTED EXPLANATION OF SECOND PHASE SOURCE                     PS20 235
# -------------------------------------------------                     PS20 236
#                                                                       PS20 237
movechar:(FILENM(IOUNIT(3)),1,PS207,27,10,0)# Insert filemane set2      PS20 238
movechar:(PS20A,2,PS207,20,1,0)#       Tell that it is set 2            PS20 239
writeline:(1,PS207,NPS207,3,3)#                                         PS20 240
BUFOT(1)=FLOAT(NSET(2))#               Get data set no. for set 2       PS20 241
ncodefld:(BUFOT,1,PS20B,380113.,1)#    Put number in print line         PS20 242
ncodefld:(BUFOT,1,PS20E,380113.,1)#    Put number in print line         PS20 243
ncodefld:(BUFOT,1,PS20F,380113.,1)#    Put number in print line         PS20 244
ncodefld:(BUFOT,1,PS20B,470113.,1)#    Put number in print line         PS20 245
ncodefld:(BUFOT,1,PS20B,550113.,1)#    Put number in print line         PS20 246
BUFOT(1)=FLOAT((PS(2)-1)*2)+31.0#      Get pointer to solution subset   PS20 247
ncodefld:(BUFOT,1,PS20F,410223.,1)#    Put number in print line         PS20 248
IF     (PHASO(2)==1) writeline:(0,PS20B,NPS20B,3,3)#                    PS20 249
ELSE IF(PHASO(2)==2) writeline:(0,PS20C,NPS20C,3,3)#                    PS20 250
ELSE IF(PHASO(2)==3) writeline:(0,PS20D,NPS20D,3,3)#                    PS20 251
ELSE IF(PHASO(2)==4) writeline:(0,PS20E,NPS20E,3,3)#                    PS20 252
ELSE IF(PHASO(2)==5) writeline:(0,PS20F,NPS20F,3,3)#                    PS20 253
#                                                                       PS20 254
#                                                                       PS20 255
# MAKE LRREFL: WANT LIST                                                PS20 256
# ---------------------                                                 PS20 257
#                                                                       PS20 258
DO I=1,maxwant:#                       Set want list for hkl,           PS20 259
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PS20 260
IWANT1(I) = 0 ; IWANT2(I) = 0#         Set the rest to zero             PS20 261
IF(I>4) NEXT#                                                           PS20 262
IWANT1(I) = I ; IWANT2(I) = I#         Sitol, and eps/mult.             PS20 263
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PS20 264
IWANT1(4) = 1000*NSET(1) + 801#        A(calc)                          PS20 265
IWANT1(5) = 1000*NSET(1) + 802#        B(calc)                          PS20 266
IWANT1(9) = 1000*NSET(1) + 511#        Density                          PS20 267
IWANT1(6) = 1000*NSET(1) + 700#        Fc phase                         PS20 268
IWANT1(7) = 1000*NSET(1) + 631 +(PS(1)-1)*2# Solution subset pointer    PS20 269
IWANT1(8) = 1000*NSET(1) + 631 +(PS(2)-1)*2# Second sol'n subset poin   PS20 270
IWANT1(10) = 701+(PS(1)-1)*4#          Mir best cos                     PS20 271
IWANT1(11) = 702+(PS(1)-1)*4#          Mir best sin                     PS20 272
IWANT1(12) = 703+(PS(1)-1)*4#          Mir most prob cos                PS20 273
IWANT1(13) = 704+(PS(1)-1)*4#          Mir most prob sin                PS20 274
IWANT1(14) = 700#                      Wieght of "best" mir phase       PS20 275
IWANT1(15) = 1000*NSET(1) + 632 +(PS(1)-1)*2# Direct methods weight     PS20 276
IWANT1(16) = 1000*NSET(1) + 632 +(PS(2)-1)*2# Second dir methods weig   PS20 277
#                                                                       PS20 278
IWANT2(4) = 1000*NSET(2) + 801#        A(calc)                          PS20 279
IWANT2(5) = 1000*NSET(2) + 802#        B(calc)                          PS20 280
IWANT2(9) = 1000*NSET(2) + 511#        Density                          PS20 281
IWANT2(6) = 1000*NSET(2) + 700#        Fc phase                         PS20 282
IWANT2(7) = 1000*NSET(2) + 631 +(PS(1)-1)*2# Direct methods solution    PS20 283
IWANT2(8) = 1000*NSET(2) + 631 +(PS(2)-1)*2# Second dir methods sol'n   PS20 284
IWANT2(10) = 701+(PS(2)-1)*4#          Mir best cos                     PS20 285
IWANT2(11) = 702+(PS(2)-1)*4#          Mir best sin                     PS20 286
IWANT2(12) = 703+(PS(2)-1)*4#          Mir most prob cos                PS20 287
IWANT2(13) = 704+(PS(2)-1)*4#          Mir most prob sin                PS20 288
IWANT2(14) = 700#                      Wieght of "best" mir phase       PS20 289
IWANT2(15) = 1000*NSET(2) + 632 +(PS(1)-1)*2# Direct methods weight     PS20 290
IWANT2(16) = 1000*NSET(2) + 632 +(PS(2)-1)*2# Second dir methods weig   PS20 291
#                                                                       PS20 292
RETURN#                                                                 PS20 293
END#                                                                    PS20 294
systemheader:(PS21)#                   Process records up to lrrefl     PS21   1
####################################################################### PS21   2
#                                                                     # PS21   3
#                              PS21                                   # PS21   4
#                                                                     # PS21   5
####################################################################### PS21   6
SUBROUTINE PS21#                       J.m. stewart june 1989           PS21   7
include:(AACOMN)#                                                       PS21   8
include:(PSCOMN)#                                                       PS21   9
#                                                                       PS21  10
string:(KEEP,6)#                                                        PS21  11
INTEGER I,J#                           An index                         PS21  12
INTEGER PSIZE,IPT#                     Packet size and pointers         PS21  13
INTEGER IWNT(7),IREL(8),KEY(4)#        For lrdset                       PS21  14
REAL SORTA,SORTB#                      Packed sort orders from lrexpl   PS21  15
datastuff:#                                                             PS21  16
#                                                                       PS21  17
# LAY OUT STORAGE                                                       PS21  18
# ---------------                                                       PS21  19
#                                                                       PS21  20
IOMARK(1) = QXSTR#                     Buffer for input bdf 1           PS21  21
IOMARK(3) = IOMARK(1) + bdfbuf:#       Buffer for input bdf 2           PS21  22
MARKB = IOMARK(3) + bdfbuf:#           Start of symops array            PS21  23
STEPB=4*SHLNUM#                        Set array step                   PS21  24
STOPB = MARKB + NBIN*STEPB#            Set bin storage                  PS21  25
incrqx:(I,STOPB+1,PS2101)#             Incr memory                      PS21  26
#                                                                       PS21  27
#   OPEN THE BDF'S CONTAINING THE PHASE SETS                            PS21  28
#   ----------------------------------------                            PS21  29
#                                                                       PS21  30
readwpkt:(1,1,I,J,0)#                  Read the history packet          PS21  31
IF(CID!=COMPID\EXT!=FILEXT(IOUNIT(1)))# Second input bdf for set 2      PS21  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PS21  33
FILEXT(IOUNIT(3))=EXT#                 Set the file extension           PS21  34
KEEP=COMPID; COMPID=CID#               Replace the compid temporarily   PS21  35
readwpkt:(3,1,I,J,0)#                  Open & read the history record   PS21  36
COMPID=KEEP#                           Restore the compid               PS21  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PS21  38
ELSE#                                  Same bdf as first phase set      PS21  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PS21  40
FILEXT(IOUNIT(3))='XX1'#               Set the scratch file extension   PS21  41
copyfile:(1,3,2,endrecord:)#           Copy all data to file xx1        PS21  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PS21  43
#                                                                       PS21  44
# PROCESS LRDDEF: DATA (READ IN DATA SET NAMES)                         PS21  45
# ---------------------------------------------                         PS21  46
#                                                                       PS21  47
movechar:(BLANK,1,DSET1,1,chtotl:,1)## Initialize id's to blanks        PS21  48
movechar:(BLANK,1,DSET2,1,chtotl:,1)## Initialize id's to blanks        PS21  49
#                                                                       PS21  50
FOR(I=1;I>0;I=I+12)#                   Loop over phase set names        PS21  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PS21  52
readwpkt:(1,lrddef:,PSIZE,IPT,0)#                                       PS21  53
IF(IPT <= 0)  BREAK#                                                    PS21  54
movertoc:(QX(IPT+1),1,DSET1,I,12,0)#   Collect all file a data set id   PS21  55
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PS21  56
#                                                                       PS21  57
FOR(J=1;J>0;J=J+12)#                   Loop over phase set names        PS21  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PS21  59
readwpkt:(3,lrddef:,PSIZE,IPT,0)#      Read file b                      PS21  60
IF(IPT <= 0)  BREAK#                                                    PS21  61
movertoc:(QX(IPT+1),1,DSET2,I,12,0)#   Collect all file b data set id   PS21  62
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PS21  63
TOTCH1=I-1 ; TOTCH2=J-1#               Number of characters in data     PS21  64
#                                                                       PS21  65
#   ENTER SORT ORDER FROM (LR LREXPL:)                                  PS21  66
#   ----------------------------------                                  PS21  67
#                                                                       PS21  68
IWNT(1)=1 ; IWNT(2)=12#                Dataset number & sort order      PS21  69
KEY(1)=2;  KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search delimiters          PS21  70
indexpkt:(1,lrexpl:,PSIZE,IPT,0,KEY,IWNT,IREL)# Search rel pointers     PS21  71
IF (KEY(4)<=0) iquit:(PS2102)#         Die if no sort information       PS21  72
REPEAT#                                Loop over data sets              PS21  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PS21  74
readwpkt:(1,lrexpl:,PSIZE,IPT,0)#                                       PS21  75
IF(IPT<=0) BREAK#                                                       PS21  76
IDS=IPT+IREL(1)#                       Make pointer to dataset no.      PS21  77
ifne:(FLOAT(NSET(1)),QX(IDS)) NEXT#    Skip unwanted datasets           PS21  78
I=IPT+IREL(2); IF(I>IPT) SORTA=QX(I)#  Get sort order                   PS21  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PS21  80
#                                                                       PS21  81
indexpkt:(3,lrexpl:,PSIZE,IPT,0,KEY,IWNT,IREL)# Search rel pointers     PS21  82
IF (KEY(4)<=0) iquit:(PS21003)#        Die if no sort information       PS21  83
REPEAT#                                Loop over data sets              PS21  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PS21  85
readwpkt:(3,lrexpl:,PSIZE,IPT,0)#                                       PS21  86
IF(IPT<=0) BREAK#                                                       PS21  87
IDS=IPT+IREL(1)#                       Make pointer to dataset no.      PS21  88
ifne:(FLOAT(NSET(1)),QX(IDS)) NEXT#    Skip unwanted datasets           PS21  89
I=IPT+IREL(2); IF(I>IPT) SORTB=QX(I)#  Get sort order                   PS21  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PS21  91
ifne:(SORTA,SORTB) iquit:(PS2104)#     Sort orders must be the same!    PS21  92
SORT1=NINT(SORTA*0.01)#                Save offset of first index sor   PS21  93
SORT2=MOD(NINT(SORTA*0.1),10)#         Save offset of second sort ind   PS21  94
SORT3=MOD(NINT(SORTA),10)#             Save offset of third sort inde   PS21  95
#                                                                       PS21  96
#   ENTER DATA SET INFORMATION (LR LRDSET:)                             PS21  97
#   ---------------------------------                                   PS21  98
#                                                                       PS21  99
IF(BIGST<=0.0)#                        If no max sine(theta)/lambda     PS21 100
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PS21 101
SMALST=0.0; BIGST=1.5#                 Set default parameters           PS21 102
IWNT(6)=1#                             Request dataset number           PS21 103
DO I=1,5 ; IWNT(I)=I+10#               Request maxhkl, max&min stol     PS21 104
KEY(1)=0;  KEY(2)=6; KEY(3)=0; KEY(4)=0# Set search delimiters          PS21 105
indexpkt:(1,lrdset:,PSIZE,IPT,0,KEY,IWNT,IREL)# Search rel pointers     PS21 106
IF (IPT>0) REPEAT#                     Loop over data sets              PS21 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PS21 108
readwpkt:(1,lrdset:,PSIZE,IPT,0)#                                       PS21 109
IF(IPT<=0) BREAK#                                                       PS21 110
IDS=IPT+IREL(6)#                       Make pointer to dataset no.      PS21 111
ifne:(FLOAT(NSET(1)),QX(IDS)) NEXT#    Skip unwanted datasets           PS21 112
I=IPT+IREL(1); IF(I>IPT) BIGIH(1)=NINT(QX(I))# Get active max /h/       PS21 113
I=IPT+IREL(2); IF(I>IPT) BIGIH(2)=NINT(QX(I))# Get active max /k/       PS21 114
I=IPT+IREL(3); IF(I>IPT) BIGIH(3)=NINT(QX(I))# Get active max /l/       PS21 115
I=IPT+IREL(4); IF(I>IPT) SMALST=QX(I)# Get active smin                  PS21 116
I=IPT+IREL(5); IF(I>IPT) BIGST=QX(I)#  Get active smax                  PS21 117
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PS21 118
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PS21 119
#                                                                       PS21 120
RETURN#                                                                 PS21 121
END#                                                                    PS21 122
systemheader:(PS30)#                   Read and select reflections      PS30   1
####################################################################### PS30   2
#                                                                     # PS30   3
#                              PS30                                   # PS30   4
#                                                                     # PS30   5
####################################################################### PS30   6
SUBROUTINE PS30#                       J.m. stewart june 1989           PS30   7
#                                                                       PS30   8
include:(AACOMN)#                                                       PS30   9
include:(PSCOMN)#                                                       PS30  10
#                                                                       PS30  11
REAL DTOR,RTOD#                        Degrees to radians and back      PS30  12
REAL FMTR#                             Output format variable           PS30  13
INTEGER IH(3)#                         H,k,l as unpacked by ps32        PS30  14
INTEGER IPTR1,IPTR2#                   Pointer to a particular input    PS30  15
#                                      Packet.                          PS30  16
INTEGER KEY(4)#                        Set indexpkt control signals     PS30  17
INTEGER REFILL#                        Set refilling of input buffers   PS30  18
INTEGER SHELL#                         Point to shell in recip. space   PS30  19
REAL WEIGHT#                           Weight for given phase d'tn      PS30  20
intdata:(PTCOS1,[0])#                  Pointer to cos(phase) of 1       PS30  21
intdata:(PTCOS2,[0])#                  Pointer to cos(phase) of 2       PS30  22
intdata:(PTSIN1,[0])#                  Pointer to sin(phase) of 1       PS30  23
intdata:(PTSIN2,[0])#                  Pointer to sin(phase) of 2       PS30  24
intdata:(PTFAZ1,[0])#                  Pointer to phase of set 1        PS30  25
intdata:(PTFAZ2,[0])#                  Pointer to phase of set 2        PS30  26
intdata:(PTWT1,[0])#                   Pointer to weight of set 1       PS30  27
intdata:(PTWT2,[0])#                   Pointer to weight of set 2       PS30  28
chardata:(PS30A,[ THE BDF ON FILE       .XXX CONTAINS THE FOLLOWING $#  PS30  29
PHASE RELATED ITEMS-])#                                                 PS30  30
chardata:(PS30B,[NONE])#                                                PS30  31
chardata:(PS30D,[ SCREENING OF REFLECTIONS BASED ON-])#                 PS30  32
chardata:(PS30E,[ H MIN  K MIN  L MIN  H MAX  K MAX  L MAX  $#          PS30  33
STOL MIN  STOL MAX    D MAX    D MIN])#                                 PS30  34
realdata:(FMT3E,[60513.,130513.,200513.,270513.,340513.,410513.,$#      PS30  35
510942.,610942.,700822.,790822.])#                                      PS30  36
datastuff:#                                                             PS30  37
DATA KEY(1),KEY(2),KEY(3),KEY(4)/3,maxwant:,0,0/#                       PS30  38
#                                                                       PS30  39
DTOR=PI2/360.0 ; RTOD=1.0/DTOR#        Make degrees to radians conver   PS30  40
#                                                                       PS30  41
# REPORT SCREENING LIMITS FOR MAX AND MIN H,K,L AND STOL                PS30  42
# ------------------------------------------------------                PS30  43
#                                                                       PS30  44
DO J=1,3#                                                               PS30  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PS30  46
BUFOT(J)=FLOAT(SMALIH(J)) ; BUFOT(J+3)=FLOAT(BIGIH(J))# H,k,l min/max   PS30  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PS30  48
BUFOT(7)=SMALST ; BUFOT(8)=BIGST#      Min/max sin(theta)/lambda        PS30  49
IF(SMALST<=0.001) BUFOT(9)=99.9#       Get safe d max                   PS30  50
ELSE BUFOT(9)=0.5/SMALST#              True d max if divide allows      PS30  51
BUFOT(10)=0.5/AMAX1(0.01,BIGST)#       Get d min                        PS30  52
LINRM=6 ; writeline:(2,PS30D,NPS30D,3,3) ; LINRM=3#                     PS30  53
ncodefld:(BUFOT,1,CHROT,FMT3E,10) ; writeline:(0,PS30E,NPS30E,1,3)#     PS30  54
#                                                                       PS30  55
# LRREFL: DIRECTORY READ/WRITE                                          PS30  56
# ----------------------------                                          PS30  57
#                                                                       PS30  58
indexpkt:(1,lrrefl:,PSIZE1,IPT,0,KEY,IWANT1,IREL1)#                     PS30  59
FMTR=513. ; K=0#                                                        PS30  60
FOR(J=4;J<=maxwant:;J=J+1)#            Scan what's in input             PS30  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PS30  62
IF(IREL1(J)<=0) NEXT#                  Identify those present           PS30  63
K=K+1 ; BUFOT(K)=QX(IPT+IREL1(J))#                                      PS30  64
FMTR=FMTR+60000. ; ncodefld:(BUFOT,K,CHROT,FMTR,1)#                     PS30  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PS30  66
movechar:(FILENM(IOUNIT(1)),1,PS30A,18,10,0)# And file extension        PS30  67
IF(K==0) movechar:(PS30B,1,CHROT,6,NPS30B,0)# Warn if none present      PS30  68
LINRM=4 ; writeline:(1,PS30A,NPS30A,1,3)# Report out items present      PS30  69
IF (KEY(4) < 0)  iquit:(PS3002)#       Missing data                     PS30  70
#                                                                       PS30  71
indexpkt:(3,lrrefl:,PSIZE1,IPT,0,KEY,IWANT2,IREL2)#                     PS30  72
FMTR=513. ; K=0#                                                        PS30  73
FOR(J=4;J<=maxwant:;J=J+1)#            Scan what's in input             PS30  74
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PS30  75
IF(IREL2(J)<=0) NEXT#                  Identify those present           PS30  76
K=K+1 ; BUFOT(K)=QX(IPT+IREL2(J))#                                      PS30  77
FMTR=FMTR+60000. ; ncodefld:(BUFOT,K,CHROT,FMTR,1)#                     PS30  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PS30  79
movechar:(FILENM(IOUNIT(3)),1,PS30A,18,10,0)# And file extension used   PS30  80
IF(K==0) movechar:(PS30B,1,CHROT,6,NPS30B,0)# Warn if none present      PS30  81
LINRM=4 ; writeline:(1,PS30A,NPS30A,1,3)#                               PS30  82
IF (KEY(4) < 0)  iquit:(PS3003)#       Missing data                     PS30  83
#                                                                       PS30  84
# CHECK TO SEE IF THE REQUIRED QUANTITIES ARE PRESENT                   PS30  85
# IF THERE ARE NO PHASES, IT IS AN ERROR                                PS30  86
# -----------------------------------------------------                 PS30  87
#                                                                       PS30  88
# IREL1(1)  FOR PACKED H,K, & L                                         PS30  89
# IREL1(2)  FOR SINE(THETA)/LAMBDA                                      PS30  90
# IREL1(3)  FOR EPSILON & MULTIPLICITY                                  PS30  91
# IREL1(4)  FOR COS(PHASE) CALCULATED                                   PS30  92
# IREL1(5)  FOR SIN(PHASE) CALCULATED                                   PS30  93
# IREL1(6)  FOR PHASE(CYCLES) CALCULATED                                PS30  94
# IREL1(7)  FOR DIRECT METHOD PHASE SET OF FIRST CHOICE                 PS30  95
# IREL1(8)  FOR DIRECT METHOD PHASE SET OF SECOND CHOICE                PS30  96
# IREL1(9)  FOR CALCULATED PHASE FROM DENSITY MODIFICATION METHODS      PS30  97
# IREL1(10) FOR COS(PHASE) MIR "BEST"                                   PS30  98
# IREL1(11) FOR SIN(PHASE) MIR "BEST"                                   PS30  99
# IREL1(12) FOR COS(PHASE) MIR "MOST PROBABLE"                          PS30 100
# IREL1(13) FOR SIN(PHASE) MIR "MOST PROBABLE"                          PS30 101
# IREL1(14) FOR WEIGHT OF "BEST" MIR PHASE                              PS30 102
# IREL1(15) FOR WEIGHT OF DIRECT METHODS FIRST CHOICE PHASE             PS30 103
# IREL1(16) FOR WEIGHT OF DIRECT METHODS SECOND CHOICE PHASE            PS30 104
# THE LIST IS THE SAME FOR IREL2 IF THERE IS A FILE B READ SET          PS30 105
#                                                                       PS30 106
IF(PHASO(1)==1)#                       Is phase source 1 f calculated   PS30 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PS30 108
PTCOS1=IREL1(4) ; PTSIN1=IREL1(5) ; PTFAZ1=IREL1(6)# Get pointers       PS30 109
PTWT1=0#                                                                PS30 110
IF(PTCOS1<=0&PTFAZ1<=0) iquit:(PS3011)# No phases for fc                PS30 111
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PS30 112
ELSE IF(PHASO(1)==2)#                  Is phase source "best" mir?      PS30 113
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PS30 114
PTCOS1=IREL1(10) ; PTSIN1=IREL1(11) ; PTFAZ1=0 ; PTWT1=IREL1(14)# Poi   PS30 115
IF(PTCOS1<=0) iquit:(PS3012)#          No phases from mir               PS30 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PS30 117
ELSE IF(PHASO(1)==3)#                  Phase source "most prob" mir?    PS30 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PS30 119
PTCOS1=IREL1(12) ; PTSIN1=IREL1(13) ; PTFAZ1=0 ; PTWT1=IREL1(14)# Poi   PS30 120
IF(PTCOS1<=0) iquit:(PS3013)#          No phases from mir               PS30 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PS30 122
ELSE IF(PHASO(1)==4)#                  Source density mod method?       PS30 123
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PS30 124
PTCOS1=0 ; PTSIN1=0 ; PTFAZ1=IREL1(9) ; PTWT1=0# Get pointers           PS30 125
IF(PTFAZ1<=0) iquit:(PS3014)#          No phases from density           PS30 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PS30 127
ELSE IF(PHASO(1)==5)#                  Phase source direct methods?     PS30 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PS30 129
PTCOS1=0 ; PTSIN1=0 ; PTFAZ1=IREL1(7) ; PTWT1=IREL1(15)# Get pointers   PS30 130
IF(PTFAZ1<=0) iquit:(PS3015)#          No phases from direct methods    PS30 131
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PS30 132
#                                                                       PS30 133
IF(PHASO(2)==1)#                       Is phase source 2 f calculated   PS30 134
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PS30 135
PTCOS2=IREL2(4) ; PTSIN2=IREL2(5) ; PTFAZ2=IREL2(6) ; PTWT2=0# Pointe   PS30 136
IF(PTCOS2<=0&PTFAZ2<=0) iquit:(PS3021)# No phases for fc                PS30 137
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PS30 138
ELSE IF(PHASO(2)==2)#                  Is phase source "best" mir?      PS30 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PS30 140
PTCOS2=IREL2(10) ; PTSIN2=IREL2(11) ; PTFAZ2=0 ; PTWT2=IREL2(14)# Poi   PS30 141
IF(PTCOS2<=0) iquit:(PS3022)#          No phases from mir               PS30 142
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PS30 143
ELSE IF(PHASO(2)==3)#                  Phase source "most prob" mir?    PS30 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PS30 145
PTCOS2=IREL2(12) ; PTSIN2=IREL2(13) ; PTFAZ2=0 ; PTWT2=IREL2(14)# Poi   PS30 146
IF(PTCOS2<=0) iquit:(PS3023)#          No phases from mir               PS30 147
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PS30 148
ELSE IF(PHASO(2)==4)#                  Source density mod method?       PS30 149
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PS30 150
PTCOS2=0 ; PTSIN2=0 ; PTFAZ2=IREL2(9) ; PTWT2=0# Get pointers           PS30 151
IF(PTFAZ2<=0) iquit:(PS3024)#          No phases from density           PS30 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PS30 153
ELSE IF(PHASO(2)==5)#                  Phase source direct methods?     PS30 154
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PS30 155
PTCOS2=0 ; PTSIN2=0 ; PTFAZ2=IREL2(8) ; PTWT2=IREL2(16)# Point          PS30 156
IF(PTFAZ2<=0) iquit:(PS3025)#          No phases from direct methods    PS30 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PS30 158
#                                                                       PS30 159
# IF ANY ERRORS HAVE BEEN ENCOUNTERED, DIE HERE....                     PS30 160
# ------------------------------------------------                      PS30 161
#                                                                       PS30 162
IF(QUITF!=' ') iquit:(PS3099)#         Die like a dog.....              PS30 163
#                                                                       PS30 164
# IF TWO BDFS ARE BEING USED FILL THE INPUT BUFFERS                     PS30 165
# -------------------------------------------------                     PS30 166
#                                                                       PS30 167
CALL PS33 ; CALL PS34 ; REFILL=no:#    Load first two reflections       PS30 168
IF(IPT1<=0\IPT2<=0) iquit:(PS3030)#    No reflections on one or t'oth   PS30 169
#                                                                       PS30 170
# BEGIN LOOP TO READ REFLECTIONS                                        PS30 171
# ------------------------------                                        PS30 172
#                                                                       PS30 173
IF(LMOD!=0) LINCT = 0#                 Force new page for refln o/p     PS30 174
REPEAT#                                                                 PS30 175
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PS30 176
IF(REFILL==yes:)#                      Do buffers need refilling?       PS30 177
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PS30 178
CALL PS33 ; CALL PS34 ; REFILL=no:#    Then refill them                 PS30 179
IF(IPT1<=0\IPT2<=0) BREAK#             And quit if either one exhaust   PS30 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PS30 181
H1NOW = H1NEXT#                        Find current hkl's being         PS30 182
H2NOW = H2NEXT#                        Processed.                       PS30 183
IF(H1NOW<H2NOW)#                       Primary file is behind seconda   PS30 184
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PS30 185
CALL PS33#                             Read primary reflection          PS30 186
IF(IPT1<=0) BREAK#                     If reading finished....          PS30 187
NEXT#                                  See if that gets a match         PS30 188
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PS30 189
ELSE IF(H1NOW>H2NOW)#                  Secondary is behind              PS30 190
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PS30 191
CALL PS34#                             Read a secondary reflection      PS30 192
IF(IPT2<=0) BREAK#                     If reading finished....          PS30 193
NEXT#                                  See if that gets a match         PS30 194
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PS30 195
NRFIN = NRFIN + 1.#                    Count input reflections          PS30 196
#                                                                       PS30 197
IPTR1 = IPT1 + IREL1(3)#               Epsilon and phase restrictions   PS30 198
intunpak:(QX(IPTR1),IEPSIL,5,5) ; EPSIL=FLOAT(IEPSIL)# Get epsilon      PS30 199
intunpak:(QX(IPTR1),RESTRC,10,4)#      Get phase restriction code       PS30 200
IPTR1 = IPT1 + IREL1(2)#                                                PS30 201
SITOL = QX(IPTR1)#                     Sine(theta)/lambda               PS30 202
IPTR1 = IPT1 + IREL1(1)#               Pointer to packed hkl            PS30 203
CALL PS32(QX(IPTR1),IH)#               Check for refl. rejection        PS30 204
IF(REJECT==yes:)#                                                       PS30 205
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PS30 206
REFILL=yes: ; NEXT#                    Go on to next reflection         PS30 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PS30 208
#                                                                       PS30 209
# PULL OUT PHASES FROM WHATEVER FORM AND PLACE                          PS30 210
# --------------------------------------------                          PS30 211
#                                                                       PS30 212
IPTR1=IPT1+IREL1(1)#                   Pointer to hkl                   PS30 213
gethkl:(IPTR1,H)#                      Put hkl into h(3)                PS30 214
IF (PTFAZ1!=0)#                        If phase exists use it           PS30 215
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PS30 216
IPTR1=IPT1+PTFAZ1#                     Point to phase in cycles         PS30 217
IF(QX(IPTR1)<(-1.0))#                  Make sure it's known             PS30 218
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PS30 219
NREJPH=NREJPH+1.0 ; REJECT=yes: ; REFILL=yes: ; NEXT# If not, next re   PS30 220
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PS30 221
FAZ1=360.0*AMOD(QX(IPTR1)+100.,1.)#    Get phase in degrees             PS30 222
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PS30 223
ELSE#                                                                   PS30 224
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PS30 225
IPTR1=IPT1+PTCOS1#                     Point to cosine of phase         PS30 226
AINP=QX(IPTR1)#                        Get acalc                        PS30 227
ifvo:(AINP)#                           Test that reflection known       PS30 228
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PS30 229
NREJPH=NREJPH+1.0 ; REJECT=yes: ; REFILL=yes: ; NEXT# Skip to next re   PS30 230
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PS30 231
IPTR1=IPT1+PTSIN1#                     Point to sine of phase           PS30 232
BINP=QX(IPTR1)#                        Get bcalc                        PS30 233
FAZ1=360.0*AMOD(ATAN2(BINP,AINP)/PI2+1.000001,1.0)# Phase in degrees    PS30 234
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PS30 235
IF (PTFAZ2!=0)#                        If second phase exists use it    PS30 236
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PS30 237
IPTR2=IPT2+PTFAZ2#                     Point to phase in cycles         PS30 238
IF(QX(IPTR2)<(-1.0))#                  Make sure it's known             PS30 239
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PS30 240
NREJPH=NREJPH+1.0 ; REJECT=yes: ; REFILL=yes: ; NEXT# Go to next refl   PS30 241
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PS30 242
FAZ2=360.0*AMOD(QX(IPTR2)+100.,1.)#    Get phase in degrees             PS30 243
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PS30 244
ELSE#                                                                   PS30 245
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PS30 246
IPTR2=IPT2+PTCOS2#                     Point to cosine of phase         PS30 247
AINP=QX(IPTR2)#                        Get acalc                        PS30 248
ifvo:(AINP)#                           Test that reflection known       PS30 249
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PS30 250
NREJPH=NREJPH+1.0 ; REJECT=yes: ; REFILL=yes: ; NEXT# Skip to next re   PS30 251
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PS30 252
IPTR2=IPT2+PTSIN2#                     Point to sine of phase           PS30 253
BINP=QX(IPTR2)#                        Get bcalc                        PS30 254
FAZ2=360.0*AMOD(ATAN2(BINP,AINP)/PI2+1.000001,1.0)# Phase in degrees    PS30 255
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PS30 256
#                                                                       PS30 257
# TEST IF THIS REFLECTION IS TO CONTRIBUTE TO THE STATISTICS            PS30 258
# ----------------------------------------------------------            PS30 259
#                                                                       PS30 260
IF(FAZ1<0.0\FAZ1>360.0\FAZ2<0.0\FAZ2>360.0)# Test for kosher phases     PS30 261
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PS30 262
NREJPH=NREJPH+1.0 ; REFILL=yes: ; NEXT#                                 PS30 263
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PS30 264
#                                                                       PS30 265
# FORM THE STATISTICAL SUMS AND COUNTS                                  PS30 266
# ------------------------------------                                  PS30 267
#                                                                       PS30 268
SHELL=SHLNUM ; DO J=1,SHLNUM#          Loop over shells of sin theta    PS30 269
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 PS30 270
IF(SITOL>DELSHL(J)) NEXT#              Find right range                 PS30 271
SHELL=J ; BREAK#                       Remember it and quit looking     PS30 272
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 PS30 273
AVP1(SHELL)=AVP1(SHELL)+FAZ1#          Sum of phases of first set       PS30 274
AVP2(SHELL)=AVP2(SHELL)+FAZ2#          Sum second set to get average    PS30 275
NRUSED(SHELL)=NRUSED(SHELL)+1.0#       Count reflections used           PS30 276
#                                                                       PS30 277
# FIND THE BIN IN WHICH EACH ANGLE BELONGS                              PS30 278
# ----------------------------------------                              PS30 279
#                                                                       PS30 280
ARG=AMOD(FAZ1+0.5*BINSIZ,360.0)*DELBIN# Slide to center of bin          PS30 281
J=MAX0(0,MIN0(NBIN-1,INT(ARG)))#       Find correct bin for set 1       PS30 282
J=J*STEPB+(SHELL-1)*4+MARKB#                                            PS30 283
QX(J+1)=QX(J+1)+1.0#                                                    PS30 284
ARG=AMOD(FAZ2+0.5*BINSIZ,360.0)*DELBIN# Slide to center of bin          PS30 285
J=MAX0(0,MIN0(NBIN-1,INT(ARG)))#       Find correct bin for set 2       PS30 286
J=J*STEPB+(SHELL-1)*4+MARKB#                                            PS30 287
QX(J+2)=QX(J+2)+1.0#                                                    PS30 288
DELP=RTOD*ABS(ACOS(COS(DTOR*(FAZ1-FAZ2))))# Find difference modulo 1    PS30 289
ARG=AMOD(DELP+0.5*BINSIZ,360.0)*DELBIN# Slide to center of bin          PS30 290
J=MAX0(0,MIN0(NBIN-1,INT(ARG)))#       Find bin for delta               PS30 291
J=J*STEPB+(SHELL-1)*4+MARKB#                                            PS30 292
QX(J+3)=QX(J+3)+1.0#                                                    PS30 293
WEIGHT=1.0#                            Default weight to 1.0            PS30 294
IF(PTWT1>0) WEIGHT=WEIGHT*QX(IPT1+PTWT1)# Decrease it by phase one wt   PS30 295
IF(PTWT2>0) WEIGHT=WEIGHT*QX(IPT2+PTWT2)# Decrease it by phase two wt   PS30 296
IF(PTWT1>0&PTWT2>0) WEIGHT=SQRT(WEIGHT)# Keep weight on scale           PS30 297
WDELP=DELP*WEIGHT#                     Get weighted delta phi           PS30 298
ARG=AMOD(WDELP+0.5*DELBIN,360.0)*DELBIN# Slide to center of bin         PS30 299
J=MAX0(0,MIN0(NBIN-1,INT(ARG)))#       Find bin for delta               PS30 300
J=J*STEPB+(SHELL-1)*4+MARKB#                                            PS30 301
QX(J+4)=QX(J+4)+1.0#                                                    PS30 302
#                                                                       PS30 303
# ADD UP DIFFERENCES AND THEIR SQUARES FOR STATISTICS                   PS30 304
# ---------------------------------------------------                   PS30 305
#                                                                       PS30 306
DELPP=DELP ; WDELPP=WDELP#             Save the delta(phase)            PS30 307
AVDEL(SHELL)=AVDEL(SHELL)+DELPP ; AVDEL2(SHELL)=AVDEL2(SHELL)+DELPP**2# PS30 308
# TAKE SUMS FOR MEAN & SIGMA OF WEIGHTED DELTA PHI                      PS30 309
AVWDE(SHELL)=AVWDE(SHELL)+WDELPP#                                       PS30 310
AVWDE2(SHELL)=AVWDE2(SHELL)+WDELPP**2#                                  PS30 311
IF(LMOD>0)#                            List option active               PS30 312
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 PS30 313
IF(MOD(INT(NRFIN),LMOD)==0)#           List reflections requested       PS30 314
CALL PS36(IPT1+IREL1(1))#                                               PS30 315
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 PS30 316
REFILL=yes:#                           Reflection contributed, do nex   PS30 317
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PS30 318
#                                                                       PS30 319
RETURN#                                                                 PS30 320
END#                                                                    PS30 321
systemheader:(PS32)#                                                    PS32   1
####################################################################### PS32   2
#                                                                     # PS32   3
#                              PS32                                   # PS32   4
#                                                                     # PS32   5
####################################################################### PS32   6
SUBROUTINE PS32(HKL,IH)#               Subroutine to check              PS32   7
#                                         Sin theta and hkl limits.     PS32   8
include:(AACOMN)#                                                       PS32   9
include:(PSCOMN)#                                                       PS32  10
#                                                                       PS32  11
INTEGER IH(3)#                         Reflection indices               PS32  12
INTEGER K#                             Loop index                       PS32  13
INTEGER N#                             Bit index                        PS32  14
REAL HKL#                              Packed hkl from qx array         PS32  15
#                                                                       PS32  16
REJECT = no:#                                                           PS32  17
# EXTRACT HKL                                                           PS32  18
#                                                                       PS32  19
DO K=1,3#                              Loop over h,k,l                  PS32  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PS32  21
N = (3-K)*9 + 3#                       Set bit index                    PS32  22
intunpak:(HKL,IH(K),N,9)#              Get out each index               PS32  23
intunpak:(HKL,N,3-K,1)#                Pick out sign of each index      PS32  24
IF(N != 0)  IH(K) = -IH(K)#            Flip the sign                    PS32  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PS32  26
#                                                                       PS32  27
DO K=1,3#                              Check hkl limits                 PS32  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PS32  29
IF(IH(K) < SMALIH(K) \ IH(K) > BIGIH(K))#                               PS32  30
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PS32  31
NREJH = NREJH + 1.#                                                     PS32  32
REJECT = yes:#                                                          PS32  33
BREAK#                                                                  PS32  34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PS32  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PS32  36
#                                                                       PS32  37
IF(REJECT == no:)#                     If hkl limits ok, check sito     PS32  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PS32  39
IF(SITOL < SMALST \ SITOL > BIGST)#                                     PS32  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PS32  41
NREJST = NREJST + 1.#                                                   PS32  42
REJECT = yes:#                                                          PS32  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PS32  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PS32  45
#                                                                       PS32  46
RETURN#                                                                 PS32  47
END#                                                                    PS32  48
systemheader:(PS33)#                   Next reflection primary bdf      PS33   1
####################################################################### PS33   2
#                                                                     # PS33   3
#                              PS33                                   # PS33   4
#                                                                     # PS33   5
####################################################################### PS33   6
SUBROUTINE PS33#                       J.m. stewart oct 1989            PS33   7
#                                                                       PS33   8
include:(AACOMN)#                                                       PS33   9
include:(PSCOMN)#                                                       PS33  10
INTEGER IB#                            Volatile register for packing    PS33  11
#                                                                       PS33  12
readwpkt:(1,lrrefl:,PSIZ1,IPT1,0)#     Get next primary reflection      PS33  13
IF(IPT1>0)#                            If reading not finished....      PS33  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PS33  15
NRA=NRA+1.0#                           Reflections from primary file    PS33  16
IPTR1 = IPT1 + IREL1(1)#                                                PS33  17
gethkl:(IPTR1,H1NOWD)#                 Pull out reflection hkl          PS33  18
H1=NINT(H1NOWD(SORT1))#                Get slowest-varying index        PS33  19
H2=NINT(H1NOWD(SORT2))#                Get medium -varying index        PS33  20
H3=NINT(H1NOWD(SORT3))#                Get fastest-varying index        PS33  21
#                                                                       PS33  22
IF((H1<0)$#                            H1 must be positive              PS33  23
\ ((H2<0)&(H1==0))$#                   H1=0 h2 negative                 PS33  24
\ ((H3<0)&(H1==0)&(H2==0)))#           H1=0 h2=0 h3 negative            PS33  25
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PS33  26
H1=-H1; H2=-H2; H3=-H3; IB=1#          Reverse hkl set bijvoet          PS33  27
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PS33  28
ELSE IB=0#                             Bijvoet sign not set             PS33  29
intpak:(0,H1NEXT,0,mxbtwd:)#           Clear out previous reflectio     PS33  30
intpak:(IABS(H1),H1NEXT,21,bitlen:(21))# Pack slow index                PS33  31
intpak:(IB,H1NEXT,0,1)#                Bijvoet sign code                PS33  32
intpak:(IABS(H3),H1NEXT, 3, 9)#        Pack fast index                  PS33  33
intpak:(IABS(H2),H1NEXT,12, 9)#        Pack med  index                  PS33  34
IF(H3<0) intpak:(1,H1NEXT, 1,1)#       Sign code for fas index          PS33  35
IF(H2<0) intpak:(1,H1NEXT, 2,1)#       Sign code for med index          PS33  36
#                                                                       PS33  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PS33  38
#                                                                       PS33  39
RETURN#                                                                 PS33  40
END#                                                                    PS33  41
systemheader:(PS34)#                   Next reflection from secondary   PS34   1
####################################################################### PS34   2
#                                                                     # PS34   3
#                              PS34                                   # PS34   4
#                                                                     # PS34   5
####################################################################### PS34   6
SUBROUTINE PS34#                       J.m. stewart oct 1989            PS34   7
#                                                                       PS34   8
include:(AACOMN)#                                                       PS34   9
include:(PSCOMN)#                                                       PS34  10
INTEGER IB#                            Volatile register for packing    PS34  11
#                                                                       PS34  12
readwpkt:(3,lrrefl:,PSIZ2,IPT2,0)#     Get next secondary reflectio     PS34  13
IF(IPT2>0)#                            If reading not finished....      PS34  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PS34  15
NRB=NRB+1.0#                           Reflections from secondary fil   PS34  16
IPTR2=IPT2+IREL2(1)#                                                    PS34  17
gethkl:(IPTR2,H2NOWD)#                 Pull out reflection hkl          PS34  18
H1=NINT(H2NOWD(SORT1))#                Get slowest-varying index        PS34  19
H2=NINT(H2NOWD(SORT2))#                Get medium -varying index        PS34  20
H3=NINT(H2NOWD(SORT3))#                Get fastest-varying index        PS34  21
#                                                                       PS34  22
IF((H1<0)$#                            H1 must be positive              PS34  23
\ ((H2<0)&(H1==0))$#                   H1=0 h2 negative                 PS34  24
\ ((H3<0)&(H1==0)&(H2==0)))#           H1=0 h2=0 h3 negative            PS34  25
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PS34  26
H1=-H1; H2=-H2; H3=-H3; IB=1#          Reverse hkl set bijvoet          PS34  27
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PS34  28
ELSE IB=0#                             Bijvoet sign not set             PS34  29
intpak:(0,H2NEXT,0,mxbtwd:)#           Clear out previous reflectio     PS34  30
intpak:(IABS(H1),H2NEXT,21,bitlen:(21))# Pack slow index                PS34  31
intpak:(IB,H2NEXT,0,1)#                Bijvoet sign code                PS34  32
intpak:(IABS(H3),H2NEXT, 3, 9)#        Pack fast index                  PS34  33
intpak:(IABS(H2),H2NEXT,12, 9)#        Pack med  index                  PS34  34
IF(H3<0) intpak:(1,H2NEXT, 1,1)#       Sign code for fas index          PS34  35
IF(H2<0) intpak:(1,H2NEXT, 2,1)#       Sign code for med index          PS34  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PS34  37
#                                                                       PS34  38
RETURN#                                                                 PS34  39
END#                                                                    PS34  40
systemheader:(PS36)#                   List output reflections          PS36   1
####################################################################### PS36   2
#                                                                     # PS36   3
#                               PS36                                  # PS36   4
#                                                                     # PS36   5
####################################################################### PS36   6
SUBROUTINE PS36(VPTR1)## J M STEWART OCT 3 1989                         PS36   7
#                                                                       PS36   8
include:(AACOMN)#                                                       PS36   9
include:(PSCOMN)#                                                       PS36  10
#                                                                       PS36  11
INTEGER VPTR1#        ## Points to hkl in qx array                      PS36  12
REAL HKL(3)#          ## Hold hkl                                       PS36  13
realdata:(FMTOT,[50313.,100313.,150313.,260812.,360812.,460812.,$#      PS36  14
660812.])#                                                              PS36  15
chardata:(MSG1,[    H    K    L      PHASE 1   PHASE 2   $#             PS36  16
PHASE DIFFERENCE   WEIGHTED DIFFERENCE])#                               PS36  17
chardata:(MSG2,[ REJECTED])#                                            PS36  18
datastuff:#                                                             PS36  19
#                                                                       PS36  20
gethkl:(VPTR1,HKL)#                    Unpack hkl values                PS36  21
#                                                                       PS36  22
ncodefld:(HKL,1,CHROT,FMTOT(1),3)#                                      PS36  23
ncodefld:(FAZ1,1,CHROT,FMTOT(4),1)#    Print values  of first phase     PS36  24
ncodefld:(FAZ2,1,CHROT,FMTOT(5),1)#    Print values  of second phase    PS36  25
ncodefld:(DELP,1,CHROT,FMTOT(6),1)#    Print the difference             PS36  26
ncodefld:(WDELP,1,CHROT,FMTOT(7),1)#   Print the weighted difference    PS36  27
IF(REJECT==yes:)#                      Mark rejected refls if needed    PS36  28
movechar:(MSG2,1,CHROT,49,NMSG2,0)#                                     PS36  29
writeline:(0,MSG1,NMSG1,1,3)#          Output to print file             PS36  30
NRPRIN=NRPRIN+1.0#                     Count it as printed              PS36  31
#                                                                       PS36  32
RETURN#                                                                 PS36  33
END#                                                                    PS36  34
systemheader:(PS44)#                                                    PS44   1
####################################################################### PS44   2
#                                                                     # PS44   3
#                              PS44                                   # PS44   4
#                                                                     # PS44   5
####################################################################### PS44   6
SUBROUTINE PS44#                       Subroutine to list               PS44   7
#                                         Reflection counts.            PS44   8
include:(AACOMN)#                                                       PS44   9
include:(PSCOMN)#                                                       PS44  10
#                                                                       PS44  11
REAL DSPACE#                           Temporary value for d spacing    PS44  12
INTEGER J,K,L,N#                       Pointers and indices             PS44  13
REAL SINTOL#                           " value for sin(theta)/lambda    PS44  14
chardata:(PS443, COUNTS OF REJECTED REFLECTIONS)#                       PS44  15
chardata:(PS444,        SIN(THETA)/LAMBDA)#                             PS44  16
chardata:(PS445,        H  K  L)#                                       PS44  17
chardata:(PS449,        PHASE NOT PRESENT IN ONE OR BOTH SETS)#         PS44  18
chardata:(PS44A, REFLECTION COUNTS)#                                    PS44  19
chardata:(PS44B,        READ FROM BDF)#                                 PS44  20
chardata:(PS44C,        USED FOR STATISTICS)#                           PS44  21
chardata:(PS44L,        PRINTED ON OUTPUT)#                             PS44  22
chardata:(PS44M,        ON FILE AA1)#                                   PS44  23
chardata:(PS44N,        ON FILE AA2)#                                   PS44  24
chardata:(PS44D, TO )#                                                  PS44  25
realdata:(FORMP,[60512.,150512.,290713.,430713.,570713.,710713.])#      PS44  26
chardata:(PS44E,     PHI RANGE    PHASE SET 1   PHASE SET 2   $#        PS44  27
DIFFERENCES   WEIGHTED DIFF.)#                                          PS44  28
chardata:(PS44F,                  NUMBER IN     NUMBER IN     $#        PS44  29
NUMBER OF     NUMBER OF)#                                               PS44  30
realdata:(FORAV,[120612.,260612.,420612.,570622.,710612.,$#             PS44  31
930622.,1070713.])#                                                     PS44  32
chardata:(PS44G, AVERAGE OF    AVERAGE OF    AVERAGE PHASE  $#          PS44  33
EST. STD. DEV.  AV WEIGHTED    STD. DEV. WEIGHTED  NUMBER OF)#          PS44  34
chardata:(PS44H, PHASE SET 1   PHASE SET 2   DIFFERENCE     $#          PS44  35
OF DIFFERENCE   DIFFERENCES    DIFFERENCE          MEASUREMENTS)#       PS44  36
chardata:(PS44I,[ STATISTICS IN RANGE D = XX.XX TO XX.XX  STOL = $#     PS44  37
X.XXX TO X.XXX ])#                                                      PS44  38
chardata:(PS44J,[ SUMMARY OF PHASE DIFFERENCES AS A FUNCTION OF $#      PS44  39
RESOLUTION-])#                                                          PS44  40
chardata:(PS44K,[     D RANGE  STOL RANGE    NUMBER   AVERAGE   $#      PS44  41
SIGMA   WT. AVE.   SIG. WT. AVE.])#                                     PS44  42
realdata:(NUMBER,[1.,2.])#             Real data set numbers            PS44  43
realdata:(FMTK,[60522.,120522.,180532.,240532.,340713.,440812.,$#       PS44  44
520822.,620812.,780822.])#                                              PS44  45
realdata:(FMT541,[70613.,240113.,630113.])# Formats                     PS44  46
realdata:(FMT44I,[300522.,390522.,530532.,620532.])#                    PS44  47
datastuff:#                                                             PS44  48
#                                                                       PS44  49
LINRM=10 ; writeline:(1,PS44A,NPS44A,3,3)#                              PS44  50
BUFOT(1) = NRFIN#                                                       PS44  51
ncodefld:(BUFOT,1,PS44B,FMT541(1),1)#                                   PS44  52
writeline:(0,PS44B,NPS44B,3,3)#                                         PS44  53
BUFOT(1)=0.0 ; DO J=1,SHLNUM ; BUFOT(1)=BUFOT(1)+NRUSED(J)# Grand tot   PS44  54
ncodefld:(BUFOT,1,PS44C,FMT541(1),1)#                                   PS44  55
writeline:(0,PS44C,NPS44C,3,3)#                                         PS44  56
BUFOT(1) = NRPRIN#                                                      PS44  57
ncodefld:(BUFOT,1,PS44L,FMT541(1),1) ; writeline:(0,PS44L,NPS44L,3,3)#  PS44  58
BUFOT(1) = NRA#                                                         PS44  59
ncodefld:(BUFOT,1,PS44M,FMT541(1),1) ; writeline:(0,PS44M,NPS44M,3,3)#  PS44  60
BUFOT(1) = NRB#                                                         PS44  61
ncodefld:(BUFOT,1,PS44N,FMT541(1),1) ; writeline:(0,PS44N,NPS44N,3,3)#  PS44  62
writeline:(1,PS443,NPS443,3,3)#                                         PS44  63
BUFOT(1) = NREJST#                                                      PS44  64
ncodefld:(BUFOT,1,PS444,FMT541(1),1)#                                   PS44  65
writeline:(0,PS444,NPS444,3,3)#                                         PS44  66
BUFOT(1) = NREJH#                                                       PS44  67
ncodefld:(BUFOT,1,PS445,FMT541(1),1)#                                   PS44  68
writeline:(0,PS445,NPS445,3,3)#                                         PS44  69
BUFOT(1) = NREJPH#                                                      PS44  70
ncodefld:(BUFOT,1,PS449,FMT541(1),1)#                                   PS44  71
writeline:(0,PS449,NPS449,3,3)#                                         PS44  72
#                                                                       PS44  73
# WRITE SUMMARIES OF STATISTICS FOR SHELLS OF RECIPROCAL SPACE          PS44  74
# ------------------------------------------------------------          PS44  75
#                                                                       PS44  76
LINRM=SHLNUM+5 ; writeline:(3,PS44J,NPS44J,3,3) ; LINRM=2#              PS44  77
SINTOL=SMALST ; DSPACE=0.5/AMAX1(.011,SMALST)# Set starting values      PS44  78
FOR(K=1;K<=SHLNUM;K=K+1)#              Loop over all shells             PS44  79
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PS44  80
BUFOT(1)=DSPACE ; BUFOT(3)=SINTOL#                                      PS44  81
SINTOL=DELSHL(K) ; DSPACE=0.5/AMAX1(0.00101,SINTOL)# Advance shell      PS44  82
BUFOT(4)=SINTOL-0.001 ; BUFOT(2)=DSPACE+0.01#                           PS44  83
#                                                                       PS44  84
# WRITE OUT AVERAGES FOR DIFFERENCES                                    PS44  85
# ----------------------------------                                    PS44  86
#                                                                       PS44  87
BUFOT(5)=NRUSED(K)#                    Number of reflections in set     PS44  88
BUFOT(6)=AVDEL(K)/AMAX1(1.0,NRUSED(K))# Average of deltas               PS44  89
BUFOT(7)=SQRT(ABS((NRUSED(K)*AVDEL2(K)-AVDEL(K)**2))/$#                 PS44  90
AMAX1(1.0,NRUSED(K)*(NRUSED(K)-1.0)))# Esd of deltas                    PS44  91
BUFOT(8)=AVWDE(K)/AMAX1(1.0,NRUSED(K))# Average of deltas               PS44  92
BUFOT(9)=SQRT(ABS((NRUSED(K)*AVWDE2(K)-AVWDE(K)**2))/$#                 PS44  93
AMAX1(1.0,NRUSED(K)*(NRUSED(K)-1.0)))# Esd of deltas                    PS44  94
ncodefld:(BUFOT,1,CHROT,FMTK,9) ; writeline:(0,PS44K,NPS44K,1,3)#       PS44  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PS44  96
#                                                                       PS44  97
# NOW WRITE COMPLETE SUMMARY OF ANGLES AND DIFFERENCES                  PS44  98
# ----------------------------------------------------                  PS44  99
#                                                                       PS44 100
SINTOL=SMALST ; DSPACE=0.5/AMAX1(.011,SMALST)# Set starting values      PS44 101
FOR(K=1;K<=SHLNUM;K=K+1)#              Loop over all shells             PS44 102
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PS44 103
LINRM=10 ; BUFOT(1)=DSPACE ; BUFOT(3)=SINTOL#                           PS44 104
SINTOL=DELSHL(K) ; DSPACE=0.5/AMAX1(0.00101,SINTOL)# Advance shell      PS44 105
BUFOT(4)=SINTOL-0.001 ; BUFOT(2)=DSPACE+0.01#                           PS44 106
ncodefld:(BUFOT,1,PS44I,FMT44I,4) ; writeline:(3,PS44I,NPS44I,3,3)#     PS44 107
#                                                                       PS44 108
# WRITE SUMMARY OF COUNTS OF REFLECTIONS IN RANGES OF PHI               PS44 109
# -------------------------------------------------------               PS44 110
#                                                                       PS44 111
PHIOUT=-0.5*BINSIZ ; LINRM=10 ; writeline:(1,PS44F,NPS44F,3,3)#         PS44 112
LINRM=3 ; FOR(J=1;J<=NBIN;J=J+1)#      Loop over all bins               PS44 113
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PS44 114
L=(J-1)*STEPB+(K-1)*4+MARKB#           Point to correct set             PS44 115
BUFOT(1)=PHIOUT ; PHIOUT=PHIOUT+BINSIZ ; BUFOT(2)=PHIOUT#               PS44 116
BUFOT(3)=QX(L+1) ; BUFOT(4)=QX(L+2) ; N=4#                              PS44 117
IF(J<=NBIN/2+1)#                       For deltas only do to 180 deg.   PS44 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PS44 119
N=6 ; BUFOT(5)=QX(L+3) ; BUFOT(6)=QX(L+4)#                              PS44 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PS44 121
movechar:(PS44D,1,CHROT,7,NPS44D,0)#   Put "to" in line                 PS44 122
ncodefld:(BUFOT,1,CHROT,FORMP,N) ; writeline:(0,PS44E,NPS44E,1,3)#      PS44 123
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PS44 124
#                                                                       PS44 125
# WRITE OUT AVERAGES FOR ANGLES AND DIFFERENCES                         PS44 126
# ---------------------------------------------                         PS44 127
#                                                                       PS44 128
LINRM=5 ; writeline:(1,PS44G,NPS44G,3,3)  ; LINRM=2#                    PS44 129
BUFOT(1)=AVP1(K)/AMAX1(1.0,NRUSED(K))# Average of set 1                 PS44 130
BUFOT(2)=AVP2(K)/AMAX1(1.0,NRUSED(K))# Average of set 2                 PS44 131
BUFOT(3)=AVDEL(K)/AMAX1(1.0,NRUSED(K))# Average of deltas               PS44 132
BUFOT(4)=SQRT(ABS((NRUSED(K)*AVDEL2(K)-AVDEL(K)**2))/$#                 PS44 133
AMAX1(1.0,NRUSED(K)*(NRUSED(K)-1.0)))# Esd of deltas                    PS44 134
BUFOT(5)=AVWDE(K)/AMAX1(1.0,NRUSED(K))# Average of deltas               PS44 135
BUFOT(6)=SQRT(ABS((NRUSED(K)*AVWDE2(K)-AVWDE(K)**2))/$#                 PS44 136
AMAX1(1.0,NRUSED(K)*(NRUSED(K)-1.0)))# Esd of deltas                    PS44 137
BUFOT(7)=NRUSED(K)#                                                     PS44 138
ncodefld:(BUFOT,1,CHROT,FORAV,7) ; writeline:(0,PS44H,NPS44H,1,3)#      PS44 139
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PS44 140
#                                                                       PS44 141
readwpkt:(1,endrecord:,I,J,0)#         Close off bdf phase set 1        PS44 142
readwpkt:(3,endrecord:,I,J,0)#         Close off bdf phase set 3        PS44 143
#                                                                       PS44 144
RETURN#                                                                 PS44 145
END#                                                                    PS44 146
pmacro:([no:])#                        Purge xtal system macros         PS44 147
