systemheader:(RC    )#                 Calculate r values               RC     1
####################################################################    RC     2
#                                                                  #    RC     3
#                        *** RCALC ***                             #    RC     4
#                                                                  #    RC     5
#    RCALC CALCULATES R-FACTORS BETWEEN ITEMS ON THE BDF.          #    RC     6
#                                                                  #    RC     7
####################################################################    RC     8
#                                                                       RC     9
include:(XMACRO)#                                                       RC    10
#                                                                       RC    11
extrude:(RCCOMN)#                                                       RC    12
INTEGER NSBIN#                         Number of stol bins              RC    13
INTEGER NIBIN#                         Number of intensity bins         RC    14
INTEGER NGBIN#                         Number of scale group bins       RC    15
INTEGER PRON#                          Print flag for output            RC    16
INTEGER ID1#                           Id number for first item         RC    17
INTEGER ID2#                           Id number for second item        RC    18
INTEGER IGRP#                          Id number of scale group         RC    19
INTEGER RANK1#                         Of largest (id1-id2) to prt      RC    20
INTEGER RANK2#                         Of largest (id1-sc*id2) to p     RC    21
INTEGER MAXGRP#                        Maximum no. of individula sc     RC    22
INTEGER MAXI#                          Maximum intensity value          RC    23
INTEGER MAXH(3)#                       Max hkl                          RC    24
INTEGER RCODE,NRCODE,RJCODE#           Reflection select codes          RC    25
INTEGER GRPPNT#                        Group scale want list positi     RC    26
INTEGER SIGPNT#                        Sigma want list position in      RC    27
INTEGER RCOPNT#                        Rcode want list position in      RC    28
INTEGER SCLGRP#                        Scale group of current refle     RC    29
COMMON /COMIRC/ MAXH, RCODE, NRCODE, RJCODE, $#                         RC    30
NSBIN, NIBIN, NGBIN, PRON, ID1, ID2, MAXI, RANK1, RANK2, $#             RC    31
GRPPNT, SIGPNT, RCOPNT, IGRP, SCLGRP, MAXGRP#                           RC    32
REAL SCALE(64)#                        Group scales for id1 to id2      RC    33
REAL ITEM1#                            Item1 value from lrrefl          RC    34
REAL ITEM2#                            Item2 value from lrrefl          RC    35
REAL AC#                                                                RC    36
REAL BC#                                                                RC    37
REAL SS#                                                                RC    38
REAL FACTOR#                                                            RC    39
REAL WAYT#                                                              RC    40
REAL DIF#                                                               RC    41
REAL SCFO#                                                              RC    42
REAL SLIMIT#                                                            RC    43
REAL RESOL(25)#                                                         RC    44
REAL STMAX,STMIN#                                                       RC    45
COMMON /COMFRC/ ITEM1, ITEM2, AC,BC, SS, WAYT, DIF, SCFO,$#             RC    46
SCALE, SLIMIT, RESOL, FACTOR, STMIN, STMAX#                             RC    47
endext:#                                                                RC    48
#                                                                       RC    49
systemheader:(RC00)#                   Calculate r values               RC00   1
# ################################################################## #  RC00   2
#                                                                    #  RC00   3
#                               RC00                                 #  RC00   4
#                                                                    #  RC00   5
# ################################################################## #  RC00   6
SUBROUTINE RC00#                       K.d.watenpaugh 1985              RC00   7
#                                      Calculate r values               RC00   8
include:(AACOMN)#                                                       RC00   9
include:(RCCOMN)#                                                       RC00  10
INTEGER I,IP,NPAK#                                                      RC00  11
INTEGER IWNT(8),IREL(9),KEY(4)#                                         RC00  12
INTEGER ADDBIG#                        Flag to add value to bigdif      RC00  13
INTEGER BIGHKL(1000,3)#                Hkl for top item differnces      RC00  14
INTEGER BIGSRT(1000)#                  Hkl for top item differnces      RC00  15
INTEGER RANK#                          Rank number                      RC00  16
INTEGER DORANK#                        Flag to calc rank listing        RC00  17
REAL BIGID1(1000)#                     Top largest item differnces      RC00  18
REAL BIGID2(1000)#                     Top largest item differnces      RC00  19
REAL BIGDIF(1000)#                     Top largest item differnces      RC00  20
REAL X(400)#                           Large array of summed values     RC00  21
REAL X2(400)#                                                           RC00  22
REAL X3(64)#                                                            RC00  23
REAL HKL(3)#                                                            RC00  24
REAL  SPACE(25), SPACE2(100)#                                           RC00  25
REAL  SPACE3(65)#                                                       RC00  26
#                                                                       RC00  27
chardata:(RC1,[        RESOLUTION         COUNT     NUMERATOR$#         RC00  28
   DENOMINATOR   R FACTOR  RESCALE])#                                   RC00  29
chardata:(RC2,[        MAGNITUDE          COUNT     NUMERATOR$#         RC00  30
   DENOMINATOR   R FACTOR   RESCALE])#                                  RC00  31
chardata:(RC3,[      SCALE GROUP          COUNT     NUMERATOR$#         RC00  32
   DENOMINATOR   R FACTOR   SCALE])#                                    RC00  33
chardata:(RC4,[ SIN(THETA/LAM) MIN MAX                            ])#   RC00  34
chardata:(RC5,[ MAX H K L                                         ])#   RC00  35
chardata:(RC6,[ SCALE                                             ])#   RC00  36
DATA SPACE/0.000,0.0025,.01,.0156,.0278,.0625,19*0.0/#                  RC00  37
datastuff:#                                                             RC00  38
#                                                                       RC00  39
#    READ INPUT LINES                                                   RC00  40
#    ----------------                                                   RC00  41
CALL RC02#                             Read input lines                 RC00  42
#                                                                       RC00  43
#    INITIALIZE IWNT LIST USING OPTIONS FROM RCALC LINE                 RC00  44
#    --------------------------------------------------                 RC00  45
#                                                                       RC00  46
DO I=1,3; IWNT(I)=I#                   Hkl, stol, mult                  RC00  47
IWNT(4) = ID1#                         Values to be used in rcalc       RC00  48
IWNT(5) = ID2#                                                          RC00  49
NIWNT = 5#                                                              RC00  50
RANK=0;#                                                                RC00  51
IF (MAXGRP>1&IGRP==0) IGRP=1309#                                        RC00  52
IF (IGRP!=0)#                          Want group scale indicator       RC00  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RC00  54
NIWNT = NIWNT + 1#                                                      RC00  55
GRPPNT = NIWNT#                                                         RC00  56
IWNT(NIWNT) = IGRP#                                                     RC00  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RC00  58
IF (SLIMIT!=0.0)#                      Want to use sigma cutoff         RC00  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RC00  60
NIWNT = NIWNT+1#                                                        RC00  61
SIGPNT = NIWNT#                                                         RC00  62
IWNT(NIWNT) = IWNT(4)+1#               Hope this is the sigma           RC00  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RC00  64
ELSE IF (RJCODE!=0)#                   Want to use rcode                RC00  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RC00  66
NIWNT = NIWNT+1#                                                        RC00  67
RCOPNT = NIWNT#                                                         RC00  68
IWNT(NIWNT)=NRCODE#                                                     RC00  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RC00  70
#                                                                       RC00  71
#    FIGURE INTERVALS FOR SCALE GROUP BINS                              RC00  72
#    -----------------------------------                                RC00  73
#                                                                       RC00  74
SPACE3(1) = 0.0#                                                        RC00  75
DO I=1,MAXGRP#                                                          RC00  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RC00  77
SPACE3(I) = FLOAT(I)#                                                   RC00  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RC00  79
NGBIN = MAXGRP#                                                         RC00  80
#                                                                       RC00  81
#    FIGURE INTERVALS FOR INTENSITY BINS                                RC00  82
#    -----------------------------------                                RC00  83
#                                                                       RC00  84
SPACE2(1) = 0.0#                                                        RC00  85
DO I=2,MAXI#                                                            RC00  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RC00  87
SPACE2(I) = FACTOR*(2**(I-1))#                                          RC00  88
NIBIN = I#                                                              RC00  89
IF(SPACE2(I)>MAXI) BREAK#                                               RC00  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RC00  91
#                                                                       RC00  92
#    FIGURE INTERVALS FOR STOL**2 BINS                                  RC00  93
#    -----------------------------------                                RC00  94
#                                                                       RC00  95
IF(NSBIN!=0)#                          Calculate stol bins              RC00  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RC00  97
SPACE(1)=0.0#                          Infinity is upper bound          RC00  98
DO I=1,NSBIN#                                                           RC00  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RC00 100
IF(RESOL(I)!=0.0) SPACE(I+1) = 1.0/(RESOL(I)*2)**2#                     RC00 101
ELSE iquit:(RC0003)#                   Zero resolution not allowed      RC00 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RC00 103
NSBIN = NSBIN+1#                       Allow for added infinity bin     RC00 104
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RC00 105
ELSE NSBIN = 6#                        Default, use 6 bins              RC00 106
#                                                                       RC00 107
#    SET IO BUFFERS                                                     RC00 108
#    --------------                                                     RC00 109
#                                                                       RC00 110
IOMARK(1)=QXSTR#                       Start of buffer for file a       RC00 111
incrqx:(MARK,IOMARK(1)+bdfbuf:,RC0004)# Incr memory.....                RC00 112
#                                                                       RC00 113
#    WRITE OUT RUN INFORMATION                                          RC00 114
#    --------------------------                                         RC00 115
WRITE(6,*) ; WRITE(6,*)#                                                RC00 116
WRITE(6,*) 'OPTIONS:'#                                                  RC00 117
WRITE(6,*) '======='#                                                   RC00 118
WRITE(6,*)#                                                             RC00 119
WRITE(6,*) 'COMPARISON ITEMS USED IN R-FACTOR: ',ID1,' AND ',ID2#       RC00 120
WRITE(6,*)#                                                             RC00 121
WRITE(6,*) 'GROUP SCALE FACTOR ITEM: ',IGRP#                            RC00 122
WRITE(6,*)#                                                             RC00 123
WRITE(6,*) 'RANK COUNT FOR LARGEST |ITEM1-ITEM2| VALUES:', RANK1#       RC00 124
WRITE(6,*)#                                                             RC00 125
WRITE(6,*) 'RANK COUNT FOR LARGEST |ITEM1*SC-ITEM2| VALUES:', RANK2#    RC00 126
WRITE(6,65) RJCODE,NRCODE#                                              RC00 127
65    FORMAT(/' USE RCODE',I2,' REFLECTIONS FOR BDF ITEM',I5)#          RC00 128
WRITE(6,70) (IWNT(I),I=1,NIWNT)#                                        RC00 129
70    FORMAT(/' ','ITEMS REQUESTED FROM INPUT BDF',/,7I10)#             RC00 130
WRITE(6,*)#                                                             RC00 131
STFMT = 340642.#                                                        RC00 132
ncodefld:(STMIN,1,RC4,STFMT,1)#        Format min st/l                  RC00 133
ncodefld:(STMAX,1,RC4,STFMT+80000.,1)# Format max st/l                  RC00 134
writeline:(1,RC4,NRC4,3,3)#            Print min/max st/l               RC00 135
STFMT = 340613.#                                                        RC00 136
ncodefld:(FLOAT(MAXH(1)),1,RC5,STFMT,1)# Format max hkl                 RC00 137
ncodefld:(FLOAT(MAXH(2)),1,RC5,STFMT+80000.,1)#                         RC00 138
ncodefld:(FLOAT(MAXH(3)),1,RC5,STFMT+160000.,1)#                        RC00 139
writeline:(1,RC5,NRC5,3,3)#            Print max hkl                    RC00 140
#                                                                       RC00 141
#    SEARCH DIRECTORY OF LRREFL:                                        RC00 142
#    ---------------------------                                        RC00 143
NBIN = NSBIN#                                                           RC00 144
# *** X IS THE ALL-PURPOSE ARRAY FOR STOL RUN***                        RC00 145
IXD = NBIN#                            Denom ptr into x array           RC00 146
IXS = NBIN*2#                          Summation ptr into x array       RC00 147
IRN = NBIN*3#                          Bin count ptr into x             RC00 148
ISC = NBIN*4#                          Scale ptr into x array           RC00 149
#                                                                       RC00 150
NBIN2 = NIBIN#                                                          RC00 151
# *** X2 IS THE ALL-PURPOSE ARRAY FOR INTENSITY RUN ***                 RC00 152
IXD2 = NBIN2#                          Denom ptr into x array           RC00 153
IXS2 = NBIN2*2#                        Summation ptr into x array       RC00 154
IRN2 = NBIN2*3#                        Bin count ptr into x             RC00 155
ISC2 = NBIN2*4#                        Scale ptr into x array           RC00 156
#                                                                       RC00 157
NBIN3 = NGBIN#                                                          RC00 158
# *** X3 IS THE ALL-PURPOSE ARRAY FOR GROUP SCALE RUN ***               RC00 159
IXD3 = NBIN3#                          Denom ptr into x array           RC00 160
IXS3 = NBIN3*2#                        Summation ptr into x array       RC00 161
IRN3 = NBIN3*3#                        Bin count ptr into x             RC00 162
ISC3 = NBIN3*4#                        Scale ptr into x array           RC00 163
#                                                                       RC00 164
#    INITIALIZE SCALES FOR FIRST LOOP                                   RC00 165
#    --------------------------------                                   RC00 166
#                                                                       RC00 167
DO I=1,NBIN#                                                            RC00 168
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RC00 169
X(ISC+I) = 1.0#                                                         RC00 170
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RC00 171
DO I=1,NBIN2#                                                           RC00 172
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RC00 173
X2(ISC2+I) = 1.0#                                                       RC00 174
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RC00 175
DO I=1,NBIN3#                                                           RC00 176
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RC00 177
X3(ISC3+I) = 1.0#                                                       RC00 178
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RC00 179
#                                                                       RC00 180
#================================================                       RC00 181
#   LOOP TWICE TIMES THRU DATA                                          RC00 182
#       FIRST LOOP: USE INPUT SCALES; BINS USE OVERALL SCALES           RC00 183
#       SECOND LOOP: USE REVISED BIN SCALES                             RC00 184
#       IF USING GROUP SCALES AND BIN RESCALES FAR FROM 1.0 ON SECOND   RC00 185
#          PASS, YOU MAY WANT TO INPUT SCALES AND DO ADDTIONAL RUN.     RC00 186
#                                                                       RC00 187
#================================================                       RC00 188
#                                                                       RC00 189
DO ITIME=1,2#                                                           RC00 190
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RC00 191
WRITE(6,*)#                                                             RC00 192
WRITE(6,*) ' SCALE GROUP:  SCALE'#                                      RC00 193
IF (MAXGRP==1 & SCALE(1)<=0.0) SCALE(1) = 1.0#                          RC00 194
DO I=1,MAXGRP#                                                          RC00 195
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RC00 196
ifnv:(SCALE(I)) WRITE(6,*) I,SCALE(I)#                                  RC00 197
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RC00 198
IF(ITIME==1)#                          Ready to calc unscaled rank      RC00 199
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RC00 200
DO I=1,1000; BIGSRT(I)=I#              Initialize big list              RC00 201
RANK=RANK1#                            Number of diffs to rank          RC00 202
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RC00 203
ELSE#                                  Ready to calc scaled rank        RC00 204
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RC00 205
DO I=1,1000; BIGSRT(I)=I#              Initialize big list              RC00 206
RANK=RANK2#                            Number of diffs to rank          RC00 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RC00 208
IF(RANK>0) DORANK=1#                   Yes, rank list wanted            RC00 209
ELSE       DORANK=0#                   No, rank list not wanted         RC00 210
NDIFF=0#                               No ranked diffs yet              RC00 211
IF (PRON==1&ITIME==2)#                                                  RC00 212
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RC00 213
WRITE(6,15)#                                                            RC00 214
15    FORMAT('   H    K    L   F(OBS) F(CALC)  A(CALC)  B(CALC)   SS')# RC00 215
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RC00 216
#                                                                       RC00 217
#    INITIALIZE SUMMED QUANTITIES TO 0 (EXCEPT FOR SCALES               RC00 218
#    ----------------------------------------------------               RC00 219
#                                                                       RC00 220
DO I=1,ISC#                                                             RC00 221
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RC00 222
X(I) = 0.0#                                                             RC00 223
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RC00 224
DO I=1,ISC2#                                                            RC00 225
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RC00 226
X2(I) = 0.0#                                                            RC00 227
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RC00 228
DO I=1,ISC3#                                                            RC00 229
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RC00 230
X3(I) = 0.0#                                                            RC00 231
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RC00 232
#                                                                       RC00 233
#    READ FROM INPUT BDF                                                RC00 234
#    -------------------                                                RC00 235
#                                                                       RC00 236
RCODE = 0#                                                              RC00 237
KEY(1)=NIWNT; KEY(2)=NIWNT; KEY(3)=NIWNT; KEY(4)=0# Set search keys     RC00 238
IWNT(1) = 1#                           Reset from previous use          RC00 239
indexpkt:(1,lrrefl:,NPAK,IP,2,KEY,IWNT,IREL)# Search lrrefl directory   RC00 240
IF(KEY(4)<=0) iquit:(RC0001)#          Items not found...               RC00 241
#                                                                       RC00 242
#    ENTER LRREFL: BDF RECORDS                                          RC00 243
#    -------------------------                                          RC00 244
REPEAT#                                Loop over lrrefl records         RC00 245
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 RC00 246
readwpkt:(1,lrrefl:,NPAK,IP,0)#        Point to ip packet               RC00 247
IF(IP<=0) BREAK#                       Exit reflection loop             RC00 248
#                                                                       RC00 249
#    READ LRREFL PACKET                                                 RC00 250
#    ------------------                                                 RC00 251
#                                                                       RC00 252
gethkl:(IREL(1)+IP,HKL)#                                                RC00 253
#                                                                       RC00 254
#  DISCARD REFLECTIONS WITHOUT ENOUGH INFO                              RC00 255
#  ----------------------------------------                             RC00 256
ITEM1 = QX(IREL(4)+IP)#                                                 RC00 257
ifvo:(ITEM1) NEXT#                     Void item1 value                 RC00 258
ITEM2 = QX(IREL(5)+IP)#                                                 RC00 259
ifvo:(ITEM2) NEXT#                     Void item2 value                 RC00 260
SS = QX(IREL(2)+IP)#                   Stol value from bdf              RC00 261
DO I=1,3; IF (HKL(I)>MAXH(I)) NEXT#    Hkl out of range                 RC00 262
IF (SS< STMIN \ SS>STMAX) NEXT#        Stol out of range                RC00 263
SS = SS**2#                                                             RC00 264
IF (GRPPNT!=0)#                        Get scale group of reflectio     RC00 265
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 RC00 266
SCLGRP = NINT(QX(IREL(GRPPNT)+IP))#                                     RC00 267
ifvo:(SCALE(SCLGRP)) NEXT#             Use requested scale groups       RC00 268
# THEN USE ONLY THOSE.                                                  RC00 269
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 RC00 270
ELSE SCLGRP = 1#                                                        RC00 271
ITEM1 = ITEM1*SCALE(SCLGRP)#                                            RC00 272
IF (SIGPNT!=0)#                                                         RC00 273
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 RC00 274
SIGMA = SCALE(SCLGRP)*QX(IREL(SIGPNT)+IP)#                              RC00 275
IF (ITEM1<SLIMIT*SIGMA) NEXT#                                           RC00 276
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 RC00 277
IF (RCOPNT!=0) RCODE=INT(QX(IREL(RCOPNT)+IP))#                          RC00 278
IF (RCODE!=RJCODE) NEXT#                                                RC00 279
#                                                                       RC00 280
#    FIND LARGEST ITEM DIFFERENCE                                       RC00 281
#    ----------------------------                                       RC00 282
#   FIRST TIME THRU DATA, CALCULATE LARGEST RAW ITEM DIFFERENCES.       RC00 283
#   SECOND TIME THRU DATA, CALCULATE LARGEST SCALED ITEM DIFFERNCES.    RC00 284
#                                                                       RC00 285
IF( DORANK==1)#                                                         RC00 286
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 RC00 287
ADDBIG=0#                                                               RC00 288
DIFF = ABS(ITEM1 - ITEM2)#             Difference between items         RC00 289
IF(NDIFF<RANK)#                        More room in top list?           RC00 290
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 RC00 291
NDIFF=NDIFF+1#                         Room to add more to top list     RC00 292
IF(NDIFF==1)#                          First element in top list        RC00 293
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 RC00 294
ADDBIG=0#                                                               RC00 295
BIGDIF(NDIFF)=DIFF#                    Newest diff assumes pos          RC00 296
BIGHKL(NDIFF,1)=HKL(1)#                Newest diff assumes pos          RC00 297
BIGHKL(NDIFF,2)=HKL(2)#                Newest diff assumes pos          RC00 298
BIGHKL(NDIFF,3)=HKL(3)#                Newest diff assumes pos          RC00 299
BIGID1(NDIFF)=ITEM1#                   Newest diff assumes pos          RC00 300
BIGID2(NDIFF)=ITEM2#                   Newest diff assumes pos          RC00 301
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 RC00 302
ELSE ADDBIG=1#                                                          RC00 303
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 RC00 304
ELSE#                                  Top list full, but should        RC00 305
#                                   WE ADD CURRENT DIFFERNCE?           RC00 306
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 RC00 307
IF(DIFF>=BIGDIF(BIGSRT(NDIFF))) ADDBIG=1# Is difference one of bigges   RC00 308
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 RC00 309
IF(ADDBIG==1)#                         Add differnce to list            RC00 310
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 RC00 311
IWHICH=BIGSRT(NDIFF)#                  Index of smallest top val        RC00 312
BIGDIF(IWHICH)=DIFF#                   Newest diff assumes pos          RC00 313
BIGHKL(IWHICH,1)=HKL(1)#               Newest diff assumes pos          RC00 314
BIGHKL(IWHICH,2)=HKL(2)#               Newest diff assumes pos          RC00 315
BIGHKL(IWHICH,3)=HKL(3)#               Newest diff assumes pos          RC00 316
BIGID1(IWHICH)=ITEM1#                  Newest diff assumes pos          RC00 317
BIGID2(IWHICH)=ITEM2#                  Newest diff assumes pos          RC00 318
DO II=1,NDIFF-1#                       Look thru top list               RC00 319
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 RC00 320
IF(BIGDIF(BIGSRT(II))<=DIFF)#          Found position for diff?         RC00 321
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 RC00 322
DO JJ=NDIFF,II+1,-1; BIGSRT(JJ)=BIGSRT(JJ-1)# Rearrange top list        RC00 323
BIGSRT(II)=IWHICH#                     Point to last added item         RC00 324
BREAK#                                 Get out - done the job           RC00 325
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 RC00 326
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 RC00 327
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 RC00 328
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 RC00 329
#                                                                       RC00 330
#    GROUP DATA BY STOL VALUES                                          RC00 331
#    -------------------------                                          RC00 332
DO I=1,NBIN-1#                         For each bin ...                 RC00 333
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 RC00 334
IF (SS < SPACE(I+1))#                  Data belong in current bin?#     RC00 335
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 RC00 336
CALL RC01(I,IXD,IXS,IRN,ISC,X)#        Update statistics for bin        RC00 337
CALL RC01(NBIN,IXD,IXS,IRN,ISC,X)#     Update statistics for bin        RC00 338
BREAK#                                                                  RC00 339
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 RC00 340
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 RC00 341
#                                                                       RC00 342
#    GROUP DATA BY INTENSITIES                                          RC00 343
#    -------------------------                                          RC00 344
DO I=1,NBIN2-1#                        For each bin ...                 RC00 345
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 RC00 346
IF (ITEM1 < SPACE2(I+1))#              Data belong in current bin?#     RC00 347
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 RC00 348
CALL RC01(I,IXD2,IXS2,IRN2,ISC2,X2)#   Update statistics for bin        RC00 349
CALL RC01(NBIN2,IXD2,IXS2,IRN2,ISC2,X2)# Update statistics for bin      RC00 350
BREAK#                                                                  RC00 351
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 RC00 352
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 RC00 353
#                                                                       RC00 354
#    GROUP DATA BY SCALE FACTOR GROUP                                   RC00 355
#    -------------------------                                          RC00 356
ifnv:(SCALE(SCLGRP))#                                                   RC00 357
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 RC00 358
CALL RC01(SCLGRP,IXD3,IXS3,IRN3,ISC3,X3)# Update statistics for bin     RC00 359
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 RC00 360
#                                                                       RC00 361
IF (PRON!=0 & ITIME==2)#                                                RC00 362
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 RC00 363
WRITE(6,75) HKL(1),HKL(2),HKL(3),ITEM1,ITEM2,ITEM2,AC,BC,SS#            RC00 364
75    FORMAT(3F5.0,5F8.1,F8.4)#                                         RC00 365
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 RC00 366
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 RC00 367
#                                                                       RC00 368
#    OUTPUT FOR STOL GROUPED DATA                                       RC00 369
#    -----------------------------                                      RC00 370
#                                                                       RC00 371
WRITE(6,*)#                                                             RC00 372
WRITE(6,*)#                                                             RC00 373
WRITE(6,*)#                                                             RC00 374
WRITE(6,*)#                                                             RC00 375
WRITE(6,*)RC1#                                                          RC00 376
DO I=1,NBIN#                                                            RC00 377
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 RC00 378
IF(X(IXD+I)<1.0) X(IXD+I)=1.0#                                          RC00 379
IF (X(IRN+I)<=0.0) R=-1.0#                                              RC00 380
ELSE R = X(IXS+I)/X(IXD+I)#                                             RC00 381
IF(I!=NBIN)#                                                            RC00 382
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 RC00 383
IF(SPACE(I)!=0)#                                                        RC00 384
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 RC00 385
RESOL1 = 0.5/SQRT(SPACE(I))#                                            RC00 386
RESOL2 = 0.5/SQRT(SPACE(I+1))#                                          RC00 387
WRITE(6,121) RESOL1,RESOL2,X(IRN+I),X(IXS+I),X(IXD+I),R,X(ISC+I)#       RC00 388
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 RC00 389
ELSE#                                                                   RC00 390
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 RC00 391
RESOL2 = 0.5/SQRT(SPACE(I+1))#                                          RC00 392
WRITE(6,122) RESOL2,X(IRN+I),X(IXS+I),X(IXD+I),R,X(ISC+I)#              RC00 393
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 RC00 394
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 RC00 395
ELSE#                                                                   RC00 396
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 RC00 397
RESOL2 = 0.5/SQRT(SPACE(NBIN))#                                         RC00 398
WRITE(6,*)#                                                             RC00 399
WRITE(6,122) RESOL2,X(IRN+I),X(IXS+I),X(IXD+I),R,X(ISC+I)#              RC00 400
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 RC00 401
X(ISC+I) = X(ISC+I)*X(I)/X(IXD+I)#     Next time thru data use this     RC00 402
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 RC00 403
#                                                                       RC00 404
#    OUTPUT FOR INTENSITY GROUPED DATA                                  RC00 405
#    -----------------------------                                      RC00 406
#                                                                       RC00 407
WRITE(6,*)#                                                             RC00 408
WRITE(6,*)#                                                             RC00 409
WRITE(6,*)RC2#                                                          RC00 410
DO I=1,NBIN2#                                                           RC00 411
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 RC00 412
IF (X2(IRN2+I)<=0.0) NEXT#                                              RC00 413
IF(X2(IXD2+I)<1.0) X2(IXD2+I)=1.0#                                      RC00 414
R = X2(IXS2+I)/X2(IXD2+I)#                                              RC00 415
XMEAN1 = X2(I)*X2(ISC2+NBIN2)/(X2(ISC2+I)*X2(IRN2+I))#                  RC00 416
XMEAN2 = X2(IXD2+I)/X2(IRN2+I)#                                         RC00 417
IF(I!=NBIN2)#                                                           RC00 418
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 RC00 419
WRITE(6,121) SPACE2(I),SPACE2(I+1),X2(IRN2+I),$#                        RC00 420
             X2(IXS2+I),X2(IXD2+I),R,X2(ISC2+I),$#                      RC00 421
             XMEAN1,XMEAN2#                                             RC00 422
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 RC00 423
ELSE#                                                                   RC00 424
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 RC00 425
WRITE(6,*)#                                                             RC00 426
WRITE(6,121) SPACE2(1),SPACE2(NBIN2),X2(IRN2+I),$#                      RC00 427
             X2(IXS2+I),X2(IXD2+I),R,X2(ISC2+I),$#                      RC00 428
             XMEAN1,XMEAN2#                                             RC00 429
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 RC00 430
X2(ISC2+I) = X2(ISC2+I)*X2(I)/X2(IXD2+I)#                               RC00 431
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 RC00 432
#                                                                       RC00 433
#    OUTPUT FOR GROUP SCALE DATA                                        RC00 434
#    -----------------------------                                      RC00 435
#                                                                       RC00 436
WRITE(6,*)#                                                             RC00 437
WRITE(6,*)#                                                             RC00 438
WRITE(6,*)RC3#                                                          RC00 439
DO I=1,NBIN3#                                                           RC00 440
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 RC00 441
IF (X3(IRN3+I)<=0.0) NEXT#                                              RC00 442
IF(X3(IXD3+I)<1.0) X3(IXD3+I)=1.0#                                      RC00 443
R = X3(IXS3+I)/X3(IXD3+I)#                                              RC00 444
XMEAN1 = X3(I)*X3(ISC3+NBIN3)/(X3(ISC3+I)*X3(IRN3+I))#                  RC00 445
XMEAN2 = X3(IXD3+I)/X3(IRN3+I)#                                         RC00 446
WRITE(6,123) SPACE3(I),X3(IRN3+I),$#                                    RC00 447
             X3(IXS3+I),X3(IXD3+I),R,SCALE(I),$#                        RC00 448
             XMEAN1,XMEAN2#                                             RC00 449
ifnv:(SCALE(I)) SCALE(I) = SCALE(I)*X3(ISC3+I)*X3(I)/X3(IXD3+I)#        RC00 450
X3(ISC3+I) = 1.0#                                                       RC00 451
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 RC00 452
#                                      #                                RC00 453
#                                                                       RC00 454
#  WRITE OUT TOP LARGEST UNSCALED/SCALED DIFFERNCES                     RC00 455
#  ------------------------------------------------                     RC00 456
#                                                                       RC00 457
IF(DORANK==1 )#                        Put out differnce rank           RC00 458
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 RC00 459
WRITE(6,*)#                                                             RC00 460
IF(ITIME==1)#                          Prepare to prt unscaled rank     RC00 461
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 RC00 462
WRITE(6,111) NDIFF#                    Unscaled differnces              RC00 463
WRITE(6,*)#                                                             RC00 464
WRITE(6,*) '          H           K          L    DIFFERENCE',$#        RC00 465
'       ITEM1           ITEM2'#                                         RC00 466
WRITE(6,*)#                                                             RC00 467
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 RC00 468
IF(ITIME==2)#                          Prepare to prt scaled rank       RC00 469
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 RC00 470
WRITE(6,112) NDIFF#                    Scaled differnces                RC00 471
113 FORMAT(/,'          H           K          L    DIFFERENCE',$#      RC00 472
'       ITEM1*',F6.2,'     ITEM2',/)#                                   RC00 473
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 RC00 474
111 FORMAT(///,' LISTING: ',I4,$#                                       RC00 475
' LARGEST UNSCALED DIFFERENCES',$#                                      RC00 476
/, ' ========')#                                                        RC00 477
112 FORMAT(///,' LISTING: ',I4,$#                                       RC00 478
' LARGEST SCALED DIFFERENCES',$#                                        RC00 479
/, ' ========')#                                                        RC00 480
DO II=1,NDIFF#                         Put out requested number         RC00 481
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 RC00 482
IWHICH=BIGSRT(II)#                     Next largest differnce point     RC00 483
SCADIF=BIGDIF(IWHICH)#                 Scale difference by overall      RC00 484
SCAID2=BIGID2(IWHICH)#                 Scale item2 by overall           RC00 485
WRITE(6,*) (BIGHKL(IWHICH,JJ),JJ=1,3),SCADIF,$#                         RC00 486
BIGID1(IWHICH),SCAID2#                                                  RC00 487
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 RC00 488
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 RC00 489
rewindbdf:(1)#                         Prepare to make another pass     RC00 490
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RC00 491
121  FORMAT (' ',F10.2,' TO',F10.2,F10.0,'   ',2(E10.4,'  '),$#         RC00 492
                 2('  ',F8.4),2F10.2)#                                  RC00 493
122  FORMAT (' ',' INFINITY ',' TO',F10.2,F10.0,'   ',2(E10.4,'  '),$#  RC00 494
                 2('  ',F8.4))#                                         RC00 495
123  FORMAT ('      ',F10.2,'        ',F10.0,'   ',2(E10.4,'  '),$#     RC00 496
                 2('  ',F8.4),2F10.2)#                                  RC00 497
RETURN#                                                                RC00 498
END#                                                                    RC00 499
#                                                                       RC00 500
systemheader:(RC01)#                                                    RC01   1
#################################################################       RC01   2
#                                                                       RC01   3
#                    RC01                                               RC01   4
#                                                                       RC01   5
#################################################################       RC01   6
SUBROUTINE RC01(INDEX,IXD,IXS,IRN,ISC,X)#                               RC01   7
include:(AACOMN)#                                                       RC01   8
include:(RCCOMN)#                                                       RC01   9
#                                                                       RC01  10
INTEGER INDEX#                                                          RC01  11
INTEGER IXD#                           Index to denominator values      RC01  12
INTEGER IXS#                                                            RC01  13
INTEGER IRN#                                                            RC01  14
INTEGER ISC#                                                            RC01  15
REAL X(400)#                                                            RC01  16
datastuff:#                                                             RC01  17
#                                                                       RC01  18
SCVAL = ITEM1*X(INDEX+ISC)#                                             RC01  19
DIF = ABS(ITEM2-SCVAL)#                                                 RC01  20
X(INDEX) = X(INDEX)+ITEM2#                                              RC01  21
X(INDEX+IXD) = X(INDEX+IXD)+SCVAL#                                      RC01  22
X(INDEX+IXS) = X(INDEX+IXS)+DIF#                                        RC01  23
X(INDEX+IRN) = X(INDEX+IRN)+1.#                                         RC01  24
RETURN#                                                                 RC01  25
END#                                                                    RC01  26
#                                                                       RC01  27
systemheader:(RC02)#                   Read input cards                 RC02   1
#                                                                       RC02   2
#################################################################       RC02   3
#                                                                       RC02   4
#                    RC02                                               RC02   5
#                                                                       RC02   6
#################################################################       RC02   7
SUBROUTINE RC02#                                                        RC02   8
include:(AACOMN)#                                                       RC02   9
include:(RCCOMN)#                                                       RC02  10
#                                      #                                RC02  11
chardata:(RC021, END    SCALE  RESOL  RCODE  MAXHKL SLIMIT $#           RC02  12
RANK1  RANK2   )#                                                       RC02  13
datastuff:#                                                             RC02  14
#                                                                       RC02  15
ID1 = 1304; ID2 = 1800; IGRP=0#        Default values for rcalc         RC02  16
MAXI = 1000000#                                                         RC02  17
FACTOR=2.#                                                              RC02  18
MAXGRP=1#                                                               RC02  19
PRON = 0#                                                               RC02  20
NSBIN = 0#                             Default 6 stol bins              RC02  21
RJCODE = 0#                                                             RC02  22
GRPPNT = 0#                                                             RC02  23
SIGPNT = 0#                                                             RC02  24
RCOPNT = 0#                                                             RC02  25
SCLPRP = 0#                                                             RC02  26
RANK1=0#                                                                RC02  27
RANK2=0#                                                                RC02  28
MAXH(1)=999; MAXH(2)=999; MAXH(3)=999# Default max h,k,l                RC02  29
STMIN=0.;    STMAX=2.#                 Default min/max st/l             RC02  30
DO I=1,64#                             Initial all group scales in      RC02  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RC02  32
SCALE(I) = voidflg:#                                                    RC02  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RC02  34
#                                                                       RC02  35
#    DECIPHER RCALC LINE                                                RC02  36
#    -------------------                                                RC02  37
ifnv:(BUFIN(1)) ID1 = NINT(BUFIN(1))#  Wanted specified by input        RC02  38
ifnv:(BUFIN(2)) ID2 = NINT(BUFIN(2))#                                   RC02  39
ifnv:(BUFIN(3)) IGRP = NINT(BUFIN(3))#                                  RC02  40
ifnv:(BUFIN(4)) PRON  = NINT(BUFIN(4))# Print control                   RC02  41
ifnv:(BUFIN(5)) MAXI = NINT(BUFIN(5))#                                  RC02  42
ifnv:(BUFIN(6)) FACTOR = BUFIN(6)#                                      RC02  43
#                                                                       RC02  44
#    READ CONTROL LINES                                                 RC02  45
#    --------------                                                     RC02  46
REPEAT#                                                                 RC02  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RC02  48
readline:(RC021,NRC021)#               Enter control lines              RC02  49
IF(LINID==1) BREAK#                    ******** end *******             RC02  50
ELSE IF(LINID==2)#                     ******** scale *****             RC02  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RC02  52
ifnv:(BUFIN(2))#                                                        RC02  53
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RC02  54
I=NINT(BUFIN(2))#                                                       RC02  55
IF(I>MAXGRP) MAXGRP = I#                                                RC02  56
SCALE(I) = BUFIN(1)#                                                    RC02  57
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RC02  58
ELSE SCALE(1) = BUFIN(1)#                                               RC02  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RC02  60
ELSE IF(LINID==3)#                     ******** resbin ****             RC02  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RC02  62
FOR(INEXT=1;INEXT<25;INEXT=INEXT+1)#                                    RC02  63
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RC02  64
ifnv:(BUFIN(INEXT)) RESOL(INEXT)=BUFIN(INEXT)#                          RC02  65
ifvo:(BUFIN(INEXT)) BREAK#                                              RC02  66
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RC02  67
NSBIN=INEXT-1#                         Number of stol bins              RC02  68
IF (NSBIN>1)#                                                           RC02  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RC02  70
DO I=2,NSBIN; IF(RESOL(I-1)<=RESOL(I)) iquit:(RC0002)#                  RC02  71
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RC02  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RC02  73
ELSE IF(LINID==4)#                     ******** rcode *****             RC02  74
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RC02  75
RJCODE = 1#                                                             RC02  76
NRCODE = 1308#                                                          RC02  77
ifnv:(BUFIN(1)) RJCODE = INT(BUFIN(1))# Get which rcode value to use    RC02  78
ifnv:(BUFIN(2)) NRCODE= INT(BUFIN(2))# Which bdf item is rcode          RC02  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RC02  80
ELSE IF(LINID==5)#                     ******* maxhkl *****             RC02  81
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RC02  82
DO J=1,3#                              Loop over hkl fields             RC02  83
IF(BUFIN(J)>(-.1))#                    Store active max hkl             RC02  84
MAXH(J)=NINT(BUFIN(J))#                                                 RC02  85
#MAXH(J)=MIN0(MAXH(J),NINT(BUFIN(J)))# STORE POSSIBLE MAX HKL           RC02  86
IF(BUFIN(4)>=0.0) STMIN=BUFIN(4)#      Store active min st              RC02  87
IF(BUFIN(5)>0.01) STMAX=BUFIN(5)#      Store active max st              RC02  88
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RC02  89
ELSE IF(LINID==6)#                     ****** sigma limit *****         RC02  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RC02  91
ifnv:(BUFIN(1)) SLIMIT = BUFIN(1)#                                      RC02  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RC02  93
ELSE IF(LINID==7)#                     ****** rank1 *****               RC02  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RC02  95
ifnv:(BUFIN(1)) RANK1 = NINT(BUFIN(1))# Take value given                RC02  96
ELSE            RANK1 = 10#            If not specified...              RC02  97
IF(RANK1>100) RANK1=1000#              Sorry, there is a limit          RC02  98
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RC02  99
ELSE IF(LINID==8)#                     ****** rank2 *****               RC02 100
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RC02 101
ifnv:(BUFIN(1)) RANK2 = NINT(BUFIN(1))#                                 RC02 102
ELSE            RANK2 = 10#            If not specified...              RC02 103
IF(RANK2>100) RANK2=1000#              Sorry, there is a limit          RC02 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RC02 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RC02 106
RETURN#                                                                 RC02 107
END#                                                                    RC02 108
pmacro:([no:])#                                                         RC02 109
