systemheader:(RM    )#                                                  RM     1
####################################################################### RM     2
#                                                                     # RM     3
#                           *** REMSET ***                            # RM     4
#                                                                     # RM     5
#   THE PROGRAM REMSET IS USED TO REMOVE ALL INFORMATION              # RM     6
#    CONCERNED WITH A PARTICULAR DATA SET FROM A BDF.                 # RM     7
#                                                                     # RM     8
####################################################################### RM     9
#                                                                       RM    10
include:(XMACRO)#                                                       RM    11
#                                                                       RM    12
macro:(maxsets:,40)#                   Maximum number of data sets      RM    13
macro:(nw12chr:,incr:(arith:(11,/,mxchwd:)))#                           RM    14
macro:(mxwdim:,incr:(arith:(decr:(mxchim:),/,mxchwd:)))#                RM    15
#                                                                       RM    16
extrude:(RMCOMN)#                                                       RM    17
COMMON/COMIRM/   IPT,   JPT, PSIZE#    Rmc                              RM    18
INTEGER IPT#                           Input packet pointer             RM    19
INTEGER JPT#                           Output packet pointer            RM    20
INTEGER PSIZE#                         Bdf packet size                  RM    21
endext:#                                                                RM    22
#                                                                       RM    23
systemheader:(RM00)#                                                    RM00   1
# ################################################################## #  RM00   2
#                                                                    #  RM00   3
#                               RM00                                 #  RM00   4
#                                                                    #  RM00   5
# ################################################################## #  RM00   6
SUBROUTINE RM00#                                                        RM00   7
#                                      Dec 1981  r.a. alden             RM00   8
include:(AACOMN)#                                                       RM00   9
include:(RMCOMN)#                                                       RM00  10
#                                                                       RM00  11
INTEGER CHCNT#                         Character count of remaining     RM00  12
#                                         Data set names.               RM00  13
INTEGER COL#                           Column counter for listing o     RM00  14
#                                         Data set names.               RM00  15
INTEGER FIRST#                         Pointer to start of idcomp       RM00  16
INTEGER I#                             Loop index                       RM00  17
INTEGER IREL#                          Offset for atom name in          RM00  18
#                                         Logical record lratom:.       RM00  19
INTEGER ISTEP1#                        Number of words in a             RM00  20
#                                         12-character name.            RM00  21
INTEGER ISTOP1#                        End of the mark1 array           RM00  22
INTEGER J#                             Another loop index               RM00  23
INTEGER LAST#                          Pointer to end of idcomp         RM00  24
INTEGER MARK1#                         Pointer to array holding         RM00  25
#                                         Data set names.               RM00  26
INTEGER MATCH#                         Set to yes: if idcomps match     RM00  27
INTEGER NCHARS#                        Number of characters in a da     RM00  28
#                                         Set name.                     RM00  29
INTEGER NSETS1#                        Number of data sets on the       RM00  30
#                                         Input bdf.                    RM00  31
INTEGER NUM#                           Data set number to which an      RM00  32
#                                         Atom belongs.                 RM00  33
INTEGER PSIZ2#                         Output packet size for lrref     RM00  34
INTEGER PTR#                           Pointer into the mark1 array     RM00  35
INTEGER PTR2#                          Another pointer into the mar     RM00  36
#                                         Array.                        RM00  37
INTEGER REMSET#                        Number of the data set to be     RM00  38
#                                         Removed.                      RM00  39
#                                                                       RM00  40
REAL ATREM#                            The number of atoms removed      RM00  41
REAL START#                            The initial and final lrrefl     RM00  42
#                                         Catalogue numbers for the     RM00  43
REAL STOP#                             Data set being removed.          RM00  44
#                                                                       RM00  45
string:(DATNAM,12)#                    Current data set name            RM00  46
string:(REMID,12)#                     Name of data set to be remov     RM00  47
chardata:(RM001, DATA FOR              WAS REMOVED FROM THE BDF.)#      RM00  48
chardata:(RM002, THE OUTPUT BDF NOW CONTAINS DATA FOR)#                 RM00  49
chardata:(RM003,ATOMS BELONGING TO              WERE REMOVED.)#         RM00  50
chardata:(RM004, LABEL  END    )#                                       RM00  51
chardata:(RM005,0123456789)#                                            RM00  52
realdata:(FMT001,[80223.,50413.])#                                      RM00  53
intdata:(KEY,[1,0,0,0])#               Signals for reading lratom:      RM00  54
intdata:(WANT,[17])#                   Idnum for data set number        RM00  55
datastuff:#                                                             RM00  56
#                                                                       RM00  57
IOMARK(1) = QXSTR#                     Input bdf buffer                 RM00  58
IOMARK(2) = IOMARK(1) + bdfbuf:#       Output bdf buffer                RM00  59
MARK1 =  IOMARK(2) + bdfbuf:#          Point to start of misc buffe     RM00  60
ISTEP1 = nw12chr:#                                                      RM00  61
ISTOP1 = MARK1 + ISTEP1*maxsets:#                                       RM00  62
incrqx:(I,ISTOP1+1,RM0001)#            Request enough room              RM00  63
#                                                                       RM00  64
copyfile:(1,2,1,lrlabl:)#              Copy through label record        RM00  65
#                                                                       RM00  66
stringlim:(1,FIRST,LAST)#              Get name of data set to          RM00  67
NCHARS = MIN0(LAST-FIRST,12)#          Be removed.                      RM00  68
movechar:(BLANK,1,REMID,1,12,1)#                                        RM00  69
movechar:(CHRIN,FIRST,REMID,1,NCHARS,0)#                                RM00  70
#                                                                       RM00  71
readline:(RM004,NRM004)#               Read any new label images        RM00  72
#                                                                       RM00  73
WHILE(LINID == 1)#                     Process them                     RM00  74
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RM00  75
writepkt:(2,lrlabl:,mxwdim:,JPT)#      Write label packet               RM00  76
movector:(BLANK,1,QX(JPT+1),1,mxchim:,1)#                               RM00  77
movector:(CHRIN,1,QX(JPT+1),1,mxchim:,0)# Move the label characters     RM00  78
readline:(RM004,NRM004)#               Read next image                  RM00  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RM00  80
#                                                                       RM00  81
copyfile:(1,2,incr:(lrlabl:),decr:(lrddef:))#                           RM00  82
#                                                                       RM00  83
NSETS1 = 0#                            Initialize data set count an     RM00  84
REMSET = 0#                            Number of data set to            RM00  85
#                                         Be removed.                   RM00  86
J = MARK1 + 1#                         Point to misc. array             RM00  87
CHCNT = 0#                             Initialize character count       RM00  88
#                                                                       RM00  89
readwpkt:(1,lrddef:,PSIZE,IPT,0)#      Read lrddef:                     RM00  90
WHILE(IPT > 0)#                        Process each data set name       RM00  91
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RM00  92
NSETS1 = NSETS1 + 1#                   Count number of sets             RM00  93
movertoc:(QX(IPT+1),1,DATNAM,1,12,0)#  Save name                        RM00  94
compchar:(DATNAM,1,REMID,1,12,1,12,MATCH)#                              RM00  95
IF(MATCH == yes:)#                     It is                            RM00  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RM00  97
IF(REMSET != 0)  iquit:(-RM0002)#      Name was there twice             RM00  98
REMSET = NSETS1#                       Keep track of number             RM00  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RM00 100
#                                                                       RM00 101
ELSE#                                                                   RM00 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RM00 103
writepkt:(2,lrddef:,PSIZE,JPT)#        Copy name to output              RM00 104
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#                                   RM00 105
movereal:(QX,IPT+1,QX,J,ISTEP1,1)#     And save in the qx.              RM00 106
J = J + ISTEP1#                        Increment storage pointer        RM00 107
CHCNT = CHCNT + 12#                    And character count.             RM00 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RM00 109
#                                                                       RM00 110
readwpkt:(1,lrddef:,PSIZE,IPT,0)#      Read next packet                 RM00 111
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RM00 112
#                                                                       RM00 113
IF(NSETS1 < 2)  iquit:(RM0003)#        There have to be at least        RM00 114
#                                         Two sets.                     RM00 115
IF(REMSET == 0)  iquit:(RM0004)#       The request must be present      RM00 116
#                                                                       RM00 117
movechar:(RM001,1,CHROT,1,NRM001,0)#   Tell user what's being done      RM00 118
movechar:(REMID,1,CHROT,11,12,0)#                                       RM00 119
writeline:(1,0,0,1,3)#                                                  RM00 120
#                                                                       RM00 121
movechar:(RM002,1,CHROT,1,NRM002,0)#   Tell user the names of data      RM00 122
#                                         Sets still remaining on       RM00 123
COL = NRM002 + 2#                      The output bdf.                  RM00 124
#                                                                       RM00 125
FOR(J=1; J < CHCNT; J=J+12)#           Loop over names                  RM00 126
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RM00 127
IF(COL+12 > prtcmax:)#                 Is the output line full?         RM00 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RM00 129
writeline:(0,0,0,1,3)#                 Write it out and                 RM00 130
COL = 2#                               Reset the column pointer.        RM00 131
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RM00 132
#                                                                       RM00 133
movertoc:(QX(MARK1+1),J,CHROT,COL,12,0)# Put name into the line bu      RM00 134
COL = COL + 13#                        Increment the column pointer     RM00 135
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RM00 136
writeline:(0,0,0,1,3)#                 Write out last partial line      RM00 137
#                                                                       RM00 138
CALL RM11(11,REMSET)#                  Remove the packets in lrexpl     RM00 139
CALL RM11(12,REMSET)#                  And lrdset: corresponding to     RM00 140
#                                         The removed data set name.    RM00 141
#                                                                       RM00 142
copyfile:(1,2,incr:(lrdset:),decr:(lratom:))#                           RM00 143
#                                                                       RM00 144
ATREM = 0.#                            Initialize count of atoms        RM00 145
#                                         Removed.                      RM00 146
#                                                                       RM00 147
indexpkt:(1,lratom:,PSIZE,IPT,2,KEY,WANT,IREL)# Read lratom: direct     RM00 148
#                                                                       RM00 149
REPEAT#                                Loop over the atom names         RM00 150
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RM00 151
readwpkt:(1,lratom:,PSIZE,IPT,0)#      Read a packet                    RM00 152
IF(IPT <= 0)  BREAK#                   Leave when exhausted             RM00 153
J = IPT + IREL#                        Get pointer for name             RM00 154
NUM = NINT(QX(J))#                     Get data set number              RM00 155
IF(NUM == REMSET)#                     Should it be removed?            RM00 156
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RM00 157
ATREM = ATREM + 1.#                    Count removed atom               RM00 158
NEXT#                                                                   RM00 159
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RM00 160
writepkt:(2,lratom:,PSIZE,JPT)#        Write out the packet             RM00 161
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#  Copy entire packet               RM00 162
IF(NUM > REMSET)#                      Does the data set number decr    RM00 163
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RM00 164
QX(JPT+IREL)=FLOAT(NUM-1)#             Decr data set number             RM00 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RM00 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RM00 167
#                                                                       RM00 168
IF(ATREM > 0)#                                                          RM00 169
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RM00 170
movechar:(RM003,1,CHROT,7,NRM003,0)#   Tell user how many atoms         RM00 171
movechar:(REMID,1,CHROT,26,12,0)#      Were removed.                    RM00 172
BUFOT(1) = ATREM#                                                       RM00 173
ncodefld:(BUFOT,1,CHROT,FMT001(2),1)##                                  RM00 174
writeline:(1,0,0,1,3)#                                                  RM00 175
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RM00 176
#                                                                       RM00 177
copyfile:(1,2,incr:(lratom:),decr:(lrrefl:))#                           RM00 178
#                                                                       RM00 179
readwpkt:(1,lrrefl:,PSIZE,IPT,0)#      Read directory of lrrefl:        RM00 180
#                                                                       RM00 181
ISTEP1 = PSIZE#                                                         RM00 182
ISTOP1 = MARK1 + 2*ISTEP1#                                              RM00 183
incrqx:(I,ISTOP1+1,RM0006)#            Request room                     RM00 184
#                                                                       RM00 185
START = FLOAT(REMSET)*1000.#           Compute inclusive packet         RM00 186
STOP = START + 1000.#                  Catalogue numbers to be          RM00 187
#                                         Removed.                      RM00 188
PTR = MARK1#                           Once again use misc. array       RM00 189
PTR2 = PTR + PSIZE#                    This time in 2 sections.         RM00 190
PSIZ2 = 0#                             Initialize output buffer siz     RM00 191
#                                                                       RM00 192
FOR (I=IPT+1; I <= IPT+PSIZE; I=I+1)#  Loop over the catalogue no.s     RM00 193
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RM00 194
PTR = PTR + 1#                         Increment the pointer            RM00 195
IF(QX(I)>START&QX(I)<STOP) QX(PTR)=-1.# Mark its position               RM00 196
ELSE#                                  It is to be retained             RM00 197
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RM00 198
PSIZ2 = PSIZ2 + 1#                     Count it for output              RM00 199
QX(PTR) = +1.#                         Mark it                          RM00 200
PTR2 = PTR2 + 1#                       Increment secondary pointer      RM00 201
QX(PTR2) = QX(I)#                      Save its catalogue number        RM00 202
IF(QX(PTR2) > STOP)  QX(PTR2) = QX(PTR2) - 1000.#                       RM00 203
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RM00 204
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RM00 205
#                                                                       RM00 206
writepkt:(2,lrrefl:,PSIZ2,JPT)#        Write the new directory          RM00 207
movereal:(QX,MARK1+PSIZE+1,QX,JPT+1,PSIZ2,1)#                           RM00 208
#                                                                       RM00 209
REPEAT#                                Loop over all lrrefl: packet     RM00 210
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RM00 211
readwpkt:(1,lrrefl:,PSIZE,IPT,0)#      Read each packet                 RM00 212
IF(IPT <= 0)  BREAK#                   Quit if exhausted                RM00 213
PTR = MARK1#                           Point to first flag              RM00 214
writepkt:(2,lrrefl:,PSIZ2,JPT)#        Write the output packet          RM00 215
#                                                                       RM00 216
DO I=1,PSIZE#                          Loop over the input packet       RM00 217
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RM00 218
PTR = PTR + 1#                         Increment the flag pointer       RM00 219
IPT = IPT + 1#                         And the input buffer pointer     RM00 220
IF(QX(PTR) < 0.)  NEXT#                Skip if to be erased             RM00 221
JPT = JPT + 1#                         Increment output buffer ptr.     RM00 222
QX(JPT) = QX(IPT)#                     Transfer to output               RM00 223
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RM00 224
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RM00 225
#                                                                       RM00 226
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Copy rest of file             RM00 227
#                                                                       RM00 228
RETURN#                                                                 RM00 229
#                                                                       RM00 230
END#                                                                    RM00 231
systemheader:(RM11)#                                                    RM11   1
#                                                                       RM11   2
# ################################################################## #  RM11   3
#                                                                    #  RM11   4
#                               RM11                                 #  RM11   5
#                                                                    #  RM11   6
# ################################################################## #  RM11   7
#                                                                       RM11   8
SUBROUTINE RM11(LREC,DATSET)#          Remove data set information      RM11   9
#                                         From logical records lrexpl:  RM11  10
#                                         And lrdset:.                  RM11  11
#                                                                       RM11  12
#                                        Dec 1981  r.a. alden           RM11  13
#                                                                       RM11  14
include:(AACOMN)#                                                       RM11  15
include:(RMCOMN)#                                                       RM11  16
#                                                                       RM11  17
INTEGER DATSET#                        Data set key to be removed       RM11  18
INTEGER LREC#                          Logical record being affecte     RM11  19
INTEGER SET#                           Current data set key being       RM11  20
#                                         Processed.                    RM11  21
#                                                                       RM11  22
REAL DECR#                             Value to decrement the curre     RM11  23
#                                         Data set key by (0 or 1).     RM11  24
#                                                                       RM11  25
readwpkt:(1,LREC,PSIZE,IPT,0)#         Read and write the directory     RM11  26
writepkt:(2,LREC,PSIZE,JPT)#           Record.                          RM11  27
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#                                   RM11  28
#                                                                       RM11  29
DECR = 0.#                             Initialize the decrement         RM11  30
SET = 0#                               And the current data set key     RM11  31
#                                                                       RM11  32
REPEAT#                                Loop over each of the            RM11  33
#                                         Data sets.                    RM11  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RM11  35
SET = SET + 1#                         Increment data set key           RM11  36
readwpkt:(1,LREC,PSIZE,IPT,0)#         Read the packet                  RM11  37
IF(IPT == 0)  BREAK#                   Stop when exhausted              RM11  38
#                                                                       RM11  39
# IF THIS IS THE DATA SET BEING REMOVED, SET THE DECREMENT FOR THE      RM11  40
#  NEXT SET TO BE PROCESSED.                                            RM11  41
#                                                                       RM11  42
IF(SET == DATSET)#                                                      RM11  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RM11  44
DECR = 1.#                                                              RM11  45
NEXT#                                                                   RM11  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RM11  47
writepkt:(2,LREC,PSIZE,JPT)#           Write out the packet             RM11  48
movereal:(QX,IPT+2,QX,JPT+2,PSIZE-1,1)## Move everything except the     RM11  49
#                                         Data set key.                 RM11  50
QX(JPT+1) = QX(IPT+1) - DECR#          Change the key, if necessary     RM11  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RM11  52
#                                                                       RM11  53
RETURN#                                                                 RM11  54
END#                                                                    RM11  55
pmacro:([no:])#                        Purge xtal system macros         RM11  56
