systemheader:(RW    )#                                                  RW     1
# ####################################################################  RW     2
##      Copyright (C) 2000, The Xtal System, The University of        # RW     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # RW     4
## Distributed under the GNU General Public Licence as published by   # RW     5
## the Free Software Foundation, in the hope that it will be useful   # RW     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # RW     7
## for more details.                                                  # RW     8
#                                                                    #  RW     9
#                  REGINA WEIGHTING PACKAGE                          #  RW    10
#    LEAST-SQUARES WEIGHTING PROGRAM DEVELOPED AT THE UNIVERSITY     #  RW    11
#     OF REGINA, REGINA, SASKACHEWAN, BY H. WANG & B.E. ROBERTSON.   #  RW    12
#                                                                    #  RW    13
# ####################################################################  RW    14
#                                                                       RW    15
include:(XMACRO)#                                                       RW    16
#                                                                       RW    17
macro:(single:,SNGL($1))#              Conver real*8 to real real*4     RW    18
macro:(double:,DBLE($1))#              Conver real*4 to real real*8     RW    19
macro:(yb:,DQX(DMARK2+$1))#            Temporary working strorage       RW    20
macro:(bb:,DQX(DMARK3+$1))#            Vector.                          RW    21
macro:(fgrid:,QX(MARK7+$1))#           Fgird: grid point along fo-a     RW    22
macro:(sgrid:,QX(MARK8+$1))#           Sgird: grid point along st-a     RW    23
macro:(gfobs:,QX(MARK9+$1))#           Accumulator for fobs.            RW    24
macro:(gstol:,QX(MARK10+$1))#          Accumulator for stol.            RW    25
macro:(numpt:,QX(MARK11+($1-1)*NGS+$2))# Accumulator for number of r    RW    26
macro:(sigmc:,QX(MARK12+($1-1)*NGS+$2))# Accumulator for sigma(f)**2    RW    27
macro:(diff2:,QX(MARK13+($1-1)*NGS+$2))# Accumulator for delta(f)       RW    28
macro:(sigmf:,QX(MARK14+($1-1)*NGS+$2))# Accumulator for sigma-f.       RW    29
macro:(sigf4:,QX(MARK15+($1-1)*NGS+$2))# Accumulator for sigma-f**2.    RW    30
macro:(numgf:,QX(MARK16+$1))#          Accumulator.                     RW    31
macro:(numgs:,QX(MARK17+$1))#          Accumulator.                     RW    32
macro:(covar:,QX(MARK18+($1-1)*NGS+$2))# Accumulator.                   RW    33
macro:(ij:,$1$2=DMARK1+$1+($2-1)*$2/2)# Pointer for uac: matrix.        RW    34
macro:(uac:,DQX($1$2))#                Matrix of normal equation.       RW    35
macro:(im:,$1$2=DMARK2+$1+($2-1)*$2/2)# Pointer for uac: matrix.        RW    36
macro:(matrixmult:,CALLRW08($1,$2,$3))##                                RW    37
macro:(bba:,DQX(DMARK3+$1))#                                            RW    38
macro:(bd:,DQX(DMARK5+$1))#                                             RW    39
macro:(bs:,DQX(DMARK4+$1))#                                             RW    40
macro:(br:,DQX(DMARK6+$1))#                                             RW    41
macro:(nuac:,DMARK1)#                                                   RW    42
macro:(nuax:,DMARK2)#                                                   RW    43
macro:(nb:,DMARK3)#                                                     RW    44
macro:(ns:,DMARK4)#                                                     RW    45
macro:(nd:,DMARK5)#                                                     RW    46
macro:(nr:,DMARK6)#                                                     RW    47
macro:(ik:,$1$2=NUAC+$1+($2-1)*$2/2)#  Pointer for packed matrix        RW    48
macro:(tac:,DQX($1$2))#                Array of packed marix            RW    49
macro:(bbb:,DQX(NB+$1))#               Vector  (r.h. constant v.)       RW    50
macro:(bt:,DQX(NS+$1))#                Vector  (solution)               RW    51
macro:(ffobs:,QX(MARK14+($1-1)*NGS+$2))# Temporary working storage      RW    52
macro:(maximum:,AMAX1($1,$2,$3))#      Find the maximum value.          RW    53
#                                                                       RW    54
extrude:(RWCOMN)#                                                       RW    55
INTEGER CFLAG#                         Flag for using weight for gr     RW    56
INTEGER DISPER#                        Flag of dispersion correctio     RW    57
INTEGER DMARK0#                        Scale factors.#                  RW    58
INTEGER DMARK1#                        Normal equation matrix.#         RW    59
INTEGER DMARK2#                        Invers of normal equation ma     RW    60
INTEGER DMARK3#                        Constant vector.#                RW    61
INTEGER DMARK4#                        Solution of the equations.#      RW    62
INTEGER DMARK5#                        Pointer for working area.#       RW    63
INTEGER DMARK6#                        Pointer for working area.#       RW    64
INTEGER DMARK7#                        Pointer for working area.#       RW    65
INTEGER DMARK8#                        Pointer for working area.#       RW    66
INTEGER DMARK9#                        Pointer for working area.#       RW    67
INTEGER IARC#                          Number of weights in the         RW    68
#                                        Bdf to be modified.            RW    69
INTEGER IFADS#                         Pointer: a(total) with dispe     RW    70
INTEGER IFBDS#                         Pointer: b(total) with dispe     RW    71
INTEGER IFCAL#                         Pointer: calculated structur     RW    72
INTEGER IFOBS#                         Pointer: real structure fact     RW    73
INTEGER INDIV#                         Flag for grid pointer type.      RW    74
INTEGER ILSWO#                         Pointer: old least  squares      RW    75
INTEGER ILSWT#                         Pointer: current least squar     RW    76
INTEGER ILSW1#                         Pointer: least squares weigh     RW    77
INTEGER ILSW2#                         Pointer: least squares weigh     RW    78
INTEGER ILSW3#                         Pointer: least squares weigh     RW    79
INTEGER IPHKL#                         Pointer: packed h,k,l.#          RW    80
INTEGER IRCOD#                         Pointer: reflection type.#       RW    81
INTEGER IRCLP#                         Pointer: 1/lp factor.#           RW    82
INTEGER ISFGN#                         Pointer: scale grop number.#     RW    83
INTEGER ISIGC#                         Pointer: sigma(f).#              RW    84
INTEGER ISTOL#                         Pointer: sin(theta)/lampda.#     RW    85
INTEGER KEY(4)#                        Search delimiters of lr.#        RW    86
INTEGER LIST,LISTFR#                   Flag for listing estimated w     RW    87
INTEGER LWANAL#                                                         RW    88
INTEGER MARK0#                         Pointer for scale factors.#      RW    89
INTEGER MARK1#                         Pointer for matrix of normal     RW    90
INTEGER MARK2#                         Pointer for invers of the co     RW    91
INTEGER MARK3#                         Pointer for constant vector      RW    92
INTEGER MARK4#                         Pointer for solution of norm     RW    93
INTEGER MARK5#                         Pointer for working area. (n     RW    94
INTEGER MARK6#                         Pointer for working area. (n     RW    95
INTEGER MARK7#                         Pointer for working area. (n     RW    96
INTEGER MARK8#                         Pointer for scale factors.#      RW    97
INTEGER MARK9#                         Pointer for scale factors.#      RW    98
INTEGER MARK10#                        Pointer for scale factors.#      RW    99
INTEGER MARK11#                        Pointer for ...                  RW   100
INTEGER MARK12#                        Pointer for ...                  RW   101
INTEGER MARK13#                        Pointer for ...                  RW   102
INTEGER MARK14#                        Pointer for ...                  RW   103
INTEGER MARK15#                        Pointer for ...                  RW   104
INTEGER MARK16#                        Pointer for ...                  RW   105
INTEGER MARK17#                        Pointer for ...                  RW   106
INTEGER MARK18#                        Pointer for ...                  RW   107
INTEGER MARK19#                        Pointer for ...                  RW   108
INTEGER NGF#                           Number of grid pointer along     RW   109
INTEGER NGS#                           Number of grid pointer along     RW   110
INTEGER NMATRD#                        Double precision. (2*nmatrx)     RW   111
INTEGER NMATRX#                        Number of store required for     RW   112
INTEGER NORD#                          Order of normal equation.#       RW   113
INTEGER NPARA#                         Number of least squares vari     RW   114
INTEGER NPARAD#                        Double precision. (2*npara)#     RW   115
INTEGER NUMCOM#                        Number of reflections contrb     RW   116
INTEGER NUMIGO#                        Totle number of ignored refl     RW   117
INTEGER NUMLTS#                        Totle number of less-than re     RW   118
INTEGER NUMOBS#                        Totle number of observed ref     RW   119
INTEGER NUMREF#                        Totle number of reflections.     RW   120
INTEGER PWANAL#                        Weight pointer                   RW   121
INTEGER RCOD#                          Flag for reflection type. 1-     RW   122
INTEGER RCODE#                         Code for type of reflections     RW   123
INTEGER RFTYPE#                        Type of reflection (1=irel,      RW   124
#                                        2=frel*frel, 3=frel).#         RW   125
INTEGER TYPE#                          Wtanal=1; normal=2; regian=3     RW   126
INTEGER VAV#                           Flag for variance-covariance     RW   127
REAL    AVERD#                         Diffrence of fdif*fdif and s     RW   128
REAL    CARCH(3)#                      Archive buffer. (3)#             RW   129
REAL    COND#                          Contribution factor.#            RW   130
REAL    DSNM#                          Number of set data in binary     RW   131
REAL    FA,FB,FC,FD,FE,FF,FG,FH,FI,FJ,FK# Coefficients of normal w.f.   RW   132
REAL    FAC#                           Scale factor of weight funct     RW   133
REAL    FCAL#                          Calculated structure factor.     RW   134
REAL    FOMAX#                         Maximum observed structure f     RW   135
REAL    FOBS#                          Real structure factor.           RW   136
REAL    LSWT#                          Current least squares weight     RW   137
REAL    LSW1#                          Least squares weight-1.          RW   138
REAL    LSW2#                          Least squares weight-2.          RW   139
REAL    LSW3#                          Least squares weight-3.          RW   140
REAL    MAPRSC#                        Scale factor of r-map            RW   141
REAL    MAPSCL#                        Scale factor of the weight a     RW   142
REAL    MAXH(3)#                       Maximum indice h,k,l.            RW   143
REAL    RLP#                           Lorentz-polarization factor.     RW   144
REAL    SIGC#                          Sigma(f).                        RW   145
REAL    STOL#                          Sin(theta)/lampda.               RW   146
REAL    STOLM#                         Maximum sin theta over lambd     RW   147
REAL SMIN,SMAX#                        Min/max sin theta / lambda       RW   148
REAL    WFLAG#                         Normal weighting scheme num      RW   149
REAL    WOLD#                          Previous weight for the leas     RW   150
DOUBLE PRECISION DQX(arith:(memmax:,/,2))#                              RW   151
COMMON /COMIRW/ NPARA,NMATRX,MARK0,MARK1,MARK2,MARK3,MARK4,MARK5,$#     RW   152
         MARK6,MARK7,MARK8,MARK9,MARK10,MARK11,MARK12,MARK13,MARK14,$#  RW   153
         MARK15,MARK16,MARK17,MARK18,MARK19,DMARK0,DMARK1,$#            RW   154
         DMARK2,DMARK3,DMARK4,DMARK5,DMARK6,DMARK7,DMARK8,DMARK9,$#     RW   155
         WFLAG,VAV,CFLAG,KEY,$#                                         RW   156
         RCODE,RCOD,NPARAD,NMATRD,MAXH,$#                               RW   157
         FOMAX,STOLM,TYPE,NUMREF,NUMOBS,NUMLTS,NUMIGO,NUMCOM,LIST,$#    RW   158
         LISTFR,LWANAL,PWANAL#                                          RW   159
COMMON /COMFRW/FOBS,FCAL,SIGC,STOL,LSWT,LSW1,LSW2,LSW3,$#               RW   160
         COND,SMIN,SMAX,FAC,$#                                          RW   161
         NORD,NGF,NGS,IPHKL,IFOBS,IFCAL,ISIGC,ISTOL,IRCOD,ISFGN,$##     RW   162
         ILSWO,IRCLP,IFADS,IFBDS,DISPER,RFTYPE,RLP,$##                  RW   163
         ILSWT,ILSW1,ILSW2,ILSW3,INDIV,AVERD,DSNM,CARCH,IARC,$##        RW   164
         WOLD,MAPRSC,MAPSCL,FA,FB,FC,FD,FE,FF,FG,FH,FI,FJ,FK##          RW   165
EQUIVALENCE (QX(1),DQX(1))## Reserving memory for double precision ar   RW   166
endext:#                                                                RW   167
#                                                                       RW   168
systemheader:(RW00)#                   Regina ratmac weight scheme.     RW00   1
# ####################################################################  RW00   2
#                                                                    #  RW00   3
#                            RW00                                    #  RW00   4
#                                                                    #  RW00   5
# ####################################################################  RW00   6
SUBROUTINE RW00#                                                        RW00   7
#                                        H. wang b. e. robertson 1985   RW00   8
include:(AACOMN)#                                                       RW00   9
include:(RWCOMN)#                                                       RW00  10
#                                                                       RW00  11
CALL RW01#                             Read control parameters and      RW00  12
IF (TYPE==3)#                          Loop for regina weighting sc     RW00  13
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RW00  14
CALL RW02#                             Grid mode                        RW00  15
CALL RW05#                             Cholesky decomposition.          RW00  16
CALL RW06#                             Invers matrix.                   RW00  17
CALL RW07#                             Iteration improvment.            RW00  18
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RW00  19
CALL RW09#                             Update the bdf and output da     RW00  20
#                                          ******** (called by rw09).   RW00  21
RETURN#                                Return to nucleus routin.        RW00  22
END#                                                                    RW00  23
systemheader:(RW01)#                   Data input routine               RW01   1
# ####################################################################  RW01   2
#                                                                    #  RW01   3
#                            RW01                                    #  RW01   4
#                                                                    #  RW01   5
# ####################################################################  RW01   6
SUBROUTINE RW01#                                                        RW01   7
#                                        H. wang b. e. robertson 1985   RW01   8
include:(AACOMN)#                                                       RW01   9
include:(RWCOMN)#                                                       RW01  10
#                                                                       RW01  11
REAL ARCH(6)#                          Archiv code.   (3)               RW01  12
REAL ORDN#                                                              RW01  13
INTEGER I,IP,J,K,NPAC#                                                  RW01  14
INTEGER IDSN,I0,ITEM,ITEMP,IVC,KK,L,L5,M,MULT,NLIST,NRFTY,NSCL,NTYPE#   RW01  15
INTEGER NMDS#                          Number of set data in bdf.       RW01  16
INTEGER IWNT(20),IR(21)#               Diectory parameters. (20)        RW01  17
INTEGER PACKET#                        Packet size of a logical rec     RW01  18
REAL AF(10)#                           Coefficients. (10)               RW01  19
chardata:(RW10,$#                      Rerwt option codes.              RW01  20
LST $# ## List relflections.                                            RW01  21
NOL $# ## Do not list reflections.                                      RW01  22
REL $# ## Use observed reflections only.                                RW01  23
INL $# ## Use observed and less-than reflections.                       RW01  24
DSE $# ## Data set number.                                              RW01  25
CNT $# ## Contribution factor.                                          RW01  26
WTA $# ## Weight analysis.                                              RW01  27
NOR $# ## Normal weighting scheme.                                      RW01  28
REG $# ## Regina weighting scheme.                                      RW01  29
WFC $# ## Scale factor for grid map of weight analysis.                 RW01  30
IRL $# ## Using itensity data.                                          RW01  31
FR2 $# ## Using f*f data.                                               RW01  32
FRL $# ## Using f(relatived) data.                                      RW01  33
DIS $# ## Dispersion correction.                                        RW01  34
NOD $# ## No dispersion correction.                                     RW01  35
RSC )# ## Scale factor for R-map of weight analysis                     RW01  36
chardata:(RW11, MAXHKL ARCHIV REGINA$# Control lines.                   RW01  37
 NORMAL FGRID  SGRID  END   )#         (cont.) control lines.           RW01  38
chardata:(RW12,POW IND GRI FAC AVC NOA APW NGW )# Regina weighting s    RW01  39
chardata:(RW13,ABCDEFGHI*)#            Normal weighting scheme(coef     RW01  40
chardata:(RW14, REGWT CONTROL PARAMETERS)#                              RW01  41
chardata:(RW15, ------------------------)#                              RW01  42
chardata:(RW16,  LIST DATA FOR ALL REFLECTIONS             )#           RW01  43
chardata:(RW17,  INCLUDE LESS-THAN REFLECTIONS             )#           RW01  44
chardata:(RW18,  PROCESS BDF DATA SET NUMBER               )#           RW01  45
chardata:(RW19,  CONTRIBUTION FACTOR TO THE MATRIX         )#           RW01  46
chardata:(RW20,  MAXIMUM H K L                             )#           RW01  47
chardata:(RW21,  MAXIMUM AND MINIMUM STOL                  )#           RW01  48
chardata:(RW22,            BDF ITEMS ARE   )##                          RW01  49
chardata:(RW23,HKL  STOL FOBS FCAL SIGC RCOD SCFG RCLP WTLS $#          RW01  50
WTF1 WTF2 WTF3 )#                                                       RW01  51
chardata:(RW24,    NOT IN THE BDF)##                                    RW01  52
chardata:(RW25,  TYPE OF REFLECTIONS                       )#           RW01  53
chardata:(RW26, I(REL)   F**2 F(REL) )#                                 RW01  54
chardata:(RW27, ************* )#                                        RW01  55
chardata:(RW28, WEIGHT ANALYSIS )#                                      RW01  56
chardata:(RW29, NORMAL WEIGHTING SCHEME )#                              RW01  57
chardata:(RW30, REGINA WEIGHTING SCHEME )#                              RW01  58
chardata:(RW32,  DISPERSION CORRECTION                     )#           RW01  59
chardata:(RW33, WEIGHT FOR WEIGHT ANALYSIS                 )#           RW01  60
chardata:(RW34,UNIT  SIGMA LSWT  LSW1  LSW2  LSW3 )#                    RW01  61
chardata:(RW50,  THE SPECIFIED WEIGHTING SCHEME IS         )#           RW01  62
chardata:(RW51,  THE COEFFICIENTS OF THE WEIGHTING FUNCTION : )#        RW01  63
chardata:(RW52, A B C D E F G H I J = )#                                RW01  64
chardata:(RW80,  ORDER OF REGINA EQUATIONS                 )#           RW01  65
chardata:(RW81,  MODE OF THE MAP                           )#           RW01  66
chardata:(RW82,  LEAST-SQUARES FREEDON FACTOR              )#           RW01  67
chardata:(RW83,  VARIANCE-COVARIANCE CORRECTION            )#           RW01  68
chardata:(RW84,  WEGHTED GRID IS APPLIED                   )#           RW01  69
chardata:(RW99, NOYES*)#                                                RW01  70
#                                                                       RW01  71
realdata:(FMT,[350403.,390403.,430403.])# Format codes for max. h,k,l   RW01  72
realdata:(MFM,[320941.,320972.,320962.,$# Format codes for coefficien   RW01  73
320952.,320942.,320932.,320922.,$#     Of regina weighting function     RW01  74
320912.,320902.,320941.])#                                              RW01  75
datastuff:#                                                             RW01  76
#======================================# INITIALIZATION AND SET DEFAULT RW01  77
##                                       VALUES.                        RW01  78
##         SET INITIAL VALUES                                           RW01  79
##       **********************                                         RW01  80
##                                                                      RW01  81
FOMAX=0.0#                             : maximum real structure.        RW01  82
STOLM=0.0#                             : maximum sin(theta)/lambda.     RW01  83
NUMREF=0#                              : total num. of reflections.     RW01  84
NUMOBS=0#                              : num. of observed reflectio     RW01  85
NUMLTS=0#                              : num. of less-than reflecti     RW01  86
NUMIGO=0#                              : num. of relfections ignore     RW01  87
NUMCOM=0#                              : num. of contributed reflec     RW01  88
FOR (I=1;I<=10;I=I+1)#                 Loop for.... initializing th     RW01  89
AF(I)=0.0#                             Coefficients of normal           RW01  90
#                                        Weight functions.              RW01  91
##                                                                      RW01  92
##      TABLE OF DEFAULT VALUES                                         RW01  93
##    ***************************                                       RW01  94
##                                                                      RW01  95
FAC=1.0#                               : freedom factor of w.f.         RW01  96
SMIN=0.0#                              : minimum sin(theta)/lambda      RW01  97
SMAX=2.0#                              : maximum sin(theta)/lambda      RW01  98
MAXH(1)=256.0#                         : maximum h                      RW01  99
MAXH(2)=256.0#                         : maximum k                      RW01 100
MAXH(3)=256.0#                         : maximum l                      RW01 101
RCODE=1#                               : refl. status == (obs).         RW01 102
DISPER=0#                              : no dispersion correction.      RW01 103
RFTYPE=3#                              : reflection type == (frel).     RW01 104
DSNM=1.#                               : data set number ==1.           RW01 105
LIST=no:#                              : listing flag == no.            RW01 106
LISTFR=1#                              : list f relative                RW01 107
COND=999.#                             : contribution f == 999.         RW01 108
NORD=2#                                : regina w.f.  == 2.             RW01 109
INDIV=no:#                             : grid point. == individual.     RW01 110
TYPE=3#                                : "regina" weighting scheme.     RW01 111
VAV=no:#                               : no variance-covariance cor     RW01 112
CFLAG=no:#                             : v-c correction == yes.         RW01 113
MAPRSC=100.0#                          : scale factor of r-map          RW01 114
MAPSCL=1.0#                            : scale factor of weight         RW01 115
##                                                                      RW01 116
##         I/O BUFFER FOR BDF                                           RW01 117
##       **********************                                         RW01 118
##                                                                      RW01 119
IOMARK(1)=QXSTR#                       Input buffer of bdf (a).         RW01 120
IOMARK(2)=IOMARK(1)+bdfbuf:#           Output buffer of bdf (b).        RW01 121
incrqx:(MARK0,IOMARK(2)+bdfbuf:+1,RW0101)# Expanding the qx array       RW01 122
MARK0=MARK0/2*2#                       Qx pointer for scale factors     RW01 123
##                                                                      RW01 124
##      PROGRAM INITIATION LINE                                         RW01 125
##     *************************                                        RW01 126
##                                                                      RW01 127
FOR (I=1;I<18;I=I+1)#                  Loop for reading control lin     RW01 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RW01 129
ifvo:(BUFIN(I)) BREAK#                 Exit at first void field.        RW01 130
stringlim:(I,J,K)#                     Translate f.p.v. to char.        RW01 131
compchar:(CHRIN,J,RW10,1,3,4,NRW10,K)# Search items.                    RW01 132
IF (K==0) iquit:(RW0102,I)#            No match then quit.              RW01 133
ELSE IF (K==1)#                        Flag for listing reflections     RW01 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RW01 135
LIST=yes:#                             Switch on the listing of hkl     RW01 136
IF(BUFIN(I+1)>0.)#                     Check for limit                  RW01 137
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RW01 138
I=I+1#                                 Incr field pointer               RW01 139
LISTFR=NINT(BUFIN(I))#                 Store list limit                 RW01 140
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RW01 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RW01 142
ELSE IF (K==2) LIST=0#                 Do not list reflections          RW01 143
ELSE IF (K==3) RCODE=1#                Reflection ssatus: only obs.     RW01 144
ELSE IF (K==4) RCODE=2#                Reflection status: includ ls     RW01 145
ELSE IF (K==5)#                        Data set number:                 RW01 146
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RW01 147
IF (BUFIN(I+1)>voidflg:)#              If next field is not void...     RW01 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RW01 149
DSNM=NINT(BUFIN(I+1))#                 Data set number.                 RW01 150
I=I+1#                                 Advance the field pointer.       RW01 151
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RW01 152
ELSE DSNM=1.#                          Void: data set number == 1       RW01 153
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RW01 154
ELSE IF (K==6)#                        Contribution factor:             RW01 155
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RW01 156
IF (BUFIN(I+1)>voidflg:)#              If next field is not void...     RW01 157
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RW01 158
I=I+1#                                 Advance the field pointer.       RW01 159
COND=BUFIN(I)#                         Contribution factor.             RW01 160
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RW01 161
ELSE COND=9999.#                       Void: use all reflections.       RW01 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RW01 163
ELSE IF (K==7)#                        Flag for weight analysis onl     RW01 164
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RW01 165
TYPE=1#                                Flag weight anal only            RW01 166
LWANAL=3#                              Signal default                   RW01 167
IF(BUFIN(I+1)>voidflg:)#               Test for following number        RW01 168
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RW01 169
I=I+1#                                 Incr field pointer               RW01 170
LWANAL=NINT(BUFIN(I))#                 Store input value                RW01 171
IF(LWANAL<1\LWANAL>6) iquit:(RW0130)#  Outside allowed values           RW01 172
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RW01 173
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RW01 174
ELSE IF (K==8) TYPE=2#                 Flag for spacial w.f. and w.     RW01 175
ELSE IF (K==9) TYPE=3#                 Flag for regina w.f. and w.a     RW01 176
ELSE IF (K==10)#                       Map scale factor of w.a.:        RW01 177
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RW01 178
IF (BUFIN(I+1)<voidflg:) MAPSCL=1.0#   Void: scale factor is 1.0.       RW01 179
ELSE#                                  Not void:                        RW01 180
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RW01 181
I=I+1#                                 Advance the field pointer.       RW01 182
MAPSCL=BUFIN(I)#                       Map scale factor.                RW01 183
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RW01 184
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RW01 185
ELSE IF (K==11) RFTYPE=1#              Flag for using irel.             RW01 186
ELSE IF (K==12) RFTYPE=2#              Flag for using frel**2.          RW01 187
ELSE IF (K==13) RFTYPE=3#              Flag for using frel.             RW01 188
ELSE IF (K==14) DISPER=1#              Dispersion correction.           RW01 189
ELSE IF (K==15) DISPER=0#              No dispersion correction.        RW01 190
ELSE#                                                                   RW01 191
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RW01 192
IF (BUFIN(I+1)<voidflg:) MAPRSC=100.0# Default r-map scale factor       RW01 193
ELSE#                                                                   RW01 194
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RW01 195
I=I+1; MAPRSC=BUFIN(I)#                R-map scale factor               RW01 196
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RW01 197
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RW01 198
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RW01 199
#--------------------------------------# READ SCALE FACTOR AND DATA SET RW01 200
#                                        Information from lr:expl of bd RW01 201
##                                                                      RW01 202
##        BDF READING: LREXPL                                           RW01 203
##      ***********************                                         RW01 204
##                                                                      RW01 205
incrqx:(MARK1,MARK0+64,RW0103)#        Expanding qx array for scale     RW01 206
#                                        Factor.                        RW01 207
IWNT(1)=1#                             Id number for data set key.      RW01 208
IWNT(2)=100#                           Id number for # of scale gro     RW01 209
KEY(1)=1; KEY(2)=2; KEY(3)=0; KEY(4)=0## Set search delimiters (r.o.)   RW01 210
indexpkt:(1,lrexpl:,PACKET,IP,0,KEY,$# Get relative pointers of         RW01 211
IWNT,IR)#                              Logical record: expl.            RW01 212
#                                                                       RW01 213
NPAC=KEY(4)#                           Return packet size.              RW01 214
NSCL=1#                                Defaule number of scale grou     RW01 215
QX(MARK0+1)=1.0#                       Defaule scale factor.            RW01 216
FOR (I=IP+1; I<=IP+NPAC;I=I+1)#        Loop for getting the pointer     RW01 217
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RW01 218
IF ((QX(I)<100.)\(QX(I)>164.1)) NEXT#  Ignore other itens.              RW01 219
J=MARK0+NINT(QX(I))-100#               Pointer of input buffer of b     RW01 220
QX(J)=FLOAT(I-IP)#                                                      RW01 221
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RW01 222
REPEAT#                                Loop for reading scale facto     RW01 223
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RW01 224
readwpkt:(1,lrexpl:,PACKET,IP,0)#      Read a packet                    RW01 225
IF (IP<=0) BREAK#                      Exit if packet is empity.        RW01 226
I=IP+IR(1)#                            Next item...                     RW01 227
IF (I==IP) NEXT#                       Exit at first void field.        RW01 228
ifne:(DSNM,QX(I)) NEXT#                Data set number is not macth     RW01 229
I=IP+IR(2)#                            Pointer...                       RW01 230
IF (I>IP) NSCL=NINT(QX(I))#            Group number of scale factor     RW01 231
FOR (I=MARK0;I<MARK0+NSCL;I=I+1)#      Loop for reading scale facto     RW01 232
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RW01 233
J=IP+NINT(QX(I+1))#                    Pointer                          RW01 234
IF (J>IP) QX(I+1)=QX(J)#               Scale factor.                    RW01 235
ELSE      QX(I+1)=1.0#                 Default vaule of scale facto     RW01 236
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RW01 237
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RW01 238
#                                                                       RW01 239
##                                                                      RW01 240
##        BDF READING: LRDSET                                           RW01 241
##      ***********************                                         RW01 242
##                                                                      RW01 243
IWNT(1)=1#                             Id number of data set key.       RW01 244
FOR (I=1;I<=5;I=I+1)#                  Loop assigning the id number     RW01 245
IWNT(I+1)=I+10#                        Maxi. h,k,l,stol and min. st     RW01 246
KEY(1)=0;KEY(2)=6;KEY(3)=0;KEY(4)=0#   Set search delimiters (r.o.)     RW01 247
indexpkt:(1,lrdset:,PACKET,IP,0,KEY,IWNT,IR)# Get relative pointers     RW01 248
#                                        Of logical record: dset.       RW01 249
IF (IP>0)#                             If the directory exists...       RW01 250
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RW01 251
REPEAT#                                Loop for reading the max. hk     RW01 252
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RW01 253
readwpkt:(1,lrdset:,PACKET,IP,0)#      Read maximum h,k,l...            RW01 254
IF (IP<=0) BREAK#                      End of the record then exit.     RW01 255
I=IP+IR(1)#                            Pointer of input buffer.         RW01 256
ifne:(DSNM,QX(I))  NEXT#               If  dset no match,  skip to      RW01 257
#                                        Next one.                      RW01 258
I=IP+IR(2); IF (I>IP) MAXH(1)=QX(I)#   Maximum h.                       RW01 259
I=IP+IR(3); IF (I>IP) MAXH(2)=QX(I)#   Maximum k.                       RW01 260
I=IP+IR(4); IF (I>IP) MAXH(3)=QX(I)#   Maximum l.                       RW01 261
I=IP+IR(5); IF (I>IP) SMIN=QX(I)#      Minimum stol.                    RW01 262
I=IP+IR(6); IF (I>IP) SMAX=QX(I)#      Maximum stol.                    RW01 263
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RW01 264
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RW01 265
##                                                                      RW01 266
##         PRINT THE TITLE                                              RW01 267
##       ===================                                            RW01 268
##                                                                      RW01 269
writeline:(1,RW14,NRW14,3,3)#          Output the title.                RW01 270
writeline:(0,RW15,NRW15,3,3)#          Output the title.                RW01 271
NLIST=LIST*3+1#                        Pointer...                       RW01 272
movechar:(RW99,NLIST,RW16,41,3,0)#     "list data for all reflxion"     RW01 273
writeline:(0,RW16,NRW16,3,3)#          Printing...                      RW01 274
NRFTY=RFTYPE*7-6#                      Pointer...                       RW01 275
movechar:(RW26,NRFTY,RW25,37,7,0)#     "type of reflection              RW01 276
writeline:(0,RW25,NRW25,3,3)#          Printing...                      RW01 277
NTYPE=RCODE*3-2#                       Pointer...                       RW01 278
movechar:(RW99,NTYPE,RW17,41,3,0)#     "include or exclude the less     RW01 279
writeline:(0,RW17,NRW17,3,3)#          Than reflections"                RW01 280
NTYPE=(DISPER+1)*3-2#                  Pointer...                       RW01 281
movechar:(RW99,NTYPE,RW32,41,3,0)#     "dispersion correction"          RW01 282
writeline:(0,RW32,NRW32,3,3)#                                           RW01 283
ncodefld:(DSNM,1,RW18,430203.,1)#      Formatting...                    RW01 284
writeline:(0,RW18,NRW18,3,3)#          Printing...                      RW01 285
ncodefld:(COND,1,RW19,430822.,1)#      Formatting...                    RW01 286
writeline:(0,RW19,NRW19,3,3)#          Printing...                      RW01 287
#                                                                       RW01 288
NMDS=NINT(DSNM)*1000#                  Archiv codes------               RW01 289
ARCH(1)=NMDS+901#                      : least squares weight-1.        RW01 290
ARCH(2)=NMDS+902#                      : least squares weight-2.        RW01 291
ARCH(3)=NMDS+903#                      : least squares weight-3.        RW01 292
ITEM=3#                                Number of the items.             RW01 293
IARC=0#                                Number of the items will be      RW01 294
#                                        Change.                        RW01 295
##                                                                      RW01 296
##           CONTROL LINES                                              RW01 297
##         *****************                                            RW01 298
##                                                                      RW01 299
REPEAT#                                Loop for read control lines.     RW01 300
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 RW01 301
readline:(RW11,NRW11)#                 Read control lines.              RW01 302
#                                                                       RW01 303
IF(LINID==1)#                          *********** maxhkl *********     RW01 304
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 RW01 305
ifnv:(BUFIN(1)) MAXH(1)=BUFIN(1)#      Maximum h.                       RW01 306
ifnv:(BUFIN(2)) MAXH(2)=BUFIN(2)#      Maximum k.                       RW01 307
ifnv:(BUFIN(3)) MAXH(3)=BUFIN(3)#      Maximum l.                       RW01 308
ifnv:(BUFIN(4)) SMIN=BUFIN(4)#         Minimum sin(theta)/l.            RW01 309
ifnv:(BUFIN(5)) SMAX=BUFIN(5)#         Maximum sin(theta)/l.            RW01 310
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 RW01 311
ELSE IF (LINID==2)#                    *********** archiv *********     RW01 312
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 RW01 313
DO J=1,3#                              Loop for archive code.           RW01 314
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 RW01 315
ifvo:(BUFIN(J))  BREAK#                If noting in rest of fields,     RW01 316
FOR (I=1;I<=ITEM;I=I+1)#               Loop for checking the archiv     RW01 317
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 RW01 318
ifne:(ABS(BUFIN(J)),ARCH(I)) NEXT#     Skip to next one if not mact     RW01 319
IARC=IARC+1#                           Advance the pointer...           RW01 320
CARCH(J)=BUFIN(J)#                     Archive code                     RW01 321
BREAK#                                 Exit.                            RW01 322
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 RW01 323
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 RW01 324
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 RW01 325
ELSE IF (LINID==3)#                    ********** regina **********     RW01 326
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 RW01 327
IF (TYPE!=3) iquit:(RW0104)#           If the type is not 'regina',     RW01 328
#                                        Then quit.                     RW01 329
FOR (I=1;I<=10;I=I+1)#                 Loop for reading the paramet     RW01 330
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 RW01 331
ifvo:(BUFIN(I)) BREAK#                 Exit at first void fields        RW01 332
stringlim:(I,M,K)#                     Translate f.p.v. to char. ty     RW01 333
compchar:(CHRIN,M,RW12,1,3,4,NRW12,K)# Search parameter code.           RW01 334
IF (K==0) iquit:(RW0105,I)#            If no match, then quit.          RW01 335
ELSE IF (K==1)#                        Order of weihgt function         RW01 336
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 RW01 337
IF (BUFIN(I+1)>voidflg:)#              No void...                       RW01 338
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 RW01 339
NORD=NINT(BUFIN(I+1))#                 Order of the function.           RW01 340
IF (NORD>3) iquit:(RW0106)#            The order # can't be greater     RW01 341
I=I+1#                                 Next field.                      RW01 342
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 RW01 343
ELSE NORD=2#                           Void: 2nd order equation.        RW01 344
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 RW01 345
ELSE IF (K==2) INDIV=yes:#             Individual mode                  RW01 346
ELSE IF (K==3) INDIV=no:#              Grid mode                        RW01 347
ELSE IF (K==4)#                        Map scale factor of w.a.         RW01 348
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 RW01 349
IF (BUFIN(I+1)>voidflg:)#              No void...                       RW01 350
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 RW01 351
I=I+1#                                 Advance the pointer.             RW01 352
FAC=1.0/(BUFIN(I))#                    Freedom factor.                  RW01 353
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 RW01 354
ELSE FAC=1.0#                          Default freedom factor           RW01 355
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 RW01 356
ELSE IF (K==5) VAV=1#                  Variance covariance correcti     RW01 357
ELSE IF (K==6) VAV=0#                  No v-c correction                RW01 358
ELSE IF (K==7) CFLAG=yes:#             Weight feature be used.          RW01 359
ELSE CFLAG=yes:#                       Weight feature not be used.      RW01 360
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 RW01 361
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 RW01 362
ELSE IF (LINID==4)#                    ********** normal **********     RW01 363
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 RW01 364
IF (TYPE!=2) iquit:(RW0107)#           If the type is no 'normal' t     RW01 365
WFLAG=BUFIN(1)#                        Weighting scheme number.         RW01 366
ifvo:(WFLAG) WFLAG=1.0#                Void: scheme 1.                  RW01 367
I=1#                                   Pointer of field. (coefficie     RW01 368
#                                                                       RW01 369
REPEAT#                                Loop for reading the coeffic     RW01 370
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 RW01 371
I=I+1#                                 Advance the pointer              RW01 372
ifvo:(BUFIN(I)) BREAK#                 If nothing there, exit !!        RW01 373
stringlim:(I,L,K)#                     Translate f.p.v. to char.        RW01 374
compchar:(CHRIN,L,RW13,1,1,1,NRW13,K)# Searching key letter.            RW01 375
IF (K==0) iquit:(RW0108,I)#            If no match, then quit.          RW01 376
ifvo:(BUFIN(I+1)) iquit:(RW0109)#      Error....                        RW01 377
AF(K)=BUFIN(I+1)#                      Coefficients.                    RW01 378
I=I+1#                                 Next field.                      RW01 379
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 RW01 380
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 RW01 381
ELSE IF (LINID==5) BREAK#              Exit... (grid point along fr     RW01 382
ELSE IF (LINID==6) BREAK#              Exit... (grid point along st     RW01 383
ELSE IF (LINID==7) BREAK#              ********** end ***********       RW01 384
ELSE iquit:(RW0110)#                   Some thing funny, i am quit.     RW01 385
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 RW01 386
ITEMP=LINID#                           Temporay storage for 'kcd'       RW01 387
IF (TYPE==3)#                          Regina weighting scheme. (ty     RW01 388
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 RW01 389
ORDN=FLOAT(NORD)#                      Order of the function.           RW01 390
NPARA=0#                               Initiation.                      RW01 391
FOR (M=1;M<=NORD+1;M=M+1)#             Loop for calculating the par     RW01 392
NPARA=NPARA+M#                         Number of w.f. parameters.       RW01 393
NPARAD=NPARA*2#                        Number of parameters of w.f.     RW01 394
NMATRX=(NPARA+1)*NPARA/2#              Number of elements of triang     RW01 395
NMATRD=NMATRX*2#                       Double precision. (matrix)       RW01 396
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 RW01 397
ELSE#                                  Normal weighting scheme and      RW01 398
#                                        Weight analysis.               RW01 399
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 RW01 400
NPARAD=0#                              Number of parameters of w.f.     RW01 401
NMATRX=0#                              Number of elements of matrix     RW01 402
NMATRD=0#                              Double precision matrix          RW01 403
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 RW01 404
DMARK0=MARK0/2#                        Pointer...                       RW01 405
MARK1=((MARK0+NSCL+1)/2)*2#            Pointer...                       RW01 406
DMARK1=MARK1/2#                        Pointer...                       RW01 407
MARK2=((MARK1+2*NMATRX+1)/2)*2#        Pointer..                        RW01 408
DMARK2=MARK2/2#                        Pointer...                       RW01 409
MARK3=((MARK2+2*NMATRX+1)/2)*2#        Pointer..                        RW01 410
DMARK3=MARK3/2#                        Pointer...                       RW01 411
MARK4=((MARK3+2*NPARAD+1)/2)*2#        Pointer..                        RW01 412
DMARK4=MARK4/2#                        Pointer...                       RW01 413
MARK5=((MARK4+2*NPARAD+1)/2)*2#        Pointer..                        RW01 414
DMARK5=MARK5/2#                        Pointer...                       RW01 415
MARK6=((MARK5+NPARAD+1)/2)*2#          Pointer..                        RW01 416
DMARK6=DMARK6/2#                       Pointer...                       RW01 417
MARK7=((MARK6+NMATRX+1)/2)*2#          Pointer..                        RW01 418
incrqx:(I,MARK7,RW0116)#               Incr qx memory                   RW01 419
##                                                                      RW01 420
##          READ GRID POINT                                             RW01 421
##        *******************                                           RW01 422
##                                                                      RW01 423
NGF=0#                                 Initialization of grid point     RW01 424
NGS=0#                                 Of fobs and stol.                RW01 425
#                                                                       RW01 426
LINID=ITEMP#                           Recall the pointer.              RW01 427
IF (LINID==5)#                         ********* fgrid **********       RW01 428
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 RW01 429
REPEAT#                                Loop for reading the grid po     RW01 430
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 RW01 431
J=1#                                   Pointer of field.                RW01 432
WHILE (BUFIN(J)>voidflg:)#             Loop for reading fobs grid p     RW01 433
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 RW01 434
NGF=NGF+1#                             Increse number of grid point     RW01 435
fgrid:(NGF)=BUFIN(J)#                  Grid point of fobs.              RW01 436
J=J+1#                                 Advance the field point.         RW01 437
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 RW01 438
readline:(RW11,NRW11)#                 Read next line.                  RW01 439
IF (LINID!=5) BREAK#                   If no match then exit.           RW01 440
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 RW01 441
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 RW01 442
#                                                                       RW01 443
IF (NGF>23) NGF=23#                    Number of fgrel points (max=     RW01 444
incrqx:(MARK8,MARK7+NGF,RW0117)#       Expand qx arrat for fobs gri     RW01 445
#                                        Pointes.                       RW01 446
IF (LINID==6)#                         ********* sgrid **********       RW01 447
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 RW01 448
REPEAT#                                Loop for reading stol grid p     RW01 449
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 RW01 450
J=1#                                   Pointer of field.                RW01 451
WHILE (BUFIN(J)>voidflg:)#             Loop for reading stol grid p     RW01 452
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 RW01 453
NGS=NGS+1#                             Increase number of grid poin     RW01 454
sgrid:(NGS)=BUFIN(J)#                  Stol grid point.                 RW01 455
J=J+1#                                 Advance the field point.         RW01 456
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 RW01 457
readline:(RW11,NRW11)#                 Read next line.                  RW01 458
IF (LINID!=6) BREAK#                   If no match, then exit.          RW01 459
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 RW01 460
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 RW01 461
IF (LINID!=7) iquit:(RW0118)#          Quit: 'end' line is missing      RW01 462
IF((NGF==0\NGS==0)&TYPE==1) iquit:(RW0119)#                             RW01 463
#                                                                       RW01 464
ncodefld:(MAXH,1,RW20,FMT,3)#          Formatting the maximum h,k,l     RW01 465
writeline:(0,RW20,NRW20,3,3)#          Printing: maximum h,k,l          RW01 466
ncodefld:(SMIN,1,RW21,350532.,1)#      Formatting the minimum stol      RW01 467
ncodefld:(SMAX,1,RW21,430532.,1)#      And maximum stol value.          RW01 468
writeline:(0,RW21,NRW21,3,3)#          Printing: minimum and maximu     RW01 469
#                                        Sin(theta)/lambda              RW01 470
movechar:(RW27,1,CHROT,1,NRW27,0)#     Subtitle:                        RW01 471
ITEMP=1+NRW27#                         Pointer of 'bfotln'.             RW01 472
IF (TYPE==1)#                          Weight analysis...               RW01 473
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 RW01 474
movechar:(RW28,1,CHROT,ITEMP,NRW28,0)# ---- weight analysis.            RW01 475
ITEMP=ITEMP+NRW28#                     Pointer of 'chrot'.              RW01 476
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 RW01 477
ELSE IF (TYPE==2)#                     Normal weighting scheme          RW01 478
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 RW01 479
movechar:(RW29,1,CHROT,ITEMP,NRW29,0)# ---- normal weighting scheme     RW01 480
ITEMP=ITEMP+NRW29#                     Pointer of 'chrot'.              RW01 481
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 RW01 482
ELSE#                                  Regina weighting scheme   rw     RW01 483
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 RW01 484
movechar:(RW30,1,CHROT,ITEMP,NRW30,0)## ---- regina weighting scheme    RW01 485
ITEMP=ITEMP+NRW30#                     Pointer of 'chrot'.              RW01 486
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 RW01 487
movechar:(RW27,1,CHROT,ITEMP,NRW27,0)## "**************"                RW01 488
writeline:(2,0,0,1,3)#                 Printing...                      RW01 489
#                                                                       RW01 490
IF (TYPE==1)#                          Print weight analysis            RW01 491
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 RW01 492
KK=LWANAL*6-5#                         Set output pointer               RW01 493
movechar:(RW34,KK,RW33,33,5,0)#        Insert type                      RW01 494
writeline:(0,RW33,NRW33,3,3)#          Print it                         RW01 495
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 RW01 496
ELSE IF (TYPE==2)#                     Printing normal weight schem     RW01 497
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 RW01 498
ncodefld:(WFLAG,1,RW50,420313.,1)#     Formatting the weighting sch     RW01 499
writeline:(1,RW50,NRW50,3,3)#          Printing...                      RW01 500
writeline:(1,RW51,NRW51,3,3)#          Printing...                      RW01 501
FOR (L=1;L<=10;L=L+1)#                 Loop for output the coeffici     RW01 502
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 RW01 503
ITEMP=2*L-1#                           'chrot'  pointer.                RW01 504
movechar:(RW52,ITEMP,CHROT,12,3,0)#    Transfer the coefficient nam     RW01 505
movechar:(RW52,22,CHROT,16,2,0)#       Transfer the equal sign '='.     RW01 506
ITEMP=ABS(NINT(AF(L)))#                Dynamic formatting...            RW01 507
IF (AF(L)>1.0-6)#                      Within the formatting range.     RW01 508
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 RW01 509
FOR (K=1;K<=10;K=K+1)#                 Loop for testing the magnitu     RW01 510
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 RW01 511
IF (ITEMP<=0) BREAK#                   Proper value be found then q     RW01 512
ITEMP=ITEMP/10#                        Shift decimal point one digi     RW01 513
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 RW01 514
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 RW01 515
ELSE K=1#                              Out of rang case...              RW01 516
ncodefld:(AF(L),1,CHROT,MFM(K),1)#     Formatting the coefficients.     RW01 517
writeline:(0,0,0,1,3)#                 Printing...                      RW01 518
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 RW01 519
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 RW01 520
ELSE#                                  Print regina weight scheme       RW01 521
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 RW01 522
ncodefld:(ORDN,1,RW80,430203.,1)#      Formatting the order value.      RW01 523
writeline:(1,RW80,NRW80,3,3)#          Printing...                      RW01 524
IF (INDIV==no:) IVC=9#                 Pointer for grid point.          RW01 525
ELSE          IVC=5#                   Pointer for individual.          RW01 526
movechar:(RW12,IVC,RW81,41,3,0)#       Transfer 'gri' to 'rw81' arr     RW01 527
writeline:(1,RW81,NRW81,3,3)#          Printing...                      RW01 528
ncodefld:(FAC,1,RW82,430822.,1)#       Formatting the freedon facto     RW01 529
writeline:(1,RW82,NRW82,3,3)#          Printing...                      RW01 530
IF (INDIV==yes:) VAV=no:#              No var-cov correction. (indi     RW01 531
ITEMP=VAV*3+1#                         Pointer for v-c correction.      RW01 532
movechar:(RW99,ITEMP,RW83,41,3,0)#     Transfer 'yes' or 'no' to 'r     RW01 533
writeline:(1,RW83,NRW83,3,3)#          Printing...                      RW01 534
ITEMP=CFLAG*3+1#                       * * * * * * * * * * * * * *      RW01 535
movechar:(RW99,ITEMP,RW84,41,3,0)#     * * * * * *w*e*i*g*h*t* * *      RW01 536
writeline:(1,RW84,NRW84,3,3)#          * * * * * * * * * * * * * *      RW01 537
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 RW01 538
#                                                                       RW01 539
##                                                                      RW01 540
##        READ REFLECTION DATA                                          RW01 541
##       **********************                                         RW01 542
##                                                                      RW01 543
IDSN=NINT(DSNM)*1000#                  Data set number                  RW01 544
IWNT(1)=1#                             H,k,l                            RW01 545
IWNT(2)=2#                             Sin(theta)/lamdar                RW01 546
IWNT(3)=IDSN+298+RFTYPE*2#             Real structure factor.           RW01 547
IWNT(4)=IDSN+800#                      Calculated structure factor.     RW01 548
IWNT(5)=IDSN+299+RFTYPE*2#             Standard deviation of freal      RW01 549
IWNT(6)=IDSN+308#                      Code of reflection type.         RW01 550
IWNT(7)=IDSN+309#                      Scale group number.              RW01 551
IWNT(8)=IDSN+204#                      Lorentz-polarization factor.     RW01 552
IWNT(9)=IDSN+900#                      Least squares weight.            RW01 553
IWNT(10)=IDSN+901#                     Least squares weight-1.          RW01 554
IWNT(11)=IDSN+902#                     Least squares weight-2.          RW01 555
IWNT(12)=IDSN+903#                     Least squares weight-3.          RW01 556
IWNT(13)=IDSN+805#                     A(total) with dispersion cor     RW01 557
IWNT(14)=IDSN+806#                     B(total) with dispersion cor     RW01 558
KEY(1)=6; KEY(2)=14; KEY(3)=0; KEY(4)=0# Set search delimiters          RW01 559
indexpkt:(1,lrrefl:,PACKET,IP,0,KEY,$## Get  relative  pointers  of     RW01 560
IWNT,IR)#                              Logical  record: refl            RW01 561
IF (KEY(4)<0) iquit:(RW0120)#          Something wrong, quit!!!         RW01 562
#--------------------------------------# POINTER OF LOGICAL RECORD:     RW01 563
IPHKL=IR(1)#                           -hkl.                            RW01 564
ISTOL=IR(2)#                           -sin(theta)/l.                   RW01 565
IFOBS=IR(3)#                           -observed structure factor.      RW01 566
IFCAL=IR(4)#                           -calculated structure factor     RW01 567
ISIGC=IR(5)#                           -standard deviation of f(rea     RW01 568
IRCOD=IR(6)#                           -rcord.                          RW01 569
ISFGN=IR(7)#                           -number of scale group.          RW01 570
IRCLP=IR(8)#                           Lorentz-polariztion factor.      RW01 571
ILSWO=IR(9)#                           -least squares weight.           RW01 572
ILSW1=IR(10)#                          -least squares weight 1.         RW01 573
ILSW2=IR(11)#                          -least squares weight 2.         RW01 574
ILSW3=IR(12)#                          -least squares weight 3.         RW01 575
IFADS=IR(13)#                          -a(total) with disper corr.      RW01 576
IFBDS=IR(14)#                          -b(total) with disper corr.      RW01 577
#--------------------------------------#                                RW01 578
writeline:(1,RW22,NRW22,3,3)#          Printing...                      RW01 579
DO L=1,12#                             Loop over refln data             RW01 580
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 RW01 581
L5=(L-1)*5+1#                          Pointer of identification.       RW01 582
movechar:(RW23,L5,CHROT,26,5,0)#       Item name                        RW01 583
IF (IR(L)<=0)#                         If no exist...                   RW01 584
movechar:(RW24,1,CHROT,32,NRW24,0)#    "item not found"                 RW01 585
writeline:(0,0,0,1,3)#                 Printing...                      RW01 586
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 RW01 587
#                                                                       RW01 588
IF(DISPER==1)#                         Dispersion correction is req     RW01 589
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 RW01 590
IF((IFADS<=0)\(IFBDS<=0))#             A(total) and b(total) are        RW01 591
iquit:(RW0121)#                        Missing from lr:refl.            RW01 592
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 RW01 593
#--------------------------------------#                                RW01 594
#                                                                       RW01 595
DO I=1,NMATRX#                         Loop packed triang matrix        RW01 596
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 RW01 597
I0=I+DMARK1#                           Index pointer.                   RW01 598
DQX(I0)=0.0D+0#                        Initializing.                    RW01 599
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 RW01 600
DO I=1,NPARA; bb:(I)=0.0D+0#           Initializing.                    RW01 601
#                                                                       RW01 602
MULT=NGS*NGF#                          Total number of grid point.      RW01 603
MARK9=MARK8+NGS#                       Expand qx array.                 RW01 604
MARK10=MARK9+NGF#                      Expand qx array.                 RW01 605
MARK11=MARK10+NGS+1#                   Expand qx array.                 RW01 606
MARK12=MARK11+MULT#                    Expand qx array.                 RW01 607
MARK13=MARK12+MULT#                    Expand qx array.                 RW01 608
MARK14=MARK13+MULT#                    Expand qx array.                 RW01 609
MARK15=MARK14+MULT#                    Expand qx array.                 RW01 610
MARK16=MARK15+MULT#                    Expand qx array.                 RW01 611
incrqx:(MARK17,MARK16+NGF,RW0129)#     Expand qx array.                 RW01 612
FA=AF(1); FB=AF(2); FC=AF(3); FD=AF(4)# Store in common                 RW01 613
FE=AF(5); FF=AF(6); FG=AF(7); FH=AF(8)# Store in common                 RW01 614
FI=AF(9); FJ=AF(10)#                   Store in common                  RW01 615
#                                                                       RW01 616
IF(TYPE==1)#                                                            RW01 617
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 RW01 618
IF(LWANAL==2)#                                                          RW01 619
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 RW01 620
IF(ISIGC<=0) iquit:(RW0132)#           R                                RW01 621
PWANAL=ISIGC#                                                           RW01 622
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 RW01 623
ELSE#                                  All other weights                RW01 624
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 RW01 625
IF(IR(LWANAL+6)<=0) iquit:(RW0132)#    Not found on bdf                 RW01 626
PWANAL=IR(LWANAL+6)#                   Store weight                     RW01 627
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 RW01 628
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 RW01 629
#                                                                       RW01 630
RETURN#                                Return to calling routine.       RW01 631
END#                                                                    RW01 632
systemheader:(RW02)#                   Grid point mode.                 RW02   1
# ####################################################################  RW02   2
#                                                                    #  RW02   3
#                            RW02                                    #  RW02   4
#                                                                    #  RW02   5
# ####################################################################  RW02   6
SUBROUTINE RW02#                                                        RW02   7
#                                        H. wang b. e. robertson 1985   RW02   8
include:(AACOMN)#                                                       RW02   9
include:(RWCOMN)#                                                       RW02  10
#                                                                       RW02  11
INTEGER I,IP,ISTEP,J,J0,J1,MULT#                                        RW02  12
REAL COVAR,DIFF2,FDIF,SIGF4,SIGMC,SIGMF,UMNREF,VARIA,VARO#              RW02  13
REAL NWEI#                             Weight of grid point.            RW02  14
#                                                                       RW02  15
chardata:(RW25,   THE MATRIX OF NORMAL EQUATION : )##                   RW02  16
chardata:(RW27,   THE CONSTANT VECTOR OF NORMAL EQUATION : )##          RW02  17
chardata:(RW28, NUMBER OF TOTAL REFLECTIONS : )##                       RW02  18
chardata:(RW29, NUMBER OF OBSERED REFLECTIONS : )##                     RW02  19
chardata:(RW30, NUMBER OF LESS-THAN REFLECTIONS : )##                   RW02  20
chardata:(RW31, NUMBER OF REJECTED REFLECTIONS : )##                    RW02  21
chardata:(RW32, NUMBER OF CONTRIBUTED REFLECTIONS : )##                 RW02  22
chardata:(RW26, *********)# ##                                          RW02  23
realdata:(MFM,[151041.,251041.,351041.,$# Format cord for the matri     RW02  24
451041.,551041.,651041.,751041.,851041.,$# And the vector.              RW02  25
951041.,1051041.,1151041.,1251041.])#                                   RW02  26
datastuff:#                                                             RW02  27
#                                                                       RW02  28
NWEI=1.0#                              Default grid point weight.       RW02  29
MULT=NGS*NGF#                          Total number of grid points.     RW02  30
##                                                                      RW02  31
##      INITIALIZATION OF QX ARRAY                                      RW02  32
##     ****************************                                     RW02  33
##                                                                      RW02  34
movereal:(0.0,1,QX,MARK9+1,NGF,2)#                                      RW02  35
movereal:(0.0,1,QX,MARK10+1,NGS,2)#                                     RW02  36
movereal:(0.0,1,QX,MARK11+1,MULT,2)#                                    RW02  37
movereal:(0.0,1,QX,MARK12+1,MULT,2)#                                    RW02  38
movereal:(0.0,1,QX,MARK13+1,MULT,2)#                                    RW02  39
movereal:(0.0,1,QX,MARK14+1,MULT,2)#                                    RW02  40
movereal:(0.0,1,QX,MARK15+1,MULT,2)#                                    RW02  41
movereal:(0.0,1,QX,MARK16+1,NGF,2)#                                     RW02  42
#                                                                       RW02  43
IF (VAV==yes:)#                        If v-c correction is require     RW02  44
incrqx:(MARK18,MARK17+NGS,RW0308)#     Expand and initialize the qx     RW02  45
movereal:(0.0,1,QX,MARK17+1,NGS,2)#    Array for v-c correction.        RW02  46
##                                                                      RW02  47
##          GRID POINT MODE                                             RW02  48
##        *******************                                           RW02  49
##                                                                      RW02  50
IF (INDIV==no:)#                       ****** grid point mode *****     RW02  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RW02  52
#                                                                       RW02  53
movereal:(0.0,1,QX,MARK11+1,MULT,2)#   Clear numpt: arrat.              RW02  54
movereal:(0.0,1,QX,MARK12+1,MULT,2)#   Clear sigmc: array.              RW02  55
#                                                                       RW02  56
REPEAT#                                Loop for evaluation of each      RW02  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RW02  58
CALL RW04(IP)#                         Get reflection data from bdf     RW02  59
IF (IP<=0) BREAK#                      Exit if no more reflection.      RW02  60
#                                                                       RW02  61
FOR (I=1;I<=NGF;I=I+1)#                Loop for grid points fobs        RW02  62
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RW02  63
IF (FOBS>fgrid:(I))  NEXT#             Find a proper position.          RW02  64
gfobs:(I)=gfobs:(I)+FOBS#              Accumulating.                    RW02  65
numgf:(I)=numgf:(I)+1.0#               Accumulate number of reflect     RW02  66
FOR (J=1;J<=NGS;J=J+1)#                Loop for grid point along        RW02  67
#                                        Sin(theta)/lambda direction    RW02  68
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RW02  69
IF (STOL>sgrid:(J))  NEXT#             Find a proper position.          RW02  70
FDIF=FOBS-FCAL#                        Delta of structure factor.       RW02  71
gstol:(J)=gstol:(J)+STOL#              Accumulating the stol.           RW02  72
numgs:(J)=numgs:(J)+1.0#               Counting the number of refle     RW02  73
numpt:(I,J)=numpt:(I,J)+1.0#           Number of reflections            RW02  74
sigmc:(I,J)=sigmc:(I,J)+SIGC*SIGC#     <sigma-c**2>---(counting sta     RW02  75
diff2:(I,J)=diff2:(I,J)+FDIF*FDIF#     <fdif**2>------:fo-fc:*:fo-f     RW02  76
IF (VAV==yes:)#                        V-c correction is required.      RW02  77
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RW02  78
VARO=1.0/(WOLD*WOLD)#                  Modified variance.               RW02  79
sigmf:(I,J)=sigmf:(I,J)+VARO#          <sigma-f**2>---modified...       RW02  80
sigf4:(I,J)=sigf4:(I,J)+VARO*VARO#     <sigma-f**4>---modified...       RW02  81
covar:(I,J)=covar:(I,J)+VARO*FDIF*FDIF## <covar=sigma-f**2 x fdif**2>   RW02  82
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RW02  83
BREAK#                                 Exit...                          RW02  84
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RW02  85
BREAK#                                 Exit...                          RW02  86
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RW02  87
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RW02  88
#                                                                       RW02  89
FOR (I=1;I<=NGF;I=I+1)#                Loop 1  for  generating the      RW02  90
#                                        Normal  equation               RW02  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RW02  92
IF (numgf:(I)<0.5) FOBS=0.0#           Void: set fobs == 0.0            RW02  93
#                                        Numgf: no void...              RW02  94
ELSE FOBS=gfobs:(I)/numgf:(I)#         Pass gfobs: to fobs.             RW02  95
FOR (J=1;J<=NGS;J=J+1)#                Loop 2 for generating the        RW02  96
#                                        Normal  equation.              RW02  97
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RW02  98
SIGMC=sigmc:(I,J)#                     Sum of sigma-c**2                RW02  99
DIFF2=diff2:(I,J)#                     Sum of delta-f**2                RW02 100
AVERD=FAC*DIFF2-SIGMC#                 Average value of sigma-m         RW02 101
#                                        Without v-c correction.        RW02 102
IF(numpt:(I,J)<=1.5) NEXT#             Skip to next step if the         RW02 103
#                                        Grid is empity.                RW02 104
AVERD=AVERD/numpt:(I,J)#               Average value of sigma-m         RW02 105
IF (VAV==yes:)#                        If v-c correction is require     RW02 106
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RW02 107
SIGMF=sigmf:(I,J)#                     Sum of sigma-f**2                RW02 108
SIGF4=sigf4:(I,J)#                     Sum of sigma-f**4                RW02 109
COVAR=covar:(I,J)#                     Sum of (sigmaf*deltaf)**2        RW02 110
VARIA=(SIGF4-SIGMF*SIGMF/numpt:(I,J))/(numpt:(I,J)-1.0)# Variance       RW02 111
COVAR=(COVAR-SIGMF*DIFF2/numpt:(I,J))/(numpt:(I,J)-1.0)# Covariance     RW02 112
AVERD=AVERD+FAC*VARIA*DIFF2/SIGMF/SIGMF# Sigma-m with variance and      RW02 113
AVERD=AVERD-FAC*COVAR/SIGMF#           Covariance correction.           RW02 114
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RW02 115
IF (numgs:(J)>0.5)#                    Numsf: no void...                RW02 116
STOL=gstol:(J)/numgs:(J)#              Pass average of gstol: to st     RW02 117
ELSE STOL=0.0#                         Void: assign stol 0.0            RW02 118
IF (CFLAG==yes:)#                      If weighted grid point is ex     RW02 119
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RW02 120
NWEI=SQRT(numpt:(I,J))#                Assign the square root of th     RW02 121
NWEI=SQRT(NWEI)#                       Grid weight of the reflectio     RW02 122
FOBS=FOBS*NWEI#                        Weighted fobs....                RW02 123
STOL=STOL*NWEI#                        Weighted stol....                RW02 124
AVERD=AVERD*NWEI#                      Weighted averd...                RW02 125
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RW02 126
CALL RW03#                             Generating the normal equati     RW02 127
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RW02 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RW02 129
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RW02 130
##                                                                      RW02 131
##       INDIVIDUAL POINT MODE                                          RW02 132
##      ***********************                                         RW02 133
##                                                                      RW02 134
ELSE#                                  ====== individual mode =====     RW02 135
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RW02 136
REPEAT#                                Loop for evaluate the normal     RW02 137
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RW02 138
CALL RW04(IP)#                         Read reflection data.            RW02 139
IF (IP<=0) BREAK#                      If end of record is reached,     RW02 140
FDIF=FOBS-FCAL#                        Difference of sturcture fact     RW02 141
AVERD=FAC*FDIF*FDIF-SIGC*SIGC#         Average value of sigma-m         RW02 142
#                                        Without v-c correction.        RW02 143
CALL RW03#                             Generate the mormal equation     RW02 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RW02 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RW02 146
#                                                                       RW02 147
##                                                                      RW02 148
##    PRINT REFLECTION STATUS TABLE                                     RW02 149
##   *******************************                                    RW02 150
##                                                                      RW02 151
movechar:(RW26,1,CHROT,1,NRW26,0)#                                      RW02 152
movechar:(RW27,1,CHROT,11,59,1)#                                        RW02 153
movechar:(RW26,1,CHROT,71,NRW26,0)#                                     RW02 154
writeline:(2,0,0,1,3)#                                                  RW02 155
movechar:(RW28,1,CHROT,11,NRW28,0)#                                     RW02 156
UMNREF=NUMREF#                                                          RW02 157
ncodefld:(UMNREF,1,CHROT,700613.,1)#                                    RW02 158
writeline:(0,0,0,1,3)#                                                  RW02 159
movechar:(RW29,1,CHROT,11,NRW29,0)#                                     RW02 160
UMNREF=NUMOBS#                                                          RW02 161
ncodefld:(UMNREF,1,CHROT,700613.,1)#                                    RW02 162
writeline:(0,0,0,1,3)#                                                  RW02 163
movechar:(RW30,1,CHROT,11,NRW30,0)#                                     RW02 164
UMNREF=NUMLTS#                                                          RW02 165
ncodefld:(UMNREF,1,CHROT,700613.,1)#                                    RW02 166
writeline:(0,0,0,1,3)#                                                  RW02 167
movechar:(RW31,1,CHROT,11,NRW31,0)#                                     RW02 168
UMNREF=NUMIGO#                                                          RW02 169
ncodefld:(UMNREF,1,CHROT,700613.,1)#                                    RW02 170
writeline:(0,0,0,1,3)#                                                  RW02 171
movechar:(RW32,1,CHROT,11,NRW32,0)#                                     RW02 172
UMNREF=NUMCOM#                                                          RW02 173
ncodefld:(UMNREF,1,CHROT,700613.,1)#                                    RW02 174
writeline:(0,0,0,1,3)#                                                  RW02 175
movechar:(RW26,1,CHROT,1,NRW26,0)#                                      RW02 176
movechar:(RW27,1,CHROT,11,59,1)#                                        RW02 177
movechar:(RW26,1,CHROT,71,NRW26,0)#                                     RW02 178
writeline:(0,0,0,1,3)#                                                  RW02 179
movechar:(RW26,6,CHROT,7,70,1)#                                         RW02 180
writeline:(0,0,0,1,3)#                                                  RW02 181
#                                                                       RW02 182
##                                                                      RW02 183
##     SAVE AND PRINT THE MATRIX                                        RW02 184
##    ***************************                                       RW02 185
##                                                                      RW02 186
movereal:(QX,MARK1+1,QX,MARK2+1,NMATRD,1)# Save the coefficient matri   RW02 187
writeline:(2,RW25,NRW25,2,3)#          Write the header.                RW02 188
FOR (J=1;J<=NMATRX;J=J+1)#             Loop: converting real*8 to       RW02 189
#                                        Real*4 for printing            RW02 190
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RW02 191
J0=MARK4+J#                            Pointer for real*4. (designa     RW02 192
J1=DMARK1+J#                           Pointer for real*8. (source)     RW02 193
QX(J0)=single:(DQX(J1))#               Convert real*8 to real*4.        RW02 194
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RW02 195
#                                                                       RW02 196
ISTEP=MARK4+1#                         Set temporary pointer.           RW02 197
FOR (I=1;I<=NPARA;I=I+1)#              Loop: for printing the matri     RW02 198
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RW02 199
ISTEP=ISTEP+I-1#                       Advance the pointer.             RW02 200
ncodefld:(QX,ISTEP,CHROT,MFM,I)#       Formatting...                    RW02 201
writeline:(0,0,0,1,3)#                 Write:                           RW02 202
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RW02 203
#                                                                       RW02 204
writeline:(2,RW27,NRW27,3,3)#          "constant vector of normal       RW02 205
#                                         Equation"                     RW02 206
FOR (I=1;I<=NPARA;I=I+1)#              Loop for variable type trans     RW02 207
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RW02 208
J0=MARK4+I#                            Pointer of designation.          RW02 209
J1=DMARK3+I#                           Pointer of source.               RW02 210
QX(J0)=single:(DQX(J1))#               Transfer d-type to s-type.       RW02 211
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RW02 212
ncodefld:(QX,MARK4+1,CHROT,MFM,NPARA)# Formatting the constant vect     RW02 213
writeline:(1,0,0,1,3)#                 Write:                           RW02 214
#                                                                       RW02 215
RETURN#                                Retur to rw01 routine.           RW02 216
END#                                                                    RW02 217
systemheader:(RW03)#                   Individual point mode.           RW03   1
# ####################################################################  RW03   2
#                                                                    #  RW03   3
#                            RW03                                    #  RW03   4
#                                                                    #  RW03   5
# ####################################################################  RW03   6
SUBROUTINE RW03#                                                        RW03   7
#                                        H. wang b. e. robertson 1985   RW03   8
INTEGER I,IJ,J,J0,J1,J2,J3,J4,K0,N#                                     RW03   9
include:(AACOMN)#                                                       RW03  10
include:(RWCOMN)#                                                       RW03  11
#                                                                       RW03  12
DOUBLE PRECISION DFOBS,DSTOL#          Local double precision varia     RW03  13
DFOBS=double:(FOBS)#                   Convert fobs to double-type.     RW03  14
DSTOL=double:(STOL)#                   Convert stol to double-type.     RW03  15
#                                                                       RW03  16
yb:(1)=1.0D0#                          Initialization.                  RW03  17
N=NORD+1#                              Number of the terns in the f     RW03  18
IF (N>1)#                              If more than one tern in the     RW03  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RW03  20
J1=1#                                  Temporary index.                 RW03  21
FOR (I=1;I<N;I=I+1)#                   Loop for w.f. parameter calc     RW03  22
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RW03  23
J0=J1; J1=J1+I; J2=J1#                 Temporary indexes.               RW03  24
yb:(J1)=yb:(J0)*DFOBS#                 The parameters including         RW03  25
#                                        The fobs.                      RW03  26
FOR (K0=1;K0<=I;K0=K0+1)#              Loop for w.f. parameter calc     RW03  27
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RW03  28
J3=J2+K0#                              Index...                         RW03  29
J4=J0+K0-1#                            Index...                         RW03  30
yb:(J3)=yb:(J4)*DSTOL#                 The parameters including         RW03  31
#                                        The sin(theta)/lambda          RW03  32
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RW03  33
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RW03  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RW03  35
#                                                                       RW03  36
yb:(NPARA+1)=double:(AVERD)#           Average value of sigma-m         RW03  37
##                                                                      RW03  38
##       GENERATE THE MATRIX                                            RW03  39
##      *********************                                           RW03  40
##                                                                      RW03  41
FOR (J=1;J<=NPARA;J=J+1)#              First loop for generating        RW03  42
#                                        The matrix                     RW03  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RW03  44
FOR (I=1;I<=J;I=I+1)#                  Second loop for generating       RW03  45
#                                        The matrix                     RW03  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RW03  47
ij:(I,J)#                              Index...                         RW03  48
uac:(I,J)=uac:(I,J)+yb:(I)*yb:(J)#     Accumulating... (for the mat     RW03  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RW03  50
bb:(J)=bb:(J)+yb:(NPARA+1)*yb:(J)#     Accumulating... (for the vec     RW03  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RW03  52
#                                                                       RW03  53
RETURN#                                End of the rw03 subroutine.      RW03  54
END#                                                                    RW03  55
systemheader:(RW04)#                   Data input routine               RW04   1
# ####################################################################  RW04   2
#                                                                    #  RW04   3
#                            RW04                                    #  RW04   4
#                                                                    #  RW04   5
# ####################################################################  RW04   6
SUBROUTINE RW04(IP)#                                                    RW04   7
#                                        H. wang b. e. robertson 1985   RW04   8
include:(AACOMN)#                                                       RW04   9
include:(RWCOMN)#                                                       RW04  10
#                                                                       RW04  11
REAL H(3)#                             H,k,l array   (3)                RW04  12
REAL FADIS,FBDIS,FDIF,SCLFCT,SFGN#                                      RW04  13
INTEGER IP,J0#                                                          RW04  14
INTEGER PACKET#                        Packet size of logical recor     RW04  15
#                                        Of refl (reflection).          RW04  16
REPEAT#                                Loop for reading the reflect     RW04  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RW04  18
readwpkt:(1,lrrefl:,PACKET,IP,0)#      Read the reflection data fro     RW04  19
#                                        Input buffer.                  RW04  20
IF (IP<=0) BREAK#                      Exit if no more reflection.      RW04  21
NUMREF=NUMREF+1#                       Counting reflections.            RW04  22
#                                        From bdf input buffer,         RW04  23
gethkl:(IP+IPHKL,H)#                   Get and unpack the h,k,l,        RW04  24
STOL=QX(IP+ISTOL)#                     Get stol,                        RW04  25
FOBS=QX(IP+IFOBS)#                     Get observed structure facto     RW04  26
FCAL=QX(IP+IFCAL)#                     Get calculated structure fac     RW04  27
IF(DISPER==1)#                         Dispersion correction is req     RW04  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RW04  29
FADIS=QX(IP+IFADS)#                    Get a(total) with dispersion     RW04  30
FBDIS=QX(IP+IFBDS)#                    Get b(total) with dispersion     RW04  31
FCAL=SQRT(FADIS*FADIS+FBDIS*FBDIS)#    Calcelated :f: with dispersi     RW04  32
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RW04  33
#                                                                       RW04  34
IF (RFTYPE==1)#                        I(rel)...                        RW04  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RW04  36
IF (IRCLP<=0) iquit:(RW0403)#          Lp factor is missing.            RW04  37
RLP=QX(IP+IRCLP)#                      Get lp factor from input buf     RW04  38
FCAL=FCAL*FCAL*RLP#                    I(cal)...                        RW04  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RW04  40
#                                                                       RW04  41
IF(RFTYPE==2) FCAL=FCAL*FCAL#          F(cal)*f(cal)                    RW04  42
IF(IRCOD>0) RCOD=NINT(QX(IP+IRCOD))#   Get rcode.                       RW04  43
ELSE RCOD=1#                           Assume to be observed            RW04  44
#                                                                       RW04  45
IF (RCOD==2) NUMLTS=NUMLTS+1#          Number of less-than reflecti     RW04  46
ELSE         NUMOBS=NUMOBS+1#          Number of observed reflectio     RW04  47
#                                                                       RW04  48
IF (ISFGN==0)   SFGN=1.0#              Default scale group number:      RW04  49
ELSE            SFGN=QX(IP+ISFGN)#     Else get from bdf input buff     RW04  50
J0=MARK0+NINT(SFGN)#                   Pointer for scale group numb     RW04  51
SCLFCT=QX(J0)#                         Scale factor.                    RW04  52
FOBS=FOBS*SCLFCT#                      Scaling observed structure f     RW04  53
IF (RFTYPE<3) FOBS=FOBS*SCLFCT#        Scaling again for i and f*f      RW04  54
FDIF=FOBS-FCAL#                        Difference of intensity          RW04  55
#                                                                       RW04  56
IF (ABS(H(1))>MAXH(1)\ABS(H(2))>$#     If h,k,l are out of the          RW04  57
MAXH(2)\ABS(H(3))>MAXH(3))#            Range...                         RW04  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RW04  59
NUMIGO=NUMIGO+1#                       Ignored reflection...            RW04  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RW04  61
ELSE IF (STOL<SMIN\STOL>SMAX)#         If stol is out of the range.     RW04  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RW04  63
NUMIGO=NUMIGO+1#                       Ignored reflection...            RW04  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RW04  65
ELSE IF (RCOD>RCODE)#                  If refleciton type is unexpe     RW04  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RW04  67
NUMIGO=NUMIGO+1#                       Ignored reflection...            RW04  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RW04  69
ELSE IF(ABS(FDIF)>COND)#               If fdif if out of the range      RW04  70
NUMIGO=NUMIGO+1#                       Contribution factor, increas     RW04  71
ELSE#                                  Otherwise...                     RW04  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RW04  73
SIGC=QX(IP+ISIGC)#                     Get stand. devia. of f(obs)      RW04  74
SIGC=SIGC*SCLFCT#                      Scaling the sigmc value.         RW04  75
IF (RFTYPE<3) SIGC=SIGC*SCLFCT#        Scaling again for i and f*f      RW04  76
#                                        Factor from bdf input buffer.  RW04  77
IF (ILSWO<=0) WOLD=1.0/SIGC#           If weight does not exist,        RW04  78
#                                        Old weight == 1 / sigmc        RW04  79
ELSE          WOLD=QX(IP+ILSWO)#       Otherwise get from input buf     RW04  80
IF (FOBS>FOMAX) FOMAX=FOBS#            Find the maximum fobs value.     RW04  81
IF (STOL>STOLM) STOLM=STOL#            Find the maximum stol value.     RW04  82
NUMCOM=NUMCOM+1#                       Number of reflections contri     RW04  83
RETURN#                                Exit...                          RW04  84
#                                                                       RW04  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RW04  86
#--------------------------------------#                                RW04  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RW04  88
#                                                                       RW04  89
RETURN#                                Reture to the rw02 routine.      RW04  90
END#                                                                    RW04  91
systemheader:(RW05)#                                                    RW05   1
# ####################################################################  RW05   2
#                                                                    #  RW05   3
#                            RW05                                    #  RW05   4
#                                                                    #  RW05   5
# ####################################################################  RW05   6
SUBROUTINE RW05#                                                        RW05   7
#                                        H. wang b. e. robertson 1986   RW05   8
include:(AACOMN)#                                                       RW05   9
include:(RWCOMN)#                                                       RW05  10
INTEGER I,II,IJ,J,JJ,L,LI,LJ#                                           RW05  11
#                                                                       RW05  12
chardata:(RW51, THE MATRIX OF NORMAL $##                                RW05  13
EQUATION IS NUMERICAL SINGULAR )#                                       RW05  14
datastuff:#                                                             RW05  15
##                                                                      RW05  16
##       CHOLYSKY DECOMPOSITION                                         RW05  17
##      ************************                                        RW05  18
##                                                                      RW05  19
DO J=1,NPARA#                          First loop for decomposition     RW05  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RW05  21
im:(J,J)#                              Evaluate the index of matrix     RW05  22
I=1#                                   Pointer.                         RW05  23
WHILE (I<=(J-1))#                      Second loop for decompositio     RW05  24
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RW05  25
im:(I,J); im:(I,I)#                    Evaluate the index of array      RW05  26
L=1#                                   Pointer.                         RW05  27
WHILE (L<=(I-1))#                      Third loop for decomposition     RW05  28
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RW05  29
im:(L,I); im:(L,J)#                    Evaluate the index of array      RW05  30
uac:(I,J)=uac:(I,J)-uac:(L,I)*uac:(L,J)# Decomposition--1.              RW05  31
L=L+1#                                 Advanced the pointer.            RW05  32
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RW05  33
uac:(I,J)=uac:(I,J)/uac:(I,I)#         Decomposition--2.                RW05  34
#                                        (off-diagonal term)            RW05  35
uac:(J,J)=uac:(J,J)-uac:(I,J)*uac:(I,J)# Decomposition--3.              RW05  36
#                                        (diagonal term)                RW05  37
I=I+1#                                 Advanced the pointer.            RW05  38
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RW05  39
IF (uac:(J,J)<=0.0D-0)#                Numerical singular testing.      RW05  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RW05  41
writeline:(2,RW51,NRW51,3,3)#          Warnng message                   RW05  42
iquit:(RW0501)#                        Then quit.                       RW05  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RW05  44
uac:(J,J)=DSQRT(uac:(J,J))#            Decomposition--4.                RW05  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RW05  46
#                                                                       RW05  47
RETURN#                                Reture to rw01 routine.          RW05  48
END#                                                                    RW05  49
systemheader:(RW06)#                   Invers matrix                    RW06   1
# ####################################################################  RW06   2
#                                                                    #  RW06   3
#                            RW06                                    #  RW06   4
#                                                                    #  RW06   5
# ####################################################################  RW06   6
SUBROUTINE RW06#                                                        RW06   7
#                                        H. wang b. e. robertson 1985   RW06   8
include:(AACOMN)#                                                       RW06   9
include:(RWCOMN)#                                                       RW06  10
#                                                                       RW06  11
INTEGER I,IJ,IL,ISTEP,J,J0,J1,JJ,JL,L,LJ#                               RW06  12
DOUBLE PRECISION TEMP#                                                  RW06  13
chardata:(RW61,  THE INVERS MATRIX OF NORMAL EQUATION : )#              RW06  14
realdata:(MFM,[151041.,251041.,351041.,451041.,$#                       RW06  15
551041.,651041.,751041.,851041.,951041.,$##                             RW06  16
1051041.,1151041.,1251041.])#                                           RW06  17
datastuff:#                                                             RW06  18
#                                                                       RW06  19
##                                                                      RW06  20
##      INVERS TRIANGULAR MATRIX                                        RW06  21
##     **************************                                       RW06  22
##                                                                      RW06  23
DO J=1,NPARA#                          First loop for inversion.        RW06  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RW06  25
I=1#                                   Pointer...                       RW06  26
im:(J,J)#                              Evaluate the index of matrix     RW06  27
WHILE (I<=(J-1))#                      Second loop for inversion.       RW06  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RW06  29
im:(I,J)#                              Evaluate the index of matrix     RW06  30
TEMP=0.0D0#                            Temporary working storage.       RW06  31
L=I#                                   Pointer...                       RW06  32
WHILE (L<=(J-1))#                      Third loop for inversion.        RW06  33
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RW06  34
im:(I,L); im:(L,J)#                    Evaluate the index of matrix     RW06  35
TEMP=TEMP-(uac:(I,L)*uac:(L,J))#       Accumulating...                  RW06  36
L=L+1#                                 Advanced the pointer.            RW06  37
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RW06  38
uac:(I,J)=TEMP/uac:(J,J)#              Inversion...                     RW06  39
I=I+1#                                 Advanced the pointer.            RW06  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RW06  41
uac:(J,J)=1.0/uac:(J,J)#               Inversion...                     RW06  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RW06  43
##                                                                      RW06  44
##  MULTIPLICATION OF UPPER AND LOWER                                   RW06  45
## *********************************** #                                RW06  46
##                                                                      RW06  47
DO I=1,NPARA#                          1st loop for multiplication      RW06  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RW06  49
DO J=I,NPARA#                          2nd loop for multiplication      RW06  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RW06  51
TEMP=0.0D00#                           Temporary working storage.       RW06  52
DO L=J,NPARA#                          3rd loop for multiplication      RW06  53
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RW06  54
im:(I,L); im:(J,L)#                    Evaluate the index of array      RW06  55
TEMP=TEMP+(uac:(I,L)*uac:(J,L))#       Accumulating...                  RW06  56
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RW06  57
im:(I,J)#                              Evaluate the index of array      RW06  58
uac:(I,J)=TEMP#                                                         RW06  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RW06  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RW06  61
writeline:(2,RW61,NRW61,2,3)#          Title: "invers of the matrix     RW06  62
##                                                                      RW06  63
##        PRINT INVERS MATRIX                                           RW06  64
##       =====================                                          RW06  65
##                                                                      RW06  66
FOR (J=1;J<=NMATRX;J=J+1)#             Loop: for convert real*8 to      RW06  67
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RW06  68
J0=MARK4+J#                            Pointer for real*4. (designa     RW06  69
J1=DMARK2+J#                           Pointer for real*8. (source)     RW06  70
QX(J0)=single:(DQX(J1))#               Convert real*8 to real*4.        RW06  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RW06  72
#                                                                       RW06  73
ISTEP=MARK4+1#                         Starting point.                  RW06  74
FOR (I=1;I<=NPARA;I=I+1)#              Loop: for printing the matri     RW06  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RW06  76
ISTEP=ISTEP+I-1#                       Increase the pointer.            RW06  77
ncodefld:(QX,ISTEP,CHROT,MFM,I)#       Formatting...                    RW06  78
writeline:(0,0,0,1,3)#                 Printing...                      RW06  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RW06  80
#                                                                       RW06  81
RETURN#                                                                 RW06  82
END#                                                                    RW06  83
systemheader:(RW07)#                   Iteration improvement.           RW07   1
# ####################################################################  RW07   2
#                                                                    #  RW07   3
#                            RW07                                    #  RW07   4
#                                                                    #  RW07   5
# ####################################################################  RW07   6
SUBROUTINE RW07#                                                        RW07   7
#                                        H. wang b. e. robertson 1985   RW07   8
include:(AACOMN)#                                                       RW07   9
include:(RWCOMN)#                                                       RW07  10
#                                                                       RW07  11
REAL LNORM,PERCEN,RNORM,SNORM#                                          RW07  12
INTEGER I,INDEX,ITERA,J0,J1#                                            RW07  13
INTEGER TEMP#                                                           RW07  14
chardata:(RW71,  SOLUTION OF THE NORMAL EQUATION )# ## R                RW07  15
chardata:(RW75, A(0,0)  A(1,0)  A(0,1)  A(2,0)  A(1,1)  A(0,2)  $## R   RW07  16
A(3,0)  A(2,1)  A(1,2)  A(0,3)  A(4,0)  A(3,1)  A(2,2)  A(1,3)  $##     RW07  17
A(0,4)  )#                                                              RW07  18
chardata:(RW76, ITERATION IMPROVEMENT FAIL TO CONVERGENCE. )#           RW07  19
chardata:(RW77, ITERATION IMPROVEMENT IS DIVERGENCE. )#                 RW07  20
chardata:(RW78,[                                    I       J ])#       RW07  21
chardata:(RW79,[           REGWT = SUM A(I,J)*(V[F]) *(V[S]) ])#        RW07  22
chardata:(RW710,  THE REG-WEIGHT FUNCTION IS : )#                       RW07  23
chardata:(RW711,*+ =     WHERE  )#                                      RW07  24
chardata:(RW712,[ V[F] = FOBS/FOBS(MAX),    FOBS(MAX)=         ])#      RW07  25
chardata:(RW713,[ V[S] = STOL/STOL(MAX),    STOL(MAX)=         ])#      RW07  26
#                                                                       RW07  27
realdata:(MFM,[151041.,251041.,351041.,451041.,$# Format code for       RW07  28
551041.,651041.,751041.,851041.,951041.,$##                             RW07  29
1051041.,1151041.,1251041.])#                                           RW07  30
realdata:(FM,[410972.,410962.,410952.,410942.,$#                        RW07  31
410932.,410922.,410912.,411153.])#                                      RW07  32
#                                                                       RW07  33
datastuff:#                                                             RW07  34
#                                                                       RW07  35
##                                                                      RW07  36
##       ITERATIVE IMPROVEMENT                                          RW07  37
##     *************************                                        RW07  38
##                                                                      RW07  39
LNORM=1.0E23#                          Initialization.                  RW07  40
ITERA=0#                               Iteration times.                 RW07  41
matrixmult:(nb:,nuax:,ns:)#            Compute the solution (multip     RW07  42
#                                        Of a matrix and a vector).     RW07  43
REPEAT#                                Loop over iteration improvem     RW07  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RW07  45
matrixmult:(ns:,nuac:,nd:)#            Multiplication of m and v.       RW07  46
DO I=1,NPARA#                          Loop for computing the resid     RW07  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RW07  48
bd:(I)=bba:(I)-bd:(I)#                 Residual of the normal equat     RW07  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RW07  50
#                                                                       RW07  51
matrixmult:(nd:,nuax:,nr:)#            Multiplication of m and v.       RW07  52
SNORM=0.0#                             Initialization of s norm,        RW07  53
RNORM=0.0#                             And r norm.                      RW07  54
#                                                                       RW07  55
FOR (I=1;I<=NPARA;I=I+1)#              Loop for computing the norm.     RW07  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RW07  57
SNORM=SNORM+bs:(I)*bs:(I)#             S norm.                          RW07  58
RNORM=RNORM+br:(I)*br:(I)#             R norm.                          RW07  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RW07  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RW07  61
FOR (I=1;I<=NPARA;I=I+1)#              Loop for improving the solut     RW07  62
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RW07  63
bs:(I)=bs:(I)+br:(I)#                  Adding the correction part o     RW07  64
#                                        Normal equation.               RW07  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RW07  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RW07  67
PERCEN=RNORM/SNORM#                                                     RW07  68
#                                                                       RW07  69
IF (!(PERCEN<1.001))#                  Divergence.                      RW07  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RW07  71
INDEX=999#                             Error code.                      RW07  72
writeline:(1,RW77,NRW77,3,3)#          Error message.                   RW07  73
RETURN#                                Quit.                            RW07  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RW07  75
ELSE IF (PERCEN<1.0E-4)  BREAK#        Converge.                        RW07  76
ELSE IF (ITERA>10)#                    Otherwise...                     RW07  77
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RW07  78
INDEX=99#                              Error code.                      RW07  79
writeline:(1,RW76,NRW76,3,3)#          Error message.                   RW07  80
RETURN#                                Quit.                            RW07  81
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RW07  82
ELSE ITERA=ITERA+1#                    Next iteration.                  RW07  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RW07  84
writeline:(2,RW71,NRW71,3,3)#          "solution of the equation"       RW07  85
#                                                                       RW07  86
FOR (I=1;I<=NPARA;I=I+1)#              Loop for converting the vria     RW07  87
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RW07  88
J0=MARK5+I#                            Pointer...                       RW07  89
J1=DMARK4+I#                           Pointer...                       RW07  90
QX(J0)=single:(DQX(J1))#               Double to single.                RW07  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RW07  92
##                                                                      RW07  93
##       PRINT THE SOLUTION                                             RW07  94
##     **********************                                           RW07  95
##                                                                      RW07  96
ncodefld:(QX,MARK5+1,CHROT,MFM,NPARA)# Formatting...                    RW07  97
writeline:(1,0,0,1,3)#                 Printing                         RW07  98
writeline:(2,RW710,NRW710,3,3)#                                         RW07  99
writeline:(1,RW78,NRW78,3,3)#                                           RW07 100
writeline:(0,RW79,NRW79,3,3)#                                           RW07 101
movechar:(RW78,1,RW711,1,4,1)#                                          RW07 102
writeline:(2,RW711,NRW711,3,3)#                                         RW07 103
movechar:(RW71,1,CHROT,1,15,1)#                                         RW07 104
ncodefld:(FOMAX,1,RW712,450622.,1)#                                     RW07 105
movechar:(RW712,1,CHROT,16,NRW712,0)#                                   RW07 106
writeline:(1,0,0,1,3)#                                                  RW07 107
movechar:(RW71,1,CHROT,1,15,1)#                                         RW07 108
ncodefld:(STOLM,1,RW713,450642.,1)#                                     RW07 109
movechar:(RW713,1,CHROT,16,NRW713,0)#                                   RW07 110
writeline:(1,0,0,1,3)#                                                  RW07 111
#                                                                       RW07 112
FOR (I=1;I<=NPARA;I=I+1)#              Loop for printing the coeffi     RW07 113
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RW07 114
J0=I*8-7#                              Pointer...                       RW07 115
movechar:(RW75,J0,CHROT,15,8,0)#                                        RW07 116
movechar:(RW712,7,CHROT,24,2,0)#                                        RW07 117
TEMP=ABS(NINT(bs:(I)))#                Pointer...                       RW07 118
DO J0=1,8#                             Loop for dynamicl formatting     RW07 119
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RW07 120
TEMP=TEMP/10#                          Counting the # of integer di     RW07 121
IF (TEMP<=0) BREAK#                    Testing...                       RW07 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RW07 123
ncodefld:(single:(bs:(I)),1,CHROT,FM(J0),1)# Formatting..               RW07 124
movechar:(RW78,1,CHROT,1,14,1)#                                         RW07 125
writeline:(1,0,0,1,3)#                 Printing...                      RW07 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RW07 127
#                                                                       RW07 128
RETURN#                                Return to calling routine.       RW07 129
END#                                                                    RW07 130
systemheader:(RW08)#                   Matrix multiplication for        RW08   1
#                                        Packed triangular matrix.      RW08   2
# ####################################################################  RW08   3
#                                                                    #  RW08   4
#                            RW08                                    #  RW08   5
#                                                                    #  RW08   6
# ####################################################################  RW08   7
SUBROUTINE RW08(NB,NUAC,NS)#                                            RW08   8
#                                        H. wang b. e. robertson 1985   RW08   9
include:(AACOMN)#                                                       RW08  10
include:(RWCOMN)#                                                       RW08  11
#                                                                       RW08  12
INTEGER I,IJ,J,NB,NS,NUAC#                                              RW08  13
dbledata:(ZERO,[0.0D+0])#              Zero                             RW08  14
datastuff:#                                                             RW08  15
##                                                                      RW08  16
FOR (I=1;I<=NPARA;I=I+1)#              Loop for initialization.         RW08  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RW08  18
bt:(I)=ZERO#                           Initialization.                  RW08  19
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RW08  20
#                                                                       RW08  21
DO I=1,NPARA#                          1st loop for matrix multipli     RW08  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RW08  23
DO J=I,NPARA#                          2nd loop for matrix multipli     RW08  24
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RW08  25
ik:(I,J)#                              Pointer of packed matrix         RW08  26
bt:(I)=bt:(I)+tac:(I,J)*bbb:(J)#       Multiplication of upper part     RW08  27
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RW08  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RW08  29
DO J=2,NPARA#                          1st loop for matrix multipli     RW08  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RW08  31
DO I=1,J-1#                            2nd loop for matrix multipli     RW08  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RW08  33
ik:(I,J)#                              Evaluate the index of matrix     RW08  34
bt:(J)=bt:(J)+tac:(I,J)*bbb:(I)#       Multiplication of lower part     RW08  35
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RW08  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RW08  37
RETURN#                                Return to calling routine.       RW08  38
#                                                                       RW08  39
END#                                                                    RW08  40
systemheader:(RW09)#                   Compute the weight from weig     RW09   1
#                                        Function and analyze weights   RW09   2
# ####################################################################  RW09   3
#                                                                    #  RW09   4
#                            RW09                                    #  RW09   5
#                                                                    #  RW09   6
# ####################################################################  RW09   7
SUBROUTINE RW09#                                                        RW09   8
#                                        H. wang b. e. robertson 1985   RW09   9
include:(AACOMN)#                                                       RW09  10
include:(RWCOMN)#                                                       RW09  11
#                                                                       RW09  12
REAL HKL(3)#                           H.k.l.                           RW09  13
INTEGER I,IBOT,IDSN,IP,IPO,IPSIZE,ITOP,J,J0,K,KEYK,L,MODIFY,MULT#       RW09  14
INTEGER II,IN,JJ,NEST,NUMR0,NUMR1#                                      RW09  15
REAL ARFAC0,ARFAC1,AWRFA0,AWRFA1,DMEAN0,DMEAN1,FADIS,FBDIS,FDIF#        RW09  16
REAL RFACT0,RFACT1,SCLFCT,SFGN,TEMP,WDIF,WFOBS,WRFAC0,WRFAC1#           RW09  17
REAL WTMIN,WTMAX#                                                       RW09  18
INTEGER IWNT(20)#                      Directory parameters of          RW09  19
INTEGER IR(21)#                        Logical record of b.d.f          RW09  20
INTEGER PACKET#                        Packet size                      RW09  21
INTEGER NREFL#                         Reflection count                 RW09  22
REAL SKEWN0,SKEWN1,KURTO0,KURTO1#      Coef. of skewness $ kurtosis     RW09  23
#                                                                       RW09  24
chardata:(RW91,     H   K   L   STOL $##                                RW09  25
 SG RD    FOBS    FCAL    SIGF    FDIF$#                                RW09  26
    LSWT    WDIF )#                                                     RW09  27
chardata:(RW92,* MAP OF WEIGHT ANALYSIS   )#                            RW09  28
chardata:(RW93,[ FOBS ----------------------- > ])#                     RW09  29
chardata:(RW94, STOL)#                                                  RW09  30
chardata:(RW96,* THE DISTRIBUTION MAP OF THE REFLECTIONS  )#            RW09  31
chardata:(RW97,[* THE WEIGHTED R*(      ) MAP ])#                       RW09  32
chardata:(RW98,    THE SCALE FACTOR OF THE MAP           )#             RW09  33
chardata:(RW99, I )#                                                    RW09  34
chardata:(RW101,-)#                                                     RW09  35
chardata:(RW09A,  STATISTICS TABLE FOR OBSERVED REFLECTIONS )#          RW09  36
chardata:(RW09B,  STATISTICS TABLE FOR ALL REFLECTIONS )#               RW09  37
chardata:(RW09F,  NUMBER OF REFLECTIONS )#                              RW09  38
chardata:(RW09G,  R-FACTOR )#                                           RW09  39
chardata:(RW09H,  WR-FACTOR )#                                          RW09  40
chardata:(RW09I,  [< SUM (WEIGHTED DELTA)**2 > ])#                      RW09  41
chardata:(RW09J,  [< SUM WEIGHTED DELTA > ])#                           RW09  42
chardata:(RW09K,  MAXIMUM WEIGHT )#                                     RW09  43
chardata:(RW09L,  MINIMUM WEIGHT )#                                     RW09  44
chardata:(RW09M,  NUMBER OF MODIFIED WEIGHTS )#                         RW09  45
chardata:(RW09N,  MOMENT COEFFICIENT OF SKEWNESS )#                     RW09  46
chardata:(RW09O,  MOMENT COEFFICIENT OF KURTOSIS )#                     RW09  47
#                                        Format codes:                  RW09  48
realdata:(FMT,[60313.,100313.,140313.,$# H k l...                       RW09  49
210642.,250213.,280213.,360722.,$#     Stol,sg,rc,fobs...               RW09  50
440722.,520722.,600722.,680722.,$#     Fcal,sigf,fdif,lswt...           RW09  51
760722.])#                             Wdif.                            RW09  52
realdata:(MFM,[120513.,170513.,220513.,$## Format codes:                RW09  53
270513.,320513.,370513.,420513.,470513.,$#                              RW09  54
520513.,570513.,620513.,670513.,720513.,$#                              RW09  55
770513.,820513.,870613.,920513.,970513.,$#                              RW09  56
1020513.,1070513.,1120513.,1170513.,1220513.])#                         RW09  57
datastuff:#                                                             RW09  58
#                                                                       RW09  59
movereal:(0.0,1,QX,MARK9+1,NGF,2)#     Initialization of accumulato     RW09  60
movereal:(0.0,1,QX,MARK10+1,NGS,2)#    For weight analysis              RW09  61
MULT=NGF*NGS#                          Number of grids of w.a. map      RW09  62
movereal:(0.0,1,QX,MARK11+1,MULT,2)#   Clear accumulator for weight     RW09  63
movereal:(0.0,1,QX,MARK12+1,MULT,2)#   Analysis                         RW09  64
movereal:(0.0,1,QX,MARK13+1,MULT,2)#                                    RW09  65
movereal:(0.0,1,QX,MARK14+1,MULT,2)#                                    RW09  66
movereal:(0.0,1,QX,MARK15+1,MULT,2)#                                    RW09  67
movereal:(0.0,1,QX,MARK16+1,NGF,2)#                                     RW09  68
#                                  ALL REFLECTIONS                      RW09  69
NUMR0=0#                                                                RW09  70
RFACT0=0.0#                                                             RW09  71
ARFAC0=0.0#                                                             RW09  72
WRFAC0=0.0#                                                             RW09  73
AWRFA0=0.0#                                                             RW09  74
DMEAN0=0.0#                                                             RW09  75
SKEWN0=0.0#                                                             RW09  76
KURTO0=0.0#                                                             RW09  77
#                                  OBSERVED REFLECTIONS                 RW09  78
NUMR1=0#                                                                RW09  79
RFACT1=0.0#                                                             RW09  80
ARFAC1=0.0#                                                             RW09  81
WRFAC1=0.0#                                                             RW09  82
AWRFA1=0.0#                                                             RW09  83
DMEAN1=0.0#                                                             RW09  84
SKEWN1=0.0#                                                             RW09  85
KURTO1=0.0#                                                             RW09  86
#                                  MAXIMUM AND MINIMUM WEIGHTS.         RW09  87
IF(TYPE==1) NEST=no:#                                                   RW09  88
IF(TYPE==2) NEST=yes:#                                                  RW09  89
MODIFY=0#                                                               RW09  90
WTMAX=-1.0#                                                             RW09  91
WTMIN=999.#                                                             RW09  92
#                                         If regina or normal weight    RW09  93
##                                       ESTIMATION ARE SPECIFIED,      RW09  94
##          UPDATE THE BDF               THE BINARY DATA FILE WILL      RW09  95
##        ******************             UPDATE.                        RW09  96
##                                                                      RW09  97
IF (TYPE!=1)#                          Weight estimation.               RW09  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RW09  99
rewindbdf:(1)#                         Rewind the binary data file.     RW09 100
copyfile:(1,2,1,decr:(lrrefl:))#       Copy lr1-19                      RW09 101
NREFL=0#                               Reset reflection count           RW09 102
##                                                                      RW09 103
##  RETRIEVED THE DIRECTORY OF "REFL"                                   RW09 104
## **********************************                                   RW09 105
##                                                                      RW09 106
IDSN=NINT(DSNM)*1000#                  Data set number                  RW09 107
IWNT(1)=1#                             H,k,l                            RW09 108
IWNT(2)=2#                             Sin(theta)/lamdar                RW09 109
IWNT(3)=IDSN+298+RFTYPE*2#             Obs. structure factor.           RW09 110
IWNT(4)=IDSN+800#                      Calculated structure factor.     RW09 111
IWNT(5)=IDSN+299+RFTYPE*2#             Standard deviation of freal      RW09 112
IWNT(6)=IDSN+308#                      Code of reflection type.         RW09 113
IWNT(7)=IDSN+309#                      Scale group number.              RW09 114
IWNT(8)=IDSN+204#                      Lorentz-polarization factor      RW09 115
IWNT(9)=IDSN+900#                      Least squares weight.            RW09 116
IWNT(10)=IDSN+901#                     Least squares weight-1.          RW09 117
IWNT(11)=IDSN+902#                     Least squares weight-2.          RW09 118
IWNT(12)=IDSN+903#                     Least squares weight-3.          RW09 119
IWNT(13)=IDSN+805#                     A(total) with dispersion cor     RW09 120
IWNT(14)=IDSN+806#                     B(total) with dispersion cor     RW09 121
IWNT(15)=IDSN+900#                     Least squares weight.            RW09 122
FOR (J=1;J<=IARC;J=J+1)#               Setting archive parameters       RW09 123
IWNT(J+15)=CARCH(J)#                                                    RW09 124
KEY(1)=5; KEY(2)=14; KEY(3)=15+IARC#   Set search delimiters.           RW09 125
KEY(4)=1#                              (update mode)                    RW09 126
indexpkt:(1,lrrefl:,PACKET,IP,2,KEY,$## Get relative pointers of        RW09 127
IWNT,IR)#                              Logical record: refl.            RW09 128
IF (KEY(4)<0) iquit:(RW0901)#          Data missing.......rw0901.       RW09 129
IPSIZE=KEY(4)#                         Return packet size.              RW09 130
#                                                                       RW09 131
#--------------------------------------# POINTER:                       RW09 132
IPHKL=IR(1)#                           -hkl.                            RW09 133
ISTOL=IR(2)#                           -sin(theta)/l.                   RW09 134
IFOBS=IR(3)#                           -observed structure factor.      RW09 135
IFCAL=IR(4)#                           -calculated structure factor     RW09 136
ISIGC=IR(5)#                           -standard deviation of f(rea     RW09 137
IRCOD=IR(6)#                           -rcord.                          RW09 138
ISFGN=IR(7)#                           -number of scale group.          RW09 139
IRCLP=IR(8)#                           -lorentz-polarization factor     RW09 140
ILSWO=IR(9)#                           -least squares weight.(for o     RW09 141
ILSW1=IR(10)#                          -least squares weight 1.         RW09 142
ILSW2=IR(11)#                          -least squares weight 2.         RW09 143
ILSW3=IR(12)#                          -least squares weight 3.         RW09 144
IFADS=IR(13)#                          -a(total) with dispersion co     RW09 145
IFBDS=IR(14)#                          -b(total) with dispersion co     RW09 146
ILSWT=IR(15)#                          -least squares weight.(for a     RW09 147
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RW09 148
WOLD=1.0#                              Default old weight.              RW09 149
KEYK=KEY(2)+1#                         Set op iwnt limit                RW09 150
ITOP=KEY(2)+2#                         Set op iwnt limit                RW09 151
IBOT=KEY(3)#                           Set op iwnt limit                RW09 152
IF((LWANAL==4)&(ILSW1<0)) iquit:(RW0934)# R                             RW09 153
IF((LWANAL==5)&(ILSW2<0)) iquit:(RW0934)# R                             RW09 154
IF((LWANAL==6)&(ILSW3<0)) iquit:(RW0934)# R                             RW09 155
LINRM=4#                               Force list header for reflns     RW09 156
#                                                                       RW09 157
##                                                                      RW09 158
##        COMPUTING THE WEIGHT                                          RW09 159
##      ************************                                        RW09 160
##                                                                      RW09 161
REPEAT#                                Loop for calucating the weig     RW09 162
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RW09 163
readwpkt:(1,lrrefl:,PACKET,IP,0)#      Read reflection data from bd     RW09 164
IF (IP<=0) BREAK#                      Exit if no more data in lr       RW09 165
IF ((TYPE==2)\(TYPE==3))#              Update the binary data file.     RW09 166
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RW09 167
writepkt:(2,lrrefl:,IPSIZE,IPO)#       Get pointer of output buffer     RW09 168
#                                                                       RW09 169
I=IP+1#                                Input pointer of buffer...       RW09 170
J=IPO+1#                               Output pointer of buffer...      RW09 171
K=KEYK#                                Key pointer of update inform     RW09 172
FOR (L=1;L<=PACKET;L=L+1)#             Dump data from in_buffer to      RW09 173
#                                        Out_buffer                     RW09 174
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RW09 175
movepakwd:(QX(I),QX(J))#               Move ip to ipo..                 RW09 176
IF (IR(K)==L)  K=K+1#                  Skip current item.               RW09 177
ELSE           J=J+1#                  Next...                          RW09 178
I=I+1#                                 More...                          RW09 179
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RW09 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RW09 181
#                                        Store the reflection informati RW09 182
#                                        The i/o buffer to....          RW09 183
STOL=QX(IP+ISTOL)#                     ...stol                          RW09 184
FOBS=QX(IP+IFOBS)#                     ...fobs                          RW09 185
FCAL=QX(IP+IFCAL)#                     ...fcal                          RW09 186
IF(DISPER==1)#                         Dispersion correction is req     RW09 187
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RW09 188
FADIS=QX(IP+IFADS)#                    A(total) with dispersion cor     RW09 189
FBDIS=QX(IP+IFBDS)#                    B(total) with dispersion cor     RW09 190
FCAL=SQRT(FADIS*FADIS+FBDIS*FBDIS)#    Calculated :f: with dispersi     RW09 191
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RW09 192
#                                                                       RW09 193
IF (RFTYPE==1)#                        Calculated intensity.            RW09 194
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RW09 195
IF (IRCLP==0) iquit:(RW0903)#          Lp factor missing...rw0903.      RW09 196
RLP=QX(IP+IRCLP)#                      Get lp factor from buffer.       RW09 197
FCAL=FCAL*FCAL*RLP#                    Calculated intensity.            RW09 198
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RW09 199
IF(RFTYPE==2) FCAL=FCAL*FCAL#          Calculated f square.             RW09 200
SIGC=QX(IP+ISIGC)#                     ...sigc                          RW09 201
IF (ILSW1>0) LSW1=QX(IP+ILSW1)#        ...lsw1                          RW09 202
IF (ILSW2>0) LSW2=QX(IP+ILSW2)#        ...lsw2                          RW09 203
IF (ILSW3>0) LSW3=QX(IP+ILSW3)#        ...lsw3                          RW09 204
#                                                                       RW09 205
IF (ISFGN==0) SFGN=1.0#                Scale factor (default)           RW09 206
ELSE          SFGN=QX(IP+ISFGN)#       Scale factor (user)              RW09 207
#                                                                       RW09 208
J0=MARK0+NINT(SFGN)#                   Pointer of scale factor.         RW09 209
SCLFCT=QX(J0)#                         Scale factor.                    RW09 210
IF (RFTYPE<3) SCLFCT=SCLFCT*SCLFCT#                                     RW09 211
FOBS=FOBS*SCLFCT#                      Scaling...                       RW09 212
SIGC=SIGC*SCLFCT#                      Scaling...                       RW09 213
FDIF=FOBS-FCAL#                        Difference between obs. and      RW09 214
#                                                                       RW09 215
IF (TYPE==1)#                          Weight analysis.                 RW09 216
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RW09 217
IF(LWANAL==1) LSWT=1.#                 Unit weight                      RW09 218
ELSE IF(LWANAL==2)#                                                     RW09 219
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RW09 220
IF(SIGC>.001)LSWT=1./SIGC#             Sigma weight                     RW09 221
ELSE         LSWT=1.0#                 Default to one                   RW09 222
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RW09 223
ELSE IF(LWANAL==3) LSWT=QX(PWANAL+IP)# Weight from bdf                  RW09 224
ELSE IF(LWANAL==4) LSWT=LSW1#          Weight from bdf (1901)           RW09 225
ELSE IF(LWANAL==5) LSWT=LSW2#          Weight from bdf (1902)           RW09 226
ELSE               LSWT=LSW3#          Weight from bdf (1903)           RW09 227
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RW09 228
ELSE IF (TYPE==2) CALL RW11#           Normal weighting scheme.         RW09 229
ELSE              CALL RW10(NEST)#     Regina weighting scheme.         RW09 230
#                                                                       RW09 231
IF(NEST==yes:) MODIFY=MODIFY+1#                                         RW09 232
#                                                                       RW09 233
WDIF=LSWT*FDIF#                        Weighted difference.             RW09 234
IF (TYPE!=1)#                          Weight estimation                RW09 235
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RW09 236
IF (ILSWO>0) WOLD=QX(IP+ILSWO)#        Retrive old weight in loc.99     RW09 237
QX(J)=LSWT#                            Transfer new weight to outpu     RW09 238
J=J+1#                                 Next iten                        RW09 239
FOR (I=ITOP;I<=IBOT;I=I+1)#            Save old weight.                 RW09 240
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RW09 241
IF (IWNT(I)<0) NEXT#                   Skip delete items.               RW09 242
QX(J)=WOLD#                            Transfer old weight to outpu     RW09 243
J=J+1#                                 Next itern                       RW09 244
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RW09 245
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RW09 246
IF(IRCOD>0) RCOD=QX(IP+IRCOD)#         Get code from input buffer       RW09 247
ELSE        RCOD=1#                    Assume to be observed            RW09 248
#                                                                       RW09 249
##  STATISTICS TABLE OF REFLECTIONS                                     RW09 250
## *********************************                                    RW09 251
##                                                                      RW09 252
NUMR0=NUMR0+1#                                                          RW09 253
RFACT0=RFACT0+ABS(FDIF)#                                                RW09 254
ARFAC0=ARFAC0+ABS(FOBS)#                                                RW09 255
TEMP=WDIF*WDIF#                                                         RW09 256
WRFAC0=WRFAC0+TEMP#                                                     RW09 257
WFOBS=FOBS*LSWT#                                                        RW09 258
AWRFA0=AWRFA0+WFOBS*WFOBS#                                              RW09 259
DMEAN0=DMEAN0+WDIF#                                                     RW09 260
SKEWN0=SKEWN0+WDIF*TEMP#                                                RW09 261
KURTO0=KURTO0+TEMP*TEMP#                                                RW09 262
IF(LSWT>WTMAX) WTMAX=LSWT#                                              RW09 263
IF(LSWT<WTMIN) WTMIN=LSWT#                                              RW09 264
##                                                                      RW09 265
##     PRINT THE REFLECTION DATA                                        RW09 266
##    ***************************                                       RW09 267
##                                                                      RW09 268
NREFL=NREFL+1#                         Count reflections                RW09 269
IF (LIST==yes:&MOD(NREFL,LISTFR)==0)#  ********* listing w.t. *****     RW09 270
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RW09 271
gethkl:(IP+IPHKL,HKL)#                 Get h,k,l from input buffer.     RW09 272
#                                        Put  following  iterns  to     RW09 273
#                                        Output buffer:                 RW09 274
BUFOT(1)=STOL#                         Stol,                            RW09 275
BUFOT(2)=SFGN#                         Scale factor group,              RW09 276
BUFOT(3)=FLOAT(RCOD)#                  Rcode (reflection type),         RW09 277
BUFOT(4)=FOBS#                         Fobs (observed structure fac     RW09 278
BUFOT(5)=FCAL#                         Fcal (calculated structure f     RW09 279
BUFOT(6)=SIGC#                         Sigc (s.d. of fobs),             RW09 280
BUFOT(7)=FDIF#                         Difference of sturcture fact     RW09 281
BUFOT(8)=LSWT#                         Least squares weight,            RW09 282
BUFOT(9)=WDIF#                         Weighted difference.             RW09 283
#                                                                       RW09 284
ncodefld:(HKL   ,1,CHROT,FMT(1),3)#    Format h,k,l.                    RW09 285
ncodefld:(BUFOT,1,CHROT,FMT(4),9)#     Format iterns in the buffer      RW09 286
IF(NEST==yes:) movechar:(RW92,1,CHROT,78,1,0)#                          RW09 287
writeline:(0,RW91,NRW91,1,1)#          Printing...                      RW09 288
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RW09 289
##                                                                      RW09 290
##        WEIGHT ANALYSIS MAP                                           RW09 291
##      ***********************                                         RW09 292
##                                                                      RW09 293
IF (RCOD<=RCODE)#                      Only for observed reflection     RW09 294
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RW09 295
##  STATISTICS TABLE OF REFLECTIONS                                     RW09 296
## *********************************                                    RW09 297
##                                                                      RW09 298
NUMR1=NUMR1+1#                                                          RW09 299
RFACT1=RFACT1+ABS(FDIF)#                                                RW09 300
ARFAC1=ARFAC1+ABS(FOBS)#                                                RW09 301
TEMP=WDIF*WDIF#                                                         RW09 302
WRFAC1=WRFAC1+TEMP#                                                     RW09 303
WFOBS=FOBS*LSWT#                                                        RW09 304
AWRFA1=AWRFA1+WFOBS*WFOBS#                                              RW09 305
DMEAN1=DMEAN1+WDIF#                                                     RW09 306
SKEWN1=SKEWN1+TEMP*WDIF#                                                RW09 307
KURTO1=KURTO1+TEMP*TEMP#                                                RW09 308
FOR (II=1;II<=NGF;II=II+1)#            Grid points alone fobs           RW09 309
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RW09 310
IF (FOBS>fgrid:(II)) NEXT#             Find proper position.            RW09 311
FOR (JJ=1;JJ<=NGS;JJ=JJ+1)#            Grid points alone stol           RW09 312
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RW09 313
IF (STOL>sgrid:(JJ)) NEXT#             Find proper position.            RW09 314
numpt:(II,JJ)=numpt:(II,JJ)+1.0000#    Counting reflection in the       RW09 315
#                                        Grid point.                    RW09 316
diff2:(II,JJ)=diff2:(II,JJ)+WDIF*WDIF# Accumulating wdif*wdif           RW09 317
ffobs:(II,JJ)=ffobs:(II,JJ)+WFOBS*WFOBS# Accumulating wfobs*wfobs       RW09 318
BREAK#                                 Exit                             RW09 319
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RW09 320
BREAK#                                                                  RW09 321
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RW09 322
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RW09 323
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RW09 324
##                                       PRINT THE DISTRIBUTION MAP     RW09 325
##     PRINT THE DISTRIBUTION MAP        OF REFLECTIONS.                RW09 326
##    ****************************                                      RW09 327
##                                                                      RW09 328
IF ((NGF>0) \ (NGS>0))#                If grid points are given         RW09 329
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RW09 330
LINCT=0#                               Print flag...                    RW09 331
movechar:(RW92,1,CHROT,21,5,1)#        Formating...                     RW09 332
movechar:(RW96,1,CHROT,26,NRW96,0)#    Formating...                     RW09 333
IN=NRW96+26#                           Pointer...                       RW09 334
movechar:(RW92,1,CHROT,IN,6,1)#        Formating...                     RW09 335
writeline:(3,0,0,1,3)#                 Printing...                      RW09 336
movechar:(RW94,1,CHROT,2,NRW94,0)#     Formating...                     RW09 337
movechar:(RW93,1,CHROT,14,NRW93,0)#    Formating...                     RW09 338
writeline:(1,0,0,1,3)#                 Printing...                      RW09 339
ncodefld:(QX,MARK7+1,CHROT,MFM,NGF)#   Formating...                     RW09 340
writeline:(1,0,0,1,3)#                 Printing...                      RW09 341
IN=5*NGF+1#                            Pointer...                       RW09 342
movechar:(RW93,10,CHROT,9,IN,1)#       Formating...                     RW09 343
writeline:(0,0,0,1,3,)#                Printing...                      RW09 344
#                                                                       RW09 345
FOR (I=1;I<=NGS;I=I+1)#                                                 RW09 346
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RW09 347
FOR (J=1;J<=NGF;J=J+1)#                                                 RW09 348
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RW09 349
K=MARK15+J#                                                             RW09 350
QX(K)=numpt:(J,I)#                                                      RW09 351
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RW09 352
ncodefld:(QX,MARK8+I,CHROT,50432.,1)#  Formating...                     RW09 353
movechar:(RW99,1,CHROT,6,NRW99,0 )#    Formating...                     RW09 354
ncodefld:(QX,MARK15+1,CHROT,MFM,NGF)#  Formating...                     RW09 355
writeline:(0,0,0,1,3)#                 Printing...                      RW09 356
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RW09 357
ncodefld:(MAPSCL,1,RW98,420902.,1)#    Formating...                     RW09 358
writeline:(3,RW98,NRW98,3,3)#          Printing...                      RW09 359
##                                                                      RW09 360
##       PRINT THE WEIGHTING MAP                                        RW09 361
##      *************************                                       RW09 362
##                                                                      RW09 363
movechar:(RW92,1,CHROT,21,5,1)#                                         RW09 364
movechar:(RW92,1,CHROT,26,NRW92,0)#                                     RW09 365
IN=NRW92+26#                                                            RW09 366
movechar:(RW92,1,CHROT,IN,6,1)#                                         RW09 367
writeline:(2,0,0,1,3)#                                                  RW09 368
movechar:(RW94,1,CHROT,2,NRW94,0)#                                      RW09 369
movechar:(RW93,1,CHROT,14,NRW93,0)#                                     RW09 370
writeline:(1,0,0,1,3)#                                                  RW09 371
ncodefld:(QX,MARK7+1,CHROT,MFM,NGF)#                                    RW09 372
writeline:(1,0,0,1,3)#                                                  RW09 373
IN=5*NGF+1#                                                             RW09 374
movechar:(RW93,10,CHROT,9,IN,1)#                                        RW09 375
writeline:(0,0,0,1,3,)#                                                 RW09 376
#                                                                       RW09 377
FOR (I=1;I<=NGS;I=I+1)#                                                 RW09 378
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RW09 379
FOR (J=1;J<=NGF;J=J+1)#                                                 RW09 380
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 RW09 381
IF (J>18) BREAK#                                                        RW09 382
K=MARK15+J#                                                             RW09 383
IF (numpt:(J,I)<=0.5) QX(K)=-99.#                                       RW09 384
ELSE QX(K)=MAPSCL*diff2:(J,I)/numpt:(J,I)#                              RW09 385
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 RW09 386
ncodefld:(QX,MARK8+I,CHROT,50432.,1)#                                   RW09 387
movechar:(RW99,1,CHROT,6,NRW99,0 )#                                     RW09 388
J=J-1#                                                                  RW09 389
ncodefld:(QX,MARK15+1,CHROT,MFM,J)#                                     RW09 390
writeline:(0,0,0,1,3)#                                                  RW09 391
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RW09 392
##                                                                      RW09 393
##      PRINT THE WEIGHTED R MAP                                        RW09 394
##     **************************                                       RW09 395
##                                                                      RW09 396
movechar:(RW92,1,CHROT,21,5,1)#                                         RW09 397
ncodefld:(MAPRSC,1,RW97,240513.,1)#                                     RW09 398
movechar:(RW97,1,CHROT,26,NRW97,0)#                                     RW09 399
IN=NRW97+26#                                                            RW09 400
movechar:(RW92,1,CHROT,IN,6,1)#                                         RW09 401
writeline:(3,0,0,1,3)#                                                  RW09 402
movechar:(RW94,1,CHROT,2,NRW94,0)#                                      RW09 403
movechar:(RW93,1,CHROT,14,NRW93,0)#                                     RW09 404
writeline:(1,0,0,1,3)#                                                  RW09 405
ncodefld:(QX,MARK7+1,CHROT,MFM,NGF)#                                    RW09 406
writeline:(1,0,0,1,3)#                                                  RW09 407
IN=5*NGF+1#                                                             RW09 408
movechar:(RW93,10,CHROT,9,IN,1)#                                        RW09 409
writeline:(0,0,0,1,3,)#                                                 RW09 410
#                                                                       RW09 411
FOR (I=1;I<=NGS;I=I+1)#                                                 RW09 412
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 RW09 413
FOR (J=1;J<=NGF;J=J+1)#                                                 RW09 414
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 RW09 415
IF (J>18) BREAK#                                                        RW09 416
K=MARK15+J#                                                             RW09 417
IF (ffobs:(J,I)<0.5) QX(K)=-99.0#                                       RW09 418
ELSE QX(K)=MAPRSC*SQRT(diff2:(J,I)/ffobs:(J,I))#                        RW09 419
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 RW09 420
ncodefld:(QX,MARK8+I,CHROT,50432.,1)#                                   RW09 421
movechar:(RW99,1,CHROT,6,NRW99,0 )#                                     RW09 422
J=J-1#                                                                  RW09 423
ncodefld:(QX,MARK15+1,CHROT,MFM,J)#                                     RW09 424
writeline:(0,0,0,1,3)#                                                  RW09 425
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 RW09 426
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RW09 427
IF (TYPE!=1) copyfile:(1,2,incr:(lrrefl:),endrecord:)#                  RW09 428
#                                                                       RW09 429
# PRINT STATISTICS TABLE                                                RW09 430
# ----------------------                                                RW09 431
#                                                                       RW09 432
# OBSERVED REFLECTIONS                                                  RW09 433
#                                                                       RW09 434
writeline:(2,RW09A,NRW09A,3,3)#        Title of stats table (obser      RW09 435
movechar:(RW09F,1,CHROT,10,NRW09F,0)#                                   RW09 436
TEMP=FLOAT(NUMR1)#                                                      RW09 437
ncodefld:(TEMP,1,CHROT,650613.,1)#                                      RW09 438
writeline:(1,0,0,1,3)#                                                  RW09 439
movechar:(RW09G,1,CHROT,10,NRW09G,0)#                                   RW09 440
TEMP=RFACT1/ARFAC1#                                                     RW09 441
ncodefld:(TEMP,1,CHROT,651532.,1)#                                      RW09 442
writeline:(0,0,0,1,3)#                                                  RW09 443
movechar:(RW09H,1,CHROT,10,NRW09H,0)#                                   RW09 444
TEMP=SQRT(WRFAC1/AWRFA1)#                                               RW09 445
ncodefld:(TEMP,1,CHROT,651532.,1)#                                      RW09 446
writeline:(0,0,0,1,3)#                                                  RW09 447
movechar:(RW09I,1,CHROT,10,NRW09I,0)#                                   RW09 448
TEMP=SQRT(WRFAC1/FLOAT(NUMR1))#                                         RW09 449
ncodefld:(TEMP,1,CHROT,651532.,1)#                                      RW09 450
writeline:(0,0,0,1,3)#                                                  RW09 451
movechar:(RW09J,1,CHROT,10,NRW09J,0)#                                   RW09 452
TEMP=DMEAN1/FLOAT(NUMR1)#                                               RW09 453
ncodefld:(TEMP,1,CHROT,651532.,1)#                                      RW09 454
writeline:(0,0,0,1,3)#                                                  RW09 455
movechar:(RW09N,1,CHROT,10,NRW09N,0)#                                   RW09 456
TEMP=SKEWN1/FLOAT(NUMR1)#                                               RW09 457
ncodefld:(TEMP,1,CHROT,651532.,1)#                                      RW09 458
writeline:(0,0,0,1,3)#                                                  RW09 459
movechar:(RW09O,1,CHROT,10,NRW09O,0)#                                   RW09 460
TEMP=KURTO1/FLOAT(NUMR1)#                                               RW09 461
ncodefld:(TEMP,1,CHROT,651532.,1)#                                      RW09 462
writeline:(0,0,0,1,3)#                                                  RW09 463
#                                                                       RW09 464
# ALL REFLECTIONS                                                       RW09 465
#                                                                       RW09 466
writeline:(2,RW09B,NRW09B,3,3)#        Title of stats table (all)       RW09 467
movechar:(RW09F,1,CHROT,10,NRW09F,0)#                                   RW09 468
TEMP=FLOAT(NUMR0)#                                                      RW09 469
ncodefld:(TEMP,1,CHROT,650613.,1)#                                      RW09 470
writeline:(1,0,0,1,3)#                                                  RW09 471
movechar:(RW09G,1,CHROT,10,NRW09G,0)#                                   RW09 472
TEMP=RFACT0/ARFAC0#                                                     RW09 473
ncodefld:(TEMP,1,CHROT,651532.,1)#                                      RW09 474
writeline:(0,0,0,1,3)#                                                  RW09 475
movechar:(RW09H,1,CHROT,10,NRW09H,0)#                                   RW09 476
TEMP=SQRT(WRFAC0/AWRFA0)#                                               RW09 477
ncodefld:(TEMP,1,CHROT,651532.,1)#                                      RW09 478
writeline:(0,0,0,1,3)#                                                  RW09 479
movechar:(RW09I,1,CHROT,10,NRW09I,0)#                                   RW09 480
TEMP=SQRT(WRFAC0/FLOAT(NUMR0))#                                         RW09 481
ncodefld:(TEMP,1,CHROT,651532.,1)#                                      RW09 482
writeline:(0,0,0,1,3)#                                                  RW09 483
movechar:(RW09J,1,CHROT,10,NRW09J,0)#                                   RW09 484
TEMP=DMEAN0/FLOAT(NUMR0)#                                               RW09 485
ncodefld:(TEMP,1,CHROT,651532.,1)#                                      RW09 486
writeline:(0,0,0,1,3)#                                                  RW09 487
movechar:(RW09K,1,CHROT,10,NRW09K,0)#                                   RW09 488
ncodefld:(WTMAX,1,CHROT,651042.,1)#                                     RW09 489
writeline:(0,0,0,1,3)#                                                  RW09 490
movechar:(RW09L,1,CHROT,10,NRW09L,0)#                                   RW09 491
ncodefld:(WTMIN,1,CHROT,651042.,1)#                                     RW09 492
writeline:(0,0,0,1,3)#                                                  RW09 493
movechar:(RW09M,1,CHROT,10,NRW09M,0)#                                   RW09 494
TEMP=FLOAT(MODIFY)#                                                     RW09 495
ncodefld:(TEMP,1,CHROT,650713.,1)#                                      RW09 496
writeline:(0,0,0,1,3)#                                                  RW09 497
movechar:(RW09N,1,CHROT,10,NRW09N,0)#                                   RW09 498
TEMP=SKEWN0/FLOAT(NUMR1)#                                               RW09 499
ncodefld:(TEMP,1,CHROT,651532.,1)#                                      RW09 500
writeline:(0,0,0,1,3)#                                                  RW09 501
movechar:(RW09O,1,CHROT,10,NRW09O,0)#                                   RW09 502
TEMP=KURTO0/FLOAT(NUMR1)#                                               RW09 503
ncodefld:(TEMP,1,CHROT,651532.,1)#                                      RW09 504
writeline:(0,0,0,1,3)#                                                  RW09 505
#                                                                       RW09 506
RETURN#                                                                 RW09 507
#                                                                       RW09 508
END#                                                                    RW09 509
systemheader:(RW10)#                   Individual point.                RW10   1
# ####################################################################  RW10   2
#                                                                    #  RW10   3
#                            RW10                                    #  RW10   4
#                                                                    #  RW10   5
# ####################################################################  RW10   6
SUBROUTINE RW10(NEST)#                                                  RW10   7
#                                        H. wang b. e. robertson 1985   RW10   8
include:(AACOMN)#                                                       RW10   9
include:(RWCOMN)#                                                       RW10  10
#                                                                       RW10  11
INTEGER I,J0,J1,J2,J3,J4,K0,N,NEST#                                     RW10  12
REAL TEMP#                                                              RW10  13
DOUBLE PRECISION DFOBS,DSTOL#          Fobs and sin(theta)/lanbda       RW10  14
REAL RWT#                              Regina weight                    RW10  15
#                                                                       RW10  16
DFOBS=double:(FOBS)#                   Convert freal to double-type     RW10  17
DSTOL=double:(STOL)#                   Convert stol to double-type.     RW10  18
yb:(1)=1.0D0#                          Initial value                    RW10  19
N=NORD+1#                                                               RW10  20
NEST=yes:#                                                              RW10  21
IF (N>1)#                              If order of the function is      RW10  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RW10  23
J1=1#                                  Pointer...                       RW10  24
FOR (I=1;I<N;I=I+1)#                   For (i=1;i<=npara;i=i+1)#        RW10  25
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RW10  26
J0=J1; J1=J1+I; J2=J1#                 Pointer...                       RW10  27
yb:(J1)=yb:(J0)*DFOBS#                 Terms contained fobs.            RW10  28
FOR (K0=1;K0<=I;K0=K0+1)#              Loop for terms contained sto     RW10  29
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RW10  30
J3=J2+K0#                              Pointer...                       RW10  31
J4=J0+K0-1#                            Pointer...                       RW10  32
yb:(J3)=yb:(J4)*DSTOL#                 Terns contained sin(theta)/l     RW10  33
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RW10  34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RW10  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RW10  36
#                                                                       RW10  37
RWT=0.0#                               Initialization...                RW10  38
FOR (I=1;I<=NPARA;I=I+1)#              Loop for calculating the wei     RW10  39
RWT=single:(bs:(I)*yb:(I))+RWT#        Calculating the modified sig     RW10  40
IF (RWT<=0.0)#                                                          RW10  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RW10  42
RWT=1.0E-25#                           Protection of negative valu      RW10  43
NEST=no:#                                                               RW10  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RW10  45
TEMP=SQRT(SIGC*SIGC+RWT)#              Protect against silly weights    RW10  46
IF(TEMP>.001) LSWT=1.0/TEMP#           Weight. (1/sigma(f)**2)          RW10  47
ELSE          LSWT=1.0#                                                 RW10  48
#                                                                       RW10  49
RETURN#                                Return to calling routine.       RW10  50
END#                                                                    RW10  51
systemheader:(RW11)#                   Normal weighting scheme.         RW11   1
# ####################################################################  RW11   2
#                                                                    #  RW11   3
#                            RW11                                    #  RW11   4
#                                                                    #  RW11   5
# ####################################################################  RW11   6
SUBROUTINE RW11#                                                        RW11   7
#                                        H. wang b. e. robertson 1985   RW11   8
include:(AACOMN)#                                                       RW11   9
include:(RWCOMN)#                                                       RW11  10
#                                                                       RW11  11
INTEGER IWFLD#                                                          RW11  12
REAL CW,TEMP,X,Y#                                                       RW11  13
REAL TCHECK,WEIGHT#                    Temporary working storage.       RW11  14
#======================================#                                RW11  15
#  FA ----- A   # FA COEFFICIENT A                                      RW11  16
#  FB ----- B   # FB COEFFICIENT B                                      RW11  17
#  FC ----- C   # FC COEFFICIENT C                                      RW11  18
#  FD ----- D   # FD COEFFICIENT D                                      RW11  19
#  FE ----- E   # FE COEFFICIENT E                                      RW11  20
#  FF ----- F   # FF COEFFICIENT F                                      RW11  21
#  FG ----- G   # FG COEFFICIENT G                                      RW11  22
#  FH ----- H   # FH COEFFICIENT H                                      RW11  23
#  FI ----- I   # FI COEFFICIENT I                                      RW11  24
#======================================#                                RW11  25
IWFLD=NINT(WFLAG)#                                                      RW11  26
##                                                                      RW11  27
##         WEIGHTING SCHEME 0                                           RW11  28
##        ********************                                          RW11  29
##                                                                      RW11  30
IF (IWFLD==0)#                         ********* scheme 0 *********     RW11  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RW11  32
IF (NINT(FA)==1)#                      Retrieve weight from (901)       RW11  33
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RW11  34
IF (ILSW1<=0) iquit:(RW1101)#          Weight is missing in the bdf     RW11  35
ELSE WEIGHT=LSW1*LSW1#                 Assign old weight (lsw1) to      RW11  36
#                                        Current weight.                RW11  37
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RW11  38
ELSE IF (NINT(FB)==2)#                 Retrieve weight from (902)       RW11  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RW11  40
IF (ILSW2<=0) iquit:(RW1102)#          Weight is missing in the bdf     RW11  41
ELSE WEIGHT=LSW2*LSW2#                 Assign old weight (lsw2) to      RW11  42
#                                        Current weight.                RW11  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RW11  44
ELSE IF (NINT(FC)==3)#                 Retrieve weight from (903)       RW11  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RW11  46
IF (ILSW1<=0) iquit:(RW1103)#          Weight is missing in the bdf     RW11  47
ELSE WEIGHT=LSW3*LSW3#                 Assign old weight (lsw3) to      RW11  48
#                                        Current weight.                RW11  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RW11  50
ELSE iquit:(RW1104)#                   Location of weight missing       RW11  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RW11  52
##                                                                      RW11  53
##         WEIGHTING SCHEME 1            ESTIMATING A WEIGHT USEING     RW11  54
##        ********************           WEIGHT FUNCTION 1.             RW11  55
##                                                                      RW11  56
ELSE IF (IWFLD==1)#                    ********** scheme 1 ********     RW11  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RW11  58
CW=0.0#                                Set 3rd term in w.f. to zero     RW11  59
IF(WOLD>.001) CW=FC/WOLD#              If old weight                    RW11  60
WEIGHT=FA+FB*SIGC*SIGC+CW+FD*FOBS+FE*FOBS*FOBS+FI*STOL# 
IF(FOBS!=0.0\FH!=0.0)
WEIGHT=WEIGHT+FG*ABS(FOBS)**FH#
IF(WEIGHT>.001) WEIGHT=1.0/WEIGHT#     Estimate the weights.            RW11  62
ELSE            WEIGHT=0.000001#                                        RW11  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RW11  64
##                                                                      RW11  65
##         WEIGHTING SCHEME 2            ESTIMATING A WEIGHT USING      RW11  66
##        ********************           WEIGHT FUNCTION 2.             RW11  67
##                                                                      RW11  68
ELSE IF (IWFLD==2)#                    ********** scheme 2 ********     RW11  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RW11  70
CW=0.0#                                Set 3rd term of w.f. to zero     RW11  71
IF(WOLD>.001) CW=FC*FOBS*FOBS/WOLD#    ... wold ...                     RW11  72
WEIGHT=FA+FB*FOBS+CW+FD*ABS(FOBS)**6+FE*STOL# Weight function 2.        RW11  73
IF(WEIGHT>.001) WEIGHT=1.0/WEIGHT#     Estimate the weights.            RW11  74
ELSE            WEIGHT=0.000001#                                        RW11  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RW11  76
##                                                                      RW11  77
##         WEIGHTING SCHEME 3            ESTIMATING A WEIGHT USIGN      RW11  78
##        ********************           WEIGHT FUNCTION 3 DEPENDING    RW11  79
##                                       ON THE 'TCHECK'.               RW11  80
ELSE IF (IWFLD==3)#                    ********** scheme 3 ********     RW11  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RW11  82
ifeq:(FB,.0) iquit:(RW1105)#           Coefficient fc missing           RW11  83
WEIGHT=0.000000001#                    Default weight (zero).           RW11  84
TCHECK=FA*FOBS-FCAL#                   Difference structure factor.     RW11  85
ifne:(TCHECK,0.)#                      If difference is > 0             RW11  86
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RW11  87
IF (STOL>FB)   X=1.0#                  ... stol ...                     RW11  88
ELSE    X=STOL/FB#                     ... stol ...                     RW11  89
IF (FOBS>FC)   Y=1.0#                  ... fobs ...                     RW11  90
ELSE    Y=FC/FOBS#                     ... fobs ...                     RW11  91
WEIGHT=X*Y#                            Weight function 3.               RW11  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RW11  93
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RW11  94
##                                                                      RW11  95
##         WEIGHTING SCHEME 4            ESTIMATING A WEIGHT            RW11  96
##        ********************                                          RW11  97
##                                                                      RW11  98
ELSE IF (IWFLD==4)#                    ********** scheme 4 ********     RW11  99
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RW11 100
IF (FOBS<=FA) WEIGHT=FOBS*FOBS/(FA*FA)## Weight function 4.             RW11 101
ELSE          WEIGHT=FA*FA/(FOBS*FOBS)## Weight function 4.             RW11 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RW11 103
##                                                                      RW11 104
##         WEIGHTING SCHEME 5            ESTIMATING A WEIGHT            RW11 105
##        ********************                                          RW11 106
##                                                                      RW11 107
ELSE IF (IWFLD==5)#                    ********** scheme 5 ********     RW11 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RW11 109
IF (FOBS<=FA) WEIGHT=1.0#              Unit weight.                     RW11 110
ELSE          WEIGHT=FA*FA/(FOBS*FOBS)## Weight function 5.             RW11 111
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RW11 112
##                                                                      RW11 113
##         WEIGHTING SCHEME 6            ESTIMATING A WEIGHT            RW11 114
##        ********************                                          RW11 115
##                                                                      RW11 116
ELSE IF (IWFLD==6)#                    ********** scheme 6 ********     RW11 117
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RW11 118
TEMP=(FOBS-FB)/FA#                     Weight function 6.               RW11 119
WEIGHT=1.0/(1.0+TEMP*TEMP)#            Estimate the weight              RW11 120
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RW11 121
##                                                                      RW11 122
##         WEIGHTING SCHEME 7            ESTIMATING A WEIGHT            RW11 123
##        ********************                                          RW11 124
##                                                                      RW11 125
ELSE IF (IWFLD==7)#                    ********** scheme 7 ********     RW11 126
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RW11 127
WEIGHT=FA+FOBS+FB*FOBS*FOBS+FC*FOBS*FOBS*FOBS# Weight function 7.       RW11 128
IF(WEIGHT>.001) WEIGHT=1.0/WEIGHT#     Estimate the weights.            RW11 129
ELSE            WEIGHT=0.000001#                                        RW11 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RW11 131
##                                                                      RW11 132
##         WEIGHTING SCHEME 8            ESTIMATING A WEIGHT            RW11 133
##        ********************                                          RW11 134
##                                                                      RW11 135
ELSE IF (IWFLD==8)#                    ********** scheme 8 ********     RW11 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RW11 137
TEMP=maximum:(SIGC,(FB*FOBS+FC),(FD*FE+FF))# Find the maximum value     RW11 138
WEIGHT=FA/TEMP#                        Estimate the weight              RW11 139
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RW11 140
##                                                                      RW11 141
##         WEIGHTING SCHEME 9            ESTIMATING  A  WEIGHT  BASED   RW11 142
##        ********************           OLNY ON THE COUNTING STATIS-   RW11 143
##                                       TICS.                          RW11 144
ELSE IF (IWFLD==9)#                    ********** scheme 9 ********     RW11 145
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RW11 146
WEIGHT=FA#                             Constant weight.                 RW11 147
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RW11 148
##                                                                      RW11 149
##         WEIGHTING SCHEME 10           RESERVED WEIGHTING SCHEME.     RW11 150
##        *********************                                         RW11 151
##                                                                      RW11 152
ELSE IF (IWFLD==10)#                   ********** scheme 10 *******     RW11 153
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RW11 154
WEIGHT=1.0#                            Unit weight.                     RW11 155
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RW11 156
##                                                                      RW11 157
##         WEIGHTING SCHEME 11           RESERVED WEIGHTING SCHEME.     RW11 158
##        *********************                                         RW11 159
##                                                                      RW11 160
ELSE IF (IWFLD==11)#                   ********** scheme 11 *******     RW11 161
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RW11 162
WEIGHT=1.0#                            Unit weight.                     RW11 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RW11 164
##                                                                      RW11 165
##         WEIGHTING SCHEME 12           RESERVED WEIGHTING SCHEME.     RW11 166
##        *********************                                         RW11 167
##                                                                      RW11 168
ELSE IF (IWFLD==12)#                   ********** scheme 12 *******     RW11 169
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RW11 170
WEIGHT=1.0#                            Unit weight.                     RW11 171
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RW11 172
##                                                                      RW11 173
##         WEIGHTING SCHEME 13           RESERVED WEIGHTING SCHEME.     RW11 174
##        *********************                                         RW11 175
##                                                                      RW11 176
ELSE IF (IWFLD==13)#                   ********** scheme 13 *******     RW11 177
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RW11 178
WEIGHT=1.0#                            Unit weight.                     RW11 179
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RW11 180
#                                                                       RW11 181
LSWT=SQRT(WEIGHT)#                     Convert weight to square roo     RW11 182
#                                        Of weight for further usage    RW11 183
RETURN#                                Return to (rw09)                 RW11 184
END#                                                                    RW11 185
pmacro:([no:])#                        Purge xtal system macros         RW11 186
