systemheader:(SK    )#                                                  SK     1
######################################################################  SK     2
#                                                                    #  SK     3
#                         *** SKLOUT ***                             #  SK     4
#                                                                    #  SK     5
#   PROGRAM FOR GENERATING SCHAKAL INPUT LINES TO PLOT ATOMS         #  SK     6
#                                                                    #  SK     7
######################################################################  SK     8
#                                                                       SK     9
include:(XMACRO)#                                                       SK    10
#                                                                       SK    11
macro:(put:,[writefmt:(iofm1:,'(a)',CHROT(1^$1))])#                     SK    12
#                                                                       SK    13
systemheader:(SK00)#                   Convert the input file           SK00   1
######################################################################  SK00   2
#                                                                    #  SK00   3
#                             SK00                                   #  SK00   4
#                                                                    #  SK00   5
######################################################################  SK00   6
SUBROUTINE SK00#                       S.r. hall oct. 90                SK00   7
include:(AACOMN)#                                                       SK00   8
#                                                                       SK00   9
INTEGER I,J,K,CELL#                                                     SK00  10
INTEGER MARKS,STOPS#                                                    SK00  11
INTEGER IWNT(2),IREL(3),KEY(4)#                                         SK00  12
#                                                                       SK00  13
chardata:(SK0, END )#                                                   SK00  14
chardata:(SK1,MOL CEL )#                                                SK00  15
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              SK00  16
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              SK00  17
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              SK00  18
realdata:(TR21,[.3333333,.5])#                                          SK00  19
realdata:(TR22,[.6666667,0.])#                                          SK00  20
realdata:(TR23,[.6666667,.5])#                                          SK00  21
realdata:(FMT1,[151042.,251042.,351042.,451032.,551032.,651032.])#      SK00  22
realdata:(FMT2,[251052.,351052.,451052.])#                              SK00  23
realdata:(FMT3,[170213.,370213.,570213.,200213.,400213.,600213.,#       SK00  24
230213.,430213.,630213.,140862.,340862.,540862.])#                      SK00  25
datastuff:#                                                             SK00  26
#                                                                       SK00  27
#    OPEN THE OUTPUT SCHAKAL FILE                                       SK00  28
#    ----------------------------                                       SK00  29
#                                                                       SK00  30
FILEXT(iofm1:)='SKL'#                  Ext of output schakal file       SK00  31
openfmt:(iofm1:,' ')#                  Open xtal data file              SK00  32
IOMARK(1)=QXSTR#                       Define start of ip buffer        SK00  33
incrqx:(MARKS,IOMARK(1)+bdfbuf:,SK0002)# Get buffer memory              SK00  34
CELL=no:#                              Default is mole                  SK00  35
#                                                                       SK00  36
#     PROCESS THE SKLOUT LINE                                           SK00  37
#     -----------------------                                           SK00  38
#                                                                       SK00  39
ifnv:(BUFIN(1))#                       If field 1 is active             SK00  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SK00  41
stringlim:(1,J,K)#                     Get the string limits            SK00  42
compchar:(CHRIN,J,SK1,1,3,4,8,K)#      See if mole or cell              SK00  43
IF(K==0) iquit:(SK0003)#               Unrecognised entry               SK00  44
CELL=K-1#                              Set cell mode                    SK00  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SK00  46
readline:(SK0,NSK0)#                   Read each line into chrin        SK00  47
#                                                                       SK00  48
#    READ AND OUTPUT CELL DATA                                          SK00  49
#    -------------------------                                          SK00  50
#                                                                       SK00  51
readwpkt:(1,lrcell:,NP,IP,0)#          Read the cell constants          SK00  52
CHROT(1^40)='TITL'//TITLE(57^92)#      Store title for output           SK00  53
put:(40)#                              Punch title line                 SK00  54
CHROT='CELL'#                          Store the cell header            SK00  55
DO I=4,6; QX(IP+I)=QX(IP+I+3)*360.#    Store angles as degrees          SK00  56
ncodefld:(QX,IP+1,CHROT,FMT1,6)#       Format the cell dimensions       SK00  57
put:(65)#                              Punch cell line                  SK00  58
#                                                                       SK00  59
#    READ THE SYMMETRY DATA & EXPAND                                    SK00  60
#    -------------------------------                                    SK00  61
#                                                                       SK00  62
IF(CELL==yes:)#                        If cell needed get symops        SK00  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SK00  64
readwpkt:(1,lrsymm:,NP,IP,0)#          Read first sym packet            SK00  65
IF(IP<=0) iquit:(SK0001)#              Exit if missing                  SK00  66
LTYP=NINT(QX(IP+1))#                   Lattice flag                     SK00  67
ICNT=NINT(QX(IP+2))#                   Centre flag (c=0;nc=1)           SK00  68
NSYM=NINT(QX(IP+3))#                   Number of matrices on bdf        SK00  69
incrqx:(STOPS,MARKS+NSYM*12,SK0002)#   End of full symop table          SK00  70
FOR(J=MARKS;J>0;J=J+12)#               Loop over sym matrices           SK00  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SK00  72
readwpkt:(1,lrsymm:,NP,IP,0)#          Point next matrix                SK00  73
IF(IP<=0) BREAK#                       Exit when no more                SK00  74
movereal:(QX,IP+1,QX,J+1,12,1)#        Store matrix in qx array         SK00  75
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SK00  76
N=J#                                   Store limit of input matrices    SK00  77
IF(ICNT==0)#                           If centrosymmetric               SK00  78
FOR(K=MARKS;K<N;K=K+12)#               Loop over input matrices         SK00  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SK00  80
DO I=1,12; QX(J+I)=-QX(K+I)#           Store inverse element            SK00  81
J=J+12#                                Incr storage pointer             SK00  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SK00  83
IF(LTYP>7) LTYP=LTYP-7#                Remove centric part              SK00  84
N=J;  K=J#                             Store temp end marker            SK00  85
IF(LTYP>1)#                            Test if sg centered              SK00  86
FOR(J=MARKS;J<N;J=J+12)#               Loop over symm matrices          SK00  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SK00  88
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            SK00  89
QX(K+10)=QX(J+10)+TR11(LTYP-1)#        Transfer t1                      SK00  90
QX(K+11)=QX(J+11)+TR12(LTYP-1)#        Transfer t2                      SK00  91
QX(K+12)=QX(J+12)+TR13(LTYP-1)#        Transfer t3                      SK00  92
K=K+12#                                Incr storage pointer             SK00  93
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               SK00  94
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            SK00  95
QX(K+10)=QX(J+10)+TR21(LTYP-2)#        Transfer t1                      SK00  96
QX(K+11)=QX(J+11)+TR22(LTYP-2)#        Transfer t2                      SK00  97
QX(K+12)=QX(J+12)+TR23(LTYP-2)#        Transfer t3                      SK00  98
K=K+12#                                Incr storage pointer             SK00  99
IF(LTYP!=4) NEXT#                      Skip if not f-centre             SK00 100
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            SK00 101
QX(K+10)=QX(J+10)+0.5#                 Transfer t1                      SK00 102
QX(K+11)=QX(J+11)+0.5#                 Transfer t2                      SK00 103
QX(K+12)=QX(J+12)+0.0#                 Transfer t3                      SK00 104
K=K+12#                                Incr storage pointer             SK00 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SK00 106
FOR(J=MARKS;J<STOPS;J=J+12)#           Loop over symmetry matrices      SK00 107
DO I=10,12; QX(J+I)=MOD(5.+QX(J+I),1.)# Store translation modulo 1.     SK00 108
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SK00 109
#                                                                       SK00 110
#    OUTPUT ATOM SITE COORDS                                            SK00 111
#    -----------------------                                            SK00 112
#                                                                       SK00 113
IWNT(1)=14;  IWNT(2)=1#                Request atom label & x coord     SK00 114
KEY(1)=2; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search parameters           SK00 115
indexpkt:(1,lratom:,NP,IP,0,KEY,IWNT,IREL)# Get packet pointers         SK00 116
IF(IP<=0) iquit:(SK0004)#              Atoms data missing               SK00 117
REPEAT#                                Loop over atoms list             SK00 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SK00 119
readwpkt:(1,lratom:,NP,IP,0)#          Read next atom packet            SK00 120
IF(IP<=0) BREAK#                       Exit when record finished        SK00 121
CHROT='ATOM'#                          Start atom output line           SK00 122
movertoc:(QX(IP+IREL(1)),1,CHROT,6,8,0)# Store atom label               SK00 123
ncodefld:(QX(IP+IREL(2)),1,CHROT,FMT2,3)# Format atom coordinates       SK00 124
put:(45)#                              Punch atom line                  SK00 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SK00 126
#                                                                       SK00 127
#    OUTPUT THE SYMM LINES IF NEEDED                                    SK00 128
#    -------------------------------                                    SK00 129
#                                                                       SK00 130
IF(CELL==yes:)#                                                         SK00 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SK00 132
FOR(I=MARKS+12;I<STOPS;I=I+12)#        Loop over symmetry lines         SK00 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SK00 134
CHROT='SYMM'#                          Start symmetry line              SK00 135
ncodefld:(QX,I+1,CHROT,FMT3,12)#       Output symop elements            SK00 136
put:(65)#                              Punch atom line                  SK00 137
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SK00 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SK00 139
#                                                                       SK00 140
#   FINISH OFF SCHAKAL OUTPUT FILE                                      SK00 141
#   ------------------------------                                      SK00 142
#                                                                       SK00 143
CHROT='END'#                           Set end line                     SK00 144
put:(4);   CHROT=' '#                  Output end line                  SK00 145
closefmt:(iofm1:)#                     Close the schakal line file      SK00 146
readwpkt:(1,endrecord:,NP,IP,0)#       Close archive bdf                SK00 147
#                                                                       SK00 148
RETURN#                                                                 SK00 149
END#                                                                    SK00 150
pmacro:([no:])#                                                         SK00 151
