systemheader:(SM    )#                 Calculate sim weight phases      SM     1
####################################################################    SM     2
#                                                                  #    SM     3
#                        *** SIMWGT ***                            #    SM     4
#                                                                  #    SM     5
#   CALCULATE SIM WEIGHTS FOR F'S AND COMBINE WITH HENDRICKSON     #    SM     6
#   LATTMAN COEFFICIENTS.                                          #    SM     7
#                                                                  #    SM     8
####################################################################    SM     9
#                                                                       SM    10
include:(XMACRO)#                                                       SM    11
#                                                                       SM    12
extrude:(SMCOMN)#                                                       SM    13
INTEGER NSBIN#                         Number of stol bins              SM    14
INTEGER PRON#                          Print flag for output            SM    15
INTEGER ID1#                           Id of f(obs)                     SM    16
INTEGER ID2#                           Id of |fcalc|                    SM    17
INTEGER ID3#                           Id of f*cos(a)                   SM    18
INTEGER ID4#                           Id of f*sin(a)                   SM    19
INTEGER ID5#                           Id of phase, a in cycles         SM    20
INTEGER OD1#                           Id of figure of merit            SM    21
INTEGER OD2#                           Id of cos(alpha) most prob       SM    22
INTEGER OD3#                           Id of sin(alpha) most prob       SM    23
INTEGER OD4#                           Id of cos(alpha) best            SM    24
INTEGER OD5#                           Id of sin(alpha) best            SM    25
INTEGER IGRP#                          Id number of scale group         SM    26
INTEGER MAXGRP#                        Maximum no. of individula sc     SM    27
INTEGER RCODE,NRCODE,RJCODE#           Reflection select codes          SM    28
INTEGER RSCALE#                        Get scales on yes pass           SM    29
INTEGER FOMPNT#                        Fig of merit want list point     SM    30
INTEGER GRPPNT#                        Group scale want list positi     SM    31
INTEGER SIGPNT#                        Sigma want list position in      SM    32
INTEGER RCOPNT#                        Rcode want list position in      SM    33
INTEGER SCLGRP#                        Scale group of current refle     SM    34
INTEGER ID(5)#                                                          SM    35
INTEGER OD(5)#                                                          SM    36
EQUIVALENCE (ID(1),ID1),(ID(2),ID2),(ID(3),ID3),(ID(4),ID4),(ID(5),ID5)#SM    37
EQUIVALENCE (OD(1),OD1),(OD(2),OD2),(OD(3),OD3),(OD(4),OD4),(OD(5),OD5)#SM    38
COMMON /COMISM/ RCODE, NRCODE, RJCODE, RSCALE, $#                       SM    39
NSBIN, NIBIN, NGBIN, PRON, ID, OD, FOMPNT, $#                           SM    40
GRPPNT, SIGPNT, RCOPNT, IGRP, SCLGRP, MAXGRP#                           SM    41
REAL SCALE(64)#                        Group scales for id1 to id2      SM    42
REAL ITEMS(4)#                                                          SM    43
REAL ITEM1#                            Item1 f(obs)                     SM    44
REAL ITEM2#                            Item2 f(calc)                    SM    45
REAL ITEM3#                            Item3 f*cos(a)                   SM    46
REAL ITEM4#                            Item4 f*sin(a)                   SM    47
REAL MAXH(3)#                          Max hkl                          SM    48
REAL SS#                                                                SM    49
REAL FACTOR#                                                            SM    50
REAL WAYT#                                                              SM    51
REAL DIF#                                                               SM    52
REAL SCFO#                                                              SM    53
REAL SLIMIT#                                                            SM    54
REAL SIMWGF#                                                            SM    55
REAL RESOL(25)#                                                         SM    56
REAL STMAX,STMIN#                                                       SM    57
EQUIVALENCE (ITEMS(1),ITEM1),(ITEMS(2),ITEM2),(ITEMS(3),ITEM3),$#       SM    58
(ITEMS(4),ITEM4)#                                                       SM    59
COMMON /COMFSM/  ITEMS, SS, WAYT, DIF, SCFO,$#                          SM    60
MAXH, SCALE, SIMWGF, SLIMIT, RESOL, FACTOR, STMIN, STMAX#               SM    61
endext:#                                                                SM    62
#                                                                       SM    63
systemheader:(SM00)#                   Calculate sim weight phases      SM00   1
# ################################################################## #  SM00   2
#                                                                    #  SM00   3
#                               SM00                                 #  SM00   4
#                                                                    #  SM00   5
# ################################################################## #  SM00   6
SUBROUTINE SM00#                       K.d.watenpaugh, b.c.finzel       SM00   7
#                                      #  September 1989                SM00   8
#                                      Calc sim weights for f(obs) and  SM00   9
#                                      Combine with h-l coef. if desir  SM00  10
include:(AACOMN)#                                                       SM00  11
include:(SMCOMN)#                                                       SM00  12
INTEGER AANDB#                         Signal phase source in input     SM00  13
INTEGER I,IOUT,IP,JP,IPAK,JPAK#                                         SM00  14
INTEGER IXD,IXS,IRN,IFM,ISC,IMN#                                        SM00  15
INTEGER MANLIS,OPTLIS,UPDLIS#                                           SM00  16
INTEGER IWNT(17),IREL(10),KEY(4)#                                       SM00  17
REAL COSAL,SINAL#                      Temporary a & b values           SM00  18
REAL DENOM#                            Sqrt(a**2+b**2)                  SM00  19
REAL X(400)#                           Large array of summed values     SM00  20
REAL HKL(3)#                                                            SM00  21
REAL  SPACE(25)#                                                        SM00  22
#                                                                       SM00  23
chardata:(SM1,[        RESOLUTION          COUNT       R(F**2)  $#      SM00  24
RESCALE     FOM])#                                                      SM00  25
chardata:(SM4,[ SIN(THETA/LAM) MIN MAX                            ])#   SM00  26
chardata:(SM5,[ MAX H K L                                         ])#   SM00  27
chardata:(SM6,[ SCALE                                             ])#   SM00  28
chardata:(SM11,[ SIM WEIGHTS USING ITEM                      ])#        SM00  29
chardata:(SM12,[ GROUP SCALE FACTOR ITEM                     ])#        SM00  30
chardata:(SM13,[ REJECTION CODE ITEM                         ])#        SM00  31
chardata:(SM14,[ SIM WEIGHTS OUTPUT ITEMS                         ])#   SM00  32
chardata:(SM15,[ DO NOT RESCALE DATA])#                                 SM00  33
chardata:(SM16,[ RESCALE THE DATA BY SIN(T)/L BINS])#                   SM00  34
chardata:(SM21,[ SCALE GROUP    SCALE])#                                SM00  35
chardata:(SM22,[   H    K    L   F(OBS)  F(CAL)   F.O.M. $#             SM00  36
COS(A)  SIN(A)])#                                                       SM00  37
realdata:(FMT1,[340642.,420632.])#                                      SM00  38
realdata:(FMT2,[340613.,420613.,500613.])#                              SM00  39
realdata:(FMT3,[50513.,100513.,150513.,230812.,310812.,$#               SM00  40
390842.,470842.,550842.])#                                              SM00  41
realdata:(FMT4,[100922.,230922.,331013.,470842.,560842.,640842.])#      SM00  42
DATA SPACE/0.000025,0.002500,0.005102,0.0100000,0.015625,$#             SM00  43
           0.020408,0.027778,0.034294,0.0400000,0.047259,$#             SM00  44
           0.056689,0.062500,0.111111,12*0.0/#                          SM00  45
datastuff:#                                                             SM00  46
#                                                                       SM00  47
TWOPI=2.0*ACOS(-1.0)#                  Set up value of two pi           SM00  48
#                                                                       SM00  49
#    READ INPUT LINES                                                   SM00  50
#    ----------------                                                   SM00  51
CALL SM01#                             Read input lines                 SM00  52
#                                                                       SM00  53
#    SET IO BUFFERS                                                     SM00  54
#    --------------                                                     SM00  55
IOMARK(1)=QXSTR#                       Start of buffer for file a       SM00  56
IOMARK(2)=IOMARK(1)+bdfbuf:#                                            SM00  57
incrqx:(MARK,IOMARK(2)+bdfbuf:,SM0004)#                                 SM00  58
#                                                                       SM00  59
copyfile:(1,2,1,decr:(lrrefl:))#                                        SM00  60
#                                                                       SM00  61
#    INITIALIZE IWNT LIST USING OPTIONS FROM SIMWGT LINE                SM00  62
#    --------------------------------------------------                 SM00  63
DO I=1,3; IWNT(I)=I#                   Hkl, stol, mult                  SM00  64
IWNT(4) = ID1#                         Values to be used in simwgt      SM00  65
IWNT(5) = ID2#                                                          SM00  66
MANLIS = 5#                            Mandatory list                   SM00  67
# CONTINUE BUILDING MANDATORY LIST                                      SM00  68
IF (MAXGRP>1&IGRP==0) IGRP=1309#                                        SM00  69
IF (IGRP!=0)#                          Want group scale indicator       SM00  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SM00  71
MANLIS = MANLIS + 1#                                                    SM00  72
GRPPNT = MANLIS#                                                        SM00  73
IWNT(MANLIS) = IGRP#                                                    SM00  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SM00  75
IF (SLIMIT!=0.0)#                      Want to use sigma cutoff         SM00  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SM00  77
MANLIS = MANLIS+1#                                                      SM00  78
SIGPNT = MANLIS#                                                        SM00  79
IWNT(MANLIS) = IWNT(4)+1#              Hope this is the sigma           SM00  80
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SM00  81
ELSE IF (RJCODE!=0)#                   Want to use rcode                SM00  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SM00  83
MANLIS = MANLIS+1#                                                      SM00  84
RCOPNT = MANLIS#                                                        SM00  85
IWNT(MANLIS)=NRCODE#                                                    SM00  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SM00  87
#  SET UP OPTIONAL LIST FOR INPUT BDF                                   SM00  88
OPTLIS = 3#                                                             SM00  89
IWNT(MANLIS+1) = ID3#                  Point to a calc                  SM00  90
IWNT(MANLIS+2) = ID4#                  Point to b calc                  SM00  91
IWNT(MANLIS+3) = ID5#                  Point to phase in cycles         SM00  92
#  SET UP UPDATE LIST OF OUTPUT BDF                                     SM00  93
NIWNT = MANLIS + OPTLIS#                                                SM00  94
UPDLIS = 5#                                                             SM00  95
IWNT(NIWNT+1) = OD1#                   Alternate fig of merit           SM00  96
IWNT(NIWNT+2) = OD2#                   Alternate cos(a) 'most prob'     SM00  97
IWNT(NIWNT+3) = OD3#                   Alternate sin(a) 'most prob'     SM00  98
IWNT(NIWNT+4) = OD4#                   Alternate cos(a) 'best'          SM00  99
IWNT(NIWNT+5) = OD5#                   Alternate sin(a) 'best'          SM00 100
#                                                                       SM00 101
#    FIGURE INTERVALS FOR STOL**2 BINS                                  SM00 102
#    -----------------------------------                                SM00 103
#                                                                       SM00 104
IF(NSBIN!=0)#                          Calculate stol bins              SM00 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SM00 106
SPACE(1)=0.00005#                      Infinity is upper bound          SM00 107
DO I=1,NSBIN#                                                           SM00 108
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SM00 109
IF(RESOL(I)>0.00005) SPACE(I+1) = 1.0/(RESOL(I)*2)**2#                  SM00 110
ELSE iquit:(SM0003)#                   Zero resolution not allowed      SM00 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SM00 112
NSBIN = NSBIN+1#                       Allow for added infinity bin     SM00 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SM00 114
ELSE NSBIN = 13#                       Default, use 13 bins             SM00 115
#                                                                       SM00 116
#    WRITE OUT RUN INFORMATION                                          SM00 117
#    --------------------------                                         SM00 118
ncodefld:(FLOAT(ID1),1,SM11,340613.,1)#                                 SM00 119
ncodefld:(FLOAT(ID2),1,SM11,420613.,1)#                                 SM00 120
writeline:(1,SM11,NSM11,3,3)#                                           SM00 121
ncodefld:(FLOAT(OD1),1,SM14,FMT2(1),1)#                                 SM00 122
ncodefld:(FLOAT(OD2),1,SM14,FMT2(2),1)#                                 SM00 123
ncodefld:(FLOAT(OD3),1,SM14,FMT2(3),1)#                                 SM00 124
writeline:(1,SM14,NSM14,3,3)#                                           SM00 125
IF (RSCALE==0) writeline:(1,SM15,NSM15,3,3)#                            SM00 126
ELSE           writeline:(1,SM16,NSM16,3,3)#                            SM00 127
ncodefld:(FLOAT(IGRP),1,SM12,340613.,1)#                                SM00 128
writeline:(1,SM12,NSM12,3,3)#                                           SM00 129
ncodefld:(FLOAT(NRCODE),1,SM13,340613.,1)#                              SM00 130
writeline:(1,SM13,NSM13,3,3)#                                           SM00 131
ncodefld:(STMIN,1,SM4,FMT1(1),1)#      Format min st/l                  SM00 132
ncodefld:(STMAX,1,SM4,FMT1(2),1)#      Format max st/l                  SM00 133
writeline:(1,SM4,NSM4,3,3)#            Print min/max st/l               SM00 134
ncodefld:(MAXH(1),1,SM5,FMT2,3)#       Format max hkl                   SM00 135
writeline:(1,SM5,NSM5,3,3)#            Print max hkl                    SM00 136
#                                                                       SM00 137
NBIN = NSBIN#                                                           SM00 138
# *** X IS THE ALL-PURPOSE ARRAY FOR STOL RUN***                        SM00 139
IXD = NBIN#                            Denom ptr into x array           SM00 140
IXS = NBIN*2#                          Summation ptr into x array       SM00 141
IRN = NBIN*3#                          Bin count ptr into x             SM00 142
IFM = NBIN*4#                          Fig of merit bins                SM00 143
ISC = NBIN*5#                          Scale ptr into x array           SM00 144
IMN = NBIN*6#                          <|fo**2-fc**2|>                  SM00 145
#                                                                       SM00 146
#    INITIALIZE SCALES FOR FIRST LOOP                                   SM00 147
#    --------------------------------                                   SM00 148
#                                                                       SM00 149
DO I=1,NBIN#                                                            SM00 150
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SM00 151
X(ISC+I) = 1.0#                                                         SM00 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SM00 153
#                                                                       SM00 154
writeline:(1,SM21,NSM21,3,3)#                                           SM00 155
IF (MAXGRP==1 & SCALE(1)<=0.0) SCALE(1) = 1.0#                          SM00 156
DO I=1,MAXGRP#                                                          SM00 157
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SM00 158
GRP=I#                                                                  SM00 159
ncodefld:(GRP,1,CHROT,100613.,1)#                                       SM00 160
ncodefld:(SCALE(I),1,CHROT,211042.,1)#                                  SM00 161
writeline:(0,0,0,1,3)#                 Print input line image           SM00 162
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SM00 163
#                                                                       SM00 164
#   PASSES TWO TIMES THRU DATA                                          SM00 165
#       FIRST PASS: USE INPUT SCALES; TALBULATE STOL BINS AND CALC      SM00 166
#       BIN SCALES.                                                     SM00 167
#       SECOND PASS: APPLIES SIM WEIGHTING (USING STOL BIN SCALING IF   SM00 168
#       REQUESTED), COMBINES WITH LATT/HENR COEFF, IF DESIRED           SM00 169
#                                                                       SM00 170
IOUT = 0#                              Indexpkt output unit             SM00 171
IF (RSCALE==no:) I1 = 2#                                                SM00 172
ELSE I1 = 1#                                                            SM00 173
DO ITIME=I1,3#                                                          SM00 174
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SM00 175
#    INITIALIZE SUMMED QUANTITIES TO 0 (EXCEPT FOR SCALES               SM00 176
#    ----------------------------------------------------               SM00 177
DO I=1,ISC; X(I) = 0.0#                                                 SM00 178
#                                                                       SM00 179
#    READ FROM INPUT BDF                                                SM00 180
#    -------------------                                                SM00 181
RCODE = 0#                                                              SM00 182
IWNT(1) = 1#                           Reset from previous use          SM00 183
NIWNT = MANLIS + OPTLIS#                                                SM00 184
KEY(1)=MANLIS; KEY(2)=KEY(1)+OPTLIS#                                    SM00 185
KEY(3)=KEY(2)+UPDLIS; KEY(4)=0#        Set search keys                  SM00 186
IF (ITIME==3) IOUT = 2#                Write it this time thru          SM00 187
indexpkt:(1,lrrefl:,IPAK,IP,IOUT,KEY,IWNT,IREL)# Search lrrefl direct   SM00 188
JPAK=KEY(4)#                           Output packet size               SM00 189
FOMPNT = IREL(MANLIS+OPTLIS+1)#                                         SM00 190
IF(KEY(4)<=0) iquit:(SM0001)#          Items not found...               SM00 191
IF(IREL(MANLIS+1)!=0&IREL(MANLIS+2)!=0)# Test if a & b are in input     SM00 192
AANDB=yes:#                            Set signal, a & b are there      SM00 193
ELSE IF(IREL(MANLIS+3)!=0) AANDB=no:#  Test phase in cycles present     SM00 194
ELSE iquit:(SM0004)#                   No phases no run                 SM00 195
IF (ITIME==3&PRON>0) writeline:(1,SM22,NSM22,3,3)#                      SM00 196
#                                                                       SM00 197
#    ENTER LRREFL: BDF RECORDS                                          SM00 198
#    -------------------------                                          SM00 199
REPEAT#                                Loop over lrrefl records         SM00 200
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SM00 201
readwpkt:(1,lrrefl:,IPAK,IP,0)#        Point to ip packet               SM00 202
IF(IP<=0) BREAK#                       Exit reflection loop             SM00 203
IF (ITIME == 3)#                                                        SM00 204
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SM00 205
writepkt:(2,lrrefl:,JPAK,JP)#                                           SM00 206
movereal:(voidflg:,1,QX,JP+1,JPAK,2)#                                   SM00 207
movereal:(QX,IP+1,QX,JP+1,IPAK,0)#                                      SM00 208
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SM00 209
gethkl:(IREL(1)+IP,HKL)#                                                SM00 210
#                                                                       SM00 211
#  DISCARD REFLECTIONS WITHOUT ENOUGH INFO                              SM00 212
#  ----------------------------------------                             SM00 213
ITEM1 = QX(IREL(4)+IP)#                                                 SM00 214
ifvo:(ITEM1) NEXT#                     Void item1 value                 SM00 215
ITEM2 = QX(IREL(5)+IP)#                                                 SM00 216
ifvo:(ITEM2) NEXT#                     Void item2 value                 SM00 217
IF (ITEM2 < 0.01) NEXT#                Very small fc                    SM00 218
IF(AANDB==yes:)#                       Are phases in form of a & b?     SM00 219
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SM00 220
ITEM3 = QX(IREL(MANLIS+1)+IP)#         Get a calc                       SM00 221
ITEM4 = QX(IREL(MANLIS+2)+IP)#         Get b calc                       SM00 222
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SM00 223
ELSE#                                  Phases as alpha in cycles        SM00 224
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SM00 225
ITEM3 = COS(TWOPI*QX(IREL(MANLIS+3)+IP))# Get cosine(alpha)             SM00 226
ITEM4 = SIN(TWOPI*QX(IREL(MANLIS+3)+IP))# Get sine(alpha)               SM00 227
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SM00 228
SS = QX(IREL(2)+IP)#                   Stol value from bdf              SM00 229
DO I=1,3; IF (HKL(I)>MAXH(I)) NEXT#    Hkl out of range                 SM00 230
IF (SS< STMIN \ SS>STMAX) NEXT#        Stol out of range                SM00 231
SS = SS**2#                                                             SM00 232
IF (GRPPNT!=0)#                        Get scale group of reflectio     SM00 233
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SM00 234
SCLGRP = NINT(QX(IREL(GRPPNT)+IP))#                                     SM00 235
ifvo:(SCALE(SCLGRP)) NEXT#             Use requested scale groups       SM00 236
# THEN USE ONLY THOSE.                                                  SM00 237
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SM00 238
ELSE SCLGRP = 1#                                                        SM00 239
ITEM1 = ITEM1*SCALE(SCLGRP)#                                            SM00 240
IF (SIGPNT!=0)#                                                         SM00 241
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SM00 242
SIGMA = SCALE(SCLGRP)*QX(IREL(SIGPNT)+IP)#                              SM00 243
IF (ITEM1<SLIMIT*SIGMA) NEXT#                                           SM00 244
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SM00 245
IF (RCOPNT!=0) RCODE=INT(QX(IREL(RCOPNT)+IP))#                          SM00 246
IF (RCODE!=RJCODE) NEXT#                                                SM00 247
#                                                                       SM00 248
#    GROUP DATA BY STOL VALUES                                          SM00 249
#    -------------------------                                          SM00 250
DO I=1,NBIN-1#                         For each bin ...                 SM00 251
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SM00 252
IF (SS < SPACE(I+1))#                  Data belong in current bin?#     SM00 253
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SM00 254
CALL SM02(I,IXD,IXS,IRN,ISC,X)#        Update statistics for bin        SM00 255
CALL SM02(NBIN,IXD,IXS,IRN,ISC,X)#     Update statistics for bin        SM00 256
BREAK#                                                                  SM00 257
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SM00 258
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SM00 259
#                                                                       SM00 260
#                                                                       SM00 261
IF (ITIME==3)#                                                          SM00 262
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SM00 263
SIMWGF = 0.0#                                                           SM00 264
IF (X(I+ISC) > 0.0) CALL SM03(I,IMN,ISC,IFM,X,NBIN)#                    SM00 265
IF(SIMWGF>=0.01)#                      If the weight is enough          SM00 266
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SM00 267
DENOM=SQRT(ITEM3**2+ITEM4**2)#         Get hypotenuse                   SM00 268
COSAL=ITEM3/AMAX1(0.01,DENOM)#         Get cos(a)                       SM00 269
SINAL=ITEM4/AMAX1(0.01,DENOM)#         & sin(a)                         SM00 270
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SM00 271
IF(SIMWGF<0.01\$#                      If weight too low or             SM00 272
ABS(1.0-(COSAL**2+SINAL**2))>0.06031)# Phases 10 deg or more off        SM00 273
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SM00 274
SIMWGF=0.0 ; COSAL=voidflg: ; SINAL=voidflg:# Cancel phasing            SM00 275
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SM00 276
ELSE IF(ABS(COSAL)<0.034899)#          Two deg of 90/270 degrees?       SM00 277
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SM00 278
COSAL=0.0 ; SINAL=SIGN(1.0,SINAL)#     Set to 90/270                    SM00 279
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SM00 280
ELSE IF(ABS(SINAL)<0.034899)#          Two deg of 0/180 degrees?        SM00 281
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SM00 282
COSAL=SIGN(1.0,COSAL) ; SINAL=0.0#     Set to 0/180                     SM00 283
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SM00 284
QX(JP+FOMPNT) = SIMWGF#                                                 SM00 285
QX(JP+FOMPNT+1)=COSAL; QX(JP+FOMPNT+2)=SINAL# Cos,sin 'most prob'       SM00 286
QX(JP+FOMPNT+3)=COSAL; QX(JP+FOMPNT+4)=SINAL# Cos,sin 'best'            SM00 287
#                                                                       SM00 288
# LATER ON WE'LL PUT IN COMBINING WITH H-L COEFF.                       SM00 289
IF (PRON > 0)#                                                          SM00 290
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SM00 291
ncodefld:(HKL,1,CHROT,FMT3,3)#                                          SM00 292
ncodefld:(ITEMS,1,CHROT,FMT3(4),2)#                                     SM00 293
ncodefld:(QX(JP+FOMPNT),1,CHROT,FMT3(6),3)#                             SM00 294
writeline:(0,SM22,NSM22,1,3)#                                           SM00 295
PRON = PRON-1#                                                          SM00 296
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SM00 297
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SM00 298
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SM00 299
#                                                                       SM00 300
#    OUTPUT FOR STOL GROUPED DATA                                       SM00 301
#    -----------------------------                                      SM00 302
#                                                                       SM00 303
IF (ITIME == 3)#                                                        SM00 304
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SM00 305
writeline:(1,SM1,NSM1,3,3)#                                             SM00 306
DO I=1,NBIN#                                                            SM00 307
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SM00 308
IF(X(IXD+I)<1.0) X(IXD+I)=1.0#                                          SM00 309
IF (X(IRN+I)<=0.0)#                                                     SM00 310
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 SM00 311
R=-1.0#                                                                 SM00 312
X(IFM+I)=0.0#                                                           SM00 313
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 SM00 314
ELSE $(#                                                                SM00 315
R = X(IXS+I)/X(IXD+I)#                 F**2 r factor                    SM00 316
X(IFM+I) = X(IFM+I)/X(IRN+I)#          Average fom                      SM00 317
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 SM00 318
IF(I!=NBIN)#                                                            SM00 319
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 SM00 320
RESOL(1) = 0.5/SQRT(SPACE(I))#                                          SM00 321
RESOL(2) = 0.5/SQRT(SPACE(I+1))#                                        SM00 322
ncodefld:(RESOL,1,CHROT,FMT4,2)#                                        SM00 323
ncodefld:(X(IRN+I),1,CHROT,FMT4(3),1)#                                  SM00 324
ncodefld:(R,1,CHROT,FMT4(4),1)#                                         SM00 325
ncodefld:(X(ISC+I),1,CHROT,FMT4(5),1)#                                  SM00 326
ncodefld:(X(IFM+I),1,CHROT,FMT4(6),1)#                                  SM00 327
movechar:('TO',1,CHROT,13,2,0)#                                         SM00 328
writeline:(0,0,0,1,3)#                                                  SM00 329
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 SM00 330
ELSE#                                                                   SM00 331
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 SM00 332
RESOL(1) = 0.5/STMIN#                                                   SM00 333
RESOL(2) = 0.5/STMAX#                                                   SM00 334
ncodefld:(RESOL,1,CHROT,FMT4,2)#                                        SM00 335
ncodefld:(X(IRN+I),1,CHROT,FMT4(3),1)#                                  SM00 336
ncodefld:(R,1,CHROT,FMT4(4),1)#                                         SM00 337
ncodefld:(X(ISC+I),1,CHROT,FMT4(5),1)#                                  SM00 338
ncodefld:(X(IFM+I),1,CHROT,FMT4(6),1)#                                  SM00 339
movechar:('TO',1,CHROT,13,2,0)#                                         SM00 340
writeline:(1,0,0,1,3)#                                                  SM00 341
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 SM00 342
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 SM00 343
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SM00 344
DO I=1,NBIN#                                                            SM00 345
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 SM00 346
IF(X(IXD+I)<1.0) X(IXD+I)=1.0#                                          SM00 347
IF (RSCALE==yes:)$#                                                     SM00 348
   X(ISC+I) = X(ISC+I)*SQRT(X(I)/X(IXD+I))# Scale for next pass         SM00 349
IF (X(IRN+I)>.5) X(IMN+I) = X(IXS+I)/X(IRN+I)# <|fo-fc|**2> for bin     SM00 350
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 SM00 351
#                                                                       SM00 352
IF (ITIME!=3) rewindbdf:(1)#           Prepare to make another pass     SM00 353
ELSE copyfile:(1,2,incr:(lrrefl:),endrecord:)# Finish off bdf           SM00 354
#                                      #                                SM00 355
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SM00 356
RETURN#                                                                 SM00 357
END#                                                                    SM00 358
#                                                                       SM00 359
#                                                                       SM00 360
systemheader:(SM01)#                   Read input cards                 SM01   1
#                                                                       SM01   2
#################################################################       SM01   3
#                                                                       SM01   4
#                    SM01                                               SM01   5
#                                                                       SM01   6
#################################################################       SM01   7
SUBROUTINE SM01#                                                        SM01   8
include:(AACOMN)#                                                       SM01   9
include:(SMCOMN)#                                                       SM01  10
#                                      #                                SM01  11
chardata:(SM021, END    SCALE  RESOL  RCODE  MAXHKL SLIMIT )#           SM01  12
datastuff:#                                                             SM01  13
#                                                                       SM01  14
ID1 = 1304; ID2 = 1800; IGRP=0#        Default values for simwgt        SM01  15
OD1 = 705;#                                                             SM01  16
PRON = 0#                                                               SM01  17
MAXGRP = 1#                                                             SM01  18
NSBIN = 0#                             Default 6 stol bins              SM01  19
RJCODE = 0#                                                             SM01  20
GRPPNT = 0#                                                             SM01  21
SIGPNT = 0#                                                             SM01  22
RCOPNT = 0#                                                             SM01  23
SCLPRP = 0#                                                             SM01  24
RSCALE = yes:#                         Rescale bins for sim weights     SM01  25
MAXH(1)=999.; MAXH(2)=999.; MAXH(3)=999.# Default max h,k,l             SM01  26
STMIN=0.005; STMAX=0.33333333#         Default min/max st/l             SM01  27
DO I=1,64#                             Initial all group scales in      SM01  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SM01  29
SCALE(I) = voidflg:#                                                    SM01  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SM01  31
#                                                                       SM01  32
#    DECIPHER SIMWGT LINE                                               SM01  33
#    -------------------                                                SM01  34
ifnv:(BUFIN(2)) PRON  = NINT(BUFIN(2))## PRINT CONTROL                  SM01  35
ifnv:(BUFIN(3)) RSCALE = NINT(BUFIN(3))# 0/1 n/y rescale bins befo fo   SM01  36
ifnv:(BUFIN(4)) ID1 = NINT(BUFIN(4))#  User f obs                       SM01  37
ifnv:(BUFIN(5)) ID2 = NINT(BUFIN(5))#  User f calculated                SM01  38
ifnv:(BUFIN(6)) IGRP = NINT(BUFIN(6))# User scale group                 SM01  39
ifnv:(BUFIN(7)) OD1 = NINT(BUFIN(7))#  Fom output id                    SM01  40
ID3 = ID2 + 1#                         A associated with fc             SM01  41
ID4 = ID3 + 1#                         B associated with fc             SM01  42
ID5 = ID2 - 800 + 700#                 Phase in cycles for fc           SM01  43
OD2 = OD1 + 1 ; OD3 = OD2 + 1 ; OD4 = OD3 + 1 ; OD5 = OD4 + 1#          SM01  44
#                                                                       SM01  45
#    READ CONTROL LINES                                                 SM01  46
#    --------------                                                     SM01  47
REPEAT#                                                                 SM01  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SM01  49
readline:(SM021,NSM021)#               Enter control lines              SM01  50
IF(LINID==1) BREAK#                    ******** end *******             SM01  51
ELSE IF(LINID==2)#                     ******** scale *****             SM01  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SM01  53
ifnv:(BUFIN(2))#                                                        SM01  54
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SM01  55
I=NINT(BUFIN(2))#                                                       SM01  56
IF(I>MAXGRP) MAXGRP = I#                                                SM01  57
SCALE(I) = BUFIN(1)#                                                    SM01  58
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SM01  59
ELSE SCALE(1) = BUFIN(1)#                                               SM01  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SM01  61
ELSE IF(LINID==3)#                     ******** resbin ****             SM01  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SM01  63
FOR(INEXT=1;INEXT<25;INEXT=INEXT+1)#                                    SM01  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SM01  65
ifnv:(BUFIN(INEXT)) RESOL(INEXT)=BUFIN(INEXT)#                          SM01  66
ifvo:(BUFIN(INEXT)) BREAK#                                              SM01  67
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SM01  68
NSBIN=INEXT-1#                         Number of stol bins              SM01  69
IF (NSBIN>1)#                                                           SM01  70
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SM01  71
DO I=2,NSBIN; IF(RESOL(I-1)<=RESOL(I)) iquit:(SM0002)#                  SM01  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SM01  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SM01  74
ELSE IF(LINID==4)#                     ******** rcode *****             SM01  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SM01  76
RJCODE = 1#                                                             SM01  77
NRCODE = 1308#                                                          SM01  78
ifnv:(BUFIN(1)) NRCODE= INT(BUFIN(1))# Which bdf item is rcode          SM01  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SM01  80
ELSE IF(LINID==5)#                     ******* maxhkl *****             SM01  81
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SM01  82
DO J=1,3#                              Loop over hkl fields             SM01  83
IF(BUFIN(J)>(-.1))#                    Store active max hkl             SM01  84
MAXH(J)=NINT(BUFIN(J))#                                                 SM01  85
#MAXH(J)=MIN0(MAXH(J),NINT(BUFIN(J)))# STORE POSSIBLE MAX HKL           SM01  86
IF(BUFIN(4)>=0.0) STMIN=BUFIN(4)#      Store active min st              SM01  87
IF(BUFIN(5)>0.01) STMAX=BUFIN(5)#      Store active max st              SM01  88
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SM01  89
ELSE IF(LINID==6)#                     ****** sigma limit *****         SM01  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SM01  91
ifnv:(BUFIN(1)) SLIMIT = BUFIN(1)#                                      SM01  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SM01  93
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SM01  94
RETURN#                                                                 SM01  95
END#                                                                    SM01  96
#                                                                       SM01  97
systemheader:(SM02)#                                                    SM02   1
#                                                                       SM02   2
#################################################################       SM02   3
#                                                                       SM02   4
#                    SM02                                               SM02   5
#                                                                       SM02   6
#################################################################       SM02   7
SUBROUTINE SM02(INDEX,IXD,IXS,IRN,ISC,X)#                               SM02   8
include:(AACOMN)#                                                       SM02   9
include:(SMCOMN)#                                                       SM02  10
#                                                                       SM02  11
INTEGER INDEX#                                                          SM02  12
INTEGER IXD#                           Index to denominator values      SM02  13
INTEGER IXS#                                                            SM02  14
INTEGER IRN#                                                            SM02  15
INTEGER ISC#                                                            SM02  16
REAL X(400)#                                                            SM02  17
REAL SCVAL#                                                             SM02  18
#                                                                       SM02  19
SCVAL = ITEM1*X(INDEX+ISC)#                                             SM02  20
DIF = ABS(ITEM2**2-SCVAL**2)#                                           SM02  21
X(INDEX) = X(INDEX)+ITEM2**2#                                           SM02  22
X(INDEX+IXD) = X(INDEX+IXD)+SCVAL**2#                                   SM02  23
X(INDEX+IXS) = X(INDEX+IXS)+DIF#                                        SM02  24
X(INDEX+IRN) = X(INDEX+IRN)+1.#                                         SM02  25
RETURN#                                                                 SM02  26
END#                                                                    SM02  27
#                                                                       SM02  28
systemheader:(SM03)#                                                    SM03   1
#                                                                       SM03   2
#################################################################       SM03   3
#                                                                       SM03   4
#                    SM03                                               SM03   5
#                                                                       SM03   6
#################################################################       SM03   7
SUBROUTINE SM03(INDEX,IMN,ISC,IFM,X,NBIN)#                              SM03   8
#     CALCULATE SIM WEIGHTS                                             SM03   9
#     TABLES OF SIM WEIGHTS W(X) = I1(X)/I0(X)                          SM03  10
#     WHERE I1 AND I0 ARE FIRST- AND ZERO-ORDER MODIFIED                SM03  11
#     BESSEL FUNCTIONS.                                                 SM03  12
#                                                                       SM03  13
#     X = (NUM/DEN) WHERE NUM = 2*FO*FC AND DEN = <|FO-FC|**2>          SM03  14
#     ARE OBTAINED AS ARGUMENTS.                                        SM03  15
#                                                                       SM03  16
include:(AACOMN)#                                                       SM03  17
include:(SMCOMN)#                                                       SM03  18
#                                                                       SM03  19
INTEGER INDEX#                                                          SM03  20
INTEGER IMN#                                                            SM03  21
INTEGER IFM,NBIN#                                                       SM03  22
REAL X(400)#                                                            SM03  23
REAL ANUM, ADEN#                                                        SM03  24
#                                                                       SM03  25
#      W(X) FOR X = 0, 1/64, ...., 63/64, 1                             SM03  26
realdata:(SMTAB1,[0.0,$#                                                SM03  27
  .0078,.0156,.0234,.0312,.0390,.0468,.0546,.0624,$#                    SM03  28
  .0701,.0779,.0856,.0933,.1010,.1087,.1164,.1243,$#                    SM03  29
  .1317,.1393,.1468,.1544,.1619,.1694,.1768,.1843,$#                    SM03  30
  .1917,.1990,.2064,.2137,.2209,.2282,.2354,.2425,$#                    SM03  31
  .2496,.2567,.2637,.2707,.2776,.2845,.2914,.2982,$#                    SM03  32
  .3049,.3116,.3183,.3249,.3315,.3380,.3445,.3509,$#                    SM03  33
  .3573,.3636,.3698,.3760,.3822,.3883,.3944,.4004,$#                    SM03  34
  .4063,.4122,.4180,.4238,.4295,.4352,.4408,.4464])#                    SM03  35
#                                                                       SM03  36
#      W(1/X) FOR 1/X = 0, 1/64, ...., 63/64, 1                         SM03  37
realdata:(SMTAB2,[1.0,$#                                                SM03  38
  .9922,.9842,.9763,.9682,.9601,.9519,.9436,.9352,$#                    SM03  39
  .9268,.9182,.9094,.9006,.8916,.8824,.8730,.8635,$#                    SM03  40
  .8538,.8440,.8339,.8237,.8134,.8030,.7925,.7820,$#                    SM03  41
  .7714,.7607,.7501,.7395,.7290,.7185,.7081,.6978,$#                    SM03  42
  .6876,.6775,.6675,.6577,.6480,.6385,.6291,.6199,$#                    SM03  43
  .6108,.6020,.5932,.5847,.5763,.5681,.5600,.5522,$#                    SM03  44
  .5444,.5369,.5295,.5222,.5151,.5082,.5014,.4947,$#                    SM03  45
  .4882,.4818,.4756,.4695,.4635,.4577,.4520,.4464])#                    SM03  46
datastuff:#                                                             SM03  47
#                                                                       SM03  48
ITEM1 = ITEM1*X(INDEX+ISC)#                                             SM03  49
ANUM = 2.0*ITEM1*ITEM2#                                                 SM03  50
ADEN = X(INDEX+IMN)#                                                    SM03  51
IF (ANUM < ADEN)#                                                       SM03  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SM03  53
SIMWGF = SMTAB1(NINT(ANUM/ADEN*64.0) +1)#                               SM03  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SM03  55
ELSE#                                                                   SM03  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SM03  57
SIMWGF = SMTAB2(NINT(ADEN/ANUM*64.0) +1)#                               SM03  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SM03  59
X(INDEX+IFM) = X(INDEX+IFM)+SIMWGF#                                     SM03  60
X(NBIN+IFM) = X(NBIN+IFM)+SIMWGF#                                       SM03  61
RETURN#                                                                 SM03  62
END#                                                                    SM03  63
pmacro:([no:])#                        Purge xtal macros                SM03  64
