systemheader:(SR    )#                                                  SR     1
####################################################################### SR     2
##      Copyright (C) 2000, The Xtal System, The University of        # SR     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # SR     4
## Distributed under the GNU General Public Licence as published by   # SR     5
## the Free Software Foundation, in the hope that it will be useful   # SR     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # SR     7
## for more details.                                                  # SR     8
##                                                                    # SR     9
##                          *** SORTRF ***                            # SR    10
##                                                                    # SR    11
## SORTRF SORTS REFLECTION DATA AND MERGES THE INTENSITY DATA OF      # SR    12
## SYMMETRICALLY EQUIVALENT REFLECTIONS. FREIDEL RELATED REFLECTIONS  # SR    13
## MAY BE MERGED OR KEPT SEPARATE. THERE IS NO LIMIT TO THE NUMBER    # SR    14
## OF REFLECTIONS.                                                    # SR    15
##      Program authors: J.M. Stewart              1983                 SR    16
##                       N. Spadaccini & S.R.Hall  1984                 SR    17
##                       K.D. Watenpaugh           1885                 SR    18
##                       N. Spadaccini & S.R.Hall  1990                 SR    19
##                                                                      SR    20
####################################################################### SR    21
#                                                                       SR    22
include:(XMACRO)#                                                       SR    23
#                                                                       SR    24
macro:(mxwdim:,incr:(arith:(decr:(mxchim:),/,mxchwd:)))#                SR    25
macro:(swapakwd:,$(movepakwd:($1,QIQI);movepakwd:($2,$1)#               SR    26
movepakwd:(QIQI,$2)$))#                                                 SR    27
macro:(swapqx:,$(QIQI=QX($1);QX($1)=QX($2);QX($2)=QIQI$))#              SR    28
#                                                                       SR    29
extrude:(SRCOMN)#                                                       SR    30
INTEGER DSET#                          Data set number*1000             SR    31
INTEGER FSEP#                          Friedel sep pak flag yes/no      SR    32
INTEGER FRDL#                          Friedel's law flag yes/no        SR    33
INTEGER NPNT#                          Lines to print                   SR    34
INTEGER IR,SS#                         Pointer to hkl & s words         SR    35
INTEGER IGNR#                          Ignore input r code flag   ^     SR    36
INTEGER J1,J2,J3#                      Hkl sort indices                 SR    37
INTEGER MARKS#                         Symop array                      SR    38
INTEGER MARKR#                         Start of sortword array          SR    39
INTEGER MARKH#                         Start of refln data              SR    40
INTEGER STOPR#                         End of sortword array            SR    41
INTEGER MREF#                          Number of reflections input      SR    42
INTEGER NREF#                          Number of reflections output     SR    43
INTEGER NTYP#                          Type of data processed 0 2 4     SR    44
INTEGER STEPP#                         Packet size                      SR    45
INTEGER MERGE#                         Merge type  -1, 0, 1, 2          SR    46
INTEGER SORT#                          Sort type 1, 2, 3                SR    47
INTEGER AREF#                          Sigma of accepted reflection     SR    48
INTEGER RREF#                          Sigma of rejected reflection     SR    49
INTEGER PREJ#                          Flag for print rejects only      SR    50
INTEGER NOTHS#                         Number extra items to average    SR    51
INTEGER OTHERS(30)#                    Table of items for averaging     SR    52
REAL PREF#                             List reflections with many o     SR    53
REAL SDEV#                             Sigma cut-off for i rejectio     SR    54
REAL RTHR#                             Sigma cut-off for rcode2         SR    55
REAL RFACT1#                           Average r equivs                 SR    56
REAL RFACT2#                           Average sigi/irel                SR    57
REAL XMIN(3),XMAX(3)#                  Min and max input h,k,l          SR    58
REAL HMIN(3),HMAX(3)#                  Min and max h,k,l                SR    59
REAL SMIN,SMAX#                        Min and max sint/l               SR    60
REAL NFACT#                            Number of contributors           SR    61
REAL COUNT(7)#                         Count of each rcode     ^        SR    62
#                                                                       SR    63
COMMON/COMISR/DSET,MARKS,MARKR,MARKH,NPNT,IR,PREJ,FSEP,#                SR    64
SS,J1,J2,J3,MERGE,NREF,NTYP,STEPP,FRDL,SORT,AREF,RREF,STOPR,MREF,#      SR    65
NOTHS,OTHERS,IGNR#                     ^                                SR    66
#                                                                       SR    67
COMMON/COMFSR/PREF,SDEV,RTHR,RFACT1,RFACT2,NFACT,COUNT,#                SR    68
XMIN,XMAX,HMIN,HMAX,SMIN,SMAX#                                          SR    69
endext:#                                                                SR    70
#                                                                       SR    71
systemheader:(SR00)#                   Sort/merge reflection data       SR00   1
# ################################################################## #  SR00   2
#                                                                    #  SR00   3
#                               SR00                                 #  SR00   4
#                                                                    #  SR00   5
# ################################################################## #  SR00   6
SUBROUTINE SR00#                                                        SR00   7
include:(AACOMN)#                                                       SR00   8
include:(SRCOMN)#                                                       SR00   9
#                                                                       SR00  10
FILEXT(ioda1:)   ='XX0'#               Direct access binary file        SR00  11
FILEXT(IOUNIT(3))='XX3'#               Extension scratch file 2         SR00  12
FILEXT(IOUNIT(4))='XX4'#               Extension scratch file 3         SR00  13
#                                                                       SR00  14
CALL SR10#                             Read controls and print          SR00  15
CALL SR20#                             Make packed sort hkl word        SR00  16
CALL SR30#                             Sort hkl on canonical word       SR00  17
CALL SR40#                             Merge data if requested          SR00  18
CALL SR50#                             Update & finish off bdf          SR00  19
#                                                                       SR00  20
RETURN#                                                                 SR00  21
END#                                                                    SR00  22
systemheader:(SR10)#                   Enter control lines & bdf        SR10   1
# ################################################################## #  SR10   2
#                                                                    #  SR10   3
#                               SR10                                 #  SR10   4
#                                                                    #  SR10   5
# ################################################################## #  SR10   6
SUBROUTINE SR10#                                                        SR10   7
include:(AACOMN)#                                                       SR10   8
include:(SRCOMN)#                                                       SR10   9
#                                                                       SR10  10
INTEGER I,J,K,K1,K2,K3,L,M,N,LL,LLL#   General indices                  SR10  11
INTEGER NEWPAK,PSIZ,IP,JP#             Packet sizes                     SR10  12
INTEGER IWNT(5),IREL(6),KEY(4)#        To read lrexpl:                  SR10  13
INTEGER POSIND(3),PHIT,PAXIS#          Index sign patterns              SR10  14
chardata:(SR101, LABEL  MERGE END    )#                                 SR10  15
chardata:(SR102,AVE NAV PRI NOP CUL NCU MOB SUC UNS $#                  SR10  16
IRE F2R FRE SOR ORD PAK SEP DSE CLU RTH IGN )# ^                        SR10  17
chardata:(SR103," s/m/f ordering indices                         ")#    SR10  18
chardata:(SR104," Sorting algorithm                              ")#    SR10  19
chardata:(SR105," SORTRF Control Parameters")#                          SR10  20
chardata:(SR106," Friedel pairs treated as                $#            SR10  21
equivalent  ")#                                                         SR10  22
chardata:(SR107," Rejection criterion                         sigma ")# SR10  23
chardata:(SR108,"HKL noyes-Frel sqrdFrelative none     ")#              SR10  24
chardata:(SR109,"ONE TWO poisson    equivalentsmaximum    rejected   ")#SR10  25
chardata:(SR10A,' Sigma (Fisher test passed)                         ')#SR10  26
chardata:(SR10B,' Sigma (Fisher test failed)                         ')#SR10  27
chardata:(SR10C," Reflections printed                                ")#SR10  28
chardata:(SR10D,[(*)(R)   ])#                                           SR10  29
chardata:(SR10E," Friedel pairs output                    same $#       SR10  30
refln packet      ")#                                                   SR10  31
chardata:(SR10F," separate independentnone      $#                      SR10  32
separate refln packets")#                                               SR10  33
chardata:(SR10G," Equivalent data clustered               yes        ")#SR10  34
chardata:(SR10W," Averaging algorithm                     1         ")# SR10  35
chardata:(SR10V," Coefficient averaged (Y)                Intensity ")# SR10  36
chardata:(SR10Y," Reflection code 2 threshold               x sigma  ")#SR10  37
chardata:(SR10Z," Extra bdf items averaged:")#                          SR10  38
intdata:(TEST,[1,0,0,0,1,0,0,0,1])#                                     SR10  39
datastuff:#                                                             SR10  40
#                                                                       SR10  41
#   SET DEFAULT PARAMETERS                                              SR10  42
#   ----------------------                                              SR10  43
#                                                                       SR10  44
IGNR=no:#                              Use input r in merge   ^         SR10  45
RTHR=0.#                               Rcode2 threshold                 SR10  46
MERGE=-1#                              Assume no merge                  SR10  47
SDEV=0.#                               Set default cutoff for rej.      SR10  48
NPNT=25#                               Set default print lines          SR10  49
FRDL=no:#                              Set friedel's to merge           SR10  50
FSEP=no:#                              Put friedel's same packet        SR10  51
PREF=100.#                             Do not list many obs refs        SR10  52
SORT=1#                                Use list only scheme             SR10  53
AREF=1#                                Sigma based on poisson           SR10  54
RREF=3#                                Sigma based on max(1,2)          SR10  55
PREJ=yes:#                             Print rejec refl only            SR10  56
NTYP=0#                                Set for intensity input          SR10  57
DSET=1000#                             Default data set is 1            SR10  58
J1=0;  J2=0;  J3=0#                    Store the sort indices           SR10  59
DO I=1,3; XMAX(I)=-1000.#              Set input hkl max                SR10  60
DO I=1,3; XMIN(I)=1000.#               Set input hkl min                SR10  61
DO I=1,3; HMAX(I)=-1000.#              Set merged hkl max               SR10  62
DO I=1,3; HMIN(I)=1000.#               Set merged hkl min               SR10  63
SMIN=10.;  SMAX=0.#                    Sint/l merged min and max        SR10  64
DO I=1,7; COUNT(I)=0.#                 Reset rcode/friedel counts       SR10  65
NOTHS=0; DO I=1,30; OTHERS(I)=0#       Reset extra items table          SR10  66
#                                                                       SR10  67
#   EXTRACT OTHER INPUT OPTIONS                                         SR10  68
#   ---------------------------                                         SR10  69
#                                                                       SR10  70
FOR(K=1;K<=mxfdim:;K=K+1)#             Loop over chrin                  SR10  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SR10  72
ifvo:(BUFIN(K))BREAK#                  Cease at first void field        SR10  73
IF(BUFIN(K)>voidflg:) NEXT#            Must be alpha to compute         SR10  74
stringlim:(K,L,J)#                     Get string pointers              SR10  75
compchar:(CHRIN,L,SR102,1,3,4,NSR102,N)# Check the list                 SR10  76
IF(N==0) iquit:(SR1006,K)#             Not recognised....sr1006         SR10  77
IF(N==1)#                              Check merge option               SR10  78
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SR10  79
IF(BUFIN(K+1)>0.) MERGE=NINT(BUFIN(K+1))# Set merge scheme              SR10  80
ELSE              MERGE=1#             Default merge is one             SR10  81
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SR10  82
ELSE IF(N==3)#                         Print line                       SR10  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SR10  84
PREJ=no:#                              Switch off reject print          SR10  85
IF(BUFIN(K+1)<=voidflg:) NPNT=99999#   Print all reflections            SR10  86
ELSE#                                  Specific count is input          SR10  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SR10  88
K=K+1; NPNT=ABS(NINT(BUFIN(K)))#       Number of refls                  SR10  89
IF(BUFIN(K)<0.) PREJ=yes:#             If numeric (positive)            SR10  90
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SR10  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SR10  92
ELSE IF(N==4)      NPNT=0#             Kill all ref printing            SR10  93
ELSE IF(N==5)#                         Check for average i cutoff       SR10  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SR10  95
IF(BUFIN(K+1)>0.5) SDEV=BUFIN(K+1)#    If it's sensible numeric         SR10  96
ELSE               SDEV=3.#            Set default reject. thresh.      SR10  97
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SR10  98
ELSE IF(N==7)#                         Test mob in input                SR10  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SR10 100
IF(BUFIN(K+1)>-.5) PREF=BUFIN(K+1)#    Set print obs limit              SR10 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SR10 102
ELSE IF(N==8)#                         Refls satisfyng hypothesis       SR10 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SR10 104
IF(BUFIN(K+1)>0.5) AREF=NINT(BUFIN(K+1))# Set sigma to be used          SR10 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SR10 106
ELSE IF(N==9)#                         Refls not satisfying hypoth.     SR10 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SR10 108
IF(BUFIN(K+1)>0.5) RREF=NINT(BUFIN(K+1))# Set sigma to be used          SR10 109
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SR10 110
ELSE IF(N==10) NTYP=0#                 Process intensity data           SR10 111
ELSE IF(N==11) NTYP=2#                 Process frel sqrd data           SR10 112
ELSE IF(N==12) NTYP=4#                 Process frel      data           SR10 113
ELSE IF(N==13)#                        Test for sort type               SR10 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SR10 115
IF(BUFIN(K+1)>0.5) SORT=NINT(BUFIN(K+1))# Set sort type to be used      SR10 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SR10 117
ELSE IF(N==14)#                        Test for sort order              SR10 118
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SR10 119
stringlim:(K+1,I,J)#                   Bring in the sorting order       SR10 120
compchar:(CHRIN,I  ,SR108,1,1,1,3,K1)# Find slow varying index          SR10 121
compchar:(CHRIN,I+1,SR108,1,1,1,3,K2)# Find med  varying index          SR10 122
compchar:(CHRIN,I+2,SR108,1,1,1,3,K3)# Find fast varying index          SR10 123
IF(K1*K2*K3==0) NEXT#                  This is not a sort index         SR10 124
J1=K1; J2=K2; J3=K3; K=K+1#            Store sort indices               SR10 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SR10 126
ELSE IF(N==15) FRDL=yes:#              Friedels in separate packet      SR10 127
ELSE IF(N==16) FSEP=yes:#              Friedels in separate packet      SR10 128
ELSE IF(N==17) DSET=NINT(BUFIN(K+1))*1000# Get data set number          SR10 129
ELSE IF(N==18) MERGE=0#                Cluster symmetry equivalents     SR10 130
ELSE IF(N==19)#                        Rcode 2 criterion                SR10 131
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SR10 132
IF(BUFIN(K+1)>-1.) RTHR=BUFIN(K+1)#    Set sigma factor to be used      SR10 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SR10 134
ELSE IF(N==20) IGNR=yes:#              Ignore the incoming r codes      SR10 135
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SR10 136
IF(FSEP==yes:) FRDL=yes:#              Set this for message below       SR10 137
IF(FRDL==yes:&MERGE<0) MERGE=1#        Force averaging if frdl=yes      SR10 138
IF(MERGE>=0)   SORT=MAX(2,SORT)#       Must be a sort merge/cluster t   SR10 139
#                                                                       SR10 140
#    SET IO BUFFERS AND ARRAY MARKERS                                   SR10 141
#    --------------------------------                                   SR10 142
#                                                                       SR10 143
IOMARK(1)=QXSTR#                       Start of file a buffer           SR10 144
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of file b buffer           SR10 145
IOMARK(3)=IOMARK(2)+bdfbuf:#           Start of file c buffer           SR10 146
IOMARK(4)=IOMARK(3)+bdfbuf:#           Start of file d buffer           SR10 147
MARKS=IOMARK(4)+bdfbuf:#               Start of symmetry matrices       SR10 148
incrqx:(I,MARKS,SR1001)#               Request storage....sr1001        SR10 149
#                                                                       SR10 150
#   ENTER =MERGE=, =LABEL= OR =END= LINES                               SR10 151
#   ------------------------------------                                SR10 152
#                                                                       SR10 153
copyfile:(1,2,1,lrlabl:)#              Copy up to label records         SR10 154
REPEAT#                                Loop over input line             SR10 155
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SR10 156
readline:(SR101,NSR101)#               Read next line                   SR10 157
IF(LINID==3) BREAK#                    Exit if end line                 SR10 158
IF(LINID==2)#                          Extra items requested            SR10 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SR10 160
IF(MERGE>0)#                           Only average when asked to       SR10 161
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SR10 162
FOR(K=1;(BUFIN(K)>voidflg:&K<=30);K=K+1)#                               SR10 163
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SR10 164
OTHERS(K)=NINT(BUFIN(K))#              Store items                      SR10 165
IF(OTHERS(K)==(300+DSET+NTYP)$#        Is it sensible?                  SR10 166
  \OTHERS(K)==(301+DSET+NTYP)) iquit:(SR1002)# Tell user and die        SR10 167
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SR10 168
NOTHS=NOTHS+K-1#                       Store number of items            SR10 169
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SR10 170
NEXT#                                  Get next line                    SR10 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SR10 172
ELSE IF(LINID==1)#                     Process extra label              SR10 173
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SR10 174
writepkt:(2,lrlabl:,mxwdim:,JP)#       Point to next label packet       SR10 175
movector:(BLANK,1,QX(JP+1),1,mxchim:,1)# Blank out packet               SR10 176
movector:(CHRIN,1,QX(JP+1),1,CHRMAX,0)# Transfer label line             SR10 177
movechar:(BLANK,1,CHRIN,1,6,2)#        Blank out label                  SR10 178
writeline:(0,CHRIN,CHRMAX,3,3)#        Print new label                  SR10 179
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SR10 180
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SR10 181
copyfile:(1,2,incr:(lrlabl:),decr:(lrsymm:))# Copy to symmetry record   SR10 182
#                                                                       SR10 183
#   EXTRACT SYMMETRY CODES & MATRICES (LRSYMM:)                         SR10 184
#   ---------------------------------------                             SR10 185
#                                                                       SR10 186
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Read first packet of lr lrsy     SR10 187
writepkt:(2,lrsymm:,PSIZ,JP)#          Point to op buffer               SR10 188
movereal:(QX,IP+1,QX,JP+1,PSIZ,1)#     Copy to op buffer                SR10 189
N=NINT(QX(IP+2))#                      Centric=0 / acentric=1           SR10 190
M=NINT(QX(IP+4))#                      Get number rotation matrices     SR10 191
incrqx:(MARKR,MARKS+M*12*(2-N),SR1001)# Expand qx......sr1005           SR10 192
FOR(J=MARKS;J>0;J=J+12)#               Loop over symm matrices          SR10 193
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SR10 194
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Get packet pointer               SR10 195
IF(IP<=0) BREAK#                       Exit after last packet           SR10 196
writepkt:(2,lrsymm:,PSIZ,JP)#          Get pointer to o/p buffer        SR10 197
movereal:(QX,IP+1,QX,JP+1,PSIZ,1)#     And copy the packet              SR10 198
movereal:(QX,IP+1,QX,J+1,PSIZ,1)#      Save the symop for later         SR10 199
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SR10 200
IF(N==0)#                              For centro symmetry              SR10 201
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SR10 202
K=J#                                   Store current symop pointer      SR10 203
FOR(I=MARKS;I<J;I=I+1)#                Loop over store symops           SR10 204
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SR10 205
K=K+1;   QX(K)=-QX(I+1)#               Reverse symops                   SR10 206
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SR10 207
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SR10 208
copyfile:(1,2,incr:(lrsymm:),decr:(lrexpl:))# Copy up to lrexpl:        SR10 209
#                                                                       SR10 210
#  UPDATE LREXPL: AND PLACE ON FILED                                    SR10 211
#  ---------------------------------                                    SR10 212
#                                                                       SR10 213
IWNT(1)=1;   IWNT(2)=12#               Dataset and sort order           SR10 214
IWNT(3)=12;  IWNT(4)=36;  IWNT(5)=11#  Sort order & sign pattern        SR10 215
KEY(1)=0; KEY(2)=2; KEY(3)=5; KEY(4)=0# Update lrexpl: directory        SR10 216
indexpkt:(1,lrexpl:,PSIZ,IP,4,KEY,IWNT,IREL)# Update lrexpl: director   SR10 217
IF(IP<=0 \ KEY(4)<=0) iquit:(SR1007)#  Somethings not right             SR10 218
NEWPAK=KEY(4)#                         Save new packet size             SR10 219
#                                                                       SR10 220
REPEAT#                                Loop over lrexpl: packets        SR10 221
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SR10 222
readwpkt:(1,lrexpl:,PSIZ,IP,0)#        Point to next ip packet          SR10 223
IF(IP<=0) BREAK#                       Exit on after last packet        SR10 224
writepkt:(4,lrexpl:,NEWPAK,JP)#        Point to new op packet           SR10 225
movereal:(QX,IP+1,QX,JP+1,PSIZ,0)#     Transfer existing data           SR10 226
J=IP+IREL(1); IF(J>IREL(1))#           Is data set present              SR10 227
ifne:(NINT(QX(J)),DSET/1000) NEXT#     Skip if not sought data set      SR10 228
IF(J1==0)#                             Has sort order been entered      SR10 229
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SR10 230
J=IP+IREL(2); IF(J>IP&QX(J)>0.)#       Is sort order present            SR10 231
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SR10 232
J=NINT(QX(J)); J1=J/100; J2=MOD(J,100)/10; J3=MOD(J,10)# Sort codes     SR10 233
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SR10 234
ELSE#                                  Set defaults                     SR10 235
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SR10 236
J1=1; J2=2; J3=3#                      Set defaults                     SR10 237
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SR10 238
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SR10 239
#                                                                       SR10 240
POSIND(J1)=1; POSIND(J2)=0; POSIND(J3)=0# Assume only freidel           SR10 241
IF(M>1 & M<4)#                         If nrot=2 or 3                   SR10 242
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SR10 243
PHIT=0#                                Set to look for two fold axis    SR10 244
FOR(L=MARKS;L<MARKR;L=L+12)#           Loop over symops                 SR10 245
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 SR10 246
K=-2; LL=L-2; LLL=L-1#                 Set to get rows & columns        SR10 247
DO J=1,3#                              Loop over all axes               SR10 248
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 SR10 249
K=K+3; LL=L+3;  LLL=LLL+1#             Advance down and across          SR10 250
IF(NINT(QX(LL+1))!=TEST(K)) NEXT#      R(1,j)                           SR10 251
IF(NINT(QX(LL+2))!=TEST(K+1)) NEXT#    R(2,j)                           SR10 252
IF(NINT(QX(LL+3))!=TEST(K+2)) NEXT#    R(3,j)                           SR10 253
IF(NINT(QX(LLL+1))!=TEST(K)) NEXT#     R(j,1)                           SR10 254
IF(NINT(QX(LL +4))!=TEST(K+1)) NEXT#   R(j,2)                           SR10 255
IF(NINT(QX(LL+7))!=TEST(K+2)) NEXT#    R(j,3)                           SR10 256
PHIT=PHIT+1;  PAXIS=J#                 Count diags & store axis         SR10 257
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 SR10 258
IF(PHIT!=1) NEXT#                      2 fold found?                    SR10 259
IF(PAXIS==J1) POSIND(J2)=1#            Either one or other ok           SR10 260
ELSE          POSIND(PAXIS)=1#         Only 2-fold all + signs          SR10 261
BREAK#                                 Stop search                      SR10 262
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 SR10 263
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 SR10 264
ELSE IF(M>3)#                          Need only one octant             SR10 265
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 SR10 266
POSIND(J2)=1; POSIND(J3)=1#            Set true for all h,k,l           SR10 267
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 SR10 268
#                                                                       SR10 269
N=IREL(3)+JP#                          Sort order op pointer            SR10 270
QX(N)=FLOAT(J1*100+J2*10+J3)#          Store sort order code            SR10 271
N=IREL(4)+JP#                          Sign pattern op pointer          SR10 272
QX(N)=FLOAT(POSIND(1)*100+POSIND(2)*10+POSIND(3))# Store sign pattern   SR10 273
N=IREL(5)+JP#                          Sort method pointer              SR10 274
QX(N)=FLOAT(SORT)#                     Store sort method signal         SR10 275
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SR10 276
copyfile:(1,4,incr:(lrexpl:),decr:(lrrefl:))# Copy up to lrrefl:        SR10 277
incrqx:(I,MARKR+1024,SR1001)#          Mem for hkl stats...sr1004       SR10 278
#                                                                       SR10 279
#    LIST SELECTED OPTIONS                                              SR10 280
#    ---------------------                                              SR10 281
#                                                                       SR10 282
movechar:(SR108,10,CHROT,2,NSR105-1,2)# Underline header                SR10 283
writeline:(1,SR105,NSR105,2,3)#        Print header                     SR10 284
ncodefld:(FLOAT(SORT),1,SR104,420213.,1)#                               SR10 285
writeline:(0,SR104,NSR104,3,3)#                                         SR10 286
movechar:(SR108,J1,SR103,42,1,0)#      Insert slow index                SR10 287
movechar:(SR108,J2,SR103,43,1,0)#      Insert med  index                SR10 288
movechar:(SR108,J3,SR103,44,1,0)#      Insert fast index                SR10 289
writeline:(0,SR103,NSR103,2,3)#        Print sort indices               SR10 290
IF(MERGE==0) writeline:(0,SR10G,NSR10G,3,3)#                            SR10 291
IF(MERGE>0)#                           If merge applied                 SR10 292
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 SR10 293
ncodefld:(FLOAT(MERGE),1,SR10W,420213.,1)#                              SR10 294
writeline:(0,SR10W,NSR10W,3,3)#                                         SR10 295
IF(NTYP==2)movechar:(SR108,11,SR10V,42,9,0)# Insert 'frel sqrd'         SR10 296
IF(NTYP==4)movechar:(SR108,20,SR10V,42,9,0)# Insert 'frelative'         SR10 297
writeline:(0,SR10V,NSR10V,3,3)#        Print merge option               SR10 298
IF(MERGE==1)#                          Test for cut option              SR10 299
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 SR10 300
IF(SDEV>.5) ncodefld:(SDEV,1,SR107,440412.,1)# Format merge sdev        SR10 301
ELSE movechar:(SR10F,22,SR107,42,10,0)# Print no rejections             SR10 302
writeline:(0,SR107,NSR107,3,3)#                                         SR10 303
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 SR10 304
IF(MERGE==2)#                                                           SR10 305
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 SR10 306
movechar:(SR109,(AREF-1)*11+9,SR10A,42,11,0)#                           SR10 307
writeline:(0,SR10A,NSR10A,3,3)#                                         SR10 308
movechar:(SR109,(RREF-1)*11+9,SR10B,42,11,0)#                           SR10 309
writeline:(0,SR10B,NSR10B,3,3)#                                         SR10 310
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 SR10 311
IF(NOTHS>0)#                           If extra items averaged          SR10 312
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 SR10 313
writeline:(0,SR10Z,NSR10Z,3,3)#        Print header                     SR10 314
FOR(I=1;I<=NOTHS;I=I+1)#               Loop over itmes                  SR10 315
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 SR10 316
ncodefld:(FLOAT(OTHERS(I)),1,CHROT,300513.,1)# Encode id numbers        SR10 317
writeline:(0,SR10Z,NSR10Z,1,3)#        Print id numbers                 SR10 318
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 SR10 319
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 SR10 320
IF(FRDL>0)#                                                             SR10 321
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 SR10 322
movechar:(SR10F,11,SR106,42,11,0)#     Independent                      SR10 323
writeline:(0,SR106,NSR106,3,3)#        Print freidel option             SR10 324
IF(FSEP>0)movechar:(SR10F,32,SR10E,42,22,0)# Friedel pairs sep packet   SR10 325
writeline:(0,SR10E,NSR10E,3,3)#        Print freidel option             SR10 326
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 SR10 327
ELSE writeline:(0,SR106,NSR106,3,3)#   Print freidel option             SR10 328
ncodefld:(RTHR,1,SR10Y,420622.,1)#     Format rcode threshold           SR10 329
writeline:(0,SR10Y,NSR10Y,3,3)#        Print rcode threshold      ^     SR10 330
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 SR10 331
IF(NPNT>0)#                                                             SR10 332
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 SR10 333
ncodefld:(FLOAT(NPNT),1,SR10C,450513.,1)#                               SR10 334
IF(PREJ==yes:&MERGE==1) movechar:(SR10D,4,SR10C,32,3,0)#                SR10 335
IF(PREJ==yes:&MERGE==2) movechar:(SR10D,1,SR10C,32,3,0)#                SR10 336
writeline:(0,SR10C,NSR10C,3,3)#                                         SR10 337
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 SR10 338
#                                                                       SR10 339
RETURN#                                                                 SR10 340
END#                                                                    SR10 341
systemheader:(SR20)#                   Store sort hkl word file c       SR20   1
# ################################################################## #  SR20   2
#                                                                    #  SR20   3
#                               SR20                                 #  SR20   4
#                                                                    #  SR20   5
# ################################################################## #  SR20   6
SUBROUTINE SR20#                       N. spadaccini apr 1990           SR20   7
include:(AACOMN)#                                                       SR20   8
include:(SRCOMN)#                                                       SR20   9
#                                                                       SR20  10
REAL H(3),U,V,W#                       Original hkl's                   SR20  11
INTEGER HS,HM,HF,JS,JM,JF#             Slow medium fast varying         SR20  12
INTEGER IB,IPAK#                       Bijvoet & friedel flags          SR20  13
INTEGER IK,NPAK,NSTEP,NSTEP0,NSTEP1,NSTEP2#                             SR20  14
INTEGER I,J,K,JREL(100),KREL(100)#                                      SR20  15
REAL MINHKL,HKL#                       Current lowest packed hkl        SR20  16
INTEGER KEY(4),IWNT(31),IREL(32)#                                       SR20  17
INTEGER IP,JP,PSIZ#                                                     SR20  18
chardata:(SR01," ** WARNING ** Averaged coeff changed from Intensity $# SR20  19
to Frelative")#                                                         SR20  20
chardata:(SR02,"Intensity Frel sqrd Frelative ")#                       SR20  21
datastuff:#                                                             SR20  22
#                                                                       SR20  23
#    ENTER LRREFL: DATA                                                 SR20  24
#    ------------------                                                 SR20  25
#                                                                       SR20  26
IWNT(1)=1;   IWNT(2)=2#                Need hkl and sin theta/lambda    SR20  27
DO I=0,9; IWNT(I+ 3)=DSET+300+I#       Friedel data 1                   SR20  28
DO I=0,9; IWNT(I+13)=DSET+310+I#       Friedel data 2                   SR20  29
KEY(1)=1; KEY(2)=22; KEY(3)=0; KEY(4)=0# Set directory search keys      SR20  30
indexpkt:(1,lrrefl:,PSIZ,IP,0,KEY,IWNT,IREL)# Search directory          SR20  31
IF(IP<=0\KEY(4)<=0) iquit:(SR2001)#    No record....sr2001              SR20  32
IF(IREL(11)<=0)     iquit:(SR2003)#    Must have an rcode to sort       SR20  33
NSTEP=0;  IR=IREL(1); SS=IREL(2)#      Set packet storage step          SR20  34
DO I=1,PSIZ#                           Loop over input directory        SR20  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SR20  36
IF(NINT(QX(IP+I))>=IWNT(3)&$#          Skip if friedel data             SR20  37
   NINT(QX(IP+I))<=IWNT(22)) NEXT#     Skip if friedel data             SR20  38
NSTEP=NSTEP+1#                         Count the non friedel data ite   SR20  39
JREL(NSTEP)=I;   KREL(NSTEP)=I#        Store the non friedel data ite   SR20  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SR20  41
NSTEP0=NSTEP#                          Limit of nonfriedel data         SR20  42
DO I=1,PSIZ#                           Loop over input directory        SR20  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SR20  44
IF(NINT(QX(IP+I))<IWNT(3)\$#           Skip if not friedel 1 data       SR20  45
   NINT(QX(IP+I))>IWNT(12)) NEXT#      Skip if not friedel 1 data       SR20  46
NSTEP=NSTEP+1;  JREL(NSTEP)=I#         Count the friedel 1 data item    SR20  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SR20  48
NSTEP1=NSTEP;   NSTEP=NSTEP0#          Limit of friedel 1 data          SR20  49
DO I=1,PSIZ#                           Loop over input directory        SR20  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SR20  51
IF(NINT(QX(IP+I))<IWNT(13)\$#          Skip if not friedel 2 data       SR20  52
   NINT(QX(IP+I))>IWNT(22)) NEXT#      Skip if not friedel 2 data       SR20  53
NSTEP=NSTEP+1;  KREL(NSTEP)=I#         Count the non friedel data ite   SR20  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SR20  55
NSTEP2=NSTEP;   STEPP=NSTEP1#          Limit of friedel 2 data          SR20  56
#                                                                       SR20  57
writepkt:(4,lrrefl:,STEPP,JP)#         Point to dir op packet           SR20  58
DO I=1,STEPP#                          Loop over data to friedel 1      SR20  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SR20  60
J=JREL(I); QX(JP+I)=QX(IP+J)#          Store new directory order        SR20  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SR20  62
IF(STEPP<PSIZ) NPAK=2#                 Friedel pair need 2 packets      SR20  63
ELSE           NPAK=1#                 No packet splitting needed       SR20  64
#                                                                       SR20  65
IF(MERGE>0&IREL(NTYP+3)==0)#           If data merge applied            SR20  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SR20  67
movechar:(SR02,NTYP*5+1,SR01,44,9,0)#  Insert initial coeff             SR20  68
IF     (IREL(3)>0) NTYP=0#             Reset request to intensity       SR20  69
ELSE IF(IREL(7)>0) NTYP=4#             Reset request to frelative       SR20  70
ELSE IF(IREL(5)>0) NTYP=2#             Reset request to frelsqud        SR20  71
ELSE iquit:(SR2002)#                   Coefficient data missing         SR20  72
movechar:(SR02,NTYP*5+1,SR01,57,9,0)#  Insert final coeff               SR20  73
writeline:(1,SR01,NSR01,2,3)#          Print warning message            SR20  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SR20  75
NREF=0;      MARKH=0#                  Set refln count to zero          SR20  76
I=MAX(100,STEPP*mxchwd:)#              Get dir access record length     SR20  77
opendac:(ioda1:,3,I,' ')#              Open dir access binary file      SR20  78
#                                                                       SR20  79
#  LOOP OVER ALL REFLECTIONS                                            SR20  80
#  -------------------------                                            SR20  81
#                                                                       SR20  82
FOR(IK=MARKR;IK>0;)#                   Loop over the lrrefl: packets    SR20  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SR20  84
readwpkt:(1,lrrefl:,PSIZ,IP,0)#        Point to next ip packet          SR20  85
IF(IP<=0) BREAK#                       Seek end of record               SR20  86
#                                                                       SR20  87
DO IPAK=1,NPAK#                        Loop over op packets             SR20  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SR20  89
K=0#                                   Rezero bufot pointer             SR20  90
IF(IPAK==1)#                           If in friedel 1 packet           SR20  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SR20  92
IF(NINT(QX(IP+IREL(11)))==4) GOTO 100# Skip if friedel missing          SR20  93
DO I=1,NSTEP1#                         Loop over friedel 1 data         SR20  94
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SR20  95
K=K+1#                                 Increment bufot pointer          SR20  96
J=JREL(I); movepakwd:(QX(IP+J),BUFOT(K))# Store friedel 1 data          SR20  97
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SR20  98
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SR20  99
ELSE#                                  If in friedel 2 packet           SR20 100
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SR20 101
IF(NINT(QX(IP+IREL(21)))==4) GOTO 100# Skip if friedel missing          SR20 102
DO I=1,NSTEP2#                         Loop over friedel 2 data         SR20 103
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SR20 104
K=K+1#                                 Increment bufot pointer          SR20 105
J=KREL(I); movepakwd:(QX(IP+J),BUFOT(K))# Store friedel 2 data          SR20 106
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SR20 107
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SR20 108
#                                                                       SR20 109
NREF=NREF+1#                           Count total reflections          SR20 110
gethkl:(IP+IR,H)#                      Unpack hkl                       SR20 111
IF(IPAK==2)#                           Test if friedel 2 hkl            SR20 112
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SR20 113
DO I=1,3; H(I)=-H(I)#                  Apply signs to hkl               SR20 114
IF(NINT(H(1))<0) J=4 ; ELSE J=0#       Set h sign bit                   SR20 115
IF(NINT(H(2))<0) J=J+2#                Set k sign bit                   SR20 116
IF(NINT(H(3))<0) J=J+1#                Set l sign bit                   SR20 117
intpak:(J,HKL,0,3)#                    Pack hkl sign code               SR20 118
intpak:(IABS(NINT(H(3))),HKL,3,9)#     Pack l index                     SR20 119
intpak:(IABS(NINT(H(2))),HKL,12,9)#    Pack k index                     SR20 120
intpak:(IABS(NINT(H(1))),HKL,21,bitlen:(21))# Pack h index              SR20 121
movepakwd:(HKL,BUFOT(IR))#             Store hkl word in op file        SR20 122
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SR20 123
writedac:(ioda1:,,NREF,(BUFOT(J),J=1,STEPP))# Write dir access file     SR20 124
DO I=1,3; XMIN(I)=MIN(XMIN(I),H(I))#   Store input min h k l            SR20 125
DO I=1,3; XMAX(I)=MAX(XMAX(I),H(I))#   Store input max h k l            SR20 126
#                                                                       SR20 127
#  IF MERGING REDUCE TO LOWEST CANONICAL WORD                           SR20 128
#  ------------------------------------------                           SR20 129
#                                                                       SR20 130
IF(MERGE>=0)#                          Apply only if cluster or avera   SR20 131
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SR20 132
U=H(1);  V=H(2);  W=H(3)#              Store h, k, l                    SR20 133
intpak:(1,MINHKL,30,1)#                Set max packed hkl               SR20 134
#                                                                       SR20 135
FOR(K=MARKS;K<MARKR;K=K+12)#           Loop over all symops             SR20 136
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SR20 137
H(1)=U*QX(K+1)+V*QX(K+2)+W*QX(K+3)#    Transform h                      SR20 138
H(2)=U*QX(K+4)+V*QX(K+5)+W*QX(K+6)#    Transform k                      SR20 139
H(3)=U*QX(K+7)+V*QX(K+8)+W*QX(K+9)#    Transform l                      SR20 140
HS=NINT(H(J1))#                        Get slowest-varying index        SR20 141
HM=NINT(H(J2))#                        Get medium -varying index        SR20 142
HF=NINT(H(J3))#                        Get fastest-varying index        SR20 143
IF((HS<0)$#                            Hs must be positive              SR20 144
\ ((HM<0)&(HS==0))$#                   Hs=0 hm negative                 SR20 145
\ ((HF<0)&(HS==0)&(HM==0)))#           Hs=0 hm=0 hf negative            SR20 146
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SR20 147
HS=-HS; HM=-HM; HF=-HF; IB=1#          Reverse hkl set bijvoet          SR20 148
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SR20 149
ELSE IB=0#                             Bijvoet sign not set             SR20 150
intpak:(0,HKL,0,mxbtwd:)#              Clear out previous packed hkl    SR20 151
IF(HM<0) intpak:(1,HKL,29,1)#          Sign code med index -/+ 1/0      SR20 152
IF(HF<0) intpak:(1,HKL,28,1)#          Sign code fas index -/+ 1/0      SR20 153
intpak:(IABS(HS),HKL,19, 9)#           Pack slow index                  SR20 154
intpak:(IABS(HM),HKL,10, 9)#           Pack med  index                  SR20 155
intpak:(IABS(HF),HKL, 1, 9)#           Pack fast index                  SR20 156
intpak:(IB      ,HKL, 0, 1)#           Bijvoet sign code                SR20 157
compakwd:(HKL,GE,MINHKL,NEXT)#         Is new packed hkl smaller        SR20 158
movepakwd:(HKL,MINHKL)#                Store smallest packed hkl        SR20 159
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SR20 160
intunpak:(MINHKL,JM,29,1)#             Sign code med index -/+ 1/0      SR20 161
intunpak:(MINHKL,JF,28,1)#             Sign code fas index -/+ 1/0      SR20 162
intunpak:(MINHKL,HS,19,9)#             Pack slow index                  SR20 163
intunpak:(MINHKL,HM,10,9)#             Pack med  index                  SR20 164
intunpak:(MINHKL,HF, 1,9)#             Pack fast index                  SR20 165
intunpak:(MINHKL,IB, 0,1)#             Bijvoet sign code                SR20 166
JS=1;  JM=1-JM;  JF=1-JF#              Reverse sign bits  -/+ 0/1       SR20 167
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SR20 168
#                                                                       SR20 169
#  IF ONLY SORTING DO NOT CHANGE INDICES                                SR20 170
#  -------------------------------------                                SR20 171
#                                                                       SR20 172
ELSE#                                  When sorting only                SR20 173
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SR20 174
HS=NINT(H(J1))#                        Get slowest-varying index        SR20 175
HM=NINT(H(J2))#                        Get medium -varying index        SR20 176
HF=NINT(H(J3))#                        Get fastest-varying index        SR20 177
IF((HS<0)$#                            Hs must be positive              SR20 178
\ ((HM<0)&(HS==0))$#                   Hs=0 hm negative                 SR20 179
\ ((HF<0)&(HS==0)&(HM==0)))#           Hs=0 hm=0 hf negative            SR20 180
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SR20 181
HS=-HS; HM=-HM; HF=-HF; IB=1#          Reverse hkl set bijvoet          SR20 182
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SR20 183
ELSE IB=0#                             Bijvoet sign not set             SR20 184
IF(HM<0)#                              Test if hm negative              SR20 185
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SR20 186
HM=-HM;  JM=0#                         Set med  index sign -/+ 0/1      SR20 187
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SR20 188
ELSE JM=1#                             Set med  index sign -/+ 0/1      SR20 189
IF(HF<0)#                              Test if hf negative              SR20 190
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SR20 191
HF=-HF;  JF=0#                         Set fast index sign -/+ 0/1      SR20 192
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SR20 193
ELSE JF=1#                             Set fast index sign -/+ 0/1      SR20 194
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SR20 195
#                                                                       SR20 196
#  REPACK FOR DIFFERENT SORT MODES                                      SR20 197
#  -------------------------------                                      SR20 198
#                                                                       SR20 199
IF(SORT==1\SORT==2)#                   Sort on index signs              SR20 200
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SR20 201
IF(SORT==1&IB==1)#                     Is bijvoet bit set               SR20 202
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SR20 203
IB=0;   JS=0;   JM=1-JM;   JF=1-JF#    Reverse sign  -/+ 0/1            SR20 204
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SR20 205
ELSE JS=1#                             Set h slow sign -/+ 0/1          SR20 206
HS=512-(1-JS*2)*HS#                    Restore h slow                   SR20 207
HM=512-(1-JM*2)*HM#                    Restore h med                    SR20 208
HF=512-(1-JF*2)*HF#                    Restore h fast                   SR20 209
intpak:(HS,HKL,21,bitlen:(21))#        Pack slow index                  SR20 210
intpak:(HM,HKL,11,10)#                 Pack med  index                  SR20 211
intpak:(HF,HKL, 1,10)#                 Pack fast index                  SR20 212
IF(FRDL== yes:) intpak:(IB,HKL, 0, 1)# Pack bijvoet bit                 SR20 213
ELSE            intpak:( 0,HKL, 0, 1)# Cancel bijvoet bit               SR20 214
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SR20 215
ELSE#                                  Magnitudes of hkl to govern      SR20 216
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SR20 217
intpak:(HS,HKL,21,bitlen:(21))#        Pack slow index                  SR20 218
intpak:(HM,HKL,12, 9)#                 Pack med  index                  SR20 219
intpak:(HF,HKL, 3, 9)#                 Pack fast index                  SR20 220
intpak:(JM,HKL, 2, 1)#                 Sign code for med index          SR20 221
intpak:(JF,HKL, 1, 1)#                 Sign code for fas index          SR20 222
IF(FRDL== yes:) intpak:(IB,HKL, 0, 1)# Pack bijvoet bit                 SR20 223
ELSE            intpak:( 0,HKL, 0, 1)# Cancel bijvoet bit               SR20 224
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SR20 225
incrqx:(STOPR,IK+2,SR2010.)#           Check enough memory for 2 word   SR20 226
movepakwd:(HKL,QX(IK+1))#              Store smallest packed hkl        SR20 227
QX(IK+2)=FLOAT(NREF)#                  Store dir access record number   SR20 228
IK=STOPR#                              Increment pointer                SR20 229
100 CONTINUE#                          Void data break point            SR20 230
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SR20 231
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SR20 232
IF(FSEP==yes:) FRDL=no:#               Treat friedels independently     SR20 233
#                                                                       SR20 234
RETURN#                                                                 SR20 235
END#                                                                    SR20 236
systemheader:(SR30)#                   Sort hkl on canon pack word      SR30   1
# ################################################################## #  SR30   2
#                                                                    #  SR30   3
#                               SR30                                 #  SR30   4
#                                                                    #  SR30   5
# ################################################################## #  SR30   6
SUBROUTINE SR30#                       J.m. stewart may 1983            SR30   7
include:(AACOMN)#                      S.r. hall mar 1984               SR30   8
include:(SRCOMN)#                      N. spadaccini apr 1990           SR30   9
#                                                                       SR30  10
INTEGER I,J,JJ,K,L,M,NREC#                                              SR30  11
INTEGER JP,HS,HM,HF#                                                    SR30  12
REAL H(3),HKL,QIQI#                                                     SR30  13
#                                                                       SR30  14
chardata:(SR301," Reflections sorted                               ")#  SR30  15
chardata:(SR30A,"    h   k   l")#                                       SR30  16
realdata:(FM,[50413.,90413.,130413.])#                                  SR30  17
datastuff:#                                                             SR30  18
#                                                                       SR30  19
ncodefld:(FLOAT(NREF),1,SR301,450613.,1)# Format total reflections      SR30  20
writeline:(0,SR301,NSR301,2,3)#        Print total reflections          SR30  21
LINRM=4#                               Force first column header        SR30  22
#                                                                       SR30  23
#    SORT HKL IN MEMORY ON CANONICAL WORD                               SR30  24
#    ------------------------------------                               SR30  25
#                                                                       SR30  26
FOR(I=(STOPR-MARKR)/4;I!=0;I=I/2)#     This is a *shell sort*           SR30  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SR30  28
M=I*2#                                 2 words per packet               SR30  29
FOR(J=MARKR+M+1;J<STOPR;J=J+2)#        Which is very efficient for      SR30  30
FOR(K=J-M;K>MARKR;K=K-M)#              Large lists such as this.        SR30  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SR30  32
L=K+M#                                 Pointer with gap                 SR30  33
compakwd:(QX(K),LT,QX(L),BREAK)#       Compare canonical words          SR30  34
swapakwd:(QX(K),QX(L))#                Exchange packed words            SR30  35
swapqx:(K+1,L+1)#                      Exchange order addresses         SR30  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SR30  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SR30  38
#                                                                       SR30  39
#    OUTPUT SORTED HKL BLOCK TO FILED                                   SR30  40
#    ----------------------------------                                 SR30  41
#                                                                       SR30  42
FOR(L=MARKR;L<STOPR;L=L+2)#            Loop over sortword/pointer lis   SR30  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SR30  44
NREC=NINT(QX(L+2))#                    Record number in direct access   SR30  45
writepkt:(4,lrrefl:,STEPP,JP)#         Write out packet                 SR30  46
readdac:(ioda1:,,NREC,(QX(JJ),JJ=JP+1,JP+STEPP))# Move contents of re   SR30  47
IF(MERGE>0)#                           If merge applied                 SR30  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SR30  49
movepakwd:(QX(L+1),HKL)#               Extract canon word               SR30  50
movepakwd:(QX(L+1),QX(JP+1))#          Store canon word                 SR30  51
IF(SORT==1\SORT==2)#                   Signs for sort only type         SR30  52
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SR30  53
intunpak:(HKL,HS,21,10)#               Extract hs index                 SR30  54
intunpak:(HKL,HM,11,10)#               Extract hm index                 SR30  55
intunpak:(HKL,HF, 1,10)#               Extract hf index                 SR30  56
HS=HS-512; HM=HM-512; HF=HF-512#       Get signed indices               SR30  57
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SR30  58
ELSE#                                  Magnitudes predominate           SR30  59
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SR30  60
intunpak:(HKL,HS,21,9)#                Extract hs index                 SR30  61
intunpak:(HKL,HM,12,9)#                Extract hm index                 SR30  62
intunpak:(HKL,HF, 3,9)#                Extract hf index                 SR30  63
intunpak:(HKL,I,2,1)#                  Extract hm sign                  SR30  64
IF(I==0)HM=-HM#                        Set hm sign                      SR30  65
intunpak:(HKL,I,1,1)#                  Extract hf sign                  SR30  66
IF(I==0)HF=-HF#                        Set hf sign                      SR30  67
intunpak:(HKL,I,0,1)#                  Extract hs sign                  SR30  68
IF(I==1)HS=-HS#                        Set hs sign                      SR30  69
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SR30  70
H(J1)=FLOAT(HS); H(J2)=FLOAT(HM); H(J3)=FLOAT(HF)# Float indices        SR30  71
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SR30  72
ELSE gethkl:(JP+IR,H)#                 Get hkl from original packet     SR30  73
DO I=1,3; HMIN(I)=MIN(HMIN(I),H(I))#   Store min h k l                  SR30  74
DO I=1,3; HMAX(I)=MAX(HMAX(I),H(I))#   Store max h k l                  SR30  75
IF(SS>0) SMIN=MIN(SMIN,QX(JP+SS))#     Get min sint/l                   SR30  76
IF(SS>0) SMAX=MAX(SMAX,QX(JP+SS))#     Get max sint/l                   SR30  77
IF(MERGE>0\NPNT<=0) NEXT#              If sort and no print get next    SR30  78
NPNT=NPNT-1#                           Decr print limit                 SR30  79
ncodefld:(H,1,CHROT,FM,3)#             Encode h,k,l                     SR30  80
writeline:(0,SR30A,NSR30A,1,3)#        Print line of intensities        SR30  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SR30  82
closedac:(ioda1:)#                     Close direct access file         SR30  83
copyfile:(1,4,incr:(lrrefl:),endrecord:)# Close off files               SR30  84
#                                                                       SR30  85
RETURN#                                                                 SR30  86
END#                                                                    SR30  87
systemheader:(SR40)#                   Merge sorted hkl data            SR40   1
# ################################################################## #  SR40   2
#                                                                    #  SR40   3
#                               SR40                                 #  SR40   4
#                                                                    #  SR40   5
# ################################################################## #  SR40   6
SUBROUTINE SR40#                       J.m. stewart may 1983            SR40   7
include:(AACOMN)#                      N. spadaccini mar 1984           SR40   8
include:(SRCOMN)#                      S.r. hall mar 1984               SR40   9
#                                                                       SR40  10
INTEGER PSIZ,PSIZO,IP,JP#              Packet pointers                  SR40  11
INTEGER KEY(4),IWNT(38),IREL(39)#      Indexpkt: variables              SR40  12
REAL SUMI,SUM2,SUMW,SUMN,SUMF,SUMS#                                     SR40  13
REAL A,B,AINT,SIGI,RCOD#                                                SR40  14
REAL HKL,HKLN,HKLP,ZERO,FFLAG#                                          SR40  15
REAL ALOGFP,CUT,FN,FN3,RCODE2,REJECT#                                   SR40  16
INTEGER I,IREF,IRR,J,JREF,JJ,K,M,MUCK,NP,NUMB#                          SR40  17
INTEGER H(3),HS,HM,HF#                                                  SR40  18
INTEGER STEPR#                                                          SR40  19
INTEGER IH,II,IS,IIF,ISF,IRF#                                           SR40  20
INTEGER IOTHS(30)#                     Pointers to extra items          SR40  21
REAL SUMV#                             Sum of variance for equivs       SR40  22
REAL SUMD#                             Sum of deviations of equivs      SR40  23
REAL SUMOTH(30)#                       Sums for extra items             SR40  24
REAL AVEOTH(30)#                       Averages for extra items         SR40  25
REAL VARP#                             Variance based on poisson        SR40  26
REAL VARE#                             Variance based on equivs         SR40  27
INTEGER REJFLG#                        Flag for reject refls            SR40  28
REAL FSHR#                             Distribution value               SR40  29
#                                                                       SR40  30
chardata:(SR401,"    h   k   l   intensity     sigma   $#               SR40  31
rcode   contributing data........")#                                    SR40  32
chardata:(SR403,R)#                                                     SR40  33
chardata:(SR405,"Frel sqrdFrelative")#                                  SR40  34
chardata:(SR407,"no data present        4 *")#                          SR40  35
realdata:(FM,[50413.,90413.,130413.,251112.,350912.,410213.])#          SR40  36
realdata:(FACTD,0.); realdata:(FACTS,0.); realdata:(FACTI,0.)#          SR40  37
realdata:(XP,2.3262);   realdata:(FLAM,0.4020)#                         SR40  38
realdata:(R,[98.5,30.8,16.7,11.39,8.75,7.19,6.18,5.47,4.94,4.54,4.22,#  SR40  39
3.96,3.74,3.56,3.40,3.27,3.15,3.05,2.96,2.87,2.80,2.73,2.68,2.62])#     SR40  40
realdata:(CON,[.833333])#                                               SR40  41
datastuff:#                                                             SR40  42
#                                                                       SR40  43
#    PREPARE TO MERGE SORTED DATA ON FILE D                             SR40  44
#    --------------------------------------                             SR40  45
#                                                                       SR40  46
JREF=0#                                                                 SR40  47
DO I=1,39; IREL(I)=0#                  Zero irel array                  SR40  48
MREF=NREF#                             Store input reflection count     SR40  49
IF(MERGE>0)#                           Test if data to be merged        SR40  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SR40  51
NREF=0;  STEPR=STEPP+1#                Reset reflection count           SR40  52
MARKR=MARKS;  MARKS=MARKS+3*STEPR#     Set storage markers              SR40  53
qxmemory:(MARKS)#                      Push back memory                 SR40  54
intpak:(0,ZERO,0,mxbtwd:)#             Create all zero word             SR40  55
movepakwd:(ZERO,HKLP)#                 Flag previous hkl word           SR40  56
FACTD=0.; FACTI=0.; FACTS=0.; NFACT=0.# Zero measurement stats          SR40  57
LINRM=4#                               Force first header               SR40  58
IF(NTYP==2)movechar:(SR405, 1,SR401,17,9,0)# Insert 'frel sqrd'         SR40  59
IF(NTYP==4)movechar:(SR405,10,SR401,17,9,0)# Insert 'frelative'         SR40  60
#                                                                       SR40  61
#   EXTRACT INTENSITY ITEMS FROM LRREFL:                                SR40  62
#   -----------------------------------                                 SR40  63
#                                                                       SR40  64
copyfile:(4,3,lrexpl:,decr:(lrrefl:))# Copy file d to c                 SR40  65
IWNT(1)=1#                             Request hkl                      SR40  66
IWNT(2)=300+DSET+NTYP#                 Request int,fr2,frel             SR40  67
FOR(I=1;I<=NOTHS;I=I+1)$#              Loop over extra id numbers       SR40  68
IWNT(2+I)=OTHERS(I)#                   Set requested id numbers         SR40  69
IWNT(3+NOTHS)=301+DSET+NTYP#           Request sigma                    SR40  70
IWNT(4+NOTHS)=308+DSET#                Request rcode for input          SR40  71
IWNT(5+NOTHS)=308+DSET#                Request rcode for output         SR40  72
KEY(1)=2; KEY(2)=4+NOTHS; KEY(3)=5+NOTHS#                               SR40  73
KEY(4)=0#                              Set directory search keys        SR40  74
IF(FRDL==yes:&FSEP==no:)#              Are pairs in same packet         SR40  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SR40  76
IWNT(6+NOTHS)=310+DSET+NTYP#           Request friedel int              SR40  77
IWNT(7+NOTHS)=311+DSET+NTYP#           Request friedel sigma            SR40  78
IWNT(8+NOTHS)=318+DSET#                Request friedel rcode            SR40  79
KEY(3)=8+NOTHS#                        Set to expand packet             SR40  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SR40  81
indexpkt:(4,lrrefl:,PSIZ,IP,3,KEY,IWNT,IREL)# Search directory          SR40  82
IF(KEY(4)<4+NOTHS) iquit:(SR4001)#     Die if missing....sr4001         SR40  83
PSIZO=KEY(4)#                          Set output packet size           SR40  84
IH =IREL(1); II =IREL(2); IS =IREL(3+NOTHS)# Set relative pointers      SR40  85
IR =IREL(4+NOTHS); IRR=IREL(5+NOTHS); IIF=IREL(6+NOTHS)# Set pointers   SR40  86
ISF=IREL(7+NOTHS); IRF=IREL(8+NOTHS)#  Set relative pointers            SR40  87
FOR(I=1;I<=NOTHS;I=I+1)$#              Loop over extra items            SR40  88
IOTHS(I)=IREL(2+I)#                    Set relative pointers            SR40  89
SUMF=0.;   SUMS=0.#                    Zero                             SR40  90
IF(IGNR==yes:) IR=0#                   Switch off incoming r codes      SR40  91
#                                                                       SR40  92
#   ENTER SORTED DATA FROM FILED; OUTPUT TO FILEC                       SR40  93
#   ---------------------------------------------                       SR40  94
#                                                                       SR40  95
REPEAT#                                Loop over reflection packets     SR40  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SR40  97
readwpkt:(4,lrrefl:,PSIZ,IP,0)#        Read next reflection             SR40  98
IREF=JREF#                             Set storage pointer              SR40  99
IF(IP<=0) GOTO 100#                    Process last & exit              SR40 100
#                                                                       SR40 101
movepakwd:(QX(IP+IH),HKLN)#            Extract new sorted word          SR40 102
compakwd:(HKLP,EQ,ZERO,GOTO200)#       Test if first reflection         SR40 103
incrqx:(JREF,IREF+STEPR,SR4002)#       Get mem ......sr4002             SR40 104
QX(IREF+1)=FFLAG#                      Set friedel flag                 SR40 105
movereal:(QX,IP+1,QX,IREF+2,PSIZ,1)#   Store reflection packet          SR40 106
compakwd:(HKLN,EQ,HKLP,NEXT)#          Skip if equivalent               SR40 107
IF(FSEP==no:)#                         Is friedel independent           SR40 108
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SR40 109
intpak:(1,HKLP,0,1)#                   Set bijvoet bit                  SR40 110
FFLAG=FLOAT(FRDL+1);   QX(IREF+1)=FFLAG# Reset friedel flag             SR40 111
compakwd:(HKLN,EQ,HKLP,NEXT)#          Test if friedel equivalent       SR40 112
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SR40 113
#                                                                       SR40 114
#   LOOP OVER STORED EQUIVALENT REFLECTIONS                             SR40 115
#   ---------------------------------------                             SR40 116
#                                                                       SR40 117
100 CONTINUE#                          Last record branch point         SR40 118
FOR(M=0;M<=FRDL;M=M+1)#                Friedel's flip-flop loop         SR40 119
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SR40 120
FFLAG=FLOAT(M+1)#                      Set friedel flag                 SR40 121
AINT=voidflg:; SIGI=voidflg:; RCOD=4.# Set default i,sigi & rcode       SR40 122
FOR(I=1;I<=NOTHS;I=I+1)$#              Loop over extra averages         SR40 123
AVEOTH(I)=voidflg:#                    Set default averages             SR40 124
REJFLG=no:#                            Assume no rejects                SR40 125
#                                                                       SR40 126
#   MERGE ACCORDING TO SCHEME ONE                                       SR40 127
#   =============================                                       SR40 128
#                                                                       SR40 129
IF(MERGE==1)#                          Apply weighted sums              SR40 130
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SR40 131
DO NP=1,2#                             Process twice for rejections     SR40 132
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SR40 133
AINT=voidflg:; SIGI=voidflg:#          Set default i,sigi & rcode       SR40 134
FOR(I=1;I<=NOTHS;I=I+1)$#              Loop over extra averages         SR40 135
AVEOTH(I)=voidflg:#                    Set default averages             SR40 136
SUMI=0.0;    SUM2=0.0#                 Zero int & int**2 sums           SR40 137
SUMW=0.0;    SUMN=0.0#                 Zero weight & count sums         SR40 138
FOR(I=1;I<=NOTHS;I=I+1)$#              Loop over extra items            SR40 139
SUMOTH(I)=0#                           Zero extra item sums             SR40 140
#                                                                       SR40 141
FOR(J=MARKR+1;J<IREF;J=J+STEPR)#       Loop over stored equivalents     SR40 142
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SR40 143
ifne:(QX(J),FFLAG) NEXT#               Skip if rejected/friedel         SR40 144
ifvo:(QX(J+II))    NEXT#               Skip void data                   SR40 145
IF(IS>0) A=QX(J+IS); ELSE A=1.#        Extract sigma from packet        SR40 146
IF(A<small:) A=1.#                     Avoid silly sigmas               SR40 147
SUMI=SUMI+QX(J+II)#                    Sum intensities                  SR40 148
SUM2=SUM2+QX(J+II)**2#                 Wtd intensity squared            SR40 149
SUMW=SUMW+A*A#                         Sum of sigma squared             SR40 150
FOR(I=1;I<=NOTHS;I=I+1)$#              Loop over extra items            SR40 151
SUMOTH(I)=SUMOTH(I)+QX(J+IOTHS(I))#    Sum of extra items               SR40 152
SUMN=SUMN+1.#                          Times measured                   SR40 153
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SR40 154
#                                                                       SR40 155
#   CALCULATE MEANS FROM EQUIVALENTS                                    SR40 156
#   --------------------------------                                    SR40 157
#                                                                       SR40 158
IF(SUMN<.5) BREAK#                     Skip if all rejected             SR40 159
AINT=SUMI/SUMN#                        Get final intensity              SR40 160
A=SQRT(SUMW)/SUMN#                     Get counting stats sigma         SR40 161
B=SQRT(ABS((SUMN*SUM2-SUMI**2)$#       Calculate dispersion             SR40 162
/(SUMN*SUMN*MAX(0.5,(SUMN-1.0)))))#                                     SR40 163
SIGI=MAX(A,B,(.0001*AINT))#            Get pessimistic sigma            SR40 164
FOR(I=1;I<=NOTHS;I=I+1)$#              Loop over extra items            SR40 165
AVEOTH(I)=SUMOTH(I)/SUMN#              Sum of extra items               SR40 166
IF(NP==2)#                             Exit if second pass              SR40 167
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SR40 168
IF(SUMN>1.5)#                          Make r values if > 1 reflns      SR40 169
FOR(J=MARKR+1;J<IREF;J=J+STEPR)#       Loop over stored equivs          SR40 170
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SR40 171
ifne:(QX(J),FFLAG) NEXT#               Skip if rejected/freidel         SR40 172
ifvo:(QX(J+II))    NEXT#               Skip void data                   SR40 173
IF(IS>0) A=QX(J+IS); ELSE A=1.#        Extract sigma from packet        SR40 174
FACTI=FACTI+QX(J+II)#                  Data set sum of intensities      SR40 175
FACTS=FACTS+A#                         Data set sum of sigmas           SR40 176
FACTD=FACTD+ABS(QX(J+II)-AINT)#        Data set sum of deviations       SR40 177
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SR40 178
BREAK#                                                                  SR40 179
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SR40 180
CUT=SIGI*SDEV#                         Calc sigma cutoff                SR40 181
REJECT=0.;    RCODE2=0.#               Reset reject & rc2 count         SR40 182
NFACT=NFACT+SUMN-1.0#                  Count a contributor              SR40 183
#                                                                       SR40 184
FOR(J=MARKR+1;J<IREF;J=J+STEPR)#       Loop over stored equivalents     SR40 185
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SR40 186
ifne:(QX(J),FFLAG) NEXT#               Skip if rejected/diff friede     SR40 187
ifvo:(QX(J+II))    NEXT#               Skip void data                   SR40 188
IF(IR>0&QX(J+IR)>1.5) RCODE2=RCODE2+1.# Count if rcode > 1              SR40 189
IF(SDEV<0.5) NEXT#                     Do not cull data                 SR40 190
IF(ABS(QX(J+II)-AINT)<CUT) NEXT#       Accept delta < cutoff            SR40 191
IF((SUMN<2.5)&(QX(J+II)>AINT)) NEXT#   Accept if above average          SR40 192
REJECT=REJECT+1.#                      Count rejected reflections       SR40 193
QX(J)=-FFLAG#                          Flag as rejected                 SR40 194
REJFLG=yes:#                           Rejection flag set to yes        SR40 195
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SR40 196
IF(REJECT>=SUMN)#                      Test if all rejected             SR40 197
FOR(J=MARKR+1;J<IREF;J=J+STEPR) QX(J)=ABS(QX(J))# Reset to accept       SR40 198
IF(RCODE2<SUMN) RCOD=1.#               If some not 2 i is obs           SR40 199
ELSE            RCOD=2.#               Set rcode as less than           SR40 200
IF(REJECT>0.5) NEXT#                   For second pass                  SR40 201
IF(SUMN>1.5)#                          Make r values for mult obs       SR40 202
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SR40 203
FOR(J=MARKR+1;J<IREF;J=J+STEPR)#       Loop equivalents                 SR40 204
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SR40 205
ifne:(QX(J),FFLAG) NEXT#                                                SR40 206
ifvo:(QX(J+II))    NEXT#               Skip void data                   SR40 207
IF(IS>0) A=QX(J+IS); ELSE A=1.#        Extract sigma from packet        SR40 208
FACTI=FACTI+QX(J+II)#                  Data set sum of intensities      SR40 209
FACTS=FACTS+A#                         Data set sum of sigmas           SR40 210
FACTD=FACTD+ABS(QX(J+II)-AINT)#        Data set sum of deviations       SR40 211
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SR40 212
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SR40 213
BREAK#                                                                  SR40 214
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SR40 215
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SR40 216
#                                                                       SR40 217
#   MERGE ACCORDING TO SCHEME TWO                                       SR40 218
#   =============================                                       SR40 219
#                                                                       SR40 220
ELSE#                                  Apply scheme 2 merging           SR40 221
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SR40 222
SUMI=0. ; SUMN=0.#                     Set equivs sums to zero          SR40 223
SUMD=0. ; SUMV=0.#                     Ditto                            SR40 224
FOR(I=1;I<=NOTHS;I=I+1)$#              Loop over extra items            SR40 225
SUMOTH(I)=0#                           Reset sum of extra items         SR40 226
FOR(J=MARKR+1;J<IREF;J=J+STEPR)#       Loop over stored equivs          SR40 227
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SR40 228
ifne:(QX(J),FFLAG) NEXT#                                                SR40 229
ifvo:(QX(J+II))    NEXT#               Skip void data                   SR40 230
IF(IS>0) A=QX(J+IS); ELSE A=1.#        Extract sigma from packet        SR40 231
SUMI=SUMI+QX(J+II)#                    Sum intensity of equivs          SR40 232
SUMV=SUMV+A*A#                         Sum variance of equivs           SR40 233
FOR(I=1;I<=NOTHS;I=I+1)$#              Loop over extra items            SR40 234
SUMOTH(I)=SUMOTH(I)+QX(J+IOTHS(I))#    Sum of extra items               SR40 235
SUMN=SUMN+1.#                          Sum observations of equivs       SR40 236
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SR40 237
#                                                                       SR40 238
#    CALCULATE MEAN AND POISSON VARIANCE                                SR40 239
#    -----------------------------------                                SR40 240
#                                                                       SR40 241
IF(SUMN>0.5)#                          Observation there                SR40 242
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SR40 243
RCOD=1.#                               Assume observed                  SR40 244
AINT=SUMI/SUMN#                        Mean intensity                   SR40 245
VARP=SUMV/(SUMN)**2#                   Mean variance                    SR40 246
FOR(I=1;I<=NOTHS;I=I+1)$#              Loop over extra items            SR40 247
AVEOTH(I)=SUMOTH(I)/SUMN#              Averages of extra items          SR40 248
NFACT=NFACT+SUMN-1.0#                  Count a contributor              SR40 249
FOR(J=MARKR+1;J<IREF;J=J+STEPR)#       Deviation                        SR40 250
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SR40 251
ifne:(QX(J),FFLAG) NEXT#                                                SR40 252
ifvo:(QX(J+II))    NEXT#               Skip void data                   SR40 253
SUMD=SUMD+(QX(J+II)-AINT)**2#          Sum of deviation of equivs       SR40 254
IF(SUMN<1.5) NEXT#                     R values for mult obs only       SR40 255
IF(IS>0) A=QX(J+IS); ELSE A=1.#        Extract sigma from packet        SR40 256
FACTI=FACTI+QX(J+II)#                  Sum intensity of data set        SR40 257
FACTS=FACTS+A#                         Sum variance of data set         SR40 258
FACTD=FACTD+ABS(QX(J+II)-AINT)#        Sum of devns of data set         SR40 259
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SR40 260
#                                                                       SR40 261
IF(SUMN==1.) VARE=VARP#                One observation only             SR40 262
ELSE VARE=SUMD/(SUMN*(SUMN-1.))#       Variance based on equivs         SR40 263
#                                                                       SR40 264
#        TEST BOTH VARIANCES TO SEE IF THEY                             SR40 265
#        ARE EQUAL AT THE 1% LEVEL ACCORDING                            SR40 266
#        TO THE F DISTRIBUTION WITH SUMN AND                            SR40 267
#        SUMN-1 DEGREES OF FREEDOM                                      SR40 268
#        -----------------------------------                            SR40 269
#                                                                       SR40 270
FSHR=1000.0#                           Set value high                   SR40 271
NUMB=NINT(SUMN)#                       Number of observations           SR40 272
IF(NUMB>1&NUMB<=25)#                   Within table provided            SR40 273
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SR40 274
FSHR=R(NUMB-1)#                        Extract table value              SR40 275
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SR40 276
ELSE IF(NUMB>25)#                      Outside tabulated values         SR40 277
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SR40 278
FN=FLOAT((NUMB-2)*(NUMB-1))#           Determine values by              SR40 279
FN3=FLOAT(2*NUMB-3)#                   Approximation...                 SR40 280
ALOGFP=(XP*FN3*SQRT(FLAM+2.0*FN/FN3)-FLAM-CON)/FN# See abrahamowitz     SR40 281
FSHR=EXP(ALOGFP)#                      And stegun (math. tables)        SR40 282
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SR40 283
#                                                                       SR40 284
IF(FSHR*VARP>=VARE)#                   Hypothesis accepted              SR40 285
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SR40 286
IF(AREF==1)      SIGI=SQRT(VARP)#      Use poisson sigma                SR40 287
ELSE IF(AREF==2) SIGI=SQRT(VARE)#      Use equivs sigma                 SR40 288
ELSE IF(AREF==3) SIGI=SQRT(AMAX1(VARP,VARE))# Use larger of two         SR40 289
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SR40 290
ELSE#                                  Hypothesis rejected              SR40 291
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SR40 292
REJFLG=yes:#                                                            SR40 293
IF(RREF==1)      SIGI=SQRT(VARP)#      Use poisson sigma                SR40 294
ELSE IF(RREF==2) SIGI=SQRT(VARE)#      Use equivs sigma                 SR40 295
ELSE IF(RREF==3) SIGI=SQRT(AMAX1(VARP,VARE))# Use larger of two         SR40 296
ELSE#                                                                   SR40 297
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SR40 298
RCOD=2.#                               Reject outright                  SR40 299
FOR(J=MARKR+1;J<IREF;J=J+STEPR)#                                        SR40 300
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SR40 301
ifvo:(QX(J+II))    NEXT#               Skip void data                   SR40 302
IF(IS>0) A=QX(J+IS); ELSE A=1.#        Extract sigma from packet        SR40 303
FACTI=FACTI-QX(J+II)#                  Remove contribution of           SR40 304
FACTS=FACTS-A#                         Rejected refls from the          SR40 305
FACTD=FACTD-ABS(QX(J+II)-AINT)#        Merging r-factors                SR40 306
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SR40 307
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SR40 308
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SR40 309
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SR40 310
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SR40 311
#                                                                       SR40 312
#   OUTPUT MERGED DATA TO FILEC                                         SR40 313
#   ---------------------------                                         SR40 314
#                                                                       SR40 315
IF(M==0)#                              On first pass get op packet      SR40 316
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SR40 317
writepkt:(3,lrrefl:,PSIZO,JP)#         Point to output packet           SR40 318
movereal:(QX,MARKR+2,QX,JP+1,PSIZ,1)#  Copy first of old pkts           SR40 319
NREF=NREF+1#                           Count output reflections         SR40 320
movepakwd:(QX(JP+IH),HKL)#             Extract canonical word           SR40 321
IF(SORT==2)#                           Signs predominate                SR40 322
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 SR40 323
intunpak:(HKL,HS,21,10)#               Extract hs index                 SR40 324
intunpak:(HKL,HM,11,10)#               Extract hm index                 SR40 325
intunpak:(HKL,HF, 1,10)#               Extract hf index                 SR40 326
intunpak:(HKL, K, 0,1)#                Extract bijvoet sign             SR40 327
HS=HS-512; HM=HM-512; HF=HF-512#       Get signed indices               SR40 328
IF(K==1)#                              If bijvoet bit set               SR40 329
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 SR40 330
HF=-HF; HM=-HM; HS=-HS#                Reverse signs                    SR40 331
COUNT(7)=COUNT(7)+1.#                  Count the friedel data   ^       SR40 332
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 SR40 333
ELSE COUNT(6)=COUNT(6)+1.#             Count the non-friedel data   ^   SR40 334
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 SR40 335
ELSE IF(SORT==3)#                      Magnitudes predominate           SR40 336
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 SR40 337
intunpak:(HKL,HS,21,9)#                Extract hs index                 SR40 338
intunpak:(HKL,HM,12,9)#                Extract hm index                 SR40 339
intunpak:(HKL,HF, 3,9)#                Extract hf index                 SR40 340
intunpak:(HKL, I, 2,1)#                Extract hm sign                  SR40 341
intunpak:(HKL, J, 1,1)#                Extract hf sign                  SR40 342
intunpak:(HKL, K, 0,1)#                Extract bijvoet sign             SR40 343
IF(K==1)#                              Test bijvoet bit -/+ 0/1         SR40 344
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 SR40 345
HS=-HS#                                Reverse hs index                 SR40 346
IF(I==1) HM=-HM#                       Reverse hm sign                  SR40 347
IF(J==1) HF=-HF#                       Reverse hf sign                  SR40 348
COUNT(7)=COUNT(7)+1.#                  Count the friedel data   ^       SR40 349
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 SR40 350
ELSE#                                  If bijvoet bit not set           SR40 351
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 SR40 352
IF(I==0) HM=-HM#                       Reverse hm sign                  SR40 353
IF(J==0) HF=-HF#                       Reverse hf sign                  SR40 354
COUNT(6)=COUNT(6)+1.#                  Count the non-friedel data   ^   SR40 355
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 SR40 356
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 SR40 357
H(J1)=HS;  H(J2)=HM;  H(J3)=HF#        Return hkl to ip order           SR40 358
IF(NINT(FFLAG)==1&NINT(RCOD)==4)#      If absent reverse friedel hkl    SR40 359
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 SR40 360
H(1)=-H(1); H(2)=-H(2); H(3)=-H(3)#    Reverse friedel hkl's            SR40 361
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 SR40 362
#                                                                       SR40 363
IF(H(1)<0) I=4;   ELSE I=0#            Set h sign bit                   SR40 364
IF(H(2)<0) I=I+2#                      Set k sign bit                   SR40 365
IF(H(3)<0) I=I+1#                      Set l sign bit                   SR40 366
intpak:(I         ,HKL, 0,3)#          Pack hkl sign code               SR40 367
intpak:(IABS(H(3)),HKL, 3,9)#          Pack l index                     SR40 368
intpak:(IABS(H(2)),HKL,12,9)#          Pack k index                     SR40 369
intpak:(IABS(H(1)),HKL,21,bitlen:(21))# Pack h index                    SR40 370
movepakwd:(HKL,QX(JP+IH))#             Store hkl word in op packet      SR40 371
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 SR40 372
#                                                                       SR40 373
IF(RCOD<1.5&AINT<RTHR*SIGI) RCOD=2.#   Test if rcode2                   SR40 374
JJ=NINT(RCOD); COUNT(JJ)=COUNT(JJ)+1.# Count reflns each rcode          SR40 375
ifnv:(AINT) ifnv:(SIGI)#               For non void data                SR40 376
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 SR40 377
SUMF=SUMF+AINT;  SUMS=SUMS+SIGI#       Sum coeff and esd                SR40 378
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 SR40 379
#                                                                       SR40 380
ifeq:(FFLAG,1.)#                       If first equivalents             SR40 381
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 SR40 382
QX(JP+II)=AINT#                        Move intensity                   SR40 383
IF(IS>0) QX(JP+IS)=SIGI#               Move final sigma                 SR40 384
QX(JP+IRR)=RCOD#                       Move final rcode                 SR40 385
FOR(I=1;I<=NOTHS;I=I+1)$#              Output extra items               SR40 386
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 SR40 387
IF(AVEOTH(I)>voidflg:)#                Is there a value?                SR40 388
QX(JP+IOTHS(I))=AVEOTH(I)#             Move extra items to output       SR40 389
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 SR40 390
#COUNT(6)=COUNT(6)+1.#                  COUNT THE NON-FRIEDEL DATA   ^  SR40 391
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 SR40 392
ELSE#                                  Flip side of friedel's flop      SR40 393
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 SR40 394
QX(JP+IIF)=AINT#                       Move intensity of ---            SR40 395
IF(ISF>0) QX(JP+ISF)=SIGI#             Move sigma(i) of ---             SR40 396
QX(JP+IRF)=RCOD#                       Move rcode                       SR40 397
FOR(I=1;I<=NOTHS;I=I+1)$#              Always output extra items        SR40 398
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 SR40 399
IF(AVEOTH(I)>voidflg:)#                Is there a value?                SR40 400
QX(JP+IOTHS(I))=AVEOTH(I)#             Move extra items to output       SR40 401
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 SR40 402
H(1)=-H(1); H(2)=-H(2); H(3)=-H(3)#    Set friedel hkl's                SR40 403
ifnv:(AINT) COUNT(7)=COUNT(7)+1.#      Count the friedel data   ^       SR40 404
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 SR40 405
#                                                                       SR40 406
#   PRINT REFLECTION SUMMARY                                            SR40 407
#   ------------------------                                            SR40 408
#                                                                       SR40 409
IF((NPNT<=0)&(SUMN<PREF)) NEXT#        Skip if no printout              SR40 410
IF(PREJ==yes:&REJFLG==no:) NEXT#       Skip if not rejected             SR40 411
NPNT=NPNT-1#                           Decr print limit                 SR40 412
DO I=1,3; BUFOT(I)=FLOAT(H(I))#        Float hkl indices                SR40 413
ncodefld:(BUFOT,1,CHROT,FM,3)#         Encode h,k,l                     SR40 414
ifnv:(AINT)#                           Test if av intensity active      SR40 415
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 SR40 416
BUFOT(1)=AINT#                         Buffer final intensity           SR40 417
BUFOT(2)=SIGI#                         Buffer final sigma(i)            SR40 418
BUFOT(3)=RCOD#                         Buffer rcode                     SR40 419
ncodefld:(BUFOT,1,CHROT,FM(4),3)#      Else format i,sigi,rcode         SR40 420
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 SR40 421
ELSE#                                  No intensity                     SR40 422
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 SR40 423
movechar:(SR407,1,CHROT,18,NSR407,0)#  Tell user no intensity           SR40 424
writeline:(0,SR401,NSR401,1,3)#        Print line of intensities        SR40 425
MUCK=42#                               Reset column pointers            SR40 426
GO TO 150#                             Jump to write fact               SR40 427
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 SR40 428
#                                                                       SR40 429
IF(MERGE==2&REJFLG==yes:) movechar:(SR407,26,CHROT,43,1,0)#             SR40 430
MUCK=42#                               Reset column pointers            SR40 431
FOR(J=MARKR+1;J<IREF;J=J+STEPR)#       Loop over equiv reflections      SR40 432
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 SR40 433
ifeq:(ABS(QX(J)),FFLAG)#               Skip on friedel hkl              SR40 434
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 SR40 435
MUCK=MUCK+10#                          Advance output column            SR40 436
A=FLOAT(MUCK*10000+912)#               Make output format               SR40 437
ncodefld:(QX,J+II,CHROT,A,1)#          Encode the intensity             SR40 438
IF(QX(J)<.5) movechar:(SR403,1,CHROT,MUCK+1,1,0)# Mark as rejected      SR40 439
ELSE ifeq:(QX(J),2.)#                  Mark friedel mates               SR40 440
movechar:(SR405,1,CHROT,MUCK+1,1,0)#   With an f behind intensity       SR40 441
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 SR40 442
IF((MUCK<(prtcmax:-9))&(J<(IREF-STEPR)))NEXT# Skip or print             SR40 443
writeline:(0,SR401,NSR401,1,3)#        Print line of intensities        SR40 444
MUCK=42#                               Reset column pointers            SR40 445
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 SR40 446
150 CONTINUE#                          Jump from no intensity           SR40 447
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SR40 448
IF(IP<=0) BREAK#                       Exit if last packet              SR40 449
#                                                                       SR40 450
#   STORE LAST REFLECTION FOR LOOKAHEAD                                 SR40 451
#   -----------------------------------                                 SR40 452
#                                                                       SR40 453
200 CONTINUE#                          First refln branch point         SR40 454
IF(FRDL==yes:)#                        Check for separate bijvoet       SR40 455
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 SR40 456
intunpak:(HKLN,K,0,1)#                 Fetch out bijvoet bit            SR40 457
FFLAG=FLOAT(K+1)#                      And set friedel flag with it     SR40 458
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 SR40 459
ELSE FFLAG=1.0#                        Else make em all one             SR40 460
JREF=MARKR+STEPR#                      Reset storage pointer            SR40 461
QX(MARKR+1)=FFLAG#                     Store equivalence type           SR40 462
movereal:(QX,IP+1,QX,MARKR+2,PSIZ,1)#  Move packet as first equiv       SR40 463
movepakwd:(HKLN,HKLP)#                 Store canonical hkl word         SR40 464
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SR40 465
RFACT1=FACTD/(FACTI+0.5)#              Average r-factor equivs          SR40 466
RFACT2=SUMS/(SUMF+0.5)#                Average sigi/irel                SR40 467
copyfile:(4,3,incr:(lrrefl:),endrecord:)# Finish off files c & d        SR40 468
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SR40 469
ELSE copyfile:(4,3,lrexpl:,endrecord:)# Copy whole file d to c          SR40 470
#                                                                       SR40 471
RETURN#                                                                 SR40 472
END#                                                                    SR40 473
systemheader:(SR50)#                   Update and complete bdf          SR50   1
# ################################################################## #  SR50   2
#                                                                    #  SR50   3
#                               SR50                                 #  SR50   4
#                                                                    #  SR50   5
# ################################################################## #  SR50   6
SUBROUTINE SR50#                       S.r. hall 1990                   SR50   7
include:(AACOMN)#                                                       SR50   8
include:(SRCOMN)#                                                       SR50   9
#                                                                       SR50  10
INTEGER I,J,K#                                                          SR50  11
INTEGER IWNT(30),IREL(31),KEY(4)#                                       SR50  12
INTEGER PSIZ,IP,JP#                                                     SR50  13
REAL LAMBDA#                                                            SR50  14
#                                                                       SR50  15
chardata:(SR403," Reflection packets output to archive           ")#    SR50  16
chardata:(SR404," Reflection counts for rcode1  rcode2  rcode3  $#      SR50  17
rcode4  rcode5")#                                                       SR50  18
chardata:(SR405," SUM(del(Y))/SUM(Y) equiv.s                    $#      SR50  19
replicates ")#                                                          SR50  20
chardata:(SR406," SUM(sig(Y))/SUM(Y)                             ")#    SR50  21
chardata:(SR408," Reflection statistics     h       k       l   $#      SR50  22
    theta  ")#                                                          SR50  23
chardata:(SR409,"                   min                           $#    SR50  24
           ")#                                                          SR50  25
chardata:(SR410,"                   max                           $#    SR50  26
           ")#                                                          SR50  27
realdata:(FMT,[280613.,360613.,440613.,520613.,600613.])#               SR50  28
datastuff:#                                                             SR50  29
#                                                                       SR50  30
#    OUTPUT UPDATED LREXPL:                                             SR50  31
#    ----------------------                                             SR50  32
#                                                                       SR50  33
IWNT(1)=1;   IWNT(2)=2#                Dataset and wavelength           SR50  34
IWNT(3)=521; IWNT(4)=524#              Number meas & merge r factor     SR50  35
IWNT(5)=521; IWNT(6)=522#              Numb meas and merged             SR50  36
IWNT(7)=524; IWNT(8)=525#              Av equivs & av sigi/irel         SR50  37
DO I=1,8; IWNT(I+8)=I+500#             Set hkls min/max limits          SR50  38
KEY(1)=2; KEY(2)=4; KEY(3)=16; KEY(4)=0# Update lrexpl: directory       SR50  39
indexpkt:(3,lrexpl:,PSIZ,IP,2,KEY,IWNT,IREL)# Update lrexpl: director   SR50  40
J=DSET/1000#                           Get data set number              SR50  41
REPEAT#                                Loop over all data sets          SR50  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SR50  43
readwpkt:(3,lrexpl:,PSIZ,IP,0)#        Point to input packet            SR50  44
IF(IP<=0) BREAK#                       Until all data sets treated      SR50  45
writepkt:(2,lrexpl:,KEY(4),JP)#        Point to output packet           SR50  46
movereal:(QX,IP+1,QX,JP+1,PSIZ,1)#     Transfer ip to op                SR50  47
DO I=PSIZ+1,KEY(4); QX(JP+I)=voidflg:# Void new items                   SR50  48
IF(NINT(QX(IP+IREL(1)))!=J) NEXT#      Skip if not selected dataset     SR50  49
LAMBDA=QX(IP+IREL(2));   K=0#          Extract the wavelength           SR50  50
QX(JP+IREL(6))=FLOAT(NREF)#            Number reflns output             SR50  51
IF(MREF>NREF) QX(JP+IREL(7))=RFACT1#   Rfact aver equivalents           SR50  52
QX(JP+IREL(8))=RFACT2#                 Rfact aver sigi/irel             SR50  53
I=IP+IREL(3); IF(I>IP)#                Test if refln count present      SR50  54
ifnm:(QX(I)) K=NINT(QX(I))#            Extract prior meas reflns        SR50  55
IF(MREF>=K)#                           If this is a larger data set     SR50  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SR50  57
QX(JP+IREL( 5))=FLOAT(MREF)#           Number reflns input              SR50  58
QX(JP+IREL( 9))=XMIN(1)#               Store input min h                SR50  59
QX(JP+IREL(10))=XMAX(1)#               Store input max h                SR50  60
QX(JP+IREL(11))=XMIN(2)#               Store input min k                SR50  61
QX(JP+IREL(12))=XMAX(2)#               Store input max k                SR50  62
QX(JP+IREL(13))=XMIN(3)#               Store input min l                SR50  63
QX(JP+IREL(14))=XMAX(3)#               Store input max l                SR50  64
IF(SMIN<9.)QX(JP+IREL(15))=57.2958*ASIN(SMIN*LAMBDA)# Min input theta   SR50  65
IF(SMAX>0.)QX(JP+IREL(16))=57.2958*ASIN(SMAX*LAMBDA)# Max input theta   SR50  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SR50  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SR50  68
#                                                                       SR50  69
#    OUTPUT UPDATED LRDSET:                                             SR50  70
#    ----------------------                                             SR50  71
#                                                                       SR50  72
IWNT(1)=1#                             Get data set number              SR50  73
DO I=1,5; IWNT(I+1)=I+10#              Request max /hkl/,smin,smax      SR50  74
DO I=1,21; IWNT(I+6)=I+70#             Request min/max h,k,l,s     ^    SR50  75
KEY(1)=0; KEY(2)=0; KEY(3)=27; KEY(4)=0# Items with update        ^     SR50  76
indexpkt:(3,lrdset:,PSIZ,IP,2,KEY,IWNT,IREL)# Point to wants            SR50  77
REPEAT#                                Loop over all data sets          SR50  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SR50  79
readwpkt:(3,lrdset:,PSIZ,IP,0)#        Point to input packet            SR50  80
IF(IP<=0) BREAK#                       Until all data sets treated      SR50  81
writepkt:(2,lrdset:,KEY(4),JP)#        Point to output packet           SR50  82
movereal:(QX,IP+1,QX,JP+1,PSIZ,1)#     Transfer ip to op                SR50  83
DO I=2,26#                             Loop over new items     ^        SR50  84
IF(IREL(I)>PSIZ) QX(JP+IREL(I))=voidflg:# Void all extra                SR50  85
IF(NINT(QX(IP+IREL(1)))!=J) NEXT#      Skip if not selected dataset     SR50  86
DO I=1,3; QX(JP+IREL(I+1))=MAX(HMAX(I),ABS(HMIN(I)))# Store max hkl     SR50  87
IF(SMIN<9.) QX(JP+IREL( 5))=SMIN#      Store min sint/l                 SR50  88
IF(SMAX>0.) QX(JP+IREL( 6))=SMAX#      Store max sint/l                 SR50  89
QX(JP+IREL( 7))=HMIN(1)#               Store min h                      SR50  90
QX(JP+IREL( 8))=HMAX(1)#               Store max h                      SR50  91
QX(JP+IREL( 9))=HMIN(2)#               Store min k                      SR50  92
QX(JP+IREL(10))=HMAX(2)#               Store max k                      SR50  93
QX(JP+IREL(11))=HMIN(3)#               Store min l                      SR50  94
QX(JP+IREL(12))=HMAX(3)#               Store max l                      SR50  95
IF(SMIN<9.) QX(JP+IREL(13))=57.2958*ASIN(SMIN*LAMBDA)# Min theta        SR50  96
IF(SMAX>0.) QX(JP+IREL(14))=57.2958*ASIN(SMAX*LAMBDA)# Max theta        SR50  97
IF(SMAX>0.) QX(JP+IREL(15))=0.5/SMAX#  Store high resoln d              SR50  98
IF(SMIN<9.) QX(JP+IREL(16))=0.5/(SMIN+.0001)# Store low resoln d        SR50  99
QX(JP+IREL(17))=COUNT(1)+COUNT(2)+COUNT(3)+COUNT(5)#   ^^
#QX(JP+IREL(17))=FLOAT(NREF)#          Number reflections op   ^^
IF(MERGE>0) DO I=1,5; QX(JP+IREL(I+17))=COUNT(I)# Count of each rcode   SR50 101
QX(JP+IREL(23))=RTHR#                  Rcode 2 threshold                SR50 102
QX(JP+IREL(24))=FLOAT(3-NTYP/2)#       Coeff type (1=f,2=f2,3=i)        SR50 103
QX(JP+IREL(25))=COUNT(6)#              Count non-friedel data   ^       SR50 104
QX(JP+IREL(26))=COUNT(7)#              Count friedel data   ^           SR50 105
QX(JP+IREL(27))=COUNT(7)/MAX(1.,COUNT(6))# Ratio of friedel data   ^    SR50 106
SMIN=QX(JP+IREL(13)); SMAX=QX(JP+IREL(14))# Save min & max thetas       SR50 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SR50 108
copyfile:(3,2,incr:(lrdset:),endrecord:)# Finish off archive bdf        SR50 109
#                                                                       SR50 110
#       REPORT R-FACTORS EQUIVS & SIGI/I                                SR50 111
#       --------------------------------                                SR50 112
#                                                                       SR50 113
LINRM=8#                               Get enough room                  SR50 114
ncodefld:(FLOAT(NREF),1,SR403,440613.,1)# Format reflections output     SR50 115
writeline:(1,SR403,NSR403,3,3)#        Print reflection count           SR50 116
IF(SMAX>0.) writeline:(1,SR408,NSR408,3,3)# Refln stats header          SR50 117
ELSE        writeline:(1,SR408,46,3,3)# Refln stats header              SR50 118
ncodefld:(HMIN,1,SR409,FMT,3)#         Insert min hkl                   SR50 119
IF(SMAX>0.) ncodefld:(SMIN,1,SR409,560722.,1)# Insert min theta         SR50 120
writeline:(0,SR409,NSR409,3,3)#        Print min values                 SR50 121
ncodefld:(HMAX,1,SR410,FMT,3)#         Insert max hkl                   SR50 122
IF(SMAX>0.) ncodefld:(SMAX,1,SR410,560722.,1)# Insert max theta         SR50 123
writeline:(0,SR410,NSR410,3,3)#        Print max values                 SR50 124
IF(MERGE>0)#                           If merge applied                 SR50 125
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SR50 126
writeline:(1,SR404,NSR404,3,3)#        Print reflection count           SR50 127
ncodefld:(COUNT,1,CHROT,FMT,5)#        Format reflections output        SR50 128
writeline:(0,0,0,1,3)#                 Print rcode counts               SR50 129
ncodefld:(NFACT,1,SR405,440613.,1)#    Count of contributors            SR50 130
ncodefld:(RFACT1,1,SR405,360642.,1)#                                    SR50 131
writeline:(1,SR405,NSR405,3,3)#        Output r-factors                 SR50 132
ncodefld:(RFACT2,1,SR406,360642.,1)#                                    SR50 133
writeline:(0,SR406,NSR406,3,3)#        Output r-factors                 SR50 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SR50 135
#                                                                       SR50 136
RETURN#                                                                 SR50 137
END#                                                                    SR50 138
pmacro:([no:])#                        Purge xtal system macros         SR50 139
