systemheader:(CD    )#                                                  CD     1
####################################################################### CD     2
##                                                                    # CD     3
##                        *** CEDAR ***                               # CD     4
##                                                                    # CD     5
##  Crystallographic, Energy and Dynamics Refinement Program          # CD     6
##                                         K.D. Watenpaugh 1982       # CD     7
##                                                                    # CD     8
####################################################################### CD     9
#                                                                       CD    10
include:(XMACRO)#                                                       CD    11
#                                                                       CD    12
#                                                                       CD    13
# THIS VERSION OF CEDAR ONLY STORES THE FIRST 8 CHARACTERS OF THE       CD    14
# ATOM LABEL (MAX 24 CHARACTERS). LATER VERSIONS WILL EMPLOY THE        CD    15
# COMLETE ATOM LABEL.                        SYD HALL MAR 23 1990.      CD    16
#                                                                       CD    17
#                                                                       CD    18
macro:(name8:,incr:(arith:(7,/,mxchwd:)))# Words in 8 char string       CD    19
macro:(maxatype:,12)#                  Maximum number of atom scatt     CD    20
macro:(mxres:,50)#                     Maximum number of residues i     CD    21
macro:(mxnasr:,50)#                    Max.num.atoms in a single re     CD    22
macro:(maxscl:,10)#                    Maximum number of scale grou     CD    23
macro:(mxdatms:,1000)#                 Maximum number of atoms in d     CD    24
macro:(maxatms:,4000)#                 Maximum number of atoms in s     CD    25
macro:(stepci:,16)#                    Number of characters in dict     CD    26
macro:(mxnres:,500)#                   Maximum number of residues i     CD    27
macro:(mxnmas:,250)#                   Maximum number of master ato     CD    28
macro:(mxnslv:,250)#                   Maximum number of slave atom     CD    29
macro:(maxparam:,9)#                   Maximum size of a matrix to      CD    30
macro:(nbcutoff:,6.0)#                 Angstrom cutoff for non-bond     CD    31
#                                                                       CD    32
macro:(seedy:,3987)#                                                    CD    33
macro:(makenum:,[macro:([seedy:],arith:(seedy:,-,$1))seedy:])#          CD    34
macro:(defineproc:,[macro:($1:,makenum:(1))])#                          CD    35
macro:(xeq:,[$(ASSIGN makenum:(1) TO JZ $1:;GOTO $1: $#                 CD    36
       ;seedy: CONTINUE$)])#                                            CD    37
macro:(procedure:,$1: CONTINUE)#                                        CD    38
macro:(endproc:,GOTO JZ $1:)#                                           CD    39
macro:(deleteproc:,[xmacro:([$1:])])#                                   CD    40
#                                                                       CD    41
macro:(keyres:,RESIPT($2))#            Don't need 1st column            CD    42
#                                                                       CD    43
#  MC ADDS THESE OFFSETS FOR THE QX ARRAY                               CD    44
#                                                                       CD    45
# OFFSETS FROM STARAT+N * STEPAT                                        CD    46
#                                                                       CD    47
macro:(kdoff:,5)#                      Key to dictionary-old tree       CD    48
macro:(bcoff:,6)#                      Backchain integer-old tree       CD    49
macro:(fcoff:,7)#                      For.chain integer-old tree       CD    50
macro:(groff:,8)#                      -old grp(*)                      CD    51
macro:(mvoff:,9)#                      Move key        -old tree        CD    52
macro:(ptoff:,10)#                     ->to next sym.related copy       CD    53
macro:(kgoff:,11)#                     -old keyg(*)                     CD    54
macro:(kvoff:,12)#                     -old keyvar(*)                   CD    55
macro:(vpoff:,13)#                     -old vptr(*)                     CD    56
macro:(tftypeoff:,29)#                 T.f. type offset                 CD    57
macro:(xpoff:,30)#                     Previous x's                     CD    58
macro:(xsoff:,17)#                     Sigmas and variances             CD    59
macro:(xxoff:,14)#                     Target x's                       CD    60
macro:(bfoff:,22)#                     B-factor offset                  CD    61
macro:(ppoff:,20)#                     Pop parameter offset             CD    62
macro:(sfoff:,21)#                     Scattering factor packet num     CD    63
#MUSTFIX MACRO:(RMOFF:,7)   # SYM.RELATED MOLECULE-TREE(3,*); *>ORIG.   CD    64
#MUSTFIX MACRO:(OAOFF:,10)  #  ORIGINAL ATOM OF SYM.RELATED ONE  *>ORIG CD    65
macro:(atname:,QX(STARAT+($1)*STEPAT-STEPAT+2))# Tree info of atom      CD    66
macro:(atkind:,QX(STARAT+($1)*STEPAT-STEPAT+3))# Type and numb info o   CD    67
macro:(x:,QX(STARAT+($2)*STEPAT-STEPAT+arith:(xxoff:,-,1)+$1))#         CD    68
macro:(xs:,QX(STARAT+($2)*STEPAT-STEPAT+arith:(xsoff:,-,1)+$1))#        CD    69
macro:(xp:,QX(STARAT+($2)*STEPAT-STEPAT+arith:(xpoff:,-,1)+$1))#        CD    70
macro:(tftype:,QX(STARAT+($2)*STEPAT-STEPAT+arith:(tftypeoff:,-,1)+$1))#CD    71
macro:(backchain:,QX(STARAT+($1)*STEPAT-STEPAT+bcoff:))#                CD    72
macro:(forwchain:,QX(STARAT+($1)*STEPAT-STEPAT+fcoff:))#                CD    73
macro:(keydict:,QX(STARAT+($1)*STEPAT-STEPAT+kdoff:))#                  CD    74
macro:(movekey:,QX(STARAT+($1)*STEPAT-STEPAT+mvoff:))#                  CD    75
macro:(pointer:,QX(STARAT+($1)*STEPAT-STEPAT+ptoff:))#                  CD    76
#MUSTFIX MACRO:(SYMOPKEY:,QX(STARAT+($1)*STEPAT-STEPAT+RMOFF:))  #      CD    77
#MUSTFIX MACRO:(ORIGATOM:,QX(STARAT+($1)*STEPAT-STEPAT+OAOFF:))  #      CD    78
macro:(grp:,QX(STARAT+($1)*STEPAT-STEPAT+groff:))#                      CD    79
#####MACRO:(KEYG:,QX(STARAT+($1)*STEPAT-STEPAT+KGOFF:)) #               CD    80
macro:(keyg:,KEYG($1))#                                                 CD    81
macro:(vptr:,QX(STARAT+($1)*STEPAT-STEPAT+vpoff:))#                     CD    82
macro:(keyvar:,QX(STARAT+($1)*STEPAT-STEPAT+kvoff:))#                   CD    83
macro:(bfact:,QX(STARAT+($1)*STEPAT-STEPAT+bfoff:))#                    CD    84
macro:(winv:,QX(STARVR+$1))#                                            CD    85
#####                                                                   CD    86
#                                                                       CD    87
# THESE WILL BE OFFSET DIFFERENTLY TO HANDLE A REQUIRED EQUIVALENCE     CD    88
#   IN THE .VA. SECTION OF QX, THE OLD ARRAYS WILL BE PACKED            CD    89
#   ONE RIGHT AFTER ANOTHER                                             CD    90
#   !!! V0 MUST COME RIGHT AFTER X1 !!!                                 CD    91
#   NVAR IS IN COMMON==# OF VARIABLE ATOMS                              CD    92
#   ALL ATOMS PUT IN THESE ARRAYS, NOT JUST VARIABLE ATOMS              CD    93
# OFFSETS FROM STARVA+NUMATM * STEPVA  ( # ATOMS )                      CD    94
macro:(stepva:,15)#                                                     CD    95
macro:(x0off:,0)#                      -old x0(3,*)                     CD    96
macro:(x2off:,3)#                      -old x2(3,*)                     CD    97
macro:(x1off:,6)#                      -old x1(3,*)                     CD    98
macro:(v0off:,9)#                      -old v0(3,*)                     CD    99
macro:(fooff:,12)#                     -old force(3,*)                  CD   100
macro:(x0:,QX(STARVA+x0off:*NUMATM+3*$2-3+$1))#                         CD   101
macro:(x2:,QX(STARVA+x2off:*NUMATM+3*$2-3+$1))#                         CD   102
macro:(force:,QX(STARVA+fooff:*NUMATM+3*$2-3+$1))#                      CD   103
macro:(x1:,QX(STARVA+x1off:*NUMATM+3*$2-3+$1))#                         CD   104
macro:(v0:,QX(STARVA+v0off:*NUMATM+3*$2-3+$1))#                         CD   105
macro:(x0eqv:,QX(STARVA+$1+x0off:*NUMATM))#                             CD   106
macro:(forceq:,QX(STARVA+$1+fooff:*NUMATM))#                            CD   107
macro:(hunion:,QX(STARVA+$1+x1off:*NUMATM))# Same as x1                 CD   108
#  THIS SHOULD "EQUIVALENCE" HUNION TO THE UNION OF X1 .U. V0           CD   109
#                                                                       CD   110
#                    DICTIONARY ITEMS ( SEE PRECED)                     CD   111
macro:(stepdc:,23)#                                                     CD   112
macro:(barr:,QX(STARDC+5+($2)*STEPDC-STEPDC+$1))#                       CD   113
macro:(dict:,QX(STARDC+($2)*STEPDC-STEPDC+$1))#                         CD   114
macro:(dict2:,QX(STARDC+8+($2)*STEPDC-STEPDC+$1))#                      CD   115
macro:(dict3:,QX(STARDC+11+($2)*STEPDC-STEPDC+$1))#                     CD   116
macro:(vdw:,QX(STARDC+16+($2)*STEPDC-STEPDC+$1))#                       CD   117
macro:(keyh:,QX(STARDC+22+($1)*STEPDC-STEPDC ))#                        CD   118
#####                                                                   CD   119
#    STEPS TO STORE BOND AND ANGLE INFORMATION                          CD   120
macro:(stepbo:,2)#                     -old bosave(2,*)                 CD   121
macro:(stepth:,6)#                     -old thesav(6,*)                 CD   122
macro:(stepdi:,4)#                     -old disave(4,*)                 CD   123
macro:(stepcs:,4)#                     -old chisav(4,*)                 CD   124
macro:(bosave:,QX(STARBO+($2)*STEPBO-STEPBO+$1))#                       CD   125
macro:(thesav:,QX(STARTH+($2)*STEPTH-STEPTH+$1))#                       CD   126
macro:(disave:,QX(STARDI+($2)*STEPDI-STEPDI+$1))#                       CD   127
macro:(chisav:,QX(STARCS+($2)*STEPCS-STEPCS+$1))#                       CD   128
#####                                                                   CD   129
macro:(stepms:,2)#                     Master/slave pairs               CD   130
macro:(master:,QX(STARMS+($1)*STEPMS-STEPMS+1))#                        CD   131
macro:(slave:,QX(STARMS+($1)*STEPMS-STEPMS+2))#                         CD   132
#                                                                       CD   133
# 22 ELEMENTS PER CEDAR-SYMOP=1-9 MATRIX, 10-12 VECTOR,                 CD   134
# 13-21 INVERSE MATRIX, 22 POINTER (RTYP)                               CD   135
macro:(stepmx:,22)#                    Rotation matirices               CD   136
macro:(steptv:,4)#                     Pointer to rot.matrix & tran     CD   137
macro:(rot:,QX(STARMX+($2)*stepmx:-stepmx:+$1))#                        CD   138
macro:(roti:,QX(STARMX+($2)*STEPMX-arith:(stepmx:,-,12)+$1))#           CD   139
macro:(rtyp:,QX(STARMX+($1)*stepmx:-arith:(stepmx:,-,22)))#             CD   140
macro:(t:,QX(STARMX+($2)*STEPMX-arith:(stepmx:,-,9)+$1))#               CD   141
#                                                                       CD   142
macro:(keybox:,QX(STARBX+$1))#         Note these are equivalenced      CD   143
macro:(keybx2:,QX(STARBX+$1+1))#       With an offset.                  CD   144
macro:(npbx:,QX(STARBX+$1+2))#         Only used in cd42 'naybor'       CD   145
macro:(bxvec:,QX(STARBV+$1))#                                           CD   146
macro:(ngbr:,QX(STARNB+$1))#                                            CD   147
#                                                                       CD   148
macro:(grabword:,[stringlim:($1,IC1,IC2);NCH=IC2-IC1;$#                 CD   149
movechar:(BLANK,1,$2,1,4,1);movechar:(CHRIN,IC1,$2,1,NCH,0)])#          CD   150
macro:(debug:,[PRINT*,$1 z:($2) z:($3) z:($4) z:($5) z:($6)#            CD   151
z:($7) z:($8)])#                                                        CD   152
macro:(z:,[ifelse:($1,,,$,arg:($1))])#                                  CD   153
#                                                                       CD   154
#                                                                       CD   155
########### MACRO SET 2                                                 CD   156
# DOUBLE PRECISION MACROS                                               CD   157
# THESE MACROS ARE USED BY PROGRAMS CD25, CD91, CD92, CD93, CD94,       CD   158
#  CD95, CD96, CD97, CD98 AND CD99.                                     CD   159
#                                                                       CD   160
ifsel:(CRAY,UNXCRA)#                   For 64 biters no dp needed       CD   161
macro:(doubleprecision:,[no:])#                                         CD   162
ifsel:#                                                                 CD   163
macro:(doubleprecision:,[yes:])#                                        CD   164
endsel:#                                                                CD   165
#                                                                       CD   166
macro:(dfunction:,[ifelse:(doubleprecision:,yes:,$#                     CD   167
DOUBLEPRECISIONFUNCTION,FUNCTION)])#                                    CD   168
#                                                                       CD   169
macro:(double:,[ifelse:(doubleprecision:,yes:,DOUBLE PRECISION,REAL)])# CD   170
#                                                                       CD   171
macro:(dabs:,[ifelse:(doubleprecision:,yes:,DABS($1),ABS($1))])#        CD   172
#                                                                       CD   173
macro:(dble:,[ifelse:(doubleprecision:,yes:,DBLE($1),$1)])#             CD   174
#                                                                       CD   175
macro:(dconstant:,[ifelse:(doubleprecision:,yes:,$1D$2,$1E$2)])#        CD   176
#                                                                       CD   177
macro:(dfloat:,[ifelse:(doubleprecision:,yes:,DFLOAT($1),FLOAT($1))])#  CD   178
#                                                                       CD   179
macro:(dptos:,[ifelse:(doubleprecision:,yes:,SNGL($1),$1)])#            CD   180
#                                                                       CD   181
macro:(dsign:,[ifelse:(doubleprecision:,yes:,DSIGN($1,$2),$#            CD   182
SIGN($1,$2))])#                                                         CD   183
#                                                                       CD   184
macro:(dsqrt:,[ifelse:(doubleprecision:,yes:,DSQRT($1),SQRT($1))])#     CD   185
#                                                                       CD   186
# LENGTH OF A MATRIX WORD-2 FOR DOUBLE PRECISION, 1 FOR SINGLE          CD   187
macro:(lmtxword:,[ifelse:(doubleprecision:,yes:,2,1)])#                 CD   188
#                                                                       CD   189
#  ***** NOTE WELL THAT MACHEP: IS A MACHINE DEPENDENT PARAMETER*****   CD   190
# RELATIVE PRECISION OF DOUBLE PRECISION FLOATING POINT ARITHMETIC      CD   191
macro:(machep:,[ifelse:(doubleprecision:,yes:,$#                        CD   192
dconstant:(2.0,-18),MNFPNBR)])#                                         CD   193
#                                                                       CD   194
#                                                                       CD   195
#  C E D A R   REFINE COMMON ARRAYS                                     CD   196
#                                                                       CD   197
# XTAL L.S. REFINEMENT                                                  CD   198
# X:=CURRENT AND NEWLY CALC. POSTIONS FROM L.S.                         CD   199
# XP:=POSITIONS BEFORE L.S. REFINEMENT                                  CD   200
# C.G. REFINEMENT                                                       CD   201
# X:=CURRENT POSITIONS                                                  CD   202
# X0:=STARTING POSTIONS FOR C.G. REFINEMENT                             CD   203
# X2:=TARGET POSTIONS FOR C.G. REFINEMENT                               CD   204
#                                                                       CD   205
extrude:(CDCOMN)#                                                       CD   206
REAL ATWT(maxatype:)#                  Atomic weights                   CD   207
REAL FTOC(9)#                          Matrix to convert fractional     CD   208
REAL CTOF(9)#                          Matrix to convert cartesian      CD   209
REAL MULTIP#                           Multiplicity of structure fa     CD   210
REAL STOL#                             Sin theta/lambda of current      CD   211
REAL XTLSCL(arith:(maxscl:,+,1))#      Xtal sturcture factor scale      CD   212
REAL FFREAL(maxatype:)#                Form factor (real)               CD   213
REAL FFIMAG(maxatype:)#                Format factor (imaginary)        CD   214
REAL FOBS,FSIG#                                                         CD   215
REAL SUMFC(arith:(maxscl:,+,1)),SUMFO(arith:(maxscl:,+,1))#             CD   216
REAL SUMDF(arith:(maxscl:,+,1))#                                        CD   217
REAL WTSQFC(arith:(maxscl:,+,1)),WTSQFO(arith:(maxscl:,+,1))#           CD   218
REAL WTSQDF(arith:(maxscl:,+,1))#                                       CD   219
REAL FCALC,PHCALC,DELF#                                                 CD   220
REAL ACALC,BCALC#                      A and b (calc) corrected for     CD   221
REAL SMAP,SMBP#                        Calc real structure factor a     CD   222
REAL SMAPP,SMBPP#                      Calc imaginary struct. facto     CD   223
REAL STLMIN,STLMAX#                    Min. and max sin theta/lambd     CD   224
REAL BCHNGE#                           B-factor change limit factor     CD   225
REAL BMIN#                             B-factor minimum                 CD   226
REAL BMAX#                             B-factor maximum                 CD   227
REAL DAMPF#                            Xtal l.s. damping factor         CD   228
REAL DIELEC#                           Dielectric constant              CD   229
REAL HKLMAX(3)#                        Max abs(h,k,l) to use            CD   230
REAL NBCUT#                            Neibor non-bonded cutoff         CD   231
REAL SGCUT#                            Sigma cutoff for refinement      CD   232
REAL ELIST#                            Minimum energy to list term      CD   233
REAL CELL(6)#                          Cell dimension and cosines       CD   234
REAL SFTLIM(3)#                        Xtal l.s. shift maximum limi     CD   235
#                                                                       CD   236
INTEGER ANISO#                         Signal aniso dp yes/no           CD   237
INTEGER NATYPE#                        Number of atom scattering ty     CD   238
INTEGER DELFF#                         Stol step size of scattering     CD   239
INTEGER NSYMOP#                        Number of symmetric operator     CD   240
#INTEGER NSTR   # MAXIMUM NUMBER OF SYMOPS                              CD   241
INTEGER LATTYP#                        Lattice type                     CD   242
INTEGER NSEQU#                         Number of items in sequence      CD   243
INTEGER NDICT#                         Number of items in dictionar     CD   244
INTEGER TYPRES#                        Number of different residue      CD   245
INTEGER NUMATM#                        Number of atoms in original      CD   246
INTEGER TOTRES#                        Total number of residues         CD   247
INTEGER NATP#                          Number of atoms in the prote     CD   248
INTEGER NRMS(7)#                       Number of observation for 'r     CD   249
INTEGER DICTPT(mxres:)#                Pointer to 1st. atom-1 of        CD   250
INTEGER RESIPT(arith:(mxnres:,+,1))#   Pointer to fist-1 atom of re     CD   251
INTEGER NSLAV#                         Number of mas/slav and slav/     CD   252
INTEGER STOPQX#                        Last location used in qx arr     CD   253
INTEGER STARFF,STEPFF,STOPFF#          Scattering factors               CD   254
INTEGER STARSY,STEPSY,STOPSY#          Symmetry information             CD   255
INTEGER STARFI,STEPFI,STOPFI#          Dispersion corrections           CD   256
INTEGER STARSQ,STEPSQ,STOPSQ#          Pointers for sequence names      CD   257
INTEGER STARDC,STEPDC,STOPDC#          Pointers to dictionary array     CD   258
#                               AND STARPA                              CD   259
INTEGER STARAT,STEPAT,STOPAT#          Pointers to atom info.           CD   260
#INTEGER STARRF,STEPRF,STOPRF#         NEVER USED                       CD   261
INTEGER STARH ,STEPH ,STOPH#           Pointers to hkl info.            CD   262
INTEGER STARPD,STEPPD,STOPPD#          Pointers to partial derivati     CD   263
INTEGER STARMT,STEPMT,STOPMT#          Pointers to matrices             CD   264
INTEGER STARMS,STEPMS,STOPMS#          Pointer to master/slave arra     CD   265
#                                                                       CD   266
INTEGER STARMX,STEPMX,STOPMX#          Pointers to rotation matrice     CD   267
INTEGER STARTV,STEPTV,STOPTV#          Pointers to translation vect     CD   268
INTEGER STARVA,STEPVA,STOPVA#          Pointers to variable atoms       CD   269
INTEGER STARBO,STEPBO,STOPBO#          Pointers to saved bondlength     CD   270
INTEGER STARTH,STEPTH,STOPTH#          Pointers to saved bondangles     CD   271
INTEGER STARDI,STEPDI,STOPDI#          Pointers to saved dihedrals      CD   272
INTEGER STARCS,STEPCS,STOPCS#          Pointers to saved chiral cen     CD   273
INTEGER STARNB,STEPNB,STOPNB#          Pointer to non-bonded intera     CD   274
INTEGER STARVR#                        Pointer to variance of atom      CD   275
INTEGER NATOTL#                        Total number of atoms in "ce     CD   276
INTEGER NB#                            Number of variable bondlengt     CD   277
INTEGER NT#                            Number of variable bondangle     CD   278
INTEGER ND#                            Number of variable dihedral      CD   279
INTEGER NCHIR#                         Number of variable chiral ce     CD   280
INTEGER NVAR#                          Number of variable atoms in      CD   281
INTEGER NVARP#                         Number of variable atoms in      CD   282
INTEGER NPARAM#                        Number of variables to be re     CD   283
INTEGER NATW2#                         Number of the first h2o atom     CD   284
INTEGER NTYP#                          Number of rotaion matrices       CD   285
INTEGER NLAT#                          Number of symmetry operation     CD   286
INTEGER KDIAG#                         Key to matrix compression        CD   287
INTEGER LAT1,LAT2#                     Atoms to refine over             CD   288
INTEGER LRES1,LRES2#                   Residues to refine over          CD   289
INTEGER MODREF,NRGREF,XTLREF#          Key to indicate type of refi     CD   290
INTEGER DYNAM#                         Dynamics run                     CD   291
INTEGER BNOREF,ANIREF#                 Key to refine specied b's        CD   292
INTEGER EXTREF#                        Key that target positions ca     CD   293
#                       #  EXTERNALLY ARE TO BE USED                    CD   294
INTEGER XXPREV#                        Previous positions on bdf(in     CD   295
INTEGER ANSCAT#                        Key to use anomalous scatter     CD   296
INTEGER ANREFL#                        Key indicating freidel refla     CD   297
INTEGER PRESAV#                        Key indicating save original     CD   298
INTEGER WTREFL#                        Key indicating sigma(f) pres     CD   299
INTEGER FINAL#                         End card read, finish and ex     CD   300
INTEGER OUTBDF#                        Output final bdf file            CD   301
INTEGER NCYCLE#                        Number of cycles of conjugat     CD   302
INTEGER XCYCLE#                        Number of pass thru whole pr     CD   303
INTEGER UNITWT#                        Unit/sigma weights to be app     CD   304
INTEGER ORTHOG#                        The cell is orthogonal           CD   305
INTEGER NREFL(arith:(maxscl:,+,1))#    No. of reflections used in       CD   306
INTEGER SKPREF#                        Modulus of reflections to sk     CD   307
INTEGER XEQFC#                         Do a fc calculation              CD   308
INTEGER DCALC#                         Do calc l.s. derivatives         CD   309
INTEGER NFILE#                         Write scratch file               CD   310
INTEGER LISTAT#                        List final atom coordinates      CD   311
INTEGER PREVFC#                        Use previous fc as fixed ato     CD   312
INTEGER FXEST#                         Est. fc as fixed atom contri     CD   313
INTEGER FXAPP#                         Apply fixed atom contributio     CD   314
INTEGER NSCGRP#                        Scale factor group of curren     CD   315
REAL ESTINI#                           Estimate for conjugate-gradi     CD   316
REAL  DC#                              Dielectric constant              CD   317
REAL  RL2#                             Non-bonded interaction dista     CD   318
REAL NUMHYD#                           Number of hydrogen scatterin     CD   319
REAL WT(8)#                            Weights used conj. grad. ref     CD   320
REAL INITWT(8), FINLWT(8)#             Initial and final weights in     CD   321
REAL FF(7)#                            Corresponding energy terms       CD   322
REAL RMS(7)#                           Rms deviation from dictionar     CD   323
REAL RTMNSQ(2)#                        Unweighted rms from original     CD   324
REAL KEYG(4400)#                                                        CD   325
REAL RESNB(arith:(mxnres:,+,1))#       Non-bonded energy per residu     CD   326
#                                                                       CD   327
COMMON /COMFCD/ $#                                                      CD   328
MULTIP, XTLSCL, ATWT, STOL,STLMIN,STLMAX,HKLMAX, $#                     CD   329
FTOC,CTOF, FFREAL,FFIMAG, NUMHYD, INITWT,FINLWT,WT,FF,RMS, $#           CD   330
ESTINI, DC, RL2, SMAP,SMBP,SMAPP,SMBPP, BCHNGE, BMIN, BMAX, DAMPF,$#    CD   331
FOBS,FSIG,SUMFC,SUMFO,FCALC,ACALC,BCALC,PHCALC,DELF,SUMDF, $#           CD   332
WTSQFC,WTSQFO,WTSQDF,SGCUT,ELIST,CELL,SFTLIM, $#                        CD   333
RTMNSQ, KEYG, DIELEC, RESNB, NBCUT#                                     CD   334
#                                                                       CD   335
COMMON /COMICD/ $#                                                      CD   336
ANISO,NSYMOP,NATYPE,DELFF,NSEQU,NDICT,TYPRES,NATOTL,NATW2, $#           CD   337
NTYP,NLAT,KDIAG,NVAR,NVARP,NUMATM,NATP,NB,NT,ND,NCHIR,LAT1,LAT2, $#     CD   338
LRES1,LRES2,MODREF,NRGREF,XTLREF,BNOREF,ANIREF,ANSCAT,PRESAV, $#        CD   339
ANREFL,WTREFL,FINAL,OUTBDF,ORTHOG,NCYCLE,NSLAV,DICTPT,RESIPT,EXTREF, $# CD   340
XXPREV,XCYCLE,UNITWT,NREFL,SKPREF,XEQFC,DCALC,NFILE,LISTAT,NRMS, $#     CD   341
PREVFC,FXEST,FXAPP,NSCGRP,DYNAM,TOTRES#                                 CD   342
COMMON /COMIC2/ STOPQX, $#                                              CD   343
STARFF,STEPFF,STOPFF,STARFI,STEPFI,STOPFI,STARSY,STEPSY,STOPSY, $#      CD   344
STARNB,STEPNB,STOPNB,STARSQ,STEPSQ,STOPSQ,STARDC,STEPDC,STOPDC, $#      CD   345
STARTP,STEPTP,STOPTP,STARAT,STEPAT,STOPAT#                              CD   346
COMMON /COMIC3/ $#                                                      CD   347
STARH ,STEPH ,STOPH ,STARPD,STEPPD,STOPPD,STARMT,STEPMT,STOPMT, $#      CD   348
STARMS,STEPMS,STOPMS,STARMX,STEPMX,STOPMX,STARTV,STEPTV,STOPTV, $#      CD   349
STARVA,STEPVA,STOPVA,STARBO,STEPBO,STOPBO,STARTH,STEPTH,STOPTH, $#      CD   350
STARDI,STEPDI,STOPDI,STARCS,STEPCS,STOPCS,LATTYP,NPARAM,STARVR#         CD   351
endext:#                                                                CD   352
#                                                                       CD   353
systemheader:(CD00)#                                                    CD00   1
####################################################################### CD00   2
#                                                                       CD00   3
# MAIN ROUTINE OF C E D A R (CD00)                                      CD00   4
#                                                                       CD00   5
####################################################################### CD00   6
SUBROUTINE CD00#                                                        CD00   7
#                                                                       CD00   8
include:(AACOMN)#                                                       CD00   9
include:(CDCOMN)#                                                       CD00  10
#                                                                       CD00  11
CALL CD05#                             Get needed info from bdf(in)     CD00  12
#                                                                       CD00  13
REPEAT#                                Until final adjustments are      CD00  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD00  15
CALL CD15#                             Read control cards               CD00  16
IF(FINAL !=yes: \ XCYCLE !=0)#         Skip if run out of things to     CD00  17
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD00  18
REPEAT#                                                                 CD00  19
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD00  20
IF(XCYCLE==0) BREAK#                                                    CD00  21
XCYCLE=XCYCLE-1#                                                        CD00  22
CALL CD18#                             Check constraints on b-facto     CD00  23
IF(XTLREF==yes:)#                                                       CD00  24
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD00  25
DCALC=yes:#                                                             CD00  26
CALL CD20#                             Calc. xtal shifts                CD00  27
CALL CD18#                             Check and reset b-factors        CD00  28
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD00  29
IF(MODREF==yes: \ NRGREF==yes: & XEQFC==no:)#                           CD00  30
CALL CD30#                             Calc geom. and ener. shifts      CD00  31
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD00  32
IF(XEQFC==yes:)#                                                        CD00  33
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD00  34
DCALC=no:#                                                              CD00  35
CALL CD20#                             Do struct factor with curren     CD00  36
XEQFC=no:#                                                              CD00  37
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD00  38
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD00  39
IF(FINAL==yes:) GO TO 90#                                               CD00  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD00  41
#                                                                       CD00  42
90 CALL CD80#                          Out info to bdf(out)             CD00  43
#                                                                       CD00  44
RETURN#                                                                 CD00  45
END#                                                                    CD00  46
####################################################################    CD00  47
systemheader:(CD01)#                                                    CD01   1
#                                                                       CD01   2
SUBROUTINE CD01(A,B,C)#                Matrix times vector              CD01   3
#                                                                       CD01   4
REAL A(3,3),B(3),C(3),D(3)#                                             CD01   5
INTEGER NULLX#                         Flag for void field              CD01   6
# CHECK FOR VOID FIELDS                                                 CD01   7
NULLX=no:#                                                              CD01   8
DO I=1,3; ifvo:(B(1)) NULLX=yes:#                                       CD01   9
IF(NULLX==yes:)#                                                        CD01  10
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD01  11
D(1)=voidflg: ; D(2)=voidflg: ; D(3)=voidflg:#                          CD01  12
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD01  13
ELSE#                                                                   CD01  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD01  15
D(1)=0.0 ; D(2)=0.0 ; D(3)=0.0#                                         CD01  16
DO I=1,3; DO J=1,3; D(I)=D(I)+A(I,J)*B(J)#                              CD01  17
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD01  18
C(1)=D(1) ; C(2)=D(2) ; C(3)=D(3)#                                      CD01  19
#                                                                       CD01  20
RETURN#                                                                 CD01  21
END#                                                                    CD01  22
#####################################################################   CD01  23
systemheader:(CD02)#                                                    CD02   1
#                                                                       CD02   2
SUBROUTINE CD02(A,B)#                                                   CD02   3
#                                                                       CD02   4
#  3 X 3 NON-SYM. MATRIX INVERTER                                       CD02   5
#                                                                       CD02   6
REAL A(9)#                             Matrix to be inverted            CD02   7
REAL B(9)#                             Inverse matrix                   CD02   8
chardata:(SING, SINGULAR MATRIX; NOT INVERTED)#                         CD02   9
datastuff:#                                                             CD02  10
#                                                                       CD02  11
#     COMPUTE COFACTORS                                                 CD02  12
COFA1=A(5)*A(9)-A(8)*A(6)#                                              CD02  13
COFA2=A(8)*A(3)-A(2)*A(9)#                                              CD02  14
COFA3=A(2)*A(6)-A(5)*A(3)#                                              CD02  15
COFA4=A(1)*A(9)-A(7)*A(3)#                                              CD02  16
COFA5=A(4)*A(3)-A(1)*A(6)#                                              CD02  17
COFA6=A(1)*A(5)-A(4)*A(2)#                                              CD02  18
COFA7=A(6)*A(7)-A(4)*A(9)#                                              CD02  19
COFA8=A(4)*A(8)-A(5)*A(7)#                                              CD02  20
COFA9=A(2)*A(7)-A(1)*A(8)#                                              CD02  21
#     COMPUTE DETERMINANT                                               CD02  22
DETER=A(1)*COFA1+A(4)*COFA2+A(7)*COFA3#                                 CD02  23
IF(DETER<.0001)#                                                        CD02  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD02  25
writeline:(1,SING,NSING,3,1)#                                           CD02  26
iquit:(CD0201)#                                                         CD02  27
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD02  28
ELSE#                                                                   CD02  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD02  30
RDET=1.0/DETER#                                                         CD02  31
#   COMPUTE INVERSE MATRIX                                              CD02  32
B(1)=COFA1*RDET ; B(2)=COFA2*RDET ; B(3)=COFA3*RDET#                    CD02  33
B(5)=COFA4*RDET ; B(6)=COFA5*RDET ; B(9)=COFA6*RDET#                    CD02  34
B(4)=COFA7*RDET ;B(7)=COFA8*RDET ; B(8)=COFA9*RDET#                     CD02  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD02  36
#                                                                       CD02  37
RETURN#                                                                 CD02  38
END#                                                                    CD02  39
#####################################################################   CD02  40
systemheader:(CD03)#                   Scalar product                   CD03   1
#                                                                       CD03   2
SUBROUTINE CD03(A,B,C)#                                                 CD03   3
REAL A(3),B(3),C#                                                       CD03   4
#                                                                       CD03   5
C=0#                                                                    CD03   6
DO I=1,3; C=C+A(I)*B(I)#                                                CD03   7
RETURN#                                                                 CD03   8
END#                                                                    CD03   9
#####################################################################   CD03  10
systemheader:(CD05)#                                                    CD05   1
#                                                                       CD05   2
SUBROUTINE CD05#                                                        CD05   3
#                                                                       CD05   4
include:(AACOMN)#                      Xtal system common               CD05   5
include:(CDCOMN)#                                                       CD05   6
#                                                                       CD05   7
INTEGER I,K#                           Temporary local integers         CD05   8
INTEGER IPT,PSIZE#                     Pointers to in/out areas         CD05   9
chardata:(CDSEQ, SEQUENCE INPUT FROM BDF          $#                    CD05  10
                                                              )#        CD05  11
datastuff:#                                                             CD05  12
#                                                                       CD05  13
#   ALLOCATE BDF BUFFERS                                                CD05  14
#                                                                       CD05  15
IOMARK(1)=QXSTR#                       Set start of bdf buffer1         CD05  16
IOMARK(2)=IOMARK(1)+bdfbuf:#           Set start of bdf buffer2         CD05  17
IOMARK(3)=IOMARK(2)+bdfbuf:#           Set end of bdf buffer2           CD05  18
IOMARK(4)=IOMARK(3)+bdfbuf:#           Set end of bdf buffer3           CD05  19
#                                                                       CD05  20
incrqx:(STOPQX,IOMARK(4),CD0500)#      Memory allocation                CD05  21
STARVA=0#                                                               CD05  22
STARPD=0#                                                               CD05  23
#                                                                       CD05  24
#   PROCESS BDF RECORDS 1-7                                             CD05  25
#                                                                       CD05  26
# GET CELL INFORMATION                                                  CD05  27
#                                                                       CD05  28
NFILE=0#                               No scratch file                  CD05  29
K=0#                                                                    CD05  30
REPEAT#                                                                 CD05  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD05  32
readwpkt:(1,lrcell:,PSIZE,IPT,0)#      Read lr lrcell: for cell inf     CD05  33
IF(IPT<=0) BREAK#                                                       CD05  34
K=K+1#                                 Keep track of packet             CD05  35
IF(K==1) movereal:(QX(IPT+1),1,CELL,1,6,0)# Get cell dimensions         CD05  36
IF(K==4)#                              Save to transformation matri     CD05  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD05  38
movereal:(QX(IPT+1),1,FTOC,1,9,0)#                                      CD05  39
CALL CD02(FTOC,CTOF)#                  Invert matrix                    CD05  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD05  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD05  42
#                                                                       CD05  43
# GET SYMMETRY INFORMATION FROM BDF(IN)                                 CD05  44
#                                                                       CD05  45
readwpkt:(1,lrsymm:,PSIZE,IPT,0)#      Read symmetry record             CD05  46
LATTYP=NINT(QX(IPT+1))#                Store lattice type               CD05  47
ACENTR=NINT(QX(IPT+2))#                Acentric indicator               CD05  48
MULTIP=QX(IPT+6)#                      Cell multiplicity                CD05  49
NSYMOP=NINT(QX(IPT+4))#                Store number of symops           CD05  50
NLAT=NINT(QX(IPT+7))#                  Get cedar lattice ops            CD05  51
#                                                                       CD05  52
STARSY=STOPQX#                         Mark start of symops             CD05  53
STEPSY=PSIZE#                          And set step size                CD05  54
STOPSY=STARSY#                         Reset end of symops              CD05  55
DO I=1,NSYMOP#                         Get crystal sym ops              CD05  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD05  57
readwpkt:(1,lrsymm:,PSIZE,IP,0)#       Read the next packet             CD05  58
IF(IP<=0) iquit:(CD0502)#              Break if it's the last one       CD05  59
movereal:(QX(IP+1),1,QX(STOPSY+1),1,PSIZE,0)# Move the symop to qx      CD05  60
STOPSY=STOPSY+PSIZE#                   Advance ptr to end of symops     CD05  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD05  62
STOPQX=STOPSY#                         Reset end of qx array            CD05  63
#                                                                       CD05  64
# STORE SYM OPS FOR ENERGY AND DYNAMICS PORTION                         CD05  65
# THIS SECTION SHOULD BE PLACE INTO PRECED LATER                        CD05  66
#                                                                       CD05  67
STARMX=STOPQX#                                                          CD05  68
STEPMX=stepmx:#                                                         CD05  69
STOPMX=STOPQX#                                                          CD05  70
KDIAG=no:#                                                              CD05  71
IF(ABS(CELL(4))<.00001&ABS(CELL(5))<.00001 &$#                          CD05  72
  ABS(CELL(6))<.00001) KDIAG=yes:#                                      CD05  73
DO I=1,NLAT#                           Get cedar sym ops                CD05  74
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD05  75
readwpkt:(1,lrsymm:,PSIZE,IP,0)#       Read the next packet             CD05  76
IF(IP<=0) iquit:(CD0503)#              Break if it's the last one       CD05  77
movereal:(QX,IP+1,QX,STOPMX+1,PSIZE,0)# Move the symop to qx            CD05  78
IF(KDIAG==yes:)#                       Convert transl to angstroms      CD05  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD05  80
QX(STOPMX+10)=QX(STOPMX+10)*FTOC(1)#   Convert to angstrom transl       CD05  81
QX(STOPMX+11)=QX(STOPMX+11)*FTOC(5)#   Convert to angstrom transl       CD05  82
QX(STOPMX+12)=QX(STOPMX+12)*FTOC(9)#   Convert to angstrom transl       CD05  83
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD05  84
STOPMX=STOPMX+STEPMX#                  Advance ptr to end of symops     CD05  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD05  86
STOPQX=STOPMX#                         Reset end of qx array            CD05  87
K=0#                                                                    CD05  88
FOR (I=STARMX;I<STOPMX;I=I+STEPMX)#                                     CD05  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD05  90
K=K+1#                                                                  CD05  91
QX(I+stepmx:)=0.0#                     Initial to identity matrix       CD05  92
FOR (J=1;J<=9;J=J+1)#                                                   CD05  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD05  94
ifeq:(QX(I+J),QX(STARMX+J)) NEXT#                                       CD05  95
ELSE#                                                                   CD05  96
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD05  97
QX(I+stepmx:)=FLOAT(K)#                                                 CD05  98
BREAK#                                                                  CD05  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD05 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD05 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD05 102
FOR (I=STARMX+1;I<=STOPMX;I=I+STEPMX)#                                  CD05 103
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD05 104
movereal:(QX(I),1,QX(I+12),1,9,0)#     Move rot: to roti:               CD05 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD05 106
#                                                                       CD05 107
# GET ATOMIC WEIGHTS AND SCATTERING FACTORS                             CD05 108
#                                                                       CD05 109
CALL CD06#                                                              CD05 110
#                                                                       CD05 111
#                                                                       CD05 112
#   GET SEQUENCE FROM LR LRSEQ:                                         CD05 113
#                                                                       CD05 114
STARSQ=STOPQX#                         Start of sequence array          CD05 115
STEPSQ=15/mxchwd:+1#                   Allow room for 8 characters      CD05 116
STOPSQ=STARSQ#                                                          CD05 117
NSEQU=0#                                                                CD05 118
REPEAT#                                                                 CD05 119
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD05 120
readwpkt:(1,lrsequ:,PSIZE,IPT,0)#      Read residue name                CD05 121
IF(IPT==0) BREAK#                                                       CD05 122
NSEQU=NSEQU+1#                         Increment number of residues     CD05 123
movereal:(QX(IPT+1),1,QX(STOPSQ+1),1,STEPSQ,0)# Move residue name to    CD05 124
STOPSQ=STOPSQ+STEPSQ#                                                   CD05 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD05 126
#                                                                       CD05 127
#   PUT SEQUENCE OUT TO LR LRSEQ:, BDF (OUT)                            CD05 128
#                                                                       CD05 129
STOPQX=STOPSQ#                                                          CD05 130
#                                                                       CD05 131
#   TELL THE WORLD WHAT THE SEQUENCE IS                                 CD05 132
#                                                                       CD05 133
IF(PPRIOR>=4)#                         If priority is greater than      CD05 134
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD05 135
I=STARSQ+1#                                                             CD05 136
LINRM=NSEQU/10+3#                      Check on lines remaining         CD05 137
WHILE (I<=STOPSQ)#                                                      CD05 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD05 139
K=2#                                   Start line in column 2           CD05 140
movechar:(BLANK,1,CHROT,1,NCDSEQ,1)#   Blank out the line               CD05 141
REPEAT#                                Do ten residues at a time        CD05 142
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD05 143
movertoc:(QX(I),1,CHROT,K,8,0)#        Move residue name to output      CD05 144
K=K+10#                                                                 CD05 145
I=I+STEPSQ#                                                             CD05 146
IF(K>=102 \ I>=STOPSQ) BREAK#          Do until 10 items or end of      CD05 147
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD05 148
writeline:(1,CDSEQ,NCDSEQ,1,3)#                                         CD05 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD05 150
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD05 151
STOPQX=STOPSQ#                         Set current end of qx array      CD05 152
#                                                                       CD05 153
#                                                                       CD05 154
#                                                                       CD05 155
#########################                                               CD05 156
# GET/PUT DICTIONARY FROM/TO BDF                                        CD05 157
#########################                                               CD05 158
#                                                                       CD05 159
CALL CD07#                                                              CD05 160
IF(NDICT<=0) iquit:(CD0504)#           No dictionary entries            CD05 161
#                                                                       CD05 162
#                                                                       CD05 163
#########################                                               CD05 164
# GET ATOMS FROM BDF(IN)                                                CD05 165
#########################                                               CD05 166
CALL CD08#                             Read atoms from bdf(in)          CD05 167
IF(NUMATM<=0) iquit:(CD0505)#          No atoms entries                 CD05 168
#########################                                               CD05 169
# GET LINK INFO. FROM DICTIONARY                                        CD05 170
#########################                                               CD05 171
#                                                                       CD05 172
CALL CD09#                             Get master/slave info from b     CD05 173
#                                                                       CD05 174
RETURN#                                                                 CD05 175
#                                                                       CD05 176
END#                                                                    CD05 177
#####################################################################   CD05 178
systemheader:(CD06)#                                                    CD06   1
#                                                                       CD06   2
SUBROUTINE CD06#                       Subroutine to load the           CD06   3
#               #  FORM FACTOR TABLES                                   CD06   4
#                                                                       CD06   5
include:(AACOMN)#                                                       CD06   6
include:(CDCOMN)#                                                       CD06   7
#                                                                       CD06   8
# THE FORM FACTORS WILL BE PLACED IN QX STARTING AT STARFF.             CD06   9
#  THE FIRST TWO ENTRIES WILL BE F' AND F'' FOLLOWED BY THE F(J).       CD06  10
#  THE FIRST ENTRY WILL BE FOR SIN(THETA)/LAMBDA OF ZERO.  THE          CD06  11
#  STOL STEP SIZE WILL BE IN THE INTEGER DELFF.  THIS WILL BE 100       CD06  12
#  TIMES THE DELTA(STOL).  THUS 1 CORRESPONDS TO 0.01, THE              CD06  13
#  SMALLEST INTERVAL PROVIDED FOR IN THE BDF.  THE ACTUAL STEP SIZE     CD06  14
#  IS LARGER.                                                           CD06  15
#                                                                       CD06  16
INTEGER I#                             Do loop index                    CD06  17
INTEGER IPT#                           Input file packet pointer        CD06  18
INTEGER J#                             Loop index                       CD06  19
INTEGER JJ#                            Loop index                       CD06  20
INTEGER JK#                            Qx pointer                       CD06  21
INTEGER JL#                            Qx pointer                       CD06  22
INTEGER PSIZE#                         Input/output file packet siz     CD06  23
#                                                                       CD06  24
REAL CLUE(2)#                          First 2 values of sitol*100      CD06  25
#         #  IN SCAT FACT TABLES.                                       CD06  26
REAL GOT(5)#                           Flags indicating whether req     CD06  27
#         #  IDENTIFIERS ARE PRESENT.                                   CD06  28
REAL WANT(3)#                          Lr8 identifiers for real and     CD06  29
#         #  SCATTERING FACTORS.                                        CD06  30
#                                                                       CD06  31
DATA WANT(1),WANT(2),WANT(3)/21.,61.,2./#                               CD06  32
#                                                                       CD06  33
STARFF=STOPQX#                                                          CD06  34
NUMHYD=0.0#                            Natype number for hydrogen       CD06  35
NATYPE=0#                              Set up to count scattering       CD06  36
#                                                                       CD06  37
readwpkt:(1,lrscat:,PSIZE,IPT,0)#      Read header packet               CD06  38
#                                                                       CD06  39
DO I=1,5; GOT(I)=0.0#                                                   CD06  40
#                                                                       CD06  41
# SCAN THE HEADER PACKET LOOKING FOR TABLES                             CD06  42
#                                                                       CD06  43
STEPFF=0#                                                               CD06  44
JL=0#                                                                   CD06  45
DO J=1,202#                            Loop over indices                CD06  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD06  47
JK=IPT#                                                                 CD06  48
DO JJ=1,PSIZE#                         Loop over input header           CD06  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD06  50
JK=JK+1#                                                                CD06  51
IF(J<4)#                                                                CD06  52
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD06  53
ifeq:(QX(JK),WANT(J)) GOT(J)=FLOAT(JJ)# Factor indices.                 CD06  54
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD06  55
ELSE ifeq:(QX(JK),FLOAT(J+96))#                                         CD06  56
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD06  57
STEPFF=STEPFF+1#                                                        CD06  58
JL=JL+1#                                                                CD06  59
IF(JL>2)  BREAK#                       You only have to know the        CD06  60
GOT(JL+3)=FLOAT(JJ)#                   First to know them all.          CD06  61
CLUE(JL)=QX(JK)#                                                        CD06  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD06  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD06  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD06  65
#                                                                       CD06  66
STEPFF=STEPFF+2#                       Add words for dispersion ter     CD06  67
DELFF=NINT(ABS(CLUE(2)-CLUE(1)))#      Find the table step size         CD06  68
#               #  IN UNITS OF STOL*100.                                CD06  69
#                                                                       CD06  70
# SET UP QX DATA ARRAYS FOR SCATTERING FACTORS                          CD06  71
#                                                                       CD06  72
STOPFF=maxatype:*STEPFF+STARFF#        Calculate required storage;      CD06  73
STOPQX=STOPFF#                                                          CD06  74
ZERO=0.0#                                                               CD06  75
ISIZE=STOPFF-STARFF#                                                    CD06  76
movereal:(ZERO,1,QX(STARFF+1),1,ISIZE,2)#                               CD06  77
#                                                                       CD06  78
# NOW CHECK TO BE SURE THERE ARE SCATTERING FACTORS AND                 CD06  79
#  DISPERSION CORRECTIONS IN THE BDF.                                   CD06  80
#                                                                       CD06  81
IF((GOT(4)*GOT(5))<=0.01)  iquit:(-CD0603)#                             CD06  82
#                                                                       CD06  83
# NOW LOAD THE TABLES IN PACKED FORM, DISPERSION CORRECTIONS FIRST,     CD06  84
#  STARTING AT STARFF.                                                  CD06  85
#                                                                       CD06  86
JK=STARFF#                                                              CD06  87
I=0#                                                                    CD06  88
REPEAT#                                Loop over all atom types         CD06  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD06  90
readwpkt:(1,lrscat:,PSIZE,IPT,0)#                                       CD06  91
IF(IPT<=0)  BREAK#                     Get out at end                   CD06  92
ifne:(GOT(1),0.0)#                                                      CD06  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD06  94
NATYPE=NATYPE+1#                                                        CD06  95
JJ=IPT+NINT(GOT(1))#                                                    CD06  96
ifvo:(QX(JJ)) QX(JJ)=0.0#                                               CD06  97
QX(JK+1)=QX(JJ)#                       Real part. dispersion correc     CD06  98
JJ=IPT+NINT(GOT(2))#                                                    CD06  99
ifvo:(QX(JJ)) QX(JJ)=0.0#                                               CD06 100
QX(JK+2)=QX(JJ)#                       Imaginary part.                  CD06 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD06 102
JK=JK+2#                                                                CD06 103
#                                      #                                CD06 104
ifne:(GOT(3),0.0)#                                                      CD06 105
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD06 106
I=I+1#                                                                  CD06 107
JJ=IPT+NINT(GOT(3))#                                                    CD06 108
ATWT(I)=QX(JJ)#                        Store atomic weight              CD06 109
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD06 110
#                                      #                                CD06 111
JJ=IPT+NINT(GOT(4))#                   Start loop index                 CD06 112
IF(QX(JJ)<1.5) NUMHYD=NATYPE#                                           CD06 113
FOR(J=1; J<=STEPFF-2; J=J+1)#                                           CD06 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD06 115
JK=JK+1#                                                                CD06 116
QX(JK)=QX(JJ)#                         Move scattering factor value     CD06 117
JJ=JJ+1#                                                                CD06 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD06 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD06 120
#                                                                       CD06 121
RETURN#                                                                 CD06 122
#                                                                       CD06 123
#                                                                       CD06 124
END#                                                                    CD06 125
#####################################################################   CD06 126
systemheader:(CD07)#                   Get dictionary items from bd     CD07   1
#                                                                       CD07   2
SUBROUTINE CD07#                       Get dictionary items on bdf(     CD07   3
#                                                                       CD07   4
#   WRITTEN BY KDW, 1-OCT-1981                                          CD07   5
#   REVISED BY KDW, 5-NOV-1981                                          CD07   6
#                                                                       CD07   7
include:(AACOMN)#                                                       CD07   8
include:(CDCOMN)#                                                       CD07   9
#                                                                       CD07  10
#                                                                       CD07  11
string:(RES,4)#                        Temporary storage of residue     CD07  12
string:(RESMIS,arith:(4,*,mxres:))#    Missing residues                 CD07  13
string:(RESHAV,arith:(4,*,mxres:))#    Residues present                 CD07  14
#                                                                       CD07  15
INTEGER PSIZE,IPT#                     Pointers for reading bdf         CD07  16
INTEGER KEYDIC(4)#                     Pointers for reading bdf         CD07  17
INTEGER SIZE#                          Characters in residue and at     CD07  18
INTEGER I,K,J,KEY#                     Local variables                  CD07  19
INTEGER IATM#                          Temp. counter of atoms           CD07  20
INTEGER NORES#                         Number of residue no in dict     CD07  21
INTEGER WANT(stepdc:)#                 Directory numbers for items      CD07  22
INTEGER POINT(arith:(stepdc:,+,1))#    Pointers to what  is wanted      CD07  23
REAL    CONVRT#                        Convert degrees to radians       CD07  24
chardata:(MSG1, EITHER NONE OR NOT ALL OF DICTIONARY ON BDF)#           CD07  25
chardata:(MSG2, RESIDUE MISSING FROM DICTIONARY==)#                     CD07  26
chardata:(DICT1, RESIDUES IN DICTIONARY AND STORED ON BDF)#             CD07  27
DATA SIZE/4/#                          Characters in residue and at     CD07  28
DATA KEYDIC /23,23,23,0/#                                               CD07  29
DATA WANT/1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,21,22,20,23/# CD07  30
DATA POINT/0,stepdc:*0/#                                                CD07  31
datastuff:#                                                             CD07  32
#                                                                       CD07  33
defineproc:(INDICT)#                   Input dictionary from bdf(in     CD07  34
defineproc:(HAVERES)#                                                   CD07  35
defineproc:(CHECKRES)#                 Check which residues not pre     CD07  36
#########################                                               CD07  37
#                                                                       CD07  38
xeq:(INDICT)#                                                           CD07  39
xeq:(HAVERES)#                                                          CD07  40
#                                                                       CD07  41
xeq:(CHECKRES)#                                                         CD07  42
#                                                                       CD07  43
RETURN#                                                                 CD07  44
#########################                                               CD07  45
#                                                                       CD07  46
#                                                                       CD07  47
#########################                                               CD07  48
procedure:(INDICT)#                                                     CD07  49
#########################                                               CD07  50
#                                                                       CD07  51
STARDC=STOPQX#                         Set start of directory secti     CD07  52
STEPDC=stepdc:#                        Set step to currently wanted     CD07  53
STOPDC=STARDC#                                                          CD07  54
#                                                                       CD07  55
# GET DIRECTORY OF LR LRDICT:                                           CD07  56
#                                                                       CD07  57
NDICT=0#                                                                CD07  58
rewindbdf:(1)#                                                          CD07  59
indexpkt:(1,lrdict:,PSIZE,IPT,0,KEYDIC,WANT,POINT)#                     CD07  60
IF(KEYDIC(4)<STEPDC)#                                                   CD07  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD07  62
writeline:(1,MSG1,NMSG1,3,3)#          Print informative message        CD07  63
RETURN#                                No dictionary on bdf (in)        CD07  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD07  65
REPEAT#                                Read the dictionary informat     CD07  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD07  67
readwpkt:(1,lrdict:,PSIZE,IPT,0)#                                       CD07  68
IF( IPT<=0) BREAK#                                                      CD07  69
DO I=1,STEPDC#                         Store the info in dictionary     CD07  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD07  71
K=STOPDC+I#                                                             CD07  72
IF(POINT(I)==no:) QX(K)=voidflg:#      Set this word as not there       CD07  73
ELSE#                                                                   CD07  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD07  75
J=IPT+POINT(I)#                        Set pointer to data              CD07  76
QX(K)=QX(J)#                           Transfer bdf info to qx          CD07  77
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD07  78
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD07  79
STOPDC=STOPDC+STEPDC#                                                   CD07  80
NDICT=NDICT+1#                                                          CD07  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD07  82
STOPQX=STOPDC#                         Set current end of qx array      CD07  83
#                                                                       CD07  84
endproc:(INDICT)#                                                       CD07  85
#                                                                       CD07  86
#                                                                       CD07  87
#                                                                       CD07  88
########################                                                CD07  89
procedure:(HAVERES)#                                                    CD07  90
#######################                                                 CD07  91
#                                                                       CD07  92
TYPRES=0#                                                               CD07  93
IF(NDICT>0)#                           Set up pointers to residues      CD07  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD07  95
K=1#                                   Initial temporary pointers ^     CD07  96
TYPRES=1  ; IATM=0#                                                     CD07  97
DICTPT(1)=0#                           Set pointer for first residu     CD07  98
J=STARDC+1#                                                             CD07  99
movertoc:(QX(J),1,RESHAV,K,SIZE,0)#    Move first residue name          CD07 100
FOR (I=STARDC+STEPDC+1; I<STOPDC; I=I+STEPDC)#                          CD07 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD07 102
IF(QX(I)!=QX(J))#                      Found new residue                CD07 103
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD07 104
TYPRES=TYPRES+1#                                                        CD07 105
DICTPT(TYPRES)=DICTPT(TYPRES-1)+IATM#  Set pointer to new residue       CD07 106
IATM=0#                                Reset number of atoms in cur     CD07 107
K=K+SIZE#                                                               CD07 108
J=I#                                   Set pointer to new residue n     CD07 109
movertoc:(QX(I),1,RESHAV,K,SIZE,0)#    Move new residue name to lis     CD07 110
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD07 111
ELSE IATM=IATM+1#                      Incr number of atoms in curr     CD07 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD07 113
DICTPT(TYPRES+1)=DICTPT(TYPRES)+IATM#  Store pointer for last atom      CD07 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD07 115
#                                                                       CD07 116
endproc:(HAVERES)#                                                      CD07 117
#                                                                       CD07 118
#                                                                       CD07 119
#                                                                       CD07 120
#########################                                               CD07 121
procedure:(CHECKRES)#                                                   CD07 122
#########################                                               CD07 123
#                                                                       CD07 124
NORES=0#                               Init number of res. not in d     CD07 125
K=TYPRES*SIZE#                         Number of characters in resh     CD07 126
#                                                                       CD07 127
FOR (I=STARSQ+1; I<=STOPSQ; I=I+STEPSQ)# Look at sequence               CD07 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD07 129
movertoc:(QX(I),1,RES,1,SIZE,0)#       Get sequ. name                   CD07 130
compchar:(RES,1,RESHAV,1,SIZE,SIZE,K,KEY)# Check against have array     CD07 131
IF(KEY==0)#                            Residue not in table             CD07 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD07 133
movechar:(RES,1,MSG2,35,SIZE,0)#       Set message                      CD07 134
writeline:(0,MSG2,NMSG2,3,3)#                                           CD07 135
K1=SIZE*NORES+1#                       Set up place to store name ^     CD07 136
NORES=NORES+1#                         Incr number not found            CD07 137
movechar:(RES,1,RESMIS,K1,SIZE,0)#                                      CD07 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD07 139
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD07 140
IF(NORES>0) iquit:(CD0701)#            There are missing residues       CD07 141
# LIST ENTRIES IN DICTIONARY                                            CD07 142
IF(PPRIOR>3)#                          If priority greater than 3       CD07 143
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD07 144
I=1#                                                                    CD07 145
J=TYPRES*SIZE#                         Compute total number of char     CD07 146
LINRM=TYPRES/10+3#                     Check on remaining lines         CD07 147
writeline:(1,DICT1,NDICT1,3,3)#                                         CD07 148
WHILE (I<=J)#                                                           CD07 149
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD07 150
K=2#                                   Start in col. 2                  CD07 151
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   CD07 152
REPEAT#                                Do ten residues at a time        CD07 153
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD07 154
movechar:(RESHAV,I,CHROT,K,SIZE,0)#    Move residue name                CD07 155
K=K+10#                                                                 CD07 156
I=I+SIZE#                                                               CD07 157
IF(K>=102 \ I>=J) BREAK#               Do ten times or end of list      CD07 158
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD07 159
writeline:(0,0,0,1,3)#                                                  CD07 160
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD07 161
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD07 162
#                                                                       CD07 163
# CONVERT ANGLES FROM DEGREES TO RADIANS                                CD07 164
#                                                                       CD07 165
CONVRT=ASIN(1.0)/90.0#                                                  CD07 166
DO K=STARDC,STOPDC,STEPDC#                                              CD07 167
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD07 168
ifnv:(QX(K+8)) QX(K+8)=QX(K+8)*CONVRT#                                  CD07 169
ifnv:(QX(K+10)) QX(K+10)=QX(K+10)*CONVRT#                               CD07 170
ifnv:(QX(K+11)) QX(K+11)=QX(K+11)*CONVRT#                               CD07 171
ifnv:(QX(K+16)) QX(K+16)=QX(K+16)*CONVRT#                               CD07 172
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD07 173
#                                                                       CD07 174
#                                                                       CD07 175
endproc:(CHECKRES)#                                                     CD07 176
#                                                                       CD07 177
#                                                                       CD07 178
#                                                                       CD07 179
#                                                                       CD07 180
deleteproc:(INDICT)#                                                    CD07 181
deleteproc:(HAVERES)#                                                   CD07 182
deleteproc:(CHECKRES)#                                                  CD07 183
#                                                                       CD07 184
END#                                                                    CD07 185
#####################################################################   CD07 186
systemheader:(CD08)#                   Read in atoms and their link     CD08   1
SUBROUTINE CD08#                       Read in atoms and their link     CD08   2
#                                                                       CD08   3
#   WRITTEN BY KDW, 16-DEC-1982                                         CD08   4
#                                                                       CD08   5
include:(AACOMN)#                                                       CD08   6
include:(CDCOMN)#                                                       CD08   7
#                                                                       CD08   8
macro:(stepat:,32)#                    Number of atom items excludi     CD08   9
macro:(nwant:,32)#                     Number of  total items in tw     CD08  10
#                                                                       CD08  11
INTEGER PSIZE,IPTI,POINT(arith:(nwant:,+,1))#                           CD08  12
INTEGER KEYATM(4)#                     Pointers for reading atoms       CD08  13
INTEGER MAXWNT#                                                         CD08  14
INTEGER WANT(nwant:)#                                                   CD08  15
INTEGER I,J,K#                         Temporary  variables             CD08  16
REAL    FMT(12)#                       Formats for output               CD08  17
string:(CURESI,4)#                                                      CD08  18
string:(ANAME,4)#                      Temporary 4 character field      CD08  19
chardata:(H2O,H2O )#                   Sequence name of water           CD08  20
chardata:(HEAD1,     =        = )#                                      CD08  21
chardata:(HEAD2,[  NO. ATOM BC   FC     GRP             COORDINATES  $# CD08  22
  B OR BETAS])#                                                         CD08  23
#                                                                       CD08  24
datastuff:#                                                             CD08  25
DATA FMT/ 40513., 250413., 380842., 460842., 540842., 600612.,$#        CD08  26
600642., 660642., 720642., 780642., 840642., 900642./#                  CD08  27
DATA KEYATM /nwant:,nwant:,nwant:,0/#                                   CD08  28
DATA WANT /16,15,14,14,210,212,213,215,214,211,216,217,218,  $#         CD08  29
1,2,3,101,102,103,11,22,4,5,6,7,8,9,10,23, $# / # coordinates,temps f   CD08  30
301,302,303/#                          Old coord.                       CD08  31
# ITEMS 214,211,216,217,218 NEED NOT BE PRESENT, IN FACT THEY WOULD JUS CD08  32
#   TAKE UP SPACE ON BDF. THEY ARE SET HERE IN 'CEDAR'                  CD08  33
#                                                                       CD08  34
#                                                                       CD08  35
# READ DIRECTORY OF ATOM INFO. FROM BDF                                 CD08  36
#                                                                       CD08  37
MAXWNT=nwant:#                                                          CD08  38
NUMATM=0#                              Number of atoms from bdf         CD08  39
#                                                                       CD08  40
#   READ LR LRATOM: FROM BDF(IN)                                        CD08  41
#                                                                       CD08  42
indexpkt:(1,lratom:,PSIZE,IPTI,0,KEYATM,WANT,POINT)#                    CD08  43
#                                                                       CD08  44
# CHECK ON WHAT INFO. IS ON THE BDF                                     CD08  45
#                                                                       CD08  46
ORTHOG=no:#                            Fractional coordinates curre     CD08  47
IF(POINT(1)==no:) iquit:(CD0802)#      Atom name information miss       CD08  48
ANISO=yes:#                                                             CD08  49
XXPREV=no:#                                                             CD08  50
UNITWT=yes:#                                                            CD08  51
IF(POINT(17) !=no:) UNITWT=no:#        Sigma on bdf                     CD08  52
IF(POINT(23)==no:) ANISO=no:#          No aniso temp. on bdf            CD08  53
IF(POINT(30) !=no:) XXPREV=yes:#       Previous coord. on bdf           CD08  54
IF(POINT(5)==no:) iquit:(CD0803)#      No link info stored              CD08  55
#                                                                       CD08  56
STARAT=STOPQX#                         Set start of atom parameters     CD08  57
STEPAT=stepat:#                                                         CD08  58
#                                                                       CD08  59
# READ ATOMS AND TRANSFER TO QX(STARAT) ARRAY                           CD08  60
#                                                                       CD08  61
STOPAT=STARAT#                         Qx place to receive atom dat     CD08  62
REPEAT#                                Loop over atoms packets          CD08  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD08  64
readwpkt:(1,lratom:,PSIZE,IPTI,0)#                                      CD08  65
IF(IPTI<=0) BREAK#                                                      CD08  66
NUMATM=NUMATM+1#                       Count the atom                   CD08  67
IF(NUMATM>=maxatms:) iquit:(CD0804)#   Too many atoms wanted            CD08  68
movereal:(voidflg:,1,QX(STOPAT+1),1,STEPAT,2)# Initialize array         CD08  69
#                                                                       CD08  70
DO K=1,3; IF(POINT(K)==0) iquit:(CD0802)# Atom name data missing        CD08  71
DO K=1,2#                              Loop over res and seq names      CD08  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD08  73
STOPAT=STOPAT+1#                                                        CD08  74
J=IPTI+POINT(K)#                                                        CD08  75
movereal:(QX(J),1,QX(STOPAT),1,1,0)#                                    CD08  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD08  77
J=IPTI+POINT(3)#                                                        CD08  78
movereal:(QX(J),1,QX(STOPAT+1),1,name8:,0)# Move first 8 chars only     CD08  79
STOPAT=STOPAT+2#                                                        CD08  80
#                                                                       CD08  81
DO K=5, STEPAT#                        Transfer parameters              CD08  82
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD08  83
STOPAT=STOPAT+1#                                                        CD08  84
IF(POINT(K) !=no:)#                                                     CD08  85
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD08  86
J=IPTI+POINT(K)#                                                        CD08  87
QX(STOPAT)=QX(J)#                                                       CD08  88
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD08  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD08  90
STOPQX=STOPAT#                                                          CD08  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD08  92
# SET UP POINTER TO START OF RESIDUES IN ATOM LIST                      CD08  93
J=STARAT+1#                            Location of first residue nu     CD08  94
movertoc:(QX(J),1,CURESI,1,4,0)#                                        CD08  95
RESIPT(1)=0#                                                            CD08  96
NATP=NUMATM#                                                            CD08  97
NATW2=0#                                                                CD08  98
K=2#                                   Current residue                  CD08  99
DO I=1,NUMATM#                                                          CD08 100
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD08 101
movertoc:(QX(J),1,ANAME,1,4,0)#                                         CD08 102
compchar:(ANAME,1,CURESI,1,4,4,4,KEY)# Check if same residue            CD08 103
IF(KEY==0)#                            Not same residue                 CD08 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD08 105
RESIPT(K)=I-1#                                                          CD08 106
movertoc:(QX(J),1,CURESI,1,4,0)#                                        CD08 107
# SPECIAL  CHECK FOR LAST PROTEIN ATOM AND NUMBER OF WATERS             CD08 108
KD=IFIX(QX(STARAT+(I-1)*STEPAT+kdoff:))#                                CD08 109
KD=STARDC+(KD-1)*STEPDC+1#                                              CD08 110
IF(NATW2==0)#                          If water not found yet, then     CD08 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD08 112
movertoc:(QX(KD),1,ANAME,1,4,0)#                                        CD08 113
compchar:(ANAME,1,H2O,1,4,4,4,KEY)#                                     CD08 114
IF(KEY !=0)#                           Water found                      CD08 115
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD08 116
NATP=I-1#                              Set atom number of last non-     CD08 117
NATW2=I#                               Increment number of water mo     CD08 118
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD08 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD08 120
K=K+1#                                                                  CD08 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD08 122
J=J+STEPAT#                                                             CD08 123
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD08 124
RESIPT(K)=NUMATM#                      Set end of pointers              CD08 125
TOTRES=K-1#                            Total number of residues         CD08 126
#                                                                       CD08 127
# CHECK FOR VOID COORDINATE FIELDS                                      CD08 128
IF(XXPREV==no:)#                       Fill previous coordinates wi     CD08 129
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD08 130
J=STARAT+xxoff:#                                                        CD08 131
K=xpoff:-xxoff:#                                                        CD08 132
DO I=J,STOPAT,STEPAT#                                                   CD08 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD08 134
QX(J+K)=QX(J)#                                                          CD08 135
QX(J+K+1)=QX(J+1)#                                                      CD08 136
QX(J+K+2)=QX(J+2)#                                                      CD08 137
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD08 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD08 139
IF(XXPREV==yes:)#                                                       CD08 140
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD08 141
J=STARAT#                                                               CD08 142
DO K=1,NUMATM#                         Check for void coord. fields     CD08 143
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD08 144
#CHECK FOR VOID OLD COORD. THAT MAY HAVE GOOD TARGET COORD.             CD08 145
ifvo:(QX(J+xpoff:))#                                                    CD08 146
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD08 147
DO L=1,3; QX(J+L+xpoff:-1)=QX(J+L+xxoff:-1)#                            CD08 148
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD08 149
#CHECK FOR VOID TARGET  COORD. THAT MAY HAVE GOOD OLD COORD.            CD08 150
ifvo:(QX(J+xxoff:))#                                                    CD08 151
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CD08 152
DO L=1,3; QX(J+L+xxoff:-1)=QX(J+L+xpoff:-1)#                            CD08 153
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD08 154
J=J+STEPAT#                                                             CD08 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD08 156
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD08 157
#                                                                       CD08 158
#                                                                       CD08 159
# IF TARGET SIGMAS                                                      CD08 160
# CONVERT SIGMAS TO ANGSTROM VARIANCE WEIGHTING                         CD08 161
#                                                                       CD08 162
STARVR=STOPQX#                                                          CD08 163
STOPQX=STARVR+NUMATM#                                                   CD08 164
IF(UNITWT==no:)#                                                        CD08 165
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CD08 166
J=STARAT+xsoff:#                                                        CD08 167
DO K=1,NUMATM#                                                          CD08 168
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CD08 169
## this should be done correctly someday, as well as in cd54            CD08 170
IF(QX(J+1)>1.0E-10)#                   Sigma present for this atom      CD08 171
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CD08 172
VARNCE=((QX(J)*FTOC(1)+QX(J+1)*FTOC(5)+QX(J+2)*FTOC(9))/3.0)**2#        CD08 173
IF(VARNCE>25.0) VARNCE=25.0#           Set upper limit for variance     CD08 174
QX(STARVR+K)=VARNCE#                                                    CD08 175
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CD08 176
ELSE QX(STARVR+K)=1.0#                                                  CD08 177
J=J+STEPAT#                                                             CD08 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CD08 179
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CD08 180
# SET ALL MOBILITIES TO YES:                                            CD08 181
J=STARAT+mvoff:#                                                        CD08 182
DO K=1,NUMATM#                                                          CD08 183
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CD08 184
QX(J)=1.0#                                                              CD08 185
J=J+STEPAT#                                                             CD08 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CD08 187
# CONVERT U(ISO) TO B(ISO)                                              CD08 188
J=STARAT+bfoff:#                                                        CD08 189
DO K=1,NUMATM#                                                          CD08 190
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CD08 191
QX(J)=QX(J)*78.95683521#                                                CD08 192
J=J+STEPAT#                                                             CD08 193
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CD08 194
#                                                                       CD08 195
# LIST ATOM COORDINATES AT PRIORITY 4                                   CD08 196
#                                                                       CD08 197
IF(PPRIOR>3)#                                                           CD08 198
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CD08 199
IPRESN=STARSQ+1#                                                        CD08 200
DO IR=1,NSEQU#                                                          CD08 201
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CD08 202
movertoc:(QX(IPRESN),1,HEAD1,11,4,0)#                                   CD08 203
movertoc:(QX(IPRESN+1),1,HEAD1,16,4,0)#                                 CD08 204
LINRM=5#                                                                CD08 205
writeline:(1,HEAD1,NHEAD1,3,3)#                                         CD08 206
writeline:(0,HEAD2,NHEAD2,3,4)#                                         CD08 207
IPRESN=IPRESN+STEPSQ#                                                   CD08 208
I=RESIPT(IR)+1#                                                         CD08 209
J=RESIPT(IR+1)#                                                         CD08 210
IF(J>=I)#                                                               CD08 211
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CD08 212
DO  IA=I,J#                                                             CD08 213
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CD08 214
KD=(IA-1)*STEPAT+STARAT#                                                CD08 215
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   CD08 216
ICOL=7#                                Set-up column                    CD08 217
movertoc:(QX(KD+2),1,CHROT,ICOL+1,3,0)# Get remoteness info             CD08 218
movertoc:(QX(KD+3),1,CHROT,ICOL,1,0)#  Get scat fact. char 1            CD08 219
ICOL=ICOL+6#                                                            CD08 220
DO IDATA=bcoff:,fcoff:#                Move back and forward chain      CD08 221
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CD08 222
K=KD+IDATA#                                                             CD08 223
K=IFIX(QX(K))#                                                          CD08 224
IF(K !=0)#                                                              CD08 225
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CD08 226
K=STARAT+(K-1)*STEPAT#                                                  CD08 227
movertoc:(QX(KD+2),1,CHROT,ICOL+1,3,0)# Get remoteness info             CD08 228
movertoc:(QX(KD+3),1,CHROT,ICOL,1,0)#  Get scat fact. char 1            CD08 229
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CD08 230
ICOL=ICOL+6#                           Set-up next column               CD08 231
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CD08 232
ATM=IA#                                                                 CD08 233
#IF(XXPREV==YES:) IOFF=XPOFF:# LIST PREVIOUS COORD                      CD08 234
#ELSE IOFF=XXOFF:#              OR CURRENT COORD                        CD08 235
IOFF=xxoff:#                           List current coord.              CD08 236
ncodefld:(ATM,1,CHROT,FMT(1),1)#       Atom number                      CD08 237
ifnv:(QX(KD+groff:)) ncodefld:(QX(KD+groff:),1,CHROT,FMT(2),1)#         CD08 238
IPA=(IA-1)*STEPAT+STARAT+IOFF#                                          CD08 239
ifnv:(QX(IPA)) ncodefld:(QX(IPA),1,CHROT,FMT(3),3)#                     CD08 240
IPA=(IA-1)*STEPAT+STARAT+bfoff:#                                        CD08 241
ifnv:(QX(IPA)) ncodefld:(QX(IPA),1,CHROT,FMT(6),1)#                     CD08 242
ifnv:(QX(IPA+1)) ncodefld:(QX(IPA+1),1,CHROT,FMT(7),6)#                 CD08 243
writeline:(0,0,0,1,4)#                 Write atom info.                 CD08 244
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CD08 245
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CD08 246
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CD08 247
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CD08 248
#                                                                       CD08 249
RETURN#                                                                 CD08 250
#                                                                       CD08 251
END#                                                                    CD08 252
#####################################################################   CD08 253
systemheader:(CD09)#                   Input master/slave from bdf      CD09   1
#                                                                       CD09   2
SUBROUTINE CD09#                       Input master/slave info.         CD09   3
#                                                                       CD09   4
#   WRITTEN BY KDW, 20-JUL-1982                                         CD09   5
#                                                                       CD09   6
include:(AACOMN)#                                                       CD09   7
include:(CDCOMN)#                                                       CD09   8
#                                                                       CD09   9
#                                                                       CD09  10
REAL FMT(20)#                          Format for listing atom atom     CD09  11
INTEGER PSIZE,IPTI#                    Pointers for reading bdf         CD09  12
INTEGER I,K#                           Local variables                  CD09  13
chardata:(FMT1,"(    :    )(    :    )(    :    )(    :    )(    :$#    CD09  14
)(    :    )(    :    )(    :    )(    :    )(    :    )")#             CD09  15
chardata:(HEAD1, MASTER/SLAVE RELATIONSHIPS)#                           CD09  16
#                                                                       CD09  17
DATA FMT/50413.,100413.,160413.,210413.,270413.,320413., $#             CD09  18
   380413.,430413.,490413.,540413.,600413.,650413.,  $#                 CD09  19
   710413.,760413.,820413.,870413.,930413.,980413.,1040413.,1090413./#  CD09  20
datastuff:#                                                             CD09  21
#                                                                       CD09  22
#                                                                       CD09  23
#   READ LR LRSLAV: FROM BDF(IN)                                        CD09  24
#                                                                       CD09  25
STARMS=STOPQX#                                                          CD09  26
STEPMS=2#                                                               CD09  27
STOPMS=STARMS#                                                          CD09  28
NSLAV=0#                                                                CD09  29
#                                                                       CD09  30
REPEAT#                                                                 CD09  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD09  32
readwpkt:(1,lrslav:,PSIZE,IPTI,0)#     Read old log.rec. lrslav:        CD09  33
IF(IPTI<=0) BREAK#                     Found end of record              CD09  34
NSLAV=NSLAV+1#                                                          CD09  35
movereal:(QX(IPTI+1),1,QX(STOPMS+1),1,STEPMS,0)#                        CD09  36
STOPMS=STOPMS+STEPMS#                                                   CD09  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD09  38
STOPQX=STOPMS#                                                          CD09  39
#                                                                       CD09  40
# LIST SLAVE INFO. AT PRIORITY 4                                        CD09  41
#                                                                       CD09  42
IF(PPRIOR>3)#                                                           CD09  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD09  44
writeline:(3,HEAD1,NHEAD1,3,4)#                                         CD09  45
#                                                                       CD09  46
I=STARMS+1#                                                             CD09  47
WHILE (I<=STOPMS)#                                                      CD09  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD09  49
K=1#                                                                    CD09  50
movechar:(FMT1,1,CHROT,1,NFMT1,0)#                                      CD09  51
REPEAT#                                Do ten pairs at a time   #       CD09  52
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD09  53
ncodefld:(QX(I),1,CHROT,FMT(K),2)#                                      CD09  54
K=K+2#                                                                  CD09  55
I=I+STEPMS#                                                             CD09  56
IF(K>=20 \ I>=STOPMS) BREAK#                                            CD09  57
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD09  58
IF(K<20)#                                                               CD09  59
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD09  60
K=(K-1)*5+2 ; J=102-K#                                                  CD09  61
movechar:(BLANK,1,CHROT,K,J,1)#                                         CD09  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD09  63
writeline:(0,0,0,1,4)#                                                  CD09  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD09  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD09  66
#                                                                       CD09  67
RETURN#                                                                 CD09  68
END#                                                                    CD09  69
#####################################################################   CD09  70
systemheader:(CD13)#                                                    CD13   1
SUBROUTINE CD13(I,RNAME)#                                               CD13   2
#                                                                       CD13   3
# FIND RESIDUE NAME AND CHAIN NAME FOR A FIELD ON INPUT LINE            CD13   4
# CREATE RESIDUE NAME WITH CHAR 1-5 AS RESIDUE NUMBER AND INSERTION     CD13   5
# NAME (RIGHT JUSTIFIED) AND CHAIN NAME IN CHAR 6-8 (RIGHT JUSTIFIED)   CD13   6
#                                                                       CD13   7
include:(AACOMN)#                                                       CD13   8
#                                                                       CD13   9
string:(RNAME,8)#                                                       CD13  10
chardata:(CD13A,RESCHN 0)#                                              CD13  11
datastuff:#                                                             CD13  12
#                                                                       CD13  13
stringlim:(I,N1,N2)#                                                    CD13  14
movechar:(BLANK,1,RNAME,1,8,1)#                                         CD13  15
IF(N1==0)#                             Real number found                CD13  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD13  17
ncodefld:(BUFIN(I),1,RNAME,50503.,1)#                                   CD13  18
movechar:(CD13A,8,RNAME,8,1,1)#                                         CD13  19
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD13  20
ELSE#                                                                   CD13  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD13  22
NSIZE=N2-N1#                                                            CD13  23
KEY=0#                                                                  CD13  24
IF(CHRIN(N1^N1+2)==CD13A(1^3)) KEY=1#                                   CD13  25
IF(KEY==1)#                            Res number preceded by res       CD13  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD13  27
N1=N1+3#                                                                CD13  28
NSIZE=NSIZE-3#                                                          CD13  29
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD13  30
movechar:(CHRIN,N1,RNAME,6-NSIZE,NSIZE,0)#                              CD13  31
IF(KEY==1)#                            Go look chain name               CD13  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD13  33
stringlim:(I+1,N1,N2)#                                                  CD13  34
NSIZE=N2-N1#                                                            CD13  35
KEY=0#                                                                  CD13  36
IF(CHRIN(N1^N1+2)==CD13A(4^6)) KEY=1#                                   CD13  37
IF(KEY==1)#                            Chain name found                 CD13  38
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD13  39
I=I+1#                                 Increment pointer for callin     CD13  40
#                                      # Program's sake                 CD13  41
N1=N1+3#                                                                CD13  42
NSIZE=NSIZE-3#                                                          CD13  43
movechar:(CHRIN,N1,RNAME,9-NSIZE,NSIZE,0)#                              CD13  44
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD13  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD13  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD13  47
RETURN#                                                                 CD13  48
END#                                                                    CD13  49
systemheader:(CD14)#                                                    CD14   1
####################################################################### CD14   2
SUBROUTINE CD14(IRES,RNAME)#                                            CD14   3
#                                                                       CD14   4
# FIND RESIDUE NAME AND CHAIN NAME FOR A FIELD ON INPUT LINE            CD14   5
#                                                                       CD14   6
include:(AACOMN)#                                                       CD14   7
include:(CDCOMN)#                                                       CD14   8
#                                                                       CD14   9
INTEGER FOUND#                                                          CD14  10
string:(RNAME,8)#                                                       CD14  11
string:(RESN,8)#                                                        CD14  12
chardata:(ZERO,0)#                                                      CD14  13
datastuff:#                                                             CD14  14
#                                                                       CD14  15
FOUND=no:#                                                              CD14  16
IPSEQ=STARSQ+1#                        Pointer to ascii residue num     CD14  17
FOR( I=1; I<=NSEQU; I=I+1)#                                             CD14  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD14  19
movechar:(BLANK,1,RESN,1,8,1)#                                          CD14  20
movertoc:(QX(IPSEQ),5,RESN,1,5,0)#     Move res number and insert       CD14  21
compchar:(RESN,5,BLANK,1,1,1,1,KEY)#                                    CD14  22
IF(KEY==1)#                            Blank found                      CD14  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD14  24
DO J=1,4#                              Move residue number right        CD14  25
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD14  26
movechar:(RESN,5-J,RESN,6-J,1,1,0)#                                     CD14  27
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD14  28
movechar:(BLANK,1,RESN,1,1,0)#                                          CD14  29
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD14  30
movertoc:(QX(IPSEQ),14,RESN,6,3,0)#    Get chain name                   CD14  31
compchar:(RESN,8,BLANK,1,1,1,1,KEY)#   Right justify chain              CD14  32
compchar:(RESN,7,BLANK,1,1,1,1,KEY2)#  Right justify chain              CD14  33
compchar:(RESN,6,BLANK,1,1,1,1,KEY3)#  Right justify chain              CD14  34
IF((KEY+KEY2+KEY3)==0)#                Blank chain name                 CD14  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD14  36
movechar:(ZERO,1,RESN,8,1,0)#                                           CD14  37
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD14  38
ELSE IF((KEY+KEY2)==2)#                Two blanks found                 CD14  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD14  40
movechar:(RESN,6,RESN,8,1,0)#                                           CD14  41
movechar:(BLANK,1,RESN,6,1,0)#                                          CD14  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD14  43
ELSE IF(KEY==1)#                       One blank found                  CD14  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD14  45
DO J=1,2#                              Move residue number right        CD14  46
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD14  47
movechar:(RESN,8-J,RESN,9-J,1,1,0)#                                     CD14  48
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD14  49
movechar:(BLANK,1,RESN,6,1,0)#                                          CD14  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD14  51
compchar:(RNAME,1,RESN,1,8,8,8,KEY)#                                    CD14  52
IPSEQ=IPSEQ+STEPSQ#                                                     CD14  53
IF( KEY!=0 )#                          Hurray                           CD14  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD14  55
FOUND=yes:#                                                             CD14  56
IRES=I#                                                                 CD14  57
BREAK#                                                                  CD14  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD14  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD14  60
IF(FOUND==no:) iquit:(-CD1401)#        Didn't find it                   CD14  61
RETURN#                                                                 CD14  62
END#                                                                    CD14  63
systemheader:(CD15)#                                                    CD15   1
######################################################################  CD15   2
SUBROUTINE CD15#                                                        CD15   3
#                                                                       CD15   4
include:(AACOMN)#                                                       CD15   5
include:(CDCOMN)#                                                       CD15   6
#                                                                       CD15   7
INTEGER FOUND#                                                          CD15   8
INTEGER INITI#                                                          CD15   9
#                                                                       CD15  10
string:(RNAM,8)#                                                        CD15  11
string:(ANAM,4)#                                                        CD15  12
string:(ANAM2,4)#                                                       CD15  13
#                                                                       CD15  14
chardata:(CD1, END    ATMZON RESZON WEIGHT MODE   DYNAM  SCALE  $#      CD15  15
MMODE  RESET  MAXHKL XLIMIT FC     REFINE XMODE  FINLWT NOBDF  $#       CD15  16
SETMD  RUNMD DIELEC NEIBOR )#                                           CD15  17
chardata:(CD2,MOD ENE XTA EXT UNI SIG LIS NOL )# Mode options           CD15  18
chardata:(CD3,CHG MIN UNI SIG MAX DAM SGC SFT )# Xlimit options         CD15  19
chardata:(CD4,UOV ISO ANI ANO FRI PRE FXE FXA FCA SKI )# Xmode option   CD15  20
chardata:(CD5,TST SNA NGB PRI STE TOL TEM TAU WTA COL COO )# Md optio   CD15  21
chardata:(MSG1, REFINE                   THROUGH                  )#    CD15  22
chardata:(MSG3, MODEL TYPE REFINEMENT)#                                 CD15  23
chardata:(MSG4, ENERGY TYPE REFINEMENT)#                                CD15  24
chardata:(MSG5, XTAL TYPE REFINEMENT)#                                  CD15  25
chardata:(MSG6,            TARGETS     BONDS    ANGLES FIX_DIHED $#     CD15  26
FLX_DIHED  NON-BOND   CHIRAL  HYDROGEN)#                                CD15  27
chardata:(MSG6A, INITIAL   FINAL     )#                                 CD15  28
chardata:(MSG7, EXTERNALLY CALCULATED TARGET PARAMETERS)#               CD15  29
chardata:(MSG8, B FACTOR CHANGE LIMIT=    )#                            CD15  30
chardata:(MSG9, B FACTOR MINIMUM    =    )#                             CD15  31
chardata:(MSG9A, B FACTOR MAXIMUM    =    )#                            CD15  32
chardata:(MSG10, TARGET ATOMS TO HAVE UNIT WEIGHTS)#                    CD15  33
chardata:(MSG11, TARGET ATOMS TO HAVE LEAST-SQUARES SIGMA WEIGHTS)#     CD15  34
chardata:(MSG12, CRYSTALLOGRAPHIC CALCULATION WILL USE UNIT WEIGHTS)#   CD15  35
chardata:(MSG13, CRYSTALLOGRAPHIC CALCULATION WILL USE SIGMA WEIGHTS)#  CD15  36
chardata:(MSG14, DAMPING FACTOR IN CRYSTALLOGRAPHIC L.S.=      )#       CD15  37
chardata:(MSG15, CALCULATION WILL USE EVERY     TH. REFLECTION)#        CD15  38
chardata:(MSG16, IGNORE REFLECTION LESS THAN      SIGMA)#               CD15  39
chardata:(MSG17, MAXIMUM CRYSTALLOGRPAPHIC SHIFT(ANGSTROMS)=     )#     CD15  40
chardata:(MSG18, SAVE PREVIOUS COORDINATES ON BDF FILE)#                CD15  41
chardata:(MSG19,[ REFLECTION LIMITS  H(MAX)  K(MAX)  L(MAX) $#          CD15  42
STOL(MIN)  STOL(MAX)  ])#                                               CD15  43
chardata:(MSG20, DIELECTRIC CONSTANT =       )#                         CD15  44
chardata:(MSG21, NON-BONDED NEIGHBOR CUTOFF =      )#                   CD15  45
REAL WTFMT(8)#                                                          CD15  46
REAL HKLFMT(5)#                                                         CD15  47
DATA WTFMT /201042.,301042.,401042.,501042.,601042.,701042.,$#          CD15  48
801042.,901042./#                                                       CD15  49
DATA HKLFMT /250802.,330802.,410802.,511042.,611042./#                  CD15  50
datastuff:#                                                             CD15  51
DATA INITI /0/#                                                         CD15  52
#                                                                       CD15  53
defineproc:(INITIAL)#                  General initialize routine       CD15  54
defineproc:(PROCEED)#                                                   CD15  55
defineproc:(SETZONE)#                                                   CD15  56
defineproc:(SETMODE)#                                                   CD15  57
defineproc:(SETXLIMIT)#                                                 CD15  58
defineproc:(SETXMODE)#                                                  CD15  59
defineproc:(NUMATS)#                                                    CD15  60
defineproc:(SETMD)#                                                     CD15  61
defineproc:(RUNMD)#                                                     CD15  62
#                                                                       CD15  63
#  CURRENTLY CALL SET MOVEMENT KEYS, ETC HERE                           CD15  64
IF(INITI==0) xeq:(INITIAL)#            Initialize first time thru       CD15  65
#                                                                       CD15  66
REPEAT#                                Read input lines                 CD15  67
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD15  68
readline:(CD1,NCD1)#                                                    CD15  69
IF(LINID==1)#                                                           CD15  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD15  71
FINAL=yes:#                                                             CD15  72
xeq:(PROCEED)#                                                          CD15  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD15  74
ELSE IF(LINID==2) xeq:(SETZONE)#                                        CD15  75
ELSE IF(LINID==3) xeq:(SETZONE)#                                        CD15  76
ELSE IF(LINID==4)#                     Set weights                      CD15  77
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD15  78
ifnv:(BUFIN(9)) ELIST=BUFIN(9)#        List large energy terms          CD15  79
DO I=1,8; ifnv:(BUFIN(I)) WT(I)=BUFIN(I)#                               CD15  80
TEMP=WT(2)+WT(3)+WT(4)+WT(5)#                                           CD15  81
ifne:(TEMP,0.0) MODREF=yes:#                                            CD15  82
ELSE MODREF=no:#                                                        CD15  83
ifne:(WT(6),0.0)#                                                       CD15  84
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD15  85
MODREF=no:#                                                             CD15  86
NRGREF=yes:#                                                            CD15  87
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD15  88
ELSE NRGREF=no:#                                                        CD15  89
DO I=1,8; FINLWT(I)=WT(I)#                                              CD15  90
DO I=1,8; INITWT(I)=WT(I)#                                              CD15  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD15  92
#                                                                       CD15  93
ELSE IF(LINID==5) xeq:(SETMODE)#                                        CD15  94
ELSE IF(LINID==6) NEXT#                                                 CD15  95
ELSE IF(LINID==7)#                                                      CD15  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD15  97
NSCGRP=1#                              Default to scale group 1         CD15  98
ifvo:(BUFIN(2))#                       Assume all scale groups use      CD15  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD15 100
DO I=1,maxscl:; XTLSCL(I)=1.0/BUFIN(1)#                                 CD15 101
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD15 102
ELSE#                                                                   CD15 103
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD15 104
NSCGRP=NINT(BUFIN(2))#                                                  CD15 105
IF(NSCGRP>maxscl:) iquit:(CD1512)#     Exceeded max allowed scale       CD15 106
ifnv:(BUFIN(1)) XTLSCL(NSCGRP)=1.0/BUFIN(1)#                            CD15 107
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD15 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD15 109
ELSE IF(LINID==8)#                                                      CD15 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD15 111
ifnv:(BUFIN(1)) NCYCLE=BUFIN(1)#                                        CD15 112
ifnv:(BUFIN(2)) ESTINI=BUFIN(2)#                                        CD15 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD15 114
#ELSE IF(LINID==9) XEQ:(RESET)   #                                      CD15 115
ELSE IF(LINID==10)#                    Set limits on reflections        CD15 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD15 117
ifnv:(BUFIN(1)) HKLMAX(1)=BUFIN(1)#                                     CD15 118
ifnv:(BUFIN(2)) HKLMAX(2)=BUFIN(2)#                                     CD15 119
ifnv:(BUFIN(3)) HKLMAX(3)=BUFIN(3)#                                     CD15 120
ifnv:(BUFIN(4)) STLMIN  =BUFIN(4)#                                      CD15 121
ifnv:(BUFIN(5)) STLMAX  =BUFIN(5)#                                      CD15 122
writeline:(1,MSG19,NMSG19,3,3)#                                         CD15 123
ifnv:(BUFIN(1)) ncodefld:(BUFIN,1,CHROT,HKLFMT(1),3)#                   CD15 124
ncodefld:(STLMIN,1,CHROT,HKLFMT(4),1)#                                  CD15 125
ncodefld:(STLMAX,1,CHROT,HKLFMT(5),1)#                                  CD15 126
writeline:(0,0,0,1,3)#                                                  CD15 127
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD15 128
ELSE IF(LINID==11) xeq:(SETXLIMIT)#    Set xtal l.s. and fc paramet     CD15 129
ELSE IF(LINID==12)#                    Do fc calc without l.s. refi     CD15 130
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD15 131
XCYCLE=0#                                                               CD15 132
XEQFC=yes:#                                                             CD15 133
xeq:(PROCEED)#                                                          CD15 134
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD15 135
ELSE IF(LINID==13)#                    Do cycles through various re     CD15 136
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD15 137
XCYCLE=1#                                                               CD15 138
ifnv:(BUFIN(1)) XCYCLE=BUFIN(1)#       Number of passes through who     CD15 139
xeq:(PROCEED)#                                                          CD15 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD15 141
ELSE IF(LINID==14) xeq:(SETXMODE)#     Set xmode options                CD15 142
#                                                                       CD15 143
ELSE IF(LINID==15)#                    Set final weights                CD15 144
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD15 145
DO I=1,7#                                                               CD15 146
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD15 147
ifnv:(BUFIN(I)) FINLWT(I)=BUFIN(I)#                                     CD15 148
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD15 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD15 150
ELSE IF(LINID==16) OUTBDF=no:#         Do not put output file bdf       CD15 151
#                                                                       CD15 152
ELSE IF(LINID==17)#                                                     CD15 153
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CD15 154
xeq:(SETMD)#                           Setup m.d. options               CD15 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD15 156
#                                                                       CD15 157
ELSE IF(LINID==18)#                                                     CD15 158
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CD15 159
DYNAM=yes:#                                                             CD15 160
xeq:(RUNMD)#                           Run m.d.                         CD15 161
xeq:(PROCEED)#                                                          CD15 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CD15 163
#                                                                       CD15 164
ELSE IF(LINID==19)#                                                     CD15 165
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CD15 166
ifnv:(BUFIN(1)) DIELEC=BUFIN(1)#                                        CD15 167
ncodefld:(DIELEC,1,MSG20,300522.,1)#                                    CD15 168
writeline:(1,MSG20,NMSG20,3,3)#                                         CD15 169
# RESET THE CHARGES                                                     CD15 170
DO I=STARDC,STOPDC-1,STEPDC#                                            CD15 171
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CD15 172
QX(I+19)=QX(I+19)/DIELEC#                                               CD15 173
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CD15 174
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CD15 175
ELSE IF(LINID==20)#                                                     CD15 176
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CD15 177
ifnv:(BUFIN(1)) NBCUT =BUFIN(1)#                                        CD15 178
ncodefld:(NBCUT ,1,MSG21,350522.,1)#                                    CD15 179
writeline:(1,MSG21,NMSG21,3,3)#                                         CD15 180
# RESET THE CHARGES                                                     CD15 181
DO I=STARDC,STOPDC-1,STEPDC#                                            CD15 182
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CD15 183
QX(I+19)=QX(I+19)/DIELEC#                                               CD15 184
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CD15 185
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CD15 186
#                                                                       CD15 187
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD15 188
# END INPUT STREAM CONTROL                                              CD15 189
#                                                                       CD15 190
procedure:(INITIAL)#                                                    CD15 191
#                                                                       CD15 192
# SET UP DEFAULT WEIGHTS AND REFINEMENT DIRECTIVES                      CD15 193
WT(1)=1.0 ; WT(2)=1.0 ; WT(3)=1.0 ; WT(4)=1.0#                          CD15 194
WT(5)=1.0 ; WT(6)=0.0 ; WT(7)=0.0 ; WT(8)=1.0/25.0#                     CD15 195
DO I=1,8#                                                               CD15 196
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CD15 197
INITWT(I)=WT(I)#                                                        CD15 198
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CD15 199
DO I=1,8#                                                               CD15 200
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CD15 201
FINLWT(I)=WT(I)#                                                        CD15 202
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CD15 203
DO I=1,arith:(maxscl:,+,1)#                                             CD15 204
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CD15 205
IF(XTLSCL(I)==0.0) XTLSCL(I)=1.0#                                       CD15 206
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CD15 207
BCHNGE=0.0#                            Don't  control b factor chan     CD15 208
BMIN =0.0#                             Default minimum b factor         CD15 209
BMAX =0.0#                             Default no maximum               CD15 210
DAMPF=0.8#                             Xtal l.s. damping factor         CD15 211
DIELEC=1.0#                            Set dielectric constant          CD15 212
NBCUT =nbcutoff:#                                                       CD15 213
MODREF=yes: ; NRGREF=no: ; XTLREF=no:#                                  CD15 214
DYNAM=no:#                                                              CD15 215
EXTREF=no:#                                                             CD15 216
BNOREF=no: ; ANIREF=no:#               Default refine iso b's           CD15 217
ANSCAT=no:#                            No anomalous scattering          CD15 218
PRESAV=no:#                            Don't save previous coordina     CD15 219
PREVFC=no:#                            Do not use previous fc as fi     CD15 220
FXEST=no:#                             Do not establish fixed atom      CD15 221
FXAPP=no:#                             Do not apply fixed atom cont     CD15 222
HKLMAX(1)=1000. ; HKLMAX(2)=1000. ; HKLMAX(3)=1000.#                    CD15 223
STLMIN=0.0 ; STLMAX=2.0#                                                CD15 224
OUTBDF=yes:#                           Output a bdf file                CD15 225
FINAL=no:#                             No end card found yet            CD15 226
INITI=1#                                                                CD15 227
XCYCLE=1#                                                               CD15 228
UNITWT=no:#                                                             CD15 229
WTREFL=no:#                                                             CD15 230
ANREFL=no:#                                                             CD15 231
XEQFC=no:#                                                              CD15 232
LISTAT=no:#                            No list of atoms                 CD15 233
SKPREF=1#                                                               CD15 234
SGCUT=0.0#                                                              CD15 235
ELIST=0.0#                                                              CD15 236
SFTLIM(1)=1.0/CELL(1)#                 Set limits on xtal l.s. shif     CD15 237
SFTLIM(2)=1.0/CELL(2)#                                                  CD15 238
SFTLIM(3)=1.0/CELL(3)#                                                  CD15 239
#                                                                       CD15 240
# SET UP DEFAULT CONJ. GRAD. CYCLES AND INIT. FORCE ESTI.               CD15 241
NCYCLE=10#                                                              CD15 242
ESTINI=NUMATM*1.#                      Currently just a number off      CD15 243
#                                                                       CD15 244
endproc:(INITIAL)#                                                      CD15 245
#################################################################       CD15 246
procedure:(SETZONE)#                                                    CD15 247
#                                                                       CD15 248
IF(LINID==2)#                          Setup atom refinement zone       CD15 249
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CD15 250
J=1#                                                                    CD15 251
CALL CD13(J,RNAM)#                     Get sequence position name       CD15 252
movechar:(BLANK,1,MSG1,11,4,1) ; movechar:(RNAM,1,MSG1,11,4,0)#         CD15 253
CALL CD14(NUMRES,RNAM)#                I-th residue returned            CD15 254
J=J+1#                                                                  CD15 255
grabword:(J,ANAM)#                     Get atom name                    CD15 256
xeq:(NUMATS)#                          Get number first atom of zone    CD15 257
LAT1=NUMAT#                                                             CD15 258
movechar:(BLANK,1,MSG1,16,4,1) ; movechar:(ANAM,1,MSG1,16,4,0)#         CD15 259
#                                                                       CD15 260
J=J+1#                                                                  CD15 261
CALL CD13(J,RNAM)#                     Get sequence position name       CD15 262
movechar:(BLANK,1,MSG1,29,4,1) ; movechar:(RNAM,1,MSG1,29,4,0)#         CD15 263
CALL CD14(NUMRES,RNAM)#                I-th residue returned            CD15 264
J=J+1#                                                                  CD15 265
grabword:(J,ANAM)#                     Get atom name                    CD15 266
xeq:(NUMATS)#                          Get number last atom of zone     CD15 267
movechar:(BLANK,1,MSG1,34,4,1) ; movechar:(ANAM,1,MSG1,34,4,0)#         CD15 268
grabword:(4,ANAM)#                                                      CD15 269
LAT2=NUMAT#                                                             CD15 270
writeline:(1,MSG1,NMSG1,3,3)#                                           CD15 271
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CD15 272
ELSE IF(LINID==3)#                     Setup residue refinement zon     CD15 273
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CD15 274
J=1#                                                                    CD15 275
CALL CD13(J,RNAM)#                     Grab first residue name and      CD15 276
movechar:(BLANK,1,MSG1,9,16,1) ; movechar:(RNAM,1,MSG1,9,16,0)#         CD15 277
CALL CD14(LRES1,RNAM)#                 Locate it's position             CD15 278
LAT1=RESIPT(LRES1)+1#                                                   CD15 279
movechar:(BLANK,1,MSG1,35,16,1) ; movechar:(RNAM,1,MSG1,35,16,0)#       CD15 280
CALL CD13(J+1,RNAM)#                   Repeat for second residue        CD15 281
CALL CD14(LRES2,RNAM)#                                                  CD15 282
LAT2=RESIPT(LRES2+1)#                                                   CD15 283
KD=STARSQ+(LRES1-1)*STEPSQ+1#                                           CD15 284
movertoc:(QX(KD),1,MSG1,11,4,0)#                                        CD15 285
KD=STARSQ+(LRES2-1)*STEPSQ+1#                                           CD15 286
movertoc:(QX(KD),1,MSG1,29,4,0)#                                        CD15 287
writeline:(1,MSG1,NMSG1,3,3)#                                           CD15 288
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CD15 289
endproc:(SETZONE)#                                                      CD15 290
#################################################################       CD15 291
procedure:(SETMODE)#                                                    CD15 292
#                                                                       CD15 293
MODREF=no:#                                                             CD15 294
NRGREF=no:#                                                             CD15 295
XTLREF=no:#                                                             CD15 296
IF(BUFIN(1)>=voidflg:) iquit:(CD1502)#                                  CD15 297
FOR (I=1; BUFIN(I)<voidflg:; I=I+1)#                                    CD15 298
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CD15 299
stringlim:(I,IC1,IC2)#                                                  CD15 300
NCH=MIN0(IC2-IC1,3)#                                                    CD15 301
compchar:(CHRIN,IC1,CD2,1,3,4,NCD2,KEY)#                                CD15 302
IF(KEY==0) BREAK#                                                       CD15 303
IF(KEY==1) MODREF=yes:#                                                 CD15 304
IF(KEY==2) NRGREF=yes:#                                                 CD15 305
IF(KEY==3) XTLREF=yes:#                                                 CD15 306
IF(KEY==4)#                            External produced target pos     CD15 307
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CD15 308
EXTREF=yes:#                                                            CD15 309
IF(XXPREV==no:) iquit:(CD1503)#        No old positions on bdf(in)      CD15 310
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CD15 311
IF(KEY==5) UNITWT=yes:#                                                 CD15 312
IF(KEY==6) UNITWT=no:#                                                  CD15 313
IF(KEY==7) LISTAT=yes:#                                                 CD15 314
IF(KEY==8) LISTAT=no:#                                                  CD15 315
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CD15 316
IF(XTLREF==yes:)#                                                       CD15 317
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CD15 318
DO I=2,6#                                                               CD15 319
$( WT(I)=0.0 $)#                                                        CD15 320
WT(1)=1.0#                                                              CD15 321
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CD15 322
IF(MODREF==yes:)#                                                       CD15 323
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CD15 324
DO I=1,5#                                                               CD15 325
$( WT(I)=1.0 $)#                                                        CD15 326
WT(6)=0.0#                                                              CD15 327
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CD15 328
IF(NRGREF==yes:)#                                                       CD15 329
DO I=1,6#                                                               CD15 330
$( WT(I)=1.0 $)#                                                        CD15 331
DO I=1,8#                                                               CD15 332
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 CD15 333
FINLWT(I)=WT(I)#                                                        CD15 334
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CD15 335
DO I=1,8#                                                               CD15 336
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 CD15 337
INITWT(I)=WT(I)#                                                        CD15 338
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 CD15 339
endproc:(SETMODE)#                                                      CD15 340
#################################################################       CD15 341
procedure:(SETXMODE)#                                                   CD15 342
FOR (I=1; BUFIN(I)!=voidflg:; I=I+1)#                                   CD15 343
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 CD15 344
stringlim:(I,IC1,IC2)#                                                  CD15 345
NCH=MIN0(IC2-IC1,3)#                                                    CD15 346
compchar:(CHRIN,IC1,CD4,1,3,4,NCD4,KEY)#                                CD15 347
IF(KEY==1)#                            No refine b's                    CD15 348
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 CD15 349
BNOREF=yes:#                                                            CD15 350
ANIREF=no:#                                                             CD15 351
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 CD15 352
IF(KEY==2)#                            Refine iso b's only              CD15 353
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 CD15 354
BNOREF=no:#                                                             CD15 355
ANIREF=no:#                                                             CD15 356
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 CD15 357
IF(KEY==3)#                            Refine iso and aniso b's         CD15 358
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 CD15 359
BNOREF=no:#                                                             CD15 360
ANIREF=yes:#                                                            CD15 361
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 CD15 362
# NEITHER OF THE TWO FOLLOWING OPTIONS OF IMPLEMENTED                   CD15 363
IF(KEY==4) ANSCAT=yes:#                                                 CD15 364
IF(KEY==5) ANSCAT=yes:#                                                 CD15 365
#                                                                       CD15 366
IF(KEY==6)#                                                             CD15 367
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 CD15 368
PRESAV=yes:#                                                            CD15 369
writeline:(1,MSG18,NMSG18,3,3)#                                         CD15 370
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 CD15 371
IF(KEY==7)#                            Establish and apply previous     CD15 372
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 CD15 373
FXEST=yes:#                                                             CD15 374
FXAPP=yes:#                                                             CD15 375
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 CD15 376
IF(KEY==8)#                            Appy previously established      CD15 377
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 CD15 378
FXEST=no:#                                                              CD15 379
FXAPP=yes:#                                                             CD15 380
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 CD15 381
IF(KEY==9)#                            Appy previously fc  as fixed     CD15 382
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 CD15 383
PREVFC=yes:#                                                            CD15 384
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 CD15 385
IF(KEY==10)#                           Xtal l.s. skip reflection        CD15 386
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 CD15 387
ifvo:(BUFIN(I+1)) SKPREF=1#                                             CD15 388
ELSE#                                                                   CD15 389
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 CD15 390
SKPREF=BUFIN(I+1)#                                                      CD15 391
I=I+1#                                                                  CD15 392
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 CD15 393
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 CD15 394
ATEMP=FLOAT(SKPREF)#                                                    CD15 395
ncodefld:(ATEMP,1,MSG15,310413.,1)#                                     CD15 396
writeline:(1,MSG15,NMSG15,3,3)#                                         CD15 397
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 CD15 398
endproc:(SETXMODE)#                                                     CD15 399
#################################################################       CD15 400
procedure:(SETMD)#                                                      CD15 401
FOR (I=1; BUFIN(I)!=voidflg:; I=I+1)#                                   CD15 402
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 CD15 403
stringlim:(I,IC1,IC2)#                                                  CD15 404
NCH=MIN0(IC2-IC1,3)#                                                    CD15 405
compchar:(CHRIN,IC1,CD5,1,3,4,NCD5,KEY)#                                CD15 406
IF(KEY==1) $( $)#                      Set total time steps             CD15 407
IF(KEY==2) $( $)#                      Set nth step to write infor      CD15 408
IF(KEY==3) $( $)#                      Do naybor every nth step         CD15 409
IF(KEY==4) $( $)#                      Print info to output every n     CD15 410
IF(KEY==5) $( $)#                      Set time step                    CD15 411
IF(KEY==6) $( $)#                      Set bond length tolerances       CD15 412
IF(KEY==7) $( $)#                      Temperature restraint            CD15 413
IF(KEY==8) $( $)#                      Molecule relaxation time         CD15 414
IF(KEY==9) $( $)#                      Water relaxation time            CD15 415
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 CD15 416
endproc:(SETMD)#                                                        CD15 417
#################################################################       CD15 418
procedure:(RUNMD)#                                                      CD15 419
MODREF=no:#                                                             CD15 420
NRGREF=no:#                                                             CD15 421
XTLREF=no:#                                                             CD15 422
DYNAM=yes:#                                                             CD15 423
endproc:(RUNMD)#                                                        CD15 424
#################################################################       CD15 425
procedure:(SETXLIMIT)#                                                  CD15 426
#  CHECK FOR OPTIONS ON THE XLIMIT LINE                                 CD15 427
FOR (I=1; BUFIN(I)!=voidflg:; I=I+1)#                                   CD15 428
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 CD15 429
stringlim:(I,IC1,IC2)#                                                  CD15 430
NCH=MIN0(IC2-IC1,3)#                                                    CD15 431
compchar:(CHRIN,IC1,CD3,1,3,4,NCD3,KEY)#                                CD15 432
IF(KEY==0) BREAK#                                                       CD15 433
IF(KEY==1)#                            B factor change limits           CD15 434
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 CD15 435
ifvo:(BUFIN(I+1)) BCHNGE=2.0#                                           CD15 436
ELSE#                                                                   CD15 437
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 CD15 438
BCHNGE=BUFIN(I+1)#                                                      CD15 439
I=I+1#                                                                  CD15 440
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 CD15 441
ncodefld:(BCHNGE,1,MSG8,300522.,1)#                                     CD15 442
writeline:(1,MSG8,NMSG8,3,3)#                                           CD15 443
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 CD15 444
IF(KEY==2)#                            Minimum b factor                 CD15 445
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 57 CD15 446
ifvo:(BUFIN(I+1)) BMIN=1.0#                                             CD15 447
ELSE#                                                                   CD15 448
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 58 CD15 449
BMIN=BUFIN(I+1)*78.95683521#                                            CD15 450
I=I+1#                                                                  CD15 451
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 58 CD15 452
ncodefld:(BMIN,1,MSG9,300522.,1)#                                       CD15 453
writeline:(1,MSG9,NMSG9,3,3)#                                           CD15 454
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 57 CD15 455
IF(KEY==3) WTREFL=no:#                 Xtal l.s. unit weights           CD15 456
IF(KEY==4) WTREFL=yes:#                Xtal l.s. sigma(f) weights       CD15 457
IF(KEY==5)#                            Maximum b factor                 CD15 458
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 59 CD15 459
ifvo:(BUFIN(I+1)) BMAX=50.0#                                            CD15 460
ELSE#                                                                   CD15 461
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 60 CD15 462
BMAX=BUFIN(I+1)*78.95683521#                                            CD15 463
I=I+1#                                                                  CD15 464
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 60 CD15 465
ncodefld:(BMAX,1,MSG9A,300522.,1)#                                      CD15 466
writeline:(1,MSG9A,NMSG9A,3,3)#                                         CD15 467
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 59 CD15 468
IF(KEY==6)#                            Xtal l.s. damping factor         CD15 469
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 61 CD15 470
ifvo:(BUFIN(I+1)) DAMPF=1.0#                                            CD15 471
ELSE#                                                                   CD15 472
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 62 CD15 473
DAMPF=BUFIN(I+1)#                                                       CD15 474
I=I+1#                                                                  CD15 475
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 62 CD15 476
ncodefld:(DAMPF,1,MSG14,500622.,1)#                                     CD15 477
writeline:(1,MSG14,NMSG14,3,3)#                                         CD15 478
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 61 CD15 479
IF(KEY==7)#                            Sigma(f) cutoff#                 CD15 480
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 63 CD15 481
ifvo:(BUFIN(I+1)) SGCUT=2.0#                                            CD15 482
ELSE#                                                                   CD15 483
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 64 CD15 484
SGCUT=BUFIN(I+1)#                                                       CD15 485
I=I+1#                                                                  CD15 486
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 64 CD15 487
ncodefld:(SGCUT,1,MSG16,330622.,1)#                                     CD15 488
writeline:(1,MSG16,NMSG16,3,3)#                                         CD15 489
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 63 CD15 490
IF(KEY==8)#                            Xtal l.s. maximum shift          CD15 491
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 65 CD15 492
ifvo:(BUFIN(I+1)) SFTLIM(1)=0.5#                                        CD15 493
ELSE#                                                                   CD15 494
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 66 CD15 495
SFTLIM(1)=BUFIN(I+1)#                                                   CD15 496
I=I+1#                                                                  CD15 497
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 66 CD15 498
ncodefld:(SFTLIM,1,MSG17,500622.,1)#                                    CD15 499
writeline:(1,MSG17,NMSG17,3,3)#                                         CD15 500
SFTLIM(3)=SFTLIM(1)/CELL(3)#           Don't reverse order of 3 lin     CD15 501
SFTLIM(2)=SFTLIM(1)/CELL(2)#                                            CD15 502
SFTLIM(1)=SFTLIM(1)/CELL(1)#                                            CD15 503
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 65 CD15 504
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 CD15 505
endproc:(SETXLIMIT)#                                                    CD15 506
#################################################################       CD15 507
procedure:(NUMATS)#                                                     CD15 508
#                                                                       CD15 509
#        RETURNS ATOMNUMBER, GIVEN ATOM NAME AND RESIDUE NUMBER         CD15 510
#                                                                       CD15 511
IF( NUMRES<=0 \ NUMRES>NSEQU ) iquit:(-CD1508)#                         CD15 512
L1=RESIPT(NUMRES)+1 ; L2=RESIPT(NUMRES+1)#                              CD15 513
FOUND=no:#                                                              CD15 514
FOR (IAT=L1; IAT<=L2; IAT=IAT+1)#                                       CD15 515
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 67 CD15 516
KD=(IAT-1)*STEPAT+STARAT+3#            Pointer to k.d.                  CD15 517
KD=IFIX( QX(KD) )#                     Key to the dictionary            CD15 518
KD=(KD-1)*STEPDC+STARDC+2#             Pointer to atom name             CD15 519
movertoc:(QX(KD),1,ANAM2,1,4,0)#       Get atom name2                   CD15 520
compchar:(ANAM,1,ANAM2,1,4,4,4,KEY)#                                    CD15 521
IF( KEY!=0 )#                                                           CD15 522
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 68 CD15 523
FOUND=yes:#                                                             CD15 524
BREAK#                                                                  CD15 525
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 68 CD15 526
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 67 CD15 527
IF(FOUND==yes:) NUMAT=IAT#                                              CD15 528
ELSE  iquit:(-CD1509)#                                                  CD15 529
endproc:(NUMATS)#                                                       CD15 530
#################################################################       CD15 531
procedure:(PROCEED)#                                                    CD15 532
#                                                                       CD15 533
IF(NCYCLE !=0)#                                                         CD15 534
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 69 CD15 535
IF(MODREF==yes:) writeline:(1,MSG3,NMSG3,3,3)#                          CD15 536
IF(NRGREF==yes:) writeline:(1,MSG4,NMSG4,3,3)#                          CD15 537
IF(XTLREF==yes:) writeline:(1,MSG5,NMSG5,3,3)#                          CD15 538
IF(EXTREF==yes:) writeline:(1,MSG7,NMSG7,3,3)#                          CD15 539
IF(UNITWT==yes:) writeline:(1,MSG10,NMSG10,3,3)#                        CD15 540
IF(UNITWT==no:)  writeline:(1,MSG11,NMSG11,3,3)#                        CD15 541
IF(WTREFL==no:)  writeline:(1,MSG12,NMSG12,3,3)#                        CD15 542
IF(WTREFL==yes:) writeline:(1,MSG13,NMSG13,3,3)#                        CD15 543
writeline:(1,MSG6,NMSG6,3,3)#                                           CD15 544
movechar:(BLANK,1,CHROT,1,80,1)#                                        CD15 545
movechar:(MSG6A,1,CHROT,1,10,0)#                                        CD15 546
ncodefld:(WT,1,CHROT,WTFMT,8)#                                          CD15 547
writeline:(0,0,0,1,3)#                                                  CD15 548
movechar:(MSG6A,11,CHROT,1,10,0)#                                       CD15 549
ncodefld:(FINLWT,1,CHROT,WTFMT,8)#                                      CD15 550
writeline:(0,0,0,1,3)#                                                  CD15 551
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 69 CD15 552
#                                                                       CD15 553
#ENDPROC:(PROCEED)   # END WITH PROGRETURN AND NOT THIS                 CD15 554
#################################################################       CD15 555
RETURN#                                                                 CD15 556
#################################################################       CD15 557
deleteproc:(INITIAL)#                                                   CD15 558
deleteproc:(SETZONE)#                                                   CD15 559
deleteproc:(PROCEED)#                                                   CD15 560
deleteproc:(NUMATS)#                                                    CD15 561
deleteproc:(SETMD)#                                                     CD15 562
deleteproc:(RUNMD)#                                                     CD15 563
END#                                                                    CD15 564
#####################################################################   CD15 565
systemheader:(CD18)#                   B-factor dampening routine       CD18   1
#                                                                       CD18   2
#                                                                       CD18   3
SUBROUTINE CD18#                       B-factor dampening routine       CD18   4
include:(AACOMN)#                                                       CD18   5
include:(CDCOMN)#                                                       CD18   6
IF(ANISO==yes:) iquit:(CD1801)#        Don't use b_change and aniso     CD18   7
#                                      #  At the same time yet          CD18   8
DO I=1,NUMATM#                         Check b factor minimum           CD18   9
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD18  10
BATOM=bfact:(I)#                                                        CD18  11
BATOM=AMAX1(BATOM,BMIN)#                                                CD18  12
bfact:(I)=BATOM#                                                        CD18  13
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD18  14
IF(BMAX>0.0)#                          Set maximum b factors            CD18  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD18  16
DO I=1,NATP#                           Check b factor minimum           CD18  17
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD18  18
BATOM=bfact:(I)#                                                        CD18  19
BATOM=AMIN1(BATOM,BMAX)#                                                CD18  20
bfact:(I)=BATOM#                                                        CD18  21
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD18  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD18  23
IF(BCHNGE>0.0)#                        Modify b factors                 CD18  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD18  25
DO I=1,NATP#                                                            CD18  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD18  27
BATOM=bfact:(I)#                       Get iso b of atom                CD18  28
IBACK=backchain:(I)#                                                    CD18  29
IF(IBACK<=0) NEXT#                                                      CD18  30
BBACK=bfact:(IBACK)#                   Get b of backchain atom          CD18  31
IF(BATOM>BBACK)#                                                        CD18  32
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD18  33
BBACK=BBACK*BCHNGE#                                                     CD18  34
BATOM=AMIN1(BATOM,BBACK)#                                               CD18  35
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD18  36
ELSE#                                                                   CD18  37
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD18  38
BBACK=BBACK/BCHNGE#                                                     CD18  39
BATOM=AMAX1(BATOM,BBACK)#                                               CD18  40
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD18  41
bfact:(I)=BATOM#                                                        CD18  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD18  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD18  44
RETURN#                                                                 CD18  45
END#                                                                    CD18  46
#####################################################################   CD18  47
systemheader:(CD20)#                                                    CD20   1
#                                                                       CD20   2
#                                                                       CD20   3
SUBROUTINE CD20#                       Main crystal refine driver       CD20   4
#                                                                       CD20   5
include:(AACOMN)#                      Xtal system common               CD20   6
include:(CDCOMN)#                                                       CD20   7
#                                                                       CD20   8
# THIS ROUTINE CONTROLS THE XTAL LEAST-SQUARES REFINEMENT PORTION       CD20   9
#                                                                       CD20  10
REAL    HKL(3)#                        Temp. storage of indices         CD20  11
REAL    FRACT#                                                          CD20  12
INTEGER IVAR#                          Indiv atom variables             CD20  13
INTEGER LAST#                          Last reflection has been rea     CD20  14
INTEGER REJECT#                        Reject current reflection        CD20  15
INTEGER SKPCNT#                        Counter for skipping reflect     CD20  16
INTEGER I,K,L,JJ#                      Temporary integers               CD20  17
INTEGER INSIZ, OUTSIZ#                 Input/output packet sizes        CD20  18
INTEGER IPNT,OPNT#                     Input/output qx pointers         CD20  19
INTEGER HKLPNT,MULPNT,STLPNT#                                           CD20  20
#                                                                       CD20  21
INTEGER KEYRF(4),IRELRF(13)#           Integers for indexpkt:           CD20  22
intdata:(IWNTRF,[1, 2, 3, 1304, 1305, 1309, 1800, 1801, 1802, 1700, $#  CD20  23
1811, 1812])#                                                           CD20  24
chardata:(CD20A,[ SCALE FACTOR GROUP NUMBER                      ])#    CD20  25
chardata:(CD20B,[ NUMBER OF REFLECTION USED IN REFINEMENT        ])#    CD20  26
chardata:(CD20C,[ R-FACTOR (UNWEIGHTED)                          ])#    CD20  27
chardata:(CD20D,[ R-FACTOR (WEIGHTED)                            ])#    CD20  28
chardata:(CD20E,[ SCALE FACTOR                                   ])#    CD20  29
chardata:(CD20F,[ SCALE FACTOR (WEIGHTED)                        ])#    CD20  30
chardata:(CD20G,[ R-FACTOR FOR ALL SCALE GROUPS])#                      CD20  31
chardata:(CD20H,[ NUMBER OF REFLECTION USED IN REFINEMENT        ])#    CD20  32
chardata:(CD20I,[ R-FACTOR (UNWEIGHTED)                          ])#    CD20  33
chardata:(CD20J,[ R-FACTOR (WEIGHTED)                            ])#    CD20  34
datastuff:#                                                             CD20  35
defineproc:(INITIAL)#                  Initial arrays, reflection n     CD20  36
defineproc:(GETREFL)#                  Read reflection off bdf(in)      CD20  37
defineproc:(GETHKLEQ)#                 Get equivalent indices           CD20  38
defineproc:(GETSCAT)#                  Get scattering factors           CD20  39
defineproc:(PUTREFL)#                  Put reflection on bdf file c     CD20  40
defineproc:(RETURN)#                   Return thru bottom of progra     CD20  41
#                                                                       CD20  42
xeq:(INITIAL)#                                                          CD20  43
#                                                                       CD20  44
REPEAT#                                Loop thru reflection records     CD20  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD20  46
xeq:(GETREFL)#                         Read reflection from bdf         CD20  47
IF(LAST==yes:) BREAK#                  Break from loop if no more r     CD20  48
IF(REJECT==no:)#                       Continue                         CD20  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD20  50
xeq:(GETHKLEQ)#                        Generate equivalent indices      CD20  51
xeq:(GETSCAT)#                         Get pointers for scattering      CD20  52
CALL CD22#                             Calc s.f. and derv. terms        CD20  53
CALL CD24#                             Build matrices and fc's          CD20  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD20  55
xeq:(PUTREFL)#                         Put modified data on file c      CD20  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD20  57
#                                                                       CD20  58
# PUT OUT SOME STATISTICS                                               CD20  59
NOGRP=0#                                                                CD20  60
DO I=1,maxscl:#                                                         CD20  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD20  62
IF(NREFL(I)<1) NEXT#                   No refl in this group            CD20  63
NOGRP=NOGRP+1#                         Check on actual groups used      CD20  64
NREFL(arith:(maxscl:,+,1))=NREFL(arith:(maxscl:,+,1))+NREFL(I)#         CD20  65
SUMFC(arith:(maxscl:,+,1))=SUMFC(arith:(maxscl:,+,1))+SUMFC(I)#         CD20  66
WTSQFC(arith:(maxscl:,+,1))=WTSQFC(arith:(maxscl:,+,1))+WTSQFC(I)#      CD20  67
SUMFO(arith:(maxscl:,+,1))=SUMFO(arith:(maxscl:,+,1))+SUMFO(I)#         CD20  68
WTSQFO(arith:(maxscl:,+,1))=WTSQFO(arith:(maxscl:,+,1))+WTSQFO(I)#      CD20  69
SUMDF(arith:(maxscl:,+,1))=SUMDF(arith:(maxscl:,+,1))+SUMDF(I)#         CD20  70
WTSQDF(arith:(maxscl:,+,1))=WTSQDF(arith:(maxscl:,+,1))+WTSQDF(I)#      CD20  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD20  72
DO I=1,maxscl:#                                                         CD20  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD20  74
IF(NREFL(I)<1) NEXT#                   Norefl in this group             CD20  75
RFACT=SUMDF(I)/SUMFO(I)#                                                CD20  76
WRFACT=SQRT(WTSQDF(I)/WTSQFO(I))#                                       CD20  77
SCAL=SUMFC(I)/(SUMFO(I)*XTLSCL(I))#                                     CD20  78
WTSCL=SQRT(WTSQFC(I)/WTSQFO(I))/XTLSCL(I)#                              CD20  79
ncodefld:(FLOAT(I),1,CD20A,480813.,1)#                                  CD20  80
ncodefld:(FLOAT(NREFL(I)),1,CD20B,480813.,1)#                           CD20  81
ncodefld:(RFACT,1,CD20C,480842.,1)#                                     CD20  82
ncodefld:(WRFACT,1,CD20D,480842.,1)#                                    CD20  83
ncodefld:(SCAL,1,CD20E,480852.,1)#                                      CD20  84
ncodefld:(WTSCL,1,CD20F,480842.,1)#                                     CD20  85
writeline:(2,CD20A,NCD20A,3,3)#                                         CD20  86
writeline:(1,CD20B,NCD20B,3,3)#                                         CD20  87
writeline:(1,CD20C,NCD20C,3,3)#                                         CD20  88
writeline:(1,CD20D,NCD20D,3,3)#                                         CD20  89
writeline:(1,CD20E,NCD20E,3,3)#                                         CD20  90
writeline:(1,CD20F,NCD20F,3,3)#                                         CD20  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD20  92
IF(NOGRP>1)#                           List out indiv group scale s     CD20  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD20  94
# WRITE OVERALL STATS                                                   CD20  95
RFACT=SUMDF(arith:(maxscl:,+,1))/SUMFO(arith:(maxscl:,+,1))#            CD20  96
WRFACT=SQRT(WTSQDF(arith:(maxscl:,+,1))/WTSQFO(arith:(maxscl:,+,1)))#   CD20  97
ncodefld:(FLOAT(NREFL(I)),1,CD20H,480813.,1)#                           CD20  98
ncodefld:(RFACT,1,CD20I,480842.,1)#                                     CD20  99
ncodefld:(WRFACT,1,CD20J,480842.,1)#                                    CD20 100
writeline:(2,CD20G,NCD20G,3,3)#                                         CD20 101
writeline:(1,CD20H,NCD20H,3,3)#                                         CD20 102
writeline:(1,CD20I,NCD20I,3,3)#                                         CD20 103
writeline:(1,CD20J,NCD20J,3,3)#                                         CD20 104
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD20 105
#                                                                       CD20 106
IF(DCALC==yes:) CALL CD25#             Calculate least-squares est.     CD20 107
#                                                                       CD20 108
xeq:(RETURN)#                                                           CD20 109
#                                                                       CD20 110
#                                                                       CD20 111
#                                                                       CD20 112
#                                                                       CD20 113
######################################################################  CD20 114
#   CD20 PROCEDURES                                                     CD20 115
######################################################################  CD20 116
#                                                                       CD20 117
procedure:(INITIAL)#                   Get ready for refinement         CD20 118
#                                                                       CD20 119
LAST=no:#                                                               CD20 120
REJECT=no:#                                                             CD20 121
SKPCNT=0#                                                               CD20 122
NFILE=3#                               Write reflection info to scr     CD20 123
#STARRF=STOPQX#                        NEVER USED                       CD20 124
KEYRF(1)=4#                                                             CD20 125
KEYRF(2)=6#                                                             CD20 126
KEYRF(3)=10#                                                            CD20 127
IF(FXAPP==yes:) KEYRF(3)=12#                                            CD20 128
KEYRF(4)=0#                            Set to update mode               CD20 129
rewindbdf:(1)#                                                          CD20 130
indexpkt:(1,lrrefl:,INSIZ,IPNT,NFILE,KEYRF,IWNTRF,IRELRF)# Get direct   CD20 131
IF(IPNT<=0) iquit:(CD2002)#                                             CD20 132
IF(KEYRF(4)<0)#                        Then mandatory items are mis     CD20 133
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD20 134
iquit:(CD2003)#                                                         CD20 135
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD20 136
OUTSIZ=KEYRF(4)#                                                        CD20 137
IF(WTREFL==no:\IRELRF(5)==0) WTREFL=no:# Use unit weights               CD20 138
IF(FXEST==yes: & IRELRF(8)==no:)#                                       CD20 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD20 140
iquit:(CD2004)#                        No previous fc to establish      CD20 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD20 142
IF(FXEST==no: & FXAPP==yes: & IRELRF(12)==no:)#                         CD20 143
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD20 144
iquit:(CD2005)#                        No fixed atom contrib to app     CD20 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD20 146
IF(SGCUT>0.0 & IRELRF(5)==0)#                                           CD20 147
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD20 148
iquit:(CD2006)#                        No sigmas on tape for sigma      CD20 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD20 150
STARH=STOPQX#                          Set start of indices informa     CD20 151
STEPH=4#                               H,k,l,phase shift                CD20 152
STOPH=STARH+STEPH*NSYMOP#                                               CD20 153
STOPQX=STOPH#                                                           CD20 154
#                                                                       CD20 155
# CLEAR OUT STATISTICAL REGION                                          CD20 156
#                                                                       CD20 157
DO I=1,arith:(maxscl:,+,1)#                                             CD20 158
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD20 159
SUMFC(I)=0.0 ; SUMFO(I)=0.0 ; SUMDF(I)=0.0#                             CD20 160
WTSQFC(I)=0.0; WTSQFO(I)=0.0; WTSQDF(I)=0.0#                            CD20 161
NREFL(I)=0#                                                             CD20 162
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD20 163
#                                                                       CD20 164
IF(ORTHOG==yes:)#                      Convert coordinates to fract     CD20 165
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD20 166
ORTHOG=no:#                                                             CD20 167
J=STARAT+xpoff:#                                                        CD20 168
K=STARAT+xxoff:#                                                        CD20 169
#                                                                       CD20 170
DO I=1,NUMATM#                                                          CD20 171
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD20 172
CALL CD01(CTOF,QX(J),QX(J))#                                            CD20 173
CALL CD01(CTOF,QX(K),QX(K))#                                            CD20 174
J=J+STEPAT#                                                             CD20 175
K=K+STEPAT#                                                             CD20 176
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD20 177
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD20 178
#                                                                       CD20 179
# FIGURE OUT NUMBER OF ATOMS AND PARAMTERS BEING REFINED                CD20 180
#                                                                       CD20 181
K=STARAT-STEPAT#                                                        CD20 182
NVAR=0#                                Number of atoms moving           CD20 183
NPARAM=0#                              Number of varibales to refin     CD20 184
STOPMT=0#                                                               CD20 185
IF(LAT1==0) LAT1=1#                                                     CD20 186
IF(LAT2==0) LAT2=NUMATM#                                                CD20 187
DO I=1,NUMATM#                         Check each atom                  CD20 188
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD20 189
SIZEMT=0#                              Size matrix for the atom         CD20 190
K=K+STEPAT#                                                             CD20 191
ifeq:(QX(K+groff:),-9.0)#                                               CD20 192
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CD20 193
QX(K+mvoff:)=-9.0#                     Slave atom                cd     CD20 194
NEXT#                                                                   CD20 195
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD20 196
ifeq:(QX(K+sfoff:),NUMHYD)#                                             CD20 197
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CD20 198
QX(K+mvoff:)=-1.0#                     Hydrogen atom                    CD20 199
NEXT#                                                                   CD20 200
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CD20 201
ELSE IF(I>=LAT1 & I<=LAT2)#                                             CD20 202
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CD20 203
QX(K+mvoff:)=1.0#                      Moving atom                      CD20 204
NVAR=NVAR+1#                                                            CD20 205
IF(BNOREF==yes:) IVAR=3#               Don't refine b's                 CD20 206
ELSE IF(ANIREF==no:) IVAR=4#           Refine iso b's                   CD20 207
ELSE IF(ANIREF==yes:)#                                                  CD20 208
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CD20 209
IVAR=9#                                Make room for aniso b's          CD20 210
ifvo:(QX(K+arith:(bfoff:,+,1))) IVAR=IVAR-5# No aniso b for this a      CD20 211
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CD20 212
NPARAM=NPARAM+IVAR#                                                     CD20 213
# MATRIX SPACE BEING ALLOCATED FOR ATOM BLOCK DIAGONAL                  CD20 214
#   WHEN MODIFIED FOR RESIDUE BLOCK OR OTHER, THEN THIS SPACE WILL      CD20 215
#   BE COMPUTED DIFFERENTLY                                             CD20 216
STOPMT=STOPMT+(IVAR*(IVAR+3))/2#                                        CD20 217
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CD20 218
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD20 219
# SET UP DERIVATIVE SPACE                                               CD20 220
IF(STARPD==0) STARPD=STOPQX#           First time set-up pointer        CD20 221
STARPD=STOPQX#                                                          CD20 222
STEPPD=NPARAM#                                                          CD20 223
#STOPPD=STARPD+4*STEPPD#            # STORAGE FOR DERIV. A,B,A'',B      CD20 224
STOPPD=STARPD+2*STEPPD#                Storage for deriv. a,b           CD20 225
STARMT=STOPPD#                                                          CD20 226
STOPMT=STARMT+STOPMT#                  Matrices space                   CD20 227
I=STOPMT-STARPD+1#                     Clear out matrices space         CD20 228
movereal:(0.0,1,QX(STARPD+1),1,I,2)#                                    CD20 229
#                                                                       CD20 230
endproc:(INITIAL)#                                                      CD20 231
#                                                                       CD20 232
#                                                                       CD20 233
#                                                                       CD20 234
#                                                                       CD20 235
procedure:(GETREFL)#                   Get reflection information       CD20 236
102 CONTINUE#                                                           CD20 237
readwpkt:(1,lrrefl:,INSIZ,IPNT,0)#                                      CD20 238
IF(IPNT<=0)#                           Finished reading reflections     CD20 239
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CD20 240
LAST=yes:#                                                              CD20 241
#READWPKT:(1,ENDRECORD:,INSIZ,IPNT,0)#  #                               CD20 242
writepkt:(NFILE,endrecord:,INSIZ,IPNT)#                                 CD20 243
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CD20 244
ELSE#                                                                   CD20 245
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CD20 246
writepkt:(NFILE,lrrefl:,OUTSIZ,OPNT)#                                   CD20 247
movereal:(voidflg:,1,QX,OPNT+1,OUTSIZ,2)# Void the output area          CD20 248
movereal:(QX,IPNT+1,QX,OPNT+1,INSIZ,0)# Move input to output area       CD20 249
ifvo:(QX(IPNT+IRELRF(4))) GO TO 102#   Skip void f(rel) reflections     CD20 250
HKLPNT=IPNT+IRELRF(1)#                 Hkl pointer                      CD20 251
MULPNT=IPNT+IRELRF(3)#                 Multiplicity pointer             CD20 252
STLPNT=IPNT+IRELRF(2)#                 Sin theta/lambda pointer         CD20 253
STOL=QX(STLPNT)#                                                        CD20 254
IF(IRELRF(6)==0) NSCGRP=1#             Default one scale group          CD20 255
ELSE NSCGRP=NINT(QX(IPNT+IRELRF(6)))#                                   CD20 256
REJECT=no:#                                                             CD20 257
IF(STOL<STLMIN \ STOL>STLMAX)#         Reject it as out of range        CD20 258
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CD20 259
REJECT=yes:#                                                            CD20 260
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CD20 261
SKPCNT=SKPCNT+1#                                                        CD20 262
IF(MOD(SKPCNT,SKPREF)!=0) REJECT=yes:#                                  CD20 263
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CD20 264
FOBS=QX(OPNT+IRELRF(4))#                                                CD20 265
IF(IRELRF(5)!=0) FSIG=QX(OPNT+IRELRF(5))#                               CD20 266
ELSE FSIG=1.0#                                                          CD20 267
IF(FOBS<SGCUT*FSIG) REJECT=yes:#                                        CD20 268
IF(WTREFL==no:) FSIG=1.0#              Unit weighting                   CD20 269
#                                                                       CD20 270
IF(PREVFC==yes:)#                      Use previous fc as fixed ato     CD20 271
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CD20 272
ACALC=QX(OPNT+IRELRF(8))#                                               CD20 273
BCALC=QX(OPNT+IRELRF(9))#              Q                                CD20 274
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CD20 275
ELSE IF(FXEST==yes:)#                                                   CD20 276
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CD20 277
ACALC=QX(OPNT+IRELRF(8))#                                               CD20 278
QX(OPNT+IRELRF(11))=QX(OPNT+IRELRF(8))#                                 CD20 279
BCALC=QX(OPNT+IRELRF(9))#                                               CD20 280
QX(OPNT+IRELRF(12))=QX(OPNT+IRELRF(9))#                                 CD20 281
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CD20 282
ELSE IF(FXAPP==yes:)#                                                   CD20 283
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CD20 284
ACALC=QX(OPNT+IRELRF(11))#                                              CD20 285
BCALC=QX(OPNT+IRELRF(12))#                                              CD20 286
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CD20 287
ELSE#                                                                   CD20 288
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CD20 289
ACALC=0.0#                                                              CD20 290
BCALC=0.0#                                                              CD20 291
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CD20 292
#                                                                       CD20 293
endproc:(GETREFL)#                                                      CD20 294
#                                                                       CD20 295
#                                                                       CD20 296
#                                                                       CD20 297
#                                                                       CD20 298
procedure:(GETHKLEQ)#                  Get equivalent indices and s     CD20 299
#                                                                       CD20 300
gethkl:(HKLPNT,HKL)#                   Unpack indices of reflection     CD20 301
DO I=1,3#                                                               CD20 302
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CD20 303
IF(ABS(HKL(I))>HKLMAX(I)) REJECT=yes:#                                  CD20 304
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CD20 305
#                                      #                                CD20 306
IF(REJECT==no:)#                                                        CD20 307
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CD20 308
K=STARSY#                              Set up symop pointer             CD20 309
L=STARH#                               Set up hkl equivalent pointe     CD20 310
DO I=1,NSYMOP#                                                          CD20 311
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CD20 312
DO JJ=1,3#                                                              CD20 313
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CD20 314
L=L+1#                                                                  CD20 315
QX(L)=HKL(1)*QX(K+1)+HKL(2)*QX(K+2)+HKL(3)*QX(K+3)#                     CD20 316
K=K+3#                                                                  CD20 317
IF(ABS(QX(L))>HKLMAX(JJ)) REJECT=yes:#                                  CD20 318
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CD20 319
L=L+1#                                 Calculate phase shift            CD20 320
QX(L)=HKL(1)*QX(K+1)+HKL(2)*QX(K+2)+HKL(3)*QX(K+3)#                     CD20 321
QX(L)=AMOD(QX(L)+1000.,1.0)#                                            CD20 322
K=K+3#                                                                  CD20 323
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CD20 324
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CD20 325
endproc:(GETHKLEQ)#                                                     CD20 326
#                                                                       CD20 327
#                                                                       CD20 328
#                                                                       CD20 329
#                                                                       CD20 330
procedure:(GETSCAT)#                   Compute pointers for scatter     CD20 331
#                                                                       CD20 332
K=STARFF+1#                                                             CD20 333
JJ=INT(STOL*100.)/DELFF#                                                CD20 334
FRACT=STOL*100./FLOAT(DELFF)-FLOAT(JJ)#                                 CD20 335
JJ=3+JJ+STARFF#                                                         CD20 336
DO I=1,NATYPE#                                                          CD20 337
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CD20 338
FFREAL(I)=QX(K)+QX(JJ)-FRACT*(QX(JJ)-QX(JJ+1))#                         CD20 339
#                                  REAL SCAT. OF ATOM "I"               CD20 340
FFIMAG(I)=QX(K+1)#                     Imaginary scat. of atom "i"      CD20 341
K=K+STEPFF#                                                             CD20 342
JJ=JJ+STEPFF#                                                           CD20 343
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CD20 344
#                                                                       CD20 345
endproc:(GETSCAT)#                                                      CD20 346
#                                                                       CD20 347
#                                                                       CD20 348
procedure:(PUTREFL)#                                                    CD20 349
IF(REJECT==yes:)#                                                       CD20 350
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CD20 351
QX(OPNT+IRELRF(7))=voidflg:#           Void f(calc) on output bdf       CD20 352
QX(OPNT+IRELRF(8))=voidflg:#           Void a(calc) on output bdf       CD20 353
QX(OPNT+IRELRF(9))=voidflg:#           Void b(calc) on output bdf       CD20 354
QX(OPNT+IRELRF(10))=voidflg:#          Void phase(calc) on output b     CD20 355
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CD20 356
ELSE#                                                                   CD20 357
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CD20 358
QX(OPNT+IRELRF(7))=FCALC#              F(calc) with current coordin     CD20 359
QX(OPNT+IRELRF(8))=ACALC#              A(calc)                          CD20 360
QX(OPNT+IRELRF(9))=BCALC#              B(calc)                          CD20 361
QX(OPNT+IRELRF(10))=PHCALC#            Phase(calc)                      CD20 362
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CD20 363
#                                                                       CD20 364
endproc:(PUTREFL)#                                                      CD20 365
#                                                                       CD20 366
procedure:(RETURN)#                    Overlay return for portabili     CD20 367
RETURN#                                                                 CD20 368
#                                                                       CD20 369
deleteproc:(INITIAL)#                                                   CD20 370
deleteproc:(GETREFL)#                                                   CD20 371
deleteproc:(GETHKLEQ)#                                                  CD20 372
deleteproc:(GETSCAT)#                                                   CD20 373
deleteproc:(PUTREFL)#                                                   CD20 374
deleteproc:(RETURN)#                                                    CD20 375
END#                                                                    CD20 376
#####################################################################   CD20 377
systemheader:(CD22)#                                                    CD22   1
#                                                                       CD22   2
SUBROUTINE CD22#                       Calculate derivatives and fc     CD22   3
#                                                                       CD22   4
include:(AACOMN)#                      Xtal system common               CD22   5
include:(CDCOMN)#                                                       CD22   6
#                                                                       CD22   7
# VARIABLE NAMES OF THIS ROUTINE ARE GENERALLY BUILT UP OUT OF          CD22   8
#  LETTERS THAT HAVE SPECIAL MEANING.                                   CD22   9
#  SYMBOLIC NAMES WITH 'X' REFER TO THE XTH DATA SET                    CD22  10
#  SYMBOLIC NAMES BEGINING WITH 'A' ARE THE REAL COMPONENT OF A.        CD22  11
#  COEFFICIENT BEGINNING WITH 'B' ARE THE IMAGINARY COMPONENT.          CD22  12
#  'J' MEANS THE JTH ATOM.                                              CD22  13
#  'K' THE THE KTH EQUIVALENT INDEX.                                    CD22  14
#  'P' (PRIME) MEANS THE REAL SCATTERING PART.                          CD22  15
#  'PP'(DOUBLE PRIME) MEANS THE ANOMALOUS SCATTERING PART.              CD22  16
#  'C' MEANS EXP(-THERMAL*S**2).                                        CD22  17
#  'DRV' MEANS THE PARTIAL DERIVIATIVE OF                               CD22  18
#  'SUM' OR 'SM' MEANS A SUMATION OF THE SET.                           CD22  19
#  VARIABLE 'N' IS A TEMPORARY INDEX USED FOR LOCAL SUBSCRIPTING.       CD22  20
#                                                                       CD22  21
#                                                                       CD22  22
#                                                                       CD22  23
INTEGER DRVAP#                                                          CD22  24
INTEGER DRVBP#                                                          CD22  25
INTEGER STEPDR#                        Number of variables for curr     CD22  26
INTEGER J#                                                              CD22  27
INTEGER K#                                                              CD22  28
INTEGER N#                                                              CD22  29
INTEGER STOHEQ#                                                         CD22  30
#                                                                       CD22  31
REAL APJK#                                                              CD22  32
REAL ARG#                                                               CD22  33
REAL BPJK#                                                              CD22  34
REAL CJ#                                                                CD22  35
REAL INDEX(240)#                                                        CD22  36
REAL POPFJ#                                                             CD22  37
REAL SMAPJ#                                                             CD22  38
REAL SMBPJ#                                                             CD22  39
REAL SSQRD#                                                             CD22  40
#                                                                       CD22  41
F64=4096.#                             Scale b-factors                  CD22  42
TWOPI=6.283185307#                     2*pi                             CD22  43
SSQRD=STOL**2#                         Calc. [sin(t)/lam]**2            CD22  44
SSTL64=F64*SSQRD#                                                       CD22  45
J=1#                                                                    CD22  46
#     #  COMPONENTS.                                                    CD22  47
STOHEQ=NSYMOP*10#                                                       CD22  48
STEPDR=4#                                                               CD22  49
FOR (N=STARH;N<=STOPH-1;N=N+STEPH)#    Modify symmetrically             CD22  50
DO N=STARH,STOPH-1,STEPH#                                               CD22  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD22  52
#     #  DERIVATIVE CALCULATION LOOP.                                   CD22  53
INDEX(J+1)=QX(N+1)*TWOPI#              2pi*h                            CD22  54
INDEX(J+2)=QX(N+2)*TWOPI#              2pi*k                            CD22  55
INDEX(J+3)=QX(N+3)*TWOPI#              2pi*l                            CD22  56
INDEX(J) =QX(N+4)*TWOPI#               2pi*translation component        CD22  57
#INDEX(J+4)=QX(N+1)**2#               # H*H                             CD22  58
#INDEX(J+5)=QX(N+2)**2#               # K*K                             CD22  59
#INDEX(J+6)=QX(N+3)**2#               # L*L                             CD22  60
#INDEX(J+7)=QX(N+1)*QX(N+2)#          # H*K                             CD22  61
#INDEX(J+8)=QX(N+1)*QX(N+3)#          # H*L                             CD22  62
#INDEX(J+9)=QX(N+2)*QX(N+3)#          # K*L                             CD22  63
J=J+10#                                Steheq#                          CD22  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD22  65
#                                                                       CD22  66
# CLEAR PARTIAL DERIVATIVE ARRAY                                        CD22  67
#                                                                       CD22  68
N=STOPPD-STARPD#                                                        CD22  69
IF(DCALC==yes:)movereal:(0.0,1,QX,STARPD+1,N,2)#                        CD22  70
#STOHEQ=J-STEHEQ#                   #                                   CD22  71
#                                                                       CD22  72
SMAP=0.0#                              Initialize a(h) and              CD22  73
SMBP=0.0#                              B(h) terms.                      CD22  74
#SMAPP=0.0#                           # INITIALIZEE A'(H) AND           CD22  75
#SMBPP=0.0#                           # B'(H) ANOMALOUS TERMS.          CD22  76
#                                                                       CD22  77
# GET NUMBER OF PARAMETERS IN THE ATOM LIST                             CD22  78
DRVAP=STARPD#                          Set pointers for deriv a'        CD22  79
#DRVAPP=DRVAP+NPARAM#               # SET POINTER OF A"                 CD22  80
#DRVBP=DRVAPP+NPARAM#               # SET POINTER OF DERIV. OF B'       CD22  81
DRVBP=DRVAP+NPARAM#                    Set pointer of deriv. of b'      CD22  82
#DRVBPP=DRVBP+NPARAM#               # SET POINTER OF DERIV. OF B"       CD22  83
#                                                                       CD22  84
DO J=STARAT,STOPAT-1,STEPAT#           Loop thru j atom of this         CD22  85
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD22  86
#IF(QX(J+GROFF:)<-5.0) NEXT# SLAVE ATOM, DON'T INCLUDE                  CD22  87
IF(QX(J+mvoff:)<-0.5) NEXT#            Slave or hydrogen atom, don'     CD22  88
#IF(ANIREF==NO:.OR.ANISO==NO:) USEANI=.FALSE.                           CD22  89
#ELSE IFVO:(QX(J+ARITH:(BFOFF:,+,1))) USEANI=.FALSE.#                   CD22  90
#ELSE USEANI=.TRUE.#                                                    CD22  91
#IF(.NOT.USEANI)#                                                       CD22  92
#$(#                                                                    CD22  93
N =NINT(QX(J+ppoff:+1))#               Get real sfac for this atom      CD22  94
POPFJ=QX(J+ppoff:)*FFREAL(N)#          Population*(real scattering      CD22  95
#     #  FACTOR).                                                       CD22  96
#POPFAJ=QX(J+PPOFF:)*FFIMAG(N)#       # POPULATION*(ANOM POPULATION)    CD22  97
CJ=EXP(-SSQRD*QX(J+bfoff:))#           Use isotropic b-fact             CD22  98
POPFJ=POPFJ*CJ*MULTIP#                                                  CD22  99
#POPFAJ=POPFAJ*CJ#                                                      CD22 100
#$)#                                                                    CD22 101
#     #  *(ANOM SCATTER).                                               CD22 102
SMAPJ=0.0#                             Initialize a'(h) and b'(h)       CD22 103
SMBPJ=0.0#                             Of the jth atom.                 CD22 104
#SMAPPJ=0.0#                          # INITIALIZE A"(H) AND B"(H)      CD22 105
#SMBPPJ=0.0#                          # OF THE JTH ATOM.                CD22 106
#                                                                       CD22 107
#DO K=STAHEQ,STOHEQ,STEHEQ#             # LOOP OVER EQUIVALENT INDICES  CD22 108
DO K=1,STOHEQ,10#                                                       CD22 109
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD22 110
#IF(USEANI)#                           USE ANISOTROPIC B-FACTORS        CD22 111
#$(#                                    # TOP>>>>>>>>>>>>>>>>>>>>>>>    CD22 112
#ARG=0.0#                             # INIT. ARG TO SUM ANISO.         CD22 113
##    #  TEMPERATURE FACTOR.                                            CD22 114
#JJ=J+BFOFF:#                                                           CD22 115
#KK=K+3#                            #                                   CD22 116
#DO N=1,6#                              # SUM H(IJ)*BETA(IJ)            CD22 117
#$(#                                    # TOP>>>>>>>>>>>>>>>>>>>>>>>    CD22 118
#JJ=JJ+1                                                                CD22 119
#KK=KK+1                                                                CD22 120
#ARG=ARG+INDEX(KK)*QX(JJ)#          #                                   CD22 121
#$)#                                    # BOT<<<<<<<<<<<<<<<<<<<<<<<    CD22 122
#CJ=EXP(-ARG)#                        #                                 CD22 123
#N =NINT(QX(J+PPOFF:+1))#              # GET REAL SFAC FOR THIS ATOM    CD22 124
#POPFJ=QX(J+PPOFF:)*FFREAL(N)#        # POPULATION*(REAL SCATTERING     CD22 125
#     #  FACTOR).                                                       CD22 126
#POPFAJ=QX(J+PPOFF:)*FFIMAG(N)#       # POPULATION*(ANOM POPULATION)    CD22 127
#POPFJ=POPFJ*CJ#                                                        CD22 128
#POPFAJ=POPFAJ*CJ#                                                      CD22 129
#$)#                                    # BOT<<<<<<<<<<<<<<<<<<<<<<<    CD22 130
#                                                                       CD22 131
# CALCULATE 2PI*(T'+H'X+K'Y+L'Z)                                        CD22 132
ARG=INDEX(K)+INDEX(K+1)*QX(J+xxoff:)+$#                                 CD22 133
      INDEX(K+2)*QX(J+arith:(xxoff:,+,1))+$#                            CD22 134
      INDEX(K+3)*QX(J+arith:(xxoff:,+,2))#                              CD22 135
APJK=POPFJ*COS(ARG)#                   A' and b' of jth. atom and       CD22 136
#BPPJK=POPFAJ*COS(ARG)#          # B" OF SAME                     CD2   CD22 137
BPJK=POPFJ*SIN(ARG)#                   Kth equivalent indices.          CD22 138
#APPJK=-POPFAJ*SIN(ARG)#          # A" (ANOMAL.) OF SAME           CD   CD22 139
SMAPJ=SMAPJ+APJK#                      Sm contributions of a and b      CD22 140
SMBPJ=SMBPJ+BPJK#                      Parts from equiv. indices        CD22 141
#SMAPPJ=SMAPPJ+APPJK#               # TO TOTAL A AND B COEFFS. OF       CD22 142
#SMBPPJ=SMBPPJ+BPPJK#               # JTH ATOM.                         CD22 143
#                                                                       CD22 144
IF(DCALC==yes:)#                       Start calculating derivative     CD22 145
#  EQUIVALENT INDICES.                                                  CD22 146
#                                                                       CD22 147
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD22 148
IF(QX(J+mvoff:)<0.5) NEXT#             This atom not moving             CD22 149
QX(DRVAP+1)=QX(DRVAP+1)-INDEX(K+1)*BPJK#                                CD22 150
QX(DRVAP+2)=QX(DRVAP+2)-INDEX(K+2)*BPJK#                                CD22 151
QX(DRVAP+3)=QX(DRVAP+3)-INDEX(K+3)*BPJK#                                CD22 152
QX(DRVBP+1)=QX(DRVBP+1)+INDEX(K+1)*APJK#                                CD22 153
QX(DRVBP+2)=QX(DRVBP+2)+INDEX(K+2)*APJK#                                CD22 154
QX(DRVBP+3)=QX(DRVBP+3)+INDEX(K+3)*APJK#                                CD22 155
#QX(DRVAPP+1)=QX(DRVAPP+1)+INDEX(K+1)*BPPJK#     #                      CD22 156
#QX(DRVBPP+1)=QX(DRVBPP+1)-INDEX(K+1)*APPJK#     #                      CD22 157
#QX(DRVAPP+2)=QX(DRVAPP+2)+INDEX(K+2)*BPPJK#     #                      CD22 158
#QX(DRVBPP+2)=QX(DRVBPP+2)-INDEX(K+2)*APPJK#     #                      CD22 159
#QX(DRVAPP+3)=QX(DRVAPP+3)+INDEX(K+3)*BPPJK#     #                      CD22 160
#QX(DRVBPP+3)=QX(DRVBPP+3)-INDEX(K+3)*APPJK#     #                      CD22 161
#                                                                       CD22 162
#IF(USEANI)#                                                            CD22 163
#$(#                                    # TOP>>>>>>>>>>>>>>>>>>>>>>>    CD22 164
#K1=K+3                                                                 CD22 165
#DO N=4,9#                              # DO LOOP OVER ANISOTRPIC       CD22 166
#$(#                                    # TOP>>>>>>>>>>>>>>>>>>>>>>>    CD22 167
#K1=K1+1#                                                               CD22 168
#N1=DRVAP+N#                        #                                   CD22 169
#QX(N1)=QX(N1)-INDEX(K1)*APJK#      #                                   CD22 170
#N1=DRVAPP+N#                       #                                   CD22 171
#QX(N1)=QX(N1)-INDEX(K1)*APPJK#     #                                   CD22 172
#N1=DRVBP+N#                        #                                   CD22 173
#QX(N1)=QX(N1)-INDEX(K1)*BPJK#      #                                   CD22 174
#N1=DRVBPP+N#                       #                                   CD22 175
#QX(N1)=QX(N1)-INDEX(K1)*BPPJK#     #                                   CD22 176
#$)#                                    # BOT<<<<<<<<<<<<<<<<<<<<<<<    CD22 177
#$)#                                    # BOT<<<<<<<<<<<<<<<<<<<<<<<    CD22 178
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD22 179
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD22 180
#                                                                       CD22 181
SMAP=SMAP+SMAPJ#                       Add contribution of the          CD22 182
SMBP=SMBP+SMBPJ#                       Jth atom to                      CD22 183
#SMAPP=SMAPP+SMAPPJ#        COEFFICIENTS.                  CD22 213     CD22 184
#SMBPP=SMBPP+SMBPPJ#                                                    CD22 185
#                                                                       CD22 186
IF(DCALC==yes:)#                       Now do derivative and other      CD22 187
#                 ON JTH ATOM BUT NOT ON THE EQUIVALENT INDICES.        CD22 188
#                                                                       CD22 189
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD22 190
IF(QX(J+mvoff:)<0.5) NEXT#             This atom not moving             CD22 191
#IF(.NOT.USEANI)#                      CALC DERIV OF ISO B'S            CD22 192
#$(#                                    # TOP>>>>>>>>>>>>>>>>>>>>>>>1   CD22 193
QX(DRVAP+4)=-SSTL64*SMAPJ#             Calc derivatives of scaled b     CD22 194
#QX(DRVAPP+4)=-SSTL64*SMAPPJ#         KEEP MAGNITUDE SIMILAR TO SHIFT   CD22 195
QX(DRVBP+4)=-SSTL64*SMBPJ#             On coordinates and/or betas      CD22 196
#QX(DRVBPP+4)=-SSTL64*SMBPPJ#                                           CD22 197
#$)#                                    # BOT<<<<<<<<<<<<<<<<<<<<<<<1   CD22 198
#IF(USEANI) STEPDR=9#                                                   CD22 199
#ELSE STEPDR=4#                                                         CD22 200
DRVAP=DRVAP+STEPDR#                    Increment the deriv pointers     CD22 201
#DRVAPP=DRVAPP+STEPDR#              #                                   CD22 202
DRVBP=DRVBP+STEPDR#                    To the next atom.                CD22 203
#DRVBPP=DRVBPP+STEPDR#              #                                   CD22 204
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD22 205
#                                                                       CD22 206
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD22 207
#                                                                       CD22 208
RETURN#                                                                 CD22 209
#                                                                       CD22 210
#                                                                       CD22 211
END#                                                                    CD22 212
#####################################################################   CD22 213
systemheader:(CD24)#                                                    CD24   1
#                                                                       CD24   2
SUBROUTINE CD24#                       Calculate fc's and build         CD24   3
#                                        Matrices                       CD24   4
include:(AACOMN)#                      Xtal system common               CD24   5
include:(CDCOMN)#                                                       CD24   6
REAL WEIGHT#                                                            CD24   7
REAL RADCYC#                                                            CD24   8
DATA RADCYC /0.1591549/#                                                CD24   9
#                                                                       CD24  10
WEIGHT=1.0/FSIG#                                                        CD24  11
#ACALC=ACALC+XTLSCL(NSCGRP)*(SMAP-SMBPP)#                               CD24  12
#BCALC=BCALC+XTLSCL(NSCGRP)*(SMBP+SMAPP)#                               CD24  13
#FCALC=SQRT(ACALC*ACALC+BCALC*BCALC)#                                   CD24  14
#DELF=FOBS-FCALC                                                        CD24  15
#WTDELF=DELF*WEIGHT#                    WEIGHTED DELTA(F)               CD24  16
#PHCALC=RADCYC*ATAN2(BCALC,ACALC)#                                      CD24  17
#COSA=XTLSCL(NSCGRP)*WEIGHT*ACALC/FCALC#       COMBINED SCALE,WEIGHT    CD24  18
#SINA=XTLSCL(NSCGRP)*WEIGHT*BCALC/FCALC#       COMBINED SCALE,WEIGHT    CD24  19
#ACALC=ACALC+(SMAP-SMBPP)#                                              CD24  20
#BCALC=BCALC+(SMBP+SMAPP)#                                              CD24  21
ACALC=ACALC+SMAP#                                                       CD24  22
BCALC=BCALC+SMBP#                                                       CD24  23
FCALC=SQRT(ACALC*ACALC+BCALC*BCALC)#                                    CD24  24
DELF=FOBS/XTLSCL(NSCGRP)-FCALC#                                         CD24  25
WTDELF=DELF*WEIGHT#                    Weighted delta(f)                CD24  26
PHCALC=RADCYC*ATAN2(BCALC,ACALC)#                                       CD24  27
COSA=WEIGHT*ACALC/FCALC#               Combined weight and phase in     CD24  28
SINA=WEIGHT*BCALC/FCALC#               Combined weight and phase in     CD24  29
#                                                                       CD24  30
# ADD TO SUMS FOR STATISTCAL VALUES                                     CD24  31
#                                                                       CD24  32
SUMFC(NSCGRP)=SUMFC(NSCGRP)+FCALC#                                      CD24  33
#SUMFO(NSCGRP)=SUMFO(NSCGRP)+FOBS#                                      CD24  34
SUMFO(NSCGRP)=SUMFO(NSCGRP)+FOBS/XTLSCL(NSCGRP)#                        CD24  35
SUMDF(NSCGRP)=SUMDF(NSCGRP)+ABS(DELF)#                                  CD24  36
WTSQFC(NSCGRP)=WTSQFC(NSCGRP)+(WEIGHT*FCALC)**2#                        CD24  37
#WTSQFO(NSCGRP)=WTSQFO(NSCGRP)+(WEIGHT*FOBS)**2#                        CD24  38
WTSQFO(NSCGRP)=WTSQFO(NSCGRP)+(WEIGHT*FOBS/XTLSCL(NSCGRP))**2#          CD24  39
WTSQDF(NSCGRP)=WTSQDF(NSCGRP)+WTDELF**2#                                CD24  40
NREFL(NSCGRP)=NREFL(NSCGRP)+1#                                          CD24  41
#                                                                       CD24  42
IF(DCALC==yes:)#                                                        CD24  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD24  44
J=STARPD#                                                               CD24  45
DO I=1,NPARAM#                         Calc. weighted deriv. of f's     CD24  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD24  47
J=J+1#                                                                  CD24  48
QX(J)=QX(J)*COSA+QX(J+NPARAM)*SINA#                                     CD24  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD24  50
DO I=1,NPARAM#                         Calc right side of equations     CD24  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD24  52
QX(STARMT+I)=QX(STARMT+I)+WTDELF*QX(STARPD+I)#                          CD24  53
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD24  54
# CALC REST OF NORMAL EQUATIONS FOR REFINING ON F'S                     CD24  55
# ATOM BLOCK DIAGONAL                                                   CD24  56
IVAR=4#                                                                 CD24  57
K=STARAT-STEPAT#                                                        CD24  58
M1=STARPD+1#                                                            CD24  59
N=STARMT+NPARAM#                                                        CD24  60
DO I=1,NUMATM#                         Check each atom                  CD24  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD24  62
K=K+STEPAT#                                                             CD24  63
#IF(QX(K+GROFF:)<-5.0) NEXT#         SLAVE ATOM                         CD24  64
IF(QX(K+mvoff:)<0.5) NEXT#             Non-moving atom (slave or hy     CD24  65
#IF(BNOREF==YES:) IVAR=3# DON'T REFINE B'S                              CD24  66
#ELSE IF(ANIREF==NO:) IVAR=4# REFINE ISO B'S                            CD24  67
#ELSE IF(ANIREF==YES:)#              #                                  CD24  68
#$(#                                    # TOP>>>>>>>>>>>>>>>>>>>>>>>    CD24  69
#IVAR=9#                   # MAKE ROOM FOR ANISO B'S                    CD24  70
#IFVO:(QX(K+ARITH:(BFOFF:,+,1))) IVAR=IVAR-5 # NO ANISO B FOR THIS A    CD24  71
#$)#                                    # BOT<<<<<<<<<<<<<<<<<<<<<<<    CD24  72
M2=M1+IVAR-1#                                                           CD24  73
DO J=M1,M2#                                                             CD24  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD24  75
DO J2=M1,J#                                                             CD24  76
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD24  77
N=N+1#                                                                  CD24  78
QX(N)=QX(N)+QX(J)*QX(J2)#                                               CD24  79
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD24  80
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD24  81
M1=M2+1#                                                                CD24  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD24  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD24  84
RETURN#                                                                 CD24  85
END#                                                                    CD24  86
#####################################################################   CD24  87
systemheader:(CD25)#                                                    CD25   1
#                                                                       CD25   2
SUBROUTINE CD25#                       Solve equation and calc.         CD25   3
#                                        Xtal least-squares shifts      CD25   4
include:(AACOMN)#                      Xtal system common               CD25   5
include:(CDCOMN)#                                                       CD25   6
INTEGER M,V#                                                            CD25   7
LOGICAL USEANI#                                                         CD25   8
#                                                                       CD25   9
chardata:(CD25A,[ BAD VARIANCE, ATOM      ; PARAMETER  X])#             CD25  10
chardata:(CD25B,[ BAD VARIANCE, ATOM      ; PARAMETER  Y])#             CD25  11
chardata:(CD25C,[ BAD VARIANCE, ATOM      ; PARAMETER  Z])#             CD25  12
datastuff:#                                                             CD25  13
DATA F64 /4096./#                      Rescale b-factors                CD25  14
#                                                                       CD25  15
#GOFPRV=WTSQDF/FLOAT(NREFL) #                                           CD25  16
GOFPRV=1.0#                            Temporary set to unity           CD25  17
IF(GOFPRV<=0.0) iquit:(-CD2501)#       Less reflection than paramte     CD25  18
#                                                                       CD25  19
K=STARAT-STEPAT#                                                        CD25  20
V=STARMT+1#                                                             CD25  21
M=V+NPARAM#                                                             CD25  22
DO I=1,NUMATM#                         Check each atom                  CD25  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD25  24
SIZEMT=0#                              Size matrix for the atom         CD25  25
K=K+STEPAT#                                                             CD25  26
#                                                                       CD25  27
QX(K+xpoff:)=QX(K+xxoff:)#             Move current to previous coo     CD25  28
QX(K+arith:(xpoff:,+,1))=QX(K+arith:(xxoff:,+,1))#                      CD25  29
QX(K+arith:(xpoff:,+,2))=QX(K+arith:(xxoff:,+,2))#                      CD25  30
#                                                                       CD25  31
#IF(QX(K+GROFF:)<-5.0) NEXT#        SLAVE ATOM                          CD25  32
IF(QX(K+mvoff:)<0.5) NEXT#             Non-moving atom                  CD25  33
IF(ANIREF==yes:) USEANI=.TRUE.#                                         CD25  34
ELSE USEANI=.FALSE.#                                                    CD25  35
ifvo:(QX(K+arith:(bfoff:,+,1))) USEANI=.FALSE.# No aniso b this ato     CD25  36
IF(USEANI) IVAR=9#                                                      CD25  37
ELSE IVAR=4#                           Refine iso b's                   CD25  38
# SOLVE EQUATIONS FOR CURRENT ATOM                                      CD25  39
CALL CD91(QX(M),QX(V),IVAR)#                                            CD25  40
##IF(PPRIOR>3)WRITE(6,*) I,(QX(V+II-1),II=1,IVAR)#                      CD25  41
J2=1 ; J1=M#                           Pointers to get sigmas           CD25  42
#                                                                       CD25  43
#CALC NEW TARGET COORDINATES#                                           CD25  44
# GET NEW X AND SIG(X)                                                  CD25  45
SHIFT = ABS(DAMPF*QX(V))#                                               CD25  46
SHIFT = AMIN1(SHIFT,SFTLIM(1))#                                         CD25  47
QX(K+xxoff:) = QX(K+xxoff:)+SIGN(SHIFT,QX(V))#                          CD25  48
IF(QX(J1)<=0.0)#                       Parameter has bad negative v     CD25  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD25  50
QX(J1)=-QX(J1)#                                                         CD25  51
ncodefld:(FLOAT(I),1,CD25A,250413.,1)#                                  CD25  52
writeline:(1,CD25A,NCD25A,3,3)#                                         CD25  53
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD25  54
QX(K+xsoff:)=SQRT(QX(J1)*GOFPRV) ; J2=J2+1; J1=J1+J2# Calc sigm         CD25  55
# GET NEW Y AND SIG(Y)                                                  CD25  56
SHIFT = ABS(DAMPF*QX(V+1))#                                             CD25  57
SHIFT = AMIN1(SHIFT,SFTLIM(2))#                                         CD25  58
QX(K+arith:(xxoff:,+,1))=QX(K+arith:(xxoff:,+,1))+SIGN(SHIFT,QX(V+1))#  CD25  59
IF(QX(J1)<=0.0)#                       Parameter has bad negative v     CD25  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD25  61
QX(J1)=-QX(J1)#                                                         CD25  62
ncodefld:(FLOAT(I),1,CD25B,250413.,1)#                                  CD25  63
writeline:(1,CD25B,NCD25B,3,3)#                                         CD25  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD25  65
QX(K+arith:(xsoff:,+,1))=SQRT(QX(J1)*GOFPRV) ; J2=J2+1; J1=J1+J2#       CD25  66
# GET NEW Z AND SIG(Z)                                                  CD25  67
SHIFT = ABS(DAMPF*QX(V+2))#                                             CD25  68
SHIFT = AMIN1(SHIFT,SFTLIM(3))#                                         CD25  69
QX(K+arith:(xxoff:,+,2))=QX(K+arith:(xxoff:,+,2))+SIGN(SHIFT,QX(V+2))#  CD25  70
IF(QX(J1)<=0.0)#                       Parameter has bad negative v     CD25  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD25  72
QX(J1)=-QX(J1)#                                                         CD25  73
ncodefld:(FLOAT(I),1,CD25C,250413.,1)#                                  CD25  74
writeline:(1,CD25C,NCD25C,3,3)#                                         CD25  75
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD25  76
QX(K+arith:(xsoff:,+,2))=SQRT(QX(J1)*GOFPRV)#                           CD25  77
# CONVERT SIGMA TO AVERAGE VARIANCE OF ATOM IN ANGSTROM**2              CD25  78
IF(UNITWT==no:)#                       If using sigma weighting in      CD25  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD25  80
WEIGHT=((QX(K+xsoff:)*FTOC(1)+QX(K+arith:(xsoff:,+,1))*FTOC(5)+$#       CD25  81
QX(K+arith:(xsoff:,+,2))*FTOC(9))/3.0)**2#                              CD25  82
IF(WEIGHT>25.0) WEIGHT=25.0#           Set upper limit for variance     CD25  83
QX(STARVR+I)=WEIGHT#                                                    CD25  84
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD25  85
IF(IVAR==4)#                                                            CD25  86
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD25  87
QX(K+bfoff:)=QX(K+bfoff:)+DAMPF*F64*QX(V+3)# New b-factor               CD25  88
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD25  89
ELSE IF(IVAR==9)#                      Calculate shifts in aniso b'     CD25  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD25  91
DO J=1,6#                                                               CD25  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD25  93
QX(K+J+bfoff:)=QX(K+J+bfoff:)+DAMPF*QX(V+J+2)#                          CD25  94
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD25  95
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD25  96
#                                                                       CD25  97
M=M+(IVAR*(IVAR+1))/2#                 Add elements use by current      CD25  98
V=V+IVAR#                                                               CD25  99
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD25 100
RETURN#                                                                 CD25 101
END#                                                                    CD25 102
#####################################################################   CD25 103
systemheader:(CD30)#                                                    CD30   1
#                                                                       CD30   2
SUBROUTINE CD30#                                                        CD30   3
#                                                                       CD30   4
include:(AACOMN)#                                                       CD30   5
include:(CDCOMN)#                                                       CD30   6
#                                                                       CD30   7
REAL EPS#                              Set once and passed to the m     CD30   8
DATA EPS/0.01/#                                                         CD30   9
#                                                                       CD30  10
CALL CD35(LAT1,LAT2)#                  Reset arrays of moving atoms     CD30  11
IF(WT(6) !=0. ) CALL CD40#             Set up neighbor information      CD30  12
#                                                                       CD30  13
# **** CALL CONJUGATE GRADIENT MINIMIZER                                CD30  14
#                                                                       CD30  15
EST=ESTINI#                                                             CD30  16
MCYCLE=NCYCLE#                                                          CD30  17
CALL CD48(EPOT,EST,EPS,MCYCLE,IER)#                                     CD30  18
#                                                                       CD30  19
RETURN#                                                                 CD30  20
END#                                                                    CD30  21
#####################################################################   CD30  22
systemheader:(CD35)#                                                    CD35   1
#                                                                       CD35   2
SUBROUTINE CD35(NATM1,NATM2)#                                           CD35   3
#                                                                       CD35   4
#  INITIALIZE ARRAYS NEEDED TO BEGIN REFINEMENT                         CD35   5
#                                                                       CD35   6
include:(AACOMN)#                                                       CD35   7
include:(CDCOMN)#                                                       CD35   8
INTEGER NATM1,NATM2#                                                    CD35   9
REAL RNAME#                                                             CD35  10
REAL FMT(4)#                                                            CD35  11
#                                                                       CD35  12
chardata:(WORD1,    )#                                                  CD35  13
chardata:(QHYDRO,H    )#                                                CD35  14
chardata:(MSG1, NUMBER OF  BONDS  THETAS  DIHEDS   CHIRS)#              CD35  15
chardata:(MSG2, NUMBER     TOTAL  MOVING)#                              CD35  16
chardata:(MSG3, NUMBER OF DEGREES OF FREEDOM IF BONDS FIXED)#           CD35  17
#                                                                       CD35  18
datastuff:#                                                             CD35  19
DATA FMT /160813.,240813.,320813.,400813./#                             CD35  20
IF(STARVA==0)#                         First entrance into cd35 (re     CD35  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD35  22
STEPVA=stepva:## prepare to initialize QX(.VA.) variable arrays         CD35  23
STARVA=STOPQX#                                                          CD35  24
STOPVA=0#                                                               CD35  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD35  26
#                                                                       CD35  27
# SET MOVES OF REAL ATOMS TO '0' OR '1' ACCORDING TO RANGE              CD35  28
IF(NATM1==0) NATM1=1#                                                   CD35  29
IF(NATM2==0) NATM2=NUMATM#                                              CD35  30
K=STARAT#                                                               CD35  31
DO I=1,NUMATM#                                                          CD35  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD35  33
IF(QX(K+mvoff:)>=-1.0)#                                                 CD35  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD35  35
IF(I>=NATM1 & I<=NATM2) QX(K+mvoff:)=1.0#                               CD35  36
ELSE QX(K+mvoff:)=0.0#                                                  CD35  37
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD35  38
K=K+STEPAT#                                                             CD35  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD35  40
#                                                                       CD35  41
NVAR=0#                                                                 CD35  42
K=STARAT#                                                               CD35  43
DO I=1,NUMATM#                                                          CD35  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD35  45
QX(K+kvoff:)=0.0#                                                       CD35  46
IF(QX(K+mvoff:)>0.0)#                                                   CD35  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD35  48
NVAR=NVAR+1#                                                            CD35  49
QX(K+kvoff:)=FLOAT(NVAR)#                                               CD35  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD35  51
K=K+STEPAT#                                                             CD35  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD35  53
NVAR3=NVAR*3#                                                           CD35  54
# SET ELEMENTS OF KEYVAR: FOR SLAVE:S TO MASTER:                        CD35  55
DO I=1,NSLAV#                                                           CD35  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD35  57
IAS=IFIX(slave:(I))#                                                    CD35  58
IAM=IFIX(master:(I))#                                                   CD35  59
keyvar:(IAS)=-FLOAT(IAM)#                                               CD35  60
QX(STARVR+IAS)=QX(STARVR+IAM)#         Set variance of slave to mas     CD35  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD35  62
#                                                                       CD35  63
J=0#                                                                    CD35  64
# ****  INITIALIZE INDEX OF LAST MOVING PROTEIN ATOM (NVARP)            CD35  65
NVARP=0#                                                                CD35  66
IF(NATP>=1)#                                                            CD35  67
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD35  68
DO I=1,NATP#                                                            CD35  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD35  70
INV=NATP-I+1#                                                           CD35  71
NVARP=IFIX(keyvar:(INV))#                                               CD35  72
IF(NVARP>0) BREAK#                                                      CD35  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD35  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD35  75
NVARP1=NVARP+1#                                                         CD35  76
#                                                                       CD35  77
# CONVERT FRACTIONAL TO CARTESIAN IF NECESSARY                          CD35  78
#                                                                       CD35  79
IF(ORTHOG==no:)#                                                        CD35  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD35  81
ORTHOG=yes:#                                                            CD35  82
J=STARAT+xxoff:#                                                        CD35  83
DO L=1,NUMATM#                                                          CD35  84
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD35  85
CALL CD01(FTOC,QX(J),QX(J))#                                            CD35  86
J=J+STEPAT#                                                             CD35  87
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD35  88
J=STARAT+xpoff:#                                                        CD35  89
DO L=1,NUMATM#                                                          CD35  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD35  91
CALL CD01(FTOC,QX(J),QX(J))#                                            CD35  92
J=J+STEPAT#                                                             CD35  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD35  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD35  95
# STORE APPROPRIATE COORDINATES IN ARRAYS X0 AND X2                     CD35  96
IF(EXTREF==no: & XTLREF==no:)#         Move coordinate into origin      CD35  97
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD35  98
DO L=1,NUMATM#                                                          CD35  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD35 100
movereal:(x:(1,L),1,xp:(1,L),1,3,0)#                                    CD35 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD35 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD35 103
DO L=1,NUMATM#                                                          CD35 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CD35 105
I=IFIX(keyvar:(L))#                                                     CD35 106
IF(I>0)#                                                                CD35 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CD35 108
#      DO J=1,3                          #                              CD35 109
#        $( #                                                           CD35 110
#        X0:(J,I)=XP:(J,L)  #                                           CD35 111
#        X2:(J,I)=X:(J,L)  #                                            CD35 112
#        $) # DO J                                                      CD35 113
IF(ORTHOG==no:)#                                                        CD35 114
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CD35 115
CALL CD01(FTOC,xp:(1,L),x0:(1,I))#                                      CD35 116
CALL CD01(FTOC,x:(1,L),x2:(1,I))#                                       CD35 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CD35 118
ELSE#                                                                   CD35 119
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CD35 120
movereal:(xp:(1,L),1,x0:(1,I),1,3,0)#                                   CD35 121
movereal:(x:(1,L),1,x2:(1,I),1,3,0)#                                    CD35 122
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CD35 123
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CD35 124
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD35 125
# MODIFY HYDROGEN WEIGHTS                                               CD35 126
# MODIFY OTHERS IF UNIT WEIGHTS WANTED                                  CD35 127
# SET SIGMA WEIGHTS AVERAGE AROUND 1.0                                  CD35 128
VRAVE=0.0#                                                              CD35 129
VRNUM=0.0#                                                              CD35 130
DO L=1,NUMATM#                                                          CD35 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CD35 132
RNAME=atkind:(L)#                                                       CD35 133
movertoc:(RNAME,1,WORD1,1,4,0)#                                         CD35 134
compchar:(WORD1,1,QHYDRO,1,1,1,1,KEY)#                                  CD35 135
IF(KEY!=0) winv:(L)=-1.0#              Tag hydrogens                    CD35 136
ELSE IF(UNITWT==yes:) winv:(L)=1.0#                                     CD35 137
ELSE#                                  Calculate average weight         CD35 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CD35 139
VRAVE=VRAVE+SQRT(winv:(L))#                                             CD35 140
VRNUM=VRNUM+1.0#                                                        CD35 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CD35 142
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CD35 143
IF(UNITWT==no:)#                                                        CD35 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CD35 145
VRAVE=(VRNUM/VRAVE)**2#                                                 CD35 146
DO L=1,NUMATM#                         Modify by mean sigma             CD35 147
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CD35 148
IF(winv:(L)<0.0) winv:(L)=1/WT(8)#     Set hydrogen weight              CD35 149
ELSE winv:(L)=winv:(L)*VRAVE#                                           CD35 150
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CD35 151
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CD35 152
IF(NATP>=1)#                                                            CD35 153
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CD35 154
IF(STOPVA==0)#                                                          CD35 155
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CD35 156
STOPVA=STARVA+NUMATM*STEPVA#           Reset the end of the qx arra     CD35 157
STOPQX=STOPVA#                                                          CD35 158
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CD35 159
# INITIALIZE ARRAYS NEEDED TO CALCULATE BONDED FORCES.                  CD35 160
#                                                                       CD35 161
CALL CD36#                             -old kvtran                      CD35 162
CALL CD37#                             -old saver                       CD35 163
#                                                                       CD35 164
writeline:(1,MSG1,NMSG1,3,3)#                                           CD35 165
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   CD35 166
ncodefld:(FLOAT(NB),1,CHROT,FMT(1),1)#                                  CD35 167
ncodefld:(FLOAT(NT),1,CHROT,FMT(2),1)#                                  CD35 168
ncodefld:(FLOAT(ND),1,CHROT,FMT(3),1)#                                  CD35 169
ncodefld:(FLOAT(NCHIR),1,CHROT,FMT(4),1)#                               CD35 170
writeline:(0,0,0,1,3)#                                                  CD35 171
writeline:(1,MSG2,NMSG2,3,3)#                                           CD35 172
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   CD35 173
ncodefld:(FLOAT(NUMATM),1,CHROT,FMT(1),1)#                              CD35 174
ncodefld:(FLOAT(NVAR),1,CHROT,FMT(2),1)#                                CD35 175
writeline:(0,0,0,1,3)#                                                  CD35 176
NVARX=(3*NVARP-NB)+(NVAR-NVARP)*2#                                      CD35 177
writeline:(1,MSG3,NMSG3,3,3)#                                           CD35 178
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   CD35 179
ncodefld:(FLOAT(NVARX),1,CHROT,FMT(1),1)#                               CD35 180
writeline:(0,0,0,1,3)#                                                  CD35 181
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CD35 182
#                                                                       CD35 183
RETURN#                                                                 CD35 184
END#                                                                    CD35 185
#####################################################################   CD35 186
systemheader:(CD36)#                                                    CD36   1
#                                                                       CD36   2
# BASED ON OLD 'KVTRAN' SUBROUTINE OF JAN HERMANS                       CD36   3
# TRANSLATE INFO IN KEYVAR: TO THE NEW DATASTRUCTURES VPTR AND ISLAVE   CD36   4
#                                                                       CD36   5
# INPUT:     INTEGER  NUMATM, KEYVAR:                                   CD36   6
#   NUMATM:   THE NUMBER OF ENTRIES IN KEYVAR:.                         CD36   7
#   KEYVAR:: FOR VARIABLE ATOMS, GIVES THE KEY TO XV AND G. FOR         CD36   8
#           SLAVES, GIVES KEY OF MASTER. FOR FIXED NONSLAVES, GIVES 0   CD36   9
#           VALUES STORED IN AT SECTION(+KVOFF:) OF QX ARRAY            CD36  10
#                                                                       CD36  11
# OUTPUT:    INTEGER VPTR                                               CD36  12
#   VPTR:  FOR FIXED ATOMS AND THEIR SLAVES,0. FOR VARIABLE ATOMS       CD36  13
#          AND THEIR SLAVES, GIVES THE KEY TO XV AND G.                 CD36  14
#          VALUES STORED IN VA SECTION(+VPOFF:) OF QX ARRAY             CD36  15
#                                                                       CD36  16
#            CODED SEPT 15, 82 BY MIKE CARSON                           CD36  17
#                                                                       CD36  18
SUBROUTINE CD36#                                                        CD36  19
include:(AACOMN)#                                                       CD36  20
include:(CDCOMN)#                                                       CD36  21
#                                                                       CD36  22
INTEGER J,K#                                                            CD36  23
#                                                                       CD36  24
DO J=1,NUMATM#                                                          CD36  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD36  26
K=IFIX(keyvar:(J))#                                                     CD36  27
IF(K<0)#                                                                CD36  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD36  29
K=IFIX(keyvar:(-K))#                                                    CD36  30
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD36  31
vptr:(J)=FLOAT(K)#                                                      CD36  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD36  33
RETURN#                                                                 CD36  34
END#                                                                    CD36  35
#####################################################################   CD36  36
systemheader:(CD37)#                                                    CD37   1
#                                                                       CD37   2
#  IDENTIFY THE BONDS, THETA PIVOT SETS, AND DIHEDRAL ANGLES.           CD37   3
#  BASED ON NEW 'SAVER' SUBROUTINE OF JAN HERMANS (OCT 85)              CD37   4
#  ALL SAVING IS DONE BY "ADDER" SUBROUTINES                            CD37   5
#                                                                       CD37   6
# ALGORITHM DESCRIPTION:                                                CD37   7
#    IF BONDS, BOND ANGLES AND DIHEDRALS CONTAIN ANY SLAVE(S),          CD37   8
#       TAKE CARE TO AVOID SAVING THE SAME CONFIGURATION TWICE:         CD37   9
#                                                                       CD37  10
#    THE ELEMENT (BOND, ANGLE OR DIHEDRAL MUST HAVE>=1 REAL ATOM        CD37  11
#    IF THERE ARE ANY SLAVES IN THE SET:                                CD37  12
#      IF THE MASTER OF THAT SLAVE (IS) WHICH IS BONDED TO A REAL ATOM  CD37  13
#      OCCURS EARLIER IN THE TREE THAN ITS MASTER, I.E., IF-KEYVAR:(IS  CD37  14
#      THEN THE  CONSTRAINTS ARE SAVED.                                 CD37  15
#      WITH THIS CHANGE, DICTIONARIES WITH DOUBLE AND SINGLE OVERLAP AT CD37  16
#      CLOSURES WILL BOTH WORK. HOWEVER, IF SINGLE OVERLAP IS USED,     CD37  17
#      SLAVES SHOULD BE PUT AS FAR DOWN THE MOLECULE AS POSSIBLE        CD37  18
#CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC CD37  19
#                                                                       CD37  20
#    KEYVAR: FOR REAL MOVING ATOMS, A MAPPING FROM TREE(*) AND X(*)     CD37  21
#            TO FORCE(*), XV(*), ETC.. FOR SLAVES KEYVAR:(IS)=-MASTER(I CD37  22
#    VPTR:   FOR ALL MOVING ATOMS, MAPPING FROM TREE                    CD37  23
#            TO XV AND FORCE. FOR NON-MOVING ATOMS, 0.                  CD37  24
#    SLAVES: IDENTIFIED BY TESTING GRP:==-9                             CD37  25
#                                                                       CD37  26
#  PIVOT SET: THE FIRST ENTRY IS THE NUMBER OF ATOMS IN THE PIVOT SET.  CD37  27
#  IF THE SET CONTAINS THE BACKCHAIN ATOM OF THE PIVOT IT IS THE SECOND CD37  28
#  ENTRY. THE PIVOT IS ALWAYS THE LAST ENTRY. THE OTHER ENTRIES ARE     CD37  29
#  ALL THE OTHER ATOMS BONDED TO THE PIVOT. PIVOT SETS THAT CONTAIN     CD37  30
#  ONLY TWO ATOMS ARE NOT CONSIDERED. (IN ARRAY "PIVSET")               CD37  31
#                                                                       CD37  32
#  SAVER CALLED BY:  CD35                                               CD37  33
#  SAVER CALLS:  ADDCHI, $(ADDIHE,  ADDBO, ADDTHE$)                     CD37  34
#   CD37         CD39  ,           CD38                                 CD37  35
#                                                                       CD37  36
####################################################################### CD37  37
SUBROUTINE CD37#                                                        CD37  38
include:(AACOMN)#                                                       CD37  39
include:(CDCOMN)#                                                       CD37  40
#                                                                       CD37  41
# INTERNAL VARIABLES:                                                   CD37  42
INTEGER   KS,KF#                       Ks,kf: keys to dict2             CD37  43
INTEGER   ATOM#                        Atom:the atom index and loop     CD37  44
INTEGER   BACKAT#                      Backat: atom's backchain bon     CD37  45
INTEGER   BBAT#                        Bbat:   backat's backchain b     CD37  46
INTEGER   DUMMY#                                                        CD37  47
INTEGER   FOBBAT#                      Fobbat: bbat's primary forwa     CD37  48
INTEGER   STACK(6)#                    The array of keys of atoms b     CD37  49
INTEGER   PIVSET(6)#                   Pivot set passed to addthe       CD37  50
INTEGER   N#                           The number atoms in stack        CD37  51
INTEGER   TEMAT#                       Temat:temporary atom key hol     CD37  52
INTEGER   FORAT#                       Temporary holder for forward     CD37  53
LOGICAL   SLAVA,SLAVB,SLAVBB,SLAVT#    Is a, b or b(b) a slave?         CD37  54
LOGICAL   FIXED#                       Is backchain bond a fixed di     CD37  55
LOGICAL   BADCUT#                      Is cut bad? (real-slave, sla     CD37  56
LOGICAL SOMERL#                        Some atom in the pivot set i     CD37  57
LOGICAL SOMEV#                         Some atom in the pivot set i     CD37  58
DATA PI/3.141592654/#                                                   CD37  59
#                                                                       CD37  60
STEPBO=stepbo:#                        Set up pertinent steps           CD37  61
STEPTH=stepth:#                                                         CD37  62
STEPDI=stepdi:#                                                         CD37  63
STEPCS=stepcs:#                                                         CD37  64
# SET SOME TEMPORARY VALUES FOR THE QX POSITONS                         CD37  65
# THESE WILL BE RECALCULATED AT THE END OF THE ROUTINE                  CD37  66
STARBO=STOPQX#                                                          CD37  67
STOPQX=STARBO+2*NUMATM*STEPBO#                                          CD37  68
STARTH=STOPQX#                                                          CD37  69
STOPQX=STARTH+2*NUMATM*STEPTH#                                          CD37  70
STARDI=STOPQX#                                                          CD37  71
STOPQX=STARDI+2*NUMATM*STEPDI#                                          CD37  72
STARCS=STOPQX#                                                          CD37  73
STOPQX=STARCS+NUMATM*STEPCS#                                            CD37  74
#                                                                       CD37  75
# PROCESS ALL THE ATOMS IN THE PROTEIN (NATP)                           CD37  76
NB=0 ; NT=0 ; ND=0 ; NCHIR=0 ; NRO=0#                                   CD37  77
DO ATOM=1,NATP $(#                     Begin loop over atoms            CD37  78
SOMEV=(vptr:(ATOM)!=0) ; SLAVA=(grp:(ATOM)==-9.)#                       CD37  79
SOMERL=!SLAVA#                                                          CD37  80
N=1 ; BACKAT=backchain:(ATOM) ; SLAVB=.FALSE.# In case there is no b    CD37  81
#--------------------------                                             CD37  82
REPEAT#                                                                 CD37  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD37  84
IF(BACKAT<1) BREAK#                                                     CD37  85
IF(vptr:(BACKAT)!=0) SOMEV=.TRUE.#                                      CD37  86
SLAVB=(grp:(BACKAT)==-9.)#                                              CD37  87
IF(!SLAVB) SOMERL=.TRUE.#                                               CD37  88
IF(SLAVA&!SLAVB)#                                                       CD37  89
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD37  90
IF(ATOM<-keyvar:(ATOM)) BREAK#         Bad cut                          CD37  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD37  92
# SAVE IT IN BOSAVE. PLACE THE BACK CHAIN ATOM'S KEY ON STACK.          CD37  93
N=N+1 ; STACK(N)=BACKAT#                                                CD37  94
IF(SOMEV&SOMERL)#                                                       CD37  95
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD37  96
# CALL ADDBON (ATOM,BACKAT)                                             CD37  97
CALL CD38 (1,ATOM,BACKAT,DUMMY,DUMMY,DUMMY)#                            CD37  98
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD37  99
FIXED=.FALSE.#                                                          CD37 100
ITEMP=keydict:(BACKAT)#                                                 CD37 101
ifeq:(barr:(2,ITEMP),0.0) FIXED=.TRUE.#                                 CD37 102
# BOND TO BACK(BACK)                                                    CD37 103
# SAVE ALL DIHEDRALS WITH 'ATOM' AS THE FORWARDMOST ATOM                CD37 104
IF(!FIXED&(forwchain:(BACKAT)!=ATOM)) BREAK# Fixed or main variable     CD37 105
#  FIND AT-BACK-BBACK-BACK(BBACK), WHICH MUST BE SAVED IN               CD37 106
#  BOTH THE FIXED AND FLEXIBLE CASES.                                   CD37 107
BBAT=backchain:(BACKAT)#                                                CD37 108
IF(BBAT<1) BREAK#                                                       CD37 109
SLAVBB=(grp:(BBAT)==-9.)#                                               CD37 110
IF(SLAVB&!SLAVBB)#                                                      CD37 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD37 112
IF(BACKAT<-keyvar:(BACKAT)) BREAK#                                      CD37 113
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD37 114
# NO DIHEDRALS IF B-BB IS A BAD CUT                                     CD37 115
TEMAT=backchain:(BBAT)#                Triple backchain                 CD37 116
IF(TEMAT>=1)#                                                           CD37 117
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD37 118
SLAVT=(grp:(TEMAT)==-9.) ; IF(SLAVT) BREAK#                             CD37 119
IF(SOMEV \ ((vptr:(BBAT) !=0) \ (vptr:(TEMAT) !=0)))#                   CD37 120
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD37 121
BADCUT=.FALSE. ; IF(SLAVBB) BADCUT=(BBAT<-keyvar:(BBAT))#               CD37 122
#IF(!BADCUT) CALL ADDIHE(TEMAT,BBAT,BACKAT,ATOM)                        CD37 123
IF(!BADCUT) CALL CD38(3,TEMAT,BBAT,BACKAT,ATOM,DUMMY)#                  CD37 124
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD37 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD37 126
IF(SLAVBB) BREAK#                                                       CD37 127
IF(!FIXED) BREAK#                                                       CD37 128
#  FIND OTHER DIHEDRALS THAT MUST BE SAVED IN THE FIXED CASE.           CD37 129
#  THESE ARE: ATOM-BACK-BBACK-(ALL CHAINS EXCEPT MAIN TO BBACK)         CD37 130
#  (DON'T SAVE BACKAT-BBAT-BACKAT-ATOM)                                 CD37 131
FOBBAT=forwchain:(BBAT)#               Forwchain: is max.               CD37 132
FOR (TEMAT=BBAT+1;TEMAT<=FOBBAT;TEMAT=TEMAT+1)#                         CD37 133
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD37 134
IF(backchain:(TEMAT)!=BBAT) NEXT#                                       CD37 135
IF(TEMAT==BACKAT) NEXT#                                                 CD37 136
IF(SOMEV\((vptr:(BBAT)!=0)\(vptr:(TEMAT)!=0)))#                         CD37 137
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD37 138
BADCUT=.FALSE.#                                                         CD37 139
IF(grp:(TEMAT)==-9.) BADCUT=(TEMAT<-keyvar:(TEMAT))#                    CD37 140
IF(!BADCUT) CALL CD38(3,TEMAT,BBAT,BACKAT,ATOM,DUMMY)#                  CD37 141
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD37 142
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD37 143
BREAK#                                                                  CD37 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD37 145
#--------------------------                                             CD37 146
REPEAT#                                                                 CD37 147
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD37 148
IF(SLAVB) BREAK#                       Everything is slave in that      CD37 149
# NOW WE SEARCH FOR PIVOT SETS (3 ATOMS TIED TO 1 CENTRAL ONE)          CD37 150
# THESE GENERATE BONDANGLE CONSTRAINTS AND, IF PLANAR,                  CD37 151
# PLANARITY CONSTRAINTS                                                 CD37 152
FORAT=forwchain:(ATOM)#                                                 CD37 153
IF(FORAT==0) BREAK#                    Need at least 1 forw. chain      CD37 154
FOR (TEMAT=ATOM+1;TEMAT<=FORAT;TEMAT=TEMAT+1)#                          CD37 155
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD37 156
IF(backchain:(TEMAT)!=ATOM) NEXT#                                       CD37 157
SLAVT=(grp:(TEMAT)==-9.) ; BADCUT=.FALSE.#                              CD37 158
IF(SLAVT&!SLAVA) BADCUT=(TEMAT<-keyvar:(TEMAT))#                        CD37 159
IF(!BADCUT)#                                                            CD37 160
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD37 161
IF(vptr:(TEMAT)!=0) SOMEV=.TRUE.#                                       CD37 162
N=N+1 ; STACK(N)=TEMAT#                Put the forward chain on the     CD37 163
IF(!SLAVT) SOMERL=.TRUE.#                                               CD37 164
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD37 165
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD37 166
# IF THE PIVOT SET CONTAINS SOME VARIABLE BONDANGLES, SAVE IT.          CD37 167
IF(!(SOMEV&SOMERL)) BREAK#                                              CD37 168
N=N+1#                                                                  CD37 169
IF(N<4) BREAK#                         Must have at least 3 atoms f     CD37 170
STACK(N)=ATOM ; STACK(1)=N-1#                                           CD37 171
IF(N>=5 & !SLAVB & SLAVA) $(#          Very special case, in which      CD37 172
# MUST BE SPLIT TO AVOID THETA FORMED BY 3 SLAVES                       CD37 173
DO K=3,N-1#                                                             CD37 174
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CD37 175
PIVSET(1)=3 ; PIVSET(2)=STACK(2)#                                       CD37 176
PIVSET(3)=STACK(K) ; PIVSET(4)=ATOM#                                    CD37 177
CALL CD38(2,DUMMY,DUMMY,DUMMY,DUMMY,PIVSET)#                            CD37 178
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD37 179
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD37 180
ELSE#                                  Most often:                      CD37 181
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CD37 182
DO J=1,N#                                                               CD37 183
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CD37 184
PIVSET(J)=STACK(J)#                                                     CD37 185
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CD37 186
CALL CD38(2,DUMMY,DUMMY,DUMMY,DUMMY,PIVSET)#                            CD37 187
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CD37 188
IF(N<5) BREAK#                         Need 4 atoms for rho             CD37 189
# SAVE THE PLANAR PIVOT SET TYPE DIHEDRALS AND CHIRAL CENTERS           CD37 190
IF(STACK(2)>ATOM) BREAK#               Need the backchain of pivot      CD37 191
DO J1=4,N-1#                                                            CD37 192
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CD37 193
KF=keydict:(STACK(J1))#                                                 CD37 194
DO J2=3,J1-1#                                                           CD37 195
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CD37 196
KS=keydict:(STACK(J2))#                                                 CD37 197
IF(ABS(PI-ABS(dict2:(3,KF)-dict2:(3,KS)))>=1.0E-3)#                     CD37 198
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CD37 199
CALL CD39(STACK(J1),ATOM,BACKAT,STACK(J2))#                             CD37 200
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CD37 201
ELSE#                                                                   CD37 202
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CD37 203
CALL CD38(3,STACK(J1),ATOM,BACKAT,STACK(J2),DUMMY)#                     CD37 204
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CD37 205
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CD37 206
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CD37 207
BREAK#                                                                  CD37 208
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD37 209
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD37 210
#+++++++++                                                              CD37 211
#    COMPRESS THE QX ARRAY                                              CD37 212
STOPBO=STARBO+NB*STEPBO#                                                CD37 213
NTINFO=NT*STEPTH#                                                       CD37 214
FOR( I=1; I<=NTINFO; I=I+1 )#                                           CD37 215
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CD37 216
QX(STOPBO+I)=QX(STARTH+I)#                                              CD37 217
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CD37 218
STARTH=STOPBO#                                                          CD37 219
STOPTH=STARTH+NTINFO#                                                   CD37 220
NDINFO=ND*STEPDI#                                                       CD37 221
FOR( I=1; I<=NDINFO; I=I+1 )#                                           CD37 222
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CD37 223
QX(STOPTH+I)=QX(STARDI+I)#                                              CD37 224
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CD37 225
STARDI=STOPTH#                                                          CD37 226
STOPDI=STARDI+NDINFO#                                                   CD37 227
NCINFO=NCHIR*STEPCS#                                                    CD37 228
FOR( I=1; I<=NCINFO; I=I+1 )#                                           CD37 229
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CD37 230
QX(STOPDI+I)=QX(STARCS+I)#                                              CD37 231
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CD37 232
STARCS=STOPDI#                                                          CD37 233
STOPCS=STARCS+NCINFO#                                                   CD37 234
STOPQX=STOPCS#                         Set new end of available qx      CD37 235
#                                                                       CD37 236
RETURN#                                                                 CD37 237
END#                                                                    CD37 238
#####################################################################   CD37 239
systemheader:(CD38)#                                                    CD38   1
#                                                                       CD38   2
#   THIS SUBROUTINE ADDS 1 OR SEVERAL (FOR ADDTHE) ELEMENT(S)           CD38   3
#   TO THE SAVE [AND IDE] ARRAYS, UPDATING THE COUNTERS                 CD38   4
#   NB, NT, ND, [AND NRO]   OCT 85                                      CD38   5
#   SWITCH NOZEROVAL_:                                                  CD38   6
#     IF OFF, ZERO-ENERGY TERMS ARE SAVED (FOR SHOW+TELL)               CD38   7
#     IF ON, ZERO-ENERGY TERMS ARE DROPPED (FOR CALCULATIONS)           CD38   8
macro:(nozeroval:,$1)#                                                  CD38   9
#                                                                       CD38  10
SUBROUTINE CD38(INX,A,B,C,D,PIVSET)#                                    CD38  11
include:(AACOMN)#                                                       CD38  12
include:(CDCOMN)#                                                       CD38  13
#                                                                       CD38  14
INTEGER INX#                           If==1->bond,==2->theta           CD38  15
INTEGER A,B,C,D#                       Atoms defining element for 1     CD38  16
INTEGER PIVSET(6)#                     Element defining bond angles     CD38  17
#                                                                       CD38  18
IF(INX==1)## BONDS                                                      CD38  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD38  20
NB=NB+1#                                                                CD38  21
bosave:(1,NB)=A#                                                        CD38  22
bosave:(2,NB)=B#                                                        CD38  23
## kd1=KEYDIC_(atom)                                                    CD38  24
## boide(1,nb)=BOND_(kd1) ; boide(2,nb)=KFBOND_(kd1)                    CD38  25
## NOZEROVAL_([if (boide(2,nb)==0.) nb=nb-1])                           CD38  26
RETURN#                                                                 CD38  27
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD38  28
IF(INX==2)# ## ANGLES                                                   CD38  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD38  30
NT=NT+1#                                                                CD38  31
N=PIVSET(1)+1#                                                          CD38  32
## write (6,*) 'PIVOT',pivset(n)                                        CD38  33
DO J=1,N#                                                               CD38  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD38  35
thesav:(J,NT)=PIVSET(J)#                                                CD38  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD38  37
RETURN#                                                                 CD38  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD38  39
IF(INX==3)# ## DIHEDRALS                                                CD38  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD38  41
ND=ND+1#                                                                CD38  42
disave:(1,ND)=A#                                                        CD38  43
disave:(2,ND)=B#                                                        CD38  44
disave:(3,ND)=C#                                                        CD38  45
disave:(4,ND)=D#                                                        CD38  46
RETURN#                                                                 CD38  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD38  48
END#                                                                    CD38  49
#####################################################################   CD38  50
systemheader:(CD39)#                                                    CD39   1
#                                                                       CD39   2
#   TEST A NON-PLANAR BRANCH DIHEDRAL FLAGGED BY SUBR. SAVER            CD39   3
#   TO SEE IF IT IS A CHIRAL CENTER.  IF SO, ENTER THE 4 ATOMS          CD39   4
#   INTO THE ARRAY CHISAV, FOR LATER PROCESSING BY CHIFOR.              CD39   5
#   PARAMETERS ARE THE FOUR ATOMS IN QUESTION.                          CD39   6
#   TEST IS: IF EITHER FORW. CHAIN IS A HYDROGEN-NO GO                  CD39   7
#      IF 2 FORW.CHAINS HAVE DIFFERENT FIRST 2 CHAR IN ATOM NAME _ GO   CD39   8
#      IF NOT, GET MAIN FORW. CHAIN OF THE 2 FORW CHAINS, AND:          CD39   9
#      IF BOTH ARE ZERO-NO GO; IF ONLY ONE IS ZERO-GO                   CD39  10
#      FINALLY, IF NEITHER ZERO, THEN IF FIRST 1 CHAR. OF THEIR         CD39  11
#      NAMES IS THE SAME-NO GO.  ELSE,-GO.                              CD39  12
#                                                                       CD39  13
#  BASED ON "ADDCHI" SUBROUTINE OF JAN HERMANS                          CD39  14
#   CONVERTED TO RATMAC BY MIKE CARSON,  SETP16,1982                    CD39  15
# ADDCHI CALLED BY:  SAVER                                              CD39  16
# ADDCHI CALLS:  ADDIHE,  NAMAT1,NAMAT2                                 CD39  17
#                                                                       CD39  18
SUBROUTINE CD39(FORAT,ATOM,BACKAT,FORATX)#                              CD39  19
include:(AACOMN)#                                                       CD39  20
include:(CDCOMN)#                                                       CD39  21
#                                                                       CD39  22
INTEGER FORAT,ATOM,BACKAT,FORATX#                                       CD39  23
INTEGER FFOR,FFORX#                                                     CD39  24
REAL RNAME1, RNAME2#                                                    CD39  25
#                                                                       CD39  26
chardata:(WORD1,    )#                                                  CD39  27
chardata:(WORD2,    )#                                                  CD39  28
chardata:(QHYDRO,H    )#                                                CD39  29
#                                                                       CD39  30
datastuff:#                                                             CD39  31
#                                                                       CD39  32
#  ELIMINATE THE SYMMETRICAL CASES                                      CD39  33
#  TEST IF EITHER FORW ATOM IS A HYDROGEN.                              CD39  34
RNAME1=atkind:(FORAT)#                                                  CD39  35
movertoc:(RNAME1,1,WORD1,1,4,0)#                                        CD39  36
compchar:(WORD1,1,QHYDRO,1,1,1,1,KEY)#                                  CD39  37
IF(KEY!=0) RETURN#                     As it was a hydrogen             CD39  38
#                                                                       CD39  39
RNAME2=atkind:(FORATX)#                                                 CD39  40
movertoc:(RNAME2,1,WORD2,1,4,0)#                                        CD39  41
compchar:(WORD1,1,QHYDRO,1,1,1,1,KEY)#                                  CD39  42
IF(KEY!=0) RETURN#                     As it was a hydrogen             CD39  43
#                                                                       CD39  44
#  IF NAMES HAVE DIFFERENT FIRST 2 CHAR., ASSUME ASYMMETRY              CD39  45
compchar:(WORD1,1,WORD2,1,2,2,2,KEY)#                                   CD39  46
IF(KEY!=0)#                            First two chars the same         CD39  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD39  48
FFOR=IFIX(forwchain:(FORAT))#                                           CD39  49
FFORX=IFIX(forwchain:(FORATX))#                                         CD39  50
#  TEST WHAT IS CONNECTED TO THE TWO FORAT'S                            CD39  51
IF( FFOR==0 & FFORX==0) RETURN#                                         CD39  52
#  ONE ZERO, THE OTHER NOT=ASYMMETRY                                    CD39  53
IF( FFOR !=0 & FFORX !=0)#                                              CD39  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD39  55
#IF(NAMAT1(FFOR)==NAMAT1(FFORX)) RETURN  #                              CD39  56
RNAME1=atname:(FFOR)#                                                   CD39  57
movertoc:(RNAME1,1,WORD2,1,4,0)#                                        CD39  58
RNAME2=atname:(FFORX)#                                                  CD39  59
movertoc:(RNAME2,1,WORD2,1,4,0)#                                        CD39  60
compchar:(WORD1,1,WORD2,1,1,1,1,KEY)#                                   CD39  61
IF(KEY!=0) RETURN#                     First character the same         CD39  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD39  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD39  64
#             SAVE INFORMATION FOR THE CHIRAL CENTER                    CD39  65
NCHIR=NCHIR+1#                                                          CD39  66
chisav:(1,NCHIR)=FLOAT(FORAT)#                                          CD39  67
chisav:(2,NCHIR)=FLOAT(ATOM)#                                           CD39  68
chisav:(3,NCHIR)=FLOAT(BACKAT)#                                         CD39  69
chisav:(4,NCHIR)=FLOAT(FORATX)#                                         CD39  70
#                                                                       CD39  71
RETURN#                                                                 CD39  72
#                                                                       CD39  73
END#                                                                    CD39  74
#####################################################################   CD39  75
systemheader:(CD40)#                                                    CD40   1
#                                                                       CD40   2
#    UPDATES ARRAY X, CONFIGURES GROUPS (ONCE)#                         CD40   3
#    CALLS FIXH2O AND NAYBOR#                                           CD40   4
#  =OLD PREPAR#                                                         CD40   5
#                                                                       CD40   6
SUBROUTINE CD40#                                                        CD40   7
include:(AACOMN)#                                                       CD40   8
include:(CDCOMN)#                                                       CD40   9
#                                                                       CD40  10
LOGICAL NEW#                                                            CD40  11
DATA NEW/.TRUE./#                                                       CD40  12
#                                                                       CD40  13
### update positions x after possible changes in X0:#                   CD40  14
DO IAT=1,NUMATM#                                                        CD40  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD40  16
IV=keyvar:(IAT)#                                                        CD40  17
IF(IV>0)#                                                               CD40  18
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD40  19
DO J=1,3#                                                               CD40  20
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD40  21
x:(J,IAT)=x0:(J,IV)#                                                    CD40  22
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD40  23
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD40  24
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD40  25
#                                                                       CD40  26
###  skip the remainder if no nonbonded terms to be calculated#         CD40  27
IF( WT(6)==0.)#                                                         CD40  28
RETURN#                                                                 CD40  29
#                                                                       CD40  30
IF(NEW)#                                                                CD40  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD40  32
NEW=.FALSE.#                                                            CD40  33
### for faster execution when kdiag=yes, compress matrices#             CD40  34
MTYP0=NTYP+1#                                                           CD40  35
IF(KDIAG==yes:)#                                                        CD40  36
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD40  37
KDIAG=2 ; LL1=MTYP0#                                                    CD40  38
DO I=1,LL1#                                                             CD40  39
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD40  40
rot:(2,I)=rot:(5,I)  ;  rot:(3,I)=rot:(9,I)#                            CD40  41
roti:(2,I)=rot:(5,I) ;  roti:(3,I)=rot:(9,I)#                           CD40  42
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD40  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD40  44
#                                                                       CD40  45
### calculate ngr,natg,natgr#                                           CD40  46
NATG=0  ;  NGR=0#                                                       CD40  47
DO I=1,NUMATM#                                                          CD40  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD40  49
IGR=IFIX(grp:(I))#                                                      CD40  50
IF(IGR>=0.0)#                                                           CD40  51
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD40  52
NATG=NATG+1 ; IF(IGR>NGR) NGR=IGR#                                      CD40  53
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD40  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD40  55
NATGR=NATG+NGR+2#                                                       CD40  56
#                                                                       CD40  57
IF(NGR !=0)#                           Calculate keyg                   CD40  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD40  59
DO IG=1,NGR $( keyg:(IG+2)=0. $)#                                       CD40  60
DO IAT=1,NUMATM#                                                        CD40  61
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD40  62
IAG=grp:(IAT)#                                                          CD40  63
IF(IAG>0) keyg:(IAG+2)=keyg:(IAG+2)+1.#                                 CD40  64
IF( IAG==0)  iquit:(-CD4002)#          Zero group is incorrect inpu     CD40  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD40  66
keyg:(1)=NGR+2  ;  keyg:(2)=NGR+2#                                      CD40  67
DO IG=1,NGR $( keyg:(IG+2)=keyg:(IG+1)+keyg:(IG+2)  $)#                 CD40  68
DO IAT=1,NUMATM#                                                        CD40  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD40  70
IAG=IFIX(grp:(IAT))#                                                    CD40  71
IF(IAG>0) $(#                                                           CD40  72
K=IFIX(keyg:(IAG+1))+1 ; keyg:(IAG+1)=K ; keyg:(K)=IAT#                 CD40  73
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD40  74
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD40  75
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD40  76
#                                                                       CD40  77
NATW2=NATP+1#                          Now the number of the first      CD40  78
#                                                                       CD40  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD40  80
#                                                                       CD40  81
### fix water positions#                                                CD40  82
CALL CD41#                                                              CD40  83
### set up naybors#                                                     CD40  84
CALL CD42#                                                              CD40  85
#                                                                       CD40  86
RETURN#                                                                 CD40  87
END#                                                                    CD40  88
#####################################################################   CD40  89
systemheader:(CD41)#                   Not yet ok! must fix!            CD41   1
#                                                                       CD41   2
SUBROUTINE CD41#                                                        CD41   3
include:(AACOMN)#                                                       CD41   4
include:(CDCOMN)#                                                       CD41   5
#                                                                       CD41   6
#   SETS MOVEKEY OF WATER HYDROGENS TO-1.                               CD41   7
#   MOVES ANY WATERS THAT HAVE DRIFTED OUTSIDE OF THE 'ASYM.UNIT'       CD41   8
#   BACK INTO THE 'ASYM.UNIT' BY ONE OF THE SYMETRY OPERATIONS          CD41   9
#LOGICAL INSIDE  # LOGICAL FUNCTION                                     CD41  10
#LOGICAL FOUND                                                          CD41  11
#REAL XX(3),XD(3)   # TO TEMPORARILY HOLD COORDINATES                   CD41  12
#REAL VX(3)         # TO TEMPORARILY HOLD VELOCITIES                    CD41  13
# ****  MOVE OF WATER HYDROGENS TO-1                                    CD41  14
FOR( IAT=NATP+2; IAT<=NUMATM ; IAT=IAT+3 )#                             CD41  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD41  16
movekey:(IAT)=-1.#                                                      CD41  17
movekey:(IAT+1)=-1.#                                                    CD41  18
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD41  19
RETURN#                                                                 CD41  20
##########                                                              CD41  21
#NWMOVE=0  # COUNT THE NUMBER OFF WATERS MOVED                          CD41  22
#                                                                       CD41  23
#IF( !ORTHOG ) $( # CONVERT CARTESIAN TO FRACTIONAL COORDINATES         CD41  24
#FOR( I=NATP+1; I<=NAT; I=I+1 ) $(                                      CD41  25
#CALL MXV(TMINV,X(1,I),XX) # MATRIX X VECTOR                            CD41  26
#DO J=1,3 $( X(J,I)=XX(J) $) # STORE TRANSFORMED XYZ                    CD41  27
#$)                                                                     CD41  28
#$)                                                                     CD41  29
#                                                                       CD41  30
#FOR( I=NATP+1; I<=NAT; I=I+3 ) $( # FOR EVERY WATER OXYGEN             CD41  31
#IF( !INSIDE(X(1,I),BOXO) ) $( # THEN MUST LOOP OVER ALL SYM.OPS        CD41  32
#FOUND=.FALSE.              # UNTIL A COPY IN THE BOX IS FOUND          CD41  33
#FOR( ILAT=2; ILAT<=NLAT && !FOUND; ILAT=ILAT+1 ) $(                    CD41  34
#MTYP=RTYP(ILAT)                                                        CD41  35
#                                                                       CD41  36
##  symmetry transform x(1..3,i) to xx(1..3)                            CD41  37
#IF(MTYP==0) $( # IDENTITY MATRIX                                       CD41  38
#DO K=1,3 $( XX(K)=T(K,ILAT)+X(K,I) $)                                  CD41  39
#$)                                                                     CD41  40
#ELSE IF(KDIAG==0) $( # NON-DIAGONAL MATRICES                           CD41  41
#DO K=1,3 $( KROT=(K-1)*3+1                                             CD41  42
#XX(K)=T(K,ILAT)+SCPR(ROT(KROT,MTYP),X(1,I)) $)                         CD41  43
#$)                                                                     CD41  44
#ELSE $( # DIAGONAL MATRICES                                            CD41  45
#DO K=1,3 $( XX(K)=T(K,ILAT)+ROT(K,MTYP)*X(K,I) $)                      CD41  46
#$)                                                                     CD41  47
### end sym.transform                                                   CD41  48
#                                                                       CD41  49
#FOUND=INSIDE(XX,BOXO) # IS SYM.RELATED POSITION INSIDE ?               CD41  50
#$) # END LOOP OVER ALL SYM.OPS                                         CD41  51
#ILAT=ILAT-1 # MUST DECREMENT BECAUSE FOR HAS INCREMENTED               CD41  52
#                                                                       CD41  53
#IF( FOUND ) $( # REPLACE THE ORIGINAL WATER IN LIST BY SYM.RELATED     CD41  54
#IATV=KEYVAR(I)                                                         CD41  55
#WRITE(6,6060) I,MTYP,ILAT#                                             CD41  56
#6060 FORMAT(' MOVED WATER OF O#:',I5,'  BY SYM.OPS.#:',I3,I5)          CD41  57
#IF( !ORTHOG ) $( # CONVERT X1() CARTESIAN TO FRACTIONAL COO            CD41  58
#FOR( KK=IATV; KK<=IATV+2; KK=KK+1 ) $(                                 CD41  59
#CALL MXV(TMINV,X1(1,KK),XX) # MATRIX X VECTOR                          CD41  60
#DO J=1,3 $( X1(J,KK)=XX(KK) $) # STORE TRANSFORMED XYZ                 CD41  61
#$)                                                                     CD41  62
#$)                                                                     CD41  63
#FOR( KK=0; KK<=2; KK=KK+1 ) $( # FOR THE 3 ATOMS IN H2O                CD41  64
#IAT=I+KK                                                               CD41  65
#IATV=KEYVAR(IAT)                                                       CD41  66
##  symmetry transform x(1..3,iat) to xx(1..3)                          CD41  67
#IF(MTYP==0) $( # IDENTITY MATRIX                                       CD41  68
#DO K=1,3 $( XX(K)=T(K,ILAT)+X(K,IAT)                                   CD41  69
#XD(K)=T(K,ILAT)+X1(K,IATV)                                             CD41  70
#VX(K)=V0(K,IATV) $)                                                    CD41  71
#$)                                                                     CD41  72
#ELSE IF(KDIAG==0) $( # NON-DIAGONAL MATRICES                           CD41  73
#DO K=1,3 $( KROT=(K-1)*3+1                                             CD41  74
#XX(K)=T(K,ILAT)+SCPR(ROT(KROT,MTYP),X(1,IAT))                          CD41  75
#XD(K)=T(K,ILAT)+SCPR(ROT(KROT,MTYP),X1(1,IATV))                        CD41  76
#VX(K)=SCPR(ROT(KROT,MTYP),V0(1,IATV)) $)                               CD41  77
#$)                                                                     CD41  78
#ELSE $( # DIAGONAL MATRICES                                            CD41  79
#DO K=1,3 $( XX(K)=T(K,ILAT)+ROT(K,MTYP)*X(K,IAT)                       CD41  80
#XD(K)=T(K,ILAT)+ROT(K,MTYP)*X1(K,IATV)                                 CD41  81
#VX(K)=ROT(K,MTYP)*V0(K,IATV) $)                                        CD41  82
#$)                                                                     CD41  83
### end sym.transform                                                   CD41  84
#DO J=1,3 $( X(J,IAT)=XX(J)   # STORE TRANSFORMED XYZ                   CD41  85
#X0(J,IATV)=XX(J)                                                       CD41  86
#X2(J,IATV)=XX(J)                                                       CD41  87
#X1(J,IATV)=XD(J)                                                       CD41  88
#V0(J,IATV)=VX(J) $)                                                    CD41  89
#                                                                       CD41  90
#$) # END FOR KK OVER 3 ATOMS                                           CD41  91
#IATV=KEYVAR(I)                                                         CD41  92
#IF( !ORTHOG ) $( # CONVERT X0,X1,X2 TO CARTESIAN                       CD41  93
#FOR( KK=IATV; KK<=IATV+2; KK=KK+1 ) $(                                 CD41  94
#CALL MXV(TM,X0(1,KK),XX) # MATRIX X VECTOR                             CD41  95
#DO J=1,3 $( X0(J,KK)=XX(KK) $) # STORE TRANSFORMED XYZ                 CD41  96
#CALL MXV(TM,X1(1,KK),XX)                                               CD41  97
#DO J=1,3 $( X1(J,KK)=XX(KK) $)                                         CD41  98
#CALL MXV(TM,X2(1,KK),XX)                                               CD41  99
#DO J=1,3 $( X2(J,KK)=XX(KK) $)                                         CD41 100
#$)                                                                     CD41 101
#$)                                                                     CD41 102
#$) # END IF FOUND                                                      CD41 103
#ELSE $(        #    COULDN'T FIX IT. SERIOUS PROBLEM                   CD41 104
#WRITE(6,5002) X(1,I),X(2,I),X(3,I)                                     CD41 105
#5002 FORMAT(3F10.4)                                                    CD41 106
#CALL CD43(3,'FIXH2O 1',I)                                              CD41 107
#$)                                                                     CD41 108
#                                                                       CD41 109
#$) # END IF NOT INSIDE BOX                                             CD41 110
#$) # END LOOP OVER WATER OXYGENS                                       CD41 111
#                                                                       CD41 112
#IF( !ORTHOG ) $( # CONVERT BACK TO CARTESIAN XYZ                       CD41 113
#DO I=1,LIMIT $(                                                        CD41 114
#CALL MXV(TM,X(1,I),XX) # MATRIX X VECTOR                               CD41 115
#DO J=1,3 $( X(J,I)=XX(J) $) # STORE TRANSFORMED XYZ                    CD41 116
#$)                                                                     CD41 117
#$)                                                                     CD41 118
#                                                                       CD41 119
#IF( NWMOVE>0 ) WRITE(6,6058) NWMOVE                                    CD41 120
#6058 FORMAT(I10,' WATERS MOVED ACROSS CELL BOUNDARY')                  CD41 121
#                                                                       CD41 122
##=============================================================#        CD41 123
## logical function  i n s i d e                                        CD41 124
##         .true. if point xyz is inside box                            CD41 125
##=============================================================#        CD41 126
#FUNCTION INSIDE(XYZ,BOXO)                                              CD41 127
#LOGICAL INSIDE                                                         CD41 128
#REAL XYZ(3),BOXO(3,2)                                                  CD41 129
#INSIDE=.FALSE.                                                         CD41 130
#                                                                       CD41 131
#DO I=1,3 $(                                                            CD41 132
#IF(XYZ(I)<BOXO(I,1)) RETURN                                            CD41 133
#IF(XYZ(I)>BOXO(I,2)) RETURN                                            CD41 134
#$)                                                                     CD41 135
#INSIDE=.TRUE.                                                          CD41 136
#                                                                       CD41 137
#RETURN                                                                 CD41 138
#END                                                                    CD41 139
END#                                                                    CD41 140
#####################################################################   CD41 141
systemheader:(CD42)#                                                    CD42   1
#                                                                       CD42   2
#     IS NARROWLY CONNECTED WITH: GRENER(CD27) AND FCH2O(CD28)          CD42   3
#   THE CONNECTION IS VIA THE ARRAY NGBR: IN QX COMMON BLOCK.           CD42   4
#     BASED ON THE 'NAYBOR' ROUTINE OF JAN HERMANS.                     CD42   5
#     CONVERTED TO RATMAC OCT 5,1982 BY MIKE CARSON.                    CD42   6
#                                                                       CD42   7
# CONVENTIONS:                                                          CD42   8
#               THE INTERACTIONS OF PROTEIN ATOMS WITH ALL OTHER ATOMS  CD42   9
#  COME FIRST, FOLLOWED BY THE WATER-WATER INTERACTIONS.  THE INFO OCCU CD42  10
#  IN DIRECTIVES=SETS OF WORDS.                                         CD42  11
#   1ST DIR.VE=IAT, IATV, MTYPI ; DESCRIBES FIRST CENTRAL ATOM'S NUMB   CD42  12
#      VARIABLE INDEX AND MATRIX TYPE.                                  CD42  13
#   NEIGHBORING ATOM DIR.VE=JAT, JATV, MTYP, AA, BB, CC; AS FOR DIR.V   CD42  14
#      NUMBER 1 AND 3 ENERGY PARAMETERS.                                CD42  15
#   NEXT CENTRAL ATOM DIR.VE=-IAT(OLD), IAT(NEW), IATV, MTYPI           CD42  16
#   CLOSING DIR.VE NUMBER 1=-IAT, ZERO OR IAT(NEW), WHERE IAT(NEW)>=    CD42  17
#  ---ONCE CLOSING DIR.VE 1 HAS BEEN ISSUED THE DIRECTIVES ARE:         CD42  18
#   NEIGHBORING WATER OXYGEN DIR.VE=JAT                                 CD42  19
#   NEXT CENTRAL WATER OXYGEN DIR.VE=-IAT(OLD)                          CD42  20
# NOTES:  ANY NUMBER OF CONSECUTIVE NEIGHBOR DIR.VES PER CENTRAL DIR.VE CD42  21
#    CENTRAL WATER OXYGEN NUMBER IMPLIED, RATHER THAN GIVEN             CD42  22
#   MAT POINTS TO LAST ITEM IN NGBR: USED; MAT MUST BE ZERO             CD42  23
#   BEFORE NEW TABLE IS WRITTEN AND BEFORE GRENER IS CALLED.            CD42  24
#  ALL DIRECTIVES BEFORE THE WATER-WATER DIRECTIVES ARE ASSUMED TO BE 6 CD42  25
#    WORDS LONG BEFORE THEY ARE WRITTEN OR READ.                        CD42  26
#  ON THE OTHER HAND, DIRECTIVES FOR WATER-WATER INTERACTIONS CONSIST   CD42  27
#     OF A SINGLE WORD EACH.                                            CD42  28
#  IF AN ATOM IS NOT A MOVER (KEYVAR:(ATOM)<1) MTYP IS SET TO-1         CD42  29
#  AN ENTRY CONSISTING OF (HEADER),(NEIGHBORS),TRAILER                  CD42  30
#    IS PRODUCED FOR EVERY REAL ATOM (MOVER OR NON-MOVER) INSIDE THE    CD42  31
#    BOX, I.E. WITH MOVEKEY:(IAT)>=2.                                   CD42  32
#                                                                       CD42  33
#    LAT1,LAT2=RANGE OF MOVING ATOMS IN ORIGINAL MOLECULE               CD42  34
#                                                                       CD42  35
SUBROUTINE CD42#                       -old naybor(lat1,lat2)           CD42  36
include:(AACOMN)#                                                       CD42  37
include:(CDCOMN)#                                                       CD42  38
#                                                                       CD42  39
macro:(maxgroup:,380)#                                                  CD42  40
#                                                                       CD42  41
INTEGER TGG(maxgroup:)#                                                 CD42  42
INTEGER NBOX(3)#                                                        CD42  43
REAL ABOX0(3),ABOX1(3),XCOP(3)#                                         CD42  44
EQUIVALENCE (NX,NBOX(1)),(NY,NBOX(2)),(NZ,NBOX(3))#                     CD42  45
EQUIVALENCE (X0,ABOX0(1)),(Y0,ABOX0(2)),(Z0,ABOX0(3))#                  CD42  46
EQUIVALENCE (XZERO,ABOX0(1)),(YZERO,ABOX0(2)),(ZZERO,ABOX0(3))#         CD42  47
#                                                                       CD42  48
INTEGER WHERE#                                                          CD42  49
#                                                                       CD42  50
LOGICAL NEW#                                                            CD42  51
LOGICAL BIGGER,EQUAL,FOUND,NEWPAIR,NOTFIRST#                            CD42  52
LOGICAL ABSPEC#                        True if 1-4 interaction          CD42  53
#                                                                       CD42  54
#   DEFINE PROCEDURE NAMES FOR THIS ROUTINE                             CD42  55
defineproc:(PASS)#                     Accumulate info about an ato     CD42  56
defineproc:(TESTPAIR)#                 Test pair of atoms ?legitima     CD42  57
defineproc:(HEAD)#                     Write header in ngbr: for pr     CD42  58
defineproc:(TAIL)#                     Write trailer in ngbr: for p     CD42  59
defineproc:(TABLE)#                    Create triangular matrices o     CD42  60
defineproc:(GETMS)#                    Get master-slave pair            CD42  61
defineproc:(SHOWNB)#                                                    CD42  62
#                                                                       CD42  63
macro:(boxsize:,2.0)#                  Size of the little cubes         CD42  64
#                                                                       CD42  65
macro:(ypoint:,LOC(1,$1))#                                              CD42  66
macro:(zpoint:,LOC(2,$1))#                                              CD42  67
macro:(planefirst:,LOCPL($1))#                                          CD42  68
macro:(next:,LINK($1))#                                                 CD42  69
macro:(nplane:,50)#                                                     CD42  70
macro:(planeloy:,LOWP(1,$1))#                                           CD42  71
macro:(planeloz:,LOWP(2,$1))#                                           CD42  72
macro:(planehiy:,HIGHP(1,$1))#                                          CD42  73
macro:(planehiz:,HIGHP(2,$1))#                                          CD42  74
# ORIGINALLY IN 'COMCEDAR.RAT'                                          CD42  75
#  REPLACEMENTS TO TREE ARE OLD REFINE-STYLE                            CD42  76
# THESE ARRAYS ARE VARIABLE LENGTH, AND SHOULD NOT BE DIMENSIONED HERE  CD42  77
INTEGER KEYLJ(mxdatms:)#               Maps atom type to l.j. type      CD42  78
INTEGER KEYLJB(mxdatms:)#              Maps l.j. type to atom type      CD42  79
INTEGER LINK(maxatms:),LOC(2,maxatms:)##                                CD42  80
INTEGER LOCPL(nplane:)#                                                 CD42  81
INTEGER LOWP(2,nplane:),HIGHP(2,nplane:)#                               CD42  82
macro:(maxpair:,100000)## This is permanently needed (until exit XTA    CD42  83
REAL AALJ(maxpair:)#                   Lennard-jones potentials for     CD42  84
REAL AANLJ(maxpair:)#                  Likewise for 1-4 naybors         CD42  85
REAL BBLJ(maxpair:)#                                                    CD42  86
REAL BBNLJ(maxpair:)#                                                   CD42  87
REAL CCEL(maxpair:)#                                                    CD42  88
#                                                                       CD42  89
chardata:(CD42A, CENTRAL ATOM=      )#                                  CD42  90
chardata:(CD42B,       TOTAL VDW TYPES)#                                CD42  91
chardata:(CD42C,       TYPES OF ATOMIC PAIRWISE INTERACTIONS SET)#      CD42  92
chardata:(CD42D,            ITEMS IN THE NEIGHBOR TABLE)#               CD42  93
chardata:(CD42E,            PAIR-ANY PAIRS)#                            CD42  94
chardata:(CD42F,            WATER-WATER PAIRS)#                         CD42  95
###########                                                             CD42  96
datastuff:#                                                             CD42  97
DATA MXGP2/maxgroup:/#                 Mxgp2=dimension of tgg           CD42  98
DATA  NEW/.TRUE./#                                                      CD42  99
#                                                                       CD42 100
#########   FIRST REGULAR STATEMENT                                     CD42 101
#                                                                       CD42 102
IF(NEW)#                               Initialize once:                 CD42 103
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD42 104
DO I=1,NDICT#                                                           CD42 105
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD42 106
DO J=1,5 $( ifvo:(vdw:(J,I)) vdw:(J,I)=0.0 $)#                          CD42 107
ifvo:(barr:(2,I)) $(barr:(2,I)=0.0$)#                                   CD42 108
ifvo:(keyh:(I)) keyh:(I)=0.0#                                           CD42 109
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD42 110
NMAS=NSLAV ; RL=NBCUT ; DC=331.#       Means==1 and convert units       CD42 111
RL2=RL*RL ; NBRAD=RL/boxsize:#                                          CD42 112
#FILE##lrec6=lrec-6                                                     CD42 113
# SET UP ARRAYS FOR ALL TYPES OF PAIR-WISE INTERACTION                  CD42 114
xeq:(TABLE)#                                                            CD42 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD42 116
STARNB=STOPQX#                         For now                          CD42 117
#                                                                       CD42 118
############################################################            CD42 119
# S E C T I O N    O F    N A Y B O R  (MARCH 83)                       CD42 120
#  CREATE LIST OF POINTERS AND BOX INDICES                              CD42 121
# FOR EACH ATOM:  YPOINT:=Y-BOX,  ZPOINT:=Z-BOX                         CD42 122
#   NEXT:=ATOM IN SAME PLANE WITH NEXT HIGHER (Y,Z)                     CD42 123
#  NOT USED-BEFORE:=REVERSE OF NEXT:                                    CD42 124
# FOR EACH PLANE: PLANEFIRST:=INDEX OF ATOM WITH LOWEST (Y,Z)           CD42 125
#   PLANELOY: ETC.=LIMITS ON Y AND Z FOR A PLANE                        CD42 126
############################################################            CD42 127
# ***  DETERMINE NUMBER OF BOXES FROM COORDS. OF LATTICE MOLECULES      CD42 128
DO I=1,3#                                                               CD42 129
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD42 130
A2=x:(I,1)   ;   A3=A2#                A2, a3 are min & max of x(i)     CD42 131
DO IAT=1,NUMATM#                                                        CD42 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD42 133
# A0, A1 ARE MIN & MAX OF X(I)                                          CD42 134
AA=x:(I,IAT)#                                                           CD42 135
IF(movekey:(IAT)<0) NEXT#                                               CD42 136
IF(AA<A2) A2=AA#                                                        CD42 137
IF(AA>A3)  A3=AA#                                                       CD42 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD42 139
ABOX0(I)=A2#                                                            CD42 140
ABOX1(I)=A3#                                                            CD42 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD42 142
# BOX SIZE IS 2 ANGSTROMS                                               CD42 143
DO I=1,3#                                                               CD42 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD42 145
ABOX0(I)=ABOX0(I)-(boxsize:/2.0)#                                       CD42 146
NBOX(I)=(ABOX1(I)-ABOX0(I))/boxsize:#                                   CD42 147
NBOX(I)=NBOX(I)+1#                                                      CD42 148
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD42 149
DO I=1,nplane:#                        Initialize pointer arrays us     CD42 150
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD42 151
planefirst:(I)=0#                                                       CD42 152
planeloy:(I)=0;  planeloz:(I)=0#                                        CD42 153
planehiy:(I)=0;  planehiz:(I)=0#                                        CD42 154
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD42 155
DO I=1,NUMATM#                                                          CD42 156
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD42 157
ypoint:(I)=0;  zpoint:(I)=0;  next:(I)=0#                               CD42 158
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD42 159
DO IAT=1,NUMATM#                                                        CD42 160
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD42 161
ypoint:(IAT)=0#                                                         CD42 162
IF(movekey:(IAT)<0) NEXT#                                               CD42 163
IX=1+(x:(1,IAT)-XZERO)/boxsize:#       Add 1 here because it's a su     CD42 164
IY=1+(x:(2,IAT)-YZERO)/boxsize:#                                        CD42 165
IZ=1+(x:(3,IAT)-ZZERO)/boxsize:#       Add 1 here for consistency       CD42 166
# HAVE FOUND BOX INDICES (IX,IY,IZ).  SAVE THEM AND FIGURE CHAINS       CD42 167
ypoint:(IAT)=IY ; zpoint:(IAT)=IZ#                                      CD42 168
WHERE=planefirst:(IX)#                                                  CD42 169
LASTW=0#                                                                CD42 170
IF(WHERE==0)#                          First box ever in this plane     CD42 171
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD42 172
planefirst:(IX)=IAT#                                                    CD42 173
planeloy:(IX)=IY ; planehiy:(IX)=IY#                                    CD42 174
planeloz:(IX)=IZ ; planehiz:(IX)=IZ#                                    CD42 175
NEXT#                                                                   CD42 176
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD42 177
REPEAT#                                Find chains                      CD42 178
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD42 179
IF(IY<planeloy:(IX)) planeloy:(IX)=IY#                                  CD42 180
IF(IY>planehiy:(IX)) planehiy:(IX)=IY#                                  CD42 181
IF(IZ<planeloz:(IX)) planeloz:(IX)=IZ#                                  CD42 182
IF(IZ>planehiz:(IX)) planehiz:(IX)=IZ#                                  CD42 183
BIGGER=.FALSE. ; EQUAL=.FALSE.#                                         CD42 184
IF(IY==ypoint:(WHERE)) EQUAL=.TRUE.#                                    CD42 185
ELSE $( IF(IY>ypoint:(WHERE)) BIGGER=.TRUE. $)#                         CD42 186
IF(EQUAL) $( IF(IZ>zpoint:(WHERE)) BIGGER=.TRUE. $)#                    CD42 187
IF( BIGGER )#                          Keep looking                     CD42 188
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CD42 189
LASTW=WHERE#                                                            CD42 190
WHERE=next:(WHERE)#                                                     CD42 191
IF(WHERE==0)#                                                           CD42 192
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CD42 193
next:(LASTW)=IAT ; BREAK#              Last in plane                    CD42 194
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CD42 195
NEXT#                                                                   CD42 196
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CD42 197
ELSE#                                  Insert before                    CD42 198
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CD42 199
next:(IAT)=WHERE#                                                       CD42 200
IF(LASTW==0) planefirst:(IX)=IAT#                                       CD42 201
ELSE         next:(LASTW)=IAT#                                          CD42 202
BREAK#                                                                  CD42 203
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CD42 204
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD42 205
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD42 206
#                                                                       CD42 207
#---------------------------------------------------------              CD42 208
#    END PRODUCE BASIS ARRAYS ////  BEGIN PRODUCE TABLE                 CD42 209
#################################################################       CD42 210
#  PART ATOMLOOP OF MARCH 83 NAYBOR ROUTINE                             CD42 211
#################################################################       CD42 212
#   THE PATH TAKEN THRU THE FOLLOWING SECTION DIFFERS ACCORDING TO THE  CD42 213
#   FOLLOWING:  ATOM IN A GROUP;  PREPARING TABLE OF GROUPS; WRITING TH CD42 214
#   TABLE ON THE BASIS OF DISTANCES; WRITING THE TABLE ON THE BASIS OF  CD42 215
#   GROUPTABLE.                                                         CD42 216
#     PASS=1 MEANS ATOM IS IN A GROUP; CALCULATE GROUPTABLE (TGG)       CD42 217
#     IPASS=2 MEANS ATOM IS IN A GROUP; WRITE NEIGHBORS TO TABLE        CD42 218
#     IPASS=3 MEANS ATOM IS NOT IN A GROUP.                             CD42 219
#-----------------------------------------------------------            CD42 220
MAT=0 ; NPAIR=0 ; NPAIRW=0#                                             CD42 221
IGRLAS=0#                                                               CD42 222
##########   LOOP OVER ALL ATOMS BEGINS                                 CD42 223
DO IATT=1,NUMATM#                                                       CD42 224
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CD42 225
IGR=grp:(IATT)#                                                         CD42 226
IF(IGR<=0)## ****  atom not in a group                                  CD42 227
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CD42 228
MOVEI=movekey:(IATT)#                                                   CD42 229
IF(MOVEI<0) NEXT#                      All real atoms can be centra     CD42 230
IPASS=3#                                                                CD42 231
IAT=IATT#                              Use same name as when in loo     CD42 232
IF( NMAS !=0 )#                                                         CD42 233
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CD42 234
xeq:(GETMS)#                                                            CD42 235
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CD42 236
##   LOOP OVER ALL SYMOPS (APPLIED TO THE CENTRAL ATOM)                 CD42 237
FOR (ILAT=1;ILAT<=NLAT;ILAT=ILAT+1)#                                    CD42 238
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CD42 239
xeq:(HEAD)#                                                             CD42 240
xeq:(PASS)#                                                             CD42 241
xeq:(TAIL)#                                                             CD42 242
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CD42 243
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CD42 244
ELSE#                                  Atom is in a group               CD42 245
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CD42 246
IF(IGR<=IGRLAS) NEXT#                  This group not new               CD42 247
# ****  PROCESS THE ENTIRE GROUP                                        CD42 248
# GROUPS ARE NOT CONTIGUOUS IN THIS VERSION                             CD42 249
IGRLAS=IGR#                            Remember the group               CD42 250
LM1=IFIX(keyg:(IGR))+1 ; LM2=IFIX(keyg:(IGR+1))#                        CD42 251
##########   LOOP OVER ALL SYMOPS (APPLIED TO THE CENTRAL GROUP)        CD42 252
FOR (ILAT=1;ILAT<=NLAT;ILAT=ILAT+1)#                                    CD42 253
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CD42 254
IPASS=1 ; NGG=0#                                                        CD42 255
FOR (KEY=LM1;KEY<=LM2;KEY=KEY+1) $(#   Loop over all atoms in group     CD42 256
IAT=keyg:(KEY)#                                                         CD42 257
MOVEI=movekey:(IAT)#                                                    CD42 258
# ****  PROCESS ALL ATOMS IN THIS GROUP FIRST TIME (IPASS=1)            CD42 259
# FIND ALL ATOMS IN GROUPS THAT ARE VALID NEIGHBORS                     CD42 260
# AND SAVE GROUP NUMBERS                                                CD42 261
xeq:(PASS)#                                                             CD42 262
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CD42 263
# ****  PROCESS ALL ATOMS IN THIS GROUP SECOND TIME (IPASS=2)           CD42 264
IPASS=2#                                                                CD42 265
FOR (KEY=LM1;KEY<=LM2;KEY=KEY+1)#      Loop over atoms in group         CD42 266
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CD42 267
IAT=keyg:(KEY)#                                                         CD42 268
MOVEI=movekey:(IAT)#                                                    CD42 269
IF(MOVEI<0) NEXT#                      Don't do h2o hydrogens           CD42 270
IF( NMAS !=0 ) $(#                                                      CD42 271
xeq:(GETMS)#                                                            CD42 272
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CD42 273
xeq:(HEAD)#                                                             CD42 274
xeq:(PASS)#                                                             CD42 275
xeq:(TAIL)#                                                             CD42 276
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CD42 277
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CD42 278
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CD42 279
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CD42 280
#                                                                       CD42 281
#   EXIT SECTION                                                        CD42 282
#                                                                       CD42 283
MAT=MAT+1#                                                              CD42 284
ngbr:(MAT)=0#                                                           CD42 285
#FILE#IF( NREC !=0 ) $(                                                 CD42 286
#FILE#NREC=NREC+1                                                       CD42 287
#FILE#WRITE (ION) (NGBR(I),I=1,LREC)                                    CD42 288
#FILE#REWIND ION                                                        CD42 289
#FILE#MAT=MAT+(NREC-1)*LREC                                             CD42 290
#FILE#$)                                                                CD42 291
IF(NEW)#                                                                CD42 292
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CD42 293
NEW=.FALSE.#                                                            CD42 294
ncodefld:(FLOAT(MAT),1,CD42D,101013.,1)#                                CD42 295
writeline:(1,CD42D,NCD42D,3,3)#                                         CD42 296
ncodefld:(FLOAT(NPAIR),1,CD42E,101013.,1)#                              CD42 297
writeline:(1,CD42E,NCD42E,3,3)#                                         CD42 298
ncodefld:(FLOAT(NPAIRW),1,CD42F,101013.,1)#                             CD42 299
writeline:(1,CD42F,NCD42F,3,3)#                                         CD42 300
STOPNB=STARNB+MAT ; STOPQX=STOPNB#                                      CD42 301
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CD42 302
IF(PPRIOR>3)#                                                           CD42 303
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CD42 304
xeq:(SHOWNB)#                                                           CD42 305
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CD42 306
RETURN#                                                                 CD42 307
####    PROCEDURES BEGIN                                                CD42 308
#                                                                       CD42 309
procedure:(TABLE)#                                                      CD42 310
#                                                                       CD42 311
# PRODUCE ARRAYS FOR ALL TYPES OF ATOMIC PAIRWISE INTERACTIONS          CD42 312
#                                                                       CD42 313
#   COMPUTE RATIOS OF L.J. B FOR OW-APOLAR AND+CHARGED..-CHARGED        CD42 314
IF(NATP<NUMATM)#                                                        CD42 315
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CD42 316
BPRIM=500.0#                                                            CD42 317
ITOW=keydict:(NATP+1) ; BBXX=BPRIM/vdw:(2,ITOW)#                        CD42 318
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CD42 319
BBYY=1500./900.#                                                        CD42 320
# DETERMINE THE DIFFERENT TYPES OF V.D.W. INTERACTIONS PRESENT          CD42 321
NLJTYP=0#                                                               CD42 322
FOR(ITYP=1; ITYP<=NDICT; ITYP=ITYP+1)# All types in the dictionary      CD42 323
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CD42 324
FOUND=.FALSE.#                                                          CD42 325
FOR(JTYP=1; JTYP<=NLJTYP; JTYP=JTYP+1) $(# Different vdw types          CD42 326
FOUND=( vdw:(1,ITYP)==AALJ(JTYP) & vdw:(2,ITYP)==BBLJ(JTYP) $#          CD42 327
& vdw:(3,ITYP)==CCEL(JTYP) & vdw:(4,ITYP)==AANLJ(JTYP)  $#              CD42 328
& vdw:(5,ITYP)==BBNLJ(JTYP) )#                                          CD42 329
IF( FOUND ) BREAK#                                                      CD42 330
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CD42 331
IF( FOUND ) KEYLJ(ITYP)=JTYP#                                           CD42 332
ELSE $(  NLJTYP=NLJTYP+1 ;  KEYLJ(ITYP)=NLJTYP#                         CD42 333
KEYLJB(NLJTYP)=ITYP#                                                    CD42 334
AALJ(NLJTYP)=vdw:(1,ITYP) ; BBLJ(NLJTYP)=vdw:(2,ITYP)#                  CD42 335
CCEL(NLJTYP)=vdw:(3,ITYP)#                                              CD42 336
AANLJ(NLJTYP)=vdw:(4,ITYP); BBNLJ(NLJTYP)=vdw:(5,ITYP)#                 CD42 337
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CD42 338
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CD42 339
ncodefld:(FLOAT(NLJTYP),1,CD42B,60413.,1)#                              CD42 340
writeline:(1,CD42B,NCD42B,3,3)#                                         CD42 341
IJPAIR=NLJTYP * (NLJTYP+1)/2#                                           CD42 342
ncodefld:(FLOAT(IJPAIR),1,CD42C,60413.,1)#                              CD42 343
writeline:(1,CD42C,NCD42C,3,3)#                                         CD42 344
IF( IJPAIR>maxpair: ) iquit:(CD4201)#  Exceeded max no. of pairs        CD42 345
FOR(ILJ=1; ILJ<=NLJTYP; ILJ=ILJ+1)#                                     CD42 346
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 CD42 347
ITYP=KEYLJB(ILJ)#                                                       CD42 348
KHI=IFIX(keyh:(ITYP))#                                                  CD42 349
FOR(JLJ=1; JLJ<=ILJ; JLJ=JLJ+1)#                                        CD42 350
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 CD42 351
JTYP=KEYLJB(JLJ)#                                                       CD42 352
KHJ=IFIX(keyh:(JTYP))#                                                  CD42 353
IJPAIR=ILJ+NLJTYP*(JLJ-1)-JLJ*(JLJ-1)/2#                                CD42 354
AALJ(IJPAIR)=-vdw:(1,ITYP)*vdw:(1,JTYP)#                                CD42 355
AANLJ(IJPAIR)=-vdw:(4,ITYP)*vdw:(4,JTYP)#                               CD42 356
BBLJ(IJPAIR)=vdw:(2,ITYP)*vdw:(2,JTYP)#                                 CD42 357
BBNLJ(IJPAIR)=vdw:(5,ITYP)*vdw:(5,JTYP)#                                CD42 358
CCEL(IJPAIR)=DC*vdw:(3,ITYP)*vdw:(3,JTYP)#                              CD42 359
##-----  'polarity' of atoms is known thru array keyh.  meaning         CD42 360
#    KEYH=-3>OW  KEYH=-/+2>+/-CHARGED N OR O                            CD42 361
#    KEYH=0 >APOLAR KEYH=1   >POLAR                                     CD42 362
#    ON THE BASIS OF POLARITIES OF IAT AND JAT                          CD42 363
#    CHANGE L.J. B IF NECESSARY.                                        CD42 364
#    SUM=-3 MEANS ONE IS-3, OTHER 0: THIS MEANS OW-APOLAR               CD42 365
#    PRODUCT=-4 MEANS ONE IS-2, OTHER+2:+CHARGE..-CHARGE                CD42 366
IF(KHJ*KHI==-4)#                                                        CD42 367
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 CD42 368
BBLJ(IJPAIR)=BBLJ(IJPAIR)*BBYY#                                         CD42 369
BBNLJ(IJPAIR)=BBNLJ(IJPAIR)*BBYY#                                       CD42 370
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 CD42 371
ELSE#                                                                   CD42 372
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 CD42 373
IF(KHI+KHJ==-3)#                                                        CD42 374
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 CD42 375
BBLJ(IJPAIR)=BBLJ(IJPAIR)*BBXX#                                         CD42 376
BBNLJ(IJPAIR)=BBNLJ(IJPAIR)*BBXX#                                       CD42 377
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 CD42 378
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 CD42 379
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 CD42 380
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 CD42 381
endproc:(TABLE)#                                                        CD42 382
###########################  end procedure TABLE                        CD42 383
procedure:(HEAD)#                                                       CD42 384
#                                                                       CD42 385
# SET HEADER RECORD FOR A CENTRAL ATOM DIRECTIVE                        CD42 386
#                                                                       CD42 387
IF( IAT<=NATP )#                       For protein atom get some in     CD42 388
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 CD42 389
ITYP=keydict:(IAT)#                                                     CD42 390
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 CD42 391
IATV=keyvar:(IAT)#                                                      CD42 392
ngbr:(MAT+1)=IAT ; ngbr:(MAT+2)=IATV ; ngbr:(MAT+3)=ILAT ; MAT=MAT+3#   CD42 393
MATBEF=MAT#                                                             CD42 394
MATZO=MAT+1#                                                            CD42 395
endproc:(HEAD)#                                                         CD42 396
###########################  end procedure HEAD                         CD42 397
####################################  PROCEDURE TAIL                    CD42 398
procedure:(TAIL)#                                                       CD42 399
#                                                                       CD42 400
#       WRITE TERMINATE-CENTRAL-ATOM DIRECTIVE                          CD42 401
#       OVERALL TERMINATOR WILL BE OVERWRITTEN IF MORE ITEMS ADDED      CD42 402
#                                                                       CD42 403
IF(MAT==MATBEF) MAT=MAT-3#             No neighbors, erase header       CD42 404
ELSE#                                                                   CD42 405
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 CD42 406
MAT=MAT+1#                                                              CD42 407
ngbr:(MAT)=-IAT#                                                        CD42 408
ngbr:(MAT+1)=0#                                                         CD42 409
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 CD42 410
endproc:(TAIL)#                                                         CD42 411
##############   END PROCEDURE tail                                     CD42 412
####                     procedure GETMS                                CD42 413
#                                                                       CD42 414
#     DETERMINE IF THE ATOM 'IAT' IS A MASTER                           CD42 415
#     IF SO GET THE RANGE OF ITS SLAVE ATOMS,  LL1..LLL2                CD42 416
#                                                                       CD42 417
procedure:(GETMS)#                                                      CD42 418
FOUND=.FALSE.#                                                          CD42 419
FOR( IMAS=1; IMAS<=NMAS & !FOUND ; IMAS=IMAS+1 )#                       CD42 420
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 CD42 421
#WRITE (6,*) ' MASTER POINTER=',IMAS                                    CD42 422
IF( IAT<master:(IMAS) ) BREAK#         For loop                         CD42 423
FOUND=( IAT==master:(IMAS) )#                                           CD42 424
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 CD42 425
IMAS=IMAS-1#                                                            CD42 426
IF(FOUND)#                                                              CD42 427
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 CD42 428
LL1=IMAS ;  LLL2=IMAS#                                                  CD42 429
WHILE( master:(LL1)==master:(LLL2+1) ) $( LLL2=LLL2+1 $)#               CD42 430
$) ELSE LLL2=0#                                                         CD42 431
endproc:(GETMS)#                                                        CD42 432
#####################################################                   CD42 433
# S E C T I O N    P A S S    OF MARCH 83 NAYBOR                        CD42 434
#                                                                       CD42 435
#####################################################                   CD42 436
####  procedure PASS                                                    CD42 437
procedure:(PASS)#                                                       CD42 438
#                                                                       CD42 439
# CALCULATE THE SYMMETRY-TRANSFORMED XYZ                                CD42 440
IF( ILAT==1 )#                                                          CD42 441
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 CD42 442
DO I=1,3  $( XCOP(I)=x:(I,IAT) $)#     Identity                         CD42 443
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 CD42 444
ELSE#                                                                   CD42 445
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 CD42 446
IF( KDIAG==no:)#                       Convert cartesian to fractio     CD42 447
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 CD42 448
#WRITE(6,"(3F8.2,' X-IAT',I5)") (X:(I,IAT),I=1,3),IAT                   CD42 449
CALL CD01(CTOF,x:(1,IAT),x:(1,IAT))#   Matrix x vector                  CD42 450
#WRITE(6,"(3F8.2,' X*-IAT',I5)") (X:(I,IAT),I=1,3),IAT                  CD42 451
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 CD42 452
MTYP=rtyp:(ILAT)#                                                       CD42 453
IF(MTYP==0)#                           No rotation                      CD42 454
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 CD42 455
DO I=1,3  $( XCOP(I)=x:(I,IAT)+t:(I,ILAT) $)#                           CD42 456
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 CD42 457
ELSE IF( KDIAG==2)#                    Diagonal rotation matrix         CD42 458
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 CD42 459
DO I=1,3  $( XCOP(I)=rot:(I,ILAT)*x:(I,IAT)+t:(I,ILAT) $)#              CD42 460
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 CD42 461
ELSE#                                  General rotation matrix          CD42 462
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 CD42 463
DO I=1,3#                                                               CD42 464
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 CD42 465
IPT=(I-1)*3+1#                                                          CD42 466
XCOP(I)=t:(I,ILAT)+rot:(IPT,ILAT)*x:(1,IAT)+$#                          CD42 467
rot:(IPT+1,ILAT)*x:(2,IAT)+rot:(IPT+2,ILAT)*x:(3,IAT)#                  CD42 468
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 CD42 469
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 CD42 470
#WRITE(6,"(3F8.2,' XCOP*-IAT',I5)") XCOP,IAT                            CD42 471
IF( KDIAG==no: )#                      Convert back to cartesian xy     CD42 472
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 CD42 473
CALL CD01(FTOC,x:(1,IAT),x:(1,IAT))#   Matrix x vector                  CD42 474
CALL CD01(FTOC,XCOP,XCOP)#             Matrix x vector                  CD42 475
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 CD42 476
#WRITE(6,*) ' IAT-XCOP',IAT,XCOP                                        CD42 477
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 CD42 478
# DETERMINE BOXES IN WHICH NEIGHBORS MAY BE FOUND                       CD42 479
IX=((XCOP(1)-XZERO)/boxsize:)+1 ; IY=((XCOP(2)-YZERO)/boxsize:)+1#      CD42 480
IZ=((XCOP(3)-ZZERO)/boxsize:)+1#                                        CD42 481
IX1=IX-NBRAD ; IX2=IX+NBRAD#                                            CD42 482
IY1=IY-NBRAD ; IY2=IY+NBRAD#                                            CD42 483
IZ1=IZ-NBRAD ; IZ2=IZ+NBRAD#                                            CD42 484
IF(IX1<1) IX1=1 ; IF(IX2>NX) IX2=NX#                                    CD42 485
#WRITE (6,*) ' BOX RANGE:',IX1,IX2,IY1,IY2,IZ1,IZ2                      CD42 486
########## LOOP OVER PLANE IX                                           CD42 487
DO IX=IX1,IX2#                                                          CD42 488
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 CD42 489
WHERE=planefirst:(IX) ; IF(WHERE==0) NEXT# No points in plane           CD42 490
IF(IY1>planehiy:(IX)) NEXT ; IF(IZ1>planehiz:(IX)) NEXT#                CD42 491
IF(IY2<planeloy:(IX)) NEXT ; IF(IZ2<planeloz:(IX)) NEXT#                CD42 492
NOTFIRST=.FALSE.#                                                       CD42 493
REPEAT#                                Go thru the atoms in this pl     CD42 494
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 CD42 495
IF(NOTFIRST) WHERE=next:(WHERE)#                                        CD42 496
ELSE NOTFIRST=.TRUE.#                                                   CD42 497
IF(WHERE==0) BREAK#                    Done with plane because no m     CD42 498
IY3=ypoint:(WHERE)#                                                     CD42 499
# DETERMINE IF IY1<=Y<=IY2                                              CD42 500
IF(IY3<IY1)  NEXT#                     Try the next one                 CD42 501
IF(IY3>IY2) BREAK#                     Done with plane because y ex     CD42 502
IZ3=zpoint:(WHERE)#                                                     CD42 503
# DETERMINE IF IZ1<=Z<=IZ2                                              CD42 504
IF(IZ1>IZ3 \ IZ2<IZ3) NEXT#                                             CD42 505
#                                                                       CD42 506
# # # # #  USE THE FOUND ATOM IF WITHIN RANGE BEING MOVED               CD42 507
JAT=WHERE#                                                              CD42 508
IF(JAT<LAT1 \ JAT>LAT2) NEXT#                                           CD42 509
#WRITE (6,*) ' JAT=WHERE=',JAT                                          CD42 510
###############################################  start part B1          CD42 511
IF(IPASS==1)#                                                           CD42 512
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 CD42 513
JGR=grp:(JAT)#                                                          CD42 514
IF(JGR<=0) NEXT#                                                        CD42 515
# ONLY GROUP-GROUP INTERACTIONS CONSIDERED IN PART B1                   CD42 516
FOUND=.FALSE.#                                                          CD42 517
IF(NGG !=0)#                                                            CD42 518
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 57 CD42 519
FOR(JG=1;JG<=NGG&(!FOUND);JG=JG+1) $( FOUND=(JGR==TGG(JG)) $)#          CD42 520
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 57 CD42 521
IF(!FOUND)#                                                             CD42 522
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 59 CD42 523
# NO PAIRS RECORDED IF NEITHER MOVES                                    CD42 524
# ONLY RECORD PAIR ONCE, WHEN JAT>IAT                                   CD42 525
MOVEJ=movekey:(JAT)#                                                    CD42 526
IF(MOVEJ<0) NEXT#                                                       CD42 527
IF(JAT<IAT) NEXT#                                                       CD42 528
IF(MOVEI+MOVEJ==0) NEXT#                                                CD42 529
DIS2=0.#                               Test if within cutoff distan     CD42 530
DO I=1,3 $( RIJ=XCOP(I)-x:(I,JAT) ; DIS2=DIS2+RIJ*RIJ  $)#              CD42 531
IF( DIS2>RL2) NEXT#                                                     CD42 532
#    ENTER THE GROUP IN THE ARRAY OF GROUPS IF NOT IN THERE             CD42 533
NGG=NGG+1 ; IF(NGG>MXGP2) iquit:(CD4202)# Exceeded max no. groups       CD42 534
TGG(NGG)=JGR#                                                           CD42 535
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 59 CD42 536
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 CD42 537
###############################   end part B1                           CD42 538
ELSE## ipass=2 or 3 and boxes                                           CD42 539
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 61 CD42 540
###############################################  start part B2          CD42 541
#               GO THROUGH SEVERAL ADJACENT BOXES                       CD42 542
JGR=grp:(JAT)#                                                          CD42 543
IF(IPASS==2 & JGR>0)  NEXT#            K                                CD42 544
IF(IPASS==1 & JGR<=0) NEXT#            K                                CD42 545
MOVEJ=movekey:(JAT)#                                                    CD42 546
IF(MOVEJ<0) NEXT#                                                       CD42 547
IF(JAT<IAT) NEXT#                                                       CD42 548
IF(MOVEI+MOVEJ==0) NEXT#                                                CD42 549
DIS2=0.#                                                                CD42 550
DO I=1,3 $( RIJ=XCOP(I)-x:(I,JAT) ; DIS2=DIS2+RIJ*RIJ $)#               CD42 551
IF( DIS2>RL2) NEXT#                                                     CD42 552
#          EXECUTE FURTHER TESTS, AND WRITE NEIGHBOR DIRECTIVE IF OK    CD42 553
xeq:(TESTPAIR)#                                                         CD42 554
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 61 CD42 555
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 CD42 556
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 CD42 557
#   END NEW LOOP OVER BOXES (MARCH 83)                                  CD42 558
###############################   end part B2                           CD42 559
IF(IPASS==1 \ IGR<=0)  endproc:(PASS)#                                  CD42 560
FOR (IG=1;IG<=NGG;IG=IG+1)#                                             CD42 561
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 63 CD42 562
JGR=TGG(IG)#                                                            CD42 563
M1=keyg:(JGR)+1 ; M2=keyg:(JGR+1)#                                      CD42 564
###############################################                         CD42 565
#  START PART B3                                                        CD42 566
# HERE IPASS=2 AND GROUPS                                               CD42 567
#               GO THROUGH ALL ATOMS IN ONE GROUP FROM TGG              CD42 568
FOR(K=M1; K<=M2; K=K+1)#               Start loop over  k .             CD42 569
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 64 CD42 570
JAT=keyg:(K)#                                                           CD42 571
MOVEJ=movekey:(JAT)#                                                    CD42 572
IF(MOVEJ<0)  NEXT#                                                      CD42 573
IF(JAT<IAT) NEXT#                                                       CD42 574
IF(MOVEI+MOVEJ==0) NEXT#                                                CD42 575
xeq:(TESTPAIR)#                                                         CD42 576
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 64 CD42 577
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 63 CD42 578
###############################   end part B3                           CD42 579
endproc:(PASS)#                                                         CD42 580
###########################  end procedure PASS                         CD42 581
###########################################################             CD42 582
#                                                                       CD42 583
############### PROCEDURE TESTPAIR                                      CD42 584
# P A R T   T E S P   OF   SUBROUTINE  NAYBOR                           CD42 585
#                                                                       CD42 586
procedure:(TESTPAIR)#                                                   CD42 587
#                                                                       CD42 588
# FIRST TEST FOR BONDED CONNECTIVITY                                    CD42 589
#  (NOTE THAT SYMOP=1<>IDENTITY)                                        CD42 590
IF(ILAT==1)#                           No connection possible if sy     CD42 591
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 65 CD42 592
LL2=LLL2 ; IATXX=IAT#                                                   CD42 593
REPEAT#                                Repeat number 1                  CD42 594
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 66 CD42 595
IC=IATXX ; ID=JAT#                                                      CD42 596
REPEAT#                                Repeat number 2                  CD42 597
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 67 CD42 598
IF( IC==ID )  endproc:(TESTPAIR)#                                       CD42 599
IF( IC<ID ) $( IT=IC ;  IC=ID ;  ID=IT $)# Make ic>id                   CD42 600
ITEMP=IFIX(keydict:(IC))#                                               CD42 601
IF(IC !=IATXX & IC !=JAT & barr:(2,ITEMP)>0)#                           CD42 602
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 69 CD42 603
IT=backchain:(IC)#                     Free rotation and>0 bond ei      CD42 604
IF(IT==JAT \ IT==IATXX)  endproc:(TESTPAIR)#                            CD42 605
ELSE BREAK#                                                             CD42 606
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 69 CD42 607
ELSE#                                                                   CD42 608
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 70 CD42 609
IC=backchain:(IC)#                                                      CD42 610
IF(IC<=0) BREAK#                       Root encountered                 CD42 611
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 70 CD42 612
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 67 CD42 613
# REPLACE IATX WITH ALL ITS SLAVES                                      CD42 614
IF(LL2 !=0 & LL2>=LL1)#                                                 CD42 615
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 71 CD42 616
IATXX=slave:(LL2) ; LL2=LL2-1#                                          CD42 617
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 71 CD42 618
ELSE BREAK#                                                             CD42 619
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 66 CD42 620
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 65 CD42 621
################  have found pair                                       CD42 622
#---------CREATE NEIGHBOR DIRECTIVE                                     CD42 623
IF(IAT<=NATP)## ---------if central atom is protein:                    CD42 624
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 72 CD42 625
II=3#                                  ---------each water molecul      CD42 626
IF(JAT>NATP) II=1#                     Begin what amounts to a loop     CD42 627
MTYP=-1#                                                                CD42 628
IF(movekey:(JAT)>0) $( JATV=keyvar:(JAT) $)#                            CD42 629
NEWPAIR=.TRUE.#                                                         CD42 630
WHILE(II<4)#                                                            CD42 631
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 74 CD42 632
IF(II<3\NEWPAIR)#                                                       CD42 633
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 75 CD42 634
# NON-WATER, OR WATER OW AND H1                                         CD42 635
NEWPAIR=.FALSE. ; JTYP=keydict:(JAT)#                                   CD42 636
# DETERMINE IF 1-4 INTERACTION (CONFORMS WITH UNC CEDAR APR86)          CD42 637
ABSPEC=.FALSE.#                                                         CD42 638
REPEAT#                                (phoney)                         CD42 639
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 76 CD42 640
IF(JAT>NATP \ ILAT==1) BREAK#          Different molecules              CD42 641
JB1=backchain:(JAT)#                                                    CD42 642
IF(JB1==0) BREAK ; JB2=backchain:(JB1)#                                 CD42 643
IF(JB2==0) BREAK ; JB3=backchain:(JB2)#                                 CD42 644
IF(IAT==JB3) $( ABSPEC=.TRUE. ; BREAK $)#                               CD42 645
IF(IAT<JB3) BREAK#                     Impossible                       CD42 646
IB1=backchain:(IAT) ; IF(IB1==0) BREAK#                                 CD42 647
IF(IB1==JB2) $( ABSPEC=.TRUE. ; BREAK $)#                               CD42 648
IF(backchain:(IB1)==JB1) ABSPEC=.TRUE.#                                 CD42 649
BREAK#                                                                  CD42 650
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 76 CD42 651
ILJ=KEYLJ(ITYP) ;  JLJ=KEYLJ(JTYP)#                                     CD42 652
IF(ILJ<JLJ) IJPAIR=JLJ+NLJTYP*(ILJ-1)-ILJ*(ILJ-1)/2#                    CD42 653
ELSE         IJPAIR=ILJ+NLJTYP*(JLJ-1)-JLJ*(JLJ-1)/2#                   CD42 654
# GET CORRECT AS & BS                                                   CD42 655
IF( ABSPEC ) $(#                       1-4 terms                        CD42 656
AA=AANLJ(IJPAIR)#                                                       CD42 657
BB=BBNLJ(IJPAIR)#                                                       CD42 658
#WRITE(6,"(2I5,' FOUND TO BE 1-4 PAIR')") IAT,JAT                       CD42 659
$) ELSE $(#                            Normal terms                     CD42 660
AA=AALJ(IJPAIR)#                                                        CD42 661
BB=BBLJ(IJPAIR)#                                                        CD42 662
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 80 CD42 663
CC=CCEL(IJPAIR)#                                                        CD42 664
#  IF AA AND CC ARE BOTH ZERO, WE ASSUME BB=0, AND SKIP PAIR            CD42 665
IF( AA==0.0 & BB==0 & CC==0.0 ) endproc:(TESTPAIR)#                     CD42 666
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 75 CD42 667
#######   write the neighbor directive                                  CD42 668
#FILE#IF(MAT>LREC6) $( #                                                CD42 669
#FILE#ION=4                             # WRITE TABLE TO FILE 4         CD42 670
#FILE#WRITE (ION) (NGBR(I),I=1,LREC)    #                               CD42 671
#FILE#MAT=0 ; NREC=NREC+1               #                               CD42 672
#FILE#$) #                                                              CD42 673
NPAIR=NPAIR+1#                                                          CD42 674
ngbr:(MAT+1)=JAT ; ngbr:(MAT+2)=JATV#                                   CD42 675
ngbr:(MAT+3)=AA ; ngbr:(MAT+4)=BB ; ngbr:(MAT+5)=CC# Old con array      CD42 676
MAT=MAT+5#                                                              CD42 677
II=II+1 ; JAT=JAT+1 ; JATV=JATV+1#                                      CD42 678
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 74 CD42 679
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 72 CD42 680
ELSE#                                  For water-water pair, only j     CD42 681
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 81 CD42 682
NPAIRW=NPAIRW+1#                                                        CD42 683
MAT=MAT+1#                                                              CD42 684
ngbr:(MAT)=JAT#                                                         CD42 685
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 81 CD42 686
#       * * *    DONE WITH THIS NEIGHBOR.                               CD42 687
endproc:(TESTPAIR)#                                                     CD42 688
#                                ########################  END of PROCE CD42 689
#                                ####### S H O W N B                    CD42 690
procedure:(SHOWNB)#                                                     CD42 691
MAT=0 ; KWAT=no: ; KOUNT=0#                                             CD42 692
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   CD42 693
REPEAT#                                                                 CD42 694
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 82 CD42 695
MAT=MAT+1#                                                              CD42 696
AIAT=ngbr:(MAT) ; IF(AIAT>FLOAT(NATP)) KWAT=yes:#                       CD42 697
IF(AIAT==0.) BREAK#                                                     CD42 698
MAT=MAT+2#                                                              CD42 699
ncodefld:(AIAT,1,CD42A,200613.,1)#                                      CD42 700
writeline:(0,CD42A,NCD42A,3,4)#                                         CD42 701
REPEAT#                                                                 CD42 702
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 83 CD42 703
MAT=MAT+1 ; AJAT=ngbr:(MAT) ; IF(AJAT==-AIAT) BREAK#                    CD42 704
IF(KWAT==no:) MAT=MAT+4 ; KOUNT=KOUNT+1#                                CD42 705
FMT=KOUNT*60000.+613. ; ncodefld:(AJAT,1,CHROT,FMT,1)#                  CD42 706
IF(KOUNT==10)#                                                          CD42 707
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 84 CD42 708
writeline:(0,0,0,1,4) ; KOUNT=0#                                        CD42 709
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   CD42 710
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 84 CD42 711
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 83 CD42 712
IF(KOUNT>0) writeline:(0,0,0,1,4)#                                      CD42 713
KOUNT=0#                                                                CD42 714
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 82 CD42 715
endproc:(SHOWNB)#                                                       CD42 716
#                                                                       CD42 717
END#                                                                    CD42 718
################################################                        CD42 719
# REMOVE SUBROUTINE CD43                                                CD42 720
#####################################################################   CD42 721
systemheader:(CD48)#                                                    CD48   1
#                                                                       CD48   2
#CCCCCCCCCCCCCCCCC  SUBROUTINE   F M C G    CCCCCCCCCCCCCC              CD48   3
#                                                                       CD48   4
# MINIMIZE THE ENERGY VIA THE CONJUGATE GRADIENT METHOD.  FOR A         CD48   5
# COMMENTED LISTING SEE:  SYSTEM/360 SCIENTIFIC SUBROUTINE PACKAGE      CD48   6
# VERSION III, PROGRAMMER'S MANUAL(AUG. '70) GH20-0205-4, PP. 225-28.   CD48   7
# FOR A THOROUGH DESCRIPTION OF THE ALGORITHM SEE THE ORIGINAL PAPER:   CD48   8
# R. FLETCHER AND C.M. REEVES, 'FUNCTION MINIMIZATION BY CONJUGATE      CD48   9
# GRADIENTS', COMPUTER JOURNAL, VOL. 7, NO. 2  1964, PP. 149-53.        CD48  10
# MODIFIED TO USE FORCES. IF MORE THAN ONE STEP EVALUATION IS           CD48  11
# TAKEN PER LINEAR SEARCH EVALUATION, STEPSZ SHOULD BE DOUBLED,         CD48  12
# BUT IF THE POTENTIAL ENERGY INCREASES SHARPLY ON THE STEP             CD48  13
# EVALUATION WHEN ONE STEP EVALUATION IS BEING TAKEN PER LINEAR         CD48  14
# EVALUATION THE STEPSZ SHOULD BE DECREASED.                            CD48  15
# FUNCTION,ETC. ARE EVALUATED BY==>  F=FORCAL(X0,FORCE)                 CD48  16
#                                                                       CD48  17
#  ROUTINE WRITTEN IN NORMAL FORTRAN                                    CD48  18
#  CONVERTED TO RATFOR BY MC, AUG 2,82.  (LOTS OF ARITHMETIC IF'S !!)   CD48  19
#  CONVERTED TO RATMAC SEPT 20, 1982 MIKE CARSON                        CD48  20
#                                                                       CD48  21
#  FMCG CALLS:         BLWAT, FORCAL, TARGET,    ABS, AMAX1, SQRT       CD48  22
#                       CD56   CD50    CD54                             CD48  23
#  FMCG CALLED BY:  CEDAR-MINI-                                         CD48  24
#                          CD10                                         CD48  25
#                                                                       CD48  26
SUBROUTINE CD48(F,ESTP,EPS,LIMIT,IER)#                                  CD48  27
#SUBROUTINE FMCG(N,X0EQV:,F,FORCE:,ESTP,EPS,LIMIT,IER,H:,X2) #          CD48  28
include:(AACOMN)#                                                       CD48  29
include:(CDCOMN)#                                                       CD48  30
#     FORMAL PARAMETERS:                                                CD48  31
#REAL X0EQV:(*),FORCEQ:(*),HUNION:(*),   !! NOT USED->X2EQV:(3,*) #     CD48  32
REAL F,ESTP,EPS#                                                        CD48  33
INTEGER N,LIMIT,IER#                                                    CD48  34
# N=#VARIABLES ,  LIMIT=NO. OF ITERATIONS ,  IER=KEY TO HOW ITS GOING   CD48  35
#                                                                       CD48  36
INTEGER  I,II,J,K,KCALLS,KOUNT,LIMCAL,N1#                               CD48  37
REAL  ALFA,AMBDA,DALFA,DX,DY,ETARG#                                     CD48  38
REAL  FX,FY,GNRM,HNRM#                                                  CD48  39
REAL  OLDF,OLDG,WTRMS,SNRM,STEPSZ,W,Z#                                  CD48  40
#          STEPSZ ORIGINALLY 6.0                                        CD48  41
#                                                                       CD48  42
chardata:(MSG1, NO CONVERGENCE IN      ITERATIONS. FORCE**2=         )# CD48  43
chardata:(MSG2, LINEAR SEARCH TECHNIQUE INDICATES NO MINIMUM EXIST)#    CD48  44
chardata:(MSG3,   **MINIMUM HAS BEEN FOUND**)#                          CD48  45
chardata:(MSG4, STEP EVALUATION)#                                       CD48  46
chardata:(MSG5,   WEIGHTED   UNWEIGHTED)#                               CD48  47
chardata:(MSG6, POT.E  BONDL  BONDA  FIX.D  FLEX.D  NON-BOND  $#        CD48  48
CHIRALITY)#                                                             CD48  49
chardata:(MSG7, INIT EVAL.          E-TARGET=         $#                CD48  50
RMS MOVE.=     )#                                                       CD48  51
chardata:(MSG8, RESTORATION EVALUATION)#                                CD48  52
chardata:(MSG9A,[    E N E R G I E S                                $#  CD48  53
                                                D I S T A N C E S])#    CD48  54
chardata:(MSG9,[  TOTAL     TARGETS       BONDS      ANGLES   F$#       CD48  55
IX_DIHED  FLEX_DIHED  NON-BONDED     CHIRAL WTRMS_TRG RMS_TRG RMS_ORG])#CD48  56
#                                                                       CD48  57
chardata:(MSG11, NON-BONDED ENERGIES FOR INDIVIDUAL RESIDUES)#          CD48  58
chardata:(MSG12,[  RESIDUE-->ENERGY  RESIDUE-->ENERGY$#                 CD48  59
  RESIDUE-->ENERGY  RESIDUE-->ENERGY  RESIDUE-->ENERGY])#               CD48  60
chardata:(FMSGA, INITIAL  FINAL     )#                                  CD48  61
chardata:(FMSG,                                    ENERGY     RMS $#    CD48  62
DEVIATION)#                                                             CD48  63
chardata:(FMSG2, BONDS(ANG)                                           )#CD48  64
chardata:(FMSG3, ANGLES(DEG)                                          )#CD48  65
chardata:(FMSG4, FIXED DIHEDRAL(DEG)                                  )#CD48  66
chardata:(FMSG5, FLEX  DIHEDRAL(DEG)                                  )#CD48  67
chardata:(FMSG6, NON-BONDED                                           )#CD48  68
chardata:(FMSG7, CHIRALITY(DEG)                                       )#CD48  69
realdata:(FMT1,[121241.,361241.,481241.,601241.,721241.,841241.,$#      CD48  70
961241.])#                                                              CD48  71
realdata:(FMT2,[441561.,541032.])#     C                                CD48  72
realdata:(FMT3,[201022.,401022.,601022.,801022.,1001022.])#             CD48  73
datastuff:#                                                             CD48  74
STEPSZ=6.0#                                                             CD48  75
N=NVAR*3#                              Set number of variables=#        CD48  76
#                                                                       CD48  77
#                                                                       CD48  78
CALL CD50(F)#                                                           CD48  79
WTRMS=SQRT(FF(1)/FLOAT(N))#                                             CD48  80
ETARG=WT(1)*FF(1)#                                                      CD48  81
writeline:(1,MSG5,NMSG5,3,4)#                                           CD48  82
ncodefld:(ETARG,1,CHROT,FMT1(2),1)#                                     CD48  83
ncodefld:(WTRMS,1,CHROT,501032.,1)#                                     CD48  84
writeline:(1,MSG7,NMSG7,2,4)#                                           CD48  85
#WRITELINE:(0,MSG6,NMSG6,3,4)   #                                       CD48  86
#NCODEFLD:(F,1,CHROT,FMT1(1),1) #                                       CD48  87
#NCODEFLD:(FF,2,CHROT,FMT1(2),6) #                                      CD48  88
#WRITELINE:(0,MSG8,NMSG8,2,4) #                                         CD48  89
# ENERGY/RMS HEADER                                                     CD48  90
movechar:(FMSGA,1,FMSG,1,10,0)#                                         CD48  91
writeline:(1,FMSG,NFMSG,3,3)#                                           CD48  92
# BOND LENGTHS                                                          CD48  93
movechar:(BLANK,1,FMSG2,30,25,1)#                                       CD48  94
IF(NRMS(2)>1)#                                                          CD48  95
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD48  96
RMS(2)=SQRT(RMS(2)/FLOAT(NRMS(2)-1))#  Rms of bonds                     CD48  97
ncodefld:(RMS,2,FMSG2,FMT2(2),1)#      C                                CD48  98
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD48  99
ncodefld:(FF,2,FMSG2,FMT2(1),1)#       C                                CD48 100
writeline:(1,FMSG2,NFMSG2,3,3)#                                         CD48 101
# BOND ANGLES                                                           CD48 102
movechar:(BLANK,1,FMSG3,30,25,1)#                                       CD48 103
IF(NRMS(3)>1)#                                                          CD48 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD48 105
RMS(3)=57.29577951*SQRT(RMS(3)/FLOAT(NRMS(3)-1))# Rms of angles         CD48 106
ncodefld:(RMS,3,FMSG3,FMT2(2),1)#      C                                CD48 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD48 108
ncodefld:(FF,3,FMSG3,FMT2(1),1)#       C                                CD48 109
writeline:(1,FMSG3,NFMSG3,3,3)#                                         CD48 110
# FIXED DIHEDRALS                                                       CD48 111
movechar:(BLANK,1,FMSG4,30,25,1)#                                       CD48 112
IF(NRMS(4)>1)#                                                          CD48 113
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD48 114
RMS(4)=57.29577951*SQRT(RMS(4)/FLOAT(NRMS(4)-1))# Rms of fixed dihe     CD48 115
ncodefld:(RMS,4,FMSG4,FMT2(2),1)#      C                                CD48 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD48 117
ncodefld:(FF,4,FMSG4,FMT2(1),1)#       C                                CD48 118
writeline:(1,FMSG4,NFMSG4,3,3)#                                         CD48 119
# FLEXIBLE DIHEDRALS                                                    CD48 120
movechar:(BLANK,1,FMSG5,30,25,1)#                                       CD48 121
IF(NRMS(5)>1)#                                                          CD48 122
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD48 123
RMS(5)=57.29577951*SQRT(RMS(5)/FLOAT(NRMS(5)-1))# Rms of fixed dihe     CD48 124
ncodefld:(RMS,5,FMSG5,FMT2(2),1)#      C                                CD48 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD48 126
ncodefld:(FF,5,FMSG5,FMT2(1),1)#       C                                CD48 127
writeline:(1,FMSG5,NFMSG5,3,3)#                                         CD48 128
# NON-BONDED TERMS                                                      CD48 129
movechar:(BLANK,1,FMSG6,30,25,1)#                                       CD48 130
ncodefld:(FF,6,FMSG6,FMT2(1),1)#       C                                CD48 131
writeline:(1,FMSG6,NFMSG6,3,3)#                                         CD48 132
# CHIRAL CENTERS                                                        CD48 133
movechar:(BLANK,1,FMSG7,30,25,1)#                                       CD48 134
IF(NRMS(7)>1)#                                                          CD48 135
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD48 136
RMS(7)=57.29577951*SQRT(RMS(7)/FLOAT(NRMS(7)-1))# Rms of chirals        CD48 137
ncodefld:(RMS,7,FMSG7,FMT2(2),1)#      C                                CD48 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD48 139
ncodefld:(FF,7,FMSG7,FMT2(1),1)#       C                                CD48 140
writeline:(1,FMSG7,NFMSG7,3,3)#                                         CD48 141
ESTP=F-ESTP#                                                            CD48 142
KCALLS=1#                                                               CD48 143
# SET A SOMEWHAT LIBERAL LIMIT ON THE NUMBER OF CALLS OF FORCAL         CD48 144
LIMCAL=LIMIT*3#                                                         CD48 145
KOUNT=0#                                                                CD48 146
IER=0#                                                                  CD48 147
N1=N+1#                                                                 CD48 148
1 CONTINUE#                            May jump to here to begin bi     CD48 149
LINRM=3#                                                                CD48 150
writeline:(1,MSG9A,NMSG9A,3,3)#                                         CD48 151
writeline:(0,MSG9,NMSG9,3,3)#                                           CD48 152
#                                                                       CD48 153
DO II=1,N1#                            Start big do loop                CD48 154
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD48 155
# CALC WEIGHT TO USE ON CURRENT CYCLE                                   CD48 156
DO J=1,8#                                                               CD48 157
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD48 158
WT(J)=(INITWT(J)*(LIMIT-KOUNT)+FINLWT(J)*KOUNT)/LIMIT#                  CD48 159
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD48 160
KOUNT=KOUNT+1#                                                          CD48 161
OLDF=F#                                                                 CD48 162
GNRM=0.#                                                                CD48 163
DO J=1,N#                                                               CD48 164
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD48 165
GNRM=GNRM+forceq:(J)*forceq:(J)#                                        CD48 166
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD48 167
IF( LIMIT==0 )#                                                         CD48 168
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD48 169
KOUNT=0#                                                                CD48 170
GOTO 44#                                                                CD48 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD48 172
IF( GNRM<=0.0 )#                                                        CD48 173
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD48 174
IER=0#                                                                  CD48 175
GOTO 48#                                                                CD48 176
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD48 177
IF( II<=1 )#                                                            CD48 178
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD48 179
DO J=1,N#                                                               CD48 180
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD48 181
hunion:(J)=forceq:(J)#                                                  CD48 182
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD48 183
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD48 184
ELSE#                                                                   CD48 185
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD48 186
AMBDA=GNRM/OLDG#                                                        CD48 187
DO J=1,N#                                                               CD48 188
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CD48 189
hunion:(J)=AMBDA*hunion:(J)+forceq:(J)#                                 CD48 190
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD48 191
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD48 192
DY=0.#                                                                  CD48 193
HNRM=0.#                                                                CD48 194
DO J=1,N#                                                               CD48 195
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CD48 196
K=J+N#                                                                  CD48 197
hunion:(K)=x0eqv:(J)#                                                   CD48 198
HNRM=HNRM+ABS(hunion:(J))#                                              CD48 199
DY=DY-hunion:(J)*forceq:(J)#                                            CD48 200
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CD48 201
IF( DY>=0 )  GOTO 42#                                                   CD48 202
SNRM=1./HNRM#                                                           CD48 203
FY=F#                                                                   CD48 204
ALFA=2.*(ESTP-F)/DY#                                                    CD48 205
AMBDA=STEPSZ*SNRM#                                                      CD48 206
IF( ALFA>0.0 )#                                                         CD48 207
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CD48 208
IF( ALFA<AMBDA ) AMBDA=ALFA#                                            CD48 209
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CD48 210
ALFA=0.#                                                                CD48 211
14 CONTINUE#                                                            CD48 212
FX=FY#                                                                  CD48 213
DX=DY#                                                                  CD48 214
DO I=1,N#                                                               CD48 215
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CD48 216
x0eqv:(I)=x0eqv:(I)+AMBDA*hunion:(I)#                                   CD48 217
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CD48 218
#WRITE (6,101)                     #                                    CD48 219
CALL CD50(F)#                                                           CD48 220
KCALLS=KCALLS+1#                                                        CD48 221
ncodefld:(F,1,CHROT,FMT1(1),1)#                                         CD48 222
ncodefld:(FF,2,CHROT,FMT1(2),6)#                                        CD48 223
writeline:(0,MSG4,NMSG4,2,4)#                                           CD48 224
FY=F#                                                                   CD48 225
DY=0.#                                                                  CD48 226
DO I=1,N#                                                               CD48 227
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CD48 228
DY=DY-forceq:(I)*hunion:(I)#                                            CD48 229
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CD48 230
ifeq:(DY,0.0) GOTO 38#                                                  CD48 231
IF( DY<0.0 )#                                                           CD48 232
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CD48 233
IF( FY<FX )#                                                            CD48 234
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CD48 235
AMBDA=AMBDA+ALFA#                                                       CD48 236
ALFA=AMBDA#                                                             CD48 237
IF( HNRM*AMBDA>1.E10)#                                                  CD48 238
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CD48 239
IER=2#                                                                  CD48 240
F=OLDF#                                                                 CD48 241
DO J=1,N#                                                               CD48 242
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CD48 243
forceq:(J)=-hunion:(J)#                                                 CD48 244
K=N+J#                                                                  CD48 245
x0eqv:(J)=hunion:(K)#                                                   CD48 246
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CD48 247
GOTO 48#                                                                CD48 248
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CD48 249
ELSE GOTO 14#                                                           CD48 250
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CD48 251
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CD48 252
20 CONTINUE#                                                            CD48 253
TEE=0.#                                                                 CD48 254
21 CONTINUE#                                                            CD48 255
ifeq:(AMBDA,0.0)  GOTO 38#                                              CD48 256
Z=3.*(FX-FY)/AMBDA+DX+DY#                                               CD48 257
ALFA=AMAX1(ABS(Z),ABS(DX),ABS(DY))#                                     CD48 258
DALFA=Z/ALFA#                                                           CD48 259
DALFA=DALFA*DALFA-DX/ALFA*DY/ALFA#                                      CD48 260
IF( DALFA<=0.0 )#                                                       CD48 261
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CD48 262
DO J=1,N#                                                               CD48 263
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CD48 264
K=N+J#                                                                  CD48 265
x0eqv:(J)=hunion:(K)#                                                   CD48 266
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CD48 267
CALL CD50(F)#                                                           CD48 268
KCALLS=KCALLS+1#                                                        CD48 269
writeline:(0,MSG6,NMSG6,3,3)#                                           CD48 270
ncodefld:(F,1,CHROT,FMT1(1),1)#                                         CD48 271
ncodefld:(FF,2,CHROT,FMT1(2),6)#                                        CD48 272
writeline:(0,MSG8,NMSG8,1,3)#                                           CD48 273
IF( IER==0 )#                                                           CD48 274
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CD48 275
IER=-1#                                                                 CD48 276
GOTO 1#                                                                 CD48 277
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CD48 278
ELSE GOTO 48#                                                           CD48 279
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CD48 280
27 CONTINUE#                                                            CD48 281
W=ALFA*SQRT(DALFA)#                                                     CD48 282
ALFA=DY-DX+W+W#                                                         CD48 283
ifne:(ALFA,0.0) ALFA=(DY-Z+W)/ALFA#                                     CD48 284
ELSE           ALFA=(Z+DY-W)/(Z+DX+Z+DY)#                               CD48 285
ALFA=ALFA*AMBDA#                                                        CD48 286
DO I=1,N#                                                               CD48 287
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CD48 288
x0eqv:(I)=x0eqv:(I)+(TEE-ALFA)*hunion:(I)#                              CD48 289
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CD48 290
CALL CD50(F)#                                                           CD48 291
KCALLS=KCALLS+1#                                                        CD48 292
WTRMS=SQRT(FF(1)/FLOAT(N))#                                             CD48 293
RTMNSQ(1)=SQRT(RTMNSQ(1)/FLOAT(NVAR))# Rms distance from original p     CD48 294
RTMNSQ(2)=SQRT(RTMNSQ(2)/FLOAT(NVAR))# Rms distance from target pos     CD48 295
ETARG=WT(1)*FF(1)#                                                      CD48 296
ncodefld:(ETARG,1,CHROT,241241.,1)#                                     CD48 297
ncodefld:(WTRMS,1,CHROT,1040832.,1)#                                    CD48 298
ncodefld:(RTMNSQ,1,CHROT,1200832.,1)#                                   CD48 299
ncodefld:(RTMNSQ,2,CHROT,1120832.,1)#                                   CD48 300
ncodefld:(F,1,CHROT,FMT1(1),1)#                                         CD48 301
ncodefld:(FF,2,CHROT,FMT1(2),6)#                                        CD48 302
writeline:(0,0,0,1,3)#                                                  CD48 303
IF( F<=FX )#                                                            CD48 304
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CD48 305
IF( F<=FY ) GOTO 38#                                                    CD48 306
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CD48 307
DALFA=0.#                                                               CD48 308
DO I=1,N#                                                               CD48 309
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CD48 310
DALFA=DALFA-forceq:(I)*hunion:(I)#                                      CD48 311
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CD48 312
IF( DALFA<0.0 )#                                                        CD48 313
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CD48 314
IF( F<=FX )#                                                            CD48 315
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CD48 316
ifeq:(F,FX)#                                                            CD48 317
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CD48 318
ifeq:(DX,DALFA) GOTO 38#                                                CD48 319
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CD48 320
FX=F#                                                                   CD48 321
DX=DALFA#                                                               CD48 322
TEE=ALFA#                                                               CD48 323
AMBDA=ALFA#                                                             CD48 324
GOTO 21#                                                                CD48 325
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CD48 326
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CD48 327
ifeq:(FY,F)#                                                            CD48 328
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 CD48 329
ifeq:(DY,DALFA)  GOTO 38#                                               CD48 330
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CD48 331
FY=F#                                                                   CD48 332
DY=DALFA#                                                               CD48 333
AMBDA=AMBDA-ALFA#                                                       CD48 334
GOTO 20#                                                                CD48 335
38 CONTINUE#                                                            CD48 336
ZFTEST=OLDF-F+EPS#                                                      CD48 337
IF( ZFTEST<=0.0 )#                                                      CD48 338
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 CD48 339
IER=2#                                                                  CD48 340
F=OLDF#                                                                 CD48 341
DO J=1,N#                                                               CD48 342
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 CD48 343
forceq:(J)=-hunion:(J)#                                                 CD48 344
K=N+J#                                                                  CD48 345
x0eqv:(J)=hunion:(K)#                                                   CD48 346
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 CD48 347
GOTO 48#                                                                CD48 348
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 CD48 349
OLDG=GNRM#                                                              CD48 350
TEE=0.#                                                                 CD48 351
DO J=1,N#                                                               CD48 352
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 CD48 353
K=J+N#                                                                  CD48 354
hunion:(K)=x0eqv:(J)-hunion:(K)#                                        CD48 355
TEE=TEE+ABS(hunion:(K))#                                                CD48 356
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 CD48 357
IF( KOUNT>=N1 )#                                                        CD48 358
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 CD48 359
IF( TEE<EPS )#                                                          CD48 360
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 CD48 361
IF( GNRM>EPS )#                                                         CD48 362
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 CD48 363
IF( IER==0 )#                                                           CD48 364
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 CD48 365
IER=-1#                                                                 CD48 366
GOTO 1#                                                                 CD48 367
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 CD48 368
ELSE GOTO 48#                                                           CD48 369
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 CD48 370
ELSE#                                                                   CD48 371
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 CD48 372
IER=0#                                                                  CD48 373
GOTO 48#                                                                CD48 374
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 CD48 375
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 CD48 376
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 CD48 377
42 CONTINUE#                                                            CD48 378
IF( KOUNT>=LIMIT) GOTO 44#                                              CD48 379
IF( KCALLS>=LIMCAL ) GOTO 44#                                           CD48 380
IER=0#                                                                  CD48 381
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD48 382
# END OF BIG DO LOOP                                                    CD48 383
GOTO 1#                                                                 CD48 384
#                                                                       CD48 385
44 CONTINUE#                                                            CD48 386
WTRMS=SQRT(FF(1)/FLOAT(N))#                                             CD48 387
ETARG=WT(1)*FF(1)#                                                      CD48 388
writeline:(1,MSG5,NMSG5,3,4)#                                           CD48 389
ncodefld:(ETARG,1,CHROT,FMT1(2),1)#                                     CD48 390
ncodefld:(WTRMS,1,CHROT,501032.,1)#                                     CD48 391
writeline:(1,MSG7,NMSG7,2,4)#                                           CD48 392
# ENERGY/RMS HEADER                                                     CD48 393
movechar:(FMSGA,11,FMSG,1,10,0)#                                        CD48 394
writeline:(1,FMSG,NFMSG,3,3)#                                           CD48 395
# BOND LENGTHS                                                          CD48 396
movechar:(BLANK,1,FMSG2,30,25,1)#                                       CD48 397
IF(NRMS(2)>1)#                                                          CD48 398
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 CD48 399
RMS(2)=SQRT(RMS(2)/FLOAT(NRMS(2)-1))#  Rms of bonds                     CD48 400
ncodefld:(RMS,2,FMSG2,FMT2(2),1)#      C                                CD48 401
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 CD48 402
ncodefld:(FF,2,FMSG2,FMT2(1),1)#       C                                CD48 403
writeline:(1,FMSG2,NFMSG2,3,3)#                                         CD48 404
# BOND ANGLES                                                           CD48 405
movechar:(BLANK,1,FMSG3,30,25,1)#                                       CD48 406
IF(NRMS(3)>1)#                                                          CD48 407
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 CD48 408
RMS(3)=57.29577951*SQRT(RMS(3)/FLOAT(NRMS(3)-1))# Rms of angles         CD48 409
ncodefld:(RMS,3,FMSG3,FMT2(2),1)#      C                                CD48 410
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 CD48 411
ncodefld:(FF,3,FMSG3,FMT2(1),1)#       C                                CD48 412
writeline:(1,FMSG3,NFMSG3,3,3)#                                         CD48 413
# FIXED DIHEDRALS                                                       CD48 414
movechar:(BLANK,1,FMSG4,30,25,1)#                                       CD48 415
IF(NRMS(4)>1)#                                                          CD48 416
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 CD48 417
RMS(4)=57.29577951*SQRT(RMS(4)/FLOAT(NRMS(4)-1))# Rms of fixed dihe     CD48 418
ncodefld:(RMS,4,FMSG4,FMT2(2),1)#      C                                CD48 419
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 CD48 420
ncodefld:(FF,4,FMSG4,FMT2(1),1)#       C                                CD48 421
writeline:(1,FMSG4,NFMSG4,3,3)#                                         CD48 422
# FLEXIBLE DIHEDRALS                                                    CD48 423
movechar:(BLANK,1,FMSG5,30,25,1)#                                       CD48 424
IF(NRMS(5)>1)#                                                          CD48 425
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 CD48 426
RMS(5)=57.29577951*SQRT(RMS(5)/FLOAT(NRMS(5)-1))# Rms of fixed dihe     CD48 427
ncodefld:(RMS,5,FMSG5,FMT2(2),1)#      C                                CD48 428
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 CD48 429
ncodefld:(FF,5,FMSG5,FMT2(1),1)#       C                                CD48 430
writeline:(1,FMSG5,NFMSG5,3,3)#                                         CD48 431
# NON-BONDED TERMS                                                      CD48 432
movechar:(BLANK,1,FMSG6,30,25,1)#                                       CD48 433
ncodefld:(FF,6,FMSG6,FMT2(1),1)#       C                                CD48 434
writeline:(1,FMSG6,NFMSG6,3,3)#                                         CD48 435
# CHIRAL CENTERS                                                        CD48 436
movechar:(BLANK,1,FMSG7,30,25,1)#                                       CD48 437
IF(NRMS(7)>1)#                                                          CD48 438
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 CD48 439
RMS(7)=57.29577951*SQRT(RMS(7)/FLOAT(NRMS(7)-1))# Rms of chirals        CD48 440
ncodefld:(RMS,7,FMSG7,FMT2(2),1)#      C                                CD48 441
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 CD48 442
ncodefld:(FF,7,FMSG7,FMT2(1),1)#       C                                CD48 443
writeline:(1,FMSG7,NFMSG7,3,3)#                                         CD48 444
# RESIDUE NON-BONDED ENERGIES                                           CD48 445
IF(WT(6)!=0.0)#                                                         CD48 446
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 CD48 447
LINRM=4#                                                                CD48 448
writeline:(1,MSG11,NMSG11,3,3)#                                         CD48 449
writeline:(1,MSG12,NMSG12,3,3)#                                         CD48 450
DO I=1,TOTRES,5#                                                        CD48 451
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 CD48 452
J=MIN0(I+4,TOTRES)#                                                     CD48 453
K=J-I+1#                                                                CD48 454
ncodefld:(RESNB(I),1,CHROT,FMT3,K)#                                     CD48 455
DO J=1,K#                                                               CD48 456
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 CD48 457
IER=STARSQ+STEPSQ*(I+J-2)+1#                                            CD48 458
movertoc:(QX(IER),1,CHROT,J*20-18,8,0)#                                 CD48 459
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 CD48 460
writeline:(0,MSG12,NMSG12,1,3)#                                         CD48 461
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 CD48 462
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 CD48 463
IER=1#                                                                  CD48 464
IF( GNRM<=EPS) IER=0#                                                   CD48 465
48 CONTINUE#                                                            CD48 466
#                                                                       CD48 467
IF( IER==0 )  iquit:(-CD4801)#         Fatal error                      CD48 468
#                                                                       CD48 469
ELSE IF( IER==1 )#                                                      CD48 470
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 CD48 471
movechar:(MSG1,1,CHROT,1,NMSG1,0)#                                      CD48 472
ncodefld:(FLOAT(LIMIT),1,CHROT,230213.,1)#                              CD48 473
ncodefld:(GNRM,1,CHROT,551461.,1)#                                      CD48 474
writeline:(0,0,0,3,3)#                                                  CD48 475
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 CD48 476
ELSE IF( IER==2 ) writeline:(0,MSG2,NMSG2,3,3)#                         CD48 477
ELSE              writeline:(0,MSG3,NMSG3,3,3)#                         CD48 478
RETURN#                                                                 CD48 479
#                                                                       CD48 480
END#                                                                    CD48 481
#####################################################################   CD48 482
systemheader:(CD49)#                                                    CD49   1
SUBROUTINE CD49(V,W,VXW)#                                               CD49   2
#       FIND THE CROSS PRODUCT OF TWO VECTORS                           CD49   3
#      VECTOR VXW BECOMES VECTOR PRODUCT V TIMES W                      CD49   4
REAL   V(3),W(3),VXW(3)#                                                CD49   5
#                                                                       CD49   6
VXW(1)=V(2)*W(3)-V(3)*W(2)#                                             CD49   7
VXW(2)=V(3)*W(1)-V(1)*W(3)#                                             CD49   8
VXW(3)=V(1)*W(2)-V(2)*W(1)#                                             CD49   9
#                                                                       CD49  10
RETURN#                                                                 CD49  11
END#                                                                    CD49  12
#####################################################################   CD49  13
systemheader:(CD50)#                                                    CD50   1
#                                                                       CD50   2
# FIND THE FORCES AND POTENTIAL ENERGY OF A POLYPEPTIDE.                CD50   3
#                                                                       CD50   4
#   BASED ON THE "FORCAL" SUBROUTINE OF JAN HERMANS                     CD50   5
#    CONVERTED TO RATMAC SEPT 21, 1982 BY MIKE CARSON                   CD50   6
#                                                                       CD50   7
#   FORCAL CALLED BY :  FMCG==CD12                                      CD50   8
#  CALLS:  DIFORC, THEFOR, BOFORC, GRENER, FCH2O, CHIFOR, TARGET        CD50   9
#          CD53    CD52    CD51    CD57    CD58   CD55    CD54          CD50  10
#                                                                       CD50  11
SUBROUTINE CD50(E)#                                                     CD50  12
include:(AACOMN)#                                                       CD50  13
include:(CDCOMN)#                                                       CD50  14
#                                                                       CD50  15
# INPUTS: REAL   X0:(3,*), X2(3,*)                                      CD50  16
# OUTPUT: REAL   FORCE:(3,*),E    # E IS CALLED F IN FMCG               CD50  17
#                                                                       CD50  18
#NCLUDE(COMMON.CEDAR)             #                                     CD50  19
#INT4CM                           # ION,NREC                            CD50  20
#                                                                       CD50  21
REAL ENER#                             Returned through other subro     CD50  22
INTEGER MAT#                           Used in calc. of non-bonded      CD50  23
INTEGER KT,I,JATOM#                    Counters                         CD50  24
LOGICAL NEW#                                                            CD50  25
DATA NEW/.TRUE./#                                                       CD50  26
#                                                                       CD50  27
# INITIALIZE FORCE AND ENERGY.  UPDATE THE ATOM POSITIONS               CD50  28
DO I=2,7#                                                               CD50  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD50  30
FF(I)=0.0#                                                              CD50  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD50  32
# INITIALIZE RMS DEVIATIONS FROM DICTIONARY                             CD50  33
DO I=1,7#                                                               CD50  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD50  35
NRMS(I)=0#                                                              CD50  36
RMS(I)=0.0#                                                             CD50  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD50  38
DO KT=1,NUMATM#                                                         CD50  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD50  40
JATOM=keyvar:(KT)#                                                      CD50  41
IF( JATOM>0)#                                                           CD50  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD50  43
DO I=1,3#                                                               CD50  44
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD50  45
force:(I,JATOM)=0.0#                                                    CD50  46
x:(I,KT)=x0:(I,JATOM)#                                                  CD50  47
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD50  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD50  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD50  50
# RESET THE SLAVES TO CURRENT MASTER POSITIONS                          CD50  51
DO KT=STARMS,STOPMS-1,STEPMS#                                           CD50  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD50  53
IAM=INT(QX(KT+1))#                                                      CD50  54
IAS=INT(QX(KT+2))#                                                      CD50  55
DO I=1,3#                                                               CD50  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD50  57
x:(I,IAS)=x:(I,IAM)#                                                    CD50  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD50  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD50  60
# CALC MEAN SQUARE DEVIATION OF MOVING ATOMS FROM ORIGINAL AND TARGET P CD50  61
RTMNSQ(1)=0.0#                                                          CD50  62
RTMNSQ(2)=0.0#                                                          CD50  63
DO KT=1,NUMATM#                                                         CD50  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD50  65
JATOM=keyvar:(KT)#                                                      CD50  66
IF( JATOM>0)#                                                           CD50  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD50  68
IF(movekey:(KT)<0.5) NEXT#             Don't include slaves,hydrog      CD50  69
DO I=1,3#                                                               CD50  70
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD50  71
RTMNSQ(1)=RTMNSQ(1)+(x:(I,KT)-xp:(I,KT))**2#                            CD50  72
RTMNSQ(2)=RTMNSQ(2)+(x:(I,KT)-x2:(I,JATOM))**2#                         CD50  73
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD50  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD50  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD50  76
# CALCULATE THE FORCE AND POTENTIAL ENERGY CONTRIBUTIONS FROM           CD50  77
# THE BONDS, THE BONDS ANGLES, AND THE DIHEDRAL ANGLES.                 CD50  78
IF( WT(2) !=0.0  &  NB !=0 )#                                           CD50  79
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD50  80
#ALL BOFORC(FORCE,FF(2))          #                                     CD50  81
CALL CD51#                             Calc. bond forces                CD50  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD50  83
IF( WT(3) !=0.0  &  NT !=0 )#                                           CD50  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD50  85
#ALL THEFOR(FORCE,FF(3))          #                                     CD50  86
CALL CD52#                             Calc. angle forces               CD50  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD50  88
IF( ((WT(4) !=0.0) \ (WT(5) !=0.)) & (ND !=0) )#                        CD50  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD50  90
#ALL DIFORC(FORCE,FF(4),FF(5))  #                                       CD50  91
CALL CD53#                             Calc. dihedral forces            CD50  92
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD50  93
#------------------CALCULATE NONBONDED FORCES AND ENERGY                CD50  94
IF(WT(6) !=0.)#                                                         CD50  95
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CD50  96
MAT=0#                                                                  CD50  97
#FILE# IF(NREC>0) REWIND ION          #                                 CD50  98
#ALL GRENER (MAT,FORCE)           #                                     CD50  99
CALL CD57(MAT)#                        Calc non-bonded forces           CD50 100
IF( NVARP<NVAR)#                                                        CD50 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CD50 102
ENER=0.#                                                                CD50 103
# *****  CALL THE ROUTINE FOR WATER-WATER INTERACTIONS                  CD50 104
#        WITH NATW2 AT THIS MOMENT.  NATW2 IN COMMON                    CD50 105
#        MAT POINTS TO THE ARRAY NGBR IN TABLE, AS USUAL.               CD50 106
#ALL FCH2O(MAT,FORCE,ENER)        #                                     CD50 107
CALL CD58(MAT,ENER)#                   Calc water-water forces          CD50 108
FF(6)=FF(6)+ENER#                                                       CD50 109
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CD50 110
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD50 111
IF(WT(7) !=0) CALL CD55#               Calc chiral forces               CD50 112
E=WT(2)*FF(2)+WT(3)*FF(3)+WT(4)*FF(4)+WT(5)*FF(5) $#                    CD50 113
     +WT(6)*FF(6)+WT(7)*FF(7)#                                          CD50 114
#                                                                       CD50 115
NEW=.FALSE.#                                                            CD50 116
IF(WT(2)!=0.) CALL CD56(E)#                                             CD50 117
IF(WT(1)!=0.) CALL CD54(E)#                                             CD50 118
#                                                                       CD50 119
RETURN#                                                                 CD50 120
END#                                                                    CD50 121
#####################################################################   CD50 122
systemheader:(CD51)#                                                    CD51   1
#                                                                       CD51   2
# SUBROUTINE TO FIND ENERGY AND FORCE CONTRIBUTIONS OF THE BONDS        CD51   3
#    IN A PEPTIDE.                                                      CD51   4
#                                                                       CD51   5
#  THE GRADIENT TERM FOR ATOM A:                                        CD51   6
#       C*(BLV-BLO)*THE UNIT VECTOR B->A                                CD51   7
#   B'S GRADIENT VECTOR IS THE NEGATION OF A'S GRADIENT VECTOR          CD51   8
#                                                                       CD51   9
#   BASED ON 'BOFORC' SUBROUTINE OF JAN HERMANS                         CD51  10
#   CONVERTED TO RATMAC SEPT 22, 1982 BY MIKE CARSON                    CD51  11
#                                                                       CD51  12
SUBROUTINE CD51#                       Boforc(force,e)        #         CD51  13
include:(AACOMN)#                                                       CD51  14
include:(CDCOMN)#                                                       CD51  15
#                                                                       CD51  16
# OUTPUTS: REAL E(==FF(2)); FORCE:(3,*)                 #               CD51  17
#     FORCE:(3,*): FORCE NOW CONTAINS THE CONTRIBUTION FROM THIS BOND   CD51  18
#     E     : THE POTENTIAL ENERGY NOW CONTAINS THE CONTRIBUTION FROM   CD51  19
#             THIS BOND.                                                CD51  20
#                                                                       CD51  21
# INPUT:    INTEGER  BOSAVE:, NB, VPTR:, TREE:                          CD51  22
#           REAL  X:, DICT2:, DICT3:, WT                                CD51  23
#     BOSAVE:(2,*): CONTAINS THE ATOM PAIRS DEFINING THE VARIABLE BONDS CD51  24
#     NB:         NUMBER OF PAIRS IN 'BOSAVE:'                          CD51  25
#     VPTR::   FOR VARIABLE ATOMS, MAPPING FROM THE TREE KEY TO THE KEY CD51  26
#            FOR FORCE. FOR NON-VARIABLE ATOMS, 0.                      CD51  27
#     X:(3,*): ALL ATOMS' POSITIONS                                     CD51  28
#     DICT2:(4,*): CONTAINS THE IDEAL BONDLENGTH IN COLUMN 1.           CD51  29
#     DICT3:(5,*): CONTAINS THE COEFFICIENT OF THE ENERGY FUNCTION IN   CD51  30
#                 COLUMN 1.                                             CD51  31
#     KEYDICT:(*): CONTAINS THE KEY TO DICT2: AND DICT3: IN COLUMN 6.   CD51  32
#     WT:         WT(2) IS THE WEIGHTING FACTOR FOR THE FORCE AND       CD51  33
#                 ENERGY OF THE BONDS. THE REALISTIC VALUE IS 1.0.      CD51  34
#                 ONLY THE FORCES ARE WEIGHTED IN THIS SUBROUTINE.      CD51  35
# INTERNAL VARIABLES:                                                   CD51  36
REAL   C#                              The bond constant                CD51  37
REAL   M#                              Computed multiplication cons     CD51  38
REAL   V(3)#                           B to a bond vector               CD51  39
REAL   BLV#                            Blv:  v's length                 CD51  40
REAL   BLO#                            The ideal, zero potential, l     CD51  41
REAL   DELL#                           Blv-blo                          CD51  42
REAL   COMP#                           The absolute value of the co     CD51  43
REAL   INNP#                           Inner product                    CD51  44
REAL   EB#                             Auxillary storage variable t     CD51  45
INTEGER   KA,KB#                       Atom a's, b's  key to force      CD51  46
INTEGER   P#                           P: pair being processed          CD51  47
INTEGER   A#                           Forward atom in pair.            CD51  48
INTEGER   B#                           Backchain atom in pair.          CD51  49
INTEGER   J#                           Loop counter                     CD51  50
INTEGER   T1#                          Scat factor type                 CD51  51
INTEGER   T2#                          Scat factor type                 CD51  52
chardata:(HEAD, BOND                        IDEAL  REAL   CONSTANT $#   CD51  53
     ENERGY )#                                                          CD51  54
realdata:(FMT,[ 340732., 410732., 510732., 631022.])# Bond angles       CD51  55
datastuff:#                                                             CD51  56
#                                                                       CD51  57
IF(ELIST>0.0)writeline:(1,HEAD,NHEAD,3,3)#                              CD51  58
#                                                                       CD51  59
E=0.0#                                 Initialize the energy to zer     CD51  60
DO P=1,NB#                                                              CD51  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD51  62
A=bosave:(1,P)#                                                         CD51  63
B=bosave:(2,P)#                                                         CD51  64
KA=vptr:(A)#                                                            CD51  65
KB=vptr:(B)#                                                            CD51  66
#                                                                       CD51  67
#                FIND THE BOND VECTOR AND COMPUTE ITS LENGTH            CD51  68
INNP=0.0#                                                               CD51  69
DO J=1,3#                                                               CD51  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD51  71
V(J)=x:(J,A)-x:(J,B)#                                                   CD51  72
INNP=V(J)*V(J)+INNP#                                                    CD51  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD51  74
BLV=SQRT(INNP)#                                                         CD51  75
#                                                                       CD51  76
#           FIND THE IDEAL BONDLENGTH AND THE ENERGY FUNCTION           CD51  77
#           COEFFICIENT. COMPUTE THE ENERGY AND THE FORCE COMPONENT.    CD51  78
#           TREE(6,A) IS KEY TO DICTIONARY                              CD51  79
KD=IFIX(keydict:(A))#                                                   CD51  80
C=dict3:(1,KD)#                                                         CD51  81
BLO=dict2:(1,KD)#                                                       CD51  82
IF(BLV==0.0) BLV=BLO#                  Set bond to ideal                CD51  83
DELL=BLV-BLO#                                                           CD51  84
T1=QX(STARAT+(A-1)*STEPAT+sfoff:)#                                      CD51  85
T2=QX(STARAT+(B-1)*STEPAT+sfoff:)#                                      CD51  86
IF(T1!=NUMHYD & T2!=NUMHYD)#                                            CD51  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD51  88
RMS(2)=RMS(2)+DELL*DELL#                                                CD51  89
NRMS(2)=NRMS(2)+1#                                                      CD51  90
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD51  91
EB=((C*((DELL)*(DELL)))*0.5)#                                           CD51  92
E=E+EB#                                                                 CD51  93
M=WT(2)*(DELL*C)/BLV#                                                   CD51  94
#                                                                       CD51  95
#           ACCUMULATE THE FORCES.                                      CD51  96
DO J=1,3#                                                               CD51  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD51  98
COMP=M*V(J)#                                                            CD51  99
IF( KA !=0 ) force:(J,KA)=force:(J,KA)-COMP#                            CD51 100
IF( KB !=0 ) force:(J,KB)=force:(J,KB)+COMP#                            CD51 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD51 102
#                                                                       CD51 103
IF(ELIST>0.0)#                                                          CD51 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD51 105
IF(EB>ELIST)#                          Print out large bond energie     CD51 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD51 107
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   CD51 108
ICOL=2#                                Set-up column                    CD51 109
KD=(A-1)*STEPAT+STARAT#                                                 CD51 110
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD51 111
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD51 112
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD51 113
ICOL=ICOL+10#                                                           CD51 114
KD=(B-1)*STEPAT+STARAT#                                                 CD51 115
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD51 116
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD51 117
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD51 118
ncodefld:(BLO,1,CHROT,FMT(1),1)#                                        CD51 119
ncodefld:(BLV,1,CHROT,FMT(2),1)#                                        CD51 120
ncodefld:(C,1,CHROT,FMT(3),1)#                                          CD51 121
ncodefld:(EB,1,CHROT,FMT(4),1)#                                         CD51 122
writeline:(0,0,0,1,3)#                                                  CD51 123
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD51 124
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD51 125
#                                                                       CD51 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD51 127
FF(2)=E#                                                                CD51 128
#                                                                       CD51 129
RETURN#                                                                 CD51 130
END#                                                                    CD51 131
#####################################################################   CD51 132
systemheader:(CD52)#                                                    CD52   1
#                                                                       CD52   2
# FIND THE FORCE AND ENERGY OF ALL THE BONDANGLES                       CD52   3
#     BASED ON "THEFOR" ROUTINE OF JAN HERMANS                          CD52   4
#     CONVERTED TO RATMAC SEPT 22,1982 BY MIKE CARSON                   CD52   5
#                                                                       CD52   6
SUBROUTINE CD52#                       Thefor (force,e)       #         CD52   7
include:(AACOMN)#                                                       CD52   8
include:(CDCOMN)#                                                       CD52   9
#                                                                       CD52  10
# OUTPUT: REAL E==FF(3); FORCE:(3,*)                 #                  CD52  11
#    E: THE ENERGY VALUE NOW CONTAINS THE CONTRIBUTION FROM THESE       CD52  12
#       ANGLES.                                                         CD52  13
#    FORCE:: FORCE NOW CONTAINS THE CONTRIBUTIONS FROM THESE ANGLES     CD52  14
#    THEFOR CALLS:  CROSS==CD49                                         CD52  15
#                                                                       CD52  16
# INPUT:       REAL  DICT2:, DICT3:, WT                                 CD52  17
#              INTEGER  THESAV:, VPTR:, NT, TREE:                       CD52  18
#    VPTR::   FOR VARIABLE ATOMS, MAPPING FROM THE TREE KEY TO THE KEY  CD52  19
#            FOR FORCE. FOR NON-VARIABLE ATOMS, 0.                      CD52  20
#    THESAV:: LIST OF ALL PIVOT SETS THAT MUST BE PROCESSED TO FIND THE CD52  21
#            GRADIENT AND POTENTIAL ENERGY. THE FIRST ENTRY IS THE NUM- CD52  22
#            BER OF ATOMS IN THE PIVOT SET.  IF THE SET CONTAINS THE    CD52  23
#            BACKCHAIN ATOM OF THE PIVOT IT IS THE SECOND ENTRY. THE    CD52  24
#            PIVOT IS ALWAYS THE LAST ENTRY. THE OTHER ENTRIES ARE      CD52  25
#            ALL THE OTHER ATOMS BONDED TO THE PIVOT. PIVOT SETS        CD52  26
#            THAT CONTAIN ONLY TWO ATOMS ARE NOT SAVED. THE PIVOTSETS   CD52  27
#            CHARACTERIZE THE BONDANGLES.                               CD52  28
#    NT:     THE NUMBER OF PIVOTSETS IN THESAV:                         CD52  29
#    X:(3,*): THE LOCATIONS OF THE ATOMS.                               CD52  30
#    KEYDICT:(*) CONTAINS THE KEY TO DICT2: AND DICT3:                  CD52  31
#    DICT2:(4,*) FOR ANGLES CONTAINING THE PIVOT'S BACKCHAIN ATOM,      CD52  32
#       THE IDEAL ANGLE IS FOUND IS IN COLUMN 2, KEYED BY THE FOR-      CD52  33
#       WARD CHAIN BOND ATOM.                                           CD52  34
#    DICT3:(5,*) FOR ANGLES CONTAINING THE PIVOT'S BACKCHAIN ATOM,      CD52  35
#       THE ENERGY FUNCTION COEFFICIENT IS FOUND IN COLUMN 2,           CD52  36
#       KEYED BY THE FORWARD CHAIN BOND ATOM. FOR OTHER BONDANGLES,     CD52  37
#       THE IDEAL ANGLE IS THE SUM OF THE TWO VALUES IN COLUMN 5        CD52  38
#       KEYED BY THE THE TWO BOND ATOMS AND THE COEFFICIENT OF THE      CD52  39
#       ENERGY FUNCTION IS THE SUM OF THE TWO VALUES IN COLUMN 4        CD52  40
#       KEYED BY THE TWO BOND ATOMS.                                    CD52  41
#    WT: THE WEIGTHING FACTOR FOR THE FORCE AND ENERGY OF THE BOND-     CD52  42
#       ANGLES IS WT(3). THE REALISTIC VALUE IS 1. ONLY THE FORCES ARE  CD52  43
#       WEIGHTED IN THIS SUBROUTINE.                                    CD52  44
#                                                                       CD52  45
# INTERNAL VARIABLES:                                                   CD52  46
INTEGER   PIVOT#                       The key of the pivot atom.       CD52  47
INTEGER   IPS#                         Pivot set index and loop cou     CD52  48
INTEGER   N#                           The number of atoms bonded t     CD52  49
#                   THE LAST BOND ATOM.                                 CD52  50
INTEGER   KTR,JTR#                     Tree keys of the bond atoms      CD52  51
INTEGER   KP,KJ,KK#                    Keys to force.                   CD52  52
INTEGER   KDK,KDJ#                     Keys to dict2: and dict3:.       CD52  53
INTEGER   JAT,KAT#                     Keys to vec,vec2,lvec, and a     CD52  54
#                                SET IN THESAV:                         CD52  55
INTEGER  I, J, JM, K#                  Loop counters                    CD52  56
INTEGER T1,T2#                         Scatering factor type            CD52  57
REAL  VEC(3,5)#                        Contains the bondvectors.        CD52  58
REAL  LVEC(5)#                         Contains the lengths of the      CD52  59
REAL  VEC2(5)#                         Contains the inner products      CD52  60
#    NOTE: THE FIRST ENTRY OF VEC,VEC2,AND LVEC IS NOT USED TO STORE    CD52  61
#          DATA. IT FUNCTIONS AS AN OFFSET.                             CD52  62
REAL   VJ(3),VK(3)#                    The bondvectors forming a bo     CD52  63
REAL   VJDVK#                          The dot product of vj and vk     CD52  64
REAL   VJXVK(3)#                       The cross product of vj and      CD52  65
REAL   INNER#                          The inner product of vjxvk.      CD52  66
REAL   DGRK(3),DGRJ(3)#                                                 CD52  67
#   DGRJ(3): THE UNSIGNED DIRECTION OF THE GRADIENT CONTRIBUTION OF A   CD52  68
#            PARTICULAR BONDANGLE TO ATOM JAT.                          CD52  69
#   DGRK(3): THE SAME FOR ATOM KAT..                                    CD52  70
REAL   LPERP#                          Length of the cross product      CD52  71
REAL   THETA#                          The bondangle                    CD52  72
REAL   CON#                            The coefficient of the energ     CD52  73
REAL   THETAO#                         The ideal value for the bond     CD52  74
REAL   MJ,MK#                          Factors used to find the len     CD52  75
REAL   GJ,GK#                          The contribution to the grad     CD52  76
REAL   COSTHE,DELTHE#                  Cosine,delta theta               CD52  77
chardata:(HEAD, BOND ANGLE                           IDEAL  REAL   $#   CD52  78
CONSTANT ENERGY )#                                                      CD52  79
realdata:(FMT,[ 440712., 510712., 610712., 731122.])#                   CD52  80
datastuff:#                                                             CD52  81
#                                                                       CD52  82
IF(ELIST>0.0)writeline:(1,HEAD,NHEAD,3,3)#                              CD52  83
#                                                                       CD52  84
E=0.0#                                 Initialize energy to zero        CD52  85
DO IPS=1,NT#                                                            CD52  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD52  87
N=IFIX(thesav:(1,IPS))#                                                 CD52  88
NP1=N+1#                                                                CD52  89
PIVOT=IFIX(thesav:(NP1,IPS))#                                           CD52  90
# CALCULATE ALL THE BONDVECTORS AND THEIR INNER PRODUCTS AND LENGTHS.   CD52  91
DO K=2,N#                                                               CD52  92
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD52  93
VEC2(K)=0.0#                                                            CD52  94
DO J=1,3#                                                               CD52  95
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD52  96
ITHSOX=IFIX(thesav:(K,IPS))#                                            CD52  97
VEC(J,K)=x:(J,ITHSOX)-x:(J,PIVOT)#                                      CD52  98
VEC2(K)=VEC(J,K)*VEC(J,K)+VEC2(K)#                                      CD52  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD52 100
LVEC(K)=SQRT(VEC2(K))#                                                  CD52 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD52 102
KP=IFIX(vptr:(PIVOT))#                                                  CD52 103
DO JAT=3,N#                                                             CD52 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD52 105
JTR=IFIX(thesav:(JAT,IPS))#                                             CD52 106
KDJ=IFIX(keydict:(JTR))#                                                CD52 107
KJ=IFIX(vptr:(JTR))#                                                    CD52 108
JM=JAT-1#                                                               CD52 109
DO KAT=2,JM#                                                            CD52 110
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD52 111
#                         FIND THE COEFFICIENT OF THE ENERGY FUNCTION   CD52 112
#                          AND THE IDEAL VALUE OF THE BOND ANGLE        CD52 113
KTR=IFIX(thesav:(KAT,IPS))#                                             CD52 114
IF( KTR>=PIVOT )#                                                       CD52 115
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD52 116
KDK=IFIX(keydict:(KTR))#                                                CD52 117
THETAO=dict3:(5,KDJ)+dict3:(5,KDK)#                                     CD52 118
CON=dict3:(4,KDJ)+dict3:(4,KDK)#                                        CD52 119
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD52 120
ELSE#                                                                   CD52 121
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD52 122
THETAO=dict2:(2,KDJ)#                                                   CD52 123
CON=dict3:(2,KDJ)#                                                      CD52 124
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD52 125
#           LOCATE THE BONDVECTORS AND FIND THEIR DOT PRODUCT           CD52 126
VJDVK=0.0#                                                              CD52 127
VJDVK=0.0#                                                              CD52 128
DO I=1,3#                                                               CD52 129
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD52 130
VJ(I)=VEC(I,JAT)#                                                       CD52 131
VK(I)=VEC(I,KAT)#                                                       CD52 132
VJDVK=VJDVK+VJ(I)*VK(I)#                                                CD52 133
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD52 134
#     CALCULATE THE UNSIGNED GRADIENT DIRECTIONS AND ]](VJ)X(VK)]]      CD52 135
CALL CD49(VJ,VK,VJXVK)#                                                 CD52 136
CALL CD49(VJXVK,VJ,DGRJ)#              Form vector cross products       CD52 137
CALL CD49(VK,VJXVK,DGRK)#              With cd49                        CD52 138
INNER=0.0#                                                              CD52 139
DO I=1,3#                                                               CD52 140
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD52 141
INNER=INNER+VJXVK(I)*VJXVK(I)#                                          CD52 142
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD52 143
LPERP=SQRT(INNER)#                                                      CD52 144
IF(LPERP>=1.0E-10)#                                                     CD52 145
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD52 146
#     CALCULATE THETA,FIND THETA'S IDEAL VALUE. FIND THE BOND           CD52 147
#     CONSTANT. CALCULATE THE BOND ANGLE'S DEFORMATION ENERGY.          CD52 148
COSTHE=VJDVK/(LVEC(JAT)*LVEC(KAT))#                                     CD52 149
IF(COSTHE<-1.0) COSTHE=-1.0#                                            CD52 150
IF(COSTHE>1.0) COSTHE=1.0#                                              CD52 151
THETA=ACOS(COSTHE)#                                                     CD52 152
DELTHE=THETAO-THETA#                                                    CD52 153
T1=QX(STARAT+(JTR-1)*STEPAT+sfoff:)#                                    CD52 154
T2=QX(STARAT+(KTR-1)*STEPAT+sfoff:)#                                    CD52 155
IF(T1!=NUMHYD & T2!=NUMHYD)#                                            CD52 156
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD52 157
NRMS(3)=NRMS(3)+1#                                                      CD52 158
RMS(3)=RMS(3)+DELTHE*DELTHE#                                            CD52 159
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD52 160
EA=0.5*CON*((DELTHE)*(DELTHE))#                                         CD52 161
E=E+EA#                                                                 CD52 162
#                                  ACCUMULATE FORCES FOR THE VARIABLE A CD52 163
MJ=WT(3)*((DELTHE)*CON)/(LPERP*VEC2(JAT))#                              CD52 164
MK=WT(3)*((DELTHE)*CON)/(LPERP*VEC2(KAT))#                              CD52 165
KK=IFIX(vptr:(KTR))#                                                    CD52 166
DO I=1,3#                                                               CD52 167
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD52 168
GJ=MJ*DGRJ(I)#                                                          CD52 169
GK=MK*DGRK(I)#                                                          CD52 170
IF(KP !=0) force:(I,KP)=force:(I,KP)+(GJ+GK)#                           CD52 171
IF(KJ !=0) force:(I,KJ)=force:(I,KJ)-GJ#                                CD52 172
IF(KK !=0) force:(I,KK)=force:(I,KK)-GK#                                CD52 173
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD52 174
#                                                                       CD52 175
IF(ELIST>0.0)#                         List large energies              CD52 176
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD52 177
IF(EA>ELIST)#                                                           CD52 178
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CD52 179
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   CD52 180
ICOL=2#                                Set-up column                    CD52 181
KD=(KTR-1)*STEPAT+STARAT#                                               CD52 182
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD52 183
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD52 184
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD52 185
ICOL=ICOL+10#                                                           CD52 186
KD=(PIVOT-1)*STEPAT+STARAT#                                             CD52 187
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD52 188
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD52 189
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD52 190
ICOL=ICOL+10#                                                           CD52 191
KD=(JTR-1)*STEPAT+STARAT#                                               CD52 192
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD52 193
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD52 194
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD52 195
ATEMP=57.29577951*THETAO#                                               CD52 196
BTEMP=57.29577951*THETA#                                                CD52 197
ncodefld:(ATEMP,1,CHROT,FMT(1),1)#                                      CD52 198
ncodefld:(BTEMP,1,CHROT,FMT(2),1)#                                      CD52 199
ncodefld:(CON,1,CHROT,FMT(3),1)#                                        CD52 200
ncodefld:(EA,1,CHROT,FMT(4),1)#                                         CD52 201
writeline:(0,0,0,1,3)#                                                  CD52 202
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD52 203
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD52 204
#                                                                       CD52 205
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD52 206
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD52 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD52 208
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD52 209
FF(3)=E#                               Return the energy                CD52 210
#                                                                       CD52 211
RETURN#                                                                 CD52 212
END#                                                                    CD52 213
#####################################################################   CD52 214
systemheader:(CD53)#                                                    CD53   1
#                                                                       CD53   2
# COMPUTE THE DEFORMATION ENERGY AND FORCES OF THE DIHEDRALS            CD53   3
#                                                                       CD53   4
#   BASED ON THE 'DIFORC' SUBROUTINE OF JAN HERMANS                     CD53   5
#   CONVERTED TO RATMAC SEPT 22,1982 BY MIKE CARSON                     CD53   6
#                                                                       CD53   7
# SUBROUTINES CALLED:                                                   CD53   8
#   CD59: FINDS AND RETURNS THE IDEAL VALUE OF THE DIHEDRAL,THE         CD53   9
#         COEFFICIENT OF THE ENERGY FUNCTION, AND THE MULTIPLICITY.     CD53  10
#   CD49: VECTOR X-PRODUCT                                              CD53  11
#                                                                       CD53  12
SUBROUTINE CD53#                                                        CD53  13
include:(AACOMN)#                                                       CD53  14
include:(CDCOMN)#                                                       CD53  15
#                                                                       CD53  16
# OUTPUT: REAL   FORCE:(3,*); EFIX(==FF(4)); EFLEX(==FF(5))      #      CD53  17
#   FORCE:: THE FORCE NOW CONTAINS THE CONTRIBUTION FROM THE DIHEDRALS  CD53  18
#   EFIX: CONTAINS THE POTENTIAL ENERGY OF THE FIXED DIHEDRALS          CD53  19
#   EFLEX: CONTAINS THE POTENTIAL ENERGY OF THE FLEXIBLE DIHEDRALS.     CD53  20
REAL EFIX, EFLEX#                                                       CD53  21
#                                                                       CD53  22
# INPUT:      REAL  X:, WT                                              CD53  23
#             INTEGER  VPTR:, DISAVE:, ND                               CD53  24
#   X:: THE POSITIONS OF THE ATOMS.                                     CD53  25
#   VPTR::   FOR VARIABLE ATOMS, MAPPING FROM THE TREE KEY TO THE KEY   CD53  26
#         FOR FORCE:. FOR NON-VARIABLE ATOMS, 0.                        CD53  27
#   DISAVE:: LIST OF ALL DIHEDRAL ANGLES THAT MUST BE PROCESSED TO FIND CD53  28
#         THE GRADIENT AND THE POTENTIAL ENERGY. PLANAR PIVOT SET       CD53  29
#         TYPES ARE ENTERED IN THIS ORDER: PRIMARY FORWARD CHAIN,       CD53  30
#         'PIVOT',BACKCHAIN,SIDE CHAIN. THUS THE BACKCHAIN BOND WILL    CD53  31
#         BE TREATED AS THE  PIVOT BOND. IN OTHER CASES THE ORDER       CD53  32
#         WILL BE SUCH THAT THE CONNECTIVITY IS 1-2-3-4 AND ENTRY 3     CD53  33
#         HAS A GREATER TREE KEY VALUE THAN ENTRY 2.                    CD53  34
#   ND:   NUMBER OF DIHEDRALS IN DISAVE:.                               CD53  35
#   WT:   ENTRY 4 IS THE WEIGHTING OF THE FIXED DIHEDRALS, ENTRY 6 THAT CD53  36
#         OF THE FLEXIBLE DIHEDRALS. 1 IS THE REALISTIC VALUE FOR THESE CD53  37
#                                                                       CD53  38
# INTERNAL VARIABLES:                                                   CD53  39
INTEGER   AV,AS#                       The two end atoms                CD53  40
INTEGER   AT,AO#                       'torque', 'origin'  atoms        CD53  41
INTEGER   KV,KT,KO,KS#                 Keys to force:.                  CD53  42
INTEGER T1,T2#                         Scat fac types                   CD53  43
REAL   V(3)#                           The vector ao->av.               CD53  44
REAL   T(3)#                           The vector ao->at.               CD53  45
REAL   S(3)#                           The vector at->av.               CD53  46
REAL   H(3)#                           The vector ao->as.               CD53  47
REAL   TDT#                            The inner product of t.          CD53  48
REAL   IVTDT#                          The inverse of tdt.              CD53  49
REAL   TDS#                            The dot product of t and s       CD53  50
REAL   TDV#                            The dot product of t and v.      CD53  51
REAL  PV(3)#                           The component of v perpendic     CD53  52
REAL  PS(3)#                           The component of s perpendic     CD53  53
REAL  PVDPV#                           The inner product of pv.         CD53  54
REAL  PSDPS#                           The inner product of ps.         CD53  55
REAL  PVDPS#                           The dot product of pv and ps     CD53  56
REAL  PVXPS(3)#                        The cross product of pv and      CD53  57
REAL  LPVXPS#                          The length of pvxps              CD53  58
REAL  INNER#                           The inner product of pvxps       CD53  59
REAL  DENOM#                           The length of pv times the l     CD53  60
REAL   TMF,SMF#                        Useful coefficients              CD53  61
REAL   RO,ROO#                         The dihedral angle, the idea     CD53  62
REAL   MIF#                            Multiplicity for flexible di     CD53  63
REAL  DGRV(3)#                         The unsigned direction of th     CD53  64
REAL  DGRS(3)#                         The unsigned direction of th     CD53  65
REAL   CON#                            The dihedral constant            CD53  66
REAL   MV,MS#                          Useful coefficients              CD53  67
REAL  TVAL#                            Helps get mv,ms                  CD53  68
REAL  GV(3)#                           The deformation gradient for     CD53  69
REAL  GS(3)#                           The deformation gradient for     CD53  70
REAL  GT(3)#                           The deformation gradient for     CD53  71
REAL  HXGS(3)#                         The negation of the torque a     CD53  72
REAL  VXGV(3)#                         The negation of the torque a     CD53  73
REAL  SUMTQU(3)#                       The sum of vxgv and hxgs.        CD53  74
REAL  STQUXT(3)#                       The cross product of sumtqu      CD53  75
REAL COSRO,DRO,WDRO#                   Cosine,delta,weighteddelta r     CD53  76
REAL EDIHRL#                           Energy of dihedral               CD53  77
INTEGER ID, J#                         Loop counters                    CD53  78
chardata:(HEAD, DIHEDRAL ANGLE                                  $#      CD53  79
IDEAL  REAL   CONSTANT ENERGY )#                                        CD53  80
realdata:(FMT,[540712., 610712., 640313., 710712., 780722.])#           CD53  81
datastuff:#                                                             CD53  82
#                                                                       CD53  83
IF(ELIST>0.0)writeline:(1,HEAD,NHEAD,3,3)#                              CD53  84
#                                                                       CD53  85
EFIX=0.0 ;  EFLEX=0.0#                 Init. energy to zero             CD53  86
DO ID=1,ND#                                                             CD53  87
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD53  88
AV=IFIX(disave:(1,ID))#                                                 CD53  89
AO=IFIX(disave:(2,ID))#                                                 CD53  90
AT=IFIX(disave:(3,ID))#                                                 CD53  91
AS=IFIX(disave:(4,ID))#                                                 CD53  92
DO J=1,3#                              Find the bond vectors and th     CD53  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD53  94
V(J)=x:(J,AV)-x:(J,AO)#                                                 CD53  95
T(J)=x:(J,AT)-x:(J,AO)#                                                 CD53  96
H(J)=x:(J,AS)-x:(J,AO)#                                                 CD53  97
S(J)=x:(J,AS)-x:(J,AT)#                                                 CD53  98
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD53  99
TDT=0.0#                               Calculate tdt,tds,tdv            CD53 100
TDS=0.0#                                                                CD53 101
TDV=0.0#                                                                CD53 102
DO J=1,3#                                                               CD53 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD53 104
TDT=T(J)*T(J)+TDT#                                                      CD53 105
TDV=T(J)*V(J)+TDV#                                                      CD53 106
TDS=T(J)*S(J)+TDS#                                                      CD53 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD53 108
TMF=TDV/TDT#                           Calculate ps,pv,lps,lpv          CD53 109
SMF=TDS/TDT#                                                            CD53 110
PVDPV=0.0#                                                              CD53 111
PSDPS=0.0#                                                              CD53 112
PVDPS=0.0#                                                              CD53 113
DO J=1,3#                                                               CD53 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD53 115
PV(J)=V(J)-(TMF*T(J))#                                                  CD53 116
PVDPV=PV(J)*PV(J)+PVDPV#                                                CD53 117
PS(J)=S(J)-(SMF*T(J))#                                                  CD53 118
PSDPS=PS(J)*PS(J)+PSDPS#                                                CD53 119
PVDPS=PV(J)*PS(J)+PVDPS#                                                CD53 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD53 121
DENOM=SQRT(PSDPS*PVDPV)#                                                CD53 122
#                                                                       CD53 123
#          CALCULATE THE UNSIGNED DIRECTION OF THE GRADIENT OF AV,AS.   CD53 124
CALL CD49(PV,PS,PVXPS)#                                                 CD53 125
CALL CD49(PS,PVXPS,DGRS)#              Form vector cross products       CD53 126
CALL CD49(PVXPS,PV,DGRV)#              With subroutine cd49             CD53 127
INNER=0.0#                                                              CD53 128
DO J=1,3#                                                               CD53 129
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD53 130
INNER=INNER+(PVXPS(J)*PVXPS(J))#                                        CD53 131
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD53 132
IF(INNER>=1.0E-20)#                    Next dihedral angle              CD53 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD53 134
LPVXPS=SQRT(INNER)#                                                     CD53 135
COSRO=PVDPS/SQRT(PSDPS*PVDPV)#                                          CD53 136
IF(COSRO>1.0) COSRO=1.0#                                                CD53 137
IF(COSRO<-1.0) COSRO=-1.0#                                              CD53 138
RO=ACOS(COSRO)#                                                         CD53 139
#                                                                       CD53 140
#           GET NECESSARY CONSTANTS AND COMPUTE E                       CD53 141
#            AND THE FACTORS OF THE GRADIENTS FOR AS AND AV.            CD53 142
CALL CD59(CON,ROO,MIF,AV,AO,AT,AS)#                                     CD53 143
DRO=ROO-RO#                                                             CD53 144
IF( MIF !=0.0 )#                                                        CD53 145
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD53 146
WDRO=MIF*DRO#                                                           CD53 147
SINDRO=SIN(WDRO)#                                                       CD53 148
DRO=ASIN(SINDRO)/MIF#                                                   CD53 149
T1=QX(STARAT+(AV-1)*STEPAT+sfoff:)#                                     CD53 150
T2=QX(STARAT+(AS-1)*STEPAT+sfoff:)#                                     CD53 151
IF(T1!=NUMHYD & T2!=NUMHYD)#                                            CD53 152
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD53 153
NRMS(5)=NRMS(5)+1#                                                      CD53 154
RMS(5)=RMS(5)+DRO*DRO#                                                  CD53 155
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD53 156
TVAL=WT(5)*0.5*CON*MIF*SINDRO/LPVXPS#                                   CD53 157
EDIHRL=0.5*CON*(1.0-COS(WDRO))#                                         CD53 158
EFLEX=EDIHRL+EFLEX#                                                     CD53 159
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD53 160
ELSE#                                                                   CD53 161
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD53 162
TVAL=WT(4)*(DRO*CON)/LPVXPS#                                            CD53 163
T1=QX(STARAT+(AV-1)*STEPAT+sfoff:)#                                     CD53 164
T2=QX(STARAT+(AS-1)*STEPAT+sfoff:)#                                     CD53 165
IF(T1!=NUMHYD & T2!=NUMHYD)#                                            CD53 166
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD53 167
NRMS(4)=NRMS(4)+1#                                                      CD53 168
RMS(4)=RMS(4)+DRO*DRO#                                                  CD53 169
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD53 170
EDIHRL=0.5*CON*(DRO*DRO)#                                               CD53 171
EFIX=EDIHRL+EFIX#                                                       CD53 172
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD53 173
IF(ELIST>0.0)#                                                          CD53 174
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD53 175
IF(EDIHRL>ELIST)#                                                       CD53 176
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD53 177
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   CD53 178
ICOL=2#                                Set-up column                    CD53 179
KD=(AV-1)*STEPAT+STARAT#                                                CD53 180
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD53 181
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD53 182
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD53 183
ICOL=ICOL+10#                                                           CD53 184
KD=(AO-1)*STEPAT+STARAT#                                                CD53 185
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD53 186
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD53 187
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD53 188
ICOL=ICOL+10#                                                           CD53 189
KD=(AT-1)*STEPAT+STARAT#                                                CD53 190
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD53 191
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD53 192
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD53 193
ICOL=ICOL+10#                                                           CD53 194
KD=(AS-1)*STEPAT+STARAT#                                                CD53 195
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD53 196
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD53 197
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD53 198
ATEMP=57.29577951*ROO#                                                  CD53 199
BTEMP=57.29577951*RO#                                                   CD53 200
ncodefld:(ATEMP,1,CHROT,FMT(1),1)#                                      CD53 201
ncodefld:(BTEMP,1,CHROT,FMT(2),1)#                                      CD53 202
ncodefld:(MIF,1,CHROT,FMT(3),1)#                                        CD53 203
ncodefld:(CON,1,CHROT,FMT(4),1)#                                        CD53 204
ncodefld:(EDIHRL,1,CHROT,FMT(5),1)#                                     CD53 205
writeline:(0,0,0,1,3)#                                                  CD53 206
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD53 207
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD53 208
MV=TVAL/PVDPV#                                                          CD53 209
MS=TVAL/PSDPS#                                                          CD53 210
KV=IFIX(vptr:(AV))#                                                     CD53 211
KO=IFIX(vptr:(AO))#                                                     CD53 212
KT=IFIX(vptr:(AT))#                                                     CD53 213
KS=IFIX(vptr:(AS))#                                                     CD53 214
#          FIND THE DEFORMATION GRADIENT FOR AV AND AS                  CD53 215
#          ACCUMULATE TOTAL FORCE FOR VARIABLE ATOMS.                   CD53 216
DO J=1,3#                                                               CD53 217
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD53 218
GV(J)=MV*DGRV(J)#                                                       CD53 219
IF( KV !=0) force:(J,KV)=force:(J,KV)-GV(J)#                            CD53 220
GS(J)=MS*DGRS(J)#                                                       CD53 221
IF(KS !=0) force:(J,KS)=force:(J,KS)-GS(J)#                             CD53 222
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD53 223
# IF KO AND KT ARE NOT VARIABLE ATOMS, SKIP THE REMAINING CALCULATIONS  CD53 224
IF((KO !=0) \ (KT !=0))#                                                CD53 225
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CD53 226
#                                                                       CD53 227
# CALCULATE THE DEFORMATION GRADIENT FOR AT, USING THE CONSERVATION     CD53 228
# OF ANGULAR MOMENTUM AROUND THE POSITION OF AO.                        CD53 229
#                                                                       CD53 230
# CALCULATE THE SUM OF THE TORQUES OF AV,AS AROUND AO.                  CD53 231
CALL CD49(H,GS,HXGS)#                                                   CD53 232
CALL CD49(V,GV,VXGV)#                                                   CD53 233
DO J=1,3#                                                               CD53 234
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CD53 235
SUMTQU(J)=HXGS(J)+VXGV(J)#                                              CD53 236
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CD53 237
#                                                                       CD53 238
# GT=(-SUMTQU)X(T)/TDT, SINCE T AND GT MUST BE PERPENDICULAR.           CD53 239
CALL CD49(SUMTQU,T,STQUXT)#                                             CD53 240
#1    WRITE(6,L13)                                                      CD53 241
IVTDT=1.0/TDT#                                                          CD53 242
DO J=1,3#                                                               CD53 243
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CD53 244
GT(J)=-STQUXT(J)*IVTDT#                                                 CD53 245
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CD53 246
#                                                                       CD53 247
# ACCUMULATE THE DEFORMATION FORCES OF GT AND GO IN 'FORCE:'.           CD53 248
IF( KT !=0)#                                                            CD53 249
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CD53 250
DO J=1,3#                                                               CD53 251
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CD53 252
force:(J,KT)=force:(J,KT)-GT(J)#                                        CD53 253
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CD53 254
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CD53 255
IF(KO !=0)#                                                             CD53 256
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CD53 257
DO J=1,3#                                                               CD53 258
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CD53 259
force:(J,KO)=force:(J,KO)+GT(J)+GV(J)+GS(J)#                            CD53 260
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CD53 261
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CD53 262
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD53 263
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD53 264
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD53 265
FF(4)=EFIX#                                                             CD53 266
FF(5)=EFLEX#                           Return energy values             CD53 267
#                                                                       CD53 268
RETURN#                                                                 CD53 269
END#                                                                    CD53 270
#####################################################################   CD53 271
systemheader:(CD54)#                                                    CD54   1
#                                                                       CD54   2
#   CALCULATE SUM OF WEIGHTED SQUARED DISPLACEMENTS AND FORCES          CD54   3
#   CALCULATE A (SPRING-LIKE) ENERGY PENALTY FOR                        CD54   4
#    MOVEMENT OF AN ATOM AWAY FROM IT'S ORIGINAL POSITION               CD54   5
#   MODIFIED 22-JAN-81 BY KDW      # RATIFIED 11-MAR-82 MC              CD54   6
#   MODIFIED AUG-1988, KDW                                              CD54   7
#   BASED ON THE "TARGET" SUBROUTINE OF JAN HERMANS                     CD54   8
#                                                                       CD54   9
SUBROUTINE CD54(F)#                    -old target (x1,x2,force,f)      CD54  10
include:(AACOMN)#                                                       CD54  11
include:(CDCOMN)#                                                       CD54  12
#                                                                       CD54  13
#   WT(1)=GLOBAL WEIGHT FOR THE TARGET CONTRIBUTION                     CD54  14
#   FF(1)=TARGET TERM      FF(1)*WT(1)=CONTRIBUTION TO F                CD54  15
#   NVAR=NUMBER OF VARIABLE ATOMS                                       CD54  16
#   WINV:(I)=VARIANCE OF ATOM POSITION                                  CD54  17
#   X0:(3,*)=CURRENT POSITIONS OF MOVING ATOMS                          CD54  18
#   X2:(3,*)=TARGET POSITIONS OF MOVING ATOMS                           CD54  19
#   FORCE:(3,*)=FORCES                                                  CD54  20
REAL F#                                F=total function (=energy)       CD54  21
#                                                                       CD54  22
INTEGER I,J#                                                            CD54  23
REAL  FT, WW#                                                           CD54  24
REAL DIS#                              Distance to target positions     CD54  25
chardata:(HEAD, TARGET             DISTANCE WT*DISTANCE$#               CD54  26
     ENERGY )#                                                          CD54  27
realdata:(FMT,[ 250722., 320722.])#                                     CD54  28
datastuff:#                                                             CD54  29
#                                                                       CD54  30
IF(ELIST>0.0)writeline:(1,HEAD,NHEAD,3,3)#                              CD54  31
#                                                                       CD54  32
#                                                                       CD54  33
FF(1)=0.0#                                                              CD54  34
IF(WT(1) !=0.)#                                                         CD54  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD54  36
DO L=1,NUMATM#                                                          CD54  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD54  38
I=keyvar:(L)#                                                           CD54  39
IF(I<0.5) NEXT#                        Don't include non-moving ato     CD54  40
IF(winv:(L)==0.0) NEXT#                Don't include zero weighted      CD54  41
WW=(-2.)*WT(1)/winv:(L)#                                                CD54  42
DIS=0.0#                                                                CD54  43
FT=0.#                                                                  CD54  44
DO J=1,3#                                                               CD54  45
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD54  46
VEC=x0:(J,I)-x2:(J,I)#                                                  CD54  47
RMS(1)=RMS(1)+VEC*VEC#                                                  CD54  48
DIS=DIS+VEC*VEC#                                                        CD54  49
FT=FT+VEC**2/winv:(L)#                                                  CD54  50
IF(WW !=0.)#                                                            CD54  51
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD54  52
force:(J,I)=WW*VEC+force:(J,I)#                                         CD54  53
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD54  54
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD54  55
FF(1)=FF(1)+FT#                                                         CD54  56
IF(ELIST>0.0)#                                                          CD54  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD54  58
IF(FT>ELIST)#                          Print out large bond energie     CD54  59
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD54  60
DIS=SQRT(DIS)#                                                          CD54  61
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   CD54  62
ICOL=2#                                Set-up column                    CD54  63
KD=(I-1)*STEPAT+STARAT#                                                 CD54  64
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD54  65
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD54  66
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD54  67
ncodefld:(DIS,1,CHROT,FMT(1),1)#                                        CD54  68
ncodefld:(FT,1,CHROT,FMT(2),1)#                                         CD54  69
writeline:(0,0,0,1,3)#                                                  CD54  70
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD54  71
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD54  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD54  73
F=F+WT(1)*FF(1)#                                                        CD54  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD54  75
RETURN#                                                                 CD54  76
END#                                                                    CD54  77
#####################################################################   CD54  78
systemheader:(CD55)#                                                    CD55   1
#                                                                       CD55   2
# CALCULATE A PENALTY FUNCTION FOR ERRORS IN CHIRALITY                  CD55   3
# THE FUNCTION IS:                                                      CD55   4
#  ECHIR==FF(7)=WTCHIR * CHICON * [(RO-ROO)**2-DELCHI**2]**2            CD55   5
#   HERE: WTCHIR==WT(7) IN COMMON (SET IT TO ZERO OR ONE)               CD55   6
#         CHICON IN DATA STMT (=10.)                                    CD55   7
#         ROO IS CALCULATED FROM DICTIONARY VALUES                      CD55   8
#         RO IS THE BRANCH DIHEDRAL (SIGNED)                            CD55   9
#         DELCHI INITIALIZED TO PI/6.                                   CD55  10
#                                                                       CD55  11
# COMMON: VPTR: GIVES VARIABLE INDEX FOR EACH ATOM                      CD55  12
#         FORCE: IS ARRAY OF FORCE:S, ECHIR IS SUMMED PENALTY TERM      CD55  13
#         NCHIR=NUMBER OF ASYMMETRIC CENTERS                            CD55  14
#         WT(7)=WEIGHT FOR ECHIR (IF ZERO, SKIP CALCN.)                 CD55  15
#         CHISAV:=4 ATOMS MAKING THE BRANCH DIHEDRAL                    CD55  16
#           1ST=BRANCH, 2ND=FORK, 3D=STEM, 4TH=REFERENCE FOR BRANCH     CD55  17
#                                                                       CD55  18
#         BASED ON "CHIFOR" SUBROUTINE OF JAN HERMANS                   CD55  19
#         CONVERTED TO RATMAC SEPT 24, 1982 BY MIKE CARSON              CD55  20
#                                                                       CD55  21
SUBROUTINE CD55#                       -old chifor(force)               CD55  22
include:(AACOMN)#                                                       CD55  23
include:(CDCOMN)#                                                       CD55  24
#                                                                       CD55  25
#  CHIFOR CALLS:   ATAN2,  CD49=VECTOR CROSS PRODUCT, SQRT              CD55  26
#                                                                       CD55  27
#  2 CHICO4 5 DEL 2 DELCH2 3 DELCHI 10 DRO                              CD55  28
# 13 I 5 ICHIR 2 INX 2 INX1 2 IVTDT                                     CD55  29
# 35 J 5 KO 4 KS 5 KT 4 KV                                              CD55  30
# 2 PSDPS 2 PVDPS 2 PVDPV 4 PVXPS 2 RO 4 ROO                            CD55  31
#  2 SINRO 2 SMF 2 SQRT  2 TDS 5 TDT 2 TDV                              CD55  32
#  2 TMF 3 TVAL  2 VXGV                                                 CD55  33
#                                                                       CD55  34
REAL V(3),T(3),H(3),S(3),PV(3),PS(3)#                                   CD55  35
REAL DGRS(3),DGRV(3),GV(3),GS(3),HXGS(3)#                               CD55  36
REAL VXGV(3),GT(3),PVXPS(3),SUMTQU(3),STQUXT(3)#                        CD55  37
REAL LPVXPS,LT,MS,MV#                                                   CD55  38
REAL ECHIR#                            Energy for chiral center         CD55  39
REAL FMT(4)#                                                            CD55  40
INTEGER AV,AT,AO,AS#                                                    CD55  41
LOGICAL NEW#                                                            CD55  42
#                                                                       CD55  43
chardata:(HEAD, CHIRALITY DIHEDRAL                           IDEAL  $#  CD55  44
REAL   CONSTANT ROT_MIN ENERGY )#                                       CD55  45
datastuff:#                                                             CD55  46
DATA FMT / 540712., 610712., 670612., 750822./#                         CD55  47
DATA PI/3.141592654/, CHICON/10./, NEW/.TRUE./#                         CD55  48
#                                                                       CD55  49
#      ***   CODE BEGINS   ***                                          CD55  50
#                                                                       CD55  51
IF(ELIST>0.0)writeline:(1,HEAD,NHEAD,3,3)#                              CD55  52
#                                                                       CD55  53
IF(NEW)#                                                                CD55  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD55  55
NEW=.FALSE.#                                                            CD55  56
DELCHI=PI/6#                                                            CD55  57
CHICO4=4.*CHICON#                                                       CD55  58
WT(7)=1.#                                                               CD55  59
DELCH2=DELCHI*DELCHI#                                                   CD55  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD55  61
FF(7)=0.0#                                                              CD55  62
DO ICHIR=1,NCHIR#                                                       CD55  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD55  64
AV=IFIX(chisav:(1,ICHIR))#                                              CD55  65
AO=IFIX(chisav:(2,ICHIR))#                                              CD55  66
AT=IFIX(chisav:(3,ICHIR))#                                              CD55  67
AS=IFIX(chisav:(4,ICHIR))#                                              CD55  68
INX=IFIX(keydict:(AS))#                                                 CD55  69
INX1=IFIX(keydict:(AV))#                                                CD55  70
ROO=dict2:(3,INX)-dict2:(3,INX1)#                                       CD55  71
#               CHANGE SIGN OF ROO-JULY 1981                            CD55  72
ROO=-ROO#                                                               CD55  73
#                                                                       CD55  74
DO I=1,3#                                                               CD55  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD55  76
V(I)=x:(I,AV)-x:(I,AO)#                                                 CD55  77
T(I)=x:(I,AT)-x:(I,AO)#                                                 CD55  78
H(I)=x:(I,AS)-x:(I,AO)#                                                 CD55  79
S(I)=x:(I,AS)-x:(I,AT)#                                                 CD55  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD55  81
#                                  FORM SCALAR PRODUCTS                 CD55  82
TDT=T(1)*T(1)+T(2)*T(2)+T(3)*T(3)#     T() dot t() , etc.               CD55  83
TDS=T(1)*S(1)+T(2)*S(2)+T(3)*S(3)#                                      CD55  84
TDV=T(1)*V(1)+T(2)*V(2)+T(3)*V(3)#                                      CD55  85
TMF=TDV/TDT#                                                            CD55  86
SMF=TDS/TDT#                                                            CD55  87
DO J=1,3#                                                               CD55  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD55  89
PV(J)=V(J)-TMF*T(J)#                                                    CD55  90
PS(J)=S(J)-SMF*T(J)#                                                    CD55  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD55  92
#                                  FORM SCALAR PRODUCTS                 CD55  93
PVDPV=PV(1)*PV(1)+PV(2)*PV(2)+PV(3)*PV(3)#                              CD55  94
PSDPS=PS(1)*PS(1)+PS(2)*PS(2)+PS(3)*PS(3)#                              CD55  95
PVDPS=PV(1)*PS(1)+PV(2)*PS(2)+PV(3)*PS(3)#                              CD55  96
#                                  DENOM=SQRT(PSDPS*PVDPV)              CD55  97
CALL  CD49(PV,PS,PVXPS)#                                                CD55  98
CALL  CD49(T,PS,DGRS)#                                                  CD55  99
CALL  CD49(T,PV,DGRV)#                                                  CD55 100
LPVXPS=PVXPS(1)*PVXPS(1)+PVXPS(2)*PVXPS(2)+PVXPS(3)*PVXPS(3)#           CD55 101
LPVXPS=SQRT(LPVXPS)#                                                    CD55 102
#                                  COSRO=PVDPS/DENOM                    CD55 103
LT=SQRT(TDT)#                                                           CD55 104
#                                  SINRO=SCPR(T,PVXPS)/(LT*DENOM)       CD55 105
SINRO=T(1)*PVXPS(1)+T(2)*PVXPS(2)+T(3)*PVXPS(3)#                        CD55 106
SINRO=SINRO/LT#                                                         CD55 107
#                                  RO=ATAN2(SINRO,COSRO)                CD55 108
#                                  COSRO AND SINRO ARE CALCULATED VALUE CD55 109
RO=ATAN2(SINRO,PVDPS)#                                                  CD55 110
DRO=RO-ROO#                                                             CD55 111
#                                                                       CD55 112
#                                                                       CD55 113
IF(DRO>PI) DRO=DRO-PI-PI#                                               CD55 114
IF(DRO<-PI) DRO=DRO+PI+PI#                                              CD55 115
DEL=DRO*DRO-DELCH2#                                                     CD55 116
IF(DEL>=0.)#                                                            CD55 117
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD55 118
NRMS(7)=NRMS(7)#                                                        CD55 119
RMS(7)=RMS(7)+DEL*DEL#                                                  CD55 120
ECHIR=CHICON*DEL*DEL#                                                   CD55 121
FF(7)=ECHIR+FF(7)#                                                      CD55 122
TVAL=WT(7)*CHICO4*DRO*DEL/LT#                                           CD55 123
IF(ELIST>0.0) $(#                                                       CD55 124
IF(ECHIR>ELIST)#                                                        CD55 125
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD55 126
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   CD55 127
ICOL=2#                                Set-up column                    CD55 128
KD=(AV-1)*STEPAT+STARAT#                                                CD55 129
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD55 130
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD55 131
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD55 132
ICOL=ICOL+10#                                                           CD55 133
KD=(AO-1)*STEPAT+STARAT#                                                CD55 134
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD55 135
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD55 136
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD55 137
ICOL=ICOL+10#                                                           CD55 138
KD=(AT-1)*STEPAT+STARAT#                                                CD55 139
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD55 140
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD55 141
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD55 142
ICOL=ICOL+10#                                                           CD55 143
KD=(AS-1)*STEPAT+STARAT#                                                CD55 144
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD55 145
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD55 146
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD55 147
ATEMP=57.29577951*ROO#                                                  CD55 148
BTEMP=57.29577951*RO#                                                   CD55 149
ncodefld:(ATEMP,1,CHROT,FMT(1),1)#                                      CD55 150
ncodefld:(BTEMP,1,CHROT,FMT(2),1)#                                      CD55 151
ncodefld:(CHICON,1,CHROT,FMT(3),1)#                                     CD55 152
ncodefld:(ECHIR,1,CHROT,FMT(4),1)#                                      CD55 153
writeline:(0,0,0,1,3)#                                                  CD55 154
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD55 155
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD55 156
MV=-TVAL/PVDPV#                                                         CD55 157
MS=TVAL/PSDPS#                                                          CD55 158
KV=IFIX(vptr:(AV))#                                                     CD55 159
KO=IFIX(vptr:(AO))#                                                     CD55 160
KT=IFIX(vptr:(AT))#                                                     CD55 161
KS=IFIX(vptr:(AS))#                                                     CD55 162
DO J=1,3#                                                               CD55 163
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD55 164
GV(J)=MV*DGRV(J)#                                                       CD55 165
IF(KV !=0) force:(J,KV)=force:(J,KV)-GV(J)#                             CD55 166
GS(J)=MS*DGRS(J)#                                                       CD55 167
IF(KS !=0) force:(J,KS)=force:(J,KS)-GS(J)#                             CD55 168
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD55 169
IF( KO !=0 \ KT !=0 )#                 If ko and kt are not variabl     CD55 170
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD55 171
#      CALCULATE THE DEFORMATION GRADIENT FOR AT, USING THE CONSERVATIO CD55 172
#       OF ANGULAR MOMENTUM AROUND THE POSITION OF AO.                  CD55 173
#                                                                       CD55 174
#                     CALCULATE THE SUM OF THE TORQUES OF AV,AS AROUND  CD55 175
CALL  CD49(H,GS,HXGS)#                                                  CD55 176
CALL  CD49(V,GV,VXGV)#                 Vector cross products            CD55 177
#                                                                       CD55 178
DO J=1,3#                                                               CD55 179
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD55 180
SUMTQU(J)=HXGS(J)+VXGV(J)#                                              CD55 181
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD55 182
#                                                                       CD55 183
# GT=(-SUMTQU)X(T)/TDT, SINCE T AND GT MUST BE PERPENDICULAR.           CD55 184
CALL  CD49(SUMTQU,T,STQUXT)#                                            CD55 185
IVTDT=1.0/TDT#                                                          CD55 186
DO J=1,3#                                                               CD55 187
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD55 188
GT(J)=-STQUXT(J)*IVTDT#                                                 CD55 189
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD55 190
#                                                                       CD55 191
# ACCUMULATE THE DEFORMATION FORCES OF GT AND GO IN 'FORCE:'.           CD55 192
IF(KT !=0)#                                                             CD55 193
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD55 194
DO J=1,3#                                                               CD55 195
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD55 196
force:(J,KT)=force:(J,KT)-GT(J)#                                        CD55 197
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD55 198
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD55 199
IF(KO !=0)#                                                             CD55 200
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CD55 201
DO J=1,3#                                                               CD55 202
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CD55 203
force:(J,KO)=force:(J,KO)+(GT(J)+GV(J)+GS(J))#                          CD55 204
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CD55 205
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD55 206
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD55 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD55 208
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD55 209
RETURN#                                                                 CD55 210
END#                                                                    CD55 211
#####################################################################   CD55 212
systemheader:(CD56)#                                                    CD56   1
#                                                                       CD56   2
#     CALCULATE ENERGY AND FORCE FOR WATER MOLECULES BONDLENGTH AND     CD56   3
# BONDANGLE DEFORMATION.  BONDANGLE BEND IS DONE AS STRETCH OF A THIRD  CD56   4
# BOND.  WATERS MUST BEGIN AT NATP+1, END AT NUMATM.  OXYGEN IS FIRST A CD56   5
# THIS ROUTINE IS TO BE USED WITH THE CONJ. GRAD. MINIMIZER.            CD56   6
#    FORCE:(3,NVAR) IS ARRAY OF FORCES.   E IS TOTAL ENERGY.            CD56   7
#                                                                       CD56   8
#  BASED ON "BLWAT" SUBROUTINE OF JAN HERMANS                           CD56   9
#  CONVERTED TO RATMAC BY MIKE CARSON SEPT 24,1982                      CD56  10
#                                                                       CD56  11
SUBROUTINE CD56(E)#                    -old blwat(force,e)              CD56  12
include:(AACOMN)#                                                       CD56  13
include:(CDCOMN)#                                                       CD56  14
#                                                                       CD56  15
REAL  E#                                                                CD56  16
REAL  V(3)#                                                             CD56  17
REAL  FC12,FC23,BL12,BL23#                                              CD56  18
REAL  BL,BLX,COMP,DE,DELE,DL,FCX,SCPR#                                  CD56  19
INTEGER IA,IAT,IATV,IB,IBTV,IW,J,KOUNT,NATP1#                           CD56  20
#                                                                       CD56  21
DATA FC12,FC23/750.,75./,BL12,BL23/1.00,1.581/#                         CD56  22
#                                                                       CD56  23
IF(NATP<NUMATM)#                                                        CD56  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD56  25
NATP1=NATP+1#                                                           CD56  26
DO IAT=NATP1,NUMATM,3#                                                  CD56  27
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD56  28
IA=IAT#                                                                 CD56  29
IATV=IFIX(keyvar:(IA))#                                                 CD56  30
IF(IATV>0)#                                                             CD56  31
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD56  32
IW=2#                                                                   CD56  33
FCX=FC12#                                                               CD56  34
BLX=BL12#                                                               CD56  35
#                            BEGIN BY CALCULATING TWO O-H STRETCHES     CD56  36
IB=IA#                                                                  CD56  37
IBTV=IATV#                                                              CD56  38
KOUNT=0#                                                                CD56  39
REPEAT#                                                                 CD56  40
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD56  41
KOUNT=KOUNT+1#                                                          CD56  42
IF(KOUNT<3)#                                                            CD56  43
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD56  44
IB=IB+1#                                                                CD56  45
IBTV=IBTV+1#                                                            CD56  46
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD56  47
ELSE#                                                                   CD56  48
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD56  49
IF(KOUNT!=3)#                                                           CD56  50
BREAK#                                                                  CD56  51
#                            SET UP FOR THE H-H 'BOND'                  CD56  52
IA=IA+1#                                                                CD56  53
IATV=IBTV-1#                                                            CD56  54
IW=3#                                                                   CD56  55
BLX=BL23#                                                               CD56  56
FCX=FC23#                                                               CD56  57
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD56  58
#                            COMMON PORTION                             CD56  59
DO J=1,3#                                                               CD56  60
V(J)=x:(J,IA)-x:(J,IB)#                                                 CD56  61
#                                   CALCULATE SCALAR PRODUCT OF V()     CD56  62
SCPR=V(1)*V(1)+V(2)*V(2)+V(3)*V(3)#                                     CD56  63
BL=SQRT(SCPR)#                                                          CD56  64
DL=BL-BLX#                                                              CD56  65
DELE=FCX*0.5*DL*DL#                                                     CD56  66
FF(IW)=DELE+FF(IW)#                                                     CD56  67
E=DELE*WT(IW)+E#                                                        CD56  68
DE=WT(IW)*DL*FCX/BL#                                                    CD56  69
DO J=1,3#                                                               CD56  70
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD56  71
COMP=DE*V(J)#                                                           CD56  72
force:(J,IATV)=-COMP+force:(J,IATV)#                                    CD56  73
force:(J,IBTV)=COMP+force:(J,IBTV)#                                     CD56  74
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD56  75
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD56  76
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD56  77
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD56  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD56  79
RETURN#                                                                 CD56  80
END#                                                                    CD56  81
#####################################################################   CD56  82
systemheader:(CD57)#                                                    CD57   1
#                                                                       CD57   2
#    CALCULATE NONBONDED ENERGY AND FORCES FOR ALL INTERACTIONS         CD57   3
#    BETWEEN PROTEIN ATOMS AND OF PROTEIN WITH WATER.                   CD57   4
#    THE "INPUT" IS IN THE FORM OF A DRIVER, CF. NAYBOR EXPLAIN         CD57   5
#                                                                       CD57   6
#     BASED ON THE SUBROUTINE 'GRENER' OF JAN HERMANS                   CD57   7
#     CONVERTED TO RATMAC OCT 1982 BY MIKE CARSON                       CD57   8
#     MODIFIED NOV 1985 BY K.WATENPAUGH AND J.HERMANS                   CD57   9
#                                                                       CD57  10
SUBROUTINE CD57(MAT)#                  -old grener(mat,force)           CD57  11
include:(AACOMN)#                                                       CD57  12
include:(CDCOMN)#                                                       CD57  13
#                                                                       CD57  14
# FORMAL PARAMETERS:                                                    CD57  15
INTEGER  MAT#                          Pointer for the neighbor tab     CD57  16
# THIS ROUTINE CHANGES:                                                 CD57  17
#  FORCE:(3,*) # XYZ COMPONENTS OF FORCE FOR VARIABLE ATOMS             CD57  18
#  AND FF(6)   # NON-BONDED FORCE                                       CD57  19
#                                                                       CD57  20
# NEIGHBOR ROUTINE (CD42) AND THIS ROUTINE CAN WORK THE NEIGHBOR TABLE  CD57  21
#  ON AND OFF A FILE. THIS REQUIRES 1. LINES MARKED #FILE# MUST BE      CD57  22
#  ACTIVATED IN BOTH, AND LREC MUST BE SET SMALLER THAN THE FULL NEIGBO CD57  23
#  TABLE REQUIRES.                                                      CD57  24
#                                                                       CD57  25
INTEGER  IAT, IATV, JAT, JATV#         Pointers to atoms                CD57  26
INTEGER  I, J#                         Counters                         CD57  27
#INTEGER  LREC6          # COUNTER FOR AUXIL. ION TAPE                  CD57  28
INTEGER MTYPI, RTYPI#                  Pointers to symop and rotati     CD57  29
REAL  ENER#                            Total nonbonded energy excep     CD57  30
REAL  AA, BB, CC, EPR#                 Epr=aa/r**6+bb/r**12+cc/         CD57  31
REAL  ABC, DUDR2#                                                       CD57  32
REAL  R, R2, R6, R12#                  Interatomic distance and dis     CD57  33
REAL  RIJ(3),DER(3)#                   Components of r, derivative      CD57  34
LOGICAL NEW#                           To initialize subroutine         CD57  35
REAL XI(3), XX(3)#                     Hold sym. transformed x(iat)     CD57  36
#                                                                       CD57  37
realdata:( EPFMT,[340822., 420802., 500802., 580802., 660812.])#        CD57  38
chardata:(HEAD,[ NON-BONDED                  RADIUS AA       BB     $#  CD57  39
  CC       ENERGY])#                                                    CD57  40
datastuff:#                                                             CD57  41
DATA NEW/.TRUE./#                                                       CD57  42
#                                                                       CD57  43
IF(ELIST>0.1) writeline:(1,HEAD,NHEAD,3,3)#                             CD57  44
#                                                                       CD57  45
#                                                                       CD57  46
#FILE#IF(NEW)                          #                                CD57  47
#FILE#$( #                                                              CD57  48
#FILE#NEW=.FALSE.                       # FIRST-TIME INITIALIZATION     CD57  49
#FILE#LREC6=LREC-6                      #                               CD57  50
#FILE#$) #                                                              CD57  51
#FILE#IF(NREC>0) READ (ION) (NGBR:(I),I=1,LREC) #                       CD57  52
# INITIALIZE RESIDUE NON-BONDED ARRY                                    CD57  53
DO I=1,TOTRES#                                                          CD57  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD57  55
RESNB(I)=0.0#                                                           CD57  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD57  57
MAT=0 ;  ENER=0.#                                                       CD57  58
#              READ NEXT CENTRAL ATOM NUMBER                            CD57  59
REPEAT#                                                                 CD57  60
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD57  61
MATP1=MAT+1#                                                            CD57  62
IAT=IFIX(ngbr:(MATP1))#                                                 CD57  63
#      TEST FOR END OF PROTEIN-ANY INTERACTIONS                         CD57  64
IF(IAT<=0 \ IAT>NATP)#                                                  CD57  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD57  66
FF(6)=FF(6)+ENER ;                 RETURN#                              CD57  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD57  68
#      GET REMAINDER OF CENTRAL ATOM DIRECTIVE                          CD57  69
MAT=MAT+2 ; IATV=IFIX(ngbr:(MAT))#                                      CD57  70
MAT=MAT+1 ; RTYPI=IFIX(ngbr:(MAT))#                                     CD57  71
MTYPI=rtyp:(RTYPI)#                                                     CD57  72
#  SYMMETRY TRANSFORM X(1..3,IAT) TO XI(1..3)                           CD57  73
IF( RTYPI==1 ) $(#                     Identity operation               CD57  74
DO K=1,3 $( XI(K)=x:(K,IAT) $)#                                         CD57  75
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD57  76
ELSE $(#                               Must do symmetry transformat     CD57  77
IF( KDIAG==yes: ) $( DO K=1,3 $( XX(K)=x:(K,IAT) $) $)# Copy x          CD57  78
ELSE $(#                               Convert cartesian to fractio     CD57  79
CALL CD01(CTOF,x:(1,IAT),XX)#          Matrix x vector                  CD57  80
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD57  81
IF(MTYPI==0) $(#                       Identity matrix                  CD57  82
DO K=1,3 $( XK=t:(K,RTYPI)+XX(K) ; XI(K)=XK $)#                         CD57  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD57  84
ELSE IF(KDIAG==no:) $(#                Non-diagonal matrices            CD57  85
DO K=1,3#                                                               CD57  86
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD57  87
KROT=(K-1)*3+1#                                                         CD57  88
CALL CD03(rot:(KROT,MTYPI),XX,SP)#                                      CD57  89
XK=t:(K,RTYPI)+SP ; XI(K)=XK#                                           CD57  90
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD57  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD57  92
ELSE $(#                               Diagonal matrices                CD57  93
DO K=1,3 $( XK=t:(K,RTYPI)+rot:(K,MTYPI)*XX(K) ; XI(K)=XK $)#           CD57  94
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD57  95
IF( KDIAG==no: )#                                                       CD57  96
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CD57  97
CALL CD01(FTOC,XI,XX)#                 Matrix x vector                  CD57  98
DO K=1,3 $( XI(K)=XX(K) $)#            Store transformed xyz            CD57  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CD57 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD57 101
DO I=1,3#                                                               CD57 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CD57 103
DER(I)=0.#                                                              CD57 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CD57 105
#              MAKE PREPARATIONS FOR SMOOTHING THAT DEPEND ON IAT:      CD57 106
#                                                                       CD57 107
#CC   NEXT NEIGHBOR ATOM JAT                                            CD57 108
REPEAT#                                                                 CD57 109
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CD57 110
#                                      # File#if( mat>lrec6)            CD57 111
#                                      # File#$( #                      CD57 112
#                                      # File#mat=0 ; read (ion) (ngb   CD57 113
#                                      # File#$) #                      CD57 114
MAT=MAT+1 ; JAT=IFIX(ngbr:(MAT))#      Retrieve directive for neigh     CD57 115
IF( JAT==-IAT ) BREAK#                 Done with iat when jat=-iat      CD57 116
#                                     ##                                CD57 117
MAT=MAT+1 ; JATV=IFIX(ngbr:(MAT))#                                      CD57 118
MAT=MAT+1 ; AA=ngbr:(MAT)#                                              CD57 119
MAT=MAT+1 ; BB=ngbr:(MAT)#                                              CD57 120
MAT=MAT+1 ; CC=ngbr:(MAT)#             Total increment is 6 for mat     CD57 121
R2=0.0#                                                                 CD57 122
DO I=1,3#                                                               CD57 123
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CD57 124
RIJ(I)=XI(I)-x:(I,JAT)#                                                 CD57 125
R2=R2+RIJ(I)*RIJ(I)#                                                    CD57 126
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CD57 127
R=SQRT(R2)#                                                             CD57 128
R6=R2*R2*R2 ; R12=R6*R6#                                                CD57 129
EPR=AA/R6+BB/R12+CC/R#                                                  CD57 130
DUDR2=-(6.*AA/R6+12.*BB/R12+CC/R)/R2#                                   CD57 131
ENER=ENER+EPR#                                                          CD57 132
DO ICOL=1,TOTRES#                                                       CD57 133
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CD57 134
IF(IAT>RESIPT(ICOL) & IAT<=RESIPT(ICOL+1)) $#                           CD57 135
    RESNB(ICOL)=RESNB(ICOL)+EPR#                                        CD57 136
IF(JAT>RESIPT(ICOL) & JAT<=RESIPT(ICOL+1)) $#                           CD57 137
    RESNB(ICOL)=RESNB(ICOL)+EPR#                                        CD57 138
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CD57 139
IF(ELIST>0.1 & EPR>ELIST)#             Print out large bond energie     CD57 140
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CD57 141
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   CD57 142
ICOL=2#                                Set-up column                    CD57 143
KD=(IAT-1)*STEPAT+STARAT#                                               CD57 144
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD57 145
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD57 146
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD57 147
ICOL=ICOL+10#                                                           CD57 148
KD=(JAT-1)*STEPAT+STARAT#                                               CD57 149
movertoc:(QX(KD+1),1,CHROT,ICOL,4,0)#                                   CD57 150
movertoc:(QX(KD+2),1,CHROT,ICOL+5,3,0)# Remoteness indicator            CD57 151
movertoc:(QX(KD+3),1,CHROT,ICOL+4,1,0)# Scat factor type char 1         CD57 152
ncodefld:(R,1,CHROT,EPFMT(1),1)#                                        CD57 153
ncodefld:(AA,1,CHROT,EPFMT(2),1)#                                       CD57 154
ncodefld:(BB,1,CHROT,EPFMT(3),1)#                                       CD57 155
ncodefld:(CC,1,CHROT,EPFMT(4),1)#                                       CD57 156
ncodefld:(EPR,1,CHROT,EPFMT(5),1)#                                      CD57 157
writeline:(0,0,0,1,3)#                                                  CD57 158
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CD57 159
DO I=1,3#                                                               CD57 160
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CD57 161
ABC=RIJ(I)*DUDR2#                                                       CD57 162
DER(I)=DER(I)+ABC#                                                      CD57 163
force:(I,JATV)=force:(I,JATV)+ABC#                                      CD57 164
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CD57 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CD57 166
#######  before going to next iat, use DER to increment force(iat)      CD57 167
IF(MTYPI==0)#                                                           CD57 168
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CD57 169
DO I=1,3#                                                               CD57 170
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CD57 171
force:(I,IATV)=force:(I,IATV)-DER(I)#                                   CD57 172
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CD57 173
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CD57 174
ELSE $(#                                                                CD57 175
IF( KDIAG !=no:)#                                                       CD57 176
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CD57 177
DO I=1,3#                                                               CD57 178
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CD57 179
force:(I,IATV)=force:(I,IATV)-DER(I)*roti:(I,MTYPI)#                    CD57 180
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CD57 181
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CD57 182
ELSE#                                                                   CD57 183
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CD57 184
J=-2#                                                                   CD57 185
DO I=1,3#                                                               CD57 186
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CD57 187
J=J+3#                                                                  CD57 188
CALL CD03(DER,roti:(J,MTYPI),SP)#                                       CD57 189
force:(I,IATV)=force:(I,IATV)-SP#                                       CD57 190
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CD57 191
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CD57 192
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CD57 193
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD57 194
#                                                                       CD57 195
END#                                                                    CD57 196
#####################################################################   CD57 197
systemheader:(CD58)#                                                    CD58   1
#                                                                       CD58   2
# FCH2O WILL SUPPLY THE FORCES ON THE WATERMOLECULES AND                CD58   3
# THE TOTAL POTENTIAL ENERGY FOR WATERMOLECULES IN A PROTEIN            CD58   4
# CRYSTAL. ONLY FORCES DUE TO OTHER WATER MOLECULES ARE CALCULATED      CD58   5
# ACCORDING TO THE SPC MODEL.                                           CD58   6
#                                                                       CD58   7
#     NATW2=NUMBER OF OXYGEN X-COORD OF FIRST WATER MOLECULE IN         CD58   8
#   LIST X:(I). THE ATOMS MUST HAVE THE ORDER O-H-H IN X                CD58   9
#                NATW2 IN COMMON                                        CD58  10
#     MAT=POINTER IN NEIGHBORLIST NGBR:                                 CD58  11
#     FORCEQ:=FORCE ON WATER MOLECULES                                  CD58  12
#     E=TOTAL POTENTIAL ENERGY                                          CD58  13
#                                                                       CD58  14
#    MODIFIED 11 AUG 81: SPC POTENTIAL                                  CD58  15
#     BASED ON THE 'FCH2O' SUBROUTINE OF JAN HERMANS                    CD58  16
#     CONVERTED TO RATMAC OCT 1982 BY MIKE CARSON                       CD58  17
#                                                                       CD58  18
#                             CALLED BY: FORCAL(CD50)                   CD58  19
SUBROUTINE CD58(MAT,E)#                Subroutine fch2o(mat,f,e)        CD58  20
include:(AACOMN)#                                                       CD58  21
include:(CDCOMN)#                                                       CD58  22
#                                                                       CD58  23
INTEGER MAT#                                                            CD58  24
REAL E#                                                                 CD58  25
#                                                                       CD58  26
INTEGER  I, IAT, IATV, IX0#                                             CD58  27
INTEGER  JAT, JATV, JM, JX0, K, K1, K2, K3, KL#                         CD58  28
INTEGER  LM1, LM2, L3, M#                                               CD58  29
INTEGER  SYMOP,RTYPI#                                                   CD58  30
REAL WTINV(3),ARM,THP#                                                  CD58  31
REAL FI(9),FJ(9),XI(9),XJ(9)#                                           CD58  32
LOGICAL NEW#                                                            CD58  33
#     CONSTANTS AND FUNCTION AS SPC MODEL, JUNE 1981                    CD58  34
REAL C6,C12,Q#                         ; smooth real rc,rs              CD58  35
DATA  NEW /.TRUE./#                                                     CD58  36
DATA  PI/3.1415926535/,Q/0.415/,C6/-625./,C12/629000./#                 CD58  37
# SMOOTH DATA RC/6./,RS/5./                                             CD58  38
#                                                                       CD58  39
IF( NEW )#                                                              CD58  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD58  41
NEW=.FALSE.#                                                            CD58  42
ARM=1.#                                                                 CD58  43
THP=ACOS(-1./3.)*180./PI#                                               CD58  44
WTINV(1)=1./16. ; WTINV(2)=1. ; WTINV(3)=1.#                            CD58  45
QSQ=Q**2*332.0636 ; QSQ2=-2.*QSQ ; QSQ4=4.*QSQ#                         CD58  46
CF6=6.*C6 ; CF12=12.*C12#                                               CD58  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD58  48
#                                                                       CD58  49
ELJ=0.E0 ; EEL=0.E0#                                                    CD58  50
REPEAT#                                For all central waters           CD58  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD58  52
MAT=MAT+1#                                                              CD58  53
IAT=IFIX(ngbr:(MAT))#                  Next item in table               CD58  54
IF(IAT<=0 \ IAT>=NUMATM) BREAK#        End of table                     CD58  55
MAT=MAT+1#                                                              CD58  56
IATV=IFIX(ngbr:(MAT))#                                                  CD58  57
MAT=MAT+1#                                                              CD58  58
SYMOP=IFIX(ngbr:(MAT))#                                                 CD58  59
RTYPI=rtyp:(SYMOP)#                                                     CD58  60
DO K=1,9#                                                               CD58  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD58  62
FI(K)=0.0#                                                              CD58  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD58  64
#                                                                       CD58  65
IX0=3*IAT-3#                                                            CD58  66
XI(1)=x:(1,IAT)#                                                        CD58  67
XI(2)=x:(2,IAT)#                                                        CD58  68
XI(3)=x:(3,IAT)#                                                        CD58  69
IATP1=IAT+1#                                                            CD58  70
XI(4)=x:(1,IATP1)#                                                      CD58  71
XI(5)=x:(2,IATP1)#                                                      CD58  72
XI(6)=x:(3,IATP1)#                                                      CD58  73
IATP1=IATP1+1#                                                          CD58  74
XI(7)=x:(1,IATP1)#                                                      CD58  75
XI(8)=x:(2,IATP1)#                                                      CD58  76
XI(9)=x:(3,IATP1)#                                                      CD58  77
#                                                                       CD58  78
# **************** SYMMETRY TRANSFORM COORDINATES                       CD58  79
# SYMMETRY TRANSORM X(1..3,IAT) TO XI(1..3)                             CD58  80
IF(SYMOP !=1)#                         Not identity operation           CD58  81
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD58  82
IF(KDIAG==no:)#                        Convert cartesian to fractio     CD58  83
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD58  84
DO K=1,7,3#                                                             CD58  85
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD58  86
CALL CD01(CTOF,XI(K),XI(K))#           Matrix x vector (ctof)           CD58  87
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD58  88
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD58  89
IF(RTYPI==0)#                          Identity matrix                  CD58  90
DO J=0,6,3#                                                             CD58  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD58  92
DO K=1,3#                                                               CD58  93
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD58  94
XI(K+J)=t:(K,SYMOP)+XI(K+J)#                                            CD58  95
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD58  96
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD58  97
ELSE IF(KDIAG==no:)#                   Non-diagonal matrices            CD58  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD58  99
DO J=1,7,3#                                                             CD58 100
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD58 101
CALL CD01(rot:(1,SYMOP),XI(J),XI(J))#                                   CD58 102
DO K=1,3#                                                               CD58 103
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD58 104
XI(J+J-1)=t:(K,SYMOP)+XI(K+J-1)#                                        CD58 105
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD58 106
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD58 107
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD58 108
ELSE#                                  Diagonal matrices                CD58 109
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD58 110
DO J=0,6,3#                                                             CD58 111
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD58 112
DO K=1,3#                                                               CD58 113
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CD58 114
XI(J+K)=t:(K,SYMOP)+rot:(K,SYMOP)*XI(J+K)#                              CD58 115
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD58 116
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD58 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD58 118
IF(KDIAG==no:)#                                                         CD58 119
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CD58 120
DO K=1,7,3#                                                             CD58 121
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CD58 122
CALL CD01(FTOC,XI(K),XI(K))#           Frac. to cart.                   CD58 123
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CD58 124
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CD58 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD58 126
#                                                                       CD58 127
REPEAT#                                *****select neighbor molecul     CD58 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CD58 129
# UNTIL BROKEN BY  IAT==JAT                                             CD58 130
MAT=MAT+1 ; JAT=IFIX(ngbr:(MAT))#                                       CD58 131
IF( JAT==-IAT ) BREAK#                 Repeat loop                      CD58 132
#                                                                       CD58 133
JX0=3*JAT-3#                                                            CD58 134
XJ(1)=x:(1,JAT)#                                                        CD58 135
XJ(2)=x:(2,JAT)#                                                        CD58 136
XJ(3)=x:(3,JAT)#                                                        CD58 137
JATP1=JAT+1#                                                            CD58 138
XJ(4)=x:(1,JATP1)#                                                      CD58 139
XJ(5)=x:(2,JATP1)#                                                      CD58 140
XJ(6)=x:(3,JATP1)#                                                      CD58 141
JATP1=JATP1+1#                                                          CD58 142
XJ(7)=x:(1,JATP1)#                                                      CD58 143
XJ(8)=x:(2,JATP1)#                                                      CD58 144
XJ(9)=x:(3,JATP1)#                                                      CD58 145
#                                                                       CD58 146
DO K=1,9#                                                               CD58 147
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CD58 148
FJ(K)=0.#                                                               CD58 149
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CD58 150
DO K1=1,7,3#                                                            CD58 151
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CD58 152
K2=K1+1 ; K3=K2+1#                                                      CD58 153
XII=XI(K1) ; YI=XI(K2) ; ZI=XI(K3)#                                     CD58 154
DO LM1=1,7,3#                                                           CD58 155
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CD58 156
LM2=LM1+1 ; L3=LM2+1#                                                   CD58 157
XIJ=XJ(LM1)-XII ; YIJ=XJ(LM2)-YI ; ZIJ=XJ(L3)-ZI#                       CD58 158
RIJ2=XIJ**2+YIJ**2+ZIJ**2 ; RIJ=SQRT(RIJ2)#                             CD58 159
KL=K1*LM1#                                                              CD58 160
#-----PRODUCT OF K AND L DETERMINES TERMS NEEDED                        CD58 161
#                                                                       CD58 162
#CCC  OXYGEN-OXYGEN INTERACTION                                         CD58 163
IF(KL<=1)#                                                              CD58 164
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CD58 165
RIJ6=RIJ2**3 ; ELJ=ELJ+(C12/RIJ6+C6)/RIJ6#                              CD58 166
VKL=QSQ4/RIJ ; DF=((CF12/RIJ6+CF6)/RIJ6+VKL)/RIJ2#                      CD58 167
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CD58 168
ELSE#                                                                   CD58 169
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CD58 170
#CCC  OXYGEN-HYDROGEN INTERACTION                                       CD58 171
IF(KL<=7)#                                                              CD58 172
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CD58 173
VKL=QSQ2/RIJ ;DF=VKL/RIJ2#                                              CD58 174
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CD58 175
#CCC  HYDROGEN-HYDROGEN INTERACTION                                     CD58 176
ELSE#                                                                   CD58 177
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CD58 178
VKL=QSQ/RIJ ; DF=VKL/RIJ2#                                              CD58 179
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CD58 180
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CD58 181
#C  APPLY SMOOTHING MULTIPLIER                                          CD58 182
# SMOOTH DF=DF*S                                                        CD58 183
DFX=DF*XIJ#                                                             CD58 184
FI(K1)=DFX+FI(K1) ; FJ(LM1)=DF+FJ(LM1)#                                 CD58 185
DFX=DF*YIJ ; FI(K2)=DFX+FI(K2)#                                         CD58 186
FJ(LM2)=DFX+FJ(LM2) ; DFX=DF*ZIJ#                                       CD58 187
FI(K3)=DFX+FI(K3) ;FJ(L3)=DFX+FJ(L3)#                                   CD58 188
EEL=EEL+VKL#                                                            CD58 189
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CD58 190
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CD58 191
#                                                                       CD58 192
#*****FIND ARRAY ELEMENT IN F FOR NEIGHBOR (J)                          CD58 193
JATV=IFIX(keyvar:(JAT))#                                                CD58 194
IF( JATV>0 )#                                                           CD58 195
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CD58 196
JX0=3*(JATV-1)#                                                         CD58 197
DO M=1,9#                                                               CD58 198
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CD58 199
JM=JX0+M#                                                               CD58 200
forceq:(JM)=forceq:(JM)+FJ(M)#                                          CD58 201
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CD58 202
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CD58 203
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CD58 204
# ***** BEFORE GOING TO NEXT IAT, INCREMENT FORCE(IAT)                  CD58 205
IF(IATV>0)#                                                             CD58 206
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CD58 207
IF(RTYPI!=0)#                          Must transform the force         CD58 208
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CD58 209
IF(KDIAG!=0)#                          Scalar multiply                  CD58 210
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CD58 211
DO J=0,6,3#                                                             CD58 212
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CD58 213
DO I=1,3#                                                               CD58 214
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CD58 215
K=I+J#                                                                  CD58 216
FI(K)=FI(K)*roti:(I,SYMOP)#                                             CD58 217
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CD58 218
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CD58 219
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CD58 220
ELSE#                                  Matrix multiply                  CD58 221
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 CD58 222
DO J=1,7,3#                                                             CD58 223
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 CD58 224
CALL CD01(roti:(1,SYMOP),FI(J),FI(J))#                                  CD58 225
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 CD58 226
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CD58 227
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CD58 228
# ACCUMULATE THE FORCE ON IAT                                           CD58 229
DO I=1,9#                              Subtract (same) contribution     CD58 230
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 CD58 231
force:(I,IATV)=force:(I,IATV)-FI(I)#                                    CD58 232
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 CD58 233
#                                                                       CD58 234
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CD58 235
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD58 236
#                                                                       CD58 237
E=ELJ+EEL#                                                              CD58 238
RETURN#                                                                 CD58 239
END#                                                                    CD58 240
################################################################        CD58 241
systemheader:(CD59)#                                                    CD59   1
#                                                                       CD59   2
# GETCON: FIND THE ENERGY FUNCTION COEFFICIENT, THE MUTIPLICITY         CD59   3
#   COEFFICIENT (IF NEEDED), AND THE IDEAL VALUE FOR A PARTICULAR       CD59   4
#   DIHEDRAL ANGLE.                                                     CD59   5
#                    BASED ON "GETCON" ROUTINE OF JAN HERMANS           CD59   6
#                    REVISED NOV 85                                     CD59   7
#                                                                       CD59   8
##subroutine getcon(coeff,iangle,plex,id1,id2,id3,id4)                  CD59   9
SUBROUTINE CD59(COEFF,IANGLE,PLEX,ID1,ID2,ID3,ID4)# Passed from difor   CD59  10
include:(AACOMN)#                                                       CD59  11
include:(CDCOMN)#                                                       CD59  12
#                                                                       CD59  13
# INPUT:       REAL  DICT2:, DICT3:, BARR:                              CD59  14
#              INTEGER  TREE                                            CD59  15
#    TREE:  COLUMN 6 CONTAINS THE KEY TO DICT2: AND DICT3:. COLUMN 5    CD59  16
#           CONTAINS THE KEY TO BARR:. FOR FIXED DIHEDRALS COLUMN 5     CD59  17
#           CONTAINS ZERO.                                              CD59  18
#    DICT2:: COLUMN 3 CONTAINS THE IDEAL VALUE OF THE ANGLE FORMED BY T CD59  19
#          PLANE (B,ID2,ID3) AND THE PLANE (ID2,ID3,DIHE                CD59  20
#          ID4), WHERE B IS THE BACKCHAIN ATOM OF ID2. DICT2: IS        CD59  21
#          KEYED BY TREE(6,ID4)                                         CD59  22
#    DICT3:: CONTAINS THE ENERGY FUNCTION COEFFICIENT IN COLUMN 3, FOR  CD59  23
#          FIXED AND PLANAR DIHEDRALS. FOR FIXED DIHEDRALS, KEYED FROM  CD59  24
#          TREE BY ID4. FOR PLANAR PIVOT SET DIHEDRALS, KEYED  BY       CD59  25
#          TREE BY ID1, THE SIDE CHAIN ATOM.                            CD59  26
#    BARR:: DICTIONARY FOR FLEXIBLE DIHEDRAL INFO. COLUMN ONE CONTAINS  CD59  27
#          THE MULTIPLICITY. COLUMN 2 CONTAIN THE COEFFICIENT. COLUMN   CD59  28
#          3 CONTAINS AN IDEAL VALUE OF THE DIHEDRAL, I.E.   AN ENERGY  CD59  29
#          MINIMUM. KEYED BY TREE(5,ID3).                               CD59  30
#    DIHE:  ID1, ID2, ID3, ID4                                          CD59  31
#          THE FOUR ATOMS OF THE DIHEDRAL. ID2->ID3 IS THE              CD59  32
#          PIVOT BOND. IN THE PLANAR PIVOT SET CASE, ID1 IS THE         CD59  33
#          FORWARD CHAIN ATOM AND ID4 IS THE SIDE CHAIN ATOM,           CD59  34
#          AND ID2>ID3. OTHERWISE, CONNECTIVITY IS 1-2-3-4              CD59  35
#          AND ID2<ID3.                                                 CD59  36
INTEGER  ID1, ID2, ID3, ID4#           Passed from diforc==cd53         CD59  37
#                                                                       CD59  38
# OUTPUT:  COEFF,IANGLE,PLEX         # PASSED TO DIFORC==CD53           CD59  39
REAL   COEFF,IANGLE,PLEX#                                               CD59  40
#    PLEX: THE MULTPLICITY COEFFICIENT. THE NUMBER OF ENERGY MINIMA     CD59  41
#          IN THE 360 DEGREE RANGE OF THE DIHEDRAL. FOR FIXED           CD59  42
#          DIHEDRALS PLEX IS SET TO ZERO.                               CD59  43
#    COEFF: THE COEFFICIENT OF THE ENERGY FUNCTION.                     CD59  44
#    IANGLE: THE IDEAL VALUE OF THE DIHEDRAL.                           CD59  45
#                                                                       CD59  46
##integer inx,inx1,kfor,kphi,kpiv,kside    # point to tree & dictionaie CD59  47
##real ro      # ideal dihedral angle, expained in detail below         CD59  48
##real ra,rb,thet, cosra,cosrb  # dictionary angles and cosines to get  CD59  49
##real ab,af,as    # temp.variables used in angle calculations          CD59  50
##logical clkwis,new                                                    CD59  51
# INTERNAL VARIABLES                                                    CD59  52
INTEGER INX,INX1,KFOR,KPHI,KPIV,KSIDE# Point to tree & dictionaies      CD59  53
REAL BANG#                             Bond angle                       CD59  54
REAL RO#                               Ideal dihedral angle, expain     CD59  55
REAL RA,RB,THET, COSRA,COSRB#          Dictionary angles and cosine     CD59  56
REAL AB,AF,AS#                         Temp.variables used in angle     CD59  57
LOGICAL CLKWIS#                                                         CD59  58
realdata:(PI,3.141592654)#                                              CD59  59
realdata:(HALFPI,1.570796327)#                                          CD59  60
realdata:(TWOPI,6.283185307)#                                           CD59  61
chardata:(CD59A, ARCANE GEOMETRY FOR TORSION ANGLE                )#    CD59  62
datastuff:#                                                             CD59  63
#                                                                       CD59  64
#---------------------                                                  CD59  65
IF(ID2>=ID3)#                          Planar group (y)                 CD59  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD59  67
PLEX=0.0#                                                               CD59  68
INX=IFIX(keydict:(ID4))#                                                CD59  69
COEFF=dict3:(3,INX)#                                                    CD59  70
IANGLE=PI#                                                              CD59  71
RETURN#                                                                 CD59  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD59  73
#---------------------                                                  CD59  74
KPHI=IFIX(keydict:(ID3))#              Single bond                      CD59  75
IF(barr:(1,KPHI)>0.0)#                                                  CD59  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD59  77
COEFF=barr:(1,KPHI)#                                                    CD59  78
IANGLE=barr:(3,KPHI)#                                                   CD59  79
PLEX=barr:(2,KPHI)#                                                     CD59  80
RETURN#                                                                 CD59  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD59  82
#---------------------                                                  CD59  83
#           FIXED DIHEDRAL (Z)                                          CD59  84
KFOR=IFIX(keydict:(ID4))#                                               CD59  85
PLEX=0.0#                                                               CD59  86
#---------------------                                                  CD59  87
#   ALL BACKCHAINS                                                      CD59  88
INX=forwchain:(ID3) ; KFOR2=keydict:(INX)#                              CD59  89
COEFF=dict3:(3,KFOR2)#                                                  CD59  90
IF(ID1<ID2)#                                                            CD59  91
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD59  92
IANGLE=ABS(dict2:(3,KFOR))#                                             CD59  93
RETURN#                                                                 CD59  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD59  95
#---------------------                                                  CD59  96
#   TWO BACKCHAINS AND ONE FORWARD CHAIN                                CD59  97
INX1=keydict:(ID1)#                                                     CD59  98
INX=keydict:(ID3)#                                                      CD59  99
BANG=ABS(dict2:(3,INX)-dict2:(3,INX1))#                                 CD59 100
IF((PI-BANG)<1.0E-2) $(#               This is not a great test, bu     CD59 101
IANGLE=BANG-ABS(dict2:(3,KFOR))#                                        CD59 102
RETURN#                                                                 CD59 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD59 104
#---------------------                                                  CD59 105
#      THE RARE CASE OF ARCANE GEOMETRY:                                CD59 106
ncodefld:(FLOAT(ID1),1,CD59A,390413.,1)#                                CD59 107
ncodefld:(FLOAT(ID2),1,CD59A,430413.,1)#                                CD59 108
ncodefld:(FLOAT(ID3),1,CD59A,470413.,1)#                                CD59 109
ncodefld:(FLOAT(ID4),1,CD59A,510413.,1)#                                CD59 110
writeline:(1,CD59A,NCD59A,3,3)#                                         CD59 111
#      REFIGURE BANG TO DISCOVER ITS ORIENTATION.IF THE BACK-           CD59 112
#      CHAIN DIHEDRAL (WITH B->ID2 AS THE PIVOT BOND) IS                CD59 113
#      SUCH THAT THE IDEAL VALUE OF THE ANGLE (<PI) BETWEEN             CD59 114
#      ID3 AND ID1 IS SWEPT OUT FROM ID3 TO ID1                         CD59 115
#      IN A CLOCKWISE DIRECTION (LOOKING UP THE B->ID2                  CD59 116
#      VECTOR) THEN CLKWIS=.TRUE., ELSE CLKWIS=.FALSE.                  CD59 117
INX=ID1#                                                                CD59 118
KSIDE=IFIX(keydict:(INX))#                                              CD59 119
INX=ID3#                                                                CD59 120
KPIV=IFIX(keydict:(INX))#                                               CD59 121
AB=dict2:(3,KPIV)#                                                      CD59 122
IF(AB<0.0) AB=TWOPI+AB#                                                 CD59 123
AS=dict2:(3,KSIDE)#                                                     CD59 124
IF(AS<0.0) AS=TWOPI+AS#                                                 CD59 125
BANG=AS-AB#                                                             CD59 126
IF(BANG>0.0) CLKWIS=(BANG<PI)#                                          CD59 127
IF(BANG<=0.0) CLKWIS=(BANG<-PI)#                                        CD59 128
#                                                                       CD59 129
#      FIGURE RO, THE IDEAL ANGLE BETWEEN THE PROJECTIONS OF            CD59 130
#      THE VECTORS ID2->B AND ID2->ID1 ONTO THE                         CD59 131
#      PLANE PERPENDICULAR TO ID2->ID3. USE CLKWIS                      CD59 132
#      TO ORIENT THIS ANGLE. THE DIFFERENCE BETWEEN RO AND              CD59 133
#      THE IDEAL VALUE OF DIHEDRAL B->ID2->ID3->                        CD59 134
#      ID4, WITH BOTH PROPERLY ORIENTED, IS THE IDEAL                   CD59 135
#      VALUE OF THE INPUT DIHEDRAL. NOTICE THAT IT IS SET               CD59 136
#      TO ITS ANGLE<PI VALUE, SO ASYMMETRIES ARE NOT                    CD59 137
#      CONSIDERED. INCORRECT ASYMMETRY WILL NOT BE CORRECTED.           CD59 138
RA=dict3:(5,KSIDE)+dict3:(5,KPIV)#                                      CD59 139
IF(RA>HALFPI) RA=PI-RA#                                                 CD59 140
COSRA=COS(RA)#                                                          CD59 141
RB=dict2:(2,KPIV)#                                                      CD59 142
IF(RB>HALFPI) RB=PI-RB#                                                 CD59 143
COSRB=COS(RB)#                                                          CD59 144
THET=dict2:(2,KSIDE)#                                                   CD59 145
RO=ACOS((COS(THET)-COSRA*COSRB)/SQRT((1-COSRA**2)*(1-COSRB**2)))#       CD59 146
IF( ! CLKWIS) RO=TWOPI-RO#                                              CD59 147
AF=dict2:(3,KFOR)#                                                      CD59 148
IF(AF<0.0) AF=TWOPI+AF#                                                 CD59 149
IANGLE=ABS(AF-RO)#                                                      CD59 150
IF(IANGLE>PI) IANGLE=TWOPI-IANGLE#                                      CD59 151
#                                                                       CD59 152
RETURN#                                                                 CD59 153
END#                                                                    CD59 154
#####################################################################   CD59 155
systemheader:(CD80)#                                                    CD80   1
#                                                                       CD80   2
# OUTPUT NEW BDF WITH REFINED COORDINATES                               CD80   3
#                                                                       CD80   4
#   WRITTEN BY KDW 4-JAN-1983                                           CD80   5
#                                                                       CD80   6
SUBROUTINE CD80#                                                        CD80   7
#                                                                       CD80   8
include:(AACOMN)#                                                       CD80   9
include:(CDCOMN)#                                                       CD80  10
INTEGER IPT,PSIZE,IPTO#                Packet pointers                  CD80  11
#                                                                       CD80  12
#                                                                       CD80  13
#   PROCESS BDF RECORDS                                                 CD80  14
#                                                                       CD80  15
readwpkt:(1,endrecord:,PSIZE,IPT,0)#                                    CD80  16
copyfile:(1,2,1,decr:(lratom:))#       Copy lr first: to lratom:-1      CD80  17
#                                                                       CD80  18
#IPTSCL=0   #                                                           CD80  19
#IPTDST=0   #                                                           CD80  20
# READ LREXPL: PACKETS                                                  CD80  21
#                                                                       CD80  22
#READWPKT:(1,LREXPL:,PSIZE,IPT,0)   # READ DIRECTORY PACKET             CD80  23
#                                                                       CD80  24
#FOR (I=1;I<=PSIZE;I=I+1)   #                                           CD80  25
#$(   #                                                                 CD80  26
#K=IPT+I   #                                                            CD80  27
#IFEQ:(QX(K),1.0) IPTDST=I      # CHECK DATA SET NUMBER                 CD80  28
#IFEQ:(QX(K),101.) IPTSCL=I   # SEE IF SCALE IS PRESENT IN RECORD       CD80  29
#$)   #                                                                 CD80  30
#IF(IPTSCL==0) IQUIT:(-CDNUMB:9001.)   # NO SCALE FACTOR SLOT           CD80  31
#IF(IPTDST==0) IQUIT:(-CDNUMB:9002.)   # NO DATASET NUMBER              CD80  32
#WRITEPKT:(2,LREXPL:,PSIZE,IPTO,0)                                      CD80  33
#MOVEREAL:(QX(IPT+1),1,QX(IPTO+1),1,PSIZE,0)                            CD80  34
#                                                                       CD80  35
#REPEAT   #                                                             CD80  36
#$(   #                                                                 CD80  37
#READWPKT:(1,LREXPL:,PSIZE,IPT,0)   #                                   CD80  38
#IF(IPT<=0) BREAK   #                                                   CD80  39
#K=IPT+IPTDST   # SET UP POINTER TO DATASET NUMBER                      CD80  40
#IFEQ:(QX(K),1.0)   #                                                   CD80  41
#$( K=IPT+IPTSCL ; QX(IPTSCL)=XLTSCL $) # UPDATE LEAST-SQUARES SCAL     CD80  42
#WRITEPKT:(2,LREXPL:,PSIZE,IPTO)   #                                    CD80  43
#MOVEREAL:(QX(IPT+1),1,QX(IPTO+1),1,PSIZE,0)   #                        CD80  44
#$)   #                                                                 CD80  45
#                                                                       CD80  46
#COPYFILE:(1,2,INCR:(LREXPL:),DECR:(LRATOM:)) # COPY LRDSET: TO LRATOM  CD80  47
#                                                                       CD80  48
CALL CD81#                             Go copy new atom parameters      CD80  49
#                                                                       CD80  50
copyfile:(1,2,incr:(lratom:),decr:(lrrefl:))#                           CD80  51
IF(NFILE==3)#                                                           CD80  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD80  53
REPEAT#                                                                 CD80  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD80  55
readwpkt:(NFILE,lrrefl:,PSIZE,IPT,0)#                                   CD80  56
IF(IPT<=0)#                                                             CD80  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD80  58
#READWPKT:(NFILE,ENDRECORD:,PSIZE,IPT,0)#                               CD80  59
BREAK#                                                                  CD80  60
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD80  61
writepkt:(2,lrrefl:,PSIZE,IPTO)#                                        CD80  62
movereal:(QX(IPT+1),1,QX(IPTO+1),1,PSIZE,0)#                            CD80  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD80  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD80  65
ELSE copyfile:(1,2,lrrefl:,lrrefl:)#   Copy to endrecord:               CD80  66
copyfile:(1,2,incr:(lrrefl:),endrecord:)#                               CD80  67
#                                                                       CD80  68
RETURN#                                                                 CD80  69
END#                                                                    CD80  70
#####################################################################   CD80  71
systemheader:(CD81)#                   Put out atoms and their link     CD81   1
#                                                                       CD81   2
SUBROUTINE CD81#                       Put out atoms and their link     CD81   3
#                                                                       CD81   4
#   WRITTEN BY KDW, 16-DEC-1982                                         CD81   5
#   REVISED BY KDW, 22-DEC-1982                                         CD81   6
#                                                                       CD81   7
include:(AACOMN)#                                                       CD81   8
include:(CDCOMN)#                                                       CD81   9
#                                                                       CD81  10
macro:(nwant2:,27)#                    Number of  total items in tw     CD81  11
#                                                                       CD81  12
INTEGER MAXWNT#                                                         CD81  13
INTEGER WANT(nwant2:)#                                                  CD81  14
INTEGER ITEM(nwant2:)#                                                  CD81  15
INTEGER I,J,K,M#                       Temporary  variables             CD81  16
REAL    FMT(6)#                        Formats for output               CD81  17
chardata:(HEAD1,     =        = )#                                      CD81  18
chardata:(HEAD2,  NO. ATOM BC   FC     GRP             COORDINATES    $#CD81  19
    B FACTOR)#                                                          CD81  20
datastuff:#                                                             CD81  21
DATA FMT/ 40513., 250413., 380822., 460822., 540822., 600612./#         CD81  22
DATA ITEM /16,15,14,14,210,212,213,215,   $#                            CD81  23
1,2,3,101,102,103,11,22,4, $#          Coordinates,temperatures fac     CD81  24
5,6,7,8,9,10,23, $#                                                     CD81  25
301,302,303/#                          Old coord.                       CD81  26
#                                                                       CD81  27
# SET UP THE WANT LIST FOR LRATOM OUTPUT BDF                            CD81  28
MAXWNT=17#                                                              CD81  29
DO I=1,MAXWNT#                                                          CD81  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD81  31
WANT(I)=ITEM(I)#                                                        CD81  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD81  33
IF(ANISO==yes:)#                                                        CD81  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD81  35
DO I=18,23#                                                             CD81  36
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD81  37
MAXWNT=MAXWNT+1#                                                        CD81  38
WANT(MAXWNT)=ITEM(I)#                                                   CD81  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD81  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD81  41
MAXWNT=MAXWNT+1#                                                        CD81  42
WANT(MAXWNT)=ITEM(24)#                 T.f. type                        CD81  43
IF(PRESAV==yes:)#                                                       CD81  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD81  45
DO I=25,27#                                                             CD81  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD81  47
MAXWNT=MAXWNT+1#                                                        CD81  48
WANT(MAXWNT)=ITEM(I)#                                                   CD81  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD81  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD81  51
#                                                                       CD81  52
# LIST ATOM COORDINATES IF REQUESTED TO DO SO                           CD81  53
#                                                                       CD81  54
IF(LISTAT>yes:)#                                                        CD81  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD81  56
# CONVERT FRACTIONAL COORDINATES TO CARTESIAN ANGSTROM ONES             CD81  57
#                                                                       CD81  58
IF(ORTHOG==no:)#                                                        CD81  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD81  60
ORTHOG=yes:#                                                            CD81  61
J=STARAT+xxoff:#                                                        CD81  62
DO K=1,NUMATM#                                                          CD81  63
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD81  64
CALL CD01(FTOC,QX(J),QX(J))#                                            CD81  65
J=J+STEPAT#                                                             CD81  66
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD81  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD81  68
IPRESN=STARSQ+1#                                                        CD81  69
DO IR=1,NSEQU#                                                          CD81  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD81  71
movertoc:(QX(IPRESN),1,HEAD1,11,4,0)#                                   CD81  72
movertoc:(QX(IPRESN+1),1,HEAD1,16,4,0)#                                 CD81  73
LINRM=5#                                                                CD81  74
writeline:(1,HEAD1,NHEAD1,3,3)#                                         CD81  75
writeline:(0,HEAD2,NHEAD2,3,3)#                                         CD81  76
IPRESN=IPRESN+STEPSQ#                                                   CD81  77
I=RESIPT(IR)+1#                                                         CD81  78
J=RESIPT(IR+1)#                                                         CD81  79
IF(J>=I)#                                                               CD81  80
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD81  81
DO  IA=I,J#                                                             CD81  82
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD81  83
KD=(IA-1)*STEPAT+STARAT#                                                CD81  84
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   CD81  85
ICOL=7#                                Set-up column                    CD81  86
movertoc:(QX(KD+2),1,CHROT,ICOL+1,4,0)# Remoteness indicator            CD81  87
movertoc:(QX(KD+3),1,CHROT,ICOL,1,0)#  Scat factor type char 1          CD81  88
ICOL=ICOL+6#                                                            CD81  89
DO IDATA=bcoff:,fcoff:#                Move back and forward chain      CD81  90
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD81  91
K=KD+IDATA#                                                             CD81  92
K=IFIX(QX(K))#                                                          CD81  93
IF(K !=0)#                                                              CD81  94
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD81  95
K=STARAT+(K-1)*STEPAT#                                                  CD81  96
movertoc:(QX(K+2),1,CHROT,ICOL+1,3,0)#                                  CD81  97
movertoc:(QX(K+3),1,CHROT,ICOL,1,0)#                                    CD81  98
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD81  99
ICOL=ICOL+6#                           Set-up next column               CD81 100
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD81 101
ATM=IA#                                                                 CD81 102
ncodefld:(ATM,1,CHROT,FMT(1),1)#       Atom number                      CD81 103
ifnv:(QX(KD+groff:)) ncodefld:(QX(KD+groff:),1,CHROT,FMT(2),1)#         CD81 104
IPA=(IA-1)*STEPAT+STARAT+xxoff:#                                        CD81 105
ifnv:(QX(IPA)) ncodefld:(QX(IPA),1,CHROT,FMT(3),3)#                     CD81 106
IPA=(IA-1)*STEPAT+STARAT+bfoff:#                                        CD81 107
ifnv:(QX(IPA)) ncodefld:(QX(IPA),1,CHROT,FMT(6),1)#                     CD81 108
writeline:(0,0,0,1,3)#                 Write atom info.                 CD81 109
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD81 110
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD81 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD81 112
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD81 113
# CONVERT B(ISO) TO U(ISO)                                              CD81 114
J=STARAT+bfoff:#                                                        CD81 115
DO K=1,NUMATM#                                                          CD81 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CD81 117
QX(J)=QX(J)/78.95683521#                                                CD81 118
J=J+STEPAT#                                                             CD81 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD81 120
#                                                                       CD81 121
# CONVERT CARTESIAN COORDINATES TO FRACTIONAL ANGSTROM ONES             CD81 122
#                                                                       CD81 123
IF(ORTHOG==yes:)#                                                       CD81 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CD81 125
ORTHOG=no:#                                                             CD81 126
J=STARAT+xxoff:#                                                        CD81 127
DO K=1,NUMATM#                                                          CD81 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CD81 129
CALL CD01(CTOF,QX(J),QX(J))#                                            CD81 130
J=J+STEPAT#                                                             CD81 131
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CD81 132
IF(PRESAV==yes:)#                                                       CD81 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CD81 134
J=STARAT+xpoff:#                                                        CD81 135
DO K=1,NUMATM#                                                          CD81 136
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CD81 137
CALL CD01(CTOF,QX(J),QX(J))#                                            CD81 138
J=J+STEPAT#                                                             CD81 139
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CD81 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CD81 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CD81 142
#                                                                       CD81 143
writepkt:(2,lratom:,MAXWNT,IPTO)#                                       CD81 144
K=IPTO#                                                                 CD81 145
DO I=1,MAXWNT#                         Write directory pointers to      CD81 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CD81 147
K=K+1#                                                                  CD81 148
QX(K)=WANT(I)#                                                          CD81 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CD81 150
#                                                                       CD81 151
J=STARAT#                                                               CD81 152
DO I=1,NUMATM#                         Write atom parameters to bdf     CD81 153
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CD81 154
writepkt:(2,lratom:,MAXWNT,IPTO)#                                       CD81 155
M=IPTO#                                                                 CD81 156
movereal:(QX,J+1,QX,M+1,1,0)#          Residue number                   CD81 157
movereal:(QX,J+2,QX,M+2,1,0)#          Atom name                        CD81 158
movereal:(QX,J+3,QX,M+3,1,0)#          Atom name (first half)           CD81 159
movereal:(QX,J+4,QX,M+4,1,0)#          Atom name (second half)          CD81 160
M=M+4#                                                                  CD81 161
DO K=5,8#                                                               CD81 162
$( M=M+1 ; QX(M)=QX(J+K) $)#                                            CD81 163
IF(ANISO==yes:)#                                                        CD81 164
IA=15#                                                                  CD81 165
ELSE#                                                                   CD81 166
IA=9#                                                                   CD81 167
DO K=1,IA#                                                              CD81 168
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CD81 169
M=M+1#                                                                  CD81 170
QX(M)=QX(J+K+xxoff:-1)#                                                 CD81 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CD81 172
M=M+1#                                                                  CD81 173
QX(M)=QX(J+tftypeoff:)#                                                 CD81 174
IF(PRESAV==yes:)#                                                       CD81 175
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CD81 176
DO K=1,3#                                                               CD81 177
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CD81 178
M=M+1#                                                                  CD81 179
QX(M)=QX(J+K+xpoff:-1)#                                                 CD81 180
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CD81 181
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CD81 182
J=J+STEPAT#                                                             CD81 183
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CD81 184
#                                                                       CD81 185
RETURN#                                                                 CD81 186
#                                                                       CD81 187
END#                                                                    CD81 188
##################################################################      CD81 189
systemheader:(CD91)#                                                    CD91   1
#                                                                       CD91   2
# ################################################################## #  CD91   3
#                                                                    #  CD91   4
#                               CD91                                 #  CD91   5
#                                                                    #  CD91   6
# ################################################################## #  CD91   7
#                                                                       CD91   8
SUBROUTINE CD91(MAT,VEC,NCOEF)#                                         CD91   9
#                                                                       CD91  10
#     SOLVE FOR SHIFTS OF PARAMETERS                                    CD91  11
#                                                                       CD91  12
REAL MAT(45)#                          Assumed 9x9 as largest matri     CD91  13
REAL VEC(9)#                                                            CD91  14
REAL RMAT(9,9)#                                                         CD91  15
REAL RVEC(9)#                                                           CD91  16
REAL RAVE#                                                              CD91  17
REAL DET#                                                               CD91  18
INTEGER NCOEF#                                                          CD91  19
chardata:(CD91A,[ SINGULAR MATRIX FOUND])#                              CD91  20
datastuff:#                                                             CD91  21
#                                                                       CD91  22
K=0#                                                                    CD91  23
DO J=1,NCOEF#                          Build complete matrix            CD91  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD91  25
DO I=1,J#                                                               CD91  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD91  27
K=K+1#                                                                  CD91  28
RMAT(I,J)=MAT(K)#                                                       CD91  29
RMAT(J,I)=MAT(K)#                                                       CD91  30
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD91  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD91  32
DO J=1,NCOEF#                                                           CD91  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD91  34
RVEC(J)=VEC(J)#                                                         CD91  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD91  36
RAVE=0.0#                                                               CD91  37
CALL CD97(RMAT,RAVE,NCOEF)#            Scale the matrix                 CD91  38
CALL CD98(RMAT,NCOEF,DET)#             Invert matrix                    CD91  39
IF(DET<0)#                                                              CD91  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD91  41
writeline:(1,CD91A,NCD91A,3,3)#                                         CD91  42
iquit:(CD9101)#                        Singular matrix                  CD91  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD91  44
CALL CD97(RMAT,RAVE,NCOEF)#            Rescale the matrix               CD91  45
#                                                                       CD91  46
DO J=1,NCOEF#                          Calc shifts of parameters        CD91  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD91  48
VEC(J)=0.0#                                                             CD91  49
DO I=1,NCOEF#                                                           CD91  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD91  51
VEC(J)=VEC(J)+RMAT(I,J)*RVEC(I)#                                        CD91  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD91  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD91  54
# TRANSFER MATRIX BACK INTO TRIANGULAR MATRIX                           CD91  55
K=0#                                                                    CD91  56
DO J=1,NCOEF#                                                           CD91  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD91  58
DO I=1,J#                                                               CD91  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD91  60
K=K+1#                                                                  CD91  61
MAT(K)=RMAT(I,J)#                                                       CD91  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD91  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD91  64
RETURN#                                                                 CD91  65
END#                                                                    CD91  66
#                                                                       CD91  67
systemheader:(CD97)#                                                    CD97   1
#                                                                       CD97   2
# ################################################################## #  CD97   3
#                                                                    #  CD97   4
#                               CD97                                 #  CD97   5
#                                                                    #  CD97   6
# ################################################################## #  CD97   7
#                                                                       CD97   8
SUBROUTINE CD97(RMAT,RAVE,NCOEF)#                                       CD97   9
#                                                                       CD97  10
#     ADJUSTS THE MATRIX AND VECTOR OF THE LEAST SQUARES PROBLEM        CD97  11
#       TO HAVE MAGNITUDES NEAR ONE FOR THE MATRIX INVERSION            CD97  12
#                                                                       CD97  13
REAL RMAT(9,9)#                                                         CD97  14
#                                                                       CD97  15
#     IF RAVE IS NOT ZERO, GO AND SCALE BY IT                           CD97  16
#                                                                       CD97  17
IF(NCOEF>9) iquit:(CD0701)#                                             CD97  18
IF(RAVE==0.0)#                                                          CD97  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD97  20
#                                                                       CD97  21
#     FIND THE SMALLEST AND LARGEST ELEMENTS                            CD97  22
#     ALSO THE AVERAGE                                                  CD97  23
#                                                                       CD97  24
RAVE=0.0#                                                               CD97  25
RMIN=10E+8#                                                             CD97  26
RMAX=10E-8#                                                             CD97  27
DO I=1,NCOEF#                                                           CD97  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD97  29
DO J=1,NCOEF#                                                           CD97  30
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD97  31
AR=ABS(RMAT(I,J))#                                                      CD97  32
RAVE=RAVE+AR#                                                           CD97  33
IF(AR>RMAX) RMAX=AR#                                                    CD97  34
IF(AR<RMIN) RMIN=AR#                                                    CD97  35
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD97  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD97  37
RAVE=RAVE/(NCOEF*NCOEF)#                                                CD97  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD97  39
#                                                                       CD97  40
#      SCALE EVERYTHING BY RAVE                                         CD97  41
#                                                                       CD97  42
DO I=1,NCOEF#                                                           CD97  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD97  44
DO J=1,NCOEF#                                                           CD97  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD97  46
RMAT(I,J)=RMAT(I,J)/RAVE#                                               CD97  47
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD97  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD97  49
RETURN#                                                                 CD97  50
END#                                                                    CD97  51
systemheader:(CD98)#                                                    CD98   1
# ################################################################## #  CD98   2
#                                                                    #  CD98   3
#                               CD98                                 #  CD98   4
#                                                                    #  CD98   5
# ################################################################## #  CD98   6
#                                                                       CD98   7
SUBROUTINE CD98(ARRAY,NORDER,DET)#                                      CD98   8
#                                                                       CD98   9
#     MATRIX INVERSION ROUTINE TAKEN FROM BEVINGTON.                    CD98  10
#                                                                       CD98  11
INTEGER IK(9)#                                                          CD98  12
INTEGER JK(9)#                                                          CD98  13
REAL ARRAY(9,9)#                                                        CD98  14
REAL SAVE#                                                              CD98  15
REAL AMAX#                                                              CD98  16
#                                                                       CD98  17
DET=1#                                                                  CD98  18
IF(NORDER>9) iquit:(CD0801)#                                            CD98  19
DO K=1,NORDER#                                                          CD98  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CD98  21
AMAX=0.0#                                                               CD98  22
DO I=K,NORDER#                                                          CD98  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CD98  24
DO J=K,NORDER#                                                          CD98  25
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CD98  26
IF(ABS(AMAX)<=ABS(ARRAY(I,J)))#                                         CD98  27
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CD98  28
AMAX=ARRAY(I,J)#                                                        CD98  29
IK(K)=I#                                                                CD98  30
JK(K)=J#                                                                CD98  31
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CD98  32
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CD98  33
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CD98  34
IF(AMAX==0.0)#                                                          CD98  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CD98  36
DET=0.0#                                                                CD98  37
BREAK#                                                                  CD98  38
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CD98  39
I=IK(K)#                                                                CD98  40
IF(I<K) NEXT#                                                           CD98  41
ELSE IF(I>K)#                                                           CD98  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CD98  43
DO J=1,NORDER#                                                          CD98  44
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CD98  45
SAVE=ARRAY(K,J)#                                                        CD98  46
ARRAY(K,J)=ARRAY(I,J)#                                                  CD98  47
ARRAY(I,J)=-SAVE#                                                       CD98  48
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CD98  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CD98  50
J=JK(K)#                                                                CD98  51
IF(J<K) NEXT#                                                           CD98  52
ELSE IF(J>K)#                                                           CD98  53
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CD98  54
DO I=1,NORDER#                                                          CD98  55
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CD98  56
SAVE=ARRAY(I,K)#                                                        CD98  57
ARRAY(I,K)=ARRAY(I,J)#                                                  CD98  58
ARRAY(I,J)=-SAVE#                                                       CD98  59
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CD98  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CD98  61
DO I=1,NORDER#                                                          CD98  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CD98  63
IF(I!=K)#                                                               CD98  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CD98  65
ARRAY(I,K)=-ARRAY(I,K)/AMAX#                                            CD98  66
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CD98  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CD98  68
DO I=1,NORDER#                                                          CD98  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CD98  70
DO J=1,NORDER#                                                          CD98  71
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CD98  72
IF(I!=K)#                                                               CD98  73
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CD98  74
IF(J!=K)#                                                               CD98  75
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CD98  76
ARRAY(I,J)=ARRAY(I,J)+ARRAY(I,K)*ARRAY(K,J)#                            CD98  77
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CD98  78
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CD98  79
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CD98  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CD98  81
DO J=1,NORDER#                                                          CD98  82
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CD98  83
IF(J!=K)#                                                               CD98  84
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CD98  85
ARRAY(K,J)=ARRAY(K,J)/AMAX#                                             CD98  86
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CD98  87
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CD98  88
ARRAY(K,K)=1./AMAX#                                                     CD98  89
DET=DET*AMAX#                                                           CD98  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CD98  91
DO L=1,NORDER#                                                          CD98  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CD98  93
K=NORDER-L+1#                                                           CD98  94
J=IK(K)#                                                                CD98  95
IF(J>K)#                                                                CD98  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CD98  97
DO I=1,NORDER#                                                          CD98  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CD98  99
SAVE=ARRAY(I,K)#                                                        CD98 100
ARRAY(I,K)=-ARRAY(I,J)#                                                 CD98 101
ARRAY(I,J)=SAVE#                                                        CD98 102
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CD98 103
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CD98 104
I=JK(K)#                                                                CD98 105
IF(I>K)#                                                                CD98 106
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CD98 107
DO J=1,NORDER#                                                          CD98 108
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CD98 109
SAVE=ARRAY(K,J)#                                                        CD98 110
ARRAY(K,J)=-ARRAY(I,J)#                                                 CD98 111
ARRAY(I,J)=SAVE#                                                        CD98 112
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CD98 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CD98 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CD98 115
RETURN#                                                                 CD98 116
END#                                                                    CD98 117
pmacro:([no:])#                        Purge xtal system macros         CD98 118
