systemheader:(CN    )#                                                  CN     1
#####################################################################   CN     2
##      Copyright (C) 2000, The Xtal System, The University of        # CN     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # CN     4
## Distributed under the GNU General Public Licence as published by   # CN     5
## the Free Software Foundation, in the hope that it will be useful   # CN     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # CN     7
## for more details.                                                  # CN     8
#                                                                   #   CN     9
#                    **** CONTRS ****                               #   CN    10
#                                                                   #   CN    11
#     CONTRS PRODUCES CONTOUR MAPS OF GRIDDED ELECTRON-DENSITY      #   CN    12
#     TYPE DATA OR VECTOR MAPS OF GRIDDED VECTOR FIELD TYPE         #   CN    13
#     DATA PRODUCED BY FOURR, SLANT OR SIMILAR PROGRAMS.            #   CN    14
#     THE PLOT COORDINATES PRODUCED BY CONTRS ARE WRITTEN ON        #   CN    15
#     FILE FOR SUBSEQUENT USE BY PLOT FOR DISPLAY ON VARIOUS        #   CN    16
#     PLOTTING DEVICES.                                             #   CN    17
#                                                                   #   CN    18
#####################################################################   CN    19
#                                                                       CN    20
include:(XMACRO)#                                                       CN    21
#                                                                       CN    22
macro:(subtqx:,[$3=QX($1)-$2#                                           CN    23
IF(ABS($3).LT.small:) $3=SIGN(small:,$3)])#                             CN    24
macro:(swapqx:,[$(QXRTZP=QX($1);QX($1)=QX($2);QX($2)=QXRTZP$)])#        CN    25
macro:(dp:,ifelse:(mxbtwd:,32,DOUBLE PRECISION ,REAL ))#                CN    26
macro:(sg:,ifelse:(mxbtwd:,32,SNGL($1),$1))#                            CN    27
macro:(db:,ifelse:(mxbtwd:,32,DBLE($1),$1))#                            CN    28
macro:(dsqrt:,ifelse:(mxbtwd:,32,DSQRT($1),SQRT($1)))#                  CN    29
macro:(d0:,ifelse:(mxbtwd:,32,D+0 ,E+0 ))#                              CN    30
macro:(dcos:,ifelse:(mxbtwd:,32,DCOS($1),COS($1)))#                     CN    31
macro:(dacos:,ifelse:(mxbtwd:,32,DACOS($1),ACOS($1)))#                  CN    32
macro:(dlog:,ifelse:(mxbtwd:,32,DLOG($1),ALOG($1)))#                    CN    33
macro:(dexp:,ifelse:(mxbtwd:,32,DEXP($1),EXP($1)))#                     CN    34
macro:(dabs:,ifelse:(mxbtwd:,32,DABS($1),ABS($1)))#                     CN    35
macro:(filling:,IF(FILLED==yes:)$(COLOR=0;IPEN=3#                       CN    36
CALL CN03($1,$2,3);IPEN=2;COLOR=-6000#                                  CN    37
CALL CN03($1,$2,3)$))#                                                  CN    38
macro:(step0:,4)#                                                       CN    39
macro:(step2:,4)#                                                       CN    40
macro:(step3:,6)#                                                       CN    41
macro:(step4:,4)#                                                       CN    42
#                                                                       CN    43
extrude:(CNCOMN)#                                                       CN    44
INTEGER ATOMS#      ## Signal for plotting of atomic sites              CN    45
INTEGER BORDER#     ## Signal for plotting of map border                CN    46
INTEGER COLOR#      ## Colour index for colour graphics output          CN    47
REAL    CLL#        ## Color scheme lower limit                         CN    48
REAL    CUL#        ## Color scheme Upper limit                         CN    49
REAL    CZL#        ## Color scheme Zero value                          CN    50
REAL    CBEG#       ## Beginning contour                                CN    51
REAL    CINT#       ## contour interval                                 CN    52
REAL    CONT(90)#   ## Contour values to be plotted                     CN    53
INTEGER COL(90)#    ## RGB color model index                            CN    54
REAL    COSG#       ## Cosine of map border interaxial angle            CN    55
INTEGER CUBIC#      ## Signal for cubic interpolation on grid           CN    56
REAL    DASH(10)#   ## Dash-gap length sequence for dashed lines        CN    57
INTEGER DLAYER#     ## Increment between layers to be contoured         CN    58
REAL    DGSEQ(10)#  ## Dash-gap sequence for current level              CN    59
REAL    DIST#       ## Distance travelled on current curve              CN    60
REAL    DISTZ#      ## Slant distance of first layer from origin        CN    61
REAL    DNEXT#      ## Next dist to move on to next d-g element         CN    62
REAL    DOT(10)#    ## Dash-gap sequence for dotted lines               CN    63
INTEGER DREC#       ## Direct access file record pointer                CN    64
REAL    DX#         ## Distance between mesh points along x-border      CN    65
REAL    DY#         ## Distance between mesh points along y-border      CN    66
REAL    EMAX#       ## Maximum component of plotting function           CN    67
INTEGER FILLED#     ## whether the contours should be filled or not     CN    68
INTEGER MULCOL#     ## wheather multicolored spectrum or not            CN    69
INTEGER FLAYER#     ## Index of first layer to contour                  CN    70
INTEGER LAYER#      ## Index of current layer being contoured           CN    71
REAL    HEIGHT#     ## Height of numbers or chars to plot               CN    72
INTEGER IBOND#      ## Draw bonds in map 
INTEGER ICON#       ## Pointer to current contour level                 CN    73
INTEGER IDGSEQ#     ## Pointer to dgseq element being executed          CN    74
INTEGER ILAYER#     ## Increment between layers on input bdf            CN    75
INTEGER INPUT#      ## Input device logical unit number (3 or 4)        CN    76
INTEGER IPEN#       ## Pen up(3)/down(2) signal                         CN    77
INTEGER IPROP#      ## Number of map components                         CN    78
INTEGER PTYPE#      ## Property type                                    CN    79
INTEGER IVEC#       ## Signal to plot strength of electric field        CN    80
INTEGER KCURV#      ## Number of curves found for this level            CN    81
INTEGER LLAYER#     ## Index of last layer to contour                   CN    82
INTEGER LINEAR#     ## Signal for linear interpolation on the grid      CN    83
INTEGER LINTYP(90)# ## Signals line type(1/0/-1) for (solid/dash/dot)   CN    84
INTEGER MARKA#      ## Pointer to base of atom list in qx               CN    85
INTEGER MARKS#      ## Pointer to base of symops list in qx             CN    86
INTEGER MARK0#      ## Pointer to contour level stats                   CN    87
INTEGER MARK1#      ## Pointer to layer of grid points in qx            CN    88
INTEGER MARK2#      ## Pointer to curve info for level                  CN    89
INTEGER MARK3#      ## Pointer to interpolated points information       CN    90
INTEGER MARK4#      ## Pointer to info on points per curve              CN    91
INTEGER STOP4#      ## End of info on points per curve                  CN    92
INTEGER MESH#       ## Signal for plotting of mesh points               CN    93
INTEGER NAMES#      ## Signal for plotting atom names below sites       CN    94
INTEGER NBLA#       ## Controls plotting of blanks in string (0/1)      CN    95
INTEGER NCON#       ## Total number of contours to be plotted           CN    96
INTEGER NDASH#      ## Number of elements in sequence for dashlines     CN    97
INTEGER NDGSEQ#     ## Number of elements in current line sequence      CN    98
INTEGER NDOT#       ## Number of elements in sequence for dotlines      CN    99
INTEGER NFIGS#      ## Number of figs to right of dec. pt to encode     CN   100
INTEGER NOPTS#      ## Number of points found for current level         CN   101
INTEGER NSTRIN#     ## Special symbol number/no of chars in string      CN   102
INTEGER NX#         ## Number of data points across the layer           CN   103
INTEGER NY#         ## Number of data points down the layer             CN   104
INTEGER OLDCOL#     ## Colour index for last curve plotted              CN   105
INTEGER ORGZ#       ## Origin of layer axis in grid units               CN   106
REAL    ORIENT(9)#  ## Orientation vectors of map axes                  CN   107
INTEGER PLAD#       ## Flag for plotting atom distances                 CN   108
INTEGER PLAYER#     ## Current layer position of the input bdf          CN   109
REAL    PLOTNU#     ## Number to be plotted on output device            CN   110
REAL    PLOTX#      ## X-dimension of final plot                        CN   111
REAL    PLOTY#      ## Y-dimension of final plot                        CN   112
INTEGER PXSIZ#      ## Packet size on lr22: (pts in rows)               CN   113
INTEGER PYSIZ#      ## Number of packets on lr22: to a layer            CN   114
REAL    RADII(16)#  ## Atomic radii
REAL    RESOL#      ## Resolution of final plot (relative to ploty)     CN   115
INTEGER ROTATE#     ## Signal to rotate plot 90 degrees clockwise       CN   116
REAL    SCALE#      ## Scale factor for the map (scales y to 10)        CN   117
REAL    SCARR#      ## Scale factor for the arrow length                CN   118
REAL    SING#       ## Sine of interaxial angle                         CN   119
INTEGER SMOOTH#     ## Signal for smoothing between points              CN   120
INTEGER STEPA#      ## Step size for atoms in list (x,y,z,sym,label)    CN   121
string:(STRING,72)# ## Character string for plotting                    CN   122
INTEGER SUPER#      ## Signal for superposition of contoured layers     CN   123
REAL    THETA#      ## Angle to x-axis to plot string/spec. symbol      CN   124
REAL    VICIN#      ## Vicinity about map for plotting of atoms         CN   125
REAL    XCUR#       ## Current pen x-coordinate                         CN   126
REAL    XL#         ## Length across the layer in angstroms             CN   127
REAL    XLOW#       ## X-coord of lower l.h. corner of the map          CN   128
REAL    XLS#        ## Scaled length across map                         CN   129
REAL    XUPP#       ## X-coord of upper r.h. corner of the map          CN   130
REAL    YCUR#       ## Current pen y-coordinate                         CN   131
REAL    YL#         ## Length down the layer in angstroms               CN   132
REAL    YLOW#       ## Y-coord of lower l.h. corner of the map          CN   133
REAL    YLS#        ## Scaled y-length down map                         CN   134
REAL    YUPP#       ## Y-coord of upper r.h. corner of the map          CN   135
REAL    ZDEL#       ## Distance between layers in angstroms             CN   136
REAL    ZMAX#       ## Maximum z component for vector plotting          CN   137
REAL    ZMIN#       ## Minimum z component for vector plotting          CN   138
#                                                                       CN   139
COMMON/COMFCN/ $#                      Real common for contrs           CN   140
CBEG, CINT, CONT, COL, COSG, DASH, DGSEQ, DIST, DISTZ, DNEXT,#          CN   141
DOT, DX, DY, EMAX, HEIGHT, PLOTNU, PLOTX, PLOTY,ORIENT,#                CN   142
RESOL, SCALE, SCARR, SING, THETA, VICIN, XCUR, XL, XLOW, XLS, XUPP,#    CN   143
YCUR, YL, YLS, YLOW, YUPP, ZDEL, ZMAX, ZMIN, CLL, CUL, CZL,RADII# 
#                                                                       CN   145
COMMON/COMICN/ $#                      Integer common for contrs        CN   146
ATOMS, BORDER, COLOR, CUBIC, DLAYER, FLAYER, ICON, IDGSEQ,FILLED,#      CN   147
ILAYER, INPUT, IPEN, IPROP, IVEC, KCURV, LAYER, LINEAR, LINTYP,MULCOL,# CN   148
LLAYER, MARKA, MARKS, MARK0, MARK1, MARK2, MESH, NAMES, NBLA, NCON,#    CN   149
NDASH, NDGSEQ, NDOT, NFIGS, NOPTS, NSTRIN, NX, NY, OLDCOL, ORGZ,#       CN   150
PTYPE, PLAYER, PXSIZ, PYSIZ, ROTATE, SMOOTH, STEPA, SUPER, PLAD,#       CN   151
MARK3, MARK4, STOP4, DREC, IBOND# 
#                                                                       CN   153
COMMON/COMCCN/ STRING#                 Character common for contrs      CN   154
endext:#                                                                CN   155
#                                                                       CN   156
systemheader:(CN00)#                                                    CN00   1
#####################################################################   CN00   2
#                                                                   #   CN00   3
#                           CN00                                    #   CN00   4
#                                                                   #   CN00   5
#####################################################################   CN00   6
SUBROUTINE CN00#                       M.a. spackman 1984               CN00   7
include:(AACOMN)#                      V.a. streltsov 1992              CN00   8
include:(CNCOMN)#                                                       CN00   9
#                                                                       CN00  10
FILEXT(IOUNIT(3))='MAP'#               Extension for fourr map          CN00  11
FILEXT(IOUNIT(4))='SLA'#               Extension for slant map          CN00  12
FILEXT(IOUNIT(5))='CON'#               Extension for plt contours       CN00  13
FILEXT(ioda1:)   ='xxe'#               Direct access binary file        CN00  14
#                                                                       CN00  15
CALL CN10#                             Process line input               CN00  16
#                                                                       CN00  17
#    LOOP OVER LAYERS OF MAP POINTS                                     CN00  18
#    ------------------------------                                     CN00  19
#                                                                       CN00  20
FOR(LAYER=FLAYER ; LAYER<=LLAYER ; LAYER=LAYER+DLAYER)# Layers loop     CN00  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN00  22
CALL CN20#                             Input layer from the bdf         CN00  23
IF(IVEC==1)#                           Test if contouring               CN00  24
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN00  25
FOR(ICON=1;ICON<=NCON;ICON=ICON+1)#    Loop over contour levels         CN00  26
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN00  27
CALL CN30#                             Interpolation over grid          CN00  28
IF(NOPTS<=0) NEXT#                     Break to next level if no pt     CN00  29
CALL CN40#                             Chain points together            CN00  30
IF(FILLED==no:) CALL CN50#             Write all curves for level       CN00  31
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN00  32
IF(FILLED==yes:)CALL CN45#             Write all contours for layer     CN00  33
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN00  34
ELSE CALL CN90#                        Vector plotting                  CN00  35
IF(SUPER==no:) CALL CN60#              Plot border, mesh pts & titl     CN00  36
IF(ATOMS==yes:) CALL CN70#             Plot atoms near plane            CN00  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN00  38
IF(SUPER==yes:) CALL CN60#             Plot border, mesh pts & titl     CN00  39
IF(ATOMS==yes:) CALL CN70#             Finish outputting atoms          CN00  40
CALL CN80#                             Finish off the plot              CN00  41
IF(DREC>=0)closedac:(ioda1:)#          Close of this temp file          CN00  42
#                                                                       CN00  43
RETURN#                                                                 CN00  44
END#                                                                    CN00  45
systemheader:(CN03)#                                                    CN03   1
#####################################################################   CN03   2
#                                                                   #   CN03   3
#                           CN03                                    #   CN03   4
#                                                                   #   CN03   5
#####################################################################   CN03   6
SUBROUTINE CN03(X,Y,K)#                                                 CN03   7
include:(AACOMN)#                                                       CN03   8
include:(CNCOMN)#                                                       CN03   9
#                                                                       CN03  10
# WRITE ALL COMMANDS TO TO PLOT INSTRUCTION FILE                        CN03  11
# PLOT FUNCTIONS ARE GIVEN BY K:                                        CN03  12
#   1 .. START OF PLOT                                                  CN03  13
#   2 .. PLOT FRAME ADVANCE SIGNAL                                      CN03  14
#   3 .. PEN MOVEMENT UP/DOWN GIVEN BY IPEN                             CN03  15
#   4 .. PLOT A NUMBER, PLOTNU                                          CN03  16
#   5 .. PLOT A SPECIAL SYMBOL OR CHAR STRING                           CN03  17
#   6 .. AUTO CENTRE AND SCALE                                          CN03  18
#   7 .. RGB COLOR MAP ENTRY                                            CN03  19
#   8 .. COMMENT                 NOT USED                               CN03  20
#   9 .. AREA FILL               NOT USED                               CN03  21
#  10 .. END OF PLOT SIGNAL                                             CN03  22
#  11 .. GROUP                   NOT USED                               CN03  23
#  12 .. END GROUP               NOT USED                               CN03  24
#                                                                       CN03  25
INTEGER IPT,K,J,II,JJ#                                                  CN03  26
REAL    X,Y#                                                            CN03  27
#                                                                       CN03  28
writepkt:(5,23,7,IPT)#                 Write the packet                 CN03  29
DO J=1,6 ; QX(IPT+J)=0.0#              Zero the packet                  CN03  30
QX(IPT+7)=FLOAT(K)#                    Plot function signal             CN03  31
IF(K>=3&K<=5)#                         Fill x, y coords here            CN03  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN03  33
QX(IPT+1)=X#                           X-coordinate offset by a bit     CN03  34
QX(IPT+2)=Y#                           Y-coordinate offset by a bit     CN03  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN03  36
#                                                                       CN03  37
IF(K==3)#                              Move pen to (x,y)                CN03  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN03  39
QX(IPT+5)=FLOAT(COLOR)#                Colour index                     CN03  40
QX(IPT+6)=FLOAT(IPEN)#                 Pen up/down signal               CN03  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN03  42
ELSE IF(K==4)#                         Plot number plotnu               CN03  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN03  44
QX(IPT+3)=HEIGHT#                      Height of number                 CN03  45
QX(IPT+4)=PLOTNU#                      Number to be plotted             CN03  46
QX(IPT+5)=THETA#                       Angle to x-axis                  CN03  47
QX(IPT+6)=FLOAT(NFIGS)#                No of decimal points             CN03  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN03  49
ELSE IF(K==5)#                         Plot symbol or char string       CN03  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CN03  51
QX(IPT+3)=HEIGHT#                      Height of symbol/chars           CN03  52
QX(IPT+4)=THETA#                       Angle to x-axis                  CN03  53
QX(IPT+5)=FLOAT(NSTRIN)#               Spec char no/string length       CN03  54
QX(IPT+6)=FLOAT(NBLA)#                 Plotting of blanks               CN03  55
IF(NSTRIN>0)#                          Stuff character string           CN03  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CN03  57
FOR(II=1 ; II<=NSTRIN ; II=II+7*mxchwd:)# Loop over char string         CN03  58
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CN03  59
JJ=MIN0(NSTRIN-II+1,7*mxchwd:)#        No of chars to transfer          CN03  60
writepkt:(5,23,7,IPT)#                 Write the packet                 CN03  61
movector:(STRING,II,QX(IPT+1),1,JJ,0)# Transfer characters              CN03  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CN03  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CN03  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CN03  65
ELSE IF(K==6)#                         Auto centre and scale            CN03  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CN03  67
QX(IPT+1)=PLOTX-(XLOW- 4.*HEIGHT)#     Plot width                       CN03  68
QX(IPT+2)=PLOTY-(YLOW-11.*HEIGHT)#     Plot height                      CN03  69
QX(IPT+3)=1.#                          Stereo flag                      CN03  70
QX(IPT+4)=0.#                          Frame margin                     CN03  71
QX(IPT+5)=XLOW-4.*HEIGHT#              Lower left x value               CN03  72
QX(IPT+6)=YLOW-11.*HEIGHT#             Lower left y value               CN03  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CN03  74
ELSE IF(K==7)#                         Color map entry                  CN03  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CN03  76
intpak:(COLOR,QX(IPT+5),0,24)#         24 bit rgb color                 CN03  77
QX(IPT+6)=FLOAT(IPEN)#                 Color map index                  CN03  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CN03  79
ELSE IF(K==10) writepkt:(5,endrecord:,4,J)# Write end of plot record    CN03  80
#                                                                       CN03  81
RETURN#                                                                 CN03  82
END#                                                                    CN03  83
systemheader:(CN10)#                                                    CN10   1
#####################################################################   CN10   2
#                                                                   #   CN10   3
#                           CN10                                    #   CN10   4
#                                                                   #   CN10   5
#####################################################################   CN10   6
SUBROUTINE CN10#                                                        CN10   7
include:(AACOMN)#                                                       CN10   8
include:(CNCOMN)#                                                       CN10   9
#                                                                       CN10  10
INTEGER J,K,L,KEY,M,N,NTEMP,N1,N2,CONS,CMODL,PLEV,K1#                   CN10  11
INTEGER ARITH,DIRECT,GEOM,LINETY,NEGATE,ZINCL#                          CN10  12
INTEGER I1,I#                                                           CN10  13
REAL    XTEMP,X#                                                        CN10  14
REAL    YMAX#                                                           CN10  15
REAL    RGB(3),V1,V3,ANGL,RANGE,COFSET#                                 CN10  16
REAL    CZF,TMP#                                                        CN10  17
#                                                                       CN10  18
chardata:(CN1A,FL LL DL SU LI CU SM NS ME BO NB AT RO FO SL RE NA $#    CN10  19
NN VE SC DI FI DR )# 
chardata:(CN1B, LEVELS LINTYP DASH   DOT    COLOR  END    )#            CN10  21
chardata:(CN1C,AR GE DI NC ST IN NE NN ZI NZ )#                         CN10  22
chardata:(CN1D,DA DO SO )#                                              CN10  23
chardata:(CN1E,TEM HUE GRE RGB )#                                       CN10  24
chardata:(CNH1, CONTRS CONTROL INPUT)#                                  CN10  25
chardata:(CNH2, --------------------)#                                  CN10  26
chardata:(CNH3, CONTOUR LEVELS INPUT)#                                  CN10  27
chardata:(CNH4, CONTOUR LEVELS FOUND)#                                  CN10  28
chardata:(CNH5, SCALAR FUNCTION PLOT)#                                  CN10  29
chardata:(CNH6, VECTOR)#                                                CN10  30
chardata:(CN10C, FIRST LAYER                        )#                  CN10  31
chardata:(CN10D, LAST LAYER                         )#                  CN10  32
chardata:(CN10E, LAYER INCREMENT                    )#                  CN10  33
chardata:(CN10F, SUPERPOSITION OF LAYERS            )#                  CN10  34
chardata:(CN10G, INTERPOLATION TYPE OVER GRID       )#                  CN10  35
chardata:(CN10H, SMOOTHING OF PLOTTED CURVES        )#                  CN10  36
chardata:(CN10I, RESOLUTION FOR SMOOTHING           )#                  CN10  37
chardata:(CN10J, PLOT THE MESH POINT LOCATIONS      )#                  CN10  38
chardata:(CN10K, PLOT THE BORDER OF THE MAP         )#                  CN10  39
chardata:(CN10L, PLOT ATOMS IN VICINITY OF MAP      )#                  CN10  40
chardata:(CN10M, ROTATE MAP 90 DEGREES CLOCKWISE    )#                  CN10  41
chardata:(CN10N, TYPE OF LEVELS INPUT               )#                  CN10  42
chardata:(CN10O, STARTING CONTOUR LEVEL             )#                  CN10  43
chardata:(CN10P, INCR/RATIO BETWEEN LEVELS          )#                  CN10  44
chardata:(CN10Q, TOTAL NUMBER OF LEVELS             )#                  CN10  45
chardata:(CN10R, DASHED LINE SEQUENCE               )#                  CN10  46
chardata:(CN10S, DOTTED LINE SEQUENCE               )#                  CN10  47
chardata:(CN10T, MAXIMUM DIST OF ATOMS FROM MAP     )#                  CN10  48
chardata:(CN10U,           CONTOUR     LINE   POINTS   POINTS   $#      CN10  49
CURVES)#                                                                CN10  50
chardata:(CN10V,             LEVEL     TYPE    FOUND   PURGED    $#     CN10  51
FOUND)#                                                                 CN10  52
chardata:(CN10W, SCALE FACTOR FOR ARROWS            )#                  CN10  53
chardata:(CNY,YES)#                                                     CN10  54
chardata:(CNN, NO)#                                                     CN10  55
chardata:(CNC, CUBIC)#                                                  CN10  56
chardata:(CNL,LINEAR)#                                                  CN10  57
chardata:(CNA,ARITHMETIC)#                                              CN10  58
chardata:(CNG, GEOMETRIC)#                                              CN10  59
chardata:(CND,    DIRECT)#                                              CN10  60
chardata:(HEXCH,0123456789ABCDEF)#                                      CN10  61
realdata:(IFMT,[320422.,360422.,400422.,440422.,480422.,#               CN10  62
520422.,560422.,600422.,640422.,680422.])#                              CN10  63
intdata:(LINE,0)#                                                       CN10  64
datastuff:#                                                             CN10  65
#                                                                       CN10  66
#    SET DEFAULT CONTOUR PARAMETERS                                     CN10  67
#    -----------------------------                                      CN10  68
#                                                                       CN10  69
YMAX=10.; YLOW=2.; YUPP=12.; PLOTY=12.# Set initial parameters          CN10  70
THETA=0.; NBLA=0; NFIGS=3#                                              CN10  71
OLDCOL=-1000000#                       Initialize old line type         CN10  72
COLOR=0#                               Initialize colour index          CN10  73
FLAYER=10000#                          First layer                      CN10  74
LLAYER=10000#                          Last layer                       CN10  75
DLAYER=10000#                          Increment between layers         CN10  76
SUPER=no:#                             No superposition of layers       CN10  77
LINEAR=no:#                            No linear interpolation          CN10  78
CUBIC=yes:#                            Default to cubic interp          CN10  79
SMOOTH=yes:#                           Smooth between points            CN10  80
MESH=no:#                              No mesh points plotted           CN10  81
BORDER=yes:#                           Plot border of map               CN10  82
ATOMS=yes:#                            Plot atomic sites                CN10  83
NAMES=yes:#                            Plot atom names below sites      CN10  84
ROTATE=no:#                            No rotation of plot              CN10  85
INPUT=3#                               Default input bdf is filec       CN10  86
RESOL=0.10#                            Default resolution for curve     CN10  87
LINETY=no:#                            Signal for lintyp input          CN10  88
VICIN=0.0#                             Map vicinity to plot atoms       CN10  89
IVEC=1#                                Default scalar function plot     CN10  90
SCARR=1.0#                             Scale factor for arrows          CN10  91
PLAD=no:#                              Default no ploting of atom dis   CN10  92
FILLED=no:#                            No filling of contours           CN10  93
MULCOL=no:#                            Not multicoloured spectrum       CN10  94
CMODL=2#                               Hue                              CN10  95
CLL=-1.#                               Lower limit not imposed          CN10  96
CUL= 6.#                               Upper limit not imposed          CN10  97
CZL=-1.#                               Zero  level not imposed          CN10  98
CZF= 1.#                               Zero  level max saturation       CN10  99
DREC=-1#                               Flag dacfile as unused           CN10 100
IBOND=no:#                             draw No bonds    
#                                                                       CN10 101
#    ENTER CONTOUR PARAMETERS                                           CN10 102
#    -----------------------                                            CN10 103
#                                                                       CN10 104
DO J=1,mxfdim:#                        Loop over input fields           CN10 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN10 106
ifvo:(BUFIN(J)) BREAK#                 Exit on first void               CN10 107
IF(BUFIN(J)<voidflg:)#                 Test for char string             CN10 108
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN10 109
stringlim:(J,N,M)#                     Get limits of char string        CN10 110
compchar:(CHRIN,N,CN1A,1,2,3,NCN1A,KEY)# Search for string match        CN10 111
IF(KEY==0) iquit:(CN1001,J)#           No match ..... 131001            CN10 112
ELSE IF(KEY==4) SUPER=yes:#            Switch on superposition          CN10 113
ELSE IF(KEY==5)#                       Linear interpolation             CN10 114
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN10 115
LINEAR=yes: ; CUBIC=no:#               Set signals for linear case      CN10 116
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN10 117
ELSE IF(KEY==6) CUBIC=yes:#            Cubic interpolation              CN10 118
ELSE IF(KEY==8) SMOOTH=no:#            Turn off smoothing               CN10 119
ELSE IF(KEY==9) MESH=yes:#             Turn on mesh plotting            CN10 120
ELSE IF(KEY==11) BORDER=no:#           No border to be plotted          CN10 121
ELSE IF(KEY==13) ROTATE=yes:#          Rotate plot 90 deg clkwise       CN10 122
ELSE IF(KEY==14) INPUT=3#              Input bdf is filec (fourr)       CN10 123
ELSE IF(KEY==15) INPUT=4#              Input bdf is filed (slant)       CN10 124
ELSE IF(KEY==17) ATOMS=no:#            Do not plot atoms                CN10 125
ELSE IF(KEY==18) NAMES=no:#            Do not plot atom names           CN10 126
ELSE IF(KEY==19) IVEC=3#               Vector function plotting         CN10 127
ELSE IF(KEY==21) PLAD=yes:#            Flag to plot atom dist           CN10 128
ELSE IF(KEY==22) FILLED=yes:#          Flag to fill inter-contour are   CN10 129
ELSE IF(KEY==23) IBOND=yes:#           Flag to draw bonds in map
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN10 130
ELSE#                                  Input is numeric                 CN10 131
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CN10 132
IF     (KEY==1) FLAYER=NINT(BUFIN(J))# Get first layer number           CN10 133
ELSE IF(KEY==2) LLAYER=NINT(BUFIN(J))# Get last layer number            CN10 134
ELSE IF(KEY==3) DLAYER=NINT(BUFIN(J))# Get layer increment              CN10 135
ELSE IF(KEY==12) VICIN=BUFIN(J)#       Vicinity for atoms               CN10 136
ELSE IF(KEY==16) RESOL=BUFIN(J)#       Get curve resolution             CN10 137
ELSE IF(KEY==20) SCARR=BUFIN(J)#       Get scale for arrow length       CN10 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CN10 139
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN10 140
IF(IVEC==3) INPUT=4#                   Input bdf is filed (slant)       CN10 141
#                                                                       CN10 142
#    SET DEFAULTS FOR CONTOUR LEVELS                                    CN10 143
#    -------------------------------                                    CN10 144
#                                                                       CN10 145
# DASH AND DOT SEQUENCE LENGTHS ARE EXPECTED RELATIVE                   CN10 146
# TO A Y (DOWN) LENGTH OF 10 PLOT UNITS                                 CN10 147
#                                                                       CN10 148
IF(IVEC==1)#                           Loop for scalar functions        CN10 149
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CN10 150
DO J=1,10#                             Loop over dash-gap elements      CN10 151
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CN10 152
DASH(J)=0.0 ; DOT(J)=0.0 ; DGSEQ(J)=0.0# Zero dot, dash arrays          CN10 153
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CN10 154
NDASH=2#                               Default of 2 dash elements       CN10 155
DASH(1)=0.2 ; DASH(2)=0.2#             Dash & gap lengths = 0.2         CN10 156
NDOT=2#                                Default of 2 dot elements        CN10 157
DOT(1)=0.08 ; DOT(2)=0.08#             Dot & gap lengths = 0.08         CN10 158
ARITH=no:#                             Default is no specification      CN10 159
GEOM=no:#                              Of contour type - this must      CN10 160
DIRECT=no:#                            Be input !!!!!!        ----      CN10 161
NEGATE=no:#                            Don't include opp sign           CN10 162
ZINCL=no:#                             Don't include zero level         CN10 163
ICON=0 ; NCON=0#                       Zero contour level counters      CN10 164
#                                                                       CN10 165
#    LOOP OVER CONTROL LINES                                            CN10 166
#    -----------------------                                            CN10 167
#                                                                       CN10 168
REPEAT#                                Read control lines to end        CN10 169
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CN10 170
readline:(CN1B,NCN1B)#                 Process next input line          CN10 171
#                                                                       CN10 172
#    ***** LEVELS *****                                                 CN10 173
#                                                                       CN10 174
IF(LINID==1)#                          Contour levels input             CN10 175
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CN10 176
DO J=1,mxfdim:#                        Loop over input fields           CN10 177
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CN10 178
ifvo:(BUFIN(J)) BREAK#                 Exit on first void               CN10 179
IF(BUFIN(J)<voidflg:)#                 Test for char string             CN10 180
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CN10 181
stringlim:(J,N,M)#                     Get limits of char string        CN10 182
compchar:(CHRIN,N,CN1C,1,2,3,NCN1C,KEY)# Search for string match        CN10 183
IF     (KEY==0) iquit:(CN1002,J)#      No match ..... 131002            CN10 184
ELSE IF(KEY==1) ARITH=yes:#            Arithmetic intervals             CN10 185
ELSE IF(KEY==2) GEOM=yes:#             Geometric intervals              CN10 186
ELSE IF(KEY==3) DIRECT=yes:#           Levels to be input directly      CN10 187
ELSE IF(KEY==7) NEGATE=yes:#           Include levels of opp sign       CN10 188
ELSE IF(KEY==9) ZINCL=yes:#            Include zero level               CN10 189
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CN10 190
ELSE IF(DIRECT==no:)#                  Else input is numeric            CN10 191
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CN10 192
IF     (KEY==4) NCON=NINT(BUFIN(J))#   Number of levels                 CN10 193
ELSE IF(KEY==5) CBEG=BUFIN(J)#         First contour level              CN10 194
ELSE IF(KEY==6) CINT=BUFIN(J)#         Contour interval                 CN10 195
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CN10 196
ELSE IF(DIRECT==yes:)#                 Direct input of levels           CN10 197
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CN10 198
IF(KEY>=4&KEY<=6) iquit:(CN1004)#      Not allowed                      CN10 199
ELSE IF(KEY==3)#                       Values are expected              CN10 200
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CN10 201
NCON=NCON+1#                           Increment contour counter        CN10 202
CONT(NCON)=BUFIN(J)#                   Assign contour level             CN10 203
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CN10 204
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CN10 205
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CN10 206
#                                                                       CN10 207
#    PROCESS CONTOUR LEVEL INFORMATION                                  CN10 208
#    ---------------------------------                                  CN10 209
#                                                                       CN10 210
IF(DIRECT==no:)#                       Generate levels                  CN10 211
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CN10 212
CONT(1)=CBEG#                          First level                      CN10 213
DO J=2,NCON#                           Assign remaining values          CN10 214
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CN10 215
IF(ARITH==yes:) CONT(J)=CONT(J-1)+CINT## Arithmetic levels              CN10 216
IF(GEOM==yes:) CONT(J)=CONT(J-1)*CINT# Geometric intervals              CN10 217
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CN10 218
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CN10 219
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CN10 220
#                                                                       CN10 221
#    ***** LINTYP *****                                                 CN10 222
#                                                                       CN10 223
ELSE IF(LINID==2)#                     Process lintyp line              CN10 224
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CN10 225
LINETY=yes:#                           Lintyp input encountered         CN10 226
DO J=1,7,3#                            Loop over char input             CN10 227
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CN10 228
ifvo:(BUFIN(J)) BREAK#                 Exit on first void               CN10 229
IF(BUFIN(J)>=voidflg:) iquit:(CN1005)# Must be a char field             CN10 230
stringlim:(J,N,M)#                     Get limits of string             CN10 231
compchar:(CHRIN,N,CN1D,1,2,3,NCN1D,KEY)# Search for string match        CN10 232
IF(KEY==0) iquit:(CN1006,J)#           No match ..... 131006            CN10 233
N1=MIN(90,MAX(1,NINT(BUFIN(J+1))))#    First line of this type          CN10 234
N2=MIN(90,MAX(1,NINT(BUFIN(J+2))))#    Last line of this type           CN10 235
IF(KEY==1) LINE=0#                     Dashed lines                     CN10 236
ELSE IF(KEY==2) LINE=-1#               Dotted lines                     CN10 237
ELSE IF(KEY==3) LINE=1#                Solid lines                      CN10 238
DO K=N1,N2 ; LINTYP(K)=LINE#           Assign line types                CN10 239
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CN10 240
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CN10 241
#                                                                       CN10 242
#    ***** DASH *****                                                   CN10 243
#                                                                       CN10 244
ELSE IF(LINID==3)#                     Process dash line                CN10 245
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CN10 246
NDASH=NINT(BUFIN(1))#                  Number of elements               CN10 247
IF(NDASH>10) iquit:(CN1007)#           Too many dash-gap elements       CN10 248
DO K=1,NDASH ; DASH(K)=BUFIN(K+1)#     Fill dash array                  CN10 249
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CN10 250
#                                                                       CN10 251
#    ***** DOT *****                                                    CN10 252
#                                                                       CN10 253
ELSE IF(LINID==4)#                     Process dot line                 CN10 254
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CN10 255
NDOT=NINT(BUFIN(1))#                   Number of elements               CN10 256
IF(NDOT>10) iquit:(CN1007)#            Too many dash-gap elements       CN10 257
DO K=1,NDOT ; DOT(K)=BUFIN(K+1)#       Fill dot array                   CN10 258
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CN10 259
#                                                                       CN10 260
#    ***** COLOR *****                                                  CN10 261
#                                                                       CN10 262
ELSE IF(LINID==5)#                     Color line                       CN10 263
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CN10 264
MULCOL=yes:#                           Multicoloured switched on        CN10 265
J=1#                                                                    CN10 266
IF(BUFIN(J)>=voidflg:) iquit:(CN1005)# Must be a char field             CN10 267
stringlim:(J,N,M)#                     Get limits of string             CN10 268
compchar:(CHRIN,N,CN1E,1,3,4,NCN1E,CMODL)# Search for string match      CN10 269
IF(CMODL<=0) CMODL=2#                  Default to hue                   CN10 270
IF(CMODL<=3)#                          Hue or temp spectrum             CN10 271
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CN10 272
ifnm:(BUFIN(J+1))CLL=MAX(0.,MIN(BUFIN(J+1),1.0))# Fixing lower color    CN10 273
ifnm:(BUFIN(J+2))CUL=MAX(0.,MIN(BUFIN(J+2),1.0))# Fixing upper color    CN10 274
ifnm:(BUFIN(J+3))CZL=MAX(0.,MIN(BUFIN(J+3),1.0))# Fixing zero contour   CN10 275
ifnm:(BUFIN(J+4))CZF=MAX(0.,MIN(BUFIN(J+4),1.0))# Fudge zero contour    CN10 276
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CN10 277
ELSEIF(CMODL==4)#                      Explicit rgb levels              CN10 278
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CN10 279
J=J+1#                                                                  CN10 280
WHILE(BUFIN(J)!=voidflg:)#             Treat all chars as string        CN10 281
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CN10 282
stringlim:(J,N,M)#                     Get limits of string             CN10 283
I1=M-N+1#                                                               CN10 284
DO I=M,N,-1#                           Loop over characters             CN10 285
COL(J-1)=COL(J-1)+8**(I1-I)*(INDEX(CHRIN(I^I),HEXCH)-1)# Convert to i   CN10 286
COL(J-1)=MAX(0,MIN(16777216,COL(J-1)))# Impose rgb limits               CN10 287
J=J+1#                                 Increment bufin pointer          CN10 288
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CN10 289
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CN10 290
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CN10 291
#                                                                       CN10 292
#    ***** END *****                                                    CN10 293
#                                                                       CN10 294
ELSE BREAK#                            Exit read loop on end            CN10 295
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CN10 296
#                                                                       CN10 297
#    ADD EXTRA LEVELS IF DESIRED                                        CN10 298
#    ---------------------------                                        CN10 299
#                                                                       CN10 300
IF(ZINCL==yes:)#                       Include zero ?                   CN10 301
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CN10 302
NCON=NCON+1#                           Increment no of levels           CN10 303
CONT(NCON)=0.0#                        Set cont=0.0                     CN10 304
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CN10 305
IF(NEGATE==yes:)#                      Expand contour list              CN10 306
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CN10 307
IF(ZINCL==yes:) J=NCON-1#              Set expansion limit'             CN10 308
ELSE J=NCON#                           Depending on zincl               CN10 309
DO K=1,J ; CONT(NCON+K)=-CONT(J-K+1)#  Fill extra levels                CN10 310
NCON=NCON+J#                           Increment no of levels           CN10 311
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CN10 312
IF(NCON>90) iquit:(CN1008)#            Exit if too many levels          CN10 313
IF(NCON<=0) iquit:(CN1011)#            Exit if no levels specified      CN10 314
IF(LINETY==no:)#                       Set default line types           CN10 315
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CN10 316
DO K=1,NCON#                           Loop over levels                 CN10 317
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CN10 318
ifeq:(CONT(K),0.0) LINTYP(K)=0#        Dashed lines                     CN10 319
ELSE IF(CONT(K)<0) LINTYP(K)=-1#       Dotted lines                     CN10 320
ELSE LINTYP(K)=1#                      Solid lines                      CN10 321
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CN10 322
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CN10 323
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CN10 324
#                                                                       CN10 325
#    SORT CONTOUR LEVELS - LOWEST TO HIGHEST                            CN10 326
#    ---------------------------------------                            CN10 327
#                                                                       CN10 328
IF(FILLED==yes:)MULCOL=yes:#           Switch on default multi colori   CN10 329
IF(MULCOL==yes:)#                      Ineficient sort of contour lev   CN10 330
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CN10 331
DO I=1,NCON-1#                                                          CN10 332
DO J=I+1,NCON#                                                          CN10 333
IF(CONT(I)>CONT(J))#                                                    CN10 334
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CN10 335
TMP=CONT(J);CONT(J)=CONT(I);CONT(I)=TMP# Swap contour levels            CN10 336
K=LINTYP(J);LINTYP(J)=LINTYP(I);LINTYP(I)=K# Swap contour linetypes     CN10 337
IF(CMODL==4)#                          Rgb colors input                 CN10 338
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CN10 339
K=COL(J);COL(J)=COL(I);COL(I)=K#       Swap contour colors              CN10 340
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CN10 341
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CN10 342
CBEG=CONT(1)#                          Save minimum contour             CN10 343
CINT=(1+CONT(NCON)-CBEG)/FLOAT(NCON)#                                   CN10 344
#                                                                       CN10 345
IF(CONT(1)<0.0 &CONT(NCON)>0.0)#       Plus and minus contours          CN10 346
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CN10 347
DO I=1,NCON#                           Loop over contour levels         CN10 348
IF(CONT(I)>=0.0)BREAK#                 Break on zero or positive        CN10 349
ifeq:(CONT(I),0.0)PLEV=I+1#            This is the first pos contour    CN10 350
ELSE PLEV=I#                           Gone 1 step too far              CN10 351
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CN10 352
ELSE PLEV=1#                                                            CN10 353
#                                                                       CN10 354
#    COLOR MODEL 1 - TEMPERATURE                                        CN10 355
#    ---------------------------                                        CN10 356
#                                                                       CN10 357
IF(CMODL==1)#                          For temp spectrum                CN10 358
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 CN10 359
V1=0.0;V3=1.0#                                                          CN10 360
CLL=MAX(CLL,0.00)#                     Lower limit on red-black         CN10 361
CUL=MIN(CUL,1.00)#                     Upper limit on blue-black        CN10 362
IF(CZL<CLL\CZL>CUL)#                   Fixed zero level                 CN10 363
CZL=(CONT(PLEV-1)-CONT(1))/(CONT(NCON)-CONT(1))#                        CN10 364
X=CLL#                                 Initialize                       CN10 365
DO I=1,NCON#                           Cycle over graph colors          CN10 366
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 CN10 367
ANGL=X*6.2831853*0.75#                 An angle (max is 3/2 pi)         CN10 368
RGB(1)=SIN(ANGL)#                      The red setting                  CN10 369
RGB(2)=SIN(ANGL-0.7853981)#            The green setting                CN10 370
RGB(3)=SIN(ANGL-1.5707963)#            The blue setting                 CN10 371
DO J=1,3#                              Test each color                  CN10 372
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 CN10 373
IF    (RGB(J)>0.707)RGB(J)=V1+V3*1.0#  Maximise this color              CN10 374
ELSEIF(RGB(J)<0.00) RGB(J)=V1+V3*0.0#  Minimise this color              CN10 375
ELSE                RGB(J)=V1+V3*(1.4142*RGB(J))# Ramp this color       CN10 376
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 CN10 377
COL(I)=NINT(255.*RGB(3))+NINT(255.*RGB(2))*256+$#                       CN10 378
       NINT(255.*RGB(1))*65536#        Convert to rgb integer           CN10 379
IF(I<PLEV)X=X+(CONT(I+1)-CONT(I))/(CONT(PLEV-1)-CONT(1))*(CZL-CLL)#     CN10 380
ELSE      X=X+(CONT(I+1)-CONT(I))/(CONT(NCON)-CONT(PLEV))*(CUL-CZL)#    CN10 381
X=MIN(X,1.0)#                                                           CN10 382
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 CN10 383
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CN10 384
#                                                                       CN10 385
#    COLOR MODEL 2 - HUE                                                CN10 386
#    -------------------                                                CN10 387
#                                                                       CN10 388
ELSEIF(CMODL==2)#                      Hue/saturation/brightness        CN10 389
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 CN10 390
V1=0.0;V3=1.0#                                                          CN10 391
CLL=MAX(CLL,0.0)*6.283183#             Lower limit on circle            CN10 392
CUL=MIN(CUL,1.0)*6.283183#             Upper limit on circle            CN10 393
CZL=CZL*6.283183#                      Zero level                       CN10 394
RANGE=(CUL-CLL)#                       Color circle range               CN10 395
CONS=NCON#                                                              CN10 396
COFSET=CLL-1.047198#                   Color circle +magenta offset     CN10 397
K1=1#                                                                   CN10 398
L=0#                                                                    CN10 399
IF(CZL>=CLL&CZL<=CUL)#                 Fixed zero level                 CN10 400
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 CN10 401
K1=2#                                                                   CN10 402
CONS=PLEV-1#                                                            CN10 403
RANGE=(CZL-CLL)#                                                        CN10 404
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 CN10 405
DO K=1,K1#                             For plus and minus levels        CN10 406
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 CN10 407
IF(K==2)#                              Doing positive contours          CN10 408
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 CN10 409
L=L-1#                                                                  CN10 410
COFSET=CZL-1.047198#                   Color circle +magenta offset     CN10 411
RANGE=(CUL-CZL)#                       Positive range                   CN10 412
CONS=NCON-CONS+1#                      Number of positive contours      CN10 413
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 CN10 414
DO I=1,CONS#                           Cycle over graph colors          CN10 415
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 CN10 416
L=L+1#                                                                  CN10 417
ANGL=COFSET+RANGE*FLOAT(I-1)/FLOAT(CONS-1)# Theta increment             CN10 418
RGB(1)=(1.0+COS(ANGL))/2.#             The red setting                  CN10 419
RGB(2)=(1.0+COS(ANGL-2.0943951))/2.#   The green setting                CN10 420
RGB(3)=(1.0+COS(ANGL+2.0943951))/2.#   The blue setting                 CN10 421
DO J=1,3#                              Test each color                  CN10 422
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 CN10 423
IF    (RGB(J)>0.75)RGB(J)=V1+V3*1.0#   Maximise this color              CN10 424
ELSEIF(RGB(J)<0.25)RGB(J)=V1+V3*0.0#   Minimise this color              CN10 425
ELSE               RGB(J)=V1+V3*(2.*RGB(J)-0.5)# Ramp this color        CN10 426
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 CN10 427
COL(L)=NINT(255.*RGB(3))+NINT(255.*RGB(2))*256+$#                       CN10 428
       NINT(255.*RGB(1))*65536#        Convert to rgb integer           CN10 429
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 CN10 430
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 CN10 431
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 CN10 432
#                                                                       CN10 433
#    COLOR MODEL 3 - GREY LEVEL                                         CN10 434
#    --------------------------                                         CN10 435
#                                                                       CN10 436
ELSEIF(CMODL==3)#                                                       CN10 437
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 CN10 438
CLL=1.-MAX(CLL,0.0)#                   Lower limit on circle            CN10 439
CUL=1.-MIN(CUL,1.0)#                   Upper limit on circle            CN10 440
IF(CZL<CUL\CZL>CLL)#                   Fixed zero level                 CN10 441
CZL=CLL-(0-CONT(1))/(CONT(NCON)-CONT(1))*(CLL-CUL)# Calc fraction       CN10 442
ELSE CZL=1.-CZL#                                                        CN10 443
#                                      Col(i)=rgb hex =010101*val       CN10 444
DO I=1,PLEV#                           Cycle over negative grey level   CN10 445
COL(I)=65793*NINT(255.*(CLL-(CLL-CZL)*FLOAT(I-1)/FLOAT(PLEV-1)))#       CN10 446
DO I=PLEV,NCON#                        Cycle over positive grey level   CN10 447
COL(I)=65793*NINT(255.*(CZL-(CZL-CUL)*FLOAT(I-PLEV)/FLOAT(NCON-PLEV)))# CN10 448
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 CN10 449
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CN10 450
#                                                                       CN10 451
#                                                                       CN10 452
IF(MULCOL==yes:)#                      Ineficient sort of contour lev   CN10 453
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 CN10 454
DO I=1,PLEV-1#                         Bottom pointer to reverse orde   CN10 455
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 CN10 456
J=PLEV-I#                              Top pointer                      CN10 457
IF(J<=I)BREAK#                         Reversed order                   CN10 458
TMP=CONT(J);CONT(J)=CONT(I);CONT(I)=TMP# Swap contour levels            CN10 459
K=LINTYP(J);LINTYP(J)=LINTYP(I);LINTYP(I)=K# Swap contour linetypes     CN10 460
K=COL(J);COL(J)=COL(I);COL(I)=K#       Swap contour colors              CN10 461
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 CN10 462
#                                                                       CN10 463
IF(CONT(1)<0.0 &CONT(NCON)<=0.0)#      Minus contours and zero only     CN10 464
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 CN10 465
DO I=1,NCON#                           Bottom pointer to reverse orde   CN10 466
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 CN10 467
J=NCON-I+1#                            Top pointer                      CN10 468
IF(J<=I)BREAK#                         Reversed order                   CN10 469
TMP=CONT(J);CONT(J)=CONT(I);CONT(I)=TMP# Swap contour levels            CN10 470
K=LINTYP(J);LINTYP(J)=LINTYP(I);LINTYP(I)=K# Swap contour linetypes     CN10 471
K=COL(J);COL(J)=COL(I);COL(I)=K#       Swap contour colors              CN10 472
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 CN10 473
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 CN10 474
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 CN10 475
#                                                                       CN10 476
CALL CN11#                             Call to load preliminary         CN10 477
#  # BDF RECORDS                                                        CN10 478
#                                                                       CN10 479
#    SET PLOT STARTUP DETAILS                                           CN10 480
#    ------------------------                                           CN10 481
#                                                                       CN10 482
#IF(YL*SING>XL) ROTATE=YES:#           GUARANTEE X IS THE LONG AXIS     CN10 483
IF(ROTATE==yes:)#                      Rotate axes                      CN10 484
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 CN10 485
NTEMP=NX; NX=NY; NY=NTEMP#             Swap nx and ny                   CN10 486
XTEMP=XL; XL=YL; YL=XTEMP#             Swap xl and yl                   CN10 487
COSG=-COSG#                            Change interaxial angle          CN10 488
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 CN10 489
SCALE=YMAX/(YL*SING)#                  Scale for uniform size plot      CN10 490
XLS=XL*SCALE ; YLS=YL*SCALE#           Rescale xl & yl                  CN10 491
DX=XLS/FLOAT(NX-1)#                    Distance between pts along x     CN10 492
DY=YLS/FLOAT(NY-1)#                    Distance between pts along y     CN10 493
IF(COSG<0.0)#                          Plot is skewed backwards         CN10 494
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 CN10 495
XLOW=-YLS*COSG#                        Lower l.h. x-coord               CN10 496
XUPP=XLS#                              Upper r.h. x-coord               CN10 497
PLOTX=XLOW+XLS#                        X-size of plot                   CN10 498
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 CN10 499
ELSE#                                  Plot is orthognl or forwards     CN10 500
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 CN10 501
XLOW=0.0#                              Lower l.h. x-coord               CN10 502
XUPP=XLS+YLS*COSG#                     Upper r.h. x-coord               CN10 503
PLOTX=XUPP#                            X-size of plot                   CN10 504
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 CN10 505
HEIGHT=0.015*PLOTY#                    Height of characters             CN10 506
PLOTX=PLOTX*1.05#                      Actual plot dimensions           CN10 507
PLOTY=PLOTY*1.05#                      Actual plot dimensions           CN10 508
CALL CN03(0.0,0.0,1)#                  Start the plot                   CN10 509
CALL CN03(0.0,0.0,6)#                  Auto centre and scale            CN10 510
IF(MULCOL==yes:)#                      Save color map                   CN10 511
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 CN10 512
DO I=1,NCON#                           Color map                        CN10 513
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 CN10 514
COLOR=COL(I)#                          Hex encoded 24 bit color         CN10 515
IPEN=7+I#                              Save color map index             CN10 516
CALL CN03(0.0,0.0,7)#                  Save colormap entry              CN10 517
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 CN10 518
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 CN10 519
#                                                                       CN10 520
#    OUTPUT CONTROL INFORMATION                                         CN10 521
#    --------------------------                                         CN10 522
#                                                                       CN10 523
writeline:(1,CNH1,NCNH1,3,3)#          Write header                     CN10 524
writeline:(0,CNH2,NCNH2,3,3)#          Underline                        CN10 525
IF(IVEC>1) movechar:(CNH6,1,CNH5,1,7,0)# Vector function plot           CN10 526
writeline:(1,CNH5,NCNH5,3,3)#          Scalar function plot             CN10 527
ncodefld:(FLOAT(FLAYER),1,CN10C,360313.,1)# Stuff flayer                CN10 528
writeline:(0,CN10C,NCN10C,3,3)#        First layer                      CN10 529
ncodefld:(FLOAT(LLAYER),1,CN10D,360313.,1)# Stuff llayer                CN10 530
writeline:(0,CN10D,NCN10D,3,3)#        Last layer                       CN10 531
ncodefld:(FLOAT(DLAYER),1,CN10E,360313.,1)# Stuff dlayer                CN10 532
writeline:(0,CN10E,NCN10E,3,3)#        Layer increment                  CN10 533
IF(SUPER==yes:) movechar:(CNY,1,CN10F,34,3,0)# Superimpose              CN10 534
ELSE movechar:(CNN,1,CN10F,34,3,0)#    No superimpose                   CN10 535
writeline:(0,CN10F,NCN10F,3,3)#        Superposition of levels          CN10 536
IF(IVEC==1)#                           Output for scalar function       CN10 537
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 CN10 538
IF(LINEAR==yes:) movechar:(CNL,1,CN10G,31,6,0)# Linear interp           CN10 539
ELSE IF(CUBIC==yes:) movechar:(CNC,1,CN10G,31,6,0)# Cubic interp        CN10 540
writeline:(0,CN10G,NCN10G,3,3)#        Interpolation type               CN10 541
IF(SMOOTH==yes:) movechar:(CNY,1,CN10H,34,3,0)# Smoothing               CN10 542
ELSE movechar:(CNN,1,CN10H,34,3,0)#    No smoothing                     CN10 543
writeline:(0,CN10H,NCN10H,3,3)#        Smoothing                        CN10 544
IF(SMOOTH==yes:)#                      Output resolution                CN10 545
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 CN10 546
ncodefld:(RESOL,1,CN10I,360422.,1)#    Stuff resol                      CN10 547
writeline:(0,CN10I,NCN10I,3,3)#        Resolution for smoothing         CN10 548
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 CN10 549
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 CN10 550
ELSE IF(IVEC>1)#                       Output for vector function       CN10 551
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 CN10 552
ncodefld:(SCARR,1,CN10W,360422.,1)#    Stuff scale factor               CN10 553
writeline:(0,CN10W,NCN10W,3,3)#        Scale factor for arrows          CN10 554
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 CN10 555
IF(MESH==yes:) movechar:(CNY,1,CN10J,34,3,0)# Plot mesh pts             CN10 556
ELSE movechar:(CNN,1,CN10J,34,3,0)#    No plot mesh pts                 CN10 557
writeline:(0,CN10J,NCN10J,3,3)#        Plotting of mesh pts             CN10 558
IF(BORDER==yes:) movechar:(CNY,1,CN10K,34,3,0)# Plot border             CN10 559
ELSE movechar:(CNN,1,CN10K,34,3,0)#    No plot border                   CN10 560
writeline:(0,CN10K,NCN10K,3,3)#        Plotting of border               CN10 561
IF(ATOMS==yes:) movechar:(CNY,1,CN10L,34,3,0)# Plot atoms               CN10 562
ELSE movechar:(CNN,1,CN10L,34,3,0)#    No plot atoms                    CN10 563
writeline:(0,CN10L,NCN10L,3,3)#        Plotting of atoms                CN10 564
IF(ATOMS==yes:)#                       Output maximum distance          CN10 565
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 CN10 566
ncodefld:(VICIN,1,CN10T,360522.,1)#    Stuff vicin                      CN10 567
writeline:(0,CN10T,NCN10T,3,3)#        Maximum distance                 CN10 568
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 CN10 569
IF(ROTATE==yes:) movechar:(CNY,1,CN10M,34,3,0)# Rotation                CN10 570
ELSE movechar:(CNN,1,CN10M,34,3,0)#    No rotation                      CN10 571
writeline:(0,CN10M,NCN10M,3,3)#        Rotation of the map              CN10 572
#                                                                       CN10 573
#    OUTPUT CONTOUR LEVELS INPUT                                        CN10 574
#    ---------------------------                                        CN10 575
#                                                                       CN10 576
IF(IVEC==1)#                           Output for scalar function       CN10 577
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 CN10 578
writeline:(1,CNH3,NCNH3,3,3)#          Write header for input           CN10 579
writeline:(0,CNH2,NCNH2,3,3)#          Underline                        CN10 580
IF(ARITH==yes:) movechar:(CNA,1,CN10N,27,10,0)# Arithmetic              CN10 581
ELSE IF(GEOM==yes:) movechar:(CNG,1,CN10N,27,10,0)# Geometric           CN10 582
ELSE IF(DIRECT==yes:) movechar:(CND,1,CN10N,27,10,0)# Direct            CN10 583
writeline:(0,CN10N,NCN10N,3,3)#        Levels specification             CN10 584
IF(DIRECT==no:)#                                                        CN10 585
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 CN10 586
ncodefld:(CBEG,1,CN10O,360732.,1)#     Stuff cbeg                       CN10 587
writeline:(0,CN10O,NCN10O,3,3)#        Starting level                   CN10 588
ncodefld:(CINT,1,CN10P,360732.,1)#     Stuff cint                       CN10 589
writeline:(0,CN10P,NCN10P,3,3)#        Incr/ratio                       CN10 590
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 CN10 591
ncodefld:(FLOAT(NCON),1,CN10Q,360313.,1)# Stuff ncon                    CN10 592
writeline:(0,CN10Q,NCN10Q,3,3)#        No. of levels                    CN10 593
ncodefld:(DASH,1,CN10R,IFMT,NDASH)#    Stuff dash sequence              CN10 594
writeline:(0,CN10R,NCN10R,3,3)#        Dash sequence                    CN10 595
ncodefld:(DOT,1,CN10S,IFMT,NDOT)#      Stuff dot sequence               CN10 596
writeline:(0,CN10S,NCN10S,3,3)#        Dot sequence                     CN10 597
#                                                                       CN10 598
#    WRITE HEADER FOR OUTPUT                                            CN10 599
#    ------------------------                                           CN10 600
#                                                                       CN10 601
writeline:(1,CNH4,NCNH4,3,3)#          Write header for output          CN10 602
writeline:(0,CNH2,NCNH2,3,3)#          Underline                        CN10 603
writeline:(0,CN10U,NCN10U,3,3)#        First line of column             CN10 604
writeline:(0,CN10V,NCN10V,3,3)#        Second line                      CN10 605
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 CN10 606
#                                                                       CN10 607
# NOTICE HERE THAT YLOW AND YUPP ARE SET IN THE DATA                    CN10 608
# STATEMENTS, AS IS PLOTY, THE PLOT SIZE ALONG Y.                       CN10 609
# THE PLOT DIMENSIONS AND ALL NECESSARY VARIABLES                       CN10 610
# HAVE BEEN SET HERE.  RETURN TO CALLER                                 CN10 611
#                                                                       CN10 612
incrqx:(MARK2,MARK1+NX*NY*IVEC,CN2001)# Request space to store layer    CN10 613
IF(IVEC==1&FILLED==yes:)#              If filling - need to sort area   CN10 614
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 57 CN10 615
opendac:(ioda1:,3,arith:(2,*,mxchwd:),' ')# Create direct access file   CN10 616
DREC=0#                                Flag as opened                   CN10 617
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 57 CN10 618
#                                                                       CN10 619
RETURN#                                                                 CN10 620
END#                                                                    CN10 621
systemheader:(CN11)#                                                    CN11   1
#####################################################################   CN11   2
#                                                                   #   CN11   3
#                           CN11                                    #   CN11   4
#                                                                   #   CN11   5
#####################################################################   CN11   6
SUBROUTINE CN11#                       Loads prelim bdf records         CN11   7
include:(AACOMN)#                                                       CN11   8
include:(CNCOMN)#                                                       CN11   9
#                                                                       CN11  10
INTEGER IP,I,J,JJ,K,L,NTEMP,PSIZ#                                       CN11  11
INTEGER IWNT(10),KEYA(10),IREL(11)#                                     CN11  12
INTEGER LTYP,ICNT,NSYM,ORG(3),NINC(3),NZ#                               CN11  13
INTEGER NDIV(3),IPAGE,IDOWN,IACRO,MARKT,IX,IY,IZ#                       CN11  14
REAL    CELLC(6),SIIGN,G(9)#                                            CN11  15
REAL    ZL,XORG(3),DISTX,DISTY#                                         CN11  16
REAL    XF(3),XFP(3),XMOV,YMOV,ZMOV,X,Y,Z,MIN#                          CN11  17
REAL    TRANS(9)#                                                       CN11  18
string:(SFTAB,128)# ## scattering factor table
#                                                                       CN11  19
string:(NAME,24)#                                                       CN11  20
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              CN11  21
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              CN11  22
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              CN11  23
realdata:(TR21,[.3333333,.5])#                                          CN11  24
realdata:(TR22,[.6666667,0.])#                                          CN11  25
realdata:(TR23,[.6666667,.5])#                                          CN11  26
realdata:(ZLO,0.0);   realdata:(ZHI,0.0)#                               CN11  27
datastuff:#                                                             CN11  28
#                                                                       CN11  29
DO J=1,9; TRANS(J)=0.0#                Zero transformation matrix       CN11  30
IOMARK(1)=QXSTR#                       Set up filea input  buffer       CN11  31
IOMARK(INPUT)=IOMARK(1)+bdfbuf:#       Start of scratch input buffe     CN11  32
IOMARK(5)=IOMARK(INPUT)+bdfbuf:#       Start of output bdf buffer       CN11  33
incrqx:(MARK0,IOMARK(5)+bdfbuf:,CN1109)# Contour level stats            CN11  34
incrqx:(MARKS,MARK0+100*4,CN1109)#     Start of symm informat           CN11  35
#                                                                       CN11  36
#    READ CELL INFO OFF FILEA                                           CN11  37
#    -----------------------                                            CN11  38
#                                                                       CN11  39
FOR(K=1;K>0;K=K+1)#                    Loop over lrcell packets         CN11  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN11  41
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Read in cell record              CN11  42
IF(IP<=0) BREAK#                       Exit on last record              CN11  43
IF(K==1) movereal:(QX,IP+1,CELLC,1,6,0)# Save real cell constants       CN11  44
IF(K==7) movereal:(QX,IP+1,G,1,9,0)#   Save metric tensor               CN11  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN11  46
#                                                                       CN11  47
#    EXTRACT SYMMETRY INFORMATION                                       CN11  48
#    ----------------------------                                       CN11  49
#                                                                       CN11  50
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Read first packet of record      CN11  51
LTYP=NINT(QX(IP+1))#                   Get lattice type                 CN11  52
ICNT=NINT(QX(IP+2))#                   Get centro flag                  CN11  53
NSYM=NINT(QX(IP+3))#                   Get total symop count            CN11  54
LTYP=LTYP-(1-ICNT)*7#                  Reduce ltyp to modulo 7          CN11  55
incrqx:(MARKA,MARKS+NSYM*12,CN1112)#   Incrqx........131112             CN11  56
FOR(J=MARKS;J>0;J=J+12)#               Loop over symop packets          CN11  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN11  58
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Point to next packet             CN11  59
IF(IP<=0) BREAK#                       Exit after last packet           CN11  60
movereal:(QX,IP+1,QX,J+1,PSIZ,1)#      Store 12 element symop           CN11  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN11  62
NTEMP=J#                               Mark end of symops               CN11  63
K=NTEMP#                               Set symm matrix pointer          CN11  64
IF(ICNT==0)#                           Test if centrosymmetric          CN11  65
FOR(J=MARKS; J<NTEMP; J=J+1)#          Loop over symm matrices          CN11  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN11  67
K=K+1#                                 Incr matrix pointer              CN11  68
QX(K)=-QX(J+1)#                        Store inverse element            CN11  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN11  70
NTEMP=K#                               Store temp end marker            CN11  71
IF(LTYP>1)#                            Test if sg centred               CN11  72
FOR(J=MARKS; J<NTEMP; J=J+12)#         Loop over symm matrices          CN11  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CN11  74
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            CN11  75
QX(K+10)=QX(J+10)+TR11(LTYP-1)#        Transfer t1                      CN11  76
QX(K+11)=QX(J+11)+TR12(LTYP-1)#        Transfer t2                      CN11  77
QX(K+12)=QX(J+12)+TR13(LTYP-1)#        Transfer t3                      CN11  78
K=K+12#                                Incr storage pointer             CN11  79
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               CN11  80
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            CN11  81
QX(K+10)=QX(J+10)+TR21(LTYP-2)#        Transfer t1                      CN11  82
QX(K+11)=QX(J+11)+TR22(LTYP-2)#        Transfer t2                      CN11  83
QX(K+12)=QX(J+12)+TR23(LTYP-2)#        Transfer t3                      CN11  84
K=K+12#                                Incr storage pointer             CN11  85
IF(LTYP!=4) NEXT#                      Skip if not f-centre             CN11  86
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            CN11  87
QX(K+10)=QX(J+10)+0.5#                 Transfer t1                      CN11  88
QX(K+11)=QX(J+11)+0.5#                 Transfer t2                      CN11  89
QX(K+12)=QX(J+12)+0.0#                 Transfer t3                      CN11  90
K=K+12#                                Incr storage pointer             CN11  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CN11  92
#                                                                       CN11  93
#    READ ATOMIC RADII 
#    -----------------
#                                                                       CN11  96
IWNT(1)=5; IWNT(2)=11#                 Bond radius and atom name        PG10 453
KEYA(1)=2; KEYA(2)=0; KEYA(3)=0; KEYA(4)=0# Set search keys           
indexpkt:(1,lrscat:,LPAK,IP,0,KEYA,IWNT,IREL)# Test for wanted items  
A=0.;       SFTAB=' '#                 Zero max radius                  PG10 457
DO I=1,16#                             Loop for atom types              PG10 458
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 PG10 459
readwpkt:(1,lrscat:,LPAK,IP,0)#        Read atom type param.            PG10 461
IF(IP<=0) BREAK#                       Test for end of types            PG10 462
IF(KEYA(4)<=0) NEXT#                   Item not found-exit              PG10 456
movertoc:(QX(IP+IREL(2)),1,NAME,1,2,0)# Extract atom type label         PG10 463
movechar:(NAME,1,SFTAB,I*8-7,2,0)#     Store scat factor table          PG10 464
RADII(I)=QX(IP+IREL(1))+0.1#           Store bond radius and incr.      PG10 467
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 PG10 474
#                                                                       CN11  93
#    READ LAYOUT INFO OFF BDF                                           CN11  94
#    ------------------------                                           CN11  95
#                                                                       CN11  96
readwpkt:(INPUT,21,PSIZ,IP,0)#         Read in layout info              CN11  97
IF(IP<=0) iquit:(CN1110)#              Non-existent record              CN11  98
IPAGE=NINT(QX(IP+16))#                 Page index                       CN11  99
IDOWN=NINT(QX(IP+17))#                 Down index                       CN11 100
IACRO=NINT(QX(IP+18))#                 Across index                     CN11 101
SIIGN=1.0#                             Sign for r.h. system             CN11 102
IF(IPAGE!=MOD(IACRO+1,3)) SIIGN=-1.0#  Sign for l.h. system             CN11 103
ORG(IPAGE)=NINT(QX(IP+1))#             Page origin in grid units        CN11 104
ORG(IDOWN)=NINT(QX(IP+2))#             Y-origin in grid units           CN11 105
ORG(IACRO)=NINT(QX(IP+3))#             X-origin in grid units           CN11 106
ORGZ=ORG(IPAGE)#                       Origin of layer axis             CN11 107
NINC(IPAGE)=NINT(QX(IP+4))#            Z-increment in grid units        CN11 108
NINC(IDOWN)=NINT(QX(IP+5))#            Y-increment in grid units        CN11 109
NINC(IACRO)=NINT(QX(IP+6))#            X-increment in grid units        CN11 110
NDIV(IPAGE)=NINT(QX(IP+7))#            Divisions along full page ax     CN11 111
NDIV(IDOWN)=NINT(QX(IP+8))#            Divisions along full y-axis      CN11 112
NDIV(IACRO)=NINT(QX(IP+9))#            Divisions along full x-axis      CN11 113
NZ=NINT(QX(IP+10))#                    Points in page direction         CN11 114
NY=NINT(QX(IP+11))#                    Points in y-direction            CN11 115
NX=NINT(QX(IP+12))#                    Points in x-direction            CN11 116
IF(FLAYER==10000\FLAYER<ORG(IPAGE)) FLAYER=ORG(IPAGE)# 1st layer=orig   CN11 117
NTEMP=NZ+FLAYER-1#                     Last layer from bdf              CN11 118
IF(LLAYER==10000\LLAYER>NTEMP) LLAYER=NTEMP# Last layer                 CN11 119
ILAYER=NINC(IPAGE)#                    Increment from bdf               CN11 120
IF(DLAYER==10000\DLAYER<ILAYER) DLAYER=ILAYER# Increment between laye   CN11 121
PLAYER=ORGZ#                           Layer position of input bdf      CN11 122
PYSIZ=NY#                              No of rows on the bdf            CN11 123
PXSIZ=NX#                              No of elements per row           CN11 124
IF(INPUT==3)#                          Input data from fourr            CN11 125
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CN11 126
ZL=SIIGN*FLOAT(NINC(IPAGE)*(NZ-1))*CELLC(IPAGE)/FLOAT(NDIV(IPAGE))# Z   CN11 127
YL=FLOAT(NINC(IDOWN)*(NY-1))*CELLC(IDOWN)/FLOAT(NDIV(IDOWN))# Y-lengt   CN11 128
XL=FLOAT(NINC(IACRO)*(NX-1))*CELLC(IACRO)/FLOAT(NDIV(IACRO))# X-lengt   CN11 129
COSG=-CELLC(9-IDOWN-IACRO)#            Cos of interaxial angle          CN11 130
SING=SQRT(1.-COSG*COSG)#               Sin of interaxial angle          CN11 131
XORG(IPAGE)=FLOAT(ORG(IPAGE))/FLOAT(NDIV(IPAGE))# Layer origin          CN11 132
XORG(IDOWN)=FLOAT(ORG(IDOWN))/FLOAT(NDIV(IDOWN))# Down page origin      CN11 133
XORG(IACRO)=FLOAT(ORG(IACRO))/FLOAT(NDIV(IACRO))# Across page origin    CN11 134
TRANS(6+IPAGE)=CELLC(IPAGE)*SIIGN#     Last row of transf. matrix       CN11 135
TRANS(3+IDOWN)=CELLC(IDOWN)#           Centre row of matrix             CN11 136
TRANS(IACRO)=CELLC(IACRO)#             First row of matrix              CN11 137
ZDEL=SIIGN*CELLC(IPAGE)/FLOAT(NDIV(IPAGE))# Distance between layers     CN11 138
ORIENT(1)=0.0;ORIENT(2)=0.0;ORIENT(3)=1.0# Map z orient for printi      CN11 139
ORIENT(4)=0.0;ORIENT(5)=1.0;ORIENT(6)=0.0# Map y orient for printi      CN11 140
ORIENT(7)=1.0;ORIENT(8)=0.0;ORIENT(9)=0.0# Map x orient for printi      CN11 141
ifeq:(VICIN,0.0) VICIN=ABS(ZDEL)/2.#   Default vicinity for atoms       CN11 142
ZLO=AMIN1(0.0,ZL)-VICIN#               Lower z-limit                    CN11 143
ZHI=AMAX1(0.0,ZL)+VICIN#               Upper z-limit                    CN11 144
DISTZ=0.#                              Not used in fourr                CN11 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CN11 146
ELSE IF(INPUT==4)#                     Input data from slant            CN11 147
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CN11 148
ZL=FLOAT(NINC(IPAGE)*(NZ-1))*QX(IP+25)# Z-length in angstroms           CN11 149
YL=FLOAT(NINC(IDOWN)*(NY-1))*QX(IP+26)# Y-length in angstroms           CN11 150
XL=FLOAT(NINC(IACRO)*(NX-1))*QX(IP+27)# X-length in angstroms           CN11 151
COSG=0.0; SING=1.0#                    Cos, sin of interaxial angle     CN11 152
DISTZ=FLOAT(ORG(IPAGE))*QX(IP+25)#     Z distance for origin shift      CN11 153
DISTY=FLOAT(ORG(IDOWN))*QX(IP+26)#     Y distance for origin shift      CN11 154
DISTX=FLOAT(ORG(IACRO))*QX(IP+27)#     X distance for origin shift      CN11 155
XORG(3)=DISTX*QX(IP+39)+DISTY*QX(IP+36)+QX(IP+30)# Z-coord of origin    CN11 156
XORG(2)=DISTX*QX(IP+38)+DISTY*QX(IP+35)+QX(IP+29)# Y-coord of origin    CN11 157
XORG(1)=DISTX*QX(IP+37)+DISTY*QX(IP+34)+QX(IP+28)# X-coord of origin    CN11 158
movereal:(QX,IP+31,ORIENT,1,9,0)#      Map orientation for printing     CN11 159
DO J=1,3#                              Form transf. matrix              CN11 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CN11 161
TRANS(J)=QX(IP+37)*G(J)+QX(IP+38)*G(J+3)+QX(IP+39)*G(J+6)# Row 1        CN11 162
TRANS(J+3)=QX(IP+34)*G(J)+QX(IP+35)*G(J+3)+QX(IP+36)*G(J+6)# Row 2      CN11 163
TRANS(J+6)=QX(IP+31)*G(J)+QX(IP+32)*G(J+3)+QX(IP+33)*G(J+6)# Row 3      CN11 164
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CN11 165
ZDEL=QX(IP+25)#                        Distance between layers          CN11 166
IF(VICIN==0.0) VICIN=ZDEL/2.#          Default vicinity for atoms       CN11 167
ZLO=DISTZ-VICIN; ZHI=DISTZ+ZL+VICIN#   Limits for major atom list       CN11 168
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CN11 169
PTYPE=QX(IP+40)#                       Property type                    CN11 170
IPROP=QX(IP+41)#                       Number of components             CN11 171
IF(IPROP<IVEC) iquit:(CN1111)#         Mismatch in components           CN11 172
DO J=4,6 ; ORIENT(J)=-ORIENT(J)#       Opposite of y vector is requir   CN11 173
DO J=0,8,3#                            Cycle over layer and  y and x    CN11 174
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CN11 175
MIN=9.9E+15#                           Initialise minimum value         CN11 176
DO JJ=1,3#                             Find min magntd non0 component   CN11 177
IF (ABS(ORIENT(J+JJ))>0.00001 & ABS(ORIENT(J+JJ))<MIN)# If less than    CN11 178
MIN=ABS(ORIENT(J+JJ))#                 Reset minimum                    CN11 179
DO JJ=1,3 ; ORIENT(J+JJ)=ORIENT(J+JJ)/MIN# Scale vector components      CN11 180
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CN11 181
#                                                                       CN11 182
#    GET ATOM LIST FROM FILEA                                           CN11 183
#    ------------------------                                           CN11 184
#                                                                       CN11 185
MARK1=MARKA#                           Pointer to grid points           CN11 186
IF(ATOMS==yes:)#                       Only if requested                CN11 187
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CN11 188
##STEPA=10#                            Step size for atom list          CN11 189
STEPA=12#                              Step size for atom list          CN11 190
IWNT(1)=1; IWNT(2)=2; IWNT(3)=3; IWNT(4)=14# Set iwnt idnums            CN11 191
KEYA(1)=0; KEYA(2)=4; KEYA(3)=0; KEYA(4)=0# Set keya                    CN11 192
indexpkt:(1,lratom:,PSIZ,IP,0,KEYA,IWNT,IREL)# Search for idnums        CN11 193
IF(KEYA(4)>0)#                         Is anything there?               CN11 194
REPEAT#                                Loop over atom packets           CN11 195
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CN11 196
readwpkt:(1,lratom:,PSIZ,IP,0)#        Point to next atom packet        CN11 197
IF(IP<=0) BREAK#                       Exit after last packet           CN11 198
DO J=1,3; XF(J)=QX(IP+IREL(J))#        Get fractional coords            CN11 199
MARKT=MARK1#                           Set bottom of atom-type          CN11 200
FOR(I=MARKS; I<MARKA; I=I+12)#         Loop over symm matrices          CN11 201
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CN11 202
DO J=1,3#                              Loop over x,y,z                  CN11 203
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CN11 204
K=I+J-1#                               Point to matrix elements         CN11 205
XFP(J)=XF(1)*QX(K+1)+XF(2)*QX(K+4)+XF(3)*QX(K+7)+QX(K+10)# Transform    CN11 206
XFP(J)=AMOD(XFP(J)+10.,1.)#            Reduce to central cell           CN11 207
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CN11 208
FOR(IX=-2; IX<3; IX=IX+1)#             Loop over x moves                CN11 209
FOR(IY=-2; IY<3; IY=IY+1)#             Loop over y moves                CN11 210
FOR(IZ=-2; IZ<3; IZ=IZ+1)#             Loop over z moves                CN11 211
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CN11 212
XMOV=XFP(1)+FLOAT(IX)-XORG(1)#         Moved x-coord                    CN11 213
YMOV=XFP(2)+FLOAT(IY)-XORG(2)#         Moved y-coord                    CN11 214
ZMOV=XFP(3)+FLOAT(IZ)-XORG(3)#         Moved z-coord                    CN11 215
X=TRANS(1)*XMOV+TRANS(2)*YMOV+TRANS(3)*ZMOV# X in map frame             CN11 216
Y=TRANS(4)*XMOV+TRANS(5)*YMOV+TRANS(6)*ZMOV# Y in map frame             CN11 217
Z=TRANS(7)*XMOV+TRANS(8)*YMOV+TRANS(9)*ZMOV# Z in map frame             CN11 218
IF(X<-.001\X>(XL+.001)) NEXT#          X-coord out of range             CN11 219
ELSE IF(Y<-.001\Y>(YL+.001)) NEXT#     Y-coord out of range             CN11 220
ELSE IF(Z<(ZLO-.001)\Z>(ZHI+.001)) NEXT# Z-coord out of range           CN11 221
FOR(J=MARKT; J<MARK1; J=J+STEPA)#      Compare with rest of type        CN11 222
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CN11 223
IF(ABS(X-QX(J+1))>0.1) NEXT#           X-coords differ                  CN11 224
ELSE IF(ABS(Y-QX(J+2))>0.1) NEXT#      Y-coords differ                  CN11 225
ELSE IF(ABS(Z-QX(J+3))>0.1) NEXT#      Z-coords differ                  CN11 226
ELSE BREAK#                            No difference found-same ato     CN11 227
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CN11 228
IF(J!=MARK1) NEXT#                     Match found-dont store           CN11 229
incrqx:(MARK1,MARK1+STEPA,CN1113)#     Incrqx.......131113              CN11 230
QX(J+1)=X#                             Store x-coord                    CN11 231
QX(J+2)=Y#                             Store y-coord                    CN11 232
QX(J+3)=Z#                             Store z-coord                    CN11 233
QX(J+4)=FLOAT((I-MARKS)/12+1)#         Store symop number               CN11 234
movertoc:(QX(IP+IREL(4)),1,NAME,1,24,0)# Store atom name                CN11 235
label:(NAME,K,L,SFTAB,M)#              Store max label length           CN11 236
movector:(NAME,1,QX(J+5),1,24,0)#      Store atom name in atom list     CN11 237
QX(J+11)=0.0#                          Only one sign for z              CN11 238
QX(J+12)=FLOAT(M)#                     store atom type
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CN11 239
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CN11 240
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CN11 241
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CN11 242
RETURN#                                                                 CN11 243
END#                                                                    CN11 244
systemheader:(CN20)#                                                    CN20   1
#####################################################################   CN20   2
#                                                                   #   CN20   3
#                           CN20                                    #   CN20   4
#                                                                   #   CN20   5
#####################################################################   CN20   6
SUBROUTINE CN20#                                                        CN20   7
include:(AACOMN)#                                                       CN20   8
include:(CNCOMN)#                                                       CN20   9
#                                                                       CN20  10
INTEGER I,J,II,IP,IPT,IX,IY,PSIZ#                                       CN20  11
REAL    VLEN,VMAX#                                                      CN20  12
chardata:(CNLA, LAYER   )#                                              CN20  13
chardata:(CNLB, MAXIMUM ARROW LENGTH         EL/ANG**2)#                CN20  14
chardata:(CNLC, MIN/MAX NORMAL TO PLANE COMPONENT                )#     CN20  15
datastuff:#                                                             CN20  16
#                                                                       CN20  17
EMAX = voidflg:#                       Default x and y max component    CN20  18
VMAX = EMAX#                           Default maximum vector length    CN20  19
ZMAX = EMAX#                           Default z maximum component      CN20  20
ZMIN = ABS(voidflg:)#                  Default z minimum component      CN20  21
#                                                                       CN20  22
#    POSITION THE INPUT BDF FOR THIS LAYER                              CN20  23
#    -------------------------------------                              CN20  24
#                                                                       CN20  25
FOR( ; PLAYER<LAYER ; PLAYER=PLAYER+ILAYER)# Loop until layer is foun   CN20  26
DO IY=1,PYSIZ ; readwpkt:(INPUT,22,PSIZ,IP,0)# Read input packets       CN20  27
#                                                                       CN20  28
#    READ WITHOUT ROTATION                                              CN20  29
#    ---------------------                                              CN20  30
#                                                                       CN20  31
IF(ROTATE==no:)#                       Read without rotation            CN20  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN20  33
DO IY=1,PYSIZ#                         Loop over the rows               CN20  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN20  35
readwpkt:(INPUT,22,PSIZ,IP,0)#         Read input packet                CN20  36
IF(IP<=0) iquit:(CN2002)#              Quit if not enough data          CN20  37
IPT=MARK1+(IY-1)*PXSIZ*IVEC#           Pointer to new row               CN20  38
DO IX=1,PXSIZ#                         Loop over row elements           CN20  39
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN20  40
I=(IX-1)*IPROP#                        Set pointer                      CN20  41
II=(IX-1)*IVEC#                        Set pointer                      CN20  42
DO J=1,IVEC#                           Loop over components of e.f.     CN20  43
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CN20  44
IF(IPROP>1&IVEC==1)$#                  Test for strength of e.f.        CN20  45
QX(IPT+II+1)=SQRT(QX(IP+I+1)*QX(IP+I+1)$# Strength of e.f.              CN20  46
+QX(IP+I+2)*QX(IP+I+2)+QX(IP+I+3)*QX(IP+I+3))#                          CN20  47
ELSE QX(IPT+II+J)=QX(IP+I+J)#          Transfer from buffer             CN20  48
IF(IVEC>1)#                            Keep track of max component      CN20  49
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CN20  50
VLEN=SQRT(QX(IPT+II+2)*QX(IPT+II+2)$#  Vector length in the plane       CN20  51
     +QX(IPT+II+3)*QX(IPT+II+3))#                                       CN20  52
IF(VLEN>VMAX) VMAX=VLEN#               Keep track of max arrow length   CN20  53
IF(ABS(QX(IPT+II+J))>EMAX) EMAX=ABS(QX(IPT+II+J))# Keep track of max    CN20  54
IF(QX(IPT+II+1)>ZMAX) ZMAX=QX(IPT+II+1)# Keep track of z max            CN20  55
IF(QX(IPT+II+1)<ZMIN) ZMIN=QX(IPT+II+1)# Keep track of z min            CN20  56
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CN20  57
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CN20  58
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN20  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN20  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN20  61
#                                                                       CN20  62
#    READ AND ROTATE 90 DEGREES CLOCKWISE                               CN20  63
#    ------------------------------------                               CN20  64
#                                                                       CN20  65
ELSE#                                  Input via 90 deg rotation        CN20  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CN20  67
DO IY=1,PYSIZ#                         Loop over rows                   CN20  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CN20  69
readwpkt:(INPUT,22,PSIZ,IP,0)#         Read input packet                CN20  70
IF(IP<=0) iquit:(CN2002)#              Quit if not enough data          CN20  71
DO IX=1,PXSIZ#                         Loop over row elements           CN20  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CN20  73
IPT=MARK1+(IX*PYSIZ-IY)*IVEC#          Destination pointer              CN20  74
I=(IX-1)*IPROP#                        Set pointer                      CN20  75
DO J=1,IVEC#                           Loop over components of e.f.     CN20  76
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CN20  77
IF(IPROP>1&IVEC==1)$#                  Test for strength of e.f.        CN20  78
QX(IPT+1)=SQRT(QX(IP+I+1)*QX(IP+I+1)$# Strength of e.f.                 CN20  79
+QX(IP+I+2)*QX(IP+I+2)+QX(IP+I+3)*QX(IP+I+3))#                          CN20  80
ELSE QX(IPT+J)=QX(IP+I+J)#             Transfer from buffer             CN20  81
IF(IVEC>1)#                            Keep track of max component      CN20  82
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CN20  83
VLEN=SQRT(QX(IPT+2)*QX(IPT+2)$#        Vector length in the plane       CN20  84
     +QX(IPT+3)*QX(IPT+3))#                                             CN20  85
IF(VLEN>VMAX) VMAX=VLEN#               Keep track of max arrow length   CN20  86
IF(ABS(QX(IPT+J))>EMAX) EMAX=ABS(QX(IPT+J))# Keep track of max          CN20  87
IF(QX(IPT+1)>ZMAX) ZMAX=QX(IPT+1)#     Keep track of z max              CN20  88
IF(QX(IPT+1)<ZMIN) ZMIN=QX(IPT+1)#     Keep track of z min              CN20  89
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CN20  90
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CN20  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CN20  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CN20  93
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CN20  94
#                                                                       CN20  95
COLOR=0#                               Zero colour                      CN20  96
PLAYER=PLAYER+ILAYER#                  Increment the bdf pointer        CN20  97
ncodefld:(FLOAT(LAYER),1,CNLA,90313.,1)# Stuff layer number             CN20  98
writeline:(0,CNLA,NCNLA,3,3)#          Write layer number               CN20  99
IF(IVEC>1)#                            Output for vector function       CN20 100
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CN20 101
ncodefld:(VMAX,1,CNLB,290522.,1)#      Format maximum arrow length      CN20 102
writeline:(1,CNLB,NCNLB,2,3)#          Print maximum arrow length       CN20 103
ncodefld:(ZMIN,1,CNLC,420612.,1)#      Format min z found               CN20 104
ncodefld:(ZMAX,1,CNLC,500612.,1)#      Format max z found               CN20 105
writeline:(0,CNLC,NCNLC,2,3)#          Print z limits                   CN20 106
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CN20 107
#                                                                       CN20 108
# QX ARRAY NOW CONTAINS A LAYER OF GRIDDED DATA, STORED FROM            CN20 109
# QX(MARK1+1) TO QX(MARK2).  THE DATA IS STORED ROW BY ROW,             CN20 110
# WITH NY ROWS OF LENGTH NX ELEMENTS                                    CN20 111
#                                                                       CN20 112
#                                      This is a fudge                  CN20 113
IF(FILLED==yes:)#                      Plot border of the map           CN20 114
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CN20 115
IPEN=3#                                Pen up                           CN20 116
COLOR=0#                               Zero colour index                CN20 117
CALL CN03(XLOW,YLOW,3)#                Change of subject (colour)       CN20 118
COLOR=-7-1#                            Change to zero color             CN20 119
IPEN=2#                                Pen down                         CN20 120
CALL CN03(XLOW,YLOW,3)#                Move to bottom l.h. corner       CN20 121
CALL CN03(XLOW+XLS,YLOW,3)#            Draw to bottom r.h.              CN20 122
CALL CN03(XUPP,YUPP,3)#                Top r.h. corner                  CN20 123
CALL CN03(XUPP-XLS,YUPP,3)#            Top l.h.corner                   CN20 124
CALL CN03(XLOW,YLOW,3)#                Return to bot l.h.               CN20 125
IPEN=3#                                Pen up                           CN20 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CN20 127
IF(IVEC==1&FILLED==yes:)DREC=0#        If filling - reset dac record    CN20 128
DO I=MARK0+1,MARKS; QX(I)=0.#          Reset the layer stats            CN20 129
MARK3=MARK2#                           Initially no curve records       CN20 130
#                                                                       CN20 131
RETURN#                                                                 CN20 132
END#                                                                    CN20 133
systemheader:(CN30)#                                                    CN30   1
#####################################################################   CN30   2
#                                                                   #   CN30   3
#                           CN30                                    #   CN30   4
#                                                                   #   CN30   5
#####################################################################   CN30   6
SUBROUTINE CN30#                                                        CN30   7
include:(AACOMN)#                                                       CN30   8
include:(CNCOMN)#                                                       CN30   9
#                                                                       CN30  10
INTEGER I,J,IPTX,IQIQ#                                                  CN30  11
REAL    CON,P0,P1,P2,P3,X,X0,X1,Y,Y0,Y1#                                CN30  12
#                                                                       CN30  13
# THE GRID OF DATA POINTS IS SCANNED ACROSS AND DOWN, AND THE           CN30  14
# COORDINATES OF INTERSECTIONS OF THE CURRENT CONTOUR LEVEL ARE         CN30  15
# DETERMINED EITHER BY INVERSE LINEAR OR CUBIC INTERPOLATION.           CN30  16
# FOR THE LINEAR CASE P1 AND P2 ARE THE DIFFERENCES BETWEEN MAP         CN30  17
# VALUES AND CONT(ICON) FOR SUCCESSIVE POINTS, WHERE P1 IS              CN30  18
# EITHER TO THE LEFT OF P2, OR ABOVE P2.  FOR THE CUBIC CASE            CN30  19
# FOUR POINTS ARE REQUIRED, IN ORDER OF P0, P1, P2 AND P3,              CN30  20
# EITHER ACROSS OR DOWN.  A CUBIC EQUATION IS THEN FITTED TO THESE      CN30  21
# FOUR POINTS AND THE ROOT AT ZERO (I.E. WHERE THE CONTOUR CROSSES      CN30  22
# THE MESH LINE) IS DETERMINED VIA CN31 AND CN12.  IN MOST CASES        CN30  23
# THE ROOT WILL BE BETWEEN P1 AND P2, EXCEPT WHEN NEAR AN EDGE, IN      CN30  24
# WHICH CASE IT IS EITHER BETWEEN P0 AND P1 (TOP OR LEFT EDGE) OR       CN30  25
# BETWEEN P2 AND P3 (BOTTOM OR RIGHT EDGE).                             CN30  26
#                                                                       CN30  27
# THE COORDINATES ARE DEFINED RELATIVE TO THE GRID COORDINATES,         CN30  28
# AND FOR THE PURPOSES OF CHAINING EACH POINT IS DEFINED BY             CN30  29
# FOUR COORDINATES,                                                     CN30  30
#                                                                       CN30  31
#       X(POINT) = I * DX + ALPHA                                       CN30  32
#       Y(POINT) = J * DY + BETA                                        CN30  33
#                                                                       CN30  34
# WHERE DX AND DY ARE THE DISTANCES BETWEEN GRID POINTS IN THE          CN30  35
# X (ACROSS) AND Y (DOWN) DIRECTIONS RESPECTIVELY.  THUS I IS           CN30  36
# AN INTEGER BETWEEN 0 & (NX-1) AND J AN INTEGER BETWEEN 0 & (NY-1).    CN30  37
# ALFA AND BETA ARE REAL AND LIE IN THE RANGE 0.0 TO DX AND             CN30  38
# 0.0 TO DY.  THESE COORDS. CAN BE BETTER UNDERSTOOD FROM THE           CN30  39
# DIAGRAM BELOW                                                         CN30  40
#                                                                       CN30  41
#                                                                       CN30  42
#               I=0      I=1      I=2      I=3      I=4      ETC.       CN30  43
#                                                                       CN30  44
#        J=0     +........+........+........+........+........+...>     CN30  45
#                .        .        .        .        .        .         CN30  46
#                .        .        .        .        .        .         CN30  47
#                .        .        .        .ALPHA   .        .         CN30  48
#                .        .        .        ------>  .        .         CN30  49
#        J=1     +........+........+........+.....S..+........+...>     CN30  50
#                .        .  !     .        .        .        .         CN30  51
#                .        .  !BETA .        .        .        .         CN30  52
#                .        .  !     .        .        .        .         CN30  53
#                .        T  V     .        .        .        .         CN30  54
#        J=2     +........+........+........+........+........+...>     CN30  55
#                .        .        .        .        .        .         CN30  56
#                .        .        .        .        .        .         CN30  57
#                .        .        .        .        .        .         CN30  58
#                .        .        .        .        .        .         CN30  59
#        ETC     +........+........+........+........+........+...>     CN30  60
#                .        .        .        .        .        .         CN30  61
#                .        .        .        .        .        .         CN30  62
#                .        .        .        .        .        .         CN30  63
#                V        V        V        V        V        V         CN30  64
#                                                                       CN30  65
# WHERE POINTS S AND T ARE REPRESENTED BY THE FOLLOWING                 CN30  66
#                                                                       CN30  67
#       X(S) = 3 * DX + ALPHA                                           CN30  68
#       Y(S) = 1 * DY + 0.0                                             CN30  69
#       X(T) = 1 * DX + 0.0                                             CN30  70
#       Y(T) = 1 * DY + BETA                                            CN30  71
#                                                                       CN30  72
# THE INFORMATION FOR EACH INTERPOLATED POINT IS STORED IN THE          CN30  73
# QX ARRAY AS A SIX WORD PACKET (THE PACKETS BEGIN FROM MARK3+1)        CN30  74
# WITH CONTENTS GIVEN BY:                                               CN30  75
#                                                                       CN30  76
#       QX(LPT+1) = I                                                   CN30  77
#       QX(LPT+2) = J                                                   CN30  78
#       QX(LPT+3) = ALPHA                                               CN30  79
#       QX(LPT+4) = BETA                                                CN30  80
#                                                                       CN30  81
# THE LAST TWO WORDS OF THE PACKET ARE NOT FILLED UNTIL AFTER           CN30  82
# CHAINING IS COMPLETE, WHEN THEY WILL CONTAIN THE CARTESIAN            CN30  83
# COORDS OF THE INTERPOLATED POINT, IN ORDER X THEN Y.                  CN30  84
#                                                                       CN30  85
NOPTS=0#                               Zero points counter              CN30  86
MARK4=MARK3#                           Initialize mark3 pointer         CN30  87
CON=CONT(ICON)#                        Set current contour level        CN30  88
#                                                                       CN30  89
#    LINEAR INTERPOLATION                                               CN30  90
#    --------------------                                               CN30  91
#                                                                       CN30  92
IF(LINEAR==yes:)#                      Use linear interpolation         CN30  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN30  94
#                                                                       CN30  95
#    SEARCH ACROSS THE ROWS                                             CN30  96
#    ----------------------                                             CN30  97
#                                                                       CN30  98
FOR(J=1 ; J<=NY ; J=J+1)#              Loop over rows                   CN30  99
FOR(I=1 ; I<NX ; I=I+1)#               Loop over row elements           CN30 100
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN30 101
IPTX=MARK1+(J-1)*NX+I#                 Pointer to first point           CN30 102
subtqx:(IPTX,CON,P1)#                  Get left most point, p1          CN30 103
subtqx:(IPTX+1,CON,P2)#                Get right most point, p2         CN30 104
IF(P1*P2>=0.0) NEXT#                   Was intersection found ?         CN30 105
NOPTS=NOPTS+1#                         Increment points counter         CN30 106
incrqx:(MARK4,MARK4+6,CN3001)#         Request 6 more words             CN30 107
QX(MARK4-5)=FLOAT(I-1)#                I-coord for this pt              CN30 108
QX(MARK4-4)=FLOAT(J-1)#                J-coord for this pt              CN30 109
QX(MARK4-3)=P1*DX/(P1-P2)#             Alpha for this pt                CN30 110
QX(MARK4-2)=0.0#                       Beta for this point              CN30 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN30 112
#                                                                       CN30 113
#    SEARCH DOWN THE COLUMNS                                            CN30 114
#    -----------------------                                            CN30 115
#                                                                       CN30 116
FOR(I=1 ; I<=NX ; I=I+1)#              Loop over columns                CN30 117
FOR(J=1 ; J<NY ; J=J+1)#               Loop over column elements        CN30 118
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN30 119
IPTX=MARK1+(J-1)*NX+I#                 Pointer to first point           CN30 120
subtqx:(IPTX,CON,P1)#                  Get upper point                  CN30 121
subtqx:(IPTX+NX,CON,P2)#               Get lower point                  CN30 122
IF(P1*P2>=0.0) NEXT#                   Was intersection found ?         CN30 123
NOPTS=NOPTS+1#                         Increment points counter         CN30 124
incrqx:(MARK4,MARK4+6,CN3001)#         Request 6 more words             CN30 125
QX(MARK4-5)=FLOAT(I-1)#                I-coord for this pt              CN30 126
QX(MARK4-4)=FLOAT(J-1)#                J-coord for this pt              CN30 127
QX(MARK4-3)=0.0#                       Alpha for this pt                CN30 128
QX(MARK4-2)=P1*DY/(P1-P2)#             Beta for this pt                 CN30 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN30 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN30 131
#                                                                       CN30 132
#    CUBIC INTERPOLATION                                                CN30 133
#    -------------------                                                CN30 134
#                                                                       CN30 135
ELSE IF(CUBIC==yes:)#                  Use cubic interpolation          CN30 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CN30 137
#                                                                       CN30 138
#    SEARCH ACROSS THE ROWS                                             CN30 139
#    ----------------------                                             CN30 140
#                                                                       CN30 141
FOR(J=1 ; J<=NY ; J=J+1)#              Loop over rows                   CN30 142
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CN30 143
FOR(I=1 ; I<NX-1 ; I=I+1)#             Loop over row elements           CN30 144
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CN30 145
X=DX*FLOAT(I-1)#                       First x-value                    CN30 146
IPTX=MARK1+(J-1)*NX+I#                 Pointer to first point           CN30 147
subtqx:(IPTX,CON,P1)#                  Get p1                           CN30 148
subtqx:(IPTX+1,CON,P2)#                Get p2                           CN30 149
subtqx:(IPTX+2,CON,P3)#                Get p3                           CN30 150
IF(P1*P2>=0.0) NEXT#                   Was intersection found ?         CN30 151
IF(I==1)#                              Special case for 1st point       CN30 152
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CN30 153
P0=P1 ; P1=P2 ; P2=P3#                 Roll back the points             CN30 154
subtqx:(IPTX+3,CON,P3)#                Get new p3                       CN30 155
X0=X+DX*P0/(P0-P1)#                    Initial linear guess             CN30 156
X=X+DX#                                Increment reference x            CN30 157
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CN30 158
ELSE IF(I>1)#                          Normal case                      CN30 159
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CN30 160
subtqx:(IPTX-1,CON,P0)#                Get p0                           CN30 161
X0=X+DX*P1/(P1-P2)#                    Initial linear guess             CN30 162
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CN30 163
CALL CN31(0,X,X0,P0,P1,P2,P3,X1)#      Solve for root, x1               CN30 164
NOPTS=NOPTS+1#                         Increment points counter         CN30 165
incrqx:(MARK4,MARK4+6,CN3001)#         Request 6 more words             CN30 166
IQIQ=INT(X1/DX)#                       I-coord for this pt              CN30 167
QX(MARK4-5)=FLOAT(IQIQ)#               I-coord for this pt              CN30 168
QX(MARK4-4)=FLOAT(J-1)#                J-coord for this pt              CN30 169
QX(MARK4-3)=AMOD(X1,DX)#               Alpha for this pt                CN30 170
QX(MARK4-2)=0.0#                       Beta for this pt                 CN30 171
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CN30 172
IF(P2*P3>=0.0) NEXT#                   Intersection on last inter       CN30 173
X0=X+DX+DX*P2/(P2-P3)#                 Initial linear guess             CN30 174
IPTX=MARK1+J*NX-3#                     Pointer to get p0                CN30 175
subtqx:(IPTX,CON,P0)#                  Get p0                           CN30 176
CALL CN31(0,X,X0,P0,P1,P2,P3,X1)#      Solve for root, x1               CN30 177
NOPTS=NOPTS+1#                         Increment points counter         CN30 178
incrqx:(MARK4,MARK4+6,CN3001)#         Request 6 more words             CN30 179
IQIQ=INT(X1/DX)#                       I-coord for this pt              CN30 180
QX(MARK4-5)=FLOAT(IQIQ)#               I-coord for this pt              CN30 181
QX(MARK4-4)=FLOAT(J-1)#                J-coord for this pt              CN30 182
QX(MARK4-3)=AMOD(X1,DX)#               Alpha for this pt                CN30 183
QX(MARK4-2)=0.0#                       Beta for this pt                 CN30 184
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CN30 185
#                                                                       CN30 186
#    SEARCH DOWN THE COLUMNS                                            CN30 187
#    ----------------------                                             CN30 188
#                                                                       CN30 189
FOR(I=1 ; I<=NX ; I=I+1)#              Loop over columns                CN30 190
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CN30 191
FOR(J=1 ; J<NY-1 ; J=J+1)#             Loop over column elements        CN30 192
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CN30 193
Y=DY*FLOAT(J-1)#                       First y-value                    CN30 194
IPTX=MARK1+(J-1)*NX+I#                 Pointer to first point           CN30 195
subtqx:(IPTX,CON,P1)#                  Get p1                           CN30 196
subtqx:(IPTX+NX,CON,P2)#               Get p2                           CN30 197
subtqx:(IPTX+2*NX,CON,P3)#             Get p3                           CN30 198
IF(P1*P2>=0.0) NEXT#                   Was intersection found ?         CN30 199
IF(J==1)#                              Special case for 1st point       CN30 200
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CN30 201
P0=P1 ; P1=P2 ; P2=P3#                 Roll back the points             CN30 202
subtqx:(IPTX+3*NX,CON,P3)#             Get new p3                       CN30 203
Y0=Y+DY*P0/(P0-P1)#                    Initial linear guess             CN30 204
Y=Y+DY#                                Increment reference y            CN30 205
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CN30 206
ELSE IF(J>1)#                          Normal case                      CN30 207
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CN30 208
subtqx:(IPTX-NX,CON,P0)#               Get p0                           CN30 209
Y0=Y+DY*P1/(P1-P2)#                    Initial linear guess             CN30 210
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CN30 211
CALL CN31(1,Y,Y0,P0,P1,P2,P3,Y1)#      Solve for root, y1               CN30 212
NOPTS=NOPTS+1#                         Increment points counter         CN30 213
incrqx:(MARK4,MARK4+6,CN3001)#         Request 6 more words             CN30 214
QX(MARK4-5)=FLOAT(I-1)#                I-coord for this pt              CN30 215
QX(MARK4-4)=FLOAT(INT(Y1/DY))#         J-coord for this pt              CN30 216
QX(MARK4-3)=0.0#                       Alpha for this pt                CN30 217
QX(MARK4-2)=AMOD(Y1,DY)#               Beta for this pt                 CN30 218
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CN30 219
IF(P2*P3>=0.0) NEXT#                   Intersection in last case        CN30 220
Y0=Y+DY+DY*P2/(P2-P3)#                 Initial linear guess             CN30 221
IPTX=MARK1+(NY-4)*NX+I#                Pointer to get p0                CN30 222
subtqx:(IPTX,CON,P0)#                  Get p0                           CN30 223
CALL CN31(1,Y,Y0,P0,P1,P2,P3,Y1)#      Solve for root, y1               CN30 224
NOPTS=NOPTS+1#                         Increment points counter         CN30 225
incrqx:(MARK4,MARK4+6,CN3001)#         Request 6 more words             CN30 226
QX(MARK4-5)=FLOAT(I-1)#                I-coord for this pt              CN30 227
QX(MARK4-4)=FLOAT(INT(Y1/DY))#         J-coord for this pt              CN30 228
QX(MARK4-3)=0.0#                       Alpha for this pt                CN30 229
QX(MARK4-2)=AMOD(Y1,DY)#               Beta for this pt                 CN30 230
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CN30 231
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CN30 232
#                                                                       CN30 233
# ALL INTERSECTIONS OF MESH LINES WITH CONTOUR CONT(ICON)               CN30 234
# HAVE BEEN FOUND.  RETURN TO CALLER.                                   CN30 235
#                                                                       CN30 236
RETURN#                                                                 CN30 237
END#                                                                    CN30 238
systemheader:(CN31)#                                                    CN31   1
#####################################################################   CN31   2
#                                                                   #   CN31   3
#                           CN31                                    #   CN31   4
#                                                                   #   CN31   5
#####################################################################   CN31   6
SUBROUTINE CN31(IXY,SX,SX0,SP0,SP1,SP2,SP3,SX1)#                        CN31   7
include:(CNCOMN)#                                                       CN31   8
#                                                                       CN31   9
# SOLVES FOR ROOT OF CUBIC EQUATION WITH INITIAL                        CN31  10
# GUESS AT SX0; RETURNED ROOT IS SX1                                    CN31  11
# IXY CONTROLS INTERPOLATION OVER X OR Y                                CN31  12
#                                                                       CN31  13
INTEGER IT,IXY#                                                         CN31  14
REAL SP0,SP1,SP2,SP3,SX,SX0,SX1#                                        CN31  15
dp: A1,A2,A3,A4,D,P(3),PL,PR,P0,P1,P2,P3,Q,R(3),R1,R2,X,X0,X1,Y#        CN31  16
dp: TWO,THREE,FOUR,SIX,SEVEN#                                           CN31  17
#                                                                       CN31  18
TWO=2.d0:; THREE=3.d0:; FOUR=4.d0:; SIX=6.d0:; SEVEN=7.d0:; D=0.#       CN31  19
X=db:(SX) ; X0=db:(SX0) ; P0=db:(SP0)# Convert to d.p.                  CN31  20
P1=db:(SP1) ; P2=db:(SP2) ; P3=db:(SP3)#                                CN31  21
IF(IXY==0) D=db:(DX)#                  Interpolation over x             CN31  22
ELSE IF(IXY==1) D=db:(DY)#             Interpolation over y             CN31  23
#                                                                       CN31  24
A1=(P3-THREE*(P2-P1)-P0)/(SIX*D*D*D)#                                   CN31  25
A2=(P3-TWO*P2+P1)/(TWO*D*D)-THREE*A1*(X+D)#                             CN31  26
A3=(P3-P2)/D-A1*((X+THREE*D)*THREE*X+SEVEN*D*D)-A2*(TWO*X+THREE*D)#     CN31  27
A4=P1-((A1*X+A2)*X+A3)*X#                                               CN31  28
IF(X0<X)#                                                               CN31  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN31  30
Y=X-D ; PL=P0; PR=P1#                                                   CN31  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN31  32
ELSE IF(X0>X+D)#                                                        CN31  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN31  34
Y=X+D ; PL=P2 ; PR=P3#                                                  CN31  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN31  36
ELSE#                                                                   CN31  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN31  38
Y=X ; PL=P1 ; PR=P2#                                                    CN31  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN31  40
IF(dabs:(A1)<1.E-10)#                  Test for zero coefficient        CN31  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CN31  42
Q=A3*A3-FOUR*A2*A4#                    This is at most a quadratic      CN31  43
IF(Q==0.0) X1=-A3/(TWO*A2)#                                             CN31  44
ELSE#                                                                   CN31  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CN31  46
Q=dsqrt:(Q)#                                                            CN31  47
R1=(-A3+Q)/(TWO*A2)#                                                    CN31  48
R2=(-A3-Q)/(TWO*A2)#                                                    CN31  49
X1=R1#                                                                  CN31  50
IF(R1<Y\R1>Y+D) X1=R2#                                                  CN31  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CN31  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CN31  53
ELSE#                                  This is a cubic                  CN31  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CN31  55
P(1)=A2/A1 ; P(2)=A3/A1 ; P(3)=A4/A1#  Fill the p array                 CN31  56
CALL CN32(P,R,IT)#                     Solve the cubic equation         CN31  57
IF(IT==0)#                             All roots are real               CN31  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CN31  59
IF(R(1)>=Y&R(1)<=Y+D) X1=R(1)#         Choose which root is             CN31  60
ELSE IF(R(2)>=Y&R(2)<=Y+D) X1=R(2)#    In the correct range             CN31  61
ELSE X1=R(3)#                                                           CN31  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CN31  63
ELSE X1=R(1)#                          Only one real root               CN31  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CN31  65
SX1=sg:(X1)#                           Return s.p. number               CN31  66
#                                                                       CN31  67
RETURN#                                                                 CN31  68
END#                                                                    CN31  69
systemheader:(CN32)#                                                    CN32   1
#####################################################################   CN32   2
#                                                                   #   CN32   3
#                           CN32                                    #   CN32   4
#                                                                   #   CN32   5
#####################################################################   CN32   6
SUBROUTINE CN32(P,X,IT)#                                                CN32   7
#                                                                       CN32   8
# SOLVES FOR ROOT OF THE CUBIC EQUATION                                 CN32   9
# Y**3 + P(1)*Y**2 + P(2)*Y +P(3) = 0                                   CN32  10
# P(1), P(2), P(3) REAL.                                                CN32  11
# IF RETURNED IT=0, ALL ROOTS ARE REAL, X(1), X(2), X(3)                CN32  12
# IF RETURNED IT!=0, ROOTS ARE X(1), X(2)+I*X(3), X(2)-I*X(3)           CN32  13
#                                                                       CN32  14
INTEGER IT#                                                             CN32  15
dp: A,A1,A2,A3,B,P(3),Q,QP,T,TEST,TT,T1,T2,X(3)#                        CN32  16
dp: ONE,TWO,THREE,Q1,Q2,Q3#                                             CN32  17
#                                                                       CN32  18
Q1=2.094395102 d0:#                                                     CN32  19
Q2=4.188790204 d0:#                                                     CN32  20
Q3=1.732050808 d0:#                                                     CN32  21
ONE=1.d0:; TWO=2.d0:; THREE=3.d0:#                                      CN32  22
IT=0#                                                                   CN32  23
Q=P(1)/THREE#                                                           CN32  24
A1=P(2)/THREE-Q*Q#                                                      CN32  25
A2=(TWO*Q*Q-P(2))*Q+P(3)#                                               CN32  26
A3=-A2/TWO#                                                             CN32  27
T1=A1*A1*A1#                                                            CN32  28
T2=A3*A3#                                                               CN32  29
T=T1+T2#                                                                CN32  30
TEST=T1/T2+ONE#                                                         CN32  31
IF(TEST<0.0)#                          Three real roots                 CN32  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN32  33
QP=TWO*dsqrt:(-A1)#                                                     CN32  34
T=A2/(A1*QP)#                                                           CN32  35
T=dacos:(T)/THREE#                     Get angle                        CN32  36
X(1)=QP*dcos:(T)-Q#                    First root                       CN32  37
X(2)=QP*dcos:(T+Q1)-Q#                 Second root                      CN32  38
X(3)=QP*dcos:(T+Q2)-Q#                 Third root                       CN32  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN32  40
ELSE#                                  Only one real root               CN32  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN32  42
TT=dsqrt:(T)#                                                           CN32  43
A=A3+TT#                                                                CN32  44
IF(A<0.0) A=-dexp:(dlog:(-A)/THREE)#   A is negative                    CN32  45
ELSE IF(A>0.0) A=dexp:(dlog:(A)/THREE)# A is positive                   CN32  46
B=A3-TT#                                                                CN32  47
IF(B<0.0) B=-dexp:(dlog:(-B)/THREE)#   B is negative                    CN32  48
ELSE IF(B>0.0) B=dexp:(dlog:(B)/THREE)# B is positive                   CN32  49
X(1)=A+B-Q#                                                             CN32  50
X(2)=-(X(1)+THREE*Q)/TWO#                                               CN32  51
IF(TEST>1.0E-6)#                                                        CN32  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN32  53
IT=1#                                                                   CN32  54
X(3)=Q3*(A-B)/TWO#                                                      CN32  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN32  56
ELSE X(3)=X(2)#                        Equal roots                      CN32  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN32  58
RETURN#                                                                 CN32  59
END#                                                                    CN32  60
systemheader:(CN40)#                                                    CN40   1
#####################################################################   CN40   2
#                                                                   #   CN40   3
#                           CN40                                    #   CN40   4
#                                                                   #   CN40   5
#####################################################################   CN40   6
SUBROUTINE CN40#                                                        CN40   7
include:(AACOMN)#                                                       CN40   8
include:(CNCOMN)#                                                       CN40   9
#                                                                       CN40  10
# THE UNCHAINED LIST OF INTERPOLATED POINTS PRODUCED BY CN30            CN40  11
# IS REPEATEDLY SORTED THROUGH UNTIL IT CONSISTS OF CONTIGUOUS          CN40  12
# POINTS ON SUCCESSIVE CURVES FOR THE CURRENT CONTOUR LEVEL.            CN40  13
# THE SPACE IN THE QX ARRAY ABOVE MARK4 IS USED TO STORE THE            CN40  14
# NUMBER OF POINTS OBTAINED FOR EACH CURVE, AND THE TOTAL NUMBER        CN40  15
# OF CURVES FOR THIS LEVEL IS GIVEN BY KCURV.                           CN40  16
#                                                                       CN40  17
# THE LIST OF UNCHAINED POINTS IS FIRST SEARCHED TO FIND ALL            CN40  18
# POINTS THAT LIE ON AN EDGE OF THE MAP.  THESE ARE USED AS             CN40  19
# INITIAL POINTS UNTIL THEY ARE EXHAUSTED (I.E. ALL OPEN CURVES         CN40  20
# ARE OBTAINED FIRST).  THE CLOSED CURVES ARE THEN CHAINED              CN40  21
# UNTIL THE CURRENT POINT POINTER (LPT) HITS THE TOP OF THE LIST        CN40  22
#                                                                       CN40  23
# LPT IS THE POINTER TO THE CURRENT POINT, WHICH DEFINES A              CN40  24
# REFERENCE POINT AT THE TOP LEFT OF THE PIXEL.  THE (I,J)              CN40  25
# COORDINATES OF THIS REFERENCE POINT, (IREF,JREF), ARE USED            CN40  26
# TO DETERMINE THE CHARACTERISTICS OF THE NEXT PIXEL FOR                CN40  27
# LINKAGE.  THE LOCATION OF THE CURRENT POINT ON THE EDGES OF           CN40  28
# THE CURRENT PIXEL ARE GIVEN BY LEGE, WHICH ASSUMES THE VALUES         CN40  29
#                                                                       CN40  30
#      LEGE = 1, LPT IS ON TOP EDGE OF PIXEL                            CN40  31
#      LEGE = 2, LPT IS ON RIGHT EDGE OF PIXEL                          CN40  32
#      LEGE = 3, LPT IS ON BOTTOM EDGE OF PIXEL                         CN40  33
#      LEGE = 4, LPT IS ON LEFT EDGE OF PIXEL                           CN40  34
#                                                                       CN40  35
# THERE ARE UP TO THREE POSSIBLE LINKS FOR EACH POINT (ONE FOR          CN40  36
# EACH OF THE OTHER EDGES), BUT IN GENERAL IT IS ONLY FEASIBLE          CN40  37
# TO HAVE EITHER ONE OR THREE AND NOT TWO.  IF THERE ARE MORE           CN40  38
# THAN ONE POSSIBLE LINKAGES, THE CHOICE OF NEXT POINT IS MADE          CN40  39
# ON THE BASIS OF WHICH OPTION GIVES THE LARGEST SPATIAL                CN40  40
# SEPARATION BETWEEN CURVES, SINCE THIS THEN AVOIDS UNDESIRABLE         CN40  41
# GOOSE-NECKED CONTOURS ON THE MAP.                                     CN40  42
#                                                                       CN40  43
INTEGER LPT,NPT,KE,LSAV,IEDGE,IPTX,IE,JE,IPTX1,IPTX2#                   CN40  44
INTEGER NLINK,K,IHIT,IPTXK,IK,JK#                                       CN40  45
INTEGER NP(4),KK,NPO(4),IPTXL,IPTXN,NOPTSB#                             CN40  46
INTEGER NMIN,PTS,SPTS,STP,SENSE,MEDGE#                                  CN40  47
INTEGER P0,P1,P2,P3,L,I#                                                CN40  48
INTEGER LPTR,EDGE,TRI#                                                  CN40  49
REAL    P1X,P1Y,P2X,P2Y,P3X,P3Y,XX(2),AREA,A1,TMP#                      CN40  50
REAL    ALF1,BET1#                                                      CN40  51
REAL    SGN#                                                            CN40  52
REAL    ALF,BET,AK,BK#                                                  CN40  53
REAL    X,Y#                                                            CN40  54
REAL    ATOP,ABOT,BRIT,BLFT,CASE1,CASE2,QXRTZP#                         CN40  55
#                                                                       CN40  56
#                                                                       CN40  57
chardata:(CNDA,DASHED)#                                                 CN40  58
chardata:(CNDO,DOTTED)#                                                 CN40  59
chardata:(CNSO, SOLID)#                                                 CN40  60
intdata:(IREF,0); intdata:(JREF,0); intdata:(LEGE,0)#                   CN40  61
intdata:(ISAV,0); intdata:(JSAV,0); intdata:(KT,0)#                     CN40  62
#                   CLOCKWISE          ANTICLOCKWISE                    CN40  63
intdata:(MEDG, [1,2,3,4,1,2,3,4,1,   1,4,3,2,1,4,3,2,1])#               CN40  64
intdata:(VERX, [1,1,0,0,1,1,0,0,1,   0,0,1,1,0,0,1,1,0])#               CN40  65
intdata:(VERY, [0,1,1,0,0,1,1,0,0,   0,1,1,0,0,1,1,0,0])#               CN40  66
intdata:(STEP, [1,1,-1,-1,1,1,-1,-1,1, -1,1,1,-1,-1,1,1,-1])#           CN40  67
datastuff:#                                                             CN40  68
#                                                                       CN40  69
LPT=1#                                 Current point in unchained l     CN40  70
KCURV=1#                               Current curve for this level     CN40  71
NPT=0#                                 No of pts for this curve         CN40  72
NOPTSB=NOPTS#                          No of pts at beginning           CN40  73
IF(FILLED==yes:)#                      Reserve space for map corners    CN40  74
incrqx:(MARK4,MARK4+1000*6,CN3001)#    Request 1000 more point packts   CN40  75
STOP4=MARK4#                           Should only need 4 at most       CN40  76
#                                                                       CN40  77
#    LOOP OVER LIST OF UNCHAINED POINTS                                 CN40  78
#    ----------------------------------                                 CN40  79
#                                     #                                 CN40  80
WHILE(LPT<NOPTS-2)#                    Loop over remaining points       CN40  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN40  82
NPT=NPT+1#                             Increment points counter         CN40  83
KE=LPT-1#                              Set the edge counter             CN40  84
IEDGE=0#                               No edge point found              CN40  85
#                                                                       CN40  86
#    SEARCH FOR AN EDGE POINT                                           CN40  87
#    ------------------------                                           CN40  88
#                                                                       CN40  89
REPEAT#                                Search for an edge point         CN40  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN40  91
KE=KE+1#                               Increment edge counter           CN40  92
IPTX=MARK3+(KE-1)*6#                   Retrieve point coordinates       CN40  93
IE=NINT(QX(IPTX+1))#                   I-coord for this pt              CN40  94
JE=NINT(QX(IPTX+2))#                   J-coord for this pt              CN40  95
ALF=ABS(QX(IPTX+3))#                   Alpha for this pt                CN40  96
BET=ABS(QX(IPTX+4))#                   Beta for this pt                 CN40  97
IF(IE==0&ALF<small:) IEDGE=1#          Left edge of map                 CN40  98
IF(IE==(NX-1)&ALF<small:) IEDGE=1#     Right edge of map                CN40  99
IF(JE==0&BET<small:) IEDGE=1#          Top edge of map                  CN40 100
IF(JE==(NY-1)&BET<small:) IEDGE=1#     Bottom edge of map               CN40 101
IF(KE==NOPTS\IEDGE==1) BREAK#          No more pts or edge found        CN40 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN40 103
#                                                                       CN40 104
#    AN EDGE POINT WAS FOUND                                            CN40 105
#    -----------------------                                            CN40 106
#                                                                       CN40 107
IF(IEDGE==1)#                          Swap ke with lpt                 CN40 108
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN40 109
IPTX1=MARK3+(KE-1)*6#                  Pointer for edge point           CN40 110
IPTX2=MARK3+(LPT-1)*6#                 Pointer for lpt                  CN40 111
swapqx:(IPTX1+1,IPTX2+1)#              Swap i-coords of these pts       CN40 112
swapqx:(IPTX1+2,IPTX2+2)#              Swap j-coords of these pts       CN40 113
swapqx:(IPTX1+3,IPTX2+3)#              Swap alphas of these pts         CN40 114
swapqx:(IPTX1+4,IPTX2+4)#              Swap betas of these pts          CN40 115
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN40 116
#                                                                       CN40 117
#    LPT IS AN APPROPRIATE STARTING POINT                               CN40 118
#    ------------------------------------                               CN40 119
#                                                                       CN40 120
NLINK=0#                               Zero the link counter            CN40 121
LSAV=LPT#                              Save this pointer                CN40 122
#                                                                       CN40 123
#    SEARCH REST OF LIST FOR POSSIBLE LINKS                             CN40 124
#    --------------------------------------                             CN40 125
#                                                                       CN40 126
REPEAT#                                Loop over remaining points       CN40 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CN40 128
IF(NLINK==0)#                          Get ref point for first pt       CN40 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CN40 130
IPTX=MARK3+(LPT-1)*6#                  Pointer for point lpt            CN40 131
IREF=NINT(QX(IPTX+1))#                 I-reference coord                CN40 132
JREF=NINT(QX(IPTX+2))#                 J-reference coord                CN40 133
IF(QX(IPTX+3)>0.0) LEGE=1#             Alpha is non-zero                CN40 134
IF(QX(IPTX+4)>0.0) LEGE=4#             Beta is non-zero                 CN40 135
IF(IREF==(NX-1))#                      Right edge of map                CN40 136
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CN40 137
IREF=IREF-1#                           Push ref. point to left          CN40 138
LEGE=2#                                Lpt on right edge                CN40 139
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CN40 140
IF(JREF==(NY-1))#                      Bottom edge of map               CN40 141
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CN40 142
JREF=JREF-1#                           Push ref. point upwards          CN40 143
LEGE=3#                                Lpt on bottom edge               CN40 144
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CN40 145
ISAV=IREF#                             Save i reference                 CN40 146
JSAV=JREF#                             Save j reference                 CN40 147
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CN40 148
#                                                                       CN40 149
NLINK=0#                               Initialize linkage counter       CN40 150
FOR (K=LPT+1 ; K<=NOPTS ; K=K+1)#      Search list for linkages         CN40 151
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CN40 152
IHIT=0#                                Flag for linkage                 CN40 153
IPTXK=MARK3+(K-1)*6#                   Pointer for point k              CN40 154
IK=NINT(QX(IPTXK+1))#                  I-coord for this pt              CN40 155
JK=NINT(QX(IPTXK+2))#                  J-coord for this pt              CN40 156
AK=QX(IPTXK+3)#                        Alpha for this pt                CN40 157
BK=QX(IPTXK+4)#                        Beta for this pt                 CN40 158
IF(IK==IREF&JK==JREF) IHIT=1#          Tests for a link                 CN40 159
IF(IK==(IREF+1)&JK==JREF&AK<small:) IHIT=1#                             CN40 160
IF(IK==IREF&JK==(JREF+1)&BK<small:) IHIT=1#                             CN40 161
#                                                                       CN40 162
IF(IHIT==0) NEXT#                      Break if no link was found       CN40 163
NLINK=NLINK+1#                         Increment link counter           CN40 164
NP(NLINK)=K#                           Store this point                 CN40 165
KT=K#                                  Kt is the valid link to lpt      CN40 166
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CN40 167
#                                                                       CN40 168
#    SEVERAL LINKS FOUND - DETERMINE THE APPROPRIATE ONE                CN40 169
#    -------------------------------------------------                  CN40 170
#                                                                       CN40 171
#IF(NLINK==2) NLINK=0#                  assume no links and continue?
# potential glitch here if contour goes one way up a river valley ...
# hopefully the plotting section now correctly checks for closure
IF(NLINK>1)#                           Several links found              CN40 172
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CN40 173
IF(NLINK==2)#                          Include first pt on curve        CN40 174
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CN40 175
IF(JSAV==JREF&ISAV==(IREF-1)) NPO(4)=LSAV# First pt was on left edge    CN40 176
ELSE IF(JSAV==JREF&ISAV==(IREF+1)) NPO(2)=LSAV# First pt was on right   CN40 177
ELSE IF(ISAV==IREF&JSAV==(JREF+1)) NPO(3)=LSAV# First pt was on botto   CN40 178
ELSE IF(ISAV==IREF&JSAV==(JREF-1)) NPO(1)=LSAV# First pt was on top     CN40 179
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CN40 180
NPO(LEGE)=LPT#                         Assign edge to point lpt         CN40 181
DO K=1,NLINK#                          Assign edges to links            CN40 182
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CN40 183
KK=NP(K)#                              Which point is it in the lis     CN40 184
IPTX=MARK3+(KK-1)*6#                   Pointer in list                  CN40 185
IF(NINT(QX(IPTX+1))==(IREF+1))#        Kk is on right edge              CN40 186
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CN40 187
NPO(2)=KK#                             Assign kk                        CN40 188
NEXT#                                  Jump to bot of loop              CN40 189
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CN40 190
ELSE IF(NINT(QX(IPTX+2))==(JREF+1))#   Kk on bot edge                   CN40 191
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CN40 192
NPO(3)=KK#                             Assign kk                        CN40 193
NEXT#                                  Jump to bot of loop              CN40 194
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CN40 195
ELSE IF(QX(IPTX+3)>0.0)#               Kk on top edge                   CN40 196
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CN40 197
NPO(1)=KK#                             Assign kk                        CN40 198
NEXT#                                  Jump to bot of loop              CN40 199
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CN40 200
ELSE NPO(4)=KK#                        Kk on left edge                  CN40 201
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CN40 202
ATOP=QX(MARK3+(NPO(1)-1)*6+3)#         Alpha top                        CN40 203
ABOT=QX(MARK3+(NPO(3)-1)*6+3)#         Alpha bottom                     CN40 204
BRIT=QX(MARK3+(NPO(2)-1)*6+4)#         Beta right                       CN40 205
BLFT=QX(MARK3+(NPO(4)-1)*6+4)#         Beta left                        CN40 206
CASE1=ATOP*BLFT+(DX-ABOT)*(DY-BRIT)#   Case 1 area                      CN40 207
CASE2=(DX-ATOP)*BRIT+(DY-BLFT)*ABOT#   Case 2 area                      CN40 208
IF(CASE1<CASE2) KT=NPO(4-LEGE+1)#      Assign link for case1            CN40 209
ELSE IF(CASE1>CASE2)#                  Assign valid links#              CN40 210
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CN40 211
IF     (LEGE==1) KT=NPO(2)#            Link 1 to 2                      CN40 212
ELSE IF(LEGE==2) KT=NPO(1)#            Link 2 to 1                      CN40 213
ELSE IF(LEGE==3) KT=NPO(4)#            Link 3 to 4                      CN40 214
ELSE IF(LEGE==4) KT=NPO(3)#            Link 4 to 3                      CN40 215
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CN40 216
IF(KT==LSAV) NLINK=0#                  Valid link is first point        CN40 217
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CN40 218
#                                                                       CN40 219
#    AT LEAST ONE LINK WAS FOUND - SWAP COORDS AND UPDATE REFERENCE     CN40 220
#    --------------------------------------------------------------     CN40 221
#                                                                       CN40 222
IF(NLINK>=1)#                          Kt is valid -swap with lpt+1     CN40 223
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CN40 224
IPTXK=MARK3+(KT-1)*6#                  Pointer for kt                   CN40 225
IPTXL=MARK3+LPT*6#                     Pointer for lpt+1                CN40 226
swapqx:(IPTXK+1,IPTXL+1)#              Swap i-coords of these pts       CN40 227
swapqx:(IPTXK+2,IPTXL+2)#              Swap j-coords of these pts       CN40 228
swapqx:(IPTXK+3,IPTXL+3)#              Swap alphas of these pts         CN40 229
swapqx:(IPTXK+4,IPTXL+4)#              Swap betas of these pts          CN40 230
NPT=NPT+1#                             Incr. points for this curve      CN40 231
LPT=LPT+1#                             Incr. current point              CN40 232
IF(NINT(QX(IPTXL+1))>IREF)#            New i-coord exceeds iref         CN40 233
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CN40 234
IREF=IREF+1#                           Increment iref                   CN40 235
LEGE=4#                                Left of pixel                    CN40 236
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CN40 237
ELSE IF(NINT(QX(IPTXL+2))>JREF)#       New j-coord exceeds jref         CN40 238
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CN40 239
JREF=JREF+1#                           Increment jref                   CN40 240
LEGE=1#                                Top of pixel                     CN40 241
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CN40 242
ELSE IF(QX(IPTXL+4)>0.0)#              New beta is non-zero             CN40 243
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CN40 244
IREF=IREF-1#                           Decrement iref                   CN40 245
LEGE=2#                                Right of pixel                   CN40 246
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CN40 247
ELSE#                                  New alpha is non-zero            CN40 248
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CN40 249
JREF=JREF-1#                           Decrement jref                   CN40 250
LEGE=3#                                Bottom of pixel                  CN40 251
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CN40 252
#                                                                       CN40 253
#    TEST IF AN EDGE WAS PASSED                                         CN40 254
#    --------------------------                                         CN40 255
#                                                                       CN40 256
IF(FILLED==no:)#                                                        CN40 257
IF(IREF<0\IREF>(NX-1)\JREF<0\JREF>(NY-1)) NLINK=0# Edge passed          CN40 258
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CN40 259
#                                                                       CN40 260
#    THIS IS AN ISOLATED POINT                                          CN40 261
#    -------------------------                                          CN40 262
#                                                                       CN40 263
IF(NLINK==0&LPT==LSAV)#                Isolated point - purge it        CN40 264
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CN40 265
IPTXL=MARK3+(LPT-1)*6#                 Pointer for lpt                  CN40 266
IPTXN=MARK3+(NOPTS-1)*6#               Pointer for last point           CN40 267
movereal:(QX,IPTXN+1,QX,IPTXL+1,4,1)#  Put last point into lpt          CN40 268
NOPTS=NOPTS-1#                         Decrement nopts                  CN40 269
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CN40 270
#                                                                       CN40 271
#    CLOSE CURVE IF FILLING                                             CN40 272
#    ----------------------                                             CN40 273
#                                                                       CN40 274
IF(FILLED==yes:&NLINK==0)#             No more links found              CN40 275
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CN40 276
MEDGE=0#                               Assume not on a map edge         CN40 277
ALF=QX(IPTXL+3)#                       New alpha                        CN40 278
BET=QX(IPTXL+4)#                       New beta                         CN40 279
IF    (IREF<=0&ALF<small:)     $(IREF=0;     MEDGE=4$)# Left of map     CN40 280
ELSEIF(IREF>=(NX-1)&ALF<small:)$(IREF=(NX-1);MEDGE=2$)# Right of map    CN40 281
ELSEIF(JREF<=0&BET<small:)     $(JREF=0;     MEDGE=1$)# Top of map      CN40 282
ELSEIF(JREF>=(NY-1)&BET<small:)$(JREF=(NY-1);MEDGE=3$)# Bottom of map   CN40 283
SGN=+1.#                               Assume for positive contours     CN40 284
IF(CONT(ICON)<=0.)SGN=-1.## negative  or zero contours                  CN40 285
IF(MEDGE>0)#                           Search along edge for closing    CN40 286
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CN40 287
#                                                                       CN40 288
#  SPECIAL CASES FOR VERTICES                                           CN40 289
#  --------------------------                                           CN40 290
#                                                                       CN40 291
IF(IREF<=0&JREF<=0)#                   Top/left corner                  CN40 292
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CN40 293
IF(SGN*QX(MARK1+ 1)#                   Next point across                CN40 294
>SGN*QX(MARK1+(JREF+1)*NX))#           Next point down                  CN40 295
$(MEDGE=1; STP=+1;SENSE= 0 $)#         Going across clockwise around    CN40 296
ELSE#                                                                   CN40 297
$(MEDGE=4; STP=+1;SENSE= 9 $)#         Going down anticlockwise aroun   CN40 298
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CN40 299
ELSEIF(IREF<=0&JREF>=(NY-1))#          Bottom/left corner               CN40 300
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CN40 301
IF(SGN*QX(MARK1+(JREF-1)*NX)#          Next point up                    CN40 302
>SGN*QX(MARK1+(JREF)*NX+1))#           Next point across                CN40 303
$(MEDGE=4; STP=-1;SENSE= 0 $)#         Going up clockwise around        CN40 304
ELSE#                                                                   CN40 305
$(MEDGE=3; STP=+1;SENSE= 9 $)#         Going across anticlockwise aro   CN40 306
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CN40 307
ELSEIF(IREF>=(NX-1)&JREF<=0)#          Top/right corner                 CN40 308
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 CN40 309
IF(SGN*QX(MARK1+  NX-2)#               Previous point across            CN40 310
>SGN*QX(MARK1+2*NX-1))#                Next point down                  CN40 311
$(MEDGE=1; STP=-1;SENSE= 9 $)#         Going up clockwise around        CN40 312
ELSE#                                                                   CN40 313
$(MEDGE=2; STP=+1;SENSE= 0 $)#         Going across anticlockwise aro   CN40 314
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 CN40 315
ELSEIF(IREF>=(NX-1)&JREF>=(NY-1))#     Bottom/right corner              CN40 316
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 CN40 317
IF(SGN*QX(MARK1+ NY*NX-2)#             Previous point across            CN40 318
>SGN*QX(MARK1+ (NY-1)*NX-1))#          Next point up                    CN40 319
$(MEDGE=3; STP=-1;SENSE= 0 $)#         Going across clockwise around    CN40 320
ELSE#                                                                   CN40 321
$(MEDGE=2; STP=-1;SENSE= 9 $)#         Going up anticlockwise around    CN40 322
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 CN40 323
#                                                                       CN40 324
#   FOR NON-CORNER EDGE POINTS                                          CN40 325
#   --------------------------                                          CN40 326
#                                                                       CN40 327
ELSEIF(MOD(MEDGE,2)==1)#               For top 1/3 bottom edge          CN40 328
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 CN40 329
IF((QX(MARK1+JREF*NX+IREF+2)-CONT(ICON))# Both sides go up/down         CN40 330
*(QX(MARK1+JREF*NX+IREF+0)-CONT(ICON))>=0.0) GOTO100# In god we trust   CN40 331
#                                      Else not auto closing            CN40 332
IF(SGN*QX(MARK1+JREF*NX+IREF+1+1)#     Is next point abs(dr)> current   CN40 333
>SGN*QX(MARK1+JREF*NX+IREF+1-1))STP=+1# Step across in pos direction    CN40 334
ELSE                              STP=-1# Step across in neg directio   CN40 335
IF(MEDGE==1&STP== 1)SENSE= 0#          Clockwise                        CN40 336
IF(MEDGE==3&STP== 1)SENSE= 9#          Anticlockwise                    CN40 337
IF(MEDGE==1&STP==-1)SENSE= 9#          Anticlockwise                    CN40 338
IF(MEDGE==3&STP==-1)SENSE= 0#          Clockwise                        CN40 339
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 CN40 340
ELSE#                                  For left 4/2 right edge          CN40 341
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 CN40 342
IF((QX(MARK1+(JREF+1)*NX+IREF+1)-CONT(ICON))# Both sides go up/down     CN40 343
*(QX(MARK1+(JREF-1)*NX+IREF+1)-CONT(ICON))>=0.0)GOTO100# In god we tr   CN40 344
#                                      Else not auto closing            CN40 345
IF(SGN*QX(MARK1+(JREF+1)*NX+IREF+1)#                                    CN40 346
>SGN*QX(MARK1+(JREF-1)*NX+IREF+1))STP=+1# Step vert in pos direction    CN40 347
ELSE                                STP=-1# Step vert in neg directio   CN40 348
IF(MEDGE==2&STP== 1)SENSE= 0#          Clockwise                        CN40 349
IF(MEDGE==4&STP== 1)SENSE= 9#          Anticlockwise                    CN40 350
IF(MEDGE==2&STP==-1)SENSE= 9#          Anticlockwise                    CN40 351
IF(MEDGE==4&STP==-1)SENSE= 0#          Clockwise                        CN40 352
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 CN40 353
#                                                                       CN40 354
#  DEFINED THE SENSE OF ROTATION, NOW LOOK FOR MATCHING EDGE POINTS     CN40 355
#  ----------------------------------------------------------------     CN40 356
#                                                                       CN40 357
SPTS=0#                                Initialize saved point           CN40 358
DO LPTR=SENSE+1,SENSE+4#                                                CN40 359
IF(MEDG(LPTR)==MEDGE) BREAK#           Identified current edge          CN40 360
DO EDGE=0,4#                           Loop for 5 map boundary edges    CN40 361
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 CN40 362
PTS=0;NMIN=10*(NX+NY)#                 Initialize, suitably large       CN40 363
REPEAT#                                Search for an edge point         CN40 364
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 CN40 365
PTS=PTS+1#                             Increment point counter          CN40 366
IPTX=MARK3+(PTS-1)*6#                  Retrieve point coordinates       CN40 367
IE=NINT(QX(IPTX+1))#                   I-coord for this pt              CN40 368
JE=NINT(QX(IPTX+2))#                   J-coord for this pt              CN40 369
ALF1=QX(IPTX+3)#                                                        CN40 370
BET1=QX(IPTX+4)#                                                        CN40 371
IF(MOD(MEDGE,2)==0)#                   For a left or right edge         CN40 372
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 CN40 373
IF(IE==IREF& ALF1<=small: & -(JREF-JE)*STP>0)# Exclude identical poin   CN40 374
IF(ABS(JREF-JE)<NMIN)#                 Closer along edge than any pre   CN40 375
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 CN40 376
NMIN=ABS(JE-JREF)#                     Save minimum grid distance       CN40 377
SPTS=PTS#                              Save pointer to closest edge p   CN40 378
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 CN40 379
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 CN40 380
ELSE#                                  For top bottom edge              CN40 381
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 CN40 382
IF(JE==JREF & BET1<=small: & -(IREF-IE)*STP>0)# Exclude identical poi   CN40 383
IF(ABS(IREF-IE)<NMIN)#                 Closer along edge than any pre   CN40 384
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 CN40 385
NMIN=ABS(IE-IREF)#                     Save minimum grid distance       CN40 386
SPTS=PTS#                              Save pointer to closest edge p   CN40 387
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 CN40 388
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 CN40 389
IF(PTS>=NOPTS)BREAK#                   End of point list                CN40 390
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 CN40 391
#                                                                       CN40 392
IF(SPTS!=0)BREAK#                      First point found must be it     CN40 393
#                                      Else add  current vertex to poin CN40 394
IREF= VERX(LPTR)*(NX-1)#               X-vertex of map corner           CN40 395
JREF= VERY(LPTR)*(NY-1)#               Y-vertex of map corner           CN40 396
IPTXK=MARK3+NOPTS*6#                                                    CN40 397
QX(IPTXK+1)=FLOAT(IREF)#               I-coord for this pt              CN40 398
QX(IPTXK+2)=FLOAT(JREF)#               J-coord for this pt              CN40 399
QX(IPTXK+3)=0.0#                       Alpha for this pt                CN40 400
QX(IPTXK+4)=0.0#                       Beta  for this pt                CN40 401
NOPTS=NOPTS+1#                         Increment points counter         CN40 402
IPTXL=MARK3+LPT*6#                     Pointer for lpt+1                CN40 403
swapqx:(IPTXK+1,IPTXL+1)#              Swap i-coords of these pts       CN40 404
swapqx:(IPTXK+2,IPTXL+2)#              Swap j-coords of these pts       CN40 405
swapqx:(IPTXK+3,IPTXL+3)#              Swap alphas of these pts         CN40 406
swapqx:(IPTXK+4,IPTXL+4)#              Swap betas of these pts          CN40 407
NPT=NPT+1#                             Incr. points for this curve      CN40 408
LPT=LPT+1#                             Incr. current point              CN40 409
LPTR=LPTR+1#                                                            CN40 410
MEDGE=MEDG(LPTR)#                      Now get new edge                 CN40 411
STP=  STEP(LPTR)#                      Intended direction               CN40 412
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 CN40 413
#                                                                       CN40 414
IF(SPTS >LPT)#                         First point of next open curve   CN40 415
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 CN40 416
IPTXK=MARK3+(SPTS-1)*6#                Pointer for saved point          CN40 417
IPTXL=MARK3+LPT*6#                     Pointer for lpt+1                CN40 418
swapqx:(IPTXK+1,IPTXL+1)#              Swap i-coords of these pts       CN40 419
swapqx:(IPTXK+2,IPTXL+2)#              Swap j-coords of these pts       CN40 420
swapqx:(IPTXK+3,IPTXL+3)#              Swap alphas of these pts         CN40 421
swapqx:(IPTXK+4,IPTXL+4)#              Swap betas of these pts          CN40 422
NPT=NPT+1#                             Incr. points for this curve      CN40 423
LPT=LPT+1#                             Incr. current point              CN40 424
NEXT#                                  Continue with new start point    CN40 425
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 CN40 426
#                                      Else the contour is closed       CN40 427
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CN40 428
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CN40 429
100 CONTINUE#                                                           CN40 430
#                                                                       CN40 431
#                                                                       CN40 432
#    END OF CURRENT CURVE - FINISH IT                                   CN40 433
#    --------------------------------                                   CN40 434
#                                                                       CN40 435
IF(NLINK==0&LPT>LSAV)#                 End of curve found               CN40 436
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 CN40 437
IPTX=STOP4#                            Save end of prev as new start    CN40 438
incrqx:(STOP4,STOP4+step4:,CN4001)#    Points per curve                 CN40 439
QX(IPTX+1)=FLOAT(NPT)#                 No. points for this curve        CN40 440
QX(IPTX+2)=FLOAT(LPT-NPT)#             Start point for this curve       CN40 441
KCURV=KCURV+1#                         Move to next curve               CN40 442
LPT=LPT+1#                             Begin at lpt+1                   CN40 443
NPT=0#                                 Zero points counter              CN40 444
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 CN40 445
IF(NLINK==0) BREAK#                    If no links left, loop           CN40 446
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CN40 447
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN40 448
#                                                                       CN40 449
#    EXIT AFTER TRANSFORMING TO CARTESIAN COORDS                        CN40 450
#    -------------------------------------------                        CN40 451
#                                                                       CN40 452
KCURV=KCURV-1#                         Decrement kcurv                  CN40 453
DO K=1,NOPTS#                          Loop over ordered points         CN40 454
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 CN40 455
IPTX=MARK3+(K-1)*step3:#               Pointer to k'th point            CN40 456
X=QX(IPTX+1)*DX+QX(IPTX+3)#            X-coord                          CN40 457
Y=QX(IPTX+2)*DY+QX(IPTX+4)#            Y-coord                          CN40 458
Y=YLS-Y#                               Transpose y-coord                CN40 459
QX(IPTX+5)=XLOW+X+Y*COSG#              Cartesian x-coord                CN40 460
QX(IPTX+6)=YLOW+Y*SING#                Cartesian y-coord                CN40 461
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 CN40 462
#                                                                       CN40 463
#                                                                       CN40 464
#                                                                       CN40 465
#                                                                       CN40 466
IF(FILLED==yes:)#                      No more links found              CN40 467
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 CN40 468
P0=MARK4#                              First curve                      CN40 469
DO K=1,KCURV#                          Loop over curves                 CN40 470
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 CN40 471
NPT=QX(P0+1)#                          Last point doesn't count         CN40 472
P1=MARK3+NINT(QX(P0+2))*step3:#        Next curve start point           CN40 473
P2=P1+step3:#                          Second chained point             CN40 474
P3=P2+step3:#                          Third chained point              CN40 475
P1X=QX(P1+5);    P1Y=QX(P1+6)#         Initialize first point           CN40 476
P2X=QX(P2+5)-P1X;P2Y=QX(P2+6)-P1Y#     Initialize first vector          CN40 477
AREA=0.0#                              Initialize area                  CN40 478
FOR(TRI=1;TRI<=NPT-2;TRI=TRI+1)#       Sum triangular areas             CN40 479
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 CN40 480
P3X=QX(P3+5)-P1X;P3Y=QX(P3+6)-P1Y#     Second vector                    CN40 481
AREA=AREA+0.5*(P2X*P3Y-P3X*P2Y)#       1/2 area of parallelogram        CN40 482
P2=P3#                                 Swap that pointer                CN40 483
P2X=P3X;P2Y=P3Y#                       Swap those vectors               CN40 484
P3=P3+step3:#                          Point to next vertex             CN40 485
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 CN40 486
#                                                                       CN40 487
# SHOULD CALCULATE WHETHER CONTOUR IS AN INTERNAL OR EXTERNAL           CN40 488
# COLOR BOUNDARY AND SHIFT ITS COLOR ACCORDINGLY                        CN40 489
#                                                                       CN40 490
QX(P0+3)=ABS(AREA)#                    Save area of curve               CN40 491
QX(P0+4)=FLOAT(ICON)#                  Save area of curve               CN40 492
P0=P0+step4:#                          Next curve                       CN40 493
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 CN40 494
#                                                                       CN40 495
# SORT ALL CURVES BASED ON AREA                                         CN40 496
# -----------------------------                                         CN40 497
#                                                                       CN40 498
FOR(P0=MARK4;P0<STOP4;P0=P0+step4:)#   Loop over curves                 CN40 499
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 CN40 500
A1=QX(P0+3);P2=P0#                                                      CN40 501
FOR(P1=P0+step4:;P1<STOP4;P1=P1+step4:)# Loop over curves               CN40 502
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 CN40 503
IF(QX(P1+3)<A1)NEXT#                   Ignore smaller areas             CN40 504
A1=QX(P1+3);P2=P1#                                                      CN40 505
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 CN40 506
P3=MARK3+NINT(QX(P2+2))*step3:#        Pointer to relevant              CN40 507
NPT=NINT(QX(P2+1))#                    Number of points per curve       CN40 508
L=DREC+1#                                                               CN40 509
DO K=1,NPT#                            Write out curve points           CN40 510
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 CN40 511
DREC=DREC+1;XX(1)=QX(P3+5);XX(2)=QX(P3+6)# Get coords                   CN40 512
writedac:(ioda1:,,DREC,XX)#            Add to dac: file                 CN40 513
P3=P3+step3:#                                                           CN40 514
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 CN40 515
IF(P2!=P0)#                            Out of order so swap             CN40 516
DO I=1,step4:#                         For all params                   CN40 517
$(TMP=QX(P0+I);QX(P0+I)=QX(P2+I);QX(P2+I)=TMP$)# Swap                   CN40 518
QX(P0+2)=FLOAT(L)#                     Record dac file pointer          CN40 519
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 CN40 520
#                                                                       CN40 521
# SQUASH CURVE POINTERS BACK UP AGAINST THE MAP                         CN40 522
# --------------------------------------------                          CN40 523
#                                                                       CN40 524
movereal:(QX,MARK4+1,QX,MARK3+1,STOP4-MARK4,1)#                         CN40 525
QX(MARK0+(ICON-1)*step0:+1)=0.#        Area sequence pointer            CN40 526
QX(MARK0+(ICON-1)*step0:+2)=FLOAT(MARK3)# Save first level record       CN40 527
MARK3=MARK3+STOP4-MARK4#               Save end of contour pntr stora   CN40 528
QX(MARK0+(ICON-1)*step0:+3)=FLOAT(MARK3)# Save last  level record       CN40 529
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 CN40 530
#                                                                       CN40 531
#    CONTOUR LEVELS OUTPUT                                              CN40 532
#    ---------------------                                              CN40 533
#                                                                       CN40 534
IF(LINTYP(ICON)==0) movechar:(CNDA,1,CHROT,22,6,0)# Dashed              CN40 535
ELSE IF(LINTYP(ICON)<0) movechar:(CNDO,1,CHROT,22,6,0)# Dotted          CN40 536
ELSE IF(LINTYP(ICON)>0) movechar:(CNSO,1,CHROT,22,6,0)# Solid           CN40 537
ncodefld:(CONT(ICON),1,CHROT,180732.,1)# Contour level                  CN40 538
ncodefld:(FLOAT(NOPTSB),1,CHROT,360413.,1)# Points found                CN40 539
ncodefld:(FLOAT(NOPTSB-NOPTS),1,CHROT,450413.,1)# Points purged         CN40 540
ncodefld:(FLOAT(KCURV),1,CHROT,540413.,1)# Curves found                 CN40 541
writeline:(0,0,0,1,3)#                 Write the line                   CN40 542
#                                                                       CN40 543
RETURN#                                                                 CN40 544
END#                                                                    CN40 545
systemheader:(CN45)#                   Sift through contours & plot     CN45   1
#####################################################################   CN45   2
#                                                                   #   CN45   3
#                           CN45                                    #   CN45   4
#                                                                   #   CN45   5
#####################################################################   CN45   6
SUBROUTINE CN45#                                                        CN45   7
include:(AACOMN)#                                                       CN45   8
include:(CNCOMN)#                                                       CN45   9
INTEGER PT1,PT1S,PT2,PT2S,PT3,PT3S#                                     CN45  10
INTEGER ICONS,NPT,REC,I#                                                CN45  11
REAL    A,XX(2)#                                                        CN45  12
#                                                                       CN45  13
#                                                                       CN45  14
REPEAT#                                Until no more curves             CN45  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN45  16
PT1S=-1#                                                                CN45  17
A=-999.#                               Initialize area                  CN45  18
FOR(ICON=1;ICON<=NCON;ICON=ICON+1)#    Loop over contour levels         CN45  19
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN45  20
PT1=MARK0+(ICON-1)*step0:#             Area sequence pointer            CN45  21
PT2=NINT(QX(PT1+1))#                   Curve sequence number            CN45  22
IF(PT2<0)NEXT#                         Flag no more curves for level    CN45  23
PT3=NINT(QX(PT1+2))+PT2*step2:#        Curve sequence number            CN45  24
IF(QX(PT3+3)<A)NEXT#                   Smaller so skip                  CN45  25
A= QX(PT3+3)#                          Save current largest area        CN45  26
PT1S=PT1#                              Save pointer to contour level    CN45  27
PT2S=PT2#                              Save curves left for level       CN45  28
PT3S=PT3#                              Save pointer to curve for leve   CN45  29
ICONS=ICON#                            Save level                       CN45  30
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN45  31
IF(PT1S<=0) BREAK#                     No curves so quit layer          CN45  32
ICON=ICONS#                            Set level                        CN45  33
PT1=PT1S;PT2=PT2S;PT3=PT3S#                                             CN45  34
PT2=PT2+1#                             Adjust to next curve             CN45  35
IF(PT3+step2:>=NINT(QX(PT1+3)))PT2=-1# End of the level list            CN45  36
QX(PT1+1)=FLOAT(PT2)#                  Curve sequence number            CN45  37
QXCUR=MARK3#                                                            CN45  38
NPT=NINT(QX(PT3+1))#                   Number of points to load         CN45  39
incrqx:(STOP4,MARK3+step3:*NPT,CN4501)#                                 CN45  40
REC=NINT(QX(PT3+2))#                   First direct access record       CN45  41
PT1=MARK3#                             Location of first loaded pnt     CN45  42
DO I=1,NPT#                            Load all points for curve        CN45  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN45  44
readdac:(ioda1:,,REC+I-1,XX)#          Read x,y                         CN45  45
QX(PT1+5)=XX(1)#                       Load x                           CN45  46
QX(PT1+6)=XX(2)#                       Load y                           CN45  47
PT1=PT1+step3:#                        Step to next point               CN45  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN45  49
MARK4=PT3#                                                              CN45  50
KCURV=1#                                                                CN45  51
CALL CN50#                             Plot this curve for level        CN45  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN45  53
#                                                                       CN45  54
#                                                                       CN45  55
RETURN#                                                                 CN45  56
END#                                                                    CN45  57
systemheader:(CN50)#                                                    CN50   1
#####################################################################   CN50   2
#                                                                   #   CN50   3
#                           CN50                                    #   CN50   4
#                                                                   #   CN50   5
#####################################################################   CN50   6
SUBROUTINE CN50#                                                        CN50   7
include:(AACOMN)#                                                       CN50   8
include:(CNCOMN)#                                                       CN50   9
#                                                                       CN50  10
INTEGER KOLOR#                                                          CN50  11
INTEGER NPLC,SL1,L3,SMUTH,ANEDGE#                                       CN50  12
INTEGER L1,L2,NPC,IPTX,K,IPTXL,IPTXK,IPTL,IPTF#                         CN50  13
INTEGER IPT,IPI,IPI1,IPI2,INCR,I,J,ONEDGE#                              CN50  14
REAL    XL1,YL1,TANG,DOT1,DOT2,P,Q,R,U,V,W,F,H,AX,AY,FPHU,BX,BY#        CN50  15
REAL    CX,CY,D0I,DI1,ALEN,DELT,T,XDES,YDES,X0I,XI1,Y0I,YI1#            CN50  16
REAL    FIRSTX,FIRSTY
intdata:(NEGC,[-2,-4,-1,-6])#          Negative fill colors             CN50  17
intdata:(POSC,[-2,-5,-3,-6])#          Positive fill colors             CN50  18
intdata:(NEND,0);    datastuff:#                                        CN50  19
#                                                                       CN50  20
# IF SMOOTHING IS REQUESTED AN ISOTROPIC FOUR-POINT ALGORITHM DUE       CN50  21
# TO J.E. MIDGLEY (COMPUTER GRAPHICS & IMAGE PROCESSING, 11, 192-196    CN50  22
# (1979)) IS EMPLOYED.  THE ALGORITHM MAKES THE DIRECTION OF THE        CN50  23
# CURVE AT EACH DATA POINT THAT OF A CIRCLE THROUGH THAT POINT AND      CN50  24
# TWO ADJACENT POINTS.  THE INTERPOLATION FORMULA CAN BE EXPRESSED AS   CN50  25
#                                                                       CN50  26
#      X(T) = X0 + AX * T + BX * T**2 + CX * T**3                       CN50  27
#      Y(T) = Y0 + AY * T + BY * T**2 + CY * T**3                       CN50  28
#                                                                       CN50  29
# WHERE THE CONSTANTS AX, AY ETC. ARE DETERMINED FROM THE X AND         CN50  30
# Y DIFFERENCES BETWEEN SUCCESSIVE POINTS, AND T IS A PARAMETRIC.       CN50  31
#                                                                       CN50  32
# THE 6-WORD PACKET STRUCTURE OF QX AFTER MARK3 IS STILL USED           CN50  33
# BUT THE CONTENTS OF THE FIRST FOUR WORDS OF EACH PACKET               CN50  34
# ARE NO LONGER NEEDED.  HOWEVER WE USE THE FIRST THREE                 CN50  35
# WORDS OF THE LOWER PACKETS HERE TO STORE DIFFERENCE                   CN50  36
# INFORMATION FOR SMOOTHING.                                            CN50  37
#                                                                       CN50  38
#    QX(IP+1) = DIFFERENCE BETWEEN SUCCESSIVE X-COORDS                  CN50  39
#    QX(IP+2) = DIFFERENCE BETWEEN SUCCESSIVE Y-COORDS                  CN50  40
#    QX(IP+3) = SQUARES OF DISTANCES BETWEEN SUCCESSIVE PTS             CN50  41
#                                                                       CN50  42
# WHERE THE PARTICULAR DIFFERENCES DEPEND ON WHETHER                    CN50  43
# THE CURVE IS CLOSED OR OPEN.                                          CN50  44
#                                                                       CN50  45
#    FILL APPROPRIATE DASH-GAP SEQUENCE                                 CN50  46
#    ----------------------------------                                 CN50  47
#                                     #                                 CN50  48
IF(LINTYP(ICON)==1)#                   Solid line                       CN50  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN50  50
NDGSEQ=1#                              One element                      CN50  51
DGSEQ(1)=0.0#                          Length set = 0.0                 CN50  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN50  53
ELSE IF(LINTYP(ICON)==0)#              Dashed line                      CN50  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN50  55
NDGSEQ=NDASH#                          Number of elements               CN50  56
movereal:(DASH,1,DGSEQ,1,NDGSEQ,0)#    Fill the sequence                CN50  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN50  58
ELSE IF(LINTYP(ICON)==-1)#             Dotted line                      CN50  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN50  60
NDGSEQ=NDOT#                           Number of elements               CN50  61
movereal:(DOT,1,DGSEQ,1,NDGSEQ,0)#     Fill the sequence                CN50  62
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN50  63
ifeq:(CONT(ICON),0.0) COLOR=-2#        Zero contour levels              CN50  64
ELSE IF(CONT(ICON)<0.0) COLOR=-1#      Negative levels                  CN50  65
ELSE IF(CONT(ICON)>0.0) COLOR=-3#      Positive levels                  CN50  66
IF(MULCOL==yes:) COLOR=-ICON-7#        Override the colors              CN50  67
IF(COLOR!=OLDCOL)#                     Change subject                   CN50  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CN50  69
OLDCOL=COLOR#                          Change old colour                CN50  70
IPEN=3#                                Put pen up                       CN50  71
COLOR=0#                               Zero colour index                CN50  72
CALL CN03(QX(MARK3+5),QX(MARK3+6),3)#  Change subject (colour)          CN50  73
COLOR=OLDCOL#                          Reset colour index               CN50  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CN50  75
#                                                                       CN50  76
#    LOOP OVER THE CURVES                                               CN50  77
#    --------------------                                               CN50  78
#                                                                       CN50  79
FIRSTX=QX(MARK3+1)#                    Save before overwriting
FIRSTY=QX(MARK3+2)#                    Save before overwriting
L2=0#                                  Zero last point counter          CN50  80
DO J=1,KCURV#                          Loop over all curves             CN50  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CN50  82
L1=L2+1#                               First point of this curve        CN50  83
SL1=L1#                                Save l1 position                 CN50  84
NPC=NINT(QX(MARK4+(J-1)*step4:+1))#    No. of pts for this curve        CN50  85
L2=NPC+SL1-1#                          Last point of curve              CN50  86
IF(NPC<=2) NEXT#                       If only 2 pts don't plot         CN50  87
ONEDGE=no:#                            Default to closed curve          CN50  88
NPLC=NPC#                              Number of points on local curv   CN50  89
#                                                                       CN50  90
#    BEGIN PLOTTING THIS CURVE                                          CN50  91
#    -------------------------                                          CN50  92
#                                                                       CN50  93
IDGSEQ=1#                              Initialize dash-gap element      CN50  94
DIST=0.0#                              Zero distances for               CN50  95
DNEXT=0.0#                             This curve                       CN50  96
IPTX=MARK3+(L1-1)*step3:#              Pointer to l1 point              CN50  97
XCUR=QX(IPTX+5)#                       Coords of current                CN50  98
YCUR=QX(IPTX+6)#                       Pen location                     CN50  99
IPEN=3#                                Put pen up                       CN50 100
OLDCOL=COLOR;COLOR=0#                  Change old colour                CN50 101
CALL CN03(XCUR,YCUR,3)#                Move with pen up                 CN50 102
COLOR=OLDCOL#                          Change old colour                CN50 103
IPEN=2#                                Put pen down                     CN50 104
#                                                                       CN50 105
#   LOOP OVER CONTINUOUS PARTS OF CURVE                                 CN50 106
#   -----------------------------------                                 CN50 107
#                                                                       CN50 108
L3=L1-1#                                                                CN50 109
REPEAT#                                For curved and linear parts      CN50 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CN50 111
REPEAT#                                Until we hit an edge             CN50 112
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CN50 113
L3=L3+1#                               Increment pointer                CN50 114
IPTX=MARK3+(L3-1)*step3:#              Pointer to l1 point              CN50 115
XL1=QX(IPTX+5)#                        X-coord of l1 point              CN50 116
YL1=QX(IPTX+6)#                        Y-coord of l1 point              CN50 117
ANEDGE=no:#                            Initialize                       CN50 119
IF(ABS(COSG)<.0001)#                   Rectangular border               CN50 120
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CN50 121
IF     (ABS(XL1-XLOW)<.0001) ANEDGE=yes:# Conditions for open           CN50 122
ELSE IF(ABS(XL1-XUPP)<.0001) ANEDGE=yes:# Curve are checked             CN50 123
ELSE IF(ABS(YL1-YLOW)<.0001) ANEDGE=yes:# I.e. curve begins on          CN50 124
ELSE IF(ABS(YL1-YUPP)<.0001) ANEDGE=yes:# A border of the map           CN50 125
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CN50 126
ELSE IF(ABS(COSG)>.0001)#              Skewed border                    CN50 127
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CN50 128
TANG=SING/COSG#                        Get tan(gamma)                   CN50 129
IF     (ABS(YL1-YLOW)<.0001) ANEDGE=yes:# Conditions for open           CN50 130
ELSE IF(ABS(YL1-YUPP)<.0001) ANEDGE=yes:# Curves are checked            CN50 131
ELSE IF(ABS(YL1-YLOW-(XL1-XLOW)*TANG)<.0001) ANEDGE=yes:#               CN50 132
ELSE IF(ABS(YL1-YLOW-(XL1-XLOW-XLS)*TANG)<.0001) ANEDGE=yes:#           CN50 133
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CN50 134
IF(ANEDGE==yes:)ONEDGE=yes:#           If an edge was found             CN50 135
#IF(ONEDGE==no:)BREAK#                 A complete closed continuous l   CN50 136
IF(ANEDGE==yes:& L3!=SL1)BREAK#        Twice on first loop              CN50 137
IF(L3==NPC+SL1-1)BREAK#                Out of points now     
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CN50 138
IF(SMOOTH==yes:)SMUTH=yes:#            Switch on                        CN50 139
ELSE            SMUTH=no:#             Unless not requested             CN50 140
IF(ANEDGE==no:)#                       assumed to be a closed loop
IF(ABS(FIRSTX-QX(MARK3+(L3-1)*step3:+1))>1.0 \# check the terminal points 
   ABS(FIRSTY-QX(MARK3+(L3-1)*step3:+2))>1.0)# not sufficiently close
$(
ONEDGE=yes:#                           treat as an edge intersection
$)
FIRSTX=QX(MARK3+L3*step3:+1)#          save first of next section
FIRSTY=QX(MARK3+L3*step3:+2)#          save first of next section
#
IF(ONEDGE==yes:)#                      Curve intersects map edge        CN50 141
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CN50 142
L2=L3#                                                                  CN50 143
IF(L2==L1+1)SMUTH=no:#                 Only 1 point so no smoothing     CN50 144
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CN50 145
ELSE L2=NPC+SL1-1#                     Last point of curve              CN50 146
NPLC=L2-L1+1#                          Number of points on local curv   CN50 147
#                                                                       CN50 148
#    SMOOTHING IS TO BE PERFORMED                                       CN50 149
#    ----------------------------                                       CN50 150
#                                                                       CN50 151
IF(SMUTH==yes:)#                       Smoothing is required            CN50 152
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CN50 153
#                                                                       CN50 154
#    FILL ARRAYS FOR DIFFERENCES                                        CN50 155
#    ---------------------------                                        CN50 156
#                                                                       CN50 157
# ALWAYS USE LOWER PORTION OF LIST OF POINTS                            CN50 158
# AND SO AVOID OVERWRITING AT THE TOP                                   CN50 159
#                                                                       CN50 160
DO K=2,NPLC#                           Loop over pts for this curve     CN50 161
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CN50 162
IPTXL=MARK3+(L1+K-2)*step3:#           Pointer to k'th point            CN50 163
IPTXK=MARK3+(K-1)*step3:#              Pointer to store diffs           CN50 164
QX(IPTXK+1)=QX(IPTXL+5)-QX(IPTXL-1)#   X-difference                     CN50 165
QX(IPTXK+2)=QX(IPTXL+6)-QX(IPTXL)#     Y-difference                     CN50 166
QX(IPTXK+3)=QX(IPTXK+1)*QX(IPTXK+1)+QX(IPTXK+2)*QX(IPTXK+2)#            CN50 167
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CN50 168
IF(ONEDGE==no:)#                       Curve is closed                  CN50 169
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CN50 170
IPTL=MARK3+(L2-1)*step3:#              Last point in list               CN50 171
IPTF=MARK3+(L1-1)*step3:#              First point in list              CN50 172
QX(MARK3+1)=QX(IPTF+5)-QX(IPTL+5)#     1st x-coord diff.                CN50 173
QX(MARK3+2)=QX(IPTF+6)-QX(IPTL+6)#     1st y-coord diff.                CN50 174
QX(MARK3+3)=QX(MARK3+1)*QX(MARK3+1)+QX(MARK3+2)*QX(MARK3+2)#            CN50 175
IPTL=MARK3+NPLC*step3:#                Top of list +1                   CN50 176
QX(IPTL+1)=QX(MARK3+1)#                Point npc+1 is set               CN50 177
QX(IPTL+2)=QX(MARK3+2)#                Equal to point 1                 CN50 178
QX(IPTL+3)=QX(MARK3+3)#                                                 CN50 179
QX(IPTL+7)=QX(MARK3+7)#                Point npc+2 is set               CN50 180
QX(IPTL+8)=QX(MARK3+8)#                Equal to point 2                 CN50 181
QX(IPTL+9)=QX(MARK3+9)#                                                 CN50 182
NEND=NPLC#                             No. of point differences         CN50 183
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CN50 184
ELSE IF(ONEDGE==yes:)#                 Curve is open                    CN50 185
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CN50 186
IPT=MARK3+step3:#                      Pointer to 2nd point             CN50 187
DOT1=2.*(QX(IPT+1)*QX(IPT+7)+QX(IPT+2)*QX(IPT+8))/QX(IPT+3)#            CN50 188
QX(IPT-5)=DOT1*QX(IPT+1)-QX(IPT+7)#    Fill pt diffs                    CN50 189
QX(IPT-4)=DOT1*QX(IPT+2)-QX(IPT+8)#                                     CN50 190
QX(IPT-3)=QX(IPT-5)*QX(IPT-5)+QX(IPT-4)*QX(IPT-4)# Distance             CN50 191
IPT=MARK3+(NPLC-1)*step3:#             Pointer to top of list           CN50 192
DOT2=2.*(QX(IPT+1)*QX(IPT-5)+QX(IPT+2)*QX(IPT-4))/QX(IPT+3)#            CN50 193
QX(IPT+7)=DOT2*QX(IPT+1)-QX(IPT-5)#    Fill pt diffs                    CN50 194
QX(IPT+8)=DOT2*QX(IPT+2)-QX(IPT-4)#                                     CN50 195
QX(IPT+9)=QX(IPT+7)*QX(IPT+7)+QX(IPT+8)*QX(IPT+8)# Distance             CN50 196
NEND=NPLC-1#                           No. of pt diffs                  CN50 197
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CN50 198
#                                                                       CN50 199
#    LOOP OVER PAIRS OF POINTS                                          CN50 200
#    -------------------------                                          CN50 201
#                                                                       CN50 202
IPI=0;IPI1=0;IPI2=MARK3-step3:#        set three initial points
FOR(I=1;I<=NEND+2;I=I+1)#              two extra steps
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 
IPI=IPI1; IPI1=IPI2;IPI2=IPI2+step3:#  pointers to pints i,i+1,i+2
IPTX=MARK3+(L1-1+(IPI-MARK3)/step3:)*step3:# Pointer to cartesian coord 
repeat#                                skip spurious identical points
$(
ifne:(qx(IPI2+1),0.0) break#           dx<>0.0 
ifne:(qx(IPI2+2),0.0) break#           dy<>0.0
I=I+1; IPI2=IPI2+step3:#               dx=dy=0.0 so skip
IF(I==NEND+2) goto 200#                nothing we can do so finish here
$)
IF(I<3) NEXT#                          first three points are essential
P=QX(IPI+3)/QX(IPI1+3)#                Obtain preliminary constants     CN50 208
Q=(QX(IPI+1)*QX(IPI1+1)+QX(IPI+2)*QX(IPI1+2))/QX(IPI1+3)#               CN50 209
R=SQRT(P*P+2.*P*Q+P)#                  See midgley for details          CN50 210
U=QX(IPI2+3)/QX(IPI1+3)#                                                CN50 211
V=(QX(IPI2+1)*QX(IPI1+1)+QX(IPI2+2)*QX(IPI1+2))/QX(IPI1+3)#             CN50 212
W=SQRT(U*U+2.*U*V+U)#                                                   CN50 213
F=2./(P+Q+R)#                                                           CN50 214
H=2./(U+V+W)#                                                           CN50 215
AX=F*(QX(IPI+1)+P*QX(IPI1+1))#         Linear coeff for x               CN50 216
AY=F*(QX(IPI+2)+P*QX(IPI1+2))#         Linear coeff for y               CN50 217
FPHU=3.-2.*F*P-H*U#                                                     CN50 218
BX=-2.*F*QX(IPI+1)+FPHU*QX(IPI1+1)-H*QX(IPI2+1)# Quadratic coeff x      CN50 219
BY=-2.*F*QX(IPI+2)+FPHU*QX(IPI1+2)-H*QX(IPI2+2)# Quadratic coeff y      CN50 220
FPHU=-2.+F*P+H*U#                                                       CN50 221
CX=F*QX(IPI+1)+FPHU*QX(IPI1+1)+H*QX(IPI2+1)# Cubic coeff for x          CN50 222
CY=F*QX(IPI+2)+FPHU*QX(IPI1+2)+H*QX(IPI2+2)# Cubic coeff for y          CN50 223
#                                                                       CN50 224
#    ESTIMATE LENGTH OF ARC TO BE PLOTTED                               CN50 225
#    ------------------------------------                               CN50 226
#                                                                       CN50 227
X0I=AX+.5*BX+.25*CX#                   Delta-x to mid point             CN50 228
Y0I=AY+.5*BY+.25*CY#                   Delta-y to mid point             CN50 229
XI1=AX+1.5*BX+1.75*CX#                 Delta-x from mid pt to end       CN50 230
YI1=AY+1.5*BY+1.75*CY#                 Delta-y from mid pt to end       CN50 231
D0I=SQRT(X0I*X0I+Y0I*Y0I)#             Distance to mid pt               CN50 232
DI1=SQRT(XI1*XI1+YI1*YI1)#             Dist from mid pt to end          CN50 233
ALEN=(D0I+DI1)/RESOL#                  Length of arc                    CN50 234
INCR=INT(ALEN)#                        No. of t increments              CN50 235
IF(INCR<=0) INCR=1#                    At least one increment           CN50 236
DELT=1./FLOAT(INCR)#                   Incr. in parametric t            CN50 237
T=0.0#                                 Zero parametric                  CN50 238
DO K=1,INCR#                           Loop over t increments           CN50 240
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CN50 241
T=T+DELT#                              Increment t                      CN50 242
XDES=((CX*T+BX)*T+AX)*T+QX(IPTX+5)#    X-coord to plot                  CN50 243
YDES=((CY*T+BY)*T+AY)*T+QX(IPTX+6)#    Y-coord to plot                  CN50 244
CALL CN51(XDES,YDES)#                  Plot this line via dash          CN50 245
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CN50 246
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CN50 247
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CN50 248
#                                                                       CN50 249
#    PLOT LINES WITHOUT SMOOTHING                                       CN50 250
#    ----------------------------                                       CN50 251
#                                                                       CN50 252
ELSE IF(SMUTH==no:)#                   No smoothing desired             CN50 253
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CN50 254
FOR(I=L1+1 ; I<=L2 ; I=I+1)#           Loop over points for curve       CN50 255
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CN50 256
IPI=MARK3+(I-1)*step3:#                Pointer to i'th point            CN50 257
XDES=QX(IPI+5)#                        X-coord to plot                  CN50 258
YDES=QX(IPI+6)#                        Y-coord to plot                  CN50 259
CALL CN51(XDES,YDES)#                  Plot this line via dash          CN50 260
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CN50 261
IF(ONEDGE==no:)#                       Close the curve                  CN50 262
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CN50 263
IPTF=MARK3+(L1-1)*step3:#              Last pt in list                  CN50 264
XDES=QX(IPTF+5)#                       X-destination                    CN50 265
YDES=QX(IPTF+6)#                       Y-destination                    CN50 266
CALL CN51(XDES,YDES)#                  Plot this last line              CN50 267
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CN50 268
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CN50 269
#                                                                       CN50 270
200 CONTINUE
L1=L2#                                                                  CN50 271
L3=L1#                                                                  CN50 272
IF(L1==NPC+SL1-1)BREAK#                Last point of current curve      CN50 273
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CN50 274
#                                                                       CN50 275
KOLOR=COLOR;COLOR=0;#                  Change the color                 CN50 276
IPEN=3#                                                                 CN50 277
CALL CN03(XDES,YDES,3)#                Plot dummy null pen up point     CN50 278
COLOR=KOLOR#                           Change the color back            CN50 279
#IPEN=2                                                                 CN50 280
#                                                                       CN50 281
#                                                                       CN50 282
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CN50 283
#                                                                       CN50 284
RETURN#                                                                 CN50 285
END#                                                                    CN50 286
systemheader:(CN51)#                                                    CN51   1
#####################################################################   CN51   2
#                                                                   #   CN51   3
#                           CN51                                    #   CN51   4
#                                                                   #   CN51   5
#####################################################################   CN51   6
SUBROUTINE CN51(XDES,YDES)#                                             CN51   7
include:(CNCOMN)#                                                       CN51   8
#                                                                       CN51   9
# DRAWS DASHED LINES OF ARBITRARY DASH-GAP SEQUENCES                    CN51  10
# DETERMINED BY DGSEQ, NDGSEQ AND IDGSEQ IN (CNCOMN).                   CN51  11
# BEFORE THE FIRST CALL TO CN51 ON ANY CURVE OF A                       CN51  12
# CONTOUR ZERO DIST & DNEXT AND SET IDGSEQ=1 AND IPEN=2.                CN51  13
#                                                                       CN51  14
REAL XDES,YDES,D,DVT,DD,F,XP,YP#                                        CN51  15
#                                                                       CN51  16
#    SOLID LINES ONLY                                                   CN51  17
#    ----------------                                                   CN51  18
#                                                                       CN51  19
IF(DGSEQ(1)<=0.0)#                     Solid lines only                 CN51  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN51  21
CALL CN03(XDES,YDES,3)#                Plot this line segment           CN51  22
XCUR=XDES#                             Update the current point         CN51  23
YCUR=YDES#                                                              CN51  24
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN51  25
#                                                                       CN51  26
#    DASHED OR DOTTED LINES                                             CN51  27
#    ----------------------                                             CN51  28
#                                                                       CN51  29
ELSE IF(DGSEQ(1)>0.0)#                 Dashed or dotted lines           CN51  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN51  31
D=SQRT((XDES-XCUR)*(XDES-XCUR)+(YDES-YCUR)*(YDES-YCUR))# Dist to move   CN51  32
DVT=DIST+D#                            Add to dist travelled            CN51  33
REPEAT#                                                                 CN51  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN51  35
IF(DVT<=DNEXT) BREAK#                  Exit if dvt short                CN51  36
DD=DNEXT-DIST#                         How much longer ?                CN51  37
F=DD/D#                                Form as a fraction               CN51  38
XP=F*(XDES-XCUR)+XCUR#                 Determine x-coord                CN51  39
YP=F*(YDES-YCUR)+YCUR#                 Determine y-coord                CN51  40
CALL CN03(XP,YP,3)#                    Plot(xp,yp)                      CN51  41
XCUR=XP; YCUR=YP#                      Update the current point         CN51  42
IPEN=MOD(IPEN+1,2)+2#                  Change ipen                      CN51  43
IDGSEQ=IDGSEQ+1#                       Move to next element             CN51  44
IF(IDGSEQ>NDGSEQ)IDGSEQ=1#             Restart the sequence             CN51  45
DIST=DNEXT#                            Reset dist travelled             CN51  46
D=D-DD#                                Decrement d                      CN51  47
DNEXT=DNEXT+DGSEQ(IDGSEQ)#             Add next element                 CN51  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN51  49
CALL CN03(XDES,YDES,3)#                Complete the operation           CN51  50
DIST=DIST+D#                           Increment dist                   CN51  51
XCUR=XDES#                             Update the current point         CN51  52
YCUR=YDES#                                                              CN51  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN51  54
#                                                                       CN51  55
RETURN#                                                                 CN51  56
END#                                                                    CN51  57
systemheader:(CN90)#                                                    CN90   1
#####################################################################   CN90   2
#                                                                   #   CN90   3
#                           CN90                                    #   CN90   4
#                                                                   #   CN90   5
#####################################################################   CN90   6
SUBROUTINE CN90#                       V.a. streltsov 1992              CN90   7
include:(AACOMN)#                                                       CN90   8
include:(CNCOMN)#                                                       CN90   9
#                                                                       CN90  10
INTEGER I,J,IPTX#                                                       CN90  11
REAL    X,X0,X1,X2,X3,X4,Y,Y0,Y1,Y2,Y3,Y4,Z,ZS#                         CN90  12
REAL    DY1,DY2,SC,VLEN,BET,ALF1,ALF2#                                  CN90  13
realdata:(ANGL,[0.20421957])#          Angle for arrow head             CN90  14
realdata:(COSA,[0.68081429])#                                           CN90  15
realdata:(PIT, [1.57079633])#          Pi/2                             CN90  16
datastuff:#                                                             CN90  17
#                                                                       CN90  18
IF(DX > DY) SC = DX/EMAX#              Scale factor                     CN90  19
ELSE        SC = DY/EMAX#              Scale factor                     CN90  20
SC=SCARR*SC#                           Just a bit more                  CN90  21
NDGSEQ=1#                              One element                      CN90  22
DGSEQ(1)=0.0#                          Length set = 0.0                 CN90  23
ZS=(ZMAX+ABS(ZMIN))/14.#               Step for color                   CN90  24
DY1=-DY*COSG ; DY2=-DY*SING#           Y-vector translation             CN90  25
X0=XUPP-XLS ; Y0=YUPP#                 Origin at top l.h. corner        CN90  26
IPTX=MARK1+1#                          Pointer to first component       CN90  27
DO J=1,NY#                             Loop over rows                   CN90  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN90  29
DO I=1,NX#                             Loop over row elements           CN90  30
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN90  31
X=X0+FLOAT(I-1)*DX+FLOAT(J-1)*DY1#     X-coordinate                     CN90  32
Y=Y0+FLOAT(J-1)*DY2#                   Y-coordinate                     CN90  33
X1= SC*QX(IPTX+2)#                     X component (across)             CN90  34
Y1=-SC*QX(IPTX+1)#                     Y component (down)               CN90  35
Z=QX(IPTX)#                            Z component (layer)              CN90  36
IF(ROTATE==yes:)#                      Rotate axes                      CN90  37
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN90  38
X2=X1; X1=Y1; Y1=-X2#                  Swap coordinates                 CN90  39
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN90  40
IPTX=IPTX+3#                           Pointer                          CN90  41
X2=X+X1#                               X-coordinate of arrow            CN90  42
Y2=Y+Y1#                               Y-coordinate of arrow            CN90  43
IF(X2<=X0\X2>=XUPP\Y2>=Y0\Y2<=YLOW) NEXT# Test for border limits        CN90  44
IF(Z<-5.*ZS)                COLOR=-6#  Negative z for purple            CN90  45
ELSE IF(Z<-3.*ZS&Z>=-5.*ZS) COLOR=-1#  Negative z for red               CN90  46
ELSE IF(Z<   -ZS&Z>=-3.*ZS) COLOR=-4#  Negative z for yellow            CN90  47
ELSE IF(ABS(Z)<=ZS)         COLOR=-7#  Zero z for white color           CN90  48
ELSE IF(Z>    ZS&Z<= 3.*ZS) COLOR=-2#  Positive z for green             CN90  49
ELSE IF(Z> 3.*ZS&Z<= 5.*ZS) COLOR=-5#  Positive z for sky-blue          CN90  50
ELSE IF(Z> 5.*ZS)           COLOR=-3#  Positive z for blue              CN90  51
IF(COLOR!=OLDCOL)#                     Change subject                   CN90  52
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CN90  53
OLDCOL=COLOR#                          Change old color                 CN90  54
COLOR=0#                               Zero color index                 CN90  55
IPEN=3#                                Put pen up                       CN90  56
CALL CN03(X,Y,3)#                      Change subject (color)           CN90  57
COLOR=OLDCOL#                          Reset color index                CN90  58
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CN90  59
ELSE#                                  Don't change subject             CN90  60
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CN90  61
IPEN=3#                                Put pen up                       CN90  62
CALL CN03(X,Y,3)#                      Move to grid point               CN90  63
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CN90  64
IPEN=2#                                Pen down                         CN90  65
CALL CN03(X2,Y2,3)#                    Draw arrow                       CN90  66
VLEN=SQRT(X1*X1+Y1*Y1)#                Length of vector projection      CN90  67
IF(VLEN<PLOTX*.002) VLEN=PLOTX*.002#   Minimum arrow length on the ma   CN90  68
VLEN=VLEN*COSA#                        Projection of arrow              CN90  69
IF(X1!=0.0) BET=ATAN(ABS(Y1/X1))#      Angle between arrow and x-axis   CN90  70
ELSE BET=PIT#                          90 degree angle                  CN90  71
IF(BET >= ANGL & BET+ANGL <= PIT)#     Check arrow direction            CN90  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CN90  73
ALF1=BET+ANGL; ALF2=BET-ANGL#          Projection angles for arrow he   CN90  74
X3=X+SIGN(VLEN*COS(ALF1),X1)#          X-coordinate of r.h. part ----   CN90  75
Y3=Y+SIGN(VLEN*SIN(ALF1),Y1)#          Y-coordinate of r.h. part ----   CN90  76
X4=X+SIGN(VLEN*COS(ALF2),X1)#          X-coordinate of l.h. part ____   CN90  77
Y4=Y+SIGN(VLEN*SIN(ALF2),Y1)#          Y-coordinate of l.h. part ____   CN90  78
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CN90  79
IF(BET < ANGL)#                        Test for angles                  CN90  80
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CN90  81
ALF1=BET+ANGL; ALF2=ANGL-BET#          As above                         CN90  82
X3=X+SIGN(VLEN*COS(ALF1),X1)#                                           CN90  83
Y3=Y+SIGN(VLEN*SIN(ALF1),Y1)#                                           CN90  84
X4=X+SIGN(VLEN*COS(ALF2),X1)#                                           CN90  85
Y4=Y-SIGN(VLEN*SIN(ALF2),Y1)#                                           CN90  86
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CN90  87
IF(BET+ANGL > PIT)#                    Test for angles                  CN90  88
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CN90  89
ALF1=BET+ANGL-PIT; ALF2=BET-ANGL#      As above                         CN90  90
X3=X-SIGN(VLEN*SIN(ALF1),X1)#                                           CN90  91
Y3=Y+SIGN(VLEN*COS(ALF1),Y1)#                                           CN90  92
X4=X+SIGN(VLEN*COS(ALF2),X1)#                                           CN90  93
Y4=Y+SIGN(VLEN*SIN(ALF2),Y1)#                                           CN90  94
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CN90  95
CALL CN03(X3,Y3,3)#                    Draw r.h. part of head ----/     CN90  96
IPEN=3#                                Pen up                           CN90  97
CALL CN03(X2,Y2,3)#                    Move to top of arrow             CN90  98
IPEN=2#                                Pen down                         CN90  99
CALL CN03(X4,Y4,3)#                    Draw l.h. part of head ____\     CN90 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN90 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN90 102
RETURN#                                                                 CN90 103
END#                                                                    CN90 104
systemheader:(CN60)#                                                    CN60   1
#####################################################################   CN60   2
#                                                                   #   CN60   3
#                           CN60                                    #   CN60   4
#                                                                   #   CN60   5
#####################################################################   CN60   6
SUBROUTINE CN60#                                                        CN60   7
include:(AACOMN)#                                                       CN60   8
include:(CNCOMN)#                                                       CN60   9
#                                                                       CN60  10
INTEGER I,J#                                                            CN60  11
REAL    DELX,DY1,DY2,GAMMA,SX,SY,X,Y,X0,Y0#                             CN60  12
REAL    CODE,POS,SIZE,VAL#                                              CN60  13
#                                                                       CN60  14
chardata:(CN6A,[          X-AXIS =       , Y-AXIS =       ,$#           CN60  15
 GAMMA =       , LAYER =     ])#                                        CN60  16
chardata:(CN6B,S   -  )#                                                CN60  17
datastuff:#                                                             CN60  18
#                                                                       CN60  19
#    PLOT THE BORDER                                                    CN60  20
#    ---------------                                                    CN60  21
#                                                                       CN60  22
IF(BORDER==yes:)#                      Plot border of the map           CN60  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN60  24
IPEN=3#                                Pen up                           CN60  25
COLOR=0#                               Zero colour index                CN60  26
CALL CN03(XLOW,YLOW,3)#                Change of subject (colour)       CN60  27
COLOR=-6000#                           Change to border color           CN60  28
IPEN=2#                                Pen down                         CN60  29
CALL CN03(XLOW,YLOW,3)#                Move to bottom l.h. corner       CN60  30
CALL CN03(XLOW+XLS,YLOW,3)#            Draw to bottom r.h.              CN60  31
filling:(XLOW+XLS,YLOW)#               Pen up pen down                  CN60  32
CALL CN03(XUPP,YUPP,3)#                Top r.h. corner                  CN60  33
filling:(XUPP,YUPP)#                   Pen up pen down                  CN60  34
CALL CN03(XUPP-XLS,YUPP,3)#            Top l.h.corner                   CN60  35
filling:(XUPP-XLS,YUPP)#               Pen up pen down                  CN60  36
CALL CN03(XLOW,YLOW,3)#                Return to bot l.h.               CN60  37
filling:(XLOW,YLOW)#                   Pen up pen down                  CN60  38
IPEN=3#                                Pen up                           CN60  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN60  40
#                                                                       CN60  41
#    PLOT THE MESH POINTS AS SMALL CROSSES                              CN60  42
#    -------------------------------------                              CN60  43
#                                                                       CN60  44
IF(MESH==yes:)#                        Plot mesh pts                    CN60  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN60  46
DY1=-DY*COSG ; DY2=-DY*SING#           Y-vector translation             CN60  47
X0=XUPP-XLS ; Y0=YUPP#                 Origin at top l.h. corner        CN60  48
SX=PLOTX*.002#                         X-size of small cross            CN60  49
SY=PLOTY*.002#                         Y-size of small cross            CN60  50
DELX=SY*COSG/SING#                     Small offset for skew maps       CN60  51
DO J=1,NY#                             Loop over rows                   CN60  52
DO I=1,NX#                             Loop over row elements           CN60  53
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN60  54
X=X0+FLOAT(I-1)*DX+FLOAT(J-1)*DY1#     X-coordinate                     CN60  55
Y=Y0+FLOAT(J-1)*DY2#                   Y-coordinate                     CN60  56
IPEN=3#                                Pen up                           CN60  57
COLOR=0#                                                                CN60  58
CALL CN03(X-SX,Y,3)#                   Move to l.h. side                CN60  59
IPEN=2#                                Pen down                         CN60  60
COLOR=-7#                              Change to white (black) crosse   CN60  61
CALL CN03(X+SX,Y,3)#                   Draw to r.h. side                CN60  62
IPEN=3#                                Pen up                           CN60  63
COLOR=0#                                                                CN60  64
CALL CN03(X+DELX,Y+SY,3)#              Move to top                      CN60  65
IPEN=2#                                Pen down                         CN60  66
COLOR=-7#                              Change to white (black) crosse   CN60  67
CALL CN03(X-DELX,Y-SY,3)#              Draw to bottom                   CN60  68
IPEN=3#                                Pen up again                     CN60  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN60  70
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN60  71
#                                                                       CN60  72
#    CONSTRUCT AND OUTPUT THE TITLE                                     CN60  73
#   -------------------------------                                     CN60  74
#                                                                       CN60  75
GAMMA=ACOS(COSG)*57.2957795#           Interaxial angle                 CN60  76
ncodefld:(XL,1,CN6A,250732.,1)#        Encode x-length                  CN60  77
ncodefld:(YL,1,CN6A,420732.,1)#        Encode y-length                  CN60  78
ncodefld:(GAMMA,1,CN6A,580722.,1)#     Encode interaxial angle          CN60  79
IF(SUPER==no:) ncodefld:(FLOAT(LAYER),1,CN6A,700313.,1)# Layer number   CN60  80
ELSE IF(SUPER==yes:)#                  Encode extra text                CN60  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CN60  82
ncodefld:(FLOAT(FLAYER),1,CN6B,40213.,1)# Encode first layer            CN60  83
ncodefld:(FLOAT(LLAYER),1,CN6B,70213.,1)# Encode last layer             CN60  84
movechar:(CN6B,1,CN6A,66,NCN6B,0)#     Stuff into cn6a                  CN60  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CN60  86
movechar:(CN6A,1,STRING,1,NCN6A,0)#    Stuff into string                CN60  87
movechar:(COMPID,1,STRING,1,6,0)#      Include compid                   CN60  88
NSTRIN=MAX(72,NCN6A)#                  No. of chars                     CN60  89
COLOR=-5000#                           Change to character colour       CN60  90
CALL CN03(0.50,3.*HEIGHT*XL/YL,5)#     Output the plot details          CN60  91
movechar:(TITLE,56,STRING,1,72,0)#     Stuff title card into string     CN60  92
NSTRIN=72#                             Output 72 characters             CN60  93
CALL CN03(0.50,HEIGHT,5)#              Plot the title output            CN60  94
#                                                                       CN60  95
#   FORMAT AND OUTPUT ORIENTATION VECTORS                               CN60  96
#   -------------------------------------                               CN60  97
#                                                                       CN60  98
DO I=1,2#                              For y and x directions           CN60  99
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CN60 100
POS=0.#                                Start of string                  CN60 101
DO J=1,3#                              Cycle over components            CN60 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CN60 103
VAL=ORIENT(I*3+J)#                     Get component  jj                CN60 104
SIZE=2.;CODE=13.#                      Min chars assumed integer        CN60 105
IF (VAL<0.0) SIZE=3.#                  Allow for minus sign             CN60 106
ifne:(VAL,0.0,0.1)SIZE=SIZE+AINT(LOG10(ABS(VAL)))# Get unit places      CN60 107
ifne:(FLOAT(NINT(VAL)),VAL,0.0099999)# Non integer number               CN60 108
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CN60 109
SIZE=SIZE+3.#                          Allow for 2 decimal places       CN60 110
ifeq:(VAL,0.,0.99)SIZE=SIZE-1.#        Delete unit (0) position         CN60 111
CODE=22.#                              Format is real type              CN60 112
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CN60 113
POS=POS+SIZE#                          Position of number in string     CN60 114
CODE=CODE+(SIZE)*100.+POS*10000.#      Construct formating code         CN60 115
ncodefld:(VAL,1,STRING,CODE,1)#        Encode vect component in strin   CN60 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CN60 117
NSTRIN=NINT(POS)+9#                    No. of chars                     CN60 118
movechar:('[',1,STRING,1,1,0)#         Initial vector bracket           CN60 119
movechar:('] ------>',1,STRING,NINT(POS)+1,9,0)# Close vector bracket   CN60 120
COLOR=-5000#                           Change to character colour       CN60 121
IF(I==1)#                              Y axis is up the page            CN60 122
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CN60 123
THETA=GAMMA#                           Incline vector text              CN60 124
CALL CN03(XLOW+HEIGHT*2.828*COS(GAMMA/57.29+.785),YLOW+2.*HEIGHT,5)#    CN60 125
THETA=0.#                              Reset printing angle             CN60 126
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CN60 127
ELSE CALL CN03(XLOW+HEIGHT*2.,YLOW-2.*HEIGHT,5)# Plot orient vector     CN60 128
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CN60 129
#                                                                       CN60 130
RETURN#                                                                 CN60 131
END#                                                                    CN60 132
systemheader:(CN70)#                                                    CN70   1
#####################################################################   CN70   2
#                                                                   #   CN70   3
#                           CN70                                    #   CN70   4
#                                                                   #   CN70   5
#####################################################################   CN70   6
SUBROUTINE CN70#                                                        CN70   7
include:(AACOMN)#                                                       CN70   8
include:(CNCOMN)#                                                       CN70   9
#                                                                       CN70  10
INTEGER J,K,NBLNK,IL,SAME,JJ#                                           CN70  11
REAL    SX,X,Y,Z,X0,Y0,XP,YP,XP1,YP1,ZLAYER,CODE,ZHI,ZLO#               CN70  12
REAL    X1,X2,Y1,Y2,Z1,Z2,XP2,YP2,BLEN
string:(NAME1,24);  string:(NAME2,24)#                                  CN70  13
#                                                                       CN70  14
chardata:(CNH7, SUMMARY OF ATOMS FOUND NEAR THE MAP)#                   CN70  15
chardata:(CNH8, -----------------------------------)#                   CN70  16
chardata:(CN7A, X AND Y ARE PARALLEL TO THE EDGES OF THE MAP)#          CN70  17
chardata:(CN7B, AND ARE MEASURED FROM THE TOP LEFT CORNER.)#            CN70  18
chardata:(CN7C, Z IS THE DISTANCE FROM THE NUMBERED LAYER )#            CN70  19
chardata:(CN7D, PARALLEL TO THE LAYER AXIS.  ALL ARE IN ANGSTROMS.)#    CN70  20
chardata:(CN7E,          ATOM       SYMOP)#                             CN70  21
chardata:(CN7F,          NAME      NUMBER       X       Y       Z)#     CN70  22
chardata:(IBLNK, )#                                                     CN70  23
chardata:(CNLA, LAYER   )#                                              CN70  24
datastuff:#                                                             CN70  25
#                                                                       CN70  26
X0=XUPP-XLS; Y0=YUPP#                  Origin at top l.h. corner        CN70  27
SX=HEIGHT/2.0#                         Size of crosses to plot          CN70  28
#                                                                       CN70  29
#    GET LIMITS FOR LAYER AND LOOP OVER ATOMS                           CN70  30
#    ----------------------------------------                           CN70  31
#                                                                       CN70  32
IF(SUPER==no:&LAYER<=LLAYER)#          Plot atoms if need be            CN70  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CN70  34
ZLAYER=FLOAT(LAYER-ORGZ)*ZDEL+DISTZ#   Z for this layer                 CN70  35
ZLO=ZLAYER-VICIN; ZHI=ZLAYER+VICIN#    Z-limits for layer               CN70  36
IF(IBOND==yes:)#                       Draw bonds
FOR(J=MARKA; J<MARK1-STEPA; J=J+STEPA)# Loop over atom list              CN70  37
$(
IF(QX(J+12)<0.5) NEXT#                 Unknown atom type
Z1=QX(J+3)#                            Get z-value                      CN70  39
IF(Z1<ZLO\Z1>ZHI) NEXT#                Dont want this one               CN70  40
FOR(JJ=J+STEPA; JJ<MARK1; JJ=JJ+STEPA)# Compare with remaining atoms    CN70  42
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN70  43
IF (QX(JJ+12)<0.5) NEXT#               Unknown atom type
Z2=QX(JJ+3)#                           Get z-value                      CN70  39
IF(Z2<ZLO\Z2>ZHI) NEXT#                Dont want this one               CN70  40
X1=QX(J+1)#                            Get x-value                      CN70  39
Y1=QX(J+2)#                            Get y-value                      CN70  39
X2=QX(JJ+1)#                           Get x-value                      CN70  39
Y2=QX(JJ+2)#                           Get y-value                      CN70  39
movertoc:(QX(J +5),1,NAME1,1,24,0)#                                     CN70  44
movertoc:(QX(JJ+5),1,NAME2,1,24,0)#                                     CN70  45
BLEN=sqrt((X1-X2)**2+(Y1-Y2)**2+(Z1-Z2)**2)#
IF(BLEN>RADII(NINT(QX(J+12)))+RADII(NINT(QX(JJ+12)))) NEXT# skip long
#write(6,*)name1,name2,BLEN,QX(J+12),QX(JJ+12),RADII(1),RADII(2)
X1=X1*SCALE#                           Scaled x-length                  CN70  55
Y1=Y1*SCALE#                           Scaled y-length                  CN70  56
X2=X2*SCALE#                           Scaled x-length                  CN70  55
Y2=Y2*SCALE#                           Scaled y-length                  CN70  56
IF(ROTATE==no:)#                       No rotation                      CN70  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CN70  58
XP1=X0+X1-COSG*Y1#                     X-coord of cross centre          CN70  59
YP1=Y0-SING*Y1#                        Y-coord of cross centre          CN70  60
XP2=X0+X2-COSG*Y2#                     X-coord of cross centre          CN70  59
YP2=Y0-SING*Y2#                        Y-coord of cross centre          CN70  60
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CN70  61
ELSE#                                  Rotation                         CN70  62
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CN70  63
XP1=X0+XLS-Y1-COSG*X1#                 X-coord of cross centre          CN70  64
YP1=Y0-SING*X1#                        Y-coord of centre                CN70  65
XP2=X0+XLS-Y2-COSG*X2#                 X-coord of cross centre          CN70  64
YP2=Y0-SING*X2#                        Y-coord of centre                CN70  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CN70  66
IPEN=3#                                Pen up                           CN70  67
COLOR=0#                               Zero colour index                CN70  68
CALL CN03(XP1,YP1,3)#                  Move to l.h. side                CN70  69
IPEN=2#                                Pen down                         CN70  70
COLOR=-7#                              Change to white (black) line     CN70  71
CALL CN03(XP2,YP2,3)#                  Draw to r.h. side                CN70  72
IPEN=3#                                Pen up                           CN70  73
COLOR=0#                               Zero colour index                CN70  74
CALL CN03(XP2,YP2,3)#                  Move to top                      CN70  75
IPEN=3#                                Pen up                           CN70  79
COLOR=0#                               Zero colour index                CN70  80
$)
$)
#
#  END OF BOND DRAWING
#  -------------------
#
FOR(J=MARKA; J<MARK1; J=J+STEPA)#      Loop over atom list              CN70  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CN70  38
Z=QX(J+3)#                             Get z-value                      CN70  39
IF(Z<ZLO\Z>ZHI) NEXT#                  Dont want this one               CN70  40
Z=Z-ZLAYER#                            Get z-value                      CN70  41
FOR(JJ=J+STEPA; JJ<MARK1; JJ=JJ+STEPA)# Compare with remaining atoms    CN70  42
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CN70  43
movertoc:(QX(J +5),1,NAME1,1,24,0)#                                     CN70  44
movertoc:(QX(JJ+5),1,NAME2,1,24,0)#                                     CN70  45
compchar:(NAME1,1,NAME2,1,24,24,24,SAME)# Compare atom labels           CN70  46
IF(SAME==0) NEXT#                      Different atom labels            CN70  47
IF     (ABS(QX(J+1)-QX(JJ+1))>0.001) NEXT# X-coords differ              CN70  48
ELSE IF(ABS(QX(J+2)-QX(JJ+2))>0.001) NEXT# Y-coords differ              CN70  49
ELSE ifne:(Z,ZLAYER-QX(JJ+3),0.002)NEXT# If not equal distance          CN70  50
QX(JJ+11)=1.0#                         Else flag as plus and minus z    CN70  51
BREAK#                                 And reject as equivalent atom    CN70  52
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CN70  53
IF (JJ!=MARK1) NEXT#                   Avoid printing this atom         CN70  54
X=QX(J+1)*SCALE#                       Scaled x-length                  CN70  55
Y=QX(J+2)*SCALE#                       Scaled y-length                  CN70  56
IF(ROTATE==no:)#                       No rotation                      CN70  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CN70  58
XP=X0+X-COSG*Y#                        X-coord of cross centre          CN70  59
YP=Y0-SING*Y#                          Y-coord of cross centre          CN70  60
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CN70  61
ELSE#                                  Rotation                         CN70  62
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CN70  63
XP=X0+XLS-Y-COSG*X#                    X-coord of cross centre          CN70  64
YP=Y0-SING*X#                          Y-coord of centre                CN70  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CN70  66
IPEN=3#                                Pen up                           CN70  67
COLOR=0#                               Zero colour index                CN70  68
CALL CN03(XP-SX,YP,3)#                 Move to l.h. side                CN70  69
IPEN=2#                                Pen down                         CN70  70
COLOR=-7#                              Change to white (black) crosse   CN70  71
CALL CN03(XP+SX,YP,3)#                 Draw to r.h. side                CN70  72
IPEN=3#                                Pen up                           CN70  73
COLOR=0#                               Zero colour index                CN70  74
CALL CN03(XP,YP+SX,3)#                 Move to top                      CN70  75
IPEN=2#                                Pen down                         CN70  76
COLOR=-7#                              Change to white (black) crosse   CN70  77
CALL CN03(XP,YP-SX,3)#                 Draw to bottom                   CN70  78
IPEN=3#                                Pen up                           CN70  79
COLOR=0#                               Zero colour index                CN70  80
IF(NAMES==yes:)#                       Plot atom names below sites      CN70  81
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CN70  82
movertoc:(QX(J+5),1,STRING,1,LABMAX,0)# Stuff atom name                 CN70  83
NSTRIN=LABMAX#                         Length of string                 CN70  84
IF (ABS(Z)>.002)#                      Out of plane so make italic      CN70  85
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CN70  86
movechar:('|',1,STRING,1,1,0)#         Flag for italics                 CN70  87
movertoc:(QX(J+5),1,STRING,2,LABMAX,0)# Stuff atom name                 CN70  88
NSTRIN=NSTRIN+1#                       Length of string                 CN70  89
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CN70  90
FOR(K=NSTRIN;K>0;K=K-1) IF(STRING(K^K)!=' ') BREAK# Exit non-blank      CN70  91
NBLNK=NSTRIN-K#                                                         CN70  92
IF (ABS(Z)<=.002) HEIGHT=HEIGHT*1.25#  Make in plane atoms larger       CN70  93
XP1=XP-.38*FLOAT(NSTRIN-NBLNK+2)*HEIGHT# X-coord for atom name          CN70  94
YP1=YP-1.8*HEIGHT#                     Y-coord for atom name            CN70  95
NBLA=1#                                Ensure skipping of blanks        CN70  96
COLOR=-5000#                           Change to character color        CN70  97
CALL CN03(XP1,YP1,5)#                  Plot the name                    CN70  98
IF (ABS(Z)<=.002) HEIGHT=HEIGHT*0.8#   Return font size to normal       CN70  99
IF (ABS(Z)>.002 & PLAD==yes:)#         Include distances on plot        CN70 100
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CN70 101
movechar:('|+/-',1,STRING,1,4,0)#      Italic distance also             CN70 102
IF     (ABS(Z)>=10.0)CODE=70632.#      Position for tens                CN70 103
ELSE IF(ABS(Z)>= 1.0)CODE=60532.#      Position for units               CN70 104
ELSE CODE=50432.#                      Position for decimals            CN70 105
IF (Z<0.0) CODE=CODE+10100.#                                            CN70 106
ifeq:(QX(J+11),1.0)#                   Equiv atoms above and below      CN70 107
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CN70 108
CODE=CODE+25000.+5000.*Z/ABS(Z)#       Add 2 or 3 places if - or +      CN70 109
QX(J+11)=0.0#                          Reset +/- flag                   CN70 110
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CN70 111
NSTRIN = NINT(CODE/10000.)#            Elements of string               CN70 112
ncodefld:(Z,1,STRING,CODE,1)#          Stuff z component in string      CN70 113
XP=XP-.38*FLOAT(NSTRIN)*HEIGHT#        X-coord for atom distance        CN70 114
YP=YP-2.8*HEIGHT#                      Y-coord for atom distance        CN70 115
HEIGHT= 4./5.*HEIGHT#                  Make label small & new font      CN70 116
COLOR=-4000#                           Change to number color           CN70 117
CALL CN03(XP,YP,5)#                    Plot the distance                CN70 118
HEIGHT= 5./4.*HEIGHT#                  Return font size to normal       CN70 119
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CN70 120
NBLA=0#                                Reset nbla                       CN70 121
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CN70 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CN70 123
IF(LAYER!=LLAYER)CALL CN03(0.0,0.0,2)# Frame advance signal             CN70 124
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CN70 125
#                                                                       CN70 126
#    SUMMARISE ATOMS IN THE VICINITY OF THE PLANE                       CN70 127
#    --------------------------------------------                       CN70 128
#                                                                       CN70 129
IF(LAYER>LLAYER)#                      Output summary of atoms          CN70 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CN70 131
writeline:(1,CNH7,NCNH7,3,3)#          Write header                     CN70 132
writeline:(0,CNH8,NCNH8,3,3)#          Underline                        CN70 133
writeline:(0,CN7A,NCN7A,3,3)#          First line of description        CN70 134
writeline:(0,CN7B,NCN7B,3,3)#          Second line                      CN70 135
writeline:(0,CN7C,NCN7C,3,3)#          Third line                       CN70 136
writeline:(0,CN7D,NCN7D,3,3)#          Fourth line                      CN70 137
writeline:(0,CN7E,NCN7E,3,3)#          1st line table heading           CN70 138
writeline:(0,CN7F,NCN7F,3,3)#          2nd line heading                 CN70 139
writeline:(0,0,0,3,3)#                 Blank line                       CN70 140
FOR(IL=FLAYER; IL<=LLAYER; IL=IL+DLAYER)# Loop over layers              CN70 141
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CN70 142
ncodefld:(FLOAT(IL),1,CNLA,90313.,1)#  Stuff layer number               CN70 143
writeline:(0,CNLA,NCNLA,3,3)#          Write layer number               CN70 144
ZLAYER=FLOAT(IL-ORGZ)*ZDEL+DISTZ#      Z for this layer                 CN70 145
ZLO=ZLAYER-VICIN; ZHI=ZLAYER+VICIN#    Z-limits for layer               CN70 146
FOR(J=MARKA; J<MARK1; J=J+STEPA)#      Loop over atom list              CN70 147
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CN70 148
Z=QX(J+3)#                             Get z-value                      CN70 149
IF(Z<ZLO\Z>ZHI) NEXT#                  Dont want this one               CN70 150
X=QX(J+1)*SCALE#                       Scaled x-length                  CN70 151
Y=QX(J+2)*SCALE#                       Scaled y-length                  CN70 152
IF(ROTATE==no:)#                       No rotation                      CN70 153
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CN70 154
XP=X0+X-COSG*Y#                        X-coord of cross centre          CN70 155
YP=Y0-SING*Y#                          Y-coord of cross centre          CN70 156
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CN70 157
ELSE#                                  Rotation                         CN70 158
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CN70 159
XP=X0+XLS-Y-COSG*X#                    X-coord of cross centre          CN70 160
YP=Y0-SING*X#                          Y-coord of centre                CN70 161
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CN70 162
IF(SUPER==yes:)#                       Plot the atom and name           CN70 163
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CN70 164
IPEN=3#                                Pen up                           CN70 165
COLOR=0#                               Zero colour index                CN70 166
CALL CN03(XP-SX,YP,3)#                 Move to l.h. side                CN70 167
IPEN=2#                                Pen down                         CN70 168
COLOR=-7#                              Change to white (black) crosse   CN70 169
CALL CN03(XP+SX,YP,3)#                 Draw to r.h. side                CN70 170
IPEN=3#                                Pen up                           CN70 171
CALL CN03(XP,YP+SX,3)#                 Move to top                      CN70 172
IPEN=2#                                Pen down                         CN70 173
CALL CN03(XP,YP-SX,3)#                 Draw to bottom                   CN70 174
IPEN=3#                                Pen up                           CN70 175
IF(NAMES==yes:)#                       Plot atom names below sites      CN70 176
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CN70 177
movertoc:(QX(J+5),1,STRING,1,LABMAX,0)# Stuff atom name                 CN70 178
NSTRIN=LABMAX#                         Length of string                 CN70 179
FOR(K=LABMAX;K>0;K=K-1) IF(STRING(K^K)!=' ') BREAK# Exit non-blank      CN70 180
NBLNK=LABMAX-K#                        Zero blanks counter              CN70 181
XP=XP-.38*FLOAT(NSTRIN-NBLNK+2)*HEIGHT# X-coord for atom name           CN70 182
YP=YP-1.8*HEIGHT#                      Y-coord for atom name            CN70 183
NBLA=1#                                Ensure skipping of blanks        CN70 184
COLOR=-5000#                           Change to character colour       CN70 185
CALL CN03(XP,YP,5)#                    Plot the name                    CN70 186
NBLA=0#                                Reset nbla                       CN70 187
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CN70 188
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CN70 189
Z=Z-ZLAYER#                            Distance from the plane          CN70 190
IF(ROTATE==yes:)#                      Swap coords for rotation         CN70 191
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CN70 192
X=XL-QX(J+2)#                          Rotated x-coordinate             CN70 193
Y=QX(J+1)#                             Rotated y-coordinate             CN70 194
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CN70 195
ELSE#                                  No rotation                      CN70 196
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CN70 197
X=QX(J+1)#                             X-coordinate                     CN70 198
Y=QX(J+2)#                             Y-coordinate                     CN70 199
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CN70 200
movertoc:(QX(J+5),1,CHROT,11,8,0)#     Stuff atom name                  CN70 201
ncodefld:(QX,J+4,CHROT,240313.,1)#     Stuff symop number               CN70 202
ncodefld:(X,1,CHROT,360842.,1)#        Stuff x-coord                    CN70 203
ncodefld:(Y,1,CHROT,440842.,1)#        Stuff y-coord                    CN70 204
ncodefld:(Z,1,CHROT,520842.,1)#        Stuff distance                   CN70 205
writeline:(0,0,0,1,3)#                 Write the line                   CN70 206
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CN70 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CN70 208
IF(SUPER==yes:) CALL CN03(0.0,0.0,2)#  Frame advance signal             CN70 209
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CN70 210
#                                                                       CN70 211
RETURN#                                                                 CN70 212
END#                                                                    CN70 213
systemheader:(CN80)#                                                    CN80   1
#####################################################################   CN80   2
#                                                                   #   CN80   3
#                           CN80                                    #   CN80   4
#                                                                   #   CN80   5
#####################################################################   CN80   6
SUBROUTINE CN80#                       J.m. stewart august 1984         CN80   7
include:(AACOMN)#                                                       CN80   8
include:(CNCOMN)#                                                       CN80   9
#                                                                       CN80  10
INTEGER IP,PSIZ#                                                        CN80  11
CALL CN03(0.0,0.0,10)#                 Finish off the plot              CN80  12
readwpkt:(1,endrecord:,PSIZ,IP,0)#     Close file a                     CN80  13
readwpkt:(INPUT,endrecord:,PSIZ,IP,0)# Close input bdf                  CN80  14
#                                                                       CN80  15
RETURN#                                                                 CN80  16
END#                                                                    CN80  17
pmacro:([no:])#                        Purge xtal system macros         CN80  18
