systemheader:(CP    )#                                                  CP     1
####################################################################### CP     2
##      Copyright (C) 2000, The Xtal System, The University of        # CP     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # CP     4
## Distributed under the GNU General Public Licence as published by   # CP     5
## the Free Software Foundation, in the hope that it will be useful   # CP     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # CP     7
## for more details.                                                  # CP     8
##                                                                    # CP     9
##                        *** CRISP  ***                              # CP    10
##                                                                    # CP    11
##       BEING AN AMALGAMATION OF THE FOLLOWING PROGRAMS FOR THE      # CP    12
##       PURPOSE OF AUTOMATING STRUCTURE (PHASE) SOLUTION             # CP    13
##                                                                    # CP    14
##                                                                    # CP    15
##                        *** GENTAN ***                              # CP    16
##    THE PROGRAM GENTAN ESTIMATES AND REFINES STRUCTURE FACTOR       # CP    17
##    PHASE USING THE STRUCTURE INVARIANT TANGENT FORMULA.            # CP    18
##                                                                    # CP    19
##                        *** FOURR ***                               # CP    20
##  THE PROGRAM CALCULATES THE FOURIER TRANSFORM FROM RECIPROCAL      # CP    21
##  TO REAL SPACE. IT IS GENERAL FOR ALL SPACE GROUPS AND STRUCTURE   # CP    22
##  SIZES.                                                            # CP    23
##                                                                    # CP    24
##                        *** PEKPIK ***                              # CP    25
##    THE PROGRAM PEKPIK SCANS THE FOURIER TRANSFORM MAP PRODUCED     # CP    26
##    BY THE FOURR PROGRAM FOR MAXIMA IN THE MINIMA IN THE MAP.       # CP    27
##                                                                    # CP    28
##                        *** FC ***                                  # CP    29
##   THE PROGRAM FC IS USED TO CALCULATE STRUCTURE FACTORS WHEN       # CP    30
##   NO REFINEMENT OF ATOMIC PARAMETERS IS TO BE DONE.                # CP    31
##                                                                    # CP    32
##                        *** MODEL ***                               # CP    33
##  MODEL forms a connected peak model based on the inter-site        # CP    34
##  distances (to form clusters) and angles (to form sub-clusters).   # CP    35
##                                                                    # CP    36
##  It has been proposed to implement the MODEL                       # CP    37
##  chemical connectivity model and match this with the sites.        # CP    38
##  The process is critically dependent on the                        # CP    39
##  most appropriate distance and angle limits being specified.       # CP    40
##  Sadly it has not been implemented as yet.                         # CP    41
##                                                                    # CP    42
##  CRISP was collated and strung together by Doug du Boulay Jan 1999 # CP    43
##                                                                    # CP    44
##  Don't get suckered in by the comments -- they can be terribly     # CP    45
##  misleading.  Debug only code.                                     # CP    46
##                 -- Dave Storer                                     # CP    47
##                                                                    # CP    48
####################################################################### CP    49
include:(XMACRO)#                                                       CP    50
#                                                                       CP    51
macro:(lsqonly:,1)#                    For itmode                       CP    52
macro:(peakelim:,0)#                   For itmode                       CP    53
#                                                                       CP    54
macro:(emap:,0)#                       An e fourr map                   CP    55
macro:(fobs:,1)#                       An fobs fourr map                CP    56
macro:(fdif:,2)#                       An fobs-fcal fourr map           CP    57
macro:(vect:,3)#                       An e^2-1 patterson map           CP    58
#                                                                       CP    59
macro:(invert4x4:,CALL CP85($1,$2,$3,$4))# Solve normal equations       CP    60
macro:(axeqb:,    CALL CP06($1,$2,$3))# Solve a.x = b                   CP    61
#                                                                       CP    62
macro:(raiseexception:,$(XCEPT=$1;RETURN$))# Throw an exception         CP    63
macro:(catchexception:,IF(XCEPT!=0)RETURN)#                             CP    64
macro:(timeit:,$( getcpus:(TIMEXX)#                                     CP    65
[WRITE(6,*)"ELAPST",TIMEXX-TIMEXY,$1];#                                 CP    66
TIMEXY=TIMEXX $) )#                                                     CP    67
#                                                                       CP    68
macro:(savepsfom:,9)#                                                   CP    69
macro:(pt0:,IF(DMP>-1))#                                                CP    70
macro:(pt1:,IF(DMP> 0))#                                                CP    71
macro:(pt2:,IF(DMP> 1))#                                                CP    72
macro:(pt3:,IF(DMP> 2))#                                                CP    73
macro:(pt4:,IF(DMP> 3))#                                                CP    74
macro:(pt5:,IF(DMP> 4))#                                                CP    75
macro:(pt6:,IF(DMP> 5))#                                                CP    76
macro:(ib:,NINT(BUFIN($1)))#                                            CP    77
macro:(bf:,BUFIN($1))#                                                  CP    78
macro:(iqx:,NINT(QX($1)))#                                              CP    79
macro:(swap:,$(QIQI=$1;$1=$2;$2=QIQI$))#                                CP    80
#                                                                       CP    81
macro:(genlist:,[ifelse:($1,,GN,$1)])# Define gen list pointer          CP    82
macro:(hkl:,[QX(genlist:($1)+ 1)])#    Define packed hkl    +1          CP    83
macro:(uvw:,[QX(genlist:($1)+ 2)])#    Define packed uvw    +2          CP    84
macro:(prc:,[QX(genlist:($1)+ 3)])#    Define restr code    +3          CP    85
macro:(alt:,[QX(genlist:($1)+ 4)])#    Define total alfa(e) +4          CP    86
macro:(evl:,[QX(genlist:($1)+ 5)])#    Define /e/-value     +5          CP    87
macro:(alp:,[QX(genlist:($1)+ 6)])#    Define part alfa(e)  +6          CP    88
macro:(sta:,[QX(genlist:($1)+ 7)])#    Define start status  +7          CP    89
macro:(pak:,[QX(genlist:($1)+ 8)])#    Define packed start  +8          CP    90
macro:(pnt:,[QX(genlist:($1)+ 9)])#    Define sort pointer  +9          CP    91
macro:(sma:,[QX(genlist:($1)+10)])#    Define sum w*alpha   +10         CP    92
macro:(top:,[QX(genlist:($1)+11)])#    Define top si block  +11         CP    93
macro:(bot:,[QX(genlist:($1)+12)])#    Define bot si block  +12         CP    94
macro:(phi:,[QX(genlist:($1)+ 2)])#    Define phase         +2          CP    95
macro:(sin:,[QX(genlist:($1)+ 7)])#    Define tang sin sum  +7          CP    96
macro:(cos:,[QX(genlist:($1)+10)])#    Define tang cos sum  +10         CP    97
macro:(seq:,[QX(genlist:($1)+10)])#    Define sequence ordr +10         CP    98
macro:(wgt:,[QX(genlist:($1)+13)])#    Define refine weight +5          CP    99
macro:(frel:,[QX(genlist:($1)+14)])#   Define fobs                      CP   100
macro:(fcal:,[QX(genlist:($1)+15)])#   Define fcal                      CP   101
macro:(ecal:,[QX(genlist:($1)+16)])#   Define ecal                      CP   102
macro:(anod:,[QX(genlist:($1)+16)])#   Define ecal                      CP   103
macro:(stol:,[QX(genlist:($1)+17)])#   Define sin theta/lambda          CP   104
macro:(mult:,[QX(genlist:($1)+18)])#   Define multiplicity              CP   105
macro:(exf2:,[QX(genlist:($1)+19)])#   Define ecal                      CP   106
macro:(scos:,[QX(genlist:($1)+19)])#   Define saved cos                 CP   107
macro:(ssin:,[QX(genlist:($1)+20)])#   Define saved sin                 CP   108
macro:(bnod:,[QX(genlist:($1)+19)])#   Define ecal                      CP   109
macro:(phi1:,[QX(genlist:($1)+20)])#   Fallback best phase set          CP   110
macro:(wgt1:,[QX(genlist:($1)+21)])#   Fallback best phase set          CP   111
macro:(phin:,   21)#                   Define phi next phase set        CP   112
macro:(psetlim:, 12)#                                                   CP   113
macro:(wgtn:,   arith:(phin:,+,psetlim:))# Define weight next phase s   CP   114
macro:(gensize:,arith:(wgtn:,+,psetlim:))# Space for weights and phas   CP   115
#                                                                       CP   116
macro:(phaserestr:, intunpak:(QX($1+1),$2, 0, 4))# 0 -  3               CP   117
macro:(phisigncode:,intunpak:(QX($1+1),$2, 4, 3))# 4 -  6               CP   118
macro:(phiinvshift:,intunpak:(QX($1+1),$2, 7, 4))# 7 - 10               CP   119
macro:(phifragment:,intunpak:(QX($1+1),$2,11, 9))# 11 - 19              CP   120
macro:(probfactor:, intunpak:(QX($1+1),$2,20,bitlen:(20)))# 20 - 31     CP   121
macro:(xvectorsum:, intunpak:(QX($1+2),$2,10,10))# 10 - 10              CP   122
macro:(probfsigma:, intunpak:(QX($1+2),$2,20,bitlen:(20)))# 20 - 31     CP   123
#                                                                       CP   124
macro:(generatornum:,         $2=NINT(QX($1+2+$3)))#                    CP   125
#                                                                       CP   126
macro:(comppakwdone:,compakwd:(QX($1+1),$2,$3,$4))# 1st inv word        CP   127
macro:(plastbitsword:,intpak:($1,$2,20,bitlen:(20)))# Pack pfactor      CP   128
#                                                                       CP   129
macro:(iprc:,[NINT(prc:($1))])#        Define integer restr code        CP   130
macro:(ista:,[NINT(sta:($1))])#        Define integer start status      CP   131
macro:(ipnt:,[NINT(pnt:($1))])#        Define integer sort order        CP   132
macro:(itop:,[NINT(top:($1))])#        Define integer si block          CP   133
macro:(ibot:,[NINT(bot:($1))])#        Define integer si block          CP   134
macro:(iseq:,[NINT(seq:($1))])#        Define integer sort order        CP   135
#                                                                       CP   136
#-----------------FS                                                    CP   137
macro:(swap1:,[$(IXZE=ISUM$1;ISUM$1=ISUM$2;ISUM$2=IXZE$)])# F           CP   138
macro:(dp:,ifelse:(mxbtwd:,32,DOUBLE PRECISION ,REAL ))#                CP   139
macro:(db:,ifelse:(mxbtwd:,32,DBLE($1),$1))#                            CP   140
macro:(dsqrt:,ifelse:(mxbtwd:,32,DSQRT($1),SQRT($1)))#                  CP   141
macro:(d0:,ifelse:(mxbtwd:,32,D+0 ,E+0 ))#                              CP   142
macro:(dcos:,ifelse:(mxbtwd:,32,DCOS($1),COS($1)))#                     CP   143
macro:(dacos:,ifelse:(mxbtwd:,32,DACOS($1),ACOS($1)))#                  CP   144
macro:(dabs:,ifelse:(mxbtwd:,32,DABS($1),ABS($1)))#                     CP   145
macro:(dmin1:,ifelse:(mxbtwd:,32,DMIN1($1,$2),AMIN1($1,$2)))#           CP   146
macro:(dmax1:,ifelse:(mxbtwd:,32,DMAX1($1,$2),AMAX1($1,$2)))#           CP   147
macro:(dsign:,ifelse:(mxbtwd:,32,DSIGN($1,$2),SIGN($1,$2)))#            CP   148
#-----------------FC                                                    CP   149
macro:(name:,incr:(arith:(23,/,mxchwd:)))#                              CP   150
macro:(templist:,[ifelse:($1,,MP,$1)])# Define list pointer             CP   151
macro:(flag:,[QX(templist:($1)+1)])#   Define storage flag              CP   152
macro:(code:,[QX(templist:($1)+2)])#   Define position code             CP   153
macro:(pnt1:,[QX(templist:($1)+3)])#   Define point 1 value             CP   154
macro:(lin1:,[QX(templist:($1)+4)])#   Define line  1 value             CP   155
macro:(lay1:,[QX(templist:($1)+5)])#   Define layer 1 value             CP   156
macro:(pek1:,[QX(templist:($1)+6)])#   Define peakh 1 value             CP   157
macro:(pnt2:,[QX(templist:($1)+7)])#   Define point 2 value             CP   158
macro:(lin2:,[QX(templist:($1)+8)])#   Define line  2 value             CP   159
macro:(lay2:,[QX(templist:($1)+9)])#   Define layer 2 value             CP   160
macro:(pek2:,[QX(templist:($1)+10)])#  Define peakh 2 value             CP   161
#-----------------PP - ML                                               CP   162
macro:(cullsite:,CALL CP45($1))#                                        CP   163
macro:(permlist:,[ifelse:($1,,KP,$1)])# Define list pointer             CP   164
macro:(peakx:,[QX(permlist:($1)+ 1)])# Define x coordinate              CP   165
macro:(peaky:,[QX(permlist:($1)+ 2)])# Define y coordinate              CP   166
macro:(peakz:,[QX(permlist:($1)+ 3)])# Define z coordinate              CP   167
macro:(peakh:,[QX(permlist:($1)+ 4)])# Define peak height               CP   168
macro:(peakm:,[QX(permlist:($1)+ 5)])# Define peak site multiplicity    CP   169
macro:(index:,[QX(permlist:($1)+ 6)])# Define reliability index -pp     CP   170
macro:(peklist:,6)#                    Length of info pak in pekpik     CP   171
macro:(peakt:,[QX(permlist:($1)+ 6)])# Define atom type for peak-ha     CP   172
macro:(atrad:,[QX(permlist:($1)+ 7)])# Define atom radius       -ml     CP   173
macro:(atomb:,[QX(permlist:($1)+ 8)])# Define atom biso                 CP   174
macro:(savlist:,8)#                    Length of info pak in pekpik     CP   175
macro:(aname:,[QX(permlist:($1)+ 8)])# Define 4 char site name          CP   176
macro:(clust:,[QX(permlist:($1)+ 9)])# Define site cluster group        CP   177
macro:(numbr:,[QX(permlist:($1)+10)])# Define site number               CP   178
macro:(bond1:,[QX(permlist:($1)+11)])# Define bond start addr.          CP   179
macro:(bond2:,[QX(permlist:($1)+12)])# Define bond stop  addr.          CP   180
macro:(start:,[QX(permlist:($1)+13)])# Define site start flag           CP   181
macro:(ringf:,[QX(permlist:($1)+14)])# Define ring indicator flag       CP   182
macro:(group:,[QX(permlist:($1)+15)])# Define site subclust group       CP   183
macro:(canon:,[QX(permlist:($1)+16)])# Define canonical descriptor      CP   184
macro:(nbond:,[QX(permlist:($1)+17)])# Define site bond count           CP   185
macro:(order:,[QX(permlist:($1)+18)])# Define site merit                CP   186
macro:(match:,[QX(permlist:($1)+19)])# Define matching atom site ad     CP   187
macro:(certn:,[QX(permlist:($1)+19)])# Certainty that site is an atom   CP   188
macro:(modellist:,19)#                 Length of info pak in model      CP   189
#                                                                       CP   190
macro:(bondlist:,[ifelse:($1,,IB,$1)])# Define bond list pointer        CP   191
macro:(peak1:,[QX(bondlist:($1)+ 1)])# Define bond site addr. 1         CP   192
macro:(peak2:,[QX(bondlist:($1)+ 2)])# Define bond site addr. 2         CP   193
macro:(bondl:,[QX(bondlist:($1)+ 3)])# Define bond length 1 to 2        CP   194
#                                                                       CP   195
macro:(sitelist:,[ifelse:($1,,IS,$1)])# Define site list pointer        CP   196
macro:(site:,[QX(sitelist:($1)+ 1)])#  Define site site addr.           CP   197
macro:(sumc:,[QX(sitelist:($1)+ 2)])#  Define sum of canonical desc     CP   198
macro:(bonf:,[QX(sitelist:($1)+ 3)])#  Define first bond site addr.     CP   199
macro:(bonl:,[QX(sitelist:($1)+ 4)])#  Define last bond site addr.      CP   200
macro:(ring:,[QX(sitelist:($1)+ 5)])#  Define ring indicator flag       CP   201
#                                                                       CP   202
macro:(sortlist:,[ifelse:($1,,IA,$1)])# Define sort list pointer        CP   203
macro:(star:,[QX(sortlist:($1)+ 1)])#  Define start site addr.          CP   204
macro:(frst:,[QX(sortlist:($1)+ 2)])#  Define first-1 bond site         CP   205
macro:(last:,[QX(sortlist:($1)+ 3)])#  Define last  bond site addr.     CP   206
macro:(link:,[QX(sortlist:($1)+ 4)])#  Define matched parent addr.      CP   207
macro:(cand:,[QX(sortlist:($1)+ 5)])#  Define canonical discriptor      CP   208
#                                                                       CP   209
macro:(inos:,1)#                       No-start status = 1              CP   210
macro:(iodr:,2)#                       Odr start status = 2             CP   211
macro:(iedr:,3)#                       Edr start status = 3             CP   212
macro:(iper:,4)#                       Permute start status = 4         CP   213
macro:(iset:,5)#                       Preset start status = 5          CP   214
macro:(inul:,6)#                       Suppress status = 6              CP   215
macro:(nos:,1.)#                       Non-starting phi = 1             CP   216
macro:(odr:,2.)#                       Odr generator type = 2           CP   217
macro:(edr:,3.)#                       Edr type no. = 3                 CP   218
macro:(per:,4.)#                       Permute generator type = 4       CP   219
macro:(set:,5.)#                       Set phi generator = 5            CP   220
macro:(nul:,6.)#                       Null generator type = 6          CP   221
macro:(trip:,0)#                       Triplet indicator                CP   222
macro:(psi0:,1)#                       Psi0 triplet indicator = 1       CP   223
macro:(posq:,2)#                       Positive quartet indicator       CP   224
macro:(negq:,3)#                       Negative quartet indicator       CP   225
macro:(mine:,0.5)#                     Min expect factor for ale        CP   226
macro:(utob:,78.9568)#                 8*pi**2                          CP   227
#                                                                       CP   228
#----------------END OF MACRO DEFINITIONS                               CP   229
#                                                                       CP   230
#                                                                       CP   231
extrude:(CPCOMN)#                                                       CP   232
REAL AMIN(3)#      ## Minimum probability factors                       CP   233
REAL AMOS#         ## Measure of success minimum                        CP   234
REAL A2MX#         ## Al**2 refinement threshold                        CP   235
INTEGER BOT#       ## Bot/len value of s.i. block                       CP   236
REAL BIAS(6)#      ## Starting phi weight bias                          CP   237
REAL CONV#         ## Iteration convergence limit                       CP   238
INTEGER DSNM#      ## Data set number                                   CP   239
INTEGER EFOM#      ## Fom pretest flag (no=0,yes=1                      CP   240
REAL EMIN#         ## /e/ minimum for all gens                          CP   241
REAL EPAR#         ## /e/ min for bdf input phases                      CP   242
INTEGER ETYP#      ## Type of /e/ used (1 or 2)                         CP   243
INTEGER FIX(6)#    ## Iteration fixes for starters                      CP   244
REAL FMIN(5),FMAX(5)## Detected min/max of fom's                        CP   245
REAL FREJ(6),FOPT(5)## Fom rejection & optimum                          CP   246
REAL FRAC#         ## Molecular fraction for bdf p                      CP   247
INTEGER IACC#      ## Refinement accelerator flag                       CP   248
INTEGER ICNT#      ## Centro flag (nc=0, c=1)                           CP   249
INTEGER INPH#      ## Input phi (no=0,fc=1,gt=2)                        CP   250
INTEGER IQPS#      ## Qpsi flag (excl=0,else=1)                         CP   251
INTEGER ISEL#      ## Si select(all=-2,q4=0,t3=2)                       CP   252
INTEGER IWGT#      ## Tangent weight flag (1 or 2)                      CP   253
INTEGER IXVF#      ## Xvf(all=1,ins=2,part=3,out=4)                     CP   254
INTEGER LEDR#      ## Edr permute limit                                 CP   255
INTEGER KEY(4)#    ## Indexpkt signal array                             CP   256
INTEGER MODE#      ## Calc mode (cas=1,blk=2,ran=3                      CP   257
INTEGER MSEL#      ## Start types to be selected                        CP   258
INTEGER MSTR#      ## Max phase set from path                           CP   259
REAL    MXTG#      ## Max trip/gen                                      CP   260
REAL    MXQG#      ## Max quar/gen                                      CP   261
INTEGER MXIT#      ## Max no. refine iterations                         CP   262
INTEGER MXPS#      ## Max no. phase sets allowed                        CP   263
INTEGER MQ#        ## Start-1 of psi(0) generators                      CP   264
INTEGER MG#        ## End of generator table                            CP   265
INTEGER NANT#      ## Enantio definition flag                           CP   266
INTEGER NCUT#      ## Addr limit of top generators                      CP   267
INTEGER NGEN#      ## Number of generators                              CP   268
INTEGER NLIM#      ## Highest addr of starter                           CP   269
INTEGER NMAG#      ## Number of magic integers                          CP   270
INTEGER NODR#      ## Numb origin def. generators                       CP   271
INTEGER NONR#      ## No. of nonrestr. odr phases                       CP   272
INTEGER NOPS#      ## No. of requested phase sets                       CP   273
INTEGER NPER#      ## Count of permute starters                         CP   274
INTEGER NPSI#      ## Count of psi(0) generators                        CP   275
INTEGER NPST#      ## Count of permuted phase sets                      CP   276
INTEGER NQPS#      ## Phase shift for nq4 psi                           CP   277
INTEGER NSTR#      ## Count of starting phases                          CP   278
INTEGER NSEL#      ## Num gens eligible as starts                       CP   279
INTEGER NTES#      ## Test no. for permute select                       CP   280
INTEGER NTOT#      ## Count of total generators                         CP   281
INTEGER NTYP(4)#   ## Count of invariant types                          CP   282
INTEGER PERI(10)#  ## Permute phase increments                          CP   283
INTEGER PERN(10)#  ## Permute phase genlist addr                        CP   284
INTEGER PERM(10)#  ## Permutations                                      CP   285
INTEGER PERS(2)#   ## Permute incr. for nr/restr                        CP   286
REAL PFAC#         ## Sigma ratio of prob. factor                       CP   287
INTEGER PSET(8)#   ## Requested phase set numbers                       CP   288
REAL RATE#         ## Rate of al**2 max reduction                       CP   289
REAL RWGT#         ## Start weight of random phi                        CP   290
REAL SCAL#         ## Frel scale for bdf phi test                       CP   291
REAL GSCAL#        ## Genev frel scale factor                           CP   292
INTEGER SEED1,SEED2## Random number seeds                               CP   293
REAL SIGA#         ## Factor of siga to reduce a                        CP   294
REAL MDSI(3)#      ## Count of ivariant orders                          CP   295
REAL SIVC(3,3)#    ## Structure invariant vectors                       CP   296
REAL STMN#         ## Sin theta /lambda maximum                         CP   297
REAL STMX#         ## Sin theta /lambda minimum                         CP   298
REAL STYP(4)#      ## Counts of invariant types                         CP   299
REAL SUMR#         ## Sum of alpha(ran)                                 CP   300
INTEGER TOP#       ## Top/nrec value of s.i. block                      CP   301
INTEGER TYPE#      ## Start phase (ran=0;per=1;mag                      CP   302
REAL WFOM(5)#      ## Fom weights for cfom                              CP   303
REAL WMIN#         ## Min extention weight                              CP   304
REAL XSHI#         ## Xvec sum upper thresh.                            CP   305
REAL XSLO#         ## Xvec sum lower thresh.                            CP   306
REAL XSMN#         ## Xvec sum min found                                CP   307
REAL XSMX#         ## Xvec sum max found                                CP   308
REAL XVMN#         ## Xvector lower threshold                           CP   309
REAL XVMX#         ## Xvector upper threshold                           CP   310
REAL PSFOM(savepsfom:,20)## Phase set figs of merit                     CP   311
INTEGER LPSET#     ## Last phase set                                    CP   312
REAL PSLFOM(savepsfom:)## Last phase set fig of merit                   CP   313
#                                                                       CP   314
#                                                                       CP   315
REAL ATA(10)#      ## Number of atoms in unit cell                      CP   316
REAL ATR(10)#      ## Atomic radii                                      CP   317
REAL ATZ(10)#      ## Atomic number                                     CP   318
REAL BOVL#         ## Overall tf                                        CP   319
REAL GBOVL#        ## Genev estimate of overall tf                      CP   320
REAL DSTL#         ## Delta st/l for ff table                           CP   321
REAL FMUL#         ## S.f. multiplicity                                 CP   322
INTEGER ISCF#      ## Step in ff name list                              CP   323
INTEGER NATM#      ## Count number of atoms                             CP   324
INTEGER NSCF#      ## Length of ff table                                CP   325
INTEGER NATYP#     ## Number of atom types                              CP   326
INTEGER OFF(10)#   ## Ff table offsets                                  CP   327
INTEGER PHSPEC(40)# ##                                                  CP   328
#                                                                       CP   329
INTEGER ISYM#      ## Signal symmetry in peak overlap                   CP   330
INTEGER MXPEAK#    ## Total number of peaks to seek                     CP   331
INTEGER NPEAKS#    ## No. of largest peaks to list in sorted order      CP   332
INTEGER NPTS#      ## No. of points in the permanent array              CP   333
#                                                                       CP   334
#                                                                       CP   335
REAL G1,G2,G3,G5,G6,G9## Terms for distance calculation                 CP   336
REAL DMIN#         ## Upper density limits for search                   CP   337
REAL PLIM#         ## Initial peak limit (= initial dmin)               CP   338
REAL PMIN#         ## Reak threshold - auto adjusted                    CP   339
REAL RES#          ## Resolution sphere squared                         CP   340
#                                                                       CP   341
#                                                                       CP   342
#                                                                       CP   343
REAL    CELLC(9)#   ## Cell constants                                   CP   344
REAL    TRAND(9)#   ## Transformation matrix from franctional to orth   CP   345
REAL    TRANR(9)#   ## Transformation matrix from Miller indx to orth   CP   346
REAL    CMETR(9)#   ## Metric tensor                                    CP   347
REAL    RMETR(9)#   ## Reciprocal metric tensor                         CP   348
REAL    DENMAX#     ## maximum density in the map                       CP   349
REAL    DENMIN#     ## minimum density in the map                       CP   350
REAL    E000#       ## E(0,0,0) value                                   CP   351
REAL    F000#       ## F(0,0,0) value                                   CP   352
INTEGER FVOL#       ## Full Four MAP volume flag                        CP   353
INTEGER GRID(3)#    ## Input grid specifications                        CP   354
INTEGER IMAP(3)#    ## IMAP(1)=map axis code for X; IMAP(3).. for Z     CP   355
INTEGER IHMAX(3)#   ## Max hkl permuted for use during summation        CP   356
INTEGER IH2MAX#     ##                                                  CP   357
INTEGER IH3MAX#     ##                                                  CP   358
INTEGER ICEL(3)#    ## ICEL(1)=cell axis code for lay; ICEL(3).. acc    CP   359
INTEGER IFORCE#     ##                                                  CP   360
INTEGER INCX(3)#    ## Increments along cell directions in grid point   CP   361
INTEGER INCT(3)#    ## Increments along cell directions not permuted    CP   362
INTEGER IRAD#       ## Radiation type 1=neut;2=elect;3xrays             CP   363
INTEGER LTYP#       ## Lattice type (1 to 7) p,i,r,f,a,b,c              CP   364
INTEGER ISUM1#      ## Contains map code for x (1=lay;2=dow;3=acc)      CP   365
INTEGER ISUM2#      ## Contains map code for y (1=lay;2=dow;3=acc)      CP   366
INTEGER ISUM3#      ## Contains map code for z (1=lay;2=dow;3=acc)      CP   367
INTEGER IXINC(3)#   ## Incx modified to be positive for actual          CP   368
INTEGER IXORG(3)#   ## Permuted plot origins in grid params modulo ng   CP   369
INTEGER JSUM1#      ## Contains cell code for layer (1=X,2=Y,3=Z)       CP   370
INTEGER JSUM2#      ## Contains cell code for down  (1=X,2=Y,3=Z)       CP   371
INTEGER JSUM3#      ## Contains cell code for accros(1=X,2=Y,3=Z)       CP   372
INTEGER MAXH(3)#    ## Maximum miller indices in the unit cell          CP   373
INTEGER NG(3)#      ## Grid parameters of map (1=layer; 3=accross)      CP   374
INTEGER NP(3)#      ## Number of points in each sum direction           CP   375
INTEGER NPP1#       ## Running 1st sum points - changes as layers don   CP   376
INTEGER NROT#       ## Number of unique symmetry matrices on bdf        CP   377
INTEGER NRSZ#       ## Number of matrices with same pattern zeros       CP   378
INTEGER NSYM#       ## Count of symmetry operations                     CP   379
INTEGER NSCL#       ## Number of scale groups                           CP   380
INTEGER ORGX(3)#    ## Permuted origin points axis in grid u   s        CP   381
INTEGER ORGX1#      ## Save first layer coord                           CP   382
INTEGER ORGT(3)#    ## Same as orgx but not permuted by jsums           CP   383
INTEGER PASSES#     ## Cycle counter used to control calling of fs04    CP   384
REAL    PPANG#      ## Scale of map in printer points/angstrom          CP   385
REAL    SCALE(65)#  ## F relative scale factors   ######!!!!!!!!!!!     CP   386
INTEGER SPAN(3)#    ## Number of grid points to be summed over          CP   387
REAL    VOL#        ## Cell volume                                      CP   388
REAL    XHI(3)#     ## Upper map limits in fractions of cell            CP   389
REAL    XLO(3)#     ## Lower map limits in fractions of cell            CP   390
REAL    SUMX#                                                           CP   391
#                                                                       CP   392
REAL    ATZDIF(16)# ## Expected decrease in Z across ordered bounda     CP   393
REAL    ATNC(16)#   ## Cumulative numbers of higher Z Atom types        CP   394
REAL    BREJECT#    ## Biso value for rejecting sites                   CP   395
REAL    FRACIN#     ## Initial fraction asigned                         CP   396
REAL    MNRSOL#     ## Minimum R factor classed as solution
REAL    TSPEC#      ## Temp Factor Range
#                                                                       CP   397
INTEGER MARK#                          Packet length of genlist         CP   398
INTEGER MARK0#                         Start-1 of sin/cos table         CP   399
INTEGER MARK2#                         Start-1 16 *8 char sf type nam   CP   400
INTEGER MARK3#                         Start-1 of scatfac table         CP   401
INTEGER MARK4#                         Start-1 of scale list            CP   402
INTEGER MARKM,STOPM#                   Start-1 peak max profile         CP   403
INTEGER MARK5,STOP5,STEP5#             Start-1 of bdf atom coords       CP   404
INTEGER MARK6#                         Start-1 of generators            CP   405
INTEGER MARK7#                         Start-1 of invariants            CP   406
INTEGER MARK8,STOP8, STEP8#            Start-1 of previous cyle atoms   CP   407
INTEGER MARK9,STOP9, STEP9#            Start-1 of duplicate of mark8    CP   408
INTEGER MARK10,STOP10, STEP10#         Start-1 of hole list             CP   409
INTEGER MARKA,STOPA, STEPA#            Start-1 of cycled peak list      CP   410
INTEGER STOPA1#                        Very end of permnnt peak list    CP   411
INTEGER MARKB,STOPB,STEPB#             Start-1 of temporary peak list   CP   412
INTEGER MARKC1#                        Fft fudge it buffer              CP   413
INTEGER MARKC,STOPC#                   Pekpik map line buffer 1         CP   414
INTEGER MARKD,STOPD#                   Pekpik map line buffer 2         CP   415
INTEGER MARKE,STOPE#                   Pekpik map line buffer 3         CP   416
INTEGER MARKF,STEPF,STOPF## Atom section of qx for assignment to p      CP   417
INTEGER MARKG,STOPG,STEPG#                                              CP   418
INTEGER MARKH,STOPH,STEPH,SIZEH#       Fourr mark2                      CP   419
INTEGER MARKI,STOPI,STEPI,SIZEI#       Fourr mark3                      CP   420
INTEGER MARKJ,STOPJ,STEPJ#             Fourr mark4                      CP   421
INTEGER MARKK,STOPK,STEPK#             Fourr mark5                      CP   422
INTEGER MARKL,STOPL,STEPL#             Fourr mark6                      CP   423
INTEGER MARKN,STOPN,IATM,STEPN#        Fc atom list                     CP   424
INTEGER MARKO,STOPO,STEPO#                                              CP   425
INTEGER MARKP,STOPP,STEPP#                                              CP   426
INTEGER MARKS,STOPR,STOPS,STEPS,STOPS1# Start-1 of sym matrices         CP   427
INTEGER MARKT,STEPT,STOPT#  ## Section of qx with special intracluste   CP   428
INTEGER MARKZ#                                                          CP   429
INTEGER INNP1#                                                          CP   430
INTEGER INORGX1#                                                        CP   431
INTEGER INXORG1#                                                        CP   432
INTEGER LOOP#                                                           CP   433
INTEGER LEVEL#              ## Desired level (depth) of search          CP   434
INTEGER DMP#                ## Desired listing level                    CP   435
INTEGER NARANG#             ## Number of ranges of atomic Z groups      CP   436
INTEGER ARANGE#             ## current atom range                       CP   437
INTEGER ITMODE#             ## Iteration mode for major loop            CP   438
INTEGER ATPROM#             ## Promote atom types based on B ?yes:/n    CP   439
INTEGER HEAVY#              ## Heavy atoms present flag ?               CP   440
INTEGER ORGANIC#            ## Contains H and C flag ?                  CP   441
INTEGER ASSMRK#             ## limit of assigned atom types             CP   442
INTEGER STPMRK#             ## Limit of peaks examined                  CP   443
INTEGER MAT(16)#            ## Next modelled atom type                  CP   444
INTEGER MAL(16)#            ## location of modelled atom type change    CP   445
INTEGER EATL(16)#           ## location of expected atom type change    CP   446
INTEGER DAREC#              ## Direct access solution   record          CP   447
INTEGER DACREF#             ## Direct access reflection record          CP   448
INTEGER ATEX#               ## Expected atoms per cell                  CP   449
INTEGER MOLZ#               ## Molecular units per cell                 CP   450
INTEGER SOLVED#             ## Is structure solved yet ?                CP   451
INTEGER VIABLE#             ## Is  phase/model structure viable ?       CP   452
INTEGER ONEOFF#             ## Default option for best solution         CP   453
INTEGER REFMOD#             ## Reflection mode GEns=1;All=0;evals>1.0   CP   454
INTEGER XCEPT#              ## exception raised flag                    CP   455
INTEGER SYMXMOL#    ## extend peaks for internal molecular symmetry     CP   456
INTEGER ATZORD(16)# ## Decreasing Z ordered list of atom types          CP   457
INTEGER AZODIF(16)# ## Ordered list of pointers to decreasing Z dif     CP   458
INTEGER MXPHST#     ## Maximum number of best phase sets to analyse     CP   459
INTEGER MAPTYP#             ## Difference map yes/no switch             CP   460
INTEGER SIGMUL#                                                         CP   461
#                                                                       CP   462
#                                                                       CP   463
#                                                                       CP   464
INTEGER BEST1(20)#          ## Fragment best matching subcluster i      CP   465
INTEGER IMF#                ## Signal better cluster or fragment matc   CP   466
INTEGER IND(3)#             ## Index eigenvectors for ls, ms and othe   CP   467
INTEGER ISTART#             ## Pointer to starting site for interp      CP   468
INTEGER MAXBON#             ## Maximum number of bonds allowed to ato   CP   469
INTEGER MTERP#              ## Max no. of interpretations per cluster   CP   470
INTEGER MAXGRP#             ## Max.no. of atoms or sites in frag/subc   CP   471
INTEGER MSUB#               ## No. of subclusters in curr. cluster      CP   472
INTEGER NATOM#              ## Mo. of expected atom sites               CP   473
INTEGER NBOND#              ## Total number of intersite bonds (redun   CP   474
INTEGER NCLUS#              ## Number of cluster under consideration    CP   475
INTEGER NFRAG#              ## Number of discrete fragments entered     CP   476
INTEGER NINFR(20)#          ## Number of atoms in fragment              CP   477
INTEGER NPKCL(32)#          ## Number of sites in each cluster          CP   478
INTEGER NSUB(20)#           ## No. of sites in each subcluster          CP   479
INTEGER NTERP#              ## Count of interps. done for current clu   CP   480
INTEGER TCLUS#              ## Total number of clusters                 CP   481
REAL ANGMAX,ANGMIN#         ## Max and min angles for subclusters       CP   482
REAL RADMAX,RADMIN#         ## Max and min site radii for clusters      CP   483
REAL TOPFOM#                ## Fig. of merit for best interp or match   CP   484
REAL FOMF#                  ## Figure of merit for frag interp.         CP   485
REAL FOMP#                  ## Figure of merit for site interp.         CP   486
REAL FRMIN#                 ## F rel R-Factor                           CP   487
REAL FRBEST#                ## Global best                              CP   488
REAL REFREL#                ## Number of reflections used for FREL      CP   489
REAL TIMEXX,TIMEXY#                                                     CP   490
#                                                                       CP   491
#     INTEGER COMMON                                                    CP   492
#     --------------                                                    CP   493
#                                                                       CP   494
COMMON /COMICP/$#                                                       CP   495
$## ---------------                     Gentan COMIGT                   CP   496
BOT,EFOM,FIX,ICNT,ISEL,INPH,IQPS,IXVF,IWGT,#                            CP   497
MSEL,MXIT,MXPS,MQ,MG,#                                                  CP   498
MSTR,NANT,NLIM,NODR,NONR,NPER,NPST,NPSI,NGEN,#                          CP   499
LEDR,MODE,NMAG,NQPS,NSEL,NSTR,NTES,NTOT,NTYP,#                          CP   500
PERI,PERN,PERS,TOP,NOPS,PSET,NCUT,SEED1,SEED2,TYPE,#                    CP   501
IACC,KEY,#                                                              CP   502
$## ---------------                     FOURR COMIF1                    CP   503
MXPHST,IHMAX,MAXH,IH2MAX,IH3MAX,ICEL,IMAP,INCX,INCT,ORGX,ORGX1,ORGT,#   CP   504
ISUM1,ISUM2,ISUM3,IXINC,IXORG,JSUM1,INNP1,INORGX1,INXORG1,#             CP   505
$## ---------------                     FOURR COMIF2                    CP   506
JSUM2,JSUM3,NG,NP,SPAN,NSCL,GRID,NPP1,NROT,NRSZ,NSYM,PASSES,#           CP   507
$## ---------------                     PEKPIK COMIPP                   CP   508
MXPEAK,ISYM,LTYP,NPEAKS,NPTS,#                                          CP   509
$## ---------------                     PEKPIK COMIFC                   CP   510
IATM,ISCF,NATM,IRAD,NSCF,NATYP,OFF,SYMXMOL,ITMODE,ATPROM,#              CP   511
$## ---------------                     MODEL COMIML                    CP   512
BEST1,IMF,IND,ISTART,MTERP,MSUB,NATOM,NCLUS,NBOND,NFRAG,NINFR,#         CP   513
MAXBON,NPKCL,NSUB,NTERP,TCLUS,#                                         CP   514
MARKF,STEPF,STOPF,MARKT,STEPT,STOPT,MAXGRP,#                            CP   515
$## ---------------                     COMMON                          CP   516
IFORCE,MAT,MAL,EATL,HEAVY,ORGANIC,ASSMRK,STPMRK,#                       CP   517
FVOL,ATEX,MOLZ,DSNM,ETYP,SOLVED,VIABLE,REFMOD,PERM,ONEOFF,#             CP   518
LPSET,MARK,DAREC,DACREF,LOOP,NARANG,ARANGE,LEVEL,DMP,#                  CP   519
MARK0,MARKS,MARK2,MARK3,MARK4,MARKM,MARK5,MARK6,MARK7,MARK8,MARK9,#     CP   520
MARKA,MARKB,MARKC,MARKD,MARKE,MARKG,MARKH,MARKI,MARKJ,MARKK,MARKL,#     CP   521
STOPR,STOPS,STOPS1,STOPM,STOP5,STOPA,STOPB,STOPC,STOPD,STOPE,STOPG,#    CP   522
STOPH,STOPI,STOPJ,STOPK,STOPL,STOPA1,STOP8,STOP9,#                      CP   523
STEPS,STEP5,STEPA,STEPB,STEPG,STEPH,STEPI,STEPJ,STEPK,STEPL,#           CP   524
SIZEH,SIZEI,STEP8,STEP9,MARK10,STEP10,STOP10,#                          CP   525
MARKO,STOPO,STEPO,#                                                     CP   526
MARKP,STOPP,STEPP,#                                                     CP   527
MARKC1,MARKN,STOPN,STEPN,MARKZ, XCEPT,MAPTYP,PHSPEC#                    CP   528
#                                                                       CP   529
#     REAL  COMMON                                                      CP   530
#     ------------                                                      CP   531
#                                                                       CP   532
COMMON /COMFCP/$#                                                       CP   533
$## ---------------                     GENTAN COMFGT                   CP   534
A2MX,AMIN,AMOS,BIAS,CONV,EMIN,EPAR,FMIN,FREJ,#                          CP   535
FMAX,FRAC,PFAC,RATE,SIGA,MDSI,SCAL,#                                    CP   536
STMN,STYP,SIVC,STMX,WFOM,WMIN,XVMN,XVMX,XSLO,XSHI,XSMN,XSMX,#           CP   537
SUMR,RWGT,FOPT,MXTG,MXQG,SUMX,#                                         CP   538
$## ---------------                     FOURR  COMFSS                   CP   539
DENMAX,DENMIN,PPANG,CELLC,E000,F000,SCALE,#                             CP   540
VOL,XLO,XHI,TRAND,TRANR,CMETR,RMETR,#                                   CP   541
$## ---------------                     PEKPIK COMFPP                   CP   542
DMIN,PLIM,PMIN,RES,G1,G2,G3,G5,G6,G9,#                                  CP   543
$## ---------------                     FC     COMFFC                   CP   544
BOVL,DSTL,FMUL,GBOVL,GSCAL,ATA,ATR,ATZ,#                                CP   545
$## ---------------                     MODEL  COMFML                   CP   546
TIMEXX,TIMEXY,SIGMUL,MNRSOL,TSPEC,#         
ANGMAX,ANGMIN,RADMAX,RADMIN,FOMF,FOMP,FRMIN,FRBEST,REFREL,#             CP   548
TOPFOM,PSFOM,PSLFOM,FRACIN,ATZORD,ATZDIF,AZODIF,ATNC,BREJECT#           CP   549
endext:#                                                                CP   550
#                                                                       CP   551
systemheader:(CP00)#                   Add refln data to bdf            CP00   1
##############################################################          CP00   2
#                                                            #          CP00   3
#                          CP00                              #          CP00   4
#                                                            #          CP00   5
##############################################################          CP00   6
SUBROUTINE CP00#                                                        CP00   7
include:(AACOMN)#                                                       CP00   8
include:(CPCOMN)#                                                       CP00   9
#                                                                       CP00  10
INTEGER TRIALS,I,J,L#                                                   CP00  11
INTEGER LOOPMX#                                                         CP00  12
INTEGER III,JJJ,FLAG,IPNT,JPNT,GN#                                      CP00  13
INTEGER PSPITR,MAXTRY,PSPTRY#                                           CP00  14
INTEGER PHSET#      ## Phase set number for emap                        CP00  15
chardata:(CP5," Peak identification process                    $#       CP00  16
                     ")#                                                CP00  17
chardata:(CP51A,"$#                                                     CP00  18
 Peaks only - not identified or refined $#                              CP00  19
 Peaks identified according to formula  $#                              CP00  20
 Peaks identification is iterated       $#                              CP00  21
 Peaks identification is extended       ")#                             CP00  22
chardata:(CP61,-)#                                                      CP00  23
chardata:(CP63,' 2. E-map peak search & type assignment')#              CP00  24
chardata:(CP001,$#                                                      CP00  25
" Trialing phase set XXXX(     )-                                    ")#CP00  26
chardata:(CP002,-)#                                                     CP00  27
chardata:(CP003," searching for peaks in an EMAP")#                     CP00  28
chardata:(CP004," invoking CELCON expectations")#                       CP00  29
chardata:(CP005," looking for an extended solution")#                   CP00  30
chardata:(CP006," Beginning iteration  xxx")#                           CP00  31
datastuff:#                                                             CP00  32
#                                                                       CP00  33
FILEXT(ioda1:)   ='SOL'#               Extension for struc solns        CP00  34
FILEXT(ioda2:)   ='XXB'#               Extension for reflection file    CP00  35
FILEXT(IOUNIT(4))='INV'#               Extension for ip invariant fil   CP00  36
FILEXT(iofm1:)   ='CP0'#               Potential re-entrant fmt file    CP00  37
FILEXT(iofm2:)   ='CP1'#               Potential re-entrant fmt file    CP00  38
IOMARK(1)=QXSTR#                       Start of bdf input buffer        CP00  39
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of bdf output buffer       CP00  40
IOMARK(3)=IOMARK(2)+bdfbuf:#           Start of filec output buffer     CP00  41
IOMARK(4)=IOMARK(3)+bdfbuf:#           Start of invariant file buffer   CP00  42
IOMARK(5)=IOMARK(4)+bdfbuf:#           Start of invariant file buffer   CP00  43
MARK0=IOMARK(5)+bdfbuf:#               Mark start of sin/cos table      CP00  44
incrqx:(MARKS,MARK0+452,CP0001)#       Expand qx .........gt0110        CP00  45
#                                                                       CP00  46
#  LOAD AND ORGANISE DATA FOR DIRECT METHODS AND FOURIER RECYCLING      CP00  47
#  ---------------------------------------------------------------      CP00  48
#                                                                       CP00  49
MAPTYP=emap:#                          Intend to use direct methods     CP00  50
CALL CP01#                             Initializations                  CP00  51
catchexception:#                       Abandon ship                     CP00  52
CALL CP02#                             Read cell:symm:scat:expl:dset:   CP00  53
CALL CP03#            ## GT01          Read Control lines  and .inv     CP00  54
CALL CP10#            ## GT02          Get  starting phases from bdf    CP00  55
#                                      If atoms on bdf calc phase?      CP00  56
catchexception:#                       Abandon ship                     CP00  57
CALL CP11#            ## GT02          Enter invariants                 CP00  58
#                                                                       CP00  59
#  IF INSUFFICIENT ODRS DETERMINE HARKER VECTORS FROM PATTERSON MAP     CP00  60
#  ----------------------------------------------------------------     CP00  61
#                                                                       CP00  62
IF(MAPTYP==vect:)#                     Inadequate odrs                  CP00  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP00  64
CALL CP12#                             Calculate pot harker vectors     CP00  65
CALL CP04#            ## FS20          accomodate users requests        CP00  66
CALL CP05#            ## FS30          Initialize Fourr params once     CP00  67
REFMOD=-1#                             Use generators for patterson m   CP00  68
CALL CP20#            ## PP01/PP02     Get MEM for FFT and pekpik       CP00  69
REPEAT#                                Loop over required passes        CP00  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP00  71
CALL CP22#            ## FS50          Calc bl summation 1              CP00  72
IF(PASSES==0)BREAK#                    Quit when pass count = 0         CP00  73
CALL CP25#            ## FS70          Cal fft summations 2&3+PEKPIK    CP00  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP00  75
CALL CP39#            ## PP05          SORT peaks according to heigh    CP00  76
CALL CP51#            ## Compare patterson and Harkers                  CP00  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP00  78
#                                                                       CP00  79
#  (RE)CONFIGURE FOR PHASED FFT MAP TYPES                               CP00  80
#  --------------------------------------                               CP00  81
#                                                                       CP00  82
IF(HEAVY!=no:) WFOM(3)=0.0#            Eliminate psi zeros from fom     CP00  83
MAPTYP=emap:#                          Set params for direct methods    CP00  84
STOP8=MARK8#                                                            CP00  85
CALL CP04#            ## FS20          accomodate users requests        CP00  86
CALL CP05#            ## FS30          Initialize Fourr params once m   CP00  87
#                                      And set grid size                CP00  88
#                                                                       CP00  89
#  LOOP FOR REQUESTED NUMBER OF PHASE SETS                              CP00  90
#  ---------------------------------------                              CP00  91
#                                                                       CP00  92
#    MXPS            -1000 PHASE SETS TOTAL                             CP00  93
#    MXPHST            120 PHASE SETS TO EXTENSIVELY TRIAL              CP00  94
#        PSPITR        100 PHASE SETS IN A GROUP                        CP00  95
#            MAXTRY     10 GROUPS OF PHASES                             CP00  96
#               PSPTRY  1 PHASE SETS TO EXTENSIVELY TRIAL IN THAT GROUP CP00  97
#                                                                       CP00  98
III=0;JJJ=0#                           Numb phase sets genertd/studie   CP00  99
IF(MXPHST==1)ONEOFF=yes:#              Only looking for first good so   CP00 100
IF(MXPS>0)#                                                             CP00 101
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP00 102
MAXTRY=MXPHST/12#                                                       CP00 103
IF(MAXTRY*12<MXPHST)MAXTRY=MAXTRY+1#                                    CP00 104
PSPTRY=MXPHST/MAXTRY#                  Phase sets per trial to look a   CP00 105
PSPITR=MXPS/MAXTRY#                    How many phase sets to try       CP00 106
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP00 107
ELSE#                                  Special dummy options            CP00 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP00 109
MXPS=-MXPS#                            Remove the flag                  CP00 110
IF(MXPS<=10000) PSPITR=100#            Batches of 100                   CP00 111
ELSE            PSPITR=500#            Batches of 500                   CP00 112
MAXTRY=MXPS/PSPITR#                    How many batches of 500          CP00 113
MXPHST=MAXTRY#                         Trial 1 per trial                CP00 114
PSPTRY=1#                              Only look at best of the batch   CP00 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP00 116
#                                                                       CP00 117
IF(PHSPEC(1)!=0)#                      User only wants selective from   CP00 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP00 119
MXPS=0#                                A previous run                   CP00 120
DO I=2,40;MXPS=MAX(MXPS,PHSPEC(I))#    Get max required                 CP00 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP00 122
#                                                                       CP00 123
DO TRIALS=1,MAXTRY#                    This number of trials            CP00 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP00 125
#                                                                       CP00 126
TYPE=0#                                                                 CP00 127
#                                                                       CP00 128
DO I=1,psetlim:;DO J=1,savepsfom:;PSFOM(J,I)=0.# Reset specs            CP00 129
IF(TRIALS>1)#                          Checking out random solutions    CP00 130
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP00 131
TYPE=0#                                Reset as random                  CP00 132
NODR=0;NPER=0#                         Configure for random             CP00 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP00 134
IF(TRIALS<=1)#                         Attempt to use odr/edr/perm fi   CP00 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP00 136
NSEL=10000#                                                             CP00 137
NSTR=0#                                                                 CP00 138
CALL CP14#           ## GT04           Arrange structure invariants     CP00 139
TYPE=0#                                Reset as random                  CP00 140
NMAG=0#                                No magic permutes                CP00 141
NODR=0;NPER=0#                         Configure for random             CP00 142
CALL CP15#           ## GT05           List params & init phase loop    CP00 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP00 144
#                                                                       CP00 145
#   LOOP FOR PHASE SETS PER ITERATION                                   CP00 146
#   ---------------------------------                                   CP00 147
#                                                                       CP00 148
pt1: $(LINCT=0;LINRM=3 $)#             Force pagination                 CP00 149
DO PHSET=1,PSPITR#                     For all permutations of start    CP00 150
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP00 151
III=III+1#                             Incremement number of sets       CP00 152
CALL CP16(PHSET,III)# ## GT09          Block tangent process            CP00 153
IF (VIABLE==yes:)    CALL CP18#        Save if good enough              CP00 154
IF(III>=MXPS)BREAK#                    Break after max request psets    CP00 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP00 156
#                                                                       CP00 157
#                                                                       CP00 158
#                                                                       CP00 159
pt5:#                                                                   CP00 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP00 161
WRITE(6,'(//a,I5,a)')"-----------Trialed ",III, " phase sets"#          CP00 162
WRITE(6,'(12F6.3)')(PSFOM(1,I),I=1,LPSET)#                              CP00 163
WRITE(6,'(12F6.0)')(PSFOM(2,I),I=1,LPSET)#                              CP00 164
WRITE(6,'(12F6.0)')(PSFOM(3,I),I=1,LPSET)#                              CP00 165
WRITE(6,'(12F6.3)')(PSFOM(4,I),I=1,LPSET)#                              CP00 166
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP00 167
#                                                                       CP00 168
#  CHECK BEST LPSET PHASE SOLUTIONS                                     CP00 169
#  --------------------------------                                     CP00 170
#                                                                       CP00 171
IF(DAREC==0)#                          Only print first time through    CP00 172
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP00 173
CHROT=' '#                             Erase the string                 CP00 174
movechar:(CP61,1,CHROT,2,NCP63-1,1)#   Underline header                 CP00 175
writeline:(1,CP63,NCP63,2,3)#          Print  stage 2 - peak search     CP00 176
movechar:(CP51A,LEVEL*40+1,CP5,35,40,0)# Insert header                  CP00 177
writeline:(1,CP5,NCP5,3,3)#            Print  study depth level         CP00 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP00 179
#                                                                       CP00 180
FLAG=no:#                                                               CP00 181
FOR(PHSET=1;PHSET<=LPSET;PHSET=PHSET+1)#                                CP00 182
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP00 183
IF(PHSET>PSPTRY&TRIALS!=MAXTRY)BREAK#  Exceeded number per trial        CP00 184
IF(JJJ+1>MXPHST) BREAK#                Exceeded max requested number    CP00 185
JJJ=JJJ+1#                             Increment the studied counter    CP00 186
IF    (LEVEL==0)CP001(33^)=CP003#      Just getting peaks               CP00 187
ELSEIF(LEVEL==1)CP001(33^)=CP004#      Doing basic celcon assignments   CP00 188
ELSE            CP001(33^)=CP005#      Iterative celcon, but no extra   CP00 189
#                                      Iterative with additionals       CP00 190
IF    (LEVEL==0)L=NCP003#              Just getting peaks               CP00 191
ELSEIF(LEVEL==1)L=NCP004#              Doing basic celcon assignments   CP00 192
ELSE            L=NCP005#              Iterative celcon, but no extra   CP00 193
ncodefld:(FLOAT(JJJ),1,CP001,240513.,1)# Encode studied number          CP00 194
ncodefld:(PSFOM(9,PHSET),1,CP001,300513.,1)# Encode actual number       CP00 195
movechar:(CP002,1,CHROT,2,33+L,2)#     Underline heading in buffer      CP00 196
pt1: writeline:(1,CP001,NCP001,2,3)#   Print parameter heading          CP00 197
#                                                                       CP00 198
IPNT=phin:(MARK6)+NINT(PSFOM(2,PHSET))#                                 CP00 199
JPNT=wgtn:(MARK6)+NINT(PSFOM(2,PHSET))#                                 CP00 200
FOR(GN=MARK6;GN<MQ;GN=GN+MARK)#        Loop over generator list         CP00 201
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP00 202
phi:=QX(GN+IPNT)#                      Recover best phases              CP00 203
wgt:=QX(GN+JPNT)#                      Recover associated weight        CP00 204
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP00 205
IF(FRMIN>0.3)SCAL=GSCAL#               Reset genev scale                CP00 206
IF(FRMIN>0.3)BOVL=GBOVL#               Reset genev bovl                 CP00 207
STOP8=MARK8#                           Erase previous saved sites       CP00 208
NARANG=2#                              Initialize                       CP00 209
#                                                                       CP00 210
#   BEGIN FOURIER RECYCLING ITERATIONS OVER NTH PHASE SET               CP00 211
#   -----------------------------------------------------               CP00 212
#                                                                       CP00 213
REFMOD=1#                              Use generators for first emap    CP00 214
VIABLE=yes:#                           Assume will be viable            CP00 215
MAPTYP=emap:#                          Start with an emap               CP00 216
LOOPMX=NARANG+2#                       Maximum number of cycles         CP00 217
IF(HEAVY==no:&ATEX/NSYM>=40)LOOPMX=NARANG+4# Extra cycles for tenuous   CP00 218
FOR(LOOP=1;LOOP<=LOOPMX;LOOP=LOOP+1)#  See if phase/model improves      CP00 219
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP00 220
CHROT=' '#                             Initialize to blank              CP00 221
movechar:(CP002,1,CHROT,2,NCP006-1,2)# Underline heading in buffer      CP00 222
ncodefld:(FLOAT(LOOP),1,CP006,250313.,1)# Encode loop value             CP00 223
pt1: writeline:(1,CP006,NCP006,2,3)#   Print loop cycle number          CP00 224
ATPROM=no:#                            No atom type promotions          CP00 225
IF(LEVEL==1)LOOP=NARANG#               Invoke all expected sites        CP00 226
IF(LEVEL==1)ATPROM=yes:#               Allow b-based type promotions    CP00 227
#                                                                       CP00 228
CALL CP20#            ## PP01/PP02     Get MEM for FFT and pekpik       CP00 229
REPEAT#                                Loop over required passes        CP00 230
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP00 231
CALL CP22#            ## FS50          Calc bl summation 1              CP00 232
IF(PASSES==0)BREAK#                    Quit when pass count = 0         CP00 233
CALL CP25#            ## FS70          Cal fft summations 2&3+PEKPIK    CP00 234
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP00 235
CALL CP39#            ## PP05          SORT peaks according to heigh    CP00 236
IF(LEVEL==0) BREAK#                    Just want the peak list          CP00 237
IF(VIABLE==no:) BREAK#                 Abnormal peak hights             CP00 238
IF(MAPTYP!=fdif:)CALL CP40#            Peak height/diff atom typ asgn   CP00 239
ELSE             CALL CP46#            Map holes and peaks onto atoms   CP00 240
CALL CP41#            ## ML13          Cluster peaks - set bond list    CP00 241
#                                                                       CP00 242
CALL CP70(STOPT)#     ## FC03          accumulate all dependent sites   CP00 243
FRMIN=9.9E+12#                         Reset                            CP00 244
REFMOD=-1#                             Recalculate for all refs         CP00 245
#                                                                       CP00 246
CALL CP72(5)#         ## FC05          Refine SKF/UOV & Calc fcal+phi   CP00 247
FRBEST=MIN(FRMIN,FRBEST)#              Save for posterity               CP00 248
CALL CP79#                             Peaklist eliminatn by diag lsq   CP00 249
FRBEST=MIN(FRMIN,FRBEST)#              Save for posterity               CP00 250
#                                                                       CP00 251
IF(LEVEL==1)            BREAK#         Just the first approximation     CP00 252
IF(HEAVY!=no:)#                        For heavy atom structures        CP00 253
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP00 254
IF(FRMIN>0.7)              VIABLE=no:# Don't mess with garbage          CP00 255
IF(LOOP>=NARANG&FRMIN>0.4) VIABLE=no:# Don't mess with garbage          CP00 256
IF(LOOP> NARANG&FRMIN>0.35)VIABLE=no:#                                  CP00 257
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP00 258
ELSE#                                  For light atom structures        CP00 259
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP00 260
IF(FRMIN>0.7)              VIABLE=no:# Don't mess with garbage          CP00 261
IF(LOOP>=NARANG&FRMIN>0.45)VIABLE=no:# Don't mess with garbage          CP00 262
IF(LOOP> NARANG&FRMIN>0.35)VIABLE=no:# Don't mess with garbage          CP00 263
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP00 264
IF(VIABLE==no:)         BREAK#         Obviously not                    CP00 265
CALL CP49#                             Compare marka with prev mark8    CP00 266
IF(FRMIN<0.2)           SOLVED=yes:#   Rfactor is good enough           CP00 267
IF(SOLVED==yes:&LOOP>NARANG&MAPTYP==fdif:)BREAK# At least one cycle e   CP00 268
#                                                                       CP00 269
# PREPARE FOR NEXT CYCLE                                                CP00 270
# ----------------------                                                CP00 271
#                                                                       CP00 272
IF(LOOP==LOOPMX)       BREAK#          Getout before atoms overwritte   CP00 273
CALL CP50#                             Save new atom solution in mark   CP00 274
REFMOD=-1#                             Use all reflections- hardwired   CP00 275
CALL CP72(1)#         ## FC05          Calc fcal and phase              CP00 276
FRBEST=MIN(FRMIN,FRBEST)#              Save for posterity               CP00 277
IF(HEAVY> 0&LOOP>=NARANG-1&FRMIN<0.20) MAPTYP=fdif:# Do a difmap next   CP00 278
IF(HEAVY==0&LOOP>=NARANG  &FRMIN<0.35) MAPTYP=fdif:# Do a difmap next   CP00 279
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP00 280
#                                                                       CP00 281
#  END OF STRUCTURAL ELUCIDATION CYCLES                                 CP00 282
#  ------------------------------------                                 CP00 283
#                                                                       CP00 284
IF(LEVEL<=1\(VIABLE==no:&IFORCE==yes:))#                                CP00 285
CALL CP97(JJJ,TRIALS,PSPITR,MAXTRY,PHSET,0)#                            CP00 286
IF(VIABLE==no:) NEXT#                  Stop here                        CP00 287
IF(LEVEL<=1)    NEXT#                  Only wanted the peaklist         CP00 288
#                                                                       CP00 289
#                                      Must be viable                   CP00 290
ATPROM=yes:#                           Permit atom type promotions      CP00 291
CALL CP80#                             Final refinement                 CP00 292
FRBEST=MIN(FRMIN,FRBEST)#              Save for posterity               CP00 293
CALL CP82#                             Thermal motion test for c/n/o    CP00 294
CALL CP83#                             Update the marka array           CP00 295
CALL CP72(1)#         ## FC05          Calc final FRMIN                 CP00 296
FRBEST=MIN(FRMIN,FRBEST)#              Save for posterity               CP00 297
CALL CP97(JJJ,TRIALS,PSPITR,MAXTRY,PHSET,1)# Dump mark8 soln            CP00 298
IF(SOLVED==yes:&ONEOFF==yes:)GOTO 100# Solved the once-off solution     CP00 299
#                                      Else try next phase solution     CP00 300
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP00 301
#                                                                       CP00 302
#  END OF PHASE SET REFINEMENTS                                         CP00 303
#  ----------------------------                                         CP00 304
#                                                                       CP00 305
LPSET=0#                               Reset                            CP00 306
IF(III>=MXPS)BREAK#                    Just enough phase sets now       CP00 307
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP00 308
#                                                                       CP00 309
IF(DAREC==0)#                          There were no suitable phases    CP00 310
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP00 311
WRITE(6,*)'NO PHASE SETS WERE GOOD ENOUGH!'#                            CP00 312
GOTO 300#                              Finish                           CP00 313
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP00 314
#                                                                       CP00 315
#                                                                       CP00 316
#                                                                       CP00 317
#                                                                       CP00 318
100 CONTINUE#                                                           CP00 319
IF (DAREC!=0) closedac:(ioda1:)#       Close file if written            CP00 320
IF (DACREF!=0) closedac:(ioda2:)#      Close file if written            CP00 321
rewindbdf:(1)#                                                          CP00 322
#                                                                       CP00 323
IF(DAREC!=0)#                                                           CP00 324
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CP00 325
openfmt:(iofm2:,' ')#                  Reopen the file                  CP00 326
writefmt:(iofm2:,'(A)','PIG  msol ')#  Run pig to look at multiple so   CP00 327
IF(LEVEL>=1)writefmt:(iofm2:,'(A)','hide  PK ')# Hide peaks initially   CP00 328
LINFLG=1#                              Force to read another line       CP00 329
IF((CHRIN(1^4)!='END ')&(CHREOF!=1))#  Next inpt line isn't end or eo   CP00 330
writefmt:(iofm2:,'(A)',CHRIP(1^80))#   Write header to file             CP00 331
closefmt:(iofm2:)#                                                      CP00 332
linestream:('CP1')#                    Run addatm/pig in line stream    CP00 333
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CP00 334
#                                                                       CP00 335
300 CONTINUE#                                                           CP00 336
#                                                                       CP00 337
RETURN#                                                                 CP00 338
END#                                                                    CP00 339
systemheader:(CP01)#                   Some initializations             CP01   1
# ####################################################################  CP01   2
#                                                                       CP01   3
#                                CP01                                   CP01   4
#                                                                       CP01   5
# ####################################################################  CP01   6
SUBROUTINE CP01#                                                        CP01   7
include:(AACOMN)#                                                       CP01   8
include:(CPCOMN)#                                                       CP01   9
#                                                                       CP01  10
INTEGER I,J,M,N,XIST,GO4IT#                                             CP01  11
INTEGER PSIZ,IP#                                                        CP01  12
chardata:(CP1, CRISP CONTROL PARAMETERS)#                               CP01  13
chardata:(CP2,-=)#                                                      CP01  14
chardata:(CP6,' Print verbosity level preset at                ')#      CP01  15
chardata:(CP61," normal (0)  low dmp (1) med dmp (2)  hi dmp (3)  $#    CP01  16
 hi dmp (4)  xhi dmp (5)  xhi dmp (6) ")#                               CP01  17
chardata:(CP62," Calculation Stages  1. Direct methods phasing   ")#    CP01  18
chardata:(CP63,"                     2. E-map peak search and ID ")#    CP01  19
chardata:(CP64,"                     3. SFLS refinement of sites ")#    CP01  20
chardata:(CP7,DSET EMIN RMAX TRIA BEST PROB OPTI LIST PBDF NACC $#      CP01  21
NBDF PACC FVOL FORC XXXX ZZZZ RMIN TEMP )#             
chardata:(CP8," GENSIN invariant file (.inv) not present -")#           CP01  23
chardata:(CP9," Spawning GENEV and GENSIN calculations ...")#           CP01  24
datastuff:#                                                             CP01  25
#                                                                       CP01  26
# IS PREREQUISITE INVARIANT FILE PRESENT?                               CP01  27
# ---------------------------------------                               CP01  28
#                                                                       CP01  29
XCEPT=0#                               No exceptions                    CP01  30
inquirefile:(IOUNIT(4),XIST,' ')#      Are the invariants there:        CP01  31
IF(XIST==0)#                           Throw an exception               CP01  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP01  33
openfmt:(iofm1:,' ')#                                                   CP01  34
writefmt:(iofm1:,'(A)','GENEV ')#      Genev to reentrant file          CP01  35
writefmt:(iofm1:,'(A)','GENSIN ')#     Gensin to reentrant file         CP01  36
writefmt:(iofm1:,'(A)', CHRIP(1^80))#  Redo the crisp line              CP01  37
pt0: writeline:(2,CP8,NCP8,3,1)#       Output message                   CP01  38
pt0: writeline:(0,CP9,NCP9,3,1)#       Output message                   CP01  39
closefmt:(iofm1:)#                     Shut down the line file          CP01  40
linestream:('CP0')#                    Insert file into line stream     CP01  41
LINFLG=1#                              Force to read another line       CP01  42
XCEPT=1#                               Throw the exception              CP01  43
RETURN#                                Go no further                    CP01  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP01  45
#                                                                       CP01  46
# SET DEFAULTS                                                          CP01  47
# ------------                                                          CP01  48
#                                                                       CP01  49
LEVEL=2#                               Just look for startx celcon      CP01  50
LPSET=0#                                                                CP01  51
DMP=0#                                                                  CP01  52
ITMODE=lsqonly:#                                                        CP01  53
#SIGMUL=4.0                                                             CP01  54
SIGMUL=2.0#                                                             CP01  55
MNRSOL=0.3#                            Min R factor classed as solved
TSPEC=20.#                             expected temp factor range
#                                                                       CP01  56
#                                                                       CP01  57
FRBEST=9.9E+12#                        Initialize best to awful         CP01  58
ONEOFF=no:#                                                             CP01  59
MXPHST=1#                              Only look at best by default     CP01  60
DSNM=1.#                               Set default data set number      CP01  61
EMIN=0.#                               Set default e-min                CP01  62
NGEN=999999#                           Set default generator n0.        CP01  63
MXPS=150#                              Set default max phase sets       CP01  64
IACC=yes:#                             Default ref accelerator on       CP01  65
INPH=0#                                Do not use bdf phis              CP01  66
SOLVED=no:#                            Assume no struct solution        CP01  67
DO I=1,12;PSFOM(1,I)=0.0#              Initialize                       CP01  68
DO I=1,12;PSFOM(2,I)=0.0#              Initialize                       CP01  69
FRACIN=0.75#                           Assume assign all to begin       CP01  70
SYMXMOL=no:#                                                            CP01  71
BOVL=0.#                               Set default parameters           CP01  72
MAXH(1)=256; MAXH(2)=256; MAXH(3)=256# Default max h,k,l                CP01  73
DMIN=+99999.#                          Cutoff limits                    CP01  74
NPEAKS=10000#                          Number unique peaks expected     CP01  75
RES=.75#                               Desired resolution in angstr     CP01  76
ISUM1=0;ISUM2=0;ISUM3=0#               Zeroize sum directions           CP01  77
PPANG=4.#                              Default points per angstrom      CP01  78
FVOL=no:#                              Default volume is asymm unit     CP01  79
ETYP=1#                                Default /e/ value applied        CP01  80
STMN=0.;    STMX=2.#                   Default min/max st/l             CP01  81
DAREC=0#                               Initialize                       CP01  82
MAXBON=4#                              Maximum atomic coordination      CP01  83
RADMAX=1.0#                            Max allowed bond distance        CP01  84
RADMIN=0.5#                            Min allowed bond distance        CP01  85
ANGMAX=145#                            Max. allowed bond angle          CP01  86
ANGMIN=85#                             Min. allowed bond angle          CP01  87
MTERP=5#                               Max. no. of interpretations      CP01  88
MAXGRP=0#                              Max no. of atoms or sites        CP01  89
NFRAG=0#                               Counts of input fragments        CP01  90
DO I=1,3; IND(I)=1#                    Set indices for proj planes      CP01  91
DO J=1,3#                              Loop cell axes (1=x;2=y;3=z)     CP01  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP01  93
GRID(J)=0;  SPAN(J)=0#                 Zeroize grid & span numbers      CP01  94
INCT(J)=1; ORGT(J)=99999#              Zeroize grid incr & start        CP01  95
IMAP(J)=0#                             Zeroize as axis pointer          CP01  96
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP01  97
GO4IT=0#                               Temporary init                   CP01  98
IFORCE=no:#                                                             CP01  99
#                                                                       CP01 100
#   PROCESS PARAMETERS ON CRISP LINE                                    CP01 101
#   --------------------------------                                    CP01 102
#                                                                       CP01 103
FOR(I=1;BUFIN(I)<voidflg:;I=I+1)#      Loop over input options          CP01 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP01 105
stringlim:(I,M,N)#                     Get string limits                CP01 106
compchar:(CHRIN,M,CP7,1,4,5,NCP7,N)#   Identify input option            CP01 107
IF(N< 9\N>=17) I=I+1#                  Incr to numeric follower         CP01 108
IF(N==0) iquit:(CP0101,I)#             Unrecognised input option        CP01 109
IF(N==1) DSNM=NINT(bf:(I))#            Extract data set number          CP01 110
IF(N==2) EMIN=bf:(I)#                  Extract minimum e-value          CP01 111
IF(N==3) NGEN=ib:(I)#                  Extract number of generators     CP01 112
IF(N==4) MXPS=ib:(I)#                  Trial this many rand phase set   CP01 113
IF(N==5) MXPHST=MIN0(ib:(I),32)#       Look at best n phase sets        CP01 114
IF(N==6) ;#                            Prob???                          CP01 115
IF(N==7) LEVEL=MIN(5,MAX(0,ib:(I)))#   Level to investigate psets       CP01 116
IF(N==8) DMP=MIN(5,MAX(0,ib:(I)))#     Level to dump results            CP01 117
IF(N==9) INPH=1#                       Start phis at bdf values         CP01 118
IF(N==10)IACC=no:#                     Switch off ref accelerator       CP01 119
IF(N==13)FVOL=yes:#                    Set map volume to full           CP01 120
IF(N==14)IFORCE=yes:#                  Force writing, no matter how b   CP01 121
IF(N==15)MXPS=-1000#                   Go for 1000 phase sets           CP01 122
IF(N==16)MXPS=-10000000#               Go for ever (effectively)        CP01 123
IF(N==17)MNRSOL=bf:(I)#                Extract new minimum sol R factr
IF(N==18)TSPEC =bf:(I)#                Extract new Temp Range
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP01 124
readwpkt:(1,lrlabl:,PSIZ,IP,0)#        Open bdf archive                 CP01 125
#                                                                       CP01 126
movechar:(CP2,2,CHROT,2,NCP1-1,1)#     Underline heading in buffer      CP01 127
writeline:(1,CP1,NCP1,2,3)#            Print parameter heading          CP01 128
movechar:(CP61,DMP*12+1,CP6,35,12,0)#  Print level                      CP01 129
writeline:(1,CP6,NCP6,3,3)#            Report listing level             CP01 130
writeline:(1,CP62,NCP62,3,3)#          Print total phase sets           CP01 131
writeline:(0,CP63,NCP63,3,3)#          Print total phase sets           CP01 132
writeline:(0,CP64,NCP64,3,3)#          Print total phase sets           CP01 133
#                                                                       CP01 134
#                                                                       CP01 135
#                                                                       CP01 136
openfmt:(iofm2:,' ')#                                                   CP01 137
writefmt:(iofm2:,'(A)','GENEV ')#      Genev to reentrant file          CP01 138
writefmt:(iofm2:,'(A)',CHRIP(1^80))#   Crisp to reentrant file          CP01 139
#                                                                       CP01 140
RETURN#                                                                 CP01 141
END#                                                                    CP01 142
systemheader:(CP02)#                   Get all sym and scat info        CP02   1
####################################################################    CP02   2
#                                                                  #    CP02   3
#                             CP02                                 #    CP02   4
#                                                                  #    CP02   5
####################################################################    CP02   6
SUBROUTINE CP02#                                                        CP02   7
include:(AACOMN)#                                                       CP02   8
include:(CPCOMN)#                                                       CP02   9
#                                                                       CP02  10
INTEGER I,J,K,K1,N,L#                                                   CP02  11
INTEGER J2#                                                             CP02  12
INTEGER IWNT(10),IREL(10)#             Id nos. for x,y,z and name       CP02  13
INTEGER PSIZ,IP#                                                        CP02  14
INTEGER LPAK#                          Input packet length              CP02  15
REAL RADINC#                                                            CP02  16
REAL TEMP#                                                              CP02  17
REAL CVOL,SH(3)#                                                        CP02  18
REAL MAXP,ATZMX,CUM,NETOT#                                              CP02  19
REAL DIFMAX#                                                            CP02  20
INTEGER MAXDIF,SAV#                                                     CP02  21
string:(LABEL,24)#                                                      CP02  22
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              CP02  23
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              CP02  24
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              CP02  25
realdata:(TR21,[.3333333,.5])#                                          CP02  26
realdata:(TR22,[.6666667,0.])#                                          CP02  27
realdata:(TR23,[.6666667,.5])#                                          CP02  28
chardata:(CP020," Lattice contents")#                                   CP02  29
chardata:(CP021,'-yesno')#                                              CP02  30
chardata:(CP022," Lattice type           centrosymmetric     P")#       CP02  31
chardata:(CP023,PIRFABCPIRFABC)#                                        CP02  32
chardata:(CP024," Number of atom types on BDF            ")#            CP02  33
chardata:(CP025," Expected atoms per cell                ")#            CP02  34
chardata:(CP026," Molecules per cell                     ")#            CP02  35
chardata:(CP027," Atoms in asymmetric unit               ")#            CP02  36
chardata:(CP028," Structure contains heavy atoms         ")#            CP02  37
chardata:(CP029," Molecule is organic                    ")#            CP02  38
chardata:(CP02A," Scattering contents")#                                CP02  39
chardata:(CP02C," Atom types split into xxx atomic number ranges")#     CP02  40
chardata:(CP02E," Data set number                        ")#            CP02  41
chardata:(CP02F," Scale groups                           ")#            CP02  42
chardata:(CP02G," Scale factor                           ")#            CP02  43
chardata:(CP02H," UOVL    BOVL                           ")#            CP02  44
chardata:(CP02I," Max ref hkl                            ")#            CP02  45
chardata:(CP02J," Min max stol                           ")#            CP02  46
chardata:(CP02K,[ TYPE CELCON  ASYMCON EFFECTIVEZ CELCON>=Z$#           CP02  47
 RADIUS ZRANGE -1+Z(I-1)/ZI])#                                          CP02  48
realdata:(FMT1,[110613.,200713.,290613.,410613.,480732.,$#              CP02  49
550513.,0932.])#                                                        CP02  50
datastuff:#                                                             CP02  51
#                                                                       CP02  52
# BEGIN READING OF INPUT BINARY DATA FILE                               CP02  53
# -----------------------------------------                             CP02  54
#                                                                       CP02  55
FOR(K=1;K>0;K=K+1)#                    Loop over lrcell packets         CP02  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP02  57
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Read in cell record              CP02  58
IF(IP<=0) BREAK#                       Exit after last record           CP02  59
IF(K==1)movereal:(QX,IP+1,CELLC,1,PSIZ,0)# Save real cell constants     CP02  60
IF(K==4)movereal:(QX,IP+1,TRAND,1,PSIZ,0)# Save transformation matrix   CP02  61
IF(K==5)movereal:(QX,IP+1,TRANR,1,PSIZ,0)# Save transformation matrix   CP02  62
IF(K==6)VOL=QX(IP+1)#                  Save real cell volume            CP02  63
IF(K==7)movereal:(QX,IP+1,CMETR,1,PSIZ,0)# Save metric tensor           CP02  64
IF(K==8)movereal:(QX,IP+1,RMETR,1,PSIZ,0)# Save inv. metric tensor      CP02  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP02  66
G1=CMETR(1)#                           A**2                             CP02  67
G2=CMETR(2)*2.#                        2 a b cosg                       CP02  68
G3=CMETR(3)*2.#                        2 a c cosb                       CP02  69
G5=CMETR(5)#                           A**2                             CP02  70
G6=CMETR(6)*2.#                        2 b c cosa                       CP02  71
G9=CMETR(9)#                           C**2                             CP02  72
DO I=1,3#                              Loop over transformation matri   CP02  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP02  74
K=3*(I-1)#                             Set up index                     CP02  75
DO J=1,3; TRAND(K+J)=TRAND(K+J)/CELLC(I)# Normalize matrix              CP02  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP02  77
TEMP=CMETR(4)#                         Store element of metric tensor   CP02  78
CMETR(4)=CMETR(5)#                     Reset element                    CP02  79
CMETR(5)=TEMP#                         Reset element                    CP02  80
TEMP=RMETR(4)#                         Store element of inv. metric     CP02  81
RMETR(4)=RMETR(5)#                     Reset element                    CP02  82
RMETR(5)=TEMP#                         Reset element                    CP02  83
#                                                                       CP02  84
#   EXTRACT SYMMETRY INFORMATION (LRSYMM)                               CP02  85
#   ------------------------------------                                CP02  86
#                                                                       CP02  87
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Read first packet of symop r     CP02  88
LTYP=NINT(QX(IP+1))#                   Get out lattice type             CP02  89
ICNT=IABS(NINT(QX(IP+2))-1)#           Gentan   (nc=0,c=1)              CP02  90
NSYM=NINT(QX(IP+3))#                   Get out total symop count        CP02  91
NROT=NINT(QX(IP+4))#                   Extract number of matrices       CP02  92
NRSZ=NINT(QX(IP+5))#                   Extract no. same pattern zer     CP02  93
FMUL=     QX(IP+6)#                    Cell multiplicity                CP02  94
ifeq:(QX(IP+8),0.) MOLZ=NINT(QX(IP+3))# If z missing assume nsymops     CP02  95
ELSE MOLZ=NINT(MIN(QX(IP+3),QX(IP+8)))# Get min moles/cell              CP02  96
MOLZ=NSYM#                             Override!!                       CP02  97
IF(ICNT==1) LTYP=LTYP-7#                                                CP02  98
#                                                                       CP02  99
#                                                                       CP02 100
#                                                                       CP02 101
#                                                                       CP02 102
incrqx:(STOPS,MARKS+NSYM*12,CP0204)#   Incr qx........fs1006            CP02 103
incrqx:(STOPS1,STOPS+(2-ICNT)*NSYM*12,CP0204)# Incr qx........fs1006    CP02 104
FOR(J=1;J<NSYM*12;J=J+PSIZ)#           Loop over symop packets          CP02 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP02 106
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Point to next packet             CP02 107
IF(IP<=0) BREAK#                       Exit after last packet           CP02 108
movereal:(QX,IP+1,QX,MARKS+J,PSIZ,1)#  Store 12-element symops          CP02 109
movereal:(QX,IP+1,QX,STOPS+J,9,1)#     Store 9 -element symops          CP02 110
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP02 111
STOPR=MARKS+J-1#                       End of rotation symops           CP02 112
STEPS=PSIZ#                            Mark end & step of symmetry      CP02 113
K=STOPR;K1=STOPS+J-1;L=STOPS#          Set symm matrix pointer          CP02 114
IF(ICNT==1)#                           Test if centrosymmetric          CP02 115
FOR(J=MARKS;J<STOPR;J=J+1)#            Loop over symm matrices          CP02 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP02 117
K=K+1;K1=K1+1#                         Incr storage pointer             CP02 118
QX(K) =-QX(J+1)#                       Store inverse element            CP02 119
QX(K1)=-QX(L+1)#                       Store inverse element            CP02 120
L=L+1#                                                                  CP02 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP02 122
N=K#                                   Store temp end marker            CP02 123
IF(LTYP>1)#                            Test if sg centered              CP02 124
FOR(J=MARKS;J<N;J=J+STEPS)#            Loop over symm matrices          CP02 125
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP02 126
SH(1)=TR11(LTYP-1);SH(2)=TR12(LTYP-1);SH(3)=TR13(LTYP-1)#               CP02 127
movereal:(QX,J+1,QX,K +1,9,1)#         Transfer rot elements            CP02 128
movereal:(QX,J+1,QX,K1+1,9,1)#         Transfer rot elements            CP02 129
DO I=1,3 ; QX(K +9+I)=QX(J+9+I)+SH(I)# Transfer t1,t2,t3                CP02 130
DO I=1,3 ; QX(K1+9+I)=          SH(I)# Transfer t1,t2,t3                CP02 131
K=K+STEPS;K1=K1+STEPS#                 Incr storage pointer             CP02 132
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               CP02 133
SH(1)=TR21(LTYP-2);SH(2)=TR22(LTYP-2);SH(3)=TR23(LTYP-2)#               CP02 134
movereal:(QX,J+1,QX,K +1,9,1)#         Transfer rot elements            CP02 135
movereal:(QX,J+1,QX,K1+1,9,1)#         Transfer rot elements            CP02 136
DO I=1,3 ; QX(K +9+I)=QX(J+9+I)+SH(I)# Transfer t1,t2,t3                CP02 137
DO I=1,3 ; QX(K1+9+I)=          SH(I)# Transfer t1,t2,t3                CP02 138
K=K+STEPS;K1=K1+STEPS#                 Incr storage pointer             CP02 139
IF(LTYP!=4) NEXT#                      Skip if not f-centre             CP02 140
SH(1)=0.5;SH(2)=0.5;SH(3)=0.5#                                          CP02 141
movereal:(QX,J+1,QX,K +1,9,1)#         Transfer rot elements            CP02 142
movereal:(QX,J+1,QX,K1+1,9,1)#         Transfer rot elements            CP02 143
DO I=1,3 ; QX(K +9+I)=QX(J+9+I)+SH(I)# Transfer t1,t2,t3                CP02 144
DO I=1,3 ; QX(K1+9+I)=          SH(I)# Transfer t1,t2,t3                CP02 145
K=K+STEPS;K1=K1+STEPS#                 Incr storage pointer             CP02 146
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP02 147
#                                                                       CP02 148
IF(ICNT==0)#                           For noncentro add centro laue    CP02 149
FOR(J=STOPS;K1<STOPS1;J=J+1)#          Loop over symm matrices          CP02 150
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP02 151
QX(K1+1)=-QX(J+1)#                     Store inverse element            CP02 152
K1=K1+1#                                                                CP02 153
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP02 154
##                                                                      CP02 155
##   MARKS = IOMARK(last)+bdfbuf:                                       CP02 156
##   STOPR = END of basic rotation symmops                              CP02 157
##   STOPS = end of all symops                                          CP02 158
##   MARKF = STOPS+1                                                    CP02 159
MARKF=STOPS1+1#                                                         CP02 160
MARK2=MARKF#                                                            CP02 161
##                                                                      CP02 162
## get SCATT. FACTOR, ATOM SUMMARY F(0,0,0) AND E(0,0,0) FROM LRSCAT:   CP02 163
## ------------------------------------------------------------------   CP02 164
##                                                                      CP02 165
RADINC=0.1#                            Default bdf radius increment     CP02 166
ATEX=0#                                Num of atoms expected            CP02 167
HEAVY=0#                               No heavy atoms                   CP02 168
ORGANIC=0#                             Assume not organic               CP02 169
E000=.01;  F000=0.#                    Set initial values               CP02 170
incrqx:(MARK3,MARK2+32,CP0205)#        Save room for 16 sf types        CP02 171
ISCF=incr:(arith:(7,/,mxchwd:))#       Allow for 8 char. per name       CP02 172
J2=MARK2#                              Set marker for first sf name     CP02 173
IWNT(1)=1#                             Request natom/cell               CP02 174
IWNT(2)=3#                             Request z                        CP02 175
IWNT(3)=100#                           Ff idnums  at s=0                CP02 176
IWNT(4)=10#                            Neut ff                          CP02 177
IWNT(5)=11 ;  IWNT(6)=7#               Set sf name idnum                CP02 178
IWNT(7)=5#                             Get atomic radius                CP02 179
KEY(1)=0;  KEY(2)=7;  KEY(3)=0#        Set search delimiters            CP02 180
KEY(4)=0#                                                               CP02 181
indexpkt:(1,lrscat:,LPAK,IP,0,KEY,IWNT,IREL)# Get packet pointers       CP02 182
IF(KEY(4)<=0)iquit:(CP0201)#                                            CP02 183
IF(IREL(1)*IREL(2)<=0)iquit:(CP0201)#  No atom number                   CP02 184
IF(IREL(3)==0) IREL(3)=IREL(2)#        Replace no. elects. with z &     CP02 185
IF(IREL(4)!=0) IREL(3)=IREL(4)#        Replace z with neutron sf        CP02 186
FOR(I=IP+IREL(3);I<=IP+LPAK;I=I+1)#    Loop over ff list                CP02 187
IF((QX(I)<99.5)\(QX(I)>299.5)) BREAK#  Exit after last ff               CP02 188
#                                                                       CP02 189
IF(IREL(3)>0) NSCF=I-IP-IREL(3)#       Count contiguous ff              CP02 190
ELSE          NSCF=0#                  Ff table present                 CP02 191
IF(IREL(4)>0) NSCF=1#                  Count neutron ff                 CP02 192
IF(IREL(3)>0) DSTL=(QX(I-1)-QX(I-2))*.01# Set st/l interval             CP02 193
#                                                                       CP02 194
NATYP=0#                               Zero count of atom types         CP02 195
FOR(J=MARK3;J>0;J=J+NSCF)#             Loop over each atom type         CP02 196
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP02 197
readwpkt:(1,lrscat:,LPAK,IP,0)#        Get packet pointer               CP02 198
IF(IP<=0) BREAK#                       Exit after last packet           CP02 199
L=IP+IREL(5)#                          Set pointer for sf name          CP02 200
movereal:(QX,L,QX,J2+1,ISCF,1)#        Move sf name to mark2 array      CP02 201
J2=J2+ISCF#                            Advance sf name pointer          CP02 202
incrqx:(MARK4,J+NSCF,CP0206)#          Expand qx.......fc108            CP02 203
NATYP=NATYP+1#                         Count atom types                 CP02 204
#I=IP+IREL(6); IF(I>IP) IFFF=NINT(QX(I))# GET REFL FF FLAG              CP02 205
I=IP+IREL(1); IF(I>IP) ATA(NATYP)=QX(I)# Get total atom number          CP02 206
I=IP+IREL(7); IF(I>IP) ATR(NATYP)=QX(I)+RADINC# Get atomic radius       CP02 207
I=IP+IREL(4); IF(I>IP) QX(MARK4)=QX(I)# Store neutron ff                CP02 208
ELSE IF(IREL(3)>0)#                    If xray or electron ff present   CP02 209
FOR(I=J;I<MARK4;I=I+1)#                Loop over sf data points         CP02 210
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP02 211
K=IP+IREL(3)+I-J#                      Point to each ff value           CP02 212
QX(I+1)=QX(K)#                         Store each ff value              CP02 213
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP02 214
I=IP+IREL(1);  K=IP+IREL(3)#           Point to natom ans z             CP02 215
F000=F000+QX(I)*QX(K)#                 Sum total electrons              CP02 216
E000=E000+QX(I)*QX(K)*QX(K)#           Sum total z**2                   CP02 217
K=IP+IREL(2)#                          Point to at/cell & at no.        CP02 218
IF(QX(K)>2.5) ATEX=ATEX+NINT(QX(I))#   Sum nonh atoms in cell           CP02 219
ATZ(NATYP)=QX(K)#                      Save atomic number z             CP02 220
IF(ATZ(NATYP)>9.5) HEAVY=HEAVY+1#      Contains heavy atoms             CP02 221
ifeq:(ATZ(NATYP),1.0)ORGANIC=ORGANIC+1# Contains h                      CP02 222
ifeq:(ATZ(NATYP),6.0)ORGANIC=ORGANIC+1# Contains c                      CP02 223
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP02 224
IF(ORGANIC==2)ORGANIC=yes:#            Contains c and h                 CP02 225
ELSE          ORGANIC=no:#             Apparently not                   CP02 226
IF(E000>small:) E000=F000/SQRT(E000)#  Calc e(0,0,0)                    CP02 227
IF(IRAD==2)#                           If xrays or neutrons             CP02 228
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP02 229
F000=0.;    E000=0.#                   Zero coefficients                CP02 230
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP02 231
##   now  we have                                                       CP02 232
##   NATYP   atom types                                                 CP02 233
##   E000                                                               CP02 234
##   F000                                                               CP02 235
##   MARK2 = 16 * 8 chars         # atom type names ISCF steps          CP02 236
##   MARK3 = MARK2+32             # start of scattering factors         CP02 237
##   MARK4 = MARK3 + NATYP*NSCF    # end of scattering factors          CP02 238
##                                                                      CP02 239
#                                                                       CP02 240
#                                                                       CP02 241
#  ORDER LIST OF ATOM TYPES IN DESCENDING Z ORDER (ATZORD)              CP02 242
#  -------------------------------------------------------              CP02 243
#                                                                       CP02 244
MAXP=500.#                             Larger z than uranium etc        CP02 245
NETOT=0.#                              Total number expected atoms      CP02 246
ATZDIF(1)=0#                           Initialize                       CP02 247
DIFMAX=0.;MAXDIF=1#                                                     CP02 248
DO J=1,NATYP#                          Loop over zord entries           CP02 249
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP02 250
IF (ATZ(J)>1.5) NETOT=NETOT+ATA(J)#    Accumulate non-h atoms in cell   CP02 251
ATZMX=0.#                              Set as low as possible           CP02 252
DO I=1,NATYP#                          Loop over atz entries            CP02 253
IF (ATZ(I)<MAXP & ATZ(I)>ATZMX)#       Largest below current limit      CP02 254
$(ATZMX=ATZ(I) ; SAV=I$)#              Save values                      CP02 255
ATZORD(J)=SAV#                         Save pointer                     CP02 256
MAXP=ATZMX-0.5#                        Next is lower than current       CP02 257
IF(J!=1)#                              Zero rel diff for first          CP02 258
ATZDIF(J)=(ATZ(ATZORD(J-1))-ATZ(SAV))/ATZ(SAV)# (prev-curr)/curr        CP02 259
IF (ATZDIF(J) >DIFMAX)#                Find maximum difference          CP02 260
$(DIFMAX= ATZDIF(J) ; MAXDIF=J$)#      Save pointer                     CP02 261
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP02 262
#                                                                       CP02 263
#  CUMULATIVE LIST OF HIGHER Z ATOM TYPE NUMBERS                        CP02 264
#  ---------------------------------------------                        CP02 265
#                                                                       CP02 266
CUM=0.#                                Cumulated atom numbers           CP02 267
DO J=1,NATYP#                          Loop over ordered diffs          CP02 268
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP02 269
ATNC(J)=CUM#                           Number of larger z atoms b4 th   CP02 270
CUM=CUM+ATA(ATZORD(J))#                Increment                        CP02 271
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP02 272
ATNC(J)=CUM#                           Number of larger z atoms b4 th   CP02 273
#                                                                       CP02 274
#  LIST OF POINTERS TO NEXT LARGEST ZI-ZJ (ATZDIF) DIFFERENCES          CP02 275
#  -----------------------------------------------------------          CP02 276
#                                                                       CP02 277
ATZMX=500.#                            Initialize                       CP02 278
DO J=1,NATYP#                          Make ranked list of diff ptrs    CP02 279
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP02 280
AZODIF(J)=1#                           Initialize - first is zero       CP02 281
DO I=1,NATYP#                          Loop over atz diffs              CP02 282
IF (ATZDIF(I)<=ATZMX & ATZDIF(I)>=ATZDIF(AZODIF(J)))#                   CP02 283
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP02 284
#                                      <= max but >= current            CP02 285
DO K=1,J; IF (AZODIF(K)==I) BREAK#     Loop over ranked diff ptrs       CP02 286
IF (K<=J) NEXT#                        Already recorded this change     CP02 287
AZODIF(J)=I#                           Save ptr to next largest diff    CP02 288
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP02 289
ATZMX=ATZDIF(AZODIF(J))#               Save last maximum difference     CP02 290
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP02 291
#                                                                       CP02 292
#  NTH LARGEST DIFF IS   ATZDIF(AZODIF(N))                              CP02 293
#  BETWEEN ATOM TYPE     AZODIF(N) AND ATOM TYPE AZODIF(N)-1            CP02 294
#  NUMBER OF PEAKS BEFORE ATOM TYPE AZODIF(N) IS ATNC(AZODIF(N))        CP02 295
#                                                                       CP02 296
pt1:#                                                                   CP02 297
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP02 298
movechar:(CP021,1,CHROT,2,NCP020-1,1)# Underline header                 CP02 299
writeline:(1,CP020,NCP020,2,3)#        Header                           CP02 300
movechar:(CP023,LTYP,CP022,45,1,0)#    Lattice character                CP02 301
IF(ICNT==0)  CP022(25^27)='non'#       Non centrosymmetric              CP02 302
writeline:(0,CP022,NCP022,3,3)#        Write message                    CP02 303
ncodefld:(FLOAT(NATYP),1,CP024,400413.,1)#                              CP02 304
writeline:(0,CP024,NCP024,3,3)#        Write message                    CP02 305
ncodefld:(FLOAT(ATEX),1,CP025,400713.,1)#                               CP02 306
writeline:(0,CP025,NCP025,3,3)#        Write message                    CP02 307
ncodefld:(FLOAT(MOLZ),1,CP026,400713.,1)#                               CP02 308
writeline:(0,CP026,NCP026,3,3)#        Write message                    CP02 309
ncodefld:(FLOAT(ATEX)/FLOAT(MOLZ),1,CP027,400712.,1)#                   CP02 310
writeline:(0,CP027,NCP027,3,3)#        Write message                    CP02 311
IF(HEAVY==no:) movechar:(CP021,5,CP028,39,2,0)# No                      CP02 312
ELSE           movechar:(CP021,2,CP028,38,3,0)# Yes                     CP02 313
writeline:(0,CP028,NCP028,3,3)#        Write message                    CP02 314
IF(ORGANIC==no:)movechar:(CP021,5,CP029,39,2,0)# No                     CP02 315
ELSE            movechar:(CP021,2,CP029,38,3,0)# Yes                    CP02 316
writeline:(0,CP029,NCP029,3,3)#        Write message                    CP02 317
movechar:(CP021,1,CHROT,2,NCP02A-1,1)# Scattering contents              CP02 318
writeline:(1,CP02A,NCP02A,2,3)#        Underline                        CP02 319
LINRM=2#                                                                CP02 320
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP02 321
#                                                                       CP02 322
DO J=1,NATYP#                          Loop over zord entries           CP02 323
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP02 324
I=ATZORD(J)#                           Get atoms in ordr of z           CP02 325
MAT(J)=I; EATL(J)=ATNC(J)#             Initialize                       CP02 326
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP02 327
#                                                                       CP02 328
#  REDUCE ATOM TYPE LIST TO BLOCKS OF SIMILAR Z RANGE                   CP02 329
#  --------------------------------------------------                   CP02 330
#                                                                       CP02 331
NARANG=1#                              Number of atom ranges            CP02 332
FOR(I=2;I<=NATYP+1;I=I+1)#             Start from 2nd, i.e. look ahea   CP02 333
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP02 334
NARANG=NARANG+1#                       Increment number of ranges       CP02 335
IF(ATZDIF(I)>0.5)#                     Large diff from prev to here     CP02 336
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP02 337
MAT(NARANG-1) = MAT(I-1)#              Treat all up to here as smalle   CP02 338
EATL(NARANG)=EATL(I)#                  Get next starter                 CP02 339
NEXT#                                  Look at next difference          CP02 340
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP02 341
WHILE(ATZDIF(I)<=0.5 & I<=NATYP)I=I+1# Look ahead  until too far        CP02 342
I=I-1#                                 Then step back                   CP02 343
MAT(NARANG-1)=MAT(I)#                  Treat all up to here as smalle   CP02 344
EATL(NARANG) =EATL(I+1)#               Get next starter                 CP02 345
DO J=NARANG,I;MAT(J)=0#                Erase intermediates              CP02 346
I=I+1#                                                                  CP02 347
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP02 348
MAT(NARANG)=0#                         Set as terminating flag          CP02 349
EATL(NARANG)=EATL(NARANG)+ATA(ATZORD(NATYP))# Set last                  CP02 350
NARANG=NARANG-1#                       Number of atom ranges            CP02 351
#                                                                       CP02 352
IF(ORGANIC==yes:)#                     Fudge for h<zi<c  force to c     CP02 353
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CP02 354
DO I=1,NARANG#                         Loop over reduced types          CP02 355
IF(ATZ(MAT(I))<5.9)BREAK#              Break on first type below c      CP02 356
IF(ATZ(MAT(I-1))>6.1)#                 Did we skip c somewhere ?        CP02 357
DO J=1,NATYP;ifeq:(ATZ(J),6.0)MAT(I)=J# Nothing less than carbon        CP02 358
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CP02 359
#                                                                       CP02 360
L=1#                                                                    CP02 361
CHROT=' '#                             Erase the string                 CP02 362
ncodefld:(FLOAT(NARANG),1,CP02C,260313.,1)#                             CP02 363
writeline:(1,CP02C,NCP02C,3,3)#                                         CP02 364
LINRM=2#                                                                CP02 365
pt0:#                                  Zero level dump                  CP02 366
DO J=1,NATYP#                          Loop over zord entries           CP02 367
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CP02 368
K=MAT(L)#                                                               CP02 369
I=ATZORD(J)#                           Pointer to ordered atoms         CP02 370
movertoc:(QX(MARK2+(I-1)*ISCF+1),1,CHROT,3,ISCF,1)#                     CP02 371
BUFOT(1)=ATA(I)#                       Atoms per cell                   CP02 372
BUFOT(2)=ATA(I)/MOLZ#                  Asym unit                        CP02 373
BUFOT(3)=ATZ(K)#                       Effective atomic number          CP02 374
BUFOT(4)=ATNC(J+1)#                    Cumulative larger z sites        CP02 375
BUFOT(5)=ATR(I)#                       Atomic radii                     CP02 376
BUFOT(6)=FLOAT(L)#                     Grouped z range                  CP02 377
BUFOT(7)=ATZDIF(J)#                    Group split factor               CP02 378
ncodefld:(BUFOT,1,CHROT,FMT1,7)#                                        CP02 379
writeline:(0,CP02K,NCP02K,1,3)#        Header                           CP02 380
#IF(ATZ(I)<=ATZ(K))L=L+1#              OK UNLESS BORON ETC              CP02 381
IF(ATNC(J+1)>=EATL(L+1))L=L+1#         Test with max num inzeffective   CP02 382
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CP02 383
#                                                                       CP02 384
#                                                                       CP02 385
#   ENTER SCALE INFORMATION (LR LREXPL:)                                CP02 386
#   ------------------------------                                      CP02 387
#                                                                       CP02 388
IWNT(1)=1;    IWNT(2)=100#             Set data set & nscl idnums       CP02 389
IWNT(3)=94;   IWNT(4)=22#              Set rad type & cell volume       CP02 390
IRAD=3#                                                                 CP02 391
KEY(1)=1; KEY(2)=4; KEY(3)=0; KEY(4)=0# Set search delimiters           CP02 392
indexpkt:(1,lrexpl:,LPAK,IP,0,KEY,IWNT,IREL)# Get packet pointers       CP02 393
incrqx:(MARK5,MARK4+64,CP0207)#        Expand qx.......fc109            CP02 394
NSCL=1;   QX(MARK4+1)=1.#              Default group & rel pointer&     CP02 395
FOR(I=IP+1;I<=IP+LPAK;I=I+1)#          Loop over directory              CP02 396
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CP02 397
IF((QX(I)<100.9)\(QX(I)>164.1)) NEXT#  Skip if not scale idnm           CP02 398
J=MARK4+NINT(QX(I))-100#               Get group number of scale        CP02 399
QX(J)=FLOAT(I-IP)#                     Store relative position          CP02 400
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CP02 401
#                                                                       CP02 402
REPEAT#                                Loop over data sets              CP02 403
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CP02 404
readwpkt:(1,lrexpl:,LPAK,IP,0)#        Get packet pointer               CP02 405
IF(IP<=0) BREAK#                       Exit after last packet           CP02 406
I=IP+IREL(1); IF(I==IP) NEXT#          Get index of data set no.        CP02 407
IF(DSNM!=NINT(QX(I))) NEXT#            Skip unwanted data set           CP02 408
I=IP+IREL(2); IF(I>IP) NSCL=NINT(QX(I))# Number of scales               CP02 409
I=IP+IREL(3); IF(I>IP) IRAD=MIN(3,NINT(QX(I)))# Radiation (1=n,2=e;3=   CP02 410
I=IP+IREL(4); IF(I>IP) CVOL=QX(I)/47.878# Cell volume for elect rad     CP02 411
FOR(I=MARK4;I<MARK4+NSCL;I=I+1)#       Loop over scale factors          CP02 412
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CP02 413
J=IP+NINT(QX(I+1))#                    Point to scale location          CP02 414
IF(J>IP) QX(I+1)=QX(J)#                Store scale in table             CP02 415
ELSE     QX(I+1)=1.#                   Default scale is 1.              CP02 416
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CP02 417
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CP02 418
SCAL=QX(MARK4+1)#                                                       CP02 419
GSCAL=SCAL#                            Save genevs scale                CP02 420
IF(IREL(4)==0&IRAD==2) iquit:(CP0203)# Cell volume missing              CP02 421
IF(IRAD==2) FMUL=FMUL/CVOL#            Scale structure factor volts     CP02 422
MARKM=MARK4+NSCL+1#                    Reset mark5 for true nscl        CP02 423
#                                                                       CP02 424
##   now     we have                                                    CP02 425
##   NSCL   atom types                                                  CP02 426
##   IRAD   radiation type                                              CP02 427
##   Cvol   for electrons                                               CP02 428
##   MARK4 = end of scat fac list                                       CP02 429
##   MARKM = MARK4+NSCl             # end of data set scales            CP02 430
#                                                                       CP02 431
#                                                                       CP02 432
#    ENTER MAXHKL INFORMATION (LRDSET)                                  CP02 433
#   ---------------------------------                                   CP02 434
#                                                                       CP02 435
IWNT(1)=1; IWNT(2)=11; IWNT(3)=12#     Set dset,maxh,maxk idnum         CP02 436
IWNT(4)=13;IWNT(5)=14; IWNT(6)=15#     Set maxl,mins,maxs idnum         CP02 437
IWNT(7)=2#                             Uoverall                         CP02 438
KEY(1)=1; KEY(2)=7; KEY(3)=0; KEY(4)=0# Set search limits               CP02 439
indexpkt:(1,lrdset:,PSIZ,IP,0,KEY,IWNT,IREL)# Search directory          CP02 440
IF(KEY(4)>0)#                          If present extract limits        CP02 441
REPEAT#                                Loop over lrdset pkts            CP02 442
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CP02 443
readwpkt:(1,lrdset:,PSIZ,IP,0)#        Point to next packet             CP02 444
IF(IP<=0) BREAK#                       Exit after last pkt              CP02 445
I=IP+IREL(1);IF(DSNM!=NINT(QX(I))) NEXT# Skip wrong dataset             CP02 446
I=IP+IREL(2);IF(I>IP)MAXH(1)=NINT(QX(I))# Extract max /h/               CP02 447
I=IP+IREL(3);IF(I>IP)MAXH(2)=NINT(QX(I))# Extract max /k/               CP02 448
I=IP+IREL(4);IF(I>IP)MAXH(3)=NINT(QX(I))# Extract max /l/               CP02 449
I=IP+IREL(5);IF(I>IP)STMN =QX(I)#      Extract min st/l                 CP02 450
I=IP+IREL(6);IF(I>IP)STMX =QX(I)#      Extract max st/l                 CP02 451
I=IP+IREL(7);IF(I>IP)BOVL =QX(I)*utob:# Get active b overall            CP02 452
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CP02 453
GBOVL=BOVL## BOVL#                     B overall                        CP02 454
#                                                                       CP02 455
ncodefld:(FLOAT(DSNM),1,CP02E,400413.,1)#                               CP02 456
pt2: writeline:(1,CP02E,NCP02E,3,3)#   Write message                    CP02 457
ncodefld:(FLOAT(NSCL),1,CP02F,400413.,1)#                               CP02 458
pt2: writeline:(0,CP02F,NCP02F,3,3)#   Write message                    CP02 459
ncodefld:(GSCAL,1,CP02G,400752.,1)#                                     CP02 460
pt2: writeline:(0,CP02G,NCP02G,3,3)#   Write message                    CP02 461
ncodefld:(GBOVL/utob:,1,CP02H,300752.,1)#                               CP02 462
ncodefld:(GBOVL,      1,CP02H,400732.,1)#                               CP02 463
pt2: writeline:(0,CP02H,NCP02H,3,3)#   Write message                    CP02 464
ncodefld:(FLOAT(MAXH(1)),1,CP02I,300413.,1)#                            CP02 465
ncodefld:(FLOAT(MAXH(2)),1,CP02I,350413.,1)#                            CP02 466
ncodefld:(FLOAT(MAXH(3)),1,CP02I,400413.,1)#                            CP02 467
pt2: writeline:(0,CP02I,NCP02I,3,3)#   Write message                    CP02 468
ncodefld:(STMN,1,CP02J,300752.,1)#                                      CP02 469
ncodefld:(STMX,1,CP02J,400752.,1)#                                      CP02 470
pt2: writeline:(0,CP02J,NCP02J,3,3)#   Write message                    CP02 471
#                                                                       CP02 472
#   EXTRACT ATOM COORDS IF PRESENT    PEKPIK                            CP02 473
#   ------------------------------                                      CP02 474
#                                                                       CP02 475
incrqx:(STOPM,MARKM+100,CP0208)#       Save room for next atom          CP02 476
MARK5=STOPM;  STOP5=MARK5#             Start of atomic coordinates      CP02 477
STEP5=arith:(4,+,name:)#               Save x,y,z and name              CP02 478
#                                                                       CP02 479
IWNT(1)=1;    IWNT(2)=2#               Request xcoord & ycoord          CP02 480
IWNT(3)=3;    IWNT(4)=14#              Request zcoord & aname           CP02 481
KEY(1)=0; KEY(2)=4; KEY(3)=4; KEY(4)=0# Set search parameters           CP02 482
indexpkt:(1,lratom:,PSIZ,IP,0,KEY,IWNT,IREL)# Find x,y,z and name       CP02 483
IF(IP>0)#                              If there are any atoms...        CP02 484
FOR(I=MARK5;I>0;I=STOP5)#              Loop over atoms list             CP02 485
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CP02 486
readwpkt:(1,lratom:,PSIZ,IP,0)#        Read atom packet                 CP02 487
IF(IP<=0) BREAK#                       Exit after last packet           CP02 488
incrqx:(STOP5,I+STEP5,CP0209)#         Save room for next atom          CP02 489
J=IP+IREL(1);  QX(I+1)=QX(J)#          Get x coordinate                 CP02 490
J=IP+IREL(2);  QX(I+2)=QX(J)#          Get y coordinate                 CP02 491
J=IP+IREL(3);  QX(I+3)=QX(J)#          Get z coordinate                 CP02 492
QX(I+4)=0.;  J=IP+IREL(4)#             Reset match flag                 CP02 493
movertoc:(QX(J),1,LABEL,1,24,0)#       Pick up atom label               CP02 494
label:(LABEL,K,L)#                     Process atom label               CP02 495
movereal:(QX,J,QX,I+5,name:,1)#        Store atom label                 CP02 496
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CP02 497
#                                                                       CP02 498
##   now     we have                                                    CP02 499
##   MARKM = MARK4+NSCl             # first of peak max profile         CP02 500
##   MARK5 = MARKM+100              # end of peak max profile           CP02 501
##   STOP5 =                        # end of bdf atom list              CP02 502
#                                                                       CP02 503
#   SETUP SIN/COS                                                       CP02 504
#   -------------                                                       CP02 505
#                                                                       CP02 506
FOR(I=MARK0;I<MARKS;I=I+1)#            Loop over degree intervals       CP02 507
QX(I+1)=SIN(FLOAT(I-MARK0)*.0174532925)# Sine 0/s/449                   CP02 508
#                                                                       CP02 509
MARK6=STOP5#                                                            CP02 510
#                                                                       CP02 511
RETURN#                                                                 CP02 512
END#                                                                    CP02 513
systemheader:(CP03)#                   Enter control lines              CP03   1
####################################################################    CP03   2
#                                                                  #    CP03   3
#                             CP03                                 #    CP03   4
#                                                                  #    CP03   5
####################################################################    CP03   6
SUBROUTINE CP03#                       S.r.hall  jun 81                 CP03   7
include:(AACOMN)#                                                       CP03   8
include:(CPCOMN)#                                                       CP03   9
#                                                                       CP03  10
INTEGER I,J,K,L,M,N,IP,NFRG,GN,NINV,PN# Gt01                            CP03  11
INTEGER H(3)#                                                           CP03  12
INTEGER H1,H2,H3#                                                       CP03  13
chardata:(GT1, INVAR  SELECT REFINE PARTSF ASSIGN PHI    $#             CP03  14
SETFOM PSETS  DUMP   ARCHIV PLIMIT ONLY   END    )#                     CP03  15
chardata:(GT2,ALLTRIQUAALINPAOUACGENINVWALGWA)#                         CP03  16
chardata:(GT3,ODEDPESENUCABLRANOPR)#                                    CP03  17
chardata:(GT4,RAPEMAQPNQNOFCGTW1W2W3)#                                  CP03  18
#CHARDATA:(GT5,SEL PSE STA ITE GEN INV PMA FOM CPL )#                   CP03  19
chardata:(CPC,' generator max HKL indices')#                            CP03  20
intdata:(PRC,[45,0,30,45,60,90,120,135,150])#                           CP03  21
datastuff:#                                                             CP03  22
#                                                                       CP03  23
#                                                                       CP03  24
#   ENTER GENSIN PARAMETERS FROM FILE4                                  CP03  25
#   ----------------------------------                                  CP03  26
#                                                                       CP03  27
readwpkt:(4,2,PN,IP,0)#                Point to record 2, file 4        CP03  28
IF(IP<=0) iquit:(GT0115)#              No bdf......gt0115               CP03  29
ETYP=NINT(QX(IP+1))#                   Extract /e/-type used (1 or      CP03  30
EMIN=AMAX1(EMIN,QX(IP+2))#             Extract /e/-min of generator     CP03  31
PFAC=QX(IP+3)#                         Extract probability factor       CP03  32
NTOT=iqx:(IP+4)#                       Extract no. nonpsi0 gens.        CP03  33
NGEN=MIN0(NGEN,NTOT)#                  Set no. gens to be used          CP03  34
NFRG=iqx:(IP+9)#                       Extract fragment count           CP03  35
NPSI=iqx:(IP+11)#                      Extract no. psi0 gens.           CP03  36
#                                                                       CP03  37
IF(NSYM<1) NSYM=2#                     Say what ???                     CP03  38
#                                                                       CP03  39
NTOT=NTOT+NPSI#                        Set total gens. (incl psi0)      CP03  40
AMIN(1)=QX(IP+29);  AMIN(2)=QX(IP+30)# Extract min prob factors         CP03  41
XVMN=QX(IP+45);     XVMX=QX(IP+46)#    Extract xvec limits              CP03  42
XSLO=QX(IP+47);     XSHI=QX(IP+48)#    Extract xvec sum limits          CP03  43
XSMN=QX(IP+70);     XSMX=QX(IP+71)#    Extract xvec sum min/max         CP03  44
NODR=iqx:(IP+76)#                      Extract no. of odr required      CP03  45
NONR=iqx:(IP+77)#                      Extract no. nonr odr allowed     CP03  46
J=IP+79;   L=IP+82#                    Point to buffer addresses        CP03  47
DO I=1,3#                              Outer odr loop                   CP03  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP03  49
J=J+1;  MDSI(I)=iqx:(J)#               Extract si vector moduli         CP03  50
DO K=1,3#                              Inner odr loop                   CP03  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP03  52
L=L+1;  SIVC(K,I)=QX(L)#               Extract si vectors               CP03  53
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP03  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP03  55
#                                                                       CP03  56
#   GET MEMORY FOR ALL GENERATOR REFLECTION PACKETS                     CP03  57
#   -----------------------------------------------                     CP03  58
#                                                                       CP03  59
# M1=   MARK6= START OF GENERATORS                                      CP03  60
MARK=gensize:#                         ****** genlist increment         CP03  61
incrqx:(MARK7,MARK6+MARK*NTOT,CP0302)# Expand qx ..........gt0120       CP03  62
#                                                                       CP03  63
#   SET DEFAULT CONTROL PARAMETERS                                      CP03  64
#   ------------------------------                                      CP03  65
#                                                                       CP03  66
IF(NONR==0) NANT=2#                    All odr restricted phis          CP03  67
ELSE        NANT=1#                    Some odr nonrestricted           CP03  68
IQPS=1;   NQPS=-1;   NPST=1#           Default control parameters &     CP03  69
NPER=0;  NTES=1;    EFOM=yes:#         Default control parameters       CP03  70
PERS(1)=90;  PERS(2)=180#              Default permute increments       CP03  71
NINV=2#                                Only use triplets                CP03  72
EPAR=EMIN;  FRAC=.5#                   Default control parameters       CP03  73
CONV=.02; WMIN=.15; A2MX=0.; RATE=0.7# Default control parameters       CP03  74
IXVF=3;   MXIT=30;  NSEL=100#          Default control parameters       CP03  75
ISEL=-2;   SIGA=1.;  MSEL=-1; MSTR=0#  Default control parameters       CP03  76
FIX(1)=0 ;   FIX(2)=30;   FIX(3)=10#   Set iteration fixes              CP03  77
FIX(4)=5;    FIX(5)=5 ;   FIX(6)=30#   Set iteration fixes              CP03  78
IF(IACC==yes:) FIX(3)=5#               Reset edr fix if blocks fixe     CP03  79
BIAS(1)=100000.;   BIAS(4)=7000000.#   Wgt bias for std, per            CP03  80
BIAS(2)=9000000.;  BIAS(5)=6000000.#   Wgt bias for odr, set            CP03  81
BIAS(3)=8000000.;  BIAS(6)=100.#       Wgt bias for edr, nul            CP03  82
MXTG=1000.;  MXQG=1000.#               Max t3 & pq per generator        CP03  83
#                                                                       CP03  84
IF(HEAVY!=no:\(HEAVY==no:&ATEX/NSYM<40))# Heavy atoms or suff small     CP03  85
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP03  86
WFOM(1)=0.5;  WFOM(2)=0.5#             Set default rfom weights         CP03  87
WFOM(3)=1.;   WFOM(4)=1.#              Set default rfom weights         CP03  88
WFOM(5)=1.#                                                             CP03  89
FOPT(1)=1.;   FOPT(2)=.25#             Set default optimal values       CP03  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP03  91
ELSE#                                  Config for tenuous light stru    CP03  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP03  93
WFOM(1)=0.0;  WFOM(2)=4.0#             Set default rfom weights         CP03  94
WFOM(3)=0.;   WFOM(4)=1.#              Set default rfom weights         CP03  95
WFOM(5)=1.#                                                             CP03  96
FOPT(1)=1.;   FOPT(2)=.20#             Set default optimal values       CP03  97
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP03  98
FOPT(3)=.75;  FOPT(4)=70.#             Set default optimal values       CP03  99
FOPT(5)=1.0;#                                                           CP03 100
FREJ(6)=0.25#                          Set lower rfom rejection         CP03 101
FMIN(1)=0.;   FMIN(2)=0.#              Set default rfom weights         CP03 102
FMIN(3)=0.;   FMIN(4)=0.#              Set default rfom weights         CP03 103
FMIN(5)=0.;#                                                            CP03 104
FMAX(1)=2.;   FMAX(2)=2.#              Set default rfom weights         CP03 105
FMAX(3)=2.;   FMAX(4)=180.#            Set default rfom weights         CP03 106
FMAX(5)=1.;#                                                            CP03 107
NOPS=0#                                Set default amos thresh.         CP03 108
MODE=2;       IWGT=2#                  Default block & w2               CP03 109
RWGT=0.25;    SEED1=137;SEED2=13804#   Set phase start flag & wgt       CP03 110
H1=0;H2=0;H3=0#                        Set max hkl magnitudes           CP03 111
TYPE=1#                                Set as permute -regardless       CP03 112
#                                                                       CP03 113
#   ENTER GENERATOR LIST FROM FILE 4                                    CP03 114
#   --------------------------------                                    CP03 115
#                                                                       CP03 116
FOR(GN=MARK6;GN<MARK7;GN=GN+MARK)#     Loop over generator list         CP03 117
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP03 118
readwpkt:(4,3,PN,IP,0)#                Point to next gen. packet        CP03 119
IF(IP<=0) iquit:(CP0303)#              Error reading invariant file     CP03 120
movereal:(QX,IP+1,QX,GN+1,PN,1)#       Store hkl,uvw,prc,sige,e         CP03 121
prc:=FLOAT(iprc:/100)#                 Store restr phase code only      CP03 122
sta:=nos:#                             Set initial status as nos        CP03 123
alt:=0.#                               Clear alpha word                 CP03 124
IF(evl:+.1<EMIN) NEXT#                                                  CP03 125
I=GN#                                  Store last accept pointer        CP03 126
gethkl:(GN+1,H)#                       Get gen hkl indices              CP03 127
H1=MAX(ABS(H(1)),H1)#                  Get max h                        CP03 128
H2=MAX(ABS(H(2)),H2)#                  Get max k                        CP03 129
H3=MAX(ABS(H(3)),H3)#                  Get max l                        CP03 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP03 131
NGEN=MIN0(NGEN,(I-MARK6)/MARK+1)#      Calculate generators used        CP03 132
I=MARK6+MARK*NGEN;   J=MARK*NPSI#      Mark psi0 gen boundary           CP03 133
movereal:(QX,MARK7-J+1,QX,I+1,J,1)#    Remove unused normal gens.       CP03 134
MQ=I;   NLIM=NTOT-NGEN-NPSI#           Set gen. pointers                CP03 135
MARK7=I+J#                             Mark end of gen list             CP03 136
NTOT=NGEN+NPSI#                        Count all generators             CP03 137
readwpkt:(4,endrecord:,I,I,0)#         Rewind and close file 4          CP03 138
#                                                                       CP03 139
MAXH(1)=MIN(MAXH(1),H1)#                                                CP03 140
MAXH(2)=MIN(MAXH(2),H2)#                                                CP03 141
MAXH(3)=MIN(MAXH(3),H3)#                                                CP03 142
CHROT=CPC#                                                              CP03 143
ncodefld:(FLOAT(MAXH(1)),1,CHROT,300413.,1)#                            CP03 144
ncodefld:(FLOAT(MAXH(2)),1,CHROT,350413.,1)#                            CP03 145
ncodefld:(FLOAT(MAXH(3)),1,CHROT,400413.,1)#                            CP03 146
pt2: writeline:(0,0,0,1,3)#            Indices                          CP03 147
#                                                                       CP03 148
#    ENTER CONTROL LINES                                                CP03 149
#    -------------------                                                CP03 150
#                                                                       CP03 151
REPEAT#                                Loop input control lines         CP03 152
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP03 153
readline:(GT1,NGT1)#                   Process input lines              CP03 154
#                                                                       CP03 155
IF(LINID==1)#                          ******  invar line *****         CP03 156
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP03 157
IF(bf:(1)<voidflg:)#                   Test if character string         CP03 158
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP03 159
stringlim:(1,M,N)#                     Get limits of string             CP03 160
compchar:(CHRIN,M,GT2,1,3,3,9,NINV)#   Search for match in gt2          CP03 161
IF(NINV==0) iquit:(CP0304)#            No match.......gt0125            CP03 162
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP03 163
IF(bf:(2)>voidflg:) AMIN(1)=bf:(2)#    Set a min for triplets           CP03 164
IF(bf:(3)>voidflg:) AMIN(2)=bf:(3)#    Set b-min for quartets           CP03 165
IF(bf:(4)>voidflg:) MXTG=bf:(4)#       Set max trip/gen                 CP03 166
IF(bf:(5)>voidflg:) MXQG=bf:(5)#       Set max quar/gen                 CP03 167
IF(bf:(6)>voidflg:) SIGA=bf:(6)#       Set siga reduce factor           CP03 168
IF(bf:(7)<voidflg:)#                   Test for xvector control         CP03 169
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP03 170
stringlim:(7,M,N)#                     Get char string limits           CP03 171
compchar:(CHRIN,M,GT2,10,2,2,19,IXVF)# Search for match in gt2          CP03 172
IF(IXVF==0) iquit:(CP0304)#            No match.......gt0125            CP03 173
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP03 174
IF(bf:(8)>voidflg:) XSLO=bf:(8)#       Set lower xvs threshold          CP03 175
IF(bf:(9)>voidflg:) XSHI=bf:(9)#       Set upper xvs threshold          CP03 176
IF(bf:(10)>voidflg:) NQPS=ib:(10)#     Set psi for neg quartets         CP03 177
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP03 178
#                                                                       CP03 179
ELSE IF(LINID==2)#                     ******  select line *****        CP03 180
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP03 181
IF(bf:(1)<voidflg:)#                   Test if string present           CP03 182
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP03 183
stringlim:(1,M,N)#                     Get limits of string             CP03 184
compchar:(CHRIN,M,GT4,1,2,2,6,TYPE)#   Match with start code            CP03 185
IF(TYPE==0) iquit:(CP0305)#            No match.......gt0130            CP03 186
TYPE=TYPE-1#                           Start flag(ra=0;pe=1;ma=2)       CP03 187
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP03 188
IF(bf:(2)>voidflg:) MSTR=ib:(2)#       Set num phase path starters      CP03 189
IF(bf:(3)>voidflg:) MSEL=ib:(3)#       Set expected permute reflns      CP03 190
IF(bf:(4)>voidflg:) NSEL=ib:(4)#       Set ngen for select process      CP03 191
IF(bf:(5)<voidflg:)#                   Test for si selection codes      CP03 192
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP03 193
stringlim:(5,M,N)#                     Get char string limits           CP03 194
compchar:(CHRIN,M,GT2,1,3,3,9,N)#      Search for match in gt2          CP03 195
IF(N>1) N=5-N#                         Reverse so n=3 for t3            CP03 196
ISEL=(N-2)*2#                          Store (all=-2,q4=0,t3=2)         CP03 197
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP03 198
IF(bf:(6)<voidflg:)#                   Is select test active            CP03 199
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP03 200
stringlim:(6,M,N)#                     Get char string limits           CP03 201
compchar:(CHRIN,M,GT2,20,3,3,31,NTES)## Search for match in gt2         CP03 202
IF(NTES==0) iquit:(CP0305)#            Ip error......gt0130             CP03 203
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP03 204
IF(bf:(7)>voidflg:) PERS(1)=ib:(7)#    Set permute incr nr phi          CP03 205
IF(bf:(8)>voidflg:) PERS(2)=ib:(8)#    Set permute incr restr           CP03 206
IF(bf:(9)>voidflg:) RWGT=bf:(9)#       Set start wgt of random phi      CP03 207
IF(bf:(10)>0.1)     SEED1=ib:(10)#     Set random number seed1          CP03 208
IF(bf:(11)>0.1)     SEED2=ib:(11)#     Set random number seed2          CP03 209
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP03 210
#                                                                       CP03 211
ELSE IF(LINID==3)#                     ******  refine line *****        CP03 212
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP03 213
IF(bf:(1)<voidflg:)#                   Test if mode string present      CP03 214
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP03 215
stringlim:(1,M,N)#                     Get limits of string             CP03 216
compchar:(CHRIN,M,GT3,11,2,2,14,MODE)# Match with mode code             CP03 217
IF(MODE==0) iquit:(CP0306)#            No match.......gt0135            CP03 218
MODE=2#                                Hardwire block mode              CP03 219
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP03 220
IF(bf:(2)<voidflg:)#                   Test if weight string presen     CP03 221
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP03 222
stringlim:(2,M,N)#                     Get limits of string             CP03 223
compchar:(CHRIN,M,GT4,17,2,2,NGT4,IWGT)# Match with weight code         CP03 224
IF(IWGT==0) iquit:(CP0306)#            No match.......gt0135            CP03 225
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP03 226
IF(bf:(3)>voidflg:) MXIT=ib:(3)#       Set max iteration limit          CP03 227
IF(bf:(4)>voidflg:) WMIN=bf:(4)#       Set minimum ext weight           CP03 228
IF(bf:(5)>voidflg:) A2MX=bf:(5)#       Set alpha**2 ext threshold       CP03 229
IF(bf:(6)>voidflg:) RATE=bf:(6)#       Set ext reduction rate           CP03 230
IF(bf:(7)>voidflg:) CONV=bf:(7)#       Set refine converge cutoff       CP03 231
DO I=1,5#                              Loop over start types            CP03 232
IF(bf:(I+7)>voidflg:) FIX(I+1)=bf:(I+7)# Set iter fix start type        CP03 233
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP03 234
#                                                                       CP03 235
ELSE IF(LINID==4)#                     ******  partsf line *****        CP03 236
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP03 237
IF(bf:(1)<voidflg:)#                   Test for qphi code               CP03 238
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP03 239
stringlim:(1,M,N)#                     Get char string limits           CP03 240
compchar:(CHRIN,M,GT4,7,2,2,10,IQPS)#  Search for match in gt4          CP03 241
IF(IQPS==2) IQPS=0#                    Set qphi flag (no=0,yes=1)       CP03 242
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP03 243
IF(bf:(2)<voidflg:)#                   Test for input phase code        CP03 244
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP03 245
stringlim:(2,M,N)#                     Get char string limits           CP03 246
compchar:(CHRIN,M,GT4,11,2,2,14,N)#    Search for match in gt4          CP03 247
IF(N>0) INPH=N-1#                      Input mode (no=0,fc=1,gt=2)      CP03 248
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP03 249
IF(bf:(3)>voidflg:) NPST=ib:(3)#       Set phase set required           CP03 250
IF(bf:(4)>voidflg:) EPAR=bf:(4)#       Set /e/ limit accepted phis      CP03 251
IF(bf:(5)>voidflg:) FRAC=bf:(5)#       Set frag fraction for fc         CP03 252
IF(bf:(6)>voidflg:) SCAL=bf:(6)#       Set scale for fo in test         CP03 253
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP03 254
#                                                                       CP03 255
ELSE IF(LINID==5)#                     ******  assign line *****        CP03 256
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CP03 257
N=3#                                   Set default start type           CP03 258
DO L=1,30#                             Loop over possible fields        CP03 259
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CP03 260
IF(bf:(L)==voidflg:) BREAK#            Stop processing on void          CP03 261
IF(bf:(L)<voidflg:)#                   Test for start type code         CP03 262
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CP03 263
stringlim:(L,M,N)#                     Get char string limits           CP03 264
compchar:(CHRIN,M,GT3,1,2,2,10,N)#     Search for match in gt3          CP03 265
IF(N==0) iquit:(CP0307)#               Unknown code.........gt0140      CP03 266
N=N+1#                                 Add storage increment            CP03 267
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CP03 268
ELSE#                                  Else its a generator number      CP03 269
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CP03 270
GN=MARK6+(ib:(L)-1)*MARK#              Point to gen start address       CP03 271
IF(sta:>nos:) iquit:(CP0307)#          Dup start......gt0142            CP03 272
I=iprc:#                               Get phi restriction              CP03 273
sta:=FLOAT(N)#                         Set start  status                CP03 274
intpak:(PRC(I),pak:, 0, 9)#            Store starting phase             CP03 275
intpak:(FIX(N),pak:, 9, 5)#            Store iteration fix              CP03 276
IF(N!=inul:) intpak:(16,pak:,25,bitlen:(25))# Store weight =1. (*16)    CP03 277
IF((N==iper:)\((N==iedr:)&(I==1)))#    For all permuted phases          CP03 278
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CP03 279
NPER=NPER+1#                           Count permute starters           CP03 280
intpak:(NPER,pak:,15, 4)#              Store permute pointer            CP03 281
IF(NPER>10) iquit:(CP0308)#            Exceed array.........gt0145      CP03 282
PERN(NPER)=GN#                         Save addr of permute gen         CP03 283
I=MIN0(2,I)#                           Resolve phi restriction          CP03 284
PERI(NPER)=PERS(I)#                    Store permute increment          CP03 285
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CP03 286
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CP03 287
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CP03 288
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CP03 289
#                                                                       CP03 290
ELSE IF(LINID==6)#                     ******  phi line *****           CP03 291
FOR(GN=MARK6;GN<MQ;GN=GN+MARK)#        Loop over generator list         CP03 292
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CP03 293
gethkl:(GN+1,H)#                       Extract h,k,l from list          CP03 294
ifne:(bf:(1),H(1)) NEXT#               Skip if h mismatch               CP03 295
ifne:(bf:(2),H(2)) NEXT#               Skip if k mismatch               CP03 296
ifne:(bf:(3),H(3)) NEXT#               Skip if l mismatch               CP03 297
IF(sta:>nos:) iquit:(CP0309)#          Dup start.......gt0147           CP03 298
I=iprc:#                               Extract phi restr. code          CP03 299
IF(bf:(4)<=voidflg:) K=PRC(I)#         Void phi at restr. value         CP03 300
ELSE IF(I==1)        K=ib:(4)#         Set unrestr. phi as input        CP03 301
ELSE#                                  For restr. phis test             CP03 302
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CP03 303
J=ib:(4)-PRC(I)#                       Get difference with restr        CP03 304
J=MIN0(IABS(J),IABS(J+360),IABS(J-360))# Minimize phi difference        CP03 305
IF(J<=90) K=PRC(I)#                    Set to closest restr. phi        CP03 306
ELSE      K=PRC(I)+180#                Set to closest restr phi         CP03 307
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CP03 308
IF(bf:(5)<voidflg:)#                   Test for start type code         CP03 309
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CP03 310
stringlim:(5,M,N)#                     Get char string limits           CP03 311
compchar:(CHRIN,M,GT3,1,2,2,10,N)#     Search for match in gt3          CP03 312
IF(N==0) iquit:(CP0310)#               Unknown code.........gt0150      CP03 313
N=N+1#                                 Add storage increment            CP03 314
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CP03 315
ELSE IF(bf:(5)>voidflg:) N=ib:(5)+1#   Set start type code              CP03 316
ELSE                     N=iper:#      Set start type permute           CP03 317
sta:=FLOAT(N)#                         Store start type in genlist      CP03 318
IF(bf:(6)>voidflg:) L=ib:(6)#          Store iter. fix limit            CP03 319
ELSE                L=FIX(N)#          Set default fix limit            CP03 320
intpak:(K  ,pak:, 0, 9)#               Store start phase                CP03 321
intpak:(L  ,pak:, 9, 5)#               Store iteration fix              CP03 322
IF((N==iper:)\((N==iedr:)&(I==1)))#    Test for permuted phis           CP03 323
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CP03 324
NPER=NPER+1#                           Increment permutatin table       CP03 325
intpak:(NPER,pak:,15, 4)#              Store permute pointer            CP03 326
IF(NPER>10) iquit:(CP0311)#            Exceeds array........gt0160      CP03 327
I=MIN0(2,I)#                           Resolve phi restriction          CP03 328
PERN(NPER)=GN#                         Store generator address          CP03 329
IF(bf:(7)>voidflg:) PERI(NPER)=ib:(7)# Extract permute increment        CP03 330
ELSE                PERI(NPER)=PERS(I)## Store preset increments        CP03 331
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CP03 332
IF(bf:(8)>voidflg:) M=NINT(bf:(8)*16.)# Extract start weight            CP03 333
ELSE IF(N!=inul:)    M=16#             Set default start weight         CP03 334
ELSE                M=0#               Set null start weight            CP03 335
intpak:(M  ,pak:,25,bitlen:(25))#      Store start weight               CP03 336
BREAK#                                 Exit when start set              CP03 337
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CP03 338
#                                                                       CP03 339
ELSE IF(LINID==7)#                     ****** setfom line ******        CP03 340
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CP03 341
IF(bf:(1)<voidflg:)#                   Test for pretest flag            CP03 342
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CP03 343
stringlim:(1,M,N)#                     Get string limits                CP03 344
compchar:(CHRIN,M,GT3,17,2,2,20,EFOM)# Search for pretest code          CP03 345
IF(EFOM==0) iquit:(CP0312)#            No match........gt0165           CP03 346
EFOM=EFOM-1#                           Pretest flag (1=yes,0=no)        CP03 347
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CP03 348
DO I=1,4#                              Loop over fom multipliers        CP03 349
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CP03 350
IF(bf:(I+1)>voidflg:) FOPT(I)=bf:(I+1)# Get active fom opt values       CP03 351
IF(bf:(I+5)>voidflg:) WFOM(I)=bf:(I+5)# Get active fom weight           CP03 352
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CP03 353
IF(bf:(10)<voidflg:) ;#                Get fom termination flag         CP03 354
IF(bf:(11)>voidflg:) FREJ(6)=bf:(11)#  Get fom lower rejection limit    CP03 355
WRITE(6,'(f10.4)') FREJ(6)#                                             CP03 356
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CP03 357
#                                                                       CP03 358
ELSE IF(LINID==8)#                     ***** psets line ******          CP03 359
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 CP03 360
DO I=1,8#                              Loop over input fields           CP03 361
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 CP03 362
ifvo:(bf:(I)) BREAK#                   Exit on null field               CP03 363
NOPS=NOPS+1#                           Count selected psets             CP03 364
PSET(NOPS)=NINT(bf:(I))#               Store pset number                CP03 365
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 CP03 366
MXPHST=NOPS#                           Set psets limit for op           CP03 367
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CP03 368
#                                                                       CP03 369
ELSE IF(LINID==9) ;#                   ***** dump line ******           CP03 370
ELSE IF(LINID==10) ;#                  ***** archiv line ******         CP03 371
ELSE IF(LINID==11)#                    Test if plimit line              CP03 372
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 CP03 373
IF(BUFIN(1)>voidflg:) DMIN=BUFIN(1)#   Enter density threshold          CP03 374
IF(BUFIN(2)>voidflg:) RES=BUFIN(2)#    Enter peak resolution d          CP03 375
IF(BUFIN(3)>0.)       NPEAKS=NINT(BUFIN(3))# Enter sorted peak max      CP03 376
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 CP03 377
#                                                                       CP03 378
ELSE IF(LINID==12)#                    ***** only pset line ******      CP03 379
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 CP03 380
PHSPEC(1)=1#                           Flag for 'only specified' sets   CP03 381
DO I=1,39#                             For 40 selected phase sets       CP03 382
ifnm:(BUFIN(I))PHSPEC(I+1)=NINT(BUFIN(I))# Only refine these ones       CP03 383
ELSE           PHSPEC(I+1)=0#          Can't match these.               CP03 384
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 CP03 385
ELSE BREAK#                            ******  end line *****           CP03 386
writefmt:(iofm2:,'(A)',CHRIP(1^80))#   Control line to reentrant file   CP03 387
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP03 388
#                                                                       CP03 389
#                                                                       CP03 390
IF((ICNT==yes:)\(TYPE==0)) NANT=0#     Switch off edr selection         CP03 391
MSTR=NODR+MIN0(1,NANT)+MAX0(MSTR,TYPE)# Set starts for maxcon           CP03 392
MSTR=MAX0(MSTR,3)#                     Ensure min maxcon selected       CP03 393
MSEL=MAX0(MSEL,5-MSTR)#                Ensure min maxext selected       CP03 394
#                                                                       CP03 395
IF(TYPE==0)$(MSTR=0;MSEL=0$)#          Reset permutes and starts        CP03 396
#                                                                       CP03 397
IF(NINV==2) XSHI=99.#                  Prohibit positive quartets       CP03 398
IF(NINV==3) AMIN(1)=16.#               Prohibit triplets                CP03 399
IF(NFRG==no:) IQPS=no:#                Only used if available           CP03 400
IF((IQPS==no: )&(NQPS<0)) NQPS=180#    Set nq4 psi for no frag          CP03 401
IF((IQPS==yes:)&(NQPS<0)) NQPS=0#      Set nq4 psi if frag used         CP03 402
ifeq:(XSHI,0.) XSHI=-.1#               Reset xvs hi limit if 0          CP03 403
IF (XSLO>99.) XSLO=AMIN1(1.5,XSMX*.25)# Set default low xvs limit       CP03 404
IF(XSHI<0.&IXVF!=3) XSHI=XSLO#         Set default upper xvs limit      CP03 405
ELSE IF(XSHI<0.)    XSHI=AMIN1(5.,XSMX*.75)# Set upper xvs limit        CP03 406
#                                                                       CP03 407
#                                                                       CP03 408
#                                                                       CP03 409
RETURN#                                                                 CP03 410
END#                                                                    CP03 411
systemheader:(CP04)#                   User controlled alterations      CP04   1
# ################################################################## #  CP04   2
#                                                                    #  CP04   3
#                               CP04                                 #  CP04   4
#                                                                    #  CP04   5
# ################################################################## #  CP04   6
SUBROUTINE CP04#                                                        CP04   7
include:(AACOMN)#                      J.m.stewart,j.r.holden 1981      CP04   8
include:(CPCOMN)#                      R.doherty, s.r.hall 1982         CP04   9
#                                                                       CP04  10
REAL A,X,Y,Z#                          Fs20  11                         CP04  11
REAL YLO(3),YHI(3)#                                                     CP04  12
INTEGER I,IXZE,J,K,L,N,NA,M#                                            CP04  13
INTEGER SP(3),HI(3),LO(3),R,T#                                          CP04  14
INTEGER ISTRT,ISTOP#                                                    CP04  15
#                                                                       CP04  16
IF(MAPTYP==vect:)$(ISTRT=STOPS;ISTOP=STOPS1$)#                          CP04  17
ELSE             $(ISTRT=MARKS;ISTOP=STOPS $)#                          CP04  18
DO J=1,3#                              Loop cell axes (1=x;2=y;3=z)     CP04  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP04  20
SP(J)=24#                                                               CP04  21
YLO(J)=0.;  YHI(J)=1.#                 Start map lo & hi limits         CP04  22
LO(J)=-12;  HI(J)=12#                  Asymm unit limits                CP04  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP04  24
DO J=1,3#                              Loop over cell axes              CP04  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP04  26
XLO(J)=100.;  XHI(J)=100.#             Start map lo & hi limits         CP04  27
IF(FVOL==yes:)#                        If full volume requested         CP04  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP04  29
XLO(J)=0.;    XHI(J)=1.#               Start map lo & hi limits         CP04  30
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP04  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP04  32
#                                                                       CP04  33
# GENERATE SYMMETRICALLY EQUIVALENT HKL MAXIMA                          CP04  34
# ---------------------------------------------                         CP04  35
#                                                                       CP04  36
X=FLOAT(MAXH(1))#                      Float max /h/                    CP04  37
Y=FLOAT(MAXH(2))#                      Float max /k/                    CP04  38
Z=FLOAT(MAXH(3))#                      Float max /l/                    CP04  39
DO N=1,3#                              Loop over indices                CP04  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP04  41
FOR(I=ISTRT;I<ISTOP;I=I+STEPS)#        Loop over sym matrices           CP04  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP04  43
M=(N-1)*3+I#                           Point to matrix columns          CP04  44
A=ABS(X*QX(M+1)+Y*QX(M+2)+Z*QX(M+3))#  Transform max hkl                CP04  45
MAXH(N)=MAX0(NINT(A),MAXH(N))#         Save max value                   CP04  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP04  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP04  48
#                                                                       CP04  49
#                                                                       CP04  50
# SUMMATION CONTROL PARAMETERS                                          CP04  51
# -----------------------------                                         CP04  52
#                                                                       CP04  53
#----NG IS THE GRID*FINENESS*( IHMAX THE MAXIMUM VALUES OF H,K,L TO BE  CP04  54
#     SUMMED OVER, STOLMN TO STOLMX IS THE RANGE OF SIN(T)/LAMBDA.)     CP04  55
#                                                                       CP04  56
#----THE NP ARE THE NUMBER OF POINTS IN EACH DIRECTION TCPT ARE TO BE   CP04  57
#     SUMMED OVER, THE IORGX ARE THE POINTS OF TRUE BEGINNING AS THE    CP04  58
#     SURVEYORS SAY), THE INCX ARE THE SIZE OF STEPS TO BE TAKEN.       CP04  59
#                                                                       CP04  60
##                      /                     /                         CP04  61
##                      /     CELL --> MAP    /    MAP --> CELL         CP04  62
##                      /                     /                         CP04  63
##                      /   X      Y      Z   /  LAY    DOW    ACC      CP04  64
##                      /                     /                         CP04  65
##  Layer  Down  Accross/ ISUM1  ISUM2  ISUM3 / JSUM1  JSUM2  JSUM3     CP04  66
##                      / map(1) map(2) map(3)/ cel(1) cel(2) cel(3)    CP04  67
##                      /                     /                         CP04  68
##                      /  contain map codes  / contain cell codes      CP04  69
##  ---------------------------------------------------------------     CP04  70
##    X      Y     Z    /   1      2      3   /   1      2      3       CP04  71
##    X      Z     Y    /   1      3      2   /   1      3      2       CP04  72
##                      /                     /                         CP04  73
##    Y      Z     X    /   3      1      2   /   2      3      1       CP04  74
##    Y      X     Z    /   2      1      3   /   2      1      3       CP04  75
##                      /                     /                         CP04  76
##    Z      X     Y    /   2      3      1   /   3      1      2       CP04  77
##    Z      Y     X    /   3      2      1   /   3      2      1       CP04  78
##  ---------------------------------------------------------------     CP04  79
##                      / the map codes are:  / the cell codes are:     CP04  80
##                      / LAY=1; DOW=2; ACC=3 /  X=1;   Y=2;   Z=3      CP04  81
##                      /                     /                         CP04  82
#                                                                       CP04  83
IF(ISUM1*ISUM2*ISUM3!=6\ISUM1+ISUM2+ISUM3!=6)# Test for illegal axes    CP04  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP04  85
#                                                                       CP04  86
IF(ISUM1==0&ISUM2==0&ISUM3==0)#        Test if directions are zero      CP04  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP04  88
IF     (MAXH(1)>=MAXH(2)&MAXH(1)>=MAXH(3)) ISUM1=1# Set a as longest    CP04  89
ELSE IF(MAXH(2)>=MAXH(1)&MAXH(2)>=MAXH(3)) ISUM2=1# Set b as longest    CP04  90
ELSE                                       ISUM3=1# Set c as longest    CP04  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP04  92
#                                                                       CP04  93
IF(ISUM1==1)#                          If a is longest                  CP04  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP04  95
ISUM2=2;   ISUM3=3#                    Set c as shortest                CP04  96
IF(MAXH(3)>MAXH(2)) swap1:(2,3)#       Set b as shortest                CP04  97
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP04  98
ELSE IF(ISUM2==1)#                     If b is longest                  CP04  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP04 100
ISUM1=2;   ISUM3=3#                    Set c as shortest                CP04 101
IF(MAXH(3)>MAXH(1)) swap1:(1,3)#       Set a as shortest                CP04 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP04 103
ELSE#                                  If c is longest                  CP04 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP04 105
ISUM1=2;   ISUM2=3#                    Set b as shortest                CP04 106
IF(MAXH(2)>MAXH(1)) swap1:(1,2)#       Set a as shortest                CP04 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP04 108
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP04 109
IF(ISUM1*ISUM2*ISUM3!=6\ISUM1+ISUM2+ISUM3!=6)iquit:(CP0401)#            CP04 110
#                                                                       CP04 111
#                                         ## Isum1  =map axis of x      CP04 112
IMAP(1)=ISUM1; IMAP(2)=ISUM2; IMAP(3)=ISUM3# Imap(1)=map axis of x      CP04 113
ICEL(ISUM1)=1; ICEL(ISUM2)=2; ICEL(ISUM3)=3# Icel(1)=cell axis of lay   CP04 114
JSUM1=ICEL(1); JSUM2=ICEL(2); JSUM3=ICEL(3)# Jsum1  =cell axis of lay   CP04 115
#                                                                       CP04 116
#    SELECT SMALLEST POSSIBLE UNIQUE SEGMENT                            CP04 117
#    ---------------------------------------                            CP04 118
#                                                                       CP04 119
DO N=1,3#                              Loop map axes (1=lay; 3=accr)    CP04 120
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP04 121
FOR(M=ISTRT+STEPS;M<ISTOP;M=M+12)#     Loop over symmetry matrices      CP04 122
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP04 123
FOR(L=1;L<=N;L=L+1)#                   Loop map axes (1=lay; 3=accr)    CP04 124
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP04 125
NA=ICEL(L)#                            Extract cell axes (1=x;3=z)      CP04 126
I=NA*4-3; J=MOD(I+1,9)+2; K=MOD(J+1,9)+2# Point to coord elements       CP04 127
ifne:(QX(M+J),0.) BREAK#               Exit on non-diagonal element     CP04 128
ifne:(QX(M+K),0.) BREAK#               Exit on non-diagonal element     CP04 129
R=NINT(QX(M+I))#                       Extract diagonal element         CP04 130
T=MOD(NINT(QX(M+NA+9)*24.)+48,24)#     Extract translation in 24ths     CP04 131
I=MOD(R+T+24,24)#                      Make coord between 0-23ths       CP04 132
IF(I>12) I=I-24#                       Make coord between -12 - 12      CP04 133
IF((I<LO(NA))\(I>HI(NA))) BREAK#       Exit if coord outside limits     CP04 134
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP04 135
IF(L<=N) NEXT#                         Skip if posn rejected            CP04 136
IF((R==1)&(T==0)) NEXT#                Skip if at identity coord        CP04 137
IF(R<0)#                               If coord reversed                CP04 138
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP04 139
IF(T==0) T=24#                         Set zero transl to unity         CP04 140
LO(NA)=MAX0(LO(NA),(T-24)/2)#          Set start of map                 CP04 141
HI(NA)=MIN0(HI(NA),T/2)#               Set end   of map                 CP04 142
SP(NA)=HI(NA)-LO(NA)#                  Set total span of map            CP04 143
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP04 144
ELSE SP(NA)=MIN0(SP(NA),T)#            Set span to screw transl         CP04 145
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP04 146
NA=ICEL(N)#                            Point to sorted map axis         CP04 147
IF(SP(NA)<HI(NA)-LO(NA))#              Test if screw/centre transl      CP04 148
LO(NA)=MIN0(0,HI(NA)-SP(NA))#          Set new start of map             CP04 149
IF(SP(NA)==24) LO(NA)=0#               Reset start if complete cell     CP04 150
HI(NA)=LO(NA)+SP(NA)#                  Set new end   of map             CP04 151
YHI(NA)=FLOAT(SP(NA))/24.#             Store end of vector map          CP04 152
IF(MAPTYP==vect:)NEXT#                                                  CP04 153
YLO(NA)=FLOAT(LO(NA))/24.#             Store map origin                 CP04 154
YHI(NA)=FLOAT(HI(NA))/24.#             Store map end                    CP04 155
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP04 156
#                                                                       CP04 157
# SET NUMBER OF GRID POINTS IN THE THREE SUM DIRECTIONS                 CP04 158
# ----------------------------------------------------                  CP04 159
#                                                                       CP04 160
DO I=1,3#                              Loop cell axes (1=x;y=2;z=3)     CP04 161
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP04 162
XHI(I)=YHI(I)#                         Store calculated upper limit     CP04 163
XLO(I)=YLO(I)#                         Store calculated lower limit     CP04 164
J=NINT(PPANG*CELLC(I))+1#              Calculate map grid from cell     CP04 165
K=MAX0(2,(24/SP(I)))#                  Get required grid factorial      CP04 166
GRID(I)=J+MOD(K-MOD(J,K),K)#           Calculate grid size              CP04 167
ORGT(I)=0#                                                              CP04 168
K=INT(FLOAT(GRID(I))*XHI(I)+.99)#      Calc high grid limit             CP04 169
SPAN(I)=K-ORGT(I)+1#                   Get span of map                  CP04 170
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP04 171
#                                                                       CP04 172
RETURN#                                                                 CP04 173
END#                                                                    CP04 174
systemheader:(CP05)#                                                    CP05   1
# ################################################################## #  CP05   2
#                                                                    #  CP05   3
#                               CP05  (FOURR FS30)                   #  CP05   4
#                                                                    #  CP05   5
# ################################################################## #  CP05   6
SUBROUTINE CP05#                       Part 3-set cycling controls      CP05   7
include:(AACOMN)#                      J.m.stewart,j.r.holden 1981      CP05   8
include:(CPCOMN)#                      R.doherty, s.r.hall 1982         CP05   9
#                                                                       CP05  10
REAL A#                                Fs30  12                         CP05  11
INTEGER I,J,K,JJ#                      Fs30  13                         CP05  12
INTEGER ISPAN#                         Last point to be calculated      CP05  13
INTEGER OLDG(3)#                       Save input grid for fft          CP05  14
chardata:(CPA,' Fourier map points/Angstrom')#                          CP05  15
chardata:(CPB,' Fourier map gridpoints  X Y Z')#                        CP05  16
chardata:(CPC,' Map boundary gridpoints X Y Z')#                        CP05  17
chardata:(CPD,' Map boundary fraction   X Y Z')#                        CP05  18
chardata:(CPE,' Map Angstroms/point     X Y Z')#                        CP05  19
chardata:(CPF,' Cell volume fraction')#                                 CP05  20
realdata:(FMT1,[360613.,420613.,480613.])#                              CP05  21
realdata:(FMT2,[360432.,420432.,480432.])#                              CP05  22
datastuff:#                                                             CP05  23
#                                                                       CP05  24
#  SET MAP PARAMETERS ALONG MAP AXES                                    CP05  25
#  ---------------------------------                                    CP05  26
#                                                                       CP05  27
## The following MAP variables have indices based on: 1=layer;          CP05  28
## 2=down and 3=accross. These are referred to as the MAP axes.         CP05  29
## ICEL(), NG(), NP(), ORGX(), IXORG(), INCX(), IXINC(), IHMAX()        CP05  30
#                                                                       CP05  31
## These are transposed from CELL variables with indices based          CP05  32
## on the CELL axes (1=X, 2=Y, 3=Z). These variables are:               CP05  33
## IMAP(), GRID(), SPAN(), INCT(), ORGT(), MAXH()                       CP05  34
#                                                                       CP05  35
#                                                                       CP05  36
#                                                                       CP05  37
DO J=1,3#                              Loop map axes (1=lay; 3=accr)    CP05  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP05  39
JJ=ICEL(J)#                            Pick up the cell axes (1=x)      CP05  40
NG(J)=GRID(JJ)#                        Number of grid points per ce     CP05  41
NP(J)=(SPAN(JJ)-1)/INCT(JJ)+1#         Points to actually plotted       CP05  42
ORGX(J)=0#                             Published origin point           CP05  43
IXORG(J)=0#                            Assure+values for fs60 tlu       CP05  44
INCX(J)=1#                             Increment or steps along axi     CP05  45
IXINC(J)=1#                            Assure that increment will       CP05  46
IHMAX(J)=MAXH(JJ)#                     Maximum value of miller inde     CP05  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP05  48
#                                                                       CP05  49
#                                                                       CP05  50
# FOR THE FFT METHOD, MAKE SURE THAT THE NUMBER OF POINTS ALONG         CP05  51
# THE AXES OF THE 2ND AND 3RD SUMS ARE ABLE TO FACTORED BY 2,3,4,5.     CP05  52
# IF THE ORIGINAL VALUES SUPPLIED FOR NG(2) AND NG(3) DONT MEET THIS    CP05  53
# CRITERION, ADJUST THEM SO THAT  THEY DO.  BUT FIRST MAKE SURE TCPT    CP05  54
# NUMBERS NG(2) AND NG(3) ARE AT LEAST AS LARGE AS THE LARGEST HKL OR   CP05  55
# THE RESPECTIVE DIRECTIONS (I.E., IHMAX(2 OR 3) PLUS 1).               CP05  56
# MAKE SURE THE ORIGINS FOR THESE AXES ARE ZERO                         CP05  57
# IF ANY ADJUSTMENT  IS NECESSARY IT WILL BE DONE IN SUCH A WAY AS      CP05  58
# TO INCREASE THE FINENESS OF  THE GRID.  IF THE VALUE OF NG(3) SUPPLIE CP05  59
# BY THE USER IS 46 (WHICH IS NOT EVENLY DIVISIBLE BY 2,3,4, AND 5) THE CP05  60
# VALUE OF NG(3) USED WILL BE 48 (THE NEXT HIGHER NUMBER WHICH MEETS TH CP05  61
# CRITERION OF FACTORABILITY).                                          CP05  62
# IN ORDER TO USE AS LITTLE STORAGE AS POSSIBLE, COUNT UP IN SIZEH AND  CP05  63
# SIZEI THE AMOUNT OF SPACE THAT WILL BE REQUIRED FOR THE KEY AND       CP05  64
# THE FACTOR LIST.                                                      CP05  65
#                                                                       CP05  66
#                                                                       CP05  67
#                                                                       CP05  68
#                                                                       CP05  69
SIZEI=0;   SIZEH=0#                    Set initial stops                CP05  70
IF(IHMAX(2)>NG(2)) iquit:(CP0501)#     Bad resolution obtains           CP05  71
IF(IHMAX(3)>NG(3)) iquit:(CP0502)#     Bad resolution obtains           CP05  72
OLDG(2)=NG(2)#                         Save for comparison, in case     CP05  73
OLDG(3)=NG(3)#                                                          CP05  74
REPEAT#                                                                 CP05  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP05  76
J=NG(3)#                                                                CP05  77
JJ=5#                                                                   CP05  78
WHILE ((J>1)&(JJ>=2))#                                                  CP05  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP05  80
IF(J==(J/JJ)*JJ)#                                                       CP05  81
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP05  82
J=J/JJ#                                                                 CP05  83
SIZEI=SIZEI+1#                         Add room for this factor         CP05  84
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP05  85
ELSE JJ=JJ-1#                                                           CP05  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP05  87
IF(J==1) BREAK#                                                         CP05  88
NG(3)=NG(3)+1#                                                          CP05  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP05  90
REPEAT#                                                                 CP05  91
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP05  92
J=NG(2)#                                                                CP05  93
JJ=5#                                                                   CP05  94
WHILE ((J>1)&(JJ>=2))#                                                  CP05  95
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP05  96
IF(J==(J/JJ)*JJ)#                                                       CP05  97
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP05  98
J=J/JJ#                                                                 CP05  99
SIZEH=SIZEH+1#                         Add room for this factor         CP05 100
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP05 101
ELSE JJ=JJ-1#                                                           CP05 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP05 103
IF(J==1) BREAK#                                                         CP05 104
NG(2)=NG(2)+1#                                                          CP05 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP05 106
#                                                                       CP05 107
# SHOULD FIX THIS IN FOURR ALSO                                         CP05 108
#                                                                       CP05 109
DO I=1,3#                              Loop map axes (1=lay; 3=accr)    CP05 110
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP05 111
DO J=1,3;IF(ICEL(J)==I)BREAK#          Loop  x,y,z                      CP05 112
GRID(I)=NG(J)#                                                          CP05 113
K=INT(FLOAT(GRID(I))*XHI(I)+.99)#      Calc high grid limit             CP05 114
SPAN(I)=K+1#                           Get span of map                  CP05 115
NP(J)=SPAN(I)#                         Points to actually plotted       CP05 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP05 117
#                                                                       CP05 118
# ENSURE THAT, FOR SECOND AND THIRD SUMS FOR FFT, THE ORIGINS ALONG     CP05 119
# THE APPROPRIATE AXES ARE ZERO AND NO MORE TCPN NG POINT ARE TO        CP05 120
# BE PRINTED FOR THOSE AXES.                                            CP05 121
#                                                                       CP05 122
DO J=2,3#                              Loop map axes (2=down;3=accr)    CP05 123
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP05 124
IF(NP(J)>=OLDG(J))  NP(J)=NG(J)+1#                                      CP05 125
ORGX(J)=0#                             Negative origins not permitt     CP05 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP05 127
SPAN(JSUM2)=NP(2)*INCX(2)#             Reset total span down            CP05 128
SPAN(JSUM3)=NP(3)*INCX(3)#             Reset total span accross         CP05 129
GRID(JSUM2)=NG(2)#                     Reset grid down                  CP05 130
GRID(JSUM3)=NG(3)#                     Reset grid accross               CP05 131
ORGT(JSUM2)=ORGX(2)#                   Reset origin down                CP05 132
ORGT(JSUM3)=ORGX(3)#                   Reset origin accross             CP05 133
SIZEH=SIZEH+NG(2)#                     Save room for 2nd sum key        CP05 134
SIZEI=SIZEI+NG(3)#                     Save room for the 3rd sum key    CP05 135
#                                                                       CP05 136
IF(MAPTYP!=vect:)#                                                      CP05 137
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP05 138
CHROT=CPA#                                                              CP05 139
ncodefld:(PPANG,1,CHROT,400522.,1)#    Format points/angstrom           CP05 140
pt2: writeline:(0,0,0,1,3)#            Print grid limits                CP05 141
CHROT=CPB#                                                              CP05 142
DO I=1,3; BUFOT(I)=FLOAT(GRID(I))#                                      CP05 143
ncodefld:(BUFOT,1,CHROT,FMT1,3)#       Format grid numb                 CP05 144
pt2: writeline:(0,0,0,1,3)#            Print grid limits                CP05 145
CHROT=CPC#                                                              CP05 146
BUFOT(1)=FLOAT(ORGT(1)+SPAN(1)-1)#     Store grid end                   CP05 147
DO I=2,3; BUFOT(I)=FLOAT(ORGT(I)+SPAN(I))# Store grid end               CP05 148
ncodefld:(BUFOT,1,CHROT,FMT1,3)#       Format grid numb                 CP05 149
pt2: writeline:(0,0,0,1,3)#            Print grid limits of map         CP05 150
CHROT=CPD#                                                              CP05 151
ncodefld:(XHI,1,CHROT,FMT2,3)#         Format xyz fraction              CP05 152
pt2: writeline:(0,0,0,1,3)#            Print  xyz fraction              CP05 153
CHROT=CPE#                                                              CP05 154
DO I=1,3; BUFOT(I)=CELLC(I)/FLOAT(GRID(I))# Store angstroms per point   CP05 155
ncodefld:(BUFOT,1,CHROT,FMT2,3)#       Format grid numb                 CP05 156
pt2: writeline:(0,0,0,1,3)#            Print angstroms/point            CP05 157
I=GRID(1)*GRID(2)*GRID(3)#             Calc total map elements          CP05 158
J=(NP(1)-1)*(NP(2)-1)*(NP(3)-1)#       Calc total map elements          CP05 159
A=FLOAT(J)/FLOAT(I)#                   Calc fraction cell vol           CP05 160
CHROT=CPF#                                                              CP05 161
ncodefld:(A,1,CHROT,400642.,1)#        Format fraction cell vol         CP05 162
pt2: writeline:(0,0,0,1,3)#            Print fraction cell volume       CP05 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP05 164
#                                                                       CP05 165
pt4:#                                                                   CP05 166
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP05 167
WRITE(6,*) "        E000,F000       ",E000,F000#                        CP05 168
WRITE(6,*)"Grid Points NG  ",NG(1),NG(2),NG(3)#                         CP05 169
WRITE(6,*)"Grid Points NP  ",NP(1),NP(2),NP(3)#                         CP05 170
WRITE(6,*)"Grid Points ORGX",ORGX(1),ORGX(2),ORGX(3)#                   CP05 171
WRITE(6,*)"Grid Points ORGT",ORGT(1),ORGT(2),ORGT(3)#                   CP05 172
WRITE(6,*)"Grid Points INCX",INCX(1),INCX(2),INCX(3)#                   CP05 173
WRITE(6,*)"Grid Points INCT",INCT(1),INCT(2),INCT(3)#                   CP05 174
WRITE(6,*)"Grid Points SPAN",SPAN(1),SPAN(2),SPAN(3)#                   CP05 175
WRITE(6,*)"Grid Points GRID",GRID(1),GRID(2),GRID(3)#                   CP05 176
WRITE(6,*)"Grid Points END",ORGT(1)+SPAN(1)-1,ORGT(2)+SPAN(2)-1,$#      CP05 177
ORGT(3)+SPAN(3)-1#                                                      CP05 178
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP05 179
#                                                                       CP05 180
RETURN#                                                                 CP05 181
END#                                                                    CP05 182
systemheader:(CP06)#                   Solve matrix ax=b for x          CP06   1
####################################################################    CP06   2
#                                                                  #    CP06   3
#                          CP06 -- AXEQB:                          #    CP06   4
#                                                                  #    CP06   5
####################################################################    CP06   6
SUBROUTINE CP06(A1,X,B1)#                                               CP06   7
INTEGER I,J,K,L#                                                        CP06   8
REAL S,TEM#                                                             CP06   9
REAL A(3,3),A1(3,3)#                                                    CP06  10
REAL B(3),B1(3)#                                                        CP06  11
REAL X(3),DET#                                                          CP06  12
INTEGER C(3)#                                                           CP06  13
INTEGER K1,K2#                                                          CP06  14
#                                                                       CP06  15
DO I=1,3 ; B(I)=B1(I)#                 Transfer to local storage        CP06  16
DO I=1,3 ; DO J=1,3 ; A(I,J)=A1(I,J)#  Transfer to local storage        CP06  17
X(1)=voidflg:;X(2)=voidflg:;X(3)=voidflg:# Initialize                   CP06  18
C(1)=0;C(2)=0;C(3)=0#                  Initialize                       CP06  19
#                                                                       CP06  20
# TRIANGULARIZE MATRIX A                                                CP06  21
# ----------------------                                                CP06  22
#                                                                       CP06  23
DO I=1,2#                                                               CP06  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP06  25
S=0.0#                                                                  CP06  26
L=I#                                   Initialize saved index           CP06  27
DO J=1,3;ifne:(A(I,J),0.0)BREAK#                                        CP06  28
IF(J>3)#                               A row of zeros - a null equati   CP06  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP06  30
DO K=I+1,3#                            Check for other non null equat   CP06  31
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP06  32
DO J=1,3;ifne:(A(K,J),0.0)BREAK#       Break on non null row elem       CP06  33
IF(J<=3)                  BREAK#       Break on non null row            CP06  34
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP06  35
IF(I==1 & K>3)            RETURN#      All null equations               CP06  36
IF(K<=3)#                                                               CP06  37
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP06  38
DO J=1,3#                              Swap curr null row               CP06  39
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP06  40
S=A(I,J); A(I,J)=A(K,J); A(K,J)=S#     Swap elements                    CP06  41
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP06  42
S=B(I); B(I)=B(K); B(K)=S#             Swap elements                    CP06  43
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP06  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP06  45
#                                                                       CP06  46
DO J=I,3#                              Find largest element in column   CP06  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP06  48
IF(ABS(A(J,I))<=S) NEXT#                                                CP06  49
S=ABS(A(J,I)); L=J#                                                     CP06  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP06  51
IF(L!=I)#                                                               CP06  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP06  53
DO J=I,3#                                                               CP06  54
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP06  55
S=A(I,J); A(I,J)=A(L,J); A(L,J)=S#     Swap elements                    CP06  56
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP06  57
S=B(I); B(I)=B(L); B(L)=S#             Swap elements                    CP06  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP06  59
TEM=A(I,I)#                                                             CP06  60
IF(ABS(TEM)<1.E-17) NEXT#                                               CP06  61
FOR(J=I+1;J<=3;J=J+1)#                                                  CP06  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP06  63
IF(A(J,I)==0.0) NEXT#                                                   CP06  64
S=A(J,I)/TEM#                                                           CP06  65
A(J,I)=0.0#                                                             CP06  66
FOR(K=I+1;K<=3;K=K+1) A(J,K)=A(J,K)-A(I,K)*S#                           CP06  67
B(J)=B(J)-B(I)*S#                                                       CP06  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP06  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP06  70
#                                                                       CP06  71
#   COMPRESS INTO TOP CORNER                                            CP06  72
#   -------------------------                                           CP06  73
#                                                                       CP06  74
DO I=1,2#                                                               CP06  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP06  76
DO K1=1,3;ifne:(A(I,K1),0.0)BREAK#                                      CP06  77
DO J=I+1,3#                                                             CP06  78
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP06  79
DO K2=1,3;ifne:(A(J,K2),0.0)BREAK#                                      CP06  80
IF(K2<K1)#                                                              CP06  81
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP06  82
DO K=I,3#                              Swap curr null row               CP06  83
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP06  84
S=A(I,K); A(I,K)=A(J,K); A(J,K)=S#     Swap elements                    CP06  85
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP06  86
S=B(I); B(I)=B(J); B(J)=S#             Swap elements                    CP06  87
K1=K2#                                                                  CP06  88
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP06  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP06  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP06  91
#WRITE(6,'(A1,30X,3E16.9)')("C",(A(I,J),J=1,3),I=1,3)                   CP06  92
#                                                                       CP06  93
# TRYING TO BACK SUBSTITUTE                                             CP06  94
# -------------------------                                             CP06  95
#                                                                       CP06  96
ifeq:(A(3,3),0.0)B(3)=voidflg:#        Undef  z value from row 3        CP06  97
ELSE             X(3)=B(3)/A(3,3)#     Got z value from row 3           CP06  98
#                                                                       CP06  99
#                                                                       CP06 100
ifeq:(A(2,2),0.0)#                     No y value from row 2            CP06 101
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP06 102
ifne:(A(2,3),0.0)#                                                      CP06 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP06 104
ifvo:(X(3))X(3)=B(2)/A(2,3)#           Got a z value from row 2         CP06 105
ELSE ifne:(X(3),B(2)/A(2,3))#          Also got one from row 1          CP06 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP06 107
B(2)=voidflg:#                         They don't match !               CP06 108
X(3)=voidflg:#                         Cancel previous value            CP06 109
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP06 110
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP06 111
ELSE B(2)=voidflg:#                    No results from second row       CP06 112
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP06 113
ELSE#                                  Potentially a row 2 y value      CP06 114
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP06 115
ifeq:(A(2,3),0.0) X(2)=B(2)/A(2,2)#    Purely dependent on y            CP06 116
ELSE ifnv:(X(3))  X(2)=(B(2)-B(3)*A(2,3))/A(2,2)# On z also             CP06 117
ELSE C(2)=3#                           Can't solve 1 equat, 2 unknown   CP06 118
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP06 119
#                                                                       CP06 120
#                                                                       CP06 121
ifne:(A(1,1),0.0)#                     Potential x value                CP06 122
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP06 123
ifnv:(X(3))            B(1)=B(1)-X(3)*A(1,3)#                           CP06 124
ELSE ifne:(A(1,3),0.0) C(1)=1#         Undef variable 3                 CP06 125
ifnv:(X(2))            B(1)=B(1)-X(2)*A(1,2)#                           CP06 126
ELSE ifne:(A(1,2),0.0) C(1)=C(1)+2#    Undef variable 2                 CP06 127
IF(C(1)==0)            X(1)=B(1)/A(1,1)# Finally got the value of x(1   CP06 128
ELSE                   C(1)=C(1)+4#    Undef variable 1                 CP06 129
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP06 130
ELSE#                                                                   CP06 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP06 132
ifne:(A(1,2),0.0)ifvo:(X(2))C(1)=2#    Undefined var  y                 CP06 133
ifne:(A(1,3),0.0)ifvo:(X(3))C(1)=C(1)+1# Undefined var z                CP06 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP06 135
#                                                                       CP06 136
#                                                                       CP06 137
IF(C(2)==0&C(1)!=0)#                   Solve from first row only        CP06 138
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CP06 139
IF(C(1)==2)ifvo:(X(2)) X(2)=B(1)/A(1,2)# Got y from row 1               CP06 140
ELSE ifne:(X(2),B(1)/A(1,2))#          Also got one from row 2          CP06 141
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CP06 142
B(1)=voidflg:#                         They don't match !               CP06 143
X(2)=voidflg:#                         Cancel value                     CP06 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CP06 145
IF(C(1)==1)ifvo:(X(3)) X(3)=B(1)/A(1,3)# Get z from row 1               CP06 146
ELSE ifne:(X(3),B(1)/A(1,3))#          Also got one from row 2          CP06 147
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CP06 148
B(1)=voidflg:#                         They don't match !               CP06 149
X(3)=voidflg:#                         Cancel value                     CP06 150
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CP06 151
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CP06 152
#                                                                       CP06 153
ifnv:(B(1))ifnv:(B(2))#                Equations not yet erased?        CP06 154
IF(C(2)==3 &C(1)>0&C(1)<4)#            Solve 2x2 for y and z            CP06 155
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CP06 156
DET=A(1,2)*A(2,3)-A(2,2)*A(1,3)#       2x2 determinant                  CP06 157
ifne:(DET,0.0)#                        Can't do anything if singular    CP06 158
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CP06 159
X(2)=( A(2,3)*B(1) -A(1,3)*B(2))/DET#                                   CP06 160
X(3)=(-A(2,2)*B(1) +A(1,2)*B(2))/DET#                                   CP06 161
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CP06 162
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CP06 163
#                                                                       CP06 164
RETURN#                                                                 CP06 165
END#                                                                    CP06 166
systemheader:(CP10)#                   Input bdf phis & invariants      CP10   1
####################################################################    CP10   2
#                                                                  #    CP10   3
#                             CP10 (FORMERLY GT02)                 #    CP10   4
#                                                                  #    CP10   5
####################################################################    CP10   6
SUBROUTINE CP10#                       S.r.hall  jun 81                 CP10   7
include:(AACOMN)#                                                       CP10   8
include:(CPCOMN)#                                                       CP10   9
#                                                                       CP10  10
INTEGER I,M,N,IP,PN#                                                    CP10  11
INTEGER GN#                                                             CP10  12
REAL EVAL,FCAL,FREL#                                                    CP10  13
REAL A,B#                                                               CP10  14
REAL BUF1(12)#                                                          CP10  15
INTEGER IW(20)#                        Item request (want) array        CP10  16
INTEGER M1#                                                             CP10  17
INTEGER FSRC#                                                           CP10  18
INTEGER IR(17)#                                                         CP10  19
INTEGER NMDS#                          Data set number *1000            CP10  20
string:(LINE,80)#                                                       CP10  21
chardata:(CPA," E values not on bdf - spawning GENEV ...")#             CP10  22
intdata:(PRC,[0,0,30,45,60,90,120,135,150,180])#                        CP10  23
realdata:(PI2,6.28318);    realdata:(PHI,0.)#                           CP10  24
datastuff:#                                                             CP10  25
#                                                                       CP10  26
#   ENTER BDF PHIS IF REQUESTED                                         CP10  27
#   ----------------------------                                        CP10  28
#                                                                       CP10  29
#    SCAL FOR DATA SET                                                  CP10  30
M1=MARK6#                              Start of ref                     CP10  31
NMDS=DSNM*1000#                        Set dataset offset               CP10  32
IW(1)=1#                               Idnum for hkl                    CP10  33
IW(2)=2#                               Idnum for stol                   CP10  34
IW(3)=3#                               Idnum for multiplicity           CP10  35
IW(4)=NMDS+604#                        Idnum for <|e|^2> -value         CP10  36
IW(5)=NMDS+304#                        Idnum for fobs                   CP10  37
IW(6)=NMDS+305#                        Idnum for f sigma                CP10  38
IW(7)=NMDS+800#                        Idnums for frel & fcal           CP10  39
IW(8)=NMDS+801; IW(9)=NMDS+700#        Idnums for arel & fc-phi         CP10  40
IW(10)=NMDS+629+NPST*2#                Idnum for gt phase               CP10  41
IW(11)=NMDS+599+ETYP#                  Idnum for /e/-value              CP10  42
IW(12)=NMDS+302#                       Idnum for f^2 rel                CP10  43
IW(13)=NMDS+300#                       Idnum for intensity              CP10  44
IW(14)=NMDS+204#                       Idnum for 1/lp (for i->f2)       CP10  45
KEY(1)=4;KEY(2)=11;KEY(3)=0;KEY(4)=0#  Set search delimiters            CP10  46
indexpkt:(1,lrrefl:,PN,IP,0,KEY,IW,IR)# Point to idnums in refl         CP10  47
IF(KEY(4)<=0)#                         /e/ miss ........gt0240          CP10  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP10  49
writeline:(2,CPA,NCPA,3,2)#            Output message                   CP10  50
LINFLG=1#                              Force new read line              CP10  51
IF((CHRIN(1^4)!='END ')&(CHREOF!=1))#  Next inpt line isn't end or eo   CP10  52
writefmt:(iofm2:,'(A)',CHRIP(1^80))#   Write header to file             CP10  53
rewindbdf:(1)#                         Half read this bdf so rewind     CP10  54
closefmt:(iofm2:)#                     Shut down the line file          CP10  55
openfmt:(iofm1:,' ')#                  Re open .gt0 file                CP10  56
openfmt:(iofm2:,' ')#                  Open the .gt1 file               CP10  57
REPEAT#                                Read until finished              CP10  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP10  59
readfmt:(iofm2:,'(A80)',150,LINE)#     Read a line of instructions      CP10  60
writefmt:(iofm1:,'(A80)',LINE)#        Add instructions to unused fil   CP10  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP10  62
150 closefmt:(iofm2:)#                 Close dump line file             CP10  63
closefmt:(iofm1:)#                     Close new linestream file        CP10  64
linestream:('CP0')#                    Insert file into line stream     CP10  65
XCEPT=1#                               Threw an exception               CP10  66
RETURN#                                Go no further                    CP10  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP10  68
closefmt:(iofm2:)#                     Close unrequired line file       CP10  69
FSRC=0#                                Source of f values               CP10  70
IF    (IR( 5)>0)       FSRC= 5#        Default is to use f              CP10  71
ELSEIF(IR(12)>0)       FSRC=12#        Otherwise f^2                    CP10  72
ELSEIF(IR(13)*IR(14)>0)FSRC=13#        Can use intensity                CP10  73
ELSE            iquit:(CP1010)#        Not enough info to continue      CP10  74
IF(INPH==1&IR(5)+IR(7)==0) iquit:(CP1011)# Sf miss.......gt0245         CP10  75
IF(INPH==1&IR(8)+IR(9)==0) iquit:(CP1012)# Fc phi miss...gt0250         CP10  76
IF(INPH==2&IR(10)==0)      iquit:(CP1013)# Gt phi miss...gt0255         CP10  77
opendac:(ioda2:,3,arith:(mxchwd:,*,12),' ')# Create direct access ref   CP10  78
##         REC 1   hkl                                                  CP10  79
##             2   epsilon                                              CP10  80
##             3   STOL                                                 CP10  81
##             4   FREL                                                 CP10  82
##             5   EREL                                                 CP10  83
##             6   <|e|^2> - random atom model                          CP10  84
##             7   FCAL                                                 CP10  85
##             8   ECAL                                                 CP10  86
##             9   PHAS                                                 CP10  87
##            10   WGT =1.0                                             CP10  88
##                                                                      CP10  89
DACREF=0#                                                               CP10  90
DO I=1,12;BUF1(I)=0.#                  Initialize buff pointers         CP10  91
#                                                                       CP10  92
REPEAT#                                Loop over all records            CP10  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP10  94
readwpkt:(1,lrrefl:,PN,IP,0)#          Point to next packet             CP10  95
IF(IP<=0) BREAK#                       Exit if no more                  CP10  96
I=IP+IR(11);  EVAL=QX(I)#              Extract /e/-value                CP10  97
movepakwd:(QX(IP+IR(1)),BUF1(1))#      Put packed hkl in temp           CP10  98
movepakwd:(QX(IP+IR(3)),BUF1(2))#      Put packed multiplicity/epsilo   CP10  99
BUF1(3)=QX(IP+IR( 2))#                 Sin theta on lambda              CP10 100
I=IP+IR(FSRC);ifvo:(QX(I)) NEXT#                                        CP10 101
ELSEIF(FSRC== 5)BUF1(4)=QX(I)#         Get frel                         CP10 102
ELSEIF(FSRC==12)BUF1(4)=SQRT(MAX(0.0,QX(I)))# Get frel from f^2         CP10 103
ELSEIF(FSRC==13)BUF1(4)=SQRT(MAX(0.0,QX(I)*QX(IP+IR(14))))# From irel   CP10 104
BUF1(5)=QX(IP+IR(11))#                 Get erel                         CP10 105
BUF1(6)=QX(IP+IR( 4))#                 Get <|e|^2> -value               CP10 106
IF(IR(6)>0)BUF1(10)=QX(IP+IR(6))#      Get sigma                        CP10 107
ELSE                BUF1(10)=1.0#      Fudge it                         CP10 108
ifeq:(BUF1(10),0.0) BUF1(10)=1.0#      Fudge it                         CP10 109
DACREF=DACREF+1#                       Increment direct acces count     CP10 110
writedac:(ioda2:,,DACREF,BUF1)#                                         CP10 111
#                                                                       CP10 112
IF(EVAL+0.1<EPAR) NEXT#                Skip if below threshold          CP10 113
IF(INPH==1)#                           Test if phis from fc calc        CP10 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP10 115
I=IP+IR(5);  FREL=QX(I)#               Extract frel value               CP10 116
I=IP+IR(7);  FCAL=QX(I)#               Extract fcal value               CP10 117
IF(FREL*SCAL*FRAC>FCAL) NEXT#          Skip if outside sf test          CP10 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP10 119
I=IP+IR(1);  movepakwd:(QX(I),A)#      Put packed hkl in temp           CP10 120
FOR(GN=M1;GN<MQ;GN=GN+MARK)#           Loop over generator list         CP10 121
compakwd:(A,EQ,hkl:,BREAK)#            Exit when hkl match found        CP10 122
IF(GN>=MQ) NEXT#                       Not on list- forget it           CP10 123
IF(IR(7)>0)fcal:=QX(IP+IR(7))/SCAL#    Fcalculated exists               CP10 124
#EXF2:=QX(IP+IR(4))#                   GET ORIGNL EVAL -NOT GS PACKED   CP10 125
frel:=QX(IP+IR(5))#                    Got frelative                    CP10 126
stol:=QX(IP+IR(2))#                    Sin theta on lambda              CP10 127
movepakwd:(QX(IP+IR(3)),mult:)#                                         CP10 128
phi1:=0.#                                                               CP10 129
IF(INPH==0) NEXT#                      Dont need the phase              CP10 130
IF(INPH<0&(IR(8)+IR(9)<=0)) NEXT#      Dont need the phase              CP10 131
IF(sta:>nos:) NEXT#                    Skip if already starter          CP10 132
IF(INPH<=1)#                           Test if in fc phi mode           CP10 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP10 134
I=IP+IR(9); IF(I>IP) PHI=QX(I)#        If available get fc phi          CP10 135
ELSE IF(IR(8)>0)#                      Else get fc phi from a & b       CP10 136
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP10 137
I=IP+IR(8);  A=QX(I);  B=QX(I+1)#      Point to acal                    CP10 138
IF((ABS(A)<.01)&(ABS(B)<.01)) NEXT#    Avoid null phi case              CP10 139
PHI=ATAN2(B,A)/PI2#                    Calc phi in cycles (2pi=1.0)     CP10 140
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP10 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP10 142
ELSE#                                  If inph=2 extract gt phi         CP10 143
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP10 144
I=IP+IR(10); PHI=QX(I)#                Point and extract gt phi         CP10 145
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP10 146
M=MOD(3600+NINT(PHI*360.),360)#        Convert phi to degrees           CP10 147
IF(prc:>1.5)#                          Test if phi restricted           CP10 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP10 149
I=iprc:;    I=PRC(I)#                  Get phi resr & integer phi       CP10 150
M=IABS(I-M); M=MIN0(M,360-M)#          Get smallest difference          CP10 151
IF(M<90) M=I#                          Set at restr value               CP10 152
ELSE     M=I+180#                                                       CP10 153
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP10 154
alt:=FLOAT(M+360)#                     Store refined phase in temp      CP10 155
IF(M==0) M=360#                        Ensure phase non-zero            CP10 156
intpak:(M   ,pak:, 0, 9)#              Store refined phase              CP10 157
IF(INPH<0) NEXT#                       Skip if not input starter        CP10 158
sta:=set:#                             Set status as set phi            CP10 159
N=FIX(iset:)#                          Extract iteration fix            CP10 160
intpak:(N   ,pak:, 9, 6)#              Store iteration fix              CP10 161
intpak:(INPH,pak:,19, 3)#              Store input mode(fc=1;gt=2)      CP10 162
intpak:(16  ,pak:,25,bitlen:(25))#     Store start weight               CP10 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP10 164
INPH=MAX0(INPH,0)#                     Reset phi flag                   CP10 165
#                                                                       CP10 166
RETURN#                                                                 CP10 167
END#                                                                    CP10 168
systemheader:(CP11)#                   Input invariants                 CP11   1
####################################################################    CP11   2
#                                                                  #    CP11   3
#                             CP11 (FORMERLY GT02)                 #    CP11   4
#                                                                  #    CP11   5
####################################################################    CP11   6
SUBROUTINE CP11#                       S.r.hall  jun 81                 CP11   7
include:(AACOMN)#                                                       CP11   8
include:(CPCOMN)#                                                       CP11   9
#                                                                       CP11  10
macro:(noodr:,$(#                      Common header macro              CP11  11
CHROT=' '#                             Initialize to blank              CP11  12
movechar:(GT2,27,CHROT,2,66,1)#        Header row                       CP11  13
writeline:(2,0,0,1,3)#                 Print chrot                      CP11  14
CHROT=' ';CHROT(2^2)='#';CHROT(67^67)='#'# Space row                    CP11  15
writeline:(0,0,0,1,3)#                 Print chrot                      CP11  16
writeline:(0,GTA,NGTA,3,3)#            Print message                    CP11  17
writeline:(0,GTB,NGTB,3,3)#            Print message                    CP11  18
writeline:(0,GTC,NGTC,3,3)#            Print message                    CP11  19
writeline:(0,GTD,NGTD,3,3)#            Print message                    CP11  20
writeline:(0,GTE,NGTE,3,3)#            Print message                    CP11  21
CHROT=' ';CHROT(2^2)='#';CHROT(67^67)='#'# Space row                    CP11  22
writeline:(0,0,0,1,3)#                 Print chrot                      CP11  23
movechar:(GT2,27,CHROT,2,66,1)#        Header row                       CP11  24
writeline:(0,0,0,1,3)#                 Print chrot                      CP11  25
MAPTYP=vect:#                          Flag for e*e-1 patterson map     CP11  26
$) )#                                                                   CP11  27
#                                                                       CP11  28
INTEGER H,I,J,K,L,M,IP,PN,NN#                                           CP11  29
INTEGER M1,M2,DET,M11,M12,M13,M21,M22,M23,M31,M32,M33#                  CP11  30
INTEGER IA,IB,IC,ID,IQ,IS,IT,JP,MM,MREC,GN,NINV,NREC,N1,N2,N3,N4#       CP11  31
INTEGER IU(3)#                                                          CP11  32
INTEGER INDX#                                                           CP11  33
REAL     ACUM(8)#                                                       CP11  34
INTEGER  CNT(8)#                       Count of types                   CP11  35
INTEGER  GCNT(8)#                      Count of types                   CP11  36
INTEGER  SRT(8)#                       Sorted uvw classes               CP11  37
INTEGER  MODC#                         Semi-invariant moduli classes    CP11  38
REAL     U(3)#                                                          CP11  39
INTEGER LSIVC(3,3),LMDSI(3)#           Local semi-invariants            CP11  40
INTEGER SIABS(3)#                      Semi-invariant odrs absent       CP11  41
REAL D,XVS#                                                             CP11  42
REAL A,B,C,W,SUMW,SSI(4)#                                               CP11  43
#                                                                       CP11  44
chardata:(GT1,  NGEN  H   K   L    |E|   TYPE  TRIP$#                   CP11  45
  PSI0  POSQ  NEGQ     SUMA)#                                           CP11  46
chardata:(GT2,'   ODREDRPERSETNULUVWHKL+-#12=2n+1')#                    CP11  47
chardata:(GT3,$#                                                        CP11  48
' #  No ODRs were found for semi-invariant index     U             #')# CP11  49
chardata:(GT4,$#                                                        CP11  50
' #  This indicates very weak reflections in the class             #')# CP11  51
chardata:(GTA,$#                                                        CP11  52
' #  NOTE that assigning origin defining reflections (ODR)s for    #')# CP11  53
chardata:(GTB,$#                                                        CP11  54
' #  this structure is difficult because not all classes of        #')# CP11  55
chardata:(GTC,$#                                                        CP11  56
' #  indices have strong E-values. This suggests that there is     #')# CP11  57
chardata:(GTD,$#                                                        CP11  58
' #  strong pseudo-symmetry in the structure and additional        #')# CP11  59
chardata:(GTE,$#                                                        CP11  60
' #  caution is needed to assess the CRISP solutions.              #')# CP11  61
chardata:(GTF,' Parity groups missing are:')#                           CP11  62
realdata:(FM,[90413.,130413.,170413.,50413.,#                           CP11  63
240522.,650802.,360603.,420603.,480603.,540603.,#                       CP11  64
690413.,730413.,770413.])#                                              CP11  65
realdata:(ATHR,0.); realdata:(BTHR,0.)#                                 CP11  66
datastuff:#                                                             CP11  67
#                                                                       CP11  68
#   ENTER INVARIANTS FROM FILE 4                                        CP11  69
#   ---------------------------                                         CP11  70
#                                                                       CP11  71
M1=MARK6#                              = start of genlist               CP11  72
M2=MARK7#                              = end of generator list and no   CP11  73
MG=MARK7#                              Mark start of pmap               CP11  74
DO I=1,3;DO J=1,3; LSIVC(I,J)=NINT(SIVC(I,J))# Copy to local var        CP11  75
DO I=1,3;LMDSI(I)=NINT(MDSI(I))#       Copy to local var                CP11  76
MODC=2#                                Assume a modulo 2 semi-invar     CP11  77
DO I=1,3;IF(LMDSI(I)==3)MODC=3#        Unless modulo 3 special cases    CP11  78
DO I=1,3;IF(LMDSI(I)==4)MODC=4#        Or modulo 4  special cases       CP11  79
DO I=1,3;IF(LMDSI(I)>100)MODC=1000#    Infinite possibilities           CP11  80
#                                      Can fix the origin anywhere      CP11  81
#                                                                       CP11  82
#                                                                       CP11  83
I=NINT(AMIN(1)*128.);J=NINT(AMIN(2)*128.)# Convert to integer           CP11  84
plastbitsword:(I,ATHR)#                Pack a-limit for test            CP11  85
plastbitsword:(J,BTHR)#                Pack b-limit for test            CP11  86
DO I=1,8; ACUM(I)=0.#                                                   CP11  87
DO I=1,8;  CNT(I)=0#                                                    CP11  88
DO I=1,8; GCNT(I)=0#                                                    CP11  89
DO I=1,4;  NTYP(I)=0#                  Zeroize invariant counters       CP11  90
GN=M1-MARK;    MM=GN;    MG=MQ#        Mark start of genlist            CP11  91
#                                                                       CP11  92
LINRM=3;  MREC=1;  BOT=M2#             Force first header               CP11  93
#                                                                       CP11  94
DO N1=1,NTOT#                          Loop over all generators         CP11  95
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP11  96
GN=GN+MARK#                            Incr to start of this gen        CP11  97
top:=FLOAT(BOT);    pnt:=FLOAT(GN)#    Store genlist pointers           CP11  98
NREC=N1+3#                             Set correct file4 recnum         CP11  99
MREC=MREC+1#                           Set output file3 recnum          CP11 100
IF(N1>NGEN) NREC=NREC+NLIM#            Use skip for psi0 gens.          CP11 101
NINV=0; SUMW=0.#                       Initialize accumulators          CP11 102
DO I=1,4;  SSI(I)=0.#                  Zeri invariant counters          CP11 103
#                                                                       CP11 104
REPEAT#                                Loop over all invariants         CP11 105
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP11 106
W=0.#                                  Reset weight sum                 CP11 107
IF(N1>NGEN) IT=psi0:#                  Set as triplet psi0              CP11 108
ELSE        IT=trip:#                  Set as triplet                   CP11 109
readwpkt:(4,NREC,PN,IP,0)#             Point to invariant packet        CP11 110
IF(IP<=0) BREAK#                       Exit if no more                  CP11 111
IF(IT==psi0:)generatornum:(IP,NN,4)#   Max gen of a psi0 invariant      CP11 112
ELSE        generatornum:(IP,NN,1)#    Max gen of triplet or quartet    CP11 113
IF(NN>NGEN) NEXT#                      Ignore si with nn>ngen           CP11 114
N4=0#                                  Initialise for psi0              CP11 115
IF(IT!=psi0:)#                         Enter if not psi0 triplet        CP11 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP11 117
generatornum:(IP,N4,4)#                Generator 4 of a quartet         CP11 118
IF(N4==0)#                             Test if invariant is triplet     CP11 119
comppakwdone:(IP,LT,ATHR,NEXT)#        Ignore trip if a<amin            CP11 120
ELSE#                                  Else must be quartet             CP11 121
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP11 122
comppakwdone:(IP,LT,BTHR,NEXT)#        Ignore quar if b<bmin            CP11 123
xvectorsum:(IP,I)#                     Extract xvector sum*8            CP11 124
XVS=FLOAT(IABS(I-512))/8.#             Convert to +real value           CP11 125
IF((IXVF==2)&(I<512)) NEXT#            If inside & negative skip        CP11 126
IF((IXVF==4)&(I>512)) NEXT#            If outside & positive skip       CP11 127
IF(I<512) IT=posq:#                    If negative set as posq          CP11 128
ELSE IF(XVS>=XSHI) IT=posq:#           Set type as pos quartet          CP11 129
ELSE IF(XVS<=XSLO) IT=negq:#           Set type as neg quartet          CP11 130
ELSE                 NEXT#                                              CP11 131
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP11 132
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP11 133
IF((SSI(1)>=MXTG)&(IT==trip:)) NEXT#   Skip if t3/gen exceeded          CP11 134
IF((SSI(3)>=MXQG)&(IT==posq:)) NEXT#   Skip if pq/gen exceeded          CP11 135
IF((SSI(4)>= 100)&(IT==negq:)) NEXT#   Skip if nq/gen exceeded          CP11 136
#                                                                       CP11 137
phaserestr:(IP,IC)#                    Get restr phi code (1-10)        CP11 138
phisigncode:(IP,IS)#                   Get phi sign code (0-7)          CP11 139
phiinvshift:(IP,ID)#                   Get si shift (deg/30)            CP11 140
phifragment:(IP,IQ)#                   Get frag psi est (0-359)         CP11 141
probfactor:(IP,IA)#                    Get ab value*128                 CP11 142
probfsigma:(IP,IB)#                    Get sig(a)*128                   CP11 143
generatornum:(IP,N2,2)#                Get n2 value                     CP11 144
generatornum:(IP,N3,3)#                Get n3 value                     CP11 145
#                                                                       CP11 146
A=FLOAT(IA)/128.#                      Extract prob fact a or b         CP11 147
B=AMIN1(FLOAT(IB)/128.,A*.5)#          Extract sigma(a)                 CP11 148
A=A-B*SIGA#                            Reduce a by factor siga          CP11 149
D=EXP(A)#                              Exponential of a                 CP11 150
IF(IC==1) C=(D-1./D)/(D+1./D)#         Calc centro expect factor        CP11 151
ELSE C=A*(A+.4807)/(A*(A+.8636)+1.3943)# Calc noncen expect factor      CP11 152
C=AMAX1(C,mine:)#                      Ensure above min expect f        CP11 153
IA=MIN0(127,NINT(A*8.))#               Prepare ab for packing           CP11 154
IB=MIN0(127,NINT(C*64.))#              Prepare expectf for packing      CP11 155
ID=ID*30#                              Convert si shift to degrees      CP11 156
IF(IQPS==yes:)   ID=ID-IQ#             Adjust shift if qpsi used        CP11 157
IF(IT==negq:)     ID=ID-NQPS#          Adjust shift if neg quartet      CP11 158
ID=MOD(ID+3600,360)#                   Ensure total shift is 0-359      CP11 159
IF(IXVF==5) IT=MIN(IT,2)#              Make negq4 equiv to posq4        CP11 160
IF(N2!=N3) W=W+512.#                   Sum unique contributors          CP11 161
IF(N3!=N4) W=W+512.#                   Sum unique contributors          CP11 162
IF(N4!=0 ) W=W+512.#                   Sum unique contributors          CP11 163
IF((IT!=negq:)&(IT!=ISEL))#            Sum w*alpha for selection        CP11 164
SUMW=SUMW+A*C*W#                       Sum a*expf*ni to each gen        CP11 165
#                                                                       CP11 166
IF((N1<=N2)&(N1<=N3)&(N2<=N3))#        Test for unique invariant        CP11 167
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP11 168
IF(IT==trip:) NTYP(1)=NTYP(1)+1#       Count unique triplets            CP11 169
ELSE IF((N1<=N4)&(N2<=N4)&(N3<=N4))#   Test for unique quartet          CP11 170
NTYP(IT+1)=NTYP(IT+1)+1#               Count unique quartets            CP11 171
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP11 172
IF(IT==psi0:) NTYP(2)=NTYP(2)+1#       Count psi(0) triplets            CP11 173
SSI(IT+1)=SSI(IT+1)+1.#                Count redundant invars           CP11 174
#                                                                       CP11 175
JP=BOT;  incrqx:(BOT,BOT+4,CP1103)#    Get mem for next invariant       CP11 176
intpak:(IT,QX(JP+1), 0, 2)#            Pack invar. type  bits  1- 0     CP11 177
intpak:(IS,QX(JP+1), 2, 3)#            Pack si sign code bits  4- 2     CP11 178
intpak:(IC,QX(JP+1), 5, 4)#            Pack si psi restr bits  8- 5     CP11 179
intpak:(ID,QX(JP+1), 9, 9)#            Pack total shift  bits 17- 9     CP11 180
intpak:(IB,QX(JP+1),18, 7)#            Pack expectf*64   bits 22-18     CP11 181
intpak:(IA,QX(JP+1),25,bitlen:(25))#   Pack ab value*8   bits **-25     CP11 182
QX(JP+2)=FLOAT(M1+(N2-1)*MARK)#        Convert n2 as genlist addr       CP11 183
QX(JP+3)=FLOAT(M1+(N3-1)*MARK)#        Convert n3 as genlist addr       CP11 184
QX(JP+4)=FLOAT(M1+(N4-1)*MARK)#        Convert n4 as genlist addr       CP11 185
NINV=NINV+4#                           Count words per si block         CP11 186
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP11 187
I=ista:;   sma:=SUMW+BIAS(I)#          Store sum w*alf with bias        CP11 188
bot:=FLOAT(BOT)#                       Store end of genlist block       CP11 189
#                                                                       CP11 190
gethkl:(GN+2,U)#                       Unpak uvw: into real word        CP11 191
IF(MODC<1000& GN<MQ)#                  Only for trip & quart gens       CP11 192
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP11 193
DO J=1,3;IU(J)=MOD(12+NINT(U(J)),LMDSI(J))# Convert to modulo integer   CP11 194
IF    (MODC==2)INDX=IU(1)+IU(2)*2+IU(3)*4# Make an integer index 1-8    CP11 195
ELSEIF(MODC==3)INDX=IU(1)+IU(2)*4#     Make an integer index 1-8        CP11 196
ELSEIF(MODC==4)INDX=IU(1)#             Make an integer index 1-4        CP11 197
IF(INDX==0) INDX=8#                                                     CP11 198
ACUM(INDX)=ACUM(INDX)+SUMW#            Accumulated semi-invariant sum   CP11 199
CNT(INDX) =CNT(INDX) +1#               Count of types                   CP11 200
GCNT(INDX)=GCNT(INDX)+NINT(SSI(1))#    Count of triplets involved       CP11 201
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP11 202
#                                                                       CP11 203
IF((NINV>12)&(N1>NGEN))#               Test if psi(0) gen active        CP11 204
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP11 205
movereal:(QX,GN+1,QX,MG+1,MARK,1)#     Bubble up psi(o) gen's           CP11 206
MG=MG+MARK#                            Incr new psi(o) limit            CP11 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP11 208
ELSE IF(N1>NGEN) NEXT#                 No record for null psi0          CP11 209
#                                                                       CP11 210
pt3: IF(GN<MQ)#                        Ignore   psi0   generators       CP11 211
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP11 212
gethkl:(GN+1,BUFOT)#                   Extract h,k,l                    CP11 213
BUFOT(4)=FLOAT(N1)#                    Store generator number           CP11 214
BUFOT(5)=evl:#                         Store /e/ value                  CP11 215
BUFOT(6)=SUMW#                         Store sum w*alpha                CP11 216
ncodefld:(BUFOT,1,CHROT,FM,6)#         Format above items               CP11 217
ncodefld:(SSI,1,CHROT,FM(7),4)#        Format invariant counters        CP11 218
IF(GN<MQ) ncodefld:(U,1,CHROT,FM(11),3)# Dump u,v,w                     CP11 219
movechar:(GT2,I*3-2,CHROT,28,3,0)#     Insert generator status          CP11 220
writeline:(0,GT1,NGT1,1,3)#            Print generator items            CP11 221
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP11 222
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP11 223
NTOT=(MG-MARK6)/MARK#                  Reset total generators           CP11 224
NPSI=(MG-MQ)/MARK#                     Reset number psi(0)'s            CP11 225
readwpkt:(4,endrecord:,I,I,0)#         Rewind and close file 4          CP11 226
#                                                                       CP11 227
#                                                                       CP11 228
#                                                                       CP11 229
#                                                                       CP11 230
DO I=1,3;SIABS(I)=0#                   Assume odrs exist in set         CP11 231
IF(NODR!=0&MODC<1000)#                 If odr's needed in principle     CP11 232
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP11 233
DO I=1,7;SRT(I)=I#                     Order largest to smallest xvsu   CP11 234
DO I=1,6;DO J=I+1,7#                   Loop over the classes            CP11 235
IF(ACUM(SRT(J))>ACUM(SRT(I)))#         Rank largest to smallest         CP11 236
$(K=SRT(I);SRT(I)=SRT(J);SRT(J)=K$)#   Swap elements                    CP11 237
#                                                                       CP11 238
pt4:#                                                                   CP11 239
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP11 240
WRITE(6,*) "semi invariant moduli",NODR#                                CP11 241
WRITE(6,*) (MDSI(I),I=1,3)#                                             CP11 242
WRITE(6,*) "semi invariant vectors"#                                    CP11 243
WRITE(6,'(3F9.2)') ((SIVC(I,J),J=1,3),I=1,3)#                           CP11 244
WRITE(6,*)"UVW  100      010      110      001$#                        CP11 245
      101      011      111      000"#                                  CP11 246
WRITE(6,'(8F9.0)')(ACUM(J),J=1,8)#                                      CP11 247
WRITE(6,'(8I9)' )(CNT(J) ,J=1,8)#                                       CP11 248
WRITE(6,'(8I9)' )(GCNT(J),J=1,8)#                                       CP11 249
WRITE(6,'(8I9)' )(SRT(J),J=1,8)#                                        CP11 250
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP11 251
#                                                                       CP11 252
#  CALCULATE VALID DETERMINANTS                                         CP11 253
#  ----------------------------                                         CP11 254
#                                                                       CP11 255
ifeq:(ACUM(8),0.0)iquit:(CP1104)#      All general refs missing!        CP11 256
IF(MODC==2)#                           Space groups with moduli of 2    CP11 257
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP11 258
#                                                                       CP11 259
#  FOR ONE ODR  CHECK ONE UVW VECTOR -  100                             CP11 260
#  ----------------------------------------                             CP11 261
#                                                                       CP11 262
IF     (NODR==1)#                      1x1 determinant for u00=100      CP11 263
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP11 264
IF(ACUM(1)/ACUM(8)<0.1) SIABS(1)=1#    Issue a warning - >10% down      CP11 265
IF(CNT(1)==0\GCNT(1)==0)SIABS(1)=2#    No odr for u class               CP11 266
## for complete rule should combine with the laue class.                CP11 267
noodr:#                                                                 CP11 268
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP11 269
#                                                                       CP11 270
#  FOR TWO ODRS CHECK THREE UVW VECTORS  100, 110 AND 010               CP11 271
#  ------------------------------------------------------               CP11 272
#                                                                       CP11 273
ELSEIF(NODR==2)#                       Three 2x2 determinants to chec   CP11 274
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP11 275
L=0#                                                                    CP11 276
DO I=1,2#                              Loop for first row               CP11 277
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP11 278
K=SRT(I)#                                                               CP11 279
IF(CNT(K)==0\GCNT(K)==0)NEXT#          No odr in this class             CP11 280
M11=MOD(K,2);K=K/2;M12=MOD(K,2)#       Convert back to vectors          CP11 281
DO J=I+1,3#                            Loo for second row               CP11 282
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP11 283
K=SRT(J)#                              Local pointer                    CP11 284
IF(CNT(K)==0\GCNT(K)==0)NEXT#          No odr in this class             CP11 285
M21=MOD(K,2);K=K/2;M22=MOD(K,2)#       Convert back to vectors          CP11 286
DET=M11*M22-M12*M21#                   Calc determinant                 CP11 287
IF(ABS(DET)==1) L=L+1#                 Count valid odr sets             CP11 288
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP11 289
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP11 290
#                                                                       CP11 291
#  BUILD UP A PICTURE OF MISSING GENERATORS                             CP11 292
#  ----------------------------------------                             CP11 293
#                                                                       CP11 294
IF(L==0)#                              Not enuf odr's, but which clas   CP11 295
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP11 296
noodr:#                                                                 CP11 297
#                                                                       CP11 298
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP11 299
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP11 300
#                                                                       CP11 301
#  FOR THREE ODRS CHECK SEVEN UVW VECTORS  100,110,010,001,101,011,111  CP11 302
#  -------------------------------------------------------------------  CP11 303
#                                                                       CP11 304
ELSEIF(NODR==3)#                       35 determinants to check         CP11 305
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP11 306
DO H=1,5#                              Loop for first row               CP11 307
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CP11 308
K=SRT(H)#                                                               CP11 309
IF(CNT(K)==0\GCNT(K)==0)NEXT#          No odr in this class             CP11 310
M11=MOD(K,2);K=K/2;M12=MOD(K,2);K=K/2;M13=MOD(K,2)# Convert back to v   CP11 311
DO I=H+1,6#                            Loop for second row              CP11 312
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CP11 313
K=SRT(I)#                              Local pointer                    CP11 314
IF(CNT(K)==0\GCNT(K)==0)NEXT#          No odr in this class             CP11 315
M21=MOD(K,2);K=K/2;M22=MOD(K,2);K=K/2;M23=MOD(K,2)# Convert back to v   CP11 316
DO J=I+1,7#                            Loop for third row               CP11 317
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CP11 318
K=SRT(J)#                              Local pointer                    CP11 319
IF(CNT(K)==0\GCNT(K)==0)NEXT#          No odr in this class             CP11 320
M31=MOD(K,2);K=K/2;M32=MOD(K,2);K=K/2;M33=MOD(K,2)# Convert back to v   CP11 321
DET=M11*(M22*M33-M32*M23)-M12*(M21*M33-M31*M23)+M13*(M21*M32-M31*M22)#  CP11 322
IF(ABS(DET)==1) GOTO 100#              Found a determinant of +/-1      CP11 323
# OTHER NONZERO VALUES OF DET DEFINE THE ORIGIN TO WITHIN DET ALTERNATI CP11 324
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CP11 325
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CP11 326
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CP11 327
100 CONTINUE#                                                           CP11 328
IF(H>5)#                               No determinants of +/-1          CP11 329
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CP11 330
noodr:#                                                                 CP11 331
#                                                                       CP11 332
WRITE(6,*) ' The following parity groups are missing:'#                 CP11 333
# PARITY GROUPS                                                         CP11 334
# LOOK FOR 0  VALUES AND REPORT                                         CP11 335
DO I=1,7#                              Search possible odr combinatio   CP11 336
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CP11 337
IF(GCNT(I)!=0) NEXT#                                                    CP11 338
K=I#                                                                    CP11 339
IU(1)=MOD(K,2);K=K/2;IU(2)=MOD(K,2);K=K/2;IU(3)=MOD(K,2)# Vectorize     CP11 340
CHROT=' '#                                                              CP11 341
DO J=1,3#                              Loop over uvw elements           CP11 342
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CP11 343
L=10+(J-1)*20#                         Pointer to class                 CP11 344
DO K=1,3#                              Loop over semi invariant vectr   CP11 345
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CP11 346
M=NINT(SIVC(J,K))#                     Moduli *sivc                     CP11 347
IF(M==0)NEXT#                                                           CP11 348
IF(M<0)      $(CHROT(L^L)='-';L=L+1 $)#                                 CP11 349
IF(ABS(M)==2)$(CHROT(L^L)='2';L=L+1 $)#                                 CP11 350
CHROT(L^L)=GT2(21+K^21+K);L=L+1#                                        CP11 351
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CP11 352
IF(IU(J)==0)CHROT(L^L+2)=GT2(30^32)#                                    CP11 353
ELSE        CHROT(L^L+4)=GT2(30^34)#                                    CP11 354
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CP11 355
writeline:(0,0,0,1,3)#                 Dump chrot string                CP11 356
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CP11 357
#                                                                       CP11 358
#                                                                       CP11 359
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CP11 360
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP11 361
#          END OF MODC==1                                               CP11 362
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP11 363
#                                                                       CP11 364
ELSEIF(MODC==3) ;#                     Check odrs for mod(3,0)/mod(3,   CP11 365
ELSEIF(MODC==4) ;#                     Check odrs for mod(4)            CP11 366
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP11 367
#                                                                       CP11 368
#                                                                       CP11 369
IF((ISEL==0)&(NTYP(3)==0)) iquit:(CP1101)# No pq4......gt0270           CP11 370
IF((ISEL==2)&(NTYP(1)==0)) iquit:(CP1102)# No t3 ......gt0275           CP11 371
IF((ISEL<0)&(NTYP(1)==0)) ISEL=0#      No t3 so limit select flag       CP11 372
IF((ISEL<0)&(NTYP(3)==0)) ISEL=2#      No q4 so limit select flag       CP11 373
MARK8=BOT#                             End of inariant list             CP11 374
#                                                                       CP11 375
RETURN#                                                                 CP11 376
END#                                                                    CP11 377
systemheader:(CP12)#                   Calculate potential harkers      CP12   1
####################################################################    CP12   2
#                                                                  #    CP12   3
#                             CP12                                      CP12   4
#                                                                  #    CP12   5
####################################################################    CP12   6
SUBROUTINE CP12#                                                        CP12   7
include:(AACOMN)#                                                       CP12   8
include:(CPCOMN)#                                                       CP12   9
#                                                                       CP12  10
INTEGER I,J,L,K,M,N1,N,M1,H#                                            CP12  11
REAL TMP(12)#                                                           CP12  12
REAL SYM(12)#                                                           CP12  13
INTEGER STOPZ,STEPZ#                                                    CP12  14
chardata:(CP12A,'Potential single-heavy-atom Harker vectors')#          CP12  15
chardata:(CP12B,"  Vect  dup   (X  + Y  + Z  + sx )  $#                 CP12  16
(X  + Y  + Z  + sy )  (X  + Y  + Z  + sy ) ")# <<<3                     CP12  17
realdata:(FMT,[0513.,513.,503.,503.,503.,732.,503.,503.,503.,732.,$#    CP12  18
503.,503.,503.,732.])#                                                  CP12  19
datastuff:#                                                             CP12  20
#                                                                       CP12  21
MARKZ=MARK8;STOPZ=MARKZ;STEPZ=13#                                       CP12  22
#                                                                       CP12  23
FOR(I=MARKS;I<STOPS-STEPS;I=I+STEPS)#  First symop loop                 CP12  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP12  25
FOR(J=I+STEPS;J<STOPS;J=J+STEPS)#      Second symop loop                CP12  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP12  27
DO L=1,9;  TMP(L)=         QX(I+L)-QX(J+L)#                             CP12  28
DO L=10,12;TMP(L)=MOD(100.+QX(I+L)-QX(J+L),1.)#                         CP12  29
DO L=10,12;SYM(L)=TMP(L)#                                               CP12  30
#                                                                       CP12  31
FOR(K=MARKZ;K<STOPZ;K=K+STEPZ)#        For all previous harkers         CP12  32
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP12  33
FOR(M=STOPS;M<STOPS1;M=M+STEPS)#       Apply laue symops (no trans)     CP12  34
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP12  35
N1=1;DO N=1,3#                         Multiply temp by laue symop      CP12  36
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP12  37
M1=M;DO H=1,3#                                                          CP12  38
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP12  39
M1=M1+1#                                                                CP12  40
SYM(H+(N-1)*3)=TMP(N1)*QX(M1)+TMP(N1+1)*QX(M1+3)+TMP(N1+2)*QX(M1+6)#    CP12  41
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP12  42
N1=N1+3#                                                                CP12  43
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP12  44
#                                      Compare rotated with previous    CP12  45
DO L=1,12;ifne:(SYM(L),QX(K+L)) BREAK# Different vector                 CP12  46
IF(L<=12) NEXT#                        No match                         CP12  47
QX(K+13)=QX(K+13)+1.#                  Got a match so count             CP12  48
GOTO 100#                              Got a match look no further      CP12  49
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP12  50
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP12  51
100 CONTINUE#                                                           CP12  52
IF(K<STOPZ)NEXT#                       Got a match so no repeats        CP12  53
K=STOPZ#                               Not necessary                    CP12  54
incrqx:(STOPZ,K+STEPZ,CP1401)#         Get memory for next vector       CP12  55
DO L=1,12;QX(K+L)=TMP(L)#              Different vector                 CP12  56
QX(K+13)=1.0#                          Count occurences                 CP12  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP12  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP12  59
#                                                                       CP12  60
L=1#                                                                    CP12  61
IF((STOPZ-MARKZ)/STEPZ <=10\DMP>2)#    More than this will simply con   CP12  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP12  63
writeline:(1,CP12A,NCP12A,3,3)#        Header                           CP12  64
writeline:(0,CP12B,NCP12B,3,3)#        List header                      CP12  65
FOR(K=MARKZ;K<STOPZ;K=K+STEPZ)#                                         CP12  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP12  67
BUFOT(1)=FLOAT(L)#                     Count of vectors                 CP12  68
BUFOT(2)=QX(K+13)#                     Duplicates                       CP12  69
DO I=1,12;BUFOT(2+I)=QX(K+1+(I-1)/4+MOD(I-1,4)*3)# Get the symmetry e   CP12  70
ncodefld:(BUFOT,1,CHROT,FMT,14)#                                        CP12  71
writeline:(0,CP12B,NCP12B,1,3)#        Header                           CP12  72
L=L+1#                                                                  CP12  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP12  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP12  75
MARK8=STOPZ;STOP8=MARK8#               Step over this space             CP12  76
#                                                                       CP12  77
RETURN#                                                                 CP12  78
END#                                                                    CP12  79
systemheader:(CP14)#                   Sort s.i. from phase path        CP14   1
####################################################################    CP14   2
#                                                                  #    CP14   3
#                             CP14  (FORMERLY GT04)                     CP14   4
#                                                                  #    CP14   5
####################################################################    CP14   6
SUBROUTINE CP14#                       S.r.hall  jun 81                 CP14   7
include:(AACOMN)#                                                       CP14   8
include:(CPCOMN)#                                                       CP14   9
#                                                                       CP14  10
INTEGER I,J,K,L,M,N,IT,IL#             Gt0                              CP14  11
INTEGER NCON,TCON,GCON,MCON,NWGT#      Gt04                             CP14  12
INTEGER IA,LREC,MCUT,NBIAS,GN,NI,NN,NT,N1,N2,N3,N4#                     CP14  13
INTEGER TEST(4),BEST(4)#                                                CP14  14
INTEGER IN(4)#                                                          CP14  15
INTEGER M1#                                                             CP14  16
#                                                                       CP14  17
REAL A,B,NOSP,ODRP,QIQI,SETP#          Gt04                             CP14  18
#                                                                       CP14  19
chardata:(GT1,[  NSEQ  NGEN  CONGEN  CONINV  SUMWGT  (1)*(3)$#          CP14  20
   *** MAXEXT PHASE   ***])#                                            CP14  21
chardata:(GT2, **********MAXEXT DUMP IN MAXCON ORDER)#                  CP14  22
intdata:(ISGN,[0,1,2,3,4,5,6,7,0,2,1,3,4,6,5,7,0,4,2,6,1,5,3,7])#       CP14  23
intdata:(PRC,[45,180,30,45,60,90,120,135,150,180])#                     CP14  24
intdata:(MAGM,[0,1,2,3,5,8,13,21,34,55,89])#                            CP14  25
intdata:(MAGN,[1,4,12,20,32,50,80,128,206,332,536])#                    CP14  26
realdata:(FM,[50413.,110413.,190713.,270713.,350713.,440713.])#         CP14  27
intdata:(IS,0)#                                                         CP14  28
datastuff:#                                                             CP14  29
#                                                                       CP14  30
#   STORE PHASE PATH SEQUENCE & COUNT STARTERS                          CP14  31
#   ------------------------------------------                          CP14  32
#                                                                       CP14  33
M1=MARK6#                                                               CP14  34
#                                                                       CP14  35
NOSP=nos:+.5; ODRP=odr:+.5; SETP=set:+.5# Set nop & odr flags           CP14  36
FOR(GN=M1;GN<MQ;GN=GN+MARK)#           Loop over generator list         CP14  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP14  38
I=ipnt:#                               Extract phase path order         CP14  39
seq:(I)=FLOAT(GN)#                     Store path sequence              CP14  40
pnt:   =FLOAT(GN)#                     Reset to /e/ order               CP14  41
evl:   =ABS(evl:)#                     Reset start flag                 CP14  42
IF(sta:<NOSP) NEXT#                    Ignore non-starters              CP14  43
IF(sta:>SETP) IS=IS+1#                 Count suppressed reflns          CP14  44
ELSE evl:=-evl:#                       Flag start generators            CP14  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP14  46
#                                                                       CP14  47
#     COUNT PERMUTED PHASE SETS                                         CP14  48
#     -------------------------                                         CP14  49
#                                                                       CP14  50
NPST=1;   NMAG=1#                      Initialize phase set cnt         CP14  51
FOR(I=1;I<=NPER;I=I+1)#                Loop over permuted phases        CP14  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP14  53
J=PERN(I);    K=iseq:(J)#              Extract generator addr           CP14  54
PERN(I)=K#                             Restore in new order             CP14  55
IF((TYPE==2)&(PERI(I)<180)) NMAG=NMAG+1# If nonrestr & magic flag       CP14  56
ELSE IF(ista:(J)==iedr:)#              Test if edr permute              CP14  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP14  58
PERN(I)=-K#                            Flag as limited permute          CP14  59
NPST=NPST*LEDR/PERI(I)#                Calc permutes for edr            CP14  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP14  61
ELSE NPST=NPST*360/PERI(I)#            Calculate other permutes         CP14  62
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP14  63
NSEL=MIN0(NSEL,NGEN)#                  Ensure select < genlist          CP14  64
NCUT=M1+NSEL*MARK#                     Sel start phase maximum          CP14  65
MCUT=M1+NSEL*MARK/2#                   Set prelim cutoff                CP14  66
TCON=NINT(FLOAT(NSEL)*.75)#            Calc start connect limit         CP14  67
NSEL=NSEL-IS#                          Allow for suppressed gens        CP14  68
IF(INPH==0) NLIM=M1+NSTR*MARK#         Set addr of highest starter      CP14  69
ELSE        NLIM=NCUT#                 Set limit if phis input          CP14  70
#                                                                       CP14  71
#   REORDER GENERATOR LIST IN PHASE PATH ORDER                          CP14  72
#   ------------------------------------------                          CP14  73
#                                                                       CP14  74
IS=QXSTR#                              Use buff for sort swap           CP14  75
FOR(N1=M1;N1<MQ;N1=N1+MARK)#           Loop over generator list         CP14  76
FOR(GN=N1;GN<MQ;GN=GN+MARK)#           Loop over generator list         CP14  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP14  78
IF(iseq:!=N1) NEXT#                                                     CP14  79
movereal:(QX,GN+1,QX,IS+1,MARK,1)#     Swap selected gen to buffer      CP14  80
movereal:(QX,N1+1,QX,GN+1,MARK,1)#     Swap running  gen to slot        CP14  81
movereal:(QX,IS+1,QX,N1+1,MARK,1)#     Swap selected gen to top         CP14  82
BREAK#                                 Exit after transfer of gen       CP14  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP14  84
FOR(GN=M1;GN<MQ;GN=GN+MARK)#           Loop over genlist                CP14  85
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP14  86
I=ipnt:;   seq:(I)=FLOAT(GN)#          Point to original order          CP14  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP14  88
#                                                                       CP14  89
#   ACCESS SI DATA, SORT AND OUTPUT                                     CP14  90
#   -------------------------------                                     CP14  91
#                                                                       CP14  92
#                                                                       CP14  93
SUMR=0.;   NBIAS=MG-M1+1#              Zero sum random alpha            CP14  94
#                                                                       CP14  95
FOR(GN=M1;GN<MG;GN=GN+MARK)#           Loop ordered gen list            CP14  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP14  97
TOP=itop:;   BOT=ibot:#                Get top/bot of si block          CP14  98
B=0.#                                  Zero random alpha term           CP14  99
#                                                                       CP14 100
FOR(M=TOP;M<BOT;M=M+4)#                Loop over invariant block        CP14 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP14 102
IN(2)=NINT(QX(M+2))#                   Extract in(2) genlist addres     CP14 103
IN(3)=NINT(QX(M+3))#                   Extract in(3) genlist addres     CP14 104
IN(4)=NINT(QX(M+4))#                   Extract in(4) genlist addres     CP14 105
intunpak:(QX(M+1),IT, 0, 2)#           Extract invariant type           CP14 106
intunpak:(QX(M+1),IS, 2, 3)#           Extract phi sign code            CP14 107
IF(IT<posq:) L=3;   ELSE L=4#          Set order of invariant           CP14 108
DO I=2,L#                              Loop over si generators          CP14 109
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP14 110
J=IN(I);  IN(I)=iseq:(J)#              Replace with new sort order      CP14 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP14 112
IF(IT==negq:) IN(2)=IN(2)+NBIAS#       For neq q4 bias n2 addr          CP14 113
J=MAX0(IN(2),IN(3),IN(4))#             Find largest address             CP14 114
DO I=2,L#                              Loop over last generators        CP14 115
IF(IN(I)==J) BREAK#                    Find which is largest            CP14 116
IN(I)=IN(2);  IN(2)=J#                 Swap gein(2) with largest        CP14 117
IS=IS+I*8-15;  IS=ISGN(IS)#            Adjust phi sign codes            CP14 118
intpak:(IS,QX(M+1), 2, 3)#             Pack sign code  bits  4- 2       CP14 119
QX(M+2)=FLOAT(IN(2))#                  Store reordered n2               CP14 120
QX(M+3)=FLOAT(IN(3))#                  Store reordered n3               CP14 121
QX(M+4)=FLOAT(IN(4))#                  Store reordered n4               CP14 122
#                                                                       CP14 123
IF(IT==negq:) NEXT#                    Skip negative quartets           CP14 124
intunpak:(QX(M+1),IA,25,7)#            Extract a *8 of si               CP14 125
B=B+FLOAT(IA)**2#                      Sum a**2 *64                     CP14 126
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP14 127
#                                                                       CP14 128
IF(GN<MQ) SUMR=SUMR+SQRT(B)/8.#        If not psi0 sum random al        CP14 129
#                                                                       CP14 130
#                                       ******** sort si block incr n2  CP14 131
FOR(M=TOP+2;M<BOT;M=M+4)#              Loop over invariant block        CP14 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP14 133
A=QX(M);               I=M#            Reset sort value/pointer         CP14 134
FOR(L=M+4;L<BOT;L=L+4)#                Loop over reduced si block       CP14 135
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP14 136
IF(QX(L)>=A) NEXT#                     Find smallest n2                 CP14 137
A=QX(L);               I=L#            Store smaller & pointer          CP14 138
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP14 139
movepakwd:(QX(M-1),A)#                 Store packed word                CP14 140
movepakwd:(QX(I-1),QX(M-1))#           Store packed word                CP14 141
movepakwd:(A,QX(I-1))#                 Store packed word                CP14 142
swap:(QX(M  ),QX(I  ))#                Swap invariant n2                CP14 143
swap:(QX(M+1),QX(I+1))#                Swap invariant n3                CP14 144
swap:(QX(M+2),QX(I+2))#                Swap invariant n4                CP14 145
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP14 146
#                                                                       CP14 147
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP14 148
#                                                                       CP14 149
#                                                                       CP14 150
#   LOOP OVER REQUIRED STARTERS                                         CP14 151
#   ===========================                                         CP14 152
#                                                                       CP14 153
NSTR=0#                                Reset number of starters         CP14 154
IF(INPH==0&TYPE>0)#                    If phases to be selected         CP14 155
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP14 156
pt6:  writeline:(1,GT2,NGT2,3,3)#      Print dump header                CP14 157
#                                                                       CP14 158
REPEAT#                                Loop over selected per phis      CP14 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP14 160
DO I=1,4;   BEST(I)=0#                 Initialize test storage          CP14 161
ncodefld:(FLOAT(NSTR+1),1,GT1,660213.,1)# Insert maxext number          CP14 162
pt6:  writeline:(1,GT1,NGT1,3,3)#      Force new header                 CP14 163
NN=0#                                  Zero generator counter           CP14 164
#                                                                       CP14 165
#                                        ****** select test starters    CP14 166
FOR(NT=M1;NT<NCUT;NT=NT+MARK)#         Loop over genlist                CP14 167
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP14 168
NN=NN+1#                               Count generators                 CP14 169
IF(sta:(NT)>NOSP) NEXT#                Skip assigned starters           CP14 170
evl:(NT)=-evl:(NT)#                    Set as trial starter             CP14 171
N1=0; GCON=0; NCON=0; NWGT=0; LREC=0#  Reset start parameters           CP14 172
#                                                                       CP14 173
#                                        ******* find start connects    CP14 174
FOR(GN=M1;GN<NCUT;GN=GN+MARK)#         Loop genlist to nsel             CP14 175
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP14 176
N1=N1+1#                               Count generator number           CP14 177
TOP=itop:;    BOT=ibot:#               Get si block limits              CP14 178
IF(sta:>SETP) NEXT#                    Skip suppressed gens             CP14 179
MCON=0#                                Reset gen connect counter        CP14 180
FOR(NI=TOP;NI<BOT;NI=NI+4)#            Loop over invariant block        CP14 181
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP14 182
intunpak:(QX(NI+1),IT, 0, 2)#          Extract invariant type           CP14 183
IF(IT==negq:) BREAK#                   Exit block if neq quartet        CP14 184
IF(IT==ISEL) NEXT#                     Use s.i. allowed for test        CP14 185
N2=NINT(QX(NI+2))#                     Extract n2 generator address     CP14 186
IF(N2>NCUT) BREAK#                     Exit if beyond test limit        CP14 187
IF(evl:(N2)>0.) NEXT#                  Skip if n2 gen not connected     CP14 188
N3=NINT(QX(NI+3))#                     Extract n3 generator address     CP14 189
IF(evl:(N3)>0.) NEXT#                  Skip if n3 gen unconnected       CP14 190
IF(IT!=trip:)#                         For quartet invariants           CP14 191
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP14 192
N4=NINT(QX(NI+4))#                     Extract n4 generator address     CP14 193
IF(evl:(N4)>0.) NEXT#                  Skip if n4 gen unconnected       CP14 194
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP14 195
MCON=MCON+1#                           Sum number of connects           CP14 196
IF(NTES==1) BREAK#                     Exit if gen count only           CP14 197
IF(NTES==2) NEXT#                      Skip weights if inv count        CP14 198
intunpak:(QX(NI+1),IS,25, 7)#          Extract a*8 from s.i.            CP14 199
NWGT=NWGT+IS#                          Sum w*alpha of s.i.              CP14 200
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP14 201
#                                                                       CP14 202
IF(MCON==0) NEXT#                      Ignore phi if no connects        CP14 203
IF(sta:<NOSP) evl:=-ABS(evl:)#         Flag gen as temp starter         CP14 204
GCON=GCON+1#                           Count connected generators       CP14 205
NCON=NCON+MCON#                        Count total connects             CP14 206
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP14 207
TEST(1)=GCON;       TEST(2)=NCON#      Store gen & total connects       CP14 208
TEST(3)=NWGT;       TEST(4)=NWGT*GCON# Store w*alpha & product          CP14 209
IF(TEST(NTES)>BEST(NTES))#             Apply specified start test       CP14 210
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP14 211
DO I=1,4;  BEST(I)=TEST(I)#            Transfer test results            CP14 212
IL=NT#                                 Store generator address          CP14 213
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP14 214
IF((NT>MCUT)&(BEST(1)>TCON)) BREAK#    If prelim test ok exit           CP14 215
#                                                                       CP14 216
#                                       *******reset temp start phis    CP14 217
FOR(GN=M1;GN<NCUT;GN=GN+MARK)#         Loop genlist to first cutoff     CP14 218
IF(sta:<NOSP) evl:=ABS(evl:)#          Reset trial start flags          CP14 219
#                                                                       CP14 220
pt4:#                                                                   CP14 221
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP14 222
BUFOT(1)=FLOAT(NN)#                    Store sequence number            CP14 223
BUFOT(2)=FLOAT((ipnt:(NT)-M1)/MARK+1)# Store generator number           CP14 224
DO I=1,4; BUFOT(I+2)=FLOAT(TEST(I))#   Float test values                CP14 225
IF(IL==NT) movechar:(GT1,49,CHROT,46,3,0)# Insert *** if top            CP14 226
ncodefld:(BUFOT,1,CHROT,FM,6)#         Format op items                  CP14 227
writeline:(0,GT1,NGT1,1,3)#            Print maxext dump                CP14 228
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP14 229
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP14 230
#                                                                       CP14 231
#    ASSIGN NEW STARTING PHASE IF FOUND                                 CP14 232
#    ----------------------------------                                 CP14 233
#                                                                       CP14 234
IF((BEST(NTES)==0)\(NPER+1>10)) BREAK# Exit if no start or limit        CP14 235
NPER=NPER+1#                           Count new permute phase          CP14 236
NSTR=NSTR+1#                           Count new starting phase         CP14 237
sta:(IL)=per:#                         Flag generator as permute        CP14 238
evl:(IL)=-evl:(IL)#                    Flag as assigned start           CP14 239
NLIM=MAX0(NLIM,IL)#                    Set addr of highest starter      CP14 240
#                                                                       CP14 241
#                                                                       CP14 242
I=iprc:(IL)#                           Extract phi restriction          CP14 243
J=MIN0(2,I)#                           Resolve restr/norestr            CP14 244
PERN(NPER)=IL#                         Store addr of permute gen        CP14 245
PERI(NPER)=PERS(J)#                    Set permute pers from restr      CP14 246
intunpak:(pak:(IL),N,0,9)#             Extract refined phase            CP14 247
IF(N==0)#                              If no refined phase              CP14 248
intpak:(PRC(I),pak:(IL), 0, 9)#        Store start phase                CP14 249
intpak:(FIX(4),pak:(IL), 9, 6)#        Store iteration fix              CP14 250
intpak:(NPER  ,pak:(IL),15, 4)#        Store permute pointer            CP14 251
intpak:(4     ,pak:(IL),19, 3)#        Store assign mode                CP14 252
intpak:(16    ,pak:(IL),25,bitlen:(25))# Store weight (=1.*16)          CP14 253
IF((TYPE==2)&(I==1)) NMAG=NMAG+1#      If nonrestr & magic flag         CP14 254
ELSE NPST=NPST*360/PERS(J)#            Calc num permute phase set       CP14 255
IF(NPST*MAGN(NMAG)>=MXPS) BREAK#       Exit if set limit reached        CP14 256
IF(NSTR<MSEL) NEXT#                    Force new start if requested     CP14 257
IF(BEST(1)>=NSEL) BREAK#               Exit if selects connect          CP14 258
IF(BEST(1)>TCON) BREAK#                Exit if connects enough          CP14 259
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP14 260
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP14 261
#                                                                       CP14 262
#                                                                       CP14 263
pt5:#                                                                   CP14 264
WRITE(6,*) "address of highest starter ",NLIM,IL,M1,BEST(1),NMAG,TYPE#  CP14 265
#                                                                       CP14 266
#                                                                       CP14 267
#                                                                       CP14 268
#                                                                       CP14 269
NSTR=BEST(1)#                          Store max connects for gt05      CP14 270
M=1;  N=2*MAGM(NMAG)#                  Set count & last magic int       CP14 271
IF(NMAG>1)#                            Test if any magic integers       CP14 272
FOR(I=1;I<=NPER;I=I+1)#                Loop over permutes               CP14 273
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP14 274
IF((TYPE<2)\(PERI(I)>179)) NEXT#       Test if restr or perm phi        CP14 275
M=M+1#                                 Count magic integers             CP14 276
PERI(I)=-(N-MAGM(M))#                  Store magic integer              CP14 277
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP14 278
NMAG=MAGN(NMAG);   M=1#                Store magic permutes             CP14 279
NPST=NPST*NMAG#                        Total permutes                   CP14 280
IF(TYPE==0) NPST=MAX0(NPST,MXPS)#      Set max phi sets if random       CP14 281
pt6:  writeline:(1,GT2,NGT2,3,3)#      Print dump header                CP14 282
#                                                                       CP14 283
RETURN#                                                                 CP14 284
END#                                                                    CP14 285
systemheader:(CP15)#                   List control/start/refine        CP15   1
####################################################################    CP15   2
#                                                                  #    CP15   3
#                             CP15     (FORMERLY GT05)             #    CP15   4
#                                                                  #    CP15   5
####################################################################    CP15   6
SUBROUTINE CP15#                       S.r.hall  jun 81                 CP15   7
include:(AACOMN)#                                                       CP15   8
include:(CPCOMN)#                                                       CP15   9
#                                                                       CP15  10
INTEGER I,K,L,M,N,IP,IX,GN#                                             CP15  11
REAL A,B,C,D#                                                           CP15  12
INTEGER M1#                                                             CP15  13
#                                                                       CP15  14
chardata:(CP3,' Total random phase sets generated              ')#      CP15  15
chardata:(CP4,' Highest FOM phase sets retained                ')#      CP15  16
chardata:(CP66,' 1. Direct methods phasing')#                           CP15  17
chardata:(GT2,' Process bdf data set number      ')#                    CP15  18
chardata:(GT3,' Generator |E|-type |E|-min           E           ')#    CP15  19
chardata:(GT4,' Number of generators to phase                  ')#      CP15  20
chardata:(GT5,' Fragment psi to be applied                     ')#      CP15  21
chardata:(GT6,' Number of triplets entered              AMIN=      ')#  CP15  22
chardata:(GT7,' Number of quartets entered              BMIN=      ')#  CP15  23
chardata:(GT8,' Positive quartets (PQ4)                 XVSM>      ')#  CP15  24
chardata:(GT9,' Negative quartets (NQ4)                 XVSM<      ')#  CP15  25
chardata:(GT10,[ NQ4 USED ONLY IN FOM, PSI=         ])#                 CP15  26
chardata:(GT11,NO YES-T3 + PQ4PQ4 ONLYT3 ONLY )#                        CP15  27
chardata:(GT12, REDUCE A AND B VALUES BY          SIGMA)#               CP15  28
chardata:(GT13, MAX ALLOWED TRIPLETS/GENER        )#                    CP15  29
chardata:(GT14, MAX ALLOWED QUARTETS/GENER        )#                    CP15  30
chardata:(GT20, STARTING PHASE INFORMATION)#                            CP15  31
chardata:(GT21, INVARIANTS USED IN SELECTION             )#             CP15  32
chardata:(GT22, NR180 30 45 60 90120135150180)#                         CP15  33
chardata:(GT23,ODREDRPERSETNUL)#                                        CP15  34
chardata:(GT24,LINEINBDF FCBDF GTMAXCONMAXEXT)#                         CP15  35
chardata:(GT25, SELECTION OF MAXEXT BASED ON            )#              CP15  36
chardata:(GT26,MAX GENSMAX INVSW*ALPCP MXG*W*AL)#                       CP15  37
chardata:(GT27,  NGEN   H   K   L   |E|  PHI RESTR  TYPE   $#           CP15  38
WGT  FIX   ASSIGNED  PERMUTE)#                                          CP15  39
chardata:(GT28,[ ** BDF PHASE ENTERED IF |E| >        ])# C             CP15  40
chardata:(GT29, START SET CONNECTS     OF TOP     SORTED GEN$#          CP15  41
ERATORS IN FIRST PASS)#                                                 CP15  42
chardata:(GT30, MAX PHASE SETS TO BE TESTED         )#                  CP15  43
chardata:(GT31,[ ACCEPT PHASE IF AL**2 MAX >           ])#              CP15  44
chardata:(GT32, REDUCE AL**2 MAX AT RATE OF           )#                CP15  45
chardata:(GT40, PHASE REFINEMENT PARAMETERS)#                           CP15  46
chardata:(GT41, FIX PHASE WHEN BLOCK REFINED  NO)# C                    CP15  47
chardata:(GT42,[ TERMINATE IF AL**2 SHIFT <        %])#                 CP15  48
chardata:(GT43,[ PHASE ACCEPTED IF WEIGHT >          ])#                CP15  49
chardata:(GT44, MAXIMUM REFINEMENT CYCLES          )#                   CP15  50
chardata:(GT45, TANGENT PHASING PROCEDURE              )#               CP15  51
chardata:(GT45A, START PHASING PROCEDURE                )#              CP15  52
chardata:(GT46,CASCADEBLOCK  RANDOM )#                                  CP15  53
chardata:(GT46A,RANDOM PERMUTEMAGIC  )#                                 CP15  54
chardata:(GT47, TANGENT WEIGHTING SCHEME       W     )#                 CP15  55
chardata:(GT48,[ EXPECTATION VALUE FORCED >             ])#             CP15  56
chardata:(GT49, START WEIGHT OF RANDOM PHASE          )# C              CP15  57
chardata:(GT50,[ NUMBER OF PSI(0) TRIPLETS          ])#                 CP15  58
chardata:(GT51, FIGURE OF MERIT PARAMETERS)#                            CP15  59
chardata:(GT52, OPTIMAL      AND AMOS WEIGHT)#                          CP15  60
chardata:(GT53,RFOMRFACPSI0NEGQ)#                                       CP15  61
chardata:(GT54,[ EXPECTED AVERAGE PHI (APHI)         ])#                CP15  62
realdata:(FMT,[100413.,140413.,180413.,240522.,290313.,#                CP15  63
470512.,520503.,700303.,50413.])#                                       CP15  64
realdata:(FM2,[720512.,770313.])#                                       CP15  65
realdata:(AVPH,[180.,90.,120.,135.,150.,180.,210.,225.,240.,90.])#      CP15  66
datastuff:#                                                             CP15  67
#                                                                       CP15  68
M1=MARK6#                                                               CP15  69
#                                                                       CP15  70
#   PRINT CONTROL PARAMETERS                                            CP15  71
#   ------------------------                                            CP15  72
#                                                                       CP15  73
CHROT=' '#                             Blank the string                 CP15  74
movechar:(GT3,15,CHROT,2,NCP66-1,1)#   Underline heading in buffer      CP15  75
pt0: writeline:(1,CP66,NCP66,2,3)#     Print parameter heading          CP15  76
ncodefld:(FLOAT(MXPS),1,CP3,400613.,1)#                                 CP15  77
pt0: writeline:(1,CP3,NCP3,3,3)#       Print total phase sets           CP15  78
ncodefld:(FLOAT(MXPHST),1,CP4,400613.,1)#                               CP15  79
pt0: writeline:(0,CP4,NCP4,3,3)#       Print detailed phase set studi   CP15  80
movechar:(GT46A,TYPE*7+1,GT45A,33,7,0)# How are phases started          CP15  81
pt2: writeline:(0,GT45A,NGT45A,3,3)#   Print method of start            CP15  82
movechar:(GT46,MODE*7-6,GT45,33,7,0)#  Insert phase extension mode      CP15  83
pt2: writeline:(0,GT45,NGT45,3,3)#     Print calculation mode           CP15  84
ncodefld:(FLOAT(IWGT),1,GT47,340113.,1)# Format weight type             CP15  85
pt2: writeline:(0,GT47,NGT47,3,3)#     Print weight type                CP15  86
ncodefld:(FLOAT(DSNM),1,GT2,340413.,1)# Format data set number          CP15  87
pt2: writeline:(0,GT2,NGT2,3,3)#       Print data set number            CP15  88
ncodefld:(FLOAT(ETYP),1,GT3,400113.,1)# Format /e/-type                 CP15  89
ncodefld:(EMIN,1,GT3,500522.,1)#       Format /e/-min of geners         CP15  90
pt0: writeline:(0,GT3,NGT3,3,3)#       Print /e/-type and minim         CP15  91
ncodefld:(FLOAT(NGEN),1,GT4,400413.,1)# Format number of geners         CP15  92
pt0: writeline:(0,GT4,NGT4,3,3)#       Print number of generators       CP15  93
ncodefld:(SIGA,1,GT12,400432.,1)#      Format sigma reduce ratio        CP15  94
pt2: writeline:(0,GT12,NGT12,3,3)#     Print it                         CP15  95
IF(mine:>.01)#                         Test min expect in force         CP15  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP15  97
ncodefld:(mine:,1,GT48,340422.,1)#     Format min expect value          CP15  98
pt2: writeline:(0,GT48,NGT48,3,3)#     Print i1/i0 application          CP15  99
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP15 100
movechar:(GT11,IQPS*3+1,GT5,33,3,0)#   Insert yes/no for frag psi       CP15 101
pt2: writeline:(0,GT5,NGT5,3,3)#       Print frag psi information       CP15 102
IF(NTYP(1)>0)#                         Test if triplets applied         CP15 103
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP15 104
ncodefld:(MXTG,1,GT13,340413.,1)#      Format max triplets/gen          CP15 105
pt2: writeline:(0,GT13,NGT13,3,3)#     Print max t3/gen                 CP15 106
A=FLOAT(NTYP(1))#                      Float number of triplets         CP15 107
ncodefld:(A      ,1,GT6,400413.,1)#    Format number of triplets        CP15 108
ncodefld:(AMIN(1),1,GT6,500412.,1)#    Format a-min of triplets         CP15 109
pt0: writeline:(0,GT6,NGT6,3,3)#       Print triplet information        CP15 110
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP15 111
A=FLOAT(NTYP(3)+NTYP(4))#              Float number nq4 & pq4           CP15 112
IF(A>.1)#                              Test if any quartets             CP15 113
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP15 114
ncodefld:(MXQG,1,GT14,340413.,1)#      Format max quartets/gen          CP15 115
pt2: writeline:(0,GT14,NGT14,3,3)#     Print max pq/gen                 CP15 116
ncodefld:(A      ,1,GT7,340413.,1)#    Format number of quartets        CP15 117
ncodefld:(AMIN(2),1,GT7,460412.,1)#    Format b-min of quartets         CP15 118
pt2: writeline:(0,GT7,NGT7,3,3)#       Print quartet information        CP15 119
IF(IXVF<5)#                            Unless negq4 active              CP15 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP15 121
IF(NTYP(3)>0)#                         Test for positive quartets       CP15 122
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP15 123
A=FLOAT(NTYP(3))#                      Float number pq4                 CP15 124
ncodefld:(A     ,1,GT8,400413.,1)#     Format numb of pos quartets      CP15 125
ncodefld:(XSHI  ,1,GT8,500412.,1)#     Format upper xvector limit       CP15 126
pt0: writeline:(0,GT8,NGT8,3,3)#       Print pos quartet info           CP15 127
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP15 128
IF(NTYP(4)>0)#                         Test for negative quartets       CP15 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP15 130
A=FLOAT(NTYP(4))#                      Float number nq4                 CP15 131
ncodefld:(A      ,1,GT9,400413.,1)#    Format num of neg quartets       CP15 132
ncodefld:(XSLO   ,1,GT9,500412.,1)#    Format lower xvector limit       CP15 133
pt0: writeline:(0,GT9,NGT9,3,3)#       Print neg quartet info           CP15 134
ncodefld:(FLOAT(NQPS),1,GT10,340413.,1)# Format si used for neg q4      CP15 135
pt2: writeline:(0,GT10,NGT10,3,3)#     Print neg q4 psi info            CP15 136
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP15 137
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP15 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP15 139
#                                                                       CP15 140
#    PRINT STARTING PHASE DATA                                          CP15 141
#    -------------------------                                          CP15 142
#                                                                       CP15 143
movechar:(GT11,7,CHROT,2,NGT20-1,1)#   Insert underline in buffer       CP15 144
pt2: writeline:(1,GT20,NGT20,2,3)#     Print start phase heading        CP15 145
movechar:(GT11,ISEL*4+16,GT21,34,8,0)# Get string for si selection      CP15 146
pt2: writeline:(0,GT21,NGT21,3,3)#     Print si selection info          CP15 147
movechar:(GT26,NTES*8-7,GT25,34,8,0)#  Get string for start test        CP15 148
IF(INPH==0&TYPE>0)#                    If start phases selected         CP15 149
pt2: writeline:(0,GT25,NGT25,3,3)#     Print start test used            CP15 150
IF(INPH>0)#                            Test if phases from bdf          CP15 151
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP15 152
movechar:(GT24,INPH*6+5,GT28,2,2,0)#   Insert bdf type (fc or gt)       CP15 153
ncodefld:(EPAR,1,GT28,360622.,1)#      Format bdf e minimum             CP15 154
pt2: writeline:(0,GT28,NGT28,3,3)#     Print bdf phase data             CP15 155
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP15 156
#                                                                       CP15 157
LINRM=3#                               Print starters heading !!        CP15 158
B=0.;   C=0.;     D=0.#                Zero sum /e/ & start count       CP15 159
FOR(GN=M1;GN<MQ;GN=GN+MARK)#           Loop over generator list         CP15 160
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP15 161
N=ista:;  evl:=ABS(evl:)#              Get phase status                 CP15 162
I=iprc:;  C=C+AVPH(I)#                 Sum expected average phi         CP15 163
IF(N==inos:) NEXT#                     Skip all but starters            CP15 164
IF(N<inul:)#                           If starting phase                CP15 165
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP15 166
B=B+evl:;    D=D+1.#                   Sum /e/s and count               CP15 167
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP15 168
intunpak:(pak:,IP, 0, 9)#              Get start phase                  CP15 169
intunpak:(pak:,IX, 9, 6)#              Get iteration fix                CP15 170
intunpak:(pak:,M ,15, 4)#              Get permute pointer              CP15 171
intunpak:(pak:,L ,19, 3)#              Get assign mode                  CP15 172
intunpak:(pak:,K ,25, 7)#              Get start weight*16              CP15 173
intpak:(N,pak:,22, 3)#                 Put status in start word         CP15 174
IF(M>0) M=PERI(M)#                     Get permute increment            CP15 175
gethkl:(GN+1,BUFOT)#                   Extract generator h,k,l          CP15 176
BUFOT(4)=evl:#                         Put /e/-value in buffer          CP15 177
BUFOT(5)=FLOAT(MOD(IP,360))#           Put starting phi in buffer       CP15 178
BUFOT(6)=FLOAT(K)/16.#                 Put start weight in buffer       CP15 179
BUFOT(7)=FLOAT(IX)#                    Put fix iteration in buffer      CP15 180
BUFOT(8)=FLOAT(IABS(M))#               Put permute incr in buffer       CP15 181
BUFOT(9)=FLOAT((ipnt:-M1)/MARK+1)#     Put genlist no. in buffer        CP15 182
ncodefld:(BUFOT,1,CHROT,FMT,9)#        Format output fields             CP15 183
IF(M<0)#                               If magic permute                 CP15 184
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP15 185
BUFOT(1)=360./MAX(FLOAT(NMAG),1.0)#    Store magic delx                 CP15 186
BUFOT(2)=-FLOAT(M)#                    Store magic integer              CP15 187
movechar:(GT28,2,CHROT,74,1,0)#        Insert * character               CP15 188
ncodefld:(BUFOT,1,CHROT,FM2,2)#        Format magic values              CP15 189
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP15 190
movechar:(GT22,iprc:*3-2,CHROT,32,3,0)# Move restr alpha to buffer      CP15 191
movechar:(GT23,N*3-5,CHROT,39,3,0)#    Move start status to buffer      CP15 192
movechar:(GT24,L*6+1,CHROT,57,6,0)#    Move assign mode to buffer       CP15 193
pt2: writeline:(0,GT27,NGT27,1,3)#     Print starting phase info        CP15 194
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP15 195
#                                                                       CP15 196
#                                                                       CP15 197
XSLO=C/FLOAT(NGEN)#                    Calc expected av phase           CP15 198
#                                                                       CP15 199
XSHI=1.#                               Set ratio for fom test           CP15 200
IF(INPH==0&TYPE>0)#                    If phases not from bdf           CP15 201
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP15 202
ncodefld:(FLOAT(NSTR),1,GT29,230413.,1)# Format max connects            CP15 203
ncodefld:(FLOAT(NSEL),1,GT29,340413.,1)# Format selection number        CP15 204
pt2: writeline:(1,GT29,NGT29,3,3)#     Print expected connectivity      CP15 205
IF(NSTR<1) iquit:(CP1501)#             Insufficient start reflns        CP15 206
XSHI=FLOAT(NSEL)/FLOAT(NSTR)#          Ratio for pre fom tests          CP15 207
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP15 208
IF(TYPE==0)#                           Test if random starters          CP15 209
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP15 210
ncodefld:(RWGT,1,GT49,340522.,1)#      Format ran start weight          CP15 211
pt2: writeline:(0,GT49,NGT49,3,3)#     Print random weight              CP15 212
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP15 213
#NCODEFLD:(FLOAT(NPST),1,GT30,340413.,1)# FORMAT NUMBER PHASE SETS      CP15 214
#WRITELINE:(0,GT30,NGT30,3,3)#          PRINT NUMBER PHASE SETS         CP15 215
#                                                                       CP15 216
#   PRINT REFINEMENT PARAMETERS                                         CP15 217
#   ---------------------------                                         CP15 218
#                                                                       CP15 219
movechar:(GT11,7,CHROT,2,NGT40-1,1)#   Underline header                 CP15 220
pt2: writeline:(1,GT40,NGT40,2,3)#     Print refinement heading         CP15 221
movechar:(GT11,1,GT41,32,3,0)#                                          CP15 222
IF(IACC>0)movechar:(GT11,4,GT41,32,3,0)# Insert 'yes' in message        CP15 223
pt2: writeline:(0,GT41,NGT41,3,3)#     Print phase fix message          CP15 224
#                                                                       CP15 225
ncodefld:(FLOAT(MXIT),1,GT44,340313.,1)# Format maximum iterations      CP15 226
pt2: writeline:(0,GT44,NGT44,3,3)#     Print maximum iterations         CP15 227
ifeq:(A2MX,0.)#                        Test if alpha**2 is defined      CP15 228
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP15 229
A2MX=PFAC*(B/AMAX1(D,1.0))**3#         Calc alpha start max             CP15 230
IF(NTYP(1)==0) A2MX=A2MX*PFAC*B/AMAX1(D,1.)# Adjust if quartets only    CP15 231
A2MX=AMIN1(25.,A2MX**2)#               Calc alpha**2 starting max       CP15 232
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP15 233
ncodefld:(A2MX,1,GT31,340622.,1)#      Format alpha**2 start max        CP15 234
pt2: writeline:(0,GT31,NGT31,3,3)#     Print alpha**2 start max         CP15 235
ncodefld:(RATE,1,GT32,340422.,1)#      Format al**2 reduct rate         CP15 236
pt2: writeline:(0,GT32,NGT32,3,3)#     Print al**2 reduct rate          CP15 237
ncodefld:(CONV*100.,1,GT42,340313.,1)# Format convergence limit         CP15 238
pt2: writeline:(0,GT42,NGT42,3,3)#     Print convergence limit          CP15 239
ncodefld:(WMIN,1,GT43,340422.,1)#      Format min accept weight         CP15 240
pt2: writeline:(0,GT43,NGT43,3,3)#     Print phi accept limit           CP15 241
#                                                                       CP15 242
#   PRINT FOM PARAMETERS                                                CP15 243
#   --------------------                                                CP15 244
#                                                                       CP15 245
movechar:(GT11,7,CHROT,2,NGT51-1,1)#   Insert underline in head         CP15 246
pt2: writeline:(1,GT51,NGT51,2,3)#     Print fom header                 CP15 247
A=FLOAT(NTYP(2))#                      Float number of psi0 t3          CP15 248
WFOM(3)=WFOM(3)*AMIN1(A,100.)/100.#    Scale psi0 fom w to count        CP15 249
B=FLOAT(NTYP(4))#                      Float number of neg q4           CP15 250
WFOM(4)=WFOM(4)*AMIN1(B,100.)/100.#    Scale negq fom w ro count        CP15 251
ncodefld:(A,1,GT50,340413.,1)#         Format number psi0 t3            CP15 252
pt2: writeline:(0,GT50,NGT50,3,3)#     Print number psi0 t3             CP15 253
#                                                                       CP15 254
DO I=1,4#                              Loop over fom types              CP15 255
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP15 256
IF(I!=2) FREJ(I)=2.*FOPT(I)#           Set fom rejection limits         CP15 257
ELSE     FREJ(2)=1.0#                  Set rfac rej limit               CP15 258
movechar:(GT52,1,CHROT,1,NGT52,0)#     Put header in buffer             CP15 259
movechar:(GT53,I*4-3,CHROT,10,4,0)#    Put fom type in header           CP15 260
ncodefld:(FOPT,I,CHROT,360422.,1)#     Format fom optimum value         CP15 261
ncodefld:(WFOM,I,CHROT,420422.,1)#     Format fom weight                CP15 262
pt2: writeline:(0,0,0,1,3)#            Print fom weight                 CP15 263
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP15 264
ncodefld:(XSLO,1,GT54,360413.,1)#      Format average phi value         CP15 265
pt2: writeline:(0,GT54,NGT54,3,3)#     Print average phi value          CP15 266
#                                                                       CP15 267
#                                                                       CP15 268
DO I=1,10;  PERM(I)=0#                 Zero permutation array           CP15 269
SUMX=1000.#                                                             CP15 270
#                                                                       CP15 271
#                                                                       CP15 272
RETURN#                                                                 CP15 273
END#                                                                    CP15 274
systemheader:(CP16)#                   Block extension/refinement       CP16   1
####################################################################    CP16   2
#                                                                  #    CP16   3
#                             CP16    (FORMERLY GT09)              #    CP16   4
#                                                                  #    CP16   5
####################################################################    CP16   6
SUBROUTINE CP16(PHSET,III)#            S.r.hall  dec 81                 CP16   7
include:(AACOMN)#                                                       CP16   8
include:(CPCOMN)#                                                       CP16   9
#                                                                       CP16  10
INTEGER III,PHSET#                                                      CP16  11
INTEGER H,I,J,K,L,N,IP,IS,NI,NC,IT#    Cp16                             CP16  12
INTEGER MLIM,NDIF,NPHI,NINV,IPHI,NCON,MGEN,KGEN#                        CP16  13
INTEGER IA,IB,N1,N2,N3,N4#                                              CP16  14
INTEGER MITR,IDIF,MDIF,MINV,TEST,IFOM#                                  CP16  15
INTEGER LGEN,LREC,NBIAS,NF,GN#                                          CP16  16
INTEGER M1#                                                             CP16  17
#                                                                       CP16  18
#                                                                       CP16  19
REAL AL2,ANQ4,APHI,PREJ3,PSIA,SUMD#                                     CP16  20
REAL DELX,SUMB,PSIE#                                                    CP16  21
REAL WGT,SSIN,SCOS,SAL2,SUMN#                                           CP16  22
REAL A,B,R,SUMA,A2TH,DAL2,PHI#                                          CP16  23
REAL SUME,WSUM,WMUL,PREJ1,PREJ2#                                        CP16  24
REAL MYFOM#                                                             CP16  25
REAL ATOT,SUMC,CONTST,XVAL#                                             CP16  26
INTEGER IREJ#                          Phase rejection flag             CP16  27
REAL DEN(5)#                                                            CP16  28
#                                                                       CP16  29
REAL RANDGS,SD,RANNUM#                                                  CP16  30
REAL  HKL(3)#                                                           CP16  31
INTEGER ADD#                                                            CP16  32
INTEGER IPD,JPD,MCRIT1,MCRIT2#                                          CP16  33
INTEGER DRDX1,DRDY1,DRDZ1, DRDX2,DRDY2,DRDZ2#                           CP16  34
INTEGER D2DXDX,D2DYDY,D2DZDZ,D2DXDY,D2DXDZ,D2DYDZ#                      CP16  35
REAL DI(3,3),DA(3,3),SH1(3),SH2(3),DD#                                  CP16  36
REAL CRIT1,CRIT2,EPD,PPD#                                               CP16  37
#                                                                       CP16  38
#                                                                       CP16  39
chardata:(GT1, REJECT)#                                                 CP16  40
#CHARDATA:(GT2, EQUIV TO PSET)#                                         CP16  41
chardata:(GT5,   NSET NPHI APHI DPHI RMSD NEGQ NINV NNQ4 NCYC  $#       CP16  42
RFOM RFAC PSI0  PFOM  AMOS )#                                           CP16  43
realdata:(FMT1,[60613.,120413.,170413.,210413.,260413.,310413.,#        CP16  44
370513.,420413.,460413.,530522.,580522.,630522.,0632.,0613.])#          CP16  45
realdata:(SOL2,0.);  realdata:(TAL2,0.);  realdata:(RFOM,0.)#           CP16  46
realdata:(RFAC,0.);  realdata:(APSI,0.)#                                CP16  47
intdata:(IS2,[+1,-1,+1,-1,+1,-1,+1,-1])#                                CP16  48
intdata:(IS3,[+1,+1,-1,-1,+1,+1,-1,-1])#                                CP16  49
intdata:(IS4,[+1,+1,+1,+1,-1,-1,-1,-1])#                                CP16  50
intdata:(PRC,[9999,0,30,45,60,90,120,135,150,180])#                     CP16  51
realdata:(WTAB1,[1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,#                        CP16  52
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.])#                         CP16  53
realdata:(WTAB2,[.12,.30,.46,.60,.72,.82,.89,.94,.98,1.0,#              CP16  54
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,#                          CP16  55
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.])#                         CP16  56
datastuff:#                                                             CP16  57
#                                                                       CP16  58
#   INITIALIZE PHASING PARAMETERS                                       CP16  59
#   -----------------------------                                       CP16  60
#                                                                       CP16  61
VIABLE=yes:#                           Assume phase set will be ok      CP16  62
IF(TYPE==0)DAL2=1.0#                                                    CP16  63
ELSE       DAL2=AMIN1(A2MX/25.,1.)#    Calc al**2 incr for wgt          CP16  64
#                                                                       CP16  65
M1=MARK6#                                                               CP16  66
N4=M1;    NBIAS=MG-M1+1#               Set dummy n4 for quartets        CP16  67
KGEN=MAX0(50,NGEN/4)*MARK#             Set refine block incr            CP16  68
DO I=1,24#                             Loop over weight table           CP16  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP16  70
A=SQRT(FLOAT(I)-.5)/2.#                Get weight increment             CP16  71
B=EXP(A)#                              Get exponential                  CP16  72
IF(ICNT==0) WTAB1(I)=A/2.5#            Calc acentric weight             CP16  73
ELSE        WTAB1(I)=(B-1./B)/(B+1./B)# Calc tanh(b/2) weight           CP16  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP16  75
DO I=1,28#                             For alf ratio > 1.               CP16  76
WTAB2(I+12)=EXP(-FLOAT(I-1)*PFAC)#     Generate weight scheme 2         CP16  77
DELX=360./MAX(1.,FLOAT(NMAG))#         Set magic number intervals       CP16  78
PREJ1=FREJ(1)*XSHI; PREJ2=FREJ(2)*XSHI# Scale pretest fom limits        CP16  79
PREJ3=2.*PREJ1#                        Get rfom pretest limit           CP16  80
#                                                                       CP16  81
#   GET STARTING PHASE                                                  CP16  82
#   -------------------                                                 CP16  83
#                                                                       CP16  84
#                                                                       CP16  85
SD=FLOAT(III-1)*2.#                    Increase bdf phase dispersion    CP16  86
FOR(GN=M1;GN<MQ;GN=GN+MARK)#           Loop over gener list             CP16  87
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP16  88
phi:=-1.; wgt:=0.#                     Zero phase, weight, iter fix     CP16  89
IF(INPH!=0)#                           Use phases from archive          CP16  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP16  91
intunpak:(pak:,N, 0, 9)#               Get starting phase               CP16  92
RANDGS = -6.#                          Initial value                    CP16  93
DO I=1,12#                             Gaussian noise simulator sd=1.   CP16  94
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP16  95
SEED1=MOD(SEED1*25173+13849,65536)#    Generate random number           CP16  96
RANNUM=FLOAT(MOD(SEED1,10000))*0.0001# Number in range 0. - 0.9999      CP16  97
RANDGS = RANDGS + RANNUM#              Accumulate                       CP16  98
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP16  99
IF(RANNUM<FLOAT(III-1)/99.)N=N+NINT(RANDGS*120.)# Increase fractional   CP16 100
IPHI=MOD(N+NINT(SD*RANDGS),360)#       Starting phase of  mean +noise   CP16 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP16 102
ELSE#                                  Completely random                CP16 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP16 104
SEED2=MOD(SEED2*25173+13849,65536)#    Generate random number           CP16 105
ADD=MOD(SEED2,13849)+1#                Derive a random offset           CP16 106
SEED1=MOD(SEED1*25173+ADD,65536)#      A larger non-repetitive sequen   CP16 107
IPHI=MOD(SEED1,360)#                   Convert to random phi 0-359      CP16 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP16 109
#                                                                       CP16 110
IF(prc:>1.5)#                          Test if phi restricted           CP16 111
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP16 112
I=iprc:;  J=PRC(I)#                    Get phi restriction              CP16 113
K=IABS(IPHI-J);  K=MIN0(K,360-K)#      Get smallest difference          CP16 114
IF(K<90) IPHI=J#                       Set as closest restr             CP16 115
ELSE     IPHI=J+180#                   Set as closest restr             CP16 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP16 117
phi:=FLOAT(IPHI)#                      Assign random phase              CP16 118
wgt:=RWGT#                             Assign random weight             CP16 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP16 120
#                                                                       CP16 121
#                                                                       CP16 122
IF(PHSPEC(1)!=0)#                      Only specific phase sets reque   CP16 123
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP16 124
DO I=2,40; IF(PHSPEC(I)==III)BREAK#    Search for requested match       CP16 125
IF(I>40)$(VIABLE=no:;RETURN$)#         No match so skip                 CP16 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP16 127
#                                                                       CP16 128
#                                      ******* permute starters         CP16 129
L=0#                                   Progressive permute flag         CP16 130
IF(NMAG>1)#                            Test if magic starters           CP16 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP16 132
SUMX=SUMX+DELX#                        Incr magic phase constant        CP16 133
IF(SUMX>360.) SUMX=0.1#                Reset initial magic x            CP16 134
ELSE          L=1#                     Disable other permutes           CP16 135
DO I=1,NPER#                           Loop over permutes               CP16 136
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP16 137
IF(PERI(I)>0) NEXT#                    Skip non-magic permutes          CP16 138
J=PERN(I);  K=IABS(J)#                 Extract genlist pointer          CP16 139
phi:(K)=AMOD(phi:(K)+SUMX*FLOAT(-PERI(I)),360.)# Add permutation        CP16 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP16 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP16 142
FOR(I=1;I<=NPER;I=I+1)#                Loop over all permutes           CP16 143
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP16 144
IF(PERI(I)<0) NEXT#                    Skip magic permutes              CP16 145
J=PERN(I);   K=IABS(J)#                Point to gener list              CP16 146
phi:(K)=AMOD(phi:(K)+FLOAT(PERM(I)),360.)# Add permutation              CP16 147
IF(L==1) NEXT#                         Skip further permutes            CP16 148
PERM(I)=PERM(I)+PERI(I)#               Increment permute phase          CP16 149
IF(((J>0)&(PERM(I)>=360))$#            Test for 2pi permute             CP16 150
\  ((J<0)&(PERM(I)>=LEDR)))PERM(I)=0#  Test for pi permute              CP16 151
ELSE L=1#                              Shutoff further permutes         CP16 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP16 153
#                                                                       CP16 154
#    INITIALIZE PHASE SET PARAMETERS                                    CP16 155
#    -------------------------------                                    CP16 156
#                                                                       CP16 157
#NCUT=MQ#########                                                       CP16 158
#                                                                       CP16 159
A2TH=A2MX#                             Reset al**2 threshold            CP16 160
TEST=-1;    IREJ=0#                    Reset iteration flag             CP16 161
MITR=MXIT#                             Reset iteration limit            CP16 162
IF(MXIT==0)TEST=1#                     Just do final test               CP16 163
MLIM=NLIM#                             Reset genlist penetration        CP16 164
MGEN=NCUT;     LGEN=M1#                Reset genlist limit              CP16 165
NPHI=0;  IDIF=0;  SAL2=0.#             Reset accumulators               CP16 166
NDIF=0;   MDIF=0;   NINV=0;   MINV=0#  Reset fom accumulators           CP16 167
PSIA=0.;   PSIE=0.;   IFOM=yes:#       Reset fom accumulators           CP16 168
NF=0#                                  Reset iteration fix count        CP16 169
#                                                                       CP16 170
IF(MLIM==M1)MLIM=MQ#                   Use all generators !!!!!!!!!     CP16 171
#   ITERATION LOOP                                                      CP16 172
#   --------------                                                      CP16 173
#                                                                       CP16 174
FOR(NC=1;NC<=MAX(1,MITR);NC=NC+1)#     Loop over phasing cycles         CP16 175
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP16 176
NF=MAX0(NF,NC)#                        Set iteration fix limit          CP16 177
N1=0;   LREC=0#                        Reset generator count            CP16 178
IF(TEST<2) SOL2=SAL2#                  Reset old al2 if not pret        CP16 179
ELSE       TAL2=SAL2#                  Else save curr al2 later         CP16 180
SAL2=0.;  NCON=0#                      Reset al**2 & connects           CP16 181
SUMA=0.;  SUMD=0.;  SUMB=0.#           Reset fom sums                   CP16 182
ATOT=0.0#                                                               CP16 183
IF(TYPE==0) WMIN=-99.99#                                                CP16 184
CONTST=-1.0#                                                            CP16 185
#                                                                       CP16 186
#    GENERATOR LOOP                                                     CP16 187
#    --------------                                                     CP16 188
#                                                                       CP16 189
FOR(GN=M1;GN<MGEN;GN=GN+MARK)#         Loop over generator list         CP16 190
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP16 191
N1=N1+1#                               Incr generator count             CP16 192
TOP=itop:;    BOT=ibot:#               Get si block limits              CP16 193
alp:=0.#                               Reset invariant count            CP16 194
IF((GN<LGEN)&(wgt:>.9)) NEXT#          Skip stable phis last block      CP16 195
intunpak:(pak:,I,9,6)#                 Extract iter fix limit           CP16 196
IF(TYPE!=0&(TEST<=0)&(I>NF)) NEXT#     Test if this phase fixed         CP16 197
IF(GN<MQ) IPHI=NINT(phi:)#             Get current phi value            CP16 198
SSIN=0.; SCOS=0.; SUMN=0.; SUME=0.#    Zero sincos sums                 CP16 199
ecal:=0.0#                             Initialize temporary storage     CP16 200
#                                                                       CP16 201
#   INVARIANT LOOP                                                      CP16 202
#   --------------                                                      CP16 203
#                                                                       CP16 204
#IF(TYPE==0 &DMP>4)#                                                    CP16 205
#IF(GN<M1+10*MARK)                                                      CP16 206
#WRITE(6,'(I3,A5,2I7,F7.2,F8.0,F6.2,3I7,F8.2)') NC,"GEN ",$#            CP16 207
#N1,(IPNT:-M1)/MARK+1, EVL:,PHI:,WGT:,ITOP:,$#                          CP16 208
#IBOT:,MLIM,WMIN#                                                       CP16 209
#IF(GN<M1+10*MARK)                                                      CP16 210
#WRITE(6,*)"   N2   N3 PHI  PN2  PN3 N2+N3 N1-N23$#                     CP16 211
#  WN2   WN3   WGT   PROB   A    SCOS SUMA"                             CP16 212
#                                                                       CP16 213
FOR(NI=TOP;NI<BOT;NI=NI+4)#            Loop over invariant block        CP16 214
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP16 215
N2=NINT(QX(NI+2))#                     Extract n2 genlist address       CP16 216
IF(N2>MLIM) BREAK#                     Exit if beyond limit             CP16 217
IF(N2>MG) N2=N2-NBIAS#                 Adjust n2 for negq4              CP16 218
IF(wgt:(N2)<WMIN) NEXT#                Skip unphased generator          CP16 219
N3=NINT(QX(NI+3))#                     Extract n3 genlist address       CP16 220
IF(wgt:(N3)<WMIN) NEXT#                Skip unphased generator          CP16 221
WMUL=2.*wgt:(N2)*wgt:(N3)#             Product triplet weights          CP16 222
WSUM=wgt:(N2)+wgt:(N3)#                Sum of triplet weights           CP16 223
intunpak:(QX(NI+1),IT, 0, 2)#          Extract invariant type           CP16 224
IF(IT>1)#                              Test if active quartet           CP16 225
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP16 226
N4=NINT(QX(NI+4))#                     Extract n4 genlist address       CP16 227
IF(wgt:(N4)<WMIN) NEXT#                Skip unphased generator          CP16 228
WMUL=1.5*WMUL*wgt:(N4)#                Product quartet weight           CP16 229
WSUM=WSUM+wgt:(N4)#                    Sum of quartet weights           CP16 230
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP16 231
ifeq:(WSUM,0.0,0.0001) NEXT#                                            CP16 232
WGT=WMUL/WSUM#                         Calculate weight of cos(psi)     CP16 233
intunpak:(QX(NI+1),IP, 9, 9)#          Extract shift-qpsi-negq          CP16 234
intunpak:(QX(NI+1),IA,25, 7)#          Extract modified a or b *8       CP16 235
A=FLOAT(IA)*WGT*0.125#                 Form total inv weight            CP16 236
IF((IWGT>1)\(TEST>0))#                 Test if weight scheme 2 or 3     CP16 237
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP16 238
intunpak:(QX(NI+1),IB,18, 7)#          Extract probf *64                CP16 239
SUME=SUME+FLOAT(IB)*A#                 Sum weighted a*probf             CP16 240
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP16 241
IF(ICNT==1)#                           Test if centrosymmetric          CP16 242
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP16 243
ifne:(phi:(N2),phi:(N3)) A=-A#         Reverse sign if diff =pi         CP16 244
IF(IP>0)                 A=-A#         Reverse sign if shift=pi         CP16 245
IF((IT>1)&(phi:(N4)>.5)) A=-A#         Reverse sign if phi4 =pi         CP16 246
IF(IT!=negq:) SCOS=SCOS+A#             Sum tangent denominator          CP16 247
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP16 248
ELSE#                                  Else phases noncentrosymmetr     CP16 249
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP16 250
intunpak:(QX(NI+1),IS, 2, 3); IS=IS+1# Extract phi sign code            CP16 251
IF(IS2(IS)>0)         PHI=    phi:(N2)# Test if  phi2 is +ve            CP16 252
ELSE                  PHI=   -phi:(N2)# Else     phi2 is -ve            CP16 253
IF(IS3(IS)>0)         PHI=PHI+phi:(N3)## Test if  phi3 is +ve           CP16 254
ELSE                  PHI=PHI-phi:(N3)## Else     phi3 is -ve           CP16 255
IF((IT>1)&(IS4(IS)>0))PHI=PHI+phi:(N4)## Test if  phi4 is +ve           CP16 256
ELSE IF(IT>1)         PHI=PHI-phi:(N4)## Else     phi4 is -ve           CP16 257
J=MOD(3600-NINT(PHI)-IP,360)+MARK0#    Phase est for invariant          CP16 258
IF(IT!=negq:)#                         Test if active invariant         CP16 259
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP16 260
SSIN=SSIN+A*QX(J+1)#                   Sum  sin component               CP16 261
SCOS=SCOS+A*QX(J+91)#                  Sum  cos component               CP16 262
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP16 263
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP16 264
SUMN=SUMN+1.#                          Count invariants used            CP16 265
#                                                                       CP16 266
#                                      Accumulate best possible         CP16 267
ecal:=ecal:+MAX(0.05,ABS(A))#          Temporary storage here           CP16 268
ATOT=ATOT+FLOAT(IA)*0.125#                                              CP16 269
#                                                                       CP16 270
pt6:#                                                                   CP16 271
WRITE(6,'(2I4,2F5.0,3F6.2,I5,3F8.2)') (ipnt:(N2)-M1)/MARK+1,$# C        CP16 272
(ipnt:(N3)-M1)/MARK+1,phi:(N2),phi:(N3),$# C                            CP16 273
wgt:(N2),wgt:(N3),WGT,IA,A,SCOS,ecal:# C                                CP16 274
#                                                                       CP16 275
IF((IT==psi0:)\(TEST!=1)\(IPHI<0)) NEXT# Skip if psi0 or pretest        CP16 276
IF(ICNT==1) J=90-NINT(SIGN(90.,A))+MARK0## Get phase for centro         CP16 277
J=IABS(IPHI-J+MARK0); J=MIN0(J,360-J)# Get smallest difference          CP16 278
NINV=NINV+1#                           Count all invariants             CP16 279
NDIF=NDIF+J**2#                        Sum new/old differences          CP16 280
IF(IT!=negq:) NEXT#                    Skip if t3 or pq4                CP16 281
MINV=MINV+1#                           Count neg quartets               CP16 282
MDIF=MDIF+J**2#                        Sum phi differences              CP16 283
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP16 284
#                                                                       CP16 285
#IF(TYPE==0)                                                            CP16 286
#IFNE:(SUMN,0.0)                                                        CP16 287
#WRITE(6,'(A,F5.0,2F9.3,4X,F10.0)')"      INV USED ",SUMN,SSIN,SCOS,SUM CP16 288
#                                                                       CP16 289
#    END INV LOOP -- STORE GENERATOR SUMS                               CP16 290
#    ---------------------------                                        CP16 291
#                                                                       CP16 292
sin:=SSIN;  cos:=SCOS#                 Store tangent numer & denom      CP16 293
alt:=SUME/64.;  alp:=SUMN#             Store alfex & count              CP16 294
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP16 295
#                                                                       CP16 296
#   END GEN LOOP -- CALC PHASE VALUES                                   CP16 297
#   ---------------------------------                                   CP16 298
#                                                                       CP16 299
IF(TEST>0)#                            If fom test iteration            CP16 300
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CP16 301
MCRIT1=0; MCRIT2=0;#                                                    CP16 302
DRDX1=0; DRDY1=0; DRDZ1=0; DRDX2=0; DRDY2=0; DRDZ2=0#                   CP16 303
D2DXDX=0; D2DYDY=0; D2DZDZ=0; D2DXDY=0; D2DXDZ=0; D2DYDZ=0#             CP16 304
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CP16 305
#                                                                       CP16 306
SUMC=0.0#                                                               CP16 307
N1=0#                                  Reset generator counter          CP16 308
FOR(GN=M1;GN<MGEN;GN=GN+MARK)#         Loop over generator list         CP16 309
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CP16 310
N1=N1+1#                               Count generators                 CP16 311
IF(alp:<.5) $( wgt:=0.0;NEXT $)#       Skip if no estimate              CP16 312
SSIN=sin:;   SCOS=cos:#                Make sums local variables        CP16 313
AL2=SSIN**2 + SCOS**2#                 Calculate alpha squared          CP16 314
SAL2=SAL2+AL2#                         Sum alpha squared                CP16 315
IF(GN<MQ)#                             If normal gens (not psi0)        CP16 316
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CP16 317
IF(TEST>0)#                            If fom test iteration            CP16 318
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CP16 319
A=SQRT(AL2)#                           Calculate alpha                  CP16 320
SUMA=SUMA+A#                           Sum alpha                        CP16 321
SUMB=SUMB+alt:#                        Sum expected alpha               CP16 322
SUMD=SUMD+ABS(A-alt:)#                 Sum alpha diff for rfac          CP16 323
IF(TEST==2) NEXT#                      Skip phi calc for pretest        CP16 324
IPHI=NINT(phi:)#                       Get current phi for test         CP16 325
IF(III==1&INPH!=0)$(ssin:=SSIN;scos:=SCOS$)# Save first for compariso   CP16 326
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CP16 327
#                                                                       CP16 328
IF(TYPE!=0 &AL2<A2TH) NEXT#            Retain for non random            CP16 329
IF(ICNT==1) IP=90-NINT(SIGN(90.,SCOS))# Convert centro ccos to deg.     CP16 330
ELSE#                                  Else calc noncentro phase        CP16 331
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CP16 332
IF((ABS(SSIN)<.01)&(ABS(SCOS)<.01))NEXT# Skip if phi uncertain          CP16 333
B=ATAN2(SSIN,SCOS)*57.2957795#         Calc phi est in degrees          CP16 334
IP=MOD(360+NINT(B),360)#               Phi as modulo 360                CP16 335
IF(prc:>1.5)#                          Test if phi restricted           CP16 336
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CP16 337
I=iprc:;  J=PRC(I)#                    Get phi restriction              CP16 338
K=IABS(IP-J);  K=MIN0(K,360-K)#        Get smallest difference          CP16 339
IF(K==90) NEXT#                        Skip if ambiguous                CP16 340
IF(K<90) IP=J#                         Set as closest restr             CP16 341
ELSE     IP=J+180#                     Set as closest restr             CP16 342
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CP16 343
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CP16 344
#                                                                       CP16 345
IF(TYPE==0)#                           For random method                CP16 346
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CP16 347
ifeq:(alp:,1.) wgt:=0.5#               Arbitrary                        CP16 348
ELSEIF(ICNT==1)wgt:=MIN(ABS(SCOS)/MAX(0.01,ecal:),1.0)# Centro symmet   CP16 349
ELSE wgt:=MIN(SQRT(SCOS**2+SSIN**2)/MAX(0.01,ecal:),1.0)#               CP16 350
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CP16 351
ELSEIF(IWGT>1)#                        Test if weight 2 or 3            CP16 352
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CP16 353
IF(IWGT==2)#                           Get table index on ratio**2      CP16 354
I=MIN0(40,INT(AL2*10./alt:**2)+1)#     Get index for x**2               CP16 355
ELSE#                                  Get table index on ratio         CP16 356
I=MIN0(40,INT(SQRT(AL2)*10./alt:)+1)#  Get index for x                  CP16 357
wgt:=WTAB2(I)#                         Store weight 2                   CP16 358
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CP16 359
ELSE#                                  Else apply weight 1              CP16 360
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CP16 361
I=MIN0(25,INT(AL2/DAL2)+1)#            Form index from alpha**2         CP16 362
wgt:=WTAB1(I)#                         Store weight 1                   CP16 363
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CP16 364
SUMC=SUMC+ecal:#                                                        CP16 365
#                                                                       CP16 366
#                                                                       CP16 367
IF(MXIT!=0) phi:=FLOAT(IP)#            Store new phi estimate           CP16 368
NCON=NCON+1#                           Count connected generators       CP16 369
MLIM=MAX0(MLIM,GN)#                    Reset penetration limit          CP16 370
IF((TEST<1)\(IPHI<0)) NEXT#            Skip if not fom or known         CP16 371
NPHI=NPHI+IP#                          Sum total phi estimates          CP16 372
J=IABS(IPHI-IP); J=MIN0(J,360-J)#      Get smallest difference          CP16 373
IDIF=IDIF+J#                           Sum dif with prev phi            CP16 374
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CP16 375
#                                                                       CP16 376
ELSE#                                  Else must be psi0 triplets       CP16 377
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CP16 378
PSIA=PSIA+SQRT(AL2)#                   Sum actual psi0 alphas           CP16 379
PSIE=PSIE+alt:#                        Sum expected psi0 alphas         CP16 380
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CP16 381
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CP16 382
XVAL=SUMC/ATOT#                                                         CP16 383
#                                                                       CP16 384
pt6:#                                                                   CP16 385
WRITE(6,'(A11,I7,A11,I7,F7.0,F7.0,F7.4)')$#                             CP16 386
" PHASE SET ", PHSET,"     CYCLE ",NC,SUMC,ATOT,XVAL#                   CP16 387
#                                                                       CP16 388
ifne:(XVAL,0.0)#                       Dont compare after a test        CP16 389
IF  (CONTST+0.005>=XVAL)#              Oscillating or leveled           CP16 390
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 CP16 391
TEST=1 ; NEXT#                         Flag for last test next cycle    CP16 392
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CP16 393
CONTST=XVAL#                           Else still increasing            CP16 394
A2TH=A2TH*RATE#                        Reduce alpha**2 threshold        CP16 395
IF(NC<6) NEXT#                         Force min iterations             CP16 396
IF(SAL2<.1) BREAK#                     Exit if no connects              CP16 397
#                                                                       CP16 398
IF(IFOM==yes:)#                        Is fom pretest requested         CP16 399
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 CP16 400
IFOM=no:;  TEST=2;  NC=NC-1;   NEXT#   Reset test flags                 CP16 401
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 CP16 402
#                                                                       CP16 403
IF(TEST==1)#                           If final fom test                CP16 404
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 CP16 405
RFOM=MAX(.1,SUMB-SUMR)/MAX(.1,SUMA-SUMR)# Calc relative fom             CP16 406
IF(RFOM>FREJ(1)) IREJ=21#              Test rejection limit             CP16 407
RFAC=SUMD/SUMB#                        Calc karle rfactor               CP16 408
IF(RFAC>FREJ(2)) IREJ=22#              Test rejection limit             CP16 409
IF(PSIE>.1)#                           Test for psi0 triplets           CP16 410
APSI=PSIA/PSIE#                        Calculate psi0 fom value         CP16 411
ELSE APSI=-.00001#                     Psi(0) value unavailable         CP16 412
IF(APSI>FREJ(3)) IREJ=23#              Test for rejection               CP16 413
IF(RFOM<FREJ(6)) IREJ=24#              Test rejection limit             CP16 414
BREAK#                                 Exit after last fom test         CP16 415
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 CP16 416
ELSE IF(TEST==2)#                      Now if preliminary test          CP16 417
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 CP16 418
RFOM=SUMB/SUMA#                        Calc pretest rel fom             CP16 419
IF(RFOM>PREJ3) IREJ=11#                Test rejection limit             CP16 420
RFAC=SUMD/SUMB#                        Calc karle rfactor               CP16 421
IF((RFOM>PREJ1)&(RFAC>PREJ2)) IREJ=12# Test rejection limit             CP16 422
IF(RFOM<FREJ(6)) IREJ=14#              Test rejection limit             CP16 423
IF((EFOM==yes:)&(IREJ>0)) BREAK#       Exit if pretest failed           CP16 424
TEST=-1;  IREJ=0;   SAL2=TAL2#         Start next iteration if ok       CP16 425
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 CP16 426
#                                                                       CP16 427
A=ABS(SAL2-SOL2)/SAL2#                 Calc converge ratio              CP16 428
IF((TEST<0)&(A>CONV)) NEXT#            Recycle if not converged         CP16 429
IF(IACC==yes:) LGEN=MGEN#              Set last gen block limit         CP16 430
IF((MGEN<MQ)&(NC<MITR))#               Test if all gen used yet         CP16 431
MGEN=MIN0(MQ,MGEN+KGEN)#               Add gens as 1/4 list             CP16 432
ELSE TEST=TEST+1#                      Flag as final iterations         CP16 433
IF(TEST==0)#                           Test if 2nd test iteration       CP16 434
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 CP16 435
NF=10000#                              Release all fixed phases         CP16 436
MITR=NC+2#                             Set new iteration limit          CP16 437
MGEN=MQ;    LGEN=M1#                   Ensure all gens phased           CP16 438
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 CP16 439
ELSE IF(TEST==1)#                      Test iter release negq           CP16 440
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 CP16 441
##MLIM=65536#                                                           CP16 442
MLIM=99999999## Enable all inv. incl negq                               CP16 443
MGEN=MG;     LGEN=M1#                  Enable psi0 triplets             CP16 444
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 CP16 445
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP16 446
IF(TEST<0) IREJ=25#                    Reject if refine incomplete      CP16 447
#                                                                       CP16 448
ANQ4=SQRT(FLOAT(MDIF/(MINV+1)))#       Calc av nq4 diff                 CP16 449
APHI=FLOAT(NPHI/(NCON+1))#             Calc mean phase                  CP16 450
MYFOM=SUMC/ATOT#                       New fig of merit                 CP16 451
IF((APHI<XSLO-45.)\(APHI>XSLO+45.)) IREJ=36# ****** <phi> rejection     CP16 452
#                                                                       CP16 453
#  END OF ITER LOOP -- PREPARE FOM                                      CP16 454
#  -------------------------------                                      CP16 455
#                                                                       CP16 456
BUFOT(1)=FLOAT(III)#                   Store phase set number           CP16 457
BUFOT(2)=FLOAT(NCON)#                  Store ngen connected             CP16 458
BUFOT(3)=APHI#                         Store mean phase                 CP16 459
BUFOT(4)=FLOAT(IDIF/(NCON+1))#         Store test av phi dif            CP16 460
BUFOT(5)=SQRT(FLOAT(NDIF/(NINV+1)))#   Store rmsd phi all               CP16 461
BUFOT(6)=ANQ4#                         Store rmsd phi nq4               CP16 462
BUFOT(7)=FLOAT(NINV)#                  Store total invar test used      CP16 463
BUFOT(8)=FLOAT(MINV)#                  Store total negq  test used      CP16 464
BUFOT(9)=FLOAT(MITR)#                  Store number iterations          CP16 465
BUFOT(10)=RFOM#                        Store abs fom                    CP16 466
BUFOT(11)=RFAC#                        Store karle rfactor              CP16 467
BUFOT(12)=APSI#                        Store psi(0) value               CP16 468
BUFOT(13)=MYFOM#                       Store new figure of merit        CP16 469
#                                                                       CP16 470
DEN(1)=(AMAX1(.001,FMAX(1)-FMIN(1)))#  2.  - 0.                         CP16 471
DEN(2)=(AMAX1(.001,FMAX(2)-FMIN(2)))#  2.  - 0.                         CP16 472
DEN(3)=(AMAX1(.001,FMAX(3)-FMIN(3)))#  2.  - 0.                         CP16 473
DEN(4)=(AMAX1(.001,FMAX(4)-FMIN(4)))#  180. - 0.                        CP16 474
DEN(5)=(AMAX1(.001,FMAX(5)-FMIN(5)))#  1.  - 0.                         CP16 475
#                                                                       CP16 476
A=0.; R=0.#                                                             CP16 477
A=A+WFOM(1)*((1.- RFOM)/ DEN(1))#                                       CP16 478
A=A+WFOM(2)*(     RFAC / DEN(2))#                                       CP16 479
A=A+WFOM(3)*(     APSI / DEN(3))#                                       CP16 480
A=A+WFOM(4)*(     ANQ4 / DEN(4))#                                       CP16 481
A=A+WFOM(5)*((1.-MYFOM)/ DEN(5))#                                       CP16 482
R=R+WFOM(1)*(    FREJ(1) / DEN(1))#                                     CP16 483
R=R+WFOM(2)*(    FREJ(2) / DEN(2))#                                     CP16 484
R=R+WFOM(3)*(    FREJ(3) / DEN(3))#                                     CP16 485
R=R+WFOM(4)*(    FREJ(4) / DEN(4))#                                     CP16 486
R=R+WFOM(5)*((1.-FREJ(5))/ DEN(5))#                                     CP16 487
AMOS= (R-A) / R#                                                        CP16 488
#                                                                       CP16 489
BUFOT(14)=100.*AMOS#                   Store absolute measure of succ   CP16 490
ncodefld:(BUFOT,1,CHROT,FMT1,14)#                                       CP16 491
IF(IREJ<=0 & AMOS<0.05 ) IREJ=37#      ****** afom rejection            CP16 492
IF(IREJ<=0)#                                                            CP16 493
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 CP16 494
pt2: writeline:(0,GT5,NGT5,1,3)#       Print phase set info             CP16 495
PSLFOM(1)=AMOS#                                                         CP16 496
PSLFOM(3)=PHSET#                                                        CP16 497
PSLFOM(4)=MYFOM#                                                        CP16 498
PSLFOM(5)=RFAC#                                                         CP16 499
PSLFOM(6)=RFOM#                                                         CP16 500
PSLFOM(7)=ANQ4#                                                         CP16 501
PSLFOM(8)=BUFOT(3)#                                                     CP16 502
PSLFOM(9)=III#                                                          CP16 503
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 CP16 504
#                                                                       CP16 505
ELSE#                                  Reject this phase set            CP16 506
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 CP16 507
ncodefld:(FLOAT(IREJ),1,CHROT,800233.,1)# Format rejection reason       CP16 508
movechar:(GT1,1,CHROT,70,NGT1,0)#      Insert rejection message         CP16 509
pt2: writeline:(0,GT5,NGT5,1,3)#       Print phase set info             CP16 510
VIABLE=no:#                            Reject phase set                 CP16 511
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 CP16 512
#                                                                       CP16 513
RETURN#                                                                 CP16 514
END#                                                                    CP16 515
systemheader:(CP18)#                   Store best phase sets            CP18   1
#********************************************************************** CP18   2
#                                                                       CP18   3
#                                CP18                                   CP18   4
#                                                                       CP18   5
#********************************************************************** CP18   6
SUBROUTINE CP18#                                                        CP18   7
include:(AACOMN)#                                                       CP18   8
include:(CPCOMN)#                                                       CP18   9
#                                                                       CP18  10
INTEGER I,J,K#                                                          CP18  11
INTEGER IPNT,JPNT#                                                      CP18  12
INTEGER GN#                                                             CP18  13
REAL PTR#                                                               CP18  14
#                                                                       CP18  15
#                                                                       CP18  16
DO J=1,LPSET#                                                           CP18  17
ifeq:(PSFOM(1,J),PSLFOM(1),0.1)#                                        CP18  18
ifeq:(PSFOM(3,J),PSLFOM(3),0.1)#                                        CP18  19
ifeq:(PSFOM(4,J),PSLFOM(4),0.1)#                                        CP18  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP18  21
pt2: WRITE(6,*)" Duplicated stored phase set number ", J#               CP18  22
RETURN#                                                                 CP18  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP18  24
#                                                                       CP18  25
#                                                                       CP18  26
DO I=1,LPSET;IF(PSLFOM(1)>PSFOM(1,I)) BREAK# Loop over saved phase se   CP18  27
#                                                                       CP18  28
IF (I>=LPSET & LPSET>=psetlim:) RETURN# Ignore this possibility         CP18  29
IF(LPSET<psetlim:)PTR=FLOAT(LPSET+1)#  Get new pointer else overwrite   CP18  30
ELSE              PTR=PSFOM(2,LPSET)#  Record pointer to last temp      CP18  31
#                                                                       CP18  32
IF (I<=LPSET)#                         Merge within                     CP18  33
DO J=psetlim:,I+1,-1#                  Copy prior betters further bac   CP18  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP18  35
DO K=1,savepsfom:; PSFOM(K,J)=PSFOM(K,J-1)# Copy fig of merit back      CP18  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP18  37
DO K=1,savepsfom:; PSFOM(K,I)=PSLFOM(K)# Stash new foms                 CP18  38
PSFOM(2,I)=PTR#                        Save new pointer to storage      CP18  39
#                                                                       CP18  40
LPSET=MIN(LPSET+1,psetlim:)#           Increment number of phase sets   CP18  41
IPNT=NINT(PTR)+phin:#                  Save pointer for writing         CP18  42
JPNT=NINT(PTR)+wgtn:#                  Save pointer for writing         CP18  43
#                                                                       CP18  44
FOR(GN=MARK6;GN<MQ;GN=GN+MARK)#        Loop over generator list         CP18  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP18  46
ifeq:(phi:,-1.0)QX(GN+IPNT)=voidflg:#  Set as void                      CP18  47
ELSE            QX(GN+IPNT)=phi:/360.# Store phase estimate in cycles   CP18  48
QX(GN+JPNT)=wgt:#                      Save the phase set weight        CP18  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP18  50
#                                                                       CP18  51
RETURN#                                                                 CP18  52
END#                                                                    CP18  53
systemheader:(CP20)#                                                    CP20   1
#********************************************************************** CP20   2
#                                                                       CP20   3
#                                CP20  (FORMERLY PP01/PP02 FS40)        CP20   4
#                                                                       CP20   5
#********************************************************************** CP20   6
SUBROUTINE CP20#                       R.m.doherty 1981                 CP20   7
include:(AACOMN)#                      S.r.hall 1982                    CP20   8
include:(CPCOMN)#                                                       CP20   9
#                                                                       CP20  10
INTEGER I,JP,KP#                                                        CP20  11
#                                                                       CP20  12
INTEGER LAYPAS#                        Number of layers per pass        CP20  13
INTEGER LAYSIZ#                        Storage for one layer            CP20  14
INTEGER MAXSIZ#                        Max. space available for lay     CP20  15
INTEGER SYMOPS#                                                         CP20  16
REAL FACTR#                                                             CP20  17
chardata:(CP201," Searching for atoms in range  x    to  y   ")#        CP20  18
chardata:(CP202," Maximum atoms expected                 ")#            CP20  19
chardata:(CP203," Maximum sites searched for             ")#            CP20  20
datastuff:#                                                             CP20  21
#                                                                       CP20  22
#    DECIDE HOW MANY PEAKS TO SEARCH FOR                                CP20  23
#    -----------------------------------                                CP20  24
#                                                                       CP20  25
IF(MAPTYP==vect:)#                                                      CP20  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP20  27
NPEAKS=40#                                                              CP20  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP20  29
ELSE#                                                                   CP20  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP20  31
movertoc:(QX(MARK2+(ATZORD(1)-1)*ISCF+1),1,CP201,32,ISCF,1)#            CP20  32
I=MAT(MIN(LOOP,NARANG))#                                                CP20  33
movertoc:(QX(MARK2+(I-1)*ISCF+1),1,CP201,41,ISCF,1)#                    CP20  34
pt1: writeline:(0,CP201,NCP201,3,3)#   Output expected                  CP20  35
#                                                                       CP20  36
#ISYM=YES:#                            ASSUME SYMMETRY APPLIED          CP20  37
SYMOPS=1#                                                               CP20  38
#IF(ISYM==NO:)SYMOPS=NSYM#             ALLOW FOR RELATED PEAKS          CP20  39
IF(ITMODE==lsqonly:)#                  No peaklist elimination          CP20  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP20  41
FACTR=3.0#                             Arbitrary fudge factor           CP20  42
IF(NPEAKS>9999&ATEX>0)#                Not defined expected amount?     CP20  43
NPEAKS=NINT(FLOAT(ATEX/MOLZ*SYMOPS)*FACTR)# Maxpeak is at/asym unit     CP20  44
IF(NPEAKS>9999)#                       Still not defined ?              CP20  45
NPEAKS=NINT(FLOAT(50*SYMOPS)*FACTR)#   Default is 50 if no info         CP20  46
#  MAYBE SHOULD PICK A RANDOM DENSITY BASED ON CELL SIZE AND            CP20  47
#  EXTRAPOLATE ??                                                       CP20  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP20  49
ELSE#                                  Using peaklist elimination       CP20  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP20  51
IF(LOOP<NARANG-1) FACTR=2.0#                                            CP20  52
ELSE              FACTR=1.5#                                            CP20  53
IF(LOOP+1<NARANG) NPEAKS=NINT(FLOAT(EATL(LOOP+1)/MOLZ*SYMOPS)*FACTR)#   CP20  54
ELSE              NPEAKS=NINT(FLOAT(EATL(NARANG)/MOLZ*SYMOPS)*FACTR)#   CP20  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP20  56
#                                                                       CP20  57
ncodefld:(FLOAT(NPEAKS)/FACTR,1,CP202,400513.,1)#                       CP20  58
pt1: writeline:(0,CP202,NCP202,3,3)#   Output expected                  CP20  59
#                                                                       CP20  60
NPEAKS=MAX(NPEAKS,10)#                 Pekik look for at least 10       CP20  61
ncodefld:(FLOAT(NPEAKS),1,CP203,400513.,1)#                             CP20  62
pt1: writeline:(0,CP203,NCP203,3,3)#   Output actual search number      CP20  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP20  64
#                                                                       CP20  65
#    ASSIGN STORAGE FOR PEAK LISTS                                      CP20  66
#    -----------------------------                                      CP20  67
#                                                                       CP20  68
MXPEAK=MAX0(1000,(NPEAKS*2)/10)#       Force list to size of npeak      CP20  69
DO I=MARKM+1,STOPM;QX(I)=0.0#          Reset peak max profile           CP20  70
QXCUR=STOP8#                           Ensure previous erased           CP20  71
STEP8=savlist:#                        Size of peklist                  CP20  72
MARK9=STOP8#                           Duplicate prior atom list        CP20  73
STOP9=MARK9#                                                            CP20  74
STEP9=modellist:+MAXBON#                                                CP20  75
IF(MAPTYP==fdif:)#                     Copy mark8 to mark9 with space   CP20  76
FOR(JP=MARK8;JP<STOP8;JP=JP+STEP8)#    Loop over saved list             CP20  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP20  78
KP=STOP9#                                                               CP20  79
incrqx:(STOP9,STOP9+STEP9,CP2003)#     Get memory for this prior atom   CP20  80
movereal:(QX,JP+1,QX,KP+1,STEP8,1)#                                     CP20  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP20  82
MARK10=STOP9#                          Start of hole list               CP20  83
STEP10=STEP9#                          Size of permanent list           CP20  84
STOP10=MARK10#                                                          CP20  85
MARKA=STOP10#                          Start of permanent peak list     CP20  86
STEPA=7#                               Step permanent peak list         CP20  87
STOPA1=MARKA+((MXPEAK*10)/2)*STEPA#    End of permanent peak list       CP20  88
MARKB=STOPA1#                          Start of temporary peak list     CP20  89
STEPB=10#                              Step temporary peak list         CP20  90
STOPB=MARKB+STEPB*MXPEAK#              End temporary peak list          CP20  91
MARKC1=STOPB#                          Start of first line buffer       CP20  92
MARKC=MARKC1+NG(3)+1#                  Save first line of layer         CP20  93
STOPC=MARKC+NG(3)+1#                   End of first line buffer         CP20  94
MARKD=STOPC#                           Start of second line buffer      CP20  95
STOPD=MARKD+NG(3)+1#                   End of second line buffer        CP20  96
MARKE=STOPD#                           Start of third line buffer       CP20  97
STOPE=MARKE+NG(3)+1#                   End of third line buffer         CP20  98
incrqx:(MARKG,STOPE,CP2003)#           No memory for peak site list     CP20  99
STOPA=MARKA#                           Reset                            CP20 100
STOPB=MARKB#                           Reset                            CP20 101
#                                                                       CP20 102
MARKH=MARKG#                           Set marker for start of trig     CP20 103
STEPG=2; STEPH=2#                                                       CP20 104
STOPG=MARKG+2*NG(1)-1#                 Calc the end of first sum tr     CP20 105
STOPH=SIZEH+MARKH+1#                   Space needed was figured in      CP20 106
MARKI=STOPH#                           Subroutine fs30 where the        CP20 107
STOPI=SIZEI+MARKI+1#                   Number of fft factors were       CP20 108
MARKJ=STOPI#                           Figured out                      CP20 109
STEPJ=2#                                                                CP20 110
IH2MAX=IHMAX(2)+1#                     Set total index counts in        CP20 111
IH3MAX=IHMAX(3)+1#                     Second and third sum direction   CP20 112
STOPJ=MARKJ+2*(NG(3)+1)*(NG(2)+1)-1#                                    CP20 113
MARKK=STOPJ+1#                         Set start of third sum result/   CP20 114
STOPK=MARKK+NG(3)+1#                   Calc space needed for fft        CP20 115
STEPK=1#                               Of a sheet of a layer            CP20 116
#                                                                       CP20 117
# THE CORE NEEDED SO FAR IS THE MAXIMUM OF STOPG OR STOPK PLUS ONE      CP20 118
# DEPENDING ON WHICH IS LARGER.  ANOTHER SAVINGS IS POSSIBLE            CP20 119
# HOWEVER.  THE COEFFICIENTS OF THE VERY FIRST LAYER OF THE             CP20 120
# SECOND SUM ARE STORED IN THE FIRST OF THE MARKL ARRAY.                CP20 121
# THESE COEFFICIENTS MAY, THEREFORE BE OVERWRITTEN DURING THE           CP20 122
# THIRD SUM. THE MODICUM OF STORAGE WHICH CAN BE SALVAGED IS            CP20 123
# EITHER ALL OF MARKK OR AT LEAST THE FIRST LAYER OF SECOND             CP20 124
# SUM COEFFICIENTS INTO MARKK.                                          CP20 125
#                                                                       CP20 126
LAYSIZ=4*(NG(2)+1)*(NG(3)+1)#          If fft algorithm                 CP20 127
MARKL=MAX0(STOPG+1,STOPK+1)#           Calculate storage needed         CP20 128
incrqx:(I,MARKL,CP2004)#               Incr qx........fs4001            CP20 129
STEPL=4; STOPL=MARKL+LAYSIZ*NP(1)-1#   Calculate the needed storage     CP20 130
MAXSIZ=QXMAX-MARKL#                    Calc the maximum size avail      CP20 131
IF(MAXSIZ<=LAYSIZ) iquit:(CP2001)#     Not enough mem for one layer     CP20 132
#                                                                       CP20 133
#  RATIONALIZE LAYERS PER PASS, ETC.                                    CP20 134
#  ---------------------------------                                    CP20 135
#                                                                       CP20 136
LAYPAS=MAXSIZ/LAYSIZ#                  Figure out number of layers      CP20 137
PASSES=(NP(1)+LAYPAS-1)/LAYPAS#        Calc the number of passes re     CP20 138
LAYPAS=(NP(1)+PASSES-1)/PASSES#        Now equalize the layers per      CP20 139
NPP1=LAYPAS#                           Set no. of layers for first      CP20 140
STOPL=LAYPAS*LAYSIZ+MARKL-1#           Recalculate end of store         CP20 141
IF(QXMAX<STOPL+2) iquit:(FS4003)#      Cannot continue                  CP20 142
qxmemory:(STOPL+2)#                    Request and zero memory          CP20 143
#                                                                       CP20 144
#  ADD BEFORE FIRST SUBTRACT IN LOOP                                    CP20 145
#  ---------------------------------                                    CP20 146
#                                                                       CP20 147
INXORG1=IXORG(1)-NPP1*IXINC(1)#        Move the origin of first sum     CP20 148
INORGX1=ORGX(1)-NPP1*INCX(1)#          Move perceived origin also       CP20 149
INNP1  =NP(1)+NPP1#                    And decrement the points to      CP20 150
PASSES=PASSES+1#                       Decrement pass count             CP20 151
#                                                                       CP20 152
# DO SOME GENERAL INITIALIZATIONS                                       CP20 153
# --------------------------------                                      CP20 154
#                                                                       CP20 155
NPTS=0#                                Zero count of pts. in perm.      CP20 156
ORGX1=ORGX(1)#                         Save first layer                 CP20 157
IF    (MAPTYP==emap:)DMIN=2.#          Set minimum density for emap     CP20 158
ELSEIF(MAPTYP==fobs:)DMIN=1.#          Set minimum density for fobs m   CP20 159
ELSEIF(MAPTYP==fdif:)DMIN=.25#         Set minimum density for dif ma   CP20 160
ELSEIF(MAPTYP==vect:)DMIN=2.#          Set minimum density for e^2-1    CP20 161
PMIN=DMIN;   PLIM=DMIN#                Set initial peak min values      CP20 162
DENMAX=-9999.; DENMIN=9999.#           Set density limits               CP20 163
#                                                                       CP20 164
RETURN#                                                                 CP20 165
END#                                                                    CP20 166
systemheader:(CP22)#                   First sum builder                CP22   1
# ################################################################## #  CP22   2
#                                                                    #  CP22   3
#                               CP22   (FORMERLY FS50 )              #  CP22   4
#                                                                    #  CP22   5
# ################################################################## #  CP22   6
SUBROUTINE CP22#                       Part 5-first sum of transfor     CP22   7
include:(AACOMN)#                      J.m.stewart,j.r.holden 1981      CP22   8
include:(CPCOMN)#                      R.doherty,k.watenpaugh 1982      CP22   9
#                                                                       CP22  10
INTEGER I,IS,J,K,L,M,N#                                                 CP22  11
REAL    FSCAL#      ## Final coefficient scale factor (1/v,scale etc.   CP22  12
INTEGER IXORG1,IXINC1#                                                  CP22  13
INTEGER LH(3),IH(3)#                                                    CP22  14
INTEGER SIGNCD,ZEROCD#                                                  CP22  15
INTEGER NG1,NG1P,NP1,NCENT,IHXS,TNG1,TINCHX#                            CP22  16
INTEGER SUM1BE,SUM1ST,IH2MP1#                                           CP22  17
INTEGER ID(48),KD(48),JS1,JS2,JS3#                                      CP22  18
INTEGER KH(48),KK(48),KL(48),KP(48)#                                    CP22  19
INTEGER GN#                                                             CP22  20
INTEGER REC#                                                            CP22  21
INTEGER REF#                                                            CP22  22
INTEGER ISTRT,ISTOP#                                                    CP22  23
REAL BUF1(12)#                                                          CP22  24
REAL PCP#                                                               CP22  25
REAL H(3),A,STOL,XSTOL,TEMP#                                            CP22  26
REAL FSIN,FCOS,FAC1,FAC2#                                               CP22  27
REAL REFCNT(12)#                                                        CP22  28
REAL AMUL#                                                              CP22  29
INTEGER PSH#                                                            CP22  30
INTEGER LCNT#                          Local centricity                 CP22  31
#                                                                       CP22  32
realdata:(TWOPI,6.2831853);   realdata:(TINY,.0000001)#                 CP22  33
intdata:(JSTOR,[1,2,3,4,1,2,3,4,1,2,4,3,1,2,4,3])#                      CP22  34
realdata:(FACTOR,[1.,1.,1.,1.,1.,1.,1.,1.,1.,-1.,-1.,1.,1.,-1.,-1.,1.])#CP22  35
intdata:(ISTOR,[1,2,1,2,2,1,2,1])#                                      CP22  36
realdata:(D1,[1.,0.,.5,0.,-.5,0.,-1.,0.,-.5,0.,.5,0.])#                 CP22  37
realdata:(D2,[.0,.0,.8660254,1.,.8660254,.0,.0,.0,-.8660254,-1.,#       CP22  38
-.8660254,.0])#                                                         CP22  39
realdata:(D3,[.0,.0,-.8660254,-1.,-.8660254,.0,.0,.0,.8660254,1.,#      CP22  40
.8660254,.0])#                                                          CP22  41
realdata:(D4,[1.,0.,.5,0.,-.5,0.,-1.,0.,-.5,0.,.5,0.])#                 CP22  42
realdata:(AA,[0.,0.,0.,0.,0.,0.,0.,0.])#                                CP22  43
intdata:(FLIP,[0,0,0,1,0,1,1,1])#                                       CP22  44
intdata:(SIGNS,[0,3,2,1,1,2,3,0])#                                      CP22  45
realdata:(SN,[1.,1.,1.,1.,-1.,1.,1.,-1.,-1.,-1.,1.,1.,-1.,1.,-1.,1.,#   CP22  46
1.,-1.,1.,1.,1.,1.,-1.,1.,-1.,1.,1.,1.,1.,1.,1.,-1.])#                  CP22  47
intdata:(REJF,0); intdata:(JS,0); intdata:(KS,0)#                       CP22  48
realdata:(AFAC,0.); realdata:(BFAC,0.)#                                 CP22  49
realdata:(AH,0.); realdata:(AK,0.); realdata:(AL,0.)#                   CP22  50
datastuff:#                                                             CP22  51
#                                                                       CP22  52
# ON SUBSEQUENT PASSES DECREMENT THE PASS COUNT                         CP22  53
# ---------------------------------------------                         CP22  54
#                                                                       CP22  55
INXORG1=INXORG1+NPP1*IXINC(1)#         Move the origin of first sum     CP22  56
INORGX1=INORGX1+NPP1*INCX(1)#          Move perceived origin also       CP22  57
INNP1=INNP1-NPP1#                      And decrement the points to      CP22  58
PASSES=PASSES-1#                       Decrement pass count             CP22  59
INXORG1=MOD(INXORG1+2*NG(1),NG(1))#    Keep it modulo the number of     CP22  60
#                                                                       CP22  61
IF(PASSES>0)#                          Test if passes still to go       CP22  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP22  63
NPP1=(INNP1+PASSES-1)/PASSES#          Calculate the number of points   CP22  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP22  65
ELSE IF(PASSES==0) RETURN#             Finished                         CP22  66
#                                                                       CP22  67
#   PREPARE FOR FIRST SUMMATION                                         CP22  68
#   ---------------------------                                         CP22  69
#                                                                       CP22  70
DO I=1,12; REFCNT(I)=0.#               Zero refln counts                CP22  71
JS1=JSUM1+1; JS2=JSUM2+1; JS3=JSUM3+1# Store coeff sum order            CP22  72
NG1=NG(1); NP1=NPP1#                   Make as local variables          CP22  73
TNG1=2*NG1#                            Grid for interleaved sin cos     CP22  74
IH2MP1=NG(2)#                          Set sum 2 for fft                CP22  75
SUM1ST=4*IH3MAX*IH2MP1#                Set the first sum stepper        CP22  76
NG1P=STOPG+1#                          Set end sum1 as local            CP22  77
#                                                                       CP22  78
# SET UP SIN COS TABLES FOR FIRST SUM                                   CP22  79
# -----------------------------------                                   CP22  80
#                                                                       CP22  81
TEMP=TWOPI/FLOAT(NG(1));  A=0.#        Get first sum grid step          CP22  82
DO  I=MARKG,STOPG,STEPG#               Loop over sum1 grid              CP22  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP22  84
QX(I+1)=COS(A); QX(I+2)=SIN(A)#        Store interleaved cos sin        CP22  85
A=A+TEMP#                              Incr to next angle               CP22  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP22  87
#                                                                       CP22  88
# CLEAR THE FIRST SUM TABLE OF SECOND SUM COEFFICIENTS                  CP22  89
# ----------------------------------------------------                  CP22  90
#                                                                       CP22  91
DO J=MARKL,STOPL; QX(J+1)=0.#          Zeroize sum 2 coefficients       CP22  92
DO J=1,NROT ; KD(J)=J#                 Set default hkl sort order       CP22  93
DO J=1,3; IH(J)=9#                     Reset reflection indices         CP22  94
DO J=1,3; LH(J)=0#                     Reset reflection indices         CP22  95
XSTOL=0.0#                                                              CP22  96
IS=1;  FSIN=0.;  FCOS=1.#              Reset sign & imag factor         CP22  97
IXINC1=IXINC(1)#                       Move incr to local store         CP22  98
IXORG1=INXORG1#                        Same for origin                  CP22  99
#                                                                       CP22 100
IF    (MAPTYP==emap:)AA(1)=E000/2.#    Set f000 for emap                CP22 101
ELSEIF(MAPTYP==vect:)AA(1)=0.0#        Set to zero for vector map       CP22 102
ELSEIF(MAPTYP==fobs:)AA(1)=F000/2.#    Set f000 for fobs map            CP22 103
ELSEIF(MAPTYP==fdif:)AA(1)=0.0#        Set f000 for dif map             CP22 104
IF(IRAD==2)FSCAL=2.#                   Set map scale (hemisphere)       CP22 105
ELSE#                                  If xrays or neutrons             CP22 106
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP22 107
FSCAL=2./MAX(1.,VOL)#                  Density per cubic angstroms      CP22 108
A=AMIN1(F000/(E000+.1),100.)#          Set emap rescale value           CP22 109
IF    (MAPTYP==emap:)FSCAL=FSCAL*A#    Adjust emap scale for f/e        CP22 110
ELSEIF(MAPTYP==vect:)FSCAL=FSCAL*A#    Adjust vect scale for f/e        CP22 111
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP22 112
LCNT=ICNT#                             Local centrosymmetric flag       CP22 113
IF(MAPTYP==vect:)LCNT=1#               Unphased centric laue map        CP22 114
IF(LCNT==1) NCENT=4#                   Set hkl loop for centric         CP22 115
ELSE        NCENT=8#                   Set hkl loop for acentric        CP22 116
IF(MAPTYP==vect:)$(ISTRT=STOPS;ISTOP=STOPS+STOPR-MARKS$)# Centric lau   CP22 117
ELSE             $(ISTRT=MARKS;ISTOP=STOPR$)# Unphased centric laue m   CP22 118
#                                                                       CP22 119
pt5: WRITE(6,*) "FSCAL ",FSCAL,F000,E000,AA(1),VOL,NCENT,MAPTYP#        CP22 120
#                                                                       CP22 121
#   START HEMISPHERE REFLECTION LOOP                                    CP22 122
#   ===============================                                     CP22 123
#                                                                       CP22 124
REF=0;REC=0#                                                            CP22 125
GN=MARK6-MARK#                                                          CP22 126
#                                                                       CP22 127
REPEAT#                                                                 CP22 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP22 129
IF(REFMOD==1)#                         Using generator ref list         CP22 130
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP22 131
GN=GN+MARK#                            Using grenerator ref list        CP22 132
IF(GN>=MQ)GOTO75#                      End of gen list                  CP22 133
PCP =phi:#                             Extract phase phi in cycles      CP22 134
ifvo:(PCP)                 GOTO 100#   Void phase                       CP22 135
gethkl:(GN+1,H)#                       Unpack h,k,l                     CP22 136
STOL=stol:#                            Get sin theta on lambda          CP22 137
IF    (MAPTYP==emap:)FAC1=evl:#        Extract e value                  CP22 138
ELSEIF(MAPTYP==fobs:)FAC1=SCAL*frel:#  Fobs map                         CP22 139
ELSEIF(MAPTYP==vect:)FAC1=evl:*evl: -1.# Vector map of e^2-1            CP22 140
FAC2=wgt:#                             Extract weight for phase         CP22 141
IF(MAPTYP==emap:)ifeq:(FAC2,0.0) GOTO100# Zippo                         CP22 142
IF(MAPTYP==vect:)FAC2=1.#              Vector map of e^2-1              CP22 143
ELSEIF(FAC1<EMIN)          GOTO100#    Reject if eval to small          CP22 144
intunpak:(mult:,J,0,4)#                Extract ref mult                 CP22 145
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP22 146
ELSE#                                                                   CP22 147
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP22 148
REC=REC+1#                                                              CP22 149
IF(REC>DACREF) $(GN=MQ;GOTO75 $)#      End of direct access file        CP22 150
readdac:(ioda2:,,REC,BUF1)#                                             CP22 151
IF(REFMOD==0 & BUF1(5)<1.0) GOTO 100#  Impose evalue threshold          CP22 152
IF(REFMOD==-1&MAPTYP!=vect:&BUF1(4)<SIGMUL*BUF1(10)) GOTO 100# Reject   CP22 153
DO KQJ=1,3#                            Get hkl                          CP22 154
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP22 155
intunpak:(BUF1(1),JQK,(KQJ-1)*9+3,9)#                                   CP22 156
intunpak:(BUF1(1),KZJ,KQJ-1,1)#                                         CP22 157
IF(KZJ!=0)JQK=-JQK#                                                     CP22 158
H(4-KQJ)=FLOAT(JQK)#                                                    CP22 159
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP22 160
DO I=1,3;IF(ABS(H(I))>FLOAT(MAXH(I))) GOTO100# Too many reflections     CP22 161
intunpak:(BUF1(2),J,0,4)#              Extract ref mult                 CP22 162
STOL=BUF1(3)#                          Get sin theta on lambda          CP22 163
IF (MAPTYP==emap:)#                    Calculating a phased emap
$(
ifvo:(BUF1(5)) GOTO 100#               If GENEV run with smax cutoff!
FAC1=BUF1(5)#                          Extract e value      
$)
ELSEIF(MAPTYP==fobs:)FAC1=SCAL*BUF1(4)# Extract fobs value              CP22 165
ELSEIF(MAPTYP==vect:)FAC1=BUF1(5)*BUF1(5)-1.# Vector map of e^2-1       CP22 166
ifeq:(FAC1,0.0)  GOTO 100#                                              CP22 167
# IF ONLY HEAVY ATOMS THEN A LOT OF SMALL UNPHASED E'S MAY WREAK HAVOC  CP22 168
IF(MAPTYP==fdif:)FAC1=SCAL*BUF1(4)-BUF1(7)# Difference map              CP22 169
FAC2=1.0#                              Extract weight for phase         CP22 170
PCP =BUF1(9)#                          Extract phase phi in cycles      CP22 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP22 172
AMUL=FLOAT(J)#                                                          CP22 173
#                                                                       CP22 174
#   CALCULATE A & B COEFFICIENTS                                        CP22 175
#   ----------------------------                                        CP22 176
#                                                                       CP22 177
IF(MAPTYP!=vect:)#                                                      CP22 178
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP22 179
ifvo:(PCP)              GOTO100#       Reject if phi missing            CP22 180
FCOS=COS(PCP*TWOPI)#                   Calculate cosphi                 CP22 181
IF(LCNT==0) FSIN=SIN(PCP*TWOPI)#       Calculate sinphi                 CP22 182
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP22 183
ELSE $(FCOS=1.0;FSIN=0.$)#                                              CP22 184
A=(FAC1*FAC2)#                         Calculate coeff                  CP22 185
#                                                                       CP22 186
REF=REF+1#                                                              CP22 187
#                                                                       CP22 188
pt5: WRITE(6,'(4I4,5F10.5)')$#                                          CP22 189
NINT(H(1)),NINT(H(2)),NINT(H(3)),NINT(AMUL),PCP,STOL,FAC1,FAC2,A#       CP22 190
#                                                                       CP22 191
AFAC=A*FCOS#                           Calculate real term              CP22 192
IF(LCNT==0) BFAC=A*FSIN#               Calculate imag term              CP22 193
AH=H(1); AK=H(2); AL=H(3)#             Restore as local variables       CP22 194
REJF=2#                                Set no rejection flag            CP22 195
#                                                                       CP22 196
#   GENERATE SYMMETRY RELATED REFLECTIONS FOR ACTUAL SUMMATION          CP22 197
#   ----------------------------------------------------------          CP22 198
#                                                                       CP22 199
L=0; M=0; N=0#                         Zero duplicate counts            CP22 200
FOR(J=ISTRT;J<ISTOP;J=J+STEPS)#        Loop over symmetry matrices      CP22 201
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP22 202
M=M+1#                                 Count generated reflections      CP22 203
KH(M)=NINT(AH*QX(J+1)+AK*QX(J+2)+AL*QX(J+3))# Generate new h            CP22 204
KK(M)=NINT(AH*QX(J+4)+AK*QX(J+5)+AL*QX(J+6))# Generate new k            CP22 205
KL(M)=NINT(AH*QX(J+7)+AK*QX(J+8)+AL*QX(J+9))# Generate new l            CP22 206
KP(M)=NINT((AH*QX(J+10)+AK*QX(J+11)+AL*QX(J+12))*12.)# Phase shift      CP22 207
IF(NRSZ==NROT) NEXT#                   Skip if no duplicates            CP22 208
K=IABS(KL(M))*261244+IABS(KK(M))*512+IABS(KH(M))# Form sort word        CP22 209
FOR(I=1;I<=N;I=I+1)#                   Loop over duplicate list         CP22 210
IF(K==KD(I))BREAK#                     Exit search on match             CP22 211
ID(M)=I#                               Store duplicate order            CP22 212
IF(I<=N) NEXT#                         Skip if old duplicate            CP22 213
KD(I)=K; N=I#                          Update if new duplicate          CP22 214
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP22 215
FOR(I=1;I<=N;I=I+1)#                   Loop over duplicate list         CP22 216
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP22 217
DO J=1,NROT#                           Loop over equiv hkl list         CP22 218
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP22 219
IF(ID(J)!=I) NEXT#                     Skip on no match                 CP22 220
L=L+1; KD(L)=J#                        Store duplicate sort order       CP22 221
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP22 222
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP22 223
#                                                                       CP22 224
#     SUM EQUIVALENT HKL IN SORTED ORDER                                CP22 225
#     ----------------------------------                                CP22 226
#                                                                       CP22 227
75     CONTINUE#                       Branch point for last packet     CP22 228
FOR(JS=1;JS<=NROT;JS=JS+1)#            Loop over hkl list               CP22 229
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP22 230
KS=KD(JS)#                             Pick up sequence number          CP22 231
IH(ISUM1)=IABS(KH(KS))#                Sorted h permuted                CP22 232
IH(ISUM2)=IABS(KK(KS))#                Sorted k permuted                CP22 233
IH(ISUM3)=IABS(KL(KS))#                Sorted l permuted                CP22 234
#                                                                       CP22 235
#     SUM COEFFICIENT IF NEXT HKL CPS DIFFERENT MAGNITUDE OF HKL        CP22 236
#     ----------------------------------------------------------        CP22 237
#                                                                       CP22 238
IF(LH(1)!=IH(1)\LH(2)!=IH(2)\LH(3)!=IH(3)\GN>=MQ)# Test if identical    CP22 239
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP22 240
#                                                                       CP22 241
#    ACCUMULATE THE FIRST SUM                                           CP22 242
#    ------------------------                                           CP22 243
#                                                                       CP22 244
SUM1BE=4*(LH(2)+LH(3)*IH2MP1)+MARKL#   Set beginning of first sum       CP22 245
IHXS=2*MOD(LH(1)*IXORG1,NG1)+MARKG#    Point to sin cos values          CP22 246
TINCHX=2*MOD(LH(1)*IXINC1,NG1)#        Make hx incr for index           CP22 247
L=0#                                   Set sign counter                 CP22 248
J=8#                                   Set pointer for fft              CP22 249
DO K=1,NCENT#                          Loop over sign coeff             CP22 250
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP22 251
IF(K<=4)#                              Test if real summation           CP22 252
A=SN(L+1)*AA(    1)+SN(L+2)*AA(JS1  )$# Sum real coefficients           CP22 253
+ SN(L+3)*AA(JS2  )+SN(L+4)*AA(JS3  )# Sum real coefficients            CP22 254
ELSE#                                  Else are imaginary               CP22 255
A=SN(L+1)*AA(    5)+SN(L+2)*AA(JS1+4)$# Sum imag coefficients           CP22 256
+ SN(L+3)*AA(JS2+4)+SN(L+4)*AA(JS3+4)# Sum imag coefficients            CP22 257
J=J+1;   L=L+4#                        Increment pointer                CP22 258
IF(ABS(A)<TINY) NEXT#                  Ignore zero coeff.s              CP22 259
A=A*FACTOR(J)*FSCAL#                   Store coeff as local variabl     CP22 260
M=JSTOR(J)+SUM1BE#                     Extract storage offset value     CP22 261
N=ISTOR(K)+IHXS#                       Point to sin(hx) cos(hx)         CP22 262
DO I=1,NP1#                            Loop over first sum points       CP22 263
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP22 264
QX(M)=QX(M)+A*QX(N)#                   Form first fourier sum           CP22 265
M=M+SUM1ST#                            Increment storage pointer        CP22 266
N=N+TINCHX#                            Increment hx pointer             CP22 267
IF(N>NG1P) N=N-TNG1#                   Adjust hx if off b-l strip       CP22 268
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP22 269
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP22 270
LH(1)=IH(1); LH(2)=IH(2); LH(3)=IH(3)# Reset current hkl to last        CP22 271
DO J=1,NCENT; AA(J)=0.#                Reset all coefficients           CP22 272
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP22 273
IF(GN>=MQ) BREAK#                                                       CP22 274
#                                                                       CP22 275
#                                                                       CP22 276
#     CPVING REDUCED THE PATTERN OF SIGNS AND ZEROS TO TWO              CP22 277
#     INTEGER VALUES ACCORDING TO THE FOLLOWING TABLE IT IS             CP22 278
#     NECESSARY TO MAKE THE SIGN CODE CONFORM TO THE METHOD             CP22 279
#     OF SUMMATION.  THE APPROACH TAKEN IS HEURISTIC AND                CP22 280
#     NOT AT ALL INTELLECTUALLY SATISFYING.                             CP22 281
#     THE VALUES IN THE TABLE ARE A FUNCTION OF THE CHOICE OF           CP22 282
#     HEMISPHERE AT THE TIME THE GENERAL FOURIER EXPRESSION             CP22 283
#     IS FACTORED.                                                      CP22 284
#                                                                       CP22 285
#     SIGNS    ZEROS     SIGNCD      ZEROCD                             CP22 286
#     +++     NNN         0           0                                 CP22 287
#     ++-     NN0         1           1                                 CP22 288
#     +-+     N0N         2           2                                 CP22 289
#     +--     N00         3           3                                 CP22 290
#     -++     0NN         4           4                                 CP22 291
#     -+-     0N0         5           5                                 CP22 292
#     --+     00N         6           6                                 CP22 293
#     ---     000         7           7                                 CP22 294
#                                                                       CP22 295
#      THIS TABLE SHOWS THE CODES REQUIRED TO PRODUCE THE CORRECT       CP22 296
#      FOURIER TRANSFORM AS A FUNCTION OF SIGNCD AND ZEROCD. THE        CP22 297
#      IF STATEMENT WHICH FOLLOWS THE TABLE TRANSFORMS THE SIGNCD       CP22 298
#      VALUE TO CONFORM TO THE TABLE VALUE                              CP22 299
#      THE BODY OF THE TABLE CONTAINS THE CORRECT VALUES OF             CP22 300
#      SIGNCD.  THE AXIAL AND ZONAL REFLECTIONS ARE THE                 CP22 301
#      PROBLEM.                                                         CP22 302
#                                                                       CP22 303
#            ZEROCD'S                                                   CP22 304
#              0    1    2    3    4    5    6    7                     CP22 305
#   SIGNCD'S                                                            CP22 306
#      0       0    0    0    0    0    0    0    0                     CP22 307
#      1       1         3         5         7                          CP22 308
#      2       2    3              2    7                               CP22 309
#      3       3                   7                                    CP22 310
#      4       4    4    4    7                                         CP22 311
#      5       5         7                                              CP22 312
#      6       6    7                                                   CP22 313
#      7       7                                                        CP22 314
#                                                                       CP22 315
IF(KL(KS)<0) SIGNCD=1#                 Get sign code of l               CP22 316
ELSE         SIGNCD=0#                                                  CP22 317
IF(KK(KS)<0) SIGNCD=SIGNCD+2#          Add on sign code of k            CP22 318
IF(KH(KS)<0) SIGNCD=SIGNCD+4#          And that of h                    CP22 319
IF(KL(KS)==0) ZEROCD=1#                Set zero code of l               CP22 320
ELSE          ZEROCD=0#                                                 CP22 321
IF(KK(KS)==0) ZEROCD=ZEROCD+2#         Add on zero code of k            CP22 322
IF(KH(KS)==0) ZEROCD=ZEROCD+4#         And that of h                    CP22 323
IF((MOD(SIGNCD,2)==1)\ $#              Decode axial & zonal codes       CP22 324
((SIGNCD==2)&(ZEROCD!=4))\ $#          Decode axial & zonal codes       CP22 325
((SIGNCD==4)&(ZEROCD==3))\ $#          Decode axial & zonal codes       CP22 326
(SIGNCD==6)) SIGNCD=SIGNCD+ZEROCD#     Decode axial & zonal codes       CP22 327
#                                                                       CP22 328
#                                                                       CP22 329
#                                                                       CP22 330
#     GENERATE THE CONTRIBUTION OF THE CURRENT REFLECTION A AND B       CP22 331
#     AS TRANSFORMED BY THE SYMMETRY DRIVERS INTO                       CP22 332
#     A(+++), OR A(-++), OR A(+-+), OR A(++-) AND                       CP22 333
#     B(+++), OR B(-++), OR B(+-+), OR B(++-) WHICH ARE STORED          CP22 334
#      IN A(1) TO A(8) RESPECTIVELY.........                            CP22 335
#                                                                       CP22 336
#                                                                       CP22 337
#                                                                       CP22 338
IS=MOD(KP(KS)+4800,12)+1#              Get phase shift in 12ths         CP22 339
J=SIGNS(SIGNCD+1)#                     Permute the sign codes           CP22 340
AA(J+1)=D1(IS)*AFAC+D2(IS)*BFAC#       Phase shift real coeff           CP22 341
IF(LCNT==1) NEXT#                      Skip imag part if centric        CP22 342
AA(J+5)=D3(IS)*AFAC+D4(IS)*BFAC#       Phase shift imag coeff           CP22 343
IF(FLIP(SIGNCD+1)==yes:) AA(J+5)=-AA(J+5)# Is hkl in rev. hemisphere    CP22 344
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP22 345
IF(GN>=MQ) BREAK#                                                       CP22 346
#                                                                       CP22 347
#  COUNT REFLECTION USAGE                                               CP22 348
#  ----------------------                                               CP22 349
#                                                                       CP22 350
100 CONTINUE#                                                           CP22 351
REFCNT(1)=REFCNT(1)+1.#                Count all bdf reflections        CP22 352
REFCNT(REJF)=REFCNT(REJF)+1.#          Count refl. by reject            CP22 353
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP22 354
#                                                                       CP22 355
IF(PASSES==1&DMP>1)#                   Only on last pass                CP22 356
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CP22 357
IF    (REFMOD==1)WRITE(6,*) "Using phased generator evals  ",REF#       CP22 358
ELSEIF(REFMOD==0)WRITE(6,*) 'Using frel for    evals >1.0   ',REF#      CP22 359
ELSEIF(MAPTYP!=vect:)WRITE(6,*) 'Using frel for all reflections ',REF#  CP22 360
ELSE         WRITE(6,*) 'Using erel for all reflections ',REF#          CP22 361
WRITE(6,*) 'Excluded reflections ',NINT(REFCNT(1))-REF#                 CP22 362
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CP22 363
#                                                                       CP22 364
#                                                                       CP22 365
#                                                                       CP22 366
CALL CP23#                             Set initial factor list          CP22 367
#                                                                       CP22 368
RETURN#                                                                 CP22 369
END#                                                                    CP22 370
systemheader:(CP23)#                                                    CP23   1
#******************************************************************#    CP23   2
#                                                                  #    CP23   3
#                              CP23                                #    CP23   4
#                                                                  #    CP23   5
#******************************************************************#    CP23   6
SUBROUTINE CP23#                                                        CP23   7
include:(AACOMN)#                                                       CP23   8
include:(CPCOMN)#                                                       CP23   9
#                                                                       CP23  10
# THIS PROGRAM FACTORS THE NUMBER OF POINTS ALONG AN AXIS, AND          CP23  11
# MAKES A TABLE OF POINTERS TCPT WILL BE USED TO UNSCRAMBLE THE ARRAY   CP23  12
# AFTER THE FFT CPS BEEN DONE.                                          CP23  13
# THE POINTERS ARE STORED IN THE FIRST N LOCATIONS AFTER START.  THE    CP23  14
# POINTERS ARE FOLLOWED BY THE FACTORS IN ORDER OF DECREASING MAGNITUDE CP23  15
# DOHERTY, 10/80                                                        CP23  16
#                                                                       CP23  17
INTEGER NTEST#                                                          CP23  18
INTEGER START#                         Pointer to place before begi     CP23  19
INTEGER I23#                           Index to tell whether 2nd or     CP23  20
INTEGER IS#                            End of key and factor list       CP23  21
INTEGER N#                             Number of grid points along      CP23  22
INTEGER I#                                                              CP23  23
INTEGER LK#                            Index for pointer table          CP23  24
INTEGER L#                             Index for loop that steps ov     CP23  25
INTEGER K#                             Index for loop that steps ov     CP23  26
INTEGER J#                             Index for factor list            CP23  27
REAL  ADD#                             Contribution to pointer from     CP23  28
REAL MULT#                             Multiplier for step size for     CP23  29
#                                                                       CP23  30
datastuff:#                                                             CP23  31
#                                                                       CP23  32
# THE FACTOR LIST MUST BE FOUND FOR BOTH THE SECOND AND THIRD SUMS.     CP23  33
# FIND THE FACTORS AND CONSTRUCT THE KEY NEEDED TO UNSCRAMBLE THE       CP23  34
# COMPLETED FOURIER TRANSFORM FOR THE TWO SUMS.                         CP23  35
#                                                                       CP23  36
K=MARKH+1#                             Begin by zeroing the locatio     CP23  37
DO J=K,STOPI#                          Do it for both 2nd and 3rd s     CP23  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP23  39
QX(J)=0.#                                                               CP23  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP23  41
START=MARKH#                           Do the key for the second su     CP23  42
IS=STOPH#                                                               CP23  43
FOR(I23=2;I23<=3;I23=I23+1)#                                            CP23  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP23  45
IF(I23==3)#                            If this is for 3rd sum, put      CP23  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP23  47
START=MARKI#                                                            CP23  48
IS=STOPI#                                                               CP23  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP23  50
N=NG(I23)#                             Pick up the number of grid p     CP23  51
#                                                                       CP23  52
#                                                                       CP23  53
# SET UP FOR FACTOR SEARCH                                              CP23  54
#                                                                       CP23  55
J=START+N+1#                           Pointer for factors              CP23  56
I=5#                                   First possible factor            CP23  57
MULT=1.#                               Multiplier is 1 for the firs     CP23  58
NTEST=N#                                                                CP23  59
#                                                                       CP23  60
# THE SEARCH FOR FACTORS WILL CONTINUE AS LONG AS ANY REMAIN.  AS EACH  CP23  61
# FACTOR IS FOUND, NTEST IS DIVIDED BY TCPT FACTOR.  WHEN NTEST IS 1, A CP23  62
# THE FACTORS CPVE BEEN FOUND.                                          CP23  63
# A PRELIMINARY SCREENING IN FS30 CPS ENSURED TCPT NG CONTAINS ONLY THE CP23  64
# PERMITTED FACTORS (I.E., 2,3,4 OR 5).                                 CP23  65
#                                                                       CP23  66
WHILE ((NTEST>1)&(I>=2))#              Go on until all factors are      CP23  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP23  68
IF(NTEST==(NTEST/I)*I)#                This is true if i is a facto     CP23  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP23  70
QX(J)=FLOAT(I)#                        Store the factor i in the fa     CP23  71
NTEST=NTEST/I#                         Remove this factor for next      CP23  72
J=J+1#                                 Increment index of factor ar     CP23  73
#                                                                       CP23  74
# BEGIN TO BUILD UP THE CONTRIBUTIONS TO THE KEY FOR UNSCRAMBLING THE   CP23  75
# COMPLETED TRANSFORM.  EACH FACTOR WILL MAKE A CONTRIBUTION TO EACH    CP23  76
# ITEM IN THE KEY.                                                      CP23  77
#                                                                       CP23  78
ADD=0.#                                                                 CP23  79
LK=START#                                                               CP23  80
DO L=1,N,NTEST#                                                         CP23  81
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP23  82
DO K=1,NTEST#                                                           CP23  83
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP23  84
LK=LK+1#                                                                CP23  85
QX(LK)=QX(LK)+ADD#                                                      CP23  86
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP23  87
ADD=AMOD(ADD+MULT,FLOAT(I)*MULT)#                                       CP23  88
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP23  89
MULT=MULT*FLOAT(I)#                                                     CP23  90
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP23  91
ELSE I=I-1#                            I was not a factor, so move      CP23  92
IF(J>IS) iquit:(CP2301)#               Don't allow more factors tha     CP23  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP23  94
#                                                                       CP23  95
#                                                                       CP23  96
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP23  97
RETURN#                                                                 CP23  98
END#                                                                    CP23  99
systemheader:(CP25)#                                                    CP25   1
# ################################################################## #  CP25   2
#                                                                    #  CP25   3
#                               CP25                                 #  CP25   4
#                                                                    #  CP25   5
# ################################################################## #  CP25   6
SUBROUTINE CP25#                       Part 6-second and third sums     CP25   7
include:(AACOMN)#                      J.m.stewart,j.r.holden 1981      CP25   8
include:(CPCOMN)#                      R.doherty, s.r.hall 1982         CP25   9
#                                                                       CP25  10
# APPLY FFT SECOND AND THIRD SUMS USING THE COEFFICIENTS WHICH WERE     CP25  11
# PRODUCED BY THE FIRST SUM PROGRAM CP22.  THE SECOND SUM COEFFICIENTS  CP25  12
# (FIRST SUM RESULTS) WHICH CAN BE HELD IN IMMEDIATE ACCESS STORAGE ARE CP25  13
# TREATED.  THE PROGRAM IS A DRASTIC RECODING OF FS60 OF XTAL.          CP25  14
#                            J.STEWART AND R. DOHERTY , NOV. 1980       CP25  15
#                                                                       CP25  16
# IN THIS VERSION THE THIRD SUM IS DONE BY THE FAST FOURIER TRANSFORM   CP25  17
# ALGORITHM.                                                            CP25  18
# IN FS60, THE THIRD SUM TO YIELD THE ELECTRON DENSITY (RHO) MAY BE     CP25  19
# EXPRESSED AS-                                                         CP25  20
#    RHO(X1,X2,X3)=SUM[D1*COS(2PI*I*H3*X3)]+SUM[D2*SIN(2PI*I*H3*X3)]    CP25  21
# THIS IS EQUIVALENT TO                                                 CP25  22
#                                                                       CP25  23
#    RHO(X1,X2,X3)=RE(SUM[(D1-I*D2)*EXP(2PI*I*H3*X3)]                   CP25  24
#                                                                       CP25  25
# THIS IS THE SUMMATION DONE BY THE FFT.  NOTICE TCPT                   CP25  26
# (1) THE COEFFICIENT IN THE FFT IS D1 MINUS I*D2 (NOT PLUS)            CP25  27
#     THEREFORE THE "IMAGINARY" PARTS OF THE COEFFICIENTS FROM THE      CP25  28
#     SECOND SUM ARE STORED AS THE NEGATIVE OF THE VALUE FROM THE SUM.  CP25  29
# (2) ONLY THE REAL PART OF THE TRANSFORM CORRESPONDS TO THE ELECTRON   CP25  30
#     DENSITY.                                                          CP25  31
#                                                                       CP25  32
# R. DOHERTY, 11-80                                                     CP25  33
# QX(MARK1+1)    THE MARK1 ARRAY IS THE INTERLEAVED COS AND SIN STRIP   CP25  34
# QX(MARK1+2)    FOR FIRST SUM STEP1=2                                  CP25  35
# QX(MARK2+1)    TRIG TABLES FOR SECOND SUM S. MARK2=MARK1              CP25  36
# QX(MARK2+2)                                                           CP25  37
# QX(MARKI+1)      THE MARKI ARRAY IS THE KEY FOR UNSCRAMBLING THE RESU CP25  38
#                  OF THE FFT, FOLLOWED BY THE LIST OF FACTORS OF NG3   CP25  39
# QX(MARKL+1)    THE MARKL ARRAY CONTAINS THE FIRST SUM RESULTS WHICH   CP25  40
# QX(MARKL+2)    SERVE AS COEFFICIENTS OF THE SECOND SUM . STEPL=4      CP25  41
# QX(MARKL+3)                        #                                  CP25  42
# QX(MARKL+4)                        #                                  CP25  43
# QX(MARKJ+1)    THE MARKJ ARRAY CONTAINS SECOND SUM RESULTS WHICH      CP25  44
# QX(MARKJ+2)    SERVE AS THE THIRD SUM COEFFICIENTS. STEPJ=2           CP25  45
# QX(MARKK+1)    THE FINAL RESULT FOR ONE LINE OF THE TRANSFORM #       CP25  46
#                                                                       CP25  47
INTEGER LW,PSIZ,IX1,IX2#                                                CP25  48
INTEGER IORGX1,IORGX2#                                                  CP25  49
INTEGER STPSIZ#                        Step size over each coeffici     CP25  50
INTEGER KK,JJ#                                                          CP25  51
INTEGER L,M,N#                                                          CP25  52
INTEGER ND,PRORG#                      Factor to be used in denom o     CP25  53
INTEGER INCX1,INCX2,INCX3,NG1,NG2,NG3,NP1,NP2,NP3#                      CP25  54
INTEGER J,I,I3,IH2M,K,I3P,IH3M#        Fs70  56                         CP25  55
INTEGER THSTEP#                        Step over lines of coefficie     CP25  56
INTEGER M1,M2,M3#                                                       CP25  57
INTEGER LAY,LIN#                                                        CP25  58
#                                                                       CP25  59
datastuff:#                                                             CP25  60
#                                                                       CP25  61
#   PREPARE SUMMATION PARAMETERS                                        CP25  62
#   ----------------------------                                        CP25  63
#                                                                       CP25  64
INCX1=INCX(1); INCX2=INCX(2); INCX3=INCX(3)#                            CP25  65
IORGX1=INORGX1#                                                         CP25  66
IORGX2=ORGX(2)#                                                         CP25  67
NG1=NG(1); NG2=NG(2); NG3=NG(3)#                                        CP25  68
NP1=NPP1; NP2=NP(2); NP3=NP(3)#        Cp                               CP25  69
IH2M=STEPL*NG2#                        Step over single values of h     CP25  70
IH3M=2*NG3#                                                             CP25  71
PRORG=MARKK+ORGX(3)#                   Pt before the first print po     CP25  72
LW=MARKK+NG3#                          Figure length needed for one     CP25  73
J=MARKL-IH2M#                          Set second sum coefficient       CP25  74
PSIZ=NP3#                              Set packet size for special      CP25  75
THSTEP=IH3M*INCX2#                                                      CP25  76
LAY=IORGX1#                                                             CP25  77
IF(NP2>NG2)NP2=NP2-1#                  This many actual interations     CP25  78
#                                                                       CP25  79
#                                                                       CP25  80
#                                                                       CP25  81
# SCAN OVER ALL LAYERS WITH FIRST SUM COEFFICIENTS STORED IN CORE       CP25  82
# ---------------------------------------------------------------       CP25  83
#                                                                       CP25  84
#                                                                       CP25  85
DO IX1=1,NP1#                          Do all layers possible on        CP25  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP25  87
M3=MARKC; M2=MARKD;M1=MARKE#           Initialize buffer pointers       CP25  88
LIN=-1#                                Detain lin until 2nd buffer      CP25  89
DO I=MARKJ,STOPJ; QX(I+1)=0.#          Clear third sum coeff table      CP25  90
I3P=MARKJ+2*(IH3MAX-1)#                                                 CP25  91
STPSIZ=STEPL#                                                           CP25  92
#                                                                       CP25  93
# START OF SECOND SUM                                                   CP25  94
# -------------------                                                   CP25  95
#                                                                       CP25  96
DO I3=MARKJ,I3P,2#                     Scan through all h3              CP25  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP25  98
ND=NG2#                                                                 CP25  99
I=MARKH+NG2+1; J=J+IH2M#                                                CP25 100
CALL CP31(I,J,ND,STPSIZ)#                                               CP25 101
I=MARKH+NG2+1#                                                          CP25 102
KK=J+2; ND=NG2#                                                         CP25 103
CALL CP31(I,KK,ND,STPSIZ)#                                              CP25 104
I=MARKH; KK=J-3; JJ=KK+2#                                               CP25 105
DO L=1,NG2#                                                             CP25 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP25 107
I=I+1#                                                                  CP25 108
KK=KK+STEPL; JJ=JJ+STEPL#                                               CP25 109
N=I3+NINT(QX(I))*IH3M#                                                  CP25 110
QX(N+1)=QX(KK); QX(N+2)=-QX(JJ)#                                        CP25 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP25 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP25 113
#                                                                       CP25 114
#                                                                       CP25 115
K=MARKJ+IH3M*(IORGX2-INCX2)#           Start of third sum coeff         CP25 116
STPSIZ=STEPJ#                                                           CP25 117
#                                                                       CP25 118
#  LOOP OVER SECOND SUM POINTS                                          CP25 119
#  ---------------------------                                          CP25 120
#                                                                       CP25 121
DO IX2=1,NP2#                          Loop over all second sum poi     CP25 122
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP25 123
DO I3=MARKK,LW;  QX(I3+1)=0.#          Clear third sum line             CP25 124
#                                                                       CP25 125
# DO SUM BY FFT AND SORT IT INTO QX(MARKK+1) ET SEQ.                    CP25 126
# BEFORE THE FIRST STEP OF THE FFT IS BEGUN, EACH PAIR OF WORDS STARTIN CP25 127
# IN QX(MARKJ+1) CONTAINS THE CONTRIBUTION FROM REFLECTIONS WITH ONE    CP25 128
# VALUE OF H(3).  THEREFORE IN ORDER TO DO THE TRANSFORMATION, A        CP25 129
# CONTRIBUTION MUST BE ADDED IN FROM EACH OF THE NG(3) PAIRS FOR EACH   CP25 130
# POINT.  AFTER A CYCLE OF THE FFT USING FACTOR F, THERE ARE CONTRIBUTI CP25 131
# FROM F VALUES OF H(3), SO ONE NEED ONLY ADD THE CONTRIBUTIONS FROM NG CP25 132
# PAIRS.  IN GENERAL, NG(3)/NSUMS PAIRS MUST BE ADDED TO GIVE THE COMPL CP25 133
# TRANSFORM.                                                            CP25 134
#                                                                       CP25 135
ND=NG3#                                                                 CP25 136
I=MARKI+NG3+1#                         Start of factor list             CP25 137
K=K+THSTEP#                                                             CP25 138
CALL CP31(I,K,ND,STPSIZ)#                                               CP25 139
#                                                                       CP25 140
# AT THIS POINT THE VALUES OF THE TRANSFORM AT THE NG(3) POINTS OF THE  CP25 141
# CURRENT LINE ARE SCRAMBLED IN THE QX ARRAY.  THE KEY FOR UNSCRAMBLING CP25 142
# BEGIN IN QX(MARKI+1). THE ELEMENTS IN THE MARKI PORTION POINT TO      CP25 143
# WHERE THE ELEMENTS IN THE MARKJ PORTION BELONG IN THE UNSCRAMBLED     CP25 144
# ARRAY.                                                                CP25 145
#                                                                       CP25 146
I=MARKI; KK=K-1; N=MARKK+1#                                             CP25 147
DO L=1,NG3#                            Loop over the ng(3) points       CP25 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP25 149
I=I+1; KK=KK+2#                        Step by 2, getting only real     CP25 150
M=N+NINT(QX(I))#                       Find where qx(kk) properly b     CP25 151
QX(M)=QX(KK)#                          Put it there                     CP25 152
DENMAX=MAX(DENMAX,QX(M))#              Get maximum density              CP25 153
DENMIN=MIN(DENMIN,QX(M))#              Get minimum density              CP25 154
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP25 155
#                                                                       CP25 156
#   PASS DENSITY ROW TO PEKPIK                                          CP25 157
#   --------------------------                                          CP25 158
#                                                                       CP25 159
movereal:(QX,MARKK+1,QX,M3+1,NG3,1)#   Copy density row to buffer       CP25 160
QX(M3+NG3+1)=QX(M3+1)#                 Copy first point to last         CP25 161
#WRITE(6,'(10F6.3)')(QX(PRORG+I),I=1,NG3+1)                             CP25 162
IF(LIN>=IORGX2) CALL CP36(M1,M2,M3,LAY,LIN)# Pekpik - pick density pe   CP25 163
ELSE movereal:(QX,M3+1,QX,MARKC1+1,NG3+1,1)# Save first line until en   CP25 164
L=M1;M1=M2;M2=M3;M3=L#                 Rotate buffer pointers           CP25 165
LIN=LIN+1#                             Increment row count              CP25 166
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP25 167
IF(NP2>=NG2)#                          Copy first buffer to last        CP25 168
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP25 169
movereal:(QX,MARKC1+1,QX,M3+1,NG3+1,1)# Append first line at end        CP25 170
CALL CP36(M1,M2,M3,LAY,LIN)#           Pekpik scan last 3 buffer        CP25 171
L=M1;M1=M2;M2=M3;M3=L#                 Rotate buffer pointers           CP25 172
LIN=LIN+1#                             Increment row count              CP25 173
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP25 174
CALL CP36(M1,M2,M3,LAY,LIN)#           Pekpik scan for last 2 buffers   CP25 175
LAY=LAY+1#                             Increment layer count            CP25 176
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP25 177
#                                                                       CP25 178
RETURN#                                                                 CP25 179
END#                                                                    CP25 180
systemheader:(CP31)#                                                    CP31   1
# ####################################################################  CP31   2
#                                                                       CP31   3
#                                   CP31                                CP31   4
#                                                                       CP31   5
# ####################################################################  CP31   6
SUBROUTINE CP31(I,K,ND,STPSIZ)#                                         CP31   7
include:(AACOMN)#                                                       CP31   8
include:(CPCOMN)#                                                       CP31   9
#                                                                       CP31  10
INTEGER I#                             Pointer to factor list           CP31  11
INTEGER F#                             Current factor                   CP31  12
INTEGER K#                             Pointer to start of transfor     CP31  13
INTEGER ND#                            Denominator for exp. q term      CP31  14
INTEGER NF#                            No. of pairs to be considere     CP31  15
INTEGER NSEP#                          Separation between start of      CP31  16
INTEGER K1,K2,K3,K4,K5#                Start of small sums              CP31  17
INTEGER NSUMS#                         No. of small sums                CP31  18
INTEGER STPSIZ#                        Spacing between "real" parts     CP31  19
#                                                                       CP31  20
NF=ND#                                                                  CP31  21
NSUMS=1#                                                                CP31  22
REPEAT#                                                                 CP31  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP31  24
F=NINT(QX(I))#                         Make factor an integer           CP31  25
IF(F==0) BREAK#                        Zero factor marks end of lis     CP31  26
NF=NF/F#                                                                CP31  27
NSEP=STPSIZ*NF#                        Separation between start of      CP31  28
K1=K+1#                                Set pointers for beginnings      CP31  29
K2=K1+NSEP#                                                             CP31  30
#                                                                       CP31  31
# THERE IS A SEPARATE SUBROUTINE TO CPNDLE EACH OF THE FACTORS.         CP31  32
#                                                                       CP31  33
IF(F==2)#                                                               CP31  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP31  35
CALL CP32(QX(K1),QX(K2),NSUMS,ND,NF,STPSIZ)#                            CP31  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP31  37
ELSE IF(F==3)#                                                          CP31  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP31  39
K3=K2+NSEP#                            Set third pointer                CP31  40
CALL CP33(QX(K1),QX(K2),QX(K3),NSUMS,ND,NF,STPSIZ)#                     CP31  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP31  42
ELSE IF(F==4)#                                                          CP31  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP31  44
K3=K2+NSEP#                                                             CP31  45
K4=K3+NSEP#                                                             CP31  46
CALL CP34(QX(K1),QX(K2),QX(K3),QX(K4),NSUMS,ND,NF,STPSIZ)#              CP31  47
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP31  48
ELSE IF(F==5)#                                                          CP31  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP31  50
K3=K2+NSEP#                                                             CP31  51
K4=K3+NSEP#                                                             CP31  52
K5=K4+NSEP#                                                             CP31  53
CALL CP35(QX(K1),QX(K2),QX(K3),QX(K4),QX(K5),NSUMS,ND,NF,STPSIZ)#       CP31  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP31  55
ND=ND/F#                                                                CP31  56
NSUMS=NSUMS*F#                                                          CP31  57
I=I+1#                                 Move on to next factor           CP31  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP31  59
RETURN#                                                                 CP31  60
END#                                                                    CP31  61
systemheader:(CP32)#                                                    CP32   1
#******************************************************************#    CP32   2
#                                                                  #    CP32   3
#                              CP32                                #    CP32   4
#                                                                  #    CP32   5
#******************************************************************#    CP32   6
SUBROUTINE CP32(FHZ,FH1,NSUMS,ND,NF,STPSIZ)#                            CP32   7
include:(AACOMN)#                                                       CP32   8
include:(CPCOMN)#                                                       CP32   9
#                                                                       CP32  10
# THE SUMMATION PERFORMED IS                                            CP32  11
#  [SUM (H=0,1)[F*EXP(2PI*I*(1/2)*H*M)]]*EXP(2PI*I*(Q/ND)*M)            CP32  12
#                                                                       CP32  13
# NOTE TCPT THE FIRST EXPONENTIAL TERM IS EITHER+OR-1 DEPENDING ON THE  CP32  14
# PARITY OF THE PRODUCT H*M. M MAY TAKE ON THE VALUES 0 AND 1.  THE F V CP32  15
# FOR H=0 ARE IN FHZ, AND FOR H=1 IN FH1.  THE RESULTS OF THE SUM FOR M CP32  16
# ARE IN FHZ AND FOR M=1 IN FH1.  THERE ARE NSUMS MAJOR SEGMENTS AND WI CP32  17
# EACH SEGMENT Q RUNS FROM 0 TO (NF-1).  THIS MEANS TCPT EVERY POINT IS CP32  18
# TREATED IN ONE CYCLE THROUGH THE SUBROUTINE SINCE NSUMS*NF*2=NP(3).   CP32  19
#                                                                       CP32  20
INTEGER K#                                                              CP32  21
INTEGER N#                                                              CP32  22
INTEGER STPSIZ#                        Step size over each coeffici     CP32  23
INTEGER J#                                                              CP32  24
INTEGER JP#                                                             CP32  25
INTEGER STEP#                          Step size over major segment     CP32  26
INTEGER NF#                                                             CP32  27
INTEGER ND#                                                             CP32  28
INTEGER NSUMS#                                                          CP32  29
REAL FHZ(*),FH1(*)#                    Coefficients for sums            CP32  30
REAL EXP#                              Second exponential term          CP32  31
REAL R1,I1#                            Re and im parts before jp ph     CP32  32
REAL PHI,CPHI,SPHI#                    Angle,sin,and cos for jp ter     CP32  33
realdata:(TWOPI,6.28318)#                                               CP32  34
datastuff:#                                                             CP32  35
#                                                                       CP32  36
STEP=ND*STPSIZ#                                                         CP32  37
K=-STEP#                                                                CP32  38
EXP=1./FLOAT(ND)*TWOPI#                                                 CP32  39
DO N=1,NSUMS#                                                           CP32  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP32  41
K=K+STEP#                                                               CP32  42
J=K-STPSIZ#                                                             CP32  43
PHI=-EXP#                                                               CP32  44
DO JP=1,NF#                            Do sums within each segment      CP32  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP32  46
PHI=PHI+EXP#                                                            CP32  47
J=J+STPSIZ#                                                             CP32  48
#                                                                       CP32  49
# SINCE M=0 FOR THE SUM STORED IN FHZ, IT IS SIMPLY THE SUM OF THE      CP32  50
# COEFFICIENTS IN FHZ AND FH1. SINCE M=1 FOR THE SUM STORED IN FH1,     CP32  51
# THE FIRST TERM IS POSITIVE (H=0) AND THE SECOND TERM IS NEGATIVE (H=1 CP32  52
# SO H*M IS ODD). THE SUM IS STORED TEMPORARILY IN R1 (REAL) AND I1     CP32  53
# (IMAGINARY) BEFORE THE EXPONENTIAL JP TERM IS APPLIED.                CP32  54
#                                                                       CP32  55
R1=FHZ(J+1)-FH1(J+1)#                                                   CP32  56
I1=FHZ(J+2)-FH1(J+2)#                                                   CP32  57
FHZ(J+1)=FHZ(J+1)+FH1(J+1)#                                             CP32  58
FHZ(J+2)=FHZ(J+2)+FH1(J+2)#                                             CP32  59
IF(JP!=1)#                                                              CP32  60
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP32  61
CPHI=COS(PHI)#                                                          CP32  62
SPHI=SIN(PHI)#                                                          CP32  63
FH1(J+1)=R1*CPHI-I1*SPHI#                                               CP32  64
FH1(J+2)=R1*SPHI+I1*CPHI#                                               CP32  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP32  66
ELSE#                                                                   CP32  67
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP32  68
FH1(J+1)=R1#                                                            CP32  69
FH1(J+2)=I1#                                                            CP32  70
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP32  71
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP32  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP32  73
RETURN#                                                                 CP32  74
END#                                                                    CP32  75
systemheader:(CP33)#                                                    CP33   1
#******************************************************************#    CP33   2
#                                                                  #    CP33   3
#                              CP33                                #    CP33   4
#                                                                  #    CP33   5
#******************************************************************#    CP33   6
SUBROUTINE CP33(FHZ,FH1,FH2,NSUMS,ND,NF,STPSIZ)#                        CP33   7
include:(AACOMN)#                                                       CP33   8
include:(CPCOMN)#                                                       CP33   9
#                                                                       CP33  10
# THE SUMMATION PERFORMED IS                                            CP33  11
#                                                                       CP33  12
# [SUM(H=0 TO 2)[F*EXP(2PI*I*(1/3)*H*M)]]*EXP(2PI*I*(Q/ND)*M)           CP33  13
#                                                                       CP33  14
# M MAY CPVE THE VALUES 0,1, AND 2. THE F VALUES FOR H=0 ARE IN FHZ, FO CP33  15
# H=1 IN FH1, AND FOR H=2 IN FH2. THE RESULTS OF THE SUM FOR M=0 ARE ST CP33  16
# IN FHZ, FOR M=1 IN FH1, AND FOR M=2 IN FH2.  THERE ARE NSUMS MAJOR SE CP33  17
# AND WITHIN EACH SEGMENT Q RUNS FROM 0 TO NF-1.  THIS MEANS TCPT EVERY CP33  18
# IS TREATED IN ONE CYCLE THROUGH THE SUBROUTINE SINCE NSUMS*NF*3=NP(3) CP33  19
# DOHERTY, 11-80                                                        CP33  20
#                                                                       CP33  21
INTEGER STEP#                          Step size over major segment     CP33  22
INTEGER STPSIZ#                        Step size over each coeffiec     CP33  23
INTEGER JP#                            Index of loop within major s     CP33  24
INTEGER J#                                                              CP33  25
INTEGER ND#                                                             CP33  26
INTEGER NF#                                                             CP33  27
INTEGER NSUMS#                                                          CP33  28
INTEGER K#                                                              CP33  29
INTEGER N#                                                              CP33  30
REAL R1,R2,I1,I2#                      Re and im parts before q pha     CP33  31
REAL FHZ(*),FH1(*),FH2(*)#             Coefficients for sums            CP33  32
REAL PHI#                                                               CP33  33
REAL CPHI,SPHI#                        Cos and sin of q term for m=     CP33  34
REAL C2PHI,S2PHI#                      Cos and sin of q term for m=     CP33  35
REAL EXP#                              Second exponential term          CP33  36
REAL AC,AS,BC,BS#                      Re and im contrib. to r1,r2,     CP33  37
realdata:(C1,-.5);  realdata:(S1,.8660254)#                             CP33  38
realdata:(TWOPI,6.28318)#                                               CP33  39
datastuff:#                                                             CP33  40
#                                                                       CP33  41
STEP=ND*STPSIZ#                        Factor of 2 for 3rd sum, 4 f     CP33  42
K=-STEP#                               Set pointer to step over maj     CP33  43
EXP=1./FLOAT(ND)*TWOPI#                                                 CP33  44
DO N=1,NSUMS#                          Loop over major segments         CP33  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP33  46
K=K+STEP#                                                               CP33  47
J=K-STPSIZ#                                                             CP33  48
PHI=-EXP#                                                               CP33  49
DO JP=1,NF#                            Do sums within each segment      CP33  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP33  51
J=J+STPSIZ#                                                             CP33  52
PHI=PHI+EXP#                                                            CP33  53
#                                                                       CP33  54
# RECALL TCPT COS(2*PI/3)=COS(4*PI/3) AND SIN(2*PI/3)=-SIN(4*PI/3)      CP33  55
#                                                                       CP33  56
AC=(FH1(J+1)+FH2(J+1))*C1#                                              CP33  57
BS=(FH1(J+2)-FH2(J+2))*S1#                                              CP33  58
AS=(FH1(J+1)-FH2(J+1))*S1#                                              CP33  59
BC=(FH1(J+2)+FH2(J+2))*C1#                                              CP33  60
R1=FHZ(J+1)+AC-BS#                                                      CP33  61
I1=FHZ(J+2)+AS+BC#                                                      CP33  62
R2=FHZ(J+1)+AC+BS#                                                      CP33  63
I2=FHZ(J+2)-AS+BC#                                                      CP33  64
FHZ(J+1)=FHZ(J+1)+FH1(J+1)+FH2(J+1)#   M=0 term (see comment above)     CP33  65
FHZ(J+2)=FHZ(J+2)+FH1(J+2)+FH2(J+2)#                                    CP33  66
IF(JP==1)#                             No exponential term if q=0       CP33  67
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP33  68
FH1(J+1)=R1#                                                            CP33  69
FH1(J+2)=I1#                                                            CP33  70
FH2(J+1)=R2#                                                            CP33  71
FH2(J+2)=I2#                                                            CP33  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP33  73
ELSE#                                  If necessary, apply exp for      CP33  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP33  75
CPHI=COS(PHI)#                         Phase for m=1 (see comment a     CP33  76
SPHI=SIN(PHI)#                                                          CP33  77
C2PHI=CPHI**2-SPHI**2#                 Phase for m=2 term               CP33  78
S2PHI=2.*CPHI*SPHI#                                                     CP33  79
FH1(J+1)=R1*CPHI-I1*SPHI#                                               CP33  80
FH1(J+2)=R1*SPHI+I1*CPHI#                                               CP33  81
FH2(J+1)=R2*C2PHI-I2*S2PHI#                                             CP33  82
FH2(J+2)=R2*S2PHI+I2*C2PHI#                                             CP33  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP33  84
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP33  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP33  86
RETURN#                                                                 CP33  87
END#                                                                    CP33  88
systemheader:(CP34)#                                                    CP34   1
#******************************************************************#    CP34   2
#                                                                  #    CP34   3
#                              CP34                                #    CP34   4
#                                                                  #    CP34   5
#******************************************************************#    CP34   6
SUBROUTINE CP34(FZERO,F1,F2,F3,NSUMS,ND,NF,STPSIZ)#                     CP34   7
include:(AACOMN)#                                                       CP34   8
include:(CPCOMN)#                                                       CP34   9
#                                                                       CP34  10
# THE SUMMATION PERFORMED IS                                            CP34  11
#                                                                       CP34  12
#  T(Q,M)=[SUM (H=0 TO 3)[F*EXP(2PI*(1/4)*H*M)]]*EXP(2PI*I*(Q/ND)*M)    CP34  13
#                                                                       CP34  14
# M MAY CPVE THE VALUES 0,1,2 OR 3.  THE F VALUES FOR H=0 ARE IN FZERO, CP34  15
# H=1 IN F1, FOR H=2 IN F2 AND FOR H=3 IN F3. THE T(Q,M) ARE STORED IN  CP34  16
# FZERO(Q+1) FOR M=0, IN F1(Q+1) FOR M=1, IN F2(Q+1) FOR M=2 AND IN F3( CP34  17
# FOR M=3.  Q RUNS FROM 0 TO NF-1.                                      CP34  18
#                                                                       CP34  19
INTEGER NSUMS#                                                          CP34  20
INTEGER STPSIZ#                                                         CP34  21
INTEGER ND#                                                             CP34  22
INTEGER NF#                                                             CP34  23
INTEGER J,JP#                                                           CP34  24
INTEGER N#                                                              CP34  25
INTEGER K#                                                              CP34  26
INTEGER STEP#                                                           CP34  27
REAL EXP#                              Second exponential term          CP34  28
REAL FZERO(*),F1(*),F2(*),F3(*)#       Vide supra                       CP34  29
REAL PHI,CPHI,SPHI#                    Angle, cos and sin for 2nd e     CP34  30
REAL C2PHI,S2PHI#                      As for cphi, but m=2             CP34  31
REAL C3PHI,S3PHI#                      As for cphi, but m=3             CP34  32
REAL ASUMZ,ASUM1,BSUMZ,BSUM1#          Intermediate stages of summa     CP34  33
REAL AEVEN,AODD,BEVEN,BODD#            Intermediate stages of summa     CP34  34
REAL R1,I1,R2,I2,R3,I3#                Summation before applying ex     CP34  35
realdata:(TWOPI,6.28318)#                                               CP34  36
datastuff:#                                                             CP34  37
#                                                                       CP34  38
EXP=1./FLOAT(ND)*TWOPI#                                                 CP34  39
STEP=STPSIZ*ND#                                                         CP34  40
K=-STEP#                                                                CP34  41
DO N=1,NSUMS#                                                           CP34  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP34  43
K=K+STEP#                                                               CP34  44
J=K-STPSIZ#                                                             CP34  45
PHI=-EXP#                                                               CP34  46
DO JP=1,NF#                                                             CP34  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP34  48
J=J+STPSIZ#                                                             CP34  49
PHI=PHI+EXP#                                                            CP34  50
#                                                                       CP34  51
# FOR H=0, THE FIRST EXPONENTIAL TERM IS ALWAYS+1. FOR H=2, THE FIRST   CP34  52
# EXPONENTIAL TERM IS+1 IF M IS EVEN AND-1 IF M IS ODD.  FOR H=1 OR 3,  CP34  53
# ONLY THE IMAGINARY PART OF THE COEFFICIENT WILL CONTRIBUTE TO THE RAL CP34  54
# OF THE PORDUCT WHEN M=1 OR 3, SINCE COS(2PI/4)=COS(3*2PI/4)=0.        CP34  55
# WHEN M=2, ONLY THE REAL PARTS OF ALL FOUR COEFFICIENTS CONTRIBUTE TO  CP34  56
# REAL PART OF THE SUM.                                                 CP34  57
#                                                                       CP34  58
AEVEN=FZERO(J+1)-F2(J+1)#                                               CP34  59
AODD=F1(J+1)-F3(J+1)#                                                   CP34  60
BEVEN=FZERO(J+2)-F2(J+2)#                                               CP34  61
BODD=F1(J+2)-F3(J+2)#                                                   CP34  62
ASUMZ=FZERO(J+1)+F2(J+1)#                                               CP34  63
ASUM1=F1(J+1)+F3(J+1)#                                                  CP34  64
BSUMZ=FZERO(J+2)+F2(J+2)#                                               CP34  65
BSUM1=F1(J+2)+F3(J+2)#                                                  CP34  66
#                                                                       CP34  67
R1=AEVEN-BODD#                                                          CP34  68
I1=BEVEN+AODD#                                                          CP34  69
R2=ASUMZ-ASUM1#                                                         CP34  70
I2=BSUMZ-BSUM1#                                                         CP34  71
R3=AEVEN+BODD#                                                          CP34  72
I3=BEVEN-AODD#                                                          CP34  73
#                                                                       CP34  74
FZERO(J+1)=ASUMZ+ASUM1#                                                 CP34  75
FZERO(J+2)=BSUMZ+BSUM1#                                                 CP34  76
IF(JP!=1)#                                                              CP34  77
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP34  78
CPHI=COS(PHI)#                                                          CP34  79
SPHI=SIN(PHI)#                                                          CP34  80
C2PHI=CPHI**2-SPHI**2#                                                  CP34  81
S2PHI=2.*CPHI*SPHI#                                                     CP34  82
C3PHI=CPHI*C2PHI-SPHI*S2PHI#                                            CP34  83
S3PHI=CPHI*S2PHI+SPHI*C2PHI#                                            CP34  84
F1(J+1)=R1*CPHI-I1*SPHI#                                                CP34  85
F1(J+2)=R1*SPHI+I1*CPHI#                                                CP34  86
F2(J+1)=R2*C2PHI-I2*S2PHI#                                              CP34  87
F2(J+2)=R2*S2PHI+I2*C2PHI#                                              CP34  88
F3(J+1)=R3*C3PHI-I3*S3PHI#                                              CP34  89
F3(J+2)=R3*S3PHI+I3*C3PHI#                                              CP34  90
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP34  91
ELSE#                                                                   CP34  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP34  93
F1(J+1)=R1#                                                             CP34  94
F1(J+2)=I1#                                                             CP34  95
F2(J+1)=R2#                                                             CP34  96
F2(J+2)=I2#                                                             CP34  97
F3(J+1)=R3#                                                             CP34  98
F3(J+2)=I3#                                                             CP34  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP34 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP34 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP34 102
RETURN#                                                                 CP34 103
END#                                                                    CP34 104
systemheader:(CP35)#                                                    CP35   1
#**************************************************************#        CP35   2
#                                                              #        CP35   3
#                            CP35                              #        CP35   4
#                                                              #        CP35   5
#**************************************************************#        CP35   6
SUBROUTINE CP35(FZERO,F1,F2,F3,F4,NSUMS,ND,NF,STPSIZ)#                  CP35   7
include:(AACOMN)#                                                       CP35   8
include:(CPCOMN)#                                                       CP35   9
#                                                                       CP35  10
# THE SUMMATION PREFORMED IS                                            CP35  11
#                                                                       CP35  12
# T(Q,M)=[SUM (H=0 TO 4)[F*EXP(2PI*I*H*M)]]*EXP(2PI*I*(Q/ND)*M)         CP35  13
#                                                                       CP35  14
# M MAY CPVE THE VALUES 0,1,2,3 AND 4.  THE F VALUES FOR H=0 ARE IN     CP35  15
# FZERO, FOR H=1 IN F1, FOR H=2 IN F2, FOR H=3 IN F3, AND FOR H=4 IN F4 CP35  16
# THE T(Q,M) ARE STORED IN FZERO(Q+1) FOR M=0, IN F1(Q+1) FOR M=1, IN   CP35  17
# F2(Q+2) FOR M=2, IN F3(Q+1) FOR M=3 AND IN F4(Q+1) FOR M=4.  Q RUNS   CP35  18
# FROM 0 TO (NF-1).                                                     CP35  19
#                                                                       CP35  20
INTEGER J#                                                              CP35  21
INTEGER JP#                                                             CP35  22
INTEGER K#                                                              CP35  23
INTEGER N#                                                              CP35  24
INTEGER ND#                                                             CP35  25
INTEGER NF#                                                             CP35  26
INTEGER NSUMS#                                                          CP35  27
INTEGER STPSIZ#                                                         CP35  28
INTEGER STEP#                                                           CP35  29
REAL ASUM1,ASUM2,ADIF1,ADIF2#                                           CP35  30
REAL AOC,AEC,AOS,AES#                                                   CP35  31
REAL BSUM1,BSUM2,BDIF1,BDIF2#                                           CP35  32
REAL BOC,BEC,BOS,BES#                                                   CP35  33
REAL FZERO(*),F1(*),F2(*),F3(*),F4(*)#                                  CP35  34
REAL R1,I1,R2,I2,R3,I3,R4,I4#                                           CP35  35
REAL EXP#                                                               CP35  36
REAL PHI,CPHI,SPHI#                                                     CP35  37
REAL C2PHI,S2PHI#                                                       CP35  38
REAL C3PHI,S3PHI#                                                       CP35  39
REAL C4PHI,S4PHI#                                                       CP35  40
realdata:(TWOPI,6.28318)#                                               CP35  41
realdata:(C1,0.30901699);  realdata:(S1,0.95105652)#                    CP35  42
realdata:(C2,-0.80901699);  realdata:(S2,0.58778525)#                   CP35  43
datastuff:#                                                             CP35  44
#                                                                       CP35  45
STEP=STPSIZ*ND#                                                         CP35  46
K=-STEP#                                                                CP35  47
EXP=1./FLOAT(ND)*TWOPI#                                                 CP35  48
DO N=1,NSUMS#                                                           CP35  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP35  50
K=K+STEP#                                                               CP35  51
J=K-STPSIZ#                                                             CP35  52
PHI=-EXP#                                                               CP35  53
DO JP=1,NF#                                                             CP35  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP35  55
J=J+STPSIZ#                                                             CP35  56
PHI=PHI+EXP#                                                            CP35  57
#                                                                       CP35  58
# RECALL TCPT COS(2PI/5)=COS(4*2PI/5) , AND SIN(2PI/5)=-SIN(4*2PI/5) .  CP35  59
# ALSO COS(2*2PI/5)=COS(3*2PI/5) AND SIN(2*2PI/5)=-SIN(3*2PI/5).        CP35  60
# IN THE FOLLOWING, CERTAIN TERMS ARE GROUPED TOGETHER TO SIMPLIFY THE  CP35  61
# ACTUAL SUMMATION INDICATED IN THE OPENING COMMENT.  ALL THE A TERMS R CP35  62
# TO THE REAL PARTS OF THE COEFFICIENTS, AND THE B TERMS REFER TO THE   CP35  63
# IMAGINARY PARTS.                                                      CP35  64
#                                                                       CP35  65
ASUM1=F1(J+1)+F4(J+1)#                                                  CP35  66
ASUM2=F2(J+1)+F3(J+1)#                                                  CP35  67
ADIF1=F1(J+1)-F4(J+1)#                                                  CP35  68
ADIF2=F2(J+1)-F3(J+1)#                                                  CP35  69
AEC=FZERO(J+1)+ASUM1*C1+ASUM2*C2#                                       CP35  70
AOC=FZERO(J+1)+ASUM1*C2+ASUM2*C1#                                       CP35  71
AES=ADIF1*S1+ADIF2*S2#                                                  CP35  72
AOS=ADIF1*S2-ADIF2*S1#                                                  CP35  73
#                                                                       CP35  74
BSUM1=F1(J+2)+F4(J+2)#                                                  CP35  75
BSUM2=F2(J+2)+F3(J+2)#                                                  CP35  76
BDIF1=F1(J+2)-F4(J+2)#                                                  CP35  77
BDIF2=F2(J+2)-F3(J+2)#                                                  CP35  78
BEC=FZERO(J+2)+BSUM1*C1+BSUM2*C2#                                       CP35  79
BOC=FZERO(J+2)+BSUM1*C2+BSUM2*C1#                                       CP35  80
BES=BDIF1*S1+BDIF2*S2#                                                  CP35  81
BOS=BDIF1*S2-BDIF2*S1#                                                  CP35  82
#                                                                       CP35  83
# THE R'S AND I'S ARE THE REAL AND IMAGINARY PARTS OF THE SUM BEFORE TH CP35  84
# EXPONENTIAL Q TERM CPS BEEN APPLIED.                                  CP35  85
#                                                                       CP35  86
R1=AEC-BES#                                                             CP35  87
I1=AES+BEC#                                                             CP35  88
R2=AOC-BOS#                                                             CP35  89
I2=AOS+BOC#                                                             CP35  90
R3=AOC+BOS#                                                             CP35  91
I3=-AOS+BOC#                                                            CP35  92
R4=AEC+BES#                                                             CP35  93
I4=-AES+BEC#                                                            CP35  94
#                                                                       CP35  95
# IF EXPONENTIAL Q TERM IS OTHER TCPN 1, APPLY IT.                      CP35  96
#                                                                       CP35  97
FZERO(J+1)=FZERO(J+1)+ASUM1+ASUM2#     For m=0, both exponentials       CP35  98
FZERO(J+2)=FZERO(J+2)+BSUM1+BSUM2#                                      CP35  99
IF(JP==1)#                             Q term is+1                      CP35 100
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP35 101
F1(J+1)=R1#                                                             CP35 102
F1(J+2)=I1#                                                             CP35 103
F2(J+1)=R2#                                                             CP35 104
F2(J+2)=I2#                                                             CP35 105
F3(J+1)=R3#                                                             CP35 106
F3(J+2)=I3#                                                             CP35 107
F4(J+1)=R4#                                                             CP35 108
F4(J+2)=I4#                                                             CP35 109
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP35 110
ELSE#                                  Q term is not+1                  CP35 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP35 112
CPHI=COS(PHI)#                                                          CP35 113
SPHI=SIN(PHI)#                                                          CP35 114
C2PHI=CPHI**2-SPHI**2#                                                  CP35 115
S2PHI=2.*CPHI*SPHI#                                                     CP35 116
C3PHI=CPHI*C2PHI-SPHI*S2PHI#                                            CP35 117
S3PHI=SPHI*C2PHI+S2PHI*CPHI#                                            CP35 118
C4PHI=C2PHI**2-S2PHI**2#                                                CP35 119
S4PHI=2.*C2PHI*S2PHI#                                                   CP35 120
F1(J+1)=R1*CPHI-I1*SPHI#                                                CP35 121
F1(J+2)=R1*SPHI+I1*CPHI#                                                CP35 122
F2(J+1)=R2*C2PHI-I2*S2PHI#                                              CP35 123
F2(J+2)=R2*S2PHI+I2*C2PHI#                                              CP35 124
F3(J+1)=R3*C3PHI-I3*S3PHI#                                              CP35 125
F3(J+2)=R3*S3PHI+I3*C3PHI#                                              CP35 126
F4(J+1)=R4*C4PHI-I4*S4PHI#                                              CP35 127
F4(J+2)=R4*S4PHI+I4*C4PHI#                                              CP35 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP35 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP35 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP35 131
RETURN#                                                                 CP35 132
END#                                                                    CP35 133
systemheader:(CP36)#                   Called from fs70                 CP36   1
#********************************************************************** CP36   2
#                                                                       CP36   3
#                                 CP36  (FORMERLY PP02)                 CP36   4
#                                                                       CP36   5
#********************************************************************** CP36   6
SUBROUTINE CP36(M1,M2,M3,LAY,LIN)#     R.m.doherty 1981                 CP36   7
include:(AACOMN)#                      S.r.hall 1982                    CP36   8
include:(CPCOMN)#                                                       CP36   9
#                                                                       CP36  10
INTEGER I,J,K,M#                                                        CP36  11
INTEGER P1,P2,P3,P4,P5#                Pointers to map points           CP36  12
INTEGER LAY,LIN,PNT#                                                    CP36  13
INTEGER ILAY,NLAY,MLAY#                                                 CP36  14
INTEGER ILIN,NLIN,MLIN#                                                 CP36  15
INTEGER IPNT,NPNT,MPNT#                                                 CP36  16
INTEGER M1,M2,M3,MC,KP#                                                 CP36  17
INTEGER POS,MDEN,POS2#                                                  CP36  18
INTEGER TMP#                                                            CP36  19
INTEGER SGN#                                                            CP36  20
REAL X,ALAY,ALIN,APNT,BLAY#                                             CP36  21
REAL A,B,CODE,DM,DX,DY,DZ,PH,PM,PP#                                     CP36  22
#                                                                       CP36  23
INTEGER TPEAK,MPEAK,MXL,NDEN#                                           CP36  24
REAL    DENS,PMAX#                                                      CP36  25
SAVE TPEAK,MPEAK,MXL,NDEN#                                              CP36  26
SAVE  DENS,PMAX#                                                        CP36  27
#                                                                       CP36  28
chardata:(P301, MORE TCPN     PEAKS FOUND ON LAYER    . THE LEAST $#    CP36  29
SIGNIFICANT ARE LOST.)#                                                 CP36  30
chardata:(P302," Adjusted min peak density                        ")#   CP36  31
intdata:(MP,0)#                                                         CP36  32
datastuff:#                                                             CP36  33
#                                                                       CP36  34
#   THE FOLLOWING SHOULD BE GLOBALS                                     CP36  35
#                                                                       CP36  36
ILAY=ORGX1;  NLAY=INCX(1);MLAY=(NP(1)-1)*NLAY+ILAY# Set map limits      CP36  37
ILIN=ORGX(2);NLIN=INCX(2);MLIN=(NP(2)-1)*NLIN+ILIN# Set map limits  ^   CP36  38
IPNT=ORGX(3);NPNT=INCX(3);MPNT=(NP(3))# Set map limits                  CP36  39
#                                                                       CP36  40
IF(LAY==ORGX1 & LIN==ORGX(2) )#        First line and layer of map      CP36  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP36  42
TPEAK=0;  MPEAK=0;   MXL=0#            Set temp & perm peak count       CP36  43
DENS=0.;  NDEN=0;#                                                      CP36  44
PMIN=DMIN;   PLIM=DMIN#                Set initial peak min values      CP36  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP36  46
#                                                                       CP36  47
ALAY=FLOAT(LAY);   BLAY=ALAY-1.#       Float layer number               CP36  48
ALIN=FLOAT(LIN)#                       Float line number                CP36  49
IF     (LIN==ILIN) POS=1#              First line of the section        CP36  50
ELSE IF(LIN<MLIN)  POS=4#              Not first line or last line      CP36  51
ELSE               POS=7#              This is the last line            CP36  52
POS2=POS#                              Save for second iteration        CP36  53
#                                                                       CP36  54
#    LOOP OVER POINTS PER LINE                                          CP36  55
#    -------------------------                                          CP36  56
#                                                                       CP36  57
DO SGN=1,-1,-2#                        Loop for holes and peaks         CP36  58
DO PNT=1,MPNT#                         Loop over fourr points           CP36  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP36  60
IF(MAPTYP!=fdif:&SGN==-1)BREAK#        Just look for peaks              CP36  61
IF(PNT==1&SGN==-1)POS=POS2#            Reinstate type                   CP36  62
IF((PNT==2)\(PNT==MPNT)) POS=POS+1#    Adjust point code in line        CP36  63
#                                                                       CP36  64
#  SCAN 3-LINE BUFFER FOR PEAK                                          CP36  65
#  ---------------------------                                          CP36  66
#                                                                       CP36  67
KP=M2+PNT#                             Point to next density            CP36  68
#                                                                       CP36  69
PH=QX(KP);  DX=0.;  DY=0.; PMAX=PH#    Set default shifts & peak        CP36  70
IF(SGN== 1&PH< DMIN) NEXT#             Test for possible peak           CP36  71
IF(SGN==-1&PH>-DMIN) NEXT#             Test for possible peak           CP36  72
DENS=DENS+ABS(PH);  NDEN=NDEN+1#       Sum average density              CP36  73
#                                                                       CP36  74
IF(POS==5)#                            ********** inside map            CP36  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP36  76
P1=M1+PNT;   P2=M3+PNT#                Vertical points                  CP36  77
IF    (SGN== 1&((PH<QX(P1-1))\(PH<QX(P1))\(PH<QX(P1+1))\$# Test if pe   CP36  78
(PH<QX(KP-1))\(PH<QX(KP+1))\(PH<QX(P2-1))\$# Test if peak               CP36  79
(PH<QX(P2))\(PH<QX(P2+1)))) NEXT#      Exit if not peak                 CP36  80
ELSEIF(SGN==-1&((PH>QX(P1-1))\(PH>QX(P1))\(PH>QX(P1+1))\$# Test if ho   CP36  81
(PH>QX(KP-1))\(PH>QX(KP+1))\(PH>QX(P2-1))\$# Test if peak               CP36  82
(PH>QX(P2))\(PH>QX(P2+1)))) NEXT#      Exit if not peak                 CP36  83
PM=QX(KP-1);   PP=QX(KP+1)#            Interpolate horizontally         CP36  84
CALL CP37(PM,PH,PP,DX,DM)#             Do 3-point peak interpolate      CP36  85
PMAX=DM#                               Store new peak height            CP36  86
PM=QX(P1);   PP=QX(P2)#                Interpolate vertically           CP36  87
CALL CP37(PM,PH,PP,DY,DM)#             Do 3-point peak interpolate      CP36  88
PMAX=(PMAX+DM)/2.+PH#                  Store new peak height            CP36  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP36  90
#                                                                       CP36  91
ELSE IF((POS==2)\(POS==8))#            *********top/bot map             CP36  92
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP36  93
IF(POS==2) P1=M3+PNT#                  Top                              CP36  94
ELSE       P1=M1+PNT#                  Bottom                           CP36  95
IF    (SGN== 1&((PH<QX(KP-1))\(PH<QX(KP+1))\(PH<QX(P1-1))\$# Test pea   CP36  96
(PH<QX(P1))\(PH<QX(P1+1)))) NEXT#      Exit if not peak                 CP36  97
ELSEIF(SGN==-1&((PH>QX(KP-1))\(PH>QX(KP+1))\(PH>QX(P1-1))\$# Test hol   CP36  98
(PH>QX(P1))\(PH>QX(P1+1)))) NEXT#      Exit if not hole                 CP36  99
PM=QX(KP-1);   PP=QX(KP+1)#            Interpolate horizontally         CP36 100
CALL CP37(PM,PH,PP,DX,DM)#             Do 3-point peak interpolate      CP36 101
PMAX=PH+DM#                            Store new peak height            CP36 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP36 103
#                                                                       CP36 104
ELSE IF((POS==4)\(POS==6))#            ***********left/right map        CP36 105
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP36 106
P1=M1+PNT;   P3=M3+PNT#                Vertical points                  CP36 107
IF(POS==4) K=+1;  ELSE K=-1#           Get left/right move              CP36 108
P2=P1+K;   P4=P3+K;   P5=KP+K#         Horizontal points                CP36 109
IF     (SGN== 1&((PH<QX(P1))\(PH<QX(P2))\(PH<QX(P3))\$# Test if peak    CP36 110
(PH<QX(P4))\(PH<QX(P5)))) NEXT#        Exit if not peak                 CP36 111
ELSEIF (SGN==-1&((PH>QX(P1))\(PH>QX(P2))\(PH>QX(P3))\$# Test if hole    CP36 112
(PH>QX(P4))\(PH>QX(P5)))) NEXT#        Exit if not peak                 CP36 113
PM=QX(P1);   PP=QX(P3)#                Interpolate vertically           CP36 114
CALL CP37(PM,PH,PP,DY,DM)#             Do 3-point peak interpolate      CP36 115
PMAX=PH+DM#                            Store new peak height            CP36 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP36 117
#                                                                       CP36 118
ELSE#                                  *************corner              CP36 119
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP36 120
IF(POS==1\POS==7) P1=KP+1#             Left corner move horiz           CP36 121
ELSE              P1=KP-1#             Right corner move horiz          CP36 122
IF(POS<4)         P2=M3+PNT#           Top corner move down             CP36 123
ELSE              P2=M1+PNT#           Bot corner move up               CP36 124
IF(P1>KP)         P3=P2+1#             Left adjust                      CP36 125
ELSE              P3=P2-1#             Right adjust                     CP36 126
IF    (SGN== 1&((PH<QX(P1))\(PH<QX(P2))\(PH<QX(P3))))NEXT# Exit no pe   CP36 127
ELSEIF(SGN==-1&((PH>QX(P1))\(PH>QX(P2))\(PH>QX(P3))))NEXT# Exit no ho   CP36 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP36 129
CODE=FLOAT(POS)#                       Float point position code        CP36 130
APNT=FLOAT((PNT-1)*NPNT+IPNT)#         Float point index                CP36 131
#                                                                       CP36 132
#   PEAK FOUND -- PROCESS                                               CP36 133
#   ---------------------                                               CP36 134
#                                                                       CP36 135
IF(LAY>ILAY)#                          Except for first layer           CP36 136
FOR(MP=MARKB;MP<STOPB;MP=MP+STEPB)#    Loop over temp peak list         CP36 137
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP36 138
ifne:(lay1:,BLAY) NEXT#                Skip except if prev layer        CP36 139
IF((lin1:>ALIN+1.5)\(lin1:<ALIN-1.5))NEXT# Skip if too far away         CP36 140
IF((pnt1:>APNT+1.5)\(pnt1:<APNT-1.5))NEXT# Skip if too far away         CP36 141
#                                                                       CP36 142
#    NEW PEAK UNRESOLVED FROM PEAK IN LIST                              CP36 143
#    ---------------------------------------                            CP36 144
#                                                                       CP36 145
IF((SGN== 1&PMAX>pek1:)\#              Test if new peak larger          CP36 146
(SGN==-1&PMAX<pek1:))#                 Test if new peak smaller         CP36 147
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP36 148
pnt2:=pnt1:#                           Store peak parameters            CP36 149
lin2:=lin1:#                           Store peak parameters            CP36 150
lay2:=lay1:#                           Store peak parameters            CP36 151
pek2:=pek1:#                           Store peak parameters            CP36 152
flag:=1.#                              Set second layer flag            CP36 153
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP36 154
ELSE IF(flag:<.5)#                     Peak on 2 layers only            CP36 155
CALL CP38(MP,pek1:,lay1:)#             Put peak in layer 1 in perm      CP36 156
ELSE IF(flag:<1.5)#                    Peak on middle of 3 layers       CP36 157
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP36 158
CALL CP37(pek2:,pek1:,PMAX,DZ,DM)#     Interpolate back 2 layers        CP36 159
A=DM+pek1:;  B=DZ+lay1:#               Store new peak values            CP36 160
IF(DZ>0.)#                             Is peak between layers 2 & 3     CP36 161
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP36 162
DZ=-DZ; pnt2:=APNT+DX; lin2:=ALIN+DY#  Overstore layer 1 peak           CP36 163
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP36 164
pnt1:=pnt1:+(pnt1:-pnt2:)*DZ#          Adjust x coordinate              CP36 165
lin1:=lin1:+(lin1:-lin2:)*DZ#          Adjust y coordinate              CP36 166
CALL CP38(MP,A,B)#                     Transfer peak to perm list       CP36 167
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP36 168
pnt1:=APNT+DX#                         Store peak parameters            CP36 169
lin1:=ALIN+DY#                         Store peak parameters            CP36 170
lay1:=ALAY#                            Mark as perm peak                CP36 171
pek1:=PMAX#                            Store peak parameters            CP36 172
code:=CODE#                            Store peak parameters            CP36 173
BREAK#                                 Exit after peak processed        CP36 174
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP36 175
#                                                                       CP36 176
#    IF FIRST LAYER OR UNIQUE PEAK FOUND                                CP36 177
#    -----------------------------------                                CP36 178
#                                                                       CP36 179
IF((LAY==ILAY)\(MP==STOPB))#           For layer 1 or unmatched pea     CP36 180
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP36 181
TPEAK=TPEAK+1;     MC=STOPB#           Count temp peak                  CP36 182
IF((TPEAK-MPEAK>MXPEAK/2)\(TPEAK>=MXPEAK))# Max no. of peaks exceeded   CP36 183
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP36 184
IF(MXL==0)#                            Write spill-over message onc     CP36 185
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP36 186
MXL=1#                                 Set spill flag                   CP36 187
TMP=TPEAK-MPEAK#                                                        CP36 188
ncodefld:(FLOAT(TMP),1,P301,140313.,1)# Format overflow                 CP36 189
ncodefld:(ALAY,1,P301,390313.,1)#      Format section number            CP36 190
writeline:(1,P301,NP301,3,3)#          Print warning message            CP36 191
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP36 192
TPEAK=TPEAK-1#                         Reset no. of peaks to max.       CP36 193
M=MARKB+MPEAK*STEPB#                   Point to start of peaks          CP36 194
X=100000.#                             Set arbitrarily large refere     CP36 195
FOR(MP=M;MP<STOPB;MP=MP+STEPB)#        Loop over part peak list         CP36 196
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP36 197
IF(ABS(pek1:)>X) NEXT#                 Look for smallest peak           CP36 198
X=ABS(pek1:);   MC=MP#                 Save new minimum                 CP36 199
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP36 200
IF(X>=ABS(PMAX)) MC=0#                 Cancel if new peak smaller       CP36 201
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP36 202
ELSE  STOPB=STOPB+STEPB#               Incr temp peak pointer           CP36 203
#                                                                       CP36 204
#    STORE NEW PEAK IN TEMP LIST 7                                      CP36 205
#    -----------------------------                                      CP36 206
#                                                                       CP36 207
IF(MC>0)#                              If it's not an extra and the     CP36 208
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP36 209
pnt1:(MC)=DX+APNT#                     Store point values               CP36 210
lin1:(MC)=DY+ALIN#                     Store line  values               CP36 211
lay1:(MC)=ALAY#                        Store section values             CP36 212
pek1:(MC)=PMAX#                        Store peak  values               CP36 213
code:(MC)=CODE#                        Store position code              CP36 214
flag:=0.#                              Initial storage flag             CP36 215
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP36 216
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP36 217
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP36 218
#                                                                       CP36 219
#                                                                       CP36 220
#                                                                       CP36 221
#WRITE(6,*)"LAY,MLAY",LIN,MLIN,LAY,MLAY                                 CP36 222
#                                                                       CP36 223
IF(LIN==MLIN)#                         At end of current layer          CP36 224
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP36 225
#                                                                       CP36 226
#    CHECK DENSITY THRESHOLD AFTER FIRST LAYER                          CP36 227
#    -----------------------------------------                          CP36 228
#                                                                       CP36 229
MDEN=NP(2)*NP(3)/3#                    Set values for thresh test       CP36 230
#                                                                       CP36 231
IF(LAY==ILAY&((NDEN>MDEN)\(MXL>0)))#   Only adjust for first layer      CP36 232
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP36 233
DMIN=DMIN+DENS*.25/FLOAT(NDEN)#        Estimate new dmin                CP36 234
ncodefld:(DMIN,1,P302,400622.,1)#      Format adjusted peak max         CP36 235
pt2:  writeline:(0,P302,NP302,3,3)#    Print adjusted peak limit        CP36 236
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP36 237
#                                                                       CP36 238
#    PROCESS PEAKS IN TEMP LIST & COMPRESS                              CP36 239
#    ------------------------------------                               CP36 240
#                                                                       CP36 241
IF(TPEAK==0) RETURN#                   Skip if no peaks                 CP36 242
FOR(MP=MARKB;MP<STOPB;MP=MP+STEPB)#    Loop over temp peak list         CP36 243
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP36 244
IF((flag:>1.5)\(lay1:>ALAY-.5)) NEXT#  Skip if transferred              CP36 245
CALL CP38(MP,pek1:,lay1:)#             Transfer to permanent list       CP36 246
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP36 247
#                                                                       CP36 248
#  COMPRESS TEMP LIST IF NOT LAST LAYER                                 CP36 249
#  ---------------------------------                                    CP36 250
#                                                                       CP36 251
IF(LAY<MLAY)#                          Test if last layer               CP36 252
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP36 253
MC=MARKB#                              Reset compress pointer           CP36 254
FOR(MP=MARKB;MP<STOPB;MP=MP+STEPB)#    Loop over temp list              CP36 255
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CP36 256
IF((flag:>1.5)&(lay1:<ALAY-.5))NEXT#   Skip if peak transferred         CP36 257
movereal:(QX,MP+1,QX,MC+1,STEPB,1)#    Push back temp list              CP36 258
MC=MC+STEPB#                           Incr push back pointer           CP36 259
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CP36 260
STOPB=MC#                              Store new temp peak limit        CP36 261
TPEAK=(MC-MARKB)/STEPB#                Calc number temp peaks           CP36 262
MPEAK=TPEAK#                           Store current peak number        CP36 263
MXL=0#                                 Reset signal for spillover m     CP36 264
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP36 265
#                                                                       CP36 266
#    THIS IS THE LAST LAYER                                             CP36 267
#    ----------------------                                             CP36 268
#                                                                       CP36 269
ELSE#                                  Last section has been done       CP36 270
FOR(MP=MARKB;MP<STOPB;MP=MP+STEPB)#    Loop over temp peak list         CP36 271
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CP36 272
IF(flag:>1.5) NEXT#                    Skip transferred peaks           CP36 273
CALL CP38(MP,pek1:,lay1:)#             Transfer to permanent list       CP36 274
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CP36 275
#                                                                       CP36 276
#   RESET PEAK MAX FROM PROFILE                                         CP36 277
#   ---------------------------                                         CP36 278
#                                                                       CP36 279
J=0;  K=NPEAKS*1.5#                    Reset peak counter               CP36 280
FOR(I=STOPM;I>MARKM;I=I-1)#            Loop over peak profile table     CP36 281
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CP36 282
J=J+NINT(QX(I))#                       Sum peaks in perm list           CP36 283
IF(J<K) NEXT#                          Skip if limit not reached        CP36 284
PMIN=AMAX1(PMIN,FLOAT(I-MARKM)+PLIM)#  Calc new peak min                CP36 285
DMIN=AMAX1(DMIN,PMIN/4)#               Calc new density min             CP36 286
BREAK#                                 Exit with new values             CP36 287
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CP36 288
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP36 289
#                                                                       CP36 290
#                                                                       CP36 291
RETURN#                                                                 CP36 292
END#                                                                    CP36 293
systemheader:(CP37)#                                                    CP37   1
#******************************************************************#    CP37   2
#                                                                  #    CP37   3
#                                CP37 (FORMERLY PP03)                   CP37   4
#                                                                  #    CP37   5
#******************************************************************#    CP37   6
SUBROUTINE CP37(PM,PH,PP,DV,DM)#                                        CP37   7
#                                                                       CP37   8
REAL S,PM,PP,PH,DV,DM#                                                  CP37   9
#                                                                       CP37  10
S=PP+PM-2.*PH#                         (y3-y2)+(y1-y2)                  CP37  11
IF(ABS(S)>small:)#                     If s is not zero                 CP37  12
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP37  13
DV=(PM-PP)/(2.*S); DM=-0.5*S*DV*DV#    X shift ; y shift                CP37  14
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP37  15
ELSE#                                                                   CP37  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP37  17
DV=0.; DM=0.#                                                           CP37  18
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP37  19
RETURN#                                                                 CP37  20
END#                                                                    CP37  21
systemheader:(CP38)#                                                    CP38   1
#******************************************************************#    CP38   2
#                                                                  #    CP38   3
#                                CP38 (FORMERLY PP04)              #    CP38   4
#                                                                  #    CP38   5
#******************************************************************#    CP38   6
SUBROUTINE CP38(MP,PH,SECTN)#          Transfer peak to perm list       CP38   7
include:(AACOMN)#                                                       CP38   8
include:(CPCOMN)#                                                       CP38   9
#                                                                       CP38  10
INTEGER I,J,K,ISTOP,ISTRT,NEW,NOVER#                                    CP38  11
INTEGER MTAB(10)#                                                       CP38  12
INTEGER MP,KP,INDREL#                                                   CP38  13
REAL A,B,C,X,Y,Z,U,V,W,DX,DY,DZ#                                        CP38  14
REAL P(3),PH,SECTN,DD,RES1#                                             CP38  15
intdata:(INDX,[3,2,3,2,1,2,3,2,3])#                                     CP38  16
datastuff:#                                                             CP38  17
#                                                                       CP38  18
#    PREPARE TO CHECK EXISTING PEAK LIST                                CP38  19
#    -----------------------------------                                CP38  20
#                                                                       CP38  21
IF(ABS(PH)<PMIN) GOTO 100#             Exit if peak too small           CP38  22
K=NINT(code:);  INDREL=INDX(K)#        Extract reliability index        CP38  23
NOVER=0#                               Reset overlap table pointer      CP38  24
RES1=RES*RES#                          Default is 0.75a^2               CP38  25
#ELSE            RES1=0.25#            DEFAULT TO 0.5A^2                CP38  26
NEW=yes:#                              Set new peak flag                CP38  27
P(3)=pnt1:/FLOAT(NG(3))#               Convert across to fractions      CP38  28
P(2)=lin1:/FLOAT(NG(2))#               Convert down   to fractions      CP38  29
P(1)=SECTN/FLOAT(NG(1))#               Convert layer  to fractions      CP38  30
#                                                                       CP38  31
#                                                                       CP38  32
A=P(IMAP(1));  B=P(IMAP(2));  C=P(IMAP(3))# Convert to crystal axes     CP38  33
IF(MAPTYP==vect:)$(ISTOP=STOPS1;ISTRT=STOPS$)#                          CP38  34
ELSE             $(ISTOP=STOPS; ISTRT=MARKS$)#                          CP38  35
#                                                                       CP38  36
#   LOOP OVER EXISTING PEAKS IN LIST                                    CP38  37
#   --------------------------------                                    CP38  38
#                                                                       CP38  39
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over peaks list             CP38  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP38  41
IF(ABS(peakh:)<PMIN) NEXT#             Ignore rejected peaks            CP38  42
X=peakx:;  Y=peaky:;  Z=peakz:#        Store peak coords local          CP38  43
#                                                                       CP38  44
#  SEARCH SYMMETRY EQUIVALENT COORDINATES                               CP38  45
#  --------------------------------------                               CP38  46
#                                                                       CP38  47
FOR(K=ISTRT;K<ISTOP;K=K+STEPS)#        Loop over all symops             CP38  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP38  49
U=X*QX(K+1)+Y*QX(K+4)+Z*QX(K+7)+QX(K+10)# Generate equivalent x         CP38  50
V=X*QX(K+2)+Y*QX(K+5)+Z*QX(K+8)+QX(K+11)# Generate equivalent y         CP38  51
W=X*QX(K+3)+Y*QX(K+6)+Z*QX(K+9)+QX(K+12)# Generate equivalent z         CP38  52
DX=MOD(99.5+A-U,1.)-0.5#               Ensure x' close to x             CP38  53
DY=MOD(99.5+B-V,1.)-0.5#               Ensure y' close to y             CP38  54
DZ=MOD(99.5+C-W,1.)-0.5#               Ensure z' close to z             CP38  55
DD=G1*DX**2+G6*DY*DZ+G5*DY**2+G3*DX*DZ+G9*DZ**2+G2*DX*DY#               CP38  56
IF(DD>RES1) NEXT#                      Continue if not overlapped       CP38  57
#                                                                       CP38  58
#  OVERLAPPED PEAK FOUND                                                CP38  59
#  ---------------------                                                CP38  60
#                                                                       CP38  61
I=NINT(index:)#                        Store reliability index          CP38  62
IF((INDREL>I)\(INDREL==I&ABS(PH)<ABS(peakh:))) NEW=no:# Reject new pe   CP38  63
ELSE#                                  New overlap peak larger          CP38  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP38  65
IF(NOVER==10) BREAK#                   Store only 10 overlaps           CP38  66
NOVER=NOVER+1#                         Count number of overlaps         CP38  67
MTAB(NOVER)=KP#                        Pointer in overlap table         CP38  68
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP38  69
BREAK#                                 Exit symop loop                  CP38  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP38  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP38  72
#                                                                       CP38  73
#   ACCEPT NEW PEAK                                                     CP38  74
#   ---------------                                                     CP38  75
#                                                                       CP38  76
IF(NOVER>0)#                           Test if any overlaps             CP38  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP38  78
DO I=1,NOVER#                          Loop peak overlap list           CP38  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP38  80
KP=MTAB(I)#                            Point to overlaped peak          CP38  81
J=MIN0(MARKM+INT(ABS(peakh:)-PLIM),STOPM)# Point to peak ht array       CP38  82
QX(J)=QX(J)-1.#                        Decr peak ht array               CP38  83
peakh:=0.#                             Flag as reject in peak table     CP38  84
NPTS=NPTS-1#                           Reduce peak count                CP38  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP38  86
IF(NEW==no:) GO TO 100#                Not largest overlap              CP38  87
KP=MTAB(1)#                            Insert new peak in old slot      CP38  88
NPTS=NPTS+1#                           Count new peak                   CP38  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP38  90
ELSE IF(NEW==yes:)#                    No overlap check free slots&     CP38  91
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP38  92
I=MARKA; DD=999999.#                   Set sort parameters              CP38  93
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over peak table             CP38  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP38  95
IF(ABS(peakh:)<PMIN)#                  Use slot of culled peak          CP38  96
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP38  97
NPTS=NPTS+1 ; GOTO 50#                 Count additional peak            CP38  98
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP38  99
IF(ABS(peakh:)>DD)    NEXT#            Sort on peak height              CP38 100
I=KP; DD=ABS(peakh:)#                  Store smallest peak              CP38 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP38 102
IF(STOPA<STOPA1)#                      Test if inside max               CP38 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP38 104
KP=STOPA#                              Point to end of table            CP38 105
STOPA=STOPA+STEPA#                     Expand table                     CP38 106
NPTS=NPTS+1#                           Count additional peak            CP38 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP38 108
ELSE IF(DD<ABS(PH))     KP=I#          Point to smallest peak           CP38 109
ELSE         GO TO 100#                If too small ignore              CP38 110
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP38 111
ELSE GO TO 100#                        Reject small overlap peak        CP38 112
#                                                                       CP38 113
#  PREPARE NEW COORDS FOR PEAK TABLE                                    CP38 114
#  ---------------------------------                                    CP38 115
#                                                                       CP38 116
50  CONTINUE#                          Branch point for transfer        CP38 117
peakx:=A#                              Store x coord                    CP38 118
peaky:=B#                              Store y coord                    CP38 119
peakz:=C#                              Store z coord                    CP38 120
peakh:=PH+.0001#                       Store peak height                CP38 121
index:=FLOAT(INDREL)#                  Store reliability index          CP38 122
#PEAKT:=0.#                            NO TYPE ASSIGNMENT YET           CP38 123
peakm:=1.#                             Assume multiplicity of 1.0       CP38 124
I=MIN0(MARKM+INT(ABS(PH)-PLIM),STOPM)# Point to peak max profile        CP38 125
QX(I)=QX(I)+1.#                        Count peak max as profile        CP38 126
100 CONTINUE#                                                           CP38 127
flag:=2.#                              Flag peak as processed           CP38 128
#                                                                       CP38 129
RETURN#                                                                 CP38 130
END#                                                                    CP38 131
systemheader:(CP39)#                                                    CP39   1
#*********************************************************************# CP39   2
#                                                                     # CP39   3
#                                CP39  SORT PEAKLIST AND EXPAND       # CP39   4
#                                                                     # CP39   5
#*********************************************************************# CP39   6
SUBROUTINE CP39#                                                        CP39   7
include:(AACOMN)#                                                       CP39   8
include:(CPCOMN)#                                                       CP39   9
#                                                                       CP39  10
INTEGER I,J,K,NM#                                                       CP39  11
INTEGER IP,KP,JP#                                                       CP39  12
REAL A,X(3),Y(3),SX(3),Z(3),DD#                                         CP39  13
REAL AMATCH#                                                            CP39  14
REAL DIF,DIFDUM,SITMUL#                                                 CP39  15
REAL S#                                                                 CP39  16
chardata:(CP39A,' Max/min Fourier map density                      ')#  CP39  17
chardata:(CP39B,' Calculated a Patterson E*E-1 Map ')#                  CP39  18
chardata:(CP39C,' Top Harker vectors Xi-Xj are   ')#                    CP39  19
datastuff:#                                                             CP39  20
#                                                                       CP39  21
IF(MAPTYP!=vect:)#                                                      CP39  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP39  23
ncodefld:(DENMAX,1,CP39A,400722.,1)#                                    CP39  24
ncodefld:(DENMIN,1,CP39A,500722.,1)#                                    CP39  25
pt1: writeline:(0,CP39A,NCP39A,3,3)#                                    CP39  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP39  27
ELSE writeline:(2,CP39B,NCP39B,3,3)#                                    CP39  28
#                                                                       CP39  29
#   LOOK FOR PEAKS NEAR SPECIAL POSITIONS AND FIX                       CP39  30
#   ---------------------------------------------                       CP39  31
#                                                                       CP39  32
IF(MAPTYP!=vect:)#                                                      CP39  33
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over perm peak list         CP39  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP39  35
X(1)=peakx:#                           Get site x coord                 CP39  36
X(2)=peaky:#                           Get site y coord                 CP39  37
X(3)=peakz:#                           Get site z coord                 CP39  38
DO I=1,3;SX(I)=X(I)#                   Initialize average coord         CP39  39
NM=1#                                  Initalize near miss              CP39  40
AMATCH=0.#                             Zero count of coincidences       CP39  41
FOR(K=MARKS;K<STOPS;K=K+STEPS)#        Loop over all symops             CP39  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP39  43
Z(1)=X(1)*QX(K+1)+X(2)*QX(K+4)+X(3)*QX(K+7)+QX(K+10)# Generate equiv    CP39  44
Z(2)=X(1)*QX(K+2)+X(2)*QX(K+5)+X(3)*QX(K+8)+QX(K+11)# Generate equiv    CP39  45
Z(3)=X(1)*QX(K+3)+X(2)*QX(K+6)+X(3)*QX(K+9)+QX(K+12)# Generate equiv    CP39  46
#                                                                       CP39  47
#  CHECK FOR NEAR-MISS SPECIAL POSITIONS                                CP39  48
#  -------------------------------------                                CP39  49
#                                                                       CP39  50
DO I=1,3;Y(I)=MOD(9.5+Z(I)-X(I),1.0)-0.5# Get closest distance          CP39  51
DD=G1*Y(1)**2+G6*Y(2)*Y(3)+$#          Calc orthog angstrom distance    CP39  52
   G5*Y(2)**2+G3*Y(1)*Y(3)+$#          Squared                          CP39  53
   G9*Y(3)**2+G2*Y(1)*Y(2)#                                             CP39  54
IF(DD<0.25&DD>0.000001)#               Sym related site <0.5a           CP39  55
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP39  56
NM=NM+1#                               Increment near miss count        CP39  57
DO I=1,3;SX(I)=SX(I)+(X(I)+Y(I))#      Accumulate coords for average    CP39  58
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP39  59
#                                                                       CP39  60
DO J=1,3#                              Loop over coordinates            CP39  61
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP39  62
DIF=X(J)-Z(J);  DIFDUM=DIF#            Get diff in coordinate           CP39  63
DIF=DIF-FLOAT(NINT(DIFDUM))#           Get smallest difference          CP39  64
IF(ABS(DIF)>0.0005) GOTO 100#          Different so skip to next symo   CP39  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP39  66
#                                                                       CP39  67
AMATCH=AMATCH+1.0#                     Count site multiplicity          CP39  68
100 CONTINUE#                          Branch point                     CP39  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP39  70
IF(NM>1)#                              Near miss special position       CP39  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP39  72
peakx:=SX(1)/FLOAT(NM)#                Replace with average x coord     CP39  73
peaky:=SX(2)/FLOAT(NM)#                Replace with average y coord     CP39  74
peakz:=SX(3)/FLOAT(NM)#                Replace with average z coord     CP39  75
pt5:#                                                                   CP39  76
WRITE(6,*)"CORRECTED SPEC. POS. PEAK ",KP,peakx:,peaky:,peakz:,NM# C    CP39  77
KP=KP-STEPA#                           Reset and try again              CP39  78
NEXT#                                  Break symop loop                 CP39  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP39  80
SITMUL=1.0/AMATCH#                     Calculate site multiplicity      CP39  81
peakm:=SITMUL#                         Save multiplicity                CP39  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP39  83
#                                                                       CP39  84
#    SORT PERMANENT PEAK LIST                                           CP39  85
#    ------------------------                                           CP39  86
#                                                                       CP39  87
QXCUR=STOPA#                           Reset to erase                   CP39  88
MARKB=STOPA#                                                            CP39  89
STEPB=STEP9#                                                            CP39  90
STOPB=MARKB#                                                            CP39  91
STOP10=STOPB#                                                           CP39  92
S=-1.#                                                                  CP39  93
IP=MARKA#                                                               CP39  94
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over perm peak list         CP39  95
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP39  96
A=S*peakh:;IP=KP#                      Initialize peak max pointers     CP39  97
FOR(JP=KP+STEPA;JP<STOPA;JP=JP+STEPA)# Loop over perm peak list         CP39  98
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP39  99
IF(S*peakh:(JP)<A)NEXT#                Peak is smaller than cur         CP39 100
A=S*peakh:(JP)#                        Save peak max                    CP39 101
IP=JP#                                 Save pointer                     CP39 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP39 103
IF(S<0.0 & A<=0.0)#                    Got all the holes now            CP39 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP39 105
S=1.#                                  So swap to peaks                 CP39 106
KP=KP-STEPA#                           Ignore this smallest of small    CP39 107
STOP10=STOPB#                          Record end of hole list          CP39 108
NEXT#                                  And look for biggest peaks       CP39 109
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP39 110
incrqx:(JP,STOPB+STEPB,CP3901)#        Get mem for copy                 CP39 111
movereal:(QX,IP+1,QX,STOPB+1,peklist:,1)# Copy pekpik peakdata          CP39 112
STOPB=JP#                              Increment current maximum        CP39 113
IF(IP!=KP)movereal:(QX,KP+1,QX,IP+1,peklist:,1)# Ovrwrite transferred   CP39 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP39 115
#                                                                       CP39 116
#    COPY HOLE LIST BACK TO MARK10                                      CP39 117
#    -----------------------------                                      CP39 118
#    CAN USE THE HOLES TO DEMOTE INCORRECT ATOM TYPE ASSIGNMENTS        CP39 119
#    -----------------------------------------------------------        CP39 120
#                                                                       CP39 121
I=0#                                                                    CP39 122
JP=MARK10#                                                              CP39 123
FOR(KP=MARKB;KP<STOP10;KP=KP+STEPB)#   Loop over perm peak list         CP39 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP39 125
movereal:(QX,KP+1,QX,JP+1,STEPB,1)#    Copy pekpik peakdata back        CP39 126
atrad:(JP)=RADMAX#                     Set peak radius                  CP39 127
peakt:(JP)=0.#                         Initialize peak type             CP39 128
IF(I<20&DMP>2) WRITE(6,*)peakh:,peakx:,peaky:,peakz:,peakm:#            CP39 129
JP=JP+STEP10#                                                           CP39 130
I=I+1#                                                                  CP39 131
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP39 132
MARKB=STOP10#                          Reset old peaks start point      CP39 133
STOP10=JP#                                                              CP39 134
MARKA=STOP10#                          Save new peaks start point       CP39 135
#                                                                       CP39 136
#    COPY PEAK LIST BACK TO MARKA                                       CP39 137
#    ----------------------------                                       CP39 138
#                                                                       CP39 139
IF(MAPTYP==vect:) writeline:(0,CP39C,NCP39C,3,3)#                       CP39 140
I=0#                                                                    CP39 141
JP=MARKA#                                                               CP39 142
STOPB=MIN(STOPB,MARKB+MIN(NPEAKS,NPTS)*STEPB)# Whichever is smaller     CP39 143
FOR(KP=MARKB;KP<STOPB;KP=KP+STEPB)#    Loop over perm peak list         CP39 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP39 145
movereal:(QX,KP+1,QX,JP+1,STEPB,1)#    Copy pekpik peakdata back        CP39 146
atrad:(JP)=RADMAX#                     Set peak radius                  CP39 147
peakt:(JP)=0.#                         Initialize peak type             CP39 148
IF(I<20)#                                                               CP39 149
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP39 150
IF(MAPTYP==vect:) WRITE(6,*)peakh:,peakx:,peaky:,peakz:#                CP39 151
ELSEIF(DMP>2)     WRITE(6,*)peakh:,peakx:,peaky:,peakz:,peakm:#         CP39 152
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP39 153
JP=JP+STEPB#                                                            CP39 154
I=I+1#                                                                  CP39 155
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP39 156
#                                                                       CP39 157
STOPA=JP#                                                               CP39 158
STEPA=STEPB#                                                            CP39 159
MARKN=STOPA#                           For fc dependent atom list       CP39 160
STOPA1=STOPA#                          Expanded molecular symmetry li   CP39 161
MARKB=STOPA;STOPB=STOPA#                                                CP39 162
MARKC=STOPA;STOPC=STOPA#                                                CP39 163
MARKD=STOPA;STOPD=STOPA#                                                CP39 164
#                                                                       CP39 165
IF(MAPTYP!=vect:&HEAVY==no:)#          Check for light atom random      CP39 166
IF(peakh:(MARKA)>2.*peakh:(MARKA+STEPA))# Large peak signature          CP39 167
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP39 168
###VIABLE=no:#                            Found it so reject !          CP39 169
###WRITE(6,*) "Single large peak identified in light atom structure."   CP39 170
###WRITE(6,*) "Rejecting as a false solution."                          CP39 171
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP39 172
#                                                                       CP39 173
RETURN#                                                                 CP39 174
END#                                                                    CP39 175
systemheader:(CP40)#                   Assign atoms to peaks            CP40   1
# ####################################################################  CP40   2
#                                                                       CP40   3
#                               CP40                                    CP40   4
#                                                                       CP40   5
# ####################################################################  CP40   6
SUBROUTINE CP40#                       Based on peak heights and diff   CP40   7
include:(AACOMN)#                                                       CP40   8
include:(CPCOMN)#                                                       CP40   9
#                                                                       CP40  10
INTEGER I,J,JJ,K#                                                       CP40  11
INTEGER NCNT#                                                           CP40  12
INTEGER KP#                                                             CP40  13
REAL A,B,PD#                                                            CP40  14
REAL NETOT,ZMAX,PSCL#                                                   CP40  15
INTEGER NAT,NAT1#     ##                                                CP40  16
INTEGER MATT#                                                           CP40  17
REAL    NDIF#         ##                                                CP40  18
REAL    PREV#                                                           CP40  19
REAL    Z,ZP#                                                           CP40  20
REAL    PEKDIF(30)#   ## Ranked observed decreases in peak height       CP40  21
REAL    PEKCNT(30)#   ## Ranked observed decreases in peak height       CP40  22
INTEGER PEKLOC(30)#   ## Peak list location of largest peak diffs       CP40  23
INTEGER USED(30)#     ## FLags to indicate PEKDIF(I) was used           CP40  24
REAL    PFOM(30)#     ## Saved list of figs of merit                    CP40  25
REAL    F1(30),F2(30),F3(30),F4(30)#                                    CP40  26
REAL ACNT,ATOT#                        Cp40  30                         CP40  27
REAL W1,W2,W3,W4,W5#                                                    CP40  28
REAL DIFMUL#                                                            CP40  29
REAL VAL#                                                               CP40  30
INTEGER MNCNT#                                                          CP40  31
INTEGER ITYP#                                                           CP40  32
INTEGER SWAPED,SWAP#                                                    CP40  33
REAL DIF1,DIF2,ANUM,OLDNC,ATNCC,TYPTOT#                                 CP40  34
#                                                                       CP40  35
chardata:(OUT0," Initial peak-list atom-type boundaries: ")#            CP40  36
chardata:(OUT1," xx(   )-yy(   ) discon between peaks xxxx(      )$#    CP40  37
  and  yyyy(      )  ")#                                                CP40  38
chardata:(OUT2,"                larger Z sites expected         x $#    CP40  39
 invoked         y")#                                                   CP40  40
chardata:(OUT3,"              ratio (Zi-Zj)/Zj expected         x $#    CP40  41
 invoked         y")#                                                   CP40  42
chardata:(OUT4," Type assignment sequence error. Swapping. ")#          CP40  43
chardata:(OUT5," Amalgamating xx scattering factor types ")#            CP40  44
chardata:(OUT6," Reduced to   yy atom type ranges.")#                   CP40  45
chardata:(OUT7," Treating all peaks from xxxxx to yyyyy as $#           CP40  46
potential zz sites.")#                                                  CP40  47
datastuff:#                                                             CP40  48
#                                                                       CP40  49
#                                                                       CP40  50
# SEARCH FOR LARGEST RELATIVE PEAK HEIGHT CHANGES                       CP40  51
# -----------------------------------------------                       CP40  52
#                                                                       CP40  53
NETOT=0.0#                                                              CP40  54
DO I=1,NATYP#                                                           CP40  55
IF (ATZ(I)>1.5) NETOT=NETOT+ATA(I)#    Accumulate non-h atoms in asym   CP40  56
#                                                                       CP40  57
DO I=1,NATYP#                                                           CP40  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP40  59
PEKDIF(I)=0.0;PEKLOC(I)=0;PEKCNT(I)=0.0# Initialize                     CP40  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP40  61
NCNT=1#                                                                 CP40  62
ACNT=0.#                                                                CP40  63
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over all sites              CP40  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP40  65
IF(KP==MARKA)A=peakh:#                 Get previous peak height         CP40  66
ELSE         A=peakh:(KP-STEPA)#       Get previous peak height         CP40  67
B=peakh:#                              Get peak height b                CP40  68
ATOT=ACNT*FLOAT(NSYM)#                 All previous atoms in cell       CP40  69
ACNT=ACNT+peakm:#                      Accumulate indep sites           CP40  70
IF (ACNT >NETOT*1.4) BREAK#            Skip the residual crud           CP40  71
PD=(A-B)/B#                            Get relative change              CP40  72
IF(PD<PEKDIF(NCNT))NEXT#               Less than last                   CP40  73
ifeq:(PD,0.0, 0.02) NEXT#              Less than significant change     CP40  74
DO I=1,NCNT#                           Loop for potential atom types    CP40  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP40  76
IF (PEKDIF(I)>PD) NEXT#                Skip over larger diffs           CP40  77
IF(NCNT<30)#                           Got a new value so make space    CP40  78
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP40  79
DO J=NCNT+1,I+1,-1#                    Loop from current end to curr    CP40  80
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP40  81
PEKDIF(J)=PEKDIF(J-1)#                 Make space for new difference    CP40  82
PEKLOC(J)=PEKLOC(J-1)#                 Make space for new marka point   CP40  83
PEKCNT(J)=PEKCNT(J-1)#                 Make space for count larger pe   CP40  84
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP40  85
NCNT=NCNT+1#                           Increment signif diff counter    CP40  86
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP40  87
PEKDIF(I)=PD#                          Save change in z                 CP40  88
PEKLOC(I)=KP#                          Save pointer to atom list        CP40  89
PEKCNT(I)=ATOT#                        Save total atoms b4 current      CP40  90
BREAK#                                 Assigned new signif diff         CP40  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP40  92
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP40  93
NCNT=NCNT-1#                           Delete the last one              CP40  94
#                                                                       CP40  95
#                                                                       CP40  96
# INITIALIZE A LIST OF MARKA TO STOPA POINTERS TO INDICATE              CP40  97
# WHEN TO CHANGE ATOM TYPES (MAT(30), MAL(30))                          CP40  98
#                                                                       CP40  99
ITYP=1#                                Assume of largest z type         CP40 100
MAT(ITYP)=ATZORD(1)#                   Assumes largest z atom type pr   CP40 101
MAL(ITYP)=MARKA#                       Fudge first location             CP40 102
ATNCC=0.0#                             Initialise atom number count     CP40 103
OLDNC=0.0#                                                              CP40 104
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over all sites              CP40 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP40 106
ATNCC= ATNCC+peakm:#                   Sum similar type sites           CP40 107
TYPTOT=ATNCC*FLOAT(NSYM)#              Atoms of type in whole cell      CP40 108
K=ATZORD(ITYP)#                        Pointer to current type          CP40 109
ANUM=ATA(K)#                           Expected num of type             CP40 110
IF(TYPTOT>ANUM)#                       Exceeded expected type           CP40 111
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP40 112
DIF1=TYPTOT-ANUM#                                                       CP40 113
DIF2=ANUM-OLDNC#                                                        CP40 114
#                                      Could also test on peak range    CP40 115
ifne:(DIF2,ANUM)IF(DIF1>1.5*DIF2)#     At least one atom of type        CP40 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP40 117
IF (ITYP==NATYP) BREAK#                Can't assign to next             CP40 118
ITYP=ITYP+1#                           Point to next atom type          CP40 119
K=ATZORD(ITYP)#                        Save pointer                     CP40 120
MAT(ITYP)=K#                           Save pointer to atom type        CP40 121
MAL(ITYP)=KP#                          Save location of change          CP40 122
ATNCC=peakm:#                          Accumulate                       CP40 123
TYPTOT=ATNCC*FLOAT(NSYM)#              Atoms of type in whole cell      CP40 124
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP40 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP40 126
OLDNC=TYPTOT#                                                           CP40 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP40 128
IF(ITYP<NATYP)DO I=ITYP,NATYP#         Not enough peaks encountered     CP40 129
$(MAT(I)=ATZORD(I);MAL(I)=MAL(ITYP)$)# Load the last with dummies       CP40 130
#                                                                       CP40 131
#                                                                       CP40 132
#  FOR HEAVY ATOM STRUCTURES CHECK THE EXPECTED AGAINST CURRENT         CP40 133
#  ------------------------------------------------------------         CP40 134
#                                                                       CP40 135
IF(HEAVY>=500)#                        How unlikely is that????         CP40 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP40 137
pt4:#                                                                   CP40 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP40 139
WRITE(6,*) " I       PEKDIF     PEKLOC    PEKCNT"#                      CP40 140
DO I=1,MIN(NCNT,10) ; WRITE(6,*)$#                                      CP40 141
I,PEKDIF(I),(PEKLOC(I)-MARKA)/STEPA,PEKCNT(I)#                          CP40 142
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP40 143
#                                                                       CP40 144
#  SCALE LARGEST EXPECTED DIFFERENCE TO LARGEST DIFFERENCE              CP40 145
#  -------------------------------------------------------              CP40 146
#                                                                       CP40 147
DO I=1,NATYP-1#                        Loop over expected differences   CP40 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP40 149
NAT =AZODIF(I)#                        Next lowest atom type change     CP40 150
Z   =ATZ(ATZORD(NAT))#                 Atomic number of current         CP40 151
IF(Z<1.5)NEXT#                         Cant realistically assign hydr   CP40 152
DIFMUL=AZODIF(NAT)#                    Get largest z difference         CP40 153
ifne:(DIFMUL,0.0) DIFMUL=PEKDIF(1)/DIFMUL# Largest peakh: difference    CP40 154
ELSE DIFMUL=1.0#                                                        CP40 155
BREAK#                                 Got crude peakh: to z scale fa   CP40 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP40 157
#                                                                       CP40 158
# COMPARE EXPECTED WITH OBSERVED PEAK HEIGHT DIFFERENCES                CP40 159
# TO FIX ATOM TYPE HEIGHT (Z) BOUNDARIES IN PEAKLIST                    CP40 160
#  AND                                                                  CP40 161
#                                                                       CP40 162
ZMAX=ATZ(ATZORD(1))#                                                    CP40 163
PSCL=ZMAX/peakh:(MARKA)#               Relative peakh: to z scal        CP40 164
#DO I=1,NATYP; MAL(I)=-1#              INITIALIZE                       CP40 165
DO J=1,NCNT;  USED(J)=no:#             Look for observed match          CP40 166
pt4: writeline:(0,OUT0,NOUT0,3,3)#     Print peak difference header     CP40 167
#                                                                       CP40 168
MNCNT=MIN(15,NCNT)#                    Maximum values to print          CP40 169
DO I=1,NATYP-1#                        Loop over expected diffs         CP40 170
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP40 171
NAT =AZODIF(I)#                        Next lowest atom type change     CP40 172
NDIF=ATZDIF(NAT)*DIFMUL#               Scale the z change from last     CP40 173
PREV=ATNC(NAT)#                        Expected num of larger z atoms   CP40 174
Z   =ATZ(ATZORD(NAT))#                 Atomic number of current         CP40 175
#IF(Z<1.5)NEXT#                         CANT REALISTICALLY ASSIGN HYDR  CP40 176
ZP  =ATZ(ATZORD(NAT-1))#               Atomic number of previous        CP40 177
#                                                                       CP40 178
#                                                                       CP40 179
# CONSTRUCT FIGS OF MERIT                                               CP40 180
# ----------------------                                                CP40 181
#                                                                       CP40 182
JJ=1#                                                                   CP40 183
IF(LOOP+1<NARANG \LOOP==1\Z<1.5)#      Weights 4 first heavy atom lev   CP40 184
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP40 185
W1=.001;W2=1.;W3=0.001;W4=0.001;W5=0.8# Startx celcon overides all      CP40 186
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP40 187
ELSE#                                                                   CP40 188
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP40 189
W1=1.;W2=1.;W3=0.1; W4=0.1;W5=0.8#     More weight to peak heights      CP40 190
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP40 191
#WRITE(6,*)"W1,W2,W3,W4",W1,W2,W3,W4,W5                                 CP40 192
#                                                                       CP40 193
PFOM(1)=99.9#                          Initialize                       CP40 194
DO J=1,NCNT#                           Look for observed match          CP40 195
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP40 196
IF (USED(J)==yes:) NEXT#               Fudge: assume right first time   CP40 197
F1(J)=ABS(PEKDIF(J)-NDIF)#             Comparable rel z changes         CP40 198
F2(J)=ABS(PEKCNT(J)-PREV)/NETOT#       Comprble atom range              CP40 199
F3(J)=ABS(peakh:(PEKLOC(J))*PSCL-Z)/ZMAX# Scld right z val              CP40 200
F4(J)=ABS(peakh:(PEKLOC(J))*PSCL-ZP)/ZMAX# Scld left z val              CP40 201
PFOM(J)= W1*F1(J) + W2*F2(J) + W3*F3(J)+W4*F4(J)#                       CP40 202
## Need a neural net to work out a better weighting scheme!             CP40 203
IF(PFOM(J)>=PFOM(JJ)) NEXT#            Not the best fit                 CP40 204
JJ=J#                                  Save pointer to best fom         CP40 205
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP40 206
#                                                                       CP40 207
pt4:#                                                                   CP40 208
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP40 209
WRITE(6,'(F7.2,15F5.2)') (PEKDIF(K),K=1,MNCNT)#                         CP40 210
WRITE(6,'(I7  ,15I5)')   ((PEKLOC(K)-MARKA)/STEPA,K=1,MNCNT)#           CP40 211
WRITE(6,'(F7.2,15F5.2)') (F1(K),K=1,MNCNT)#                             CP40 212
WRITE(6,'(F7.2,15F5.2)') (F2(K),K=1,MNCNT)#                             CP40 213
WRITE(6,'(F7.2,15F5.2)') (F3(K),K=1,MNCNT)#                             CP40 214
WRITE(6,'(F7.2,15F5.2)') (F4(K),K=1,MNCNT)#                             CP40 215
WRITE(6,'(F7.2,15F5.2)') (PFOM(K),K=1,MNCNT)#                           CP40 216
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP40 217
#                                                                       CP40 218
IF(PFOM(JJ)>100.) NEXT#                Best fit is lousy                CP40 219
#                                      Type change does not exist       CP40 220
USED(JJ)=yes:#                         Fudge: flag change as used       CP40 221
pt4:#                                                                   CP40 222
WRITE(6,'(I7  ,15I5  )') (USED(K),K=1,MNCNT)#                           CP40 223
#                                                                       CP40 224
pt3:#                                                                   CP40 225
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP40 226
CHROT=OUT1#                            Copy test string                 CP40 227
movertoc:(QX(MARK2+(ATZORD(NAT-1)-1)*ISCF+1),1,CHROT, 2,ISCF,1)#        CP40 228
movertoc:(QX(MARK2+(ATZORD(NAT  )-1)*ISCF+1),1,CHROT,10,ISCF,1)#        CP40 229
ncodefld:(ZP,1,CHROT,70313.,1)#        Lower boundary                   CP40 230
ncodefld:(Z ,1,CHROT,150313.,1)#       Upper boundary                   CP40 231
VAL=FLOAT((PEKLOC(JJ)-MARKA)/STEPA)#   How many peaks?                  CP40 232
ncodefld:(VAL,1,CHROT,420513.,1)#      Lower boundary                   CP40 233
ncodefld:(VAL+1.0,1,CHROT,610513.,1)#  Upper boundary                   CP40 234
VAL=peakh:(PEKLOC(JJ)-STEPA)#          Previous peak hight              CP40 235
ncodefld:(VAL,1,CHROT,490512.,1)#      Encode hight                     CP40 236
VAL=peakh:(PEKLOC(JJ))#                Next peak hight                  CP40 237
ncodefld:(VAL,1,CHROT,680512.,1)#      Encode hight                     CP40 238
writeline:(0,CHROT,NOUT1,3,3)#         Print peak difference header     CP40 239
#                                                                       CP40 240
CHROT=OUT3#                            Copy test string                 CP40 241
ncodefld:((ZP-Z)/Z,1,CHROT,490522.,1)# Expected diff ratio              CP40 242
VAL=peakh:(PEKLOC(JJ))#                Peak height less than boundary   CP40 243
VAL=(peakh:(PEKLOC(JJ)-STEPA)-VAL)/VAL# Greater than boundary           CP40 244
ncodefld:(VAL,1,CHROT,680522.,1)#      Actual  diff ratio               CP40 245
writeline:(0,CHROT,NOUT3,3,3)#         Print peak difference header     CP40 246
#                                                                       CP40 247
CHROT=OUT2#                            Copy test string                 CP40 248
ncodefld:(PREV      ,1,CHROT,490513.,1)# Expected prior peaks           CP40 249
ncodefld:(PEKCNT(JJ),1,CHROT,680513.,1)# Current prior sites            CP40 250
writeline:(0,CHROT,NOUT3,3,3)#         Print peak difference header     CP40 251
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP40 252
#                                                                       CP40 253
MAT(NAT)=ATZORD(NAT)#                  Z ordered modelled atom type     CP40 254
MAL(NAT)=PEKLOC(JJ)#                   Modelled atom change location    CP40 255
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP40 256
MAT(1)=ATZORD(1)#                      Assumes largest z atom type pr   CP40 257
MAL(1)=MARKA#                          Fudge first location             CP40 258
#                                                                       CP40 259
#IF(ATZ(ATZORD(NATYP))<=1.5)#           IGNORE HYDROGEN ATOMS           CP40 260
#$(                                                                     CP40 261
#MAT(NATYP)=ATZORD(NATYP)#              SET AS H ATOM                   CP40 262
#MAL(NATYP)=MAL(NATYP-1)+STEPA#         SAVE POINTER TO ATOM TYPE       CP40 263
#$)                                                                     CP40 264
#                                                                       CP40 265
#   CHECK THE ATZ(MAT(I)) ORDER                                         CP40 266
#   ---------------------------                                         CP40 267
#                                                                       CP40 268
SWAPED=no:#                            Assume  no swapping              CP40 269
REPEAT#                                Repeat until no swap required    CP40 270
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP40 271
SWAP=no:#                              Assume no swapping done          CP40 272
#                                      Looping backwards over types     CP40 273
DO I=NATYP,2,-1#                       First should always be right     CP40 274
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CP40 275
IF(MAL(I)>=MAL(I-1))NEXT#              Current has smaller z than pre   CP40 276
MATT=MAL(I);MAL(I)=MAL(I-1);MAL(I-1)=MATT# Swap atom change locations   CP40 277
SWAP=yes:#                             Had to swap                      CP40 278
SWAPED=yes:#                           Flag the swap                    CP40 279
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CP40 280
IF(SWAP==no:) BREAK#                   No more swaps required           CP40 281
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP40 282
#                                                                       CP40 283
IF(SWAPED==yes:)#                      Flag the swap                    CP40 284
pt1: writeline:(2,OUT4,NOUT4,3,1)#     Print peak difference header     CP40 285
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP40 286
#                                                                       CP40 287
#   ONLY LIGHT ATOMS OR ORGANICS (INSENSITIVE TO C N O DIFFERENCES)     CP40 288
#   ---------------------------------------------------------------     CP40 289
#                                                                       CP40 290
#   NOW UNDO ALL PREVIOUS GOOD WORK AND REPLACE WITH EMPIRICAL FUDGE    CP40 291
#   ------------------------------------------------------------------  CP40 292
#                                                                       CP40 293
#                                                                       CP40 294
NARANG=1#                              Number of atom ranges            CP40 295
FOR(I=2;I<=NATYP+1;I=I+1)#             Start from 2nd, i.e. look ahea   CP40 296
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CP40 297
NARANG=NARANG+1#                       Increment number of ranges       CP40 298
IF(ATZDIF(I)>0.5)#                     Large difference to next         CP40 299
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CP40 300
MAT(NARANG-1) = MAT(I-1)#              Treat all up to here as smalle   CP40 301
MAL(NARANG)=MAL(I)#                    Get next starter                 CP40 302
NEXT#                                  Look at next difference          CP40 303
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CP40 304
WHILE(ATZDIF(I)<=0.5 & I<=NATYP)I=I+1# Look ahead  until too far        CP40 305
I=I-1#                                 Then step back                   CP40 306
MAT(NARANG-1)=MAT(I)#                  Treat all up to here as smalle   CP40 307
MAL(NARANG)  =MAL(I+1)#                Get next starter                 CP40 308
DO J=NARANG,I;MAT(J)=0## ;MAL(J)=-1$)#  erase intermediates             CP40 309
I=I+1#                                                                  CP40 310
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CP40 311
#                                                                       CP40 312
#                                                                       CP40 313
MAT(NARANG)=0#                         Set as terminating flag          CP40 314
MAL(NARANG)=-1#                        Set as terminating flag          CP40 315
NARANG=NARANG-1#                       Number of atom ranges            CP40 316
#                                                                       CP40 317
IF(ORGANIC==yes:)#                     Fudge for h<zi<c  force to c     CP40 318
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CP40 319
DO I=1,NARANG#                         Loop over reduced types          CP40 320
IF(ATZ(MAT(I))<5.9)BREAK#              Break on first type below c      CP40 321
IF(ATZ(MAT(I-1))>6.1)#                 Did we skip c somewhere ?        CP40 322
DO J=1,NATYP;ifeq:(ATZ(J),6.0)MAT(I)=J# Nothing less than carbon        CP40 323
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CP40 324
#                                                                       CP40 325
#                                                                       CP40 326
#                                                                       CP40 327
#                                                                       CP40 328
pt2:#                                                                   CP40 329
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CP40 330
ncodefld:(FLOAT(NATYP),1,OUT5,160213.,1)# How many sf types?            CP40 331
writeline:(2,OUT5,NOUT5,3,1)#          Almagamating - header            CP40 332
ncodefld:(FLOAT(NARANG),1,OUT6,160213.,1)# Now how many z ranges        CP40 333
writeline:(0,OUT6,NOUT6,3,3)#          Almagamating - header            CP40 334
DO I=2,NARANG#                         Loop over expected diffs         CP40 335
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CP40 336
NAT =MAT(I-1)#                         Previous type                    CP40 337
NAT1=MAT(I)#                           Current type                     CP40 338
CHROT=OUT1#                            Copy test string                 CP40 339
movertoc:(QX(MARK2+(NAT -1)*ISCF+1),1,CHROT, 2,ISCF,1)#                 CP40 340
movertoc:(QX(MARK2+(NAT1-1)*ISCF+1),1,CHROT,10,ISCF,1)#                 CP40 341
ncodefld:(ATZ(NAT ),1,CHROT,70313.,1)# Lower boundary                   CP40 342
ncodefld:(ATZ(NAT1),1,CHROT,150313.,1)# Upper boundary                  CP40 343
VAL=FLOAT((MAL(I)-MARKA)/STEPA)#       How many peaks?                  CP40 344
ncodefld:(VAL    ,1,CHROT,420513.,1)#  Lower boundary                   CP40 345
ncodefld:(VAL+1.0,1,CHROT,610513.,1)#  Upper boundary                   CP40 346
VAL=peakh:(MAL(I)-STEPA)#              Previous peak hight              CP40 347
ncodefld:(VAL,1,CHROT,490512.,1)#      Encode hight                     CP40 348
VAL=peakh:(MAL(I))#                    Next peak hight                  CP40 349
ncodefld:(VAL,1,CHROT,680512.,1)#      Encode hight                     CP40 350
writeline:(0,CHROT,NOUT1,3,3)#         Print peak difference header     CP40 351
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CP40 352
#                                                                       CP40 353
#                                                                       CP40 354
#                                                                       CP40 355
#                                                                       CP40 356
ncodefld:(FLOAT((MAL(NARANG)-MARKA)/STEPA+1),1,OUT7,300513.,1)# Sites   CP40 357
ncodefld:(FLOAT((STOPA-MARKA)/STEPA),1,OUT7,390513.,1)# All sites       CP40 358
movertoc:(QX(MARK2+(MAT(NARANG-1) -1)*ISCF+1),1,OUT7,54,ISCF,1)#        CP40 359
writeline:(0,OUT7,NOUT7,3,3)#          Print peak difference header     CP40 360
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CP40 361
CHROT=' '#                             Erase string                     CP40 362
####MAL(NARANG)=STOPA#                 override last value (later)      CP40 363
#                                                                       CP40 364
#                                                                       CP40 365
RETURN#                                                                 CP40 366
END#                                                                    CP40 367
systemheader:(CP41)#                   Group sites into clusters        CP41   1
####################################################################### CP41   2
#                                                                       CP41   3
#                                CP41   (FORMERLY ML13)                 CP41   4
#                                                                       CP41   5
####################################################################### CP41   6
SUBROUTINE CP41#                                                        CP41   7
include:(AACOMN)#                                                       CP41   8
include:(CPCOMN)#                                                       CP41   9
#                                                                       CP41  10
INTEGER I,J,K,L,N#                                                      CP41  11
INTEGER IP,IB,JA,JP,KA,KP,FNEW,NC#     Cp4                              CP41  12
#                                                                       CP41  13
INTEGER IEXT#               ## Signal to extend input atom sites        CP41  14
REAL A,B,C,P,Q,R,X,Y,Z,U,V,W#                                           CP41  15
REAL SX,SY,SZ,CX,CY,CZ,CN#                                              CP41  16
REAL TM(3),DD,DIST,RAD,R2MAX#                                           CP41  17
chardata:(CP41A," Clustering sites for level 1 (bondlength) $#          CP41  18
geometry tests.")#                                                      CP41  19
chardata:(CP41B," Using radii based on expected peak-type.")#           CP41  20
chardata:(CP41C," Grouped peak sites into xx clusters.")#               CP41  21
chardata:(CP41D," Cluster xx comprised of xxxx sites.")#                CP41  22
chardata:(CP41E," Extending site list for internal molecular $#         CP41  23
symmetry.")#                                                            CP41  24
datastuff:#                                                             CP41  25
#                                                                       CP41  26
#  GROUP SITES INTO CONNECTED CLUSTERS ABOUT BODY CENTRE                CP41  27
#  -----------------------------------------------------                CP41  28
pt3: writeline:(2,CP41A,NCP41A,3,3)#   Doing the clustering             CP41  29
pt3: writeline:(0,CP41B,NCP41B,3,3)#   How ?                            CP41  30
#                                                                       CP41  31
IEXT=-1#                               Unset site extension flag        CP41  32
NCLUS=0;     STOPI=STOPA#              Initialize no. of clusters       CP41  33
FOR(K=1;K<=NFRAG;K=K+1)#               Loop over input fragments        CP41  34
MAXGRP=MAX0(MAXGRP,NINFR(K))#          Find max atoms in any frag       CP41  35
#                                                                       CP41  36
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over all sites              CP41  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP41  38
ifne:(clust:,0.) NEXT#                 Skip if cluster assigned         CP41  39
NCLUS=MIN0(NCLUS+1,32)#                Incr cluster counter             CP41  40
clust:=FLOAT(NCLUS)#                   Mark site with this cluster      CP41  41
N=1;   DIST=9999999.;   FNEW=yes:#     Zero cluster cnt & reset flg     CP41  42
X=peakx:;  Y=peaky:;  Z=peakz:#        Store site coords local          CP41  43
#                                                                       CP41  44
FOR(K=MARKS;K<STOPS;K=K+STEPS)#        Loop over all symops             CP41  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP41  46
U=X*QX(K+1)+Y*QX(K+4)+Z*QX(K+7)+QX(K+10)# Generate equivalent x         CP41  47
V=X*QX(K+2)+Y*QX(K+5)+Z*QX(K+8)+QX(K+11)# Generate equivalent y         CP41  48
W=X*QX(K+3)+Y*QX(K+6)+Z*QX(K+9)+QX(K+12)# Generate equivalent z         CP41  49
U=MOD(99.+U,1.)-0.5#                   Ensure x' close to x             CP41  50
V=MOD(99.+V,1.)-0.5#                   Ensure y' close to y             CP41  51
W=MOD(99.+W,1.)-0.5#                   Ensure z' close to z             CP41  52
DD=G1*U*U+G5*V*V+G9*W*W+G2*U*V+G3*U*W+G6*V*W# Distance squared          CP41  53
IF(DD>=DIST) NEXT#                     Skip if outside range            CP41  54
P=U+.5; Q=V+.5; R=W+.5; DIST=DD-0.01#  Store the closest coords         CP41  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP41  56
peakx:=P; peaky:=Q; peakz:=R#          Keep site closest to 0.          CP41  57
#                                                                       CP41  58
WHILE(FNEW==yes:)#                     Loop if new connects found       CP41  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP41  60
FNEW=no:#                              Assume no connects found         CP41  61
FOR(JP=MARKA;JP<STOPA;JP=JP+STEPA)#    Loop over all sites              CP41  62
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP41  63
ifne:(clust:(JP),clust:) NEXT#         Skip unless same cluster         CP41  64
RAD=atrad:(JP)#                        Get atom radius                  CP41  65
P=peakx:(JP); Q=peaky:(JP); R=peakz:(JP)# Get site coords to local      CP41  66
#                                                                       CP41  67
FOR(IP=MARKA;IP<STOPA;IP=IP+STEPA)#    Loop over all sites              CP41  68
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP41  69
ifne:(clust:(IP),0.) NEXT#             Skip if connected                CP41  70
R2MAX=(RAD+atrad:(IP))**2#             Get radius max squared           CP41  71
X=peakx:(IP); Y=peaky:(IP); Z=peakz:(IP)# Get site coords to local      CP41  72
#                                                                       CP41  73
FOR(K=MARKS;K<STOPS;K=K+STEPS)#        Loop over all symops             CP41  74
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP41  75
U=X*QX(K+1)+Y*QX(K+4)+Z*QX(K+7)+QX(K+10)# Generate equivalent x         CP41  76
V=X*QX(K+2)+Y*QX(K+5)+Z*QX(K+8)+QX(K+11)# Generate equivalent y         CP41  77
W=X*QX(K+3)+Y*QX(K+6)+Z*QX(K+9)+QX(K+12)# Generate equivalent z         CP41  78
U=MOD(99.5+U-P,1.)-0.5#                Ensure x' close to x             CP41  79
V=MOD(99.5+V-Q,1.)-0.5#                Ensure y' close to y             CP41  80
W=MOD(99.5+W-R,1.)-0.5#                Ensure z' close to z             CP41  81
DD=G1*U*U+G5*V*V+G9*W*W+G2*U*V+G3*U*W+G6*V*W# Distance squared          CP41  82
IF(DD<R2MAX) GOTO 100#                 Exit if connected                CP41  83
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP41  84
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP41  85
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP41  86
NEXT#                                  Atom not connected; get next     CP41  87
100 CONTINUE#                          Atom connected; bonded or twin   CP41  88
N=N+1;    FNEW=yes:#                   Count atoms in this cluster      CP41  89
peakx:(IP)=U+P#                        Calculate connected site x"      CP41  90
peaky:(IP)=V+Q#                        Calculate connected site y"      CP41  91
peakz:(IP)=W+R#                        Calculate connected site z"      CP41  92
clust:(IP)=clust:#                     Flag as connected                CP41  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP41  94
NPKCL(NCLUS)=N#                        Store sites in cluster           CP41  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP41  96
#                                                                       CP41  97
pt3:#                                                                   CP41  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP41  99
ncodefld:(FLOAT(NCLUS),1,CP41C,270213.,1)# Encode clusters              CP41 100
writeline:(0,CP41C,NCP41C,3,3)#        How many clusters ?              CP41 101
#                                                                       CP41 102
DO I=1,NCLUS#                                                           CP41 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP41 104
ncodefld:(FLOAT(I),1,CP41D,110213.,1)# Encode clusters                  CP41 105
ncodefld:(FLOAT(NPKCL(I)),1,CP41D,290413.,1)# Encode clusters           CP41 106
writeline:(0,CP41D,NCP41D,3,3)#        How many clusters ?              CP41 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP41 108
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP41 109
#                                                                       CP41 110
#                                                                       CP41 111
#                                                                       CP41 112
#                                                                       CP41 113
#    EXPAND INPUT ATOM LIST FOR BONDED SYMMETRY RELATED SITES           CP41 114
#    --------------------------------------------------------           CP41 115
#                                                                       CP41 116
IF(SYMXMOL==yes:)writeline:(0,CP41E,NCP41E,3,3)# Extending molec sym    CP41 117
IF(SYMXMOL==yes:)#                     Extend molec for molec symm      CP41 118
FOR(FNEW=IEXT;FNEW==yes:;)#            Loop until no connections        CP41 119
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP41 120
FNEW=no:#                              Assume no connections found      CP41 121
FOR(KP=MARKA;KP<STOPA1;KP=KP+STEPA)#   Loop over all sites              CP41 122
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP41 123
RAD=atrad:#                            Get atom radius                  CP41 124
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symops                 CP41 125
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP41 126
U=peakx:*QX(J+1)+peaky:*QX(J+4)+peakz:*QX(J+7)+QX(J+10)# New x'         CP41 127
V=peakx:*QX(J+2)+peaky:*QX(J+5)+peakz:*QX(J+8)+QX(J+11)# New y'         CP41 128
W=peakx:*QX(J+3)+peaky:*QX(J+6)+peakz:*QX(J+9)+QX(J+12)# New z'         CP41 129
#                                                                       CP41 130
FOR(JA=MARKA;JA<STOPA1;JA=JA+STEPA)#   Loop thro. all stored atoms      CP41 131
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP41 132
ifne:(clust:,clust:(JA))  NEXT#        Skip if different cluster        CP41 133
IF(KP==JA&J==MARKS) NEXT#              Avoid identical overlap          CP41 134
P=MOD(99.5+U-peakx:(JA),1.0)-0.5#      Get closest bonded atom          CP41 135
Q=MOD(99.5+V-peaky:(JA),1.0)-0.5#      Get closest bonded atom          CP41 136
R=MOD(99.5+W-peakz:(JA),1.0)-0.5#      Get closest bonded atom          CP41 137
DD=G1*P*P+G5*Q*Q+G9*R*R+G2*P*Q+G3*P*R+G6*Q*R# Get distance squared      CP41 138
IF(DD<.01\DD>(RAD+atrad:(JA))**2) NEXT# Skip if not bonded              CP41 139
P=P+peakx:(JA); Q=Q+peaky:(JA); R=R+peakz:(JA)# Store new coords        CP41 140
#                                                                       CP41 141
FOR(KA=MARKA;KA<STOPA1;KA=KA+STEPA)#   Atom pos. already stored ?       CP41 142
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP41 143
ifne:(clust:,clust:(KA))   NEXT#       Skip if different cluster        CP41 144
IF(ABS(MOD(99.5+P-peakx:(KA),1.)-.5)>.001) NEXT# Skip if x coord diff   CP41 145
IF(ABS(MOD(99.5+Q-peaky:(KA),1.)-.5)>.001) NEXT# Skip if y coord diff   CP41 146
IF(ABS(MOD(99.5+R-peakz:(KA),1.)-.5)<.001) BREAK# Break if pos. equiv   CP41 147
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP41 148
IF(KA<STOPA1) NEXT#                    Pos. not found-new atom          CP41 149
I=STOPA1;      FNEW=yes:#              Save current end of list         CP41 150
incrqx:(STOPA1,STOPA1+STEPA,CP4101)#   Sym related list - out of memo   CP41 151
peakx:(I)=P; peaky:(I)=Q; peakz:(I)=R# Store new coords                 CP41 152
clust:(I)=clust:#                      Store cluster                    CP41 153
numbr:(I)=numbr:#                      Store site number                CP41 154
peakh:(I)=peakh:#                      Store peakheight                 CP41 155
movereal:(aname:,1,aname:(I),1,1,0)#   New atom name                    CP41 156
#                                                                       CP41 157
# FOR A POLYMER THIS COULD CONTINUE INDEFINITELY                        CP41 158
# SO LETS TRUNCATE IT WHEN ALL SYM RELATED SITES HAVE BEEN INCLUDED     CP41 159
#                                                                       CP41 160
IF((STOPA1-MARKA)/STEPA>NSYM*(STOPA-MARKA)/STEPA) GOTO 200#             CP41 161
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP41 162
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP41 163
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP41 164
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP41 165
200 CONTINUE#                          Exit for site list overflow      CP41 166
#                                                                       CP41 167
#   PACK CENTRES OF CLUSTERS CLOSE TOGETHER                             CP41 168
#   ---------------------------------------                             CP41 169
#                                                                       CP41 170
DO NC=1,NCLUS#                         Loop over clusters               CP41 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP41 172
CN=0.;  SX=0.;  SY=0.;  SZ=0.#         Zero centre sums                 CP41 173
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over all sites              CP41 174
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP41 175
IF(NINT(clust:)!=NC) NEXT#             Skip if not in this cluster      CP41 176
CN=CN+1.#                              Count contributions              CP41 177
SX=SX+peakx:#                          Sum x coords                     CP41 178
SY=SY+peaky:#                          Sum y coords                     CP41 179
SZ=SZ+peakz:#                          Sum z coords                     CP41 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP41 181
IF(CN>0.5)#                            If there are contributors        CP41 182
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP41 183
SX=SX/CN;  SY=SY/CN;  SZ=SZ/CN#        Store centre of cluster          CP41 184
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP41 185
#                                                                       CP41 186
IF(NC==1)#                             For cluster 1                    CP41 187
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP41 188
CX=SX;  CY=SY;  CZ=SZ;  NEXT#          Save centre first cluster        CP41 189
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP41 190
DIST=99999999.#                        Set initial vector               CP41 191
FOR(K=MARKS;K<STOPS;K=K+STEPS)#        Loop over all symops             CP41 192
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP41 193
X=SX*QX(K+1)+SY*QX(K+4)+SZ*QX(K+7)+QX(K+10)# Generate equivalent x      CP41 194
Y=SX*QX(K+2)+SY*QX(K+5)+SZ*QX(K+8)+QX(K+11)# Generate equivalent y      CP41 195
Z=SX*QX(K+3)+SY*QX(K+6)+SZ*QX(K+9)+QX(K+12)# Generate equivalent z      CP41 196
P=X-CX;  Q=Y-CY;  R=Z-CZ#              Get diff with centre 1           CP41 197
U=MOD(99.5+P,1.)-0.5#                  Ensure x' close to centre 1      CP41 198
V=MOD(99.5+Q,1.)-0.5#                  Ensure y' close to centre 1      CP41 199
W=MOD(99.5+R,1.)-0.5#                  Ensure z' close to centre 1      CP41 200
DD=G1*U*U+G5*V*V+G9*W*W+G2*U*V+G3*U*W+G6*V*W# Distance squared          CP41 201
IF(DD>=DIST) NEXT#                     Skip if not smallest             CP41 202
A=P-U; B=Q-V; C=R-W; J=K; DIST=DD-0.01# Closest to centre 1             CP41 203
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP41 204
#                                                                       CP41 205
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over all sites              CP41 206
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP41 207
IF(NINT(clust:)!=NC) NEXT#             Skip if not this cluster         CP41 208
X=peakx:*QX(J+1)+peaky:*QX(J+4)+peakz:*QX(J+7)+QX(J+10)# Generate  x    CP41 209
Y=peakx:*QX(J+2)+peaky:*QX(J+5)+peakz:*QX(J+8)+QX(J+11)# Generate  y    CP41 210
Z=peakx:*QX(J+3)+peaky:*QX(J+6)+peakz:*QX(J+9)+QX(J+12)# Generate  z    CP41 211
peakx:=X-A#                            Move x to new centre             CP41 212
peaky:=Y-B#                            Move y to new centre             CP41 213
peakz:=Z-C#                            Move z to new centre             CP41 214
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP41 215
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP41 216
#                                                                       CP41 217
#    ENSURE CENTRE OF COMBINED CLUSTERS INSIDE CELL                     CP41 218
#    ----------------------------------------------                     CP41 219
#                                                                       CP41 220
DO I=1,3; TM(I)=0.;    CN=0.#          Set centre sums to zero          CP41 221
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over all sites              CP41 222
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CP41 223
CN=CN+1.#                              Count contributions              CP41 224
DO I=1,3; TM(I)=TM(I)+QX(KP+I)#        Sum all coords                   CP41 225
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CP41 226
IF(CN>0.5)#                            If there are contributors        CP41 227
DO I=1,3#                              Loop over coords                 CP41 228
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CP41 229
TM(I)=TM(I)/CN#                        Get average coord                CP41 230
IF     (TM(I)<0.) TM(I)=+1.#           Centre out of cell               CP41 231
ELSE IF(TM(I)>1.) TM(I)=-1.#           Centre out of cell               CP41 232
ELSE              TM(I)= 0.#           Centre in cell                   CP41 233
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CP41 234
#                                                                       CP41 235
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over all sites              CP41 236
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CP41 237
DO I=1,3; QX(KP+I)=QX(KP+I)+TM(I)#     Move to new centre               CP41 238
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CP41 239
#                                                                       CP41 240
#   MARK START OF CONNECTION ARRAYS                                     CP41 241
#   -------------------------------                                     CP41 242
#                                                                       CP41 243
MARKB=STOPA1#                          Start of bond list               CP41 244
STOPB=MARKB#                           End of current bondlist          CP41 245
STEPB=3#                               Set steps bond & twin list       CP41 246
#                                                                       CP41 247
#   COUNT ALL CONNECTED SITES                                           CP41 248
#   -------------------------                                           CP41 249
#                                                                       CP41 250
IB=MARKB#                              Start of bond table              CP41 251
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over all sites              CP41 252
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CP41 253
X=peakx:; Y=peaky:; Z=peakz:; RAD=atrad:# Store site coords local       CP41 254
#                                                                       CP41 255
FOR(JP=MARKA;JP<STOPA;JP=JP+STEPA)#    Loop over all sites              CP41 256
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CP41 257
ifne:(clust:,clust:(JP)) NEXT#         Skip if not the same cluster     CP41 258
IF(KP==JP) NEXT#                       Skip identical sites             CP41 259
U=X-peakx:(JP);V=Y-peaky:(JP);W=Z-peakz:(JP)# Get displacements         CP41 260
DD=SQRT(G1*U*U+G5*V*V+G9*W*W+G2*U*V+G3*U*W+G6*V*W)# Distance squared    CP41 261
IF(DD>RAD+atrad:(JP)) NEXT#            Skip unconnected sites           CP41 262
I=(KP-MARKA)/STEPA;  J=(JP-MARKA)/STEPA# Extract list serial no.s       CP41 263
incrqx:(STOPB,IB+STEPB,CP4103)#        Get mem for new bond             CP41 264
peak1:=FLOAT(KP)#                      Store site address 1             CP41 265
intpak:(J,peak2:, 0,mxbtwd:)#          Store site number 2              CP41 266
intpak:(I,peak2:,16,     16)#          Store sort number                CP41 267
bondl:=DD#                             Store intersite distance         CP41 268
IB=STOPB#                              Incr bond list pointer           CP41 269
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CP41 270
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CP41 271
NBOND=(STOPB-MARKB)/STEPB#             Store total bonds                CP41 272
#                                                                       CP41 273
#  SORT CONNECT ATOMS LIST IN INCREASING SITE NUMBER                    CP41 274
#  -------------------------------------------------                    CP41 275
#                                                                       CP41 276
FOR(N=NBOND/2;N>0;N=N/2)#              This is a shell sort             CP41 277
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CP41 278
L=STEPB*N#                             Get n step                       CP41 279
FOR(I=MARKB+L+STEPB;I<STOPB;I=I+STEPB)# Forward list loop               CP41 280
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CP41 281
FOR(J=I-L;J>MARKB;J=J-STEPB)#          Backward list loop               CP41 282
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CP41 283
IB=J+L#                                Incr spacer                      CP41 284
compakwd:(peak2:(J),LE,peak2:,BREAK)#  Compare packed site no.s         CP41 285
movereal:(QX,IB+1,TM,   1,3,0)#        Save first bond                  CP41 286
movereal:(QX,J +1,QX,IB+1,3,0)#        Transfer second bond             CP41 287
movereal:(TM,   1,QX,J +1,3,0)#        Transfer first bond              CP41 288
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CP41 289
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CP41 290
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CP41 291
#                                                                       CP41 292
#   COUNT CONNECTS TO EACH SITE                                         CP41 293
#   ---------------------------                                         CP41 294
#                                                                       CP41 295
KP=MARKA;  A=FLOAT(STEPB)#             Point to start of site list      CP41 296
FOR(IB=MARKB;IB<STOPB;IB=IB+STEPB)#    Loop over bond list              CP41 297
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CP41 298
intunpak:(peak2:,I,0,16)#              Extract site number              CP41 299
peak2:=FLOAT(MARKA+I*STEPA)#           Store as site address            CP41 300
N=NINT(peak1:)#                        Get site address                 CP41 301
FOR(;KP<=N;KP=KP+STEPA)#               Loop over site list              CP41 302
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CP41 303
bond1:=FLOAT(IB)#                      Store bond list pointer          CP41 304
bond2:=FLOAT(IB)#                      Store bondlist stop              CP41 305
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CP41 306
nbond:(N)=nbond:(N)+1.#                Count bonds to site              CP41 307
bond2:(N)=bond2:(N)+A#                 Incr bondlist stop addr.         CP41 308
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CP41 309
FOR(;KP<STOPA;KP=KP+STEPA)#            Loop over remaining sites        CP41 310
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CP41 311
bond1:=FLOAT(STOPB)#                   Store bond list start            CP41 312
bond2:=FLOAT(STOPB)#                   Store bond list end              CP41 313
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CP41 314
TCLUS=NCLUS#                           Store total clusters             CP41 315
#                                                                       CP41 316
#                                                                       CP41 317
MARKT=STOPB#                           Start of twin list               CP41 318
STOPT=STOPB#                                                            CP41 319
MARKC=STOPB#                                                            CP41 320
STOPC=STOPB#                                                            CP41 321
#                                                                       CP41 322
#  MEMORY MAP                                                           CP41 323
#  ----------                                                           CP41 324
#   MARKA                  START OF PEAK HEIGHT ORDERED ATOM SITES      CP41 325
#   STEPA=21+MAXBON#       SIZE OF EACH ATOM SITE                       CP41 326
#   STOPA                  END OF PEAKLIST                              CP41 327
#   MARKB                  START OF ATOM BONDLISTS                      CP41 328
#   STEPB=3                STEPS OF BONDLIST =3                         CP41 329
#   STOPB                  END OF BONDLIST                              CP41 330
#                                                                       CP41 331
#   MARKC                  START OF FIG OF MERIT FOR CLUSTERS           CP41 332
#   STEPC=1                                                             CP41 333
#   STOPC                  START OF FIG OF MERIT FOR CLUSTERS           CP41 334
#                                                                       CP41 335
#                                                                       CP41 336
RETURN#                                                                 CP41 337
END#                                                                    CP41 338
systemheader:(CP42)#                   Select site to start search      CP42   1
####################################################################### CP42   2
#                                                                       CP42   3
#                                CP42 (FORMERLY ML20)                   CP42   4
#                                                                       CP42   5
####################################################################### CP42   6
SUBROUTINE CP42#                                                        CP42   7
include:(AACOMN)#                                                       CP42   8
include:(CPCOMN)#                                                       CP42   9
#                                                                       CP42  10
INTEGER KP,IB#                                                          CP42  11
#                                                                       CP42  12
#   CHECK THE NUMBER OF BOND CONNECTIONS                                CP42  13
#   ------------------------------------                                CP42  14
#                                                                       CP42  15
ISTART=0#                              Set initial site number          CP42  16
IF(NPKCL(NCLUS)>2)#                    Look at clusters >2              CP42  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP42  18
IF(NTERP==1) TOPFOM=0.1#               Reset cluster fom max            CP42  19
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over site list              CP42  20
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP42  21
movereal:(0.,1,ringf:,1,MAXBON+6,2)#   Zero site parameters             CP42  22
IF(NINT(clust:)==NCLUS)nbond:=(bond2:-bond1:)/3.# Number of bonds       CP42  23
IF(NTERP==1) start:=0.#                Reset starter flag               CP42  24
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP42  25
FOR(IB=MARKB;IB<STOPB;IB=IB+STEPB)#    Loop over bond list              CP42  26
peak1:=ABS(peak1:)#                    Reset bond cancel flag           CP42  27
#                                                                       CP42  28
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Look for first site in nclus     CP42  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP42  30
IF(NINT(clust:)!=NCLUS) NEXT#          Skip until match found           CP42  31
IF((start:>.5)\(nbond:<.5)) NEXT#      Skip if started or void          CP42  32
ISTART=KP#                             Get site list start addr.        CP42  33
start:=1.0#                            Mark this as used for starti     CP42  34
BREAK#                                                                  CP42  35
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP42  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP42  37
#                                                                       CP42  38
RETURN#                                                                 CP42  39
END#                                                                    CP42  40
#                                                                       CP42  41
systemheader:(CP43)#                   Weighted subcluster search       CP43   1
####################################################################### CP43   2
#                                                                       CP43   3
#                                CP43 (FORMERLY ML35)                   CP43   4
#                                                                       CP43   5
####################################################################### CP43   6
SUBROUTINE CP43#                                                        CP43   7
include:(AACOMN)#                                                       CP43   8
include:(CPCOMN)#                                                       CP43   9
#                                                                       CP43  10
INTEGER IB,JB,IP,JP,KP#                Loop indices                     CP43  11
INTEGER IB1,IB2,IB3#                   Loop limits                      CP43  12
INTEGER M,IS,LP,NB,KB#                                                  CP43  13
INTEGER OFFSET#                                                         CP43  14
REAL COSA,CMAX,CMIN,BMIN#              Cosine & limits                  CP43  15
REAL DD,DX,DY,DZ,DS,DM,CS,CM#          Bond distance & dif xyz          CP43  16
REAL A,BB,WW,WT#                                                        CP43  17
REAL RADMX,RADMN,ANGMN,ANGMX#                                           CP43  18
REAL CLUFOM(32)#                       Fig of merit for cluster         CP43  19
realdata:(DTOR,0.0174533)#                                              CP43  20
datastuff:#                                                             CP43  21
#                                                                       CP43  22
#  REPLICATE THE ENTIRE BONDLIST TO ENABLE SAVING STATE                 CP43  23
#  ----------------------------------------------------                 CP43  24
#                                                                       CP43  25
incrqx:(STOPT,MARKT+STOPB-MARKB,CP4301)# Get space for duplication      CP43  26
movereal:(QX,MARKB+1,QX,MARKT+1,STOPB-MARKB,1)# Copy the bondlist       CP43  27
OFFSET=STOPB-MARKB#                                                     CP43  28
#                                                                       CP43  29
#   PREPARE TO APPLY LIMITS                                             CP43  30
#   -----------------------                                             CP43  31
#                                                                       CP43  32
RADMX=4.*RADMAX**2#                    Square search limit              CP43  33
RADMN=4.*RADMIN**2#                    Square search limit              CP43  34
ANGMX=ANGMAX*DTOR#                     Convert to radians               CP43  35
ANGMN=ANGMIN*DTOR#                     Convert to radians               CP43  36
#                                                                       CP43  37
#                                                                       CP43  38
IF(ANGMX>3.) CMAX=-2.#                 Allow for max of 180 deg         CP43  39
ELSE         CMAX=COS(ANGMX)#          Find cos of max allowed angl     CP43  40
CMIN=COS(ANGMN)#                       And min allowed angle            CP43  41
BMIN=SQRT(RADMN)#                      Get bond minimum                 CP43  42
MSUB=0#                                Zero subcluster limits           CP43  43
DS=(SQRT(RADMX)-BMIN)/2.;   DM=BMIN+DS# Calc bond span & mean           CP43  44
CS=(CMAX-CMIN)/2.;       CM=CMIN+CS#   Calc cos**2 span & mean          CP43  45
#                                                                       CP43  46
#  DETERMINE STRUCTURE AND FOM FROM PEAKS                               CP43  47
#  --------------------------------------                               CP43  48
#                                                                       CP43  49
FOR(NCLUS=1; NCLUS<=TCLUS; NCLUS=NCLUS+1)# Loop over site clusters      CP43  50
FOR(NTERP=1; NTERP<=MTERP; NTERP=NTERP+1)# Loop over interpretation     CP43  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP43  52
CALL CP42## ML20                       Start interpretation run         CP43  53
IF(ISTART==0) BREAK#                   No more interpretations          CP43  54
#                                                                       CP43  55
#                                                                       CP43  56
#   LOOP OVER SITELIST FROM START                                       CP43  57
#   -----------------------------                                       CP43  58
#                                                                       CP43  59
FOR(IS=ISTART;IS<STOPA1;IS=IS+STEPA)#  Loop over site list              CP43  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP43  61
IF((NINT(clust:(IS))!=NCLUS)$#         If site not in cluster           CP43  62
\  (ABS(group:(IS))>small:)$#          If subcluster unassigned         CP43  63
\  (nbond:(IS)<.5))            NEXT#   Site is not connected            CP43  64
#                TCPT LAST ONE REJECTED ANY FREE H2O MOLECULES          CP43  65
MSUB=MSUB+1#                           Incr subcluster count            CP43  66
group:(IS)=FLOAT(MSUB)#                Store subcluster number          CP43  67
NSUB(MSUB)=1#                          Increment count of sites in      CP43  68
KP=IS#                                 Set the central site i           CP43  69
#                                                                       CP43  70
#   LOOP UNTIL ALL SUBCLUSTER TESTS COMPLETE                            CP43  71
#   ----------------------------------------                            CP43  72
#                                                                       CP43  73
WHILE(KP<STOPA1)#                      Loop until tests complete        CP43  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP43  75
IB1=NINT(bond1:)#                      Point to start connect bonds     CP43  76
IB2=NINT(bond2:)#                      Point to end connect bonds       CP43  77
IB3=IB2-STEPB#                         Point to last bond               CP43  78
#                                                                       CP43  79
#    TEST BONDLENGTHS OF CONNECTED SITES                                CP43  80
#    -----------------------------------                                CP43  81
#                                                                       CP43  82
FOR(IB=IB1;IB<IB2;IB=IB+STEPB)#        Loop over bond list              CP43  83
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP43  84
IF((peak1:<.5)\(bondl:>BMIN)) NEXT#    Skip if not too close            CP43  85
IP=NINT(peak2:)#                       Point to sitelist                CP43  86
cullsite:(IP)#                         Disable site and bonds           CP43  87
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP43  88
#                                                                       CP43  89
#  TEST BOND ANGLES TO SITES IN SAME SUBCLUSTER                         CP43  90
#  --------------------------------------------                         CP43  91
#  (INITIALLY THERE ARE NO SITES IN THE SUBCLUSTER I.E. GROUP:==0 )     CP43  92
#                                                                       CP43  93
IF(nbond:>1.1)#                        Test connect bons exceeds 1      CP43  94
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP43  95
M=0#                                   Set flag for central site        CP43  96
FOR(IB=IB1;IB<IB2;IB=IB+STEPB)#        Primary  bond list loop          CP43  97
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP43  98
IF(peak1:<.5) NEXT#                    Skip if bond disabled            CP43  99
LP=NINT(peak2:)#                       Point to site list               CP43 100
IF(NINT(ABS(group:(LP)))!=MSUB) NEXT#  Skip bond if diff subcluster     CP43 101
#                                                                       CP43 102
FOR(JB=IB1;JB<IB2;JB=JB+STEPB)#        Secondary bond list loop         CP43 103
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP43 104
IF(peak1:(JB)<.5) NEXT#                Skip disabled bonds              CP43 105
JP=NINT(peak2:(JB))#                   Point to site list               CP43 106
IF(JP==LP) NEXT#                       Skip if same site                CP43 107
DX=peakx:(JP)-peakx:(LP)#              Get x difference                 CP43 108
DY=peaky:(JP)-peaky:(LP)#              Get y difference                 CP43 109
DZ=peakz:(JP)-peakz:(LP)#              Get z difference                 CP43 110
DD=G1*DX**2+G6*DY*DZ$#                 Calculate distance squared       CP43 111
+  G5*DY**2+G3*DX*DZ$#                 Calculate distance squared       CP43 112
+  G9*DZ**2+G2*DX*DY#                  Calculate distance squared       CP43 113
COSA=(bondl:(JB)**2+bondl:**2-DD)$#    Calculate cosine angle           CP43 114
/(2.*bondl:(JB)*bondl:)#               Calculate cosine angle           CP43 115
IF((COSA>=CMAX)&(COSA<=CMIN)) NEXT#    Skip if angles within limits     CP43 116
ifeq:(group:(JP),0.) cullsite:(JP)#    Reject connected site            CP43 117
ELSE IF(NINT(ABS(group:(JP)))==MSUB)#  If in same subcluster            CP43 118
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP43 119
NSUB(MSUB)=NSUB(MSUB)-1#               Decrement subcluster count       CP43 120
IF(group:(JP)>.5) cullsite:(JP)#       If positive disable j            CP43 121
ELSE#                                  Else disable central site        CP43 122
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP43 123
cullsite:(KP);  M=1#                   Disable i and flag               CP43 124
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP43 125
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP43 126
#                                                                       CP43 127
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP43 128
IF(M==1) GO TO 100#                    Exit if central site disable     CP43 129
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP43 130
#                                                                       CP43 131
#  TEST ANGLES WITH SITES J & L NOT IN SUBCLUSTER                       CP43 132
#  ---------------------------------------------                        CP43 133
#                                                                       CP43 134
WT=0.;    NB=0#                        Set initial weight & pointer     CP43 135
FOR(KB=IB1;KB<IB2;KB=KB+STEPB)#        Loop over all bonds              CP43 136
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP43 137
IF(peak1:(KB)<.5) NEXT#                Skip rejected bonds              CP43 138
FOR(IB=IB1;IB<IB2;IB=IB+STEPB)#        Loop over all bonds              CP43 139
IF(peak1:<.5) bondl:=-ABS(bondl:)#     Switch off reject bonds          CP43 140
ELSE          bondl:= ABS(bondl:)#     Switch on  other  bonds          CP43 141
WW=0.;   IB=IB1#                       Reset weight & pointer           CP43 142
LP=NINT(peak2:(KB))#                   Get site 2 address               CP43 143
BB=bondl:(KB)#                         Get first bond                   CP43 144
REPEAT#                                Loop until all lp tested         CP43 145
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP43 146
A=1.-ABS((BB-DM)/DS)#                  Form bond dist weight            CP43 147
WW=WW+A#                               Add distance weight              CP43 148
FOR(JB=IB1;JB<IB2;JB=JB+STEPB)#        Secondary bond list loop         CP43 149
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP43 150
IF(bondl:(JB)<0.) NEXT#                Skip if bond disabled            CP43 151
JP=NINT(peak2:(JB))#                   Get sitelist pointer j           CP43 152
ifne:(group:(JP),0.) NEXT#             Skip if already assigned         CP43 153
DX=peakx:(JP)-peakx:(LP)#              Get x difference                 CP43 154
DY=peaky:(JP)-peaky:(LP)#              Get y difference                 CP43 155
DZ=peakz:(JP)-peakz:(LP)#              Get z difference                 CP43 156
DD=G1*DX**2+G6*DY*DZ$#                 Calculate distance squared       CP43 157
+  G5*DY**2+G3*DX*DZ$#                 Calculate distance squared       CP43 158
+  G9*DZ**2+G2*DX*DY#                  Calculate distance squared       CP43 159
COSA=(bondl:(JB)**2+BB**2-DD)$#        Calculate cosine angle           CP43 160
/(2.*bondl:(JB)*BB)#                   Calculate cosine angle           CP43 161
IF((COSA<CMAX)\(COSA>CMIN)) bondl:(JB)=-bondl:(JB)# Temp reject bond    CP43 162
ELSE WW=WW+1.-ABS((COSA-CM)/CS)#       Sum bond & angle weights         CP43 163
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP43 164
FOR(;IB<IB2;IB=IB+STEPB)#              Loop along bond list             CP43 165
IF(IB!=KB&bondl:>0.) BREAK#            Get next lp site                 CP43 166
IF(IB==IB2) BREAK#                     Exit after last                  CP43 167
LP=NINT(peak2:)#                       Get next lp site                 CP43 168
BB=bondl:#                             Get bond distance                CP43 169
IB=IB+STEPB#                           Reset bond pointer               CP43 170
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP43 171
IF(WW<=WT) NEXT#                       Skip if new wt smaller           CP43 172
WT=WW;   NB=KB#                        Store best connects              CP43 173
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP43 174
FOR(IB=IB1;IB<IB2;IB=IB+STEPB)#        Loop over all bonds              CP43 175
bondl:=ABS(bondl:)#                    Reset bond lengths               CP43 176
#                                                                       CP43 177
#                                                                       CP43 178
#                                                                       CP43 179
#                                                                       CP43 180
IF(NB>0)#                              If new lp site found             CP43 181
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP43 182
IB=IB1#                                Set start lp pointer             CP43 183
LP=NINT(peak2:(NB))#                   Set first lp site                CP43 184
BB=bondl:(NB)#                         Get first bond                   CP43 185
REPEAT#                                Loop for all lp's                CP43 186
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP43 187
ifeq:(group:(LP),0.)#                  Skip assigned sites              CP43 188
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP43 189
group:(LP)=FLOAT(MSUB)#                Set at current subcluster        CP43 190
NSUB(MSUB)=NSUB(MSUB)+1#               Increment count of sites         CP43 191
FOR(JB=IB1;JB<IB2;JB=JB+STEPB)#        Secondary bond list loop         CP43 192
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP43 193
IF(JB==NB\peak1:(JB)<.5) NEXT#         Skip if bond disabled            CP43 194
JP=NINT(peak2:(JB))#                   Get sitelist pointer j           CP43 195
ifne:(group:(JP),0.) NEXT#             Skip if already assigned         CP43 196
DX=peakx:(JP)-peakx:(LP)#              Get x difference                 CP43 197
DY=peaky:(JP)-peaky:(LP)#              Get y difference                 CP43 198
DZ=peakz:(JP)-peakz:(LP)#              Get z difference                 CP43 199
DD=G1*DX**2+G6*DY*DZ$#                 Calculate distance squared       CP43 200
+  G5*DY**2+G3*DX*DZ$#                 Calculate distance squared       CP43 201
+  G9*DZ**2+G2*DX*DY#                  Calculate distance squared       CP43 202
COSA=(bondl:(JB)**2+BB**2-DD)$#        Calculate cosine angle           CP43 203
/(2.*bondl:(JB)*BB)#                   Calculate cosine angle           CP43 204
IF((COSA<CMAX)\(COSA>CMIN)) cullsite:(JP)# Disable site j               CP43 205
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP43 206
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP43 207
FOR(;IB<IB2;IB=IB+STEPB)#              Loop along bonds                 CP43 208
IF(IB!=NB&peak1:>.5) BREAK#            Exit if next lp                  CP43 209
IF(IB==IB2) BREAK#                     Exit after last lp               CP43 210
LP=NINT(peak2:)#                       Get site address                 CP43 211
BB=bondl:#                             Get bond distance                CP43 212
IB=IB+STEPB#                           Incr bond pointer                CP43 213
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP43 214
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP43 215
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP43 216
#                                                                       CP43 217
#   TEST LAST CONNECTED SITE FOR CLUSTER                                CP43 218
#   ------------------------------------                                CP43 219
#                                                                       CP43 220
IF(peak1:(IB3)>.5)#                    Test if last site disabled       CP43 221
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP43 222
JP=NINT(peak2:(IB3))#                  Get sitelist pointer j           CP43 223
ifeq:(group:(JP),0.)#                  Skip if already assigeqd         CP43 224
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP43 225
group:(JP)=FLOAT(MSUB)#                Assign site to subcluster        CP43 226
NSUB(MSUB)=NSUB(MSUB)+1#               Increment count of sites         CP43 227
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP43 228
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP43 229
group:=-ABS(group:)#                   Flag site as processed           CP43 230
#                                                                       CP43 231
#  FIND NEXT SITE IN THIS SUBCLUSTER                                    CP43 232
#  ---------------------------------                                    CP43 233
#                                                                       CP43 234
100 CONTINUE#                          Branch point for retry           CP43 235
FOR(KP=MARKA;KP<STOPA1;KP=KP+STEPA)#   Loop over entire site list       CP43 236
IF(NINT(group:)==MSUB) BREAK#          Exit at first match              CP43 237
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP43 238
#                                                                       CP43 239
#   ACCEPT SUBCLUSTER IF MORE TCPN ONE SITE                             CP43 240
#   ---------------------------------------                             CP43 241
#                                                                       CP43 242
IF(NSUB(MSUB)>1) NEXT#                 Skip to next site if ok          CP43 243
group:(IS)=0.#                         Cancel subcluster number         CP43 244
MSUB=MSUB-1#                           Decrement subcluster count       CP43 245
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP43 246
#                                                                       CP43 247
#  CALCULATE FIGURE OF MERIT FOR CLUSTER INTERPRETATION                 CP43 248
#  ----------------------------------------------------                 CP43 249
#                                                                       CP43 250
CALL CP44#   ## ML37                   Calculate figure of merit        CP43 251
IF(FOMP<=CLUFOM(NCLUS))NEXT#           Not best cluster interpretatio   CP43 252
#                                      Else save the best               CP43 253
FOR(KP=MARKA;KP<STOPA1;KP=KP+STEPA)#   Loop over all sites              CP43 254
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP43 255
IF(NINT(clust:)!=NCLUS) NEXT#          Skip sites not in cluster        CP43 256
ringf:=group:#                         Duplicate the group state        CP43 257
IB2=NINT(bond2:)#                      Get end of bond sequence         CP43 258
IB1=NINT(bond1:)#                      Get start of bond sequence       CP43 259
movereal:(QX,IB1+1,QX,OFFSET+IB1+1,IB2-IB1,1)# Copy the bond state      CP43 260
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP43 261
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP43 262
#                                                                       CP43 263
#   SHOULD NOW HAVE SAVED THE BEST INTERPRETATION FOR ALL CLUSTERS      CP43 264
#   SO RELOAD BEST OF EACH - AS STORED                                  CP43 265
#                                                                       CP43 266
FOR(KP=MARKA;KP<STOPA1;KP=KP+STEPA)#   Loop over all sites              CP43 267
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CP43 268
IB2=NINT(bond2:)#                      Get end of bond sequence         CP43 269
IB1=NINT(bond1:)#                      Get end of bond sequence         CP43 270
movereal:(QX,IB1+OFFSET+1,QX,IB1+1,IB2-IB1,1)# Copy the bond state      CP43 271
JP=KP+modellist:;   IP=JP+MAXBON#      Get sitelist bond bias           CP43 272
FOR(IB=IB1;IB<IB2;IB=IB+STEPB)#        Loop over bond list              CP43 273
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CP43 274
IF(JP==IP) peak1:=-ABS(peak1:)#        Suppress excess sites            CP43 275
IF(peak1:<.5) NEXT#                    Skip disabled sites              CP43 276
JP=JP+1#                               Incr sitelist pointer            CP43 277
QX(JP)=peak2:#                         Store bonded site addr.          CP43 278
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CP43 279
nbond:=FLOAT(JP-KP-modellist:)#        Store num accepted bonds         CP43 280
IF(nbond:<0.5) group:=0.#              Zero group if no bonds           CP43 281
group:=ABS(group:)#                    Activate site subcluster         CP43 282
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CP43 283
#                                                                       CP43 284
#   SHOULD NOW HAVE BEST INTERPRETATION OF ALL SITES                    CP43 285
#                                                                       CP43 286
#                                                                       CP43 287
#                                                                       CP43 288
STOPT=STOPB#                           Reset                            CP43 289
QXCUR=STOPB+1#                                                          CP43 290
#                                                                       CP43 291
RETURN#                                                                 CP43 292
END#                                                                    CP43 293
systemheader:(CP44)#                   Calculate figure-of-merit        CP44   1
####################################################################### CP44   2
#                                                                       CP44   3
#                                CP44 (FORMERLY ML37)                   CP44   4
#                                                                       CP44   5
####################################################################### CP44   6
SUBROUTINE CP44#                                                        CP44   7
include:(AACOMN)#                                                       CP44   8
include:(CPCOMN)#                                                       CP44   9
INTEGER I,IB,IB2,KP,JP,IP#                                              CP44  10
REAL A,B,DD#                                                            CP44  11
#                                                                       CP44  12
#  CALCULATE FIGURE OF MERIT FOR EACH SUBCLUSTER                        CP44  13
#  ---------------------------------------------                        CP44  14
#                                                                       CP44  15
FOMP=0.0;   A=0.0;    B=0.0#           Zero fomp calculation            CP44  16
FOR(KP=MARKA;KP<STOPA1;KP=KP+STEPA)#   Loop over all sites              CP44  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP44  18
A=A+peakh:#                            Sum all site heights             CP44  19
peakt:=-ABS(peakt:)#                   Flag as disabled                 CP44  20
IF(NINT(clust:)!=NCLUS) NEXT#          Skip sites not in cluster        CP44  21
#                                                                       CP44  22
IB2=NINT(bond2:)#                      Get end of bond sequence         CP44  23
JP=KP+modellist:;   IP=JP+MAXBON#      Get sitelist bond bias           CP44  24
FOR(IB=NINT(bond1:);IB<IB2;IB=IB+STEPB)# Loop over bond list            CP44  25
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP44  26
IF(JP==IP) peak1:=-ABS(peak1:)#        Suppress excess sites            CP44  27
IF(peak1:<.5) NEXT#                    Skip disabled sites              CP44  28
JP=JP+1#                               Incr sitelist pointer            CP44  29
QX(JP)=peak2:#                         Store bonded site addr.          CP44  30
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP44  31
nbond:=FLOAT(JP-KP-modellist:)#        Store num accepted bonds         CP44  32
IF(nbond:<0.5) group:=0.#              Zero group if no bonds           CP44  33
group:=ABS(group:)#                    Activate site subcluster         CP44  34
I=NINT(group:);  IF(I==0) NEXT#        Skip null groups                 CP44  35
DD=FLOAT(NSUB(I))#                     Get number of sites in group     CP44  36
B=B+1.#                                Count active sites in group      CP44  37
IF(DD>2.1) FOMP=FOMP+peakh:*ALOG10(DD)# Sum site height * population    CP44  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP44  39
IF(A>0.) FOMP=FOMP/A#                  Normalize figure of merit        CP44  40
#                                                                       CP44  41
#                                                                       CP44  42
IF(B<2.5) FOMP=0.#                     Cancel cluster if less than      CP44  43
TOPFOM=MAX(TOPFOM,FOMP)#               Record best fig of merit         CP44  44
#                                                                       CP44  45
DO KP=1,MSUB; MAXGRP=MAX0(NSUB(KP),MAXGRP)# Loop over subclusters       CP44  46
#                                                                       CP44  47
pt4:#                                                                   CP44  48
WRITE(6,'(a,I5,a,I5,3F12.5)')"NCLUS ",NCLUS," NTERP ",NTERP,FOMP,A,B#   CP44  49
#                                                                       CP44  50
RETURN#                                                                 CP44  51
END#                                                                    CP44  52
systemheader:(CP45)#                   Disable site pointer & bonds     CP45   1
####################################################################### CP45   2
#                                                                     # CP45   3
#                               CP45  (FORMERLY ML07 )                # CP45   4
#                                                                     # CP45   5
####################################################################### CP45   6
SUBROUTINE CP45(KP)#                                                    CP45   7
include:(AACOMN)#                                                       CP45   8
include:(CPCOMN)#                                                       CP45   9
#                                                                       CP45  10
# THIS SUBROUTINE CAUSES SITE N TO BE ELIMINATED FROM CONSIDERATION IN  CP45  11
# THE INTERPRETATION BY (A) ZEROING THE COUNT OF BONDS TO THE SITE AND  CP45  12
# (B) FLAGGING ALL THE CONNECTIONS TO OTHER SITES IN MARKB.             CP45  13
#                                                                       CP45  14
INTEGER IB,JB,KB,KP,JP,LB#             Loop indices                     CP45  15
#                                                                       CP45  16
nbond:=0.;    group:=0.#               Zero number of bonds             CP45  17
JB=NINT(bond2:)#                       Get end of bond list             CP45  18
FOR(IB=NINT(bond1:);IB<JB;IB=IB+STEPB)# Loop over connect bonds         CP45  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP45  20
IF(peak1:<0.5) NEXT#                   Skip if already disabled         CP45  21
peak1:=-peak1:#                        Disable this bond                CP45  22
JP=NINT(peak2:)#                       Get pointer to sitelist          CP45  23
nbond:(JP)=nbond:(JP)-1.#              Decrement bond count             CP45  24
IF(nbond:(JP)<.5) group:(JP)=0.#       Not in group if no bonds         CP45  25
LB=NINT(bond2:(JP))#                   Get end of bond list             CP45  26
FOR(KB=NINT(bond1:(JP));KB<LB;KB=KB+STEPB)# Loop over connect bonds     CP45  27
IF(NINT(peak2:(KB))==KP)#              Find connected site1             CP45  28
peak1:(KB)=-ABS(peak1:(KB))#           Disable this bond too            CP45  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP45  30
#                                                                       CP45  31
RETURN#                                                                 CP45  32
END#                                                                    CP45  33
#                                                                       CP45  34
#                                                                       CP45  35
systemheader:(CP46)#                   Eliminate holes and some peaks   CP46   1
# ####################################################################  CP46   2
#                                                                       CP46   3
#                               CP46                                    CP46   4
#                                                                       CP46   5
# ####################################################################  CP46   6
SUBROUTINE CP46#                                                        CP46   7
include:(AACOMN)#                                                       CP46   8
include:(CPCOMN)#                                                       CP46   9
#                                                                       CP46  10
REAL A,B,C,X,Y,Z,Q,R,S,U,V,W,DD,ZZ#                                     CP46  11
REAL SHX,SHY,SHZ,SHH,SHD#                                               CP46  12
REAL SPX,SPY,SPZ,SPH,SPD#                                               CP46  13
INTEGER K,KP,JP,T,N, NPK,NH,TYP,P1#                                     CP46  14
#                                                                       CP46  15
FOR(KP=MARK9;KP<STOP9;KP=KP+STEP9)#    Loop over prior atom sites       CP46  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP46  17
P1=0#                                                                   CP46  18
X=peakx:;Y=peaky:;Z=peakz:#            Get atom coords                  CP46  19
T=NINT(peakt:)#                        Get atom type                    CP46  20
IF(T<1\T>10)#                                                           CP46  21
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP46  22
WRITE(6,*)"AAAAAAAAAAAAARGGGHHHHHH!!!",peakt:,X,Y,Z#                    CP46  23
STOP#                                                                   CP46  24
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP46  25
ZZ=ATZ(T)#                             Get number of electrons          CP46  26
IF(ZZ<10.)NEXT#                        Ignore carbon atom overlap       CP46  27
#                                                                       CP46  28
# LOOK FOR COINCIDENT HOLES - INDICATIVE OF ATOM TYPE ERROR             CP46  29
# ---------------------------------------------------------             CP46  30
#                                                                       CP46  31
SHX=0.0;SHY=0.0;SHZ=0.0;SHH=0.0;SHD=0.0;NH=0# Initialize hole count     CP46  32
FOR(JP=MARK10;JP<STOP10;JP=JP+STEP10)# Loop over all holes              CP46  33
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP46  34
ifeq:(peakh:(JP),0.0,0.1)NEXT#         Ignore cancelled sites           CP46  35
Q=peakx:(JP);R=peaky:(JP);S=peakz:(JP)# Get atom coords                 CP46  36
FOR(K=MARKS;K<STOPS;K=K+STEPS)#        Loop over all symops             CP46  37
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP46  38
A=Q*QX(K+1)+R*QX(K+4)+S*QX(K+7)+QX(K+10)# Generate equivalent x         CP46  39
B=Q*QX(K+2)+R*QX(K+5)+S*QX(K+8)+QX(K+11)# Generate equivalent y         CP46  40
C=Q*QX(K+3)+R*QX(K+6)+S*QX(K+9)+QX(K+12)# Generate equivalent z         CP46  41
U=MOD(99.5+X-A,1.)-0.5#                Ensure x' close to x             CP46  42
V=MOD(99.5+Y-B,1.)-0.5#                Ensure y' close to y             CP46  43
W=MOD(99.5+Z-C,1.)-0.5#                Ensure z' close to z             CP46  44
DD=G1*U*U+G5*V*V+G9*W*W+G2*U*V+G3*U*W+G6*V*W# Distance squared          CP46  45
IF(DD<0.5625) BREAK#                   Got a hole <0.75a^2 from atom    CP46  46
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP46  47
IF(K<STOPS)#                           Premature termination            CP46  48
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP46  49
SHX=SHX+(X+U); SHY=SHY+(Y+V); SHZ=SHZ+(Z+W);SHH=SHH+peakh:(JP)#         CP46  50
SHD=SHD+DD#                            Save distance                    CP46  51
NH=NH+1#                               Count nearby holes               CP46  52
pt2: IF(P1==0) WRITE(6,'(a,f6.0,I5,I5,3f8.4)')$#                        CP46  53
"atom overlap ",peakh:(KP),T,1+(KP-MARK9)/STEP9,X,Y,Z#                  CP46  54
pt2: WRITE(6,'(a,f6.0,4f8.4)')$#                                        CP46  55
"        hole ",peakh:(JP),SQRT(DD),Q,R,S#                              CP46  56
P1=P1+1#                                                                CP46  57
peakh:(JP)=0.0#                        Reset to ignore                  CP46  58
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP46  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP46  60
#                                                                       CP46  61
# LOOK FOR COINCIDENT PEAKS - INDICATIVE OF ATOM TYPE ERROR             CP46  62
# ---------------------------------------------------------             CP46  63
#                                                                       CP46  64
SPX=0.0;SPY=0.0;SPZ=0.0;SPH=0.0;SPD=0.0;NPK=0# Initialize peak count    CP46  65
FOR(JP=MARKA;JP<STOPA;JP=JP+STEPA)#    Loop over all peaks              CP46  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP46  67
ifeq:(peakh:(JP),0.0,0.1)NEXT#         Ignore cancelled sites           CP46  68
Q=peakx:(JP);R=peaky:(JP);S=peakz:(JP)# Get atom coords                 CP46  69
FOR(K=MARKS;K<STOPS;K=K+STEPS)#        Loop over all symops             CP46  70
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP46  71
A=Q*QX(K+1)+R*QX(K+4)+S*QX(K+7)+QX(K+10)# Generate equivalent x         CP46  72
B=Q*QX(K+2)+R*QX(K+5)+S*QX(K+8)+QX(K+11)# Generate equivalent y         CP46  73
C=Q*QX(K+3)+R*QX(K+6)+S*QX(K+9)+QX(K+12)# Generate equivalent z         CP46  74
U=MOD(99.5+X-A,1.)-0.5#                Ensure x' close to x             CP46  75
V=MOD(99.5+Y-B,1.)-0.5#                Ensure y' close to y             CP46  76
W=MOD(99.5+Z-C,1.)-0.5#                Ensure z' close to z             CP46  77
DD=G1*U*U+G5*V*V+G9*W*W+G2*U*V+G3*U*W+G6*V*W# Distance squared          CP46  78
IF(DD<0.5625) BREAK#                   Got a hole <0.75a^2 from atom    CP46  79
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP46  80
IF(K<STOPS)#                           Premature termination            CP46  81
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP46  82
SPX=SPX+(X+U); SPY=SPY+(Y+V); SPZ=SPZ+(Z+W);SPH=SPH+peakh:(JP)#         CP46  83
SPD=SPD+DD#                            Save distance                    CP46  84
NPK=NPK+1#                             Count nearby holes               CP46  85
IF(P1==0) WRITE(6,'(a,f6.0,I5,I5,3f8.4)')$#                             CP46  86
"atom overlap ",peakh:(KP),T,1+(KP-MARK9)/STEP9,X,Y,Z#                  CP46  87
WRITE(6,'(a,f6.0,4f8.4)')$#                                             CP46  88
"        peak ",peakh:(JP),SQRT(DD),Q,R,S#                              CP46  89
peakh:(JP)=0.0#                        Reset to ignore                  CP46  90
P1=P1+1#                                                                CP46  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP46  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP46  93
IF(NPK==0&NH==0)NEXT#                                                   CP46  94
#                                                                       CP46  95
#  MODIFY PREVIOUS CYCLE ATOM TYPE IF REQUIRED                          CP46  96
#  -------------------------------------------                          CP46  97
#                                                                       CP46  98
#RATIO= /Z                                                              CP46  99
#                                                                       CP46 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP46 101
#                                                                       CP46 102
# REDUCE MARK9 - MARK10 - MARKA - STOPA  TO    MARKA-STOPA              CP46 103
# --------------------------------------------------------              CP46 104
#                                                                       CP46 105
# ACTUALLY THIS SHOULD REALLY SEQUENCE THE PEAKS AND ATOMS BASED        CP46 106
# ON PEAKH: AND  Z, BUT FOR NOW WE WILL TREAT ALL AS C TYPE             CP46 107
#                                                                       CP46 108
#                                                                       CP46 109
KP=MARK9#                              Point to beginning of atom lis   CP46 110
N=0#                                   Count number of peaks            CP46 111
FOR(JP=MARK9;JP<STOPA;JP=JP+STEP9)#    Loop over all prior/holes/peak   CP46 112
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP46 113
IF(JP>=MARK10 & JP<STOP10)NEXT#        Ignore all holes                 CP46 114
ifeq:(peakh:(JP),0.0,0.1)NEXT#         Ignore cancelled peaks           CP46 115
IF(JP!=KP) movereal:(QX,JP+1,QX,KP+1,STEP9,1)# Copy back over cancell   CP46 116
IF(JP>=MARKA)#                         For new peaks                    CP46 117
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP46 118
N=N+1#                                                                  CP46 119
TYP=MAT(NARANG)#                       Set as potential current atom    CP46 120
IF(ORGANIC==yes: & ATZ(TYP)<1.5)#      Exclude h atoms if organic       CP46 121
TYP=MAT(MAX(1,NARANG-1))#              Set as potential current atom    CP46 122
peakt:=-FLOAT(TYP)#                    Flag as not invoked type         CP46 123
atrad:=   ATR(TYP)#                    Set atom type radius             CP46 124
atomb:=-1.#                            Flag atom biso as overall        CP46 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP46 126
KP=KP+STEP9#                                                            CP46 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP46 128
STOP9=MARK9;MARK10=STOP9;STOP10=MARK10# Reset qx pointers               CP46 129
MARKA=MARK9#                           Start of new atom/peak list      CP46 130
STOPA=KP#                              End of the peak list             CP46 131
QXCUR=STOPA#                           Reset                            CP46 132
MARKN=STOPA#                           For fc dependent atom list       CP46 133
STOPA1=STOPA#                          Expanded molecular symmetry li   CP46 134
MARKB=STOPA;STOPB=STOPA#                                                CP46 135
MARKC=STOPA;STOPC=STOPA#                                                CP46 136
MARKD=STOPA;STOPD=STOPA#                                                CP46 137
#                                                                       CP46 138
RETURN#                                                                 CP46 139
END#                                                                    CP46 140
systemheader:(CP47)#                   Asign atoms to peaks             CP47   1
# ####################################################################  CP47   2
#                                                                       CP47   3
#                               CP47                                    CP47   4
#                                                                       CP47   5
# ####################################################################  CP47   6
SUBROUTINE CP47#                                                        CP47   7
include:(AACOMN)#                                                       CP47   8
include:(CPCOMN)#                                                       CP47   9
#                                                                       CP47  10
INTEGER I#                                                              CP47  11
INTEGER IT#                                                             CP47  12
INTEGER KP,JP,LP#                                                       CP47  13
INTEGER JB,LB#                                                          CP47  14
INTEGER IB2#                                                            CP47  15
INTEGER NBND#                                                           CP47  16
INTEGER NANG#                                                           CP47  17
INTEGER DBLE#                                                           CP47  18
INTEGER ATOMH,ATOMC,ATOMN,ATOMO#       Initialize pointers              CP47  19
INTEGER  LIGHT#                        Flags for structural data type   CP47  20
REAL DX,DY,DZ,DD#                      Cp47                             CP47  21
REAL NETOT#                            Number atoms expected total      CP47  22
REAL ACNT,ATOT#                        Counts of previous assigned at   CP47  23
REAL COSA,MEAN#                                                         CP47  24
REAL BL1,BL2#                                                           CP47  25
REAL ANGLE(150)#                                                        CP47  26
REAL LENGTH(20)#                                                        CP47  27
#                                                                       CP47  28
string:(NAMES,8)#                                                       CP47  29
datastuff:#                                                             CP47  30
#                                                                       CP47  31
#  SOME IMPORTANT INITIALIZATIONS                                       CP47  32
#  ------------------------------                                       CP47  33
#                                                                       CP47  34
ATOMH=0;ATOMC=0;ATOMN=0;ATOMO=0#       Initialize pointers              CP47  35
NETOT=0.0#                             Initialize                       CP47  36
DO I=1,NATYP;#                                                          CP47  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP47  38
ifeq:(ATZ(I),1.0,0.1)ATOMH=I#          Hydrogen                         CP47  39
ifeq:(ATZ(I),6.0,0.1)ATOMC=I#          Carbon                           CP47  40
ifeq:(ATZ(I),7.0,0.1)ATOMN=I#          Nitrogen                         CP47  41
ifeq:(ATZ(I),8.0,0.1)ATOMO=I#          Oxygen                           CP47  42
IF   (ATZ(I)>1.5)    NETOT=NETOT+ATA(I)# Accumulate non-h atoms in ce   CP47  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP47  44
IF (ATOMN==0)ATOMN=ATOMC#                                               CP47  45
IF (ATOMO==0)ATOMO=ATOMC#                                               CP47  46
#                                                                       CP47  47
#  ASSIGN ATOMS TO PEAKS BASED ON BOND LENGTHS AND ANGLES               CP47  48
#  ------------------------------------------------------               CP47  49
#                                                                       CP47  50
IT=0#                                                                   CP47  51
ACNT=0.0#                              Initialize                       CP47  52
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over all sites              CP47  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP47  54
#                                                                       CP47  55
#                                                                       CP47  56
IF(HEAVY>=1)#                          Invoke heavy atom type assign    CP47  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP47  58
WHILE(MAL(IT+1)<=0 & IT<NATYP-1) IT=IT+1# Skip non assigned types       CP47  59
IF (KP==MAL(IT+1) & IT<NATYP) IT=IT+1# Change of atom type expected     CP47  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP47  61
#                                                                       CP47  62
#                                                                       CP47  63
IB2=NINT(bond2:)#                      Get end of bond sequence         CP47  64
#                                                                       CP47  65
#    CHECK BONDS                                                        CP47  66
#    -----------                                                        CP47  67
#                                                                       CP47  68
DO I=1,150; ANGLE(I)=0.0#              Initialize                       CP47  69
NBND=0; NANG=0#                        Initialize                       CP47  70
FOR(LB=NINT(bond1:);LB<=IB2;LB=LB+STEPB)# Loop over 1st bond            CP47  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP47  72
IF(peak1:(LB)<.5) NEXT#                Skip disabled bonds              CP47  73
NBND=NBND+1#                           Increment                        CP47  74
LP=NINT(peak2:(LB))#                   Point to site list               CP47  75
BL1=bondl:(LB)#                        Bond length 1                    CP47  76
LENGTH(NBND)=BL1#                      Save length                      CP47  77
#                                                                       CP47  78
#    CHECK BOND ANGLES                                                  CP47  79
#    -----------------                                                  CP47  80
#                                                                       CP47  81
FOR(JB=LB+STEPB;JB<=IB2;JB=JB+STEPB)#  Loop over second bond            CP47  82
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP47  83
IF(peak1:(JB)<.5) NEXT#                Skip disabled bonds              CP47  84
JP=NINT(peak2:(JB))#                   Point to site list               CP47  85
IF(JP==LP) NEXT#                       Skip if same site                CP47  86
BL2=bondl:(JB)#                        Bond length 2                    CP47  87
DX=peakx:(JP)-peakx:(LP)#              Get x difference                 CP47  88
DY=peaky:(JP)-peaky:(LP)#              Get y difference                 CP47  89
DZ=peakz:(JP)-peakz:(LP)#              Get z difference                 CP47  90
DD=G1*DX**2+G6*DY*DZ$#                 Calculate distance squared       CP47  91
+  G5*DY**2+G3*DX*DZ$#                 Calculate distance squared       CP47  92
+  G9*DZ**2+G2*DX*DY#                  Calculate distance squared       CP47  93
COSA=(BL1**2+BL2**2-DD)/(2.*BL1*BL2)#  Calculate cosine angle           CP47  94
NANG=NANG+1#                           Sum angles                       CP47  95
ANGLE(NANG)=COSA#                                                       CP47  96
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP47  97
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP47  98
#                                                                       CP47  99
#    CHECK IF ITS A HEAVY ATOM                                          CP47 100
#    -------------------------                                          CP47 101
#                                                                       CP47 102
LIGHT=0#                               Assume a heavy atom              CP47 103
DO I=1,NBND;IF (LENGTH(I)<1.8)LIGHT=LIGHT+1# A c, o or n bond           CP47 104
#                                                                       CP47 105
pt5:#                                                                   CP47 106
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP47 107
WRITE(6,*) (KP-MARKA)/STEPA,NBND,NANG,LIGHT#                            CP47 108
WRITE(6,*)"BONDS ",(LENGTH(I),I=1,NBND)#                                CP47 109
WRITE(6,*)"ANGLES",(ANGLE(I),I=1,NANG)#                                 CP47 110
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP47 111
#                                                                       CP47 112
#  MAKE NEW PEAK TYPE ASSIGNMENT                                        CP47 113
#  -----------------------------                                        CP47 114
#                                                                       CP47 115
IF (ORGANIC==yes: & (LIGHT>1 \(LIGHT==1 & NBND==1)))# One short bond    CP47 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP47 117
IF    (NBND>=4) peakt:=FLOAT(ATOMC)#   Assign as c peak type            CP47 118
#                                                                       CP47 119
#                                                                       CP47 120
ELSEIF(NBND==3)#                       N or c (three non h bonds)       CP47 121
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP47 122
MEAN=(ANGLE(1)+ANGLE(2)+ANGLE(3))/3.#  Average cos angle                CP47 123
IF (MEAN >-0.423) peakt: =FLOAT(ATOMC)# Cos 109.5 angle > cos 115       CP47 124
ELSE#                                  Trigonal planar not tetrah       CP47 125
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP47 126
peakt:=FLOAT(ATOMN)#                   Three bonds, assume nitrogen     CP47 127
DO I=1,3;IF(LENGTH(I)<1.4)peakt:=FLOAT(ATOMC)# 1 double bond so its c   CP47 128
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP47 129
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP47 130
#                                                                       CP47 131
#                                                                       CP47 132
ELSEIF(NBND==2)#                       Two non h bonds (needs work)     CP47 133
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP47 134
DBLE=0#                                Not double                       CP47 135
DO I=1,2;IF(LENGTH(I)<1.45)DBLE=DBLE+1# At least double or triple       CP47 136
IF (DBLE==2)    peakt:=FLOAT(ATOMC)#   Bond is =c=                      CP47 137
ELSEIF(DBLE==1) peakt:=FLOAT(ATOMC)#   Bond is =x- i.e. 1 single 1 db   CP47 138
#                                      Can't id n atoms as yet          CP47 139
ELSE#                                  Only single bonds                CP47 140
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP47 141
IF(ANGLE(1)<-0.423) peakt:=FLOAT(ATOMO)# X-o-x bonds typically >115 d   CP47 142
ELSE peakt:=FLOAT(ATOMC)#              Cant id n atoms as yet           CP47 143
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP47 144
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP47 145
#                                                                       CP47 146
#                                                                       CP47 147
ELSEIF(NBND==1)#                       One bond (non h) - no angles     CP47 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP47 149
IF    (LENGTH(1)<1.17) peakt:=FLOAT(ATOMO)# Bond o=-c-m triple 1.15     CP47 150
ELSEIF(LENGTH(1)<1.26) peakt:=FLOAT(ATOMN)# Bond n=-c   triple 1.23     CP47 151
ELSEIF(LENGTH(1)<1.29) peakt:=FLOAT(ATOMC)# Bond c=-c triple 1.15-1.2   CP47 152
ELSEIF(LENGTH(1)<1.31) peakt:=FLOAT(ATOMO)# Bond o=c   double 1.30      CP47 153
ELSEIF(LENGTH(1)<1.35) peakt:=FLOAT(ATOMN)# Bond hn=c single 1.32       CP47 154
ELSEIF(LENGTH(1)<1.45) peakt:=FLOAT(ATOMC)# Bond h2c=c double 1.29-1.   CP47 155
ELSEIF(LENGTH(1)<1.49) peakt:=FLOAT(ATOMO)# Bond ho-c single 1.48       CP47 156
ELSEIF(LENGTH(1)<1.52) peakt:=FLOAT(ATOMN)# Bond h2n-c single 1.50      CP47 157
ELSEIF(LENGTH(1)<1.57) peakt:=FLOAT(ATOMC)# Bond h3c-c single 1.45-1.   CP47 158
ELSE peakt:=FLOAT(ATOMC)#              Default                          CP47 159
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP47 160
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP47 161
ELSE#                                  Not a light atom                 CP47 162
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP47 163
IF(IT>0) peakt:=FLOAT(MAT(IT))#        Set as current atom type         CP47 164
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP47 165
#                                                                       CP47 166
pt4:#                                                                   CP47 167
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP47 168
IF(peakt:>0.5)#                                                         CP47 169
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP47 170
movertoc:(QX(MARK2+(NINT(peakt:)-1)*ISCF+1),1,NAMES,1,ISCF,1)#          CP47 171
WRITE(6,*)1+(KP-MARKA)/STEPA,peakh:,peakt:,NAMES(1^ISCF)#               CP47 172
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP47 173
ELSE WRITE(6,*)1+(KP-MARKA)/STEPA,peakh:,peakt:#                        CP47 174
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP47 175
#                                                                       CP47 176
ACNT=ACNT+peakm:#                      Accumulate indep sites           CP47 177
ATOT=ACNT*FLOAT(NSYM)#                 All previous atoms in cell       CP47 178
#                                                                       CP47 179
IF(ATOT>NETOT) BREAK#                  Assigned enough atoms            CP47 180
#                                                                       CP47 181
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP47 182
#                                                                       CP47 183
RETURN#                                                                 CP47 184
END#                                                                    CP47 185
systemheader:(CP48)#                   Sort model figs of merit         CP48   1
# ####################################################################  CP48   2
#                                                                       CP48   3
#                               CP48                                    CP48   4
#                                                                       CP48   5
# ####################################################################  CP48   6
SUBROUTINE CP48#                                                        CP48   7
include:(AACOMN)#                                                       CP48   8
include:(CPCOMN)#                                                       CP48   9
#                                                                       CP48  10
INTEGER IA,LTERP#                                                       CP48  11
REAL F1,F2,N1,TMP1,TMP2#                                                CP48  12
#                                                                       CP48  13
#                                                                       CP48  14
#                                                                       CP48  15
FOR(NCLUS=1; NCLUS<=TCLUS; NCLUS=NCLUS+1)# Loop over site clusters      CP48  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP48  17
IA=MARKO+(NCLUS-1)*STEPO#                                               CP48  18
FOR(NTERP=1; NTERP< MTERP; NTERP=NTERP+1)# Loop over interpretation     CP48  19
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP48  20
F1=QX(IA+(NTERP-1)*2+1);N1=NTERP#      Initialize                       CP48  21
FOR(LTERP=NTERP+1;LTERP<=MTERP; LTERP=LTERP+1)# Loop over next interp   CP48  22
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP48  23
F2=QX(IA+(LTERP-1)*2+1)#                                                CP48  24
IF(F2>F1)$( N1=LTERP;F1=F2$)#                                           CP48  25
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP48  26
IF(N1==NTERP)NEXT#                     Allready in sequence             CP48  27
TMP1=QX(IA+(NTERP-1)*2+1)#             Save first fom                   CP48  28
TMP2=QX(IA+(NTERP-1)*2+2)#             Save first nterp pointer         CP48  29
QX(IA+(NTERP-1)*2+1)=QX(IA+(N1-1)*2+1)# Copy fom                        CP48  30
QX(IA+(NTERP-1)*2+2)=QX(IA+(N1-1)*2+2)# Copy nterp                      CP48  31
QX(IA+(N1-1)*2+1)=TMP1#                                                 CP48  32
QX(IA+(N1-1)*2+2)=TMP2#                                                 CP48  33
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP48  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP48  35
#                                                                       CP48  36
#                                                                       CP48  37
#                                                                       CP48  38
pt5:#                                                                   CP48  39
FOR(NCLUS=1; NCLUS<=TCLUS; NCLUS=NCLUS+1)# Loop over site clusters      CP48  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP48  41
WRITE(6,*)"CLUSTER ",NCLUS#                                             CP48  42
IA=MARKO+(NCLUS-1)*STEPO#                                               CP48  43
FOR(NTERP=1; NTERP<=MTERP; NTERP=NTERP+1)# Loop over interpretation     CP48  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP48  45
WRITE(6,*)NTERP,QX(IA+(NTERP-1)*2+1),NINT(QX(IA+(NTERP-1)*2+2))#        CP48  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP48  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP48  48
#                                                                       CP48  49
RETURN#                                                                 CP48  50
END#                                                                    CP48  51
systemheader:(CP49)#                                                    CP49   1
# ####################################################################  CP49   2
#                                                                       CP49   3
#                               CP49                                    CP49   4
#                                                                       CP49   5
# ####################################################################  CP49   6
SUBROUTINE CP49#                                                        CP49   7
include:(AACOMN)#                                                       CP49   8
include:(CPCOMN)#                                                       CP49   9
INTEGER KP,JP,NEW#                                                      CP49  10
REAL  U,V,W,DD,VAL#                                                     CP49  11
INTEGER MCNT,OLD#                                                       CP49  12
INTEGER STRCNV#                        Structural convergence           CP49  13
chardata:(CP49A,' Gross structure identified.')#                        CP49  14
chardata:(CP49B,' Solution convergence                   %')#           CP49  15
datastuff:#                                                             CP49  16
#                                                                       CP49  17
pt5:#                                                                   CP49  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP49  19
WRITE(6,*)"CP49 CURRENT",MARKA,STPMRK,(STPMRK-MARKA)/STEPA#             CP49  20
WRITE(6,*)"CP49 PREVIOUS",MARK8,STOP8,(STOP8-MARK8)/STEP8#              CP49  21
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP49  22
MCNT=0#                                                                 CP49  23
OLD=(STOP8-MARK8)/STEP8#                                                CP49  24
NEW=0#                                                                  CP49  25
FOR(KP=MARKA;KP<STPMRK;KP=KP+STEPA)#   Loop over sorted list            CP49  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP49  27
IF (peakt:<=0.5)NEXT#                  Skip rejected sites              CP49  28
NEW=NEW+1#                             Count new sites                  CP49  29
IF(MCNT>=OLD)NEXT#                     No need to check remainder       CP49  30
FOR(JP=MARK8;JP<STOP8;JP=JP+STEP8)#    Loop over saved list             CP49  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP49  32
U=MOD(99.5+peakx:-peakx:(JP),1.)-0.5#                                   CP49  33
V=MOD(99.5+peaky:-peaky:(JP),1.)-0.5#                                   CP49  34
W=MOD(99.5+peakz:-peakz:(JP),1.)-0.5#                                   CP49  35
DD=G1*U*U+G5*V*V+G9*W*W+G2*U*V+G3*U*W+G6*V*W# Distance squared          CP49  36
IF(DD>0.1)NEXT#                        Not overlapping old site         CP49  37
MCNT=MCNT+1#                           Got an old/new overlap           CP49  38
BREAK#                                                                  CP49  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP49  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP49  41
SOLVED=no:#                            Assume not converged yet         CP49  42
VAL=FLOAT(MCNT)/FLOAT(NEW)#                                             CP49  43
IF(VAL>0.95) STRCNV=yes:#              Structural convergence           CP49  44
ELSE         STRCNV=no:#               Not converged yet.               CP49  45
IF(FRMIN<=MNRSOL&STRCNV==yes:) SOLVED=yes:# Bearable r-factor          
IF(SOLVED==yes:)pt1: writeline:(1,CP49A,NCP49A,3,3)#                    CP49  47
ncodefld:(100.*VAL,1,CP49B,400813.,1)#                                  CP49  48
pt2: writeline:(1,CP49B,NCP49B,3,3)#                                    CP49  49
#                                                                       CP49  50
RETURN#                                                                 CP49  51
END#                                                                    CP49  52
systemheader:(CP50)#                   Save assigned atoms of marka     CP50   1
# ####################################################################  CP50   2
#                                                                       CP50   3
#                               CP50                                    CP50   4
#                                                                       CP50   5
# ####################################################################  CP50   6
SUBROUTINE CP50#                                                        CP50   7
include:(AACOMN)#                                                       CP50   8
include:(CPCOMN)#                                                       CP50   9
#                                                                       CP50  10
INTEGER KP#                                                             CP50  11
REAL NAT#                                                               CP50  12
#                                                                       CP50  13
STOP8=MARK8#                                                            CP50  14
STEP8=savlist:#                        Size of peklist                  CP50  15
FOR(KP=MARKA;KP<STPMRK;KP=KP+STEPA)#   Loop over sorted list            CP50  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP50  17
NAT=peakt:#                                                             CP50  18
IF(NAT<=0.5) NEXT#                     Skip nonassigned peaks           CP50  19
IF(KP==STOP8)#                         No copy first time               CP50  20
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP50  21
STOP8=STOP8+STEP8#                     Just partial step over first     CP50  22
NEXT#                                  And move on                      CP50  23
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP50  24
movereal:(QX,KP+1,QX,STOP8+1,STEP8,1)#                                  CP50  25
STOP8=STOP8+STEP8#                                                      CP50  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP50  27
# CP20 SHOULD RESET MARKA BASED ON STOP8                                CP50  28
pt5: WRITE(6,*)"CP50 NEW   ",MARK8,STOP8,(STOP8-MARK8)/STEP8#           CP50  29
MARKA=STOP8;STOPA=MARKA#               Reset for now                    CP50  30
#                                                                       CP50  31
RETURN#                                                                 CP50  32
END#                                                                    CP50  33
systemheader:(CP51)#                   Analyse patterson map            CP51   1
# ####################################################################  CP51   2
#                                                                       CP51   3
#                               CP51                                    CP51   4
#                                                                       CP51   5
# ####################################################################  CP51   6
SUBROUTINE CP51#                                                        CP51   7
include:(AACOMN)#                                                       CP51   8
include:(CPCOMN)#                                                       CP51   9
REAL A(3,3),X(3),B(3),V(3),C(3),D(3)#                                   CP51  10
REAL Q,R,S,E,F,G,DD#                                                    CP51  11
INTEGER H,I,J,K,L,M,LSTOP,LMARKB#                                       CP51  12
INTEGER P1,P2,P3,LAT#                                                   CP51  13
INTEGER KP,JP#                                                          CP51  14
REAL DX,DY,DZ#                                                          CP51  15
chardata:(CP51A," Some of the following coordinates may be valid $#     CP51  16
as single heavy atom sites.")#                                          CP51  17
realdata:(FMT,[200702.,713.,742.,742.,742.])#                           CP51  18
datastuff:#                                                             CP51  19
#                                                                       CP51  20
# IF WE GOT THIS FAR, IT MEANS THAT THERE IS VERY STRONG PSEUDO         CP51  21
# OR REAL SYMMETRY IN THIS CRYSTAL. THIS WOULD MOST LIKELY ARISE FROM   CP51  22
# ONE OR MORE HEAVY ATOMS IN GENERAL OR SPECIAL POSITIONS.              CP51  23
#                                                                       CP51  24
# THIS SUBROUTINE ATTEMPTS TO FIND A SINGLE HEAVY ATOM                  CP51  25
# BY TRYING TO FIT PATTERSON PEAKS TO THE HARKER VECTORS VIA            CP51  26
# [HARKER ].[X,Y,Z] = [PATTERSON] - [SHIFT] +[N1,N2,N3]                 CP51  27
#                                       (for some n1,n2,n3)             CP51  28
writeline:(1,CP51A,NCP51A,3,3)#                                         CP51  29
CHROT=' '#                             Erase                            CP51  30
#                                                                       CP51  31
P1=3*(MARK8-MARKZ)/26#                 Arb 1.5*expected                 CP51  32
P2=(STOPA-MARKA)/STEPA#                Total possible                   CP51  33
P3=MIN(P2,P1)#                                                          CP51  34
LSTOP=MIN(STOPA,MARKA+P3*STEPA)#       Arb 1.5*expected                 CP51  35
incrqx:(MARKB,STOPA+P3*2,CP5101)#      Get mem for site index           CP51  36
STOPB=MARKB#                           ??should already be true         CP51  37
LAT=1#                                                                  CP51  38
FOR(KP=MARKA;KP<LSTOP;KP=KP+STEPA)#    Loop for xpctd patterson peaks   CP51  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP51  40
LMARKB=STOPB#                          Pointer to first site of currn   CP51  41
QX(STOPA+LAT)=FLOAT(LMARKB)#           Save end of last point           CP51  42
LAT=LAT+2#                                                              CP51  43
V(1)=peakx:;V(2)=peaky:;V(3)=peakz:#   Get patterson peaks              CP51  44
FOR(H=MARKZ;H<MARK8;H=H+13)#                                            CP51  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP51  46
DO I=1,3;D(I)=V(I)-QX(H+9+I)#                                           CP51  47
DO I=1,3;DO J=1,3;A(I,J)=QX(H+I+(J-1)*3)#                               CP51  48
DO J=1,3;C(J)=ABS(A(J,1))+ABS(A(J,2))+ABS(A(J,3))# Sum contribs         CP51  49
DO J=1,3;ifeq:(C(J),0.0)#                                               CP51  50
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP51  51
ifne:(MOD(100.+D(J),1.),.0,.1E-2)BREAK# Zero != zero                    CP51  52
ELSE D(J)=0.0#                         Force it exactly                 CP51  53
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP51  54
IF(J<=3)NEXT#                          Harker & patterson no match      CP51  55
#                                                                       CP51  56
# THE FOLLOWING LOOPS ARE A POORLY THOUGHT OUT FUDGE                    CP51  57
# THERE SHOULD BE A GENERAL METHOD FOR DETERMINING POTENTIAL SHIFTS     CP51  58
# ESPECIALLY WHEN THE HARKER SHIFT IS NOT 1/2 BUT 1/3 OR 2/3 E.G.       CP51  59
# IN THAT CASE WE MAY MISS SOME IMPORTANT SHIFT FACTORS.                CP51  60
# ON THE OTHER HAND WE MIGHT GET LUCKY.                                 CP51  61
DO I=-1,1;DO J=-1,1;DO K=-1,1#         For typical translations         CP51  62
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP51  63
B(1)=D(1)+FLOAT(I)#                                                     CP51  64
B(2)=D(2)+FLOAT(J)#                                                     CP51  65
B(3)=D(3)+FLOAT(K)#                                                     CP51  66
axeqb:(A,X,B)#                                                          CP51  67
#                                                                       CP51  68
# IFEQ:(C(J),0.0) FOR SOME J THEN WE DON'T HAVE ALL INFO TO MAP THROUGH CP51  69
# THE SYMOPS I.E. SOME OF X,Y,Z ARE NOT DEFINED BY A X =B               CP51  70
JP=1#                                                                   CP51  71
ifnv:(X(1),0.0)ifnv:(X(2),0.0)ifnv:(X(3),0.0)JP=0#                      CP51  72
ifnv:(X(1),0.0)ifnv:(X(2),0.0)ifnv:(X(3),0.0)JP=0#                      CP51  73
IF(JP==0)#                                                              CP51  74
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP51  75
FOR(JP=LMARKB;JP<STOPB;JP=JP+4)#       Compare with previous solution   CP51  76
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP51  77
E=QX(JP+1);F=QX(JP+2);G=QX(JP+3)#                                       CP51  78
FOR(L=MARKS;L<STOPS;L=L+STEPS)#        Loop over all space group symo   CP51  79
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP51  80
Q=X(1)*QX(L+1)+X(2)*QX(L+4)+X(3)*QX(L+7)+QX(L+10)# Gen equivalent x     CP51  81
R=X(1)*QX(L+2)+X(2)*QX(L+5)+X(3)*QX(L+8)+QX(L+11)# Gen equivalent y     CP51  82
S=X(1)*QX(L+3)+X(2)*QX(L+6)+X(3)*QX(L+9)+QX(L+12)# Gen equivalent z     CP51  83
DX=MOD(99.5+E-Q,1.)-0.5#               Ensure x' close to x             CP51  84
DY=MOD(99.5+F-R,1.)-0.5#               Ensure y' close to y             CP51  85
DZ=MOD(99.5+G-S,1.)-0.5#               Ensure z' close to z             CP51  86
DD=G1*DX**2+G6*DY*DZ+G5*DY**2+G3*DX*DZ+G9*DZ**2+G2*DX*DY#               CP51  87
IF(DD<=0.04) GOTO 100#                 A match within <0.2 angstroms    CP51  88
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP51  89
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP51  90
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP51  91
ELSE#                                  Some undefined coords            CP51  92
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP51  93
FOR(JP=LMARKB;JP<STOPB;JP=JP+4)#       Compare with previous solution   CP51  94
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP51  95
E=QX(JP+1);F=QX(JP+2);G=QX(JP+3)#      Just check translations          CP51  96
DX=0.;DY=0.;DZ=0.#                                                      CP51  97
ifnv:(X(1),0.) DX=MOD(99.5+E-X(1),1.)-0.5# Ensure x' close to x         CP51  98
ifnv:(X(2),0.) DY=MOD(99.5+F-X(2),1.)-0.5# Ensure y' close to y         CP51  99
ifnv:(X(3),0.) DZ=MOD(99.5+G-X(3),1.)-0.5# Ensure z' close to z         CP51 100
DD=G1*DX**2+G6*DY*DZ+G5*DY**2+G3*DX*DZ+G9*DZ**2+G2*DX*DY#               CP51 101
IF(DD>0.04) NEXT#                      A match within <0.2 angstroms    CP51 102
GOTO 100#                              A match within <0.2 angstroms    CP51 103
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP51 104
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP51 105
100 CONTINUE#                                                           CP51 106
IF(JP<STOPB) NEXT#                     Only record symmetry unique si   CP51 107
#                                                                       CP51 108
incrqx:(STOPB,JP+4,CP5102)#            Get memory for next vector       CP51 109
DO M=1,3#                              For three coordinates            CP51 110
ifnv:(X(M)) QX(JP+M)=MOD(100.+X(M),1.)# Save positive coordinates       CP51 111
ELSE        QX(JP+M)=voidflg:#                                          CP51 112
QX(JP+4)=FLOAT(1+(H-MARKZ)/13)#        Save the harker vector           CP51 113
ncodefld:(peakh:,1,CHROT,FMT,1)#       Encode peak height               CP51 114
ncodefld:(QX(JP+4),1,CHROT,FMT(2),1)#  Encode peak height               CP51 115
ncodefld:(QX(JP+1),1,CHROT,FMT(3),3)#  Encode x,y,z                     CP51 116
writeline:(0,0,0,1,3)#                 Write out the line               CP51 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP51 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP51 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP51 120
#                                                                       CP51 121
extrude:(JUNK)#                                                         CP51 122
#                                                                       CP51 123
#  CP51: SCAN THE POTENTIAL SITE LISTS LOOKING FOR AGREEMENT            CP51 124
#  ---------------------------------------------------------            CP51 125
#                                                                       CP51 126
NS=(MARK8-MARKZ)/13#                   Max possibl agreeing harkers     CP51 127
FOR(IP=STOPA;IP<(P3-NS)*2;IP=IP+2)#    Maximum starting points          CP51 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP51 129
P1A=NINT(QX(IP+1))#                    First poss site for cur pattpk   CP51 130
P1B=NINT(QX(IP+3))#                    Last possible for cur patt pea   CP51 131
KP=IP+2#                               Pointer to next                  CP51 132
FOR(JP=P1A;JP<P1B;JP=JP+4)#            Loop for all sites in between    CP51 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP51 134
E=QX(JP+1);F=QX(JP+2);G=QX(JP+3)#      Get first site                   CP51 135
E1=E;F1=F;G1=G#                        Adjusted for voids               CP51 136
NCNT=1#                                Initialize for 1 match           CP51 137
WHILE(NCNT<NS)#                        Not enough matches yet           CP51 138
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP51 139
P2A=NINT(QX(KP+1))#                    First poss site for cur pattpk   CP51 140
P2B=NINT(QX(KP+3))#                    Last possible for cur patt pea   CP51 141
FOR(LP=P2A;LP<P2B;LP=LP+4)#            Loop for all sites in between    CP51 142
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP51 143
Q=QX(LP+1);R=QX(LP+2);S=QX(LP+3)#      Get first site                   CP51 144
ifvo:(E1) E1=Q  ; Q1#                                                   CP51 145
ifvo:(F1) F1=R  ; R1#                                                   CP51 146
#                                                                       CP51 147
#                                                                       CP51 148
#                                                                       CP51 149
FOR(L=MARKS;L<STOPS;L=L+STEPS)#        Loop over all space group symo   CP51 150
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP51 151
T=Q1*QX(L+1)+R1*QX(L+4)+S1*QX(L+7)+QX(L+10)# Gen equivalent x           CP51 152
U=Q1*QX(L+2)+R1*QX(L+5)+S1*QX(L+8)+QX(L+11)# Gen equivalent y           CP51 153
V=Q1*QX(L+3)+R1*QX(L+6)+S1*QX(L+9)+QX(L+12)# Gen equivalent z           CP51 154
DX=MOD(99.5+E1-T,1.)-0.5#              Ensure x' close to x             CP51 155
DY=MOD(99.5+F1-U,1.)-0.5#              Ensure y' close to y             CP51 156
DZ=MOD(99.5+G1-V,1.)-0.5#              Ensure z' close to z             CP51 157
DD=G1*DX**2+G6*DY*DZ+G5*DY**2+G3*DX*DZ+G9*DZ**2+G2*DX*DY#               CP51 158
IF(DD<=0.04) GOTO 200#                 A match within <0.2 angstroms    CP51 159
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP51 160
ELSE#                                  Some undefined coords            CP51 161
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP51 162
E=QX(JP+1);F=QX(JP+2);G=QX(JP+3)#      Just check translations          CP51 163
DX=0.;DY=0.;DZ=0.#                                                      CP51 164
ifnv:(X(1),0.) DX=MOD(99.5+E-X(1),1.)-0.5# Ensure x' close to x         CP51 165
ifnv:(X(2),0.) DY=MOD(99.5+F-X(2),1.)-0.5# Ensure y' close to y         CP51 166
ifnv:(X(3),0.) DZ=MOD(99.5+G-X(3),1.)-0.5# Ensure z' close to z         CP51 167
DD=G1*DX**2+G6*DY*DZ+G5*DY**2+G3*DX*DZ+G9*DZ**2+G2*DX*DY#               CP51 168
IF(DD<=0.04) GOTO 200#                 A match within <0.2 angstroms    CP51 169
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP51 170
#                                                                       CP51 171
NEXT#                                  No match so get next             CP51 172
200 CONTINUE#                          Its a match                      CP51 173
NCNT=NCNT+1#                                                            CP51 174
#                                                                       CP51 175
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP51 176
#                                                                       CP51 177
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP51 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP51 179
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP51 180
#                                                                       CP51 181
#STEPA=STEPB#                                                           CP51 182
MARKN=STOPA#                           For fc dependent atom list       CP51 183
STOPA1=STOPA#                          Expanded molecular symmetry li   CP51 184
MARKB=STOPA;STOPB=STOPA#                                                CP51 185
MARKC=STOPA;STOPC=STOPA#                                                CP51 186
MARKD=STOPA;STOPD=STOPA#                                                CP51 187
endext:#                                                                CP51 188
#                                                                       CP51 189
MARK8=MARKZ; STOP8=MARK8#              Reset mem 4 tangent phas soln    CP51 190
QXCUR=MARK8#                                                            CP51 191
#                                                                       CP51 192
RETURN#                                                                 CP51 193
END#                                                                    CP51 194
systemheader:(CP70)#                   Get atom parameters from lra     CP70   1
# ####################################################################  CP70   2
#                                                                       CP70   3
#                               CP70   FORMERLY (FC03)                  CP70   4
#                                                                       CP70   5
# ####################################################################  CP70   6
SUBROUTINE CP70(START)#                                                 CP70   7
include:(AACOMN)#                                                       CP70   8
include:(CPCOMN)#                                                       CP70   9
#                                                                       CP70  10
INTEGER START#                                                          CP70  11
#                                                                       CP70  12
INTEGER I,J,K,L,N#                     Working indices                  CP70  13
INTEGER IT#                                                             CP70  14
INTEGER KP,JP#                                                          CP70  15
INTEGER MAXM,MCNT#                                                      CP70  16
REAL SMUL#                             Site muliplicity                 CP70  17
REAL POPP#                             Population parameter             CP70  18
REAL X,Y,Z#                            Coordinate storage               CP70  19
REAL P,Q,R,U,V,W,DD#                                                    CP70  20
REAL A(3),CN(3),ML(3)#                                                  CP70  21
REAL BISO#                                                              CP70  22
INTEGER FLG(3),PAR(3)#                                                  CP70  23
INTEGER N1#                                                             CP70  24
INTEGER NONHV,TYP#                                                      CP70  25
INTEGER OK#                                                             CP70  26
REAL TEMP#                                                              CP70  27
#                                                                       CP70  28
realdata:(FMT1,[842.,842.,842.])#                                       CP70  29
realdata:(DEFCON,[1.,1.,2.,1.,3.,1.])# Default site non-constraint      CP70  30
chardata:(CP70A," Invoking the expected atom types")#                   CP70  31
chardata:(CP70B," Initially including only top xxx% of sites up to $#   CP70  32
peak number xxxxx")#                                                    CP70  33
datastuff:#                                                             CP70  34
#                                                                       CP70  35
pt2:      writeline:(2,CP70A,NCP70A,3,3)#                               CP70  36
ELSE pt1: writeline:(0,CP70A,NCP70A,3,3)#                               CP70  37
#                                                                       CP70  38
#--------------------------------------------------------------------   CP70  39
##### LAYOUT OF ATOM PARAMETER STORAGE                                  CP70  40
# RELATIVE ADDRESS                                                      CP70  41
# IN QX ARRAY                                                           CP70  42
IATM=8#                                                                 CP70  43
#      1                SCAT. FACTOR POINTER                            CP70  44
#      2                X                                               CP70  45
#      3                Y                                               CP70  46
#      4                Z                                               CP70  47
#      5                ATOM MULTIPLICITY * POPULATION                  CP70  48
#      6                BISO                                            CP70  49
#      7                POINTER TO MARKA KP                             CP70  50
#      8                POINTER TO SITE CONSTRAINT                      CP70  51
STEPP= 6#                              ->3                              CP70  52
#         FOR NEW XI COORD                                              CP70  53
#      X     Y     Z    SOURCE DEPENDENCY                               CP70  54
#      1     2     3    MULTIPLICATIVE FACTOR                           CP70  55
#---------------------------------------------------------------------- CP70  56
MARKN=START#                                                            CP70  57
QXCUR=MARKN#                           Ensure old erased                CP70  58
STEPN=NROT*IATM#                       Figure step size for each at     CP70  59
MCNT=0;MAXM=(STOP8-MARK8)/STEP8#                                        CP70  60
IF(MAXM>=ATEX/MOLZ) NATM= 3*MAXM/2#    Look for 1.5*current             CP70  61
ELSE                NATM= 3*ATEX/MOLZ/2# Default - look for this many   CP70  62
STPMRK=MARKA+NATM*STEPA#               Maximum sites to be considered   CP70  63
STPMRK=MIN(STPMRK,STOPA)#              Too many?                        CP70  64
NATM=(STPMRK-MARKA)/STEPA#             Maximum atom/sites considered    CP70  65
incrqx:(STOPN,MARKN+STEPN*NATM,CP7001)# Reserve for sym related         CP70  66
NATM=0#                                Zero count of selected atoms     CP70  67
K=MARKN#                               Start atom list pointer          CP70  68
MARKP=STOPN;STOPP=MARKP#                                                CP70  69
#                                                                       CP70  70
IF(LOOP<NARANG)ASSMRK=MAL(LOOP+1)-STEPA# Save expected site list end    CP70  71
ELSE           ASSMRK=MAL(NARANG)#     Expected end of atom list        CP70  72
IF(ITMODE==lsqonly:)FRACIN=1.0#        Assume all expected are there    CP70  73
TEMP=FLOAT((ASSMRK-MARKA)/STEPA+1)#    How many sites expected?         CP70  74
pt3:#                                                                   CP70  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP70  76
ncodefld:(FRACIN*100.,1,CP70B,330313.,1)# Encode fraction               CP70  77
ncodefld:(TEMP,1,CP70B,670513.,1)#     Encode sites                     CP70  78
writeline:(0,CP70B,NCP70B,3,3)#        Output the line                  CP70  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP70  80
ASSMRK=MARKA+NINT(FRACIN*TEMP)*STEPA-STEPA#                             CP70  81
MAL(NARANG)=STOPA#                     Now override last value          CP70  82
#                                                                       CP70  83
#                                                                       CP70  84
#   EXTRACT ATOM PARAMETERS FROM LR LRATOM:                             CP70  85
#   ---------------------------------                                   CP70  86
#                                                                       CP70  87
MCNT=0;MAXM=(STOP8-MARK8)/STEP8#                                        CP70  88
pt5: WRITE(6,*)"MARK8 ",MARK8,STOP8,STEP8,MAXM,MCNT#                    CP70  89
#                                                                       CP70  90
#                                                                       CP70  91
IT=1#                                  Largest atomic number group      CP70  92
NONHV=0#                                                                CP70  93
FOR(KP=MARKA;KP<STPMRK;KP=KP+STEPA)#   Loop over sorted list            CP70  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP70  95
#                                                                       CP70  96
#   ONLY DO THIS FOR AN FOBS OR EMAP                                    CP70  97
#   --------------------------------                                    CP70  98
#                                                                       CP70  99
IF(MAPTYP!=fdif:)#                                                      CP70 100
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP70 101
IF (KP>=MAL(IT+1)& IT<NARANG) IT=IT+1# Change of atom type expected     CP70 102
IF(IT>LOOP)$(STPMRK=KP;BREAK $)#       Iterative assignment cutoff      CP70 103
#                                                                       CP70 104
peakt:=  FLOAT(MAT(IT))#               Set as potential current atom    CP70 105
atrad:(KP)=ATR(MAT(IT))#               Set atom type radius             CP70 106
BISO=-1.#                                                               CP70 107
#                                                                       CP70 108
IF(HEAVY>0 & LOOP<=1 & ATZ(NINT(peakt:))<9.5)# Only set heavy atoms     CP70 109
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP70 110
NONHV=NONHV+1#                                                          CP70 111
peakt:=-peakt:#                        Set all else as potential site   CP70 112
IF (FLOAT(NONHV)/FLOAT(1+(KP-MARKA)/STEPA)>0.5)#                        CP70 113
$(STPMRK=KP ;BREAK$)#                                                   CP70 114
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP70 115
ELSEIF(KP>ASSMRK) peakt:=-peakt:#      Set all else as potential site   CP70 116
#                                                                       CP70 117
#                                                                       CP70 118
#  COMPARE WITH PREVIOUS CYCLE RESULTS                                  CP70 119
#  -----------------------------------                                  CP70 120
#                                                                       CP70 121
X=peakx:; Y=peaky:; Z=peakz:#          Get site coords to local         CP70 122
IF(MCNT<MAXM)#                         Only while necessary             CP70 123
FOR(JP=MARK8;JP<STOP8;JP=JP+STEP8)#    Loop over sorted list            CP70 124
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP70 125
P=peakx:(JP);Q=peaky:(JP);R=peakz:(JP)#                                 CP70 126
FOR(N=MARKS;N<STOPS;N=N+STEPS)#        Loop over all symops             CP70 127
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP70 128
U=P*QX(N+1)+Q*QX(N+4)+R*QX(N+7)+QX(N+10)# Generate equivalent x         CP70 129
V=P*QX(N+2)+Q*QX(N+5)+R*QX(N+8)+QX(N+11)# Generate equivalent y         CP70 130
W=P*QX(N+3)+Q*QX(N+6)+R*QX(N+9)+QX(N+12)# Generate equivalent z         CP70 131
U=MOD(99.5+U-X,1.)-0.5#                Ensure x' close to x             CP70 132
V=MOD(99.5+V-Y,1.)-0.5#                Ensure y' close to y             CP70 133
W=MOD(99.5+W-Z,1.)-0.5#                Ensure z' close to z             CP70 134
DD=G1*U*U+G5*V*V+G9*W*W+G2*U*V+G3*U*W+G6*V*W# Distance squared          CP70 135
IF(DD>0.15) NEXT#                      No match                         CP70 136
#                                                                       CP70 137
# IF WRONG PEAK TYPE PREVIOUSLY,  THEN THIS IS BAD                      CP70 138
#                                                                       CP70 139
#PEAKT:=PEAKT:(JP)#                    SET AS POTENTIAL CURRENT ATOM    CP70 140
peakt:=ABS(peakt:)#                    Set as potential current atom    CP70 141
DO I=1,NARANG;IF(MAT(I)==NINT(peakt:(JP)))BREAK# Already decided        CP70 142
IF(I>NARANG) peakt:=peakt:(JP)#        So impose previous               CP70 143
#                                                                       CP70 144
#PEAKT:=PEAKT:(JP)##  OVERRIDE ALL- WARNING-WARNING-DANGER-DANGER       CP70 145
#                                                                       CP70 146
#                                                                       CP70 147
# IDEALLY CP39 SHOULD CLUSTER MARKA SITES ABOUT MARK8 ATOMS             CP70 148
# I THINK ...??                                                         CP70 149
#                                                                       CP70 150
#PEAKX:(JP)=X;PEAKY:(JP)=Y;PEAKZ:(JP)=Z# SAVE NEW COORDS FOR HA50 TEST  CP70 151
peakx:=peakx:(JP);peaky:=peaky:(JP);peakz:=peakz:(JP)#                  CP70 152
X=peakx:;Y=peaky:;Z=peakz:#                                             CP70 153
#                                                                       CP70 154
atrad:(KP)=ATR(NINT(peakt:(JP)))#      Set atom type radius             CP70 155
BISO=atomb:(JP)#                       Get previous refinement value    CP70 156
MCNT=MCNT+1#                           Increment match count            CP70 157
GOTO 100#                              Exit if connected                CP70 158
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP70 159
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP70 160
ELSE JP=STOP8#                                                          CP70 161
100 CONTINUE#                                                           CP70 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP70 163
#                                                                       CP70 164
#   ONLY DO THIS FOR AN FDIF MAP                                        CP70 165
#   ----------------------------                                        CP70 166
#                                                                       CP70 167
ELSE#                                                                   CP70 168
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP70 169
IF(peakt:>0.5)BISO=atomb:#             Get previous refinement value    CP70 170
ELSE          BISO=-1.0#               Default to overall value         CP70 171
IF(KP<=ASSMRK) peakt:=ABS(peakt:)#     Invoke all assigned else rejec   CP70 172
X=peakx:; Y=peaky:; Z=peakz:#          Get site coords to local         CP70 173
JP=STOP8#                              Initialize it                    CP70 174
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP70 175
#                                                                       CP70 176
#                                                                       CP70 177
#                                                                       CP70 178
#                                                                       CP70 179
OK=yes:#                                                                CP70 180
IF(peakt:>0.5) CALL CP77(KP,OK)#                                        CP70 181
IF(OK==no:)#                                                            CP70 182
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP70 183
peakt:=-ABS(peakt:)#                                                    CP70 184
## Possibly  SHOULD not included the symmetry extension to this site    CP70 185
##      but if restricting site is rejected for some reason  ...?       CP70 186
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP70 187
#                                                                       CP70 188
#   COMMON FOR ALL PROSPECTIVE SITES                                    CP70 189
#   --------------------------------                                    CP70 190
#                                                                       CP70 191
NATM=NATM+1#                           Increment count of found ato     CP70 192
POPP=1.#                               Get population                   CP70 193
SMUL=peakm:#                           Get site mult.                   CP70 194
POPP=POPP*SMUL#                        Get combined m*pp                CP70 195
A(1)=X;A(2)=Y;A(3)=Z#                  Local array                      CP70 196
incrqx:(N1,STOPP+STEPP,CP7002)#        Expand qx for constraint         CP70 197
movereal:(DEFCON,1,QX,STOPP+1,6,0)#    Add default (no)constraint       CP70 198
ifne:(SMUL,1.0)#                       Fractional site multiplicity     CP70 199
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP70 200
CALL CP81(A,FLG,PAR,CN,ML)#            Assumes an input parameter is    CP70 201
#                                      Dependent on 1\0 other coords    CP70 202
#                                      If not - then i blew it.         CP70 203
DO I=1,3#                              For three original coords        CP70 204
IF     (FLG(I)==3) QX(STOPP+I*2  )=0.# Invariant parameter mult is ze   CP70 205
ELSE IF(PAR(I)==0) NEXT#               Use default no-constraint        CP70 206
ELSE#                                  Apply constraint here            CP70 207
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP70 208
QX(STOPP+I*2-1)=FLOAT(PAR(I))#         Store dependency                 CP70 209
QX(STOPP+I*2  )=ML(I)#                 Store derivative or multiplier   CP70 210
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP70 211
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP70 212
QX(K+1)=peakt:#                        Set structure factor type        CP70 213
QX(K+6)=BISO#                          Get biso                         CP70 214
QX(K+7)=FLOAT(KP)#                     Set pointer to orig              CP70 215
QX(K+8)=FLOAT(STOPP)#                  Set pointer to constraint        CP70 216
TYP=ABS(NINT(peakt:))#                                                  CP70 217
pt4:#                                                                   CP70 218
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP70 219
movertoc:(QX(MARK2+(TYP-1)*ISCF+1),1,CHROT,7,ISCF,1)#                   CP70 220
ncodefld:(FLOAT(NATM),1,CHROT,120413.,1)# Encode sequence number        CP70 221
IF(BISO<0) $( CHROT(13^20)='  BOVL  ' ; LCHROT=20$)# Default value      CP70 222
ELSE ncodefld:(QX(K+6),1,CHROT,200842.,1)# Encode biso                  CP70 223
ncodefld:(A,1,CHROT,FMT1,3)#           Encode x,y,z                     CP70 224
ncodefld:(peakh:,1,CHROT,0722.,1)#     Encode peak height               CP70 225
ncodefld:(SMUL, 1,CHROT,0632.,1)#      Encode multiplicity              CP70 226
IF(MCNT<=MAXM & JP<STOP8)#             Only for fobs maps               CP70 227
ncodefld:(FLOAT(1+(JP-MARK8)/STEP8),1,CHROT,0513.,1)# Encode sequence   CP70 228
writeline:(0,0,0,1,3)#                 Output buffer                    CP70 229
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP70 230
#                                                                       CP70 231
#   GENERATE EQUIVALENT POSITIONS                                       CP70 232
#   -----------------------------                                       CP70 233
#                                                                       CP70 234
FOR(N=MARKS;N<STOPR;N=N+12)#           Loop only over rot matrices      CP70 235
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP70 236
DO I=1,3#                              Rowxcolumn marix multiply        CP70 237
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP70 238
J=N+I;   L=K+I+1#                      Increment pointers               CP70 239
QX(L)=X*QX(J)+Y*QX(J+3)+Z*QX(J+6)+QX(J+9)# Matrix multiply              CP70 240
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP70 241
QX(K+5)=POPP*FMUL#                     Apply sym multipicity now        CP70 242
QX(K+8)=FLOAT(STOPP)#                  Save pointer to constraint       CP70 243
K=K+IATM#                              Incr atom list pointer           CP70 244
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP70 245
STOPP=N1#                              Update last constraint marker    CP70 246
#                                                                       CP70 247
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP70 248
STOPN=K#  ## (could be some unused between STOPN and MARKP)             CP70 249
#                                                                       CP70 250
RETURN#                                                                 CP70 251
END#                                                                    CP70 252
systemheader:(CP72)#                   Calculate structure factors      CP72   1
# ####################################################################  CP72   2
#                                                                       CP72   3
#                                CP72  (FORMERLY FC05)                  CP72   4
#                                                                       CP72   5
# ####################################################################  CP72   6
SUBROUTINE CP72(MLSQ)#                                                  CP72   7
include:(AACOMN)#                                                       CP72   8
include:(CPCOMN)#                                                       CP72   9
#                                                                       CP72  10
INTEGER MLSQ#                                                           CP72  11
#                                                                       CP72  12
REAL ANOD,ACAL(10)#                    Real s.f. components             CP72  13
REAL BNOD,BCAL(10)#                    Imag s.f. components             CP72  14
REAL FCAL,FREL#                        Structure factors                CP72  15
REAL ENEW,EREL#                        Structure factors                CP72  16
REAL HKL(3)#                           Miller indices & products        CP72  17
INTEGER I,J,L,M#                       Working indices                  CP72  18
REAL PHI,ANG#                          Phase components                 CP72  19
REAL STOL,S2L2#                        St/l & s2t/l2 values             CP72  20
REAL KFCAL,DELF,Q , DQDK,DQDB,DKDK,DBDB,DKDB,DET#                       CP72  21
REAL EXF2#                                                              CP72  22
INTEGER LSQ#                                                            CP72  23
REAL BOV,RSCAL#                                                         CP72  24
REAL SHIFTA,SHIFTB#                                                     CP72  25
INTEGER NREF#                                                           CP72  26
INTEGER GN#                                                             CP72  27
INTEGER SAB#                           Scale and bov refinement         CP72  28
REAL SORSCAL#                          Cp72                             CP72  29
REAL EPSI#                                                              CP72  30
REAL BUF1(12)#                         Direct access buffer             CP72  31
REAL FRFAC#                                                             CP72  32
#                                                                       CP72  33
REAL MFREL,MEREL,MFCAL,MECAL#                                           CP72  34
REAL SUMFR,SUMFC,SUMFD,SUMER,SUMEC,SUMED#                               CP72  35
REAL SHIFTS,ESDS,ESDB#                                                  CP72  36
REAL SFMUL#                                                             CP72  37
INTEGER REC#                                                            CP72  38
#                                                                       CP72  39
realdata:(PI2,6.2831853)#                                               CP72  40
realdata:(AH,0.); realdata:(AK,0.); realdata:(AL,0.)#                   CP72  41
realdata:(FACT,0.)#                                                     CP72  42
realdata:(TEMP,0.)#                                                     CP72  43
chardata:(CP72A,' Refining scale and BOVL')#                            CP72  44
chardata:(CP72B,' Refined Frel R-factor                  ')#            CP72  45
chardata:(CP72C,' New scale factor                       ')#            CP72  46
chardata:(CP72D,' New B overall                          ')#            CP72  47
datastuff:#                                                             CP72  48
#                                                                       CP72  49
SFMUL=SQRT(FMUL)#                                                       CP72  50
pt2: writeline:(0,CP72A,NCP72A,3,3)#   Indicate what we are doing       CP72  51
pt4:#                                                                   CP72  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP72  53
IF    (REFMOD==1)WRITE(6,*) "Only using generators "#                   CP72  54
ELSEIF(REFMOD==0)WRITE(6,*) 'Using all Es >1.0 '#                       CP72  55
ELSE             WRITE(6,*) 'Using all reflections ',DACREF#            CP72  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP72  57
#                                                                       CP72  58
SAB=yes:#                                                               CP72  59
RSCAL=1./SCAL#                         Initialize reciprocal scale      CP72  60
BOV=BOVL#                              Initialize temp factor           CP72  61
DO I=1,NATYP; OFF(I)=MARK3+(I-1)*NSCF+1# Setup ff table offsets         CP72  62
#                                                                       CP72  63
#  BEGIN LEAST SQUARES REFINEMENT OF SCALE AND BOVL                     CP72  64
#  ------------------------------------------------                     CP72  65
#                                                                       CP72  66
FOR(LSQ=1;LSQ<=MLSQ;LSQ=LSQ+1)#        Several least squares cycles     CP72  67
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP72  68
#                                      Initialize lsq sums              CP72  69
Q   =0.#                               (fm-k.fc)*(fm-k.fc) residual     CP72  70
DQDK=0.#                               (fm-k.fc)*(-fc)                  CP72  71
DQDB=0.#                               (fm-k.fc)*(-s2l2.k.fc)           CP72  72
DKDK=0.#                               (-fc)*(-fc)                      CP72  73
DBDB=0.#                               (-s2l2.k.fc)*(-s2l2.k.fc)        CP72  74
DKDB=0.#                               (-fc)*(-s2l2.k.fc)               CP72  75
#                                      Other sums                       CP72  76
SUMFR=0.#                              Sum measured s.f.                CP72  77
SUMFC=0.#                              Sum calculated s.f.              CP72  78
SUMFD=0.#                              Sum f difference                 CP72  79
SUMER=0.#                              Sum measured s.f.                CP72  80
SUMEC=0.#                              Sum calculated s.f.              CP72  81
SUMED=0.#                              Sum f difference                 CP72  82
#                                                                       CP72  83
#  LOOP OVER GENERATOR REFLECTION PACKETS                               CP72  84
#  ======================================                               CP72  85
#                                                                       CP72  86
NREF=0#                                Number of generator refs         CP72  87
REC=0#                                                                  CP72  88
IF(REFMOD==1)GN=MARK6-MARK#            Initialize                       CP72  89
REPEAT#                                                                 CP72  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP72  91
#                                                                       CP72  92
#    EXTRACT REQUIRED REFLN DATA                                        CP72  93
#    ---------------------------                                        CP72  94
#                                                                       CP72  95
IF(REFMOD==1)#                         Using grenerator ref list        CP72  96
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP72  97
GN=GN+MARK#                            Using grenerator ref list        CP72  98
IF(GN>=MQ)BREAK#                       End of gen list                  CP72  99
FREL=frel:#                            Ha76 1                           CP72 100
STOL=stol:#                            Extract st/l                     CP72 101
gethkl:(GN+1,HKL)#                     Extract signed h,k,l             CP72 102
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP72 103
ELSE#                                                                   CP72 104
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP72 105
REC=REC+1#                                                              CP72 106
IF(REC>DACREF) BREAK#                  End of direct access file        CP72 107
readdac:(ioda2:,,REC,BUF1)#                                             CP72 108
IF(LSQ!=MLSQ& REFMOD==0 & BUF1(5)<1.0) NEXT# Impose evalue threshold    CP72 109
IF(REFMOD==-1& BUF1(4)<SIGMUL*BUF1(10))NEXT# Ignore very weak           CP72 110
DO KQJ=1,3#                            Get hkl                          CP72 111
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP72 112
intunpak:(BUF1(1),JQK,(KQJ-1)*9+3,9)#                                   CP72 113
intunpak:(BUF1(1),KZJ,KQJ-1,1)#                                         CP72 114
IF(KZJ!=0)JQK=-JQK#                                                     CP72 115
HKL(4-KQJ)=FLOAT(JQK)#                                                  CP72 116
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP72 117
STOL=BUF1(3)#                          Extract st/l                     CP72 118
FREL=BUF1(4)#                          F relative                       CP72 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP72 120
#                                                                       CP72 121
S2L2=STOL**2#                          Get (st/l) squared               CP72 122
NREF=NREF+1#                                                            CP72 123
AH=HKL(1); AK=HKL(2); AL=HKL(3)#       Make hkl local variables         CP72 124
#                                                                       CP72 125
TEMP=EXP(-BOV*S2L2)#                   Calc overall temp factor         CP72 126
#                                                                       CP72 127
#    LOOP OVER ATOMS LIST                                               CP72 128
#    --------------------                                               CP72 129
#                                                                       CP72 130
DO I=1,NATYP#                          Loop over atom types             CP72 131
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP72 132
ACAL(I)=0.;   BCAL(I)=0.#              Zeroize s.f. components          CP72 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP72 134
#                                                                       CP72 135
FOR(M=MARKN;M<STOPN;M=M+IATM)#         Loop over atoms list             CP72 136
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP72 137
#                                                                       CP72 138
IF(QX(M+1)<-0.5)#                      Not invoked site                 CP72 139
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP72 140
M=M+STEPN-IATM#                        Skip equivalents                 CP72 141
NEXT#                                  Go back for more                 CP72 142
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP72 143
ELSEIF(QX(M+1)>0.5)#                   Test if equivalent site          CP72 144
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP72 145
L=NINT(QX(M+1))#                       Extract sf sequence              CP72 146
IF(QX(M+6)<0.0) FACT=QX(M+5)*TEMP#     Popp*mul* overall b              CP72 147
ELSE FACT=QX(M+5)*EXP(-QX(M+6)*S2L2)#  Calc individual biso vals        CP72 148
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP72 149
#                                                                       CP72 150
#   CALC A & B FOR EACH ATOM TYPE                                       CP72 151
#   -----------------------------                                       CP72 152
#                                                                       CP72 153
ANG=AH*QX(M+2)+AK*QX(M+3)+AL*QX(M+4)#  Calc phase component             CP72 154
IF(ANG<0.)#                            Test if angle negative           CP72 155
I=INT((1.+AMOD(ANG,1.))*360.+.5)+MARK0## Point to sin/cos table         CP72 156
ELSE#                                  If angle is positive             CP72 157
I=INT(AMOD(ANG,1.)*360.+.5)+MARK0#     Point to sin/cos table           CP72 158
ACAL(L)=ACAL(L)+FACT*QX(I+91)#         Calc real s.f. component         CP72 159
IF(ICNT==0)#                           Test if centrosymmetric          CP72 160
BCAL(L)=BCAL(L)+FACT*QX(I+1)#          Calc imag s.f. component         CP72 161
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP72 162
#                                                                       CP72 163
#   CALC TOTAL COMPONENTS A & B                                         CP72 164
#   ---------------------------                                         CP72 165
#                                                                       CP72 166
ANOD=0.;  BNOD=0.#                     Reset a & b sums                 CP72 167
#                                                                       CP72 168
DO L=1,NATYP#                          Loop over scat. factors          CP72 169
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP72 170
IF(IRAD==1)J=OFF(L)#                   Point to neutron ff              CP72 171
ELSE       J=NINT(STOL/DSTL)+OFF(L)#   Point to ff curves               CP72 172
#                                                                       CP72 173
ANOD=ANOD+ACAL(L)*QX(J)#               Sum total real s.f.              CP72 174
IF(ICNT==0)#                           Test if centrosymmetric          CP72 175
BNOD=BNOD+BCAL(L)*QX(J)#               Sum total imag s.f.              CP72 176
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP72 177
#                                                                       CP72 178
#   CALCULATE TOTAL STRUCTURE FACTOR                                    CP72 179
#   --------------------------------                                    CP72 180
#                                                                       CP72 181
IF((ABS(ANOD)<.01)&(ABS(BNOD)<.01))ANOD=.01# Test indeterminency        CP72 182
PHI=AMOD(ATAN2(BNOD,ANOD)/PI2+1.000001,1.)# Get phase in cycles         CP72 183
IF(ICNT==0)FCAL=SQRT(ANOD*ANOD+BNOD*BNOD)# Calculate s.f.               CP72 184
ELSE       FCAL=ABS(ANOD)#                                              CP72 185
#                                                                       CP72 186
#                                                                       CP72 187
#    SETUP OUTPUT ARCHIVE LIST                                          CP72 188
#    -------------------------                                          CP72 189
#                                                                       CP72 190
IF(REFMOD==1)#                                                          CP72 191
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP72 192
phi:=PHI#                              Archive phase in cycles          CP72 193
wgt:=1.0#                                                               CP72 194
fcal:=FCAL#                            Fcalc                            CP72 195
#                                                                       CP72 196
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP72 197
ELSE#                                  Rewrite the access record        CP72 198
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP72 199
BUF1(7)=FCAL#                                                           CP72 200
BUF1(9)=PHI#                                                            CP72 201
writedac:(ioda2:,,REC,BUF1)#                                            CP72 202
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP72 203
IF(LSQ==MLSQ& REFMOD==0 & BUF1(5)<=1.0) NEXT# Impose evalue threshold   CP72 204
#                                                                       CP72 205
#   CALCULATE BOVL AND K DERIVS                                         CP72 206
#   ---------------------------                                         CP72 207
#                                                                       CP72 208
KFCAL=RSCAL*FCAL#                      Apply recip scale to fc          CP72 209
DELF=(FREL-KFCAL)#                                                      CP72 210
Q   =Q   +DELF*DELF#                   (fm-k.fc)*(fm-k.fc)              CP72 211
DQDK=DQDK+DELF*(-FCAL)#                (fm-k.fc)*(-fc)                  CP72 212
DQDB=DQDB+DELF*( S2L2*KFCAL)#          (fm-k.fc)*(-s2l2.k.fc)           CP72 213
DKDK=DKDK+FCAL*FCAL#                   (-fc)*(-fc)                      CP72 214
DBDB=DBDB+( S2L2*KFCAL)*( S2L2*KFCAL)# (-s2l2.k.fc)*(-s2l2.k.fc)        CP72 215
DBDB=DBDB+DELF*(-S2L2**2)*KFCAL#                                        CP72 216
DKDB=DKDB+(-FCAL)*( S2L2*KFCAL)#       (-fc)*(-s2l2.k.fc)               CP72 217
DKDB=DKDB+DELF*(S2L2**2)*FCAL#                                          CP72 218
#                                                                       CP72 219
FREL=FREL/RSCAL#                       Scale measured s.f.              CP72 220
#                                                                       CP72 221
IF(LSQ==MLSQ&DMP>4)#                                                    CP72 222
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP72 223
WRITE(6,'(3I4,F7.4,2F8.2,2F6.2,3F8.3)')$#                               CP72 224
NINT(AH),NINT(AK),NINT(AL),STOL,FREL,FCAL,EREL,ENEW,EXF2,TEMP,EPSI#     CP72 225
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP72 226
#                                                                       CP72 227
#    ACCUMULATE STATISTICS                                              CP72 228
#    ---------------------                                              CP72 229
#                                                                       CP72 230
SUMFR=SUMFR+FREL#                      Sum measured s.f.                CP72 231
SUMFC=SUMFC+FCAL#                      Sum calculated s.f.              CP72 232
SUMFD=SUMFD+ABS(FREL-FCAL)#            Sum f difference                 CP72 233
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP72 234
#                                                                       CP72 235
FRFAC=SUMFD/AMAX1(1.,SUMFR)#           F rfactor                        CP72 236
MFREL=SUMFR/AMAX1(1.,FLOAT(NREF))#     Mean frel                        CP72 237
MFCAL=SUMFC/AMAX1(1.,FLOAT(NREF))#     Mean fcal                        CP72 238
#                                                                       CP72 239
#                                                                       CP72 240
#ENCODE THESE VALUES AND REPORT AS FIGURES OF MERIT                     CP72 241
#                                                                       CP72 242
IF(DMP>2\(DMP==2&LSQ==MLSQ))#                                           CP72 243
WRITE(6,'(a14,F8.1,a10,F6.4,15x,a6,F7.3,a6,F7.3)')$# H              c   CP72 244
'SUM(Fm-Fc/k)^2',Q,"F Rfactor",FRFAC,"SCALE",$# Cp72 245                CP72 245
1./RSCAL,"BOVL",BOV#                                                    CP72 246
#                                                                       CP72 247
IF(LSQ==MLSQ) BREAK#                                                    CP72 248
#                                                                       CP72 249
DET=DKDK*DBDB-DKDB*DKDB#               Determinant                      CP72 250
#     IF DET IS <0 THEN THE SCALE/BOV CORRELATION MUST BE HUGE!         CP72 251
IF(SAB==yes: & DET<0.)#                                                 CP72 252
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP72 253
WRITE(6,*)' Huge scale and BOVL correlation suggests that this'#        CP72 254
WRITE(6,*)' solution is far from satisfactory!'#                        CP72 255
WRITE(6,*)' Defaulting to scale refinement only.'#                      CP72 256
SAB=no:#                                                                CP72 257
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP72 258
IF(SAB==yes:)#                                                          CP72 259
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP72 260
SHIFTA =-(DBDB*DQDK - DKDB*DQDB)/DET#                                   CP72 261
SHIFTB =-(-DKDB*DQDK + DKDK*DQDB)/DET#                                  CP72 262
SORSCAL=RSCAL#                                                          CP72 263
RSCAL=RSCAL+SHIFTA#                                                     CP72 264
BOV  =BOV  +SHIFTB#                                                     CP72 265
#                                                                       CP72 266
#                                                                       CP72 267
IF(DMP>2\(DMP==2&LSQ==MLSQ-1))#                                         CP72 268
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP72 269
SHIFTS= SHIFTA/SORSCAL/RSCAL#          Shift in actual scale            CP72 270
ESDS=SQRT(DBDB/DET)/(RSCAL*RSCAL)#                                      CP72 271
ESDB=SQRT(DKDK/DET)#                                                    CP72 272
WRITE(6,'(/a60,F7.3,6x,F7.3)')'SHIFTS   ', SHIFTS,SHIFTB#               CP72 273
WRITE(6,'(a60,F7.3,6x,F7.3)')'SU       ', ESDS,ESDB#                    CP72 274
WRITE(6,'(a60,F7.5,6x,F7.5)')$#                                         CP72 275
'SHIFT/SU ',ABS(SHIFTS/ESDS),ABS(SHIFTB/ESDB)#                          CP72 276
WRITE(6,'(/a9,F7.2,a9,F7.2,a9,F7.2,a9,f7.2,a5,I7/)')$#                  CP72 277
'<FREL>',MFREL,'<FCAL>',MFCAL,'<EREL>',MEREL,'<ECAL> ',MECAL,'NREF',$#  CP72 278
NREF#                                  Ha72 233                         CP72 279
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP72 280
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP72 281
ELSE RSCAL=RSCAL-DQDK/DKDK#            Apply shift                      CP72 282
#                                                                       CP72 283
IF(GSCAL*RSCAL>4.0 \ GSCAL*RSCAL<1./4.)#                                CP72 284
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP72 285
pt3:#                                                                   CP72 286
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP72 287
WRITE(6,*) "GENEV scale unlikely to be this inaccurate "#               CP72 288
WRITE(6,*) "Terminating scale refinement "#                             CP72 289
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP72 290
RSCAL=1./SCAL#                         Reset scale                      CP72 291
BOV=BOVL#                              Reset b overall                  CP72 292
LSQ=MLSQ-1#                                                             CP72 293
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP72 294
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP72 295
#                                                                       CP72 296
IF(MLSQ==1\LOOP==1)FRMIN=FRFAC#        Just calculating                 CP72 297
ELSE       FRMIN=MIN(FRMIN,FRFAC)#                                      CP72 298
ncodefld:(FRFAC,1,CP72B,400742.,1)#    Encode the final r-factor        CP72 299
pt1: writeline:(0,CP72B,NCP72B,3,3)#                                    CP72 300
ncodefld:(1./RSCAL,1,CP72C,400742.,1)# Encode the refined scale         CP72 301
pt1: writeline:(0,CP72C,NCP72C,3,3)#                                    CP72 302
ncodefld:(BOV,1,CP72D,400742.,1)#      Encode the refined b value       CP72 303
pt1: writeline:(0,CP72D,NCP72D,3,3)#                                    CP72 304
REFREL=FLOAT(NREF)#                    Save number of reflections       CP72 305
#                                                                       CP72 306
SCAL=1./RSCAL#                         Save last scale                  CP72 307
IF(BOV>0.0) BOVL=BOV#                  Save last boverall               CP72 308
ELSE WRITE(6,*) "RESETTING BOVL, to ",BOVL#                             CP72 309
100 CONTINUE#                                                           CP72 310
#                                                                       CP72 311
RETURN#                                                                 CP72 312
END#                                                                    CP72 313
systemheader:(CP77)#                   Compar current site with peakl   CP77   1
###################################################################     CP77   2
#                                                                  #    CP77   3
#                             CP77     (FORMERLY PP05)             #    CP77   4
#                                                                  #    CP77   5
###################################################################     CP77   6
SUBROUTINE CP77(KP,OK)#                                                 CP77   7
include:(AACOMN)#                                                       CP77   8
include:(CPCOMN)#                                                       CP77   9
#                                                                       CP77  10
INTEGER OK#                                                             CP77  11
INTEGER KP#                                                             CP77  12
INTEGER IB2,LB#                                                         CP77  13
INTEGER LP#                                                             CP77  14
REAL BL1,R1,MINR#                                                       CP77  15
#                                                                       CP77  16
OK=yes:#                               Assume ok                        CP77  17
#                                                                       CP77  18
#    CHECK BONDS                                                        CP77  19
#    -----------                                                        CP77  20
#                                                                       CP77  21
R1=atrad:#                                                              CP77  22
IB2=NINT(bond2:)#                      Get end of bond sequence         CP77  23
FOR(LB=NINT(bond1:);LB<IB2;LB=LB+STEPB)# Loop over 1st bond             CP77  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP77  25
IF(peak1:(LB)<.5) NEXT#                Skip disabled bonds              CP77  26
LP=NINT(peak2:(LB))#                   Point to site list               CP77  27
IF(peakt:(LP)<.5) NEXT#                Peak site not in current model   CP77  28
BL1=bondl:(LB)#                        Bond length 1                    CP77  29
MINR=(R1+atrad:(LP))*0.6#                                               CP77  30
IF(BL1>MINR) NEXT#                                                      CP77  31
OK=no:#                                                                 CP77  32
BREAK#                                                                  CP77  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP77  34
#                                                                       CP77  35
pt3:#                                                                   CP77  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP77  37
IF(OK==no:) WRITE(6,'(a9,I5,28x,I5,2F7.4,I5,F7.0)')" exclude ",$#       CP77  38
1+(KP-MARKA)/STEPA,NINT(peakt:(LP)),bondl:(LB),MINR,$#                  CP77  39
1+(LP-MARKA)/STEPA,peakh:(KP)#                                          CP77  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP77  41
#                                                                       CP77  42
#    CHECK BOND ANGLES                                                  CP77  43
#    -----------------                                                  CP77  44
#                                                                       CP77  45
####$(                                                                  CP77  46
#FOR(JB=LB+STEPB;JB<IB2;JB=JB+STEPB)#   LOOP OVER SECOND BOND           CP77  47
#$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5 CP77  48
#IF(PEAK1:(JB)<.5) NEXT#                SKIP DISABLED BONDS             CP77  49
#JP=NINT(PEAK2:(JB))#                   POINT TO SITE LIST              CP77  50
#IF(JP==LP) NEXT#                       SKIP IF SAME SITE               CP77  51
#BL2=BONDL:(JB)#                        BOND LENGTH 2                   CP77  52
#DX=PEAKX:(JP)-PEAKX:(LP)#              GET X DIFFERENCE                CP77  53
#DY=PEAKY:(JP)-PEAKY:(LP)#              GET Y DIFFERENCE                CP77  54
#DZ=PEAKZ:(JP)-PEAKZ:(LP)#              GET Z DIFFERENCE                CP77  55
#DD=G1*DX**2+G6*DY*DZ$#                 CALCULATE DISTANCE SQUARED      CP77  56
#+  G5*DY**2+G3*DX*DZ$#                 CALCULATE DISTANCE SQUARED      CP77  57
#+  G9*DZ**2+G2*DX*DY#                  CALCULATE DISTANCE SQUARED      CP77  58
#COSA=(BL1**2+BL2**2-DD)/(2.*BL1*BL2)#  CALCULATE COSINE ANGLE          CP77  59
#NANG=NANG+1#                           SUM ANGLES                      CP77  60
#ANGLE(NANG)=COSA#                                                      CP77  61
#$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5 CP77  62
#$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4 CP77  63
#                                                                       CP77  64
RETURN#                                                                 CP77  65
END#                                                                    CP77  66
systemheader:(CP79)#                   Peak list elimination by lsq     CP79   1
###################################################################     CP79   2
#                                                                  #    CP79   3
#                             CP79                                      CP79   4
#                                                                  #    CP79   5
###################################################################     CP79   6
SUBROUTINE CP79#                                                        CP79   7
include:(AACOMN)#                                                       CP79   8
include:(CPCOMN)#                                                       CP79   9
#                                                                       CP79  10
INTEGER MOREPK#                        More peaks yes:/no:              CP79  11
#                                                                       CP79  12
#                                                                       CP79  13
#  CONTINUE UNTIL NO MORE ADDITIONS                                     CP79  14
#  ================================                                     CP79  15
#                                                                       CP79  16
MOREPK=yes:#                                                            CP79  17
REPEAT#                                                                 CP79  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP79  19
CALL CP80#                             Least squares xyzb refinement    CP79  20
CALL CP82#                             Adjust types/reject sites        CP79  21
CALL CP83#                             Update marka atom list           CP79  22
CALL CP84(MOREPK)#                     Add smaller peaks until runout   CP79  23
IF(MOREPK==no:) BREAK#                                                  CP79  24
IF(LEVEL<=1)BREAK##                                                     CP79  25
#CALL CP72(5)#        ## FC05          Recalculate  fcal and phi        CP79  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP79  27
#CALL CP72(5)#        ## FC05          Recalculate  fcal and phi        CP79  28
#                                                                       CP79  29
#                                                                       CP79  30
#                                                                       CP79  31
RETURN#                                                                 CP79  32
END#                                                                    CP79  33
systemheader:(CP80)#                   Least squares refinement         CP80   1
###################################################################     CP80   2
#                                                                  #    CP80   3
#                             CP80                                      CP80   4
#                                                                  #    CP80   5
###################################################################     CP80   6
SUBROUTINE CP80#                       Simple diagonal lsq              CP80   7
include:(AACOMN)#                                                       CP80   8
include:(CPCOMN)#                                                       CP80   9
#                                                                       CP80  10
INTEGER H,I,J,K,L,M#                   Cp                               CP80  11
INTEGER JP,KP,KQ,KU,KV#                                                 CP80  12
INTEGER PNT#                           Cp8                              CP80  13
REAL Q,DQDK,DQDB,DKDK,DBDB,DKDB,DET#                                    CP80  14
REAL DFDP(4),DFDPI,SHPSUB,EBSH#                                         CP80  15
REAL SHIFTA,SHIFTB,SORSCAL,SHIFTS,ESDS,ESDB#                            CP80  16
REAL BUF1(12)#                                                          CP80  17
REAL SUMFR,SUMFC,SUMFD,FREL,STOL,FCAL,S2L2,DELF,FACT,ANG#               CP80  18
REAL SUMER,SUMEC,SUMED,FRFAC#                                           CP80  19
REAL RSCAL,BOV#                                                         CP80  20
INTEGER LSQ,NREF,REC,GN#                                                CP80  21
REAL HKL(3)#                                                            CP80  22
REAL AH,AK,AL#                                                          CP80  23
REAL ACAL(16),BCAL(16)#                                                 CP80  24
REAL ANOD,BNOD#                                                         CP80  25
REAL A1,B1,PHI,KFCAL#                                                   CP80  26
REAL MFREL,MFCAL#                      Cp80  27                         CP80  27
INTEGER MLSQ#                                                           CP80  28
REAL SHIFT#                                                             CP80  29
INTEGER FF,LPT#                                                         CP80  30
INTEGER NA,NS#                                                          CP80  31
REAL S,SH(3),SH1(3)#                                                    CP80  32
REAL MULT,SIG,TEMP,WGT,SBOV#                                            CP80  33
INTEGER TYP#                                                            CP80  34
INTEGER PTZ#                                                            CP80  35
#                                                                       CP80  36
INTEGER MARKQ,MARKU,MARKV#                                              CP80  37
INTEGER STOPQ,STOPU,STOPV#                                              CP80  38
INTEGER STEPQ,STEPU,STEPV#                                              CP80  39
REAL    SIGMA(4)#                      Least squares errors             CP80  40
realdata:(FMT1,[952.,952.,952.])#                                       CP80  41
realdata:(PI2,6.2831853)#                                               CP80  42
chardata:(CP80A,$#                                                      CP80  43
' Diagonal least squares for scale BOVL x y z and BISO ')#              CP80  44
chardata:(CP80B," Only using generators ")#                             CP80  45
chardata:(CP80C," Using all Es >1.0 ")#                                 CP80  46
chardata:(CP80D," Using all Reflections ")#                             CP80  47
chardata:(CP80E,' Refined Frel R-factor                  ')#            CP80  48
chardata:(CP80F,' New scale factor                       ')#            CP80  49
chardata:(CP80G,' New B overall                          ')#            CP80  50
intdata:(ZEROS,[2,3,4,2,6,7,3,6,9,4,7,9])# For invariant params         CP80  51
intdata:(ONES, [1,5,8,10])#            For invariant params             CP80  52
datastuff:#                                                             CP80  53
#                                                                       CP80  54
pt1: writeline:(0,CP80A,NCP80A,3,3)#   Cp80  50                         CP80  55
pt3:#                                                                   CP80  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP80  57
IF    (REFMOD==1)writeline:(0,CP80B,NCP80B,3,3)#                        CP80  58
ELSEIF(REFMOD==0)writeline:(0,CP80C,NCP80C,3,3)#                        CP80  59
ELSE             writeline:(0,CP80D,NCP80D,3,3)#                        CP80  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP80  61
DO I=1,NATYP; OFF(I)=MARK3+(I-1)*NSCF+1# Setup ff table offsets         CP80  62
RSCAL=1.0/SCAL#                                                         CP80  63
BOV=BOVL#                                                               CP80  64
#                                                                       CP80  65
#   GET MEMORY FOR FIRST AND SECOND DERIVES                             CP80  66
#   ---------------------------------------                             CP80  67
#                                                                       CP80  68
STEPQ=4;STEPU=4;STEPV=10#                                               CP80  69
IF(ICNT==0)STEPQ=STEPQ*2#                                               CP80  70
MARKQ=STOPP#                                                            CP80  71
QXCUR=MARKQ#                                                            CP80  72
incrqx:(STOPQ,MARKQ+NATM*STEPQ,CP8001)# (d f(h,n) /dpi)**2              CP80  73
MARKU=STOPQ#                                                            CP80  74
incrqx:(STOPU,MARKU+NATM*STEPU,CP8001)# Del *(sum d f(h) /dpi)          CP80  75
MARKV=STOPU#                           C                                CP80  76
incrqx:(STOPV,MARKV+NATM*STEPV,CP8001)# (sum d f(h) /dpi)**2            CP80  77
#                                                                       CP80  78
#   BEGIN LEAST SQUARES REFINEMENT                                      CP80  79
#   ------------------------------                                      CP80  80
#                                                                       CP80  81
MLSQ=5#                                                                 CP80  82
DO LSQ=1,MLSQ#                         Three least squares cycles       CP80  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP80  84
DO I=MARKU+1,STOPU;QX(I)=0.0#          Initialize                       CP80  85
DO I=MARKV+1,STOPV;QX(I)=0.0#          Initialize                       CP80  86
#                                      Initialize lsq sums              CP80  87
Q   =0.#                               (fm-k.fc)*(fm-k.fc) residual     CP80  88
DQDK=0.#                               (fm-k.fc)*(-fc)                  CP80  89
DQDB=0.#                               (fm-k.fc)*(-s2l2.k.fc)           CP80  90
DKDK=0.#                               (-fc)*(-fc)                      CP80  91
DBDB=0.#                               (-s2l2.k.fc)*(-s2l2.k.fc)        CP80  92
DKDB=0.#                               (-fc)*(-s2l2.k.fc)               CP80  93
#                                      Other sums                       CP80  94
SUMFR=0.#                              Sum measured s.f.                CP80  95
SUMFC=0.#                              Sum calculated s.f.              CP80  96
SUMFD=0.#                              Sum f difference                 CP80  97
SUMER=0.#                              Sum measured s.f.                CP80  98
SUMEC=0.#                              Sum calculated s.f.              CP80  99
SUMED=0.#                              Sum f difference                 CP80 100
#                                                                       CP80 101
#  LOOP OVER GENERATOR REFLECTION PACKETS                               CP80 102
#  ======================================                               CP80 103
#                                                                       CP80 104
NREF=0#                                Number of generator refs         CP80 105
REC=0#                                                                  CP80 106
IF(REFMOD==1)GN=MARK6-MARK#            Initialize                       CP80 107
REPEAT#                                                                 CP80 108
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP80 109
#                                                                       CP80 110
#    EXTRACT REQUIRED REFLN DATA                                        CP80 111
#    ---------------------------                                        CP80 112
#                                                                       CP80 113
IF(REFMOD==1)#                         Using grenerator ref list        CP80 114
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP80 115
GN=GN+MARK#                            Using grenerator ref list        CP80 116
IF(GN>=MQ)BREAK#                       End of gen list                  CP80 117
FREL=frel:#                            Ha76 1                           CP80 118
STOL=stol:#                            Extract st/l                     CP80 119
FCAL=fcal:#                                                             CP80 120
PHI= phi:#                             Get old phi estimate             CP80 121
SIG=1.0#                               Fudge it for now                 CP80 122
gethkl:(GN+1,HKL)#                     Extract signed h,k,l             CP80 123
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP80 124
ELSE#                                                                   CP80 125
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP80 126
REC=REC+1#                                                              CP80 127
IF(REC>DACREF) BREAK#                  End of direct access file        CP80 128
readdac:(ioda2:,,REC,BUF1)#                                             CP80 129
IF(REFMOD==0 & BUF1(5)<1.0) NEXT#      Impose evalue threshold          CP80 130
IF(REFMOD==-1& BUF1(4)<SIGMUL*BUF1(10))NEXT# Ignore very weak           CP80 131
DO KQJ=1,3#                            Get hkl                          CP80 132
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP80 133
intunpak:(BUF1(1),JQK,(KQJ-1)*9+3,9)#                                   CP80 134
intunpak:(BUF1(1),KZJ,KQJ-1,1)#                                         CP80 135
IF(KZJ!=0)JQK=-JQK#                                                     CP80 136
HKL(4-KQJ)=FLOAT(JQK)#                                                  CP80 137
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP80 138
STOL=BUF1(3)#                          Extract st/l                     CP80 139
FREL=BUF1(4)#                          F relative                       CP80 140
FCAL=BUF1(7)#                          Get old estimate                 CP80 141
PHI=BUF1(9)#                           Get old phi estimate             CP80 142
SIG=BUF1(10)#                          Get true sigma                   CP80 143
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP80 144
IF(FREL<0.5)NEXT#                      Ignore weak reflections          CP80 145
NREF=NREF+1#                                                            CP80 146
S2L2=STOL**2#                          Get (st/l) squared               CP80 147
AH=HKL(1); AK=HKL(2); AL=HKL(3)#       Make hkl local variables         CP80 148
NA=-1#                                 Sequence number of indep atoms   CP80 149
DO KQ=MARKQ+1,STOPQ;QX(KQ)=0.0#        Clear temp first deriv sums      CP80 150
TEMP=EXP(-BOV*S2L2)#                   Calc overall temp factor         CP80 151
#                                                                       CP80 152
IF (PHI> .1) S=-1.#                                                     CP80 153
ELSE         S=1.#                                                      CP80 154
#                                                                       CP80 155
#                                                                       CP80 156
#    LOOP OVER ATOMS LIST                                               CP80 157
#    --------------------                                               CP80 158
#                                                                       CP80 159
DO I=1,NATYP#                          Loop over atom types             CP80 160
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP80 161
ACAL(I)=0.;   BCAL(I)=0.#              Zeroize s.f. components          CP80 162
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP80 163
#                                                                       CP80 164
FOR(M=MARKN;M<STOPN;M=M+IATM)#         Loop over atoms list             CP80 165
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP80 166
L=NINT(QX(M+1))#                       Extract sf sequence              CP80 167
IF(L<0)#                               Not invoked site                 CP80 168
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP80 169
M=M+STEPN-IATM#                        Skip equivalents                 CP80 170
NA=NA+1#                                                                CP80 171
NEXT#                                  Go back for more                 CP80 172
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP80 173
ELSEIF(L>0)#                           Test if equivalent site          CP80 174
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP80 175
NA=NA+1#                                                                CP80 176
IF(IRAD==1)FF=OFF(L)#                  Point to neutron ff              CP80 177
ELSE       FF=NINT(STOL/DSTL)+OFF(L)#  Point to ff curves               CP80 178
IF(QX(M+6)>0.0)FACT=QX(M+5)*EXP(-QX(M+6)*S2L2)*QX(FF)# Get s.f.prod     CP80 179
ELSE           FACT=QX(M+5)*TEMP*QX(FF)# Get s.f.product                CP80 180
KQ=MARKQ+NA*STEPQ#                     Pointer to sym equiv derivs      CP80 181
NS=-1#                                 Save current sym equiv positio   CP80 182
LPT=L#                                 Last l type pointer              CP80 183
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP80 184
NS=NS+1#                                                                CP80 185
#                                                                       CP80 186
#   CALC A & B FOR EACH ATOM TYPE                                       CP80 187
#   -----------------------------                                       CP80 188
#                                                                       CP80 189
ANG=AH*QX(M+2)+AK*QX(M+3)+AL*QX(M+4)#  Calc phase component             CP80 190
IF(ANG<0.)#                            Test if angle negative           CP80 191
I=INT((1.+AMOD(ANG,1.))*360.+.5)+MARK0## Point to sin/cos table         CP80 192
ELSE#                                  If angle is positive             CP80 193
I=INT(    AMOD(ANG,1.) *360.+.5)+MARK0# Point to sin/cos table          CP80 194
A1=FACT*QX(I+91)#                      Ff*pop*mul*expu*cos              CP80 195
B1=FACT*QX(I+ 1)#                      Ff*pop*mul*expu*sin              CP80 196
#IF(NREF==1)WRITE(6,'(6F9.4)')$#                                        CP80 197
#A1,FACT,QX(M+6),S2L2,QX(I+91),ANG                                      CP80 198
#                                                                       CP80 199
# ACCUMULATE FIRST DERIVATIVES WRT XYZB                                 CP80 200
# -------------------------------------                                 CP80 201
#                                                                       CP80 202
ACAL(LPT)=ACAL(LPT)+A1#                Calc real s.f. component         CP80 203
QX(KQ+1) = QX(KQ+1)-S2L2*A1#           D expb cos /d bn                 CP80 204
PNT=QX(M+8)#                           Pointer to constraint            CP80 205
K=MARKS+NS*STEPS#                      Symop offset number              CP80 206
DO J=1,3#                              Derivtve d/dxh wrt orig h coor   CP80 207
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP80 208
H=NINT(QX(PNT+J*2-1))#                 Coordinate xj depends on xh      CP80 209
MULT=QX(PNT+J*2)#                      Dxj/dxh                          CP80 210
ifeq:(MULT,0.0)NEXT#                   Invariant param                  CP80 211
DO I=1,3#                              For yi=yi(xh=1,2,3)              CP80 212
QX(KQ+1+H)=QX(KQ+1+H)-$#               For orig coord xh                CP80 213
PI2*HKL(I)*B1*QX(K+I+J*3-3)*MULT#      D expb cos yi(j) /d xh           CP80 214
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP80 215
#                                                                       CP80 216
IF(ICNT==0)#                           Test if noncentrosymmetric       CP80 217
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP80 218
BCAL(LPT)=BCAL(LPT)+B1#                Calc real s.f. component         CP80 219
QX(KQ+5) =QX(KQ+5) -B1*S2L2#           D expb cos /d bn                 CP80 220
DO J=1,3#                              Derivtve d/dxh wrt orig h coor   CP80 221
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP80 222
H=NINT(QX(PNT+J*2-1))#                 Coordinate xj depends on xh      CP80 223
MULT=QX(PNT+J*2)#                      Dxj/dxh                          CP80 224
ifeq:(MULT,0.0)NEXT#                   Invariant param                  CP80 225
DO I=1,3#                              For yi=yi(xh=1,2,3)              CP80 226
QX(KQ+5+H)=QX(KQ+5+H)+$#               For orig coord xh                CP80 227
PI2*HKL(I)*A1*QX(K+I+J*3-3)*MULT#      D expb sin yi(j) /d xh           CP80 228
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP80 229
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP80 230
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP80 231
#                                                                       CP80 232
#   FOR EACH REFLECTION CALC TOTAL COMPONENTS A & B                     CP80 233
#   -----------------------------------------------                     CP80 234
#                                                                       CP80 235
ANOD=0.;  BNOD=0.#                     Reset a & b sums                 CP80 236
DO L=1,NATYP#                          Loop over scat. factors          CP80 237
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP80 238
ANOD=ANOD+ACAL(L)#                     Accumulate indep components      CP80 239
IF(ICNT==0)#                           Test if centrosymmetric          CP80 240
BNOD=BNOD+BCAL(L)#                                                      CP80 241
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP80 242
IF((ABS(ANOD)<.01)&(ABS(BNOD)<.01))ANOD=.01# Test indeterminency        CP80 243
#                                                                       CP80 244
#                                                                       CP80 245
#   CALCULATE TOTAL STRUCTURE FACTOR                                    CP80 246
#   --------------------------------                                    CP80 247
#                                                                       CP80 248
PHI=AMOD(ATAN2(BNOD,ANOD)/PI2+1.000001,1.)# Get phase in cycles         CP80 249
IF(ICNT==0)FCAL=SQRT(ANOD*ANOD+BNOD*BNOD)# Calculate s.f.               CP80 250
ELSE       FCAL=ABS(ANOD)#                                              CP80 251
KFCAL=RSCAL*FCAL#                      Apply recip scale to fc          CP80 252
DELF=(FREL-KFCAL)#                                                      CP80 253
WGT=1./SIG*SIG#                        Weight = 1/sig^2                 CP80 254
#                                                                       CP80 255
#                                                                       CP80 256
#   ACCUMULATE DERIVATIVES FOR PARAM UI,XI,YI,ZI                        CP80 257
#   --------------------------------------------                        CP80 258
#                                                                       CP80 259
KU=MARKU#                                                               CP80 260
KV=MARKV#                                                               CP80 261
FOR(KQ=0;KQ<STOPQ-MARKQ;KQ=KQ+STEPQ)#  For all independent atoms        CP80 262
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP80 263
DO J=1,4#                              For all 4 params                 CP80 264
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP80 265
IF(ICNT==0)#                                                            CP80 266
DFDPI=RSCAL*(ANOD*QX(MARKQ+KQ+J)+BNOD*QX(MARKQ+KQ+4+J))/MAX(.01,FCAL)#  CP80 267
ELSE     DFDPI= S*RSCAL*QX(MARKQ+KQ+J)#                                 CP80 268
QX(KU+J)= QX(KU+J)+WGT*DFDPI*DELF#     Sum[hkl](dfc/dpi)*delf           CP80 269
DFDP(J)=DFDPI#                         Save for cross terms             CP80 270
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP80 271
L=0#                                                                    CP80 272
DO J=1,4;DO K=J,4#                     For all 4 params                 CP80 273
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP80 274
L=L+1#                                 Upper triangular 4x4 matrix      CP80 275
QX(KV+L)=QX(KV+L)+WGT*DFDP(J)*DFDP(K)# Sum[hkl](dfc/dpi)(dfc/dpj)       CP80 276
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP80 277
KV=KV+STEPV#                           Step to next 2deriv 4x4 matrix   CP80 278
KU=KU+STEPU#                           Step to next 1stderiv 4 vector   CP80 279
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP80 280
#                                                                       CP80 281
#   CALCULATE BOVL AND SCALE FACTOR DERIVS                              CP80 282
#   --------------------------------------                              CP80 283
#                                                                       CP80 284
Q   =Q   +WGT*DELF*DELF#               (fm-k.fc)*(fm-k.fc)              CP80 285
DQDK=DQDK+WGT*DELF*(-FCAL)#            (fm-k.fc)*(-fc)                  CP80 286
DQDB=DQDB+WGT*DELF*( S2L2*KFCAL)#      (fm-k.fc)*(-s2l2.k.fc)           CP80 287
DKDK=DKDK+WGT*FCAL*FCAL#               (-fc)*(-fc)                      CP80 288
DBDB=DBDB+WGT*( S2L2*KFCAL)*( S2L2*KFCAL)# (-s2l2.k.fc)*(-s2l2.k.fc)    CP80 289
#DBDB=DBDB+WGT*DELF*(-S2L2**2)*KFCAL#                                   CP80 290
DKDB=DKDB+WGT*(-FCAL)*( S2L2*KFCAL)#   (-fc)*(-s2l2.k.fc)               CP80 291
#DKDB=DKDB+WGT*DELF*(S2L2**2)*FCAL#                                     CP80 292
#                                                                       CP80 293
#    SETUP OUTPUT ARCHIVE LIST                                          CP80 294
#    -------------------------                                          CP80 295
#                                                                       CP80 296
FREL=FREL/RSCAL#                       Scale measured s.f.              CP80 297
#                                                                       CP80 298
IF(REFMOD==1)#                                                          CP80 299
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP80 300
phi:=PHI#                              Archive phase in cycles          CP80 301
wgt:=1.0#                                                               CP80 302
fcal:=FCAL#                            Fcalc                            CP80 303
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP80 304
ELSE#                                  Rewrite the access record        CP80 305
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP80 306
BUF1(7)=FCAL#                                                           CP80 307
BUF1(9)=PHI#                                                            CP80 308
writedac:(ioda2:,,REC,BUF1)#                                            CP80 309
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP80 310
#                                                                       CP80 311
IF(DMP>4&LSQ>=MLSQ)#                                                    CP80 312
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CP80 313
WRITE(6,'(3I4,F7.4,2F8.2,F7.0,F8.2)')$#                                 CP80 314
NINT(AH),NINT(AK),NINT(AL),STOL,FREL,FCAL,PHI*360.,DELF#                CP80 315
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CP80 316
#                                                                       CP80 317
#    ACCUMULATE STATISTICS                                              CP80 318
#    ---------------------                                              CP80 319
#                                                                       CP80 320
SUMFR=SUMFR+FREL#                      Sum measured s.f.                CP80 321
SUMFC=SUMFC+FCAL#                      Sum calculated s.f.              CP80 322
SUMFD=SUMFD+ABS(FREL-FCAL)#            Sum f difference                 CP80 323
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP80 324
#                                                                       CP80 325
FRFAC=SUMFD/AMAX1(1.,SUMFR)#           F rfactor                        CP80 326
MFREL=SUMFR/AMAX1(1.,FLOAT(NREF))#     Mean frel                        CP80 327
MFCAL=SUMFC/AMAX1(1.,FLOAT(NREF))#     Mean fcal                        CP80 328
#                                                                       CP80 329
#     ENCODE THESE VALUES AND REPORT AS FIGURES OF MERIT                CP80 330
#                                                                       CP80 331
#IF(DMP>2&LSQ>=MLSQ)#                                                   CP80 332
pt3:#                                                                   CP80 333
WRITE(6,'(a14,F8.1,a10,F7.4,15x,a6,F7.3,a6,F7.3)')$# H              c   CP80 334
'SUM(Fm-Fc/k)^2',Q,"F Rfactor",FRFAC,"SKF",RSCAL,"BOVL",BOV#            CP80 335
#                                                                       CP80 336
DET=DKDK*DBDB-DKDB*DKDB#               Determinant                      CP80 337
SHIFTA =-(DBDB*DQDK - DKDB*DQDB)/DET#                                   CP80 338
SHIFTB =-(-DKDB*DQDK + DKDK*DQDB)/DET#                                  CP80 339
SORSCAL=RSCAL#                                                          CP80 340
SBOV=BOV#                              Cp72                             CP80 341
RSCAL=RSCAL+0.5*SHIFTA#                                                 CP80 342
#BOV  =BOV  +0.5*SHIFTB#                                                CP80 343
#IF(DMP>2&LSQ>=MLSQ)#                                                   CP80 344
pt3:#                                                                   CP80 345
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CP80 346
WRITE(6,'(a60,F7.3,6x,F7.3)')'SHIFTS   ', SHIFTA,SHIFTB# C              CP80 347
WRITE(6,'(a60,F7.3,6x,F7.3)')'NEW      ', RSCAL ,BOV#                   CP80 348
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CP80 349
#                                                                       CP80 350
IF(LSQ>=MLSQ&DMP>2)#                   Only write second loop           CP80 351
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CP80 352
SHIFTS= SHIFTA/SORSCAL/RSCAL#          Shift in actual scale            CP80 353
ESDS=SQRT(DBDB/DET)/(RSCAL*RSCAL)#                                      CP80 354
ESDB=SQRT(DKDK/DET)#                                                    CP80 355
WRITE(6,'(a60,F7.3,6x,F7.3)')'SU       ', ESDS,ESDB#                    CP80 356
WRITE(6,'(a60,F7.5,6x,F7.5)')$#                                         CP80 357
'SHIFT/SU ',ABS(SHIFTS/ESDS),ABS(SHIFTB/ESDB)#                          CP80 358
WRITE(6,'(/a9,F7.2,a9,F7.2,a5,I7/)')$#                                  CP80 359
'<FREL>',MFREL,'<FCAL>',MFCAL,'NREF',NREF#                              CP80 360
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CP80 361
#                                                                       CP80 362
#                                                                       CP80 363
SHPSUB=-DQDB/DBDB#                     Shift in pseudo b                CP80 364
EBSH= -SHPSUB+SHIFTB#                                                   CP80 365
pt4:#                                                                   CP80 366
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CP80 367
WRITE(6,*)"BISO   CORRELATED",SHIFTB#                                   CP80 368
WRITE(6,*)"BISO UNCORRELATED",SHPSUB#                                   CP80 369
WRITE(6,*)"BISO CORRECTION",  EBSH#                                     CP80 370
WRITE(6,*)"NREF             ",NREF#                                     CP80 371
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CP80 372
#                                                                       CP80 373
#  CALCULATE DIAGONAL MATRIX PARAMETER SHIFTS                           CP80 374
#  ------------------------------------------                           CP80 375
#                                                                       CP80 376
KV=MARKV-STEPV;KP=MARKN-STEPN#                                          CP80 377
FOR(KU=MARKU;KU<STOPU;KU=KU+STEPU)#    For all params b,x,y,z           CP80 378
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CP80 379
KV=KV+STEPV;KP=KP+STEPN#               Pointer to markn                 CP80 380
TYP=NINT(QX(KP+1))#                    Cp80                             CP80 381
IF(TYP<=0)NEXT#                        Skip not invoked site            CP80 382
DO I=1,4;ifeq:(QX(KU+I),0.0)#          Filter derivatives (1st d=0)     CP80 383
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CP80 384
DO J=1,3;QX(KV+ZEROS(I*3-3+J))=0.0#    Zeroize correlation terms        CP80 385
QX(KV+ONES(I)) =1.0#                   Fix invariant term to one        CP80 386
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CP80 387
invert4x4:(KU,KV,SIGMA,yes:)#          Complete inversion               CP80 388
DO I=1,4;QX(KU+I)=0.5*QX(KU+I)#        Shift damping factor             CP80 389
#                                                                       CP80 390
CHROT='  OLD '#                                                         CP80 391
movertoc:(QX(MARK2+(TYP-1)*ISCF+1),1,CHROT,7,ISCF,1)#                   CP80 392
ncodefld:(FLOAT(1+(KU-MARKU)/STEPU),1,CHROT,120413.,1)# Encode sequ n   CP80 393
SHIFT=QX(KU+1)#                        Shift in biso                    CP80 394
IF(QX(KP+6)<=0.0)#                     New value do shift from iso      CP80 395
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CP80 396
ncodefld:(SBOV,1,CHROT,200842.,1)#     Encode biso                      CP80 397
QX(KP+6)=SBOV+SHIFT#                   Calculate new biso               CP80 398
IF(QX(KP+6)<=0.0)#                     Strongly suggests wrong type     CP80 399
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CP80 400
DO PTZ=1,NATYP#                                                         CP80 401
IF(ATZORD(PTZ)==TYP)BREAK#                                              CP80 402
TYP=ATZORD(MAX(1,PTZ-1))#                                               CP80 403
QX(KP+1)=FLOAT(TYP)#                   Positive its a larger z atom t   CP80 404
QX(KP+6)=-1.0#                         Reset the b value to boverall    CP80 405
movertoc:(QX(MARK2+(TYP-1)*ISCF+1),1,CHROT,7,ISCF,1)#                   CP80 406
CHROT(50^66)='Forcibly promoted'#                                       CP80 407
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CP80 408
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CP80 409
ELSE#                                  Modify old value                 CP80 410
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CP80 411
ncodefld:(QX(KP+6),1,CHROT,200842.,1)# Encode biso                      CP80 412
QX(KP+6)=QX(KP+6)+SHIFT#               Calculate new biso               CP80 413
IF(QX(KP+6)>20.)#                      What a disaster!                 CP80 414
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CP80 415
QX(KP+1)=-100.-ABS(QX(KP+1))#          Erase from face of the earth     CP80 416
QX(KP+6)=-1.#                          Reset the b value to boverall    CP80 417
CHROT(50^75)='Terminated with prejudice'# It won't do that again        CP80 418
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CP80 419
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CP80 420
ncodefld:(QX(KP+2),1,CHROT,FMT1,3)#    Encode x,y,z                     CP80 421
pt4:  writeline:(0,0,0,1,3)#           Output buffer                    CP80 422
CHROT='SHIFT '#                                                         CP80 423
ncodefld:(SHIFT,1,CHROT,200842.,1)#    Encode biso                      CP80 424
#                                      Biso used for all sym related    CP80 425
# CALCULATE XYZ SHIFTS                                                  CP80 426
# --------------------                                                  CP80 427
#                                                                       CP80 428
PNT=QX(KP+8)#                          Pointer to peak site constrain   CP80 429
DO H=1,3; SH(H)=QX(KU+1+H)#            Shift in biso                    CP80 430
ncodefld:(SH,1,CHROT,FMT1,3)#          Encode biso                      CP80 431
pt4:  writeline:(0,0,0,1,3)#           Output buffer                    CP80 432
#                                                                       CP80 433
#  LOOP FOR PARAMETER DEPENDENCIES                                      CP80 434
#  -------------------------------                                      CP80 435
#                                                                       CP80 436
DO J=1,3#                              Derivtve d/dxh wrt orig h coor   CP80 437
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CP80 438
H=NINT(QX(PNT+J*2-1))#                 Coordinate xj depends on xh      CP80 439
MULT  =QX(PNT+J*2)#                    Dxj/dxh                          CP80 440
SH1(J)=MULT*SH(H)#                     Propagate dependent params       CP80 441
IF(ABS(SH1(J)*CELLC(J))>0.4)SH1(J)=0.0# Shift too large - force invar   CP80 442
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CP80 443
#                                                                       CP80 444
#  PROPOGATE XYZ SHIFTS THROUGH ALL SYM RELATED SITES                   CP80 445
#  --------------------------------------------------                   CP80 446
#                                                                       CP80 447
#WRITE(6,*)( QX(PNT+I),I=1,6)# WRITE CONSTRAINT                         CP80 448
FOR(JP=KP;JP<KP+STEPN;JP=JP+IATM)#     For all symm related sites       CP80 449
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CP80 450
K=MARKS+12*(JP-KP)/IATM#               Identify symop and get ptr       CP80 451
DO I=1,3#                              For y1,y2,y3                     CP80 452
DO H=1,3#                              Dependent on x1,x2,x3            CP80 453
QX(JP+1+I) =QX(JP+1+I)+ SH1(H)*QX(K+I+3*H-3)# Apply shift to coords     CP80 454
#WRITE(6,*) QX(JP+2),QX(JP+3),QX(JP+4)#  NEW COORDS                     CP80 455
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CP80 456
#                                                                       CP80 457
CHROT='  NEW '#                                                         CP80 458
ncodefld:(QX(KP+6),1,CHROT,200842.,1)# Encode biso                      CP80 459
ncodefld:(QX(KP+2),1,CHROT,FMT1,3)#    Encode x,y,z                     CP80 460
pt4:  writeline:(0,0,0,1,3)#           Output buffer                    CP80 461
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CP80 462
#                                                                       CP80 463
#  MOVE ON TO NEXT LEAST SQUARES CYCLE                                  CP80 464
#  -----------------------------------                                  CP80 465
#                                                                       CP80 466
IF(GSCAL*RSCAL>4.0 \ GSCAL*RSCAL<1./4.)#                                CP80 467
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 CP80 468
WRITE(6,*) "GENEV scale unlikely to be this inaccurate "#               CP80 469
WRITE(6,*) "Terminating scale refinement "#                             CP80 470
BREAK#                                                                  CP80 471
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CP80 472
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP80 473
FRMIN=MIN(FRMIN,FRFAC)#                Record minimum r-factor          CP80 474
ncodefld:(FRFAC,1,CP80E,400742.,1)#    Encode the final r-factor        CP80 475
pt1: writeline:(0,CP80E,NCP80E,3,3)#                                    CP80 476
ncodefld:(1./RSCAL,1,CP80F,400742.,1)# Encode the refined scale         CP80 477
pt1: writeline:(0,CP80F,NCP80F,3,3)#                                    CP80 478
ncodefld:(BOV,1,CP80G,400742.,1)#      Encode the refined b value       CP80 479
pt1: writeline:(0,CP80G,NCP80G,3,3)#                                    CP80 480
REFREL=FLOAT(NREF)#                    Save number of reflections       CP80 481
SCAL=1.0/RSCAL#                                                         CP80 482
BOVL=BOV#                                                               CP80 483
#                                                                       CP80 484
#                                                                       CP80 485
RETURN#                                                                 CP80 486
END#                                                                    CP80 487
systemheader:(CP81)#                   Atom site constraint identifie   CP81   1
###################################################################     CP81   2
#                                                                  #    CP81   3
#                             CP81                                      CP81   4
#                                                                  #    CP81   5
###################################################################     CP81   6
SUBROUTINE CP81(X,FLG,PAR,CONST,MULT)#                                  CP81   7
include:(AACOMN)#                                                       CP81   8
include:(CPCOMN)#                                                       CP81   9
#                                                                       CP81  10
REAL X(3)#          ## Original coordinates                             CP81  11
REAL CONST(3)#      ## additive constant for dependent coord            CP81  12
REAL MULT(3)#       ## multipliier for dependent coord                  CP81  13
INTEGER  FLG(3)#    ## constraint status of  original coords            CP81  14
INTEGER  PAR(3)#    ## Dependency of original coord                     CP81  15
REAL    EQUPOS(9)#                                                      CP81  16
INTEGER I,J#                                                            CP81  17
INTEGER II,JJ,LL,NN#                                                    CP81  18
INTEGER PARPNT(3)#  ## Related parameter pointer 1 to 9 for x to u23    CP81  19
REAL    PARSCL(3)#  ## Parameter scale factors                          CP81  20
INTEGER STATUS(3)#  ## Parameter status as search unfolds               CP81  21
REAL    Y(3)#    ## Positional parameters derived from symmetry         CP81  22
INTEGER L,JREF,KK#                     Ad05                             CP81  23
REAL    DIAG,DIF,DIFDUM,ZZZ#                                            CP81  24
#                                                                       CP81  25
realdata:(RESOLU,0.0005)#                                               CP81  26
intdata:(REFPNT,[1,5,9])#                                               CP81  27
datastuff:#                                                             CP81  28
#                                                                       CP81  29
#   LOOP OVER ATOMS LIST                                                CP81  30
#   --------------------                                                CP81  31
#                                                                       CP81  32
DO I=1,3#                              Loop over atom parameters        CP81  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP81  34
STATUS(I)=0; PARPNT(I)=0; PARSCL(I)=0.# Reset stat, point & scl         CP81  35
CONST(I)=0.0;MULT(I)=0.0;PAR(I)=0;FLG(I)=0#                             CP81  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP81  37
#                                                                       CP81  38
#   LOOP OVER SYMMMETRY MATRICES                                        CP81  39
#   ----------------------------                                        CP81  40
#                                                                       CP81  41
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over all symops             CP81  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP81  43
Y(1)=X(1)*QX(J+1)+X(2)*QX(J+4)+X(3)*QX(J+7)+QX(J+10)# Get x             CP81  44
Y(2)=X(1)*QX(J+2)+X(2)*QX(J+5)+X(3)*QX(J+8)+QX(J+11)# Get y             CP81  45
Y(3)=X(1)*QX(J+3)+X(2)*QX(J+6)+X(3)*QX(J+9)+QX(J+12)# Get z             CP81  46
#                                                                       CP81  47
#   TEST FOR SPECIAL POSITION                                           CP81  48
#   -------------------------                                           CP81  49
#                                                                       CP81  50
DO I=1,3#                              Loop over coordinates            CP81  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP81  52
DIF=X(I)-Y(I);  DIFDUM=DIF#            Get diff in coordinate           CP81  53
DIF=DIF-FLOAT(NINT(DIFDUM))#           Get smallest difference          CP81  54
IF(ABS(DIF)>RESOLU) GOTO 100#          Skip to next symop               CP81  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP81  56
#                                                                       CP81  57
#   SPECIAL POSITION DETECTED - BUILD 3X3 MATRIX                        CP81  58
#   --------------------------------------------                        CP81  59
#                                                                       CP81  60
KK=0#                                  Reset the equpos pointer         CP81  61
DO II=1,3#                             Loop over x,y,z,u11,u22,u33      CP81  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP81  63
L=J+II-1#                              Point to symops                  CP81  64
EQUPOS(KK+1)=QX(L+1)#                  Store r11 (r21, r31)             CP81  65
EQUPOS(KK+2)=QX(L+4)#                  Store r12 (r22, r32)             CP81  66
EQUPOS(KK+3)=QX(L+7)#                  Store r13 (r23, r33)             CP81  67
KK=KK+3#                               Incr equpos pointer              CP81  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP81  69
#                                                                       CP81  70
#   SCAN MATRIX FOR CONSTRAINTS                                         CP81  71
#   ---------------------------                                         CP81  72
#                                                                       CP81  73
#     STATUS         MEANING                                            CP81  74
#      -1            REFINABLE WITH SITES CONSTRAINED TO IT             CP81  75
#       0            UNDETERMINED OR REFINABLE                          CP81  76
#       1            CONSTRAINED                                        CP81  77
#       2            CONSTRAINED OR INVARIANT DEPENDING REF PARAM.      CP81  78
#       3            INVARIANT                                          CP81  79
#                                                                       CP81  80
#     AFTER ALL PROCESSING ONLY STATUS 1 AND STATUS 3 CAN SURVIVE       CP81  81
#                                                                       CP81  82
DO II=1,3#                             Loop x,y,z,u11,...u23            CP81  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP81  84
KK=(II-1)*3#                           Point to first row element       CP81  85
JREF=-1#                               Reset element pointer            CP81  86
LL=REFPNT(II);    DIAG=EQUPOS(LL)#     Point to diagonal element        CP81  87
DO JJ=1,3#                             Loop along row elements          CP81  88
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP81  89
NN=KK+JJ#                              Point to equpos elements         CP81  90
IF(NN==LL) NEXT#                       Skip diagonal elements           CP81  91
ifeq:(EQUPOS(NN),0.) NEXT#             Skip zero elements               CP81  92
JREF=JJ#                               Save element pointer             CP81  93
BREAK#                                 And cease and desist             CP81  94
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP81  95
#                                                                       CP81  96
IF(DIAG<(-small:) & JREF<0) STATUS(II)=3# Parameter invariant           CP81  97
#                                                                       CP81  98
ELSE IF(JREF<0) NEXT#                  Skip if no constraint            CP81  99
#                                                                       CP81 100
ELSE IF(DIAG<(-small:) & STATUS(II)<=1)# Reference parameter            CP81 101
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP81 102
STATUS(II)=2;  PARSCL(II)=2.#          Set constrained flags            CP81 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP81 104
#                                                                       CP81 105
ELSE IF(ABS(DIAG)<small: & STATUS(II)==1)# If diagonal at zero          CP81 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP81 107
I=KK+JREF#                             Make the reference indirect      CP81 108
IF(EQUPOS(I)<(-small:))PARSCL(II)=EQUPOS(I)# If element negative        CP81 109
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP81 110
ELSE IF(ABS(DIAG)<small: & STATUS(II)<1)# Diag element zero             CP81 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP81 112
I=KK+JREF#                             Point to ref element             CP81 113
STATUS(II)=1#                          Set as constrained               CP81 114
PARSCL(II)=EQUPOS(I)#                  Store scale factor               CP81 115
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP81 116
JREF=MAX0(JREF,1)#                     -1 means parameter 1             CP81 117
IF(II<=3) PARPNT(II)=JREF#             A positional parameter           CP81 118
ELSE      PARPNT(II)=JREF+3#           A thermal parameter              CP81 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP81 120
100 CONTINUE#                          Branchpoint                      CP81 121
#                                                                       CP81 122
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP81 123
#                                                                       CP81 124
#    PROCESS SITE WITH STATUS 2                                         CP81 125
#    --------------------------                                         CP81 126
#                                                                       CP81 127
DO II=1,3#                             Loop over x,y,z,u11,.....u23     CP81 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CP81 129
IF(STATUS(II)!=2) NEXT#                Skip unless status 2             CP81 130
JJ=PARPNT(II)#                         Pick up the reference param      CP81 131
IF(STATUS(JJ)==1)#                     If 1 param is doubly depende     CP81 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CP81 133
KK=PARPNT(JJ)#                         Point to ref parameter           CP81 134
STATUS(KK)=1#                          Set parameter constrained        CP81 135
PARSCL(KK)=2.0#                        Set dependency as 2.0            CP81 136
PARPNT(KK)=II#                         Point to current parameter       CP81 137
STATUS(II)=1#                          Set parameter as constrained     CP81 138
PARSCL(II)=1.0#                        Set dependency as 1.             CP81 139
PARSCL(JJ)=2.0#                        Set dependency as 2.             CP81 140
PARPNT(JJ)=II#                         Set pointer to current           CP81 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CP81 142
ELSE IF(STATUS(JJ)<1)#                 Test if refinable                CP81 143
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP81 144
STATUS(II)=1#                          Set as constrained               CP81 145
PARSCL(II)=1.0#                        Set dependency as 1.             CP81 146
STATUS(JJ)=1#                          Set parameter constrained        CP81 147
PARSCL(JJ)=2.0#                        Set dependency as 2.             CP81 148
PARPNT(JJ)=II#                         Point to current site            CP81 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP81 150
ELSE STATUS(II)=3#                     If the reference parameter       CP81 151
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CP81 152
#                                                                       CP81 153
#   RESOLVE PARAMETER DEPENDENCIES                                      CP81 154
#   ------------------------------                                      CP81 155
#                                                                       CP81 156
DO II=1,3#                             Loop over x,y,z                  CP81 157
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP81 158
KK=PARPNT(II)#                         Pick up reference parameter      CP81 159
ifeq:(ABS(PARSCL(II)),1.)#             Test for dependency of 1.        CP81 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP81 161
IF(STATUS(KK)>=1)#                     Test if the reference param      CP81 162
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP81 163
JJ=PARPNT(KK)#                         Point to dependent site          CP81 164
IF(STATUS(JJ)>=0 & STATUS(KK)<3)#      Test parameter status            CP81 165
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP81 166
STATUS(II)=-1#                         Refinable with sites depende     CP81 167
PARPNT(KK)=II#                         Store site address               CP81 168
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP81 169
ELSE IF(STATUS(JJ)<0)#                 If refinable site                CP81 170
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP81 171
PARPNT(II)=PARPNT(KK)#                 Replace site pointer             CP81 172
PARSCL(II)=PARSCL(II)*PARSCL(KK)#      Change site dependency           CP81 173
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP81 174
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP81 175
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP81 176
#                                                                       CP81 177
ELSE ifeq:(ABS(PARSCL(II)),2.)#        If dependence scale is 2.        CP81 178
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP81 179
ifeq:(ABS(PARSCL(KK)),2.)#             If dependency scale is 2.        CP81 180
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP81 181
STATUS(II)=3;  STATUS(KK)=3#           If so both are invariant         CP81 182
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP81 183
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP81 184
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP81 185
#                                                                       CP81 186
#    STORE CONSTRAINTS READY FOR LRCONS:                                CP81 187
#    -----------------------------------                                CP81 188
#                                                                       CP81 189
DO II=1,3#                             Loop over x,y,z,u11,...u23       CP81 190
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CP81 191
IF(STATUS(II)<1) NEXT#                 Test if param is special         CP81 192
IF(STATUS(II)==3) PARSCL(II)=0.0#      For fixed param scale is zero    CP81 193
FLG(II)=STATUS(II)#                    Store subject status flag        CP81 194
PAR(II)=PARPNT(II)#                    Store subject status flag        CP81 195
MULT(II)=PARSCL(II)#                   Store ref-sub param scale        CP81 196
JJ=PARPNT(II)#                         Get parameter pointer            CP81 197
CONST(II)=X(II)-PARSCL(II)*X(JJ)#      Q constant                       CP81 198
ZZZ=12.*CONST(II)#                     Convert fractions to integers    CP81 199
ifne:(ANINT(ZZZ),ZZZ,0.00005)#         If not a rational fraction       CP81 200
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CP81 201
ZZZ=(X(II)+PARSCL(II)*X(JJ))#          Get alternate q constant         CP81 202
ifeq:(ANINT(ZZZ*12.),ZZZ*12.,0.00005)# Test if alternate is ok          CP81 203
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CP81 204
CONST(II)=ZZZ#                         Store q constant                 CP81 205
MULT(II)=-MULT(II)#                    Store ref-sub param scale        CP81 206
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CP81 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CP81 208
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CP81 209
#                                                                       CP81 210
RETURN#                                                                 CP81 211
END#                                                                    CP81 212
systemheader:(CP82)#                   Biso site analysis               CP82   1
###################################################################     CP82   2
#                                                                  #    CP82   3
#                             CP82                                 #    CP82   4
#                                                                  #    CP82   5
###################################################################     CP82   6
SUBROUTINE CP82#                       Thermal motion analysis          CP82   7
include:(AACOMN)#                                                       CP82   8
include:(CPCOMN)#                                                       CP82   9
#                                                                       CP82  10
INTEGER I,L,M,PNT,PTZ#                                                  CP82  11
INTEGER BUCKET(40)#                    Count of refined b-values in r   CP82  12
INTEGER SMEAR(40)#                     Smear histogram values           CP82  13
REAL BMED,BPROM,BDEMO#                 B value critical points          CP82  14
INTEGER ZEROS,CNT,ZEROF,MEDPNT,MEDIAN#                                  CP82  15
INTEGER NEWZ#                                                           CP82  16
INTEGER NOGO#                                                           CP82  17
REAL BISO#                                                              CP82  18
REAL TSCAL#
chardata:(CP820," Analysing refined atomic temperature factors BISO")#  CP82  19
chardata:(CP82A," Temperature spectrum histogram B=0.0 0.5 ... 20.0")#  CP82  20
chardata:(CP82B," Temp-based atom-type promotions switched off.")#      CP82  21
chardata:(CP82C," marks: Promote P  Median M  Demote D  Reject R")#     CP82  22
chardata:(CP82D," Making atom-type adjustments.")#                      CP82  23
chardata:(CP82E,"PromotingDemoting Rejecting")#                         CP82  24
datastuff:#                                                             CP82  25
#                                                                       CP82  26
pt2:      writeline:(2,CP820,NCP820,3,3)# Header                        CP82  27
ELSE pt1: writeline:(0,CP820,NCP820,3,3)#                               CP82  28
BREJECT=0.0#                                                            CP82  29
DO I=1,40; BUCKET(I)=0#                Initialize                       CP82  30
TSCAL=TSPEC/20.#
#                                                                       CP82  31
#   CRUDE RANGE ANALYSIS OF REFINED B VALUES                            CP82  32
#   ----------------------------------------                            CP82  33
#                                                                       CP82  34
FOR(M=MARKN;M<STOPN;M=M+STEPN)#        Loop over atoms list             CP82  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP82  36
L=NINT(QX(M+1))#                       Extract sf sequence              CP82  37
IF(L<=0) NEXT#                         Not invoked site                 CP82  38
BISO=QX(M+6)#                          Get refined b value              CP82  39
I=MIN(40, NINT(BISO*TSCAL*2.0))#       Get apropriate b range i*0.5  
BUCKET(I)=BUCKET(I)+1#                 Increment count in range         CP82  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP82  42
SMEAR(1)=(BUCKET(1)+BUCKET(2))/2#      Smear first value                CP82  43
SMEAR(40)=(BUCKET(39)+BUCKET(40))/2#   Smear last value                 CP82  44
DO I=2,39#                             Smooth out the histogram value   CP82  45
SMEAR(I)=(BUCKET(I-1)+BUCKET(I)+BUCKET(I+1))/3#                         CP82  46
MEDIAN=0;MEDPNT=0#                     Find median value                CP82  47
DO I=1,20;IF(MEDIAN<SMEAR(I))#         Search buckets for median valu   CP82  48
$(MEDIAN=SMEAR(I);MEDPNT=I$)#          Save pointer to bucket           CP82  49
NOGO=no:#                                                               CP82  50
IF(MEDPNT==0) NOGO=yes:#               Found nothing                    CP82  51
ELSEIF(SMEAR(MEDPNT)==1)NOGO=yes:#     Found virtually nothing          CP82  52
IF(NOGO==yes:)#                        Use the original buckets         CP82  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP82  54
DO I=1,20;IF(MEDIAN<BUCKET(I))#        Forget the smeared version       CP82  55
$(MEDIAN=BUCKET(I);MEDPNT=I$)#         Try for a bucket pointer again   CP82  56
NOGO=no:#                                                               CP82  57
IF(MEDPNT==0) NOGO=yes:#               Found nothing                    CP82  58
ELSEIF(BUCKET(MEDPNT)==1)NOGO=yes:#    Found virtually nothing          CP82  59
IF(NOGO==yes:)MEDPNT=0#                Set to defaults                  CP82  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP82  61
#                                                                       CP82  62
#                                                                       CP82  63
IF(MEDPNT>0&MEDPNT<20)#                Realistic value b=0 to b=10      CP82  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP82  65
ZEROS=MEDPNT;ZEROF=ZEROS;CNT=0#        Initialize                       CP82  66
DO I=MEDPNT,40#                        Loop over histogram ranges       CP82  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP82  68
IF(SMEAR(I)==0)#                       Current is flat                  CP82  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP82  70
IF(SMEAR(ZEROS)!=0)ZEROS=I#            Set zero start point             CP82  71
ELSE CNT=CNT+1#                        Count flat range                 CP82  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP82  73
IF(SMEAR(ZEROS)==0)#                   If we are in a flat range        CP82  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP82  75
IF(SMEAR(I)!=0)#                       If current isn't flat            CP82  76
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CP82  77
IF(CNT<4)#                             Wasn't flat for long enough      CP82  78
$(ZEROS=I;CNT=0$)#                     Reset zero point                 CP82  79
ELSE $(ZEROF=I ; BREAK $)#             Got approximate rejection thre   CP82  80
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CP82  81
ELSE CNT=CNT+1#                        Increment                        CP82  82
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP82  83
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP82  84
IF(SMEAR(ZEROS)==0 &SMEAR(ZEROF)!=0) ZEROF=40# Set to end               CP82  85
IF(ZEROF-ZEROS>4)#                                                      CP82  86
BREJECT=FLOAT(ZEROS+1)*TSPEC/40.#      Set critical rejection thresho   CP82  87
BMED=FLOAT(MEDPNT)*TSPEC/40.#          Typical expected biso value      CP82  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP82  89
ELSE BMED=4.*TSCAL#                
IF(BREJECT>10.*TSCAL\BREJECT<=0.)BREJECT=2.*GBOVL# Typical reject value
BREJECT=MAX(BREJECT,10.*TSCAL)#           
#                                                                       CP82  93
# IDEALLY SHOULD JUST CURVE FIT A SKEW SYMMETRIC CURVE !!!!!!!!!!       CP82  94
#                                                                       CP82  95
BPROM=(BMED+0.)/2.#                    Promote to higher z type         CP82  96
BDEMO=(BREJECT+BMED)/2.0#              Demote to lower z type           CP82  97
BDEMO=MIN(BDEMO,BREJECT)#                                               CP82  98
#                                                                       CP82  99
#   LOOK FOR OUTLIERS                                                   CP82 100
#   -----------------                                                   CP82 101
#                                                                       CP82 102
#                                                                       CP82 103
#   PRINT OUT ADJUSTMENT CRITERIA                                       CP82 104
#   -----------------------------                                       CP82 105
#                                                                       CP82 106
pt3:#                                                                   CP82 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CP82 108
writeline:(1,CP82A,NCP82A,3,3)#        Temperature histogram            CP82 109
IF(ATPROM==no:) writeline:(0,CP82B,NCP82B,3,3)# No promotions           CP82 110
writeline:(0,CP82C,NCP82C,3,3)#        Marker meanings                  CP82 111
WRITE(6,'(40I2)')(BUCKET(I),I=1,40)#   Input values                     CP82 112
WRITE(6,'(40I2)')( SMEAR(I),I=1,40)#   Smeared values                   CP82 113
CHROT=' '#                             Blank out input string           CP82 114
PNT=MIN(MAX(1,NINT(BPROM  *4./TSCAL)),80);CHROT(PNT^PNT)='P'# Promote
PNT=MIN(MAX(1,NINT(BMED   *4./TSCAL)),80);CHROT(PNT^PNT)='M'# Median  
PNT=MIN(MAX(1,NINT(BDEMO  *4./TSCAL)),80);CHROT(PNT^PNT)='D'# Demote   
PNT=MIN(MAX(1,NINT(BREJECT*4./TSCAL)),80);CHROT(PNT^PNT)='R'# Reject    
writeline:(0,0,0,1,3)#                 Output marker line               CP82 119
writeline:(1,CP82D,NCP82D,3,3)#        Start adjusting                  CP82 120
WRITE(6,*) BPROM,BMED, BDEMO , BREJECT#                                 CP82 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CP82 122
#                                                                       CP82 123
#   MAKE THE BISO-BASED ATOM-TYPE ADJUSTMENTS                           CP82 124
#   -----------------------------------------                           CP82 125
#                                                                       CP82 126
FOR(M=MARKN;M<STOPN;M=M+STEPN)#        Loop over atoms list             CP82 127
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CP82 128
L=NINT(QX(M+1))#                       Extract sf sequence              CP82 129
IF(L<0) NEXT#                          Not invoked site                 CP82 130
DO PTZ=1,NATYP#                                                         CP82 131
IF(ATZORD(PTZ)==L)BREAK#                                                CP82 132
BISO=QX(M+6)#                          Get refined b value              CP82 133
IF(BISO>BPROM & BISO<BDEMO)NEXT#       Site seems to be ok currently    CP82 134
IF(BISO<BPROM)#                        Not enough electrons in type     CP82 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CP82 136
IF(ATPROM==no:)NEXT#                   Hold back on promoting just ye   CP82 137
IF(LOOP<NARANG& ATZ(L)<=ATZ(MAT(LOOP)))NEXT# Inhibit prem n/o/c upgra   CP82 138
IF(ATZDIF(PTZ)<0.5 &PTZ>1&PTZ<=NATYP)# Got a nearby z>zcur neighbour    CP82 139
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CP82 140
CHROT(2^10)=CP82E(1^9)#                Promoting                        CP82 141
movertoc:(QX(MARK2+(ATZORD(PTZ-1)-1)*ISCF+1),1,CHROT,32,ISCF,1)# New    CP82 142
CHROT(28^31)=' -> '#                   Becomes                          CP82 143
QX(M+1)=FLOAT(ATZORD(PTZ-1))#          Positive its a larger z atom t   CP82 144
QX(M+6)=-1.0#                          Reset the b value to boverall    CP82 145
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CP82 146
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CP82 147
ELSEIF(BISO>BREJECT)#                  Way too many electrons           CP82 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CP82 149
IF(ATZ(ATZORD(PTZ+1))<1.5 \$#          Regressed to h or nothing        CP82 150
       ATZORD(PTZ+1)<1\$#              I.e. =0 and off the list         CP82 151
       ATZORD(PTZ+1)>NATYP)#           B is too large but excluded      CP82 152
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CP82 153
CHROT(2^10)=CP82E(19^27)#              Rejecting                        CP82 154
QX(M+1)=-100.-ABS(QX(M+1))#            Disable site                     CP82 155
QX(M+6)=-1.0#                          Reset the b value to boverall    CP82 156
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CP82 157
ELSE#                                  Can try demoting                 CP82 158
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CP82 159
NEWZ=ANINT(MIN(ATZ(L)*EXP((-QX(M+6)+BOVL)*0.22),100000.))# Put on rig   CP82 160
IF(ABS(ATZ(L)-NEWZ)>ABS(NEWZ-ATZ(ATZORD(PTZ+1))))# Change or keep??     CP82 161
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CP82 162
CHROT(2^10)=CP82E(10^18)#              Demoting                         CP82 163
movertoc:(QX(MARK2+(ATZORD(PTZ+1)-1)*ISCF+1),1,CHROT,32,ISCF,1)# New    CP82 164
CHROT(28^31)=' -> '#                   Becomes                          CP82 165
QX(M+1)=FLOAT(ATZORD(PTZ+1))#          Smaller z atom type              CP82 166
QX(M+6)=-1.0#                          Reset the b value to boverall    CP82 167
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CP82 168
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CP82 169
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CP82 170
ELSE#                                  Demote. too few e- for current   CP82 171
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CP82 172
IF(LOOP<NARANG& ATZ(L) <=ATZ(MAT(LOOP)))NEXT# Exclude z>c downgrades    CP82 173
IF(ATZORD(PTZ+1)<1\ATZORD(PTZ+1)>NATYP)NEXT# Out of limits              CP82 174
IF(ATZ(ATZORD(PTZ+1))<1.5)NEXT#        Skip hydrogens                   CP82 175
CHROT(2^10)=CP82E(10^18)#              Demoting                         CP82 176
movertoc:(QX(MARK2+(ATZORD(PTZ+1)-1)*ISCF+1),1,CHROT,32,ISCF,1)# New    CP82 177
CHROT(28^31)=' -> '#                   Becomes                          CP82 178
QX(M+1)=FLOAT(ATZORD(PTZ+1))#          Larger z atom type               CP82 179
QX(M+6)=-1.0#                          Reset the b value to boverall    CP82 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CP82 181
movertoc:(QX(MARK2+(L-1)*ISCF+1),1,CHROT,12,ISCF,1)# Site type          CP82 182
ncodefld:(FLOAT((M-MARKN)/STEPN+1),1,CHROT, 180513.,1)# Number          CP82 183
ncodefld:(BISO,1,CHROT, 270742.,1)#    Temperature factor               CP82 184
pt4: writeline:(0,0,0,1,3)#            Output chrot                     CP82 185
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CP82 186
#                                                                       CP82 187
RETURN#                                                                 CP82 188
END#                                                                    CP82 189
systemheader:(CP83)#                   Use markn to update  marka       CP83   1
###################################################################     CP83   2
#                                                                  #    CP83   3
#                             CP83                                 #    CP83   4
#                                                                  #    CP83   5
###################################################################     CP83   6
SUBROUTINE CP83#                                                        CP83   7
include:(AACOMN)#                                                       CP83   8
include:(CPCOMN)#                                                       CP83   9
INTEGER JP,KP#                                                          CP83  10
#                                                                       CP83  11
#    SAVE CURRENT SOLUTION IN MARKA                                     CP83  12
#    ------------------------------                                     CP83  13
#                                                                       CP83  14
JP=MARKN#                                                               CP83  15
FOR(KP=MARKA;KP<STPMRK;KP=KP+STEPA)#   Loop over sorted list            CP83  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP83  17
IF(QX(JP+6 )>BREJECT)#                 Very large vibration             CP83  18
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP83  19
peakt:=-100.-ABS(peakt:)#              Disable site forever             CP83  20
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP83  21
ELSE#                                                                   CP83  22
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP83  23
peakt:=QX(JP+1)#                       Get new peak type !!!!!!edit     CP83  24
peakx:=QX(JP+2)#                       Get x coordinate                 CP83  25
peaky:=QX(JP+3)#                       Get y coordinate                 CP83  26
peakz:=QX(JP+4)#                       Get z coordinate                 CP83  27
atomb:=QX(JP+6)#                       Save biso                        CP83  28
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP83  29
JP=JP+STEPN#                                                            CP83  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP83  31
RETURN#                                                                 CP83  32
END#                                                                    CP83  33
systemheader:(CP84)#                   Use markn to update  marka       CP84   1
###################################################################     CP84   2
#                                                                  #    CP84   3
#                             CP84                                 #    CP84   4
#                                                                  #    CP84   5
###################################################################     CP84   6
SUBROUTINE CP84(MOREPK)#                                                CP84   7
include:(AACOMN)#                                                       CP84   8
include:(CPCOMN)#                                                       CP84   9
INTEGER MOREPK#                                                         CP84  10
REAL  ADDED,CURRNT,TOTAL,EXPCTD#                                        CP84  11
INTEGER MMARK#                                                          CP84  12
INTEGER KP#                                                             CP84  13
INTEGER OK#                                                             CP84  14
chardata:(CP84A," ADDING EXTRA SITES ")#                                CP84  15
datastuff:#                                                             CP84  16
#                                                                       CP84  17
#                                                                       CP84  18
#                                                                       CP84  19
#                                                                       CP84  20
ADDED=0.#                                                               CP84  21
TOTAL=0.#                                                               CP84  22
CURRNT=0.#                                                              CP84  23
EXPCTD=ATEX/MOLZ*NSYM#                 Maxpeak is at/asym unit          CP84  24
FOR(KP=MARKA;KP<STPMRK;KP=KP+STEPA)#   Pointer to peak site array       CP84  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP84  26
TOTAL=TOTAL+peakm:*FLOAT(NSYM)#        Accumulate total sites           CP84  27
IF(peakt:< 0.5)NEXT#                   Site already invoked -or rejec   CP84  28
CURRNT=CURRNT+peakm:*FLOAT(NSYM)#      Accumulate current sites         CP84  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP84  30
#                                                                       CP84  31
#                                                                       CP84  32
#                                                                       CP84  33
#                                                                       CP84  34
IF(LEVEL>2\CURRNT<EXPCTD)#                                              CP84  35
IF(CURRNT<TOTAL)#                                                       CP84  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP84  37
pt1: writeline:(2,CP84A,NCP84A,3,3)#   Write out the header             CP84  38
FOR(KP=ASSMRK;KP<STPMRK;KP=KP+STEPA)#  Pointer to peak site array       CP84  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP84  40
IF(peakt:>-0.5)NEXT#                   Site already invoked             CP84  41
IF(peakt:<-100.)NEXT#                  Site already excluded            CP84  42
CALL CP77(KP,OK)#                      Test distance to included site   CP84  43
IF(OK==no:) NEXT#                      Too close to valid               CP84  44
MMARK=MARKN+(KP-MARKA)/STEPA*STEPN#    Pointer to sym related array     CP84  45
ADDED=ADDED+peakm:*FLOAT(NSYM)#        Accumulate sym related sites     CP84  46
pt4: WRITE(6,*) "Adding site ",(KP-MARKA)/STEPA+1#                      CP84  47
peakt:=ABS(peakt:)#                    Flag as a site to be used        CP84  48
QX(MMARK+1)=ABS(QX(MMARK+1))#          Flag as a site to be used        CP84  49
IF(CURRNT+ADDED>1.25*CURRNT &#         Increase sites by factor 1.2     CP84  50
CURRNT+ADDED<.90*TOTAL)BREAK#          But continue if almost at end    CP84  51
IF(LEVEL<=2&CURRNT>=EXPCTD)BREAK#      Only add the expected sites      CP84  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP84  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP84  54
#                                                                       CP84  55
IF(ADDED<=0.1)MOREPK=no:#                                               CP84  56
ELSE         MOREPK=yes:#                                               CP84  57
#                                                                       CP84  58
RETURN#                                                                 CP84  59
END#                                                                    CP84  60
systemheader:(CP85)#                   Invert matrix                    CP85   1
###################################################################     CP85   2
#                                                                  #    CP85   3
#                             CP85     INVERT4X4:                  #    CP85   4
#                                                                  #    CP85   5
###################################################################     CP85   6
SUBROUTINE CP85(MDVECT,MDMATX,SIGMA,INVERT)#                            CP85   7
include:(AACOMN)#                                                       CP85   8
include:(CPCOMN)#                                                       CP85   9
#                                                                       CP85  10
INTEGER J,K,P#          ## Indices                                      CP85  11
INTEGER LLM,LLMK,LLMP#  ## Pointers in matrix                           CP85  12
REAL    Q#              ## Multiplier                                   CP85  13
INTEGER MDMATX, MDVECT#                                                 CP85  14
INTEGER INVERT#                                                         CP85  15
REAL   SIGMA(4),TEMP(4)#                                                CP85  16
REAL   GOF#                                                             CP85  17
intdata:(VARTOT,4)#                                                     CP85  18
datastuff:#                                                             CP85  19
#                                                                       CP85  20
#       MATRIX INVERSION                                                CP85  21
#       ----------------                                                CP85  22
#                                                                       CP85  23
LLMK=MDMATX#                           Point to start of matrix         CP85  24
DO K=1,VARTOT#                         Loop over b,x,y,z                CP85  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP85  26
LLMP=MDMATX#                           Point to start of matrix         CP85  27
FOR(P=1;P<K;P=P+1)#                    Loop over 1 row                  CP85  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CP85  29
Q=QX(LLMP+K)*QX(LLMP+P)#               Matrix element                   CP85  30
DO J=K,VARTOT#                                                          CP85  31
QX(LLMK+J)=QX(LLMK+J)-Q*QX(LLMP+J)#    Matrix                           CP85  32
QX(MDVECT+K)=QX(MDVECT+K)-Q*QX(MDVECT+P)# Vector                        CP85  33
LLMP=LLMP+VARTOT-P#                                                     CP85  34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CP85  35
ifne:(QX(LLMK+K),0.) QX(LLMK+K)=1./QX(LLMK+K)#                          CP85  36
LLMK=LLMK+VARTOT-K#                                                     CP85  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP85  38
#                                                                       CP85  39
LLM=LLMK#                                                               CP85  40
FOR(K=VARTOT;K>=1;K=K-1)#                                               CP85  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CP85  42
QX(MDVECT+K)=QX(MDVECT+K)*QX(LLMK+K)#                                   CP85  43
LLMP=LLM#                                                               CP85  44
FOR(P=VARTOT;P>K;P=P-1)#                                                CP85  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP85  46
TEMP(P)=QX(LLMK+K)*QX(LLMK+P)#                                          CP85  47
QX(MDVECT+K)=QX(MDVECT+K)-TEMP(P)*QX(MDVECT+P)#                         CP85  48
IF(INVERT==no:)NEXT#                   Not inverting                    CP85  49
#                                                                       CP85  50
#  TO INVERT THE MATRIX                                                 CP85  51
#  --------------------                                                 CP85  52
#                                                                       CP85  53
QX(LLMK+P)=-TEMP(P)*QX(LLMP+P)#                                         CP85  54
FOR(J=P+1;J<=VARTOT;J=J+1)#                                             CP85  55
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP85  56
QX(LLMK+P)=QX(LLMK+P)-TEMP(J)*QX(LLMP+J)#                               CP85  57
QX(LLMK+J)=QX(LLMK+J)-TEMP(P)*QX(LLMP+J)#                               CP85  58
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP85  59
LLMP=LLMP-VARTOT+P-1#                                                   CP85  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP85  61
#                                                                       CP85  62
IF(INVERT==yes:)#                      Invert diag. el. last cycle      CP85  63
FOR(J=K+1;J<=VARTOT;J=J+1)#                                             CP85  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP85  65
QX(LLMK+K)=QX(LLMK+K)-TEMP(J)*QX(LLMK+J)#                               CP85  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP85  67
LLMK=LLMK-VARTOT+K-1#                                                   CP85  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CP85  69
#                                                                       CP85  70
#    CALCULATE ST.DEV. AND MOVE INTO MDTEMP-ARRAY                       CP85  71
#    --------------------------------------------                       CP85  72
#                                                                       CP85  73
GOF=1.0#                               Fudgeit                          CP85  74
LLM=MDMATX#                            Point to start of matrix         CP85  75
DO K=1,VARTOT#                         Loop over variables              CP85  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP85  77
SIGMA(K)=SQRT(ABS(QX(LLM+K)))*GOF#     Sqrt(absval*sum(w*dsq)/(n-m))    CP85  78
LLM=LLM+VARTOT-K#                                                       CP85  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP85  80
#                                                                       CP85  81
RETURN#                                                                 CP85  82
END#                                                                    CP85  83
systemheader:(CP86)#                   Sort marka array                 CP86   1
###################################################################     CP86   2
#                                                                  #    CP86   3
#                             CP86                                 #    CP86   4
#                                                                  #    CP86   5
###################################################################     CP86   6
SUBROUTINE CP86#                                                        CP86   7
#                                                                       CP86   8
RETURN#                                                                 CP86   9
END#                                                                    CP86  10
systemheader:(JUNK)#                                                    JUNK   1
#                                                                       JUNK   2
#                                                                       JUNK   3
#                                                                       JUNK   4
#                                                                       JUNK   5
#                                                                       JUNK   6
#                                                                       JUNK   7
#                                                                       JUNK   8
#                                                                       JUNK   9
#  DO NEW PHASE CHECK  AND ANNEALING HERE   ????                        JUNK  10
#                                                                       JUNK  11
#                                                                       JUNK  12
#                                                                       JUNK  13
#                                                                       JUNK  14
#                                                                       JUNK  15
#                                                                       JUNK  16
#                                                                       JUNK  17
#                                                                       JUNK  18
#                                                                       JUNK  19
#                                                                       JUNK  20
systemheader:(CP97)#                   Write pig solution file          CP97   1
###################################################################     CP97   2
#                                                                  #    CP97   3
#                             CP97     (FORMERLY PP05)             #    CP97   4
#                                                                  #    CP97   5
###################################################################     CP97   6
SUBROUTINE CP97(JJJ,TRIAL,PSPITR,MAXTRY,PCPS,STAGE)#                    CP97   7
include:(AACOMN)#                                                       CP97   8
include:(CPCOMN)#                                                       CP97   9
#                                                                       CP97  10
INTEGER PCPS,STAGE,JJJ,TRIAL,PSPITR,MAXTRY#                             CP97  11
INTEGER K,N#                                                            CP97  12
INTEGER KP#                                                             CP97  13
INTEGER MK,SO,SE#                                                       CP97  14
INTEGER NSITES#                                                         CP97  15
REAL SEQU#                                                              CP97  16
REAL NAT#                                                               CP97  17
REAL FMT#                                                               CP97  18
string:(FF,60)#                                                         CP97  19
LOGICAL TEST#                                                           CP97  20
string:(FN,60)#                                                         CP97  21
string:(STRG,80)#                                                       CP97  22
chardata:(LIN0,' 3. Final solution statistics-')#                       CP97  23
chardata:(LIN1,' Solution xxxxx of xxxxx       Optimisation x')#        CP97  24
chardata:(LIN2,' DM FOM= x.xxx for phase set xxxxx of yMXPS')#          CP97  25
chardata:(LIN3,'   Fc R= x.xxx (from yyyyyy reflns.) ')#                CP97  26
chardata:(LINA,$#                                                       CP97  27
' Solution   Phase set    FOM    R-factor   sites   peaks')#            CP97  28
realdata:(FOM,[842.,842.,842.,832.])#                                   CP97  29
realdata:(FMT0,[80613.,200613.,280642.,380642.,480613.,560613.])#       CP97  30
datastuff:#                                                             CP97  31
#                                                                       CP97  32
#  DUMP FINAL SOLUTION RESULTS                                          CP97  33
#  ---------------------------                                          CP97  34
#                                                                       CP97  35
CHROT=' ';STRG=' '#                    Erase the string                 CP97  36
IF(DAREC==0\DMP>0)#                    Only first time/or every time    CP97  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CP97  38
movechar:(LIN0,NLIN0,CHROT,2,NLIN0-2,1)# Underline header               CP97  39
pt0: writeline:(1,LIN0,NLIN0-1,2,3)#   Print  stage 2 - peak search     CP97  40
pt0: writeline:(0,LINA,NLINA,3,3)#     Print  list header               CP97  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CP97  42
BUFOT(1)=FLOAT(JJJ)#                   Listed number                    CP97  43
BUFOT(2)=FLOAT(PSPITR*(TRIAL-1))+PSFOM(3,PCPS)# True sequence number    CP97  44
BUFOT(3)=PSFOM(1,PCPS)#                Figure of merit                  CP97  45
BUFOT(4)=FRMIN#                                                         CP97  46
BUFOT(5)=0.#                                                            CP97  47
BUFOT(6)=0.#                                                            CP97  48
ncodefld:(BUFOT,1,STRG,FMT0,6)#        Encode the  values               CP97  49
#                                                                       CP97  50
#                                                                       CP97  51
IF(STAGE==2)$(MK=MARK8;SO=STOP8;SE=STEP8$)# Previous saved sites        CP97  52
ELSE        $(MK=MARKA;SO=STOPA;SE=STEPA$)# Current solution            CP97  53
IF(MK==SO) GOTO 100#                   No sites to dump                 CP97  54
#                                                                       CP97  55
IF(DAREC==0)#                                                           CP97  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CP97  57
DO K=6,1,-1; IF(COMPID(K^K)!=' ') BREAK# Find 1st non-blank of compid   CP97  58
FF=filename:(COMPID(1^K),FILEXT(ioda1:))# Construct the filename        CP97  59
DO K=60,1,-1; IF(FF(K^K)!=' ') BREAK#  Find last non-blank character    CP97  60
ifsel:(IBM,SIE)#                                                        CP97  61
upcase:(FF,FN,K)#                      Ebcdic  to upper case            CP97  62
ifsel:#                                                                 CP97  63
locase:(FF,FN,K)#                      Ascii   to lower case            CP97  64
endsel:#                                                                CP97  65
INQUIRE(FILE=FN,EXIST=TEST)#           Inquire if named file exists     CP97  66
IF(TEST)#                                                               CP97  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CP97  68
OPEN(UNIT=ioda1:,FILE=FN,STATUS='OLD')# Open the old file               CP97  69
CLOSE(ioda1:,STATUS='DELETE')#         Close and delete it              CP97  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CP97  71
opendac:(ioda1:,1,80,' ')#                                              CP97  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CP97  73
CHROT=LIN1#                                                             CP97  74
ncodefld:(FLOAT(JJJ)   ,1,CHROT,150513.,1)# Encode phase set studied    CP97  75
ncodefld:(FLOAT(MXPHST),1,CHROT,240613.,1)# Encode max to be studied    CP97  76
IF(MAXTRY>1)#                          Number of trials                 CP97  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CP97  78
CHROT(25^25)='/'#                      Max solutions for trial          CP97  79
ncodefld:(FLOAT(TRIAL) ,1,CHROT,300513.,1)# Encode trial/batch number   CP97  80
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CP97  81
ncodefld:(FLOAT(LEVEL) ,1,CHROT,450113.,1)# Encode study level          CP97  82
writedac:(ioda1:,['(a80)',],DAREC+1,[CHROT(1^80)])#                     CP97  83
CHROT=LIN2#                                                             CP97  84
ncodefld:(PSFOM(1,PCPS),1,CHROT,140632.,1)# Encode fig of merit         CP97  85
SEQU=FLOAT(PSPITR*(TRIAL-1))+PSFOM(3,PCPS)# True sequence number        CP97  86
ncodefld:(SEQU,1,CHROT,340613.,1)#     Encode phase set number          CP97  87
ncodefld:(FLOAT(MXPS),1,CHROT,430613.,1)# Encode phase set number       CP97  88
writedac:(ioda1:,['(a80)',],DAREC+2,[CHROT(1^80)])#                     CP97  89
CHROT=LIN3#                                                             CP97  90
ncodefld:(FRMIN,       1,CHROT,140632.,1)# Rfactor                      CP97  91
ncodefld:(REFREL,      1,CHROT,270713.,1)# How many refined refs        CP97  92
writedac:(ioda1:,['(a80)',],DAREC+3,[CHROT(1^80)])#                     CP97  93
DAREC=DAREC+3#                                                          CP97  94
#                                                                       CP97  95
#                                                                       CP97  96
#    OUTPUT THE ATOM SITES TO DAC FILE                                  CP97  97
#    ---------------------------------                                  CP97  98
#                                                                       CP97  99
N=0;K=0#                                                                CP97 100
NSITES =MIN(NPEAKS,NPTS)#              Nothing like duplication!        CP97 101
FOR(KP=MK;KP<SO;KP=KP+SE)#             Loop over atom list              CP97 102
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CP97 103
N=N+1#                                                                  CP97 104
NAT=NINT(peakt:)#                      Get atom type                    CP97 105
IF(NAT<=0) NEXT#                       Skip nonassigned peaks           CP97 106
K=K+1#                                 Count assigned types             CP97 107
CHROT=' '#                                                              CP97 108
movertoc:(QX(MARK2+(NAT-1)*ISCF+1),1,CHROT,1,ISCF,1)#                   CP97 109
FMT=1.+AINT(LOG10(MAX(1.,FLOAT(N))))#  Truncate number of digits        CP97 110
FMT=10003.+FMT*10110.#                 Calculate and offset format      CP97 111
IF(CHROT(2^2)!=' ')FMT=FMT+10000.#     A 2 char atom type               CP97 112
ncodefld:(FLOAT(N),1,CHROT,FMT,1)#     Insert atom number               CP97 113
LCHROT=9#                              Set format pointer               CP97 114
ncodefld:(QX,KP+1,CHROT,FOM,4)#        Get x,y,z and peak height        CP97 115
DAREC=DAREC+1#                                                          CP97 116
writedac:(ioda1:,['(a80)',],DAREC,[CHROT(1^80)])#                       CP97 117
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CP97 118
BUFOT(5)=FLOAT(K)#                                                      CP97 119
#                                                                       CP97 120
#    OUTPUT PEAK SITES TO DAC FILE                                      CP97 121
#    ---------------------------------                                  CP97 122
#                                                                       CP97 123
N=0;K=0#                                                                CP97 124
FOR(KP=MARKA;KP<STOPA;KP=KP+STEPA)#    Loop over peak list              CP97 125
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CP97 126
N=N+1#                                                                  CP97 127
NAT=NINT(peakt:)#                      Get atom type                    CP97 128
IF(NAT>0) NEXT#                        Skip nonassigned peaks           CP97 129
K=K+1#                                                                  CP97 130
CHROT='Pk  '#                                                           CP97 131
FMT=1.+AINT(LOG10(MAX(1.,FLOAT(N))))#  Truncate number of digits        CP97 132
FMT=10003.+FMT*10110.#                 Calculate and offset format      CP97 133
IF(CHROT(2^2)!=' ')FMT=FMT+10000.#     A 2 char atom type               CP97 134
ncodefld:(FLOAT(N),1,CHROT,FMT,1)#     Insert atom number               CP97 135
LCHROT=9#                              Set format pointer               CP97 136
ncodefld:(QX,KP+1,CHROT,FOM,4)#        Get x,y,z and peak height        CP97 137
DAREC=DAREC+1#                                                          CP97 138
writedac:(ioda1:,['(a80)',],DAREC,[CHROT(1^80)])#                       CP97 139
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CP97 140
BUFOT(6)=FLOAT(K)#                                                      CP97 141
ncodefld:(BUFOT,5,STRG,FMT0(5),2)#     Encode the  values               CP97 142
#                                                                       CP97 143
100 CONTINUE#                          Branch point                     CP97 144
CHROT=STRG#                            Copy details                     CP97 145
pt0: writeline:(0,STRG,80,3,3)#        Report                           CP97 146
CHROT=' '#                             Reset                            CP97 147
#                                                                       CP97 148
RETURN#                                                                 CP97 149
END#                                                                    CP97 150
pmacro:([no:])#                        Purge xtal system macros         CP97 151
