systemheader:(DD    )#                                                  DD     1
####################################################################### DD     2
##      Copyright (C) 2000, The Xtal System, The University of        # DD     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # DD     4
## Distributed under the GNU General Public Licence as published by   # DD     5
## the Free Software Foundation, in the hope that it will be useful   # DD     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # DD     7
## for more details.                                                  # DD     8
##                                                                    # DD     9
##                          *** DIFDAT ***                            # DD    10
##                                                                    # DD    11
##   DIFDAT processes raw diffractometer data and produces scaled     # DD    12
##   intensities and sigma intensities. Standard formats (CAD4 and    # DD    13
##   Nicolet) and non-standard formats may be read.                   # DD    14
##                                                                    # DD    15
####################################################################### DD    16
#                                                                       DD    17
include:(XMACRO)#                                                       DD    18
#                                                                       DD    19
macro:(mxwd40c:,incr:(arith:(39,/,mxchwd:)))#                           DD    20
macro:(smax:,10)#                      Maximum number of standards      DD    21
#                                                                       DD    22
extrude:(DDCOMN)#                                                       DD    23
INTEGER TCODE#       ## 0=lines 1=tape 2=cad 3=nic(vax)                 DD    24
#                    ## 4=nic(DG) 5=tsu 6=rd5 7=bdf 8=uwa p3  9=dct     DD    25
INTEGER ENDTAP#                        Signal end of diff. tape         DD    26
INTEGER READNT#                        Number of records read           DD    27
INTEGER READFR#                        Record to be read from           DD    28
INTEGER READTO#                        Record to be read to             DD    29
INTEGER IOFFCH#                        Offset for special chr code      DD    30
INTEGER TOTCHR#                        Total characters in 'list'       DD    31
INTEGER IRECOR#                        Count of records from tape       DD    32
INTEGER PARITY#                        Parity of tape 2/1 even/odd      DD    33
INTEGER NWORDS#                        Wrds on computer/tape rec        DD    34
INTEGER DENSIT#                        Tape density as 200;556;etc.     DD    35
INTEGER RCOVR#                         Tape recovery signal             DD    36
INTEGER NBITCH#                        No. bits/char on tape            DD    37
INTEGER EOF#                           Eof code                         DD    38
INTEGER IP#                            Packet address                   DD    39
INTEGER ISC#                           Count of standard refs           DD    40
INTEGER ITM#                           Flag to apply transf hkl         DD    41
INTEGER USESTD#                        Count of valid stds              DD    42
INTEGER FIRSTD#                        No. of first standard            DD    43
INTEGER INFILE#                        Signal to read input file c      DD    44
INTEGER MARKCB#                        Circular buffer for TSU
INTEGER STOPCB#                        End Circular buffer for TSU
INTEGER MARKS#                         Region for standard storage      DD    45
INTEGER STOPS#                         End of standards storage         DD    46
INTEGER STEPS#                         Items per measured standard      DD    47
INTEGER MARKR#                         Region for rescale factors       DD    48
INTEGER STOPR#                         End of standards rescales        DD    49
INTEGER STEPR#                         Items per rescale factor         DD    50
INTEGER IHH(3,smax:+1)#                H,k,l values of standards        DD    51
INTEGER IHS(3,smax:)#                  H,k,l of user spec. stds.        DD    52
INTEGER IREJCT(smax:)#                 Rejection flags for stds         DD    53
INTEGER ISERMX#                        Maximum external serial no.      DD    54
INTEGER NGRPS#                         Number of std scale groups       DD    55
INTEGER NTABS#                         No. of discontinuities in da     DD    56
INTEGER NTAB(50)#                      Table of discont. groups         DD    57
INTEGER ISMTH#                         No. of smoothing points          DD    58
INTEGER IOFF(30)#                      Reflection record offsets        DD    59
INTEGER IWANT(30)#                     Wanted items from lrrefl:        DD    60
INTEGER CAE(4)#                        Indexpkt: keys                   DD    61
INTEGER MAXCB#                         Size of TSU circular buffer
INTEGER NCCS#                          Total characters in ref flag     DD    62
INTEGER NCCR(11)#                      Type #'s for ref flags           DD    63
INTEGER NH#                            H field                          DD    64
INTEGER NK#                            K field                          DD    65
INTEGER NL#                            L field                          DD    66
INTEGER NS#                            Signal field                     DD    67
INTEGER NSCT#                          Pointer to scan time in inpu     DD    68
INTEGER NSCC#                          Pointer to scan counts in in     DD    69
INTEGER NRFN#                          Pointer to reflection seq no     DD    70
INTEGER NBG1#                          Pointer to background 1 coun     DD    71
INTEGER NBG2#                          Pointer to background 2 coun     DD    72
INTEGER NATN#                          Pointer to attenuator used f     DD    73
INTEGER NFO#                           Pointer to f relative            DD    74
INTEGER NFSQ#                          Pointer to f(rel)**2             DD    75
INTEGER NIRL#                          Pointer to i relative            DD    76
INTEGER NSFO#                          Pointer to sigma(f rel)          DD    77
INTEGER NSFS#                          Pointer to sigma(f(rel)**2)      DD    78
INTEGER NSIR#                          Pointer to sigma(i)              DD    79
INTEGER NTTH#                          Pointer to twotheta              DD    80
INTEGER NOMG#                          Pointer to omega                 DD    81
INTEGER NCHI#                          Pointer to chi                   DD    82
INTEGER NPHI#                          Pointer to phi                   DD    83
INTEGER NPSI#                          Pointer to psi                   DD    84
INTEGER NPBD#                          Pointer to bgd time/peak time    DD    85
INTEGER NBGT#                          Pointer to bgd time              DD    86
INTEGER NCP1,NCP2,NCP3,NCD1,NCD2,NCD3# Pointer to dir cos               DD    87
INTEGER NMON                           Pointer to monitor variability
INTEGER INTEST(30)#                    Array for nh, nk, nl etc.        DD    88
INTEGER NUMATT#                        Number of attenuator factors     DD    89
INTEGER NREF#                          Number of reflections            DD    90
INTEGER SUBTHR#                        Store thresh i rcod=2            DD    91
INTEGER USTCNT#                        Count of user spec. stds.        DD    92
REAL    BALAN#                         Test factor for bgnd balance     DD    93
REAL    DAMPPL#                        Damping stds plots               DD    94
REAL    SLOPE(4)#                      Slopes of instability            DD    95
REAL    INTERC(4)#                     Intercepts of instability        DD    96
REAL    THRESH#                        Sigmas to set observability      DD    97
REAL    THRCUL#                        Tsu file culling threshold
REAL    CNTTIM#                        Tsu file counting time fudge
REAL    ATTENU(10)#                    Attenuator factors none - 9      DD    98
INTEGER IPRINT#                        Printed output flag              DD    99
INTEGER IANG#                          Angle storage flag               DD   100
INTEGER IEUL#                          Store eulerian angle data        DD   101
INTEGER LISRAW#                        Signal o/p of raw tape           DD   102
INTEGER ICOPB#                         Copy refs from lrrefl: and a     DD   103
INTEGER IAPPLY#                        Scale apllication flag           DD   104
INTEGER IXSTD#                         Exclude standards from outpu     DD   105
INTEGER INSTAB#                        Set application of instabili     DD   106
INTEGER ICOS#                          Direction cosines on bdf         DD   107
INTEGER IPSI#                          Psi angle on bdf                 DD   108
INTEGER ISEQ#                          save sequence num on bdf
INTEGER IMONV#                         save monitor variability
INTEGER PSIZ#                          Packet size for lrrefl:          DD   109
INTEGER IRAW#                          Instab using raw counts          DD   110
INTEGER MISGUIDED#                     Requested raw counts, but can'   DD   111
REAL    BGTIME#                        Time for counting background     DD   112
REAL    TIMMIN#                        Min allowed scan time            DD   113
REAL    RELERR#                        Ave rel error in observtns       DD   114
REAL    SIGMPI#                        Sigma enlargement factor         DD   115
REAL    TM(9)#                         Hkl transformation matrix        DD   116
REAL    DEDTM#                         Deadtime corrrection factor      DD   117
INTEGER SCSTD#                         Instab from scaled stds (y/n)    DD   118
REAL    WAVE#                          Radiation wavelength             DD   119
REAL    IUB(9)#                        Inverse orientation matrix       DD   120
#                                                                       DD   121
string:(CNTRLS,66)#                    Reflection type codes            DD   122
string:(FILNAM,256)#                   alternative reflection file name 
#                                                                       DD   123
COMMON/COMIDD/EOF,INFILE,IP,NH,NK,NL,NS,TCODE,IAPPLY,#                  DD   124
IPRINT,IXSTD,ICOPB,NSCT,NSCC,NBG1,NBG2,NATN,PSIZ,NRFN,NUMATT,NREF,#     DD   125
IREJCT,IHH,IHS,IOFF,IWANT,CAE,MARKS,STOPS,STEPS,ISC,#                   DD   126
MARKR,STOPR,STEPR,NCCR,NCCS,ISERMX,NGRPS,INTEST,#                       DD   127
ISMTH,NTAB,NTABS,USESTD,FIRSTD,INSTAB,SUBTHR,#                          DD   128
ENDTAP,IOFFCH,IRECOR,PARITY,NWORDS,DENSIT,RCOVR,NBITCH,TOTCHR,#         DD   129
READNT,READFR,READTO,LISRAW,USTCNT,#                                    DD   130
NFO,NFSQ,NIRL,NSFO,NSFS,NSIR,ITM, MISGUIDED,#                           DD   131
NCP1,NCP2,NCP3,NCD1,NCD2,NCD3,ICOS,IPSI,MARKCB,STOPCB,MAXCB,#   
NTTH,NOMG,NCHI,NPHI,NPSI,NPBD,IANG,IRAW,IEUL,SCSTD,NBGT,#
ISEQ,IMONV,NMON#
#                                                                       DD   134
COMMON/COMCDD/CNTRLS,FILNAM#            
#                                                                       DD   136
COMMON/COMFDD/ATTENU,BGTIME,BALAN,THRESH,DAMPPL,INTERC,SLOPE,#          DD   137
TIMMIN,RELERR,SIGMPI,TM,DEDTM,WAVE,IUB,THRCUL,CNTTIM#
endext:#                                                                DD   139
#                                                                       DD   140
systemheader:(DD00)#                                                    DD00   1
#*********************************************************************# DD00   2
#                                                                     # DD00   3
#                                DD00                                 # DD00   4
#                                                                     # DD00   5
#*********************************************************************# DD00   6
SUBROUTINE DD00#                       J.m. stewart apr 1983            DD00   7
include:(AACOMN)#                      N spadaccini may 1989 apr 1990   DD00   8
include:(DDCOMN)#                                                       DD00   9
#                                                                       DD00  10
FILEXT(IOUNIT(3))='XX1'#               Extension for scratch file       DD00  11
FILEXT(IOUNIT(4))='DIF'#               Extension for diff file          DD00  12
#                                                                       DD00  13
#                                                                       DD00  14
CALL DD10#                             Process the difdat line          DD00  15
CALL DD20#                             Read control cards               DD00  16
CALL DD30#                             Read data from raw tape          DD00  17
CALL DD40#                             Plot standards                   DD00  18
CALL DD50#                             Find scales from stds            DD00  19
CALL DD60#                             Find smoothed in scales          DD00  20
IF(SCSTD==yes:)#                       Instab. from scaled stds         DD00  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD00  22
CALL DD90#                             Scale the standards first        DD00  23
IF(ISC>0)             CALL DD70#       Find instability factors         DD00  24
CALL DD80#                             Apply scale factors to reflx     DD00  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD00  26
ELSE#                                  Instab. from unscaled stds       DD00  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD00  28
IF(ISC>0)             CALL DD70#       Find instability factors         DD00  29
CALL DD80#                             Apply scale factors to reflx     DD00  30
IF(IAPPLY==yes:) CALL DD90#            Scale the standards after        DD00  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD00  32
IF(USESTD>0)#                          If there are standards           DD00  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DD00  34
IF(IAPPLY==yes:) CALL DD40#            Report them as rescaled          DD00  35
IF(INSTAB>0&(INSTAB<4&SCSTD==no:)) CALL DD70# Recalculate statistic     DD00  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DD00  37
#                                                                       DD00  38
RETURN#                                                                 DD00  39
END#                                                                    DD00  40
systemheader:(DD10)#                   Process the difdat line          DD10   1
#********************************************************************** DD10   2
#                                                                       DD10   3
#                                DD10                                   DD10   4
#                                                                       DD10   5
#********************************************************************** DD10   6
SUBROUTINE DD10#                                                        DD10   7
include:(AACOMN)#                                                       DD10   8
include:(DDCOMN)#                      J.m. stewart apr 83              DD10   9
#                                      N spadaccini may 1989            DD10  10
INTEGER IREL(30)#                      Input file offsets               DD10  11
INTEGER IPP,OMG#                       Output pkt pointer               DD10  12
INTEGER PSZ#                           Input file packet                DD10  13
INTEGER H,I,J,JP,K,KEY,L,MPAK,NPAK#    Misc pointers and indexes        DD10  14
REAL REFLPK(14)#                       Lrrefl: index packet             DD10  15
REAL DD#                                                                DD10  16
#                                                                       DD10  17
string:(TEMP,40)#                                                       DD10  18
chardata:(DD101,ADD NOA INC EXC OBS BAL BGT PRI NOP INS DAM NOB OBT $#  DD10  19
MIN RAW EST ANG NAP SIG NSC 2TH OME EUL NRW DTM COS SMU CTH SEQ MON $#
FIL DAT SPE CAD NID NIV TSU RD5 BDF UWA SIE BRU SHX RAP SH3 )#    
chardata:(DD102," Reflections printed                    ")#            DD10  22
chardata:(DD103," Copy reflections from input bdf      no")#            DD10  23
chardata:(DD104," Exclude standards from output bdf    no")#            DD10  24
chardata:(DD105,"[ rcode=1 if I/sig(I)           >        ]")#          DD10  25
chardata:(DD106,"[ Warning if (BG1-BG2)/sig(I)   >        ]")#          DD10  26
chardata:(DD107," Background count time each side        ")#            DD10  27
chardata:(DD108,"yes")#                                                 DD10  28
chardata:(DD109," no")#                                                 DD10  29
chardata:(DD10A,"[ sig(I) calculated by instab option     ]")#          DD10  30
chardata:(DD10B," Reflections copied from bdf            ")#            DD10  31
chardata:(DD10C," Minimum reflection scan time           ")#            DD10  32
chardata:(DD10D,"[ Default sig(I) ratio with I            ]")#          DD10  33
chardata:(DD10E," Store angles on the output bdf       no")#            DD10  34
chardata:(DD10F," Rescale data using smooth standard   no")#            DD10  35
chardata:(DD110, DIFDAT CONTROL PARAMETERS)#                            DD10  36
chardata:(DD111,"Special CAD4    Nicolet Nicolet Tsukuba Rigaku  $#     DD10  37
Xtl bdf Siem p3 Siemens Bruker  Shelx 4 Rig f2p Shelx 3   ")# 
chardata:(DD112," Diffractometer file format                     ")#    DD10  39
chardata:(DD113,"[ sig(I) enhancement factor              ]")#          DD10  40
chardata:(DD114," Instability factor from  scaled  standards ")#        DD10  41
chardata:(DD115,"Unscaled")#                                            DD10  42
chardata:(DD116," Store Eulerian angles on the bdf    yes")#            DD10  43
chardata:(DD118," Instability using raw counts        yes")#            DD10  44
realdata:(FMT2,[120513.,60512.,320722.,400732.])#                       DD10  45
datastuff:#                                                             DD10  46
#                                                                       DD10  47
# SET UP I/O BUFFER FOR BDF AND ASK FOR MEMORY                          DD10  48
# --------------------------------------------                          DD10  49
#                                                                       DD10  50
IOMARK(1)=QXSTR#                       Save buffer for input file       DD10  51
IOMARK(2)=IOMARK(1)+bdfbuf:#           Save buffer for output bdf       DD10  52
IOMARK(3)=IOMARK(2)+bdfbuf:#           Save buffer for scratch file     DD10  53
IOMARK(4)=IOMARK(3)+bdfbuf:#           Save buffer for diff. tape       DD10  54
incrqx:(MARKCB,IOMARK(4)+bdfbuf:,DD1001)# End of IO buffers
NUMATT=1#                              Set no. of attenuators           DD10  57
#                                                                       DD10  58
# SET DEFAULT OPTIONS FOR DIFDAT LINE                                   DD10  59
# -----------------------------------                                   DD10  60
#                                                                       DD10  61
NTABS=0;   TCODE=0#                    Set default no. of discontin     DD10  62
IPRINT=0 ; ICOPB=no:  ; IXSTD=no:#     Set output flags                 DD10  63
INSTAB=0;   IAPPLY=yes:#               Apply no instability             DD10  64
SCSTD=yes:#                            Scaled stds for instability      DD10  65
SUBTHR=no:#                            Do not change i if rcod=2        DD10  66
TIMMIN=10.#                            Set the min allowed scan         DD10  67
LISRAW=no:#                            Refuse to list raw data          DD10  68
SIGMPI=0.0#                            Sigma i enlargement factor       DD10  69
RELERR=0.08; OMG=no:#                  Set default relative error       DD10  70
IANG=no:;    IEUL=no:#                 Default - do not store angle     DD10  71
IRAW=yes:#                             Default - raw counts for inst.   DD10  72
ICOS=no:#                              No direction cosines             DD10  73
ISEQ=no:#                              No sequence num on archive
IMONV=no:#                             no monitor variability
DAMPPL=0.5#                            Set stds plot damping            DD10  74
THRESH=2.0;      BALAN=10.0#           Set observability thresholds     DD10  75
DEDTM=0.#                              Set extra deadtime correction    DD10  76
MAXCB=-1#                              no circular buffer needed         
THRCUL=1000.0#                         Tsu file cull threshold
CNTTIM=-1.0#                           use tsu file count time(deflt)
FILNAM=' '#                            init as blank
BGTIME=10.#                            Set backgound count time (se     DD10  77
DO J=1,10;       ATTENU(J)=1.0#        Set attenuators none - 9         DD10  78
DO J=1,11;       NCCR(J)=0#            Set standards numbers            DD10  79
DO J=1,4#                              Clear instabilities              DD10  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD10  81
SLOPE(J)=0.0;    INTERC(J)=0.0#        To zeros                         DD10  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD10  83
#                                                                       DD10  84
#    LOOP OVER DIFDAT FIELDS                                            DD10  85
#    -----------------------                                            DD10  86
#                                                                       DD10  87
FOR(K=1;K<=mxfdim:;K=K+1)#             Loop over difdat line fields     DD10  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD10  89
ifvo:(BUFIN(K)) BREAK#                 Quit on first void field         DD10  90
IF (BUFIN(K)>voidflg:) NEXT#           Check for alphabetics            DD10  91
stringlim:(K,I,J)#                     Get limits of character fiel     DD10  92
compchar:(CHRIN,I,DD101,1,3,4,NDD101,KEY)# Identify key                 DD10  93
IF(KEY==0) iquit:(-DD1002,K)#          Unrecognizable input field       DD10  94
IF(KEY==1)      ICOPB=yes:#            Set binary data file write       DD10  95
ELSE IF(KEY==4) IXSTD=yes:#            Set for exclusion of stds        DD10  96
ELSE IF(KEY==5)#                       Check for unobserved thresh      DD10  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DD10  98
IF(BUFIN(K+1)<0.) iquit:(DD1003,K+1)#  Test base                        DD10  99
THRESH=BUFIN(K+1);   K=K+1#            Set thresh and bump pointer      DD10 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DD10 101
ELSE IF(KEY==6)#                       Check for balan                  DD10 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DD10 103
IF(BUFIN(K+1)<3.) iquit:(DD1003,K+1)#  Test base                        DD10 104
BALAN=BUFIN(K+1);   K=K+1#             Set balan and bump pointer       DD10 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DD10 106
ELSE IF(KEY==7)#                       Check for bgtime                 DD10 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DD10 108
IF(BUFIN(K+1)<1.) iquit:(DD1003,K+1)#  Test base                        DD10 109
BGTIME=BUFIN(K+1);   K=K+1#            Set bgtime and bump pointer      DD10 110
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DD10 111
ELSE IF(KEY==8)#                       Check for print                  DD10 112
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DD10 113
IPRINT=99999#                                                           DD10 114
IF(BUFIN(K+1)>1.)#                                                      DD10 115
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  DD10 116
IPRINT=NINT(BUFIN(K+1));  K=K+1#       Take users desires               DD10 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  DD10 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DD10 119
ELSE IF(KEY==10)#                      Check on instability             DD10 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  DD10 121
IF((BUFIN(K+1)>=1.0)&(BUFIN(K+1)<=4.0))# Test options                   DD10 122
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  DD10 123
INSTAB=NINT(BUFIN(K+1));  K=K+1#       Accept method                    DD10 124
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  DD10 125
IF(INSTAB==4)#                         User supplies consts.            DD10 126
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 DD10 127
IF(BUFIN(K+1)>voidflg:)#               Must be a number                 DD10 128
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 DD10 129
SLOPE(4)=BUFIN(K+1);    K=K+1#         Take slope                       DD10 130
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 DD10 131
IF(BUFIN(K+1)>voidflg:)#               Check second fld                 DD10 132
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 DD10 133
INTERC(4)=BUFIN(K+1);   K=K+1#         Take intercept                   DD10 134
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 DD10 135
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 DD10 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  DD10 137
ELSE IF(KEY==11)#                      Damping of stds plots            DD10 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 DD10 139
IF((BUFIN(K+1)>0.1)&(BUFIN(K+1)<1.0))# Safe range                       DD10 140
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 DD10 141
DAMPPL=BUFIN(K+1);   K=K+1#            Save damper                      DD10 142
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 DD10 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 DD10 144
ELSE IF(KEY==13) SUBTHR=yes:#          Set the flag                     DD10 145
ELSE IF(KEY==14)#                      Check min scan time              DD10 146
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 DD10 147
IF(BUFIN(K+1)>small:)#                 Must be something                DD10 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 DD10 149
TIMMIN=BUFIN(K+1);   K=K+1#            Take value from user             DD10 150
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 DD10 151
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 DD10 152
ELSE IF(KEY==16)#                      Check relative error             DD10 153
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 DD10 154
IF(BUFIN(K+1)>small:)#                 Must be something                DD10 155
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 DD10 156
RELERR=BUFIN(K+1);   K=K+1#            Take value from user             DD10 157
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 DD10 158
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 DD10 159
ELSE IF(KEY==15) LISRAW=yes:#          Set to list raw data             DD10 160
ELSE IF(KEY==17) IANG=yes:#            Check for angle storage          DD10 161
ELSE IF(KEY==18) IAPPLY=no:#           Check for scale application      DD10 162
ELSE IF(KEY==19)#                      Check sigma i enlargement        DD10 163
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 DD10 164
SIGMPI=0.02#                           Default is 2 percent             DD10 165
IF(BUFIN(K+1)>voidflg:)#               Must be something                DD10 166
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 DD10 167
SIGMPI=BUFIN(K+1);   K=K+1#            Take value from user             DD10 168
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 DD10 169
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 DD10 170
ELSE IF(KEY==20) SCSTD=no:#            Unscaled stds for instability    DD10 171
ELSE IF(KEY==22) OMG=yes:#             Omega scan                       DD10 172
ELSE IF(KEY==23) IEUL=yes:#            Store eulerian data on bdf       DD10 173
ELSE IF(KEY==24) IRAW=no:#             No raw counts for inst.          DD10 174
ELSE IF(KEY==25)#                      Change deadtime                  DD10 175
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 DD10 176
ifnm:(BUFIN(K+1))#                     Make sure number present         DD10 177
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 DD10 178
DEDTM=BUFIN(K+1); K=K+1#               Set new value for deadtime       DD10 179
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 DD10 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 DD10 181
ELSE IF(KEY==26) ICOS=yes:#            Load direction cosines           DD10 182
ELSE IF(KEY==27)#                      TSU file monitor count smoothing 
$(
MAXCB=1
ifnm:(BUFIN(K+1))#                     Make sure number present         DD10 177
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 DD10 178
MAXCB=MAX(1,MIN(60,NINT(BUFIN(K+1)))); K=K+1#            
IF (MOD(MAXCB,2)!=1)MAXCB=MAXCB+1#     Ensure odd and symmetric
ifnm:(BUFIN(K+1))#                     fudged tsu file cnt time
$(CNTTIM=BUFIN(K+1);k=k+1$)#           get the time.
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 DD10 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 DD10 181
ELSE IF(KEY==28)#                      TSU monitor count culling
$(
ifnm:(BUFIN(K+1))#                     Make sure number present         DD10 177
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 DD10 178
THRCUL=BUFIN(K+1);K=K+1#
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 DD10 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 DD10 181
ELSE IF(KEY==29) ISEQ=yes:#            Save refln sequence number
ELSE IF(KEY==30) IMONV=yes:#           Save monitor variability
ELSE IF(KEY==31) 
$(
stringlim:(K+1,I,J)#                   Get limits of character fiel     DD10  92
FILNAM=CHRIP(I^J)#                     Copy the name
K=K+1#
$)
#
ELSE IF(KEY> 31) TCODE=KEY-32#         Diffractometer file input    
#   ## 0=data lines 1=tape  2=cad4  3=nic(vax)                          DD10 184
#   ## 4=nic(DG)    5=tsu   6=rd5   7=bdf  8=uwa-p3  9=sie/dct          DD10 185
#   ## 10=bruker/raw  11 SHELX hkl  12 rigaku rapid f2plus  
#   ## 13=SHELX HKLF 3 format
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD10 187
IF(IEUL==yes:) IANG=yes:#              Must store diffr angles          DD10 188
IF(IRAW==yes:&INSTAB==0) IRAW=no:#     No need for raw counts           DD10 189
IF(TCODE==7&ICOPB==yes:) iquit:(DD1020)# Contradictory bdf handling i   DD10 190
#                                                                       DD10 191
IF     (TCODE< 2) ;#                   For lines or special tape#       DD10 192
ELSE IF(TCODE==2) FILEXT(iofm1:)='CAD'# Extension for cad4 data         DD10 193
ELSE IF(TCODE< 5) FILEXT(iofm1:)='NIC'# Extension for nicolet data      DD10 194
ELSE IF(TCODE==5) FILEXT(iofm1:)='TSU'# Extension for tsukuba data      DD10 195
ELSE IF(TCODE==6) FILEXT(iofm1:)='RD5'# Extension for afc5s.dat data    DD10 196
ELSE IF(TCODE==8) FILEXT(iofm1:)='DCT'# Extension for p3/uwa data       DD10 197
ELSE IF(TCODE==9) FILEXT(iofm1:)='SIE'# Extension for siemens data      DD10 198
ELSE IF(TCODE==10)FILEXT(iofm1:)='RAW'# Extenn for bruker smart area    DD10 199
ELSE IF(TCODE==11\TCODE==13)#                    Check for file name
$(
IF(FILNAM(1^1)==' ') FILEXT(iofm1:)='HKL'# Extenn for compid.hkl
$)
ELSE IF(TCODE==12)#                     Special actions ...
$(
IF(FILNAM(1^1)==' ') iquit:(DD1023)#   no default file name
$)
IF(ICOS ==yes:&TCODE!=10) ICOS=no:#     Only possible for bruker    
IF(IMONV==yes:&TCODE!=5) IMONV=no:#    Only possible for .tsu
incrqx:(STOPCB,MARKCB+ABS(MAXCB)*20,DD1001)#  Reserve circular buffer
MARKS=STOPCB#                          Mark start of scales   
STOPS=MARKS;      STEPS=4#             Set scales limits                DD10  56
#                                                                       DD10 201
#    STORE DIFFRATOMETER MODE ON BDF                                    DD10 202
#    -------------------------------                                    DD10 203
#                                                                       DD10 204
copyfile:(1,3,1,decr:(lrexpl:))#       Copy up to lrexpl:               DD10 205
IF(TCODE!=7)#                          Raw data from outside file       DD10 206
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 DD10 207
IF(TCODE==10)#                         Only for bruker smart            DD10 208
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 DD10 209
IWANT(1)=2#                            Require wavelength               DD10 210
DO I=1,9;        IWANT(1 +I)=40+I#     Request ub elements              DD10 211
DO I=1,mxwd40c:; IWANT(10+I)=511#      Request measurement process      DD10 212
CAE(1)=10; CAE(2)=10; CAE(3)=10+mxwd40c:; CAE(4)=0# Set for update      DD10 213
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 DD10 214
ELSE#                                  Use standard procedure           DD10 215
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 DD10 216
DO I=1,mxwd40c:; IWANT(I)=511#         Request measurement process      DD10 217
CAE(1)=0; CAE(2)=0; CAE(3)=mxwd40c:; CAE(4)=0# Set for update           DD10 218
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 DD10 219
indexpkt:(1,lrexpl:,NPAK,IP,3,CAE,IWANT,IREL)# Look at directory        DD10 220
IF(CAE(4)<=0)iquit:(DD1021)#           No ub matrix on file             DD10 221
MPAK=CAE(4)#                           Set the op packet size           DD10 222
IF(TCODE==10) J=IREL(11)#              Pointr 2 measrmnt meth. string   DD10 223
ELSE          J=IREL(1)#               Pointr 2 measrmnt meth. string   DD10 224
DO I=1,26#                             Loop over all packets            DD10 225
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 DD10 226
readwpkt:(1,lrexpl:,NPAK,IP,0)#        Read next data set               DD10 227
IF(IP<=0) BREAK#                       Exit when packet finished        DD10 228
writepkt:(3,lrexpl:,MPAK,JP,0)#        Read next data set               DD10 229
movereal:(QX,IP+1,QX,JP+1,NPAK,0)#     Output packet                    DD10 230
IF(I>1) NEXT#                          Skip all but 1st dataset         DD10 231
IF(TCODE==10)#                         Get inverse ub orient matrix     DD10 232
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 DD10 233
IPSI=yes:#                             Must store psi                   DD10 234
WAVE=QX(IP+IREL(1))#                   Grab wavelength                  DD10 235
K=IP+IREL(2)-1#                        First ub location -1             DD10 236
DO H=1,9; ifvo:(QX(K+H))iquit:(DD1021)# No ub matrix on file            DD10 237
IUB(1)=QX(K+5)*QX(K+9)-QX(K+6)*QX(K+8)# Calculate adjunct               DD10 238
IUB(2)=QX(K+3)*QX(K+8)-QX(K+2)*QX(K+9)# Calculate adjunct               DD10 239
IUB(3)=QX(K+2)*QX(K+6)-QX(K+3)*QX(K+5)# Calculate adjunct               DD10 240
IUB(4)=QX(K+6)*QX(K+7)-QX(K+4)*QX(K+9)# Calculate adjunct               DD10 241
IUB(5)=QX(K+1)*QX(K+9)-QX(K+3)*QX(K+7)# Calculate adjunct               DD10 242
IUB(6)=QX(K+3)*QX(K+4)-QX(K+1)*QX(K+6)# Calculate adjunct               DD10 243
IUB(7)=QX(K+4)*QX(K+8)-QX(K+7)*QX(K+5)# Calculate adjunct               DD10 244
IUB(8)=QX(K+2)*QX(K+7)-QX(K+1)*QX(K+8)# Calculate adjunct               DD10 245
IUB(9)=QX(K+1)*QX(K+5)-QX(K+2)*QX(K+4)# Calculate adjunct               DD10 246
DD=QX(K+1)*IUB(1)+QX(K+4)*IUB(2)+QX(K+7)*IUB(3)# Get determinant        DD10 247
ifeq:(DD,0.0,.0001) iquit:(DD1022)#    Ub matrix is singular            DD10 248
DO K=1,9; IUB(K)=IUB(K)/DD#            Scale adjuncts                   DD10 249
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 DD10 250
TEMP=' '#                              Reset diffr string               DD10 251
IF     (TCODE==2)  TEMP='CAD4'#        Signal cad4 used                 DD10 252
ELSE IF(TCODE==3\TCODE==4)#            Test if nicolet                  DD10 253
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 DD10 254
TEMP='Nicolet'#                        Signal nicolet used              DD10 255
IF(OMG==no: ) TEMP(10^)='theta-2theta scan'# Insert scan mod            DD10 256
ELSE          TEMP(10^)='omega scan'#  Insert scan mode                 DD10 257
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 DD10 258
ELSE IF(TCODE==5)  TEMP='Tsukuba'#     Signal tsukuba used              DD10 259
ELSE IF(TCODE==6)  TEMP='Rigaku5'#     Signal rigaku5 used              DD10 260
ELSE IF(TCODE==8)  TEMP='Siem p3'#     Signal siemen3 used              DD10 261
ELSE IF(TCODE==9)  TEMP='Siemens'#     Signal siemen3 used              DD10 262
ELSE IF(TCODE==10) TEMP='Bruker '#     Signal bruker used               DD10 263
ELSE IF(TCODE==11) TEMP='Shelx  '#     Signal Shelx format
ELSE IF(TCODE==12) TEMP='Rapid  '#     Rapid
ELSE IF(TCODE==13) TEMP='Shelx3 '#     Signal Shelx format
movector:(TEMP,1,QX(JP+J),1,40,0)#     Insert diffr process string      DD10 264
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 DD10 265
copyfile:(1,3,incr:(lrexpl:),decr:(lrrefl:))# Copy up to lrrefl:        DD10 266
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 DD10 267
ELSE copyfile:(1,3,lrexpl:,decr:(lrrefl:))# Copy up to lrrefl:          DD10 268
#                                                                       DD10 269
#    REPORT OUT KEYED ACTIVITIES AND SETTINGS                           DD10 270
#    ----------------------------------------                           DD10 271
#                                                                       DD10 272
movechar:(DD106,17,CHROT,2,NDD110-1,1)# Insert underline -              DD10 273
writeline:(1,DD110,NDD110,2,3)#        Write difdat header              DD10 274
IF(TCODE>0)#                           If tape input                    DD10 275
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 DD10 276
movechar:(DD111,TCODE*8-7,DD112,37,8,0)# Diff file format               DD10 277
writeline:(0,DD112,NDD112,3,3)#        Print it now                     DD10 278
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 DD10 279
ncodefld:(FLOAT(IPRINT),1,DD102,400613.,1)# Hkl printed                 DD10 280
writeline:(0,DD102,NDD102,3,3)#        Print it now                     DD10 281
IF(ICOPB==yes:) movechar:(DD108,1,DD103,38,3,0)# Hkl from bdf?          DD10 282
writeline:(0,DD103,NDD103,3,3)#        Print it now                     DD10 283
IF(IAPPLY==yes:)movechar:(DD108,1,DD10F,38,3,0)#                        DD10 284
writeline:(0,DD10F,NDD10F,3,3)#        Print it now                     DD10 285
IF(IXSTD==yes:) movechar:(DD108,1,DD104,38,3,0)#                        DD10 286
writeline:(0,DD104,NDD104,3,3)#        Print it now                     DD10 287
IF(IANG==yes:)  movechar:(DD108,1,DD10E,38,3,0)#                        DD10 288
writeline:(0,DD10E,NDD10E,3,3)#        Print it now                     DD10 289
IF(IEUL==yes:)  writeline:(0,DD116,NDD116,3,3)# Print eulerian angles   DD10 290
IF(INSTAB>0)#                          Only relevant for instab calc.   DD10 291
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 DD10 292
IF(IRAW==no:)  movechar:(DD109,1,DD118,38,3,0)#                         DD10 293
writeline:(0,DD118,NDD118,3,3)#        Print it now                     DD10 294
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 DD10 295
ncodefld:(FLOAT(INSTAB),1,DD10A,400213.,1)#                             DD10 296
writeline:(0,DD10A,NDD10A,3,3)#        Print it now                     DD10 297
IF(INSTAB>0&SCSTD==no:) movechar:(DD115,1,DD114,26,8,0)# Unscaled       DD10 298
writeline:(0,DD114,NDD114,3,3)#        Print it now                     DD10 299
ncodefld:(RELERR,1,DD10D,400832.,1)#                                    DD10 300
IF(TCODE<2)writeline:(0,DD10D,NDD10D,3,3)# Print it now                 DD10 301
ncodefld:(SIGMPI,1,DD113,400842.,1)#                                    DD10 302
writeline:(0,DD113,NDD113,3,3)#        Print it now                     DD10 303
ncodefld:(THRESH,1,DD105,400842.,1)#                                    DD10 304
writeline:(0,DD105,NDD105,3,3)#        Print it now                     DD10 305
ncodefld:(BALAN,1,DD106,400842.,1)#                                     DD10 306
writeline:(0,DD106,NDD106,3,3)#        Print it now                     DD10 307
ncodefld:(BGTIME,1,DD107,400822.,1)#                                    DD10 308
IF(TCODE<2)writeline:(0,DD107,NDD107,3,3)# Print it now                 DD10 309
ncodefld:(TIMMIN,1,DD10C,400822.,1)#                                    DD10 310
IF(TCODE<2)writeline:(0,DD10C,NDD10C,3,3)# Print it now                 DD10 311
#                                                                       DD10 312
#  COPY TO FILEB IF REQUESTED                                           DD10 313
#  -------------------------                                            DD10 314
#                                                                       DD10 315
PSIZ=4#                                Set packet size for default      DD10 316
IF(TCODE>=10)#                                                          DD10 317
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 DD10 318
IWANT(1)=1;IWANT(2)=1302;IWANT(3)=1303;IWANT(4)=1308#                   DD10 319
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 DD10 320
ELSE#                                                                   DD10 321
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 DD10 322
IWANT(1)=1;IWANT(2)=1300;IWANT(3)=1301;IWANT(4)=1308#                   DD10 323
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 DD10 324
IF(IANG==yes:)#                        Are angles stored                DD10 325
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 DD10 326
PSIZ=PSIZ+4#                           Expand for angle storage         DD10 327
IWANT(PSIZ-3)=1008;IWANT(PSIZ-2)=1007;IWANT(PSIZ-1)=1006#               DD10 328
IWANT(PSIZ)=1005#                                                       DD10 329
IF(IEUL==yes:)#                        Are eulerian data stored         DD10 330
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 DD10 331
PSIZ=PSIZ+3#                           Expand for angle storage         DD10 332
IWANT(PSIZ-2)=1018;IWANT(PSIZ-1)=1027;IWANT(PSIZ)=1014#                 DD10 333
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 DD10 334
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 DD10 335
IF(IRAW==yes:)#                        Raw counts stored                DD10 336
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 DD10 337
PSIZ=PSIZ+3#                           Packets are a bit bigger         DD10 338
IWANT(PSIZ-2)=1000#                    Total gross counts               DD10 339
IWANT(PSIZ-1)=1001#                    Total backgrnd counts            DD10 340
IWANT(PSIZ)=1002#                      Background time                  DD10 341
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 DD10 342
IF(IPSI==yes:)#                        Store flack psi angle            DD10 343
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 DD10 344
PSIZ=PSIZ+1#                           Packets are a bit bigger         DD10 345
IWANT(PSIZ)=1011#                      Pointers for flack azim psi      DD10 346
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 DD10 347
IF(ICOS==yes:)#                        Store cosines                    DD10 348
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 DD10 349
PSIZ=PSIZ+6#                           Packets are a bit bigger         DD10 350
DO I=5,0,-1;IWANT(PSIZ-I)=1053+6-I#    Pointers for primary/source co   DD10 351
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 DD10 352
IF(ISEQ==yes:)#                        Store reflection sequence number
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 DD10 344
PSIZ=PSIZ+1#                           Packets are a bit bigger         DD10 345
IWANT(PSIZ)=1027#                      stash  sequence number
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 DD10 347
IF(IMONV==yes:)#                       Store monitor count variability
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 DD10 344
PSIZ=PSIZ+1#                           Packets are a bit bigger         DD10 345
IWANT(PSIZ)=1030#                      stash  sequence number
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 DD10 347
#                                                                       DD10 353
DO K=1,21; REFLPK(K)=FLOAT(IWANT(K))#  Store directory packet           DD10 354
DO K=1,21; IOFF(K)=K#                  Default lrrefl: offsets          DD10 355
IF(ICOPB==yes:)#                       If bdf is to be copied           DD10 356
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 DD10 357
CAE(1)=PSIZ;CAE(2)=PSIZ;CAE(3)=PSIZ;CAE(4)=1# For indexpkt:             DD10 358
indexpkt:(1,lrrefl:,PSZ,IP,0,CAE,IWANT,IREL)#                           DD10 359
IF(CAE(4)!=4) iquit:(DD1010)#          Die if packet wrong              DD10 360
writepkt:(3,lrrefl:,PSIZ,IPP)#         Write header                     DD10 361
movereal:(REFLPK,1,QX,IPP+1,PSIZ,0)#   Move in directory                DD10 362
#                                                                       DD10 363
#  NOW COPY ALL REFLECTIONS ON THE INPUT FILE TO THE OUTPUT             DD10 364
#  --------------------------------------------------------             DD10 365
#                                                                       DD10 366
BUFOT(1)=0.0#                          Start reflection count           DD10 367
REPEAT#                                Loop over reflection data        DD10 368
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 DD10 369
readwpkt:(1,lrrefl:,PSZ,IP,0)#         Read the next lrrefl: packet     DD10 370
IF(IP<=0)BREAK#                        Quit at end of record            DD10 371
writepkt:(3,lrrefl:,PSIZ,IPP)#         Get output pointer               DD10 372
L=IP+IREL(1)#                          Get packed hkl                   DD10 373
movepakwd:(QX(L),QX(IPP+1))#           Move hkl to output               DD10 374
L=IP+IREL(2);QX(IPP+2)=QX(L)#          Move intensity                   DD10 375
L=IP+IREL(3);QX(IPP+3)=QX(L)#          Move sigma(i)                    DD10 376
L=IP+IREL(4)#                                                           DD10 377
L=NINT(QX(L));K=0#                     Pick up rcode as integer         DD10 378
intpak:(K,QX(IPP+4),4,28)#             Fake serial no.                  DD10 379
intpak:(L,QX(IPP+4),0,4)#              Pack rcode                       DD10 380
BUFOT(1)=BUFOT(1)+1.0#                 Count the move                   DD10 381
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 DD10 382
ncodefld:(BUFOT,1,DD10B,400513.,1)#    Hkl count from bdf               DD10 383
writeline:(0,DD10B,NDD10B,3,3)#        Print it                         DD10 384
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 DD10 385
ELSE IF(ICOPB==no:)#                   Check bdf outputing              DD10 386
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 DD10 387
writepkt:(3,lrrefl:,PSIZ,IP)#          Write lrrefl: directory          DD10 388
movereal:(REFLPK,1,QX,IP+1,PSIZ,0)#    Move directory to buffer         DD10 389
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 DD10 390
RETURN#                                                                 DD10 391
END#                                                                    DD10 392
systemheader:(DD20)#                                                    DD20   1
#********************************************************************** DD20   2
#                                                                       DD20   3
#                                DD20                                   DD20   4
#                                                                       DD20   5
#********************************************************************** DD20   6
SUBROUTINE DD20#                                                        DD20   7
include:(AACOMN)#                                                       DD20   8
include:(DDCOMN)#                                                       DD20   9
#                                                                       DD20  10
#  THIS PROGRAM READS THE REST OF THE CONTROL LINES AND SETS            DD20  11
#  UP THE ORDER OF THE INPUT QUANTITIES AND THE ATTENUATOR              DD20  12
#  FACTORS.                                                             DD20  13
#  J. M. STEWART  APRIL 1983.                                           DD20  14
#                                                                       DD20  15
REAL FMT#                                                               DD20  16
INTEGER J,K,I#                         Local index                      DD20  17
INTEGER NSTD#                          Count of reflection codes        DD20  18
INTEGER START#                         Pointer to chars in chrin        DD20  19
INTEGER IEND#                          Ditto                            DD20  20
INTEGER NCHR#                          No. of characters                DD20  21
#                                                                       DD20  22
chardata:(LABEL, DATA END SETSCL GENSCL DISCON $#                       DD20  23
TAPEIN FETCH CODE ATTENU STANDS STHKLS TRANSF )#                        DD20  24
chardata:(DD201," Reflection type code for XXXXXXXX            ")#      DD20  25
chardata:(DD202,"normal  standardrejected")#                            DD20  26
chardata:(DD209," Attenuator   Multiplier")#                            DD20  27
realdata:(FORM,[90333.,130338.,170229.,270333.,310338.,350229.,#        DD20  28
450333.,490338.,530229.,630333.,670338.,710229.])#                      DD20  29
datastuff:#                                                             DD20  30
#                                                                       DD20  31
#     SET INPUT DEFAULTS                                                DD20  32
#     ------------------                                                DD20  33
#                                                                       DD20  34
TOTCHR=0;     USTCNT=0#                Zero count of user defined       DD20  35
NH=0;   NK=0;   NL=0;   NS=0#          Switch off all item pointers     DD20  36
NSCT=0; NSCC=0; NBG1=0; NBG2=0#        Switch off all item pointers     DD20  37
NATN=0; NRFN=0; NFO=0;  NSFO=0#        Switch off all item pointers     DD20  38
NIRL=0; NSIR=0; NFSQ=0; NSFS=0#        Switch off all item pointers     DD20  39
NTTH=0; NOMG=0; NCHI=0; NPHI=0#        Switch off all item pointers     DD20  40
NCP1=0; NCP2=0; NCP3=0#                Switch off prim dir cos ptr      DD20  41
NCD1=0; NCD2=0; NCD3=0#                Switch off diff dir cos ptr      DD20  42
NPSI=0#                                Switch off psi angle ptr         DD20  43
NPBD=0#                                Switch off all time pointers     DD20  44
NBGT=0#                                Switch off all item pointers     DD20  45
CNTRLS='1     2      ';  NCCS=13#      Default reflection types         DD20  46
NSTD=2;   NCCR(1)=1;   NCCR(2)=2#      Default reflection types         DD20  47
ITM=no:#                               No hkl transformation            DD20  48
#                                                                       DD20  49
#  LOOP OVER INPUT LINES                                                DD20  50
#  ---------------------                                                DD20  51
#                                                                       DD20  52
REPEAT#                                Loop over input lines            DD20  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD20  54
readline:(LABEL,NLABEL)#               Read next line                   DD20  55
#                                                                       DD20  56
IF(LINID==7)CALL DD22#                 Process **fetch** line           DD20  57
#                                                                       DD20  58
ELSE IF(LINID==9)#                     Process **attenu** line          DD20  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD20  60
DO K=1,9#                              Loop over all but first          DD20  61
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DD20  62
ifvo:(BUFIN(K)) BREAK#                 And stop at first void           DD20  63
ELSE IF(BUFIN(K)>=1.)#                                                  DD20  64
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DD20  65
NUMATT=NUMATT+1;ATTENU(K+1)=BUFIN(K)#  Store factor                     DD20  66
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DD20  67
ELSE iquit:(-DD2004,K)#                Or die                           DD20  68
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DD20  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD20  70
#                                                                       DD20  71
ELSE IF(LINID==10)#                    Process **stands** line          DD20  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DD20  73
NSTD=0;    NCCS=1#                     Zero counts of stand flags       DD20  74
FOR(K=1;K<=21;K=K+2)#                  Loop over input fields           DD20  75
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DD20  76
ifvo:(BUFIN(K+1))BREAK#                Stop at first void type          DD20  77
IF((BUFIN(K+1)>0.5)&(BUFIN(K+1)<2.5))# Test for valid code              DD20  78
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  DD20  79
NSTD=NSTD+1#                           Count the code                   DD20  80
NCCR(NSTD)=NINT(BUFIN(K+1))#           Save reflection type             DD20  81
IF(BUFIN(K)<voidflg:)#                 Code is characters               DD20  82
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  DD20  83
stringlim:(K,START,IEND)#              Where is it                      DD20  84
NCHR=MIN0(6,IEND-START)#               How long is it                   DD20  85
movechar:(CHRIN,START,CNTRLS,NCCS,NCHR,0)# Save it away                 DD20  86
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  DD20  87
ELSE IF((BUFIN(K)>(-.5))&(BUFIN(K)<9.5))#                               DD20  88
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  DD20  89
FMT=113.+FLOAT(NCCS)*10000.#           Make a format                    DD20  90
ncodefld:(BUFIN,K,CNTRLS,FMT,1)#       And store it away                DD20  91
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  DD20  92
ELSE IF((BUFIN(K)>9.5)&(BUFIN(K)<99.5))# Two digit codes                DD20  93
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 DD20  94
FMT=213.+FLOAT(NCCS+1)*10000.#         Make a format                    DD20  95
ncodefld:(BUFIN,K,CNTRLS,FMT,1)#       An store it away                 DD20  96
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 DD20  97
NCCS=NCCS+6#                           Total the characters             DD20  98
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  DD20  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DD20 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DD20 101
#                                                                       DD20 102
ELSE IF(LINID==11)#                    Process **sthkls** line          DD20 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 DD20 104
FOR(K=1;K<=21;K=K+3)#                  Loop over triples                DD20 105
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 DD20 106
ifvo:(BUFIN(K)) BREAK#                 End of the line                  DD20 107
USTCNT=USTCNT+1#                       Count next refln.                DD20 108
IF(USTCNT>smax:) BREAK#                Ten is maximum                   DD20 109
IHS(1,USTCNT)=NINT(BUFIN(K))#          Get h of std. ref.               DD20 110
IHS(2,USTCNT)=NINT(BUFIN(K+1))#        Get k of std. ref.               DD20 111
IHS(3,USTCNT)=NINT(BUFIN(K+2))#        Get l of std. ref.               DD20 112
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 DD20 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 DD20 114
#                                                                       DD20 115
ELSE IF(LINID==12)#                    ***********transf***********     DD20 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 DD20 117
DO I=1,9; ifnm:(BUFIN(I)) TM(I)=BUFIN(I)# Numeric field                 DD20 118
ITM=yes:#                              Transform hkl                    DD20 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 DD20 120
#                                                                       DD20 121
ELSE IF(LINID==5)#                     **discon** line entered          DD50 190
FOR(I=1;I>0;I=I+1)#                    Loop over input fields           DD50 191
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 DD50 192
IF(BUFIN(I)<=0.0)BREAK#                Stop when data stops             DD50 193
IF(NTABS>48) NEXT#                     Table only 50 long               DD50 194
NTABS=NTABS+1#                                                          DD50 203
NTAB(NTABS)=BUFIN(I)#                  Save the last refln number       DD50 204
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 DD50 210
#
ELSE IF(LINID<5)BREAK#                 Exit if data to discon           DD20 122
#                                      
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD20 123
IF(QUITF(1^1)!=' ')iquit:(DD2006)#     Die dead from earlier crap       DD20 124
#                                                                       DD20 125
#   PRINT REFLECTION TYPE CODES                                         DD20 126
#   ---------------------------                                         DD20 127
#                                                                       DD20 128
DO I=1,NSTD#                           Loop over reflection codes       DD20 129
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 DD20 130
J=NCCR(I)#                             Get numerical values             DD20 131
movechar:(CNTRLS,I*6-5,DD201,40,6,0)#  Pull back the code               DD20 132
movechar:(DD202,J*8-7,DD201,27,8,0)#   Write type of reflection         DD20 133
writeline:(0,DD201,NDD201,3,3)#        Print scale data                 DD20 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 DD20 135
#                                                                       DD20 136
#   PRINT ATTENUATOR VALUES                                             DD20 137
#   -----------------------                                             DD20 138
#                                                                       DD20 139
writeline:(1,DD209,NDD209,3,3)#        Attenuator header                DD20 140
DO K=1,NUMATT#                         Loop over attenuators            DD20 141
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 DD20 142
ncodefld:(FLOAT(K-1),1,CHROT,70313.,1)# Format attenuator count         DD20 143
ncodefld:(ATTENU,K,CHROT,221042.,1)#   Format attenuator                DD20 144
writeline:(0,0,0,1,3)#                 Print attenuator                 DD20 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 DD20 146
#                                                                       DD20 147
#    ASSIGN ITEM ORDER FOR SET DIFFR FILES                              DD20 148
#    -------------------------------------                              DD20 149
#                                                                       DD20 150
IF(NH==0\TCODE>1)#                     Test if fetch line entered       DD20 151
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 DD20 152
IF(TCODE<2)iquit:(DD2030)#             Fetch line must be entered       DD20 153
IF(TCODE==2)#                          **** cad **** data from dd32     DD20 154
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 DD20 155
NRFN=1#                                Refln sequence number            DD20 156
NH=2;    NK=3;    NL=4#                Refln h k l                      DD20 157
NTTH=5;  NPHI=6;  NOMG=7;  NCHI=8;  NPSI=9# Angles 2th phi omega chi    DD20 158
NATN=10; NS=11#                        Attenuator number & refln type   DD20 159
NIRL=12; NSIR=13#                      Counts irel and sigirel          DD20 160
NBG1=14; NBG2=15#                      Backgrounds                      DD20 161
NSCC=16; NPBD=17#                      Raw counts,time peak/time bkgd   DD20 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 DD20 163
ELSE IF(TCODE==3\TCODE==4\TCODE==8\TCODE==9)# **** data from dd32       DD20 164
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 DD20 165
NRFN=1#                                Refln sequence number            DD20 166
NH=2;    NK=3;    NL=4#                Refln h k l                      DD20 167
NTTH=5;  NOMG=6;  NPHI=7;  NCHI=8#     Angles 2th omega phi chi         DD20 168
NIRL=9;  NSIR=10#                      Counts irel sigirel              DD20 169
NS=11#                                 Refln type norm/std              DD20 170
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 DD20 171
ELSE IF(TCODE==5)#                     **** tsu **** data from dd33     DD20 172
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 DD20 173
NS=1#                                  Refln type                       DD20 174
NH=2;    NK=3;    NL=4#                Refln h k l                      DD20 175
NIRL=5;  NSIR=6#                       Counts irel sigirel              DD20 176
NBG1=7;  NBG2=8#                       Counts bg1 bg2                   DD20 177
NATN=10#                               Attenuator number                DD20 178
NMON=18#                               Monitor count variability
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 DD20 179
ELSE IF(TCODE==6)#                     **** rig **** data from dd34     DD20 180
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 DD20 181
NS=1;    NRFN=2#                       Refln type and number            DD20 182
NH=3;    NK=4;    NL=5#                Refln h k l                      DD20 183
NBG1=6;  NBG2=7#                       Backgrounds                      DD20 184
NIRL=8;  NSIR=9#                       Counts irel sigirel              DD20 185
NTTH=10; NOMG=11; NPHI=12; NCHI=13#    Angles 2th omega phi chi         DD20 186
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 DD20 187
ELSE IF(TCODE==7)#                     From input bdf                   DD20 188
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 DD20 189
#                                                                       DD20 190
#   CHANGE THE FOLLOWING VALUES IN CONJUNCTION WITH DD35                DD20 191
#                                                                       DD20 192
NS=1#                                  Standard code                    DD20 193
NH=2;NK=3;NL=4#                        Refln hkl                        DD20 194
NBG1=7;  NBG2=8#                       Counts bg1 bg2                   DD20 195
NSCC=9#                                Raw counts                       DD20 196
NATN=10#                               Attenuator number                DD20 197
NSCT=11#                               Scan time                        DD20 198
NBGT=12#                               Background time                  DD20 199
NPBD=13#                               Peak/background ratio            DD20 200
NIRL= 5#                               Integrated intensity             DD20 201
NSIR= 6#                               Sigma int int.                   DD20 202
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 DD20 203
ELSEIF(TCODE==10)#                     Bruker smart area detector       DD20 204
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 DD20 205
##      ## from the saint manual                                        DD20 206
## check first char - may be an "!" SHELX comment flag                  DD20 207
NH=1;    NK=2;    NL=3#                Refln h k l                      DD20 208
NFSQ=4# ## Integrated intensity, bkgd sub, normalised +lp corrected     DD20 209
#       ##     i.e. F^2                                                 DD20 210
NSFS=5# ## Sigma on integrated intensity                                DD20 211
#N  =6# ##     Batch number for scaling ??                              DD20 212
NCP1=7; NCD1= 8;## X direction cosines of primary and diffracted        DD20 213
NCP2=9; NCD2=10;## Y direction cosines of primary and diffracted        DD20 214
NCP3=11;NCD3=12;## Z direction cosines of primary and diffracted        DD20 215
NPSI=13## psi calculated and stored here                                DD20 216
#NS  =13##     Status mask for abnormal refs                            DD20 217
#N   =14##     X pixel coord of int weighted refln                      DD20 218
#N   =15##     Y pixel coord of int weighted refln                      DD20 219
#N   =16##     Observed frame number of int weighted refln              DD20 220
#N   =17##     Predicted X pixel coord of int weighted refln            DD20 221
#N   =18##     Predicted y pixel coord of int weighted refln            DD20 222
#N   =19##     Predicted frame number of int weighted refln             DD20 223
#N   =20##     LP, air absorb correction factor                         DD20 224
#N   =21##     3D profile and modelled 3d profile correl coef           DD20 225
#N   =22##     X-ray exposure in hours                                  DD20 226
#NTTH=23##     Detector 2theta angle                                    DD20 227
#N   =24##     Scan axis setting in degrees                             DD20 228
#N   =25##     Scan axis number (2=omega)                               DD20 229
#N   =26##     Sin theta / lambda *10^4                                 DD20 230
#NSCC=27##     Total raw peak counts - no lp correc etc                 DD20 231
#NBG12=28##    Total Background counts                                  DD20 232
#N   =29##     rotation angle of scan axis ???                          DD20 233
#N   =30##     Crystal number ??                                        DD20 234
#N   =31##     Fraction of profile volume nearest this hkl??            DD20 235
#N   =32##     Refln SORT key (word - for SHELX?)                       DD20 236
#N   =33##     Point group refln multiplicity                           DD20 237
#NPBD=???#     THERE IS NO TIME PEAK/TIME BKGD = 1.0???                 DD20 238
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 DD20 239
ELSEIF(TCODE==11\TCODE==13)#           SHELX format hkl file in
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 DD20 205
NH=1;    NK=2;    NL=3#                Refln h k l                      DD20 208
NFSQ=4; NSFS=5#                        f squared and sigma fsquared
#N=6                                   batch number for scaling
$)
ELSEIF(TCODE==12)#                     Rigaku Rapid f2plus
$(
NH=1;    NK=2;    NL=3#                Refln h k l                      DD20 208
NFSQ=4; NSFS=5#                        f squared and sigma fsquared
$)
CALL DD22#                             Simulate a fetch line            DD20 240
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 DD20 241
#                                                                       DD20 242
RETURN#                                                                 DD20 243
END#                                                                    DD20 244
systemheader:(DD22)#                   Process the fetch line           DD22   1
#********************************************************************** DD22   2
#                                                                       DD22   3
#                                DD22                                   DD22   4
#                                                                       DD22   5
#********************************************************************** DD22   6
SUBROUTINE DD22#                                                        DD22   7
include:(AACOMN)#                                                       DD22   8
include:(DDCOMN)#                                                       DD22   9
#                                                                       DD22  10
INTEGER INDEX,I,J,K#                                                    DD22  11
string:(BUF,6)#                        To hold nmemonics                DD22  12
chardata:(MNE,SIGH  K  L  TTHOMGCHIPHISCTSCCBGTBG1BG2EMRATNRFNNBG$#     DD22  13
NSCRSBRMBFO SFORFORSTRPSIRLSIRFSQSFSSKP)#                               DD22  14
datastuff:#                                                             DD22  15
#                                                                       DD22  16
#   LOOP OVER **FETCH** FIELDS                                          DD22  17
#   --------------------------                                          DD22  18
#                                                                       DD22  19
IF(NH==0)#                             If pointers not set              DD22  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD22  21
FOR(I=1;I<40;I=I+1)#                   Loop over all non-void field     DD22  22
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD22  23
ifvo:(BUFIN(I))  BREAK#                Break at first void field        DD22  24
movechar:(BLANK,1,BUF,1,3,1)#          Blank out buf                    DD22  25
stringlim:(I,J,K)#                     Find mnemonic's limits           DD22  26
movechar:(CHRIN,J,BUF,1,K-J,0)#        Move string into buf             DD22  27
compchar:(BUF,1,MNE,1,3,3,NMNE,INDEX)# Compare input w/reference  d     DD22  28
IF(INDEX==0)iquit:(DD2201)#            Illegal mnemonic                 DD22  29
#                                                                       DD22  30
IF     (INDEX==1)NS=I#                 Signal of reflection type        DD22  31
ELSE IF(INDEX==2)NH=I#                 H                                DD22  32
ELSE IF(INDEX==3)NK=I#                 K                                DD22  33
ELSE IF(INDEX==4)NL=I#                 L                                DD22  34
ELSE IF(INDEX==5)NTTH=I#               2theta                           DD22  35
ELSE IF(INDEX==6)NOMG=I#               Omega                            DD22  36
ELSE IF(INDEX==7)NCHI=I#               Chi                              DD22  37
ELSE IF(INDEX==8)NPHI=I#               Phi                              DD22  38
ELSE IF(INDEX==9)NSCT=I#               Scan time                        DD22  39
ELSE IF(INDEX==10)NSCC=I#              Counts peak scan                 DD22  40
ELSE IF(INDEX==11)NBGT=I#              Background time                  DD22  41
ELSE IF(INDEX==12)NBG1=I#              Counts bg1                       DD22  42
ELSE IF(INDEX==13)NBG2=I#              Counts bg2                       DD22  43
ELSE IF(INDEX==15)NATN=I#              Attenuator number                DD22  44
ELSE IF(INDEX==16)NRFN=I#              Reflection sequence number       DD22  45
ELSE IF(INDEX==21)NFO =I#              Frel                             DD22  46
ELSE IF(INDEX==22)NSFO=I#              Sigma frel                       DD22  47
ELSE IF(INDEX==26)NIRL=I#              Irel                             DD22  48
ELSE IF(INDEX==27)NSIR=I#              Sigma irel                       DD22  49
ELSE IF(INDEX==28)NFSQ=I#              Frel squared                     DD22  50
ELSE IF(INDEX==29)NSFS=I#              Sigma frel squared               DD22  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD22  52
IF((NH*NK*NL)<1)iquit:(DD2202)#        D                                DD22  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD22  54
RETURN#                                                                 DD22  55
END#                                                                    DD22  56
systemheader:(DD30)#                   Read raw data from diff file     DD30   1
#********************************************************************** DD30   2
#                                                                       DD30   3
#                                DD30                                   DD30   4
#                                                                       DD30   5
#********************************************************************** DD30   6
SUBROUTINE DD30#                                                        DD30   7
include:(AACOMN)#                                                       DD30   8
include:(DDCOMN)#                      J.m. stewart 1983                DD30   9
#                                                                       DD30  10
INTEGER HKL(3)#                        Buffer for packed h,k,l          DD30  11
INTEGER IPRINL#                        Reflections to print             DD30  12
INTEGER JJ#                                                             DD30  13
INTEGER ISIGN#                                                          DD30  14
INTEGER INDEX#                                                          DD30  15
INTEGER IBIT#                                                           DD30  16
INTEGER IY,L#                                                           DD30  17
INTEGER I#                                                              DD30  18
REAL BKG#                                                               DD30  19
REAL BG1#                                                               DD30  20
REAL BG2#                                                               DD30  21
REAL SCANTM#                                                            DD30  22
REAL SCANTM0#                          Scan time first reflection       DD30  23
REAL QUANT#                                                             DD30  24
REAL SCAN#                                                              DD30  25
REAL VAR#                                                               DD30  26
REAL TPBG#                                                              DD30  27
INTEGER IATTEN#                                                         DD30  28
INTEGER JREF#                                                           DD30  29
INTEGER NREC#                                                           DD30  30
INTEGER ISSEQ#                                                          DD30  31
INTEGER START#                                                          DD30  32
INTEGER IEND#                                                           DD30  33
INTEGER KEY#                                                            DD30  34
INTEGER NCCT#                                                           DD30  35
INTEGER NPRE#                                                           DD30  36
string:(BUF,6)#                                                         DD30  37
string:(LINE,80)#                      Extra line buffer                DD30  38
#                                                                       DD30  39
chardata:(DD300, DATA END SETSCL GENSCL DISCON )#                       DD30  40
chardata:(DD301," Input DATA line inconsistent with FETCH line")#       DD30  41
chardata:(DD305,"   h   k   l    intensity    sig(I)   $#               DD30  42
rcode  sequences   flags   ")#                                          DD30  43
chardata:(DD306,"Scan time unreasonably short - input skipped")#        DD30  44
chardata:(DD307,"Atten  X")#                                            DD30  45
chardata:(DD308,"backgrds")#                                            DD30  46
chardata:(DD309,"seq err XXXX ")#                                       DD30  47
chardata:(DD311," * XXXXXX reflections treated.  Last $#                DD30  48
input sequence number XXXXXX *")#                                       DD30  49
chardata:(DD312,"std")#                                                 DD30  50
chardata:(DD313,"bad attenuator specification")#                        DD30  51
chardata:(DD314,"Raw counts not used for instability - none available")#DD30  52
realdata:(TINY,0.000125)#                                               DD30  53
realdata:(RAWSCN,0.)#                                                   DD30  54
realdata:(FMT,[90713.,650613.])#                                        DD30  55
realdata:(RFMT,[40413., 80413.,120413.,#                                DD30  56
251232.,361032.,400113.,490513.,550513.])#                              DD30  57
intdata:(IZERO,0)#                                                      DD30  58
intdata:(CHRMXP,80)#                                                    DD30  59
datastuff:#                                                             DD30  60
#                                                                       DD30  61
#  INITIALIZATIONS                                                      DD30  62
#  ---------------                                                      DD30  63
#                                                                       DD30  64
NREC=0;   NREF=0;   ISC=0#                                              DD30  65
IPRINL=IPRINT#                         Pick up refs to print            DD30  66
KEY=1#                                 Set all refs 'observed'          DD30  67
ISERMX=0#                              Zero the maximum serial no.      DD30  68
ENDTAP=no:#                            Signal end of tape               DD30  69
IRECOR=1#                              Record count                     DD30  70
BG1=0.0;   BG2=0.0#                    Default the backgrounds          DD30  71
SCANTM=BGTIME#                         Set default scan times           DD30  72
writeline:(0,0,0,1,3)#                 Space for header                 DD30  73
LINRM=5#                               Force first header               DD30  74
MISGUIDED = no:#                       Assume user is genius            DD30  75
#                                                                       DD30  76
#                                                                       DD30  77
#  PRINT WARNINGS ABOUT SUPPLIED DATA                                   DD30  78
#  ----------------------------------                                   DD30  79
IF(IRAW==yes:&NSCC==0)#                No peak counts available         DD30  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD30  81
writeline:(1,DD314,NDD314,3,3)#        Output warning                   DD30  82
MISGUIDED = yes:#                      Already prepared bdf space for   DD30  83
#                                      Counts, so cannot reset iraw.    DD30  84
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD30  85
#                                                                       DD30  86
#    TEST IF DIFFRACTOMETER FILE USED                                   DD30  87
#    --------------------------------                                   DD30  88
#                                                                       DD30  89
IF(TCODE>0)#                           Test if diff. tape input         DD30  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD30  91
CHRMXP=CHRMAX; LINE=CHRIN#             Hide away the input chars        DD30  92
IF     (TCODE<=4) CALL DD32#           Get 1st nic/cad4 tape record     DD30  93
ELSE IF(TCODE==5) CALL DD33#           Get 1st tsukuba intput record    DD30  94
ELSE IF(TCODE==6) CALL DD34#           Get 1st rigaku  intput record    DD30  95
ELSE IF(TCODE==7) CALL DD35#           Get first record from bdf        DD30  96
ELSE IF(TCODE==8) CALL DD32#           Get first record uwa  p3         DD30  97
ELSE IF(TCODE==9) CALL DD32#           Get first record siemens         DD30  98
ELSE IF(TCODE==10)CALL DD36#           Get first record of bruker       DD30  99
ELSE IF(TCODE==11)CALL DD37#           Get first record of shelx hkl
ELSE IF(TCODE==12)CALL DD37#           Get first record of Rig. Rapid
ELSE IF(TCODE==13)CALL DD37#           Get first record of shelx hkl
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD30 100
#                                                                       DD30 101
#  PLACE THE POINTERS IN AN ARRAY FOR USE IN CHECKING INPUT             DD30 102
#  --------------------------------------------------------             DD30 103
#  WE DO THIS AFTER THE FIRST CALL TO THE DIFFRACTOMETER FILE TO        DD30 104
#  GIVE THE FILE READING SUBROUTINE THE OPPORTUNITY TO ALTER THE        DD30 105
#  THE NS, NH ETC. FLAGS TO REFLECT THE ACTUAL FILE CONTENTS.           DD30 106
#                                                                       DD30 107
INTEST(1)=NS#                                                           DD30 108
INTEST(2)=NH#                                                           DD30 109
INTEST(3)=NK#                                                           DD30 110
INTEST(4)=NL#                                                           DD30 111
INTEST(5)=NSCT#                                                         DD30 112
INTEST(6)=NSCC#                                                         DD30 113
INTEST(7)=NBG1#                                                         DD30 114
INTEST(8)=NBG2#                                                         DD30 115
INTEST(9)=NATN#                                                         DD30 116
INTEST(10)=NFO#                                                         DD30 117
INTEST(11)=NSFO#                                                        DD30 118
INTEST(12)=NIRL#                                                        DD30 119
INTEST(13)=NSIR#                                                        DD30 120
INTEST(14)=NFSQ#                                                        DD30 121
INTEST(15)=NSFS#                                                        DD30 122
INTEST(16)=NTTH#                                                        DD30 123
INTEST(17)=NOMG#                                                        DD30 124
INTEST(18)=NCHI#                                                        DD30 125
INTEST(19)=NPHI#                                                        DD30 126
INTEST(20)=NPBD#                                                        DD30 127
INTEST(21)=NBGT#                                                        DD30 128
#                                      New ones for bruker              DD30 129
INTEST(22)=NPSI#                                                        DD30 130
INTEST(23)=NCP1#                                                        DD30 131
INTEST(24)=NCP2#                                                        DD30 132
INTEST(25)=NCP3#                                                        DD30 133
INTEST(26)=NCD1#                                                        DD30 134
INTEST(27)=NCD2#                                                        DD30 135
INTEST(28)=NCD3#                                                        DD30 136
INTEST(29)=NMON#                                                        DD30 136
#                                                                       DD30 137
#                                                                       DD30 138
#    PROCESS DIFFRACTOMETER FILE                                        DD30 139
#    ---------------------------                                        DD30 140
#                                                                       DD30 141
IF(ENDTAP==no:)#                       Make sure not at end             DD30 142
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DD30 143
REPEAT#                                Loop over records                DD30 144
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DD30 145
IF     (TCODE> 0&ENDTAP==yes:) BREAK#  Quit at tape end                 DD30 146
ELSE IF(TCODE==0&LINID>1)      BREAK#  Or no more data lines            DD30 147
NREC=NREC+1#                           Count up all records read        DD30 148
#                                                                       DD30 149
#  TEST THAT ALL FIELDS WHICH MUST BE NUMBERS HAVE BEEN LOADED          DD30 150
#  -----------------------------------------------------------          DD30 151
#                                                                       DD30 152
DO I=2,28#                             Loop over offset table           DD30 153
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DD30 154
L=INTEST(I)#                           Pick up nh, nk, etc.             DD30 155
IF(L==0)      NEXT#                    Ignore missing                   DD30 156
IF(BUFIN(L)>voidflg:) NEXT#            Keep the input line              DD30 157
CHROT=CHRIP#                           Store input buffer               DD30 158
writeline:(0,DD301,NDD301,2,3)#        Write error message              DD30 159
GOTO 100#                              Skip reflection                  DD30 160
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DD30 161
#                                                                       DD30 162
#  TEST IF INPUT LINE SEEMS VALID IN TERMS OF HKL                       DD30 163
#  -----------------------------------------------                      DD30 164
#                                                                       DD30 165
IF((FLOAT(MOD(NINT(BUFIN(NH)*1024.),1024))>TINY)\ $#                    DD30 166
              (ABS(BUFIN(NH))>511.)\ $#                                 DD30 167
   (FLOAT(MOD(NINT(BUFIN(NK)*1024.),1024))>TINY)\ $#                    DD30 168
              (ABS(BUFIN(NK))>511.)\ $#                                 DD30 169
   (FLOAT(MOD(NINT(BUFIN(NL)*1024.),1024))>TINY)\ $#                    DD30 170
              (ABS(BUFIN(NL))>511.)) GOTO 100# Skip relection           DD30 171
BUFOT(1)=BUFIN(NH)#                    Place h for printing             DD30 172
BUFOT(2)=BUFIN(NK)#                    Ditto k                          DD30 173
BUFOT(3)=BUFIN(NL)#                    Ditto l                          DD30 174
ncodefld:(BUFOT,1,CHROT,RFMT,3)#       Put up hkl for printed outpu     DD30 175
HKL(1)=NINT(BUFIN(NH))#                Get integer h for packing        DD30 176
HKL(2)=NINT(BUFIN(NK))#                And k and l                      DD30 177
HKL(3)=NINT(BUFIN(NL))#                                                 DD30 178
#                                                                       DD30 179
#  TEST IF INPUT REFLECTION CODE IS VALID                               DD30 180
#  --------------------------------------                               DD30 181
#                                                                       DD30 182
IF(NS>0&TCODE<2)#                      Test for reflection codes        DD30 183
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DD30 184
ifvo:(BUFIN(NS))GO TO 100#             Drop when no std flag            DD30 185
movechar:(BLANK,1,BUF,1,6,1)#          Blank input                      DD30 186
IF(BUFIN(NS)<voidflg:)#                Character string ids             DD30 187
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  DD30 188
stringlim:(NS,START,IEND)#             Get character string             DD30 189
NCCT=MIN0(IEND-START,6)#               Get string length                DD30 190
movechar:(CHRIN,START,BUF,1,NCCT,0)#   Move data line ref flag          DD30 191
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  DD30 192
ELSE IF((BUFIN(NS)>(-.1))&(BUFIN(NS)<9.5))# Must be numeric id          DD30 193
ncodefld:(BUFIN,NS,BUF,10113.,1)#      Set up as chars                  DD30 194
ELSE IF((BUFIN(NS)>9.5)&(BUFIN(NS)<99.5))# Two digit                    DD30 195
ncodefld:(BUFIN,NS,BUF,20113.,1)#      Store it                         DD30 196
ELSE GO TO 100#                        Ditch all others                 DD30 197
#                                                                       DD30 198
compchar:(BUF,1,CNTRLS,1,6,6,NCCS,KEY)# Scan reg obs refl               DD30 199
IF(KEY==0)GO TO 100#                   Not one of ours                  DD30 200
KEY=NCCR(KEY)#                         Take users view                  DD30 201
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DD30 202
#                                                                       DD30 203
#  SEARCH LIST OF STANDARD REFLECTIONS                                  DD30 204
#  -----------------------------------                                  DD30 205
#                                                                       DD30 206
ELSE IF(NS==0)#                        Stand/reg flag not available     DD30 207
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  DD30 208
KEY=1#                                 Default to non-standard          DD30 209
DO I=1,USTCNT#                         Loop over user stated stds.      DD30 210
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  DD30 211
IF(HKL(1)!=IHS(1,I)) NEXT#             Skip if no match                 DD30 212
IF(HKL(2)!=IHS(2,I)) NEXT#             Skip if no match                 DD30 213
IF(HKL(3)!=IHS(3,I)) NEXT#             Skip if no match                 DD30 214
KEY=2;    BREAK#                       Mark as std. and get on          DD30 215
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  DD30 216
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  DD30 217
ELSE KEY=NINT(BUFIN(NS))#              Extract refn type 1=norm;2=std   DD30 218
KEY=MAX0(MIN0(KEY,3),1)#               But protect the pgm              DD30 219
#                                                                       DD30 220
#   TEST FOR SENSIBLE SCAN TIME                                         DD30 221
#   ---------------------------                                         DD30 222
#                                                                       DD30 223
IF(NSCT>0)#                            Apply scan time if present       DD30 224
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 DD30 225
IF(BUFIN(NSCT)<TIMMIN)#                                                 DD30 226
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 DD30 227
movechar:(DD306,1,CHROT,57,NDD306,0)#                                   DD30 228
writeline:(0,DD305,NDD305,1,3)#                                         DD30 229
GO TO 100#                             Skip to next input               DD30 230
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 DD30 231
IF(NREF==0) SCANTM0=BUFIN(NSCT)#       Set initial scan time            DD30 232
SCANTM=BUFIN(NSCT)#                    Move scan time for calc          DD30 233
IF(NREF==0) SCANTM0=SCANTM#            Remember first scan time         DD30 234
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 DD30 235
ELSE SCANTM0=SCANTM#                   Dummy value if not present       DD30 236
#                                                                       DD30 237
#   DEAL WITH THE ATTENUATOR PROBLEM                                    DD30 238
#   --------------------------------                                    DD30 239
#                                                                       DD30 240
IATTEN=1#                              Assume its unattenuated          DD30 241
IF(NATN>0)#                            Check if attenuators used        DD30 242
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 DD30 243
IF(BUFIN(NATN)>.5)#                                                     DD30 244
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 DD30 245
movechar:(DD307,1,CHROT,57,NDD307,0)#                                   DD30 246
ncodefld:(BUFIN(NATN),1,CHROT,640213.,1)#                               DD30 247
IATTEN=NINT(BUFIN(NATN)+1)#            Add one for open beam            DD30 248
IF(IATTEN>NUMATT)#                     If not there stop                DD30 249
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 DD30 250
movechar:(DD313,1,CHROT,66,NDD313,0)#  Complain about iatten            DD30 251
writeline:(0,DD305,NDD305,1,3)#        Bitterly write it out            DD30 252
GO TO 100#                             And go on                        DD30 253
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 DD30 254
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 DD30 255
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 DD30 256
#                                                                       DD30 257
#  PROCESS THE SUPPLIED DATA                                            DD30 258
#  -------------------------                                            DD30 259
#                                                                       DD30 260
IF(NBG1>0)BG1=BUFIN(NBG1)#             Move from input buffer           DD30 261
IF(NBG2>0)BG2=BUFIN(NBG2)#             Move from input buffer           DD30 262
#                                                                       DD30 263
IF(NFO>0)#                             Test for f relative              DD30 264
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 DD30 265
BUFOT(4)=BUFIN(NFO)**2#                Square f relative, treat as      DD30 266
IF(NSFO>0)BUFOT(5)=2.0*BUFIN(NFO)*BUFIN(NSFO)# Make sigma(i)            DD30 267
ELSE      BUFOT(5)=RELERR*BUFOT(4)#    Or fake sigma(i)                 DD30 268
RAWSCN=BUFOT(4);  VAR=BUFOT(5)**2#     Fake raw scan counts;varianc     DD30 269
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 DD30 270
#                                                                       DD30 271
ELSE IF(NFSQ>0)#                       Test for frel squared            DD30 272
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 DD30 273
BUFOT(4)=BUFIN(NFSQ)#                  Treat f rel squared as i         DD30 274
IF(NSFS>0)BUFOT(5)=BUFIN(NSFS)#        Get sigma in place               DD30 275
ELSE      BUFOT(5)=RELERR*SQRT(BUFOT(4))# One way or another            DD30 276
RAWSCN=BUFOT(4);  VAR=BUFOT(5)**2#     Fake raw scan counts;varianc     DD30 277
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 DD30 278
#                                                                       DD30 279
ELSE IF(NIRL>0)#                       Test for int relative            DD30 280
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 DD30 281
BUFOT(4)=BUFIN(NIRL)#                  Use intensity straight up        DD30 282
IF(NSIR>0)BUFOT(5)=BUFIN(NSIR)#        Use sigma(i)                     DD30 283
ELSE      BUFOT(5)=RELERR*SQRT(BUFOT(4))# Or fake sigma(i)              DD30 284
RAWSCN=BUFOT(4);  VAR=BUFOT(5)**2#     Fake raw scan counts;varianc     DD30 285
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 DD30 286
#                                                                       DD30 287
#  NOTE NSCC TEST MUST COME LAST                                        DD30 288
#  OTHERWISE NSCC TEST MIGHT INCORRECTLY ASSIGN IREL AND SIGMA(I)       DD30 289
#  THE FOLLOWING RAW COUNT CALCULATIONS ASSUME THAT, IF THE MAIN        DD30 290
#  PEAK IS ATTENUATED, SO ARE THE BACKGROUND MEASUREMENTS.              DD30 291
#                                                                       DD30 292
#                                                                       DD30 293
ELSE IF(NSCC>0)#                       Test for raw data                DD30 294
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 DD30 295
IF(NBGT>0) BGTIME=BUFIN(NBGT)#         Get background time              DD30 296
IF((ABS(BG1-BG2)-(BALAN*SQRT(ABS(BG1+BG2))))>0.)# Check unequal bg      DD30 297
movechar:(DD308,1,CHROT,67,NDD308,0)#  Warn user unequal bg's           DD30 298
QUANT=0.5*SCANTM/BGTIME#               Scale bgds to scan time          DD30 299
BKG=QUANT*(BG1+BG2)*ATTENU(IATTEN)#    Adjust total background          DD30 300
RAWSCN=BUFIN(NSCC)#                    Pick up raw scan counts          DD30 301
SCAN=RAWSCN*ATTENU(IATTEN)#            Get the scan counts              DD30 302
BUFOT(4)=(SCAN-BKG)*SCANTM0/SCANTM#    Calculate the intensity          DD30 303
VAR=BUFIN(NSCC)+QUANT**2*(BG1+BG2)#    The variance in measured i       DD30 304
BUFOT(5)=SQRT(ABS(VAR))*SCANTM0/SCANTM*ATTENU(IATTEN)# Get sigma(i)     DD30 305
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 DD30 306
ELSE iquit:(DD3001)#                   No source of i's                 DD30 307
IF(NSCC>0&IRAW==yes:) RAWSCN=BUFIN(NSCC)# Prefer raw data               DD30 308
IF(NPBD>0) TPBG=BUFIN(NPBD)#           Get ratio peak time/ bkg time    DD30 309
ELSE IF(QUANT>0) TPBG=QUANT#           Use if calculated                DD30 310
ELSE TPBG=2.#                          Otherwise fudge it               DD30 311
#                                                                       DD30 312
#   THIS REFLECTION IS GOING TO BE ACCEPTED                             DD30 313
#   ---------------------------------------                             DD30 314
#                                                                       DD30 315
NREF=NREF+1#                           Count up reflections             DD30 316
IF(NRFN==0)                JREF=NREF#  If no seq nos fake one           DD30 317
ELSE IF(BUFIN(NRFN)<small:)JREF=NREF#  No silly seq nums                DD30 318
ELSE                       JREF=NINT(BUFIN(NRFN))# Pick up diff num     DD30 319
BUFOT(7)=FLOAT(JREF)#                  Pass it to output                DD30 320
ISERMX=MAX0(ISERMX,JREF)#              If not in order                  DD30 321
BUFOT(8)=FLOAT(NREF)#                  Also put out current one         DD30 322
IF((NREF-JREF-ISSEQ)!=0)#              Check for shift in the delta     DD30 323
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 DD30 324
ISSEQ=NREF-JREF#                       Reset the delta                  DD30 325
ncodefld:(FLOAT(ISSEQ),1,DD309,120513.,1)#                              DD30 326
IF(IPRINL>0) movechar:(DD309,1,CHROT,77,NDD309,0)#                      DD30 327
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 DD30 328
#                                                                       DD30 329
#   CHECK IF REFLECTION IS 'OBSERVED'                                   DD30 330
#   ---------------------------------                                   DD30 331
#                                                                       DD30 332
BUFOT(6)=1.0#                          Assume it is observed            DD30 333
IF(BUFOT(4)<=THRESH*BUFOT(5)&THRESH>0.)# Check for less than            DD30 334
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 DD30 335
BUFOT(6)=2.0#                          Below thresh                     DD30 336
IF(SUBTHR==yes:)#                      Check if i to be modified        DD30 337
BUFOT(4)=ABS(THRESH*BUFOT(5))#         Change i to i threshold          DD30 338
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 DD30 339
#                                                                       DD30 340
#   TEST IF STANDARD REFLECTION FLAGGED                                 DD30 341
#   -----------------------------------                                 DD30 342
#                                                                       DD30 343
IF(KEY==2)#                            If a standard reflection         DD30 344
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 DD30 345
BUFOT(6)=4.0#                          Set a silly rcode on it          DD30 346
movechar:(DD312,1,CHROT,41,NDD312,0)#  And tag it in print              DD30 347
DO I=1,ISC#                            Loop over stored standards       DD30 348
IF((IHH(1,I)==HKL(1))&(IHH(2,I)==HKL(2))&(IHH(3,I)==HKL(3)))BREAK#      DD30 349
IF((I>ISC)&(ISC<10)) ISC=I#            Reset coun of different stds     DD30 350
IHH(1,I)=HKL(1);IHH(2,I)=HKL(2);IHH(3,I)=HKL(3)# Save new hkl           DD30 351
IF(I<=smax:)#                          Up to a max of 10                DD30 352
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 DD30 353
L=STOPS;incrqx:(STOPS,STOPS+STEPS,DD3002)#                              DD30 354
intpak:(I,QX(L+1),0,4)#                Standard number                  DD30 355
intpak:(JREF,QX(L+1),4,28)#            Reflection number                DD30 356
QX(L+2)=BUFOT(4)#                      Store irel                       DD30 357
QX(L+3)=VAR#                           Store var(irel)                  DD30 358
QX(L+4)=RAWSCN+BG1+BG2#                Store count sum                  DD30 359
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 DD30 360
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 DD30 361
#                                                                       DD30 362
#   PRINT THE OUTPUT AS REQUESTED                                       DD30 363
#   -----------------------------                                       DD30 364
#                                                                       DD30 365
IF(IPRINL>0)#                                                           DD30 366
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 DD30 367
IPRINL=IPRINL-1#                       Decrement lines out              DD30 368
ncodefld:(BUFOT,1,CHROT,RFMT,8)#       Format first ten items           DD30 369
writeline:(0,DD305,NDD305,1,3)#        Print reflection line            DD30 370
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 DD30 371
#                                                                       DD30 372
#   PUT REFLECTION TO SCRATCH FILEC                                     DD30 373
#   -------------------------------                                     DD30 374
#                                                                       DD30 375
writepkt:(3,lrrefl:,PSIZ,IY)#          Get packet pointer               DD30 376
L=IY+IOFF(1)#                          Set to store hkl in buf          DD30 377
intpak:(IZERO,QX(L),0,mxbtwd:)#        Zero the word                    DD30 378
DO JJ=1,3#                             Loop over hkl                    DD30 379
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 DD30 380
ISIGN=0#                               Assume plus sign                 DD30 381
INDEX=IABS(HKL(JJ))#                   Get magnitude                    DD30 382
IF(HKL(JJ)<0) ISIGN=1#                 Check sign                       DD30 383
I=3-JJ#                                Pack outward in word             DD30 384
intpak:(ISIGN,QX(L),I,1)#              Pack sign bit                    DD30 385
IBIT=I*9+3#                            Find low order bit               DD30 386
intpak:(INDEX,QX(L),IBIT,9)#           Pack mag of index                DD30 387
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 DD30 388
L=IY+IOFF(2);QX(L)=BUFOT(4)#           Store intensity                  DD30 389
L=IY+IOFF(3);QX(L)=BUFOT(5)#           Store sigma intensity            DD30 390
L=IY+IOFF(4)#                          Store rcode                      DD30 391
INDEX=NINT(BUFOT(6));intpak:(INDEX,QX(L),0,4)# Pack rcode               DD30 392
intpak:(JREF,QX(L),4,28)#              Pack serial number               DD30 393
NPRE=4#                                Number previously assigned       DD30 394
IF (IANG==yes:)#                       Are angles needed ?              DD30 395
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 DD30 396
L=IY+IOFF(NPRE+1); QX(L)=BUFIN(NTTH)#  Store twotheta                   DD30 397
L=IY+IOFF(NPRE+2); QX(L)=BUFIN(NOMG)#  Store omega                      DD30 398
L=IY+IOFF(NPRE+3); QX(L)=BUFIN(NCHI)#  Store chi                        DD30 399
L=IY+IOFF(NPRE+4); QX(L)=BUFIN(NPHI)#  Store phi                        DD30 400
NPRE=NPRE+4#                           Increment ptr                    DD30 401
IF (IEUL==yes:)#                       Are eulerian angles requested    DD30 402
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 DD30 403
L=IY+IOFF(NPRE+1);QX(L)=BUFIN(NS)-1.#  Store refln type                 DD30 404
L=IY+IOFF(NPRE+2);QX(L)=FLOAT(JREF)#   Store seq. number                DD30 405
L=IY+IOFF(NPRE+3);QX(L)=BUFIN(NSCT)#   Store exposure time              DD30 406
NPRE=NPRE+3#                           Increment ptr                    DD30 407
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 DD30 408
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 DD30 409
IF (IRAW==yes:)#                       Raw counts should be stored      DD30 410
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 DD30 411
QX(IY+IOFF(NPRE+1))=RAWSCN+BG1+BG2#    Store gross raw counts           DD30 412
QX(IY+IOFF(NPRE+2))=BG1+BG2#           Store total background cts       DD30 413
QX(IY+IOFF(NPRE+3))=TPBG#              Store bckg/peak ratio            DD30 414
NPRE=NPRE+3#                           Increment ptr                    DD30 415
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 DD30 416
IF (IPSI==yes:)#                       Store flack azimuthal psi angl   DD30 417
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 DD30 418
QX(IY+IOFF(NPRE+1))=BUFIN(NPSI)#       Store angle                      DD30 419
NPRE=NPRE+1#                           Increment ptr                  ^^ 
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 DD30 421
IF (ICOS==yes:)#                       Store direction cosines          DD30 422
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 DD30 423
QX(IY+IOFF(NPRE+1))=BUFIN(NCP1)#       Store x primary cosine           DD30 424
QX(IY+IOFF(NPRE+2))=BUFIN(NCP2)#       Store y primary cosine           DD30 425
QX(IY+IOFF(NPRE+3))=BUFIN(NCP3)#       Store z primary cosine           DD30 426
QX(IY+IOFF(NPRE+4))=BUFIN(NCD1)#       Store x diffracted cosine        DD30 427
QX(IY+IOFF(NPRE+5))=BUFIN(NCD2)#       Store y diffracted cosine        DD30 428
QX(IY+IOFF(NPRE+6))=BUFIN(NCD3)#       Store z diffracted cosine        DD30 429
NPRE=NPRE+6#                           Increment ptr                    DD30 430
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 DD30 431
IF (IMONV==yes:)#                      
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 DD30 423
QX(IY+IOFF(NPRE+1))=BUFIN(NMON)#       Store monitor count variation
NPRE=NPRE+1#                           Increment ptr                    DD30 430
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 DD30 431
IF (ISEQ==yes:)#                       Sequence number needed       
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 DD30 423
QX(IY+IOFF(NPRE+1))=FLOAT(JREF)#       Store sequence number
NPRE=NPRE+1#                           Increment ptr                    DD30 430
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 DD30 431
#                                                                       DD30 432
#   READ THE NEXT INPUT LINE                                            DD30 433
#   ------------------------                                            DD30 434
#                                                                       DD30 435
100 CONTINUE#                          This serves for input reject     DD30 436
IF     (TCODE==0) readline:(DD300,NDD300)# Read the next data line      DD30 437
ELSE IF(TCODE<=4) CALL DD32#           Get nic/cad4 tape record         DD30 438
ELSE IF(TCODE==5) CALL DD33#           Get tsukuba intput record        DD30 439
ELSE IF(TCODE==6) CALL DD34#           Get rigaku  intput record        DD30 440
ELSE IF(TCODE==7) CALL DD35#           Get bdf input packet             DD30 441
ELSE IF(TCODE==8) CALL DD32#           Get uwa siemens p3 record        DD30 442
ELSE IF(TCODE==9) CALL DD32#           Get siemens record               DD30 443
ELSE IF(TCODE==10)CALL DD36#           Get bruker record                DD30 444
ELSE IF(TCODE==11)CALL DD37#           Get shelx hkl record
ELSE IF(TCODE==12)CALL DD37#           Get Rig. Rapid f2plus record
ELSE IF(TCODE==13)CALL DD37#           Get shelx hkl record
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DD30 445
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DD30 446
#                                                                       DD30 447
#  RELOAD INPUT LINE BUFFER WHEN IN TAPE MODE                           DD30 448
#  ------------------------------------------                           DD30 449
#                                                                       DD30 450
IF(TCODE>0)#                           See if tape input                DD30 451
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 DD30 452
CHRMAX=CHRMXP; CHRIN=LINE; LINFLG=0#   Restore character buffer         DD30 453
readline:(DD300,NDD300)#               Read next line if data line      DD30 454
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 DD30 455
copyfile:(1,3,incr:(lrrefl:),endrecord:)# Finish off                    DD30 456
#                                                                       DD30 457
#   GIVE A SUMMARY OF REFLECTIONS PROCESSED                             DD30 458
#   ---------------------------------------                             DD30 459
#                                                                       DD30 460
LINRM=6#                               Check room for output            DD30 461
BUFOT(1)=FLOAT(NREF);  BUFOT(2)=FLOAT(JREF)# Store nref and nseq        DD30 462
movechar:(DD311,2,CHROT,2,NDD311-1,1)# Insert * for highlight           DD30 463
writeline:(2,0,0,1,3)#                 Print highlight line             DD30 464
movechar:(DD311,2,CHROT,2,NDD311-1,1)# Insert * for highlight           DD30 465
ncodefld:(BUFOT,1,DD311,FMT,2)#        Format nref and nseq             DD30 466
writeline:(0,DD311,NDD311,2,3)#        Print nref and nseq              DD30 467
writeline:(1,0,0,1,3)#                 Output spacer                    DD30 468
#                                                                       DD30 469
RETURN#                                                                 DD30 470
END#                                                                    DD30 471
systemheader:(DD32)#                   Process nicolet/cad4 file        DD32   1
#********************************************************************   DD32   2
#                                                                       DD32   3
#                               DD32                                    DD32   4
#                                                                       DD32   5
#********************************************************************   DD32   6
SUBROUTINE DD32#                                                        DD32   7
#                    ## 2=cad 3=nic(vax) 4=nic(DG) 8=uwa p3  9=sie      DD32   8
#                                                                       DD32   9
include:(AACOMN)#                      E.n.maslen aug 1983              DD32  10
include:(DDCOMN)#                      S.r.hall sep 1987                DD32  11
#                                                                       DD32  12
string:(SPEC,1)#                                                        DD32  13
string:(CREC,56)#                                                       DD32  14
string:(BUFFER, 150)#                                                   DD32  15
REAL DREC(20)#                                                          DD32  16
INTEGER*4 IBUF(112),IHKL(4)#                                            DD32  17
INTEGER ICOL#                          Collision flag                   DD32  18
INTEGER I,J,K,L,M,N,JREC#              Local index                      DD32  19
REAL BGD,CNT,DELTA,SCAN,SIG#                                            DD32  20
REAL    PHI,OMEGA,KAPPA,CHI#           Diffr. angles                    DD32  21
EQUIVALENCE (DREC(3),IBUF(5))#                                          DD32  22
#                                                                       DD32  23
chardata:(DD1,NI)#                                                      DD32  24
chardata:(DD2," Refn       out of sequence")#                           DD32  25
chardata:(DD3,DATA )#                                                   DD32  26
realdata:(FMT,[100513.,150513.,200513.,250513.,330822.,410822.,#        DD32  27
490822.,570822.,671013.,771012.,800313.])#                              DD32  28
realdata:(ALFA,.87208475)#                                              DD32  29
realdata:(RAD,57.29578)#                                                DD32  30
intdata:(FIRST,-1);   intdata:(LAST,2)#                                 DD32  31
datastuff:#                                                             DD32  32
#                                                                       DD32  33
#    OPEN TAPE FIRST TIME                                               DD32  34
#    --------------------                                               DD32  35
#                                                                       DD32  36
IF(FIRST<0)#                           Test for first entry             DD32  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD32  38
DO I=1,6; IF(COMPID(I^I)==' ') BREAK#  Find length of compid            DD32  39
IF(TCODE==8) OPEN(UNIT=iofm1:,FILE=COMPID(1^I-1)//'.dct',#              DD32  40
FORM='unformatted',STATUS ='old')#                                      DD32  41
ELSE IF(TCODE==9) OPEN(UNIT=iofm1:,FILE=COMPID(1^I-1)//'.sie',#         DD32  42
FORM='formatted',STATUS ='old')#                                        DD32  43
ELSE openfmt:(iofm1:,' ')#             Open diffractometer file         DD32  44
DREC(1)=0.; JREC=0; CHRMAX=70#         Set initial record               DD32  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD32  46
#                                                                       DD32  47
#     INPUT NICOLET RECORDS                                             DD32  48
#     ---------------------                                             DD32  49
#                                                                       DD32  50
IF(TCODE>2)#                           Test if nicolet/siemens data     DD32  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD32  52
FIRST=0;   JREC=JREC+1#                Flag as opened                   DD32  53
IF(TCODE< 8)#                          Nicolet has integer half words   DD32  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DD32  55
readfmt:(iofm1:,'(A)',99,CREC)#        Read diffr 56 char record        DD32  56
movector:(CREC,1,DREC,1,56,0)#         Data into real array             DD32  57
intunpak:(DREC(1),IHKL(1),16,16)#      Unpack integer halfwords         DD32  58
intunpak:(DREC(1),IHKL(2), 0,16)#      Unpack integer halfwords         DD32  59
intunpak:(DREC(2),IHKL(3),16,16)#      Unpack integer halfwords         DD32  60
intunpak:(DREC(2),IHKL(4), 0,16)#      Unpack integer halfwords         DD32  61
DO I=1,4#                              Loop over halfword integers      DD32  62
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DD32  63
IF(IHKL(I)>36863) IHKL(I)=IHKL(I)-65536# Convert negative values        DD32  64
BUFIN(I)=FLOAT(IHKL(I))#               Float miller indices             DD32  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DD32  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DD32  67
ELSE IF(TCODE==8)#                     Siemens p3 integer full words    DD32  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DD32  69
READ(iofm1:,END=99)IBUF#               Read diffr 448 char record       DD32  70
DO I=1,4; BUFIN(I)=FLOAT(IBUF(I))#     Float miller indices             DD32  71
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DD32  72
ELSE IF(TCODE==9)#                     Siemens ascii file               DD32  73
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DD32  74
REPEAT#                                Loop over input buffer           DD32  75
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  DD32  76
READ(iofm1:,'(a)',END=99)BUFFER#       Pick up the profile dat          DD32  77
IF(BUFFER(1^1)==' ') BREAK#            Exit the read look               DD32  78
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  DD32  79
READ(BUFFER,'(f7.0,3f4.0,4f8.2,37x,f15.1,f8.1)',END=99)$#               DD32  80
              (BUFIN(I),I=1,10)#       N h k l t o p c i s              DD32  81
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DD32  82
IF (BUFIN(1)<0.) BUFIN(11)=2.#         Standard reflection              DD32  83
ELSE             BUFIN(11)=1.#         Normal reflection                DD32  84
BUFIN(1)=ABS(BUFIN(1))#                Get reflection number            DD32  85
IF(TCODE==9) GOTO 100#                 Finish for sie data              DD32  86
N=5#                                   Set buffer pointer               DD32  87
FOR(I=3;I<14;I=I+1)#                   Loop over input words            DD32  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  DD32  89
IF(I==7) I=12#                         Skip words 7 to 11               DD32  90
IF(TCODE==3)#                          Data general controller          DD32  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  DD32  92
intunpak:(DREC(I),K,0,24)#             Extract fp fraction              DD32  93
intunpak:(DREC(I),L,24,7)#             Extract fp exponent              DD32  94
intunpak:(DREC(I),M,31,1)#             Extract fp sign                  DD32  95
BUFIN(N)=FLOAT(((-1)**M)*(16**(L-64)))*FLOAT(K)/16777216.#              DD32  96
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  DD32  97
ELSE IF(TCODE==4)#                     Vax controller                   DD32  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 DD32  99
intunpak:(DREC(I),J,0,7)#              Extract fp fraction1             DD32 100
intunpak:(DREC(I),K,16,16)#            Extract fp fraction2             DD32 101
intunpak:(DREC(I),L,7,8)#              Extract fp exponent              DD32 102
intunpak:(DREC(I),M,15,1)#             Extract fp sign                  DD32 103
BUFIN(N)=FLOAT(((-1)**M)*(2**(L-128)))$# Calculate local fp number      DD32 104
*FLOAT(K+J*65536+8388608)/16777216.#   Calculate local fp number        DD32 105
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 DD32 106
ELSE BUFIN(N)=DREC(I)#                 Siemens p3 data                  DD32 107
N=N+1#                                 Incr buffer pointer              DD32 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  DD32 109
ncodefld:(BUFIN,1,CHRIN,FMT,11)#       Format n,hkl,angles,int          DD32 110
movechar:(DD3,1,CHRIN,1,5,0)#          Insert 'data' string             DD32 111
writepch:(CHRIN,80)#                   Punch the data line              DD32 112
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD32 113
#                                                                       DD32 114
#     INPUT CAD4 RECORDS                                                DD32 115
#     ------------------                                                DD32 116
#                                                                       DD32 117
ELSE#                                  Else read cad4 tape              DD32 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 DD32 119
REPEAT#                                Loop over diffr records          DD32 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 DD32 121
CHRCOL=1;    SYNTXF=1;   JREC=JREC+1#  Switch off syntax check          DD32 122
readfmt:(iofm1:,'(a1,A)',99,[SPEC,CHRIN(1^61)])# Read cad4 record       DD32 123
dcodefld:#                             Decode diffractometer record     DD32 124
IF(BUFIN(1)<1.) NEXT#                  Skip garbage numbers             DD32 125
N=NINT(BUFIN(1))#                      Extract record type              DD32 126
IF(N==21&FIRST!=0)#                    Test for start block             DD32 127
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 DD32 128
FIRST=0;   DREC(11)=1.#                Switch off if start block        DD32 129
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 DD32 130
IF(FIRST<1)#                           Test if initial records          DD32 131
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 DD32 132
IF(N==23&CHRIN(6^11)=='AZIMUT') DREC(11)=3.# Phi spin obs.              DD32 133
IF(N==32) FIRST=1#                     Reset first indicator            DD32 134
NEXT#                                                                   DD32 135
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 DD32 136
#                                                                       DD32 137
IF(N==1)#                              Test if record type 1            DD32 138
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 DD32 139
IF(LAST==1\(BUFIN(2)-DREC(1)-1.)>.1)#  Test for correct sequence        DD32 140
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 DD32 141
ncodefld:(BUFIN,2,DD2,110613.,1)#      Format squence number            DD32 142
writeline:(0,DD2,NDD2,3,3)#            Print warning message            DD32 143
DREC(1)=BUFIN(2)#                      Reset record number              DD32 144
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 DD32 145
LAST=1#                                Store record type                DD32 146
DO I=2,5; DREC(I-1)=BUFIN(I)#          Store n, h, k, l                 DD32 147
stringlim:(6,I,K)#                     Get limits of code string        DD32 148
ifne:(DREC(11),3.)#                    If not spin correction           DD32 149
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 DD32 150
compchar:(CHRIN,I,DD1,1,1,1,2,J)#      Test if standard refln           DD32 151
DREC(11)=FLOAT(J)#                     Std=2; other=1                   DD32 152
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 DD32 153
IF(K-I>6)#                             Test if psi is -180.00           DD32 154
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 DD32 155
DO J=79,I+6,-1;CHRIN(J+1^J+1)=CHRIN(J^J)# Shift the string up one pla   DD32 156
CHRIN(I+6^I+6)=' '#                    Insert a space                   DD32 157
dcodefld:#                             Decode the record                DD32 158
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 DD32 159
DREC(9)=BUFIN(7)#                      Store psi angle                  DD32 160
IF(BUFIN(8)>0.) DREC(10)=0.#           No attenuator set                DD32 161
ELSE            DREC(10)=1.#           Attenuator used                  DD32 162
J=NINT(DREC(10))+1#                    Get attenuator index             DD32 163
SCAN=ABS(BUFIN(8))/ATTENU(J)#          Store scan speed/attn            DD32 164
IF(CHRIN(I+1^I+1)=='C') ICOL=yes:#     Test if collision posn           DD32 165
ELSE#                                  There is some data there         DD32 166
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 DD32 167
ICOL=no:#                              No collision                     DD32 168
IF(CHRIN(I+2^I+5)=='PR0F')#            Test if nrc profile data         DD32 169
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 DD32 170
CNT=BUFIN(10)/SCAN#                    Convert peak count               DD32 171
SIG=BUFIN(9)/(100.*SCAN)#              Convert sigma i                  DD32 172
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 DD32 173
ELSE#                                  Peak-background data             DD32 174
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 DD32 175
BGD=(BUFIN(9)+BUFIN(11))*2.#           Store total bg count             DD32 176
CNT=(BUFIN(10)-BGD)/SCAN#              Calc net intensity               DD32 177
SIG=SQRT(BUFIN(10)+2.*BGD)/SCAN#       Calc intensity sigma             DD32 178
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 DD32 179
ifne:(SIGMPI,0.)#                      Test if sigma modified           DD32 180
SIG=SQRT(SIG**2+(SIGMPI*CNT)**2)#      Add sigma enhancement factor     DD32 181
DREC(12)=CNT;      DREC(13)=SIG#       Store net count and sigma        DD32 182
DREC(14)=BUFIN(9); DREC(15)=BUFIN(11)# Store background counts          DD32 183
DREC(16)=BUFIN(10)#                    Gross peak counts                DD32 184
DREC(17)=2.#                           Ratio scan to background time    DD32 185
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 DD32 186
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 DD32 187
#                                                                       DD32 188
ELSE IF(N==2&ICOL==no:)#               Test if record type 2            DD32 189
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 DD32 190
IF(LAST==2\(DREC(1)-BUFIN(2))>small:)# Test for correct sequence        DD32 191
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 DD32 192
ncodefld:(BUFIN,2,DD2,110613.,1)#      Format squence number            DD32 193
writeline:(0,DD2,NDD2,3,3)#            Print warning message            DD32 194
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 DD32 195
LAST=2#                                Store record type                DD32 196
DREC(5)=BUFIN(3)*2.#                   Store 2theta angle               DD32 197
DO I=1,3; DREC(I+5)=BUFIN(I+3)#        Store phi, omega, kappa          DD32 198
IF(IEUL==yes:)#                        Are eulerian angles stored?      DD32 199
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 DD32 200
PHI=BUFIN(4)/RAD#                      Phik in rad                      DD32 201
OMEGA=BUFIN(5)/RAD#                    Omegak in rad                    DD32 202
KAPPA=BUFIN(6)/RAD#                    Kappa in rad                     DD32 203
CHI=2.*ASIN(SIN(ALFA)*SIN(.5*KAPPA))#  Transform kappa to chi           DD32 204
DELTA=ASIN(TAN(.5*CHI)/TAN(ALFA))#     Correction angle                 DD32 205
DREC(6)=(PHI+DELTA)*RAD#               Phib in degr.                    DD32 206
DREC(7)=(OMEGA+DELTA)*RAD#             Omegab in degr.                  DD32 207
DREC(8)=CHI*RAD#                       Chi in degr.                     DD32 208
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 DD32 209
movereal:(DREC,1,BUFIN,1,17,0)#        Store output items               DD32 210
BREAK#                                 Exit from loop                   DD32 211
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 DD32 212
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 DD32 213
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 DD32 214
#                                                                       DD32 215
#    CLOSE IF END OF FILE                                               DD32 216
#    --------------------                                               DD32 217
#                                                                       DD32 218
IF(ENDTAP==no:) GOTO 100#              Test if eof detected             DD32 219
99 CONTINUE#                           Branch point for eof             DD32 220
closefmt:(iofm1:)#                     Close diffractometer file        DD32 221
SYNTXF=0;   ENDTAP=yes:#               Restore syntax flag              DD32 222
100 CONTINUE#                                                           DD32 223
#                                                                       DD32 224
RETURN#                                                                 DD32 225
END#                                                                    DD32 226
systemheader:(DD33)#                   Process tsukuba file             DD33   1
#********************************************************************   DD33   2
#                                                                       DD33   3
#                               DD33                                    DD33   4
#                                                                       DD33   5
#********************************************************************   DD33   6
SUBROUTINE DD33#                       Tsukuba 80 byte ascii file       DD33   7
include:(AACOMN)#                      N spadaccini apr 1990            DD33   8
include:(DDCOMN)#                      Hacked for data probs by
#                                      D. du Boulay june 2002
#                                                                       DD33  10
REAL DREC(80)#                         Diffractometer record buffer     DD33  11
REAL TREC(80)#                         Temporary storage                DD33  12
REAL NMEAS#                            Number of scans                  DD33  13
REAL SCANTM#                           Peak scan time                   DD33  14
REAL SCMON#                            Peak scan monitor counts         DD33  15
REAL B1MON#                            Bkgrd 1 monitor counts           DD33  16
REAL B2MON#                            Bkgrd 2 monitor counts           DD33  17
REAL CORR#                             Peak counts correction           DD33  18
REAL QUANT#                            Scaling quantity                 DD33  19
REAL QUANT2#                           Scaling quantity                 DD33  20
REAL SCMN0#                            Initial scan monitor counts      DD33  21
REAL SCTM0#                            Initial scan time                DD33  22
REAL BG1,BG2,BKG2,RAWSCAN,SCAN,VAR#                                     DD33  23
REAL SMU(61)#
INTEGER LNTAB(50)
INTEGER I,JREC#                                                         DD33  24
INTEGER JATT#                          Attenuator number                DD33  25
INTEGER LSTSPC#                                                         DD33  26
string:(BUF,132)#                      Input data buffer                DD33  27
intdata:(FIRST,-1)#                                                     DD33  28
INTEGER P1,P2
INTEGER PTIN,PTOUT,MXCB,IOFFC,DPT
INTEGER IATEND
INTEGER STEPCB
INTEGER LNREF                         local reflection counter
SAVE FIRST,SCMN0,SCTM0,IATEND,PTIN,PTOUT,LNREF,LNTAB#
CHARACTER MRK
CHARACTER MRK2
datastuff:#                                                             DD33  29
#                                                                       DD33  30
#    OPEN TAPE FIRST TIME                                               DD33  31
#    --------------------                                               DD33  32
#                                                                       DD33  33
STEPCB=20#                             1 counter + data
IOFFC=MAXCB/2#
IF(FIRST<0)#                           Test for first entry             DD33  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD33  35
openfmt:(iofm1:,' ')#                  Open diffractometer file         DD33  36
JREC=0 ; FIRST=0#                      Set initial record               DD33  37
CHRCOL= 1 ; SYNTXF=1#                  Switch off syntax check          DD33  38
IATEND=0#                              initialiZE
PTIN=1#                                start of the circular buffer 
PTOUT=1#                               first reflection out, from here
LNREF=0#                               local NREF
DO I=1,NTABS;LNTAB(I)=NTAB(I)#         Save discontinuity table
#write(6,*) "discons ",NTABS,NTAB(1),NTAB(2),NTAB(3)
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD33  39
#                                                                       DD33  40
#     READ TSUKUBA RECORDS INTO CIRCULAR BUFFER
#     -----------------------------------------
#                                                                       DD33  43
10 CONTINUE#                            branch point for refln skip
IF(PTIN<PTOUT)DPT=ABS(MAXCB)-PTOUT+PTIN
ELSE DPT=PTIN-PTOUT
KKK=0
WHILE(DPT!=IOFFC+1)#                   unfilled buffer so read
$(
IF(IATEND==0)#                         Not finished yet
$(
ISKIP=0
REPEAT#                                loop till we get a valid record
$(
readfmt:(iofm1:,'(A)',99,[BUF])#       Read tsukuba record              DD33  44
IF(BUF(1^6)=='remark'\ BUF(1^6)=='REMARK')NEXT# skip comments
IF(BUF(1^1)==':')$(ISKIP=ISKIP+1; NEXT$)# edit: preserve discon line
IF(BUF(1^2)=='10'\BUF(1^2)==' 5')$(ISKIP=ISKIP+1; NEXT$)# preserve dis
LSTSPC=INDEX(BUF(60^132),' ')#         Find nearest blank               DD33  45
CHRIN=BUF(1^(59+LSTSPC))#              Transfer first part to chrin     DD33  46
dcodefld:#                             Decode first part of record      DD33  47
I=1; REPEAT#                                                            DD33  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD33  49
ifvo:(BUFIN(I)) BREAK#                 Find last field                  DD33  50
I=I+1#                                 Go to next field                 DD33  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD33  52
IF(I>1\IATEND!=0)BREAK#                skip blank lines
$)
IPT=MARKCB+(PTIN-1)*STEPCB#            point to load into
QX(IPT+1)=float(ISKIP)#                  save skips
movereal:(BUFIN,1,QX,IPT+2,I-1,0)#     Transfer values                  DD33  53
CHRIN=BUF(60+LSTSPC^132)#              Get rest of record               DD33  54
dcodefld:#                             Decode rest of record            DD33  55
J=1; REPEAT#                                                            DD33  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD33  49
ifvo:(BUFIN(J)) BREAK#                 Find last field                  DD33  50
J=J+1#                                 Go to next field                 DD33  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD33  52
movereal:(BUFIN,1,QX,IPT+I+1,J-1,0)#     Shift new data into positio   DD33  56
$)
ELSEIF(PTOUT==IATEND)
$(
DO I=1,NTABS;NTAB(I)=LNTAB(I)#        Reset discons if needed
#write(6,*)"discons ",(NTAB(I),I=1,NTABS)
ENDTAP=yes:; RETURN
$)#  FINISH here       
GOTO 100
99 continue#                           EOF detected
closefmt:(iofm1:)#                     Close diffractometer file        DD33  98
SYNTXF=0#                              Restore syntax flag              DD33  99
IATEND=PTIN#                           Save ptr to final reflection
IF(ABS(MAXCB)==1) 
$(
DO I=1,NTABS;NTAB(I)=LNTAB(I)#        Reset discons if needed
#write(6,*)"discons ",(NTAB(I),I=1,NTABS)
ENDTAP=yes:;  RETURN
$)#  FINISH here       
#
100 CONTINUE
PTIN=PTIN+1#                           increment for next virtual read
IF(PTIN>ABS(MAXCB))PTIN=1#             Reset to first
IF(PTIN<PTOUT)DPT=ABS(MAXCB)-PTOUT+PTIN
ELSE          DPT=PTIN -PTOUT
IF(ABS(MAXCB)==1)BREAK#
$)
#
#   READ REQUESTED REFLECTION FROM CIRCULAR BUFFER
#   ----------------------------------------------
#
MRK2=' '
IPT=MARKCB+(PTOUT-1)*STEPCB#           pointer to requested
movereal:(QX,IPT+2,BUFIN,1,STEPCB-1,0)# Copy previous 
LNREF=LNREF+NINT(QX(IPT+1))#           Add skipped refs for discon
DO I=1,NTABS;IF(NTAB(I)-(LNREF+1)==0)# Adjust discons to compensate
$(
MRK2='#'
LNTAB(I)=NREF+1#                       Save discon point 
$)
#
#   CHECK MONITOR COUNTS IF REQUESTED
#   ---------------------------------
#
# this should never really be used because it was a fudge
# to get around some short term hardware problems.
#
IF(MAXCB>0)#                           Monitor count smoothing requested 
$(
IF(CNTTIM>0.0) BUFIN(10)=CNTTIM#       Fudged the peak scan time 
RPK=BUFIN(12)/BUFIN(10)#               almost correct value (J. Hester)
RBG1=BUFIN(13)/BUFIN(11)#              delayed incorrect value (Hester)
RBG2=BUFIN(14)/BUFIN(11)#              delayed incorrect value (Hester)
#
IF(MAXCB==1)#                          Average only across peak and bgd 
$(
IF(CNTTIM>0.0) RAVE=(RBG1+RBG2)/2.#    Fudged the count time         
ELSE           RAVE=(RPK+RBG1+RBG2)/3.#              
RPCNT=(RPK-RAVE)/RAVE#                 percentage fluctuation
IF(CNTTIM<0.0) RAVE=RPK#               just use correct value
$)
ELSEIF(MAXCB>1)#                       Average over refections in CB 
$(
P1=PTOUT-IOFFC;P2=PTOUT+IOFFC#         Initial upper and lower bounds
#
# Determine relevent pointers P1 and P2 given an IOFFC(=3 below) 
# with a MAXCB=7 
#                      P1=3       POUT        P2=9
#            |         v           v     |     v
#            | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 1 | 2 | 
#            |                           |
DO I=1,NTABS
$(
DEL=NTAB(I)-(LNREF+1)#                 NREF is updated afterwards
IF(DEL>IOFFC) NEXT#                    Not in range
IF(DEL<-IOFFC) NEXT#                   Not in range
IF(DEL>=0) P2= PTOUT+DEL#              new upper bound
IF(DEL< 0) P1= PTOUT+DEL+1#            new lower bound (without discon line)
#IF(DEL==0) LNTAB(I)=NREF+1#            Save new discon point 
$)
#                                      allow for input file edge effects
IF(LNREF+1<IOFFC+1) P1=1#               Lower bound moved up
IF(IATEND!=0)#                         Upper bound moved down
$(
II=(IATEND-PTOUT)#                     Should not be here if II=0
IF (II<0)II=MAXCB+II#                    
P2=PTOUT+II-1
$)
SUM=0.0
Do I=P1,P2
$(
K=I
IF(I< 1   )K=MAXCB+I#                  before first CB element
IF(I>MAXCB)K=I-MAXCB#                  after last CB element
IPT=MARKCB+(K-1)*STEPCB+1#             pointer to requested
#IF(CNTTIM>0.00005) PKTIM=CNTTIM#       ideal peak scan time 
#ELSE               PKTIM=QX(IPT+10)#   original peak scan time
#SMU(K)=QX(IPT+12)/PKTIM#               save count rate
SMU(K)=(QX(IPT+13)+QX(IPT+14))/QX(IPT+11)/2.# save bg mon cnt rate
SUM=SUM+SMU(K)#                        accumulate monitor count rates
$)
RAVE=SUM/FLOAT(P2-P1+1)#               Average across reflections
RPCNT=(RPK-RAVE)/RAVE#                 percentage fluctuation
$)
#
XXX=RAVE*BUFIN(10)#                    Smoothed Io monitor counts
IF(ABS(RPCNT)>ABS(THRCUL)) MRK='*'
ELSE                MRK=' '
write(6,'(3I4,6F8.0,F8.4,1X,2A)')(NINT(BUFIN(I)),I=2,4),$#
(BUFIN(I),I=12,14),RPK,RAVE,XXX,RPCNT,MRK,MRK2
BUFIN(12)=XXX#                        Io monitor counts no probs
BUFIN(13)=RAVE*BUFIN(11)#             Correct the background 
BUFIN(14)=RAVE*BUFIN(11)#             Correct the background
BUFIN(18)=RPCNT
$)
#
#   END OF SMOOTHING
#   ----------------
#
PTOUT=PTOUT+1#                         update pointer for next time
IF(PTOUT>ABS(MAXCB))PTOUT=1#           Reset to first
LNREF=LNREF+1
#
IF(MAXCB>0&THRCUL<0.0)#               Monitor count smoothing enabled
IF(ABS(RPCNT) >-THRCUL)
IF(BUFIN(1)>0.5) 
$(
write(6,*) "culled "
GOTO 10#              Cull if normal reflection        DD33  58
$)
#
#  CONTINUE WITH STANDARD DATA TREATMENT
#  -------------------------------------
#
IF(BUFIN(1)>0.5) DREC(1)=1.#           Test if normal reflection        DD33  58
ELSE             DREC(1)=2.#           Set as standard reflection       DD33  59
DO I=2,4 ; DREC(I)=BUFIN(I)#           Store hkl                        DD33  60
NMEAS=BUFIN(6)#                        Number of scans                  DD33  61
SCANTM=BUFIN(10)#                      Peak scan time                   DD33  62
SCMON=BUFIN(12)#                       Peak scan monitor counts         DD33  63
B1MON=BUFIN(13) ; B2MON=BUFIN(14)#     Background monitors counts       DD33  64
CORR=BUFIN(15)#                        Correction to scan counts        DD33  65
ifnv:(BUFIN(16))#                      Deadtime corrections present?    DD33  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DD33  67
CORR=CORR + DEDTM/100.* BUFIN(16) + $# Use correction factor            DD33  68
(DEDTM/100)**2 * BUFIN(17)#            And second order correction      DD33  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DD33  70
ELSE CORR=CORR+(CORR-1.)*DEDTM/100#    Approximate correction           DD33  71
JATT=NINT(BUFIN(5)+1)#                 Attenuator number                DD33  72
IF(NREF==0)#                           If first reflection              DD33  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DD33  74
SCMN0=SCMON#                           Store initial monitor counts     DD33  75
SCTM0=SCANTM#                          Store initial scan time          DD33  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DD33  77
QUANT=.5*SCMON#                        Scale to monitor counts          DD33  78
QUANT2=SCMN0*SCANTM/(SCTM0*SCMON)#     Scale to first reflection        DD33  79
BG1=QUANT*ATTENU(JATT)*QUANT2*BUFIN(8)/(B1MON*NMEAS)# True scale bg1    DD33  80
BG2=QUANT*ATTENU(JATT)*QUANT2*BUFIN(9)/(B2MON*NMEAS)# True scale bg2    DD33  81
RAWSCAN=BUFIN(7)*CORR*ATTENU(JATT)*QUANT2/NMEAS# True peak scan         DD33  82
SCAN=RAWSCAN-BG1-BG2#                  Integrated intensity             DD33  83
DREC(5)=SCAN#                          Store it                         DD33  84
BKG2=(BG1/B1MON+BG2/B2MON)*QUANT#      Scale bkgds for variance         DD33  85
VAR=ATTENU(JATT)*QUANT2*(RAWSCAN*CORR+BKG2)# Variance of intensity      DD33  86
DREC(6)=SQRT(ABS(VAR))#                Sigma(i)                         DD33  87
DREC(7)=BG1#                           Store backgrd 1                  DD33  88
DREC(8)=BG1#                           Store backgrd 2                  DD33  89
DREC(10)=FLOAT(JATT-1)#                Store attenuator number          DD33  90
DO I=1,10; BUFIN(I)=DREC(I)#           Store output items               DD33  91
#                                                                       DD33  92
RETURN#                                                                 DD33 102
END#                                                                    DD33 103
systemheader:(DD34)#                   Process rigaku denki file        DD34   1
#********************************************************************   DD34   2
#                                                                       DD34   3
#                               DD34                                    DD34   4
#                                                                       DD34   5
#********************************************************************   DD34   6
SUBROUTINE DD34#                       Afc5s.dat & afc6s.dat files      DD34   7
include:(AACOMN)#                      S.r. hall feb 91                 DD34   8
include:(DDCOMN)#                                                       DD34   9
#                                                                       DD34  10
string:(BUF,132)#                      File buffer                      DD34  11
REAL DREC(13),SCAN,PK,BG,RT#           Diffractometer record buffer     DD34  12
INTEGER I,NAT#                         Local index                      DD34  13
intdata:(FIRST,-1)#                                                     DD34  14
intdata:(FMT1,[2,8,12,16,20,29,36,38,40,47,52,57,63])#                  DD34  15
intdata:(FMT2,[7,14,21,28,35,41,46,51,69])#                             DD34  16
datastuff:#                                                             DD34  17
#                                                                       DD34  18
#    OPEN TAPE FIRST TIME                                               DD34  19
#    --------------------                                               DD34  20
#                                                                       DD34  21
IF(FIRST<0)#                           Test for first entry             DD34  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD34  23
openfmt:(iofm1:,' ')#                  Open diffractometer file         DD34  24
FIRST=0;     FIELDF=1#                 Set initial record & fixed fmt   DD34  25
CHRCOL=1;    SYNTXF=1;    CHRMAX=70#   Switch off syntax check          DD34  26
REPEAT#                                Skip non-data lines              DD34  27
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD34  28
readfmt:(iofm1:,'(A)',99,[BUF])#       Read diffractometer record       DD34  29
IF(BUF(1^8)=='STANDARD') BREAK#        Exit on start line               DD34  30
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD34  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD34  32
#                                                                       DD34  33
#     INPUT DATA RECORDS                                                DD34  34
#     ------------------                                                DD34  35
#                                                                       DD34  36
readfmt:(iofm1:,'(A)',99,[BUF])#       Read diffr data 132 chars        DD34  37
CHRIN=BUF(1^63)#                       Transfer partial data            DD34  38
DO I=1,13; BUFPNT(I)=FMT1(I)#          Install line format              DD34  39
dcodefld:#                             Decode diffractometer record     DD34  40
IF(BUFIN(1)>0.) DREC(1)=1.#            Refln type is normal             DD34  41
ELSE            DREC(1)=2.#            Refln type is standard           DD34  42
DO I=2,5;       DREC(I)=BUFIN(I)#      Refln number h k l               DD34  43
NAT=NINT(BUFIN(8))+1#                  Store attn number                DD34  44
SCAN=BUFIN(9)#                         Number of scans per peak         DD34  45
PK=BUFIN(10)#                          Peak counts                      DD34  46
BG=BUFIN(11)+BUFIN(12)#                Background counts                DD34  47
DREC(6)=BUFIN(11)#                     Store background 1               DD34  48
DREC(7)=BUFIN(12)#                     Store background 2               DD34  49
#                                                                       DD34  50
CHRIN=BUF(64^132)#                     Transfer partial data            DD34  51
DO I=1,9; BUFPNT(I)=FMT2(I)#           Install line format              DD34  52
dcodefld:#                             Decode diffractometer record     DD34  53
SCAN=BUFIN(6)*ATTENU(NAT)/(4.*SCAN)#   Combine scan speed & attenu      DD34  54
RT=BUFIN(7)/(2.*BUFIN(8))#             Ratio of scan/bg times           DD34  55
DREC(8)=(PK-RT*BG)*SCAN#               Net intensity counts             DD34  56
DREC(9)=SQRT(PK+RT*RT*BG)*SCAN#        Net intensity sigma              DD34  57
DO I=1,4;    DREC(I+9)=BUFIN(I+1)#     2th omega chi phi                DD34  58
DO I=1,13;   BUFIN(I)=DREC(I)#         Restore for dd30                 DD34  59
#                                                                       DD34  60
#    CLOSE IF END OF FILE                                               DD34  61
#    --------------------                                               DD34  62
#                                                                       DD34  63
IF(ENDTAP==no:) GOTO 100#              Test if eof detected             DD34  64
99 CONTINUE#                           Branch point for eof             DD34  65
closefmt:(iofm1:)#                     Close diffractometer file        DD34  66
SYNTXF=0;   FIELDF=0;   ENDTAP=yes:#   Restore variable fields          DD34  67
100 CONTINUE#                                                           DD34  68
#                                                                       DD34  69
RETURN#                                                                 DD34  70
END#                                                                    DD34  71
systemheader:(DD35)#                                                    DD35   1
#********************************************************************** DD35   2
#                                                                       DD35   3
#                                DD35                                   DD35   4
#                                                                       DD35   5
#********************************************************************** DD35   6
SUBROUTINE DD35#                       Raw data already on bdf          DD35   7
include:(AACOMN)#                      J. r. hester july 1995           DD35   8
include:(DDCOMN)#                                                       DD35   9
#                                                                       DD35  10
INTEGER I#                             Local index                      DD35  11
INTEGER IWNT(40)#                      Desired quantities               DD35  12
INTEGER IREL(41)#                      Returned location                DD35  13
INTEGER KEY(4)#                        Required quantity                DD35  14
INTEGER PKSIZ,IQ#                      Local packet size, pointe        DD35  15
REAL HKL(3)#                           Storage for hkl                  DD35  16
intdata:(FIRST,-1)#                    Flag first time                  DD35  17
datastuff:#                                                             DD35  18
#                                                                       DD35  19
#     READ OFF THE INPUT ARCHIVE BDF.                                   DD35  20
#     THIS ROUTINE USES THE FLACK AND BLANC PARAMETERS TO SUPPLY        DD35  21
#     SCANNING DETAILS.  IT COULD BE MODIFIED FOR OTHER SITUATIONS.     DD35  22
#                                                                       DD35  23
#                                                                       DD35  24
IF(FIRST<0)#                           Test for first time              DD35  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD35  26
IWNT(1)=1#                             Hkl                              DD35  27
IWNT(2)=1021#                          Peak counts                      DD35  28
IWNT(3)=1023#                          Left background                  DD35  29
IWNT(4)=1024#                          Right background                 DD35  30
IWNT(5)=1018#                          Reflection type                  DD35  31
IWNT(6)=1026#                          Attenuator code                  DD35  32
IWNT(7)=1047;IWNT(8)=1048;IWNT(9)=1049;IWNT(10)=1050# Flack and blanc   DD35  33
IWNT(11) = 1300; IWNT(12) = 1301#      Integrated intensity + sigma     DD35  34
KEY(1)=1;KEY(2)=12;KEY(3)=12;KEY(4)=0# Only hkl mandatory               DD35  35
#                                                                       DD35  36
indexpkt:(1,lrrefl:,PKSIZ,IQ,0,KEY,IWNT,IREL)# Get positions            DD35  37
IF(KEY(4)<0) iquit:(DD3510)#           Items not found                  DD35  38
FIRST=0#                               Don't do this again              DD35  39
ifeq:(IREL(2),0.0) NSCC = 0#           Don't have this                  DD35  40
ifeq:(IREL(3),0.0) NBG1 = 0#           Don't have this                  DD35  41
ifeq:(IREL(4),0.0) NBG2 = 0#           Don't have this                  DD35  42
ifeq:(IREL(5),0.0) NS   = 0#           Don't have this                  DD35  43
ifeq:(IREL(6),0.0) NATN = 0#           Don't have this                  DD35  44
ifeq:(IREL(7),0.0) NBGT = 0#           Don't have this                  DD35  45
ifeq:(IREL(8),0.0) NSCT = 0#           Don't have this                  DD35  46
ifeq:(IREL(9),0.0) NBGT = 0#           Don't have this                  DD35  47
ifeq:(IREL(10),0.0) NBGT = 0#          Don't have this                  DD35  48
ifeq:(IREL(11),0.0) NIRL = 0#          Not available                    DD35  49
ifeq:(IREL(12),0.0) NSIR = 0#          Not available                    DD35  50
IF(NBGT==0\NSCT==0) NPBD = 0#          No peak/bacground ratio          DD35  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD35  52
#                                                                       DD35  53
#  READ AND STORE A BDF RECORD                                          DD35  54
#                                                                       DD35  55
readwpkt:(1,lrrefl:,PKSIZ,IQ,0)#       Get buffer pointer               DD35  56
IF(IQ==0)#                             Finished input                   DD35  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD35  58
ENDTAP=yes:#                           Flag finish                      DD35  59
RETURN#                                Go back to dd30                  DD35  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD35  61
BUFIN(1) = QX(IQ+IREL(5))#             Get standard code                DD35  62
gethkl:(IQ+IREL(1),HKL)#               Extract hkl                      DD35  63
DO I=1,3;BUFIN(1+I)=HKL(I)#            Transfer to bufin                DD35  64
#                                                                       DD35  65
#     NET PEAK INTENSITY CAN BE CALCULATED ACCORDING TO THE EQUATION    DD35  66
#     IN FLACK AND BLANC, JAC, (1992), IE                               DD35  67
#     POBS = [QOBS - 0.5 CB (LOBS / CL + HOBS / CH)] / CP.              DD35  68
#                                                                       DD35  69
BUFIN(7)=QX(IQ+IREL(3))#               Left background                  DD35  70
BUFIN(8)=QX(IQ+IREL(4))#               Right background                 DD35  71
BUFIN(9)=QX(IQ+IREL(2))#               Raw counts                       DD35  72
BUFIN(10)=QX(IQ+IREL(6))#              Attenuator number                DD35  73
BUFIN(11)=QX(IQ+IREL(8))#              C_b=peak count time              DD35  74
BUFIN(12)=(QX(IQ+IREL(9))+QX(IQ+IREL(10)))/2.# C_l+c_h=background tim   DD35  75
ifne:(BUFIN(12),0.) BUFIN(13)=0.5*BUFIN(11)/BUFIN(12)# Return this as   DD35  76
BUFIN(5) = QX(IQ+IREL(11))#            Integrated intensity             DD35  77
BUFIN(6) = QX(IQ+IREL(12))#            Sigma i                          DD35  78
RETURN#                                                                 DD35  79
END#                                                                    DD35  80
systemheader:(DD36)#                   Process bruker smart area raw    DD36   1
#********************************************************************   DD36   2
#                                                                       DD36   3
#                               DD36                                    DD36   4
#                                                                       DD36   5
#********************************************************************   DD36   6
SUBROUTINE DD36#                       D du boulay 1998                 DD36   7
include:(AACOMN)#                                                       DD36   8
include:(DDCOMN)#                                                       DD36   9
#                                                                       DD36  10
REAL TREC(80)#                         Temporary storage                DD36  11
REAL U(3),Q(3)#                        Reference vector                 DD36  12
REAL E(3),G(3)#                        Flack vectors e,f,g              DD36  13
REAL SINP,COSP,NORM#                                                    DD36  14
REAL COST,SINT,SIN2T,STOL#             Scattering angles                DD36  15
REAL CD1,CD2,CD3,CP1,CP2,CP3#          Direction cosines                DD36  16
INTEGER I,J,JREC#                                                       DD36  17
INTEGER LSTSPC#                                                         DD36  18
INTEGER KPT,LPT#                                                        DD36  19
string:(BUF,256)#                      Input data buffer                DD36  20
intdata:(FIRST,-1)#                                                     DD36  21
datastuff:#                                                             DD36  22
#                                                                       DD36  23
#    OPEN TAPE FIRST TIME                                               DD36  24
#    --------------------                                               DD36  25
#                                                                       DD36  26
IF(FIRST<0)#                           Test for first entry             DD36  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD36  28
openfmt:(iofm1:,' ')#                  Open diffractometer file         DD36  29
JREC=0 ; FIRST=0#                      Set initial record               DD36  30
CHRCOL= 1 ; SYNTXF=1#                  Switch off syntax check          DD36  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD36  32
#                                                                       DD36  33
#     INPUT SAINT RAW FILE                                              DD36  34
#     ---------------------                                             DD36  35
#                                                                       DD36  36
REPEAT#                                                                 DD36  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD36  38
readfmt:(iofm1:,'(A)',99,[BUF])#       Read tsukuba record              DD36  39
IF(BUF(1^1)!='!')BREAK#                Skip comment lines               DD36  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD36  41
KPT=1#                                                                  DD36  42
LPT=1#                                                                  DD36  43
DO J=1,5#                              Grab multiple 80 char buffers    DD36  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DD36  45
LSTSPC=INDEX(BUF(KPT+59^KPT+59+20),' ')# Find nearest blank             DD36  46
CHRIN=BUF(KPT^KPT+58+LSTSPC)#          Transfer first part to chrin     DD36  47
dcodefld:#                             Decode first part of record      DD36  48
I=0; REPEAT#                                                            DD36  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DD36  50
ifvo:(BUFIN(I+1)) BREAK#               Find last field                  DD36  51
I=I+1#                                 Go to next field                 DD36  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DD36  53
IF(I>0)movereal:(BUFIN,1,TREC,LPT,I,0)# Transfer values                 DD36  54
KPT=KPT+58+LSTSPC#                                                      DD36  55
LPT=LPT+I#                                                              DD36  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DD36  57
CHRIN=BUF(1^72)#                       Transfer first part to chrin     DD36  58
#BUFIN(NS)=0#                          NO STANDARDS                     DD36  59
BUFIN(NH)=TREC(NH)#                                                     DD36  60
BUFIN(NK)=TREC(NK)#                                                     DD36  61
BUFIN(NL)=TREC(NL)#                                                     DD36  62
BUFIN(NFSQ)=TREC(NFSQ)#                F^2                              DD36  63
BUFIN(NSFS)=TREC(NSFS)#                Sigma(f^2)                       DD36  64
BUFIN(NCP1)=TREC(NCP1)#                X direction cosines of primary   DD36  65
BUFIN(NCP2)=TREC(NCP2)#                Y direction cosines of primary   DD36  66
BUFIN(NCP3)=TREC(NCP3)#                Z direction cosines of primary   DD36  67
BUFIN(NCD1)=TREC(NCD1)#                X direction cosines of diffrac   DD36  68
BUFIN(NCD2)=TREC(NCD2)#                Y direction cosines of diffrac   DD36  69
BUFIN(NCD3)=TREC(NCD3)#                Z direction cosines of diffrac   DD36  70
STOL= TREC(26)/10000.#                 Sin theta /lambda *10^4          DD36  71
SINT=STOL*WAVE#                        Sin theta                        DD36  72
IF(SINT> 1.0) SINT= 1.0000#                                             DD36  73
IF(SINT<-1.0) SINT=-1.0000#            First quadrant theta             DD36  74
COST=SQRT(1.-SINT*SINT)#               Cos theta                        DD36  75
SIN2T=2.*COST*SINT#                    Sin 2 theta                      DD36  76
#                                                                       DD36  77
#  VECTORS ARE IN DIFFRACT ORTHOG UB BASIS                              DD36  78
#  ---------------------------------------                              DD36  79
#                                                                       DD36  80
CD1=TREC(NCD1)#                        X direction cosines of diffrac   DD36  81
CD2=TREC(NCD2)#                        Y direction cosines of diffrac   DD36  82
CD3=TREC(NCD3)#                        Z direction cosines of diffrac   DD36  83
#                                                                       DD36  84
CP1=TREC(NCP1)#                        X direction cosines of primary   DD36  85
CP2=TREC(NCP2)#                        Y direction cosines of primary   DD36  86
CP3=TREC(NCP3)#                        Z direction cosines of primary   DD36  87
#                                                                       DD36  88
#  FLACK CRYSTAL BASED AZIMUTHAL PSI ANGLE CALCULATION                  DD36  89
#  ---------------------------------------------------                  DD36  90
#                                                                       DD36  91
IF(NINT(TREC(NH))==NINT(TREC(NK))&NINT(TREC(NH))==NINT(TREC(NL)))# H=   DD36  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DD36  93
U(1)= TREC(NH)#                        Define as  h                     DD36  94
U(2)=-TREC(NH)#                        Define as -h                     DD36  95
U(3)= 0.#                              Define as 0                      DD36  96
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DD36  97
ELSE#                                  General refln reference vector   DD36  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DD36  99
U(1)=TREC(NK)-TREC(NL)#                Define as k-l                    DD36 100
U(2)=TREC(NL)-TREC(NH)#                Define as l-h                    DD36 101
U(3)=TREC(NH)-TREC(NK)#                Define as h-k                    DD36 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DD36 103
Q(1)=U(1)*IUB(1)+U(2)*IUB(4)+U(3)*IUB(7)# Calc cartesion x ref q        DD36 104
Q(2)=U(1)*IUB(2)+U(2)*IUB(5)+U(3)*IUB(8)# Calc cartesion y ref q        DD36 105
Q(3)=U(1)*IUB(3)+U(2)*IUB(6)+U(3)*IUB(9)# Calc cartesion z ref q        DD36 106
NORM=SQRT(Q(1)*Q(1)+Q(2)*Q(2)+Q(3)*Q(3))# Get magnitude of q            DD36 107
DO I=1,3;Q(I)=Q(I)/NORM#               Normalize q                      DD36 108
#                                                                       DD36 109
E(1)=-(CD1+CP1)/(2.*COST)#                                              DD36 110
E(2)=-(CD2+CP2)/(2.*COST)#                                              DD36 111
E(3)=-(CD3+CP3)/(2.*COST)#                                              DD36 112
NORM=SQRT(E(1)*E(1)+E(2)*E(2)+E(3)*E(3))# Get magnitude of q            DD36 113
DO I=1,3;E(I)=E(I)/NORM#               Normalize q                      DD36 114
G(1)= (CD2*CP3-CD3*CP2)/SIN2T#         Cross product (d x p)i           DD36 115
G(2)=-(CD1*CP3-CD3*CP1)/SIN2T#         Cross product (d x p)j           DD36 116
G(3)= (CD1*CP2-CD2*CP1)/SIN2T#         Cross product (d x p)k           DD36 117
NORM=SQRT(G(1)*G(1)+G(2)*G(2)+G(3)*G(3))# Get magnitude of q            DD36 118
DO I=1,3;G(I)=G(I)/NORM#               Normalize q                      DD36 119
SINP= Q(1)*E(1)+Q(2)*E(2)+Q(3)*E(3)#                                    DD36 120
COSP= Q(1)*G(1)+Q(2)*G(2)+Q(3)*G(3)#                                    DD36 121
BUFIN(NPSI)=ATAN2(SINP,COSP)*57.29578# Calculate psi angle              DD36 122
#                                                                       DD36 123
#    CLOSE IF END OF FILE                                               DD36 124
#    --------------------                                               DD36 125
#                                                                       DD36 126
IF(ENDTAP==no:) GOTO 100#              Test if eof detected             DD36 127
99 CONTINUE#                           Branch point for eof             DD36 128
closefmt:(iofm1:)#                     Close diffractometer file        DD36 129
SYNTXF=0;   ENDTAP=yes:#               Restore syntax flag              DD36 130
100 CONTINUE#                                                           DD36 131
#                                                                       DD36 132
RETURN#                                                                 DD36 133
END#                                                                    DD36 134
systemheader:(DD37)#                   Read shelx format .hkl file
#********************************************************************   DD37   2
#                                                                       DD37   3
#                               DD37                                    DD37   4
#                                                                       DD37   5
#********************************************************************   DD37   6
SUBROUTINE DD37#                       D. du boulay 2002
include:(AACOMN)#                      
include:(DDCOMN)#                                                       DD37   9
#                                                                       DD37  10
INTEGER H,K,L,IB
REAL   F2,SF2
intdata:(FIRST,-1)#                                                     DD33  28
datastuff:#                                                             DD37  17
#                                                                       DD37  18
#    OPEN TAPE FIRST TIME                                               DD37  19
#    --------------------                                               DD37  20
#                                                                       DD37  21
IF(FIRST<0)#                           Test for first entry             DD37  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD37  23
ENDTAP=no:
openfmt:(iofm1:,FILNAM)
FIRST=no:
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1 
#                                                                      
#     INPUT DATA RECORDS                                               
#     ------------------                                               
#                                                                      
IB=0
IF(TCODE==12)readfmt:(iofm1:,$#
'(3I4,4F14.1)',99,[H,K,L,F2,SF2,X,Y])#
#'(3I4,F10.1,F14.1,F18.1,F10.6,F14.5)',99,[H,K,L,F2,SF2,X,Y,Z])#
ELSE         readfmt:(iofm1:,'(3I4,2F8.2,I4)',99,[H,K,L,F2,SF2,IB])#
IF(TCODE==13)$(SF2=2.*F2*SF2; F2=F2*F2$)# convert ftof2 sftosf2
BUFIN(1)=FLOAT(H)
BUFIN(2)=FLOAT(K)
BUFIN(3)=FLOAT(L)
BUFIN(4)=F2
BUFIN(5)=SF2
BUFIN(6)=FLOAT(IB)
#                                                                     
#    CLOSE IF END OF FILE                                             
#    --------------------                                            
#                                                                    
IF(ENDTAP==no:) GOTO 100#              Test if eof detected             DD37  64
99 CONTINUE#                           Branch point for eof             DD37  65
closefmt:(iofm1:)#                     Close diffractometer file        DD37  66
ENDTAP=yes:#   
100 CONTINUE#                                                           DD37  68
#                                                                       DD37  69
RETURN#                                                                 DD37  70
END#                                                                    DD37  71
systemheader:(DD40)#                                                    DD40   1
#********************************************************************** DD40   2
#                                                                       DD40   3
#                                DD40                                   DD40   4
#                                                                       DD40   5
#********************************************************************** DD40   6
SUBROUTINE DD40#                                                        DD40   7
include:(AACOMN)#                                                       DD40   8
include:(DDCOMN)#                                                       DD40   9
#                                                                       DD40  10
INTEGER J#                             Loop counter for all stds.       DD40  11
INTEGER IHOLD#                         Temp storage for std no.         DD40  12
INTEGER TOTSTD#                        Total number of standards        DD40  13
INTEGER I#                             Count of number of observati     DD40  14
INTEGER K#                             Loop index for stored observ     DD40  15
REAL    S#                             Sum of observed intensities      DD40  16
REAL    SQ#                            Sum of squares of obs int        DD40  17
REAL    TENTY#                         Intensity of a standard          DD40  18
REAL    STENTY#                        Counting sigma i                 DD40  19
REAL    SMAX#                          For finding range of i's         DD40  20
REAL    SMIN#                          Ditto                            DD40  21
INTEGER IP1,IP2,IP3,IP4#               Pointers to plotter position     DD40  22
REAL    AVE#                           Average standard's intensity     DD40  23
REAL    SIGA#                          Std dev of a standard            DD40  24
REAL    RANGE#                         Range of intensities for a s     DD40  25
REAL    DIV#                           Size of a plot point divisio     DD40  26
REAL    FI#                            Real of i above                  DD40  27
REAL FMT1(3)#                          Arrays for formats               DD40  28
REAL OFFS#                             Offset for plot mid pt           DD40  29
#                                                                       DD40  30
chardata:(DD401," Insufficient data for standard XXXX XXXX XXXX ")#     DD40  31
chardata:(DD402,"[ standard       times obs  average I  calc $#         DD40  32
sig(I)  iten/div  plot I  2*sig ave]")#                                 DD40  33
chardata:(DD403,X.*0123456789)#                                         DD40  34
chardata:(DD408," no information on standard reflections, no plots.")#  DD40  35
realdata:(BIG,9999999.)#                                                DD40  36
realdata:(POINTS,78.)#                                                  DD40  37
realdata:(FORM,[360413.,410413.,460413.])#                              DD40  38
realdata:(FMT,[50413.,100413.,150413.,250613.,#                         DD40  39
371022.,491032.,591042.])#                                              DD40  40
datastuff:#                                                             DD40  41
#                                                                       DD40  42
#  SET UP FORMATS FOR HEADING GRAPHS AT MID POINT AND RIGHT             DD40  43
#  --------------------------------------------------------             DD40  44
#                                                                       DD40  45
FMT1(1)=90831.#                        Set left of graph                DD40  46
FMT1(2)=5000.*POINTS+30831.#           Center point                     DD40  47
FMT1(3)=10000.*POINTS+10831.#          Right end point                  DD40  48
OFFS=0.5*POINTS#                       Set center of graph              DD40  49
#                                                                       DD40  50
#  REPORT OUT TREND OF ALL STANDARDS HELD IN MEMORY                     DD40  51
#  ------------------------------------------------                     DD40  52
#                                                                       DD40  53
IF(STOPS<=MARKS)#                      Test if any standards gather     DD40  54
writeline:(1,DD408,NDD408,3,3)#        Swan song                        DD40  55
ELSE#                                  There are some standards         DD40  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD40  57
TOTSTD=(STOPS-MARKS)/STEPS#            Calculate total stds             DD40  58
USESTD=0#                              Count of 'good' stds             DD40  59
FOR(J=1;J<=ISC;J=J+1)#                 Loop over each different std     DD40  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD40  61
I=0#                                   Zero count of times measured     DD40  62
S=0.0;SQ=0.0#                          Zero sums of i and i**2          DD40  63
SMAX=-BIG;SMIN=BIG#                    Set extremes for searching       DD40  64
#                                                                       DD40  65
#  SCAN THROUGH LIST LOOKING FOR JTH STANDARD.                          DD40  66
#  -------------------------------------------                          DD40  67
#                                                                       DD40  68
FOR(K=MARKS;K<STOPS;K=K+STEPS)#        Loop over storage                DD40  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DD40  70
intunpak:(QX(K+1),IHOLD,0,4)#          Pull out standard no.            DD40  71
IF(IHOLD==J)#                          Check if current j               DD40  72
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DD40  73
I=I+1#                                 Count it                         DD40  74
TENTY=QX(K+2)#                         Retrieve the intensity           DD40  75
S=S+TENTY#                             Sum of all observations          DD40  76
SQ=SQ+TENTY**2#                        Sum of squares                   DD40  77
STENTY=2.*SQRT(ABS(QX(K+3)))#          Get out sigma i                  DD40  78
SMAX=AMAX1(SMAX,TENTY+STENTY)#         Seek maximum in i + sigi         DD40  79
SMIN=AMIN1(SMIN,TENTY-STENTY)#         Seek minimum in i - sigi         DD40  80
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DD40  81
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DD40  82
#                                                                       DD40  83
#  CHECK IF THERE ARE ENOUGH MEASUREMENTS TO MAKE PLOT                  DD40  84
#  ---------------------------------------------------                  DD40  85
BUFOT(1)=FLOAT(IHH(1,J))#              Pick up h of std.                DD40  86
BUFOT(2)=FLOAT(IHH(2,J))#              K                                DD40  87
BUFOT(3)=FLOAT(IHH(3,J))#              L                                DD40  88
IREJCT(J)=no:#                         Assume enough measures           DD40  89
IF(I*ISC<((TOTSTD*9)/10))#             Ditch if not all there           DD40  90
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DD40  91
ncodefld:(BUFOT,1,DD401,FORM,3)#       Encode h, k, and l               DD40  92
writeline:(1,DD401,NDD401,3,3)#        Say goodbye                      DD40  93
IREJCT(J)=yes:#                        And mark std as crook            DD40  94
NEXT#                                                                   DD40  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DD40  96
#                                                                       DD40  97
#  CALCULATE THE STATISTICS ON THE JTH STANDARD                         DD40  98
#  --------------------------------------------                         DD40  99
#                                                                       DD40 100
USESTD=USESTD+1#                       Count good ones                  DD40 101
IF(USESTD==1)FIRSTD=J#                 Remember the first               DD40 102
FI=FLOAT(I)#                                                            DD40 103
AVE=S/FI#                              Calculate the mean of all me     DD40 104
SIGA=SQRT(ABS((FI*SQ-S**2)/AMAX1((FI**2-FI),1.0)))# Get standard dev.   DD40 105
SMAX=AMAX1(SMAX,AVE+2.*SIGA)#          Reexamine maximum                DD40 106
SMIN=AMIN1(SMIN,AVE-2.*SIGA)#          And minimum also                 DD40 107
RANGE = (SMAX-SMIN)/DAMPPL#            Get total spread of i            DD40 108
DIV=RANGE/POINTS#                      Get division size                DD40 109
LINRM=10#                              Force space                      DD40 110
BUFOT(4)=FI;BUFOT(5)=AVE;BUFOT(6)=SIGA;BUFOT(7)=DIV#                    DD40 111
BUFOT(8)=AVE-.5*RANGE;BUFOT(9)=AVE#    Store for print                  DD40 112
BUFOT(10)=AVE+.5*RANGE#                                                 DD40 113
RANGE=POINTS/RANGE#                    Set for plotting                 DD40 114
ncodefld:(BUFOT,1,CHROT,FMT,7)#                                         DD40 115
movechar:(DD403,1,CHROT,67,1,1)#       Move x                           DD40 116
movechar:(DD403,2,CHROT,74,1,1)#       Move .                           DD40 117
movechar:(DD403,3,CHROT,77,1,1)#       Move *                           DD40 118
writeline:(1,DD402,NDD402,2,3)#        Write the plot heading           DD40 119
ncodefld:(BUFOT,8,CHROT,FMT1,3)#       Encode min/ave/max               DD40 120
writeline:(0,0,0,1,3)#                                                  DD40 121
#                                                                       DD40 122
IP1=NINT((SMIN-AVE)*RANGE+OFFS)#       Get upper two sigma              DD40 123
IP4=NINT(OFFS)#                        Get average for graph            DD40 124
IP3=NINT((SMAX-AVE)*RANGE+OFFS)#       Get lower two sigma              DD40 125
movechar:(DD403,2,CHROT,IP1,IP3-IP1+1,1)# Plug in character .           DD40 126
movechar:(DD403,3,CHROT,IP4,1,1)#      Plug in character *              DD40 127
writeline:(0,0,0,1,3)#                 Write heading of plot itself     DD40 128
#                                                                       DD40 129
I=0#                                   Set initial digit pointer        DD40 130
FOR(K=MARKS;K<STOPS;K=K+STEPS)#        Loop over all stored data        DD40 131
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DD40 132
intunpak:(QX(K+1),IHOLD,0,4)#          Get reflection id no.            DD40 133
IF(IHOLD!=J) NEXT#                     Check if it is j                 DD40 134
TENTY=QX(K+2)#                         Pick up individual intensity     DD40 135
STENTY=2.*SQRT(ABS(QX(K+3)))#          Estimated sigma(i)               DD40 136
IP1=NINT((TENTY+STENTY-AVE)*RANGE+OFFS)# Get upper s(i) pt              DD40 137
IP2=NINT((TENTY-AVE)*RANGE+OFFS)#      Get measured i pt                DD40 138
IP3=NINT((TENTY-STENTY-AVE)*RANGE+OFFS)# Get lower bound                DD40 139
IP1=MIN0(MAX0(IP1,1),79)#              Protect graph pointer            DD40 140
IP2=MIN0(MAX0(IP2,1),79)#              Protect graph pointer            DD40 141
IP3=MIN0(MAX0(IP3,1),79)#              Protect graph pointer            DD40 142
I=MOD(I+1,10)#                         Get digit pointer                DD40 143
movechar:(DD403,I+4,CHROT,IP4,1,1)#    Plug in character *              DD40 144
movechar:(DD403,2,CHROT,IP1,1,1)#      Plug in character .              DD40 145
movechar:(DD403,2,CHROT,IP3,1,1)#      Plug in character .              DD40 146
movechar:(DD403,1,CHROT,IP2,1,1)#      Plug in character x              DD40 147
writeline:(0,0,0,1,3)#                 Put out line of plot             DD40 148
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DD40 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD40 150
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD40 151
RETURN#                                                                 DD40 152
END#                                                                    DD40 153
systemheader:(DD50)#                                                    DD50   1
#********************************************************************** DD50   2
#                                                                       DD50   3
#                                DD50                                   DD50   4
#                                                                       DD50   5
#********************************************************************** DD50   6
SUBROUTINE DD50#                                                        DD50   7
include:(AACOMN)#                                                       DD50   8
include:(DDCOMN)#                                                       DD50   9
#                                                                       DD50  10
#  SUBROUTINE TO READ INSTRUCTIONS FOR SETTING STANDARDS GROUP          DD50  11
#  SCALE FACTORS, DISCONTINUITIES IN STANDARDS GROUPS, OR               DD50  12
#  SIMPLY READING USER SPECIFIED STANDARDS GROUP SCALE VALUES.          DD50  13
#  J. M. STEWART  APRIL 1983                                            DD50  14
#                                                                       DD50  15
INTEGER I,K,KK,KKK,J#                  Misc. pointers                   DD50  16
INTEGER IHIT#                          For serial no. check             DD50  17
INTEGER IHED#                          For serial headings              DD50  18
INTEGER ISTD1,ISTD2#                                                    DD50  19
INTEGER ISER1,ISER2#                                                    DD50  20
INTEGER IAUTO#                         Automatic scaling flag           DD50  21
INTEGER ISCLF#                         Scale factors forced by user     DD50  22
REAL    TEMP#                                                           DD50  23
#                                                                       DD50  24
chardata:(DD501, DATA   END    SETSCL GENSCL DISCON )#                  DD50  25
chardata:(DD502," discontinuity in scales at group no.")#               DD50  26
chardata:(DD503," defective standards between serial $#                 DD50  27
XXXXXX and XXXXXX ignored.")#                                           DD50  28
chardata:(DD504," previous standards used for final $#                  DD50  29
defective group.")#                                                     DD50  30
chardata:(DD506," intensity scale   std serial  fate of input")#        DD50  31
chardata:(DD507,"ignored")#                                             DD50  32
chardata:(DD508,"accepted")#                                            DD50  33
chardata:(DD509," discontinuity at scale group XXX ending $#            DD50  34
std serial XXXXXX. XXXXXX")#                                            DD50  35
realdata:(SUMI,0.)#                                                     DD50  36
realdata:(FMW,[420613.,530613.])#                                       DD50  37
realdata:(FMS,[141151.,270613.])#                                       DD50  38
realdata:(FMD,[330313.,580613.,660613.])#                               DD50  39
datastuff:#                                                             DD50  40
#                                                                       DD50  41
#  SET UP MINIMAL STANDARDS SCALE FACTORS FOR DEFAULT CALCULATION       DD50  42
#  --------------------------------------------------------------       DD50  43
#                                                                       DD50  44
MARKR=STOPS+STEPS+1;   STEPR=2#        Set up scale array               DD50  45
incrqx:(STOPR,MARKR+STEPR,DD5001)#     Get memory for it                DD50  46
QX(MARKR+1)=1.0;   QX(MARKR+2)=1.0#    Set scale and serial             DD50  47
LINRM=4;IHED=no:#                                                       DD50  48
NGRPS=1;KKK=1#                         There will always be one         DD50  49
IAUTO=no:;ISCLF=no:#                   Deny automatic scaling           DD50  50
ISMTH=5#                               Smooth over +/- 5 scale grou     DD50  51
#                                                                       DD50  52
#  LOOP OVER INPUT UNTIL END LINE FOUND                                 DD50  53
#  -----------------------------------                                  DD50  54
#                                                                       DD50  55
IF(USESTD>0)#                          There must be some standards     DD50  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD50  57
I=MARKS-STEPS#                         Get ready to scan standards      DD50  58
IAUTO=yes:#                            Remember that auto scale don     DD50  59
#                                                                       DD50  60
REPEAT#                                                                 DD50  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD50  62
I=I+STEPS#                             Move to next standard            DD50  63
IF(I>=STOPS) BREAK#                    Quit when all groups treated     DD50  64
intunpak:(QX(I+1),ISTD1,0,4)#          Standard number                  DD50  65
intunpak:(QX(I+1),ISER1,4,28)#         Serial number                    DD50  66
IF(ISTD1!=FIRSTD)NEXT#                 Must be first std                DD50  67
KKK=1;KK=1;SUMI=QX(I+2)#               Start stats                      DD50  68
ISER2=ISER1#                           In case only one std.            DD50  69
#                                                                       DD50  70
REPEAT#                                Loop over all stds               DD50  71
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DD50  72
K=I+STEPS#                             Look ahead in stds               DD50  73
KK=KK+1#                               Prevent infinite loop            DD50  74
IF((K>=STOPS)\(KK>ISC))BREAK#          Don't fall off end               DD50  75
intunpak:(QX(K+1),ISTD2,0,4)#          Find next std no.                DD50  76
IF((ISTD2==FIRSTD)\(KKK>=USESTD))BREAK# Keep in group bounds            DD50  77
IF(IREJCT(ISTD2)==yes:)NEXT#           Ignore rejected                  DD50  78
I=K;intunpak:(QX(K+1),ISER2,4,28)#     Remember serial no.              DD50  79
SUMI=SUMI+QX(K+2)#                     Add up intensities               DD50  80
KKK=KKK+1#                             Count as used                    DD50  81
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DD50  82
#                                                                       DD50  83
#  CHECK THAT A COMPLETE GROUP WAS PRESENT                              DD50  84
#  ---------------------------------------                              DD50  85
#                                                                       DD50  86
IF(((ISER2-ISER1+1)>ISC)\(KKK!=USESTD))#                                DD50  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DD50  88
BUFOT(1)=FLOAT(ISER1);BUFOT(2)=FLOAT(ISER2)# Float serials              DD50  89
ncodefld:(BUFOT,1,DD503,FMW,2)#                                         DD50  90
writeline:(1,DD503,NDD503,3,3)#        Warn the user                    DD50  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DD50  92
ELSE#                                                                   DD50  93
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DD50  94
K=STOPR;incrqx:(STOPR,STOPR+STEPR,DD5002)# Expand memory                DD50  95
NGRPS=NGRPS+1#                         Count up groups                  DD50  96
QX(K+1)=SUMI#                          Save intensity sum               DD50  97
QX(K+2)=FLOAT(ISER2)#                  Save last member serial no.      DD50  98
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DD50  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD50 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD50 101
#                                                                       DD50 102
#  EXTRACT INSTRUCTIONS FROM THE GENSCL INPUT LINE                      DD50 103
#  ----------------------------------------------                       DD50 104
#                                                                       DD50 105
IF(LINID==4)#                          Process **genscl** line          DD50 106
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DD50 107
IF((BUFIN(1)>0.0)&(BUFIN(1)<11.0))ISMTH=NINT(BUFIN(1))#                 DD50 108
readline:(DD501,NDD501)#               Input next line                  DD50 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DD50 110
#                                                                       DD50 111
#  PUT IN A FINAL SCALE NUMBER TO COMPLETE THE TABLE                    DD50 112
#  AND STORE THE MAXIMUM SERIAL NUMBER AT THE END OF THE TABLE          DD50 113
# ------------------------------------------------------------          DD50 114
#                                                                       DD50 115
K=STOPR;incrqx:(STOPR,STOPR+STEPR,DD5002)# Get memory                   DD50 116
QX(K+2)=FLOAT(ISERMX)#                 Save the last of the last        DD50 117
IF(((ISER2-ISER1+1)>ISC)\(KKK!=USESTD))# Check bad final group          DD50 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  DD50 119
KK=K-STEPR#                            Look back for help               DD50 120
QX(K+1)=QX(KK+1)#                      Pick up penultimate sumi         DD50 121
writeline:(0,DD504,NDD504,3,3)#        Warn user                        DD50 122
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  DD50 123
ELSE QX(K+1)=SUMI#                     Save sum of i stds               DD50 124
NGRPS=NGRPS+1#                         Count the addition               DD50 125
#                                                                       DD50 126
#  CHECK THAT THERE ARE ENOUGH SCALE GROUPS TO DO STATISTICS            DD50 127
#  ---------------------------------------------------------            DD50 128
#                                                                       DD50 129
IF(NGRPS>2)#                                                            DD50 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  DD50 131
I=MARKR+STEPR#                         Point to second entry            DD50 132
TEMP=QX(I+1)#                          Pick up the sumi of grp 2        DD50 133
QX(I+1)=1.0#                           Define scale two as 1.0          DD50 134
KK=I+STEPR#                                                             DD50 135
DO K=3,NGRPS#                                                           DD50 136
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  DD50 137
QX(KK+1)=TEMP/QX(KK+1)#                Make a scale factor of sumi      DD50 138
KK=KK+STEPR#                           And having writ move on          DD50 139
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  DD50 140
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  DD50 141
#                                                                       DD50 142
#  READ FURTHER INPUT LINES IF PRESENT                                  DD50 143
#  -----------------------------------                                  DD50 144
#                                                                       DD50 145
REPEAT#                                Loop over input lines            DD50 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 DD50 147
IF(LINID==2) BREAK#                    Quit at end line                 DD50 148
#                                                                       DD50 149
IF(LINID==3)#                          Process **setscl** line          DD50 150
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 DD50 151
IF(IHED==no:)#                         Test if here before              DD50 152
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 DD50 153
IHED=yes:#                             Switch off                       DD50 154
writeline:(1,DD506,NDD506,3,3)#                                         DD50 155
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 DD50 156
#                                                                       DD50 157
IF((BUFIN(1)>small:)&(BUFIN(2)>=1.0)& $#                                DD50 158
(BUFIN(2)<=FLOAT(ISERMX)))#                                             DD50 159
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 DD50 160
IHIT=no:#                              Assume scale no good             DD50 161
IF(IAUTO==no:)#                        See if no scale factors forc     DD50 162
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 DD50 163
NGRPS=NGRPS+1#                         Count up standards groups        DD50 164
ISCLF=yes:#                            Remember that this happened      DD50 165
I=STOPR;incrqx:(STOPR,STOPR+STEPR,DD5002)# Get storage                  DD50 166
QX(I+1)=BUFIN(1);QX(I+2)=BUFIN(2)#     Store scale and serial           DD50 167
IHIT=yes:#                             Mark accepted                    DD50 168
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 DD50 169
ELSE#                                  Scales already in memory         DD50 170
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 DD50 171
FOR(I=MARKR;I<=STOPR;I=I+STEPR)#       Loop over all groups             DD50 172
ifeq:(BUFIN(2),QX(I+2),0.1)#           Test ending serial no.           DD50 173
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 DD50 174
QX(I+1)=BUFIN(1)#                      Force the scale for group        DD50 175
IHIT=yes:#                             Keep score                       DD50 176
BREAK#                                 And get out to do next           DD50 177
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 DD50 178
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 DD50 179
ncodefld:(BUFIN,1,CHROT,FMS,2)#        Encode scale, serial no.         DD50 180
IF(IHIT==no:) movechar:(DD507,1,CHROT,31,NDD507,0)# Ignored             DD50 181
ELSE          movechar:(DD508,1,CHROT,31,NDD508,0)# Accepted            DD50 182
writeline:(0,DD506,NDD506,1,3)#        Echo scale factor                DD50 183
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 DD50 184
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 DD50 185
#                                                                       DD50 186
#  SET UP DISCONTINUITY POINTS IN STANDARDS                             DD50 187
#  ---------------------------------------                              DD50 188
#                                                                       DD50 189
ELSE IF(LINID==5)#                     **discon** line entered          DD50 190
FOR(I=1;I>0;I=I+1)#                    Loop over input fields           DD50 191
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 DD50 192
IF(BUFIN(I)<=0.0)BREAK#                Stop when data stops             DD50 193
IF(NTABS>48) NEXT#                     Table only 50 long               DD50 194
NTABS=NTABS+1#                                                          DD50 203
NTAB(NTABS)=BUFIN(I)#                  Save the group pointer           DD50 204
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 DD50 210
readline:(DD501,NDD501)#               Replenish the buffer             DD50 211
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 DD50 212
#
# CHECK DISCONTINUITIES
# ---------------------
#
L=NTABS;NTABS=0#
FOR(I=1;I<=L;I=I+1)#                   Loop over discontinuities
$(
J=0#                                   Zero group count                 DD50 195
FOR(K=MARKR;K<STOPR;K=K+STEPR)#        Loop over standards              DD50 196
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 DD50 197
J=J+1#                                 Count groups                     DD50 198
IF(QX(K+2)>=NTAB(I))BREAK#             Seek to match serials            DD50 199
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 DD50 200
IF(J>1)#                               Its got to make sense            DD50 201
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 DD50 202
BUFOT(1)=FLOAT(J);BUFOT(2)=NTAB(I)#    Group and serial                 DD50 205
BUFOT(3)=QX(K+2)#                      Dump table value too             DD50 206
ncodefld:(BUFOT,1,DD509,FMD,3)#                                         DD50 207
writeline:(0,DD509,NDD509,3,3)#        Echo tab setting                 DD50 208
NTABS=NTABS+1#                         increment valid count
NTAB(NTABS)=J#                         Save the group pointer           DD50 204
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 DD50 209
$)
#                                                                       DD50 213
#  IF THERE ARE NO SCALE FACTORS AT ALL SET LAST SCALE AS WELL          DD50 214
#  -----------------------------------------------------------          DD50 215
#                                                                       DD50 216
IF(USESTD<=0)#                         Test for no standards            DD50 217
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 DD50 218
I=STOPR;incrqx:(STOPR,STOPR+STEPR,DD5002)# Get memory                   DD50 219
QX(I+1)=1.0;QX(I+2)=FLOAT(ISERMX)#     Set end scale and serial         DD50 220
NGRPS=NGRPS+1#                         Increase group count             DD50 221
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 DD50 222
#                                                                       DD50 223
#  PUT ONE ADDITIONAL ENTRY IN SCALE TABLE TO ALLOW FOR INTERPOLATION   DD50 224
#  -------------------------------------------------------------------  DD50 225
#                                                                       DD50 226
I=STOPR-STEPR;K=STOPR;incrqx:(STOPR,STOPR+STEPR,DD5002)# Memory         DD50 227
QX(K+1)=QX(I+1)#                       Same scale                       DD50 228
QX(K+2)=QX(I+2)+FLOAT(ISC)#            More serial numbers              DD50 229
writeline:(1,0,0,3,3)#                 Force a blank line               DD50 230
IF(NTABS<=0)#                                                           DD50 231
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 DD50 232
NTABS=1;    NTAB(NTABS)=NGRPS#                                          DD50 233
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 DD50 234
ELSE#                                                                   DD50 235
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 DD50 236
NTABS=NTABS+1#                         Count last tab                   DD50 237
NTAB(NTABS)=NGRPS#                     Set upper limit for sure         DD50 238
LINRM=4#                               Be sure it will go               DD50 239
FOR(J=1;J<=NTABS;J=J+1)#               Loop over whole table            DD50 240
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 DD50 241
NTAB(J)=MIN0(NGRPS,NTAB(J))#           Don't let it fall off            DD50 242
BUFOT(1)=FLOAT(NTAB(J))#                                                DD50 243
ncodefld:(BUFOT,1,CHROT,360313.,1)#                                     DD50 244
writeline:(0,DD502,NDD502,1,3)#        Display tabs                     DD50 245
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 DD50 246
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 DD50 247
#                                                                       DD50 248
RETURN#                                                                 DD50 249
END#                                                                    DD50 250
systemheader:(DD60)#                                                    DD60   1
#********************************************************************** DD60   2
#                                                                       DD60   3
#                                DD60                                   DD60   4
#                                                                       DD60   5
#********************************************************************** DD60   6
SUBROUTINE DD60#                                                        DD60   7
include:(AACOMN)#                                                       DD60   8
include:(DDCOMN)#                                                       DD60   9
#                                                                       DD60  10
#  SUBPROGRAM TO SMOOTH THE STANDARD REFLECTION GENERATED               DD60  11
#  SCALE FACTORS AND TO WRITE OUT ADJUSTED INTENSITY                    DD60  12
#  DATA FOR ALL OBSERVATIONS.                                           DD60  13
#  THIS CODE WAS TAKEN FROM DATCO5 OF THE XRAY SYSTEM.                  DD60  14
#  THE SMOOTHING ALGORITHM WAS FROM THE CRYSTALLOGRAPHERS               DD60  15
#  AT THE UNIVERSITY OF GENEVA.  THE CONCEPT OF SETTING 'TABS'          DD60  16
#  HAS BEEN INTRODUCED IN THIS XTAL PROGRAM TO ALLOW SMOOTHING          DD60  17
#  OVER GROUPS OF SCALE FACTORS.  THIS ALLOWS FOR DISCONTINUITIES       DD60  18
#  IN DATA GATHERING.                                                   DD60  19
#  J. M. STEWART APRIL 1983                                             DD60  20
#                                                                       DD60  21
# ACCORDING TO THE UNIVERSITY OF GENEVA, IF THERE ARE ONLY              DD60  22
# A FEW DIFFERENT STANDARD REFLECTIONS THE SCALE FACTORS WILL           DD60  23
# REQUIRE SMOOTHING.  IF NO SMOOTHING IS DONE THE SCALE FACTOR          DD60  24
# VARIATIONS TEND TO BE DUE MAINLY TO STATISTICAL COUNTING              DD60  25
# FLUCTUATIONS.  THIS CAUSES SENSELESS VARIATIONS IN THE                DD60  26
# SUCCESSIVE GROUP SCALES GENERATED FROM THE STANDARDS.                 DD60  27
# THIS EFFECT CAN LEAD TO NEGATIVE STABILITY CONSTANTS.                 DD60  28
# THE SMOOTHING DONE IS 'SIMPLE-MINDED'.  IT WORKS BY FINDING           DD60  29
# THE AVERAGE OF THE ISMTH PREVIOUS AND ISMTH FOLLOWING                 DD60  30
# GROUP SCALES AND APPLYING THIS AVERAGE TO THE CURRENT SCALE.          DD60  31
# THIS WILL DAMP OUT ANY NON TRENDING VALUES IN THE SCALE FACTORS.      DD60  32
#                                                                       DD60  33
REAL AVE#                              Average scale                    DD60  34
REAL PFACT#                            Scaling factor for smoothing     DD60  35
INTEGER J,J1,J2,JJ1,JJ2,K,KK#          Pointers for smoothing           DD60  36
INTEGER NSTART,NSTOP#                  Dynamic tabs                     DD60  37
#                                                                       DD60  38
chardata:(DD601," scale group  raw I scale factor       std serial")#   DD60  39
chardata:(DD602,"discontinuity")#                                       DD60  40
chardata:(DD603," scale group  smoothed I scale factor  std serial")#   DD60  41
chardata:(DD604," Standard scales are smoothed over XX scale groups")#  DD60  42
chardata:(DD605," Standard scales are not applied to intensity data")#  DD60  43
realdata:(FMT,[80413.,231052.,481013.])#                                DD60  44
datastuff:#                                                             DD60  45
#                                                                       DD60  46
# PRINT OUT THE RAW SCALE FACTORS                                       DD60  47
# -------------------------------                                       DD60  48
#                                                                       DD60  49
KK=MARKR-STEPR;    J=1#                Set a running pointer            DD60  50
LINRM=6#                               Force first header               DD60  51
movechar:(DD602,1,CHROT,50,NDD602,0)#  Discontinuity at start           DD60  52
DO K=1,NGRPS#                          Loop over scale groups           DD60  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD60  54
KK=KK+STEPR#                           Advance storage                  DD60  55
BUFOT(1)=FLOAT(K-1);BUFOT(2)=QX(KK+1);BUFOT(3)=QX(KK+2)#                DD60  56
ncodefld:(BUFOT,1,CHROT,FMT,3)#                                         DD60  57
IF((NTAB(J)==K)&(J<=NTABS))#           Find discontinuities             DD60  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD60  59
movechar:(DD602,1,CHROT,50,NDD602,0)#  Tell user                        DD60  60
J=J+1#                                 Having writ, move on             DD60  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD60  62
writeline:(0,DD601,NDD601,1,3)#        Print raw scales                 DD60  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD60  64
#                                                                       DD60  65
#  PREPARE SMOOTHED SCALE FACTORS                                       DD60  66
#  ------------------------------                                       DD60  67
#                                                                       DD60  68
IF(IAPPLY==no:) writeline:(2,DD605,NDD605,2,3)# Print no scales         DD60  69
ELSE#                                  Apply scaling                    DD60  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DD60  71
ncodefld:(FLOAT(ISMTH),1,DD604,370213.,1)# Format scale smoothing       DD60  72
writeline:(2,DD604,NDD604,2,3)#        Print scale smoothing            DD60  73
#                                                                       DD60  74
PFACT=1.0/FLOAT(2*ISMTH+1)#            Prepare 1/n for ave              DD60  75
NSTART=1#                              Always start with group one      DD60  76
FOR(J=1;J<=NTABS;J=J+1)#               Loop over all tabs               DD60  77
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DD60  78
NSTOP=NTAB(J)#                         Pick up the last member          DD60  79
#                                                                       DD60  80
#  SET THE BASE AVERAGE FROM SCALE OF THE FIRST GROUP.                  DD60  81
#  ---------------------------------------------------                  DD60  82
#                                                                       DD60  83
JJ1=(NSTART-1)*STEPR+MARKR#            Find first at tab                DD60  84
AVE=FLOAT(ISMTH+1)*QX(JJ1+1)#                                           DD60  85
DO K=1,ISMTH#                          Loop over smoothing interval     DD60  86
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DD60  87
J1=NSTART+K-1#                                                          DD60  88
IF(J1>NSTOP) J1=NSTOP#                 Keep in bounds                   DD60  89
JJ1=(J1-1)*STEPR+MARKR#                Get out a pointer                DD60  90
AVE=AVE+QX(JJ1+1)#                     Sum group scales                 DD60  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DD60  92
AVE=AVE*PFACT#                         Get average scale                DD60  93
#                                                                       DD60  94
# CALCULATE FOR THE KTH SCALE BY ADDING ON THE                          DD60  95
# SCALE OF THE K + ISMTH AND SUBTRACTING OFF THE SCALE                  DD60  96
# OF THE K - ISMTH GROUP.                                               DD60  97
# ------------------------------------------------------                DD60  98
#                                                                       DD60  99
DO K=NSTART,NSTOP#                     Loop over each set of scales     DD60 100
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DD60 101
J1=K-ISMTH#                            Look back                        DD60 102
IF(J1<NSTART)J1=NSTART#                But not too far back             DD60 103
J2=K+ISMTH#                            Look ahead                       DD60 104
IF(J2>NSTOP)J2=NSTOP#                  But carefully                    DD60 105
JJ1=(J1-1)*STEPR+MARKR;JJ2=(J2-1)*STEPR+MARKR#                          DD60 106
AVE=AVE+PFACT*(QX(JJ2+1)-QX(JJ1+1))#   Adjust the average               DD60 107
KK=(K-1)*STEPR+MARKR#                  Find the group                   DD60 108
QX(KK+1)=AVE#                          Damp the scale factor            DD60 109
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DD60 110
NSTART=NSTOP+1#                        Go on to next group              DD60 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DD60 112
#                                                                       DD60 113
# PRINT OUT THE SMOOTHED SCALE FACTORS                                  DD60 114
# ------------------------------------                                  DD60 115
#                                                                       DD60 116
KK=MARKR-STEPR;   J=1#                 Set a running pointer            DD60 117
LINRM=6#                               Force first header               DD60 118
movechar:(DD602,1,CHROT,50,NDD602,0)#  Discontinuity at start           DD60 119
DO K=1,NGRPS#                          Loop number of scale groups      DD60 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  DD60 121
KK=KK+STEPR#                           Advance storage                  DD60 122
BUFOT(1)=FLOAT(K-1);BUFOT(2)=QX(KK+1);BUFOT(3)=QX(KK+2)#                DD60 123
ncodefld:(BUFOT,1,CHROT,FMT,3)#                                         DD60 124
IF((NTAB(J)==K)&(J<=NTABS))#           Find discontinuities             DD60 125
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  DD60 126
movechar:(DD602,1,CHROT,50,NDD602,0)#  Tell user                        DD60 127
J=J+1#                                 Having writ, move on             DD60 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  DD60 129
writeline:(0,DD603,NDD603,1,3)#        Print smoothed scale             DD60 130
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  DD60 131
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DD60 132
#                                                                       DD60 133
#                                                                       DD60 134
RETURN#                                                                 DD60 135
END#                                                                    DD60 136
systemheader:(DD70)#                                                    DD70   1
####################################################################### DD70   2
#                                                                       DD70   3
#                               DD70                                    DD70   4
#                                                                       DD70   5
####################################################################### DD70   6
SUBROUTINE DD70#                                                        DD70   7
include:(AACOMN)#                                                       DD70   8
include:(DDCOMN)#                                                       DD70   9
#                                                                       DD70  10
#  THIS SUBROUTINE IS USED TO ESTIMATE THE DATA INSTABILITY             DD70  11
#  CONSTANTS.  THESE CONSTANTS ARE USED IN SETTING UP WEIGHTS           DD70  12
#  FOR USE IN LATER ATOMIC PARAMETER LEAST-SQUARES REFINEMENT.          DD70  13
#  THE SUBROUTINE USES THE TOTAL COUNTS OBSERVED FOR THE                DD70  14
#  STANDARD REFLECTIONS OVER THE WHOLE DATA GATHERING TIME.             DD70  15
#  THE ALGORITHM IS BASED ON THE CODE OF H. AMMON IN DATCO5             DD70  16
#  OF THE XRAY SYSTEM.  IT FOLLOWS JENSEN AND STOUT.                    DD70  17
#  THE METHOD MAKES A LEAST-SQUARES ANALYSIS OF THE VARIATION           DD70  18
#  IN THE TOTAL COUNTS FOR THE UNRESCALED STANDARDS OVER THE            DD70  19
#  WHOLE DATA GATHERING PROCESS.  THE RESULTS OF THE ANALYSIS           DD70  20
#  ARE APPLIED TO THE SIGMA(I) BASED ON INDIVIDUAL REFLECTION           DD70  21
#  COUNTING STATISTICS.  THE PROCESS INCREASES THE SIGMA(I).            DD70  22
#                                                                       DD70  23
#  THERE ARE FOUR OPTIONS:                                              DD70  24
#                                                                       DD70  25
#  1.  CALCULATE A FACTOR BASED ON THE SCATTER OF THE STANDARDS.        DD70  26
#                                                                       DD70  27
#  2.  CALCULATE TWO FACTORS BASED ON THE SCATTER AND TREND IN          DD70  28
#      THE STANDARDS.  A LEAST-SQUARES LINE THROUGH THE                 DD70  29
#      STANDARDS AS A FUNCTION OF TIME.                                 DD70  30
#                                                                       DD70  31
#  3.  LIKE 2. BUT THE INTERCEPT IS FORCED TO ZERO.                     DD70  32
#                                                                       DD70  33
#  4.  USE VALUES FOR THE SLOPE FACTOR AND THE INTERCEPT FACTOR         DD70  34
#      WHICH ARE SUPPLIED BY THE USER IN THE DIFDAT INPUT LINE.         DD70  35
#                                                                       DD70  36
#  J. M. STEWART APRIL 1983                                             DD70  37
#                                                                       DD70  38
#  IF COUNTS FOR ANY STANDARD VARY BY MORE THAN 30 PERCENT              DD70  39
#  THAT STANDARD IS NOT USED FOR INSTABILITY CALCULATION                DD70  40
#  THIS IS TO AVOID SITUATION IN WHICH USE OF ATTENUATOR                DD70  41
#  OR DIFFERING SCAN SPEEDS MAKE RAW COUNTS INCOMPATIBLE                DD70  42
#                                                                       DD70  43
#  J. R. HESTER MAY 1993                                                DD70  44
#                                                                       DD70  45
REAL AVERAG(smax:)# ## Calculated average tot counts                    DD70  46
REAL DENOM#         ## Denominator temp.                                DD70  47
REAL RAWSUM(smax:)# ## Sum for average                                  DD70  48
REAL SSIGMA(smax:)# ## Calc std dev in total counts                     DD70  49
REAL VARI(smax:)#   ## Summations of variances of tot counts            DD70  50
REAL X#             ## X for least squares line                         DD70  51
REAL Y#             ## Y for least squares lines                        DD70  52
REAL SUMYX#         ## Sum of xy product for l-s lines                  DD70  53
REAL SUMX#          ##                                                  DD70  54
REAL SUMY#          ##                                                  DD70  55
REAL SUMXSQ#        ##                                                  DD70  56
REAL A2#            ## Temp store average tot counts                    DD70  57
INTEGER NGO#        ## Number of different options pointer              DD70  58
INTEGER I,K,NQ,J#   ## Loop control                                     DD70  59
INTEGER NSTD(smax:)## Number of observations of stds                    DD70  60
INTEGER GSTD(smax:)## Flag use of Irel instead of Rawscn                DD70  61
#                                                                       DD70  62
chardata:(DD701," Instability factors determined from$#                 DD70  63
 -- standard reflections")#                                             DD70  64
chardata:(DD702,-)#                                                     DD70  65
chardata:(DD703,"[ Option 0.  From total counts  (scan counts$#         DD70  66
 + both backgrounds)]")#                                                DD70  67
chardata:(DD704,"           external   average of   average    times")# DD70  68
chardata:(DD705,"[ standard  variance   total count   tc**2     $#      DD70  69
measured  sqrt(ev)/<tc>%]")#                                            DD70  70
chardata:(DD707," Option 1   Least squares line through the origin ")#  DD70  71
chardata:(DD708,"[ variance = total counts  + abs(             )$#      DD70  72
*(tc**2)]")#                                                            DD70  73
chardata:(DD70A," Option x   Least squares line of the $#               DD70  74
type  y = b + mx ")#                                                    DD70  75
chardata:(DD70B,"[ variance = total counts + abs(          ) $#         DD70  76
+ abs(          )*(tc**2)]")#                                           DD70  77
chardata:(DD70C," Warning: Raw counts for standard    vary by $#        DD70  78
more than 30 percent:Not used")#                                        DD70  79
realdata:(FMT,[80213.,201241.,320841.,431041.,500613.,630722.])#        DD70  80
realdata:(FMT1,[90113.,400951.,590951.])#                               DD70  81
realdata:(TINY,.000001)#                                                DD70  82
datastuff:#                                                             DD70  83
#                                                                       DD70  84
#  CLEAR OUT SUMS FOR EACH AND EVERY DIFFERENT STANDARD                 DD70  85
#  ----------------------------------------------------                 DD70  86
#                                                                       DD70  87
DO I=1,ISC#                                                             DD70  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD70  89
NSTD(I)=0;SSIGMA(I)=0.0;AVERAG(I)=0.0#                                  DD70  90
RAWSUM(I)=0.;GSTD(I)=yes:#             Clear flags as well              DD70  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD70  92
FOR(I=MARKS;I<STOPS;I=I+STEPS)#        Checking standards               DD70  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD70  94
intunpak:(QX(I+1),K,0,4)#              Pick up each std id no.          DD70  95
IF(K>ISC) NEXT#                        Keep within tables               DD70  96
NSTD(K)=NSTD(K)+1#                     Count times observed             DD70  97
IF(GSTD(K)==yes:&NSTD(K)>1)#           Compare average so far           DD70  98
IF(ABS((QX(I+4)*FLOAT(NSTD(K)-1)/RAWSUM(K))-1.)>.3)# If >30 percent     DD70  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DD70 100
GSTD(K)=no:#                           This standard unsuitable         DD70 101
ncodefld:(FLOAT(K),1,DD70C,360213.,1)# Tell user                        DD70 102
writeline:(0,DD70C,NDD70C,3,3)#                                         DD70 103
NEXT#                                  Try next standard                DD70 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DD70 105
RAWSUM(K)=RAWSUM(K)+QX(I+4)#           Add up counts                    DD70 106
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD70 107
DO I=1,ISC; NSTD(I)=0#                 Zero count again                 DD70 108
FOR(I=MARKS;I<STOPS;I=I+STEPS)#        Loop over standards              DD70 109
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DD70 110
intunpak:(QX(I+1),K,0,4)#              Pick up each std id no.          DD70 111
IF(K>ISC) NEXT#                        Keep within tables               DD70 112
NSTD(K)=NSTD(K)+1#                     Count times observed             DD70 113
SSIGMA(K)=SSIGMA(K)+(1.0/QX(I+4))#     Add up 1/tot counts              DD70 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DD70 115
#                                                                       DD70 116
#  FORM AVERAGE OF THE TOTAL COUNTS.  BY TOTAL COUNTS IS                DD70 117
#  MEANT SCAN COUNTS + BG1 COUNTS + BG2 COUNTS                          DD70 118
#  OVER THE WHOLE DATA GATHERING SESSION.                               DD70 119
#  ----------------------------------------------------                 DD70 120
#                                                                       DD70 121
NQ=0#                                  Set to count acceptible          DD70 122
DO I=1,ISC#                            Loop over possible               DD70 123
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DD70 124
IF(NSTD(I)<4\GSTD(I)==no:) NEXT#       Ignore small samples,variable    DD70 125
NQ=NQ+1#                               Count as good                    DD70 126
AVERAG(I)=FLOAT(NSTD(I))/SSIGMA(I)#    N/(sum tot counts)               DD70 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DD70 128
#                                                                       DD70 129
#  REPORT RAW DATA TO USER                                              DD70 130
#  -----------------------                                              DD70 131
#                                                                       DD70 132
movechar:(DD702,1,CHROT,2,NDD701-1,1)# Insert underline                 DD70 133
ncodefld:(FLOAT(NQ),1,DD701,390213.,1)# Format no. standards            DD70 134
writeline:(1,DD701,NDD701,2,3)#                                         DD70 135
writeline:(1,DD704,NDD704,3,3)#                                         DD70 136
writeline:(0,DD705,NDD705,3,3)#                                         DD70 137
#                                                                       DD70 138
#  CALCULATE THE EXTERNAL STANDARD DEVIATION FOR EACH                   DD70 139
#  STANDARD MEASURED MORE THAN SIX TIMES.                               DD70 140
#  ----------------------------------------------------                 DD70 141
#                                                                       DD70 142
DO I=1,ISC#                                                             DD70 143
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DD70 144
IF(NSTD(I)<7\GSTD(I)==no:)  NEXT#      Too few or vary too much         DD70 145
VARI(I)=0.0#                                                            DD70 146
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over all standards          DD70 147
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  DD70 148
intunpak:(QX(J+1),K,0,4)#              Pick up std no.                  DD70 149
IF(K==I)#                                                               DD70 150
VARI(I)=VARI(I)+((QX(J+4)-AVERAG(I))**2)/QX(J+4)# Delta**2/jth tot      DD70 151
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  DD70 152
#                                                                       DD70 153
#  CALCULATE THE EXTERNAL VARIANCE OF TOTAL COUNTS.                     DD70 154
#  EXTERNAL MEANS ITS BASED ON OBSERVED VARIATIONS RATHER THAN          DD70 155
#  COUNTING STATISTICS.                                                 DD70 156
#  --------------------------------------------------------             DD70 157
#                                                                       DD70 158
VARI(I)=(VARI(I)*FLOAT(NSTD(I)))/(SSIGMA(I)*FLOAT(NSTD(I)-1))#          DD70 159
A2=AVERAG(I)**2#                                                        DD70 160
BUFOT(1)=FLOAT(I)#                                                      DD70 161
BUFOT(2)=VARI(I)#                                                       DD70 162
BUFOT(3)=AVERAG(I)#                                                     DD70 163
BUFOT(4)=A2#                                                            DD70 164
BUFOT(5)=FLOAT(NSTD(I))#                                                DD70 165
BUFOT(6)=SQRT(BUFOT(2))/BUFOT(3)*100.# 1 esd as percent of total        DD70 166
ncodefld:(BUFOT,1,CHROT,FMT,6)#                                         DD70 167
writeline:(0,DD705,NDD705,1,3)#                                         DD70 168
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DD70 169
writeline:(1,DD703,NDD703,3,3)#        Print option 0.                  DD70 170
#                                                                       DD70 171
#  CALCULATE THE SLOPE AND INTERCEPT OF A LEAST SQUARES LINE            DD70 172
#  BASED ON THE SCATTER OF THE TOTAL COUNTS.                            DD70 173
#  ---------------------------------------------------------            DD70 174
#                                                                       DD70 175
FOR(NGO=1;NGO<=4;NGO=NGO+1)#                                            DD70 176
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  DD70 177
#                                                                       DD70 178
#  FIND VARI(I) = AVERAG(I) + SLOPE*AVERAG(I)**2                        DD70 179
#  FIRST ZERO THE NECESSARY SUMS                                        DD70 180
#  ----------------------------------------------                       DD70 181
#                                                                       DD70 182
SUMYX=0.0;SUMXSQ=0.0#                                                   DD70 183
IF(NGO==1)#                                                             DD70 184
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  DD70 185
DO I=1,ISC#                                                             DD70 186
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 DD70 187
IF(NSTD(I)<7\GSTD(I)==no:) NEXT#       No small or irregular potatoes   DD70 188
X=AVERAG(I)**2#                                                         DD70 189
SUMYX=(VARI(I)-AVERAG(I))*X+SUMYX#                                      DD70 190
SUMXSQ=SUMXSQ+X**2#                                                     DD70 191
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 DD70 192
IF(SUMXSQ>TINY)#                       Protect divide                   DD70 193
SLOPE(NGO)=SUMYX/SUMXSQ#               Get the slope                    DD70 194
ncodefld:(SLOPE,NGO,DD708,451351.,1)#                                   DD70 195
writeline:(1,DD707,NDD707,3,3)#                                         DD70 196
writeline:(0,DD708,NDD708,3,3)#                                         DD70 197
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  DD70 198
#                                                                       DD70 199
#   LEAST SQUARES LINE WITH A CALCULATED INTERCEPT.                     DD70 200
#  ------------------------------------------------                     DD70 201
#                                                                       DD70 202
ELSE IF(NGO==2)#                                                        DD70 203
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 DD70 204
SUMX=0.0;SUMY=0.0#                                                      DD70 205
DO I=1,ISC#                                                             DD70 206
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 DD70 207
IF(NSTD(I)<7\GSTD(I)==no:)  NEXT#      Skip stds of no account          DD70 208
Y=VARI(I)-AVERAG(I)#                                                    DD70 209
X=AVERAG(I)**2#                                                         DD70 210
SUMYX=SUMYX+Y*X#                                                        DD70 211
SUMX=SUMX+X#                                                            DD70 212
SUMY=SUMY+Y#                                                            DD70 213
SUMXSQ=SUMXSQ+X**2#                                                     DD70 214
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 DD70 215
DENOM=-SUMXSQ+SUMX**2/FLOAT(MAX0(1,NQ))# Get denominator                DD70 216
IF(ABS(DENOM)>TINY)#                   Protect divide                   DD70 217
SLOPE(NGO)=(-SUMYX+SUMX*SUMY/FLOAT(NQ))/DENOM#                          DD70 218
INTERC(NGO)=(SUMY-SLOPE(NGO)*SUMX)/FLOAT(MAX0(1,NQ))# And save them     DD70 219
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 DD70 220
#                                                                       DD70 221
#  IN THE THIRD CASE INTERCEPT IS FORCED TO ZERO SLOPE                  DD70 222
#  IS ACCEPTED FROM CALCULATION LIKE CASE 2.                            DD70 223
#  ---------------------------------------------------                  DD70 224
#                                                                       DD70 225
ELSE IF(NGO==3) SLOPE(NGO)=SLOPE(NGO-1)# Take slope from ii.            DD70 226
#                                                                       DD70 227
#                                                                       DD70 228
IF(NGO!=1)#                                                             DD70 229
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 DD70 230
BUFOT(1)=FLOAT(NGO);BUFOT(2)=INTERC(NGO);BUFOT(3)=SLOPE(NGO)#           DD70 231
ncodefld:(BUFOT,1,DD70A,FMT1,1)#                                        DD70 232
ncodefld:(BUFOT,2,DD70B,FMT1(2),2)#                                     DD70 233
writeline:(1,DD70A,NDD70A,3,3)#                                         DD70 234
writeline:(0,DD70B,NDD70B,3,3)#                                         DD70 235
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 DD70 236
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  DD70 237
#                                                                       DD70 238
RETURN#                                                                 DD70 239
END#                                                                    DD70 240
systemheader:(DD80)#                                                    DD80   1
#********************************************************************** DD80   2
#                                                                       DD80   3
#                                DD80                                   DD80   4
#                                                                       DD80   5
#********************************************************************** DD80   6
SUBROUTINE DD80#                                                        DD80   7
include:(AACOMN)#                                                       DD80   8
include:(DDCOMN)#                                                       DD80   9
#                                                                       DD80  10
#  ACTUALLY APPLY THE SCALE FACTORS NOW DEVELOPED AND STORED            DD80  11
#  TO ALL THE REFLECTIONS IN THE BINARY DATA FILE.  COPY AND            DD80  12
#  UPDATE THE BINARY DATA FILE.                                         DD80  13
#  J. M. STEWART APRIL 1983                                             DD80  14
#                                                                       DD80  15
REAL FRACT#                            Interpolation fraction           DD80  16
REAL TEST#                             Flt pt value of ser no.          DD80  17
REAL SUMN(27),SUMI(27),SUMS(27),SUM3(27)#                               DD80  18
REAL RATIO#                            Ratio irel to rawcnts            DD80  19
REAL IPEAK#                            Raw peak intensity               DD80  20
REAL RCODE,X,Y,Z#                                                       DD80  21
INTEGER I,IH,IK,IL,JH,JK,JL,IJK,K,KK,M#                                 DD80  22
INTEGER ICODE#                         Reflection code                  DD80  23
INTEGER JREF#                          Reflection serial no.            DD80  24
INTEGER L,JJ#                          Pointers                         DD80  25
INTEGER IPP,IPSIZ#                     Output packet pointers           DD80  26
INTEGER IPRINL#                        Local count of refs to print     DD80  27
#                                                                       DD80  28
chardata:(DD801," * Reflections output to bdf          *")#             DD80  29
chardata:(DD802,"[    h   k   l  rcode   intensity   $#                 DD80  30
 sig(I)    serial  correction]")#                                       DD80  31
chardata:(DD803,"copied")#                                              DD80  32
chardata:(DD805,"[ sig(I) calculated with instability option     ]")#   DD80  33
chardata:(DD1," Summary of intensity data in parity groups-")#          DD80  34
chardata:(DD2,"e00o000e00o000e00oee0eo0oo0oe0e0ee0oo0oo0e0ee0eo0oo0oe$# DD80  35
eeeeeoeoeoeeoooooeoeoeooall")#                                          DD80  36
chardata:(DD3,' parity    N    N>3sig   <intensity>   <sigma>')#        DD80  37
realdata:(FMT,[120503.,200503.,321112.,440912.])#                       DD80  38
realdata:(HFMT,[50413., 90413.,130413.,#                                DD80  39
180213.,321251.,431031.,520813.,641042.])#                              DD80  40
realdata:(FMU,[390313.,530313.])#                                       DD80  41
intdata:(J,1);   realdata:(CORR,1.)#                                    DD80  42
datastuff:#                                                             DD80  43
#                                                                       DD80  44
ncodefld:(FLOAT(INSTAB),1,DD805,470213.,1)# Insert instability no.      DD80  45
writeline:(1,DD805,NDD805,3,3)#        Print instabilty no.             DD80  46
copyfile:(3,2,1,decr:(lrrefl:))#       Copy leading records             DD80  47
readwpkt:(3,lrrefl:,PSIZ,IP,0)#        Read index record                DD80  48
IPSIZ=PSIZ#                            Set output packet size           DD80  49
writepkt:(2,lrrefl:,IPSIZ,IPP)#        Write output file                DD80  50
movereal:(QX,IP+1,QX,IPP+1,IPSIZ,1)#   Move packet                      DD80  51
writeline:(0,0,0,1,3)#                 Insert blank line                DD80  52
IPRINL=IPRINT;LINRM=4;NREF=0#          Move  refs to print              DD80  53
DO I=1,26; SUMN(I)=0.#                 Zero parity refln count          DD80  54
DO I=1,26; SUMI(I)=0.#                 Zero parity refln intensity      DD80  55
DO I=1,26; SUMS(I)=0.#                 Zero parity refln sigmas         DD80  56
DO I=1,26; SUM3(I)=0.#                 Zero parity refln count >3s      DD80  57
#                                                                       DD80  58
#  LOOP OVER ALL REFLECTIONS                                            DD80  59
#  -------------------------                                            DD80  60
#                                                                       DD80  61
REPEAT#                                Loop over all data               DD80  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD80  63
readwpkt:(3,lrrefl:,PSIZ,IP,0)#        Read index record                DD80  64
IF(IP<=0) BREAK#                       Quit when done                   DD80  65
L=IP+IOFF(4)#                          Get out serial and rcode         DD80  66
intunpak:(QX(L),ICODE,0,4)#            Get the reflection code          DD80  67
intunpak:(QX(L),JREF,4,28)#            Get the reflection number        DD80  68
IF(ICODE>2&IXSTD==yes:) NEXT#          Skip standard reflections        DD80  69
#                                                                       DD80  70
writepkt:(2,lrrefl:,IPSIZ,IPP)#        Write output file                DD80  71
movereal:(QX,IP+1,QX,IPP+1,IPSIZ,1)#   Move packet                      DD80  72
#                                                                       DD80  73
TEST=FLOAT(JREF)#                      Serial no. floated               DD80  74
IF(ICODE>2) RCODE=1.0#                 Set stds to observeds            DD80  75
ELSE        RCODE=FLOAT(ICODE)#        Else keep rcode                  DD80  76
L=IPP+IOFF(4);  QX(L)=RCODE#           Store the rcode for op           DD80  77
CORR=1.0#                              Treat copied refs                DD80  78
IF(ISC>0&IAPPLY==yes:&JREF>0)#         Skip if no standards             DD80  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD80  80
FOR(JJ=MARKR;JJ<=STOPR;JJ=JJ+STEPR)#   Loop over std scales             DD80  81
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DD80  82
J=JJ+STEPR#                            Get one ahead                    DD80  83
IF(TEST>=QX(JJ+2)&TEST<=QX(J+2))BREAK# Find interval                    DD80  84
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DD80  85
IF(ICODE==4) CORR=QX(J+1)#             Set correction for stds.         DD80  86
ELSE#                                  For normal measurement           DD80  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DD80  88
FRACT=(TEST-QX(JJ+2))/(QX(J+2)-QX(JJ+2))# Fraction of span              DD80  89
CORR=QX(JJ+1)+FRACT*(QX(J+1)-QX(JJ+1))# Linear interpolation            DD80  90
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DD80  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD80  92
#                                                                       DD80  93
#  CORRECT THE INTENSITY AND SIGMA(I)                                   DD80  94
#  ----------------------------------                                   DD80  95
#                                                                       DD80  96
L=IPP+IOFF(2);   QX(L)=QX(L)*CORR#     Intensity                        DD80  97
J=IPP+IOFF(3);   QX(J)=QX(J)*CORR#     Sigma(i) * scale                 DD80  98
IF(INSTAB>0&JREF>0&IAPPLY==yes:)#      Include instabity in sigma       DD80  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DD80 100
#       INSTABILITY CALCULATION USING RAW COUNTS                        DD80 101
#       ----------------------------------------                        DD80 102
#                                                                       DD80 103
#                                                                       DD80 104
#   INSTABILITY BASED ON RAW COUNTS ASSUMES THAT                        DD80 105
#   I(NET)=I(PEAK) + I(BACKGROUND)*TPBG.                                DD80 106
#   THE INSTABILITY CORRECTION IS APPLIED TO I(PEAK) AND IS ASSUMED     DD80 107
#   NEGLIGIBLE FOR I(BACKGROUND), SO (FOR RAW COUNTS)                   DD80 108
#   SIGMA^2(I_NET)=I_PEAK + I_BACK*TPBG^2 + C I_PEAK^2                  DD80 109
#   SIGMA IS SCALED TO THE SAME LEVEL AS I_REL BY USING                 DD80 110
#   THE RATIO I_NET(RAW)/I_NET                                          DD80 111
#                                                                       DD80 112
IF(IRAW==yes:&MISGUIDED==no:)#         Instability using raw counts     DD80 113
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DD80 114
IF(IEUL==yes:) K=IPP+IOFF(12)#         Get raw counts for instab        DD80 115
ELSE IF(IANG==yes:) K=IPP+IOFF(9)#     Raw counts are last item         DD80 116
ELSE K=IPP+IOFF(5)#                    In case no angles stored         DD80 117
IPEAK=QX(K)-(QX(K+1)*(1+QX(K+2)))#     Calculate net (raw) intensity    DD80 118
ifne:(QX(L),0)#                        Avoid zero net counts            DD80 119
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  DD80 120
RATIO=IPEAK/QX(L)#                     Scale irel -> raw                DD80 121
IPEAK=QX(K)-QX(K+1)#                   Need gross peak counts           DD80 122
QX(J)=SQRT(IPEAK+(QX(K+1)*QX(K+2)**2) + $# Sigma from raw variance      DD80 123
ABS(INTERC(INSTAB))+ABS(SLOPE(INSTAB))*IPEAK**2)/RATIO#                 DD80 124
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  DD80 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DD80 126
#                                                                       DD80 127
#   INSTABILITY CALCULATION USING IREL                                  DD80 128
#   ----------------------------------                                  DD80 129
#                                                                       DD80 130
#   IF NO RAW COUNTS ARE AVAILABLE, AN                                  DD80 131
#   INSTABILITY CORRECTION IS APPLIED USING I_REL AND SIG(I_REL)        DD80 132
#   THIS IS NOT GROSSLY DIFFERENT TO THE CALCULATION BASED ON           DD80 133
#   RAW COUNTS IF THE RATIO I_NET/I_RAW IS CLOSE TO 1.                  DD80 134
#                                                                       DD80 135
ELSE QX(J)=SQRT(QX(J)**2+ABS(INTERC(INSTAB))$# Var=tc+slp*i**2+cept     DD80 136
     +ABS(SLOPE(INSTAB))*QX(L)**2)*CORR#                                DD80 137
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DD80 138
NREF=NREF+1#                           Count op refs                    DD80 139
#                                                                       DD80 140
#    TRANSFORM HKL IF REQUESTED                                         DD80 141
#    --------------------------                                         DD80 142
#                                                                       DD80 143
K=IPP+IOFF(1);  gethkl:(K,BUFOT)#      Unpack h, k, and l               DD80 144
IF(ITM==yes:)#                         Transform hkl                    DD80 145
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  DD80 146
X=BUFOT(1) ; Y=BUFOT(2) ; Z=BUFOT(3)#  Store temporary                  DD80 147
BUFOT(1)=X*TM(1)+Y*TM(2)+Z*TM(3)#      Transformed h'                   DD80 148
BUFOT(2)=X*TM(4)+Y*TM(5)+Z*TM(6)#      Transformed k'                   DD80 149
BUFOT(3)=X*TM(7)+Y*TM(8)+Z*TM(9)#      Transformed l'                   DD80 150
intpak:(0,QX(K),0,mxbtwd:)#            Clear word                       DD80 151
DO JJ=1,3#                             Loop over h,k,l                  DD80 152
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  DD80 153
IJK=NINT(BUFOT(4-JJ))#                 Integerize index                 DD80 154
KK=0#                                  Sign of index                    DD80 155
IF(IJK<0)#                             Negative index                   DD80 156
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 DD80 157
IJK=-IJK#                              Make index positive              DD80 158
KK=1#                                  Take note of negative            DD80 159
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 DD80 160
intpak:(KK,QX(K),JJ-1,1)#              Pack the sign                    DD80 161
intpak:(IJK,QX(K),(JJ-1)*9+3,9)#       Pack the index                   DD80 162
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  DD80 163
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  DD80 164
#                                                                       DD80 165
#    ACCUMULATE INTENSITY STATISTICS                                    DD80 166
#    -------------------------------                                    DD80 167
#                                                                       DD80 168
IH=NINT(BUFOT(1)); IK=NINT(BUFOT(2)); IL=NINT(BUFOT(3))# Get h,k,l      DD80 169
JH=MOD(ABS(IH),2); JK=MOD(ABS(IK),2); JL=MOD(ABS(IL),2)# Get odd/even   DD80 170
IF(IL==0)#                             For l zero                       DD80 171
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 DD80 172
IF(IK==0)#                             For k zero                       DD80 173
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 DD80 174
IF(JH==0) M=1#                         For g00                          DD80 175
ELSE      M=2#                         For u00                          DD80 176
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 DD80 177
ELSE IF(JK==0)#                        For k even                       DD80 178
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 DD80 179
IF     (IH==0) M=3#                    For 0g0                          DD80 180
ELSE IF(JH==0) M=7#                    For gg0                          DD80 181
ELSE           M=10#                   For ug0                          DD80 182
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 DD80 183
ELSE#                                  For k odd                        DD80 184
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 DD80 185
IF     (IH==0) M=4#                    For 0u0                          DD80 186
ELSE IF(JH==0) M=8#                    For gu0                          DD80 187
ELSE           M=9#                    For uu0                          DD80 188
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 DD80 189
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 DD80 190
ELSE IF(JL==0)#                        For l even                       DD80 191
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 DD80 192
IF(IK==0)#                             For k zero                       DD80 193
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 DD80 194
IF     (IH==0) M=5#                    For 00g                          DD80 195
ELSE IF(JH==0) M=11#                   For g0g                          DD80 196
ELSE           M=14#                   For u0g                          DD80 197
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 DD80 198
ELSE IF(JK==0)#                        For k even                       DD80 199
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 DD80 200
IF     (IH==0) M=15#                   For 0gg                          DD80 201
ELSE IF(JH==0) M=19#                   For ggg                          DD80 202
ELSE           M=22#                   For ugg                          DD80 203
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 DD80 204
ELSE#                                  For k odd                        DD80 205
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 DD80 206
IF     (IH==0) M=18#                   For 0ug                          DD80 207
ELSE IF(JH==0) M=21#                   For gug                          DD80 208
ELSE           M=24#                   For uug                          DD80 209
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 DD80 210
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 DD80 211
ELSE#                                  For l odd                        DD80 212
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 DD80 213
IF(IK==0)#                             For k zero                       DD80 214
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 DD80 215
IF     (IH==0) M=6#                    For 00u                          DD80 216
ELSE IF(JH==0) M=12#                   For g0u                          DD80 217
ELSE      M=13#                        For u0u                          DD80 218
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 DD80 219
ELSE IF(JK==0)#                        For k even                       DD80 220
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 DD80 221
IF     (IH==0) M=16#                   For 0gu                          DD80 222
ELSE IF(JH==0) M=20#                   For ggu                          DD80 223
ELSE           M=25#                   For ugu                          DD80 224
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 DD80 225
ELSE#                                  For k odd                        DD80 226
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 DD80 227
IF     (IH==0) M=17#                   For 0uu                          DD80 228
ELSE IF(JH==0) M=26#                   For guu                          DD80 229
ELSE           M=23#                   For uuu                          DD80 230
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 DD80 231
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 DD80 232
SUMN(M)=SUMN(M)+1.#                    Count reflns in parity           DD80 233
SUMI(M)=SUMI(M)+QX(L)#                 Sum intensities                  DD80 234
SUMS(M)=SUMS(M)+QX(J)#                 Sum sigmas                       DD80 235
IF(QX(L)>3*QX(J)) SUM3(M)=SUM3(M)+1.#  Count hkl > 3sigma               DD80 236
SUMN(27)=SUMN(27)+1.#                  Count reflns in parity           DD80 237
SUMI(27)=SUMI(27)+QX(L)#               Sum intensities                  DD80 238
SUMS(27)=SUMS(27)+QX(J)#               Sum sigmas                       DD80 239
IF(QX(L)>3*QX(J)) SUM3(27)=SUM3(27)+1.# Count hkl > 3sigma              DD80 240
#                                                                       DD80 241
IF(NREF>IPRINL) NEXT#                  Skip print if too large          DD80 242
BUFOT(4)=RCODE#                        Put up for printing              DD80 243
BUFOT(5)=QX(L)#                        Print intensity                  DD80 244
BUFOT(6)=QX(J)#                        Print sigma(i)                   DD80 245
BUFOT(7)=TEST#                         Serial to print                  DD80 246
BUFOT(8)=CORR#                         Print correction                 DD80 247
ncodefld:(BUFOT,1,CHROT,HFMT,8)#                                        DD80 248
IF(TEST<.9) movechar:(DD803,1,CHROT,47,NDD803,0)#                       DD80 249
writeline:(0,DD802,NDD802,1,3)#                                         DD80 250
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD80 251
#                                                                       DD80 252
#   PRINT SUMMARY                                                       DD80 253
#   -------------                                                       DD80 254
#                                                                       DD80 255
LINRM=6#                               Check space for output           DD80 256
movechar:(DD801,2,CHROT,2,NDD801-1,1)# Insert highlight *               DD80 257
writeline:(2,0,0,1,3)#                 Print highlight line             DD80 258
movechar:(DD801,2,CHROT,2,NDD801-1,1)# Insert highlight *               DD80 259
ncodefld:(FLOAT(NREF),1,DD801,370513.,1)# Format no. refs to bdf        DD80 260
writeline:(0,DD801,NDD801,2,3)#        Print no. refs to bdf            DD80 261
#                                                                       DD80 262
movechar:(DD1,NDD1,CHROT,2,NDD1-2,1)#  Insert underline                 DD80 263
writeline:(2,DD1,NDD1-1,2,3);  LINRM=6# Print highlight line            DD80 264
DO I=1,27#                             Loop over all bins               DD80 265
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 DD80 266
movechar:(DD2,I*3-2,CHROT,3,3,0)#      Insert parity header             DD80 267
BUFOT(1)=SUMN(I)#                      Store parity count               DD80 268
BUFOT(2)=SUM3(I)#                      Store parity count >3s           DD80 269
BUFOT(3)=SUMI(I)/(SUMN(I)+.1)#         Store parity av intensity        DD80 270
BUFOT(4)=SUMS(I)/(SUMN(I)+.1)#         Store parity av sigma            DD80 271
ncodefld:(BUFOT,1,CHROT,FMT,4)#        Format statistics                DD80 272
writeline:(0,DD3,NDD3,1,3)#            Print statistics                 DD80 273
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 DD80 274
#                                                                       DD80 275
copyfile:(3,2,incr:(lrrefl:),endrecord:)# Copy all the rest             DD80 276
RETURN#                                                                 DD80 277
END#                                                                    DD80 278
systemheader:(DD90)#                                                    DD90   1
######################################################################  DD90   2
#                                                                    #  DD90   3
#                               DD90                                 #  DD90   4
#                                                                    #  DD90   5
######################################################################  DD90   6
SUBROUTINE DD90#                       N spadaccini may 1989            DD90   7
include:(AACOMN)#                                                       DD90   8
include:(DDCOMN)#                                                       DD90   9
#                                                                       DD90  10
REAL CORR#                                                              DD90  11
INTEGER J,JJ,JREF,L#                                                    DD90  12
chardata:(DD901," Standards rescaled for verification plot  ")#         DD90  13
datastuff:#                                                             DD90  14
#                                                                       DD90  15
#  RESCALE THE STANDARDS                                                DD90  16
#  ---------------------                                                DD90  17
#                                                                       DD90  18
IF(USESTD>0)#                          Not much use if no stds          DD90  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DD90  20
JJ=MARKR;L=NINT(QX(JJ+2))#             Get first std serial             DD90  21
FOR(J=MARKS;J<=STOPS;J=J+STEPS)#       Loop over all stds               DD90  22
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DD90  23
intunpak:(QX(J+1),JREF,4,28)#          Get std serial in jref           DD90  24
WHILE(L<JREF)#                         Move forward in scales           DD90  25
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DD90  26
JJ=JJ+STEPR;L=NINT(QX(JJ+2))#          Next ending serial no.           DD90  27
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DD90  28
CORR=QX(JJ+1)#                         Get the group scale factor       DD90  29
QX(J+2)=QX(J+2)*CORR#                  Correct intensity                DD90  30
QX(J+3)=QX(J+3)*CORR#                  Correct sigma i                  DD90  31
QX(J+4)=QX(J+4)*CORR#                  Correct total counts             DD90  32
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DD90  33
writeline:(1,DD901,NDD901,3,3)#        Signal intent to call dd40       DD90  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DD90  35
#                                                                       DD90  36
RETURN#                                                                 DD90  37
END#                                                                    DD90  38
pmacro:([no:])#                        Purge xtal system macros         DD90  39
#                                                                       DD90  40
