systemheader:(FS    )#                                                  FS     1
####################################################################### FS     2
##      Copyright (C) 2000, The Xtal System, The University of        # FS     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # FS     4
## Distributed under the GNU General Public Licence as published by   # FS     5
## the Free Software Foundation, in the hope that it will be useful   # FS     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # FS     7
## for more details.                                                  # FS     8
#                                                                     # FS     9
#                         *** FOURR ***                               # FS    10
#                                                                     # FS    11
#   THE PROGRAM CALCULATES THE FOURIER TRANSFORM FROM RECIPROCAL      # FS    12
#   TO REAL SPACE. IT IS GENERAL FOR ALL SPACE GROUPS AND STRUCTURE   # FS    13
#   SIZES. TWO SUMMATION ALGORITHMS ARE AVAILABLE; A CONVENTIONAL     # FS    14
#   BEEVERS-LIPSON APPROACH, AND COMBINED B-L & FAST-FOURIER          # FS    15
#   APPROACH.   A WIDE VARIETY OF FOURIER COEFFS. ARE POSSIBLE.       # FS    16
#                                                                     # FS    17
####################################################################### FS    18
#                                                                       FS    19
include:(XMACRO)#                                                       FS    20
#                                                                       FS    21
macro:(swap:,[$(IXZE=ISUM$1;ISUM$1=ISUM$2;ISUM$2=IXZE$)])#              FS    22
macro:(dp:,ifelse:(mxbtwd:,32,DOUBLE PRECISION ,REAL ))#                FS    23
macro:(db:,ifelse:(mxbtwd:,32,DBLE($1),$1))#                            FS    24
macro:(dsqrt:,ifelse:(mxbtwd:,32,DSQRT($1),SQRT($1)))#                  FS    25
macro:(d0:,ifelse:(mxbtwd:,32,D+0 ,E+0 ))#                              FS    26
macro:(dcos:,ifelse:(mxbtwd:,32,DCOS($1),COS($1)))#                     FS    27
macro:(dacos:,ifelse:(mxbtwd:,32,DACOS($1),ACOS($1)))#                  FS    28
macro:(dabs:,ifelse:(mxbtwd:,32,DABS($1),ABS($1)))#                     FS    29
macro:(dmin1:,ifelse:(mxbtwd:,32,DMIN1($1,$2),AMIN1($1,$2)))#           FS    30
macro:(dmax1:,ifelse:(mxbtwd:,32,DMAX1($1,$2),AMAX1($1,$2)))#           FS    31
macro:(dsign:,ifelse:(mxbtwd:,32,DSIGN($1,$2),SIGN($1,$2)))#            FS    32
#                                                                       FS    33
extrude:(FSCOMN)#                                                       FS    34
REAL    CELLC(9)#   ## Cell constants                                   FS    35
REAL    TRAND(9)#   ## Transformation matrix from franctional to orth   FS    36
REAL    TRANR(9)#   ## Transformation matrix from Miller indx to orth   FS    37
REAL    CMETR(9)#   ## Metric tensor                                    FS    38
REAL    RMETR(9)#   ## Reciprocal metric tensor                         FS    39
REAL    COEF(20)#   ## Fourier transform coefficients                   FS    40
INTEGER CTYPE#      ## Code to indicate fourier coefficient type        FS    41
INTEGER PTYPE#      ## Code to indicate fourier property type           FS    42
INTEGER IPROP#      ## The amount of components for properties          FS    43
INTEGER ETYPE#      ## Signal to show which e is to be used             FS    44
INTEGER COLPIN#     ## Print columns per unit length on printer         FS    45
INTEGER COLPNT#     ## Number of columns per fourier grid point         FS    46
REAL    DENMAX#     ## maximum density in the map                       FS    47
REAL    DENMIN#     ## minimum density in the map                       FS    48
INTEGER DSET#       ## Pointer to data set being treated                FS    49
REAL    E000#       ## E(0,0,0) value                                   FS    50
REAL    ERR#        ## Mean esd of density                              FS    51
REAL    FCMIN#      ## Lowest |FC| allowed to phase reflns              FS    52
INTEGER FCREJ#      ## Code to signal rejection based on FC min         FS    53
REAL    FUSE#       ## F(0,0,0) value actually applied                  FS    54
INTEGER FREJ#       ## Code to signal rejection of certain f values     FS    55
REAL    F000#       ## F(0,0,0) value                                   FS    56
REAL    FORCE#      ## Value which is to be forced on 1st grid point    FS    57
INTEGER FORMAT#     ## Format flag for print normal=0,shade=1,pack=2    FS    58
REAL    FORSCL#     ## Scale when shaded format used                    FS    59
INTEGER GRID(3)#    ## Input grid specifications                        FS    60
INTEGER IBDF#       ## Archive bdf output flag (0=no;1=yes)             FS    61
INTEGER ICNT#       ## Centric flag as 0/1 for centric/acentric         FS    62
INTEGER IMAP(3)#    ## IMAP(1)=map axis code for X; IMAP(3).. for Z     FS    63
INTEGER IHMAX(3)#   ## Max hkl permuted for use during summation        FS    64
INTEGER IH2MAX#     ##                                                  FS    65
INTEGER IH3MAX#     ##                                                  FS    66
INTEGER ICOEF#      ## Signal that COEFF line has been input            FS    67
INTEGER ICEL(3)#    ## ICEL(1)=cell axis code for lay; ICEL(3).. acc    FS    68
INTEGER IPHI#       ## Flag to signal if phases used or not             FS    69
INTEGER INCX(3)#    ## Increments along cell directions in grid point   FS    70
INTEGER INCT(3)#    ## Increments along cell directions not permuted    FS    71
INTEGER IPROJ#      ## Signal to make a projection map                  FS    72
INTEGER IRAD#       ## Radiation type 1=neut;2=elect;3xrays             FS    73
INTEGER IREL(21)#   ## Relative positions of items in packet            FS    74
INTEGER IWNT(20)#   ## Requested want list of items to indexpkt         FS    75
INTEGER LAUE#       ## Laue flag (0=general symm.; 1=laue symm.)        FS    76
INTEGER LTYP#       ## Lattice type (1 to 7) p,i,r,f,a,b,c              FS    77
INTEGER ISUM1#      ## Contains map code for x (1=lay;2=dow;3=acc)      FS    78
INTEGER ISUM2#      ## Contains map code for y (1=lay;2=dow;3=acc)      FS    79
INTEGER ISUM3#      ## Contains map code for z (1=lay;2=dow;3=acc)      FS    80
INTEGER IXINC(3)#   ## Incx modified to be positive for actual          FS    81
INTEGER IXORG(3)#   ## Permuted plot origins in grid params modulo ng   FS    82
INTEGER JSUM1#      ## Contains cell code for layer (1=X,2=Y,3=Z)       FS    83
INTEGER JSUM2#      ## Contains cell code for down  (1=X,2=Y,3=Z)       FS    84
INTEGER JSUM3#      ## Contains cell code for accros(1=X,2=Y,3=Z)       FS    85
INTEGER JCODE(5)#   ## Contains component codes for E.F.G.              FS    86
INTEGER JUMP#       ## Increment along axis for printing line           FS    87
INTEGER LINPIN#     ## Lines per unit of length down the page           FS    88
INTEGER LINPNT#     ## Number of printer lines per point                FS    89
REAL    LOLIM#      ## Lower limit for printing fourier                 FS    90
INTEGER LREJ#       ## Code to control less-than rejection              FS    91
string:(MAPCHR,1)#  ## Map character used for rejected op points        FS    92
INTEGER MARKS,MARK1,MARK2,MARK3,MARK4,MARK5,MARK6#                      FS    93
INTEGER MAXH(3)#    ## Maximum miller indices in the unit cell          FS    94
INTEGER NG(3)#      ## Grid parameters of map (1=layer; 3=accross)      FS    95
INTEGER NP(3)#      ## Number of points in each sum direction           FS    96
INTEGER NPP1#       ## Running 1st sum points - changes as layers don   FS    97
INTEGER NPR#        ## Number of print points across page               FS    98
INTEGER NROT#       ## Number of unique symmetry matrices on bdf        FS    99
INTEGER NRSZ#       ## Number of matrices with same pattern zeros       FS   100
INTEGER NSYM#       ## Count of symmetry operations                     FS   101
INTEGER NSCL#       ## Number of scale groups                           FS   102
INTEGER NSH#        ## Number of printed sheets per layer               FS   103
INTEGER ORGX(3)#    ## Permuted origin points axis in grid u   s        FS   104
INTEGER ORGT(3)#    ## Same as orgx but not permuted by jsums           FS   105
INTEGER PASSES#     ## Cycle counter used to control calling of fs04    FS   106
REAL    PPANG#      ## Scale of map in printer points/angstrom          FS   107
INTEGER PRINT#      ## Signal that transform is to be printed           FS   108
INTEGER PRNATM#     ## Signal that asymmetric atoms are to be printed   FS   109
INTEGER PRNSYM#     ## Signal printing of all atoms in unit cell        FS   110
INTEGER PSET#       ## Phase set number for emap                        FS   111
INTEGER PSIX#       ##                                                  FS   112
REAL    RR1#        ## Rejection ratio 1                                FS   113
REAL    RR2#        ## Rejection ratio 2                                FS   114
REAL    RRS#        ## Rejection ratio for sig f                        FS   115
REAL    SCALE(65)#  ## F relative scale factors                         FS   116
REAL    SCAL#       ## Final coefficient scale factor (1/v,scale etc.   FS   117
INTEGER SFILE#      ## Flag for output file c                           FS   118
REAL    SKAL#       ## Electron density scale factor                    FS   119
INTEGER SPAN(3)#     ## Number of grid points to be summed over         FS   120
INTEGER STEPS,STEP1,STEP2,STEP3,STEP4,STEP5,STEP6#                      FS   121
INTEGER STOPS,STOP1,STOP2,STOP3,STOP4,STOP5,STOP6#                      FS   122
INTEGER SREJ#       ## Sigma rejection flag                             FS   123
REAL    STMX#       ## Sin(theta)/lambda maximum                        FS   124
REAL    STMN#       ##                                                  FS   125
INTEGER SUMFF#      ## Summation method. yes: implies fft               FS   126
REAL    UPLIM#      ## Upper limit for printing fourier                 FS   127
REAL    VOL#        ## Cell volume                                      FS   128
REAL    XHI(3)#     ## Upper map limits in fractions of cell            FS   129
REAL    XLO(3)#     ## Lower map limits in fractions of cell            FS   130
#                                                                       FS   131
COMMON/COMFFS/ $#                      Real common array for fs rou     FS   132
PPANG,FORCE,COEF,PSET,#                                                 FS   133
CELLC,E000,F000,FCMIN,FUSE,LOLIM,RR1,RR2,RRS,SCALE,#                    FS   134
SCAL,SKAL,STMX,STMN,UPLIM,VOL,XLO,XHI,#                                 FS   135
TRAND,TRANR,CMETR,RMETR#                                                FS   136
#                                                                       FS   137
COMMON/COMIF1/ $#                      Integer common1 for fs           FS   138
ETYPE,FORMAT,FORSCL,LAUE,DENMAX,DENMIN,ERR,IBDF,#                       FS   139
COLPIN,COLPNT,IPROJ ,LINPNT,LINPIN,LTYP,IRAD,#                          FS   140
CTYPE,DSET,FCREJ,FREJ,IHMAX,MAXH,IH2MAX,IH3MAX,#                        FS   141
ICEL,IMAP,INCX,INCT,ORGX,ORGT,IPHI,IREL,IWNT,#                          FS   142
ISUM1,ISUM2,ISUM3,IXINC,IXORG,JSUM1,SREJ,#                              FS   143
PTYPE,IPROP,JCODE,ICOEF#                                                FS   144
COMMON/COMIF2/ $#                      Integer common2 for fs           FS   145
JSUM2,JSUM3,JUMP,LREJ,MARKS,MARK1,MARK2,MARK3,#                         FS   146
MARK4,MARK5,MARK6,NG,NP,SPAN,NPR,NSCL,#                                 FS   147
ICNT,GRID,NPP1,NROT,NRSZ,NSYM,PASSES,PRNATM,PRNSYM,#                    FS   148
NSH,STEPS,STEP1,STEP2,STEP3,STEP4,STEP5,STEP6,#                         FS   149
STOPS,STOP1,STOP2,STOP3,STOP4,STOP5,STOP6,#                             FS   150
PRINT,PSIX,SFILE,SUMFF#                                                 FS   151
#                                                                       FS   152
COMMON/COMCFS/ MAPCHR#                                                  FS   153
endext:#                                                                FS   154
#                                                                       FS   155
systemheader:(FS00)#                                                    FS00   1
# ################################################################## #  FS00   2
#                                                                       FS00   3
#                               FS00                                 #  FS00   4
#                                                                    #  FS00   5
# ################################################################## #  FS00   6
SUBROUTINE FS00#                       J.m.stewart,j.r.holden 1981      FS00   7
include:(AACOMN)#                      R.doherty, s.r.hall 1982         FS00   8
include:(FSCOMN)#                      V.a.streltsov 1992               FS00   9
#                                                                       FS00  10
FILEXT(IOUNIT(3))='MAP'#               Default ext fourier map          FS00  11
#                                                                       FS00  12
CALL FS10#                             Bdf input and startup            FS00  13
CALL FS20#                             Process line input controls      FS00  14
CALL FS30#                             Set map controls and print       FS00  15
PASSES=-1#                             Set initial passes flag          FS00  16
REPEAT#                                Loop over required passes        FS00  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS00  18
CALL FS40#                             Reset for pass & read lrrefl     FS00  19
IF(PASSES==0) BREAK#                   Quit when pass count = 0         FS00  20
CALL FS50#                             Calc bl summation 1              FS00  21
IF(SUMFF==no:\PTYPE>1) CALL FS60#      Calc bl summations 2 & 3         FS00  22
ELSE           CALL FS70#              Cal fft summations 2 & 3         FS00  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS00  24
#                                                                       FS00  25
RETURN#                                                                 FS00  26
END#                                                                    FS00  27
systemheader:(FS10)#                                                    FS10   1
# ################################################################## #  FS10   2
#                                                                    #  FS10   3
#                               FS10                                 #  FS10   4
#                                                                    #  FS10   5
# ################################################################## #  FS10   6
SUBROUTINE FS10#                       Part 1-bdf input and initial     FS10   7
include:(AACOMN)#                      J.m.stewart,j.r.holden 1981      FS10   8
include:(FSCOMN)#                      R.doherty, s.r.hall 1982         FS10   9
#                                      V.a.streltsov 1992               FS10  10
##    Note the following COEFF types are specified:                     FS10  11
##    COEFF PATT EPAT VECT EMAP FOBS FDIF FCAL WFOB WDIF                FS10  12
##      0    1    2    3    4    5    6    7    8    9                  FS10  13
##    PDIF  EDIF GDIF                                                   FS10  14
##     10   11   12                                                     FS10  15
#                                                                       FS10  16
INTEGER I,J,K,N,M,IP,IPP,PSIZ#                                          FS10  17
INTEGER FLG(4),KEY#                                                     FS10  18
REAL TEMP#                                                              FS10  19
REAL FVOL#                             Map volume                       FS10  20
#                                                                       FS10  21
chardata:(FS11,E1 E2 PS DS BL FF NO R1 R2 PR FI NP PE NE NW $#          FS10  22
LA GS AS FU RF NB RS PA EP VE EM FO FD FC WF WD $#                      FS10  23
PD ED GD )#                                                             FS10  24
intdata:(ID,[$#                                                         FS10  25
304,304,309,  0, -1,309,  0,  0,  0,  0,#                               FS10  26
304,600,309,  0, -1, -1,  0,  0,  0,  0,#                               FS10  27
600,600, -1, -1, -1, -1,  0,  0,  0,  0,#                               FS10  28
600,630, -1,  0, -1, -1,  0,  0,630,  0,#                               FS10  29
701, -1,309,  0, -1, -1,801,802,700,  0,#                               FS10  30
701, -1,309,800, -1, -1,801,802,700,  0,#                               FS10  31
800, -1, -1,  0, -1, -1,801,802,700,  0,#                               FS10  32
701, -1,309,  0,910, -1,801,802,700,  0,#                               FS10  33
701, -1,309,800,910, -1,801,802,700,  0])#                              FS10  34
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              FS10  35
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              FS10  36
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              FS10  37
realdata:(TR21,[.3333333,.5])#                                          FS10  38
realdata:(TR22,[.6666667,0.])#                                          FS10  39
realdata:(TR23,[.6666667,.5])#                                          FS10  40
datastuff:#                                                             FS10  41
#                                                                       FS10  42
#   SET DEFAULT FOURR PARAMETERS                                        FS10  43
#   ----------------------------                                        FS10  44
#                                                                       FS10  45
SFILE=yes:;   IBDF=yes:#               Default output bdf's             FS10  46
PRINT=no:#                             Default no print of map          FS10  47
FVOL=no:#                              Default volume is asymm unit     FS10  48
CTYPE=6#                               Default assumes f diff map       FS10  49
PTYPE=0#                               Default assumes f diff map       FS10  50
IPROP=1#                               Default assumes 1 component pr   FS10  51
LAUE=-1#                               Flag symmetry not set            FS10  52
ETYPE=1#                               Default /e/ value applied        FS10  53
FCMIN=0.;   FCREJ=no:#                 Default to no screen fc          FS10  54
FREJ=no:;   RR1=0.#                    Default overall f rejection      FS10  55
LREJ=no:;   RR2=0.#                    Default rcode=2 f rejection      FS10  56
SREJ=no:;   RRS=1.#                    Default sigma   f rejection      FS10  57
DENMAX=-9999.; DENMIN=9999.#           Set density limits               FS10  58
ERR=0.0#                               Default esd of density           FS10  59
PRNSYM=no:#                            Do not print all atoms in uc     FS10  60
PRNATM=yes:#                           Print asymmetric atoms in bd     FS10  61
DSET=1#                                Default is data set 1            FS10  62
PSET=-1#                               Default phase set is 1     
SUMFF=no:#                             Default summation is b-l         FS10  64
MAXH(1)=999; MAXH(2)=999; MAXH(3)=999# Default max h,k,l                FS10  65
STMN=0.;    STMX=2.#                   Default min/max st/l             FS10  66
DO J=1,65; SCALE(J)=1.0#               Default scale factor             FS10  67
#                                                                       FS10  68
#   ENTER FOURR PARAMETERS                                              FS10  69
#   ----------------------                                              FS10  70
#                                                                       FS10  71
DO J=1,30#                             Loop over input fields           FS10  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS10  73
ifvo:(BUFIN(J)) BREAK#                 Exit on first void               FS10  74
IF(BUFIN(J)<voidflg:)#                 Test for char string             FS10  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FS10  76
stringlim:(J,N,M)#                     Get limits of char string        FS10  77
compchar:(CHRIN,N,FS11,1,2,3,NFS11,KEY)# Search for string match        FS10  78
IF(KEY==0) iquit:(FS1001,J)#           No match.......fs1001            FS10  79
IF     (KEY<= 2) ETYPE=KEY#            Set /e/ type                     FS10  80
ELSE IF(KEY== 6) SUMFF=yes:#           Set summation as fft             FS10  81
ELSE IF(KEY== 7) SFILE=no:#            Switch off op file c             FS10  82
ELSE IF(KEY== 8) FREJ =yes:#           Switch on ovall rej test         FS10  83
ELSE IF(KEY== 9) LREJ =yes:#           Switch on rcod2 rej test         FS10  84
ELSE IF(KEY==10) PRINT=yes:#           Switch on map printing           FS10  85
ELSE IF(KEY==13) PRNSYM=yes:#          Print all atoms in unit cell     FS10  86
ELSE IF(KEY==15) PRNATM=no:#           Shut off atom print, period.     FS10  87
ELSE IF(KEY==16) LAUE=yes:#            Set symmetry to laue             FS10  88
ELSE IF(KEY==17) LAUE=no:#             Set symmetry to general          FS10  89
ELSE IF(KEY==19) FVOL=yes:#            Set map volume to full           FS10  90
ELSE IF(KEY==20) FCREJ=yes:#           Set to reject small fc's         FS10  91
ELSE IF(KEY==21) IBDF=no:#             Set archive bdf output off       FS10  92
ELSE IF(KEY==22) SREJ=yes:#            Switch on sigma f rej test       FS10  93
ELSE IF(KEY>=23) CTYPE=KEY-22#         Set calculation type             FS10  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FS10  95
ELSE#                                  Else input is numeric            FS10  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FS10  97
IF     (KEY== 3) PSET=NINT(BUFIN(J))#  Get phase set number             FS10  98
ELSE IF(KEY== 4) DSET=NINT(BUFIN(J))#  Get data set number              FS10  99
ELSE IF(KEY== 8) RR1 =AMIN1(1.1,BUFIN(J))# Get rej all fraction         FS10 100
ELSE IF(KEY== 9) RR2 =AMIN1(1.1,BUFIN(J))# Get rej r=2 fraction         FS10 101
ELSE IF(KEY==20) FCMIN=MAX(0.,BUFIN(J))# Get min |fc| to phase          FS10 102
ELSE IF(KEY==22) RRS =MAX(0.,BUFIN(J))# Get sigma fraction rejects      FS10 103
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FS10 104
IF(CTYPE>=10&CTYPE<=12)#               Set property type                FS10 105
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FS10 106
PTYPE=CTYPE-9#                         1=potent;2=el field;3=el grad    FS10 107
CTYPE=6#                               Assume standard fdiff            FS10 108
IF(PTYPE==2) IPROP=3#                  Number of components             FS10 109
IF(PTYPE==3) IPROP=5#                  Number of components             FS10 110
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FS10 111
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS10 112
DO J=1,3#                              Loop over cell axes              FS10 113
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FS10 114
XLO(J)=100.;  XHI(J)=100.#             Start map lo & hi limits         FS10 115
IF(FVOL==yes:\CTYPE==2)#               If full volume requested         FS10 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FS10 117
XLO(J)=0.;    XHI(J)=1.#               Start map lo & hi limits         FS10 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FS10 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FS10 120
#                                                                       FS10 121
#   ASSESS FOURR CONTROL PARAMETERS                                     FS10 122
#   -------------------------------                                     FS10 123
#                                                                       FS10 124
IF     (LAUE>-1);#                     If symmetry entered              FS10 125
ELSE IF(CTYPE>3) LAUE=no:#             Assume general symmetry          FS10 126
ELSE             LAUE=yes:#            Laue for patterson maps          FS10 127
J=MAX0(1,CTYPE*10-9)#                  Point to stored idnum list       FS10 128
DO I=1,10#                             Loop over stored items           FS10 129
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FS10 130
IF(ID(J)>0) COEF(I)=FLOAT(ID(J)+1000*DSET)# Store coeff idnum           FS10 131
ELSE        COEF(I)=FLOAT(ID(J))#      Store as constant                FS10 132
J=J+1#                                 Incr to next coeff               FS10 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FS10 134
IF(CTYPE>=3&CTYPE<=4)#                 Test if e.s are used             FS10 135
COEF(1)=COEF(1)+FLOAT(ETYPE-1)#        Adjust idnum for e-type          FS10 136
IF(CTYPE>=2&CTYPE<=3)#                 Test if e.s are used             FS10 137
COEF(2)=COEF(2)+FLOAT(ETYPE-1)#        Adjust idnum for e-type          FS10 138
IF(CTYPE==4\PSET>0)#                   Test for emap calc.       
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FS10 140
IF(CTYPE!=4)COEF(9)=FLOAT(630+1000*DSET)# set explicitly, no weight
ELSE#                                  Set weight
COEF(2)=COEF(2)+FLOAT(ABS(PSET)*2)#    Adjust idnum for phase set  
COEF(9)=COEF(9)+FLOAT(ABS(PSET)*2-1)#  Adjust idnum for phase set 
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FS10 143
IOMARK(1)=QXSTR#                       Set up bdf input buffer          FS10 144
IOMARK(2)=IOMARK(1)+bdfbuf:#           Set up bdf output buffer         FS10 145
IOMARK(3)=IOMARK(2)+bdfbuf:#           Set up filec output buffer       FS10 146
MARKS=IOMARK(3)#                       Mark start of symop table        FS10 147
IF(SFILE==yes:) MARKS=IOMARK(3)+bdfbuf:# Incr for file c buffer         FS10 148
incrqx:(I,MARKS,FS1004)#               Exp qx.........fs1004            FS10 149
#                                                                       FS10 150
# BEGIN READING OF INPUT BINARY DATA FILE                               FS10 151
# -----------------------------------------                             FS10 152
#                                                                       FS10 153
IF(SFILE==yes:) copyfile:(1,3,lrhist:,decr:(lrcell:))# Copy hist to c   FS10 154
FOR(K=1;K>0;K=K+1)#                    Loop over lrcell packets         FS10 155
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FS10 156
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Read in cell record              FS10 157
IF(IP<=0) BREAK#                       Exit after last record           FS10 158
IF(K==1)movereal:(QX,IP+1,CELLC,1,PSIZ,0)# Save real cell constants     FS10 159
IF(K==4)movereal:(QX,IP+1,TRAND,1,PSIZ,0)# Save transformation matrix   FS10 160
IF(K==5)movereal:(QX,IP+1,TRANR,1,PSIZ,0)# Save transformation matrix   FS10 161
IF(K==6)VOL=QX(IP+1)#                  Save real cell volume            FS10 162
IF(K==7)movereal:(QX,IP+1,CMETR,1,PSIZ,0)# Save metric tensor           FS10 163
IF(K==8)movereal:(QX,IP+1,RMETR,1,PSIZ,0)# Save inv. metric tensor      FS10 164
IF(SFILE==no:) NEXT#                   Skip unless filec op             FS10 165
writepkt:(3,lrcell:,PSIZ,IPP)#         Point to filec packet            FS10 166
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Transfer pkt to output           FS10 167
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FS10 168
DO I=1,3#                              Loop over transformation matri   FS10 169
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FS10 170
K=3*(I-1)#                             Set up index                     FS10 171
DO J=1,3; TRAND(K+J)=TRAND(K+J)/CELLC(I)# Normalize matrix              FS10 172
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FS10 173
TEMP=CMETR(4)#                         Store element of metric tensor   FS10 174
CMETR(4)=CMETR(5)#                     Reset element                    FS10 175
CMETR(5)=TEMP#                         Reset element                    FS10 176
TEMP=RMETR(4)#                         Store element of inv. metric     FS10 177
RMETR(4)=RMETR(5)#                     Reset element                    FS10 178
RMETR(5)=TEMP#                         Reset element                    FS10 179
#                                                                       FS10 180
#   EXTRACT SYMMETRY INFORMATION (LRSYMM)                               FS10 181
#   ------------------------------------                                FS10 182
#                                                                       FS10 183
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Read first packet of symop r     FS10 184
IF(SFILE==yes:)#                       Test if file c output            FS10 185
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FS10 186
writepkt:(3,lrsymm:,PSIZ,IPP)#         Point to filec packet            FS10 187
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Transfer packet to op            FS10 188
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FS10 189
LTYP=NINT(QX(IP+1))#                   Get out lattice type             FS10 190
ICNT=NINT(QX(IP+2))#                   Get out centro flag (nc=1)       FS10 191
NSYM=NINT(QX(IP+3))#                   Get out total symop count        FS10 192
NROT=NINT(QX(IP+4))#                   Extract number of matrices       FS10 193
NRSZ=NINT(QX(IP+5))#                   Extract no. same pattern zer     FS10 194
LTYP=LTYP-(1-ICNT)*7#                  Reduce ltyp to modulo 7          FS10 195
incrqx:(STOPS,MARKS+NSYM*12,FS1006)#   Incr qx........fs1006            FS10 196
FOR(J=MARKS;J<STOPS;J=J+PSIZ)#         Loop over symop packets          FS10 197
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FS10 198
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Point to next packet             FS10 199
IF(IP<=0) BREAK#                       Exit after last packet           FS10 200
movereal:(QX,IP+1,QX,J+1,PSIZ,1)#      Store 12-element symops          FS10 201
IF(LAUE==yes:)#                        If patt or vector maps           FS10 202
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FS10 203
QX(J+10)=0.; QX(J+11)=0.; QX(J+12)=0.# Remove translations              FS10 204
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FS10 205
IF(SFILE==no:) NEXT#                   Skip if no filec                 FS10 206
writepkt:(3,lrsymm:,PSIZ,IPP)#         Point to op packet               FS10 207
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Transfer op packet               FS10 208
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FS10 209
MARK1=J;  STEPS=PSIZ#                  Mark end & step of symmetry      FS10 210
K=MARK1#                               Set symm matrix pointer          FS10 211
IF(ICNT==0)#                           Test if centrosymmetric          FS10 212
FOR(J=MARKS;J<MARK1;J=J+1)#            Loop over symm matrices          FS10 213
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FS10 214
K=K+1#                                 Incr storage pointer             FS10 215
QX(K)=-QX(J+1)#                        Store inverse element            FS10 216
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FS10 217
N=K#                                   Store temp end marker            FS10 218
IF(LTYP>1)#                            Test if sg centered              FS10 219
FOR(J=MARKS;J<N;J=J+STEPS)#            Loop over symm matrices          FS10 220
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FS10 221
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            FS10 222
QX(K+10)=QX(J+10)+TR11(LTYP-1)#        Transfer t1                      FS10 223
QX(K+11)=QX(J+11)+TR12(LTYP-1)#        Transfer t2                      FS10 224
QX(K+12)=QX(J+12)+TR13(LTYP-1)#        Transfer t3                      FS10 225
K=K+STEPS#                             Incr storage pointer             FS10 226
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               FS10 227
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            FS10 228
QX(K+10)=QX(J+10)+TR21(LTYP-2)#        Transfer t1                      FS10 229
QX(K+11)=QX(J+11)+TR22(LTYP-2)#        Transfer t2                      FS10 230
QX(K+12)=QX(J+12)+TR23(LTYP-2)#        Transfer t3                      FS10 231
K=K+STEPS#                             Incr storage pointer             FS10 232
IF(LTYP!=4) NEXT#                      Skip if not f-centre             FS10 233
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            FS10 234
QX(K+10)=QX(J+10)+0.5#                 Transfer t1                      FS10 235
QX(K+11)=QX(J+11)+0.5#                 Transfer t2                      FS10 236
QX(K+12)=QX(J+12)+0.0#                 Transfer t3                      FS10 237
K=K+STEPS#                             Incr storage pointer             FS10 238
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FS10 239
#                                                                       FS10 240
# GET F(0,0,0) AND E(0,0,0) FROM LRSCAT:                                FS10 241
# ------------------------------------                                  FS10 242
#                                                                       FS10 243
E000=.01;  F000=0.#                    Set initial values               FS10 244
IWNT(1)=1; IWNT(2)=100#                Request natom/cell & ff0         FS10 245
IWNT(3)=3; IWNT(4)=10#                 Request z & neut ff              FS10 246
FLG(1)=0; FLG(2)=4; FLG(3)=0; FLG(4)=0# Set search keys                 FS10 247
indexpkt:(1,lrscat:,PSIZ,IP,0,FLG,IWNT,IREL)# Search lrscat record      FS10 248
IF(IREL(2)==0) IREL(2)=IREL(3)#        Replace no. elects. with z &     FS10 249
IF(IREL(4)!=0) IREL(2)=IREL(4)#        Replace z with neutron sf        FS10 250
IF(SFILE==yes:)#                       Test for scratch file            FS10 251
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FS10 252
writepkt:(3,lrscat:,PSIZ,IPP)#         Poit to output pkt               FS10 253
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Move  the packet                 FS10 254
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FS10 255
IF(IREL(1)*IREL(2)>0)#                 Test if items present            FS10 256
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FS10 257
REPEAT#                                Loop over lrscat records         FS10 258
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FS10 259
readwpkt:(1,lrscat:,PSIZ,IP,0)#        Point to lrscat record           FS10 260
IF(IP<=0) BREAK#                       Exit after last pkt              FS10 261
IF(SFILE==yes:)#                       Test for scratch file            FS10 262
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 FS10 263
writepkt:(3,lrscat:,PSIZ,IPP)#         Point to output pkt              FS10 264
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Move the packet to out           FS10 265
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 FS10 266
I=IP+IREL(1);  J=IP+IREL(2)#           Point to natom ans z             FS10 267
F000=F000+QX(I)*QX(J)#                 Sum total electrons              FS10 268
E000=E000+QX(I)*QX(J)*QX(J)#           Sum total z**2                   FS10 269
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FS10 270
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FS10 271
IF(E000>small:) E000=F000/SQRT(E000)#  Calc e(0,0,0)                    FS10 272
#                                                                       FS10 273
#  COPY LRDDEF IF FILEC OUTPUT                                          FS10 274
#  ---------------------------                                          FS10 275
#                                                                       FS10 276
IF(SFILE==yes:)#                       Test if filec output             FS10 277
REPEAT#                                Loop over lrddef packets         FS10 278
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 FS10 279
readwpkt:(1,lrddef:,PSIZ,IP,0)#        Read input packet                FS10 280
IF(IP<=0) BREAK#                       Break after last pkt             FS10 281
writepkt:(3,lrddef:,PSIZ,IPP)#         Get output pointer               FS10 282
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Copy pkt across                  FS10 283
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 FS10 284
#                                                                       FS10 285
#   ENTER SCALE INFORMATION (LREXPL:)                                   FS10 286
#  ------------------------------                                       FS10 287
#                                                                       FS10 288
IWNT(1)=1;   IWNT(2)=100#              Set data set & nscl idnums       FS10 289
IWNT(3)=94;  IRAD=3#                   Set rad type  default xrays      FS10 290
FLG(1)=1;  FLG(2)=3;  FLG(3)=0#        Set search delimiters            FS10 291
FLG(4)=0#                              Set update mode                  FS10 292
indexpkt:(1,lrexpl:,PSIZ,IP,0,FLG,IWNT,IREL)# Get packet pointers       FS10 293
NSCL=1;   SCALE(1)=0.#                 Default group & rel pointer      FS10 294
FOR(I=IP+1;I<=IP+PSIZ;I=I+1)#          Loop over directory              FS10 295
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 FS10 296
IF((QX(I)<100.9)\(QX(I)>164.1)) NEXT#  Skip if not scale idnm           FS10 297
J=NINT(QX(I))-100#                     Get group number of scale        FS10 298
SCALE(J)=FLOAT(I-IP)#                  Store relative position          FS10 299
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 FS10 300
REPEAT#                                Loop over data sets              FS10 301
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 FS10 302
readwpkt:(1,lrexpl:,PSIZ,IP,0)#        Get packet pointer               FS10 303
IF(IP<=0) BREAK#                       Exit after last packet           FS10 304
I=IP+IREL(1)#                          Get index of data set no.        FS10 305
IF(DSET!=NINT(QX(I))) NEXT#            Skip unwanted idnum              FS10 306
I=IP+IREL(2); IF(I>IP) NSCL=NINT(QX(I))# Number of scales               FS10 307
I=IP+IREL(3); IF(I>IP) IRAD=MIN(3,NINT(QX(I)))# Radiation type          FS10 308
DO I=1,NSCL#                           Loop over scale factors          FS10 309
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 FS10 310
J=IP+NINT(SCALE(I))#                   Point to scale location          FS10 311
IF(J>IP) SCALE(I)=QX(J)#               Store scale in table             FS10 312
ELSE     SCALE(I)=1.#                  Default scale is 1.              FS10 313
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 FS10 314
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 FS10 315
#                                                                       FS10 316
#    ENTER MAXHKL INFORMATION (LRDSET)                                  FS10 317
#   ---------------------------------                                   FS10 318
#                                                                       FS10 319
IWNT(1)=1; IWNT(2)=11; IWNT(3)=12#     Set dset,maxh,maxk idnum         FS10 320
IWNT(4)=13;IWNT(5)=14; IWNT(6)=15#     Set maxl,mins,maxs idnum         FS10 321
FLG(1)=6; FLG(2)=0; FLG(3)=0; FLG(4)=0# Set search limits               FS10 322
indexpkt:(1,lrdset:,PSIZ,IP,0,FLG,IWNT,IREL)# Search directory          FS10 323
IF(FLG(4)>0)#                          If present extract limits        FS10 324
REPEAT#                                Loop over lrdset pkts            FS10 325
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 FS10 326
readwpkt:(1,lrdset:,PSIZ,IP,0)#        Point to next packet             FS10 327
IF(IP<=0) BREAK#                       Exit after last pkt              FS10 328
I=IP+IREL(1); IF(DSET!=NINT(QX(I))) NEXT# Skip wrong dataset            FS10 329
I=IP+IREL(2); MAXH(1)=NINT(QX(I))#     Extract max /h/                  FS10 330
I=IP+IREL(3); MAXH(2)=NINT(QX(I))#     Extract max /k/                  FS10 331
I=IP+IREL(4); MAXH(3)=NINT(QX(I))#     Extract max /l/                  FS10 332
I=IP+IREL(5); STMN =QX(I)#             Extract min st/l                 FS10 333
I=IP+IREL(6); STMX =QX(I)#             Extract max st/l                 FS10 334
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 FS10 335
#                                                                       FS10 336
RETURN#                                                                 FS10 337
END#                                                                    FS10 338
systemheader:(FS20)#                                                    FS20   1
# ################################################################## #  FS20   2
#                                                                    #  FS20   3
#                               FS20                                 #  FS20   4
#                                                                    #  FS20   5
# ################################################################## #  FS20   6
SUBROUTINE FS20#                       Part 2-line input directives     FS20   7
include:(AACOMN)#                      J.m.stewart,j.r.holden 1981      FS20   8
include:(FSCOMN)#                      R.doherty, s.r.hall 1982         FS20   9
#                                      V.a.streltsov 1992               FS20  10
REAL A,ANGPIN,FZERO,X,Y,Z#                                              FS20  11
REAL YLO(3),YHI(3)#                                                     FS20  12
INTEGER I,IXZE,J,K,L,N,NA,M#                                            FS20  13
INTEGER SP(3),HI(3),LO(3),R,T#                                          FS20  14
#                                                                       FS20  15
chardata:(FS21, SCALE GRID MAXHKL LAYOUT MAP COEFF $#                   FS20  16
PRINT FZERO END )#                                                      FS20  17
chardata:(FS22,A B C PAPBPC LA DO AC PR )#                              FS20  18
chardata:(FS23,.NO PA SH )#                                             FS20  19
realdata:(SKDEF,[1.,1.,1.,1.,10.,10.,100.,10.,10.,100.])#               FS20  20
datastuff:#                                                             FS20  21
#                                                                       FS20  22
# INITIALIZE SUMMATION CONTROLS                                         FS20  23
# ------------------------------                                        FS20  24
#                                                                       FS20  25
ISUM1=0;ISUM2=0;ISUM3=0;IPROJ=0#       Zeroize sum directions           FS20  26
PPANG=4.#                              Default points per angstrom      FS20  27
SKAL=-1.#                              Default print scale off          FS20  28
FORMAT=1#                              Default format is normal         FS20  29
FORSCL=10. ; FORCE=0.0#                Default shade format scale       FS20  30
COLPNT=0#                              Set column default to 0          FS20  31
LINPNT=0#                              Set double spacing default       FS20  32
UPLIM=+10.#                            Default accept all               FS20  33
LOLIM=-99999.#                         Default accept all               FS20  34
FZERO=voidflg:#                        Default f000 is off              FS20  35
ANGPIN=0.#                             Default angstroms per inch       FS20  36
COLPIN=prtcpin:#                       Default cols per inch            FS20  37
LINPIN=prtlpin:#                       Default lines per inch           FS20  38
movechar:(FS23,1,MAPCHR,1,1,0)#        Default map char is (.)          FS20  39
DO J=1,3#                              Loop cell axes (1=x;2=y;3=z)     FS20  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS20  41
GRID(J)=0;  SPAN(J)=0#                 Zeroize grid & span numbers      FS20  42
INCT(J)=1; ORGT(J)=99999#              Zeroize grid incr & start        FS20  43
IMAP(J)=0;  SP(J)=24#                  Zeroize as axis pointer          FS20  44
YLO(J)=0.;  YHI(J)=1.#                 Start map lo & hi limits         FS20  45
LO(J)=-12;  HI(J)=12#                  Asymm unit limits                FS20  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS20  47
IF((LREJ==yes:)&(RR2<small:)) LREJ=-1# Global reject of jcode=2         FS20  48
#                                                                       FS20  49
#    LOOP OVER CONTROL LINES                                            FS20  50
#    -----------------------                                            FS20  51
#                                                                       FS20  52
ICOEF=no:#                             Assume coef not entered          FS20  53
REPEAT#                                Read control lines to end        FS20  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FS20  55
readline:(FS21,NFS21)#                 Process next input line          FS20  56
#                                                                       FS20  57
IF(LINID==1)#                          ******** scale *************     FS20  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FS20  59
IF(BUFIN(2)>small:) J=NINT(BUFIN(2))#  Get scale factor group           FS20  60
ELSE                J=1#               Default scale group = 1.         FS20  61
IF(J>64) iquit:(FS2001)#               Protect against out of bound     FS20  62
IF(BUFIN(1)>0.) SCALE(J)=BUFIN(1)#     Store active scale               FS20  63
ELSE            SCALE(J)=1.#           Else set as 1.                   FS20  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FS20  65
#                                                                       FS20  66
ELSE IF(LINID==2)#                     ******** grid ***************    FS20  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FS20  68
DO I=1,3#                              Loop over input fields           FS20  69
IF(BUFIN(I)>.5) GRID(I)=NINT(BUFIN(I))# Store active grid value         FS20  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FS20  71
#                                                                       FS20  72
ELSE IF(LINID==3)#                     ******** maxhkl *************    FS20  73
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FS20  74
DO J=1,3#                              Loop over hkl fields             FS20  75
IF(BUFIN(J)>(-.1))#                    Store active max hkl             FS20  76
MAXH(J)=MIN0(MAXH(J),NINT(BUFIN(J)))#  Store possible max hkl           FS20  77
IF(BUFIN(4)>=0.0) STMN=BUFIN(4)#       Store active min st              FS20  78
IF(BUFIN(5)>0.01) STMX=BUFIN(5)#       Store active max st              FS20  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FS20  80
#                                                                       FS20  81
ELSE IF(LINID==4)#                     ******** layout *************    FS20  82
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FS20  83
DO I=1,3#                              Loop cell axes (1=x;2=y;3=z)     FS20  84
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FS20  85
IF(BUFIN(I)<voidflg:)#                 Test for direction string        FS20  86
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FS20  87
stringlim:(I,N,M)#                     Get string limits                FS20  88
compchar:(CHRIN,N,FS22,14,2,3,NFS22,M)# Search for string match         FS20  89
IF(M==0) iquit:(FS2002,I)#             No match........fs2002           FS20  90
IF(M==4)#                              Test if projection requested     FS20  91
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FS20  92
IPROJ=I ; M=1 ; IMAP(I) = 1#           Set up projection axis           FS20  93
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FS20  94
IF(I==1) ISUM1=M#                      Store summation order 1          FS20  95
IF(I==2) ISUM2=M#                      Store summation order 2          FS20  96
IF(I==3) ISUM3=M#                      Store summation order 3          FS20  97
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FS20  98
IF(BUFIN(I+3)>(-.1)) SPAN(I)=NINT(BUFIN(I+3))# Extract active span      FS20  99
ifnv:(BUFIN(I+6))    ORGT(I)=NINT(BUFIN(I+6))# Extract grid origin      FS20 100
IF(BUFIN(I+9)>(-.1)) INCT(I)=NINT(BUFIN(I+9))# Extract grid incr.       FS20 101
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FS20 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FS20 103
#                                                                       FS20 104
ELSE IF(LINID==5)#                     ******** map  ***************    FS20 105
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FS20 106
IF(BUFIN(1)<voidflg:)#                 Test for layer code              FS20 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FS20 108
stringlim:(1,N,M)#                     Get string limits                FS20 109
compchar:(CHRIN,N,FS22,1,2,2,13,M)#    Search for match                 FS20 110
IF(M==0) iquit:(FS2004)#               No match........fs2004           FS20 111
IF(M<=3) IMAP(M)=1#                    Set layer direction              FS20 112
ELSE#                                  Else must be projection          FS20 113
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FS20 114
IPROJ=M-3;  IMAP(M-3)=1#               Set project axis(1=x;2=y;3=z)    FS20 115
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FS20 116
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FS20 117
DO I=1,3#                              Loop cell axes (1=x;2=y;3=z)     FS20 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FS20 119
IF(BUFIN(I+1)>(-1.5)) XLO(I)=BUFIN(I+1)# Lower cell limit               FS20 120
IF(BUFIN(I+4)>(-1.5)) XHI(I)=BUFIN(I+4)# Upper cell limit               FS20 121
IF((XLO(I)>XHI(I))&(XLO(I)<9.)&(XHI(I)<9.))# Test if in correct order   FS20 122
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FS20 123
A=XLO(I); XLO(I)=XHI(I); XHI(I)=A#     No; swap limits                  FS20 124
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FS20 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FS20 126
IF(BUFIN(8)>.001) PPANG=BUFIN(8)#      Store angstroms /inch            FS20 127
ISUM1=IMAP(1);ISUM2=IMAP(2);ISUM3=IMAP(3)# Restore directions           FS20 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FS20 129
#                                                                       FS20 130
ELSE IF(LINID==6)#                     ******** coeff **************    FS20 131
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FS20 132
ICOEF=yes:#                            Flag that coeff line read        FS20 133
DO J=1,9#                              Loop over input fields           FS20 134
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FS20 135
IF(BUFIN(J)>voidflg:) COEF(J)=BUFIN(J)# Store active coeff.s            FS20 136
ELSE                   iquit:(FS2008)# Missing........fs2008            FS20 137
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FS20 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FS20 139
#                                                                       FS20 140
ELSE IF(LINID==7)#                     ******** print **************    FS20 141
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FS20 142
PRINT=yes:#                            Switch on map print flag         FS20 143
IF(BUFIN(1)<voidflg:)#                 Test for format string           FS20 144
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FS20 145
stringlim:(1,N,M)#                     Get string limits                FS20 146
compchar:(CHRIN,N,FS23,2,2,3,NFS23,M)# Search for match                 FS20 147
IF(M==0) iquit:(FS2006)#               No match........fs2006           FS20 148
FORMAT=M#                              Store print format               FS20 149
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FS20 150
IF(BUFIN(2)>small:)   SKAL=BUFIN(2)#   Store active print scale         FS20 151
IF(BUFIN(3)>voidflg:) UPLIM=BUFIN(3)#  Store active upper limit         FS20 152
IF(BUFIN(4)>voidflg:) LOLIM=BUFIN(4)#  Store active lower limit         FS20 153
IF(BUFIN(5)>small:)   FORSCL=BUFIN(5)# Store   format shade scale       FS20 154
IF(BUFIN(6)>voidflg:) FORCE=BUFIN(6)#  Store set origin value           FS20 155
IF(BUFIN(7)>small:)   COLPNT=NINT(BUFIN(7))# Set col.s /point           FS20 156
IF(BUFIN(8)>small:)   LINPNT=NINT(BUFIN(8))# Set lines /point           FS20 157
IF(BUFIN(9)>small:)   COLPIN=NINT(BUFIN(9))# Set col.s /inch            FS20 158
IF(BUFIN(10)>small:)  LINPIN=NINT(BUFIN(10))# Set lines /inch           FS20 159
IF(BUFIN(11)<voidflg:)#                Test if map char input           FS20 160
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 FS20 161
stringlim:(11,N,M)#                    Set char position                FS20 162
movechar:(CHRIN,N,MAPCHR,1,1,0)#       Store map char                   FS20 163
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 FS20 164
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FS20 165
#                                                                       FS20 166
ELSE IF(LINID==8)#                     ******** fzero **************    FS20 167
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 FS20 168
IF(BUFIN(1)>voidflg:) FZERO=BUFIN(1)#  Set f000 value                   FS20 169
ELSE                  FZERO=0.#        Default as f000 is 0.            FS20 170
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 FS20 171
ELSE BREAK#                            **********end**************      FS20 172
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FS20 173
#                                                                       FS20 174
#   SET CONTROL PARAMETERS                                              FS20 175
#   ----------------------                                              FS20 176
#                                                                       FS20 177
IF(SKAL<small:&PRINT==yes:) SKAL=SKDEF(CTYPE+1)# Default print scale    FS20 178
SCAL=2.#                               Set map scale (hemisphere)       FS20 179
IF(IRAD!=2)#                           If xrays or neutrons             FS20 180
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 FS20 181
SCAL=2./MAX(1.,VOL)#                   Density per cubic angstroms      FS20 182
A=AMIN1(F000/(E000+.1),100.)#          Set emap rescale value           FS20 183
IF(CTYPE==2) SCAL=SCAL*A/2.#           Adjust epatt scale for f/e       FS20 184
IF(CTYPE==3) SCAL=SCAL*A#              Adjust vect scale for f/e        FS20 185
IF(CTYPE==4) SCAL=SCAL*A#              Adjust emap scale for f/e        FS20 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 FS20 187
ELSE#                                  For electron radiation           FS20 188
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 FS20 189
F000=0.;    E000=0.#                   Zero coefficients                FS20 190
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 FS20 191
IF(CTYPE==6&LOLIM<-99998.)LOLIM=-10.#  Set default for difference       FS20 192
IF(CTYPE==9&LOLIM<-99998.)LOLIM=-10.#  Set default for weighted di      FS20 193
IF(FZERO>voidflg:)FUSE=FZERO#          Test f000 set explicitly         FS20 194
ELSE IF(CTYPE==0) FUSE=0.#             Set default if coeff ip          FS20 195
ELSE IF(CTYPE==1) FUSE=0.#             Set f000 for patterson           FS20 196
ELSE IF(CTYPE==2) FUSE=0.#             Set f000 for e-patt map          FS20 197
ELSE IF(CTYPE==3) FUSE=0.#             Set f000 for vector map          FS20 198
ELSE IF(CTYPE==4) FUSE=E000#           Set f000 for e - map             FS20 199
ELSE IF(CTYPE==5) FUSE=F000#           Set f000 for fobs map            FS20 200
ELSE IF(CTYPE==6) FUSE=0.#             Set f000 for fdiff map           FS20 201
ELSE IF(CTYPE==7) FUSE=F000#           Set f000 for fcal map            FS20 202
ELSE IF(CTYPE==8) FUSE=F000#           Set f000 for wfobs map           FS20 203
ELSE IF(CTYPE==9) FUSE=0.#             Set f000 for weighted diff map   FS20 204
#                                                                       FS20 205
# GENERATE SYMMETRICALLY EQUIVALENT HKL MAXIMA                          FS20 206
# ---------------------------------------------                         FS20 207
#                                                                       FS20 208
X=FLOAT(MAXH(1))#                      Float max /h/                    FS20 209
Y=FLOAT(MAXH(2))#                      Float max /k/                    FS20 210
Z=FLOAT(MAXH(3))#                      Float max /l/                    FS20 211
DO N=1,3#                              Loop over indices                FS20 212
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 FS20 213
FOR(I=MARKS;I<STOPS;I=I+STEPS)#        Loop over sym matrices           FS20 214
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 FS20 215
M=(N-1)*3+I#                           Point to matrix columns          FS20 216
A=ABS(X*QX(M+1)+Y*QX(M+2)+Z*QX(M+3))#  Transform max hkl                FS20 217
MAXH(N)=MAX0(NINT(A),MAXH(N))#         Save max value                   FS20 218
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 FS20 219
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 FS20 220
#                                                                       FS20 221
#                                                                       FS20 222
# SUMMATION CONTROL PARAMETERS                                          FS20 223
# -----------------------------                                         FS20 224
#                                                                       FS20 225
#----NG IS THE GRID*FINENESS*( IHMAX THE MAXIMUM VALUES OF H,K,L TO BE  FS20 226
#     SUMMED OVER, STOLMN TO STOLMX IS THE RANGE OF SIN(T)/LAMBDA.)     FS20 227
#                                                                       FS20 228
#----THE NP ARE THE NUMBER OF POINTS IN EACH DIRECTION THAT ARE TO BE   FS20 229
#     SUMMED OVER, THE IORGX ARE THE POINTS OF TRUE BEGINNING AS THE    FS20 230
#     SURVEYORS SAY), THE INCX ARE THE SIZE OF STEPS TO BE TAKEN.       FS20 231
#                                                                       FS20 232
##                      /                     /                         FS20 233
##                      /     CELL --> MAP    /    MAP --> CELL         FS20 234
##                      /                     /                         FS20 235
##                      /   X      Y      Z   /  LAY    DOW    ACC      FS20 236
##                      /                     /                         FS20 237
##  Layer  Down  Accross/ ISUM1  ISUM2  ISUM3 / JSUM1  JSUM2  JSUM3     FS20 238
##                      / map(1) map(2) map(3)/ cel(1) cel(2) cel(3)    FS20 239
##                      /                     /                         FS20 240
##                      /  contain map codes  / contain cell codes      FS20 241
##  ---------------------------------------------------------------     FS20 242
##    X      Y     Z    /   1      2      3   /   1      2      3       FS20 243
##    X      Z     Y    /   1      3      2   /   1      3      2       FS20 244
##                      /                     /                         FS20 245
##    Y      Z     X    /   3      1      2   /   2      3      1       FS20 246
##    Y      X     Z    /   2      1      3   /   2      1      3       FS20 247
##                      /                     /                         FS20 248
##    Z      X     Y    /   2      3      1   /   3      1      2       FS20 249
##    Z      Y     X    /   3      2      1   /   3      2      1       FS20 250
##  ---------------------------------------------------------------     FS20 251
##                      / the map codes are:  / the cell codes are:     FS20 252
##                      / LAY=1; DOW=2; ACC=3 /  X=1;   Y=2;   Z=3      FS20 253
##                      /                     /                         FS20 254
#                                                                       FS20 255
IF(ISUM1*ISUM2*ISUM3!=6\ISUM1+ISUM2+ISUM3!=6)# Test for illegal axes    FS20 256
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 FS20 257
#                                                                       FS20 258
IF(ISUM1==0&ISUM2==0&ISUM3==0)#        Test if directions are zero      FS20 259
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 FS20 260
IF     (MAXH(1)>=MAXH(2)&MAXH(1)>=MAXH(3)) ISUM1=1# Set a as longest    FS20 261
ELSE IF(MAXH(2)>=MAXH(1)&MAXH(2)>=MAXH(3)) ISUM2=1# Set b as longest    FS20 262
ELSE                                       ISUM3=1# Set c as longest    FS20 263
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 FS20 264
#                                                                       FS20 265
IF(ISUM1==1)#                          If a is longest                  FS20 266
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 FS20 267
ISUM2=2;   ISUM3=3#                    Set c as shortest                FS20 268
IF(MAXH(3)>MAXH(2)) swap:(2,3)#        Set b as shortest                FS20 269
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 FS20 270
ELSE IF(ISUM2==1)#                     If b is longest                  FS20 271
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 FS20 272
ISUM1=2;   ISUM3=3#                    Set c as shortest                FS20 273
IF(MAXH(3)>MAXH(1)) swap:(1,3)#        Set a as shortest                FS20 274
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 FS20 275
ELSE#                                  If c is longest                  FS20 276
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 FS20 277
ISUM1=2;   ISUM2=3#                    Set b as shortest                FS20 278
IF(MAXH(2)>MAXH(1)) swap:(1,2)#        Set a as shortest                FS20 279
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 FS20 280
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 FS20 281
IF(ISUM1*ISUM2*ISUM3!=6\ISUM1+ISUM2+ISUM3!=6)iquit:(FS2012)#            FS20 282
#                                                                       FS20 283
#                                         ## Isum1  =map axis of x      FS20 284
IMAP(1)=ISUM1; IMAP(2)=ISUM2; IMAP(3)=ISUM3# Imap(1)=map axis of x      FS20 285
ICEL(ISUM1)=1; ICEL(ISUM2)=2; ICEL(ISUM3)=3# Icel(1)=cell axis of lay   FS20 286
JSUM1=ICEL(1); JSUM2=ICEL(2); JSUM3=ICEL(3)# Jsum1  =cell axis of lay   FS20 287
JCODE(1)=JSUM1*JSUM1#                                                   FS20 288
JCODE(2)=JSUM1*JSUM2#                                                   FS20 289
JCODE(3)=JSUM1*JSUM3#                                                   FS20 290
JCODE(4)=JSUM2*JSUM3#                                                   FS20 291
JCODE(5)=JSUM3*JSUM3#                                                   FS20 292
#                                                                       FS20 293
#    SELECT SMALLEST POSSIBLE UNIQUE SEGMENT                            FS20 294
#    ---------------------------------------                            FS20 295
#                                                                       FS20 296
DO N=1,3#                              Loop map axes (1=lay; 3=accr)    FS20 297
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 FS20 298
FOR(M=MARKS+STEPS;M<STOPS;M=M+12)#     Loop over symmetry matrices      FS20 299
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 FS20 300
FOR(L=1;L<=N;L=L+1)#                   Loop map axes (1=lay; 3=accr)    FS20 301
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 FS20 302
NA=ICEL(L)#                            Extract cell axes (1=x;3=z)      FS20 303
I=NA*4-3; J=MOD(I+1,9)+2; K=MOD(J+1,9)+2# Point to coord elements       FS20 304
ifne:(QX(M+J),0.) BREAK#               Exit on non-diagonal element     FS20 305
ifne:(QX(M+K),0.) BREAK#               Exit on non-diagonal element     FS20 306
R=NINT(QX(M+I))#                       Extract diagonal element         FS20 307
T=MOD(NINT(QX(M+NA+9)*24.)+48,24)#     Extract translation in 24ths     FS20 308
I=MOD(R+T+24,24)#                      Make coord between 0-23ths       FS20 309
IF(I>12) I=I-24#                       Make coord between -12 - 12      FS20 310
IF((I<LO(NA))\(I>HI(NA))) BREAK#       Exit if coord outside limits     FS20 311
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 FS20 312
IF(L<=N) NEXT#                         Skip if posn rejected            FS20 313
IF((R==1)&(T==0)) NEXT#                Skip if at identity coord        FS20 314
IF(R<0)#                               If coord reversed                FS20 315
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 FS20 316
IF(T==0) T=24#                         Set zero transl to unity         FS20 317
LO(NA)=MAX0(LO(NA),(T-24)/2)#          Set start of map                 FS20 318
HI(NA)=MIN0(HI(NA),T/2)#               Set end   of map                 FS20 319
SP(NA)=HI(NA)-LO(NA)#                  Set total span of map            FS20 320
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 FS20 321
ELSE SP(NA)=MIN0(SP(NA),T)#            Set span to screw transl         FS20 322
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 FS20 323
NA=ICEL(N)#                            Point to sorted map axis         FS20 324
IF(SP(NA)<HI(NA)-LO(NA))#              Test if screw/centre transl      FS20 325
LO(NA)=MIN0(0,HI(NA)-SP(NA))#          Set new start of map             FS20 326
IF(SP(NA)==24) LO(NA)=0#               Reset start if complete cell     FS20 327
HI(NA)=LO(NA)+SP(NA)#                  Set new end   of map             FS20 328
YHI(NA)=FLOAT(SP(NA))/24.#             Store end of vector map          FS20 329
IF(CTYPE>=1&CTYPE<=3) NEXT#            Test for vector maps             FS20 330
YLO(NA)=FLOAT(LO(NA))/24.#             Store map origin                 FS20 331
YHI(NA)=FLOAT(HI(NA))/24.#             Store map end                    FS20 332
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 FS20 333
#                                                                       FS20 334
# SET NUMBER OF GRID POINTS IN THE THREE SUM DIRECTIONS                 FS20 335
# ----------------------------------------------------                  FS20 336
#                                                                       FS20 337
DO I=1,3#                              Loop cell axes (1=x;y=2;z=3)     FS20 338
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 FS20 339
IF(XHI(I)>99.) XHI(I)=YHI(I)#          Store calculated upper limit     FS20 340
IF(XLO(I)>99.) XLO(I)=YLO(I)#          Store calculated lower limit     FS20 341
IF(GRID(I)<=0)#                        Test if grid specified           FS20 342
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 FS20 343
J=NINT(PPANG*CELLC(I))+1#              Calculate map grid from cell     FS20 344
K=MAX0(2,(24/SP(I)))#                  Get required grid factorial      FS20 345
GRID(I)=J+MOD(K-MOD(J,K),K)#           Calculate grid size              FS20 346
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 FS20 347
IF(ORGT(I)>99998)#                     Test if orgin is set             FS20 348
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 FS20 349
ORGT(I)=INT(FLOAT(GRID(I))*XLO(I)+.01)# Calc grid origin of map         FS20 350
IF(ORGT(I)<0) ORGT(I)=ORGT(I)-1#       Allow for -ve origin             FS20 351
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 FS20 352
IF(SPAN(I)<=0)#                        Test if map span set             FS20 353
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 FS20 354
K=INT(FLOAT(GRID(I))*XHI(I)+.99)#      Calc high grid limit             FS20 355
SPAN(I)=K-ORGT(I)+1#                   Get span of map                  FS20 356
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 FS20 357
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 FS20 358
#                                                                       FS20 359
#   CALCULATE AUTO POINT LAYOUT                                         FS20 360
#   ----------------------------                                        FS20 361
#                                                                       FS20 362
IF(LINPNT+COLPNT==0) COLPNT=4#         Default lines per point          FS20 363
IF(LINPNT==0)#                         Test if colpnt gets linpnt       FS20 364
LINPNT=NINT(FLOAT(COLPNT*LINPIN)/FLOAT(COLPIN))# Calc lines/point       FS20 365
IF(COLPNT==0)#                         Test if linpnt gets colpnt       FS20 366
COLPNT=NINT(FLOAT(LINPNT*COLPIN)/FLOAT(LINPIN))# Calc cols/point        FS20 367
IF(FORMAT>1)#                          Test if special format reque     FS20 368
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 FS20 369
COLPNT=1;  LINPNT=1#                   Force packed printout            FS20 370
IF(FORMAT==2)#                         Test if packed format            FS20 371
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 FS20 372
UPLIM=AMAX1(0.,UPLIM);   LOLIM=-99999.# Allow only positive density     FS20 373
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 FS20 374
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 FS20 375
#                                                                       FS20 376
RETURN#                                                                 FS20 377
END#                                                                    FS20 378
systemheader:(FS30)#                                                    FS30   1
# ################################################################## #  FS30   2
#                                                                    #  FS30   3
#                               FS30                                 #  FS30   4
#                                                                    #  FS30   5
# ################################################################## #  FS30   6
SUBROUTINE FS30#                       Part 3-set cycling controls      FS30   7
include:(AACOMN)#                      J.m.stewart,j.r.holden 1981      FS30   8
include:(FSCOMN)#                      R.doherty, s.r.hall 1982         FS30   9
#                                      V.a.streltsov 1992               FS30  10
REAL TEM(7)#                                                            FS30  11
REAL A,B,C,X,Y,Z#                                                       FS30  12
INTEGER I,J,JJ,K,N,IP,IPP,PSIZ#                                         FS30  13
INTEGER ISPAN#                         Last point to be calculated      FS30  14
INTEGER OLDG(3)#                       Save input grid for fft          FS30  15
INTEGER KEY(4)#                        Signals for indexpkt             FS30  16
string:(ATNAME,24)#                    Temp store of atom names         FS30  17
#                                                                       FS30  18
chardata:(FS31, FOURR CONTROL PARAMETERS)#                              FS30  19
chardata:(FS32, FOURIER TRANSFORM TYPE                          $#      FS30  20
               )#                                                       FS30  21
chardata:(FS33, FOURIER TRANSFORM PHASE                 )#              FS30  22
chardata:(FS331, FOURIER PROPERTY TYPE                            )#    FS30  23
chardata:(FS332,ELECTROSTATIC POTENTIALELECTRIC FIELD         $#        FS30  24
ELECTRIC FIELD GRADIENT)#                                               FS30  25
chardata:(FS34, ORIENTATION OF  X  AXIS   ACROSS WITH  GRID      )#     FS30  26
chardata:(FS35, SUMMATION ORDER OF HKL                           )#     FS30  27
chardata:(FS36, SUMMATION ALGORITHM                              )#     FS30  28
chardata:(FS37, DATASET NUMBER APPLIED                           )#     FS30  29
chardata:(FS38, RADIATION AND MAP UNITS   XXXXXXXXX     XXXXXXX/$#      FS30  30
ANG**3 )#                                                               FS30  31
chardata:(FS39, PRINTER COL/PT LINE/PT                           )#     FS30  32
chardata:(FS3A, ZERO COEFFICIENT APPLIED                         )#     FS30  33
chardata:(FS3B,[ FOURIER TRANSFORM COEFF  (FAC1*FAC2*SCL3-FAC4$#        FS30  34
)*FAC5*SCL6])#                                                          FS30  35
chardata:(FS3C, FOURIER TRANSFORM PHASE   FAC7 FAC8 FAC9)#              FS30  36
chardata:(FS3D,XYZ1ST2ND3RDLAYER DOWN  ACROSS)#                         FS30  37
chardata:(FS3E,[ SIN(THETA/LAM) MIN MAX                           ])#   FS30  38
chardata:(FS3F, ATOM COORDINATES FROM BDF-)#                            FS30  39
chardata:(FS3G, ATOM            X       Y       Z     GRIDX GRIDY $#    FS30  40
GRIDZ    MAPX  MAPY  MAPZ SYMOP)#                                       FS30  41
chardata:(FS3H,MODIFIED FFT  PHASE  SETFC/CRYLSQ )#                     FS30  42
chardata:(FS3I,PATT F**2 PATT F*E  PATT E*E-1E-MAP     $#               FS30  43
FOBS      FOBS-FCAL  FCAL      WEIGHT-FOBWFOB-WFCAL)#                   FS30  44
chardata:(FS3J,ATOM OUTSIDE MAP)#                                       FS30  45
chardata:(FS3K, MAP BOUNDARY IN X  GRID     -  TO   -  INCR.     )#     FS30  46
chardata:(FS3L, MAP BOUNDARY IN X COORDS       TO      A/PNT     )#     FS30  47
chardata:(FS3M, PRINTER DENSITY SCALE                            )#     FS30  48
chardata:(FS3N,NEUTRONS ELECTRONSXRAYS    )#                            FS30  49
chardata:(FS3O,PICO-CM/ANG**3VOLTS         ELECT.S/ANG**3)#             FS30  50
chardata:(FS3O1,ELECT.S/ANG    ELECT.S/ANG**2 ELECT.S/ANG**3)#          FS30  51
chardata:(FS3P, PRINTER DENSITY LIMITS                           )#     FS30  52
chardata:(FS3Q, SYMMETRY EQUIV. MAXHKL                           )#     FS30  53
chardata:(FS3R,[ INPUT GROUP SCALE(S)])#                                FS30  54
chardata:(FS3S, PRINTER DENSITY FORMAT       INCR          NORMAL)#     FS30  55
chardata:(FS3T, MAP FRACTION OF CELL VOLUME                      )#     FS30  56
chardata:(FS3U,NORMALPACKEDSHADED)#                                     FS30  57
chardata:(FS3V,BEEVERS-LIPSON  MODIFIED-FFT  )#                         FS30  58
chardata:(FS3X,COORDINATES FROM BDF..)# ....                            FS30  59
chardata:(FS3Y,SPACE GROUP SYMMETRY LAUE SYMMETRY       )#              FS30  60
chardata:(FS3Z," CALCULATED E(000) AND F(000)                     ")#   FS30  61
realdata:(FM1,[640612.,700612.,760612.])#                               FS30  62
realdata:(FM2,[310403.,360403.,410403.,460403.,520403.,570403.])#       FS30  63
realdata:(FM3,[210742.,290742.,370742.,#                                FS30  64
440612.,500612.,560612.,820313.])#                                      FS30  65
realdata:(FM4,[300413.,380413.,500413.])#                               FS30  66
realdata:(FM5,[310432.,390432.,500422.])#                               FS30  67
realdata:(FM7,[340413.,420413.,500413.])#                               FS30  68
datastuff:#                                                             FS30  69
#                                                                       FS30  70
#  SET MAP PARAMETERS ALONG MAP AXES                                    FS30  71
#  ---------------------------------                                    FS30  72
#                                                                       FS30  73
## The following MAP variables have indices based on: 1=layer;          FS30  74
## 2=down and 3=accross. These are referred to as the MAP axes.         FS30  75
## ICEL(), NG(), NP(), ORGX(), IXORG(), INCX(), IXINC(), IHMAX()        FS30  76
#                                                                       FS30  77
## These are transposed from CELL variables with indices based          FS30  78
## on the CELL axes (1=X, 2=Y, 3=Z). These variables are:               FS30  79
## IMAP(), GRID(), SPAN(), INCT(), ORGT(), MAXH()                       FS30  80
#                                                                       FS30  81
#                                                                       FS30  82
IF(IPROJ>0)#                           For projections set axes         FS30  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS30  84
GRID(JSUM1)=1#                         Set grid on project axis         FS30  85
SPAN(JSUM1)=1#                         Set span on project axis         FS30  86
MAXH(IPROJ)=0#                         Set maxh on project axis         FS30  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS30  88
DO J=1,3#                              Loop map axes (1=lay; 3=accr)    FS30  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FS30  90
JJ=ICEL(J)#                            Pick up the cell axes (1=x)      FS30  91
NG(J)=GRID(JJ)#                        Number of grid points per ce     FS30  92
NP(J)=(SPAN(JJ)-1)/INCT(JJ)+1#         Points to actually plotted       FS30  93
ORGX(J)=ORGT(JJ)#                      Published origin point           FS30  94
IXORG(J)=MOD(ORGX(J)+2*NG(J),NG(J))#   Assure+values for fs60 tlu       FS30  95
INCX(J)=INCT(JJ)#                      Increment or steps along axi     FS30  96
IXINC(J)=MOD(INCX(J)+2*NG(J),NG(J))#   Assure that increment will       FS30  97
IHMAX(J)=MAXH(JJ)#                     Maximum value of miller inde     FS30  98
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FS30  99
#                                                                       FS30 100
#                                                                       FS30 101
# FOR THE FFT METHOD, MAKE SURE THAT THE NUMBER OF POINTS ALONG         FS30 102
# THE AXES OF THE 2ND AND 3RD SUMS ARE ABLE TO FACTORED BY 2,3,4,5.     FS30 103
# IF THE ORIGINAL VALUES SUPPLIED FOR NG(2) AND NG(3) DONT MEET THIS    FS30 104
# CRITERION, ADJUST THEM SO THAT  THEY DO.  BUT FIRST MAKE SURE THAT    FS30 105
# NUMBERS NG(2) AND NG(3) ARE AT LEAST AS LARGE AS THE LARGEST HKL OR   FS30 106
# THE RESPECTIVE DIRECTIONS (I.E., IHMAX(2 OR 3) PLUS 1).               FS30 107
# MAKE SURE THE ORIGINS FOR THESE AXES ARE ZERO                         FS30 108
# IF ANY ADJUSTMENT  IS NECESSARY IT WILL BE DONE IN SUCH A WAY AS      FS30 109
# TO INCREASE THE FINENESS OF  THE GRID.  IF THE VALUE OF NG(3) S PPLIE FS30 110
# BY THE USER IS 46 (WHICH IS NOT EVENLY DIVISIBLE BY 2,3,4, AND 5) THE FS30 111
# VALUE OF NG(3) USED WILL BE 48 (THE NEXT HIGHER NUMBER WHICH MEETS TH FS30 112
# CRITERION OF FACTORABILITY).                                          FS30 113
# IN ORDER TO USE AS LITTLE STORAGE AS POSSIBLE, COUNT UP IN STOP2 AND  FS30 114
# STOP3 THE AMOUNT OF SPACE THAT WILL BE REQUIRED FOR THE KEY AND       FS30 115
# THE FACTOR LIST.                                                      FS30 116
#                                                                       FS30 117
STOP3=0;   STOP2=0#                    Set initial stops                FS30 118
IF(SUMFF==yes:)#                                                        FS30 119
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FS30 120
IF(IHMAX(2)>NG(2)) iquit:(FS3001)#     Bad resolution obtains           FS30 121
IF(IHMAX(3)>NG(3)) iquit:(FS3002)#     Bad resolution obtains           FS30 122
OLDG(2)=NG(2)#                         Save for comparison, in case     FS30 123
OLDG(3)=NG(3)#                                                          FS30 124
REPEAT#                                                                 FS30 125
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FS30 126
J=NG(3)#                                                                FS30 127
JJ=5#                                                                   FS30 128
WHILE ((J>1)&(JJ>=2))#                                                  FS30 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FS30 130
IF(J==(J/JJ)*JJ)#                                                       FS30 131
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FS30 132
J=J/JJ#                                                                 FS30 133
STOP3=STOP3+1#                         Add room for this factor         FS30 134
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FS30 135
ELSE JJ=JJ-1#                                                           FS30 136
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FS30 137
IF(J==1) BREAK#                                                         FS30 138
NG(3)=NG(3)+1#                                                          FS30 139
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FS30 140
REPEAT#                                                                 FS30 141
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FS30 142
J=NG(2)#                                                                FS30 143
JJ=5#                                                                   FS30 144
WHILE ((J>1)&(JJ>=2))#                                                  FS30 145
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FS30 146
IF(J==(J/JJ)*JJ)#                                                       FS30 147
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FS30 148
J=J/JJ#                                                                 FS30 149
STOP2=STOP2+1#                         Add room for this factor         FS30 150
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FS30 151
ELSE JJ=JJ-1#                                                           FS30 152
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FS30 153
IF(J==1) BREAK#                                                         FS30 154
NG(2)=NG(2)+1#                                                          FS30 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FS30 156
#                                                                       FS30 157
# ENSURE THAT, FOR SECOND AND THIRD SUMS FOR FFT, THE ORIGINS ALONG     FS30 158
# THE APPROPRIATE AXES ARE ZERO AND NO MORE THAN NG POINT ARE TO        FS30 159
# BE PRINTED FOR THOSE AXES.                                            FS30 160
#                                                                       FS30 161
DO J=2,3#                              Loop map axes (2=down;3=accr)    FS30 162
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FS30 163
IF(NP(J)>=OLDG(J))  NP(J)=NG(J)#                                        FS30 164
ORGX(J)=MAX0(ORGX(J),0)#               Negative origins not permitt     FS30 165
ISPAN=NP(J)*INCX(J)+ORGX(J)#           How far does the user want t     FS30 166
IF(ISPAN>NG(J))#                                                        FS30 167
NP(J)=(NG(J)-ORGX(J)-1)/INCX(J)+1#                                      FS30 168
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FS30 169
SPAN(JSUM2)=NP(2)*INCX(2)#             Reset total span down            FS30 170
SPAN(JSUM3)=NP(3)*INCX(3)#             Reset total span accross         FS30 171
GRID(JSUM2)=NG(2)#                     Reset grid down                  FS30 172
GRID(JSUM3)=NG(3)#                     Reset grid accross               FS30 173
ORGT(JSUM2)=ORGX(2)#                   Reset origin down                FS30 174
ORGT(JSUM3)=ORGX(3)#                   Reset origin accross             FS30 175
STOP2=STOP2+NG(2)#                     Save room for 2nd sum key        FS30 176
STOP3=STOP3+NG(3)#                     Save room for the 3rd sum key    FS30 177
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FS30 178
DO I=1,3#                              Loop cell axes (1=x;y=2;z=3)     FS30 179
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FS30 180
XLO(I)=FLOAT(ORGT(I))/FLOAT(GRID(I))#  Back calc start fraction         FS30 181
XHI(I)=XLO(I)+FLOAT(SPAN(I)-1)/FLOAT(GRID(I))# Back calc end fraction   FS30 182
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FS30 183
#                                                                       FS30 184
#                                                                       FS30 185
#   PRINT CONTROL SUMMARY                                               FS30 186
#   ---------------------                                               FS30 187
#                                                                       FS30 188
movechar:(FS3B,42,CHROT,2,NFS31-1,2)#  Underline control header         FS30 189
writeline:(1,FS31,NFS31,2,3)#          Print controls header            FS30 190
IF(CTYPE>0)#                           Test if calc type set            FS30 191
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FS30 192
movechar:(FS3I,CTYPE*10-9,FS32,28,10,0)# Insert transform type          FS30 193
movechar:(FS3Y,LAUE*21+1 ,FS32,42,20,0)# Insert symmetry type           FS30 194
writeline:(1,FS32,NFS32,3,3)#          Print transform type             FS30 195
IF(CTYPE>3)#                           Test if phases applied           FS30 196
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FS30 197
IF(CTYPE==4) J=15;  ELSE J=25#         Point to phase string            FS30 198
movechar:(FS3H,J,FS33,28,10,0)#        Insert phase string source       FS30 199
IF(CTYPE==4\PSET>0)#                   Test if gentan phase set     
ncodefld:(FLOAT(ABS(PSET)),1,FS33,400313.,1)# Format phase set     
writeline:(0,FS33,NFS33,3,3)#          Print phase source               FS30 202
IF(PTYPE>0)#                           Test if properties calculated    FS30 203
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FS30 204
movechar:(FS332,PTYPE*23-22,FS331,28,23,0)# Insert property type        FS30 205
writeline:(0,FS331,NFS331,3,3)#        Print property type              FS30 206
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FS30 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FS30 208
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FS30 209
IF(ICOEF==yes:)#                       Set for coeff line input         FS30 210
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FS30 211
CTYPE=0#                               Set to input coefficients        FS30 212
ncodefld:(COEF,1,CHROT,FM2,6)#         Format coeff idnums              FS30 213
writeline:(1,FS3B,NFS3B,2,3)#          Print coeff idnums               FS30 214
ncodefld:(COEF,7,CHROT,FM2,3)#         Format phase idnums              FS30 215
writeline:(0,FS3C,NFS3C,2,3)#          Print phase idnums               FS30 216
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FS30 217
movechar:(FS3N,IRAD*9-8,FS38,28,9,0)#  Insert radiation type            FS30 218
IF(PTYPE>0) movechar:(FS3O1,PTYPE*15-14,FS38,42,14,0)# Property units   FS30 219
ELSE        movechar:(FS3O,IRAD*14-13,FS38,42,14,0)# Map units          FS30 220
writeline:(0,FS38,NFS38,2,3)#          Print rad/density                FS30 221
#                                                                       FS30 222
DO I=1,3#                              Loop cell axes (1=x;y=2;z=3)     FS30 223
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FS30 224
movechar:(FS3D,I,FS34,18,1,0)#         Insert x, y, or z                FS30 225
movechar:(FS3D,IMAP(I)*6+7,FS34,28,6,0)# Insert direction               FS30 226
ncodefld:(FLOAT(GRID(I)),1,FS34,500413.,1)# Format grid number          FS30 227
writeline:(0,FS34,NFS34,3,3)#          Print orientation line           FS30 228
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FS30 229
DO I=1,3#                              Loop cell axes (1=x;y=2;z=3)     FS30 230
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FS30 231
movechar:(FS3D,I,FS3K,18,1,0)#         Insert x, y, or z                FS30 232
BUFOT(1)=FLOAT(ORGT(I))#               Store grid start                 FS30 233
BUFOT(2)=FLOAT(ORGT(I)+SPAN(I)-1)#     Store grid end                   FS30 234
BUFOT(3)=FLOAT(INCT(I))#               Store grid incr                  FS30 235
ncodefld:(BUFOT,1,FS3K,FM4,3)#         Format grid limits               FS30 236
writeline:(0,FS3K,NFS3K,3,3)#          Print grid limits                FS30 237
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FS30 238
DO I=1,3#                              Loop cell axes (1=x;y=2;z=3)     FS30 239
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FS30 240
movechar:(FS3D,I,FS3L,18,1,0)#         Insert x, y, or z                FS30 241
BUFOT(1)=XLO(I)#                       Store map start                  FS30 242
BUFOT(2)=XHI(I)#                       Store map end                    FS30 243
BUFOT(3)=CELLC(I)/FLOAT(GRID(I))#      Store angstroms per point        FS30 244
ncodefld:(BUFOT,1,FS3L,FM5,3)#         Format map limits                FS30 245
writeline:(0,FS3L,NFS3L,3,3)#          Print map limits                 FS30 246
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FS30 247
I=GRID(1)*GRID(2)*GRID(3)#             Calc total map elements          FS30 248
J=(SPAN(1)-1)*(SPAN(2)-1)*(SPAN(3)-1)# Calc total map elements          FS30 249
A=FLOAT(J)/FLOAT(I)#                   Calc fraction cell vol           FS30 250
ncodefld:(A,1,FS3T,500642.,1)#         Format fraction cell vol         FS30 251
writeline:(0,FS3T,NFS3T,2,3)#          Print fraction cell volume       FS30 252
#                                                                       FS30 253
movechar:(FS3V,SUMFF*14+1,FS36,37,14,0)# Insert fft header              FS30 254
writeline:(0,FS36,NFS36,3,3)#          Print fft header                 FS30 255
movechar:(FS3D,ISUM1*3+1,FS35,32,3,0)# Store summation order of h       FS30 256
movechar:(FS3D,ISUM2*3+1,FS35,40,3,0)# Store summation order of k       FS30 257
movechar:(FS3D,ISUM3*3+1,FS35,48,3,0)# Store summation order of l       FS30 258
writeline:(0,FS35,NFS35,3,3)#          Print hkl summation order        FS30 259
DO I=1,3; BUFOT(I)=FLOAT(MAXH(I))#     Store max hkl in buffer          FS30 260
ncodefld:(BUFOT,1,FS3Q,FM7,3)#         Format max hkl                   FS30 261
writeline:(0,FS3Q,NFS3Q,3,3)#          Print max hkl                    FS30 262
ncodefld:(STMN,1,FS3E,420642.,1)#      Format min st/l                  FS30 263
ncodefld:(STMX,1,FS3E,500642.,1)#      Format max st/l                  FS30 264
writeline:(0,FS3E,NFS3E,3,3)#          Print min/max st/l               FS30 265
#                                                                       FS30 266
ncodefld:(FLOAT(DSET),1,FS37,500213.,1)# Format data set number         FS30 267
writeline:(0,FS37,NFS37,3,3)#          Print data set number            FS30 268
ncodefld:(F000,1,FS3Z,500812.,1)#      Format f000 term                 FS30 269
ncodefld:(E000,1,FS3Z,420812.,1)#      Format e000 term                 FS30 270
writeline:(0,FS3Z,NFS3Z,3,3)#          Print calc f000 and e000         FS30 271
ncodefld:(FUSE,1,FS3A,500812.,1)#      Format f000 term                 FS30 272
writeline:(0,FS3A,NFS3A,2,3)#          Print f000 term                  FS30 273
#                                                                       FS30 274
IF(PRINT==yes:)#                       Test if map to be printed        FS30 275
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 FS30 276
movechar:(FS3S,1,CHROT,1,NFS3S,0)#     Insert format type               FS30 277
movechar:(FS3U,FORMAT*6-5,CHROT,45,6,0)# Insert format type             FS30 278
ncodefld:(FORSCL,1,CHROT,420413.,1)#   Format interval                  FS30 279
writeline:(0,0,0,1,3)#                 Print format type                FS30 280
ncodefld:(FLOAT(COLPNT),1,FS39,420313.,1)# Format col/p lin/p           FS30 281
ncodefld:(FLOAT(LINPNT),1,FS39,500313.,1)# Format col/p lin/p           FS30 282
writeline:(0,FS39,NFS39,3,3)#          Print col/p lin/p                FS30 283
LINPNT=LINPNT-1#                       Adjust lines/pnt for later       FS30 284
ncodefld:(SKAL,1,FS3M,500832.,1)#      Format printer scale             FS30 285
writeline:(0,FS3M,NFS3M,3,3)#          Print output scale               FS30 286
ncodefld:(UPLIM,1,FS3P,420713.,1)#     Format up density limit          FS30 287
ncodefld:(LOLIM,1,FS3P,500713.,1)#     Format lo density limit          FS30 288
writeline:(0,FS3P,NFS3P,3,3)#          Print density limits             FS30 289
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 FS30 290
#                                                                       FS30 291
LINRM=4#                               Force first scale header         FS30 292
DO I=1,NSCL#                           Loop over input scales           FS30 293
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 FS30 294
ncodefld:(FLOAT(I),1,CHROT,420213.,1)# Format group number              FS30 295
ncodefld:(SCALE(I),1,CHROT,500642.,1)# Format scale group               FS30 296
IF(I==1) movechar:(FS3R,1,CHROT,1,NFS3R,0)# Insert scale header         FS30 297
writeline:(0,0,0,1,3)#                 Print scale line                 FS30 298
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 FS30 299
#                                                                       FS30 300
#   GET ATOM LIST FROM BDF                                              FS30 301
#   ----------------------                                              FS30 302
#                                                                       FS30 303
IF(SFILE==yes:) N=3#                   Store no. of output file         FS30 304
ELSE            N=0#                   If none, signal it with 0        FS30 305
IWNT(1)=1;  IWNT(2)=2;  LINRM=4#       Request x/a, y/b                 FS30 306
IWNT(3)=3;  IWNT(4)=14#                Request z/b, name                FS30 307
KEY(1)=0; KEY(2)=4; KEY(3)=0; KEY(4)=0# Set search parameters           FS30 308
indexpkt:(1,lratom:,PSIZ,IP,N,KEY,IWNT,IREL)# Search for idnums         FS30 309
IF((IREL(1)*IREL(2)*IREL(3)*IREL(4))!=0)# Was anybody at home....       FS30 310
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 FS30 311
IF(PRNATM==yes:)#                      If atoms to be printed           FS30 312
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 FS30 313
LINRM=8#                               Get sufficient space for heade   FS30 314
movechar:(FS3F,NFS3F,CHROT,2,NFS3F-2,2)# Insert underline               FS30 315
writeline:(1,FS3F,NFS3F-1,2,3)#        Print a header                   FS30 316
LINRM=4#                               Force coord header               FS30 317
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 FS30 318
REPEAT#                                Loop over atom packets           FS30 319
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 FS30 320
readwpkt:(1,lratom:,PSIZ,IP,0)#        Point to next atom packet        FS30 321
IF(IP<=0) BREAK#                       Exit after last packet           FS30 322
IF(SFILE==yes:)#                       Copy packets to filec            FS30 323
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 FS30 324
writepkt:(3,lratom:,PSIZ,IPP)#         Point to output file             FS30 325
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Transfer atom coords             FS30 326
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 FS30 327
IF(PRNATM==yes:)#                      Are atoms to be printed?         FS30 328
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 FS30 329
JJ=IP+IREL(4)#                         Get pointer for atom name        FS30 330
movertoc:(QX(JJ),1,ATNAME,1,24,0)#     Move name to temp store          FS30 331
DO J=1,3#                              Loop over x,y,z                  FS30 332
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 FS30 333
JJ=IP+IREL(J); BUFOT(J)=QX(JJ)#        Buffer atom coordinate           FS30 334
BUFOT(J+3)=QX(JJ)*FLOAT(GRID(J))#      Convert coord to grid units      FS30 335
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 FS30 336
X=BUFOT(1);Y=BUFOT(2);Z=BUFOT(3)#      Restore x, y, z coords           FS30 337
TEM(7)=0.0#                            Prepare to tally symops          FS30 338
FOR(I=MARKS;I<STOPS;I=I+STEPS)#        Loop over sym matrices           FS30 339
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 FS30 340
TEM(7)=TEM(7)+1.0#                     Count up symops                  FS30 341
FOR(J=1;J<4;J=J+1)#                    Loop over x, y, z                FS30 342
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 FS30 343
K=I+J-1#                               Point to matrix elements         FS30 344
A=X*QX(K+1)+Y*QX(K+4)+Z*QX(K+7)+QX(K+10)# Tranform coordinate           FS30 345
A=MOD(A+100.,1.)#                      Reduce to positive cell          FS30 346
B=A-1.;  C=A+1.#                       Allow for cell either side       FS30 347
IF     (A>=XLO(J)&A<=XHI(J))A=A#       Store inside map limits          FS30 348
ELSE IF(B>=XLO(J)&B<=XHI(J))A=B#       Store inside map limits          FS30 349
ELSE IF(C>=XLO(J)&C<=XHI(J))A=C#       Store inside map limits          FS30 350
ELSE IF(PRNSYM==no:)     BREAK#        Coordinate not in map            FS30 351
TEM(J)=A*FLOAT(GRID(J))#               Convert to grid coords           FS30 352
TEM(J+3)=A#                            Also save fractionals            FS30 353
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 FS30 354
IF(J==4&PRNSYM==no:) BREAK#            All coords in map so exit        FS30 355
IF(PRNSYM==yes:)#                      Unless keyed to print all        FS30 356
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 FS30 357
movechar:(ATNAME,1,CHROT,2,24,0)#      Atom name to output              FS30 358
ncodefld:(TEM,1,CHROT,FM1,3)#          Put up grid coordinates          FS30 359
ncodefld:(TEM,4,CHROT,FM3,3)#          Put up transformed fractiona     FS30 360
ncodefld:(TEM,7,CHROT,FM3(7),1)#       Put out symmetry count           FS30 361
writeline:(0,FS3G,NFS3G,1,3)#          Print transformed                FS30 362
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 FS30 363
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 FS30 364
IF(PRNSYM==no:)#                       Check if no dump                 FS30 365
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 FS30 366
IF(I==STOPS)movechar:( FS3J,1,CHROT,61,16,0)# Atom outside map          FS30 367
ELSE ncodefld:(TEM,1,CHROT,FM1,3)#     Format tranformed coords         FS30 368
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 FS30 369
movechar:(ATNAME,1,CHROT,2,24,0)#      Atom name to output              FS30 370
IF(PRNSYM==yes:) movechar:(FS3X,1,CHROT,61,NFS3X,0)# ....               FS30 371
ncodefld:(BUFOT,1,CHROT,FM3,6)#        Format fract & grid coords       FS30 372
writeline:(0,FS3G,NFS3G,1,3)#          Print atom coords                FS30 373
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 FS30 374
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 FS30 375
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 FS30 376
STOPS=MARK1#                           Reset end symop table            FS30 377
#                                                                       FS30 378
RETURN#                                                                 FS30 379
END#                                                                    FS30 380
systemheader:(FS40)#                                                    FS40   1
# ################################################################## #  FS40   2
#                                                                    #  FS40   3
#                               FS40                                 #  FS40   4
#                                                                    #  FS40   5
# ################################################################## #  FS40   6
SUBROUTINE FS40#                       Part 4-cycling control           FS40   7
include:(AACOMN)#                      J.m.stewart,j.r.holden 1981      FS40   8
include:(FSCOMN)#                      R.doherty, s.r.hall 1982         FS40   9
#                                      V.a.streltsov 1993               FS40  10
#                                                                       FS40  11
INTEGER I,J,IP,JP,PSIZ#                                                 FS40  12
INTEGER LAYPAS#                        Number of layers per pass        FS40  13
INTEGER LAYSIZ#                        Storage for one layer            FS40  14
INTEGER MAXSIZ#                        Max. space available for lay     FS40  15
INTEGER MAXLIN#                                                         FS40  16
INTEGER KEY(4),JJ#                     Signals for indexpkt:            FS40  17
#                                                                       FS40  18
chardata:(FS41, MIN/MAX DENSITY VALUES                           )#     FS40  19
chardata:(FS42, MEAN ESD OF DENSITY                              )#     FS40  20
chardata:(FS47, GRID ACROSS PAGE BDF/PRINT                       )#     FS40  21
realdata:(FM3,[420413.,500413.])#                                       FS40  22
datastuff:#                                                             FS40  23
#                                                                       FS40  24
# THE CORE IS LAID OUT IN THE FOLLOWING WAY DURING THE SUMMATION        FS40  25
# THE I/O BUFFERS FOR FILEA AND FILEC                                   FS40  26
#                                                                       FS40  27
# MARKS /***************/    STEPS IS 12                                FS40  28
#       /THE SYMOPS     /                                               FS40  29
#       /IN ROTATION    /                                               FS40  30
#       /MATRIX FORM    /                                               FS40  31
# MARK2 /***************/    MARK1 /***************/                    FS40  32
#       /SINE COSINE    /          /               /                    FS40  33
#       /TABLE OF THE   /          /               /                    FS40  34
#       /SECOND SUM     /          /SINE COSINE    /                    FS40  35
# MARK3 /***************/          /TABLES OF THE  /                    FS40  36
#       /SINE COSINE    /          /FIRST SUMMATION/                    FS40  37
#       /TABLE FOR THE  /          /               /                    FS40  38
#       /THIRD SUMMATION/          /               /                    FS40  39
# MARK4 /***************/          /               /                    FS40  40
#       /COEFFICIENTS   /    STOP1/---------------/                     FS40  41
#       /OF THE THIRD   /    STOP1 CANNOT BE GREATER THAN MARK6         FS40  42
#       /SUMMATION FOR  /                                               FS40  43
#       /ONE COMPLETE   /    STEP1 IS  2 FOR SIN-COS                    FS40  44
#       /LAYER CUTTING  /    STEP2, STEP3, AND STEP4 ARE 2              FS40  45
#       /THE FIRST SUM  /    STEP5 IS 1                                 FS40  46
#       /DIRECTION      /    STEP6 IS 4                                 FS40  47
# MARK5 /***************/    MARK2=MARK1 AT END OF SYMOPS               FS40  48
#       /THIRD SUMMATION/    STOP2=MARK3-1                              FS40  49
#       /FOR ONE LINE OF/    STOP3=MARK4-1                              FS40  50
#       /ONE SHEET OF   /    STOP4=MARK5-1                              FS40  51
#       /OF THE FINAL,  /    STOP5=MARK6-1                              FS40  52
#       /THIRD SUMMATION/    STOP6 DEPENDS UPON THE AMOUNT OF CORE      FS40  53
# MARK6 /***************/    OR THE SIZE OF THE PROBLEM, WHICHEVER IS   FS40  54
#       /COEFFICIENTS   /    SMALLER IN THE GIVEN CASE                  FS40  55
#       /OF THE SECOND  /                                               FS40  56
#       /SUMMATION FOR  /                                               FS40  57
#       /AS MANY LAYERS /                                               FS40  58
#       /AS AVAILABLE   /                                               FS40  59
#       /CORE WILL ALLOW/                                               FS40  60
# STOP6/***************/                                                FS40  61
#                                                                       FS40  62
#                                                                       FS40  63
# CALCULATE THE CORE NEEDED FOR THE PROBLEM AT HAND.  THE INFLEXIBLE    FS40  64
# PART OF THE NEEDS ARE FOR THE FIRST SUM TRIG TABLES, THE OVERLAYING   FS40  65
# SECOND AND THIRD SUM TRIG TABLES PLUS THE COEFFICIENTS OF THE THIRD   FS40  66
# SUM FOR ONE COMPLETE LAYER PLUS THE THIRD SUM FOR ONE LINE.           FS40  67
#                                                                       FS40  68
IF(PASSES<0)#                          Test if first pass               FS40  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS40  70
MARK2=MARK1#                           Set marker for start of trig     FS40  71
STEP1=2; STEP2=2#                                                       FS40  72
STOP1=MARK1+2*NG(1)-1#                 Calc the end of first sum tr     FS40  73
#                                                                       FS40  74
# THE STORAGE REQUIREMENTS ARE SLIGHTLY DIFFERENT FOR THE FFT AND BEEVE FS40  75
# LIPSON METHODS. FFT NEEDS SPACE FOR THE UNSCRAMBLING KEY AND THE FACT FS40  76
# LIST FOR THE SECOND AND THIRD SUMS.  B-L NEEDS TWO LOCATIONS FOR EACH FS40  77
# GRID POINT (FOR THE SIN AND COS) FOR THE SECOND AND THIRD SUMS.       FS40  78
# SET THE MARKS TO TAKE BEST ADVANTAGE OF THE SPACE AVAILABLE.          FS40  79
#                                                                       FS40  80
IF(SUMFF==no:)#                        Beevers-lipson method            FS40  81
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FS40  82
STOP2=MARK1+2*NG(2)-1#                 Calc end of 2ond sum trigs       FS40  83
MARK3=STOP2+1#                         Set start of third sum trigs     FS40  84
STEP3=2#                                                                FS40  85
STOP3=MARK3+2*NG(3)-1#                 Set end of third sum trigs       FS40  86
MARK4=STOP3+1#                         Set start of third sum coeff     FS40  87
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FS40  88
ELSE#                                  Fft to be used                   FS40  89
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FS40  90
STOP2=STOP2+MARK2+1#                   Space needed was figured in      FS40  91
MARK3=STOP2#                           Subroutine fs30 where the        FS40  92
STOP3=STOP3+MARK3+1#                   Number of fft factors were       FS40  93
MARK4=STOP3#                           Figured out                      FS40  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FS40  95
STEP4=2#                                                                FS40  96
IH2MAX=IHMAX(2)+1#                     Set total index counts in        FS40  97
IH3MAX=IHMAX(3)+1#                     Second and third sum direction   FS40  98
IF(SUMFF==yes:) STOP4=MARK4+2*(NG(3)+1)*(NG(2)+1)-1#                    FS40  99
ELSE STOP4=MARK4+2*IPROP*(IH3MAX*NP(2))-1# Calc space for third sum     FS40 100
#ELSE STOP4=MARK4+2*(IH3MAX*NP(2))-1#   CALC SPACE FOR THIRD SUM        FS40 101
MARK5=STOP4+1#                         Set start of third sum result/   FS40 102
#                                                                       FS40 103
# NOW FIGURE OUT IF THE PAGES ARE WIDE ENOUGH TO TAKE THE WHOLE OF      FS40 104
# ONE THIRD SUM LINE AND SET UP NUMBER OF SHEETS PER LAYER              FS40 105
#                                                                       FS40 106
MAXLIN=prtcmax:-9+COLPNT#              Calculate maximum avail char     FS40 107
IF(MAXLIN<COLPNT) iquit:(FS4004)#      Die if not even one grid col     FS40 108
NSH=(COLPNT*NP(3)-1)/MAXLIN+1#         Calculate no. of sheets          FS40 109
NPR=MIN0(NP(3),(MAXLIN-1)/COLPNT+1)#                                    FS40 110
#                                                                       FS40 111
# IF IT WOULD TAKE MORE THAN ONE SHEET TO FIT IN ALL THE COLUMNS REQUES FS40 112
# TELL THE USER THAT ONLY THE NUMBER OF POINTS THAT WILL FIT ON ONE PAG FS40 113
# WILL BE PRINTED.  IF A SCRATCH FILE HAS BEEN REQUESTED, CALCULATE ALL FS40 114
# THE POINTS, BUT PRINT ONLY WHAT WILL FIT ON A PAGE.  IF THERE IS NO   FS40 115
# SCRATCH FILE, ONLY CALCULATE WHAT WILL FIT ON ONE PAGE IF THE         FS40 116
# BEEVERS-LIPSON METHOD IS BEING USED.  FOR FFT THE WHOLE GRID MUST     FS40 117
# BE CALCULATED REGARDLESS OF WHAT IS PRINTED.                          FS40 118
# IF ONLY A FRACTION OF THE POINTS WILL FIT ON ONE LINE, TRY TO         FS40 119
# REPRESENT THE WHOLE GRID BY PRINTING EVERY NTH POINT, WHERE N IS      FS40 120
# THE RECIPROCAL OF THE FRACTION OF POINTS THAT WILL FIT ON A LINE.     FS40 121
#                                                                       FS40 122
JUMP=1#                                Set increment for printing a     FS40 123
IF((NSH>1)&(PRINT==yes:))#             If sheets >1 & print on          FS40 124
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FS40 125
JUMP=(NP(3)-1)/NPR+1#                  Find out how many point to s     FS40 126
NPR=MIN0(NPR,(NP(3)-1)/JUMP+1)#        Adjust npr so that not too m     FS40 127
#                                                                       FS40 128
# IF THE B-L METHOD IS BEING USED AND THERE'S NO SCRATCH FILE, THERE'S  FS40 129
# NO POINT IN CALCULATING MORE THAN YOU NEED TO.                        FS40 130
# ALSO CHANGE THE VALUES FOR THE SECOND SUM DIRECTION SO THE SCALE WILL FS40 131
# BE PRESERVED.                                                         FS40 132
#                                                                       FS40 133
IF((SFILE==no:)&(SUMFF==no:))#         If bl sum & no filec             FS40 134
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FS40 135
INCX(2)=INCX(2)*JUMP#                  Modify for fraction calcd        FS40 136
INCX(3)=INCX(3)*JUMP#                  Modify for fraction calcd        FS40 137
JUMP=1#                                But be ready to print all        FS40 138
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FS40 139
#                                                                       FS40 140
ELSE IF((SFILE==no:)&(SUMFF==yes:))#   If fft sum & no filec            FS40 141
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FS40 142
IF((JUMP<=6)&(NG(3)/JUMP*JUMP==NG(3))&(NG(2)/JUMP*JUMP==NG(2)))#        FS40 143
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FS40 144
NG(2)=NG(2)/JUMP#                                                       FS40 145
NG(3)=NG(3)/JUMP#                                                       FS40 146
NP(2)=MIN0(NPR,NG(2))#                                                  FS40 147
NP(3)=MIN0(NPR,NG(3))#                                                  FS40 148
JUMP=1#                                                                 FS40 149
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FS40 150
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FS40 151
BUFOT(1)=FLOAT(NP(3))#                 Store points calculated          FS40 152
BUFOT(2)=FLOAT(NP(3)/JUMP)#            Store points printed             FS40 153
ncodefld:(BUFOT,1,FS47,FM3,2)#         Format points printed            FS40 154
writeline:(1,FS47,NFS47,3,3)#          Print points printed             FS40 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FS40 156
#                                                                       FS40 157
IF(SUMFF==yes:) STOP5=MARK5+NG(3)+1#   Calc space needed for fft        FS40 158
ELSE            STOP5=MARK5+IPROP*NP(3)-1# Calc space for portion of    FS40 159
#ELSE            STOP5=MARK5+NP(3)-1#   CALC SPACE FOR PORTION OF A     FS40 160
STEP5=1#                               Of a sheet of a layer            FS40 161
#                                                                       FS40 162
# THE CORE NEEDED SO FAR IS THE MAXIMUM OF STOP1 OR STOP5 PLUS ONE      FS40 163
# DEPENDING ON WHICH IS LARGER.  ANOTHER SAVINGS IS POSSIBLE            FS40 164
# HOWEVER.  THE COEFFICIENTS OF THE VERY FIRST LAYER OF THE             FS40 165
# SECOND SUM ARE STORED IN THE FIRST OF THE MARK6 ARRAY.                FS40 166
# THESE COEFFICIENTS MAY, THEREFORE BE OVERWRITTEN DURING THE           FS40 167
# THIRD SUM. THE MODICUM OF STORAGE WHICH CAN BE SALVAGED IS            FS40 168
# EITHER ALL OF MARK5 OR AT LEAST THE FIRST LAYER OF SECOND             FS40 169
# SUM COEFFICIENTS INTO MARK5.                                          FS40 170
#                                                                       FS40 171
IF(SUMFF==yes:) LAYSIZ=4*(NG(2)+1)*(NG(3)+1)# If fft algorithm          FS40 172
ELSE            LAYSIZ=4*IH2MAX*IH3MAX# For beever-lipson strips        FS40 173
MARK6=MAX0(STOP1+1,STOP5+1)#           Calculate storage needed         FS40 174
incrqx:(I,MARK6,FS4001)#               Incr qx........fs4001            FS40 175
STEP6=4; STOP6=MARK6+IPROP*LAYSIZ*NP(1)-1# Calculate the needed stora   FS40 176
#STEP6=4; STOP6=MARK6+LAYSIZ*NP(1)-1#   CALCULATE THE NEEDED STORAGE    FS40 177
MAXSIZ=QXMAX-MARK6#                    Calc the maximum size avail      FS40 178
IF(MAXSIZ<=LAYSIZ) iquit:(FS4002)#     Not enough mem for one layer     FS40 179
#                                                                       FS40 180
#  RATIONALIZE LAYERS PER PASS, ETC.                                    FS40 181
#  ---------------------------------                                    FS40 182
#                                                                       FS40 183
LAYPAS=MAXSIZ/LAYSIZ#                  Figure out number of layers      FS40 184
PASSES=(NP(1)+LAYPAS-1)/LAYPAS#        Calc the number of passes re     FS40 185
LAYPAS=(NP(1)+PASSES-1)/PASSES#        Now equalize the layers per      FS40 186
NPP1=LAYPAS#                           Set no. of layers for first      FS40 187
STOP6=IPROP*LAYPAS*LAYSIZ+MARK6-1#     Recalculate end of store         FS40 188
#STOP6=LAYPAS*LAYSIZ+MARK6-1#           RECALCULATE END OF STORE        FS40 189
IF(QXMAX<STOP6+2) iquit:(FS4003)#      Cannot continue                  FS40 190
qxmemory:(STOP6+2)#                    Request and zero memory          FS40 191
PASSES=-PASSES#                        Flag number passes for later     FS40 192
#                                                                       FS40 193
#                                                                       FS40 194
#   ENTER REFLECTION DATA FROM LRREFL                                   FS40 195
#   ---------------------------------                                   FS40 196
#                                                                       FS40 197
IWNT(1)=1;  IWNT(2)=2#                 Request hkl & st/l               FS40 198
IWNT(3)=308+DSET*1000#                 Request rcode                    FS40 199
DO I=1,10#                             Loop over coefficients           FS40 200
IWNT(I+3)=MAX0(0,NINT(COEF(I)))#       Store requested idnum            FS40 201
IWNT(14)=304+DSET*1000#                Request frel for rej test        FS40 202
IWNT(15)=800+DSET*1000#                Request fcal for rej test        FS40 203
IWNT(16)=309+DSET*1000#                Request sclg for rej test        FS40 204
IWNT(17)=305+DSET*1000#                Request sigf for sig dens        FS40 205
IWNT(18)=3#                            Get reflectiom multiplicity      FS40 206
KEY(1)=2; KEY(2)=18; KEY(3)=0; KEY(4)=0# Set search parameters          FS40 207
indexpkt:(1,lrrefl:,PSIZ,IP,0,KEY,IWNT,IREL)# Scan directory            FS40 208
#                                                                       FS40 209
#  CHECK ON ITEMS REQUESTED                                             FS40 210
#  ------------------------                                             FS40 211
#                                                                       FS40 212
IF(KEY(4)<0) iquit:(FS4005)#           No hkl/stol........fs4005        FS40 213
IF((IREL(4)==0)&(CTYPE==5\CTYPE==6))#  Is ad-correct frel there         FS40 214
IREL(4)=IREL(14)#                      If not set to norm frel          FS40 215
IF((IREL(4)==0)&(CTYPE==8\CTYPE==9))#  Is ad-correct frel there         FS40 216
IREL(4)=IREL(14)#                      If not set to norm frel          FS40 217
DO I=1,2#                              Loop over coeff array            FS40 218
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FS40 219
IF((IREL(I+3)==0)&(COEF(I  )>0.5)\$#   Test if coeff missing            FS40 220
   (IREL(I+6)==0)&(COEF(I+3)>0.5))#    Test if coeff missing            FS40 221
iquit:(FS4006)#                        Coef missing.....fs4006          FS40 222
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FS40 223
IPHI=no:#                              Set no phases required           FS40 224
IF((IREL(10)+IREL(11))>0) IPHI=1#      Set phase from a & b             FS40 225
IF(IREL(12)>0)            IPHI=2#      Set phase from phi               FS40 226
IF((COEF(7)+COEF(8)+COEF(9)>.5)&(IPHI==0))# Test phase is missing       FS40 227
iquit:(FS4007)#                        Phi missing........fs4007        FS40 228
IF((IREL(14)==0)\(IREL(15)==0))#       Test if frel & fcal missing      FS40 229
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FS40 230
FREJ=no:; LREJ=MIN0(LREJ,0)#           Switch off rej flags             FS40 231
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FS40 232
#                                                                       FS40 233
#   OUTPUT MAP DATA TO FILEC                                            FS40 234
#   ------------------------                                            FS40 235
#                                                                       FS40 236
IF(SFILE==yes:)#                       Is output filec required         FS40 237
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FS40 238
PSIZ=41#                               Setup packet for misc data       FS40 239
writepkt:(3,21,PSIZ,IP)#               Point to op packet               FS40 240
DO J=1,3#                              Loop cell axes (1=x;2=y;3=z)     FS40 241
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FS40 242
JJ=IP+J#                               Point to op buffer               FS40 243
QX(JJ  )=FLOAT(ORGX(J))#               Store transformed start          FS40 244
QX(JJ+3)=FLOAT(INCX(J))#               Store transformed incr           FS40 245
QX(JJ+6)=FLOAT(NG  (J))#               Store transformed grid           FS40 246
QX(JJ+9)=FLOAT(NP  (J))#               Store transformed points         FS40 247
QX(JJ+12)=FLOAT(IMAP(J))#              Store map codes for x,y,z        FS40 248
QX(JJ+15)=FLOAT(ICEL(J))#              Store cell codes for l,d,a       FS40 249
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FS40 250
QX(IP+18)=FLOAT(JSUM3)#                Store cell code for accross      FS40 251
QX(IP+19)=UPLIM#                       Store upper print limit          FS40 252
QX(IP+20)=LOLIM#                       Store lower print limit          FS40 253
IF(CTYPE>7) QX(IP+21)=FLOAT(CTYPE-3)#  Store calc type for pekpik       FS40 254
ELSE        QX(IP+21)=FLOAT(CTYPE)#    Store calc type for pekpik       FS40 255
QX(IP+22)=FUSE#                        Store f000 term added            FS40 256
QX(IP+23)=FLOAT(IABS(PASSES))#         Store total passes               FS40 257
QX(IP+24)=SKAL#                        Store print scale                FS40 258
QX(IP+40)=FLOAT(PTYPE)#                Property 0=ed 1=ep 2=ef 3=eg     FS40 259
QX(IP+41)=FLOAT(IPROP)#                Number of components             FS40 260
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FS40 261
#                                                                       FS40 262
#                                     ********END OF INITIALIZATION***  FS40 263
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS40 264
#                                                                       FS40 265
# ON SUBSEQUENT PASSES DECREMENT THE PASS COUNT                         FS40 266
# ---------------------------------------------                         FS40 267
#                                                                       FS40 268
ELSE#                                                                   FS40 269
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FS40 270
IXORG(1)=IXORG(1)+NPP1*IXINC(1)#       Move the origin of first sum     FS40 271
ORGX(1)=ORGX(1)+NPP1*INCX(1)#          Move perceived origin also       FS40 272
NP(1)=NP(1)-NPP1#                      And decrement the points to      FS40 273
PASSES=PASSES-1#                       Decrement pass count             FS40 274
IXORG(1)=MOD(IXORG(1)+2*NG(1),NG(1))#  Keep it modulo the number of     FS40 275
#                                                                       FS40 276
IF(PASSES>0)#                          Test if passes still to go       FS40 277
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FS40 278
rewindbdf:(1)#                         Reposition the file              FS40 279
readwpkt:(1,lrrefl:,PSIZ,IP,0)#        Point to lrrefl packet           FS40 280
NPP1=(NP(1)+PASSES-1)/PASSES#          Calculate the number of points   FS40 281
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FS40 282
ELSE#                                  Else this is last pass           FS40 283
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FS40 284
IF(CTYPE==6&IBDF==yes:)#               Test if difference map           FS40 285
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FS40 286
rewindbdf:(1)#                         Restart the input bdf            FS40 287
copyfile:(1,2,1,decr:(lrmole:))#       Copy up to molecular record      FS40 288
IWNT(1)=1; IWNT(2)=22; IWNT(3)=23#     Request f000 and e000            FS40 289
KEY(1)=0; KEY(2)=0; KEY(3)=3; KEY(4)=0# Set in update mode              FS40 290
indexpkt:(1,lrmole:,PSIZ,IP,2,KEY,IWNT,IREL)# Scan directory            FS40 291
IF(IP<=0)#                             If directory missing             FS40 292
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FS40 293
writepkt:(2,lrmole:,KEY(3),IP)#        Point to output dir              FS40 294
DO I=1,KEY(3); QX(IP+I)=FLOAT(IWNT(I))# Store directory items           FS40 295
writepkt:(2,lrmole:,KEY(3),IP)#        Point to output dir              FS40 296
QX(IP+1)=FLOAT(DSET)#                  Store data set value             FS40 297
QX(IP+2)=F000#                         Store f(000) value               FS40 298
QX(IP+3)=E000#                         Store e(000) value               FS40 299
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FS40 300
ELSE#                                  Lrmole already exists            FS40 301
REPEAT#                                Loop over data sets              FS40 302
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FS40 303
readwpkt:(1,lrmole:,PSIZ,IP,0)#        Read the next packet             FS40 304
IF(IP<=0) BREAK#                       Exit after last packet           FS40 305
writepkt:(2,lrmole:,KEY(4),JP)#        Point to output dir              FS40 306
movereal:(QX,IP+1,QX,JP+1,PSIZ,0)#     Transfer existing data           FS40 307
IF(NINT(QX(IP+IREL(1)))!=DSET) NEXT#   Skip if not requested dataset    FS40 308
QX(JP+IREL(2))=F000#                   Store f(000) value               FS40 309
QX(JP+IREL(3))=E000#                   Store e(000) value               FS40 310
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FS40 311
#                                                                       FS40 312
copyfile:(1,2,incr:(lrmole:),decr:(lrdens:))# Copy to density record    FS40 313
writepkt:(2,lrdens:,3,IP)#             Point to output dir              FS40 314
QX(IP+1)=1.; QX(IP+2)=11.; QX(IP+3)=12.# Store directory items          FS40 315
writepkt:(2,lrdens:,3,IP)#             Point to output packet           FS40 316
QX(IP+1)=FLOAT(DSET)#                  Store data set number            FS40 317
QX(IP+2)=DENMIN#                       Store minimum density            FS40 318
QX(IP+3)=DENMAX#                       Store maximum density            FS40 319
copyfile:(1,2,incr:(lrdens:),endrecord:)# Finish off copy               FS40 320
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FS40 321
ELSE readwpkt:(1,endrecord:,PSIZ,IP,0)# Close out input file            FS40 322
IF(SFILE==yes:)#                                                        FS40 323
writepkt:(3,endrecord:,3,IP)#                                           FS40 324
ncodefld:(DENMIN,1,FS41,420622.,1)#    Format min density found         FS40 325
ncodefld:(DENMAX,1,FS41,500622.,1)#    Format max density found         FS40 326
writeline:(1,FS41,NFS41,2,3)#          Print density limits             FS40 327
IF(PTYPE==0)#                          Errors in density                FS40 328
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FS40 329
ERR=SQRT(2.0*ERR)/VOL#                 Mean esd of density              FS40 330
ncodefld:(ERR,1,FS42,420622.,1)#       Format esd of density            FS40 331
writeline:(0,FS42,NFS42,2,3)#          Print esd of density             FS40 332
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FS40 333
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FS40 334
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FS40 335
#                                                                       FS40 336
RETURN#                                                                 FS40 337
END#                                                                    FS40 338
systemheader:(FS50)#                   First sum builder                FS50   1
# ################################################################## #  FS50   2
#                                                                    #  FS50   3
#                               FS50                                 #  FS50   4
#                                                                    #  FS50   5
# ################################################################## #  FS50   6
SUBROUTINE FS50#                       Part 5-first sum of transfor     FS50   7
include:(AACOMN)#                      J.m.stewart,j.r.holden 1981      FS50   8
include:(FSCOMN)#                      R.doherty,k.watenpaugh 1982      FS50   9
#                                      V.a.streltsov 1992               FS50  10
INTEGER I,IREJ,IS,J,K,L,M,N,IP,JCOD,PSIZ#                               FS50  11
INTEGER IXORG1,IXINC1#                                                  FS50  12
INTEGER IPT1,IPT2,IPT3,IPT4#                                            FS50  13
INTEGER IPT5,IPT6,IPT7,IPT8#                                            FS50  14
INTEGER IPT9,IPT10,IPT11,IPT12#                                         FS50  15
INTEGER IPT13,IPT14,IPT15,IPT16,IPT17,IPT18#                            FS50  16
INTEGER LH(3),IH(3),ISG1,ISG2,ISG3#                                     FS50  17
INTEGER SIGNCD,ZEROCD#                                                  FS50  18
INTEGER NG1,NG1P,NP1,NCENT,IHXS,TNG1,TINCHX#                            FS50  19
INTEGER SUM1BE,SUM1ST,IH2MP1#                                           FS50  20
INTEGER ID(48),KD(48),JS1,JS2,JS3#                                      FS50  21
INTEGER KH(48),KK(48),KL(48),KP(48)#                                    FS50  22
INTEGER IJ,KI,MN,NM#                                                    FS50  23
REAL XAN#                                                               FS50  24
REAL H(3),A,SIGF,STOL,STOL2,XSTOL,TEMP#                                 FS50  25
REAL FSIN,FCOS,FAC1,FAC2,FAC4,FAC5#                                     FS50  26
REAL REFCNT(12),HMAX(3)#                                                FS50  27
REAL AN(40),AB(8),AC(5),AMUL#                                           FS50  28
#                                                                       FS50  29
chardata:(FS52, REFLECTIONS REJECTED                              )#    FS50  30
chardata:(FS53,RCODE GT 2ST/L LIMITHKL LIMIT NO COEFF.SFR/FC RC=1$#     FS50  31
RCODE GT 1FR/FC RC=2FC SMALL  NSIGF GT F )#                             FS50  32
chardata:(FS55, REFLECTIONS APPLIED                               )#    FS50  33
realdata:(TWOPI,6.2831853);   realdata:(TINY,.0000001)#                 FS50  34
realdata:(PI,3.1415927);   realdata:(FOUPI,.0795775)#                   FS50  35
realdata:(SG,[-1.,1.,1.,1.,-1.,1.,1.,-1.,1.,1.,1.,-1.,#                 FS50  36
1.,-1.,-1.,1.,1.,1.,1.,-1.,-1.,1.,-1.,-1.])#                            FS50  37
intdata:(IK,[1,5,12,6,7,11,3,8,10,2,4,9,#                               FS50  38
13,17,24,18,19,23,15,20,22,14,16,21])#                                  FS50  39
intdata:(IN,[1,1,1,3,3,3,4,4,4,2,2,2,#                                  FS50  40
13,13,13,15,15,15,16,16,16,14,14,14])#                                  FS50  41
realdata:(SI,[1.,1.,-1.,-1.,-1.,1.,1.,1.,1.,-1.,1.,1.,1.,1.,-1.,#       FS50  42
1.,1.,1.,1.,-1.,#                                                       FS50  43
1.,1.,1.,-1.,1.,1.,1.,1.,-1.,1.,-1.,1.,1.,-1.,1.,#                      FS50  44
1.,-1.,1.,1.,1.])#                                                      FS50  45
intdata:(IG,[1,5,7,14,18,6,10,13,19,2,8,11,15,17,3,9,12,16,20,4,#       FS50  46
21,25,27,34,38,22,26,30,33,39,28,31,35,37,23,29,32,36,40,24])#          FS50  47
intdata:(IR,[1,1,1,1,1,2,2,2,2,2,3,3,3,3,4,4,4,4,4,8,#                  FS50  48
21,21,21,21,21,22,22,22,22,22,23,23,23,23,24,24,24,24,24,28])#          FS50  49
intdata:(JSTOR,[1,2,3,4,1,2,3,4,1,2,4,3,1,2,4,3])#                      FS50  50
realdata:(FACTOR,[1.,1.,1.,1.,1.,1.,1.,1.,1.,-1.,-1.,1.,1.,-1.,-1.,1.])#FS50  51
intdata:(ISTOR,[1,2,1,2,2,1,2,1])#                                      FS50  52
intdata:(ISTORE,[2,1,2,1,1,2,1,2])#                                     FS50  53
realdata:(D1,[1.,0.,.5,0.,-.5,0.,-1.,0.,-.5,0.,.5,0.])#                 FS50  54
realdata:(D2,[.0,.0,.8660254,1.,.8660254,.0,.0,.0,-.8660254,-1.,#       FS50  55
-.8660254,.0])#                                                         FS50  56
realdata:(D3,[.0,.0,-.8660254,-1.,-.8660254,.0,.0,.0,.8660254,1.,#      FS50  57
.8660254,.0])#                                                          FS50  58
realdata:(D4,[1.,0.,.5,0.,-.5,0.,-1.,0.,-.5,0.,.5,0.])#                 FS50  59
realdata:(AA,[0.,0.,0.,0.,0.,0.,0.,0.])#                                FS50  60
intdata:(FLIP,[0,0,0,1,0,1,1,1])#                                       FS50  61
intdata:(SIGNS,[0,3,2,1,1,2,3,0])#                                      FS50  62
realdata:(SN,[1.,1.,1.,1.,-1.,1.,1.,-1.,-1.,-1.,1.,1.,-1.,1.,-1.,1.,#   FS50  63
1.,-1.,1.,1.,1.,1.,-1.,1.,-1.,1.,1.,1.,1.,1.,1.,-1.])#                  FS50  64
intdata:(REJF,0); intdata:(JS,0); intdata:(KS,0)#                       FS50  65
realdata:(AFAC,0.); realdata:(BFAC,0.); realdata:(FREL,0.)#             FS50  66
realdata:(FCAL,0.)#                                                     FS50  67
realdata:(AH,0.); realdata:(AK,0.); realdata:(AL,0.)#                   FS50  68
datastuff:#                                                             FS50  69
#                                                                       FS50  70
#   PREPARE FOR FIRST SUMMATION                                         FS50  71
#   ---------------------------                                         FS50  72
#                                                                       FS50  73
DO I=1,12; REFCNT(I)=0.#               Zero refln counts                FS50  74
JS1=JSUM1+1; JS2=JSUM2+1; JS3=JSUM3+1# Store coeff sum order            FS50  75
NG1=NG(1); NP1=NPP1#                   Make as local variables          FS50  76
TNG1=2*NG1#                            Grid for interleaved sin cos     FS50  77
IF(SUMFF==yes:) IH2MP1=NG(2)#          Set sum 2 for fft                FS50  78
ELSE            IH2MP1=IH2MAX#         Set sum 2=maxh+1 for bl          FS50  79
SUM1ST=4*IH3MAX*IH2MP1#                Set the first sum stepper        FS50  80
NG1P=STOP1+1#                          Set end sum1 as local            FS50  81
IF(IPHI==0) ICNT=0#                    If no phase force centric        FS50  82
IF(ICNT==0) NCENT=4#                   Set hkl loop for centric         FS50  83
ELSE        NCENT=8#                   Set hkl loop for acentric        FS50  84
IREJ=FREJ+LREJ+FCREJ+SREJ#             Set overall rej flag             FS50  85
MN=8*IPROP#                            Set an loop for properties       FS50  86
NM=4*(IPROP-1)#                        Set increment for imag prop.     FS50  87
#                                                                       FS50  88
# SET UP SIN COS TABLES FOR FIRST SUM                                   FS50  89
# -----------------------------------                                   FS50  90
#                                                                       FS50  91
TEMP=TWOPI/FLOAT(NG(1));  A=0.#        Get first sum grid step          FS50  92
DO  I=MARK1,STOP1,STEP1#               Loop over sum1 grid              FS50  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS50  94
QX(I+1)=COS(A); QX(I+2)=SIN(A)#        Store interleaved cos sin        FS50  95
A=A+TEMP#                              Incr to next angle               FS50  96
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS50  97
#                                                                       FS50  98
# CLEAR THE FIRST SUM TABLE OF SECOND SUM COEFFICIENTS                  FS50  99
# ----------------------------------------------------                  FS50 100
#                                                                       FS50 101
DO J=MARK6,STOP6; QX(J+1)=0.#          Zeroize sum 2 coefficients       FS50 102
DO J=1,NROT ; KD(J)=J#                 Set default hkl sort order       FS50 103
DO J=1,3; IH(J)=9#                     Reset reflection indices         FS50 104
DO J=1,3; LH(J)=0#                     Reset reflection indices         FS50 105
XSTOL=0.0#                                                              FS50 106
DO J=1,3; HMAX(J)=FLOAT(MAXH(J))+.5#   Float hkl maxima                 FS50 107
IS=1;  FSIN=0.;  FCOS=1.#              Reset sign & imag factor         FS50 108
AA(1)=FUSE/2.#                         Place f(000) as coeff1           FS50 109
IXINC1=IXINC(1)#                       Move incr to local store         FS50 110
IXORG1=IXORG(1)#                       Same for origin                  FS50 111
IPT1=IREL(1);    IPT2=IREL(2)#         Make pointer local variable      FS50 112
IPT3=IREL(3);    IPT4=IREL(4)#         Make pointer local variable      FS50 113
IPT5=IREL(5);    IPT6=IREL(6)#         Make pointer local variable      FS50 114
IPT7=IREL(7);    IPT8=IREL(8)#         Make pointer local variable      FS50 115
IPT9=IREL(9);    IPT10=IREL(10)#       Make pointer local variable      FS50 116
IPT11=IREL(11);  IPT12=IREL(12)#       Make pointer local variable      FS50 117
IPT13=IREL(13);  IPT14=IREL(14)#       Make pointer local variable      FS50 118
IPT15=IREL(15);  IPT16=IREL(16)#       Make pointer local variable      FS50 119
IPT17=IREL(17)#                        Make pointer local variable      FS50 120
IPT18=IREL(18)#                        Make pointer local variable      FS50 121
FAC1=ABS(COEF(1)); FAC2=ABS(COEF(2))#  Make coeff local variables       FS50 122
FAC4=ABS(COEF(4)); FAC5=ABS(COEF(5))#  Make coeff local varaibles       FS50 123
IF(COEF(3)>.5) ISG1=1;  ELSE ISG1=65#  Activate only if requested       FS50 124
IF(COEF(6)>.5) ISG2=1;  ELSE ISG2=65#  Activate only if requested       FS50 125
SCALE(65)=1.;  ISG3=1;  JCOD=1#        Set as default scale             FS50 126
#                                                                       FS50 127
#                                                                       FS50 128
#   START HEMISPHERE REFLECTION LOOP                                    FS50 129
#   ===============================                                     FS50 130
#                                                                       FS50 131
#                                                                       FS50 132
REPEAT#                                Loop over all reflections        FS50 133
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FS50 134
readwpkt:(1,lrrefl:,PSIZ,IP,0)#        Read next reflection packet      FS50 135
IF(IP<=0) GOTO75#                      Test if last packet              FS50 136
#                                                                       FS50 137
I=IP+IPT1; gethkl:(I,H); REJF=5#       Unpack h,k,l                     FS50 138
DO I=1,3#                              Loop over h,k,l                  FS50 139
IF(ABS(H(I))>HMAX(I)) GOTO100#         Reject if outside limits         FS50 140
#                                                                       FS50 141
I=IP+IPT2; STOL=QX(I); REJF=4#         Extract st/l                     FS50 142
IF(STOL<STMN\STOL>STMX)     GOTO100#   Skip if outside stol limits      FS50 143
#                                                                       FS50 144
I=IP+IPT3; IF(I>IP) TEMP=QX(I)#        Extract reflection jcode         FS50 145
REJF=3;    ifvo:(TEMP)      GOTO100#   Ignore if void data              FS50 146
IF(I>IP) JCOD=NINT(TEMP)#              Store jcode as integer           FS50 147
REJF=3; IF(JCOD>2)          GOTO100#   Ignore jcodes > 2                FS50 148
REJF=8; IF(LREJ<0&JCOD>1)   GOTO100#   Reject by jcode2 test            FS50 149
#                                                                       FS50 150
I=IP+IPT4; IF(I>IP) FAC1=QX(I)#        Extract factor 1                 FS50 151
REJF=6; ifvo:(FAC1)         GOTO100#   Reject if coeff missing          FS50 152
I=IP+IPT5; IF(I>IP) FAC2=QX(I)#        Extract factor 2                 FS50 153
ifvo:(FAC2)                 GOTO100#   Reject if coeff missing          FS50 154
I=IP+IPT6; IF(I>IP) TEMP=QX(I)#        Extract scale group 1            FS50 155
ifvo:(TEMP)                 GOTO100#   Ignore if void data              FS50 156
IF(I>IP) ISG1=NINT(TEMP)#              Store scale group as integer     FS50 157
I=IP+IPT7; IF(I>IP) FAC4=QX(I)#        Extract factor 4                 FS50 158
ifvo:(FAC4)                 GOTO100#   Reject if coeff missing          FS50 159
I=IP+IPT8; IF(I>IP) FAC5=QX(I)#        Extract factor 5                 FS50 160
ifvo:(FAC5)                 GOTO100#   Reject if coeff missing          FS50 161
I=IP+IPT9; IF(I>IP) TEMP=QX(I)#        Extract scale group 2            FS50 162
ifvo:(TEMP)                 GOTO100#   Ignore if void data              FS50 163
IF(I>IP) ISG2=NINT(TEMP)#              Store scale group as integer     FS50 164
#                                                                       FS50 165
IF(IPHI==1)#                           Test if a and b requested        FS50 166
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FS50 167
I=IP+IPT10; IF(I>IP) AFAC=QX(I)#       Extract real fc component        FS50 168
ifvo:(AFAC)                 GOTO100#   Reject if afac missing           FS50 169
I=IP+IPT11; IF(I>IP) BFAC=QX(I)#       Extract imag fc component        FS50 170
ifvo:(BFAC)                 GOTO100#   Reject if bfac missing           FS50 171
A=AMAX1(TINY,SQRT(AFAC**2+BFAC**2))#   Calculate /fcal/                 FS50 172
FCOS=AFAC/A#                           Calculate cosphi                 FS50 173
IF(ICNT==1) FSIN=BFAC/A#               Calculate sinphi                 FS50 174
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FS50 175
ELSE IF(IPHI==2)#                      Test if phi requested            FS50 176
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FS50 177
I=IP+IPT12; IF(I>IP) A=QX(I)#          Extract phi in cycles            FS50 178
ifvo:(A)                    GOTO100#   Reject if phi missing            FS50 179
FCOS=COS(A*TWOPI)#                     Calculate cosphi                 FS50 180
IF(ICNT==1) FSIN=SIN(A*TWOPI)#         Calculate sinphi                 FS50 181
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FS50 182
#                                                                       FS50 183
IF(PTYPE==0\IREJ>0)#                   Test density or reject           FS50 184
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FS50 185
I=IP+IPT16; IF(I>IP) TEMP=QX(I)#       Extract scale group 3            FS50 186
ifvo:(TEMP) GOTO50#                    Ignore if void data              FS50 187
IF(I>IP) ISG3=NINT(TEMP)#              Store scale group as integer     FS50 188
I=IP+IPT17; IF(I>IP) SIGF=QX(I)#       Extract extract sigma f          FS50 189
ifvo:(SIGF) GOTO50#                    Ignore if void data              FS50 190
I=IP+IPT18; IF(I>IP) intunpak:(QX(I),J,0,5)# Extract ref mult           FS50 191
AMUL=FLOAT(J)#                         Reflection multiplicity          FS50 192
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FS50 193
IF(IREJ>0)#                            Test if rej tests applied        FS50 194
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FS50 195
I=IP+IPT14; IF(I>IP) FREL=QX(I)#       Extract frel value               FS50 196
ifvo:(FREL) GOTO50#                    Skip test if missing             FS50 197
I=IP+IPT15; IF(I>IP) FCAL=QX(I)#       Extract fcal value               FS50 198
ifvo:(FCAL) GOTO50#                    Skip test if missing             FS50 199
IF(FCREJ==yes:&FCAL<FCMIN)#            Test if fc ok to phase           FS50 200
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FS50 201
REJF=10;  GOTO100#                     Set reject type and leave it     FS50 202
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FS50 203
IF(FREJ==yes:&JCOD==1)#                Is jcode1 test requested         FS50 204
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FS50 205
REJF=7#                                Set reject flag in case          FS50 206
IF(FREL*SCALE(ISG3)*RR1>FCAL) GOTO100# Reject from ratio                FS50 207
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FS50 208
ELSE IF(LREJ==yes:&JCOD==2)#           If jcode2 test requested         FS50 209
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FS50 210
REJF=9#                                Set reject flag in case          FS50 211
IF(FREL*SCALE(ISG3)*RR2>FCAL) GOTO100# Reject from ratio                FS50 212
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FS50 213
IF(SREJ==yes:)#                        Is sigma  test requested         FS50 214
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FS50 215
REJF=11#                               Set reject flag in case          FS50 216
IF(SIGF*RRS>FREL) GOTO100#             Reject from sigma ratio          FS50 217
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FS50 218
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FS50 219
#                                                                       FS50 220
#   CALCULATE A & B COEFFICIENTS                                        FS50 221
#   ----------------------------                                        FS50 222
#                                                                       FS50 223
50 CONTINUE#                           Branch point for reject          FS50 224
IF(PTYPE>0)  STOL2=STOL*STOL#          Sin(t)/lambda squared            FS50 225
IF(PTYPE==1) FAC5=-FOUPI/STOL2#        Factor for potential             FS50 226
IF(PTYPE==2) FAC5=.5/STOL2#            Factor for electric field        FS50 227
IF(PTYPE==3) FAC5=PI/STOL2#            Factor for el.field gradient     FS50 228
A=(FAC1*FAC2*SCALE(ISG1)-FAC4)*FAC5*SCALE(ISG2)# Calculate coeff        FS50 229
AFAC=A*FCOS#                           Calculate real term              FS50 230
IF(ICNT==1) BFAC=A*FSIN#               Calculate imag term              FS50 231
AH=H(1); AK=H(2); AL=H(3)#             Restore as local variables       FS50 232
REJF=2#                                Set no rejection flag            FS50 233
#                                                                       FS50 234
#                                                                       FS50 235
#   MEAN ESD OF DENSITY. ASSUME CENTRIC DISTRIBUTION OF REFLECTIONS     FS50 236
#   ---------------------------------------------------------------     FS50 237
#                                                                       FS50 238
IF(PTYPE==0)#                          Error in density                 FS50 239
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FS50 240
ifnv:(SIGF) ERR=ERR+AMUL*SIGF*SIGF*SCALE(ISG3)**2# Sum error terms      FS50 241
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FS50 242
#                                                                       FS50 243
#   GENERATE SYMMETRY RELATED REFLECTIONS FOR ACTUAL SUMMATION          FS50 244
#   ----------------------------------------------------------          FS50 245
#                                                                       FS50 246
L=0; M=0; N=0#                         Zero duplicate counts            FS50 247
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symmetry matrices      FS50 248
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FS50 249
M=M+1#                                 Count generated reflections      FS50 250
KH(M)=NINT(AH*QX(J+1)+AK*QX(J+2)+AL*QX(J+3))# Generate new h            FS50 251
KK(M)=NINT(AH*QX(J+4)+AK*QX(J+5)+AL*QX(J+6))# Generate new k            FS50 252
KL(M)=NINT(AH*QX(J+7)+AK*QX(J+8)+AL*QX(J+9))# Generate new l            FS50 253
KP(M)=NINT((AH*QX(J+10)+AK*QX(J+11)+AL*QX(J+12))*12.)# Phase shift      FS50 254
IF(NRSZ==NROT) NEXT#                   Skip if no duplicates            FS50 255
K=IABS(KL(M))*261244+IABS(KK(M))*512+IABS(KH(M))# Form sort word        FS50 256
FOR(I=1;I<=N;I=I+1)#                   Loop over duplicate list         FS50 257
IF(K==KD(I))BREAK#                     Exit search on match             FS50 258
ID(M)=I#                               Store duplicate order            FS50 259
IF(I<=N) NEXT#                         Skip if old duplicate            FS50 260
KD(I)=K; N=I#                          Update if new duplicate          FS50 261
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FS50 262
FOR(I=1;I<=N;I=I+1)#                   Loop over duplicate list         FS50 263
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FS50 264
DO J=1,NROT#                           Loop over equiv hkl list         FS50 265
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FS50 266
IF(ID(J)!=I) NEXT#                     Skip on no match                 FS50 267
L=L+1; KD(L)=J#                        Store duplicate sort order       FS50 268
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FS50 269
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FS50 270
#                                                                       FS50 271
#     SUM EQUIVALENT HKL IN SORTED ORDER                                FS50 272
#     ----------------------------------                                FS50 273
#                                                                       FS50 274
75     CONTINUE#                       Branch point for last packet     FS50 275
FOR(JS=1;JS<=NROT;JS=JS+1)#            Loop over hkl list               FS50 276
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FS50 277
KS=KD(JS)#                             Pick up sequence number          FS50 278
IH(ISUM1)=IABS(KH(KS))#                Sorted h permuted                FS50 279
IH(ISUM2)=IABS(KK(KS))#                Sorted k permuted                FS50 280
IH(ISUM3)=IABS(KL(KS))#                Sorted l permuted                FS50 281
#                                                                       FS50 282
#     SUM COEFFICIENT IF NEXT HKL HAS DIFFERENT MAGNITUDE OF HKL        FS50 283
#     ----------------------------------------------------------        FS50 284
#                                                                       FS50 285
IF(LH(1)!=IH(1)\LH(2)!=IH(2)\LH(3)!=IH(3)\IP<=0)# Test if identical t   FS50 286
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FS50 287
#                                                                       FS50 288
#    ACCUMULATE THE FIRST SUM                                           FS50 289
#    ------------------------                                           FS50 290
#                                                                       FS50 291
SUM1BE=4*(LH(2)+LH(3)*IH2MP1)+MARK6#   Set beginning of first sum       FS50 292
IHXS=2*MOD(LH(1)*IXORG1,NG1)+MARK1#    Point to sin cos values          FS50 293
TINCHX=2*MOD(LH(1)*IXINC1,NG1)#        Make hx incr for index           FS50 294
L=0#                                   Set sign counter                 FS50 295
IF(SUMFF==yes:) J=8#                   Set pointer for fft              FS50 296
ELSE            J=0#                   Set pointer for b-l              FS50 297
IF(PTYPE<2)#                           Test if summ for el.den.and po   FS50 298
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FS50 299
DO K=1,NCENT#                          Loop over sign coeff             FS50 300
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FS50 301
IF(K<=4)#                              Test if real summation           FS50 302
A=SN(L+1)*AA(    1)+SN(L+2)*AA(JS1  )$# Sum real coefficients           FS50 303
+ SN(L+3)*AA(JS2  )+SN(L+4)*AA(JS3  )# Sum real coefficients            FS50 304
ELSE#                                  Else are imaginary               FS50 305
A=SN(L+1)*AA(    5)+SN(L+2)*AA(JS1+4)$# Sum imag coefficients           FS50 306
+ SN(L+3)*AA(JS2+4)+SN(L+4)*AA(JS3+4)# Sum imag coefficients            FS50 307
J=J+1;   L=L+4#                        Increment pointer                FS50 308
IF(ABS(A)<TINY) NEXT#                  Ignore zero coeff.s              FS50 309
A=A*FACTOR(J)*SCAL#                    Store coeff as local variabl     FS50 310
M=JSTOR(J)+SUM1BE#                     Extract storage offset value     FS50 311
N=ISTOR(K)+IHXS#                       Point to sin(hx) cos(hx)         FS50 312
DO I=1,NP1#                            Loop over first sum points       FS50 313
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 FS50 314
QX(M)=QX(M)+A*QX(N)#                   Form first fourier sum           FS50 315
M=M+SUM1ST#                            Increment storage pointer        FS50 316
N=N+TINCHX#                            Increment hx pointer             FS50 317
IF(N>NG1P) N=N-TNG1#                   Adjust hx if off b-l strip       FS50 318
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 FS50 319
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FS50 320
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FS50 321
ELSE#                                  Test if summ for el.fld and gr   FS50 322
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 FS50 323
DO K=1,MN;  AN(K)=0.#                  Reset coefficients               FS50 324
DO K=1,NCENT#                          Loop over sign coeff             FS50 325
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 FS50 326
IF(K<=4)#                              Test if real summation           FS50 327
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 FS50 328
AN(K)=SN(L+1)*AA(    1)+SN(L+2)*AA(JS1  )$# Sum real coefficients       FS50 329
+ SN(L+3)*AA(JS2  )+SN(L+4)*AA(JS3  )# Sum real coefficients            FS50 330
AB(K)=AN(K)#                           Store real coefficients          FS50 331
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 FS50 332
ELSE#                                  Else are imaginary               FS50 333
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 FS50 334
AN(K+NM)=SN(L+1)*AA(    5)+SN(L+2)*AA(JS1+4)$# Sum imag coefficients    FS50 335
+ SN(L+3)*AA(JS2+4)+SN(L+4)*AA(JS3+4)# Sum imag coefficients            FS50 336
AB(K)=AN(K)#                           Store imag coefficients          FS50 337
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 FS50 338
L=L+4#                                 Increment pointer                FS50 339
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 FS50 340
AA(1)=LH(1)#                           Store first index                FS50 341
AA(2)=LH(2)#                           Store second index               FS50 342
AA(3)=LH(3)#                           Store third index                FS50 343
IF(PTYPE==2)#                          Test if el. field                FS50 344
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 FS50 345
DO K=1,MN; AN(IK(K))=SG(K)*AN(IN(K))#  Sort coefficients for el.field   FS50 346
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 FS50 347
ELSE#                                  Test if el.field gradient        FS50 348
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 FS50 349
DO K=1,MN; AN(IG(K))=SI(K)*AN(IR(K))#  Sort coefficients for gradient   FS50 350
AA(1)=LH(1)*LH(1)#                     Form first part of 11 componen   FS50 351
AA(2)=LH(1)*LH(2)#                     Form first part of 12 componen   FS50 352
AA(3)=LH(1)*LH(3)#                     Form first part of 13 componen   FS50 353
AA(4)=LH(2)*LH(3)#                     Form first part of 23 componen   FS50 354
AA(5)=LH(3)*LH(3)#                     Form first part of 33 componen   FS50 355
AC(1)=CMETR(JCODE(1))*XSTOL#           Form second part of 11 compone   FS50 356
AC(2)=CMETR(JCODE(2))*XSTOL#           Form second part of 12 compone   FS50 357
AC(3)=CMETR(JCODE(3))*XSTOL#           Form second part of 13 compone   FS50 358
AC(4)=CMETR(JCODE(4))*XSTOL#           Form second part of 23 compone   FS50 359
AC(5)=CMETR(JCODE(5))*XSTOL#           Form second part of 33 compone   FS50 360
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 FS50 361
DO K=1,NCENT#                          Loop over sign coeff             FS50 362
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 FS50 363
KI=(K-1)*IPROP#                        Increment pointer                FS50 364
J=J+1#                                 Increment pointer                FS50 365
IF(PTYPE==2&$#                         Test if el. field                FS50 366
   ABS(AN(KI+1))<TINY&$#               Ignore zero coeff.s              FS50 367
   ABS(AN(KI+2))<TINY&$#               Ignore zero coeff.s              FS50 368
   ABS(AN(KI+3))<TINY) NEXT#           Ignore zero coeff.s              FS50 369
IF(PTYPE==3&$#                         Test if el. field gradient       FS50 370
   ABS(AN(KI+1))<TINY&$#               Ignore zero coeff.s              FS50 371
   ABS(AN(KI+2))<TINY&$#               Ignore zero coeff.s              FS50 372
   ABS(AN(KI+3))<TINY&$#               Ignore zero coeff.s              FS50 373
   ABS(AN(KI+4))<TINY&$#               Ignore zero coeff.s              FS50 374
   ABS(AN(KI+5))<TINY) NEXT#           Ignore zero coeff.s              FS50 375
A=FACTOR(J)*SCAL#                      Sign and scale factor            FS50 376
M=JSTOR(J)+SUM1BE#                     Extract storage offset value     FS50 377
IF(PTYPE==3) N=ISTOR(K)+IHXS#          Point to cos(hx) sin(hx)         FS50 378
ELSE N=ISTORE(K)+IHXS#                 Point to sin(hx) cos(hx)         FS50 379
DO I=1,NP1#                            Loop over first sum points       FS50 380
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 FS50 381
DO IJ=1,IPROP#                         Loop over all components         FS50 382
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 FS50 383
IF(PTYPE==2) XAN=AN(KI+IJ)*AA(IJ)#     Form coefficient for el. field   FS50 384
ELSE XAN=AN(KI+IJ)*AA(IJ)-AB(K)*AC(IJ)# Form coefficient for e.f.g      FS50 385
QX(M)=QX(M)+A*QX(N)*XAN#               Form first fourier sum           FS50 386
M=M+SUM1ST#                            Increment storage pointer        FS50 387
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 FS50 388
N=N+TINCHX#                            Increment hx pointer             FS50 389
IF(N>NG1P) N=N-TNG1#                   Adjust hx if off b-l strip       FS50 390
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 FS50 391
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 FS50 392
XSTOL=1.3333333333*STOL2#              Reset current sin(t)/lambda      FS50 393
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 FS50 394
LH(1)=IH(1); LH(2)=IH(2); LH(3)=IH(3)# Reset current hkl to last        FS50 395
DO J=1,NCENT; AA(J)=0.#                Reset all coefficients           FS50 396
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FS50 397
IF(IP<=0) BREAK#                       End of first summation           FS50 398
#                                                                       FS50 399
#                                                                       FS50 400
#     HAVING REDUCED THE PATTERN OF SIGNS AND ZEROS TO TWO              FS50 401
#     INTEGER VALUES ACCORDING TO THE FOLLOWING TABLE IT IS             FS50 402
#     NECESSARY TO MAKE THE SIGN CODE CONFORM TO THE METHOD             FS50 403
#     OF SUMMATION.  THE APPROACH TAKEN IS HEURISTIC AND                FS50 404
#     NOT AT ALL INTELLECTUALLY SATISFYING.                             FS50 405
#     THE VALUES IN THE TABLE ARE A FUNCTION OF THE CHOICE OF           FS50 406
#     HEMISPHERE AT THE TIME THE GENERAL FOURIER EXPRESSION             FS50 407
#     IS FACTORED.                                                      FS50 408
#                                                                       FS50 409
#     SIGNS    ZEROS     SIGNCD      ZEROCD                             FS50 410
#     +++     NNN         0           0                                 FS50 411
#     ++-     NN0         1           1                                 FS50 412
#     +-+     N0N         2           2                                 FS50 413
#     +--     N00         3           3                                 FS50 414
#     -++     0NN         4           4                                 FS50 415
#     -+-     0N0         5           5                                 FS50 416
#     --+     00N         6           6                                 FS50 417
#     ---     000         7           7                                 FS50 418
#                                                                       FS50 419
#      THIS TABLE SHOWS THE CODES REQUIRED TO PRODUCE THE CORRECT       FS50 420
#      FOURIER TRANSFORM AS A FUNCTION OF SIGNCD AND ZEROCD. THE        FS50 421
#      IF STATEMENT WHICH FOLLOWS THE TABLE TRANSFORMS THE SIGNCD       FS50 422
#      VALUE TO CONFORM TO THE TABLE VALUE                              FS50 423
#      THE BODY OF THE TABLE CONTAINS THE CORRECT VALUES OF             FS50 424
#      SIGNCD.  THE AXIAL AND ZONAL REFLECTIONS ARE THE                 FS50 425
#      PROBLEM.                                                         FS50 426
#                                                                       FS50 427
#            ZEROCD'S                                                   FS50 428
#              0    1    2    3    4    5    6    7                     FS50 429
#   SIGNCD'S                                                            FS50 430
#      0       0    0    0    0    0    0    0    0                     FS50 431
#      1       1         3         5         7                          FS50 432
#      2       2    3              2    7                               FS50 433
#      3       3                   7                                    FS50 434
#      4       4    4    4    7                                         FS50 435
#      5       5         7                                              FS50 436
#      6       6    7                                                   FS50 437
#      7       7                                                        FS50 438
#                                                                       FS50 439
IF(KL(KS)<0) SIGNCD=1#                 Get sign code of l               FS50 440
ELSE         SIGNCD=0#                                                  FS50 441
IF(KK(KS)<0) SIGNCD=SIGNCD+2#          Add on sign code of k            FS50 442
IF(KH(KS)<0) SIGNCD=SIGNCD+4#          And that of h                    FS50 443
IF(KL(KS)==0) ZEROCD=1#                Set zero code of l               FS50 444
ELSE          ZEROCD=0#                                                 FS50 445
IF(KK(KS)==0) ZEROCD=ZEROCD+2#         Add on zero code of k            FS50 446
IF(KH(KS)==0) ZEROCD=ZEROCD+4#         And that of h                    FS50 447
IF((MOD(SIGNCD,2)==1)\ $#              Decode axial & zonal codes       FS50 448
((SIGNCD==2)&(ZEROCD!=4))\ $#          Decode axial & zonal codes       FS50 449
((SIGNCD==4)&(ZEROCD==3))\ $#          Decode axial & zonal codes       FS50 450
(SIGNCD==6)) SIGNCD=SIGNCD+ZEROCD#     Decode axial & zonal codes       FS50 451
#                                                                       FS50 452
#                                                                       FS50 453
#                                                                       FS50 454
#     GENERATE THE CONTRIBUTION OF THE CURRENT REFLECTION A AND B       FS50 455
#     AS TRANSFORMED BY THE SYMMETRY DRIVERS INTO                       FS50 456
#     A(+++), OR A(-++), OR A(+-+), OR A(++-) AND                       FS50 457
#     B(+++), OR B(-++), OR B(+-+), OR B(++-) WHICH ARE STORED          FS50 458
#      IN A(1) TO A(8) RESPECTIVELY.........                            FS50 459
#                                                                       FS50 460
#                                                                       FS50 461
IF(IPHI>0) IS=MOD(KP(KS)+4800,12)+1#   Get phase shift in 12ths         FS50 462
J=SIGNS(SIGNCD+1)#                     Permute the sign codes           FS50 463
AA(J+1)=D1(IS)*AFAC+D2(IS)*BFAC#       Phase shift real coeff           FS50 464
IF(ICNT==0) NEXT#                      Skip imag part if centric        FS50 465
AA(J+5)=D3(IS)*AFAC+D4(IS)*BFAC#       Phase shift imag coeff           FS50 466
IF(FLIP(SIGNCD+1)==yes:) AA(J+5)=-AA(J+5)# Is hkl in rev. hemisphere    FS50 467
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FS50 468
IF(IP<=0) BREAK#                       Exit if last hkl                 FS50 469
#                                                                       FS50 470
#  COUNT REFLECTION USAGE                                               FS50 471
#  ----------------------                                               FS50 472
#                                                                       FS50 473
100 CONTINUE#                                                           FS50 474
REFCNT(1)=REFCNT(1)+1.#                Count all bdf reflections        FS50 475
REFCNT(REJF)=REFCNT(REJF)+1.#          Count refl. by reject            FS50 476
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FS50 477
#                                                                       FS50 478
#                                                                       FS50 479
#    PRINT REFLECTION SUMMARY FIRST PASS                                FS50 480
#    -----------------------------------                                FS50 481
#                                                                       FS50 482
IF(PASSES<0)#                          Test if first pass               FS50 483
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 FS50 484
ncodefld:(REFCNT,2,FS55,500803.,1)#    Format refln num used            FS50 485
writeline:(1,FS55,NFS55,3,3)#          Print refln num used             FS50 486
DO I=3,12#                             Loop over reject counts          FS50 487
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 FS50 488
IF(REFCNT(I)<0.5) NEXT#                Skip null counts                 FS50 489
ncodefld:(REFCNT,I,FS52,500803.,1)#    Format reject count              FS50 490
movechar:(FS53,I*10-29,FS52,30,10,0)#  Insert reject type               FS50 491
writeline:(0,FS52,NFS52,3,3)#          Print rejection count            FS50 492
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 FS50 493
IF(SUMFF==yes:) CALL FS51#             Set initial factor list          FS50 494
PASSES=IABS(PASSES)#                   Passes +ve first time            FS50 495
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 FS50 496
ELSE IF(SUMFF==yes:) CALL FS51#        Set initial factor list          FS50 497
#                                                                       FS50 498
RETURN#                                                                 FS50 499
END#                                                                    FS50 500
systemheader:(FS51)#                                                    FS51   1
#******************************************************************#    FS51   2
#                                                                  #    FS51   3
#                              FS51                                #    FS51   4
#                                                                  #    FS51   5
#******************************************************************#    FS51   6
SUBROUTINE FS51#                                                        FS51   7
include:(AACOMN)#                                                       FS51   8
include:(FSCOMN)#                                                       FS51   9
#                                                                       FS51  10
# THIS PROGRAM FACTORS THE NUMBER OF POINTS ALONG AN AXIS, AND          FS51  11
# MAKES A TABLE OF POINTERS THAT WILL BE USED TO UNSCRAMBLE THE ARRAY   FS51  12
# AFTER THE FFT HAS BEEN DONE.                                          FS51  13
# THE POINTERS ARE STORED IN THE FIRST N LOCATIONS AFTER START.  THE    FS51  14
# POINTERS ARE FOLLOWED BY THE FACTORS IN ORDER OF DECREASING MAGNITUDE FS51  15
# DOHERTY, 10/80                                                        FS51  16
#                                                                       FS51  17
INTEGER NTEST#                                                          FS51  18
INTEGER START#                         Pointer to place before begi     FS51  19
INTEGER I23#                           Index to tell whether 2nd or     FS51  20
INTEGER IS#                            End of key and factor list       FS51  21
INTEGER N#                             Number of grid points along      FS51  22
INTEGER I#                                                              FS51  23
INTEGER LK#                            Index for pointer table          FS51  24
INTEGER L#                             Index for loop that steps ov     FS51  25
INTEGER K#                             Index for loop that steps ov     FS51  26
INTEGER J#                             Index for factor list            FS51  27
REAL  ADD#                             Contribution to pointer from     FS51  28
REAL MULT#                             Multiplier for step size for     FS51  29
REAL F#                                Format for output of factors     FS51  30
#                                                                       FS51  31
chardata:(FS81, THE NUMBER OF POINTS ALONG THE AXIS FOR THE        $#   FS51  32
SUM IS    .)#                                                           FS51  33
chardata:(FS82, THE FACTORS USED IN THE FAST FOURIER TRANSFORM ON $#    FS51  34
THIS AXIS ARE-)#                                                        FS51  35
chardata:(FS83,SECOND)#                                                 FS51  36
chardata:(FS84,THIRD )#                                                 FS51  37
datastuff:#                                                             FS51  38
#                                                                       FS51  39
# THE FACTOR LIST MUST BE FOUND FOR BOTH THE SECOND AND THIRD SUMS.     FS51  40
# FIND THE FACTORS AND CONSTRUCT THE KEY NEEDED TO UNSCRAMBLE THE       FS51  41
# COMPLETED FOURIER TRANSFORM FOR THE TWO SUMS.                         FS51  42
#                                                                       FS51  43
K=MARK2+1#                             Begin by zeroing the locatio     FS51  44
DO J=K,STOP3#                          Do it for both 2nd and 3rd s     FS51  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS51  46
QX(J)=0.#                                                               FS51  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS51  48
START=MARK2#                           Do the key for the second su     FS51  49
IS=STOP2#                                                               FS51  50
FOR(I23=2;I23<=3;I23=I23+1)#                                            FS51  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FS51  52
IF(I23==3)#                            If this is for 3rd sum, put      FS51  53
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FS51  54
START=MARK3#                                                            FS51  55
IS=STOP3#                                                               FS51  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FS51  57
N=NG(I23)#                             Pick up the number of grid p     FS51  58
#                                                                       FS51  59
#                                                                       FS51  60
# SET UP FOR FACTOR SEARCH                                              FS51  61
#                                                                       FS51  62
J=START+N+1#                           Pointer for factors              FS51  63
I=5#                                   First possible factor            FS51  64
MULT=1.#                               Multiplier is 1 for the firs     FS51  65
NTEST=N#                                                                FS51  66
#                                                                       FS51  67
# THE SEARCH FOR FACTORS WILL CONTINUE AS LONG AS ANY REMAIN.  AS EACH  FS51  68
# FACTOR IS FOUND, NTEST IS DIVIDED BY THAT FACTOR.  WHEN NTEST IS 1, A FS51  69
# THE FACTORS HAVE BEEN FOUND.                                          FS51  70
# A PRELIMINARY SCREENING IN FS30 HAS ENSURED THAT NG CONTAINS ONLY THE FS51  71
# PERMITTED FACTORS (I.E., 2,3,4 OR 5).                                 FS51  72
#                                                                       FS51  73
WHILE ((NTEST>1)&(I>=2))#              Go on until all factors are      FS51  74
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FS51  75
IF(NTEST==(NTEST/I)*I)#                This is true if i is a facto     FS51  76
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FS51  77
QX(J)=FLOAT(I)#                        Store the factor i in the fa     FS51  78
NTEST=NTEST/I#                         Remove this factor for next      FS51  79
J=J+1#                                 Increment index of factor ar     FS51  80
#                                                                       FS51  81
# BEGIN TO BUILD UP THE CONTRIBUTIONS TO THE KEY FOR UNSCRAMBLING THE   FS51  82
# COMPLETED TRANSFORM.  EACH FACTOR WILL MAKE A CONTRIBUTION TO EACH    FS51  83
# ITEM IN THE KEY.                                                      FS51  84
#                                                                       FS51  85
ADD=0.#                                                                 FS51  86
LK=START#                                                               FS51  87
DO L=1,N,NTEST#                                                         FS51  88
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FS51  89
DO K=1,NTEST#                                                           FS51  90
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FS51  91
LK=LK+1#                                                                FS51  92
QX(LK)=QX(LK)+ADD#                                                      FS51  93
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FS51  94
ADD=AMOD(ADD+MULT,FLOAT(I)*MULT)#                                       FS51  95
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FS51  96
MULT=MULT*FLOAT(I)#                                                     FS51  97
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FS51  98
ELSE I=I-1#                            I was not a factor, so move      FS51  99
IF(J>IS) iquit:(FS5101)#               Don't allow more factors tha     FS51 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FS51 101
#                                                                       FS51 102
# REPORT THE FACTORS OF THE NUMBER OF GRID POINTS FOR THE SECOND OR THI FS51 103
# SUM AS APPROPRIATE (A LOW PRIORITY  ITEM). BUT ONLY THE FIRST TIME.   FS51 104
#                                                                       FS51 105
IF(PASSES<0)#                                                           FS51 106
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FS51 107
movechar:(FS81,1,CHROT,1,NFS81,0)#                                      FS51 108
IF(START==MARK2) movechar:(FS83,1,CHROT,46,NFS83,0)# For 2nd sum        FS51 109
ELSE movechar:(FS84,1,CHROT,46,NFS84,0)# For third sum                  FS51 110
BUFOT(1)=FLOAT(N)#                                                      FS51 111
ncodefld:(BUFOT,1,CHROT,620313.,1)#                                     FS51 112
writeline:(1,0,0,1,5)#                                                  FS51 113
writeline:(0,FS82,NFS82,3,5)#                                           FS51 114
F=40113.#                              Initialize format for factor     FS51 115
I=START+N+1#                           Mark beginning of factor lis     FS51 116
DO J=I,IS#                                                              FS51 117
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FS51 118
ncodefld:(QX,J,CHROT,F,1)#                                              FS51 119
IF(QX(J+1)<=small:) BREAK#                                              FS51 120
F=F+40000.#                                                             FS51 121
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FS51 122
writeline:(0,0,0,1,5)#                                                  FS51 123
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FS51 124
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FS51 125
RETURN#                                                                 FS51 126
END#                                                                    FS51 127
systemheader:(FS60)#                                                    FS60   1
# ################################################################## #  FS60   2
#                                                                    #  FS60   3
#                               FS60                                 #  FS60   4
#                                                                    #  FS60   5
# ################################################################## #  FS60   6
SUBROUTINE FS60#                       Part 6-second and third sums     FS60   7
include:(AACOMN)#                      J.m.stewart,j.r.holden 1981      FS60   8
include:(FSCOMN)#                      R.doherty, s.r.hall 1982         FS60   9
#                                      V.a.streltsov 1992               FS60  10
# THESE ROUTINES PRODUCE THE RECIPROCAL                                 FS60  11
# SPACE TO DIRECT SPACE FOURIER TRANSFORM FROM THE COEFFICIENTS         FS60  12
# PRODUCED BY THE FIRST SUM PROGRAM FS50.  THE SECOND SUM COEFFICIENTS  FS60  13
# (FIRST SUM RESULTS) WHICH CAN BE HELD IN IMMEDIATE ACCESS STORAGE ARE FS60  14
# TREATED.  THE PROGRAM IS A RECODING OF FBSM OF XRAY76.  IT IS BASED   FS60  15
# ON A CODE FIRST WORKED OUT BY L. JENSEN AND D. HIGH FOR THE IBM 650 I FS60  16
# ABOUT 1955. THIS CODE IS BY J.STEWART AND J. HOLDEN , FEB. 1979       FS60  17
# QX(MARK1+1)    THE MARK1 ARRAY IS THE INTERLEAVED COS AND SIN STRIP   FS60  18
# QX(MARK1+2)    FOR FIRST SUM STEP1=2                                  FS60  19
# QX(MARK2+1)    TRIG TABLES FOR SECOND SUM S. MARK2=MARK1              FS60  20
# QX(MARK2+2)                                                           FS60  21
# QX(MARK3+1)    THE MARK3 ARRAY IS THE INTERLEAVED COS AND SIN STRIP   FS60  22
# QX(MARK3+2)      FOR THIRD SUM. STEP2=2                               FS60  23
# QX(MARK6+1)    THE MARK6 ARRAY CONTAINS THE FIRST SUM RESULTS WHICH   FS60  24
# QX(MARK6+2)    SERVE AS COEFFICIENTS OF THE SECOND SUM . STEP6=4      FS60  25
# QX(MARK6+3)                        #                                  FS60  26
# QX(MARK6+4)                        #                                  FS60  27
# QX(MARK4+1)    THE MARK4 ARRAY CONTAINS SECOND SUM RESULTS WHICH      FS60  28
# QX(MARK4+2)    SERVE AS THE THIRD SUM COEFFICIENTS. STEP4=2           FS60  29
# QX(MARK5+1)    THE FINAL RESULT FOR ONE LINE OF THE TRANSFORM #       FS60  30
#                                                                       FS60  31
INTEGER LW,PSIZ,IX1,IX2,IXX1,IXX2#                                      FS60  32
INTEGER IORGX1,IORGX2#                                                  FS60  33
INTEGER IXORG2,IXORG3#                                                  FS60  34
INTEGER IXINC2,IXINC3#                                                  FS60  35
INTEGER ISTP2,ISTP3,TNG2,TNG3#                                          FS60  36
INTEGER INCX1,INCX2,INCX3,NG1,NG2,NG3,NP1,NP2,NP3#                      FS60  37
INTEGER IG,J,I,IP,IZ,IHX,I3,I2,INCHX,K,I3P,IH3M#                        FS60  38
INTEGER IX,IY,IX3,IZZ#                                                  FS60  39
INTEGER IJ,IQUIT,LWW#                                                   FS60  40
REAL TEMP5#                                                             FS60  41
REAL A,DTTHD,MODF,THDCOD#              Dtmodf,thd#                      FS60  42
REAL TEMP,ARG,FMT#                                                      FS60  43
REAL TEMP1,TEMP2,TEMP3,TEMP4#                                           FS60  44
#                                                                       FS60  45
chardata:(FS061, X DOWN IN   THS          Y ACROSS IN   THS          $# FS60  46
Z LAYER=   /   THS)#                                                    FS60  47
chardata:(FS062,XYZ)#                                                   FS60  48
chardata:(FS063,@ZYX-.+ABC*)#                                           FS60  49
chardata:(FS064,THSTNDRDTHTHTHTHTHTH)#                                  FS60  50
chardata:(FS065,ELECTRIC FIELD GRADIENT CONTRIBUTIONS $#                FS60  51
                               )#                                       FS60  52
chardata:(FS066,IN XTAL COORDINATE SYSTEM)#                             FS60  53
chardata:(FS067,IN ORTHOGONAL COORDINATE SYSTEM)#                       FS60  54
chardata:(FS068,    ETA       LAMBDA                 E.F.G.TENSOR)#     FS60  55
chardata:(FS069,        DIR IN XYZ                   DIR IN ABC$#       FS60  56
              PHI(DEG))#                                                FS60  57
chardata:(FS06A,EFG NON-PHYSICAL HAVING IMAGINARY ROOTS)#               FS60  58
realdata:(TWOPI,6.2831853); realdata:(INCF,1.)#                         FS60  59
realdata:(TINY,.0000001); realdata:(RAD,57.2957795)#                    FS60  60
realdata:(AA,[0.,0.,0.,0.,0.,0.,0.,0.,0.])#                             FS60  61
realdata:(EFG,[0.,0.,0.,0.,0.,0.,0.,0.,0.])#                            FS60  62
intdata:(MAPLIN,0); intdata:(NLINE,0); intdata:(IFORCE,0)#              FS60  63
realdata:(PRTSCL,1.); realdata:(STARTF,0.); realdata:(HEADF,0.)#        FS60  64
realdata:(FM1,[680313.,130313.,400313.])#                               FS60  65
realdata:(FM2,[361042.,461042.,561042.])#                               FS60  66
realdata:(FM3,[360842.,440842.,520842.])#                               FS60  67
realdata:(FM4,[70842.,150842.,230842.])#                                FS60  68
realdata:(FM5,[70732.,200942.,680732.])#                                FS60  69
datastuff:#                                                             FS60  70
#                                                                       FS60  71
#  SET SUMMATION PARAMETERS                                             FS60  72
#  ------------------------                                             FS60  73
#                                                                       FS60  74
INCX1=INCX(1);   INCX2=INCX(2);   INCX3=INCX(3)#                        FS60  75
IORGX1=ORGX(1);  IORGX2=ORGX(2)#                                        FS60  76
IXORG2=IXORG(2); IXORG3=IXORG(3)#                                       FS60  77
IXINC2=IXINC(2); IXINC3=IXINC(3)#                                       FS60  78
DTTHD=FLOAT(MAX0(IXINC(3),JUMP))#      Float third sum step size        FS60  79
NG1=NG(1); NG2=NG(2); NG3=NG(3)#                                        FS60  80
NP1=NPP1;  NP2=NP(2); NP3=NP(3)#                                        FS60  81
ISTP3=STOP3;ISTP2=STOP2;TNG2=2*NG2;TNG3=2*NG3#                          FS60  82
IH3M=2*IH3MAX#                         Set up twice (h3max+1)           FS60  83
#PSIZ=NP3#                              SET PACKET SIZE FOR SPECIAL     FS60  84
PSIZ=NP3*IPROP#                        Set packet size for special      FS60  85
J=MARK6-STEP6#                         Set second sum coefficient       FS60  86
#                                                                       FS60  87
# SET UP PAGE HEADING FOR PRINTED FOURIER                               FS60  88
# ---------------------------------------                               FS60  89
#                                                                       FS60  90
IF(PRINT==yes:)#                       But only if printing to be       FS60  91
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS60  92
movechar:(MAPCHR,1,FS063,6,1,0)#       Store map char as local          FS60  93
PRTSCL=SKAL#                           Set printer op scale             FS60  94
INCF=FLOAT(COLPNT)*10000.#             Set value of format incremen     FS60  95
MODF=FLOAT(10**COLPNT)#                Set across print limit           FS60  96
IF(FORMAT==2) STARTF=90116.#           Set format for packed op         FS60  97
ELSE STARTF=FLOAT(COLPNT*100)+90013.#  Set format for normal op         FS60  98
HEADF=FLOAT(COLPNT*100)+90013.#        Set format for header            FS60  99
MAPLIN=NP2*(LINPNT+1)+4#               Calc line length of map          FS60 100
NLINE=mxlnpg:#                         Set initial line count           FS60 101
IFORCE=yes:#                                                            FS60 102
IF(FORCE<small:) IFORCE=no:#           Set to rescale map to origin     FS60 103
IXX1=IORGX1-INCX1#                     Set page to page coordinate      FS60 104
BUFOT(1)=FLOAT(NG1); BUFOT(2)=FLOAT(NG2); BUFOT(3)=FLOAT(NG3)#          FS60 105
ncodefld:(BUFOT,1,FS061,FM1,3)#        Encode grid points               FS60 106
movechar:(FS062,JSUM1,FS061,54,1,0)#   Insert layer axis                FS60 107
movechar:(FS062,JSUM2,FS061, 2,1,0)#   Insert down  axis                FS60 108
movechar:(FS062,JSUM3,FS061,27,1,0)#   Insert acros axis                FS60 109
IF((NG1>10)&(NG1<14)) IG=1#            11,12, and 13 are special        FS60 110
ELSE IG=MOD(NG1,10)*2+1#               Figure out ordinal suffix        FS60 111
movechar:(FS064,IG,FS061,69,2,0)#      For page to page coordinate      FS60 112
IF((NG2>10)&(NG2<14)) IG=1#            11,12, and 13 are special        FS60 113
ELSE IG=MOD(NG2,10)*2+1#               Figure out ordinal suffix        FS60 114
movechar:(FS064,IG,FS061,14,2,0)#      For down the page                FS60 115
IF((NG3>10)&(NG3<14)) IG=1#            11,12, and 13 are special        FS60 116
ELSE IG=MOD(NG3,10)*2+1#               Figure out ordinal suffix        FS60 117
movechar:(FS064,IG,FS061,41,2,0)#      For across the page              FS60 118
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS60 119
#                                                                       FS60 120
# SET UP SECOND AND THIRD SUM COSINE AND SINE TABLES                    FS60 121
# --------------------------------------------------                    FS60 122
#                                                                       FS60 123
TEMP=TWOPI/FLOAT(NG2)#                 Two pi/(second sum grid)         FS60 124
ARG=0.0#                                                                FS60 125
DO IG=MARK2,STOP2,STEP2#               Loop over all cos-sin table      FS60 126
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FS60 127
QX(IG+1)=COS(ARG)#                     Generate cosine strip            FS60 128
QX(IG+2)=SIN(ARG)#                     Generate sine strip              FS60 129
ARG=ARG+TEMP#                          Increment the argument           FS60 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FS60 131
TEMP=TWOPI/FLOAT(NG3)#                 Two pi/(third sum grid)          FS60 132
ARG=0.0#                                                                FS60 133
DO IG=MARK3,STOP3,STEP3#               Loop over all cos-sin for th     FS60 134
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FS60 135
QX(IG+1)=COS(ARG)#                     Third sum cosine strip           FS60 136
QX(IG+2)=SIN(ARG)#                     Third sum sine strip             FS60 137
ARG=ARG+TEMP#                          Increment the argument           FS60 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FS60 139
#                                                                       FS60 140
# SCAN OVER ALL LAYERS WITH FIRST SUM COEFFICIENTS STORED IN CORE       FS60 141
# ----------------------------------------------------------------      FS60 142
#                                                                       FS60 143
DO IX1=1,NP1#                          Do all layers possible on        FS60 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FS60 145
DO I=MARK4,STOP4; QX(I+1)=0.#          Clear third sum coeff.s          FS60 146
#                                                                       FS60 147
# START OF SECOND SUM                                                   FS60 148
# -------------------                                                   FS60 149
# SUM(X,Y1,L)=SUM(X,Y1,L)+SUM(X1,K,L)COS(KY)+SUM(X2,K,L)SIN(KY)         FS60 150
# SUM(X,Y2,L)=SUM(X,Y2,L)+SUM(X3,K,L)SIN(KY)+SUM(X4,K,L)COS(KY)         FS60 151
#                                                                       FS60 152
DO I=1,IPROP#                          Loop over all components         FS60 153
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FS60 154
DO I3=1,IH3MAX#                        Scan through all h3              FS60 155
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FS60 156
#I3P=MARK4+2*(I3-1)#                    SET THE SECOND SUM STORAGE      FS60 157
I3P=MARK4+2*(I3-1)+IH3M*(I-1)#         Set the second sum storage       FS60 158
DO I2=1,IH2MAX#                        Scan over all h2 for current     FS60 159
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FS60 160
J=J+STEP6#                             Increment second sum coef.       FS60 161
TEMP1=QX(J+1);  TEMP2=QX(J+2)#         Store coefficients               FS60 162
TEMP3=QX(J+3);  TEMP4=QX(J+4)#         Store coefficients               FS60 163
IHX=  2*MOD((I2-1)*IXORG2,NG2)+MARK2#  Set start of loop up for sin     FS60 164
INCHX=2*MOD((I2-1)*IXINC2,NG2)#        Set increment in sine-cosine     FS60 165
K=I3P#                                 Set second sum storage point     FS60 166
DO IZ=1,NP2#                           Loop over all the second sum p   FS60 167
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FS60 168
QX(K+1)=QX(K+1)+TEMP1*QX(IHX+1)+TEMP2*QX(IHX+2)#                        FS60 169
QX(K+2)=QX(K+2)+TEMP3*QX(IHX+2)+TEMP4*QX(IHX+1)#                        FS60 170
#K=K+IH3M;    IHX=IHX+INCHX#            INCREMENT POINTERS              FS60 171
K=K+IH3M*IPROP;    IHX=IHX+INCHX#      Increment pointers               FS60 172
IF(IHX>ISTP2)IHX=IHX-TNG2#             Keep on beevers-lipson strip     FS60 173
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FS60 174
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FS60 175
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FS60 176
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FS60 177
LW=IPROP*NP3+MARK5-1#                  Set linewidth limit for pass     FS60 178
#LW=NP3+MARK5-1#                       SET LINEWIDTH LIMIT FOR PASS     FS60 179
K=MARK4-STEP4#                         Set start of third sum coefs     FS60 180
#                                                                       FS60 181
# PRINT PAGE HEADING HERE                                               FS60 182
# -----------------------                                               FS60 183
#                                                                       FS60 184
IF(PRINT==yes:)#                       Test if fourier is to be pr      FS60 185
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FS60 186
NLINE=NLINE+MAPLIN#                    Incr map line counter            FS60 187
IF(NLINE>mxlnpg:)#                     Test if page exceeded            FS60 188
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FS60 189
LINCT=0;   NLINE=MAPLIN#               Yes, force new page & reset      FS60 190
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FS60 191
IXX2=IORGX2-INCX2#                     Pick up starting value of x2     FS60 192
IXX1=IXX1+INCX1#                       Pick up starting value of x1     FS60 193
ncodefld:(FLOAT(IXX1),1,FS061,640413.,1)# Encode section coord for hd   FS60 194
writeline:(1,FS061,NFS061,3,3)#        Write the page heading           FS60 195
THDCOD=FLOAT(ORGX(3))#                 Get third sum starting coord     FS60 196
FMT=HEADF#                             Set up output format             FS60 197
DO IZ=1,NPR#                           Loop over line to build col      FS60 198
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FS60 199
A=AMOD(THDCOD,MODF)#                   Reduce to printable value        FS60 200
ncodefld:(A,1,CHROT,FMT,1)#                                             FS60 201
THDCOD=THDCOD+DTTHD#                                                    FS60 202
FMT=FMT+INCF#                                                           FS60 203
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FS60 204
writeline:(1,0,0,1,3)#                 Write column headings            FS60 205
IF(MAPLIN>mxlnpg:) LINCT=100000#       Prevent pagination               FS60 206
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FS60 207
#                                                                       FS60 208
# START THIRD SUM COEFF.S                                               FS60 209
# -----------------------                                               FS60 210
# SUM(X,Y,Z)=SUM(X,Y,Z)+SUM(X,Y1,L)COS(LZ)+SUM(X,Y2,L)*SIN(LZ)          FS60 211
#                                                                       FS60 212
DO IX2=1,NP2#                          Loop over all second sum poi     FS60 213
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FS60 214
DO I3=MARK5,LW; QX(I3+1)=0.#           Zero each map line               FS60 215
DO IJ=1,IPROP#                                                          FS60 216
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FS60 217
DO I3=1,IH3MAX#                        Loop over all values of thir     FS60 218
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FS60 219
K=K+STEP4#                                                              FS60 220
IHX=2*MOD((I3-1)*IXORG3,NG3)+MARK3#    Set starting pointer             FS60 221
INCHX=2*MOD((I3-1)*IXINC3,NG3)#        Set third sum sin-cos incrmn     FS60 222
TEMP1=QX(K+1)#                         Pick up third sum coefficien     FS60 223
TEMP2=QX(K+2)#                                                          FS60 224
IF((ABS(TEMP1)>small:)&(ABS(TEMP2)>small:))#                            FS60 225
#DO IZ=MARK5,LW#                       LOOP OVER PARTIAL ROW FINAL      FS60 226
DO IZZ=MARK5,LW,IPROP#                 Loop over partial row final      FS60 227
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FS60 228
IZ=IZZ+IJ-1#                                                            FS60 229
QX(IZ+1)=QX(IZ+1)+TEMP1*QX(IHX+1)+TEMP2*QX(IHX+2)#                      FS60 230
IHX=IHX+INCHX#                         Increment trig pointer           FS60 231
IF(IHX>ISTP3) IHX=IHX-TNG3#            But don't go off the end of      FS60 232
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FS60 233
ELSE IF(ABS(TEMP2)>small:)#                                             FS60 234
#DO IZ=MARK5,LW#                                                        FS60 235
DO IZZ=MARK5,LW,IPROP#                                                  FS60 236
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FS60 237
IZ=IZZ+IJ-1#                                                            FS60 238
QX(IZ+1)=QX(IZ+1)+TEMP2*QX(IHX+2)#                                      FS60 239
IHX=IHX+INCHX#                                                          FS60 240
IF(IHX>ISTP3) IHX=IHX-TNG3#                                             FS60 241
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FS60 242
ELSE IF(ABS(TEMP1)>small:)#                                             FS60 243
#DO IZ=MARK5,LW#                                                        FS60 244
DO IZZ=MARK5,LW,IPROP#                                                  FS60 245
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FS60 246
IZ=IZZ+IJ-1#                                                            FS60 247
QX(IZ+1)=QX(IZ+1)+TEMP1*QX(IHX+1)#                                      FS60 248
IHX=IHX+INCHX#                                                          FS60 249
IF(IHX>ISTP3) IHX=IHX-TNG3#                                             FS60 250
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FS60 251
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FS60 252
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FS60 253
#                                                                       FS60 254
# START PROPERTY EVALUATION                                             FS60 255
# -------------------------                                             FS60 256
#                                                                       FS60 257
DO I3=MARK5,LW,IPROP#                  Loop over line of points         FS60 258
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FS60 259
#                                                                       FS60 260
# START OF ELECTRIC FIELD VECTOR TRANSFORMATION                         FS60 261
# ---------------------------------------------                         FS60 262
#                                                                       FS60 263
IF(PTYPE==2)#                          Test if el. field                FS60 264
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 FS60 265
TEMP1=QX(I3+IMAP(1))#                  Store x component of el. field   FS60 266
TEMP2=QX(I3+IMAP(2))#                  Store y component of el. field   FS60 267
TEMP3=QX(I3+IMAP(3))#                  Store z component of el. field   FS60 268
QX(I3+1)=TEMP1*TRANR(1)+TEMP2*TRANR(4)+TEMP3*TRANR(7)# Transform x      FS60 269
QX(I3+2)=TEMP1*TRANR(2)+TEMP2*TRANR(5)+TEMP3*TRANR(8)# Transform y      FS60 270
QX(I3+3)=TEMP1*TRANR(3)+TEMP2*TRANR(6)+TEMP3*TRANR(9)# Transform z      FS60 271
TEMP=SQRT(QX(I3+1)*QX(I3+1)+QX(I3+2)*QX(I3+2)+QX(I3+3)*QX(I3+3))#       FS60 272
QX(I3+1)=TEMP1#                        Store x                          FS60 273
QX(I3+2)=TEMP2#                        Store y                          FS60 274
QX(I3+3)=TEMP3#                        Store z                          FS60 275
#                                                                       FS60 276
# GET MIN/MAX OF ELECTRIC FIELD STRENGTH                                FS60 277
# --------------------------------------                                FS60 278
#                                                                       FS60 279
DENMAX=MAX(DENMAX,TEMP)#               Get maximum strength             FS60 280
DENMIN=MIN(DENMIN,TEMP)#               Get minimum strength             FS60 281
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 FS60 282
#                                                                       FS60 283
# ELECTRIC FIELD GRADIENT                                               FS60 284
# -----------------------                                               FS60 285
#                                                                       FS60 286
ELSE IF(PTYPE==3)#                     Test if e.f.g.                   FS60 287
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 FS60 288
J=25-JCODE(1)-JCODE(2)-JCODE(3)-JCODE(4)-JCODE(5)#                      FS60 289
TEMP1=QX(I3+1)*RMETR(JCODE(1))#        Set 11 component of e.f.g.       FS60 290
TEMP2=QX(I3+2)*RMETR(JCODE(2))#        Set 12 component of e.f.g.       FS60 291
TEMP3=QX(I3+3)*RMETR(JCODE(3))#        Set 13 component of e.f.g.       FS60 292
TEMP4=QX(I3+4)*RMETR(JCODE(4))#        Set 23 component of e.f.g.       FS60 293
TEMP5=QX(I3+5)*RMETR(JCODE(5))#        Set 33 component of e.f.g.       FS60 294
TEMP1=-(TEMP1+TEMP5+2.*(TEMP2+TEMP3+TEMP4))# Get 22 component of e.f.   FS60 295
EFG(JCODE(1))=QX(I3+1)#                Store hh component               FS60 296
EFG(JCODE(2))=QX(I3+2)#                Store hk component               FS60 297
EFG(JCODE(3))=QX(I3+3)#                Store hl component               FS60 298
EFG(JCODE(4))=QX(I3+4)#                Store kl component               FS60 299
EFG(JCODE(5))=QX(I3+5)#                Store ll component               FS60 300
EFG(J)=TEMP1/RMETR(J)#                 Form kk component                FS60 301
EFG(5)=EFG(4)#                         Store kk component               FS60 302
EFG(4)=EFG(2)#                         Store kh component               FS60 303
EFG(7)=EFG(3)#                         Store lh component               FS60 304
EFG(8)=EFG(6)#                         Store lk component               FS60 305
#                                                                       FS60 306
# SET UP POINT COORDINATES                                              FS60 307
# ------------------------                                              FS60 308
#                                                                       FS60 309
IX3=(I3-MARK5)/IPROP+1#                                                 FS60 310
BUFOT(1)=FLOAT(ORGX(1)+INCX1*(IX1-1))/FLOAT(NG1)#                       FS60 311
BUFOT(2)=FLOAT(ORGX(2)+INCX2*(IX2-1))/FLOAT(NG2)#                       FS60 312
BUFOT(3)=FLOAT(ORGX(3)+INCX3*(IX3-1))/FLOAT(NG3)#                       FS60 313
#                                                                       FS60 314
# PRINT HEADING AND E.F.G.TENSOR IN XTAL COORDINATE SYSTEM              FS60 315
# --------------------------------------------------------              FS60 316
#                                                                       FS60 317
movechar:(FS063,5,CHROT,1,63,1)#       Underline control header         FS60 318
movechar:(FS066,1,FS065,39,NFS066,0)#  Insert control header            FS60 319
writeline:(2,FS065,63,2,3)#            Print control header             FS60 320
movechar:(FS062,1,CHROT,5,1,1)#        Insert x                         FS60 321
movechar:(FS062,2,CHROT,13,1,1)#       Insert y                         FS60 322
movechar:(FS062,3,CHROT,21,1,1)#       Insert z                         FS60 323
movechar:(FS068,38,CHROT,38,12,0)#     Insert control header            FS60 324
writeline:(0,0,0,1,3)#                 Print control header             FS60 325
ncodefld:(BUFOT,1,CHROT,FM4,3)#        Format point coordinates         FS60 326
DO I=1,7,3#                                                             FS60 327
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 FS60 328
ncodefld:(EFG,I,CHROT,FM2,3)#          Format e.f.g. tensor             FS60 329
writeline:(0,0,0,1,3)#                 Print e.f.g. tensor              FS60 330
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 FS60 331
#                                                                       FS60 332
# START OF ELECTRIC FIELD GRADIENT TRANSFORMATION                       FS60 333
# -----------------------------------------------                       FS60 334
#                                                                       FS60 335
DO I=1,3#                              T'*efg matrix multiply           FS60 336
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 FS60 337
DO J=1,3#                                                               FS60 338
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 FS60 339
K=J+3*(I-1)#                                                            FS60 340
AA(K)=TRANR(I)*EFG(J)+TRANR(I+3)*EFG(J+3)+TRANR(I+6)*EFG(J+6)#          FS60 341
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 FS60 342
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 FS60 343
DO J=1,9; EFG(J)=.0#                   Clear efg                        FS60 344
DO I=1,3#                              Efg*t' matrix multiply           FS60 345
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 FS60 346
K=3*I-2#                                                                FS60 347
DO J=1,3#                                                               FS60 348
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 FS60 349
IX=J+3*(I-1)#                                                           FS60 350
EFG(IX)=AA(K)*TRANR(J)+AA(K+1)*TRANR(J+3)+AA(K+2)*TRANR(J+6)#           FS60 351
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 FS60 352
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 FS60 353
EFG(4)=EFG(5)#                         Reset efg(4)                     FS60 354
EFG(5)=EFG(6)#                         Reset efg(5)                     FS60 355
EFG(6)=EFG(9)#                         Reset efg(6)                     FS60 356
DO J=7,9; EFG(J)=.0#                   Clear the last three elements    FS60 357
DO J=1,9; AA(J)=.0#                    Clear aa                         FS60 358
#                                                                       FS60 359
# EIGENSYSTEM CALCULATION FOR ELECTRIC FIELD GRADIENT                   FS60 360
# ---------------------------------------------------                   FS60 361
#                                                                       FS60 362
CALL FS61(EFG,AA,IQUIT)#               Eigensystem calculation          FS60 363
IF(IQUIT==1)#                          Test if non-physical efg         FS60 364
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 FS60 365
writeline:(1,FS06A,NFS06A,3,3)#        Print line                       FS60 366
NEXT#                                                                   FS60 367
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 FS60 368
TEMP1=AMAX1(ABS(EFG(7)),ABS(EFG(8)),ABS(EFG(9)))# Max eigenvalue        FS60 369
TEMP2=AMIN1(ABS(EFG(7)),ABS(EFG(8)),ABS(EFG(9)))# Min eigenvalue        FS60 370
DO I=7,9#                                                               FS60 371
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 FS60 372
IF(ABS(EFG(I))==TEMP1) IZ=I#                                            FS60 373
IF(ABS(EFG(I))==TEMP2) IX=I#                                            FS60 374
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 FS60 375
IY=24-IZ-IX#                                                            FS60 376
TEMP3=(EFG(IX)-EFG(IY))/EFG(IZ)#       'eta', coefficient of asymmetr   FS60 377
#                                                                       FS60 378
# GET MIN/MAX EIGENVALUES                                               FS60 379
# -----------------------                                               FS60 380
#                                                                       FS60 381
DENMAX=MAX(DENMAX,EFG(IZ))#            Get maximum eigenvalue           FS60 382
DENMIN=MIN(DENMIN,EFG(IX))#            Get minimum eigenvalue           FS60 383
IZZ=(I3-MARK5)/IPROP+1#                                                 FS60 384
QX(MARK5+IZZ)=EFG(IZ)#                 Store max component              FS60 385
#                                                                       FS60 386
# PRINT HEADING, ETA, EIGENVALUES AND E.F.G.TENSOR IN ORTHOGONAL SYSTEM FS60 387
# --------------------------------------------------------------        FS60 388
#                                                                       FS60 389
movechar:(FS063,5,CHROT,1,69,1)#       Underline control header         FS60 390
movechar:(FS067,1,FS065,39,NFS067,0)#  Insert control header            FS60 391
writeline:(1,FS065,NFS065,2,3)#        Print control header             FS60 392
writeline:(1,FS068,NFS068,3,3)#        Print header                     FS60 393
ncodefld:(TEMP3,1,CHROT,FM5(1),1)#     Format eta coefficient           FS60 394
ncodefld:(EFG,IX,CHROT,FM5(2),1)#      Format small eigenvalue          FS60 395
ncodefld:(EFG,1,CHROT,FM2,3)#          Format first row of e.f.g        FS60 396
writeline:(0,0,0,1,3)#                 Print line                       FS60 397
ncodefld:(EFG,IY,CHROT,FM5(2),1)#      Format medium eigenvalue         FS60 398
TEMP1=EFG(3)#                          Store efg(3)                     FS60 399
EFG(3)=EFG(2)#                         Reset efg(3)                     FS60 400
ncodefld:(EFG,3,CHROT,FM2,3)#          Format second row of e.f.g       FS60 401
writeline:(0,0,0,1,3)#                 Print line                       FS60 402
ncodefld:(EFG,IZ,CHROT,FM5(2),1)#      Format big eigenvalue            FS60 403
EFG(4)=TEMP1#                          Reset efg(4)                     FS60 404
ncodefld:(EFG,4,CHROT,FM2,3)#          Format third row of e.f.g        FS60 405
writeline:(0,0,0,1,3)#                 Print line                       FS60 406
#                                                                       FS60 407
# TRANSFORMATION EIGENVECTORS IN XTAL COORDINATE SYSTEM                 FS60 408
# -----------------------------------------------------                 FS60 409
#                                                                       FS60 410
DO I=1,3#                              Loop over i                      FS60 411
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 FS60 412
I2=3*(I-1)#                            Set index                        FS60 413
DO J=1,3#                              Loop over j                      FS60 414
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 FS60 415
K=3*(J-1); TEMP=0.#                    Set index and clear sum          FS60 416
DO IZZ=1,3; TEMP=TEMP+AA(I2+IZZ)*TRAND(K+IZZ)# Get transformation       FS60 417
EFG(I2+J)=TEMP#                        Store transformed components     FS60 418
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 FS60 419
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 FS60 420
TEMP=RAD*ACOS(EFG(3*IZ-18))#           Get phi angle in degree          FS60 421
#                                                                       FS60 422
# PRINT HEADING, EIGENVECTORS IN XYZ AND ABC                            FS60 423
# ------------------------------------------                            FS60 424
#                                                                       FS60 425
writeline:(1,FS069,NFS069,3,3)#        Print header                     FS60 426
ncodefld:(AA,3*IX-20,CHROT,FM4,3)#     Format first eigenvector         FS60 427
ncodefld:(EFG,3*IX-20,CHROT,FM3,3)#    Format first dir in abc          FS60 428
writeline:(0,0,0,1,3)#                 Print line                       FS60 429
ncodefld:(AA,3*IY-20,CHROT,FM4,3)#     Format second eigenvector        FS60 430
ncodefld:(EFG,3*IY-20,CHROT,FM3,3)#    Format second dir in abc         FS60 431
writeline:(0,0,0,1,3)#                 Print line                       FS60 432
ncodefld:(AA,3*IZ-20,CHROT,FM4,3)#     Format third eigenvector         FS60 433
ncodefld:(EFG,3*IZ-20,CHROT,FM3,3)#    Format third dir in abc          FS60 434
ncodefld:(TEMP,1,CHROT,FM5(3),1)#      Format phi angle                 FS60 435
writeline:(0,0,0,1,3)#                 Print line                       FS60 436
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 FS60 437
ELSE IF(PTYPE<2)#                                                       FS60 438
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 FS60 439
#                                                                       FS60 440
# GET MIN/MAX OF DENSITY                                                FS60 441
# ----------------------                                                FS60 442
#                                                                       FS60 443
DENMAX=MAX(DENMAX,QX(I3+1))#           Get maximum density              FS60 444
DENMIN=MIN(DENMIN,QX(I3+1))#           Get minimum density              FS60 445
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 FS60 446
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FS60 447
#                                                                       FS60 448
#   OUTPUT LINE TO FILE C                                               FS60 449
#   ---------------------                                               FS60 450
#                                                                       FS60 451
IF(SFILE==yes:&PTYPE!=3)#              Test if fourier to go to fil     FS60 452
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 FS60 453
writepkt:(3,22,PSIZ,IZ )#              For later use by pekpik or e     FS60 454
movereal:(QX,MARK5+1,QX,IZ+1,PSIZ,1)#                                   FS60 455
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 FS60 456
#                                                                       FS60 457
#   PRINT LINE OF MAP IF REQUESTED                                      FS60 458
#   ------------------------------                                      FS60 459
#                                                                       FS60 460
IF(PRINT==yes:&PTYPE!=3)#              Are we printing this one         FS60 461
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 FS60 462
IF(PTYPE>1) LWW=NP3+MARK5-1#           The first map of el.field is u   FS60 463
ELSE LWW=LW#                                                            FS60 464
IF(IFORCE==yes:)#                      Test to see if the first poi     FS60 465
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 FS60 466
IF(ABS(QX(MARK5+1))>small:)#           Rest of the points...            FS60 467
PRTSCL=(FORCE+.5)/ABS(QX(MARK5+1))#                                     FS60 468
IFORCE=no:#                                                             FS60 469
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 FS60 470
IXX2=IXX2+INCX2#                       Calculate second sum coordin     FS60 471
BUFOT(1)=FLOAT(IXX2)#                  Encode line coordinate           FS60 472
ncodefld:(BUFOT,1,CHROT,40413.,1)#                                      FS60 473
FMT=STARTF;  IP=9#                     Set up format for first colu     FS60 474
#DO I3=MARK5,LW,JUMP#                   MOVE THE FOURIER TO THE OUTP    FS60 475
DO I3=MARK5,LWW,JUMP#                  Move the fourier to the outp     FS60 476
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 FS60 477
A=QX(I3+1)*PRTSCL#                     Scale to origin depending        FS60 478
IF((A>UPLIM)\(A<LOLIM))#               Supress unwanted values          FS60 479
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 FS60 480
IF(FORMAT<3) ncodefld:(A,1,CHROT,FMT,1)# Format normal or packed        FS60 481
ELSE#                                  Else shaded required             FS60 482
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 FS60 483
IF(A>UPLIM) I=MIN0(NINT((A-UPLIM)/FORSCL)+7,11)# Point to op char       FS60 484
ELSE        I=MAX0(NINT((A-LOLIM)/FORSCL)+5,1)# Point to op char        FS60 485
movechar:(FS063,I,CHROT,IP,1,0)#       Insert char in buffer            FS60 486
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 FS60 487
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 FS60 488
ELSE movechar:(FS063,6,CHROT,IP,1,0)#  Insert map char in buff          FS60 489
FMT=FMT+INCF;  IP=IP+COLPNT#           Incr col pointers                FS60 490
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 FS60 491
writeline:(LINPNT,0,0,1,3)#            Move the line to the printer     FS60 492
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 FS60 493
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FS60 494
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FS60 495
IF(PASSES==0) LINCT=0#                 Reset line count for next pr     FS60 496
#                                                                       FS60 497
RETURN#                                                                 FS60 498
END#                                                                    FS60 499
systemheader:(FS61)#                                                    FS61   1
# ################################################################## #  FS61   2
#                                                                    #  FS61   3
#                               FS61                                 #  FS61   4
#                                                                    #  FS61   5
# ################################################################## #  FS61   6
SUBROUTINE FS61(VE,EVE,IQ)#            V.a.streltsov 1992               FS61   7
#                                                                       FS61   8
# DETERMINE THE EIGENVALUES AND THE EIGENVECTORS OF THE EFG TENSOR.     FS61   9
# THE EFG TENSOR IS SYMMETRICAL WITH ZERO TRACE. THE ELEMENTS OF THE    FS61  10
# EFG TENSOR CONTAINED IN VE ARE IN THE ORDER V11,V12,V13,V22,V23,V33.  FS61  11
# THE EIGENVALUES ARE RETURNED IN THE ORDER LARGEST TO SMALLEST. THE    FS61  12
# EIGENVECTORS ARE RETURNED AS NORMALISED ARRAY EVE.                    FS61  13
#                                                                       FS61  14
INTEGER I,IQ,IB,IM,IS,IE,J#                                             FS61  15
REAL VE(9),EVE(9)#                                                      FS61  16
dp: A,B,C,D,U,AA,ARG,FAC,EB,EM,ES,V(9),EV(9)#                           FS61  17
dp: ONE,TWO,THREE,TPIO3#                                                FS61  18
datastuff:#                                                             FS61  19
#                                                                       FS61  20
ONE=1.d0:; TWO=2.d0:; THREE=3.d0:#                                      FS61  21
TPIO3=2.094395102393d0:#               2*pi/3                           FS61  22
DO I=1,6; V(I)=VE(I)#                  Store e.f.g. tensor              FS61  23
#                                                                       FS61  24
# SOLUTION FOR A CUBIC EQUITION OF THE FORM V**3 + A*V + B = 0          FS61  25
# ------------------------------------------------------------          FS61  26
#                                                                       FS61  27
A=V(1)*V(4)+V(1)*V(6)+V(4)*V(6)-V(2)*V(2)-V(3)*V(3)-V(5)*V(5)# Coeff.   FS61  28
IF(A<.0)#                              Check that all roots are real    FS61  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS61  30
B=V(3)*V(3)*V(4)+V(1)*V(5)*V(5)+V(2)*V(2)*V(6)-$# Coefficient b         FS61  31
  V(1)*V(4)*V(6)-2.*V(2)*V(3)*V(5)#                                     FS61  32
AA=dabs:(A)/THREE; FAC=TWO*dsqrt:(AA)# Factor for eigenvalues           FS61  33
A=A*FAC;           U=THREE*B/A#        Cosine of the smallest angle     FS61  34
U=dsign:(dmin1:(ONE,dabs:(U)),U)#      Cos must be equil or less than   FS61  35
ARG=dacos:(U)/THREE#                   The smallest positive angle      FS61  36
DO I=7,9#                              Determine the eigenvalues        FS61  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FS61  38
V(I)=FAC*dcos:(ARG)#                   Get eigenvalue                   FS61  39
ARG=ARG+TPIO3#                         Set new angle                    FS61  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FS61  41
EB=dmax1:(V(7),V(8),V(9))#             Set up the big one               FS61  42
ES=dmin1:(V(7),V(8),V(9))#             Set up the small one             FS61  43
DO I=7,9#                              Sort v(i) into ascending order   FS61  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FS61  45
IF(V(I)==EB) IB=I#                     Pick up index of the biggest     FS61  46
IF(V(I)==ES) IS=I#                     Pick up index of the smallest    FS61  47
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FS61  48
IM=24-IB-IS; EM=V(IM)#                 Set up the middle one            FS61  49
V(7)=EB; V(8)=EM; V(9)=ES#             Set the order big, middle, sma   FS61  50
DO I=1,3#                              Determine the eigenvectors       FS61  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FS61  52
IE=I+6#                                Set index for eigenvalues        FS61  53
A=V(2)*V(5)-V(3)*(V(4)-V(IE))#         Nominator of the first solutio   FS61  54
B=V(2)*V(3)-V(5)*(V(1)-V(IE))#         Nominator of the second soluti   FS61  55
C=(V(1)-V(IE))*(V(4)-V(IE))-V(2)*V(2)# Denominator of solutions         FS61  56
D=dsqrt:(A*A+B*B+C*C)#                 Denominator of eigenvectors      FS61  57
J=(I-1)*3#                             Set index                        FS61  58
EV(1+J)=A/D; EV(2+J)=B/D; EV(3+J)=C/D# Store the eigenvectors           FS61  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FS61  60
DO I=1,9#                              Reset solutions                  FS61  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FS61  62
VE(I)=V(I); EVE(I)=EV(I)#              Store the eigensystem            FS61  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FS61  64
IQ=0#                                  Normal quit                      FS61  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS61  66
ELSE IQ=1#                             Abnormal quit, non-physical ef   FS61  67
RETURN#                                                                 FS61  68
END#                                                                    FS61  69
systemheader:(FS70)#                                                    FS70   1
# ################################################################## #  FS70   2
#                                                                    #  FS70   3
#                               FS70                                 #  FS70   4
#                                                                    #  FS70   5
# ################################################################## #  FS70   6
SUBROUTINE FS70#                       Part 6-second and third sums     FS70   7
include:(AACOMN)#                      J.m.stewart,j.r.holden 1981      FS70   8
include:(FSCOMN)#                      R.doherty, s.r.hall 1982         FS70   9
#                                                                       FS70  10
# APPLY FFT SECOND AND THIRD SUMS USING THE COEFFICIENTS WHICH WERE     FS70  11
# PRODUCED BY THE FIRST SUM PROGRAM FS50.  THE SECOND SUM COEFFICIENTS  FS70  12
# (FIRST SUM RESULTS) WHICH CAN BE HELD IN IMMEDIATE ACCESS STORAGE ARE FS70  13
# TREATED.  THE PROGRAM IS A DRASTIC RECODING OF FS60 OF XTAL.          FS70  14
#                            J.STEWART AND R. DOHERTY , NOV. 1980       FS70  15
#                                                                       FS70  16
# IN THIS VERSION THE THIRD SUM IS DONE BY THE FAST FOURIER TRANSFORM   FS70  17
# ALGORITHM.                                                            FS70  18
# IN FS60, THE THIRD SUM TO YIELD THE ELECTRON DENSITY (RHO) MAY BE     FS70  19
# EXPRESSED AS-                                                         FS70  20
#    RHO(X1,X2,X3)=SUM[D1*COS(2PI*I*H3*X3)]+SUM[D2*SIN(2PI*I*H3*X3)]    FS70  21
# THIS IS EQUIVALENT TO                                                 FS70  22
#                                                                       FS70  23
#    RHO(X1,X2,X3)=RE(SUM[(D1-I*D2)*EXP(2PI*I*H3*X3)]                   FS70  24
#                                                                       FS70  25
# THIS IS THE SUMMATION DONE BY THE FFT.  NOTICE THAT                   FS70  26
# (1) THE COEFFICIENT IN THE FFT IS D1 MINUS I*D2 (NOT PLUS)            FS70  27
#     THEREFORE THE "IMAGINARY" PARTS OF THE COEFFICIENTS FROM THE      FS70  28
#     SECOND SUM ARE STORED AS THE NEGATIVE OF THE VALUE FROM THE SUM.  FS70  29
# (2) ONLY THE REAL PART OF THE TRANSFORM CORRESPONDS TO THE ELECTRON   FS70  30
#     DENSITY.                                                          FS70  31
#                                                                       FS70  32
# R. DOHERTY, 11-80                                                     FS70  33
# QX(MARK1+1)    THE MARK1 ARRAY IS THE INTERLEAVED COS AND SIN STRIP   FS70  34
# QX(MARK1+2)    FOR FIRST SUM STEP1=2                                  FS70  35
# QX(MARK2+1)    TRIG TABLES FOR SECOND SUM S. MARK2=MARK1              FS70  36
# QX(MARK2+2)                                                           FS70  37
# QX(MARK3+1)      THE MARK3 ARRAY IS THE KEY FOR UNSCRAMBLING THE RESU FS70  38
#                  OF THE FFT, FOLLOWED BY THE LIST OF FACTORS OF NG3   FS70  39
# QX(MARK6+1)    THE MARK6 ARRAY CONTAINS THE FIRST SUM RESULTS WHICH   FS70  40
# QX(MARK6+2)    SERVE AS COEFFICIENTS OF THE SECOND SUM . STEP6=4      FS70  41
# QX(MARK6+3)                        #                                  FS70  42
# QX(MARK6+4)                        #                                  FS70  43
# QX(MARK4+1)    THE MARK4 ARRAY CONTAINS SECOND SUM RESULTS WHICH      FS70  44
# QX(MARK4+2)    SERVE AS THE THIRD SUM COEFFICIENTS. STEP4=2           FS70  45
# QX(MARK5+1)    THE FINAL RESULT FOR ONE LINE OF THE TRANSFORM #       FS70  46
#                                                                       FS70  47
INTEGER LW,PSIZ,IX1,IX2,IXX1,IXX2#                                      FS70  48
INTEGER LEAP3#                         Step over third sum pts for      FS70  49
INTEGER IORGX1,IORGX2#                                                  FS70  50
INTEGER STPSIZ#                        Step size over each coeffici     FS70  51
INTEGER KK,JJ#                                                          FS70  52
INTEGER L,M,N#                                                          FS70  53
INTEGER ND,PRORG#                      Factor to be used in denom o     FS70  54
INTEGER INCX1,INCX2,INCX3,NG1,NG2,NG3,NP1,NP2,NP3#                      FS70  55
INTEGER IG,J,I,IP,IZ,I3,IH2M,K,I3P,IH3M#                                FS70  56
INTEGER THSTEP#                        Step over lines of coefficie     FS70  57
REAL A,THDCOD,DTTHD,FMT,MODF#                                           FS70  58
#                                                                       FS70  59
chardata:(FS77, X DOWN IN   THS          Y ACROSS IN   THS          $#  FS70  60
Z LAYER=   /   THS)#                                                    FS70  61
chardata:(FS72,XYZ.)#                                                   FS70  62
chardata:(FS73,@ZYX-.+ABC*)#                                            FS70  63
chardata:(FS74,THSTNDRDTHTHTHTHTHTH)#                                   FS70  64
realdata:(INCF,1.); intdata:(LWID,30)#                                  FS70  65
intdata:(MAPLIN,0); intdata:(NLINE,0); intdata:(IFORCE,0)#              FS70  66
realdata:(FM1,[680313.,130313.,400313.])#                               FS70  67
realdata:(PRTSCL,1.); realdata:(STARTF,0.); realdata:(HEADF,0.)#        FS70  68
datastuff:#                                                             FS70  69
#                                                                       FS70  70
#   PREPARE SUMMATION PARAMETERS                                        FS70  71
#   ----------------------------                                        FS70  72
#                                                                       FS70  73
INCX1=INCX(1); INCX2=INCX(2); INCX3=INCX(3)#                            FS70  74
LEAP3=INCX3*JUMP#                      Net step over 3rd sum pts        FS70  75
IORGX1=ORGX(1)#                                                         FS70  76
IORGX2=ORGX(2)#                                                         FS70  77
DTTHD=FLOAT(MAX0(INCX3,JUMP))#         Float third sum step size        FS70  78
NG1=NG(1); NG2=NG(2); NG3=NG(3)#                                        FS70  79
NP1=NPP1; NP2=NP(2); NP3=NP(3)#                                         FS70  80
IH2M=STEP6*NG2#                        Step over single values of h     FS70  81
IH3M=2*NG3#                                                             FS70  82
PRORG=MARK5+ORGX(3)#                   Pt before the first print po     FS70  83
LW=MARK5+NG3#                          Figure length needed for one     FS70  84
J=MARK6-IH2M#                          Set second sum coefficient       FS70  85
PSIZ=NP3#                              Set packet size for special      FS70  86
THSTEP=IH3M*INCX2#                                                      FS70  87
#                                                                       FS70  88
#                                                                       FS70  89
# SET UP PAGE HEADING FOR PRINTED FOURIER                               FS70  90
# ---------------------------------------                               FS70  91
#                                                                       FS70  92
IF(PRINT==yes:)#                       But only if printing to be       FS70  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS70  94
movechar:(MAPCHR,1,FS73,6,1,0)#        Store map char as local          FS70  95
PRTSCL=SKAL#                           Set printer density scale        FS70  96
INCF=FLOAT(COLPNT)*10000.#             Set value of format incremen     FS70  97
MODF=FLOAT(10**COLPNT)#                Set across print limit           FS70  98
IF(FORMAT==2) STARTF=90116.#           Set format for packed op         FS70  99
ELSE STARTF=FLOAT(COLPNT*100)+90013.#  Set format for normal op         FS70 100
HEADF=FLOAT(COLPNT*100)+90013.#        Set format for header            FS70 101
MAPLIN=NP2*(LINPNT+1)+4#               Calc line length of map          FS70 102
NLINE=mxlnpg:#                         Set initial line count           FS70 103
IFORCE=yes:#                                                            FS70 104
IF(FORCE<small:) IFORCE=no:#           Set to rescale map to origin     FS70 105
LWID=PRORG+NP3-1#                      And width of line printed        FS70 106
IXX1=IORGX1-INCX1#                     Set page to page coordinate      FS70 107
BUFOT(1)=FLOAT(NG1)#                                                    FS70 108
BUFOT(2)=FLOAT(NG2)#                                                    FS70 109
BUFOT(3)=FLOAT(NG3)#                                                    FS70 110
ncodefld:(BUFOT,1,FS77,FM1,3)#         Encode grid points               FS70 111
movechar:(FS72,JSUM1,FS77,54,1,0)#     Insert layer axis                FS70 112
movechar:(FS72,JSUM2,FS77, 2,1,0)#     Insert down  axis                FS70 113
movechar:(FS72,JSUM3,FS77,27,1,0)#     Insert acros axis                FS70 114
IF((NG1>10)&(NG1<14)) IG=1#            11,12, and 13 are special        FS70 115
ELSE IG=MOD(NG1,10)*2+1#               Figure out ordinal suffix        FS70 116
movechar:(FS74,IG,FS77,69,2,0)#        For page to page coordinate      FS70 117
IF((NG2>10)&(NG2<14)) IG=1#            11,12, and 13 are special        FS70 118
ELSE IG=MOD(NG2,10)*2+1#               Figure out ordinal suffix        FS70 119
movechar:(FS74,IG,FS77,14,2,0)#        For down the page                FS70 120
IF((NG3>10)&(NG3<14)) IG=1#            11,12, and 13 are special        FS70 121
ELSE IG=MOD(NG3,10)*2+1#               Figure out ordinal suffix        FS70 122
movechar:(FS74,IG,FS77,41,2,0)#        For across the page              FS70 123
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS70 124
#                                                                       FS70 125
#                                                                       FS70 126
# SCAN OVER ALL LAYERS WITH FIRST SUM COEFFICIENTS STORED IN CORE       FS70 127
# ---------------------------------------------------------------       FS70 128
#                                                                       FS70 129
#                                                                       FS70 130
DO IX1=1,NP1#                          Do all layers possible on        FS70 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FS70 132
DO I=MARK4,STOP4; QX(I+1)=0.#          Clear third sum coeff table      FS70 133
I3P=MARK4+2*(IH3MAX-1)#                                                 FS70 134
STPSIZ=STEP6#                                                           FS70 135
#                                                                       FS70 136
# START OF SECOND SUM                                                   FS70 137
# -------------------                                                   FS70 138
#                                                                       FS70 139
DO I3=MARK4,I3P,2#                     Scan through all h3              FS70 140
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FS70 141
ND=NG2#                                                                 FS70 142
I=MARK2+NG2+1; J=J+IH2M#                                                FS70 143
CALL FS71(I,J,ND,STPSIZ)#                                               FS70 144
I=MARK2+NG2+1#                                                          FS70 145
KK=J+2; ND=NG2#                                                         FS70 146
CALL FS71(I,KK,ND,STPSIZ)#                                              FS70 147
I=MARK2; KK=J-3; JJ=KK+2#                                               FS70 148
DO L=1,NG2#                                                             FS70 149
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FS70 150
I=I+1#                                                                  FS70 151
KK=KK+STEP6; JJ=JJ+STEP6#                                               FS70 152
N=I3+NINT(QX(I))*IH3M#                                                  FS70 153
QX(N+1)=QX(KK); QX(N+2)=-QX(JJ)#                                        FS70 154
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FS70 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FS70 156
#                                                                       FS70 157
# PRINT PAGE HEADING HERE                                               FS70 158
# -----------------------                                               FS70 159
#                                                                       FS70 160
IF(PRINT==yes:)#                       Test if fourier is to be pr      FS70 161
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FS70 162
IXX2=IORGX2-INCX2#                     Pick up starting value of x2     FS70 163
IXX1=IXX1+INCX1#                       Increment x1 pointer             FS70 164
ncodefld:(FLOAT(IXX1),1,FS77,640413.,1)# Encode section coord for hdi   FS70 165
NLINE=NLINE+MAPLIN#                    Incr line count for map          FS70 166
IF(NLINE>mxlnpg:)#                     Test if page exceeded            FS70 167
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FS70 168
LINCT=0;   NLINE=MAPLIN#               Force page & reset count         FS70 169
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FS70 170
writeline:(1,FS77,NFS77,3,3)#          Write the page heading           FS70 171
THDCOD=FLOAT(ORGX(3))#                 Get third sum starting coord     FS70 172
FMT=HEADF#                             Set up output format             FS70 173
DO IZ=1,NP3,JUMP#                      Loop over line to build col      FS70 174
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FS70 175
A=AMOD(THDCOD,MODF)#                   Avoid column overflow            FS70 176
ncodefld:(A,1,CHROT,FMT,1)#                                             FS70 177
THDCOD=THDCOD+DTTHD#                                                    FS70 178
FMT=FMT+INCF#                                                           FS70 179
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FS70 180
writeline:(1,0,0,1,3)#                 Write column headings            FS70 181
IF(MAPLIN>mxlnpg:) LINCT=100000#       Prevent pagination               FS70 182
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FS70 183
#                                                                       FS70 184
K=MARK4+IH3M*(IORGX2-INCX2)#           Start of third sum coeff         FS70 185
STPSIZ=STEP4#                                                           FS70 186
#                                                                       FS70 187
#  LOOP OVER SECOND SUM POINTS                                          FS70 188
#  ---------------------------                                          FS70 189
#                                                                       FS70 190
DO IX2=1,NP2#                          Loop over all second sum poi     FS70 191
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FS70 192
DO I3=MARK5,LW;  QX(I3+1)=0.#          Clear third sum line             FS70 193
#                                                                       FS70 194
# DO SUM BY FFT AND SORT IT INTO QX(MARK5+1) ET SEQ.                    FS70 195
# BEFORE THE FIRST STEP OF THE FFT IS BEGUN, EACH PAIR OF WORDS STARTIN FS70 196
# IN QX(MARK4+1) CONTAINS THE CONTRIBUTION FROM REFLECTIONS WITH ONE    FS70 197
# VALUE OF H(3).  THEREFORE IN ORDER TO DO THE TRANSFORMATION, A        FS70 198
# CONTRIBUTION MUST BE ADDED IN FROM EACH OF THE NG(3) PAIRS FOR EACH   FS70 199
# POINT.  AFTER A CYCLE OF THE FFT USING FACTOR F, THERE ARE CONTRIBUTI FS70 200
# FROM F VALUES OF H(3), SO ONE NEED ONLY ADD THE CONTRIBUTIONS FROM NG FS70 201
# PAIRS.  IN GENERAL, NG(3)/NSUMS PAIRS MUST BE ADDED TO GIVE THE COMPL FS70 202
# TRANSFORM.                                                            FS70 203
#                                                                       FS70 204
ND=NG3#                                                                 FS70 205
I=MARK3+NG3+1#                         Start of factor list             FS70 206
K=K+THSTEP#                                                             FS70 207
CALL FS71(I,K,ND,STPSIZ)#                                               FS70 208
#                                                                       FS70 209
# AT THIS POINT THE VALUES OF THE TRANSFORM AT THE NG(3) POINTS OF THE  FS70 210
# CURRENT LINE ARE SCRAMBLED IN THE QX ARRAY.  THE KEY FOR UNSCRAMBLING FS70 211
# BEGIN IN QX(MARK3+1). THE ELEMENTS IN THE MARK3 PORTION POINT TO      FS70 212
# WHERE THE ELEMENTS IN THE MARK4 PORTION BELONG IN THE UNSCRAMBLED     FS70 213
# ARRAY.                                                                FS70 214
#                                                                       FS70 215
I=MARK3; KK=K-1; N=MARK5+1#                                             FS70 216
DO L=1,NG3#                            Loop over the ng(3) points       FS70 217
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FS70 218
I=I+1; KK=KK+2#                        Step by 2, getting only real     FS70 219
M=N+NINT(QX(I))#                       Find where qx(kk) properly b     FS70 220
QX(M)=QX(KK)#                          Put it there                     FS70 221
DENMAX=MAX(DENMAX,QX(M))#              Get maximum density              FS70 222
DENMIN=MIN(DENMIN,QX(M))#              Get minimum density              FS70 223
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FS70 224
DO L=PRORG,IZ#                         Loop over line of points         FS70 225
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FS70 226
DENMAX=MAX(DENMAX,QX(L+1))#            Get maximum density              FS70 227
DENMIN=MIN(DENMIN,QX(L+1))#            Get minimum density              FS70 228
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FS70 229
#                                                                       FS70 230
#   OUTPUT MAP TO FILE C                                                FS70 231
#   --------------------                                                FS70 232
#                                                                       FS70 233
IF(SFILE==yes:)#                       Test if fourier to go to fil     FS70 234
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FS70 235
writepkt:(3,22,PSIZ,IZ )#              For later use by pekpik or e     FS70 236
movereal:(QX,PRORG+1,QX,IZ+1,PSIZ,1)#                                   FS70 237
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FS70 238
#                                                                       FS70 239
#   PRINT MAP LINE IF REQUESTED                                         FS70 240
#   ---------------------------                                         FS70 241
#                                                                       FS70 242
IF(PRINT==yes:)#                                                        FS70 243
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FS70 244
IF(IFORCE==yes:)#                      Test to see if the first poi     FS70 245
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FS70 246
IF(ABS(QX(MARK5+1))>small:)#           Rest of the points...            FS70 247
PRTSCL=(FORCE+.5)/ABS(QX(MARK5+1))#                                     FS70 248
IFORCE=no:#                                                             FS70 249
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FS70 250
IXX2=IXX2+INCX2#                       Calculate second sum coordin     FS70 251
BUFOT(1)=FLOAT(IXX2)#                  Encode line coordinate           FS70 252
ncodefld:(BUFOT,1,CHROT,40413.,1)#                                      FS70 253
FMT=STARTF;   IP=9#                    Set up format for first col      FS70 254
DO I3=PRORG,LWID,LEAP3#                Move the fourier to the outp     FS70 255
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FS70 256
A=QX(I3+1)*PRTSCL#                     Scale to origin depending        FS70 257
IF((A>UPLIM)\(A<LOLIM))#               Supress unwanted values          FS70 258
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FS70 259
IF(FORMAT<3) ncodefld:(A,1,CHROT,FMT,1)# Format normal or packed        FS70 260
ELSE#                                  Else shaded required             FS70 261
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FS70 262
IF(A>UPLIM) I=MIN0(NINT((A-UPLIM)/FORSCL)+7,11)# Point to op char       FS70 263
ELSE        I=MAX0(NINT((A-LOLIM)/FORSCL)+5,1)# Point to op char        FS70 264
movechar:(FS73,I,CHROT,IP,1,0)#        Insert char in buffer            FS70 265
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FS70 266
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FS70 267
ELSE movechar:(FS73,6,CHROT,IP,1,0)#   Insert point (.) in buff         FS70 268
FMT=FMT+INCF;  IP=IP+COLPNT#           Incr col pointers                FS70 269
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FS70 270
writeline:(LINPNT,0,0,1,3)#            Move the line to the printer     FS70 271
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FS70 272
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FS70 273
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FS70 274
LINCT=0#                               Reset line count                 FS70 275
#                                                                       FS70 276
RETURN#                                                                 FS70 277
END#                                                                    FS70 278
systemheader:(FS71)#                                                    FS71   1
# ####################################################################  FS71   2
#                                                                       FS71   3
#                                   FS71                                FS71   4
#                                                                       FS71   5
# ####################################################################  FS71   6
SUBROUTINE FS71(I,K,ND,STPSIZ)#                                         FS71   7
include:(AACOMN)#                                                       FS71   8
include:(FSCOMN)#                                                       FS71   9
#                                                                       FS71  10
INTEGER I#                             Pointer to factor list           FS71  11
INTEGER F#                             Current factor                   FS71  12
INTEGER K#                             Pointer to start of transfor     FS71  13
INTEGER ND#                            Denominator for exp. q term      FS71  14
INTEGER NF#                            No. of pairs to be considere     FS71  15
INTEGER NSEP#                          Separation between start of      FS71  16
INTEGER K1,K2,K3,K4,K5#                Start of small sums              FS71  17
INTEGER NSUMS#                         No. of small sums                FS71  18
INTEGER STPSIZ#                        Spacing between "real" parts     FS71  19
#                                                                       FS71  20
NF=ND#                                                                  FS71  21
NSUMS=1#                                                                FS71  22
REPEAT#                                                                 FS71  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS71  24
F=NINT(QX(I))#                         Make factor an integer           FS71  25
IF(F==0) BREAK#                        Zero factor marks end of lis     FS71  26
NF=NF/F#                                                                FS71  27
NSEP=STPSIZ*NF#                        Separation between start of      FS71  28
K1=K+1#                                Set pointers for beginnings      FS71  29
K2=K1+NSEP#                                                             FS71  30
#                                                                       FS71  31
# THERE IS A SEPARATE SUBROUTINE TO HANDLE EACH OF THE FACTORS.         FS71  32
#                                                                       FS71  33
IF(F==2)#                                                               FS71  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FS71  35
CALL FS72(QX(K1),QX(K2),NSUMS,ND,NF,STPSIZ)#                            FS71  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FS71  37
ELSE IF(F==3)#                                                          FS71  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FS71  39
K3=K2+NSEP#                            Set third pointer                FS71  40
CALL FS73(QX(K1),QX(K2),QX(K3),NSUMS,ND,NF,STPSIZ)#                     FS71  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FS71  42
ELSE IF(F==4)#                                                          FS71  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FS71  44
K3=K2+NSEP#                                                             FS71  45
K4=K3+NSEP#                                                             FS71  46
CALL FS74(QX(K1),QX(K2),QX(K3),QX(K4),NSUMS,ND,NF,STPSIZ)#              FS71  47
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FS71  48
ELSE IF(F==5)#                                                          FS71  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FS71  50
K3=K2+NSEP#                                                             FS71  51
K4=K3+NSEP#                                                             FS71  52
K5=K4+NSEP#                                                             FS71  53
CALL FS75(QX(K1),QX(K2),QX(K3),QX(K4),QX(K5),NSUMS,ND,NF,STPSIZ)#       FS71  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FS71  55
ND=ND/F#                                                                FS71  56
NSUMS=NSUMS*F#                                                          FS71  57
I=I+1#                                 Move on to next factor           FS71  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS71  59
RETURN#                                                                 FS71  60
END#                                                                    FS71  61
systemheader:(FS72)#                                                    FS72   1
#******************************************************************#    FS72   2
#                                                                  #    FS72   3
#                              FS72                                #    FS72   4
#                                                                  #    FS72   5
#******************************************************************#    FS72   6
SUBROUTINE FS72(FHZ,FH1,NSUMS,ND,NF,STPSIZ)#                            FS72   7
include:(AACOMN)#                                                       FS72   8
include:(FSCOMN)#                                                       FS72   9
#                                                                       FS72  10
# THE SUMMATION PERFORMED IS                                            FS72  11
#  [SUM (H=0,1)[F*EXP(2PI*I*(1/2)*H*M)]]*EXP(2PI*I*(Q/ND)*M)            FS72  12
#                                                                       FS72  13
# NOTE THAT THE FIRST EXPONENTIAL TERM IS EITHER+OR-1 DEPENDING ON THE  FS72  14
# PARITY OF THE PRODUCT H*M. M MAY TAKE ON THE VALUES 0 AND 1.  THE F V FS72  15
# FOR H=0 ARE IN FHZ, AND FOR H=1 IN FH1.  THE RESULTS OF THE SUM FOR M FS72  16
# ARE IN FHZ AND FOR M=1 IN FH1.  THERE ARE NSUMS MAJOR SEGMENTS AND WI FS72  17
# EACH SEGMENT Q RUNS FROM 0 TO (NF-1).  THIS MEANS THAT EVERY POINT IS FS72  18
# TREATED IN ONE CYCLE THROUGH THE SUBROUTINE SINCE NSUMS*NF*2=NP(3).   FS72  19
#                                                                       FS72  20
INTEGER K#                                                              FS72  21
INTEGER N#                                                              FS72  22
INTEGER STPSIZ#                        Step size over each coeffici     FS72  23
INTEGER J#                                                              FS72  24
INTEGER JP#                                                             FS72  25
INTEGER STEP#                          Step size over major segment     FS72  26
INTEGER NF#                                                             FS72  27
INTEGER ND#                                                             FS72  28
INTEGER NSUMS#                                                          FS72  29
REAL FHZ(*),FH1(*)#                    Coefficients for sums            FS72  30
REAL EXP#                              Second exponential term          FS72  31
REAL R1,I1#                            Re and im parts before jp ph     FS72  32
REAL PHI,CPHI,SPHI#                    Angle,sin,and cos for jp ter     FS72  33
realdata:(TWOPI,6.28318)#                                               FS72  34
datastuff:#                                                             FS72  35
#                                                                       FS72  36
STEP=ND*STPSIZ#                                                         FS72  37
K=-STEP#                                                                FS72  38
EXP=1./FLOAT(ND)*TWOPI#                                                 FS72  39
DO N=1,NSUMS#                                                           FS72  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS72  41
K=K+STEP#                                                               FS72  42
J=K-STPSIZ#                                                             FS72  43
PHI=-EXP#                                                               FS72  44
DO JP=1,NF#                            Do sums within each segment      FS72  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FS72  46
PHI=PHI+EXP#                                                            FS72  47
J=J+STPSIZ#                                                             FS72  48
#                                                                       FS72  49
# SINCE M=0 FOR THE SUM STORED IN FHZ, IT IS SIMPLY THE SUM OF THE      FS72  50
# COEFFICIENTS IN FHZ AND FH1. SINCE M=1 FOR THE SUM STORED IN FH1,     FS72  51
# THE FIRST TERM IS POSITIVE (H=0) AND THE SECOND TERM IS NEGATIVE (H=1 FS72  52
# SO H*M IS ODD). THE SUM IS STORED TEMPORARILY IN R1 (REAL) AND I1     FS72  53
# (IMAGINARY) BEFORE THE EXPONENTIAL JP TERM IS APPLIED.                FS72  54
#                                                                       FS72  55
R1=FHZ(J+1)-FH1(J+1)#                                                   FS72  56
I1=FHZ(J+2)-FH1(J+2)#                                                   FS72  57
FHZ(J+1)=FHZ(J+1)+FH1(J+1)#                                             FS72  58
FHZ(J+2)=FHZ(J+2)+FH1(J+2)#                                             FS72  59
IF(JP!=1)#                                                              FS72  60
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FS72  61
CPHI=COS(PHI)#                                                          FS72  62
SPHI=SIN(PHI)#                                                          FS72  63
FH1(J+1)=R1*CPHI-I1*SPHI#                                               FS72  64
FH1(J+2)=R1*SPHI+I1*CPHI#                                               FS72  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FS72  66
ELSE#                                                                   FS72  67
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FS72  68
FH1(J+1)=R1#                                                            FS72  69
FH1(J+2)=I1#                                                            FS72  70
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FS72  71
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FS72  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS72  73
RETURN#                                                                 FS72  74
END#                                                                    FS72  75
systemheader:(FS73)#                                                    FS73   1
#******************************************************************#    FS73   2
#                                                                  #    FS73   3
#                              FS73                                #    FS73   4
#                                                                  #    FS73   5
#******************************************************************#    FS73   6
SUBROUTINE FS73(FHZ,FH1,FH2,NSUMS,ND,NF,STPSIZ)#                        FS73   7
include:(AACOMN)#                                                       FS73   8
include:(FSCOMN)#                                                       FS73   9
#                                                                       FS73  10
# THE SUMMATION PERFORMED IS                                            FS73  11
#                                                                       FS73  12
# [SUM(H=0 TO 2)[F*EXP(2PI*I*(1/3)*H*M)]]*EXP(2PI*I*(Q/ND)*M)           FS73  13
#                                                                       FS73  14
# M MAY HAVE THE VALUES 0,1, AND 2. THE F VALUES FOR H=0 ARE IN FHZ, FO FS73  15
# H=1 IN FH1, AND FOR H=2 IN FH2. THE RESULTS OF THE SUM FOR M=0 ARE ST FS73  16
# IN FHZ, FOR M=1 IN FH1, AND FOR M=2 IN FH2.  THERE ARE NSUMS MAJOR SE FS73  17
# AND WITHIN EACH SEGMENT Q RUNS FROM 0 TO NF-1.  THIS MEANS THAT EVERY FS73  18
# IS TREATED IN ONE CYCLE THROUGH THE SUBROUTINE SINCE NSUMS*NF*3=NP(3) FS73  19
# DOHERTY, 11-80                                                        FS73  20
#                                                                       FS73  21
INTEGER STEP#                          Step size over major segment     FS73  22
INTEGER STPSIZ#                        Step size over each coeffiec     FS73  23
INTEGER JP#                            Index of loop within major s     FS73  24
INTEGER J#                                                              FS73  25
INTEGER ND#                                                             FS73  26
INTEGER NF#                                                             FS73  27
INTEGER NSUMS#                                                          FS73  28
INTEGER K#                                                              FS73  29
INTEGER N#                                                              FS73  30
REAL R1,R2,I1,I2#                      Re and im parts before q pha     FS73  31
REAL FHZ(*),FH1(*),FH2(*)#             Coefficients for sums            FS73  32
REAL PHI#                                                               FS73  33
REAL CPHI,SPHI#                        Cos and sin of q term for m=     FS73  34
REAL C2PHI,S2PHI#                      Cos and sin of q term for m=     FS73  35
REAL EXP#                              Second exponential term          FS73  36
REAL AC,AS,BC,BS#                      Re and im contrib. to r1,r2,     FS73  37
realdata:(C1,-.5);  realdata:(S1,.8660254)#                             FS73  38
realdata:(TWOPI,6.28318)#                                               FS73  39
datastuff:#                                                             FS73  40
#                                                                       FS73  41
STEP=ND*STPSIZ#                        Factor of 2 for 3rd sum, 4 f     FS73  42
K=-STEP#                               Set pointer to step over maj     FS73  43
EXP=1./FLOAT(ND)*TWOPI#                                                 FS73  44
DO N=1,NSUMS#                          Loop over major segments         FS73  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS73  46
K=K+STEP#                                                               FS73  47
J=K-STPSIZ#                                                             FS73  48
PHI=-EXP#                                                               FS73  49
DO JP=1,NF#                            Do sums within each segment      FS73  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FS73  51
J=J+STPSIZ#                                                             FS73  52
PHI=PHI+EXP#                                                            FS73  53
#                                                                       FS73  54
# RECALL THAT COS(2*PI/3)=COS(4*PI/3) AND SIN(2*PI/3)=-SIN(4*PI/3)      FS73  55
#                                                                       FS73  56
AC=(FH1(J+1)+FH2(J+1))*C1#                                              FS73  57
BS=(FH1(J+2)-FH2(J+2))*S1#                                              FS73  58
AS=(FH1(J+1)-FH2(J+1))*S1#                                              FS73  59
BC=(FH1(J+2)+FH2(J+2))*C1#                                              FS73  60
R1=FHZ(J+1)+AC-BS#                                                      FS73  61
I1=FHZ(J+2)+AS+BC#                                                      FS73  62
R2=FHZ(J+1)+AC+BS#                                                      FS73  63
I2=FHZ(J+2)-AS+BC#                                                      FS73  64
FHZ(J+1)=FHZ(J+1)+FH1(J+1)+FH2(J+1)#   M=0 term (see comment above)     FS73  65
FHZ(J+2)=FHZ(J+2)+FH1(J+2)+FH2(J+2)#                                    FS73  66
IF(JP==1)#                             No exponential term if q=0       FS73  67
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FS73  68
FH1(J+1)=R1#                                                            FS73  69
FH1(J+2)=I1#                                                            FS73  70
FH2(J+1)=R2#                                                            FS73  71
FH2(J+2)=I2#                                                            FS73  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FS73  73
ELSE#                                  If necessary, apply exp for      FS73  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FS73  75
CPHI=COS(PHI)#                         Phase for m=1 (see comment a     FS73  76
SPHI=SIN(PHI)#                                                          FS73  77
C2PHI=CPHI**2-SPHI**2#                 Phase for m=2 term               FS73  78
S2PHI=2.*CPHI*SPHI#                                                     FS73  79
FH1(J+1)=R1*CPHI-I1*SPHI#                                               FS73  80
FH1(J+2)=R1*SPHI+I1*CPHI#                                               FS73  81
FH2(J+1)=R2*C2PHI-I2*S2PHI#                                             FS73  82
FH2(J+2)=R2*S2PHI+I2*C2PHI#                                             FS73  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FS73  84
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FS73  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS73  86
RETURN#                                                                 FS73  87
END#                                                                    FS73  88
systemheader:(FS74)#                                                    FS74   1
#******************************************************************#    FS74   2
#                                                                  #    FS74   3
#                              FS74                                #    FS74   4
#                                                                  #    FS74   5
#******************************************************************#    FS74   6
SUBROUTINE FS74(FZERO,F1,F2,F3,NSUMS,ND,NF,STPSIZ)#                     FS74   7
include:(AACOMN)#                                                       FS74   8
include:(FSCOMN)#                                                       FS74   9
#                                                                       FS74  10
# THE SUMMATION PERFORMED IS                                            FS74  11
#                                                                       FS74  12
#  T(Q,M)=[SUM (H=0 TO 3)[F*EXP(2PI*(1/4)*H*M)]]*EXP(2PI*I*(Q/ND)*M)    FS74  13
#                                                                       FS74  14
# M MAY HAVE THE VALUES 0,1,2 OR 3.  THE F VALUES FOR H=0 ARE IN FZERO, FS74  15
# H=1 IN F1, FOR H=2 IN F2 AND FOR H=3 IN F3. THE T(Q,M) ARE STORED IN  FS74  16
# FZERO(Q+1) FOR M=0, IN F1(Q+1) FOR M=1, IN F2(Q+1) FOR M=2 AND IN F3( FS74  17
# FOR M=3.  Q RUNS FROM 0 TO NF-1.                                      FS74  18
#                                                                       FS74  19
INTEGER NSUMS#                                                          FS74  20
INTEGER STPSIZ#                                                         FS74  21
INTEGER ND#                                                             FS74  22
INTEGER NF#                                                             FS74  23
INTEGER J,JP#                                                           FS74  24
INTEGER N#                                                              FS74  25
INTEGER K#                                                              FS74  26
INTEGER STEP#                                                           FS74  27
REAL EXP#                              Second exponential term          FS74  28
REAL FZERO(*),F1(*),F2(*),F3(*)#       Vide supra                       FS74  29
REAL PHI,CPHI,SPHI#                    Angle, cos and sin for 2nd e     FS74  30
REAL C2PHI,S2PHI#                      As for cphi, but m=2             FS74  31
REAL C3PHI,S3PHI#                      As for cphi, but m=3             FS74  32
REAL ASUMZ,ASUM1,BSUMZ,BSUM1#          Intermediate stages of summa     FS74  33
REAL AEVEN,AODD,BEVEN,BODD#            Intermediate stages of summa     FS74  34
REAL R1,I1,R2,I2,R3,I3#                Summation before applying ex     FS74  35
realdata:(TWOPI,6.28318)#                                               FS74  36
datastuff:#                                                             FS74  37
#                                                                       FS74  38
EXP=1./FLOAT(ND)*TWOPI#                                                 FS74  39
STEP=STPSIZ*ND#                                                         FS74  40
K=-STEP#                                                                FS74  41
DO N=1,NSUMS#                                                           FS74  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS74  43
K=K+STEP#                                                               FS74  44
J=K-STPSIZ#                                                             FS74  45
PHI=-EXP#                                                               FS74  46
DO JP=1,NF#                                                             FS74  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FS74  48
J=J+STPSIZ#                                                             FS74  49
PHI=PHI+EXP#                                                            FS74  50
#                                                                       FS74  51
# FOR H=0, THE FIRST EXPONENTIAL TERM IS ALWAYS+1. FOR H=2, THE FIRST   FS74  52
# EXPONENTIAL TERM IS+1 IF M IS EVEN AND-1 IF M IS ODD.  FOR H=1 OR 3,  FS74  53
# ONLY THE IMAGINARY PART OF THE COEFFICIENT WILL CONTRIBUTE TO THE RAL FS74  54
# OF THE PORDUCT WHEN M=1 OR 3, SINCE COS(2PI/4)=COS(3*2PI/4)=0.        FS74  55
# WHEN M=2, ONLY THE REAL PARTS OF ALL FOUR COEFFICIENTS CONTRIBUTE TO  FS74  56
# REAL PART OF THE SUM.                                                 FS74  57
#                                                                       FS74  58
AEVEN=FZERO(J+1)-F2(J+1)#                                               FS74  59
AODD=F1(J+1)-F3(J+1)#                                                   FS74  60
BEVEN=FZERO(J+2)-F2(J+2)#                                               FS74  61
BODD=F1(J+2)-F3(J+2)#                                                   FS74  62
ASUMZ=FZERO(J+1)+F2(J+1)#                                               FS74  63
ASUM1=F1(J+1)+F3(J+1)#                                                  FS74  64
BSUMZ=FZERO(J+2)+F2(J+2)#                                               FS74  65
BSUM1=F1(J+2)+F3(J+2)#                                                  FS74  66
#                                                                       FS74  67
R1=AEVEN-BODD#                                                          FS74  68
I1=BEVEN+AODD#                                                          FS74  69
R2=ASUMZ-ASUM1#                                                         FS74  70
I2=BSUMZ-BSUM1#                                                         FS74  71
R3=AEVEN+BODD#                                                          FS74  72
I3=BEVEN-AODD#                                                          FS74  73
#                                                                       FS74  74
FZERO(J+1)=ASUMZ+ASUM1#                                                 FS74  75
FZERO(J+2)=BSUMZ+BSUM1#                                                 FS74  76
IF(JP!=1)#                                                              FS74  77
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FS74  78
CPHI=COS(PHI)#                                                          FS74  79
SPHI=SIN(PHI)#                                                          FS74  80
C2PHI=CPHI**2-SPHI**2#                                                  FS74  81
S2PHI=2.*CPHI*SPHI#                                                     FS74  82
C3PHI=CPHI*C2PHI-SPHI*S2PHI#                                            FS74  83
S3PHI=CPHI*S2PHI+SPHI*C2PHI#                                            FS74  84
F1(J+1)=R1*CPHI-I1*SPHI#                                                FS74  85
F1(J+2)=R1*SPHI+I1*CPHI#                                                FS74  86
F2(J+1)=R2*C2PHI-I2*S2PHI#                                              FS74  87
F2(J+2)=R2*S2PHI+I2*C2PHI#                                              FS74  88
F3(J+1)=R3*C3PHI-I3*S3PHI#                                              FS74  89
F3(J+2)=R3*S3PHI+I3*C3PHI#                                              FS74  90
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FS74  91
ELSE#                                                                   FS74  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FS74  93
F1(J+1)=R1#                                                             FS74  94
F1(J+2)=I1#                                                             FS74  95
F2(J+1)=R2#                                                             FS74  96
F2(J+2)=I2#                                                             FS74  97
F3(J+1)=R3#                                                             FS74  98
F3(J+2)=I3#                                                             FS74  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FS74 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FS74 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS74 102
RETURN#                                                                 FS74 103
END#                                                                    FS74 104
systemheader:(FS75)#                                                    FS75   1
#**************************************************************#        FS75   2
#                                                              #        FS75   3
#                            FS75                              #        FS75   4
#                                                              #        FS75   5
#**************************************************************#        FS75   6
SUBROUTINE FS75(FZERO,F1,F2,F3,F4,NSUMS,ND,NF,STPSIZ)#                  FS75   7
include:(AACOMN)#                                                       FS75   8
include:(FSCOMN)#                                                       FS75   9
#                                                                       FS75  10
# THE SUMMATION PREFORMED IS                                            FS75  11
#                                                                       FS75  12
# T(Q,M)=[SUM (H=0 TO 4)[F*EXP(2PI*I*H*M)]]*EXP(2PI*I*(Q/ND)*M)         FS75  13
#                                                                       FS75  14
# M MAY HAVE THE VALUES 0,1,2,3 AND 4.  THE F VALUES FOR H=0 ARE IN     FS75  15
# FZERO, FOR H=1 IN F1, FOR H=2 IN F2, FOR H=3 IN F3, AND FOR H=4 IN F4 FS75  16
# THE T(Q,M) ARE STORED IN FZERO(Q+1) FOR M=0, IN F1(Q+1) FOR M=1, IN   FS75  17
# F2(Q+2) FOR M=2, IN F3(Q+1) FOR M=3 AND IN F4(Q+1) FOR M=4.  Q RUNS   FS75  18
# FROM 0 TO (NF-1).                                                     FS75  19
#                                                                       FS75  20
INTEGER J#                                                              FS75  21
INTEGER JP#                                                             FS75  22
INTEGER K#                                                              FS75  23
INTEGER N#                                                              FS75  24
INTEGER ND#                                                             FS75  25
INTEGER NF#                                                             FS75  26
INTEGER NSUMS#                                                          FS75  27
INTEGER STPSIZ#                                                         FS75  28
INTEGER STEP#                                                           FS75  29
REAL ASUM1,ASUM2,ADIF1,ADIF2#                                           FS75  30
REAL AOC,AEC,AOS,AES#                                                   FS75  31
REAL BSUM1,BSUM2,BDIF1,BDIF2#                                           FS75  32
REAL BOC,BEC,BOS,BES#                                                   FS75  33
REAL FZERO(*),F1(*),F2(*),F3(*),F4(*)#                                  FS75  34
REAL R1,I1,R2,I2,R3,I3,R4,I4#                                           FS75  35
REAL EXP#                                                               FS75  36
REAL PHI,CPHI,SPHI#                                                     FS75  37
REAL C2PHI,S2PHI#                                                       FS75  38
REAL C3PHI,S3PHI#                                                       FS75  39
REAL C4PHI,S4PHI#                                                       FS75  40
realdata:(TWOPI,6.28318)#                                               FS75  41
realdata:(C1,0.30901699);  realdata:(S1,0.95105652)#                    FS75  42
realdata:(C2,-0.80901699);  realdata:(S2,0.58778525)#                   FS75  43
datastuff:#                                                             FS75  44
#                                                                       FS75  45
STEP=STPSIZ*ND#                                                         FS75  46
K=-STEP#                                                                FS75  47
EXP=1./FLOAT(ND)*TWOPI#                                                 FS75  48
DO N=1,NSUMS#                                                           FS75  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FS75  50
K=K+STEP#                                                               FS75  51
J=K-STPSIZ#                                                             FS75  52
PHI=-EXP#                                                               FS75  53
DO JP=1,NF#                                                             FS75  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FS75  55
J=J+STPSIZ#                                                             FS75  56
PHI=PHI+EXP#                                                            FS75  57
#                                                                       FS75  58
# RECALL THAT COS(2PI/5)=COS(4*2PI/5) , AND SIN(2PI/5)=-SIN(4*2PI/5) .  FS75  59
# ALSO COS(2*2PI/5)=COS(3*2PI/5) AND SIN(2*2PI/5)=-SIN(3*2PI/5).        FS75  60
# IN THE FOLLOWING, CERTAIN TERMS ARE GROUPED TOGETHER TO SIMPLIFY THE  FS75  61
# ACTUAL SUMMATION INDICATED IN THE OPENING COMMENT.  ALL THE A TERMS R FS75  62
# TO THE REAL PARTS OF THE COEFFICIENTS, AND THE B TERMS REFER TO THE   FS75  63
# IMAGINARY PARTS.                                                      FS75  64
#                                                                       FS75  65
ASUM1=F1(J+1)+F4(J+1)#                                                  FS75  66
ASUM2=F2(J+1)+F3(J+1)#                                                  FS75  67
ADIF1=F1(J+1)-F4(J+1)#                                                  FS75  68
ADIF2=F2(J+1)-F3(J+1)#                                                  FS75  69
AEC=FZERO(J+1)+ASUM1*C1+ASUM2*C2#                                       FS75  70
AOC=FZERO(J+1)+ASUM1*C2+ASUM2*C1#                                       FS75  71
AES=ADIF1*S1+ADIF2*S2#                                                  FS75  72
AOS=ADIF1*S2-ADIF2*S1#                                                  FS75  73
#                                                                       FS75  74
BSUM1=F1(J+2)+F4(J+2)#                                                  FS75  75
BSUM2=F2(J+2)+F3(J+2)#                                                  FS75  76
BDIF1=F1(J+2)-F4(J+2)#                                                  FS75  77
BDIF2=F2(J+2)-F3(J+2)#                                                  FS75  78
BEC=FZERO(J+2)+BSUM1*C1+BSUM2*C2#                                       FS75  79
BOC=FZERO(J+2)+BSUM1*C2+BSUM2*C1#                                       FS75  80
BES=BDIF1*S1+BDIF2*S2#                                                  FS75  81
BOS=BDIF1*S2-BDIF2*S1#                                                  FS75  82
#                                                                       FS75  83
# THE R'S AND I'S ARE THE REAL AND IMAGINARY PARTS OF THE SUM BEFORE TH FS75  84
# EXPONENTIAL Q TERM HAS BEEN APPLIED.                                  FS75  85
#                                                                       FS75  86
R1=AEC-BES#                                                             FS75  87
I1=AES+BEC#                                                             FS75  88
R2=AOC-BOS#                                                             FS75  89
I2=AOS+BOC#                                                             FS75  90
R3=AOC+BOS#                                                             FS75  91
I3=-AOS+BOC#                                                            FS75  92
R4=AEC+BES#                                                             FS75  93
I4=-AES+BEC#                                                            FS75  94
#                                                                       FS75  95
# IF EXPONENTIAL Q TERM IS OTHER THAN 1, APPLY IT.                      FS75  96
#                                                                       FS75  97
FZERO(J+1)=FZERO(J+1)+ASUM1+ASUM2#     For m=0, both exponentials       FS75  98
FZERO(J+2)=FZERO(J+2)+BSUM1+BSUM2#                                      FS75  99
IF(JP==1)#                             Q term is+1                      FS75 100
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FS75 101
F1(J+1)=R1#                                                             FS75 102
F1(J+2)=I1#                                                             FS75 103
F2(J+1)=R2#                                                             FS75 104
F2(J+2)=I2#                                                             FS75 105
F3(J+1)=R3#                                                             FS75 106
F3(J+2)=I3#                                                             FS75 107
F4(J+1)=R4#                                                             FS75 108
F4(J+2)=I4#                                                             FS75 109
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FS75 110
ELSE#                                  Q term is not+1                  FS75 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FS75 112
CPHI=COS(PHI)#                                                          FS75 113
SPHI=SIN(PHI)#                                                          FS75 114
C2PHI=CPHI**2-SPHI**2#                                                  FS75 115
S2PHI=2.*CPHI*SPHI#                                                     FS75 116
C3PHI=CPHI*C2PHI-SPHI*S2PHI#                                            FS75 117
S3PHI=SPHI*C2PHI+S2PHI*CPHI#                                            FS75 118
C4PHI=C2PHI**2-S2PHI**2#                                                FS75 119
S4PHI=2.*C2PHI*S2PHI#                                                   FS75 120
F1(J+1)=R1*CPHI-I1*SPHI#                                                FS75 121
F1(J+2)=R1*SPHI+I1*CPHI#                                                FS75 122
F2(J+1)=R2*C2PHI-I2*S2PHI#                                              FS75 123
F2(J+2)=R2*S2PHI+I2*C2PHI#                                              FS75 124
F3(J+1)=R3*C3PHI-I3*S3PHI#                                              FS75 125
F3(J+2)=R3*S3PHI+I3*C3PHI#                                              FS75 126
F4(J+1)=R4*C4PHI-I4*S4PHI#                                              FS75 127
F4(J+2)=R4*S4PHI+I4*C4PHI#                                              FS75 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FS75 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FS75 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FS75 131
RETURN#                                                                 FS75 132
END#                                                                    FS75 133
pmacro:([no:])#                        Purge xtal system macros         FS75 134
