systemheader:(MA    )#                                                  MA     1
####################################################################### MA     2
#                                                                     # MA     3
#                           *** MEPHAS ***                            # MA     4
#                                                                     # MA     5
#    THE PROGRAM MEPHAS EXTENDS PHASES IN FOUR DIFFERENT MODES        # MA     6
#    FIRST, BY THE USE OF CENTRIC REFLECTIONS IN A PROCESS OF         # MA     7
#    TESTING 16 REFLECTIONS AT A TIME. THIS IS THE MESIGN MODE.       # MA     8
#    SECOND, BY TAKING A GENERAL REFLECTION AND STEPPING IT FROM      # MA     9
#    0 TO 360 DEGREES. THIS IS THE MECYC MODE.   THIRD, BY TAKING     # MA    10
#    A SUBSET OF REFLECTIONS AND TRYING EACH PHASE AND ITS SUPPLEMENT.# MA    11
#    THIS IS THE MEOSC MODE.                                          # MA    12
#    FOURTH, BY TAKING A LARGE SUBSET OF REFLECTIONS AND THEIR PHASES # MA    13
#    DERIVED FROM MAPS CREATED BY THE FIRST THREE MODES AND REFINING  # MA    14
#    THEIR MODULI.                                                    # MA    15
#    THE CODE IS BASED ON THE PROGRAM MESIGNS WRITTEN                 # MA    16
#    BY E. PRINCE IN SEPTEMBER 1989 AT THE NATIONAL INSTITUTE OF      # MA    17
#    STANDARDS AND TECHNOLOGY.  GIVEN A 'PRIOR' INPUT LOGRITHMIC      # MA    18
#    DENSITY MAP PRODUCED BY MEDENS OR THIS PROGRAM AND A LIST OF     # MA    19
#    REFLECTIONS CHOSEN EITHER BY THE USER OR AUTOMATICALLY           # MA    20
#    THE PROGRAM DETERMINES THE THE PHASES OF THE SPECIFIED           # MA    21
#    REFLECTIONS AND FORCES THE CALCULATED MODULI TO MATCH THE        # MA    22
#    OBSERVED MODULI. SEARCHING IN THE MESIGN MEOSC AND MECYC MODES   # MA    23
#    FOR THE PHASES THAT PRODUCE THE MAXIMUM ENTROPY.  THESE PHASES   # MA    24
#    MAY THEN BE USED TO PRODUCE A NEW 'PRIOR' MAP FOR REINPUT INTO   # MA    25
#    MEPHAS WITH A NEW LIST OF REFLECTIONS TO BE PHASED OR A RUN OF   # MA    26
#    RFOURR CAN BE MADE TO PRODUCE PHASES FOR MANY REFLECTIONS FROM   # MA    27
#    THE OUTPUT MAP.  THE MEFIT MODE CAN BE USED WITH THIS MAP TO     # MA    28
#    FIT THE MODULI OF MANY REFLECTIONS.                              # MA    29
#                                                                     # MA    30
####################################################################### MA    31
#                                                                       MA    32
include:(XMACRO)#                                                       MA    33
macro:(ma:,MA)#                        Overlay symbol                   MA    34
macro:(dirbuf:,4095)#                  Direct access file buffer siz    MA    35
macro:(bit:,[arith:(mxbtwd:,-,$1)])#                                    MA    36
macro:(swapakwd:,$(movepakwd:($1,QIQI);movepakwd:($2,$1)#               MA    37
movepakwd:(QIQI,$2)$))#                                                 MA    38
macro:(swapqx:,$(QIQI=QX($1);QX($1)=QX($2);QX($2)=QIQI$))#              MA    39
#                                                                       MA    40
extrude:(MACOMN)#                                                       MA    41
REAL    ALPHA#      ## zero of line derivative                          MA    42
REAL    BESCOR#     ## Correlation value when best criterion found      MA    43
REAL    BESENT#     ## Entropy value when best criterion found          MA    44
INTEGER CHKFMG#     ## Flag check of agreement of independent refl      MA    45
REAL    CHKMAG#     ## Minimum magnitude of F obs to include in chec    MA    46
INTEGER CHKREF#     ## Count of reflections in correlation check        MA    47
REAL    CNTRSP#     ## The contrast of the "prior" map as input CNTRS   MA    48
REAL    CNTRST#     ## The map contrast on log scale = LNRHMX-LNRHMN    MA    49
INTEGER COMBIN#     ## Pointer to current combination of test phases    MA    50
INTEGER COMREF#     ## Companion refls must be within map resolution    MA    51
REAL    CORREL#     ## Correlation between unphased fobs & f calc       MA    52
INTEGER CORUSE,CORSIG## Signal to use file for correction ln(rho) map   MA    53
REAL    COSCHK(9)#  ## Cosine values for checking centric phases        MA    54
REAL    CRIBES#     ## Best maximum entropy criterion found in run      MA    55
REAL    CRITER#     ## Criterion for selecting phases                   MA    56
REAL    CRIWGT#     ## Weight to build criterion from entropy & corre   MA    57
REAL    DETORA,RATODE# ## Degrees to radians and back                   MA    58
REAL    DFCUT#      ## Threshold of delta f for auto refl inclusion     MA    59
INTEGER DIRACC## Direct access in action flag for reverse fourier       MA    60
INTEGER DIRSIG#     ## Signal to use direct access files 3rd sums       MA    61
INTEGER DSET,ISET#  ## 1000 times the data set number                   MA    62
REAL    DUAL#       ## Value of the dual function                       MA    63
REAL    ENPRIO#     ## Entropy of 'prior' map; input expo. e.d. map     MA    64
REAL    ENTRPY#     ## Entropy found in run of MA31 (FIT)               MA    65
INTEGER EXTEST#     ## Flag extended phase combinations to be run       MA    66
INTEGER FINFIT#     ## Signal final fit has been made: update map       MA    67
INTEGER FINPNT#     ## Pointer in lr 21 of .mee file ma09 to ma50       MA    68
REAL    FITFAC#     ## Fraction of sig(fo) gradient must achieve        MA    69
REAL    FOVFC#      ## Scale factor F(0,0,0)/FC(0,0,0)                  MA    70
REAL    FC000#      ## Sum of all electrons in unit cell CALCULATED     MA    71
REAL    F000#       ## Sum of all electrons from cell contents OBSERV   MA    72
REAL    GNORM#      ## ??????????????????????????????????               MA    73
REAL    HLIM(3)#    ## Limits on mag h, k, & l for run                  MA    74
INTEGER IBEST#      ## Pointer to trial which produced max entropy      MA    75
INTEGER ICEL(3)#    ## Crystal axes and map axes                        MA    76
INTEGER ICNT#       ## Signal for centric/acentric cell as 0/1          MA    77
INTEGER ICORR,IPRIOR# ## Pointers to corrected and prior maps in MA60   MA    78
INTEGER IHMAX(3)#   ## Max hkl permuted for use during summation        MA    79
INTEGER IMAP(3)#    ## Summation order correlation between              MA    80
INTEGER INCX(3)#    ## Increments along cell directions in grid point   MA    81
INTEGER IREL(12)#   ## pointers to items discovered by indexpkt:        MA    82
INTEGER ISUM1#      ## Contains map code for x (1=lay;2=dow;3=acc)      MA    83
INTEGER ISUM2#      ## Contains map code for y (1=lay;2=dow;3=acc)      MA    84
INTEGER ISUM3#      ## Contains map code for z (1=lay;2=dow;3=acc)      MA    85
INTEGER IWANT(11)#  ## indexpkt: array for wanted items                 MA    86
INTEGER IXINC(3)#   ## Incx modified to be positive for actual          MA    87
INTEGER IXORG(3)#   ## Permuted plot origins in grid params modulo ng   MA    88
INTEGER JP#         ## File D offset pointer for record 21              MA    89
INTEGER KEY(4)#     ## signals for indexpkt: utility                    MA    90
REAL    LNFOFC#     ## Ln(F000/FC000) sum of corr. to scale of 'prior   MA    91
REAL    LNRHSC#     ## Ln(vol/totpix) rho from e/a**3 to e/pixel        MA    92
REAL    LNRHMN#     ## Ln(rho minimum) for 'current' map                MA    93
REAL    LNRHMP#     ## Ln(rho minimum) for 'prior' map                  MA    94
REAL    LNRMNS#     ## Ln(rho minimum) for 'updated' map                MA    95
REAL    LNRHMX#     ## Ln(rho maximum) for 'current' map                MA    96
REAL    LNRMXS#     ## Ln(rho maximum) for 'updated' map                MA    97
INTEGER LTYP#       ## P,I,R,F,A,B,C as 1-7 acentric 8-14 centric       MA    98
INTEGER MARKG#      ## Start of sec sum coef for fft                    MA    99
INTEGER MARKM#      ## Start of storage of 'prior' ln(rho) map          MA   100
INTEGER MARKN#      ## Start of storage of 'log adjustments' map        MA   101
INTEGER MARKP#      ## Start of third sum coef for fft                  MA   102
INTEGER MARKQ#      ## Start of 'companion' reflection storage          MA   103
INTEGER MARKR#      ## Start of storage of treated reflections          MA   104
##             N.B. SEE THE COMMENT IN MA08 WHICH TELLS WHAT'S IN THERE MA   105
INTEGER MARKS#      ## Start of storage of symmetry operations          MA   106
INTEGER MARKX,MARKY## Start region for reflection sort pointers         MA   107
INTEGER MARK1,MARK2,MARK3,MARK4,MARK5,MARK6# Recip to dir fft pointer   MA   108
INTEGER MAXH(3)#    ## Maximum miller indices in the unit cell          MA   109
INTEGER MAXPHA#     ## Maximum phases treated in a run                  MA   110
REAL    MEANFC,MEANFO## For means of correlation reflections            MA   111
INTEGER MITERA#     ## Maximum number of iterations to fit moduli       MA   112
INTEGER MDENT#      ## QX array which holds the +- entopy differences   MA   113
INTEGER MECYC#      ## Signal phasing a few gen'rl refls by stepping    MA   114
INTEGER MEFIT#      ## Signal if fitting reflection moduli              MA   115
INTEGER MEOSC#      ## Signal testing refls by phase oscillation        MA   116
INTEGER MESIGN#     ## Signal testing centric phases by statistics      MA   117
INTEGER MGRAD#      ## QX array which holds the gradient vector, dF     MA   118
INTEGER MHESS#      ## QX array which holds the Hessian matrix          MA   119
INTEGER MWRK1#      ## QX array which holds the first 'work' vector     MA   120
INTEGER MWRK2#      ## QX array which holds the second 'work' vector    MA   121
INTEGER MWRK3#      ## QX array which holds the third 'work' vector     MA   122
INTEGER MWRK4#      ## QX array which holds the fourth 'work' vector    MA   123
INTEGER MWRK5#      ## QX array which holds the fifth 'work' vector     MA   124
INTEGER MXNEW#      ## QX array which holds the latest X vector*        MA   125
INTEGER MXOLD#      ## QX array which holds the previous X vector*      MA   126
# * THESE ARE MULTIPLIERS OF THE LAGRANGE TYPE USED HERE TO WEIGHT      MA   127
#   THE CONSTRAINTS OF PRINCE'S DUAL FUNCTION.                          MA   128
INTEGER NITERA#     ## Number of fitting iterations within a trial      MA   129
INTEGER NDIV1,NDIV2,NDIV3## Fourier grid divisions                      MA   130
INTEGER NEGIND(3)#  ## Signal any neg h,k,l yes:/no: among reflection   MA   131
INTEGER NG(3)#      ## Number of grid points in map                     MA   132
INTEGER NH1,NH2,NH3## No. of indices in each direction 0,+&- for ma80   MA   133
INTEGER NOTMED## Signal that an input map is not from medens run        MA   134
INTEGER NP(3)#      ## Actual number of points in map                   MA   135
INTEGER NPHOLD(3)#  ## Holding place actual number of points in map     MA   136
INTEGER NPIX#       ## Total pixels in input fourier map                MA   137
INTEGER NPP1#       ## Running 1st sum points - changes as layers don   MA   138
INTEGER NREADS#     ## Number of direct access reads to get in a laye   MA   139
INTEGER NREF#       ## Number of reflections to have moduli fitted      MA   140
INTEGER NREFIX#     ## Number of reflections with fixed phases          MA   141
INTEGER NROT#       ## No. of symops exclusive of center and center'n   MA   142
INTEGER NRSZ#       ## symops with same pattern of zeros in rot matri   MA   143
INTEGER NSCL#       ## No. of f relative scale groups                   MA   144
INTEGER NSYM#       ## Number of symmetry operators in space group      MA   145
INTEGER NX1,NX2,NX3## No. of points in each direction                   MA   146
INTEGER NYQF1,NYQF2,NYQF3## Nyquist frequencies in each direction       MA   147
INTEGER NYQF3P## Third nyquist frequency plus one for use in ma80       MA   148
INTEGER OLDPHA#     ## Signal if old phases are to be used to start     MA   149
INTEGER ONMAX#      ## Value of ontest when maximum entropy hit         MA   150
REAL    ONPHAS#     ## Current phase shift during general cycling       MA   151
INTEGER ONTEST## Counter to note trial where maximum entropy occurs     MA   152
INTEGER ORGX(3)#    ## Permuted origin points on axis in grid units     MA   153
REAL ORTHOV(16,16)# ## Sign combinations for trials                     MA   154
INTEGER PASS,PASSES## Counter to control forward fourier by parts       MA   155
REAL    PHAJMP#     ## Phase shift for use in general phase search      MA   156
INTEGER PHASED#     ## Signal MEPHAS has previously treated refl'ns     MA   157
INTEGER PRINTL#     ## Flag to control printing                         MA   158
INTEGER PRIUSE,PRISIG## Signal to use file for 'prior' ln(rho) map      MA   159
REAL    RESCAL#     ## Rescale factor taken from MEDENS input file      MA   160
REAL    RHOTHR#     ## Threshhold of rho in input map                   MA   161
INTEGER RSUM1#      ## Contains cell code for layer (1=X,2=Y,3=Z)       MA   162
INTEGER RSUM2#      ## Contains cell code for down  (1=X,2=Y,3=Z)       MA   163
INTEGER RSUM3#      ## Contains cell code for accros(1=X,2=Y,3=Z)       MA   164
REAL    RU#         ## R value for reflections with unit weight         MA   165
REAL    RW#         ## R value for weighted reflections                 MA   166
REAL    SCALE(65)#  ## F relative scale factors                         MA   167
REAL    SIGGVN#     ## Sigma as fraction of f obs                       MA   168
REAL    SHARPF#     ## Sharpening factor taken from MEDENS input file   MA   169
INTEGER SIGNC#      ## 0/1/2 for no/+/- 'combin' being tested in ma30   MA   170
REAL    SINCHK(9)#  ## Sine values for checking centric phases          MA   171
INTEGER SORSLO,SORMED,SORFAS## Reflection sort order codes from lrexp   MA   172
INTEGER SORT,SORTP## sort order codes from lrrefl: and rec 21 of .map   MA   173
INTEGER STEPG,STEPP,STEPGP,STEPH## Stepping sizes for rev. fourier      MA   174
INTEGER STEPQ#      ## No of items per 'companion' reflection           MA   175
INTEGER STEPR#      ## Number of items per refl to be phased            MA   176
INTEGER STEPS#      ## Number of items per symop                        MA   177
INTEGER STEP1,STEP4,STEP6#                                              MA   178
INTEGER STOPM#      ## End of 'prior' ln(rho) array                     MA   179
INTEGER STOPN#      ## End of 'ln(adjustments)' array                   MA   180
INTEGER STOPQ#      ## End of items for 'companion' reflections         MA   181
INTEGER STOPP#      ## End of third sum coeff storage in rev. four.     MA   182
INTEGER STOPR#      ## End of input phase information                   MA   183
INTEGER STOPS#      ## End of symmetry operations                       MA   184
INTEGER STOPT#      ## End of expanded to complete set of symops        MA   185
INTEGER STOPX,STOPY## End region for reflection sort pointers           MA   186
INTEGER STOP1,STOP2,STOP3,STOP4,STOP5,STOP6#                            MA   187
REAL SUFC,SUFC2,SUFO,SUFOFC,SUFO2,SUREF## Sums for correlation          MA   188
REAL    SUMRCU#     ## Sum of rho cubed over all pixels                 MA   189
REAL    SUMRHO#     ## Sum of rho over all pixels                       MA   190
REAL    SUMRCN# ## Sum of rho*((lnrho-lnrhmn)/cntrst)**2 all pixels     MA   191
REAL    SUTEST#     ## Test for contributor                             MA   192
REAL    THRESH#     ## Threshold of calc'd a & b to set 0/90/180/270    MA   193
INTEGER TOTHES#     ## Total elements in triangular Hessian matrix      MA   194
REAL    TOTPIX#     ## Floating point value of total pixels in map      MA   195
INTEGER TOTREF#     ## Total reflections generated for the hessian      MA   196
REAL    TWOPI#      ## Two times pi for cycles to radians               MA   197
REAL    VOL#        ## Unit cell volume                                 MA   198
INTEGER YATENT#     ## Entropy/criterion yes:/no: used in Yate's alg.   MA   199
#                                                                       MA   200
COMMON/COMIMA/$#                                                        MA   201
CHKFMG,CHKREF,COMBIN,COMREF,CORREL,CORSIG,CORUSE,DIRACC,$#              MA   202
DIRSIG,EXTEST,PRISIG,DSET  ,ISET  ,$#                                   MA   203
IBEST ,ICEL  ,ICNT  ,ICORR ,IPRIOR,IHMAX ,IMAP  ,INCX  ,IREL  ,$#       MA   204
ISUM1 ,ISUM2 ,ISUM3 ,IWANT ,IXINC ,IXORG ,JP    ,KEY   ,LTYP  ,$#       MA   205
MARKG ,MARKM ,MARKN ,MARKP ,MARKQ ,MARKR ,MARKS ,MARKX ,$#              MA   206
MARKY ,MARK1 ,MARK2 ,MARK3 ,MARK4 ,MARK5 ,MARK6 ,MAXH  ,$#              MA   207
MAXPHA,MDENT ,MECYC ,MEFIT ,MEOSC ,MESIGN,MGRAD ,MHESS ,MITERA,$#       MA   208
MWRK1 ,MWRK2 ,MWRK3 ,MWRK4 ,MWRK5 ,MXNEW ,MXOLD ,NDIV1 ,$#              MA   209
NDIV2 ,NDIV3 ,NEGIND,NG    ,NH1   ,NH2   ,NH3   ,NITERA,NOTMED,$#       MA   210
NP    ,NPHOLD,NPIX  ,NPP1#                                              MA   211
COMMON/COMLMA/$#                                                        MA   212
NREADS,NREF  ,NREFIX,NROT  ,NRSZ  ,NSCL  ,NSYM  ,NX1   ,NX2   ,$#       MA   213
NX3   ,NYQF1 ,NYQF2 ,NYQF3 ,NYQF3P,OLDPHA,ONMAX ,ONTEST,ORGX  ,$#       MA   214
PASS  ,PASSES,PHASED,PRINTL,PRIUSE,RSUM1 ,RSUM2 ,RSUM3 ,SORSLO,$#       MA   215
SORMED,SORFAS,SORT  ,SORTP ,STEPG ,STEPGP,STEPH ,STEPP ,$#              MA   216
STEPQ ,STEPR ,STEPS ,STEP1 ,STEP4 ,STEP6 ,STOPM ,$#                     MA   217
STOPN ,STOPP ,STOPQ ,STOPR ,STOPS ,STOPT ,STOPX ,STOPY ,$#              MA   218
STOP1 ,STOP2 ,STOP3 ,STOP4 ,STOP5 ,$#                                   MA   219
STOP6 ,SIGNC ,TOTHES,TOTPIX,TOTREF,YATENT#                              MA   220
COMMON/COMFMA/$#                                                        MA   221
ALPHA ,BESCOR,BESENT,CNTRSP,CNTRST,COSCHK,CRIBES,CRITER,CRIWGT,$#       MA   222
DETORA,DFCUT ,DUAL  ,ENPRIO,ENTRPY,FINFIT,FINPNT,FITFAC,FOVFC ,$#       MA   223
FC000 ,F000  ,GNORM ,HLIM  ,LNFOFC,LNRHSC,LNRHMN,LNRHMP,$#              MA   224
LNRHMX,LNRMNS,LNRMXS,CHKMAG,$#                                          MA   225
MEANFC,MEANFO,ONPHAS,ORTHOV,PHAJMP,RESCAL,RHOTHR,RU    ,RW    ,$#       MA   226
RATODE,SCALE ,SIGGVN,SHARPF,SINCHK,SUFC  ,SUFC2 ,SUFO  ,SUFOFC,$#       MA   227
SUFO2 ,SUREF,SUMRCU,SUMRHO,SUMRCN,SUTEST,THRESH,TWOPI  ,VOL#            MA   228
#                                                                       MA   229
endext:#                                                                MA   230
#                                                                       MA   231
systemheader:(MA00)#                                                    MA00   1
# ################################################################## #  MA00   2
#                                                                    #  MA00   3
#                               MA00                                 #  MA00   4
#                                                                    #  MA00   5
# ################################################################## #  MA00   6
SUBROUTINE MA00## D.M. Collins, J.M. Stewart                            MA00   7
IMPLICIT NONE#                                                          MA00   8
include:(AACOMN)#                      March 1990                       MA00   9
include:(MACOMN)#                                                       MA00  10
#                                                                       MA00  11
FILEXT(IOUNIT(4))='MED'#               'prior' input density map        MA00  12
FILEXT(IOUNIT(5))='MEE'#               'update' output density map      MA00  13
FILEXT(IOUNIT(6))='XX1'#               Scratch ln(rho) prior            MA00  14
FILEXT(IOUNIT(7))='XX2'#               Scratch ln(rho) correction       MA00  15
FILEXT(unitda2:)='XX3'#                Scratch file reverse fourier     MA00  16
#                                                                       MA00  17
CALL MA01#                             Simulate block data              MA00  18
CALL MA08#                             Bdf input and startup            MA00  19
CALL MA20#                             Load map and get density stats   MA00  20
IF(MEFIT==yes:) CALL MA25#             Fit many reflection moduli       MA00  21
IF(MEOSC==yes:) CALL MA26#             Test many centri refl phases     MA00  22
IF(MECYC==yes:) CALL MA27#             Test gen'rl reflection  phases   MA00  23
IF(MESIGN==yes:) CALL MA30#            Statistical centric phase det.   MA00  24
#                                                                       MA00  25
RETURN#                                                                 MA00  26
END#                                                                    MA00  27
systemheader:(MA01)#                   Mesign block data                MA01   1
#********************************************************************** MA01   2
#                                                                     # MA01   3
#                             MA01                                    # MA01   4
#                                                                     # MA01   5
#********************************************************************** MA01   6
SUBROUTINE MA01#                       J.m. stewart mar 1990            MA01   7
IMPLICIT NONE#                                                          MA01   8
# BLOCK DATA                                   E. PRINCE SEPT 1989      MA01   9
include:(MACOMN)#                                                       MA01  10
INTEGER J#                             Loop index                       MA01  11
#                                                                       MA01  12
# THIS SUBROUTINE SETS THE PATTERN OF PHASE COMBINATIONS USED TO        MA01  13
# MAKE THE INITIAL SEARCH FOR A MAXIMUM ENTROPY CONSTRAINED             MA01  14
# EXPONENTIAL ELECTRON DENSITY.  THESE AND THE SET OBTAINED BY          MA01  15
# TAKING THEIR NEGATIVES ARE USED IN THE SEARCH. L1,3,... IS A SET      MA01  16
# OF REAL 'A' TERMS L2,4,... ARE THE CORRESPONDING IMAGINARY 'B'        MA01  17
# TERMS. THE INPUT RESTRICTED COSINE AND SINE OF THE PHASES             MA01  18
# CORRESPONDING TO THE 'A' AND 'B' OF THE TESTED REFLECTION ARE         MA01  19
# MULTIPLIED BY THESE TERMS TO CAUSE THE SYSTEMATIC PERMUTATION OF      MA01  20
# PHASES REQUIRED IN THE MESIGN FITTING.                                MA01  21
# -------------------------------------------------------------------   MA01  22
#                                                                       MA01  23
realdata:(L1 ,[ +1.,+1.,+1.,+1.,+1.,+1.,+1.,+1.,+1.,+1.,+1.,+1.,$#      MA01  24
+1.,+1.,+1.,+1.])#                                                      MA01  25
realdata:(L2 ,[+1.,-1.,+1.,-1.,+1.,-1.,+1.,-1.,+1.,-1.,+1.,-1.,$#       MA01  26
+1.,-1.,+1.,-1.])#                                                      MA01  27
realdata:(L3 ,[+1.,+1.,-1.,-1.,+1.,+1.,-1.,-1.,+1.,+1.,-1.,-1.,$#       MA01  28
+1.,+1.,-1.,-1.])#                                                      MA01  29
realdata:(L4 ,[+1.,-1.,-1.,+1.,+1.,-1.,-1.,+1.,+1.,-1.,-1.,+1.,$#       MA01  30
+1.,-1.,-1.,+1.])#                                                      MA01  31
realdata:(L5 ,[+1.,+1.,+1.,+1.,-1.,-1.,-1.,-1.,+1.,+1.,+1.,+1.,$#       MA01  32
-1.,-1.,-1.,-1.])#                                                      MA01  33
realdata:(L6 ,[+1.,-1.,+1.,-1.,-1.,+1.,-1.,+1.,+1.,-1.,+1.,-1.,$#       MA01  34
-1.,+1.,-1.,+1.])#                                                      MA01  35
realdata:(L7 ,[+1.,+1.,-1.,-1.,-1.,-1.,+1.,+1.,+1.,+1.,-1.,-1.,$#       MA01  36
-1.,-1.,+1.,+1.])#                                                      MA01  37
realdata:(L8 ,[+1.,-1.,-1.,+1.,-1.,+1.,+1.,-1.,+1.,-1.,-1.,+1.,$#       MA01  38
-1.,+1.,+1.,-1.])#                                                      MA01  39
realdata:(L9 ,[+1.,+1.,+1.,+1.,+1.,+1.,+1.,+1.,-1.,-1.,-1.,-1.,$#       MA01  40
-1.,-1.,-1.,-1.])#                                                      MA01  41
realdata:(L10,[+1.,-1.,+1.,-1.,+1.,-1.,+1.,-1.,-1.,+1.,-1.,+1.,$#       MA01  42
-1.,+1.,-1.,+1.])#                                                      MA01  43
realdata:(L11,[+1.,+1.,-1.,-1.,+1.,+1.,-1.,-1.,-1.,-1.,+1.,+1.,$#       MA01  44
-1.,-1.,+1.,+1.])#                                                      MA01  45
realdata:(L12,[+1.,-1.,-1.,+1.,+1.,-1.,-1.,+1.,-1.,+1.,+1.,-1.,$#       MA01  46
-1.,+1.,+1.,-1.])#                                                      MA01  47
realdata:(L13,[+1.,+1.,+1.,+1.,-1.,-1.,-1.,-1.,-1.,-1.,-1.,-1.,$#       MA01  48
+1.,+1.,+1.,+1.])#                                                      MA01  49
realdata:(L14,[+1.,-1.,+1.,-1.,-1.,+1.,-1.,+1.,-1.,+1.,-1.,+1.,$#       MA01  50
+1.,-1.,+1.,-1.])#                                                      MA01  51
realdata:(L15,[+1.,+1.,-1.,-1.,-1.,-1.,+1.,+1.,-1.,-1.,+1.,+1.,$#       MA01  52
+1.,+1.,-1.,-1.])#                                                      MA01  53
realdata:(L16,[+1.,-1.,-1.,+1.,-1.,+1.,+1.,-1.,-1.,+1.,+1.,-1.,$#       MA01  54
+1.,-1.,-1.,+1.])#                                                      MA01  55
datastuff:#                                                             MA01  56
DO J=1,16#                                                              MA01  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA01  58
ORTHOV(J,1)=L1(J) ; ORTHOV(J,2)=L2(J) ; ORTHOV(J,3)=L3(J)#              MA01  59
ORTHOV(J,4)=L4(J) ; ORTHOV(J,5)=L5(J) ; ORTHOV(J,6)=L6(J)#              MA01  60
ORTHOV(J,7)=L7(J)  ; ORTHOV(J,8)=L8(J)  ; ORTHOV(J,9)=L9(J)#            MA01  61
ORTHOV(J,10)=L10(J)  ; ORTHOV(J,11)=L11(J)  ; ORTHOV(J,12)=L12(J)#      MA01  62
ORTHOV(J,13)=L13(J)  ; ORTHOV(J,14)=L14(J)  ; ORTHOV(J,15)=L15(J)#      MA01  63
ORTHOV(J,16)=L16(J)#                                                    MA01  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA01  65
END#                                                                    MA01  66
systemheader:(MA02)#                   Set reflection exactly centric   MA02   1
#********************************************************************** MA02   2
#                                                                     # MA02   3
#                             MA02                                    # MA02   4
#                                                                     # MA02   5
#********************************************************************** MA02   6
SUBROUTINE MA02(C,S)## J.M. Stewart Jun 1990                            MA02   7
IMPLICIT NONE#                                                          MA02   8
include:(MACOMN)#                                                       MA02   9
INTEGER J#                             Loop index                       MA02  10
REAL C,S#                              The cosine and sine              MA02  11
REAL MAG#                              The modulus of vector            MA02  12
#                                                                       MA02  13
# THIS SUBROUTINE SETS THE A AND B TO A MODULUS 1 COSINE AND SINE       MA02  14
# FOR VALUES NEAR 0, 30, 45, 60, 90, 120, 135, 150, AND THEIR           MA02  15
# SUPPLEMENTS IT SETS THE VALUES 'EXACTLY' AS THE GIVEN MACHINE         MA02  16
# REGISTER ALLOWS.                                                      MA02  17
# -------------------------------------------------------------------   MA02  18
#                                                                       MA02  19
MAG=SQRT(C**2+S**2)#                   Find length of vector            MA02  20
IF(MAG<0.00001)#                       Protect against tiny ones        MA02  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA02  22
C=1.0 ; S=0.0#                         Make phase zero                  MA02  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA02  24
ELSE#                                                                   MA02  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA02  26
C=C/MAG ; S=S/MAG#                     Normalise                        MA02  27
DO J=2,6#                                                               MA02  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA02  29
#                                                                       MA02  30
# TEST IF THE TWO COMPONENTS ARE NEAR AN EXACT CENTRIC PHASE VALUE      MA02  31
# ----------------------------------------------------------------      MA02  32
#                                                                       MA02  33
IF(ABS(ABS(C)-COSCHK(J))<THRESH&ABS(ABS(S)-SINCHK(J))<THRESH)#          MA02  34
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA02  35
C=SIGN(COSCHK(J),C)#                   Make real component 'exact'      MA02  36
S=SIGN(SINCHK(J),S)#                   Also imaginary component         MA02  37
BREAK#                                                                  MA02  38
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA02  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA02  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA02  41
END#                                                                    MA02  42
systemheader:(MA08)## bdf input and initialization                      MA08   1
# ################################################################## #  MA08   2
#                                                                    #  MA08   3
#                               MA08                                 #  MA08   4
#                                                                    #  MA08   5
# ################################################################## #  MA08   6
SUBROUTINE MA08## J.M.Stewart D.M.Collins March 1990                    MA08   7
include:(AACOMN)#                                                       MA08   8
include:(MACOMN)#                                                       MA08   9
#                                                                       MA08  10
chardata:(MA10B,PR  PI  DS  SI  FF  CI  TH  CR  CF  RO  IT  NM  $#      MA08  11
MC  MF  NR  UP  DF  MO  MS  EX  WT  CV  RE  )## Control signals ;inpu   MA08  12
chardata:(MA10D,XYZ)#                                                   MA08  13
chardata:(MA10E,[ HKL FORCED CENTRIC IF COS/SIN(PHI) WITHIN        ])#  MA08  14
chardata:(MA08E,[ HKL INCLUDED ONLY IF WT*(FO-FC)     >            ])#  MA08  15
chardata:(MA10G, MAP TRANSFORMATION    X FIRST Y SEC Z THIRD )#         MA08  16
chardata:(MA10J,[YES NO  ])#                                            MA08  17
chardata:(MA10K, PROCESS A MAXIMUM ENTROPY DENSITY MAP TO ESTABLISH $#  MA08  18
PHASES.)#                                                               MA08  19
chardata:(MA10L, DIRECTIVES GIVEN OR IMPLIED BY THE MEPHAS LINE...)#    MA08  20
chardata:(MA10N, PRINT                                              )#  MA08  21
chardata:(MA10O,[ USE FILE F FOR HOLDING LN(RHO) $#                     MA08  22
PRIOR             ])#                                                   MA08  23
chardata:(MA10P, REFLECTIONS DESIGNATED TO HAVE PHASES ESTABLISHED...)# MA08  24
chardata:(MA10Q,[      H     K     L    F OBS    SIGMA(FO)         $#   MA08  25
A           B      FCALC     PHASE    STATUS])#                         MA08  26
chardata:(MA08Q,VOID)#                 To report new fcs                MA08  27
chardata:(MA10S,[ DIRECT ACCESS FILE FOR REVERSE FOURIER $#             MA08  28
TABLES    ])#                                                           MA08  29
chardata:(MA10X, TREAT DATA SET                                    )#   MA08  30
chardata:(MA10Y,[ USE FILE G FOR HOLDING LN(RHO) $#                     MA08  31
CORRECTIONS       ])#                                                   MA08  32
chardata:(MA105,[ PRIOR MAP IS A MEDENS $#                              MA08  33
MAP                        ])#                                          MA08  34
chardata:(MA106,[ MAX ITERATIONS PER PHA$#                              MA08  35
SE TRIAL                   ])#                                          MA08  36
chardata:(MA107,[ TEST GENERAL PHASES B$#                               MA08  37
Y CYCLING                   ])#                                         MA08  38
chardata:(MA108,[ PHASE SHIFT USED IN T$#                               MA08  39
ESTING REFLECTIONS          ])#                                         MA08  40
chardata:(MA109,[ MAXIMUM NUMBER OF REF$#                               MA08  41
LECTIONS TO BE PHASED       ])#                                         MA08  42
chardata:(MA111,[ FIT GENERAL REF$#                                     MA08  43
LECTION MODULI                    ])#                                   MA08  44
chardata:(MA112,[ TEST CENTRIC PHASES S$#                               MA08  45
IXTEEN AT A TIME            ])#                                         MA08  46
chardata:(MA113,[ PHASES FROM BDF USED $#                               MA08  47
AS STARTING VALUES          ])#                                         MA08  48
chardata:(MA114,[ REFINE CENTRIC $#                                     MA08  49
PHASES BY OSCILLATION             ])#                                   MA08  50
chardata:(MA115,[ ESTABLISH CORRELATION OF        UNPHASED $#           MA08  51
REFLECTIONS WITH F OBS ABOVE        ])#                                 MA08  52
chardata:(MA116,[ EXTEND TESTING OF CENTRIC PHASES FROM 16 $#           MA08  53
NEAR MAXIMUM ENTROPY TO ALL 256 POSSIBILITIES.])#                       MA08  54
chardata:(MA117,[ SELECTION BASED ON CRITERION = X.XXX*(ENTROPY) $#     MA08  55
+ X.XXX*(CORRELATION)])#                                                MA08  56
chardata:(MA118,[ FIT MODULI TO WITHIN XXX.XXX% OF SIGMA F OBS])#       MA08  57
chardata:(MA120,[HELD FIXED])#                                          MA08  58
chardata:(MA121,[TEST PHASE])#                                          MA08  59
chardata:(MA122,[ STOP RUN IF COMPANION REFLECTIONS OUTSIDE MAP $#      MA08  60
RESOLUTION     ])#                                                      MA08  61
chardata:(MA10Z,[ THE SORT ORDER OF REFLECTIONS ON THE BDF (XXX) IS $#  MA08  62
NOT CORRECT RELATIVE TO THE SUMMATION ORDER OF THE FOURIER MAP (XXX).])#MA08  63
chardata:(MA09D,[ MAXIMUM H, K, & L MAGNITUDES THAT CAN BE USED $#      MA08  64
AT MAP RESOLUTION IS                ])#                                 MA08  65
realdata:(FMTD,[720513.,770513.,820513.])# Format for max h,k,l         MA08  66
realdata:(FMT1,[70613.,130613.,190613.,290922.,410922.,530942.,$#       MA08  67
650942.])#                             Reflection listing format        MA08  68
realdata:(FMT3,[460313.,1180313.])#    Bad sort report                  MA08  69
realdata:(FMT4,[320613.,780812.])#     Correlation test report          MA08  70
realdata:(FMT5,[370632.,550632.])#     Entropy/correlation weighting    MA08  71
#                                                                       MA08  72
realdata:(RESPHA,[0.,0.,30.,45.,60.,90.,120.,135.,150.])# Centric pha   MA08  73
#                                                                       MA08  74
INTEGER I,J,JJ,K,L#                    Local indices                    MA08  75
INTEGER H1,H2,H3#                      Hkl used to check for maxima     MA08  76
#                                                                       MA08  77
datastuff:#                                                             MA08  78
#                                                                       MA08  79
# SET ALL DEFAULTS FOR MEPHAS RUN TO START                              MA08  80
# ----------------------------------------                              MA08  81
#                                                                       MA08  82
MAXPHA=0#                              Maximum no. new phases in run    MA08  83
MESIGN=yes: ; MECYC=no: ; MEFIT=no: ; MEOSC=no:# Default to mesign ru   MA08  84
EXTEST=no:#                            Do not extend centric search     MA08  85
CRIWGT=1.0#                            Default full weight to entropy   MA08  86
YATENT=yes:#                           Use entropy in yate's algorith   MA08  87
PHAJMP=22.5#                           Phase shift for general refs     MA08  88
TWOPI=2.0*ACOS(-1.0)#                  Get local value of two pi        MA08  89
DETORA=TWOPI/360.0#                    Get degrees to radians           MA08  90
RATODE=1.0/DETORA#                     And back again to degrees        MA08  91
DO J=1,9#                              Set up table of exact centrics   MA08  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA08  93
COSCHK(J)=COS(RESPHA(J)*DETORA)#       Cosine of centric phase angles   MA08  94
SINCHK(J)=SIN(RESPHA(J)*DETORA)#       Sine of centric phase angles     MA08  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA08  96
COSCHK(1)=1.0 ; COSCHK(2)=1.0 ; COSCHK(6)=0.0# Make sure!               MA08  97
SINCHK(1)=0.0 ; SINCHK(2)=0.0 ; SINCHK(6)=1.0# Make really sure!        MA08  98
SIGGVN=0.05#                           Guess 5% error in f obs's        MA08  99
ENPRIO=999.0#                          Entropy of 'prior' map as sign   MA08 100
NREF=0 ; NREFIX=0#                     Count refl'ns to be treated      MA08 101
MITERA=13#                             Max iterations to fit moduli     MA08 102
PRINTL=0#                              Suppress refl print              MA08 103
PRISIG=no: ; CORSIG=no:#               No scratch files ln(rho) maps    MA08 104
NOTMED=no:#                            Prior map created by medens      MA08 105
OLDPHA=yes:#                           Phase in bdf, take it at start   MA08 106
DIRSIG=no:#                            No dir. access file for rfourr   MA08 107
COMREF=yes:#                           Signal need companion refls      MA08 108
DSET=1000#                             Default data set 1               MA08 109
NSCL=1 ; DO J=1,65 ; SCALE(J)=1.0#     Default f rel scales to 1.0      MA08 110
THRESH=0.01#                           Set limit on fc magnitude        MA08 111
RHOTHR=0.00001#                        Set limit on lowest rho input    MA08 112
CHKFMG=no: ; CHKREF=0 ; CHKMAG=0.1#    Set extra refl testing 'off'     MA08 113
FINFIT=no:#                            Not yet time to output map       MA08 114
DFCUT=1.0#                             Set refl delta f screening       MA08 115
FITFAC=1.0#                            Set factor to judge convergenc   MA08 116
#                                                                       MA08 117
K=0#                                   Set to scan *mephas* line        MA08 118
REPEAT#                                Loop over input fields           MA08 119
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA08 120
K=K+1#                                 Advance to the next field        MA08 121
IF(BUFIN(K)>=voidflg:) BREAK#          Go to first non-alpha field      MA08 122
stringlim:(K,I,J)#                     Find characters in input         MA08 123
compchar:(CHRIN,I,MA10B,1,2,4,NMA10B,J)# Search list of options         MA08 124
IF(J==0) iquit:(ma:0801,K)#            It must be valid                 MA08 125
ELSE IF(J==1)#                         Test reflection print control    MA08 126
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA08 127
IF(BUFIN(K+1)>0.0)#                                                     MA08 128
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA08 129
K=K+1 ; PRINTL=NINT(BUFIN(K))#                                          MA08 130
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA08 131
ELSE PRINTL=32#                                                         MA08 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA08 133
ELSE IF(J==2) PRISIG=yes:#             Force file f for ln(rho) prior   MA08 134
ELSE IF(J==3)#                         Set data set number              MA08 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA08 136
IF(BUFIN(K+1)>0.0&BUFIN(K+1)<17.0)#    See if a data set number there   MA08 137
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA08 138
K=K+1 ; DSET=1000*NINT(BUFIN(K))#      Scale for use in pointing        MA08 139
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA08 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA08 141
ELSE IF(J==4)#                         Set estimated error in f obs     MA08 142
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA08 143
IF(BUFIN(K+1)>0.0&BUFIN(K+1)<1.0)#     See if an error there            MA08 144
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA08 145
K=K+1 ; SIGGVN=BUFIN(K)#               Given sigma for faking sig(fo)   MA08 146
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA08 147
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA08 148
ELSE IF(J==5) DIRSIG=yes:#             Force use dir. acc. for rfourr   MA08 149
ELSE IF(J==6) CORSIG=yes:#             Force file g for ln(rho) corr'   MA08 150
ELSE IF(J==7)#                         A & b threshold?                 MA08 151
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MA08 152
IF(BUFIN(K+1)>0.0001&BUFIN(K+1)<0.2)#  Is thresh sensible?              MA08 153
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MA08 154
K=K+1;    THRESH=BUFIN(K)#             Store user threshold             MA08 155
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MA08 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MA08 157
ELSE IF(J==8)#                         Largest reflections for check?   MA08 158
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MA08 159
IF(BUFIN(K+1)>1.0&BUFIN(K+1)<1001.0)#  Is number sensible?              MA08 160
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MA08 161
K=K+1;    CHKREF=MIN0(1000,NINT(BUFIN(K)))# Store number user wants     MA08 162
CHKFMG=yes:#                           Signal correlation wanted        MA08 163
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MA08 164
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MA08 165
ELSE IF(J==9)#                         Check on f obs above value?      MA08 166
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MA08 167
IF(BUFIN(K+1)>0.1)#                    Is cut point sensible?           MA08 168
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MA08 169
K=K+1; CHKMAG=BUFIN(K); CHKFMG=yes:#   Store user cutpoint              MA08 170
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MA08 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MA08 172
ELSE IF(J==10)#                        Check rho threshold value        MA08 173
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MA08 174
IF(BUFIN(K+1)>0.000001)#               Is threshold sensible?           MA08 175
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MA08 176
K=K+1; RHOTHR=BUFIN(K)#                Store user threshold for rho     MA08 177
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MA08 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MA08 179
ELSE IF(J==11)#                        Check iterations to fit moduli   MA08 180
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MA08 181
IF(BUFIN(K+1)>1.0&BUFIN(K+1)<36.0)#    Is number sensible?              MA08 182
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MA08 183
K=K+1; MITERA=NINT(BUFIN(K))#          Store user chosen iterations     MA08 184
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MA08 185
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MA08 186
ELSE IF(J==12) NOTMED=yes:#            Prior map not from medens        MA08 187
ELSE IF(J==13)#                        Check general phase step size    MA08 188
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MA08 189
MESIGN=no: ; MECYC=yes: ; MEFIT=no: ; MEOSC=no:# Set working conditio   MA08 190
IF(BUFIN(K+1)>11.0&BUFIN(K+1)<181.0)#  Is step sensible?                MA08 191
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MA08 192
K=K+1; PHAJMP=BUFIN(K)#                Store user chosen step size      MA08 193
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MA08 194
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MA08 195
ELSE IF(J==14)#                        Fit general refls, no cycling    MA08 196
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MA08 197
MEFIT=yes: ; MESIGN=no: ; MECYC=no: ; MEOSC=no:# Only one option!       MA08 198
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MA08 199
ELSE IF(J==15)#                        Maximum refls for auto select    MA08 200
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MA08 201
IF(BUFIN(K+1)>0.0&BUFIN(K+1)<501.0)#   Is number sensible?              MA08 202
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MA08 203
K=K+1; MAXPHA=BUFIN(K)#                Set max refls to be selected     MA08 204
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MA08 205
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MA08 206
ELSE IF(J==16) OLDPHA=no:#             No old phases from bdf           MA08 207
ELSE IF(J==17)#                        Delta f cut for refl selection   MA08 208
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MA08 209
IF(BUFIN(K+1)>0.0001&BUFIN(K+1)<100.1)# Is threshold sensible?          MA08 210
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MA08 211
K=K+1;    DFCUT=BUFIN(K)#              Store delta f screening value    MA08 212
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MA08 213
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MA08 214
ELSE IF(J==18)#                        Fit general refls, no cycling    MA08 215
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MA08 216
MEFIT=no: ; MESIGN=no: ; MECYC=no: ; MEOSC=yes:# Only one option!       MA08 217
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MA08 218
ELSE IF(J==19)#                        Fit by oscillation cycling       MA08 219
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MA08 220
MEFIT=no: ; MESIGN=yes: ; MECYC=no: ; MEOSC=no:# Prince's classic       MA08 221
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MA08 222
ELSE IF(J==20)#                        Extend centric testing?          MA08 223
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MA08 224
EXTEST=yes:#                           Set to test 256 possibilities    MA08 225
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MA08 226
ELSE IF(J==21)#                        Entropy/correlation weighting    MA08 227
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 MA08 228
IF(BUFIN(K+1)>=0.0&BUFIN(K+1)<=1.0)#   Is number sensible?              MA08 229
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 MA08 230
K=K+1; CRIWGT=BUFIN(K)#                Set weight for entropy           MA08 231
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 MA08 232
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 MA08 233
ELSE IF(J==22)#                        Convergence fit factor           MA08 234
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 MA08 235
IF(BUFIN(K+1)>0.0&BUFIN(K+1)<=1.0)#    Number a sensible fraction?      MA08 236
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 MA08 237
K=K+1; FITFAC=BUFIN(K)#                Set fraction of sig(fo)          MA08 238
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 MA08 239
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 MA08 240
ELSE IF(J==23) COMREF=no:#             Don't stop low map resolution    MA08 241
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA08 242
IF(MESIGN==yes:\MEOSC==yes:) PHAJMP=180.0# Phase shift 180 for these    MA08 243
ELSE IF (MEFIT==yes:) PHAJMP=0.0#      No phase shift for fitting       MA08 244
#                                                                       MA08 245
# SET UP I/O BUFFERS FOR REQUIRED FILES                                 MA08 246
# -------------------------------------                                 MA08 247
#                                                                       MA08 248
IOMARK(1)=QXSTR#                       Set up input bdf buffer          MA08 249
IOMARK(2)=IOMARK(1)+bdfbuf:#           Set up output bdf buffer         MA08 250
IOMARK(4)=IOMARK(2)+bdfbuf:#           Set up 'prior' map buffer        MA08 251
IOMARK(5)=IOMARK(4)+bdfbuf:#           Set up output map buffer         MA08 252
incrqx:(MARKS,IOMARK(5)+bdfbuf:,ma:0805)# Point to stored reflection    MA08 253
STEPR=15#                              Set items per reflection         MA08 254
#                                                                       MA08 255
# THE QUANTITIES STORED IN THE REFLECTION PACKETS ARE AS FOLLOWS:       MA08 256
# QX(J+ 1)   H                                                          MA08 257
# QX(J+ 2)   K                                                          MA08 258
# QX(J+ 3)   L                                                          MA08 259
# QX(J+ 4)   F OBSERVED                                                 MA08 260
# QX(J+ 5)   SIGMA OF F OBSERVED                                        MA08 261
# QX(J+ 6)   COSINE OF PHASE BEING TESTED                               MA08 262
# QX(J+ 7)   SINE OF PHASE BEING TESTED                                 MA08 263
# QX(J+ 8)   WORKING, TEMPORARY, COSINE OF PHASE BEING TESTED           MA08 264
# QX(J+ 9)   WORKING, TEMPORARY, SINE OF PHASE BEING TESTED             MA08 265
# QX(J+10)   MAGNITUDE OF F CALCULATED FROM REVERSE FOURIER TRANSFORM   MA08 266
# QX(J+11)   A CALCULATED FROM REVERSE FOURIER TRANSFORM                MA08 267
# QX(J+12)   B CALCULATED FROM REVERSE FOURIER TRANSFORM                MA08 268
# QX(J+13)   |FC|COS(ALPHA CALC - PHI TESTED)                           MA08 269
# QX(J+14)   |FC|SIN(ALPHA CALC - PHI TESTED)                           MA08 270
# QX(J+15)   PHASE RESTRICTION CODE AS UNPACKED FROM IDNUM 3 OF LRREFL: MA08 271
#            0=NO RESTRICTION, 1=0/180, 2=30/210, 3=45/225, 4=60/240    MA08 272
#            5=90/270, 6=120/300, 7=135/315, 8=150/330                  MA08 273
#            IF THIS SIGNAL WORD HAS 64 ADDED TO IT, IT INDICATES THAT  MA08 274
#            THE REFLECTION IS TO BE HELD CONSTANT DURING ANY CYCLING   MA08 275
#            OF PHASES. THIS ALLOWS FOR THE INCLUSION OF ORIGIN         MA08 276
#            DEFINING AND PREVIOUSLY DETERMINED PHASES IN THE HESSIAN   MA08 277
#            AND HENCE IN THE FITTING PROCESS AT EVERY TRIAL.           MA08 278
#                                                                       MA08 279
# NOTE WELL THAT THE REFLECTION ARRAY CONTAINS A LEADING AND TRAILING   MA08 280
# PACKET WITH F(0,0,0) IN IT.  THESE PACKETS ARE IMPORTANT FOR SCALING  MA08 281
# AND FOR CONTROL IN THE BUILDING OF THE HESSIAN.  THIS FACT DOES,      MA08 282
# HOWEVER, MAKE FOR STRANGE USE IN THE USUAL XTAL PRACTICE WITH         MA08 283
# RESPECT TO MARKR.  POINTERS ARE STARTED AT MARKR-STEPR  WHEN THE      MA08 284
# (0,0,0) REFLECTION MUST BE INCLUDED, BUT AT MARKR WHEN JUST THE NREF  MA08 285
# REFLECTIONS BEING TREATED ARE BEING WORKED ON.  BE CAREFUL!           MA08 286
# THE MARKQ ARRAY HAS IN IT ALL THE REFLECTIONS REQUIRED TO FORM THE    MA08 287
# HESSIAN MATRIX AND THOSE NEEDED TO TEST THE CORRELATION OF, AS YET,   MA08 288
# UNDETERMINED REFLECTION F OBSERVED AND F CALCULATED. THE PACKETS      MA08 289
# IN THE MARKQ ARRAY CONTAIN THE FOLLOWING ITEMS:                       MA08 290
# QX(I+1)   A CALCULATED                                                MA08 291
# QX(I+2)   B CALCULATED                                                MA08 292
# QX(I+3),QX(I+4), & QX(I+5) H, K, & L  PACKETS IN HESSIAN ORDER        MA08 293
# QX(I+6)   SORT POINTER FOR USE BY REVERSE FOURIER SUBROUTINE MA80     MA08 294
# QX(I+7)   SIGNAL WORD FOR SETTING DISPOSITION OF REFLECTION A & B     MA08 295
#           THIS WORD IS NEGATIVE F OBSERVED IF THIS IS A CORRELATION   MA08 296
#           REFLECTION. IT IS POSITIVE IF THE REFLECTION CONTRIBUTES    MA08 297
#           TO THE HESSIAN MATRIX.  SEE LONG COMMENT IN MA11.           MA08 298
#                                                                       MA08 299
#  CONTINUE TO INITIALIZE THE CALCULATION                               MA08 300
# ---------------------------------------                               MA08 301
#                                                                       MA08 302
CALL MA09#                             Call divided initialization      MA08 303
#                                                                       MA08 304
movechar:(MA10D,ICEL(3),MA10G,24,1,0)# Change to correct axis           MA08 305
movechar:(MA10D,ICEL(2),MA10G,32,1,0)# Change to correct axis           MA08 306
movechar:(MA10D,ICEL(1),MA10G,38,1,0)# Change to correct axis           MA08 307
writeline:(1,MA10G,NMA10G,3,3)#                                         MA08 308
#                                                                       MA08 309
# SET UP THE USE OF THE QX ARRAY FOR ALL PARTS OF THE CALCULATION       MA08 310
# ---------------------------------------------------------------       MA08 311
#                                                                       MA08 312
CALL MA10#                             Storage allocator                MA08 313
#                                                                       MA08 314
# WRITE OUT A SUMMARY OF INSTRUCTIONS                                   MA08 315
# -----------------------------------                                   MA08 316
#                                                                       MA08 317
LINRM=12 ; writeline:(1,MA10K,NMA10K,3,3)# Heading                      MA08 318
writeline:(1,MA10L,NMA10L,3,3)#                                         MA08 319
BUFOT(1)=FLOAT(PRINTL) ; ncodefld:(BUFOT,1,MA10N,500513.,1)#            MA08 320
writeline:(1,MA10N,NMA10N,3,3)#                                         MA08 321
ncodefld:(THRESH,1,MA10E,500842.,1)#   Format a & b threshold           MA08 322
writeline:(1,MA10E,NMA10E,3,3)#        Print a b threshold              MA08 323
ncodefld:(DFCUT,1,MA08E,500842.,1)#    Format delta f cut point         MA08 324
writeline:(1,MA08E,NMA08E,3,3)#        Print delta f screen             MA08 325
IF(NOTMED==no:)#                       Prior map from medens?           MA08 326
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 MA08 327
movechar:(MA10J,1,MA105,48,3,0)#                                        MA08 328
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 MA08 329
ELSE movechar:(MA10J,4,MA105,48,3,0)#                                   MA08 330
writeline:(1,MA105,NMA105,3,3)#                                         MA08 331
IF(MECYC==yes:)#                       Testing general refs?            MA08 332
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 MA08 333
MITERA=MAX0(35,MITERA);movechar:(MA10J,1,MA107,48,3,0)# Up iterations   MA08 334
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 MA08 335
ELSE movechar:(MA10J,4,MA107,48,3,0)#                                   MA08 336
writeline:(1,MA107,NMA107,3,3)#                                         MA08 337
IF(MEFIT==yes:)#                       Phasing refls, no cycling?       MA08 338
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 MA08 339
MITERA=MAX0(25,MITERA)#                More iterations to get fit       MA08 340
movechar:(MA10J,1,MA111,48,3,0)#                                        MA08 341
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 MA08 342
ELSE movechar:(MA10J,4,MA111,48,3,0)#                                   MA08 343
writeline:(1,MA111,NMA111,3,3)#                                         MA08 344
IF(MESIGN==yes:)#                      Centric refls by statistics?     MA08 345
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 MA08 346
movechar:(MA10J,1,MA112,48,3,0)#                                        MA08 347
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 MA08 348
ELSE movechar:(MA10J,4,MA112,48,3,0)#                                   MA08 349
writeline:(1,MA112,NMA112,3,3)#                                         MA08 350
IF(MEOSC==yes:)#                       Centric refls, oscillating?      MA08 351
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 MA08 352
movechar:(MA10J,1,MA114,48,3,0)#                                        MA08 353
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 MA08 354
ELSE movechar:(MA10J,4,MA114,48,3,0)#                                   MA08 355
writeline:(1,MA114,NMA114,3,3)#                                         MA08 356
IF(COMREF==yes:)#                      Quitting companion refs out?     MA08 357
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 MA08 358
movechar:(MA10J,1,MA122,59,3,0)#                                        MA08 359
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 MA08 360
ELSE movechar:(MA10J,4,MA122,59,3,0)#                                   MA08 361
writeline:(1,MA122,NMA122,3,3)#                                         MA08 362
IF(CHKFMG==yes:)#                      Run correlation of unphased?     MA08 363
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 MA08 364
BUFOT(1)=FLOAT(CHKREF) ; BUFOT(2)=CHKMAG# Echo number and magnitude f   MA08 365
ncodefld:(BUFOT,1,MA115,FMT4,2) ; writeline:(1,MA115,NMA115,3,3)#       MA08 366
BUFOT(1)=CRIWGT ; BUFOT(2)=1.0-CRIWGT# Echo entropy/correl wgts         MA08 367
ncodefld:(BUFOT,1,MA117,FMT5,2) ; writeline:(1,MA117,NMA117,3,3)#       MA08 368
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 MA08 369
BUFOT(1)=100.0*FITFAC ; ncodefld:(BUFOT,1,MA118,290832.,1)#             MA08 370
writeline:(1,MA118,NMA118,3,3)#        Tell convergence fitting facto   MA08 371
IF(EXTEST==yes:)#                      Run extended centric tests?      MA08 372
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 MA08 373
writeline:(1,MA116,NMA116,3,3)#        Confirm 256 rather than 16       MA08 374
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 MA08 375
IF(OLDPHA==yes:)#                      Take bdf phases, if there?       MA08 376
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 MA08 377
movechar:(MA10J,1,MA113,48,3,0)#                                        MA08 378
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 MA08 379
ELSE movechar:(MA10J,4,MA113,48,3,0)#                                   MA08 380
writeline:(1,MA113,NMA113,3,3)#                                         MA08 381
BUFOT(1)=PHAJMP#                       Set phase shift                  MA08 382
ncodefld:(BUFOT,1,MA108,500413.,1) ; writeline:(1,MA108,NMA108,3,3)#    MA08 383
IF(PRISIG==yes:)#                      User demands file f use          MA08 384
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 MA08 385
movechar:(MA10J,1,MA10O,48,3,0)#                                        MA08 386
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 MA08 387
ELSE movechar:(MA10J,4,MA10O,48,3,0)#                                   MA08 388
writeline:(1,MA10O,NMA10O,3,3)#                                         MA08 389
IF(CORSIG==yes:)#                      User demands file g use          MA08 390
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 MA08 391
movechar:(MA10J,1,MA10Y,48,3,0)#                                        MA08 392
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 MA08 393
ELSE movechar:(MA10J,4,MA10Y,48,3,0)#                                   MA08 394
writeline:(1,MA10Y,NMA10Y,3,3)#                                         MA08 395
IF(DIRSIG==yes:)#                      User demands direct access use   MA08 396
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 MA08 397
movechar:(MA10J,1,MA10S,48,3,0)#                                        MA08 398
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 MA08 399
ELSE movechar:(MA10J,4,MA10S,48,3,0)#                                   MA08 400
writeline:(1,MA10S,NMA10S,3,3)#                                         MA08 401
#                                                                       MA08 402
BUFOT(1)=FLOAT(MAXPHA)#                Set maximum phases treated       MA08 403
ncodefld:(BUFOT,1,MA109,500313.,1) ; writeline:(1,MA109,NMA109,3,3)#    MA08 404
BUFOT(1)=FLOAT(MITERA)#                Set maximum iterations           MA08 405
ncodefld:(BUFOT,1,MA106,500313.,1) ; writeline:(1,MA106,NMA106,3,3)#    MA08 406
BUFOT(1)=0.001*FLOAT(DSET)#            Set data set for printing        MA08 407
ncodefld:(BUFOT,1,MA10X,500313.,1) ; writeline:(1,MA10X,NMA10X,3,3)#    MA08 408
ncodefld:(HLIM,1,MA09D,FMTD,3) ; writeline:(1,MA09D,NMA09D,3,1)#        MA08 409
#                                                                       MA08 410
# REPORT OUT INPUT REFLECTION INFORMATION                               MA08 411
# ---------------------------------------                               MA08 412
#                                                                       MA08 413
writeline:(1,MA10P,NMA10P,3,3) ; LINRM=3# Head reflection listing       MA08 414
FOR(K=MARKR+STEPR;K<STOPR-STEPR;K=K+STEPR)# Search chosen reflections   MA08 415
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 MA08 416
ncodefld:(QX(K+1),1,CHROT,FMT1,7)#     Translate new refs to output     MA08 417
BUFOT(1)=RATODE*ATAN2(QX(K+7),QX(K+6))# Also give as phase in degrees   MA08 418
BUFOT(1)=AMOD(BUFOT(1)+360.0,360.0)#   Make positive angles             MA08 419
ifvo:(QX(K+10)) movechar:(MA08Q,1,CHROT,71,NMA08Q,0)# Void in fc        MA08 420
ELSE ncodefld:(QX(K+10),1,CHROT,741022.,1)# Otherwise show fc value     MA08 421
IF(MEFIT==yes:\QX(K+15)>=64.0) movechar:(MA120,1,CHROT,89,NMA120,0)#    MA08 422
ELSE movechar:(MA121,1,CHROT,89,NMA121,0)# Give phase test status       MA08 423
ncodefld:(BUFOT,1,CHROT,840612.,1) ; writeline:(0,MA10Q,NMA10Q,1,3)#    MA08 424
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 MA08 425
DO J=1,3 ; MAXH(J)=-9999#              Set to find max h, k, & l        MA08 426
L=MARKR ; DO J=1,NREF#                 Find maxhkl                      MA08 427
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 MA08 428
L=L+STEPR#                             Point to hkls in this run        MA08 429
FOR(K=MARKS;K<STOPS;K=K+STEPS)#        Loop over all symops             MA08 430
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 MA08 431
H1=NINT(QX(L+1)*QX(K+1)+QX(L+2)*QX(K+2)+QX(L+3)*QX(K+3))# Transform h   MA08 432
H2=NINT(QX(L+1)*QX(K+4)+QX(L+2)*QX(K+5)+QX(L+3)*QX(K+6))# Transform k   MA08 433
H3=NINT(QX(L+1)*QX(K+7)+QX(L+2)*QX(K+8)+QX(L+3)*QX(K+9))# Transform l   MA08 434
MAXH(1)=MAX0(IABS(H1),MAXH(1))#        Get maximum absolute h, k, l     MA08 435
MAXH(2)=MAX0(IABS(H2),MAXH(2))#                                         MA08 436
MAXH(3)=MAX0(IABS(H3),MAXH(3))#                                         MA08 437
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 MA08 438
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 MA08 439
#                                                                       MA08 440
# CHECK UP ON THE SORT ORDER OF THE REFLECTIONS IN THE BDF IN RELATION  MA08 441
# TO THE SORT ORDER IMPLIED BY THE SUMMATION ORDER OF THE INPUT         MA08 442
# FOURIER MAP.  FOR THIS PROGRAM TO GIVE CORRECT STRUCTURE FACTORS      MA08 443
# THE TWO SORT ORDERS MUST BE THE SAME.                                 MA08 444
# --------------------------------------------------------------------  MA08 445
#                                                                       MA08 446
IF(SORT!=SORTP)#                       Look out for mismatch in sort    MA08 447
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 MA08 448
BUFOT(1)=FLOAT(SORTP) ; BUFOT(2)=FLOAT(SORT)# Show sort orders          MA08 449
ncodefld:(BUFOT,1,MA10Z,FMT3,2) ; writeline:(1,MA10Z,NMA10Z,3,1)#       MA08 450
iquit:(ma:0808)#                                                        MA08 451
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 MA08 452
#                                                                       MA08 453
# SET UP 'COMPANION' REFLECTIONS TO THOSE CHOSEN TO BE PHASED           MA08 454
# -----------------------------------------------------------           MA08 455
#                                                                       MA08 456
CALL MA11#                             Prep for hessian building        MA08 457
#                                                                       MA08 458
# SET THE ORIGINS, INCREMENTS, AND PERMUTED HKLS FOR FOURIER TIME       MA08 459
# ---------------------------------------------------------------       MA08 460
#                                                                       MA08 461
DO J=1,3#                              Loop over layer, down, & acros   MA08 462
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 MA08 463
JJ=ICEL(J)#                            Pick up cell axis correspondin   MA08 464
IXORG(J)=MOD(ORGX(J)+2*NG(J),NG(J))#   Assure+values for indices        MA08 465
IXINC(J)=MOD(INCX(J)+2*NG(J),NG(J))#   Assure that increment will giv   MA08 466
IHMAX(J)=MAXH(JJ)#                     Maximum value of miller index    MA08 467
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 MA08 468
IF(IHMAX(2)>NG(2)) iquit:(ma:0811)#    Resolution 2ond sum direction    MA08 469
IF(IHMAX(3)>NG(3)) iquit:(ma:0812)#    Resolution 3rd sum direction     MA08 470
#                                                                       MA08 471
RETURN#                                                                 MA08 472
END#                                                                    MA08 473
systemheader:(MA09)## bdf input and initialization continued            MA09   1
# ################################################################## #  MA09   2
#                                                                    #  MA09   3
#                               MA09                                 #  MA09   4
#                                                                    #  MA09   5
# ################################################################## #  MA09   6
SUBROUTINE MA09## J.M.Stewart D.M.Collins March 1990                    MA09   7
include:(AACOMN)#                                                       MA09   8
include:(MACOMN)#                                                       MA09   9
#                                                                       MA09  10
realdata:(FMT2,[160413.,210413.,260413.])# Missing reflection format    MA09  11
chardata:(MA10A, END    PHI    SCALE  MAXHKL )# Input lines allowed     MA09  12
chardata:(MA10R,[ REFLECTION     ,    ,     MISSING FROM INPUT BDF.])#  MA09  13
#                                                                       MA09  14
#------  ALLOWED VALUES OF NX IN FOURIER GRIDS                          MA09  15
#        (RANGE FROM 2 TO 5040) ONLY MXGRID IMPLEMENTED                 MA09  16
intdata:(ND,[$#                                                         MA09  17
   2,   3,   4,   5,   6,   7,   8,   9,#                               MA09  18
10,  12,  14,  15,  16,  18,  20,  21,#                                 MA09  19
24,  28,  30,  35,  36,  40,  42,  45,#                                 MA09  20
48,  56,  60,  63,  70,  72,  80,  84,#                                 MA09  21
90, 105, 112, 120, 126, 140, 144, 168,#                                 MA09  22
180, 210, 240, 252, 280, 315, 336, 360,#                                MA09  23
420, 504, 560, 630, 720, 840,1008,1260,#                                MA09  24
1680,2520,5040])#                                                       MA09  25
intdata:(MXGRID,[57])##                                                 MA09  26
realdata:(FMNX,[110413.,170413.,270413.])# Format for grid error        MA09  27
chardata:(MA7A, ONE OR MORE SUMMATION DIRECTIONS ARE NOT IN $#          MA09  28
GRID DIVISIONS HANDLED BY FFT SUBROUTINES.)#                            MA09  29
chardata:(MA7B,[ GIVEN     ,     , AND     .   ACCEPTIBLE.......])#     MA09  30
chardata:(MA7U,[                   F(0,0,0) IN INPUT  =            ])#  MA09  31
chardata:(MA7X,[           LOG(RHO MAXIMUM) IN INPUT  =            ])#  MA09  32
chardata:(MA7V,[           LOG(RHO MINIMUM) IN INPUT  =            ])#  MA09  33
chardata:(MA7W,[   LOG((RHO MAX)/(RHO MIN)) IN INPUT  =            ])#  MA09  34
chardata:(MA09B,[ ***WARNING F CALC =          FOBS =          $#       MA09  35
FC*(FO-FC) =          ])#                                               MA09  36
chardata:(MA09A,[ ***WARNING THE F CALC OF THE                   $#     MA09  37
IS LARGE!])#                                                            MA09  38
chardata:(MA09E,[ MAP RESOLUTION WILL NOT ALLOW INDEX OF       ])#      MA09  39
chardata:(MA09F,[ SIGMA(F OBS) TAKEN AS XXX.XXX% OF F OBS ITSELF])#     MA09  40
realdata:(FMTW,[350413.,410413.,470413.])# Format for bad refls         MA09  41
realdata:(FMTV,[290831.,450831.,670831.])# Format for bad refls         MA09  42
#                                                                       MA09  43
REAL FMT#                              Format for printing e. d.        MA09  44
REAL FOBS,DFMIN,FOSIG,FCALC,DELF,COSPH,SINPH,FTEST# Auto refl select    MA09  45
INTEGER I,J,K,L#                       Local indices                    MA09  46
INTEGER IFOUND,NFOUND,ISCGRP#          Used to establish f rel scales   MA09  47
INTEGER MININ#                         Pointer to minimum f observed    MA09  48
REAL HKL(3)#                           Hold h, k, & l for checking      MA09  49
INTEGER PHARES#                        Refl. phase restriction code     MA09  50
INTEGER PSIZ,IP,IIP#                   Bdf reading parameters           MA09  51
REAL RHO,LNRHO#                        For map scan                     MA09  52
REAL TEMP#                             To hold reals temporarily        MA09  53
INTEGER X1,X2,X3#                      Loop indices                     MA09  54
INTEGER ZIPPO#                         Signal reflection to be skippe   MA09  55
#                                                                       MA09  56
datastuff:#                                                             MA09  57
#                                                                       MA09  58
# READ THE BDF ON FILE A AND PUT AWAY CELL INFORMATION.                 MA09  59
# -----------------------------------------------------                 MA09  60
#                                                                       MA09  61
K=0#                                   Prepare to get needed cell i     MA09  62
REPEAT#                                Loop over lrcell packets         MA09  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA09  64
K=K+1#                                 Count packets as they come i     MA09  65
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Read in cell record              MA09  66
IF(IP<=0) BREAK#                       Exit after last record           MA09  67
IF(K==6)VOL=QX(IP+1)#                  Save real cell volume            MA09  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA09  69
#                                                                       MA09  70
#   EXTRACT SYMMETRY INFORMATION (LRSYMM)                               MA09  71
#   ------------------------------------                                MA09  72
#                                                                       MA09  73
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Read first packet of symop r     MA09  74
LTYP=NINT(QX(IP+1))#                   Get out lattice type             MA09  75
ICNT=NINT(QX(IP+2))#                   Get out centro flag (nc=1)       MA09  76
NSYM=NINT(QX(IP+3))#                   Get out total symop count        MA09  77
NROT=NINT(QX(IP+4))#                   Extract number of matrices       MA09  78
NRSZ=NINT(QX(IP+5))#                   Extract no. same pattern zer     MA09  79
LTYP=LTYP-(1-ICNT)*7#                  Reduce ltyp to modulo 7          MA09  80
incrqx:(STOPS,MARKS+NROT*12,ma:0906)#  Incr qx                          MA09  81
FOR(J=MARKS;J<STOPS;J=J+PSIZ)#         Loop over symop packets          MA09  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA09  83
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Point to next packet             MA09  84
IF(IP<=0) BREAK#                       Exit after last packet           MA09  85
movereal:(QX,IP+1,QX,J+1,PSIZ,1)#      Store 12-element symops          MA09  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA09  87
STEPS=PSIZ#                            Store step of symmetry operato   MA09  88
#                                                                       MA09  89
# STORAGE FOR 'COMPANION' REFLECTIONS REQUIRED FOR BUILDING OF HESSIAN  MA09  90
# MATRIX.  SEE SUBROUTINE MA36. 6 ITEMS PER PACKET CONSISTING OF:       MA09  91
# A & B CALC OF GENERATED REFLECTION, H, K, L, OF GENERATED REFLECTION, MA09  92
# AND TWO SORT POINTERS FOR USE IN MA36. ONE TO POINT TO H(I)+H(J) THE  MA09  93
# OTHER TO H(I)-H(J) REFLECTIONS.                                       MA09  94
# --------------------------------------------------------------------  MA09  95
#                                                                       MA09  96
STEPQ=7#                               Set step for 'companion' refls   MA09  97
ISET=DSET/1000#                        Get data set number              MA09  98
#                                                                       MA09  99
#                                                                       MA09 100
#   ENTER SCALE, SORT ORDER, & HKL SIGN PATTERN INFORMATION (LREXPL:)   MA09 101
#  ------------------------------                                       MA09 102
#                                                                       MA09 103
IWANT(1)=1;IWANT(2)=12;IWANT(4)=100#   Data set, sort & nscl idnums     MA09 104
IWANT(3)=36#                           Signals about + indices in bdf   MA09 105
KEY(1)=1;  KEY(2)=4;  KEY(3)=0#        Set search delimiters            MA09 106
KEY(4)=0#                              Set update mode                  MA09 107
indexpkt:(1,lrexpl:,PSIZ,IP,0,KEY,IWANT,IREL)# Get packet pointers      MA09 108
IF(KEY(4)<=0) iquit:(ma:0904)#         Must have data set number        MA09 109
IF(IREL(2)<=0) iquit:(ma:0905)#        Is reflection sort there?        MA09 110
NSCL=1;   SCALE(1)=0.#                 Default group & rel pointer      MA09 111
FOR(I=IP+1;I<=IP+PSIZ;I=I+1)#          Loop over directory              MA09 112
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA09 113
IF((QX(I)<100.9)\(QX(I)>164.1)) NEXT#  Skip if not scale idnm           MA09 114
J=NINT(QX(I))-100#                     Get group number of scale        MA09 115
SCALE(J)=FLOAT(I-IP)#                  Store relative position          MA09 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA09 117
REPEAT#                                Loop over data sets              MA09 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA09 119
readwpkt:(1,lrexpl:,PSIZ,IP,0)#        Get packet pointer               MA09 120
IF(IP<=0) BREAK#                       Exit after last packet           MA09 121
IF(IREL(2)>0)#                         Get sort order if there          MA09 122
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA09 123
I=IP+IREL(2);I=NINT(QX(I))#            Save sort order                  MA09 124
SORFAS=MOD(I,10) ; SORMED=MOD(I/10,10)# Unpack sort codes               MA09 125
SORSLO=I/100 ; SORT=I#                 For use in ma12 & checking       MA09 126
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA09 127
IF(IREL(3)>0)#                         Get index sign pattern if ther   MA09 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA09 129
I=IP+IREL(3); J=NINT(QX(I))#           Pick up pattern                  MA09 130
IF(MOD(J,10)>0)       NEGIND(3)=no:#   No negative l indices            MA09 131
IF(MOD(J,100)/10>0)   NEGIND(2)=no:#   No negative k indices            MA09 132
IF(MOD(J,1000)/100>0) NEGIND(1)=no:#   No negative h indices            MA09 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA09 134
I=IP+IREL(1)#                          Get index of data set no.        MA09 135
IF(ISET!=NINT(QX(I))) NEXT#            Skip unwanted idnum              MA09 136
I=IP+IREL(4); IF(I>IP) NSCL=MIN0(NINT(QX(I)),64)# Number of scales      MA09 137
DO I=1,NSCL#                           Loop over scale factors          MA09 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA09 139
J=IP+NINT(SCALE(I))#                   Point to scale location          MA09 140
IF(J>IP) SCALE(I)=QX(J)#               Store scale in table             MA09 141
ELSE     SCALE(I)=1.#                  Default scale is 1.              MA09 142
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA09 143
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA09 144
MARKR=STOPS ; STOPR=MARKR+STEPR#       Set pointer to end of 0,0,0 re   MA09 145
#                                                                       MA09 146
# RETRIEVE THE MAP PARAMETERS FROM LR 21 OF FILE D                      MA09 147
# AND COPY THE FILE FOR OUTPUT OF UPDATED CONSTRAINED EXPONENTIAL MAP   MA09 148
# -------------------------------------------------------------------   MA09 149
#                                                                       MA09 150
copyfile:(4,5,1,20)#                   Prologue records                 MA09 151
readwpkt:(4,21,PSIZ,IP,0)#             Read map parameter record        MA09 152
## This file will sit idle until the last pass through the forward      MA09 153
## fourier.  In case file is from fourr instead of medens note PSIZ=28  MA09 154
## The last of the record will be updated once the final constrained    MA09 155
## exponential electron density is known.                               MA09 156
writepkt:(5,21,PSIZ,FINPNT)#           Save pointer for use in ma50     MA09 157
movereal:(QX,IP+1,QX,FINPNT+1,PSIZ,0)# Copy everything over; save it    MA09 158
DO K=1,3#                                                               MA09 159
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA09 160
IIP=IP+K#                                                               MA09 161
ORGX(K)=NINT(QX(IIP))#                 Pick up origins                  MA09 162
INCX(K)=NINT(QX(IIP+3))#               Increments along axes            MA09 163
NG(K)=NINT(QX(IIP+6))#                 No. of grid points               MA09 164
NP(K)=NINT(QX(IIP+9))#                 Calculated points                MA09 165
NPHOLD(K)=NINT(QX(IIP+9))#             Calc'ed points for restoration   MA09 166
IMAP(K)=NINT(QX(IIP+12))#              Correlations between crystal     MA09 167
ICEL(K)=NINT(QX(IIP+15))#              Axes and calculation axes        MA09 168
IF(ORGX(K)!=0\NP(K)!=NG(K)) iquit:(ma:0948)# Must be mod1 unit cell     MA09 169
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA09 170
#                                                                       MA09 171
#----TO DESCRIBE PERMUTATIONS BETWEEN XTAL AXES AND COMPUTATIONAL AXES, MA09 172
#     TWO PERMUTATION VECTORS ARE DEFINED.       THE IMAP'S AND ICEL'S  MA09 173
#                                                                       MA09 174
#----THE IMAP'S GIVE COMPUTATIONAL VARIABLES CORRESPONDING TO THE XTAL  MA09 175
#     VARIABLES.  THE ICEL'S GIVE XTAL VARIABLES CORRESPONDING TO THE   MA09 176
#     COMPUTATIONAL VARIABLES.                                          MA09 177
#                                                                       MA09 178
#----THUS, FOR ALL POSSIBLE PERMUTATIONS                                MA09 179
#        LAYER  DOWN  ACROSS  IMAP1  IMAP2  IMAP3  ICEL1  ICEL2  ICEL3  MA09 180
#          X      Y     Z       1      2      3      1      2      3    MA09 181
#          X      Z     Y       1      3      2      1      3      2    MA09 182
#          Y      X     Z       2      1      3      2      1      3    MA09 183
#          Z      Y     X       3      2      1      3      2      1    MA09 184
#          Z      X     Y       2      3      1      3      1      2    MA09 185
#          Y      Z     X       3      1      2      2      3      1    MA09 186
#                                                                       MA09 187
ISUM1=IMAP(1) ; ISUM2=IMAP(2) ; ISUM3=IMAP(3)# Build subscripts         MA09 188
RSUM1=ICEL(1) ; RSUM2=ICEL(2) ; RSUM3=ICEL(3)# Build subscripts         MA09 189
SORTP=ICEL(1)+10*ICEL(2)+100*ICEL(3)#  Get implied refl'n sort order    MA09 190
NX1=NG(1);NX2=NG(2);NX3=NG(3)#         Get points in 3 directions       MA09 191
#                                                                       MA09 192
# SET THE UPPER LIMITS ON H, K, & L DICTATED BY THE MAP RESOLUTION      MA09 193
# ----------------------------------------------------------------      MA09 194
#                                                                       MA09 195
HLIM(RSUM1)=FLOAT(NX1/4 -1) ; HLIM(RSUM2)=FLOAT(NX2/4 -1)#              MA09 196
HLIM(RSUM3)=FLOAT(NX3/4 -1)#           Permuted back to cell order      MA09 197
#                                                                       MA09 198
# MAKE SURE GRID SIZES ARE POSSIBLE TO DO                               MA09 199
# ---------------------------------------                               MA09 200
#                                                                       MA09 201
TOTPIX=FLOAT(NX1*NX2*NX3)#             Get total pixels in map          MA09 202
NYQF1=(NX1-1)/2; NYQF2=(NX2-1)/2; NYQF3=(NX3-1)/2# Set nyquist freq     MA09 203
NDIV1=0;NDIV2=0;NDIV3=0#               Set grid size pointers           MA09 204
NPIX=NX1*NX2*NX3#                      Get total pixels in map          MA09 205
DO J=1,MXGRID#                         Loop over possible grids         MA09 206
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MA09 207
IF(NX1==ND(J)) NDIV1=J#                Set layer divisions              MA09 208
IF(NX2==ND(J)) NDIV2=J#                Set down layer divisions         MA09 209
IF(NX3==ND(J)) NDIV3=J#                Set across layer divisions       MA09 210
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MA09 211
IF((NDIV1==0)\(NDIV2==0)\(NDIV3==0))#  Test that all o.k.               MA09 212
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MA09 213
BUFOT(1)=FLOAT(NX1);BUFOT(2)=FLOAT(NX2);BUFOT(3)=FLOAT(NX3)#            MA09 214
writeline:(1,MA7A,NMA7A,3,1)#                                           MA09 215
ncodefld:(BUFOT,1,MA7B,FMNX,3)#                                         MA09 216
writeline:(0,MA7B,NMA7B,3,1)#                                           MA09 217
K=0; FOR(J=1;J<=4;J=J+1)#              Dump all possible grids          MA09 218
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MA09 219
IF(J<4) N=15#                          15 items per line for three li   MA09 220
ELSE N=14#                             14 on the last                   MA09 221
FMT=413.#                              Start building the format        MA09 222
DO L=1,N#                                                               MA09 223
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MA09 224
K=K+1 ; FMT=FMT+50000. ; BUFOT(1)=FLOAT(ND(K))#                         MA09 225
ncodefld:(BUFOT,1,CHROT,FMT,1)#                                         MA09 226
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MA09 227
writeline:(0,0,0,1,1)#                                                  MA09 228
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MA09 229
iquit:(ma:0907)#                       Impossible grid for fft          MA09 230
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MA09 231
F000=QX(IP+22)#                        Original f(0,0,0) in map         MA09 232
# THE INPUT FILE FROM MEDENS CONTAINS THE 'PRIOR' ELECTRON DENSITY,     MA09 233
# RHO, WHERE RHO=RESCAL*EXP(LNRHO).                                     MA09 234
#  LNRHO = SHARPF*(Z*LNRHMX + (1 - Z)*LNRHMN                            MA09 235
# Z IS THE 'PRIOR' DENSITY MAPPED ON [0,1]. QUANTITIES SHARPF,RESCAL,   MA09 236
# LNRHMN, AND LNRHMX ARE PASSED IN THE FILE FOR USE BY OTHER PROGRAMS.  MA09 237
# IN THIS FITTING PROGRAM THE 'PRIOR' MAP IS RECONSTITUTED AND STORED   MA09 238
# AS LNRHO FOR USE DURING THE FITTING PROCEEDURE. BUT IT WILL HAVE BEEN MA09 239
# RESCALED TO ELECTRONS PER PIXEL FROM ELECTRONS PER CUBIC ANGSTROM.    MA09 240
#                                                                       MA09 241
LNRHMX=QX(IP+26)#                      Log(rho max) from medens         MA09 242
LNRHMN=QX(IP+27)#                      Log(rho min) from medens         MA09 243
SHARPF=QX(IP+28)#                      Sharpening factor from me        MA09 244
RESCAL=QX(IP+29)#                      Rescaling factor from me         MA09 245
#                                      Reduces sharpness. 0.5=sqrt      MA09 246
IF(SHARPF<=0.0) SHARPF=1.0#            Protect div overflow in ma20     MA09 247
IF(RESCAL<=0.0) RESCAL=1.0#            Protect div overflow in ma20     MA09 248
#                                                                       MA09 249
IF(NOTMED==yes:)#                      See if other than medens map     MA09 250
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MA09 251
LNRHMX=-9999.0 ; LNRHMN=9999.0#        Gather extremes                  MA09 252
#                                                                       MA09 253
DO X1=1,NX1#                           Loop over layers                 MA09 254
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MA09 255
DO X2=1,NX2#                           Loop over pages                  MA09 256
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MA09 257
readwpkt:(4,22,PSIZ,IP,0)#             Read next line                   MA09 258
IF(IP<=0) BREAK#                       Quit if all layers done          MA09 259
I=IP#                                  Set pointer for prior el-densi   MA09 260
DO X3=1,NX3#                           Loop across line                 MA09 261
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MA09 262
I=I+1 ; RHO=QX(I)#                     Bump pointers and pick up rho    MA09 263
IF(RHO<=0.0)#                          Can't allow zero or negatives    MA09 264
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MA09 265
RHO=RHOTHR#                            Stuff arbitrary small amount     MA09 266
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MA09 267
LNRHO=ALOG(RHO)#                       Convert 'prior' to ln(rho)       MA09 268
LNRHMN=AMIN1(LNRHMN,LNRHO);LNRHMX=AMAX1(LNRHMX,LNRHO)# Get min/max      MA09 269
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MA09 270
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MA09 271
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MA09 272
readwpkt:(4,endrecord:,PSIZ,IP,0)#     Finish off medens file           MA09 273
#                                                                       MA09 274
CNTRST=LNRHMX-LNRHMN#                  Set contrast of 'prior' map      MA09 275
ncodefld:(F000,1,MA7U,501042.,1) ; writeline:(1,MA7U,NMA7U,3,3)#        MA09 276
ncodefld:(LNRHMX,1,MA7X,501042.,1) ; writeline:(1,MA7X,NMA7X,3,3)#      MA09 277
ncodefld:(LNRHMN,1,MA7V,501042.,1) ; writeline:(1,MA7V,NMA7V,3,3)#      MA09 278
ncodefld:(CNTRST,1,MA7W,501042.,1) ; writeline:(1,MA7W,NMA7W,3,3)#      MA09 279
SHARPF=1.0 ; RESCAL=1.0#               No sharpening of map             MA09 280
#                                                                       MA09 281
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MA09 282
#                                                                       MA09 283
# TAKE IN ANY OTHER INPUT LINES                                         MA09 284
# -----------------------------                                         MA09 285
#                                                                       MA09 286
REPEAT#                                Loop over lines                  MA09 287
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MA09 288
readline:(MA10A,NMA10A)#                                                MA09 289
IF(LINID==1) BREAK#                    Stop reading when end line       MA09 290
ELSE IF(LINID==3)#                     Scale factor line                MA09 291
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MA09 292
K=1#                                   Assume first group               MA09 293
IF(BUFIN(1)>0.0)#                      Test positive number for scale   MA09 294
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MA09 295
IF(BUFIN(2)>0.0&BUFIN(2)<65.0) K=NINT(BUFIN(2))# Take pointer           MA09 296
SCALE(K)=BUFIN(1)#                     Overwrite bdf values             MA09 297
NSCL=MAX0(NSCL,K)#                     Keep biggest pointer             MA09 298
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MA09 299
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MA09 300
ELSE IF(LINID==4)#                     Check for 'maxhkl'               MA09 301
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MA09 302
DO K=1,3#                              New max h,k,l to allow           MA09 303
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MA09 304
IF(BUFIN(K)>HLIM(K))#                  Make sure map resolution enoug   MA09 305
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MA09 306
ncodefld:(BUFIN,K,MA09E,450513.,1) ; writeline:(0,MA09E,NMA09E,3,2)#    MA09 307
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MA09 308
ELSE IF(BUFIN(K)>0.0) HLIM(K)=BUFIN(K)# Maximum index is not silly      MA09 309
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MA09 310
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MA09 311
ELSE IF(LINID==2)#                     Check for starting phases        MA09 312
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MA09 313
#                                                                       MA09 314
# READ IN 'PHI' LINES TO ESTABLISH REFLECTIONS TO BE PHASED IN RUN      MA09 315
# MUST BE NO DUPLICATES SINCE THAT WILL MAKE HESSIAN SINGULAR           MA09 316
# ----------------------------------------------------------------      MA09 317
#                                                                       MA09 318
FOR(K=MARKR+STEPR;K<STOPR;K=K+STEPR)#  Loop over those already loaded   MA09 319
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MA09 320
IF(QX(K+1)!=BUFIN(1)\QX(K+2)!=BUFIN(2)\QX(K+3)!=BUFIN(3)) NEXT# Diffe   MA09 321
iquit:(ma:0921)#                       Die if a duplicate hit           MA09 322
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MA09 323
K=STOPR ; incrqx:(STOPR,STOPR+STEPR,ma:0802)# Get more storage          MA09 324
QX(K+1)=BUFIN(1)#                      Get h                            MA09 325
QX(K+2)=BUFIN(2)#                      Get k                            MA09 326
QX(K+3)=BUFIN(3)#                      Get l                            MA09 327
QX(K+6)=-9999.0#                       Signal reflection input          MA09 328
IF(BUFIN(4)>-361.0&BUFIN(4)<361.0)#    Does it look like an angle?      MA09 329
QX(K+7)=AMOD(BUFIN(4)+720.0,360.0)#    Phase in degrees in temp. form   MA09 330
ELSE QX(K+7)=voidflg:#                 Phase from bdf or by default     MA09 331
#                                                                       MA09 332
# SET A SIGNAL IF REFLECTION IS TO BE FITTED ONLY.  THAT IS, PHASE IS   MA09 333
# TO REMAIN CONSTANT AND NOT BE TESTED AT VARIOUS VALUES.  THIS IS TO   MA09 334
# ALLOW THE INCLUSION OF ORIGIN AND PREVIOUSLY DETERMINED PHASES IN     MA09 335
# THE TESTING PROCESS AT EVERY STAGE.                                   MA09 336
# --------------------------------------------------------------------  MA09 337
#                                                                       MA09 338
ifnv:(BUFIN(5))#                                                        MA09 339
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MA09 340
NREFIX=NREFIX+1 ;  QX(K+15)=64.0#      Mark as fixed phase & count      MA09 341
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MA09 342
ELSE QX(K+15)=0.0#                     Keep as variable phase           MA09 343
NREF=NREF+1#                           Keep count of all                MA09 344
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MA09 345
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MA09 346
#                                                                       MA09 347
# SET UP THE MAXIMUM REFLECTIONS TO BE PHASED.  MESIGN PROCESS MUST     MA09 348
# BE SIXTEEN.  MECYC & MEFIT ARE EITHER DETERMINED BY THE NUMBER OF     MA09 349
# PHI LINES OR THE USER SPECIFIED NUMBER IN THE CALLING LINE            MA09 350
# -----------------------------------------------------------------     MA09 351
#                                                                       MA09 352
IF(MESIGN==yes:) MAXPHA=16#            Mesign case                      MA09 353
ELSE IF(MAXPHA==0) MAXPHA=NREF#        Take number of phi input lines   MA09 354
#                                                                       MA09 355
# OBTAIN INFORMATION ON DESIGNATED REFLECTIONS FROM INPUT BDF           MA09 356
# READ IN THE REFLECTIONS SPECIFIED IN PHI LINES FROM BDF ON FILEA      MA09 357
# OR THOSE THAT HAVE THE NEXT LARGEST F OBS WITH STILL UNDETERMINED     MA09 358
# PHASES.                                                               MA09 359
# ----------------------------------------------------------------      MA09 360
#                                                                       MA09 361
IWANT(1)=1 ; IWANT(2)=3#               Get h, k, l & phse restriction   MA09 362
IWANT(3)=DSET+304 ; IWANT(10)=DSET+911# F relative & mephas signal      MA09 363
IWANT(4)=DSET+305 ; IWANT(5)=DSET+700# Sigma f & phase in cycles        MA09 364
IWANT(6)=DSET+801 ; IWANT(7)=DSET+802# A and b part of f calc           MA09 365
IWANT(8)=DSET+309 ; IWANT(9)=DSET+800# Scale group & |f calc|           MA09 366
KEY(1)=4 ; KEY(2)=10 ; KEY(3)=10 ; KEY(4)=0# Signal indexpkt:           MA09 367
indexpkt:(1,lrrefl:,PSIZ,IP,0,KEY,IWANT,IREL)# Get what's there         MA09 368
IF(IREL(4)<=0)#                        Make sure sigma(f obs) on file   MA09 369
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MA09 370
BUFOT(1)=100.0*SIGGVN ; ncodefld:(BUFOT,1,MA09F,300832.,1)# If not-     MA09 371
writeline:(1,MA09F,NMA09F,3,3)## Explain how its faked for convergenc   MA09 372
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MA09 373
#                                                                       MA09 374
## In order to calculate correlation coefficients for a subset of       MA09 375
## reflections a signal, item n911, is stored in the bdf.  If it        MA09 376
## is not void, then MEPHAS has been the one to assign the reflection   MA09 377
## phase.  If this item is void, then RFOURR or some other program      MA09 378
## has assigned the phase and this program may use the reflection for   MA09 379
## inclusion in the correlation sub-set of reflections.                 MA09 380
#                                                                       MA09 381
PHASED=yes: ; IF(IREL(10)<=0) PHASED=no:# Note if mephas signal there   MA09 382
#                                                                       MA09 383
NFOUND=0 ; ISCGRP=1 ; REPEAT#          Search through refls             MA09 384
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MA09 385
readwpkt:(1,lrrefl:,PSIZ,IP,0)#        Read input bdf                   MA09 386
IF(IP<=0) BREAK#                       Quitting at end of refletions    MA09 387
gethkl:(IP+IREL(1),HKL)#               Pick up h, k, & l                MA09 388
intunpak:(QX(IP+IREL(2)),PHARES,12,4)# Get refl. phase restriction      MA09 389
IF((MESIGN==yes:\MEOSC==yes:)&PHARES==0) NEXT## Centrics only?          MA09 390
ifvo:(QX(IP+IREL(3))) NEXT#            Skip void f rel reflections!     MA09 391
IF(NREF==0)#                           If no phi lines skip high orde   MA09 392
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 MA09 393
ZIPPO=no: ; DO K=1,3 ; IF(ABS(HKL(K))>HLIM(K)) ZIPPO=yes:# Test each    MA09 394
IF(ZIPPO==yes:) NEXT#                  Leave out high order refls       MA09 395
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 MA09 396
IF(IREL(8)>0) ISCGRP=NINT(QX(IREL(8)+IP))# See if scale group given     MA09 397
FOBS=SCALE(ISCGRP)*QX(IP+IREL(3))#     Pick up f observed               MA09 398
FOSIG=FOBS*SIGGVN#                     Give dummy sigma f obs           MA09 399
IF(IREL(4)>0)#                         If there are sigma fs on file    MA09 400
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 MA09 401
ifnv:(QX(IP+IREL(4))) FOSIG=SCALE(ISCGRP)*QX(IP+IREL(4))# Use them      MA09 402
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 MA09 403
#                                                                       MA09 404
# IN THE CYCLING MODES REFLECTIONS ARE CHOSEN BY THE MAGNITUDE OF       MA09 405
# DELTA F; IN THE FITTING MODE BY FC WEIGHTED DELTA F.  WARNINGS ARE    MA09 406
# PRINTED FOR USER CHOSEN REFLECTIONS WHERE DELF IS LESS THAN DFCUT.    MA09 407
# IN AUTOMATIC MODE SUCH REFLECTIONS ARE SIMPLY NOT USED.               MA09 408
# ------------------------------------------------------------------    MA09 409
#                                                                       MA09 410
FCALC=voidflg:#                        Assume no fcalcs in file         MA09 411
IF(IREL(9)>0) FCALC=QX(IREL(9)+IP)#    Pick up f calculated if there    MA09 412
ifvo:(FCALC) FTEST=0.0 ; ELSE FTEST=FCALC# Set temporary f calc         MA09 413
IF(MEFIT==no:) DELF=ABS(FOBS-FTEST)#   Usual delta f                    MA09 414
ELSE DELF=FTEST*(FOBS-FTEST)#          Screening delta f for mefit      MA09 415
#                                                                       MA09 416
#                                                                       MA09 417
# DEFAULT THE PHASE BASED ON PHASE RESTRICTION CODE FROM BDF            MA09 418
# ----------------------------------------------------------            MA09 419
#                                                                       MA09 420
COSPH=COSCHK(PHARES+1) ; SINPH=SINCHK(PHARES+1)# Default to table       MA09 421
IF(OLDPHA==yes:)#                      Are we using old phases?         MA09 422
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 MA09 423
IF(NREF==0)#                           When refls not specified         MA09 424
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 MA09 425
## Screen against reflections previously phased.                        MA09 426
## Various programs can set phases.  The signals are held in IDN n911   MA09 427
## lrrefl: as 1., 2., 3., 4., ... for MESTAR, MEPHAS, MIR, RFOURR, ...  MA09 428
# --------------------------------------------------------------------  MA09 429
#                                                                       MA09 430
IF(IREL(10)>0)#                        Det'ned phases signal in bdf?    MA09 431
IF(QX(IP+IREL(10))>0.0) NEXT#          Skip previously mephased refls   MA09 432
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 MA09 433
IF(IREL(5)>0)#                         Phases in the file?              MA09 434
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 MA09 435
IF(QX(IP+IREL(5))>=0.0&QX(IP+IREL(5))<=1.0)# Must be phase in cycles    MA09 436
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 MA09 437
COSPH=COS(TWOPI*QX(IP+IREL(5)))#       Get real part of phase, cos      MA09 438
SINPH=SIN(TWOPI*QX(IP+IREL(5)))#       Imaginary part of phase, sin     MA09 439
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 MA09 440
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 MA09 441
ELSE IF(IREL(6)>0&IREL(7)>0)#          A & b in bdf?                    MA09 442
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 MA09 443
ifnv:(QX(IP+IREL(6)))#                 Phase already determined?        MA09 444
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 MA09 445
TEMP=SQRT(QX(IP+IREL(6))**2 + QX(IP+IREL(7))**2)# Root(a**2 + b**2)     MA09 446
COSPH=QX(IP+IREL(6))/AMAX1(TEMP,.1)#   Set cos(phi)                     MA09 447
SINPH=QX(IP+IREL(7))/AMAX1(TEMP,.1)#   And sin(phi)                     MA09 448
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 MA09 449
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 MA09 450
CALL MA02(COSPH,SINPH)#                Clean starting values            MA09 451
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 MA09 452
IF(NREF>0)#                            User supplied phi lines          MA09 453
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 MA09 454
#                                                                       MA09 455
# LOOK FOR REFLECTION IN BDF TO ESTABLISH FOBS SIGMA F AND              MA09 456
# ANY PREEXISTING PHASE INFORMATION. USE BDF SORT ORDER TO FORCE        MA09 457
# ORDER OF REFLECTIONS.  THIS IS DONE TO PROTECT THE FFT CALCULATION    MA09 458
# OF STRUCTURE FACTORS LATER ON.                                        MA09 459
# ------------------------------------------------------------------    MA09 460
#                                                                       MA09 461
FOR(K=MARKR+STEPR;K<STOPR;K=K+STEPR)#  Search loaded reflections        MA09 462
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 MA09 463
IF(QX(K+1)!=HKL(1)\QX(K+2)!=HKL(2)\QX(K+3)!=HKL(3)) NEXT# No match?     MA09 464
L=(NFOUND+1)*STEPR+MARKR#              Point to next refl in bdf orde   MA09 465
DO LL=1,STEPR#                         Swap the found reflection        MA09 466
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 MA09 467
TEMP=QX(L+LL) ; QX(L+LL)=QX(K+LL) ; QX(K+LL)=TEMP# Save everything      MA09 468
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 MA09 469
NFOUND=NFOUND+1 ; TEMP=QX(L+7)#        Protect users phase value        MA09 470
QX(L+4)=FOBS#                          Pick up f observed               MA09 471
QX(L+5)=FOSIG#                         Pick up sigma f obs              MA09 472
QX(L+10)=FCALC#                        Pick up f calculated             MA09 473
QX(L+15)=QX(L+15)+FLOAT(PHARES)#       Hold the phase restriction cod   MA09 474
IF(TEMP>=0.0&TEMP<360.)#               Take users phase if there        MA09 475
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 MA09 476
QX(L+6)=COS(DETORA*TEMP) ; QX(L+7)=SIN(DETORA*TEMP)# Set cos & sin      MA09 477
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 MA09 478
ELSE#                                  Take automatic phase             MA09 479
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 MA09 480
QX(L+6)=COSPH ; QX(L+7)=SINPH#         Cosine and sine terms            MA09 481
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 MA09 482
IF((MESIGN==yes:\MECYC==yes:)&QX(L+15)<64.0)# If det'n phase ab initi   MA09 483
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 MA09 484
IF(DELF<DFCUT)#                        And fcalc already known?         MA09 485
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 MA09 486
ncodefld:(HKL,1,MA09A,FMTW,3) ; writeline:(0,MA09A,NMA09A,3,2)#         MA09 487
BUFOT(1)=FTEST ; BUFOT(2)=FOBS ; BUFOT(3)=DELF# Warn user fc known!     MA09 488
ncodefld:(BUFOT,1,MA09B,FMTV,3) ; writeline:(0,MA09B,NMA09B,3,2)#       MA09 489
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 MA09 490
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 MA09 491
BREAK#                                 Found one, on to next bdf refl   MA09 492
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 MA09 493
IF(NFOUND>=NREF) BREAK#                Cease loop when all found        MA09 494
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 MA09 495
ELSE#                                  Use largest f, unphased refls    MA09 496
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 MA09 497
#                                                                       MA09 498
# IN AUTOMATIC MODE DO NOT LOAD THOSE REFLECTIONS WITH FC NEAR FO       MA09 499
# ---------------------------------------------------------------       MA09 500
#                                                                       MA09 501
IF(DELF<DFCUT) NEXT#                   Simply pass them by              MA09 502
#                                                                       MA09 503
# NOW FILL AND THEN UPDATE THE STACK AS BIGGEST DELF COME BY            MA09 504
# ----------------------------------------------------------            MA09 505
#                                                                       MA09 506
IF(NFOUND<MAXPHA)#                     Stack full?                      MA09 507
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 MA09 508
NFOUND=NFOUND+1 ; L=NFOUND*STEPR+MARKR# No, so add next reflection      MA09 509
incrqx:(STOPR,STOPR+STEPR,ma:0902)#    Get more storage                 MA09 510
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 MA09 511
ELSE IF(DELF<=DFMIN) NEXT#             Full, toss smallest delta f      MA09 512
ELSE#                                  Update stack for new bigger df   MA09 513
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 MA09 514
FOR(K=MININ;K<MAXPHA;K=K+1)#           From previous minimum onward     MA09 515
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 MA09 516
L=K*STEPR+MARKR ; movereal:(QX,L+STEPR+1,QX,L+1,STEPR,0)# Push back     MA09 517
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 MA09 518
L=MAXPHA*STEPR+MARKR#                  Point to bottom of stack         MA09 519
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 MA09 520
QX(L+1)=HKL(1) ; QX(L+2)=HKL(2) ; QX(L+3)=HKL(3)# H,k,l into stack      MA09 521
QX(L+4)=FOBS ; QX(L+5)=FOSIG#          F obs & estimated error in fo    MA09 522
QX(L+6)=COSPH ; QX(L+7)=SINPH#         Default phase                    MA09 523
QX(L+8)=DELF#                          Df=fc*(fo-fc) or df=(fo-fc)      MA09 524
QX(L+10)=FCALC#                        Pick up f calculated             MA09 525
#                                                                       MA09 526
# REESTABLISH THE MINIMUM STORED THUS FAR AND MAKE POINTER TO IT        MA09 527
# --------------------------------------------------------------        MA09 528
#                                                                       MA09 529
DFMIN=9.0E+12 ; L=MARKR ; FOR(K=1;K<=NFOUND;K=K+1)#                     MA09 530
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 MA09 531
L=L+STEPR ; IF(QX(L+8)<DFMIN)#         Look at each df in turn          MA09 532
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 MA09 533
DFMIN=QX(L+8) ; MININ=K#               And mark the minimum             MA09 534
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 MA09 535
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 MA09 536
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 MA09 537
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MA09 538
#                                                                       MA09 539
readwpkt:(1,endrecord:,PSIZ,IP,0)#     Go to end of file                MA09 540
#                                                                       MA09 541
# ADD ONE LAST REFLECTION, A COPY OF THE F(0,0,0) REFLECTION            MA09 542
# ----------------------------------------------------------            MA09 543
incrqx:(STOPR,STOPR+STEPR,ma:0802)#    Get more storage                 MA09 544
#                                                                       MA09 545
# TEST THAT THERE ARE THE CORRECT NUMBER OF DESIGNATED REFLECTIONS      MA09 546
# ----------------------------------------------------------------      MA09 547
#                                                                       MA09 548
IF(NREF==0) NREF=NFOUND#               Set auto loaded                  MA09 549
IF((NREF-NREFIX)!=16&MESIGN==yes:) iquit:(ma:0903)# Be exact for mesi   MA09 550
#                                                                       MA09 551
# MAKE SURE THAT ALL REFLECTIONS LOADED IF THEY COME FROM PHI LINES     MA09 552
# -----------------------------------------------------------------     MA09 553
#                                                                       MA09 554
IFOUND=0 ; FOR(K=MARKR+STEPR;K<STOPR-STEPR;K=K+STEPR)# Chosen refl's    MA09 555
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 MA09 556
ifeq:(QX(K+6),-9999.0)#                All reflections loaded?          MA09 557
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 MA09 558
ncodefld:(QX,K+1,MA10R,FMT2,3) ; writeline:(0,MA10R,NMA10R,3,1)#        MA09 559
IFOUND=IFOUND+1#                                                        MA09 560
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 MA09 561
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 MA09 562
IF(IFOUND>0) iquit:(ma:0906)#          Missing reflection               MA09 563
#                                                                       MA09 564
# SET UP THE TWO COPIES OF THE F(0,0,0) REFLECTION AT THE START AND     MA09 565
# END OF THE REFLECTION ARRAY                                           MA09 566
# -----------------------------------------------------------------     MA09 567
#                                                                       MA09 568
DO J=1,STEPR ; QX(MARKR+J)=0.0#        Mostly zeros                     MA09 569
QX(MARKR+4)=F000 ;QX(MARKR+6)=1.0 ;QX(MARKR+8)=1.0 ;QX(MARKR+11)=F000#  MA09 570
#                                                                       MA09 571
# IN THE PROCESS OF GENERATING COMPANION REFLECTIONS FOR BUILDING THE   MA09 572
# HESSIAN A REFLECTION IS GENERATED OFF THE END OF THE LIST.  IT WILL   MA09 573
# HAVE A THETA(H(J)) OF ZERO DEGREES.  IT MAKES THE LOOP WORK WITHOUT   MA09 574
# SPECIAL TESTS.                                                        MA09 575
# -------------------------------------------------------------------   MA09 576
#                                                                       MA09 577
movereal:(QX,MARKR+1,QX,STOPR-STEPR+1,STEPR,0)# And the last            MA09 578
#                                                                       MA09 579
#                                                                       MA09 580
RETURN#                                                                 MA09 581
END#                                                                    MA09 582
systemheader:(MA10)## Obtain QX array storage for whole job             MA10   1
# ################################################################## #  MA10   2
#                                                                    #  MA10   3
#                               MA10                                 #  MA10   4
#                                                                    #  MA10   5
# ################################################################## #  MA10   6
SUBROUTINE MA10## J.M.Stewart D.M.Collins March 1990                    MA10   7
EXTERNAL AA21#                                                          MA10   8
include:(AACOMN)#                                                       MA10   9
include:(MACOMN)#                                                       MA10  10
REAL    DFMIN,FOBS#                    Selection of correlation refls   MA10  11
INTEGER FIRST,LAST## First and last words of a direct access buffer     MA10  12
INTEGER I,J,JJ,K,L#                    Loop indices                     MA10  13
INTEGER ISCGRP#                        F rel scale group pointer        MA10  14
INTEGER LAYPAS#                        Number of layers per pass        MA10  15
INTEGER LAYSIZ#                        Storage for one layer            MA10  16
INTEGER MAXSIZ#                        Max. space available for lay     MA10  17
INTEGER MININ#                         Pointer for correlation refls    MA10  18
INTEGER NFOUND#                        Count of correlation refls       MA10  19
REAL    HKL(3)#                        Hold h, k, & l for checking      MA10  20
INTEGER PSIZ,IP#                       For lrrefl: io pointers          MA10  21
INTEGER RECRD## Direct access unit record pointer                       MA10  22
INTEGER STOPMX#                        Maximum qx array for fouriers    MA10  23
INTEGER ZIPPO#                         Correlation reflection signal    MA10  24
chardata:(MA7S,[ FILE F WILL BE USED IN MULTIPLE READS OF PRIOR $#      MA10  25
LN(RHO) MAP.  IMMEDIATE ACCESS MEMORY TOO LIMITED.])#                   MA10  26
chardata:(MA7T,[ FILE G WILL BE USED IN MULTIPLE READS OF CORRECTION $# MA10  27
LN(RHO) MAP.  IMMEDIATE ACCESS MEMORY TOO LIMITED.])#                   MA10  28
chardata:(MA8S,[ *** SCRATCH FILE unitda2: USED FOR EACH LAYER $#       MA10  29
IN REVERSSE FOURIER TRANSFORM***])#                                     MA10  30
chardata:(MA8SS,[ memory:    AVAILABLE       NEEDED USED 1 LAYER  $#    MA10  31
READS/LAYER       LAYERS])#                                             MA10  32
chardata:(MA9A, STORAGE LAYOUT IN TERMS OF NUMBER OF WORDS REQUIRED $#  MA10  33
FOR.......)#                                                            MA10  34
chardata:(MA9B,[ I/O BUFFERS  PHASE REFL      SYMOPS     $# U           MA10  35
SORTING       FOURR      RFOURR  FITTED MAP   PRIOR MAP ])# 3           MA10  36
chardata:(MA9C,[  QXSTR    MARKR   MARKS   MARKQ   MARKX   MARKY   $#   MA10  37
MARKG   MARK1   STOPP   STOP6   MARKN   MARKM   STOPM])#                MA10  38
realdata:(FMT1,[80713.,160713.,240713.,320713.,400713.,480713.,$#       MA10  39
560713.,640713.,720713.,800713.,880713.,960713.,1040713.])#             MA10  40
realdata:(FMT2,[120713.,240713.,360713.,480713.,600713.,720713.,$#      MA10  41
840713.,960713.])#                                                      MA10  42
realdata:(FMTDA,[211002.,341002.,471002.,601002.,731002.])#             MA10  43
datastuff:#                                                             MA10  44
#                                                                       MA10  45
# THE LAYOUT OF THE QX ARRAY IN THIS PROGRAM IS AS FOLLOWS:             MA10  46
#                                                                       MA10  47
# QXSTR   TO  MARKS   I/O BUFFERS                                       MA10  48
# MARKS   TO  MARKR   SYMMETRY OPERATORS FOR SPACE GROUP                MA10  49
# MARKR   TO  MDENT   REFLECTIONS IN SUBSET TO BE PHASED                MA10  50
# MDENT   TO  MGRAD   ENTROPY DIFFERENCES FOR SUPPLEMENT TESTS, MESIGN  MA10  51
# MGRAD   TO  MWRK1   VECTOR OF GRADIENT FOR FINDING PRINCE'S DUAL F.M. MA10  52
# MWRK1   TO  MWRK2   WORKING VECTOR 1                                  MA10  53
# MWRK2   TO  MWRK3   WORKING VECTOR 2                                  MA10  54
# MWRK3   TO  MWRK4   WORKING VECTOR 3                                  MA10  55
# MWRK4   TO  MWRK5   WORKING VECTOR 4                                  MA10  56
# MWRK5   TO  MXNEW   WORKING VECTOR 5                                  MA10  57
# MXNEW   TO  MXOLD   UPDATED PRINCE'S DUAL FUNCTION MULTIPLIERS        MA10  58
# MXOLD   TO  MHESS   PREV. CYCLE PRINCE'S DUAL FUNCTION MULTIPLIERS    MA10  59
# MHESS   TO  MARKQ   THE HESSIAN MATRIX FOR FINDING MULTIPLIERS        MA10  60
# MARKQ   TO  MARKN   COMPANION REFLECTIONS FOR BUILDING HESSIAN        MA10  61
# MARKN   TO  STOPY   TEMPORARY FOR SORTING COMPANION REFLECTIONS       MA10  62
# MARKN   TO  MARKM   THE WHOLE CELL ELECTRON DENSITY MAP STORED AS     MA10  63
#                     LN(RHO'), THE MAP OF LOGARITHM ADJUSTMENTS OR     MA10  64
#                     ON FILE G IF NOT ENOUGH MEMORY AVAILBLE           MA10  65
# MARKM   TO  STOPM   THE WHOLE CELL PRIOR ELECTRON DENSITY MAP STORED  MA10  66
#                     AS LN(RHO) IN MEMORY OR ON FILE F IF NOT ENOUGH   MA10  67
#                     MEMORY AVAILABLE                                  MA10  68
# MARKG   IS  STOPM                                                     MA10  69
# MARKG   IS  MARK1   THESE TWO MARKS SET THE BEGINNING OF THE TABLES   MA10  70
#                     REQUIRED BY THE REVERSE AND DIRECT FOURIER        MA10  71
#                     TRANSFORMATIONS.  THE SAME REGION IN MEMORY IS    MA10  72
#                     USED FOR THESE ARRAYS DURING CYCLING.             MA10  73
# MARKG   TO  STOPP   ARRAYS FOR REVERSE FOURIER TRANSFORM              MA10  74
# MARK1   TO  STOP6+2 ARRAYS FOR DIRECT FOURIER TRANSFORM               MA10  75
#                     THE MAXIMUM MEMORY REQUIRED IS TO THE GREATER     MA10  76
#                     OF STOPP OR STOP6+2.                              MA10  77
# STOPMX              IS MAX0(STOPP,STOP6+2)                            MA10  78
#                                                                       MA10  79
MDENT=STOPR#                           Begin yates' ent diff vector     MA10  80
MGRAD=MDENT+NREF ; MWRK1=MGRAD+NREF+2 ; MWRK2=MWRK1+NREF+2#             MA10  81
MWRK3=MWRK2+NREF+2 ; MWRK4=MWRK3+NREF+2 ; MWRK5=MWRK4+NREF+2#           MA10  82
MXNEW=MWRK5+NREF+2 ; MXOLD=MXNEW+NREF+2 ; MHESS=MXOLD+NREF+2#           MA10  83
TOTHES=(NREF+2)*(NREF+3)/2#            Elements in triangular matrix    MA10  84
MARKQ=MHESS+TOTHES#                    Begin companion refl's array     MA10  85
#                                                                       MA10  86
# SET UP REGION FOR REFLECTIONS FOR HESSIAN AND CORRELATION STUDY       MA10  87
# ---------------------------------------------------------------       MA10  88
#                                                                       MA10  89
TOTREF=2*(((NREF+1)*(NREF+2)/2)-1)#    Total reflections for hessian    MA10  90
incrqx:(STOPQ,MARKQ+(TOTREF)*STEPQ,ma:1011)# Region for all             MA10  91
#                                                                       MA10  92
# IN THE FOLLOWING SECTION THE 'CHKREF' LARGEST UNPHASED REFLECTIONS    MA10  93
# ARE LOADED IN ORDER TO GIVE A SUBSET OF REFLECTIONS TO CHECK FOR      MA10  94
# CORRELATION OF F OBS AND F CALC.  HOPEFULLY THIS WILL GIVE            MA10  95
# ADDITIONAL INFORMATION ABOUT TESTED PHASES OF THE CURRENTLY           MA10  96
# PROCESSED REFLECTIONS.                                                MA10  97
# -------------------------------------------------------------------   MA10  98
#                                                                       MA10  99
IF(CHKFMG==yes:)#                      Are correlations sought?         MA10 100
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA10 101
readwpkt:(1,lrrefl:,PSIZ,IP,0)#        Skip header packet this pass     MA10 102
NFOUND=0 ; ISCGRP=1 ; REPEAT#          Search through refls             MA10 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA10 104
readwpkt:(1,lrrefl:,PSIZ,IP,0)#        Read input bdf                   MA10 105
IF(IP<=0) BREAK#                       Quitting at end of refletions    MA10 106
gethkl:(IP+IREL(1),HKL)#               Pick up h, k, & l                MA10 107
ZIPPO=no: ; DO K=1,3 ; IF(ABS(HKL(K))>HLIM(K)) ZIPPO=yes:# Test each    MA10 108
IF(ZIPPO==yes:) NEXT#                  Leave out high order refls       MA10 109
IF(IREL(8)>0) ISCGRP=NINT(QX(IREL(8)+IP))# See if scale group given     MA10 110
FOBS=SCALE(ISCGRP)*QX(IP+IREL(3))#     Pick up f observed               MA10 111
IF(FOBS<CHKMAG) NEXT#                  Ditch little ones                MA10 112
IF(IREL(5)>0)#                         Phases in bdf?                   MA10 113
IF(QX(IP+IREL(5))>=0.0&QX(IP+IREL(5))<1.0) NEXT# Ditch phased ones      MA10 114
J=0 ; FOR(K=MARKR;K<STOPR;K=K+STEPR)#  Check if refl in process now     MA10 115
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA10 116
IF(ABS(QX(K+1)-HKL(1))<0.1&$#          Search for ones in process       MA10 117
ABS(QX(K+2)-HKL(2))<0.1&$#             In this run of mephase           MA10 118
ABS(QX(K+3)-HKL(3))<0.1)#              And reject them from             MA10 119
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA10 120
J=1 ; BREAK#                           The correlation test             MA10 121
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA10 122
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA10 123
IF(J==1) NEXT#                         Skip to next reflection          MA10 124
#                                                                       MA10 125
# NOW FILL AND THEN UPDATE THE STACK AS BIGGEST F OBS COME BY           MA10 126
# -----------------------------------------------------------           MA10 127
#                                                                       MA10 128
IF(NFOUND<CHKREF)#                     Stack full?                      MA10 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA10 130
L=(TOTREF+NFOUND)*STEPQ+MARKQ ; NFOUND=NFOUND+1# Next reflection        MA10 131
incrqx:(STOPQ,STOPQ+STEPQ,ma:0902)#    Get more storage                 MA10 132
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA10 133
ELSE IF(FOBS<=DFMIN) NEXT#             Full, toss smallest fobs         MA10 134
ELSE#                                  Update stack for bigger fobs     MA10 135
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA10 136
FOR(K=MININ;K<CHKREF;K=K+1)#           From previous minimum onward     MA10 137
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA10 138
L=(TOTREF+K-1)*STEPQ+MARKQ#            Pull the stack up to leave       MA10 139
movereal:(QX,L+STEPQ+1,QX,L+1,STEPQ,0)# Space at the bottom for large   MA10 140
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA10 141
L=(TOTREF+CHKREF-1)*STEPQ+MARKQ#       Point to newly cleared item      MA10 142
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA10 143
QX(L+3)=HKL(1) ; QX(L+4)=HKL(2) ; QX(L+5)=HKL(3)# H,k,l into stack      MA10 144
QX(L+7)=FOBS#                          F obs into the stack             MA10 145
#                                                                       MA10 146
# REESTABLISH THE MINIMUM STORED THUS FAR AND MAKE POINTER TO IT        MA10 147
# --------------------------------------------------------------        MA10 148
#                                                                       MA10 149
DFMIN=9.0E+12 ; L=MARKQ+(TOTREF-1)*STEPQ;FOR(K=1;K<=NFOUND;K=K+1)#      MA10 150
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA10 151
L=L+STEPQ ; IF(QX(L+7)<DFMIN)#         Look at each fobs in turn        MA10 152
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MA10 153
DFMIN=QX(L+7) ; MININ=K#               And mark the minimum             MA10 154
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MA10 155
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA10 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA10 157
#                                                                       MA10 158
CHKREF=NFOUND ; CHKMAG=DFMIN#          Remember actual numbers found    MA10 159
readwpkt:(1,endrecord:,PSIZ,IP,0)#     Go to end of file                MA10 160
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA10 161
MARKX=STOPQ ; STOPX=MARKX+TOTREF+CHKREF# Region for packed hkl          MA10 162
MARKY=STOPX ; STOPY=STOPX+TOTREF+CHKREF# Region for sort pointers       MA10 163
#                                                                       MA10 164
# ACQUIRE STORAGE AND SET UP USE OF FILE F & G, IF NEED BE              MA10 165
# --------------------------------------------------------              MA10 166
#                                                                       MA10 167
MARKN=STOPQ#                           Start ln(rho) correction map     MA10 168
STOPN=MARKN+NPIX ; CORUSE=no:#         Get storage for correction map   MA10 169
qxmemory:(STOPN)#                      Will it all go in memory?        MA10 170
IF((STOPN>QXCUR)\(CORSIG==yes:))#      Or does user fancy file use      MA10 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MA10 172
CORUSE=yes:#                           Have to use file g               MA10 173
STOPN=MARKN+bdfbuf:#                   Lower sights on memory           MA10 174
IOMARK(7)=MARKN#                       Set up buffer for file g         MA10 175
qxmemory:(STOPN)#                      And try again                    MA10 176
writeline:(1,MA7T,NMA7T,3,3)#                                           MA10 177
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MA10 178
MARKM=STOPN#                           Start of ln(rho) prior map       MA10 179
STOPM=MARKM+NPIX ; PRIUSE=no:#         Get storage for prior map        MA10 180
qxmemory:(STOPM)#                      Will it all go in memory?        MA10 181
IF((STOPM>QXCUR)\(PRISIG==yes:))#      Or does user fancy file use      MA10 182
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MA10 183
PRIUSE=yes:#                           Have to use file f               MA10 184
STOPM=MARKM+bdfbuf:#                   Lower sights on memory           MA10 185
IOMARK(6)=MARKM#                       Set up buffer for file f         MA10 186
qxmemory:(STOPM)#                      And try again                    MA10 187
writeline:(1,MA7S,NMA7S,3,3)#                                           MA10 188
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MA10 189
MARK1=STOPM#                           Go on beyond companion refls     MA10 190
MARK2=MARK1#                           Set marker for start of trig     MA10 191
STEP1=2#                               Step for trig tables             MA10 192
STOP1=MARK1+2*NG(1)-1#                 End of first sum trig tables     MA10 193
#                                                                       MA10 194
# THE MEMORY IS LAID OUT IN THE FOLLOWING WAY DURING THE RECIPROCAL     MA10 195
# SPACE TO DIRECT SPACE FOURIER TRANSFORM                               MA10 196
# -----------------------------------------------------------------     MA10 197
#                                                                       MA10 198
# MARK2 /***************/    MARK1 /***************/                    MA10 199
#       /FFT UNSCRAMBLE /          /               /                    MA10 200
#       /TABLE OF THE   /          /               /                    MA10 201
#       /SECOND SUM     /          /SINE COSINE    /                    MA10 202
# MARK3 /***************/          /TABLES OF THE  /                    MA10 203
#       /FFT UNSCRAMBLE /          /FIRST SUMMATION/                    MA10 204
#       /TABLE FOR THE  /          /               /                    MA10 205
#       /THIRD SUMMATION/          /               /                    MA10 206
# MARK4 /***************/          /               /                    MA10 207
#       /COEFFICIENTS   /    STOP1/---------------/                     MA10 208
#       /OF THE THIRD   /    STOP1 CANNOT BE GREATER THAN MARK6         MA10 209
#       /SUMMATION FOR  /                                               MA10 210
#       /ONE COMPLETE   /    STEP1 IS  2 FOR SIN-COS                    MA10 211
#       /LAYER CUTTING  /    STEP4 IS 2                                 MA10 212
#       /THE FIRST SUM  /                                               MA10 213
#       /DIRECTION      /    STEP6 IS 4                                 MA10 214
# MARK5 /***************/    MARK2=MARK1 AT END OF SYMOPS               MA10 215
#       /THIRD SUMMATION/    STOP2=MARK3-1                              MA10 216
#       /FOR ONE LINE OF/    STOP3=MARK4-1                              MA10 217
#       /ONE SHEET OF   /    STOP4=MARK5-1                              MA10 218
#       /OF THE FINAL,  /    STOP5=MARK6-1                              MA10 219
#       /THIRD SUMMATION/    STOP6 DEPENDS UPON THE AMOUNT OF MEMORY    MA10 220
# MARK6 /***************/    OR THE SIZE OF THE PROBLEM, WHICHEVER IS   MA10 221
#       /COEFFICIENTS   /    SMALLER IN THE GIVEN CASE                  MA10 222
#       /OF THE SECOND  /                                               MA10 223
#       /SUMMATION FOR  /                                               MA10 224
#       /AS MANY LAYERS /                                               MA10 225
#       /AS AVAILABLE   /                                               MA10 226
#       /MEMORY WILL ALLOW/                                             MA10 227
# STOP6/***************/                                                MA10 228
#                                                                       MA10 229
#                                                                       MA10 230
# CALCULATE THE MEMORY NEEDED FOR THE PROBLEM AT HAND.  THE INFLEXIBLE  MA10 231
# PART OF THE NEEDS ARE FOR THE FIRST SUM TRIG TABLES, THE OVERLAYING   MA10 232
# SECOND AND THIRD SUM FFT UNSCRAMBLING POINTERS PLUS THE COEFFICIENTS  MA10 233
# OF THE THIRD SUM FOR ONE COMPLETE LAYER PLUS THE THIRD SUM FOR        MA10 234
# ONE LINE.                                                             MA10 235
#                                                                       MA10 236
#                                                                       MA10 237
# FFT NEEDS SPACE FOR THE UNSCRAMBLING KEY AND THE FACT LIST FOR        MA10 238
# THE SECOND AND THIRD SUMS AS WELL.                                    MA10 239
# SET THE MARKS TO TAKE BEST ADVANTAGE OF THE SPACE AVAILABLE.          MA10 240
#                                                                       MA10 241
#                                                                       MA10 242
# FOR THE FFT METHOD, MAKE SURE THAT THE NUMBER OF POINTS ALONG         MA10 243
# THE AXES OF THE 2ND AND 3RD SUMS ARE ABLE TO BE FACTORED BY 2,3,4,5.  MA10 244
# IF THE ORIGINAL VALUES SUPPLIED FOR NG(2) AND NG(3) DON'T MEET THIS   MA10 245
# CRITERION, GIVE UP AND QUIT.  BUT FIRST MAKE SURE THAT                MA10 246
# NUMBERS NG(2) AND NG(3) ARE AT LEAST AS LARGE AS THE LARGEST HKL OR   MA10 247
# THE RESPECTIVE DIRECTIONS (I.E., IHMAX(2 OR 3) PLUS 1).               MA10 248
# MAKE SURE THE ORIGINS FOR THESE AXES ARE ZERO                         MA10 249
# IN ORDER TO USE AS LITTLE STORAGE AS POSSIBLE, COUNT UP IN STOP2 AND  MA10 250
# STOP3 THE AMOUNT OF SPACE THAT WILL BE REQUIRED FOR THE KEY AND       MA10 251
# THE FACTOR LIST.                                                      MA10 252
#                                                                       MA10 253
STOP3=0;   STOP2=0#                    Set initial stops                MA10 254
REPEAT#                                                                 MA10 255
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MA10 256
J=NG(3)#                                                                MA10 257
JJ=5#                                                                   MA10 258
WHILE ((J>1)&(JJ>=2))#                                                  MA10 259
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MA10 260
IF(J==(J/JJ)*JJ)#                                                       MA10 261
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MA10 262
J=J/JJ#                                                                 MA10 263
STOP3=STOP3+1#                         Add room for this factor         MA10 264
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MA10 265
ELSE JJ=JJ-1#                                                           MA10 266
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MA10 267
IF(J==1) BREAK#                                                         MA10 268
iquit:(ma:1003)#                       Ng(3)=ng(3)+1 it should not be   MA10 269
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MA10 270
REPEAT#                                                                 MA10 271
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MA10 272
J=NG(2)#                                                                MA10 273
JJ=5#                                                                   MA10 274
WHILE ((J>1)&(JJ>=2))#                                                  MA10 275
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MA10 276
IF(J==(J/JJ)*JJ)#                                                       MA10 277
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MA10 278
J=J/JJ#                                                                 MA10 279
STOP2=STOP2+1#                         Add room for this factor         MA10 280
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MA10 281
ELSE JJ=JJ-1#                                                           MA10 282
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MA10 283
IF(J==1) BREAK#                                                         MA10 284
iquit:(ma:1004)#                       Ng(2)=ng(2)+1 it should not be   MA10 285
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MA10 286
#                                                                       MA10 287
STOP2=STOP2+NG(2)#                     Save room for 2nd sum key        MA10 288
STOP3=STOP3+NG(3)#                     Save room for the 3rd sum ke     MA10 289
STOP2=STOP2+MARK2+1#                   Space needed was figured in      MA10 290
MARK3=STOP2#                           Subroutine fs30 where the        MA10 291
STOP3=STOP3+MARK3+1#                   Number of fft factors were       MA10 292
MARK4=STOP3#                           Figured out                      MA10 293
STEP4=2#                                                                MA10 294
STOP4=MARK4+2*(NG(3)+1)*(NG(2)+1)-1#   Calc space for third sum         MA10 295
MARK5=STOP4+1#                         Set start of third sum resul     MA10 296
#                                                                       MA10 297
STOP5=MARK5+NG(3)+1#                   Calc space for portion           MA10 298
#                                      Of a sheet of a layer            MA10 299
#                                                                       MA10 300
# THE MEMORY NEEDED SO FAR IS THE MAXIMUM OF STOP1 OR STOP5 PLUS ONE    MA10 301
# DEPENDING ON WHICH IS LARGER.  ANOTHER SAVINGS IS POSSIBLE            MA10 302
# HOWEVER.  THE COEFFICIENTS OF THE VERY FIRST LAYER OF THE             MA10 303
# SECOND SUM ARE STORED IN THE FIRST OF THE MARK6 ARRAY.                MA10 304
# THESE COEFFICIENTS MAY, THEREFORE BE OVERWRITTEN DURING THE           MA10 305
# THIRD SUM. THE MODICUM OF STORAGE WHICH CAN BE SALVAGED IS            MA10 306
# EITHER ALL OF MARK5 OR AT LEAST THE FIRST LAYER OF SECOND             MA10 307
# SUM COEFFICIENTS INTO MARK5.                                          MA10 308
#                                                                       MA10 309
LAYSIZ=4*(NG(2)+1)*(NG(3)+1)#          For fft algorithm                MA10 310
MARK6=MAX0(STOP1+1,STOP5+1)#           Calculate storage needed         MA10 311
qxmemory:(MARK6)#                      Fetch memory if possible         MA10 312
#                                                                       MA10 313
# NOW TEST THAT THERE IS ENOUGH FOR THE FIRST SUM TRIG TABLES AND       MA10 314
# THE FIRST SUM COEFFICIENTS FOR AT LEAST ONE LAYER.                    MA10 315
# ---------------------------------------------------------------       MA10 316
#                                                                       MA10 317
IF(MARK6>QXCUR) iquit:(-ma:1005)#      If not give up here              MA10 318
STEP6=4; STOP6=MARK6+LAYSIZ*NP(1)-1#   Calculate the needed storage     MA10 319
qxmemory:(STOP6+2)#                    Request and zero memory          MA10 320
MAXSIZ=QXMAX-MARK6#                    Calc the maximum size avail      MA10 321
IF(MAXSIZ<=LAYSIZ) iquit:(-ma:1006)#   Second sum coefs for one layer   MA10 322
#                                                                       MA10 323
#  RATIONALIZE LAYERS PER PASS, ETC.                                    MA10 324
#  ---------------------------------                                    MA10 325
#                                                                       MA10 326
LAYPAS=MAXSIZ/LAYSIZ#                  Figure out number of layers      MA10 327
PASSES=(NP(1)+LAYPAS-1)/MAX0(LAYPAS,1)# Calc the number of passes       MA10 328
LAYPAS=(NP(1)+PASSES-1)/MAX0(PASSES,1)# Now equalize the layers per     MA10 329
NPP1=LAYPAS#                           Set no. of layers for first      MA10 330
STOP6=LAYPAS*LAYSIZ+MARK6-1#           Recalculate end of store         MA10 331
qxmemory:(STOP6+2)#                    Request and zero memory          MA10 332
IF(QXCUR<STOP6+2) iquit:(-ma:1007)#    No to third sum coeffs           MA10 333
#                                                                       MA10 334
# NOW ATTEND TO THE NEEDS OF THE REVERSE FOURIER TRANSFORM FROM         MA10 335
# DIRECT SPACE TO RECIPROCAL SPACE                                      MA10 336
# -------------------------------------------------------------         MA10 337
#                                                                       MA10 338
#                                                                       MA10 339
#-----STORAGE OF REVERSE FOURIER SUMMATION COEFFICIENTS                 MA10 340
#                                                                       MA10 341
# ALL TRANSFORMS ARE CARRIED OUT IN THE COMPLEX ARRAY 'W' DECLARED IN   MA10 342
# SUBROUTINE MA80.  AS EACH LINE OF THE ELECTRON DENSITY MAP IS READ IN MA10 343
# THE E-DS ARE MOVED TO THE W ARRAY AS THE REAL PART OF COMPLEX NUMBERS MA10 344
# ONCE MOVED THE ONE DIMENSIONAL FFT OF THE LINE IS MADE BY SUBROUTINE  MA10 345
# MA81 ET.SEQ. TO FORM SECOND SUMMATION COEFFICIENTS WHICH ARE STORED   MA10 346
# IN THE MARKG PORTION OF THE QX ARRAY AS PAIRED REAL-IMAGINARY NUMBERS MA10 347
# AFER ALL THE LINES OF A LAYER ARE THUS TRANSFORMED, THE THIRD         MA10 348
# SUMMATION COEFFICIENTS ARE FORMED AND PLACED IN THE MARKP REGION OF   MA10 349
# THE QX ARRAY, AGAIN AS 2 WORDS PER COEFFICIENT.   IF THERE IS NOT     MA10 350
# ENOUGH IMMEDIATE ACCESS STORAGE FOR THE WHOLE TRANSFORM THE THIRD     MA10 351
# SUM COEFFICIENTS ARE DUMPED TO A RANDOM ACCESS SCRATCH FILE.          MA10 352
# THE STORAGE LAYOUT FOR THE SECOND SUM COEFFICIENTS IN THE MARKG ARRAY MA10 353
# ARE:                                                                  MA10 354
#---------------------------------------------------------------------- MA10 355
#          /X1=CURRENT LAYER VALUE  /    EACH PACKET CONTAINS STEPG     MA10 356
# PACKET 1 /X2=0 TO X2 MAXIMUM      /    WORDS,  WHERE                  MA10 357
#          /H3=1                    /    STEPG=2*(NO. X2 POINTS)        MA10 358
#---------------------------------------------------------------------- MA10 359
#          /X1=CURRENT LAYER VALUE  /                                   MA10 360
# PACKET 2 /X2=0 TO X2 MAXIMUM      /                                   MA10 361
#          /H3=0                    /                                   MA10 362
#---------------------------------------------------------------------- MA10 363
#          / ......       ........  /                                   MA10 364
#          / ......       ........  /                                   MA10 365
#          / ......       ........  /                                   MA10 366
#---------------------------------------------------------------------- MA10 367
#          /X1=CURRENT LAYER VALUE  /                                   MA10 368
# PACKET N /X2=0 TO X2 MAXIMUM      /                                   MA10 369
#          /H3=NYQUIST FREQ OF H3   /                                   MA10 370
#---------------------------------------------------------------------- MA10 371
#                                                                       MA10 372
# IN THE CASE OF THE THIRD SUMMATION COEFFICIENTS THERE ARE PACKETS     MA10 373
# AND SUB PACKETS.  THE SUBPACKETS ARE STEPH=2*(NO. POINTS 3RD SUM)     MA10 374
# AND THE PACKETS, WHICH CONSTITUTE ALL THE COEFFICIENTS NEEDED FOR     MA10 375
# ONE LAYER IN RECIPROCAL SPACE, ARE STEPP=STEPH*(NO. 2ND SUM PTS).     MA10 376
# IF THERE IS SUFFICIENT MEMORY THEN (H3 MAX +1)*STEPP WILL BE HELD.    MA10 377
# IF NOT THEN EACH LAYER WILL BE STORED ON DIRECT ACCESS FILE ON        MA10 378
# FILE H.  THE ORDER OF STORAGE IS AS FOLLOWS:                          MA10 379
#                                                                       MA10 380
#---------------------------------------------------------------------- MA10 381
#          /X1=0 THRU X1 MAXIMUM    /                                   MA10 382
# PACKET 1 /H2=0                    / STEPH SUBPACKET 1                 MA10 383
#          /H3=0                    /                                   MA10 384
#---------------------------------------------------------------------- MA10 385
#          /X1=0 THRU X1 MAXIMUM    /                                   MA10 386
# PACKET 2 /H2=1                    / STEPH SUBPACKET 2                 MA10 387
#          /H3=0                    /                                   MA10 388
#---------------------------------------------------------------------- MA10 389
#          / ......        .......  /                                   MA10 390
#          / ......        .......  /                                   MA10 391
#---------------------------------------------------------------------- MA10 392
#          /X1=0 THRU X1 MAXIMUM    /                                   MA10 393
# PACKET N /H2=H2 MAXIMUM           / STEPH SUBPACKET N                 MA10 394
#          /H3=0                    /                                   MA10 395
#---------------------------------------------------------------------- MA10 396
#          / ......        .......  /                                   MA10 397
#          / ......        .......  /                                   MA10 398
#          / ......        .......  /                                   MA10 399
#          / ......        .......  /                                   MA10 400
#---------------------------------------------------------------------- MA10 401
#          /X1=0 THRU X1 MAXIMUM    /                                   MA10 402
# PACKET M /H2=H2 MAXIMUM           / STEPH SUBPACKET N*(NO. H3S)       MA10 403
#          /H3=NYQUIST FREQ OF H3   /                                   MA10 404
#---------------------------------------------------------------------- MA10 405
#                                                                       MA10 406
NH1=NX1;NH2=NX2;NH3=NX3#               Also set indices for clarity     MA10 407
NYQF1=(NH1-1)/2; NYQF2=(NH2-1)/2; NYQF3=(NH3-1)/2# Set nyquist freq     MA10 408
#                                                                       MA10 409
#                                                                       MA10 410
# GET STORAGE AND SET UP DIRECT ACCESS FILES IF NEED BE                 MA10 411
# -----------------------------------------------------                 MA10 412
#                                                                       MA10 413
MARKG=MARK1#                           Set start at same as fourr       MA10 414
qxmemory:(MARKG)#                      Reset qx available               MA10 415
STEPG=2*NX2;  STEPH=2*NX1#             Set up array steps               MA10 416
STEPGP=0;     STEPP=2*NX1*NH2#         For third sum with direct acce   MA10 417
NYQF3P=NYQF3+1#                        Incr positive h3 count           MA10 418
MARKP=MARKG+NYQF3P*STEPG#              Memory for sec sum coefs         MA10 419
qxmemory:(MARKP)#                      See if space available           MA10 420
IF(MARKP>QXCUR) iquit:(-ma:1008)#      No memory for 2ond sum coeffs    MA10 421
IF(DIRSIG==no:)#                       If no direct access file requ    MA10 422
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MA10 423
STOPP=MARKP+NYQF3P*STEPP#              Get storage for third sum coef   MA10 424
qxmemory:(STOPP)#                      Will it all go in memory?        MA10 425
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MA10 426
IF((STOPP>QXCUR)\(DIRSIG==yes:))#      Or does user fancy direct acce   MA10 427
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MA10 428
DIRACC=yes:#                           Have to use direct access file   MA10 429
BUFOT(1)=FLOAT(QXCUR) ; BUFOT(2)=FLOAT(STOPP)# State memory problem     MA10 430
STOPP=MARKP+STEPP ; qxmemory:(STOPP)#  Readjust memory                  MA10 431
IF(STOPP>QXCUR) iquit:(ma:7003)#       Test if completely out of ?      MA10 432
writeline:(1,MA8S,NMA8S,2,3)#          Explain use of random file       MA10 433
NREADS=(STEPP-1)/dirbuf:+1#            No. of reads per layer           MA10 434
BUFOT(3)=FLOAT(STEPP) ; BUFOT(4)=FLOAT(NREADS)# Explain storage use     MA10 435
BUFOT(5)=FLOAT(NYQF3P) ; ncodefld:(BUFOT,1,CHROT,FMTDA,5)# 1            MA10 436
writeline:(0,MA8SS,NMA8SS,2,3)#        Report facts        i            MA10 437
opendac:(unitda2:,3,arith:(dirbuf:,*,mxchwd:),' ')# Open direct acces   MA10 438
RECRD=0#                               Direct access record pointera    MA10 439
DO I=1,NYQF3P#                         Loop over all layers             MA10 440
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MA10 441
FIRST=MARKP+1-dirbuf:#                 Prepare to point to first word   MA10 442
DO J=1,NREADS#                         Loop over no. of buffers         MA10 443
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MA10 444
FIRST=FIRST+dirbuf: ; LAST=MIN0(FIRST+dirbuf:-1,STOPP)# Read region     MA10 445
RECRD=RECRD+1 ; writedac:(unitda2:,,RECRD,(QX(JJ),JJ=FIRST,LAST))# O    MA10 446
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MA10 447
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MA10 448
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MA10 449
ELSE  DIRACC=no:#                      Default do not use direct acce   MA10 450
#                                                                       MA10 451
# NOW REPORT OUT THE ACTUAL USE OF STORAGE ARRAYS WITHIN QXD            MA10 452
# ---------------------------------------------------------             MA10 453
#                                                                       MA10 454
STOPMX=MAX0(STOPP,STOP6+2)#            Get maximum needed               MA10 455
qxmemory:(STOPMX)#                     See if space available           MA10 456
IF(STOPMX<QXCUR) iquit:(-ma:1010)#     Die for lack of space in qx      MA10 457
LINRM=4 ; writeline:(1,MA9A,NMA9A,3,3)# Report storage usage            MA10 458
BUFOT(1)=FLOAT(MARKR-QXSTR) ; BUFOT(2)=FLOAT(STOPR-MARKR)#              MA10 459
BUFOT(3)=FLOAT(STOPS-MARKS)#                                            MA10 460
BUFOT(4)=FLOAT(STOPY-MARKX) ; BUFOT(5)=FLOAT(STOP6+2-MARK1)#            MA10 461
BUFOT(6)=FLOAT(STOPP-MARKG)#                                            MA10 462
BUFOT(7)=FLOAT(STOPN-MARKN) ; BUFOT(8)=FLOAT(STOPM-MARKM)#              MA10 463
ncodefld:(BUFOT,1,CHROT,FMT2,8) ; writeline:(0,MA9B,NMA9B,2,3)#         MA10 464
BUFOT(1)=FLOAT(QXSTR) ; BUFOT(2)=FLOAT(MARKR) ; BUFOT(3)=FLOAT(MARKS)#  MA10 465
BUFOT(4)=FLOAT(MARKQ) ; BUFOT(5)=FLOAT(MARKX) ; BUFOT(6)=FLOAT(MARKY)#  MA10 466
BUFOT(7)=FLOAT(MARKG) ; BUFOT(8)=FLOAT(MARK1) ; BUFOT(9)=FLOAT(STOPP)#  MA10 467
BUFOT(10)=FLOAT(STOP6);BUFOT(11)=FLOAT(MARKN);BUFOT(12)=FLOAT(MARKM)#   MA10 468
BUFOT(13)=FLOAT(STOPM)#                                                 MA10 469
ncodefld:(BUFOT,1,CHROT,FMT1,13) ; writeline:(0,MA9C,NMA9C,2,3)#        MA10 470
IF(QUITF(1^1)!=' ') iquit:(ma:1013)#   Now die, die, die, dead!         MA10 471
RETURN#                                                                 MA10 472
END#                                                                    MA10 473
systemheader:(MA11)## Prepare companion reflections for hessian calc    MA11   1
# ################################################################## #  MA11   2
#                                                                    #  MA11   3
#                               MA11                                 #  MA11   4
#                                                                    #  MA11   5
# ################################################################## #  MA11   6
SUBROUTINE MA11## D.M. Collins J.M. Stewart                             MA11   7
IMPLICIT NONE#                                                          MA11   8
include:(AACOMN)#                      April 1990                       MA11   9
include:(MACOMN)#                                                       MA11  10
#                                                                       MA11  11
INTEGER BIJVO## Signal which hemisphere a reflection lives in           MA11  12
INTEGER I,J,K#                         Loop indices                     MA11  13
REAL    HFOURR(3)## Values of h, k, and l in fourier order              MA11  14
REAL    HHESS(3)## VALUES of h, k, and l in hessian order               MA11  15
REAL    HMAX(3)## Maximum values of h, k, and l in generated set        MA11  16
REAL    HOLDF## To hold correlation f obs for sort pointer formation    MA11  17
INTEGER IREF## Pointer to storage place generating reflection 1         MA11  18
INTEGER JREF## Pointer to storage place generating reflection 2         MA11  19
INTEGER PHASHF## Phase shift rfourr to hessian reflection               MA11  20
INTEGER PUTCON## Pointer to storage place for packed cannonical hkl     MA11  21
INTEGER PUTPNT## Pointer to pointer for sorted packed cannonical hkl    MA11  22
INTEGER PUTREF## Pointer to storage place for generated reflection      MA11  23
INTEGER REFBAD## Signal reflections outside resolution of map           MA11  24
chardata:(MA11A, THE RESOLUTION OF THE INPUT MAP IS TOO LOW FOR $#      MA11  25
THE ORDER OF A REFLECTION BEING PHASED.)#                               MA11  26
chardata:(MA11B, LOOK ABOVE FOR THE OFFENDER. GRIDS MUST BE AT LEAST $# MA11  27
2*MAXH+1 IN EACH DIRECTION. LOOK ALSO TO MAXHKL LINE.)#                 MA11  28
chardata:(MA11C, UTILIZATION ORDER            PHASE CORRECTIONS       $#MA11  29
FOURIER ORDER)#                                                         MA11  30
chardata:(MA11D,    H    K    L     STATUS   BIJVOET  PHASE SHIFT     $#MA11  31
H    K    L )#                                                          MA11  32
chardata:(MA11E,[<--CHOSEN  ])#                                         MA11  33
chardata:(MA11J,[GENERATED  ])#                                         MA11  34
chardata:(MA11K,[CORRELATION])#                                         MA11  35
chardata:(MA11F,[                    MAXIMUM H,K,L GENERATED])#         MA11  36
chardata:(MA11G, DURING THE CALCULATION OF THE PHASE CORRECTIONS THE $# MA11  37
REFLECTIONS MUST BE USED IN UTILIZATION ORDER)#                         MA11  38
chardata:(MA11H, DURING THE REVERSE FOURIER TRANSFORM THE REFLECTIONS $#MA11  39
ARE GENERATED IN FOURIER ORDER )#                                       MA11  40
chardata:(MA11I, THE PHASE FROM THE FOURIER MUST BE CORRECTED AS $#     MA11  41
SHOWN TO PRODUCE THE CORRECT PHASE FOR UTILIZATION)#                    MA11  42
realdata:(FMT1,[50413.,100413.,150413.])#                               MA11  43
realdata:(FMT2,[560413.,610413.,660413.])#                              MA11  44
realdata:(SHIFT,[0.,30.,60.,90.,120.,150.,180.,$#                       MA11  45
210.,240.,270.,300.,330.,360.])#       Phase shifts in degrees          MA11  46
chardata:(SIGNS,[+-])#                                                  MA11  47
datastuff:#                                                             MA11  48
#                                                                       MA11  49
REFBAD=no:#                            Assume reflections o.k.          MA11  50
PUTREF=MARKQ-STEPQ#                    Set to store generated refl      MA11  51
PUTPNT=MARKY-1#                        Set to store sort pointer        MA11  52
PUTCON=MARKX-1#                        Set to store packed hkl          MA11  53
IREF=MARKR#                            Set to pick up generator 1       MA11  54
#                                                                       MA11  55
# LOOP OVER ALL REFLECTIONS BEING PHASED IN ORDER TO GENERATE ALL       MA11  56
# THE H(I)+H(J) AND H(I)-H(J) 'COMPANION REFLECTIONS REQUIRED IN        MA11  57
# THE FORMATION OF THE HESSIAN MATRIX IN SUBROUTINE MA36.               MA11  58
# THE SEVEN ITEMS SAVED IN THE MARKQ ARRAY ARE A CALC, B CALC,          MA11  59
# H, K, L, A SORT POINTER WHICH IS USED IN MA80 (RFOURR) TO CAUSE       MA11  60
# A AND B TO BE PICKED UP IN SORTED REFLECTION ORDER, AND, FINALLY      MA11  61
# A PACKED SIGNAL WORD CONTAINING EITHER THE NEGATIVE VALUE OF          MA11  62
# F RELATIVE TO SIGNAL THAT THE REFLECTION IS UNPHASED AND TO BE USED   MA11  63
# TO STUDY THE CORRELATION WITH F CALCULATED OR POSITIVE NUMBERS WHICH  MA11  64
# GIVE THE PHASE SHIFT INFORMATION TO GO FROM THE REFLECTION FROM       MA11  65
# RFOURR TO THE SYMMETRIC PHASE REQUIRED BY THE HESSIAN WITH CODES      MA11  66
# AS FOLLOWS:                                                           MA11  67
# IC + 10*BIJVO + 100*PHASHF                                            MA11  68
# IC IS 0/1 FOR COMPANION/CHOSEN, BIJVO IS 0/1 FOR POSITIVE HEMISPHERE  MA11  69
# NEGATIVE HEMISPHERE, PHASHF IS 0/1/2/3/4/5/6/7/8/9/10/11 FOR          MA11  70
# PHASE SHIFTS OF 0/30/60/90/120/150/180/210/240/270/300/330 DEGREES.   MA11  71
# THESE LAST TWO SIGNALS GIVE THE PHASE SHIFT REQUIRED TO CARRY THE     MA11  72
# PHASE OF THE REFLECTION OBTAINED FROM THE REVERSE FOURIER BACK TO     MA11  73
# THE PHASE OF THE SYMMETRICALLY RELATED REFLECTION NEEDED TO BUILD     MA11  74
# THE HESSIAN MATRIX.  THE H, K, AND L HAVE BEEN TRANSFORMED INTO THE   MA11  75
# SUB-SET NEEDED BY THE REVERSE FOURIER TRANSFORM.  ACALC AND BCALC     MA11  76
# HOWEVER, HAVE BEEN SET TO BE CORRECT FOR THE CONTRIBUTION TO THE      MA11  77
# HESSIAN.                                                              MA11  78
# --------------------------------------------------------------------- MA11  79
#                                                                       MA11  80
DO I=1,NREF#                           Outer loop over reflections      MA11  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA11  82
JREF=IREF#                             Set to point to generator 2      MA11  83
IREF=IREF+STEPR#                       Point to generator 1             MA11  84
DO J=I,NREF+1#                         Combinations and originals       MA11  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA11  86
JREF=JREF+STEPR#                       Point to generator 2             MA11  87
IF(J<=NREF)#                           For the ones which combine       MA11  88
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA11  89
PUTREF=PUTREF+STEPQ#                   Point to generated reflection    MA11  90
QX(PUTREF+6)=0.0 ; QX(PUTREF+7)=0.0#   Sort pointer & companion signa   MA11  91
QX(PUTREF+3)=QX(IREF+1)+QX(JREF+1)#    H(new)=h(i)+h(j)                 MA11  92
QX(PUTREF+4)=QX(IREF+2)+QX(JREF+2)#    K(new)=k(i)+k(j)                 MA11  93
QX(PUTREF+5)=QX(IREF+3)+QX(JREF+3)#    L(new)=l(i)+l(j)                 MA11  94
CALL MA12(PUTREF,PUTPNT,PUTCON,REFBAD)# Get packed sorting word         MA11  95
PUTREF=PUTREF+STEPQ#                   Next generated refl              MA11  96
QX(PUTREF+6)=0.0 ; QX(PUTREF+7)=0.0#   Sort pointer & companion signa   MA11  97
QX(PUTREF+3)=QX(IREF+1)-QX(JREF+1)#    H(new)=h(i)-h(j)                 MA11  98
QX(PUTREF+4)=QX(IREF+2)-QX(JREF+2)#    K(new)=k(i)-k(j)                 MA11  99
QX(PUTREF+5)=QX(IREF+3)-QX(JREF+3)#    L(new)=l(i)-l(j)                 MA11 100
CALL MA12(PUTREF,PUTPNT,PUTCON,REFBAD)# Get packed sorting word         MA11 101
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA11 102
ELSE#                                  For the original refls           MA11 103
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA11 104
PUTREF=PUTREF+STEPQ#                   Point to original reflection     MA11 105
QX(PUTREF+6)=0.0 ; QX(PUTREF+7)=1.0#   Sort pointer & companion signa   MA11 106
QX(PUTREF+3)=QX(IREF+1)#               H(new)=h(i)+h(j)                 MA11 107
QX(PUTREF+4)=QX(IREF+2)#               K(new)=k(i)+k(j)                 MA11 108
QX(PUTREF+5)=QX(IREF+3)#               L(new)=l(i)+l(j)                 MA11 109
CALL MA12(PUTREF,PUTPNT,PUTCON,REFBAD)# Get packed sorting word         MA11 110
PUTREF=PUTREF+STEPQ#                   Next generated refl              MA11 111
QX(PUTREF+6)=0.0 ; QX(PUTREF+7)=0.0#   Sort pointer & companion signa   MA11 112
QX(PUTREF+3)=QX(IREF+1)#               H(new)=h(i)-h(j)                 MA11 113
QX(PUTREF+4)=QX(IREF+2)#               K(new)=k(i)-k(j)                 MA11 114
QX(PUTREF+5)=QX(IREF+3)#               L(new)=l(i)-l(j)                 MA11 115
CALL MA12(PUTREF,PUTPNT,PUTCON,REFBAD)# Get packed sorting word         MA11 116
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA11 117
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA11 118
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA11 119
#                                                                       MA11 120
IF(REFBAD==yes:)#                                                       MA11 121
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA11 122
writeline:(1,MA11A,NMA11A,3,1) ; writeline:(1,MA11B,NMA11B,3,1)#        MA11 123
IF(COMREF==yes:) iquit:(ma:1101)#                                       MA11 124
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA11 125
#                                                                       MA11 126
# SET THE CORRELATION STUDY REFLECTIONS AT THE BOTTOM OF                MA11 127
# MARKQ BEYOND THE HESSIANS BUT IN THE PLACE THAT WILL CAUSE THEM       MA11 128
# TO BE SORTED FOR REVERSE FOURIER TRANSFORM ORDER.                     MA11 129
# -----------------------------------------------------------------     MA11 130
#                                                                       MA11 131
DO I=1,CHKREF#                         Loop over correlation refls      MA11 132
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA11 133
PUTREF=PUTREF+STEPQ#                   Point to generated reflection    MA11 134
QX(PUTREF+6)=0.0 ; HOLDF=QX(PUTREF+7)# Sort pointer & save f obs        MA11 135
QX(PUTREF+7)=0.0#                      Temp for preparation for sort    MA11 136
CALL MA12(PUTREF,PUTPNT,PUTCON,REFBAD)# Get packed sorting word         MA11 137
QX(PUTREF+7)=-HOLDF#                   Store negative of f obs          MA11 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA11 139
#                                                                       MA11 140
#                                                                       MA11 141
# THE GENERATED REFLECTIONS MUST BE SORTED IN THE ORDER EXPECTED BY     MA11 142
# THE REVERSE FOURIER TRANSFORM SUBROUTINES.  THE POINTERS FOR          MA11 143
# USE IN FORMING THE A & B CALC NEEDED FOR THE HESSIAN MUST BE          MA11 144
# INITIALIZED SO THAT THE REFLECTIONS MAY BE REOBTAINED IN THE          MA11 145
# CORRECT ORDER IN SUBROUTINE MA80,THE REVERSE FOURIER TRANSFORM.       MA11 146
# -----------------------------------------------------------------     MA11 147
#                                                                       MA11 148
CALL MA13#                             Order the reflections            MA11 149
#                                                                       MA11 150
#                                                                       MA11 151
# REPORT OUT THE RESULTS OF THE SORT AND THE REFLECTIONS INVOLVED       MA11 152
# ---------------------------------------------------------------       MA11 153
#                                                                       MA11 154
IF(PRINTL>0)#                                                           MA11 155
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA11 156
LINRM=13;writeline:(1,MA11G,NMA11G,3,3) ;writeline:(0,MA11H,NMA11H,3,3)#MA11 157
writeline:(0,MA11I,NMA11I,3,3); writeline:(1,MA11C,NMA11C,3,3)# Linrm   MA11 158
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA11 159
DO I=1,3 ; HMAX(I)=-9999.0#            Set maxima                       MA11 160
FOR(I=MARKQ;I<STOPQ;I=I+STEPQ)#        Loop over all reflections        MA11 161
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA11 162
J=NINT(QX(I+6))#                       Point to refl in fourier order   MA11 163
IF(QX(I+7)>=0.0)#                      Is this phase shift info?        MA11 164
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MA11 165
PHASHF=MOD(NINT(QX(I+7)*0.01)+4800,12)# Get phase shift to hessian      MA11 166
BIJVO=NINT(AMOD(QX(I+7)*0.1,10.0))#    Get bijvoet signal               MA11 167
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MA11 168
DO K=1,3#                              Over h, k, & l                   MA11 169
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MA11 170
HHESS(K)=QX(I+K+2) ; HFOURR(K)=QX(J+K+2)# Get h, k, l both ways         MA11 171
IF(QX(I+7)>=0.0)#                      If not for correlation           MA11 172
HMAX(K)=AMAX1(HMAX(K),HHESS(K))#       Find biggest                     MA11 173
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MA11 174
IF(PRINTL<=0) NEXT#                    Skip if no printout              MA11 175
PRINTL=PRINTL-1#                       Decrement print limit            MA11 176
ncodefld:(HHESS,1,CHROT,FMT1,3)#       H,k,l as hessian sort goes       MA11 177
ncodefld:(HFOURR,1,CHROT,FMT2,3)#      H,k,l as reverse fourier goes    MA11 178
IF(QX(I+7)>=0.0)#                      For hessian reflections          MA11 179
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MA11 180
ncodefld:(SHIFT,PHASHF+1,CHROT,480512.,1)# Phase shift in degrees       MA11 181
movechar:(SIGNS,BIJVO+1,CHROT,34,1,0)# Append bijvoet phase shift       MA11 182
IF(AMOD(QX(I+7),10.0)>0.0)#            Test if user chosen refl         MA11 183
movechar:(MA11E,1,CHROT,18,NMA11E,0)#  And mark the chosen ones         MA11 184
ELSE movechar:(MA11J,1,CHROT,18,NMA11J,0)# Mark the generated ones      MA11 185
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MA11 186
ELSE movechar:(MA11K,1,CHROT,18,NMA11K,0)# Mark the ones for correln    MA11 187
writeline:(0,MA11D,NMA11D,1,3)#        Print line of intensities        MA11 188
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA11 189
ncodefld:(HMAX,1,MA11F,FMT1,3)#        H,k,l maxima in run              MA11 190
writeline:(1,MA11F,NMA11F,3,3)#        Print out maxima                 MA11 191
RETURN#                                                                 MA11 192
END#                                                                    MA11 193
systemheader:(MA12)## Find lowest cannonical form for reflections       MA12   1
# ################################################################## #  MA12   2
#                                                                    #  MA12   3
#                               MA12                                 #  MA12   4
#                                                                    #  MA12   5
# ################################################################## #  MA12   6
SUBROUTINE MA12(PUTREF,PUTPNT,PUTCON,REFBAD)## D.M.Collins J.M.Stewar   MA12   7
include:(AACOMN)#                      April 1990                       MA12   8
include:(MACOMN)#                                                       MA12   9
#                                                                       MA12  10
INTEGER BIJVO## Bijvoet signal rfourr to hessian representation         MA12  11
INTEGER FILIN1,FILIN2,FILIN3## For testing h, k, l against nyquist fr   MA12  12
REAL H(3)## Temporary storage of symmetry generated reflection          MA12  13
REAL HG(3)## Temporary storage of symmetry generated reflection         MA12  14
REAL HKL## Packed permuted value of h,k,l                               MA12  15
INTEGER H1,H2,H3## Integer value of reflection transposed for sorting   MA12  16
INTEGER IB## Bijvoit sign signal                                        MA12  17
INTEGER IHIT## Signal for search for rfourr to hessian transformation   MA12  18
INTEGER I,J,K## Loop index                                              MA12  19
REAL MINHKL## Minimum packed h, k, l                                    MA12  20
INTEGER PHASHF## (h)dot(t) to give phase shift from rfourr to hessian   MA12  21
INTEGER PUTCON## Pointer to storage place for packed cannonical hkl     MA12  22
INTEGER PUTPNT## Pointer to pointer for sorted packed cannonical hkl    MA12  23
INTEGER PUTREF## Pointer to reflection array in MARKQ                   MA12  24
INTEGER REFBAD## Flag to say reflection too high order for resolution   MA12  25
INTEGER SYMUSE## To keep track of symmetry operation used to get        MA12  26
##               lowest cannonical form from ref generated in hessian   MA12  27
##               building loop.                                         MA12  28
realdata:(FMT1,[60513.,120513.,180513.])# Refl format                   MA12  29
chardata:(MA12A,     H     K     L OUTSIDE INPUT MAP RESOLUTION)#       MA12  30
datastuff:#                                                             MA12  31
#                                                                       MA12  32
REFBAD=no:#                            All refls within resolution      MA12  33
DO K=1,3 ; BUFOT(K)=QX(PUTREF+K+2)#    Pick up h, k, l                  MA12  34
#                                                                       MA12  35
# TEST TO SEE IF ANY REFLECTIONS ARE OF TOO HIGH ORDER FOR THE          MA12  36
# RESOLUTION OF THE ELECTRON DENSITY MAP SUPPLIED.                      MA12  37
# ------------------------------------------------------------          MA12  38
#                                                                       MA12  39
FILIN1=NINT(BUFOT(RSUM1))#             Fix fast and permute it          MA12  40
FILIN2=NINT(BUFOT(RSUM2))#             Fix medium and permute it        MA12  41
FILIN3=NINT(BUFOT(RSUM3))#             Fix slow and permute it          MA12  42
#                                                                       MA12  43
# ELIMINATE UNKNOWABLE FC REFLECTIONS AND SET FLAG TO DIE               MA12  44
# -------------------------------------------------------               MA12  45
#                                                                       MA12  46
IF((IABS(FILIN1)>NYQF1)\$#             Refl outside map resolution      MA12  47
   (IABS(FILIN2)>NYQF2)\$#             Refl outside map resolution      MA12  48
   (IABS(FILIN3)>NYQF3))#              Refl outside map resolution      MA12  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA12  50
ncodefld:(BUFOT,1,CHROT,FMT1,3) ; writeline:(0,MA12A,NMA12A,2,1)#       MA12  51
REFBAD=yes:#                           Flag it as too high order        MA12  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA12  53
ELSE#                                  Reflection should be acceptibl   MA12  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA12  55
intpak:(0,MINHKL,0,mxbtwd:)#           Clear out previous reflectio     MA12  56
intpak:(1,MINHKL,30,1)#                Set sort packed hkl              MA12  57
PUTPNT=PUTPNT+1 ; PUTCON=PUTCON+1#     Increment storage pointers       MA12  58
QX(PUTPNT+1)=FLOAT(PUTREF)#            Save refl location pointer       MA12  59
#                                                                       MA12  60
#  REDUCE HKL LOWEST CANONICAL FORM                                     MA12  61
#  --------------------------------                                     MA12  62
#                                                                       MA12  63
FOR(K=MARKS;K<STOPS;K=K+STEPS)#        Loop over all symops             MA12  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA12  65
H(1)=BUFOT(1)*QX(K+1)+BUFOT(2)*QX(K+2)+BUFOT(3)*QX(K+3)# Transform h    MA12  66
H(2)=BUFOT(1)*QX(K+4)+BUFOT(2)*QX(K+5)+BUFOT(3)*QX(K+6)# Transform k    MA12  67
H(3)=BUFOT(1)*QX(K+7)+BUFOT(2)*QX(K+8)+BUFOT(3)*QX(K+9)# Transform l    MA12  68
H1=NINT(H(SORSLO))#                    Get slowest-varying index        MA12  69
H2=NINT(H(SORMED))#                    Get medium -varying index        MA12  70
H3=NINT(H(SORFAS))#                    Get fastest-varying index        MA12  71
#                                                                       MA12  72
IF((H1<0)$#                            H1 must be positive              MA12  73
\ ((H2<0)&(H1==0))$#                   H1=0 h2 negative                 MA12  74
\ ((H3<0)&(H1==0)&(H2==0)))#           H1=0 h2=0 h3 negative            MA12  75
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA12  76
H1=-H1; H2=-H2; H3=-H3; IB=1#          Reverse hkl set bijvoet          MA12  77
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA12  78
ELSE IB=0#                             Bijvoet sign not set             MA12  79
intpak:(0,HKL,0,mxbtwd:)#              Clear out previous reflection    MA12  80
intpak:(IABS(H1),HKL,21,bit:(21))#     Pack slow index                  MA12  81
intpak:(IB,HKL,0,1)#                   Bijvoet sign code                MA12  82
intpak:(IABS(H3),HKL, 3, 9)#           Pack fast index                  MA12  83
intpak:(IABS(H2),HKL,12, 9)#           Pack med  index                  MA12  84
IF(H3<0) intpak:(1,HKL, 1,1)#          Sign code for fas index          MA12  85
IF(H2<0) intpak:(1,HKL, 2,1)#          Sign code for med index          MA12  86
#                                                                       MA12  87
compakwd:(HKL,GE,MINHKL,NEXT)#         Is new packed hkl smaller        MA12  88
movepakwd:(HKL,MINHKL)#                Store smallest packed hkl        MA12  89
SYMUSE=IB+10*K#                        Keep track of symmetry move      MA12  90
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA12  91
#                                                                       MA12  92
#   NOW HAVE LOWEST CANONICAL FORM OF HKL. THIS FORM WILL BE STORED     MA12  93
#   FOR THE USE OF THE REVERSE FOURIER IN PICKING UP REFLECTIONS        MA12  94
#   AS THEY WHISTLE BY.  THE PHASE SHIFT INFORMATION TO GET BACK TO     MA12  95
#   THE PHASE OF THE REFLECTION GENERATED BY THE HESSIAN BUILDER MUST   MA12  96
#   ALSO BE SAVED.                                                      MA12  97
#   -----------------------------------------------------------------   MA12  98
#                                                                       MA12  99
movepakwd:(MINHKL,QX(PUTCON+1))#       Smallest packed hkl for sort     MA12 100
IB=MOD(SYMUSE,10)#                     Find bijvoet bit                 MA12 101
#                                                                       MA12 102
intunpak:(MINHKL,H1,21,9)#             Extract h1 index                 MA12 103
intunpak:(MINHKL, K, 0,1)#             Extract bijvoet sign             MA12 104
intunpak:(MINHKL,H2,12,9)#             Extract h2 index                 MA12 105
intunpak:(MINHKL,H3, 3,9)#             Extract h3 index                 MA12 106
intunpak:(MINHKL, I, 2,1)#             Extract h2 sign                  MA12 107
intunpak:(MINHKL, J, 1,1)#             Extract h3 sign                  MA12 108
#                                                                       MA12 109
IF(K>0)#                               Test h1 sign bit                 MA12 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA12 111
H1=-H1#                                Reverse h1 index                 MA12 112
IF(I==0) H2=-H2#                       Reverse h2 sign                  MA12 113
IF(J==0) H3=-H3#                       Reverse h3 sign                  MA12 114
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA12 115
ELSE#                                  If h1 bit not set                MA12 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA12 117
IF(I>0) H2=-H2#                        Reverse h2 sign                  MA12 118
IF(J>0) H3=-H3#                        Reverse h3 sign                  MA12 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA12 120
H(SORSLO)=H1;  H(SORMED)=H2;  H(SORFAS)=H3# Return hkl to ip order      MA12 121
IF(IB==1)#                             For negative hemisphere negate   MA12 122
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA12 123
H(1)=-H(1) ; H(2)=-H(2) ; H(3)=-H(3)#  Friedel it!                      MA12 124
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA12 125
#                                                                       MA12 126
# IN THE FOLLOWING LOOP THE H, K, L OF THE REFLECTION AS IT WILL COME   MA12 127
# FROM THE REVERSE FOURIER TRANSFORM IS RETRANSFORMED TO FIND WHICH     MA12 128
# SYMOP IS REQUIRED TO GIVE THE H, K, L OF THE REFLECTION REQUIRED IN   MA12 129
# THE GENERATION OF THE HESSIAN.  THIS WILL PERMIT THE DOT PRODUCT TO   MA12 130
# BE FORMED WHICH WILL GIVE THE PHASE SHIFT INFORMATION NEEDED TO       MA12 131
# PHASE SHIFT THE RFOURR REFLECTION TO THE HESSIAN REFLECTION.          MA12 132
# --------------------------------------------------------------------  MA12 133
#                                                                       MA12 134
IHIT=no:#                              Set search signal                MA12 135
FOR(K=MARKS;K<STOPS;K=K+STEPS)#        Loop over symops again           MA12 136
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA12 137
HG(1)=H(1)*QX(K+1)+H(2)*QX(K+2)+H(3)*QX(K+3)# Transform h               MA12 138
HG(2)=H(1)*QX(K+4)+H(2)*QX(K+5)+H(3)*QX(K+6)# Transform k               MA12 139
HG(3)=H(1)*QX(K+7)+H(2)*QX(K+8)+H(3)*QX(K+9)# Transform l               MA12 140
ifeq:(HG(1),QX(PUTREF+3))#             H indices equal?                 MA12 141
ifeq:(HG(2),QX(PUTREF+4))#             K indices equal?                 MA12 142
ifeq:(HG(3),QX(PUTREF+5))#             L indices equal?                 MA12 143
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MA12 144
IHIT=yes: ; BIJVO=0 ; BREAK#           Found it in positive hemispher   MA12 145
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MA12 146
ifeq:(-HG(1),QX(PUTREF+3))#            H indices equal?                 MA12 147
ifeq:(-HG(2),QX(PUTREF+4))#            K indices equal?                 MA12 148
ifeq:(-HG(3),QX(PUTREF+5))#            L indices equal?                 MA12 149
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MA12 150
IHIT=yes: ; BIJVO=1 ; BREAK#           Found it in negative hemispher   MA12 151
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MA12 152
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA12 153
IF(IHIT==no:) iquit:(ma:1202)#         There must be one that does it   MA12 154
PHASHF=NINT((H(1)*QX(K+10)+H(2)*QX(K+11)+H(3)*QX(K+12))*12.0)# Dot pr   MA12 155
PHASHF=MOD(PHASHF+9600,12)#            Phase shift positive mod 12      MA12 156
QX(PUTREF+7)=QX(PUTREF+7)+FLOAT(PHASHF*100+BIJVO*10)# Build signal wo   MA12 157
QX(PUTREF+3)=H(1) ; QX(PUTREF+4)=H(2) ; QX(PUTREF+5)=H(3)# Bdf hkl      MA12 158
#                                                                       MA12 159
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA12 160
IF(REFBAD==yes:&COMREF==yes:) iquit:(ma:1201)# Refls outside map res.   MA12 161
RETURN#                                                                 MA12 162
END#                                                                    MA12 163
systemheader:(MA13)## Sort reflections into normal RFOURR order         MA13   1
# ################################################################## #  MA13   2
#                                                                    #  MA13   3
#                               MA13                                 #  MA13   4
#                                                                    #  MA13   5
# ################################################################## #  MA13   6
SUBROUTINE MA13## D.M. Collins J.M. Stewart                             MA13   7
include:(AACOMN)#                      April 1990                       MA13   8
include:(MACOMN)#                                                       MA13   9
#                                                                       MA13  10
# ORIGINALLY FROM SORTRF  J.M. STEWART MAY 1983  S.R. HALL MAR 1984     MA13  11
#                                                                       MA13  12
INTEGER I,J,K,L,N#                                                      MA13  13
REAL QIQI#                             For macro swapqx                 MA13  14
chardata:(MA13B, NUMBER OF ELEMENTS IN HESSIAN MATRIX            )#     MA13  15
chardata:(MA13A, NUMBER OF REFLECTIONS SORTED FOR HESSIAN        )#     MA13  16
chardata:(MA13C, NUMBER OF LARGEST FOBS FOR CORRELATION          )#     MA13  17
datastuff:#                                                             MA13  18
#                                                                       MA13  19
ncodefld:(FLOAT(TOTREF),1,MA13A,480613.,1)# Format total refl           MA13  20
writeline:(1,MA13A,NMA13A,2,3)#        Print total reflections          MA13  21
ncodefld:(FLOAT(TOTHES),1,MA13B,480613.,1)# Total elements in hessian   MA13  22
writeline:(1,MA13B,NMA13B,2,3)#        Print total elements             MA13  23
ncodefld:(FLOAT(CHKREF),1,MA13C,480613.,1)# Format total refl           MA13  24
writeline:(1,MA13C,NMA13C,2,3)#        Print total corr reflections     MA13  25
#                                                                       MA13  26
LINRM=4#                               Force first column header        MA13  27
#                                                                       MA13  28
#  SORT THE REFLECTIONS                                                 MA13  29
#  SORT HKL IN MEMORY ON CANONICAL WORD                                 MA13  30
#  ------------------------------------                                 MA13  31
#                                                                       MA13  32
FOR(I=TOTREF+CHKREF;I!=0;I=I/2)#       This is a *shell sort*           MA13  33
FOR(J=MARKX+I+1;J<=STOPX;J=J+1)#       Which is very efficient for      MA13  34
FOR(K=J-I;K>MARKX;K=K-I)#              Large lists                      MA13  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA13  36
L=K+I#                                 Pointer with gap                 MA13  37
compakwd:(QX(K),LT,QX(L),BREAK)#       Compare canonical words          MA13  38
swapakwd:(QX(K),QX(L))#                Exchange packed words            MA13  39
swapqx:(K+TOTREF+CHKREF,L+TOTREF+CHKREF)# Exchange order addresses      MA13  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA13  41
#                                                                       MA13  42
N=MARKQ-STEPQ#                         Point to generated refl array    MA13  43
FOR(L=MARKY;L<STOPY;L=L+1)#            Loop over sorted addresses       MA13  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA13  45
N=N+STEPQ#                             Advance through reflections      MA13  46
movepakwd:(QX(L+1),QX(N+6))#           Save sort address in refl arra   MA13  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA13  48
#                                                                       MA13  49
RETURN#                                                                 MA13  50
END#                                                                    MA13  51
systemheader:(MA20)#                   Maximum entropy density survey   MA20   1
# ################################################################## #  MA20   2
#                                                                    #  MA20   3
#                               MA20                                 #  MA20   4
#                                                                    #  MA20   5
# ################################################################## #  MA20   6
SUBROUTINE MA20## D.M. Collins J.M. Stewart                             MA20   7
IMPLICIT NONE#                                                          MA20   8
include:(AACOMN)#                      March 1990                       MA20   9
include:(MACOMN)#                                                       MA20  10
#                                                                       MA20  11
#***  TAKEN FROM SUBROUTINES MESIGNS, FIXFFT AND COLUMN WHICH WERE      MA20  12
#***  WRITTEN BY E. PRINCE, NATIONAL BUREAU OF STANDARDS. SEPT, 1989.   MA20  13
# TO TAKE ADVANTAGE OF THE INCREASE OF RESOLUTION IN THE NEW DENSITY,   MA20  14
# THE GRID ON WHICH THE DENSITY IS SAMPLED MUST BE APPROPRIATELY        MA20  15
# FINE.                                                                 MA20  16
#                                                                       MA20  17
REAL DENLIM(3)## El-dens statistics                                     MA20  18
INTEGER FLAGIT## Flag for holes in input electron density               MA20  19
INTEGER I,II## Local indices for loops etc.                             MA20  20
REAL    LNRHO#      ## Ln(rho) at a given pixel, rho in electrons/pix   MA20  21
INTEGER PSIZ,IP## I/o pointers                                          MA20  22
REAL Q## Temporary variables for statistics                             MA20  23
REAL RHO## Electron density during processing                           MA20  24
REAL SOED## Original sum for constraint one                             MA20  25
REAL SOED2## Original sum for constraint two                            MA20  26
REAL V## Normalized density variance                                    MA20  27
INTEGER X1,X2,X3## Layer, down the layer, across the layer coordinate   MA20  28
chardata:(MA7D, SUM OF ELECTRON DENS =             $#                   MA20  29
SUM OF SQUARED =             )#                                         MA20  30
chardata:(MA7F,[   MAP MAX       MIN       AVE  VARIANCE    $#          MA20  31
PIXELS  VOL A**3  F(0,0,0)   LN(MAX)   LN(MIN) LN(MA/MI)])#             MA20  32
chardata:(MA7I, THE INPUT MAP IS ILL CONDITIONED SINCE )#               MA20  33
chardata:(MA7J, THE VARIANCE OF THE ELECTRON DENSITY IS $#              MA20  34
OUTSIDE THE RANGE 0.0001 THRU 0.9999.)#                                 MA20  35
chardata:(MA20A,[ ****W*A*R*N*I*N*G**** THE INPUT MAP HAS HOLES!  $#    MA20  36
IS IT A PROPER MEDENS MAP?])#                                           MA20  37
realdata:(FMTV,[650642.,770642.])#                                      MA20  38
realdata:(FMT7,[341031.,631031.])#                                      MA20  39
realdata:(FMT8,[100941.,200941.,300941.,400941.,500913.,600941.,$#      MA20  40
700912.,800942.,900942.,1000942.])#                                     MA20  41
realdata:(VARLOW,[0.0001])#            Low end of map variance          MA20  42
realdata:(VARHIG,[0.9999])#            High end of map variance         MA20  43
datastuff:#                                                             MA20  44
#                                                                       MA20  45
# INITIALIZE COUNTS, NUMBERS OF POINTS IN SUMMATIONS                    MA20  46
# --------------------------------------------------                    MA20  47
#                                                                       MA20  48
DENLIM(1)=-99999. ; DENLIM(2)=99999. ; DENLIM(3)=0.0# El-den stats      MA20  49
SOED=0.0 ; SOED2=0.0#                  Initialize constraint sums       MA20  50
#                                                                       MA20  51
# SET THE LOG OF THE SCALE FACTOR WHICH WILL CARY ELECTRON DENSITY IN   MA20  52
# ELECTRONS/CUBIC ANGSTROM INTO ELECTRONS/PIXEL FROM THIS SUBROUTINE    MA20  53
# ONWARD THE VALUE OF RHO WILL BE SCALED ON THIS COMPUTATIONAL BASIS    MA20  54
# ------------------------------------------------------------------    MA20  55
#                                                                       MA20  56
LNRHSC=ALOG(VOL/TOTPIX)#               Set logarithmic scale factor     MA20  57
LNRHMX=-9999.0 ; LNRHMN=9999.0 ; FLAGIT=no:# Gather extremes            MA20  58
#                                                                       MA20  59
# TOP OF LOOPS OVER LINES AND LAYERS TO PROCESS ELECTRON DENSITY        MA20  60
# --------------------------------------------------------------        MA20  61
#                                                                       MA20  62
IF(PRIUSE==no:) STOPM=MARKM#           Set storage of ln(rho) prior     MA20  63
DO X1=1,NX1#                           Loop over layers                 MA20  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA20  65
DO X2=1,NX2#                           Loop over pages                  MA20  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA20  67
readwpkt:(4,22,PSIZ,IP,0)#             Read next line                   MA20  68
IF(IP<=0) BREAK#                       Quit if all layers done          MA20  69
IF(PRIUSE==yes:) writepkt:(6,22,PSIZ,II)# Write next line to file f     MA20  70
I=IP#                                  Set pointer for prior el-densi   MA20  71
DO X3=1,NX3#                           Loop across line                 MA20  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA20  73
I=I+1 ; RHO=QX(I)#                     Bump pointers and pick up rho    MA20  74
IF(RHO<=0.0)#                          Can't allow zero or negatives    MA20  75
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA20  76
RHO=RHOTHR#                            Stuff arbitrary small amount     MA20  77
IF(FLAGIT==no:)#                                                        MA20  78
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA20  79
writeline:(1,MA20A,NMA20A,3,1) ; FLAGIT=yes:# Warning of bad values     MA20  80
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA20  81
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA20  82
LNRHO=ALOG(RHO/RESCAL)/SHARPF+LNRHSC#  Convert 'prior' to ln(rho)       MA20  83
#                                                                       MA20  84
# FIND SUMMATIONS TO GIVE STATISTICS                                    MA20  85
# ----------------------------------                                    MA20  86
#                                                                       MA20  87
LNRHMN=AMIN1(LNRHMN,LNRHO);LNRHMX=AMAX1(LNRHMX,LNRHO)# Get min/max      MA20  88
DENLIM(3)=DENLIM(3)+RHO#               Build statistics                 MA20  89
DENLIM(1)=AMAX1(RHO,DENLIM(1)) ; DENLIM(2)=AMIN1(RHO,DENLIM(2))#        MA20  90
SOED=SOED+RHO ; SOED2=SOED2+RHO**2#    Total dens and square            MA20  91
IF(PRIUSE==yes:)#                      Ln(rho) prior on file f?         MA20  92
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA20  93
II=II+1 ; QX(II)=LNRHO#                Ln(rho) prior on file f          MA20  94
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA20  95
ELSE#                                  Ln(rho) prior in memory          MA20  96
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA20  97
STOPM=STOPM+1 ; QX(STOPM)=LNRHO#       Save the ln(rho) in memory       MA20  98
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA20  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA20 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA20 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA20 102
readwpkt:(4,endrecord:,PSIZ,IP,0)#     Finish off medens file           MA20 103
IF(PRIUSE==yes:) writepkt:(6,endrecord:,PSIZ,IP)# Finish ln(rho) file   MA20 104
#                                                                       MA20 105
# AT THE END OF READING THE WHOLE MAP GIVE ELECTRON-DENSITY STATS       MA20 106
# ---------------------------------------------------------------       MA20 107
#                                                                       MA20 108
DENLIM(3)=DENLIM(3)/FLOAT(NPIX)#       Find ave el-dens                 MA20 109
CNTRST=LNRHMX-LNRHMN#                  Set contrast of 'prior' map      MA20 110
CNTRSP=CNTRST#                         Save as contrast of "prior"      MA20 111
LNRHMP=LNRHMN#                         Log(rho min) 'prior' ma31/ma60   MA20 112
Q=(SOED**2)/TOTPIX#                    Q=sum( el.den)**2 per pixel      MA20 113
V=(SOED2-Q)/SOED2#                     Soed2=sum( ed**2)                MA20 114
DO I=1,3 ; BUFOT(I)=DENLIM(I)#                                          MA20 115
BUFOT(4)=V ; BUFOT(5)=TOTPIX ; BUFOT(6)=VOL#                            MA20 116
BUFOT(7)=F000 ; BUFOT(8)=LNRHMX ; BUFOT(9)=LNRHMN ; BUFOT(10)=CNTRST#   MA20 117
ncodefld:(BUFOT,1,CHROT,FMT8,10) ; writeline:(1,MA7F,NMA7F,2,2)#        MA20 118
#                                                                       MA20 119
# CHECK THE DENSITY FUNCTION FOR SUITABILITY                            MA20 120
# ------------------------------------------                            MA20 121
#                                                                       MA20 122
IF(V<VARLOW\V>VARHIG)#                 Variance must lie in [0,1]       MA20 123
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA20 124
BUFOT(1)=SOED ; BUFOT(2)=SOED2#        Display sums                     MA20 125
ncodefld:(BUFOT,1,MA7D,FMT7,2) ; writeline:(1,MA7D,NMA7D,3,1)#          MA20 126
writeline:(1,MA7I,NMA7I,3,1) ; BUFOT(1)=VARLOW ; BUFOT(2)=VARHIG#       MA20 127
ncodefld:(BUFOT,1,MA7J,FMTV,2) ; writeline:(0,MA7J,NMA7J,3,1)#          MA20 128
iquit:(ma:2001)#                       If variance extreme              MA20 129
#                                      I.e., if dens flat or spiky      MA20 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA20 131
#                                                                       MA20 132
# PLACE ALL THE CONSTANT DATA IN THE ARRAYS REQUIRED BY MA30 & BEYOND   MA20 133
# -------------------------------------------------------------------   MA20 134
#                                                                       MA20 135
RETURN#                                                                 MA20 136
END#                                                                    MA20 137
systemheader:(MA25)## Expand phased reflections & refine moduli         MA25   1
#********************************************************************** MA25   2
#                                                                     # MA25   3
#                             MA25                                    # MA25   4
#                                                                     # MA25   5
#********************************************************************** MA25   6
SUBROUTINE MA25## J.M. Stewart, D.M. Collins Jul 1990                   MA25   7
IMPLICIT NONE#                                                          MA25   8
include:(AACOMN)#                                                       MA25   9
include:(MACOMN)#                                                       MA25  10
INTEGER I,L#        ## Do loop indices, misc. applications              MA25  11
chardata:(MA25A, EXTEND PHASES AND FIT MODULI OF GENERAL REFLECTIONS.)# MA25  12
datastuff:#                                                             MA25  13
LINRM=8 ;writeline:(1,MA25A,NMA25A,3,3)# Announce purpose of run        MA25  14
writeline:(1,0,0,1,3) ; LINRM=5#       And a couple of blank lines      MA25  15
#                                                                       MA25  16
# PLACE INPUT PHASES IN WORKING ARRAY FOR MA31                          MA25  17
# --------------------------------------------                          MA25  18
#                                                                       MA25  19
I=MARKR ; DO L=1,NREF#                 Loop over reflections            MA25  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA25  21
I=I+STEPR ; QX(I+8)=QX(I+6) ; QX(I+9)=QX(I+7)# Move phases              MA25  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA25  23
#                                                                       MA25  24
# CALL FITTING SUBROUTINE TO DEVELOP PHASES AND FORCE MODULI TO MATCH   MA25  25
# -------------------------------------------------------------------   MA25  26
#                                                                       MA25  27
SIGNC=6 ; CALL MA31#                                                    MA25  28
#                                                                       MA25  29
# CALL TO PUT OUT UPDATED PHASES & CONSTRAINED EXPONENTIAL E. D. MAP    MA25  30
# ------------------------------------------------------------------    MA25  31
#                                                                       MA25  32
CALL MA29#                                                              MA25  33
#                                                                       MA25  34
RETURN#                                                                 MA25  35
END#                                                                    MA25  36
systemheader:(MA26)## Oscillate centric reflections like mesign does    MA26   1
#********************************************************************** MA26   2
#                                                                     # MA26   3
#                             MA26                                    # MA26   4
#                                                                     # MA26   5
#********************************************************************** MA26   6
SUBROUTINE MA26## J.M. Stewart, D.M. Collins Jul 1990                   MA26   7
IMPLICIT NONE#                                                          MA26   8
include:(AACOMN)#                                                       MA26   9
include:(MACOMN)#                                                       MA26  10
INTEGER I,K,L,M,N#      ## Do loop indices, misc. applications          MA26  11
INTEGER STILCH## Signal that phases still changing in search            MA26  12
chardata:(MA26L,[ THE MAXIMUM CRITERION,           , OCCURED AT $#      MA26  13
TRIAL    WITH ENTROPY               AND CORRELATION            ])#      MA26  14
realdata:(FMTB,[341182.,550313.,821182.,1091182.])#                     MA26  15
datastuff:#                                                             MA26  16
ONTEST=0#                              Get ready to search              MA26  17
writeline:(1,0,0,1,3) ; LINRM=5#       Add a couple of blank lines      MA26  18
#                                                                       MA26  19
# PLACE INPUT PHASES IN WORKING ARRAY FOR MA31                          MA26  20
# --------------------------------------------                          MA26  21
#                                                                       MA26  22
I=MARKR ; DO L=1,NREF#                 Loop over reflections            MA26  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA26  24
I=I+STEPR ; QX(I+8)=QX(I+6) ; QX(I+9)=QX(I+7)# Move phases              MA26  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA26  26
#                                                                       MA26  27
# MAKE A PRELIMINARY RUN TO ESTABLISH BASELINE ENTROPY                  MA26  28
# ----------------------------------------------------                  MA26  29
#                                                                       MA26  30
SIGNC=10 ; CALL MA31 ; CRIBES=CRITER#  Establish entropy criterion      MA26  31
ONMAX=ONTEST#                          Point to best entropy trial      MA26  32
BESENT=ENTRPY ; BESCOR=CORREL#         Save in case no change           MA26  33
#                                                                       MA26  34
# TRY ALL NODES ADJACENT TO THE 'BEST' ONE.                             MA26  35
# -----------------------------------------                             MA26  36
#                                                                       MA26  37
N=1 ; STILCH=yes:#                     Prepare for just 16 tries        MA26  38
IF(EXTEST==yes:) N=NREF#               Unless user says all 256         MA26  39
FOR(M=1;M<=N;M=M+1)#                   Loop as much as required         MA26  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA26  41
IF(STILCH==no:) BREAK#                 But stop on no phase changes     MA26  42
STILCH=no: ; K=MARKR ; DO I=1,NREF#    Make inner pass over 16          MA26  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA26  44
K=K+STEPR ; ONTEST=ONTEST+1#                                            MA26  45
IF(QX(K+15)>=64.0) NEXT#               Skip fixed reflections           MA26  46
QX(K+8)=-QX(K+8) ; QX(K+9)=-QX(K+9)#   Get supplement of ith phase      MA26  47
#                                                                       MA26  48
# CALL TO FIT MODULI FOR EACH TESTED REFLECTION IN TURN                 MA26  49
# ----------------------------------------------------------            MA26  50
#                                                                       MA26  51
SIGNC=11 ; CALL MA31#                  And try another fit              MA26  52
#                                                                       MA26  53
IF(CRITER>CRIBES)#                     Save new maximum                 MA26  54
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA26  55
ONMAX=ONTEST ;  CRIBES=CRITER ; STILCH=yes:# Got better; mark event     MA26  56
BESENT=ENTRPY ; BESCOR=CORREL#         Save values at best criterion    MA26  57
QX(K+6)=QX(K+8) ; QX(K+7)=QX(K+9)#     Register change in main list     MA26  58
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA26  59
ELSE#                                  Flip phase back; no improvemen   MA26  60
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA26  61
QX(K+8)=-QX(K+8) ; QX(K+9)=-QX(K+9)#   Restore ith phase                MA26  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA26  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA26  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA26  65
#                                                                       MA26  66
# CALL TO PUT OUT THE UPDATED BINARY DATA FILE AND THE ENHANCED MAP     MA26  67
# -----------------------------------------------------------------     MA26  68
#                                                                       MA26  69
SIGNC=5 ; CALL MA29#                                                    MA26  70
#                                                                       MA26  71
# PRINT OUT CHOSEN PHASE SET AND THE ENTROPY OF THE CORRESPONDING MAP   MA26  72
# -------------------------------------------------------------------   MA26  73
#                                                                       MA26  74
BUFOT(1)=CRIBES ; BUFOT(2)=FLOAT(ONMAX)# Point to best entropy trial    MA26  75
BUFOT(3)=BESENT ; BUFOT(4)=BESCOR#                                      MA26  76
ncodefld:(BUFOT,1,MA26L,FMTB,4) ; writeline:(2,MA26L,NMA26L,3,2)#       MA26  77
#                                                                       MA26  78
#                                                                       MA26  79
RETURN#                                                                 MA26  80
END#                                                                    MA26  81
systemheader:(MA27)#                   Refine general phases            MA27   1
#********************************************************************** MA27   2
#                                                                     # MA27   3
#                             MA27                                    # MA27   4
#                                                                     # MA27   5
#********************************************************************** MA27   6
SUBROUTINE MA27## J.M. Stewart, D.M. Collins July 1990                  MA27   7
IMPLICIT NONE#                                                          MA27   8
include:(AACOMN)#                                                       MA27   9
include:(MACOMN)#                                                       MA27  10
INTEGER BEST1#      ## Pointer to best phase step                       MA27  11
REAL    CBEST,SBEST## Cosine and sine of best phase                     MA27  12
REAL    CORHI,CORLO## Max and min correlation in search around circle   MA27  13
REAL    ENTHI,ENTLO## Max and min entropy in search around circle       MA27  14
INTEGER I,KK,L,M#   ## Do loop indices, misc. applications              MA27  15
INTEGER NUMJMP#     ## Number of steps to shift non restricted phases   MA27  16
INTEGER NUMJMQ#     ## Number of steps to shift phases per reflection   MA27  17
REAL    ONBEST#     ## Search angle of best phase                       MA27  18
REAL    PHICOR#     ## Phase when correlation at a maximum              MA27  19
REAL    PHIENT#     ## Phase when entropy is at a maximum               MA27  20
REAL    PHAJMQ#     ## Phase angle change during stepping               MA27  21
REAL    ROOT2#      ## Square root of two                               MA27  22
REAL    SAMEC#      ## Count of times thhat entropy is the same         MA27  23
chardata:(MA27A, STEP SEARCH FOR PHASES OF GENERAL REFLECTIONS.)#       MA27  24
chardata:(MA27B,[    H   K   L  PHASE    CRITERION     ENTROPY $#       MA27  25
CORRELATION  ENT SPREAD CORR SPREAD  D(PHI)   ENT PRIOR N CORR   $#     MA27  26
AVE FO   AVE FC])#                                                      MA27  27
realdata:(FMTR,[50413.,90413.,130413.,200413.,331161.,451161.,$# M      MA27  28
571161.,691161.,811161.,890512.,1011161.,1080713.,1170821.,1260821.])#  MA27  29
realdata:(RESTR,[0.0,30.0,45.0,60.0,90.0,120.0,135.0,150.0])# Centric   MA27  30
datastuff:#                                                             MA27  31
ROOT2=SQRT(2.0)#                       Establish root 2                 MA27  32
LINRM=8 ;writeline:(1,MA27A,NMA27A,3,3)# Announce purpose of run        MA27  33
writeline:(1,0,0,1,3) ; LINRM=5#       And a couple of blank lines      MA27  34
NUMJMP=INT((360.0-PHAJMP)/PHAJMP)+1## From 0 to (360 - phajmp) degree   MA27  35
#                                                                       MA27  36
# PLACE INPUT PHASES IN WORKING ARRAY FOR MA31                          MA27  37
# --------------------------------------------                          MA27  38
#                                                                       MA27  39
I=MARKR ; DO L=1,NREF#                 Loop over reflections            MA27  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA27  41
I=I+STEPR ; QX(I+8)=QX(I+6) ; QX(I+9)=QX(I+7)# Move phases              MA27  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA27  43
#                                                                       MA27  44
CRIBES=-9999.0#                        Establish entropy criterion      MA27  45
BESENT=CRIBES ; BESCOR=CRIBES#         And other statistics             MA27  46
ENTHI=CRIBES ; ENTLO=9999.0 ; CORHI=CRIBES ; CORLO=ENTLO#               MA27  47
#                                                                       MA27  48
# LOOP OVER ALL REFLECTIONS IN TURN                                     MA27  49
# ---------------------------------                                     MA27  50
#                                                                       MA27  51
I=MARKR ; DO L=1,NREF#                                                  MA27  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA27  53
I=I+STEPR ; SAMEC=1.0#                 Reset count of = entropy cases   MA27  54
IF(QX(I+15)>=64.0) NEXT#               Skip fixed phase reflections     MA27  55
BEST1=1 ; ONTEST=0#                    Reset best try and trial count   MA27  56
IF(QX(I+15)<=0.0)#                     Test for non restricted phase    MA27  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA27  58
ONPHAS=-PHAJMP ; PHAJMQ=PHAJMP ; NUMJMQ=NUMJMP# Set for stepping        MA27  59
PHIENT=0.0 ; PHICOR=0.0#               Default phis at maxima           MA27  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA27  61
ELSE#                                  Phase is a restricted one        MA27  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA27  63
M=NINT(QX(I+15)) ; ONPHAS=RESTR(M)-180.0# Set starting phase            MA27  64
PHIENT=RESTR(M) ; PHICOR=PHIENT#       Default phis at maxima           MA27  65
PHAJMQ=180.0 ; NUMJMQ=2#               Just two possible values         MA27  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA27  67
DO M=1,NUMJMQ#                         Loop over appropriate number     MA27  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA27  69
ONPHAS=ONPHAS+PHAJMQ#                  Move to next check angle         MA27  70
QX(I+8)=COS(DETORA*ONPHAS) ; QX(I+9)=SIN(DETORA*ONPHAS)# Set trig       MA27  71
#                                                                       MA27  72
# CALL FITTING SUBROUTINE TO USE PHASE AND FORCE MODULI TO MATCH        MA27  73
# --------------------------------------------------------------        MA27  74
#                                                                       MA27  75
SIGNC=7 ; ONTEST=ONTEST+1 ; CALL MA31#                                  MA27  76
ENTHI=AMAX1(ENTHI,ENTRPY);ENTLO=AMIN1(ENTLO,ENTRPY)# Capture entropy    MA27  77
CORHI=AMAX1(CORHI,CORREL);CORLO=AMIN1(CORLO,CORREL)# Capture correl'n   MA27  78
#                                                                       MA27  79
## If there are several maps which give equal values for the criterion  MA27  80
## Then calculate the phase angle to be at the center of the region     MA27  81
## of equality. Only for non-restricted (general) reflections.          MA27  82
#  -------------------------------------------------------------------  MA27  83
#                                                                       MA27  84
IF(QX(I+15)<=0.0)#                     Must be a general reflection     MA27  85
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA27  86
ifeq:(CRITER,CRIBES)#                                                   MA27  87
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA27  88
SAMEC=SAMEC+1.0#                       Count the event                  MA27  89
IF(SAMEC>1.0&(ONPHAS-ONBEST)<180.0)#   Look out for negative angles     MA27  90
ONBEST=(ONBEST*(SAMEC-1.0)+ONPHAS)/SAMEC# Get advancing average         MA27  91
ELSE#                                  Split by being near 0 and 360    MA27  92
ONBEST=AMOD((((ONBEST*(SAMEC-1.0)+ONPHAS-360.0)/SAMEC)+360.0),360.0)#   MA27  93
CBEST=COS(DETORA*ONBEST) ; SBEST=SIN(DETORA*ONBEST)# Set trig functs    MA27  94
BEST1=ONTEST#                          Keep track of step number        MA27  95
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA27  96
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA27  97
ELSE IF(M==1)#                         Must initialize best on 1st      MA27  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA27  99
ONBEST=ONPHAS;IBEST=M#                 For centrics                     MA27 100
CBEST=QX(I+8);SBEST=QX(I+9);BEST1=ONTEST#                               MA27 101
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA27 102
#                                                                       MA27 103
## Check to see if entropy criterion goes up on this trial              MA27 104
#  -------------------------------------------------------              MA27 105
#                                                                       MA27 106
IF(CRITER>CRIBES)#                     Maximum entropy/correlation      MA27 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MA27 108
CRIBES=CRITER ; IBEST=M#               Capture the moment               MA27 109
CBEST=QX(I+8) ; SBEST=QX(I+9) ; ONBEST=ONPHAS# Including phase used     MA27 110
BEST1=ONTEST#                          And step where it occured        MA27 111
CALL MA02(CBEST,SBEST)#                Keep centrics honest             MA27 112
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MA27 113
IF(ENTRPY>BESENT)#                     Seek best entropy itself         MA27 114
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MA27 115
BESENT=ENTRPY ; PHIENT=ONPHAS#         And remember where it comes      MA27 116
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MA27 117
IF(CORREL>BESCOR)#                     Seek best correlation itself     MA27 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MA27 119
BESCOR=CORREL ; PHICOR=ONPHAS#         And remember where it comes      MA27 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MA27 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA27 122
#                                                                       MA27 123
# CAPTURE THE BEST PHASE FOR THIS REFLECTION FOR POSTERITY              MA27 124
# --------------------------------------------------------              MA27 125
#                                                                       MA27 126
QX(I+8)=CBEST ; QX(I+6)=CBEST ; QX(I+9)=SBEST ; QX(I+7)=SBEST#          MA27 127
DO KK=1,3 ; BUFOT(KK)=QX(I+KK) ; BUFOT(4)=RATODE*ATAN2(SBEST,CBEST)#    MA27 128
BUFOT(4)=AMOD(BUFOT(4)+360.0,360.0)#   Get clean phase                  MA27 129
BUFOT(5)=CRIBES ; BUFOT(6)=BESENT ; BUFOT(7)=BESCOR ; LINRM=4#          MA27 130
BUFOT(8)=ENTHI-ENTLO ; BUFOT(9)=CORHI-CORLO# Get spreads in params      MA27 131
BUFOT(10)=RATODE*ACOS(COS(DETORA*(PHIENT-PHICOR)))# Angle between max   MA27 132
BUFOT(11)=ENPRIO#                      Get entropy of "prior"           MA27 133
BUFOT(12)=SUREF ; BUFOT(13)=MEANFO ; BUFOT(14)=MEANFC# Correl ref sta   MA27 134
ncodefld:(BUFOT,1,CHROT,FMTR,14);writeline:(0,MA27B,NMA27B,2,2);LINRM=4#MA27 135
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA27 136
#                                                                       MA27 137
# CALL TO PUT OUT UPDATED PHASES & CONSTRAINED EXPONENTIAL E. D. MAP    MA27 138
# ------------------------------------------------------------------    MA27 139
#                                                                       MA27 140
SIGNC=8 ; ONPHAS=ONBEST ; ONTEST=BEST1 ; CALL MA29# Make final map      MA27 141
#                                                                       MA27 142
RETURN#                                                                 MA27 143
END#                                                                    MA27 144
systemheader:(MA29)## Output of refined phases and map                  MA29   1
#********************************************************************** MA29   2
#                                                                     # MA29   3
#                             MA29                                    # MA29   4
#                                                                     # MA29   5
#********************************************************************** MA29   6
SUBROUTINE MA29## J.M. Stewart Jun 1990                                 MA29   7
include:(AACOMN)#                                                       MA29   8
include:(MACOMN)#                                                       MA29   9
#                                                                       MA29  10
REAL HKL(3)#                           Floating h,k,l                   MA29  11
INTEGER IHKLT(3),IH(3)#                Temporary for h,k,l              MA29  12
INTEGER K,L#                           Loop indicies                    MA29  13
INTEGER PSIZ,IP,PSIZO#                 I/o stuff                        MA29  14
chardata:(MA30D,[ PHASES OF MEPHAS DETERMINED REFLECTIONS PLACED $#     MA29  15
IN OUTPUT BINARY DATA FILE...... ])#                                    MA29  16
chardata:(MA30E,[ PREVIOUSLY DETERMINED REFLECTION F CALC AND PHASES $# MA29  17
CARRIED FORWARD UNCHANGED])#                                            MA29  18
chardata:(MA30F,[    H    K    L   PHASE     FOBS      FCALC       $#   MA29  19
R%    STATUS])#                                                         MA29  20
chardata:(MA120,[HELD FIXED])#                                          MA29  21
chardata:(MA121,[TEST PHASE])#                                          MA29  22
chardata:(MA122,[ UNPHASED REFLECTION SAMPLE CORRELATION    N$#         MA29  23
REF    AVE FO     AVE FC])#                                             MA29  24
realdata:(FMTR,[50513.,100513.,150513.,230413.,331022.,431022.,$#       MA29  25
531022.])#                             Reflection output                MA29  26
realdata:(FMTC,[381261.,460613.,561032.,671032.])#                      MA29  27
datastuff:#                                                             MA29  28
#                                                                       MA29  29
# NOW DO THE ULTIMATE RUN USING THE PHASES DETERMINED ABOVE.  THIS      MA29  30
# WILL PUT OUT AN UPDATED CONSTRAINED EXPONENTIAL ELECTRON DENSITY      MA29  31
# MAP ON THE SAME SCALE AS THE 'PRIOR' MAP FROM MEDENS OR THIS          MA29  32
# PROGRAM.                                                              MA29  33
# REDETERMINE THE PRINCE"S DUAL FUNCTION MULTIPLIERS IN ORDER TO        MA29  34
# MAKE THE NEXT CONSTRAINED EXPONENTIAL ELECTRON DENSITY MAP WHICH      MA29  35
# INCLUDES THE NEWLY DETERMINED REFLECTIONS.                            MA29  36
# ------------------------------------------------------------------    MA29  37
#                                                                       MA29  38
IF(SIGNC!=6)#                          Unless it's a simple fitting     MA29  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA29  40
MITERA=MAX0(35,MITERA) ; CALL MA31#    Redetermine max entropy map      MA29  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA29  42
FINFIT=yes: ; CALL MA50#               Make final map                   MA29  43
#                                                                       MA29  44
# UPDATE THE BINARY DATA FILE WITH THE FINAL PHASE SET                  MA29  45
# ----------------------------------------------------                  MA29  46
#                                                                       MA29  47
copyfile:(1,2,1,decr:(lrrefl:))#       Copy first records               MA29  48
IWANT(1)=1#                            Get h, k, l                      MA29  49
IWANT(2)=DSET+700#                     Phase in cycles                  MA29  50
IWANT(3)=DSET+800 ; IWANT(4)=DSET+911# |f calc| & mephas signal         MA29  51
KEY(1)=1 ; KEY(2)=4 ; KEY(3)=4 ; KEY(4)=0# Signal indexpkt:             MA29  52
indexpkt:(1,lrrefl:,PSIZ,IP,2,KEY,IWANT,IREL)# Get what's there         MA29  53
#                                                                       MA29  54
PSIZO=KEY(4)#                                                           MA29  55
#                                                                       MA29  56
LINRM=8 ; writeline:(2,MA30D,NMA30D,3,2)# Print the phases that         MA29  57
writeline:(0,MA30E,NMA30E,3,2) ; LINRM=5# Go to the file                MA29  58
REPEAT#                                Search through reflections       MA29  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA29  60
readwpkt:(1,lrrefl:,PSIZ,IP,0)#        Read input bdf                   MA29  61
IF(IP<=0) BREAK#                       Quitting at end of reflexions    MA29  62
writepkt:(2,lrrefl:,PSIZO,JP)#         Write packet to file b           MA29  63
movereal:(QX,IP+1,QX,JP+1,PSIZ,0)#     Copy preexisting datums          MA29  64
#                                                                       MA29  65
## If the reflection has been phased previously by MEPHAS the quantity  MA29  66
## in word IP+IREL(4) will be 2.0, the signal that this program         MA29  67
## assigned it.  If this word is zero or less (voidflg:) it             MA29  68
## means that the value of FC and the phase should be set to voidflg:   MA29  69
## so that RFOURR will treat it as freshly unknown. The reflections     MA29  70
## being treated in this run will be marked as treated for future use   MA29  71
## in choosing reflections for correlation tests in subroutine MA10.    MA29  72
#                                                                       MA29  73
IF(PHASED==yes:)#                      Make sure signal is in bdf       MA29  74
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA29  75
IF(QX(IP+IREL(4))<=0.0)#               Refl not previously det'ned?     MA29  76
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA29  77
IF(IREL(2)>0) QX(JP+IREL(2))=voidflg:# Nuke the phase                   MA29  78
IF(IREL(3)>0) QX(JP+IREL(3))=voidflg:# Nuke the |fc|                    MA29  79
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA29  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA29  81
gethkl:(IP+IREL(1),HKL)#               Pick up h, k, & l                MA29  82
DO K=1,3 ; IHKLT(K)=NINT(HKL(K))#      Fix h,k,l for search in bdf      MA29  83
#                                                                       MA29  84
# LOOK FOR REFLECTION IN MEMORY TO MATCH ONE IN BDF AND PUT OUT FCALC   MA29  85
# -------------------------------------------------------------------   MA29  86
#                                                                       MA29  87
L=MARKR ; FOR(K=1;K<=NREF;K=K+1)#      Search chosen reflections        MA29  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA29  89
L=L+STEPR ; IH(1)=NINT(QX(L+1))#       Integerize hkl for testing       MA29  90
IH(2)=NINT(QX(L+2)) ; IH(3)=NINT(QX(L+3))#                              MA29  91
IF(IH(1)!=IHKLT(1)\IH(2)!=IHKLT(2)\$#  Match?                           MA29  92
IH(3)!=IHKLT(3)) NEXT#                 Find the treated reflections     MA29  93
BUFOT(1)=RATODE*ATAN2(QX(L+7),QX(L+6))# Form phase in degree            MA29  94
BUFOT(1)=AMOD(BUFOT(1)+360.0,360.0)#   Make angle positive              MA29  95
BUFOT(2)=QX(L+4) ; BUFOT(3)=QX(L+10)#  Get f obs & f calc               MA29  96
BUFOT(4)=100.0*ABS(BUFOT(2)-BUFOT(3))/AMAX1(0.01,BUFOT(2))# R/refl      MA29  97
ncodefld:(HKL,1,CHROT,FMTR,3) ; ncodefld:(BUFOT,1,CHROT,FMTR(4),4)#     MA29  98
IF(QX(L+15)>=64.0) movechar:(MA120,1,CHROT,57,NMA120,0)# Fixed phase?   MA29  99
ELSE movechar:(MA121,1,CHROT,57,NMA121,0)# Phase being tested           MA29 100
writeline:(0,MA30F,NMA30F,1,2)#                                         MA29 101
IF(IREL(2)>0)#                         Phases in bdf?                   MA29 102
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA29 103
QX(JP+IREL(2))=BUFOT(1)/360.0#         Phase in cycles for bdf          MA29 104
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA29 105
IF(IREL(3)>0)#                         | f calc| in bdf?                MA29 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA29 107
QX(JP+IREL(3))=QX(L+10)#               Put out pseudo |f calc|          MA29 108
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA29 109
#                                                                       MA29 110
## If the phase has been generated by this program, MEPHAS, put a       MA29 111
## signal in the BDF to show that this is the case. If the program has  MA29 112
## been used simply to fit moduli, i.e. the MEFIT mode, preserve the    MA29 113
## phase source.                                                        MA29 114
## Codes 1., 2., 3., 4.,... for MESTAR, MEPHAS, MIR, RFOURR,.....       MA29 115
#  ------------------------------------------------------------------   MA29 116
#                                                                       MA29 117
IF(IREL(4)>0&MEFIT==no:)#              Signal in bdf & not fitting?     MA29 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA29 119
QX(JP+IREL(4))=2.0#                    Signal = phase set by this pgm   MA29 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA29 121
BREAK#                                 Go to next bdf reflection        MA29 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA29 123
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA29 124
BUFOT(1)=CORREL ; BUFOT(2)=SUREF ; BUFOT(3)=MEANFO ; BUFOT(4)=MEANFC#   MA29 125
ncodefld:(BUFOT,1,CHROT,FMTC,4); writeline:(1,MA122,NMA122,2,2)#        MA29 126
writeline:(0,0,0,3,2)#                 Write a couple of blank lines    MA29 127
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Copy last records             MA29 128
#                                                                       MA29 129
RETURN#                                                                 MA29 130
END#                                                                    MA29 131
systemheader:(MA30)#                   Drive determination of signs     MA30   1
# ################################################################## #  MA30   2
#                                                                    #  MA30   3
#                               MA30                                 #  MA30   4
#                                                                    #  MA30   5
# ################################################################## #  MA30   6
SUBROUTINE MA30#                       D.m.collins j.m.stewart          MA30   7
include:(AACOMN)#                      March 1990                       MA30   8
include:(MACOMN)#                                                       MA30   9
#                                                                       MA30  10
#***  TAKEN FROM SUBROUTINE MESIGNS WHICH WAS                           MA30  11
#***  WRITTEN BY E. PRINCE, NATIONAL BUREAU OF STANDARDS. SEPT, 1989.   MA30  12
#                                                                       MA30  13
REAL    CRINEG## Entropy/correlation criterion in 'negative' trial      MA30  14
REAL    CRIPOS## Entropy/correlation criterion in 'positive' trial      MA30  15
REAL    DENT(16)## Working storage for entropy differences              MA30  16
REAL    ENTNEG## Entropy found in 'negative' trial                      MA30  17
REAL    ENTPOS## Entropy found in 'positive' trial                      MA30  18
INTEGER I,J,K,L,M,N## Loop indices & pointers                           MA30  19
INTEGER STILCH## Signal that phases still changing in final search      MA30  20
REAL    ISBEST#     ## Signal +1/-1 for sign trial at maximum entropy   MA30  21
chardata:(MA30A,FIND MAXIMUM ENTROPY PHASE COMBINATION.)#               MA30  22
chardata:(MA30J,[ RESULTS OF APPLICATION OF YATES` ALGORITHM])#         MA30  23
chardata:(MA30K,[    H    K    L   PHASE  ENTROPY DIFFERENCE  SIGN $#   MA30  24
SHIFT])#                                                                MA30  25
realdata:(FMTR,[50513.,100513.,150513.,230413.,401272.,540512.])# Ref   MA30  26
chardata:(MA30L,[ THE MAXIMUM CRITERION,         , OCCURED AT $#        MA30  27
TRIAL    WITH ENTROPY            AND CORRELATION            ])#         MA30  28
chardata:(MA30M,[ THE 16 YEATS DIFFERENCES....])#                       MA30  29
chardata:(MA30N,[ THE 8 YEATS SUMS OF DIFFERENCES AND THE 8 $#          MA30  30
DIFFERENCES OF DIFFERENCES....])#                                       MA30  31
realdata:(FMTB,[320962.,530313.,771062.,1041062.])#                     MA30  32
realdata:(FMYE1,[131261.,261261.,391261.,521261.,651261.,781261.,$#     MA30  33
911261.,1041261.])#                                                     MA30  34
INTEGER NCYC,NPOINT## Pointers for yates' algorithm                     MA30  35
REAL SS#                                                                MA30  36
datastuff:#                                                             MA30  37
LINRM=8 ;writeline:(1,MA30A,NMA30A,3,3)# Announce purpose of run        MA30  38
writeline:(1,0,0,1,3) ; LINRM=5#       And a couple of blank lines      MA30  39
CRIBES=-100000. ; ONTEST=0#            Set entropy criterion to start   MA30  40
DO COMBIN=1,16#                        All sign combinations            MA30  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA30  42
L=0 ; K=MARKR ; DO J=1,NREF#           All reflections treated          MA30  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA30  44
K=K+STEPR ; IF(QX(K+15)>=64.0)#        Advance through refl'n array     MA30  45
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA30  46
QX(K+8)=QX(K+6) ; QX(K+9)=QX(K+7)#     Move fixed to working array      MA30  47
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA30  48
ELSE#                                  It's one of the 16 centrics      MA30  49
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA30  50
L=L+1#                                 Advance through sign combos      MA30  51
QX(K+8)=QX(K+6)*ORTHOV(L,COMBIN)#      Set working cosine of phase      MA30  52
QX(K+9)=QX(K+7)*ORTHOV(L,COMBIN)#      Set working sine of phase        MA30  53
CALL MA02(QX(K+8),QX(K+9))#            Keep on exact centric values     MA30  54
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA30  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA30  56
#                                                                       MA30  57
# CALL TO FIT THE MODULI WITH THE 'POSITIVE' TRIAL PHASES               MA30  58
# -------------------------------------------------------               MA30  59
#                                                                       MA30  60
ONTEST=ONTEST+1 ;SIGNC=1 ; CALL MA31#  Call to fit + signs              MA30  61
CRIPOS=CRITER ; ENTPOS=ENTRPY#         Save entropy criterion           MA30  62
IF(CRITER>CRIBES)#                     Seek maximum among 'positive'    MA30  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA30  64
CRIBES=CRITER ; IBEST=COMBIN ; ISBEST=+1.0 ; ONMAX=ONTEST# What's bes   MA30  65
BESENT=ENTRPY ; BESCOR=CORREL#         Save values at best criterion    MA30  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA30  67
K=MARKR ; DO J=1,NREF#                 For all reflections phased       MA30  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA30  69
K=K+STEPR ; IF(QX(K+15)>=64.0) NEXT#                                    MA30  70
QX(K+8)=-1.0*QX(K+8) ; QX(K+9)=-1.0*QX(K+9)# Set phase to supplement    MA30  71
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA30  72
#                                                                       MA30  73
# CALL TO FIT THE MODULI WITH THE 'NEGATIVE' TRIAL PHASES               MA30  74
# -----------------------------------------------------------           MA30  75
#                                                                       MA30  76
ONTEST=ONTEST+1 ; SIGNC=2 ; CALL MA31# Call to fit - of current combi   MA30  77
CRINEG=CRITER ; ENTNEG=ENTRPY#         Save entropy from fit            MA30  78
IF(CRITER>CRIBES)#                     Test to see if entropy rose      MA30  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA30  80
CRIBES=CRITER ; IBEST=COMBIN ; ISBEST=-1.0 ; ONMAX=ONTEST# Keep recor   MA30  81
BESENT=ENTRPY ; BESCOR=CORREL#         Save values at best criterion    MA30  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA30  83
#                                                                       MA30  84
# SAVE THE DIFFERENCE IN ENTROPY BETWEEN THE TRIAL PHASES AND THEIR     MA30  85
# SUPPLEMENTS FOR USE IN YATES ALGORITHM.                               MA30  86
# ------------------------------------------------------------------    MA30  87
#                                                                       MA30  88
IF(YATENT==yes:)#                      Either entropy or criterion      MA30  89
QX(MDENT+COMBIN)=ENTPOS-ENTNEG## Find the diff. between + and -         MA30  90
ELSE QX(MDENT+COMBIN)=CRIPOS-CRINEG## Find the diff. between + and -    MA30  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA30  92
#                                                                       MA30  93
# USE "YATES' ALGORITHM" TO UNSCRAMBLE.                                 MA30  94
# -------------------------------------                                 MA30  95
#                                                                       MA30  96
#NCYC=INT(ALOG(FLOAT(NREF))/ALOG(2.)+0.2)# NUMBER OF CYCLES IN GENRL    MA30  97
#NPOINT=NREF/2#                        NUMBER OF POINTS IN GENERAL      MA30  98
NCYC=4 ; NPOINT=8#                     Cycles and points for mesigns    MA30  99
DO I=1,16 ; DENT(I)=QX(MDENT+I)#       Move entropy differences         MA30 100
DO I=1,NCYC#                                                            MA30 101
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA30 102
DO J=1,NPOINT#                         Over table of entropy diffs      MA30 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MA30 104
QX(MWRK1+J)=DENT(2*J-1)+DENT(2*J)#     2 pnt fft in npoint dimensions   MA30 105
QX(MWRK1+NPOINT+J)=DENT(2*J-1)-DENT(2*J)# First sums then differences   MA30 106
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MA30 107
DO J=1,16 ; DENT(J)=QX(MWRK1+J)#       Reset differences                MA30 108
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA30 109
#                                                                       MA30 110
# COMPUTE THE ENTROPY OF THE BEST SIGN COMBINATION                      MA30 111
# ------------------------------------------------                      MA30 112
#                                                                       MA30 113
IF(PPRIOR>3)#                                                           MA30 114
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MA30 115
LINRM=8;writeline:(1,MA30J,NMA30J,3,4)# Publish yates` result           MA30 116
DO K=1,16 ; BUFOT(K)=QX(MDENT+K)#                                       MA30 117
ncodefld:(BUFOT,1,CHROT,FMYE1,8) ; writeline:(1,MA30M,NMA30M,2,4)#      MA30 118
ncodefld:(BUFOT,9,CHROT,FMYE1,8) ; writeline:(0,0,0,1,4)#               MA30 119
ncodefld:(DENT,1,CHROT,FMYE1,8) ; writeline:(1,MA30N,NMA30N,2,4)#       MA30 120
ncodefld:(DENT,9,CHROT,FMYE1,8) ; writeline:(0,0,0,1,4) ; LINRM=5#      MA30 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MA30 122
K=MARKR ; M=0 ; DO I=1,NREF#                                            MA30 123
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MA30 124
K=K+STEPR ; IF(QX(K+15)>=64.0) NEXT#                                    MA30 125
M=M+1#                                                                  MA30 126
IF(DENT(M)<0.0) SS=-1.0#               If difference of difference      MA30 127
ELSE SS=1.0#                           Negative set sign shift -        MA30 128
# PHIW(1,I)=PHI(1,I)*SS ; PHIW(2,I)=PHI(2,I)*SS                         MA30 129
QX(K+8)=SS*QX(K+6) ; QX(K+9)=SS*QX(K+7)# Set working cosine and sine    MA30 130
CALL MA02(QX(K+8),QX(K+9))#            Keep centrics under control      MA30 131
IF(PPRIOR>3)#                          Dump yates stuff; print wanted   MA30 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MA30 133
BUFOT(4)=RATODE*ATAN2(QX(K+9),QX(K+8))# Form phase in degrees           MA30 134
BUFOT(4)=AMOD(BUFOT(4)+360.0,360.0)#   Make angle positive              MA30 135
DO L=1,3 ; BUFOT(L)=QX(K+L)#           Pick up miller indices           MA30 136
BUFOT(5)=QX(MDENT+I) ; BUFOT(6)=SS ; ncodefld:(BUFOT,1,CHROT,FMTR,6)#   MA30 137
writeline:(0,MA30K,NMA30K,1,4)#        Publish yates' results           MA30 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MA30 139
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MA30 140
#                                                                       MA30 141
# CALL TO FIT THE MODULI FOR THE YATES' RESULT PHASES                   MA30 142
# ---------------------------------------------------                   MA30 143
#                                                                       MA30 144
ONTEST=ONTEST+1 ; SIGNC=3 ; CALL MA31# Get fit to get entropy           MA30 145
#                                                                       MA30 146
# AT THIS POINT THE MAXIMUM ENTROPY MAY COME FROM THE YATES' RESULT OR  MA30 147
# MAY HAVE OCCURED DURING THE SEARCH ABOVE: SEE WHICH.                  MA30 148
# --------------------------------------------------------------------  MA30 149
#                                                                       MA30 150
IF(CRITER>CRIBES)#                     Check for new maximum            MA30 151
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MA30 152
ONMAX=ONTEST ; CRIBES=CRITER#          Yates produced the maximum       MA30 153
BESENT=ENTRPY ; BESCOR=CORREL#         Save values at best criterion    MA30 154
K=MARKR ; DO L=1,NREF#                                                  MA30 155
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MA30 156
K=K+STEPR ; IF(QX(K+15)>=64.0) NEXT#                                    MA30 157
#                                                                       MA30 158
# RESET STARTING COS AND SIN OF PHASE TO PHASE FROM YATES' ALGORITHM    MA30 159
# ------------------------------------------------------------------    MA30 160
#                                                                       MA30 161
QX(K+6)=QX(K+8) ; QX(K+7)=QX(K+9)#     Set cos(phi)/sin(phi) yates      MA30 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MA30 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MA30 164
#                                                                       MA30 165
# THE MAXIMUM ENTROPY WAS SEEN IN THE CYCLING AT THE BEGINNING          MA30 166
# ------------------------------------------------------------          MA30 167
#                                                                       MA30 168
ELSE#                                  Yates' not the maximum           MA30 169
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MA30 170
K=MARKR ; M=0 ; DO I=1,NREF#           Set phases based on max ent      MA30 171
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MA30 172
K=K+STEPR ; IF(QX(K+15)>=64.0) NEXT#                                    MA30 173
M=M+1#                                                                  MA30 174
QX(K+6)=QX(K+6)*ISBEST*ORTHOV(M,IBEST)# Set cosine of phase             MA30 175
QX(K+7)=QX(K+7)*ISBEST*ORTHOV(M,IBEST)# Set sine of phase               MA30 176
CALL MA02(QX(K+6),QX(K+7))#            Keep centric values on target    MA30 177
QX(K+8)=QX(K+6) ; QX(K+9)=QX(K+7)#     Set working values the same      MA30 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MA30 179
CRITER=CRIBES ; SIGNC=9 ; K=ONTEST ; ONTEST=ONMAX# Set to max trial     MA30 180
ENTRPY=BESENT ; CORREL=BESCOR#         Values for good print out        MA30 181
CALL MA33 ; ONTEST=K#                  Print that run & restore trial   MA30 182
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MA30 183
#                                                                       MA30 184
# TRY ALL NODES ADJACENT TO THE 'BEST' ONE.                             MA30 185
# -----------------------------------------                             MA30 186
#                                                                       MA30 187
N=1 ; STILCH=yes:#                     Prepare for just 16 tries        MA30 188
IF(EXTEST==yes:) N=16#                 Unless user says all 256         MA30 189
FOR(M=1;M<=N;M=M+1)#                   Loop as much as required         MA30 190
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MA30 191
IF(STILCH==no:) BREAK#                 But stop on no phase changes     MA30 192
STILCH=no: ; K=MARKR ; DO I=1,NREF#    Make inner pass over 16          MA30 193
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MA30 194
K=K+STEPR ; IF(QX(K+15)>=64.0) NEXT#                                    MA30 195
QX(K+8)=-QX(K+8) ; QX(K+9)=-QX(K+9)#   Get supplement of ith phase      MA30 196
#                                                                       MA30 197
# CALL TO FIT MODULI FOR EACH TESTED REFLECTION IN TURN                 MA30 198
# ----------------------------------------------------------            MA30 199
#                                                                       MA30 200
ONTEST=ONTEST+1 ; SIGNC=4 ; CALL MA31# And try another fit              MA30 201
#                                                                       MA30 202
IF(CRITER>CRIBES)#                     Save new maximum                 MA30 203
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MA30 204
ONMAX=ONTEST ;  CRIBES=CRITER ; STILCH=yes:# Phase flipped; mark even   MA30 205
BESENT=ENTRPY ; BESCOR=CORREL#         Save values at best criterion    MA30 206
QX(K+6)=QX(K+8) ; QX(K+7)=QX(K+9)#     Register change in main list     MA30 207
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MA30 208
ELSE#                                  Flip phase back; no improvemen   MA30 209
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MA30 210
QX(K+8)=-QX(K+8) ; QX(K+9)=-QX(K+9)#   Restore ith phase unchanged      MA30 211
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MA30 212
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MA30 213
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MA30 214
#                                                                       MA30 215
# CALL TO PUT OUT THE UPDATED BINARY DATA FILE AND THE ENHANCED MAP     MA30 216
# -----------------------------------------------------------------     MA30 217
#                                                                       MA30 218
SIGNC=5 ; CALL MA29#                                                    MA30 219
#                                                                       MA30 220
# PRINT OUT CHOSEN PHASE SET AND THE ENTROPY OF THE CORRESPONDING MAP   MA30 221
# -------------------------------------------------------------------   MA30 222
#                                                                       MA30 223
BUFOT(1)=CRIBES ; BUFOT(2)=FLOAT(ONMAX)# Point to best entropy trial    MA30 224
BUFOT(3)=BESENT ; BUFOT(4)=BESCOR#                                      MA30 225
ncodefld:(BUFOT,1,MA30L,FMTB,4) ; writeline:(2,MA30L,NMA30L,3,2)#       MA30 226
#                                                                       MA30 227
RETURN#                                                                 MA30 228
END#                                                                    MA30 229
systemheader:(MA31)#                   Fit |f max ent| to be |f obs|    MA31   1
# ################################################################## #  MA31   2
#                                                                    #  MA31   3
#                               MA31                                 #  MA31   4
#                                                                    #  MA31   5
# ################################################################## #  MA31   6
SUBROUTINE MA31## D.M. Collins J.M. Stewart                             MA31   7
IMPLICIT NONE#                                                          MA31   8
include:(AACOMN)## March 1990                                           MA31   9
include:(MACOMN)#                                                       MA31  10
#                                                                       MA31  11
#***  TAKEN FROM SUBROUTINE FITFFT WHICH WAS                            MA31  12
#***  WRITTEN BY E. PRINCE, NATIONAL BUREAU OF STANDARDS. SEPT, 1989.   MA31  13
#                                                                       MA31  14
#********************************************************************** MA31  15
# SUBROUTINE FITFFT(RHO,NX,NXD,NY,NYD,NZ,NZD,X,M,IH,PHI,FOBS,TOL        MA31  16
# 1,CECT,EC,SCALC,BUFF,ENT)                                             MA31  17
#                                                                       MA31  18
# CALCULATE THE MAXIMUM ENTROPY DENSITY DISTRIBUTION, AND ITERATE       MA31  19
# TO FIND A FEASIBLE POINT. ARGUMENTS WERE:                             MA31  20
# ---------------------------------------------------------------       MA31  21
#                                                                       MA31  22
#     RHO   - SCALED INPUT MAP THIS RESIDES IN THE QX ARRAY BETWEEN     MA31  23
#             MARKM +1 AND STOPM                                        MA31  24
#     NX    - NUMBER OF PIXELS IN X DIRECTION                           MA31  25
#     NXD   - DENOMINATOR OF FRACTION OF X IN ASYMMETRIC UNIT           MA31  26
#     NY    - NUMBER OF PIXELS IN Y DIRECTION                           MA31  27
#     NYD   - DENOMINATOR OF FRACTION OF Y IN ASYMMETRIC UNIT           MA31  28
#     NZ    - NUMBER OF PIXELS IN Z DIRECTION                           MA31  29
#     NZD   - DENOMINATOR OF FRACTION OF Z IN ASYMMETRIC UNIT           MA31  30
#     X     - VECTOR OF LOGARITHMS FOR INDEPENDENT VARIABLES            MA31  31
#     M     - NUMBER OF REFLECTIONS TO BE MATCHED (NOW NREF)            MA31  32
#     IH    - INDICES OF REFLECTIONS TO BE MATCHED                      MA31  33
#     PHI   - PHASES OF REFLECTIONS TO BE MATCHED                       MA31  34
#     FOBS  - OBSERVED FS OF REFLECTIONS                                MA31  35
#     TOL   - TOLERANCE FOR FIT (NOW SIGMA)                             MA31  36
#     CECT  - WORKSPACE FOR MATRIX OF PARTIAL DERIVATIVES               MA31  37
#     EC    - WORKSPACE FOR VECTOR-WEIGHTED ROW SUMS OF C (NOW FCCSDA)  MA31  38
#     SCALC - WEIGHTED SINE SUMS  (NOW FCSNDA)                          MA31  39
#     BUFF  - BUFFER FOR COLUMNS OF C AND SINE COEFFICIENTS             MA31  40
#             (NOW WORK1, WORK2, WORK3, WORK4, & WORK5)                 MA31  41
#     ENT   - ENTROPY OF MAP CORRESPONDING TO X (NOW ENTRPY)            MA31  42
#                                                                       MA31  43
# IN XTAL THE VARIABLES ARE CARRIED IN COMMON.  BECAUSE OF THE FACT     MA31  44
# THAT THE FOURIER MAY BE CALCULATED IN ANY ORDER THE NX, NY, AND NZ    MA31  45
# ARE HANDLED DIFFERENTLY. NOTED ABOVE ARE CERTAIN VARIABLE NAME CHANGE MA31  46
# MADE DURING TRANSLATION TO BRING THE VARIABLE NAMES INTO              MA31  47
# CORRESPONDENCE IN THE CALLING ROUTINES AND THEIR SUBROUTINES.         MA31  48
#                                                                       MA31  49
EXTERNAL MA41 ; REAL MA41## Function to get length of vector            MA31  50
REAL    ABEST#      ## Shift factor in secant method to find            MA31  51
REAL    ALPHA0#     ## zero of line derivative                          MA31  52
REAL    ALPHA1#     ## "                                                MA31  53
REAL    AVERHO#     ## Average value of rho i. e. sumrho                MA31  54
INTEGER BRAKET#     ## Signal two derivs bracket zero during secant f   MA31  55
REAL    DELPHI#     ## Shift in phase in radians from fitting           MA31  56
REAL    DELTA#      ## Shift for secant refinement                      MA31  57
REAL    DENOM#      ## Denominator of delta shift fasctor               MA31  58
REAL    DERHI#      ## Largest value of derivative during secant fit    MA31  59
REAL    DERINI#     ## Begining value of deriv dot product in sec fit   MA31  60
REAL    DERNOW#     ## Current value of a line derivative in the sear   MA31  61
#                   ## direction. The dot product of the search         MA31  62
#                   ## direction and the gradient.                      MA31  63
REAL    ENTP2,ENTP3## Partial entropy sums; to foil register errors     MA31  64
REAL    GBEST#      ## Min value up to current cycle of the Euclidian   MA31  65
#                   ## norm of the gradient used in the secant fit.     MA31  66
INTEGER I,J,K,L,LL# ## Do loop indices, misc. applications              MA31  67
INTEGER LASTIM#     ## Signal for final, cleanup fitting iteration      MA31  68
REAL    LNRHO#      ## Ln(rho) at a given pixel, rho in electrons/pix   MA31  69
INTEGER NOTOK#      ## Signal 'not o.k.' which is true until the valu   MA31  70
#                   ## of all Fcalcs is within the delta(F) tolerance.  MA31  71
REAL    NUMER#      ## Numerator of delta shift factor                  MA31  72
REAL    PHIOLD#     ## Original phase in radians                        MA31  73
INTEGER PSIZ## I/O pointers                                             MA31  74
REAL    RDEN,RNUM#  ## Sums to get R to say if Hessian needs rebuildi   MA31  75
REAL    RHO#        ## Antilog of LNRHO on e/pixel scale                MA31  76
REAL    RHOCN2,RHOCN3## Partial "contrast" e. d. sums; foil errors      MA31  77
REAL    RHOCU2,RHOCU3## Partial cubed e. d. sums; foil overflow         MA31  78
REAL    RHOP2,RHOP3## Partial e. d. sums; to foil register errors       MA31  79
REAL    ROOT2#      ## Square root of two                               MA31  80
REAL    SDOT#       ## Register for accumulating a dot product          MA31  81
REAL    SECTES#     ## Used to see if secant method or BFGS used        MA31  82
INTEGER X1,X2#      ## Loop indices in the three sum directions         MA31  83
chardata:(MA31A,[ ENTROPY OF PRIOR MAP IS               ])#             MA31  84
datastuff:#                                                             MA31  85
#                                                                       MA31  86
NITERA=1#                              Iterations fitting x vector      MA31  87
LASTIM=no:#                            It is not yet the last iterati   MA31  88
LNFOFC=0.0#                            Rescale of 'prior' map to 1.0    MA31  89
GBEST=0.0 ; ABEST=0.0#                                                  MA31  90
ENTRPY=0.0 ; SUMRHO=0.0#               Zero the entropy & sum of rho    MA31  91
SUMRCN=0.0 ; SUMRCU=0.0#               Sum of rho contrast and cubed    MA31  92
ROOT2=SQRT(2.0)#                       Establish root 2                 MA31  93
#                                                                       MA31  94
# SET FIRST AND LAST CONSTRAINT MULTIPLIER TO LOG(RHO MIN) AND          MA31  95
# LOG((RHO MAX)/(RHO MIN)) RESPECTIVLY.                                 MA31  96
# ------------------------------------------------------------          MA31  97
#                                                                       MA31  98
DO I=1,NREF ; QX(MXNEW+I+1)=0.0## Clear Prince's dual function mults    MA31  99
QX(MXNEW+1)=CNTRSP ; QX(MXNEW+NREF+2)=LNRHMP ; LNRHMN=LNRHMP#           MA31 100
#                                                                       MA31 101
DO I=1,TOTHES ; QX(MHESS+I)=0.0## Clear matrix of partial derivatives   MA31 102
#                                                                       MA31 103
# START OF MAIN LOOP.                                                   MA31 104
# ------------------                                                    MA31 105
#                                                                       MA31 106
REPEAT#                                                                 MA31 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA31 108
L=MARKR-STEPR ; DO I=1,NREF+2#                                          MA31 109
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA31 110
L=L+STEPR ; QX(L+13)=0.0#              Zero |fc|cos(alpha c - phi)      MA31 111
QX(L+14)=0.0#                          Zero |fc|sin(alpha c - phi)      MA31 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA31 113
NOTOK=no:#                             Not 'not o.k.'; think about it   MA31 114
#                                                                       MA31 115
# ON THE FIRST ITERATION MAKE THE SUMS NEEDED TO ESTABLISH THE ENTROPY  MA31 116
# ON SUBSEQUENT ITERATIONS THESE SUMS ARE CALCULATED IN MA60, THE       MA31 117
# FORWARD FOURIER TRANSFORM SUBROUTINE.                                 MA31 118
# --------------------------------------------------------------------  MA31 119
#                                                                       MA31 120
IF(NITERA==1)#                         Establish entropy iteration 1    MA31 121
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA31 122
L=MARKM ; LL=MARKN#                    Point to maps in memory          MA31 123
#                                                                       MA31 124
DO X1=1,NX1#                           Loop over layers                 MA31 125
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA31 126
ENTP2=0.0 ; RHOP2=0.0#                 Prepare for partial sums of      MA31 127
RHOCN2=0.0 ; RHOCU2=0.0#               Entropy, rho, contrast, rho**3   MA31 128
DO X2=1,NX2#                           Loop over pages                  MA31 129
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA31 130
ENTP3=0.0 ; RHOP3=0.0#                 Prepare for partial sums of      MA31 131
RHOCN3=0.0 ; RHOCU3=0.0#               Entropy, rho, contrast, rho**3   MA31 132
IF(PRIUSE==yes:) readwpkt:(6,22,PSIZ,L,0)# Next line of ln(rho) prior   MA31 133
IF(CORUSE==yes:) writepkt:(7,22,PSIZ,LL)# Line of rho correction        MA31 134
DO J=1,NX3#                            Loop across line                 MA31 135
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA31 136
L=L+1 ; LL=LL+1#                       Advance to next pixel            MA31 137
#                                                                       MA31 138
# L POINTS TO A PIXEL OF THE 'PRIOR' MAP; LL TO THE MAP BEING 'FITTED'  MA31 139
# IN THIS PROGRAM THE ELECTRON DENSITY, RHO, IS ALWAYS THE TRUE         MA31 140
# ELECTRON DENSITY TIMES VOL/TOTPIX.  THAT IS, ELECTRONS PER PIXEL      MA31 141
# INSTEAD OF ELECTRONS PER CUBIC ANGSTROM.                              MA31 142
# --------------------------------------------------------------------  MA31 143
#                                                                       MA31 144
LNRHO=QX(L)#                           Take ln(rho) prior               MA31 145
RHO=EXP(LNRHO)#                        Restore rho  e/pixel             MA31 146
ENTP3=ENTP3-RHO*LNRHO#                 Contribute pixel value to entr   MA31 147
RHOP3=RHOP3+RHO#                       Sum will be fc000 if all well    MA31 148
RHOCN3=RHOCN3+RHO*((LNRHO-LNRHMN)/CNTRST)**2# Sum builds contrast ter   MA31 149
##                                     to refine FC(0,0,0)              MA31 150
RHOCU3=RHOCU3+RHO**3#                  Sum gives measure of features    MA31 151
#                                                                       MA31 152
# IN PREPARATION FOR THE REVERSE FOURIER TRANSFORM STORE THE ELECTRON   MA31 153
# DENSITY IN ELECTRONS PER PIXEL TO PRODUCE FC VALUES FOR THE NREF      MA31 154
# REFLECTIONS BEING PHASED.                                             MA31 155
# -------------------------------------------------------------------   MA31 156
#                                                                       MA31 157
QX(LL)=RHO#                            Save the new density for next    MA31 158
#                                                                       MA31 159
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA31 160
ENTP2=ENTP2+ENTP3 ; RHOP2=RHOP2+RHOP3# Build partial sums to avoid      MA31 161
RHOCN2=RHOCN2+RHOCN3 ; RHOCU2=RHOCU2+RHOCU3# Register overflow          MA31 162
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA31 163
ENTRPY=ENTRPY+ENTP2 ; SUMRHO=SUMRHO+RHOP2# Again protect against        MA31 164
SUMRCN=SUMRCN+RHOCN2 ; SUMRCU=SUMRCU+RHOCU2# Register overflow          MA31 165
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA31 166
IF(PRIUSE==yes:) readwpkt:(6,endrecord:,PSIZ,L,0)# Rewind prior         MA31 167
IF(CORUSE==yes:) writepkt:(7,endrecord:,PSIZ,LL)# End file              MA31 168
#                                                                       MA31 169
## Set up the first row of the Hessian matrix in order to provide for   MA31 170
## the refinement of the contrast term. SUMRHO is current FC(0,0,0)     MA31 171
#                                                                       MA31 172
QX(MHESS+1)=SUMRHO ; QX(MHESS+NREF+2)=SUMRCN# First and last element    MA31 173
QX(MARKR+13)=SUMRHO#                   A(0,0,0) in reflection array     MA31 174
#                                                                       MA31 175
## This is done as an approximation in two respects.  First, the rho    MA31 176
## values should be weighted depending upon whether they are located    MA31 177
## on an edge (w=0.25), in a face (w=.50), or in the bulk of the map    MA31 178
## (w=1.0). In this implementation these weights are ignored.           MA31 179
## Second, the elements from QX(MHESS+2) through QX(MHESS+NREF+1) are   MA31 180
## left as zero.  Strictly, they should be weighted by a space group    MA31 181
## specific function.  Since this function is sinusoidal in nature,     MA31 182
## having both + and - terms the sums will be small with respect to     MA31 183
## the sum of rho**2 and the sum of rho.                                MA31 184
#                                                                       MA31 185
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA31 186
#SPECIAL TEST OF SQUARED FUNCTION                                       MA31 187
#DO L=MARKN+1,STOPN-1 ; QX(L)=QX(L)**2#                                 MA31 188
#CALL MA80#                                                             MA31 189
#DO L=MARKN+1,STOPN-1 ; QX(L)=SQRT(QX(L))#                              MA31 190
#WRITE(6,*)' ====> MEANFO MEANFC CORREL ',MEANFO,MEANFC,CORREL#         MA31 191
#END SPECIAL TEST                                                       MA31 192
#                                                                       MA31 193
# COMPUTE THE STRUCTURE FACTORS BY REVERSE FOURIER TRANSFORM            MA31 194
# THIS WILL GIVE F CALCULATED AS COS & SIN (ALPHA- PHI(INPUT))          MA31 195
# ------------------------------------------------------------          MA31 196
#                                                                       MA31 197
CALL MA80#                             Call reverse fourier transform   MA31 198
#                                                                       MA31 199
K=MARKR-STEPR ; DO L=1,NREF+1#                                          MA31 200
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA31 201
K=K+STEPR#                             Refresh the f calc terms         MA31 202
# FCCSDA(L+1)=ACALC(L)*PHIW(1,L)+BCALC(L)*PHIW(2,L)# COSINE TERM        MA31 203
QX(K+13)=QX(K+11)*QX(K+8)+QX(K+12)*QX(K+9)# |fc|cos(alpha c - phi)      MA31 204
# FCSNDA(L+1)=BCALC(L)*PHIW(1,L)-ACALC(L)*PHIW(2,L)# SINE TERM          MA31 205
QX(K+14)=QX(K+12)*QX(K+8)-QX(K+11)*QX(K+9)# |fc|sin(alpha c - phi)      MA31 206
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA31 207
QX(K+STEPR+13)=FC000## Last element to F calc (0,0,0)                   MA31 208
#                                                                       MA31 209
# IS THE FIT ADEQUATE?                                                  MA31 210
# --------------------                                                  MA31 211
#                                                                       MA31 212
FOVFC=F000/FC000#                      Scale as ratio of f(0,0,0)s      MA31 213
#                                                                       MA31 214
#********************************************************************   MA31 215
#                                                                   *   MA31 216
#   THE FOLLOWING STATEMENTS CALCULATE THE STANDARD RELATIVE        *   MA31 217
#   ENTROPY AGAINST THE UNIFORM DISTRIBUTION, WHICH RESULTS IN      *   MA31 218
#   A MEASURE OF THE 'LUMPINESS' OF RHO.                            *   MA31 219
#                                                                   *   MA31 220
#      S = -SUM(RHO'*LN[RHO'/U']), WHERE                            *   MA31 221
#               RHO' = RHO/SUM(RHO),                                *   MA31 222
#               U'   = U/SUM(U) = 1/N, THE UNIFORM DISTRIBUTION.    *   MA31 223
#                                                                   *   MA31 224
#      BECAUSE THE SUMS ARE NOT KNOWN UNTIL AFTER THE LOOPS HAVE    *   MA31 225
#      BEEN COMPLETED, AT THEIR COMPLETION S IS CALCULATED AS:      *   MA31 226
#                                                                   *   MA31 227
#      S = -(1/SUM(RHO))*SUM(RHO*LN[RHO]) + LN[SUM(RHO)/N]          *   MA31 228
#                                                                   *   MA31 229
#      THE ENTROPY, S, IS INDEPENDENT OF THE SCALE OF RHO, AND,     *   MA31 230
#      PROVIDED RHO IS SUFFICIENTLY SAMPLED BY THE PIXEL GRID,      *   MA31 231
#      S IS ALSO INDEPENDENT OF THE NUMBER OF PIXELS.               *   MA31 232
#                                                                   *   MA31 233
AVERHO=SUMRHO/TOTPIX#                  Find the average electron dens   MA31 234
ENTRPY=ENTRPY/SUMRHO+ALOG(AVERHO)#     Find absolute entropy/pixel      MA31 235
CRITER=CRIWGT*ENTRPY+(1.0-CRIWGT)*CORREL# Establish entropy criterion   MA31 236
ifeq:(ENPRIO,999.0)#                   Only on the very first time      MA31 237
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA31 238
ncodefld:(ENTRPY,1,MA31A,381271.,1) ; writeline:(1,MA31A,NMA31A,3,2)#   MA31 239
ENPRIO=ENTRPY#                         Save entropy of the "prior"      MA31 240
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA31 241
#                                                                   *   MA31 242
#********************************************************************   MA31 243
#                                                                       MA31 244
I=MARKR-STEPR ; DO L=1,NREF+2#         Scale the cos & sin terms        MA31 245
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MA31 246
I=I+STEPR#                                                              MA31 247
# FCCSDA(L)=FOVFC*FCCSDA(L)                                             MA31 248
QX(I+13)=FOVFC*QX(I+13)#               Cos terms by f000/fc000          MA31 249
# FCSNDA(L+1)=FOVFC*FCSNDA(L+1)                                         MA31 250
QX(I+14)=FOVFC*QX(I+14)#               Sin terms by f000/fc000          MA31 251
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MA31 252
#                                                                       MA31 253
## At this point a judgement must be made on whether convergence has    MA31 254
## been reached.  The signal "NOTOK" (pronounced not okay) has been     MA31 255
## set to no: i.e. it is okay.  If even one of the gradient delta f     MA31 256
## values is greater than "FITFAC" times the observed sigma f then      MA31 257
## it becomes true that it's not okay.  i.e. notok=yes:  as in,         MA31 258
## "yes it is not yet okay".  Even if it is okay by the test at least   MA31 259
## two iterations will be done.                                         MA31 260
## The gradient is formed in the scratch array MWRK1 and later moved    MA31 261
## to MGRAD                                                             MA31 262
# --------------------------------------------------------------------  MA31 263
#                                                                       MA31 264
RNUM=0.0 ; RDEN=0.1#                   Set up for r value calc          MA31 265
I=MARKR-STEPR ; DO L=1,NREF+1#                                          MA31 266
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MA31 267
I=I+STEPR#                                                              MA31 268
#                                                                       MA31 269
## Pick up |Fc|cos(alpha - phi) and make sure it's not too near zero    MA31 270
#  -----------------------------------------------------------------    MA31 271
#                                                                       MA31 272
IF(ABS(QX(I+13))>0.01*QX(I+5))#        Cos term > .01 sigma f?          MA31 273
QX(MWRK1+L)=QX(I+4)-(QX(I+13)/ABS(QX(I+13)))*$# Find gradient df        MA31 274
SQRT(QX(I+13)**2+QX(I+14)**2)#         This is just |fobs|-|fcalc|      MA31 275
#                                                                       MA31 276
## If |Fc|cos(alpha - phi) is very small just set gradient df to fobs   MA31 277
#  ------------------------------------------------------------------   MA31 278
#                                                                       MA31 279
ELSE QX(MWRK1+L)=QX(I+4)#              Set delta(f) to f(obs)           MA31 280
IF(L>1)#                               Leave out f(000)                 MA31 281
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MA31 282
RNUM=RNUM+ABS(QX(MWRK1+L))#            Sum of delta(f)                  MA31 283
RDEN=RDEN+ABS(QX(I+4))#                Sum of f observed                MA31 284
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MA31 285
#                                                                       MA31 286
## Now test if the refinement has driven the gradient df below the      MA31 287
## observed sigma F observed.  If not signal to try again (iterate!)    MA31 288
#  -----------------------------------------------------------------    MA31 289
#                                                                       MA31 290
IF(ABS(QX(MWRK1+L))>FITFAC*QX(I+5))#   Fit now converged?               MA31 291
NOTOK=yes:## If the signal NOTOK "Not o.k." is true; not converged      MA31 292
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MA31 293
IF(LASTIM==no:&NOTOK==no:)#            The penultimate iteration?       MA31 294
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MA31 295
NOTOK=yes: ; LASTIM=yes:#              Once more to get final fit       MA31 296
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MA31 297
#                                                                       MA31 298
## The first and last elements are special in this treatment.           MA31 299
## The first element deals with the refinement of the contrast "CNTRST" MA31 300
## factor that is, ln(rho max/rho min). The last element deals with     MA31 301
## "LNRHMN", the ln(rho min).  As of 3 Oct 1991 LNRHMN the gradient     MA31 302
## component is set to zero while the contrast is included.             MA31 303
## The adjustment to the element which refines LNRHMN, is done as       MA31 304
## a separate operation. Look for LNRHMN=QX(MXNEW+NREF+2) lines.        MA31 305
## these two factors hold the value of FC(0,0,0).  The rescale of ln(rh MA31 306
## minimum is done through the FOVFC factor set above.                  MA31 307
#  -------------------------------------------------------------------  MA31 308
#                                                                       MA31 309
QX(MWRK1+NREF+2)=0.0#                  Externalize shift of ln(rho mi   MA31 310
#                                                                       MA31 311
# CALCULATE VALUE OF DUAL FUNCTION FOR PRINTING                         MA31 312
# ---------------------------------------------                         MA31 313
#                                                                       MA31 314
GNORM=MA41(NREF+1,QX(MWRK1+1))#        Get length of vector             MA31 315
SDOT=0.0; DO L=1,NREF; SDOT=SDOT+QX(MXNEW+L+1)*QX(MWRK1+L+1)# Dot pro   MA31 316
DUAL=ENTRPY+SDOT/F000#                                                  MA31 317
DO L=1,NREF+2 ; QX(MGRAD+L)=QX(MWRK1+L)# Save the new gradient          MA31 318
#                                                                       MA31 319
# RESCALE THE 'PRIOR' MAP TO KEEP FC(0,0,0) CONSTANT.                   MA31 320
# ---------------------------------------------------                   MA31 321
#                                                                       MA31 322
LNFOFC=LNFOFC+ALOG(FOVFC)#             Sum shift in scale of 'prior'    MA31 323
QX(MXNEW+NREF+2)=QX(MXNEW+NREF+2)+ALOG(FOVFC)# Correct ln(rhomin)       MA31 324
LNRHMN=QX(MXNEW+NREF+2)#               Update ln(rho min)               MA31 325
#                                                                       MA31 326
# FIT NOT YET SATISFACTORY. UPDATE X AND TRY AGAIN.                     MA31 327
# -------------------------------------------------                     MA31 328
#                                                                       MA31 329
IF(GNORM<GBEST)#                                                        MA31 330
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MA31 331
GBEST=GNORM ; ABEST=ALPHA#                                              MA31 332
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MA31 333
#                                                                       MA31 334
# ON THE OTHER HAND IF FIT O.K. OR ITERATIONS EXHAUSTED GET OUT         MA31 335
# -------------------------------------------------------------         MA31 336
#                                                                       MA31 337
IF(NITERA>=MITERA\NOTOK==no:)#         Stop if iterations exceeded or   MA31 338
#                                      Not 'not o.k.' i.e. converged    MA31 339
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MA31 340
IF(NOTOK==yes:)#                       If 'not o.k.' true cycle again   MA31 341
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MA31 342
DO L=1,NREF+1#                         Save/ update dual func. mult.    MA31 343
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MA31 344
QX(MXOLD+L)=QX(MXNEW+L)#               Save the old value for printin   MA31 345
QX(MXNEW+L)=QX(MWRK4+L)+ABEST*QX(MWRK5+L)# New prince's multipliers     MA31 346
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MA31 347
QX(MXOLD+NREF+2)=QX(MXNEW+NREF+2)#     Save old ln(rho min)             MA31 348
QX(MXNEW+NREF+2)=LNRHMN#               Restore ln(rho min)              MA31 349
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MA31 350
CALL MA33#                             Call to calculate r values       MA31 351
BREAK#                                 Return                           MA31 352
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MA31 353
#                                                                       MA31 354
# THE HESSIAN MUST ALWAYS BE FORMED AT LEAST ONCE, AND MAY NEED TO BE   MA31 355
# CALCULATED AGAIN IF THE F CALCS ARE FAR FROM THE F OBSERVEDS.         MA31 356
# --------------------------------------------------------------------  MA31 357
#                                                                       MA31 358
IF(NITERA==1\(RNUM/RDEN>0.075))#       First iteration or far away?     MA31 359
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MA31 360
#                                                                       MA31 361
# CALL A SUBROUTINE TO COMPUTE THE HESSIAN MATRIX FROM THE PHASES       MA31 362
# OF THE REFLECTIONS BEING PHASED AND THOSE GENERATED FROM THEM.        MA31 363
# ---------------------------------------------------------------       MA31 364
#                                                                       MA31 365
CALL MA36#                             Build hessian                    MA31 366
#                                                                       MA31 367
DO L=1,TOTHES ; QX(MHESS+L)=FOVFC*QX(MHESS+L)# Hessian by f000/fc000    MA31 368
CALL MA34(QX(MHESS+1),NREF+2)#         Get cholesky factor              MA31 369
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MA31 370
#                                                                       MA31 371
# IN SUBSEQUENT ITERATIONS, APPLY BROYDEN-FLETCHER-GOLDFARB-SHANNO      MA31 372
# UPDATE TO MODIFY THE HESSIAN MATRIX OR USE THE SECANT METHOD TO       MA31 373
# MODIFY PRINCE"S X VECTOR.                                             MA31 374
# ----------------------------------------------------------------      MA31 375
#                                                                       MA31 376
ELSE## IS THERE MORE TO BE GAINED IN THIS DIRECTION?                    MA31 377
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MA31 378
DERNOW=0.0#                                                             MA31 379
DO L=1,NREF+1 ; DERNOW=DERNOW+QX(MWRK1+L)*QX(MWRK5+L)# V1 dot v5        MA31 380
#IF(ABS(DERNOW)>SECTES)#                WHICH WAY TO UPDATE X?          MA31 381
IF(ABS(DERNOW)<0.0)#                   Junky statement to stay away f   MA31 382
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MA31 383
#                                                                       MA31 384
# ABS(DERNOW)>SECTES; SECANT METHOD TO FIND ZERO OF LINE DERIVATIVE.    MA31 385
# --------------------------------------------------------------------  MA31 386
#                                                                       MA31 387
IF(BRAKET==yes:)#                                                       MA31 388
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MA31 389
NUMER=DERNOW*(ALPHA1-ALPHA0) ; DENOM=DERINI-DERHI#                      MA31 390
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MA31 391
ELSE#                                                                   MA31 392
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MA31 393
NUMER=DERNOW*(ALPHA-ALPHA0) ; DENOM=DERINI-DERNOW#                      MA31 394
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MA31 395
REPEAT#                                                                 MA31 396
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MA31 397
ifeq:(DENOM,0.0) DENOM=1.0#                                             MA31 398
ELSE IF(ABS(DENOM)<0.1*ABS(NUMER))DENOM=2.0*DENOM# Protect divide       MA31 399
ELSE BREAK#                                                             MA31 400
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MA31 401
DELTA=NUMER/DENOM#                                                      MA31 402
IF(DELTA<0.0)#                                                          MA31 403
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MA31 404
BRAKET=yes: ; ALPHA1=ALPHA ; DERHI=DERNOW#                              MA31 405
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MA31 406
ELSE#                                                                   MA31 407
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MA31 408
ALPHA0=ALPHA ; DERINI=DERNOW#                                           MA31 409
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MA31 410
ALPHA=ALPHA+DELTA#                                                      MA31 411
#                                                                       MA31 412
# RESET PRINCE'S DUAL FUNCTION MULTIPLIER, X BY SECANT METHOD.          MA31 413
# IN THIS CASE LEAVE THE HESSIAN ALONE AND MODIFY PRINCE"S X VECTOR.    MA31 414
# ------------------------------------------------------------------    MA31 415
#                                                                       MA31 416
DO L=1,NREF+2#                         Save dual function multiplier    MA31 417
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MA31 418
QX(MXOLD+L)=QX(MXNEW+L)#               Save the unchanged x for print   MA31 419
QX(MXNEW+L)=QX(MWRK4+L)#               Update the x vector              MA31 420
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MA31 421
DO L=1,NREF+2#                         Update dual function multiplie   MA31 422
QX(MXNEW+L)=QX(MXNEW+L)+ALPHA*QX(MWRK5+L)# Update prince's multiplier   MA31 423
GO TO 501#                             Move to next iteration           MA31 424
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MA31 425
#                                                                       MA31 426
# RESET PRINCE'S DUAL FUNCTION MULTIPLIER, X BY B-F-G-S TO HESSIAN.     MA31 427
# -----------------------------------------------------------------     MA31 428
#                                                                       MA31 429
ELSE#                                  Abs(dernow)<=sectes; use bfgs    MA31 430
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MA31 431
DO L=1,NREF+2#                                                          MA31 432
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MA31 433
QX(MWRK3+L)=QX(MWRK3+L)-1.0*QX(MWRK1+L)# -vector1 + vector3 ??????      MA31 434
QX(MWRK2+L)=QX(MXNEW+L)#               X's to vector 2    ??????        MA31 435
QX(MWRK2+L)=QX(MWRK2+L)-1.0*QX(MWRK4+L)# -vector4 + vector2 ??????      MA31 436
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MA31 437
#                                                                       MA31 438
# CALL ON BROYDEN-FLETCHER-GOLDFARB-SHANNON TO WORK THEIR MAGIC.        MA31 439
# --------------------------------------------------------------        MA31 440
#                                                                       MA31 441
CALL MA37(QX(MHESS+1),NREF+2,QX(MWRK2+1),QX(MWRK3+1))#                  MA31 442
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MA31 443
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MA31 444
#                                                                       MA31 445
# SAVE THE CURRENT DIFFERENCE VECTOR AND PARAMETER VECTOR FOR BFGS      MA31 446
# UPDATE IN THE NEXT ITERATION.                                         MA31 447
# ----------------------------------------------------------------      MA31 448
#                                                                       MA31 449
DO L=1,NREF+2#                                                          MA31 450
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MA31 451
QX(MWRK3+L)=QX(MWRK1+L)#               Save the old gradient elements   MA31 452
QX(MWRK4+L)=QX(MXNEW+L)#               Save the old multipliers         MA31 453
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MA31 454
#                                                                       MA31 455
# NOW SOLVE THE EQUATIONS AND UPDATE X                                  MA31 456
# MA35 SOLVES HESS*DELTA(X)=GRAD WHERE                                  MA31 457
# GRAD = (|FO|-|FC|)COS(ALPHA(CALC)-PHI)                                MA31 458
# --------------------------------------                                MA31 459
#                                                                       MA31 460
CALL MA35(QX(MHESS+1),NREF+2,QX(MWRK1+1),no:)# Do the cholesky multip   MA31 461
#                                                                       MA31 462
# SAVE THE SEARCH DIRECTION AND INITIAL DERIVATIVE                      MA31 463
# ------------------------------------------------                      MA31 464
#                                                                       MA31 465
DO L=1,NREF+1 ; QX(MWRK5+L)=QX(MWRK1+L)# Save current delta(x)          MA31 466
DERINI=0.0;DO L=1,NREF+1;DERINI=DERINI+QX(MWRK1+L)*QX(MWRK3+L)# Dot p   MA31 467
IF(MEFIT==yes:)#                       Test if fitting general refls    MA31 468
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 MA31 469
#                                                                       MA31 470
# IN THIS CASE THE PHASES AS WELL AS THE MODULI ARE REFINED HENCE:      MA31 471
# IS THE PHASE OF FMAP VERY DIFFERENT FROM THAT OF FOBS?                MA31 472
# RELATIVE TO (COMPLEX) FOBS, IF THE VECTOR OF OUT-OF-PHASE AND         MA31 473
# ANTIPARALLEL COMPONENTS OF FCALC IS LONGER THAN (ROOT2/2.0)*|FOBS|,   MA31 474
# SET NEW = DELTA + ORIGINAL.                                           MA31 475
# -------------------------------------------------------------------   MA31 476
#                                                                       MA31 477
I=MARKR ; DO L=1,NREF#                                                  MA31 478
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 MA31 479
I=I+STEPR#                                                              MA31 480
IF(ABS(QX(I+14))>0.5*ROOT2*QX(I+4)\$#  |fc|sin(alpha(calc)-phi) enoug   MA31 481
QX(I+13)<0.0)#                         Or |alpha(calc)-phi| > 90 deg    MA31 482
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 MA31 483
#                                                                       MA31 484
IF((ROOT2*QX(I+13))**2+(ROOT2*QX(I+14))**2>QX(I+4)**2)# Outside?        MA31 485
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 MA31 486
DELPHI=ATAN2(QX(I+14),QX(I+13))#       Recover alpha calc in radians    MA31 487
PHIOLD=ATAN2(QX(I+9),QX(I+8))#         Recover alpha original           MA31 488
QX(I+8)=COS(DELPHI+PHIOLD)#            New = delta+original             MA31 489
QX(I+9)=SIN(DELPHI+PHIOLD)#                                             MA31 490
CALL MA02(QX(I+8),QX(I+9))#            Keep centrics honest             MA31 491
QX(I+6)=QX(I+8) ; QX(I+7)=QX(I+9)#     Restore input output phases      MA31 492
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 MA31 493
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 MA31 494
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 MA31 495
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 MA31 496
#                                                                       MA31 497
SECTES=0.25*ABS(DERINI)#               Reset criterion for ref method   MA31 498
DO L=1,NREF+2#                         Save/update p.d.f multipliers    MA31 499
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 MA31 500
QX(MXOLD+L)=QX(MXNEW+L)#               Save the old mult's for print    MA31 501
QX(MXNEW+L)=QX(MXNEW+L)+QX(MWRK1+L)#   Shift prince's multipliers       MA31 502
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 MA31 503
#                                                                       MA31 504
# LOOP BACK AND TRY AGAIN; SAVE THE GENERAL PARAMETERS.                 MA31 505
# -----------------------------------------------------                 MA31 506
#                                                                       MA31 507
ALPHA=1.0 ; ALPHA0=0.0#                                                 MA31 508
BRAKET=no:#                                                             MA31 509
ABEST=0.0#                                                              MA31 510
GBEST=GNORM#                                                            MA31 511
501 CONTINUE#                          From first iteration             MA31 512
LNRHMN=QX(MXNEW+NREF+2)#               Update ln(rho min)               MA31 513
CNTRST=QX(MXNEW+1)#                    Update ln(rho max/rho min)       MA31 514
#                                                                       MA31 515
#                                                                       MA31 516
# REPORT OUT PROGRESS OF FITTING IF PRINT PRIORITY IS HIGH              MA31 517
# --------------------------------------------------------              MA31 518
#                                                                       MA31 519
IF(PPRIOR>3)#                          For high print priority          MA31 520
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 MA31 521
CALL MA33#                             Put out current results          MA31 522
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 MA31 523
NITERA=NITERA+1#                       Next iteration in fitting loop   MA31 524
#                                                                       MA31 525
# REBUILD THE FOURIER MAP FOR THE NEXT FITTING ATTEMPT                  MA31 526
# ----------------------------------------------------                  MA31 527
#                                                                       MA31 528
CALL MA50#                                                              MA31 529
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA31 530
RETURN#                                                                 MA31 531
END#                                                                    MA31 532
systemheader:(MA33)## Calculate R values                                MA33   1
# ################################################################## #  MA33   2
#                                                                    #  MA33   3
#                               MA33                                 #  MA33   4
#                                                                    #  MA33   5
# ################################################################## #  MA33   6
SUBROUTINE MA33## D.M. Collins J.M. Stewart                             MA33   7
IMPLICIT NONE#                                                          MA33   8
include:(AACOMN)## March 1990                                           MA33   9
include:(MACOMN)#                                                       MA33  10
#                                                                       MA33  11
#***  EXPANDED FROM SUBROUTINE RCALC WHICH WAS                          MA33  12
#***  WRITTEN BY E. PRINCE, NATIONAL BUREAU OF STANDARDS. SEPT, 1989.   MA33  13
#                                                                       MA33  14
# ROUTINE EXPANDED TO GIVE A RUNNING OR SUMMARY REPORT OF ALL THE       MA33  15
# TRIALS AND ITERATIONS DURING THE MAXIMUM ENTROPY SEARCH               MA33  16
# ---------------------------------------------------------------       MA33  17
#                                                                       MA33  18
INTEGER I,IK,L,M#                      Loop indicies & pointers         MA33  19
INTEGER IANG#                          For printing phase angles        MA33  20
string:(ISIGN,16)#  ## Individual reflection signs as characters        MA33  21
REAL    RDEN##                                                          MA33  22
REAL    RWDEN##                                                         MA33  23
REAL    SUMUD##                                                         MA33  24
REAL    SUMWD##                                                         MA33  25
chardata:(MA31A,[    H   K   L PHI       FOBS       FMAP     $#         MA33  26
A CALC     B CALC  SIGMAF  GRAD(PHI)    X IN     X NEW])#               MA33  27
realdata:(FMTR,[50413.,90413.,130413.,170413.,281022.,391022.,501022.,$#MA33  28
611032.,690722.,791041.,891041.,991041.])# Format for reflection repo   MA33  29
chardata:(MA31C,[ TRIAL  ITERA        DUAL     ENTROPY      R%   WT $#  MA33  30
R%      GNORM       ALPHA     SUM RHO     FC(000)  CORRELATION])#       MA33  31
chardata:(MA31D,[ X IS PRINCE`S DUAL FUNCTION MULTIPLIER  TRIAL      $# MA33  32
ITERATION                     ])#                                       MA33  33
realdata:(FMTT,[60413.,130413.,281161.,401161.,470622.,540622.,$#       MA33  34
661161.,781161.,901161.,1021161.,1151162.])#                            MA33  35
realdata:(FMTX,[100962.,130313.,180422.,301182.,370862.,620413.,$#      MA33  36
660413.,700413.,740413.,780413.,820413.,860413.,900413.,940413.,$#      MA33  37
980413.,1020413.,1060413.,1100413.,1140413.,1180413.,1220413.,$#        MA33  38
1260413.])#                                                             MA33  39
chardata:(MINUS,[-])#                  A minus character                MA33  40
chardata:(PLUS,[+])#                   A plus character                 MA33  41
chardata:(MA30B,[ CRITER`N ITRN  R%   ENTROPY  CORREL`N   $#            MA33  42
TEST      PHASES--> 1   2   3   4   5   6   7   8   9  10  11  12  $#   MA33  43
13  14  15  16 TRIAL])#                                                 MA33  44
chardata:(MA30G,[YATES ALGORITHM ])#                                    MA33  45
chardata:(MA30H,[PHASE     TESTED])#                                    MA33  46
chardata:(MA30I,[FINAL FITTING   ])#                                    MA33  47
chardata:(MA30J,[FIT GENERAL REFL])#                                    MA33  48
chardata:(MA30K,[PHASE STEP      ])#                                    MA33  49
chardata:(MA30L,[MAX CRITERION   ])#                                    MA33  50
chardata:(MA30M,[OSCILLATION BASE])#                                    MA33  51
chardata:(MA30N,[PHASE CHOSEN    ])#                                    MA33  52
chardata:(MA33A,[ SUM OF RHO PER PIXEL CUBED =                   $#     MA33  53
SCALED BY TOTPIX**2/VOL**3 =               ])#                          MA33  54
realdata:(FM33A,[471261.,891261.])#                                     MA33  55
datastuff:#                                                             MA33  56
#                                                                       MA33  57
RU=99.0 ; RW=99.0#                     Anticipate failure               MA33  58
RDEN=0.0 ; RWDEN=0.0 ; SUMUD=0.0 ; SUMWD=0.0# Zero sums                 MA33  59
#                                                                       MA33  60
M=0 ; L=MARKR ; DO I=1,NREF#           Loop over all reflections        MA33  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA33  62
#                                                                       MA33  63
# PICK UP THE REAL AND IMAGINARY PARTS OF F CALC FROM REVERSE FOURIER   MA33  64
# -------------------------------------------------------------------   MA33  65
#                                                                       MA33  66
L=L+STEPR ; RDEN=RDEN+QX(L+4)#         Sum up denominator wt = 1        MA33  67
RWDEN=RWDEN+(QX(L+4)/AMAX1(0.001,QX(L+5)))**2# Sum up weighted denom'   MA33  68
SUMUD=SUMUD+ABS(QX(L+4)-QX(L+10))#     Sum weight 1 differences         MA33  69
SUMWD=SUMWD+((QX(L+4)-QX(L+10))/AMAX1(0.001,QX(L+5)))**2# Weigh'd dif   MA33  70
IF(QX(L+15)<64.0&M<16&M<(NREF-NREFIX))# A refined phase before 16th?    MA33  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA33  72
M=M+1 ; ISIGN(M^M)=PLUS#               Assume first 'halftant'          MA33  73
IF(QX(L+9)<(-.035)) ISIGN(M^M)=MINUS#  If the sine - its 182 to 358     MA33  74
ELSE IF(ABS(QX(L+9))<0.035&$#          Is sine near zero?               MA33  75
QX(L+8)<0.0) ISIGN(M^M)=MINUS#         And cosine minus ; it's minus    MA33  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA33  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA33  78
RU=100.0*SUMUD/AMAX1(0.1,RDEN)#                                         MA33  79
RW=100.0*SQRT(SUMWD/AMAX1(0.1,RWDEN))# Calculate r values               MA33  80
BUFOT(1)=CRITER;BUFOT(2)=FLOAT(NITERA);BUFOT(3)=RU#                     MA33  81
BUFOT(4)=ENTRPY ; BUFOT(5)=CORREL#     Set up parameters of trial       MA33  82
BUFOT(22)=FLOAT(ONTEST)#               Trial number                     MA33  83
IK=MIN0(16,NREF-NREFIX)#               Take lesser for listing          MA33  84
M=0 ; L=MARKR ; DO I=1,NREF#           Print up to 16, no more space    MA33  85
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA33  86
L=L+STEPR#                             Go to cos/sin values             MA33  87
IF(QX(L+15)<64.0&M<16&M<(NREF-NREFIX))# A refined phase before 16th?    MA33  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA33  89
M=M+1#                                 Increment print pointer          MA33  90
BUFOT(M+5)=RATODE*ATAN2(QX(L+9),QX(L+8))# Form phase in degrees         MA33  91
IANG=NINT(BUFOT(M+5))#                 Angle at nearest degree          MA33  92
BUFOT(M+5)=FLOAT(MOD(IANG+360,360))#   Positive in 0 to 359 degrees     MA33  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA33  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA33  95
ncodefld:(BUFOT,1,CHROT,FMTX,IK+5)#    The phase summary line           MA33  96
ncodefld:(BUFOT,22,CHROT,FMTX(22),1)#  The trial number                 MA33  97
IF(SIGNC==3) movechar:(MA30G,1,CHROT,39,NMA30G,0)# Yates result         MA33  98
ELSE IF(SIGNC==4\SIGNC==11)#                                            MA33  99
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA33 100
IF(SIGNC==4) BUFOT(23)=FLOAT(MOD(ONTEST-34,16)+1)#                      MA33 101
ELSE BUFOT(23)=FLOAT(ONTEST);ncodefld:(BUFOT,23,MA30H,90313.,1)#        MA33 102
movechar:(MA30H,1,CHROT,39,NMA30H,0)#  Individual phase tests           MA33 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA33 104
ELSE IF(SIGNC==5)#                                                      MA33 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA33 106
LINRM=4 ;  movechar:(MA30I,1,CHROT,39,NMA30I,0)# Final fitting          MA33 107
ncodefld:(FLOAT(ONMAX),1,CHROT,FMTX(22),1)# Trial where maximum found   MA33 108
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA33 109
ELSE IF(SIGNC==6)#                                                      MA33 110
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA33 111
LINRM=4 ;  movechar:(MA30J,1,CHROT,39,NMA30J,0)# General fitting        MA33 112
ncodefld:(FLOAT(ONMAX),1,CHROT,FMTX(22),1)# Trial where maximum found   MA33 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA33 114
ELSE IF(SIGNC==7\SIGNC==8)#            Phase cycling                    MA33 115
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA33 116
ncodefld:(ONPHAS,1,MA30K,160413.,1)#   Tell phase step                  MA33 117
movechar:(MA30K,1,CHROT,39,NMA30K,0)#  Step fitting                     MA33 118
IF(SIGNC==8)#                          Nice headings, please!           MA33 119
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MA33 120
movechar:(MA30N,1,CHROT,39,NMA30N,0) ;  LINRM=4## Step fitting  choic   MA33 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MA33 122
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA33 123
ELSE IF(SIGNC==9)#                     One of the first trials max      MA33 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MA33 125
ncodefld:(FLOAT(ONMAX),1,MA30L,160213.,1)# Use captured trial number    MA33 126
movechar:(MA30L,1,CHROT,39,NMA30L,0)#  And show result again            MA33 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MA33 128
ELSE IF(SIGNC==10)#                    The first oscillation run        MA33 129
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MA33 130
movechar:(MA30M,1,CHROT,39,NMA30M,0)#  Tell oscilation base run         MA33 131
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MA33 132
ELSE#                                  Must be initial trials           MA33 133
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MA33 134
movechar:(ISIGN,1,CHROT,39,16,0)#      Signs as compact phases          MA33 135
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MA33 136
IK=1 ; IF(PPRIOR>3) IK=2#              Test if printing in ma31 too     MA33 137
writeline:(IK-1,MA30B,NMA30B,IK,2)#    Report entropy of trials         MA33 138
IF(PPRIOR>3)#                                                           MA33 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MA33 140
BUFOT(1)=SUMRCU ; BUFOT(2)=SUMRCU*TOTPIX**2/VOL**3# Print cubed stats   MA33 141
ncodefld:(BUFOT,1,MA33A,FM33A,2) ; writeline:(0,MA33A,NMA33A,3,2)#      MA33 142
ncodefld:(FLOAT(ONTEST),1,MA31D,500413.,1)#                             MA33 143
ncodefld:(FLOAT(NITERA),1,MA31D,610313.,1)#                             MA33 144
movechar:(ISIGN,1,MA31D,63,16,0)#      Signs as compact phases          MA33 145
writeline:(1,MA31D,NMA31D,3,4)#        Define x in output               MA33 146
BUFOT(1)=FLOAT(NITERA)#                                                 MA33 147
LINRM=8 ; I=MARKR ; DO L=1,NREF+2## Summary of progress at priority 4   MA33 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MA33 149
IF(L==1)#                                                               MA33 150
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MA33 151
## Output list is h,k,l,phi,Fobs,Fmap,Acalc,bcalc,sigfo,grad,xin,xnew   MA33 152
BUFOT(1)=0.0 ; BUFOT(2)=0.0 ; BUFOT(3)=0.0 ; BUFOT(4)=0.0#              MA33 153
BUFOT(5)=F000 ; BUFOT(6)=FC000*FOVFC ; BUFOT(7)=FC000#                  MA33 154
BUFOT(8)=0.0 ; BUFOT(9)=0.0 ;BUFOT(10)=QX(MGRAD+1)#                     MA33 155
BUFOT(11)=QX(MXOLD+1) ; BUFOT(12)=QX(MXNEW+1)# Old & new p.d.f. mults   MA33 156
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MA33 157
ELSE#                                  All specified reflections        MA33 158
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MA33 159
I=I+STEPR#                                                              MA33 160
BUFOT(1)=QX(I+1) ; BUFOT(2)=QX(I+2) ; BUFOT(3)=QX(I+3)#                 MA33 161
BUFOT(4)=QX(MWRK3+L-1)#                Pick up phase in degrees         MA33 162
BUFOT(4)=RATODE*ATAN2(QX(I+9),QX(I+8))# Form phase in degrees           MA33 163
BUFOT(4)=AMOD(BUFOT(4)+360.0,360.0)#   Positive by degrees              MA33 164
BUFOT(5)=QX(I+4)#                      Pick up f observed               MA33 165
BUFOT(6)=QX(I+4)-QX(MGRAD+L)#          Calculate f calculated (f map)   MA33 166
BUFOT(9)=QX(I+5) ; BUFOT(11)=QX(MXOLD+L)# And sigma f observed          MA33 167
BUFOT(10)=QX(MGRAD+L) ; BUFOT(7)=QX(I+11)# Grad(phi) & a calculated     MA33 168
BUFOT(8)=QX(I+12) ; BUFOT(12)=QX(MXNEW+L)# B calc & p.d.f. multiplier   MA33 169
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MA33 170
ncodefld:(BUFOT,1,CHROT,FMTR,12) ; writeline:(0,MA31A,NMA31A,1,4)#      MA33 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MA33 172
BUFOT(1)=FLOAT(ONTEST)#                Trial number                     MA33 173
BUFOT(3)=DUAL ; BUFOT(2)=FLOAT(NITERA)# Put out value of dual functio   MA33 174
BUFOT(5)=RU ; BUFOT(6)=RW ; BUFOT(7)=GNORM# R values and gnorm          MA33 175
BUFOT(8)=ALPHA ; BUFOT(4)=ENTRPY#      Put out current entropy          MA33 176
BUFOT(9)=SUMRHO ; BUFOT(10)=FC000#     Put out current fc(0,0,0)        MA33 177
BUFOT(11)=CORREL#                      And correlation of unphased      MA33 178
ncodefld:(BUFOT,1,CHROT,FMTT,11) ; writeline:(1,MA31C,NMA31C,2,4)#      MA33 179
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MA33 180
RETURN#                                                                 MA33 181
END#                                                                    MA33 182
systemheader:(MA34)## Compute lower triangular Chloesky factor          MA34   1
# ################################################################## #  MA34   2
#                                                                    #  MA34   3
#                               MA34                                 #  MA34   4
#                                                                    #  MA34   5
# ################################################################## #  MA34   6
SUBROUTINE MA34(TRIMAT,N)## D.M. Collins J.M. Stewart Mar 1990          MA34   7
IMPLICIT NONE#                                                          MA34   8
#                                                                       MA34   9
# COMPUTE THE LOWER TRIANGULAR CHOLESKY FACTOR OF A POSITIVE            MA34  10
# DEFINITE MATRIX, TRIMAT, OF ORDER N STORED AS A PACKED LOWER          MA34  11
# TRIANGLE.                                                             MA34  12
# BASED ON SUBROUTINE CHOLES OF E. PRINCE AT NIST (UNDATED)             MA34  13
#                                                                       MA34  14
INTEGER DIAG## Pointer to the current diagonal element treated          MA34  15
INTEGER I,J,K## Runing indices                                          MA34  16
INTEGER N## The order of the matrix                                     MA34  17
INTEGER NEXTDI## Pointer to the next diagonal element                   MA34  18
INTEGER NUMCOL## No. of elements in the current column                  MA34  19
INTEGER NUMNEX## No. of elements in the next column                     MA34  20
REAL    RECIP## Square root of reciprocal of a diagonal element         MA34  21
REAL    TRIMAT(*)## The packed matrix 1,1 2,1 ... n,1 2,2 ... n,2  n    MA34  22
#                                                                       MA34  23
DIAG=1 ; NUMCOL=N#                     Point to element(1,1)            MA34  24
DO I=1,N-1#                            All columns, save the last       MA34  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA34  26
NEXTDI=DIAG+NUMCOL#                    Point to next diag. element      MA34  27
RECIP=1.0/SQRT(TRIMAT(DIAG))#          Find reciprocal square root      MA34  28
DO J=1,NUMCOL ; TRIMAT(DIAG+J-1)=RECIP*TRIMAT(DIAG+J-1)# Scale          MA34  29
DO J=1,NUMCOL-1#                       All current off diag. elt's      MA34  30
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA34  31
NUMNEX=NUMCOL-J#                       Elements in next column          MA34  32
DO K=1,NUMNEX#                         All elt's in next column         MA34  33
#                                                                       MA34  34
# ACCUMULATE THE NEGATIVE PRODUCT OF ELEMENTS OF THE CURRENT COLUMN     MA34  35
# INTO ELEMENTS OF THE NEXT COLUMN.                                     MA34  36
# -----------------------------------------------------------------     MA34  37
#                                                                       MA34  38
TRIMAT(NEXTDI+K-1)=TRIMAT(NEXTDI+K-1)-TRIMAT(DIAG+J)*$#                 MA34  39
TRIMAT(DIAG+J+K-1)#                    Accumulate product               MA34  40
NEXTDI=NEXTDI+NUMNEX#                  Move to 'next' next diag. elt    MA34  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA34  42
DIAG=DIAG+NUMCOL## Move to 'next' current diagonal element              MA34  43
NUMCOL=NUMCOL-1#                       Elements in current column       MA34  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA34  45
TRIMAT(DIAG)=SQRT(TRIMAT(DIAG))#       Last element root of self        MA34  46
RETURN#                                                                 MA34  47
END#                                                                    MA34  48
systemheader:(MA35)## Solve the real, symmetric, pos. def. system       MA35   1
# ################################################################## #  MA35   2
#                                                                    #  MA35   3
#                               MA35                                 #  MA35   4
#                                                                    #  MA35   5
# ################################################################## #  MA35   6
SUBROUTINE MA35(TRIMAT,N,VECTOR,LTONLY)## D.M.Collins J.M.Stewart       MA35   7
##                                        April 1990                    MA35   8
IMPLICIT NONE#                                                          MA35   9
#                                                                       MA35  10
# BASED ON SUBROUTINE SPLSL FROM E. PRINCE AT NIST (02/08/88)           MA35  11
# ALSO HAS ENTRY SLTSL NOW CALLED MA35T                                 MA35  12
# ON ENTRY SOLVE A*Y = B  WHERE A, THE LOWER TRIANGULAR CHOLESKY        MA35  13
# FACTOR IS IN "TRIMAT" AND B, THE RIGHT HAND SIDE VECTOR IS IN         MA35  14
# "VECTOR". IN THE FIRST LOOP, VECTOR IS REPLACED BY "Y", IN THE        MA35  15
# SECOND LOOP THE SOLUTION TO A'*X = Y IS SOLVED FOR X.  AT THE         MA35  16
# RETURN "VECTOR" CONTAINS X.                                           MA35  17
# TRIMAT MUST BE OF RANK N STORED AS A PACKED LOWER TRIANGLE.           MA35  18
#                                                                       MA35  19
INTEGER DIAG## Pointer to each diagonal element in turn                 MA35  20
INTEGER I,K## Loop indices                                              MA35  21
INTEGER LTONLY## Flag if solution is of a*y=b only or also a*x=y        MA35  22
INTEGER N## The rank of matrix "trimat"                                 MA35  23
INTEGER NUMCOL## At each stage the number of elements in the column     MA35  24
REAL    SDOT## Volatile and dot product storage                         MA35  25
REAL    TRIMAT(*)## The lower triangular, packed matrix                 MA35  26
REAL    VECTOR(*)## The vector B, then Y, then X                        MA35  27
#                                                                       MA35  28
## IF(LTONLY==no:)                     Do both a*y=b & a'*x=y           MA35  29
## ELSE IF(LTONLY==yes:)               Only solve a*y=b                 MA35  30
NUMCOL=N#                              First column has n elts.         MA35  31
DIAG=1#                                Point to element(1,1)            MA35  32
DO I=1,N-1#                            Over all but last element        MA35  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA35  34
VECTOR(I)=VECTOR(I)/TRIMAT(DIAG)#      Each vect. elt. by diagonal      MA35  35
SDOT=-VECTOR(I)#                       Save first elt. to scale by      MA35  36
DO K=1,N-I ; VECTOR(I+K)=VECTOR(I+K)+SDOT*TRIMAT(DIAG+K)# Solve a*x=b   MA35  37
DIAG=DIAG+NUMCOL ; NUMCOL=NUMCOL-1#    Move to next column              MA35  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA35  39
VECTOR(N)=VECTOR(N)/TRIMAT(DIAG)#      Compute nth element of a*x=b     MA35  40
#                                                                       MA35  41
IF(LTONLY==no:)#                       Also solve a'*x=y?               MA35  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA35  43
VECTOR(N)=VECTOR(N)/TRIMAT(DIAG)#      Compute nth element of a*y=x     MA35  44
NUMCOL=N#                              Forword to vector element        MA35  45
DO I=2,N#                              Over the rest of the columns     MA35  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA35  47
DIAG=DIAG-I ; NUMCOL=NUMCOL-1#         Adjust pointers                  MA35  48
SDOT=0.0 ; DO K=1,I-1 ; SDOT=SDOT+TRIMAT(DIAG+K)*VECTOR(NUMCOL+K)# Do   MA35  49
VECTOR(NUMCOL)=(VECTOR(NUMCOL)-SDOT)/TRIMAT(DIAG)# Get element of x     MA35  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA35  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA35  52
RETURN#                                                                 MA35  53
END#                                                                    MA35  54
systemheader:(MA36)## Compute Hessian matrix of the entropy function    MA36   1
# ################################################################## #  MA36   2
#                                                                    #  MA36   3
#                               MA36                                 #  MA36   4
#                                                                    #  MA36   5
# ################################################################## #  MA36   6
SUBROUTINE MA36#                       D.m.collins j.m.stewart          MA36   7
IMPLICIT NONE#                                                          MA36   8
include:(AACOMN)#                      April 1990                       MA36   9
include:(MACOMN)#                                                       MA36  10
#                                                                       MA36  11
# COMPUTE THE HESSIAN LOWER TRIANGULAR POSITIVE DEFINITE MATRIX         MA36  12
# OF RANK N STORED AS A PACKED LOWER TRIANGLE.                          MA36  13
# BASED ON SUBROUTINE HESS FROM E. PRINCE AT NIST (UNDATED)             MA36  14
#                                                                       MA36  15
REAL AI,BI#                            Cos and sin of ith refl          MA36  16
INTEGER I,J,L,M## Loop indices                                          MA36  17
INTEGER MATELT## Pointer to matrix element                              MA36  18
INTEGER MPOINT## Pointer to H(I)-H(J) reflection F calc'd               MA36  19
INTEGER PPOINT## Pointer to H(I)+H(J) reflection F calc'd               MA36  20
INTEGER STEPPP## Stepper for PPOINT = 2*STEPQ                           MA36  21
chardata:(MA36A,[    I   J    H(I,J)    A(HW)    B(HW)    A(HV)    $#   MA36  22
B(HV)   A(HI)  B(HI)  A(HJ)  B(HJ) ])#                                  MA36  23
realdata:(FMT,[50413.,90413.,211151.,300922.,390922.,480922.$#          MA36  24
,550722.,620722.,690722.,760722.,830722.])#                             MA36  25
datastuff:#                                                             MA36  26
#                                                                       MA36  27
IF(PPRIOR>3)#                          Under dumping conditions         MA36  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA36  29
writeline:(1,0,0,3,4) ;  LINRM=8#      Take a space & force heading     MA36  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA36  31
MATELT=MHESS+NREF+2#                   Set matrix pointer               MA36  32
STEPPP=2*STEPQ ; PPOINT=MARKQ-STEPPP#  Set to pick up contributers      MA36  33
L=MARKR ; DO I=1,NREF#                 Over all reflec's being phased   MA36  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA36  35
M=L ; L=L+STEPR#                                                        MA36  36
AI=QX(L+8) ; BI=QX(L+9)#               Put phase in local register      MA36  37
DO J=I,NREF+1#                         From i to all beyond + 1         MA36  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA36  39
M=M+STEPR ; MATELT=MATELT+1#           Advance phase & matrix pointer   MA36  40
PPOINT=PPOINT+STEPPP#                  Point to plus combination        MA36  41
MPOINT=PPOINT+STEPQ#                   Point to minus combination       MA36  42
#                                                                       MA36  43
# CONTRIBUTE TO MATRIX ELEMENTS BASED ON PHASES OF REFLECTIONS BEING    MA36  44
# PHASED AND ONES GENERATED BY H(I)+H(J) AND H(I)-H(J).                 MA36  45
# THIS IS THE EXPANDED FORM OF (FP + FM)/2 WHERE THE FP & FM ARE THE    MA36  46
# F CALCULATED FOR THE PLUS & MINUS COMPANION REFLECTIONS.              MA36  47
# EACH HESSIAN ELEMENT IS FORMED BY A SPECIAL COMBINATION OF THE TWO    MA36  48
# CALCULATED COMPANION REFLECTION STRUCTURE FACTORS.  FIRST THE         MA36  49
# COMPANION STRUCTURE FACTORS ARE OFFSET IN PHASE BY -(PHI(I)+PHI(J))   MA36  50
# AND -(PHI(I)-PHI(J)) RESPECTIVELY; THEN THE RESULTING REAL PARTS      MA36  51
# ARE AVERAGED TO GIVE H(I,J).                                          MA36  52
# -------------------------------------------------------------------   MA36  53
#                                                                       MA36  54
QX(MATELT)=0.25*($#                                                     MA36  55
QX(PPOINT+1)*(AI*QX(M+8)-BI*QX(M+9))+$#                                 MA36  56
QX(PPOINT+2)*(BI*QX(M+8)+AI*QX(M+9))+$#                                 MA36  57
QX(MPOINT+1)*(AI*QX(M+8)+BI*QX(M+9))+$#                                 MA36  58
QX(MPOINT+2)*(BI*QX(M+8)-AI*QX(M+9)))#                                  MA36  59
IF(PPRIOR>4)#                          Under dumping conditions         MA36  60
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA36  61
BUFOT(1)=FLOAT(I) ; BUFOT(2)=FLOAT(J) ; BUFOT(3)=QX(MATELT)#            MA36  62
BUFOT(4)=QX(PPOINT+1) ; BUFOT(5)=QX(PPOINT+2) ; BUFOT(6)=QX(MPOINT+1)#  MA36  63
BUFOT(7)=QX(MPOINT+2) ; BUFOT(8)=AI ; BUFOT(9)=BI#                      MA36  64
BUFOT(10)=QX(M+8) ; BUFOT(11)=QX(M+9)#                                  MA36  65
ncodefld:(BUFOT,1,CHROT,FMT,11) ; writeline:(0,MA36A,NMA36A,1,5)#       MA36  66
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA36  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA36  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA36  69
QX(MATELT+1)=FC000#                    Set last element to fc(0,0,0)    MA36  70
RETURN#                                                                 MA36  71
END#                                                                    MA36  72
systemheader:(MA37)## Apply Broyden-Fletcher-Goldfarb-Shanno-update     MA37   1
# ################################################################## #  MA37   2
#                                                                    #  MA37   3
#                               MA37                                 #  MA37   4
#                                                                    #  MA37   5
# ################################################################## #  MA37   6
SUBROUTINE MA37(TRIMAT,N,SHIFT,CHGRAD)# D.m.collins j.m.stewart         MA37   7
IMPLICIT NONE#                                                          MA37   8
#                                       April 1990                      MA37   9
# APPLY THE BROYDEN-FLETCHER-GOLDFARB-SHANNO  UPDATE TO POSITIVE        MA37  10
# DEFINITE MATRIX B, WHOSE LOWER-TRIANGULAR CHLOSKEY FACTOR IS          MA37  11
# STORED, PACKED, IN TRIMAT. N IS THE RANK OF B, SHIFT IS THE SHIFT     MA37  12
# FROM THE MOST RECENT ITERATION, AND CHGRAD IS THE CHANGE IN GRADIENT  MA37  13
# FROM THE MOST RECENT ITERATION.  TRIMAT WILL BE OVERWRITTEN AND       MA37  14
# SHIFT AND CHGRAD WILL BE TRASHED.                                     MA37  15
# ADAPTED FROM SUBROUTINE BFGS OF E. PRINCE AT NIST (UNDATED)           MA37  16
# -------------------------------------------------------------------   MA37  17
#                                                                       MA37  18
REAL    CHGRAD(*)## Vector of change in gradient                        MA37  19
INTEGER I## Loop index                                                  MA37  20
INTEGER N## Rank of the matrix                                          MA37  21
REAL    SDOT## For forming dot products                                 MA37  22
REAL    SCLFAC## For scaling shifts                                     MA37  23
REAL    SHIFT(*)## Vector of shifts                                     MA37  24
REAL    TRIMAT(*)## The packed matrix 1,1 2,1 ... n,1 2,2 ... n,2  n    MA37  25
#                                                                       MA37  26
SDOT=0.0 ; DO I=1,N ; SDOT=SDOT+SHIFT(I)*CHGRAD(I)# Form dot product    MA37  27
SCLFAC=1.0/SQRT(SDOT)#                 Form scale factor                MA37  28
DO I=1,N ; CHGRAD(I)=SCLFAC*CHGRAD(I)# Scale change in gradieint        MA37  29
CALL MA38(TRIMAT,N,SHIFT)#             Compute scaled vector            MA37  30
CALL MA39(TRIMAT,N,CHGRAD)#            Update the cholesky factor       MA37  31
CALL MA40(TRIMAT,N,SHIFT)#             Downdate the cholesky factor     MA37  32
#                                                                       MA37  33
RETURN#                                                                 MA37  34
END#                                                                    MA37  35
systemheader:(MA38)## Compute scaled vector for update of cholesky      MA38   1
# ################################################################## #  MA38   2
#                                                                    #  MA38   3
#                               MA38                                 #  MA38   4
#                                                                    #  MA38   5
# ################################################################## #  MA38   6
SUBROUTINE MA38(TRIMAT,N,SHIFT)## D.m.collins j.m.stewart apr 1990      MA38   7
IMPLICIT NONE#                                                          MA38   8
#                                                                       MA38   9
# COMPUTE THE VECTOR B*S, SCALED BY 1/(MAG OF LENGTH OF THE PARAMETER   MA38  10
# SHIFT VECTOR)                                                         MA38  11
# FOR USE IN THE BROYDEN-FLETCHER-GOLDFARB UPDATE TO POSITIVE DEFINITE  MA38  12
# MATRIX B, WHOSE LOWER-TRIANGULAR CHLOSKEY FACTOR IS STORED, PACKED,   MA38  13
# IN TRIMAT. N IS THE RANK OF B, SHIFT IS THE SHIFT FROM THE CALLING    MA38  14
# SUBROUTINE AND WILL BE OVERWRITTEN BY THE DOWNDATE VECTOR.            MA38  15
# ADAPTED FROM SUBROUTINE BXS OF E. PRINCE AT NIST (UNDATED)            MA38  16
# BASED ON ALGORITHMS DESCRIBED BY J.J. DONGARRA, C.B. MOLER,           MA38  17
# J.R. BUNCH & G.W. STEWART. SOCIETY FOR INDUSTRIAL AND APPLIED MATH    MA38  18
# IBSN-0-89871-172-X (1979) SECTION 10.                                 MA38  19
# -------------------------------------------------------------------   MA38  20
#                                                                       MA38  21
EXTERNAL MA41 ; REAL MA41#                                              MA38  22
INTEGER DIAG## Pointer to the diagonal element                          MA38  23
REAL    FAC## Vector element for scaling                                MA38  24
INTEGER I,J## Loop indices                                              MA38  25
INTEGER N## Rank of the matrix                                          MA38  26
INTEGER NUMCOL## Number of elements in current column                   MA38  27
REAL    SDOT## For forming dot products                                 MA38  28
REAL    SCLFAC## For scaling shifts                                     MA38  29
REAL    SHIFT(*)## Vector of shifts                                     MA38  30
REAL    TRIMAT(*)## The packed matrix 1,1 2,1 ... n,1 2,2 ... n,2  n    MA38  31
#                                                                       MA38  32
# FORM TRIMAT(TRANSPOSE)*SHIFT  MATRIX VECTOR MULTIPLY                  MA38  33
# ----------------------------------------------------                  MA38  34
#                                                                       MA38  35
DIAG=1 ; NUMCOL=N#                                                      MA38  36
DO I=1,N#                              Over the matrix                  MA38  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA38  38
SDOT=0.0; DO J=1,N-I+1; SDOT=SDOT+TRIMAT(DIAG+J-1)*SHIFT(I+J-1)# Dot    MA38  39
SHIFT(I)=SDOT#                                                          MA38  40
DIAG=DIAG+NUMCOL ; NUMCOL=NUMCOL-1#    Adjust matrix pointers           MA38  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA38  42
SCLFAC=1.0/MA41(N,SHIFT)#              Scale factor from length         MA38  43
#                                                                       MA38  44
# FORM SCALED SHIFT VECTOR                                              MA38  45
# ------------------------                                              MA38  46
#                                                                       MA38  47
DO I=1,N#                              Backward over matrix             MA38  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA38  49
DIAG=DIAG-I#                                                            MA38  50
FAC=SHIFT(N-I+1) ; SHIFT(N-I+1)=0.0#   Save element & zero it           MA38  51
DO J=1,I ; SHIFT(N-I+J)=SHIFT(N-I+J)+FAC*TRIMAT(DIAG+J-1)# Alter vect   MA38  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA38  53
#                                                                       MA38  54
DO I=1,N ; SHIFT(I)=SCLFAC*SHIFT(I)#   Scale change in shift vector     MA38  55
#                                                                       MA38  56
RETURN#                                                                 MA38  57
END#                                                                    MA38  58
systemheader:(MA39)## Update the cholesky factor                        MA39   1
# ################################################################## #  MA39   2
#                                                                    #  MA39   3
#                               MA39                                 #  MA39   4
#                                                                    #  MA39   5
# ################################################################## #  MA39   6
SUBROUTINE MA39(TRIMAT,N,UPDATE)#      D.m.collins j.m.stewart apr '9   MA39   7
IMPLICIT NONE#                                                          MA39   8
#                                                                       MA39   9
# USE GIVENS ROTATORS TO UPDATE THE LOWER-TRIANGULAR CHLOSKEY FACTOR    MA39  10
# OF A POSITIVE DEFINITE MATRIX STORED IN TRIMAT. N IS THE RANK,        MA39  11
# UPDATE IS THE UPDATE VECTOR FROM THE CALLING SUBROUTINE AND WILL      MA39  12
# TRASHED. TRIMAT WILL BE OVERWRITTEN WITH THE UPDATED MATRIX.          MA39  13
# ADAPTED FROM SUBROUTINE UPDATE OF E. PRINCE AT NIST (UNDATED)         MA39  14
# SEE REFERENCE IN MA38                                                 MA39  15
# -------------------------------------------------------------------   MA39  16
#                                                                       MA39  17
INTEGER DIAG## Pointer to the diagonal element                          MA39  18
REAL    CFAC## Cosine factor for rotation                               MA39  19
INTEGER I## Loop indices                                                MA39  20
INTEGER N## Rank of the matrix                                          MA39  21
INTEGER NUMCOL## Number of elements in current column                   MA39  22
REAL    SFAC## Sine factor for rotation                                 MA39  23
REAL    UPDATE(*)## Vector of shifts                                    MA39  24
REAL    TRIMAT(*)## The packed matrix 1,1 2,1 ... n,1 2,2 ... n,2  n    MA39  25
#                                                                       MA39  26
DIAG=1 ; NUMCOL=N#                                                      MA39  27
DO I=1,N#                              Over the matrix                  MA39  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA39  29
CALL MA43(TRIMAT(DIAG),UPDATE(I),CFAC,SFAC)# ???????                    MA39  30
IF(TRIMAT(DIAG)<0.0)#                  Look for neg diag elts           MA39  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA39  32
CFAC=-CFAC ; SFAC=-SFAC ; TRIMAT(DIAG)=-TRIMAT(DIAG)# Flip signs        MA39  33
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA39  34
IF(I==N) BREAK#                        Rotate all but last elt          MA39  35
CALL MA42(N-I,TRIMAT(DIAG+1),UPDATE(I+1),CFAC,SFAC)# ????????           MA39  36
DIAG=DIAG+NUMCOL ; NUMCOL=NUMCOL-1#    Adjust matrix pointers           MA39  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA39  38
#                                                                       MA39  39
RETURN#                                                                 MA39  40
END#                                                                    MA39  41
systemheader:(MA40)## Downdate the cholesky factor                      MA40   1
# ################################################################## #  MA40   2
#                                                                    #  MA40   3
#                               MA40                                 #  MA40   4
#                                                                    #  MA40   5
# ################################################################## #  MA40   6
SUBROUTINE MA40(TRIMAT,N,DNDATE)## D.m.collins j.m.stewart apr 1990     MA40   7
IMPLICIT NONE#                                                          MA40   8
#                                                                       MA40   9
# DOWNDATE THE LOWER-TRIANGULAR CHLOSKEY FACTOR OF A POSITIVE           MA40  10
# DEFINITE MATRIX STORED IN TRIMAT. N IS THE RANK,                      MA40  11
# DNDATE IS THE DOWNDATE VECTOR FROM THE CALLING SUBROUTINE AND WILL    MA40  12
# BE ?????????????  TRIMAT WILL BE OVERWRITTEN WITH THE DOWNDATED       MA40  13
# MATRIX.                                                               MA40  14
# ADAPTED FROM SUBROUTINE DNDATE OF E. PRINCE AT NIST (UNDATED)         MA40  15
# SEE REFERENCE IN MA38                                                 MA40  16
# -------------------------------------------------------------------   MA40  17
#                                                                       MA40  18
EXTERNAL MA41 ; REAL MA41## MA41 calculates vector lengths              MA40  19
REAL    CC## Renomalization factor for downdate vector                  MA40  20
REAL    CFAC## cosine factor                                            MA40  21
REAL    DNDATE(*)## Vector of shifts                                    MA40  22
REAL    HYPO## Length of hypotenuse of a triangle                       MA40  23
INTEGER I## Loop indices                                                MA40  24
INTEGER LAST## Pointer to last element in a column                      MA40  25
INTEGER N## Rank of the matrix                                          MA40  26
REAL    SFAC## Sine factor                                              MA40  27
REAL    SS## Renormalization factor for downdate vector                 MA40  28
REAL    SCLFAC## For scaling shifts                                     MA40  29
REAL    TRIMAT(*)## The packed matrix 1,1 2,1 ... n,1 2,2 ... n,2  n    MA40  30
#                                                                       MA40  31
CALL MA35(TRIMAT,N,DNDATE,yes:)#       Solve a*x=b                      MA40  32
CC=SQRT(1.0-MA41(N,DNDATE)**2)#        Get cos from sin?                MA40  33
#                                                                       MA40  34
LAST=(N*(N+1))/2+1#                    Point to last + 1 elt            MA40  35
#                                                                       MA40  36
DO I=1,N#                              Over the matrix                  MA40  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA40  38
LAST=LAST-I#                           Point current last elt           MA40  39
SS=DNDATE(N-I+1)#                      ?????                            MA40  40
SCLFAC=CC+SS#                          ?????                            MA40  41
HYPO=SQRT((CC/SCLFAC)**2+(SS/SCLFAC)**2)*SCLFAC# ???                    MA40  42
CFAC=CC/HYPO ; SFAC=SS/HYPO#           ?????                            MA40  43
DNDATE(N-I+1)=0.0#                     Zero vector                      MA40  44
CALL MA42(I,DNDATE(N-I+1),TRIMAT(LAST),CFAC,SFAC)# ???????              MA40  45
CC=CC/CFAC#                                                             MA40  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA40  47
#                                                                       MA40  48
RETURN#                                                                 MA40  49
END#                                                                    MA40  50
systemheader:(MA41)## Get euclidian length of a sing prec vector        MA41   1
# ################################################################## #  MA41   2
#                                                                    #  MA41   3
#                               MA41                                 #  MA41   4
#                                                                    #  MA41   5
# ################################################################## #  MA41   6
REAL FUNCTION MA41(N,SX)## D.m.collins j.m.stewart apr 1990             MA41   7
IMPLICIT NONE#                                                          MA41   8
include:(AACOMN)#                                                       MA41   9
#                                                                       MA41  10
# THIS SUBROUTINE IS A RECODING OF A B L A S SUBROUTINE SNRM2           MA41  11
# ITS PURPOSE IS TO                                                     MA41  12
# FIND THE EUCLIDIAN LENGTH OF A SINGLE PRECISION VECTOR PROTECTING     MA41  13
# AGAINST REGISTER OVER OR UNDERFLOW.                                   MA41  14
# THE VALUES OF CUTLO AND CUTHI ARE TAKEN FROM THE ORIGINAL PROGRAM     MA41  15
# FROM ESTIMATES (CIRCA 1977) GIVEN IN THE IMSL CONVERTER DOCUMENT.     MA41  16
# HERE THE ESTIMATE FOR 32 BIT MACHINES IS  1.703E-16 & 4.123E15;       MA41  17
# WHICH SHOULD BE SAFE, IF UNNECESSARY, FOR ALL OTHERS.                 MA41  18
# REFERENCE: LAWSON C.L., HANSON R.J., KINCAID D.R.,KROUGH F.T.,        MA41  19
# 'BASIC LINEAR ALGEBRA SUBPROGRAMS FOR FORTRAN USAGE'                  MA41  20
# ALGORITHM NO. 539, TRANSACTIONS ON MATHEMATICAL SOFTWARE, VOL 5,      MA41  21
# NUMBER 3, SEPTEMBER 1979, 308-323.                                    MA41  22
#                                                                       MA41  23
INTEGER I## Loop index                                                  MA41  24
INTEGER IHIT## Flag to signal all elements are essentially zero         MA41  25
INTEGER N## Order of the vector                                         MA41  26
REAL SUM## Single precision register for sum of squares                 MA41  27
REAL SXMAX,SXMIN## Scaler arguments                                     MA41  28
REAL SX(*)## Vector to have its length determined                       MA41  29
realdata:(ZERO,[0.0E0])#               Single precision 0               MA41  30
realdata:(CUTHI,[4.123E15])#           Estimate 32 bit machine          MA41  31
realdata:(CUTLO,[4.441E-16])#          Estimate 32 bit machine          MA41  32
realdata:(BOOST,[1.0E+04])#            Booster for 'all' small number   MA41  33
datastuff:#                                                             MA41  34
#                                                                       MA41  35
SUM=ZERO ; IHIT=no:#                   Zero sum of squares; set flag    MA41  36
SXMAX=-CUTLO ; SXMIN=CUTHI#            Prepare to find range            MA41  37
DO I=1,N#                              Over all elements of vector      MA41  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA41  39
ifeq:(SX(I),ZERO) NEXT#                Don't call zeros to judge        MA41  40
IHIT=yes:#                             There's something there          MA41  41
SXMAX=AMAX1(SXMAX,ABS(SX(I)))#         Look for maximum                 MA41  42
SXMIN=AMIN1(SXMIN,ABS(SX(I)))#         Look for minimum                 MA41  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA41  44
IF(IHIT==no:) MA41=ZERO#               Don't fool with null vectors     MA41  45
ELSE IF(SXMAX>=CUTHI/FLOAT(N))#        Will overflow occur?             MA41  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA41  47
DO I=1,N ; SUM=SUM+(SX(I)/SXMAX)**2#   Find sum of squares              MA41  48
MA41=SXMAX*SQRT(SUM)#                  Get length on proper scale       MA41  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA41  50
ELSE IF(SXMAX<=CUTLO&SXMAX/SXMIN<CUTHI/FLOAT(N))# Underflow?            MA41  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA41  52
DO I=1,N ; SUM=SUM+(SX(I)*BOOST)**2#   Find sum of squares              MA41  53
MA41=SQRT(SUM)/BOOST#                  Get length on proper scale       MA41  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA41  55
ELSE#                                  Run of the mill                  MA41  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA41  57
DO I=1,N ; SUM=SUM+SX(I)**2#           Just find sum of squares         MA41  58
MA41=SQRT(SUM)#                        Get length from sum of squares   MA41  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA41  60
RETURN#                                                                 MA41  61
END#                                                                    MA41  62
systemheader:(MA42)## Apply a single precision Givens' rotation         MA42   1
# ################################################################## #  MA42   2
#                                                                    #  MA42   3
#                               MA42                                 #  MA42   4
#                                                                    #  MA42   5
# ################################################################## #  MA42   6
SUBROUTINE MA42(N,SX,SY,SC,SS)## D.m.collins j.m.stewart apr 1990       MA42   7
IMPLICIT NONE#                                                          MA42   8
#                                                                       MA42   9
# THIS SUBROUTINE IS A RECODING OF A B L A S SUBROUTINE SROT            MA42  10
# ITS PURPOSE IS TO                                                     MA42  11
# MULTIPLY THE (2X2) MATRIX ( SC  SS) BY THE (2XN) MATRIX (SX')         MA42  12
#                           (-SS SC)                      (SY')         MA42  13
# WHERE SX' AND SY' ARE THE TRANSPOSE.                                  MA42  14
# REFERENCE: LAWSON C.L., HANSON R.J., KINCAID D.R.,KROUGH F.T.,        MA42  15
# 'BASIC LINEAR ALGEBRA SUBPROGRAMS FOR FORTRAN USAGE'                  MA42  16
# ALGORITHM NO. 539, TRANSACTIONS ON MATHEMATICAL SOFTWARE, VOL 5,      MA42  17
# NUMBER 3, SEPTEMBER 1979, 308-323.                                    MA42  18
#                                                                       MA42  19
INTEGER I## Loop index                                                  MA42  20
INTEGER N## Order of the vectors                                        MA42  21
REAL SC,SS## Scaler arguments                                           MA42  22
REAL SX(*),SY(*)## Vectors for rotation                                 MA42  23
REAL W,Z## Scaler intermediate results                                  MA42  24
realdata:(ONE,[1.0E0])#                Single precision 1               MA42  25
realdata:(ZERO,[0.0E0])#               Single precision 0               MA42  26
datastuff:#                                                             MA42  27
ifne:(SS,ZERO)#                                                         MA42  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA42  29
ifne:(SC,ONE)#                                                          MA42  30
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA42  31
IF(N>0)#                                                                MA42  32
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA42  33
DO I=1,N#                              Over all elements of sx & sy     MA42  34
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA42  35
W=SX(I) ; Z=SY(I)#                     Save ith elements                MA42  36
SX(I)=SC*W+SS*Z ; SY(I)=-SS*W+SC*Z#    Update the ith elements          MA42  37
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA42  38
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA42  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA42  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA42  41
RETURN#                                                                 MA42  42
END#                                                                    MA42  43
systemheader:(MA43)## Construct sing. prec. plane Givens' rotation      MA43   1
# ################################################################## #  MA43   2
#                                                                    #  MA43   3
#                               MA43                                 #  MA43   4
#                                                                    #  MA43   5
# ################################################################## #  MA43   6
SUBROUTINE MA43(SA,SB,SC,SS)## D.m.collins j.m.stewart apr 1990         MA43   7
IMPLICIT NONE#                                                          MA43   8
#                                                                       MA43   9
# THIS SUBROUTINE IS A RECODING OF A B L A S SUBROUTINE SROTG           MA43  10
# DESIGNED BY C. L. LAWSON AT JPL IN SEPT 1977. ITS PURPOSE IS          MA43  11
# TO CONSTRUCT A SINGLE PRECISION GIVENS' ROTATION.                     MA43  12
# INPUT SA & SB S.P. SCALERS                                            MA43  13
# OUTPUT SA, RESULT R, SB, RESULT Z, SC, & SS ALL S.P. SCALERS          MA43  14
#                                                                       MA43  15
# CONSTRUCT THE GIVENS' TRANSFORMATION WHERE:                           MA43  16
#                                                                       MA43  17
#     ( SC  SS)                                                         MA43  18
# G = (       )  ,  SC**2 + SS**2 = 1.0 ,                               MA43  19
#     (-SS  SC)                                                         MA43  20
# WHICH ZEROS THE SECOND ENTRY OF THE 2-VECTOR (SA,SB)**T.              MA43  21
# THE QUANTITY R = (+/-)SQRT(SA**2 + SB**2) OVERWRITES SA IN            MA43  22
# STORAGE.  THE VALUE OF SB IS OVERWRITTEN BY A VALUE, Z, WHICH         MA43  23
# ALLOWS SC & SS TO BE RECOVERED BY THE FOLLOWING ALGRITHM:             MA43  24
# IF Z=1 SET SC=0.0 & SS=1.0                                            MA43  25
# IF ABS(Z) < 1 SET SC=SQRT(1-Z**2) AND SS=Z                            MA43  26
# IF(ABS(Z) > 1 SET SC=1/Z & SS=SQRT(1-SC**2)                           MA43  27
# THIS SUBROUTINE IS NORMALLY USED IN CONJUNCTION WITH MA42 A           MA43  28
# TRANSLATION OF B L A S SUBROUTINE SROT WHICH WILL APPLY THE           MA43  29
# TRANSFORMATION TO A (2 X N) MATRIX.                                   MA43  30
# REFERENCE: LAWSON C.L., HANSON R.J., KINCAID D.R.,KROUGH F.T.,        MA43  31
# 'BASIC LINEAR ALGEBRA SUBPROGRAMS FOR FORTRAN USAGE'                  MA43  32
# ALGORITHM NO. 539, TRANSACTIONS ON MATHEMATICAL SOFTWARE, VOL 5,      MA43  33
# NUMBER 3, SEPTEMBER 1979, 308-323.                                    MA43  34
#                                                                       MA43  35
REAL SA,SB,SC,SS## Scaler arguments                                     MA43  36
REAL R,U,V## Scaler intermediate results                                MA43  37
#                                                                       MA43  38
IF(ABS(SA)<=ABS(SB))#                  When sa is <= to sb              MA43  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA43  40
ifne:(SB,0.0)#                         And sb is greater than zero      MA43  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA43  42
U=SB+SB ; V=SA/U#                      U=2*sb & v=sa/(2*sb)             MA43  43
SA=SQRT(0.25+V**2)*U#                                                   MA43  44
SS=SB/SA ; SC=V*(SS+SS)#                                                MA43  45
ifne:(SC,0.0) SB=1.0/SC#                                                MA43  46
ELSE SB=1.0#                                                            MA43  47
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA43  48
ELSE#                                  Sb is zero                       MA43  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA43  50
SC=1.0 ; SS=0.0#                                                        MA43  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA43  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA43  53
ELSE#                                  When sa > sb                     MA43  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA43  55
U=SA+SA ; V=SB/U#                      U=2*sa & v=sb/(2*sa)             MA43  56
R=SQRT(0.25+V**2)*U#                                                    MA43  57
SC=SA/R ; SS=V*(SC+SC)#                                                 MA43  58
SB=SS ; SA=R#                                                           MA43  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA43  60
RETURN#                                                                 MA43  61
END#                                                                    MA43  62
systemheader:(MA50)## Drive reciprocal cell to direct cell fourier      MA50   1
# ################################################################## #  MA50   2
#                                                                    #  MA50   3
#                               MA50                                 #  MA50   4
#                                                                    #  MA50   5
# ################################################################## #  MA50   6
SUBROUTINE MA50#                       D.m.collins j.m.stewart          MA50   7
IMPLICIT NONE#                                                          MA50   8
include:(AACOMN)#                      March 1990                       MA50   9
include:(MACOMN)#                                                       MA50  10
INTEGER J#                             Loop index                       MA50  11
#                                                                       MA50  12
# IN THE FINAL USE OF THE FOURIER TRANSFORM AN UPDATED CONSTRAINED      MA50  13
# EXPONENTIAL ELECTRON DENSITY MAP ON THE SCALE OF A MEDENS MAP         MA50  14
# IS WRITTEN TO FILE .MEE                                               MA50  15
# ----------------------------------------------------------------      MA50  16
#                                                                       MA50  17
IF(FINFIT==yes:)#                      Last shot?                       MA50  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA50  19
SHARPF=1.0 ; RESCAL=1.0#               Map is now a c.e.e.d. map        MA50  20
QX(FINPNT+28)=SHARPF#                  The sharpening parameter         MA50  21
QX(FINPNT+29)=RESCAL#                  The scaling parameter            MA50  22
QX(FINPNT+26)=SHARPF*(LNRHMX-LNRHSC)#  Ln(rho maximum)                  MA50  23
QX(FINPNT+27)=SHARPF*(LNRHMN-LNRHSC)#  Ln(rho minimum)                  MA50  24
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA50  25
#                                                                       MA50  26
# GO DO THE FOURIER TRANSFORM FROM RECIPROCAL SPACE TO DIRECT SPACE     MA50  27
# -----------------------------------------------------------------     MA50  28
#                                                                       MA50  29
DO J=MARK1,STOP6+1 ; QX(J+1)=0.0#      Clear storage                    MA50  30
ENTRPY=0.0 ; SUMRHO=0.0 ; SUMRCU=0.0#  Zero sums for entropy and rho    MA50  31
LNRMXS=-9999.0 ; LNRMNS=9999.0#        Get statistics                   MA50  32
PASS=PASSES#                           Reset number of passes           MA50  33
ICORR=MARKN-NG(3)#                     Prepare to store map in memory   MA50  34
IPRIOR=MARKM-NG(3)#                    Prepare to find prior map        MA50  35
DO J=1,3#                              Loop over layer, down, & acros   MA50  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA50  37
IXORG(J)=MOD(ORGX(J)+2*NG(J),NG(J))#   Restore origins                  MA50  38
NP(J)=NPHOLD(J)#                       Restore point counts             MA50  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA50  40
#                                                                       MA50  41
REPEAT#                                Loop over required passes        MA50  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA50  43
#                                                                       MA50  44
# ON SUBSEQUENT PASSES MOVE THE LAYERS BEING TREATED                    MA50  45
# --------------------------------------------------                    MA50  46
#                                                                       MA50  47
IF(PASS<PASSES)#                       Skip if first pass               MA50  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA50  49
IXORG(1)=IXORG(1)+NPP1*IXINC(1)#       Move the origin of first sum     MA50  50
ORGX(1)=ORGX(1)+NPP1*INCX(1)#          Move perceived origin also       MA50  51
NP(1)=NP(1)-NPP1#                      And decrement the points to      MA50  52
IXORG(1)=MOD(IXORG(1)+2*NG(1),NG(1))#  Keep it modulo the number of     MA50  53
IF(PASS>0) NPP1=(NP(1)+PASS-1)/PASS#   Calc no. of points next pass     MA50  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA50  55
#                                                                       MA50  56
IF(PASS<=0) BREAK#                     Quit when pass count = 0         MA50  57
CALL MA52#                             Calc bl summation 1              MA50  58
CALL MA53#                             Set initial factor list          MA50  59
CALL MA60#                             Cal fft summations 2 & 3         MA50  60
PASS=PASS-1#                           Decrement pass count             MA50  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA50  62
IF(CORUSE==yes:) writepkt:(7,endrecord:,NG(3),J)# End ln(rho') file     MA50  63
IF(PRIUSE==yes:) readwpkt:(6,endrecord:,NG(3),J,0)# End ln(rho) file    MA50  64
IF(FINFIT==yes:) writepkt:(5,endrecord:,NG(3),J)# End update rho file   MA50  65
RETURN#                                                                 MA50  66
END#                                                                    MA50  67
systemheader:(MA52)#                   First sum builder                MA52   1
# ################################################################## #  MA52   2
#                                                                    #  MA52   3
#                               MA52                                 #  MA52   4
#                                                                    #  MA52   5
# ################################################################## #  MA52   6
SUBROUTINE MA52#                       Part 5-first sum of transfor     MA52   7
IMPLICIT NONE#                                                          MA52   8
include:(AACOMN)#                      J.m.stewart,j.r.holden 1981      MA52   9
include:(MACOMN)#                      R.doherty,k.watenpaugh 1982      MA52  10
#                                                                       MA52  11
INTEGER ENUF#                          Limit of reflection loop         MA52  12
INTEGER I,IS,J,K,L,M,N#                                                 MA52  13
INTEGER IXORG1,IXINC1#                                                  MA52  14
INTEGER LH(3),IIH(3)#                                                   MA52  15
INTEGER SIGNCD,ZEROCD#                                                  MA52  16
INTEGER NG1,NG1P,NP1,NCENT,IHXS,TNG1,TINCHX#                            MA52  17
INTEGER SUM1BE,SUM1ST,IH2MP1#                                           MA52  18
INTEGER HIGHSY#                                                         MA52  19
INTEGER ID(24),KD(24),JS1,JS2,JS3#                                      MA52  20
INTEGER JREF,JREFP#                    Current reflection pointer       MA52  21
INTEGER KH(24),KK(24),KL(24),KP(24)#                                    MA52  22
REAL A,FCOS,FSIN,TEMP#                                                  MA52  23
REAL HMAX(3)#                                                           MA52  24
#                                                                       MA52  25
chardata:(MA52A,[ CORRECTION FOURIER COEFFICIENTS    H   K   L     $#   MA52  26
  REAL       IMAGINARY       X])#                                       MA52  27
realdata:(FMTR,[370413.,410413.,450413.,571241.,691241.,821241.])#      MA52  28
realdata:(TINY,.0000001)#                                               MA52  29
intdata:(JSTOR,[1,2,3,4,1,2,3,4,1,2,4,3,1,2,4,3])#                      MA52  30
realdata:(FACTOR,[1.,1.,1.,1.,1.,1.,1.,1.,1.,-1.,-1.,1.,1.,-1.,-1.,1.])#MA52  31
intdata:(ISTOR,[1,2,1,2,2,1,2,1])#                                      MA52  32
realdata:(D1,[1.,0.,.5,0.,-.5,0.,-1.,0.,-.5,0.,.5,0.])#                 MA52  33
realdata:(D2,[.0,.0,.8660254,1.,.8660254,.0,.0,.0,-.8660254,-1.,#       MA52  34
-.8660254,.0])#                                                         MA52  35
realdata:(D3,[.0,.0,-.8660254,-1.,-.8660254,.0,.0,.0,.8660254,1.,#      MA52  36
.8660254,.0])#                                                          MA52  37
realdata:(D4,[1.,0.,.5,0.,-.5,0.,-1.,0.,-.5,0.,.5,0.])#                 MA52  38
realdata:(AA,[0.,0.,0.,0.,0.,0.,0.,0.])#                                MA52  39
intdata:(FLIP,[0,0,0,1,0,1,1,1])#                                       MA52  40
intdata:(SIGNS,[0,3,2,1,1,2,3,0])#                                      MA52  41
realdata:(SN,[1.,1.,1.,1.,-1.,1.,1.,-1.,-1.,-1.,1.,1.,-1.,1.,-1.,1.,#   MA52  42
1.,-1.,1.,1.,1.,1.,-1.,1.,-1.,1.,1.,1.,1.,1.,1.,-1.])#                  MA52  43
intdata:(JS,0); intdata:(KS,0)#                                         MA52  44
realdata:(AFAC,0.); realdata:(BFAC,0.)#                                 MA52  45
realdata:(AH,0.); realdata:(AK,0.); realdata:(AL,0.)#                   MA52  46
datastuff:#                                                             MA52  47
#                                                                       MA52  48
#   PREPARE FOR FIRST SUMMATION                                         MA52  49
#   ---------------------------                                         MA52  50
#                                                                       MA52  51
JS1=RSUM1+1; JS2=RSUM2+1; JS3=RSUM3+1# Store coeff sum order            MA52  52
NG1=NG(1); NP1=NPP1#                   Make as local variables          MA52  53
TNG1=2*NG1#                            Grid for interleaved sin cos     MA52  54
IH2MP1=NG(2)#                          Set sum 2 for fft                MA52  55
SUM1ST=4*(IHMAX(3)+1)*IH2MP1#          Set the first sum stepper        MA52  56
NG1P=STOP1+1#                          Set end sum1 as local            MA52  57
IF(ICNT==0) NCENT=4#                   Set hkl loop for centric         MA52  58
ELSE        NCENT=8#                   Set hkl loop for acentric        MA52  59
BFAC=0.0#                              Assume centric                   MA52  60
IF(PPRIOR>3) LINRM=5#                  Make print out neat              MA52  61
#                                                                       MA52  62
#    CHECK FOR HIGH SYMMETRY SPACE GROUPS                               MA52  63
#    ------------------------------------                               MA52  64
#                                                                       MA52  65
HIGHSY=no: ; J=0#                      Assume low                       MA52  66
#                                                                       MA52  67
# SET UP SIN COS TABLES FOR FIRST SUM                                   MA52  68
# -----------------------------------                                   MA52  69
#                                                                       MA52  70
TEMP=TWOPI/FLOAT(NG(1));  A=0.#        Get first sum grid step          MA52  71
DO  I=MARK1,STOP1,STEP1#               Loop over sum1 grid              MA52  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA52  73
QX(I+1)=COS(A); QX(I+2)=SIN(A)#        Store interleaved cos sin        MA52  74
A=A+TEMP#                              Incr to next angle               MA52  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA52  76
#                                                                       MA52  77
# CLEAR THE FIRST SUM TABLE OF SECOND SUM COEFFICIENTS                  MA52  78
# ----------------------------------------------------                  MA52  79
#                                                                       MA52  80
DO J=MARK6,STOP6; QX(J+1)=0.#          Zeroize sum 2 coefficients       MA52  81
DO J=1,NROT ; KD(J)=J#                 Set default hkl sort order       MA52  82
DO J=1,3; IIH(J)=9#                    Reset reflection indices         MA52  83
DO J=1,3; LH(J)=0#                     Reset reflection indices         MA52  84
DO J=1,3; HMAX(J)=FLOAT(MAXH(J))+.5#   Float hkl maxima                 MA52  85
IS=1;  FSIN=0.;  FCOS=1.#              Reset sign & imag factor         MA52  86
#                                                                       MA52  87
# FOR A USUAL FOURIER TRANSFORM SET F000 TO BE FIRST COEFF.  BUT        MA52  88
# IN THE CASE OF THIS "CORRECTION" MAP FOR MEPHAS SET IT TO ZERO        MA52  89
# ---------------------------------------------------------------       MA52  90
#AA(1)=0.5*F0000#                      PLACE F(000) AS COEFF1           MA52  91
AA(1)=0.0#                             Place zero, null, gar nichts     MA52  92
IXINC1=IXINC(1)#                       Move incr to local store         MA52  93
IXORG1=IXORG(1)#                       Same for origin                  MA52  94
#                                                                       MA52  95
#   START HEMISPHERE REFLECTION LOOP                                    MA52  96
#   ===============================                                     MA52  97
#                                                                       MA52  98
#                                                                       MA52  99
JREF=MXNEW+1 ; ENUF=JREF+NREF ; JREFP=MARKR# Set pointers to refls      MA52 100
REPEAT#                                Loop over all reflections        MA52 101
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA52 102
JREF=JREF+1 ; JREFP=JREFP+STEPR#       Move to next reflection          MA52 103
IF(JREF>ENUF) GOTO75#                  Test all asymmetric refls done   MA52 104
#                                                                       MA52 105
AH=QX(JREFP+1) ; AK=QX(JREFP+2) ; AL=QX(JREFP+3)#                       MA52 106
#                                                                       MA52 107
#   CALCULATE A & B COEFFICIENTS FROM THE TRIAL PHASES AND THE          MA52 108
#   PRINCE'S DUAL FUNCTION MULTIPLIERS                                  MA52 109
##  e.g.  AFAC=0.5*(Prince's multiplier)*(A of reflection)              MA52 110
#   ----------------------------------------------------------          MA52 111
#                                                                       MA52 112
AFAC=0.5*QX(JREF)*QX(JREFP+8)#         Get real factor of coeff.        MA52 113
IF(ICNT==1)#                           For acentric need a & b          MA52 114
BFAC=0.5*QX(JREF)*QX(JREFP+9)#         Get imaginary factor of coef     MA52 115
IF(PPRIOR>4)#                          At high priority print coefs     MA52 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA52 117
BUFOT(1)=AH ; BUFOT(2)=AK ; BUFOT(3)=AL# H, k, and l                    MA52 118
BUFOT(4)=AFAC ; BUFOT(5)=BFAC#         A and b used as unique coefs     MA52 119
BUFOT(6)=QX(JREF)#                                                      MA52 120
ncodefld:(BUFOT,1,CHROT,FMTR,6) ; writeline:(0,MA52A,NMA52A,1,5)#       MA52 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA52 122
#                                                                       MA52 123
#   GENERATE SYMMETRY RELATED REFLECTIONS FOR ACTUAL SUMMATION          MA52 124
#   ----------------------------------------------------------          MA52 125
#                                                                       MA52 126
L=0; M=0; N=0#                         Zero duplicate counts            MA52 127
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symmetry matrices      MA52 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA52 129
M=M+1#                                 Count generated reflections      MA52 130
KH(M)=NINT(AH*QX(J+1)+AK*QX(J+2)+AL*QX(J+3))# Generate new h            MA52 131
KK(M)=NINT(AH*QX(J+4)+AK*QX(J+5)+AL*QX(J+6))# Generate new k            MA52 132
KL(M)=NINT(AH*QX(J+7)+AK*QX(J+8)+AL*QX(J+9))# Generate new l            MA52 133
KP(M)=NINT((AH*QX(J+10)+AK*QX(J+11)+AL*QX(J+12))*12.)# Phase shift      MA52 134
IF(NRSZ==NROT) NEXT#                   Skip if no duplicates            MA52 135
K=IABS(KL(M))*261244+IABS(KK(M))*512+IABS(KH(M))# Form sort word        MA52 136
FOR(I=1;I<=N;I=I+1)#                   Loop over duplicate list         MA52 137
IF(K==KD(I))BREAK#                     Exit search on match             MA52 138
ID(M)=I#                               Store duplicate order            MA52 139
IF(I<=N) NEXT#                         Skip if old duplicate            MA52 140
KD(I)=K; N=I#                          Update if new duplicate          MA52 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA52 142
FOR(I=1;I<=N;I=I+1)#                   Loop over duplicate list         MA52 143
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA52 144
DO J=1,NROT#                           Loop over equiv hkl list         MA52 145
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA52 146
IF(ID(J)!=I) NEXT#                     Skip on no match                 MA52 147
L=L+1; KD(L)=J#                        Store duplicate sort order       MA52 148
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA52 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA52 150
#                                                                       MA52 151
#     SUM EQUIVALENT HKL IN SORTED ORDER                                MA52 152
#     ----------------------------------                                MA52 153
#                                                                       MA52 154
75     CONTINUE#                       Branch point for last packet     MA52 155
FOR(JS=1;JS<=NROT;JS=JS+1)#            Loop over hkl list               MA52 156
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA52 157
KS=KD(JS)#                             Pick up sequence number          MA52 158
IIH(ISUM1)=IABS(KH(KS))#               Sorted h permuted                MA52 159
IIH(ISUM2)=IABS(KK(KS))#               Sorted k permuted                MA52 160
IIH(ISUM3)=IABS(KL(KS))#               Sorted l permuted                MA52 161
#                                                                       MA52 162
#     SUM COEFFICIENT IF NEXT HKL HAS DIFFERENT MAGNITUDE OF HKL        MA52 163
#     OR ALL REFLECTIONS HAVE BEEN PROCESSED                            MA52 164
#     ----------------------------------------------------------        MA52 165
#                                                                       MA52 166
IF(LH(1)!=IIH(1)\LH(2)!=IIH(2)\LH(3)!=IIH(3)\JREF>ENUF)# Time to sum?   MA52 167
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA52 168
#                                                                       MA52 169
#    ACCUMULATE THE FIRST SUM                                           MA52 170
#    ------------------------                                           MA52 171
#                                                                       MA52 172
SUM1BE=4*(LH(2)+LH(3)*IH2MP1)+MARK6#   Set beginning of first sum       MA52 173
IHXS=2*MOD(LH(1)*IXORG1,NG1)+MARK1#    Point to sin cos values          MA52 174
TINCHX=2*MOD(LH(1)*IXINC1,NG1)#        Make hx incr for index           MA52 175
L=0#                                   Set sign counter                 MA52 176
J=8#                                   Set pointer for fft              MA52 177
DO K=1,NCENT#                          Loop over sign coeff             MA52 178
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MA52 179
IF(K<=4)#                              Test if real summation           MA52 180
A=SN(L+1)*AA(    1)+SN(L+2)*AA(JS1  )$# Sum real coefficients           MA52 181
+ SN(L+3)*AA(JS2  )+SN(L+4)*AA(JS3  )# Sum real coefficients            MA52 182
ELSE#                                  Else are imaginary               MA52 183
A=SN(L+1)*AA(    5)+SN(L+2)*AA(JS1+4)$# Sum imag coefficients           MA52 184
+ SN(L+3)*AA(JS2+4)+SN(L+4)*AA(JS3+4)# Sum imag coefficients            MA52 185
J=J+1;   L=L+4#                        Increment pointer                MA52 186
IF(ABS(A)<TINY) NEXT#                  Ignore zero coeff.s              MA52 187
A=A*FACTOR(J)#                         Store coeff as local variabl     MA52 188
M=JSTOR(J)+SUM1BE#                     Extract storage offset value     MA52 189
N=ISTOR(K)+IHXS#                       Point to sin(hx) cos(hx)         MA52 190
DO I=1,NP1#                            Loop over first sum points       MA52 191
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MA52 192
QX(M)=QX(M)+A*QX(N)#                   Form first fourier sum           MA52 193
M=M+SUM1ST#                            Increment storage pointer        MA52 194
N=N+TINCHX#                            Increment hx pointer             MA52 195
IF(N>NG1P) N=N-TNG1#                   Adjust hx if off b-l strip       MA52 196
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MA52 197
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MA52 198
LH(1)=IIH(1); LH(2)=IIH(2); LH(3)=IIH(3)# Reset current hkl to last     MA52 199
DO J=1,NCENT; AA(J)=0.#                Reset all coefficients           MA52 200
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA52 201
IF(JREF>ENUF) BREAK#                   End of first summation           MA52 202
#                                                                       MA52 203
#                                                                       MA52 204
#     HAVING REDUCED THE PATTERN OF SIGNS AND ZEROS TO TWO              MA52 205
#     INTEGER VALUES ACCORDING TO THE FOLLOWING TABLE IT IS             MA52 206
#     NECESSARY TO MAKE THE SIGN CODE CONFORM TO THE METHOD             MA52 207
#     OF SUMMATION.  THE APPROACH TAKEN IS HEURISTIC AND                MA52 208
#     NOT AT ALL INTELLECTUALLY SATISFYING.                             MA52 209
#     THE VALUES IN THE TABLE ARE A FUNCTION OF THE CHOICE OF           MA52 210
#     HEMISPHERE AT THE TIME THE GENERAL FOURIER EXPRESSION             MA52 211
#     IS FACTORED.                                                      MA52 212
#                                                                       MA52 213
#     SIGNS    ZEROS     SIGNCD      ZEROCD                             MA52 214
#     +++     NNN         0           0                                 MA52 215
#     ++-     NN0         1           1                                 MA52 216
#     +-+     N0N         2           2                                 MA52 217
#     +--     N00         3           3                                 MA52 218
#     -++     0NN         4           4                                 MA52 219
#     -+-     0N0         5           5                                 MA52 220
#     --+     00N         6           6                                 MA52 221
#     ---     000         7           7                                 MA52 222
#                                                                       MA52 223
#      THIS TABLE SHOWS THE CODES REQUIRED TO PRODUCE THE CORRECT       MA52 224
#      FOURIER TRANSFORM AS A FUNCTION OF SIGNCD AND ZEROCD. THE        MA52 225
#      IF STATEMENT WHICH FOLLOWS THE TABLE TRANSFORMS THE SIGNCD       MA52 226
#      VALUE TO CONFORM TO THE TABLE VALUE                              MA52 227
#      THE BODY OF THE TABLE CONTAINS THE CORRECT VALUES OF             MA52 228
#      SIGNCD.  THE AXIAL AND ZONAL REFLECTIONS ARE THE                 MA52 229
#      PROBLEM.                                                         MA52 230
#                                                                       MA52 231
#            ZEROCD'S                                                   MA52 232
#              0    1    2    3    4    5    6    7                     MA52 233
#   SIGNCD'S                                                            MA52 234
#      0       0    0    0    0    0    0    0    0                     MA52 235
#      1       1         3         5         7                          MA52 236
#      2       2    3              2    7                               MA52 237
#      3       3                   7                                    MA52 238
#      4       4    4    4    7                                         MA52 239
#      5       5         7                                              MA52 240
#      6       6    7                                                   MA52 241
#      7       7                                                        MA52 242
#                                                                       MA52 243
IF(KL(KS)<0) SIGNCD=1#                 Get sign code of l               MA52 244
ELSE         SIGNCD=0#                                                  MA52 245
IF(KK(KS)<0) SIGNCD=SIGNCD+2#          Add on sign code of k            MA52 246
IF(KH(KS)<0) SIGNCD=SIGNCD+4#          And that of h                    MA52 247
IF(KL(KS)==0) ZEROCD=1#                Set zero code of l               MA52 248
ELSE          ZEROCD=0#                                                 MA52 249
IF(KK(KS)==0) ZEROCD=ZEROCD+2#         Add on zero code of k            MA52 250
IF(KH(KS)==0) ZEROCD=ZEROCD+4#         And that of h                    MA52 251
IF((MOD(SIGNCD,2)==1)\ $#              Decode axial & zonal codes       MA52 252
((SIGNCD==2)&(ZEROCD!=4))\ $#          Decode axial & zonal codes       MA52 253
((SIGNCD==4)&(ZEROCD==3))\ $#          Decode axial & zonal codes       MA52 254
(SIGNCD==6)) SIGNCD=SIGNCD+ZEROCD#     Decode axial & zonal codes       MA52 255
#                                                                       MA52 256
#                                                                       MA52 257
#                                                                       MA52 258
#     GENERATE THE CONTRIBUTION OF THE CURRENT REFLECTION A AND B       MA52 259
#     AS TRANSFORMED BY THE SYMMETRY DRIVERS INTO                       MA52 260
#     A(+++), OR A(-++), OR A(+-+), OR A(++-) AND                       MA52 261
#     B(+++), OR B(-++), OR B(+-+), OR B(++-) WHICH ARE STORED          MA52 262
#      IN A(1) TO A(8) RESPECTIVELY.........                            MA52 263
#                                                                       MA52 264
#                                                                       MA52 265
IS=MOD(KP(KS)+4800,12)+1#              Get phase shift in 12ths         MA52 266
J=SIGNS(SIGNCD+1)#                     Permute the sign codes           MA52 267
AA(J+1)=D1(IS)*AFAC+D2(IS)*BFAC#       Phase shift real coeff           MA52 268
IF(ICNT==0) NEXT#                      Skip imag part if centric        MA52 269
AA(J+5)=D3(IS)*AFAC+D4(IS)*BFAC#       Phase shift imag coeff           MA52 270
IF(FLIP(SIGNCD+1)==yes:) AA(J+5)=-AA(J+5)# Is hkl in rev. hemisphere    MA52 271
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA52 272
IF(JREF>ENUF) BREAK#                   Exit if last hkl                 MA52 273
#                                                                       MA52 274
100 CONTINUE#                                                           MA52 275
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA52 276
#                                                                       MA52 277
#                                                                       MA52 278
RETURN#                                                                 MA52 279
END#                                                                    MA52 280
systemheader:(MA53)#                                                    MA53   1
#******************************************************************#    MA53   2
#                                                                  #    MA53   3
#                              MA53                                #    MA53   4
#                                                                  #    MA53   5
#******************************************************************#    MA53   6
SUBROUTINE MA53#                                                        MA53   7
IMPLICIT NONE#                                                          MA53   8
include:(AACOMN)#                                                       MA53   9
include:(MACOMN)#                                                       MA53  10
#                                                                       MA53  11
# THIS PROGRAM FACTORS THE NUMBER OF POINTS ALONG AN AXIS, AND          MA53  12
# MAKES A TABLE OF POINTERS THAT WILL BE USED TO UNSCRAMBLE THE ARRAY   MA53  13
# AFTER THE FFT HAS BEEN DONE.                                          MA53  14
# THE POINTERS ARE STORED IN THE FIRST N LOCATIONS AFTER START.  THE    MA53  15
# POINTERS ARE FOLLOWED BY THE FACTORS IN ORDER OF DECREASING MAGNITUDE MA53  16
# DOHERTY, 10/80                                                        MA53  17
#                                                                       MA53  18
INTEGER NTEST#                                                          MA53  19
INTEGER START#                         Pointer to place before begi     MA53  20
INTEGER I23#                           Index to tell whether 2nd or     MA53  21
INTEGER IS#                            End of key and factor list       MA53  22
INTEGER N#                             Number of grid points along      MA53  23
INTEGER I#                                                              MA53  24
INTEGER LK#                            Index for pointer table          MA53  25
INTEGER L#                             Index for loop that steps ov     MA53  26
INTEGER K#                             Index for loop that steps ov     MA53  27
INTEGER J#                             Index for factor list            MA53  28
REAL  ADD#                             Contribution to pointer from     MA53  29
REAL MULT#                             Multiplier for step size for     MA53  30
#                                                                       MA53  31
#                                                                       MA53  32
# THE FACTOR LIST MUST BE FOUND FOR BOTH THE SECOND AND THIRD SUMS.     MA53  33
# FIND THE FACTORS AND CONSTRUCT THE KEY NEEDED TO UNSCRAMBLE THE       MA53  34
# COMPLETED FOURIER TRANSFORM FOR THE TWO SUMS.                         MA53  35
#                                                                       MA53  36
K=MARK2+1#                             Begin by zeroing the locatio     MA53  37
DO J=K,STOP3#                          Do it for both 2nd and 3rd s     MA53  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA53  39
QX(J)=0.#                                                               MA53  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA53  41
START=MARK2#                           Do the key for the second su     MA53  42
IS=STOP2#                                                               MA53  43
FOR(I23=2;I23<=3;I23=I23+1)#                                            MA53  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA53  45
IF(I23==3)#                            If this is for 3rd sum, put      MA53  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA53  47
START=MARK3#                                                            MA53  48
IS=STOP3#                                                               MA53  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA53  50
N=NG(I23)#                             Pick up the number of grid p     MA53  51
#                                                                       MA53  52
#                                                                       MA53  53
# SET UP FOR FACTOR SEARCH                                              MA53  54
#                                                                       MA53  55
J=START+N+1#                           Pointer for factors              MA53  56
I=5#                                   First possible factor            MA53  57
MULT=1.#                               Multiplier is 1 for the firs     MA53  58
NTEST=N#                                                                MA53  59
#                                                                       MA53  60
# THE SEARCH FOR FACTORS WILL CONTINUE AS LONG AS ANY REMAIN.  AS EACH  MA53  61
# FACTOR IS FOUND, NTEST IS DIVIDED BY THAT FACTOR.  WHEN NTEST IS 1, A MA53  62
# THE FACTORS HAVE BEEN FOUND.                                          MA53  63
# A PRELIMINARY SCREENING IN FS30 HAS ENSURED THAT NG CONTAINS ONLY THE MA53  64
# PERMITTED FACTORS (I.E., 2,3,4 OR 5).                                 MA53  65
#                                                                       MA53  66
WHILE ((NTEST>1)&(I>=2))#              Go on until all factors are      MA53  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA53  68
IF(NTEST==(NTEST/I)*I)#                This is true if i is a facto     MA53  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA53  70
QX(J)=FLOAT(I)#                        Store the factor i in the fa     MA53  71
NTEST=NTEST/I#                         Remove this factor for next      MA53  72
J=J+1#                                 Increment index of factor ar     MA53  73
#                                                                       MA53  74
# BEGIN TO BUILD UP THE CONTRIBUTIONS TO THE KEY FOR UNSCRAMBLING THE   MA53  75
# COMPLETED TRANSFORM.  EACH FACTOR WILL MAKE A CONTRIBUTION TO EACH    MA53  76
# ITEM IN THE KEY.                                                      MA53  77
#                                                                       MA53  78
ADD=0.#                                                                 MA53  79
LK=START#                                                               MA53  80
DO L=1,N,NTEST#                                                         MA53  81
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA53  82
DO K=1,NTEST#                                                           MA53  83
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA53  84
LK=LK+1#                                                                MA53  85
QX(LK)=QX(LK)+ADD#                                                      MA53  86
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA53  87
ADD=AMOD(ADD+MULT,FLOAT(I)*MULT)#                                       MA53  88
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA53  89
MULT=MULT*FLOAT(I)#                                                     MA53  90
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA53  91
ELSE I=I-1#                            I was not a factor, so move      MA53  92
IF(J>IS) iquit:(ma:5301)#              Don't allow more factors tha     MA53  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA53  94
#                                                                       MA53  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA53  96
RETURN#                                                                 MA53  97
END#                                                                    MA53  98
systemheader:(MA60)#                                                    MA60   1
# ################################################################## #  MA60   2
#                                                                    #  MA60   3
#                               MA60                                 #  MA60   4
#                                                                    #  MA60   5
# ################################################################## #  MA60   6
SUBROUTINE MA60#                       Part 6-second and third sums     MA60   7
IMPLICIT NONE#                                                          MA60   8
include:(AACOMN)#                      J.m.stewart,j.r.holden 1981      MA60   9
include:(MACOMN)#                      R.doherty, s.r.hall 1982         MA60  10
#                                                                       MA60  11
# APPLY FFT SECOND AND THIRD SUMS USING THE COEFFICIENTS WHICH WERE     MA60  12
# PRODUCED BY THE FIRST SUM PROGRAM MA52.  THE SECOND SUM COEFFICIENTS  MA60  13
# (FIRST SUM RESULTS) WHICH CAN BE HELD IN IMMEDIATE ACCESS STORAGE ARE MA60  14
# TREATED.  THE PROGRAM IS A DRASTIC RECODING OF FS60 OF XTAL.          MA60  15
#                            J.STEWART AND R. DOHERTY , NOV. 1980       MA60  16
#                                                                       MA60  17
# IN THIS VERSION THE THIRD SUM IS DONE BY THE FAST FOURIER TRANSFORM   MA60  18
# ALGORITHM.                                                            MA60  19
# IN FS60, THE THIRD SUM TO YIELD THE ELECTRON DENSITY (RHO) MAY BE     MA60  20
# EXPRESSED AS-                                                         MA60  21
#    RHO(X1,X2,X3)=SUM[D1*COS(2PI*I*H3*X3)]+SUM[D2*SIN(2PI*I*H3*X3)]    MA60  22
# THIS IS EQUIVALENT TO                                                 MA60  23
#                                                                       MA60  24
#    RHO(X1,X2,X3)=RE(SUM[(D1-I*D2)*EXP(2PI*I*H3*X3)]                   MA60  25
#                                                                       MA60  26
# THIS IS THE SUMMATION DONE BY THE FFT.  NOTICE THAT                   MA60  27
# (1) THE COEFFICIENT IN THE FFT IS D1 MINUS I*D2 (NOT PLUS)            MA60  28
#     THEREFORE THE "IMAGINARY" PARTS OF THE COEFFICIENTS FROM THE      MA60  29
#     SECOND SUM ARE STORED AS THE NEGATIVE OF THE VALUE FROM THE SUM.  MA60  30
# (2) ONLY THE REAL PART OF THE TRANSFORM CORRESPONDS TO THE ELECTRON   MA60  31
#     DENSITY.                                                          MA60  32
#                                                                       MA60  33
# R. DOHERTY, 11-80                                                     MA60  34
# QX(MARK1+1)    THE MARK1 ARRAY IS THE INTERLEAVED COS AND SIN STRIP   MA60  35
# QX(MARK1+2)    FOR FIRST SUM STEP1=2                                  MA60  36
# QX(MARK2+1)    TRIG TABLES FOR SECOND SUM S. MARK2=MARK1              MA60  37
# QX(MARK2+2)                                                           MA60  38
# QX(MARK3+1)      THE MARK3 ARRAY IS THE KEY FOR UNSCRAMBLING THE RESU MA60  39
#                  OF THE FFT, FOLLOWED BY THE LIST OF FACTORS OF NG3   MA60  40
# QX(MARK6+1)    THE MARK6 ARRAY CONTAINS THE FIRST SUM RESULTS WHICH   MA60  41
# QX(MARK6+2)    SERVE AS COEFFICIENTS OF THE SECOND SUM . STEP6=4      MA60  42
# QX(MARK6+3)                        #                                  MA60  43
# QX(MARK6+4)                        #                                  MA60  44
# QX(MARK4+1)    THE MARK4 ARRAY CONTAINS SECOND SUM RESULTS WHICH      MA60  45
# QX(MARK4+2)    SERVE AS THE THIRD SUM COEFFICIENTS. STEP4=2           MA60  46
# QX(MARK5+1)    THE FINAL RESULT FOR ONE LINE OF THE TRANSFORM #       MA60  47
#                                                                       MA60  48
REAL    ENTP2,ENTP3#                   Partial sums                     MA60  49
INTEGER LW,IX1,IX2#                                                     MA60  50
INTEGER IORGX1,IORGX2#                                                  MA60  51
INTEGER STPSIZ#                        Step size over each coeffici     MA60  52
INTEGER KK,JJ,ZJP#                                                      MA60  53
INTEGER L,M,N#                                                          MA60  54
REAL    LNRHO#      ## Ln(rho) at a given pixel, rho in electrons/pix   MA60  55
INTEGER ND#                            Factor to be used in denom o     MA60  56
INTEGER INCX1,INCX2,INCX3,NG1,NG2,NG3,NP1,NP2,NP3#                      MA60  57
INTEGER J,I,I3,IH2M,K,I3P,IH3M#                                         MA60  58
REAL    RHO#                           Rho correction for output        MA60  59
REAL    RHOCU2,RHOCU3#                 Partial sums cubed e.d.          MA60  60
REAL    RHOP2,RHOP3#                   Partial sums e.d.                MA60  61
INTEGER THSTEP#                        Step over lines of coefficie     MA60  62
REAL DTTHD#                                                             MA60  63
chardata:(MA60A,[ LAYER  DOWN ACRSS  LN(RHO PRIOR)   LN(RHO CORR)   $#  MA60  64
LN(RHO MIN)     LN(RHO)      RHO])#                                     MA60  65
realdata:(FMTR,[60513.,120513.,180513.,311241.,461241.,601241.,$#       MA60  66
731241.,861241.])#                                                      MA60  67
intdata:(LSAMP,[25])#                                                   MA60  68
datastuff:#                                                             MA60  69
#                                                                       MA60  70
#                                                                       MA60  71
#   PREPARE SUMMATION PARAMETERS                                        MA60  72
#   ----------------------------                                        MA60  73
#                                                                       MA60  74
INCX1=INCX(1); INCX2=INCX(2); INCX3=INCX(3)#                            MA60  75
IORGX1=ORGX(1)#                                                         MA60  76
IORGX2=ORGX(2)#                                                         MA60  77
DTTHD=FLOAT(INCX3)#                    Float third sum step size        MA60  78
NG1=NG(1); NG2=NG(2); NG3=NG(3)#                                        MA60  79
NP1=NPP1; NP2=NP(2); NP3=NP(3)#                                         MA60  80
IH2M=STEP6*NG2#                        Step over single values of h     MA60  81
IH3M=2*NG3#                                                             MA60  82
LW=MARK5+NG3#                          Figure length needed for one     MA60  83
J=MARK6-IH2M#                          Set second sum coefficient       MA60  84
THSTEP=IH3M*INCX2#                                                      MA60  85
IF(PPRIOR>4) LINRM=5#                  Make pretty dumps                MA60  86
#                                                                       MA60  87
#                                                                       MA60  88
#                                                                       MA60  89
# SCAN OVER ALL LAYERS WITH FIRST SUM COEFFICIENTS STORED IN MEMORY     MA60  90
# -----------------------------------------------------------------     MA60  91
#                                                                       MA60  92
#                                                                       MA60  93
DO IX1=1,NP1#                          Do all layers possible on        MA60  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA60  95
DO I=MARK4,STOP4; QX(I)=0.#            Clear third sum coeff table      MA60  96
I3P=MARK4+2*IHMAX(3)#                                                   MA60  97
STPSIZ=STEP6#                                                           MA60  98
#                                                                       MA60  99
# START OF SECOND SUM                                                   MA60 100
# -------------------                                                   MA60 101
#                                                                       MA60 102
DO I3=MARK4,I3P,2#                     Scan through all h3              MA60 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA60 104
ND=NG2#                                                                 MA60 105
I=MARK2+NG2+1; J=J+IH2M#                                                MA60 106
CALL MA61(I,J,ND,STPSIZ)#                                               MA60 107
I=MARK2+NG2+1#                                                          MA60 108
KK=J+2; ND=NG2#                                                         MA60 109
CALL MA61(I,KK,ND,STPSIZ)#                                              MA60 110
I=MARK2; KK=J-3; JJ=KK+2#                                               MA60 111
DO L=1,NG2#                                                             MA60 112
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA60 113
I=I+1#                                                                  MA60 114
KK=KK+STEP6; JJ=JJ+STEP6#                                               MA60 115
N=I3+NINT(QX(I))*IH3M#                                                  MA60 116
QX(N+1)=QX(KK); QX(N+2)=-QX(JJ)#                                        MA60 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA60 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA60 119
#                                                                       MA60 120
#                                                                       MA60 121
K=MARK4+IH3M*(IORGX2-INCX2)#           Start of third sum coeff         MA60 122
STPSIZ=STEP4#                                                           MA60 123
#                                                                       MA60 124
#  LOOP OVER SECOND SUM POINTS                                          MA60 125
#  ---------------------------                                          MA60 126
#                                                                       MA60 127
ENTP2=0.0 ; RHOP2=0.0 ; RHOCU2=0.0#    Partial sums to foil errors      MA60 128
DO IX2=1,NP2#                          Loop over all second sum poi     MA60 129
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA60 130
DO I3=MARK5,LW;  QX(I3)=0.#            Clear third sum line             MA60 131
#                                                                       MA60 132
# DO SUM BY FFT AND SORT IT INTO QX(MARK5+1) ET SEQ.                    MA60 133
# BEFORE THE FIRST STEP OF THE FFT IS BEGUN, EACH PAIR OF WORDS STARTIN MA60 134
# IN QX(MARK4+1) CONTAINS THE CONTRIBUTION FROM REFLECTIONS WITH ONE    MA60 135
# VALUE OF H(3).  THEREFORE IN ORDER TO DO THE TRANSFORMATION, A        MA60 136
# CONTRIBUTION MUST BE ADDED IN FROM EACH OF THE NG(3) PAIRS FOR EACH   MA60 137
# POINT.  AFTER A CYCLE OF THE FFT USING FACTOR F, THERE ARE CONTRIBUTI MA60 138
# FROM F VALUES OF H(3), SO ONE NEED ONLY ADD THE CONTRIBUTIONS FROM NG MA60 139
# PAIRS.  IN GENERAL, NG(3)/NSUMS PAIRS MUST BE ADDED TO GIVE THE COMPL MA60 140
# TRANSFORM.                                                            MA60 141
#                                                                       MA60 142
ND=NG3#                                                                 MA60 143
I=MARK3+NG3+1#                         Start of factor list             MA60 144
K=K+THSTEP#                                                             MA60 145
CALL MA61(I,K,ND,STPSIZ)#                                               MA60 146
#                                                                       MA60 147
# AT THIS POINT THE VALUES OF THE TRANSFORM AT THE NG(3) POINTS OF THE  MA60 148
# CURRENT LINE ARE SCRAMBLED IN THE QX ARRAY.  THE KEY FOR UNSCRAMBLING MA60 149
# BEGIN IN QX(MARK3+1). THE ELEMENTS IN THE MARK3 PORTION POINT TO      MA60 150
# WHERE THE ELEMENTS IN THE MARK4 PORTION BELONG IN THE UNSCRAMBLED     MA60 151
# ARRAY.                                                                MA60 152
#                                                                       MA60 153
I=MARK3; KK=K-1; N=MARK5+1#                                             MA60 154
DO L=1,NG3#                            Loop over the ng(3) points       MA60 155
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA60 156
I=I+1; KK=KK+2#                        Step by 2, getting only real     MA60 157
M=N+NINT(QX(I))#                       Find where qx(kk) properly b     MA60 158
QX(M)=QX(KK)#                          Put it there                     MA60 159
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA60 160
#                                                                       MA60 161
#   GET AND OUTPUT MAP TO MEMORY OR FILE AS STORAGE ALLOWS              MA60 162
#   ------------------------------------------------------              MA60 163
#                                                                       MA60 164
IF(CORUSE==yes:) writepkt:(7,22,NG3,ICORR)# Put out rho corrected       MA60 165
ELSE ICORR=ICORR+NG3#                  Or advance storage pointer       MA60 166
IF(PRIUSE==yes:) readwpkt:(6,22,NG3,IPRIOR,0)# Get ln(rho) prior        MA60 167
ELSE IPRIOR=IPRIOR+NG3#                Or advance storage pointers      MA60 168
IF(FINFIT==yes:) writepkt:(5,22,NG3,ZJP)# Write updated map; last sho   MA60 169
ENTP3=0.0 ; RHOP3=0.0 ; RHOCU3=0.0#    Partial sums to foil errors      MA60 170
DO L=1,NG3#                            Loop over line in map            MA60 171
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA60 172
#                                                                       MA60 173
# IPRIOR+L POINTS TO A PIXEL OF THE 'PRIOR' MAP; ICORR+L TO THE MAP     MA60 174
# BEING 'FITTED'. IN THIS PROGRAM THE ELECTRON DENSITY, RHO, IS ALWAYS  MA60 175
# THE 'TRUE'  ELECTRON DENSITY TIMES VOL/TOTPIX.  THAT IS, ELECTRONS    MA60 176
# PER PIXEL INSTEAD OF ELECTRONS PER CUBIC ANGSTROM.  THE FACTOR        MA60 177
# LNFOFC IS LN(FO(0,0,0)/FC(0,0,0)), THE RESCALE FACTOR TO CONTROL      MA60 178
# THE 'PRIOR' MAP SCALE                                                 MA60 179
# --------------------------------------------------------------------  MA60 180
#                                                                       MA60 181
## ln(rho updated) =                                                    MA60 182
##                   ((ln(rho max current)-ln(rho min current))/        MA60 183
##                   (ln(rho max prior)-ln(rho min prior)))*            MA60 184
##                   (ln(rho prior)-ln(rho min prior))+                 MA60 185
##                    ln(rho correction)+ln(rho min updated)            MA60 186
LNRHO=(CNTRST/CNTRSP)*(QX(IPRIOR+L)-LNRHMP)+QX(MARK5+L)+LNRHMN#         MA60 187
LNRMXS=AMAX1(LNRMXS,LNRHO) ; LNRMNS=AMIN1(LNRMNS,LNRHO)# Stats          MA60 188
RHO=EXP(LNRHO)#                        Restore rho(elec/pixel)          MA60 189
IF(FINFIT==yes:)#                      Only on final run                MA60 190
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA60 191
QX(ZJP+L)=EXP(LNRHO-LNRHSC)#           Reconstitute medens c.e.e.d.     MA60 192
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA60 193
IF(PPRIOR>4)#                          Dump sample?                     MA60 194
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA60 195
IF(MOD(L-1,LSAMP)==0&$#                                                 MA60 196
MOD(IX2-1,LSAMP)==0)#                  For the selected few             MA60 197
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MA60 198
BUFOT(1)=FLOAT(IX1-1) ; BUFOT(2)=FLOAT(IX2-1) ; BUFOT(3)=FLOAT(L-1)#    MA60 199
BUFOT(4)=QX(IPRIOR+L) ; BUFOT(5)=QX(MARK5+L) ; BUFOT(6)=LNFOFC#         MA60 200
BUFOT(7)=LNRHO ; BUFOT(8)=RHO#                                          MA60 201
ncodefld:(BUFOT,1,CHROT,FMTR,8) ; writeline:(0,MA60A,NMA60A,1,5)#       MA60 202
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MA60 203
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA60 204
#                                                                       MA60 205
# IN PREPARATION FOR THE REVERSE FOURIER TRANSFORM STORE THE ELECTRON   MA60 206
# DENSITY IN ELECTRONS PER PIXEL TO PRODUCE FC VALUES FOR THE NREF      MA60 207
# REFLECTIONS BEING PHASED.                                             MA60 208
# -------------------------------------------------------------------   MA60 209
#                                                                       MA60 210
QX(ICORR+L)=RHO#                       Save new density for next cycl   MA60 211
ENTP3=ENTP3-RHO*LNRHO#                 Contribute pixel value to entr   MA60 212
RHOP3=RHOP3+RHO#                       Get sum get fc000 if all well    MA60 213
RHOCU3=RHOCU3+RHO**3#                  Sum of cubed e.d. for features   MA60 214
#                                                                       MA60 215
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA60 216
ENTP2=ENTP2+ENTP3 ; RHOP2=RHOP2+RHOP3 ; RHOCU2=RHOCU2+RHOCU3# Part su   MA60 217
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA60 218
ENTRPY=ENTRPY+ENTP2 ; SUMRHO=SUMRHO+RHOP2 ; SUMRCU=SUMRCU+RHOCU2# Par   MA60 219
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA60 220
#                                                                       MA60 221
RETURN#                                                                 MA60 222
END#                                                                    MA60 223
systemheader:(MA61)#                                                    MA61   1
# ####################################################################  MA61   2
#                                                                       MA61   3
#                                   MA61                                MA61   4
#                                                                       MA61   5
# ####################################################################  MA61   6
SUBROUTINE MA61(I,K,ND,STPSIZ)#                                         MA61   7
IMPLICIT NONE#                                                          MA61   8
include:(AACOMN)#                                                       MA61   9
include:(MACOMN)#                                                       MA61  10
#                                                                       MA61  11
INTEGER I#                             Pointer to factor list           MA61  12
INTEGER F#                             Current factor                   MA61  13
INTEGER K#                             Pointer to start of transfor     MA61  14
INTEGER ND#                            Denominator for exp. q term      MA61  15
INTEGER NF#                            No. of pairs to be considere     MA61  16
INTEGER NSEP#                          Separation between start of      MA61  17
INTEGER K1,K2,K3,K4,K5#                Start of small sums              MA61  18
INTEGER NSUMS#                         No. of small sums                MA61  19
INTEGER STPSIZ#                        Spacing between "real" parts     MA61  20
#                                                                       MA61  21
NF=ND#                                                                  MA61  22
NSUMS=1#                                                                MA61  23
REPEAT#                                                                 MA61  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA61  25
F=NINT(QX(I))#                         Make factor an integer           MA61  26
IF(F==0) BREAK#                        Zero factor marks end of lis     MA61  27
NF=NF/F#                                                                MA61  28
NSEP=STPSIZ*NF#                        Separation between start of      MA61  29
K1=K+1#                                Set pointers for beginnings      MA61  30
K2=K1+NSEP#                                                             MA61  31
#                                                                       MA61  32
# THERE IS A SEPARATE SUBROUTINE TO HANDLE EACH OF THE FACTORS.         MA61  33
#                                                                       MA61  34
IF(F==2)#                                                               MA61  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA61  36
CALL MA62(QX(K1),QX(K2),NSUMS,ND,NF,STPSIZ)#                            MA61  37
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA61  38
ELSE IF(F==3)#                                                          MA61  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA61  40
K3=K2+NSEP#                            Set third pointer                MA61  41
CALL MA63(QX(K1),QX(K2),QX(K3),NSUMS,ND,NF,STPSIZ)#                     MA61  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA61  43
ELSE IF(F==4)#                                                          MA61  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA61  45
K3=K2+NSEP#                                                             MA61  46
K4=K3+NSEP#                                                             MA61  47
CALL MA64(QX(K1),QX(K2),QX(K3),QX(K4),NSUMS,ND,NF,STPSIZ)#              MA61  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA61  49
ELSE IF(F==5)#                                                          MA61  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA61  51
K3=K2+NSEP#                                                             MA61  52
K4=K3+NSEP#                                                             MA61  53
K5=K4+NSEP#                                                             MA61  54
CALL MA65(QX(K1),QX(K2),QX(K3),QX(K4),QX(K5),NSUMS,ND,NF,STPSIZ)#       MA61  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA61  56
ND=ND/F#                                                                MA61  57
NSUMS=NSUMS*F#                                                          MA61  58
I=I+1#                                 Move on to next factor           MA61  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA61  60
RETURN#                                                                 MA61  61
END#                                                                    MA61  62
systemheader:(MA62)#                                                    MA62   1
#******************************************************************#    MA62   2
#                                                                  #    MA62   3
#                              MA62                                #    MA62   4
#                                                                  #    MA62   5
#******************************************************************#    MA62   6
SUBROUTINE MA62(FHZ,FH1,NSUMS,ND,NF,STPSIZ)#                            MA62   7
IMPLICIT NONE#                                                          MA62   8
include:(AACOMN)#                                                       MA62   9
include:(MACOMN)#                                                       MA62  10
#                                                                       MA62  11
# THE SUMMATION PERFORMED IS                                            MA62  12
#  [SUM (H=0,1)[F*EXP(2PI*I*(1/2)*H*M)]]*EXP(2PI*I*(Q/ND)*M)            MA62  13
#                                                                       MA62  14
# NOTE THAT THE FIRST EXPONENTIAL TERM IS EITHER+OR-1 DEPENDING ON THE  MA62  15
# PARITY OF THE PRODUCT H*M. M MAY TAKE ON THE VALUES 0 AND 1.  THE F V MA62  16
# FOR H=0 ARE IN FHZ, AND FOR H=1 IN FH1.  THE RESULTS OF THE SUM FOR M MA62  17
# ARE IN FHZ AND FOR M=1 IN FH1.  THERE ARE NSUMS MAJOR SEGMENTS AND WI MA62  18
# EACH SEGMENT Q RUNS FROM 0 TO (NF-1).  THIS MEANS THAT EVERY POINT IS MA62  19
# TREATED IN ONE CYCLE THROUGH THE SUBROUTINE SINCE NSUMS*NF*2=NP(3).   MA62  20
#                                                                       MA62  21
INTEGER K#                                                              MA62  22
INTEGER N#                                                              MA62  23
INTEGER STPSIZ#                        Step size over each coeffici     MA62  24
INTEGER J#                                                              MA62  25
INTEGER JPP#                                                            MA62  26
INTEGER STEP#                          Step size over major segment     MA62  27
INTEGER NF#                                                             MA62  28
INTEGER ND#                                                             MA62  29
INTEGER NSUMS#                                                          MA62  30
REAL FHZ(*),FH1(*)#                    Coefficients for sums            MA62  31
REAL EXP#                              Second exponential term          MA62  32
REAL R1,I1#                            Re and im parts before jp ph     MA62  33
REAL PHII,CPHI,SPHI#                   Angle,sin,and cos for jp ter     MA62  34
#                                                                       MA62  35
STEP=ND*STPSIZ#                                                         MA62  36
K=-STEP#                                                                MA62  37
EXP=1./FLOAT(ND)*TWOPI#                                                 MA62  38
DO N=1,NSUMS#                                                           MA62  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA62  40
K=K+STEP#                                                               MA62  41
J=K-STPSIZ#                                                             MA62  42
PHII=-EXP#                                                              MA62  43
DO JPP=1,NF#                           Do sums within each segment      MA62  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA62  45
PHII=PHII+EXP#                                                          MA62  46
J=J+STPSIZ#                                                             MA62  47
#                                                                       MA62  48
# SINCE M=0 FOR THE SUM STORED IN FHZ, IT IS SIMPLY THE SUM OF THE      MA62  49
# COEFFICIENTS IN FHZ AND FH1. SINCE M=1 FOR THE SUM STORED IN FH1,     MA62  50
# THE FIRST TERM IS POSITIVE (H=0) AND THE SECOND TERM IS NEGATIVE (H=1 MA62  51
# SO H*M IS ODD). THE SUM IS STORED TEMPORARILY IN R1 (REAL) AND I1     MA62  52
# (IMAGINARY) BEFORE THE EXPONENTIAL JPP TERM IS APPLIED.               MA62  53
#                                                                       MA62  54
R1=FHZ(J+1)-FH1(J+1)#                                                   MA62  55
I1=FHZ(J+2)-FH1(J+2)#                                                   MA62  56
FHZ(J+1)=FHZ(J+1)+FH1(J+1)#                                             MA62  57
FHZ(J+2)=FHZ(J+2)+FH1(J+2)#                                             MA62  58
IF(JPP!=1)#                                                             MA62  59
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA62  60
CPHI=COS(PHII)#                                                         MA62  61
SPHI=SIN(PHII)#                                                         MA62  62
FH1(J+1)=R1*CPHI-I1*SPHI#                                               MA62  63
FH1(J+2)=R1*SPHI+I1*CPHI#                                               MA62  64
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA62  65
ELSE#                                                                   MA62  66
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA62  67
FH1(J+1)=R1#                                                            MA62  68
FH1(J+2)=I1#                                                            MA62  69
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA62  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA62  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA62  72
RETURN#                                                                 MA62  73
END#                                                                    MA62  74
systemheader:(MA63)#                                                    MA63   1
#******************************************************************#    MA63   2
#                                                                  #    MA63   3
#                              MA63                                #    MA63   4
#                                                                  #    MA63   5
#******************************************************************#    MA63   6
SUBROUTINE MA63(FHZ,FH1,FH2,NSUMS,ND,NF,STPSIZ)#                        MA63   7
IMPLICIT NONE#                                                          MA63   8
include:(AACOMN)#                                                       MA63   9
include:(MACOMN)#                                                       MA63  10
#                                                                       MA63  11
# THE SUMMATION PERFORMED IS                                            MA63  12
#                                                                       MA63  13
# [SUM(H=0 TO 2)[F*EXP(2PI*I*(1/3)*H*M)]]*EXP(2PI*I*(Q/ND)*M)           MA63  14
#                                                                       MA63  15
# M MAY HAVE THE VALUES 0,1, AND 2. THE F VALUES FOR H=0 ARE IN FHZ, FO MA63  16
# H=1 IN FH1, AND FOR H=2 IN FH2. THE RESULTS OF THE SUM FOR M=0 ARE ST MA63  17
# IN FHZ, FOR M=1 IN FH1, AND FOR M=2 IN FH2.  THERE ARE NSUMS MAJOR SE MA63  18
# AND WITHIN EACH SEGMENT Q RUNS FROM 0 TO NF-1.  THIS MEANS THAT EVERY MA63  19
# IS TREATED IN ONE CYCLE THROUGH THE SUBROUTINE SINCE NSUMS*NF*3=NP(3) MA63  20
# DOHERTY, 11-80                                                        MA63  21
#                                                                       MA63  22
INTEGER STEP#                          Step size over major segment     MA63  23
INTEGER STPSIZ#                        Step size over each coeffiec     MA63  24
INTEGER JPP#                           Index of loop within major s     MA63  25
INTEGER J#                                                              MA63  26
INTEGER ND#                                                             MA63  27
INTEGER NF#                                                             MA63  28
INTEGER NSUMS#                                                          MA63  29
INTEGER K#                                                              MA63  30
INTEGER N#                                                              MA63  31
REAL R1,R2,I1,I2#                      Re and im parts before q pha     MA63  32
REAL FHZ(*),FH1(*),FH2(*)#             Coefficients for sums            MA63  33
REAL PHII#                                                              MA63  34
REAL CPHI,SPHI#                        Cos and sin of q term for m=     MA63  35
REAL C2PHI,S2PHI#                      Cos and sin of q term for m=     MA63  36
REAL EXP#                              Second exponential term          MA63  37
REAL AC,AS,BC,BS#                      Re and im contrib. to r1,r2,     MA63  38
realdata:(C1,-.5);  realdata:(S1,.8660254)#                             MA63  39
datastuff:#                                                             MA63  40
#                                                                       MA63  41
STEP=ND*STPSIZ#                        Factor of 2 for 3rd sum, 4 f     MA63  42
K=-STEP#                               Set pointer to step over maj     MA63  43
EXP=1./FLOAT(ND)*TWOPI#                                                 MA63  44
DO N=1,NSUMS#                          Loop over major segments         MA63  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA63  46
K=K+STEP#                                                               MA63  47
J=K-STPSIZ#                                                             MA63  48
PHII=-EXP#                                                              MA63  49
DO JPP=1,NF#                           Do sums within each segment      MA63  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA63  51
J=J+STPSIZ#                                                             MA63  52
PHII=PHII+EXP#                                                          MA63  53
#                                                                       MA63  54
# RECALL THAT COS(2*PI/3)=COS(4*PI/3) AND SIN(2*PI/3)=-SIN(4*PI/3)      MA63  55
#                                                                       MA63  56
AC=(FH1(J+1)+FH2(J+1))*C1#                                              MA63  57
BS=(FH1(J+2)-FH2(J+2))*S1#                                              MA63  58
AS=(FH1(J+1)-FH2(J+1))*S1#                                              MA63  59
BC=(FH1(J+2)+FH2(J+2))*C1#                                              MA63  60
R1=FHZ(J+1)+AC-BS#                                                      MA63  61
I1=FHZ(J+2)+AS+BC#                                                      MA63  62
R2=FHZ(J+1)+AC+BS#                                                      MA63  63
I2=FHZ(J+2)-AS+BC#                                                      MA63  64
FHZ(J+1)=FHZ(J+1)+FH1(J+1)+FH2(J+1)#   M=0 term (see comment above)     MA63  65
FHZ(J+2)=FHZ(J+2)+FH1(J+2)+FH2(J+2)#                                    MA63  66
IF(JPP==1)#                            No exponential term if q=0       MA63  67
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA63  68
FH1(J+1)=R1#                                                            MA63  69
FH1(J+2)=I1#                                                            MA63  70
FH2(J+1)=R2#                                                            MA63  71
FH2(J+2)=I2#                                                            MA63  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA63  73
ELSE#                                  If necessary, apply exp for      MA63  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA63  75
CPHI=COS(PHII)#                        Phase for m=1 (see comment a     MA63  76
SPHI=SIN(PHII)#                                                         MA63  77
C2PHI=CPHI**2-SPHI**2#                 Phase for m=2 term               MA63  78
S2PHI=2.*CPHI*SPHI#                                                     MA63  79
FH1(J+1)=R1*CPHI-I1*SPHI#                                               MA63  80
FH1(J+2)=R1*SPHI+I1*CPHI#                                               MA63  81
FH2(J+1)=R2*C2PHI-I2*S2PHI#                                             MA63  82
FH2(J+2)=R2*S2PHI+I2*C2PHI#                                             MA63  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA63  84
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA63  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA63  86
RETURN#                                                                 MA63  87
END#                                                                    MA63  88
systemheader:(MA64)#                                                    MA64   1
#******************************************************************#    MA64   2
#                                                                  #    MA64   3
#                              MA64                                #    MA64   4
#                                                                  #    MA64   5
#******************************************************************#    MA64   6
SUBROUTINE MA64(FZERO,F1,F2,F3,NSUMS,ND,NF,STPSIZ)#                     MA64   7
IMPLICIT NONE#                                                          MA64   8
include:(AACOMN)#                                                       MA64   9
include:(MACOMN)#                                                       MA64  10
#                                                                       MA64  11
# THE SUMMATION PERFORMED IS                                            MA64  12
#                                                                       MA64  13
#  T(Q,M)=[SUM (H=0 TO 3)[F*EXP(2PI*(1/4)*H*M)]]*EXP(2PI*I*(Q/ND)*M)    MA64  14
#                                                                       MA64  15
# M MAY HAVE THE VALUES 0,1,2 OR 3.  THE F VALUES FOR H=0 ARE IN FZERO, MA64  16
# H=1 IN F1, FOR H=2 IN F2 AND FOR H=3 IN F3. THE T(Q,M) ARE STORED IN  MA64  17
# FZERO(Q+1) FOR M=0, IN F1(Q+1) FOR M=1, IN F2(Q+1) FOR M=2 AND IN F3( MA64  18
# FOR M=3.  Q RUNS FROM 0 TO NF-1.                                      MA64  19
#                                                                       MA64  20
INTEGER NSUMS#                                                          MA64  21
INTEGER STPSIZ#                                                         MA64  22
INTEGER ND#                                                             MA64  23
INTEGER NF#                                                             MA64  24
INTEGER J,JPP#                                                          MA64  25
INTEGER N#                                                              MA64  26
INTEGER K#                                                              MA64  27
INTEGER STEP#                                                           MA64  28
REAL EXP#                              Second exponential term          MA64  29
REAL FZERO(*),F1(*),F2(*),F3(*)#       Vide supra                       MA64  30
REAL PHII,CPHI,SPHI#                   Angle, cos and sin for 2nd e     MA64  31
REAL C2PHI,S2PHI#                      As for cphi, but m=2             MA64  32
REAL C3PHI,S3PHI#                      As for cphi, but m=3             MA64  33
REAL ASUMZ,ASUM1,BSUMZ,BSUM1#          Intermediate stages of summa     MA64  34
REAL AEVEN,AODD,BEVEN,BODD#            Intermediate stages of summa     MA64  35
REAL R1,I1,R2,I2,R3,I3#                Summation before applying ex     MA64  36
#                                                                       MA64  37
EXP=1./FLOAT(ND)*TWOPI#                                                 MA64  38
STEP=STPSIZ*ND#                                                         MA64  39
K=-STEP#                                                                MA64  40
DO N=1,NSUMS#                                                           MA64  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA64  42
K=K+STEP#                                                               MA64  43
J=K-STPSIZ#                                                             MA64  44
PHII=-EXP#                                                              MA64  45
DO JPP=1,NF#                                                            MA64  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA64  47
J=J+STPSIZ#                                                             MA64  48
PHII=PHII+EXP#                                                          MA64  49
#                                                                       MA64  50
# FOR H=0, THE FIRST EXPONENTIAL TERM IS ALWAYS+1. FOR H=2, THE FIRST   MA64  51
# EXPONENTIAL TERM IS+1 IF M IS EVEN AND-1 IF M IS ODD.  FOR H=1 OR 3,  MA64  52
# ONLY THE IMAGINARY PART OF THE COEFFICIENT WILL CONTRIBUTE TO THE RAL MA64  53
# OF THE PORDUCT WHEN M=1 OR 3, SINCE COS(2PI/4)=COS(3*2PI/4)=0.        MA64  54
# WHEN M=2, ONLY THE REAL PARTS OF ALL FOUR COEFFICIENTS CONTRIBUTE TO  MA64  55
# REAL PART OF THE SUM.                                                 MA64  56
#                                                                       MA64  57
AEVEN=FZERO(J+1)-F2(J+1)#                                               MA64  58
AODD=F1(J+1)-F3(J+1)#                                                   MA64  59
BEVEN=FZERO(J+2)-F2(J+2)#                                               MA64  60
BODD=F1(J+2)-F3(J+2)#                                                   MA64  61
ASUMZ=FZERO(J+1)+F2(J+1)#                                               MA64  62
ASUM1=F1(J+1)+F3(J+1)#                                                  MA64  63
BSUMZ=FZERO(J+2)+F2(J+2)#                                               MA64  64
BSUM1=F1(J+2)+F3(J+2)#                                                  MA64  65
#                                                                       MA64  66
R1=AEVEN-BODD#                                                          MA64  67
I1=BEVEN+AODD#                                                          MA64  68
R2=ASUMZ-ASUM1#                                                         MA64  69
I2=BSUMZ-BSUM1#                                                         MA64  70
R3=AEVEN+BODD#                                                          MA64  71
I3=BEVEN-AODD#                                                          MA64  72
#                                                                       MA64  73
FZERO(J+1)=ASUMZ+ASUM1#                                                 MA64  74
FZERO(J+2)=BSUMZ+BSUM1#                                                 MA64  75
IF(JPP!=1)#                                                             MA64  76
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA64  77
CPHI=COS(PHII)#                                                         MA64  78
SPHI=SIN(PHII)#                                                         MA64  79
C2PHI=CPHI**2-SPHI**2#                                                  MA64  80
S2PHI=2.*CPHI*SPHI#                                                     MA64  81
C3PHI=CPHI*C2PHI-SPHI*S2PHI#                                            MA64  82
S3PHI=CPHI*S2PHI+SPHI*C2PHI#                                            MA64  83
F1(J+1)=R1*CPHI-I1*SPHI#                                                MA64  84
F1(J+2)=R1*SPHI+I1*CPHI#                                                MA64  85
F2(J+1)=R2*C2PHI-I2*S2PHI#                                              MA64  86
F2(J+2)=R2*S2PHI+I2*C2PHI#                                              MA64  87
F3(J+1)=R3*C3PHI-I3*S3PHI#                                              MA64  88
F3(J+2)=R3*S3PHI+I3*C3PHI#                                              MA64  89
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA64  90
ELSE#                                                                   MA64  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA64  92
F1(J+1)=R1#                                                             MA64  93
F1(J+2)=I1#                                                             MA64  94
F2(J+1)=R2#                                                             MA64  95
F2(J+2)=I2#                                                             MA64  96
F3(J+1)=R3#                                                             MA64  97
F3(J+2)=I3#                                                             MA64  98
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA64  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA64 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA64 101
RETURN#                                                                 MA64 102
END#                                                                    MA64 103
systemheader:(MA65)#                                                    MA65   1
#**************************************************************#        MA65   2
#                                                              #        MA65   3
#                            MA65                              #        MA65   4
#                                                              #        MA65   5
#**************************************************************#        MA65   6
SUBROUTINE MA65(FZERO,F1,F2,F3,F4,NSUMS,ND,NF,STPSIZ)#                  MA65   7
IMPLICIT NONE#                                                          MA65   8
include:(AACOMN)#                                                       MA65   9
include:(MACOMN)#                                                       MA65  10
#                                                                       MA65  11
# THE SUMMATION PREFORMED IS                                            MA65  12
#                                                                       MA65  13
# T(Q,M)=[SUM (H=0 TO 4)[F*EXP(2PI*I*H*M)]]*EXP(2PI*I*(Q/ND)*M)         MA65  14
#                                                                       MA65  15
# M MAY HAVE THE VALUES 0,1,2,3 AND 4.  THE F VALUES FOR H=0 ARE IN     MA65  16
# FZERO, FOR H=1 IN F1, FOR H=2 IN F2, FOR H=3 IN F3, AND FOR H=4 IN F4 MA65  17
# THE T(Q,M) ARE STORED IN FZERO(Q+1) FOR M=0, IN F1(Q+1) FOR M=1, IN   MA65  18
# F2(Q+2) FOR M=2, IN F3(Q+1) FOR M=3 AND IN F4(Q+1) FOR M=4.  Q RUNS   MA65  19
# FROM 0 TO (NF-1).                                                     MA65  20
#                                                                       MA65  21
INTEGER J#                                                              MA65  22
INTEGER JPP#                                                            MA65  23
INTEGER K#                                                              MA65  24
INTEGER N#                                                              MA65  25
INTEGER ND#                                                             MA65  26
INTEGER NF#                                                             MA65  27
INTEGER NSUMS#                                                          MA65  28
INTEGER STPSIZ#                                                         MA65  29
INTEGER STEP#                                                           MA65  30
REAL ASUM1,ASUM2,ADIF1,ADIF2#                                           MA65  31
REAL AOC,AEC,AOS,AES#                                                   MA65  32
REAL BSUM1,BSUM2,BDIF1,BDIF2#                                           MA65  33
REAL BOC,BEC,BOS,BES#                                                   MA65  34
REAL FZERO(*),F1(*),F2(*),F3(*),F4(*)#                                  MA65  35
REAL R1,I1,R2,I2,R3,I3,R4,I4#                                           MA65  36
REAL EXP#                                                               MA65  37
REAL PHII,CPHI,SPHI#                                                    MA65  38
REAL C2PHI,S2PHI#                                                       MA65  39
REAL C3PHI,S3PHI#                                                       MA65  40
REAL C4PHI,S4PHI#                                                       MA65  41
realdata:(C1,0.30901699);  realdata:(S1,0.95105652)#                    MA65  42
realdata:(C2,-0.80901699);  realdata:(S2,0.58778525)#                   MA65  43
datastuff:#                                                             MA65  44
#                                                                       MA65  45
STEP=STPSIZ*ND#                                                         MA65  46
K=-STEP#                                                                MA65  47
EXP=1./FLOAT(ND)*TWOPI#                                                 MA65  48
DO N=1,NSUMS#                                                           MA65  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA65  50
K=K+STEP#                                                               MA65  51
J=K-STPSIZ#                                                             MA65  52
PHII=-EXP#                                                              MA65  53
DO JPP=1,NF#                                                            MA65  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA65  55
J=J+STPSIZ#                                                             MA65  56
PHII=PHII+EXP#                                                          MA65  57
#                                                                       MA65  58
# RECALL THAT COS(2PI/5)=COS(4*2PI/5) , AND SIN(2PI/5)=-SIN(4*2PI/5) .  MA65  59
# ALSO COS(2*2PI/5)=COS(3*2PI/5) AND SIN(2*2PI/5)=-SIN(3*2PI/5).        MA65  60
# IN THE FOLLOWING, CERTAIN TERMS ARE GROUPED TOGETHER TO SIMPLIFY THE  MA65  61
# ACTUAL SUMMATION INDICATED IN THE OPENING COMMENT.  ALL THE A TERMS R MA65  62
# TO THE REAL PARTS OF THE COEFFICIENTS, AND THE B TERMS REFER TO THE   MA65  63
# IMAGINARY PARTS.                                                      MA65  64
#                                                                       MA65  65
ASUM1=F1(J+1)+F4(J+1)#                                                  MA65  66
ASUM2=F2(J+1)+F3(J+1)#                                                  MA65  67
ADIF1=F1(J+1)-F4(J+1)#                                                  MA65  68
ADIF2=F2(J+1)-F3(J+1)#                                                  MA65  69
AEC=FZERO(J+1)+ASUM1*C1+ASUM2*C2#                                       MA65  70
AOC=FZERO(J+1)+ASUM1*C2+ASUM2*C1#                                       MA65  71
AES=ADIF1*S1+ADIF2*S2#                                                  MA65  72
AOS=ADIF1*S2-ADIF2*S1#                                                  MA65  73
#                                                                       MA65  74
BSUM1=F1(J+2)+F4(J+2)#                                                  MA65  75
BSUM2=F2(J+2)+F3(J+2)#                                                  MA65  76
BDIF1=F1(J+2)-F4(J+2)#                                                  MA65  77
BDIF2=F2(J+2)-F3(J+2)#                                                  MA65  78
BEC=FZERO(J+2)+BSUM1*C1+BSUM2*C2#                                       MA65  79
BOC=FZERO(J+2)+BSUM1*C2+BSUM2*C1#                                       MA65  80
BES=BDIF1*S1+BDIF2*S2#                                                  MA65  81
BOS=BDIF1*S2-BDIF2*S1#                                                  MA65  82
#                                                                       MA65  83
# THE R'S AND I'S ARE THE REAL AND IMAGINARY PARTS OF THE SUM BEFORE TH MA65  84
# EXPONENTIAL Q TERM HAS BEEN APPLIED.                                  MA65  85
#                                                                       MA65  86
R1=AEC-BES#                                                             MA65  87
I1=AES+BEC#                                                             MA65  88
R2=AOC-BOS#                                                             MA65  89
I2=AOS+BOC#                                                             MA65  90
R3=AOC+BOS#                                                             MA65  91
I3=-AOS+BOC#                                                            MA65  92
R4=AEC+BES#                                                             MA65  93
I4=-AES+BEC#                                                            MA65  94
#                                                                       MA65  95
# IF EXPONENTIAL Q TERM IS OTHER THAN 1, APPLY IT.                      MA65  96
#                                                                       MA65  97
FZERO(J+1)=FZERO(J+1)+ASUM1+ASUM2#     For m=0, both exponentials       MA65  98
FZERO(J+2)=FZERO(J+2)+BSUM1+BSUM2#                                      MA65  99
IF(JPP==1)#                            Q term is+1                      MA65 100
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA65 101
F1(J+1)=R1#                                                             MA65 102
F1(J+2)=I1#                                                             MA65 103
F2(J+1)=R2#                                                             MA65 104
F2(J+2)=I2#                                                             MA65 105
F3(J+1)=R3#                                                             MA65 106
F3(J+2)=I3#                                                             MA65 107
F4(J+1)=R4#                                                             MA65 108
F4(J+2)=I4#                                                             MA65 109
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA65 110
ELSE#                                  Q term is not+1                  MA65 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA65 112
CPHI=COS(PHII)#                                                         MA65 113
SPHI=SIN(PHII)#                                                         MA65 114
C2PHI=CPHI**2-SPHI**2#                                                  MA65 115
S2PHI=2.*CPHI*SPHI#                                                     MA65 116
C3PHI=CPHI*C2PHI-SPHI*S2PHI#                                            MA65 117
S3PHI=SPHI*C2PHI+S2PHI*CPHI#                                            MA65 118
C4PHI=C2PHI**2-S2PHI**2#                                                MA65 119
S4PHI=2.*C2PHI*S2PHI#                                                   MA65 120
F1(J+1)=R1*CPHI-I1*SPHI#                                                MA65 121
F1(J+2)=R1*SPHI+I1*CPHI#                                                MA65 122
F2(J+1)=R2*C2PHI-I2*S2PHI#                                              MA65 123
F2(J+2)=R2*S2PHI+I2*C2PHI#                                              MA65 124
F3(J+1)=R3*C3PHI-I3*S3PHI#                                              MA65 125
F3(J+2)=R3*S3PHI+I3*C3PHI#                                              MA65 126
F4(J+1)=R4*C4PHI-I4*S4PHI#                                              MA65 127
F4(J+2)=R4*S4PHI+I4*C4PHI#                                              MA65 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA65 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA65 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA65 131
RETURN#                                                                 MA65 132
END#                                                                    MA65 133
systemheader:(MA80)#                   Fft reverse transform            MA80   1
# ################################################################## #  MA80   2
#                                                                    #  MA80   3
#                               MA80                                 #  MA80   4
#                                                                    #  MA80   5
# ################################################################## #  MA80   6
SUBROUTINE MA80#                       J.m.stewart d.m.collins mar 90   MA80   7
IMPLICIT NONE#                                                          MA80   8
include:(AACOMN)#                                                       MA80   9
include:(MACOMN)#                                                       MA80  10
#                                                                       MA80  11
# THIS ROUTINE CALCULATES A REVERSE (DIRECT SPACE TO RECIPROCAL SPACE)  MA80  12
# FOURIER TRANSFORM USING THE WFFT CODE OF WINOGRAD.                    MA80  13
#                                                                       MA80  14
REAL AFAC,BFAC,APHIT## Temporary store for a, b, and phase calculated   MA80  15
REAL AMODUL## SQRT(A**2+B**2)                                           MA80  16
INTEGER BIJVO## Signal bijvoet relation of computed refl to hessian     MA80  17
INTEGER FILIN1,FILIN2,FILIN3## Miller indices from input bdf packets    MA80  18
INTEGER FIRST,LAST## First and last words of a direct access buffer     MA80  19
INTEGER GENIN1,GENIN2,GENIN3## Miller indices from generation loops     MA80  20
INTEGER GETG,GETPN,GETPP## Coefficient storage pointers                 MA80  21
INTEGER J,JJ,K,L## Local indices & pointers for loops etc.              MA80  22
INTEGER INPROS## Signal for reflection in process                       MA80  23
INTEGER JREF## Pointer to subset of reflections in memory to be phase   MA80  24
INTEGER NEGH2P## Signal negative sec sum indices in bdf                 MA80  25
INTEGER NOWFC0## Signal arrival of FC000                                MA80  26
# THE VARIABLES NX1P.. ARE LOCAL COPIES OF NX1.. ( HELP OPTIMIZERS)     MA80  27
INTEGER NX1P,NX2P,NX3P## No. of points in each direction                MA80  28
INTEGER PHASHF## Signal phase shift of computed refl to hessian refl    MA80  29
INTEGER PRESH(3),PREVH(3)## Present and previous h,k,l for duplicates   MA80  30
INTEGER PUTG,PUTP## Coefficient storage pointers                        MA80  31
INTEGER PSIZ,IP## For I/O operations                                    MA80  32
REAL Q## Volatile register for QX values                                MA80  33
INTEGER RECRD## Direct access unit record pointer                       MA80  34
INTEGER REFPT## Pointer to current reflection in MARKQ array            MA80  35
REAL SCAPTS## Scale factor for el-dens to F                             MA80  36
INTEGER SORTPT## Pointer to reflections in sorted order                 MA80  37
COMPLEX W(1681),WP(1681)## Complex 1 dim arrays for transforms          MA80  38
INTEGER X1,X2## Layer, down the layer                                   MA80  39
#                                                                       MA80  40
realdata:(D1,[1.,0.,.5,0.,-.5,0.,-1.,0.,-.5,0.,.5,0.])# Phase shifts    MA80  41
realdata:(D2,[.0,.0,.8660254,1.,.8660254,.0,.0,.0,-.8660254,-1.,#       MA80  42
-.8660254,.0])#                                                         MA80  43
realdata:(D3,[.0,.0,-.8660254,-1.,-.8660254,.0,.0,.0,.8660254,1.,#      MA80  44
.8660254,.0])#                                                          MA80  45
realdata:(D4,[1.,0.,.5,0.,-.5,0.,-1.,0.,-.5,0.,.5,0.])#                 MA80  46
datastuff:#                                                             MA80  47
#                                                                       MA80  48
# INITIALIZE COUNTS, NUMBERS OF POINTS IN SUMMATIONS                    MA80  49
# --------------------------------------------------                    MA80  50
#                                                                       MA80  51
INPROS=no:#                            No reflections in process        MA80  52
DO J=MARKG,STOPP-1 ; QX(J+1)=0.0#      Reclear memory                   MA80  53
NEGH2P=yes:#                           Assume some negative h2s         MA80  54
IF(NEGIND(RSUM2)==no:)NEGH2P=no:#      Negative h2 indices in bdf       MA80  55
#                                                                       MA80  56
SCAPTS=1.0#                            Point compensation scale         MA80  57
NX1P=NG(1);NX2P=NG(2);NX3P=NG(3)#      Get points in 3 directions       MA80  58
#                                                                       MA80  59
# ZERO SUMS FOR CALCULATION OF CORRELATION COEFFICIENT FOR FO WITH      MA80  60
# FC OF THOSE REFLECTIONS IN THE INPUT FILE WHICH HAVE NOT PREVIOUSLY   MA80  61
# BEEN PHASED.                                                          MA80  62
# -------------------------------------------------------------------   MA80  63
#                                                                       MA80  64
SUFOFC=0.0 ; SUFC=0.0 ; SUFC2=0.0 ; SUFO=0.0 ; SUFO2=0.0 ; SUREF=0.0#   MA80  65
#                                                                       MA80  66
# LOOP OVER POINTS TO PRODUCE A HEMISPHERE OF REFLECTIONS               MA80  67
# -------------------------------------------------------               MA80  68
#                                                                       MA80  69
IP=MARKN#                              Take map from 'ln(adjusted)'     MA80  70
DO X1=0,NX1P-1#                        Loop over layers in cell         MA80  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA80  72
PUTP=MARKP+2*X1;   GETG=MARKG#         Set storage position             MA80  73
#                                                                       MA80  74
DO X2=0,NX2P-1#                        Loop over lines in layer         MA80  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA80  76
PUTG=MARKG+2*X2#                       Set pointer to sec sum array     MA80  77
IF(CORUSE==yes:) readwpkt:(7,22,PSIZ,IP,0)# Rho correction on file?     MA80  78
IF(IP>=STOPN-1\IP<=0) BREAK#           Quit if all layers done          MA80  79
#                                                                       MA80  80
DO J=1,NX3P#                           Loop over points in line         MA80  81
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA80  82
IP=IP+1#                               Point in map of adjusted e.d.    MA80  83
Q=QX(IP)#                              Get each value of e.d.           MA80  84
W(J)=CMPLX(Q*SCAPTS)#                  Scale and load el-dens           MA80  85
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA80  86
CALL MA81(W,NX3,1,NDIV3)#              Fft the line                     MA80  87
#                                                                       MA80  88
# FOURIER TRANSFORM EACH LINE TO PUT SECOND SUM COEFFICIENT IN STORE    MA80  89
# -------------------------------------------------------------------   MA80  90
#                                                                       MA80  91
DO J=1,NYQF3P#                         Loop over all positive h3        MA80  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA80  93
QX(PUTG+1)=REAL(W(J))#                 Save the real component          MA80  94
QX(PUTG+2)=AIMAG(W(J))#                Save the imaginary component     MA80  95
PUTG=PUTG+STEPG#                       Set offset based on h3           MA80  96
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA80  97
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA80  98
#                                                                       MA80  99
# TRANSFORM THE LAYER INTO THIRD SUM COEFFICIENTS                       MA80 100
# -----------------------------------------------                       MA80 101
#                                                                       MA80 102
DO J=1,NYQF3P#                         Loop over all positive h3        MA80 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA80 104
IF(DIRACC==yes:)#                      If direct access file used       MA80 105
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA80 106
RECRD=(J-1)*NREADS#                    Direct access record pointer     MA80 107
FIRST=MARKP+1-dirbuf:#                 Prepare to point to first word   MA80 108
DO K=1,NREADS#                         Loop over no. of buffers         MA80 109
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA80 110
FIRST=FIRST+dirbuf: ; LAST=MIN0(FIRST+dirbuf:-1,STOPP)# Read region     MA80 111
RECRD=RECRD+1 ; readdac:(unitda2:,,RECRD,(QX(JJ),JJ=FIRST,LAST))#       MA80 112
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA80 113
PUTP=MARKP+2*X1#                       Reset output pointer             MA80 114
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA80 115
DO K=1,NX2P#                           For all second sum points        MA80 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA80 117
W(K)=CMPLX(QX(GETG+1),QX(GETG+2))#     Fetch back complex coefficient   MA80 118
GETG=GETG+2#                           Step through coefficients        MA80 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA80 120
CALL MA81(W,NX2,1,NDIV2)#              Transform one line at a time     MA80 121
#                                                                       MA80 122
# FOURIER TRANSFORM SEC SUM COEFFICIENTS INTO THIRD SUM COEFFICIENTS    MA80 123
# ------------------------------------------------------------------    MA80 124
#                                                                       MA80 125
DO K=1,NH2#                            Loop over all h2                 MA80 126
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MA80 127
QX(PUTP+1)=REAL(W(K))#                 Save real component third sum    MA80 128
QX(PUTP+2)=AIMAG(W(K))#                Save imaginary as well           MA80 129
PUTP=PUTP+STEPH#                                                        MA80 130
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MA80 131
IF(DIRACC==yes:)#                      Must direct access be used       MA80 132
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MA80 133
RECRD=(J-1)*NREADS#                    Direct access record pointer     MA80 134
FIRST=MARKP+1-dirbuf:#                 Prepare to point to first word   MA80 135
DO K=1,NREADS#                         Loop over no. of buffers         MA80 136
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MA80 137
FIRST=FIRST+dirbuf: ; LAST=MIN0(FIRST+dirbuf:-1,STOPP)# Write region    MA80 138
RECRD=RECRD+1 ; writedac:(unitda2:,,RECRD,(QX(JJ),JJ=FIRST,LAST))#      MA80 139
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MA80 140
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MA80 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA80 142
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA80 143
#                                                                       MA80 144
IF(CORUSE==yes:) readwpkt:(7,endrecord:,PSIZ,IP,0)# Rewind rho file     MA80 145
GENIN3=9999; GENIN2=9999#              Falsify current indices          MA80 146
#                                                                       MA80 147
# DO THE THIRD SUMS TO PRODUCE A, B, FC, AND PHASE                      MA80 148
# ------------------------------------------------                      MA80 149
#                                                                       MA80 150
DO K=1,3 ; PREVH(K)=-9999 ; NOWFC0=0#  Set previous h, k, l to imposs   MA80 151
JREF=MARKR ; BFAC=0.0#                 'in memory' reflection pointer   MA80 152
FOR(REFPT=MARKQ;REFPT<STOPQ;REFPT=REFPT+STEPQ)# Over refls in memory    MA80 153
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MA80 154
SORTPT=NINT(QX(REFPT+6))#              Point to next refl in long lis   MA80 155
DO K=1,3 ; PRESH(K)=NINT(QX(SORTPT+K+2))# Get present h, k, l           MA80 156
IF(PRESH(1)!=PREVH(1)\PRESH(2)!=PREVH(2)\PRESH(3)!=PREVH(3))# Changed   MA80 157
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MA80 158
DO K=1,3 ; PREVH(K)=PRESH(K)#          Remember what it changed to      MA80 159
#                                                                       MA80 160
# PERMUTE H,K,L ACCORDING TO GIVEN SUMMATION ORDER                      MA80 161
# ------------------------------------------------                      MA80 162
#                                                                       MA80 163
FILIN1=PRESH(RSUM1);GENIN1=IABS(FILIN1)# Permute index for fast sum     MA80 164
FILIN2=PRESH(RSUM2)#                   Permute index for medium sum     MA80 165
FILIN3=PRESH(RSUM3)#                   Permute index for slow sum       MA80 166
IF((IABS(FILIN1)>NYQF1)\$#             Refl outside map resolution?     MA80 167
   (IABS(FILIN2)>NYQF2)\$#             Refl outside map resolution?     MA80 168
   (IABS(FILIN3)>NYQF3))#              Refl outside map resolution?     MA80 169
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MA80 170
AFAC=THRESH ; BFAC=0.0 ; APHIT=0.0 ; AMODUL=THRESH# Default small fc    MA80 171
GOTO 1313#                                                              MA80 172
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MA80 173
#                                                                       MA80 174
IF(GENIN3!=IABS(FILIN3))#              Change in slow sum index?        MA80 175
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MA80 176
INPROS=yes:; GENIN3=IABS(FILIN3)#      Note change and reset index      MA80 177
IF(DIRACC==yes:)#                      Must direct access be used       MA80 178
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MA80 179
RECRD=GENIN3*NREADS#                   Direct access record pointe      MA80 180
FIRST=MARKP+1-dirbuf:#                 Prepare to point to first word   MA80 181
DO K=1,NREADS#                         Loop over no. of buffers         MA80 182
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MA80 183
FIRST=FIRST+dirbuf: ; LAST=MIN0(FIRST+dirbuf:-1,STOPP)# Read region     MA80 184
RECRD=RECRD+1 ; readdac:(unitda2:,,RECRD,(QX(JJ),JJ=FIRST,LAST))# E     MA80 185
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MA80 186
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MA80 187
ELSE STEPGP=GENIN3*STEPP#              Calculate storage offset         MA80 188
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MA80 189
IF(GENIN2!=IABS(FILIN2))#              Change in medium index?          MA80 190
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MA80 191
INPROS=yes:; GENIN2=IABS(FILIN2)#      Note change and reset index      MA80 192
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MA80 193
#                                                                       MA80 194
# FOURIER TRANSFORM ALONG X1, LINE BY LINE                              MA80 195
# ----------------------------------------                              MA80 196
#                                                                       MA80 197
IF(INPROS==yes:)#                      Test if slow or medium change    MA80 198
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MA80 199
INPROS=no:#                            Shut off processing till next    MA80 200
GETPP=MARKP+STEPGP+GENIN2*STEPH#       Point to third sum coefficient   MA80 201
DO L=1,NX1P#                           Loop over all x1                 MA80 202
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MA80 203
W(L)=CMPLX(QX(GETPP+1),QX(GETPP+2))#   Recomplex coef                   MA80 204
GETPP=GETPP+2#                         Incr pointer                     MA80 205
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MA80 206
CALL MA81(W,NX1P,1,NDIV1)#             Transform the line               MA80 207
#                                                                       MA80 208
IF((GENIN2>0)&(NEGH2P==yes:))#         Any non zero negative index?     MA80 209
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MA80 210
GETPN=MARKP+STEPGP+(NH2-GENIN2)*STEPH# Point to 3rd sum coeff           MA80 211
DO L=1,NX1P#                           Loop over all x1                 MA80 212
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MA80 213
WP(L)=CMPLX(QX(GETPN+1),QX(GETPN+2))#  Recomplex coef                   MA80 214
GETPN=GETPN+2#                         Incr pointer                     MA80 215
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MA80 216
CALL MA81(WP,NX1P,1,NDIV1)#            Transform the line               MA80 217
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MA80 218
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MA80 219
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MA80 220
#                                                                       MA80 221
# PICK UP F CALCULATED FOR (0,0,0) AS IT GOES BY                        MA80 222
# ----------------------------------------------                        MA80 223
#                                                                       MA80 224
IF(NOWFC0==0)#                                                          MA80 225
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MA80 226
FC000=REAL(W(1)) ; NOWFC0=1#           Get it and shut off search       MA80 227
QX(MARKR+10)=FC000 ; QX(MARKR+11)=FC000# Store in reflection array      MA80 228
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MA80 229
#                                                                       MA80 230
#  AT THIS POINT A LINE IN RECIPROCAL SPACE IS IN THE W ARRAY           MA80 231
#  FOR POSITIVE H2 AND, IF NECESSARY, IN WP FOR NEGATIVE H2             MA80 232
#  ONLY THE UNIQUE ASSYMETRIC REFLECTIONS FROM THE RFOURR LIST WILL     MA80 233
#  HAVE THEIR A, B, AND PHASE PICKED UP BUT THESE WILL BE PHASE         MA80 234
# SHIFTED AND PUT IN ALL THE HESSIAN REFLECTION SLOTS IN THE MARKQ      MA80 235
# ARRAY. SEE MA11, 12, 13, & 36 FOR MORE DETAILS.                       MA80 236
# ------------------------------------------------------------------    MA80 237
#                                                                       MA80 238
IF(FILIN1<0) L=NH1+FILIN1#             Make pointer out of - index      MA80 239
ELSE         L=FILIN1#                 Positives are easy               MA80 240
IF(FILIN2<0)#                          Negative h2?                     MA80 241
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MA80 242
AFAC=REAL(WP(L+1))#                    Get a and b for - h2             MA80 243
IF(ICNT!=0) BFAC=AIMAG(WP(L+1))#                                        MA80 244
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MA80 245
ELSE#                                                                   MA80 246
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MA80 247
AFAC=REAL(W(L+1))#                     Get a and b for + h2             MA80 248
IF(ICNT!=0) BFAC=AIMAG(W(L+1))#                                         MA80 249
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MA80 250
IF(FILIN3<0&ICNT!=0) BFAC=-BFAC#       Freidel it!                      MA80 251
#                                                                       MA80 252
#   CALCULATE THE PHASE AND MAKE NEAR CENTRICS EXACT HITS               MA80 253
#   -----------------------------------------------------               MA80 254
#                                                                       MA80 255
AMODUL=SQRT(AFAC**2+BFAC**2)#          Get modulus                      MA80 256
IF(AMODUL>THRESH)#                     Structure factor big enough?     MA80 257
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MA80 258
CALL MA02(AFAC,BFAC)#                  Call to centric checker/setter   MA80 259
APHIT=ATAN2(BFAC,AFAC)*RATODE#         Get phase in degrees             MA80 260
AFAC=AFAC*AMODUL ; BFAC=BFAC*AMODUL#   Restore scale                    MA80 261
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MA80 262
ELSE#                                                                   MA80 263
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MA80 264
AFAC=THRESH ; BFAC=0.0 ; APHIT=0.0 ; AMODUL=THRESH# Default small fc    MA80 265
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MA80 266
1313 CONTINUE#                         Also refls outside resolution    MA80 267
#                                                                       MA80 268
IF(QX(SORTPT+7)<0.0&AMODUL>THRESH)#    Is this a good correl'n refl?    MA80 269
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MA80 270
#                                                                       MA80 271
# GET SUMS FOR CORRELATION COEFFICIENT OF UNPHASED REFLECTIONS          MA80 272
# ------------------------------------------------------------          MA80 273
#                                                                       MA80 274
SUREF=SUREF+1.0 ; SUFO=SUFO+ABS(QX(SORTPT+7))#                          MA80 275
SUFO2=SUFO2+QX(SORTPT+7)**2 ; SUFC=SUFC+AMODUL#                         MA80 276
SUFC2=SUFC2+AMODUL**2 ; SUFOFC=SUFOFC+ABS(QX(SORTPT+7))*AMODUL#         MA80 277
QX(SORTPT+1)=AFAC ; QX(SORTPT+2)=BFAC# Save a & b for fun of it         MA80 278
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MA80 279
ELSE#                                  It is a hessian contributor      MA80 280
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 MA80 281
PHASHF=MOD(NINT(QX(SORTPT+7)*0.01)+4800,12)# Get phase shift to hessi   MA80 282
BIJVO=NINT(AMOD(QX(SORTPT+7)*0.1,10.0))# Get bijvoet signal             MA80 283
QX(SORTPT+1)=D1(PHASHF+1)*AFAC+D2(PHASHF+1)*BFAC# Get a transformed     MA80 284
QX(SORTPT+2)=D3(PHASHF+1)*AFAC+D4(PHASHF+1)*BFAC# Get b transformed     MA80 285
IF(BIJVO==1) QX(SORTPT+2)=-QX(SORTPT+2)# Friedel it again               MA80 286
IF(AMOD(QX(SORTPT+7),10.0)>0.0)#       Refl is in sought subset?        MA80 287
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 MA80 288
JREF=JREF+STEPR#                       Point to sought subset refl      MA80 289
QX(JREF+11)=QX(SORTPT+1) ; QX(JREF+12)=QX(SORTPT+2)# Duplicate a & b    MA80 290
QX(JREF+10)=AMODUL#                    Get magnitude of fc              MA80 291
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 MA80 292
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 MA80 293
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MA80 294
#                                                                       MA80 295
IF(DIRACC==yes:) closedac:(unitda2:)#  Close direct access file         MA80 296
IF(SUREF>1.0)#                         Any refls for correlation?       MA80 297
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 MA80 298
CORREL=(SUFOFC-(SUFO*SUFC/SUREF))/$#   Compute correlation for          MA80 299
AMAX1(1.0,(SQRT(SUFO2-(SUFO**2/SUREF))*$# Fobs with fcalc               MA80 300
SQRT(SUFC2-(SUFC**2/SUREF))))#         For unphased refls               MA80 301
MEANFO=SUFO/SUREF ; MEANFC=SUFC/SUREF# Get mean values of moduli        MA80 302
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 MA80 303
ELSE#                                                                   MA80 304
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 MA80 305
MEANFO=0.0 ; MEANFC=0.0 ; CORREL=0.0#  If none correlation is zero      MA80 306
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 MA80 307
#                                                                       MA80 308
RETURN#                                                                 MA80 309
END#                                                                    MA80 310
systemheader:(MA81)#                   Winograd's fft suite wfft        MA81   1
# ################################################################## #  MA81   2
#                                                                    #  MA81   3
#                               MA81                                 #  MA81   4
#                                                                    #  MA81   5
# ################################################################## #  MA81   6
SUBROUTINE MA81(X1,N,ISN,IDIV)#        J.m.stewart mar 1987             MA81   7
IMPLICIT NONE#                                                          MA81   8
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  MA81   9
#      <<< WFFT >>>    COMPUTES 1 DIMENSIONAL FOURIER TRANSFORM         MA81  10
#     X1=INPUT VECTOR(COMPLEX) OF LENGTH N, OUTPUT IS IN SAME LOC...    MA81  11
#     ISN= CONTROLS FORWARD OR REV TRANSFORM, 1= DEN TO SF, -1=SF TO DE MA81  12
#     ALLOWED VALUES OF N ARE GIVEN IN VECTOR << ND(59) >>              MA81  13
#     IDIV IS THE POINTER TO ONE OF THE 59 POSSIBLE GRID SIZES          MA81  14
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  MA81  15
INTEGER NF(2),LFIN(2),IP(80),OP(80),F(108),ALPHA,BETA,OP1#              MA81  16
INTEGER I,IDIV,IDIM,ID,ID1,ID2,IFD,IP1,IS,ISN,J,K,L,LIN,LL,LLL,L22#     MA81  17
INTEGER L1,L2,L1IN,L2IN,M1,M2#                                          MA81  18
INTEGER N,N1,N2,NOVL#                                                   MA81  19
REAL C(108),D#                                                          MA81  20
COMPLEX X1(N),X(108),Y(108),T1,T2,T3,T4,T5,T6,S1,S2,S3#                 MA81  21
intdata:(NF1,[1,1,1,1,2,1,1,1,1,3,2,1,1,2,1,1,3,4,2,5,4,1,2,5,3,6,4,1,# MA81  22
6,7,1,4,8,6,6,7,2,6,8,7,8,10,11,4,6,5,9,8,12,7,6,10,8,13,9,12,13,#      MA81  23
14,15])#                                                                MA81  24
intdata:(NB,[1,2,3,4,5,7,8,9,16,10,15,20,21,40,63,80])#                 MA81  25
intdata:(NBF1,[1,2,3,4,5,6,7,8,9,2,3,4,3,7,8,9])#                       MA81  26
intdata:(NBF2,[1,1,1,1,1,1,1,1,1,5,5,5,6,5,6,5])#                       MA81  27
intdata:(PHII,[1,1,2,2,4,6,4,6,8])#                                     MA81  28
intdata:(MB,[1,2,3,4,6,9,8,11,18])#                                     MA81  29
intdata:(MIND,[0,0,2,5,9,15,24,32,43])#                                 MA81  30
intdata:(FD,[1,1,1,1,-1,1,1,1,-1,1,1,1,-1,-1,-1,1,1,1,1,1,-1,-1,-1,-1,# MA81  31
1,1,1,1,-1,-1,1,-1,1,1,1,1,1,1,-1,-1,-1,-1,-1,1,1,1,1,1,-1,-1,-1,#      MA81  32
1,1,1,1,1,-1,-1,-1,-1,-1])#                                             MA81  33
realdata:(CD,[1.0,1.0,1.0,-1.5,.866025403,#                             MA81  34
1.0,1.0,1.0,1.0,1.0,-1.25,.559016994,#                                  MA81  35
.951056516,1.538841768,-.363271264,#                                    MA81  36
1.0,-1.166666667,.790156468,#                                           MA81  37
.0558542672,.734302201,.440958551,#                                     MA81  38
.340872930,-.53396936,.87484229,#                                       MA81  39
1.0,1.0,1.0,1.0,1.0,1.0,#                                               MA81  40
.707106782,.707106782,1.0,-.5,-1.5,.766044443,.93969262,#               MA81  41
-.173648177,.866025403,.866025403,#                                     MA81  42
.64278761,-.342020143,.984807753,#                                      MA81  43
1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,#                                       MA81  44
.707106782,.707106782,.382683432,1.306562965,#                          MA81  45
-.5411961,.707106782,.707106782,#                                       MA81  46
.923879533,-.5411961,1.306562965])#                                     MA81  47
EQUIVALENCE (L1IN,LFIN(1)),(L2IN,LFIN(2))#                              MA81  48
datastuff:#                                                             MA81  49
#                                                                       MA81  50
NF(1)=NB(NF1(IDIV))#                                                    MA81  51
NF(2)=N/NF(1)#                                                          MA81  52
FOR(IDIM=1;IDIM<=2;IDIM=IDIM+1)#                                        MA81  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA81  54
L=NF(IDIM)#                                                             MA81  55
IF(L==1) NEXT#                                                          MA81  56
NOVL=N/L#                                                               MA81  57
LIN=0#                                                                  MA81  58
DO I=1,16#                                                              MA81  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA81  60
IF(L==NB(I)) BREAK#                                                     MA81  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA81  62
LIN=I#                                                                  MA81  63
L1IN=NBF1(LIN); L2IN=NBF2(LIN); L1=NB(L1IN); M1=MB(L1IN)#               MA81  64
L2=NB(L2IN); M2=MB(L2IN)#                                               MA81  65
IF(M2>1)#                                                               MA81  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA81  67
I=0; ID2=MIND(L2IN)#                                                    MA81  68
DO K=1,M2#                                                              MA81  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA81  70
ID2=ID2+1; ID1=MIND(L1IN); IFD=ISN+FD(ID2)#                             MA81  71
DO J=1,M1#                                                              MA81  72
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA81  73
I=I+1; ID1=ID1+1; C(I)=CD(ID1)*CD(ID2); F(I)=FD(ID1)*FD(ID2)#           MA81  74
IF((FD(ID1)+IFD)<0) C(I)=-C(I)#                                         MA81  75
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA81  76
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA81  77
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA81  78
ELSE#                                                                   MA81  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MA81  80
ID=MIND(L1IN)#                                                          MA81  81
DO J=1,M1#                                                              MA81  82
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MA81  83
C(J)=CD(J+ID); F(J)=FD(J+ID)#                                           MA81  84
IF((F(J)+ISN)==(-2)) C(J)=-C(J)#                                        MA81  85
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MA81  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MA81  87
ALPHA=MOD(N/L1,L1)#                                                     MA81  88
IF((ALPHA>1)&(L1>4)) ALPHA=MOD(ALPHA**(PHII(L1IN)-1),L1)#               MA81  89
BETA=MOD(N/L2,L2)#                                                      MA81  90
IF((BETA>1)&(L2>4)) BETA=MOD(BETA**( PHII(L2IN)-1),L2)#                 MA81  91
ID1=ALPHA*L2; ID2=BETA*L1#                                              MA81  92
I=0; IP1=1-L1-L2; OP1=1-ID1-ID2#                                        MA81  93
DO K=1,L2#                                                              MA81  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MA81  95
IP1=IP1+L1; OP1=OP1+ID2#                                                MA81  96
IF(OP1>L)OP1=OP1-L#                                                     MA81  97
DO J=1,L1#                                                              MA81  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MA81  99
I=I+1; IP1=IP1+L2#                                                      MA81 100
IF(IP1>L)IP1=IP1-L#                                                     MA81 101
IP(IP1)=I; OP1=OP1+ID1#                                                 MA81 102
IF(OP1>L)OP1=OP1-L#                                                     MA81 103
OP(OP1)=I#                                                              MA81 104
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MA81 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MA81 106
ID=1-L-NOVL#                                                            MA81 107
DO N2=1,NOVL#                                                           MA81 108
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MA81 109
ID=ID+L; LL=(N-ID)/NOVL; ID1=ID+NOVL*LL-N; I=ID#                        MA81 110
DO N1=1,LL#                                                             MA81 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MA81 112
I=I+NOVL; X(IP(N1))=X1(I)#                                              MA81 113
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MA81 114
IF(LL!=L)#                                                              MA81 115
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MA81 116
LLL=LL+1; I=ID1#                                                        MA81 117
DO N1=LLL,L#                                                            MA81 118
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MA81 119
I=I+NOVL; X(IP(N1))=X1(I)#                                              MA81 120
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MA81 121
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MA81 122
#                                                                       MA81 123
#  NOW PICK OUT THE CORRECT PROCEEDURE FOR TRANSFORMING BASED ON        MA81 124
#  REQUESTED GRID FINENESS.                                             MA81 125
#  --------------------------------------------------------------       MA81 126
#                                                                       MA81 127
GO TO (1000,202,203,204,205,207,208,209,2016,2010,2015,2020,2021,#      MA81 128
2040,2063,2080),LIN#                                                    MA81 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MA81 130
202 CONTINUE#                                                           MA81 131
T1=X(1); X(1)=X(2)+T1; X(2)=T1-X(2)#                                    MA81 132
GO TO 240#                                                              MA81 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MA81 134
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MA81 135
203 CONTINUE#                                                           MA81 136
Y(2)=X(2)+X(3); X(1)=X(1)+Y(2); Y(3)=X(2)-X(3)#                         MA81 137
Y(2)=CMPLX(C(2)*REAL(Y(2)),C(2)*AIMAG(Y(2)))#                           MA81 138
Y(3)=CMPLX(-C(3)*AIMAG(Y(3)),C(3)*REAL(Y(3)))#                          MA81 139
S1=X(1)+Y(2); X(3)=S1-Y(3); X(2)=S1+Y(3)#                               MA81 140
GO TO 240#                                                              MA81 141
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MA81 142
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MA81 143
204 CONTINUE#                                                           MA81 144
S1=X(2)-X(4); S2=X(1)-X(3)#            204 214                          MA81 145
S1=CMPLX(AIMAG(S1),-REAL(S1))#         264                              MA81 146
IF(ISN==1)S1=-S1#                      274                              MA81 147
T2=X(2)+X(4); X(4)=S2-S1; T1=X(1)+X(3)# 234 284 224                     MA81 148
X(3)=T1-T2; X(1)=T1+T2; X(2)=S2+S1#    244 254 294                      MA81 149
GO TO 240#                                                              MA81 150
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MA81 151
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MA81 152
205 CONTINUE#                                                           MA81 153
T1=X(2)+X(5); T2=X(3)+X(4); Y(3)=T1-T2# 205 215 225                     MA81 154
Y(2)=T1+T2; Y(6)=X(2)-X(5); Y(5)=X(4)-X(3)# 235 245 255                 MA81 155
X(1)=Y(2)+X(1); Y(4)=Y(6)+Y(5)#        265 275                          MA81 156
DO IS=2,6#                                                              MA81 157
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MA81 158
D=C(IS)#                                                                MA81 159
IF(IS<4) Y(IS)=CMPLX(D*REAL(Y(IS)),D*AIMAG(Y(IS)))# 285                 MA81 160
ELSE     Y(IS)=CMPLX(-D*AIMAG(Y(IS)),D*REAL(Y(IS)))# 295                MA81 161
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MA81 162
S1=X(1)+Y(2); S2=S1+Y(3); S3=Y(4)-Y(5)# 305 315 325                     MA81 163
X(5)=S2-S3; X(2)=S2+S3; S2=S1-Y(3)#    335 345 355                      MA81 164
S3=Y(4)+Y(6); X(4)=S2-S3; X(3)=S2+S3#  365 375 385                      MA81 165
GO TO 240#                                                              MA81 166
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MA81 167
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MA81 168
207 CONTINUE#                                                           MA81 169
T1=X(2)+X(7); T2=X(3)+X(6); Y(5)=T2-T1# 207 217 227                     MA81 170
T3=X(4)+X(5); Y(3)=T1-T3; Y(4)=T3-T2#  237 247 257                      MA81 171
Y(2)=T1+T2+T3; T1=X(2)-X(7); T2=X(3)-X(6)# 267 277 287                  MA81 172
Y(9)=T2-T1; X(1)=X(1)+Y(2); T3=X(5)-X(4)# 297 307 317                   MA81 173
Y(7)=T1-T3; Y(8)=T3-T2; Y(6)=T1+T2+T3# 327 337 347                      MA81 174
DO IS=2,9#                                                              MA81 175
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MA81 176
D=C(IS)#                                                                MA81 177
IF(IS<6) Y(IS)=CMPLX(D*REAL(Y(IS)),D*AIMAG(Y(IS)))# 357                 MA81 178
ELSE     Y(IS)=CMPLX(-D*AIMAG(Y(IS)),D*REAL(Y(IS)))# 367                MA81 179
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MA81 180
S1=X(1)+Y(2); S2=S1+Y(3)+Y(4); S3=Y(6)+Y(7)+Y(8)# 377 387 397           MA81 181
X(7)=S2-S3; X(2)=S3+S2; S2=S1-Y(3)-Y(5)# 407 417 427                    MA81 182
S3=Y(6)-Y(7)-Y(9); X(6)=S2-S3; X(3)=S3+S2# 437 447 457                  MA81 183
S2=S1-Y(4)+Y(5); S3=Y(6)-Y(8)+Y(9); X(4)=S2-S3# 467 477 487             MA81 184
X(5)=S3+S2#                            497                              MA81 185
GO TO 240#                                                              MA81 186
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MA81 187
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MA81 188
208 CONTINUE#                                                           MA81 189
I=-8#                                                                   MA81 190
DO L22=1,L2#                                                            MA81 191
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MA81 192
I=I+8#                                                                  MA81 193
T2=X(I+4)-X(I+8); T1=X(I+2)-X(I+6); Y(I+7)=T1-T2# 488 218 228           MA81 194
Y(I+8)=T1+T2; T2=X(I+3)+X(I+7); T1=X(I+1)+X(I+5)# 238 248 258           MA81 195
Y(I+3)=T1-T2; T3=T1+T2; T2=X(I+4)+X(I+8)# 268 278 288                   MA81 196
T1=X(I+2)+X(I+6); Y(I+5)=T1-T2; T4=T1+T2# 298 308 318                   MA81 197
Y(I+1)=T4+T3; Y(I+2)=T3-T4; Y(I+4)=X(I+1)-X(I+5)# 328 338 348           MA81 198
Y(I+6)=X(I+3)-X(I+7)#                  358                              MA81 199
Y(5)=CMPLX(-AIMAG(Y(5)),REAL(Y(5)))#                                    MA81 200
IF(ISN==-1)Y(5)=-Y(5)#                                                  MA81 201
Y(6)=CMPLX(-AIMAG(Y(6)),REAL(Y(6)))#                                    MA81 202
IF(ISN==-1)Y(6)=-Y(6)#                                                  MA81 203
Y(7)=CMPLX(C(7)*REAL(Y(7)),C(7)*AIMAG(Y(7)))#                           MA81 204
Y(8)=CMPLX(-C(8)*AIMAG(Y(8)),C(8)*REAL(Y(8)))#                          MA81 205
X(I+5)=Y(I+2); X(I+1)=Y(I+1); X(I+7)=Y(I+3)-Y(I+5)# 368 378 388         MA81 206
T2=Y(I+6)+Y(I+8); T1=Y(I+4)+Y(I+7); X(I+8)=T1-T2# 398 408 418           MA81 207
X(I+2)=T1+T2; T2=Y(I+6)-Y(I+8); T1=Y(I+4)-Y(I+7)# 428 438 448           MA81 208
X(I+4)=T1-T2; X(I+6)=T1+T2; X(I+3)=Y(I+3)+Y(I+5)# 458 468 478           MA81 209
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MA81 210
GO TO 240#                                                              MA81 211
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MA81 212
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MA81 213
209 CONTINUE#                                                           MA81 214
I=-8#                                                                   MA81 215
DO L22=1,L2#                                                            MA81 216
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MA81 217
I=I+8#                                                                  MA81 218
Y(I+3)=X(I+4)+X(I+7);T2=X(I+3)+X(I+8);T1=X(I+2)+X(I+9)# 609 219 229     MA81 219
Y(I+4)=T1-T2; T3=X(I+5)+X(I+6); Y(I+2)=T3+T1+T2# 239 249 259            MA81 220
Y(I+6)=T3-T1; Y(I+5)=T2-T3#            269 279                          MA81 221
Y(I+1)=X(I+1)+Y(I+3)+Y(I+2); Y(I+8)=X(I+4)-X(I+7)# 289 299              MA81 222
T2=X(I+8)-X(I+3); T1=X(I+2)-X(I+9); Y(I+9)=T1-T2# 309 319 329           MA81 223
T3=X(I+5)-X(I+6); Y(I+7)=T3+T1+T2; Y(I+11)=T3-T1# 339 349 359           MA81 224
Y(I+10)=T2-T3#                         369                              MA81 225
DO IS=2,11#                            379                              MA81 226
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MA81 227
D=C(IS)#                                                                MA81 228
IF(IS<7) Y(IS)=CMPLX(D*REAL(Y(IS)),D*AIMAG(Y(IS)))# 409                 MA81 229
ELSE     Y(IS)=CMPLX(-D*AIMAG(Y(IS)),D*REAL(Y(IS)))# 419                MA81 230
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MA81 231
T4=Y(I+2)+Y(I+2); T1=T4+Y(I+1)+Y(I+3)# 429 439                          MA81 232
T3=T1+Y(I+4)+Y(I+5); T2=Y(I+8)+Y(I+9)+Y(I+10)# 449 459                  MA81 233
X(I+2)=T2+T3; X(I+9)=T3-T2; T2=Y(I+1)+Y(I+2)+T4# 469 479 489            MA81 234
X(I+7)=T2-Y(I+7); T4=T1+Y(I+6)-Y(I+5)# 499 509                          MA81 235
T3=Y(I+8)+Y(I+11)-Y(I+10); X(I+8)=T3+T4# 519 529                        MA81 236
X(I+3)=T4-T3; X(I+4)=T2+Y(I+7)#        539 549                          MA81 237
T2=T1-Y(I+4)-Y(I+6); T1=Y(I+8)-Y(I+9)-Y(I+11)# 559 569                  MA81 238
X(I+5)=T1+T2; X(I+6)=T2-T1; X(I+1)=Y(I+1)# 579 589 599                  MA81 239
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MA81 240
GO TO 240#                                                              MA81 241
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MA81 242
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MA81 243
2016  CONTINUE#                                                         MA81 244
T1=X(1)+X(9); T2=X(5)+X(13); T3=T1+T2; Y(4)=T1-T2#                      MA81 245
T1=X(3)+X(11); T2=X(7)+X(15); T4=T1+T2; Y(7)=T1-T2#                     MA81 246
T5=T3+T4; Y(3)=T3-T4; T1=X(3)-X(11); T2=X(7)-X(15)#                     MA81 247
Y(15)=T1+T2; Y(10)=T1-T2; T1=X(2)+X(10); T2=X(6)+X(14)#                 MA81 248
T3=T1+T2; T4=T1-T2; T1=X(4)+X(12); T2=X(8)+X(16)#                       MA81 249
T6=T1+T2; T1=T1-T2; Y(14)=T4+T1; Y(9)=T4-T1#                            MA81 250
Y(6)=T3-T6; T1=T3+T6; Y(1)=T5+T1; Y(2)=T5-T1#                           MA81 251
T1=X(2)-X(10); T2=X(8)-X(16); Y(17)=T1+T2; Y(12)=T1-T2#                 MA81 252
T1=X(6)-X(14); T2=X(4)-X(12); Y(18)=T1+T2; Y(13)=T1-T2#                 MA81 253
Y(5)=X(1)-X(9); Y(8)=X(5)-X(13); Y(16)=Y(17)+Y(18)#                     MA81 254
Y(11)=Y(12)+Y(13)#                                                      MA81 255
DO IS=6,8#                                                              MA81 256
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MA81 257
Y(IS)=CMPLX(-AIMAG(Y(IS)),REAL(Y(IS)))#                                 MA81 258
IF(ISN==-1) Y(IS)=-Y(IS)#                                               MA81 259
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MA81 260
DO IS=9,18#                                                             MA81 261
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MA81 262
D=C(IS)#                                                                MA81 263
IF(IS<14) Y(IS)=CMPLX(D*REAL(Y(IS)),D*AIMAG(Y(IS)))# 6316               MA81 264
ELSE      Y(IS)=CMPLX(-D*AIMAG(Y(IS)),D*REAL(Y(IS)))# 6416              MA81 265
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MA81 266
T1=Y(4)+Y(9); T2=Y(7)+Y(14); X(3)=T1+T2; X(15)=T1-T2#                   MA81 267
T1=Y(4)-Y(9); T2=Y(14)-Y(7); X(7)=T1+T2; X(11)=T1-T2#                   MA81 268
T1=Y(5)+Y(10); T2=Y(12)-Y(11); T3=T1+T2; T4=T1-T2#                      MA81 269
T1=Y(8)+Y(15); T2=Y(16)+Y(17); T5=T1+T2; T6=T1-T2#                      MA81 270
X(10)=T4+T6; X(8)=T4-T6; X(2)=T3+T5; X(16)=T3-T5#                       MA81 271
X(1)=Y(1); X(5)=Y(3)+Y(6); T1=Y(5)-Y(10); T2=Y(13)-Y(11)#               MA81 272
T3=T1+T2; T4=T1-T2; T1=Y(8)-Y(15); T2=Y(16)-Y(18)#                      MA81 273
T5=T1+T2; T6=T1-T2; X(14)=T4+T6; X(4)=T4-T6; X(6)=T3+T5#                MA81 274
X(12)=T3-T5; X(9)=Y(2); X(13)=Y(3)-Y(6)#                                MA81 275
GO TO 240#                                                              MA81 276
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MA81 277
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 MA81 278
2010 CONTINUE#                                                          MA81 279
CALL MA82(X,Y,C,F)#                    Call wfft10(x,y,c,f)             MA81 280
GO TO 240#                                                              MA81 281
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 MA81 282
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 MA81 283
2015 CONTINUE#                                                          MA81 284
CALL MA83(X,Y,C,F)#                    Call wfft15(x,y,c,f)             MA81 285
GO TO 240#                                                              MA81 286
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 MA81 287
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 MA81 288
2020 CONTINUE#                                                          MA81 289
CALL MA84(X,Y,C,F)#                    Call wfft20(x,y,c,f)             MA81 290
GO TO 240#                                                              MA81 291
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 MA81 292
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 MA81 293
2021 CONTINUE#                                                          MA81 294
CALL MA85(X,Y,C,F)#                    Call wfft21(x,y,c,f)             MA81 295
GO TO 240#                                                              MA81 296
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 MA81 297
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 MA81 298
2040 CONTINUE#                                                          MA81 299
CALL MA86(X,Y,C,F)#                    Call wfft40(x,y,c,f)             MA81 300
GO TO 240#                                                              MA81 301
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 MA81 302
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 MA81 303
2063 CONTINUE#                                                          MA81 304
CALL MA87(X,Y,C,F)#                    Call wfft63(x,y,c,f)             MA81 305
GO TO 240#                                                              MA81 306
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 MA81 307
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 MA81 308
2080 CONTINUE#                                                          MA81 309
CALL MA88(X,Y,C,F)#                    Call wfft80(x,y,c,f)             MA81 310
GO TO 240#                                                              MA81 311
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 MA81 312
240   CONTINUE#                                                         MA81 313
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 MA81 314
I=ID#                                                                   MA81 315
DO N1=1,LL#                                                             MA81 316
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 MA81 317
I=I+NOVL; X1(I)=X(OP(N1))#                                              MA81 318
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 MA81 319
IF(LL!=L)#                                                              MA81 320
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 MA81 321
I=ID1#                                                                  MA81 322
DO N1=LLL,L#                                                            MA81 323
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 MA81 324
I=I+NOVL; X1(I)=X(OP(N1))#                                              MA81 325
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 MA81 326
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 MA81 327
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 MA81 328
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MA81 329
#                                                                       MA81 330
1000  CONTINUE#                                                         MA81 331
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA81 332
RETURN#                                                                 MA81 333
END#                                                                    MA81 334
systemheader:(MA82)#                   Winograd's fft suite wfft10      MA82   1
# ################################################################## #  MA82   2
#                                                                    #  MA82   3
#                               MA82                                 #  MA82   4
#                                                                    #  MA82   5
# ################################################################## #  MA82   6
SUBROUTINE MA82(X,Y,C,F)#              J.m.stewart mar 1987             MA82   7
IMPLICIT NONE#                                                          MA82   8
COMPLEX X(12),Y(12),T1,T2,T3#                                           MA82   9
REAL C(12)#                                                             MA82  10
INTEGER F(12)#                                                          MA82  11
INTEGER I,N,N1,N2#                                                      MA82  12
REAL D#                                                                 MA82  13
#                                                                       MA82  14
I=-1#                                                                   MA82  15
DO N2=1,5#                                                              MA82  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA82  17
I=I+2#                                                                  MA82  18
T1=X(I); X(I)=X(I+1)+T1; X(I+1)=T1-X(I+1)# 101 102 100                  MA82  19
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA82  20
DO N1=1,2#                                                              MA82  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA82  22
T1=X(N1+2)+X(N1+8); T2=X(N1+4)+X(N1+6); Y(N1+4)=T1-T2# 201 202 203      MA82  23
Y(N1+2)=T1+T2; Y(N1+10)=X(N1+2)-X(N1+8)# 204 205                        MA82  24
Y(N1+8)=X(N1+6)-X(N1+4); X(N1)=Y(N1+2)+X(N1)# 206 207                   MA82  25
Y(N1+6)=Y(N1+10)+Y(N1+8)#              200                              MA82  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA82  27
DO N=3,12#                                                              MA82  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA82  29
D=C(N)#                                                                 MA82  30
IF(F(N)>0) Y(N)=CMPLX(D*REAL(Y(N)),D*AIMAG(Y(N)))# 250                  MA82  31
ELSE       Y(N)=CMPLX(-D*AIMAG(Y(N)),D*REAL(Y(N)))# 300                 MA82  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA82  33
DO N1=1,2#                                                              MA82  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA82  35
T1=X(N1)+Y(N1+2); T2=T1+Y(N1+4); T3=Y(N1+6)-Y(N1+8)# 401 402 403        MA82  36
X(N1+8)=T2-T3; X(N1+2)=T2+T3; T2=T1-Y(N1+4)# 404 405 406                MA82  37
T3=Y(N1+6)+Y(N1+10); X(N1+6)=T2-T3; X(N1+4)=T2+T3# 407 408 400          MA82  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA82  39
RETURN#                                                                 MA82  40
END#                                                                    MA82  41
systemheader:(MA83)#                   Winograd's fft suite wfft15      MA83   1
# ################################################################## #  MA83   2
#                                                                    #  MA83   3
#                               MA83                                 #  MA83   4
#                                                                    #  MA83   5
# ################################################################## #  MA83   6
SUBROUTINE MA83(X,Y,C,F)#              J.m.stewart mar 1987             MA83   7
IMPLICIT NONE#                                                          MA83   8
COMPLEX X(18),Y(18),T1,T2,T3#                                           MA83   9
REAL C(18)#                                                             MA83  10
INTEGER F(18)#                                                          MA83  11
INTEGER I,N,N1,N2#                                                      MA83  12
REAL D#                                                                 MA83  13
#                                                                       MA83  14
I=-2#                                                                   MA83  15
DO N2=1,5#                                                              MA83  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA83  17
I=I+3#                                 101                              MA83  18
Y(I+1)=X(I+1)+X(I+2); Y(I)=X(I)+Y(I+1)# 102 103                         MA83  19
Y(I+2)=X(I+1)-X(I+2)#                  100                              MA83  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA83  21
DO N1=1,3#                                                              MA83  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA83  23
T1=Y(N1+3)+Y(N1+12); T2=Y(N1+6)+Y(N1+9)# 201 202                        MA83  24
X(N1+6)=T1-T2; X(N1+3)=T1+T2#          203 204                          MA83  25
X(N1+15)=Y(N1+3)-Y(N1+12); X(N1+12)=Y(N1+9)-Y(N1+6)# 205 206            MA83  26
X(N1)=Y(N1)+X(N1+3); X(N1+9)=X(N1+15)+X(N1+12)# 207 200                 MA83  27
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA83  28
DO N=2,18#                                                              MA83  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA83  30
D=C(N)#                                                                 MA83  31
IF(F(N)>0) X(N)=CMPLX(D*REAL(X(N)),D*AIMAG(X(N)))# 250                  MA83  32
ELSE       X(N)=CMPLX(-D*AIMAG(X(N)),D*REAL(X(N)))# 300                 MA83  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA83  34
DO N1=1,3#                                                              MA83  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA83  36
T1=X(N1)+X(N1+3); T2=T1+X(N1+6); T3=X(N1+9)-X(N1+12)# 401 402 403       MA83  37
Y(N1+12)=T2-T3; Y(N1+3)=T3+T2; T2=T1-X(N1+6)# 404 405 406               MA83  38
T3=X(N1+9)+X(N1+15); Y(N1+9)=T2-T3#    407 408                          MA83  39
Y(N1+6)=T3+T2; Y(N1)=X(N1)#            409 400                          MA83  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA83  41
I=-2#                                                                   MA83  42
DO N2=1,5#                                                              MA83  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA83  44
I=I+3; T1=Y(I)+Y(I+1); X(I+2)=T1-Y(I+2)# 501 502 503                    MA83  45
X(I)=Y(I); X(I+1)=T1+Y(I+2)#           504 500                          MA83  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA83  47
RETURN#                                                                 MA83  48
END#                                                                    MA83  49
systemheader:(MA84)#                   Winograd's fft suite wfft20      MA84   1
# ################################################################## #  MA84   2
#                                                                    #  MA84   3
#                               MA84                                 #  MA84   4
#                                                                    #  MA84   5
# ################################################################## #  MA84   6
SUBROUTINE MA84(X,Y,C,F)#              J.m.stewart mar 1987             MA84   7
IMPLICIT NONE#                                                          MA84   8
COMPLEX X(24),Y(24),T1,T2,T3,T4,T5#                                     MA84   9
REAL C(24)#                                                             MA84  10
INTEGER F(24)#                                                          MA84  11
INTEGER I,N,N1,N2#                                                      MA84  12
REAL D#                                                                 MA84  13
I=-3#                                                                   MA84  14
DO N2=1,5#                                                              MA84  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA84  16
I=I+4; T1=X(I)+X(I+2); T2=X(I+1)+X(I+3)# 102 103 104                    MA84  17
Y(I+1)=T1-T2; Y(I)=T1+T2#              105 106                          MA84  18
Y(I+2)=X(I)-X(I+2); Y(I+3)=X(I+1)-X(I+3)# 107 108                       MA84  19
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA84  20
DO N1=1,4#                                                              MA84  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA84  22
T1=Y(N1+4)+Y(N1+16); T2=Y(N1+8)+Y(N1+12)# 201 202                       MA84  23
X(N1+8)=T1-T2; X(N1+4)=T1+T2#          203 204                          MA84  24
X(N1+20)=Y(N1+4)-Y(N1+16); X(N1+16)=Y(N1+12)-Y(N1+8)# 205 206           MA84  25
X(N1)=X(N1+4)+Y(N1); X(N1+12)=X(N1+20)+X(N1+16)# 207 208                MA84  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA84  27
DO N=4,24#                                                              MA84  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA84  29
D=C(N)#                                                                 MA84  30
IF(F(N)>0) X(N)=CMPLX(D*REAL(X(N)),D*AIMAG(X(N)))# 250                  MA84  31
ELSE       X(N)=CMPLX(-D*AIMAG(X(N)),D*REAL(X(N)))# 300                 MA84  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA84  33
DO N1=1,4#                                                              MA84  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA84  35
T1=X(N1)+X(N1+4);T2=T1+X(N1+8);T3=X(N1+12)-X(N1+16)# 401 402 403        MA84  36
Y(N1+16)=T2-T3; Y(N1+4)=T2+T3; T4=T1-X(N1+8)# 404 405 406               MA84  37
T5=X(N1+12)+X(N1+20)#                  407                              MA84  38
Y(N1+12)=T4-T5; Y(N1+8)=T4+T5; Y(N1)=X(N1)# 408 409 410                 MA84  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA84  40
I=-3#                                                                   MA84  41
DO N2=1,5#                                                              MA84  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA84  43
I=I+4; X(I+3)=Y(I+2)-Y(I+3); X(I)=Y(I)# 501 502 503                     MA84  44
X(I+2)=Y(I+1); X(I+1)=Y(I+2)+Y(I+3)#   504 505                          MA84  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA84  46
RETURN#                                                                 MA84  47
END#                                                                    MA84  48
systemheader:(MA85)#                   Winograd's fft suite wfft21      MA85   1
# ################################################################## #  MA85   2
#                                                                    #  MA85   3
#                               MA85                                 #  MA85   4
#                                                                    #  MA85   5
# ################################################################## #  MA85   6
SUBROUTINE MA85(X,Y,C,F)#              J.m.stewart mar 1987             MA85   7
IMPLICIT NONE#                                                          MA85   8
COMPLEX X(27),Y(27),T1,T2,T3#                                           MA85   9
REAL C(27)#                                                             MA85  10
INTEGER F(27)#                                                          MA85  11
INTEGER I,N,N2#                                                         MA85  12
REAL D#                                                                 MA85  13
I=-2#                                                                   MA85  14
DO N2=1,7#                                                              MA85  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA85  16
I=I+3; Y(I+1)=X(I+1)+X(I+2)#           101 102                          MA85  17
Y(I)=X(I)+Y(I+1); Y(I+2)=X(I+1)-X(I+2)# 103 104                         MA85  18
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA85  19
DO I=1,3#                                                               MA85  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA85  21
T1=Y(I+3)+Y(I+18); T2=Y(I+6)+Y(I+15); X(I+12)=T2-T1# 201 202 203        MA85  22
T3=Y(I+9)+Y(I+12); X(I+6)=T1-T3; X(I+9)=T3-T2# 204 205 206              MA85  23
X(I+3)=T1+T2+T3; T1=Y(I+3)-Y(I+18); T2=Y(I+6)-Y(I+15)# 207 208 209      MA85  24
X(I+24)=T2-T1; X(I)=Y(I)+X(I+3); T3=Y(I+12)-Y(I+9)# 210 211 212         MA85  25
X(I+18)=T1-T3; X(I+21)=T3-T2; X(I+15)=T1+T2+T3# 213 214 215             MA85  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA85  27
DO N=2,27#                                                              MA85  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA85  29
D=C(N)#                                                                 MA85  30
IF(F(N)>0) X(N)=CMPLX(D*REAL(X(N)),D*AIMAG(X(N)))# 250                  MA85  31
ELSE       X(N)=CMPLX(-D*AIMAG(X(N)),D*REAL(X(N)))# 300                 MA85  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA85  33
DO I=1,3#                                                               MA85  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA85  35
T1=X(I)+X(I+3); T2=T1+X(I+6)+X(I+9)#   401 402                          MA85  36
T3=X(I+15)+X(I+18)+X(I+21); Y(I+18)=T2-T3# 403 404                      MA85  37
Y(I+3)=T3+T2; T2=T1-X(I+6)-X(I+12)#    405 406                          MA85  38
T3=X(I+15)-X(I+18)-X(I+24); Y(I+15)=T2-T3# 407 408                      MA85  39
Y(I+6)=T3+T2; T2=T1-X(I+9)+X(I+12)#    409 410                          MA85  40
T3=X(I+15)-X(I+21)+X(I+24)#            411                              MA85  41
Y(I+9)=T2-T3; Y(I+12)=T3+T2; Y(I)=X(I)# 412 413 414                     MA85  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA85  43
I=-2#                                                                   MA85  44
DO N2=1,7#                                                              MA85  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA85  46
I=I+3; T1=Y(I)+Y(I+1); X(I+2)=T1-Y(I+2)# 501 502 503                    MA85  47
X(I)=Y(I); X(I+1)=T1+Y(I+2)#           504 505                          MA85  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA85  49
RETURN#                                                                 MA85  50
END#                                                                    MA85  51
systemheader:(MA86)#                   Winograd's fft suite wfft40      MA86   1
# ################################################################## #  MA86   2
#                                                                    #  MA86   3
#                               MA86                                 #  MA86   4
#                                                                    #  MA86   5
# ################################################################## #  MA86   6
SUBROUTINE MA86(X,Y,C,F)#              J.m.stewart mar 1987             MA86   7
IMPLICIT NONE#                                                          MA86   8
COMPLEX X(48),Y(48),T1,T2,T3,T4#                                        MA86   9
REAL C(48)#                                                             MA86  10
INTEGER F(48)#                                                          MA86  11
INTEGER I,N,N1,N2#                                                      MA86  12
REAL D#                                                                 MA86  13
I=-8#                                                                   MA86  14
DO N2=1,5#                                                              MA86  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA86  16
I=I+8; T2=X(I+4)-X(I+8); T1=X(I+2)-X(I+6)# 208 218                      MA86  17
Y(I+7)=T1-T2; Y(I+8)=T1+T2; T2=X(I+3)+X(I+7)# 228 238 248               MA86  18
T1=X(I+1)+X(I+5); Y(I+3)=T1-T2; T3=T1+T2# 258 268 278                   MA86  19
T2=X(I+4)+X(I+8); T1=X(I+2)+X(I+6); Y(I+5)=T1-T2# 288 298 308           MA86  20
T4=T1+T2; Y(I+1)=T4+T3; Y(I+2)=T3-T4#  318 328 338                      MA86  21
Y(I+4)=X(I+1)-X(I+5); Y(I+6)=X(I+3)-X(I+7)#                             MA86  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA86  23
DO N1=1,8#                                                              MA86  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA86  25
T1=Y(N1+8)+Y(N1+32); T2=Y(N1+16)+Y(N1+24)# 201 202                      MA86  26
X(N1+16)=T1-T2; X(N1+8)=T1+T2#         203 204                          MA86  27
X(N1+40)=Y(N1+8)-Y(N1+32); X(N1+32)=Y(N1+24)-Y(N1+16)# 205 206          MA86  28
X(N1)=X(N1+8)+Y(N1); X(N1+24)=X(N1+40)+X(N1+32)# 207 209                MA86  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA86  30
DO N=5,48#                                                              MA86  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA86  32
D=C(N)#                                                                 MA86  33
IF(F(N)>0) X(N)=CMPLX(D*REAL(X(N)),D*AIMAG(X(N)))# 250                  MA86  34
ELSE       X(N)=CMPLX(-D*AIMAG(X(N)),D*REAL(X(N)))# 300                 MA86  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA86  36
DO N1=1,8#                                                              MA86  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA86  38
T1=X(N1)+X(N1+8); T2=T1+X(N1+16); T3=X(N1+24)-X(N1+32)# 401 402 403     MA86  39
Y(N1+32)=T2-T3; Y(N1+8)=T2+T3; T2=T1-X(N1+16)# 404 405 406              MA86  40
T3=X(N1+24)+X(N1+40); Y(N1+24)=T2-T3#  407 411                          MA86  41
Y(N1+16)=T2+T3; Y(N1)=X(N1)#           409 410                          MA86  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA86  43
I=-8#                                                                   MA86  44
DO N2=1,5#                                                              MA86  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA86  46
I=I+8; X(I+5)=Y(I+2); X(I+1)=Y(I+1)#   501 368 378                      MA86  47
X(I+7)=Y(I+3)-Y(I+5);T2=Y(I+6)+Y(I+8);T1=Y(I+4)+Y(I+7)# 388 398 408     MA86  48
X(I+8)=T1-T2; X(I+2)=T1+T2; T2=Y(I+6)-Y(I+8)# 418 428 438               MA86  49
T1=Y(I+4)-Y(I+7); X(I+4)=T1-T2#        448 458                          MA86  50
X(I+6)=T1+T2; X(I+3)=Y(I+3)+Y(I+5)#    468 478                          MA86  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA86  52
RETURN#                                                                 MA86  53
END#                                                                    MA86  54
systemheader:(MA87)#                   Winograd's fft suite wfft63      MA87   1
# ################################################################## #  MA87   2
#                                                                    #  MA87   3
#                               MA87                                 #  MA87   4
#                                                                    #  MA87   5
# ################################################################## #  MA87   6
SUBROUTINE MA87(X,Y,C,F)#              J.m.stewart mar 1987             MA87   7
IMPLICIT NONE#                                                          MA87   8
COMPLEX X(99),Y(99),T1,T2,T3,T4#                                        MA87   9
REAL C(99)#                                                             MA87  10
INTEGER F(99)#                                                          MA87  11
INTEGER I,IY,N,N2#                                                      MA87  12
REAL D#                                                                 MA87  13
I=-9; IY=-11#                                                           MA87  14
DO N2=1,7#                                                              MA87  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA87  16
I=I+9; IY=IY+11#                                                        MA87  17
Y(IY+3)=X(I+4)+X(I+7); T2=X(I+3)+X(I+8); T1=X(I+2)+X(I+9)# 209 219      MA87  18
Y(IY+4)=T1-T2; T3=X(I+5)+X(I+6); Y(IY+2)=T3+T1+T2# 239 249 259          MA87  19
Y(IY+6)=T3-T1; Y(IY+5)=T2-T3; Y(IY+1)=X(I+1)+Y(IY+3)+Y(IY+2)# 269 2     MA87  20
Y(IY+8)=X(I+4)-X(I+7); T2=X(I+8)-X(I+3); T1=X(I+2)-X(I+9)# 299 309      MA87  21
Y(IY+9)=T1-T2; T3=X(I+5)-X(I+6); Y(IY+7)=T3+T1+T2# 329 339 349          MA87  22
Y(IY+11)=T3-T1; Y(IY+10)=T2-T3#        359 369                          MA87  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA87  24
DO I=1,11#                                                              MA87  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA87  26
T1=Y(I+11)+Y(I+66); T2=Y(I+22)+Y(I+55); X(I+44)=T2-T1# 201 202 203      MA87  27
T3=Y(I+33)+Y(I+44); X(I+22)=T1-T3; X(I+33)=T3-T2# 204 205 206           MA87  28
X(I+11)=T1+T2+T3; T1=Y(I+11)-Y(I+66); T2=Y(I+22)-Y(I+55)# 207 208 2     MA87  29
X(I+88)=T2-T1; X(I)=Y(I)+X(I+11); T3=Y(I+44)-Y(I+33)# 210 211 212       MA87  30
X(I+66)=T1-T3; X(I+77) =T3-T2; X(I+55)=T1+T2+T3# 213 214 215            MA87  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA87  32
DO N=2,99#                                                              MA87  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA87  34
D=C(N)#                                                                 MA87  35
IF(F(N)>0) X(N)=CMPLX(D*REAL(X(N)),D*AIMAG(X(N)))# 250                  MA87  36
ELSE       X(N)=CMPLX(-D*AIMAG(X(N)),D*REAL(X(N)))# 300                 MA87  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA87  38
DO I=1,11#                                                              MA87  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA87  40
T1=X(I)+X(I+11); T2=T1+X(I+22)+X(I+33)# 401 402                         MA87  41
T3=X(I+55)+X(I+66)+X(I+77)#            403                              MA87  42
Y(I+66)=T2-T3; Y(I+11)=T3+T2; T2=T1-X(I+22)-X(I+44)# 404 405 406        MA87  43
T3=X(I+55)-X(I+66)-X(I+88);Y(I+55)=T2-T3;Y(I+22)=T3+T2# 407 408 415     MA87  44
T2=T1-X(I+33)+X(I+44); T3=X(I+55)-X(I+77)+X(I+88)# 410 411              MA87  45
Y(I+33)=T2-T3; Y(I+44)=T3+T2; Y(I)=X(I)# 412 413 414                    MA87  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA87  47
I=-9; IY=-11#                                                           MA87  48
DO N2=1,7#                                                              MA87  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA87  50
I=I+9; IY=IY+11#                                                        MA87  51
T4=Y(IY+2)+Y(IY+2); T1=T4+Y(IY+1)+Y(IY+3)# 429 439                      MA87  52
T3=T1+Y(IY+4)+Y(IY+5); T2=Y(IY+8)+Y(IY+9)+Y(IY+10)# 449 459             MA87  53
X(I+2)=T2+T3; X(I+9)=T3-T2; T2=Y(IY+1)+Y(IY+2)+T4# 469 479 489          MA87  54
X(I+7)=T2-Y(IY+7); T4=T1+Y(IY+6)-Y(IY+5)# 499 509                       MA87  55
T3=Y(IY+8)+Y(IY+11)-Y(IY+10)#          519                              MA87  56
X(I+8)=T3+T4; X(I+3)=T4-T3; X(I+4)=T2+Y(IY+7)# 529 539 549              MA87  57
T2=T1-Y(IY+4)-Y(IY+6); T1=Y(IY+8)-Y(IY+9)-Y(IY+11)# 559 569             MA87  58
X(I+5)=T1+T2; X(I+6)=T2-T1; X(I+1)=Y(IY+1)# 579 589 599                 MA87  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA87  60
RETURN#                                                                 MA87  61
END#                                                                    MA87  62
systemheader:(MA88)#                   Winograd's fft suite wfft80      MA88   1
# ################################################################## #  MA88   2
#                                                                    #  MA88   3
#                               MA88                                 #  MA88   4
#                                                                    #  MA88   5
# ################################################################## #  MA88   6
SUBROUTINE MA88(X,Y,C,F)#              J.m.stewart mar 1987             MA88   7
IMPLICIT NONE#                                                          MA88   8
COMPLEX X(108),Y(108),T1,T2,T3,T4,T5,T6#                                MA88   9
REAL C(108)#                                                            MA88  10
INTEGER F(108)#                                                         MA88  11
INTEGER I,IY,N,N1,N2#                                                   MA88  12
REAL D#                                                                 MA88  13
I=-16; IY=-18#                                                          MA88  14
DO N2=1,5#                                                              MA88  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MA88  16
I=I+16; IY=IY+18#                                                       MA88  17
T1=X(I+1)+X(I+9); T2=X(I+5)+X(I+13); T3=T1+T2# 2116 2216 2316           MA88  18
Y(IY+4)=T1-T2; T1=X(I+3)+X(I+11); T2=X(I+7)+X(I+15)# 2416 2516 2616     MA88  19
T4=T1+T2; Y(IY+7)=T1-T2; T5=T3+T4#     2716 2816 2916                   MA88  20
Y(IY+3)=T3-T4; T1=X(I+3)-X(I+11); T2=X(I+7)-X(I+15)# 3016 3116 3216     MA88  21
Y(IY+15)=T1+T2; Y(IY+10)=T1-T2; T1=X(I+2)+X(I+10)# 3316 3416 3516       MA88  22
T2=X(I+6)+X(I+14); T3=T1+T2; T4=T1-T2# 3616 3716 3816                   MA88  23
T1=X(I+4)+X(I+12); T2=X(I+8)+X(I+16); T6=T1+T2# 3916 4016 4116          MA88  24
T1=T1-T2; Y(IY+14)=T4+T1; Y(IY+9)=T4-T1# 4216 4316 4416                 MA88  25
Y(IY+6)=T3-T6; T1=T3+T6; Y(IY+1)=T5+T1# 4516 4616 4716                  MA88  26
Y(IY+2)=T5-T1; T1=X(I+2)-X(I+10); T2=X(I+8)-X(I+16)# 4816 4916 5016     MA88  27
Y(IY+17)=T1+T2; Y(IY+12)=T1-T2; T1=X(I+6)-X(I+14)# 5116 5216 5316       MA88  28
T2=X(I+4)-X(I+12); Y(IY+18)=T1+T2; Y(IY+13)=T1-T2# 5416 5516 5616       MA88  29
Y(IY+5)=X(I+1)-X(I+9); Y(IY+8)=X(I+5)-X(I+13)# 5716 5816                MA88  30
Y(IY+16)=Y(IY+17)+Y(IY+18); Y(IY+11)=Y(IY+12)+Y(IY+13)# 5916 6016       MA88  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MA88  32
DO N1=1,18#                                                             MA88  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MA88  34
T1=Y(N1+18)+Y(N1+72); T2=Y(N1+36)+Y(N1+54)# 201 202                     MA88  35
X(N1+36)=T1-T2; X(N1+18)=T1+T2#        203 204                          MA88  36
X(N1+90)=Y(N1+18)-Y(N1+72); X(N1+72)=Y(N1+54)-Y(N1+36)# 205 206         MA88  37
X(N1)   =X(N1+18)+Y(N1); X(N1+54)=X(N1+90)+X(N1+72)# 207 209            MA88  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MA88  39
DO N=6,108#                                                             MA88  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MA88  41
D=C(N)#                                                                 MA88  42
IF(F(N)>0) X(N)=CMPLX(D*REAL(X(N)),D*AIMAG(X(N)))# 250                  MA88  43
ELSE       X(N)=CMPLX(-D*AIMAG(X(N)),D*REAL(X(N)))# 300                 MA88  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MA88  45
DO N1=1,18#                                                             MA88  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MA88  47
T1=X(N1)+X(N1+18); T2=T1+X(N1+36); T3=X(N1+54)-X(N1+72)# 401 402 40     MA88  48
Y(N1+72)=T2-T3; Y(N1+18)=T2+T3; T2=T1-X(N1+36)# 404 405 406             MA88  49
T3=X(N1+54)+X(N1+90)#                  407                              MA88  50
Y(N1+54)=T2-T3; Y(N1+36)=T2+T3; Y(N1)=X(N1)# 411 409 410                MA88  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MA88  52
I=-16; IY=-18#                                                          MA88  53
DO N2=1,5#                                                              MA88  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MA88  55
I=I+16; IY=IY+18#                                                       MA88  56
T1=Y(IY+4)+Y(IY+9); T2=Y(IY+7)+Y(IY+14); X(I+3)=T1+T2# 6516 6616 67     MA88  57
X(I+15)=T1-T2; T1=Y(IY+4)-Y(IY+9); T2=Y(IY+14)-Y(IY+7)# 6816 6916 7     MA88  58
X(I+7)=T1+T2; X(I+11)=T1-T2; T1=Y(IY+5)+Y(IY+10)# 7116 7216 7316        MA88  59
T2=Y(IY+12)-Y(IY+11); T3=T1+T2; T4=T1-T2# 7416 7516 7616                MA88  60
T1=Y(IY+8)+Y(IY+15); T2=Y(IY+16)+Y(IY+17); T5=T1+T2# 7716 7816 7916     MA88  61
T6=T1-T2; X(I+10)=T4+T6; X(I+8)=T4-T6# 8016 8116 8216                   MA88  62
X(I+2)=T3+T5; X(I+16)=T3-T5; X(I+1)=Y(IY+1)# 8316 8416 8516             MA88  63
X(I+5)=Y(IY+3)+Y(IY+6); T1=Y(IY+5)-Y(IY+10)# 8616 8716                  MA88  64
T2=Y(IY+13)-Y(IY+11)#                  8816                             MA88  65
T3=T1+T2; T4=T1-T2; T1=Y(IY+8)-Y(IY+15)# 8916 9016 9116                 MA88  66
T2=Y(IY+16)-Y(IY+18); T5=T1+T2; T6=T1-T2# 9216 9316 9416                MA88  67
X(I+14)=T4+T6; X(I+4)=T4-T6; X(I+6)=T3+T5# 9516 9616 9716               MA88  68
X(I+12)=T3-T5; X(I+9)=Y(IY+2); X(I+13)=Y(IY+3)-Y(IY+6)# 9816 9916 1     MA88  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MA88  70
RETURN#                                                                 MA88  71
END#                                                                    MA88  72
pmacro:([no:])#                        Purge xtal system macros         MA88  73
