systemheader:(MI    )#                                                  MI     1
##   version: Aug93                                                             
####################################################################### MI     2
#                                                                     # MI     3
#                            ***   MIR  ***                           # MI     4
#                                                                     # MI     5
# THE MIR PROGRAM (MULTIPLE ISOMORPHOUS REFINEMENT) IS DESIGNED TO    # MI     6
#  PROVIDE A MEANS OF CALCULATING REFLECTION PHASES AND REFINING HEAVY# MI     7
#  ATOM PARAMETER PHASES AND REFINING HEAVY ATOM PARAMETERS FOR MACRO-# MI     8
#  MOLECULAR COMPOUNDS BY THE METHOD OF MULTIPLE ISOMORPHOUS          # MI     9
#  REFINEMENT.                                                        # MI    10
#      NATIONAL RESOURCE FOR CHEMISTRY WORKSHOP, NOVEMBER 1979.       # MI    11
#           NRCC WORKSHOPS, 1980,1981.                                # MI    12
#  USE OF THIS PROGRAM SHOULD REFERENCE THE FOLLOWING PAPER           # MI    13
#  REFERENCE: R.A.ALDEN,G.BRICOGNE,S.T.FREER,S.R.HALL,W.A.HENDRICKSON,# MI    14
#    P.MACHIN,R.J.MUNN,A.J.OLSON,G.N.REEKE,JR.,S.SHERIFF,J.M.STEWART, # MI    15
#    J.SYGUSH,L.F.TEN EYCK, AND K.D.WATENPAUGH,                       # MI    16
#    COMPUTERS IN CHEM.,7,137 (1983).                                 # MI    17
#                                                                     # MI    18
#  INQUIRIES AND COMMENTS SHOULD BE ADDRESSED TO:                     # MI    19
#                     KEITH D. WATENPAUGH                             # MI    20
#          PHYSICAL AND ANALYTICAL CHEMISTRY RESEARCH                 # MI    21
#                THE UPJOHN COMPANY 7255-209-1                        # MI    22
#                      KALAMAZOO, MI 49001                            # MI    23
#                         (616)385-5481                               # MI    24
####################################################################### MI    25
#                                                                       MI    26
include:(XMACRO)#                                                       MI    27
#                                                                       MI    28
########## MACRO SET 0                                                  MI    29
extrude:(MIMAC0)#                                                       MI    30
macro:(aanomc:,QX($1+9))#              A part of anomalous scatteri     MI    31
#                                         Calculated heavy atom s.f.    MI    32
macro:(abcd:,QX($1+11))#               Hendrickson coefficients for     MI    33
#                                         Isomorphous differences.      MI    34
macro:(abcdan:,QX($1+15))#             Hendrickson coefficients for     MI    35
#                                         Anomalous differences.        MI    36
macro:(ahcalc:,QX($1+7))#              A part of calc. heavy atom       MI    37
#                                         Structure factor.             MI    38
macro:(anflg:,QX($1+1))#               Processing flag, telling how     MI    39
#                                         To include this isomorph.     MI    40
macro:(banomc:,QX($1+10))#             B part of anomalous scatteri     MI    41
#                                         Calculated heavy atom s.f.    MI    42
macro:(bhcalc:,QX($1+8))#              B part of calc. heavy atom       MI    43
#                                         Structure factor.             MI    44
macro:(binstart:,6)#                   Number of items preceding th     MI    45
#                                         Error bins in qx(starkb)      MI    46
macro:(cosbst:,QX(STARCR+6))#          Cosine of best phase             MI    47
macro:(cosmp:,QX(STARCR+8))#           Cosine of most probable phas     MI    48
macro:(delfsq:,QX($1+23))#             (fph(+)**2-fph(-)**2)/2.         MI    49
#                                                                       MI    50
macro:(delfsqn:,QX($1+28))#            Scaled delfsq: value             MI    51
macro:(eano:,QX($1+36))#               Squared residual lack of         MI    52
#                                         Closure error for anomalous   MI    53
#                                         Data.                         MI    54
macro:(eiso:,QX($1+35))#               Squared residual lack of         MI    55
#                                         Closure error for isomorphous MI    56
#                                         Data.                         MI    57
macro:(fazprb:,3)#                     Indicates fazprb phase detn.     MI    58
macro:(figmer:,QX(STARCR+5))#          Figure of merit                  MI    59
macro:(fph:,QX($1+20))#                |fph| (or |fp| for native)       MI    60
macro:(fphn:,QX($1+26))#               |fph| observed, scaled, etc.     MI    61
macro:(fphsq:,QX($1+21))#              Fph**2                           MI    62
macro:(fphsqn:,QX($1+25))#             (k*exp(db*sitol**2)) * fph**     MI    63
macro:(frelm:,QX($1+4))#               |f-| relative                    MI    64
macro:(frelp:,QX($1+2))#               |f+| relative                    MI    65
macro:(hxx:,QX(STARCR+19))#            Inverse hessian.                 MI    66
macro:(hxy:,QX(STARCR+20))#            Inverse hessian.                 MI    67
macro:(hyy:,QX(STARCR+21))#            Inverse hessian.                 MI    68
macro:(maxatoms:,100)#                 Maximum no. of atoms allowed     MI    69
macro:(maxparam:,125)#                 Max. no. of parameters allow     MI    70
macro:(maxsets:,10)#                   Maximum number of datasets       MI    71
macro:(maxspace:,[arith:(maxatoms:,*,arith:(stepat:,+,stepan:))])#      MI    72
macro:(multiplicity:,QX(STARCR+11))#   Reflection multiplicity          MI    73
macro:(mvfc:,2)#                       Indicates mvfc phase determ.     MI    74
macro:(none:,-1)#                      Indicates something not          MI    75
#                                         Explicitly specified          MI    76
#                                         (phasing, matrix, etc.).      MI    77
macro:(rcul:,QX($1+8))#                R cullis numerator               MI    78
macro:(scale:,QX($1+19))#              Scale factor to scale |f|        MI    79
#                                         To native.                    MI    80
macro:(sgrp:,QX($1+6))#                Reserved for scale group         MI    81
#                                         Control.                      MI    82
macro:(signopp:,QX($1+2))#             Sign of observed and             MI    83
#                                         Calculated anomalous is       MI    84
#                                         Opposite.                     MI    85
macro:(signsame:,QX($1+1))#            Sign of observed and             MI    86
#                                         Calculated is the same.       MI    87
macro:(signzero:,QX($1+3))#            Either was unobserved or         MI    88
#                                         Calculated anomalous          MI    89
#                                         Difference was zero.          MI    90
macro:(sinbst:,QX(STARCR+7))#          Sine of best phase               MI    91
macro:(sinmp:,QX(STARCR+9))#           Sine of most probable phase      MI    92
macro:(stepan:,[incr:(arith:(23,/,mxchwd:))])# Words to hold 24 chars   MI    93
macro:(stepat:,13)#                    Step size for atom directory     MI    94
macro:(stol:,QX(STARCR+4))#            Sine(theta)/lambda               MI    95
macro:(varano:,QX($1+38))#             Total anomalous variance         MI    96
macro:(vardelf:,QX($1+24))#            Variance of anomalous            MI    97
#                                         Difference.                   MI    98
macro:(varfsq:,QX($1+22))#             Var(fph**2)                      MI    99
macro:(varfsqn:,QX($1+27))#            Scaled variance of fph**2        MI   100
macro:(variso:,QX($1+37))#             Total isomorphous variance       MI   101
macro:(xp:,QX(STARCR+17))#             Most prob. native struc. fac     MI   102
macro:(yp:,QX(STARCR+18))#             Most prob. native struc. fac     MI   103
#                                                                       MI   104
# DEBUGGING TOOLS                                                       MI   105
#                                                                       MI   106
macro:(arg:,[ifelse:($1,,,[$1])])#                                      MI   107
macro:(debug:,[PRINT*,#                                                 MI   108
$1 z:($2) z:($3) z:($4) z:($5) z:($6) z:($7) z:($8) z:($9)])#           MI   109
macro:(mdebug:,[$2=$2-1;IF($2>0)$(PRINT*,#                              MI   110
$1  z:($3) z:($4) z:($5) z:($6) z:($7) z:($8) z:($9)$)])#               MI   111
macro:(setknt:,$1=$2)#                                                  MI   112
macro:(z:,[ifelse:($1,,,$,arg:($1))])#                                  MI   113
endext:#                                                                MI   114
#                                                                       MI   115
############ MACRO SET 1                                                MI   116
extrude:(MIMAC1)#                                                       MI   117
# MISCELLANEOUS DEFINITIONS                                             MI   118
macro:(blockd:,4)#                     Indicates block diagonal         MI   119
#                                         Matrices used in phase        MI   120
#                                         Refinement (independent       MI   121
#                                         Isomorphs).                   MI   122
macro:(bover:,QX($1+3))#               Overall b for dataset            MI   123
macro:(exmin:,-50.0)#                  Exponent of minimum revised      MI   124
#                                         Probability.                  MI   125
macro:(expon:,QX($1))#                                                  MI   126
macro:(extop:,0.0)#                    Exponent of maximum revised      MI   127
#                                         Probability.  currently set   MI   128
#                                         For pmax=1.                   MI   129
macro:(factor:,50)#                                                     MI   130
macro:(fullmtx:,5)#                    Indicates full matrix used       MI   131
macro:(getvar:,MI49($1,$2,$3))#                                         MI   132
macro:(hh:,QX(STARCR+1))#                                               MI   133
macro:(half:,0.5)#                                                      MI   134
macro:(hkl:,QX(STARCR+10))#            Packed indices                   MI   135
macro:(kk:,QX(STARCR+2))#                                               MI   136
macro:(kover:,QX($1+1))#               Overall scale of dataset         MI   137
macro:(ll:,QX(STARCR+3))#                                               MI   138
macro:(little:,0.001)#                                                  MI   139
macro:(max20:,200)#                    Max. no. of items which can      MI   140
#                                         Be on scratch lrrefl:.        MI   141
macro:(maxcycs:,10)#                   Max. no. of least squares cyc.   MI   142
macro:(rmul:,QX(STARCR+11))#                                            MI   143
macro:(sincos:,QX($1))#                Sine and cosine table            MI   144
macro:(size:,2)#                       Number of new items/isomorph     MI   145
#                                         To be put into lrrefl:.       MI   146
macro:(srelm:,QX($1+5))#               Std. dev. of |f-|**2             MI   147
macro:(srelp:,QX($1+3))#               Std. dev. of |f+|**2             MI   148
macro:(sumfh:,QX($1+6))#               Heavy atom contribution          MI   149
macro:(sumfph:,QX($1+2))#              R kraut denominator              MI   150
endext:#                                                                MI   151
#                                                                       MI   152
############# MACRO SET 2                                               MI   153
extrude:(MIMAC2)#                                                       MI   154
# DEFINE "PROCEDURE" MACROS                                             MI   155
# THESE MACROS ARE USED BY PROGRAMS MI05, MI30, MI40, MI75, AND MI86    MI   156
#                                                                       MI   157
macro:(seed:,2000)#                                                     MI   158
macro:(makenum:,[macro:([seed:],arith:(seed:,-,$1))seed:])#             MI   159
macro:(defineproc:,[macro:($1:,makenum:(1))])#                          MI   160
macro:(procedure:,$1: CONTINUE)#                                        MI   161
macro:(xeq:,[$(#                                                        MI   162
ASSIGN makenum:(1) TO J $1:#                                            MI   163
GO TO $1:#                                                              MI   164
seed: CONTINUE#                                                         MI   165
$)])#                                                                   MI   166
macro:(endproc:,GOTO J $1:)#                                            MI   167
macro:(deleteproc:,[xmacro:([$1:])])#                                   MI   168
endext:#                                                                MI   169
#                                                                       MI   170
########### MACRO SET 3                                                 MI   171
extrude:(MIMAC3)#                                                       MI   172
# BLOCK 4 STATISTICAL TYPES                                             MI   173
# THESE MACROS ARE USED BY PROGRAMS MI64, MI75, MI77, MI78, MI79,       MI   174
#  AND MI85.                                                            MI   175
#                                                                       MI   176
macro:(sumanoadj:,QX($1+17))#          Adjusted anomalous closure       MI   177
#                                         On fph**2.                    MI   178
macro:(sumanoclo:,QX($1+16))#          Anomalous closure on fph**2      MI   179
macro:(sumanodif:,QX($1+18))#          Anomalous differences on         MI   180
#                                         Fph**2.                       MI   181
macro:(sumnatanoadj:,QX($1+5))#        Adj. anomalous closure error     MI   182
#                                         For parent.                   MI   183
macro:(sumnatanoclo:,QX($1+4))#        Anomalous closure error for      MI   184
#                                         Parent.                       MI   185
macro:(sumnatanodif:,QX($1+6))#        Anomalous differences for        MI   186
#                                         Parent.                       MI   187
macro:(sumvar:,QX($1+1))#              Variance for parent, all         MI   188
macro:(sumvara:,QX($1+3))#             Variance for parent, acentri     MI   189
macro:(sumvarc:,QX($1+2))#             Variance for parent, centric     MI   190
endext:#                                                                MI   191
#                                                                       MI   192
########### MACRO SET 4                                                 MI   193
extrude:(MIMAC4)#                                                       MI   194
# THESE MACROS ARE USED BY PROGRAMS MI48, MI50, MI52, MI53 AND MI56.    MI   195
#                                                                       MI   196
macro:(aanomcn:,QX($1+31))#            Ah prime, heavy atom anomalo     MI   197
#                                         A part.                       MI   198
macro:(ahcalcn:,QX($1+29))#            Ah, heavy atom a calc            MI   199
macro:(banomcn:,QX($1+32))#            Bh prime, heavy atom anomalo     MI   200
#                                         B part.                       MI   201
macro:(bhcalcn:,QX($1+30))#            Bh, heavy atom b calc            MI   202
macro:(fhanomn:,QX($1+34))#            |fh prime|, anomalous heavy      MI   203
#                                         Atom amplitude.               MI   204
macro:(fhn:,QX($1+33))#                |fh|, calculated heavy atom      MI   205
#                                         Structure amplitude.          MI   206
endext:#                                                                MI   207
#                                                                       MI   208
############ MACRO SET 5                                                MI   209
extrude:(MIMAC5)#                                                       MI   210
# BLOCK 1 STATISTICAL TYPES                                             MI   211
# THESE MACROS ARE USED BY PROGRAMS MI63 AND MI76.                      MI   212
#                                                                       MI   213
macro:(delrho:,QX(STARS1+31))#         Mean square error in electro     MI   214
#                                         Density.                      MI   215
macro:(fomhist:,QX($1+1))#             Figure of merit histogram        MI   216
macro:(fomhista:,QX($1+3))#            Figure of merit histogram,       MI   217
#                                         Acentric reflections.         MI   218
macro:(fomhistc:,QX($1+2))#            Figure of merit histogram,       MI   219
#                                         Centric reflections.          MI   220
macro:(sumbmdifa:,QX(STARS1+39))#      Acentric best minus most         MI   221
#                                         Probable phase differences.   MI   222
macro:(sumbmdifc:,QX(STARS1+37))#      Number of centric phase          MI   223
#                                         Differences between best and  MI   224
#                                         Most probable phases.         MI   225
macro:(sumfazdifa:,QX(STARS1+35))#     Acentric phase differences       MI   226
macro:(sumfazdifc:,QX(STARS1+33))#     No. of centric phase changes     MI   227
macro:(summpdifa:,QX(STARS1+43))#      Acentric phase differences,      MI   228
#                                         Most probable.                MI   229
macro:(summpdifc:,QX(STARS1+41))#      Number of centric phase          MI   230
#                                         Changes, most probable.       MI   231
macro:(sumnuma:,QX(STARS1+34))#        Number of acentric reflectio     MI   232
#                                         With phases from last cycle.  MI   233
macro:(sumnumbma:,QX(STARS1+38))#      Number of acentric reflectio     MI   234
#                                         This cycle.                   MI   235
macro:(sumnumbmc:,QX(STARS1+36))#      Number of centric reflection     MI   236
#                                         This cycle.                   MI   237
macro:(sumnumc:,QX(STARS1+32))#        Number of centric reflection     MI   238
#                                         With phases from last cycle.  MI   239
macro:(sumnummpa:,QX(STARS1+42))#      Number of acentric reflectio     MI   240
#                                         With phases from last cycle,  MI   241
#                                         Most probable.                MI   242
macro:(sumnummpc:,QX(STARS1+40))#      Number of centric reflection     MI   243
#                                         With phases from last cycle,  MI   244
#                                         Most probable.                MI   245
endext:#                                                                MI   246
#                                                                       MI   247
########### MACRO SET 6                                                 MI   248
extrude:(MIMAC6)#                                                       MI   249
# BLOCK 3 STATISTICAL TYPES                                             MI   250
# THESE MACROS ARE USED BY PROGRAMS MI63, MI78, MI80 AND MI85           MI   251
#                                                                       MI   252
macro:(delisoc:,QX($1+9))#             R cullis denominator             MI   253
macro:(sumalfdel:,QX($1+4))#           Difference between protein a     MI   254
#                                         Heavy atom phase.             MI   255
macro:(sumalfdela:,QX($1+20))#         Acentric difference between      MI   256
#                                         Protein and heavy atom phase. MI   257
macro:(sumalfdelc:,QX($1+13))#         Centric difference between       MI   258
#                                         Protein and heavy atom phase. MI   259
macro:(sumall:,QX($1+3))#              Number of reflections by         MI   260
#                                         Isomorph by sitol.            MI   261
macro:(sumalla:,QX($1+19))#            Acentric number of reflectio     MI   262
#                                         By isomorph by stol.          MI   263
macro:(sumallc:,QX($1+12))#            Centric number of reflection     MI   264
#                                         By isomorph by stol.          MI   265
macro:(sumdfa:,QX($1+17))#             Acentric r kraut numerator       MI   266
macro:(sumdfc:,QX($1+10))#             Centric r kraut numerator        MI   267
macro:(sumfazpwra:,QX($1+21))#         Acentric closure error           MI   268
macro:(sumfazpwrc:,QX($1+14))#         Centric closure error            MI   269
macro:(sumfha:,QX($1+22))#             Acentric heavy atom              MI   270
#                                         Contribution.                 MI   271
macro:(sumfhc:,QX($1+15))#             Centric heavy atom               MI   272
#                                         Contribution.                 MI   273
macro:(sumfpha:,QX($1+18))#            Acentric r kraut denominator     MI   274
macro:(sumfphc:,QX($1+11))#            Centric r kraut denominator      MI   275
macro:(sumwteano:,QX($1+24))#          Weighted, squared anomalous      MI   276
#                                         Closure error.                MI   277
macro:(sumwteiso:,QX($1+7))#           Weighted squared closure err     MI   278
macro:(sumwteisoa:,QX($1+23))#         Acentric weighted, squared       MI   279
#                                         Closure error.                MI   280
macro:(sumwteisoc:,QX($1+16))#         Centric weighted, squared        MI   281
#                                         Closure error.                MI   282
endext:#                                                                MI   283
#                                                                       MI   284
############ MACRO SET 7                                                MI   285
extrude:(MIMAC7)#                                                       MI   286
# BLOCK 5 STATISTICAL TYPES                                             MI   287
# THESE MACROS ARE USED BY PROGRAMS MI64, MI75, MI78, MI80 AND MI85.    MI   288
#                                                                       MI   289
macro:(sumadjclo:,QX($1+3))#           Closure adjusted for             MI   290
#                                         Observational errors.         MI   291
macro:(sumadjcloa:,QX($1+13))#         Acentric closure adjusted fo     MI   292
#                                         Observational errors.         MI   293
macro:(sumadjcloc:,QX($1+8))#          Centric closure adjusted for     MI   294
#                                         Observational errors.         MI   295
macro:(sumclosure:,QX($1+1))#          Closure on fph**2                MI   296
macro:(sumclosurea:,QX($1+11))#        Acentric closure on fph**2       MI   297
macro:(sumclosurec:,QX($1+6))#         Centric closure on fph**2        MI   298
macro:(sumdf:,QX($1+1))#               R kraut numerator                MI   299
macro:(sumdifiso:,QX($1+2))#           Isomorphous differences on       MI   300
#                                         F**2.                         MI   301
macro:(sumdifisoa:,QX($1+12))#         Acentric isomorphous             MI   302
#                                         Differences on f**2.          MI   303
macro:(sumdifisoc:,QX($1+7))#          Centric isomorphous differen     MI   304
#                                         On f**2.                      MI   305
macro:(sumfazpwr:,QX($1+5))#           Closure error                    MI   306
macro:(sumfhsq:,QX($1+4))#             Heavy atom model contributio     MI   307
macro:(sumfhsqa:,QX($1+14))#           Acentric heavy atom model        MI   308
#                                        Contribution.                  MI   309
macro:(sumfhsqc:,QX($1+9))#            Centric heavy atom model         MI   310
#                                         Contribution.                 MI   311
macro:(sumjntvar:,QX($1+5))#           Joint variance of parent         MI   312
#                                         And isomorph.                 MI   313
macro:(sumjntvara:,QX($1+15))#         Acentric joint variance of       MI   314
#                                         Parent and isomorph.          MI   315
macro:(sumjntvarc:,QX($1+10))#         Centric joint variance of        MI   316
#                                         Parent and isomorph.          MI   317
endext:#                                                                MI   318
#                                                                       MI   319
############ MACRO SET 8                                                MI   320
extrude:(MIMAC8)#                                                       MI   321
# BLOCK 2 STATISTICAL TYPES                                             MI   322
# THESE MACROS ARE USED BY PROGRAMS MI63, MI75, MI77 AND MI79           MI   323
#                                                                       MI   324
macro:(sumfom:,QX($1+1))#              Figure of merit by stol          MI   325
macro:(sumfoma:,QX($1+5))#             Acentric figure of merit by      MI   326
#                                         Stol.                         MI   327
macro:(sumfomc:,QX($1+3))#             Centric figure of merit by       MI   328
#                                         Stol.                         MI   329
macro:(sumnatwteano:,QX($1+7))#        Weighted, squared anomalous      MI   330
macro:(sumref:,QX($1+2))#              Number of reflections by sto     MI   331
macro:(sumrefa:,QX($1+6))#             Acentric number of reflectio     MI   332
#                                         By stol.                      MI   333
macro:(sumrefc:,QX($1+4))#             Centric number of reflection     MI   334
#                                         Closure error.                MI   335
endext:#                                                                MI   336
#                                                                       MI   337
########### MACRO SET 9                                                 MI   338
extrude:(MIMAC9)#                                                       MI   339
# DOUBLE PRECISION MACROS                                               MI   340
# THESE MACROS WERE USED BY PROGRAMS MI73, MI91, MI92, MI93, MI94,      MI   341
#  MI95, MI96, MI97, MI98 AND MI99 IN THE ORIGINAL VERSION OF MIR.      MI   342
#  THEY WERE ALL REPLACED BY THE CEDAR PROGRAMS CD91, CD97, & CD98      MI   343
#  AS OF 30 JAN 1990 AS THE "NEW" MI91, MI97, & MI98.                   MI   344
#  THE MACROS ARE RETAINED IN CASE NEEDED IN THE FUTURE.                MI   345
#                                                                       MI   346
ifsel:(CRAY,UNXCRA)#                                                    MI   347
macro:(doubleprecision:,[no:])#                                         MI   348
ifsel:#                                                                 MI   349
macro:(doubleprecision:,[no:])#                                         Aug93001
endsel:#                                                                MI   351
#                                                                       MI   352
macro:(double:,[ifelse:(doubleprecision:,yes:,DOUBLE PRECISION,REAL)])# MI   353
#                                                                       MI   354
macro:(dfunction:,[ifelse:(doubleprecision:,yes:,$#                     MI   355
DOUBLEPRECISIONFUNCTION,FUNCTION)])#                                    MI   356
macro:(dabs:,[ifelse:(doubleprecision:,yes:,DABS($1),ABS($1))])#        MI   357
#                                                                       MI   358
macro:(dble:,[ifelse:(doubleprecision:,yes:,DBLE($1),$1)])#             MI   359
#                                                                       MI   360
macro:(dconstant:,[ifelse:(doubleprecision:,yes:,$1D$2,$1E$2)])#        MI   361
#                                                                       MI   362
macro:(dfloat:,[ifelse:(doubleprecision:,yes:,DFLOAT($1),FLOAT($1))])#  MI   363
#                                                                       MI   364
macro:(dptos:,[ifelse:(doubleprecision:,yes:,SNGL($1),$1)])#            MI   365
#                                                                       MI   366
macro:(dsign:,[ifelse:(doubleprecision:,yes:,DSIGN($1,$2),$#            MI   367
SIGN($1,$2))])#                                                         MI   368
#                                                                       MI   369
macro:(dsqrt:,[ifelse:(doubleprecision:,yes:,DSQRT($1),SQRT($1))])#     MI   370
#                                                                       MI   371
# LENGTH OF A MATRIX WORD-2 FOR DOUBLE PRECISION, 1 FOR SINGLE          MI   372
macro:(lmtxword:,[ifelse:(doubleprecision:,yes:,2,1)])#                 MI   373
#                                                                       MI   374
#  ***** NOTE WELL THAT MACHEP: IS A MACHINE DEPENDENT PARAMETER*****   MI   375
# RELATIVE PRECISION OF DOUBLE PRECISION FLOATING POINT ARITHMETIC      MI   376
macro:(machep:,[ifelse:(doubleprecision:,yes:,$#                        MI   377
dconstant:(2.0,-18),MNFPNBR)])#                                         MI   378
endext:#                                                                MI   379
#                                                                       MI   380
extrude:(MICOMN)#                                                       MI   381
INTEGER ACNREJ#                        Newton, low centroid rejecti     MI   382
#                                         Counter, acentric reflections MI   383
INTEGER ATMPTR(incr:(maxsets:))#       Pointers for 1st atom packed     MI   384
#                                         For each data set.            MI   385
INTEGER ATSET(maxatoms:)#              Indicates to which data set      MI   386
#                                         Each atom belongs.            MI   387
INTEGER BADDET#                        Newton, count reflection wit     MI   388
#                                         Bad hessian (non-positive     MI   389
#                                         Definite.                     MI   390
INTEGER BDFSEQ(maxsets:)#              Indicates the order in which     MI   391
#                                         Data sets on the bdf are      MI   392
#                                         Too be used.                  MI   393
INTEGER CANTPH#                        Number of unphaseable refls.     MI   394
INTEGER CNTREJ#                        Newton, low centroid rejecti     MI   395
#                                         Count, centric reflections.   MI   396
INTEGER DELFF#                         Sine(theta)/lambda step size     MI   397
#                                         For scattering factors.       MI   398
INTEGER DRVPTA(incr:(maxsets:))#       Real partial derivative          MI   399
#                                         Pointers by data sets.        MI   400
INTEGER DRVPTB(incr:(maxsets:))#       Imaginary partial derivative     MI   401
#                                         Pointers by data sets.        MI   402
INTEGER FAZFM1#                        Bdf item for init fig of merit   MI   403
INTEGER FAZA1#                         Bdf item for init cos(phase)     MI   404
INTEGER FAZB1#                         Bdf item for init cos(phase)     MI   405
INTEGER FAZPT1#                        Point to location on file c      MI   406
INTEGER FAZFM2#                        Bdf item for combining fig.mer   MI   407
INTEGER FAZA2#                         Bdf item for comb cos(phase)     MI   408
INTEGER FAZB2#                         Bdf item for comb cos(phase)     MI   409
INTEGER FAZPT2#                        Point to location on file c      MI   410
#                                                                       MI   411
INTEGER FAZTYP#                        Phasing method, none: (-1),      MI   412
#                                         Mvfc: (2), or fazprb: (3).    MI   413
INTEGER FIXORG#                        Yes:, to fix origin in a         MI   414
#                                         Polar space group.            MI   415
INTEGER ICTREF#                        Internal reflection counter      MI   416
INTEGER ICYC#                          Current cycle number             MI   417
INTEGER IFBIN#                         F**2 bin                         MI   418
INTEGER IFPROB#                        Controls choice of phase         MI   419
INTEGER ILIST#                         Controls output of refls.        MI   420
INTEGER INFORM#                        Control amount of refl. info     MI   421
#                                         Which is printed.             MI   422
INTEGER IOUTF#                         Output bdf switch                MI   423
INTEGER IPLOT#                         Signals number of plots          MI   424
INTEGER IPRC#                          Phase restriction code as 0-     MI   425
INTEGER IPUNCH#                        Controls writing to punch fi     MI   426
INTEGER ISBIN#                         Sine(theta)/lambda bin           MI   427
INTEGER LSTCYC#                        Final cycle number               MI   428
INTEGER MTXPTR(incr:(maxsets:))#       Start of least squares matri     MI   429
#                                         For each data set.            MI   430
INTEGER NADJPH#                        Newton, count of refls. with     MI   431
#                                         Adjusted phases.              MI   432
INTEGER NAT#                           Number of atoms on bdf           MI   433
INTEGER NATIN#                         Number of atoms input            MI   434
INTEGER NATTYP#                        No. of different atom types      MI   435
INTEGER NBIN#                          Number of statistics bins        MI   436
#                                         For sine(theta)/lambda.       MI   437
INTEGER NCBIN#                         Control number of bins for       MI   438
#                                         Centricity on output.         MI   439
INTEGER NCYC#                          Total number of cycles to        MI   440
#                                         To be done.                   MI   441
INTEGER NDAT#                          Number of data sets on bdf       MI   442
INTEGER NDATIN#                        Number of data sets input        MI   443
INTEGER NEWTON#                        Yes: for newton phase adjust     MI   444
INTEGER NFBIN#                         Number of statistics bins        MI   445
#                                         For f**2.                     MI   446
INTEGER NOMIN#                         Newton, count refls. with        MI   447
#                                         Min. error>cutoff.            MI   448
INTEGER NPAREF(maxsets:)#              Number of atoms parameters       MI   449
#                                         Refined per data set.         MI   450
INTEGER NREF(maxsets:)#                Numbers of reflections used      MI   451
#                                         Per data set.                 MI   452
INTEGER NROT#                          Number of unique equivalence     MI   453
#                                         For the current reflection.   MI   454
INTEGER NRMZ#                          Number of symmetry rotation      MI   455
#                                         Matrices with same pattern    MI   456
#                                         Of zeroes.                    MI   457
INTEGER NUMAT(maxsets:)#               Number of atoms per data set     MI   458
INTEGER NUMPLT(10)#                    Number of plots                  MI   459
INTEGER NUMVPH#                        Set to yes: if new phases        MI   460
#                                         (alternate phases) required   MI   461
#                                         With the mvfc method.         MI   462
INTEGER OPSIZ#                         Output packed size integer       MI   463
#                                        For logical record lrrefl:.    MI   464
INTEGER PHSINC#                        Delta alpha stepping value       MI   465
#                                         In degrees.                   MI   466
INTEGER REFPTR(incr:(maxsets:))#       Pointers to atoms to be          MI   467
#                                         Refined.                      MI   468
INTEGER REFTYP#                        Refinement method none: (-1)     MI   469
#                                         Block diagonal (4), full      MI   470
#                                         Matrix (5).                   MI   471
INTEGER SEQAT(maxatoms:)#              Points to atoms in bdf           MI   472
#                                         To be used.                   MI   473
INTEGER SEQDAT(maxsets:)#              Points to data sets to be        MI   474
#                                         Used.                         MI   475
#                                                                       MI   476
INTEGER STARAN,STEPAN,STOPAN#          Atom names as 8-char. string     MI   477
INTEGER STARAT,STEPAT,STOPAT#          Atom parameters as x,y,z         MI   478
INTEGER STARCR,STEPCR,STOPCR#          Crystal data list                MI   479
INTEGER STARDN,STEPDN,STOPDN#          Data set names as character      MI   480
#                                         Strings.                      MI   481
INTEGER STAREF,STEPEF,STOPEF#          Atom list refinement flags       MI   482
INTEGER STAREM,STEPEM,STOPEM#          Maximum normalized structure     MI   483
#                                         Amplitudes; average f**2.     MI   484
INTEGER STARFA,STEPFA,STOPFA#          Phase probabilities              MI   485
INTEGER STARFF,STEPFF,STOPFF#          Form factors                     MI   486
INTEGER STARFI,STEPFI,STOPFI#          Interpolated scatt. factors      MI   487
INTEGER STARH,STEPH,STOPH#             H,k,l and epsilon list           MI   488
INTEGER STARKB,STEPKB,STOPKB#          Scale, delta b, circle error     MI   489
INTEGER STARMT,STEPMT,STOPMT#          Matrix                           MI   490
INTEGER STARPD,STEPPD,STOPPD#          Partial derivatives              MI   491
INTEGER STARPR,STEPPR,STOPPR#          Probability distribution tab     MI   492
INTEGER STARRO,STEPRO,STOPRO#          Actual lrrefl: output idnums     MI   493
INTEGER STARSC,STEPSC,STOPSC#          Sin/cos tables                   MI   494
INTEGER STARST,STEPST,STOPST#          Limit statistical output         MI   495
INTEGER STARSY,STEPSY,STOPSY#          Symmetry operations              MI   496
INTEGER STARS1,STEPS1,STOPS1#          Statistical block one            MI   497
INTEGER STARS2,STEPS2,STOPS2#          Statistical block two            MI   498
INTEGER STARS3,STEPS3,STOPS3#          Statistical block three          MI   499
INTEGER STARS4,STEPS4,STOPS4#          Statistical block four           MI   500
INTEGER STARS5,STEPS5,STOPS5#          Statistical block five           MI   501
INTEGER STARS6,STEPS6,STOPS6#          Statistical block six            MI   502
#                                                                       MI   503
COMMON/COMIM1/ $#                                                       MI   504
ACNREJ,ATMPTR,ATSET ,BADDET,BDFSEQ,CANTPH,CNTREJ, DELFF, $#             MI   505
DRVPTA,DRVPTB,FAZFM1,FAZA1,FAZB1,FAZFM2,FAZA2,FAZB2,FAZPT1,FAZPT2, $#   MI   506
FAZTYP,FIXORG,$#                                                        MI   507
ICTREF,ICYC  ,IFBIN ,IFPROB,ILIST ,INFORM,IOUTF ,IPLOT ,IPRC  ,$#       MI   508
IPUNCH,ISBIN ,LSTCYC,MTXPTR,NADJPH,NAT   ,NATIN ,NATTYP,NBIN  ,$#       MI   509
NCBIN ,NCYC  ,NDAT  ,NDATIN,NEWTON,NFBIN ,NOMIN,NPAREF,NREF  ,NROT  ,$# MI   510
NRMZ  ,NUMAT ,NUMPLT,NUMVPH,OPSIZ ,PHSINC,REFPTR,REFTYP,SEQAT# Mi       MI   511
COMMON/COMIM2/ $#                                                       MI   512
SEQDAT,STARAN,STARAT,STARCR,STARDN,STAREF,STAREM,$#                     MI   513
STARFA,STARFF,STARFI,STARH ,STARKB,STARMT,$#                            MI   514
STARPD,STARPR,STARRO,STARSC,STARST,STARSY,$#                            MI   515
STARS1,STARS2,STARS3,STARS4,STARS5,STARS6,$#                            MI   516
STEPAN,STEPAT,STEPCR,STEPDN,STEPEF,STEPEM,$#                            MI   517
STEPFA,STEPFF,STEPFI,STEPH ,STEPKB,STEPMT# Mi                           MI   518
COMMON/COMIM3/ $#                                                       MI   519
STEPPD,STEPPR,STEPRO,STEPSC,STEPST,STEPSY,$#                            MI   520
STEPS1,STEPS2,STEPS3,STEPS4,STEPS5,STEPS6,$#                            MI   521
STOPAN,STOPAT,STOPCR,STOPDN,STOPEF,STOPEM,$#                            MI   522
STOPFA,STOPFF,STOPFI,STOPH ,STOPKB,STOPMT,$#                            MI   523
STOPPD,STOPPR,STOPRO,STOPSC,STOPST,STOPSY,$#                            MI   524
STOPS1,STOPS2,STOPS3,STOPS4,STOPS5,STOPS6#                              MI   525
#                                                                       MI   526
REAL BIMODL#                           Largest difference in degree     MI   527
#                                         For accepting bimodal sir     MI   528
#                                         Solution.                     MI   529
REAL CUTACN#                           Newton, centroid cutoff for      MI   530
#                                         Acentric reflections.         MI   531
REAL CUTCNT#                           Newton, centroid cutoff for      MI   532
#                                         Centric reflections.          MI   533
REAL DEGRAD#                           Number of degrees in 1 radia     MI   534
REAL EMIN#                             Newton, error cutoff, do not     MI   535
#                                         Use refls. with e>emin.       MI   536
REAL FAZDA1(maxsets:)#                 Data type for phase              MI   537
#                                         Determination.                MI   538
REAL FAZDA2(maxsets:)#                 Data type for phase refineme     MI   539
REAL GAP#                              Distance in sine**2(theta)/      MI   540
#                                         Lambda**2.                    MI   541
REAL GOFPRV#                           Goodness of fit from the         MI   542
#                                         Previous cycle.               MI   543
REAL PHSHFT#                           Shift factor for refinement      MI   544
#                                         Phases around phase circle.   MI   545
REAL PI#                               Value of pi in radians           MI   546
REAL PLTHKL(10)#                       Packed integers of first hkl     MI   547
#                                         Of a group of reflections to  MI   548
#                                         Plotted.                      MI   549
REAL REFCUT#                           Criterion for successful         MI   550
#                                         Phase refinement.             MI   551
REAL SIGCUT#                           Criterion for phasing with       MI   552
#                                         Weak reflections.             MI   553
REAL STAB(maxsets:)#                   Instability factor for           MI   554
#                                         Creating variances when none  MI   555
#                                         Exist on the bdf.             MI   556
REAL STOLMN(maxsets:)#                 Minimum sine(theta)/lambda f     MI   557
#                                         Each data set.                MI   558
REAL STOLMX(maxsets:)#                 Maximum sine(theta)/lambda f     MI   559
#                                         Each data set.                MI   560
REAL TFCON(6)#                         Convert uij to betaij            MI   561
REAL TWOPI#                            Value of 2.*pi radians           MI   562
REAL VOLUME#                           Unit cell volume                 MI   563
REAL WTDFSQ(maxsets:)#                 Weighted delta f square          MI   564
#                                         For least squares.            MI   565
#                                                                       MI   566
COMMON/COMFMI/ $#                                                       MI   567
BIMODL,DEGRAD,CUTACN,CUTCNT,EMIN  ,FAZDA1,FAZDA2,GAP   ,GOFPRV, $#      MI   568
PI    ,PHSHFT,PLTHKL,TFCON,#                                            MI   569
REFCUT,SIGCUT,STAB  ,STOLMX,STOLMN,TWOPI ,VOLUME,WTDFSQ#                MI   570
endext:#                                                                MI   571
#                                                                       MI   572
systemheader:(MI00)#                                                    MI00   1
# ################################################################## #  MI00   2
#                                                                    #  MI00   3
#                               MI00                                 #  MI00   4
#                                                                    #  MI00   5
# ################################################################## #  MI00   6
SUBROUTINE MI00#                       Replacement code driver          MI00   7
#                                                                       MI00   8
include:(MIMAC0)#                                                       MI00   9
include:(AACOMN)#                                                       MI00  10
include:(MICOMN)#                                                       MI00  11
INTEGER I#                                                              MI00  12
#                                                                       MI00  13
CALL MI01#                             Program initialization           MI00  14
CALL MI05#                             Set defaults; read input         MI00  15
CALL MI25#                             Print out input                  MI00  16
CALL MI30#                             Prepare scratch file and         MI00  17
#                                      Set up statistics bins.          MI00  18
DO I = 1,NCYC#                         Start refining                   MI00  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI00  20
CALL MI38#                             Start cycle                      MI00  21
CALL MI40#                             Process reflections              MI00  22
CALL MI72#                             Process results                  MI00  23
CALL MI75#                             Do statistics                    MI00  24
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI00  25
CALL MI89#                             Write final version of bdf       MI00  26
#                                                                       MI00  27
RETURN#                                                                 MI00  28
END#                                                                    MI00  29
systemheader:(MI01)#                                                    MI01   1
# ################################################################## #  MI01   2
#                                                                    #  MI01   3
#                               MI01                                 #  MI01   4
#                                                                    #  MI01   5
# ################################################################## #  MI01   6
SUBROUTINE MI01#                       November 1979  s.r. hall         MI01   7
#                                                                       MI01   8
include:(AACOMN)#                                                       MI01   9
include:(MICOMN)#                                                       MI01  10
#                                                                       MI01  11
INTEGER I#                             Loop index                       MI01  12
INTEGER IPT#                           Input file packet pointer        MI01  13
INTEGER PSIZE#                         Input/output file packet size    MI01  14
#                                                                       MI01  15
#     ###### ALLOCATE BDF BUFFERS #######                               MI01  16
#                                                                       MI01  17
FILEXT(IOUNIT(3))='XX1'#               Set up for scratch file          MI01  18
IOMARK(1) = QXSTR#                     Start of buffer for file a       MI01  19
IOMARK(2) = IOMARK(1) + bdfbuf:#       Start of buffer for file b       MI01  20
IOMARK(3) = IOMARK(2) + bdfbuf:#       Start of buffer for file c       MI01  21
IOMARK(4) = IOMARK(3) + bdfbuf:#       Set end of bdf buffer3           MI01  22
#                                                                       MI01  23
#     ###### GENERATE SIN/COS TABLES #######                            MI01  24
#                                                                       MI01  25
PI = ABS(ATAN2(0.0,-1.0))#             Get machine precision            MI01  26
#                                         Value of pi.                  MI01  27
TWOPI = 2.0*PI#                        Store for later use              MI01  28
DEGRAD = 180./PI#                      Degrees/radians                  MI01  29
#                                                                       MI01  30
STARSC = IOMARK(4) + 1#                Set start of sin/cos table       MI01  31
STEPSC = 1#                            1 degree increments              MI01  32
STOPSC = STARSC + 450#                 Set end   of sin/cos table       MI01  33
#                                                                       MI01  34
incrqx:(I,STOPSC+1,MI0101)#            Get memory                       MI01  35
#                                                                       MI01  36
DO I=STARSC,STOPSC#                    Loop over 450 degrees in         MI01  37
QX(I) = SIN(FLOAT(I-STARSC)/DEGRAD)#   Calc. & store sine values        MI01  38
#                                                                       MI01  39
#     ###### ALLOCATE PROB. PROFILE TABLES ######                       MI01  40
#                                                                       MI01  41
STARPR = STOPSC + 1#                   Set pointers to beginning and    MI01  42
STEPPR = 1#                            End of probability tables.       MI01  43
STOPPR = STARPR + 363#                                                  MI01  44
#                                                                       MI01  45
STARFA = STOPPR#                       Set pointers to beginning and    MI01  46
STEPFA = 1#                            End of probability scratch       MI01  47
STOPFA = STARFA + 37#                  Area.                            MI01  48
#                                                                       MI01  49
incrqx:(I,STOPFA+1,MI0101)#            Get memory                       MI01  50
#                                                                       MI01  51
#     ###### PROCESS BDF RECORDS 1 - LRSYMM: #######                    MI01  52
#                                                                       MI01  53
copyfile:(1,3,1,1)#                    Copy history record              MI01  54
DO I=1,6#                              Loop over six packets            MI01  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI01  56
readwpkt:(1,lrcell:,PSIZE,IPT,0)#      Read crystal data record         MI01  57
IF(I==3)#                              Reciprocal cell constants        MI01  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI01  59
TFCON(1)=0.5*TWOPI**2*QX(IPT+1)**2#    4*pi**2*a(*)*a(*)                MI01  60
TFCON(2)=0.5*TWOPI**2*QX(IPT+2)**2#    4*pi**2*b(*)*b(*)                MI01  61
TFCON(3)=0.5*TWOPI**2*QX(IPT+3)**2#    4*pi**2*c(*)*c(*)                MI01  62
TFCON(4)=TWOPI**2*QX(IPT+1)*QX(IPT+2)# 2*pi**2*a(*)*b(*)                MI01  63
TFCON(5)=TWOPI**2*QX(IPT+1)*QX(IPT+3)# 2*pi**2*a(*)*c(*)                MI01  64
TFCON(6)=TWOPI**2*QX(IPT+2)*QX(IPT+3)# 2*pi**2*b(*)*c(*)                MI01  65
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI01  66
ELSE IF(I==6)#                         From last packet                 MI01  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI01  68
VOLUME = QX(IPT+1)#                    Extract crystal volume           MI01  69
ICYC = NINT(QX(IPT+3))#                Default initial cycle number     MI01  70
GOFPRV = QX(IPT+5)#                    Previous reduced chi**2          MI01  71
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI01  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI01  73
#                                                                       MI01  74
readwpkt:(1,lrsymm:,PSIZE,IPT,0)#      Read symmetry record             MI01  75
NROT = NINT(QX(IPT+4))#                Get max. number of symops        MI01  76
NRMZ = NINT(QX(IPT+5))#                Get number of rotation           MI01  77
#                                         Matrices with same zeroes.    MI01  78
STARSY = STOPFA#                       Mark start of symops             MI01  79
STEPSY = PSIZE#                        And set step size.               MI01  80
incrqx:(STOPSY,STARSY+NROT*STEPSY,MI0101)# Get storage needed           MI01  81
STOPSY = STARSY#                       Reset end of symops              MI01  82
#                                                                       MI01  83
REPEAT#                                Loop over all pkts. of lrsymm:   MI01  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI01  85
readwpkt:(1,lrsymm:,PSIZE,IP,0)#       Read the next packet             MI01  86
IF(IP <= 0)  BREAK#                    Stop, if it's the last one       MI01  87
movereal:(QX,IP+1,QX,STOPSY+1,PSIZE,1)# Move the symop to storage       MI01  88
STOPSY = STOPSY + PSIZE#               Advance ptr. to end of symops    MI01  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI01  90
#                                                                       MI01  91
#    ##### PROCESS SCATTERING FACTORS ######                            MI01  92
#                                                                       MI01  93
STARFF = STOPSY#                       Set start of form fac. tables    MI01  94
CALL MI03#                             Extract form fact. bdf tables    MI01  95
#                                                                       MI01  96
RETURN#                                                                 MI01  97
END#                                                                    MI01  98
systemheader:(MI03)#                                                    MI03   1
# ################################################################## #  MI03   2
#                                                                    #  MI03   3
#                               MI03                                 #  MI03   4
#                                                                    #  MI03   5
# ################################################################## #  MI03   6
SUBROUTINE MI03#                       Subroutine to load the           MI03   7
#                                         Structure factor tables.      MI03   8
#                                        Nov 1979  j.m. stewart         MI03   9
#                                        Revised 1982 r.m doherty and   MI03  10
#                                         R.a. alden                    MI03  11
include:(AACOMN)#                                                       MI03  12
include:(MICOMN)#                                                       MI03  13
#                                                                       MI03  14
# THE SCATTERING FACTORS WILL BE PLACED IN QX STARTING AT STARFF.       MI03  15
#  THE FIRST TWO ENTRIES WILL BE F' AND F'' FOLLOWED BY THE F(J).       MI03  16
#  THE FIRST ENTRY WILL BE FOR SINE(THETA)/LAMBDA OF ZERO.  THE         MI03  17
#  STOL STEP SIZE WILL BE IN THE INTEGER DELFF.  THIS WILL BE 100       MI03  18
#  TIMES THE DELTA(STOL).  THUS 1 CORRESPONDS TO 0.01, THE              MI03  19
#  SMALLEST INTERVAL PROVIDED FOR IN THE BDF.  THE ACTUAL STEP SIZE     MI03  20
#  IS LARGER.                                                           MI03  21
#                                                                       MI03  22
INTEGER COUNT#                         No. of form factors in table     MI03  23
INTEGER FFPTR#                         Pointer into form factor table   MI03  24
INTEGER FIPTR#                         Pointer into interpolated        MI03  25
#                                         Form factor table.            MI03  26
INTEGER I#                             Do loop index                    MI03  27
INTEGER IPT#                           Input file packet pointer        MI03  28
INTEGER IPTR#                          Pointer to a particular value    MI03  29
#                                         In the input bdf buffer.      MI03  30
INTEGER J#                             Loop index                       MI03  31
INTEGER PSIZE#                         Input/output file packet size    MI03  32
REAL CLUE(2)#                          First 2 values of sitol*100      MI03  33
#                                         In the scat. fact. tables.    MI03  34
REAL GOT(4)#                           Flags indicating whether         MI03  35
#                                         Required lrscat: idnums are   MI03  36
#                                         Present.                      MI03  37
realdata:(WANT,[21.,61.])#             Lrscat: identifiers for real     MI03  38
#                                         And imaginary dispersion      MI03  39
datastuff:#                                                             MI03  40
#                                                                       MI03  41
NATTYP = 0#                            Set up to count all              MI03  42
#                                         Scattering factor types.      MI03  43
readwpkt:(1,lrscat:,PSIZE,IPT,0)#      Read directory                   MI03  44
DO I=1,4;  GOT(I)=0.#                                                   MI03  45
#                                                                       MI03  46
# SCAN THE DIRECTORY PACKET LOOKING FOR TABLES                          MI03  47
#                                                                       MI03  48
STEPFF = 0#                                                             MI03  49
COUNT = 0#                                                              MI03  50
DO J=1,202#                            Loop over indices                MI03  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI03  52
IPTR = IPT#                            Idnums can go as high as 299     MI03  53
DO I = 1,PSIZE#                        Loop over input header packet    MI03  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI03  55
IPTR = IPTR + 1#                       Increment buffer pointer         MI03  56
IF((J < 3) & (ABS(QX(IPTR)-WANT(J)) < 0.01))# Find the dispersion       MI03  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI03  58
GOT(J) = FLOAT(I)#                     Factor indices.                  MI03  59
STEPFF = STEPFF + 1#                   Count the entries per            MI03  60
BREAK#                                 Atom type.                       MI03  61
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI03  62
#                                                                       MI03  63
ELSE  IF((J > 2) & (ABS(QX(IPTR)-FLOAT(J+97)) < 0.01))#                 MI03  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI03  65
STEPFF = STEPFF + 1#                   Find scattering factor table     MI03  66
COUNT = COUNT + 1#                                                      MI03  67
IF(COUNT > 2)  BREAK#                  You only have to know the        MI03  68
GOT(COUNT+2) = FLOAT(I)#               First to know them all.          MI03  69
CLUE(COUNT) = QX(IPTR)#                                                 MI03  70
BREAK#                                                                  MI03  71
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI03  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI03  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI03  74
DELFF = NINT(ABS(CLUE(2) - CLUE(1)))#  Find the table step size         MI03  75
#                                         In units of stol*100.         MI03  76
#                                                                       MI03  77
# SET UP QX DATA ARRAYS FOR SCATTERING FACTORS                          MI03  78
#                                                                       MI03  79
STOPFF = 16*STEPFF + STARFF#           Calc. max. required storage      MI03  80
STARFI = STOPFF#                                                        MI03  81
STEPFI = 2#                                                             MI03  82
STOPFI = STEPFI*16 + STARFI#                                            MI03  83
incrqx:(I,STOPFI+1,MI0302)#            Get memory                       MI03  84
#                                                                       MI03  85
# NOW CHECK TO BE SURE THERE ARE SCATTERING FACTORS AND                 MI03  86
#  DISPERSION CORRECTIONS IN THE BDF.                                   MI03  87
#                                                                       MI03  88
IF((GOT(1)*GOT(2)*GOT(3)*GOT(4)) <= 0.01)  iquit:(-MI0303)#             MI03  89
#                                                                       MI03  90
# NOW LOAD THE TABLES IN PACKED FORM, DISPERSION CORRECTIONS FIRST,     MI03  91
#  STARTING AT STARFF.                                                  MI03  92
#                                                                       MI03  93
FFPTR = STARFF#                                                         MI03  94
FIPTR = STARFI#                                                         MI03  95
#                                                                       MI03  96
REPEAT#                                Loop over all atom types         MI03  97
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI03  98
readwpkt:(1,lrscat:,PSIZE,IPT,0)#                                       MI03  99
IF(IPT <= 0)  BREAK#                   Get out at end                   MI03 100
NATTYP = NATTYP + 1#                   Count up atom types              MI03 101
IPTR = IPT + NINT(GOT(1))#                                              MI03 102
FFPTR = FFPTR + 2#                                                      MI03 103
FIPTR = FIPTR + 2#                                                      MI03 104
QX(FFPTR-1) = QX(IPTR)#                Move dispersion correction,      MI03 105
QX(FIPTR-1) = QX(IPTR)#                Real part                        MI03 106
IPTR = IPT + NINT(GOT(2))#                                              MI03 107
QX(FIPTR) = QX(IPTR)#                  And                              MI03 108
QX(FFPTR) = QX(IPTR)#                  Imaginary part.                  MI03 109
#                                                                       MI03 110
IPTR = IPT + NINT(GOT(3))#             Start loop index                 MI03 111
FOR(J=3; J <= STEPFF; J=J+1)#                                           MI03 112
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI03 113
FFPTR = FFPTR + 1#                                                      MI03 114
QX(FFPTR) = QX(IPTR)#                  Move scattering factor value     MI03 115
IPTR = IPTR + 1#                                                        MI03 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI03 117
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI03 118
#                                                                       MI03 119
IF(NATTYP == 0)  iquit:(MI0301)#                                        MI03 120
IF(QUITF(1^1)!=' ') iquit:(MI0304)#                                     MI03 121
#                                                                       MI03 122
STOPFF = NATTYP*STEPFF + STARFF#       Reset end of form fact. array    MI03 123
FIPTR = STARFI#                        Now we're going to move the      MI03 124
STARFI = STOPFF#                       Interpolated form factor         MI03 125
COUNT = NATTYP*STEPFI#                 Tables down to the end of the    MI03 126
STOPFI = COUNT + STARFI#               Form factor tables.              MI03 127
movereal:(QX,FIPTR+1,QX,STARFI+1,COUNT,1)#                              MI03 128
#                                                                       MI03 129
IF(QXMAX < STOPFI+1)  iquit:(MI0302)#                                   MI03 130
qxmemory:(STOPFI+1)#                                                    MI03 131
#                                                                       MI03 132
RETURN#                                                                 MI03 133
END#                                                                    MI03 134
systemheader:(MI05)#                                                    MI05   1
# ################################################################## #  MI05   2
#                                                                    #  MI05   3
#                               MI05                                 #  MI05   4
#                                                                    #  MI05   5
# ################################################################## #  MI05   6
SUBROUTINE MI05#                       3 sep 1980  k.d. watenpaugh      MI05   7
#                                                                       MI05   8
# REPLACES PREVIOUS VERSION BY ALDEN, WATENPAUGH, SHERIFF, ET AL.       MI05   9
# USES THE "PROCEDURE" CALL TO HELP MODULARITY AND READABILITY          MI05  10
# MULTIPLE CHANGES BY R.A. ALDEN AND S.T. FREER  NOV 1980 - JAN 1981    MI05  11
# CLOSERROR PROCEDURE RE-WRITTEN BY S. SHERIFF  JAN 1981                MI05  12
# MIR AND DATSET PROCEDURES MODIFIED BY S. SHERIFF FEB 1981             MI05  13
# ATOMSINIT AND ATOMSFINI PROCEDURES MODIFIED TO BE CONSISTENT WITH     MI05  14
#  CURRENT LRATOM: STRUCTURE.  R. M. DOHERTY  APR 1982                  MI05  15
#                                                                       MI05  16
include:(MIMAC1)#                                                       MI05  17
include:(MIMAC2)#                      Procedure macros                 MI05  18
include:(AACOMN)#                                                       MI05  19
include:(MICOMN)#                                                       MI05  20
#                                                                       MI05  21
INTEGER ANPTR#                         Point to atom name in qx         MI05  22
INTEGER ATNOW#                         Index to atoms in bdf            MI05  23
INTEGER CLOPTR#                        Pointer to closure errors        MI05  24
INTEGER DNOW#                          Index to data set names on bdf   MI05  25
INTEGER DSET#                          Current data set number          MI05  26
INTEGER DSPREV#                        Temporary storage of data-set    MI05  27
#                                         Number.                       MI05  28
INTEGER EPTR#                          Pointer to eiso or eano          MI05  29
INTEGER FBINNO#                        F**2 bin number on closure       MI05  30
#                                         Error line.                   MI05  31
INTEGER FIELD#                         Current field on input line      MI05  32
INTEGER FIRST#                         Pointer to first character in    MI05  33
#                                         A string.                     MI05  34
INTEGER I#                             An index                         MI05  35
INTEGER IBNCHK(arith:(24,*,maxsets:))# Check to make sure bins          MI05  36
#                                         Updated.                      MI05  37
INTEGER ICD#                           1 for eiso line, 2 for eano      MI05  38
INTEGER INDX#                          Data set sequence number         MI05  39
INTEGER IPT#                           Input packet pointer             MI05  40
INTEGER IPTR#                          Pointer into input buffer        MI05  41
INTEGER J#                             An index                         MI05  42
INTEGER KPTR#                          Points to k in qx                MI05  43
INTEGER KEY#                           Refinement on/off indicator      MI05  44
INTEGER LAST#                          Points to last character plus    MI05  45
#                                         One in an input field.        MI05  46
INTEGER MATCH#                         Points to string that matches    MI05  47
#                                         Input string.                 MI05  48
INTEGER NAMPTR#                        Pointer to data set name         MI05  49
#                                         In array, datnam.             MI05  50
INTEGER NCHAR#                         Number of characters in data     MI05  51
#                                         Set name.                     MI05  52
INTEGER NEED12(107)#                   Want list for lrdset:            MI05  53
INTEGER NMPTR#                         Points to atom name in atnam     MI05  54
INTEGER NONAME#                        Set to yes: when name missing    MI05  55
#                                         From line input.              MI05  56
INTEGER POINT(108)#                    Offsets to items in lrdset:      MI05  57
INTEGER PSIZE#                         Size of packet                   MI05  58
INTEGER SAVKCD#                        Value of linid on previous eis   MI05  59
#                                         Or eano line.  needed to      MI05  60
#                                         Allow closure errors to       MI05  61
#                                         Appear on 2 or more lines.    MI05  62
INTEGER SIGNAL(4)#                     Signal array for indexpkt:       MI05  63
#                                                                       MI05  64
INTEGER STAT#                          Tells whether stat or nostat     MI05  65
#                                     #  Line read.                     MI05  66
REAL CLOSUR(13)#                       Temporary storage for closure    MI05  67
#                                         Errors.                       MI05  68
string:(ATNAM,arith:(24,*,maxatoms:))# List of atom names               MI05  69
string:(ATOM,24)#                      Holds current atom name          MI05  70
string:(DATNAM,arith:(12,*,maxsets:))# Concatenated list                MI05  71
#                                         Of data set names on the bdf. MI05  72
string:(UPCOMA,12)#                    Comparison of data set names     Aug93002
chardata:(CONTN,C)#                    Continuation flag on closure     MI05  73
#                                         Error lines.                  MI05  74
chardata:(MI051, END    DATSET ATOMS  LIMSET DATSCL REF    NOREF  $#    MI05  75
BINS   FAZIN  MVFC   FAZPRB EISO   EANO   STAT   NOSTAT CYCLE  PLTHKL )#MI05  76
chardata:(MI052,NONE ISOM ANOM BOTH )# Datset line, fields 2 and 3 m    MI05  77
chardata:(MI053, THE INPUT BDF CONTAINS DATA FOR)#                      MI05  78
chardata:(MI054,PARALL)#                                                MI05  79
chardata:(MI055,CLO)#                                                   MI05  80
chardata:(MI057,BLFUND)#               Set refinement, blockd, full     MI05  81
#                                        Matrix, none.                  MI05  82
chardata:(MI058, BRICOGNE METHOD NO IMPLIMENTED, BLOCKED MATRIX WILL $# MI05  83
BE USED)#                                                               MI05  84
realdata:(FMT051,[80223.])#                                             MI05  85
datastuff:#                                                             MI05  86
#                                                                       MI05  87
# ################################################################## #  MI05  88
# DEFINE THE NAMES OF PROCEDURES THAT WILL BE USED IN THIS ROUTINE      MI05  89
#                                                                       MI05  90
defineproc:(SEQNUM)#                   Return local data set order in   MI05  91
#                                         Idat.                         MI05  92
defineproc:(MIR)#                      Finish processing mir line       MI05  93
defineproc:(DATSETINIT)#               Initialize datset information    MI05  94
defineproc:(DATSET)#                   Process datset input line        MI05  95
defineproc:(DATSETFINI)#               Read bdf lrdset: and finish      MI05  96
#                                         Off datset.                   MI05  97
defineproc:(ATOMSINIT)#                Initialize atom information      MI05  98
defineproc:(ATOMS)#                    Process atoms input lines        MI05  99
defineproc:(ATOMSFINI)#                Read bdf lratom: and finish      MI05 100
#                                         Off atom information.         MI05 101
defineproc:(SETDEFAULT)#               Set various statisitic default   MI05 102
#                                         Defaults.                     MI05 103
defineproc:(LIMSET)#                   Process limset input line        MI05 104
defineproc:(DATSCL)#                   Process datscl input line        MI05 105
defineproc:(REFKEY)#                   Process ref and noref input      MI05 106
#                                         Lines.                        MI05 107
defineproc:(BINS)#                     Process bins input line          MI05 108
defineproc:(FAZIN)#                    Process fazin input line         MI05 109
#                                         (dummy).                      MI05 110
defineproc:(MINVFC)#                   Process mvfc input line          MI05 111
defineproc:(PHAZPRB)#                  Process fazprb input line        MI05 112
defineproc:(CLOSERROR)#                Process eiso and eano input      MI05 113
#                                         Lines.                        MI05 114
defineproc:(SETSTATS)#                 Process stats and nostats        MI05 115
#                                         Input lines.                  MI05 116
defineproc:(SETCYCLE)#                 Process cycle input line         MI05 117
defineproc:(PLTHKL)#                   Process plthkl input line        MI05 118
# END OF DEFINING OF PROCEDURE NAMES                                    MI05 119
# ################################################################## #  MI05 120
#                                                                       MI05 121
#   START OF INPUT CONTROL                                              MI05 122
#                                                                       MI05 123
xeq:(MIR)#                             Process fields beyond            MI05 124
#                                         Compound ident on mir line.   MI05 125
#                                                                       MI05 126
xeq:(DATSETINIT)#                      Initialize datasets from lrexp   MI05 127
readline:(MI051,NMI051)#               Read first line of input line    MI05 128
WHILE(LINID == 2)#                     Treat only data set lines        MI05 129
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI05 130
xeq:(DATSET)#                          Process dataset line             MI05 131
readline:(MI051,NMI051)#               Read new line before             MI05 132
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI05 133
xeq:(DATSETFINI)#                      Finished reading datset lines    MI05 134
#                                                                       MI05 135
#                                                                       MI05 136
xeq:(ATOMSINIT)#                       Get lratom: and initialize       MI05 137
WHILE(LINID == 3)#                     Process only atom lines          MI05 138
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI05 139
xeq:(ATOMS)#                           Process atoms lines              MI05 140
readline:(MI051,NMI051)#               Read another line                MI05 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI05 142
xeq:(ATOMSFINI)#                       Process atom data                MI05 143
#                                                                       MI05 144
xeq:(SETDEFAULT)#                      Set defaults                     MI05 145
#                                                                       MI05 146
#       PROCESS REST OF CONTROL LINE INPUT                              MI05 147
#                                                                       MI05 148
WHILE(LINID > 3)#                      Enter loop only for rest of      MI05 149
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI05 150
IF(LINID == 4)         xeq:(LIMSET)#   Input lines.                     MI05 151
ELSE  IF(LINID == 5)   xeq:(DATSCL)#                                    MI05 152
ELSE  IF(LINID == 6)   xeq:(REFKEY)#                                    MI05 153
ELSE  IF(LINID == 7)   xeq:(REFKEY)#                                    MI05 154
ELSE  IF(LINID == 8)   xeq:(BINS)#                                      MI05 155
ELSE  IF(LINID == 9)   xeq:(FAZIN)#                                     MI05 156
ELSE  IF(LINID == 10)  xeq:(MINVFC)#                                    MI05 157
ELSE  IF(LINID == 11)  xeq:(PHAZPRB)#                                   MI05 158
ELSE  IF(LINID == 12)  xeq:(CLOSERROR)#                                 MI05 159
ELSE  IF(LINID == 13)  xeq:(CLOSERROR)#                                 MI05 160
ELSE  IF(LINID == 14)  xeq:(SETSTATS)#                                  MI05 161
ELSE  IF(LINID == 15)  xeq:(SETSTATS)#                                  MI05 162
ELSE  IF(LINID == 16)  xeq:(SETCYCLE)#                                  MI05 163
ELSE  IF(LINID == 17)  xeq:(PLTHKL)#                                    MI05 164
readline:(MI051,NMI051)#               Get new line                     MI05 165
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI05 166
#                                                                       MI05 167
IF(LINID == 2 \  LINID == 3)        iquit:(MI0501)# Line order          MI05 168
IF(LINID == 1)#                        End line - final tests           MI05 169
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI05 170
IF(NDATIN < 2)                      iquit:(-MI0550)# No data sets       MI05 171
IF(NATIN == 0)                      iquit:(-MI0551)# No atoms           MI05 172
IF(FAZTYP ==  none:)                iquit:(-MI0552)# No method          MI05 173
IF(FAZTYP == mvfc: & NUMAT(1) !=0)  iquit:(-MI0553)# No parent atoms    MI05 174
DO I=2,NDATIN; IF(NUMAT(I) == 0)    iquit:(-MI0554)# No atoms in ds     MI05 175
IF(QUITF(1^1)!=' ')                 iquit:(MI0599)# Prior errors        MI05 176
GAP = (STOLMX(1)**3-STOLMN(1)**3)/FLOAT(NBIN)# Size of stol bin         MI05 177
RETURN#                                Checking finished                MI05 178
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI05 179
#                                                                       MI05 180
#   END OF INPUT CONTROL                                                MI05 181
#                                                                       MI05 182
# FOLLOWING ARE PROCEDURES CALLED BY INPUT CONTROL                      MI05 183
#                                                                       MI05 184
#                           ###                                         MI05 185
########################### MIR ####################################### MI05 186
#                           ###                                         MI05 187
#                                                                       MI05 188
procedure:(MIR)#                                                        MI05 189
#                                                                       MI05 190
# EXTRACT INFORMATION FROM MIR LINE                                     MI05 191
#                                                                       MI05 192
# PARAMETER REFINEMENT CONTROL...BLOCK-DIAGONAL MATRICES,               MI05 193
#  A SINGLE FULL MATRIX, OR NO PARAMETER REFINEMENT.                    MI05 194
#                                                                       MI05 195
REFTYP = blockd:#                                                       MI05 196
ifnv:(BUFIN(1))#                                                        MI05 197
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI05 198
stringlim:(1,FIRST,LAST)#                                               MI05 199
compchar:(CHRIN,FIRST,MI057,1,2,2,NMI057,MATCH)#                        MI05 200
IF(MATCH == 0) iquit:(MI0523,1)#                                        MI05 201
IF(MATCH == 2) writeline:(1,MI058,NMI058,3,3)#                          MI05 202
ELSE IF(MATCH == 3) REFTYP = none:#                                     MI05 203
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI05 204
#                                                                       MI05 205
# ILIST -- LIST REFLECTIONS ON LAST CYCLE; ILIST = 0 IS DEFAULT, DO NOT MI05 206
#  LIST; 1 IS LIST EVERY REFLECTION; 2 EVERY OTHER REFLECTION, ETC.;    MI05 207
#  INVOKED AS: IF(MOD(ICTREF,ILIST) == 0) AFTER CHECKING WHETHER        MI05 208
#  ILIST == 0.                                                          MI05 209
#                                                                       MI05 210
ILIST = 0#                                                              MI05 211
IF(BUFIN(2) >= 1.0)  ILIST = NINT(BUFIN(2))#                            MI05 212
#                                                                       MI05 213
#..INFORM -- CONTROLS LISTING.                                          MI05 214
#  0,1  BASIC QUANTITIES                                                MI05 215
#  2  BASIC PLUS EXPANDED LIST FOR PARENT                               MI05 216
#  3  BASIC PLUS EXPANDED LIST FOR PARENT, ALL ISOMORPHS                MI05 217
#                                                                       MI05 218
INFORM = 1#                                                             MI05 219
IF(BUFIN(3) < voidflg:)#                                                MI05 220
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI05 221
stringlim:(3,FIRST,LAST)#                                               MI05 222
compchar:(CHRIN,FIRST,MI054,1,3,3,NMI054,MATCH)#                        MI05 223
INFORM = INFORM + MATCH#                                                MI05 224
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI05 225
#                                                                       MI05 226
# CLOSURE ERROR OUTPUT CONTROL.  IF FIELD 4 OF THE MIR LINE CONTAINS    MI05 227
#  'CLOSURE' (FIRST 3 CHARACTERS ARE ENOUGH), THEN A FILE CONTAINING    MI05 228
#  CLOSURE ERROR INPUT IMAGES WILL BE PRODUCED WHEN THE FAZPRB PHAZING  MI05 229
#  METHOD IS BEING USED.                                                MI05 230
#                                                                       MI05 231
IPUNCH = 0#                            Set punch flag to don't          MI05 232
IF(BUFIN(4) < voidflg:)#                                                MI05 233
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI05 234
stringlim:(4,FIRST,LAST)#                                               MI05 235
compchar:(CHRIN,FIRST,MI055,1,3,3,NMI055,MATCH)#                        MI05 236
IPUNCH = MATCH#                                                         MI05 237
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI05 238
#                                                                       MI05 239
endproc:(MIR)#                                                          MI05 240
#                                                                       MI05 241
#                       ##########                                      MI05 242
####################### DATSETINIT #################################### MI05 243
#                       ##########                                      MI05 244
#                                                                       MI05 245
procedure:(DATSETINIT)#                                                 MI05 246
#                                                                       MI05 247
STARDN = STOPFI#                       Pointer to start of data sets    MI05 248
STOPDN = STARDN#                                                        MI05 249
STEPDN = incr:(arith:(11,/,mxchwd:))#  Max. words to hold 12 chars.     MI05 250
incrqx:(I,STARDN+STEPDN*maxsets:+1,MI0503)#                             MI05 251
#                                                                       MI05 252
NDAT = 0#                              No. of data sets on bdf          MI05 253
NDATIN = 0#                            Counter for number of data       MI05 254
NAMPTR = 1#                            Ptr. to data set name array      MI05 255
DO I=1,maxsets:#                       Initialize some things           MI05 256
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI05 257
SEQDAT(I) = no:#                       Data set sequence numbers        MI05 258
BDFSEQ(I) = no:#                       Order of data sets on bdf        MI05 259
FAZDA1(I) = 0.#                        Refl. control for phasing        MI05 260
FAZDA2(I) = 0.#                        And for refinement.              MI05 261
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI05 262
#                                                                       MI05 263
REPEAT#                                Loop over data set names         MI05 264
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI05 265
readwpkt:(1,lrddef:,PSIZE,IPT,0)#      Get next name                    MI05 266
IF(IPT <=0) BREAK#                                                      MI05 267
IF(NDAT > maxsets:)  iquit:(MI0505)#   Too many data sets               MI05 268
movertoc:(QX(IPT+1),1,DATNAM,NAMPTR,12,0)#                              MI05 269
NDAT = NDAT + 1#                       Increment counter                MI05 270
NAMPTR = NAMPTR + 12#                  And pointer.                     MI05 271
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI05 272
IF(NDAT==0) iquit:(MI0504)#            No data set information          MI05 273
upcase:(DATNAM,DATNAM,NAMPTR)#         Roll names into upper case       Aug93003
writeline:(1,MI053,NMI053,3,3)#        Print data set header            MI05 274
I = 2#                                 Initialize column pointer        MI05 275
FOR(J=1; J < NAMPTR; J=J+12)#          Loop over the 12-char. names     MI05 276
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI05 277
IF((I+14) > prtcmax:)#                 Prepare to print a complete      MI05 278
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI05 279
writeline:(0,0,0,1,3)#                 Line.                            MI05 280
I = 2#                                 Re-initialize column pointer     MI05 281
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI05 282
movechar:(DATNAM,J,CHROT,I,12,0)#      Stuff the name in the output     MI05 283
I = I + 14#                            Increment the column pointer     MI05 284
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI05 285
writeline:(0,0,0,1,3)#                 Print last incomplete line       MI05 286
#                                                                       MI05 287
endproc:(DATSETINIT)#                                                   MI05 288
#                                                                       MI05 289
#                        #########                                      MI05 290
######################## ATOMSINIT #################################### MI05 291
#                        #########                                      MI05 292
#                                                                       MI05 293
procedure:(ATOMSINIT)#                                                  MI05 294
#                                                                       MI05 295
NAT = 0#                               Counter for atoms on bdf         MI05 296
NATIN = 0#                             Counter for number atoms used    MI05 297
DO I=1,maxsets:;  NUMAT(I) = 0#        Data set.                        MI05 298
DO I=1,maxatoms:; SEQAT(I) = 0#        Atoms on the bdf.                MI05 299
DO I=1,maxatoms:; ATSET(I) = 0#                                         MI05 300
#                                                                       MI05 301
CALL MI06#                             Read in and store the atom       MI05 302
#                                         Names and parameters.         MI05 303
#                                                                       MI05 304
ANPTR = STARAN#                        Start of 1st atom name on bdf    MI05 305
NMPTR = 1#                                                              MI05 306
DO I=1,NAT#                            Put all names on the bdf in      MI05 307
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI05 308
movertoc:(QX(ANPTR+1),1,ATNAM,NMPTR,24,0)# One concatenated list.       MI05 309
ANPTR = ANPTR + STEPAT#                Point to next one                MI05 310
NMPTR = NMPTR + 24#                                                     MI05 311
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI05 312
#                                                                       MI05 313
endproc:(ATOMSINIT)#                                                    MI05 314
#                                                                       MI05 315
#                       ######                                          MI05 316
####################### DATSET ######################################## MI05 317
#                       ######                                          MI05 318
#                                                                       MI05 319
procedure:(DATSET)#                    Procedure to treat datset        MI05 320
#                                         Input lines.                  MI05 321
#                                                                       MI05 322
# THE ORDER OF THE DATSET LINES IS SIGNIFICANT.  THE INITIAL DATSET     MI05 323
#  LINE SPECIFIES THE "PARENT" DATA SET.  SUBSEQUENT LINES DETERMINE    MI05 324
#  THE ORDER OF STORAGE AND LISTING FOR THE "ISOMORPHS".  IF NO         MI05 325
#  DATSET LINES APPEAR, THE FIRST DATA SET ON THE BDF IS CONSIDERED     MI05 326
#  TO BE THE "PARENT".                                                  MI05 327
#                                                                       MI05 328
FIELD = 1#                                                              MI05 329
IF(BUFIN(FIELD) >= voidflg:)#                                           MI05 330
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI05 331
iquit:(-MI0508)#                       No data set names on datset      MI05 332
endproc:(DATSET)#                      Input line.                      MI05 333
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI05 334
#                                                                       MI05 335
stringlim:(FIELD,FIRST,LAST)#          Get boundaries of each name      MI05 336
NCHAR = MIN0((LAST-FIRST),12)#                                          MI05 337
#                                                                       MI05 338
# SEE IF REQUESTED DATA SET NAME WAS ON THE BDF                         MI05 339
movechar:(BLANK,1,UPCOMA,1,12,1)#      Blank datset name for test       Aug93004
movechar:(CHRIN,FIRST,UPCOMA,1,NCHAR,0)# Copy from datset line          Aug93005
upcase:(UPCOMA,UPCOMA,12)#             Roll data set name to up case    Aug93006
compchar:(UPCOMA,1,DATNAM,1,12,12,NDAT*12,DNOW)#                        Aug93007
IF(DNOW == no:)#                                                        MI05 341
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI05 342
iquit:(-MI0508)#                       Name is bad                      MI05 343
endproc:(DATSET)#                                                       MI05 344
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI05 345
#                                                                       MI05 346
# SEQDAT(I) IS USED AS FOLLOWS:                                         MI05 347
#  THE INDEX, I, SPECIFIES THE ITH DATA SET ON THE BDF.  THE VALUE      MI05 348
#  OF SEQDAT(I) IS THE REQUEST ORDER FOR THAT DATA SET.  A VALUE OF     MI05 349
#  ZERO MEANS THAT DATA SET WAS NOT REQUESTED.                          MI05 350
#                                                                       MI05 351
IF(SEQDAT(DNOW) != 0)#                 Now check if data set is         MI05 352
#                                         Already in.                   MI05 353
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI05 354
iquit:(-MI0509)#                       It's a duplicate                 MI05 355
endproc:(DATSET)#                                                       MI05 356
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI05 357
#                                                                       MI05 358
NDATIN = NDATIN + 1#                   It's a new one                   MI05 359
IF(NDATIN > maxsets:)#                                                  MI05 360
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MI05 361
iquit:(-MI0505)#                       Too many data sets               MI05 362
endproc:(DATSET)#                                                       MI05 363
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MI05 364
#                                                                       MI05 365
SEQDAT(DNOW) = NDATIN#                 Set sequence number indicating   MI05 366
#                                         That this data set is to be   MI05 367
#                                         Used.                         MI05 368
# MOVE DATA SET NAME INTO QX ARRAY                                      MI05 369
movector:(DATNAM,(DNOW-1)*12+1,QX(STOPDN+1),1,12,0)#                    MI05 370
#                                                                       MI05 371
STOPDN = STOPDN + STEPDN#              Reset end of data set names      MI05 372
#                                                                       MI05 373
#        SET UP THE FLAGS WHICH CONTROL INCLUSION OF ISOMORPHOUS        MI05 374
#         AND ANOMALOUS DISPERSION DATA IN PHASE DETERMINATION          MI05 375
#         AND PARAMETER REFINEMENT.                                     MI05 376
#        THESE FLAGS ARE STORED AT THE BEGINNING OF THE                 MI05 377
#         STARRO REGION OF COMMON.                                      MI05 378
#        FAZDA1 CONTROLS PHASING ...                                    MI05 379
#        FAZDA2 CONTROLS PARAMETER REFINEMENT...                        MI05 380
#        PERMISSIBLE VALUES ARE:                                        MI05 381
#                0 NEITHER ISOMORPHOUS OR ANOMALOUS DATA                MI05 382
#                1 ISOMORPHOUS DATA, ONLY                               MI05 383
#                2 ANOMALOUS DISPERSION DATA, ONLY                      MI05 384
#                3 BOTH ISOMORPHOUS AND ANOMALOUS DATA                  MI05 385
#                DEFAULT IS 3                                           MI05 386
#        THESE FLAGS ARE USED BY MI40 AND ITS SUBROUTINES               MI05 387
#                                                                       MI05 388
FAZDA1(NDATIN) = 3.0#                                                   MI05 389
#                                                                       MI05 390
# CHANGE ANFLG: FOR PHASING FROM DEFAULT                                MI05 391
FIELD = 2#                                                              MI05 392
IF(BUFIN(FIELD) > voidflg:)  iquit:(-MI0502,FIELD)#                     MI05 393
ELSE ifnv:(BUFIN(FIELD))#                                               MI05 394
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MI05 395
stringlim:(FIELD,FIRST,LAST)#                                           MI05 396
NCHAR = MIN0((LAST-FIRST),4)#                                           MI05 397
compchar:(CHRIN,FIRST,MI052,1,4,5,NMI052,MATCH)#                        MI05 398
IF(MATCH != 0)  FAZDA1(NDATIN) = FLOAT(MATCH-1)#                        MI05 399
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MI05 400
#                                                                       MI05 401
FAZDA2(NDATIN) = 3.0#                                                   MI05 402
#                                                                       MI05 403
# CHANGE ANFLG: FOR REFINING FROM DEFAULT                               MI05 404
FIELD = 3#                                                              MI05 405
IF(BUFIN(FIELD) > voidflg:)  iquit:(-MI0502,FIELD)#                     MI05 406
ELSE ifnv:(BUFIN(FIELD))#                                               MI05 407
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MI05 408
stringlim:(FIELD,FIRST,LAST)#                                           MI05 409
NCHAR = MIN0((LAST-FIRST),4)#                                           MI05 410
compchar:(CHRIN,FIRST,MI052,1,4,5,NMI052,MATCH)#                        MI05 411
IF(MATCH != 0)  FAZDA2(NDATIN) = FLOAT(MATCH-1)#                        MI05 412
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MI05 413
#                                                                       MI05 414
endproc:(DATSET)#                                                       MI05 415
#                                                                       MI05 416
#                       ##########                                      MI05 417
####################### DATSETFINI #################################### MI05 418
#                       ##########                                      MI05 419
#                                                                       MI05 420
procedure:(DATSETFINI)#                Finish off datset information    MI05 421
#                                         And read lrdset:.             MI05 422
IF(NDATIN == 0)#                       Check if any datset cards read   MI05 423
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MI05 424
NDATIN = NDAT#                                                          MI05 425
NAMPTR = 1#                                                             MI05 426
DO I=1,NDATIN#                         Move all data set names          MI05 427
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MI05 428
SEQDAT(I) = I#                         Set sequence number              MI05 429
movector:(DATNAM,NAMPTR,QX(STOPDN+1),1,12,0)#                           MI05 430
STOPDN = STOPDN + STEPDN#              Increment end of qx array        MI05 431
NAMPTR = NAMPTR + 12#                  Increment character pointer      MI05 432
FAZDA1(I) = 3.0#                                                        MI05 433
FAZDA2(I) = 3.0#                                                        MI05 434
STOLMN(I) = 0.0#                       Minimum and maximum              MI05 435
STOLMX(I) = 0.25#                      Sine(theta/lambda).              MI05 436
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MI05 437
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MI05 438
#                                                                       MI05 439
# INDICATE THE ORDER OF THE REQUESTED DATA SETS AS THEY APPEAR          MI05 440
#  ON THE BDF.  THAT IS, IF THE PARENT IS DATA SET NUMBER 3,            MI05 441
#  THEN BDFSEQ(1) WILL BE EQUAL TO 3.                                   MI05 442
#                                                                       MI05 443
DO I=1,NDAT#                           Loop over all bdf data sets      MI05 444
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MI05 445
INDX = SEQDAT(I)#                      Pick up the sequence number      MI05 446
IF(INDX != no:)  BDFSEQ(INDX) = I#     Set the order                    MI05 447
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MI05 448
#                                                                       MI05 449
STARKB = STOPDN#                       Set start of scale,thermal,      MI05 450
STEPKB = 100 + binstart:#              Closure error area.              MI05 451
KPTR = STARKB#                                                          MI05 452
incrqx:(I,STARKB+STEPKB*NDATIN,MI0503)#                                 MI05 453
#                                                                       MI05 454
DO I=1,NDATIN#                         Loop over number of data sets    MI05 455
#                                         Stuffing away default values  MI05 456
#                                         For k, b, closure errors, etc MI05 457
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MI05 458
QX(KPTR+1) = 1.0#                      Scale factor                     MI05 459
QX(KPTR+3) = 0.0#                      Delta b                          MI05 460
IF(I == 1)#                            Don't refine these               MI05 461
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MI05 462
QX(KPTR+2) = 0.#                       Parameters for the parent.       MI05 463
QX(KPTR+4) = 0.#                                                        MI05 464
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MI05 465
ELSE#                                  Do refine them for all other     MI05 466
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MI05 467
QX(KPTR+2) = 1.#                       Isomorphs.                       MI05 468
QX(KPTR+4) = 1.#                                                        MI05 469
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MI05 470
QX(KPTR+5) = 5.#                       Number of stol bins              MI05 471
QX(KPTR+6) = 3.#                       Number of f**2 bins              MI05 472
EPTR = KPTR + binstart:#               Adjust pointer                   MI05 473
DO J=1,50#                                                              MI05 474
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MI05 475
EPTR = EPTR + 1#                                                        MI05 476
QX(EPTR) = 1000000.#                   Default for ermiso**2            MI05 477
QX(EPTR+50) = 350000.#                 Default for ermsano**2           MI05 478
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MI05 479
KPTR = KPTR + STEPKB#                                                   MI05 480
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MI05 481
#                                                                       MI05 482
STOPKB = KPTR#                                                          MI05 483
#                                                                       MI05 484
SIGNAL(1) = 0#                         Set signals for indexpkt:        MI05 485
SIGNAL(2) = 107#                                                        MI05 486
SIGNAL(3) = 0#                                                          MI05 487
SIGNAL(4) = 0#                                                          MI05 488
#                                                                       MI05 489
NEED12(1) = 1#                         Data-set key                     MI05 490
NEED12(2) = 14#                        Minimum sine(theta/lambda)       MI05 491
NEED12(3) = 15#                        Maximim sine(theta/lambda)       MI05 492
NEED12(4) = 30#                        Scale, data-set to parent        MI05 493
NEED12(5) = 31#                        Delta b relative to parent       MI05 494
NEED12(6) = 34#                        Number of stol bins              MI05 495
NEED12(7) = 35#                        Number of f**2 bins              MI05 496
#                                                                       MI05 497
DO I=8,57#                                                              MI05 498
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MI05 499
# ISOMORPHOUS ERRORS FOR SHELLS                                         MI05 500
NEED12(I) = 192 + I#                   Set need12 items 200-249         MI05 501
# ANOMALOUS ERRORS FOR SHELLS                                           MI05 502
NEED12(I+50) = NEED12(I) + 100#        Set need12 items 300-349         MI05 503
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MI05 504
#                                                                       MI05 505
# GET DIRECTORY FOR LOGICAL RECORD LRDSET:                              MI05 506
#                                                                       MI05 507
indexpkt:(1,lrdset:,PSIZE,IPT,0,SIGNAL,NEED12,POINT)#                   MI05 508
IF(IPT < 0)  iquit:(MI0510)#           Lrdset: missing                  MI05 509
#                                                                       MI05 510
readwpkt:(1,lrdset:,PSIZE,IPT,0)#      Read rest of lrdset:             MI05 511
WHILE(IPT > 0)#                        Loop thru lrdset:, stuffing      MI05 512
#                                         Away k and delta-b.           MI05 513
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MI05 514
IPTR = IPT + POINT(1)#                                                  MI05 515
DNOW = NINT(QX(IPTR))#                 Get data-set number              MI05 516
DSET = SEQDAT(DNOW)#                   Data set sequence number         MI05 517
IF(DSET != 0)#                         Was current data set requested   MI05 518
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MI05 519
KPTR = STEPKB*(DSET-1) + STARKB#       Make pointer to kb area          MI05 520
IF(POINT(2) > 0)#                      Get min. sine(theta/lambda)      MI05 521
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 MI05 522
IPTR = IPT + POINT(2)#                                                  MI05 523
STOLMN(DSET) = QX(IPTR)#                                                MI05 524
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 MI05 525
IF(POINT(3) > 0)#                      Get max. sine(theta/lambda)      MI05 526
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 MI05 527
IPTR = IPT + POINT(3)#                                                  MI05 528
STOLMX(DSET) = QX(IPTR)#                                                MI05 529
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 MI05 530
IF(POINT(4) > 0)#                      Get scale to parent              MI05 531
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 MI05 532
IPTR = IPT + POINT(4)#                                                  MI05 533
ifnv:(QX(IPTR))  QX(KPTR+1) = QX(IPTR)#                                 MI05 534
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 MI05 535
IF(POINT(5) > 0)#                      Get delta b to parent            MI05 536
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 MI05 537
IPTR = IPT + POINT(5)#                                                  MI05 538
ifnv:(QX(IPTR))  QX(KPTR+3) = QX(IPTR)#                                 MI05 539
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 MI05 540
IF(POINT(6) > 0)#                      Get number stol bins             MI05 541
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 MI05 542
IPTR = IPT + POINT(6)#                                                  MI05 543
ifvo:(QX(IPTR))  QX(IPTR) = 0.#                                         MI05 544
QX(KPTR+5) = QX(IPTR) + 1000.#         The 1000 is a flag indicating    MI05 545
#                                         That the source of the no. of MI05 546
#                                         Bins is the bdf.  if 10000    MI05 547
#                                         Were added, it would indicate MI05 548
#                                         Source is input lines.        MI05 549
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 MI05 550
#                                                                       MI05 551
IF (POINT(7) > 0)#                     Get number of f**2 bins          MI05 552
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 MI05 553
IPTR = IPT + POINT(7)#                                                  MI05 554
ifvo:(QX(IPTR))  QX(IPTR) = 0.#                                         MI05 555
QX(KPTR+binstart:) = QX(IPTR) + 1000.#                                  MI05 556
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 MI05 557
#                                                                       MI05 558
DO I=1,100#                            Try to get isomorphous and       MI05 559
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 MI05 560
IF(POINT(I+7) > 0)#                    Anomalous errors.                MI05 561
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 MI05 562
IPTR = IPT + POINT(I+7)#                                                MI05 563
ifvo:(QX(IPTR))  QX(IPTR) = 0.#                                         MI05 564
EPTR = KPTR + binstart: + I#           Pointer of where to put in qx    MI05 565
QX(EPTR) = QX(IPTR)**2#                Stored squared in qx array       MI05 566
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 MI05 567
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 MI05 568
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MI05 569
#                                                                       MI05 570
readwpkt:(1,lrdset:,PSIZE,IPT,0)#      Get next packet                  MI05 571
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MI05 572
#                                                                       MI05 573
endproc:(DATSETFINI)#                                                   MI05 574
#                                                                       MI05 575
#                      ##########                                       MI05 576
###################### SETDEFAULT ####################################  MI05 577
#                      ##########                                       MI05 578
#                                                                       MI05 579
procedure:(SETDEFAULT)#                Set statistics and other         MI05 580
#                                         Defaults.                     MI05 581
#                                                                       MI05 582
# TURN OFF PHASING METHOD INDICATOR..FOR LATER CHECKS                   MI05 583
FAZA1 = 0 ; FAZB1 = 0; FAZFM1 = 0#                                      MI05 584
FAZA2 = 0 ; FAZB2 = 0; FAZFM2 = 0#                                      MI05 585
FAZTYP = none:#                                                         MI05 586
NCYC = 1#                              Set default on cycles to 1       MI05 587
#                                                                       MI05 588
# SET DEFAULT ON WHETHER CLOSURE ERRORS HAVE BEEN UPDATED FROM INPUT    MI05 589
#                                                                       MI05 590
DO I=1,arith:(24,*,maxsets:)#                                           MI05 591
IBNCHK(I) = no:#                                                        MI05 592
#                                                                       MI05 593
# INITIALIZE VARIABLES FOR PLOTTING PHASE PROBABILITY PROFILES          MI05 594
#                                                                       MI05 595
IPLOT = 0#                             Set number of plots to don't     MI05 596
DO I=1,10#                                                              MI05 597
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 MI05 598
PLTHKL(I) = voidflg:#                  Packed index                     MI05 599
NUMPLT(I) = 10#                        Number to plot                   MI05 600
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 MI05 601
DO I=1,NDATIN; STAB(I)=0.05#           Set default instability factor   MI05 602
#                                                                       MI05 603
# SET DEFAULT FOR STATISTICS OUTPUT                                     MI05 604
#                                                                       MI05 605
STARST = STOPEF#                                                        MI05 606
STEPST = 1#                                                             MI05 607
incrqx:(STOPST,STARST+19,MI0503)#                                       MI05 608
#                                                                       MI05 609
# CODE FOR PRINTING STATISTICS:  2. INDICATES PRINT ALL CYCLES          MI05 610
#  1. INDICATES PRINT LAST CYCLE ONLY; 0. INDICATES DO NOT PRINT EVER   MI05 611
#                                                                       MI05 612
QX(STARST+1)  = 2.#                    Fomhist                          MI05 613
QX(STARST+2)  = 2.#                    Fom                              MI05 614
QX(STARST+3)  = 1.#                    Parvar                           MI05 615
QX(STARST+4)  = 2.#                    Rcullis                          MI05 616
QX(STARST+5)  = 2.#                    Rkraut                           MI05 617
QX(STARST+6)  = 2.#                    Rfazpwr                          MI05 618
QX(STARST+7)  = 1.#                    Wteiso                           MI05 619
QX(STARST+8)  = 1.#                    Wteano                           MI05 620
QX(STARST+9)  = 1.#                    Number                           MI05 621
QX(STARST+10) = 1.#                    Fazdif                           MI05 622
QX(STARST+11) = 2.#                    Ermsiso                          MI05 623
QX(STARST+12) = 2.#                    Eisoadj                          MI05 624
QX(STARST+13) = 1.#                    Isodif                           MI05 625
QX(STARST+14) = 1.#                    Hamodel                          MI05 626
QX(STARST+15) = 1.#                    Jntvar                           MI05 627
QX(STARST+16) = 2.#                    Ermsano                          MI05 628
QX(STARST+17) = 2.#                    Eanoadj                          MI05 629
QX(STARST+18) = 1.#                    Anodif                           MI05 630
QX(STARST+19) = 1.#                    Signs                            MI05 631
#                                                                       MI05 632
NBIN = NINT(AMOD(QX(STARKB+5),1000.))# Number of stol bins         m    MI05 633
NFBIN = NINT(AMOD(QX(STARKB+6),1000.))# Number of f**2 bins             MI05 634
NCBIN = 21#                            Centric on last cycle,           MI05 635
#                                         All on rest.                  MI05 636
#                                                                       MI05 637
endproc:(SETDEFAULT)#                                                   MI05 638
#                                                                       MI05 639
#                       ######                                          MI05 640
####################### SEQNUM ######################################## MI05 641
#                       ######                                          MI05 642
#                                                                       MI05 643
# RETURN LOCAL SEQUENCE ORDER OF NAMED DATA SET INTO IDAT               MI05 644
#                                                                       MI05 645
procedure:(SEQNUM)#                                                     MI05 646
#                                                                       MI05 647
NONAME = no:#                          Initialize to "data set name     MI05 648
FIELD = 1#                             Found".                          MI05 649
IF(BUFIN(FIELD) >= voidflg:)#                                           MI05 650
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 MI05 651
iquit:(-MI0511,FIELD)#                 No data set name on current      MI05 652
NONAME = yes:#                         Input line.                      MI05 653
endproc:(SEQNUM)#                                                       MI05 654
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 MI05 655
#                                                                       MI05 656
stringlim:(FIELD,FIRST,LAST)#          Pick out name                    MI05 657
NCHAR = MIN0((LAST-FIRST),12)#                                          MI05 658
movechar:(BLANK,1,UPCOMA,1,12,1)#      Blank datset name for test       Aug93008
movechar:(CHRIN,FIRST,UPCOMA,1,NCHAR,0)# Copy from datset line          Aug93009
upcase:(UPCOMA,UPCOMA,12)#             Roll data set name to up case    Aug93010
compchar:(UPCOMA,1,DATNAM,1,12,12,NDAT*12,DNOW)#                        Aug93011
IF(DNOW == no:)#                                                        MI05 660
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 MI05 661
iquit:(-MI0512,FIELD)#                 Bad name on current input        MI05 662
NONAME = yes:#                         Line.                            MI05 663
endproc:(SEQNUM)#                                                       MI05 664
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 MI05 665
INDX = SEQDAT(DNOW)#                   Sequence number of this          MI05 666
IF(INDX == no:)#                       Data set.                        MI05 667
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 MI05 668
iquit:(-MI0513,FIELD)#                 Data set on current input        MI05 669
NONAME = yes:#                         Line not being used.             MI05 670
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 MI05 671
#                                                                       MI05 672
endproc:(SEQNUM)#                                                       MI05 673
#                                                                       MI05 674
#                       #####                                           MI05 675
####################### ATOMS ######################################### MI05 676
#                       #####                                           MI05 677
#                                                                       MI05 678
# READ THE ATOMS DESIRED FOR A DATA SET                                 MI05 679
#                                                                       MI05 680
procedure:(ATOMS)#                                                      MI05 681
#                                                                       MI05 682
xeq:(SEQNUM)#                          Look for a data set name         MI05 683
#                                                                       MI05 684
IF(NONAME == yes:)  endproc:(ATOMS)#   Something wrong with field 1     MI05 685
#                                                                       MI05 686
FOR(FIELD=2; BUFIN(FIELD) < voidflg:; FIELD=FIELD+1)#                   MI05 687
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 MI05 688
stringlim:(FIELD,FIRST,LAST)#          Pick out an atom name            MI05 689
ATOM=CHRIP(FIRST^LAST-1)#              Rstore the atom name             MI05 690
BUFOT(1)=FLOAT(DNOW)#                  Float data set indicator         MI05 691
ncodefld:(BUFOT,1,ATOM,FMT051,1)#      Append data set indicator        MI05 692
compchar:(ATOM,1,ATNAM,1,24,24,NAT*12,ATNOW)# Test if on the bdf        MI05 693
IF(ATNOW == 0)  iquit:(-MI0514,FIELD)#                                  MI05 694
ELSE#                                                                   MI05 695
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 MI05 696
J = STARAT+(ATNOW-1)*STEPAT+stepat:#   Get data set number              MI05 697
ifvo:(QX(J)) QX(J) = BUFOT(1)#                                          MI05 698
ifne:(QX(J),BUFOT(1)) BREAK#                                            MI05 699
IF(ATSET(ATNOW) > 0)  iquit:(-MI0515,FIELD)# Read in before             MI05 700
NATIN = NATIN + 1#                     It's new, count it               MI05 701
IF(NATIN > maxatoms:)  iquit:(MI0516)# See if max. atoms limit          MI05 702
ATSET(ATNOW) = DNOW#                   Data set to which it belongs     MI05 703
NUMAT(INDX) = NUMAT(INDX) + 1#         No. of atoms for this data set   MI05 704
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 MI05 705
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 MI05 706
#                                                                       MI05 707
endproc:(ATOMS)#                                                        MI05 708
#                                                                       MI05 709
#                       #########                                       MI05 710
####################### ATOMSFINI ##################################### MI05 711
#                       #########                                       MI05 712
#                                                                       MI05 713
# BRING IN ALL DEFAULT ATOMS AND RE-ARRANGE THE ATOM PARAMETER STORAGE  MI05 714
#                                                                       MI05 715
procedure:(ATOMSFINI)#                                                  MI05 716
#                                                                       MI05 717
DO I=1,NDAT#                           Loop over data sets              MI05 718
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 MI05 719
INDX = SEQDAT(I)#                      Data set sequence number         MI05 720
IF(INDX == 0)  NEXT#                   Skip if no seq number            MI05 721
IF(NUMAT(INDX)!=0) NEXT#               Skip if already checked          MI05 722
BUFOT(1) = FLOAT(I)#                   Load data set number             MI05 723
K=STARAT+stepat:-STEPAT#               Point to data set number         MI05 724
DO J=1,NAT#                            Look for all atoms belonging     MI05 725
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 MI05 726
K=K+STEPAT#                            Point to next atom parameters    MI05 727
ifne:(BUFOT(1),QX(K)) NEXT#            Skip if does not belong          MI05 728
NUMAT(INDX) = NUMAT(INDX) + 1#         Count atom in data set           MI05 729
ATSET(J) = I#                          Flag atom with data set          MI05 730
NATIN = NATIN + 1#                     Count total refinenment atoms    MI05 731
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 MI05 732
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 MI05 733
#                                                                       MI05 734
# NOW GET ALL THE SELECTED ATOMS AND THEIR COORDINATES                  MI05 735
#  AND THEIR DEFAULT REFIN. KEYS INTO THE QX ARRAY.                     MI05 736
#                                                                       MI05 737
CALL MI07#                                                              MI05 738
#                                                                       MI05 739
endproc:(ATOMSFINI)#                                                    MI05 740
#                                                                       MI05 741
#                       ######                                          MI05 742
####################### LIMSET ######################################## MI05 743
#                       ######                                          MI05 744
#                                                                       MI05 745
procedure:(LIMSET)#                    Process "limset" line            MI05 746
#                                                                       MI05 747
xeq:(SEQNUM)#                          Store in dnow the local data     MI05 748
#                                         Set number.                   MI05 749
#                                                                       MI05 750
IF(NONAME == yes:)  endproc:(LIMSET)#                                   MI05 751
#                                                                       MI05 752
# STORE MINIMUM AND MAXIMUM SINE(THETA)/LAMBDA                          MI05 753
FIELD = 2#                                                              MI05 754
IF(BUFIN(FIELD) >= 0.0)  STOLMN(INDX) = BUFIN(FIELD)#                   MI05 755
FIELD = 3#                                                              MI05 756
IF(BUFIN(FIELD) >= STOLMN(INDX))  STOLMX(INDX) = BUFIN(FIELD)#          MI05 757
IF(STOLMX(INDX) <= STOLMN(INDX))  iquit:(-MI0517,FIELD)#                MI05 758
#                                                                       MI05 759
endproc:(LIMSET)#                                                       MI05 760
#                                                                       MI05 761
#                       ######                                          MI05 762
####################### DATSCL ######################################## MI05 763
#                       ######                                          MI05 764
#                                                                       MI05 765
procedure:(DATSCL)#                    Process datscl line              MI05 766
#                                                                       MI05 767
xeq:(SEQNUM)#                          Get local data set name          MI05 768
#                                                                       MI05 769
IF(NONAME == yes:)  endproc:(DATSCL)#                                   MI05 770
#                                                                       MI05 771
KPTR = (INDX-1)*STEPKB + STARKB#       Calculate pointer for data       MI05 772
FIELD = 2#                                                              MI05 773
ifnv:(BUFIN(FIELD))#                                                    MI05 774
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 MI05 775
IF(BUFIN(FIELD) <= 0.)  iquit:(-MI0518,FIELD)#                          MI05 776
ELSE  QX(KPTR+1) = BUFIN(FIELD)#       Store scale                      MI05 777
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 MI05 778
# STORE DELTA B                                                         MI05 779
FIELD = 3#                                                              MI05 780
ifnv:(BUFIN(FIELD))  QX(KPTR+3) = BUFIN(FIELD)#                         MI05 781
FIELD = 4#                                                              MI05 782
ifnv:(BUFIN(FIELD))#                                                    MI05 783
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 MI05 784
IF(BUFIN(FIELD) <= 0.)  iquit:(-MI0518,FIELD)#                          MI05 785
ELSE  STAB(INDX) = BUFIN(FIELD)#                                        MI05 786
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 MI05 787
#                                                                       MI05 788
endproc:(DATSCL)#                                                       MI05 789
#                                                                       MI05 790
#                       ######                                          MI05 791
####################### REFKEY ######################################## MI05 792
#                       ######                                          MI05 793
#                                                                       MI05 794
procedure:(REFKEY)#                    Reset refinement keys            MI05 795
#                                                                       MI05 796
IF(LINID == 6)  KEY = yes:#            Turn  on ref keys                MI05 797
IF(LINID == 7)  KEY = no:#             Turn off ref keys                MI05 798
#                                                                       MI05 799
CALL MI12(KEY,DATNAM,ATNAM)#           Call routine to process keys     MI05 800
#                                                                       MI05 801
endproc:(REFKEY)#                                                       MI05 802
#                                                                       MI05 803
#                       ####                                            MI05 804
####################### BINS ########################################## MI05 805
#                       ####                                            MI05 806
#                                                                       MI05 807
procedure:(BINS)#                      Process bins input line          MI05 808
#                                                                       MI05 809
CALL MI13#                                                              MI05 810
#                                                                       MI05 811
endproc:(BINS)#                                                         MI05 812
#                                                                       MI05 813
#                       #####                                           MI05 814
####################### FAZIN ######################################### MI05 815
#                       #####                                           MI05 816
#                                                                       MI05 817
procedure:(FAZIN)#                     Input selected phase input       MI05 818
#                                                                       MI05 819
CALL MI14#                                                              MI05 820
#                                                                       MI05 821
endproc:(FAZIN)#                                                        MI05 822
#                                                                       MI05 823
#                     ######                                            MI05 824
##################### MINVFC ########################################## MI05 825
#                     ######                                            MI05 826
#                                                                       MI05 827
procedure:(MINVFC)#                    Process mvfc input line          MI05 828
#                                                                       MI05 829
CALL MI15#                                                              MI05 830
#                                                                       MI05 831
endproc:(MINVFC)#                                                       MI05 832
#                                                                       MI05 833
#                      #######                                          MI05 834
###################### PHAZPRB ######################################## MI05 835
#                      #######                                          MI05 836
#                                                                       MI05 837
procedure:(PHAZPRB)#                   Process fazprb input line        MI05 838
#                                                                       MI05 839
CALL MI16#                                                              MI05 840
#                                                                       MI05 841
endproc:(PHAZPRB)#                                                      MI05 842
#                                                                       MI05 843
#                       #########                                       MI05 844
####################### CLOSERROR ##################################### MI05 845
#                       #########                                       MI05 846
#                                                                       MI05 847
procedure:(CLOSERROR)#                 Process eiso and eano lines      MI05 848
#                                                                       MI05 849
xeq:(SEQNUM)#                          Get local data set number        MI05 850
#                                                                       MI05 851
IF(NONAME == yes:)  endproc:(CLOSERROR)#                                MI05 852
#                                                                       MI05 853
SAVKCD = LINID#                        Save line ident for future       MI05 854
#                                         Checking.                     MI05 855
DSPREV = DNOW#                         Save temporarily local           MI05 856
FIELD = 2#                             Data set number.                 MI05 857
FBINNO = NINT(BUFIN(FIELD))#           F**2 bin number                  MI05 858
#                                                                       MI05 859
DO J=1,13#                             Clear out current values of      MI05 860
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 MI05 861
CLOSUR(J) = voidflg:#                  Closure errors.                  MI05 862
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 MI05 863
#                                                                       MI05 864
FIELD = 3#                             Third field on input line        MI05 865
#                                         Is first closure error.       MI05 866
CLOPTR = 0#                            Pointer to temporary storage     MI05 867
#                                         For closure errors.           MI05 868
#                                                                       MI05 869
REPEAT#                                Pick up all closure errors       MI05 870
#                                         Even if on multiple lines.    MI05 871
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 MI05 872
IF(BUFIN(FIELD) < voidflg:)#           Character information            MI05 873
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 MI05 874
stringlim:(FIELD,FIRST,LAST)#          Extract character                MI05 875
compchar:(CHRIN,FIRST,CONTN,1,1,1,NCONTN,MATCH)#                        MI05 876
IF(MATCH == 0)#                        If character not a "c", die      MI05 877
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 MI05 878
iquit:(-MI0519,FIELD)#                                                  MI05 879
endproc:(CLOSERROR)#                                                    MI05 880
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 MI05 881
readline:(MI051,NMI051)#               Otherwise read new line          MI05 882
IF(SAVKCD != LINID)#                   Must be the same type of         MI05 883
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 MI05 884
iquit:(-MI0520)#                       Closure error line.              MI05 885
endproc:(CLOSERROR)#                                                    MI05 886
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 MI05 887
#                                                                       MI05 888
xeq:(SEQNUM)#                          Get local data-set number        MI05 889
#                                                                       MI05 890
IF(DNOW != DSPREV)#                    Must be same data set            MI05 891
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 MI05 892
iquit:(-MI0512,FIELD)#                                                  MI05 893
endproc:(CLOSERROR)#                                                    MI05 894
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 MI05 895
FIELD = 2#                                                              MI05 896
IF(NINT(BUFIN(FIELD)) != FBINNO)#      Must be the same f**2 bin        MI05 897
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 MI05 898
iquit:(-MI0521,FIELD)#                                                  MI05 899
endproc:(CLOSERROR)#                                                    MI05 900
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 MI05 901
FIELD = 3#                             Reset field pointer              MI05 902
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 MI05 903
#                                                                       MI05 904
IF(BUFIN(FIELD) < small:)  BREAK#      No more closure errors           MI05 905
CLOPTR = CLOPTR + 1#                   Increment pointer to closure     MI05 906
#                                         Error temporary storage.      MI05 907
IF(CLOPTR > 13)#                       Too many values                  MI05 908
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 MI05 909
iquit:(-MI0522)#                                                        MI05 910
endproc:(CLOSERROR)#                                                    MI05 911
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 MI05 912
CLOSUR(CLOPTR) = BUFIN(FIELD)#         Store closure error away         MI05 913
FIELD = FIELD + 1#                     Point to next field              MI05 914
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 MI05 915
#                                                                       MI05 916
ICD = LINID - 11#                      This is done so that mi17        MI05 917
#                                         Never has to know value of    MI05 918
#                                         Linid.                        MI05 919
CALL MI17(ICD,INDX,IBNCHK,FBINNO,CLOSUR)#                               MI05 920
#                                                                       MI05 921
endproc:(CLOSERROR)#                                                    MI05 922
#                                                                       MI05 923
#                       ########                                        MI05 924
# ##################### SETSTATS ###################################### MI05 925
#                       ########                                        MI05 926
#                                                                       MI05 927
procedure:(SETSTATS)#                  Process stat and nostat lines    MI05 928
#                                                                       MI05 929
IF(LINID == 14)  STAT = yes:#          Stat line                        MI05 930
IF(LINID == 15)  STAT = no:#           Nostat line                      MI05 931
#                                                                       MI05 932
CALL MI18(STAT)#                                                        MI05 933
#                                                                       MI05 934
endproc:(SETSTATS)#                                                     MI05 935
#                                                                       MI05 936
#                        ########                                       MI05 937
######################## SETCYCLE ##################################### MI05 938
#                        ########                                       MI05 939
#                                                                       MI05 940
procedure:(SETCYCLE)#                  Process cycle input line         MI05 941
#                                                                       MI05 942
# MAXIMUM OF 10 CYCLES ALLOWED                                          MI05 943
FIELD = 1#                                                              MI05 944
IF(BUFIN(FIELD) >= 1.)  NCYC = MIN0(NINT(BUFIN(FIELD)),10)#             MI05 945
#                                                                       MI05 946
# SET CYCLE NUMBER EXTERNALLY WITH FIELD 2.  THIS OVERRIDES THE         MI05 947
#  LAST CYCLE NUMBER FOUND IN LOGICAL RECORD LRCELL: OF THE BDF.        MI05 948
# THE VALUE ENTERED ON THE LINE IS THE INITIAL CYCLE NUMBER FOR THE     MI05 949
#  PRESENT RUN.  IT MUST BE REDUCED BY ONE TO MAKE IT THE LAST CYCLE    MI05 950
#  NUMBER.                                                              MI05 951
#                                                                       MI05 952
FIELD = 2#                                                              MI05 953
ifnv:(BUFIN(FIELD))  ICYC = NINT(BUFIN(FIELD)) - 1#                     MI05 954
LSTCYC = ICYC + NCYC#                  Get number which will be         MI05 955
#                                         That of the last cycle.       MI05 956
#                                                                       MI05 957
endproc:(SETCYCLE)#                                                     MI05 958
#                                                                       MI05 959
#                       ######                                          MI05 960
####################### PLTHKL ######################################## MI05 961
#                       ######                                          MI05 962
#                                                                       MI05 963
procedure:(PLTHKL)#                    Process plthkl input line        MI05 964
#                                                                       MI05 965
CALL MI20#                                                              MI05 966
#                                                                       MI05 967
endproc:(PLTHKL)#                                                       MI05 968
#                                                                       MI05 969
# DELETE PROCEDURE MACRO NAMES                                          MI05 970
#                                                                       MI05 971
deleteproc:(SEQNUM)#                                                    MI05 972
deleteproc:(MIR)#                                                       MI05 973
deleteproc:(DATSETINIT)#                                                MI05 974
deleteproc:(DATSET)#                                                    MI05 975
deleteproc:(DATSETFINI)#                                                MI05 976
deleteproc:(ATOMSINIT)#                                                 MI05 977
deleteproc:(ATOMS)#                                                     MI05 978
deleteproc:(ATOMSFINI)#                                                 MI05 979
deleteproc:(SETDEFAULT)#                                                MI05 980
deleteproc:(LIMSET)#                                                    MI05 981
deleteproc:(DATSCL)#                                                    MI05 982
deleteproc:(REFKEY)#                                                    MI05 983
deleteproc:(BINS)#                                                      MI05 984
deleteproc:(FAZIN)#                                                     MI05 985
deleteproc:(MINVFC)#                                                    MI05 986
deleteproc:(PHAZPRB)#                                                   MI05 987
deleteproc:(CLOSERROR)#                                                 MI05 988
deleteproc:(SETSTATS)#                                                  MI05 989
deleteproc:(SETCYCLE)#                                                  MI05 990
deleteproc:(PLTHKL)#                                                    MI05 991
#                                                                       MI05 992
#                                                                       MI05 993
END#                                                                    MI05 994
systemheader:(MI06)#                                                    MI06   1
# ################################################################## #  MI06   2
#                                                                    #  MI06   3
#                               MI06                                 #  MI06   4
#                                                                    #  MI06   5
# ################################################################## #  MI06   6
#                                                                       MI06   7
SUBROUTINE MI06#                                                        MI06   8
#                                                                       MI06   9
# READS THE ATOM PARAMETERS FROM BDF LRATOM: AND STUFFS ALL OF THEM     MI06  10
#  AWAY TEMPORARILY.                                                    MI06  11
#                                                                       MI06  12
#                                        15 sep 1980  k.d. watenpaugh   MI06  13
#                                        Revised mar 1982 r.m. doherty  MI06  14
#                                         To accommodate new bdf format MI06  15
#                                                                       MI06  16
include:(AACOMN)#                                                       MI06  17
include:(MICOMN)#                                                       MI06  18
#                                                                       MI06  19
#INTEGER ANPTR#                          POINTER TO AN ATOM NAME &&&&&  MI06  20
INTEGER ATPTR#                         Pointer to atom name in table    MI06  21
#                                         Of names on the bdf.          MI06  22
INTEGER BKEY#                          Temperature factor type;         MI06  23
#                                         = 0, overall b                MI06  24
#                                         = 1, isotropic                MI06  25
#                                         = 2, anisotropic              MI06  26
INTEGER I#                             An index                         MI06  27
INTEGER IPT#                           Lratom: packet pointer           MI06  28
INTEGER IPTR#                          Pointer to a particular value    MI06  29
#                                         In the input buffer.          MI06  30
INTEGER POINT(17)#                     Offsets pointing to lratom:      MI06  31
#                                         Packet ids found.             MI06  32
INTEGER PSIZE#                         Packet size for lratom:          MI06  33
#                                                                       MI06  34
intdata:(NEED16,[14,1,2,3,4,$#                                          MI06  35
5,6,7,8,9,10,11,12,22,23,17])#                                          MI06  36
intdata:(SGNL16,[4,16,16,0])#                                           MI06  37
datastuff:#                                                             MI06  38
#                                                                       MI06  39
# INITIALIZE POINTERS                                                   MI06  40
#                                                                       MI06  41
STEPAT = arith:(stepat:,+,stepan:)#    Atom parameters and names will   MI06  42
STARAT = STOPKB + maxspace:#           Be stored temporarily in the     MI06  43
STOPAT = STARAT + maxspace:#           Region that ultimately will      MI06  44
STARAN = STARAT + stepat:#             Hold the refinement keys.        MI06  45
STEPAN = stepan:#                      Length of atom name              MI06  46
STOPAN = STOPAT#                       Current end of atom array        MI06  47
ATPTR = STARAT#                        Atom array pointer               MI06  48
incrqx:(I,STOPAN+1,MI0501)#                                             MI06  49
#                                                                       MI06  50
# READ BDF LRATOM: AND STORE AWAY IN DESIRED POSITIONS                  MI06  51
#                                                                       MI06  52
indexpkt:(1,lratom:,PSIZE,IPT,0,SGNL16,NEED16,POINT)#                   MI06  53
IF(IPT == 0)  iquit:(MI0602)#                                           MI06  54
IF(SGNL16(4) < 0)  iquit:(MI0603)#     X,y,z or name missing            MI06  55
#                                                                       MI06  56
REPEAT#                                Loop over all atoms in file      MI06  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI06  58
readwpkt:(1,lratom:,PSIZE,IPT,0)#      Read next packet                 MI06  59
IF(IPT <= 0)  BREAK#                   Exit repeat when all read        MI06  60
NAT = NAT + 1#                         Count atoms on the bdf           MI06  61
IF(NAT > maxatoms:)  iquit:(MI0604)#   Too many                         MI06  62
#                                                                       MI06  63
# MOVE ATOMIC PARAMETERS                                                MI06  64
#                                                                       MI06  65
DO I=2,4#                              Move xyz                         MI06  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI06  67
IPTR = IPT + POINT(I)#                                                  MI06  68
ATPTR = ATPTR + 1#                     Xyz at +1 to +3                  MI06  69
QX(ATPTR) = QX(IPTR)#                                                   MI06  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI06  71
#                                                                       MI06  72
# NOW MOVE TEMPERATURE FACTORS TO QX                                    MI06  73
#                                                                       MI06  74
IF(POINT(15) > 0)#                     Use temperature key from bdf     MI06  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI06  76
IPTR = IPT + POINT(15)#                                                 MI06  77
BKEY = NINT(QX(IPTR))#                 Save temp. key                   MI06  78
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI06  79
ELSE#                                                                   MI06  80
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI06  81
BKEY = 0#                              Set key to overall b             MI06  82
IF(POINT(5) > 0)#                                                       MI06  83
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI06  84
IPTR = IPT + POINT(5)#                                                  MI06  85
ifnv:(QX(IPTR))  BKEY = 1#             Set key to isotropic             MI06  86
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI06  87
IF(POINT(6) > 0)#                      Betas take precedence            MI06  88
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI06  89
IPTR = IPT + POINT(6)#                                                  MI06  90
ifnv:(QX(IPTR))  BKEY = 2#             Set key to anisotropic           MI06  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI06  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI06  93
IF(BKEY == 0)#                         Overall b                        MI06  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI06  95
DO I=1,6#                              Set bij to voidflg:              MI06  96
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI06  97
ATPTR = ATPTR + 1#                     Bij at +4 to +9                  MI06  98
QX(ATPTR) = voidflg:#                                                   MI06  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI06 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI06 101
ELSE  IF(BKEY == 1)#                   Use isotropic b                  MI06 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI06 103
ATPTR = ATPTR + 1#                     B at +4                          MI06 104
IPTR = IPT + POINT(5)#                                                  MI06 105
QX(ATPTR) = QX(IPTR)*78.957#           Set iso b                        MI06 106
DO I=2,6#                              Set rest to voidflg:             MI06 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI06 108
ATPTR = ATPTR + 1#                     Void at +5 to +9                 MI06 109
QX(ATPTR) = voidflg:#                                                   MI06 110
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI06 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI06 112
ELSE  IF(BKEY == 2)#                   Set anisotropic b                MI06 113
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI06 114
DO I=6,11#                                                              MI06 115
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI06 116
IF(POINT(I) <= 0)  iquit:(MI0605)#     No anisotropic b                 MI06 117
ATPTR = ATPTR + 1#                     Betaij at +4 to +9               MI06 118
IPTR = IPT + POINT(I)#                                                  MI06 119
QX(ATPTR) = QX(IPTR)*TFCON(I-5)#       Convert uij to betaij            MI06 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI06 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI06 122
#                                                                       MI06 123
# STORE POP PARAMETER                                                   MI06 124
#                                                                       MI06 125
ATPTR = ATPTR + 1#                     Pp at +10                        MI06 126
QX(ATPTR) = 1.0#                                                        MI06 127
QX(ATPTR+1) = 1.0#                                                      MI06 128
IF(POINT(12) > 0)#                     If pp on bdf                     MI06 129
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI06 130
IPTR = IPT + POINT(12)#                                                 MI06 131
QX(ATPTR) = QX(IPTR)#                                                   MI06 132
IF(QX(ATPTR) <= 0.)  QX(ATPTR) = 1.0#  Make sure it's legal             MI06 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI06 134
#                                                                       MI06 135
# STORE ANOMALOUS POP PARAMETER                                         MI06 136
#                                                                       MI06 137
ATPTR = ATPTR + 1#                     Ppa at +11                       MI06 138
IF(POINT(13) > 0.)#                    If p.p.a. on bdf                 MI06 139
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI06 140
IPTR = IPT + POINT(13)#                                                 MI06 141
QX(ATPTR) = QX(IPTR)#                                                   MI06 142
IF(QX(ATPTR) <= 0.0)  QX(ATPTR) = 1.0#                                  MI06 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI06 144
#                                                                       MI06 145
# STORE SCATT FACTOR POINTER                                            MI06 146
#                                                                       MI06 147
ATPTR = ATPTR + 1#                     Scat fact n at +12               MI06 148
IF(POINT(14) <= 0)  iquit:(MI0606)#    No scattering factor pointer     MI06 149
IPTR = IPT + POINT(14)#                                                 MI06 150
QX(ATPTR) = QX(IPTR)*2 + FLOAT(STARFI-1)# Make pointer to pointer in    MI06 151
#                                                                       MI06 152
# STORE DATA SET NUMBER                                                 MI06 153
#                                                                       MI06 154
ATPTR = ATPTR +1#                      Data set n at +13 (stepat:)      MI06 155
QX(ATPTR)=voidflg:#                                                     MI06 156
IF(POINT(16)>0) QX(ATPTR)=QX(IPT+POINT(16))#                            MI06 157
#                                                                       MI06 158
# STORE ATOM LABEL                                                      MI06 159
#                                                                       MI06 160
ATPTR = ATPTR + 1#                     Atom label at +14 (stepat:+1)    MI06 161
IPTR = IPT + POINT(1)#                 Get pointer to atom label        MI06 162
movereal:(QX,IPTR,QX,ATPTR,stepan:,1)# Move it                          MI06 163
ATPTR = ATPTR + decr:(stepan:)#        End of atom packet length        MI06 164
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI06 165
#                                                                       MI06 166
RETURN#                                                                 MI06 167
END#                                                                    MI06 168
systemheader:(MI07)#                                                    MI07   1
# ################################################################## #  MI07   2
#                                                                    #  MI07   3
#                               MI07                                 #  MI07   4
#                                                                    #  MI07   5
# ################################################################## #  MI07   6
SUBROUTINE MI07#                                                        MI07   7
#                                                                       MI07   8
include:(AACOMN)#                                                       MI07   9
include:(MICOMN)#                                                       MI07  10
#                                                                       MI07  11
INTEGER ATPTR#                         Pointer to atom name in table    MI07  12
#                                         Of names on the bdf.          MI07  13
INTEGER I#                             An index                         MI07  14
INTEGER J#                             Another index                    MI07  15
INTEGER K#                             Yet another index                MI07  16
INTEGER QXPTR#                         Another atom parameter pointer   MI07  17
INTEGER RFPTR#                         Refinement key pointer           MI07  18
INTEGER SEQNO#                         Atom sequence number             MI07  19
INTEGER STARTM#                        Pointer to temporary storage     MI07  20
#                                         Of all atom parameters        MI07  21
#                                         Copied from the bdf.          MI07  22
REAL REFKEY(stepat:)#                  Flags indicating whether         MI07  23
#                                         To refine x,y,z,pp, and app.  MI07  24
datastuff:#                                                             MI07  25
#                                                                       MI07  26
# RE-INITIALIZE POINTERS                                                MI07  27
#                                                                       MI07  28
REFKEY(1)=1.;REFKEY(2)=1.;REFKEY(3)=1.;REFKEY(4)=0.;#                   MI07  29
REFKEY(5)=0.;REFKEY(6)=0.;REFKEY(7)=0.;REFKEY(8)=0.;#                   MI07  30
REFKEY(9)=0.;REFKEY(10)=1.;REFKEY(11)=1.;REFKEY(12)=0.;#                MI07  31
STARTM = STARAT#                       Save current location of atom    MI07  32
#                                         Parameters as read bdf        MI07  33
STARAT = STOPKB#                       Final location of atom           MI07  34
STOPAT = STARAT + NATIN*STEPAT#        Parameters that will be          MI07  35
STARAN = STARAT + stepat:#             Included in refinement.          MI07  36
STOPAN = STOPAT#                                                        MI07  37
STAREF = STOPAT#                       Start of refinement keys         MI07  38
STEPEF = stepat:#                                                       MI07  39
STOPEF = STAREF + NATIN*STEPEF#                                         MI07  40
#                                                                       MI07  41
# NOW, ON THE BASIS OF THE NUMBER OF ATOMS IN EACH DATA SET, SET        MI07  42
#  POINTERS TO THE START OF EACH GROUP OF ATOMS IN THE STARAT PART      MI07  43
#  OF QX.                                                               MI07  44
#                                                                       MI07  45
ATMPTR(1) = STARAT#                                                     MI07  46
REFPTR(1) = STAREF#                                                     MI07  47
DO I = 1,maxsets:#                                                      MI07  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI07  49
ATMPTR(I+1) = ATMPTR(I) + NUMAT(I)*STEPAT#                              MI07  50
REFPTR(I+1) = REFPTR(I) + NUMAT(I)*STEPEF#                              MI07  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI07  52
SEQNO = 0#                             Initialize sequence number       MI07  53
QXPTR = STARAT#                                                         MI07  54
#                                                                       MI07  55
DO I=2,NDATIN#                         Loop over data sets used         MI07  56
#                                         In this refinement.           MI07  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI07  58
DO J=1,NDAT#                           Loop over all data sets on       MI07  59
#                                         The bdf.                      MI07  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI07  61
IF(SEQDAT(J) != I)  NEXT#              Skip, if not being used          MI07  62
DO K=1,NAT#                            Loop over all atoms on the bdf   MI07  63
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI07  64
IF(ATSET(K) == J)#                     Does this atom belong to the     MI07  65
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI07  66
SEQNO = SEQNO + 1#                     Current set?  yes, increment     MI07  67
SEQAT(K) = SEQNO#                      And store the sequence number    MI07  68
ATPTR = STARTM + (K-1)*STEPAT#         Move the parameters and name     MI07  69
movereal:(QX,ATPTR+1,QX,QXPTR+1,STEPAT,1)# To the proper place.         MI07  70
QXPTR = QXPTR + STEPAT#                Advance sorted atom pointer      MI07  71
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI07  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI07  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI07  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI07  75
#                                                                       MI07  76
RFPTR = STAREF - STEPEF#               Set pointer to start of          MI07  77
#                                         Refinement keys.              MI07  78
FOR(I=STARAT; I < STOPAT; I=I+STEPAT)# Loop over all atoms              MI07  79
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI07  80
RFPTR = RFPTR + STEPEF#                Advance ref. key pointer         MI07  81
DO J=1,STEPEF#                         Store default refinement keys    MI07  82
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI07  83
QX(RFPTR+J)=REFKEY(J)#                                                  MI07  84
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI07  85
ifvo:(QX(I+4))  NEXT#                  If bov, go to next atom          MI07  86
QX(RFPTR+4) = 1.#                      Else refine isotropic b          MI07  87
ifvo:(QX(I+5))  NEXT#                  If isotropic, go to next atom    MI07  88
DO J=5,9#                              Else set aniso refinement keys   MI07  89
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI07  90
QX(RFPTR+J)=REFKEY(1)#                                                  MI07  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI07  92
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI07  93
#                                                                       MI07  94
RETURN#                                                                 MI07  95
END#                                                                    MI07  96
systemheader:(MI12)#                                                    MI12   1
# ################################################################## #  MI12   2
#                                                                    #  MI12   3
#                               MI12                                 #  MI12   4
#                                                                    #  MI12   5
# ################################################################## #  MI12   6
SUBROUTINE MI12(REF,DATNAM,ATNAM)#                                      MI12   7
#                                                                       MI12   8
# ROUTINE TO SCAN REF AND NOREF INPUT LINES AND SET                     MI12   9
#  REFINEMENT FLAGS FOR ATOMIC, SCALE AND THERMAL                       MI12  10
#  PARAMETER REFINEMENT IN THE QX ARRAY.                                MI12  11
#                                        19 dec 1979  r.a. alden        MI12  12
#                                        Updated sep 1980 k. watenpaugh MI12  13
#                                        Rewritten nov 1980  r.a. alden MI12  14
#    FIELD 1 == ALL/DATA SET NAME                                       MI12  15
#       (ALL IMPLIES ALL ATOMS AND/OR ALL DATA SETS)                    MI12  16
#    FIELD 2-N == BLANK/ATOM NAME/PARAMETER NAME                        MI12  17
#       (BLANK IMPLIES ALL ATOMIC PARAMETERS)                           MI12  18
#       ("BIJ" IMPLIES ALL ANISOTROPIC PARAMETERS)                      MI12  19
#                                                                       MI12  20
include:(AACOMN)#                                                       MI12  21
include:(MICOMN)#                                                       MI12  22
#                                                                       MI12  23
INTEGER ALLL#                          Flag set to yes:/no: if "all"    MI12  24
#                                         Found/not found.              MI12  25
INTEGER ANOW#                          Points to atom name on the bdf   MI12  26
INTEGER ANYPAR#                        Set to yes:/no: depending on     MI12  27
#                                         Whether any parameters have   MI12  28
#                                         Been affected already.        MI12  29
INTEGER ATNUM(maxatoms:)#              Set to yes: for each atom        MI12  30
#                                         Affected by current line.     MI12  31
INTEGER DATNUM(maxsets:)#              Set to yes: for each data set    MI12  32
#                                         Affected by the current line. MI12  33
INTEGER DNOW#                          Points to data set name on the   MI12  34
#                                         Bdf.                          MI12  35
INTEGER FIELD#                         Points to current field being    MI12  36
#                                         Processed.                    MI12  37
INTEGER FIRST#                         First character position in      MI12  38
#                                         Current field.                MI12  39
INTEGER LAST#                          Last character position plus     MI12  40
#                                         One in the current field.     MI12  41
INTEGER NCHAR#                         Number of characters found in    MI12  42
#                                         Field being processed.        MI12  43
INTEGER PARNUM(13)#                    Flag signifying whether a        MI12  44
#                                         Particular parameter is to be MI12  45
#                                         Affected.                     MI12  46
INTEGER PNOW#                          Flag set to yes:/no: if a        MI12  47
#                                         Valid parameter name found/   MI12  48
#                                         Not found.                    MI12  49
INTEGER PTR#                           Pointer into the qx array for    MI12  50
#                                         A refinement indicator.       MI12  51
INTEGER REF#                           Subroutine argument; set to      MI12  52
#                                         0/1 for ref/noref line.       MI12  53
string:(ATNAM,arith:(8,*,maxatoms:))#  Atom names on bdf                MI12  54
string:(DATNAM,arith:(12,*,maxsets:))# Dataset names on bdf             MI12  55
string:(WORD,12)#                      Holds characters in the          MI12  56
#                                         Current field.                MI12  57
chardata:(ALL,ALL)#                                                     MI12  58
chardata:(NAMES,X  Y  Z  B  B11B22B33B12B13B23PP PPAK  C  BIJ)#         MI12  59
datastuff:#                                                             MI12  60
#                                                                       MI12  61
DO PNOW=1,13#                          Clear parameter pointers         MI12  62
PARNUM(PNOW) = no:#                                                     MI12  63
DO DNOW=1,NDAT#                        Clear data set pointers          MI12  64
DATNUM(DNOW) = no:#                                                     MI12  65
DO ANOW=1,NAT#                         Clear atom pointers              MI12  66
ATNUM(ANOW) = no:#                                                      MI12  67
ANYPAR = no:#                          No parameters specified yet      MI12  68
#                                                                       MI12  69
IF(BUFIN(1) >= voidflg:)#                                               MI12  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI12  71
iquit:(-MI1201,1)#                     Must have character strings      MI12  72
RETURN#                                Or complain.                     MI12  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI12  74
#                                                                       MI12  75
stringlim:(1,FIRST,LAST)#              Locate start of and number       MI12  76
NCHAR = MIN0((LAST-FIRST),3)#          Of characters in the first       MI12  77
#                                         Field.                        MI12  78
movechar:(BLANK,1,WORD,1,12,1)#        Blank out word                   MI12  79
movechar:(CHRIN,FIRST,WORD,1,NCHAR,0)# Move field 1                     MI12  80
compchar:(WORD,1,ALL,1,3,3,3,ALLL)#    Look for string 'all'            MI12  81
IF(ALLL == yes:)#                      "all" was specified              MI12  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI12  83
DO DNOW=1,NDAT#                        All data sets are affected       MI12  84
IF(SEQDAT(DNOW) != no:)#               But only those which             MI12  85
DATNUM(DNOW) = yes:#                   Contribute to the refinement.    MI12  86
DO ANOW=1,NAT#                         All atoms are to be affected,    MI12  87
IF(SEQAT(ANOW) != no:)#                But only those which             MI12  88
ATNUM(ANOW) = yes:#                    Contribute to the refinement.    MI12  89
#                                                                       MI12  90
# LOOK AT THE REST OF THE FIELDS                                        MI12  91
FOR(FIELD=2; BUFIN(FIELD) < voidflg:; FIELD=FIELD+1)#                   MI12  92
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI12  93
stringlim:(FIELD,FIRST,LAST)#          Locate characters in field       MI12  94
NCHAR = MIN0((LAST-FIRST),3)#                                           MI12  95
movechar:(BLANK,1,WORD,1,3,1)#         Blank out word                   MI12  96
# MOVE THE FIELD                                                        MI12  97
movechar:(CHRIN,FIRST,WORD,1,NCHAR,0)#                                  MI12  98
# LOOK FOR A PARAMETER NAME                                             MI12  99
compchar:(WORD,1,NAMES,1,3,3,NNAMES,PNOW)#                              MI12 100
IF(PNOW == no:)#                       No valid parameter,              MI12 101
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI12 102
iquit:(-MI1202,FIELD)#                 So complain and leave.           MI12 103
RETURN#                                                                 MI12 104
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI12 105
#                                                                       MI12 106
ANYPAR = yes:#                         Note that at least 1             MI12 107
#                                         Parameter has been found.     MI12 108
IF(PNOW > 4)  PNOW = PNOW - 1#         Adjust pointer for b             MI12 109
IF(PNOW == 14)#                        If bij found,                    MI12 110
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI12 111
DO PNOW=4,9#                           Set all betas.                   MI12 112
PARNUM(PNOW) = yes:#                                                    MI12 113
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI12 114
#                                                                       MI12 115
ELSE  PARNUM(PNOW) = yes:#             Finally, set requested           MI12 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI12 117
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI12 118
#                                                                       MI12 119
ELSE#                                  Look for a data set name         MI12 120
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI12 121
NCHAR = MIN0((LAST-FIRST),12)#         May be up to 12 characters       MI12 122
movechar:(BLANK,1,WORD,1,12,1)#        Blank datset name for test       Aug93012
movechar:(CHRIN,FIRST,WORD,1,NCHAR,0)# Copy from noref line             Aug93013
upcase:(WORD,WORD,12)#                 Roll data set name to up case    Aug93014
#                                                                       MI12 124
# COMPARE WITH DATA SET NAMES USED IN THIS REFINEMENT                   MI12 125
compchar:(WORD,1,DATNAM,1,12,12,NDAT*12,DNOW)#                          Aug93015
IF(DNOW == no:)#                       If name isn't proper,            MI12 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI12 128
iquit:(-MI1203,1)#                     Complain and return.             MI12 129
RETURN#                                                                 MI12 130
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI12 131
#                                                                       MI12 132
IF(SEQDAT(DNOW) == no:)#               If requested name isn't          MI12 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI12 134
iquit:(-MI1204,1)#                     Part of this refinement,         MI12 135
RETURN#                                Complain and leave.              MI12 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI12 137
#                                                                       MI12 138
DATNUM(DNOW) = yes:#                   Note that this data set is       MI12 139
#                                         To be affected.               MI12 140
# LOOK AT THE REMAINING FIELDS                                          MI12 141
FOR(FIELD=2; BUFIN(FIELD) < voidflg:; FIELD=FIELD+1)#                   MI12 142
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI12 143
stringlim:(FIELD,FIRST,LAST)#          Find the first character         MI12 144
NCHAR = MIN0((LAST-FIRST),6)#          And the no. of characters.       MI12 145
movechar:(BLANK,1,WORD,1,8,1)#         Blank out the word.              MI12 146
movechar:(CHRIN,FIRST,WORD,1,NCHAR,0)# Move the word                    MI12 147
ncodefld:(FLOAT(DNOW),1,WORD,80223.,1)# Append the data set number      MI12 148
#                                                                       MI12 149
# COMPARE WITH ATOMS USED IN THIS REFINEMENT                            MI12 150
compchar:(WORD,1,ATNAM,1,8,8,NAT*8,ANOW)#                               MI12 151
IF(ANOW == no:)  BREAK#                It isn't an atom name            MI12 152
IF(SEQAT(ANOW) == no:)#                It's an illegal atom name        MI12 153
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI12 154
iquit:(-MI1205.,FIELD)#                So complain and get out.         MI12 155
RETURN#                                                                 MI12 156
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI12 157
ATNUM(ANOW) = yes:#                    Note that this atom is to        MI12 158
#                                         Be affected.                  MI12 159
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI12 160
IF(FIELD == 2)#                        If no atom names were on the     MI12 161
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI12 162
DO ANOW=1,NAT#                         Line, all atoms affected         MI12 163
IF(ATSET(ANOW) == DNOW)  ATNUM(ANOW) = yes:#                            MI12 164
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI12 165
#                                                                       MI12 166
ifnv:(BUFIN(FIELD))#                   Make sure the current field      MI12 167
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI12 168
REPEAT#                                Didn't terminate the line.       MI12 169
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI12 170
NCHAR = MIN0((LAST-FIRST),3)#          3-character fields               MI12 171
movechar:(BLANK,1,WORD,1,3,1)#         Blank out the word               MI12 172
movechar:(CHRIN,FIRST,WORD,1,NCHAR,0)# Move the field                   MI12 173
#                                                                       MI12 174
# LOOK FOR A VALID PARAMETER NAME                                       MI12 175
compchar:(WORD,1,NAMES,1,3,3,NNAMES,PNOW)#                              MI12 176
IF(PNOW == no:)#                       If name is illegal,              MI12 177
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI12 178
iquit:(-MI1202,FIELD)#                 Complain and return.             MI12 179
RETURN#                                                                 MI12 180
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI12 181
#                                                                       MI12 182
ANYPAR = yes:#                         At least 1 parameter has         MI12 183
#                                         Been specified.               MI12 184
IF(PNOW > 4)  PNOW = PNOW - 1#         Adjust for b                     MI12 185
IF(PNOW == 14)#                        For bij, set all betas           MI12 186
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI12 187
DO PNOW=4,9#                                                            MI12 188
PARNUM(PNOW) = yes:#                                                    MI12 189
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI12 190
#                                                                       MI12 191
ELSE  PARNUM(PNOW) = yes:#             Finally, set the indicator       MI12 192
FIELD = FIELD + 1#                     Get set for next field           MI12 193
IF(BUFIN(FIELD) >= voidflg:)  BREAK#                                    MI12 194
stringlim:(FIELD,FIRST,LAST)#          Find the first character         MI12 195
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI12 196
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI12 197
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI12 198
#                                                                       MI12 199
IF(ANYPAR == no:)#                     If no parameters specified       MI12 200
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MI12 201
DO PNOW=1,13#                          Yet, then set them all.          MI12 202
PARNUM(PNOW) = yes:#                                                    MI12 203
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MI12 204
#                                                                       MI12 205
DO DNOW=1,NDAT#                        For each param & dataset         MI12 206
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MI12 207
IF(SEQDAT(DNOW) == no:)  NEXT#         The correct k and delta b        MI12 208
IF(DATNUM(DNOW) == yes:)#              Refinement indicator in the      MI12 209
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MI12 210
DO PNOW=12,13#                         Qx array.                        MI12 211
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MI12 212
IF(PARNUM(PNOW) == no:)  NEXT#                                          MI12 213
PTR = STARKB + STEPKB*(SEQDAT(DNOW)-1) + 2*(PNOW-11)#                   MI12 214
QX(PTR) = FLOAT(REF)#                                                   MI12 215
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MI12 216
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MI12 217
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MI12 218
#                                                                       MI12 219
DO ANOW=1,NAT#                         For every parameter for          MI12 220
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MI12 221
IF(SEQAT(ANOW) == no:)  NEXT#          Every atom for every data        MI12 222
IF(ATNUM(ANOW) == yes:)#               Set, place the correct           MI12 223
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MI12 224
DO PNOW=1,11#                          Refinement indicator in the      MI12 225
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MI12 226
IF(PARNUM(PNOW) == no:)  NEXT#         Qx array.                        MI12 227
PTR = STAREF + STEPEF*(SEQAT(ANOW)-1) + PNOW#                           MI12 228
QX(PTR) = FLOAT(REF)#                                                   MI12 229
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MI12 230
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MI12 231
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MI12 232
#                                                                       MI12 233
RETURN#                                                                 MI12 234
END#                                                                    MI12 235
systemheader:(MI13)#                                                    MI13   1
# ################################################################## #  MI13   2
#                                                                    #  MI13   3
#                               MI13                                 #  MI13   4
#                                                                    #  MI13   5
# ################################################################## #  MI13   6
SUBROUTINE MI13#                       Process bins input line          MI13   7
#                                        Jul 1980  s. sheriff           MI13   8
#                                                                       MI13   9
include:(AACOMN)#                                                       MI13  10
include:(MICOMN)#                                                       MI13  11
#                                                                       MI13  12
INTEGER FIRST#                         Points to first character of     MI13  13
#                                         Current field.                MI13  14
INTEGER I#                             Do loop index                    MI13  15
INTEGER IUPDAT#                        Flag to indicate whether         MI13  16
#                                         Closure errors have been      MI13  17
#                                         Updated from input.           MI13  18
INTEGER KBPTR#                         Pointer to kb part of qx array   MI13  19
INTEGER LAST#                          Points to last character plus    MI13  20
#                                         One of current field.         MI13  21
INTEGER LCYC#                          Flag for whether to break        MI13  22
#                                         Statistics into all, centric, MI13  23
#                                         Or acentric when printing     MI13  24
#                                         The last cycle.               MI13  25
INTEGER NCHAR#                         Number of characters in the      MI13  26
#                                         Current field.                MI13  27
INTEGER NORMAL#                        Flag for whether to break        MI13  28
#                                         Statistics into all, centric, MI13  29
#                                         Or acentric when printing all MI13  30
#                                         Cycles except the last.       MI13  31
string:(PARAM,8)#                      Temporary storage to hold stat   MI13  32
#                                         Names for comparison.         MI13  33
chardata:(MI131, INPUT NUMBER OF STOL BINS WAS    .  THIS WOULD BE $#   MI13  34
GREATER THAN PAGE WIDTH.  RESET TO    STOL BINS.)#                      MI13  35
chardata:(MI132, NUMBER OF F**2 BINS TIMES NUMBER OF STOL BINS $#       MI13  36
GREATER THAN 50 TOTAL BINS.  NUMBER OF F**2 BINS RESET TO    .)#        MI13  37
chardata:(CENBN,ALL    CENTRIC)#                                        MI13  38
realdata:(FMT131,[340313.,880213.,1060213.])#                           MI13  39
datastuff:#                                                             MI13  40
#                                                                       MI13  41
# CHECK TO SEE IF CLOSURE ERRORS HAVE BEEN UPDATED FROM INPUT           MI13  42
#                                                                       MI13  43
IUPDAT = no:#                                                           MI13  44
KBPTR = STARKB + 5#                    Ptr to kb part of qx array       MI13  45
#                                                                       MI13  46
DO I=1,NDATIN#                                                          MI13  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI13  48
IF(QX(KBPTR) >= 10000.)  IUPDAT = yes:## Isomorphous updated            MI13  49
IF(QX(KBPTR+1) >= 10000.)  IUPDAT = yes:# Anomalous updated             MI13  50
KBPTR = KBPTR + STEPKB#                Increment pointer                MI13  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI13  52
#                                                                       MI13  53
# CHANGE NUMBER OF STOL BINS                                            MI13  54
#                                                                       MI13  55
IF(BUFIN(1) >= 1.0)#                   Must request a min. of 1 bin     MI13  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI13  57
IF(IUPDAT == yes:)#                    Return if closure errors         MI13  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI13  59
iquit:(-MI1301,1)#                     Changed.                         MI13  60
RETURN#                                                                 MI13  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI13  62
#                                                                       MI13  63
NBIN = NINT(BUFIN(1))#                                                  MI13  64
NBIN = MIN0(NBIN,(mxchln:/10))#        Dont allow more bins             MI13  65
#                                         Than page width.              MI13  66
IF(NBIN != NINT(BUFIN(1)))#            Print warning                    MI13  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI13  68
movechar:(MI131,1,CHROT,1,NMI131,0)#                                    MI13  69
BUFOT(1) = BUFIN(1)#                                                    MI13  70
BUFOT(2) = FLOAT(NBIN)#                                                 MI13  71
ncodefld:(BUFOT,1,CHROT,FMT131(1),2)#                                   MI13  72
writeline:(1,0,0,1,3)#                                                  MI13  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI13  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI13  75
#                                                                       MI13  76
# CHANGE NUMBER OF F**2 BINS                                            MI13  77
#                                                                       MI13  78
IF(BUFIN(2) >= 1.0)#                   Must request at least one bin    MI13  79
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI13  80
IF(IUPDAT == yes:)#                    Return if closure errors         MI13  81
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI13  82
iquit:(-MI1301,2)#                     Changed.                         MI13  83
RETURN#                                                                 MI13  84
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI13  85
#                                                                       MI13  86
NFBIN = NINT(BUFIN(2))#                                                 MI13  87
NFBIN = MIN0(NFBIN,12)#                Maximum 12 bins (arbitrary)      MI13  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI13  89
IF((NBIN*NFBIN) > 50)#                 Check if storage ok              MI13  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI13  91
NFBIN = 50/NBIN#                       Get max. that can be handled     MI13  92
movechar:(MI132,1,CHROT,1,NMI132,0)#                                    MI13  93
BUFOT(1) = FLOAT(NFBIN)#                                                MI13  94
ncodefld:(BUFOT,1,CHROT,FMT131(3),1)#                                   MI13  95
writeline:(1,0,0,1,3)#                                                  MI13  96
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI13  97
#                                                                       MI13  98
# DETERMINE WHETHER LISTING SHOULD INCLUDE ALL,CENTRIC, ACENTRIC        MI13  99
#  OR JUST ALL FOR CYCLES OTHER THAN LAST.                              MI13 100
#                                                                       MI13 101
IF(BUFIN(3) < voidflg:)#                                                MI13 102
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI13 103
stringlim:(3,FIRST,LAST)#                                               MI13 104
NCHAR = MIN0((LAST-FIRST),8)#                                           MI13 105
movechar:(BLANK,1,PARAM,1,8,1)#                                         MI13 106
movechar:(CHRIN,FIRST,PARAM,1,NCHAR,0)#                                 MI13 107
compchar:(PARAM,1,CENBN,1,7,7,NCENBN,NORMAL)#                           MI13 108
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI13 109
IF(NORMAL == 0)  NORMAL = 1#                                            MI13 110
#                                                                       MI13 111
# DETERMINE WHETHER LISTING SHOULD INCLUDE ALL,CENTRIC, ACENTRIC        MI13 112
#  OR JUST ALL FOR LAST CYCLE                                           MI13 113
#                                                                       MI13 114
IF(BUFIN(4) < voidflg:)#                                                MI13 115
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI13 116
stringlim:(4,FIRST,LAST)#                                               MI13 117
NCHAR = MIN0((LAST-FIRST),8)#                                           MI13 118
movechar:(BLANK,1,PARAM,1,8,1)#                                         MI13 119
movechar:(CHRIN,FIRST,PARAM,1,NCHAR,0)#                                 MI13 120
compchar:(PARAM,1,CENBN,1,7,7,NCENBN,LCYC)#                             MI13 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI13 122
#                                                                       MI13 123
IF(LCYC == 0)  LCYC = 2#                                                MI13 124
#                                                                       MI13 125
NCBIN = LCYC*10 + NORMAL#              Pack away information            MI13 126
#                                                                       MI13 127
RETURN#                                                                 MI13 128
END#                                                                    MI13 129
systemheader:(MI14)#                                                    MI14   1
# ################################################################## #  MI14   2
#                                                                    #  MI14   3
#                               MI14                                 #  MI14   4
#                                                                    #  MI14   5
# ################################################################## #  MI14   6
SUBROUTINE MI14#                                                        MI14   7
#                                                                       MI14   8
# ROUTINE TO READ IN ANY PHASE INFORMATION KNOWN BEFORE                 MI14   9
#  REFINEMENT BEGINS.                                                   MI14  10
# PROCESSES FAZIN LINE                                                  MI14  11
include:(AACOMN)#                                                       MI14  12
include:(MICOMN)#                                                       MI14  13
#                                                                       MI14  14
chardata:(MI142,INI COM )#             Fazin options                    MI14  15
chardata:(MSG1, INITIAL PHASES FROM PHASE SET =     )#                  MI14  16
chardata:(MSG2, COMBINE PHASES WITH PHASES FROM PHASE SET =     )#      MI14  17
datastuff:#                                                             MI14  18
#                                                                       MI14  19
#  CHECK FOR OPTIONS ON THE FAZIN LINE                                  MI14  20
FOR (I=1; BUFIN(I)!=voidflg:; I=I+1)#                                   MI14  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI14  22
stringlim:(I,IC1,IC2)#                                                  MI14  23
NCH = MIN0(IC2-IC1,3)#                                                  MI14  24
compchar:(CHRIN,IC1,MI142,1,3,4,NMI142,KEY)#                            MI14  25
IF (KEY == 1)#                         Set initial phase set            MI14  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI14  27
ifvo:(BUFIN(I+1)) FAZSET = 1.0#        Default to phase set 1           MI14  28
ELSE#                                                                   MI14  29
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI14  30
FAZSET = BUFIN(I+1)#                                                    MI14  31
I = I + 1#                                                              MI14  32
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI14  33
FAZFM1 = 700 + (NINT(FAZSET)-1)*5#     Figure of merit                  MI14  34
FAZA1 = FAZFM1 + 1#                    Best cos(phase)                  MI14  35
FAZB1 = FAZFM1 + 2#                    Best sin(phase)                  MI14  36
ncodefld:(FAZSET,1,MSG1,370513.,1)#                                     MI14  37
writeline:(1,MSG1,NMSG1,3,3)#                                           MI14  38
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI14  39
IF (KEY == 2)#                         Set combination phase set        MI14  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI14  41
ifvo:(BUFIN(I+1)) FAZSET = 2.0#        Default to phase set 2           MI14  42
ELSE#                                                                   MI14  43
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI14  44
FAZSET = BUFIN(I+1)#                                                    MI14  45
I = I + 1#                                                              MI14  46
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI14  47
FAZFM2 = 700 + (NINT(FAZSET)-1)*5#     Figure of merit                  MI14  48
FAZA2 = FAZFM2 + 1#                    Best cos(phase)                  MI14  49
FAZB2 = FAZFM2 + 2#                    Best sin(phase)                  MI14  50
ncodefld:(FAZSET,1,MSG2,470513.,1)#                                     MI14  51
writeline:(1,MSG2,NMSG2 ,3,3)#                                          MI14  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI14  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI14  54
#                                                                       MI14  55
RETURN#                                                                 MI14  56
END#                                                                    MI14  57
systemheader:(MI15)#                                                    MI15   1
# ################################################################## #  MI15   2
#                                                                    #  MI15   3
#                               MI15                                 #  MI15   4
#                                                                    #  MI15   5
# ################################################################## #  MI15   6
SUBROUTINE MI15#                                                        MI15   7
#                                                                       MI15   8
# PROGRAM TO READ MVFC (MINIMUM VARIANCE FOURIER COEFFICENT)            MI15   9
#  PARAMETERS FROM MVFC INPUT LINE.                                     MI15  10
#                                        Jun 1980  j.m. stewart and     MI15  11
#                                                  J. sygusch           MI15  12
#                                        Updated aug 1980  s. sheriff   MI15  13
include:(AACOMN)#                                                       MI15  14
include:(MICOMN)#                                                       MI15  15
#                                                                       MI15  16
INTEGER FIRST#                         Pointer to first character in    MI15  17
#                                         Current field.                MI15  18
INTEGER I#                             An index                         MI15  19
INTEGER LASTP1#                        Pointer to last character plus   MI15  20
#                                         One in the current field.     MI15  21
INTEGER NCHAR#                         Number of characters in field    MI15  22
INTEGER INC#                           Trial phase increment            MI15  23
chardata:(MI151, STEP SIZE INPUT     IS NOT AN EVEN DIVISOR OF $# M     MI15  24
360.  IT WILL BE RESET.)#                                               MI15  25
chardata:(MI152,NEWPHASES)#                                             MI15  26
realdata:(FMT151,[190213.])#                                            MI15  27
datastuff:#                                                             MI15  28
#                                                                       MI15  29
IF(FAZTYP != none:)#                   Return, if already specified     MI15  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI15  31
iquit:(-MI1501)#                                                        MI15  32
RETURN#                                                                 MI15  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI15  34
#                                                                       MI15  35
FAZTYP = mvfc:#                        Signal type of refinement        MI15  36
IFPROB = no:#                          No such thing as most            MI15  37
#                                         Probable phase in mvfc.       MI15  38
# SET PHASING INCREMENTS                                                MI15  39
#                                                                       MI15  40
IF(BUFIN(1) < 1.0)  PHSINC = 10#                                        MI15  41
ELSE  PHSINC = NINT(AMIN1(BUFIN(1),180.))#                              MI15  42
#                                                                       MI15  43
# PROTECT AGAINST UNEVEN DIVISOR OF 360 FOR PHASE INCREMENT             MI15  44
#                                                                       MI15  45
IF(MOD(360,PHSINC) != 0)#                                               MI15  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI15  47
movechar:(MI151,1,CHROT,1,NMI151,0)#                                    MI15  48
BUFOT(1) = FLOAT(PHSINC)#                                               MI15  49
ncodefld:(BUFOT,1,CHROT,FMT151,1)#                                      MI15  50
writeline:(1,0,0,1,3)#                                                  MI15  51
DO I=1,180#                                                             MI15  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI15  53
INC = PHSINC - I#                                                       MI15  54
IF(MOD(360,INC) == 0)  BREAK#                                           MI15  55
INC = PHSINC + I#                                                       MI15  56
IF(MOD(360,INC) == 0)  BREAK#                                           MI15  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI15  58
PHSINC = INC#                                                           MI15  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI15  60
#                                                                       MI15  61
# SET WEAK REFLECTION CUT-OFF VALUE                                     MI15  62
#                                                                       MI15  63
IF(BUFIN(2) <= 0.0)  SIGCUT = 2.5#                                      MI15  64
ELSE  SIGCUT = BUFIN(2)#                                                MI15  65
#                                                                       MI15  66
# PHASE REFINEMENT CRITERION SELECTION                                  MI15  67
#                                                                       MI15  68
IF(BUFIN(3) <= 0.0)  REFCUT = 1.0#                                      MI15  69
ELSE  REFCUT = BUFIN(3)#                                                MI15  70
#                                                                       MI15  71
# SHIFT FACTOR FOR PHASES                                               MI15  72
#                                                                       MI15  73
IF((BUFIN(4) <= 0.0) \ (BUFIN(4) > 10.0))  PHSHFT = 1.0#                MI15  74
ELSE  PHSHFT = BUFIN(4)#                                                MI15  75
#                                                                       MI15  76
# MAXIMUM DIFFERENCE IN DEGREES FOR ACCEPTING BIMODAL SIR SOLUTION      MI15  77
#                                                                       MI15  78
IF((BUFIN(5) <= 0.1) \ (BUFIN(5) >= 180.0))  BIMODL = 179.0#            MI15  79
ELSE  BIMODL = BUFIN(5)#                                                MI15  80
BIMODL = BIMODL/2.#                                                     MI15  81
#                                                                       MI15  82
# VALUE FOR THE GOODNESS OF FIT PARAMETER TO BE USED DURING THE         MI15  83
#  INITIAL CYCLE OF THIS RUN.  THIS AFFECTS THE CALCULATION OF THE      MI15  84
#  FIGURE OF MERIT AND IS INITIALIZED TO 100. IN DATIN OR STARTX.       MI15  85
#  ITS CURRENT VALUE IS STORED ON THE BDF IN LRCELL:, PACKET 6, WORD 5. MI15  86
#                                                                       MI15  87
IF(BUFIN(6) >= 1.)  GOFPRV = BUFIN(6)#                                  MI15  88
ifvo:(GOFPRV)  GOFPRV = 100.#                                           MI15  89
#                                                                       MI15  90
# CONTROL FOR "ALTERNATE" METHOD OF PHASING.  IF FIELD 7 CONTAINS       MI15  91
#   ANY PART OF THE STRING "NEWPHASES", THE 'ALTERNATE' METHOD OF       MI15  92
#   PHASE ESTIMATION WILL BE USED IN MI61.  THE PHASES ALREADY ON THE   MI15  93
#   BDF WILL BE IGNORED AND THE INITIAL PHASES WILL BE OBTAINED BY      MI15  94
#   'GOING AROUND THE PHASE CIRCLE'.                                    MI15  95
#                                                                       MI15  96
IF(BUFIN(7) < voidflg:)#               If characters in field 7,        MI15  97
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI15  98
stringlim:(7,FIRST,LASTP1)#            "newphases", and take            MI15  99
NCHAR = MIN0((LASTP1-FIRST),NMI152)#   Appropriate action.              MI15 100
compchar:(CHRIN,FIRST,MI152,1,NCHAR,NCHAR,NCHAR,NUMVPH)#                MI15 101
IF(NUMVPH == 0)  iquit:(-MI1502)#                                       MI15 102
ELSE NUMVPH = yes:#                                                     MI15 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI15 104
ELSE NUMVPH = no:#                     Default condition is to use      MI15 105
#                                         Any phases present on the bdf MI15 106
#                                         For the initial estimate.     MI15 107
RETURN#                                                                 MI15 108
END#                                                                    MI15 109
systemheader:(MI16)#                                                    MI16   1
# ################################################################## #  MI16   2
#                                                                    #  MI16   3
#                               MI16                                 #  MI16   4
#                                                                    #  MI16   5
# ################################################################## #  MI16   6
SUBROUTINE MI16#                                                        MI16   7
#                                                                       MI16   8
# READ IN PHASE PROBABILITY PARAMETERS BEFORE REFINEMENT BEGINS.        MI16   9
#  GET STEP SIZE, IF AVAILABLE.  GET PHASE TO REFINE AND COLLECT        MI16  10
#  STATISTICS ON.                                                       MI16  11
#                                        May 1980  j.m stewart          MI16  12
#                                        Sep 1980  s. sheriff           MI16  13
include:(AACOMN)#                                                       MI16  14
include:(MICOMN)#                                                       MI16  15
#                                                                       MI16  16
INTEGER BEST#                          = 1, if "best" was found by      MI16  17
#                                         Compchar:.                    MI16  18
INTEGER FIRST#                         Points to first character of     MI16  19
#                                         Data set name.                MI16  20
INTEGER I#                             Loop index                       MI16  21
INTEGER INC#                           Phase increment when searching   MI16  22
#                                         For new value.                MI16  23
INTEGER LASTP1#                        Points to last character plus    MI16  24
#                                         One of data set name.         MI16  25
INTEGER NCHAR#                         Number of characters in data     MI16  26
#                                         Set name.                     MI16  27
chardata:(MI161, STEP SIZE INPUT OF    IS NOT AN EVEN DIVISOR OF $#     MI16  28
180.  IT WILL BE RESET.)#                                               MI16  29
chardata:(MI162,BEST)#                                                  MI16  30
realdata:(FMT161,[220213.])#                                            MI16  31
datastuff:#                                                             MI16  32
#                                                                       MI16  33
IF(FAZTYP != none:)#                   If type is already set,          MI16  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI16  35
iquit:(-MI1601)#                       That's illegal.                  MI16  36
RETURN#                                                                 MI16  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI16  38
#                                                                       MI16  39
PHSINC = 5#                            Set acentric reflection phase    MI16  40
#                                         Stepper to default value.     MI16  41
FAZTYP = fazprb:#                      Signal phasing method            MI16  42
#                                                                       MI16  43
# TEST TO SEE IF THE USER WISHES TO SUPERCEDE THE STEP SIZE.            MI16  44
#  REQUESTS FOR STEPS SMALLER THAN 1 DEGREE ARE TREATED AS 5 DEGREES,   MI16  45
#  BUT IN NO CASE GREATER THAN 180 DEGREES. PROTECT FROM                MI16  46
#  UNEQUALLY SPACED STEPS.                                              MI16  47
#                                                                       MI16  48
IF(BUFIN(1) >= 1.0)  PHSINC = NINT(AMIN1(BUFIN(1),180.0))#              MI16  49
IF(MOD(180,PHSINC) != 0)#                                               MI16  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI16  51
movechar:(MI161,1,CHROT,1,NMI161,0)#   Tell user we are going to        MI16  52
BUFOT(1) = FLOAT(PHSINC)#              Change step size.                MI16  53
ncodefld:(BUFOT,1,CHROT,FMT161,1)#                                      MI16  54
writeline:(1,0,0,1,3)#                                                  MI16  55
#                                                                       MI16  56
DO I=1,180#                            Find closest even divisor        MI16  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI16  58
INC = PHSINC - I#                      Check for smaller value first    MI16  59
IF(MOD(180,INC) == 0)  BREAK#                                           MI16  60
INC = PHSINC + I#                      Now check larger value           MI16  61
IF(MOD(180,INC) == 0)  BREAK#                                           MI16  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI16  63
PHSINC = INC#                                                           MI16  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI16  65
#                                                                       MI16  66
# CHOOSE PHASE FOR REFINEMENT AND STATISTICS CALCULATION                MI16  67
#                                                                       MI16  68
IF(BUFIN(2) < voidflg:)#                                                MI16  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI16  70
stringlim:(2,FIRST,LASTP1)#            Determine no. of characters      MI16  71
NCHAR = MIN0((LASTP1-FIRST),4)#                                         MI16  72
compchar:(CHRIN,FIRST,MI162,1,4,4,4,BEST)#                              MI16  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI16  74
#                                                                       MI16  75
IF(BEST == yes:)  IFPROB = no:#                                         MI16  76
ELSE  IFPROB = yes:#                                                    MI16  77
#                                                                       MI16  78
RETURN#                                                                 MI16  79
END#                                                                    MI16  80
systemheader:(MI17)#                                                    MI17   1
# ################################################################## #  MI17   2
#                                                                    #  MI17   3
#                               MI17                                 #  MI17   4
#                                                                    #  MI17   5
# ################################################################## #  MI17   6
SUBROUTINE MI17(ICD,DNOW,IBNCHK,JFBIN,CLOSUR)#                          MI17   7
#                                                                       MI17   8
# PROCESS OPTIONAL EISO LINES; GET NEW ISOMORPHOUS CLOSURE ERRORS       MI17   9
#  PROCESS OPTIONAL EANO LINES; GET NEW ANOMALOUS CLOSURE ERRORS        MI17  10
#                                        Jun 1980  s. sheriff           MI17  11
#                                        Updated jan 1981  s. sheriff   MI17  12
include:(AACOMN)#                                                       MI17  13
include:(MICOMN)#                                                       MI17  14
#                                                                       MI17  15
INTEGER CLOPTR#                        Pointer to closure error part    MI17  16
#                                         Of kb part of qx array.       MI17  17
INTEGER DNOW#                          Data set number                  MI17  18
INTEGER IBNCHK(1)#                     Check to make sure same bin is   MI17  19
#                                         Not updated twice.            MI17  20
INTEGER ICD#                           1 if eiso line, 2 if eano line   MI17  21
INTEGER IBNPTR#                        Pointer to ibnchk                MI17  22
INTEGER IEND#                          Total number of bins =           MI17  23
#                                         Nbin*nfbin.                   MI17  24
INTEGER J#                             Loop index                       MI17  25
INTEGER JBIN#                          Number of closure errors on      MI17  26
#                                         Input line.                   MI17  27
INTEGER JFBIN#                         F**2 bin number on input line    MI17  28
INTEGER K#                             Another loop index               MI17  29
INTEGER KBPTR#                         Pointer to number of bins in     MI17  30
#                                         Kb part of qx array.          MI17  31
REAL CLOSUR(13)#                       Input values from closure        MI17  32
#                                         Error lines.                  MI17  33
# SET POINTERS DEPENDING ON WHETHER ISOMORPHOUS OR ANOMALOUS            MI17  34
#                                                                       MI17  35
KBPTR = STARKB + (DNOW-1)*STEPKB + 5#  Point to number of stol bins     MI17  36
IF(ICD == 1)#                          Isomorphous                      MI17  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI17  38
# POINT TO ISOMORPHOUS CLOSURE ERROR                                    MI17  39
CLOPTR = STARKB + (DNOW-1)*STEPKB + binstart: + 1#                      MI17  40
IBNPTR = 1#                                                             MI17  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI17  42
#                                                                       MI17  43
ELSE#                                  Anomalous closure errors         MI17  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI17  45
# POINT TO THE ERRORS                                                   MI17  46
CLOPTR = STARKB + (DNOW-1)*STEPKB + binstart: + 51#                     MI17  47
IBNPTR = 16#                                                            MI17  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI17  49
#                                                                       MI17  50
# IN THE FOLLOWING WE FIRST ESTABLISH THAT:                             MI17  51
#   1) WE HAVE A LEGITIMATE VALUE FOR THE F**2 BIN NUMBER.              MI17  52
#   2) WE HAVE A LEGITIMATE VALUE FOR THE NUMBER OF STOL BINS.          MI17  53
#                                                                       MI17  54
# WE THEN PROCESS ON THE FOLLOWING BASIS:                               MI17  55
#   1) IF THE F**2 BIN NUMBER IS 0 (THIS MEANS THAT WE REPLACE ALL      MI17  56
#      VALUES OF THE CLOSURE ERROR WITH THE NEW ONE(S).                 MI17  57
#        A) IF ONLY ONE STOL VALUE WE REPLACE ALL THE CURRENT           MI17  58
#           VALUES WITH IT.                                             MI17  59
#        B) IF MORE THAN ONE STOL VALUE WE REPLACE WITH THE ARRAY       MI17  60
#           THROUGH ALL OF THE CURRENT F**2 BINS.                       MI17  61
#   2) IF THE F**2 BINS NUMBER IS OTHER THAN 0.                         MI17  62
#        A) IF ONLY ONE STOL VALUE WE REPLACE ALL THE STOL BINS WITHIN  MI17  63
#           THAT F**2 BIN WITH THE STOL VALUE.                          MI17  64
#        B) IF MORE THAN ONE STOL VALUE WE REPLACE CORRESPONDINGLY.     MI17  65
#                                                                       MI17  66
# A FLAG OF 10000. FOR EACH F**2 BIN WHICH HAS BEEN UPDATED IS ADDED    MI17  67
#  TO QX(STARKB + (DNOW-1)*STEPKB +5) FOR ISOMORPHOUS CLOSURE ERRORS    MI17  68
#  AND TO QX(STARKB + (DNOW-1)*STEPKB + 6) FOR ANOMALOUS CLOSURE ERRORS MI17  69
#                                                                       MI17  70
IF(JFBIN < 0. \ JFBIN > NFBIN)#                                         MI17  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI17  72
iquit:(-MI1701,2)#                                                      MI17  73
RETURN#                                                                 MI17  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI17  75
#                                                                       MI17  76
IBNPTR = (DNOW-1)*30 + JFBIN + IBNPTR#                                  MI17  77
IF(IBNCHK(IBNPTR) == yes:)#                                             MI17  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI17  79
iquit:(-MI1702)#                                                        MI17  80
RETURN#                                                                 MI17  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI17  82
#                                                                       MI17  83
ELSE  IBNCHK(IBNPTR) = yes:#                                            MI17  84
#                                                                       MI17  85
IF(QX(KBPTR+1) < 10000.)  QX(KBPTR+1) = 10000.# Flag as updated         MI17  86
#                                                                       MI17  87
# DETERMINE NUMBER OF CLOSURE ERRORS ON LINE, HENCE NUMBER OF STOL BINS MI17  88
#                                                                       MI17  89
JBIN = 0#                                                               MI17  90
DO J=1,13#                                                              MI17  91
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI17  92
IF(CLOSUR(J) <= small:)  BREAK#                                         MI17  93
JBIN = JBIN + 1#                                                        MI17  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI17  95
IF(JBIN == 0)#                                                          MI17  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI17  97
iquit:(-MI1703)#                                                        MI17  98
RETURN#                                                                 MI17  99
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI17 100
#                                                                       MI17 101
IF(JBIN != 1 & JBIN != NBIN)#                                           MI17 102
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI17 103
iquit:(-MI1704)#                                                        MI17 104
RETURN#                                                                 MI17 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI17 106
#                                                                       MI17 107
QX(KBPTR) = 10000. + FLOAT(NBIN)#      Set stol bin counter             MI17 108
#                                                                       MI17 109
IF(JFBIN == 0)#                        Replace all f**2 bins            MI17 110
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI17 111
QX(KBPTR+1) = QX(KBPTR+1) + FLOAT(NFBIN)# Add flag                      MI17 112
IF(JBIN == 1)#                         Replace all stol bins            MI17 113
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI17 114
IEND = NFBIN*NBIN#                     Total number of bins             MI17 115
DO K=1,IEND#                           Over all bins                    MI17 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI17 117
QX(CLOPTR) = CLOSUR(1)**2#             Values stored (and used          MI17 118
CLOPTR = CLOPTR + 1#                   Internally) squared.             MI17 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI17 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI17 121
#                                                                       MI17 122
ELSE#                                  Replace stol bins                MI17 123
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI17 124
DO J=1,NFBIN#                          Loop over all f**2 bins          MI17 125
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI17 126
DO K=1,NBIN#                           Loop over all stol bins          MI17 127
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI17 128
QX(CLOPTR) = CLOSUR(K)**2#             Values stored (and used          MI17 129
CLOPTR = CLOPTR + 1#                   Internally) squared.             MI17 130
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI17 131
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI17 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI17 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI17 134
#                                                                       MI17 135
ELSE#                                  Replace only one f**2 bin        MI17 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI17 137
QX(KBPTR+1) = QX(KBPTR+1) + 1.#        Add flag                         MI17 138
CLOPTR = CLOPTR + (JFBIN-1)*NBIN#      Adjust pointer to                MI17 139
#                                         Proper f**2 bin.              MI17 140
IF(JBIN == 1)#                         Replace all stol bins            MI17 141
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI17 142
DO K=1,NBIN#                           Loop over all stol bins          MI17 143
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MI17 144
QX(CLOPTR) = CLOSUR(1)**2#             Values stored (and used          MI17 145
CLOPTR = CLOPTR + 1#                   Internally) squared.             MI17 146
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MI17 147
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI17 148
#                                                                       MI17 149
ELSE#                                  Replace stol bins                MI17 150
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MI17 151
DO K=1,NBIN#                           Loop over all stol bins          MI17 152
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MI17 153
QX(CLOPTR) = CLOSUR(K)**2#             Values stored (and used          MI17 154
CLOPTR = CLOPTR + 1#                   Internally) squared.             MI17 155
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MI17 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MI17 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI17 158
#                                                                       MI17 159
RETURN#                                                                 MI17 160
END#                                                                    MI17 161
systemheader:(MI18)#                                                    MI18   1
# ################################################################## #  MI18   2
#                                                                    #  MI18   3
#                               MI18                                 #  MI18   4
#                                                                    #  MI18   5
# ################################################################## #  MI18   6
SUBROUTINE MI18(ITYPE)#                Process stat and nostat lines    MI18   7
#                                        Jul 1980  s. sheriff           MI18   8
#                                        Revised sep 1980  s. sheriff   MI18   9
include:(AACOMN)#                                                       MI18  10
include:(MICOMN)#                                                       MI18  11
#                                                                       MI18  12
INTEGER FIRST#                         Pointer to first character of    MI18  13
#                                         The current field.            MI18  14
INTEGER I#                             Loop index                       MI18  15
INTEGER ISTPTR#                        Pointer to the starst part of    MI18  16
#                                         The qx array.                 MI18  17
INTEGER ITYPE#                         Flag to indicate whether line    MI18  18
#                                         Was stat (=1) or nostat (=2). MI18  19
INTEGER J#                             Loop index                       MI18  20
INTEGER LASTP1#                        Pointer to last character plus   MI18  21
#                                         One on current field.         MI18  22
INTEGER MATCH#                         Flag whether a match was found   MI18  23
#                                         By stringlim:.                MI18  24
INTEGER NCHAR#                         Number of characters in          MI18  25
#                                         Current field.                MI18  26
INTEGER NUMSTA#                        Number of statistical types      MI18  27
REAL ALEVEL#                           Flag at what level this          MI18  28
#                                         Statistic should be printed.  MI18  29
chardata:(MI181,ALL     LSTCYC  )#                                      MI18  30
chardata:(MI182,FOMHIST FOM     PARVAR  RCULLIS RKRAUT  RFAZPWR $#      MI18  31
WTEISO  WTEANO  NUMBER  FAZDIF  ERMSISO EISOADJ )#                      MI18  32
chardata:(MI183,ISODIF  HAMODEL JNTVAR  ERMSANO EANOADJ ANODIF  $#      MI18  33
SIGNS   )#                                                              MI18  34
datastuff:#                                                             MI18  35
NUMSTA = STOPST - STARST#              Get number of statistical        MI18  36
#                                         Types.                        MI18  37
IF(ITYPE == yes:)  ALEVEL = 2.#        Stat line                        MI18  38
ELSE  ALEVEL = 0.0#                    Nostat line                      MI18  39
#                                                                       MI18  40
FOR(J=1; BUFIN(J) < voidflg:; J=J+1)#  Scan to first void field         MI18  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI18  42
stringlim:(J,FIRST,LASTP1)#                                             MI18  43
NCHAR = MIN0((LASTP1-FIRST),8)#                                         MI18  44
compchar:(CHRIN,FIRST,MI181,1,8,8,NMI181,MATCH)#                        MI18  45
IF(MATCH == 0)#                        Not in mi181; is it in mi182?    MI18  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI18  47
compchar:(CHRIN,FIRST,MI182,1,8,8,NMI182,MATCH)#                        MI18  48
IF(MATCH != 0) MATCH = MATCH + 2#                                       MI18  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI18  50
#                                                                       MI18  51
IF(MATCH == 0)#                        Not in mi182; is it in mi183?    MI18  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI18  53
compchar:(CHRIN,FIRST,MI183,1,8,8,NMI183,MATCH)#                        MI18  54
IF(MATCH != 0) MATCH = MATCH + 14#                                      MI18  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI18  56
#                                                                       MI18  57
IF(MATCH == 0)  iquit:(-MI1801,J)#     No match, complain               MI18  58
ELSE  IF(MATCH == 1)#                  All                              MI18  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI18  60
DO I=1,NUMSTA#                         Change all to this output        MI18  61
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI18  62
ISTPTR = STARST + I#                   Level.                           MI18  63
QX(ISTPTR) = ALEVEL#                                                    MI18  64
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI18  65
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI18  66
#                                                                       MI18  67
ELSE  IF(MATCH == 2)#                  Lstcyc                           MI18  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI18  69
IF(ITYPE == yes:)  ALEVEL = 1.0#       If "stat" line, set alevel       MI18  70
#                                         Accordingly.                  MI18  71
IF(BUFIN(J+1) >= voidflg:)#            If no names follow, change all   MI18  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI18  73
DO I=1,NUMSTA#                                                          MI18  74
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI18  75
ISTPTR = STARST + I#                                                    MI18  76
IF(NINT(QX(ISTPTR)) != 2)  QX(ISTPTR) = ALEVEL#                         MI18  77
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI18  78
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI18  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI18  80
#                                                                       MI18  81
ELSE  IF(MATCH ==  3)  QX(STARST+ 1) = ALEVEL# Fomhist                  MI18  82
ELSE  IF(MATCH ==  4)  QX(STARST+ 2) = ALEVEL# Fom                      MI18  83
ELSE  IF(MATCH ==  5)  QX(STARST+ 3) = ALEVEL# Parvar                   MI18  84
ELSE  IF(MATCH ==  6)  QX(STARST+ 4) = ALEVEL# Rcullis                  MI18  85
ELSE  IF(MATCH ==  7)  QX(STARST+ 5) = ALEVEL# Rkraut                   MI18  86
ELSE  IF(MATCH ==  8)  QX(STARST+ 6) = ALEVEL# Rfazpwr                  MI18  87
ELSE  IF(MATCH ==  9)  QX(STARST+ 7) = ALEVEL# Wteiso                   MI18  88
ELSE  IF(MATCH == 10)  QX(STARST+ 8) = ALEVEL# Wteano                   MI18  89
ELSE  IF(MATCH == 11)  QX(STARST+ 9) = ALEVEL# Number                   MI18  90
ELSE  IF(MATCH == 12)  QX(STARST+10) = ALEVEL# Fazdif                   MI18  91
ELSE  IF(MATCH == 13)  QX(STARST+11) = ALEVEL# Ermsiso                  MI18  92
ELSE  IF(MATCH == 14)  QX(STARST+12) = ALEVEL# Eisoadj                  MI18  93
ELSE  IF(MATCH == 15)  QX(STARST+13) = ALEVEL# Isodif                   MI18  94
ELSE  IF(MATCH == 16)  QX(STARST+14) = ALEVEL# Hamodel                  MI18  95
ELSE  IF(MATCH == 17)  QX(STARST+15) = ALEVEL# Jntvar                   MI18  96
ELSE  IF(MATCH == 18)  QX(STARST+16) = ALEVEL# Ermsano                  MI18  97
ELSE  IF(MATCH == 19)  QX(STARST+17) = ALEVEL# Eanoadj                  MI18  98
ELSE  IF(MATCH == 20)  QX(STARST+18) = ALEVEL# Anodif                   MI18  99
ELSE  IF(MATCH == 21)  QX(STARST+19) = ALEVEL# Signs                    MI18 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI18 101
RETURN#                                                                 MI18 102
END#                                                                    MI18 103
pmacro:([z:])#                                                          MI18 104
systemheader:(MI20)#                                                    MI20   1
# ################################################################## #  MI20   2
#                                                                    #  MI20   3
#                               MI20                                 #  MI20   4
#                                                                    #  MI20   5
# ################################################################## #  MI20   6
SUBROUTINE MI20#                       Reads optional plthkl lines      MI20   7
#                                         Gets h,k,l and number to plot MI20   8
#                                        Jun 1980  s. sheriff           MI20   9
#                                        Revised sep 1980  s. sheriff   MI20  10
#                                        Revised feb 1981  s. sheriff   MI20  11
include:(AACOMN)#                                                       MI20  12
include:(MICOMN)#                                                       MI20  13
#                                                                       MI20  14
INTEGER INDEX#                         Packed h,k,l for plotting        MI20  15
INTEGER J#                             Loop index                       MI20  16
INTEGER PLACE#                         End bit for packed index         MI20  17
INTEGER SIGNBI#                        Sign bit position for packed     MI20  18
#                                         Index.                        MI20  19
INTEGER SGN#                           Sign of h, k, or l               MI20  20
REAL HP(3)#                            H,k,l indices                    MI20  21
chardata:(MI201, NO MORE THAN 10 PLTHKL LINES WILL BE PROCESSED)#       MI20  22
chardata:(MI202, AS EVERY       TH REFLECTION WAS REQUESTED TO BE $#    MI20  23
PRINTED, NO REFLECTIONS WILL BE PLOTTED)#                               MI20  24
realdata:(FMT201,[160513.])#                                            MI20  25
intdata:(ICHECK,no:)#                                                   MI20  26
intdata:(ZERO,[0])#                                                     MI20  27
datastuff:#                                                             MI20  28
#                                                                       MI20  29
IF((ILIST > 0) & (ICHECK == no:))#                                      MI20  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI20  31
# TELL USER THAT REFLECTIONS BEING PRINTED (ILIST ON MIR LINE)          MI20  32
#  IS INCOMPATIBLE WITH PLOTTING REFLECTIONS.                           MI20  33
#                                                                       MI20  34
ICHECK = yes:#                                                          MI20  35
movechar:(MI202,1,CHROT,1,NMI202,0)#                                    MI20  36
BUFOT(1) = FLOAT(ILIST)#                                                MI20  37
ncodefld:(BUFOT,1,CHROT,FMT201,1)#                                      MI20  38
writeline:(1,0,0,1,3)#                                                  MI20  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI20  40
#                                                                       MI20  41
ELSE  IF((IPLOT >= 10) & (ICHECK == no:))#                              MI20  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI20  43
# TELL USER THAT NO MORE THAN 10 GROUPS OF PLOTS ARE ALLOWED            MI20  44
#                                                                       MI20  45
ICHECK = yes:#                                                          MI20  46
writeline:(1,MI201,NMI201,3,3)#                                         MI20  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI20  48
#                                                                       MI20  49
ELSE  IF(ICHECK == no:)#                                                MI20  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI20  51
# PACK THE INDEX FOR LATER COMPARISON                                   MI20  52
#                                                                       MI20  53
IPLOT = IPLOT + 1#                     Increment number of groups       MI20  54
movereal:(BUFIN,1,HP,1,3,0)#                                            MI20  55
intpak:(ZERO,PLTHKL(IPLOT),0,mxbtwd:)# Zero the word to be packed       MI20  56
#                                                                       MI20  57
FOR(J=1; J <= 3; J=J+1)#               Now pack up the indices          MI20  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI20  59
SIGNBI = 3 - J#                        Set the sign bit position        MI20  60
PLACE = SIGNBI*9 + 3#                  Set end bit for index            MI20  61
INDEX = NINT(ABS(HP(J)))#              Make index into positive         MI20  62
SGN = 0#                               Integer value, assume plus       MI20  63
IF(HP(J) < -.1)  SGN = 1#              But change sign for minus.       MI20  64
intpak:(SGN,PLTHKL(IPLOT),SIGNBI,1)#   Move sign to storage             MI20  65
intpak:(INDEX,PLTHKL(IPLOT),PLACE,9)#  Move the index bits              MI20  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI20  67
#                                                                       MI20  68
# IF THERE IS A POSITIVE NUMBER TO BE PLOTTED, REPLACE DEFAULT (10)     MI20  69
#  BUT DON'T ALLOW MORE THAN 100 TO BE PLOTTED.                         MI20  70
#                                                                       MI20  71
IF(BUFIN(4) >= 1.0)  NUMPLT(IPLOT) = MIN0(NINT(BUFIN(4)),100)#          MI20  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI20  73
RETURN#                                                                 MI20  74
END#                                                                    MI20  75
systemheader:(MI22)#                                                    MI22   1
# ################################################################## #  MI22   2
#                                                                    #  MI22   3
#                               MI22                                 #  MI22   4
#                                                                    #  MI22   5
# ################################################################## #  MI22   6
SUBROUTINE MI22(IBNCHK)#               Check to be sure if bin          MI22   7
#                                         Numbers have been changed and MI22   8
#                                         That closure errors have all  MI22   9
#                                         Been updated.                 MI22  10
#                                        Jul 1980  s. sheriff           MI22  11
#                                        Revised sep 1980  s. sheriff   MI22  12
include:(AACOMN)#                                                       MI22  13
include:(MICOMN)#                                                       MI22  14
#                                                                       MI22  15
INTEGER FAZE#                          Holds fazda1(i)                  MI22  16
INTEGER I#                             Loop index                       MI22  17
INTEGER IBNCHK(arith:(30,*,maxsets:))# Check to make sure same bin      MI22  18
#                                       #  Is not updated twice.        MI22  19
INTEGER IFTEST#                        Value of nfbin when flags have   MI22  20
#                                         Been stripped off.            MI22  21
INTEGER ISTEST#                        Value of nbin when flags have    MI22  22
#                                         Been stripped off.            MI22  23
INTEGER KBPTR#                         Pointer to kb part of qx array   MI22  24
INTEGER MULT#                          How many bins to check           MI22  25
#                                                                       MI22  26
# LOGIC OF TESTS BELOW:                                                 MI22  27
#                                                                       MI22  28
#   1) TEST TO SEE IF THIS DATASET IS USED IN PHASING                   MI22  29
#   2) TEST TO SEE IF CLOSURE ERRORS HAVE OTHER THAN DEFAULT VALUES     MI22  30
#   3) TEST TO SEE IF THE NUMBER OF BINS HAVE BEEN CHANGED              MI22  31
#   4) TEST TO SEE IF ALL THE CLOSURE ERRORS HAVE BEEN UPDATED          MI22  32
#                                                                       MI22  33
DO I=1,NDATIN#                                                          MI22  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI22  35
FAZE = NINT(FAZDA1(I))#                Pick up phasing indicator        MI22  36
IF(I == 1 & (FAZE ==1 \ NUMAT(1) == 0))  NEXT#                          MI22  37
KBPTR = STARKB + (I-1)*STEPKB + 5#     Pointer to kb part of qx array   MI22  38
ISTEST = NINT(AMOD(QX(KBPTR),1000.))#  Determine number of stol bins    MI22  39
IFTEST = NINT(AMOD(QX(KBPTR+1),1000.))# Determine number of f**2 bins   MI22  40
MULT = FAZE#                                                            MI22  41
IF(FAZE > 1)  MULT = MULT - 1#                                          MI22  42
IF(MULT > 0)#                                                           MI22  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI22  44
IF((ISTEST != NBIN) \ (IFTEST != MULT*NFBIN))  iquit:(-MI2201)#         MI22  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI22  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI22  47
RETURN#                                                                 MI22  48
END#                                                                    MI22  49
systemheader:(MI25)#                                                    MI25   1
# ################################################################## #  MI25   2
#                                                                    #  MI25   3
#                               MI25                                 #  MI25   4
#                                                                    #  MI25   5
# ################################################################## #  MI25   6
SUBROUTINE MI25#                       Sep 1980  s. sheriff             MI25   7
include:(AACOMN)#                                                       MI25   8
include:(MICOMN)#                                                       MI25   9
#                                                                       MI25  10
# PRINT OUT ATOMS USED IN PHASING, OVERALL AND ATOMIC PARAMETERS        MI25  11
#  AND WHETHER THEY ARE TO BE REFINED.                                  MI25  12
#                                                                       MI25  13
CALL MI26#                                                              MI25  14
#                                                                       MI25  15
# PRINT OUT PHASING METHOD AND VARIOUS PARAMETERS WHICH COULD HAVE      MI25  16
#  BEEN SET ON INPUT, BUT MIGHT NOT HAVE BEEN.                          MI25  17
#                                                                       MI25  18
CALL MI27#                                                              MI25  19
#                                                                       MI25  20
# PRINT OUT INFORMATION ABOUT STATISTICS                                MI25  21
#                                                                       MI25  22
CALL MI28#                                                              MI25  23
#                                                                       MI25  24
# N.B. CLOSURE ERRORS IN FAZPRB MODE ARE PRINTED IN MI36 AFTER          MI25  25
#  WRITING OF SCRATCH FILE WITH LRREFL:, SO THAT USER MAY SEE RELATION  MI25  26
#  TO THE STATISTICS BINS (WHICH FOR F**2 BINS ARE SET AFTER NUMBERS    MI25  27
#  ARE CALCULATED DURING WRITE).                                        MI25  28
#                                                                       MI25  29
RETURN#                                                                 MI25  30
END#                                                                    MI25  31
systemheader:(MI26)#                                                    MI26   1
# ################################################################## #  MI26   2
#                                                                    #  MI26   3
#                               MI26                                 #  MI26   4
#                                                                    #  MI26   5
# ################################################################## #  MI26   6
SUBROUTINE MI26#                       Print scales, delta-bs, atomic   MI26   7
#                                         Parameters, and refinement    MI26   8
#                                         Keys.                         MI26   9
#                                        Dec 1980  r.a. alden           MI26  10
include:(AACOMN)#                                                       MI26  11
include:(MICOMN)#                                                       MI26  12
#                                                                       MI26  13
INTEGER ANOW#                          Current atom index               MI26  14
INTEGER ANPTR#                         Atom name pointer                MI26  15
INTEGER ATPTR#                         Pointer to current parameter     MI26  16
INTEGER DATPTR#                        Data set name pointer            MI26  17
INTEGER DNOW#                          Current data set index           MI26  18
INTEGER IND#                           Refinement name pointer          MI26  19
INTEGER INDCNT#                        To distinguish b and b11         MI26  20
INTEGER J#                             Scratch index                    MI26  21
INTEGER KBPTR#                         Pointer to k and delta-b for     MI26  22
#                                         Current data set.             MI26  23
INTEGER PARAM#                         Parameter pointer                MI26  24
INTEGER REFKEY#                        Refinement indicator for         MI26  25
#                                         Current k or delta-b.         MI26  26
INTEGER RFPTR#                         Pointer to current refinement    MI26  27
#                                         Indicator.                    MI26  28
chardata:(MI261, INPUT PARAMETERS AND REFINEMENT INDICATORS)#           MI26  29
chardata:(MI262,  DATA SET     ATOM    PARAM      VALUE   REFINE)#      MI26  30
chardata:(MI263,X  Y  Z  B11B22B33B12B13B23PP PPASCALE DELTA B)#        MI26  31
chardata:(MI264,NO YES)#                                                MI26  32
realdata:(FMT261,[400842.])#                                            MI26  33
datastuff:#                                                             MI26  34
#                                                                       MI26  35
LINCT = 0#                             Force fresh page                 MI26  36
ANPTR = STARAN#                        Initialize atom name             MI26  37
#                                         Character pointer.            MI26  38
DATPTR = STARDN#                       Also data set name               MI26  39
#                                         Character pointer.            MI26  40
ATPTR = STARAT#                        Set beginning of atom params     MI26  41
RFPTR = STAREF#                        Set beginning of refinement      MI26  42
#                                         Parameters.                   MI26  43
KBPTR=STARKB#                          Set beginning of kb-array        MI26  44
writeline:(2,MI261,NMI261,3,3)#        Heading line                     MI26  45
writeline:(1,MI262,NMI262,3,3)#        Column headings                  MI26  46
#                                                                       MI26  47
DO DNOW=1,NDATIN#                      Loop over all data sets          MI26  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI26  49
movertoc:(QX(DATPTR+1),1,CHROT,2,12,0)# Data set name                   MI26  50
movechar:(MI263,34,CHROT,24,5,0)#      Scale (k)                        MI26  51
#                                                                       MI26  52
# POINT TO PROPER SCALE AND ENCODE IT                                   MI26  53
#                                                                       MI26  54
ncodefld:(QX,KBPTR+1,CHROT,FMT261,1)#                                   MI26  55
REFKEY = NINT(QX(KBPTR+2))*3 + 1#      Index to refinement indicator    MI26  56
movechar:(MI264,REFKEY,CHROT,45,3,0)#  Move it                          MI26  57
writeline:(1,MI262,NMI262,1,3)#        Write out line                   MI26  58
#                                                                       MI26  59
movechar:(MI263,40,CHROT,24,7,0)#      Pick up delta-b and encode       MI26  60
ncodefld:(QX,KBPTR+3,CHROT,FMT261,1)#  Its value.                       MI26  61
REFKEY = NINT(QX(KBPTR+4))*3 + 1#      Index to refinement indicator    MI26  62
movechar:(MI264,REFKEY,CHROT,45,3,0)#  Move it                          MI26  63
writeline:(0,MI262,NMI262,1,3)#        Write out line                   MI26  64
#                                                                       MI26  65
DATPTR = DATPTR + STEPDN#              Increment data set name ptr.     MI26  66
KBPTR = KBPTR + STEPKB#                                                 MI26  67
IF(DNOW == 1)  NEXT#                   If parent, skip rest             MI26  68
FOR(ANOW=1; ANOW <= NUMAT(DNOW); ANOW=ANOW+1)# Loop over the atoms      MI26  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI26  70
movertoc:(QX(ANPTR+1),1,CHROT,15,24,0)# Extract atom name               MI26  71
IND = -2#                              Refinement name pointer          MI26  72
DO PARAM=1,11#                         Loop over the parameters         MI26  73
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI26  74
IND=IND + 3#                                                            MI26  75
J = ATPTR + PARAM#                                                      MI26  76
ifvo:(QX(J)) NEXT#                     If void, it must be a beta       MI26  77
INDCNT = 3#                                                             MI26  78
IF(PARAM == 4 & QX(ATPTR+5) <= voidflg:)  INDCNT = 1#                   MI26  79
movechar:(MI263,IND,CHROT,24,INDCNT,0)# Parameter name                  MI26  80
ncodefld:(QX,J,CHROT,FMT261,1)#        Encode the parameter             MI26  81
#                                                                       MI26  82
J = RFPTR + PARAM#                     Point to the refinement          MI26  83
REFKEY = NINT(QX(J))*3 + 1#            Indicator.                       MI26  84
movechar:(MI264,REFKEY,CHROT,45,3,0)#                                   MI26  85
writeline:(0,MI262,NMI262,1,3)#        Write out complete line          MI26  86
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI26  87
#                                                                       MI26  88
# INCREMENT POINTERS FOR ATOM PARAMETERS AND THEIR KEYS                 MI26  89
#                                                                       MI26  90
ANPTR = ANPTR + STEPAT#                                                 MI26  91
ATPTR = ATPTR + STEPAT#                                                 MI26  92
RFPTR = RFPTR + STEPEF#                                                 MI26  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI26  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI26  95
RETURN#                                                                 MI26  96
END#                                                                    MI26  97
systemheader:(MI27)#                                                    MI27   1
# ################################################################## #  MI27   2
#                                                                    #  MI27   3
#                               MI27                                 #  MI27   4
#                                                                    #  MI27   5
# ################################################################## #  MI27   6
SUBROUTINE MI27#                       Printout program information     MI27   7
#                                        Jun 1980  s. sheriff           MI27   8
#                                        Revised feb 1981  s. sheriff   MI27   9
include:(AACOMN)#                                                       MI27  10
include:(MICOMN)#                                                       MI27  11
#                                                                       MI27  12
INTEGER I#                             Loop index                       MI27  13
INTEGER INDEX#                         Either h,k or l                  MI27  14
INTEGER K#                             Another loop index               MI27  15
INTEGER N#                             Pointer to bit in packed hkl     MI27  16
#                                         Of either h, k, or l.         MI27  17
INTEGER PTR#                           Points to proper ordinal         MI27  18
#                                         Suffix.                       MI27  19
chardata:(MI270,    CYCLES OF PHASE REFINEMENT WILL BE DONE)#           MI27  20
chardata:(MI271, ON THE LAST CYCLE EVERY       REFLECTION WILL BE $#    MI27  21
LISTED)#                                                                MI27  22
chardata:(MI272,  THSTNDRDTHTHTHTHTHTH)# Ordinal suffixes               MI27  23
chardata:(MI273, DATA WILL BE PHASED BY THE METHOD OF BLOW AND $#       MI27  24
CRICK AS MODIFIED BY)#                                                  MI27  25
chardata:(MI274, PHASE CIRCLE STEPS WILL BE    DEGREES)#                MI27  26
chardata:(MI275, THE PHASE USED FOR REFINEMENT AND CALCULATING $#       MI27  27
STATISTICS WILL BE THE)#                                                MI27  28
chardata:(MI276,BEST MOST PROBABLE)#                                    MI27  29
chardata:(MI277, ON THE LAST CYCLE CLOSURE ERRORS WILL BE WRITTEN $#    MI27  30
TO A FORMATTED FILE)#                                                   MI27  31
chardata:(MI278, PRINTING OF REFLECTION INFORMATION WILL INCLUDE $#     MI27  32
PARENT PARAMETERS)#                                                     MI27  33
chardata:(MI279, PRINTING OF REFLECTION INFORMATION WILL INCLUDE $#     MI27  34
PARENT AND ISOMORPH PARAMETERS)#                                        MI27  35
chardata:(MI27A, GROUPS OF REFLECTIONS TO BE PLOTTED)#                  MI27  36
chardata:(MI27B, STARTING    H   K   L  NUMBER IN GROUP)#               MI27  37
chardata:(MI27C, DATA WILL BE PHASED BY THE MVFC METHOD)#               MI27  38
chardata:(MI27D, FOR REFLECTIONS WITH F**2 LESS THAN     $#             MI27  39
*VAR(F**2) ONLY 1 CYCLE)#                                               MI27  40
chardata:(MI27E, WHEN SIGMA**2(T) FOR A REFLECTION FALLS $#             MI27  41
BELOW     , LEAST SQUARES CYCLING WILL STOP)#                           MI27  42
chardata:(MI27F, A DAMPING FACTOR OF      WILL BE APPLIED TO THE $#     MI27  43
PHASE SHIFT OF EACH ACENTRIC REFLECTION)#                               MI27  44
chardata:(MI27G, LARGEST DIFFERENCE FOR ACCEPTING BIMODAL SIR $#        MI27  45
SOLUTION IS      DEGREES.)#                                             MI27  46
chardata:(MI27H, THE INITIAL VALUE OF CHI**2 (GOODNESS OF FIT) $#       MI27  47
IS       )#                                                             MI27  48
chardata:(MI27I,     NEW PHASES (NOT THOSE ON BDF) WILL BE USED $#      MI27  49
FOR INITIAL PHASE ESTIMATES.)#                                          MI27  50
chardata:(MI27J, HENDRICKSON AND LATTMAN)#                              MI27  51
chardata:(MI27K, WILL BE MADE THROUGH THE PHASING PROCEDURE.)#          MI27  52
realdata:(FMT271,[140413.,180413.,220413.,330413.])#                    MI27  53
realdata:(FMT272,[30213.,280313.,300313.])#                             MI27  54
realdata:(FMT273,[410412.,510412.,250422.,620402.,560612.])#            MI27  55
datastuff:#                                                             MI27  56
#                                                                       MI27  57
# WRITE OUT NUMBER OF CYCLES                                            MI27  58
#                                                                       MI27  59
movechar:(MI270,1,CHROT,1,NMI270,0)#                                    MI27  60
IF(NCYC == 1)  movechar:(BLANK,1,CHROT,10,1,0)#                         MI27  61
BUFOT(1) = FLOAT(NCYC)#                                                 MI27  62
ncodefld:(BUFOT,1,CHROT,FMT272(1),1)#                                   MI27  63
writeline:(1,0,0,1,3)#                                                  MI27  64
#                                                                       MI27  65
# WRITE OUT WHETHER REFLECTIONS WILL BE LISTED                          MI27  66
#                                                                       MI27  67
IF(ILIST > 0)#                                                          MI27  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI27  69
movechar:(MI271,1,CHROT,1,NMI271,0)#                                    MI27  70
BUFOT(1) = FLOAT(ILIST)#                                                MI27  71
ncodefld:(BUFOT,1,CHROT,FMT272(2),1)#                                   MI27  72
IF(ILIST == 1)  PTR = 1#               List every reflection            MI27  73
ELSE IF(ILIST > 10 & ILIST < 14)  PTR = 3#                              MI27  74
ELSE  PTR = MOD(ILIST,10)*2 + 3#                                        MI27  75
movechar:(MI272,PTR,CHROT,29,2,0)#     Move ordinal suffix              MI27  76
writeline:(1,0,0,1,3)#                                                  MI27  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI27  78
#                                                                       MI27  79
IF(FAZTYP == fazprb:)#                                                  MI27  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI27  81
movechar:(MI27J,1,CHROT,1,NMI27J,0)#   Get 2nd line of phasing method   MI27  82
writeline:(2,MI273,NMI273,2,3)#        Tell phasing method -- fazprb    MI27  83
movechar:(MI274,1,CHROT,1,NMI274,0)#   Tell step size                   MI27  84
BUFOT(1) = FLOAT(PHSINC)#                                               MI27  85
ncodefld:(BUFOT,1,CHROT,FMT272(3),1)#                                   MI27  86
writeline:(2,0,0,1,3)#                                                  MI27  87
#                                                                       MI27  88
movechar:(MI275,1,CHROT,1,NMI275,0)#   Tell phase for refining and      MI27  89
#                                         Statistics.                   MI27  90
IF(IFPROB == no:)  movechar:(MI276,1,CHROT,NMI275+2,4,0)#               MI27  91
ELSE  movechar:(MI276,6,CHROT,NMI275+2,13,0)#                           MI27  92
writeline:(1,0,0,1,3)#                                                  MI27  93
#                                                                       MI27  94
# CLOSURE ERRORS WRITTEN TO FORMATTED FILE?                             MI27  95
#                                                                       MI27  96
IF(IPUNCH > 0)  writeline:(1,MI277,NMI277,3,3)#                         MI27  97
#                                                                       MI27  98
# TELL ABOUT EXTRA INFORMATION IF PRINTING REFLECTIONS                  MI27  99
#                                                                       MI27 100
IF(ILIST > 0)#                                                          MI27 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI27 102
IF(INFORM == 2)  writeline:(1,MI278,NMI278,3,3)#                        MI27 103
ELSE  IF(INFORM == 3)  writeline:(1,MI279,NMI279,3,3)#                  MI27 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI27 105
#                                                                       MI27 106
IF(PLTHKL(1) > voidflg:)#              Any reflections to be plotted?   MI27 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI27 108
IF(LINCT < 7)  LINCT = 0#              Force new page                   MI27 109
writeline:(2,MI27A,NMI27A,3,3)#                                         MI27 110
writeline:(0,MI27B,NMI27B,3,3)#                                         MI27 111
FOR(I=1; ((PLTHKL(I) > voidflg:) & (I <= 10)); I=I+1)#                  MI27 112
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI27 113
DO K=1,3#                                                               MI27 114
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI27 115
N = (3-K)*9+3#                         Set bit index                    MI27 116
intunpak:(PLTHKL(I),INDEX,N,9)#        Get out each index               MI27 117
intunpak:(PLTHKL(I),N,3-K,1)#          Pick out sign of each index      MI27 118
IF(N != 0)  INDEX = -INDEX#            Change sign                      MI27 119
BUFOT(K) = FLOAT(INDEX)#               Store for printing               MI27 120
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI27 121
BUFOT(4) = FLOAT(NUMPLT(I))#           Get number to plot               MI27 122
movechar:(BLANK,1,CHROT,1,mxchln:,1)#  Clear out line                   MI27 123
ncodefld:(BUFOT,1,CHROT,FMT271(1),4)#                                   MI27 124
writeline:(0,MI27B,NMI27B,1,3)#                                         MI27 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI27 126
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI27 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI27 128
#                                                                       MI27 129
ELSE  IF(FAZTYP == mvfc:)#                                              MI27 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI27 131
writeline:(2,MI27C,NMI27C,3,3)#        Tell phasing method -- mvfc      MI27 132
IF(NUMVPH == yes:) writeline:(0,MI27I,NMI27I,3,3)#                      MI27 133
#                                                                       MI27 134
BUFOT(1) = FLOAT(PHSINC)#              Tell step size                   MI27 135
ncodefld:(BUFOT,1,MI274,FMT272(3),1)#                                   MI27 136
writeline:(2,MI274,NMI274,3,3)#                                         MI27 137
#                                                                       MI27 138
movechar:(MI27K,1,CHROT,1,NMI27K,0)#                                    MI27 139
BUFOT(1) = SIGCUT#                                                      MI27 140
ncodefld:(BUFOT,1,MI27D,FMT273(1),1)#                                   MI27 141
writeline:(1,MI27D,NMI27D,2,3)#                                         MI27 142
#                                                                       MI27 143
BUFOT(1) = REFCUT#                                                      MI27 144
ncodefld:(BUFOT,1,MI27E,FMT273(2),1)#                                   MI27 145
writeline:(1,MI27E,NMI27E,3,3)#                                         MI27 146
#                                                                       MI27 147
BUFOT(1) = PHSHFT#                                                      MI27 148
ncodefld:(BUFOT,1,MI27F,FMT273(3),1)#                                   MI27 149
writeline:(1,MI27F,NMI27F,3,3)#                                         MI27 150
#                                                                       MI27 151
BUFOT(1) = BIMODL#                                                      MI27 152
ncodefld:(BUFOT,1,MI27G,FMT273(4),1)#                                   MI27 153
writeline:(1,MI27G,NMI27G,3,3)#                                         MI27 154
#                                                                       MI27 155
BUFOT(1) = GOFPRV#                                                      MI27 156
ncodefld:(BUFOT,1,MI27H,FMT273(5),1)#                                   MI27 157
writeline:(1,MI27H,NMI27H,3,3)#                                         MI27 158
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI27 159
RETURN#                                                                 MI27 160
END#                                                                    MI27 161
systemheader:(MI28)#                                                    MI28   1
# ################################################################## #  MI28   2
#                                                                    #  MI28   3
#                               MI28                                 #  MI28   4
#                                                                    #  MI28   5
# ################################################################## #  MI28   6
SUBROUTINE MI28#                                                        MI28   7
#                                                                       MI28   8
# PUTS OUT INFORMATION ABOUT BINS AND STATISTICS AFTER                  MI28   9
#  CHOICE OF PHASING METHOD IS MADE.                                    MI28  10
#                                        Jul 1980  s. sheriff           MI28  11
include:(AACOMN)#                                                       MI28  12
include:(MICOMN)#                                                       MI28  13
#                                                                       MI28  14
INTEGER I#                             Loop index                       MI28  15
INTEGER ISTPTR#                        Pointer to the starst part of    MI28  16
#                                         The qx array.                 MI28  17
INTEGER ITITLE#                        Flag as to whether or not        MI28  18
#                                         Output has been titled.       MI28  19
INTEGER J#                             Another loop index               MI28  20
INTEGER LCYC#                          Flag for whether to break        MI28  21
#                                         Statistics into all, centric, MI28  22
#                                         And acentric when printing    MI28  23
#                                         Last cycle.                   MI28  24
INTEGER LINSKP#                        Number of lines to leave blank   MI28  25
#                                         On output.                    MI28  26
INTEGER LOCATE#                        Current location in chrot        MI28  27
INTEGER NORMAL#                        Flag for whether to break        MI28  28
#                                         Statistics into all, centric, MI28  29
#                                         And acentric when print on    MI28  30
#                                         All cycles except the last.   MI28  31
string:(OUTLIN,mxchln:)#               Temporary output line            MI28  32
chardata:(MI281, NUMBER OF STOL BINS =   .  NUMBER OF F**2 BINS =   .)# MI28  33
chardata:(MI282, ON ALL CYCLES EXCEPT THE LAST THE BREAKDOWN INTO $#    MI28  34
CATEGORIES WILL BE)#                                                    MI28  35
chardata:(MI283, ON THE LAST CYCLE THE BREAKDOWN INTO $#                MI28  36
CATEGORIES WILL BE)#                                                    MI28  37
chardata:(MI284, ON ALL CYCLES THE FOLLOWING STATISTICS WILL BE $#      MI28  38
OUTPUT AT PRIORITY 3 --)#                                               MI28  39
chardata:(MI285, ON THE LAST CYCLE THE FOLLOWING STATISTICS WILL BE $#  MI28  40
OUTPUT AT PRIORITY 3 --)#                                               MI28  41
chardata:(CENBN,ALL    CENTRIC)#                                        MI28  42
chardata:(STAT2,FOMHIST FOM     PARVAR  RCULLIS RKRAUT  RFAZPWR $#      MI28  43
WTEISO  WTEANO  NUMBER  FAZDIF  ERMSISO EISOADJ )#                      MI28  44
chardata:(STAT3,ISODIF  HAMODEL JNTVAR  ERMSANO EANOADJ ANODIF  $#      MI28  45
SIGNS   )#                                                              MI28  46
realdata:(FMT281,[250213.,520213.])#                                    MI28  47
datastuff:#                                                             MI28  48
#                                                                       MI28  49
# WRITE OUT BIN INFORMATION                                             MI28  50
#                                                                       MI28  51
movechar:(MI281,1,CHROT,1,NMI281,0)#                                    MI28  52
BUFOT(1) = FLOAT(NBIN)#                                                 MI28  53
BUFOT(2) = FLOAT(NFBIN)#                                                MI28  54
ncodefld:(BUFOT,1,CHROT,FMT281(1),2)#                                   MI28  55
writeline:(1,0,0,1,3)#                                                  MI28  56
#                                                                       MI28  57
NORMAL = (MOD(NCBIN,10) - 1)*7 + 1#                                     MI28  58
movechar:(MI282,1,CHROT,1,NMI282,0)#                                    MI28  59
movechar:(CENBN,NORMAL,CHROT,70,7,0)#                                   MI28  60
writeline:(1,0,0,1,3)#                                                  MI28  61
#                                                                       MI28  62
LCYC = ((NCBIN/10) - 1)*7 + 1#                                          MI28  63
movechar:(MI283,1,CHROT,1,NMI283,0)#                                    MI28  64
movechar:(CENBN,LCYC,CHROT,58,7,0)#                                     MI28  65
writeline:(1,0,0,1,3)#                                                  MI28  66
#                                                                       MI28  67
# SET TO 0 STATISTICS WHICH ARE NOT CALCULATED IN MVFC MODE             MI28  68
#                                                                       MI28  69
IF(FAZTYP == mvfc:)#                   &&&&&                            MI28  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI28  71
QX(STARST+3) =  0.0#                   Parvar                           MI28  72
QX(STARST+13) = 0.0#                   Ermsiso                          MI28  73
QX(STARST+14) = 0.0#                   Eisoadj                          MI28  74
QX(STARST+15) = 0.0#                   Isodif                           MI28  75
QX(STARST+16) = 0.0#                   Hamodel                          MI28  76
QX(STARST+17) = 0.0#                   Jntvar                           MI28  77
QX(STARST+18) = 0.0#                   Ermsano                          MI28  78
QX(STARST+19) = 0.0#                   Eanoadj                          MI28  79
QX(STARST+20) = 0.0#                   Anodif                           MI28  80
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI28  81
#                                                                       MI28  82
# TELL WHAT STATISTICS ARE GOING TO BE SEEN                             MI28  83
#                                                                       MI28  84
FOR(J=2; J > 0; J=J-1)#                First put out statistics         MI28  85
#                                         On all cycles, then on last.  MI28  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI28  87
movechar:(BLANK,1,OUTLIN,1,mxchln:,1)# Clear out buffer                 MI28  88
LOCATE = 1#                            Initialize offset                MI28  89
ITITLE = no:#                          Initialize flag to heading       MI28  90
DO I=1,12#                                                              MI28  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI28  92
ISTPTR = STARST + I#                                                    MI28  93
IF(NINT(QX(ISTPTR)) == J)#                                              MI28  94
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI28  95
movechar:(STAT2,((I-1)*8)+1,OUTLIN,LOCATE,8,0)#                         MI28  96
LOCATE = LOCATE + 8#                   Increment offset on line         MI28  97
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI28  98
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI28  99
#                                                                       MI28 100
IF(LOCATE > 1)#                        We have statistics from          MI28 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI28 102
ITITLE = yes:#                         First grouping.                  MI28 103
IF(J == 2)  writeline:(1,MI284,NMI284,3,3)# All cycles                  MI28 104
ELSE  writeline:(1,MI285,NMI285,3,3)#  Last cycle only                  MI28 105
movechar:(OUTLIN,1,CHROT,2,LOCATE-1,0)#                                 MI28 106
writeline:(1,0,0,1,3)#                                                  MI28 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI28 108
#                                                                       MI28 109
movechar:(BLANK,1,OUTLIN,1,mxchln:,1)# Clear out buffer                 MI28 110
LOCATE = 1#                                                             MI28 111
DO I=13,STEPST#                                                         MI28 112
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI28 113
ISTPTR = STARST + I#                                                    MI28 114
IF(NINT(QX(ISTPTR)) == J)#                                              MI28 115
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI28 116
movechar:(STAT3,((I-13)*8)+1,OUTLIN,LOCATE,8,0)# Stuff buffer           MI28 117
LOCATE = LOCATE + 8#                   Increment offset on line         MI28 118
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI28 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI28 120
#                                                                       MI28 121
IF(LOCATE > 1)#                        We have statistics from          MI28 122
#                                         First grouping.               MI28 123
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI28 124
IF(ITITLE ==  yes:)  LINSKP = 0#       Flag to skip line between        MI28 125
ELSE#                                  Heading and statistics names.    MI28 126
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI28 127
IF(J == 2)  writeline:(1,MI284,NMI284,3,3)# All cycles                  MI28 128
ELSE  writeline:(1,MI285,NMI285,3,3)#  Last cycle only                  MI28 129
LINSKP = 1#                                                             MI28 130
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI28 131
#                                                                       MI28 132
movechar:(OUTLIN,1,CHROT,2,LOCATE-1,0)#                                 MI28 133
writeline:(LINSKP,0,0,1,3)#                                             MI28 134
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI28 135
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI28 136
RETURN#                                                                 MI28 137
END#                                                                    MI28 138
systemheader:(MI30)#                                                    MI30   1
# ################################################################## #  MI30   2
#                                                                    #  MI30   3
#                               MI30                                 #  MI30   4
#                                                                    #  MI30   5
# ################################################################## #  MI30   6
SUBROUTINE MI30#                       Copy lrrefl: to filec            MI30   7
#                                      May 1980  j.m. stewart           MI30   8
#                                        Updated mar 1981  s. sheriff   MI30   9
include:(AACOMN)#                                                       MI30  10
include:(MICOMN)#                                                       MI30  11
include:(MIMAC2)#                      Include procedure macros         MI30  12
#                                                                       MI30  13
########## DEFINE PROCEDURE NAME USED IN THIS ROUTINE # ############ #  MI30  14
defineproc:(ALLOCATE)#                 Allocate blocks of the qx        MI30  15
#                                         Array.                        MI30  16
########## END OF PROCEDURE NAME DEFINITIONS ####################### #  MI30  17
#                                                                       MI30  18
# ALLOCATE STORAGE BLOCKS IN QX ARRAY IN ANTICIPATION OF LRREFL:        MI30  19
#                                                                       MI30  20
xeq:(ALLOCATE)#                                                         MI30  21
#                                                                       MI30  22
# SET UP PACKET POINTERS FOR LR20 + STAT.                               MI30  23
#                                                                       MI30  24
CALL MI31#                                                              MI30  25
#                                                                       MI30  26
# SET UP STORAGE POINTERS FOR REFOUT AND STATS                          MI30  27
#                                                                       MI30  28
CALL MI34#                                                              MI30  29
#                                                                       MI30  30
# SET UP STORAGE POINTERS FOR MATRIX AND DERIVATIVES                    MI30  31
#                                                                       MI30  32
CALL MI35#                                                              MI30  33
#                                                                       MI30  34
# PREPARES FOR HANDLING STATISTICS                                      MI30  35
#                                                                       MI30  36
CALL MI36#                                                              MI30  37
#                                                                       MI30  38
RETURN#                                                                 MI30  39
#                                                                       MI30  40
# ##################### ALLOCATE ################################### #  MI30  41
procedure:(ALLOCATE)#                                                   MI30  42
STARH = STOPST#                        Set start of sym indices         MI30  43
STEPH = 5#                             Set hklts step increment         MI30  44
STOPH = STARH + NROT*STEPH#            Make space for max. number       MI30  45
#                                         Of symmetry indices.          MI30  46
STARCR = STOPH#                                                         MI30  47
STEPCR = 16#                           Set size of crystal space        MI30  48
STOPCR = STARCR + STEPCR#                                               MI30  49
# IT IS ESSENTIAL THAT THE EM PART OF THE QX ARRAY BE                   MI30  50
#  SET BEFORE THE CALL TO MI31.                                         MI30  51
#                                                                       MI30  52
STEPEM = 15#                                                            MI30  53
STAREM = STOPCR#                       Em part of qx array holds        MI30  54
#                                         1) average intensity for      MI30  55
#                                             Each stol bin, and        MI30  56
incrqx:(STOPEM,STAREM+30,MI3001)#      2) maximum e(norm)               MI30  57
endproc:(ALLOCATE)#                                                     MI30  58
# ####### REMOVE PROCEDURE ########################################## # MI30  59
deleteproc:(ALLOCATE)#                                                  MI30  60
#                                                                       MI30  61
END#                                                                    MI30  62
systemheader:(MI31)#                                                    MI31   1
# ################################################################## #  MI31   2
#                                                                    #  MI31   3
#                               MI31                                 #  MI31   4
#                                                                    #  MI31   5
# ################################################################## #  MI31   6
SUBROUTINE MI31#                       Scan logical record lrrefl:      MI31   7
#                                         For quantities stored in the  MI31   8
#                                         Bdf and set up the output     MI31   9
#                                         Lrrefl: on scratch file c.    MI31  10
#                                        Called by mi30                 MI31  11
#                                        Nov 1979  j.m. stewart         MI31  12
#                                        Revised mar 1982  r.m. doherty MI31  13
#                                        And yet again aug 1985         MI31  14
#                                        J.m. stewart                   MI31  15
include:(AACOMN)#                                                       MI31  16
include:(MICOMN)#                                                       MI31  17
#                                                                       MI31  18
INTEGER IHIT#                          Signal for needed f rel items    MI31  19
INTEGER IN20(113)#                     Wanted entities from rec20       MI31  20
INTEGER IPTR,IPTRR#                    Storage pointers into            MI31  21
#                                         Input want list.              MI31  22
INTEGER IPT#                           Input packet pointer             MI31  23
INTEGER IREL(114)#                     Offsets to items in lrrefl:      MI31  24
INTEGER J#                             Running index for loops          MI31  25
INTEGER JJ#                            Running indices for loops        MI31  26
INTEGER JPT,JPTR#                      Output packet pointers           MI31  27
#                                         Lrrefl: want list.            MI31  28
INTEGER NEEDIT(21)#                                                     MI31  29
INTEGER OPTR#                          Storage pointer into             MI31  30
#                                         Output want list.             MI31  31
INTEGER PHWANT(2)#                     Phase want list                  MI31  32
INTEGER PSIZE#                         Packet size                      MI31  33
INTEGER SIGNAL(4)#                     To hold counts of packet         MI31  34
#                                         Quantities needed and         MI31  35
#                                         Returned.                     MI31  36
chardata:(MI311, DUMP OF ARRAYS WHICH CONTROL IO OF $#                  MI31  37
REFLECTION RECORD)#                                                     MI31  38
chardata:(MI312,      WANTS      OFFSETS  INPUT PKT    OUTPUT PKT  )#   MI31  39
realdata:(FMT311,[121013.,241013.,361013.,481013.])#                    MI31  40
realdata:(NUL,[0.])#                                                    MI31  41
# NONC NOW 9, MAKE IT 17 TO OUTPUT HENDRICKSON ABCD ON LRREFL:          MI31  42
#  IT ALSO IS CHANGED IN MI40 AND MI89............                      MI31  43
#  NWANT MUST BE EITHER 13 OR 21 DEPENDING ON HENDRICKSON.              MI31  44
intdata:(NONC,[9])#                    Number of items/deriv to c       MI31  45
intdata:(NWANT,[13])#                  Number of wants/deriv from a     MI31  46
intdata:(WANT,[302,303,304,305,309,312,313,314,315,801,$#               MI31  47
802,803,804,501,502,503,504,505,506,507,508])#                          MI31  48
intdata:(WANT2,[700,701,702,703,704])#                                  MI31  49
intdata:(IPUTO,[ 4, 5, 4, 5, 8, 6, 7, 6, 7, 9,10,11,$#                  MI31  50
12,13,14,15,16,17,18,19,17])#                                           MI31  51
realdata:(OUTPAK,[304.,303.,314.,313.,309.,801.,802.,803.,$#            MI31  52
804.,501.,502.,503.,504.,505.,506.,507.,508.])#                         MI31  53
datastuff:#                                                             MI31  54
#                                                                       MI31  55
NEEDIT(1)=yes:#                                                         MI31  56
NEEDIT(2)= no:#                                                         MI31  57
NEEDIT(3)=yes:#                                                         MI31  58
NEEDIT(4)= no:#                                                         MI31  59
NEEDIT(5)= no:#                                                         MI31  60
NEEDIT(6)= no:#                                                         MI31  61
NEEDIT(7)= no:#                                                         MI31  62
NEEDIT(8)= no:#                                                         MI31  63
NEEDIT(9)= no:#                                                         MI31  64
NEEDIT(10)= no:#                                                        MI31  65
NEEDIT(11)= no:#                                                        MI31  66
NEEDIT(12)= no:#                                                        MI31  67
NEEDIT(13)= no:#                                                        MI31  68
NEEDIT(14)= no:#                                                        MI31  69
NEEDIT(15)= no:#                                                        MI31  70
NEEDIT(16)= no:#                                                        MI31  71
NEEDIT(17)= no:#                                                        MI31  72
NEEDIT(18)= no:#                                                        MI31  73
NEEDIT(19)= no:#                                                        MI31  74
NEEDIT(20)= no:#                                                        MI31  75
NEEDIT(21)= no:#                                                        MI31  76
PHWANT(1) = no:#                                                        MI31  77
PHWANT(2) = no:#                                                        MI31  78
movereal:(NUL,1,QX,STAREM+1,30,2)#     Clear em part of qx array        MI31  79
SIGNAL(1) = 3#                         Must have hkl, stol and mult     MI31  80
#                                                                       MI31  81
# NOW SET UP THE PART OF THE LIST WHICH WILL BE CALCULATED BY           MI31  82
#  MIR AND MAY ALREADY BE IN THE INPUT FILE.                            MI31  83
#                                                                       MI31  84
IN20(1)=1#                             Get hkl                          MI31  85
IN20(2)=2#                             Stol                             MI31  86
IN20(3)=3#                             Epsilon                          MI31  87
IPTR = 3#                              Set ptr at end of mandatory      MI31  88
DO J=1,NDATIN#                         Loop over all data sets          MI31  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI31  90
DO JJ=1,NWANT#                                                          MI31  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI31  92
IPTR = IPTR + 1#                       Move index in in20 array         MI31  93
IN20(IPTR) = BDFSEQ(J)*1000 + WANT(JJ)# Make idnum for this data set    MI31  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI31  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI31  96
#                                                                       MI31  97
# NOW PUT IN IDNUMS FOR QUANTITIES THAT ARE UNIQUE FOR EACH             MI31  98
#  REFLECTION.  AT END OF SECTION 2 OF IN20 ARRAY PUT IDNUMS FOR        MI31  99
#  PREVIOUS PHASE INFORMATION THAT MAY BE ON THE FILE.                  MI31 100
#  ALL THESE IDNUMS ARE SET IN THE DATA STATEMENTS FOR THE WANT2        MI31 101
#  ARRAY.                                                               MI31 102
#                                                                       MI31 103
DO J=1,5#                                                               MI31 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI31 105
IPTR = IPTR + 1#                                                        MI31 106
IN20(IPTR) = WANT2(J)#                                                  MI31 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI31 108
# CHECK IF WANT INITAL PHASES                                           MI31 109
IF (FAZA1 != 0)#                                                        MI31 110
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI31 111
PHWANT(1) = IPTR+1#                                                     MI31 112
IN20(IPTR+1) = FAZFM1#                                                  MI31 113
IN20(IPTR+2) = FAZA1#                                                   MI31 114
IN20(IPTR+3) = FAZB1#                                                   MI31 115
IPTR = IPTR + 3#                                                        MI31 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI31 117
# CHECK IF WANT PHASES TO COMBINE WITH                                  MI31 118
IF (FAZA2 != 0)#                                                        MI31 119
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI31 120
PHWANT(2) = IPTR+1#                                                     MI31 121
IN20(IPTR+1) = FAZFM2#                                                  MI31 122
IN20(IPTR+2) = FAZA2#                                                   MI31 123
IN20(IPTR+3) = FAZB2#                                                   MI31 124
IPTR = IPTR + 3#                                                        MI31 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI31 126
SIGNAL(2) = IPTR#                                                       MI31 127
SIGNAL(3) = 0#                                                          MI31 128
SIGNAL(4) = 0#                                                          MI31 129
indexpkt:(1,lrrefl:,PSIZE,IPT,0,SIGNAL,IN20,IREL)#                      MI31 130
IF((IPT < 0) \ (SIGNAL(4) < 0))  iquit:(MI3103)#                        MI31 131
#                                                                       MI31 132
#  CHECK THAT THERE IS SOME FORM OF F RELATIVE DATA ON THE FILE         MI31 133
#                                                                       MI31 134
IHIT=0 ; IPTRR=3#                      Set to scan id packet            MI31 135
DO J=1,NDATIN#                         Loop over data sets              MI31 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI31 137
DO JJ=1,NWANT#                         Loop over f rel items            MI31 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI31 139
IPTRR=IPTRR+1#                         Advance through packet           MI31 140
IF((IREL(IPTRR)>0)&(NEEDIT(JJ)==yes:))IHIT=IHIT+1# Register hits        MI31 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI31 142
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI31 143
IF(IHIT<=0) iquit:(MI3102)#            Get out for no f data            MI31 144
# CHECK IF DESIRED PHASE INFORMATION ON BDF                             MI31 145
IF(PHWANT(1)!=no:)#                                                     MI31 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI31 147
J = PHWANT(1)#                                                          MI31 148
IF (IREL(J)==0) iquit:(MI3103)#        Initial phase missing from bdf   MI31 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI31 150
IF(PHWANT(2)!=no:)#                                                     MI31 151
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI31 152
J = PHWANT(2)#                                                          MI31 153
IF (IREL(J)==0) iquit:(MI3104)#        Combining phase missing from b   MI31 154
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI31 155
#                                                                       MI31 156
# NOW MAKE A LOG. REC. LRREFL:  ON FILE C, WHICH WILL                   MI31 157
# BE USED AND UPDATED ON EVERY CYCLE OF REFINEMENT.                     MI31 158
# LOG. REC. LRREFL: OF THE INPUT FILE IS MODIFIED, IF NEED BE, AND      MI31 159
# THE RESULTS ARE WRITTEN TO SCRATCH FILE C.                            MI31 160
# ALL QUANTITIES NOT SUPPLIED ON FILE A, WHICH ARE GENERATED BY         MI31 161
# THE MIR PROGRAM ARE SET TO VOIDFLG:.                                  MI31 162
#                                                                       MI31 163
OPTR=NONC*NDATIN+8#                    Calculate the output pkt size    MI31 164
IF (FAZA1 != 0) OPTR = OPTR + 3#                                        MI31 165
IF (FAZA2 != 0) OPTR = OPTR + 3#                                        MI31 166
#                                        For scratch file c             MI31 167
#                                                                       MI31 168
writepkt:(3,lrrefl:,OPTR,JPT)#         Get pointer for o/p pkt          MI31 169
JPTR=JPT#                              Set pointer to o/p buffer        MI31 170
DO J=1,3#                              Loop over hkl, stol, mult item   MI31 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI31 172
JPTR=JPTR+1 ; QX(JPTR)=FLOAT(J)#       Set up idnums                    MI31 173
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI31 174
DO J=1,NDATIN#                         Loop over data sets              MI31 175
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI31 176
DO JJ=1,NONC#                          Loop over items/data set         MI31 177
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI31 178
JPTR=JPTR+1#                           Increment packet pointer         MI31 179
QX(JPTR)=FLOAT(BDFSEQ(J))*1000.+OUTPAK(JJ)# Form id number for refl     MI31 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI31 181
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI31 182
DO J=1,5#                              Loop over refl phase results     MI31 183
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI31 184
JPTR=JPTR+1 ; QX(JPTR)=FLOAT(WANT2(J))# Make packet id numbers          MI31 185
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI31 186
# CHECK IF WANT EXTERNAL PHASE                                          MI31 187
IF (FAZA1 != 0)#                                                        MI31 188
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI31 189
FAZPT1 = JPTR-JPT+1#                   Point to location on file c      MI31 190
QX(JPTR+1) = FAZFM1#                                                    MI31 191
QX(JPTR+2) = FAZA1#                                                     MI31 192
QX(JPTR+3) = FAZB1#                                                     MI31 193
JPTR = JPTR + 3#                                                        MI31 194
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI31 195
# CHECK IF WANT EXTERNAL PHASE                                          MI31 196
IF (FAZA2 != 0)#                                                        MI31 197
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI31 198
FAZPT2 = JPTR-JPT+1#                   Point to location on file c      MI31 199
QX(JPTR+1) = FAZFM2#                                                    MI31 200
QX(JPTR+2) = FAZA2#                                                     MI31 201
QX(JPTR+3) = FAZB2#                                                     MI31 202
JPTR = JPTR + 3#                                                        MI31 203
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI31 204
#                                                                       MI31 205
# AT LOWEST PRIORITY DUMP THE LRREFL: HEADER PACKET,                    MI31 206
# THE WANTS AND THE OFFSETS.                                            MI31 207
#                                                                       MI31 208
IF(PPRIOR > 4)#                                                         MI31 209
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MI31 210
writeline:(1,MI311,NMI311,3,5)#                                         MI31 211
LINRM = 6#                                                              MI31 212
FOR(J=1; J <= IPTR ; J=J+1)#           Loop over longest list           MI31 213
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MI31 214
IF(J<=OPTR)BUFOT(4)=QX(JPT+J)#         Check for end of packet          MI31 215
ELSE BUFOT(4)=0.0#                                                      MI31 216
BUFOT(1)=FLOAT(IN20(J))#               Get want list item               MI31 217
BUFOT(2) = FLOAT(IREL(J))#             Get returned pointer             MI31 218
IF(J <= PSIZE)#                                                         MI31 219
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MI31 220
JJ = IPT + J#                                                           MI31 221
BUFOT(3) = QX(JJ)#                     Pick up packet information       MI31 222
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MI31 223
ELSE  BUFOT(3) = 0.0#                                                   MI31 224
ncodefld:(BUFOT,1,CHROT,FMT311(1),4)#                                   MI31 225
writeline:(0,MI312,NMI312,1,5)#                                         MI31 226
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MI31 227
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MI31 228
#                                                                       MI31 229
REPEAT#                                Loop over i/p pkts of lrrefl:    MI31 230
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MI31 231
readwpkt:(1,lrrefl:,PSIZE,IPT,0)#      Read next input packet           MI31 232
IF(IPT <= 0)  BREAK#                   Exit loop after last one         MI31 233
writepkt:(3,lrrefl:,OPTR,JPT)#         Get pointer for o/p packet       MI31 234
#                                                                       MI31 235
#  TRANSFER THE NEEDED QUANTITIES AND SET UP THE NEW QUANTITIES FOR     MI31 236
#  EACH REFLECTION IN FILE 'C' FROM FILE 'A'.                           MI31 237
#                                                                       MI31 238
movereal:(voidflg:,1,QX,JPT+1,OPTR,2)# Void the output pkt              MI31 239
IPTR=0#                                Set pointer into reloc. array    MI31 240
DO J=1,3#                                                               MI31 241
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MI31 242
IPTR=IPTR+1 ; IPTRR=IREL(IPTR)+IPT#    Find input hkl, stol, mult       MI31 243
movepakwd:(QX(IPTRR),QX(JPT+J))#       Move the quantities              MI31 244
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MI31 245
DO J=1,NDATIN#                         Loop over all the data sets      MI31 246
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MI31 247
DO JJ=1,NWANT#                         Loop over all refl items         MI31 248
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MI31 249
IPTR=IPTR+1#                           Point to in and out              MI31 250
JPTR=JPT+IPUTO(JJ)+(J-1)*NONC#         Especially to out                MI31 251
THING=voidflg:#                        Prepare for nothing              MI31 252
IF(IREL(IPTR)>0)#                      Test for item in input           MI31 253
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MI31 254
IPTRR=IPT+IREL(IPTR)#                  Set pointer to input             MI31 255
THING=QX(IPTRR)#                       Pull the item for processing     MI31 256
IF((JJ==1)&(THING>voidflg:))#          Test if f**2(+++) present        MI31 257
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MI31 258
THING=SQRT(ABS(THING))#                Change f**2 into f +++           MI31 259
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MI31 260
ELSE IF((JJ==4)&(IREL(IPTR-2)<=0)&(THING>voidflg:))# Sigma f**2         MI31 261
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MI31 262
THING=2.0*THING#                       Find 2*sigma(f) +++              MI31 263
IF(IREL(IPTR-1)>0)#                    See if f+++ is in input file     MI31 264
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MI31 265
IPTRR=IPT+IREL(IPTR-1)#                Point to f relative +++          MI31 266
IF(QX(IPTRR)>voidflg:)THING=THING*AMAX1(1.0,QX(IPTRR))# Caution         MI31 267
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MI31 268
ELSE IF(IREL(IPTR-3)>0)#               If not f how about f**2          MI31 269
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MI31 270
IPTRR=IPT+IREL(IPTR-3)#                Point to f**2 +++                MI31 271
IF(QX(IPTRR)>voidflg:)THING=THING*AMAX1(1.0,SQRT(ABS(QX(IPTRR))))#      MI31 272
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MI31 273
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MI31 274
ELSE IF((JJ==6)&(THING>voidflg:))#     Test if f**2(---) present        MI31 275
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MI31 276
THING=SQRT(ABS(THING))#                Change f**2 into f ---           MI31 277
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MI31 278
ELSE IF((JJ==9)&(IREL(IPTR-2)<=0)&(THING>voidflg:))# Sigma f**2         MI31 279
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 MI31 280
THING=2.0*THING#                       Find 2*sigma(f) ---              MI31 281
IF(IREL(IPTR-1)>0)#                    See if f--- is in input file     MI31 282
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 MI31 283
IPTRR=IPT+IREL(IPTR-1)#                Point to f relative ---          MI31 284
IF(QX(IPTRR)>voidflg:)THING=THING*AMAX1(1.0,QX(IPTRR))# Caution         MI31 285
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 MI31 286
ELSE IF(IREL(IPTR-3)>0)#               If not f how about f**2          MI31 287
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 MI31 288
IPTRR=IPT+IREL(IPTR-3)#                Point to f**2 ---                MI31 289
IF(QX(IPTRR)>voidflg:)THING=THING*AMAX1(1.0,SQRT(ABS(QX(IPTRR))))#      MI31 290
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 MI31 291
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 MI31 292
QX(JPTR)=THING#                        Put the reflection datum away    MI31 293
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MI31 294
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MI31 295
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MI31 296
JJ = 5#                                Default 5 general items          MI31 297
IF (FAZA1!=0) JJ = JJ+3#               Store initializing phases        MI31 298
IF (FAZA2!=0) JJ = JJ+3#               Store combining phases           MI31 299
DO J=1,JJ#                             Loop over phase information      MI31 300
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 MI31 301
IPTR=IPTR+1 ; JPTR=JPT+OPTR-JJ+J#      Set input and output pointers    MI31 302
IF(IREL(IPTR)>0)#                      Check for something in input     MI31 303
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 MI31 304
IPTRR=IPT+IREL(IPTR) ; QX(JPTR)=QX(IPTRR)# Get old value of phase inf   MI31 305
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 MI31 306
ELSE QX(JPTR)=voidflg:#                Void if void in input phases     MI31 307
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 MI31 308
#                                                                       MI31 309
# COLLECT SUM OF F**2 FOR F**2 BINNING                                  MI31 310
#                                                                       MI31 311
CALL MI32(JPT)#                                                         MI31 312
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MI31 313
#                                                                       MI31 314
readwpkt:(1,endrecord:,PSIZE,IPT,0)#   Close out file a                 MI31 315
writepkt:(3,endrecord:,PSIZE,JPT)#     Write eof on file c              MI31 316
#                                                                       MI31 317
RETURN#                                                                 MI31 318
END#                                                                    MI31 319
systemheader:(MI32)#                                                    MI32   1
# ################################################################## #  MI32   2
#                                                                    #  MI32   3
#                               MI32                                 #  MI32   4
#                                                                    #  MI32   5
# ################################################################## #  MI32   6
SUBROUTINE MI32(PO)#                   Sum parent f**2's and number     MI32   7
#                                         Of refls. by stol bin in      MI32   8
#                                         Preparation for statistics    MI32   9
#                                         Routines.  done during copy   MI32  10
#                                         Of lrrefl: in mi31.           MI32  11
#                                        Called from mi31               MI32  12
#                                        Jul 1980  s. sheriff           MI32  13
include:(AACOMN)#                                                       MI32  14
include:(MICOMN)#                                                       MI32  15
#                                                                       MI32  16
INTEGER IP#                            Index to temporary storage       MI32  17
INTEGER J#                             Loop index                       MI32  18
INTEGER K#                             Another loop index               MI32  19
INTEGER PO#                            Index to temporary storage       MI32  20
REAL FMINUS#                           Frel(-)                          MI32  21
REAL FPLUS#                            Frel(+)                          MI32  22
REAL FPSQ#                             Mean of frel(-) and frel(+), s   MI32  23
REAL STOL#                             Sine(theta)/lambda               MI32  24
#                                                                       MI32  25
# CHECK TO SEE IF REFLECTION IS IN RANGE FOR THIS RUN                   MI32  26
#                                                                       MI32  27
STOL=QX(PO+2)#                         Drh                      # sin   MI32  28
IF((STOL >= STOLMN(1)) & (STOL <= STOLMX(1)))#                          MI32  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI32  30
IP = 3 + PO#                                                            MI32  31
FPLUS=QX(IP+1)#                        Drh                     #        MI32  32
FMINUS=QX(IP+3)#                       Drh                    #         MI32  33
#                                                                       MI32  34
# CALCULATE FPSQ DEPENDING ON WHAT IS AVAILABLE                         MI32  35
#                                                                       MI32  36
ifnv:(FPLUS)#                                                           MI32  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI32  38
ifnv:(FMINUS)  FPSQ = 0.5*(FPLUS**2+FMINUS**2)#                         MI32  39
ELSE  FPSQ = FPLUS**2#                                                  MI32  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI32  41
ELSE#                                                                   MI32  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI32  43
ifnv:(FMINUS)  FPSQ = FMINUS**2#                                        MI32  44
ELSE  FPSQ = voidflg:#                                                  MI32  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI32  46
#                                                                       MI32  47
# CALCULATE APPROPRIATE STOL RANGE AND SUM FPSQ AND NO. OF REFLS.       MI32  48
#                                                                       MI32  49
ifnv:(FPSQ)#                                                            MI32  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI32  51
ISBIN = MIN0(NBIN-1,NINT((STOL**3-STOLMN(1)**3)/GAP))#                  MI32  52
J = STAREM + ISBIN + 1#                                                 MI32  53
K = STAREM + STEPEM + ISBIN + 1#                                        MI32  54
QX(J) = QX(J) + FPSQ#                                                   MI32  55
QX(K) = QX(K) + 1.#                                                     MI32  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI32  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI32  58
RETURN#                                                                 MI32  59
END#                                                                    MI32  60
systemheader:(MI34)#                                                    MI34   1
# ################################################################## #  MI34   2
#                                                                    #  MI34   3
#                               MI34                                 #  MI34   4
#                                                                    #  MI34   5
# ################################################################## #  MI34   6
SUBROUTINE MI34#                       Allocate space in the qx array   MI34   7
#                                         For reflection and statistics MI34   8
#                                         Blocks.                       MI34   9
#                                        Dec 1979  s. sheriff           MI34  10
#                                        Revised jul 1980  s. sheriff   MI34  11
include:(AACOMN)#                                                       MI34  12
include:(MICOMN)#                                                       MI34  13
#                                                                       MI34  14
# SET UP STORAGE FOR REFLECTION INFORMATION                             MI34  15
#                                                                       MI34  16
STEPRO = 38#                           Allow 38 slots for               MI34  17
STARRO = STOPEM#                       Reflection information/set.      MI34  18
STOPRO = STARRO + NDATIN*STEPRO#                                        MI34  19
#                                                                       MI34  20
# SET UP STORAGE FOR STATISTICS GATHERING                               MI34  21
#                                                                       MI34  22
STEPS1 = 43#                                                            MI34  23
STEPS2 = 7#                                                             MI34  24
STEPS3 = 24#                                                            MI34  25
STEPS4 = 6#                                                             MI34  26
STEPS5 = 18#                                                            MI34  27
STEPS6 = 3#                                                             MI34  28
#                                                                       MI34  29
STARS1 = STOPRO#                                                        MI34  30
STOPS1 = STARS1 + STEPS1#                                               MI34  31
STARS2 = STOPS1#                                                        MI34  32
STOPS2 = STARS2 + STEPS2*(NBIN+1)*(NFBIN+1)#                            MI34  33
STARS3 = STOPS2#                                                        MI34  34
STOPS3 = STARS3 + STEPS3*(NBIN+1)*(NFBIN+1)*(NDATIN-1)#                 MI34  35
STARS4 = STOPS3#                                                        MI34  36
IF (FAZTYP == fazprb:)#                                                 MI34  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI34  38
STOPS4 = STARS4 + STEPS4*(NBIN+1)*(NFBIN+1)#                            MI34  39
STARS5 = STOPS4#                                                        MI34  40
STOPS5 = STARS5 + STEPS5*(NDATIN-1)*(NBIN+1)*(NFBIN+1)#                 MI34  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI34  42
#                                                                       MI34  43
ELSE#                                  Mvfc is the case; do not use     MI34  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI34  45
STOPS4 = STARS4#                       Statistics blocks 4 and 5.       MI34  46
STARS5 = STOPS4#                                                        MI34  47
STOPS5 = STARS5#                                                        MI34  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI34  49
#                                                                       MI34  50
STARS6 = STOPS5#                                                        MI34  51
STOPS6 = STARS6 + STEPS6*NDATIN#                                        MI34  52
#                                                                       MI34  53
IF(QXMAX < STOPS6+1)  iquit:(MI0501)#                                   MI34  54
qxmemory:(STOPS6+1)#                                                    MI34  55
#                                                                       MI34  56
RETURN#                                                                 MI34  57
END#                                                                    MI34  58
systemheader:(MI35)#                                                    MI35   1
# ################################################################## #  MI35   2
#                                                                    #  MI35   3
#                               MI35                                 #  MI35   4
#                                                                    #  MI35   5
# ################################################################## #  MI35   6
SUBROUTINE MI35#                       Allocate the partial deriv.      MI35   7
#                                         And matrix space and compute  MI35   8
#                                         The number of parameters to   MI35   9
#                                         Refine for each data set.     MI35  10
#                                         The pointer of data set '1'   MI35  11
#                                         Will be trivial.              MI35  12
#                                        Nov 1979  j.m. stewart         MI35  13
#                                        Revised may 1980               MI35  14
#                                         K.d. watenpaugh               MI35  15
include:(AACOMN)#                                                       MI35  16
include:(MICOMN)#                                                       MI35  17
include:(MIMAC9)#                      Add double precision macros      MI35  18
#                                                                       MI35  19
INTEGER I#                             Loop index                       MI35  20
INTEGER J#                             Another loop index               MI35  21
INTEGER KBPTR#                         Pointer to start of kb region    MI35  22
#                                         Of qx.                        MI35  23
INTEGER NKB#                           Number of scales and delta bs    MI35  24
#                                         To be refined.                MI35  25
INTEGER NPARAM#                        Number of parameters to refine   MI35  26
INTEGER STARRF#                        Pointer to start of refinement   MI35  27
#                                         Key list.                     MI35  28
INTEGER STOPRF#                        Pointer to end of refinement     MI35  29
#                                         Key list.                     MI35  30
#                                                                       MI35  31
STARPD = STOPS6#                       Set start of partial derivs.     MI35  32
#                                         Following statistics.         MI35  33
NPARAM = 0#                            Initialize parameter count       MI35  34
DO I=2,NDATIN#                         Loop thru the data sets to       MI35  35
#                                         Get number of parameters to   MI35  36
#                                         Refine.                       MI35  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI35  38
STARRF = REFPTR(I) + 1#                Starting and ending pointers     MI35  39
STOPRF = REFPTR(I+1)#                  Of refinement key list.          MI35  40
#                                                                       MI35  41
DO J=STARRF,STOPRF#                    Loop thru refinement checking    MI35  42
#                                         Switches.                     MI35  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI35  44
# INCREMENT NUMBER TO REFINE OF ITH DATA SET                            MI35  45
IF(QX(J) > 0.0)  NPAREF(I) = NPAREF(I) + 1#                             MI35  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI35  47
NPARAM = NPARAM + NPAREF(I)#           Total parameters so far          MI35  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI35  49
#                                                                       MI35  50
IF(NPARAM > maxparam:)  iquit:(MI3501)# Too many parameters             MI35  51
#                                                                       MI35  52
NPAREF(1) = 0#                         No parameter to refine on        MI35  53
#                                         Parent.                       MI35  54
DRVPTA(1) = STARPD#                    Set start pointer of partial     MI35  55
#                                         Deriv. 'a' of data set 'i'.   MI35  56
DO I=1,NDATIN#                         Loop over the data sets          MI35  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI35  58
# SET POINTER FOR DERIV. A' AND A" OF DATA SET 'I+1'.                   MI35  59
DRVPTA(I+1) = DRVPTA(I) + 2*(REFPTR(I+1)-REFPTR(I))#                    MI35  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI35  61
#                                                                       MI35  62
DRVPTB(1) = DRVPTA(NDATIN+1)#          Set pointer of partial deriv.    MI35  63
#                                         'b' of data set 'i'.          MI35  64
DO I=1,NDATIN#                         Loop over the data sets for      MI35  65
#                                         Partial 'b' pointers.         MI35  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI35  67
# SET POINTER FOR DERIV. B' AND B" OF DATA SET 'I+1'.                   MI35  68
DRVPTB(I+1) = DRVPTB(I) + 2*(REFPTR(I+1)-REFPTR(I))#                    MI35  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI35  70
#                                                                       MI35  71
STOPPD = DRVPTB(NDATIN+1)#             Set start of matrix area         MI35  72
STARMT = STOPPD#                                                        MI35  73
MTXPTR(1) = STARMT#                    Set pointer to matrix for        MI35  74
#                                         Data set '1'.                 MI35  75
KBPTR = STARKB - STEPKB#               Set pointer to start of          MI35  76
#                                         Scale/delta-b region.         MI35  77
DO I=1,NDATIN#                         Loop thru data sets to set       MI35  78
#                                         Matrix pointers.              MI35  79
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI35  80
KBPTR = KBPTR + STEPKB#                Jump to next set of scale/b      MI35  81
NKB = 0#                                                                MI35  82
IF(QX(KBPTR+2) > 0.)  NKB = 1#                                          MI35  83
IF(QX(KBPTR+4) > 0.)  NKB = NKB + 1#                                    MI35  84
NKB = NPAREF(I) + NKB#                                                  MI35  85
MTXPTR(I+1) = MTXPTR(I) + lmtxword:*((NKB)*(NKB+3))/2#                  MI35  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI35  87
STOPMT = MTXPTR(NDATIN+1)#             Set top of matrix area           MI35  88
IF(QXMAX < STOPMT+1)  iquit:(MI3502)#                                   MI35  89
qxmemory:(STOPMT+1)#                                                    MI35  90
#                                                                       MI35  91
RETURN#                                                                 MI35  92
END#                                                                    MI35  93
systemheader:(MI36)#                                                    MI36   1
# ################################################################## #  MI36   2
#                                                                    #  MI36   3
#                               MI36                                 #  MI36   4
#                                                                    #  MI36   5
# ################################################################## #  MI36   6
SUBROUTINE MI36#                                                        MI36   7
#                                                                       MI36   8
# ROUTINE TO PREPARE FOR STATISTICS BEFORE FIRST CYCLE OF EACH RUN      MI36   9
#   1) FROM INFORMATION COLLECTED BY MI34, CALCULATE AVERAGE F**2 FOR   MI36  10
#      EACH STOL BIN.                                                   MI36  11
#   2) FROM NUMBER OF F**2 BINS CALCULATE MAXIMUM NORMALIZED STRUCTURE  MI36  12
#      FACTOR FOR EACH F**2 BIN.                                        MI36  13
#   3) OUTPUT VALUE OF AVERAGE F**2 FOR EACH F**2-STOL BIN ALONG WITH   MI36  14
#      MAXIMUM NORMALIZED STRUCTURE FACTOR FOR EACH F**2 BIN            MI36  15
#   4) IN FAZPRB MODE OUTPUT LIST OF CLOSURE ERRORS FOR EACH ISOMORPH   MI36  16
#      CONTRIBUTING TO PHASING WHICH WILL BE USED ON FIRST CYCLE.  ALSO MI36  17
#      INDICATE SOURCE: A) DEFAULT; B) FROM BDF; C) INPUT.              MI36  18
#   5) MAKE SURE ALL VALUES FOR NUMBER OF BINS IN KB PART OF QX ARRAY   MI36  19
#      AGREE WITH NBIN AND NFBIN.                                       MI36  20
# CALLED FROM MI30                                                      MI36  21
#                                        Jul 1980  s. sheriff           MI36  22
#                                        Modified jun 1981  l. teneyck  MI36  23
include:(AACOMN)#                                                       MI36  24
include:(MICOMN)#                                                       MI36  25
#                                                                       MI36  26
INTEGER I#                             Loop index                       MI36  27
INTEGER ICHECK#                        Checks on whether data set       MI36  28
#                                         Name has been written.        MI36  29
INTEGER IFROM#                         Points to source of closure      MI36  30
#                                         Errors.                       MI36  31
INTEGER J#                             Another loop index               MI36  32
INTEGER K#                             Another loop index               MI36  33
INTEGER KBPTR#                         Points to bin numbers in kb      MI36  34
#                                         Part of qx array.             MI36  35
INTEGER KLOPTR#                        Points to closure errors in kb   MI36  36
#                                         Part of qx array.             MI36  37
INTEGER LENGTH#                        Length of output line            MI36  38
INTEGER NOUT#                          No. of items output on a line    MI36  39
INTEGER NAME#                          Index to dataset names           MI36  40
REAL FR1,FR2#                          Scratch variables                MI36  41
REAL FRACTN#                           Fraction of no. of f**2 bins     MI36  42
REAL STOL#                             (sine(theta)/lambda)**3 for a    MI36  43
#                                         Particular statistics bin.    MI36  44
string:(HEADER,mxchln:)#               Page heading for output          MI36  45
chardata:(MI361, STATISTICS BINS -- AVERAGE PARENT F**2 IN EACH BIN)#   MI36  46
chardata:(MI362, DMIN(ANGSTROMS))#                                      MI36  47
chardata:(MI363, F**2 BIN  ESQMAX)#                                     MI36  48
chardata:(MI364, CLOSURE ERRORS)#                                       MI36  49
chardata:(MI365, ISOMORPH)#                                             MI36  50
chardata:(MI366, ISOMORPHOUS FROM)#                                     MI36  51
chardata:(MI367, ANOMALOUS FROM)#                                       MI36  52
chardata:(MI368, DEFAULT BDF     INPUT  )#                              MI36  53
realdata:(FMT361,[240622.,320622.,$#                                    MI36  54
400622.,480622., 560622.,640622.,$#                                     MI36  55
720622.,800622., 880622.,960622.,$#                                     MI36  56
1040622.,1120622., 1200622.])#                                          MI36  57
realdata:(FMT362,[90613.,160522.,240613.,320613.,$#                     MI36  58
400613.,480613., 560613.,640613.,$#                                     MI36  59
720613.,800613., 880613.,960613.,$#                                     MI36  60
1040613.,1120613., 1200613.])#                                          MI36  61
realdata:(FMT363,[ 90513.,240613.,$#                                    MI36  62
320613.,400613., 480613.,560613.,$#                                     MI36  63
640613.,720613., 800613.,880613.,$#                                     MI36  64
960613.,1040613., 1120613.,1200613.])#                                  MI36  65
datastuff:#                                                             MI36  66
#                                                                       MI36  67
# CALCULATE AVERAGE F**2 FOR EACH STOL BIN                              MI36  68
#                                                                       MI36  69
DO I=1,NBIN#                           Loop over all stol bins          MI36  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI36  71
J = STAREM + I#                        Pointer to sum of fp**2          MI36  72
K = STAREM + STEPEM + I#               Pointer to number of terms       MI36  73
IF(QX(K) > 0.0)  QX(J) = QX(J)/QX(K)#                                   MI36  74
QX(K) = 0.0#                           Zero for new usage below         MI36  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI36  76
#                                                                       MI36  77
# CALCULATE MAXIMUM NORMALIZED STRUCTURE FACTOR FOR EACH F**2 BIN       MI36  78
#                                                                       MI36  79
J = STAREM + STEPEM + NFBIN#           Pointer to largest f**2 bin      MI36  80
QX(J) = 100.#                          Enormous normalized struc.       MI36  81
#                                         Factor for largest f**2 bin.  MI36  82
#                                                                       MI36  83
FOR(I=1; I <= (NFBIN-1); I=I+1)#                                        MI36  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI36  85
J = STAREM + STEPEM + I#               Pointer to f**2 bin              MI36  86
FRACTN = FLOAT(I)/FLOAT(NFBIN)#                                         MI36  87
QX(J) = -ALOG(1.0-FRACTN)#             Normalized intensity             MI36  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI36  89
#                                                                       MI36  90
IF(LINCT < (NFBIN+6))  LINCT = 0#      Create heading for output        MI36  91
writeline:(2,MI361,NMI361,3,3)#                                         MI36  92
LENGTH = 16 + NBIN*8#                  Calculate length of output       MI36  93
movechar:(BLANK,1,HEADER,1,mxchln:,1)# Clear out array from             MI36  94
#                                         Last usage.                   MI36  95
movechar:(MI362,1,HEADER,1,NMI362,0)#  Add dmin to header               MI36  96
STOL = STOLMN(1)**3#                                                    MI36  97
DO I=1,NBIN#                                                            MI36  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI36  99
STOL = STOL + GAP#                                                      MI36 100
BUFOT(I) = 1.0/(2.0*(STOL**.33333333))#                                 MI36 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI36 102
ncodefld:(BUFOT,1,HEADER,FMT361,NBIN)#                                  MI36 103
writeline:(1,HEADER,LENGTH,3,3)#                                        MI36 104
#                                                                       MI36 105
movechar:(MI363,1,CHROT,1,NMI363,0)#                                    MI36 106
writeline:(0,HEADER,LENGTH,1,3)#                                        MI36 107
#                                                                       MI36 108
NOUT = NBIN + 2#                       Output value of average f**2     MI36 109
DO I=1,NFBIN#                          For each f**2-stol bin.          MI36 110
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI36 111
FR2 = AMIN1(FLOAT(I)/FLOAT(NFBIN),0.99999)#                             MI36 112
FR1 = FLOAT(I-1)/FLOAT(NFBIN)#                                          MI36 113
FRACTN = ((1.0-FR2)*ALOG(1.0-FR2)-(1.0-FR1)*ALOG(1.0-FR1))/(FR2-FR1)$#  MI36 114
+1.0#                                                                   MI36 115
#                                                                       MI36 116
DO J=1,NBIN#                                                            MI36 117
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI36 118
K = STAREM + J#                                                         MI36 119
BUFOT(J+2) = FRACTN*QX(K)#                                              MI36 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI36 121
BUFOT(1) = FLOAT(I)#                   F**2 bin number                  MI36 122
K = STAREM + STEPEM + I#               Pointer to normalized s.f.       MI36 123
BUFOT(2) = QX(K)#                      Normalized intensity             MI36 124
ncodefld:(BUFOT,1,CHROT,FMT362,NOUT)#                                   MI36 125
writeline:(0,HEADER,LENGTH,1,3)#                                        MI36 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI36 127
#                                                                       MI36 128
# OUTPUT LIST OF CLOSURE ERRORS, IF USED                                MI36 129
#                                                                       MI36 130
IF(FAZTYP == fazprb:)#                 Faztyp was fazprb                MI36 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI36 132
NOUT = NBIN + 1#                       Output header                    MI36 133
IF(LINCT < (NFBIN+6))  LINCT = 0#                                       MI36 134
movechar:(MI364,1,CHROT,1,NMI364,0)#                                    MI36 135
writeline:(2,HEADER,LENGTH,1,3)#                                        MI36 136
#                                                                       MI36 137
DO I=1,NDATIN#                                                          MI36 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI36 139
ICHECK = no:#                          Check on whether data set        MI36 140
#                                         Identifier has been printed.  MI36 141
#                                                                       MI36 142
# ISOMORPHOUS CLOSURE ERRORS                                            MI36 143
#                                                                       MI36 144
#                                                                       MI36 145
IF((I != 1) &   $#                     No parent isom. closure err.     MI36 146
((ABS(FAZDA1(I)-1.0) < small:) \ $#    Isomorphous phasing              MI36 147
(ABS(FAZDA1(I)-3.0) < small:)))#       Isom and anom phasing            MI36 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI36 149
NAME = STARDN + (I-1)*STEPDN + 1#                                       MI36 150
movechar:(MI365,1,CHROT,1,NMI365,0)#                                    MI36 151
movertoc:(QX(NAME),1,CHROT,11,12,0)#   Data set name                    MI36 152
writeline:(1,HEADER,LENGTH,1,3)#                                        MI36 153
ICHECK = yes:#                         Dataset identifier written       MI36 154
#                                                                       MI36 155
movechar:(MI366,1,CHROT,1,NMI366,0)#                                    MI36 156
# ORIGIN OF ISOMORPHOUS CLOSURE ERRORS STORED AS FLAG IN                MI36 157
#  STOL BIN LOCATION.                                                   MI36 158
KBPTR = STARKB + (I-1)*STEPKB + 5#                                      MI36 159
IF(QX(KBPTR) > 10000.)  IFROM = 17#    Closure errors from inp. image   MI36 160
ELSE  IF(QX(KBPTR) > 1000.)  IFROM = 9# From bdf                        MI36 161
ELSE  IFROM = 1#                       Program default                  MI36 162
movechar:(MI368,IFROM,CHROT,NMI366+1,8,0)#                              MI36 163
IF(LINCT < (NFBIN+2))  LINCT = 0#      Force new page, if not enough    MI36 164
writeline:(0,HEADER,LENGTH,1,3)#       Room.                            MI36 165
#                                                                       MI36 166
DO J=1,NFBIN#                          Loop over all f**2 bins          MI36 167
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI36 168
DO K=1,NBIN#                           Over all stol bins               MI36 169
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI36 170
KLOPTR = STARKB + (I-1)*STEPKB + 6 + (J-1)*NBIN + K#                    MI36 171
BUFOT(K+1) = SQRT(QX(KLOPTR))#         Closure errors stored squared    MI36 172
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI36 173
BUFOT(1) = FLOAT(J)#                                                    MI36 174
ncodefld:(BUFOT,1,CHROT,FMT363,NOUT)#                                   MI36 175
writeline:(0,HEADER,LENGTH,1,3)#                                        MI36 176
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI36 177
#                                                                       MI36 178
# ANOMALOUS CLOSURE ERRORS                                              MI36 179
#                                                                       MI36 180
IF((ABS(FAZDA1(I)-2.0) < small:) \ $#  Anomalous phasing                MI36 181
(ABS(FAZDA1(I)-3.0) < small:))#        Isom and anom phasing            MI36 182
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI36 183
IF(ICHECK == no:)#                     Data set identifier not          MI36 184
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI36 185
NAME = STARDN + (I-1)*STEPDN + 1#      Written.                         MI36 186
movechar:(MI365,1,CHROT,1,NMI365,0)#                                    MI36 187
movertoc:(QX(NAME),1,CHROT,11,12,0)#   Data set name                    MI36 188
writeline:(1,HEADER,LENGTH,1,3)#                                        MI36 189
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI36 190
#                                                                       MI36 191
movechar:(MI367,1,CHROT,1,NMI367,0)#                                    MI36 192
KBPTR = STARKB + (I-1)*STEPKB + 6#                                      MI36 193
IF(QX(KBPTR) > 10000.)  IFROM = 17#    Closure errors from inp. image   MI36 194
ELSE  IF(QX(KBPTR) > 1000.)  IFROM = 9## From bdf                       MI36 195
ELSE  IFROM = 1#                       Program default                  MI36 196
movechar:(MI368,IFROM,CHROT,NMI367+1,8,0)#                              MI36 197
IF(LINCT < (NFBIN+2))  LINCT = 0#                                       MI36 198
writeline:(0,HEADER,LENGTH,1,3)#                                        MI36 199
#                                                                       MI36 200
DO J=1,NFBIN#                          Over all f**2 bins               MI36 201
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI36 202
DO K=1,NBIN#                           Over all stol bins               MI36 203
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI36 204
KLOPTR = STARKB + (I-1)*STEPKB + 56 + (J-1)*NBIN + K#                   MI36 205
BUFOT(K+1) = SQRT(QX(KLOPTR))#         Closure errors stored squared    MI36 206
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI36 207
BUFOT(1) = FLOAT(J)#                                                    MI36 208
ncodefld:(BUFOT,1,CHROT,FMT363,NOUT)#                                   MI36 209
writeline:(0,HEADER,LENGTH,1,3)#                                        MI36 210
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI36 211
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI36 212
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI36 213
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI36 214
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI36 215
#                                                                       MI36 216
# MAKE VALUES OF NUMBER OF STOL AND F**2 BINS IN QX ARRAY AGREE WITH    MI36 217
#  THOSE USED.  VALUES IN QX ARRAY WILL BE WRITTEN TO BDF.              MI36 218
#                                                                       MI36 219
DO I=1,NDATIN#                                                          MI36 220
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI36 221
KBPTR = STARKB + 5 + (I-1)*STEPKB#                                      MI36 222
QX(KBPTR) = FLOAT(NBIN)#                                                MI36 223
QX(KBPTR+1) = FLOAT(NFBIN)#                                             MI36 224
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI36 225
RETURN#                                                                 MI36 226
END#                                                                    MI36 227
systemheader:(MI38)#                                                    MI38   1
# ################################################################## #  MI38   2
#                                                                    #  MI38   3
#                               MI38                                 #  MI38   4
#                                                                    #  MI38   5
# ################################################################## #  MI38   6
SUBROUTINE MI38#                       Cycle of refinement begins       MI38   7
#                                      Advance the cycle counter.       MI38   8
include:(AACOMN)#                                                       MI38   9
include:(MICOMN)#                                                       MI38  10
#                                                                       MI38  11
INTEGER SPAN#                          Size of matrix plus              MI38  12
#                                         Derivative region.            MI38  13
INTEGER NSET#                          Do loop index over the number    MI38  14
#                                         Of data sets.                 MI38  15
chardata:(MI381, ********** BEGIN CYCLE     **********)#                MI38  16
realdata:(FMT381,[270413.])#                                            MI38  17
realdata:(NUL,[0.])#                                                    MI38  18
datastuff:#                                                             MI38  19
#                                                                       MI38  20
ICYC = ICYC + 1#                       Count cycle and list it          MI38  21
BUFOT(1) = FLOAT(ICYC)#                                                 MI38  22
ncodefld:(BUFOT,1,MI381,FMT381,1)#                                      MI38  23
LINCT = 0#                             Force new page                   MI38  24
writeline:(1,MI381,NMI381,3,3)#                                         MI38  25
#                                                                       MI38  26
SPAN = STOPMT - STARMT#                Calculate matrix and             MI38  27
#                                         Derivative region length.     MI38  28
movereal:(NUL,1,QX,STARMT+1,SPAN,2)#   Clear array                      MI38  29
SPAN = STOPS6 - STARS1#                Length of statistics array       MI38  30
movereal:(NUL,1,QX,STARS1+1,SPAN,2)#   Clear 'em all                    MI38  31
#                                                                       MI38  32
DO NSET=2,NDATIN#                      Initialize no. of refls. and     MI38  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI38  34
NREF(NSET) = 0#                        Chi**@ for each data set.        MI38  35
WTDFSQ(NSET) = 0.0#                                                     MI38  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI38  37
#                                                                       MI38  38
ICTREF = 0#                            Zero internal reflection         MI38  39
#                                         Count at beginning of cycle.  MI38  40
CANTPH = 0#                            Unphaseable (mvfc) refl. count   MI38  41
RETURN#                                                                 MI38  42
END#                                                                    MI38  43
systemheader:(MI40)#                                                    MI40   1
# ################################################################## #  MI40   2
#                                                                    #  MI40   3
#                               MI40                                 #  MI40   4
#                                                                    #  MI40   5
# ################################################################## #  MI40   6
SUBROUTINE MI40#                       S.r.hall & j.m.stewart 1979      MI40   7
#                                                                       MI40   8
#  IT IS RESPONSIBLE FOR READING A REFLECTION PACKET FROM THE           MI40   9
#  BINARY DATA FILE (RECORD LRREFL:) AND PREPARING BASIC CRYSTAL        MI40  10
#  AND SYMMETRY INFORMATION FOR THE MIR CALCULATION ROUTINES            MI40  11
#  THAT IT CALLS.  THIS PREPARATION INCLUDES UNPACKING H, K,            MI40  12
#  AND L, AND GENERATING A UNIQUE SET OF EQUIVALENT INDICES WITH        MI40  13
#  THE TRANSLATION FRACTION.  SCATTERING FACTORS ARE ALSO               MI40  14
#  INTERPOLATED FOR USE IN THE STRUCTURE FACTOR LEAST SQUARES           MI40  15
#  ROUTINES.  CALCULATION ROUTINES MI45-MI65 ARE CALLED IN THE          MI40  16
#  REQUIRED MIR SEQUENCE.  FINALLY THE INPUT AND CALCULATED             MI40  17
#  DATA ARE PLACED IN THE OUTPUT BUFFER FOR TRANSFER TO THE             MI40  18
#  BINARY DATA FILE (FILE B).                                           MI40  19
#                                        Revised mar 1981  s. sheriff   MI40  20
include:(AACOMN)#                                                       MI40  21
include:(MICOMN)#                                                       MI40  22
#                                                                       MI40  23
INTEGER ABSH(3)#                       Absolute values of parent hkl    MI40  24
INTEGER ATTYP#                         Do loop index over atom types    MI40  25
INTEGER ARGAT#                         Pointer into form factor table   MI40  26
INTEGER COUNT#                         Counter of number of items in    MI40  27
#                                         Input logical record lrrefl:. MI40  28
INTEGER FAZDIF#                        Phase restriction pointer        MI40  29
INTEGER FFPTR#                         Pointer to a particular item     MI40  30
#                                         In the starff region.         MI40  31
INTEGER FIPTR#                         Pointer to a particular item     MI40  32
#                                         In the starfi region.         MI40  33
INTEGER HINDX#                         Pointer to next hklt in starh    MI40  34
#                                         Region.                       MI40  35
REAL HKL(3)#                           H,k,l temporary storage          MI40  36
INTEGER HPTR#                          Pointer to a particular item     MI40  37
#                                         In the starh region.          MI40  38
INTEGER I#                             Loop index                       MI40  39
INTEGER IBREAK#                        Flag to indicate that end of     MI40  40
#                                         Lrrefl: has been reached.     MI40  41
INTEGER IPT#                           Input packet pointer             MI40  42
INTEGER IPTR#                          Pointer to a particular item     MI40  43
#                                         In the input i/o buffer.      MI40  44
INTEGER J#                             Another loop index               MI40  45
INTEGER K#                             Another loop index               MI40  46
INTEGER KPUT#                          Pointer to individual hkl        MI40  47
#                                         Quantities.                   MI40  48
INTEGER MPTR#                          Another bloody pointer           MI40  49
#                                         Input lrrefl:.                MI40  50
INTEGER MULT#                          Reflection multiplicity          MI40  51
INTEGER PHAZ(24)#                      Phase codes for current refl.    MI40  52
INTEGER PSIZE#                         Input packet size                MI40  53
INTEGER ROPTR#                         Pointer to a particular item     MI40  54
#                                         In the starro region.         MI40  55
INTEGER SAME#                          Number of hkls with same         MI40  56
#                                         Absolute indices.             MI40  57
INTEGER SIGN(24)#                      Sign codes for current refl.     MI40  58
INTEGER SIZERO#                        Length of ro common region for   MI40  59
#                                         Initialization.               MI40  60
INTEGER SYNCOD#                        Value corresponds to number of   MI40  61
#                                         Plus signs in miller index.   MI40  62
INTEGER SYPTR#                         Pointer to a particular item     MI40  63
#                                         In the starsy region.         MI40  64
INTEGER SYSABS#                        Flag turned on if a reflection   MI40  65
#                                         Should not have been present. MI40  66
REAL VOID(1)#                          Holds voidflg:                   MI40  67
chardata:(MI401, SYMOPS SAY             SHOULD BE ABSENT - IGNORED)#    MI40  68
realdata:(FMT401,[150413.,190413.,230413.])#                            MI40  69
intdata:(JPH,[ 0,2,3,4,0,$#            Phase restriction codes          MI40  70
5,0,6,7,8,0,1,0,2,3,4,0,5,0,6])#                                        MI40  71
intdata:(NWANT,[9])#                   Count of number of wants         MI40  72
realdata:(SGNHKL,[4.,2.,1.,0.])#       Values for constructing          MI40  73
intdata:(NUMPAS,[0])#                  Zero passes thru mi40            MI40  74
datastuff:#                                                             MI40  75
#                                                                       MI40  76
########## DEFINE PROCEDURE NAMES USED IN THIS ROUTINE ############# #  MI40  77
defineproc:(INITIAL)#                  Initialize parameters for        MI40  78
#                                         Reading lrrefl:.              MI40  79
defineproc:(GETREF)#                   Get reflection information       MI40  80
#                                         From lrrefl:.                 MI40  81
defineproc:(RESETFAZ)#                 Combine phases with external     MI40  82
defineproc:(SYMCODE)#                  Determine symmetry code          MI40  83
defineproc:(SCATFACT)#                 Get scattering factor for this   MI40  84
#                                         Reflection.                   MI40  85
defineproc:(SETANFLG)#                 Set flags for phasing and        MI40  86
#                                         Refining.                     MI40  87
defineproc:(PUTREF)#                   Put reflection information       MI40  88
#                                         Into lrrefl:.                 MI40  89
########## END OF PROCEDURE NAME DEFINITIONS ####################### #  MI40  90
#                                                                       MI40  91
NUMPAS = NUMPAS + 1#                   Number of pass thru mi40         MI40  92
xeq:(INITIAL)#                         Set parameters for reading       MI40  93
#                                         Logical record lrrefl:.       MI40  94
#                                                                       MI40  95
REPEAT#                                Reflection processing loop       MI40  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI40  97
xeq:(GETREF)#                          Copy quantities from i/o         MI40  98
#                                         Buffer to starro block.       MI40  99
#                                                                       MI40 100
IF(IBREAK == yes:)  BREAK#             Exit after last packet           MI40 101
#                                                                       MI40 102
xeq:(SYMCODE)#                         Get symmetry codes               MI40 103
#                                                                       MI40 104
IF(SYSABS == yes:)  NEXT#              Skip reflection which should     MI40 105
#                                         Have been absent.             MI40 106
#                                                                       MI40 107
xeq:(SCATFACT)#                        Get scattering factors           MI40 108
#                                                                       MI40 109
xeq:(SETANFLG)#                        Set flags for phasing and        MI40 110
#                                         Refining.                     MI40 111
#                                                                       MI40 112
IF(ABS(anflg:(STARRO)) > small:)#      Do the rest if native data       MI40 113
#                                         Are present.                  MI40 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI40 115
ICTREF = ICTREF + 1#                   Internal reflection counter      MI40 116
#                                                                       MI40 117
CALL MI45#                             Structure factor routine         MI40 118
#                                                                       MI40 119
CALL MI47#                             Extract and prepare data         MI40 120
#                                         For phasing calculations.     MI40 121
#                                         Also checks on useful data.   MI40 122
#                                         Call mi48 and mi49.           MI40 123
IF(FAZTYP == fazprb:)#                                                  MI40 124
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI40 125
CALL MI50#                             Phase probability routines       MI40 126
#                                         Call mi52-mi56 and mi58.      MI40 127
IF (FAZA2!=0) xeq:(RESETFAZ)#                                           MI40 128
CALL MI63#                             R factor statistics routine      MI40 129
CALL MI64#                             Closure error statistics         MI40 130
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI40 131
#                                                                       MI40 132
ELSE  IF(FAZTYP == mvfc:)#                                              MI40 133
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI40 134
CALL MI61#                             Min. variance fourier coeff.     MI40 135
IF (FAZA2!=0) xeq:(RESETFAZ)#                                           MI40 136
CALL MI63#                             R factor statistics routine      MI40 137
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI40 138
#                                                                       MI40 139
CALL MI65#                             Build least squares matrices     MI40 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI40 141
#                                                                       MI40 142
xeq:(PUTREF)#                          Now copy back to i/o buffer      MI40 143
#                                         Reflections modified by data  MI40 144
#                                         Set quantities.               MI40 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI40 146
#                                                                       MI40 147
rewindbdf:(3)#                                                          MI40 148
RETURN#                                                                 MI40 149
# ##################### INITIAL #################################### #  MI40 150
procedure:(INITIAL)#                                                    MI40 151
SIZERO = STOPRO - STARRO#              To initialize refl. region       MI40 152
IBREAK = no:#                          Set flag to initial value        MI40 153
readwpkt:(3,lrrefl:,PSIZE,IPT,3)#      Read past directory              MI40 154
endproc:(INITIAL)#                                                      MI40 155
#                                                                       MI40 156
# ##################### GETREF ##################################### #  MI40 157
procedure:(GETREF)#                                                     MI40 158
# INITIALIZE REFLECTION REGION TO VOID                                  MI40 159
VOID(1) = voidflg:#                                                     MI40 160
movereal:(VOID,1,QX(STARRO),1,SIZERO,2)#                                MI40 161
readwpkt:(3,lrrefl:,PSIZE,IPT,3)#      Point to input packet            MI40 162
IF(IPT == 0)  IBREAK = yes:#           Exit after last packet           MI40 163
ELSE#                                  Read in reflection               MI40 164
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI40 165
# EXTRACT H K L SINT/L                                                  MI40 166
movepakwd:(QX(IPT+1),QX(STARCR+10))#   Move packed hkl to storage       MI40 167
gethkl:(IPT+1,HKL)#                    Unpack hkl values                MI40 168
movereal:(HKL,1,QX,STARCR+1,3,0)#      Put unpacked to storage          MI40 169
stol:=QX(IPT+2)#                       Store                            MI40 170
intunpak:(QX(IPT+3),MULT,0,5)#         Unpack refl. multiplicity        MI40 171
multiplicity: = FLOAT(MULT)#           Stoore as floating value         MI40 172
#                                                                       MI40 173
# EXTRACT FIGURE OF MERIT, BEST AND MOST PROBABLE PHASES                MI40 174
#                                                                       MI40 175
KPUT = NDATIN*NWANT+ 4 + IPT#                                           MI40 176
figmer:=QX(KPUT)#                                                       MI40 177
cosbst:=QX(KPUT+1)#                                                     MI40 178
sinbst:=QX(KPUT+2)#                                                     MI40 179
cosmp:=QX(KPUT+3)#                                                      MI40 180
sinmp:=QX(KPUT+4)#                                                      MI40 181
#                                                                       MI40 182
# IF FIRST CYCLE AND INITIAL PHASE INFO REQUESTED ON FAZIN LINE, THEN   MI40 183
#  GET THAT INFO FROM THE BDF ITEMS FAZA1 AND FAZB1. IF FAZB MISSING,   MI40 184
#  THEN PHASE IN MILLICYCLES IN IS ITEM FAZA, ELSE A AND B TERMS ARE    MI40 185
#  IN FAZA AND FAZB. PUT THE PHASE INFO INTO COSBST: AND SINBST:        MI40 186
#                                                                       MI40 187
IF (NUMPAS == 1)## If wanted substitute phases on first pass            MI40 188
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI40 189
IF (FAZA1 != 0)## Get cos(a) and sin(a) portion of phase                MI40 190
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI40 191
figmer:=QX(IPT+FAZPT1)#                                                 MI40 192
cosbst:=QX(IPT+FAZPT1+1)#                                               MI40 193
sinbst:=QX(IPT+FAZPT1+2)#                                               MI40 194
sinmp:=sinbst:#                                                         MI40 195
cosmp:=cosbst:#                                                         MI40 196
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI40 197
IF (FAZA2!=0) xeq:(RESETFAZ)#          Combine phases if desired        MI40 198
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI40 199
#                                                                       MI40 200
#                                                                       MI40 201
# GET REQUESTED BDF INPUT                                               MI40 202
# NOW MOVE DOWN THROUGH THE VARIOUS DATA SETS PICKING UP THE            MI40 203
#  SPECIFIED QUANTITIES WHICH EXIST AND PLACING THEM IN THE             MI40 204
#  DATASET REFLECTION STORAGE REGIONS.                                  MI40 205
#                                                                       MI40 206
COUNT = 3#                             Set input counter                MI40 207
DO J=1,NDATIN#                         Loop over all datasets           MI40 208
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI40 209
# FIND THE DATA SET OFFSET AMOUNT WHICH MARKS THE BEGINNING OF          MI40 210
#  EACH STEPRO WITHIN THE STARRO REGION.                                MI40 211
ROPTR = STARRO + (J-1)*STEPRO#                                          MI40 212
DO K=1,NWANT#                          Scan over the wants for the      MI40 213
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI40 214
COUNT = COUNT + 1#                     Current data set.                MI40 215
ROPTR = ROPTR + 1#                                                      MI40 216
IPTR = COUNT + IPT#                                                     MI40 217
# MOVE THE DATUM FROM THE I/O BUFFER TO THE STARRO REGION               MI40 218
#                                                                       MI40 219
QX(ROPTR+1) = QX(IPTR)#                                                 MI40 220
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI40 221
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI40 222
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI40 223
endproc:(GETREF)#                                                       MI40 224
#                                                                       MI40 225
# ##################### RESETFAZ ####################################   MI40 226
procedure:(RESETFAZ)#                                                   MI40 227
# COMBINE PHASES IF REQUESTED AND PHASES ARE PRESENT                    MI40 228
K = IPT+FAZPT2#                        Pointer to fom and phases        MI40 229
ifvo:(cosbst:)#                                                         MI40 230
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI40 231
figmer:=QX(K)#                                                          MI40 232
cosbst:=QX(K+1)#                                                        MI40 233
sinbst:=QX(K+2)#                                                        MI40 234
cosmp:=cosbst:#                                                         MI40 235
sinmp:=sinbst:#                                                         MI40 236
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI40 237
ELSE ifnv:(QX(K+1))#                                                    MI40 238
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI40 239
cosbst: = figmer:*cosbst: + QX(K)*QX(K+1)# Combine weighted phases      MI40 240
sinbst: = figmer:*sinbst: + QX(K)*QX(K+2)# Combine weighted phases      MI40 241
TEMP = SQRT(cosbst:**2+sinbst:**2)#    Normalize cos(a) and sin(a)      MI40 242
IF (TEMP < 0.01)#                                                       MI40 243
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI40 244
figmer: = 0.0#                                                          MI40 245
cosbst: = voidflg:#                                                     MI40 246
sinbst: = voidflg:#                                                     MI40 247
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI40 248
ELSE#                                                                   MI40 249
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI40 250
cosbst: = cosbst:/TEMP#                                                 MI40 251
sinbst: = sinbst:/TEMP#                                                 MI40 252
figmer: = 0.25*TEMP*(figmer:+QX(K))#                                    MI40 253
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI40 254
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI40 255
endproc:(RESETFAZ)#                                                     MI40 256
#                                                                       MI40 257
# ##################### SYMCODE #################################### #  MI40 258
procedure:(SYMCODE)#                                                    MI40 259
HPTR = STARH#                          Start of hklts list              MI40 260
SYPTR = STARSY#                        Mark start of symops             MI40 261
WHILE(SYPTR < STOPSY)#                 Loop over all symops             MI40 262
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI40 263
QX(HPTR+5) = 0.#                       Initialize sign code             MI40 264
DO J=1,4#                              Get transformed h,k,l, phase,    MI40 265
#                                         And sign codes.               MI40 266
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI40 267
HINDX = HPTR + J#                      Point to transformed index       MI40 268
QX(HINDX) = QX(STARCR+1)*QX(SYPTR+1) + QX(STARCR+2)*QX(SYPTR+2)$#       MI40 269
+ QX(STARCR+3)*QX(SYPTR+3)#            Apply the symop                  MI40 270
SYPTR = SYPTR + 3#                     Advance symop pointer            MI40 271
IF(QX(HINDX) > (-0.5))  NEXT#          If negative result for hkl,      MI40 272
QX(HPTR+5) = QX(HPTR+5) + SGNHKL(J)#   Adjust sign code.                MI40 273
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI40 274
QX(HPTR+4) = AMOD(QX(HPTR+4),1.)#      Translation component            MI40 275
HPTR = HPTR + STEPH#                   Point to next hkl                MI40 276
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI40 277
STOPH = HPTR#                          Mark end of transformed hkl      MI40 278
#                                                                       MI40 279
DO I=1,3#                              Pick up absolute values of       MI40 280
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MI40 281
HPTR = STARH + I#                      Parent hkl (i.e,. the hkl        MI40 282
ABSH(I) = NINT(ABS(QX(HPTR)))#         With no symop applied).          MI40 283
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MI40 284
#                                                                       MI40 285
SYNCOD = 9#                            This is a code for finding out   MI40 286
#                                         Which refls. are friedel-     MI40 287
#                                         Related.  it must be adjusted MI40 288
#                                         For any zeroes present.       MI40 289
IF(ABSH(1) == 0)  SYNCOD = SYNCOD - 4# H = 0                            MI40 290
IF(ABSH(2) == 0)  SYNCOD = SYNCOD - 2# K = 0                            MI40 291
IF(ABSH(3) == 0)  SYNCOD = SYNCOD - 1# L = 0                            MI40 292
#                                                                       MI40 293
SAME = 0#                              Initialize count of refls.       MI40 294
#                                         With same abs. hkl.           MI40 295
HPTR = STARH - STEPH#                  Initialize hkl pointer           MI40 296
#                                                                       MI40 297
DO K=1,NROT#                           Loop over all symopped refls.    MI40 298
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MI40 299
HPTR = HPTR + STEPH#                   Point to next hkl                MI40 300
#                                                                       MI40 301
# LOOK FOR ONLY THOSE HKLS WHICH ARE NOT PERMUTATIONS OF THE ORIGINAL   MI40 302
#  HKL.                                                                 MI40 303
#                                                                       MI40 304
IF(ABSH(1) != NINT(ABS(QX(HPTR+1))))  NEXT#                             MI40 305
IF(ABSH(2) != NINT(ABS(QX(HPTR+2))))  NEXT#                             MI40 306
IF(ABSH(3) != NINT(ABS(QX(HPTR+3))))  NEXT#                             MI40 307
#                                                                       MI40 308
SAME = SAME + 1#                       Found one                        MI40 309
SIGN(SAME) = NINT(QX(HPTR+5)) + 1#     Save its sign code               MI40 310
PHAZ(SAME) = NINT(QX(HPTR+4)*24.)#     And phase shift (as an           MI40 311
#                                         Integral fraction of 24).     MI40 312
IF(PHAZ(SAME)==24)PHAZ(SAME)=0#        Phaz must not exceed 24          MI40 313
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MI40 314
#                                                                       MI40 315
IPRC = 0#                              No phase restriction (default)   MI40 316
SYSABS = no:#                                                           MI40 317
#                                                                       MI40 318
DO I=2,SAME#                           Now look for sytematically       MI40 319
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MI40 320
FOR(J=1; J < I; J=J+1)#                Absent indices.                  MI40 321
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MI40 322
IF(SIGN(I) == SIGN(J))#                If both the signs and phases     MI40 323
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MI40 324
IF(PHAZ(I) != PHAZ(J))#                Codes are identical, then        MI40 325
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MI40 326
SYSABS = yes:#                         The reflection should not        MI40 327
movechar:(MI401,1,CHROT,1,NMI401,0)#   Been included.  tell the user    MI40 328
ncodefld:(QX,STARCR+1,CHROT,FMT401(1),3)#                               MI40 329
writeline:(1,0,0,1,3)#                                                  MI40 330
BREAK#                                                                  MI40 331
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MI40 332
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MI40 333
#                                                                       MI40 334
IF((SIGN(I)+SIGN(J)) == SYNCOD)#       If refls. are friedel-related,   MI40 335
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MI40 336
IF(J == 1 \ IPRC == 0)#                Then find one of the phases      MI40 337
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MI40 338
FAZDIF = MOD((PHAZ(I)-PHAZ(J)+24),24)/2# To which the original refl.    MI40 339
IF(FAZDIF == 0)  FAZDIF = 12#          Is restricted.  the other        MI40 340
IPRC = JPH(FAZDIF)#                    Possible phase will be 180       MI40 341
#                                         Degrees away from that.       MI40 342
#                                         Iprc is actually a pointer    MI40 343
#                                         To a table of phases in mi61. MI40 344
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MI40 345
BREAK#                                                                  MI40 346
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MI40 347
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MI40 348
IF(SYSABS == yes:)  BREAK#                                              MI40 349
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MI40 350
endproc:(SYMCODE)#                                                      MI40 351
#                                                                       MI40 352
# ##################### SCATFACT #################################### # MI40 353
procedure:(SCATFACT)#                                                   MI40 354
# GETS SCATTERING FACTORS FOR ALL ATOMS AT THE SINE(THETA)/LAMBDA       MI40 355
#  FOR THIS REFLECTION; THUS, IN STRUCTURE FACTOR CALCULATOR, ONLY      MI40 356
#  A TABLE LOOKUP NEEDS TO BE DONE TO GET SCATTERING FACTOR.            MI40 357
#                                                                       MI40 358
FFPTR = STARFF#                        Start of form factor tables      MI40 359
FIPTR = STARFI#                        Start of form factor pairs       MI40 360
# POINT TO VALUE IN FORM FACTOR TABLE                                   MI40 361
SITOL = stol:*100.#                                                     MI40 362
ARGAT = INT(SITOL)/DELFF#                                               MI40 363
FRACT = SITOL/FLOAT(DELFF) - FLOAT(ARGAT)#                              MI40 364
ARGAT = STARFF + ARGAT + 3#                                             MI40 365
DO ATTYP=1,NATTYP#                     Loop over atom types and calc.   MI40 366
#                                         F(nonanom)+f(real anom).      MI40 367
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MI40 368
QX(FIPTR+1) = QX(ARGAT) - FRACT*(QX(ARGAT)-QX(ARGAT+1))+QX(FFPTR+1)#    MI40 369
FFPTR = FFPTR + STEPFF#                Incr. to next atom type          MI40 370
FIPTR = FIPTR + 2#                     Incr. form factor pairs          MI40 371
ARGAT = ARGAT + STEPFF#                Incr. to next atom type          MI40 372
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MI40 373
endproc:(SCATFACT)#                                                     MI40 374
#                                                                       MI40 375
# ##################### SETANFLG ################################### #  MI40 376
procedure:(SETANFLG)#                                                   MI40 377
DO J=1,NDATIN#                         Loop over all data sets          MI40 378
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MI40 379
# FIND THE DATA SET OFFSET AMOUNT WHICH MARKS THE BEGINNING OF          MI40 380
#  EACH STEPRO WITHIN THE STARRO REGION.                                MI40 381
#                                                                       MI40 382
ROPTR = STARRO + (J-1)*STEPRO#                                          MI40 383
#                                                                       MI40 384
anflg:(ROPTR) = FAZDA1(J)#             Initialize phasing/refinement    MI40 385
#                                         Flag.                         MI40 386
IF(IPRC != 0 & ABS(anflg:(ROPTR)-3.) < small:)  anflg:(ROPTR) = 1.0#    MI40 387
#                                        Use only sir, if centric       MI40 388
IF(IPRC != 0 & ABS(anflg:(ROPTR)-2.) < small:)  anflg:(ROPTR) = 0.0#    MI40 389
#                                        Don't use if centric and       MI40 390
#                                         Want anomalous.               MI40 391
IF(frelp:(ROPTR) <= small: & frelm:(ROPTR) <= small:)$#                 MI40 392
anflg:(ROPTR) = 0.0#                                                    MI40 393
#                                        No f**2 values to use          MI40 394
IF((stol: < STOLMN(J)) \ (stol: > STOLMX(J)))  anflg:(ROPTR) = 0.0#     MI40 395
#                                                                       MI40 396
# MORE CHECKS FOR SETTING ANFLG GO IN HERE                              MI40 397
#                                                                       MI40 398
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MI40 399
endproc:(SETANFLG)#                                                     MI40 400
#                                                                       MI40 401
# ##################### PUTREF ##################################### #  MI40 402
procedure:(PUTREF)#                                                     MI40 403
QX(KPUT)=figmer:#                                                       MI40 404
QX(KPUT+1)=cosbst:#                                                     MI40 405
QX(KPUT+2)=sinbst:#                                                     MI40 406
QX(KPUT+3)=cosmp:#                                                      MI40 407
QX(KPUT+4)=sinmp:#                                                      MI40 408
#                                                                       MI40 409
MPTR = 3#                                                               MI40 410
#                                                                       MI40 411
DO J=1,NDATIN#                         Loop over all data sets          MI40 412
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MI40 413
ROPTR = STARRO + (J-1)*STEPRO#                                          MI40 414
DO K=1,NWANT#                                                           MI40 415
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MI40 416
MPTR = MPTR + 1#                                                        MI40 417
ROPTR = ROPTR + 1#                                                      MI40 418
IPTR = MPTR + IPT#                                                      MI40 419
QX(IPTR) = QX(ROPTR+1)#                                                 MI40 420
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MI40 421
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MI40 422
endproc:(PUTREF)#                                                       MI40 423
#                                                                       MI40 424
######### REMOVE PROCEDURES ################################            MI40 425
deleteproc:(INITIAL)#                                                   MI40 426
deleteproc:(GETREF)#                                                    MI40 427
deleteproc:(RESETFAZ)#                                                  MI40 428
deleteproc:(SYMCODE)#                                                   MI40 429
deleteproc:(SCATFACT)#                                                  MI40 430
deleteproc:(SETANFLG)#                                                  MI40 431
deleteproc:(PUTREF)#                                                    MI40 432
#                                                                       MI40 433
END#                                                                    MI40 434
systemheader:(MI45)#                                                    MI45   1
# ################################################################## #  MI45   2
#                                                                    #  MI45   3
#                               MI45                                 #  MI45   4
#                                                                    #  MI45   5
# ################################################################## #  MI45   6
SUBROUTINE MI45#                                                        MI45   7
#                                                                       MI45   8
# ROUTINE TO CALCULATE PARTIAL DERVATIVES AND HEAVY ATOM CONTRIBUTIONS  MI45   9
#  TO THE STRUCTURE FACTORS.                                            MI45  10
# CODED BY KEITH D. WATENPAUGH                                          MI45  11
# VARIABLE NAMES OF THIS ROUTINE ARE GENERALLY BUILT UP OUT OF          MI45  12
#  LETTERS THAT HAVE SPECIAL MEANING.                                   MI45  13
#  SYMBOLIC NAMES WITH 'X' REFER TO THE XTH DATA SET                    MI45  14
#  SYMBOLIC NAMES BEGINING WITH 'A' ARE THE REAL COMPONENT OF A.        MI45  15
#  COEFFICIENT BEGINNING WITH 'B' ARE THE IMAGINARY COMPONENT.          MI45  16
#  'J' MEANS THE JTH ATOM.                                              MI45  17
#  'K' THE THE KTH EQUIVALENT INDEX.                                    MI45  18
#  'P' (PRIME) MEANS THE REAL SCATTERING PART.                          MI45  19
#  'PP'(DOUBLE PRIME) MEANS THE ANOMALOUS SCATTERING PART.              MI45  20
#  'C' MEANS EXP(-THERMAL*S**2).                                        MI45  21
#  'DRV' MEANS THE PARTIAL DERIVIATIVE OF                               MI45  22
#  'SUM' OR 'SM' MEANS A SUMATION OF THE SET.                           MI45  23
#  VARIABLE 'N' IS A TEMPORARY INDEX USED FOR LOCAL SUBSCRIPTING.       MI45  24
#                                                                       MI45  25
include:(AACOMN)#                                                       MI45  26
include:(MICOMN)#                                                       MI45  27
#                                                                       MI45  28
INTEGER DRVAP#                                                          MI45  29
INTEGER DRVAPP#                                                         MI45  30
INTEGER DRVBP#                                                          MI45  31
INTEGER DRVBPP#                                                         MI45  32
INTEGER J#                                                              MI45  33
INTEGER J1#                                                             MI45  34
INTEGER JJ#                                                             MI45  35
INTEGER K#                                                              MI45  36
INTEGER K1#                                                             MI45  37
INTEGER KK#                                                             MI45  38
INTEGER N#                                                              MI45  39
INTEGER N1#                                                             MI45  40
INTEGER NPARAM#                                                         MI45  41
INTEGER NSET#                                                           MI45  42
INTEGER PTRRO#                                                          MI45  43
INTEGER STAHEQ#                                                         MI45  44
INTEGER STARJX#                                                         MI45  45
INTEGER STARRF#                                                         MI45  46
INTEGER STEHEQ#                                                         MI45  47
INTEGER STOHEQ#                                                         MI45  48
INTEGER STOPJX#                                                         MI45  49
INTEGER STOPRF#                                                         MI45  50
REAL APJK#                                                              MI45  51
REAL APPJK#                                                             MI45  52
REAL ARG#                                                               MI45  53
REAL BPJK#                                                              MI45  54
REAL BPPJK#                                                             MI45  55
REAL CJ#                                                                MI45  56
REAL COSARG#                                                            MI45  57
REAL INDEX(240)#                                                        MI45  58
REAL NUL(1)#                           Holds zero                       MI45  59
REAL POPFJ#                                                             MI45  60
REAL POPFAJ#                                                            MI45  61
REAL SINARG#                                                            MI45  62
REAL SMAP#                                                              MI45  63
REAL SMAPJ#                                                             MI45  64
REAL SMAPP#                                                             MI45  65
REAL SMAPPJ#                                                            MI45  66
REAL SMBP#                                                              MI45  67
REAL SMBPJ#                                                             MI45  68
REAL SMBPP#                                                             MI45  69
REAL SMBPPJ#                                                            MI45  70
REAL SSQRD#                                                             MI45  71
#                                                                       MI45  72
SSQRD = stol:**2#                      Calc. [sin(t)/lam]**2            MI45  73
J = 1#                                                                  MI45  74
STAHEQ = 1#                            Start of equivalent indices      MI45  75
STEHEQ = 10#                           Number of individual             MI45  76
#                                         Components.                   MI45  77
FOR(N=STARH; N <= STOPH-1; N=N+STEPH)# Modify symmetrically-related     MI45  78
#                                         Indices to speed up           MI45  79
#                                         Derivative calculation loop.  MI45  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI45  81
INDEX(J)   = QX(N+4)*TWOPI#            2pi*translation component        MI45  82
INDEX(J+1) = QX(N+1)*TWOPI#            2pi*h                            MI45  83
INDEX(J+2) = QX(N+2)*TWOPI#            2pi*k                            MI45  84
INDEX(J+3) = QX(N+3)*TWOPI#            2pi*l                            MI45  85
INDEX(J+4) = QX(N+1)**2#               H*h                              MI45  86
INDEX(J+5) = QX(N+2)**2#               K*k                              MI45  87
INDEX(J+6) = QX(N+3)**2#               L*l                              MI45  88
INDEX(J+7) = QX(N+1)*QX(N+2)#          H*k                              MI45  89
INDEX(J+8) = QX(N+1)*QX(N+3)#          H*l                              MI45  90
INDEX(J+9) = QX(N+2)*QX(N+3)#          K*l                              MI45  91
J = J + STEHEQ#                        Increment for next set of        MI45  92
#                                         Modified indices.             MI45  93
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI45  94
#                                                                       MI45  95
# CLEAR PARTIAL DERIVATIVE ARRAY                                        MI45  96
#                                                                       MI45  97
N = STOPPD - STARPD#                                                    MI45  98
movereal:(NUL,1,QX,STARPD+1,N,2)#                                       MI45  99
STOHEQ = J - STEHEQ#                                                    MI45 100
DO NSET=2,NDATIN#                      Begin loop over the number of    MI45 101
#                                         'isomorphous' data sets.      MI45 102
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI45 103
SMAP =  0.0#                           Initialize a(h) and              MI45 104
SMBP =  0.0#                           B(h) terms.                      MI45 105
SMAPP = 0.0#                           Initializee a'(h) and            MI45 106
SMBPP = 0.0#                           B'(h) anomalous terms.           MI45 107
#                                                                       MI45 108
STARJX = ATMPTR(NSET)#                 Start of parameter array of      MI45 109
#                                         The 'x' data set.             MI45 110
STOPJX = ATMPTR(NSET+1) - 1#           Stop of the atom parameter       MI45 111
#                                        Array of the 'x' data set.     MI45 112
# GET NUMBER OF PARAMETERS IN THE ATOM LIST                             MI45 113
NPARAM = REFPTR(NSET+1) - REFPTR(NSET)#                                 MI45 114
DRVAP = DRVPTA(NSET)#                  Set pointer for deriv. of a'     MI45 115
DRVAPP = DRVAP + NPARAM#               Set pointer for deriv. of a"     MI45 116
DRVBP = DRVPTB(NSET)#                  Set pointer for deriv. of b'     MI45 117
DRVBPP = DRVBP + NPARAM#               Set pointer for deriv. of b"     MI45 118
#                                                                       MI45 119
DO J=STARJX,STOPJX,STEPAT#             Loop through j atom of data      MI45 120
#                                         Set 'x'.                      MI45 121
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI45 122
ifvo:(QX(J+5))#                        Is this an isotropic             MI45 123
#                                         Thermal factor?               MI45 124
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI45 125
CJ = EXP(-SSQRD*QX(J+4))#              Cj=exp(-stol**2*b(is0))          MI45 126
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI45 127
#                                                                       MI45 128
N = NINT(QX(J+12))#                    Get real sfac for this atom      MI45 129
POPFJ = QX(J+10)*QX(N)#                Population*(real scattering      MI45 130
#                                         Factor).                      MI45 131
POPFAJ = QX(J+10)*QX(J+11)*QX(N+1)#    Population*(anom population)     MI45 132
#                                         *(anom scatter).              MI45 133
SMAPJ =  0.0#                          Initialize a'(h) and b'(h)       MI45 134
SMBPJ =  0.0#                          Of the jth atom.                 MI45 135
SMAPPJ = 0.0#                          Initialize a"(h) and b"(h)       MI45 136
SMBPPJ = 0.0#                          Of the jth atom.                 MI45 137
#                                                                       MI45 138
DO K=STAHEQ,STOHEQ,STEHEQ#             Loop over equivalent indices     MI45 139
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI45 140
# CALCULATE 2PI*(T'+H'X+K'Y+L'Z)                                        MI45 141
ARG = INDEX(K) + INDEX(K+1)*QX(J+1) + INDEX(K+2)*QX(J+2)  $#            MI45 142
+ INDEX(K+3)*QX(J+3)#                                                   MI45 143
COSARG = COS(ARG)#                     These could be table lookups     MI45 144
SINARG = SIN(ARG)#                     Someday.                         MI45 145
ifnv:(QX(J+5))#                        We must have an aniso b!         MI45 146
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI45 147
ARG = 0.0#                             Init. arg to sum aniso.          MI45 148
#                                         Temperature factor.           MI45 149
DO N=4,9#                              Sum h(ij)*beta(ij)               MI45 150
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI45 151
KK = K + N#                                                             MI45 152
JJ = J + N#                                                             MI45 153
ARG = ARG + INDEX(KK)*QX(JJ)#                                           MI45 154
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI45 155
CJ = EXP(-ARG)#                                                         MI45 156
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI45 157
#                                                                       MI45 158
APJK  =  CJ*POPFJ*COSARG#              A' and b' of jth atom and        MI45 159
BPJK  =  CJ*POPFJ*SINARG#              Kth equivalent indices.          MI45 160
APPJK = -CJ*POPFAJ*SINARG#             A" (anomal.) of same             MI45 161
BPPJK =  CJ*POPFAJ*COSARG#             B" of same                       MI45 162
#                                                                       MI45 163
# START CALCULATING DERIVATIVES OF JTH ATOM AND KTH EQUIVALENT INDICES  MI45 164
#                                                                       MI45 165
DO N=1,3#                              Loop with respect to x,y,z       MI45 166
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI45 167
K1 = K + N#                            Of the jth atom.                 MI45 168
N1 = DRVAP + N#                                                         MI45 169
QX(N1) = QX(N1) - INDEX(K1)*BPJK#                                       MI45 170
N1 = DRVAPP + N#                                                        MI45 171
QX(N1) = QX(N1) + INDEX(K1)*BPPJK#                                      MI45 172
N1 = DRVBP + N#                                                         MI45 173
QX(N1) = QX(N1) + INDEX(K1)*APJK#                                       MI45 174
N1 = DRVBPP + N#                                                        MI45 175
QX(N1) = QX(N1) - INDEX(K1)*APPJK#                                      MI45 176
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI45 177
#                                                                       MI45 178
ifnv:(QX(J+5))#                        Calc derivs. of aniso b's        MI45 179
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI45 180
DO N=4,9#                              Loop over anisotropic            MI45 181
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI45 182
K1 = K + N#                            Thermal factors.                 MI45 183
N1 = DRVAP + N#                                                         MI45 184
QX(N1) = QX(N1) - INDEX(K1)*APJK#                                       MI45 185
N1 = DRVAPP + N#                                                        MI45 186
QX(N1) = QX(N1) - INDEX(K1)*APPJK#                                      MI45 187
N1 = DRVBP + N#                                                         MI45 188
QX(N1) = QX(N1) - INDEX(K1)*BPJK#                                       MI45 189
N1 = DRVBPP + N#                                                        MI45 190
QX(N1) = QX(N1) - INDEX(K1)*BPPJK#                                      MI45 191
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI45 192
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI45 193
#                                                                       MI45 194
SMAPJ  = SMAPJ  + APJK#                Sm contributions of a and b      MI45 195
SMBPJ  = SMBPJ  + BPJK#                Parts from equiv. indices        MI45 196
SMAPPJ = SMAPPJ + APPJK#               To total a and b coeffs. of      MI45 197
SMBPPJ = SMBPPJ + BPPJK#               Jth atom.                        MI45 198
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI45 199
#                                                                       MI45 200
# NOW DO DERIVATIVE AND OTHER CALCS. THAT DEPEND ON JTH ATOM,           MI45 201
#  BUT NOT ON THE EQUIVALENT INDICES.                                   MI45 202
#                                                                       MI45 203
ifvo:(QX(J+5))#                        Calc. derivs. of iso b           MI45 204
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI45 205
QX(DRVAP+4)  = -SSQRD*SMAPJ#                                            MI45 206
QX(DRVAPP+4) = -SSQRD*SMAPPJ#                                           MI45 207
QX(DRVBP+4)  = -SSQRD*SMBPJ#                                            MI45 208
QX(DRVBPP+4) = -SSQRD*SMBPPJ#                                           MI45 209
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI45 210
#                                                                       MI45 211
# CALCULATE DERIVATIVES OF THE POPULATION OF THE JTH ATOM.              MI45 212
#  THIS INCLUDES THE 'ANOMALOUS' POPULATION.                            MI45 213
#                                                                       MI45 214
# CALCULATE D(A)/D(POP(J))                                              MI45 215
#                                                                       MI45 216
QX(DRVAP+10)  = SMAPJ/QX(J+10)#                                         MI45 217
QX(DRVAPP+10) = SMAPPJ/QX(J+10)#                                        MI45 218
QX(DRVBP+10)  = SMBPJ/QX(J+10)#                                         MI45 219
QX(DRVBPP+10) = SMBPPJ/QX(J+10)#                                        MI45 220
QX(DRVAP+11)  = 0.0#                                                    MI45 221
QX(DRVAPP+11) = SMAPPJ/QX(J+11)#                                        MI45 222
QX(DRVBP+11)  = 0.0#                                                    MI45 223
QX(DRVBPP+11) = SMBPPJ/QX(J+11)#                                        MI45 224
#                                                                       MI45 225
SMAP  = SMAP  + SMAPJ#                 Add contribution of the          MI45 226
SMBP  = SMBP  + SMBPJ#                 Jth atom to the heavy atom       MI45 227
SMAPP = SMAPP + SMAPPJ#                Coefficients.                    MI45 228
SMBPP = SMBPP + SMBPPJ#                                                 MI45 229
#                                                                       MI45 230
DRVAP  = DRVAP  + STEPEF#              Increment the deriv. pointers    MI45 231
DRVAPP = DRVAPP + STEPEF#                                               MI45 232
DRVBP  = DRVBP  + STEPEF#              To the next atom.                MI45 233
DRVBPP = DRVBPP + STEPEF#                                               MI45 234
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI45 235
#                                                                       MI45 236
DRVAP = DRVPTA(NSET)#                  Reset pointers to start of       MI45 237
DRVAPP = DRVAP + NPARAM#               The partial derviatives of       MI45 238
DRVBP = DRVPTB(NSET)#                  This data set.                   MI45 239
DRVBPP = DRVBP + NPARAM#                                                MI45 240
#                                                                       MI45 241
STARRF = REFPTR(NSET) + 1#             Set pointers to beginning and    MI45 242
STOPRF = REFPTR(NSET+1)#               End of refinement key array.     MI45 243
#                                                                       MI45 244
J = 0#                                 J, k, and n are local            MI45 245
K = 0#                                 Subscripting indices here.       MI45 246
#                                                                       MI45 247
DO N=STARRF,STOPRF#                    Compress the partial             MI45 248
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI45 249
K = K + 1#                             Derivative arrays to remove      MI45 250
#                                        Those that are not refined on. MI45 251
IF(QX(N) > 0.0)#                       Check if this parameter is       MI45 252
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI45 253
J = J + 1#                             Refined.                         MI45 254
J1 = DRVAP + J#                                                         MI45 255
K1 = DRVAP + K#                                                         MI45 256
QX(J1) = QX(K1)#                       Move it towards the              MI45 257
J1 = DRVAPP + J#                       Beginning of the array.          MI45 258
K1 = DRVAPP + K#                                                        MI45 259
QX(J1) = QX(K1)#                                                        MI45 260
J1 = DRVBP + J#                                                         MI45 261
K1 = DRVBP + K#                                                         MI45 262
QX(J1) = QX(K1)#                                                        MI45 263
J1 = DRVBPP + J#                                                        MI45 264
K1 = DRVBPP + K#                                                        MI45 265
QX(J1) = QX(K1)#                                                        MI45 266
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI45 267
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI45 268
#                                                                       MI45 269
# CALC THE DERIVATIVES WITH RESPECT TO THE DATA SET PARAMETERS          MI45 270
#                                                                       MI45 271
PTRRO = STARRO + (NSET-1)*STEPRO#      Calc. pointer                    MI45 272
ahcalc:(PTRRO) = SMAP#                 Give 'em back the coeffs.        MI45 273
bhcalc:(PTRRO) = SMBP#                 For the heavy atom               MI45 274
aanomc:(PTRRO) = SMAPP#                Contributions.                   MI45 275
banomc:(PTRRO) = SMBPP#                                                 MI45 276
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI45 277
RETURN#                                                                 MI45 278
END#                                                                    MI45 279
systemheader:(MI47)#                                                    MI47   1
# ################################################################## #  MI47   2
#                                                                    #  MI47   3
#                               MI47                                 #  MI47   4
#                                                                    #  MI47   5
# ################################################################## #  MI47   6
SUBROUTINE MI47#                                                        MI47   7
#                                                                       MI47   8
# THIS SUBROUTINE PASSES THROUGH THE LIST OF REFLECTION OUT INFORMATION MI47   9
#  CONVERTING THE F+, F- INFORMATION TO F**2 INFORMATION.  IT ALSO      MI47  10
#  CALCULATES THE SCALE FACTOR NECESSARY TO PLACE THE DATA ON THE       MI47  11
#  SCALE OF THE NATIVE DATA SET.                                        MI47  12
#  PROPER WEIGHTED AVERAGES ARE USED BASED ON THE VARIANCES OF F+       MI47  13
#  AND F-.  AN EXTERNAL ROUTINE IS USED TO GET THE STANDARD DEVIATIONS, MI47  14
#  GIVEN THE INPUT STANDARD DEVIATION, THE MEASUREMENT, AND AN          MI47  15
#  INSTRUMENT INSTABILITY FACTOR.                                       MI47  16
# THE LAYOUT OF THE STORAGE IS DESCRIBED IN THE FILE OF MACRO           MI47  17
#  DEFINITIONS.                                                         MI47  18
#                                        Nov 1979  l. ten eyck          MI47  19
#                                        Modified jun 1980  j. sygusch  MI47  20
#                                        Modified jun 1980  s. sheriff  MI47  21
include:(MIMAC1)#                                                       MI47  22
include:(AACOMN)#                                                       MI47  23
include:(MICOMN)#                                                       MI47  24
#                                                                       MI47  25
INTEGER I#                             Loop index; pointer to           MI47  26
#                                         Appropriate data set.         MI47  27
INTEGER INORM#                         Pointer to average f**2 for a    MI47  28
#                                         Stol bin.                     MI47  29
INTEGER KBPTR#                         Pointer to kb part of qx array   MI47  30
INTEGER L#                             Loop index                       MI47  31
INTEGER LNORM#                         Pointer to max. normalized       MI47  32
#                                         Structure factor.             MI47  33
INTEGER ROPTR#                         Pointer to dataset reflection    MI47  34
#                                         Information in the qx array.  MI47  35
REAL ENORM#                            Normalized structure factor      MI47  36
REAL FMINUS#                           Amplitude of f(-)                MI47  37
REAL FPLUS#                            Amplitude of f(+)                MI47  38
REAL MI49#                             Function to find variance        MI47  39
REAL S#                                (sine(theta)/lambda)**2          MI47  40
REAL VMINUS#                           Variance of f(-)**2              MI47  41
REAL VPLUS#                            Variance of f(+)**2              MI47  42
#                                                                       MI47  43
S = stol:**2#                          (sine(theta)/lambda)**2          MI47  44
ROPTR = STARRO#                                                         MI47  45
FOR(I=1; I <= NDATIN; I=I+1)#                                           MI47  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI47  47
FPLUS = frelp:(ROPTR)#                                                  MI47  48
FMINUS = frelm:(ROPTR)#                                                 MI47  49
ifvo:(FPLUS)#                                                           MI47  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI47  51
ifvo:(FMINUS)#                                                          MI47  52
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI47  53
# WE DO NOT HAVE ANY DATA FOR THIS ISOMORPH THIS TIME                   MI47  54
fph:(ROPTR)    = voidflg:#                                              MI47  55
fphsq:(ROPTR)  = voidflg:#                                              MI47  56
varfsq:(ROPTR) = voidflg:#                                              MI47  57
delfsq:(ROPTR) = voidflg:#                                              MI47  58
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI47  59
#                                                                       MI47  60
ELSE#                                                                   MI47  61
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI47  62
# F- IS THE ONLY MEASUREMENT                                            MI47  63
fph:(ROPTR)    = FMINUS#                                                MI47  64
fphsq:(ROPTR)  = FMINUS**2#                                             MI47  65
varfsq:(ROPTR) = getvar:(srelm:(ROPTR),FMINUS,STAB(I))#                 MI47  66
delfsq:(ROPTR) = voidflg:#                                              MI47  67
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI47  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI47  69
#                                                                       MI47  70
ELSE#                                                                   MI47  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI47  72
ifvo:(FMINUS)#                                                          MI47  73
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI47  74
# F+ IS THE ONLY MEASUREMENT                                            MI47  75
fph:(ROPTR)    = FPLUS#                                                 MI47  76
fphsq:(ROPTR)  = FPLUS**2#                                              MI47  77
varfsq:(ROPTR) = getvar:(srelp:(ROPTR),FPLUS,STAB(I))#                  MI47  78
delfsq:(ROPTR) = voidflg:#                                              MI47  79
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI47  80
#                                                                       MI47  81
ELSE#                                                                   MI47  82
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI47  83
# WE HAVE BOTH MEASUREMENTS                                             MI47  84
VPLUS = getvar:(srelp:(ROPTR),FPLUS,STAB(I))#                           MI47  85
VMINUS = getvar:(srelm:(ROPTR),FMINUS,STAB(I))#                         MI47  86
FPLUS = FPLUS**2#                                                       MI47  87
FMINUS = FMINUS**2#                                                     MI47  88
fphsq:(ROPTR) = 0.5*(FPLUS+FMINUS)#    Mean f**2                        MI47  89
delfsq:(ROPTR) = FPLUS-FMINUS#         I(+)-i(-)                        MI47  90
fph:(ROPTR) = SQRT(fphsq:(ROPTR))#     /f/                              MI47  91
varfsq:(ROPTR) = 0.25*(VPLUS+VMINUS)#  Var(f**2)                        MI47  92
vardelf:(ROPTR) = VPLUS+VMINUS#        Var(delfsq:)                     MI47  93
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI47  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI47  95
#                                                                       MI47  96
KBPTR = (I-1)*STEPKB + STARKB#                                          MI47  97
scale:(ROPTR) = kover:(KBPTR)*EXP(bover:(KBPTR)*S)#                     MI47  98
#                                                                       MI47  99
CALL MI48(ROPTR)#                      Scale data                       MI47 100
#                                                                       MI47 101
# ESTABLISH POINTERS TO BIN IN STOL AND F**2                            MI47 102
#                                                                       MI47 103
IF(I == 1)#                            Do only once per reflection      MI47 104
#                                         Bin on f**2 of parent.        MI47 105
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI47 106
ISBIN = MIN0(NBIN-1,IFIX((stol:**3-STOLMN(1)**3)/GAP))#                 MI47 107
INORM = STAREM + ISBIN + 1#            Offset to average f**2 for       MI47 108
#                                         That stol bin.                MI47 109
ENORM = fphsq:(ROPTR)/QX(INORM)#       Normalized structure factor      MI47 110
DO L=1,NFBIN#                                                           MI47 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI47 112
LNORM = STAREM + STEPEM + L#           Offset to max. normalized sf     MI47 113
IFBIN = L - 1#                                                          MI47 114
IF(ENORM <= QX(LNORM))  BREAK#                                          MI47 115
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI47 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI47 117
#                                                                       MI47 118
ROPTR = ROPTR + STEPRO#                                                 MI47 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI47 120
#                                                                       MI47 121
# PUT AWAY PREVIOUS CYCLES VALUES FOR STATISTICS                        MI47 122
#                                                                       MI47 123
IF((frelp:(STARRO) <= voidflg:) & (frelm:(STARRO) <= voidflg:))#        MI47 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI47 125
figmer: = 0.0#                                                          MI47 126
cosbst: = voidflg:#                                                     MI47 127
sinbst: = voidflg:#                                                     MI47 128
cosmp:  = voidflg:#                                                     MI47 129
sinmp:  = voidflg:#                                                     MI47 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI47 131
#                                                                       MI47 132
ELSE#                                                                   MI47 133
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI47 134
QX(STARCR+12) = figmer:#                                                MI47 135
QX(STARCR+13) = cosbst:#                                                MI47 136
QX(STARCR+14) = sinbst:#                                                MI47 137
QX(STARCR+15) = cosmp:#                                                 MI47 138
QX(STARCR+16) = sinmp:#                                                 MI47 139
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI47 140
RETURN#                                                                 MI47 141
END#                                                                    MI47 142
systemheader:(MI48)#                                                    MI48   1
# ################################################################## #  MI48   2
#                                                                    #  MI48   3
#                               MI48                                 #  MI48   4
#                                                                    #  MI48   5
# ################################################################## #  MI48   6
SUBROUTINE MI48(INDX)#                                                  MI48   7
#                                                                       MI48   8
# THIS MODULE PLACES THE DATA POINTED TO BY INDX (A SUBSCRIPT FOR THE   MI48   9
#  STARRO DATA STRUCTURE IN THE QX ARRAY) ON THE NATIVE SCALE, IF       MI48  10
#  THERE IS ANY SUCH DATA TO BE SCALED.                                 MI48  11
#                                        Nov 1979  l. ten eyck          MI48  12
include:(MIMAC4)#                                                       MI48  13
include:(AACOMN)#                                                       MI48  14
include:(MICOMN)#                                                       MI48  15
#                                                                       MI48  16
INTEGER INDX#                          Same as roptr (below)            MI48  17
INTEGER ROPTR#                         Pointer to data set reflection   MI48  18
#                                         Information in the starro     MI48  19
#                                         Region of qx.                 MI48  20
REAL SCL#                              Scale for data set               MI48  21
REAL SCLSQ#                            Scale squared                    MI48  22
#                                                                       MI48  23
ROPTR = INDX#                                                           MI48  24
ifvo:(fph:(ROPTR))#                                                     MI48  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI48  26
# THE REFLECTION DATA ARE MISSING                                       MI48  27
fphsqn:(ROPTR)  = voidflg:#                                             MI48  28
fphn:(ROPTR)    = voidflg:#                                             MI48  29
delfsqn:(ROPTR) = voidflg:#                                             MI48  30
varfsqn:(ROPTR) = voidflg:#                                             MI48  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI48  32
#                                                                       MI48  33
ELSE#                                                                   MI48  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI48  35
# WE HAVE REFLECTION DATA, SO SCALE IT.                                 MI48  36
# NOTE THAT WE MUST CHECK FOR MISSING DATA SO WE DON`T                  MI48  37
#  SCALE THE VOID FLAG.                                                 MI48  38
# AT PRESENT THE SCALE FACTOR MULTIPLIES FPH(OBS) TO GET                MI48  39
#  IT ON THE SCALE OF FP.  THE HEAVY ATOM SCATTERING                    MI48  40
#  IS CALCULATED ON THE SCALE OF FP.                                    MI48  41
#                                                                       MI48  42
SCL         = scale:(ROPTR)#                                            MI48  43
SCLSQ       = SCL*SCL#                                                  MI48  44
fphsqn:(ROPTR)  = SCLSQ*fphsq:(ROPTR)#                                  MI48  45
varfsqn:(ROPTR) = SCLSQ*SCLSQ*varfsq:(ROPTR)# Scaled variance is squa   MI48  46
#                                         Of scaled sigma(f**2).        MI48  47
fphn:(ROPTR)   = SCL*fph:(ROPTR)#                                       MI48  48
#                                                                       MI48  49
ifvo:(delfsq:(ROPTR))  delfsqn:(ROPTR) = voidflg:#                      MI48  50
ELSE                   delfsqn:(ROPTR) = SCLSQ*delfsq:(ROPTR)#          MI48  51
#                                                                       MI48  52
ahcalcn:(ROPTR) = ahcalc:(ROPTR)#                                       MI48  53
bhcalcn:(ROPTR) = bhcalc:(ROPTR)#                                       MI48  54
aanomcn:(ROPTR) = aanomc:(ROPTR)#                                       MI48  55
banomcn:(ROPTR) = banomc:(ROPTR)#                                       MI48  56
#                                                                       MI48  57
ifvo:(ahcalc:(ROPTR))  fhn:(ROPTR) = voidflg:#                          MI48  58
ELSE  fhn:(ROPTR) = SQRT(ahcalc:(ROPTR)**2 + bhcalc:(ROPTR)**2)#        MI48  59
#                                                                       MI48  60
ifvo:(aanomc:(ROPTR))  fhanomn:(ROPTR) = voidflg:#                      MI48  61
ELSE  fhanomn:(ROPTR) = SQRT(aanomc:(ROPTR)**2 + banomc:(ROPTR)**2)#    MI48  62
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI48  63
RETURN#                                                                 MI48  64
END#                                                                    MI48  65
systemheader:(MI49)#                                                    MI49   1
# ################################################################## #  MI49   2
#                                                                    #  MI49   3
#                               MI49                                 #  MI49   4
#                                                                    #  MI49   5
# ################################################################## #  MI49   6
REAL FUNCTION MI49(SIGMA,F,STAB)#                                       MI49   7
#                                                                       MI49   8
# IF SIGMA'S HAVE NOT BEEN PROVIDED, INVENT THEM                        MI49   9
# CALLED BY MI48                                                        MI49  10
#                                        K.d.watenpaugh aug 1985        MI49  11
#                                                                       MI49  12
REAL F#                                Structure factor amplitude       MI49  13
REAL SIGMA#                            Sigma is sigma of f-squared      MI49  14
REAL STAB#                             Instrumental instability         MI49  15
#                                         Factor.                       MI49  16
#                                                                       MI49  17
ifvo:(SIGMA)  MI49 = ((1.0+STAB)**2)*F**2#                              MI49  18
ELSE  MI49 = SIGMA**2#                                                  MI49  19
RETURN#                                                                 MI49  20
END#                                                                    MI49  21
systemheader:(MI50)#                                                    MI50   1
# ################################################################## #  MI50   2
#                                                                    #  MI50   3
#                               MI50                                 #  MI50   4
#                                                                    #  MI50   5
# ################################################################## #  MI50   6
SUBROUTINE MI50#                                                        MI50   7
#                                                                       MI50   8
# OVERALL CONTROL ROUTINE FOR BLOW AND CRICK TYPE PHASING.              MI50   9
# THIS ROUTINE SEQUENCES THROUGH THE CALCULATION OF PHASES BY           MI50  10
#  INTEGRATION AROUND THE PHASE CIRCLE USING HENDRICKSON                MI50  11
#  COEFFICIENTS.                                                        MI50  12
# THE FOLLOWING GROUND RULES APPLY.                                     MI50  13
#  1.  IF THERE IS NO MEASUREMENT FOR COMPOUND 1, NO CALCULATIONS       MI50  14
#      ARE PERFORMED.                                                   MI50  15
#  2.  IF DATA ARE PROVIDED FOR A PARTICULAR ISOMORPH, THE              MI50  16
#      HENDRICKSON COEFFICIENTS ARE RECALCULATED ON THE BASIS           MI50  17
#      OF CURRENT DATA.                                                 MI50  18
#  3.  IF NO DATA ARE PROVIDED BUT HENDRICKSON COEFFICIENTS ARE         MI50  19
#      PROVIDED FOR A PARTICULAR ISOMORPH, THOSE COEFFICIENTS           MI50  20
#      ARE USED ON THE ASSUMPTION THAT THEY CAME FROM A VALID           MI50  21
#      SOURCE.  THIS PROVIDES ONE POSSIBLE MECHANISM FOR COMBINING      MI50  22
#      PHASE INFORMATION FROM OTHER SOURCES.                            MI50  23
#  4.  IF THERE ARE NO PHASE INDICATORS FOR A REFLECTION, THE PHASE     MI50  24
#      INFORMATION IS CLEARED.  OTHERWISE PHASE INFORMATION IS RETURNED MI50  25
#      IN THE M, COS ALPHA, SIN ALPHA, COS MP, AND SIN MP FIELDS OF     MI50  26
#      OF THE PER REFLECTION DATA STRUCTURE.                            MI50  27
# MACROS USED IN ROUTINES MI50,MI51,MI52,MI53,MI54,MI55,MI56,MI58       MI50  28
#  ARE DESCRIBED IN MIMAC1.                                             MI50  29
#                                        Nov 1979  l. ten eyck          MI50  30
#                                        Revised may 1980  s. sheriff   MI50  31
# CALLS TO STATISTICS ROUTINES (ORGINALLY MI56 AND MI57) MOVED TO MI40. MI50  32
#  STORAGE OF LAST CYCLES PHASES MOVED TO MI48.  CALLS TO MI56 (PRINT   MI50  33
#  REFLECTIONS) ADDED AND MI58 MODIFIED.  STEVEN SHERIFF APRIL 1981     MI50  34
#                                                                       MI50  35
include:(AACOMN)#                                                       MI50  36
include:(MICOMN)#                                                       MI50  37
#                                                                       MI50  38
INTEGER I#                             Loop index; pointer to           MI50  39
#                                         Appropriate data set.         MI50  40
INTEGER IND#                           Count of no. of contributing     MI50  41
#                                         Sources of coefficients.      MI50  42
INTEGER ROPTR#                         Pointer to dataset reflection    MI50  43
#                                         Information.                  MI50  44
INTEGER KBPTR#                         Pointer to kb part of qx array   MI50  45
#                                                                       MI50  46
IF((frelp:(STARRO) > voidflg:) \ (frelm:(STARRO) > voidflg:))#          MI50  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI50  48
# SINCE WE HAVE A PARENT MEASUREMENT, WE CAN PROCEDE.                   MI50  49
#                                                                       MI50  50
ROPTR = STARRO#                                                         MI50  51
DO I=1,4#                              First zero out the               MI50  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI50  53
abcd:(ROPTR) = 0.0#                    Hendrickson coefficients.        MI50  54
ROPTR = ROPTR + 1#                                                      MI50  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI50  56
#                                                                       MI50  57
# NOW LOOP THROUGH THE COMPOUNDS, ACCUMULATING THE                      MI50  58
#  WEIGHTED HENDRICKSON COEFFICIENTS.                                   MI50  59
IND = 0#                                                                MI50  60
ROPTR = STARRO#                                                         MI50  61
FOR(I=1; I <= NDATIN; I=I+1)#                                           MI50  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI50  63
# CHECK IF SCALED DATA PRESENT                                          MI50  64
ifnv:(fphn:(ROPTR))#                                                    MI50  65
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI50  66
# CALCULATE THE HENDRICKSON COEFFICIENTS                                MI50  67
#                                                                       MI50  68
CALL MI52(ROPTR,fphn:(STARRO),I,abcd:(ROPTR),abcdan:(ROPTR))#           MI50  69
CALL MI53(I,ROPTR)#                                                     MI50  70
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI50  71
#                                                                       MI50  72
ELSE#                                                                   MI50  73
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI50  74
KBPTR = STARKB + (I-1)*STEPKB + IFBIN*NBIN + ISBIN + binstart: +1#      MI50  75
eiso:(ROPTR) = QX(KBPTR)#                                               MI50  76
eano:(ROPTR) = QX(KBPTR+50)#                                            MI50  77
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI50  78
#                                                                       MI50  79
# COEFFICIENTS FOR THIS ISOMORPH ARE NOW EITHER                         MI50  80
#  CURRENT, VALID FROM OTHER SOURCES, OR MISSING.                       MI50  81
#  COMBINE THEM APPROPRIATELY.                                          MI50  82
IF(((ABS(anflg:(ROPTR)-1.0) < small:) $#                                MI50  83
\ (ABS(anflg:(ROPTR)-3.0) < small:)) & (I != 1))#                       MI50  84
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI50  85
CALL MI54(abcd:(ROPTR),eiso:(ROPTR),abcd:(STARRO),IND)#                 MI50  86
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI50  87
#                                                                       MI50  88
IF((ABS(anflg:(ROPTR)-2.0) < small:)$#                                  MI50  89
\ (ABS(anflg:(ROPTR)-3.0) < small:))#                                   MI50  90
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI50  91
CALL MI54(abcdan:(ROPTR),eano:(ROPTR),abcd:(STARRO),IND)#               MI50  92
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI50  93
ROPTR = ROPTR + STEPRO#                                                 MI50  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI50  95
#                                                                       MI50  96
IF(IND == 0)#                                                           MI50  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI50  98
# INSUFFICIENT DATA TO PHASE THIS ONE                                   MI50  99
figmer: = 0.0#                                                          MI50 100
cosbst: = voidflg:#                                                     MI50 101
sinbst: = voidflg:#                                                     MI50 102
cosmp:  = voidflg:#                                                     MI50 103
sinmp:  = voidflg:#                                                     MI50 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI50 105
#                                                                       MI50 106
ELSE#                                                                   MI50 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI50 108
# INTEGRATE THE PROBABILITY DISTRIBUTION                                MI50 109
CALL MI55(abcd:(STARRO),abcd:(STARRO+1),#                               MI50 110
abcd:(STARRO+2),abcd:(STARRO+3))#                                       MI50 111
#                                                                       MI50 112
# PREPARE DELISO VARIANCES FOR REFINEMENT                               MI50 113
#                                                                       MI50 114
IF(figmer: > 1.0)  VARPHI = 0.0#       Variance of phi, with            MI50 115
ELSE VARPHI = ACOS(figmer:)**2#        Protection for acos.        mi   MI50 116
#                                                                       MI50 117
ROPTR = STARRO#                                                         MI50 118
DO I=2,NDATIN#                                                          MI50 119
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI50 120
ROPTR = ROPTR + STEPRO#                                                 MI50 121
ifvo:(fphn:(ROPTR)) NEXT#              Skip, if no data                 MI50 122
variso:(ROPTR) = varfsqn:(ROPTR)  $#                                    MI50 123
+ varfsqn:(STARRO)*(1.0 +  $#                                           MI50 124
(cosmp:*ahcalcn:(ROPTR) + sinmp:*bhcalcn:(ROPTR))/ $#                   MI50 125
fphn:(STARRO))**2  $#                                                   MI50 126
+ VARPHI*(2.0*fphn:(STARRO)*  $#                                        MI50 127
(sinmp:*ahcalcn:(ROPTR) - cosmp:*bhcalcn:(ROPTR)))**2#                  MI50 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI50 129
#                                                                       MI50 130
# OUTPUT INFORMATION AS REQUESTED ON LAST CYCLE                         MI50 131
IF(ICYC == LSTCYC)#                                                     MI50 132
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI50 133
IF(ILIST > 0)#                         Print reflections                MI50 134
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI50 135
IF(MOD(ICTREF,ILIST) == 0)  CALL MI56#                                  MI50 136
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI50 137
#                                                                       MI50 138
ELSE IF((IPLOT > 0) & $#               Plot reflections                 MI50 139
(IPRC == 0))  CALL MI58#               Acentrics only.                  MI50 140
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI50 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI50 142
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI50 143
RETURN#                                                                 MI50 144
END#                                                                    MI50 145
systemheader:(MI52)#                                                    MI52   1
# ################################################################## #  MI52   2
#                                                                    #  MI52   3
#                               MI52                                 #  MI52   4
#                                                                    #  MI52   5
# ################################################################## #  MI52   6
SUBROUTINE MI52(INDX,FPAR,DNOW,A,B)#                                    MI52   7
#                                                                       MI52   8
# IF THE NECESSARY DATA ARE PRESENT IN THE STARRO TYPE DATA STRUCTURE,  MI52   9
#  POINTED TO BY INDX, HENDRICKSON COEFFICIENTS ARE CALCULATED FOR      MI52  10
#  THIS ISOMORPH.  THE RULE IS THAT COEFFICIENTS ARE ALWAYS             MI52  11
#  RECALCULATED IF THE DATA ARE AVAILABLE; OTHERWISE, THEY ARE LEFT     MI52  12
#  ALONE.  THIS PERMITS USE OF THIS DATA STRUCTURE FOR OTHER SOURCES    MI52  13
#  OF PHASING INFORMATION.                                              MI52  14
# DNOW IS THE DATA SET NUMBER; WE NEVER MAKE COEFFICIENTS FOR           MI52  15
#  THE ISOMORPHOUS PART OF DATA SET 1.                                  MI52  16
#                                        Nov 1979  l. ten eyck          MI52  17
include:(AACOMN)#                                                       MI52  18
include:(MICOMN)#                                                       MI52  19
#                                                                       MI52  20
INTEGER DNOW#                          Pointer to appropriate           MI52  21
#                                         Data set.                     MI52  22
INTEGER INDX#                          Same as roptr (below)            MI52  23
INTEGER ROPTR#                         Pointer to dataset reflection    MI52  24
#                                         Information in the starro     MI52  25
#                                         Region.                       MI52  26
REAL A(4)#                             Isomorphous hendrickson-         MI52  27
#                                         Lattman coefficients.         MI52  28
REAL B(4)#                             Anomalous hendrickson-lattman    MI52  29
#                                         Coefficients.                 MI52  30
REAL C#                                                                 MI52  31
REAL D#                                                                 MI52  32
REAL E#                                                                 MI52  33
REAL FPAR#                             Amplitude of parent              MI52  34
#                                                                       MI52  35
ROPTR = INDX#                                                           MI52  36
ifnv:(fphn:(ROPTR))#                                                    MI52  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI52  38
IF((fhn:(ROPTR) > voidflg:) & (DNOW != 1))#                             MI52  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI52  40
# GIVEN FPH, FPAR, AND FH WE CAN CALCULATE THE ISOMORPHOUS              MI52  41
#  COEFFICIENTS.  HOWEVER, WE DO NOT CALCULATE                          MI52  42
#  THEM FOR THE PARENT COMPOUND, WHICH CAN HAVE                         MI52  43
#  CALCULATED STRUCTURE FACTORS, BUT NEVER ISOMORPHOUS                  MI52  44
#  DIFFERENCES.                                                         MI52  45
#                                                                       MI52  46
C    = FPAR**2 + fhn:(ROPTR)**2 - fphn:(ROPTR)**2#                      MI52  47
A(1) = -4.0*C*ahcalcn:(ROPTR)*FPAR#                                     MI52  48
A(2) = -4.0*C*bhcalcn:(ROPTR)*FPAR#                                     MI52  49
A(3) = -2.0*(ahcalcn:(ROPTR)**2 - bhcalcn:(ROPTR)**2)*FPAR**2#          MI52  50
A(4) = -4.0*ahcalcn:(ROPTR)*bhcalcn:(ROPTR)*FPAR**2#                    MI52  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI52  52
#                                                                       MI52  53
IF((delfsqn:(ROPTR) > voidflg:) & (fhanomn:(ROPTR) > voidflg:))#        MI52  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI52  55
# GIVEN (FPH(+)**2 - FPH(-)**2), FPAR, AND FHANOM,                      MI52  56
#  WE CAN CALCULATE THE ANOMALOUS COEFFICIENTS.                         MI52  57
#                                                                       MI52  58
C = 4.0*aanomcn:(ROPTR)*FPAR#                                           MI52  59
D = 4.0*banomcn:(ROPTR)*FPAR#                                           MI52  60
E = 4.0*(ahcalcn:(ROPTR)*aanomcn:(ROPTR) +  $#                          MI52  61
bhcalcn:(ROPTR)*banomcn:(ROPTR)) - 2.0*delfsqn:(ROPTR)#                 MI52  62
B(1) = -2.0*C*E#                                                        MI52  63
B(2) = -2.0*D*E#                                                        MI52  64
B(3) = -0.5*(C**2 - D**2)#                                              MI52  65
B(4) = -C*D#                                                            MI52  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI52  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI52  68
RETURN#                                                                 MI52  69
END#                                                                    MI52  70
systemheader:(MI53)#                                                    MI53   1
# ################################################################## #  MI53   2
#                                                                    #  MI53   3
#                               MI53                                 #  MI53   4
#                                                                    #  MI53   5
# ################################################################## #  MI53   6
SUBROUTINE MI53(DSET,INDX)#                                             MI53   7
#                                                                       MI53   8
# THIS SUBROUTINE OBTAINS THE EXPECTED VALUE FOR THE SQUARE OF THE      MI53   9
#  LACK OF CLOSURE FOR ISOMORPH, DSET, IN THE DATA SET POINTED TO       MI53  10
#  BY INDX.  IF THE DATA ARE PRESENT, THE VALUES ARE CORRECTED FOR      MI53  11
#  THE EFFECTS OF RANDOM ERROR (COUNTING STATISTICS, ETC.) BY THE       MI53  12
#  METHOD OF TENEYCK AND ARNONE, J. MOL. BIOL. 100, PPS. 3-11 (1976).   MI53  13
# NOTE THAT THIS METHOD OF CORRECTION CANNOT BE USED UNLESS             MI53  14
#  THE CALCULATED HEAVY ATOM CONTRIBUTIONS ARE PRESENT.                 MI53  15
#                                        Nov 1979  l. ten eyck          MI53  16
#                                        Re-coded jun 1981              MI53  17
#                                         W. hendrickson                MI53  18
include:(AACOMN)#                                                       MI53  19
include:(MICOMN)#                                                       MI53  20
#                                                                       MI53  21
INTEGER DNUM#                          Same as dset (below)             MI53  22
INTEGER DSET#                          Data set number                  MI53  23
INTEGER INDX#                          Pointer to reflection part of    MI53  24
INTEGER ROPTR#                         Same as indx (above)             MI53  25
INTEGER KBPTR#                         Pointer to kb part of qx array   MI53  26
#                                                                       MI53  27
# CALCULATION OF KBPTR                                                  MI53  28
#  SECOND TERM POINTS TO DATA SET                                       MI53  29
#  THIRD TERM POINTS TO F**2 BIN                                        MI53  30
#  FOURTH TERM POINTS TO STOL BIN WITHIN F**2 BIN                       MI53  31
#                                                                       MI53  32
KBPTR = STARKB + (DSET-1)*STEPKB + IFBIN*NBIN + ISBIN + binstart: + 1#  MI53  33
DNUM = DSET#                                                            MI53  34
ROPTR = INDX#                                                           MI53  35
#                                                                       MI53  36
eiso:(ROPTR) = QX(KBPTR)#                                               MI53  37
eano:(ROPTR) = QX(KBPTR+50)#                                            MI53  38
#                                                                       MI53  39
IF(DNUM == 1)#                         No isomorphous error for         MI53  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI53  41
eiso:(STARRO) = 0.#                    The parent.                      MI53  42
variso:(STARRO) = 0.#                                                   MI53  43
varano:(STARRO) = 0.#                                                   MI53  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI53  45
#                                                                       MI53  46
ifnv:(fphsqn:(ROPTR))#                 Must have a measurement          MI53  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI53  48
ifvo:(cosmp:)#                                                          MI53  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI53  50
IF(DNUM > 1)  variso:(ROPTR) = varfsqn:(ROPTR) + varfsqn:(STARRO)#      MI53  51
varano:(ROPTR) = 4.0*varfsqn:(ROPTR)#                                   MI53  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI53  53
#                                                                       MI53  54
ELSE#                                                                   MI53  55
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI53  56
IF(DNUM > 1)#                                                           MI53  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI53  58
variso:(ROPTR) = varfsqn:(ROPTR)  $#                                    MI53  59
+ varfsqn:(STARRO)*(1.0 +  $#                                           MI53  60
(cosmp:*ahcalcn:(ROPTR) + sinmp:*bhcalcn:(ROPTR))/ $#                   MI53  61
fphn:(STARRO))**2#                                                      MI53  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI53  63
#                                                                       MI53  64
ifnv:(delfsqn:(ROPTR))#                                                 MI53  65
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI53  66
ifnv:(aanomc:(ROPTR))#                                                  MI53  67
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI53  68
varano:(ROPTR) = 4.0*varfsqn:(ROPTR)  $#                                MI53  69
+ varfsqn:(STARRO)*  $#                                                 MI53  70
((2.0/fphn:(STARRO))  $#                                                MI53  71
*(cosmp:*aanomc:(ROPTR)+sinmp:*banomc:(ROPTR)))**2#                     MI53  72
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI53  73
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI53  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI53  75
#                                                                       MI53  76
eiso:(ROPTR) = eiso:(ROPTR) + variso:(ROPTR)#                           MI53  77
eano:(ROPTR) = eano:(ROPTR) + varano:(ROPTR)#                           MI53  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI53  79
RETURN#                                                                 MI53  80
END#                                                                    MI53  81
systemheader:(MI54)#                                                    MI54   1
# ################################################################## #  MI54   2
#                                                                    #  MI54   3
#                               MI54                                 #  MI54   4
#                                                                    #  MI54   5
# ################################################################## #  MI54   6
SUBROUTINE MI54(A,E,B,KOUNT)#                                           MI54   7
#                                                                       MI54   8
# THIS SUBROUTINE APPLIES THE WEIGHT, E, TO THE SET OF COEFFICIENTS     MI54   9
#  IN A AND ADDS THEM TO B.  IF THE COEFFICIENTS IN A ARE UNDEFINED,    MI54  10
#  NOTHING IS DONE.                                                     MI54  11
#                                        Nov 1979  l. ten eyck          MI54  12
INTEGER I#                             Loop index                       MI54  13
INTEGER KOUNT#                         Count of number of               MI54  14
#                                         Contributing sources of       MI54  15
#                                         Coefficients.                 MI54  16
REAL A(4)#                             Hendrickson-lattman coeff.       MI54  17
#                                         From individual source.       MI54  18
REAL B(4)#                             Combined hendrickson-lattman     MI54  19
#                                         Coefficients.                 MI54  20
REAL E#                                Weighting factor for coeffs.,    MI54  21
#                                         Usually closure errors.       MI54  22
#                                                                       MI54  23
ifnv:(A(1))#                                                            MI54  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI54  25
DO I=1,4#                                                               MI54  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI54  27
B(I) = B(I) + 0.5*A(I)/E#                                               MI54  28
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI54  29
KOUNT = KOUNT + 1#                                                      MI54  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI54  31
RETURN#                                                                 MI54  32
END#                                                                    MI54  33
pmacro:([z:])#                                                          MI54  34
systemheader:(MI55)#                                                    MI55   1
# ################################################################## #  MI55   2
#                                                                    #  MI55   3
#                               MI55                                 #  MI55   4
#                                                                    #  MI55   5
# ################################################################## #  MI55   6
SUBROUTINE MI55(A,B,C,D)#                                               MI55   7
#                                                                       MI55   8
# ROUTINE TO STEP AROUND PHASE CIRCLE.                                  MI55   9
# ROUTINE STUFFS FIGURE OF MERIT AND BEST AND MOST PROBABLE             MI55  10
#  PHASES AS COSINE AND SINE INTO QX ARRAY.  IT ALSO STUFFS             MI55  11
#  PROBABILITY DISTRIBUTION INTO QX ARRAY, ALONG WITH MAXIMUM           MI55  12
#  PROBABILITY, START, AND INCREMENT FOR LATER USE.                     MI55  13
#                                        Nov 1979  s. sheriff           MI55  14
#                                        Revised jun 1980               MI55  15
#                                         W. hendrickson                MI55  16
#                                        Updated apr 1981  s. sheriff   MI55  17
include:(MIMAC1)#                                                       MI55  18
include:(AACOMN)#                                                       MI55  19
include:(MICOMN)#                                                       MI55  20
#                                                                       MI55  21
INTEGER I#                             Do loop index to alpha, the      MI55  22
#                                         Protein phase being tested.   MI55  23
INTEGER II#                            Do loop index to 2alpha, twice   MI55  24
#                                         The protein phase being       MI55  25
#                                         Tested.                       MI55  26
INTEGER IIN#                           Starting position for stepping   MI55  27
#                                         Around the phase circle.      MI55  28
INTEGER INC#                           Increment for stepping around    MI55  29
#                                         The phase circle.             MI55  30
INTEGER ISIN#                          Position of sin(alpha) in        MI55  31
#                                         The sine/cosine table.        MI55  32
INTEGER ISIN2#                         Position of sin(2alpha) in       MI55  33
#                                         The sine/cosine table.        MI55  34
INTEGER MPROB#                         The most probable phase          MI55  35
INTEGER M180#                          Centric phase 180 degrees away   MI55  36
#                                       #  From most probable.          MI55  37
INTEGER PRPTR#                         Position of expon or             MI55  38
#                                         Probability(alpha) in the qx. MI55  39
REAL A#                                Hendrickson-lattmann coeff.      MI55  40
REAL B#                                Hendrickson-lattmann coeff.      MI55  41
REAL C#                                Hendrickson-lattmann coeff.      MI55  42
REAL COS2#                             Cosine of 2alpha                 MI55  43
REAL COS2MP#                                                            MI55  44
REAL COSINE#                           Cosine of alpha                  MI55  45
REAL COSM#                             Sum of probability times         MI55  46
#                                         Cosine(alpha).                MI55  47
REAL COSMP#                                                             MI55  48
REAL D#                                Hendrickson-lattmann coeff.      MI55  49
REAL DELPHI#                                                            MI55  50
REAL EXMAX#                            Exponent of max. probability     MI55  51
REAL FIGMER#                           Figure of merit                  MI55  52
REAL INCRAD#                           Half the phase increment         MI55  53
#                                         In radians.                   MI55  54
REAL PHIC#                             Centric phase                    MI55  55
REAL PHIMP#                                                             MI55  56
REAL PMAX#                             Maximum probability              MI55  57
REAL PROB#                             Probability of a particular      MI55  58
#                                         Alpha being the correct phase MI55  59
REAL Q#                                Exponent offset to convert to    MI55  60
#                                         Revised quasi-normalized      MI55  61
#                                         Probability.                  MI55  62
REAL SIN2#                             Sine of 2alpha                   MI55  63
REAL SIN2MP#                                                            MI55  64
REAL SINE#                             Sine of alpha                    MI55  65
REAL SINM#                             Sum of probability times         MI55  66
#                                         Sine(alpha).                  MI55  67
REAL SINMP#                                                             MI55  68
REAL SUM#                              Sum of probabilities             MI55  69
REAL U#                                                                 MI55  70
REAL UPRIME#                                                            MI55  71
#                                                                       MI55  72
SUM  = 0.0#                            Zero sums                        MI55  73
COSM = 0.0#                                                             MI55  74
SINM = 0.0#                                                             MI55  75
PROB = 0.0#                                                             MI55  76
#                                                                       MI55  77
IF(IPRC > 0)#                          Is reflection centric?           MI55  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI55  79
#                                                                       MI55  80
# PHASING FOR A CENTRIC REFLECTION                                      MI55  81
#                                                                       MI55  82
FIGMER = TANH(SQRT(A**2+B**2))#        Figure of merit                  MI55  83
IF((ABS(A) < small:) & (ABS(B) < small:))  PHIC = 0.#                   MI55  84
ELSE  PHIC = ATAN2(B,A)#               Mi5                              MI55  85
#                                                                       MI55  86
COSM = COS(PHIC)#                                                       MI55  87
SINM = SIN(PHIC)#                                                       MI55  88
MPROB = NINT(PHIC*DEGRAD)#             Phase in integer degrees         MI55  89
IF(MPROB <= 0)  MPROB = MPROB + 360#   Force between 1 and 360          MI55  90
EXMAX = A*COSM + B*SINM#               Maximum exponent                 MI55  91
Q = EXMAX - extop:#                                                     MI55  92
PMAX = EXP(extop:)#                    Maximum probability              MI55  93
PRPTR = STARPR + MPROB#                                                 MI55  94
QX(PRPTR) = PMAX#                      Store maximum probabilty         MI55  95
M180 = MPROB + 180#                    Phase 180 degrees away           MI55  96
IF(M180 > 360)  M180 = M180 - 360#     Force between 1 and 360          MI55  97
PRPTR = STARPR + M180#                                                  MI55  98
QX(PRPTR) = EXP(AMAX1(exmin:,-EXMAX-Q))# Store probability              MI55  99
IIN = MIN0(MPROB,M180)#                                                 MI55 100
INC = 180#                                                              MI55 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI55 102
#                                                                       MI55 103
ELSE#                                                                   MI55 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI55 105
#                                                                       MI55 106
#   PHASING FOR AN ACENTRIC REFLECTION                                  MI55 107
#                                                                       MI55 108
IIN = PHSINC#                          Start and increment              MI55 109
INC = PHSINC#                          For acentric reflections.        MI55 110
#                                                                       MI55 111
DO I=IIN,180,INC#                      In each cycle of loop            MI55 112
#                                         Calculate for alpha and       MI55 113
#                                         Alpha + 180.                  MI55 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI55 115
II = I + I#                            Find 2alpha                      MI55 116
ISIN = I + STARSC#                     Calculate offset to sin table    MI55 117
ISIN2 = II + STARSC#                   Sincos table starts at 1 deg.    MI55 118
COSINE = QX(ISIN+90)#                  Extract sine and cosine          MI55 119
SINE = QX(ISIN)#                       From table in qx array.          MI55 120
COS2 = QX(ISIN2+90)#                                                    MI55 121
SIN2 = QX(ISIN2)#                                                       MI55 122
PRPTR = I + STARPR#                                                     MI55 123
expon:(PRPTR) = A*COSINE + B*SINE + C*COS2 + D*SIN2# Calculate expone   MI55 124
expon:(PRPTR+180) = -A*COSINE - B*SINE + C*COS2 + D*SIN2#               MI55 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI55 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI55 127
#                                                                       MI55 128
EXMAX = voidflg:#                                                       MI55 129
DO I=IIN,360,INC#                      Find the maximum probability     MI55 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI55 131
PRPTR = I + STARPR#                                                     MI55 132
IF(expon:(PRPTR) > EXMAX)#                                              MI55 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI55 134
EXMAX = expon:(PRPTR)#                                                  MI55 135
MPROB = I#                                                              MI55 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI55 137
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI55 138
#                                                                       MI55 139
Q = EXMAX - extop:#                                                     MI55 140
DO I=IIN,360,INC#                                                       MI55 141
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI55 142
PRPTR = I + STARPR#                                                     MI55 143
expon:(PRPTR) = expon:(PRPTR) - Q#     Adjust to revised probability    MI55 144
expon:(PRPTR) = AMAX1(exmin:,expon:(PRPTR))#                            MI55 145
PROB = EXP(expon:(PRPTR))#             Could be replaced by table       MI55 146
#                                         Lookup.                       MI55 147
IF(I == MPROB)  PMAX = PROB#                                            MI55 148
SUM = SUM + PROB#                      Accumulate sums for              MI55 149
ISIN = I + STARSC#                     Figure of merit                  MI55 150
SINE = QX(ISIN)#                                                        MI55 151
COSINE = QX(ISIN+90)#                                                   MI55 152
COSM = COSM + PROB*COSINE#             And best phase.                  MI55 153
SINM = SINM + PROB*SINE#                                                MI55 154
expon:(PRPTR) = PROB#                  Stuff probability into           MI55 155
#                                         Qx array for later use.       MI55 156
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI55 157
#                                                                       MI55 158
COSM = COSM/SUM#                       Normalize sums                   MI55 159
SINM = SINM/SUM#                                                        MI55 160
FIGMER = SQRT(COSM**2+SINM**2)#        Calculate figure of merit        MI55 161
IF(FIGMER > 0.0)#                                                       MI55 162
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI55 163
COSM = COSM/FIGMER#                    Divide figure of merit           MI55 164
SINM = SINM/FIGMER#                    Out of cosine and sine of        MI55 165
#                                         Best phase.                   MI55 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI55 167
#                                                                       MI55 168
ELSE#                                                                   MI55 169
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI55 170
COSM = voidflg:#                       If figure of merit is zero,      MI55 171
SINM = voidflg:#                       Cannot calc. cos and sin.        MI55 172
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI55 173
#                                                                       MI55 174
#   REFINE ESTIMATE OF THE MOST PROBABLE PHASE                          MI55 175
INCRAD = 0.5*FLOAT(INC)/DEGRAD#        Convert increment to radians     MI55 176
ISIN = MPROB + STARSC#                                                  MI55 177
ISIN2 = MOD(2*MPROB,360) + STARSC#                                      MI55 178
COSMP = QX(ISIN+90)#                                                    MI55 179
SINMP = QX(ISIN)#                                                       MI55 180
COS2MP = QX(ISIN2+90)#                                                  MI55 181
SIN2MP = QX(ISIN2)#                                                     MI55 182
U = -A*SINMP + B*COSMP - 2.*C*SIN2MP + 2.*D*COS2MP#                     MI55 183
UPRIME = -(A*COSMP + B*SINMP + 4.*C*COS2MP + 4.*D*SIN2MP)#              MI55 184
PHIMP = ATAN2(SINMP,COSMP)#                                             MI55 185
DELPHI = -U/UPRIME#                                                     MI55 186
IF(ABS(DELPHI)>INCRAD) DELPHI=(DELPHI*INCRAD)/ABS(DELPHI)#              MI55 187
PHIMP = PHIMP + DELPHI#                                                 MI55 188
#                                                                       MI55 189
#   STORAGE OF RESULTS INTO QX ARRAY                                    MI55 190
#                                                                       MI55 191
figmer: = AMIN1(FIGMER,1.0)#           Stuff qx array with              MI55 192
#                                         Figure of merit               MI55 193
cosbst: = COSM#                        And cosine and sine              MI55 194
sinbst: = SINM#                        Of best phase.                   MI55 195
#                                        Stuff qx array with            MI55 196
cosmp: = COS(PHIMP)#                   Cosine and sine of               MI55 197
sinmp: = SIN(PHIMP)#                   Most probable phase.             MI55 198
QX(STARPR+361) = PMAX#                 Stuff maximum probability,       MI55 199
QX(STARPR+362) = FLOAT(IIN)#           Start, and increment into        MI55 200
QX(STARPR+363) = FLOAT(INC)#           Qx array for later use.          MI55 201
RETURN#                                                                 MI55 202
END#                                                                    MI55 203
systemheader:(MI56)#                                                    MI56   1
# ################################################################## #  MI56   2
#                                                                    #  MI56   3
#                               MI56                                 #  MI56   4
#                                                                    #  MI56   5
# ################################################################## #  MI56   6
SUBROUTINE MI56#                       Print out information about      MI56   7
#                                       #  Every nth reflection on last MI56   8
#                                       #  Cycle as requested.          MI56   9
#                                       # Called from mi50              MI56  10
#                                       # Feb 1981  s. sheriff          MI56  11
#                                       # Apr 1981  remove from mi55    MI56  12
include:(AACOMN)#                                                       MI56  13
include:(MICOMN)#                                                       MI56  14
include:(MIMAC4)#                                                       MI56  15
#                                                                       MI56  16
INTEGER I#                             Loop index to alpha, the         MI56  17
#                                         Protein phase being tested.   MI56  18
INTEGER IIN#                           Starting position for stepping   MI56  19
#                                         Around phase circle.          MI56  20
INTEGER INC#                           Increment for stepping around    MI56  21
#                                         Phase circle.                 MI56  22
INTEGER NSETS#                         Number of data sets in           MI56  23
#                                         Supplemental output.          MI56  24
INTEGER PRPTR#                         Position of expon or             MI56  25
#                                         Probability(alpha) in the qx. MI56  26
INTEGER ROPTR#                         Pointer to starro block of qx    MI56  27
REAL FMT563(1)#                                                         MI56  28
chardata:(MI561,    H   K   L    FPAR  PH-PROB  PH-BEST  $#             MI56  29
CENTROID    PROBABILITY DISTRIBUTION)#                                  MI56  30
chardata:(MI562, DATASET       FPHSQ   VAR  EISO    AH    BH      $#    MI56  31
A      B      C      D DELFSQ   VAR  EANO   AHP   BHP      )#           MI56  32
chardata:(MI563, PHASE INCREMENT TOO SMALL TO OUTPUT EVERY VALUE.  $#   MI56  33
RESET FOR OUTPUT ONLY TO   .)#                                          MI56  34
realdata:(FMT561,[50413.,90413.,$#                                      MI56  35
130413.,210813.,$#                                                      MI56  36
300513.,390513.,490742.])#                                              MI56  37
realdata:(FMT562,[ 200603.,260503.,$#                                   MI56  38
320503.,380503., 440503.,510603.,$#                                     MI56  39
580603.,650603., 720603.,790603.,$#                                     MI56  40
850503.,910503., 970503.,1030503.,$#                                    MI56  41
1100603.,1170603., 1240603.,1310603.])#                                 MI56  42
realdata:(FMT564,[780213.])#                                            MI56  43
datastuff:#                                                             MI56  44
#                                                                       MI56  45
IF(ICTREF <= ILIST)#                   On first entry adjust phase      MI56  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI56  47
IF(PHSINC <= 4)#                       Increment to be listed.          MI56  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI56  49
IF(PHSINC == 1)  BUFOT(1) = 5.#                                         MI56  50
ELSE  IF((PHSINC == 2) \ (PHSINC == 3))  BUFOT(1) = 6.#                 MI56  51
ELSE  IF(PHSINC == 4)  BUFOT(1) = 8.#                                   MI56  52
ncodefld:(BUFOT,1,MI563,FMT564,1)#                                      MI56  53
writeline:(1,MI563,NMI563,3,3)#                                         MI56  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI56  55
#                                                                       MI56  56
writeline:(2,0,0,3,3)#                 Blank lines for 1st output       MI56  57
IF(INFORM < 2) LINRM=5#                Basic output, 3 ref 1st page     MI56  58
ELSE#                                  Supplemental output              MI56  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI56  60
IF(INFORM == 2)  NSETS = 1#            Parent only                      MI56  61
IF(INFORM == 3)  NSETS = NDATIN#       All data sets                    MI56  62
IF(LINCT < 3 + NSETS)  LINCT = 0#      Write heading for 1st page       MI56  63
writeline:(0,MI561,NMI561,3,3)#        Output                           MI56  64
movechar:(MI562,1,CHROT,1,NMI562,0)#                                    MI56  65
movechar:(MI562,51,CHROT,NMI562+1,22,0)#                                MI56  66
writeline:(0,0,0,1,3)#                                                  MI56  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI56  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI56  69
#                                                                       MI56  70
IF(INFORM > 1 & LINCT < NSETS+1)#      For multi-line sub heading       MI56  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI56  72
LINCT = 0#                             Required for supplemental        MI56  73
writeline:(0,MI561,NMI561,3,3)#        Output.                          MI56  74
writeline:(0,MI562,NMI562,3,3)#                                         MI56  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI56  76
#                                                                       MI56  77
# PUT OUT H,K,L,PHASES,FOM, AND PROBABILITY DISTRIBUTION                MI56  78
#                                                                       MI56  79
movereal:(QX,STARCR+1,BUFOT,1,3,0)#    Move h, k, and l                 MI56  80
BUFOT(4) = fph:(STARRO)#               F-parent                         MI56  81
# CALCULATE MOST PROBABLE PHASE AND MAKE POSITIVE                       MI56  82
BUFOT(5) = ATAN2(sinmp:,cosmp:)*DEGRAD#                                 MI56  83
IF(BUFOT(5) < -0.5)  BUFOT(5) = BUFOT(5) + 360.#                        MI56  84
# CALCULATE BEST PHASE AND MAKE POSITIVE                                MI56  85
BUFOT(6) = ATAN2(sinbst:,cosbst:)*DEGRAD#                               MI56  86
IF(BUFOT(6) < -0.5)  BUFOT(6) = BUFOT(6) + 360.#                        MI56  87
BUFOT(7) = figmer:#                    Figure of merit                  MI56  88
ncodefld:(BUFOT,1,CHROT,FMT561(1),7)#                                   MI56  89
#                                                                       MI56  90
IIN = NINT(QX(STARPR+362))#                                             MI56  91
INC = NINT(QX(STARPR+363))#                                             MI56  92
IF(INC == 1)#                          Protect against wraparound       MI56  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI56  94
IIN = 5#                               For too small an increment.      MI56  95
INC = 5#                                                                MI56  96
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI56  97
#                                                                       MI56  98
ELSE  IF((IIN == 2) \ (IIN == 3))#                                      MI56  99
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI56 100
IIN = 6#                                                                MI56 101
INC = 6#                                                                MI56 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI56 103
#                                                                       MI56 104
ELSE  IF(IIN == 4)#                                                     MI56 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI56 106
IIN = 8#                                                                MI56 107
INC = 8#                                                                MI56 108
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI56 109
#                                                                       MI56 110
FMT563(1) = 530113.#                                                    MI56 111
DO I=IIN,360,INC#                                                       MI56 112
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI56 113
PRPTR = STARPR + I#                    Pointer to probability array     MI56 114
BUFOT(1) = 9.0*QX(PRPTR)#                                               MI56 115
FMT563(1) = FMT563(1) + 10000.#        Set output column position       MI56 116
ncodefld:(BUFOT,1,CHROT,FMT563,1)#                                      MI56 117
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI56 118
# BASIC OUTPUT                                                          MI56 119
IF(INFORM < 2) writeline:(0,MI561,NMI561,1,3)#                          MI56 120
ELSE#                                                                   MI56 121
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI56 122
writeline:(0,0,0,1,3)#                 Basic part of supplemental       MI56 123
ROPTR = STARRO#                        Start of refl. info.             MI56 124
DO I=1,NSETS#                                                           MI56 125
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI56 126
movereal:(0.0,1,BUFOT,1,18,2)#         Initialize for output            MI56 127
IF(fphsqn:(ROPTR)  > small:)    BUFOT(1)  = fphsqn:(ROPTR)# Fphsq   m   MI56 128
IF(varfsqn:(ROPTR) > small:)    BUFOT(2)  = varfsqn:(ROPTR)# Var        MI56 129
IF(eiso:(ROPTR)    > small:)    BUFOT(3)  = eiso:(ROPTR)# Eiso    m     MI56 130
IF(ahcalcn:(ROPTR) > voidflg:)  BUFOT(4)  = ahcalcn:(ROPTR)# Ah         MI56 131
IF(bhcalcn:(ROPTR) > voidflg:)  BUFOT(5)  = bhcalcn:(ROPTR)# Bh         MI56 132
IF(abcd:(ROPTR)    > voidflg:)  BUFOT(6)  = abcd:(ROPTR)# A       m     MI56 133
IF(abcd:(ROPTR+1)  > voidflg:)  BUFOT(7)  = abcd:(ROPTR+1)# B       m   MI56 134
IF(abcd:(ROPTR+2)  > voidflg:)  BUFOT(8)  = abcd:(ROPTR+2)# C       m   MI56 135
IF(abcd:(ROPTR+3)  > voidflg:)  BUFOT(9)  = abcd:(ROPTR+3)# D       m   MI56 136
IF(delfsqn:(ROPTR) > voidflg:)  BUFOT(10) = delfsqn:(ROPTR)# Delfsq     MI56 137
IF(vardelf:(ROPTR) > small:)    BUFOT(11) = vardelf:(ROPTR)# Var        MI56 138
IF(eano:(ROPTR)    > small:)    BUFOT(12) = eano:(ROPTR)# Eano    m     MI56 139
IF(aanomcn:(ROPTR) > voidflg:)  BUFOT(13) = aanomcn:(ROPTR)# Ahp        MI56 140
IF(banomcn:(ROPTR) > voidflg:)  BUFOT(14) = banomcn:(ROPTR)# Bhp        MI56 141
IF(abcdan:(ROPTR)  > voidflg:)  BUFOT(15) = abcdan:(ROPTR)# A       m   MI56 142
IF(abcdan:(ROPTR+1) > voidflg:) BUFOT(16) = abcdan:(ROPTR+1)# B         MI56 143
IF(abcdan:(ROPTR+2) > voidflg:) BUFOT(17) = abcdan:(ROPTR+2)# C         MI56 144
IF(abcdan:(ROPTR+3) > voidflg:) BUFOT(18) = abcdan:(ROPTR+3)# D         MI56 145
#                                                                       MI56 146
NAME = STARDN + STEPDN*(I-1) + 1#      Get dataset name                 MI56 147
movertoc:(QX(NAME),1,CHROT,2,12,0)#                                     MI56 148
ncodefld:(BUFOT,1,CHROT,FMT562(1),18)#                                  MI56 149
writeline:(0,0,0,1,3)#                                                  MI56 150
ROPTR = ROPTR + STEPRO#                Increment ptr. to refl. area     MI56 151
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI56 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI56 153
RETURN#                                                                 MI56 154
END#                                                                    MI56 155
systemheader:(MI58)#                                                    MI58   1
# ################################################################## #  MI58   2
#                                                                    #  MI58   3
#                               MI58                                 #  MI58   4
#                                                                    #  MI58   5
# ################################################################## #  MI58   6
SUBROUTINE MI58#                       Plot probability profiles on     MI58   7
#                                         Line printer.  called from    MI58   8
#                                         Mi50, on last cycle only, in  MI58   9
#                                         Response to plthkl line       MI58  10
#                                         Images; does not plot centric MI58  11
#                                         Reflections.                  MI58  12
#                                        May 1980  s. sheriff           MI58  13
include:(AACOMN)#                                                       MI58  14
include:(MICOMN)#                                                       MI58  15
#                                                                       MI58  16
INTEGER I#                             Loop index                       MI58  17
INTEGER IIN#                           Starting position for stepping   MI58  18
#                                         Around phase circle.          MI58  19
INTEGER INC#                           Increment for stepping around    MI58  20
#                                         Phase circle.                 MI58  21
INTEGER K#                             Loop index for top of page to    MI58  22
#                                         Bottom.                       MI58  23
INTEGER M#                             Abcissa postion on page          MI58  24
INTEGER MULT#                          Multiplication factor for        MI58  25
#                                         Abscissa scale.               MI58  26
INTEGER NAME#                          Pointer to data set name         MI58  27
INTEGER NPLOT#                         Pointer to current group of      MI58  28
#                                         Plots.                        MI58  29
INTEGER PRPTR#                         Pointer to probability           MI58  30
#                                         Distribution part of qx array MI58  31
INTEGER ROPTR#                         Pointer to starro part of qx     MI58  32
INTEGER NUMBER#                        Number of plots for current      MI58  33
#                                         Group.                        MI58  34
INTEGER NUMDAT#                        Data set number minus one        MI58  35
REAL FMT582(5)#                        Formats                          MI58  36
REAL PMAX#                             Maximum probabilty for this      MI58  37
#                                         Reflection.                   MI58  38
REAL VARFMT(1)#                        Variable format                  MI58  39
chardata:(MI581, H =     K =     L =     START =     INC =     $#       MI58  40
PMAX =         FIGMER =      BEST =     MOST PROB =     )#              MI58  41
chardata:(MI582,RELATIVE PROBABILITY)#                                  MI58  42
chardata:(MI583,*.ALPHA)#                                               MI58  43
chardata:(MI584,COMPID     FSQ     VAR AHCALC BHCALC   EISO)#           MI58  44
chardata:(MI585,         DELFSQ        AANOMC BANOMC   EANO)#           MI58  45
realdata:(FMT581,[ 80413.,160413.,$#                                    MI58  46
240413.,360313.,460313.,610721.,$#                                      MI58  47
750432.,860313.,1020313.])#                                             MI58  48
realdata:(FMT583,[ 50513.,60303.])#                                     MI58  49
intdata:(ICHECK,0)#                                                     MI58  50
datastuff:#                                                             MI58  51
#                                                                       MI58  52
IF(ICHECK == no:)#                     First call to routine            MI58  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI58  54
ICHECK = yes:#                                                          MI58  55
NUMBER = NUMPLT(1)#                                                     MI58  56
NPLOT = 1#                                                              MI58  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI58  58
#                                                                       MI58  59
IF((hkl: >= PLTHKL(NPLOT)) \ (NUMBER < NUMPLT(NPLOT)))#                 MI58  60
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI58  61
NUMBER = NUMBER - 1#                                                    MI58  62
IF(NUMBER == 0)#                       Go on to next group to be        MI58  63
#                                         Plotted.                      MI58  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI58  65
IPLOT = IPLOT - 1#                     Plots remaining                  MI58  66
NPLOT = NPLOT + 1#                     Current group number             MI58  67
NUMBER = NUMPLT(NPLOT)#                Number of plots in group         MI58  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI58  69
#                                                                       MI58  70
PMAX = QX(STARPR+361)#                                                  MI58  71
IF((PMAX <= 0.0) \ (IPRC > 0))  RETURN#                                 MI58  72
IIN = NINT(QX(STARPR+362))#                                             MI58  73
INC = NINT(QX(STARPR+363))#                                             MI58  74
#                                                                       MI58  75
# PROTECT US FROM WRAPAROUND FOR THOSE WHO CHOOSE FINELY-SPACED         MI58  76
#  INCREMENTS.                                                          MI58  77
#                                                                       MI58  78
IF(INC < 4)#                                                            MI58  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI58  80
IIN = 6#                                                                MI58  81
INC = 6#                                                                MI58  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI58  83
#                                                                       MI58  84
ELSE  IF(INC == 4)#                                                     MI58  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI58  86
IIN = 8#                                                                MI58  87
INC = 8#                                                                MI58  88
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI58  89
#                                                                       MI58  90
# PUT OUT HEADER                                                        MI58  91
#                                                                       MI58  92
LINCT = 0#                             Force new page                   MI58  93
movechar:(MI581,1,CHROT,1,NMI581,0)#                                    MI58  94
movereal:(hh:,1,BUFOT,1,3,0)#          Get h,k,l                        MI58  95
BUFOT(4) = QX(STARPR+362)#                                              MI58  96
BUFOT(5) = QX(STARPR+363)#                                              MI58  97
BUFOT(6) = PMAX#                                                        MI58  98
BUFOT(7) = figmer:#                                                     MI58  99
BUFOT(8) = ATAN2(sinbst:,cosbst:)*DEGRAD#                               MI58 100
IF(BUFOT(8) < 0.0)  BUFOT(8) = BUFOT(8) + 360.0#                        MI58 101
BUFOT(9) = ATAN2(sinmp:,cosmp:)*DEGRAD#                                 MI58 102
IF(BUFOT(9) < 0.0)  BUFOT(9) = BUFOT(9) + 360.0#                        MI58 103
ncodefld:(BUFOT,1,CHROT,FMT581(1),9)#                                   MI58 104
writeline:(2,0,0,1,3)#                                                  MI58 105
writeline:(1,0,0,1,3)#                                                  MI58 106
#                                                                       MI58 107
# CALCULATE OUTPUT CONTROL                                              MI58 108
#                                                                       MI58 109
FMT582(1) = FLOAT((360/IIN)+22)*10000. + 603.#                          MI58 110
FMT582(2) = FLOAT((360/IIN)+29)*10000. + 603.#                          MI58 111
FMT582(3) = FLOAT((360/IIN)+36)*10000. + 603.#                          MI58 112
FMT582(4) = FLOAT((360/IIN)+43)*10000. + 603.#                          MI58 113
FMT582(5) = FLOAT((360/IIN)+50)*10000. + 603.#                          MI58 114
#                                                                       MI58 115
# PLOT PROBABILITY PROFILE                                              MI58 116
#                                                                       MI58 117
FOR(K=factor:; K >= 0; K=K-1)#         Descend from top of page         MI58 118
#                                         To bottom.                    MI58 119
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI58 120
IF(MOD(K,5) == 0)#                     Put scale on ordinate            MI58 121
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI58 122
BUFOT(1) = 2*K#                                                         MI58 123
ncodefld:(BUFOT,1,CHROT,FMT583(1),1)#                                   MI58 124
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI58 125
#                                                                       MI58 126
M = 0#                                                                  MI58 127
DO I=IIN,360,INC#                                                       MI58 128
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI58 129
M = M + 1#                             Abcissa position                 MI58 130
PRPTR = STARPR + I#                    Access probability               MI58 131
#                                         Distribution.                 MI58 132
#                                                                       MI58 133
# IF VALUE IS EQUAL TO CURRENT LINE, PRINT "*"                          MI58 134
IF(NINT((QX(PRPTR)/PMAX)*FLOAT(factor:)) == K)#                         MI58 135
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI58 136
movechar:(MI583,1,CHROT,M+6,1,0)#                                       MI58 137
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI58 138
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI58 139
#                                                                       MI58 140
IF((K < 35) & (K >= 15))#              Label ordinate                   MI58 141
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI58 142
movechar:(MI582,35-K,CHROT,2,1,0)#                                      MI58 143
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI58 144
#                                                                       MI58 145
IF (K == factor:)  movechar:(MI584,1,CHROT,M+8,NMI584,0)#               MI58 146
ELSE  IF(K == (factor:-1)) movechar:(MI585,1,CHROT,M+8,NMI585,0)#       MI58 147
ELSE  IF((factor:-K-2) < (2*NDATIN))#  Write values                     MI58 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI58 149
NUMDAT = (factor:-K-2)/2#              Dataset number minus one         MI58 150
NAME = STARDN+NUMDAT*STEPDN+1#         Pointer to dataset name          MI58 151
ROPTR = STARRO + STEPRO*NUMDAT#        Pointer to starro region of qx   MI58 152
IF(MOD((factor:-K),2) == 0)#           Isomorphous information          MI58 153
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI58 154
movertoc:(QX(NAME),1,CHROT,M+8,6,0)#                                    MI58 155
DO I=1,5#                              Clear out array                  MI58 156
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI58 157
BUFOT(I) = 0.0#                                                         MI58 158
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI58 159
#                                                                       MI58 160
ifnv:(fphn:(ROPTR))    BUFOT(1) = fphn:(ROPTR)# Amplitude               MI58 161
ifnv:(varfsq:(ROPTR))  BUFOT(2) = varfsq:(ROPTR)# Var                   MI58 162
ifnv:(ahcalc:(ROPTR))  BUFOT(3) = ahcalc:(ROPTR)# A                     MI58 163
ifnv:(bhcalc:(ROPTR))  BUFOT(4) = bhcalc:(ROPTR)# B                     MI58 164
ifnv:(eiso:(ROPTR))    BUFOT(5) = SQRT(eiso:(ROPTR))# Iso closure err   MI58 165
ncodefld:(BUFOT,1,CHROT,FMT2,5)#                                        MI58 166
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI58 167
#                                                                       MI58 168
ELSE#                                  Anomalous information            MI58 169
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI58 170
movertoc:(QX(NAME+6),1,CHROT,M+8,6,0)#                                  MI58 171
DO I=1,5#                              Clear out array                  MI58 172
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI58 173
BUFOT(I) = 0.0#                                                         MI58 174
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI58 175
ifnv:(delfsqn:(ROPTR))  BUFOT(1) = delfsqn:(ROPTR)# Amplitude           MI58 176
ifnv:(vardelf:(ROPTR))  BUFOT(2) = vardelf:(ROPTR)# Var                 MI58 177
ifnv:(aanomc:(ROPTR))   BUFOT(3) = aanomc:(ROPTR)# A"                   MI58 178
ifnv:(banomc:(ROPTR))   BUFOT(4) = banomc:(ROPTR)# B"                   MI58 179
ifnv:(eano:(ROPTR))  BUFOT(5) = SQRT(eano:(ROPTR))# Anom. closure err   MI58 180
ncodefld:(BUFOT,1,CHROT,FMT582(1),5)#                                   MI58 181
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI58 182
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI58 183
writeline:(0,0,0,1,3)#                                                  MI58 184
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI58 185
#                                                                       MI58 186
# LABEL ABCISSA                                                         MI58 187
#                                                                       MI58 188
IF(MOD((360/INC),5) == 0)  MULT = 5#                                    MI58 189
ELSE  MULT = 6#                                                         MI58 190
IIN = IIN*MULT#                                                         MI58 191
INC = INC*MULT#                                                         MI58 192
FOR(I=0; I <= 360; I=I+INC)#           Put tick marks on abcissa        MI58 193
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MI58 194
movechar:(MI583,2,CHROT,((I/INC)*MULT+6),1,0)#                          MI58 195
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MI58 196
writeline:(0,0,0,1,3)#                                                  MI58 197
BUFOT(1) = 0.0#                                                         MI58 198
ncodefld:(BUFOT,1,CHROT,FMT583(2),1)#                                   MI58 199
#                                                                       MI58 200
DO I=IIN,360,INC#                      Put scale on abcissa             MI58 201
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MI58 202
BUFOT(1) = FLOAT(I)#                                                    MI58 203
VARFMT(1) = FLOAT((I/INC)*MULT)*10000. + 70303.#                        MI58 204
ncodefld:(BUFOT,1,CHROT,VARFMT(1),1)#                                   MI58 205
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MI58 206
#                                                                       MI58 207
writeline:(0,0,0,1,3)#                                                  MI58 208
movechar:(MI583,3,CHROT,(((360*MULT)/(2*INC))+5),5,0)#                  MI58 209
writeline:(0,0,0,1,3)#                 Label abcissa                    MI58 210
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI58 211
RETURN#                                                                 MI58 212
END#                                                                    MI58 213
systemheader:(MI61)#                                                    MI61   1
# ################################################################## #  MI61   2
#                                                                    #  MI61   3
#                               MI61                                 #  MI61   4
#                                                                    #  MI61   5
# ################################################################## #  MI61   6
SUBROUTINE MI61#                       Produces minimum variance        MI61   7
#                                         Fourier coefficients (mvfc)   MI61   8
#                                         By method of sygusch.         MI61   9
#                                        Nov 1979  g.n. reeke and       MI61  10
#                                                  J. sygusch           MI61  11
#                                        Modified jun 1980  j. sygusch  MI61  12
include:(AACOMN)#                                                       MI61  13
include:(MICOMN)#                                                       MI61  14
#                                                                       MI61  15
INTEGER AINCR#                         Increment for iang               MI61  16
INTEGER ANGLE1#                        (position of first minimum)      MI61  17
#                                         + aincr.                      MI61  18
INTEGER ANGLE2#                        (position of other minimum)      MI61  19
#                                         + aincr.                      MI61  20
INTEGER ARG#                           Angle table argument             MI61  21
INTEGER ASTOP#                         Last value for iang              MI61  22
INTEGER ASTRT#                         First value for iang             MI61  23
INTEGER DOALT#                         =0, no alt; =1, do alt phasing   MI61  24
INTEGER IANG#                          Current alpha in alt. method     MI61  25
INTEGER J#                             Derivative index, ptr. to qx     MI61  26
INTEGER JINCR#                         Increment for j                  MI61  27
INTEGER JSTOP#                         Last value for j                 MI61  28
INTEGER JSTRT#                         First value for j                MI61  29
INTEGER LENGTH#                        Length of heading line           MI61  30
INTEGER MCYC#                          Cycle counter                    MI61  31
INTEGER NCYCS#                         Max number of refine cycles      MI61  32
INTEGER SIR#                           =0, not sir; =1, sir             MI61  33
INTEGER TICK#                          =+1, ssum increasing             MI61  34
#                                        =-1, ssum decreasing           MI61  35
INTEGER TRIGSW#                        0/1, refine cos/sin              MI61  36
REAL A11#                              Least squares matrix (1 by 1)    MI61  37
REAL B1#                               Least squares vector             MI61  38
REAL COEFF#                                                             MI61  39
REAL COSA#                             Cos(alpha)                       MI61  40
REAL DDFT#                             Partial of dfphc2 with respect   MI61  41
#                                         To trig.                      MI61  42
REAL DFFP#                             Partial of fphc2 or dfphc2       MI61  43
#                                         With respect to fp**2.        MI61  44
REAL DFPHC2#                           Delta for anom calc. squared     MI61  45
REAL DFT#                              Partial of fphc2 with respect    MI61  46
#                                         To trig.                      MI61  47
REAL FIGMRT#                           Figure of merit                  MI61  48
REAL FMT611(arith:(6,+,maxcycs:))#     Formats                          MI61  49
REAL FOURFP#                           4*fp                             MI61  50
REAL FP#                               Observed fo                      MI61  51
REAL FPHC2#                            Fph calc. squared                MI61  52
REAL FPHCA#                            Real (fph calc)                  MI61  53
REAL FPHCB#                            Imag (fph calc)                  MI61  54
REAL FPSQ#                             Fobs squared                     MI61  55
REAL ONEOFP#                           1./fp                            MI61  56
REAL PHASE#                            Starting phase                   MI61  57
REAL PHZTBL(maxcycs:)#                 Phases prior to each least       MI61  58
#                                         Squares cycle.                MI61  59
REAL SHIFT#                            Least squares shift              MI61  60
REAL SIGT2#                            Sigma t squared                  MI61  61
REAL SINA#                             Sin(alpha)                       MI61  62
REAL SMIN1#                            Value of residual at first       MI61  63
#                                         Minimum.                      MI61  64
REAL SMIN2#                            Value of residual at other       MI61  65
#                                         Minimum.                      MI61  66
REAL SPRV#                             Previous residual sum            MI61  67
REAL SSUM#                             Current residual sum             MI61  68
REAL TANCOT#                           Tan(alpha) or cot(alpha)         MI61  69
REAL TWOFP#                            2*fp                             MI61  70
REAL VARFP2#                           Variance fpsq                    MI61  71
REAL WT#                               A weight                         MI61  72
intdata:(ICHECK,0)#                                                             
chardata:(MI611,         H    K    L       F   PHASE   FIGMRT  $#       MI61  73
COURSE OF PHASE DETERMINATION DURING THIS CYCLE)#                       MI61  74
chardata:(MI612,VOID)#                                                  MI61  75
realdata:(BIG,[1E25])#                                                  MI61  76
intdata:(CSTRT,[ 0, 30, 45, 60,$#                                       MI61  77
90,120,135,150])#                      Table of centric phase start     MI61  78
realdata:(WTCNT,[1.0,1.57735,2.0,1.57735,$#                             MI61  79
1.0,1.57735,2.0,1.57735])#             Table of centric zone weight     MI61  80
datastuff:#                                                             MI61  81
#                                                                       MI61  82
FMT611(1)=100513.;FMT611(2)=150513.;FMT611(3)=200513.#                  MI61  83
FMT611(4)=301012.;FMT611(5)=350513.;FMT611(6)=450632.#                  MI61  84
FMT611(7)=530513.;FMT611(8)=580513.;FMT611(9)=630513.#                  MI61  85
FMT611(10)=680513.;FMT611(11)=730513.;FMT611(12)=780513.#               MI61  86
FMT611(13)=830513.;FMT611(14)=880513.;FMT611(15)=930513.#               MI61  87
FMT611(16)=980513.#                                                     MI61  88
#                                                                       MI61  89
# INITIALIZE CONTROL VARIABLES                                          MI61  90
#                                                                       MI61  91
AINCR = PHSINC#                        Pick up phsinc                   MI61  92
ASTRT = 0#                             Default start = 0 deg.           MI61  93
NCYCS = maxcycs:#                      Set max refine cycles            MI61  94
JSTRT = STARRO + STEPRO#               Start value of j                 MI61  95
JSTOP = STOPRO#                        Stop for j                       MI61  96
JINCR = STEPRO#                        Increment for j                  MI61  97
SHIFT = 0.0#                                                            MI61  98
#                                                                       MI61  99
# PICK UP NATIVE DATA                                                   MI61 100
#                                                                       MI61 101
FP = fphn:(STARRO)#                    Fobs                             MI61 102
ONEOFP = 1./FP#                                                         MI61 103
TWOFP  = 2.*FP#                                                         MI61 104
FOURFP = 4.*FP#                                                         MI61 105
FPSQ = fphsqn:(STARRO)#                Fobs squared                     MI61 106
VARFP2 = varfsqn:(STARRO)#             Variance (fpsq)                  MI61 107
#                                                                       MI61 108
# COUNT AVAILABLE OBSERVATIONS,SCALE FH,SET SIR SWITCH                  MI61 109
#                                                                       MI61 110
SIR = 0#                                                                MI61 111
FOR(J=JSTRT; J < JSTOP; J=J+JINCR)#                                     MI61 112
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI61 113
IF(anflg:(J) <= 0.0)  NEXT#            Skip, if not using               MI61 114
ifvo:(fphsqn:(J))  NEXT#               Skip, if no data                 MI61 115
ifne:(anflg:(J),2.0)#                  Using isomorphous?               MI61 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI61 117
ifnv:(fphsqn:(J))#                     Yes, present?                    MI61 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI61 119
SIR = SIR + 1#                         Yes, count it                    MI61 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI61 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI61 122
#                                                                       MI61 123
IF(anflg:(J) >= 2.0)#                  Using anomalous?                 MI61 124
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI61 125
ifnv:(delfsqn:(J))#                    Yes, present?                    MI61 126
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI61 127
SIR = SIR + 1#                         Yes, count it                    MI61 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI61 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI61 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI61 131
#                                                                       MI61 132
IF(SIR == 0)#                          Any at all?                      MI61 133
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI61 134
figmer: = 0.#                          No, return with no phase         MI61 135
cosbst: = voidflg:#                                                     MI61 136
sinbst: = voidflg:#                                                     MI61 137
cosmp:  = voidflg:#                                                     MI61 138
sinmp:  = voidflg:#                                                     MI61 139
anflg:(J) = 0.0#                       Turn this observation off        MI61 140
RETURN#                                Exit with no phase               MI61 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI61 142
#                                                                       MI61 143
IF(SIR > 1)  SIR = 0#                  Set for mir                      MI61 144
#                                                                       MI61 145
# CHECK FOR VARIOUS SPECIAL CASES (CENTRIC, ETC.)                       MI61 146
#                                                                       MI61 147
DOALT = 1#                             Set for alternate phasing        MI61 148
IF(IPRC > 0)#                          Is it centric?                   MI61 149
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI61 150
AINCR = 180#                           Yes, set increment               MI61 151
ASTRT = CSTRT(IPRC)#                   And start.                       MI61 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI61 153
#                                                                       MI61 154
ELSE  IF(FPSQ < SIGCUT*SQRT(VARFP2))#  Is it weak?                      MI61 155
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI61 156
NCYCS = 1#                             Yes, do only one cycle           MI61 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI61 158
ELSE IF(NUMVPH == no:)#                If we are not required to        MI61 159
#                                         Start with new phases, check  MI61 160
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI61 161
ifnv:(cosbst:)#                        For a phase estimate.            MI61 162
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI61 163
#                                        Yes, there is an estimate,     MI61 164
DOALT = 0#                             So bypass alt. phasing.          MI61 165
COSA = cosbst:#                        Pick up external phase, etc.     MI61 166
SINA = sinbst:#                                                         MI61 167
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI61 168
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI61 169
#                                                                       MI61 170
# LOOP OVER ENTIRE PHASING PROCEDURE                                    MI61 171
#                                                                       MI61 172
DO MCYC=1,NCYCS#                       Do at most ncycs cycles          MI61 173
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI61 174
# ALTERNATE PHASING PROCEDURE (GO ROUND CIRCLE)                         MI61 175
IF (DOALT > 0 )#                                                        MI61 176
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI61 177
# INITIALIZE SEARCH FOR ONE OR TWO MINIMA                               MI61 178
SMIN1 = BIG#                           Set very large min.              MI61 179
ANGLE1 = -1#                           Flag - no 2nd minimum found      MI61 180
SPRV = BIG#                            Set large previous s             MI61 181
#                                                                       MI61 182
# LOOP OVER VALID ANGLES AND ONE EXTRA AT THE END                       MI61 183
ASTOP = ASTRT + 360#                   Allow for overlap                MI61 184
FOR(IANG=ASTRT; IANG <= ASTOP; IANG=IANG+AINCR)#                        MI61 185
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI61 186
ARG = MOD(IANG,360) + STARSC#          Generate actual angle            MI61 187
SINA = sincos:(ARG)#                   Fetch trig function              MI61 188
COSA = sincos:(ARG+90)#                                                 MI61 189
SSUM = 0.0#                            Zero the residual sum            MI61 190
#                                                                       MI61 191
# LOOP OVER ISOMORPHOUS COMPOUNDS                                       MI61 192
FOR(J=JSTRT; J < JSTOP; J=J+JINCR)#                                     MI61 193
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI61 194
IF(anflg:(J) <= 0.0)  NEXT#            Omit, if not using               MI61 195
ifvo:(fphsqn:(J))  NEXT#               Or if no data.                   MI61 196
FPHCA = FP*COSA + ahcalc:(J)#          Form fph calc.                   MI61 197
FPHCB = FP*SINA + bhcalc:(J)#                                           MI61 198
FPHC2 = FPHCA**2 + FPHCB**2#           Fph calc. squared                MI61 199
#                                                                       MI61 200
# PREPARE AND ADD ANOMALOUS TERM                                        MI61 201
IF(anflg:(J) >= 2.0 & delfsqn:(J) > voidflg:)# Anomalous?               MI61 202
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI61 203
FPHC2 = FPHC2 + aanomc:(J)**2 + banomc:(J)**2#                          MI61 204
DFPHC2 = 2.0*(FPHCA*aanomc:(J)+FPHCB*banomc:(J))#                       MI61 205
DFFP = ONEOFP*(aanomc:(J)*COSA+banomc:(J)*SINA)#                        MI61 206
varano:(J) = varfsqn:(J) + DFFP**2*VARFP2#                              MI61 207
SSUM = SSUM + (delfsqn:(J)-DFPHC2)**2/varano:(J)#                       MI61 208
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI61 209
#                                                                       MI61 210
# PREPARE AND ADD NORMAL TERM                                           MI61 211
ifne:(anflg:(J),2.0)#                  Using isomorphous?               MI61 212
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MI61 213
DFFP = ONEOFP*(FPHCA*COSA+FPHCB*SINA)#                                  MI61 214
variso:(J) = varfsqn:(J) + DFFP**2*VARFP2#                              MI61 215
SSUM = SSUM + (fphsqn:(J)-FPHC2)**2/variso:(J)#                         MI61 216
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MI61 217
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI61 218
#                                                                       MI61 219
# NOW WE HAVE RESIDUAL SUM.  SEARCH FOR MINIMA                          MI61 220
IF(SSUM <= SPRV)#                      Are we decreasing?               MI61 221
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MI61 222
TICK = -1#                             Yes, so indicate                 MI61 223
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MI61 224
ELSE  IF(TICK <= 0)#                   Increasing; check for inflxn     MI61 225
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MI61 226
TICK = +1#                             Indicate increasing              MI61 227
IF(SIR > 0)#                           Is it sir?                       MI61 228
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MI61 229
SMIN2 = SMIN1#                         Yes, so keep two minima          MI61 230
ANGLE2 = ANGLE1#                                                        MI61 231
SMIN1 = SPRV#                                                           MI61 232
ANGLE1 = IANG - AINCR#                                                  MI61 233
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MI61 234
#                                                                       MI61 235
ELSE  IF(SPRV < SMIN1)#                Not sir, just keep deepest       MI61 236
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MI61 237
SMIN1 = SPRV#                                                           MI61 238
ANGLE1 = IANG - AINCR#                                                  MI61 239
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MI61 240
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MI61 241
#                                                                       MI61 242
SPRV = SSUM#                           Record new ssum as previous      MI61 243
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI61 244
#                                                                       MI61 245
# HAVE MINIMA; IF SIR, AVERAGE TWO MINIMA                               MI61 246
ARG = ANGLE1#                                                           MI61 247
IF(SIR > 0 & IPRC == 0 & ANGLE2 > 0)#                                   MI61 248
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MI61 249
ARG = (ANGLE2+ANGLE1)/2#               Compute average angle            MI61 250
IF(IABS(ANGLE2-ANGLE1) > 180)#                                          MI61 251
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MI61 252
ARG = 180. + ARG#                      Take closer way around           MI61 253
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MI61 254
IF(FLOAT(IABS(ARG-ANGLE2)) > BIMODL)#  Check if bimodal solutions       MI61 255
#                                         Are close enough.             MI61 256
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MI61 257
figmer: = 0.#                          Not close enough                 MI61 258
cosbst: = voidflg:#                                                     MI61 259
sinbst: = voidflg:#                                                     MI61 260
cosmp:  = voidflg:#                                                     MI61 261
sinmp:  = voidflg:#                                                     MI61 262
RETURN#                                Exit                             MI61 263
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MI61 264
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MI61 265
#                                                                       MI61 266
# HAVE ARGUMENT, NOW SET TRIAL PHASE                                    MI61 267
IF(ARG < 1)  ARG = 0#                                                   MI61 268
ARG = MOD(ARG,360) + STARSC#           Be sure in range of table        MI61 269
SINA = sincos:(ARG)#                                                    MI61 270
COSA = sincos:(ARG+90)#                                                 MI61 271
DOALT = 0#                             Prevent second time through      MI61 272
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI61 273
#                                                                       MI61 274
# BEGIN LEAST SQUARES PHASING PROCEDURE                                 MI61 275
#                                                                       MI61 276
A11 = 0.#                              Zero least-squares matrix        MI61 277
B1 = 0.#                               And vector.                      MI61 278
#                                                                       MI61 279
PHASE = ATAN2(SINA,COSA)*DEGRAD#       Save incoming phase              MI61 280
IF(PHASE < -0.5)  PHASE = PHASE + 360.# Make positive                   MI61 281
PHZTBL(MCYC) = PHASE#                                                   MI61 282
#                                                                       MI61 283
IF(ABS(COSA) <= ABS(SINA))#            Choose cos or sin to refine      MI61 284
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MI61 285
TRIGSW = 0#                                                             MI61 286
TANCOT = COSA/SINA#                    Cosine                           MI61 287
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MI61 288
ELSE#                                                                   MI61 289
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MI61 290
TRIGSW = 1#                                                             MI61 291
TANCOT = SINA/COSA#                    Sine                             MI61 292
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MI61 293
#                                                                       MI61 294
# PREPARATION COMMON TO NORMAL AND ANOMALOUS COMPOUNDS                  MI61 295
FOR(J=JSTRT; J < JSTOP; J=J+JINCR)#                                     MI61 296
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MI61 297
IF(anflg:(J) <= 0.0)  NEXT#            Omit, if not using               MI61 298
ifvo:(fphsqn:(J))  NEXT#               Or if no data.                   MI61 299
FPHCA = FP*COSA + ahcalc:(J)#          Form fph calc.                   MI61 300
FPHCB = FP*SINA + bhcalc:(J)#                                           MI61 301
FPHC2 = FPHCA**2 + FPHCB**2#           Fph calc. squared                MI61 302
IF(IPRC != 0)#                         Centric cases go here            MI61 303
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MI61 304
COEFF = WTCNT(IPRC)*FOURFP#                                             MI61 305
IF(TRIGSW > 0)  DFT = COEFF*FPHCA#                                      MI61 306
ELSE  DFT = COEFF*FPHCB#                                                MI61 307
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MI61 308
ELSE#                                                                   MI61 309
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MI61 310
IF(TRIGSW <= 0)  DFT = FOURFP*(FPHCA-TANCOT*FPHCB)#                     MI61 311
ELSE  DFT = FOURFP*(FPHCB-TANCOT*FPHCA)#                                MI61 312
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MI61 313
#                                                                       MI61 314
# NOW TAKE CARE OF ANOMALOUS SCATTERING                                 MI61 315
IF(anflg:(J) >= 2.0 & delfsqn:(J) > voidflg:)#                          MI61 316
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 MI61 317
FPHC2 = FPHC2 + aanomc:(J)**2 + banomc:(J)**2#                          MI61 318
DFPHC2 = 2.0*(FPHCA*aanomc:(J)+FPHCB*banomc:(J))#                       MI61 319
DFFP = ONEOFP*(aanomc:(J)*COSA+banomc:(J)*SINA)#                        MI61 320
varano:(J) = varfsqn:(J) + DFFP**2*VARFP2#                              MI61 321
WT = 1.0/varano:(J)#                                                    MI61 322
IF(TRIGSW <= 0)#                                                        MI61 323
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 MI61 324
DDFT = FOURFP*(aanomc:(J)-TANCOT*banomc:(J))#                           MI61 325
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 MI61 326
ELSE#                                                                   MI61 327
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 MI61 328
DDFT = FOURFP*(banomc:(J)-TANCOT*aanomc:(J))#                           MI61 329
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 MI61 330
A11 = A11 + WT*DDFT**2#                Accumulate matrix, vector        MI61 331
B1 = B1 + WT*(delfsqn:(J)-DFPHC2)*DDFT##                                MI61 332
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 MI61 333
#                                                                       MI61 334
# MATRIX ACCUMULATION FOR ISOMORPHOUS REPLACEMENTS                      MI61 335
ifne:(anflg:(J),2.0)#                  Using isomorphous?               MI61 336
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 MI61 337
DFFP = ONEOFP*(FPHCA*COSA+FPHCB*SINA)#                                  MI61 338
variso:(J) = varfsqn:(J) + DFFP**2*VARFP2#                              MI61 339
WT = 1.0/variso:(J)#                                                    MI61 340
A11 = A11 + WT*DFT**2#                 Accumulate matrix                MI61 341
B1 = B1 + WT*(fphsqn:(J)-FPHC2)*DFT#                                    MI61 342
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 MI61 343
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MI61 344
#                                                                       MI61 345
# SHIFT COSA AND SINA CONDITIONALLY                                     MI61 346
IF(SIR == 0)  SHIFT = B1/A11#          Apply acentric shift             MI61 347
IF(IPRC == 0)#                                                          MI61 348
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 MI61 349
SHIFT = SHIFT*PHSHFT#                  Apply partial shift              MI61 350
IF(ABS(SHIFT) > .7)  SHIFT = 0.25*SHIFT#                                MI61 351
IF(TRIGSW <= 0)#                                                        MI61 352
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 MI61 353
COSA = COSA + SHIFT#                   Shift cosine                     MI61 354
SIGT2 = 1.0 - COSA**2#                 Save sin**2                      MI61 355
IF(SIGT2 < 1E-6)#                      Check for domain error           MI61 356
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 MI61 357
COSA = SIGN(1.0,COSA)#                 Bad, set big error               MI61 358
SINA = 0.0#                                                             MI61 359
SIGT2 = BIG#                                                            MI61 360
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 MI61 361
ELSE#                                                                   MI61 362
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 MI61 363
SINA = SIGN(SQRT(SIGT2),SINA)#         Ok, proceed normally             MI61 364
IF(A11 <= 0.)  SIGT2 = BIG#            Set big error                    MI61 365
ELSE  SIGT2 = GOFPRV/(A11*SIGT2)#      Trig variance                    MI61 366
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 MI61 367
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 MI61 368
#                                                                       MI61 369
ELSE#                                                                   MI61 370
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 MI61 371
SINA = SINA + SHIFT#                   Shift sine                       MI61 372
SIGT2 = 1.0 - SINA**2#                 Save cos**2                      MI61 373
IF(SIGT2 < 1E-6)#                      Check for domain error           MI61 374
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 MI61 375
SINA = SIGN(1.0,COSA)#                 Bad, set big error               MI61 376
COSA = 0.0#                                                             MI61 377
SIGT2 = BIG#                                                            MI61 378
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 MI61 379
ELSE#                                                                   MI61 380
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 MI61 381
COSA = SIGN(SQRT(SIGT2),COSA)#         Ok, proceed normally             MI61 382
IF(A11 <= 0.)  SIGT2 = BIG#            Set big error                    MI61 383
ELSE  SIGT2 = GOFPRV/(A11*SIGT2)#      Trig variance                    MI61 384
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 MI61 385
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 MI61 386
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 MI61 387
#                                                                       MI61 388
ELSE#                                                                   MI61 389
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 MI61 390
SIGT2 = GOFPRV/A11#                                                     MI61 391
BREAK#                                                                  MI61 392
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 MI61 393
IF(SIGT2 <= REFCUT)  BREAK#            Variance small - exit            MI61 394
IF(ABS(SHIFT) < .01) BREAK#            Shift small - exit               MI61 395
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI61 396
#                                                                       MI61 397
# CALCULATE FINAL "FIGURE OF MERIT"                                     MI61 398
#                                                                       MI61 399
FIGMRT = 1.0/(1.0+VARFP2/(2.0*FPSQ)**2)#                                MI61 400
figmer: = FIGMRT/(1.0+SIGT2)#                                           MI61 401
IF(MCYC == incr:(maxcycs:))#           If refinement didn't             MI61 402
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 MI61 403
cosbst: = voidflg:#                    Converge, then the phase is      MI61 404
sinbst: = voidflg:#                    Probably meaningless.            MI61 405
cosmp:  = voidflg:#                                                     MI61 406
sinmp:  = voidflg:#                                                     MI61 407
figmer: = 0.#                                                           MI61 408
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 MI61 409
#                                                                       MI61 410
ELSE#                                                                   MI61 411
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 MI61 412
cosbst: = COSA#                                                         MI61 413
sinbst: = SINA#                                                         MI61 414
cosmp:  = COSA#                                                         MI61 415
sinmp:  = SINA#                                                         MI61 416
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 MI61 417
#                                                                       MI61 418
# PRINT OUT OF EVERY NTH REFLECTION ON LAST CYCLE AS REQUESTED          MI61 419
#                                                                       MI61 420
IF((ICYC == LSTCYC) & (ILIST > 0))#                                     MI61 421
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 MI61 422
IF(MOD(ICTREF,ILIST) == 0)#                                             MI61 423
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 MI61 424
IF(ICHECK == no:)#                     On first reflection force        MI61 425
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 MI61 426
IF(LINCT < 7)  LINCT = 0#              Heading.                         MI61 427
LENGTH = NMI611#                                                        MI61 428
IF(PPRIOR < 4)  LENGTH = LENGTH - 49#                                   MI61 429
writeline:(2,MI611,LENGTH,3,3)#                                         MI61 430
ICHECK = yes:#                                                          MI61 431
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 MI61 432
ncodefld:(QX(STARCR+1),1,CHROT,FMT611(1),3)# H,k,l                      MI61 433
ncodefld:(fph:(STARRO),1,CHROT,FMT611(4),1)# F parent                   MI61 434
#                                                                       MI61 435
ifvo:(cosbst:)#                        Void phase is special            MI61 436
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 MI61 437
movechar:(MI612,1,CHROT,32,4,0)#                                        MI61 438
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 MI61 439
ELSE#                                                                   MI61 440
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 MI61 441
# CALCULATE BEST ANGLE IN DEGREES                                       MI61 442
BUFOT(1) = DEGRAD*ATAN2(SINA,COSA)#                                     MI61 443
# MAKE POSITIVE                                                         MI61 444
IF(BUFOT(1) < -0.5)  BUFOT(1) = BUFOT(1) + 360.#                        MI61 445
ncodefld:(BUFOT,1,CHROT,FMT611(5),1)#  Angle                            MI61 446
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 MI61 447
ncodefld:(figmer:,1,CHROT,FMT611(6),1)# Figure of merit                 MI61 448
IF(PPRIOR > 3)#                                                         MI61 449
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 MI61 450
# HISTORY OF PHASE CHANGES                                              MI61 451
ncodefld:(PHZTBL,1,CHROT,FMT611(7),MIN0(MCYC,maxcycs:))#                MI61 452
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 MI61 453
#                                                                       MI61 454
writeline:(0,MI611,LENGTH,1,3)#                                         MI61 455
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 MI61 456
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 MI61 457
RETURN#                                                                 MI61 458
END#                                                                    MI61 459
systemheader:(MI63)#                                                    MI63   1
# ################################################################## #  MI63   2
#                                                                    #  MI63   3
#                               MI63                                 #  MI63   4
#                                                                    #  MI63   5
# ################################################################## #  MI63   6
SUBROUTINE MI63#                                                        MI63   7
#                                        Dec 1979  s. sheriff           MI63   8
#                                        Updated jan 1981  s. sheriff   MI63   9
#                                        Revised apr 1981  s. sheriff   MI63  10
include:(AACOMN)#                                                       MI63  11
include:(MICOMN)#                                                       MI63  12
include:(MIMAC5)#                                                       MI63  13
include:(MIMAC6)#                                                       MI63  14
include:(MIMAC8)#                                                       MI63  15
#                                                                       MI63  16
INTEGER I#                             Loop index                       MI63  17
INTEGER IPTR1#                         Ptr. into statistical block 1    MI63  18
INTEGER IPTR2#                         Ptr. into statistical block 2    MI63  19
INTEGER IPTR3#                         Ptr. into statistical block 3    MI63  20
INTEGER IPTR6#                         Ptr. into statistical block 6    MI63  21
INTEGER J#                             Pointer into reflection          MI63  22
#                                         Information region.           MI63  23
REAL ABSDIF#                           Absolute value of difference     MI63  24
#                                         Between obs. and calc. f.     MI63  25
REAL ALFDEL#                           Phase difference between         MI63  26
#                                         Parent and heavy atom model.  MI63  27
REAL ALPHA#                            Phase of parent                  MI63  28
REAL ALPHAB#                           Best phase of parent             MI63  29
REAL ALPHAM#                           Most probable phase of parent    MI63  30
REAL ANOCAL#                           Fc(+)**2-fc(-)**2                MI63  31
REAL ANODIF#                           Difference on f of calculated    MI63  32
#                                         And observed anomalous.       MI63  33
REAL ANOFOB#                           Observed anomalous difference    MI63  34
#                                         On f.                         MI63  35
REAL ANOMA#                            Calculated anomalous a part of   MI63  36
#                                         Heavy-atom structure factor.  MI63  37
REAL ANOMB#                            Calculated anomalous b part of   MI63  38
#                                         Heavy-atom structure factor.  MI63  39
REAL ANOOBS#                           Observed anomalous difference    MI63  40
#                                         Squared.                      MI63  41
REAL COSALF#                           Cosine of parent (either best    MI63  42
#                                         Or most probable, depending   MI63  43
#                                         On flag).                     MI63  44
REAL DELISO#                           Difference between parent and    MI63  45
#                                         Isomorph (centrics only).     MI63  46
REAL DIF#                              Phase difference between cycls   MI63  47
REAL FCMISQ#                           Calculated frel(-)**2            MI63  48
REAL FCPLSQ#                           Calculated frel(+)**2            MI63  49
REAL FH#                               Amplitude of heavy atom model    MI63  50
REAL FHA#                              A of heavy atom model            MI63  51
REAL FHB#                              B of heavy atom model            MI63  52
REAL FOM#                              Figure of merit                  MI63  53
REAL FP#                               Parent amplitude                 MI63  54
REAL FPA#                              A of parent                      MI63  55
REAL FPB#                              B of parent                      MI63  56
REAL FPHC#                             Calc. amplitude of isomorph      MI63  57
REAL FPHO#                             Observed, scaled amplitude of    MI63  58
#                                         Isomorph.                     MI63  59
REAL OLD#                              Best phase of parent, previous   MI63  60
#                                         Cycle.                        MI63  61
REAL OLDMP#                            Most probable phase of parent,   MI63  62
#                                         Previous cycle.               MI63  63
REAL PHI#                              Phase of heavy atom model        MI63  64
REAL RCULMI#                           Cullis numerator without         MI63  65
#                                         Crossover.                    MI63  66
REAL RCULN#                            R cullis numerator               MI63  67
REAL RCULPL#                           Cullis numerator with            MI63  68
#                                         Crossover.                    MI63  69
REAL SINALF#                           Sine of parent (either best or   MI63  70
#                                         Most probable depending on    MI63  71
#                                         Flag).                        MI63  72
REAL WEIGHT#                           1.0/(corrected variance)         MI63  73
REAL WTEANO#                           Weight*anomalous closure error   MI63  74
#                                         (on f).                       MI63  75
REAL WTEISO#                           Weight*isomorphous closure       MI63  76
#                                         Error (on f).                 MI63  77
#                                                                       MI63  78
ifvo:(cosbst:)#                        Phase was not calculated         MI63  79
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI63  80
CANTPH = CANTPH + 1#                   Count non-phaseable reflection   MI63  81
RETURN#                                And return.                      MI63  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI63  83
#                                                                       MI63  84
ALPHAB = ATAN2(sinbst:,cosbst:)#                                        MI63  85
COSALF = cosbst:#                                                       MI63  86
SINALF = sinbst:#                                                       MI63  87
ALPHA  = ALPHAB#                                                        MI63  88
IF(FAZTYP == fazprb:)#                 Fazprb phasing                   MI63  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI63  90
ALPHAM = ATAN2(sinmp:,cosmp:)#         Most probable phase of parent    MI63  91
IF(IFPROB == yes:)#                    Use most probable phase          MI63  92
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI63  93
COSALF = cosmp:#                       For statistics.                  MI63  94
SINALF = sinmp:#                                                        MI63  95
ALPHA = ALPHAM#                                                         MI63  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI63  97
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI63  98
#                                                                       MI63  99
FP = fph:(STARRO)*scale:(STARRO)#      Calculate a and b of parent      MI63 100
FPA = FP*COSALF#                                                        MI63 101
FPB = FP*SINALF#                                                        MI63 102
#                                                                       MI63 103
# CALCULATE PHASE DIFFERENCES BETWEEN AND WITHIN CYCLES                 MI63 104
#                                                                       MI63 105
ifnv:(QX(STARCR+13))#                  Is there a phase from            MI63 106
#                                         The previous cycle?           MI63 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI63 108
OLD = ATAN2(QX(STARCR+14),QX(STARCR+13))# Best phase                    MI63 109
DIF = ABS(ALPHAB-OLD)#                 Phase diff. between cycles       MI63 110
IF(DIF >= TWOPI) DIF = ABS(DIF-TWOPI)# Must be less than 2*pi           MI63 111
IF(DIF > PI)  DIF = TWOPI - DIF#       Cannot be greater than pi        MI63 112
IF(IPRC > 0)#                          Is reflection centric?           MI63 113
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI63 114
sumnumc: = sumnumc: + 1.0#             Total number of centric refls.   MI63 115
#                                                                       MI63 116
# IF PHASE IS DIFFERENT, THEN COUNT                                     MI63 117
IF(NINT(DIF) != 0)  sumfazdifc: = sumfazdifc: + 1.0#                    MI63 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI63 119
ELSE#                                  Reflection is acentric           MI63 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI63 121
sumnuma: = sumnuma: + 1.0#             Total number of acentric refls   MI63 122
sumfazdifa: = sumfazdifa: + DIF#                                        MI63 123
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI63 124
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI63 125
#                                                                       MI63 126
IF(FAZTYP == fazprb:)#                 Fazprb phasing                   MI63 127
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI63 128
DIF = ABS(ALPHAB-ALPHAM)#              (best-most probable) phase       MI63 129
#                                         Difference.                   MI63 130
IF(DIF >= TWOPI) DIF = ABS(DIF-TWOPI)# Must be less than 2*pi           MI63 131
IF(DIF > PI)  DIF = TWOPI - DIF#       Cannot be greater than pi        MI63 132
IF(IPRC > 0)#                          Within cycle, is refl. centric   MI63 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI63 134
sumnumbmc: = sumnumbmc: + 1.0#         Total no. of centric refls.      MI63 135
#                                                                       MI63 136
# IF MOST PROBABLE DIFFERENT FROM BEST, COUNT                           MI63 137
IF(NINT(DIF) != 0)  sumbmdifc: = sumbmdifc: + 1.0#                      MI63 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI63 139
ELSE#                                  Reflection is acentric           MI63 140
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI63 141
sumnumbma: = sumnumbma: + 1.0#         Total no. of acrntric refls.     MI63 142
sumbmdifa: = sumbmdifa: + DIF#                                          MI63 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI63 144
ifnv:(QX(STARCR+15))#                  Is there a most probable phase   MI63 145
#                                         From the previous cycle?      MI63 146
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI63 147
#                                                                       MI63 148
# MOST PROBABLE PHASE                                                   MI63 149
OLDMP = ATAN2(QX(STARCR+16),QX(STARCR+15))#                             MI63 150
DIF = ABS(ALPHAM-OLDMP)#               Most prob. phase difference      MI63 151
IF(DIF >= TWOPI)  DIF = ABS(DIF-TWOPI)# Must be less than 2*pi          MI63 152
IF(DIF > PI)  DIF = TWOPI - DIF#       Cannot be greater than pi        MI63 153
IF(IPRC > 0)#                          Is reflection centric?           MI63 154
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI63 155
sumnummpc: = sumnummpc: + 1.0#         Total no. centric refls.         MI63 156
#                                                                       MI63 157
# IF PHASE IS DIFFERENT, THEN COUNT                                     MI63 158
IF(NINT(DIF) != 0)  summpdifc: = summpdifc: + 1.0#                      MI63 159
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI63 160
ELSE#                                  Reflection is acentric           MI63 161
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI63 162
sumnummpa: = sumnummpa: + 1.0#         Total no. acen. refls.           MI63 163
summpdifa: = summpdifa: + DIF#                                          MI63 164
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI63 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI63 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI63 167
#                                                                       MI63 168
# COLLECT MEAN SQUARE ERROR IN ELECTRON DENSITY, FIGURE OF MERIT        MI63 169
#  HISTOGRAM AND AVERAGE VALUE OF PARENT F**2.                          MI63 170
#                                                                       MI63 171
FOM = figmer:#                                                          MI63 172
delrho: = delrho: + rmul:*(FP**2)*(1.0-FOM)**2# Electron density erro   MI63 173
IPTR1 = STARS1 + MIN0(9,NINT(FOM/0.1))*3# Decile of figure of merit     MI63 174
fomhist:(IPTR1) = fomhist:(IPTR1) + 1.0# Figure of merit histogram      MI63 175
IF(IPRC > 0)#                          Is reflection centric?           MI63 176
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI63 177
fomhistc:(IPTR1) = fomhistc:(IPTR1) + 1.0#                              MI63 178
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI63 179
ELSE#                                  Reflection is acentric           MI63 180
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI63 181
fomhista:(IPTR1) = fomhista:(IPTR1) + 1.0#                              MI63 182
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI63 183
#                                                                       MI63 184
# STATISTICAL BLOCK 2                                                   MI63 185
# COLLECT FIGURE OF MERIT AND TOTAL NUMBER OF REFLECTIONS AS A          MI63 186
#  FUNCTION OF SINE(THETA)/LAMBDA AND F**2.                             MI63 187
#                                                                       MI63 188
# CALCULATION OF OFFSET TO STOL-F**2 BIN                                MI63 189
#  SECOND TERM POINTS TO F**2 BIN                                       MI63 190
#  THIRD TERM POINTS TO STOL BIN                                        MI63 191
#                                                                       MI63 192
IPTR2 = STARS2 + IFBIN*STEPS2*(NBIN+1) + ISBIN*STEPS2#                  MI63 193
IF(IPRC > 0)#                          Is reflection centric?           MI63 194
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI63 195
sumfomc:(IPTR2) = sumfomc:(IPTR2) + FOM# Sum of figures of merit        MI63 196
sumrefc:(IPTR2) = sumrefc:(IPTR2) + 1.0# Number of reflections          MI63 197
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI63 198
ELSE#                                  Reflection is acentric           MI63 199
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MI63 200
sumfoma:(IPTR2) = sumfoma:(IPTR2) + FOM# Sum of figures of merit        MI63 201
sumrefa:(IPTR2) = sumrefa:(IPTR2) + 1.0# Number of reflections          MI63 202
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MI63 203
#                                                                       MI63 204
# STATISTICAL BLOCK 3                                                   MI63 205
# COLLECT ISOMORPH SPECIFIC STATISTICS (EXCEPT PARENT)                  MI63 206
#  R CULLIS, R KRAUT, (FPHOBS-FPHCALC)/FH, NUMBER OF REFLECTIONS        MI63 207
#  FOR ISOMORPH, DIFFERENCE BETWEEN PHASE OF HEAVY ATOM MODEL,          MI63 208
#  AND PHASE OF PARENT.                                                 MI63 209
#                                                                       MI63 210
J = STARRO#                            Access the reflection            MI63 211
#                                         Information region.           MI63 212
DO I=1,NDATIN#                         Loop over all data sets          MI63 213
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MI63 214
IF(I != 1)#                                                             MI63 215
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MI63 216
#                                                                       MI63 217
# CALCULATION OF OFFSET TO STOL-F**2 BIN                                MI63 218
#  SECOND TERM POINTS TO F**2 BIN                                       MI63 219
#  THIRD TERM POINTS TO STOL BIN                                        MI63 220
#  FOURTH TERM POINTS TO ISOMORPH BIN                                   MI63 221
#                                                                       MI63 222
IPTR3 = STARS3 + IFBIN*STEPS3*(NDATIN-1)*(NBIN+1) + $#                  MI63 223
ISBIN*STEPS3*(NDATIN-1) + (I-2)*STEPS3##                                MI63 224
#                                                                       MI63 225
ifnv:(fphsq:(J))#                      Is refl. present for isomorph?   MI63 226
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MI63 227
FHA = ahcalc:(J)#                      Create local variables for       MI63 228
FHB = bhcalc:(J)#                      Frequently used quantities.      MI63 229
FH = SQRT(FHA**2 + FHB**2)#                                             MI63 230
FPHO = fph:(J)*scale:(J)#              Scale derivative to parent !!    MI63 231
IF(varfsq:(J) > 0.01)  WEIGHT = 1.0/varfsq:(J)#                         MI63 232
ELSE  WEIGHT = 1.0#                                                     MI63 233
FPHC = SQRT((FPA+FHA)**2 + (FPB+FHB)**2)#                               MI63 234
IF(FH < small:) PHI = small:#          Put in false angle, but don t    MI63 235
ELSE PHI = ATAN2(FHB,FHA)#             Tell.                            MI63 236
ABSDIF = ABS(FPHO-FPHC)#                                                MI63 237
ALFDEL = ABS(ALPHA-PHI)#               Difference between protein       MI63 238
#                                         And heavy-atom phase.         MI63 239
IF(ALFDEL >= TWOPI)  ALFDEL = ABS(ALFDEL-TWOPI)#                        MI63 240
IF(ALFDEL > PI)  ALFDEL = TWOPI - ALFDEL#                               MI63 241
WTEISO = (WEIGHT*ABSDIF)**2#           Weighted isomorphous closure     MI63 242
#                                         Error on f.                   MI63 243
#                                                                       MI63 244
IF(IPRC > 0)#                          Is reflection centric?           MI63 245
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MI63 246
DELISO = ABS(FPHO-FP)#                 R cullis denominator             MI63 247
# CALCULATE NUMERATOR FOR CULLIS R FACTOR TAKING                        MI63 248
#  CROSSOVERS INTO ACCOUNT.                                             MI63 249
RCULMI = ABS(ABS(FPHO-FP)-FH)#         No crossover                     MI63 250
RCULPL = ABS(ABS(FPHO+FP)-FH)#         Crossover                        MI63 251
IF(RCULMI <= RCULPL)  RCULN = RCULMI#                                   MI63 252
ELSE  RCULN = RCULPL#                  Choose whichever is smaller      MI63 253
#                                                                       MI63 254
rcul:(IPTR3) = rcul:(IPTR3) + RCULN#   Cullis numerator                 MI63 255
delisoc:(IPTR3) = delisoc:(IPTR3) + DELISO# Cullis denominator          MI63 256
sumdfc:(IPTR3) = sumdfc:(IPTR3) + ABSDIF# Rkraut numerator              MI63 257
sumfphc:(IPTR3) = sumfphc:(IPTR3) + FPHO# Rkraut denominator            MI63 258
sumallc:(IPTR3) = sumallc:(IPTR3) + 1.0# Number of reflections          MI63 259
#                                                                       MI63 260
# PROTEIN - HEAVY ATOM PHASE DIFFERENCE                                 MI63 261
sumalfdelc:(IPTR3) = sumalfdelc:(IPTR3) + ALFDEL#                       MI63 262
sumfazpwrc:(IPTR3) = sumfazpwrc:(IPTR3) + ABSDIF# Closure error         MI63 263
sumfhc:(IPTR3) = sumfhc:(IPTR3) + FH#  Weighted heavy-atom amplitude    MI63 264
#                                                                       MI63 265
# WEIGHTED ISOMORPHOUS CLOSURE ERROR                                    MI63 266
sumwteisoc:(IPTR3) = sumwteisoc:(IPTR3) + WTEISO#                       MI63 267
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MI63 268
#                                                                       MI63 269
ELSE#                                  Reflection is acentric           MI63 270
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MI63 271
sumdfa:(IPTR3) = sumdfa:(IPTR3) + ABSDIF# Rkraut numerator              MI63 272
sumfpha:(IPTR3) = sumfpha:(IPTR3) + FPHO# Rkraut denominator            MI63 273
sumalla:(IPTR3) = sumalla:(IPTR3) + 1.0# Number of reflections          MI63 274
#                                                                       MI63 275
# PROTEIN - HEAVY ATOM PHASE DIFFERENCE                                 MI63 276
sumalfdela:(IPTR3) = sumalfdela:(IPTR3) + ALFDEL#                       MI63 277
sumfazpwra:(IPTR3) = sumfazpwra:(IPTR3) + ABSDIF# Closure error         MI63 278
sumfha:(IPTR3) = sumfha:(IPTR3) + FH#  Weighted heavy-atom amplitude    MI63 279
#                                                                       MI63 280
# WEIGHTED ISOMORPHOUS CLOSURE ERROR                                    MI63 281
sumwteisoa:(IPTR3) = sumwteisoa:(IPTR3) + WTEISO#                       MI63 282
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MI63 283
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MI63 284
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MI63 285
#                                                                       MI63 286
# STATISTICAL BLOCK 6                                                   MI63 287
# COLLECT WHETHER ANOMALOUS DIFFERENCE CALCULATES WITH SAME SIGN        MI63 288
#  AS OBSERVED.                                                         MI63 289
#                                                                       MI63 290
IPTR6 = STARS6 + (I-1)*STEPS6#                                          MI63 291
FCPLSQ = voidflg:#                                                      MI63 292
IF(I == 1)#                            Parent treated slightly          MI63 293
#                                         Different.                    MI63 294
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MI63 295
# CALCULATE PLUS AND MINUS FC**2 FOR PARENT                             MI63 296
IF((ABS(anflg:(STARRO) - 2.0) < small:) $#                              MI63 297
& (delfsq:(STARRO) > voidflg:))#                                        MI63 298
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MI63 299
ANOMA = aanomc:(STARRO)#                                                MI63 300
ANOMB = banomc:(STARRO)#                                                MI63 301
FCPLSQ = (FPA+ANOMA)**2 + (FPB+ANOMB)**2#                               MI63 302
FCMISQ = (FPA-ANOMA)**2 + (FPB-ANOMB)**2#                               MI63 303
IF(varfsq:(STARRO) > 0.01)  WEIGHT = 1.0/varfsq:(STARRO)#               MI63 304
ELSE  WEIGHT = 1.0#                                                     MI63 305
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MI63 306
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MI63 307
#                                                                       MI63 308
ELSE#                                  All other data sets              MI63 309
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MI63 310
IF(((ABS(anflg:(J) - 2.0) < small:) \ $#                                MI63 311
ABS(anflg:(J) - 3.0) < small:) & $#                                     MI63 312
(delfsq:(J) > voidflg:))#                                               MI63 313
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MI63 314
ANOMA = aanomc:(J)#                                                     MI63 315
ANOMB = banomc:(J)#                                                     MI63 316
FCPLSQ = (FPA+FHA+ANOMA)**2 + (FPB+FHB+ANOMB)**2#                       MI63 317
FCMISQ = (FPA+FHA-ANOMA)**2 + (FPB+FHB-ANOMB)**2#                       MI63 318
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MI63 319
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MI63 320
#                                                                       MI63 321
ifnv:(FCPLSQ)#                                                          MI63 322
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MI63 323
ANOCAL = FCPLSQ - FCMISQ#                                               MI63 324
ifnv:(delfsq:(J))  ANOOBS = delfsq:(J)#                                 MI63 325
ELSE  ANOOBS = 0.0#                                                     MI63 326
IF(((ANOCAL > 0.0) & (ANOOBS > 0.0)) \ $#                               MI63 327
((ANOCAL < 0.0) & (ANOOBS < 0.0)))  $#                                  MI63 328
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MI63 329
signsame:(IPTR6) = signsame:(IPTR6) + 1.0#                              MI63 330
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MI63 331
ELSE  IF((ABS(ANOCAL) <= small:) \ (ABS(ANOOBS) <= small:))$#           MI63 332
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MI63 333
signzero:(IPTR6) = signzero:(IPTR6) + 1.0#                              MI63 334
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MI63 335
ELSE  signopp:(IPTR6) = signopp:(IPTR6) + 1.0#                          MI63 336
ANOFOB = frelp:(J)*scale:(J) - frelm:(J)*scale:(J)#                     MI63 337
ANODIF = ABS(SQRT(FCPLSQ) - SQRT(FCMISQ) - ANOFOB)#                     MI63 338
WTEANO = (WEIGHT*ANODIF)**2#                                            MI63 339
IF(I != 1)  sumwteano:(IPTR3) = sumwteano:(IPTR3) + WTEANO#             MI63 340
ELSE  sumnatwteano:(IPTR2) = sumnatwteano:(IPTR2) + WTEANO#             MI63 341
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MI63 342
J = J + STEPRO#                        Move to next isomorph area       MI63 343
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MI63 344
RETURN#                                                                 MI63 345
END#                                                                    MI63 346
systemheader:(MI64)#                                                    MI64   1
# ################################################################## #  MI64   2
#                                                                    #  MI64   3
#                               MI64                                 #  MI64   4
#                                                                    #  MI64   5
# ################################################################## #  MI64   6
SUBROUTINE MI64#                                                        MI64   7
#                                        Dec 1979  s. sheriff           MI64   8
#                                        Re-named apr 1981  s. sheriff  MI64   9
include:(MIMAC3)#                                                       MI64  10
include:(MIMAC7)#                                                       MI64  11
include:(AACOMN)#                                                       MI64  12
include:(MICOMN)#                                                       MI64  13
#                                                                       MI64  14
INTEGER I#                             Loop index                       MI64  15
INTEGER IPTR4#                         Ptr. into statistical region 4   MI64  16
INTEGER IPTR5#                         Ptr. into statistical region 5   MI64  17
INTEGER J#                             Index to reflection              MI64  18
#                                         Information region.           MI64  19
REAL ADJCLO#                           Isomorphous closure error        MI64  20
#                                         Adjusted for observational    MI64  21
#                                         Errors.                       MI64  22
REAL ANOADJ#                           Anomalous closure error          MI64  23
#                                         Adjusted for observational    MI64  24
#                                         Errors.                       MI64  25
REAL ANOCAL#                           Calculated anomalous diff.       MI64  26
#                                         (fcplsq-fcmisq).              MI64  27
REAL ANOCLO#                           Closure error for anom. signal   MI64  28
REAL ANOMA#                            Anom. a of heavy-atom model      MI64  29
REAL ANOMB#                            Anom. b of heavy-atom model      MI64  30
REAL ANOMSQ#                           Calculated anomalous signal      MI64  31
#                                         Squared.                      MI64  32
REAL ANOOBS#                           Observed anomalous difference    MI64  33
#                                         (fphplsq-fphmisq).            MI64  34
REAL CLOSUR#                           Closure error for isomorphous    MI64  35
#                                         Signal.                       MI64  36
REAL COSALF#                           Cosine of parent (either best    MI64  37
#                                         Or most probable depending on MI64  38
#                                         Flag).                        MI64  39
REAL DIFISO#                           Isomorphous difference between   MI64  40
#                                         Parent and isomorph).         MI64  41
REAL FCMISQ#                           Calculated amplitude squared     MI64  42
#                                         Minus anomalous of isomorph.  MI64  43
REAL FCPLSQ#                           Calculated amplitude squared     MI64  44
#                                         Plus anomalous of isomorph.   MI64  45
REAL FHA#                              A of heavy atom model            MI64  46
REAL FHB#                              B of heavy atom model            MI64  47
REAL FHSQ#                             Amplitude of heavy atom model,   MI64  48
#                                         Squared.                      MI64  49
REAL FP#                               Parent amplitude                 MI64  50
REAL FPA#                              A of parent                      MI64  51
REAL FPB#                              B of parent                      MI64  52
REAL FPHCSQ#                           Calculated amplitude squared     MI64  53
#                                         Of isomorph.                  MI64  54
REAL FPHOSQ#                           Observed, scaled amplitude       MI64  55
#                                         Squared, of isomorph.         MI64  56
REAL FPSQ#                             Parent amplitude, squared        MI64  57
REAL SINALF#                           Sine of parent (either best or   MI64  58
#                                         Most probable depending on    MI64  59
#                                         Flag).                        MI64  60
REAL VARFP#                            Parent variance on fpsq          MI64  61
REAL VARFPH#                           Variance on fphosq, scaled       MI64  62
REAL VARFP2#                           Parent variance on fpsq,         MI64  63
#                                         Squared.                      MI64  64
REAL VARJNT#                           Joint variance of fpsq and       MI64  65
#                                         Fphosq.                       MI64  66
#                                                                       MI64  67
ifvo:(cosbst:)  RETURN#                Phase was not calculated         MI64  68
COSALF = cosbst:#                                                       MI64  69
SINALF = sinbst:#                                                       MI64  70
IF((FAZTYP == fazprb:) & (IFPROB == yes:))#                             MI64  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI64  72
COSALF = cosmp:#                                                        MI64  73
SINALF = sinmp:#                                                        MI64  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI64  75
FP = fphn:(STARRO)#                    Scaled parent f                  MI64  76
FPSQ = fphsqn:(STARRO)#                Scaled parent f**2               MI64  77
FPA = FP*COSALF#                                                        MI64  78
FPB = FP*SINALF#                                                        MI64  79
IF(varfsq:(STARRO) > small:)  VARFP = varfsqn:(STARRO)#                 MI64  80
ELSE  VARFP = 0.0#                                                      MI64  81
VARFP2 = VARFP**2#                                                      MI64  82
#                                                                       MI64  83
# STATISTICAL BLOCK 4                                                   MI64  84
# COLLECT STATISTICS RELEVANT TO PARENT, E.G., VARIANCE AND PARENT      MI64  85
#  ANOMALOUS CLOSURE ERROR.                                             MI64  86
#                                                                       MI64  87
# CALCULATION OF OFFSET TO STOL-F**2 BIN                                MI64  88
#  SECOND TERM POINTS TO F**2 BIN                                       MI64  89
#  THIRD TERM POINTS TO STOL BIN                                        MI64  90
#                                                                       MI64  91
IPTR4 = STARS4 + IFBIN*STEPS4*(NBIN+1) + ISBIN*STEPS4#                  MI64  92
IF(IPRC > 0)#                          Is reflection centric?           MI64  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI64  94
sumvarc:(IPTR4) = sumvarc:(IPTR4) + VARFP2#                             MI64  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI64  96
ELSE#                                  Reflection is acentric           MI64  97
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI64  98
sumvara:(IPTR4) = sumvara:(IPTR4) + VARFP2#                             MI64  99
#                                                                       MI64 100
# IF WE ARE USING PARENT ANOMALOUS SIGNAL, CALC. CLOSURE ERRORS, ETC.   MI64 101
#                                                                       MI64 102
IF(ABS(anflg:(STARRO)-2.0) < small: & delfsq:(STARRO) > voidflg:)#      MI64 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI64 104
ANOMA = aanomc:(STARRO)#                                                MI64 105
ANOMB = banomc:(STARRO)#                                                MI64 106
ANOMSQ = ANOMA**2 + ANOMB**2#                                           MI64 107
FCPLSQ = (FPA+ANOMA)**2 + (FPB+ANOMB)**2#                               MI64 108
FCMISQ = (FPA-ANOMA)**2 + (FPB-ANOMB)**2#                               MI64 109
ANOCAL = FCPLSQ - FCMISQ#                                               MI64 110
ANOOBS = 2.0*delfsqn:(STARRO)#                                          MI64 111
ANOCLO = (ANOCAL-ANOOBS)**2#                                            MI64 112
ANOADJ = ANOCLO - varano:(STARRO)#                                      MI64 113
IF(ANOADJ < 0.0)  ANOADJ = 0.0#                                         MI64 114
sumnatanoclo:(IPTR4) = sumnatanoclo:(IPTR4) + ANOCLO#                   MI64 115
sumnatanoadj:(IPTR4) = sumnatanoadj:(IPTR4) + ANOADJ#                   MI64 116
sumnatanodif:(IPTR4) = sumnatanodif:(IPTR4) + ANOOBS**2#                MI64 117
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI64 118
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI64 119
#                                                                       MI64 120
# STATISTICAL BLOCK 5                                                   MI64 121
# COLLECT ISOMORPH SPECIFIC STATISTICS (EXCEPT PARENT)                  MI64 122
#  CLOSURE, ISOMORPHOUS DIFFERENCES, CLOSURE ADJUSTED FOR VARIANCE,     MI64 123
#  HEAVY ATOM MODEL CONTRIBUTION, JOINT VARIANCE OF PARENT, AND         MI64 124
#  ISOMORPH, ANOMALOUS CLOSURE ERROR.                                   MI64 125
#                                                                       MI64 126
J = STARRO + STEPRO#                   Access the reflection            MI64 127
#                                         Information region, starting  MI64 128
#                                         With the first isomorph.      MI64 129
#                                                                       MI64 130
DO I=2,NDATIN#                         Loop over isomorphs              MI64 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI64 132
#                                                                       MI64 133
# CALCULATION OF OFFSET TO STOL-F**2 BIN                                MI64 134
#  SECOND TERM POINTS TO F**2 BIN                                       MI64 135
#  THIRD TERM POINTS TO STOL BIN                                        MI64 136
#  FOURTH TERM POINTS TO ISOMORPH BIN                                   MI64 137
#                                                                       MI64 138
IPTR5 = STARS5 + IFBIN*STEPS5*(NDATIN-1)*(NBIN+1) + $#                  MI64 139
ISBIN*STEPS5*(NDATIN-1) + (I-2)*STEPS5##                                MI64 140
ifnv:(fphsq:(J))#                      Is refl. present for isomorph?   MI64 141
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI64 142
FHA = ahcalc:(J)#                      Create local variables for       MI64 143
FHB = bhcalc:(J)#                      Frequently used quantities.      MI64 144
FPHOSQ = fphsqn:(J)#                   Scale derivative to parent!!     MI64 145
IF(varfsq:(J) > small:)  VARFPH = varfsqn:(J)#                          MI64 146
ELSE  VARFPH = 0.0#                                                     MI64 147
VARJNT = (VARFP+VARFPH)**2#            Joint variance of fpsq           MI64 148
#                                         And fphosq.                   MI64 149
FPHCSQ = (FPA+FHA)**2 + (FPB+FHB)**2#  Calculated fphsq                 MI64 150
CLOSUR = (FPHOSQ-FPHCSQ)**2#           Closure error on fsq             MI64 151
DIFISO = (FPHOSQ-FPSQ)**2#             Isomorphous differences on fsq   MI64 152
FHSQ = FHA**2 + FHB**2#                Heavy-atom model contribution    MI64 153
ADJCLO = CLOSUR - variso:(J)#          Closure error adjusted for       MI64 154
IF(ADJCLO < 0.0)  ADJCLO = 0.0#        Observational errors.            MI64 155
FHSQ = FHSQ**2#                        Heavy-atom model contribution    MI64 156
#                                         Squared.                      MI64 157
#                                                                       MI64 158
IF(IPRC > 0)#                          Is reflection centric?           MI64 159
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI64 160
sumclosurec:(IPTR5) = sumclosurec:(IPTR5) + CLOSUR#                     MI64 161
sumdifisoc:(IPTR5) = sumdifisoc:(IPTR5) + DIFISO#                       MI64 162
sumadjcloc:(IPTR5) = sumadjcloc:(IPTR5) + ADJCLO#                       MI64 163
sumfhsqc:(IPTR5) = sumfhsqc:(IPTR5) + FHSQ#                             MI64 164
sumjntvarc:(IPTR5) = sumjntvarc:(IPTR5) + VARJNT#                       MI64 165
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI64 166
#                                                                       MI64 167
ELSE#                                  Reflection is acentric           MI64 168
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI64 169
sumclosurea:(IPTR5) = sumclosurea:(IPTR5) + CLOSUR#                     MI64 170
sumdifisoa:(IPTR5) = sumdifisoa:(IPTR5) + DIFISO#                       MI64 171
sumadjcloa:(IPTR5) = sumadjcloa:(IPTR5) + ADJCLO#                       MI64 172
sumfhsqa:(IPTR5) = sumfhsqa:(IPTR5) + FHSQ#                             MI64 173
sumjntvara:(IPTR5) = sumjntvara:(IPTR5) + VARJNT#                       MI64 174
IF(((ABS(anflg:(J)-2.0) < small:)  \ $##                                MI64 175
(ABS(anflg:(J)-3.0) < small:)) & $#                                     MI64 176
(delfsq:(J) > voidflg:))#                                               MI64 177
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI64 178
ANOMA = aanomc:(J)#                                                     MI64 179
ANOMB = banomc:(J)#                                                     MI64 180
ANOMSQ = ANOMA**2 + ANOMB**2#                                           MI64 181
FCPLSQ = (FPA+FHA+ANOMA)**2 + (FPB+FHB+ANOMB)**2#                       MI64 182
FCMISQ = (FPA+FHA-ANOMA)**2 + (FPB+FHB-ANOMB)**2#                       MI64 183
ANOCAL = FCPLSQ - FCMISQ#                                               MI64 184
ANOOBS = 2.0*delfsqn:(J)#                                               MI64 185
ANOCLO = (ANOCAL-ANOOBS)**2#                                            MI64 186
ANOADJ = ANOCLO - varano:(J)#                                           MI64 187
IF(ANOADJ < 0.0)  ANOADJ = 0.0#                                         MI64 188
sumanoclo:(IPTR5) = sumanoclo:(IPTR5) + ANOCLO#                         MI64 189
sumanoadj:(IPTR5) = sumanoadj:(IPTR5) + ANOADJ#                         MI64 190
sumanodif:(IPTR5) = sumanodif:(IPTR5) + ANOOBS**2#                      MI64 191
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI64 192
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI64 193
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI64 194
J = J + STEPRO#                        Move to next isomorph            MI64 195
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI64 196
RETURN#                                                                 MI64 197
END#                                                                    MI64 198
pmacro:([z:])#                                                          MI64 199
systemheader:(MI65)#                                                    MI65   1
# ################################################################## #  MI65   2
#                                                                    #  MI65   3
#                               MI65                                 #  MI65   4
#                                                                    #  MI65   5
# ################################################################## #  MI65   6
SUBROUTINE MI65#                       Matrix building                  MI65   7
#                                        Nov 1979  s.t. freer and       MI65   8
#                                             K.d. watenpaugh           MI65   9
#                                        Re-written may 1980            MI65  10
#                                        Modified jun 1980              MI65  11
#                                             K.d. watenpaugh           MI65  12
include:(AACOMN)#                                                       MI65  13
include:(MICOMN)#                                                       MI65  14
include:(MIMAC1)#                                                       MI65  15
include:(MIMAC9)#                                                       MI65  16
#                                                                       MI65  17
INTEGER DRVAP#                                                          MI65  18
INTEGER DRVBP#                                                          MI65  19
INTEGER K#                                                              MI65  20
INTEGER KBPTR#                                                          MI65  21
INTEGER M#                                                              MI65  22
INTEGER M1#                                                             MI65  23
INTEGER M2#                                                             MI65  24
INTEGER MAXFH#                                                          MI65  25
INTEGER MAXFP#                                                          MI65  26
INTEGER MINFH#                                                          MI65  27
INTEGER MINFP#                                                          MI65  28
INTEGER MM#                                                             MI65  29
INTEGER N#                                                              MI65  30
INTEGER NPARAM#                                                         MI65  31
INTEGER NSET#                                                           MI65  32
INTEGER ROPTR#                                                          MI65  33
INTEGER START#                                                          MI65  34
INTEGER STOP#                                                           MI65  35
INTEGER V#                                                              MI65  36
REAL APH(2)#                                                            MI65  37
REAL BPH(2)#                                                            MI65  38
REAL COSALF#                                                            MI65  39
REAL DELFSQ#                                                            MI65  40
REAL DELTA(2)#                                                          MI65  41
REAL DRVFHP#                                                            MI65  42
REAL FCPH(2)#                                                           MI65  43
REAL FCSQ(2)#                                                           MI65  44
REAL FPCOS(2)#                                                          MI65  45
REAL FPH(2)#                                                            MI65  46
REAL FPHSQ(2)#                                                          MI65  47
REAL FPSIN(2)#                                                          MI65  48
REAL FPSQ(2)#                                                           MI65  49
REAL SIGSCL(2)#                                                         MI65  50
REAL SINALF#                                                            MI65  51
REAL STOLSQ#                                                            MI65  52
#                                                                       MI65  53
# CHECK TO SEE IF NATIVE STRUCTURE FACTOR IS PRESENT AND QUIT           MI65  54
#  IF IT IS NOT.                                                        MI65  55
#                                                                       MI65  56
IF(anflg:(STARRO) < small:)  RETURN#                                    MI65  57
IF((frelp:(STARRO) < small:) & (frelm:(STARRO) < small:))  RETURN#      MI65  58
#                                                                       MI65  59
ROPTR = STARRO#                        Set pointer for native data      MI65  60
MINFP = 0#                             Clear the working variables      MI65  61
MAXFP = 0#                                                              MI65  62
DELFSQ = delfsqn:(ROPTR)#                                               MI65  63
ifvo:(DELFSQ)  DELFSQ = 0.0#                                            MI65  64
FPSQ(1)  = 0.0#                                                         MI65  65
FPSQ(2)  = 0.0#                                                         MI65  66
FPCOS(1) = 0.0#                                                         MI65  67
FPCOS(2) = 0.0#                                                         MI65  68
FPSIN(1) = 0.0#                                                         MI65  69
FPSIN(2) = 0.0#                                                         MI65  70
COSALF = cosbst:#                      Set phase for refinement         MI65  71
SINALF = sinbst:#                                                       MI65  72
IF((FAZTYP == fazprb:) & (IFPROB == yes:))# Default is ifprob = yes:    MI65  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI65  74
COSALF = cosmp:#                                                        MI65  75
SINALF = sinmp:#                                                        MI65  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI65  77
#                                                                       MI65  78
# IF THERE WERE NO USABLE DATA (I.E., COSALF IS VOID), THEN             MI65  79
#  SKIP THE REMAINDER OF THIS ROUTINE.                                  MI65  80
#                                                                       MI65  81
ifvo:(COSALF)  RETURN#                                                  MI65  82
#                                                                       MI65  83
STOLSQ = stol:**2#                                                      MI65  84
IF(frelp:(ROPTR) > small:)#            Check for positive native f's    MI65  85
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI65  86
MINFP = 1#                             Positive struct. fact. present   MI65  87
MAXFP = 1#                                                              MI65  88
FPSQ(1) = fphsqn:(ROPTR) + DELFSQ#     Add observed anomalous           MI65  89
#                                                                       MI65  90
# GET A AND B TERMS USING EITHER 'BEST' OR 'MOST PROBABLE' PHASES       MI65  91
FPCOS(1) = scale:(ROPTR)*frelp:(ROPTR)*COSALF#                          MI65  92
FPSIN(1) = scale:(ROPTR)*frelp:(ROPTR)*SINALF#                          MI65  93
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI65  94
IF(frelm:(ROPTR) > small:)#            Check for negative native f's    MI65  95
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI65  96
IF(MINFP == 0)  MINFP = 2#                                              MI65  97
MAXFP = 2#                             Negative f present               MI65  98
FPSQ(2) = fphsqn:(ROPTR) - DELFSQ#     Subtract observed anomalous      MI65  99
FPCOS(2) = scale:(ROPTR)*frelm:(ROPTR)*COSALF#                          MI65 100
FPSIN(2) = scale:(ROPTR)*frelm:(ROPTR)*SINALF#                          MI65 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI65 102
#                                                                       MI65 103
# CHECK TO SEE IF NO ANOMALOUS SIGNAL OF NATIVE IS TO BE USED           MI65 104
#                                                                       MI65 105
IF((anflg:(ROPTR)-1.0) < half:)#       Use real scattering (no anom)    MI65 106
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI65 107
FPCOS(1) = 0.5*(FPCOS(MINFP)+FPCOS(MAXFP))# Get rid of any anomalous    MI65 108
FPCOS(2) = FPCOS(1)#                                                    MI65 109
FPSIN(1) = 0.5*(FPSIN(MINFP)+FPSIN(MAXFP))#                             MI65 110
FPSIN(2) = FPSIN(1)#                                                    MI65 111
FPSQ(1) = 0.5*(FPSQ(MINFP)+FPSQ(MAXFP))#                                MI65 112
FPSQ(2) = FPSQ(1)#                                                      MI65 113
MINFP = 1#                                                              MI65 114
MAXFP = 2#                                                              MI65 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI65 116
#                                                                       MI65 117
DO NSET=2,NDATIN#                      Start processing the isomorphs   MI65 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI65 119
N = REFPTR(NSET+1) - REFPTR(NSET)#     'n' temporarily equals the       MI65 120
#                                         Number of atomic parameters.  MI65 121
ROPTR = STARRO + (NSET-1)*STEPRO#      Set pointer to start             MI65 122
DELTA(1) = 0.#                         Init. delta-f for rej. test      MI65 123
DELTA(2) = 0.#                                                          MI65 124
IF(anflg:(ROPTR) < half:)  NEXT#       Check if this reflection of      MI65 125
#                                         This isomorph is to be used.  MI65 126
MINFH = 0#                                                              MI65 127
MAXFH = 0#                                                              MI65 128
DELFSQ = delfsqn:(ROPTR)#                                               MI65 129
ifvo:(DELFSQ)  DELFSQ = 0.0#                                            MI65 130
#                                                                       MI65 131
IF(frelp:(ROPTR) > small:)#            Is the pos. f present?           MI65 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI65 133
MINFH = 1#                                                              MI65 134
MAXFH = 1#                                                              MI65 135
FPH(1) = scale:(ROPTR)*frelp:(ROPTR)#                                   MI65 136
# PROTECT MYSELF                                                        MI65 137
IF(fphsqn:(ROPTR) < little:)  fphsqn:(ROPTR) = little:#                 MI65 138
# MAKE SURE THIS IS TOTALLY RIGHT                                       MI65 139
SIGSCL(1)=1.0/SQRT(variso:(ROPTR))#    Weight for delta                 MI65 140
FPHSQ(1) = fphsqn:(ROPTR) + DELFSQ#    Add the observed anomalous       MI65 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI65 142
IF(frelm:(ROPTR) > small:)#            Is the friedel f present?        MI65 143
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI65 144
IF(MINFH == 0)  MINFH = 2#                                              MI65 145
MAXFH = 2#                                                              MI65 146
FPH(2) = scale:(ROPTR)*frelm:(ROPTR)#                                   MI65 147
# PROTECT MYSELF                                                        MI65 148
IF(fphsqn:(ROPTR) < little:)  fphsqn:(ROPTR) = little:#                 MI65 149
# MAKE SURE THIS IS TOTALLY RIGHT                                       MI65 150
SIGSCL(2)=1.0/SQRT(variso:(ROPTR))#    Weight for delta                 MI65 151
FPHSQ(2) = fphsqn:(ROPTR) - DELFSQ#    Subtract the observed anom.      MI65 152
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI65 153
IF(MINFH == 0)  NEXT#                  Do only if f(isomorph)           MI65 154
#                                         Present.  if not, look at     MI65 155
#                                         The next isomorph.            MI65 156
#                                                                       MI65 157
# CHECK ON NOT USING ANOMALOUS                                          MI65 158
#                                                                       MI65 159
IF((anflg:(ROPTR)-1.0) < half:)#                                        MI65 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI65 161
FPH(1) = 0.5*(FPH(MINFH)+FPH(MAXFH))#                                   MI65 162
SIGSCL(1) = SIGSCL(MINFH)#                                              MI65 163
FPHSQ(1) = 0.5*(FPHSQ(MINFH)+FPHSQ(MAXFH))#                             MI65 164
APH(1) = FPCOS(1) + ahcalc:(ROPTR)#                                     MI65 165
BPH(1) = FPSIN(1) + bhcalc:(ROPTR)#                                     MI65 166
FCSQ(1) = APH(1)**2 + BPH(1)**2#       Calc. f**2 for isomorph          MI65 167
FCPH(1) =  SQRT(FCSQ(1))#              Calc. f(ph)                      MI65 168
DELTA(1) = SIGSCL(1)*(FPHSQ(1)-FCSQ(1))# Calc. weighted delta-f**2      MI65 169
WTDFSQ(NSET) = WTDFSQ(NSET) + DELTA(1)**2#                              MI65 170
NREF(NSET) = NREF(NSET) + 1#                                            MI65 171
MINFH = 1#                                                              MI65 172
MAXFH = 1#                                                              MI65 173
#                                                                       MI65 174
# NOW CALCULATE DERIVATIVE OF FC                                        MI65 175
#                                                                       MI65 176
DRVAP = DRVPTA(NSET)#                  Set the pointers                 MI65 177
DRVBP = DRVPTB(NSET)#                                                   MI65 178
NPARAM = NPAREF(NSET)#                                                  MI65 179
IF(NPARAM > 0)#                                                         MI65 180
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI65 181
DO M=1,NPARAM#                         Calc. derivs. of f's             MI65 182
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI65 183
DRVAP = DRVAP + 1#                                                      MI65 184
DRVBP = DRVBP + 1#                                                      MI65 185
QX(DRVAP) = 2.0*SIGSCL(1)*(APH(1)*QX(DRVAP) + BPH(1)*QX(DRVBP))#        MI65 186
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI65 187
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI65 188
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI65 189
#                                                                       MI65 190
# DO THE SEPARATE FRIEDEL RELATED ONES, IF PRESENT                      MI65 191
#                                                                       MI65 192
IF(anflg:(ROPTR) >= 2.0)#              Check on using anomalous         MI65 193
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI65 194
DRVAP = DRVPTA(NSET)#                  Set pointer for derivs.          MI65 195
DRVBP = DRVPTB(NSET)#                                                   MI65 196
NPARAM = NPAREF(NSET)#                                                  MI65 197
APH(1) = 0.0#                                                           MI65 198
APH(2) = 0.0#                                                           MI65 199
BPH(1) = 0.0#                                                           MI65 200
BPH(2) = 0.0#                                                           MI65 201
IF(MINFH == 1)#                        Positive isomorph present        MI65 202
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI65 203
APH(1) = FPCOS(MINFP) + ahcalc:(ROPTR) + aanomc:(ROPTR)#                MI65 204
BPH(1) = FPSIN(MINFP) + bhcalc:(ROPTR) + banomc:(ROPTR)#                MI65 205
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI65 206
IF(MAXFH == 2)#                        Negative isomorph present        MI65 207
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI65 208
APH(2) = FPCOS(MAXFP) + ahcalc:(ROPTR) - aanomc:(ROPTR)#                MI65 209
BPH(2) = FPSIN(MAXFP) + bhcalc:(ROPTR) - banomc:(ROPTR)#                MI65 210
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI65 211
#                                                                       MI65 212
# CALC. DERIVATIVES OF F**2 FOR BOTH POS. AND NEG. REFLECTIONS          MI65 213
#                                                                       MI65 214
DO K=MINFH,MAXFH#                                                       MI65 215
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI65 216
FCSQ(K) = APH(K)**2 + BPH(K)**2#                                        MI65 217
FCPH(K) = SQRT(FCSQ(K))#                                                MI65 218
DELTA(K) = SIGSCL(K)*(FPHSQ(K)-FCSQ(K))# Calc. weighted delta-f**2      MI65 219
WTDFSQ(NSET) = WTDFSQ(NSET) + DELTA(K)**2#                              MI65 220
NREF(NSET) = NREF(NSET) + 1#                                            MI65 221
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI65 222
#                                                                       MI65 223
# NOW BUILD DERIV. OF F**2 WITH RESPECT TO ATOMIC PARAMETERS            MI65 224
#  FOR BOTH THE POS. AND NEG. REFLECTIONS, IF PRESENT.                  MI65 225
#                                                                       MI65 226
IF(NPARAM > 0)#                                                         MI65 227
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI65 228
DO M=1,NPARAM#                                                          MI65 229
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MI65 230
DRVAP = DRVAP + 1#                                                      MI65 231
DRVBP = DRVBP + 1#                                                      MI65 232
M1 = DRVAP + N#                        Inserted for portability         MI65 233
M2 = DRVBP + N#                                                         MI65 234
DRVFHP = 2.0*SIGSCL(1)*(APH(1)*(QX(DRVAP)+QX(M1)) $#                    MI65 235
+ BPH(1)*(QX(DRVBP)+QX(M2)))#                                           MI65 236
QX(DRVBP) = 2.0*SIGSCL(2)*(APH(2)*(QX(DRVAP)-QX(M1)) $#                 MI65 237
+ BPH(2)*(QX(DRVBP)-QX(M2)))#                                           MI65 238
QX(DRVAP) = DRVFHP#                                                     MI65 239
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MI65 240
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI65 241
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI65 242
#                                                                       MI65 243
# PUT POSSIBLE DERIVATIVES OF K AND/OR C AFTER THE DERIVATIVES          MI65 244
#  OF ATOMIC PARAMETERS.                                                MI65 245
#                                                                       MI65 246
KBPTR = (NSET-1)*STEPKB + STARKB#      Set pointer for overall          MI65 247
#                                         Scale and delta-b.            MI65 248
NPARAM = NPAREF(NSET) + NINT(QX(KBPTR+2)+QX(KBPTR+4))#                  MI65 249
# NPARAM = NUMBER OF ATOM PARAM + SCALE AND OVERALL TO REFINE           MI65 250
IF(NPARAM <= 0)  NEXT#                 Skip, if nothing to refine       MI65 251
IF(QX(KBPTR+2) > half:)#               Calc. deriv. of overall          MI65 252
#                                         Scale of data set.            MI65 253
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MI65 254
DRVAP = DRVAP + 1#                                                      MI65 255
DRVBP = DRVBP + 1#                                                      MI65 256
IF(MINFH == 1) QX(DRVAP) = -2.0*SIGSCL(1)*FPHSQ(1)/QX(KBPTR+1)#         MI65 257
IF(MAXFH == 2) QX(DRVBP) = -2.0*SIGSCL(2)*FPHSQ(2)/QX(KBPTR+1)#         MI65 258
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MI65 259
IF(QX(KBPTR+4) > half:)#               Calc. deriv. of overall          MI65 260
#                                         Delta-b.                      MI65 261
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MI65 262
DRVAP = DRVAP + 1#                                                      MI65 263
DRVBP = DRVBP + 1#                                                      MI65 264
IF(MINFH == 1)  QX(DRVAP) = -2.0*SIGSCL(1)*STOLSQ*FPHSQ(1)#             MI65 265
IF(MAXFH == 2)  QX(DRVBP) = -2.0*SIGSCL(2)*STOLSQ*FPHSQ(2)#             MI65 266
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MI65 267
#                                                                       MI65 268
# BUILD THE MATRIX AND VECTOR OF NORMAL EQUATIONS                       MI65 269
#                                                                       MI65 270
DO K=MINFH,MAXFH#                                                       MI65 271
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MI65 272
IF(K == 1)  START = DRVPTA(NSET) + 1#                                   MI65 273
IF(K == 2)  START = DRVPTB(NSET) + 1#                                   MI65 274
STOP = START + NPARAM - 1#                                              MI65 275
V = MTXPTR(NSET) - lmtxword: + 1#      Set pointer for vector           MI65 276
M = V + lmtxword: * NPARAM#            Set pointer for matrix           MI65 277
DELTA(1) = DELTA(K)#                                                    MI65 278
#                                                                       MI65 279
DO N=START,STOP#                                                        MI65 280
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MI65 281
V = V + lmtxword:#                                                      MI65 282
QX(V) = QX(V) + QX(N)*DELTA(1)#        Calculate vector elements        MI65 283
#                                                                       MI65 284
DO MM=START,N#                         Store matrix by columns,         MI65 285
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MI65 286
M = M + lmtxword:#                     Upper triangular.                MI65 287
QX(M) = QX(M) + QX(N)*QX(MM)#          Calculate matrix elements        MI65 288
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MI65 289
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MI65 290
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MI65 291
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI65 292
RETURN#                                                                 MI65 293
END#                                                                    MI65 294
systemheader:(MI72)#                                                    MI72   1
# ################################################################## #  MI72   2
#                                                                    #  MI72   3
#                               MI72                                 #  MI72   4
#                                                                    #  MI72   5
# ################################################################## #  MI72   6
SUBROUTINE MI72#                       May 1980  k.d. watenpaugh        MI72   7
#                                        Modified jun 1980              MI72   8
#                                            K.d. watenpaugh            MI72   9
#                                        Revised mar 1982  r.m. doherty MI72  10
include:(AACOMN)#                                                       MI72  11
include:(MICOMN)#                                                       MI72  12
#                                                                       MI72  13
INTEGER BEGINL#                                                         MI72  14
INTEGER DATPTR#                        Pointer to data set name in      MI72  15
#                                         Stardn region.                MI72  16
INTEGER ENDL#                                                           MI72  17
INTEGER I#                             Loop index                       MI72  18
INTEGER IND#                           Pointer to name of atom param    MI72  19
INTEGER INDCNT#                        Special number of characters     MI72  20
INTEGER J#                             Another loop index               MI72  21
INTEGER K#                             Index to temporary parameter     MI72  22
#                                         Storage.                      MI72  23
INTEGER KBPTR#                         Pointer to k/delta-b region      MI72  24
INTEGER KK#                                                             MI72  25
INTEGER M#                             Location of normal equation      MI72  26
#                                         Matrix.                       MI72  27
INTEGER NAMPTR#                        Pointer to atom names            MI72  28
INTEGER NPARAM#                        No. parameters for a data set    MI72  29
INTEGER NSET#                          Data set index                   MI72  30
INTEGER PSKIP#                         Signal to skip over atom names   MI72  31
INTEGER PTR#                                                            MI72  32
INTEGER START#                                                          MI72  33
INTEGER STOP#                                                           MI72  34
INTEGER V#                             Location of normal equation      MI72  35
#                                         Vector.                       MI72  36
REAL BPARAM(4)#                                                         MI72  37
REAL KPARAM(4)#                        Local temp. storage for          MI72  38
#                                         Parameters, shifts, etc.      MI72  39
REAL SUMSD#                            Goodness of fit for a data set   MI72  40
REAL TOTAL#                            Total degrees of freedom         MI72  41
chardata:(MI721, REFINEMENT OF ATOMIC PARAMETERS)#                      MI72  42
chardata:(MI722,  DATA SET     ATOM    PARAM            $#              MI72  43
OLD     SHIFT       NEW     SIGMA      $#                               MI72  44
CYCLE    )#                                                             MI72  45
chardata:(MI723,     FIXED)#                                            MI72  46
chardata:(MI724, MATRIX FOR ISOMORPH    )#                              MI72  47
chardata:(MI725,REDUCED CHI**2 =)#                                      MI72  48
chardata:(MI726,X  Y  Z  B11B22B33B12B13B23PP PPASCALE $#               MI72  49
DELTA B)#                                                               MI72  50
realdata:(FMT721,[431042.,531042.,$#                                    MI72  51
631042.,731042.])#                                                      MI72  52
realdata:(FMT722,[880413.,230313.,$#                                    MI72  53
261022.])#                                                              MI72  54
datastuff:#                                                             MI72  55
#                                                                       MI72  56
# STORE CYCLE NUMBER IN HEADING FOR REFINEMENT PRINTING                 MI72  57
BUFOT(1) = FLOAT(ICYC)#                                                 MI72  58
ncodefld:(BUFOT,1,MI722,FMT722(1),1)#                                   MI72  59
#                                                                       MI72  60
GOFPRV = 0.0#                                                           MI72  61
TOTAL  = 0.0#                                                           MI72  62
#                                                                       MI72  63
LINCT = 0#                             Force new page for               MI72  64
writeline:(2,MI721,NMI721,3,3)#        Shift printing.                  MI72  65
#                                                                       MI72  66
# CALCULATE START OF ATOM NAMES                                         MI72  67
K = DRVPTA(2)#                         Start of temporary storage       MI72  68
#                                         To hold parameters, changes,  MI72  69
#                                         And sigmas.                   MI72  70
#                                                                       MI72  71
# LOOP OVER DATA SETS...NOT PARENT (AS YET)                             MI72  72
#                                                                       MI72  73
DO NSET=2,NDATIN#                                                       MI72  74
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI72  75
IF(PPRIOR >= 4)#                                                        MI72  76
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI72  77
BUFOT(1) = FLOAT(NSET)#                                                 MI72  78
ncodefld:(BUFOT,1,MI724,FMT722(2),1)#                                   MI72  79
writeline:(2,MI724,NMI724,3,4)#                                         MI72  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI72  81
#                                                                       MI72  82
KBPTR = STARKB + (NSET-1)*STEPKB#                                       MI72  83
BEGINL = K + 1#                                                         MI72  84
# GET REAL NUMBER OF PARAMETERS TO REFINE                               MI72  85
NPARAM = NPAREF(NSET) + NINT(QX(KBPTR+2)+QX(KBPTR+4))#                  MI72  86
IF(NPARAM > 0)#                        Skip block, if nothing           MI72  87
#                                         Refined for this data set.    MI72  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI72  89
V = MTXPTR(NSET)#                      Location of vector               MI72  90
M = V + lmtxword:*NPARAM + 1#          Location of matrix               MI72  91
#                                                                       MI72  92
# INVERT MATRIX AND SOLVE THE LINEAR EQUATIONS                          MI72  93
#                                                                       MI72  94
#  MI73 AND MATRIX INVERSION ROUTINES CALLED THEREIN SEEMED NEEDLESSLY  MI72  95
#  UNSTABLE.  (OFTEN RESULTING IN ZERO ROOTS AND NONSENSICAL SHIFTS).   MI72  96
#  REPLACED (2-13-89) WITH MATRIX ROUTINES TAKEN FROM CEDAR (CD91).     MI72  97
#                                                                       MI72  98
CALL MI91(QX(M),QX(V+1),NPARAM)#                                        MI72  99
#                                                                       MI72 100
SUMSD = WTDFSQ(NSET)/FLOAT(NREF(NSET)-NPARAM)#                          MI72 101
GOFPRV = GOFPRV + WTDFSQ(NSET)#                                         MI72 102
TOTAL = TOTAL + FLOAT(NREF(NSET)-NPARAM)#                               MI72 103
#                                                                       MI72 104
IF(SUMSD <= 0.0)  iquit:(MI7201)#      Stop if not enough obs.          MI72 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI72 106
PTR = ATMPTR(NSET)#                                                     MI72 107
START = REFPTR(NSET) + 1#                                               MI72 108
STOP = REFPTR(NSET+1)#                                                  MI72 109
#                                                                       MI72 110
# CALCULATE SIGMAS AND REFINED ATOMIC PARAMETERS                        MI72 111
V = V - lmtxword:/2#                   Set v so it starts at right      MI72 112
#                                         Place when lmtxword: is 2.    MI72 113
PSKIP = ATMPTR(NSET) + stepat:#        Mark end of atom parameters      MI72 114
#                                         So name can be skipped.       MI72 115
#                                                                       MI72 116
#                                      Pointer to position in an        MI72 117
#                                      Upper triangular matrix          MI72 118
I=1#                                   Indexed as columns               MI72 119
DO J=START,STOP#                                                        MI72 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI72 121
PTR = PTR + 1#                                                          MI72 122
IF(QX(J) > half:)#                                                      MI72 123
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI72 124
V = V + lmtxword:#                                                      MI72 125
QX(K+1) = QX(PTR)#                     Old                              MI72 126
QX(K+2) = QX(V)#                       Shift                            MI72 127
QX(K+3) = QX(K+1) + QX(K+2)#           New                              MI72 128
###QX(K+4) = SQRT(dptos:(QX(M))*SUMSD)#   Sigma                         MI72 129
QX(K+4) = SQRT(QX(M)*SUMSD)#           Sigma                            MI72 130
QX(PTR) = QX(K+3)#                     Store the new param in qx        MI72 131
#                                      Preceeding incorrect. (2-13-89)  MI72 132
I = I + 1#                             Address diagonal elements with   MI72 133
M = M + lmtxword: * I#                 New index i                      MI72 134
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI72 135
ELSE#                                                                   MI72 136
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI72 137
QX(K+1) = QX(PTR)#                     Old                              MI72 138
QX(K+2) = 0.0#                         Shift                            MI72 139
QX(K+3) = QX(K+1)#                                                      MI72 140
QX(K+4) = voidflg:#                    Sigma                            MI72 141
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI72 142
K = K + 4#                                                              MI72 143
IF(PTR == PSKIP)#                      All params for this atom done    MI72 144
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI72 145
PTR = PTR + stepan:#                                                    MI72 146
PSKIP = PSKIP + STEPAT#                                                 MI72 147
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI72 148
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI72 149
#                                                                       MI72 150
DATPTR = STARDN + (NSET-1)*STEPDN + 1# Point to data set name in qx     MI72 151
movertoc:(QX(DATPTR),1,CHROT,3,12,0)#  Move name into line              MI72 152
#                                                                       MI72 153
# CALCULATE NEW SCALE AND SIGMA OF DATA SET                             MI72 154
#                                                                       MI72 155
KPARAM(1) = QX(KBPTR+1)#               Previous scale                   MI72 156
IF(QX(KBPTR+2) > half:)#               Test if refined on               MI72 157
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI72 158
V = V + lmtxword:#                     Yes                              MI72 159
KPARAM(2) = QX(V)#                     Shift                            MI72 160
KPARAM(3) = KPARAM(1) + KPARAM(2)#     New scale                        MI72 161
###KPARAM(4) = SQRT(dptos:(QX(M))*SUMSD)# Standard deviation            MI72 162
KPARAM(4) = SQRT(QX(M)*SUMSD)#         Standard deviation               MI72 163
QX(KBPTR+1) = KPARAM(3)#                                                MI72 164
#                                      Preceeding incorrect. (2-13-89)  MI72 165
I = I + 1#                             Address diagonal elements with   MI72 166
M = M + lmtxword: * I#                 New index i                      MI72 167
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI72 168
ELSE#                                  Not refined                      MI72 169
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI72 170
KPARAM(2) = 0.#                                                         MI72 171
KPARAM(3) = KPARAM(1)#                                                  MI72 172
KPARAM(4) = 0.#                                                         MI72 173
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI72 174
LINRM = 6#                             Be sure enough lines             MI72 175
ncodefld:(KPARAM,1,CHROT,FMT721(1),4)# Remain on the page.        m     MI72 176
movechar:(MI726,34,CHROT,24,5,0)#      Move scale designation to out    MI72 177
#                                                                       MI72 178
writeline:(3,MI722,NMI722,1,3)#                                         MI72 179
#                                                                       MI72 180
# CALCULATE SIGMA OF OVERALL B                                          MI72 181
#                                                                       MI72 182
BPARAM(1) = QX(KBPTR+3)#               Previous b                       MI72 183
IF(QX(KBPTR+4) > half:)#               Test if refined on               MI72 184
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI72 185
V = V + lmtxword:#                     Yes                              MI72 186
BPARAM(2) = QX(V)#                     Shift                            MI72 187
BPARAM(3) = BPARAM(1) + BPARAM(2)#     New b                            MI72 188
###BPARAM(4) = SQRT(dptos:(QX(M))*SUMSD)# Standard deviation            MI72 189
BPARAM(4) = SQRT(QX(M)*SUMSD)#         Standard deviation               MI72 190
QX(KBPTR+3) = BPARAM(3)#                                                MI72 191
#                                      Preceeding incorrect. (2-13-89)  MI72 192
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI72 193
ELSE#                                  Not refined                      MI72 194
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI72 195
BPARAM(2) = 0.#                                                         MI72 196
BPARAM(3) = BPARAM(1)#                                                  MI72 197
BPARAM(4) = 0.#                                                         MI72 198
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI72 199
#                                                                       MI72 200
ncodefld:(BPARAM,1,CHROT,FMT721(1),4)#                                  MI72 201
movechar:(MI726,40,CHROT,24,7,0)#      Move delta b to output line      MI72 202
writeline:(0,MI722,NMI722,1,3)#                                         MI72 203
#                                                                       MI72 204
# OUTPUT THE RESULTS                                                    MI72 205
#                                                                       MI72 206
ENDL = K - 4#                          Set stop for listing             MI72 207
#                                         Modified atoms.               MI72 208
#                                                                       MI72 209
NAMPTR = ATMPTR(NSET) + stepat: + 1#   Point to name of 1st atom        MI72 210
#                                         In this data set.             MI72 211
DO J=BEGINL,ENDL,arith:(4,*,stepat:)#                                   MI72 212
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI72 213
# WRITE HEADING FOR ATOM                                                MI72 214
movertoc:(QX(NAMPTR),1,CHROT,16,24,0)# Extract atom name                MI72 215
KK = J-4#                                                               MI72 216
IND = -2#                              Set name list pointer            MI72 217
DO I=1,arith:(stepat:,-,2)#                                             MI72 218
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI72 219
KK = KK + 4#                                                            MI72 220
IND = IND + 3#                                                          MI72 221
ifvo:(QX(KK))  NEXT#                                                    MI72 222
INDCNT = 3#                            Set number of print characters   MI72 223
IF(I == 4 & QX(KK+4) <= voidflg:)  INDCNT = 1#                          MI72 224
movechar:(MI726,IND,CHROT,24,INDCNT,0)# Move name of param. to output   MI72 225
ncodefld:(QX,KK,CHROT,FMT721(1),4)#    Line.                            MI72 226
IF(QX(KK+3) <= voidflg:)#                                               MI72 227
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI72 228
movechar:(MI723,1,CHROT,64,10,0)#      Make it clear that param         MI72 229
#                                         Not refined.                  MI72 230
movechar:(MI723,1,CHROT,44,10,1)#      Blank shift                      MI72 231
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI72 232
writeline:(0,MI722,NMI722,1,3)#                                         MI72 233
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI72 234
NAMPTR = NAMPTR + STEPAT#              Move to next atom name           MI72 235
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI72 236
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI72 237
#                                                                       MI72 238
IF(TOTAL > small:)#                                                     MI72 239
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI72 240
GOFPRV = GOFPRV/TOTAL#                 Reduced chi**2 over all          MI72 241
#                                         Data sets.                    MI72 242
movechar:(MI725,1,CHROT,2,NMI725,0)#                                    MI72 243
BUFOT(1) = GOFPRV#                                                      MI72 244
ncodefld:(BUFOT,1,CHROT,FMT722(3),1)#                                   MI72 245
writeline:(1,0,0,1,3)#                                                  MI72 246
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI72 247
RETURN#                                                                 MI72 248
END#                                                                    MI72 249
systemheader:(MI75)#                                                    MI75   1
# ################################################################## #  MI75   2
#                                                                    #  MI75   3
#                               MI75                                 #  MI75   4
#                                                                    #  MI75   5
# ################################################################## #  MI75   6
SUBROUTINE MI75#                       Calculations and printing of     MI75   7
#                                         Statistics.  writes out       MI75   8
#                                         Summary of statistics.        MI75   9
#                                        Jun 1980  s. sheriff           MI75  10
#                                        Revised mar 1981  s. sheriff   MI75  11
# CALLED BY MI00.                                                       MI75  12
# CALLS MI76 WHICH WRITES OUT BLOCK 1 STATISTICS                        MI75  13
# CALLS MI77 WHICH COMPUTES BLOCK 2 AND (IN FAZPRB MODE)                MI75  14
#  BLOCK 4 STATISTICS.                                                  MI75  15
# CALLS MI78 WHICH COMPUTES BLOCK 3 AND (IN FAZPRB MODE)                MI75  16
#  BLOCK 5 STATISTICS.                                                  MI75  17
# CALLS MI79 WHICH WRITES OUT BLOCK 2 AND (IN FAZPRB MODE)              MI75  18
#  BLOCK 4 STATISTICS.                                                  MI75  19
# CALLS MI80 WHICH WRITES OUT BLOCK 3 AND (IN FAZPRB MODE)              MI75  20
#  BLOCK 5 STATISTICS.                                                  MI75  21
# CALLS MI85 (IN FAZPRB MODE) WHICH UPDATES CLOSURE ERRORS IN QX ARRAY  MI75  22
# CALLS MI86 (IN FAZPRB MODE) WHICH WRITES CLOSURE ERRORS               MI75  23
#  TO FORMATTED FILE ON LAST CYCLE IF, REQUESTED.                       MI75  24
#                                                                       MI75  25
include:(AACOMN)#                                                       MI75  26
include:(MICOMN)#                                                       MI75  27
include:(MIMAC2)#                                                       MI75  28
include:(MIMAC3)#                                                       MI75  29
include:(MIMAC7)#                                                       MI75  30
include:(MIMAC8)#                                                       MI75  31
#                                                                       MI75  32
INTEGER DNPTR#                         Pointer to a particular value    MI75  33
#                                         In the stardn region.         MI75  34
INTEGER I#                             Loop index                       MI75  35
INTEGER IPTR2#                         Pointers to total f**2-stol      MI75  36
INTEGER IPTR3#                         Bins in various regions of       MI75  37
INTEGER IPTR4#                         The qx array.                    MI75  38
INTEGER IPTR5#                                                          MI75  39
INTEGER LENGTH#                        Length of output line for        MI75  40
#                                         Statistical blocks 2,3,4, & 5 MI75  41
INTEGER LEVEL#                         Output level for this cycle;     MI75  42
#                                         Last = 1; rest = 2.           MI75  43
INTEGER NCBIN1#                        Output control for all,          MI75  44
#                                         Centric, acentric categories. MI75  45
REAL STOL#                             Sine(theta)**3/lambda**3         MI75  46
string:(HEADER,mxchln:)#               Page heading for statistics      MI75  47
chardata:(MI751, DMIN(A)   F BIN )#                                     MI75  48
chardata:(MI752, TOTAL)#                                                MI75  49
chardata:(MI753, OVERALL FIGURE OF MERIT =      )#                      MI75  50
chardata:(MI754, ISOMORPH     RCULLIS  RKRAUT   ERROR/FH)#              MI75  51
chardata:(MI755,  ERMSISO  ERMSANO)#                                    MI75  52
chardata:(MI756, STATISTICS FOR CYCLE   )#                              MI75  53
chardata:(MI757, SUMMARY OF STATISTICS FOR CYCLE   )#                   MI75  54
chardata:(MI758, NUMBER OF UNPHASEABLE REFLECTIONS =      )#            MI75  55
chardata:(MI759, THEY ARE NOT INCLUDED IN THE STATISTICS)#              MI75  56
realdata:(FMT751,[ 240622.,320622.,$#                                   MI75  57
400622.,480622., 560622.,640622.,$#                                     MI75  58
720622.,800622., 880622.,960622.,$#                                     MI75  59
1040622.,1120622., 1200622.])#                                          MI75  60
realdata:(FMT752,[200632.,280632.,380632.])#                            MI75  61
realdata:(FMT753,[490703.,580703.])#                                    MI75  62
realdata:(FMT754,[240313.,350313.,$#                                    MI75  63
420413.,320632.])#                                                      MI75  64
datastuff:#                                                             MI75  65
#                                                                       MI75  66
########## DEFINE PROCEDURE NAMES USED IN THIS ROUTINE ############# #  MI75  67
defineproc:(MAKEHEADER)#               Prepare header for statistics    MI75  68
defineproc:(OUTPUTCONT)#               Determine output level for       MI75  69
#                                         The current cycle.            MI75  70
defineproc:(SUMMARY)#                  Print summary of statistics      MI75  71
########## END OF PROCEDURE NAME DEFINITIONS ####################### #  MI75  72
#                                                                       MI75  73
# PREPARE HEADER FOR STATISTICS OUTPUT                                  MI75  74
#                                                                       MI75  75
xeq:(MAKEHEADER)#                                                       MI75  76
#                                                                       MI75  77
# DETERMINE LEVEL OF OUTPUT FOR THIS CYCLE                              MI75  78
#                                                                       MI75  79
xeq:(OUTPUTCONT)#                                                       MI75  80
#                                                                       MI75  81
# WRITE OUT BLOCK 1 STATISTICS                                          MI75  82
#                                                                       MI75  83
CALL MI76(NCBIN1,LEVEL)#                                                MI75  84
#                                                                       MI75  85
# COMPUTE BLOCK 2 AND (IN FAZPRB MODE) BLOCK 4 STATISTICS               MI75  86
#                                                                       MI75  87
CALL MI77#                                                              MI75  88
#                                                                       MI75  89
# COMPUTE BLOCK 3 AND (IN FAZPRB MODE) BLOCK 5 STATISTICS               MI75  90
#                                                                       MI75  91
CALL MI78#                                                              MI75  92
#                                                                       MI75  93
# WRITE OUT BLOCK 2 AND (IN FAZPRB MODE) BLOCK 4 STATISTICS             MI75  94
#                                                                       MI75  95
CALL MI79(HEADER,LENGTH,NCBIN1,LEVEL)#                                  MI75  96
#                                                                       MI75  97
# WRITE OUT BLOCK 3 AND (IN FAZPRB MODE) BLOCK 5 STATISTICS             MI75  98
#                                                                       MI75  99
CALL MI80(HEADER,LENGTH,NCBIN1,LEVEL)#                                  MI75 100
#                                                                       MI75 101
# UPDATE (IN FAZPRB MODE) CLOSURE ERRORS IN QX ARRAY                    MI75 102
#                                                                       MI75 103
IF(FAZTYP == fazprb:)#                                                  MI75 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI75 105
CALL MI85#                                                              MI75 106
IF((ICYC == LSTCYC) & (IPUNCH == yes:))  CALL MI86#                     MI75 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI75 108
#                                                                       MI75 109
# PRINT SUMMARY AND EXIT OUT BOTTOM                                     MI75 110
#                                                                       MI75 111
xeq:(SUMMARY)#                                                          MI75 112
GO TO 100#                             Go to return statement           MI75 113
#                                                                       MI75 114
#                       ##########                                      MI75 115
# ##################### MAKEHEADER ################################# #  MI75 116
#                       ##########                                      MI75 117
#                                                                       MI75 118
procedure:(MAKEHEADER)#                                                 MI75 119
#                                                                       MI75 120
LINCT = 0#                             Force new page                   MI75 121
movechar:(MI756,1,CHROT,1,NMI756,0)#                                    MI75 122
BUFOT(1) = FLOAT(ICYC)#                Pick up cycle number             MI75 123
ncodefld:(BUFOT,1,CHROT,FMT754(1),1)#                                   MI75 124
writeline:(0,0,0,1,3)#                                                  MI75 125
#                                                                       MI75 126
# PREPARE HEADER FOR OUTPUT BY STOL BINS                                MI75 127
#                                                                       MI75 128
movechar:(BLANK,1,HEADER,1,mxchln:,1)# Clear out array from             MI75 129
#                                         Last usage.                   MI75 130
movechar:(MI751,1,HEADER,1,NMI751,0)#  Add dmin to header               MI75 131
IF(NBIN == 1)  LENGTH = 24#                                             MI75 132
ELSE#                                                                   MI75 133
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI75 134
LENGTH = 24 + NBIN*8#                  Calculate length of              MI75 135
#                                         Statistical output.           MI75 136
STOL = STOLMN(1)**3#                                                    MI75 137
DO I=1,NBIN#                           Loop over all stol bins          MI75 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI75 139
STOL = STOL + GAP#                                                      MI75 140
BUFOT(I) = 1.0/(2.0*(STOL**.33333333))#                                 MI75 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI75 142
ncodefld:(BUFOT,1,HEADER,FMT751(1),NBIN)#                               MI75 143
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI75 144
movechar:(MI752,1,HEADER,LENGTH-5,NMI752,0)# Add "total"                MI75 145
#                                                                       MI75 146
endproc:(MAKEHEADER)#                                                   MI75 147
#                                                                       MI75 148
#                       ##########                                      MI75 149
# ##################### OUTPUTCONT ################################# #  MI75 150
#                       ##########                                      MI75 151
#                                                                       MI75 152
procedure:(OUTPUTCONT)#                                                 MI75 153
#                                                                       MI75 154
# DETERMINE CENTRICITY AND LEVEL OF OUTPUT FOR THIS CYCLE               MI75 155
#  FOR MI76,MI79,MI80.                                                  MI75 156
#                                                                       MI75 157
IF(ICYC != LSTCYC)#                                                     MI75 158
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI75 159
NCBIN1 = MOD(NCBIN,10)#                Unpack level                     MI75 160
LEVEL = 2#                                                              MI75 161
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI75 162
ELSE#                                  Last cycle                       MI75 163
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI75 164
NCBIN1 = NCBIN/10#                     Unpack level                     MI75 165
LEVEL = 1#                                                              MI75 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI75 167
#                                                                       MI75 168
endproc:(OUTPUTCONT)#                                                   MI75 169
#                                                                       MI75 170
#                       #######                                         MI75 171
# ##################### SUMMARY #################################### #  MI75 172
#                       #######                                         MI75 173
#                                                                       MI75 174
procedure:(SUMMARY)#                                                    MI75 175
#                                                                       MI75 176
# WRITE OUT SUMMARY OF STATISTICS                                       MI75 177
#                                                                       MI75 178
IF(LINCT < (NDATIN+7))  LINCT = 0#     Force new page                   MI75 179
movechar:(MI757,1,CHROT,1,NMI757,0)#   Summary title                    MI75 180
BUFOT(1) = FLOAT(ICYC)#                Pick up cycle number             MI75 181
ncodefld:(BUFOT,1,CHROT,FMT754(2),1)#                                   MI75 182
writeline:(3,0,0,1,3)#                                                  MI75 183
#                                                                       MI75 184
IF(CANTPH > 0)#                        Unphaseable reflections          MI75 185
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI75 186
BUFOT(1) = CANTPH#                                                      MI75 187
ncodefld:(BUFOT,1,MI758,FMT754(3),1)#                                   MI75 188
writeline:(1,MI758,NMI758,3,3)#                                         MI75 189
writeline:(0,MI759,NMI759,3,3)#                                         MI75 190
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI75 191
#                                                                       MI75 192
movechar:(MI753,1,CHROT,1,NMI753,0)#   Figure of merit                  MI75 193
IPTR2 = STOPS2 - STEPS2#               Find overall bin                 MI75 194
BUFOT(1) = sumfom:(IPTR2)#                                              MI75 195
ncodefld:(BUFOT,1,CHROT,FMT754(4),1)#                                   MI75 196
writeline:(1,0,0,1,3)#                                                  MI75 197
#                                                                       MI75 198
movechar:(MI754,1,CHROT,1,NMI754,0)#   Isomorph summary header          MI75 199
IF(FAZTYP == fazprb:)  movechar:(MI755,1,CHROT,NMI754+1,NMI755,0)#      MI75 200
writeline:(3,0,0,1,3)#                                                  MI75 201
#                                                                       MI75 202
DNPTR = STARDN + 1#                    Get index to isomorph            MI75 203
#                                         (data set) names.             MI75 204
IF(FAZTYP == fazprb:)#                 Parent closure error in          MI75 205
#                                         Fazprb mode.                  MI75 206
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI75 207
IPTR4 = STOPS4 - STEPS4#               Overall bin pointer              MI75 208
IF(sumnatanodif:(IPTR4) > 0.0)#        Any observations?                MI75 209
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI75 210
BUFOT(1) = sumnatanoclo:(IPTR4)#                                        MI75 211
movertoc:(QX(DNPTR),1,CHROT,2,12,0)#                                    MI75 212
ncodefld:(BUFOT,1,CHROT,FMT753(2),1)#                                   MI75 213
writeline:(0,0,0,1,3)#                                                  MI75 214
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI75 215
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI75 216
#                                                                       MI75 217
DO I=2,NDATIN#                         Loop over all isomorphs          MI75 218
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI75 219
DNPTR = DNPTR + STEPDN#                                                 MI75 220
IPTR3 = STOPS3 - STEPS3*(NDATIN-1) + (I-2)*STEPS3#                      MI75 221
IPTR5 = STOPS5 - STEPS5*(NDATIN-1) + (I-2)*STEPS5#                      MI75 222
movertoc:(QX(DNPTR),1,CHROT,2,12,0)#   Dataset name                     MI75 223
BUFOT(1) = rcul:(IPTR3)#               Rcullis                          MI75 224
BUFOT(2) = sumdf:(IPTR3)#              Rkraut                           MI75 225
BUFOT(3) = sumfazpwr:(IPTR3)#          Error/f(heavy)                   MI75 226
ncodefld:(BUFOT,1,CHROT,FMT752(1),3)#                                   MI75 227
IF(FAZTYP == fazprb:)#                 Fazprb: pick up closure errors   MI75 228
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI75 229
BUFOT(1) = sumclosure:(IPTR5)#         Isomorphous                      MI75 230
BUFOT(2) = sumanoclo:(IPTR5)#          Anomalous                        MI75 231
ncodefld:(BUFOT,1,CHROT,FMT753(1),2)#                                   MI75 232
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI75 233
writeline:(0,0,0,1,3)#                                                  MI75 234
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI75 235
#                                                                       MI75 236
endproc:(SUMMARY)#                                                      MI75 237
#                                                                       MI75 238
100 CONTINUE#                                                           MI75 239
RETURN#                                                                 MI75 240
######### REMOVE PROCEDURES ################################            MI75 241
deleteproc:(MAKEHEADER)#                                                MI75 242
deleteproc:(OUTPUTCONT)#                                                MI75 243
deleteproc:(SUMMARY)#                                                   MI75 244
#                                                                       MI75 245
END#                                                                    MI75 246
pmacro:([z:])#                                                          MI75 247
systemheader:(MI76)#                                                    MI76   1
# ################################################################## #  MI76   2
#                                                                    #  MI76   3
#                               MI76                                 #  MI76   4
#                                                                    #  MI76   5
# ################################################################## #  MI76   6
SUBROUTINE MI76(NCBIN1,LEVEL)#         Computes and writes out          MI76   7
#                                         Block 1 statistics.           MI76   8
#                                        Called by mi75                 MI76   9
#                                        Calls mi81                     MI76  10
#                                        Dec 1979  s. sheriff           MI76  11
#                                        Revised jul 1980  s. sheriff   MI76  12
include:(MIMAC1)#                                                       MI76  13
include:(MIMAC5)#                                                       MI76  14
include:(AACOMN)#                                                       MI76  15
include:(MICOMN)#                                                       MI76  16
#                                                                       MI76  17
INTEGER I#                             Loop index                       MI76  18
INTEGER IPRACE#                        Priority for acentrics for       MI76  19
#                                         The current statistic.        MI76  20
INTEGER IPRALL#                        Priority for "all" category      MI76  21
#                                         For the current statistic.    MI76  22
INTEGER IPRCEN#                        Priority for centrics for        MI76  23
#                                         The current statistic.        MI76  24
INTEGER IPTR1#                         Pointer to figure of merit       MI76  25
#                                         Histogram in the qx array.    MI76  26
INTEGER LEVEL#                         Output level for this cycle;     MI76  27
#                                         Last = 1; rest = 2.           MI76  28
INTEGER NCBIN1#                        Output control for all,          MI76  29
#                                         Centric, acentric categories. MI76  30
chardata:(MI761, ALL)#                                                  MI76  31
chardata:(MI762, CENTRIC)#                                              MI76  32
chardata:(MI763, ACENTRIC)#                                             MI76  33
chardata:(MI764,NUMBER)#                                                MI76  34
chardata:(MI765, PHASE DIFFERENCE BETWEEN CYCLES IN DEGREES)#           MI76  35
chardata:(MI766, ACENTRIC   AVERAGE =        NUMBER OF $#               MI76  36
REFLECTIONS =         )#                                                MI76  37
chardata:(MI767, CENTRIC    CHANGES =        NUMBER OF $#               MI76  38
REFLECTIONS =         )#                                                MI76  39
chardata:(MI768, PHASE DIFFERENCE BETWEEN (OR WITHIN) $#                MI76  40
CYCLES IN DEGREES)#                                                     MI76  41
chardata:(MI769,                      BEST      MOST PROB   $#          MI76  42
BEST-MPROB)#                                                            MI76  43
chardata:(MI76A, ACENTRIC  AVERAGE)#                                    MI76  44
chardata:(MI76B, CENTRIC   CHANGES)#                                    MI76  45
chardata:(MI76C, MEAN SQUARE ERROR IN ELECTRON DENSITY $#               MI76  46
IS          (ELECTRONS**2/ANGSTROMS**6))#                               MI76  47
chardata:(MI76D, FIGURE OF MERIT HISTOGRAM)#                            MI76  48
chardata:(MI76E,           .0-.1  .1-.2  .2-.3  .3-.4  .4-.5  .5-$#     MI76  49
.6  .6-.7  .7-.8  .8-.9  .9-1.)#                                        MI76  50
realdata:(FMT761,[280613.,600713.])#                                    MI76  51
realdata:(FMT762,[280613.,600713.])#                                    MI76  52
realdata:(FMT763,[260612.,380612.,$#                                    MI76  53
500612.])#                                                              MI76  54
realdata:(FMT764,[260613.,380613.,$#                                    MI76  55
500613.])#                                                              MI76  56
realdata:(FMT765,[160613.,230613.,$#                                    MI76  57
300613.,370613.,$#                                                      MI76  58
440613.,510613.,$#                                                      MI76  59
580613.,650613.,$#                                                      MI76  60
720613.,790613.])#                                                      MI76  61
realdata:(FMT766,[500831.])#                                            MI76  62
datastuff:#                                                             MI76  63
#                                                                       MI76  64
# PREPARE AVERAGE PHASE DIFFERENCES BETWEEN CYCLES FOR OUTPUT;          MI76  65
#  CONVERT FROM RADIANS TO DEGREES.                                     MI76  66
#                                                                       MI76  67
IF(sumnuma:   > 0.0)  sumfazdifa: = (sumfazdifa:/sumnuma:)*DEGRAD#      MI76  68
IF(sumnummpa: > 0.0)  summpdifa: = (summpdifa:/sumnummpa:)*DEGRAD#      MI76  69
IF(sumnumbma: > 0.0)  sumbmdifa: = (sumbmdifa:/sumnumbma:)*DEGRAD#      MI76  70
#                                                                       MI76  71
IF(FAZTYP == mvfc:)#                   Method was mvfc                  MI76  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI76  73
IF((sumnuma: > small:) \ (sumnumc: > small:))#                          MI76  74
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI76  75
writeline:(2,0,0,3,3)#                                                  MI76  76
LINRM = 4#                                                              MI76  77
writeline:(0,MI765,NMI765,3,3)#                                         MI76  78
movechar:(MI766,1,CHROT,1,NMI766,0)#                                    MI76  79
BUFOT(1) = sumfazdifa:#                                                 MI76  80
BUFOT(2) = sumnuma:#                                                    MI76  81
ncodefld:(BUFOT,1,CHROT,FMT761(1),2)#                                   MI76  82
writeline:(1,0,0,1,3)#                                                  MI76  83
#                                                                       MI76  84
movechar:(MI767,1,CHROT,1,NMI767,0)#                                    MI76  85
BUFOT(1) = sumfazdifc:#                                                 MI76  86
BUFOT(2) = sumnumc:#                                                    MI76  87
ncodefld:(BUFOT,1,CHROT,FMT762(1),2)#                                   MI76  88
writeline:(0,0,0,1,3)#                                                  MI76  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI76  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI76  91
#                                                                       MI76  92
ELSE#                                  Method was fazprb                MI76  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI76  94
writeline:(2,0,0,3,3)#                                                  MI76  95
LINRM = 7#                                                              MI76  96
writeline:(0,MI768,NMI768,3,3)#                                         MI76  97
writeline:(1,MI769,NMI769,3,3)#                                         MI76  98
movechar:(MI76A,1,CHROT,1,NMI76A,0)#                                    MI76  99
BUFOT(1) = sumfazdifa:#                                                 MI76 100
BUFOT(2) = summpdifa:#                                                  MI76 101
BUFOT(3) = sumbmdifa:#                                                  MI76 102
ncodefld:(BUFOT,1,CHROT,FMT763(1),3)#                                   MI76 103
writeline:(0,0,0,1,3)#                                                  MI76 104
#                                                                       MI76 105
movechar:(MI764,1,CHROT,12,NMI764,0)#                                   MI76 106
BUFOT(1) = sumnuma:#                                                    MI76 107
BUFOT(2) = sumnummpa:#                                                  MI76 108
BUFOT(3) = sumnumbma:#                                                  MI76 109
ncodefld:(BUFOT,1,CHROT,FMT764(1),3)#                                   MI76 110
writeline:(0,0,0,1,3)#                                                  MI76 111
#                                                                       MI76 112
movechar:(MI76B,1,CHROT,1,NMI76B,0)#                                    MI76 113
BUFOT(1) = sumfazdifc:#                                                 MI76 114
BUFOT(2) = summpdifc:#                                                  MI76 115
BUFOT(3) = sumbmdifc:#                                                  MI76 116
ncodefld:(BUFOT,1,CHROT,FMT764(1),3)#                                   MI76 117
writeline:(0,0,0,1,3)#                                                  MI76 118
#                                                                       MI76 119
movechar:(MI764,1,CHROT,12,NMI764,0)#                                   MI76 120
BUFOT(1) = sumnumc:#                                                    MI76 121
BUFOT(2) = sumnummpc:#                                                  MI76 122
BUFOT(3) = sumnumbmc:#                                                  MI76 123
ncodefld:(BUFOT,1,CHROT,FMT764(1),3)#                                   MI76 124
writeline:(0,0,0,1,3)#                                                  MI76 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI76 126
#                                                                       MI76 127
# MEAN SQUARE ERROR IN ELECTRON DENSITY IS CALCULATED BY THE METHOD     MI76 128
#  OF DICKERSON, KENDREW & STRANDBERG (1961) ACTA CRYST, 14, 1188-1195. MI76 129
#  HOWEVER, INSTEAD OF ASSUMING THAT CALCULATION IS OVER HALF A SPHERE, MI76 130
#  WHEN DELRHO: IS CALCULATED THE REFLECTION MULTIPLICITY IS TAKEN INTO MI76 131
#  ACCOUNT.                                                             MI76 132
#                                                                       MI76 133
IF(ICYC == LSTCYC)  IPRALL = 3#                                         MI76 134
ELSE  IPRALL = 5#                                                       MI76 135
IF(VOLUME > 0.0)  delrho: = (1.0/VOLUME**2)*delrho:#                    MI76 136
movechar:(MI76C,1,CHROT,1,NMI76C,0)#                                    MI76 137
BUFOT(1) = delrho:#                                                     MI76 138
ncodefld:(BUFOT,1,CHROT,FMT766,1)#                                      MI76 139
writeline:(2,0,0,1,IPRALL)#                                             MI76 140
#                                                                       MI76 141
# WRITE OUT FIGURE OF MERIT HISTOGRAM                                   MI76 142
#                                                                       MI76 143
CALL MI81(QX(STARST+1),LEVEL,NCBIN1,no:,no:,sumnumc:,IPRALL,$#          MI76 144
IPRCEN,IPRACE)#                        Fomhist                          MI76 145
writeline:(2,0,0,3,3)#                                                  MI76 146
LINRM = 6#                                                              MI76 147
writeline:(0,MI76D,NMI76D,3,IPRALL)#                                    MI76 148
writeline:(1,MI76E,NMI76E,3,IPRALL)#                                    MI76 149
#                                                                       MI76 150
movechar:(MI761,1,CHROT,1,NMI761,0)#                                    MI76 151
DO I=1,10#                                                              MI76 152
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI76 153
IPTR1 = STARS1 + (I-1)*3#                                               MI76 154
BUFOT(I) = fomhist:(IPTR1)#                                             MI76 155
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI76 156
ncodefld:(BUFOT,1,CHROT,FMT765(1),10)#                                  MI76 157
writeline:(0,0,0,1,IPRALL)#                                             MI76 158
#                                                                       MI76 159
movechar:(MI762,1,CHROT,1,NMI762,0)#                                    MI76 160
DO I=1,10#                                                              MI76 161
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI76 162
IPTR1 = STARS1 + (I-1)*3#                                               MI76 163
BUFOT(I) = fomhistc:(IPTR1)#                                            MI76 164
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI76 165
ncodefld:(BUFOT,1,CHROT,FMT765(1),10)#                                  MI76 166
writeline:(0,0,0,1,IPRCEN)#                                             MI76 167
#                                                                       MI76 168
movechar:(MI763,1,CHROT,1,NMI763,0)#                                    MI76 169
DO I=1,10#                                                              MI76 170
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI76 171
IPTR1 = STARS1 + (I-1)*3#                                               MI76 172
BUFOT(I) = fomhista:(IPTR1)#                                            MI76 173
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI76 174
ncodefld:(BUFOT,1,CHROT,FMT765(1),10)#                                  MI76 175
writeline:(0,0,0,1,IPRACE)#                                             MI76 176
RETURN#                                                                 MI76 177
END#                                                                    MI76 178
systemheader:(MI77)#                                                    MI77   1
# ################################################################## #  MI77   2
#                                                                    #  MI77   3
#                               MI77                                 #  MI77   4
#                                                                    #  MI77   5
# ################################################################## #  MI77   6
SUBROUTINE MI77#                       Computes block 2 statistics      MI77   7
#                                         And, in fazprb mode, block 4  MI77   8
#                                         Statistics.                   MI77   9
#                                        Called by mi75                 MI77  10
#                                        Dec 1979  s. sheriff           MI77  11
#                                        Revised jul 1980  s. sheriff   MI77  12
include:(MIMAC3)#                                                       MI77  13
include:(MIMAC8)#                                                       MI77  14
include:(AACOMN)#                                                       MI77  15
include:(MICOMN)#                                                       MI77  16
#                                                                       MI77  17
INTEGER I#                             Loop index                       MI77  18
INTEGER IPTRF#                         Pointer to overall f**2 bin      MI77  19
INTEGER IPTRS#                         Pointer to overall stol bin      MI77  20
INTEGER J#                             Another loop index               MI77  21
INTEGER JPTRF#                         Pointer to particular f**2 bin   MI77  22
INTEGER JPTRS#                         Pointer to particular stol bin   MI77  23
INTEGER K#                             Pointer to particular            MI77  24
#                                         F**2-stol bin.                MI77  25
INTEGER L#                             Pointer to particular            MI77  26
#                                         F**2-stol bin.                MI77  27
INTEGER NBIN1#                         Number of stol bins plus one     MI77  28
INTEGER NFBIN1#                        Number of f**2 bins plus one     MI77  29
#                                                                       MI77  30
# CALCULATION OF POINTERS:                                              MI77  31
#                                                                       MI77  32
# CALCULATION OF IPTRF:                                                 MI77  33
#  SECOND TERM LOCATES THE OVERALL F**2 BINS.                           MI77  34
#  THIRD TERM OFFSETS TO THE STOL BIN WITHIN THE OVERALL F**2 BINS.     MI77  35
#                                                                       MI77  36
# CALCULATION OF IPTRS:                                                 MI77  37
#  SECOND TERM LOCATES BEGINNING OF NEXT F**2 BIN.                      MI77  38
#  THIRD TERM OFFSETS BACK TO BEGINNING OF OVERALL STOL BIN IN          MI77  39
#   PREVIOUS F**2 BIN.                                                  MI77  40
#                                                                       MI77  41
# CALCULATION OF JPTRF:                                                 MI77  42
#  SECOND TERM LOCATES APPROPRIATE F**2 BIN.                            MI77  43
#  THIRD TERM OFFSETS TO THE APPROPRIATE STOL BIN.                      MI77  44
#                                                                       MI77  45
# CALCULATION OF JPTRS:                                                 MI77  46
#  SECOND TERM LOCATES APPROPRIATE F**2 BIN.                            MI77  47
#  THIRD TERM OFFSETS TO THE APPROPRIATE STOL BIN.                      MI77  48
#                                                                       MI77  49
# CALCULATION OF K:                                                     MI77  50
#  SECOND TERM LOCATES APPROPRIATE F**2 BIN.                            MI77  51
#  THIRD TERM OFFSETS TO THE APPROPRIATE STOL BIN.                      MI77  52
#                                                                       MI77  53
# CALCULATION OF L:                                                     MI77  54
#  SECOND TERM LOCATES APPROPRIATE F**2 BIN.                            MI77  55
#  THIRD TERM OFFSETS TO THE APPROPRIATE STOL BIN.                      MI77  56
#                                                                       MI77  57
NBIN1 = NBIN + 1#                                                       MI77  58
NFBIN1 = NFBIN + 1#                                                     MI77  59
#                                                                       MI77  60
# PREPARE FIGURE OF MERIT BY STOL FOR OUTPUT.                           MI77  61
#  ADD EACH BIN TOGETHER TO GET OVERALL VALUE FOR STOL.                 MI77  62
#                                                                       MI77  63
DO I=1,NFBIN#                                                           MI77  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI77  65
DO J=1,NBIN#                                                            MI77  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI77  67
IPTRS = STARS2 + I*STEPS2*(NBIN+1) - STEPS2#                            MI77  68
JPTRS = STARS2 + (I-1)*STEPS2*(NBIN+1) + (J-1)*STEPS2#                  MI77  69
#                                                                       MI77  70
sumfomc:(IPTRS) = sumfomc:(IPTRS) + sumfomc:(JPTRS)#                    MI77  71
sumrefc:(IPTRS) = sumrefc:(IPTRS) + sumrefc:(JPTRS)#                    MI77  72
sumfoma:(IPTRS) = sumfoma:(IPTRS) + sumfoma:(JPTRS)#                    MI77  73
sumrefa:(IPTRS) = sumrefa:(IPTRS) + sumrefa:(JPTRS)#                    MI77  74
sumnatwteano:(IPTRS) = sumnatwteano:(IPTRS) + sumnatwteano:(JPTRS)#     MI77  75
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI77  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI77  77
#                                                                       MI77  78
# ADD EACH BIN TOGETHER TO GET OVERALL VALUE FOR F**2                   MI77  79
#                                                                       MI77  80
DO I=1,NFBIN#                                                           MI77  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI77  82
DO J=1,NBIN1#                                                           MI77  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI77  84
IPTRF = STARS2 + STEPS2*(NBIN+1)*NFBIN + (J-1)*STEPS2#                  MI77  85
JPTRF = STARS2 + (I-1)*STEPS2*(NBIN+1) + (J-1)*STEPS2#                  MI77  86
#                                                                       MI77  87
sumfomc:(IPTRF) = sumfomc:(IPTRF) + sumfomc:(JPTRF)#                    MI77  88
sumrefc:(IPTRF) = sumrefc:(IPTRF) + sumrefc:(JPTRF)#                    MI77  89
sumfoma:(IPTRF) = sumfoma:(IPTRF) + sumfoma:(JPTRF)#                    MI77  90
sumrefa:(IPTRF) = sumrefa:(IPTRF) + sumrefa:(JPTRF)#                    MI77  91
sumnatwteano:(IPTRF) = sumnatwteano:(IPTRF) + sumnatwteano:(JPTRF)#     MI77  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI77  93
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI77  94
#                                                                       MI77  95
# NOW ADD TOGETHER THE BINS FOR CENTRIC AND ACENTRIC REFLECTIONS        MI77  96
#  TO OBTAIN THE SUMS FOR ALL STATISTICS.                               MI77  97
#                                                                       MI77  98
DO I=1,NFBIN1#                                                          MI77  99
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI77 100
DO J=1,NBIN1#                                                           MI77 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI77 102
K = STARS2 + (I-1)*STEPS2*(NBIN+1) + (J-1)*STEPS2#                      MI77 103
#                                                                       MI77 104
sumfom:(K) = sumfom:(K) + sumfomc:(K) + sumfoma:(K)#                    MI77 105
sumref:(K) = sumref:(K) + sumrefc:(K) + sumrefa:(K)#                    MI77 106
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI77 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI77 108
#                                                                       MI77 109
# CONVERT EACH BIN TO AVERAGE FIGURE OF MERIT                           MI77 110
#                                                                       MI77 111
DO I=1,NFBIN1#                                                          MI77 112
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI77 113
DO J=1,NBIN1#                                                           MI77 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI77 115
K = STARS2 + (I-1)*STEPS2*(NBIN+1) + (J-1)*STEPS2#                      MI77 116
#                                                                       MI77 117
IF(sumref:(K) > 0.0)  sumfom:(K) = sumfom:(K)/sumref:(K)#               MI77 118
IF(sumrefc:(K) > 0.0)  sumfomc:(K) = sumfomc:(K)/sumrefc:(K)#           MI77 119
IF(sumrefa:(K) > 0.0)#                                                  MI77 120
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI77 121
sumfoma:(K) = sumfoma:(K)/sumrefa:(K)#                                  MI77 122
sumnatwteano:(K) = SQRT(sumnatwteano:(K)/sumrefa:(K))#                  MI77 123
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI77 124
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI77 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI77 126
#                                                                       MI77 127
# PREPARE STATISTICAL BLOCK 4 FOR OUTPUT BY ADDING TOGETHER EACH BIN    MI77 128
#  TO GET OVERALL VALUE.                                                MI77 129
#                                                                       MI77 130
IF(FAZTYP == fazprb:)#                                                  MI77 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI77 132
#                                                                       MI77 133
DO I=1,NFBIN#                                                           MI77 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI77 135
DO J=1,NBIN#                                                            MI77 136
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI77 137
IPTRS = STARS4 + I*STEPS4*(NBIN+1) - STEPS4#                            MI77 138
JPTRS = STARS4 + (I-1)*STEPS4*(NBIN+1) + (J-1)*STEPS4#                  MI77 139
#                                                                       MI77 140
sumvarc:(IPTRS) = sumvarc:(IPTRS) + sumvarc:(JPTRS)#                    MI77 141
sumvara:(IPTRS) = sumvara:(IPTRS) + sumvara:(JPTRS)#                    MI77 142
sumnatanoclo:(IPTRS) = sumnatanoclo:(IPTRS) + sumnatanoclo:(JPTRS)#     MI77 143
sumnatanoadj:(IPTRS) = sumnatanoadj:(IPTRS) + sumnatanoadj:(JPTRS)#     MI77 144
sumnatanodif:(IPTRS) = sumnatanodif:(IPTRS) + sumnatanodif:(IPTRS)#     MI77 145
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI77 146
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI77 147
#                                                                       MI77 148
DO I=1,NFBIN#                                                           MI77 149
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI77 150
DO J=1,NBIN1#                                                           MI77 151
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI77 152
IPTRF = STARS4 + STEPS4*(NBIN+1)*NFBIN + (J-1)*STEPS4#                  MI77 153
JPTRF = STARS4 + (I-1)*STEPS4*(NBIN+1) + (J-1)*STEPS4#                  MI77 154
#                                                                       MI77 155
sumvarc:(IPTRF) = sumvarc:(IPTRF) + sumvarc:(JPTRF)#                    MI77 156
sumvara:(IPTRF) = sumvara:(IPTRF) + sumvara:(JPTRF)#                    MI77 157
sumnatanoclo:(IPTRF) = sumnatanoclo:(IPTRF) + sumnatanoclo:(IPTRF)#     MI77 158
sumnatanoadj:(IPTRF) = sumnatanoadj:(IPTRF) + sumnatanoadj:(JPTRF)#     MI77 159
sumnatanodif:(IPTRF) = sumnatanodif:(IPTRF) + sumnatanodif:(IPTRF)#     MI77 160
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI77 161
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI77 162
#                                                                       MI77 163
# NOW ADD TOGETHER THE BINS FOR CENTRIC AND ACENTRIC REFLECTIONS        MI77 164
#  TO OBTAIN THE SUMS FOR ALL STATISTICS.                               MI77 165
#                                                                       MI77 166
DO I=1,NFBIN1#                                                          MI77 167
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI77 168
DO J=1,NBIN1#                                                           MI77 169
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MI77 170
K = STARS4 + (I-1)*STEPS4*(NBIN+1) + (J-1)*STEPS4#                      MI77 171
sumvar:(K) = sumvar:(K) + sumvarc:(K) + sumvara:(K)#                    MI77 172
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MI77 173
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI77 174
#                                                                       MI77 175
# CONVERT EACH BIN TO RMS VALUE                                         MI77 176
#                                                                       MI77 177
DO I=1,NFBIN1#                                                          MI77 178
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MI77 179
DO J=1,NBIN1#                                                           MI77 180
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MI77 181
K = STARS4 + (I-1)*STEPS4*(NBIN+1) + (J-1)*STEPS4#                      MI77 182
# ACCESS BLOCK2                                                         MI77 183
L = STARS2 + (I-1)*STEPS2*(NBIN+1) + (J-1)*STEPS2#                      MI77 184
#                                                                       MI77 185
IF(sumref:(L) > 0.0)  sumvar:(K) = SQRT(sumvar:(K)/sumref:(L))#         MI77 186
IF(sumrefc:(L) > 0.0)#                                                  MI77 187
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MI77 188
sumvarc:(K) = SQRT(sumvarc:(K)/sumrefc:(L))#                            MI77 189
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MI77 190
IF(sumrefa:(L) > 0.0)#                                                  MI77 191
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MI77 192
sumvara:(K) = SQRT(sumvara:(K)/sumrefa:(L))#                            MI77 193
sumnatanoclo:(K) = SQRT(sumnatanoclo:(K)/sumrefa:(L))#                  MI77 194
sumnatanoadj:(K) = SQRT(sumnatanoadj:(K)/sumrefa:(L))#                  MI77 195
sumnatanodif:(K) = SQRT(sumnatanodif:(K)/sumrefa:(L))#                  MI77 196
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MI77 197
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MI77 198
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MI77 199
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI77 200
RETURN#                                                                 MI77 201
END#                                                                    MI77 202
systemheader:(MI78)#                                                    MI78   1
# ################################################################## #  MI78   2
#                                                                    #  MI78   3
#                               MI78                                 #  MI78   4
#                                                                    #  MI78   5
# ################################################################## #  MI78   6
SUBROUTINE MI78#                       Computes block 3 statistics      MI78   7
#                                         And, in fazprb mode, block 5  MI78   8
#                                         Statistics.                   MI78   9
#                                        Called by mi75                 MI78  10
#                                        Dec 1979  s. sheriff           MI78  11
#                                        Revised jul 1980  s. sheriff   MI78  12
include:(MIMAC6)#                                                       MI78  13
include:(MIMAC7)#                                                       MI78  14
include:(AACOMN)#                                                       MI78  15
include:(MICOMN)#                                                       MI78  16
#                                                                       MI78  17
INTEGER I#                             Loop index                       MI78  18
INTEGER IPTRF#                         Pointer to overall f**2 bin      MI78  19
INTEGER IPTRS#                         Pointer to overall stol bin      MI78  20
INTEGER J#                             Another loop index               MI78  21
INTEGER JPTRF#                         Pointer to particular f**2 bin   MI78  22
INTEGER JPTRS#                         Pointer to particular stol bin   MI78  23
INTEGER K#                             Another loop index               MI78  24
INTEGER L#                             Pointer to particular            MI78  25
#                                         F**2-stol bin.                MI78  26
INTEGER M#                             Pointer to particular            MI78  27
#                                         F**2-stol bin.                MI78  28
INTEGER NBIN1#                         Number of stol bins plus one     MI78  29
INTEGER NFBIN1#                        Number of f**2 bins plus one     MI78  30
REAL TOTAL#                            Number of reflections for        MI78  31
#                                         Isomorph.                     MI78  32
# CALCULATION OF POINTERS:                                              MI78  33
#                                                                       MI78  34
# CALCULATION OF IPTRF:                                                 MI78  35
#   SECOND TERM LOCATES THE OVERALL F**2 BINS.                          MI78  36
#   THIRD TERM OFFSETS TO THE STOL BIN WITHIN THE OVERALL F**2 BINS.    MI78  37
#   FOURTH TERM OFFSETS TO ISOMORPH.                                    MI78  38
#                                                                       MI78  39
# CALCULATION OF IPTRS:                                                 MI78  40
#   SECOND TERM LOCATES BEGINNING OF NEXT F**2 BIN.                     MI78  41
#   THIRD TERM OFFSETS BACK TO BEGINNING OF OVERALL STOL BIN IN         MI78  42
#    PREVIOUS F**2 BIN.                                                 MI78  43
#   FOURTH TERM OFFSETS TO ISOMORPH.                                    MI78  44
#                                                                       MI78  45
# CALCULATION OF JPTRF:                                                 MI78  46
#   SECOND TERM LOCATES APPROPRIATE F**2 BIN.                           MI78  47
#   THIRD TERM OFFSETS TO THE APPROPRIATE STOL BIN.                     MI78  48
#   FOURTH TERM OFFSETS TO ISOMORPH.                                    MI78  49
#                                                                       MI78  50
# CALCULATION OF JPTRS:                                                 MI78  51
#   SECOND TERM LOCATES APPROPRIATE F**2 BIN.                           MI78  52
#   THIRD TERM OFFSETS TO THE APPROPRIATE STOL BIN.                     MI78  53
#   FOURTH TERM OFFSETS TO ISOMORPH.                                    MI78  54
#                                                                       MI78  55
# CALCULATION OF L:                                                     MI78  56
#   SECOND TERM LOCATES APPROPRIATE F**2 BIN.                           MI78  57
#   THIRD TERM OFFSETS TO THE APPROPRIATE STOL BIN.                     MI78  58
#   FOURTH TERM OFFSETS TO ISOMORPH.                                    MI78  59
#                                                                       MI78  60
# CALCULATION OF M:                                                     MI78  61
#   SECOND TERM LOCATES APPROPRIATE F**2 BIN.                           MI78  62
#   THIRD TERM OFFSETS TO THE APPROPRIATE STOL BIN.                     MI78  63
#   FOURTH TERM OFFSETS TO ISOMORPH.                                    MI78  64
#                                                                       MI78  65
NBIN1 = NBIN + 1#                                                       MI78  66
NFBIN1 = NFBIN + 1#                                                     MI78  67
#                                                                       MI78  68
# PREPARE STATISTICAL BLOCK 3 FOR OUTPUT BY ADDING TOGETHER EACH BIN    MI78  69
# TO GET OVERALL VALUE.                                                 MI78  70
#                                                                       MI78  71
DO I=1,NFBIN#                                                           MI78  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI78  73
DO J=1,NBIN#                                                            MI78  74
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI78  75
DO K=2,NDATIN#                                                          MI78  76
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI78  77
IPTRS = STARS3 + I*STEPS3*(NDATIN-1)*(NBIN+1) $#                        MI78  78
- STEPS3*(NDATIN-1) + (K-2)*STEPS3#                                     MI78  79
JPTRS = STARS3 + (I-1)*STEPS3*(NDATIN-1)*(NBIN+1) $#                    MI78  80
+ (J-1)*STEPS3*(NDATIN-1) + (K-2)*STEPS3#                               MI78  81
#                                                                       MI78  82
rcul:(IPTRS) = rcul:(IPTRS) + rcul:(JPTRS)#                             MI78  83
delisoc:(IPTRS) = delisoc:(IPTRS) + delisoc:(JPTRS)#                    MI78  84
sumdfc:(IPTRS) = sumdfc:(IPTRS) + sumdfc:(JPTRS)#                       MI78  85
sumfphc:(IPTRS) = sumfphc:(IPTRS) + sumfphc:(JPTRS)#                    MI78  86
sumallc:(IPTRS) = sumallc:(IPTRS) + sumallc:(JPTRS)#                    MI78  87
sumalfdelc:(IPTRS) = sumalfdelc:(IPTRS) + sumalfdelc:(JPTRS)#           MI78  88
sumfazpwrc:(IPTRS) = sumfazpwrc:(IPTRS) + sumfazpwrc:(JPTRS)#           MI78  89
sumfhc:(IPTRS) = sumfhc:(IPTRS) + sumfhc:(JPTRS)#                       MI78  90
sumwteisoc:(IPTRS) = sumwteisoc:(IPTRS) + sumwteisoc:(JPTRS)#           MI78  91
sumdfa:(IPTRS) = sumdfa:(IPTRS) + sumdfa:(JPTRS)#                       MI78  92
sumfpha:(IPTRS) = sumfpha:(IPTRS) + sumfpha:(JPTRS)#                    MI78  93
sumalla:(IPTRS) = sumalla:(IPTRS) + sumalla:(JPTRS)#                    MI78  94
sumalfdela:(IPTRS) = sumalfdela:(IPTRS) + sumalfdela:(JPTRS)#           MI78  95
sumfazpwra:(IPTRS) = sumfazpwra:(IPTRS) + sumfazpwra:(JPTRS)#           MI78  96
sumfha:(IPTRS) = sumfha:(IPTRS) + sumfha:(JPTRS)#                       MI78  97
sumwteisoa:(IPTRS) = sumwteisoa:(IPTRS) + sumwteisoa:(JPTRS)#           MI78  98
sumwteano:(IPTRS) = sumwteano:(IPTRS) + sumwteano:(JPTRS)#              MI78  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI78 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI78 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI78 102
#                                                                       MI78 103
DO I=1,NFBIN#                                                           MI78 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI78 105
DO J=1,NBIN1#                                                           MI78 106
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI78 107
DO K=2,NDATIN#                                                          MI78 108
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI78 109
IPTRF = STARS3 + STEPS3*(NDATIN-1)*(NBIN+1)*NFBIN $#                    MI78 110
+ (J-1)*STEPS3*(NDATIN-1) + (K-2)*STEPS3#                               MI78 111
JPTRF = STARS3 + (I-1)*STEPS3*(NDATIN-1)*(NBIN+1) $#                    MI78 112
+ (J-1)*STEPS3*(NDATIN-1) + (K-2)*STEPS3#                               MI78 113
#                                                                       MI78 114
rcul:(IPTRF) = rcul:(IPTRF) + rcul:(JPTRF)#                             MI78 115
delisoc:(IPTRF) = delisoc:(IPTRF) + delisoc:(JPTRF)#                    MI78 116
sumdfc:(IPTRF) = sumdfc:(IPTRF) + sumdfc:(JPTRF)#                       MI78 117
sumfphc:(IPTRF) = sumfphc:(IPTRF) + sumfphc:(JPTRF)#                    MI78 118
sumallc:(IPTRF) = sumallc:(IPTRF) + sumallc:(JPTRF)#                    MI78 119
sumalfdelc:(IPTRF) = sumalfdelc:(IPTRF) + sumalfdelc:(JPTRF)#           MI78 120
sumfazpwrc:(IPTRF) = sumfazpwrc:(IPTRF) + sumfazpwrc:(JPTRF)#           MI78 121
sumfhc:(IPTRF) = sumfhc:(IPTRF) + sumfhc:(JPTRF)#                       MI78 122
sumwteisoc:(IPTRF) = sumwteisoc:(IPTRF) + sumwteisoc:(JPTRF)#           MI78 123
sumdfa:(IPTRF) = sumdfa:(IPTRF) + sumdfa:(JPTRF)#                       MI78 124
sumfpha:(IPTRF) = sumfpha:(IPTRF) + sumfpha:(JPTRF)#                    MI78 125
sumalla:(IPTRF) = sumalla:(IPTRF) + sumalla:(JPTRF)#                    MI78 126
sumalfdela:(IPTRF) = sumalfdela:(IPTRF) + sumalfdela:(JPTRF)#           MI78 127
sumfazpwra:(IPTRF) = sumfazpwra:(IPTRF) + sumfazpwra:(JPTRF)#           MI78 128
sumfha:(IPTRF) = sumfha:(IPTRF) + sumfha:(JPTRF)#                       MI78 129
sumwteisoa:(IPTRF) = sumwteisoa:(IPTRF) + sumwteisoa:(JPTRF)#           MI78 130
sumwteano:(IPTRF) = sumwteano:(IPTRF) + sumwteano:(JPTRF)#              MI78 131
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI78 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI78 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI78 134
#                                                                       MI78 135
# NOW ADD TOGETHER THE BINS FOR CENTRIC AND ACENTRIC REFLECTIONS        MI78 136
#  TO OBTAIN THE SUMS FOR ALL STATISTICS.                               MI78 137
#                                                                       MI78 138
DO I=1,NFBIN1#                                                          MI78 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI78 140
DO J=1,NBIN1#                                                           MI78 141
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI78 142
DO K=2,NDATIN#                                                          MI78 143
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI78 144
L = STARS3 + (I-1)*STEPS3*(NDATIN-1)*(NBIN+1) $#                        MI78 145
+ (J-1)*STEPS3*(NDATIN-1) + (K-2)*STEPS3#                               MI78 146
#                                                                       MI78 147
sumdf:(L) = sumdf:(L) + sumdfc:(L) + sumdfa:(L)#                        MI78 148
sumfph:(L) = sumfph:(L) + sumfphc:(L) + sumfpha:(L)#                    MI78 149
sumall:(L) = sumall:(L) + sumallc:(L) + sumalla:(L)#                    MI78 150
sumalfdel:(L) = sumalfdel:(L) + sumalfdelc:(L) + sumalfdela:(L)#        MI78 151
sumfazpwr:(L) = sumfazpwr:(L) + sumfazpwrc:(L) + sumfazpwra:(L)#        MI78 152
sumfh:(L) = sumfh:(L) + sumfhc:(L) + sumfha:(L)#                        MI78 153
sumwteiso:(L) = sumwteiso:(L) + sumwteisoc:(L) + sumwteisoa:(L)#        MI78 154
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI78 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI78 156
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI78 157
#                                                                       MI78 158
# PERFORM FINAL ARITHMETIC FOR OUTPUT VALUES                            MI78 159
#                                                                       MI78 160
DO I=1,NFBIN1#                                                          MI78 161
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI78 162
DO J=1,NBIN1#                                                           MI78 163
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI78 164
DO K=2,NDATIN#                                                          MI78 165
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI78 166
L = STARS3 + (I-1)*STEPS3*(NDATIN-1)*(NBIN+1) $#                        MI78 167
+ (J-1)*STEPS3*(NDATIN-1) + (K-2)*STEPS3#                               MI78 168
#                                                                       MI78 169
IF(sumall:(L) > 0.0)#                                                   MI78 170
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI78 171
sumalfdel:(L) = (sumalfdel:(L)/sumall:(L))*DEGRAD#                      MI78 172
sumwteiso:(L) = SQRT(sumwteiso:(L)/sumall:(L))#                         MI78 173
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI78 174
# R KRAUT                                                               MI78 175
IF(sumfph:(L) > 0.0)  sumdf:(L) = sumdf:(L)/sumfph:(L)#                 MI78 176
IF(sumfh:(L) > 0.0)  sumfazpwr:(L) = sumfazpwr:(L)/sumfh:(L)#           MI78 177
IF(sumallc:(L) > 0.0)#                                                  MI78 178
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI78 179
sumalfdelc:(L) = (sumalfdelc:(L)/sumallc:(L))*DEGRAD#                   MI78 180
sumwteisoc:(L) = SQRT(sumwteisoc:(L)/sumallc:(L))#                      MI78 181
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI78 182
# R CULLIS                                                              MI78 183
IF(delisoc:(L) > 0.0)  rcul:(L) = rcul:(L)/delisoc:(L)#                 MI78 184
IF(sumfphc:(L) > 0.0)  sumdfc:(L) = sumdfc:(L)/sumfphc:(L)#             MI78 185
IF(sumfhc:(L) > 0.0)  sumfazpwrc:(L)=sumfazpwrc:(L)/sumfhc:(L)#         MI78 186
IF(sumalla:(L) > 0.0)#                                                  MI78 187
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI78 188
sumalfdela:(L) = (sumalfdela:(L)/sumalla:(L))*DEGRAD#                   MI78 189
sumwteisoa:(L) = SQRT(sumwteisoa:(L)/sumalla:(L))#                      MI78 190
sumwteano:(L) =  SQRT(sumwteano:(L)/sumalla:(L))#                       MI78 191
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI78 192
IF(sumfpha:(L) > 0.0)  sumdfa:(L) = sumdfa:(L)/sumfpha:(L)#             MI78 193
IF(sumfha:(L) > 0.0)  sumfazpwra:(L) = sumfazpwra:(L)/sumfha:(L)#       MI78 194
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI78 195
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI78 196
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI78 197
#                                                                       MI78 198
# PREPARE STATISTICAL BLOCK 5 FOR OUTPUT BY ADDING TOGETHER EACH BIN    MI78 199
#  TO GET OVERALL VALUE.                                                MI78 200
#                                                                       MI78 201
IF(FAZTYP == fazprb:)#                 Method was fazprb                MI78 202
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MI78 203
#                                                                       MI78 204
DO I=1,NFBIN#                                                           MI78 205
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MI78 206
DO J=1,NBIN#                                                            MI78 207
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MI78 208
DO K=2,NDATIN#                                                          MI78 209
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MI78 210
IPTRS = STARS5 + I*STEPS5*(NDATIN-1)*(NBIN+1) $#                        MI78 211
- STEPS5*(NDATIN-1) + (K-2)*STEPS5#                                     MI78 212
JPTRS = STARS5 + (I-1)*STEPS5*(NDATIN-1)*(NBIN+1) $#                    MI78 213
+ (J-1)*STEPS5*(NDATIN-1) + (K-2)*STEPS5#                               MI78 214
#                                                                       MI78 215
sumclosurec:(IPTRS) = sumclosurec:(IPTRS) + sumclosurec:(JPTRS)#        MI78 216
sumdifisoc:(IPTRS) = sumdifisoc:(IPTRS) + sumdifisoc:(JPTRS)#           MI78 217
sumadjcloc:(IPTRS) = sumadjcloc:(IPTRS) + sumadjcloc:(JPTRS)#           MI78 218
sumfhsqc:(IPTRS) = sumfhsqc:(IPTRS) + sumfhsqc:(JPTRS)#                 MI78 219
sumjntvarc:(IPTRS) = sumjntvarc:(IPTRS) + sumjntvarc:(JPTRS)#           MI78 220
sumclosurea:(IPTRS) = sumclosurea:(IPTRS) + sumclosurea:(JPTRS)#        MI78 221
sumdifisoa:(IPTRS) = sumdifisoa:(IPTRS) + sumdifisoa:(JPTRS)#           MI78 222
sumadjcloa:(IPTRS) = sumadjcloa:(IPTRS) + sumadjcloa:(JPTRS)#           MI78 223
sumfhsqa:(IPTRS) = sumfhsqa:(IPTRS) + sumfhsqa:(JPTRS)#                 MI78 224
sumjntvara:(IPTRS) = sumjntvara:(IPTRS) + sumjntvara:(JPTRS)#           MI78 225
sumanoclo:(IPTRS) = sumanoclo:(IPTRS) + sumanoclo:(JPTRS)#              MI78 226
sumanoadj:(IPTRS) = sumanoadj:(IPTRS) + sumanoadj:(JPTRS)#              MI78 227
sumanodif:(IPTRS) = sumanodif:(IPTRS) + sumanodif:(JPTRS)#              MI78 228
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MI78 229
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MI78 230
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MI78 231
#                                                                       MI78 232
DO I=1,NFBIN#                                                           MI78 233
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MI78 234
DO J=1,NBIN1#                                                           MI78 235
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MI78 236
DO K=2,NDATIN#                                                          MI78 237
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MI78 238
IPTRF = STARS5 + STEPS5*(NDATIN-1)*(NBIN+1)*NFBIN $#                    MI78 239
+ (J-1)*STEPS5*(NDATIN-1) + (K-2)*STEPS5#                               MI78 240
JPTRF = STARS5 + (I-1)*STEPS5*(NDATIN-1)*(NBIN+1) $#                    MI78 241
+ (J-1)*STEPS5*(NDATIN-1) + (K-2)*STEPS5#                               MI78 242
#                                                                       MI78 243
sumclosurec:(IPTRF) = sumclosurec:(IPTRF) + sumclosurec:(JPTRF)#        MI78 244
sumdifisoc:(IPTRF) = sumdifisoc:(IPTRF) + sumdifisoc:(JPTRF)#           MI78 245
sumadjcloc:(IPTRF) = sumadjcloc:(IPTRF) + sumadjcloc:(JPTRF)#           MI78 246
sumfhsqc:(IPTRF) = sumfhsqc:(IPTRF) + sumfhsqc:(JPTRF)#                 MI78 247
sumjntvarc:(IPTRF) = sumjntvarc:(IPTRF) + sumjntvarc:(JPTRF)#           MI78 248
sumclosurea:(IPTRF) = sumclosurea:(IPTRF) + sumclosurea:(JPTRF)#        MI78 249
sumdifisoa:(IPTRF) = sumdifisoa:(IPTRF) + sumdifisoa:(JPTRF)#           MI78 250
sumadjcloa:(IPTRF) = sumadjcloa:(IPTRF) + sumadjcloa:(JPTRF)#           MI78 251
sumfhsqa:(IPTRF) = sumfhsqa:(IPTRF) + sumfhsqa:(JPTRF)#                 MI78 252
sumjntvara:(IPTRF) = sumjntvara:(IPTRF) + sumjntvara:(JPTRF)#           MI78 253
sumanoclo:(IPTRF) = sumanoclo:(IPTRF) + sumanoclo:(JPTRF)#              MI78 254
sumanoadj:(IPTRF) = sumanoadj:(IPTRF) + sumanoadj:(JPTRF)#              MI78 255
sumanodif:(IPTRF) = sumanodif:(IPTRF) + sumanodif:(JPTRF)#              MI78 256
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MI78 257
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MI78 258
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MI78 259
#                                                                       MI78 260
# NOW ADD TOGETHER THE BINS FOR CENTRIC AND ACENTRIC REFLECTIONS        MI78 261
#  TO OBTAIN THE SUMS FOR ALL STATISTICS.                               MI78 262
#                                                                       MI78 263
DO I=1,NFBIN1#                                                          MI78 264
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MI78 265
DO J=1,NBIN1#                                                           MI78 266
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MI78 267
DO K=2,NDATIN#                                                          MI78 268
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MI78 269
L = STARS5 + (I-1)*STEPS5*(NDATIN-1)*(NBIN+1) $#                        MI78 270
+ (J-1)*STEPS5*(NDATIN-1) + (K-2)*STEPS5#                               MI78 271
#                                                                       MI78 272
sumclosure:(L) = sumclosure:(L) + sumclosurec:(L) + sumclosurea:(L)#    MI78 273
sumdifiso:(L) = sumdifiso:(L) + sumdifisoc:(L) + sumdifisoa:(L)#        MI78 274
sumadjclo:(L) = sumadjclo:(L) + sumadjcloc:(L) + sumadjcloa:(L)#        MI78 275
sumfhsq:(L) = sumfhsq:(L) + sumfhsqc:(L) + sumfhsqa:(L)#                MI78 276
sumjntvar:(L) = sumjntvar:(L) + sumjntvarc:(L) + sumjntvara:(L)#        MI78 277
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MI78 278
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MI78 279
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MI78 280
#                                                                       MI78 281
# CONVERT EACH BIN TO RMS VALUE                                         MI78 282
#                                                                       MI78 283
DO I=1,NFBIN1#                                                          MI78 284
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MI78 285
DO J=1,NBIN1#                                                           MI78 286
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MI78 287
DO K=2,NDATIN#                                                          MI78 288
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MI78 289
L = STARS5 + (I-1)*STEPS5*(NDATIN-1)*(NBIN+1) $#                        MI78 290
+ (J-1)*STEPS5*(NDATIN-1) + (K-2)*STEPS5#                               MI78 291
M = STARS3 + (I-1)*STEPS3*(NDATIN-1)*(NBIN+1) $#                        MI78 292
+ (J-1)*STEPS3*(NDATIN-1) + (K-2)*STEPS3#                               MI78 293
#                                                                       MI78 294
TOTAL = sumall:(M)#                                                     MI78 295
IF(TOTAL > 0.0)#                       Were there reflections           MI78 296
#                                         Measured in this bin?         MI78 297
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 MI78 298
sumclosure:(L) = SQRT(sumclosure:(L)/TOTAL)# Rms closure error          MI78 299
sumdifiso:(L) = SQRT(sumdifiso:(L)/TOTAL)# Rms isomorphous differenc    MI78 300
sumadjclo:(L) = SQRT(sumadjclo:(L)/TOTAL)# Rms adjusted closure         MI78 301
sumfhsq:(L) = SQRT(sumfhsq:(L)/TOTAL)# Rms heavy atom model squared     MI78 302
sumjntvar:(L) = SQRT(sumjntvar:(L)/TOTAL)# Rms joint variance           MI78 303
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 MI78 304
TOTAL = sumallc:(M)#                                                    MI78 305
IF(TOTAL > 0.0)#                       Were there centric refls.        MI78 306
#                                         Measured in this bin?         MI78 307
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 MI78 308
sumclosurec:(L) = SQRT(sumclosurec:(L)/TOTAL)# Rms closure error        MI78 309
sumdifisoc:(L) = SQRT(sumdifisoc:(L)/TOTAL)# Rms isomorphous differe    MI78 310
sumadjcloc:(L) = SQRT(sumadjcloc:(L)/TOTAL)# Rms adjusted closure       MI78 311
sumfhsqc:(L) = SQRT(sumfhsqc:(L)/TOTAL)# Rms heavy atom model squared   MI78 312
sumjntvarc:(L) = SQRT(sumjntvarc:(L)/TOTAL)# Rms joint variance         MI78 313
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 MI78 314
TOTAL = sumalla:(M)#                                                    MI78 315
IF(TOTAL > 0.0)#                       Were there acentric refls.       MI78 316
#                                         Measured in this bin?         MI78 317
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 MI78 318
sumclosurea:(L) = SQRT(sumclosurea:(L)/TOTAL)# Rms closure error        MI78 319
sumdifisoa:(L) = SQRT(sumdifisoa:(L)/TOTAL)# Rms isomorphous differe    MI78 320
sumadjcloa:(L) = SQRT(sumadjcloa:(L)/TOTAL)# Rms adjusted closure       MI78 321
sumfhsqa:(L) = SQRT(sumfhsqa:(L)/TOTAL)# Rms heavy atom model squared   MI78 322
sumjntvara:(L) = SQRT(sumjntvara:(L)/TOTAL)# Rms joint variance         MI78 323
sumanoclo:(L) = SQRT(sumanoclo:(L)/TOTAL)# Rms anomalous closure        MI78 324
sumanoadj:(L) = SQRT(sumanoadj:(L)/TOTAL)# Rms anom. adjusted closure   MI78 325
sumanodif:(L) = SQRT(sumanodif:(L)/TOTAL)# Rms anom. difference closu   MI78 326
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 MI78 327
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MI78 328
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MI78 329
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MI78 330
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MI78 331
RETURN#                                                                 MI78 332
END#                                                                    MI78 333
systemheader:(MI79)#                                                    MI79   1
# ################################################################## #  MI79   2
#                                                                    #  MI79   3
#                               MI79                                 #  MI79   4
#                                                                    #  MI79   5
# ################################################################## #  MI79   6
SUBROUTINE MI79(HEADER,LENGTH,NCBIN1,LEVEL)# Writes out block 2         MI79   7
#                                         Statistics and, in fazprb     MI79   8
#                                         Mode, block 4 statistics.     MI79   9
# CALLS MI81 (UTILITY ROUTINE TO DETERMINE OUTPUT PRIORITY)             MI79  10
# CALLS MI82 (UTILITY ROUTINE TO PRINT BY BINS)                         MI79  11
# CALLS MI83 (ROUTINE TO PRINT BLOCK 6 STATS)                           MI79  12
#                                        Dec 1979  s. sheriff           MI79  13
#                                        Revised jul 1980  s. sheriff   MI79  14
include:(AACOMN)#                                                       MI79  15
include:(MICOMN)#                                                       MI79  16
#                                                                       MI79  17
INTEGER IOFFST(6)#                     Offset of statistic from         MI79  18
#                                         Beginning of bin.             MI79  19
INTEGER IPRACE#                        Priority for acentrics for       MI79  20
#                                         The current statistic.        MI79  21
INTEGER IPRALL#                        Priority for "all" category      MI79  22
#                                         For the current statistic.    MI79  23
INTEGER IPRCEN#                        Priority for centrics for the    MI79  24
#                                         Current statistic.            MI79  25
INTEGER IPRIOR(6)#                     Priority to print the current    MI79  26
#                                         Statistic.                    MI79  27
INTEGER IPTR2#                         Pointer to total f**2-stol       MI79  28
#                                         Bins in qx array.             MI79  29
INTEGER IPTR4#                         Pointer to total f**2-stol       MI79  30
#                                         Bins in qx array.             MI79  31
INTEGER LENGTH#                        Length of output line for        MI79  32
#                                         Statistical blocks 2,3,4, & 5 MI79  33
INTEGER LEVEL#                         Output level for this cycle;     MI79  34
#                                         Last = 1; rest = 2.           MI79  35
INTEGER NCBIN1#                        Output control for all,          MI79  36
#                                         Centric, acentric categories. MI79  37
INTEGER NLINHD(6)#                     Key to heading on line in        MI79  38
#                                       #  Mi82; e.g., all, centric.    MI79  39
REAL FMT791(6)#                        Formats                          MI79  40
string:(HEADER,1)#                     Page heading for statistics      MI79  41
chardata:(MI791, ISOMORPH)#            M                                MI79  42
chardata:(MI792, FIGURE OF MERIT)#     M                                MI79  43
chardata:(MI793, RMS PARENT WEIGHTED ANOMALOUS CLOSURE ERROR)#          MI79  44
chardata:(MI794, RMS PARENT VARIANCE)#                                  MI79  45
chardata:(MI795, RMS PARENT ANOMALOUS CLOSURE ERROR)#                   MI79  46
chardata:(MI796, RMS PARENT ANOMALOUS CLOSURE ERROR ADJUSTED FOR $#     MI79  47
VARIANCE)#                                                              MI79  48
chardata:(MI797, RMS PARENT ANOMALOUS DIFFERENCES)#                     MI79  49
datastuff:#                                                             MI79  50
#                                                                       MI79  51
# CALCULATION OF IPTR4:                                                 MI79  52
#   SECOND TERM OFFSETS BACK TO BEGINNING OF OVERALL STOL BIN           MI79  53
#    WITHIN THE OVERALL F**2 BIN.                                       MI79  54
#                                                                       MI79  55
# ############# FORMAL PARAMETERS FOR CALLS TO MI81 ################ #  MI79  56
# THIS IS THE OUTPUT LEVEL DETERMINING UTILITY.                         MI79  57
#                                                                       MI79  58
# FORMAL                                                                MI79  59
# PARAM  NORMAL                                                         MI79  60
# NUMBER TYPE NAME USE                                                  MI79  61
#    1  REAL  OUTPUT LEVEL FOR THIS STATISTIC                           MI79  62
#    2  INT LEVEL OUTPUT LEVEL FOR THIS CYCLE; LAST = 1; REST = 2       MI79  63
#    3  INT NCBIN OUTPUT CONTROL FOR ALL, CENTRIC, ACENTRIC             MI79  64
#   CATEGORIES                                                          MI79  65
#    4  INT  SHOULD THE ACENTRICS FOR THIS STAT HAVE                    MI79  66
#   HIGHER PRIORITY                                                     MI79  67
#    5  INT  SHOULD THE CENTRICS FOR THIS STAT HAVE                     MI79  68
#   HIGHER PRIORITY                                                     MI79  69
#    6  REAL  NUMBER OF CENTRIC REFLECTIONS                             MI79  70
#    7  INT IPRALL PRIORITY FOR ALL CATEGORY FOR THIS STATISTIC         MI79  71
#    8  INT IPRCEN PRIORITY FOR CENTRICS FOR THIS STATITISTIC           MI79  72
#    9  INT IPRACE PRIORITY FOR ACENTRICS FOR THIS STATISTIC            MI79  73
#                                                                       MI79  74
#                                                                       MI79  75
# ############# FORMAL PARAMETERS FOR CALLS TO MI82 ################ #  MI79  76
#                                                                       MI79  77
# THIS IS THE UTILITY TO PRINT STATISTICS BY BINS IN TWO DIMENSIONS --  MI79  78
# SIN(THETA)/LAMBDA AND F**2.                                           MI79  79
#                                                                       MI79  80
# FORMAL                                                                MI79  81
# PARAM  NORMAL                                                         MI79  82
# NUMBER TYPE NAME USE                                                  MI79  83
#     1  INT  STAR__ STARTING POINTER IN QX ARRAY FOR THESE DATA        MI79  84
#     2  INT  STEP__ INCREMENT IN QX ARRAY FOR INFORMATION TO BE        MI79  85
#                    OUTPUT.                                            MI79  86
#     3  INT  ZERO   FOR BLOCKS 2 AND 4                                 MI79  87
#     4  INT  ONE    FOR STAT BLOCKS 2 AND 4                            MI79  88
#     5  INT  TOTAL  NUMBER OF LINES NEEDED TO PRINT THIS BLOCK         MI79  89
#                    OF STATISTICS.                                     MI79  90
#     6  CHAR MI79_  <EXPLICIT CHARACTER ARRAY> WHICH IS SUBHEADING     MI79  91
#                    FOR THESE DATA.                                    MI79  92
#     7  INT  NMI79_ NUMBER OF CHARACTERS IN SUBHEADING                 MI79  93
#     8  CHAR HEADER <EXPLICIT CHARACTER ARRAY> WHICH IS HEADING        MI79  94
#                    FOR THESE DATA.                                    MI79  95
#     9  INT  LENGTH NUMBER OF CHARACTERS IN HEADING                    MI79  96
#    10  INT  NBLOCK NUMBER OF DIFFERENT LINES OUTPUT IN EACH           MI79  97
#                    F**2 BLOCK.                                        MI79  98
#    11  INT  LENGTH LENGTH OF LINE -- NUMBER OF BLANKS TO CREATE       MI79  99
#                    IN CHROT.                                          MI79 100
#    12  INT  IOFFST ARRAY OF OFFSETS IN QX ARRAY FOR GROUP OF          MI79 101
#                    STATISTICS.                                        MI79 102
#    13  INT  NLINHD ARRAY INDEXING WHICH KEY WORD HEADS EACH LINE      MI79 103
#    14  INT  IPRIOR ARRAY OF PRIORITY LEVELS FOR GROUP OUTPUT          MI79 104
#    15  REAL FMT    ARRAY USED TO DEFINE FORMAT CONTROL                MI79 105
# ################################################################## #  MI79 106
#                                                                       MI79 107
# WRITE OUT FIGURE OF MERIT BY STOL AND F**2                            MI79 108
#                                                                       MI79 109
macro:(getoffset:,[substr:($1,6,arith:(lenstr:($1),-,6))])#             MI79 110
IPTR2 = STOPS2 - STEPS2#                                                MI79 111
# FIGURE OF MERIT                                                       MI79 112
#                                                                       MI79 113
CALL MI81(QX(STARST+2),LEVEL,NCBIN1,no:,no:,sumrefc:(IPTR2),IPRALL,$#   MI79 114
IPRCEN,IPRACE)#                                                         MI79 115
#                                                                       MI79 116
writeline:(2,0,0,3,IPRALL)#                                             MI79 117
IOFFST(1) = getoffset:(sumfom:(0))#                                     MI79 118
NLINHD(1) = 1#                                                          MI79 119
IPRIOR(1) = IPRALL#                                                     MI79 120
FMT791(1) = 32.#                                                        MI79 121
IOFFST(2) = getoffset:(sumref:(0))#                                     MI79 122
NLINHD(2) = 4#                                                          MI79 123
IPRIOR(2) = IPRALL#                                                     MI79 124
FMT791(2) = 13.#                                                        MI79 125
IOFFST(3) = getoffset:(sumfomc:(0))#                                    MI79 126
NLINHD(3) = 2#                                                          MI79 127
IPRIOR(3) = IPRCEN#                                                     MI79 128
FMT791(3) = 32.#                                                        MI79 129
IOFFST(4) = getoffset:(sumrefc:(0))#                                    MI79 130
NLINHD(4) = 4#                                                          MI79 131
IPRIOR(4) = IPRCEN#                                                     MI79 132
FMT791(4) = 13.#                                                        MI79 133
IOFFST(5) = getoffset:(sumfoma:(0))#                                    MI79 134
NLINHD(5) = 3#                                                          MI79 135
IPRIOR(5) = IPRACE#                                                     MI79 136
FMT791(5) = 32.#                                                        MI79 137
IOFFST(6) = getoffset:(sumrefa:(0))#                                    MI79 138
NLINHD(6) = 4#                                                          MI79 139
IPRIOR(6) = IPRACE#                                                     MI79 140
FMT791(6) = 13.#                                                        MI79 141
#                                                                       MI79 142
CALL MI82(STARS2,STEPS2,0,1,7,MI792,NMI792,HEADER,LENGTH,$#             MI79 143
6,LENGTH,IOFFST,NLINHD,IPRIOR,FMT791)#                                  MI79 144
#                                                                       MI79 145
IF(sumnatwteano:(IPTR2) > 0.0)#                                         MI79 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI79 147
#                                                                       MI79 148
CALL MI81(QX(STARST+8),LEVEL,NCBIN1,yes:,no:,sumrefc:(IPTR2),$#         MI79 149
IPRALL,IPRCEN,IPRACE)#                 [nat]wteano                      MI79 150
#                                                                       MI79 151
IF(LINCT < 3)  LINCT = 0#                                               MI79 152
IOFFST(1) = getoffset:(sumnatwteano:(0))#                               MI79 153
NLINHD(1) = 3#                                                          MI79 154
IPRIOR(1) = IPRACE#                                                     MI79 155
FMT791(1) = 13.#                                                        MI79 156
#                                                                       MI79 157
CALL MI82(STARS2,STEPS2,0,1,2,MI793,NMI793,HEADER,LENGTH,$#             MI79 158
1,LENGTH,IOFFST,NLINHD,IPRIOR,FMT791)#                                  MI79 159
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI79 160
#                                                                       MI79 161
# WRITE OUT INFORMATION IN STATISTICAL BLOCK 4                          MI79 162
#                                                                       MI79 163
IF(FAZTYP == fazprb:)#                                                  MI79 164
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI79 165
IPTR4 = STOPS4 - STEPS4#                                                MI79 166
#                                                                       MI79 167
CALL MI81(QX(STARST+3),LEVEL,NCBIN1,no:,no:,sumrefc:(IPTR2),$#          MI79 168
IPRALL,IPRCEN,IPRACE)#                 Parvar                           MI79 169
#                                                                       MI79 170
writeline:(2,0,0,3,3)#                                                  MI79 171
LINCT = 0#                             Force new page                   MI79 172
movechar:(MI791,1,CHROT,1,NMI791,0)#                                    MI79 173
movertoc:(QX(STARDN+1),1,CHROT,11,12,0)#                                MI79 174
writeline:(0,HEADER,LENGTH,1,IPRALL)#                                   MI79 175
IOFFST(1) = getoffset:(sumvar:(0))#                                     MI79 176
NLINHD(1) = 1#                                                          MI79 177
IPRIOR(1) = IPRALL#                                                     MI79 178
FMT791(1) = 13.#                                                        MI79 179
IOFFST(2) = getoffset:(sumvarc:(0))#                                    MI79 180
NLINHD(2) = 2#                                                          MI79 181
IPRIOR(2) = IPRCEN#                                                     MI79 182
FMT791(2) = 13.#                                                        MI79 183
IOFFST(3) = getoffset:(sumvara:(0))#                                    MI79 184
NLINHD(3) = 3#                                                          MI79 185
IPRIOR(3) = IPRACE#                                                     MI79 186
FMT791(3) = 13.#                                                        MI79 187
#                                                                       MI79 188
CALL MI82(STARS4,STEPS4,0,1,4,MI794,NMI794,HEADER,LENGTH,$#             MI79 189
3,LENGTH,IOFFST,NLINHD,IPRIOR,FMT791)#                                  MI79 190
#                                                                       MI79 191
IF(sumnatanodif:(IPTR4) > 0.0)#                                         MI79 192
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI79 193
#                                                                       MI79 194
CALL MI81(QX(STARST+16),LEVEL,NCBIN1,yes:,no:,sumrefc:(IPTR2),$#        MI79 195
IPRALL,IPRCEN,IPRACE)#                 Ermsano                          MI79 196
#                                                                       MI79 197
IF(LINCT < 3)  LINCT = 0#                                               MI79 198
IOFFST(1) = getoffset:(sumnatanoclo:(0))#                               MI79 199
NLINHD(1)=3#                                                            MI79 200
IPRIOR(1) = IPRACE#                                                     MI79 201
FMT791(1) = 13.#                                                        MI79 202
#                                                                       MI79 203
CALL MI82(STARS4,STEPS4,0,1,2,MI795,NMI795,HEADER,LENGTH,$#             MI79 204
1,LENGTH,IOFFST,NLINHD,IPRIOR,FMT791)#                                  MI79 205
#                                                                       MI79 206
CALL MI81(QX(STARST+17),LEVEL,NCBIN1,yes:,no:,sumrefc:(IPTR2), $#       MI79 207
IPRALL,IPRCEN,IPRACE)#                 Eanoadj                          MI79 208
#                                                                       MI79 209
IF(LINCT < 3)  LINCT = 0#                                               MI79 210
IOFFST(1) = getoffset:(sumnatanoadj:(0))#                               MI79 211
NLINHD(1) = 3#                                                          MI79 212
IPRIOR(1) = IPRACE#                                                     MI79 213
FMT791(1) = 13.#                                                        MI79 214
#                                                                       MI79 215
CALL MI82(STARS4,STEPS4,0,1,2,MI796,NMI796,HEADER,LENGTH,$#             MI79 216
1,LENGTH,IOFFST,NLINHD,IPRIOR,FMT791)#                                  MI79 217
#                                                                       MI79 218
CALL MI81(QX(STARST+18),LEVEL,NCBIN1,yes:,no:,sumrefc:(IPTR2), $#       MI79 219
IPRALL,IPRCEN,IPRACE)#                 Anodif                           MI79 220
#                                                                       MI79 221
IF(LINCT < 3)  LINCT = 0#                                               MI79 222
IOFFST(1) = getoffset:(sumnatanodif:(0))#                               MI79 223
NLINHD(1) = 3#                                                          MI79 224
IPRIOR(1) = IPRACE#                                                     MI79 225
FMT791(1) = 13.#                                                        MI79 226
#                                                                       MI79 227
CALL MI82(STARS4,STEPS4,0,1,2,MI797,NMI797,HEADER,LENGTH,$#             MI79 228
1,LENGTH,IOFFST,NLINHD,IPRIOR,FMT791)#                                  MI79 229
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI79 230
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI79 231
#                                                                       MI79 232
# WRITE OUT INFORMATION IN STAT BLOCK 6                                 MI79 233
#                                                                       MI79 234
IF((signsame:(STARS6) > 0.0) \ (signopp:(STARS6) > 0.0))#               MI79 235
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI79 236
#                                                                       MI79 237
CALL MI81(QX(STARST+19),LEVEL,NCBIN1,no:,no:,sumrefc:(IPTR2), $#        MI79 238
IPRALL,IPRCEN,IPRACE)#                 Signs                            MI79 239
#                                                                       MI79 240
CALL MI83(signsame:(STARS6),signopp:(STARS6),signzero:(STARS6),IPRACE)# MI79 241
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI79 242
RETURN#                                                                 MI79 243
END#                                                                    MI79 244
pmacro:([z:])#                                                          MI79 245
systemheader:(MI80)#                                                    MI80   1
# ################################################################## #  MI80   2
#                                                                    #  MI80   3
#                               MI80                                 #  MI80   4
#                                                                    #  MI80   5
# ################################################################## #  MI80   6
SUBROUTINE MI80(HEADER,LENGTH,NCBIN1,LEVEL)# Writes out block 3         MI80   7
#                                         Statistics and, in fazprb     MI80   8
#                                         Mode, block 5 statistics.     MI80   9
#                                        Called by mi75                 MI80  10
# CALLS MI81 (UTILITY ROUTINE TO DETERMINE OUTPUT PRIORITY)             MI80  11
# CALLS MI82 (UTILITY ROUTINE TO PRINT BY BINS)                         MI80  12
# CALLS MI83 (ROUTINE TO PRINT BLOCK 6 STATS)                           MI80  13
#                                        Dec 1979  s. sheriff           MI80  14
#                                        Revised jul 1980  s. sheriff   MI80  15
include:(AACOMN)#                                                       MI80  16
include:(MICOMN)#                                                       MI80  17
include:(MIMAC1)#                                                       MI80  18
include:(MIMAC3)#                                                       MI80  19
include:(MIMAC6)#                                                       MI80  20
include:(MIMAC7)#                                                       MI80  21
#                                                                       MI80  22
INTEGER IDAT#                          Current data set number          MI80  23
#                                         Minus two.                    MI80  24
INTEGER IOFFST(3)#                     Offset of statistic from         MI80  25
#                                         Beginning of bin.             MI80  26
INTEGER IPRACE#                        Priority for acentrics for the   MI80  27
#                                         Current statistic.            MI80  28
INTEGER IPRALL#                        Priority for "all" category      MI80  29
#                                         For the current statistic.    MI80  30
INTEGER IPRCEN#                        Priority for centrics for the    MI80  31
#                                         Current statistic.            MI80  32
INTEGER IPRIOR(3)#                     Priority to print the current    MI80  33
#                                         Statistic.                    MI80  34
INTEGER IPTR3#                         Pointer to overall f**2-stol     MI80  35
#                                         Bin.                          MI80  36
INTEGER IPTR5#                         Pointer to overall f**2-stol     MI80  37
#                                         Bin.                          MI80  38
INTEGER IPTR6#                         Pointer to particular isomorph   MI80  39
#                                         In statistics block 6.        MI80  40
INTEGER K#                             Loop index                       MI80  41
INTEGER LENGTH#                        Length of output line for        MI80  42
#                                         Statistical blocks 2,3,4, & 5 MI80  43
INTEGER LEVEL#                         Output level for this cycle;     MI80  44
#                                         Last = 1; rest = 2.           MI80  45
INTEGER NAME#                          Pointer to data set name         MI80  46
INTEGER NCBIN1#                        Output control for all,          MI80  47
#                                         Centric, acentric categories. MI80  48
INTEGER NLINHD(3)#                     Key to heading on line in        MI80  49
#                                         Mi82; e.g., all, centric.     MI80  50
INTEGER NUMDAT#                        Total number of data sets        MI80  51
#                                         Minus one.                    MI80  52
REAL FMT801(3)#                        Formats                          MI80  53
string:(HEADER,1)#                     Page heading for statistics      MI80  54
chardata:(MI801, ISOMORPH)#                                             MI80  55
chardata:(MI802, RCULLIS -- ABS(ABS(FPHOBS+/-FP)-FH)/$#                 MI80  56
/ABS(FPHOBS-FP))#                                                       MI80  57
chardata:(MI803, RKRAUT -- ABS(FPHOBS-FPHCALC)/FPHOBS)#                 MI80  58
chardata:(MI804, ERROR/FH -- (FPHOBS-FPHCALC)/FH)#                      MI80  59
chardata:(MI805, NUMBER OF REFLECTIONS FOR THIS ISOMORPH)#              MI80  60
chardata:(MI806, PHASE OF PARENT MINUS PHASE OF HEAVY ATOM MODEL $#     MI80  61
(IN DEGREES))#                                                          MI80  62
chardata:(MI807, RMS WEIGHTED ISOMORPHOUS CLOSURE ERROR)#               MI80  63
chardata:(MI808, RMS WEIGHTED ANOMALOUS CLOSURE ERROR)#                 MI80  64
chardata:(MI809, RMS CLOSURE ERROR)#                                    MI80  65
chardata:(MI80A, RMS CLOSURE ERROR ADJUSTED FOR VARIANCES)#             MI80  66
chardata:(MI80B, RMS ISOMORPHOUS DIFFERENCES)#                          MI80  67
chardata:(MI80C, RMS HEAVY ATOM MODEL CONTRIBUTION)#                    MI80  68
chardata:(MI80D, RMS JOINT VARIANCE OF PARENT AND ISOMORPH)#            MI80  69
chardata:(MI80E, RMS ANOMALOUS CLOSURE ERROR)#                          MI80  70
chardata:(MI80F, RMS ANOMALOUS CLOSURE ERROR ADJUSTED FOR VARIANCES)#   MI80  71
chardata:(MI80G, RMS ANOMALOUS DIFFERENCES)#                            MI80  72
datastuff:#                                                             MI80  73
#                                                                       MI80  74
# CALCULATION OF POINTERS:                                              MI80  75
#                                                                       MI80  76
# CALCULATION OF IPTR3 AND IPTR5:                                       MI80  77
#   SECOND TERM OFFSETS BACK TO BEGINNING OF OVERALL STOL BIN           MI80  78
#    WITHIN THE OVERALL F**2 BIN.                                       MI80  79
#   THIRD TERM OFFSETS TO ISOMORPH.                                     MI80  80
#                                                                       MI80  81
# CALCULATION OF IPTR6:                                                 MI80  82
#   SECOND TERM LOCATES APPROPRIATE ISOMORPH.                           MI80  83
#                                                                       MI80  84
# ############# FORMAL PARAMETERS FOR CALLS TO MI81 ################ #  MI80  85
#                                                                       MI80  86
# THIS IS THE OUTPUT LEVEL DETERMINING UTILITY.                         MI80  87
#                                                                       MI80  88
# FORMAL                                                                MI80  89
# PARAM  NORMAL                                                         MI80  90
# NUMBER TYPE NAME USE                                                  MI80  91
#    1  REAL  OUTPUT LEVEL FOR THIS STATISTIC                           MI80  92
#    2  INT LEVEL OUTPUT LEVEL FOR THIS CYCLE; LAST = 1; REST = 2       MI80  93
#    3  INT NCBIN OUTPUT CONTROL FOR ALL, CENTRIC, ACENTRIC             MI80  94
#   CATEGORIES                                                          MI80  95
#    4  INT  SHOULD THE ACENTRICS FOR THIS STAT HAVE                    MI80  96
#   HIGHER PRIORITY                                                     MI80  97
#    5  INT  SHOULD THE CENTRICS FOR THIS STAT HAVE                     MI80  98
#   HIGHER PRIORITY                                                     MI80  99
#    6  REAL  NUMBER OF CENTRIC REFLECTIONS                             MI80 100
#    7  INT IPRALL PRIORITY FOR ALL CATEGORY FOR THIS STATISTIC         MI80 101
#    8  INT IPRCEN PRIORITY FOR CENTRICS FOR THIS STATITISTIC           MI80 102
#    9  INT IPRACE PRIORITY FOR ACENTRICS FOR THIS STATISTIC            MI80 103
#                                                                       MI80 104
#                                                                       MI80 105
# ############# FORMAL PARAMETERS FOR CALLS TO MI82 ################ #  MI80 106
#                                                                       MI80 107
# THIS IS THE UTILITY TO PRINT STATISTICS BY BINS IN TWO DIMENSIONS --  MI80 108
# SIN(THETA)/LAMBDA AND F**2.                                           MI80 109
#                                                                       MI80 110
# FORMAL                                                                MI80 111
# PARAM  NORMAL                                                         MI80 112
# NUMBER TYPE NAME USE                                                  MI80 113
#     1  INT STAR__ STARTING POINTER IN QX ARRAY FOR THIS DATA          MI80 114
#     2  INT STEP__ INCREMENT IN QX ARRAY FOR INFORMATION TO BE         MI80 115
#   OUTPUT                                                              MI80 116
#     3  INT IDAT CURRENT DATASET NUMBER MINUS TWO FOR BLOCKS           MI80 117
#   3 AND 5                                                             MI80 118
#     4  INT NUMDAT NUMBER OF DATA SETS MINUS ONE FOR STAT BLOCKS       MI80 119
#   3 AND 5                                                             MI80 120
#     5  INT  TOTAL NUMBER OF LINES NEEDED TO PRINT THIS                MI80 121
#   BLOCK OF STATISTICS                                                 MI80 122
#     6  CHAR MI80_ <EXPLICIT CHARACTER ARRAY> WHICH IS SUBHEADING      MI80 123
#   FOR THIS DATA                                                       MI80 124
#     7  INT NMI80_ NUMBER OF CHARACTERS IN SUBHEADING                  MI80 125
#     8  CHAR HEADER <EXPLICIT CHARACTER ARRAY> WHICH IS HEADING        MI80 126
#   FOR THIS DATA                                                       MI80 127
#     9  INT LENGTH NUMBER OF CHARACTERS IN HEADING                     MI80 128
#    10  INT  NUMBER OF DIFFERENT LINES OUTPUT IN EACH                  MI80 129
#   F**2 BLOCK                                                          MI80 130
#    11  INT LENGTH LENGTH OF LINE -- NUMBER OF BLANKS TO CREATE        MI80 131
#   IN CHROT                                                            MI80 132
#    12  INT IOFFST ARRAY OF OFFSETS IN QX ARRAY FOR GROUP OF           MI80 133
#   STATISTICS                                                          MI80 134
#    13  INT NLINHD ARRAY INDEXING WHICH KEY WORD HEADS EACH LINE       MI80 135
#    14  INT IPRIOR ARRAY OF PRIORITY LEVELS FOR GROUP OUTPUT           MI80 136
#    15  REAL FMT ARRAY USED TO DEFINE FORMAT CONTROL                   MI80 137
# ################################################################## #  MI80 138
#                                                                       MI80 139
macro:(getoffset:,[substr:($1,6,arith:(lenstr:($1),-,6))])#             MI80 140
NUMDAT = NDATIN - 1#                                                    MI80 141
NAME = STARDN + 1#                     Get index to isomorph            MI80 142
#                                         (data set name).              MI80 143
DO K=2,NDATIN#                                                          MI80 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI80 145
NAME = NAME + STEPDN#                                                   MI80 146
IDAT = K - 2#                                                           MI80 147
IPTR3 = STOPS3 - STEPS3*(NDATIN-1) + (K-2)*STEPS3#                      MI80 148
IPTR5 = STOPS5 - STEPS5*(NDATIN-1) + (K-2)*STEPS5#                      MI80 149
IPTR6 = STARS6 + (K-1)*STEPS6#                                          MI80 150
#                                                                       MI80 151
CALL MI81(QX(STARST+4),LEVEL,NCBIN1,no:,yes:,sumallc:(IPTR3),$#         MI80 152
IPRALL,IPRCEN,IPRACE)#                 Rcullis                          MI80 153
IF(LINCT < 6)  LINCT = 0#                                               MI80 154
movechar:(MI801,1,CHROT,1,NMI801,0)#   Write out isomorph               MI80 155
movertoc:(QX(NAME),1,CHROT,11,12,0)#   Name                             MI80 156
writeline:(2,HEADER,LENGTH,1,3)#                                        MI80 157
#                                                                       MI80 158
IOFFST(1) = getoffset:(rcul:(0))#                                       MI80 159
NLINHD(1) = 2#                                                          MI80 160
IPRIOR(1) = IPRCEN#                                                     MI80 161
FMT801(1) = 32.#                                                        MI80 162
#                                                                       MI80 163
CALL MI82(STARS3,STEPS3,IDAT,NUMDAT,2,MI802,NMI802,HEADER,LENGTH,$#     MI80 164
1,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                                  MI80 165
#                                                                       MI80 166
CALL MI81(QX(STARST+5),LEVEL,NCBIN1,no:,no:,sumallc:(IPTR3),$#          MI80 167
IPRALL,IPRCEN,IPRACE)#                 Rkraut                           MI80 168
#                                                                       MI80 169
IF(LINCT < 5)  LINCT = 0#                                               MI80 170
IOFFST(1) = getoffset:(sumdf:(0))#                                      MI80 171
NLINHD(1) = 1#                                                          MI80 172
IPRIOR(1) = IPRALL#                                                     MI80 173
FMT801(1) = 32.#                                                        MI80 174
IOFFST(2) = getoffset:(sumdfc:(0))#                                     MI80 175
NLINHD(2) = 2#                                                          MI80 176
IPRIOR(2) = IPRCEN#                                                     MI80 177
FMT801(2) = 32.#                                                        MI80 178
IOFFST(3) = getoffset:(sumdfa:(0))#                                     MI80 179
NLINHD(3) = 3#                                                          MI80 180
IPRIOR(3) = IPRACE#                                                     MI80 181
FMT801(3) = 32.#                                                        MI80 182
#                                                                       MI80 183
CALL MI82(STARS3,STEPS3,IDAT,NUMDAT,4,MI803,NMI803,HEADER,LENGTH,$#     MI80 184
3,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                                  MI80 185
#                                                                       MI80 186
CALL MI81(QX(STARST+6),LEVEL,NCBIN1,no:,no:,sumallc:(IPTR3),$#          MI80 187
IPRALL,IPRCEN,IPRACE)#                 Error/f(heavy)                   MI80 188
#                                                                       MI80 189
IF(LINCT < 5)  LINCT = 0#                                               MI80 190
IOFFST(1) = getoffset:(sumfazpwr:(0))#                                  MI80 191
NLINHD(1) = 1#                                                          MI80 192
IPRIOR(1) = IPRALL#                                                     MI80 193
FMT801(1) = 32.#                                                        MI80 194
IOFFST(2) = getoffset:(sumfazpwrc:(0))#                                 MI80 195
NLINHD(2) = 2#                                                          MI80 196
IPRIOR(2) = IPRCEN#                                                     MI80 197
FMT801(2) = 32.#                                                        MI80 198
IOFFST(3) = getoffset:(sumfazpwra:(0))#                                 MI80 199
NLINHD(3) = 3#                                                          MI80 200
IPRIOR(3) = IPRACE#                                                     MI80 201
FMT801(3) = 32.#                                                        MI80 202
#                                                                       MI80 203
CALL MI82(STARS3,STEPS3,IDAT,NUMDAT,4,MI804,NMI804,HEADER,LENGTH,$#     MI80 204
3,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                                  MI80 205
#                                                                       MI80 206
CALL MI81(QX(STARST+7),LEVEL,NCBIN1,no:,no:,sumallc:(IPTR3),$#          MI80 207
IPRALL,IPRCEN,IPRACE)#                 Wteiso                           MI80 208
#                                                                       MI80 209
IF(LINCT < 5)  LINCT = 0#                                               MI80 210
IOFFST(1) = getoffset:(sumwteiso:(0))#                                  MI80 211
NLINHD(1) = 1#                                                          MI80 212
IPRIOR(1) = IPRALL#                                                     MI80 213
FMT801(1) = 32.#                                                        MI80 214
IOFFST(2) = getoffset:(sumwteisoc:(0))#                                 MI80 215
NLINHD(2) = 2#                                                          MI80 216
IPRIOR(2) = IPRCEN#                                                     MI80 217
FMT801(2) = 32.#                                                        MI80 218
IOFFST(3) = getoffset:(sumwteisoa:(0))#                                 MI80 219
NLINHD(3) = 3#                                                          MI80 220
IPRIOR(3) = IPRACE#                                                     MI80 221
FMT801(3) = 32.#                                                        MI80 222
#                                                                       MI80 223
CALL MI82(STARS3,STEPS3,IDAT,NUMDAT,4,MI807,NMI807,HEADER,LENGTH,$#     MI80 224
3,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                                  MI80 225
#                                                                       MI80 226
CALL MI81(QX(STARST+8),LEVEL,NCBIN1,yes:,no:,sumallc:(IPTR3),$#         MI80 227
IPRALL,IPRCEN,IPRACE)#                 Wteano                           MI80 228
#                                                                       MI80 229
IF(LINCT < 3) LINCT = 0#                                                MI80 230
IOFFST(1) = getoffset:(sumwteano:(0))#                                  MI80 231
NLINHD(1) = 1#                                                          MI80 232
IPRIOR(1) = IPRACE#                                                     MI80 233
FMT801(1) = 32.#                                                        MI80 234
#                                                                       MI80 235
CALL MI82(STARS3,STEPS3,IDAT,NUMDAT,2,MI808,NMI808,HEADER,LENGTH,$#     MI80 236
1,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                                  MI80 237
#                                                                       MI80 238
CALL MI81(QX(STARST+9),LEVEL,NCBIN1,no:,no:,sumallc:(IPTR3),$#          MI80 239
IPRALL,IPRCEN,IPRACE)#                 Number                           MI80 240
#                                                                       MI80 241
IF(LINCT < 5)  LINCT = 0#                                               MI80 242
IOFFST(1) = getoffset:(sumall:(0))#                                     MI80 243
NLINHD(1) = 1#                                                          MI80 244
IPRIOR(1) = IPRALL#                                                     MI80 245
FMT801(1) = 13.#                                                        MI80 246
IOFFST(2) = getoffset:(sumallc:(0))#                                    MI80 247
NLINHD(2) = 2#                                                          MI80 248
IPRIOR(2) = IPRCEN#                                                     MI80 249
FMT801(2) = 13.#                                                        MI80 250
IOFFST(3) = getoffset:(sumalla:(0))#                                    MI80 251
NLINHD(3) = 3#                                                          MI80 252
IPRIOR(3) = IPRACE#                                                     MI80 253
FMT801(3) = 13.#                                                        MI80 254
#                                                                       MI80 255
CALL MI82(STARS3,STEPS3,IDAT,NUMDAT,4,MI805,NMI805,HEADER,LENGTH,$#     MI80 256
3,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                                  MI80 257
#                                                                       MI80 258
CALL MI81(QX(STARST+10),LEVEL,NCBIN1,no:,no:,sumallc:(IPTR3),$#         MI80 259
IPRALL,IPRCEN,IPRACE)#                 Fazdif                           MI80 260
#                                                                       MI80 261
IF(LINCT < 5)  LINCT = 0#                                               MI80 262
IOFFST(1) = getoffset:(sumalfdel:(0))#                                  MI80 263
NLINHD(1) = 1#                                                          MI80 264
IPRIOR(1) = IPRALL#                                                     MI80 265
FMT801(1) = 12.#                                                        MI80 266
IOFFST(2) = getoffset:(sumalfdelc:(0))#                                 MI80 267
NLINHD(2) = 2#                                                          MI80 268
IPRIOR(2) = IPRCEN#                                                     MI80 269
FMT801(2) = 12.#                                                        MI80 270
IOFFST(3) = getoffset:(sumalfdela:(0))#                                 MI80 271
NLINHD(3) = 3#                                                          MI80 272
IPRIOR(3) = IPRACE#                                                     MI80 273
FMT801(3) = 12.#                                                        MI80 274
#                                                                       MI80 275
CALL MI82(STARS3,STEPS3,IDAT,NUMDAT,4,MI806,NMI806,HEADER,LENGTH,$#     MI80 276
3,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                                  MI80 277
#                                                                       MI80 278
IF(FAZTYP == fazprb:)#                 Method was fazprb                MI80 279
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI80 280
#                                                                       MI80 281
CALL MI81(QX(STARST+11),LEVEL,NCBIN1,no:,yes:,sumallc:(IPTR3),$#        MI80 282
IPRALL,IPRCEN,IPRACE)#                 Ermsiso                          MI80 283
#                                                                       MI80 284
IF(LINCT < 5)  LINCT = 0#                                               MI80 285
IOFFST(1) = getoffset:(sumclosure:(0))#                                 MI80 286
NLINHD(1) = 1#                                                          MI80 287
IPRIOR(1) = IPRALL#                                                     MI80 288
FMT801(1) = 13.#                                                        MI80 289
IOFFST(2) = getoffset:(sumclosurec:(0))#                                MI80 290
NLINHD(2) = 2#                                                          MI80 291
IPRIOR(2) = IPRCEN#                                                     MI80 292
FMT801(2) = 13.#                                                        MI80 293
IOFFST(3) = getoffset:(sumclosurea:(0))#                                MI80 294
NLINHD(3) = 3#                                                          MI80 295
IPRIOR(3) = IPRACE#                                                     MI80 296
FMT801(3) = 13.#                                                        MI80 297
#                                                                       MI80 298
CALL MI82(STARS5,STEPS5,IDAT,NUMDAT,4,MI809,NMI809,HEADER,$#            MI80 299
LENGTH,3,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                           MI80 300
#                                                                       MI80 301
CALL MI81(QX(STARST+12),LEVEL,NCBIN1,no:,yes:,sumallc:(IPTR3),$#        MI80 302
IPRALL,IPRCEN,IPRACE)#                 Eisoadj                          MI80 303
#                                                                       MI80 304
IF(LINCT < 5)  LINCT = 0#                                               MI80 305
IOFFST(1) = getoffset:(sumadjclo:(0))#                                  MI80 306
NLINHD(1) = 1#                                                          MI80 307
IPRIOR(1) = IPRALL#                                                     MI80 308
FMT801(1) = 13.#                                                        MI80 309
IOFFST(2) = getoffset:(sumadjcloc:(0))#                                 MI80 310
NLINHD(2) = 2#                                                          MI80 311
IPRIOR(2) = IPRCEN#                                                     MI80 312
FMT801(2) = 13.#                                                        MI80 313
IOFFST(3) = getoffset:(sumadjcloa:(0))#                                 MI80 314
NLINHD(3) = 3#                                                          MI80 315
IPRIOR(3) = IPRACE#                                                     MI80 316
FMT801(3) = 13.#                                                        MI80 317
#                                                                       MI80 318
CALL MI82(STARS5,STEPS5,IDAT,NUMDAT,4,MI80A,NMI80A,HEADER,$#            MI80 319
LENGTH,3,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                           MI80 320
#                                                                       MI80 321
CALL MI81(QX(STARST+13),LEVEL,NCBIN1,no:,no:,sumallc:(IPTR3),$#         MI80 322
IPRALL,IPRCEN,IPRACE)#                 Isodif                           MI80 323
#                                                                       MI80 324
IF(LINCT < 5)  LINCT = 0#                                               MI80 325
IOFFST(1) = getoffset:(sumdifiso:(0))#                                  MI80 326
NLINHD(1) = 1#                                                          MI80 327
IPRIOR(1) = IPRALL#                                                     MI80 328
FMT801(1) = 13.#                                                        MI80 329
IOFFST(2) = getoffset:(sumdifisoc:(0))#                                 MI80 330
NLINHD(2) = 2#                                                          MI80 331
IPRIOR(2) = IPRCEN#                                                     MI80 332
FMT801(2) = 13.#                                                        MI80 333
IOFFST(3) = getoffset:(sumdifisoa:(0))#                                 MI80 334
NLINHD(3) = 3#                                                          MI80 335
IPRIOR(3) = IPRACE#                                                     MI80 336
FMT801(3) = 13.#                                                        MI80 337
#                                                                       MI80 338
CALL MI82(STARS5,STEPS5,IDAT,NUMDAT,4,MI80B,NMI80B,HEADER,$#            MI80 339
LENGTH,3,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                           MI80 340
#                                                                       MI80 341
CALL MI81(QX(STARST+14),LEVEL,NCBIN1,no:,no:,sumallc:(IPTR3),$#         MI80 342
IPRALL,IPRCEN,IPRACE)#                 Hamodel                          MI80 343
#                                                                       MI80 344
IF(LINCT < 5)  LINCT = 0#                                               MI80 345
IOFFST(1) = getoffset:(sumfhsq:(0))#                                    MI80 346
NLINHD(1) = 1#                                                          MI80 347
IPRIOR(1) = IPRALL#                                                     MI80 348
FMT801(1) = 13.#                                                        MI80 349
IOFFST(2) = getoffset:(sumfhsqc:(0))#                                   MI80 350
NLINHD(2) = 2#                                                          MI80 351
IPRIOR(2) = IPRCEN#                                                     MI80 352
FMT801(2) = 13.#                                                        MI80 353
IOFFST(3) = getoffset:(sumfhsqa:(0))#                                   MI80 354
NLINHD(3) = 3#                                                          MI80 355
IPRIOR(3) = IPRACE#                                                     MI80 356
FMT801(3) = 13.#                                                        MI80 357
#                                                                       MI80 358
CALL MI82(STARS5,STEPS5,IDAT,NUMDAT,4,MI80C,NMI80C,HEADER,$#            MI80 359
LENGTH,3,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                           MI80 360
#                                                                       MI80 361
CALL MI81(QX(STARST+15),LEVEL,NCBIN1,no:,no:,sumallc:(IPTR3),$#         MI80 362
IPRALL,IPRCEN,IPRACE)#                 Jntvar                           MI80 363
#                                                                       MI80 364
IF(LINCT < 5)  LINCT = 0#                                               MI80 365
IOFFST(1) = getoffset:(sumjntvar:(0))#                                  MI80 366
NLINHD(1) = 1#                                                          MI80 367
IPRIOR(1) = IPRALL#                                                     MI80 368
FMT801(1) = 13.#                                                        MI80 369
IOFFST(2) = getoffset:(sumjntvarc:(0))#                                 MI80 370
NLINHD(2) = 2#                                                          MI80 371
IPRIOR(2) = IPRCEN#                                                     MI80 372
FMT801(2) = 13.#                                                        MI80 373
IOFFST(3) = getoffset:(sumjntvara:(0))#                                 MI80 374
NLINHD(3) = 3#                                                          MI80 375
IPRIOR(3) = IPRACE#                                                     MI80 376
FMT801(3) = 13.#                                                        MI80 377
#                                                                       MI80 378
CALL MI82(STARS5,STEPS5,IDAT,NUMDAT,4,MI80D,NMI80D,HEADER,$#            MI80 379
LENGTH,3,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                           MI80 380
#                                                                       MI80 381
IF(sumanodif:(IPTR5) > 0.0)#                                            MI80 382
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI80 383
#                                                                       MI80 384
CALL MI81(QX(STARST+16),LEVEL,NCBIN1,yes:,no:, $#                       MI80 385
sumallc:(IPTR3),IPRALL,IPRCEN,IPRACE)# Ermsano                          MI80 386
#                                                                       MI80 387
IF(LINCT < 3)  LINCT = 0#                                               MI80 388
IOFFST(1) = getoffset:(sumanoclo:(0))#                                  MI80 389
NLINHD(1) = 3#                                                          MI80 390
IPRIOR(1) = IPRACE#                                                     MI80 391
FMT801(1) = 13.#                                                        MI80 392
#                                                                       MI80 393
CALL MI82(STARS5,STEPS5,IDAT,NUMDAT,2,MI80E,NMI80E,HEADER,$#            MI80 394
LENGTH,1,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                           MI80 395
#                                                                       MI80 396
CALL MI81(QX(STARST+17),LEVEL,NCBIN1,yes:,no:, $#                       MI80 397
sumallc:(IPTR3),IPRALL,IPRCEN,IPRACE)# Eanoadj                          MI80 398
#                                                                       MI80 399
IF(LINCT < 3)  LINCT = 0#                                               MI80 400
IOFFST(1) = getoffset:(sumanoadj:(0))#                                  MI80 401
NLINHD(1) = 3#                                                          MI80 402
IPRIOR(1) = IPRACE#                                                     MI80 403
FMT801(1) = 13.#                                                        MI80 404
#                                                                       MI80 405
CALL MI82(STARS5,STEPS5,IDAT,NUMDAT,2,MI80F,NMI80F,HEADER,$#            MI80 406
LENGTH,1,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                           MI80 407
#                                                                       MI80 408
CALL MI81(QX(STARST+18),LEVEL,NCBIN1,yes:,no:, $#                       MI80 409
sumallc:(IPTR3),IPRALL,IPRCEN,IPRACE)# Anodif                           MI80 410
#                                                                       MI80 411
IF(LINCT < 3)  LINCT = 0#                                               MI80 412
IOFFST(1) = getoffset:(sumanodif:(0))#                                  MI80 413
NLINHD(1) = 3#                                                          MI80 414
IPRIOR(1) = IPRACE#                                                     MI80 415
FMT801(1) = 13.#                                                        MI80 416
#                                                                       MI80 417
CALL MI82(STARS5,STEPS5,IDAT,NUMDAT,2,MI80G,NMI80G,HEADER,$#            MI80 418
LENGTH,1,LENGTH,IOFFST,NLINHD,IPRIOR,FMT801)#                           MI80 419
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI80 420
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI80 421
#                                                                       MI80 422
# STAT BLOCK 6 MAY BE FROM EITHER METHOD                                MI80 423
# DO NOT MOVE INSIDE REFTYP BLOCK                                       MI80 424
#                                                                       MI80 425
IF((signsame:(IPTR6) > 0.0) \ (signopp:(IPTR6) > 0.0))#                 MI80 426
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI80 427
#                                                                       MI80 428
CALL MI81(QX(STARST+19),LEVEL,NCBIN1,yes:,no:,sumallc:(IPTR3),$#        MI80 429
IPRALL,IPRCEN,IPRACE)#                 Signs                            MI80 430
#                                                                       MI80 431
CALL MI83(signsame:(IPTR6),signopp:(IPTR6),signzero:(IPTR6),IPRACE)#    MI80 432
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI80 433
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI80 434
RETURN#                                                                 MI80 435
END#                                                                    MI80 436
xmacro:([getoffset:])#                                                  MI80 437
systemheader:(MI81)#                                                    MI81   1
# ################################################################## #  MI81   2
#                                                                    #  MI81   3
#                               MI81                                 #  MI81   4
#                                                                    #  MI81   5
# ################################################################## #  MI81   6
SUBROUTINE MI81(STAT,LEVEL,NCBIN1,IACCHK,ICECHK,CENNUM,IPRALL,$#        MI81   7
IPRCEN,IPRACE)#                        Decide on output priorities      MI81   8
#                                                                       MI81   9
#                                        Called from mi76,mi79,mi80     MI81  10
#                                        Jul 1980  s. sheriff           MI81  11
#                                                                       MI81  12
INTEGER IACCHK#                        Should the acentrics for this    MI81  13
#                                         Stat. have higher priority?   MI81  14
INTEGER ICECHK#                        Should the centrics for this     MI81  15
#                                         Stat. have higher priority?   MI81  16
INTEGER IPRACE#                        Priority for acentrics for       MI81  17
#                                         This statistic.               MI81  18
INTEGER IPRALL#                        Priority for "all" category      MI81  19
#                                         For this statistic.           MI81  20
INTEGER IPRCEN#                        Priority for centrics for this   MI81  21
INTEGER JSTAT#                         Output level for this stat.      MI81  22
INTEGER LEVEL#                         Output level for this cycle;     MI81  23
#                                         Never =0; last = 1; all = 2.  MI81  24
INTEGER NCBIN1#                        Output control for all,          MI81  25
#                                         Centric, acentric categories. MI81  26
REAL CENNUM#                           Number of centric reflections    MI81  27
REAL STAT#                             Output level for this stat.      MI81  28
#                                                                       MI81  29
JSTAT = NINT(STAT)#                    Make output level integer        MI81  30
#                                         For easy comparison.          MI81  31
IF(JSTAT >= LEVEL)#                    Should this stat. be printed     MI81  32
#                                         On this cycle?                MI81  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI81  34
IF(NCBIN1 == 1)#                       Only "all" category; check       MI81  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI81  36
IPRALL = 3#                            For exceptions.                  MI81  37
IF(IACCHK == yes:)  IPRACE = 3#        Acentric exceptions              MI81  38
ELSE  IPRACE = 5#                                                       MI81  39
IF((ICECHK == yes:) & (CENNUM > small:))  IPRCEN = 3# Centric           MI81  40
ELSE  IPRCEN = 5#                      Exceptions.                      MI81  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI81  42
ELSE#                                  All,centric,acentric             MI81  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI81  44
IPRALL = 3#                                                             MI81  45
IPRACE = 3#                                                             MI81  46
IF(CENNUM > small:)  IPRCEN = 3#                                        MI81  47
ELSE  IPRCEN = 5#                                                       MI81  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI81  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI81  50
#                                                                       MI81  51
ELSE#                                  No printing                      MI81  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI81  53
IPRALL = 5#                                                             MI81  54
IPRACE = 5#                                                             MI81  55
IPRCEN = 5#                                                             MI81  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI81  57
RETURN#                                                                 MI81  58
END#                                                                    MI81  59
systemheader:(MI82)#                                                    MI82   1
# ################################################################## #  MI82   2
#                                                                    #  MI82   3
#                               MI82                                 #  MI82   4
#                                                                    #  MI82   5
# ################################################################## #  MI82   6
SUBROUTINE MI82(STAR,STEP,IDAT,NUMDAT,NLINE,SUBHD,NSUBHD,HEAD,NHEAD,$#  MI82   7
NBLOCK,NSPACE,IOFFST,NLINHD,IPRIOR,FMT821)#                             MI82   8
#                                                                       MI82   9
# DUMMY ARGUMENTS 'NSPACE' AND 'NLINE' ARE NEVER REFERENCED             MI82  10
# WRITE OUT INFORMATION DIVIDED BY BINS                                 MI82  11
# CALLED FROM MI79,MI80                                                 MI82  12
#                                        Jul 1980  s. sheriff           MI82  13
include:(AACOMN)#                                                       MI82  14
include:(MICOMN)#                                                       MI82  15
#                                                                       MI82  16
INTEGER I#                             Loop index                       MI82  17
INTEGER IDAT#                          Zero for blocks 2 and 4 or       MI82  18
#                                         Data set number two for       MI82  19
#                                         Blocks 3 and 5.               MI82  20
INTEGER IFROM#                         Pointer to appropriate           MI82  21
#                                         Character string in mi81.     MI82  22
INTEGER IOFFST(1)#                     Array of offsets in qx array     MI82  23
#                                         For group of statistics.      MI82  24
INTEGER IPRIOR(1)#                     Array of priority levels for     MI82  25
#                                         Group output.                 MI82  26
INTEGER J#                             A loop index                     MI82  27
INTEGER K#                             Another loop index               MI82  28
INTEGER L#                             Another loop index               MI82  29
INTEGER NBIN1#                         Number of stol bins plus one     MI82  30
INTEGER NBLOCK#                        Number of different lines        MI82  31
#                                         Output in each f**2 block.    MI82  32
INTEGER NFBIN1#                        Number of f**2 bins plus one     MI82  33
INTEGER NHEAD#                         Number of chars. in heading      MI82  34
INTEGER NLINE#                         Total number of lines needed     MI82  35
#                                         To print this block of stats. MI82  36
INTEGER NLINHD(1)#                     Array indexing which key word    MI82  37
#                                         Heads each line.              MI82  38
INTEGER NSPACE#                        Length of output line            MI82  39
INTEGER NSUBHD#                        Number of characters in sub-     MI82  40
#                                         Heading.                      MI82  41
INTEGER NUMDAT#                        Either number of data sets       MI82  42
#                                         Minus one for statistics      MI82  43
#                                         Block 5 or one for statistics MI82  44
#                                         Block 4.                      MI82  45
INTEGER STAR#                          Starting pointer in qx array     MI82  46
#                                         For these data.               MI82  47
INTEGER STEP#                          Increment in qx array for        MI82  48
#                                         Information to be output.     MI82  49
REAL FMT821(1)#                        Number of figures after          MI82  50
#                                         Decimal point and type of     MI82  51
#                                         Format.                       MI82  52
REAL FMT823(13)#                       Final output formats             MI82  53
string:(BINNUM,6)#                     F**2 bin number or "total"       MI82  54
string:(HEAD,1)#                       Table heading                    MI82  55
string:(SUBHD,1)#                      Table sub-heading                MI82  56
chardata:(MI821, ALL      CENTRIC  ACENTRIC NUMBER   )#                 MI82  57
chardata:(MI822, (CONTINUED))#                                          MI82  58
chardata:(MI823, TOTAL)#                                                MI82  59
realdata:(FMT822,[240600.,320600.,400600.,$#                            MI82  60
480600., 560600., 640600.,$#                                            MI82  61
720600., 800600., 880600.,$#                                            MI82  62
960600.,1040600.,1120600.,$#                                            MI82  63
1200600.])#                            Column pointers and output w     MI82  64
realdata:(FMT824,[60213.])#                                             MI82  65
datastuff:#                                                             MI82  66
#                                                                       MI82  67
IF(NFBIN > 1)  NFBIN1 = NFBIN + 1#     No need for summary line,        MI82  68
ELSE  NFBIN1 = 1#                      If only one bin.                 MI82  69
IF(NBIN > 1)  NBIN1 = NBIN + 1#        No need for summary column,      MI82  70
ELSE  NBIN1 = 1#                       If only one bin.                 MI82  71
#                                                                       MI82  72
LINRM = NBLOCK + 6#                    Fit on the headings              MI82  73
writeline:(2,SUBHD,NSUBHD,3,IPRIOR(1))#                                 MI82  74
writeline:(1,HEAD,NHEAD,3,IPRIOR(1))#                                   MI82  75
#                                                                       MI82  76
DO I=1,NFBIN1#                         Loop over f**2 bins              MI82  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI82  78
IF((LINCT-NBLOCK-1) <= 0)#                                              MI82  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI82  80
LINCT = 0#                             Force new page                   MI82  81
movechar:(SUBHD,1,CHROT,1,NSUBHD,0)#                                    MI82  82
movechar:(MI822,1,CHROT,NSUBHD+1,NMI822,0)#                             MI82  83
writeline:(2,0,0,1,IPRIOR(1))#                                          MI82  84
writeline:(1,HEAD,NHEAD,3,IPRIOR(1))#                                   MI82  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI82  86
#                                                                       MI82  87
# IF LAST PASS THROUGH LOOP, PUT "TOTAL" IN F**2 BIN NUMBER             MI82  88
#  LOCATION, OTHERWISE PUT BIN NUMBER THERE.                            MI82  89
#                                                                       MI82  90
IF(I == NFBIN1)  movechar:(MI823,1,BINNUM,1,NMI823,0)#                  MI82  91
ELSE#                                                                   MI82  92
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI82  93
movechar:(BLANK,1,BINNUM,1,6,1)#                                        MI82  94
BUFOT(1) = FLOAT(I)#                                                    MI82  95
ncodefld:(BUFOT,1,BINNUM,FMT824,1)#                                     MI82  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI82  97
#                                                                       MI82  98
# LOOP OVER CATEGORIES (ALL,CENTRIC,ACENTRIC) FOR THIS F**2 BIN         MI82  99
#                                                                       MI82 100
DO J=1,NBLOCK#                                                          MI82 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI82 102
IFROM = (NLINHD(J)-1)*9 + 1#           Put category name on line        MI82 103
movechar:(MI821,IFROM,CHROT,1,9,0)#                                     MI82 104
movechar:(BINNUM,1,CHROT,11,6,0)#      Put f**2 bin number on line      MI82 105
DO K=1,NBIN1#                          Loop over stol bins              MI82 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI82 107
#                                                                       MI82 108
# CALCULATION OF L:                                                     MI82 109
# SECOND TERM POINTS TO F**2 BIN                                        MI82 110
# THIRD TERM POINTS TO STOL BIN                                         MI82 111
# FOURTH TERM POINTS DATA SET BIN                                       MI82 112
# FIFTH TERM POINTS TO SPECIFIC STATISTIC                               MI82 113
#                                                                       MI82 114
L = STAR + (I-1)*STEP*NUMDAT*NBIN1 + (K-1)*STEP*NUMDAT $#               MI82 115
+ IDAT*STEP + IOFFST(J)#                                                MI82 116
BUFOT(K) = QX(L)#                                                       MI82 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI82 118
DO K=1,NBIN1#                          Synthesize format                MI82 119
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI82 120
FMT823(K) = FMT822(K) + FMT821(J)#                                      MI82 121
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI82 122
ncodefld:(BUFOT,1,CHROT,FMT823(1),NBIN1)#                               MI82 123
writeline:(0,0,0,1,IPRIOR(J))#                                          MI82 124
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI82 125
writeline:(1,0,0,3,IPRIOR(1))#         One blank line                   MI82 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI82 127
RETURN#                                                                 MI82 128
END#                                                                    MI82 129
systemheader:(MI83)#                                                    MI83   1
# ################################################################## #  MI83   2
#                                                                    #  MI83   3
#                               MI83                                 #  MI83   4
#                                                                    #  MI83   5
# ################################################################## #  MI83   6
SUBROUTINE MI83(SAME,OPP,ZERO,IPRIOR)#                                  MI83   7
#                                                                       MI83   8
# WRITE OUT INFORMATION IN BLOCK 6                                      MI83   9
# CALLED FROM MI79,MI80                                                 MI83  10
#                                        Jul 1980  s. sheriff           MI83  11
include:(AACOMN)#                                                       MI83  12
#                                                                       MI83  13
INTEGER IPRIOR#                        Output priority                  MI83  14
REAL OPP#                              Number of reflections with       MI83  15
#                                         Calculated and observed signs MI83  16
#                                         Opposite.                     MI83  17
REAL SAME#                             Number of reflections with       MI83  18
#                                         Calculated and observed signs MI83  19
#                                         The same.                     MI83  20
REAL ZERO#                             Number of reflections either     MI83  21
#                                         Unobserved or no anomalous    MI83  22
#                                         Difference.                   MI83  23
chardata:(MI831, AGREEMENT OF SIGNS FOR CALCULATED AND OBSERVED $#      MI83  24
ANOMALOUS DIFFERENCES)#                                                 MI83  25
chardata:(MI832, SAME)#                                                 MI83  26
chardata:(MI833, OPPOSITE)#                                             MI83  27
chardata:(MI834, ANOMALOUS DIFFERENCES CALCULATED OR WERE OBSERVED $#   MI83  28
AS ZERO)#                                                               MI83  29
realdata:(FMT831,[100913.])#                                            MI83  30
datastuff:#                                                             MI83  31
#                                                                       MI83  32
#                                                                       MI83  33
LINRM = 5#                             Force new page, if necessary     MI83  34
movechar:(MI831,1,CHROT,1,NMI831,0)#   Print statistics header          MI83  35
writeline:(1,0,0,1,IPRIOR)#                                             MI83  36
#                                                                       MI83  37
movechar:(MI832,1,CHROT,12,NMI832,0)#  Put title on line                MI83  38
BUFOT(1) = SAME#                                                        MI83  39
ncodefld:(BUFOT,1,CHROT,FMT831,1)#                                      MI83  40
writeline:(0,0,0,1,IPRIOR)#                                             MI83  41
#                                                                       MI83  42
movechar:(MI833,1,CHROT,12,NMI833,0)#  Put title on line                MI83  43
BUFOT(1) = OPP#                                                         MI83  44
ncodefld:(BUFOT,1,CHROT,FMT831,1)#                                      MI83  45
writeline:(0,0,0,1,IPRIOR)#                                             MI83  46
#                                                                       MI83  47
movechar:(MI834,1,CHROT,12,NMI834,0)#  Put title on line                MI83  48
BUFOT(1) = ZERO#                                                        MI83  49
ncodefld:(BUFOT,1,CHROT,FMT831,1)#                                      MI83  50
writeline:(0,0,0,1,IPRIOR)#                                             MI83  51
RETURN#                                                                 MI83  52
END#                                                                    MI83  53
systemheader:(MI85)#                                                    MI85   1
# ################################################################## #  MI85   2
#                                                                    #  MI85   3
#                               MI85                                 #  MI85   4
#                                                                    #  MI85   5
# ################################################################## #  MI85   6
SUBROUTINE MI85#                       Update of closure errors         MI85   7
#                                        Called from mi75               MI85   8
#                                        Jun 1980  s. sheriff           MI85   9
#                                        Revised jul 1980  s. sheriff   MI85  10
# THIS ROUTINE WORKS ON THE FOLLOWING UNWARRENTED PRESUMPTIONS:         MI85  11
# 1) CLOSURE ERRORS ARE ONLY UPDATED WHEN NEW ONES HAVE BEEN            MI85  12
#    CALCULATED.  I.E., THERE WERE OBSERVATIONS IN A PARTICULAR BIN.    MI85  13
# 2) USES ADJUSTED CLOSURE ERRORS AS DEFINED BY TENEYCK AND             MI85  14
#    ARNONE, J. MOL. BIOL., 100, 3-11 (1976).                           MI85  15
# 3) CLOSURE ERRORS USED FOR ISOMORPHOUS ARE FROM CENTRIC ZONES,        MI85  16
#    IF AVAILABLE.                                                      MI85  17
# 4) OTHERWISE ISOMORPHOUS CLOSURE ERRORS ARE UPDATED FROM THE          MI85  18
#    TOTAL REFLECTIONS (WHICH IN THIS CASE MUST BE ACENTRIC) IF         MI85  19
#    THERE WERE ANY MEASUREMENTS.                                       MI85  20
#                                                                       MI85  21
include:(AACOMN)#                                                       MI85  22
include:(MICOMN)#                                                       MI85  23
#                                                                       MI85  24
INTEGER I#                             Loop index                       MI85  25
INTEGER IPTR3#                         Pointer to stat block 3          MI85  26
INTEGER IPTR4#                         Pointer to stat block 4          MI85  27
INTEGER IPTR5#                         Pointer to stat block 5          MI85  28
INTEGER J#                             Another loop index               MI85  29
INTEGER K#                             Yet another loop index           MI85  30
INTEGER KBPTR#                         Pointer to kb part of qx array   MI85  31
#                                                                       MI85  32
# CALCULATION OF POINTERS:                                              MI85  33
#                                                                       MI85  34
# CALCULATION OF IPTR3 AND IPTR5:                                       MI85  35
#   SECOND TERM POINTS TO F**2 BIN.                                     MI85  36
#   THIRD TERM POINTS TO STOL BIN.                                      MI85  37
#   FOURTH TERM OFFSETS TO ISOMORPH.                                    MI85  38
#                                                                       MI85  39
# CALCULATION OF IPTR4:                                                 MI85  40
#   SECOND TERM POINTS TO F**2 BIN.                                     MI85  41
#   THIRD TERM POINTS TO STOL BIN.                                      MI85  42
#                                                                       MI85  43
# CALCULATION OF KBPTR FOR ISOMORPHS:                                   MI85  44
#   SECOND TERM POINTS TO F**2 BIN.                                     MI85  45
#   THIRD TERM POINTS TO STOL BIN.                                      MI85  46
#   FOURTH TERM POINTS TO ISOMORPH.                                     MI85  47
#   FIFTH TERM OFFSETS TO CLOSURE ERRORS WITHIN ISOMORPH BLOCK.         MI85  48
#                                                                       MI85  49
KBPTR = STARKB + binstart: + 50#       Start of ermsano                 MI85  50
DO I=1,NFBIN#                          Loop over f**2 bins              MI85  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI85  52
DO J=1,NBIN#                           Loop over stol bins              MI85  53
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI85  54
IPTR4 = STARS4 + (I-1)*STEPS4*(NBIN+1) + (J-1)*STEPS4#                  MI85  55
KBPTR = KBPTR + 1#                                                      MI85  56
IF(sumnatanodif:(IPTR4) > small:)#                                      MI85  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI85  58
QX(KBPTR) = sumnatanoadj:(IPTR4)**2#                                    MI85  59
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI85  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI85  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI85  62
#                                                                       MI85  63
DO I=1,NFBIN#                          Loop over f**2 bins              MI85  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI85  65
DO J=1,NBIN#                           Loop over stol bins              MI85  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI85  67
DO K=2,NDATIN#                         Loop over isomorphs              MI85  68
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI85  69
IPTR3 = STARS3 + (I-1)*STEPS3*(NDATIN-1)*(NBIN+1) $#                    MI85  70
+ (J-1)*STEPS3*(NDATIN-1) + (K-2)*STEPS3#                               MI85  71
IPTR5 = STARS5 + (I-1)*STEPS5*(NDATIN-1)*(NBIN+1) $#                    MI85  72
+ (J-1)*STEPS5*(NDATIN-1) + (K-2)*STEPS5#                               MI85  73
KBPTR = STARKB + (I-1)*NBIN + J + (K-1)*STEPKB + binstart:#             MI85  74
IF(sumallc:(IPTR3) > small:)#          Use centric, if there            MI85  75
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI85  76
QX(KBPTR) = sumadjcloc:(IPTR5)**2#                                      MI85  77
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI85  78
#                                                                       MI85  79
ELSE  IF(sumall:(IPTR3) > small:)#     Otherwise, use "all"             MI85  80
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI85  81
QX(KBPTR) = sumadjclo:(IPTR5)**2#                                       MI85  82
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI85  83
#                                                                       MI85  84
IF(sumanodif:(IPTR5) > small:)#        Anomalous closure errors         MI85  85
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI85  86
QX(KBPTR+50) = sumanoadj:(IPTR5)**2#                                    MI85  87
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI85  88
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI85  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI85  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI85  91
RETURN#                                                                 MI85  92
END#                                                                    MI85  93
systemheader:(MI86)#                                                    MI86   1
# ################################################################## #  MI86   2
#                                                                    #  MI86   3
#                               MI86                                 #  MI86   4
#                                                                    #  MI86   5
# ################################################################## #  MI86   6
SUBROUTINE MI86#                       Allow closure errors to be       MI86   7
#                                         Punched on last cycle.        MI86   8
#                                        Called from mi75               MI86   9
#                                        Jul 1980  s. sheriff           MI86  10
#                                        Revised jan 1981  s. sheriff   MI86  11
include:(MIMAC2)#                                                       MI86  12
include:(AACOMN)#                                                       MI86  13
include:(MICOMN)#                                                       MI86  14
#                                                                       MI86  15
INTEGER I#                             Loop index                       MI86  16
INTEGER J#                             Another loop index               MI86  17
INTEGER K#                             Yet another loop index           MI86  18
INTEGER KBPTR#                         Pointer to kb part of qx array   MI86  19
INTEGER LEFTOV#                        Flag to indicate a second line   MI86  20
#                                         Is needed.                    MI86  21
INTEGER NAME#                          Pointer to data set name         MI86  22
INTEGER NTITLE#                        No. of chars. in line title      MI86  23
INTEGER IOFFST#                        Offset to closure errors in kb   MI86  24
#                                         Region of qx array; equals    MI86  25
#                                         Binstart: for eiso and        MI86  26
#                                         Binstart:+50 for eano.        MI86  27
string:(PUNCH,80)#                     Temp. storage for formatted      MI86  28
#                                         Output.                       MI86  29
chardata:(MI861,EISO)#                                                  MI86  30
chardata:(MI862,EANO)#                                                  MI86  31
chardata:(MI863,=)#                                                     MI86  32
chardata:(MI864,C)#                                                     MI86  33
realdata:(FMT861,[320713.,400713.,480713.,560713.,640713.,720713.,$#    MI86  34
800713.])#                                                              MI86  35
realdata:(FMT862,[230313.])#                                            MI86  36
datastuff:#                                                             MI86  37
#                                                                       MI86  38
########## DEFINE PROCEDURE NAMES USED IN THIS ROUTINE ############# #  MI86  39
defineproc:(PUNCHER)#                  Write out closure errors in      MI86  40
#                                         Formatted file.               MI86  41
defineproc:(TITLER)#                   Write title on line              MI86  42
########## END OF PROCEDURE NAME DEFINITIONS ####################### #  MI86  43
#                                                                       MI86  44
DO K=1,NDATIN#                         Loop over all data sets          MI86  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI86  46
NAME = STARDN + (K-1)*STEPDN + 1#      Location of data set name        MI86  47
#                                                                       MI86  48
# ISOMORPHOUS CLOSURE ERRORS                                            MI86  49
# PARENT CANNOT HAVE ISOMORPHOUS CLOSURE ERRORS                         MI86  50
IF(K != 1 & (ABS(FAZDA1(K)-1.) < small:$# Isomorphous only              MI86  51
\ ABS(FAZDA2(K)-3.) < small:))#        Both isomorphous and anomalous   MI86  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI86  53
movechar:(MI861,1,TITLE,1,NMI861,0)#                                    MI86  54
NTITLE = NMI861#                                                        MI86  55
IOFFST = binstart:#                                                     MI86  56
#                                                                       MI86  57
xeq:(PUNCHER)#                         Write out isomorphous            MI86  58
#                                         Closure errors.               MI86  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI86  60
#                                                                       MI86  61
# ANOMALOUS CLOSURE ERRORS                                              MI86  62
#                                                                       MI86  63
IF(ABS(FAZDA1(K)-2.) < small:       $# Isomorphous only                 MI86  64
\ ABS(FAZDA2(K)-3.) < small:)#         Both isomorphous and anomalous   MI86  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI86  66
movechar:(MI862,1,TITLE,1,NMI862,0)#                                    MI86  67
NTITLE = NMI862#                                                        MI86  68
IOFFST = 50 + binstart:#                                                MI86  69
#                                                                       MI86  70
xeq:(PUNCHER)#                         Write out anomalous              MI86  71
#                                         Closure errors.               MI86  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI86  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI86  74
RETURN#                                                                 MI86  75
# ##################### PUNCHER #################################### #  MI86  76
procedure:(PUNCHER)#                                                    MI86  77
DO I=1,NFBIN#                          Over all f**2 bins               MI86  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI86  79
BUFOT(1) = FLOAT(I)#                   F**2 bin number                  MI86  80
#                                                                       MI86  81
xeq:(TITLER)#                          Write line identifier            MI86  82
#                                         And data set name.            MI86  83
DO J=1,NBIN#                                                            MI86  84
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI86  85
# CALCULATION OF KBPTR FOR ISOMORPHS:                                   MI86  86
#    SECOND TERM POINTS TO F**2 BIN.                                    MI86  87
#    THIRD TERM POINTS TO STOL BIN.                                     MI86  88
#    FOURTH TERM POINTS TO ISOMORPH.                                    MI86  89
#    FIFTH TERM OFFSETS TO CLOSURE ERRORS WITHIN ISOMORPH BLOCK.        MI86  90
#                                                                       MI86  91
KBPTR = STARKB + (I-1)*NBIN + J + (K-1)*STEPKB + IOFFST#                MI86  92
BUFOT(J+1) = SQRT(QX(KBPTR))#          Closure errors stored squared    MI86  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI86  94
IF(NBIN <= 7)#                                                          MI86  95
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI86  96
ncodefld:(BUFOT,2,PUNCH,FMT861(1),NBIN)#                                MI86  97
writepch:(PUNCH,80)#                                                    MI86  98
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI86  99
ELSE#                                  More than seven closure          MI86 100
#                                         Errors requires 2 lines.      MI86 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI86 102
ncodefld:(BUFOT,2,PUNCH,FMT861(1),6)#  Write out first six              MI86 103
#                                         Closure errors.               MI86 104
movechar:(MI864,1,PUNCH,80,1,0)#       Write out continuation           MI86 105
#                                         Character.                    MI86 106
writepch:(PUNCH,80)#                                                    MI86 107
LEFTOV = NBIN - 6#                                                      MI86 108
#                                                                       MI86 109
xeq:(TITLER)#                          Write line identifier            MI86 110
#                                         And data set name.            MI86 111
ncodefld:(BUFOT,8,PUNCH,FMT861(1),LEFTOV)#                              MI86 112
writepch:(PUNCH,80)#                                                    MI86 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI86 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI86 115
endproc:(PUNCHER)#                                                      MI86 116
#                                                                       MI86 117
# ##################### TITLER ##################################### #  MI86 118
procedure:(TITLER)#                                                     MI86 119
movechar:(BLANK,1,PUNCH,1,80,1)#       Clear out array                  MI86 120
movechar:(TITLE,1,PUNCH,1,NTITLE,0)#   Write line identifier            MI86 121
movechar:(MI863,1,PUNCH,8,1,0)#        Name delineator                  MI86 122
movertoc:(QX(NAME),1,PUNCH,9,12,0)#    Data set name                    MI86 123
movechar:(MI863,1,PUNCH,20,1,0)#       Name delineator                  MI86 124
ncodefld:(BUFOT,1,PUNCH,FMT862,1)#     F**2 bin number                  MI86 125
endproc:(TITLER)#                                                       MI86 126
#                                                                       MI86 127
######### REMOVE PROCEDURES ################################            MI86 128
deleteproc:(PUNCHER)#                                                   MI86 129
deleteproc:(TITLER)#                                                    MI86 130
#                                                                       MI86 131
END#                                                                    MI86 132
systemheader:(MI89)#                                                    MI89   1
# ################################################################## #  MI89   2
#                                                                    #  MI89   3
#                               MI89                                 #  MI89   4
#                                                                    #  MI89   5
# ################################################################## #  MI89   6
SUBROUTINE MI89#                       Write final output bdf           MI89   7
#                                        Jan 1981  r.a. alden           MI89   8
#                                        Mar 1982  r.m. doherty         MI89   9
#                                        Revised for new bdf format and MI89  10
#                                         To use indexpkt:.             MI89  11
#                                        Aug 1985 k.d.watenpaugh        MI89  12
#                                        Aug 1985 j.m.stewart           MI89  13
#                                        Dec 1986 k.d.watenpaugh and    MI89  14
#                                                 D.r.holland           MI89  15
include:(AACOMN)#                                                       MI89  16
include:(MICOMN)#                                                       MI89  17
#                                                                       MI89  18
INTEGER DIR16(50)#                     Directory idnums for output      MI89  19
#                                         Lratom:.                      MI89  20
INTEGER GETA20(109)#                   Relocation pointers for file a   MI89  21
INTEGER GETC20(109)#                   "         "       "   "   c      MI89  22
INTEGER I,K#                           A couple of loop indexes         MI89  23
INTEGER INDX#                          Data set sequence number         MI89  24
INTEGER IPT1#                          Input packet pointer             MI89  25
INTEGER IPT3#                          Scratch file packet pointer      MI89  26
INTEGER IPTR,IPTRR#                    Counts of items in i/o pakts.    MI89  27
INTEGER IPTA,IPTB,IPTC#                Pkt pointer file a,b,c           MI89  28
INTEGER J,JJ#                          Another loop index               MI89  29
INTEGER JC,JB#                         Offset points for file update    MI89  31
INTEGER JPT#                           Output packet pointer            MI89  32
INTEGER JPTR#                          Miscellaneous composite index    MI89  33
INTEGER KBPTR#                         Pointer to scale and delta b     MI89  34
#                                         Region of the qx array.       MI89  35
INTEGER DIR12(107)#                    Directory numbers for lrdset     MI89  36
INTEGER OFF12(108)#                    Offsets for catalog numbers      MI89  37
#                                         For file a (lrdset:).         MI89  38
INTEGER OFF16(37)#                     Offsets for catalog numbers      MI89  39
#                                         For file a (lratom:).         MI89  40
INTEGER PKTPTR#                        Current packet number in         MI89  41
#                                         Logical record lrcell:.       MI89  42
INTEGER PSIZ1#                         Input packet size                MI89  43
INTEGER PSIZ2#                         Output packet size               MI89  44
INTEGER PSIZ3#                         Scratch file packet size         MI89  45
INTEGER SGNL16(4)#                     Lratom: data group indices       MI89  46
INTEGER SIGA20(4)#                     Lrrefl: data group indices       MI89  47
INTEGER SIGC20(4)#                     Lrrefl: data group indices       MI89  48
INTEGER START#                         Pointer which moves through      MI89  49
#                                         The new parameters.           MI89  50
REAL VOID(1)#                          Holds voidflg:                   MI89  51
INTEGER WNT20(108)#                                                     MI89  52
chardata:(MI89A, DUMP OF ARRAYS WHICH CONTROL I/O $#                    MI89  53
OF REFLECTION RECORD.)#                                                 MI89  54
chardata:(MI89B,      WANT LIST    FILEA INPKT  FILEA OFFSETS   $#      MI89  55
FILEB OUTPKT   FILEC INPKT   FILEC OFFSETS )#                           MI89  56
intdata:(NEED12,[ 1, 14, 15, 30, 31, 34, 35])#                          MI89  57
intdata:(NEED16,[14, 15, 16, 17, 21, 22, 24, 25, 23,  1,101,  2,$#      MI89  58
102,  3,103,  4,104,  5,105,  6,106,  7,107, 8,108,  9,109, 10 ,$#      MI89  59
110, 11,111, 12,112])#                                                  MI89  60
intdata:(SGNL12,[5,5,107,0])#                                           MI89  61
realdata:(FMDM,[150613.,300613.,450613.,600613.,750613.,900613.])#      MI89  62
intdata:(WNTAU,[700, 701, 702, 703, 704])#                              MI89  63
# THE FOLLOWING TABLE HAS THE LRREFL: PACKET ID NUMS FOR THE ITEMS      MI89  64
# CONSIDERED TEMPORARY TO FILE C.  THEY ARE NEGATIVE TO CAUSE           MI89  65
# INDEXPKT: TO FORCE DELETION NOT INCLUSION OF THE ITEMS ON FILE B.     MI89  66
# IF ONE MAKES THEM POSITIVE THEY WILL BE PUT OUT.  IF NONC IS SET      MI89  67
# TO 4 ONLY THE FIRST FOUR APPLY ; 12 AND THEY'RE ALL USED.             MI89  68
intdata:(WNTAV,[-801,-802,-803, -804,-501,-502,-503,$#                  MI89  69
-504,-505,-506,-507,-508])#                                             MI89  70
# NONC MUST BE SET IN MI31, MI40 AND MI89 IF HENDRICKSON COEFFICIENTS   MI89  71
# ARE TO BE IMPLEMENTED.                                                MI89  72
intdata:(NONC,[4])#                                                     MI89  73
datastuff:#                                                             MI89  74
#                                                                       MI89  75
#                                                                       MI89  76
VOID(1) = voidflg:#                                                     MI89  77
#                                                                       MI89  78
# COPY UP TO CELL RECORD                                                MI89  79
#                                                                       MI89  80
copyfile:(1,2,1,decr:(lrcell:))#                                        MI89  81
#                                                                       MI89  82
# UPDATE THE CYCLE NUMBER AND GOODNESS OF FIT IN LOG. REC. LRCELL:      MI89  83
#                                                                       MI89  84
PKTPTR = 0#                            Initialize packet pointer        MI89  85
REPEAT#                                                                 MI89  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI89  87
readwpkt:(1,lrcell:,PSIZ1,IPT1,0)#                                      MI89  88
IF(IPT1 <= 0)  BREAK#                                                   MI89  89
PKTPTR = PKTPTR + 1#                   Increment packet pointer         MI89  90
writepkt:(2,lrcell:,PSIZ1,JPT)#                                         MI89  91
movereal:(QX,IPT1+1,QX,JPT+1,PSIZ1,0)#                                  MI89  92
IF(PKTPTR == 6)#                       The sixth packet is the one      MI89  93
#                                         We want.                      MI89  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI89  95
QX(JPT+3) = FLOAT(ICYC)#               Insert the last cycle number     MI89  96
QX(JPT+5) = GOFPRV#                    Reduced chi**2                   MI89  97
QX(JPT+4) = 0.0#                       For those bdfs which were        MI89  98
#                                         Improperly initialized.       MI89  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI89 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI89 101
#                                                                       MI89 102
# COPY UP TO DATA SET RECORD                                            MI89 103
#                                                                       MI89 104
copyfile:(1,2,incr:(lrcell:),decr:(lrdset:))#                           MI89 105
#                                                                       MI89 106
# MODIFY DATA SET INFORMATION                                           MI89 107
#                                                                       MI89 108
DO I=1,7#                              Directory of needed items        MI89 109
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI89 110
DIR12(I) = NEED12(I)#                                                   MI89 111
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI89 112
DO I=8,57#                                                              MI89 113
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI89 114
DIR12(I)    = I + 192#                 200-249                          MI89 115
DIR12(I+50) = DIR12(I) + 100#          300-349                          MI89 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI89 117
#                                                                       MI89 118
# FIND ALL OF THE PACKET OFFSETS                                        MI89 119
SGNL12(4) = 0#                                                          MI89 120
indexpkt:(1,lrdset:,PSIZ1,IPT1,2,SGNL12,DIR12,OFF12)#                   MI89 121
IF(SGNL12(4) <= 0)  iquit:(MI8901)#    Quit, if no directory            MI89 122
#                                                                       MI89 123
DO I=1,NDAT#                           Loop over the data sets          MI89 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI89 125
readwpkt:(1,lrdset:,PSIZ1,IPT1,0)#     Read filea original data         MI89 126
PSIZ2 = SGNL12(4)#                                                      MI89 127
writepkt:(2,lrdset:,PSIZ2,JPT)#        Assign buffer space for output   MI89 128
movereal:(QX,IPT1+1,QX,JPT+1,PSIZ1,1)#                                  MI89 129
JPTR = JPT + PSIZ1#                                                     MI89 130
IF(SEQDAT(I) == no:)#                                                   MI89 131
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI89 132
FOR(J=6; J <= SGNL12(3); J=J+1)#                                        MI89 133
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI89 134
IF(OFF12(J) > PSIZ1)#                                                   MI89 135
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI89 136
JPTR = JPTR + 1#                                                        MI89 137
QX(JPTR) = 0.#                                                          MI89 138
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI89 139
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI89 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI89 141
#                                                                       MI89 142
ELSE#                                  If included in refinement,...    MI89 143
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI89 144
KBPTR = STARKB + (SEQDAT(I)-1)*STEPKB# Point to kb area in qx           MI89 145
#                                                                       MI89 146
# PICK UP SCALE AND DELTA-B                                             MI89 147
#                                                                       MI89 148
QX(JPT+OFF12(4))=QX(KBPTR+1)#                                           MI89 149
QX(JPT+OFF12(5))=QX(KBPTR+3)#                                           MI89 150
KBPTR = KBPTR - 1#                                                      MI89 151
QX(JPT+OFF12(6)) = FLOAT(NBIN)#        Number of stol bins              MI89 152
QX(JPT+OFF12(7)) = FLOAT(NFBIN)#       Nuber of f**2 bins               MI89 153
DO J=8,107#                            Closure errors                   MI89 154
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI89 155
JPTR = KBPTR + J#                                                       MI89 156
QX(JPT+OFF12(J))=SQRT(QX(JPTR))#                                        MI89 157
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI89 158
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI89 159
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI89 160
#                                                                       MI89 161
# COPY RECORDS UP TO LRATOM:                                            MI89 162
#                                                                       MI89 163
copyfile:(1,2,incr:(lrdset:),decr:(lratom:))#                           MI89 164
#                                                                       MI89 165
# MODIFY ATOM PARAMETERS                                                MI89 166
#                                                                       MI89 167
# GET ALL OF THE PACKET OFFSETS                                         MI89 168
SGNL16(1) = 0#                                                          MI89 169
SGNL16(2) = 9#                                                          MI89 170
SGNL16(3) = 33#                                                         MI89 171
SGNL16(4) = 0#                                                          MI89 172
indexpkt:(1,lratom:,PSIZ1,IPT1,0,SGNL16,NEED16,OFF16)#                  MI89 173
#                                                                       MI89 174
PSIZ2 = 0#                             Start constructing the packet    MI89 175
DO I=1,STEPAN; DIR16(I) = 14#          Directory of lratom:.            Aug93016
PSIZ2=PSIZ2+STEPAN#                                                     MI89 177
#                                                                       MI89 178
DO I=2,8#                              Get all non-refined parameters   MI89 179
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI89 180
IF(OFF16(I) > 0)#                      And copy them to output.         MI89 181
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI89 182
PSIZ2 = PSIZ2 + 1#                     Increment packet size            MI89 183
DIR16(PSIZ2) = NEED16(I)#                                               MI89 184
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI89 185
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI89 186
#                                                                       MI89 187
SGNL16(1) = PSIZ2#                                                      MI89 188
PSIZ2 = PSIZ2 + 1#                                                      MI89 189
DIR16(PSIZ2) = NEED16(9)#              Temp. factor type                MI89 190
SGNL16(2) = PSIZ2#                                                      MI89 191
#                                                                       MI89 192
DO I=10,35,2#                          Now get refinable parameters     MI89 193
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI89 194
IF(OFF16(I) > 0)#                                                       MI89 195
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI89 196
PSIZ2 = PSIZ2 + 1#                                                      MI89 197
DIR16(PSIZ2) = NEED16(I)#                                               MI89 198
PSIZ2 = PSIZ2 + 1#                                                      MI89 199
DIR16(PSIZ2) = NEED16(I+1)#                                             MI89 200
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI89 201
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI89 202
#                                                                       MI89 203
SGNL16(3) = PSIZ2#                                                      MI89 204
SGNL16(4) = 0#                                                          MI89 205
#                                                                       MI89 206
indexpkt:(1,lratom:,PSIZ1,IPT1,0,SGNL16,DIR16,OFF16)#                   MI89 207
writepkt:(2,lratom:,PSIZ2,JPT)#                                         MI89 208
DO I=1,PSIZ2#                          Create a new directory           MI89 209
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI89 210
movereal:(FLOAT(DIR16(I)),1,QX,JPT+I,1,0)#                              MI89 211
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI89 212
#                                                                       MI89 213
DO I=1,NAT#                            Loop over each of the atoms      MI89 214
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MI89 215
readwpkt:(1,lratom:,PSIZ1,IPT1,0)#     Read the old parameter values    MI89 216
writepkt:(2,lratom:,PSIZ2,JPT)#        Assign output buffer space       MI89 217
#                                                                       MI89 218
movereal:(QX,IPT1+OFF16(1),QX,JPT+1,STEPAN,1)# Move atom name           MI89 219
#                                                                       MI89 220
DO J=STEPAN+1,SGNL16(3)#               Copy over the input              MI89 221
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MI89 222
IF(OFF16(J) > 0)  movereal:(QX,IPT1+OFF16(J),QX,JPT+J,1,1)#             MI89 223
ELSE  movereal:(VOID,1,QX,JPT+J,1,1)#                                   MI89 224
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MI89 225
#                                                                       MI89 226
INDX = SEQAT(I)#                       Get atom sequence number         MI89 227
IF(INDX >= yes:)#                      If included in refinement,....   MI89 228
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MI89 229
# CALCULATE POINTER TO STORAGE OF NEW PARAMETERS IN QX.                 MI89 230
#  THE PARAMETERS STORED BEGINNING AT QX(DRVPTA(2))+1 USE               MI89 231
#  4 LOCATIONS FOR EACH:                                                MI89 232
#    OLD VALUE                                                          MI89 233
#    SHIFT                                                              MI89 234
#    NEW VALUE                                                          MI89 235
#    STANDARD DEVIATION                                                 MI89 236
#                                                                       MI89 237
START = 4*(INDX-1)*(stepat:)+ DRVPTA(2)#                                MI89 238
JPTR = JPT + SGNL16(2)#                Point to temp. factor type       MI89 239
ifvo:(QX(START+17))  BUFOT(1) = 1.#    Set isotropic                    MI89 240
ELSE BUFOT(1) = 2.#                    Or anisotropic                   MI89 241
QX(JPTR)=BUFOT(1)#                     And store away flag.             MI89 242
JPTR = JPTR - 1#                       Adjust pointer                   MI89 243
#                                                                       MI89 244
DO J=1,3#                              Pick up new x,y, and z           MI89 245
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MI89 246
JPTR = JPTR + 2#                                                        MI89 247
QX(JPTR)=QX(START+3)#                  Get coordinates                  MI89 248
QX(JPTR+1)=QX(START+4)#                And their std. devs.             MI89 249
START = START + 4#                     Move to next coordinate          MI89 250
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MI89 251
IF (BUFOT(1) == 1.0)#                  If isotropic b was used          MI89 252
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MI89 253
JPTR = JPTR + 2#                                                        MI89 254
QX(JPTR)=QX(START+3)/78.957#           Get new b                        MI89 255
QX(JPTR+1)=QX(START+4)/78.957#         And its std. dev.                MI89 256
START = START + 24#                    Skip over anisotropic            MI89 257
DO J=1,6#                                                               MI89 258
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MI89 259
JPTR = JPTR+2#                         Void iso b's in fileb if         MI89 260
QX(JPTR)=voidflg:#                     Atom is aniso                    MI89 261
QX(JPTR)=voidflg:#                                                      MI89 262
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MI89 263
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MI89 264
#                                                                       MI89 265
ELSE#                                  Must have been anisotropic       MI89 266
#                                         Refinement.                   MI89 267
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MI89 268
START = START + 4#                     Skip over isotropic temp.        MI89 269
JPTR = JPTR + 2#                       Incr iso pointer                 MI89 270
QX(JPTR)=voidflg:#                     Void isob in file b              MI89 271
QX(JPTR)=voidflg:#                                                      MI89 272
DO J=1,6#                              Get new betas                    MI89 273
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MI89 274
JPTR = JPTR + 2#                                                        MI89 275
QX(JPTR)=QX(START+3)/TFCON(J)#         Store betaij as uij              MI89 276
QX(JPTR+1)=QX(START+4)/TFCON(J)#       And its std. dev.                MI89 277
START = START + 4#                                                      MI89 278
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MI89 279
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MI89 280
#                                                                       MI89 281
DO J=1,2#                              Get new real and anomalous       MI89 282
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MI89 283
JPTR = JPTR + 2#                                                        MI89 284
QX(JPTR)=QX(START+3)#                  Population parameters.           MI89 285
QX(JPTR+1)=QX(START+4)#                Also store away sigma            MI89 286
START = START + 4#                                                      MI89 287
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MI89 288
QX(JPTR+2)=voidflg:#                   Void neutron parameter           MI89 289
QX(JPTR+3)=voidflg:#                                                    MI89 290
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MI89 291
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MI89 292
#                                                                       MI89 293
# COPY RECORDS UP TO LRREFL: (REFLECTION RECORD)                        MI89 294
#                                                                       MI89 295
copyfile:(1,2,incr:(lratom:),decr:(lrrefl:))#                           MI89 296
#                                                                       MI89 297
# MODIFY REFLECTION INFORMATION                                         MI89 298
#                                                                       MI89 299
#                                                                       MI89 300
SIGA20(1)=0;SIGA20(2)=0;SIGA20(4)=0#                                    MI89 301
# SIGA20(3) SET UP BOTTOM OF SETUP OF DIRECTORY INFO                    MI89 302
DO J=1,3;SIGC20(J)=SIGA20(J)#          Make requests the same           MI89 303
SIGC20(4)=0#                           Except for archiving business    MI89 304
IPTR=0#                                                                 MI89 305
DO J=1,5#                              Loop over fixed items            MI89 306
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MI89 307
IPTR=IPTR+1#                                                            MI89 308
WNT20(J)=WNTAU(J)#                     Move indices of lrrefl. items    MI89 309
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MI89 310
IF (FAZA2!=0)#                         Save combining phases for        MI89 311
#                                      Another day                      MI89 312
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MI89 313
WNT20(IPTR+1) = FAZFM2#                                                 MI89 314
WNT20(IPTR+2) = FAZA2#                                                  MI89 315
WNT20(IPTR+3) = FAZB2#                                                  MI89 316
IPTR = IPTR+3#                                                          MI89 317
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MI89 318
DO J=1,NDATIN#                         Loop over derivatives            MI89 319
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MI89 320
DO JJ=1,NONC#                          Loop over per deriv. item        MI89 321
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MI89 322
IPTR=IPTR+1#                                                            MI89 323
#                                                                       MI89 324
# NOW CONSTRUCT THE WANT LIST FOR THOSE QUANTITIES                      MI89 325
# WHICH WILL BE NEEDED IN SUBSEQUENT CALCULATIONS. SEE WNTAV DATA       MI89 326
# STATEMENT AND COMMENT ABOVE.                                          MI89 327
# -------------------------------------------------------------------   MI89 328
#                                                                       MI89 329
WNT20(IPTR)=BDFSEQ(J)*1000+IABS(WNTAV(JJ))#                             MI89 330
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MI89 331
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MI89 332
SIGA20(3)=IPTR ; SIGC20(3)=IPTR#       Now set packet size              MI89 333
#                                                                       MI89 334
# FIND THE CORRECT OFFSETS FOR THE QUANTITIES TO BE UPDATED FROM FILE A MI89 335
# AND FILE C WHICH ARE MERGED AND WRITTEN TO OR DELETED FROM FILEB.     MI89 336
# --------------------------------------------------------------------- MI89 337
#                                                                       MI89 338
indexpkt:(1,lrrefl:,PSIZ1,IPTA,2,SIGA20,WNT20,GETA20)#                  MI89 339
PSIZ2=SIGA20(4)#                       Pick up the file b pkt length    MI89 340
#                                                                       MI89 341
#                                                                       MI89 342
# COMPACT THE FILE A HEADER PACKET INTO THE NEW FILE B HEADER PACKET    MI89 343
# ------------------------------------------------------------------    MI89 344
#                                                                       MI89 345
IPTB=IOPKPT(2)#                        Set up for loop over file b      MI89 346
#                                                                       MI89 347
indexpkt:(3,lrrefl:,PSIZ3,IPTC,0,SIGC20,WNT20,GETC20)#                  MI89 348
#                                                                       MI89 349
IF(PPRIOR>4)#                          At low print priority dump pkt   MI89 350
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 MI89 351
writeline:(1,MI89A,NMI89A,3,5)#        Write header for pkt items       MI89 352
LINRM=6#                                                                MI89 353
JJ=MAX0(PSIZ1,PSIZ2,PSIZ3,IPTR)#       Find longest packet              MI89 354
DO J=1,JJ#                             Loop over longest possible pkt   MI89 355
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 MI89 356
DO K=1,6;BUFOT(K)=0.0#                 Clear o/p to zero for nondata    MI89 357
IF(J<=IPTR) BUFOT(1)=FLOAT(WNT20(J))#  Get file a and c want list       MI89 358
IF(J<=PSIZ1) BUFOT(2)=QX(IPTA+J)#      File a idnums                    MI89 359
IF(J<=IPTR) BUFOT(3)=FLOAT(GETA20(J))## File a offset pointers          MI89 360
IF(J<=PSIZ2) BUFOT(4)=QX(IPTB+J)#      File b idnums                    MI89 361
IF(J<=PSIZ3) BUFOT(5)=QX(IPTC+J)#      File c idnums                    MI89 362
IF(J<=IPTR) BUFOT(6)=FLOAT(GETC20(J))## File c offset pointers          MI89 363
ncodefld:(BUFOT,1,CHROT,FMDM,6)#                                        MI89 364
writeline:(0,MI89B,NMI89B,1,5)#        Write dump of pkt info           MI89 365
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 MI89 366
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 MI89 367
#                                                                       MI89 368
#                                                                       MI89 369
REPEAT#                                Loop over the reflections        MI89 370
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 MI89 371
readwpkt:(1,lrrefl:,PSIZ1,IPTA,0)#     Read filea                       MI89 372
IF(IPTA == 0)  BREAK#                                                   MI89 373
readwpkt:(3,lrrefl:,PSIZ3,IPTC,0)#     Read filec                       MI89 374
IF(IPTC == 0)  iquit:(98902.)#         Should terminate at the same     MI89 375
#                                         Time as file a.               MI89 376
#                                                                       MI89 377
writepkt:(2,lrrefl:,PSIZ2,IPTB)#       Assign output buffer space       MI89 378
#                                                                       MI89 379
J=IPTB+1#                              Set up for loop over file a  ^   MI89 380
DO I=1,PSIZ1#                          Examine all of old file a        MI89 381
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 MI89 382
movepakwd:(QX(IPTA+I),QX(J))#          Move input word to output        MI89 383
J=J+1#                                 Advance file b pointer           MI89 384
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 MI89 385
#                                                                       MI89 386
# NOW FETCH THE NEW STUFF FROM FILE C AND PLACE IT IN FILEB             MI89 387
#                                                                       MI89 388
IPTRR=0#                               Set item pointer to zero         MI89 389
DO J=1,JJ#                             Loop one/refl items @@@@@@       MI89 390
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 MI89 391
IPTRR=IPTRR+1#                         Advance item pointer             MI89 392
IF(GETC20(IPTRR)<=0\GETA20(IPTRR)<=0) NEXT# Skip the items not there    MI89 393
JC=IPTC+GETC20(IPTRR)#                 Get offset to new data in c      MI89 394
JB=IPTB+GETA20(IPTRR)#                 Get offset to locate file c      MI89 395
movepakwd:(QX(JC),QX(JB))#             Get offset loc on file b         MI89 396
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 MI89 397
DO J=1,NDATIN#                         Loop over all data sets          MI89 398
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 MI89 399
DO JJ=1,NONC#                          Loop over all item/dataset       MI89 400
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 MI89 401
IPTRR=IPTRR+1#                         Advance item pointer             MI89 402
IF(GETC20(IPTRR)<=0\GETA20(IPTRR)<=0) NEXT# Skip the items not there    MI89 403
JC=IPTC+GETC20(IPTRR)#                                                  MI89 404
JB=IPTB+GETA20(IPTRR)#                                                  MI89 405
movepakwd:(QX(JC),QX(JB))#             Move data item                   MI89 406
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 MI89 407
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 MI89 408
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 MI89 409
#                                                                       MI89 410
readwpkt:(3,lrrefl:,PSIZ3,IPT3,0)#     Make sure that both files        MI89 411
IF(IPT3 != 0)  iquit:(98902.)#         Ended together.                  MI89 412
#                                                                       MI89 413
readwpkt:(3,endrecord:,PSIZ3,IPT3,0)#  Finish reading file c            MI89 414
copyfile:(1,2,incr:(lrrefl:),endrecord:)#                               MI89 415
#                                                                       MI89 416
RETURN#                                                                 MI89 417
END#                                                                    MI89 418
systemheader:(MI91)#                                                    MI91   1
# ################################################################## #  MI91   2
#                                                                    #  MI91   3
#                               MI91                                 #  MI91   4
#                                                                    #  MI91   5
# ################################################################## #  MI91   6
#                                                                       MI91   7
SUBROUTINE MI91(MAT,VEC,NCOEF)#                                         MI91   8
#                                                                       MI91   9
#     SOLVE FOR SHIFTS OF PARAMETERS                                    MI91  10
#                                                                       MI91  11
REAL MAT(1275)#                        Assumed 50x50 as largest matri   MI91  12
REAL VEC(50)#                                                           MI91  13
REAL RMAT(50,50)#                                                       MI91  14
REAL RVEC(50)#                                                          MI91  15
REAL RAVE#                                                              MI91  16
REAL DET#                                                               MI91  17
INTEGER NCOEF#                                                          MI91  18
chardata:(MI91A, SINGULAR MATRIX FOUND IN MI91)#                        MI91  19
datastuff:#                                                             MI91  20
K = 0#                                                                  MI91  21
DO J=1,NCOEF#                          Build complete matrix            MI91  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI91  23
DO I=1,J#                                                               MI91  24
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI91  25
K = K + 1#                                                              MI91  26
RMAT(I,J) = MAT(K)#                                                     MI91  27
RMAT(J,I) = MAT(K)#                                                     MI91  28
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI91  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI91  30
DO J=1,NCOEF#                                                           MI91  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI91  32
RVEC(J) = VEC(J)#                                                       MI91  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI91  34
RAVE = 0.0#                                                             MI91  35
CALL MI97(RMAT,RAVE,NCOEF)#            Scale the matrix                 MI91  36
CALL MI98(RMAT,NCOEF,DET)#             Invert matrix                    MI91  37
IF (DET < 0)#                                                           MI91  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI91  39
writeline:(1,MI91A,NMI91A,3,1)#        'singular matrix found'          MI91  40
iquit:(MI9101)#                                                         MI91  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI91  42
CALL MI97(RMAT,RAVE,NCOEF)#            Rescale the matrix               MI91  43
#                                                                       MI91  44
DO J=1,NCOEF#                          Calc shifts of parameters        MI91  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI91  46
VEC(J) = 0.0#                                                           MI91  47
DO I=1,NCOEF#                                                           MI91  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI91  49
VEC(J) = VEC(J) + RMAT(I,J)*RVEC(I)#                                    MI91  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI91  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI91  52
# TRANSFER MATRIX BACK INTO TRIANGULAR MATRIX                           MI91  53
K = 0#                                                                  MI91  54
DO J=1,NCOEF#                                                           MI91  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI91  56
DO I=1,J#                                                               MI91  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI91  58
K = K + 1#                                                              MI91  59
MAT(K) = RMAT(I,J)#                                                     MI91  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI91  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI91  62
RETURN#                                                                 MI91  63
END#                                                                    MI91  64
#                                                                       MI91  65
systemheader:(MI97)#                                                    MI97   1
# ################################################################## #  MI97   2
#                                                                    #  MI97   3
#                               MI97                                 #  MI97   4
#                                                                    #  MI97   5
# ################################################################## #  MI97   6
#                                                                       MI97   7
SUBROUTINE MI97(RMAT,RAVE,NCOEF)#                                       MI97   8
#                                                                       MI97   9
#     ADJUSTS THE MATRIX AND VECTOR OF THE LEAST SQUARES PROBLEM        MI97  10
#       TO HAVE MAGNITUDES NEAR ONE FOR THE MATRIX INVERSION            MI97  11
#                                                                       MI97  12
REAL RMAT(50,50)#                                                       MI97  13
#                                                                       MI97  14
#     IF RAVE IS NOT ZERO, GO AND SCALE BY IT                           MI97  15
#                                                                       MI97  16
IF (NCOEF > 50) iquit:(MI9701)#                                         MI97  17
IF (RAVE==0.0)#                                                         MI97  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI97  19
#                                                                       MI97  20
#     FIND THE SMALLEST AND LARGEST ELEMENTS                            MI97  21
#     ALSO THE AVERAGE                                                  MI97  22
#                                                                       MI97  23
RAVE=0.0#                                                               MI97  24
RMIN=10E+8#                                                             MI97  25
RMAX=10E-8#                                                             MI97  26
DO I=1,NCOEF#                                                           MI97  27
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI97  28
DO J=1,NCOEF#                                                           MI97  29
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI97  30
AR=ABS(RMAT(I,J))#                                                      MI97  31
RAVE=RAVE+AR#                                                           MI97  32
IF (AR>RMAX) RMAX=AR#                                                   MI97  33
IF (AR<RMIN) RMIN=AR#                                                   MI97  34
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI97  35
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI97  36
RAVE=RAVE/(NCOEF*NCOEF)#                                                MI97  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI97  38
#                                                                       MI97  39
#      SCALE EVERYTHING BY RAVE                                         MI97  40
#                                                                       MI97  41
DO I=1,NCOEF#                                                           MI97  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI97  43
DO J=1,NCOEF#                                                           MI97  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI97  45
RMAT(I,J)=RMAT(I,J)/RAVE#                                               MI97  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI97  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI97  48
RETURN#                                                                 MI97  49
END#                                                                    MI97  50
systemheader:(MI98)#                                                    MI98   1
# ################################################################## #  MI98   2
#                                                                    #  MI98   3
#                               MI98                                 #  MI98   4
#                                                                    #  MI98   5
# ################################################################## #  MI98   6
#                                                                       MI98   7
SUBROUTINE MI98(ARRAY,NORDER,DET)#                                      MI98   8
#                                                                       MI98   9
#     MATRIX INVERSION ROUTINE TAKEN FROM BEVINGTON.                    MI98  10
#                                                                       MI98  11
INTEGER IK(50)#                                                         MI98  12
INTEGER JK(50)#                                                         MI98  13
REAL ARRAY(50,50)#                                                      MI98  14
REAL SAVE#                                                              MI98  15
REAL AMAX#                                                              MI98  16
#                                                                       MI98  17
DET=1#                                                                  MI98  18
IF (NORDER >50) iquit:(MI9801)#                                         MI98  19
DO K=1,NORDER#                                                          MI98  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MI98  21
AMAX=0.0#                                                               MI98  22
DO I=K,NORDER#                                                          MI98  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MI98  24
DO J=K,NORDER#                                                          MI98  25
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MI98  26
IF (ABS(AMAX)<=ABS(ARRAY(I,J)))#                                        MI98  27
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MI98  28
AMAX=ARRAY(I,J)#                                                        MI98  29
IK(K)=I#                                                                MI98  30
JK(K)=J#                                                                MI98  31
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MI98  32
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MI98  33
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MI98  34
IF (AMAX==0.0)#                                                         MI98  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MI98  36
DET=0.0#                                                                MI98  37
BREAK#                                                                  MI98  38
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MI98  39
I=IK(K)#                                                                MI98  40
IF (I<K) NEXT#                                                          MI98  41
ELSE IF (I>K)#                                                          MI98  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MI98  43
DO J=1,NORDER#                                                          MI98  44
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MI98  45
SAVE =ARRAY(K,J)#                                                       MI98  46
ARRAY(K,J)=ARRAY(I,J)#                                                  MI98  47
ARRAY(I,J)=-SAVE#                                                       MI98  48
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MI98  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MI98  50
J=JK(K)#                                                                MI98  51
IF (J<K) NEXT#                                                          MI98  52
ELSE IF (J>K)#                                                          MI98  53
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MI98  54
DO I=1,NORDER#                                                          MI98  55
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MI98  56
SAVE =ARRAY(I,K)#                                                       MI98  57
ARRAY(I,K)=ARRAY(I,J)#                                                  MI98  58
ARRAY(I,J)=-SAVE#                                                       MI98  59
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MI98  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MI98  61
DO I=1,NORDER#                                                          MI98  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MI98  63
IF (I!=K)#                                                              MI98  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MI98  65
ARRAY(I,K)=-ARRAY(I,K)/AMAX#                                            MI98  66
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MI98  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MI98  68
DO I=1,NORDER#                                                          MI98  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MI98  70
DO J=1,NORDER#                                                          MI98  71
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MI98  72
IF (I!=K)#                                                              MI98  73
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MI98  74
IF (J!=K)#                                                              MI98  75
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MI98  76
ARRAY(I,J)=ARRAY(I,J)+ARRAY(I,K)*ARRAY(K,J)#                            MI98  77
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MI98  78
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MI98  79
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MI98  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MI98  81
DO J=1,NORDER#                                                          MI98  82
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MI98  83
IF (J!=K)#                                                              MI98  84
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MI98  85
ARRAY(K,J)=ARRAY(K,J)/AMAX#                                             MI98  86
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MI98  87
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MI98  88
ARRAY(K,K)=1./AMAX#                                                     MI98  89
DET=DET*AMAX#                                                           MI98  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MI98  91
DO L=1,NORDER#                                                          MI98  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MI98  93
K=NORDER-L+1#                                                           MI98  94
J=IK(K)#                                                                MI98  95
IF (J>K)#                                                               MI98  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MI98  97
DO I=1,NORDER#                                                          MI98  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MI98  99
SAVE =ARRAY(I,K)#                                                       MI98 100
ARRAY(I,K)=-ARRAY(I,J)#                                                 MI98 101
ARRAY(I,J)=SAVE#                                                        MI98 102
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MI98 103
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MI98 104
I=JK(K)#                                                                MI98 105
IF (I>K)#                                                               MI98 106
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MI98 107
DO J=1,NORDER#                                                          MI98 108
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MI98 109
SAVE =ARRAY(K,J)#                                                       MI98 110
ARRAY(K,J)=-ARRAY(I,J)#                                                 MI98 111
ARRAY(I,J)=SAVE#                                                        MI98 112
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MI98 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MI98 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MI98 115
RETURN#                                                                 MI98 116
END#                                                                    MI98 117
pmacro:([no:])#                                                         MI98 118
#                                                                       MI98 119
