systemheader:(PB    )#                                                  PB     1
####################################################################### PB     2
##      Copyright (C) 2000, The Xtal System, The University of        # PB     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # PB     4
## Distributed under the GNU General Public Licence as published by   # PB     5
## the Free Software Foundation, in the hope that it will be useful   # PB     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # PB     7
## for more details.                                                  # PB     8
##                                                                    # PB     9
##                      *** PREPUB ***                                # PB    10
##                                                                    # PB    11
##   This program performs a number of validation checks on the       # PB    12
##   compid.cif for consistent symmetry, molecular weight,            # PB    13
##   molecules per cell (Z) and legitimate reflection measurement     # PB    14
##   and usage.                                                       # PB    15
##                                                                    # PB    16
####################################################################### PB    17
include:(XMACRO)#                      Include macros and write commo   PB    18
#                                                                       PB    19
macro:(mat:,16)#                       Maximum number of atom types     PB    20
macro:(mnas:,2000)#                    Maximum number of atom sites     PB    21
macro:(miref:,100000)#                 Maximum number of indep refs     PB    22
macro:(debug:,0)#                      Debug=0/1=off/on                 PB    23
#                                                                       PB    24
macro:(try:,$(XCEPT=0;$1;IF(XCEPT!=0)RETURN $) )# Try to execute        PB    25
macro:(raiseexception:,$(XCEPT=$1;RETURN$))# Throw an exception         PB    26
macro:(catchexception:,IF(XCEPT!=0)RETURN)# Catch the exception         PB    27
macro:(lquit:,$([#                     Local quit from subroutine       PB    28
CHROT=' ALERT: '//$1;writeline:(1,' ',0,1,2)# Dump error message        PB    29
raiseexception:(1)]$) )#               Set flag and return              PB    30
#                                                                       PB    31
macro:(dbx:,IF(DEBUG==1))#                                              PB    32
macro:(dp:,ifelse:(mxbtwd:,32,DOUBLE PRECISION,REAL))#                  PB    33
macro:(sg:,ifelse:(dp:,REAL,$1,SNGL($1)))#                              PB    34
macro:(db:,ifelse:(dp:,REAL,$1,DBLE($1)))#                              PB    35
macro:(getnum:,CALL PB90($1,$2,$3,$4))# Decode number from string       PB    36
macro:(char:,1)#                                                        PB    37
macro:(numb:,2)#                                                        PB    38
#                                                                       PB    39
extrude:(PBCOMN)#                                                       PB    40
flagon:(R)                                                                      
       INCLUDE  'ciftbx.cmn'                                                    
flagoff:(R)                                                                     
INTEGER ICNT#                          0=centro,1=non-centro            PB    44
INTEGER NCRYS#                         Crystal system number            PB    45
INTEGER LTYP#                          Lattice type                     PB    46
INTEGER SGN#                           Sgname switch from latice line   PB    47
INTEGER NREM#                          Count of remaining matrices      PB    48
INTEGER ICHR#                          Op character counter             PB    49
INTEGER IROT#                          Rotation code                    PB    50
INTEGER JROT#                          Rotation code retained           PB    51
INTEGER ITRN#                          Translation code                 PB    52
INTEGER SROT(6)#                       Save rotations from sgname       PB    53
INTEGER SAXS(6)#                       Save axes of sgname              PB    54
INTEGER NSYM#                          Number of symops                 PB    55
INTEGER SYMFAC#                        Totalnum of sym equiv pos        PB    56
INTEGER DEBUG#                                                          PB    57
INTEGER SMAT(16,200)#                  Symop array                      PB    58
REAL    RSMAT(12,200)#                                                  PB    59
INTEGER SYMSTR#                        Save symmap start                PB    60
INTEGER SYMSTP#                        Save symmap stop                 PB    61
INTEGER CIFSTR#                        Save cif start                   PB    62
INTEGER CIFSTP#                        Save cif stop                    PB    63
INTEGER XCEPT#                                                          PB    64
#                                                                       PB    65
string:(SYMMAP,40)#                    Record symmap data blok name     PB    66
string:(BLKNAM,40)#                    Record current cif blok name     PB    67
string:(STRG,40)#                      General string buffer            PB    68
string:(ITNM,40)#                      General string buffer            PB    69
string:(HALL,40)#                      Hall notation                    PB    70
string:(MAUG,40)#                      Herman-maugin notation           PB    71
string:(SHIFT,8)#                      For sgname shift string          PB    72
#                                                                       PB    73
COMMON/COMIPB/ NCRYS,NREM,ICHR,IROT,JROT,ITRN,LTYP,SROT,SAXS,#          PB    74
ICNT,NSYM,SGN,SYMFAC,SMAT,SYMSTR,SYMSTP,CIFSTR,CIFSTP,#                 PB    75
DEBUG,XCEPT#                                                            PB    76
#                                                                       PB    77
COMMON/COMFPB/RSMAT#                                                    PB    78
#                                                                       PB    79
COMMON/COMCPB/STRG,SHIFT,HALL,MAUG,ITNM,SYMMAP,BLKNAM#                  PB    80
endext:#                                                                PB    81
#                                                                       PB    82
systemheader:(PB00)#                                                    PB00   1
#################################################################       PB00   2
#                                                               #       PB00   3
#                             PB00                              #       PB00   4
#                                                               #       PB00   5
#################################################################       PB00   6
SUBROUTINE PB00#                                                        PB00   7
include:(AACOMN)#                                                       PB00   8
include:(PBCOMN)#                                                       PB00   9
#                                                                       PB00  10
INTEGER LNBLNK#                        Function returning int           PB00  11
LOGICAL F1,F2,F3#                                                       PB00  12
INTEGER NBLK#                                                           PB00  13
INTEGER I#                                                              PB00  14
REAL    GAMMA,SDEV#                                                     PB00  15
string:(DUMMY,4)#                                                       PB00  16
string:(CFILE,12)#                                                      PB00  17
chardata:(PB001,' >>>>> Check input data names against dictionary.')#   PB00  18
chardata:(PB002,' >>>>> End of CIF dictionary checking.')#              PB00  19
chardata:(PB003,' INPUT FILE:                ')#                        PB00  20
chardata:(PB004,' >>>>>>>>>>>>>>>>> Data block:                   ')#   PB00  21
datastuff:#                                                             PB00  22
DEBUG=debug:#                                                           PB00  23
#                                                                       PB00  24
# READ IN THE CIF FILE WITH CIFTBX                                      PB00  25
# --------------------------------                                      PB00  26
#                                                                       PB00  27
FOR(I=6;COMPID(I^I)==' ';I=I-1);#      Detect trailing blanks           PB00  28
CFILE=COMPID(1^I)//'.cif'#             Specify  cif to be checked       PB00  29
movechar:(CFILE,1,PB003,15,10,0)#      Insert the file name             PB00  30
writeline:(2,PB003,NPB003,2,3)#        Write out cif file header        PB00  31
#                                                                       PB00  32
writeline:(1,PB001,NPB001,2,3)#        Write out dictionary header      PB00  33
APPEND_=.FALSE.#                       Overwrite any existing           PB00  34
F1=INIT_(iofm1:, 0, ioda1:, ioprt:)#   Set device numbers               PB00  35
F1=DICT_(' ','close')#                 Close any existing dictionarie   PB00  36
F2= DICT_(cifdic1:,'dtype')#           Open main dictionary             PB00  37
IF(!F2)              iquit:(CF5055)#   Open main dictionary             PB00  38
F2= DICT_(cifdic2:,'dtype')#           Open secondary dictionay         PB00  39
IF(!OCIF_(CFILE))    iquit:(CF5060)#   Open cif to be checked           PB00  40
FOR(NBLK=0;DATA_(' ');NBLK=NBLK+1)#    Check each data block in cif     PB00  41
BLKNAM=BLOC_#                          Record last data block name      PB00  42
IF(NBLK<=0)          iquit:(SX1310)#   No data block in cif             PB00  43
CIFSTR=RECBEG_#                        Save cif start                   PB00  44
CIFSTP=RECEND_#                        Save cif stop                    PB00  45
SYMSTR=1+CIFSTP#                       Save symmap start                PB00  46
F2= DICT_(' ','close')#                Close all dictionaries           PB00  47
writeline:(1,PB002,NPB002,2,3)#        Write out dictionary trailer     PB00  48
#                                                                       PB00  49
# APPEND THE SYMMAP FILE TO THE CIF FILE                                PB00  50
# --------------------------------------                                PB00  51
#                                                                       PB00  52
APPEND_=.TRUE.#                        Overwrite any existing           PB00  53
F3=INIT_(iofm2:, 0,  ioda1:, ioprt:)#  Set device numbers               PB00  54
IF(!OCIF_(symmapp:)) iquit:(SX1305)#   Where is the map file?           PB00  55
IF(!DATA_(BLKNAM))   iquit:(SX1310)#   Fudge ciftbx error               PB00  56
IF(!DATA_(' '))      iquit:(SX1310)#   Notation data block missing!     PB00  57
SYMMAP=BLOC_#                          Record symmap block name         PB00  58
SYMSTP=RECEND_#                        Save symmap stop                 PB00  59
#                                                                       PB00  60
# PARSE CIF FOR DATA BLOCKS AND RUN IUCR DATA VALIDATION TESTS          PB00  61
# ------------------------------------------------------------          PB00  62
#                                                                       PB00  63
RECBEG_=CIFSTR#                        Start checking  only the cif     PB00  64
RECEND_=CIFSTP#                        End of input cif data blocks     PB00  65
F1=FIND_(' ','head',DUMMY)#            Reset ciftbx to preread state    PB00  66
#                                                                       PB00  67
FOR(NBLK=0;DATA_(' ');NBLK=NBLK+1)#    Check each data block in cif     PB00  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB00  69
movechar:('=',1,CHROT,2,75,1)#         Insert the file name             PB00  70
writeline:(1,0,0,2,3)#                 Write out cif file header        PB00  71
movechar:(BLOC_,1,PB004,32,18,0)#      Insert dat block name            PB00  72
writeline:(0,PB004,NPB004,2,3)#        Write out the block name         PB00  73
BLKNAM=BLOC_#                          Record current data block        PB00  74
IF(!NUMB_('_cell_angle_alpha',GAMMA,SDEV))# No cell parameters here     PB00  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB00  76
NEXT#                                  Jump to next data block          PB00  77
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB00  78
#                                                                       PB00  79
# GET BLOCK POINTERS                                                    PB00  80
# ------------------                                                    PB00  81
#                                                                       PB00  82
CALL PB10#                             Dvntest  symmg_01                PB00  83
CALL PB20#                             Dvntest  symmg_02                PB00  84
CALL PB30#                             Dvntest  cellz_01                PB00  85
CALL PB40#                             Dvntest  chemw_03                PB00  86
CALL PB50#                             Dvntest  reflt_03                PB00  87
CALL PB60#                             Dvntest  strval_02               PB00  88
F1=DATA_(BLKNAM)#                      Reselect current cif data bloc   PB00  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB00  90
IF(NBLK==0)          iquit:(CF5065)#   No data blocks present           PB00  91
CALL PURGE_#                           Reset the cif tool box           PB00  92
#                                                                       PB00  93
RETURN#                                                                 PB00  94
END#                                                                    PB00  95
systemheader:(PB10)#                   Real name  symmg_01              PB10   1
#################################################################       PB10   2
#                                                               #       PB10   3
#                             PB10                              #       PB10   4
#                                                               #       PB10   5
#################################################################       PB10   6
SUBROUTINE PB10#                                                        PB10   7
include:(AACOMN)#                                                       PB10   8
include:(PBCOMN)#                                                       PB10   9
#                                                                       PB10  10
LOGICAL       F1,F2,F3#                                                 PB10  11
CHARACTER*80  NAME#                                                     PB10  12
CHARACTER*80  HALL1,MAUG1,MAUG2#                                        PB10  13
string:(SNAME,80)#                                                      PB10  14
#                                                                       PB10  15
INTEGER       I,J,K,L,MATCH,NH1,NM,NM1,NM0#                             PB10  16
INTEGER       TEST#                    Test modes                       PB10  17
REAL          NUM,SDEV#                                                 PB10  18
REAL          GAMMA#                                                    PB10  19
INTEGER       SGNUM,NID,SGID#                                           PB10  20
INTEGER       COLON#                                                    PB10  21
chardata:(SY01,'123456789')#                                            PB10  22
chardata:(SY02,'#<>.?|";(){}[]~!@$%^&*+=')# Illegal h-m characters      PB10  23
chardata:(SHLX,'(1)(2)(3)(4)(6)')#     Sheldricks subscripts            PB10  24
chardata:(OTHR,'~1~~2~~3~~4~~6~')#     Cif subscripts                   PB10  25
datastuff:#                                                             PB10  26
#                                                                       PB10  27
WRITE(6,'(//a)') ' SYMMG_01: Check the space group number'#             PB10  28
WRITE(6,'( a)') ' --------------------------------------'#              PB10  29
#                                                                       PB10  30
F1=NUMB_('_cell_angle_gamma',GAMMA,SDEV)# For trigonal cell checks      PB10  31
IF(!F1)#                                                                PB10  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB10  33
WRITE(6,*)"No cell Information in data block"//BLOC_#                   PB10  34
RETURN#                                                                 PB10  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB10  36
##                                                                      PB10  37
##  LOOK FOR SPACE GROUP NUMBER                                         PB10  38
##  ---------------------------                                         PB10  39
##                                                                      PB10  40
TEST=1#                                                                 PB10  41
IF(!NUMB_('_symmetry_space_group_number',NUM,SDEV))# Test   requested   PB10  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB10  43
IF(!NUMB_('_symmetry_Int_Tables_number', NUM,SDEV))# Cifdic numeric     PB10  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB10  45
IF(!CHAR_('_symmetry_space_group_id', NAME))# Symmap char               PB10  46
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PB10  47
WRITE(6,'(/a,10x,a)')$#                                                 PB10  48
' From the CIF: _symmetry_space_group_number ',' ?'#                    PB10  49
TEST=0#                                                                 PB10  50
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PB10  51
ELSE WRITE(6,'(/a,10x,a)')' From the CIF: _symmetry_space_group_id ',#  PB10  52
NAME(1^LONG_)#                                                          PB10  53
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB10  54
ELSE WRITE(6,'(a,a,11x,I5)')' From the CIF: ',#                         PB10  55
'_symmetry_Int_Tables_number ',NINT(NUM)#                               PB10  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB10  57
ELSE WRITE(6,'(a,a,11x,I5)')' From the CIF: ',#                         PB10  58
'_symmetry_space_group_number',NINT(NUM)#                               PB10  59
SGNUM=NINT(NUM)#                                                        PB10  60
#                                                                       PB10  61
#  LOOK FOR HERMANN-MAUGIN NOTATION ON CIF                              PB10  62
#  ---------------------------------------                              PB10  63
#                                                                       PB10  64
NAME=' ';SNAME=' ';COLON=0#            Assume no :h/:r/:1/:2            PB10  65
IF(!CHAR_('_symmetry_space_group_name_H-M', NAME))#                     PB10  66
$( WRITE(6,'(/a/)')$#                                                   PB10  67
' _symmetry_space_group_name_H-M s not in the CIF';RETURN#              PB10  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PB10  69
NM0=LONG_#                             Length of original name          PB10  70
WRITE(6,'(a,10x,a)')' From the CIF: _symmetry_space_group_name_H-M',#   PB10  71
NAME(1^NM0)#                                                            PB10  72
#                                                                       PB10  73
MAUG1=NAME#                                                             PB10  74
DO J=1,NM0#                            Loop over table symbol           PB10  75
IF(INDEX(SHLX,MAUG1(J^J+2))>0)#        Detect shelx axes brakets        PB10  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PB10  77
MAUG1(J^NM0-1)=MAUG1(J+1^J+1)//' '//MAUG1(J+3^NM0)# Remove brackets     PB10  78
NM0=NM0-1#                             Reduce length of string          PB10  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PB10  80
DO J=1,NM0#                            Loop over table symbol           PB10  81
IF(INDEX(OTHR,MAUG1(J^J+2))>0)#        Detect shelx axes brakets        PB10  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PB10  83
MAUG1(J^NM0-1)=MAUG1(J+1^J+1)//' '//MAUG1(J+3^NM0)# Remove brackets     PB10  84
NM0=NM0-1#                             Reduce length of string          PB10  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PB10  86
#                                                                       PB10  87
#                                                                       PB10  88
NM=0#                                  Start notation length            PB10  89
DO J=1,NM0#                            Loop over table symbol           PB10  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PB10  91
IF(MAUG1(J^J)==' '\MAUG1(J^J)=='_') NEXT# Strip blanks and underscore   PB10  92
NM=NM+1#                               Increment number coppied chars   PB10  93
MAUG(NM^NM)=MAUG1(J^J)#                Copy characters                  PB10  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PB10  95
locase:(MAUG,MAUG,NM)#                 Convert string to lower case     PB10  96
DO J=1,NM;IF(INDEX(SY02,MAUG(J^J))>0)BREAK# Detect illegal comments     PB10  97
IF(J<=NM)NM=J-1#                       Strip                            PB10  98
DO J=1,NM;IF(MAUG(J^J)==':')BREAK#     Search for colon                 PB10  99
IF(J<NM)COLON=1#                       Must be trigonal                 PB10 100
#                                                                       PB10 101
#    SCAN SYMMAP FILE FOR  H-M GROUP MATCH                              PB10 102
#    -------------------------------------                              PB10 103
#                                                                       PB10 104
RECBEG_=SYMSTR; RECEND_=SYMSTP#        Reset min and max pointers       PB10 105
IF(!DATA_(SYMMAP))      lquit:('NO DATA BLOCK IN CIF')# Data block mi   PB10 106
#                                                                       PB10 107
REPEAT#                                Loop over notation               PB10 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PB10 109
F1=CHAR_('_symmetry_space_group_name_Hall',HALL1)# Get hall symbol      PB10 110
NH1=LONG_#                             And its length                   PB10 111
F2=CHAR_('_symmetry_space_group_name_H-M',MAUG1)# Get h-m symbol        PB10 112
NM1=LONG_#                             And its length                   PB10 113
F3=CHAR_('_symmetry_space_group_id',ITNM)# Get space group id number    PB10 114
NID=LONG_#                             And its length                   PB10 115
MATCH=yes:#                            Flag for match                   PB10 116
#                                                                       PB10 117
IF(COLON==0&MAUG1(NM1-1^NM1-1)==':')NM1=NM1-2# Erase :x for pattern m   PB10 118
#                                                                       PB10 119
MAUG2=' ';K=NM1;NM1=0#                 Start notation length            PB10 120
DO J=1,K#                              Loop over table symbol           PB10 121
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PB10 122
IF(MAUG1(J^J)==' '\MAUG1(J^J)=='_') NEXT# Strip blanks and underscore   PB10 123
NM1=NM1+1#                             Increment number coppied chars   PB10 124
MAUG2(NM1^NM1)=MAUG1(J^J)#             Copy characters                  PB10 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PB10 126
locase:(MAUG2,MAUG2,NM1)#              Convert string to lower case     PB10 127
IF(NM==NM1)#                           If lengths the same              PB10 128
IF(MAUG(1^NM)==MAUG2(1^NM)) BREAK#     Exit if match found              PB10 129
#                                                                       PB10 130
MATCH=no:#                             No match yet                     PB10 131
IF(!LOOP_) BREAK#                      Exit if notation finished        PB10 132
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PB10 133
NM1=K#                                                                  PB10 134
#                                                                       PB10 135
# NOTE THAT IN THIS TEST NON STANDARD SETTINGS HAVE THE SAME            PB10 136
# SPACE GROUP NUMBER AS THE STANDARD SETTINGS ETC, SO NO NEED           PB10 137
# TO DISTINGUISH BETWEEN THEM. I.E. CAN IGNORE ANY COLON EXTENSIONS     PB10 138
#                                                                       PB10 139
SGID=0#                                                                 PB10 140
IF(MATCH==yes: & F3)#                  H-m symbol match and id presen   PB10 141
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PB10 142
DO J=1,NID;IF(ITNM(J^J)!=' ') BREAK#   Get first char                   PB10 143
DO I=J,NID;IF(ITNM(I^I)==' '\ITNM(I^I)==':') BREAK# Get last char       PB10 144
NID=I-J#                               Number of chars                  PB10 145
IF (NID>3)#                                                             PB10 146
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PB10 147
WRITE(6,'(/a/)')' NO match for space group in symmetry map'#            PB10 148
TEST=0#                                Cancell the test                 PB10 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PB10 150
ELSE#                                  Construct integer from string    PB10 151
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PB10 152
SGID=0;L=0;J=J-1#                      Initialize                       PB10 153
DO I=NID,1,-1#                                                          PB10 154
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PB10 155
K=INDEX(SY01,ITNM(I+J^I+J))#           Get lower case index             PB10 156
SGID=SGID+K*(10**L)#                                                    PB10 157
L=L+1#                                                                  PB10 158
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PB10 159
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PB10 160
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PB10 161
ELSE TEST=0#                           Cancel sg number test            PB10 162
#                                                                       PB10 163
WRITE(6,'(/4a,i4)') ' International Tables ',#                          PB10 164
'space group number for ', MAUG1(1^NM1),' is',SGID#                     PB10 165
#                                                                       PB10 166
IF(MATCH==no:)#                        Symbols didn't match             PB10 167
WRITE(6,'(/a/)')$#                                                      PB10 168
' SYMMG_01: ALERT Unrecognised _symmetry_space_group_name_H-M'# Sy      PB10 169
ELSE IF(TEST==1 & SGID !=SGNUM )#                                       PB10 170
WRITE(6,'(/a,a/)')' SYMMG_01: ALERT _symmetry_space_group_number',#     PB10 171
' does not match H-M symbol'#                                           PB10 172
ELSE WRITE(6,'(/a/)')' SYMMG_01: OK '#                                  PB10 173
#                                                                       PB10 174
RECBEG_=CIFSTR; RECEND_=CIFSTP#        Reset min max access pointers    PB10 175
F1=DATA_(BLKNAM)#                      Reselect current cif data bloc   PB10 176
RETURN#                                                                 PB10 177
END#                                                                    PB10 178
systemheader:(SYMMG2)#                 Real name  symmg_02              SYMM   1
###########################################################             SYMM   2
#                                                                       SYMM   3
# REQUIRE                                                               SYMM   4
#     _SYMMETRY_SPACE_GROUP_NAME_H-M                                    SYMM   5
#                                                                       SYMM   6
# (1) CONVERT TO EQUIVALENT HALL NAME                                   SYMM   7
#     GENERATE SYMOPS                                                   SYMM   8
#     CONVERT SYMOPS BACK TO HALL NAME                                  SYMM   9
#     CONVERT  HALL NAME BACK TO H-M                                    SYMM  10
#                                                                       SYMM  11
# REQUIRE                                                               SYMM  12
# LOOP                                                                  SYMM  13
#     _SYMMETRY_EQUIV_POS_AS_XYZ                                        SYMM  14
#                                                                       SYMM  15
# (2) CONVERT SYMOPS BACK TO HALL NAME                                  SYMM  16
#     CONVERT  HALL NAME BACK TO H-M                                    SYMM  17
#                                                                       SYMM  18
# CHECK  H-M FROM (1) AND (2)                                           SYMM  19
#                                                                       SYMM  20
systemheader:(PB20)#                                                    PB20   1
#################################################################       PB20   2
#                                                               #       PB20   3
#                             PB20                              #       PB20   4
#                                                               #       PB20   5
#################################################################       PB20   6
SUBROUTINE PB20#                                                        PB20   7
include:(AACOMN)#                                                       PB20   8
include:(PBCOMN)#                                                       PB20   9
#                                                                       PB20  10
LOGICAL       F1,F2#                                                    PB20  11
CHARACTER*80  NAME#                                                     PB20  12
CHARACTER*80  HALL1,HALL2,HALL3,MAUG1,MAUG2,MAUG3#                      PB20  13
CHARACTER*80  MAUGNB#                                                   PB20  14
string:(SNAME,80)#                                                      PB20  15
string:(SYMOP,80)#                                                      PB20  16
#                                                                       PB20  17
INTEGER       NSYMS#                                                    PB20  18
INTEGER       MATCH1#                                                   PB20  19
INTEGER       NMNB#                                                     PB20  20
INTEGER       COLON,COLON2#                                             PB20  21
INTEGER       I,IR,J,K,MATCH,NH,NH1,NH2,NH3,NM,NM1,NM2,NN#              PB20  22
REAL          SDEV#                                                     PB20  23
REAL          GAMMA#                                                    PB20  24
intdata:(NUMSYM,[1,2,3,4,6,8,9,12,16,18,24,36,48,96,192])#              PB20  25
intdata:(LATTYP,[1,2,3,4,2,2,2])#      Indexed by ltyp                  PB20  26
chardata:(SY02,'pabcfirhPABCFIRHmndMND-/123456:_ ')# Permited charact   PB20  27
chardata:(SHLX,'(1)(2)(3)(4)(6)')#     Sheldricks subscripts            PB20  28
chardata:(OTHR,'~1~~2~~3~~4~~6~')#     Cif subscripts                   PB20  29
datastuff:#                                                             PB20  30
#                                                                       PB20  31
WRITE(6,'(//a)') ' SYMMG_02: Check the space group is recognised'#      PB20  32
WRITE(6,'( a)') ' ---------------------------------------------'#       PB20  33
#                                                                       PB20  34
STRG=' '#                              Blank out sgname string          PB20  35
LTYP=0;  ICNT=-1#                      Unset moles/cell & symmetry      PB20  36
NSYM=0; SGN=yes:#                      Initialize count of symops.      PB20  37
DO J=1,200#                            Loop over symops                 PB20  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB20  39
SMAT(16,J)=12#                         (4,4) matrix element             PB20  40
DO I=1,15 ; SMAT(I,J)=0#               Others                           PB20  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB20  42
##                                                                      PB20  43
##     BEGIN PART(2)                                                    PB20  44
##                                                                      PB20  45
##     GET _SYMMETRY_EQUIV_POS_AS_XYZ FROM CIF                          PB20  46
##     ---------------------------------------                          PB20  47
##                                                                      PB20  48
F1=NUMB_('_cell_angle_gamma',GAMMA,SDEV)# For trigonal cell checks      PB20  49
#                                                                       PB20  50
REPEAT#                                Get equiv position symops        PB20  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB20  52
IF(!CHAR_('_symmetry_equiv_pos_as_xyz', SYMOP)) BREAK#                  PB20  53
IF(NSYM==0)WRITE(6,'(/a)')' From the CIF: _symmetry_equiv_pos_as_xyz'#  PB20  54
NSYM=NSYM+1#                           Increment number of symops       PB20  55
WRITE(6,'(43x,a)')SYMOP(1^LONG_)#                                       PB20  56
try:(CALL PB91(SYMOP))#                Decode symop to matrix           PB20  57
IF(!LOOP_) BREAK#                      No more packets in loop          PB20  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB20  59
##                                                                      PB20  60
##     CONVERT SYMOPS TO HALL1 NAME                                     PB20  61
##     ----------------------------                                     PB20  62
##                                                                      PB20  63
IF (NSYM>0)#                           If symops present                PB20  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB20  65
DO I=1,15;IF(NSYM==NUMSYM(I))BREAK#    Check for sensible numbers       PB20  66
IF(I>15)#                              I.e. 16 if no match              PB20  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PB20  68
WRITE(6,'(a)')$#                                                        PB20  69
' Invalid number of _symmetry_equiv_pos_as_xyz on CIF'#                 PB20  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PB20  71
NSYMS=NSYM#                            Save number of symops            PB20  72
try:(CALL PB94)#                       Convert symops to hall name      PB20  73
locase:(STRG,HALL1,40); NH=ICHR#                                        PB20  74
WRITE(6,'(/1x,a,a)')$#                                                  PB20  75
'The xyz symops generate the Hall space group symbol   ',HALL1(1^NH)#   PB20  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB20  77
ELSE#                                  No equiv positions here          PB20  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PB20  79
WRITE(6,'(a)')' ALERT: _symmetry_equiv_pos_as_xyz not in the CIF'#      PB20  80
RETURN#                                                                 PB20  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PB20  82
##                                                                      PB20  83
##     END PART(2)   XYZ ->  HALL1                                      PB20  84
##                                                                      PB20  85
##     BEGIN PART(1) H-M -> HALL -> XYZ -> HALL -> H-M                  PB20  86
##                                                                      PB20  87
##                                                                      PB20  88
#                                                                       PB20  89
#   READ HERMAN MAUGIN NAME FROM CIF                                    PB20  90
#   --------------------------------                                    PB20  91
#                                                                       PB20  92
SNAME=' ';NAME=' ';MAUG=' '#           Initialize                       PB20  93
IF(!CHAR_('_symmetry_space_group_name_H-M', NAME))#                     PB20  94
$( WRITE(6,'(/a/)')$#                                                   PB20  95
' _symmetry_space_group_name_H-M not in the CIF';RETURN#                PB20  96
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PB20  97
K=LONG_#                               Get length of string             PB20  98
DO I=1,K; IF(NAME(I^I)!=' ') BREAK#    Find first non-blank             PB20  99
SNAME(1^)=NAME(I^K)#                                                    PB20 100
#                                                                       PB20 101
NM=K-I+1#                                                               PB20 102
DO J=1,NM#                             Loop over table symbol           PB20 103
IF(INDEX(SHLX,SNAME(J^J+2))>0)#        Detect shelx axes brakets        PB20 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PB20 105
SNAME(J^NM-1)=SNAME(J+1^J+1)//' '//SNAME(J+3^NM)# Remove brackets       PB20 106
NM=NM-1#                               Reduce length of string          PB20 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PB20 108
DO J=1,NM#                             Loop over table symbol           PB20 109
IF(INDEX(OTHR,SNAME(J^J+2))>0)#        Detect cif subscripts            PB20 110
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PB20 111
SNAME(J^NM-1)=SNAME(J+1^J+1)//' '//SNAME(J+3^NM)# Remove brackets       PB20 112
NM=NM-1#                               Reduce length of string          PB20 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PB20 114
#                                                                       PB20 115
#                                                                       PB20 116
DO J=1,NM;IF(INDEX(SY02,SNAME(J^J))<=0)BREAK# Detect illegal comments   PB20 117
IF(J<=NM)NM=J-1#                       Strip off remainder              PB20 118
DO J=NM,1,-1; IF(SNAME(J^J)!=' '&SNAME(J^J)!='_')BREAK#                 PB20 119
IF(J<NM)NM=J#                          Strip off remainder              PB20 120
#                                                                       PB20 121
locase:(SNAME,MAUG,NM)#                Extract input string             PB20 122
DO K=1,NM; IF(MAUG(K^K)==' ') MAUG(K^K)='_'# Fill with underlines       PB20 123
MAUGNB=' ';NMNB=0#                     Create abbreviated name          PB20 124
DO J=1,NM#                             Loop over table symbol           PB20 125
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PB20 126
IF(MAUG(J^J)=='_') NEXT#               Strip all blanks and underscor   PB20 127
NMNB=NMNB+1#                           Increment number coppied chars   PB20 128
MAUGNB(NMNB^NMNB)=MAUG(J^J)#           Copy characters                  PB20 129
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PB20 130
COLON=0#                               Assume no :h/:r/:1/:2            PB20 131
DO J=1,NM;IF(MAUG(J^J)==':')BREAK#     Search for colon                 PB20 132
IF(J<NM)COLON=1#                       Must have be one of :h/:r/:1/:   PB20 133
#                                                                       PB20 134
#    SCAN SYMMAP FILE FOR  MAUG TO DETERMINE EQUIVALENT HALL            PB20 135
#    -------------------------------------------------------            PB20 136
#                                                                       PB20 137
RECBEG_=SYMSTR; RECEND_=SYMSTP#        Reset min and max pointers       PB20 138
IF(!DATA_(SYMMAP)) lquit:('No data block in Symmap')# Data block miss   PB20 139
#                                                                       PB20 140
REPEAT#                                Scan symmap file                 PB20 141
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PB20 142
F1=CHAR_('_symmetry_space_group_name_Hall',HALL)# Get hall symbol       PB20 143
NH1=LONG_#                             And its length                   PB20 144
F2=CHAR_('_symmetry_space_group_name_H-M',MAUG1)# Get h-m symbol        PB20 145
NM1=LONG_#                             And its length                   PB20 146
MATCH=yes:#                            Flag for match                   PB20 147
#                                                                       PB20 148
IF(NH1==NH)#                           Do hall lengths match            PB20 149
IF(HALL(1^NH)==HALL1(1^NH)) MAUG3=MAUG1# Save the h-m symbol            PB20 150
locase:(MAUG1,MAUG1,NM1)#              Convert to lower case            PB20 151
#                                                                       PB20 152
NM2=0#                                 Start notation length            PB20 153
DO J=1,NM1#                            Loop over table symbol           PB20 154
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PB20 155
IF(MAUG1(J^J)=='_') NEXT#              Skip underscores                 PB20 156
NM2=NM2+1#                             Count chars in notation          PB20 157
MAUG2(NM2^NM2)=MAUG1(J^J)#             Notation with no spacers         PB20 158
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PB20 159
IF(NM==NM1)#                           If lengths the same              PB20 160
IF(MAUG(1^NM)==MAUG1(1^NM)) BREAK#     Exit if match found              PB20 161
IF(NM==NM2)#                           If lengths the same              PB20 162
IF(MAUG(1^NM)==MAUG2(1^NM)) BREAK#     Exit if match found              PB20 163
IF(NMNB==NM2)#                         If lengths the same              PB20 164
IF(MAUGNB(1^NMNB)==MAUG2(1^NMNB))BREAK# Exit if match found             PB20 165
#                                                                       PB20 166
COLON2=no:#                            There is no colon                PB20 167
IF(COLON==no:&MAUG1(NM1-1^NM1-1)==':')# No cif colon but symmap colon   PB20 168
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PB20 169
COLON2=yes:#                           Flag that there is a colon       PB20 170
NM1=NM1-2#                             Erase :x for pattern match       PB20 171
NM2=NM2-2#                             Erase :x for pattern match       PB20 172
IF(NM==NM1)#                           If lengths the same              PB20 173
IF(MAUG(1^NM)==MAUG1(1^NM)) BREAK#     Exit if match found              PB20 174
IF(NM==NM2)#                           If lengths the same              PB20 175
IF(MAUG(1^NM)==MAUG2(1^NM)) BREAK#     Exit if match found              PB20 176
IF(NMNB==NM2)#                         If lengths the same              PB20 177
IF(MAUGNB(1^NMNB)==MAUG2(1^NMNB))BREAK# Exit if match found             PB20 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PB20 179
#                                                                       PB20 180
MATCH=no:#                             No match yet                     PB20 181
IF(!LOOP_) BREAK#                      Exit if notation finished        PB20 182
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PB20 183
#                                                                       PB20 184
# IF NO HERM-MAUG MATCH THEN QUIT                                       PB20 185
# -------------------------------                                       PB20 186
#                                                                       PB20 187
IF(MATCH==no:)#                                                         PB20 188
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PB20 189
WRITE(6,'(1x,a,a)')$#                                                   PB20 190
' which is equivalent to the H-M space group symbol  ',MAUG3(1^NM1)#    PB20 191
WRITE(6,'(/a/)')$#                                                      PB20 192
' ALERT: supplied _symmetry_space_group_name_H-M not recognised'#       PB20 193
RETURN#                                                                 PB20 194
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PB20 195
#                                                                       PB20 196
# ELSE IF A LIMITED MATCH GET COMPLETE MATCH                            PB20 197
# ------------------------------------------                            PB20 198
#                                                                       PB20 199
ELSEIF(MATCH==yes:&COLON2==yes:)#      Symop match with erased colon    PB20 200
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PB20 201
IF(MAUG1(NM1+2^NM1+2)=='h'&#           For both hexag and rhomb         PB20 202
(GAMMA<119.8\GAMMA>120.2))#            Can't be hexagonal               PB20 203
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PB20 204
F1=CHAR_('_symmetry_space_group_name_Hall',HALL)# Get hall symbol       PB20 205
F2=CHAR_('_symmetry_space_group_name_H-M',MAUG1)# Get h-m symbol        PB20 206
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PB20 207
ELSEIF(MAUG1(NM1+1^NM1+2)==':1'&ICNT==0)# For :1/:2 settings            PB20 208
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PB20 209
# NOTE THE NONCENTRO SETTINGS ARE ALWAYS FIRST IN SYMMAP FILE           PB20 210
# SO GET THE CENTROSYMMETRIC SETTING WHICH IS NEXT.                     PB20 211
# ICNT=0 -> CENTRO  ICNT=1 ->NONCENTRO  SET BASED ON CIF SYMOPS ENTERED PB20 212
F1=CHAR_('_symmetry_space_group_name_Hall',HALL)# Get hall symbol       PB20 213
F2=CHAR_('_symmetry_space_group_name_H-M',MAUG1)# Get h-m symbol        PB20 214
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PB20 215
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PB20 216
#                                                                       PB20 217
# CONSTRUCT SYMOPS FROM (HALL) NAME EQUIVALENT OF MATCHING HERM-MAUG    PB20 218
# ------------------------------------------------------------------    PB20 219
#                                                                       PB20 220
try:(CALL PB92)#                       Generate symmetry matrices fro   PB20 221
try:(CALL PB97)#                       Check & write symops             PB20 222
try:(CALL PB94)#                       Convert symops to hall name      PB20 223
locase:(STRG,HALL,40); NH=ICHR#                                         PB20 224
#                                                                       PB20 225
# RECOVERED HALL NAME FROM SYMOPS SO LOOK FOR MATCH IN SYMMAP           PB20 226
# -----------------------------------------------------------           PB20 227
#                                                                       PB20 228
LOOP_=.FALSE.#                         Force to restart loop            PB20 229
DO IR=1,2#                             Loop for second match pass       PB20 230
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PB20 231
REPEAT#                                Loop over notation               PB20 232
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PB20 233
F1=CHAR_('_symmetry_space_group_name_Hall',HALL2)# Get hall symbol      PB20 234
NH1=LONG_#                             And its length                   PB20 235
F2=CHAR_('_symmetry_space_group_name_H-M',MAUG2)# Get h-m symbol        PB20 236
NM1=LONG_#                             And its length                   PB20 237
MATCH=yes:#                            Flag for match                   PB20 238
#                                                                       PB20 239
NH2=0#                                 Start notation length            PB20 240
DO J=1,NH1#                            Loop over table symbol           PB20 241
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PB20 242
IF(HALL2(J^J)=='_') NEXT#              Skip underscores                 PB20 243
NH2=NH2+1#                             Count chars in notation          PB20 244
HALL3(NH2^NH2)=HALL2(J^J)#             Notation with no spacers         PB20 245
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PB20 246
IF(NH==NH1)#                           If lengths the same              PB20 247
IF(HALL(1^NH)==HALL2(1^NH)) BREAK#     Exit if match found              PB20 248
IF(NH==NH2)#                           If lengths the same              PB20 249
IF(HALL(1^NH)==HALL3(1^NH)) BREAK#     Exit if match found              PB20 250
#                                                                       PB20 251
#                                                                       PB20 252
MATCH=no:#                             No match yet                     PB20 253
IF(!LOOP_) BREAK#                      Exit if notation finished        PB20 254
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PB20 255
IF(MATCH==yes:)    BREAK#              Symbols matched                  PB20 256
IF(HALL(1^1)!='-') BREAK#              If space group noncentro         PB20 257
SNAME='-'; NN=1#                       Start new hall symbol            PB20 258
DO I=2,NH#                             Loop over old symbol             PB20 259
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PB20 260
SNAME(NN+1^NN+1)=HALL(I^I)#            Store symbol                     PB20 261
IF(HALL(I^I)!='-') NN=NN+1#            Count non-negative symbols       PB20 262
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PB20 263
HALL=SNAME(1^NN); NH=NN#               Reset for new search             PB20 264
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PB20 265
#                                                                       PB20 266
# FOUND MATCHING HALL NAME IN SYMMAP FILE?                              PB20 267
# ---------------------------------------                               PB20 268
#                                                                       PB20 269
IF(MATCH==no:)#                                                         PB20 270
WRITE(6,'(a,a20,a)') ' Hall symbol ',HALL,'missing from symmap file'#   PB20 271
#                                                                       PB20 272
# NOW CHECK IF ORIGINAL XYZ->HALL1 NAME IS IN SYMMAP                    PB20 273
# DOUBLE CHECK IN CASE INVERSION RELATED SYMOPS WERE MISSING            PB20 274
# ----------------------------------------------------------            PB20 275
#                                                                       PB20 276
DO NH1=0,39;IF(HALL1(NH1+1^NH1+1)==' ')BREAK#                           PB20 277
LOOP_=.FALSE.#                         Force symmap restart             PB20 278
DO IR=1,2#                             Loop for second match pass       PB20 279
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PB20 280
REPEAT#                                Loop over notation               PB20 281
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PB20 282
F1=CHAR_('_symmetry_space_group_name_Hall',HALL3)# Get hall symbol      PB20 283
NH3=LONG_#                             And its length                   PB20 284
F2=CHAR_('_symmetry_space_group_name_H-M',MAUG1)# Get h-m symbol        PB20 285
NM1=LONG_#                             And its length                   PB20 286
MATCH1=yes:#                           Flag for match                   PB20 287
#                                                                       PB20 288
NH2=0#                                 Start notation length            PB20 289
HALL2=' '#                                                              PB20 290
DO J=1,NH3#                            Loop over table symbol           PB20 291
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PB20 292
IF(HALL3(J^J)=='_') NEXT#              Skip underscores                 PB20 293
NH2=NH2+1#                             Count chars in notation          PB20 294
HALL2(NH2^NH2)=HALL3(J^J)#             Notation with no spacers         PB20 295
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PB20 296
IF(NH1==NH3)#                          If lengths the same              PB20 297
IF(HALL1(1^NH1)==HALL3(1^NH1)) BREAK#  Exit if match found              PB20 298
IF(NH1==NH2)#                          If lengths the same              PB20 299
IF(HALL1(1^NH1)==HALL2(1^NH1)) BREAK#  Exit if match found              PB20 300
#                                                                       PB20 301
#                                                                       PB20 302
MATCH1=no:#                            No match yet                     PB20 303
IF(!LOOP_) BREAK#                      Exit if notation finished        PB20 304
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PB20 305
IF(MATCH1==yes:)    BREAK#             Symbols matched                  PB20 306
IF(HALL1(1^1)!='-') BREAK#             If space group noncentro         PB20 307
SNAME='-'; NN=1#                       Start new hall symbol            PB20 308
DO I=2,NH1#                            Loop over old symbol             PB20 309
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PB20 310
SNAME(NN+1^NN+1)=HALL1(I^I)#           Store symbol                     PB20 311
IF(HALL(I^I)!='-') NN=NN+1#            Count non-negative symbols       PB20 312
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PB20 313
HALL1=SNAME(1^NN); NH1=NN#             Reset for new search             PB20 314
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PB20 315
#                                                                       PB20 316
#                                                                       PB20 317
#                                                                       PB20 318
#                                                                       PB20 319
IF(MATCH1==no:)#                                                        PB20 320
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PB20 321
WRITE(6,'(a,a20,a)') ' Hall symbol ',HALL1,'missing from symmap file'#  PB20 322
MAUG1='???????'#                                                        PB20 323
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PB20 324
#                                                                       PB20 325
WRITE(6,'(/a,04x,a15)')$#                                               PB20 326
' The xyz symops consistent with the H-M space group',MAUG1#            PB20 327
WRITE(6,'(/a,10x,a15)')$#                                               PB20 328
' From the CIF: _symmetry_space_group_name_H-M',NAME#                   PB20 329
#                                                                       PB20 330
NSYM=NSYM*LATTYP(LTYP)*(2-ICNT)#       Calc total number from gen hal   PB20 331
IF (NSYMS!=NSYM)#                                                       PB20 332
WRITE(6,'(/a16,i5,a16,i5,a)')$#                                         PB20 333
' ALERT ',NSYMS,' symops in cif, ',NSYM,' symops generated'#            PB20 334
#                                                                       PB20 335
IF (MATCH1==0 \ MATCH==0 \ MAUG2(1^20)!=MAUG1(1^20))#                   PB20 336
WRITE(6,'(/a/)')$#                                                      PB20 337
' ALERT _symmetry_equiv_pos_as_xyz does not match H-M symbol'#          PB20 338
#                                                                       PB20 339
ELSE WRITE(6,'(/a/)') ' SYMMG_02: OK '#                                 PB20 340
#                                                                       PB20 341
RECBEG_=CIFSTR; RECEND_=CIFSTP#        Reset min max access pointers    PB20 342
F1=DATA_(BLKNAM)#                      Reselect current cif data bloc   PB20 343
#                                                                       PB20 344
RETURN#                                                                 PB20 345
END#                                                                    PB20 346
systemheader:(PB30)#                                                    PB30   1
####################################################################### PB30   2
##                                                                    # PB30   3
## CELLZ_01 applies two tests:                                        # PB30   4
##                                                                    # PB30   5
##     (1) Compares the atomic content of the unit cell from the      # PB30   6
##         composition derived from the _chemical_formula_sum         # PB30   7
##         and the items in the _atom_type_ list.                     # PB30   8
##                                                                    # PB30   9
##     (2) Compares the atomic content of the unit cell from the      # PB30  10
##         composition derived from the _chemical_formula_sum         # PB30  11
##         and the items in the _atom_site_ list.                     # PB30  12
##                                                                    # PB30  13
####################################################################### PB30  14
SUBROUTINE PB30#                                                        PB30  15
include:(AACOMN)#                                                       PB30  16
include:(PBCOMN)#                                                       PB30  17
#                                                                       PB30  18
LOGICAL       F1,F2#                                                    PB30  19
CHARACTER*80  NAME#                                                     PB30  20
REAL          COND,CONF,CONS,CSUM#                                      PB30  21
REAL          DUMMY#                                                    PB30  22
REAL          SDEV#                                                     PB30  23
#                                                                       PB30  24
string:(FORSUM,80)#                                                     PB30  25
INTEGER       I,J,K,N,NN#                                               PB30  26
#                                                                       PB30  27
REAL ZMOLE#                                                             PB30  28
INTEGER SITTYP(mnas:)#                 Site type                        PB30  29
REAL  SITOCC(mnas:)#                   Site occupancy                   PB30  30
REAL  SITMUL(mnas:)#                   Site multiplicity                PB30  31
REAL  SITX(mnas:)#                     Site x coord                     PB30  32
REAL  SITY(mnas:)#                     Site y coord                     PB30  33
REAL  SITZ(mnas:)#                     Site z coord                     PB30  34
INTEGER  TMODE(3)#                     Test modes                       PB30  35
INTEGER ACNT#                          Atom site count                  PB30  36
INTEGER NAT#                           Number of atom types             PB30  37
REAL    ATNCC(mat:)#                                                    PB30  38
REAL    ATNUM1(mat:)#                                                   PB30  39
REAL    ATWHT(mat:)#                                                    PB30  40
string:(ATNAMES,128)#                  Space for 16 atom names          PB30  41
string:(ATNAME1,128)#                  Space for 16 atom names          PB30  42
CHARACTER CH#                                                           PB30  43
REAL    CONH#                                                           PB30  44
INTEGER SLEN#                                                           PB30  45
#                                                                       PB30  46
REAL    AMATCH#                                                         PB30  47
INTEGER JJ,LL#                                                          PB30  48
INTEGER TRSTAR#     ## Start of lattice translations in array trans     PB30  49
INTEGER TRSTOP#     ## End of lattice translations in array trans       PB30  50
REAL  X(3),Y(3),Z(3)## Positional parameters derived from symmetry      PB30  51
INTEGER L,M#                           Ad                               PB30  52
REAL    DIF#                                                            PB30  53
INTEGER NAT1#                                                           PB30  54
#                                                                       PB30  55
chardata:(NUM,'0123456789 ')#                                           PB30  56
realdata:(RESOLU,0.0005)#                                               PB30  57
intdata:(TRPOIN,[1,3,4,9,10,18,19,30,31,36,37,42,43,48])#               PB30  58
realdata:(TRANS,[$#                    Transformation matrices          PB30  59
0.0,0.0,0.0,#                                                           PB30  60
0.0,0.0,0.0,#                          I cells                          PB30  61
0.5,0.5,0.5,#                                                           PB30  62
0.0,0.0,0.0,#                          R cells                          PB30  63
0.333333,0.666667,0.666667,#                                            PB30  64
0.666667,0.333333,0.333333,#                                            PB30  65
0.0,0.0,0.0,#                          F cells                          PB30  66
0.0,0.5,0.5,#                                                           PB30  67
0.5,0.0,0.5,#                                                           PB30  68
0.5,0.5,0.0,#                                                           PB30  69
0.0,0.0,0.0,#                          A cells                          PB30  70
0.0,0.5,0.5,#                                                           PB30  71
0.0,0.0,0.0,#                          B cells                          PB30  72
0.5,0.0,0.5,#                                                           PB30  73
0.0,0.0,0.0,#                          C cells                          PB30  74
0.5,0.5,0.0])#                                                          PB30  75
datastuff:#                                                             PB30  76
#                                                                       PB30  77
WRITE(6,'(//a)') ' CELLZ_01: Check formula with the supplied model'#    PB30  78
WRITE(6,'( a)') ' -----------------------------------------------'#     PB30  79
#                                                                       PB30  80
ZMOLE=1.#                              Initialize                       PB30  81
IF(!NUMB_('_cell_formula_units_Z', ZMOLE, DUMMY) )#                     PB30  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB30  83
WRITE(6,'(/a)') ' From the CIF: _cell_formula_units_Z          ?'#      PB30  84
RETURN#                                                                 PB30  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB30  86
WRITE(6,'(/a,i9)')' From the CIF: _cell_formula_units_Z',NINT(ZMOLE)#   PB30  87
##                                                                      PB30  88
##    READ THE CHEMICAL_FORMULA_SUM  FROM THE CIF                       PB30  89
##    -------------------------------------------                       PB30  90
##                                                                      PB30  91
IF(!CHAR_('_chemical_formula_sum', FORSUM ))#                           PB30  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB30  93
WRITE(6,'(/a)') ' From the CIF: _chemical_formula_sum       ?'#         PB30  94
RETURN#                                                                 PB30  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB30  96
WRITE(6,'(a,a)')' From the CIF: _chemical_formula_sum  ',FORSUM(1^40)#  PB30  97
#                                                                       PB30  98
SLEN=MIN(LONG_+1,80)#                                                   PB30  99
DO J=1,SLEN; IF(FORSUM(J^J)=='_')FORSUM(J^J)=' '#                       PB30 100
ATNAME1=' '#                           Initialise                       PB30 101
M=-1#                                  Initially unknown char type      PB30 102
NAME='        '#                       Initialise name                  PB30 103
K=1#                                   Pointer to name                  PB30 104
LL=1#                                  Pointer to name table            PB30 105
DO J=1,SLEN#                           Loop over string chars           PB30 106
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB30 107
CH=FORSUM(J^J)#                        Get next char                    PB30 108
IF((CH==' '\CH=='_')&M==-1)NEXT#       Skip first blanks                PB30 109
L=INDEX(NUM(1^11),CH)#                 Get number if present            PB30 110
N=M#                                   Set same as last                 PB30 111
IF(L==0)   M=char:#                    Must be atom type char           PB30 112
ELSE       M=numb:#                    Else atom content digit          PB30 113
IF(CH=='.')M=numb:#                    Decimal point is also a number   PB30 114
IF(J==SLEN)  M=0#                      Force change at string end       PB30 115
#                                                                       PB30 116
IF (N!=M & N!=-1)#                     New string type beginning        PB30 117
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PB30 118
IF(N==char:)#                          Get atom type from string        PB30 119
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PB30 120
label:(NAME,JJ,K,ATNAME1,NN)#          Check if already present         PB30 121
IF(NN<=0)#                             New atom type - copy label       PB30 122
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PB30 123
movechar:(NAME,1,ATNAME1,LL,K,0)#      Copy atom label/name             PB30 124
LL=LL+8#                               Increment label pointer          PB30 125
L=(LL-1)/8;  ATNUM1(L)=1.0#            Pointer to table entries         PB30 126
IF (LL>8*mat:) BREAK## Possibly Iquit:    Exceeds XTAL limit of 16 ff   PB30 127
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PB30 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PB30 129
ELSEIF(N==numb:)#                      Name contains atom type number   PB30 130
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PB30 131
L=(LL-1)/8#                            Pointer to table entries         PB30 132
getnum:(NAME,K-1,ATNUM1(L),SDEV)#      Get number of atoms of type      PB30 133
IF(ATNUM1(L)<0.1) ATNUM1(L)=1.0#       Formula sum *moles/cell          PB30 134
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PB30 135
NAME='        '#                       Blank name string                PB30 136
K=1#                                   Reset pointer to first char      PB30 137
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PB30 138
IF (CH==' ')NEXT#                      Don't copy but treat as number   PB30 139
NAME(K^K)=CH#                          Copy char to name string         PB30 140
K=K+1#                                 Step to next char in name        PB30 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB30 142
NAT1=L#                                                                 PB30 143
##                                                                      PB30 144
## TEST 1:                                                              PB30 145
##                                                                      PB30 146
## COMPARE CELL CONTENTS FROM FORMULA AND ATOM_TYPE LIST                PB30 147
## =====================================================                PB30 148
##                                                                      PB30 149
TMODE(1)=1#                            Test mode                        PB30 150
FOR(NAT=1;NAT<=mat:;NAT=NAT+1)#        Loop atom type list              PB30 151
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PB30 152
IF(!CHAR_('_atom_type_symbol', ATNAMES(NAT*8-7^NAT*8)))#                PB30 153
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PB30 154
NAT=0#                                                                  PB30 155
TMODE(1)=0#                                                             PB30 156
BREAK#                                                                  PB30 157
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PB30 158
IF(!NUMB_('_atom_type_number_in_cell',ATNCC(NAT),DUMMY ))#              PB30 159
TMODE(1)=0#                            Can't test on                    PB30 160
IF(!LOOP_) BREAK#                      Set by ciftbx                    PB30 161
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PB30 162
#                                                                       PB30 163
IF (TMODE(1)==0)#                      If atom types not present        PB30 164
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PB30 165
ATNAMES=ATNAME1#                       Copy atname list                 PB30 166
NAT=NAT1#                                                               PB30 167
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PB30 168
ELSE#                                  If atom types exist on cif       PB30 169
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PB30 170
WRITE(6,'(/a,a)')'      TEST: Compare cell contents',$#                 PB30 171
'of formula and atom_type data'#                                        PB30 172
K=0;  CSUM=0.#                                                          PB30 173
IF(NAT != NAT1) WRITE(6,'(/a,a)') 'WARNING:',$#                         PB30 174
' Elements in formula and atom_type inconsistent'#                      PB30 175
WRITE(6,'(/a)')'             atom    Z*formula  atom_type diff'#        PB30 176
DO I=1,NAT  ; DO J=1,NAT1#                                              PB30 177
IF (ATNAMES(I*8-7^I*8)==ATNAME1(J*8-7^J*8) )#                           PB30 178
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PB30 179
CONF=ZMOLE*ATNUM1(J)#                  Contents from formula sum        PB30 180
CONS=ATNCC(I)#                         Contents from formula sum        PB30 181
COND=CONS-CONF#                                                         PB30 182
CSUM=CSUM+COND#                                                         PB30 183
WRITE(6,'(13x,a5,2f10.2,f8.2)') ATNAMES(I*8-7^I*8),CONF,CONS,COND#      PB30 184
K=K+1#                                                                  PB30 185
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PB30 186
IF(K<NAT \K<NAT1)#                                                      PB30 187
WRITE(6,'(/a)')' WARNING: not all elements recognised.'#                PB30 188
IF(CSUM>0.01) WRITE(6,'(/a)')$#                                         PB30 189
' WARNING: Cell contents from the formula and atom_type data differ!'#  PB30 190
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PB30 191
##                                                                      PB30 192
##  TEST2:                                                              PB30 193
##                                                                      PB30 194
## COMPARE CELL CONTENTS FROM FORMULA AND ATOM_SITE LIST                PB30 195
## =====================================================                PB30 196
##                                                                      PB30 197
WRITE(6,'(/a,a)')'      TEST: Compare cell contents of formula ',$#     PB30 198
'and atom_site data'#                                                   PB30 199
ACNT=0#                                                                 PB30 200
TMODE(2)=1;TMODE(3)=1#                                                  PB30 201
REPEAT#                                Loop over all atom sites         PB30 202
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PB30 203
IF(!CHAR_('_atom_site_type_symbol', NAME))#                             PB30 204
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PB30 205
F1=CHAR_('_atom_site_label',       NAME)#                               PB30 206
IF(!F1) $(WRITE(6,'(/a)') ' Atom labels not found';RETURN$)#            PB30 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PB30 208
label:(NAME,JJ,K,ATNAMES,NN)#          Check if already present         PB30 209
IF(NN<=0)#                             New atom type - copy label       PB30 210
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PB30 211
WRITE(6,'(/a,a)')$#                                                     PB30 212
' WARNING: Unexpected atom type is in site list: ',NAME(1^K)#           PB30 213
NAT=NAT+1#                                                              PB30 214
IF(NAT>mat:)$(WRITE(6,'(a)')' atom type array size `exceeded';RETURN$)# PB30 215
ATNAMES(NAT*8-7^NAT*8)=NAME(1^K)#      Copy name to list                PB30 216
NN=NAT#                                                                 PB30 217
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PB30 218
ACNT=ACNT+1#                                                            PB30 219
SITTYP(ACNT)=NN#                                                        PB30 220
#                                                                       PB30 221
IF (!NUMB_('_atom_site_occupancy',SITOCC(ACNT),DUMMY ) )#               PB30 222
$(SITOCC(ACNT)=1.0 ; TMODE(2)=0 $)#    Can't use occupancy              PB30 223
IF (!NUMB_('_atom_site_symmetry_multiplicity',SITMUL(ACNT),DUMMY))#     PB30 224
TMODE(3)=0#                            Can't use multiplicity           PB30 225
F2 = NUMB_('_atom_site_fract_x',SITX(ACNT), SDEV)#                      PB30 226
F2 = NUMB_('_atom_site_fract_y',SITY(ACNT), SDEV)#                      PB30 227
F2 = NUMB_('_atom_site_fract_z',SITZ(ACNT), SDEV)#                      PB30 228
IF(!LOOP_) BREAK#                      How was this set ??              PB30 229
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PB30 230
##                                                                      PB30 231
##     DETERMINE SYMMETRY OPERATIONS                                    PB30 232
##     -----------------------------                                    PB30 233
##                                                                      PB30 234
try:(CALL PB89)#                       Get symops from cif              PB30 235
#                                                                       PB30 236
IF(ICNT==0)#                           If centrosymmetric               PB30 237
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PB30 238
DO K=1,NSYM#                           Loop over symops                 PB30 239
DO L=1,12; RSMAT(L,NSYM+K)=-RSMAT(L,K)# Store centro values             PB30 240
NSYM=2*NSYM#                                                            PB30 241
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PB30 242
##                                                                      PB30 243
##   DETERMINE MULTIPLICITY OF EACH ATOM SITE                           PB30 244
##   ----------------------------------------                           PB30 245
##                                                                      PB30 246
I=(LTYP-1)*2#                          Set up for lattice translati     PB30 247
TRSTAR=TRPOIN(I+1)#                    Set start in trans array         PB30 248
TRSTOP=TRPOIN(I+2)#                    Set end in trans array           PB30 249
#                                                                       PB30 250
#   LOOP OVER ATOMS LIST                                                PB30 251
#   --------------------                                                PB30 252
#                                                                       PB30 253
#                                                                       PB30 254
DO M=1,ACNT#                           Loop over atoms list             PB30 255
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PB30 256
X(1)=SITX(M)#                                                           PB30 257
X(2)=SITY(M)#                                                           PB30 258
X(3)=SITZ(M)#                                                           PB30 259
AMATCH=0.#                             Zero count of coincidences       PB30 260
#                                                                       PB30 261
#   LOOP OVER SYMMMETRY MATRICES                                        PB30 262
#   ----------------------------                                        PB30 263
#                                                                       PB30 264
DO J=1,NSYM#                                                            PB30 265
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PB30 266
Y(1)=X(1)*RSMAT(1,J)+X(2)*RSMAT(4,J)+X(3)*RSMAT(7,J)+RSMAT(10,J)# Get   PB30 267
Y(2)=X(1)*RSMAT(2,J)+X(2)*RSMAT(5,J)+X(3)*RSMAT(8,J)+RSMAT(11,J)# Get   PB30 268
Y(3)=X(1)*RSMAT(3,J)+X(2)*RSMAT(6,J)+X(3)*RSMAT(9,J)+RSMAT(12,J)# Get   PB30 269
#                                                                       PB30 270
FOR(K=TRSTAR;K<=TRSTOP;K=K+3)#         Loop over lattice centres        PB30 271
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PB30 272
Z(1)=Y(1)+TRANS(K  )#                  Translate x                      PB30 273
Z(2)=Y(2)+TRANS(K+1)#                  Translate y                      PB30 274
Z(3)=Y(3)+TRANS(K+2)#                  Translate z                      PB30 275
#                                                                       PB30 276
#   TEST FOR SPECIAL POSITION                                           PB30 277
#   -------------------------                                           PB30 278
#                                                                       PB30 279
DO I=1,3#                              Loop over coordinates            PB30 280
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PB30 281
DIF=X(I)-Z(I)#                         Get diff in coordinate           PB30 282
DIF=MOD(DIF+100.5,1.0)-0.5#                                             PB30 283
##write(6,'(4f10.4)') X(I), Z(I), DIF, RESOLU                           PB30 284
IF(ABS(DIF)>RESOLU) GOTO 100#          Skip to next symop               PB30 285
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PB30 286
#                                                                       PB30 287
#   SPECIAL POSITION DETECTED                                           PB30 288
#   -------------------------                                           PB30 289
#                                                                       PB30 290
AMATCH=AMATCH+1.0#                     Count atom multiplicity          PB30 291
100 CONTINUE#                          Branchpoint                      PB30 292
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PB30 293
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PB30 294
SITMUL(M)=1.0/AMATCH#                  Calculate site multiplicity      PB30 295
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PB30 296
##                                                                      PB30 297
##   SUM  COUNTS OF ATOM_TYPE                                           PB30 298
##   ------------------------                                           PB30 299
##                                                                      PB30 300
FOR(I=1;I<=NAT;I=I+1)#                                                  PB30 301
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PB30 302
NAME=ATNAMES(I*8-7^I*8)#                                                PB30 303
try:(CALL PB99(NAME,ATWHT(I)))#        Get atomic weight                PB30 304
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PB30 305
#                                                                       PB30 306
DO I=1,NAT;ATNCC(I)=0.0#               Initialise atom counts           PB30 307
DO M=1,ACNT#                           Loop over atoms list             PB30 308
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PB30 309
J=SITTYP(M)#                           Get s.f. type number             PB30 310
ATNCC(J)=ATNCC(J)+   SITOCC(M)*SITMUL(M)# Count atoms of type           PB30 311
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PB30 312
#                                                                       PB30 313
IF(TMODE(2)==0)#                                                        PB30 314
WRITE(6,'(/11x,a)')'Site occupancies missing: assumed 1.0'#             PB30 315
#                                                                       PB30 316
K=0#                                                                    PB30 317
CSUM=0.; CONH=0.#                                                       PB30 318
IF(NAT != NAT1) WRITE(6,'(/a)')$#                                       PB30 319
' WARNING: Formula and atom_type_symbol element names mismatch.'#       PB30 320
WRITE(6,'(/a)')'             atom    Z*formula  cif sites diff'#        PB30 321
DO I=1,NAT  ; DO J=1,NAT1#                                              PB30 322
IF (ATNAMES(I*8-7^I*8)==ATNAME1(J*8-7^J*8) )#                           PB30 323
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PB30 324
CONF=ZMOLE*ATNUM1(J)#                  Contents from formula sum        PB30 325
CONS=ATNCC(I)*FLOAT(SYMFAC)#           Contents from formula sum        PB30 326
COND=CONF-CONS#                                                         PB30 327
CSUM=CSUM+ABS(COND)#                                                    PB30 328
IF(ATNAMES(I*8-7^I*8)=='H       ') CONH=COND# Save h atom difference    PB30 329
WRITE(6,'(13x,a5,2f10.2,f8.2)')ATNAMES(I*8-7^I*8),CONF,CONS,COND#       PB30 330
K=K+1#                                                                  PB30 331
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PB30 332
IF(K<NAT \K<NAT1)#                                                      PB30 333
WRITE(6,'(/a/)')' WARNING: Site labels do not match formula elements'#  PB30 334
IF(CSUM>0.05)#                                                          PB30 335
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PB30 336
WRITE(6,'(/a)')$#                                                       PB30 337
' Difference between formula and atom_site contents detected.'#         PB30 338
IF(CSUM<0.5) WRITE(6,'(/a,a)') ' ALERT:',$#                             PB30 339
' check formula stoichiometry or atom site occupancies.'#               PB30 340
ELSE IF(CSUM<CONH+0.5) WRITE(6,'(/a,a)') ' WARNING:',$#                 PB30 341
' H atoms missing from atom site list. Is this intentional?'#           PB30 342
ELSE                   WRITE(6,'(/a,a)') ' ALERT:',$#                   PB30 343
' Large difference may be due to symmetry error - see SYMMG tests.'#    PB30 344
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PB30 345
ELSE WRITE(6,'(/a)') ' CELLZ_01: OK '#                                  PB30 346
#                                                                       PB30 347
RECBEG_=CIFSTR; RECEND_=CIFSTP#        Reset min max access pointers    PB30 348
F1=DATA_(BLKNAM)#                      Reselect current cif data bloc   PB30 349
#                                                                       PB30 350
RETURN#                                                                 PB30 351
END#                                                                    PB30 352
systemheader:(PB40)#                                                    PB40   1
####################################################################### PB40   2
##                                                                    # PB40   3
## CHEMW_03 applies two tests:                                        # PB40   4
##                                                                    # PB40   5
##     (1) Compares the _chemical_formula_weight with that            # PB40   6
##         calculated from items in the _atom_type_ list.             # PB40   7
##                                                                    # PB40   8
##     (2) Compares the _chemical_formula_weight with that            # PB40   9
##         calculated from items in the _atom_site_ list.             # PB40  10
##                                                                    # PB40  11
####################################################################### PB40  12
SUBROUTINE PB40#                                                        PB40  13
include:(AACOMN)#                                                       PB40  14
include:(PBCOMN)#                                                       PB40  15
#                                                                       PB40  16
LOGICAL       F1,F2#                                                    PB40  17
CHARACTER*80  NAME#                                                     PB40  18
REAL          SX,SY,SZ,DUMMY#                                           PB40  19
REAL          SDEV#                                                     PB40  20
#                                                                       PB40  21
INTEGER       I,J,K#                                                    PB40  22
INTEGER       NN#                                                       PB40  23
#                                                                       PB40  24
REAL TOTAL,ZMOLE#                                                       PB40  25
INTEGER SITTYP(mnas:)#                 Site type                        PB40  26
REAL  SITOCC(mnas:)#                   Site occupancy                   PB40  27
REAL  SITMUL(mnas:)#                   Site multiplicity                PB40  28
REAL  SITX(mnas:)#                     Site x coord                     PB40  29
REAL  SITY(mnas:)#                     Site y coord                     PB40  30
REAL  SITZ(mnas:)#                     Site z coord                     PB40  31
INTEGER  TMODE(3)#                     Test modes                       PB40  32
INTEGER ACNT#                          Atom site count                  PB40  33
INTEGER NAT#                           Number of atom types             PB40  34
REAL    MASS(mat:)#                                                     PB40  35
REAL    ATNCC(mat:)#                                                    PB40  36
REAL    ATWHT(mat:)#                                                    PB40  37
string:(ATNAMES,128)#                  Space for 16 atom names          PB40  38
REAL    VAL#                                                            PB40  39
REAL MLWGHT#                                                            PB40  40
REAL    AMATCH#                                                         PB40  41
INTEGER JJ#                                                             PB40  42
INTEGER TRSTAR#     ## Start of lattice translations in array trans     PB40  43
INTEGER TRSTOP#     ## End of lattice translations in array trans       PB40  44
REAL  X(3),Y(3),Z(3)## Positional parameters derived from symmetry      PB40  45
INTEGER L,M#                           Ad                               PB40  46
REAL    DIF#                                                            PB40  47
REAL    WGT#                                                            PB40  48
REAL    RC#                                                             PB40  49
REAL    CDENS#                                                          PB40  50
REAL    DC#                                                             PB40  51
#                                                                       PB40  52
realdata:(RESOLU,0.0005)#                                               PB40  53
intdata:(TRPOIN,[1,3,4,9,10,18,19,30,31,36,37,42,43,48])#               PB40  54
realdata:(TRANS,[$#                    Transformation matrices          PB40  55
0.0,0.0,0.0,#                                                           PB40  56
0.0,0.0,0.0,#                          I cells                          PB40  57
0.5,0.5,0.5,#                                                           PB40  58
0.0,0.0,0.0,#                          R cells                          PB40  59
0.333333,0.666667,0.666667,#                                            PB40  60
0.666667,0.333333,0.333333,#                                            PB40  61
0.0,0.0,0.0,#                          F cells                          PB40  62
0.0,0.5,0.5,#                                                           PB40  63
0.5,0.0,0.5,#                                                           PB40  64
0.5,0.5,0.0,#                                                           PB40  65
0.0,0.0,0.0,#                          A cells                          PB40  66
0.0,0.5,0.5,#                                                           PB40  67
0.0,0.0,0.0,#                          B cells                          PB40  68
0.5,0.0,0.5,#                                                           PB40  69
0.0,0.0,0.0,#                          C cells                          PB40  70
0.5,0.5,0.0])#                                                          PB40  71
datastuff:#                                                             PB40  72
#                                                                       PB40  73
WRITE(6,'(//a)') ' CHEMW_03: Check formula weight with the model'#      PB40  74
WRITE(6,'( a)') ' ---------------------------------------------'#       PB40  75
#                                                                       PB40  76
IF(!NUMB_('_chemical_formula_weight', WGT, SDEV ))#                     PB40  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB40  78
WRITE(6,'(/a)') ' From the CIF: _cell_formula_units_Z         ?'#       PB40  79
RETURN#                                                                 PB40  80
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB40  81
#                                                                       PB40  82
ZMOLE=1.#                              Initialize                       PB40  83
IF(!NUMB_('_cell_formula_units_Z', ZMOLE, SDEV) )#                      PB40  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB40  85
WRITE(6,'(/a)') ' From the CIF: _chemical_formula_weight       ?'#      PB40  86
RETURN#                                                                 PB40  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB40  88
WRITE(6,'(/a,I11)')' From the CIF: _cell_formula_units_Z',NINT(ZMOLE)#  PB40  89
WRITE(6,'(a,f10.2)')' From the CIF: _chemical_formula_weight ',WGT#     PB40  90
##                                                                      PB40  91
##                                                                      PB40  92
## REQUIRE list of atoms types and atomic mass                          PB40  93
## -------------------------------------------                          PB40  94
##                                                                      PB40  95
TMODE(1)=1#                            Test mode                        PB40  96
FOR(NAT=1;NAT<=mat:;NAT=NAT+1)#                                         PB40  97
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB40  98
IF(!CHAR_('_atom_type_symbol', ATNAMES(NAT*8-7^NAT*8)))#                PB40  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PB40 100
NAT=0#                                                                  PB40 101
TMODE(1)=0#                                                             PB40 102
BREAK#                                                                  PB40 103
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PB40 104
IF(!NUMB_('_atom_type_number_in_cell',ATNCC(NAT),SDEV ))#               PB40 105
TMODE(1)=0#                            Can't test on                    PB40 106
IF(!LOOP_) BREAK#                      Set by ciftbx                    PB40 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB40 108
dbx:WRITE(6,'(/a,I4,a)') 'Picked up ',NAT,' atom types'#                PB40 109
##                                                                      PB40 110
##                                                                      PB40 111
##  GET ALL INDEPENDENT ATOM SITES AND STORE                            PB40 112
##  ----------------------------------------                            PB40 113
##                                                                      PB40 114
ACNT=0#                                                                 PB40 115
TMODE(2)=1;TMODE(3)=1#                                                  PB40 116
dbx:WRITE(6,'(/a/)') ' Atom sites'#                                     PB40 117
REPEAT#                                Loop over all atom sites         PB40 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PB40 119
IF(!CHAR_('_atom_site_type_symbol', NAME))#                             PB40 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PB40 121
F1=CHAR_('_atom_site_label',       NAME)#                               PB40 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PB40 123
label:(NAME,JJ,K,ATNAMES,NN)#          Check if already present         PB40 124
IF(NN<=0)#                             New atom type - copy label       PB40 125
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PB40 126
NAT=NAT+1;#                                                             PB40 127
IF(NAT>mat:) $(WRITE(6,'(a)') ' maximum atom type exceeded';RETURN$)#   PB40 128
ATNAMES(NAT*8-7^NAT*8)=NAME(1^K)#      Copy name to list                PB40 129
NN=NAT#                                                                 PB40 130
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PB40 131
ACNT=ACNT+1#                                                            PB40 132
SITTYP(ACNT)=NN#                                                        PB40 133
#                                                                       PB40 134
IF (!NUMB_('_atom_site_occupancy',SITOCC(ACNT),DUMMY ) )#               PB40 135
$(SITOCC(ACNT)=1.0 ; TMODE(2)=0 $)#    Can't use occupancy              PB40 136
IF (!NUMB_('_atom_site_symmetry_multiplicity',SITMUL(ACNT),DUMMY))#     PB40 137
TMODE(3)=0#                            Can't use multiplicity           PB40 138
F2 = NUMB_('_atom_site_fract_x',SITX(ACNT), SX)#                        PB40 139
F2 = NUMB_('_atom_site_fract_y',SITY(ACNT), SY)#                        PB40 140
F2 = NUMB_('_atom_site_fract_z',SITZ(ACNT), SZ)#                        PB40 141
dbx:WRITE(6,'(1x,a8,4f8.4,I7)')NAME,SITX(ACNT),SITY(ACNT),$#            PB40 142
SITZ(ACNT),SITMUL(ACNT),SITTYP(ACNT)#                                   PB40 143
IF(!LOOP_) BREAK#                      How was this set ??              PB40 144
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PB40 145
##                                                                      PB40 146
##  TEST 1:                                                             PB40 147
##                                                                      PB40 148
##  CALCULATE FORMULA WEIGHT USING _ATOM_TYPE_NUMBER_IN_CELL            PB40 149
##  ========================================================            PB40 150
##                                                                      PB40 151
IF(TMODE(1)!=0)#                                                        PB40 152
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PB40 153
WRITE(6,'(/a,a)')'      TEST: Calculate formula weight from',$#         PB40 154
' _atom_type_*'#                                                        PB40 155
TOTAL=0.0#                                                              PB40 156
WRITE(6,'(/a)') '             atom    mass   num    sum'#               PB40 157
FOR(I=1;I<=NAT;I=I+1)#                                                  PB40 158
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PB40 159
NAME=ATNAMES(I*8-7^I*8)#                                                PB40 160
try:(CALL PB99(NAME,ATWHT(I)))#        Get atomic weight                PB40 161
IF(ATWHT(I)<=0.0)#                                                      PB40 162
WRITE(6,'(a,a)')' Atomic weight unknown for atom:',NAME#                PB40 163
MASS(I)=ATWHT(I)*NINT(ATNCC(I));#                                       PB40 164
TOTAL=TOTAL+MASS(I)#                                                    PB40 165
WRITE(6,'(13x,a4,f9.2,I5,f9.2)')NAME,ATWHT(I),NINT(ATNCC(I)),MASS(I)#   PB40 166
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PB40 167
WRITE(6, '(/12x,a,f13.2)')'Calculated formula weight',TOTAL/ZMOLE#      PB40 168
TOTAL=TOTAL/ZMOLE#                                                      PB40 169
RC= WGT/TOTAL#                         C                                PB40 170
IF     (0.90>RC \RC>1.10) WRITE(6,'(/a)') ' ALERT A: >10% difference'#  PB40 171
ELSEIF (0.95>RC \RC>1.05) WRITE(6,'(/a)') ' ALERT B: > 5% difference'#  PB40 172
ELSEIF (0.99>RC \RC>1.01) WRITE(6,'(/a)') ' ALERT C: > 1% difference'#  PB40 173
ELSE                      WRITE(6,'(/a)') ' CHEMW_03: OK '#             PB40 174
IF (0.99>RC \RC>1.01)#                                                  PB40 175
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PB40 176
IF(TMODE(2)==0)#                                                        PB40 177
WRITE(6,'(11x,a)')'Note that site occupancies missing: assumed 1.0'#    PB40 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PB40 179
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PB40 180
##                                                                      PB40 181
##  TEST 2:                                                             PB40 182
##                                                                      PB40 183
##  CALCULATE FORMULA WEIGHT USING _ATOM_SITE DATA                      PB40 184
##  ==============================================                      PB40 185
##                                                                      PB40 186
WRITE(6,'(/a,a)')'      TEST: Calculate formula weight from',$#         PB40 187
' _atom_site_*'#                                                        PB40 188
IF(TMODE(2)==0)#                                                        PB40 189
WRITE(6,'(/11x,a)')' Site occupancies missing: assumed 1.0'#            PB40 190
##                                                                      PB40 191
##     DETERMINE SYMMETRY OPERATIONS                                    PB40 192
##     -----------------------------                                    PB40 193
##                                                                      PB40 194
try:(CALL PB89)#                       Get the symmetry operations      PB40 195
#                                                                       PB40 196
#                                      Expand for inversion symops      PB40 197
IF(ICNT==0)#                           If centrosymmetric               PB40 198
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PB40 199
DO K=1,NSYM#                           Loop over symops                 PB40 200
DO L=1,12; RSMAT(L,NSYM+K)=-RSMAT(L,K)# Store centro values             PB40 201
NSYM=2*NSYM#                                                            PB40 202
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PB40 203
##                                                                      PB40 204
##   DETERMINE MULTIPLICITY OF EACH ATOM SITE                           PB40 205
##   ----------------------------------------                           PB40 206
##                                                                      PB40 207
I=(LTYP-1)*2#                          Set up for lattice translati     PB40 208
TRSTAR=TRPOIN(I+1)#                    Set start in trans array         PB40 209
TRSTOP=TRPOIN(I+2)#                    Set end in trans array           PB40 210
#                                                                       PB40 211
DO M=1,ACNT#                           Loop over atoms list             PB40 212
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PB40 213
X(1)=SITX(M)#                                                           PB40 214
X(2)=SITY(M)#                                                           PB40 215
X(3)=SITZ(M)#                                                           PB40 216
AMATCH=0.#                             Zero count of coincidences       PB40 217
#                                                                       PB40 218
DO J=1,NSYM#                           Loop over symmetry matrices      PB40 219
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PB40 220
Y(1)=X(1)*RSMAT(1,J)+X(2)*RSMAT(4,J)+X(3)*RSMAT(7,J)+RSMAT(10,J)# Get   PB40 221
Y(2)=X(1)*RSMAT(2,J)+X(2)*RSMAT(5,J)+X(3)*RSMAT(8,J)+RSMAT(11,J)# Get   PB40 222
Y(3)=X(1)*RSMAT(3,J)+X(2)*RSMAT(6,J)+X(3)*RSMAT(9,J)+RSMAT(12,J)# Get   PB40 223
#                                                                       PB40 224
FOR(K=TRSTAR;K<=TRSTOP;K=K+3)#         Loop over lattice centres        PB40 225
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PB40 226
Z(1)=Y(1)+TRANS(K  )#                  Translate x                      PB40 227
Z(2)=Y(2)+TRANS(K+1)#                  Translate y                      PB40 228
Z(3)=Y(3)+TRANS(K+2)#                  Translate z                      PB40 229
#                                                                       PB40 230
#   TEST FOR SPECIAL POSITION                                           PB40 231
#   -------------------------                                           PB40 232
#                                                                       PB40 233
DO I=1,3#                              Loop over coordinates            PB40 234
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PB40 235
DIF=X(I)-Z(I)#                         Get diff in coordinate           PB40 236
DIF=MOD(DIF+100.5,1.0)-0.5#                                             PB40 237
IF(ABS(DIF)>RESOLU) GOTO 100#          Skip to next symop               PB40 238
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PB40 239
AMATCH=AMATCH+1.0#                     Count atom multiplicity          PB40 240
100 CONTINUE#                          Branchpoint                      PB40 241
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PB40 242
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PB40 243
SITMUL(M)=1.0/AMATCH#                  Calculate site multiplicity      PB40 244
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PB40 245
##                                                                      PB40 246
##   SUM  COUNTS OF ATOM_TYPE                                           PB40 247
##   ------------------------                                           PB40 248
##                                                                      PB40 249
FOR(I=1;I<=NAT;I=I+1)#                                                  PB40 250
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PB40 251
NAME=ATNAMES(I*8-7^I*8)#                                                PB40 252
try:(CALL PB99(NAME,ATWHT(I)))#        Get atomic weight                PB40 253
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PB40 254
#                                                                       PB40 255
DO I=1,NAT;ATNCC(I)=0.0#               Initialise atom counts           PB40 256
CDENS=0.#                              Set up for special positions     PB40 257
DO M=1,ACNT#                           Loop over atoms list             PB40 258
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PB40 259
J=SITTYP(M)#                           Get s.f. type number             PB40 260
ATNCC(J)=ATNCC(J)+   SITOCC(M)*SITMUL(M)# Count atoms of type           PB40 261
CDENS=CDENS+ATWHT(J)*SITOCC(M)*SITMUL(M)# Build up density              PB40 262
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PB40 263
#                                                                       PB40 264
WRITE(6,'(/a)') '             atom     mass    num     sum'#            PB40 265
MLWGHT=0.0#                            Initialize startx molecular we   PB40 266
DO I=1,NAT#                            Cycle over all atom types        PB40 267
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PB40 268
VAL=ATNCC(I)*FLOAT(SYMFAC)/ZMOLE#      Addatm atom count value          PB40 269
MLWGHT=MLWGHT+VAL*ATWHT(I)#            Accumulate the molecular weigh   PB40 270
WRITE(6,'(13x,a8,f6.2,2f8.2)')ATNAMES(I*8-7^I*8),ATWHT(I),VAL,#         PB40 271
VAL*ATWHT(I)#                                                           PB40 272
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PB40 273
#                                                                       PB40 274
WRITE(6,'(/12x,a,f13.2)') 'Calculated formula weight',MLWGHT#           PB40 275
RC= WGT/MLWGHT#                                                         PB40 276
DC= ABS(WGT - MLWGHT)#                                                  PB40 277
IF     (0.90>RC \RC>1.10) WRITE(6,'(/a)') ' ALERT A: >10% difference'#  PB40 278
ELSEIF (0.95>RC \RC>1.05) WRITE(6,'(/a)') ' ALERT B: > 5% difference'#  PB40 279
ELSEIF (0.99>RC \RC>1.01) WRITE(6,'(/a)') ' ALERT C: > 1% difference'#  PB40 280
ELSE                      WRITE(6,'(/a)') ' CHEMW_03: OK '#             PB40 281
#                                                                       PB40 282
RECBEG_=CIFSTR; RECEND_=CIFSTP#        Reset min max access pointers    PB40 283
F1=DATA_(BLKNAM)#                      Reselect current cif data bloc   PB40 284
#                                                                       PB40 285
RETURN#                                                                 PB40 286
END#                                                                    PB40 287
systemheader:(REFLT3)#                 Real name  reflt_03              REFL   1
#####################################################################   REFL   2
# REQUIRE                                                               REFL   3
#      _CELL_VOLUME                                                     REFL   4
#   ELSE                                                                REFL   5
#      _CELL_LENGTH_A                                                   REFL   6
#      _CELL_LENGTH_B                                                   REFL   7
#      _CELL_LENGTH_C                                                   REFL   8
#      _CELL_ANGLE_ALPHA                                                REFL   9
#      _CELL_ANGLE_BETA                                                 REFL  10
#      _CELL_ANGLE_GAMMA                                                REFL  11
#                                                                       REFL  12
#   REQUIRE                                                             REFL  13
#      _DIFFRN_RADIATION_WAVELENGTH                                     REFL  14
#      _REFLNS_NUMBER_TOTAL                                             REFL  15
#      _REFLNS_NUMBER_OBSERVED                                          REFL  16
#      _DIFFRN_REFLNS_THETA_MAX                                         REFL  17
#   SIMPLE CALCULATION                                                  REFL  18
#      _SYMMETRY_EQUIV_POS_AS_XYZ                                       REFL  19
#      _SYMMETRY_SPACE_GROUP_NAME_HALL                                  REFL  20
#      _SYMMETRY_SPACE_GROUP_NAME_H-M                                   REFL  21
#       REQUIRE NLATT  AND NLAUE  - FROM SYMMETRY                       REFL  22
#      NREF=33.5 *VOL *S^3 / (NLATT * NLAUE)                            REFL  23
#                                                                       REFL  24
#   COMPLEX CALCULATION                                                 REFL  25
#      LOOP  H    -500 TO +500                                          REFL  26
#         LOOP  K -500 TO +500                                          REFL  27
#           LOOP  L -500 TO +500                                        REFL  28
#       OR                                                              REFL  29
#      _DIFFRN_REFLNS_THETA_MIN                                         REFL  30
#      _DIFFRN_REFLNS_LIMIT_H_MIN                                       REFL  31
#      _DIFFRN_REFLNS_LIMIT_H_MAX                                       REFL  32
#      _DIFFRN_REFLNS_LIMIT_K_MIN                                       REFL  33
#      _DIFFRN_REFLNS_LIMIT_K_MAX                                       REFL  34
#      _DIFFRN_REFLNS_LIMIT_L_MIN                                       REFL  35
#      _DIFFRN_REFLNS_LIMIT_L_MAX                                       REFL  36
#             IF S>THETA_MAX NEXT                                       REFL  37
#                                                                       REFL  38
#              TEST IF ABSENT USING SYMOPS                              REFL  39
#                                                                       REFL  40
#       LOOP OVER ALL REFLECTIONS                                       REFL  41
#           CULL EQUIVALENTS                                            REFL  42
#       SUM INDEPENDENTS                                                REFL  43
#                                                                       REFL  44
systemheader:(PB50)#                                                    PB50   1
#################################################################       PB50   2
#                                                               #       PB50   3
#                             PB50                              #       PB50   4
#                                                               #       PB50   5
#################################################################       PB50   6
SUBROUTINE PB50#                                                        PB50   7
include:(AACOMN)#                                                       PB50   8
include:(PBCOMN)#                                                       PB50   9
#                                                                       PB50  10
LOGICAL       F1#                                                       PB50  11
string:(NAME,80)#                                                       PB50  12
REAL          SDEV#                                                     PB50  13
#                                                                       PB50  14
#                                                                       PB50  15
REAL    MAXTH,REFTOT,WAVEL,VOL,NLATT,NLAUE#                             PB50  16
INTEGER II,I,JJ,K,M,NN#                                                 PB50  17
INTEGER JTOT#                                                           PB50  18
REAL    BB(3),CELLP(6),GS(9),RM(9),RC(9)#                               PB50  19
INTEGER  PTR1,PTR2#                    Pointers to qx array             PB50  20
#REAL   QX(MIREF:)#                    MAX NUMBER OF INDEPENDENT REFL   PB50  21
REAL ATWTMX#                                                            PB50  22
string:(ATNAMES,128)#                  Space for 16 atom names          PB50  23
REAL HPOS(3),HNEG(3)#                                                   PB50  24
REAL HKLMAX(3)#                                                         PB50  25
REAL HKLMIN(3)#                                                         PB50  26
REAL HKL(3)#                           Unpacked h,k,l                   PB50  27
REAL H(3)#                                                              PB50  28
REAL A,B,C#                            Rotated h,k,l                    PB50  29
REAL D,DVAL#                           D-spacings                       PB50  30
REAL PQ(100)#                          Proto-qx buffer for output       PB50  31
INTEGER EPS#                           Augment to epsilon               PB50  32
INTEGER IZERO#                         Null                             PB50  33
INTEGER J#                             Point to interpolation point     PB50  34
INTEGER MUL#                           Multiplicity                     PB50  35
INTEGER NROT#                          Number of rotation matrices      PB50  36
INTEGER PRC#                           Phase restriction code           PB50  37
INTEGER HS,HM,HF#                                                       PB50  38
INTEGER HX,KX,LX#                                                       PB50  39
REAL    STOLMX,STOLMN#                                                  PB50  40
INTEGER III,IP,J1,J2,J3,SABS,IB#                                        PB50  41
REAL    R#                                                              PB50  42
INTEGER NTOT,NTOT1#                                                     PB50  43
REAL MINHKL,MINHKL1#                                                    PB50  44
REAL MINH(3),MAXH(3)#                                                   PB50  45
REAL MINK(3),MAXK(3)#                                                   PB50  46
INTEGER  NIABS1,NIREF1#                                                 PB50  47
REAL HKL1#                                                              PB50  48
REAL SMAX,DMIN#                                                         PB50  49
INTEGER  NIABS,NIREF,TNSABS,RFTOT#     R                                PB50  50
REAL ATWHT#                                                             PB50  51
#                                                                       PB50  52
realdata:(STOL,0.);   realdata:(TINY,0.000001)#                         PB50  53
realdata:(X,0.);  realdata:(Y,0.);  realdata:(Z,0.)#                    PB50  54
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              PB50  55
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              PB50  56
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              PB50  57
realdata:(TR21,[.3333333,.5])#                                          PB50  58
realdata:(TR22,[.6666667,0.])#                                          PB50  59
realdata:(TR23,[.6666667,.5])#                                          PB50  60
realdata:(DTOR,.017453293)#                                             PB50  61
#                                                                       PB50  62
datastuff:#                                                             PB50  63
#                                                                       PB50  64
WRITE(6,'(//a)') ' REFLT_03: Check the reflection counts'#              PB50  65
WRITE(6,'( a)') ' -------------------------------------'#               PB50  66
#                                                                       PB50  67
IF(!NUMB_('_diffrn_radiation_wavelength', WAVEL, SDEV ))#               PB50  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB50  69
WRITE(6,'(/a)') ' _diffrn_radiation_wavelength not in the CIF'#         PB50  70
RETURN#                                                                 PB50  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB50  72
#                                                                       PB50  73
IF(!NUMB_('_reflns_number_total', REFTOT, SDEV ))#                      PB50  74
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB50  75
WRITE(6,'(/a)') ' _reflns_number_total not in the CIF'#                 PB50  76
RETURN#                                                                 PB50  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB50  78
JTOT=NINT(REFTOT)#                                                      PB50  79
#                                                                       PB50  80
IF(!NUMB_('_diffrn_reflns_theta_max', MAXTH, SDEV ))#                   PB50  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB50  82
WRITE(6,'(/a)') ' _diffrn_reflns_theta_max not in the CIF'#             PB50  83
RETURN#                                                                 PB50  84
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB50  85
WRITE(6,'(/a,f16.2)')' From the CIF: _diffrn_reflns_theta_max',MAXTH#   PB50  86
WRITE(6,'(a,I19)')' From the CIF: _reflns_number_total',JTOT#           PB50  87
#                                                                       PB50  88
IF(!NUMB_('_diffrn_reflns_limit_h_min', MINH(1), SDEV )\$#              PB50  89
   !NUMB_('_diffrn_reflns_limit_k_min', MINH(2), SDEV )\$#              PB50  90
   !NUMB_('_diffrn_reflns_limit_l_min', MINH(3), SDEV )\$#              PB50  91
   !NUMB_('_diffrn_reflns_limit_h_max', MAXH(1), SDEV )\$#              PB50  92
   !NUMB_('_diffrn_reflns_limit_k_max', MAXH(2), SDEV )\$#              PB50  93
   !NUMB_('_diffrn_reflns_limit_l_max', MAXH(3), SDEV ))$#              PB50  94
WRITE(6,'(/a)')' WARNING: _diffrn_reflns_limit_ values not in CIF'#     PB50  95
ELSE#                                                                   PB50  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PB50  97
WRITE(6,'(/a,3f6.0)')' From the CIF: _diffrn_reflns_limit_ max hkl',$#  PB50  98
(MAXH(I),I=1,3)#                                                        PB50  99
WRITE(6,'(a,3f6.0)')' From the CIF: _diffrn_reflns_limit_ min hkl',$#   PB50 100
(MINH(I),I=1,3)#                                                        PB50 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PB50 102
#                                                                       PB50 103
IF(!NUMB_('_cell_length_a',   CELLP(1), SDEV ) \#                       PB50 104
!NUMB_('_cell_length_b',   CELLP(2), SDEV ) \#                          PB50 105
!NUMB_('_cell_length_c',   CELLP(3), SDEV ) \#                          PB50 106
!NUMB_('_cell_angle_alpha',CELLP(4), SDEV ) \#                          PB50 107
!NUMB_('_cell_angle_beta', CELLP(5), SDEV ) \#                          PB50 108
!NUMB_('_cell_angle_gamma',CELLP(6), SDEV ) )#                          PB50 109
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PB50 110
WRITE(6,'(/a/)') ' Cell length or angle missing from cif'#              PB50 111
RETURN#                                                                 PB50 112
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PB50 113
DO I=4,6;CELLP(I)=COS(CELLP(I)*DTOR)#                                   PB50 114
#                                      Metric tensor                    PB50 115
GS(1)=CELLP(1)**2#                     A..2                             PB50 116
GS(2)=CELLP(1)*CELLP(2)*CELLP(6)#      A.b.cos(gamma)                   PB50 117
GS(3)=CELLP(1)*CELLP(3)*CELLP(5)#      A.c.cos(beta)                    PB50 118
GS(4)=GS(2)#                           A.b.cos(gamma)                   PB50 119
GS(5)=CELLP(2)**2#                     B..2                             PB50 120
GS(6)=CELLP(2)*CELLP(3)*CELLP(4)#      B.c.cos(alpha)                   PB50 121
GS(7)=GS(3)#                           A.c.cos(beta)                    PB50 122
GS(8)=GS(6)#                           B.c.cos(alpha)                   PB50 123
GS(9)=CELLP(3)**2#                     C..2                             PB50 124
DO I=1,9; RM(I)=GS(I)#                 Copy to inverse                  PB50 125
#                                                                       PB50 126
DO I=1,3#                              Invert the tensor                PB50 127
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PB50 128
BB(3)=1.0/RM(1)#                                                        PB50 129
BB(1)=RM(2)*BB(3)#                                                      PB50 130
BB(2)=RM(3)*BB(3)#                                                      PB50 131
RM(3)=-RM(4)*BB(3)#                    S                                PB50 132
RM(1)=RM(5)-RM(4)*BB(1)#               Sx                               PB50 133
RM(2)=RM(6)-RM(4)*BB(2)#               Sx                               PB50 134
RM(6)=-RM(7)*BB(3)#                    S                                PB50 135
RM(4)=RM(8)-RM(7)*BB(1)#               Sx                               PB50 136
RM(5)=RM(9)-RM(7)*BB(2)#               Sx                               PB50 137
RM(7)=BB(1)#                                                            PB50 138
RM(8)=BB(2)#                                                            PB50 139
RM(9)=BB(3)#                                                            PB50 140
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PB50 141
#                                      Reciprocal cell constants        PB50 142
RC(1)=SQRT(RM(1))#                     A*                               PB50 143
RC(2)=SQRT(RM(5))#                     B*                               PB50 144
RC(3)=SQRT(RM(9))#                     C*                               PB50 145
RC(4)=RM(6)/(RC(2)*RC(3))#             Cos(alpha*)                      PB50 146
RC(5)=RM(3)/(RC(1)*RC(3))#             Cos(beta*)                       PB50 147
RC(6)=RM(2)/(RC(1)*RC(2))#             Cos(gamma*)                      PB50 148
RC(7)=ACOS(RC(4))/DTOR#                Alpha*                           PB50 149
RC(8)=ACOS(RC(5))/DTOR#                Beta*                            PB50 150
RC(9)=ACOS(RC(6))/DTOR#                Gamma*                           PB50 151
#                                                                       PB50 152
#  CURRENTLY THERE ARE NO ATOM TYPES IN ATNAMES!                        PB50 153
#  ---------------------------------------------                        PB50 154
#                                                                       PB50 155
ATWTMX=0.#                                                              PB50 156
REPEAT#                                Loop over all atom sites         PB50 157
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PB50 158
IF(!CHAR_('_atom_site_type_symbol', NAME))#                             PB50 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PB50 160
F1=CHAR_('_atom_site_label',       NAME)#                               PB50 161
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PB50 162
label:(NAME,JJ,K,ATNAMES,NN)#          Check if already present         PB50 163
try:(CALL PB99(NAME(1^K),ATWHT))#      Get atomic weight                PB50 164
ATWTMX=MAX(ATWTMX,ATWHT)#              Maybe this works anyway          PB50 165
IF(!LOOP_) BREAK#                      How was this set ??              PB50 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PB50 167
##                                                                      PB50 168
##     DETERMINE SYMMETRY OPERATIONS                                    PB50 169
##     -----------------------------                                    PB50 170
##                                                                      PB50 171
try:(CALL PB89)#                       Check & write symops             PB50 172
#                                      Only need rotational symops      PB50 173
##                                                                      PB50 174
NLAUE= 2.0*FLOAT(NSYM)#                                                 PB50 175
NLATT= FLOAT(LTYP)#                                                     PB50 176
IF(LTYP==5 \LTYP==6 \LTYP==7 )NLATT=2.#                                 PB50 177
SMAX=SIN(MAXTH*DTOR)/WAVEL#                                             PB50 178
#######NREF=33.5 * VOL * (SMAX**3) /(NLAUE*NLATT)# approximation        PB50 179
ICNT=1-ICNT#                           Centricity a=0   c=1             PB50 180
#                                                                       PB50 181
# GET SYMMETRY EQUIVALENT POSITIONS FROM LRSYMM:                        PB50 182
# ----------------------------------------------                        PB50 183
#                                                                       PB50 184
IF(ICNT==1)#                           If centrosymmetric               PB50 185
DO J=1,NSYM#                                                            PB50 186
DO I=1,12; RSMAT(I,NSYM+J)=-RSMAT(I,J)# Store inverse matrix            PB50 187
II= NSYM+ICNT*NSYM#                    Rot+inv symops                   PB50 188
#                                                                       PB50 189
IF(LTYP>1)#                            Test if sg centered              PB50 190
DO J=1,NSYM+ICNT*NSYM#                                                  PB50 191
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PB50 192
DO I=1,9; RSMAT(I,II+J)=RSMAT(I,J)#    Store inverse matrix             PB50 193
RSMAT(10,II+J)=RSMAT(10,J)+TR11(LTYP-1)# Transfer t1                    PB50 194
RSMAT(11,II+J)=RSMAT(11,J)+TR12(LTYP-1)# Transfer t2                    PB50 195
RSMAT(12,II+J)=RSMAT(12,J)+TR13(LTYP-1)# Transfer t3                    PB50 196
II=II+1#                               Incr storage pointer             PB50 197
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               PB50 198
DO I=1,9; RSMAT(I,II+J)=RSMAT(I,J)#    Store inverse matrix             PB50 199
RSMAT(10,II+J)=RSMAT(10,J)+TR21(LTYP-2)# Transfer t1                    PB50 200
RSMAT(11,II+J)=RSMAT(11,J)+TR22(LTYP-2)# Transfer t2                    PB50 201
RSMAT(12,II+J)=RSMAT(12,J)+TR23(LTYP-2)# Transfer t3                    PB50 202
II=II+1#                               Incr storage pointer             PB50 203
IF(LTYP!=4) NEXT#                      Skip if not f-centre             PB50 204
DO I=1,9; RSMAT(I,II+J)=RSMAT(I,J)#    Store inverse matrix             PB50 205
RSMAT(10,II+J)=RSMAT(10,J)+0.5#        Transfer t1                      PB50 206
RSMAT(11,II+J)=RSMAT(11,J)+0.5#        Transfer t2                      PB50 207
RSMAT(12,II+J)=RSMAT(12,J)+0.0#        Transfer t3                      PB50 208
II=II+1#                               Incr storage pointer             PB50 209
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PB50 210
NROT=II#                                                                PB50 211
##                                                                      PB50 212
DO I=7,9; RC(I)=ABS(SIN(RC(I)*DTOR))#  Get sine of angles               PB50 213
HPOS(1)=2.*SMAX/(RC(1)*RC(8)*RC(9))#   Calc h max                       PB50 214
HPOS(2)=2.*SMAX/(RC(2)*RC(7)*RC(9))#   Calc k max                       PB50 215
HPOS(3)=2.*SMAX/(RC(3)*RC(8)*RC(7))#   Calc l max                       PB50 216
DO I=1,3; HPOS(I)=FLOAT(NINT(HPOS(I)))# Intergerize maxima              PB50 217
DO I=1,3; HNEG(I)=-HPOS(I)#            Set hkl minimum                  PB50 218
#                                                                       PB50 219
# MARK ITEMS FOR OUTPUT                                                 PB50 220
# ---------------------                                                 PB50 221
#                                                                       PB50 222
DO I=1,3; HKL(I)=0.0#                                                   PB50 223
DO I=1,100; PQ(I)=0.0#                 Zero input parameters            PB50 224
IZERO=0#                               Used to clear packed words       PB50 225
DO I=1,3 ; HKLMAX(I)=-999.#            Initial max hkl                  PB50 226
DO I=1,3 ; HKLMIN(I)=999.#             Initial min hkl                  PB50 227
DO I=1,3; HKL(I)=HNEG(I);#                                              PB50 228
DO I=1,3 ; MAXK(I)=-999.#              Initial max hkl                  PB50 229
DO I=1,3 ; MINK(I)=999.#               Initial min hkl                  PB50 230
HKL(1)=HKL(1)-1.#                      Set initial hkl counters         PB50 231
HX=99999;KX=HX;LX=HX#                  Set improbable limits            PB50 232
STOLMX=0.0#                            Max stol                         PB50 233
STOLMN=180.0#                          Min stol                         PB50 234
IP=0#                                  Set base pointer into pq()       PB50 235
RFTOT=0#                               Number of reflns in sphere       PB50 236
NIREF=0#                               Number of independent reflns     PB50 237
NIABS=0#                               Number of independent sysabs     PB50 238
TNSABS=0#                              Total num of sysabs in sphere    PB50 239
DMIN=0.#                                                                PB50 240
NTOT=0#                                                                 PB50 241
NTOT1=0#                                                                PB50 242
NIREF1=0;NIABS1=0#                                                      PB50 243
J1=1;J2=2;J3=3#                        Slow, med & fast indices         PB50 244
#                                                                       PB50 245
# SMALL XTAL SPECIFIC SECTION TO CUT DOWN ON VARIABLE SPACE             PB50 246
#                                                                       PB50 247
incrqx:(K,QXCUR+2*miref:,PB5001)#      Unable to get space required     PB50 248
PTR1=QXCUR;PTR2=PTR1+miref:#           Pointers to reflection array     PB50 249
#                                                                       PB50 250
#   LOOP OVER ALL REFLECTIONS                                           PB50 251
#   -------------------------                                           PB50 252
FOR(HKL(1)=HNEG(1);HKL(1)<=HPOS(1);HKL(1)=HKL(1)+1.)#                   PB50 253
FOR(HKL(2)=HNEG(2);HKL(2)<=HPOS(2);HKL(2)=HKL(2)+1.)#                   PB50 254
FOR(HKL(3)=HNEG(3);HKL(3)<=HPOS(3);HKL(3)=HKL(3)+1.)#                   PB50 255
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PB50 256
X=HKL(1) ; Y=HKL(2) ; Z=HKL(3)#        Store temporary                  PB50 257
IF(ABS(X)>HX \ ABS(Y)>KX \ ABS(Z)>LX) NEXT# Test h,k,l max values       PB50 258
#                                                                       PB50 259
STOL=.5*SQRT(X*(X*RM(1)+Y*RM(2)+Z*RM(3))$# Apply metric tensor          PB50 260
            +Y*(X*RM(4)+Y*RM(5)+Z*RM(6))$# Apply metric tensor          PB50 261
            +Z*(X*RM(7)+Y*RM(8)+Z*RM(9)))# Apply metric tensor          PB50 262
IF(STOL*WAVEL>1.0) NEXT#                                                PB50 263
IF(STOL<0.00001) NEXT#                 This is should not be here       PB50 264
DVAL=0.5/STOL#                         D spacing                        PB50 265
IF(STOL>SMAX\DVAL<DMIN) NEXT#                                           PB50 266
##                                                                      PB50 267
## CHECK FOR SYSTEMATIC ABSENCES                                        PB50 268
##                                                                      PB50 269
MUL=0;   EPS=0;   PRC=ICNT#            Reset hkl mult/epsilon/prc       PB50 270
SABS=no:#                                                               PB50 271
DO K=1,NROT#                           Skip identity                    PB50 272
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PB50 273
A=X*RSMAT(1, K)+Y*RSMAT(2, K)+Z*RSMAT(3, K)# Generate h'                PB50 274
B=X*RSMAT(4, K)+Y*RSMAT(5, K)+Z*RSMAT(6, K)# Generate k'                PB50 275
C=X*RSMAT(7, K)+Y*RSMAT(8, K)+Z*RSMAT(9, K)# Generate l'                PB50 276
D=X*RSMAT(10,K)+Y*RSMAT(11,K)+Z*RSMAT(12,K)# Generate shift             PB50 277
M=MOD(NINT(12.*D)+120,12)#             Ensure d in 12ths of 2pi         PB50 278
IF((ABS(A-X)<TINY)$#                   H=h'                             PB50 279
&  (ABS(B-Y)<TINY)$#                   K=k'                             PB50 280
&  (ABS(C-Z)<TINY))#                   L=l'                             PB50 281
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PB50 282
MUL=MUL+1#                             Count equiv hkl                  PB50 283
IF(M==0) EPS=EPS+1#                    Count reinforcement factor       PB50 284
ELSE#                                                                   PB50 285
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PB50 286
SABS=yes:#                             Skip if sysabs not requ.         PB50 287
GOTO 100#                              Set reason flag                  PB50 288
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PB50 289
NEXT#                                  Next eq pos                      PB50 290
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PB50 291
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PB50 292
100 CONTINUE#                                                           PB50 293
#                                                                       PB50 294
#  IF MERGING REDUCE TO LOWEST CANONICAL WORD                           PB50 295
#  ------------------------------------------                           PB50 296
#                                                                       PB50 297
X=HKL(1) ; Y=HKL(2) ; Z=HKL(3)#        Store temporary                  PB50 298
intpak:(1,MINHKL,30,1)#                Set max packed hkl               PB50 299
intpak:(1,MINHKL1,30,1)#                                                PB50 300
#                                                                       PB50 301
DO K=1,NSYM+ICNT*NSYM#                 Loop over all rot symops         PB50 302
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PB50 303
H(1)=X*RSMAT(1, K)+Y*RSMAT(2, K)+Z*RSMAT(3, K)# Generate h'             PB50 304
H(2)=X*RSMAT(4, K)+Y*RSMAT(5, K)+Z*RSMAT(6, K)# Generate k'             PB50 305
H(3)=X*RSMAT(7, K)+Y*RSMAT(8, K)+Z*RSMAT(9, K)# Generate l'             PB50 306
HS=NINT(H(J1))#                        Get slowest-varying index        PB50 307
HM=NINT(H(J2))#                        Get medium -varying index        PB50 308
HF=NINT(H(J3))#                        Get fastest-varying index        PB50 309
IF((HS<0)$#                            Hs must be positive              PB50 310
\ ((HM<0)&(HS==0))$#                   Hs=0 hm negative                 PB50 311
\ ((HF<0)&(HS==0)&(HM==0)))#           Hs=0 hm=0 hf negative            PB50 312
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PB50 313
HS=-HS; HM=-HM; HF=-HF; IB=1#          Reverse hkl set bijvoet          PB50 314
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PB50 315
ELSE IB=0#                             Bijvoet sign not set             PB50 316
intpak:(0,HKL1,0,mxbtwd:)#             Clear out previous packed hkl    PB50 317
IF(HM<0) intpak:(1,HKL1,29,1)#         Sign code med index -/+ 1/0      PB50 318
IF(HF<0) intpak:(1,HKL1,28,1)#         Sign code fas index -/+ 1/0      PB50 319
intpak:(IABS(HS),HKL1,19, 9)#          Pack slow index                  PB50 320
intpak:(IABS(HM),HKL1,10, 9)#          Pack med  index                  PB50 321
intpak:(IABS(HF),HKL1, 1, 9)#          Pack fast index                  PB50 322
intpak:(IB      ,HKL1, 0, 1)#          Bijvoet sign code                PB50 323
compakwd:(HKL1,LT,MINHKL,movepakwd:(HKL1,MINHKL))# Store smallest pac   PB50 324
IF(ICNT==0)#                           If non centrosymmetric           PB50 325
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PB50 326
intpak:( 0,HKL1, 0, 1)#                Cancel bijvoet bit               PB50 327
compakwd:(HKL1,LT,MINHKL1,movepakwd:(HKL1,MINHKL1))# Store smallest p   PB50 328
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PB50 329
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PB50 330
#                                                                       PB50 331
DO I=1,3; MAXK(I)=MAX(MAXK(I),HKL(I))# Save largest hkl                 PB50 332
DO I=1,3; MINK(I)=MIN(MINK(I),HKL(I))# Save smallest hkl                PB50 333
#                                                                       PB50 334
# XTAL SPECIFIC QX ARRAY SECTION                                        PB50 335
#                                                                       PB50 336
IF(NTOT==0) I=1#                                                        PB50 337
ELSE DO I=1,NTOT#                                                       PB50 338
compakwd:(QX(PTR1+I),EQ,MINHKL,BREAK)# Is new packed hkl smaller        PB50 339
IF (I>NTOT)#                           A new word                       PB50 340
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PB50 341
IF (SABS==yes:) NIABS=NIABS+1#         Number of independent sysabs     PB50 342
ELSE            NIREF=NIREF+1#         Number of independent reflns     PB50 343
NTOT=NTOT+1#                           Increment reflection counter     PB50 344
movepakwd:(MINHKL,QX(PTR1+NTOT))#      Store smallest packed hkl        PB50 345
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PB50 346
ELSE#                                  (i<=ntot) - an old reflection    PB50 347
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PB50 348
IF (SABS==yes:) TNSABS=TNSABS+1#       Total num of sysabs in sphere    PB50 349
ELSE            RFTOT=RFTOT+1#         Number of reflns in sphere       PB50 350
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PB50 351
#                                                                       PB50 352
IF(ICNT==0)#                           Repeat for non-centro            PB50 353
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PB50 354
IF(NTOT1==0) I=1#                                                       PB50 355
ELSE DO I=1,NTOT1#                                                      PB50 356
compakwd:(QX(PTR2+I),EQ,MINHKL1,BREAK)# Is new packed hkl smaller       PB50 357
IF (I>NTOT1)#                          A new word                       PB50 358
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PB50 359
IF (SABS==yes:) NIABS1=NIABS1+1#       Number of independent sysabs     PB50 360
ELSE            NIREF1=NIREF1+1#       Number of independent reflns     PB50 361
NTOT1=NTOT1+1#                         Increment reflection counter     PB50 362
movepakwd:(MINHKL1,QX(PTR2+NTOT1))#    Store smallest packed hkl        PB50 363
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PB50 364
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PB50 365
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PB50 366
TNSABS=TNSABS+NIABS#                                                    PB50 367
RFTOT=RFTOT+NIREF#                                                      PB50 368
IF(ICNT!=0)NIREF1=NIREF#               If centrosymmetric               PB50 369
#                                                                       PB50 370
WRITE(6,'(/a)')'      TEST1: Expected hkl limits for theta max'#        PB50 371
WRITE(6,'(/22x,a,3f6.0)') 'Calculated maximum hkl',(MAXK(I),I=1,3)#     PB50 372
WRITE(6,'(22x,a,3f6.0)')  'Calculated minimum hkl',(MINK(I),I=1,3)#     PB50 373
DO I=1,3;IF((ABS(MAXK(I)-MAXH(I))>.5)&(ABS(MINK(I)-MINH(I))>.5))BREAK#  PB50 374
IF(I<4)#                                                                PB50 375
WRITE(6,'(/a)')' ALERT: Expected hkl max differ from CIF values'#       PB50 376
#                                                                       PB50 377
WRITE(6,'(/a)')'      TEST2: Reflns within _diffrn_reflns_theta_max'#   PB50 378
C=100.*FLOAT(JTOT)/FLOAT(NIREF1)#      Data completeness                PB50 379
WRITE(6,'(/10x,a,i13)')'Count of symmetry unique reflns',NIREF1#        PB50 380
WRITE(6,'(10x,a,f13.2,a)')'Completeness (_total/calc)     ',C,'%'#      PB50 381
IF(ICNT==1)#                           If centrosymmetric               PB50 382
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PB50 383
IF     (C<85.) WRITE(6,'(/a)')' ALERT A: < 85% complete (theta max?)'#  PB50 384
ELSE IF(C<90.) WRITE(6,'(/a)')' ALERT B: < 90% complete (theta max?)'#  PB50 385
ELSE IF(C<95.) WRITE(6,'(/a)')' ALERT C: < 95% complete'#               PB50 386
ELSE IF(C>115.) WRITE(6,'(/a)')$#                                       PB50 387
' ALERT A: >15% excess reflns : are sys abs data still present?'#       PB50 388
ELSE IF(C>110.) WRITE(6,'(/a)')$#                                       PB50 389
' ALERT B: >10% excess reflns : are sys abs data still present?'#       PB50 390
ELSE IF(C>105.) WRITE(6,'(/a)')$#                                       PB50 391
' ALERT C:  >5% excess reflns : are sys abs data still present?'#       PB50 392
ELSE            WRITE(6,'(/a)')' REFLT_03: OK '#                        PB50 393
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PB50 394
#                                                                       PB50 395
ELSE#                                  If non-centrosymmetric           PB50 396
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PB50 397
IF     (C<85.) WRITE(6,'(/a)')' ALERT A: < 85% complete (theta max?)'#  PB50 398
ELSE IF(C<90.) WRITE(6,'(/a)')' ALERT B: < 90% complete (theta max?)'#  PB50 399
ELSE IF(C<95.) WRITE(6,'(/a)')' ALERT C: < 95% complete'#               PB50 400
#                                                                       PB50 401
WRITE(6,'(//a)')'      TEST3: Check Friedels for noncentro structure'#  PB50 402
NN=MAX(0,JTOT-NIREF1)#                                                  PB50 403
WRITE(6,'(/10x,a,i10)')'Estimate of Friedel pairs measured',NN#         PB50 404
R=FLOAT(NN)/FLOAT(NIREF1)#                                              PB50 405
WRITE(6,'(10x,a,f10.3)')'Fraction of Friedel pairs measured',R#         PB50 406
#                                                                       PB50 407
IF(ATWTMX>28.)#                        A heavy atom noncentro structu   PB50 408
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PB50 409
WRITE(6,'(10x,a)')'Are heavy atom types Z>Si present        yes'#       PB50 410
IF(R<0.5)#                                                              PB50 411
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PB50 412
WRITE(6,'(/a)')' WARNING: Large fraction of Friedel related reflns'#    PB50 413
WRITE(6,'(a)')'          needed to determine absolute structure'#       PB50 414
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PB50 415
ELSE            WRITE(6,'(/a/)')' REFLT_03: OK '#                       PB50 416
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PB50 417
#                                                                       PB50 418
ELSE#                                  Noncentro light atom             PB50 419
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PB50 420
WRITE(6,'(10x,a)')'Are heavy atom types Z>Si present         no'#       PB50 421
III=1#                                 Default is mo rad                PB50 422
IF(!NUMB_('_diffrn_radiation_wavelength',C,SDEV))#                      PB50 423
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PB50 424
IF(CHAR_('_diffrn_radiation_type',NAME))#                               PB50 425
DO I=1,20; IF(NAME(I^I)!=' ') BREAK#   Find first non-blank             PB50 426
IF(NAME(I^I)!='M') III=0#              Flag as cu rad                   PB50 427
IF(NAME(I^I)!='m') III=0#              Flag as cu rad                   PB50 428
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PB50 429
ELSE#                                  Wavelength is present            PB50 430
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PB50 431
IF((C-0.7107)>0.1) III=0#              Flag as cu rad                   PB50 432
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PB50 433
IF(FLOAT(JTOT)/FLOAT(NIREF1)<1.02) WRITE(6,'(/a/)')' REFLT_03: OK '#    PB50 434
ELSE#                                  Friedel data is present          PB50 435
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 PB50 436
IF(III==0)#                            If cu radiation                  PB50 437
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 PB50 438
IF(R<0.5)#                             If fraction < 50%                PB50 439
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 PB50 440
WRITE(6,'(/a)')' WARNING: CuKa measured Friedel data can be used to'#   PB50 441
WRITE(6,'(a)')'          determine absolute structure in a light-atom'# PB50 442
WRITE(6,'(a)')'          study only if the Friedel fraction is large.'# PB50 443
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 PB50 444
ELSE            WRITE(6,'(/a/)')' REFLT_03: OK '#                       PB50 445
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 PB50 446
ELSE#                                  This is mo rad                   PB50 447
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 PB50 448
WRITE(6,'(/a)')' ALERT: MoKa measured Friedel data cannot be used to'#  PB50 449
WRITE(6,'(a)')'        determine absolute structure in a light-atom'#   PB50 450
WRITE(6,'(a)')'        study EXCEPT under VERY special conditions.'#    PB50 451
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 PB50 452
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 PB50 453
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PB50 454
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PB50 455
#                                                                       PB50 456
QXCUR=PTR1#                            Recover pointer to refln array   PB50 457
RECBEG_=CIFSTR; RECEND_=CIFSTP#        Reset min max access pointers    PB50 458
F1=DATA_(BLKNAM)#                      Reselect current cif data bloc   PB50 459
#                                                                       PB50 460
RETURN#                                                                 PB50 461
END#                                                                    PB50 462
systemheader:(PB60)#                                                    PB60   1
#################################################################       PB60   2
#                                                               #       PB60   3
#                           STRVAL                              #       PB60   4
#                                                               #       PB60   5
#################################################################       PB60   6
SUBROUTINE PB60#                                                        PB60   7
include:(AACOMN)#                                                       PB60   8
include:(PBCOMN)#                                                       PB60   9
#                                                                       PB60  10
LOGICAL       F1,F2#                                                    PB60  11
REAL  ROGERS,SROGERS#                                                   PB60  12
REAL  FLACK ,SFLACK#                                                    PB60  13
#                                                                       PB60  14
WRITE(6,'(//a)') ' STRVAL_02: Check absolute structure measures'#       PB60  15
WRITE(6,'( a)') ' --------------------------------------------'#        PB60  16
##                                                                      PB60  17
##  LOOK FOR _refine_ls_abs_structure_Flack                             PB60  18
##  ---------------------------------------                             PB60  19
##                                                                      PB60  20
F1=NUMB_('_refine_ls_abs_structure_Flack',FLACK,SFLACK)#                PB60  21
IF(F1)#                                                                 PB60  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB60  23
WRITE(6,'(/a,f9.3)')$#                                                  PB60  24
' From the CIF: _refine_ls_abs_structure_Flack   ',FLACK#               PB60  25
WRITE(6,'(a,f9.3)')$#                                                   PB60  26
' From the CIF: _refine_ls_abs_structure_Flack_su',SFLACK#              PB60  27
#                                                                       PB60  28
IF(FLACK>0.7)#                                                          PB60  29
WRITE(6,'(/a,f7.3/)')' ALERT: Chirality of atom sites is inverted?'#    PB60  30
ELSEIF(FLACK>0.3)#                                                      PB60  31
WRITE(6,'(/a,f7.3/)')' ALERT: Flack test results are ambiguous.'#       PB60  32
ELSEIF(FLACK<-0.2)#                                                     PB60  33
WRITE(6,'(/a,f7.3/)')' WARNING: Flack parameter is too small'#          PB60  34
ELSEIF(SFLACK>0.5)#                                                     PB60  35
WRITE(6,'(/a,f7.3/)')' ALERT: Flack test results are meaningless.'#     PB60  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB60  37
ELSE#                                                                   PB60  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB60  39
WRITE(6,'(/a)') ' _refine_ls_abs_structure_Flack not in the CIF'#       PB60  40
##                                                                      PB60  41
##  LOOK FOR _refine_ls_abs_structure_Rogers                            PB60  42
##  ---------------------------------------                             PB60  43
##                                                                      PB60  44
F2=NUMB_('_refine_ls_abs_structure_Rogers',ROGERS,SROGERS)#             PB60  45
IF(F2)#                                                                 PB60  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB60  47
WRITE(6,'(/a,f9.3)')' From the CIF: _refine_ls_abs_structure_Rogers',#  PB60  48
ROGERS#                                                                 PB60  49
IF (ABS(ROGERS)>1.2) WRITE(6,'(/a,f7.3/)')$#                            PB60  50
' STRVAL_02: WARNING Rogers value is too large'#                        PB60  51
ELSE IF(ROGERS<0.5&ROGERS>-0.5) WRITE(6,'(/a,f7.3/)')$#                 PB60  52
' STRVAL_02: WARNING Rogers value is inconclusive'#                     PB60  53
ELSEIF(ROGERS <-1.2) WRITE(6,'(/a,f7.3/)')$#                            PB60  54
' STRVAL_02: WARNING Rogers value is too low'#                          PB60  55
ELSEIF(ROGERS <-0.5) WRITE(6,'(/a,f7.3/)')$#                            PB60  56
' STRVAL_02: WARNING Rogers value suggests reverse chirality'#          PB60  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB60  58
ELSE#                                                                   PB60  59
WRITE(6,'(/a/)') ' _refine_ls_abs_structure_Rogers not in the CIF'#     PB60  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB60  61
#                                                                       PB60  62
RETURN#                                                                 PB60  63
END#                                                                    PB60  64
systemheader:(PB89)#                   Convert cif sym to matrices      PB89   1
# ################################################################## #  PB89   2
#                                                                    #  PB89   3
#                               PB89                                 #  PB89   4
#                                                                    #  PB89   5
# ################################################################## #  PB89   6
SUBROUTINE PB89#                                                        PB89   7
include:(AACOMN)#                                                       PB89   8
include:(PBCOMN)#                                                       PB89   9
#                                                                       PB89  10
LOGICAL F1,F2,F3#                                                       PB89  11
CHARACTER*80  NAME#                                                     PB89  12
string:(SNAME,80)#                                                      PB89  13
string:(SYMOP,80)#                                                      PB89  14
CHARACTER*80  HALL1,HALL2,MAUG1,MAUG2#                                  PB89  15
INTEGER       I,IR,J,K,MATCH,NH,NH1,NH2,NM,NM1,NM2#                     PB89  16
INTEGER       NN#                                                       PB89  17
chardata:(SHLX,'(1)(2)(3)(4)(6)')#     Sheldricks subscripts            PB89  18
chardata:(OTHR,'~1~~2~~3~~4~~6~')#     Cif subscripts                   PB89  19
datastuff:#                                                             PB89  20
#                                                                       PB89  21
#                                                                       PB89  22
STRG=' '#                              Blank out sgname string          PB89  23
LTYP=0;  ICNT=-1#                      Unset moles/cell & symmetry      PB89  24
NSYM=0; SGN=yes:#                      Initialize count of symops.      PB89  25
DO J=1,200#                            Loop over symops                 PB89  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB89  27
SMAT(16,J)=12#                         (4,4) matrix element             PB89  28
DO I=1,15 ; SMAT(I,J)=0#               Others                           PB89  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB89  30
#                                                                       PB89  31
REPEAT#                                Get equiv position symops        PB89  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB89  33
IF(!CHAR_('_symmetry_equiv_pos_as_xyz', SYMOP)) BREAK#                  PB89  34
NSYM=NSYM+1#                           Increment number of symops       PB89  35
try:(CALL PB91(SYMOP))#                Decode symop to matrix           PB89  36
IF(!LOOP_) BREAK#                      No more packets in loop          PB89  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB89  38
#                                                                       PB89  39
#                                                                       PB89  40
IF (NSYM>0)#                           If xyz symops present            PB89  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB89  42
try:(CALL PB94)#                       Convert symops to hall name      PB89  43
locase:(STRG,HALL,40); NH=ICHR#                                         PB89  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB89  45
#                                                                       PB89  46
ELSE#                                  Get symops from space group      PB89  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PB89  48
IF(!CHAR_('_symmetry_space_group_name_Hall', NAME))#                    PB89  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PB89  50
IF(!CHAR_('_symmetry_space_group_name_H-M', NAME))#                     PB89  51
$( WRITE(6,'(/a/)') ' `No symmetry data in CIF - exiting';RETURN $)#    PB89  52
#                                                                       PB89  53
DO I=1,40; IF(NAME(I^I)!=' ') BREAK#   Find first non-blank             PB89  54
locase:(NAME(I^I+59),SNAME,60)#        Extract input string             PB89  55
DO I=1,60; IF(SNAME(I^I)==':') BREAK#  Stop at end of string            PB89  56
DO K=60,1,-1; IF(SNAME(K^K)!=' ') BREAK# Stop at end of hall string     PB89  57
IF(K>1)#                               H-m symbol detected              PB89  58
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PB89  59
MAUG=SNAME(1^K);  NM=K#                Store h-m symbol only            PB89  60
DO K=1,NM; IF(MAUG(K^K)==' ') MAUG(K^K)='_'# Fill with underlines       PB89  61
DO K=1,NM#                             Loop over table symbol           PB89  62
IF(INDEX(SHLX,MAUG(J^J+2))>0)#         Detect shelx axes brakets        PB89  63
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PB89  64
MAUG(J^NM-1)=MAUG(J+1^J+1)//' '//MAUG(J+3^NM)# Remove brackets          PB89  65
NM=NM-1#                               Reduce length of string          PB89  66
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PB89  67
DO K=1,NM#                             Loop over table symbol           PB89  68
IF(INDEX(OTHR,MAUG(J^J+2))>0)#         Detect shelx axes brakets        PB89  69
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PB89  70
MAUG(J^NM-1)=MAUG(J+1^J+1)//' '//MAUG(J+3^NM)# Remove brackets          PB89  71
NM=NM-1#                               Reduce length of string          PB89  72
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PB89  73
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PB89  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PB89  75
#                                                                       PB89  76
ELSE#                                                                   PB89  77
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PB89  78
WRITE(6,'(a,a)') 'Hall Space group   ',NAME(1^LONG_)#                   PB89  79
DO I=1,40; IF(NAME(I^I)!=' ') BREAK#   Find first non-blank             PB89  80
locase:(NAME(I^I+59),SNAME,60)#        Extract input string             PB89  81
DO I=1,60; IF(SNAME(I^I)==':') BREAK#  Stop at end of string            PB89  82
DO K=I-1,1,-1; IF(SNAME(K^K)!=' ') BREAK# Stop at end of hall string    PB89  83
IF(K>1)#                               Hall symbol detected             PB89  84
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PB89  85
HALL=' '; J=0; DO I=1,K#               Loop over string                 PB89  86
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PB89  87
IF(SNAME(I^I)==' '&SNAME(I+1^I+1)==' ') NEXT# Skip multiple blanks      PB89  88
J=J+1;  HALL(J^J)=SNAME(I^I)#          Store notation                   PB89  89
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PB89  90
NH=J#                                  Store hall symbol only           PB89  91
DO K=1,NH; IF(HALL(K^K)==' ') HALL(K^K)='_'# Fill with underlines       PB89  92
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PB89  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PB89  94
#                                                                       PB89  95
#    FOR HALL OR H-M SCAN SYMMAP FILE FOR MATCH                         PB89  96
#    ------------------------------------------                         PB89  97
#                                                                       PB89  98
RECBEG_=SYMSTR; RECEND_=SYMSTP#        Reset min and max pointers       PB89  99
IF(!DATA_(SYMMAP)) lquit:('Data block missing from cif')#               PB89 100
#                                                                       PB89 101
DO IR=1,2#                             Loop for second match pass       PB89 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PB89 103
REPEAT#                                Loop over notation               PB89 104
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PB89 105
F1=CHAR_('_symmetry_space_group_name_Hall',HALL1)# Get hall symbol      PB89 106
NH1=LONG_#                             And its length                   PB89 107
F2=CHAR_('_symmetry_space_group_name_H-M',MAUG1)# Get h-m symbol        PB89 108
NM1=LONG_#                             And its length                   PB89 109
F3=CHAR_('_symmetry_space_group_id',ITNM)# Get space group id number    PB89 110
MATCH=yes:#                            Flag for match                   PB89 111
locase:(MAUG1,MAUG1,NM1)#              Convert all to lowercase         PB89 112
#                                                                       PB89 113
IF(NH>0)#                              Look for hall match              PB89 114
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PB89 115
NH2=0#                                 Start notation length            PB89 116
DO J=1,NH1#                            Loop over table symbol           PB89 117
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PB89 118
IF(HALL1(J^J)=='_') NEXT#              Skip underscores                 PB89 119
NH2=NH2+1#                             Count chars in notation          PB89 120
HALL2(NH2^NH2)=HALL1(J^J)#             Notation with no spacers         PB89 121
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PB89 122
IF(NH==NH1)#                           If lengths the same              PB89 123
IF(HALL(1^NH)==HALL1(1^NH)) BREAK#     Exit if match found              PB89 124
IF(NH==NH2)#                           If lengths the same              PB89 125
IF(HALL(1^NH)==HALL2(1^NH)) BREAK#     Exit if match found              PB89 126
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PB89 127
#                                                                       PB89 128
ELSE#                                  Look for herm-maug match         PB89 129
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PB89 130
NM2=0#                                 Start notation length            PB89 131
DO J=1,NM1#                            Loop over table symbol           PB89 132
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PB89 133
IF(MAUG1(J^J)=='_') NEXT#              Skip underscores                 PB89 134
NM2=NM2+1#                             Count chars in notation          PB89 135
MAUG2(NM2^NM2)=MAUG1(J^J)#             Notation with no spacers         PB89 136
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PB89 137
IF(NM==NM1)#                           If lengths the same              PB89 138
IF(MAUG(1^NM)==MAUG1(1^NM)) BREAK#     Exit if match found              PB89 139
IF(NM==NM2)#                           If lengths the same              PB89 140
IF(MAUG(1^NM)==MAUG2(1^NM)) BREAK#     Exit if match found              PB89 141
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PB89 142
#                                                                       PB89 143
MATCH=no:#                             No match yet                     PB89 144
IF(!LOOP_) BREAK#                      Exit if notation finished        PB89 145
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PB89 146
IF(MATCH==yes:)    BREAK#              Symbols matched                  PB89 147
IF(NH==0)          BREAK#              H-m name sought                  PB89 148
IF(HALL(1^1)!='-') BREAK#              If space group noncentro         PB89 149
SNAME='-'; NN=1#                       Start new hall symbol            PB89 150
DO I=2,NH#                             Loop over old symbol             PB89 151
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PB89 152
SNAME(NN+1^NN+1)=HALL(I^I)#            Store symbol                     PB89 153
IF(HALL(I^I)!='-') NN=NN+1#            Count non-negative symbols       PB89 154
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PB89 155
HALL=SNAME(1^NN); NH=NN#               Reset for new search             PB89 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PB89 157
#                                                                       PB89 158
IF(MATCH==yes:)#                       Symbols matched                  PB89 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PB89 160
HALL=HALL1;  MAUG=MAUG1#               Transfer to global array         PB89 161
IF(NM>0)#                              Test if h-m symbol entered       PB89 162
IF(MAUG(1^NM)!=MAUG1(1^NM1))#          Test if symbols match            PB89 163
IF(MAUG(1^NM)!=MAUG2(1^NM2))#          Test if symbols match            PB89 164
WRITE(6,'(a)')' WARNING: Input H-M symbol mismatch with Hall symbol'#   PB89 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PB89 166
ELSE ITNM='0'#                         Blank out the it number          PB89 167
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PB89 168
##                                                                      PB89 169
##  SHOULD NOW HAVE A VALID HALL NAME                                   PB89 170
##  ---------------------------------                                   PB89 171
##                                                                      PB89 172
try:(CALL PB92)#                       Generate symmetry matrices fro   PB89 173
try:(CALL PB97)#                       Check & write symops             PB89 174
#                                                                       PB89 175
RETURN#                                                                 PB89 176
END#                                                                    PB89 177
#                                                                       PB89 178
systemheader:(PB90)#                   Convert string to number         PB90   1
# ################################################################## #  PB90   2
#                                                                    #  PB90   3
#                               PB90  FORMERLY CF45 GETNUMB:         #  PB90   4
#                                                                    #  PB90   5
# ################################################################## #  PB90   6
SUBROUTINE PB90(TEMP,NSTR,RNUM,SDEV)#                                   PB90   7
include:(AACOMN)#                                                       PB90   8
include:(PBCOMN)#                                                       PB90   9
#                                                                       PB90  10
INTEGER M,N#                                                            PB90  11
INTEGER CCNT,MANT,EXPN,MSIN,ESIN,NSTR,NDEC#                             PB90  12
REAL    SDEV,RNUM#                                                      PB90  13
dp: RNUMB#                                                              PB90  14
string:(TEMP,*)#                                                        PB90  15
chardata:(TEST,'0123456789+.-()')#                                      PB90  16
datastuff:#                                                             PB90  17
#                                                                       PB90  18
##   components CCNT 11111222223333444                                  PB90  19
##                   -xxxx.xxxx+xxx(x)                                  PB90  20
#                                                                       PB90  21
RNUM=voidflg:;  SDEV=0.#               Set default values               PB90  22
IF(TEMP(1^NSTR)=='?') RETURN#          Value is unknown                 PB90  23
#                                                                       PB90  24
STRG=TEMP#                             Store the input string           PB90  25
CCNT=0#                                Component counter                PB90  26
RNUMB=1.0D+0#                          Initialise                       PB90  27
RNUM=1.;   SDEV=0.#                    Number scale & standard dev      PB90  28
MANT=0;    EXPN=0.#                    Zero mantissa & exponent         PB90  29
MSIN=+1;   ESIN=+1#                    Assume signs are positive        PB90  30
NDEC=0#                                Digits after decimal point       PB90  31
#                                                                       PB90  32
DO N=1,NSTR#                           Loop over chars in string        PB90  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB90  34
IF(CCNT==0&STRG(N^N)==' ') NEXT#       Skip leading blanks              PB90  35
M=INDEX(TEST,STRG(N^N))#               Get the index                    PB90  36
IF(M==0)#                              Test if illegal character        PB90  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB90  38
lquit:('CF4501')#                      Non-number char detected         PB90  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB90  40
#                                                                       PB90  41
IF(M<11)#                              Test if a digit                  PB90  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB90  43
IF(CCNT==0) CCNT=1#                    Start the number                 PB90  44
IF(CCNT==2) NDEC=NDEC+1#               Digits after dec point           PB90  45
IF     (CCNT<=2) MANT=MANT*10+M-1#     Accumulate mantissa              PB90  46
ELSE IF(CCNT==3) EXPN=EXPN*10+M-1#     Accumulate exponent              PB90  47
ELSE             SDEV=SDEV*10.+FLOAT(M-1)# Accumulate standard dev      PB90  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB90  49
#                                                                       PB90  50
ELSE IF(M==12)#                        If decimal point detected        PB90  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PB90  52
IF(CCNT>1)#                            Test if number sensible          PB90  53
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PB90  54
lquit:('CF4502')#                      Illegal number construction      PB90  55
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PB90  56
CCNT=2#                                Signals that digits after deci   PB90  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PB90  58
#                                                                       PB90  59
ELSE IF(M>13) CCNT=4#                  If parentheses detected          PB90  60
#                                                                       PB90  61
ELSE#                                  If signs '+' or '-'              PB90  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PB90  63
IF(CCNT==3) lquit:('CF4502')#          Illegal sign construction        PB90  64
IF(CCNT==0)#                           Test if mantissa sign            PB90  65
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PB90  66
CCNT=1; MSIN=12-M#                     Set the mantissa sign            PB90  67
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PB90  68
ELSE#                                  This is an exponent sign         PB90  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PB90  70
CCNT=3; ESIN=12-M#                     Set exponent sign                PB90  71
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PB90  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PB90  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB90  74
EXPN=EXPN*ESIN-NDEC#                   Calculate total exponent         PB90  75
IF(ABS(EXPN)>21) EXPN=SIGN(21,EXPN)#   Protect against overflow         PB90  76
IF(EXPN<0) RNUMB=(1.0D+0)/(10.0D+0)**ABS(EXPN)# Apply negative expone   PB90  77
IF(EXPN>0) RNUMB=(10.0D+0)**EXPN#      Apply positive exponent          PB90  78
SDEV=sg:(RNUMB*db:(SDEV))#             Scale standard deviation         PB90  79
RNUM=sg:(RNUMB*db:(FLOAT(MANT*MSIN)))# Scale the number                 PB90  80
RETURN#                                                                 PB90  81
END#                                                                    PB90  82
#                                                                       PB90  83
systemheader:(PB91)#                   Process latice & symtry lines    PB91   1
# ################################################################## #  PB91   2
#                                                                    #  PB91   3
#                               PB91   FORMERLY SX11                 #  PB91   4
#                                                                    #  PB91   5
# ################################################################## #  PB91   6
SUBROUTINE PB91(SYMOP)#                                                 PB91   7
include:(AACOMN)#                                                       PB91   8
include:(PBCOMN)#                                                       PB91   9
#                                                                       PB91  10
string:(SYMOP,*)#                                                       PB91  11
REAL A#                                                                 PB91  12
INTEGER DET#                           Determinant of rotation matr     PB91  13
INTEGER I,J#                           Loop index                       PB91  14
INTEGER KEY(81)#                       Key to each symmetry char        PB91  15
INTEGER IPT#                           Pointers                         PB91  16
INTEGER LINLEN#                        Effective line length            PB91  17
INTEGER NUM#                           Numerator                        PB91  18
intdata:(IFIELD,0)#                    Flag x,y,z rotation              PB91  19
intdata:(SING,0)#                      Sign of rotation                 PB91  20
chardata:(PB023,[0123456789XYZ/,+- ])#                                  PB91  21
datastuff:#                                                             PB91  22
#                                                                       PB91  23
#   DECODE SYMTRY LINES                                                 PB91  24
#   -------------------                                                 PB91  25
#                                                                       PB91  26
upcase:(SYMOP,SYMOP,80)#               Convert to upper case            PB91  27
dbx: WRITE(6,'(A,A)')'SYMOP IS ',SYMOP#                                 PB91  28
IFIELD=1#                              First of three parts             PB91  29
SING=1#                                Default sign positive            PB91  30
#                                                                       PB91  31
CHRCOL=1; CHRMAX=80#                                                    PB91  32
DO I=CHRCOL,CHRMAX#                    Loop over input image            PB91  33
compchar:(SYMOP,I,PB023,1,1,1,NPB023,KEY(I))# Identify all character    PB91  34
DO LINLEN=CHRMAX,CHRCOL,-1#            Begin at end of string           PB91  35
IF(SYMOP(LINLEN^LINLEN)!=' ')BREAK#    Find last non blank              PB91  36
FOR(I=CHRCOL+1;I<=LINLEN;I=I+1)#       Loop over input image            PB91  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB91  38
WHILE (LINLEN>I&KEY(I)==18)#           Strip multi and selctd blnks     PB91  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB91  40
IF(((KEY(I-1)>=14)&(KEY(I-1)<=19))\#   Was last char blk or operator    PB91  41
((KEY(I+1)==14)\(KEY(I+1)==15)\(KEY(I+1)==18)))# Is next /,blnk         PB91  42
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB91  43
DO J=I,LINLEN-1 ; SYMOP(J^J)=SYMOP(J+1^J+1)# Shift to left & erase      PB91  44
DO J=I,LINLEN-1 ; KEY(J)=KEY(J+1)#     Shift to left                    PB91  45
SYMOP(LINLEN^LINLEN)=' '#              Blank last char                  PB91  46
LINLEN=LINLEN-1#                       Decrement length                 PB91  47
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB91  48
ELSE BREAK#                                                             PB91  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB91  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB91  51
#                                      End of unrequired blnk strip     PB91  52
DO I=CHRCOL,CHRMAX#                    Loop over input image            PB91  53
compchar:(SYMOP,I,PB023,1,1,1,NPB023,KEY(I))# Identify all character    PB91  54
KEY(CHRMAX+1)=18#                      Store blank signal at last +     PB91  55
#                                                                       PB91  56
FOR(I=CHRCOL;I<=CHRMAX;I=I+1)#         Scan input image less one        PB91  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PB91  58
IF(KEY(I)==0) lquit:('Unrecognised character in XYZ symop list')#       PB91  59
ELSE IF(KEY(I)==18)#                   Blank                            PB91  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PB91  61
IF(KEY(I+1)!=18)#                      Followed by non-blank            PB91  62
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PB91  63
IFIELD=1#                              First of three parts             PB91  64
SING=1#                                Default sign positive            PB91  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PB91  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PB91  67
ELSE IF(KEY(I)==17) SING=-1#           Sign is negative                 PB91  68
ELSE IF(KEY(I)==16) SING=1#            Positive sign                    PB91  69
ELSE IF(KEY(I)<11)#                    A number                         PB91  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PB91  71
IF(KEY(I+1)<11)#                       A second number                  PB91  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PB91  73
NUM=(KEY(I)-1)*10+KEY(I+1)-1#          Encode                           PB91  74
I=I+1#                                 Pretend only one digit           PB91  75
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PB91  76
ELSE NUM=KEY(I)-1#                     Encode <10                       PB91  77
IF(KEY(I+1)!=14) A=12.*FLOAT(NUM)#     No / after number (a=0)          PB91  78
ELSE#                                  There is a /                     PB91  79
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PB91  80
IF((KEY(I+2)-1>6)\(KEY(I+2)-1==5)\(KEY(I+2)==1))#                       PB91  81
lquit:('Illegal construction in the XYZ symop list.')#                  PB91  82
A=12.*FLOAT(NUM)/FLOAT(KEY(I+2)-1)#    Translation                      PB91  83
I=I+2#                                                                  PB91  84
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PB91  85
#IF(LAX==NO:)#                         NOT RELAXED                      PB91  86
SMAT(IFIELD+12,NSYM)=MOD(144+SING*INT(A),12)# Translation modulo 12     PB91  87
IF(KEY(I+1)!=16&KEY(I+1)!=17& $#       No rotation sign                 PB91  88
KEY(I+1)!=15&KEY(I+1)!=18)lquit:('Illegal XYZ symop punctuation.')#     PB91  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PB91  90
ELSE IF((KEY(I)<14)&(KEY(I)>10))#      A letter                         PB91  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PB91  92
IPT=IFIELD+4*(KEY(I)-11)#              Point to its place               PB91  93
SMAT(IPT,NSYM)=12*SING#                Rotation element                 PB91  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PB91  95
ELSE IF(KEY(I)==15)#                   Comma                            PB91  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PB91  97
IFIELD=IFIELD+1#                       Go to next part                  PB91  98
SING=1#                                Default sign positive            PB91  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PB91 100
ELSE lquit:('Illegitimate character in XYZ symop list.')#               PB91 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PB91 102
#                                                                       PB91 103
DET=SMAT(1,NSYM)*SMAT(6,NSYM)*SMAT(11,NSYM)$#                           PB91 104
     -SMAT(2,NSYM)*SMAT(5,NSYM)*SMAT(11,NSYM)$#                         PB91 105
     -SMAT(1,NSYM)*SMAT(7,NSYM)*SMAT(10,NSYM)$#                         PB91 106
     -SMAT(3,NSYM)*SMAT(6,NSYM)*SMAT(9,NSYM)$#                          PB91 107
     +SMAT(3,NSYM)*SMAT(5,NSYM)*SMAT(10,NSYM)$#                         PB91 108
     +SMAT(2,NSYM)*SMAT(7,NSYM)*SMAT(9,NSYM)# Determinant               PB91 109
#                                                                       PB91 110
IF(IABS(DET)!=1728)#                   Determinant not +1 or -1         PB91 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PB91 112
WRITE(6,'(a,a,f10.2)')' Error in symmetry operation: ',SYMOP,DET#       PB91 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PB91 114
#                                                                       PB91 115
dbx: WRITE(6,'(/I7)')NSYM#                                              PB91 116
dbx: DO I=1,13,4#                                                       PB91 117
WRITE(6,'(4I7)')SMAT(I,NSYM),SMAT(I+1,NSYM),SMAT(I+2,NSYM),#            PB91 118
SMAT(I+3,NSYM)#                                                         PB91 119
#                                                                       PB91 120
#                                                                       PB91 121
RETURN#                                                                 PB91 122
END#                                                                    PB91 123
#                                                                       PB91 124
systemheader:(PB92)#                   Symmetry from hall sgname        PB92   1
################################################################        PB92   2
#                                                                       PB92   3
#                         PB92         FORMERLY SX12                    PB92   4
#                                                                       PB92   5
################################################################        PB92   6
SUBROUTINE PB92#                                                        PB92   7
include:(AACOMN)#                                                       PB92   8
include:(PBCOMN)#                                                       PB92   9
#                                                                       PB92  10
INTEGER I,J,K,L,M,N#                   Working integer varaibles        PB92  11
INTEGER IAXS#                          Current axis pointer to tab      PB92  12
INTEGER IEND#                          Pointer                          PB92  13
INTEGER ISGN#                          Matrix sign flag                 PB92  14
INTEGER JAXS#                          Previous axis pointer to tab     PB92  15
INTEGER NEQP#                          Number of equivalent positio     PB92  16
INTEGER NGEN#                          No. of generator seitz matri     PB92  17
INTEGER NROT#                          Current rot order (1,2,3,4,6     PB92  18
INTEGER NEW#                           Position of matrix product       PB92  19
INTEGER OLD#                           Matrix count before inner lo     PB92  20
INTEGER ROT(12,20)#                    Table of rotation matrices       PB92  21
INTEGER SVEC(3)#                       Temporary t-vector array         PB92  22
INTEGER ORSH(3)#                       Origin shift values              PB92  23
INTEGER ORAX#                          Origin shift axis count          PB92  24
#                                                                       PB92  25
string:(SNAME,80)#                                                      PB92  26
chardata:(CHARS,'123456prabcifnuvwd -xyz*q"(:)')#                       PB92  27
chardata:(NUMS,0123456)#                                                PB92  28
intdata:(RM1,[$#                                                        PB92  29
1,0,0,0,0,1,0,0,0,0,1,0,#              1-fold rotation on x,y,z         PB92  30
1,0,0,0,0,-1,0,0,0,0,-1,0,#            2-fold rotation on x             PB92  31
-1,0,0,0,0,1,0,0,0,0,-1,0,#            2-fold rotation on y             PB92  32
-1,0,0,0,0,-1,0,0,0,0,1,0,#            2-fold rotation on z             PB92  33
1,0,0,0,0,0,1,0,0,-1,-1,0,#            3-fold rotation on x             PB92  34
-1,0,-1,0,0,1,0,0,1,0,0,0,#            3-fold rotation on y             PB92  35
0,1,0,0,-1,-1,0,0,0,0,1,0,#            3-fold rotation on z             PB92  36
1,0,0,0,0,0,1,0,0,-1,0,0,#             4-fold rotation on x             PB92  37
0,0,-1,0,0,1,0,0,1,0,0,0,#             4-fold rotation on y             PB92  38
0,1,0,0,-1,0,0,0,0,0,1,0])#            4-fold rotation on z             PB92  39
intdata:(RM2,[$#                                                        PB92  40
1,0,0,0,0,1,1,0,0,-1,0,0,#             6-fold rotation on x             PB92  41
0,0,-1,0,0,1,0,0,1,0,1,0,#             6-fold rotation on y             PB92  42
1,1,0,0,-1,0,0,0,0,0,1,0,#             6-fold rotation on z             PB92  43
0,0,1,0,1,0,0,0,0,1,0,0,#              3-fold rotation on x+y+z         PB92  44
-1,0,0,0,0,0,-1,0,0,-1,0,0,#           2-fold rotation on y-z           PB92  45
0,0,-1,0,0,-1,0,0,-1,0,0,0,#           2-fold rotation on z-x           PB92  46
0,-1,0,0,-1,0,0,0,0,0,-1,0,#           2-fold rotation on x-y           PB92  47
-1,0,0,0,0,0,1,0,0,1,0,0,#             2-fold rotation on y+z           PB92  48
0,0,1,0,0,-1,0,0,1,0,0,0,#             2-fold rotation on z+x           PB92  49
0,1,0,0,1,0,0,0,0,0,-1,0])#            2-fold rotation on x+y           PB92  50
intdata:(TAB,[1,1,1,2,3,4,5,6,7,8,9,10,0,0,0,11,12,13,#                 PB92  51
14,14,14,15,16,17,18,19,20])#                                           PB92  52
intdata:(VEC,[6,0,0,0,6,0,0,0,6,6,6,6,3,0,0,0,3,0,0,0,3,3,3,3])#        PB92  53
datastuff:#                                                             PB92  54
#                                                                       PB92  55
SNAME=HALL;    STRG=HALL#              Transfer to local variable       PB92  56
DO I=1,40; IF(SNAME(I^I)=='_') SNAME(I^I)=' '# Convert '_' to blanks    PB92  57
#                                                                       PB92  58
#  DECODE SPACE GROUP NAME INTO GENERATOR MATRICES                      PB92  59
#  -----------------------------------------------                      PB92  60
#                                                                       PB92  61
N=0; DO J=1,20; DO I=1,12#             Loop over matrices               PB92  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB92  63
N=N+1#                                 Incr rot matrix pointer          PB92  64
IF(N<121) ROT(I,J)=RM1(N)#             Transfer first matrix            PB92  65
ELSE      ROT(I,J)=RM2(N-120)#         Transfer second matrix           PB92  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB92  67
NGEN=1; NEQP=1; ISGN=12#               Set initial symops               PB92  68
NROT=0; IROT=0; JROT=0; IAXS=0; JAXS=0# Zero axis settings              PB92  69
ICNT=1; LTYP=0; ORAX=0#                Start lattice and no centre      PB92  70
DO I=1,3;  SVEC(I)=0#                  Zeroize vector accumulator       PB92  71
DO I=1,3;  ORSH(I)=0#                  Zeroize origin shift values      PB92  72
DO I=1,6;  SROT(I)=0#                  Zeroize rotations                PB92  73
DO I=1,6;  SAXS(I)=0#                  Zeroize axes                     PB92  74
DO I=1,50#                             Loop over symop matrices         PB92  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB92  76
DO J=1,15; SMAT(J,I)=0#                Zero the symop matrices          PB92  77
SMAT(16,I)=12#                         Set the (4,4) element to 12      PB92  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB92  79
DO I=1,11,5; SMAT(I,1)=12#             Set identity rotations           PB92  80
#                                                                       PB92  81
#                                                                       PB92  82
DO N=1,40#                             ********* scan input buffer      PB92  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB92  84
M=INDEX(CHARS,SNAME(N^N))#             Identify character               PB92  85
IF(M==0) BREAK#                        Unidentified char                PB92  86
IF((M==19)&(NROT==0)) NEXT#            Skip inactive blanks             PB92  87
IF(LTYP==0)#                           ********** specify lattice       PB92  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PB92  89
IF(M==20) ICNT=0#                      Initial-indicates centre         PB92  90
ELSE IF((M>6)&(M<14)) LTYP=M-6#        Extract lattice code             PB92  91
ELSE#                                  Illegal character                PB92  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PB92  93
WRITE(6,'(a)')SNAME#                                                    PB92  94
lquit:('Space group lattice code is not recognised.')#                  PB92  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PB92  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PB92  97
ELSE IF(M==20) ISGN=-12#               Later neg indicates inversio     PB92  98
ELSE IF(M>27) BREAK#                   Exit if : or )                   PB92  99
#                                                                       PB92 100
ELSE IF(M==27)#                        Test for origin shift (          PB92 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PB92 102
FOR(I=N+1;I<40;I=I+1)#                 Loop over remaining chars        PB92 103
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PB92 104
M=INDEX(CHARS(28^29),SNAME(I+1^I+1))#  Is this ) or :                   PB92 105
IF(M>0)#                               End detected                     PB92 106
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PB92 107
IEND=I+1; SNAME(I+1^80)=' '#           Blank off remainder              PB92 108
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PB92 109
M=INDEX(NUMS,SNAME(I^I))#              Look for digits                  PB92 110
IF(M==0) NEXT#                         Skip until found                 PB92 111
ORAX=ORAX+1#                           Incr axis counter                PB92 112
ORSH(ORAX)=MOD((M-1)*2,12)#            Store as coord shift             PB92 113
IF(SNAME(I-1^I-1)=='-') ORSH(ORAX)=12-ORSH(ORAX)# Reverse shift         PB92 114
IF(ORAX==3) BREAK#                     Test if last axis                PB92 115
I=I+1#                                 Skip extra char                  PB92 116
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PB92 117
IF(ORAX<3) lquit:('NOT ENOUGH FIELDS IN HALL ORIGIN SHIFT')# Shift mi   PB92 118
BREAK#                                 Must be all thru                 PB92 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PB92 120
#                                                                       PB92 121
ELSE IF(NROT==0)#                      ********* specify rotation       PB92 122
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PB92 123
IF(M>6) lquit:('INCORRECT HALL ROTATION CODE')# Quit on illegal char    PB92 124
SROT(NGEN)=M#                          Save rotation                    PB92 125
IF(M==1&ISGN<0) NEQP=NEQP*2#           Indicates -1 not at origin       PB92 126
ELSE IF(M==1) NEXT#                    Skip on +1                       PB92 127
NROT=M;   IROT=M#                      Set rotation order & pointer     PB92 128
NGEN=NGEN+1#                           Count as next generator matr     PB92 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PB92 130
ELSE#                                  If the rot order is set          PB92 131
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PB92 132
IF(M>20) IAXS=M-20#                    ********* specify direction      PB92 133
IF(IAXS==0)#                           Test if default axis require     PB92 134
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PB92 135
IF((NGEN==2)\(IROT==1))       IAXS=3#  Rot1 or axis1 assumed z          PB92 136
ELSE IF((NROT==2)&(JROT==2))  IAXS=1#  Later axes assumed as x          PB92 137
ELSE IF((NROT==2)&(JROT==3))  IAXS=5#  Axis after 3,6 assumed as x-     PB92 138
ELSE IF(NROT==3)              IAXS=4#  Axis for later 3 must be x+y     PB92 139
ELSE lquit:('INCORRECT HALL AXIS CODE')# Quit on illegal char           PB92 140
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PB92 141
IF(M>20) SAXS(NGEN)=IAXS#              Save axis pointer                PB92 142
IF(IAXS>3)#                            For non-principal axes           PB92 143
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PB92 144
IROT=IAXS+3#                           Redefine order for table         PB92 145
IAXS=JAXS#                             Axis defined by prev rotatio     PB92 146
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PB92 147
IF(M<6)#                               ********* specify translatio     PB92 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PB92 149
IF(IROT>6) lquit:('INCORRECT HALL TRANSLATION')# Only for x,y,z direc   PB92 150
SVEC(IAXS)=SVEC(IAXS)+M*12/NROT#       Calc translation in 12ths        PB92 151
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PB92 152
IF(((M>8)&(M<12))\((M>13)&(M<19)))#    Test for a,b,c,n,u,v,w,d         PB92 153
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PB92 154
IF(M<12) I=(M-9)*3;  ELSE I=(M-11)*3#  Point to vector array            PB92 155
DO J=1,3; SVEC(J)=SVEC(J)+VEC(J+I)#    Sum in vector translations       PB92 156
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PB92 157
#                                                                       PB92 158
IF(M==19)#                             ******** construct generators    PB92 159
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PB92 160
K=(IROT-1)*3;   K=TAB(IAXS+K)#         Point to rotation matrix         PB92 161
DO I=1,12#                             Loop over rotation partition     PB92 162
SMAT(I,NGEN)=ROT(I,K)*ISGN#                                             PB92 163
DO I=13,15#                            Loop over translation vector     PB92 164
SMAT(I,NGEN)=MOD(SVEC(I-12)+120,12)#   Deposit translation base 12      PB92 165
NEQP=NEQP*NROT#                        Calc the number of equiv. po     PB92 166
IF(NROT>3) NROT=NROT/2#                Reduce order to 2 or 3           PB92 167
JROT=NROT; NROT=0; IROT=0#             Reset order flags                PB92 168
JAXS=IAXS; IAXS=0; ISGN=12#            Reset axis flags                 PB92 169
DO I=1,3;   SVEC(I)=0#                 Zeroize vector accumulator       PB92 170
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PB92 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PB92 172
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB92 173
IF((NROT>0)\(LTYP==0)) lquit:('NO LATTICE CODE IN HALL NOTATION')#      PB92 174
#                                                                       PB92 175
#                                                                       PB92 176
#    GENERATE MATRICES BY PROGRESSIVE BINARY PRODUCTS                   PB92 177
#    ------------------------------------------------                   PB92 178
#                                                                       PB92 179
IF(NGEN>1)#                            Skip generation if p1 or -p1     PB92 180
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PB92 181
FOR(M=2;M<=NGEN;M=M+1)#                Outer generator loop             PB92 182
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PB92 183
OLD=NGEN#                              Save current matrix count        PB92 184
FOR(N=M;N<=NGEN;N=N+1)#                Inner generator loop             PB92 185
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PB92 186
NEW=NGEN+1#                            Point to generated matrix in     PB92 187
DO I=1,3#                              Loop over column elements        PB92 188
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PB92 189
DO J=1,13,4#                           Loop over row elements           PB92 190
SMAT(I+J-1,NEW)=(SMAT(I,   M)*SMAT(J,  N)$# Multiply (*,1) by (1,*)     PB92 191
+                SMAT(I+ 4,M)*SMAT(J+1,N)$# Multiply (*,2) by (2,*)     PB92 192
+                SMAT(I+ 8,M)*SMAT(J+2,N)$# Multiply (*,3) by (3,*)     PB92 193
+                SMAT(I+12,M)*SMAT(J+3,N))/12# Multiply (*,4) by (4,*   PB92 194
SMAT(I+12,NEW)=MOD(SMAT(I+12,NEW)+120,12)# Reduce vector to base 12     PB92 195
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PB92 196
#                                                                       PB92 197
FOR(L=1;L<=NGEN;L=L+1)#                ********** is matrix unique      PB92 198
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PB92 199
FOR(I=1;I<=12;I=I+1)#                  Loop over rotation partition     PB92 200
IF(SMAT(I,L)!=SMAT(I,NEW)) BREAK#      Exit loop if not equal           PB92 201
IF(I>12)#                              If rotation elements identic     PB92 202
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PB92 203
IF(LTYP==1)#                           Test vectors if primitive sg     PB92 204
FOR(I=13;I<=16;I=I+1)#                 Check trans for primitive        PB92 205
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PB92 206
IF(SMAT(I,L)==SMAT(I,NEW)) NEXT#       Skip if translations agree       PB92 207
lquit:('BAD HALL CODE TRANSLATIONS')#  Error condition                  PB92 208
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PB92 209
BREAK#                                 Not unique so skip               PB92 210
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PB92 211
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PB92 212
IF(L>NGEN) NGEN=NEW#                   Add unique matrix as gen.        PB92 213
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PB92 214
IF((NGEN==OLD)&(NGEN>=NEQP))BREAK#     Stop scan at expected max        PB92 215
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PB92 216
#                                                                       PB92 217
DO N=2,NGEN#                           ********** sort on zero patt     PB92 218
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PB92 219
DO L=N,NGEN#                           Inner sort loop                  PB92 220
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PB92 221
DO K=1,12#                             Loop over rotation partition     PB92 222
IF((SMAT(K,N-1)==0)&(SMAT(K,L)!=0)) BREAK# Exit on zero mismatch        PB92 223
IF(K>12) BREAK#                        Matrices match-exit inner        PB92 224
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PB92 225
IF(K>12)#                              If same pattern of zeros         PB92 226
DO K=1,16#                             Loop over all elements           PB92 227
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PB92 228
I=SMAT(K,L);SMAT(K,L)=SMAT(K,N);SMAT(K,N)=I# Exchange sorted elements   PB92 229
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PB92 230
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PB92 231
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PB92 232
IF(NGEN>NEQP) lquit:('MORE SYMOPS THAN EXPECTED FROM HALL NOTATION')#   PB92 233
#                                                                       PB92 234
#                                                                       PB92 235
#  TRANSLATE SYMMETRY MATRICES INTO EQUIVALENT POSITIONS                PB92 236
#  -----------------------------------------------------                PB92 237
#                                                                       PB92 238
DO M=1,NGEN#                           Loop over all matrices           PB92 239
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PB92 240
DO L=1,3; DO K=1,3#                    Loop over row elements           PB92 241
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PB92 242
J=L+(K-1)*4#                           Point to row element             PB92 243
IF(SMAT(J,M)>=0) NEXT#                 Skip positive elements           PB92 244
SMAT(K+12,M)=MOD(SMAT(K+12,M)+ORSH(K),12)# Apply coord shift            PB92 245
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PB92 246
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PB92 247
NSYM=NGEN#                             Store in common                  PB92 248
#                                                                       PB92 249
IF     (LTYP==2) LTYP=3#               Reset lattice codes from xray    PB92 250
ELSE IF(LTYP==6) LTYP=2#               Codes to xtal codes              PB92 251
ELSE IF(LTYP==7) LTYP=4#                                                PB92 252
ELSE IF(LTYP>2)  LTYP=LTYP+2#                                           PB92 253
#                                                                       PB92 254
#                                                                       PB92 255
RETURN#                                                                 PB92 256
END#                                                                    PB92 257
systemheader:(PB94)#                   Convert symops to hall sgname    PB94   1
# ################################################################## #  PB94   2
#                                                                    #  PB94   3
#                               PB94   FORMERLY SX14                 #  PB94   4
#                                                                    #  PB94   5
# ################################################################## #  PB94   6
SUBROUTINE PB94#                                                        PB94   7
include:(AACOMN)#                                                       PB94   8
include:(PBCOMN)#                                                       PB94   9
#                                                                       PB94  10
INTEGER I,J,NGEN#                                                       PB94  11
#                                                                       PB94  12
string:(TEMP,2)#                                                        PB94  13
chardata:(CLAT,'iabcrr')#                                               PB94  14
chardata:(LAT,'pirfabc')#                                               PB94  15
chardata:(ORIGN,'_     ')#                                              PB94  16
datastuff:#                                                             PB94  17
#                                                                       PB94  18
#   FIRST SORT THE SIETZ MATRICES                                       PB94  19
#                                                                       PB94  20
try:(CALL PB98)#                       Sort the matrices                PB94  21
#                                                                       PB94  22
#     USE LATTICE DATA IF AVAILABLE                                     PB94  23
#     -----------------------------                                     PB94  24
#                                                                       PB94  25
ICHR=0;   STRG=' '#                    Set initial op char pointer      PB94  26
NREM=NSYM;  NGEN=NSYM#                 Store total matrices             PB94  27
SHIFT='_(0_0_0)'#                      Default shift                    PB94  28
DO I=1,NSYM; SMAT(16,I)=-12#           Set "not used" flag              PB94  29
IF(ICNT==0) try:(CALL PB96('-',1))#    Insert centro flag               PB94  30
IF(LTYP>0)  try:(CALL PB96(LAT(LTYP^LTYP),1))# Latice has been determ   PB94  31
#                                                                       PB94  32
#    IDENTIFY LATTICE SYMBOL IF UNKNOWN                                 PB94  33
#    ----------------------------------                                 PB94  34
#                                                                       PB94  35
IF(LTYP==0)#                           Has lattice been determined      PB94  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB94  37
IF(ICHR>0) ICHR=ICHR-1#                Backoff op char pointer          PB94  38
J=ICHR#                                Save char pointer                PB94  39
try:(CALL PB96('p',1))#                Default is primitive             PB94  40
DO I=1,2#                              Search for centre twice          PB94  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB94  42
try:(CALL PB95(1,1,1,1))#              Search for identity matrix       PB94  43
IF(IROT==0) BREAK#                     Exit if no identity found        PB94  44
IF(ITRN==1) lquit:('Duplicate entry in xyz symop list')# Illegal        PB94  45
IF(ITRN<=7) NGEN=NGEN/2#               I,a,b,c reduce generators        PB94  46
ICHR=J#                                Reset char pointer               PB94  47
IF(I==1\ ITRN>7) try:(CALL PB96(CLAT(ITRN-3^ITRN-3),1))#                PB94  48
IF(I==2&ITRN<=7) try:(CALL PB96('f',1))# Face centred                   PB94  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB94  50
IF(ITRN>7) NGEN=NGEN/3#                Must be rhombohedral centred     PB94  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB94  52
#                                                                       PB94  53
#    TEST IF INVERSION CENTRE                                           PB94  54
#    ------------------------                                           PB94  55
#                                                                       PB94  56
J=ICHR#                                Set op char pointer              PB94  57
try:(CALL PB95(1,1,2,2))#              Search for inversion             PB94  58
IF(ICNT<0)#                            If centro flag not set           PB94  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB94  60
IF(IROT==1&ITRN<=1)#                   Test if inversion at origin      PB94  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PB94  62
TEMP='-'//STRG(1^1); STRG=TEMP; J=2#   Store centro flag                PB94  63
ICNT=0#                                Centrosymmetric set              PB94  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PB94  65
ELSE  ICNT=1#                          Noncentrosymmetric set           PB94  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB94  67
IF(IROT==1) NGEN=NGEN/2#               Centro reduce generators         PB94  68
IF(ITRN>1) ORIGN(2^6)=STRG(J+2^J+5)#   Save shifted inversion symbol    PB94  69
ICHR=J#                                Reset char pointer               PB94  70
#                                                                       PB94  71
#     TEST FOR DIFFERENT SYMMETRIES                                     PB94  72
#     -----------------------------                                     PB94  73
#                                                                       PB94  74
IF(NGEN==1)#                           ********* triclinic *******      PB94  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PB94  76
try:(CALL PB96('_1',2))#               Store 1 fold symmetry            PB94  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PB94  78
#                                                                       PB94  79
ELSE IF(NGEN==2)#                      ******** monoclinic *******      PB94  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PB94  81
try:(CALL PB95(4,2,1,2))#              Test for 2z 2y 2x                PB94  82
IF(NREM!=1) lquit:('UNKNOWN MONOCLINIC SYMMETRY')#                      PB94  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PB94  84
#                                                                       PB94  85
ELSE IF(NGEN!=3&NGEN!=6&NGEN<9)#       ****** orth/tetr *******         PB94  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PB94  87
try:(CALL PB95(7,5,1,2))#              Test for 4z 4y 4x                PB94  88
IF(IROT==0) try:(CALL PB95(4,2,1,2))#  Test for 2z 2y 2x                PB94  89
try:(CALL PB95(2,4,1,2))#              Test for 2x 2y 2z                PB94  90
IF(NREM!=1) lquit:('SYMOPS FORM UNRECOGNISED ORTH/TETR SYMMETRY')#      PB94  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PB94  92
#                                                                       PB94  93
ELSE#                                  ****** trig/cubic ******         PB94  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PB94  95
IF(NGEN<=6) try:(CALL PB95(20,20,1,2))# Test for 3a+b+c                 PB94  96
try:(CALL PB95(13,11,1,2))#            Test for 6z 6y 6x                PB94  97
IF(IROT==0) try:(CALL PB95(10, 8,1,2))# Test for 3z 3y 3x               PB94  98
IF(IROT==0) try:(CALL PB95( 7, 5,1,2))# Test for 4z 4y 4z               PB94  99
IF(IROT==0) try:(CALL PB95( 4, 2,1,2))# Test for 2z 2y 2x               PB94 100
IF(JROT>=8)#                           Test if trig hex                 PB94 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PB94 102
try:(CALL PB95(16,14,1,2))#            Test for 2a-b 2c-a 2b-c          PB94 103
IF(IROT==0) try:(CALL PB95(19,17,1,2))# Test for 2a+b 2c+a 2b+c         PB94 104
IF(NREM!=1) lquit:('SYMOPS FORM UNRECOGNISED TRIG/HEX SYMMETRY')#       PB94 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PB94 106
ELSE#                                  Else cubic                       PB94 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PB94 108
try:(CALL PB95(2,4,1,2))#              Test for 2z 2y 2x                PB94 109
try:(CALL PB95(20,20,1,2))#            Test for 3a+b+c                  PB94 110
STRG(ICHR^ICHR)=' '#                   Remove the trailing '*'          PB94 111
ICHR=ICHR-1#                           Adjust op pointer                PB94 112
IF(NREM!=1) lquit:('SYMOPS FORM UNRECOGNISED CUBIC SYMMETRY')#          PB94 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PB94 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PB94 115
#                                                                       PB94 116
IF(ORIGN!='_    ')    try:(CALL PB96(ORIGN,5))# Insert origin shift     PB94 117
IF(SHIFT!='_(0_0_0)') try:(CALL PB96(SHIFT,8))# Insert shift value      PB94 118
#                                                                       PB94 119
RETURN#                                                                 PB94 120
END#                                                                    PB94 121
systemheader:(PB95)#                   Convert symops to hall sgname    PB95   1
# ################################################################## #  PB95   2
#                                                                    #  PB95   3
#                               PB95   FORMERLY SX15                 #  PB95   4
#                                                                    #  PB95   5
# ################################################################## #  PB95   6
SUBROUTINE PB95(NROT1,NROT2,NSGN1,NSGN2)#                               PB95   7
include:(AACOMN)#                                                       PB95   8
include:(PBCOMN)#                                                       PB95   9
##-------------------------------------------------------------------   PB95  10
##    Search for the specified ROT(nrot1 to nrot2) symmetry operator(s) PB95  11
##    in SMAT(). If present, put the rotation symbol, the axis symbol   PB95  12
##    and the translation symbols into the output buffer.               PB95  13
##-------------------------------------------------------------------   PB95  14
#                                                                       PB95  15
INTEGER I,J,L,M,N#                                                      PB95  16
INTEGER NROT1,NROT2,NSGN1,NSGN2,MAT(16),LIND#                           PB95  17
INTEGER ROT(12,20),TRN1(3,18),TRN2(4),TRN3(4)#                          PB95  18
#                                                                       PB95  19
intdata:(ISGN,[+12,-12])#                                               PB95  20
chardata:(ROTC,'1 2x2y2z4x4y4z3x3y3z6x6y6z2 2 2 2"2"2"3*')#             PB95  21
chardata:(TRC1,'  d ndn bcacabr r udvdwdadbdcdnunvnw')#                 PB95  22
chardata:(TRC2,'      u v w a b c aubvcw')#                             PB95  23
chardata:(TRC3,'   111111111222222222444444   555555')#                 PB95  24
intdata:(LATES,[3,6,15,24,18,30,27])#                                   PB95  25
intdata:(LATSS,[1,1,7,13,13,25,22])#                                    PB95  26
intdata:(TLAT,[0,0,0,6,6,6,4,8,8,8,4,4,0,0,0,0,6,6,6,0,6,6,6,#          PB95  27
0,0,0,0,6,0,6])#                                                        PB95  28
datastuff:#                                                             PB95  29
DATA     TRN1 /0,0,0,3,3,3,9,9,9,6,6,6,0,6,6,6,0,6,6,6,0,4,8,8,#        PB95  30
8,4,4,6,3,3,3,6,3,3,3,6,9,3,3,3,9,3,3,3,9,9,6,6,6,9,6,6,6,9/#           PB95  31
DATA     TRN2 /0,3,6,9/#                                                PB95  32
DATA     TRN3 /2,4,8,10/#                                               PB95  33
DATA     ROT /$#                       4x3 rotation matrices            PB95  34
1,0,0,0,0,1,0,0,0,0,1,0,    1,0,0,0,0,-1,0,0,0,0,-1,0,# 1     2x        PB95  35
-1,0,0,0,0,1,0,0,0,0,-1,0,  -1,0,0,0,0,-1,0,0,0,0,1,0,# 2y    2z        PB95  36
1,0,0,0,0,0,1,0,0,-1,0,0,    0,0,-1,0,0,1,0,0,1,0,0,0,# 4x    4y        PB95  37
0,1,0,0,-1,0,0,0,0,0,1,0,   1,0,0,0,0,0,1,0,0,-1,-1,0,# 4z    3x        PB95  38
-1,0,-1,0,0,1,0,0,1,0,0,0,  0,1,0,0,-1,-1,0,0,0,0,1,0,# 3y    3z        PB95  39
1,0,0,0,0,1,1,0,0,-1,0,0,    0,0,-1,0,0,1,0,0,1,0,1,0,# 6x    6y        PB95  40
1,1,0,0,-1,0,0,0,0,0,1,0,  -1,0,0,0,0,0,-1,0,0,-1,0,0,# 6z    2b-c      PB95  41
0,0,-1,0,0,-1,0,0,-1,0,0,0,0,-1,0,0,-1,0,0,0,0,0,-1,0,# 2c-a  2a-b      PB95  42
-1,0,0,0,0,0,1,0,0,1,0,0,    0,0,1,0,0,-1,0,0,1,0,0,0,# 2b+c  2c+a      PB95  43
0,1,0,0,1,0,0,0,0,0,-1,0,     0,0,1,0,1,0,0,0,0,1,0,0/# 2a+b  3a+b+c    PB95  44
#                                                                       PB95  45
#     SEARCH FOR ROTATION                                               PB95  46
#     -------------------                                               PB95  47
#                                                                       PB95  48
N=1#                                                                    PB95  49
IF(NROT2<NROT1) N=-1#                                                   PB95  50
DO IROT=NROT1,NROT2,N; DO J=NSGN1,NSGN2# Loop rot matrices and signs    PB95  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB95  52
DO I=1,12; MAT(I)=ISGN(J)*ROT(I,IROT)#                                  PB95  53
DO M=2,NSYM#                                                            PB95  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB95  55
IF(SMAT(16,M)>0) NEXT#                                                  PB95  56
DO I=1,12; IF(SMAT(I,M)!=MAT(I)) GOTO 50#                               PB95  57
IF(ICHR>0) try:(CALL PB96('_',1))#                                      PB95  58
IF(J==2)   try:(CALL PB96('-',1))#                                      PB95  59
I=IROT*2-1#                                                             PB95  60
IF(IROT==NROT1&IROT<14) try:(CALL PB96(ROTC(I^I)  ,1))#                 PB95  61
IF(IROT!=NROT1\IROT>=14)try:(CALL PB96(ROTC(I^I+1),2))#                 PB95  62
NREM=NREM-1#                                                            PB95  63
SMAT(16,M)=12#                                                          PB95  64
GOTO 100#                                                               PB95  65
50 CONTINUE#                                                            PB95  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB95  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB95  68
IROT=0; ITRN=0; GOTO 600#                                               PB95  69
#                                                                       PB95  70
#     IDENTIFY TRANSLATION                                              PB95  71
#     --------------------                                              PB95  72
#                                                                       PB95  73
100 CONTINUE#                          Break point#                     PB95  74
DO ITRN=1,18#                                                           PB95  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB95  76
DO I=1,3; IF(SMAT(I+12,M)!=TRN1(I,ITRN)) GOTO 120#                      PB95  77
try:(CALL PB96(TRC1(ITRN*2-1^ITRN*2),2))#                               PB95  78
GOTO 200#                                                               PB95  79
120 CONTINUE#                                                           PB95  80
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB95  81
DO I=1,3#                                                               PB95  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PB95  83
DO J=1,4; IF(SMAT(I+12,M)==TRN2(J)) GOTO 140#                           PB95  84
GOTO 160#                                                               PB95  85
140 J=(J-1)*6+I*2#                                                      PB95  86
try:(CALL PB96(TRC2(J-1^J),2))#                                         PB95  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PB95  88
ITRN=100#                                                               PB95  89
GOTO 200#                                                               PB95  90
#                                                                       PB95  91
160 CONTINUE#                                                           PB95  92
IF(IROT<8\IROT>16) lquit:('ILLEGAL SYMOP TRANSLATION')#                 PB95  93
J=MOD(IROT-2,3)+1#                                                      PB95  94
DO I=1,4; IF(SMAT(J+12,M)==TRN3(I)) GOTO 190#                           PB95  95
lquit:('ILLEGAL SYMOP TRANSLATION')#   Illegal translation              PB95  96
190 I=(I-1)*9+IROT-7#                                                   PB95  97
IF(IROT<14) try:(CALL PB96(TRC3(I^I),1))#                               PB95  98
IF(IROT>=14) SHIFT(J*2+1^J*2+1)=TRC3(I^I)#                              PB95  99
ITRN=200#                                                               PB95 100
#                                                                       PB95 101
#     REMOVE SYMMETRY OPERATIONS                                        PB95 102
#     --------------------------                                        PB95 103
#                                                                       PB95 104
200 CONTINUE#                                                           PB95 105
IF(NREM>1)#                            Can matrices be removed          PB95 106
DO N=2,NSYM#                                                            PB95 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PB95 108
IF(SMAT(16,N)<0) NEXT#                                                  PB95 109
DO M=N,NSYM#                                                            PB95 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PB95 111
IF(SMAT(16,M)<0) NEXT#                                                  PB95 112
DO I=1,3#                                                               PB95 113
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PB95 114
DO J=1,13,4#                                                            PB95 115
MAT(I+J-1)=(SMAT(I,M)*SMAT(J,N)+SMAT(I+4,M)*SMAT(J+1,N)$#               PB95 116
     +SMAT(I+8,M)*SMAT(J+2,N)+SMAT(I+12,M)*SMAT(J+3,N))/12#             PB95 117
MAT(I+12)=MOD(MAT(I+12)+1200,12)#                                       PB95 118
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PB95 119
DO I=2,NSYM#                                                            PB95 120
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PB95 121
IF(SMAT(16,I)>0) NEXT#                 Already checked                  PB95 122
DO J=1,12; IF(SMAT(J,I)!=MAT(J)) GOTO 280# Loop over rotation part      PB95 123
IF(LTYP!=0) LIND = LTYP#               We have a lattice type           PB95 124
ELSE LIND = 1#                         Assume primitive                 PB95 125
FOR(L=LATSS(LIND);L<LATES(LIND);L=L+3)# Loop over centering trans       PB95 126
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PB95 127
DO J=13,15#                            Loop over translations           PB95 128
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PB95 129
IF(SMAT(J,I)!= MOD(MAT(J)+ TLAT(L+J-13),12)) BREAK# Add centering tra   PB95 130
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PB95 131
IF(J>15)#                              We matched                       PB95 132
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PB95 133
NREM=NREM-1#                                                            PB95 134
SMAT(16,I)=12#                                                          PB95 135
GOTO 200#                                                               PB95 136
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PB95 137
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PB95 138
280 CONTINUE#                                                           PB95 139
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PB95 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PB95 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PB95 142
#                                                                       PB95 143
600 CONTINUE#                                                           PB95 144
IF(IROT>0) JROT=IROT#                  Retain last matrix applied       PB95 145
#                                                                       PB95 146
RETURN#                                                                 PB95 147
END#                                                                    PB95 148
systemheader:(PB96)#                   Place chars in op string         PB96   1
# ################################################################## #  PB96   2
#                                                                    #  PB96   3
#                               PB96   FORMERLY SX16                 #  PB96   4
#                                                                    #  PB96   5
# ################################################################## #  PB96   6
SUBROUTINE PB96(STRING,NCHR)#                                           PB96   7
include:(AACOMN)#                                                       PB96   8
include:(PBCOMN)#                                                       PB96   9
INTEGER NCHR#                                                           PB96  10
INTEGER I,J,K,L#                                                        PB96  11
string:(STRING,*); string:(ZZZ,1);string:(TEMP,50)#                     PB96  12
chardata:(CTRAN,'abcuvw')#                                              PB96  13
datastuff:#                                                             PB96  14
#                                                                       PB96  15
DO I=1,NCHR#                                                            PB96  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB96  17
IF(STRING(I^I)==' ') NEXT#             Skip blanks                      PB96  18
ICHR=ICHR+1#                           Count the characters             PB96  19
STRG(ICHR^ICHR)=STRING(I^I)#           Transfer the character           PB96  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB96  21
DO I=1,ICHR#                                                            PB96  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB96  23
ZZZ=STRG(I^I)#                         Extract each character           PB96  24
DO J=1,6; IF(ZZZ==CTRAN(J^J)) BREAK#   Detect translation character     PB96  25
IF(J>6) NEXT#                          Skip if non-tran char            PB96  26
DO K=I+1,ICHR#                         Loop over remaining characters   PB96  27
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB96  28
IF(STRG(K^K)=='_') BREAK#              Exit if new matrix               PB96  29
DO L=1,J; IF(STRG(K^K)==CTRAN(L^L)) BREAK# Detect translation charact   PB96  30
IF(L>J) NEXT#                          Skip if non-tran char            PB96  31
STRG(I^I)=STRG(K^K); STRG(K^K)=ZZZ#    Swap characters                  PB96  32
BREAK#                                                                  PB96  33
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB96  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB96  35
DO I=1,ICHR#                                                            PB96  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PB96  37
IF(STRG(I^I+2)=='abc')#                Extract each character           PB96  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PB96  39
TEMP=STRG(1^ICHR)#                     Save current string              PB96  40
STRG(I^I)='n'#                         Substitute n for abc             PB96  41
STRG(I+1^ICHR-2)=TEMP(I+3^ICHR)#       Shuffle string forward           PB96  42
ICHR=ICHR-2#                                                            PB96  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PB96  44
IF(STRG(I^I+2)=='uvw')#                Extract each character           PB96  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PB96  46
TEMP=STRG(1^ICHR)#                     Save current string              PB96  47
STRG(I^I)='d'#                         Substitute d for uvw             PB96  48
STRG(I+1^ICHR-2)=TEMP(I+3^ICHR)#       Shuffle string forward           PB96  49
ICHR=ICHR-2#                                                            PB96  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PB96  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PB96  52
STRG(ICHR+1^40)=' '#                   Reset rest to blank              PB96  53
RETURN#                                                                 PB96  54
END#                                                                    PB96  55
systemheader:(PB97)#                   Check, sort and output symops    PB97   1
# ################################################################## #  PB97   2
#                                                                    #  PB97   3
#                               PB97   FORMERLY SX17                 #  PB97   4
#                                                                    #  PB97   5
# ################################################################## #  PB97   6
SUBROUTINE PB97#                                                        PB97   7
include:(AACOMN)#                                                       PB97   8
include:(PBCOMN)#                                                       PB97   9
#                                                                       PB97  10
INTEGER N1,N2,N3,A1,A2,A3#                                              PB97  11
INTEGER GROUP(48)#                     Rotation group flags             PB97  12
INTEGER I,J,K,L,JJ,KK#                 Loop indices                     PB97  13
INTEGER IDFLAG#                        Count of common elements         PB97  14
INTEGER IGROUP#                        Rotation group number            PB97  15
INTEGER IMATCH#                        Flag identical matrices          PB97  16
INTEGER KKK#                           Flag sign of trans. vector       PB97  17
INTEGER LATE#                                                           PB97  18
INTEGER LATS#                                                           PB97  19
INTEGER NROT1#                         No. elements 1st rot. group      PB97  20
INTEGER NROT2#                         Running count of symops          PB97  21
INTEGER NROT3#                         No. elements in current grou     PB97  22
INTEGER PROD(20)#                      Product of 2 symops              PB97  23
INTEGER SORT(48)#                      New ordering of symops           PB97  24
#                                                                       PB97  25
realdata:(FMUL,[1.,2.,3.,4.,2.,2.,2.])#                                 PB97  26
intdata:(IDEN,[12,0,0,0,0,12,0,0,0,0,12,0,0,0,0,12])#                   PB97  27
intdata:(LATES,[3,6,15,24,18,30,27])#                                   PB97  28
intdata:(LATSS,[1,1,7,13,13,25,22])#                                    PB97  29
intdata:(TLAT,[0,0,0,6,6,6,4,8,8,8,4,4,0,0,0,0,6,6,6,0,6,6,6,#          PB97  30
0,0,0,0,6,0,6])#                                                        PB97  31
datastuff:#                                                             PB97  32
#                                                                       PB97  33
# SCAN SGNAME AND IDENTIFY CRYSTAL SYSTEM                               PB97  34
# ---------------------------------------                               PB97  35
#                                                                       PB97  36
#IF(SGN==YES:)#                         IF SNAME AVAILABLE              PB97  37
#$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1 PB97  38
N1=SROT(1); N2=SROT(2); N3=SROT(3)#    Get rotations                    PB97  39
A1=SAXS(2); A2=SAXS(3); A3=SAXS(4)#    Get axes                         PB97  40
IF(N1<2&N2<2&N3<2)       NCRYS=1#      Crystal system triclinic         PB97  41
IF(N1==6)                NCRYS=7#      Crystal system hexagonal         PB97  42
IF(N1==2&N2==0&N3==0)    NCRYS=2#      Crystal system monoclinic        PB97  43
IF(N1==2&N2==2&N3 <2)    NCRYS=3#      Crystal system orthorhombic      PB97  44
IF(N1==3&A1==4)          NCRYS=6#      Crystal system rhombohedral      PB97  45
IF(N1==3&A1!=4)          NCRYS=5#      Crystal system trigonal          PB97  46
IF(N2==3\N3==3)          NCRYS=8#      Crystal system cubic             PB97  47
IF(N1==4&N3!=3)          NCRYS=4#      Crystal system tetragonal        PB97  48
IF(A1==0) A1=3#                        Default axis is z                PB97  49
#$)                                                                     PB97  50
#                                                                       PB97  51
#                                                                       PB97  52
#                                                                       PB97  53
#   NOW TEST SYMOPS FOR INTEGRITY                                       PB97  54
#   -----------------------------                                       PB97  55
#                                                                       PB97  56
DO I=1,NSYM#                           Loop over symops                 PB97  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB97  58
SMAT(16,I)=12;  SORT(I)=0;  GROUP(I)=0# Initialize group(i)             PB97  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB97  60
DO J=1,NSYM#                           Loop over symops                 PB97  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB97  62
IDFLAG=0#                              Count identical elements         PB97  63
DO I=1,16#                             Loop over matrix elements        PB97  64
IF(SMAT(I,J)==IDEN(I)) IDFLAG=IDFLAG+1# Increment count                 PB97  65
IF(IDFLAG==16) BREAK#                  Identity matrix                  PB97  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB97  67
IF(IDFLAG!=16) lquit:('Identity symop X,Y,Z missing from input.')#      PB97  68
SORT(1)=J#                             Store it first                   PB97  69
GROUP(J)=1#                            Flag matrix ordered              PB97  70
#                                                                       PB97  71
# FIND ROTATION MATRICES WITH SAME PATTERN OF ZEROS                     PB97  72
# -------------------------------------------------                     PB97  73
#                                                                       PB97  74
NROT1=1#                               Initialize count                 PB97  75
DO J=1,NSYM#                           Loop over symops                 PB97  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB97  77
IF(GROUP(J)!=0) NEXT#                  Matrix not ordered yet           PB97  78
IDFLAG=0#                              Count identical elements         PB97  79
DO I=1,12#                             Loop over rotation elements      PB97  80
IF(IABS(SMAT(I,J))==IDEN(I)) IDFLAG=IDFLAG+1# Increment count           PB97  81
IF(IDFLAG!=12) NEXT#                   Identical rotation matrix        PB97  82
NROT1=NROT1+1#                         Increment count                  PB97  83
SORT(NROT1)=J#                         New position                     PB97  84
GROUP(J)=1#                            Flag matrix ordered              PB97  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB97  86
#                                                                       PB97  87
# SORT THE REST OF THE MATRICES                                         PB97  88
# FIND ROTATION MATRICES WITH SAME PATTERNS OF ZEROS                    PB97  89
# --------------------------------------------------                    PB97  90
#                                                                       PB97  91
NROT2=NROT1#                           Total count of matrices          PB97  92
IGROUP=1#                              Flag rotation groups             PB97  93
DO J=1,NSYM#                           Loop over symops                 PB97  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PB97  95
IF(GROUP(J)!=0) NEXT#                  Matrix not ordered yet           PB97  96
NROT2=NROT2+1#                         Count matrix                     PB97  97
SORT(NROT2)=J#                         New position                     PB97  98
IGROUP=IGROUP+1#                       New rotation group               PB97  99
NROT3=1#                               Elements of this rotation gr     PB97 100
GROUP(J)=IGROUP#                       Flag matrix ordered              PB97 101
KK=J+1#                                Start of next loop               PB97 102
DO K=KK,NSYM#                          Loop over rest of symops         PB97 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PB97 104
IF(GROUP(K)!=0) NEXT#                  Matrix not ordered yet           PB97 105
IDFLAG=0#                              Count identical elements         PB97 106
DO I=1,12#                             Loop over rotation elements      PB97 107
IF(IABS(SMAT(I,J))==IABS(SMAT(I,K))) IDFLAG=IDFLAG+1# Increment cou     PB97 108
IF(IDFLAG!=12) NEXT#                   Identical rotation matrices      PB97 109
NROT2=NROT2+1#                         Count matrix                     PB97 110
SORT(NROT2)=K#                         New position                     PB97 111
GROUP(K)=IGROUP#                       Flag matrix ordered              PB97 112
NROT3=NROT3+1#                         Increment count                  PB97 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PB97 114
IF(NROT3!=NROT1) lquit:('Supplied XYZ symops are inconsistent.')#       PB97 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PB97 116
#                                      Now do the delayed write out of  PB97 117
#                                                                       PB97 118
#                                                                       PB97 119
SYMFAC = (NSYM)*NINT(FMUL(LTYP))#      Number equiv. positions          PB97 120
IF(ICNT==0) SYMFAC=SYMFAC*2#           Adjust symops for centrosymmet   PB97 121
#                                                                       PB97 122
#                                                                       PB97 123
# CHECK FOR DUPLICATE ROTATION MATRICES                                 PB97 124
# -------------------------------------                                 PB97 125
#                                                                       PB97 126
DO J=1,NSYM#                           Loop over symops                 PB97 127
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PB97 128
DO I=13,16#                            Loop over translation elemen     PB97 129
IF(SMAT(I,J)<0) SMAT(I,J)=SMAT(I,J)+12# Make positive                   PB97 130
KK=J+1#                                Start of next loop               PB97 131
DO K=KK,NSYM#                          Loop over rest of symops         PB97 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PB97 133
IDFLAG=0#                              Count identical elements         PB97 134
DO I=1,12#                             Loop over rotation elements      PB97 135
IF(SMAT(I,J)==SMAT(I,K)) IDFLAG=IDFLAG+1# Increment count               PB97 136
IF(IDFLAG>=12)$#                                                        PB97 137
lquit:('Unexpected identical rotation matrices in symop list.')#        PB97 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PB97 139
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PB97 140
#                                                                       PB97 141
# CHECK THAT THE SYMOPS FORM A GROUP                                    PB97 142
# ----------------------------------                                    PB97 143
#                                                                       PB97 144
LATS=LATSS(LTYP)#                                                       PB97 145
LATE=LATES(LTYP)#                                                       PB97 146
DO I=1,NSYM#                           Loop over symops                 PB97 147
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PB97 148
DO J=1,NSYM#                           Loop over symops                 PB97 149
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PB97 150
DO K=1,4#                              Loop over columns of #2          PB97 151
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PB97 152
PROD(K)=SMAT(K,J)*SMAT(1,I)+SMAT(K+4,J)*SMAT(2,I)$#                     PB97 153
                             +SMAT(K+8,J)*SMAT(3,I)#                    PB97 154
PROD(K+4)=SMAT(K,J)*SMAT(5,I)+SMAT(K+4,J)*SMAT(6,I)$#                   PB97 155
                               +SMAT(K+8,J)*SMAT(7,I)#                  PB97 156
PROD(K+8)=SMAT(K,J)*SMAT(9,I)+SMAT(K+4,J)*SMAT(10,I)$#                  PB97 157
                               +SMAT(K+8,J)*SMAT(11,I)#                 PB97 158
PROD(K+12)=SMAT(K,J)*SMAT(13,I)+SMAT(K+4,J)*SMAT(14,I)$#                PB97 159
            +SMAT(K+8,J)*SMAT(15,I)+SMAT(K+12,J)*SMAT(16,I)#            PB97 160
PROD(K)=PROD(K)/12#                                                     PB97 161
PROD(K+4)=PROD(K+4)/12#                                                 PB97 162
PROD(K+8)=PROD(K+8)/12#                                                 PB97 163
PROD(K+12)=PROD(K+12)/12#                                               PB97 164
IF(PROD(K+12)<0) PROD(K+12)=PROD(K+12)+12# Make positive                PB97 165
PROD(K+16)=12-PROD(K+12)#              Negative for centrosymmetric     PB97 166
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PB97 167
#                                                                       PB97 168
IMATCH=0#                              No match initially               PB97 169
DO K=1,NSYM#                           Loop over symops                 PB97 170
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PB97 171
KKK=13#                                For noncentrosymmetric           PB97 172
IDFLAG=0#                              Count identical elements         PB97 173
DO L=1,12#                             Loop over rotation elements      PB97 174
IF(SMAT(L,K)==PROD(L)) IDFLAG=IDFLAG+1# Increment count                 PB97 175
IF(IDFLAG<12)#                         No match                         PB97 176
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PB97 177
IF(ICNT!=0) NEXT#                      Skip if noncentrosymmetric       PB97 178
IDFLAG=0#                              Test for negatives               PB97 179
DO L=1,12#                             Loop over rotation elements      PB97 180
IF(SMAT(L,K)==(-PROD(L))) IDFLAG=IDFLAG+1# Increment count              PB97 181
KKK=17#                                Negative translation vector      PB97 182
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PB97 183
IF(IDFLAG==12)#                        Match                            PB97 184
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PB97 185
FOR(L=LATS;L<=LATE;L=L+3)#             ????                             PB97 186
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PB97 187
IF((SMAT(13,K)==MOD(PROD(KKK)+TLAT(L),12))&$#                           PB97 188
   (SMAT(14,K)==MOD(PROD(KKK+1)+TLAT(L+1),12))&$#                       PB97 189
   (SMAT(15,K)==MOD(PROD(KKK+2)+TLAT(L+2),12)))# Whew                   PB97 190
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PB97 191
IMATCH=1#                              Flag match                       PB97 192
BREAK#                                 Break out                        PB97 193
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PB97 194
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PB97 195
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PB97 196
IF(IMATCH==1) BREAK#                   Break again                      PB97 197
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PB97 198
IF(IMATCH==0) lquit:('Supplied XYZ symops do not form a space group.')# PB97 199
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PB97 200
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PB97 201
##                                                                      PB97 202
##                                                                      PB97 203
##  CONVERT SMAT to REAL SYMOP ARRAY                                    PB97 204
##  --------------------------------                                    PB97 205
##                                                                      PB97 206
DO J=1,NSYM#                           Loop over symops                 PB97 207
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PB97 208
JJ=SORT(J)#                            Get sorted symop                 PB97 209
DO I=2,4 ;  RSMAT(I-1,J)=FLOAT(SMAT(I-1,JJ)/12)#                        PB97 210
DO I=5,7 ;  RSMAT(I-1,J)=FLOAT(SMAT(I,JJ)/12)#                          PB97 211
DO I=8,10 ; RSMAT(I-1,J)=FLOAT(SMAT(I+1,JJ)/12)#                        PB97 212
DO I=11,13 ;RSMAT(I-1,J)=FLOAT(SMAT(I+2,JJ))/12.0#                      PB97 213
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PB97 214
##write(6,'(12F6.2)') ((RSMAT(L,K), L=1,12), K=1,NSYM)                  PB97 215
#                                                                       PB97 216
#                                                                       PB97 217
RETURN#                                                                 PB97 218
END#                                                                    PB97 219
systemheader:(PB98)#                   Sort the sietz matrices          PB98   1
# ################################################################## #  PB98   2
#                                                                    #  PB98   3
#                               PB98   FORMERLY SX18                 #  PB98   4
#                                                                    #  PB98   5
# ################################################################## #  PB98   6
SUBROUTINE PB98#                                                        PB98   7
include:(AACOMN)#                                                       PB98   8
include:(PBCOMN)#                                                       PB98   9
##                                                                      PB98  10
## This routine sorts the Sietz matrices of the form...                 PB98  11
##                                                                      PB98  12
##                 r11 r12 r13 t1                                       PB98  13
##                 r21 r22 r23 t2                                       PB98  14
##                 r31 r32 r33 t3                                       PB98  15
##                  0   0   0  12                                       PB98  16
##                                                                      PB98  17
##    where r's are 12, 0 or -12, t's are fractions mod 12.             PB98  18
##                                                                      PB98  19
## SMAT is a linear array order r11 r21 r31 0 r12.... t2 t3 12.         PB98  20
##                                                                      PB98  21
## The sort order is r11 r22 r33 r12 r13 r21 r23 r31 r32 t1 t2 t3       PB98  22
##                                                                      PB98  23
## Note the kluge that ensures that transl (0,0,t3) precedes (t1,t2,0)  PB98  24
##                                                                      PB98  25
#                                                                       PB98  26
INTEGER I,J,K,M,N,S#                                                    PB98  27
INTEGER ISORT(200)#                                                     PB98  28
intdata:(PAK,[1,3,9,27,81,243,729,2187,6561,164025,4100625,102515625])# PB98  29
intdata:(DIV,[12,12,12,12,12,12,12,12,12,1,1,1])#                       PB98  30
intdata:(ORD,[1,6,11,5,9,2,10,3,7,13,14,15])#                           PB98  31
datastuff:#                                                             PB98  32
#                                                                       PB98  33
DO I=1,NSYM#                           Loop over sietz matrices         PB98  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB98  35
##WRITE(6,'(16i5)') (SMAT(J,I), J=1,16)#                                PB98  36
ISORT(I)=0#                            Reset sort index                 PB98  37
DO M=1,12#                             Loop over active elements        PB98  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PB98  39
J=ORD(M)#                              Get the order of elements        PB98  40
K=SMAT(J,I)/DIV(M)#                    Extract matrix element           PB98  41
IF(K<0) N=2#                           For -ve r elements               PB98  42
ELSE    N=K#                           For others                       PB98  43
ISORT(I)=ISORT(I)+N*PAK(M)#            Calculate the sort index         PB98  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PB98  45
IF(SMAT(13,I)+SMAT(14,I)==0&SMAT(15,I)>0)# Test for 0,0,t3 condition    PB98  46
ISORT(I)=ISORT(I)-98415000*SMAT(15,I)# Ensure 0,0,t3 above t1,t2,0      PB98  47
##WRITE(6,'(i20)') ISORT(I)#                                            PB98  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB98  49
#                                                                       PB98  50
#   SORT SIETZ MATRICES ON T1 T2 T3 R11 R12 R13 R21 R22.... R33         PB98  51
#                                                                       PB98  52
DO I=1,NSYM#                           Loop sietz matrices              PB98  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PB98  54
N=I#                                   Set starting value               PB98  55
DO J=I+1,NSYM#                         Loop sietz matrices              PB98  56
IF(ISORT(N)>ISORT(J)) N=J#             Store value if j<n               PB98  57
ISORT(N)=ISORT(I)#                     Save the sort index              PB98  58
DO K=1,16#                                                              PB98  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PB98  60
S=SMAT(K,I); SMAT(K,I)=SMAT(K,N); SMAT(K,N)=S# Swap elements            PB98  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PB98  62
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PB98  63
#DO I=1,NSYM; WRITE(6,'(16I5)') (SMAT(J,I), J=1,16)#                    PB98  64
#                                                                       PB98  65
RETURN#                                                                 PB98  66
END#                                                                    PB98  67
systemheader:(PB99)#                   Hacked to get atomic weights     PB99   1
# ################################################################## #  PB99   2
#                                                                    #  PB99   3
#                               PB99   FORMERLY SX20                 #  PB99   4
#                                                                    #  PB99   5
# ################################################################## #  PB99   6
SUBROUTINE PB99(NAME,WEIGHT)#                                           PB99   7
#                                                                       PB99   8
INTEGER IEL#                                                            PB99   9
REAL WEIGHT#                           Return val                       PB99  10
REAL ATWT(105)#                        Atomic weight table              PB99  11
string:(NAME,*)#                                                        PB99  12
string:(NNAME,2)#                      New name                         PB99  13
string:(ELNAM,315)#                    Element symbol table             PB99  14
chardata:(PB6C,H  HE LI BE B  C  N  O  F  NE NA MG AL SI P  S  CL $#    PB99  15
AR K  CA SC TI V  CR MN FE CO NI CU ZN GA GE AS SE BR )#                PB99  16
chardata:(PB6D,KR RB SR Y  ZR NB MO TC RU RH PD AG CD IN SN SB TE $#    PB99  17
I  XE CS BA LA CE PR ND PM SM EU GD TB DY HO ER TM YB )#                PB99  18
chardata:(PB6E,LU HF TA W  RE OS IR PT AU HG TL PB BI PO AT RN FR $#    PB99  19
RA AC TH PA U  NP PU AM CM BK CF ES FM MD NO LR RF ?? )#                PB99  20
realdata:(AW1,[$#                      Iupac 1984 rounded to 3 plac     PB99  21
 1.008, 4.003, 6.941, 9.012,10.811,12.011,14.007,15.999,18.998,20.179,# PB99  22
22.990,24.305,26.982,28.086,30.974,32.066,35.453,39.948,39.098,40.078,# PB99  23
44.956,47.88, 50.942,51.996,54.938,55.847,58.933,58.69, 63.546,65.39,#  PB99  24
69.723,72.59, 74.922,78.96, 79.904,83.80, 85.468,87.62, 88.906,91.224])#PB99  25
realdata:(AW2,[$#                                                       PB99  26
92.906,95.94,98.906,101.07,102.906,106.42,107.868,112.41,114.82,118.71,#PB99  27
121.75,127.60,126.905,131.29,132.905,137.33,138.906,140.12,140.908,#    PB99  28
144.24,147.,150.36,151.96,157.25,158.926,162.5,164.93,167.26,168.934,#  PB99  29
173.04,174.967,178.49,180.948,183.85,186.207,190.2,192.22,195.08])#     PB99  30
realdata:(AW3,[$#                                                       PB99  31
196.966,200.59,204.383,207.2,208.980,209.,210.,222.,223.,226.025,#      PB99  32
227.,232.038,231.036,238.029,237.048,242.,243.,247.,247.,249.,254.,#    PB99  33
253.,256.,254.,257.,261.,0.])#                                          PB99  34
datastuff:#                                                             PB99  35
#                                                                       PB99  36
#                                                                       PB99  37
movechar:(PB6C,1,ELNAM,1,105,0)#       Transfer element symbols         PB99  38
movechar:(PB6D,1,ELNAM,106,105,0)#     Transfer element symbols         PB99  39
movechar:(PB6E,1,ELNAM,211,105,0)#     Transfer element symbols         PB99  40
movereal:(AW1,1,ATWT,1,40,0)#          Transfer atomic weights          PB99  41
movereal:(AW2,1,ATWT,41,38,0)#         Transfer atomic weights          PB99  42
movereal:(AW3,1,ATWT,79,27,0)#         Transfer atomic weights          PB99  43
upcase:(NAME,NNAME,2)#                 Convert to upper case            PB99  44
compchar:(NNAME,1,ELNAM,1,2,3,315,IEL)# Seek element symbol             PB99  45
IF(IEL!=0) WEIGHT=ATWT(IEL)#                                            PB99  46
ELSE $( WEIGHT=0.0 $)#                                                  PB99  47
#                                                                       PB99  48
RETURN#                                                                 PB99  49
END#                                                                    PB99  50
pmacro:([no:])#                        Purge xtal system macros         PB99  51
