systemheader:(PC    )#                                                  PC     1
####################################################################    PC     2
##                                                                 #    PC     3
##                          *** PRECED ***                         #    PC     4
##                                                                 #    PC     5
##    PRECED loads the macromolecular parameters for CEDAR         #    PC     6
##                                                                 #    PC     7
####################################################################    PC     8
include:(XMACRO)#                                                       PC     9
#                                                                       PC    10
macro:(maxatype:,12)#                  Maximum number of atom scatt     PC    11
macro:(mxres:,50)#                     Maximum number of residues i     PC    12
macro:(mxnasr:,50)#                    Mas.num.atoms in a single re     PC    13
macro:(mxdatms:,1000)#                 Maximum number of atoms in d     PC    14
macro:(stepdc:,23)#                    Number of items in dictionar     PC    15
macro:(stepat:,9)#                     Max. words in stepat             PC    16
macro:(steppa:,22)#                    Min. words in steppa             PC    17
macro:(id5:,13)#                       Position of id5 in param arr     PC    18
macro:(id18:,10)#                      Position of id18 in param ar     PC    19
macro:(maxatms:,4000)#                 Maximum number of atoms in s     PC    20
macro:(stepch:,16)#                    Number of characters in dict     PC    21
macro:(maxatoms:,4000)#                Maximum number of atoms in s     PC    22
macro:(mxnres:,500)#                   Maximum number of residues i     PC    23
macro:(mxnmas:,250)#                   Maximum number of master ato     PC    24
macro:(mxnslv:,250)#                   Maximum number of slave atom     PC    25
macro:(maxlat:,50)#                    Maximum number of cedar sym      PC    26
macro:(grabword:,[$(stringlim:($1,IC1,IC2);NCH=IC2-IC1;$#               PC    27
movechar:(BLANK,1,$2,1,4,1);movechar:(CHRIN,IC1,$2,1,NCH,0)$)])#        PC    28
#                                                                       PC    29
macro:(rot:,QX(STARMX+($2)*STEPMX-STEPMX+$1))#                          PC    30
macro:(t:,QX(STARMX+($2)*STEPMX-3+$1))#                                 PC    31
macro:(rotx:,QX(STARSY+($2)*STEPSY-STEPSY+$1))#                         PC    32
macro:(tx:,QX(STARSY+($2)*STEPSY-3+$1))#                                PC    33
macro:(x:,QX(STARPA+($2)*STEPPA-STEPPA+$1))#                            PC    34
#                                                                       PC    35
# DEFINE PROCEDURE MACROS                                               PC    36
macro:(seedy:,3987)#                                                    PC    37
macro:(makenum:,[macro:([seedy:],arith:(seedy:,-,$1))seedy:])#          PC    38
macro:(defineproc:,[macro:($1:,makenum:(1))])#                          PC    39
macro:(xeq:,[$(ASSIGN makenum:(1) TO JZ $1:;GOTO $1:#                   PC    40
seedy: CONTINUE$)])#                                                    PC    41
macro:(procedure:,$1: CONTINUE)#                                        PC    42
macro:(endproc:,GOTO JZ $1:)#                                           PC    43
#                                                                       PC    44
extrude:(PCCOMN)#                                                       PC    45
REAL  FTOC(9)#                         Matrix to convert fractional     PC    46
REAL  CTOF(9)#                         Matrix to convert cartesian      PC    47
REAL CUTOFF#                           =nonbonded cutoff                PC    48
#                                                                       PC    49
INTEGER NATYPE#                        Number of atom scattering ty     PC    50
INTEGER NSEQU#                         Number of items in sequence      PC    51
INTEGER NDICT#                         Number of items in dictionar     PC    52
INTEGER TYPRES#                        Number of different residue      PC    53
INTEGER NUMATM#                        Number of atoms in atom arra     PC    54
INTEGER DICTPT(mxres:)#                Pointer to 1st. atom-1 of        PC    55
INTEGER NSLAV#                         Number of mas/slav and slav/     PC    56
INTEGER NSYMOP#                        Number of cystal symetry pos     PC    57
INTEGER NLAT#                          Number of cedar latice posit     PC    58
INTEGER STOPQX#                        Last location used in qx arr     PC    59
INTEGER STARSQ,STEPSQ,STOPSQ#          Pointers for sequence names      PC    60
INTEGER STARDC,STEPDC,STOPDC#          Pointers to dictionary array     PC    61
INTEGER STARAT,STEPAT,STOPAT#          Pointers to atom info.           PC    62
INTEGER STARPA,STEPPA,STOPPA#          Pointers to atom parameters      PC    63
INTEGER STARMS,STEPMS,STOPMS#          Pointer to master arrays         PC    64
INTEGER STARSY,STEPSY,STOPSY#          Crystal symetry array            PC    65
INTEGER STARMX,STEPMX,STOPMX#          Cedar lattice array              PC    66
INTEGER RESIPT(arith:(mxnres:,+,1))#   Pointer to fist-1 atom of re     PC    67
INTEGER NEIBOR,NEIFIL#                 Calc.neighbor interactions       PC    68
INTEGER ANISO#                         Key to aniso present             PC    69
INTEGER OLDATM#                        Key to old coord present         PC    70
string:(ATYPE,arith:(4,*,maxatype:))#  Space for store of atom type     PC    71
string:(RESHAV,arith:(4,*,mxres:))#    Names of residues in diction     PC    72
#                                                                       PC    73
COMMON /COMFPC/ FTOC,CTOF,CUTOFF#                                       PC    74
#                                                                       PC    75
COMMON /COMIPC/ NATYPE,NSEQU,NDICT,TYPRES,NUMATM,NSLAV,#                PC    76
NSYMOP,NLAT,DICTPT,RESIPT,STOPQX,#                                      PC    77
STARSQ,STEPSQ,STOPSQ,STARDC,STEPDC,STOPDC,STARAT,STEPAT,STOPAT,#        PC    78
STARPA,STEPPA,STOPPA,STARMS,STEPMS,STOPMS,STARSY,STEPSY,STOPSY,#        PC    79
STARMX,STEPMX,STOPMX,NEIBOR,NEIFIL,ANISO,OLDATM#                        PC    80
#                                                                       PC    81
COMMON /COMCPC/ RESHAV,ATYPE#                                           PC    82
endext:#                                                                PC    83
#                                                                       PC    84
systemheader:(PC00)#                                                    PC00   1
#####################################################################   PC00   2
# MAIN ROUTINE OF PRE-CEDAR  (PC00)                                     PC00   3
#####################################################################   PC00   4
SUBROUTINE PC00#                                                        PC00   5
include:(AACOMN)#                      Xtal system common               PC00   6
include:(PCCOMN)#                                                       PC00   7
#                                                                       PC00   8
INTEGER I,K#                           Temporary local integers         PC00   9
INTEGER IPTI,IPTO,PSIZE#               Pointers to in/out areas         PC00  10
#                                                                       PC00  11
chardata:(PC1, END    SEQIN  DICTIN LINKIN NEIBOR ENDCHN NEWCHN )#      PC00  12
chardata:(PCSEQ, SEQUENCE STORED ON OUTPUT BDF)#                        PC00  13
chardata:(PCHD, PRE-CEDAR PROGRAM-VERSION 30-MAR-1988)#                 PC00  14
chardata:(SEPAR,[//])#                                                  PC00  15
datastuff:#                                                             PC00  16
#                                                                       PC00  17
# DEFINE NAMES OF PROCEDURES THAT WILL BE USED IN THIS ROUTINE          PC00  18
defineproc:(INITIAL)#                  General intialize process        PC00  19
defineproc:(GETSEQ)#                   Get sequence from bdf(in)        PC00  20
defineproc:(SETSEQ)#                   Treat sequence directives        PC00  21
defineproc:(PUTSEQ)#                   Put sequence onto bdf(temp)      PC00  22
defineproc:(GETDICT)#                  Get dictionary from bdf(in)      PC00  23
defineproc:(SETDICT)#                  Treat dictionary directives      PC00  24
defineproc:(PUTDICT)#                  Put dictionary onto bdf(temp     PC00  25
defineproc:(GETATOM)#                  Read atoms from bdf(in) and      PC00  26
defineproc:(PUTATOM)#                  Put atoms onto bdf(temp)         PC00  27
defineproc:(GETLINK)#                  Get link info. from director     PC00  28
defineproc:(SETLINK)#                  Treat atom link directives       PC00  29
defineproc:(PUTLINK)#                  Put atom link info onto bdf(     PC00  30
defineproc:(SETLATT)#                  Put atom link info onto bdf(     PC00  31
defineproc:(FINI)#                     Copy rest of bdf(in) to bdf(     PC00  32
#                                                                       PC00  33
###################################                                     PC00  34
# START OF PROGRAM CONTROL        #                                     PC00  35
###################################                                     PC00  36
#                                                                       PC00  37
xeq:(INITIAL)#                         Get desired info off bdf fil     PC00  38
#                                      Setup arrays, pointers, etc.     PC00  39
readline:(PC1,NPC1)#                                                    PC00  40
IF(LINID==5)#                          Search for intermolecular        PC00  41
#                                      Interactions                     PC00  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC00  43
NEIBOR=yes:#                                                            PC00  44
NEIFIL=3#                              Output intermediate file         PC00  45
CUTOFF=6.0#                            Check on neibors to 6.0 ang.     PC00  46
ifnv:(BUFIN(1)) CUTOFF=BUFIN(1)#                                        PC00  47
readline:(PC1,NPC1)#                                                    PC00  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC00  49
xeq:(GETSEQ)#                          Get sequence from bdf(in), i     PC00  50
IF(LINID==2)#                                                           PC00  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC00  52
xeq:(SETSEQ)#                                                           PC00  53
readline:(PC1,NPC1)#                                                    PC00  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC00  55
IF(NSEQU==0) iquit:(PC0001)#           No sequence information          PC00  56
xeq:(PUTSEQ)#                          Put sequence onto bdf(out)       PC00  57
xeq:(GETDICT)#                         Get dictionary from bdf(in)      PC00  58
IF(LINID==3)#                                                           PC00  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC00  60
xeq:(SETDICT)#                                                          PC00  61
readline:(PC1,NPC1)#                                                    PC00  62
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC00  63
IF(NDICT==0) iquit:(PC0002)#           No dictionary information        PC00  64
xeq:(PUTDICT)#                         Put dictionary info. to bdf(     PC00  65
xeq:(GETATOM)#                                                          PC00  66
IF(NUMATM==0) iquit:(PC0003)#          No atom in array                 PC00  67
xeq:(GETLINK)#                         Link up the atoms with defau     PC00  68
xeq:(SETLINK)#                         Process special link directi     PC00  69
xeq:(PUTATOM)#                         Put atoms with link info. on     PC00  70
xeq:(PUTLINK)#                         Put misc and master/slave in     PC00  71
xeq:(SETLATT)#                         Set up lattice of neighborin     PC00  72
xeq:(FINI)#                            Close out the bdf, etc.          PC00  73
RETURN#                                                                 PC00  74
#                                                                       PC00  75
###################################                                     PC00  76
# END OF PROGRAM CONTROL        #                                       PC00  77
###################################                                     PC00  78
#                                                                       PC00  79
#                                                                       PC00  80
#                                                                       PC00  81
#                                                                       PC00  82
#########################                                               PC00  83
procedure:(INITIAL)#                   General intialize process        PC00  84
#########################                                               PC00  85
#                                                                       PC00  86
#  ALLOCATE BDF BUFFERS                                                 PC00  87
#                                                                       PC00  88
IOMARK(1)=QXSTR#                       Set start of bdf buffer1         PC00  89
IOMARK(2)=IOMARK(1)+bdfbuf:#           Set start of bdf buffer2         PC00  90
IOMARK(3)=IOMARK(2)+bdfbuf:#           Set end of bdf buffer2           PC00  91
IOMARK(4)=IOMARK(3)+bdfbuf:#           Set end of bdf buffer3           PC00  92
IOMARK(5)=IOMARK(4)+bdfbuf:#           Set end of bdf buffer4           PC00  93
#                                                                       PC00  94
incrqx:(STOPQX,IOMARK(5)+1,PC0004)#    Set current end of qx            PC00  95
#                                                                       PC00  96
FILEXT(IOUNIT(3))='XX1'#               Scratch file 1                   PC00  97
FILEXT(IOUNIT(4))='XX2'#               Scratch file 1                   PC00  98
NEIBOR=no:#                            Default, do not search for       PC00  99
NEIFIL=2#                              Intermolecular interactions      PC00 100
endproc:(INITIAL)#                                                      PC00 101
#                                                                       PC00 102
#                                                                       PC00 103
#                                                                       PC00 104
#########################                                               PC00 105
procedure:(GETSEQ)#                    Get sequence from bdf, if th     PC00 106
#########################                                               PC00 107
#                                                                       PC00 108
CALL PC01#                                                              PC00 109
#                                                                       PC00 110
STARSQ=STOPQX#                                                          PC00 111
STEPSQ=15/mxchwd:+1#                   Allow room for 8 characters      PC00 112
STOPSQ=STARSQ#                                                          PC00 113
NSEQU=0#                                                                PC00 114
LINCT=0#                               Force new printer page           PC00 115
writeline:(0,PCHD,NPCHD,3,2)#                                           PC00 116
#                                                                       PC00 117
#  GET SEQUENCE FROM LR LRSEQU:                                         PC00 118
#                                                                       PC00 119
REPEAT#                                                                 PC00 120
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC00 121
readwpkt:(1,lrsequ:,PSIZE,IPTI,0)#     Read residue name                PC00 122
IF(IPTI <=0) BREAK#                                                     PC00 123
NSEQU=NSEQU+1#                         Increment number of residues     PC00 124
movereal:(QX(IPTI+1),1,QX(STOPSQ+1),1,STEPSQ,0)# Move residue name to   PC00 125
STOPSQ=STOPSQ+STEPSQ#                                                   PC00 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC00 127
endproc:(GETSEQ)#                                                       PC00 128
#                                                                       PC00 129
#                                                                       PC00 130
#                                                                       PC00 131
#########################                                               PC00 132
procedure:(SETSEQ)#                    Treat sequence directives        PC00 133
#########################                                               PC00 134
#                                                                       PC00 135
CALL PC10#                             Get sequence from input file     PC00 136
#                                                                       PC00 137
endproc:(SETSEQ)#                                                       PC00 138
#                                                                       PC00 139
#                                                                       PC00 140
#                                                                       PC00 141
#########################                                               PC00 142
procedure:(PUTSEQ)#                    Put sequence onto bdf(out)       PC00 143
#########################                                               PC00 144
#                                                                       PC00 145
#  PUT SEQUENCE OUT TO LR LRSEQU:, BDF (OUT)                            PC00 146
#                                                                       PC00 147
K=STARSQ+1#                                                             PC00 148
DO I=1, NSEQU#                                                          PC00 149
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC00 150
writepkt:(NEIFIL,lrsequ:,STEPSQ,IPTO)# Prepare to write packets         PC00 151
movereal:(QX,K,QX(IPTO+1),1,STEPSQ,0)# Move packet to output            PC00 152
K=K+STEPSQ#                            Increment to next residue        PC00 153
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC00 154
#                                                                       PC00 155
#  TELL THE WORLD WHAT THE SEQUENCE IS                                  PC00 156
#                                                                       PC00 157
I=STARSQ+1#                                                             PC00 158
writeline:(1,PCSEQ,NPCSEQ,3,3)#                                         PC00 159
WHILE (I <=STOPSQ)#                                                     PC00 160
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PC00 161
K=2#                                   Start line in column 2           PC00 162
REPEAT#                                Do ten residues at a time        PC00 163
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PC00 164
movertoc:(QX(I),1,CHROT,K,16,0)#       Move residue name to output      PC00 165
movechar:(SEPAR,1,CHROT,K+16,2,0)#                                      PC00 166
K=K+18#                                                                 PC00 167
I=I+STEPSQ#                                                             PC00 168
IF(K >=100 \ I >=STOPSQ) BREAK#        Do until 5 items or end          PC00 169
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PC00 170
writeline:(0,0,0,1,3)#                                                  PC00 171
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PC00 172
STOPQX=STOPSQ#                         Set current end of qx array      PC00 173
#                                                                       PC00 174
endproc:(PUTSEQ)#                                                       PC00 175
#                                                                       PC00 176
#                                                                       PC00 177
#                                                                       PC00 178
#########################                                               PC00 179
procedure:(GETDICT)#                   Get dictionary from bdf(in)      PC00 180
#########################                                               PC00 181
#                                                                       PC00 182
CALL PC04(0)#                                                           PC00 183
#                                                                       PC00 184
endproc:(GETDICT)#                                                      PC00 185
#                                                                       PC00 186
#                                                                       PC00 187
#                                                                       PC00 188
#########################                                               PC00 189
procedure:(SETDICT)#                   Treat dictionary directives      PC00 190
#########################                                               PC00 191
#                                                                       PC00 192
CALL PC20#                                                              PC00 193
#READLINE:(PC1,NPC1)#                                                   PC00 194
#                                                                       PC00 195
endproc:(SETDICT)#                                                      PC00 196
#                                                                       PC00 197
#                                                                       PC00 198
#                                                                       PC00 199
#########################                                               PC00 200
procedure:(PUTDICT)#                   Put dictionary onto bdf(out)     PC00 201
#########################                                               PC00 202
#                                                                       PC00 203
CALL PC04(1)#                                                           PC00 204
#                                                                       PC00 205
endproc:(PUTDICT)#                                                      PC00 206
#                                                                       PC00 207
#                                                                       PC00 208
#                                                                       PC00 209
#########################                                               PC00 210
procedure:(GETATOM)#                   Get atoms from bdf(in)           PC00 211
#########################                                               PC00 212
#                                                                       PC00 213
CALL PC30#                             Create atom array with dummy     PC00 214
copyfile:(1,NEIFIL,incr:(lrdict:),decr:(lratom:))#                      PC00 215
CALL PC32#                             Read atoms from bdf(in)          PC00 216
endproc:(GETATOM)#                                                      PC00 217
#                                                                       PC00 218
#                                                                       PC00 219
#                                                                       PC00 220
#########################                                               PC00 221
procedure:(PUTATOM)#                   Put atoms onto bdf(out)          PC00 222
#########################                                               PC00 223
#                                                                       PC00 224
CALL PC34#                                                              PC00 225
endproc:(PUTATOM)#                                                      PC00 226
#                                                                       PC00 227
#                                                                       PC00 228
#                                                                       PC00 229
#########################                                               PC00 230
procedure:(GETLINK)#                   Get default link info. from      PC00 231
#########################                                               PC00 232
#                                                                       PC00 233
CALL PC50#                                                              PC00 234
endproc:(GETLINK)#                                                      PC00 235
#                                                                       PC00 236
#                                                                       PC00 237
#                                                                       PC00 238
#########################                                               PC00 239
procedure:(SETLINK)#                   Treat atom link directives       PC00 240
#########################                                               PC00 241
#                                                                       PC00 242
IF(LINID==4) INFO=yes:#                Special link info.               PC00 243
ELSE INFO=no:#                         No special link info.            PC00 244
CALL PC55(INFO)#                       Set-up tree info.                PC00 245
IF(INFO==yes:) readline:(PC1,NPC1)#                                     PC00 246
endproc:(SETLINK)#                                                      PC00 247
#                                                                       PC00 248
#                                                                       PC00 249
#                                                                       PC00 250
#########################                                               PC00 251
procedure:(PUTLINK)#                   Put atom link info onto bdf(     PC00 252
#########################                                               PC00 253
#                                                                       PC00 254
CALL PC58#                             Put master/slave info to bdf     PC00 255
endproc:(PUTLINK)#                                                      PC00 256
#                                                                       PC00 257
#                                                                       PC00 258
#                                                                       PC00 259
#########################                                               PC00 260
procedure:(SETLATT)#                                                    PC00 261
#########################                                               PC00 262
#                                                                       PC00 263
IF(NEIBOR==yes:)CALL PC60#             Get latice info for neighbor     PC00 264
endproc:(SETLATT)#                                                      PC00 265
#                                                                       PC00 266
#########################                                               PC00 267
procedure:(FINI)#                      Copy rest of bdf(in) to bdf(     PC00 268
#########################                                               PC00 269
#                                                                       PC00 270
CALL PC70#                                                              PC00 271
qxmemory:(QXSTR)#                      Push back mem to start           PC00 272
qxmemory:(STOPQX)#                     Push back mem to start           PC00 273
endproc:(FINI)#                                                         PC00 274
#                                                                       PC00 275
END#                                                                    PC00 276
systemheader:(PC01)#                   Pre-cedar initialization rou     PC01   1
####################################################################    PC01   2
SUBROUTINE PC01#                                                        PC01   3
#                                                                       PC01   4
#   WRITTEN BY KDW 25-SEP-1981                                          PC01   5
#                                                                       PC01   6
include:(AACOMN)#                                                       PC01   7
include:(PCCOMN)#                                                       PC01   8
INTEGER I,K,J#                                                          PC01   9
INTEGER IPT,PSIZE,IPTO#                Packet pointers                  PC01  10
INTEGER NRECR#                                                          PC01  11
#                                                                       PC01  12
#                                                                       PC01  13
#   PROCESS BDF RECORDS 1-7                                             PC01  14
#                                                                       PC01  15
copyfile:(1,2,1,decr:(lrcell:))#                                        PC01  16
NRECR=0#                                                                PC01  17
REPEAT#                                                                 PC01  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC01  19
readwpkt:(1,lrcell:,PSIZE,IPT,0)#                                       PC01  20
IF(IPT <=0) BREAK#                                                      PC01  21
writepkt:(NEIFIL,lrcell:,PSIZE,IPTO)#                                   PC01  22
movereal:(QX(IPT+1),1,QX(IPTO+1),1,PSIZE,0)#                            PC01  23
NRECR=NRECR+1#                         Keep track of packet             PC01  24
IF(NRECR==4)#                          Save to transformation matri     PC01  25
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC01  26
movereal:(QX(IPT+1),1,FTOC,1,9,0)#                                      PC01  27
CALL PC02(FTOC,CTOF)#                  Invert matrix                    PC01  28
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC01  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC01  30
#                                                                       PC01  31
readwpkt:(1,lrsymm:,PSIZE,IPT,0)#                                       PC01  32
writepkt:(NEIFIL,lrsymm:,PSIZE,IPTO)#                                   PC01  33
movereal:(QX(IPT+1),1,QX(IPTO+1),1,PSIZE,0)#                            PC01  34
LATTYP=NINT(QX(IPT+1))#                Store lattice type               PC01  35
ACENTR=NINT(QX(IPT+2))#                Acentric indicator               PC01  36
MULTIP=QX(IPT+6)#                      Cell multiplicity                PC01  37
NSYMOP=NINT(QX(IPT+4))#                Number of symops                 PC01  38
ifnv:(QX(IPT+7)) NLAT=NINT(QX(IPT+7))#                                  PC01  39
ELSE NLAT=1#                           Set one cedar lattice inform     PC01  40
QX(IPTO+7)=FLOAT(NLAT)#                                                 PC01  41
#                                                                       PC01  42
STARSY=STOPQX#                         Mark start of symops             PC01  43
STEPSY=PSIZE#                          And set step size                PC01  44
STOPSY=STARSY#                         Reset end of symops              PC01  45
DO I=1,NSYMOP#                                                          PC01  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC01  47
readwpkt:(1,lrsymm:,PSIZE,IPT,0)#      Read the next packet             PC01  48
writepkt:(NEIFIL,lrsymm:,PSIZE,IPTO)#                                   PC01  49
IF(IPT <=0) iquit:(PC0102)#            Iquit if too few present         PC01  50
movereal:(QX,IPT+1,QX,IPTO+1,PSIZE,0)#                                  PC01  51
movereal:(QX,IPT+1,QX,STOPSY+1,PSIZE,0)# Move the symop to qx           PC01  52
STOPSY=STOPSY+STEPSY#                  Advance ptr to end of            PC01  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC01  54
STOPQX=STOPSY#                         Reset end of qx array            PC01  55
#                                                                       PC01  56
# STORE SYM OPS FOR ENERGY AND DYNAMICS PORTION                         PC01  57
STARMX=STOPQX#                                                          PC01  58
STOPMX=STARMX#                                                          PC01  59
STEPMX=STEPSY#                                                          PC01  60
#                                                                       PC01  61
IF(NEIBOR==no:&NLAT==1)#               Move identity matrix             PC01  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC01  63
writepkt:(NEIFIL,lrsymm:,PSIZE,IPTO)#                                   PC01  64
movereal:(QX(STARSY+1),1,QX(IPTO+1),1,STEPSY,0)#                        PC01  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC01  66
ELSE IF(NEIBOR==no:&NLAT>1)#           Move existing intermolec. ma     PC01  67
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC01  68
FOR (I=1;I<=NLAT;I=I+1)#               P                                PC01  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PC01  70
readwpkt:(1,lrsymm:,PSIZE,IPT,0)#      P                                PC01  71
IF(IPT <=0) iquit:(PC0103)#            Quit if too few present          PC01  72
writepkt:(NEIFIL,lrsymm:,PSIZE,IPTO)#                                   PC01  73
movereal:(QX(IPT+1),1,QX(IPTO+1),1,PSIZE,0)#                            PC01  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PC01  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC01  76
ELSE#                                  Setup space for calc intermo     PC01  77
#                                      Symmetry matrices                PC01  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PC01  79
ORTHOG=no:#                                                             PC01  80
STOPQX=STARMX+maxlat:*STEPMX#          Reserve space for maxlat: ma     PC01  81
movereal:(QX(STARSY+1),1,QX(STARMX+1),1,STEPSY,0)#                      PC01  82
STOPMX=STOPMX+STEPMX#                                                   PC01  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PC01  84
# GET SCATTERING FACTOR INFORMATION                                     PC01  85
NRECR=0#                                                                PC01  86
REPEAT#                                                                 PC01  87
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PC01  88
readwpkt:(1,lrscat:,PSIZE,IPT,0)#                                       PC01  89
IF(IPT <=0) BREAK#                                                      PC01  90
writepkt:(NEIFIL,lrscat:,PSIZE,IPTO)#                                   PC01  91
movereal:(QX(IPT+1),1,QX(IPTO+1),1,PSIZE,0)#                            PC01  92
NRECR=NRECR+1#                                                          PC01  93
IF(NRECR==1)#                                                           PC01  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PC01  95
DO I=1,PSIZE#                                                           PC01  96
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PC01  97
K=IPT+I#                                                                PC01  98
ifeq:(QX(K),11.)#                                                       PC01  99
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PC01 100
J=I#                                                                    PC01 101
BREAK#                                                                  PC01 102
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PC01 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PC01 104
IF(J==0) iquit:(-PC0104)#              No scattering factor nam         PC01 105
K=1#                                                                    PC01 106
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PC01 107
ELSE#                                                                   PC01 108
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PC01 109
NATYPE=NRECR-1#                                                         PC01 110
movertoc:(QX(IPT+J),1,ATYPE,K,4,0)#    Move scattering factor           PC01 111
K=K+4#                                                                  PC01 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PC01 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PC01 114
RETURN#                                                                 PC01 115
END#                                                                    PC01 116
systemheader:(PC02)#                                                    PC02   1
####################################################################### PC02   2
SUBROUTINE PC02(A,B)#                                                   PC02   3
#                                                                       PC02   4
#  3 X 3 MATRIX INVERTER                                                PC02   5
#                                                                       PC02   6
chardata:(SING, SINGULAR MATRIX; NOT INVERTED)#                         PC02   7
REAL A(9)#                             Matrix to be inverted            PC02   8
REAL B(9)#                             Inverse matrix                   PC02   9
datastuff:#                                                             PC02  10
#                                                                       PC02  11
#     COMPUTE COFACTORS                                                 PC02  12
COFA1=A(5)*A(9)-A(8)*A(6)#                                              PC02  13
COFA2=A(8)*A(3)-A(2)*A(9)#                                              PC02  14
COFA3=A(2)*A(6)-A(5)*A(3)#                                              PC02  15
COFA4=A(1)*A(9)-A(7)*A(3)#                                              PC02  16
COFA5=A(4)*A(3)-A(1)*A(6)#                                              PC02  17
COFA6=A(1)*A(5)-A(4)*A(2)#                                              PC02  18
COFA7=A(6)*A(7)-A(4)*A(9)#                                              PC02  19
COFA8=A(4)*A(8)-A(5)*A(7)#                                              PC02  20
COFA9=A(2)*A(7)-A(1)*A(8)#                                              PC02  21
#     COMPUTE DETERMINANT                                               PC02  22
DETER=A(1)*COFA1+A(4)*COFA2+A(7)*COFA3#                                 PC02  23
IF(DETER<.0001)#                                                        PC02  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC02  25
writeline:(1,SING,NSING,3,1)#                                           PC02  26
iquit:(PC0201)#                                                         PC02  27
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC02  28
ELSE#                                                                   PC02  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC02  30
RDET=1.0/DETER#                                                         PC02  31
#   COMPUTE INVERSE MATRIX                                              PC02  32
B(1)=COFA1*RDET ; B(2)=COFA2*RDET ; B(3)=COFA3*RDET#                    PC02  33
B(5)=COFA4*RDET ; B(6)=COFA5*RDET ; B(9)=COFA6*RDET#                    PC02  34
B(4)=COFA7*RDET ;B(7)=COFA8*RDET ; B(8)=COFA9*RDET#                     PC02  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC02  36
#                                                                       PC02  37
RETURN#                                                                 PC02  38
END#                                                                    PC02  39
systemheader:(PC04)#                   Get/put dictionary items fro     PC04   1
####################################################################### PC04   2
SUBROUTINE PC04(INOUT)#                Get/put dictionary items on      PC04   3
#                                                                       PC04   4
#   WRITTEN BY KDW, 1-OCT-1981                                          PC04   5
#                                                                       PC04   6
include:(AACOMN)#                                                       PC04   7
include:(PCCOMN)#                                                       PC04   8
#                                                                       PC04   9
#                                                                       PC04  10
string:(RES,4)#                        Place to dump charactername      PC04  11
string:(RESMIS,arith:(4,*,mxres:))#    Missing residues                 PC04  12
#                                                                       PC04  13
REAL    ATM#                           Temp. counter of atoms           PC04  14
INTEGER PSIZE,IPTI,IPTO#               Pointers for reading bdf         PC04  15
INTEGER I,K,KRES,J,KEY,ICOL#           Local variables                  PC04  16
INTEGER IATM#                          Temp. counter of atoms           PC04  17
INTEGER NORES#                         Number of residue not in dic     PC04  18
chardata:(MSG1, EITHER NONE OR NOT ALL OF DICTIONARY ON BDF)#           PC04  19
chardata:(MSG2, RESIDUE MISSING FROM DICTIONARY=  =)#                   PC04  20
chardata:(DICT1, RESIDUES IN DICTIONARY AND STORED ON BDF)#             PC04  21
chardata:(DICT2, RESIDUE=  =)#                                          PC04  22
#CHARDATA:(DICT3,  NAME  BCH  FCH  GRP LENGTH   ANGLE DIHED NO. ROT $#  PC04  23
# MIN.ANG  ENERGIES)                                                    PC04  24
#                                                                       PC04  25
chardata:(DICT4, N   N    B    F     G   L    A    D  N   M   E)#       PC04  26
chardata:(DICT5, U   A    C    C     R   E    N    I  O   I       N)#   PC04  27
chardata:(DICT6, M   M    H    H     O   N    G    H  .   N           $#PC04  28
E)#                                                                     PC04  29
chardata:(DICT7, B   E               U   G    L    E  R   .           $#PC04  30
    R)#                                                                 PC04  31
chardata:(DICT8, E                   P   T    E    D  O   A           $#PC04  32
        I)#                                                             PC04  33
chardata:(DICT9, R                       H         .  T   N           $#PC04  34
            E)#                                                         PC04  35
chardata:(DICTA,                                      .   G           $#PC04  36
                S)#                                                     PC04  37
#                                                                       PC04  38
realdata:(FMT,[220213.,490522.,390213.,440513.,280622.,320413.,370513.,#PC04  39
500602.,560602.,620612.,680602.,740602.,800602.,860602., $#             PC04  40
    940832.,970313.,1030602.,1090602.,1130413.])#                       PC04  41
intdata:(SIZE,4)#                      Characters in residue and at     PC04  42
INTEGER KEYP(4)#                                                        PC04  43
intdata:(WANT,[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,$#    PC04  44
    21,22,23])#                                                         PC04  45
INTEGER POINT(incr:(stepdc:))#                                          PC04  46
datastuff:#                                                             PC04  47
DATA KEYP/stepdc:,stepdc:,stepdc:,0/#                                   PC04  48
DATA POINT /incr:(stepdc:)*0/#                                          PC04  49
#                                                                       PC04  50
defineproc:(INDICT)#                   Read lr lrdict:                  PC04  51
defineproc:(OUTDICT)#                  Write lr lrdict: to bdf(out)     PC04  52
defineproc:(HAVERES)#                                                   PC04  53
defineproc:(CHECKRES)#                 Check which residues not pre     PC04  54
#                                                                       PC04  55
#   DECIDE IF INPUT OR OUTPUT PROCEDURE WANTED                          PC04  56
#                                                                       PC04  57
##############################                                          PC04  58
IF(SIZE > mxchwd:) iquit:(PC0401)#     Routine excepts 4 char./rea      PC04  59
IF(INOUT==0)#                          Read lr lrdict: and set up p     PC04  60
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC04  61
xeq:(INDICT)#                                                           PC04  62
xeq:(HAVERES)#                                                          PC04  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC04  64
IF(INOUT==1)#                          Write lr lrdict: to bdf(out)     PC04  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC04  66
xeq:(CHECKRES)#                                                         PC04  67
xeq:(OUTDICT)#                                                          PC04  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC04  69
RETURN#                                                                 PC04  70
#########################                                               PC04  71
#                                                                       PC04  72
#                                                                       PC04  73
#                                                                       PC04  74
#########################                                               PC04  75
procedure:(INDICT)#                                                     PC04  76
#########################                                               PC04  77
#                                                                       PC04  78
copyfile:(1,NEIFIL,incr:(lrsequ:),decr:(lrdict:))#                      PC04  79
#                                                                       PC04  80
STARDC=STOPQX#                         Set start of directory secti     PC04  81
STEPDC=stepdc:#                        Set step to currently wanted     PC04  82
STOPDC=STARDC#                                                          PC04  83
#                                                                       PC04  84
# GET DIRECTORY OF LR LRDICT:                                           PC04  85
#                                                                       PC04  86
NDICT=0#                                                                PC04  87
indexpkt:(1,lrdict:,PSIZE,IPTI,0,KEYP,WANT,POINT)#                      PC04  88
IF(KEYP(4) < STEPDC)#                                                   PC04  89
writeline:(1,MSG1,NMSG1,3,3)#          Print informative message        PC04  90
IF(KEYP(4) < 1)   RETURN#              No dictionary on bdf (in)        PC04  91
REPEAT#                                Read the dictionary informat     PC04  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC04  93
readwpkt:(1,lrdict:,PSIZE,IPTI,0)#                                      PC04  94
IF( IPTI <=0) BREAK#                                                    PC04  95
DO I=1,STEPDC#                         Store the info in dictionary     PC04  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC04  97
K=STOPDC+I#                                                             PC04  98
IF(POINT(I)==no:)#                     Check if info present            PC04  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC04 100
QX(K)=voidflg:#                        Set this word as not there       PC04 101
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC04 102
ELSE#                                                                   PC04 103
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PC04 104
J=IPTI+POINT(I)#                       Set pointer to data              PC04 105
QX(K)=QX(J)#                           Transfer bdf info to qx          PC04 106
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PC04 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC04 108
STOPDC=STOPDC+STEPDC#                                                   PC04 109
NDICT=NDICT+1#                                                          PC04 110
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC04 111
STOPQX=STOPDC#                         Set current end of qx array      PC04 112
#                                                                       PC04 113
endproc:(INDICT)#                                                       PC04 114
#                                                                       PC04 115
#                                                                       PC04 116
#                                                                       PC04 117
#########################                                               PC04 118
procedure:(OUTDICT)#                                                    PC04 119
#########################                                               PC04 120
#                                                                       PC04 121
#   WRITE LR LRDICT: TO BDF(OUT)                                        PC04 122
#                                                                       PC04 123
writepkt:(NEIFIL,lrdict:,STEPDC,IPTO)# Write directory packet           PC04 124
DO I=1, STEPDC#                                                         PC04 125
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PC04 126
QX(IPTO+I)=FLOAT(WANT(I))#                                              PC04 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PC04 128
K=STARDC+1#                                                             PC04 129
DO I=1,NDICT#                          Write out dictionary in orde     PC04 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PC04 131
writepkt:(NEIFIL,lrdict:,STEPDC,IPTO)#                                  PC04 132
movereal:(QX(K),1,QX(IPTO+1),1,STEPDC,0)#                               PC04 133
K=K+STEPDC#                                                             PC04 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PC04 135
#                                                                       PC04 136
endproc:(OUTDICT)#                                                      PC04 137
#                                                                       PC04 138
#                                                                       PC04 139
#                                                                       PC04 140
########################                                                PC04 141
procedure:(HAVERES)#                                                    PC04 142
#######################                                                 PC04 143
#                                                                       PC04 144
TYPRES=0#                                                               PC04 145
IF(NDICT > 0)#                         Set up pointers to residues      PC04 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PC04 147
K=1#                                   Initial temporary pointers       PC04 148
TYPRES=1  ; IATM=1#                                                     PC04 149
DICTPT(1)=0#                           Set pointer for first residu     PC04 150
J=STARDC+1#                                                             PC04 151
movertoc:(QX(J),1,RESHAV,K,SIZE,0)#    Move first residue name          PC04 152
FOR (I=STARDC+STEPDC+1; I<STOPDC; I=I+STEPDC)#                          PC04 153
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PC04 154
IF(QX(I)!=QX(J))#                      Found new residue                PC04 155
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PC04 156
TYPRES=TYPRES+1#                                                        PC04 157
DICTPT(TYPRES)=DICTPT(TYPRES-1)+IATM#  Set pointer to new residue       PC04 158
IATM=1#                                Reset number of atoms in cur     PC04 159
K=K+SIZE#                                                               PC04 160
J=I#                                   Set pointer to new residue n     PC04 161
movertoc:(QX(I),1,RESHAV,K,SIZE,0)#    Move new residue name to lis     PC04 162
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PC04 163
ELSE#                                                                   PC04 164
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PC04 165
IATM=IATM+1#                           Incr number of atoms in curr     PC04 166
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PC04 167
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PC04 168
DICTPT(TYPRES+1)=DICTPT(TYPRES)+IATM#  Store pointer for last atom      PC04 169
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PC04 170
#                                                                       PC04 171
endproc:(HAVERES)#                                                      PC04 172
#                                                                       PC04 173
#                                                                       PC04 174
#                                                                       PC04 175
#########################                                               PC04 176
procedure:(CHECKRES)#                                                   PC04 177
#########################                                               PC04 178
#                                                                       PC04 179
NORES=0#                               Init number of res. not in d     PC04 180
KRES=TYPRES*SIZE#                      Number of characters in resh     PC04 181
#                                                                       PC04 182
FOR (I=STARSQ+1; I<=STOPSQ; I=I+STEPSQ)# Look at sequence               PC04 183
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PC04 184
movertoc:(QX(I),1,RES,1,SIZE,0)#       Get sequ. name                   PC04 185
compchar:(RES,1,RESHAV,1,SIZE,SIZE,KRES,KEY)# Check against have arra   PC04 186
IF(KEY==0)#                            Residue not in table             PC04 187
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PC04 188
movechar:(RES,1,MSG2,35,SIZE,0)#       Set message                      PC04 189
writeline:(0,MSG2,NMSG2,3,3)#                                           PC04 190
K=SIZE*NORES+1#                        Set up place to store name       PC04 191
NORES=NORES+1#                         Incr number not found            PC04 192
movechar:(RES,1,RESMIS,K,SIZE,0)#                                       PC04 193
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PC04 194
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PC04 195
# LIST ENTRIES IN DICTIONARY                                            PC04 196
I=1#                                                                    PC04 197
J=TYPRES*SIZE#                         Compute total number of char     PC04 198
LINRM=TYPRES/10+3#                     Check on remaining lines         PC04 199
writeline:(1,DICT1,NDICT1,3,3)#                                         PC04 200
WHILE (I <=J)#                                                          PC04 201
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PC04 202
K=2#                                   Start in col. 2                  PC04 203
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   PC04 204
REPEAT#                                Do ten residues at a time        PC04 205
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PC04 206
movechar:(RESHAV,I,CHROT,K,SIZE,0)#    Move residue name                PC04 207
K=K+10#                                                                 PC04 208
I=I+SIZE#                                                               PC04 209
IF(K >=102 \ I >=J) BREAK#             Do ten times or end of list      PC04 210
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PC04 211
writeline:(0,0,0,1,3)#                                                  PC04 212
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PC04 213
#                                                                       PC04 214
# LIST DICTIONARY AT PRIORITY 4                                         PC04 215
#                                                                       PC04 216
IF(PPRIOR > 3)#                                                         PC04 217
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PC04 218
ATM=0#                                                                  PC04 219
writeline:(1,DICT4,NDICT4,3,4)#                                         PC04 220
writeline:(0,DICT5,NDICT5,3,4)#                                         PC04 221
writeline:(0,DICT6,NDICT6,3,4)#                                         PC04 222
writeline:(0,DICT7,NDICT7,3,4)#                                         PC04 223
writeline:(0,DICT8,NDICT8,3,4)#                                         PC04 224
writeline:(0,DICT9,NDICT9,3,4)#                                         PC04 225
writeline:(0,DICTA,NDICTA,3,4)#                                         PC04 226
DO I=1,TYPRES#                                                          PC04 227
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PC04 228
J=DICTPT(I)*STEPDC+STARDC+1#           Start of i th. residue           PC04 229
K=DICTPT(I+1)*STEPDC+STARDC#           Stop of i th. residue            PC04 230
LINRM=5#                                                                PC04 231
movertoc:(QX(J),1,DICT2,11,SIZE,0)#    Get residue name                 PC04 232
writeline:(1,DICT2,NDICT2,3,4)#                                         PC04 233
#WRITELINE:(0,DICT3,NDICT3,3,4)                                         PC04 234
WHILE (J<=K)#                          List indiv. atom data            PC04 235
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PC04 236
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   PC04 237
ATM=ATM+1.#                                                             PC04 238
ncodefld:(ATM,1,CHROT,40313.,1)#                                        PC04 239
ICOL=6#                                Set-up column                    PC04 240
DO IDATA=1,3#                          Move atom names                  PC04 241
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PC04 242
J=J+1#                                                                  PC04 243
movertoc:(QX(J),1,CHROT,ICOL,SIZE,0)#                                   PC04 244
ICOL=ICOL+5#                           Set-up next column               PC04 245
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PC04 246
DO IDATA=1,19#                         Encode next 19 words of qx       PC04 247
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PC04 248
J=J+1#                                                                  PC04 249
ifnv:(QX(J)) ncodefld:(QX(J),1,CHROT,FMT(IDATA),1)#                     PC04 250
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PC04 251
writeline:(0,0,0,1,4)#                                                  PC04 252
J=J+1#                                                                  PC04 253
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PC04 254
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PC04 255
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PC04 256
#                                                                       PC04 257
endproc:(CHECKRES)#                                                     PC04 258
#                                                                       PC04 259
#                                                                       PC04 260
END#                                                                    PC04 261
systemheader:(PC10)#                                                    PC10   1
####################################################################### PC10   2
# SUBROUTINE TO READ SEQUENCE ENTRIES OFF INPUT STREAM.                 PC10   3
# THIS WRITES OVER ANY SEQUENCE INFORMATION OBTAINED BY READING         PC10   4
#    THE BINARY DATA FILE, SO BEWARE.                                   PC10   5
# THE SEQUENCE NAME (THREE LETTER CODE) AND SEQUENCE NUMBER             PC10   6
#    IDENTIFIER ARE STORED AS CHARACTERS IN THE QX ARRAY,               PC10   7
#    STARTING AT STARSQ IN STEPS OF STEPSQ TO STOPSQ.                   PC10   8
# NSEQU IS THE NUMBER OF SEQUENCE ENTRIES.                              PC10   9
#                                                                       PC10  10
SUBROUTINE PC10#                                                        PC10  11
include:(AACOMN)#                                                       PC10  12
include:(PCCOMN)#                                                       PC10  13
chardata:(X001, SEQU   ENDSEQ   )#                                      PC10  14
string:(SEQNAM,16)#                    Set up areas for fiddling wi     PC10  15
string:(SEQNAM1,16)#                   Another fiddling area.           PC10  16
datastuff:#                                                             PC10  17
NSEQU=0#                               Reinitialize the number of r     PC10  18
STOPSQ=STARSQ#                         Going to write over any old      PC10  19
REPEAT#                                Read input lines                 PC10  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC10  21
readline:(X001,NX001)#                 Actually read the input line     PC10  22
IF(LINID==2) BREAK#                    End of input seqence, so go      PC10  23
IFLD=1#                                Set field count                  PC10  24
REPEAT#                                Now process fields on input      PC10  25
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC10  26
ifvo:(BUFIN(IFLD)) BREAK#              Hit first null field, so do      PC10  27
NSEQU=NSEQU+1#                         Increment sequence number        PC10  28
CALL PC11(IFLD,SEQNAM,NSEQU)#          Move characters to seqnam fr     PC10  29
movector:(SEQNAM,1,QX(STOPSQ+1),1,16,0)# Move residue name to array     PC10  30
STOPSQ=STOPSQ+STEPSQ#                  Increment pointer to qx          PC10  31
IFLD=IFLD+1#                           Increment field count            PC10  32
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC10  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC10  34
# NOW OUTPUT THE SEQUENCE ON THE BINARY DATA FILE.                      PC10  35
# CHECK QX ARRAY TO SEE IF THE PROPER STUFF IS BEING PLACED THERE       PC10  36
I=1#                                                                    PC10  37
DO J=1,NSEQU#                                                           PC10  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC10  39
movertoc:(QX(STARSQ+1),I,SEQNAM1,1,16,0)#                               PC10  40
I=I+16#                                                                 PC10  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC10  42
RETURN#                                                                 PC10  43
END#                                                                    PC10  44
systemheader:(PC11)#                                                    PC11   1
####################################################################### PC11   2
SUBROUTINE PC11(IFLD,SEQNAM,NSEQU)#                                     PC11   3
include:(AACOMN)#                                                       PC11   4
# MOVES CHARACTERS FROM THE IFLD-TH FIELD TO SEQNAM.                    PC11   5
# CHECKS TO SEE IF SOME RESIDUE NUMBER HAS BEEN READ AND IF SO,         PC11   6
#   THIS MOVES IT TO START IN COLUMN 5.                                 PC11   7
# IF NOT, IT ENCODES THE SEQUENCE NUMBER IN COLUMN 5.                   PC11   8
string:(SEQNAM  ,16)#                                                   PC11   9
string:(DUMM    ,16)#                                                   PC11  10
DATA RFMT/0080803./#                                                    PC11  11
stringlim:(IFLD,IFLDS,IFLDN)#          Pull off limits of field, if     PC11  12
# IFLDN=START OF NEXT FIELD                                             PC11  13
movechar:(BLANK,1,SEQNAM,1,16,1)#      Initialize seqnam to blanks      PC11  14
movechar:(CHRIN,IFLDS,SEQNAM,1,IFLDN-IFLDS,0)# Move field to seqnam     PC11  15
compchar:(BLANK,1,SEQNAM,1,1,1,16,IB1)# Search for first blank          PC11  16
# SEARCH FOR FIRST NON-BLANK CHARACTER                                  PC11  17
J=IB1+1#                               Set pointer for start of sea     PC11  18
REPEAT#                                                                 PC11  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC11  20
IF(J>16) BREAK#                        Only 8 characters to check       PC11  21
compchar:(SEQNAM,J,BLANK,1,1,1,1,KEY)# If non-blank(1), get out         PC11  22
IF(KEY==0) BREAK#                                                       PC11  23
J=J+1#                                 Increment index                  PC11  24
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC11  25
movechar:(BLANK,1,DUMM,1,16,1)#        Blank out dumm.                  PC11  26
IF(J<=16) movechar:(SEQNAM,J,DUMM,1,17-J,0)# Move residue number        PC11  27
#                                      From seqnam to dumm              PC11  28
IF(J<=16)#                                                              PC11  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC11  30
DO K=IB1,16#                                                            PC11  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC11  32
movechar:(BLANK,1,SEQNAM,K,1,0)#                                        PC11  33
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC11  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC11  35
IF(J>16)#                                                               PC11  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC11  37
RSEQU=NSEQU#                                                            PC11  38
ncodefld:(RSEQU,1,DUMM,RFMT,1)#                                         PC11  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC11  40
CALL PC12(DUMM,16,BLANK)#              Cram characters to left          PC11  41
movechar:(DUMM,1,SEQNAM,5,4,0)#        Move dumm to seqnam              PC11  42
RETURN#                                                                 PC11  43
END#                                                                    PC11  44
systemheader:(PC12)#                                                    PC12   1
####################################################################### PC12   2
SUBROUTINE PC12(STRING,LENGTH,CHAR)#                                    PC12   3
# CONDENSES A STRING TO THE LOWER INDEX END, DELETING CHAR.             PC12   4
# THE REST OF THE STRING IS FILLED WITH BLANKS                          PC12   5
include:(AACOMN)#                                                       PC12   6
INTEGER LENGTH#                                                         PC12   7
string:(STRING,1)#                                                      PC12   8
string:(CHAR,1)#                                                        PC12   9
I=1#                                                                    PC12  10
DO J=1,LENGTH#                                                          PC12  11
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC12  12
compchar:(STRING,J,CHAR,1,1,1,1,KEY)#                                   PC12  13
IF(KEY==0)#                                                             PC12  14
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC12  15
movechar:(STRING,J,STRING,I,1,0)#                                       PC12  16
I=I+1#                                                                  PC12  17
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC12  18
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC12  19
IF(I>LENGTH) RETURN#                                                    PC12  20
DO J=I,LENGTH#                                                          PC12  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC12  22
movechar:(BLANK,1,STRING,J,1,0)#                                        PC12  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC12  24
RETURN#                                                                 PC12  25
END#                                                                    PC12  26
systemheader:(PC13)#                                                    PC13   1
####################################################################### PC13   2
SUBROUTINE PC13(I,RNAME)#                                               PC13   3
# FIND RESIDUE NAME AND CHAIN NAME FOR A FIELD ON INPUT LINE            PC13   4
# CREATE RESIDUE NAME WITH CHAR 1-5 AS RESIDUE NUMBER AND INSERTION     PC13   5
# NAME (RIGHT JUSTIFIED) AND CHAIN NAME IN CHAR 6-8 (RIGHT JUSTIFIED)   PC13   6
include:(AACOMN)#                                                       PC13   7
string:(RNAME,8)#                                                       PC13   8
chardata:(PC13A,RESCHN A)#                                              PC13   9
datastuff:#                                                             PC13  10
stringlim:(I,N1,N2)#                                                    PC13  11
movechar:(BLANK,1,RNAME,1,8,1)#                                         PC13  12
IF(N1==0)#                             Real number found                PC13  13
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC13  14
ncodefld:(BUFIN(I),1,RNAME,50503.,1)#                                   PC13  15
movechar:(PC13A,8,RNAME,8,1,1)#                                         PC13  16
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC13  17
ELSE#                                                                   PC13  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC13  19
NSIZE=N2-N1#                                                            PC13  20
KEY=0#                                                                  PC13  21
IF(CHRIN(N1^N1+2)==PC13A(1^3)) KEY=1#                                   PC13  22
IF(KEY==1)#                            Res number preceded by res       PC13  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC13  24
N1=N1+3#                                                                PC13  25
NSIZE=NSIZE-3#                                                          PC13  26
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC13  27
movechar:(CHRIN,N1,RNAME,6-NSIZE,NSIZE,0)#                              PC13  28
IF(KEY==1)#                            Go look chain name               PC13  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC13  30
stringlim:(I+1,N1,N2)#                                                  PC13  31
NSIZE=N2-N1#                                                            PC13  32
KEY=0#                                                                  PC13  33
IF(CHRIN(N1^N1+2)==PC13A(4^6)) KEY=1#                                   PC13  34
IF(KEY==1)#                            Chain name found                 PC13  35
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC13  36
I=I+1#                                 Increment pointer for callin     PC13  37
#                                      # Program's sake                 PC13  38
N1=N1+3#                                                                PC13  39
NSIZE=NSIZE-3#                                                          PC13  40
movechar:(CHRIN,N1,RNAME,9-NSIZE,NSIZE,0)#                              PC13  41
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC13  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC13  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC13  44
RETURN#                                                                 PC13  45
END#                                                                    PC13  46
systemheader:(PC14)#                                                    PC14   1
####################################################################### PC14   2
SUBROUTINE PC14(IRES,RNAME)#                                            PC14   3
# FIND RESIDUE NAME AND CHAIN NAME FOR A FIELD ON INPUT LINE            PC14   4
include:(AACOMN)#                                                       PC14   5
include:(PCCOMN)#                                                       PC14   6
INTEGER FOUND#                                                          PC14   7
string:(RNAME,8)#                                                       PC14   8
string:(RESN,8)#                                                        PC14   9
chardata:(ZERO,0)#                                                      PC14  10
datastuff:#                                                             PC14  11
#                                                                       PC14  12
FOUND=no:#                                                              PC14  13
IPSEQ=STARSQ+1#                        Pointer to ascii residue num     PC14  14
FOR( I=1; I<=NSEQU; I=I+1)#                                             PC14  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC14  16
movechar:(BLANK,1,RESN,1,8,1)#                                          PC14  17
movertoc:(QX(IPSEQ),5,RESN,1,5,0)#     Move res number and insert       PC14  18
compchar:(RESN,5,BLANK,1,1,1,1,KEY)#                                    PC14  19
IF(KEY==1)#                            Blank found                      PC14  20
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC14  21
DO J=1,4#                              Move residue number right        PC14  22
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC14  23
movechar:(RESN,5-J,RESN,6-J,1,1,0)#                                     PC14  24
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC14  25
movechar:(BLANK,1,RESN,1,1,0)#                                          PC14  26
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC14  27
movertoc:(QX(IPSEQ),14,RESN,6,3,0)#    Get chain name                   PC14  28
compchar:(RESN,8,BLANK,1,1,1,1,KEY)#   Right justify chain              PC14  29
compchar:(RESN,7,BLANK,1,1,1,1,KEY2)#  Right justify chain              PC14  30
compchar:(RESN,6,BLANK,1,1,1,1,KEY3)#  Right justify chain              PC14  31
IF((KEY+KEY2+KEY3)==0)#                Blank chain name                 PC14  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC14  33
movechar:(ZERO,1,RESN,8,1,0)#                                           PC14  34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC14  35
ELSE IF((KEY+KEY2)==2)#                Two blanks found                 PC14  36
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC14  37
movechar:(RESN,6,RESN,8,1,0)#                                           PC14  38
movechar:(BLANK,1,RESN,6,1,0)#                                          PC14  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC14  40
ELSE IF(KEY==1)#                       One blank found                  PC14  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PC14  42
DO J=1,2#                              Move residue number right        PC14  43
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PC14  44
movechar:(RESN,8-J,RESN,9-J,1,1,0)#                                     PC14  45
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PC14  46
movechar:(BLANK,1,RESN,6,1,0)#                                          PC14  47
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PC14  48
compchar:(RNAME,1,RESN,1,8,8,8,KEY)#                                    PC14  49
IPSEQ=IPSEQ+STEPSQ#                                                     PC14  50
IF( KEY!=0 )#                          Hurray                           PC14  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PC14  52
FOUND=yes:#                                                             PC14  53
IRES=I#                                                                 PC14  54
BREAK#                                                                  PC14  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PC14  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC14  57
IF(FOUND==no:) iquit:(-PC1401)#        Didn't find it                   PC14  58
RETURN#                                                                 PC14  59
END#                                                                    PC14  60
systemheader:(PC20)#                                                    PC20   1
####################################################################### PC20   2
SUBROUTINE PC20#                                                        PC20   3
#                                                                       PC20   4
#   SUBROUTINE FOR HANDLING DICTIONARY INPUT TO PRECED  (PC20)          PC20   5
#   REVISED JAN-1990, KDW                                               PC20   6
#                                                                       PC20   7
include:(AACOMN)#                                                       PC20   8
include:(PCCOMN)#                                                       PC20   9
#                                                                       PC20  10
# PC20 SPECIFIC MACROS                                                  PC20  11
macro:(resnam:,QX($1))#                Real representation of resid     PC20  12
macro:(atnam:,QX($1+1))#               Same for atom name (4chrs)       PC20  13
macro:(bch:,QX($1+2 ))#                Backchain name (stored as real   PC20  14
macro:(fch:,QX($1+3 ))#                Forward chain name (stored as    PC20  15
macro:(movechrs:,[$(stringlim:($1,IP1,IP2);NCH=IP2-IP1;#                PC20  16
movector:(CHRIN,IP1,$2,1,NCH,0)$)])#                                    PC20  17
#                                                                       PC20  18
##############                                                          PC20  19
# STRUCTURE OF DICTIONARY ENTRY IN QX ARRAY WILL BE AS FOLLOWS:         PC20  20
#                                                                       PC20  21
#QX(IP+1)=RESNAM                                                        PC20  22
#    +2 =ATNAM                                                          PC20  23
#    +3 =BCH                                                            PC20  24
#    +4 =FCH                                                            PC20  25
#    +5 =GROUP KEY                                                      PC20  26
#    +6 =ROTATIONAL ANGLE ENERGY VALUE                                  PC20  27
#    +7 =NUMBER OF ROTATIONAL BARRIERS                                  PC20  28
#    +8 =ANGLE MINIMUM                                                  PC20  29
#    +9 =LENGTH                                                         PC20  30
#   +10 =ANGLE                                                          PC20  31
#   +11 =DIHEDRAL ANGLE                                                 PC20  32
#   +12 =ENERGY ASSOCIATED WITH ROTATION ABOUT BOND                     PC20  33
#   +13 =  "        "        "  ANGLE DISTORTION                        PC20  34
#   +14 =  "        "        "  DIHERAL DISTORTION                      PC20  35
#   +15 =  "        "        "  SECOND DIHEDRAL DISTORTION              PC20  36
#   +16 =VALUE OF SECOND DIHEDRAL ANGLE                                 PC20  37
#   +17 =LENNARD-JONES COEFFICIENT  A                                   PC20  38
#   +18 =  "       "       "        B                                   PC20  39
#   +19 =  "       "       "        C                                   PC20  40
#   +20 =SPECIAL POTENTIAL KEY                                          PC20  41
#   +21 =LENNARD-JONES COEF A FOR 1-4 INTERACTIONS                      PC20  42
#   +22 =LENNARD-JONES COEF B FOR 1-4 INTERACTIONS                      PC20  43
#   +23 =MASS OF ATOM OR PSEUDO ATOM                                    PC20  44
#############                                                           PC20  45
INTEGER IP1,IP2,NCH#                   Pointers used in stringlim:      PC20  46
INTEGER IRES,NRES#                     Residue number, total number     PC20  47
INTEGER IATM,NATM#                     Atom number, total number of     PC20  48
INTEGER INSTRM#                        Read from input stream           PC20  49
INTEGER LIBR#                          Read from standard library       PC20  50
INTEGER NATRES#                        Number of atoms per residue      PC20  51
INTEGER NED,NEDKEY#                    Number of chars in reshav,re     PC20  52
#                                      And flag which is nonzero if r   PC20  53
#                                      Needed                           PC20  54
#                                                                       PC20  55
#                                                                       PC20  56
string:(OLDRES,4)#                                                      PC20  57
string:(RES,4)#                        Place to dump charactername      PC20  58
string:(ATM,4)#                        Place to dump atom name temp     PC20  59
string:(RESNED,arith:(4,*,mxres:))#                                     PC20  60
#                                      List of residues needed, const   PC20  61
string:(ATNTEM,arith:(4,*,mxres:))#                                     PC20  62
#                                      Short list of atom names withi   PC20  63
#                                      Overdimensioned....              PC20  64
#                                                                       PC20  65
#DEFINE ARRAYS, ETC.                                                    PC20  66
###############                                                         PC20  67
#SET UP TABLE FOR PROGRAM DIRECTIVES                                    PC20  68
chardata:(PCX20, ENDICT TRELTR TRECAL )#                                PC20  69
chardata:(OPTNS, DEL NOD )#                                             PC20  70
chardata:(PCX22, H )#                                                   PC20  71
chardata:(MSG1,[ IF PRESENT, DICTIONARY WILL BE DELETED FROM BDF])#     PC20  72
chardata:(MSG3, NO ENTRIES IN DICTIONARY AFTER SETDIC )#                PC20  73
chardata:(MSG4, ENTRIES MAY BE INCLUDED FROM STANDARD DICTIONARY)#      PC20  74
chardata:(MSG5, NO STANDARD DICTIONARY WILL BE USED)#                   PC20  75
chardata:(TERM,NTR CTR NPR )#                                           PC20  76
#                                                                       PC20  77
intdata:(ORDER1,[5,9,10,11,16,7,8])#   Order of fields to stuff tre     PC20  78
intdata:(ORDER2,[12,13,14,15,6,17,18,19,21,22,20,23])# Order of field   PC20  79
datastuff:#                                                             PC20  80
#                                                 #  Trecal data        PC20  81
#   #DEFINE PROCEDURES TO BE USED IN PC20                               PC20  82
defineproc:(INIT)#                                                      PC20  83
defineproc:(NEDRES)#                                                    PC20  84
defineproc:(RESFIND)#                                                   PC20  85
defineproc:(ATFIN)#                                                     PC20  86
defineproc:(ATLOC)#                                                     PC20  87
defineproc:(STORLTR)#                                                   PC20  88
defineproc:(STORCAL)#                                                   PC20  89
defineproc:(ENDICT)#                                                    PC20  90
#                                                                       PC20  91
###########   START PROGRAM CONTROL                                     PC20  92
#                                                                       PC20  93
xeq:(INIT)#                            Initialize scratch areas         PC20  94
xeq:(NEDRES)#                          Establish table of needed re     PC20  95
##########                                                              PC20  96
REPEAT#                                Start main program loop          PC20  97
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC20  98
readline:(PCX20,NPCX20)#               Start reading input              PC20  99
###########                                                             PC20 100
IF(LINID==2)#                          Treltr instruction               PC20 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC20 102
xeq:(RESFIND)#                         Check if residue is new          PC20 103
IF(NEDKEY !=0)#                        If residue is not to be skip     PC20 104
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC20 105
xeq:(ATFIN)#                           Get pointer for atom             PC20 106
xeq:(STORLTR)#                         Store bond,angle,torsion inf     PC20 107
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC20 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC20 109
###########                                                             PC20 110
ELSE IF(LINID==3)#                     Trecal instruction               PC20 111
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC20 112
xeq:(RESFIND)#                         Find residue name and pointe     PC20 113
IF(NEDKEY !=0)#                        Residue is not to be skipped     PC20 114
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PC20 115
xeq:(ATFIN)#                           Find atom name and pointers      PC20 116
xeq:(STORCAL)#                         Store away energy data           PC20 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PC20 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC20 119
###########                                                             PC20 120
ELSE IF(LINID <=1)#                    Endict instruction               PC20 121
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PC20 122
IF(LIBR==yes: & INSTRM==yes:)#         Set up to read library           PC20 123
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PC20 124
INSTRM=no:#                                                             PC20 125
openfmt:(iofm1:,prodict:)#             Open the protein dictionary      PC20 126
IOIN2=ioinp:; ioinp:=iofm1:#           Insert file into line stream     PC20 127
NEXT#                                                                   PC20 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PC20 129
IF(LIBR==yes:)#                                                         PC20 130
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PC20 131
ioinp:=IOIN2#                                                           PC20 132
closefmt:(iofm1:)#                                                      PC20 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PC20 134
xeq:(ENDICT)#                          Check for missing residues       PC20 135
RETURN#                                                                 PC20 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PC20 137
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC20 138
############                                                            PC20 139
### END OF PROGRAM CONTROL                                              PC20 140
############                                                            PC20 141
procedure:(INIT)#                                                       PC20 142
INSTRM=yes:#                           Read from input stream first     PC20 143
LIBR=yes:#                             Default read from library al     PC20 144
movechar:(BLANK,1,OLDRES,1,4,0)#                                        PC20 145
J=1#                                   Location of first option         PC20 146
DO I=1,2#                                                               PC20 147
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PC20 148
compchar:(OPTNS,J,CHRIN,1,4,1,mxchim:,KEY)#                             PC20 149
J=J+4#                                 Location of next option          PC20 150
IF(KEY==0) NEXT#                                                        PC20 151
IF(I==1)#                              Delete dictionary                PC20 152
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PC20 153
STOPDC=STARDC#                                                          PC20 154
STOPQX=STOPDC#                                                          PC20 155
TYPRES=0#                                                               PC20 156
NDICT=0#                                                                PC20 157
writeline:(1,MSG1,NMSG1,3,3)#          Print informative message        PC20 158
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PC20 159
IF(I==2)#                              No standard library wanted       PC20 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PC20 161
LIBR=no:#                                                               PC20 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PC20 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PC20 164
IF(LIBR==yes:)writeline:(1,MSG4,NMSG4,3,3)#                             PC20 165
ELSE writeline:(1,MSG5,NMSG5,3,3)#                                      PC20 166
IF(NDICT==0)#                          If bdf had no entries            PC20 167
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PC20 168
STARDC=STOPQX#                                                          PC20 169
STOPDC=STARDC#                                                          PC20 170
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PC20 171
IP2=STOPDC+1#                                                           PC20 172
QX(IP2)=voidflg:#                                                       PC20 173
movereal:(QX,IP2,QX,IP2,arith:(stepdc:,*,mxdatms:),2)#                  PC20 174
#                                      Blank out character parts of q   PC20 175
FOR (I=1; I<=mxdatms:; I=I+1)#                                          PC20 176
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PC20 177
movector:(BLANK,1,QX(IP2),1,16,1)#                                      PC20 178
IP2=IP2+STEPDC#                                                         PC20 179
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PC20 180
movechar:(BLANK,1,ATNTEM,1,4*mxres:,1)#                                 PC20 181
FOR (I=TYPRES+1; I<=mxres:; I=I+1)#                                     PC20 182
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PC20 183
DICTPT(I)=0.#                                                           PC20 184
NATRES=0#                                                               PC20 185
movechar:(BLANK,1,RESHAV,I*4-3,4,1)#                                    PC20 186
#                                      Blank out remaining part of re   PC20 187
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PC20 188
movechar:(BLANK,1,RESNED,1,4*mxres:,1)#                                 PC20 189
#                                      Now, for the rest we need sequ   PC20 190
IF(NSEQU==0) iquit:(PC2001)#                                            PC20 191
STEPDC=stepdc:#                                                         PC20 192
IATM=(STOPDC-STARDC)/STEPDC+1#                                          PC20 193
IF(STOPDC==STARDC) IATM=0#                                              PC20 194
endproc:(INIT)#                                                         PC20 195
###########                                                             PC20 196
procedure:(NEDRES)#                    Establish table of needed re     PC20 197
#         #STORE IN RESNED                                              PC20 198
IP1=STARSQ+1#                          Set pointer to sequence in q     PC20 199
IP2=13#                                                                 PC20 200
NED=12#                                Set initial number of charac     PC20 201
movechar:(TERM,1,RESNED,1,8,0)#        Put in n-term and c-term         PC20 202
movertoc:(QX(IP1),1,RESNED,9,4,0)#     Pc                               PC20 203
#                                      Store away first needed residu   PC20 204
FOR (I=1; I<=NSEQU; I=I+1)#                                             PC20 205
#                                      Scan through entire sequence     PC20 206
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PC20 207
IP1=IP1+STEPSQ#                        Increment qx pointer             PC20 208
movertoc:(QX(IP1),1,RES,1,4,0)#                                         PC20 209
#                                      Temporarily store away charact   PC20 210
compchar:(RES,1,RESNED,1,4,4,NED,KEY)#                                  PC20 211
#                                      See if new name or not           PC20 212
IF(KEY==0 )#                           It is a new name                 PC20 213
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PC20 214
NED=NED+4#                                                              PC20 215
movechar:(RES,1,RESNED,IP2,4,0)#                                        PC20 216
#                                      Store it away                    PC20 217
IP2=IP2+4#                             Increment its pointer            PC20 218
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PC20 219
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PC20 220
endproc:(NEDRES)#                                                       PC20 221
###########                                                             PC20 222
procedure:(RESFIND)#                   Identify residue and store i     PC20 223
stringlim:(1,IP1,IP2)#                 Get pointers to first charac     PC20 224
NCH=IP2-IP1#                                                            PC20 225
compchar:(CHRIN,IP1,OLDRES,1,4,4,4,KEY)#                                PC20 226
IF(KEY==0)#                            Not current residue              PC20 227
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PC20 228
#                                      Check to see if a needed resid   PC20 229
movechar:(BLANK,1,OLDRES,1,4,0)#       Reset current residue name       PC20 230
movechar:(CHRIN,IP1,OLDRES,1,NCH,0)#                                    PC20 231
compchar:(CHRIN,IP1,RESNED,1,4,4,NED,NEDKEY)#                           PC20 232
IF(NEDKEY !=0)#                        This residue is needed           PC20 233
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PC20 234
IF(IRES==0)#                           If this is the first residue     PC20 235
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PC20 236
IRES=1#                                Set up the first pointers        PC20 237
NRES=1#                                                                 PC20 238
DICTPT(IRES)=0#                                                         PC20 239
movechar:(CHRIN,IP1,RESHAV,1,NCH,0)#   Store first residue name         PC20 240
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PC20 241
ELSE#                                  We already have some residue     PC20 242
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PC20 243
compchar:(CHRIN,IP1,RESHAV,1,4,4,NRES*4,KEY)#                           PC20 244
#                                      See if name is already known     PC20 245
IF(KEY==0)#                            No match,must be new             PC20 246
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PC20 247
IRES=IRES+1#                           Increment residue pointer        PC20 248
DICTPT(IRES)=DICTPT(IRES-1)+NATRES#    Set residue pointer              PC20 249
NATRES=0#                                                               PC20 250
movechar:(BLANK,1,ATNTEM,1,4*NATRES,1)#                                 PC20 251
#                                      Clear temporary atomnames        PC20 252
NRES=NRES+1#                           Increment total of residues      PC20 253
movechar:(CHRIN,IP1,RESHAV,4*(IRES-1)+1,NCH,0)#                         PC20 254
#                                      Store residue name in hav        PC20 255
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PC20 256
ELSE#                                  Match is found                   PC20 257
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PC20 258
NEDKEY=0#                              Don't read residue again         PC20 259
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PC20 260
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PC20 261
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PC20 262
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PC20 263
endproc:(RESFIND)#                                                      PC20 264
###########                                                             PC20 265
procedure:(ATFIN)#                     Find atom pointer                PC20 266
stringlim:(2,IP1,IP2)#                 Get pointers to field 2 of i     PC20 267
NCH=IP2-IP1#                                                            PC20 268
xeq:(ATLOC)#                                                            PC20 269
endproc:(ATFIN)#                                                        PC20 270
##########                                                              PC20 271
procedure:(ATLOC)#                                                      PC20 272
IF(IATM==0)#                           For first atom                   PC20 273
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PC20 274
IATM=1#                                                                 PC20 275
NATM=1#                                                                 PC20 276
NATRES=1#                                                               PC20 277
IP3=STOPDC+1#                                                           PC20 278
movector:(BLANK,1,resnam:(IP3),1,16,1)#                                 PC20 279
movechar:(BLANK,1,ATNTEM,1,4,1)#                                        PC20 280
movechar:(CHRIN,IP1,ATNTEM,1,NCH,0)#                                    PC20 281
movector:(CHRIN,IP1,atnam:(IP3),1,NCH,0)# Store permanently             PC20 282
movector:(RESHAV,1,resnam:(IP3),1,4,0)# Store resnam permanently        PC20 283
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PC20 284
movechar:(BLANK,1,ATM,1,4,1)#                                           PC20 285
movechar:(CHRIN,IP1,ATM,1,NCH,0)#                                       PC20 286
compchar:(ATM,1,ATNTEM,1,4,4,4*NATRES,KEY)#                             PC20 287
#                                      See if already in list           PC20 288
IF(KEY==0)#                            If no match is found             PC20 289
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PC20 290
NATRES=NATRES+1#                       Increment no of atoms per re     PC20 291
IATM=IATM+1#                           Increment atom pointer           PC20 292
NATM=NATM+1#                                                            PC20 293
IP2=STARDC+STEPDC*(IATM-1)+1#                                           PC20 294
movechar:(BLANK,1,ATNTEM,4*(NATRES-1)+1,4,1)#                           PC20 295
movechar:(CHRIN,IP1,ATNTEM,4*(NATRES-1)+1,NCH,0)#                       PC20 296
#                                      Store in temporary atom list     PC20 297
movector:(BLANK,1,QX(IP2),1,16,1)#                                      PC20 298
movector:(CHRIN,IP1,atnam:(IP2),1,NCH,0)#                               PC20 299
#                                      Store in permament list          PC20 300
movector:(RESHAV,4*(IRES-1)+1,resnam:(IP2),1,4,0)#                      PC20 301
#                                      Store residue name in permanen   PC20 302
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PC20 303
ELSE#                                  If match is found                PC20 304
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PC20 305
IATM=DICTPT(IRES)+KEY#                 Set atom pointer                 PC20 306
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PC20 307
endproc:(ATLOC)#                                                        PC20 308
###########                                                             PC20 309
procedure:(STORLTR)#                                                    PC20 310
IP3=STEPDC*(IATM-1)+STARDC+1#                                           PC20 311
ifnv:(BUFIN(3)) movechrs:(3,bch:(IP3))# Move field 3 of input to bac    PC20 312
ifnv:(BUFIN(4)) movechrs:(4,fch:(IP3))# Move forward chain              PC20 313
DO I=1,7#                              Move next 7 numeric fields       PC20 314
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PC20 315
J=ORDER1(I)#                                                            PC20 316
movereal:(BUFIN(I+4),1,QX(IP3),J,1,0)# Stuff into proper qx positio     PC20 317
#WRITE (6,1001) (QX(IP3+IXX),IXX=0,3),(QX(IP3+IXX),IXX=4,10)            PC20 318
#1001 FORMAT(1X,4A4,7F8.3)                                              PC20 319
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PC20 320
endproc:(STORLTR)#                                                      PC20 321
###########                                                             PC20 322
procedure:(STORCAL)#                                                    PC20 323
IP3=stepdc:*(IATM-1)+STARDC+1#                                          PC20 324
DO I=1,12#                             For items 12 through 23 in q     PC20 325
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 PC20 326
J=ORDER2(I)#                           Get word to stuff into           PC20 327
movereal:(BUFIN(I+2),1,QX(IP3),J,1,0)# Stuff into proper qx postion     PC20 328
#WRITE (6,1002) (QX(IP3+IXX),IXX=11,22)                                 PC20 329
#WRITE (6                                                               PC20 330
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 PC20 331
endproc:(STORCAL)#                                                      PC20 332
###########                                                             PC20 333
procedure:(ENDICT)#                    Tidy up                          PC20 334
STOPDC=STOPDC+NATM*stepdc:#                                             PC20 335
TYPRES=TYPRES+NRES#                                                     PC20 336
IP1=STARDC+1#                                                           PC20 337
NDICT=IATM#                                                             PC20 338
DICTPT(IRES+1)=IATM#                                                    PC20 339
STOPQX=STOPDC#                         Set current end of qx array      PC20 340
#                                                                       PC20 341
endproc:(ENDICT)#                                                       PC20 342
###########                                                             PC20 343
END#                                                                    PC20 344
systemheader:(PC30)#                                                    PC30   1
######################################################################  PC30   2
SUBROUTINE PC30#                                                        PC30   3
#                                                                       PC30   4
#    SUBROUTINE TO PRODUCE DUMMY ATOMS FOR EVERY ATOM EXPECTED          PC30   5
#    FROM SEQUENCE AND DICTIONARY ENTRIES.                              PC30   6
#                                                                       PC30   7
include:(AACOMN)#                                                       PC30   8
include:(PCCOMN)#                                                       PC30   9
#                                                                       PC30  10
string:(RES,16)#                       Temporary character              PC30  11
string:(NAME,4)#                                                        PC30  12
INTEGER KEYTYP#                        Type of residue                  PC30  13
INTEGER K,J,I,L,KEY,NKEY#              Local variables                  PC30  14
INTEGER ITEM,FIRST,LAST#                                                PC30  15
INTEGER ISEQ#                                                           PC30  16
chardata:(TYPES,NTR CTR CHN HET )#                                      PC30  17
chardata:(RSPEC,PRO NPR )#             Special n-term residues          PC30  18
datastuff:#                                                             PC30  19
#                                                                       PC30  20
defineproc:(MAKEATOMS)#                                                 PC30  21
#                                                                       PC30  22
K=TYPRES*4#                            Number of characters in dict     PC30  23
STARAT=STOPQX ; STOPAT=STOPQX ; STEPAT=stepat:#                         PC30  24
ISEQ=0#                                                                 PC30  25
NUMATM=0#                                                               PC30  26
#                                                                       PC30  27
FOR (I=STARSQ+1 ; I <=STOPSQ ; I=I+STEPSQ)#                             PC30  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC30  29
ISEQ=ISEQ+1#                                                            PC30  30
RESIPT(ISEQ)=NUMATM#                                                    PC30  31
movertoc:(QX(I),1,RES,1,16,0)#                                          PC30  32
compchar:(RES,10,TYPES,1,4,4,16,KEYTYP)# Find residue chain type        PC30  33
IF(KEYTYP==1)#                         N-terminal residue               PC30  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC30  35
compchar:(RES,1,RSPEC,1,4,4,4,NKEY)#   Check if special resiude         PC30  36
IF(NKEY==1) compchar:(RSPEC,5,RESHAV,1,4,4,K,KEY)# N-term proline       PC30  37
ELSE compchar:(TYPES,1,RESHAV,1,4,4,K,KEY)# Find residue in dict        PC30  38
ITEM=DICTPT(KEY)#                      Item number in dictionary        PC30  39
FIRST=DICTPT(KEY)*STEPDC+STARDC+1#                                      PC30  40
LAST=DICTPT(KEY+1)*STEPDC+STARDC#                                       PC30  41
xeq:(MAKEATOMS)#                                                        PC30  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC30  43
compchar:(RES,1,RESHAV,1,4,4,K,KEY)#   Find where residue is in dic     PC30  44
IF(KEY==no:) iquit:(PC3001)#           Somehow missed checking earl     PC30  45
ITEM=DICTPT(KEY)#                      Item number in dictionary        PC30  46
FIRST=DICTPT(KEY)*STEPDC+STARDC+1#                                      PC30  47
IF(KEYTYP==1)#                                                          PC30  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC30  49
ITEM=ITEM+2#                                                            PC30  50
FIRST=FIRST+2*STEPDC#                  Skip n and h atom of residue     PC30  51
IF (NKEY==1)#                                                           PC30  52
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC30  53
FIRST=FIRST-STEPDC#                    Skip n only for proline          PC30  54
ITEM=ITEM-1#                                                            PC30  55
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC30  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC30  57
LAST=DICTPT(KEY+1)*STEPDC+STARDC#                                       PC30  58
xeq:(MAKEATOMS)#                                                        PC30  59
#                                                                       PC30  60
IF(KEYTYP==2)#                         C-terminal residue               PC30  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC30  62
compchar:(TYPES,5,RESHAV,1,4,4,K,KEY)# Find where residue is in dic     PC30  63
ITEM=DICTPT(KEY)#                      Item number in dictionary        PC30  64
FIRST=DICTPT(KEY)*STEPDC+STARDC+1#                                      PC30  65
LAST=DICTPT(KEY+1)*STEPDC+STARDC#                                       PC30  66
STOPAT=STOPAT-2*STEPAT#                Cover up last two atoms          PC30  67
NUMATM=NUMATM-2#                                                        PC30  68
xeq:(MAKEATOMS)#                                                        PC30  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC30  70
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC30  71
RESIPT(ISEQ+1)=NUMATM#                                                  PC30  72
STOPQX=STOPAT#                         Set current end of qx array      PC30  73
RETURN#                                                                 PC30  74
#                                                                       PC30  75
####################################################################### PC30  76
procedure:(MAKEATOMS)#                                                  PC30  77
####################################################################### PC30  78
DO J=FIRST,LAST,STEPDC#                Produce atoms in this residu     PC30  79
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PC30  80
ITEM=ITEM+1#                                                            PC30  81
NUMATM=NUMATM+1#                                                        PC30  82
QX(STOPAT+1)=QX(I+1)#                  Residue number from sequence     PC30  83
QX(STOPAT+3)=QX(J+1)#                  Atom name from dictionary        PC30  84
movechar:(BLANK,1,NAME,1,4,1)#                                          PC30  85
movertoc:(QX(J+1),2,NAME,1,3,0)#       Get remoteness from dict.        PC30  86
movector:(NAME,1,QX(STOPAT+2),1,4,0)#                                   PC30  87
QX(STOPAT+4)=ITEM#                     Dictionary item number           PC30  88
L=STARDC+(ITEM-1)*STEPDC+3#            Move forward and back chain      PC30  89
movereal:(QX(L),1,QX(STOPAT+6),1,2,0)#                                  PC30  90
QX(STOPAT+9)=QX(L+2)#                  Get group key for dict           PC30  91
STOPAT=STOPAT+STEPAT#                                                   PC30  92
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PC30  93
endproc:(MAKEATOMS)#                                                    PC30  94
#                                                                       PC30  95
END#                                                                    PC30  96
systemheader:(PC32)#                   Read atoms from bdf              PC32   1
####################################################################### PC32   2
SUBROUTINE PC32#                       Read atoms from bdf              PC32   3
#                                                                       PC32   4
include:(AACOMN)#                                                       PC32   5
include:(PCCOMN)#                                                       PC32   6
#                                                                       PC32   7
macro:(dumb:,-9)#                      Key for dummy atoms              PC32   8
macro:(nwant:,31)#                     Number of items wanted from      PC32   9
#                                                                       PC32  10
string:(NAME,4)#                                                        PC32  11
INTEGER PSIZE,IPTI,KEY,POINT(arith:(nwant:,+,1))#                       PC32  12
INTEGER KEYP(4)#                       Keys for indexpkt lratom:        PC32  13
INTEGER START,STOP#                                                     PC32  14
INTEGER ISTART,ISTOP#                                                   PC32  15
INTEGER I,J,K,NTIME#                   Temporary  variables             PC32  16
INTEGER INATM#                         Current atom being treated f     PC32  17
#INTEGER NEWATM#                        COUNT OF ATOMS IN DUMMY PLUS    PC32  18
REAL OUTBUF(nwant:)#                   Updated data from bdf            PC32  19
chardata:(OPTNS, ALL ANI CUR DEL)#     Options from atomin input li     PC32  20
chardata:(MSG1, NO ATOMS FOUND ON INPUT BDF)#                           PC32  21
chardata:(MSG2, SKIP ANY ATOMS CURRENTLY STORED ON BDF )#               PC32  22
intdata:(WANT,[16,15,14,210,211,212,213,214,215, $# Residue,atom,dict   PC32  23
1,2,3,101,102,103,11,22,4,18,19,20,5,6,7,8,9,10, $# Coors,temps         PC32  24
301,302,303,23])#                                                       PC32  25
datastuff:#                                                             PC32  26
#                                                                       PC32  27
KEYP(1)=3#                                                              PC32  28
KEYP(2)=nwant:#                                                         PC32  29
KEYP(3)=nwant:#                                                         PC32  30
KEYP(4)=0#                                                              PC32  31
# DEACTIVATE ATOM INPUT LINES                                           PC32  32
#DECODE THE ATOM INPUT LINE                                             PC32  33
#IF(LINID==4)#                       DECODE IF ATOMIN LINE WAS PRES     PC32  34
#$(#                                    >>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1 PC32  35
##                                                                      PC32  36
#J=2#                                 LOCATION OF FIRST OPTION          PC32  37
#DO I=1,4#                              LOOP THRU POSSIBLE OPTIONS      PC32  38
#$(#                                    >>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2 PC32  39
#COMPCHAR:(OPTNS,J,CHRIN,1,3,1,MXCHIM:,KEY)#                            PC32  40
#IF(KEY !=NO:) USE(I)=YES:#         TURN ON OPTION                      PC32  41
#J=J+4#                                                                 PC32  42
#$)#                                    <<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2 PC32  43
#IF(USE(2)==YES:) USE(2)=2#            ANISOTROPIC TEMP                 PC32  44
#ELSE USE(2)=1#                         ISOTROPIC TEMP                  PC32  45
##                                                                      PC32  46
#$)#                                    <<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1 PC32  47
#                                                                       PC32  48
# READ DIRECTORY OF ATOM INFO. FROM BDF                                 PC32  49
#                                                                       PC32  50
MAXWNT=nwant:#                                                          PC32  51
#IF(ANISO==1) MAXWNT=MAXWNT-6#   NO ANISOTROPIC TEMP                    PC32  52
#NEWATM=NUMATM#                                                         PC32  53
#                                                                       PC32  54
INATM=0#                               Number of current atom from      PC32  55
indexpkt:(1,lratom:,PSIZE,IPTI,0,KEYP,WANT,POINT)#                      PC32  56
IF(POINT(1)*POINT(2)==0)#              Then no atom info on file        PC32  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC32  58
writeline:(1,MSG1,NMSG1,3,3)#                                           PC32  59
RETURN#                                                                 PC32  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC32  61
#                                                                       PC32  62
# CHECK ON WHAT INFO. IS ON THE BDF                                     PC32  63
#                                                                       PC32  64
ANISO=2#                               Assume aniso and mixed t.f.      PC32  65
IF(POINT(22)==no:) ANISO=1#            No aniso temp. on bdf            PC32  66
OLDATM=yes:#                                                            PC32  67
IF(POINT(30)==no:) OLDATM=no:#                                          PC32  68
#                                                                       PC32  69
# REALLOCATE QX ARRAY SPACE                                             PC32  70
#                                                                       PC32  71
STARPA=STOPQX#                         Set start of atom parameters     PC32  72
STEPPA=steppa:#                        Number of parameters per ato     PC32  73
#                                      Plus the t.f. type indicator     PC32  74
NUMPARM=NUMATM*STEPPA#                 Number of parameters in arra     PC32  75
STOPPA=STARPA+NUMPARM#                                                  PC32  76
STOPQX=STOPPA#                         Set current end of qx array      PC32  77
movereal:(voidflg:,1,QX(STARPA+1),1,NUMPARM,2)# Initialize array        PC32  78
#                                                                       PC32  79
START=STARAT+1#                        Initialize pointer for name      PC32  80
REPEAT#                                                                 PC32  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC32  82
readwpkt:(1,lratom:,PSIZE,IPTI,0)#                                      PC32  83
IF(IPTI <=0) BREAK#                                                     PC32  84
INATM=INATM+1#                                                          PC32  85
IF(INATM >=maxatms:) iquit:(PC3203)#   Too many atoms wanted            PC32  86
DO I=1,nwant:#                                                          PC32  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC32  88
IF(POINT(I)==no:) OUTBUF(I)=voidflg:#                                   PC32  89
ELSE#                                                                   PC32  90
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC32  91
J=IPTI+POINT(I)#                                                        PC32  92
OUTBUF(I)=QX(J)#                                                        PC32  93
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC32  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC32  95
#                                                                       PC32  96
# CHECK THE INFORMATION FOR THIS ATOM                                   PC32  97
#                                                                       PC32  98
NTIME=0#                                                                PC32  99
STOP=STOPAT#                                                            PC32 100
movertoc:(OUTBUF(1),1,NAME,1,4,0)#     Get sequ number                  PC32 101
compchar:(NAME,4,BLANK,1,1,1,1,KEY)#   Check for blank last char        PC32 102
IF(KEY!=0)#                            Blank last char                  PC32 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC32 104
movector:(BLANK,1,OUTBUF(1),1,4,0)#    Get rid of blank last char       PC32 105
movector:(NAME,1,OUTBUF(1),2,3,0)#                                      PC32 106
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC32 107
movertoc:(OUTBUF(3),1,NAME,1,1,0)#     Get atom type from name 1st      PC32 108
movertoc:(OUTBUF(2),1,NAME,2,3,0)#     Get atom tree info               PC32 109
#                                      For comparison to other atoms    PC32 110
movector:(NAME,1,OUTBUF(3),1,4,0)#                                      PC32 111
# MOVE SEQU NUMBER TO LOW ORDER POSITION SQUEEZING OUT BLANKS           PC32 112
#                                      #                                PC32 113
WHILE (NTIME < 2)#                     Loop thru all atoms              PC32 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PC32 115
FOR (I=START; I<=STOP; I=I+STEPAT)#                                     PC32 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PC32 117
IF(QX(I+7)==dumb:) NEXT#               Dummy atom, don't consider       PC32 118
#IFNE:(OUTBUF(1),QX(I)) NEXT#           NAMES DON'T MATCH               PC32 119
#IFNE:(OUTBUF(2),QX(I+1)) NEXT#        NAMES DON'T MATCH                PC32 120
IF(OUTBUF(1)!=QX(I)) NEXT#             Names don't match                PC32 121
IF(OUTBUF(3)!=QX(I+2)) NEXT#           Names don't match                PC32 122
START=I+STEPAT#                        Set up start for next atom s     PC32 123
I=(I-STARAT+STEPAT)/STEPAT#            Calc. atom number in dummy l     PC32 124
# MOVE PARAMTERS TO QX(STARPA) REGION                                   PC32 125
ISTOP=STARPA+I*STEPPA#                                                  PC32 126
ISTART=ISTOP-STEPPA+1#                                                  PC32 127
K=9#                                                                    PC32 128
DO I=ISTART,ISTOP#                     Transfer parameters              PC32 129
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PC32 130
K=K+1#                                                                  PC32 131
QX(I)=OUTBUF(K)#                                                        PC32 132
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PC32 133
BREAK#                                                                  PC32 134
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PC32 135
ifnv:(OUTBUF(4)) BREAK#                Leave loop if atom found         PC32 136
NTIME=NTIME+1#                         Else try from beginning          PC32 137
STOP=START#                                                             PC32 138
START=STARAT+1#                                                         PC32 139
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PC32 140
#                                                                       PC32 141
# CHECK ON WHAT TO DO WITH ATOMS NOT FOUND IN DICTIONARY                PC32 142
#                                                                       PC32 143
##IF(ALL==yes: & OUTBUF(4)==voidflg:)#                                  PC32 144
##$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>>  PC32 145
##NEWATM=NEWATM+1#                       Put atom in anyway             PC32 146
##iquit:(PC3204)#                        Can't handle extra atoms at    PC32 147
##$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<<  PC32 148
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC32 149
RETURN#                                                                 PC32 150
END#                                                                    PC32 151
systemheader:(PC34)#                   Put out atoms and their link     PC34   1
####################################################################### PC34   2
SUBROUTINE PC34#                       Put out atoms and their link     PC34   3
#                                                                       PC34   4
#   REVISED BY KDW, 16-JUL-1982                                         PC34   5
#                                                                       PC34   6
include:(AACOMN)#                                                       PC34   7
include:(PCCOMN)#                                                       PC34   8
#                                                                       PC34   9
macro:(maxpa:,22)#                     Max. words in steppa             PC34  10
macro:(step:,arith:(stepat:,+,maxpa:))# Max. items for bdf              PC34  11
#                                                                       PC34  12
INTEGER IPTO#                          Pointers for writing bdf         PC34  13
INTEGER PSIZE#                         Output packet size               PC34  14
INTEGER I,K,J,ICOL#                    Local variables                  PC34  15
INTEGER STEP#                          Maximum number of items          PC34  16
#INTEGER WANT(INCR:(STEP:)) # DIRECTORY NUMBERS FOR ITEMS WANTED        PC34  17
INTEGER POINT(arith:(step:,+,2))#      Pointers to what  is wanted      PC34  18
CHARACTER*4 ANAM1,ANAM2,ATMP#                                           PC34  19
chardata:(HEAD1,      =          =  )#                                  PC34  20
chardata:(HEAD2,  NO. ATOM   KD        COORDINATES       OCC.   B)#     PC34  21
#                                                                       PC34  22
realdata:(FMT,[40513.,150413.,230842.,310842.,390842.,450622.,$#        PC34  23
510622.,510622.,570622.,630622.,690622.,750622.])#                      PC34  24
intdata:(SIZE,4)#                      Characters in residue and at     PC34  25
intdata:(WANT,[16,15,14,14,210,211,212,213,214,215, $#                  PC34  26
   1,2,3,101,102,103,11,22,4,18,19,20,5,6,7,8,9,10, $# Coordinates      PC34  27
   301,302,303,23])#                                                    PC34  28
DATA POINT /arith:(step:,+,2)*0/#                                       PC34  29
datastuff:#                                                             PC34  30
#                                                                       PC34  31
#                                                                       PC34  32
#   WRITE LR LRATOM: TO BDF(OUT)                                        PC34  33
#                                                                       PC34  34
# THE FOLLOWING CODE HAS BEEN PATCHED TO TAKE INTO ACCOUNT THAT THE ATO PC34  35
# NAMES ARE TWO REAL WORDS LONG                                         PC34  36
STEP=STEPAT+STEPPA+1#                  Put out number of words in t     PC34  37
PSIZE=STEP#                                                             PC34  38
IF(ANISO==1)#                          Throw away pointers to aniso     PC34  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC34  40
PSIZE=PSIZE-6#                                                          PC34  41
DO I=23,28#                                                             PC34  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC34  43
WANT(I)=0#                                                              PC34  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC34  45
IF(OLDATM==no:)#                       Throw away pointers to old a     PC34  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC34  47
PSIZE=PSIZE-3#                                                          PC34  48
DO I=29,31#                                                             PC34  49
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC34  50
WANT(I)=0#                                                              PC34  51
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC34  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC34  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC34  54
writepkt:(NEIFIL,lratom:,PSIZE,IPTO)#  Write directory packet           PC34  55
J=0#                                                                    PC34  56
DO I=1, STEP#                          Desired directory items in i     PC34  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC34  58
IF(WANT(I)==0) NEXT#                                                    PC34  59
J=J+1#                                                                  PC34  60
QX(IPTO+J)=FLOAT(WANT(I))#                                              PC34  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC34  62
KAT=STARAT+1#                          Pointer for atom name and ke     PC34  63
KPA=STARPA+1#                          Pointer for atom parameters      PC34  64
DO I=1,NUMATM#                         Write out atom info to bdf(o     PC34  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PC34  66
writepkt:(NEIFIL,lratom:,PSIZE,IPTO)#                                   PC34  67
movereal:(QX(KAT),1,QX(IPTO+1),1,1,0)# Move residue number              PC34  68
ifvo:(QX(KPA+8)) QX(KPA+8)=0.2#        Set void tf to real number       PC34  69
ifvo:(QX(KPA+6)) QX(KPA+6)=1.0#        Set pop param.                   PC34  70
#---FILL IN VOID IDS=18,19,20                                           PC34  71
ifvo:(QX(KPA+id18:-1))#                Ensure non-void id 18            PC34  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PC34  73
IF(I==1 )$#                                                             PC34  74
movector:(BLANK,1,QX(KPA+id18:-1),1,3,1)# Same chain                    PC34  75
ELSE $#                                                                 PC34  76
movereal:(QX(KPA+id18:-1+STEPPA),1,QX(KPA+id18:-1),1,1,0)# Same chain   PC34  77
movector:(BLANK,1,QX(KPA+id18:-1),4,1,0)# Blank insertion code          PC34  78
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PC34  79
ifvo:(QX(KPA+id18:))#                  Ensure non-void id 19            PC34  80
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PC34  81
IDICT=STARDC+((IFIX(QX(KAT+3))-1)*STEPDC)+1# Pointer to dictionary      PC34  82
movereal:(QX(IDICT),1,QX(KPA+id18:),1,1,0)# Get res name from diction   PC34  83
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PC34  84
ifvo:(QX(KPA+id18:+1))$#               Ensure non-void id 20            PC34  85
movereal:(0.,1,QX(KPA+id18:+1),1,1,0)# Zero for default serial#         PC34  86
#---CONSTRUCT ATOM NAME TO GO IN ID 14                                  PC34  87
movechar:(BLANK,1,ANAM1,1,4,1)#        Blank first half of atom nam     PC34  88
#                                                                       PC34  89
# PUT RES NUMBER INTO ATOM NAME, PART 1                                 PC34  90
#                                                                       PC34  91
movertoc:(QX(KAT),1,ANAM1,2,4,0)#      Move residue name to part1       PC34  92
DO II=2,4#                                                              PC34  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PC34  94
IF(ANAM1(II^II)==' ') ANAM1(II^II)='0'# Pad res # with 0's              PC34  95
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PC34  96
#                                                                       PC34  97
# PUT ATOM TYPE INFO INTO ATOM NAME, PART 1                             PC34  98
#                                                                       PC34  99
II=STARAT+STEPAT*(I-1)+3#              Get atom name pointer            PC34 100
movertoc:(QX(II),1,ATMP,1,4,0)#        Get residue name                 PC34 101
FOR (J=4;J>0;J=J-1)#                   Get form factor pointer          PC34 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PC34 103
compchar:(ATMP,1,ATYPE,1,J,4,NATYPE*4,KEY)#                             PC34 104
IF(KEY !=0)#                                                            PC34 105
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PC34 106
QX(KPA+7)=FLOAT(KEY)#                                                   PC34 107
KEY=KEY*4-3#                           Point to start of atom type      PC34 108
movechar:(ATYPE,KEY,ATMP,1,4,0)#                                        PC34 109
LEN=1#                                 Determine the length of atom     PC34 110
DO II=2,4#                             Type name                        PC34 111
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PC34 112
IF(ATMP(II^II)!=' ') LEN=LEN+1#                                         PC34 113
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PC34 114
movechar:(ATMP,1,ANAM1,1,LEN,0)#       Move atom type into first pa     PC34 115
BREAK#                                 Of atom name                     PC34 116
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PC34 117
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PC34 118
IF(J==0) iquit:(PC3401)#               Scattering factor type missi     PC34 119
#                                                                       PC34 120
# PUT RES POSITIONAL INFO INTO ATOM NAME, PART 2                        PC34 121
#                                                                       PC34 122
movechar:(BLANK,1,ANAM2,1,4,1)#        Blank second half of atom na     PC34 123
movertoc:(QX(KAT+1),1,ANAM2,2,3,0)#    Move remoteness indicator        PC34 124
#                                                                       PC34 125
# PUT INSERTION CODE INTO ATOM NAME, PART 2                             PC34 126
#                                                                       PC34 127
ifnv:(QX(KPA+id18:-1))$#               Insertion code exist???          PC34 128
movertoc:(QX(KPA+id18:-1),4,ANAM2,1,1,0)# Include insertion code        PC34 129
IF(ANAM2(1^1)==' '&ANAM2(2^4)!='   ')$##                                PC34 130
 ANAM2(1^1)='_'#                       _ in place of blank ins code     PC34 131
#NPART=MOD(I,100)#                      LEAST SIG DIG OF ATM NUM        PC34 132
#NCODEFLD:(FLOAT(NPART),1,ANAM2,20223.,1)#PUT ATOM # INTO NAME          PC34 133
#NPART=INT(I/100.)#                     4 MOST SIG DIG OF ATM NUM       PC34 134
#NCODEFLD:(FLOAT(NPART),1,ANAM1,40333.,1)#PUT UPPER ATOM # INTO NAME    PC34 135
#                                                                       PC34 136
# PUT NEW ATOM NAME (2 PARTS) INTO OUTPUT BUFFER                        PC34 137
#                                                                       PC34 138
QX(IPTO+2)=QX(KAT+1)#                  Move remoteness info             PC34 139
movector:(ANAM1,1,QX(IPTO+3),1,4,0)#   Move first half of name          PC34 140
movector:(ANAM2,1,QX(IPTO+4),1,4,0)#   Move last half of name           PC34 141
movereal:(QX(KAT),4,QX(IPTO+1),5,STEPAT-3,0)#                           PC34 142
K=IPTO+STEPAT+2#                       Set point for parameters in      PC34 143
movereal:(QX(KPA),1,QX(K),1,12,0)#     Move 1st part of starpa list     PC34 144
K=K+12#                                                                 PC34 145
IF(ANISO==2)#                          Move aniso t.f. if present       PC34 146
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PC34 147
movereal:(QX(KPA+12),1,QX(K),1,6,0)#                                    PC34 148
K=K+6#                                                                  PC34 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PC34 150
IF(OLDATM !=no:)#                      Move old atom x,y,z              PC34 151
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PC34 152
movereal:(QX(KPA+18),1,QX(K),1,3,0)#                                    PC34 153
K=K+3#                                                                  PC34 154
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PC34 155
QX(K)=1.0#                                                              PC34 156
ifnv:(QX(KPA+21)) QX(K)=QX(KPA+21)#    Move t.f. type                   PC34 157
KAT=KAT+STEPAT#                                                         PC34 158
KPA=KPA+STEPPA#                                                         PC34 159
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PC34 160
#                                                                       PC34 161
# LIST ATOM COORDINATES AT PRIORITY 4                                   PC34 162
#                                                                       PC34 163
IF(PPRIOR > 3)#                                                         PC34 164
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PC34 165
IPRESN=STARSQ+1#                                                        PC34 166
DO IR=1,NSEQU#                                                          PC34 167
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PC34 168
movertoc:(QX(IPRESN),1,HEAD1,11,4,0)#                                   PC34 169
movertoc:(QX(IPRESN+1),1,HEAD1,16,4,0)#                                 PC34 170
LINRM=5#                                                                PC34 171
writeline:(1,HEAD1,NHEAD1,3,3)#                                         PC34 172
writeline:(0,HEAD2,NHEAD2,3,4)#                                         PC34 173
IPRESN=IPRESN+STEPSQ#                                                   PC34 174
L1=RESIPT(IR)+1#                                                        PC34 175
L2=RESIPT(IR+1)#                                                        PC34 176
IF(L2 >=L1)#                                                            PC34 177
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PC34 178
DO  IA=L1,L2#                                                           PC34 179
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PC34 180
KD=(IA-1)*STEPAT+STARAT#                                                PC34 181
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   PC34 182
ICOL=7#                                Set-up column                    PC34 183
movertoc:(QX(KD+3),1,CHROT,ICOL,4,0)#                                   PC34 184
ATM=IA#                                                                 PC34 185
ncodefld:(ATM,1,CHROT,FMT(1),1)#       Atom number                      PC34 186
ifnv:(QX(KD+4)) ncodefld:(QX(KD+4),1,CHROT,FMT(2),1)#                   PC34 187
IPA=(IA-1)*STEPPA+STARPA#                                               PC34 188
ifnv:(QX(IPA+1)) ncodefld:(QX(IPA+1),1,CHROT,FMT(3),3)# X,y,z           PC34 189
ifnv:(QX(IPA+7)) ncodefld:(QX(IPA+7),1,CHROT,FMT(6),1)# Occ.            PC34 190
ifnv:(QX(IPA+9)) ncodefld:(QX(IPA+9),1,CHROT,FMT(7),1)# Iso b           PC34 191
IF(ANISO==2)#                          Aniso uij's                      PC34 192
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PC34 193
ifnv:(QX(IPA+id5:)) ncodefld:(QX(IPA+id5:),1,CHROT,FMT(8),6)#           PC34 194
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PC34 195
writeline:(0,0,0,1,4)#                 Write atom info.                 PC34 196
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PC34 197
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PC34 198
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PC34 199
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PC34 200
#                                                                       PC34 201
RETURN#                                                                 PC34 202
#                                                                       PC34 203
END#                                                                    PC34 204
systemheader:(PC50)#                                                    PC50   1
####################################################################### PC50   2
SUBROUTINE PC50#                                                        PC50   3
# SUBROUTINE TO CONSTRUCT THE TREELIST MATRIX                           PC50   4
# FROM THE SEQUENCE AND DICTIONARY INFORMATION                          PC50   5
# THE SEQUENCE NAME IS IN THE QX ARRAY                                  PC50   6
#  FROM STARSQ TO STOPSQ BY STEPSQ                                      PC50   7
# THE DICTIONARY INFORMATION IS IN QX                                   PC50   8
#  FROM STARDC TO STOPDC BY STEPDC                                      PC50   9
#  SEE ROUTINE PC20 FOR DETAILS                                         PC50  10
#                                                                       PC50  11
# BASED ON 'TREBIL' SUBROUTINE OF JAN HERMANS                           PC50  12
#  TREELIST INFORMATION STORED IN QX ARRAY                              PC50  13
#  FROM STARAT TO STOPAT BY STEPAT                                      PC50  14
# QX(IP+4)=KEY TO DICTIONARY ( ALREADY STORED )                         PC50  15
#         =OLD TREE(6,IAT)                                              PC50  16
# QX(IP+6)=POINTER TO BACKCHAIN ( OLD TREE(2,IAT) )                     PC50  17
#     +7)=POINTER TO FOR.CHAIN ( OLD TREE(3,IAT) )                      PC50  18
# QX(IP+8)=KEY TO MOVE OR NOT   ( OLD TREE(4,IAT) )                     PC50  19
# QX(IP+9)=GRP/NON-GROUP/SLAVE KEY ( OLD GRP(IAT) )                     PC50  20
#   THE OLD TREE(5,IAT) THAT POINTS TO TORSION ANGLES                   PC50  21
#   IS NO LONGER REQUIRED, AS STORED IN DICTIONARY                      PC50  22
#   THE POINTER TO SYM.RELATED ATOMS ( OLD TREE(1,IAT) )                PC50  23
#   IS NOT RESERVED YET                                                 PC50  24
#  SEE PC30 & PC32 FOR MORE ON STARAT..                                 PC50  25
# OLD KEYRES(1,NRES) IS NOT REALLY NEEDED                               PC50  26
# OLD KEYRES(2,NRES) IS SET HERE AS RESIPT(NRES)                        PC50  27
#                                                                       PC50  28
#                                                                       PC50  29
# CODED BY MIKE CARSON,    13 JULY 1982                                 PC50  30
# SIGNIFICANTLY MODIFIED JAN 1990 FOR XTAL 2.6, K.WATENPAUGH            PC50  31
#                                                                       PC50  32
include:(AACOMN)#                                                       PC50  33
include:(PCCOMN)#                                                       PC50  34
#                                                                       PC50  35
INTEGER NGR,NATGR#                     Num.groups & num.atoms in gr     PC50  36
INTEGER IAID#                          Pointer to dictionary for cu     PC50  37
string:(ANAME,4)#                      Hold atom name                   PC50  38
string:(BNAME,4)#                      Hold b.c. name                   PC50  39
INTEGER FOUND#                                                          PC50  40
#                                                                       PC50  41
NGR=0   ;  NATG2=0#                                                     PC50  42
JROOT=0 ;  NEW=1#                      Keys for begining of new cha     PC50  43
#                                                                       PC50  44
QX(STARAT+6)=0.0#                      No backchain for first atom      PC50  45
FOR(IAT=2; IAT<=NUMATM; IAT=IAT+1)#    Set backchains                   PC50  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC50  47
FOUND=no:#                                                              PC50  48
IAID=STARAT+(IAT-1)*STEPAT+1#          Start of current atom array      PC50  49
movertoc:(QX(IAID+5),1,BNAME,1,4,0)#   Set backch. name                 PC50  50
compchar:(BNAME,1,BLANK,1,4,4,4,KEY)#                                   PC50  51
IF(KEY!=0)#                            No backchain                     PC50  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC50  53
QX(IAID+5)=0.0#                                                         PC50  54
FOUND=yes:#                                                             PC50  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC50  56
ELSE#                                                                   PC50  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC50  58
JAID=IAID#                                                              PC50  59
FOR(ICA=IAT-1; ICA>0; ICA=ICA-1)#                                       PC50  60
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC50  61
JAID=JAID-STEPAT#                                                       PC50  62
movertoc:(QX(JAID+2),1,ANAME,1,4,0)#   Atom name                        PC50  63
compchar:(ANAME,1,BNAME,1,4,4,4,KEY)#                                   PC50  64
IF( KEY !=0 )#                         Set backchain integer            PC50  65
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC50  66
QX(IAID+5)=FLOAT(ICA)#                                                  PC50  67
FOUND=yes:#                                                             PC50  68
BREAK#                                                                  PC50  69
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC50  70
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC50  71
IF(FOUND==no:) iquit:(PC5001)#         Backchain not found              PC50  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC50  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC50  74
#                                                                       PC50  75
QX(STARAT+(NUMATM-1)*STEPAT+7)=0.0#    No forward for last atom         PC50  76
FOR(IAT=1; IAT<=NUMATM-1; IAT=IAT+1)#  Set forward chain atoms          PC50  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PC50  78
FOUND=no:#                                                              PC50  79
IAID=STARAT+(IAT-1)*STEPAT+1#          Start of current atom array      PC50  80
movertoc:(QX(IAID+6),1,BNAME,1,4,0)#   Set forwch. name                 PC50  81
compchar:(BNAME,1,BLANK,1,4,4,4,KEY)#                                   PC50  82
IF(KEY!=0)#                            No forwchain                     PC50  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PC50  84
QX(IAID+6)=0.0#                                                         PC50  85
FOUND=yes:#                                                             PC50  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PC50  87
ELSE#                                                                   PC50  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PC50  89
JAID=IAID#                                                              PC50  90
FOR(ICA=IAT+1; ICA<=NUMATM; ICA=ICA+1)#                                 PC50  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PC50  92
JAID=JAID+STEPAT#                                                       PC50  93
movertoc:(QX(JAID+2),1,ANAME,1,4,0)#   Atom name                        PC50  94
compchar:(ANAME,1,BNAME,1,4,4,4,KEY)#                                   PC50  95
IF( KEY !=0 )#                         Set forwchain integer            PC50  96
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PC50  97
QX(IAID+6)=FLOAT(ICA)#                                                  PC50  98
FOUND=yes:#                                                             PC50  99
BREAK#                                                                  PC50 100
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PC50 101
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PC50 102
IF(FOUND==no:) iquit:(PC5002)#         Forward chain not found          PC50 103
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PC50 104
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PC50 105
#                                                                       PC50 106
#     SET UP GROUPS, BUT LEAVE KEYG FOR LATER                           PC50 107
#    POSITIVE IG=START NEW GROUP;  ZERO IG=SAME GROUP AS BACKCHAIN      PC50 108
#    NEGATIVE IG=NOT IN A GROUP                                         PC50 109
IPJAT=STARAT+9#                                                         PC50 110
DO JAT=1,NUMATM#                                                        PC50 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PC50 112
IG=INT(QX(IPJAT))#                                                      PC50 113
IF(IG >=0 )#                                                            PC50 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PC50 115
IF(IG == 0 )#                                                           PC50 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PC50 117
KAT=IPJAT-3#                           Points to b.chain                PC50 118
KAT=INT( QX(KAT) )#                    Backchain integer                PC50 119
KAT=STARAT+(KAT-1)*STEPAT+9#           Points to grp of b.c.            PC50 120
QX(IPJAT)=QX(KAT)#                                                      PC50 121
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PC50 122
ELSE#                                                                   PC50 123
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PC50 124
NGR=NGR+1#                                                              PC50 125
QX(IPJAT)=FLOAT(NGR)#                                                   PC50 126
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PC50 127
NATG2=NATG2+1#                                                          PC50 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PC50 129
IPJAT=IPJAT+STEPAT#                    Advance pointer                  PC50 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PC50 131
NATGR=NATG2+NGR+2#                                                      PC50 132
#                                                                       PC50 133
CALL PC52#                             Automatically add missing at     PC50 134
#                                                                       PC50 135
RETURN#                                                                 PC50 136
END#                                                                    PC50 137
systemheader:(PC52)#                                                    PC52   1
####################################################################### PC52   2
SUBROUTINE PC52#                                                        PC52   3
#                                                                       PC52   4
#    CALCULATE COORDINATES OF ATOMS NOT READ IN                         PC52   5
#   ON THE BASIS OF IDEAL GEOMETRY DESCRIBED IN DICTIONARY AND          PC52   6
#   COORDINATES OF OTHER ATOMS.                                         PC52   7
#  THIS ROUTINE FINDS THE NECESSARY POINTERS                            PC52   8
#  ACTUAL CALCULATION PERFORMED BY PC53                                 PC52   9
#     FROM 'ADDALL' SUBROUTINE OF JAN HERMANS                           PC52  10
#                                                                       PC52  11
#  MISSING XYZ SIGNALLED BY VOIDFLG:                                    PC52  12
#   SLAVE ATOMS ALSO HAVE VOIDFLG, BUT THESE                            PC52  13
#   SHOULD NOT BE CONSIDERED HERE                                       PC52  14
#  COORDINATES STORED IN QX ARRAY FROM STARPA TO STOPPA                 PC52  15
#   BY STEPPA POINTERS+1,2,&3.  NUMATM ATOMS                            PC52  16
#  TREELIST INFORMATION IN QX FROM STARAT TO STOPAT                     PC52  17
#   BY STEPAT POINTERS+6=BACKCHAIN,+7=FOR.CHAIN                         PC52  18
#                     +9=GRP.KEY(-9 MEANS SLAVE)                        PC52  19
#                                                                       PC52  20
#   CODED BY MIKE CARSON,  JULY 15,1982                                 PC52  21
#   TREAT H2O WITH VOID HYDROGENS, KDW 12-AUG-88                        PC52  22
#                                                                       PC52  23
include:(AACOMN)#                                                       PC52  24
include:(PCCOMN)#                                                       PC52  25
#                                                                       PC52  26
#                                                                       PC52  27
#                                                                       PC52  28
INTEGER J,JPASS#                       Counters                         PC52  29
INTEGER IA2#                           =atom                            PC52  30
INTEGER IPL#                           =ia2+1                           PC52  31
INTEGER IA1#                           =backchain                       PC52  32
INTEGER IX#                            =missing atom                    PC52  33
INTEGER IA3#                           =back(back)                      PC52  34
INTEGER IA4#                           =highest forw. chain             PC52  35
INTEGER IA5#                           =another forw. chain             PC52  36
LOGICAL FOUND#                                                          PC52  37
LOGICAL MISSING#                                                        PC52  38
LOGICAL SLAVE#                                                          PC52  39
REAL HYDF1(3),HYDF2(3)#                Hydrogen vectors (fractional     PC52  40
string:(RESI,4)#                                                        PC52  41
string:(ATOM,4)#                                                        PC52  42
chardata:(H2O,HOH )#                                                    PC52  43
realdata:(HYD1,[1.0,0.0,0.0])#         Hydrogen vectors (orthog)        PC52  44
realdata:(HYD2,[-.325,.945,0.0])#      Hydrogen vectors (orthog)        PC52  45
datastuff:#                                                             PC52  46
#                                                                       PC52  47
defineproc:(SLAVCHK)#                  Returns true if slave atom       PC52  48
#                                                                       PC52  49
#     THE CALCULATION IS DONE IN 2 PARTS:                               PC52  50
#     PART 1 IS GONE THROUGH TWICE,                                     PC52  51
#     PART 2 IS GONE THROUGH ONCE                                       PC52  52
JPASS=0#                                                                PC52  53
WHILE ( JPASS < 2 )#                                                    PC52  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC52  55
JPASS=JPASS+1#                                                          PC52  56
#    PART 1: TREAT MISSING ATOMS AS FORWARD CHAINS AND CALCULATE XYZ IF PC52  57
#   POSSIBLE                                                            PC52  58
IPIA2=STARPA-STEPPA+1#                 Pointer to ia2                   PC52  59
DO IA2=1,NUMATM#                                                        PC52  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC52  61
# LOOP OVER ALL ATOMS                                                   PC52  62
IPIA2=IPIA2+STEPPA#                    Set pointer to ia2               PC52  63
ifnv:( QX(IPIA2) )#                                                     PC52  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC52  65
IPBC2=(IA2-1)*STEPAT+STARAT+6#         Set pointer to bc                PC52  66
IA1=IFIX( QX(IPBC2) )#                 Backchain                        PC52  67
ifvo:(QX(IPBC2+1)) NEXT#               No forward chain                 PC52  68
IX=IFIX( QX(IPBC2+1) )#                Get for.chain                    PC52  69
IPIA1=(IA1-1)*STEPPA+STARPA+1#         X coord. bc points to            PC52  70
X=QX(IPIA1)#                                                            PC52  71
MISSING=.FALSE.#                                                        PC52  72
ifvo:( X ) MISSING=.TRUE.#                                              PC52  73
IF( IA1>=1 & !MISSING )#                                                PC52  74
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC52  75
IF(IX >=1)#                                                             PC52  76
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC52  77
IATSL=IX#                                                               PC52  78
xeq:(SLAVCHK)#                                                          PC52  79
IF( SLAVE ) NEXT#                      Ia2                              PC52  80
IA4=IX#                                                                 PC52  81
IPL=IA2+1#                                                              PC52  82
IPIA4=(IA4-1)*STEPPA+STARPA+1#                                          PC52  83
ifvo:( QX(IPIA4) )#                                                     PC52  84
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PC52  85
#  MAIN FORWARD CHAIN DOES NOT EXIST                                    PC52  86
FOUND=.FALSE.#                         Search for another forw.chai     PC52  87
DO IA5=IPL,IA4#                                                         PC52  88
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PC52  89
IPBC5=(IA5-1)*STEPAT+STARAT+6#         Pt. to b.c. of ia5               PC52  90
IBC5=IFIX( QX(IPBC5) )#                                                 PC52  91
IPIA5=(IA5-1)*STEPPA+STARPA+1#         Pt. to x of ia5                  PC52  92
X=QX(IPIA5)#                                                            PC52  93
MISSING=.FALSE.#                                                        PC52  94
ifvo:( X ) MISSING=.TRUE.#                                              PC52  95
IF( IBC5==IA2 & !MISSING )#                                             PC52  96
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PC52  97
FOUND=.TRUE.  ; BREAK#                                                  PC52  98
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PC52  99
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PC52 100
IF( FOUND )#                                                            PC52 101
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PC52 102
# HAVE FOUND ONE AND USE IT TO GET XYZ OF IA4                           PC52 103
CALL PC53(IA1,IA2,IA5,IA4)#                                             PC52 104
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PC52 105
ELSE#                                                                   PC52 106
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PC52 107
#        NO OTHER FORW. CHAIN WITH XYZ; USE BACKCHAIN                   PC52 108
IPBC1=(IA1-1)*STEPAT+STARAT+6#                                          PC52 109
IA3=IFIX( QX(IPBC1) )#                                                  PC52 110
IPIA3=(IA3-1)*STEPPA+STARPA+1#                                          PC52 111
X=QX(IPIA3)#                                                            PC52 112
MISSING=.FALSE.#                                                        PC52 113
ifvo:( X ) MISSING=.TRUE.#                                              PC52 114
IF( IA3<1 \ MISSING ) NEXT#            Next ia2                         PC52 115
CALL PC53(IA1,IA2,IA3,IX)#                                              PC52 116
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PC52 117
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PC52 118
#             CALCULATE XYZ OF OTHER FW. CHAINS                         PC52 119
#             WITH HIGHEST FW. CHAIN AS REFERENCE                       PC52 120
DO  IX=IPL,IA4#                                                         PC52 121
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PC52 122
IATSL=IX#                                                               PC52 123
xeq:(SLAVCHK)#                                                          PC52 124
IF( SLAVE ) NEXT#                      Ix                               PC52 125
IPBCX=(IX-1)*STEPAT+STARAT+6#                                           PC52 126
IPIX=(IX-1)*STEPPA+STARPA+1#                                            PC52 127
X=QX(IPIX)#                                                             PC52 128
MISSING=.FALSE.#                                                        PC52 129
ifvo:( X ) MISSING=.TRUE.#                                              PC52 130
IF( IFIX(QX(IPBCX))==IA2 & MISSING )#                                   PC52 131
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PC52 132
CALL PC53(IA1,IA2,IA4,IX)#                                              PC52 133
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PC52 134
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PC52 135
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC52 136
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC52 137
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC52 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC52 139
#                                                                       PC52 140
IF(JPASS==2) BREAK#                                                     PC52 141
#         PART 2.  SCAN FOR TRIPLE BACKCHAINS W/O XYZ                   PC52 142
#                     (REVERSE OPERATION)                               PC52 143
#DO J=1,NUMATM                     #                                    PC52 144
FOR (J=1;J<=NUMATM;J=J+1)#                                              PC52 145
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PC52 146
IA1=NUMATM+1-J#                                                         PC52 147
IPBC1=(IA1-1)*STEPAT+STARAT+6#                                          PC52 148
IA2=IFIX( QX(IPBC1) )#                                                  PC52 149
IF(IA2 >=1)#                                                            PC52 150
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PC52 151
IPBC2=(IA2-1)*STEPAT+STARAT+6#                                          PC52 152
IA3=IFIX( QX(IPBC2) )#                                                  PC52 153
IF(IA3 >=1)#                                                            PC52 154
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PC52 155
IPBC3=(IA3-1)*STEPAT+STARAT+6#                                          PC52 156
IA4=IFIX( QX(IPBC3) )#                                                  PC52 157
IATSL=IA4#                                                              PC52 158
xeq:(SLAVCHK)#                                                          PC52 159
IF( SLAVE ) NEXT#                      J                                PC52 160
IPIA4=(IA4-1)*STEPPA+STARPA+1#                                          PC52 161
X=QX(IPIA4)#                                                            PC52 162
MISSING=.FALSE.#                                                        PC52 163
ifvo:( X ) MISSING=.TRUE.#                                              PC52 164
IF( IA4>=1 & MISSING )#                                                 PC52 165
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PC52 166
IPIA1=(IA1-1)*STEPPA+STARPA+1#                                          PC52 167
X=QX(IPIA1)#                                                            PC52 168
ifnv:( X )#                                                             PC52 169
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PC52 170
IPIA2=(IA2-1)*STEPPA+STARPA+1#                                          PC52 171
X=QX(IPIA2)#                                                            PC52 172
ifnv:( X )#                                                             PC52 173
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PC52 174
IPIA3=(IA3-1)*STEPPA+STARPA+1#                                          PC52 175
X=QX(IPIA3)#                                                            PC52 176
ifnv:( X ) CALL PC53(IA2,IA3,IA1,IA4)#                                  PC52 177
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PC52 178
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PC52 179
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PC52 180
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PC52 181
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PC52 182
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PC52 183
# END J LOOP                                                            PC52 184
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC52 185
# CHECK AND TREAT H2O GROUPS FOR HYDROGENS                              PC52 186
# TWO HYDROGENS FIELDS *MUST* FOLLOW OXYGEN                             PC52 187
# CALC. HYDROGEN VECTORS IN FRACTIONAL COORDINATES                      PC52 188
HYDF1(1)=CTOF(1)*HYD1(1)+CTOF(2)*HYD1(2)+CTOF(3)*HYD1(3)#               PC52 189
HYDF1(2)=CTOF(4)*HYD1(1)+CTOF(5)*HYD1(2)+CTOF(6)*HYD1(3)#               PC52 190
HYDF1(3)=CTOF(7)*HYD1(1)+CTOF(8)*HYD1(2)+CTOF(9)*HYD1(3)#               PC52 191
HYDF2(1)=CTOF(1)*HYD2(1)+CTOF(2)*HYD2(2)+CTOF(3)*HYD2(3)#               PC52 192
HYDF2(2)=CTOF(4)*HYD2(1)+CTOF(5)*HYD2(2)+CTOF(6)*HYD2(3)#               PC52 193
HYDF2(3)=CTOF(7)*HYD2(1)+CTOF(8)*HYD2(2)+CTOF(9)*HYD2(3)#               PC52 194
#                                                                       PC52 195
DO IA1=1,NUMATM-2#                                                      PC52 196
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PC52 197
IPNT=STARAT+(IA1-1)*STEPAT#                                             PC52 198
IDIC=STARDC+(NINT(QX(IPNT+4))-1)*STEPDC+1#                              PC52 199
movertoc:(QX(IDIC),1,RESI,1,4,0)#      Get residue name                 PC52 200
compchar:(RESI,1,H2O,1,4,4,4,KEY)#                                      PC52 201
movertoc:(QX(IPNT+3),1,ATOM,1,4,0)#                                     PC52 202
compchar:(ATOM,1,H2O,2,1,1,4,KEY2)#    Check if oxygen                  PC52 203
IF(KEY==1&KEY2==1)#                    Check and process next two a     PC52 204
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PC52 205
IPNT=IPNT+STEPAT#                                                       PC52 206
movertoc:(QX(IPNT+3),1,ATOM,1,4,0)#                                     PC52 207
compchar:(ATOM,1,H2O,1,1,1,4,KEY)#     Check if hydrogen                PC52 208
movertoc:(QX(IPNT+STEPAT+3),1,ATOM,1,4,0)#                              PC52 209
compchar:(ATOM,1,H2O,1,1,1,4,KEY2)#    Check if hydrogen                PC52 210
IF(KEY!=1\KEY2!=1) iquit:(PC5201)#     One or two hydrogens mis         PC52 211
IPNT=STARPA+IA1*STEPPA#                Pointer to first hydrogen pa     PC52 212
ifvo:(QX(IPNT+1))#                     Calc. hydrogen parameters        PC52 213
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PC52 214
DO I=1,3#                                                               PC52 215
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PC52 216
QX(IPNT+I)=QX(IPNT-STEPPA+I)+HYDF1(I)# X,y,z                            PC52 217
QX(IPNT+STEPPA+I)=QX(IPNT-STEPPA+I)+HYDF2(I)# X,y,z                     PC52 218
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PC52 219
QX(IPNT+7)=QX(IPNT-STEPPA+7)#          Pp                               PC52 220
QX(IPNT+STEPPA+7)=QX(IPNT-STEPPA+7)#   Pp                               PC52 221
QX(IPNT+9)=QX(IPNT-STEPPA+9)#          B                                PC52 222
QX(IPNT+STEPPA+9)=QX(IPNT-STEPPA+9)#   B                                PC52 223
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PC52 224
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PC52 225
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PC52 226
RETURN#                                                                 PC52 227
########################                                                PC52 228
procedure:(SLAVCHK)#                                                    PC52 229
#                                                                       PC52 230
SLAVE=.FALSE.#                                                          PC52 231
IPSLA=(IATSL-1)*STEPAT+STARAT+9#                                        PC52 232
ifeq:(-9.0,QX(IPSLA) ) SLAVE=.TRUE.#                                    PC52 233
#                                                                       PC52 234
endproc:(SLAVCHK)#                                                      PC52 235
END#                                                                    PC52 236
systemheader:(PC53)#                                                    PC53   1
#####################################################################   PC53   2
SUBROUTINE PC53(IA1,IA2,IA3,IX)#                                        PC53   3
#                                                                       PC53   4
#   CALCULATE COORDINATES OF ATOM IX                                    PC53   5
#   AS DEFINED BY POSITIONS OF ATOMS 1,2,3                              PC53   6
#   AND STANDARD GEOMETRY IN THE DICTIONARY                             PC53   7
#   IA1-IA2=BOND;  IA3=REFERENCE                                        PC53   8
#   IX IS BONDED TO IA2                                                 PC53   9
#   IA3 BONDED TO IA2 OR IA1                                            PC53  10
#          BASED ON `ADDAT' ROUTINE OF JAN HERMANS                      PC53  11
#                                                                       PC53  12
#  CODED BY MIKE CARSON,  JULY 15, 1982                                 PC53  13
#                                                                       PC53  14
include:(AACOMN)#                                                       PC53  15
include:(PCCOMN)#                                                       PC53  16
#                                                                       PC53  17
INTEGER IA1,IA2,IA3,IX#                Formal params=atom numbers       PC53  18
REAL XF21(3),XF31(3)#                  Vectors between atoms(fracti     PC53  19
REAL EX(3),EY(3),EZ(3)#                Local unitr vectors              PC53  20
REAL A(3),B(3),C(3)#                   Temp. storage for math           PC53  21
#                                                                       PC53  22
#   MATHEMATICAL ROUTINES:                                              PC53  23
defineproc:(SETVC)## set vectors for transformations                    PC53  24
defineproc:(SCPR)# ## s c p r     = scalar product                      PC53  25
defineproc:(CROSS)## c r o s s   = vector product                       PC53  26
defineproc:(NORM)# ## n o r m     = normalize a vector                  PC53  27
defineproc:(ORTHO)## orthogonalize the reference coords.                PC53  28
defineproc:(DEORT)## fractionalize the result for ix                    PC53  29
#                                                                       PC53  30
#     CODE BEGINS                                                       PC53  31
#                                                                       PC53  32
IA4=IX#                                The unknown atom                 PC53  33
IPA1=(IA1-1)*STEPPA+STARPA#            Set pointers to xyz              PC53  34
IPA2=(IA2-1)*STEPPA+STARPA#                                             PC53  35
IPA3=(IA3-1)*STEPPA+STARPA#                                             PC53  36
IPA4=(IA4-1)*STEPPA+STARPA#                                             PC53  37
xeq:(SETVC)#                                                            PC53  38
IPD1=(IA1-1)*STEPAT+STARAT+4#          Set pointers to dictionary       PC53  39
IPD2=(IA2-1)*STEPAT+STARAT+4#                                           PC53  40
IPD3=(IA3-1)*STEPAT+STARAT+4#                                           PC53  41
IPD4=(IA4-1)*STEPAT+STARAT+4#                                           PC53  42
IPD1=IFIX( QX(IPD1) )#                 Keys to dict. entries            PC53  43
IPD2=IFIX( QX(IPD2) )#                                                  PC53  44
IPD3=IFIX( QX(IPD3) )#                                                  PC53  45
IPD4=IFIX( QX(IPD4) )#                                                  PC53  46
IPD1=(IPD1-1)*STEPDC+STARDC#           Actual pointers to dict.         PC53  47
IPD2=(IPD2-1)*STEPDC+STARDC#                                            PC53  48
IPD3=(IPD3-1)*STEPDC+STARDC#                                            PC53  49
IPD4=(IPD4-1)*STEPDC+STARDC#                                            PC53  50
IF( IA1 >=IA2 )#                       Reversed construction ( rare     PC53  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC53  52
BL=QX(IPD2+9)#                         Get bondlength                   PC53  53
THE=QX(IPD1+10)#                       Get bondangle                    PC53  54
RO=QX(IPD3+11)#                        Get dihedral                     PC53  55
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC53  56
ELSE#                                  Normal forward construction      PC53  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC53  58
BL=QX(IPD4+9)#                         Bondlength                       PC53  59
THE=QX(IPD4+10)#                       Bondangle                        PC53  60
RO=QX(IPD4+11)#                        Dihedral                         PC53  61
IBC3=(IA3-1)*STEPAT+STARAT+6#          Pointer to b.c. of ia3           PC53  62
IBC3=IFIX( QX(IBC3) )#                 Backchain of ia3                 PC53  63
IF( IBC3==IA2 )#                       If ref. is another for.chain     PC53  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC53  65
RO=RO-QX(IPD3+11)#                                                      PC53  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC53  67
#                                                                       PC53  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC53  69
THE=THE*3.14159/180.0#                                                  PC53  70
RO=RO*3.14159/180.0#                                                    PC53  71
A(1)=-BL*COS(THE)#                                                      PC53  72
B(1)= BL*SIN(THE)#                                                      PC53  73
A(2)=B(1)*COS(RO)#                                                      PC53  74
A(3)=B(1)*SIN(RO)#                                                      PC53  75
C(1)=A(1)*EX(1)+A(2)*EY(1)+A(3)*EZ(1)# Form corrections                 PC53  76
C(2)=A(1)*EX(2)+A(2)*EY(2)+A(3)*EZ(2)#                                  PC53  77
C(3)=A(1)*EX(3)+A(2)*EY(3)+A(3)*EZ(3)#                                  PC53  78
xeq:(DEORT)#                           Convert back to fractional       PC53  79
DO I=1,3#                              Compute missing coordinates      PC53  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC53  81
QX(IPA4+I)=QX(IPA2+I)+C(I)#                                             PC53  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC53  83
RETURN#                                                                 PC53  84
#                                                                       PC53  85
#                                                                       PC53  86
procedure:(SETVC)#                                                      PC53  87
DO I=1,3#                              Set vectors between atoms        PC53  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC53  89
XF21(I)=QX(IPA2+I)-QX(IPA1+I)#                                          PC53  90
XF31(I)=QX(IPA3+I)-QX(IPA1+I)#                                          PC53  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC53  92
DO I=1,3#                              Orthogonalize the difference     PC53  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PC53  94
A(I)=XF21(I)#                                                           PC53  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PC53  96
xeq:(ORTHO)#                                                            PC53  97
DO I=1,3#                                                               PC53  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PC53  99
XF21(I)=A(I)#                                                           PC53 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PC53 101
DO I=1,3#                              Orthogonalize the other vect     PC53 102
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PC53 103
A(I)=XF31(I)#                                                           PC53 104
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PC53 105
xeq:(ORTHO)#                                                            PC53 106
DO I=1,3#                                                               PC53 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PC53 108
XF31(I)=A(I)#                                                           PC53 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PC53 110
DO I=1,3#                              Take cross product               PC53 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PC53 112
A(I)=XF21(I)#                                                           PC53 113
B(I)=XF31(I)#                                                           PC53 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PC53 115
xeq:(CROSS)#                                                            PC53 116
xeq:(NORM)#                                                             PC53 117
DO I=1,3#                              Have just made ex()              PC53 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PC53 119
EX(I)=A(I)#                                                             PC53 120
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PC53 121
DO I=1,3#                              Save result of cross             PC53 122
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PC53 123
A(I)=C(I)#                                                              PC53 124
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PC53 125
xeq:(NORM)#                                                             PC53 126
DO I=1,3#                              Have just made ez()              PC53 127
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PC53 128
EZ(I)=A(I)#                                                             PC53 129
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PC53 130
DO I=1,3#                              Prepar to make ey()              PC53 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PC53 132
B(I)=EX(I)#                                                             PC53 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PC53 134
xeq:(CROSS)#                           Makes ey()                       PC53 135
DO I=1,3#                                                               PC53 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PC53 137
EY(I)=C(I)#                                                             PC53 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PC53 139
endproc:(SETVC)#                                                        PC53 140
#                                                                       PC53 141
#                                                                       PC53 142
#########################                                               PC53 143
procedure:(CROSS)#                                                      PC53 144
#                                                                       PC53 145
DO I=1,3#                                                               PC53 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PC53 147
J=I+1#                                                                  PC53 148
IF(J==4) J=1#                                                           PC53 149
K=6-I-J#                                                                PC53 150
C(I)=A(J)*B(K)-A(K)*B(J)#                                               PC53 151
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PC53 152
endproc:(CROSS)#                                                        PC53 153
#                                                                       PC53 154
#                                                                       PC53 155
#########################                                               PC53 156
procedure:(NORM)#                                                       PC53 157
B(1)=1./SQRT(A(1)*A(1)+A(2)*A(2)+A(3)*A(3))#                            PC53 158
A(1)=B(1)*A(1)#                                                         PC53 159
A(2)=B(1)*A(2)#                                                         PC53 160
A(3)=B(1)*A(3)#                                                         PC53 161
endproc:(NORM)#                                                         PC53 162
#                                                                       PC53 163
########################                                                PC53 164
procedure:(ORTHO)#                                                      PC53 165
#                                                                       PC53 166
DO I=1,3#                              Set temp.array                   PC53 167
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PC53 168
B(I)=A(I)#                                                              PC53 169
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PC53 170
A(1)=FTOC(1)*B(1)+FTOC(2)*B(2)+FTOC(3)*B(3)#                            PC53 171
A(2)=FTOC(4)*B(1)+FTOC(5)*B(2)+FTOC(6)*B(3)#                            PC53 172
A(3)=FTOC(7)*B(1)+FTOC(8)*B(2)+FTOC(9)*B(3)#                            PC53 173
endproc:(ORTHO)#                                                        PC53 174
#                                                                       PC53 175
#                                                                       PC53 176
procedure:(DEORT)#                                                      PC53 177
#  DEORT MUST RETURN C() WITH C AS INPUT B AVAIL. FOR DUMMY             PC53 178
DO I=1,3#                              Set temp.array                   PC53 179
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PC53 180
B(I)=C(I)#                                                              PC53 181
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PC53 182
C(1)=CTOF(1)*B(1)+CTOF(2)*B(2)+CTOF(3)*B(3)#                            PC53 183
C(2)=CTOF(4)*B(1)+CTOF(5)*B(2)+CTOF(6)*B(3)#                            PC53 184
C(3)=CTOF(7)*B(1)+CTOF(8)*B(2)+CTOF(9)*B(3)#                            PC53 185
#                                                                       PC53 186
endproc:(DEORT)#                                                        PC53 187
#                                                                       PC53 188
END#                                                                    PC53 189
systemheader:(PC55)#                                                    PC55   1
######################################################################  PC55   2
SUBROUTINE PC55(INFO)#                                                  PC55   3
#                                                                       PC55   4
#     SET UP ARRAYS OF MASTERS AND SLAVES FROM INPUT AND FROM ATOM      PC55   5
#     NAMES (NAMES WITH X OR Y BECOME SLAVES).                          PC55   6
#      BASED ON SUBROUTINE 'SETSLA' OF JAN HERMANS                      PC55   7
#                                                                       PC55   8
#   IMASOR(*)=ORDERED LIST OF MASTERS                                   PC55   9
#   IMASPT(*)=POINTERS TO ISLVMA(*)                                     PC55  10
#   ISLVOR(*)=ORDERED LIST OF SLAVES                                    PC55  11
#   ISLVMA(*)=SLAVES ORDERED ACCORDING TO MASTERS                       PC55  12
#                                                                       PC55  13
# CODED BY MIKE CARSON,    17 JULY 1982                                 PC55  14
#                                                                       PC55  15
include:(AACOMN)#                                                       PC55  16
include:(PCCOMN)#                                                       PC55  17
#                                                                       PC55  18
#   DEFINE PROCEDURE NAMES FOR THIS ROUTINE                             PC55  19
defineproc:(SETDISU)#                  Set keys for disulphide link     PC55  20
defineproc:(SETMAST)#                  Set keys for explicit master     PC55  21
defineproc:(SETCAST)#                  Set to divide the seq. into      PC55  22
defineproc:(SETNOTA)#                  Set residue not to be treate     PC55  23
defineproc:(NUMATS)#                   Return atomnumber, given at.     PC55  24
defineproc:(SORTMSL)#                  Sort mas/slv pairs by master     PC55  25
defineproc:(AUTOKEY)#                  Set up keys to automatically     PC55  26
defineproc:(ASSIGN)#                   Assign values to imaspt,islv     PC55  27
#                       ACCORDING TO KEYS WHICH HAVE BEEN SET           PC55  28
defineproc:(CASTOFF2)#                 Signal end of a polypeptide      PC55  29
defineproc:(SETXYZ)#                   Set xyz of slave=xyz of ma       PC55  30
defineproc:(QXFILL)#                   Enter master/slave keys into     PC55  31
#          AND OUTPUT STUFF WITH FORMATS FOR NOW                        PC55  32
#                                                                       PC55  33
chardata:(PC55I, DISULF NEWCHN MSPAIR NOAUTO ENDLIN )#                  PC55  34
chardata:(DISMS,CA  CB  SG  CAX CBX SGX )# To set disul.keys            PC55  35
chardata:(XXXX,X)#                                                      PC55  36
chardata:(YYYY,Y)#                                                      PC55  37
# FOLLOWING 4 ARRAY EXPLAINED BELOW                                     PC55  38
INTEGER INFO#                          Link information input           PC55  39
INTEGER IMASOR(arith:(mxnres:,+,1))#                                    PC55  40
INTEGER IMASPT(arith:(mxnres:,+,1))#                                    PC55  41
INTEGER ISLVOR(mxnslv:)#                                                PC55  42
INTEGER ISLVMA(mxnslv:)#                                                PC55  43
INTEGER KEYS(mxnslv:), NUMOM(mxnslv:), NUMOS(mxnslv:)#                  PC55  44
INTEGER I,IA1,IA2,II,IM,INN,IR,IR1,IR2,ISL,ITYP,IX#                     PC55  45
INTEGER J,JAT,JJ,K,KD,KK,KMAS,L1,L2,L3,L4,MASSA,NNN,NRA#                PC55  46
LOGICAL AUTO,EXPLIC,FOUND,DONE,SORT#                                    PC55  47
#   CHARACTER VARIABLES                                                 PC55  48
string:(RNAM,8)#                                                        PC55  49
string:(ANAM,4)#                                                        PC55  50
string:(ANAM2,4)#                                                       PC55  51
string:(ANAMSL,4)#                                                      PC55  52
#                                                                       PC55  53
datastuff:#                                                             PC55  54
#            **  CODE BEGINS  **                                        PC55  55
NRA=0 ; NMAS=0 ; NSLAV=0 ; IMASPT(1)=0#                                 PC55  56
INN=1#                                 Used to count explicit maste     PC55  57
#          BY MASTER OR DISULF.  SAVED IN SCRATCH ARRAYS                PC55  58
#          NUMOM/NUMOS, WHICH ARE LATER SORTED                          PC55  59
AUTO=.TRUE.#                           Automatic processing of dict     PC55  60
#                                                                       PC55  61
IF(INFO==yes:)#                                                         PC55  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC55  63
#                      READ INPUT CARDS                                 PC55  64
#  MSPAIR =RES.NUM= ATOMNAME  =RES.NUM.(SLAVE) ATOMNAME(SLAVE)          PC55  65
#  DISULF =RES.NUM1==RES.NUM2=                                          PC55  66
#  NEWCHN =RES.NUM(THAT BEGINS NEW CHAIN)=                              PC55  67
#  NOAUTO =RES.NUM= (NOT YET IMPLEMENTED)                               PC55  68
#  ENDLINK   (KEYS END OF INPUT)                                        PC55  69
#                                                                       PC55  70
REPEAT#                                Reading of input streams unt     PC55  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC55  72
readline:(PC55I,NPC55I)#               Get input stream                 PC55  73
IF( LINID==5 ) BREAK#                  As endlink found                 PC55  74
ELSE IF( LINID==1 ) xeq:(SETDISU)#                                      PC55  75
ELSE IF( LINID==2 ) xeq:(SETCAST)#                                      PC55  76
ELSE IF( LINID==3 ) xeq:(SETMAST)#                                      PC55  77
ELSE IF( LINID==4 ) xeq:(SETNOTA)#                                      PC55  78
ELSE iquit:(PC5501)#                   Illegal input                    PC55  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC55  80
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC55  81
NNN=INN-1#                                                              PC55  82
IF( NNN>1 ) xeq:(SORTMSL)#             Sort only if more than 1         PC55  83
#  LOOP OVER ALL THE RESIDUES                                           PC55  84
#    SET UP A POINTER TO NEXT EXPLICIT MSPAIR                           PC55  85
KMAS=1#                                                                 PC55  86
IF(NNN==0) MASSA=0#                                                     PC55  87
ELSE MASSA=NUMOM(1)#                                                    PC55  88
#                                                                       PC55  89
# START LOOP OVER ALL RESIDUES.  GOES TWICE OVER ALL ATOMS IN EACH RESI PC55  90
ITYP=STARSQ+1#                         Set pointer to 1st res.name      PC55  91
FOR (IR=1;IR<=NSEQU;IR=IR+1)#          See if for loop does any bet     PC55  92
#DO IR=1,NSEQU                     #                                    PC55  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC55  94
###write (6,*) ' residue ',ir                                           PC55  95
movertoc:(QX(ITYP),1,RNAM,1,4,0)#      Get residue name                 PC55  96
ITYP=ITYP+STEPSQ#                                                       PC55  97
L1=RESIPT(IR)+1 ; L2=RESIPT(IR+1)#                                      PC55  98
###write (6,*) l1,l2                                                    PC55  99
#                                                                       PC55 100
# IF NOAUTO EVER IMPLEMENTED, ONE SHOULD LOOK HERE TO                   PC55 101
# TURN OFF AUTOMATIC PROCESSING OF SLAVE ATOMS                          PC55 102
#  THE CSS GROUP IS HANDLED CORRECTLY THRU DISULF CARD                  PC55 103
#                                                                       PC55 104
FOUND=.FALSE.#                         Find out if any slave atoms      PC55 105
FOR (IAT=L1;IAT<=L2;IAT=IAT+1)#                                         PC55 106
#DO IAT=L1,L2                      #                                    PC55 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC55 108
I=IAT-L1+1 ; KEYS(I)=0#                                                 PC55 109
IPGRP=(IAT-1)*STEPAT+STARAT+9#                                          PC55 110
ifeq:(-9.0,QX(IPGRP)) FOUND=.TRUE.#    It is a slave                    PC55 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC55 112
IF( FOUND ) xeq:(AUTOKEY)#             Set up keys for slave atoms      PC55 113
FOR (IA1=L1;IA1<=L2;IA1=IA1+1)#                                         PC55 114
#DO IA1=L1,L2                      #                                    PC55 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC55 116
IF(KMAS > NNN \ IA1 !=MASSA)#                                           PC55 117
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PC55 118
#   AUTOMATIC?                                                          PC55 119
IF( !AUTO) NEXT#                       Ia1-next atom this residu        PC55 120
JJ=IA1-L1+1 ; IF(KEYS(JJ) <=0) NEXT#                                    PC55 121
NMAS=NMAS+1 ; IMASOR(NMAS)=IA1 ; IA2=KEYS(JJ)+L1-1 ; EXPLIC=.FALSE.#    PC55 122
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PC55 123
ELSE#                                                                   PC55 124
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PC55 125
#        EXPLICIT MSPAIR                                                PC55 126
IA2=NUMOS(KMAS) ; EXPLIC=.TRUE. ;  NMAS=NMAS+1#                         PC55 127
IMASOR(NMAS)=IA1  ;  KMAS=KMAS+1#                                       PC55 128
IF(KMAS <=NNN) MASSA=NUMOM(KMAS)#                                       PC55 129
ELSE MASSA=0#                                                           PC55 130
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PC55 131
#    COMMON SECTION FOR ASSIGNMENT                                      PC55 132
xeq:(ASSIGN)#                          Set major arrays, now that k     PC55 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC55 134
#-END IA1 LOOP OVER ATOMS                                               PC55 135
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC55 136
#-END IR LOOP OVER RESIDUES                                             PC55 137
#          TERMINATION SECTION                                          PC55 138
IF(NMAS==0)  NSLAV=0#                                                   PC55 139
ELSE#                                                                   PC55 140
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PC55 141
xeq:(QXFILL)## write IMASOR,etc. arrays to QX                           PC55 142
xeq:(SETXYZ)## set coordinates of slaves=those of masters               PC55 143
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PC55 144
CALL PC56#                             Set moves                        PC55 145
RETURN#                                                                 PC55 146
#                                                                       PC55 147
#                                                                       PC55 148
####################                                                    PC55 149
procedure:(SETMAST)#                                                    PC55 150
#                                                                       PC55 151
J=1#                                                                    PC55 152
CALL PC13(J,RNAM)#                     Get sequence position name       PC55 153
CALL PC14(IRI,RNAM)#                   I-th residue returned            PC55 154
J=J+1#                                                                  PC55 155
grabword:(J,ANAM)#                     Get atom name                    PC55 156
xeq:(NUMATS)#                          Get number of master atom        PC55 157
NUMOM(INN)=NUMAT#                                                       PC55 158
#                                                                       PC55 159
J=J+1#                                                                  PC55 160
CALL PC13(J,RNAM)#                     Get sequence position name       PC55 161
CALL PC14(IRI,RNAM)#                   I-th residue returned            PC55 162
J=J+1#                                                                  PC55 163
grabword:(J,ANAM)#                     Get atom name                    PC55 164
xeq:(NUMATS)#                          Get number of slave atom         PC55 165
NUMOS(INN)=NUMAT#                                                       PC55 166
INN=INN+1#                             Increment num. of combinatio     PC55 167
#                                                                       PC55 168
endproc:(SETMAST)#                                                      PC55 169
#                                                                       PC55 170
#                                                                       PC55 171
####################                                                    PC55 172
procedure:(SETDISU)#                                                    PC55 173
#  READ SPECIFICATIONS FOR DISULFIDE BONDS                              PC55 174
J=1#                                                                    PC55 175
CALL PC13(J,RNAM)#                     Grab first residue name and      PC55 176
CALL PC14(IR1,RNAM)#                   Locate it's position             PC55 177
CALL PC13(J+1,RNAM)#                   Repeat for second residue        PC55 178
CALL PC14(IR2,RNAM)#                                                    PC55 179
movechar:(DISMS,1,ANAM,1,4,0)#         Extract "ca  "                   PC55 180
IRI=IR1; xeq:(NUMATS)#                 Determine it's atom number f     PC55 181
NUMOM(INN)=NUMAT#                      First residue and save it        PC55 182
IRI=IR2; xeq:(NUMATS)#                 Repeat for second residue        PC55 183
NUMOM(INN+3)=NUMAT#                    The ordering in numom is imp     PC55 184
movechar:(DISMS,5,ANAM,1,4,0)#         Extract "cb  "                   PC55 185
IRI=IR1; xeq:(NUMATS)#                                                  PC55 186
NUMOM(INN+1)=NUMAT#                                                     PC55 187
IRI=IR2; xeq:(NUMATS)#                                                  PC55 188
NUMOM(INN+4)=NUMAT#                                                     PC55 189
movechar:(DISMS,9,ANAM,1,4,0)#         Extract "sg  "                   PC55 190
IRI=IR1; xeq:(NUMATS)#                                                  PC55 191
NUMOM(INN+2)=NUMAT#                                                     PC55 192
IRI=IR2; xeq:(NUMATS)#                                                  PC55 193
NUMOM(INN+5)=NUMAT#                                                     PC55 194
movechar:(DISMS,13,ANAM,1,4,0)#        Extract "cax "                   PC55 195
IRI=IR2; xeq:(NUMATS)#                                                  PC55 196
NUMOS(INN)=NUMAT#                                                       PC55 197
IRI=IR1; xeq:(NUMATS)#                                                  PC55 198
NUMOS(INN+3)=NUMAT#                                                     PC55 199
movechar:(DISMS,17,ANAM,1,4,0)#        Extract "cbx "                   PC55 200
IRI=IR2; xeq:(NUMATS)#                                                  PC55 201
NUMOS(INN+1)=NUMAT#                                                     PC55 202
IRI=IR1; xeq:(NUMATS)#                                                  PC55 203
NUMOS(INN+4)=NUMAT#                                                     PC55 204
movechar:(DISMS,21,ANAM,1,4,0)#        Extract "sgx "                   PC55 205
IRI=IR2; xeq:(NUMATS)#                                                  PC55 206
NUMOS(INN+2)=NUMAT#                                                     PC55 207
IRI=IR1; xeq:(NUMATS)#                                                  PC55 208
NUMOS(INN+5)=NUMAT#                                                     PC55 209
INN=INN+6#                                                              PC55 210
#                                                                       PC55 211
endproc:(SETDISU)#                                                      PC55 212
#                                                                       PC55 213
#                                                                       PC55 214
####################                                                    PC55 215
procedure:(SETCAST)#                                                    PC55 216
#                                                                       PC55 217
J=1#                                                                    PC55 218
CALL PC13(J,RNAM)#                     Get residue that starts the      PC55 219
CALL PC14(I,RNAM)#                     Locate its position in seque     PC55 220
NAT=RESIPT(I)#                         Num.atoms before(!) that res     PC55 221
IPAT=NAT*STEPAT+STARAT+6#              Pointer to b.c.                  PC55 222
QX(IPAT)=0.0#                          B.c. of nat+1st atom to zero     PC55 223
xeq:(CASTOFF2)#                        Based on nat, to disconnect      PC55 224
#                                                                       PC55 225
endproc:(SETCAST)#                                                      PC55 226
#                                                                       PC55 227
#                                                                       PC55 228
####################                                                    PC55 229
procedure:(SETNOTA)#                                                    PC55 230
#                                                                       PC55 231
#  DUMMY, AS PROBABLY WILL NEVER BE USED.                               PC55 232
endproc:(SETNOTA)#                                                      PC55 233
########################                                                PC55 234
procedure:(CASTOFF2)#                                                   PC55 235
#                                                                       PC55 236
#  ERASE NONEXISTENT FORWARD CHAINS                                     PC55 237
FOR (I=1;I<=mxnasr:;I=I+1)#                                             PC55 238
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PC55 239
JAT=NAT+1-I#                                                            PC55 240
IF(JAT >0)#                                                             PC55 241
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PC55 242
IPJAT=(JAT-1)*STEPAT+STARAT+7#                                          PC55 243
IF( IFIX( QX(IPJAT) )> NAT )#                                           PC55 244
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PC55 245
QX(IPJAT)=0#                                                            PC55 246
IF(I !=1)#                                                              PC55 247
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PC55 248
DO IAT=JAT,NAT#                                                         PC55 249
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PC55 250
KAT=(IAT-1)*STEPAT+STARAT+6#           B.c. pointer                     PC55 251
KAT=IFIX( QX(KAT) )#                   B.c.                             PC55 252
IF( KAT==JAT ) QX(IPJAT)=IAT#                                           PC55 253
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PC55 254
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PC55 255
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PC55 256
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PC55 257
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PC55 258
#  SET SIGNALS FOR GROWTREE                                             PC55 259
JROOT=0  ;  NEW=1#                                                      PC55 260
#                                                                       PC55 261
endproc:(CASTOFF2)#                                                     PC55 262
#                                                                       PC55 263
#####################                                                   PC55 264
procedure:(SORTMSL)#                                                    PC55 265
#                                                                       PC55 266
#               SORT MASTER-SLAVE PAIRS BY MSPAIR NUMBER                PC55 267
DO I=1,NNN-1#                                                           PC55 268
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PC55 269
DO J=I,NNN-1#                                                           PC55 270
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PC55 271
IF(NUMOM(J) > NUMOM(J+1))#                                              PC55 272
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PC55 273
IX=NUMOM(J) ; NUMOM(J)=NUMOM(J+1) ; NUMOM(J+1)=IX#                      PC55 274
IX=NUMOS(J) ; NUMOS(J)=NUMOS(J+1) ; NUMOS(J+1)=IX#                      PC55 275
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PC55 276
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PC55 277
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PC55 278
endproc:(SORTMSL)#                                                      PC55 279
#                                                                       PC55 280
####################                                                    PC55 281
procedure:(AUTOKEY)#                                                    PC55 282
#  CALCULATE ARRAY  KEYS  FOR AUTO RESIDUE ONLY                         PC55 283
#               KEYS(MASTER)=+SLAVE   KEYS(SLAVE)=0/-NEXT SLAVE         PC55 284
#               KEYS(OTHER)=0                                           PC55 285
IF( L2-L1 > mxnslv: )  iquit:(-PC5505)#                                 PC55 286
FOR (IAT=L1;IAT<=L2;IAT=IAT+1)#                                         PC55 287
#DO IAT=L1,L2                      #                                    PC55 288
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PC55 289
#   AUTO MASTER-SLAVE IS DETERMINED BY SLAVE'S NAME CONTAINING          PC55 290
#   'X' OR 'Y'                                                          PC55 291
#CHECK ALL ATOMS THIS RESIDUE FOR X OR Y                                PC55 292
IPGRP=(IAT-1)*STEPAT+STARAT+9#         Points to group key              PC55 293
ifne:(-9.0,QX(IPGRP)) NEXT#            Iat, as not slave                PC55 294
I=IAT-L1+1#                                                             PC55 295
KD=(IAT-1)*STEPAT+STARAT+4#            Pointer to key to dict.          PC55 296
KD=IFIX( QX(KD) )#                     Key to dictionary                PC55 297
IPAN=(KD-1)*STEPDC+STARDC+2#           Position of atom name            PC55 298
movertoc:(QX(IPAN),1,ANAMSL,1,4,0)#    Slave name                       PC55 299
compchar:(XXXX,1,ANAMSL,1,1,1,4,KEY)#  Find position of x               PC55 300
IF( KEY==0 )#                                                           PC55 301
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PC55 302
compchar:(YYYY,1,ANAMSL,1,1,1,4,KEY)#                                   PC55 303
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PC55 304
IF(KEY==0) NEXT#                       Not x or y, i.e. something s     PC55 305
movechar:(BLANK,1,ANAMSL,KEY,1,0)#     Blank out x or y                 PC55 306
FOR( JAT=L1; JAT<=L2; JAT=JAT+1 )#                                      PC55 307
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PC55 308
J=JAT-L1+1#                                                             PC55 309
KD=(JAT-1)*STEPAT+STARAT+4#                                             PC55 310
KD=IFIX( QX(KD) )#                                                      PC55 311
IPAN=(KD-1)*STEPDC+STARDC+2#                                            PC55 312
movertoc:(QX(IPAN),1,ANAM,1,4,0)#                                       PC55 313
compchar:(ANAM,1,ANAMSL,1,4,4,4,KEY)#                                   PC55 314
IF( KEY !=0 )#                                                          PC55 315
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PC55 316
FOUND=.TRUE.#                                                           PC55 317
BREAK#                                                                  PC55 318
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PC55 319
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PC55 320
IF(FOUND)#                                                              PC55 321
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PC55 322
IF(KEYS(J)==0)  KEYS(J)=I#                                              PC55 323
ELSE#                                                                   PC55 324
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PC55 325
K=KEYS(J)#                             Multiple slave: chain slave      PC55 326
WHILE (KEYS(K) !=0)#                                                    PC55 327
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PC55 328
K=-KEYS(K)#                                                             PC55 329
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PC55 330
KEYS(K)=-I#                                                             PC55 331
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PC55 332
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PC55 333
ELSE iquit:(-PC5503)#                                                   PC55 334
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PC55 335
endproc:(AUTOKEY)#                                                      PC55 336
#                                                                       PC55 337
####################                                                    PC55 338
procedure:(ASSIGN)#                                                     PC55 339
#                                                                       PC55 340
#    COMMON SECTION FOR ASSIGNMENT                                      PC55 341
DONE=.FALSE.#                                                           PC55 342
REPEAT#                                                                 PC55 343
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PC55 344
NSLAV=NSLAV+1 ; IMASPT(NMAS+1)=NSLAV ; ISLVMA(NSLAV)=IA2#               PC55 345
#      INSERT SLAVE IN ISLVOR(*) BY RANK                                PC55 346
SORT=.FALSE.#                                                           PC55 347
FOR (I=1; I<=NSLAV-1 & !SORT; I=I+1)#                                   PC55 348
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PC55 349
SORT=( IA2 <=ISLVOR(I) )#                                               PC55 350
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PC55 351
IF(SORT)#                                                               PC55 352
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PC55 353
I=I-1  ;  L3=0  ;  L4=NSLAV-I-1#                                        PC55 354
DO J=L3,L4#                                                             PC55 355
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PC55 356
IX=NSLAV-J ; ISLVOR(IX)=ISLVOR(IX-1)#                                   PC55 357
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PC55 358
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PC55 359
ISLVOR(I)=IA2#                                                          PC55 360
IF(EXPLIC)#                                                             PC55 361
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 PC55 362
#     MORE SLAVES SAME MASTER EXPLICIT?                                 PC55 363
IF(IA1 !=MASSA) DONE=.TRUE.#                                            PC55 364
ELSE#                                                                   PC55 365
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 PC55 366
IA2=NUMOS(KMAS)#                                                        PC55 367
KMAS=KMAS+1#                                                            PC55 368
IF(KMAS <=NNN) MASSA=NUMOM(KMAS)#                                       PC55 369
ELSE MASSA=0#                                                           PC55 370
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 PC55 371
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 PC55 372
#       MORE SLAVES SAME MASTER AUTOMATIC?                              PC55 373
#     ANY MORE SLAVES? (CHAIN FROM SLAVE)                               PC55 374
ELSE#                                                                   PC55 375
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 PC55 376
IA2=-KEYS(IA2-L1+1)#                                                    PC55 377
IF(IA2 <=0)  DONE=.TRUE.#                                               PC55 378
ELSE  IA2=IA2+L1-1#                                                     PC55 379
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 PC55 380
IF(DONE) BREAK#                        End common assignment repeat     PC55 381
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PC55 382
endproc:(ASSIGN)#                                                       PC55 383
#                                                                       PC55 384
#                                                                       PC55 385
####################                                                    PC55 386
procedure:(SETXYZ)#                                                     PC55 387
#                                                                       PC55 388
#   SET COORDINATES OF SLAVES=THOSE OF MASTERS                          PC55 389
DO I=1,NMAS#                                                            PC55 390
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 PC55 391
L1=IMASPT(I)+1 ; L2=IMASPT(I+1) ; IM=IMASOR(I)#                         PC55 392
IPAM=(IM-1)*STEPPA+STARPA#             Set pointer to master atom       PC55 393
DO J=L1,L2#                                                             PC55 394
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 PC55 395
ISL=ISLVMA(J)#                                                          PC55 396
IPAS=(ISL-1)*STEPPA+STARPA#            Set pointer to slave atom        PC55 397
DO K=1,3; QX(IPAS+K)=QX(IPAM+K)#                                        PC55 398
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 PC55 399
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 PC55 400
endproc:(SETXYZ)#                                                       PC55 401
#                                                                       PC55 402
#                                                                       PC55 403
##################                                                      PC55 404
procedure:(QXFILL)#                                                     PC55 405
#                                                                       PC55 406
#        MOVE THE MASTER/SLAVE POINTERS TO QX(MASTER/SLAVE) ARRAY       PC55 407
L3=0#                                                                   PC55 408
DO I=1,NMAS#                                                            PC55 409
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 PC55 410
L1=IMASPT(I)+1 ; L2=IMASPT(I+1)#                                        PC55 411
DO II=L1,L2#                                                            PC55 412
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 PC55 413
L3=L3+1#                                                                PC55 414
NUMOM(L3)=IMASOR(I);  NUMOS(L3)=ISLVMA(II)#                             PC55 415
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 PC55 416
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 PC55 417
IF( L3 !=NSLAV ) iquit:(PC5512)#                                        PC55 418
STARMS=STOPQX#                         Start at current end of qx a     PC55 419
STEPMS=2#                              Step the same for master and     PC55 420
STOPMS=STARMS#                         Init. stopms                     PC55 421
FOR(I=1; I<=NSLAV; I=I+1)#                                              PC55 422
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 PC55 423
QX(STOPMS+1)=NUMOM(I)#                                                  PC55 424
QX(STOPMS+2)=NUMOS(I)#                                                  PC55 425
STOPMS=STOPMS+STEPMS#                  Increment stopms                 PC55 426
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 PC55 427
STOPQX=STOPMS#                         Set new stopqx                   PC55 428
KK=0#                                                                   PC55 429
DO II=1,NSLAV#                                                          PC55 430
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 PC55 431
KK=KK+1#                                                                PC55 432
NUMOM(II)=ISLVOR(II)#                                                   PC55 433
IF(KK==0 \ II==NSLAV)#                                                  PC55 434
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 PC55 435
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 PC55 436
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 PC55 437
IF( NSLAV>mxnslv: \ NMAS+1>mxnmas: )  iquit:(PC5502)#                   PC55 438
endproc:(QXFILL)#                                                       PC55 439
#                                                                       PC55 440
#                                                                       PC55 441
######################                                                  PC55 442
procedure:(NUMATS)#                                                     PC55 443
#                                                                       PC55 444
#        RETURNS ATOMNUMBER, GIVEN ATOM NAME AND RESIDUE NUMBER         PC55 445
#                                                                       PC55 446
IF( IRI<=0 \ IRI>NSEQU ) iquit:(-PC5508)#                               PC55 447
L1=RESIPT(IRI)+1 ; L2=RESIPT(IRI+1)#                                    PC55 448
FOUND=.FALSE.#                                                          PC55 449
FOR (IAT=L1; IAT<=L2; IAT=IAT+1)#                                       PC55 450
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 PC55 451
KD=(IAT-1)*STEPAT+STARAT+4#            Pointer to k.d.                  PC55 452
KD=IFIX( QX(KD) )#                     Key to the dictionary            PC55 453
KD=(KD-1)*STEPDC+STARDC+2#             Pointer to atom name             PC55 454
movertoc:(QX(KD),1,ANAM2,1,4,0)#       Get atom name2                   PC55 455
compchar:(ANAM,1,ANAM2,1,4,4,4,KEY)#                                    PC55 456
IF( KEY!=0 )#                                                           PC55 457
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 PC55 458
FOUND=.TRUE.#                                                           PC55 459
BREAK#                                                                  PC55 460
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 PC55 461
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 PC55 462
IF(FOUND) NUMAT=IAT#                                                    PC55 463
ELSE  iquit:(-PC5509)#                                                  PC55 464
endproc:(NUMATS)#                                                       PC55 465
#                                                                       PC55 466
#####################                                                   PC55 467
END#                                                                    PC55 468
systemheader:(PC56)#                                                    PC56   1
####################################################################### PC56   2
SUBROUTINE PC56#                                                        PC56   3
#                                                                       PC56   4
#      SETS MOVE(=TREE(4)) ACCORDING TO SLAVE/NONSLAVE                  PC56   5
#      SET TREE(4,I)=0 IF ATOM IAT IS MASTER OF ITSELF                  PC56   6
#        OR IF NOT PART OF RESIDUES IR1 THRU IR2                        PC56   7
#       SET TREE(4,I)=1    FOR ALL OTHER ATOMS                          PC56   8
#       THEN SUBTRACT 10 FROM TREE(4,I)  IF IAT IS A (TRUE) SLAVE.      PC56   9
#      FROM OLD 'SETMOV' SUBROUTINE OF JAN HERMANS                      PC56  10
#                                                                       PC56  11
#   CODED BY MIKE CARSON,  JULY 15, 1982                                PC56  12
#                                                                       PC56  13
include:(AACOMN)#                                                       PC56  14
include:(PCCOMN)#                                                       PC56  15
#                                                                       PC56  16
INTEGER  IR1, IR2#                     First & last residues            PC56  17
INTEGER  LL1, LL2, ISLAV, IAT, MOVE, I#                                 PC56  18
#                                                                       PC56  19
#                                                                       PC56  20
IR1=1;  IR2=NSEQU;#                    Set for first thru last resi     PC56  21
LL1=RESIPT(IR1)+1 ; LL2=RESIPT(IR2+1)#                                  PC56  22
IPAX=STARPA+1#                         Set pointer to first atom x      PC56  23
IPMV=STARAT+8#                         Set pointer to move key          PC56  24
DO I=1,NUMATM#                                                          PC56  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC56  26
IF(I < LL1 \ I > LL2) MOVE=0#                                           PC56  27
ELSE  MOVE=1#                                                           PC56  28
X=QX(IPAX)#                                                             PC56  29
IPAX=IPAX+STEPPA#                                                       PC56  30
ifvo:(X)#                              Missing coordinate               PC56  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC56  32
QX(IPMV)=FLOAT( MOVE-20 )#                                              PC56  33
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC56  34
ELSE  QX(IPMV)=FLOAT( MOVE )#                                           PC56  35
IPMV=IPMV+STEPAT#                                                       PC56  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC56  37
#  SUBTRACT 10 FROM TRUE SLAVE                                          PC56  38
IPSLV=STARMS+2#                        Set pointer to slave atom nu     PC56  39
DO ISLAV=1,NSLAV#                                                       PC56  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC56  41
I=IFIX( QX(IPSLV) )#                                                    PC56  42
IPMV=(I-1)*STEPAT+STARAT+8#                                             PC56  43
QX(IPMV)=QX(IPMV)-10.0#                                                 PC56  44
IPSLV=IPSLV+STEPMS#                                                     PC56  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC56  46
#                                                                       PC56  47
# TEST IF AN ATOM IS ITS OWN MASTER                                     PC56  48
IPSLV=STARMS#                                                           PC56  49
DO IAT=1,NSLAV#                                                         PC56  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC56  51
ifeq:( QX(IPSLV+1), QX(IPSLV+2) )#                                      PC56  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC56  53
I=IFIX( QX(IPSLV+1) )#                                                  PC56  54
IPMV=(I-1)*STEPAT+STARAT+8#                                             PC56  55
QX(IPMV)=0.0#                                                           PC56  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC56  57
IPSLV=IPSLV+STEPMS#                                                     PC56  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC56  59
#                                                                       PC56  60
RETURN#                                                                 PC56  61
END#                                                                    PC56  62
systemheader:(PC58)#                   Put out master/slave to bdf      PC58   1
####################################################################### PC58   2
SUBROUTINE PC58#                       Put out master/slave info.       PC58   3
#                                                                       PC58   4
#   WRITTEN BY KDW, 20-JUL-1982                                         PC58   5
#                                                                       PC58   6
include:(AACOMN)#                                                       PC58   7
include:(PCCOMN)#                                                       PC58   8
#                                                                       PC58   9
#                                                                       PC58  10
INTEGER PSIZE,IPTO#                    Pointers for reading bdf         PC58  11
INTEGER I,K,J#                         Local variables                  PC58  12
chardata:(FMT1,[ (    /    )(    /    )(    /    )(    /    )$#         PC58  13
(    /    )(    /    )(    /    )(    /    )(    /    )(    /    )])#   PC58  14
chardata:(HEAD1, MASTER/SLAVE RELATIONSHIPS )#                          PC58  15
#                                                                       PC58  16
realdata:(FMT,[60413.,110413.,170413.,220413.,280413.,330413., $#       PC58  17
   390413.,440413.,500413.,550413.,610413.,660413.,  $#                 PC58  18
   720413.,770413.,830413.,880413.,940413.,990413.,1050413.,1100413.])# PC58  19
datastuff:#                                                             PC58  20
#                                                                       PC58  21
#   WRITE LR LRSLAV: TO BDF(OUT)                                        PC58  22
#                                                                       PC58  23
PSIZE=2#                               Two items/packet                 PC58  24
#                                                                       PC58  25
J=STARMS#                                                               PC58  26
FOR (I=1; I<=NSLAV; I=I+1)#            Output master/slave info.        PC58  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC58  28
writepkt:(NEIFIL,lrslav:,PSIZE,IPTO)#                                   PC58  29
QX(IPTO+1)=QX(J+1)#                                                     PC58  30
QX(IPTO+2)=QX(J+2)#                                                     PC58  31
J=J+STEPMS#                                                             PC58  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC58  33
#                                                                       PC58  34
# LIST SLAVE INFO. AT PRIORITY 4                                        PC58  35
#                                                                       PC58  36
IF(PPRIOR>3)#                                                           PC58  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC58  38
writeline:(2,HEAD1,NHEAD1,3,4)#                                         PC58  39
#                                                                       PC58  40
K=1#                                                                    PC58  41
movechar:(FMT1,1,CHROT,1,NFMT1,0)#                                      PC58  42
DO I=STARMS,STOPMS,STEPMS#                                              PC58  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC58  44
ncodefld:(QX(I+1),1,CHROT,FMT(K),2)#                                    PC58  45
K=K+2#                                                                  PC58  46
IF(K >=20)#                                                             PC58  47
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC58  48
writeline:(0,0,0,1,4)#                                                  PC58  49
movechar:(FMT1,1,CHROT,1,NFMT1,0)#                                      PC58  50
K=1#                                                                    PC58  51
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC58  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC58  53
IF(K !=1)#                                                              PC58  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC58  55
I=11*(K-3)/2+2 ; J=mxchln:-I#                                           PC58  56
movechar:(BLANK,1,CHROT,I,J,1)#                                         PC58  57
writeline:(0,0,0,1,4)#                                                  PC58  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC58  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC58  60
#                                                                       PC58  61
RETURN#                                                                 PC58  62
END#                                                                    PC58  63
#                                                                       PC58  64
systemheader:(PC60)#                                                    PC60   1
####################################################################### PC60   2
SUBROUTINE PC60#                                                        PC60   3
# SUBROUTINES SETLAT FROM UNCEDAR (JH AND MC)                           PC60   4
#                                                                       PC60   5
# SET THE NEEDED CEDAR SYMMETRY OPERATIONS. THESE GO INTO THE HIGHER    PC60   6
# ELEMENTS OF ROT:, THE FIRST FEW BEING THE CRYSTALLOGRAPHIC BASIS SET. PC60   7
# FIRST 9 ELEMENTS=MATRIX, LAST THREE=TRANSLATION. WILL BE FRACTIONAL,  PC60   8
# AND OUTPUT ON FSYMM: RECORD IN BDF                                    PC60   9
#                                                                       PC60  10
include:(AACOMN)#                                                       PC60  11
include:(PCCOMN)#                                                       PC60  12
#                                                                       PC60  13
INTEGER NUC#                           Number of cells checked in e     PC60  14
#                                                                       PC60  15
chardata:(MSG1,[ NEIGHBORING ATOM CUTOFF=    ])#                        PC60  16
chardata:(MSG2,[ CEDAR SYMOPS (MATRIX -- TRANSLATION)])#                PC60  17
realdata:(FMT1,[60622.,120622.,180622.,240622.,300622.,360622., $#      PC60  18
420622.,480622.,540622.,661222.,720622.,780622.])#                      PC60  19
datastuff:#                                                             PC60  20
DATA NUC/2/#                                                            PC60  21
#                                                                       PC60  22
# DEFINE THE IDENTITY OPERN AS THE FIRST CEDAR-SYMOP                    PC60  23
NLAT=1#                                                                 PC60  24
DO I=1,12 $( rot:(I,NLAT)=0. $)#                                        PC60  25
DO I=1,9,4 $( rot:(I,NLAT)=1. $)#                                       PC60  26
#                                                                       PC60  27
ncodefld:(CUTOFF,1,MSG1,310512.,1)#                                     PC60  28
writeline:(1,MSG1,NMSG1,3,3)#                                           PC60  29
CALL PC61(NUC)#                        Calculate all necessary cell     PC60  30
#                                                                       PC60  31
#    LIST RESULTS                                                       PC60  32
writeline:(1,MSG2,NMSG2,3,4)#                                           PC60  33
J=STARMX#                                                               PC60  34
###WRITE(6,'(8i5)') STARPA,STEPPA,STOPPA,STARMX,STEPMX,STOPMX,NLAT##    PC60  35
###WRITE(6,'(12f8.0)') FMT1##                                           PC60  36
DO I=1,NLAT#                                                            PC60  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC60  38
###WRITE(6,'(12f6.2)') (QX(K),K=J+1,J+12)##                             PC60  39
###WRITE(6,'(su,16r,12i10)') (QX(K),K=J+1,J+12)##                       PC60  40
ncodefld:(QX(J+1),1,CHROT,1,FMT1,12)#                                   PC60  41
writeline:(0,0,0,1,4)#                                                  PC60  42
J=J+STEPMX#                                                             PC60  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC60  44
#                                                                       PC60  45
RETURN#                                                                 PC60  46
END#                                                                    PC60  47
systemheader:(PC61)#                                                    PC61   1
####################################################################### PC61   2
SUBROUTINE PC61(NUC)#                                                   PC61   3
#  <> GETOPS.R FROM UNCEDAR PROGRAM (MC AND JH)                         PC61   4
#  DETERMINE ALL SYMOPS REQUIRED TO GENERATE SYMMETRY-RELATED ATOMS     PC61   5
#  INSIDE THE VOLUME OF THE GIVEN ATOMS+-A MARGIN==CUTOFF               PC61   6
#                                                                       PC61   7
#                                                                       PC61   8
include:(AACOMN)#                                                       PC61   9
include:(PCCOMN)#                                                       PC61  10
#                                                                       PC61  11
INTEGER NUC#                           Number of cells tocheck in e     PC61  12
#                                                                       PC61  13
LOGICAL SAVE#                                                           PC61  14
LOGICAL PC69#                          Logical function                 PC61  15
REAL ABOX0(3),ABOX1(3)#                Limits of volume spanned by      PC61  16
REAL BOX(3,2)#                         Corners of box                   PC61  17
EQUIVALENCE (ABOX0(1),BOX(1,1)),(ABOX1(1),BOX(1,2))#                    PC61  18
REAL RC(3,3),TC(3),TCF(3)#                                              PC61  19
REAL XYZ(3),XYZT(3)#                                                    PC61  20
#                                                                       PC61  21
defineproc:(SAVE)#                                                      PC61  22
#                                                                       PC61  23
# TRANSFORM COORDINATES TO CARTESIAN                                    PC61  24
DO IAT=1,NUMATM#                                                        PC61  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC61  26
DO IT=1,3 $( XYZ(IT)=x:(IT,IAT) $)#                                     PC61  27
CALL PC68(FTOC,XYZ,x:(1,IAT))#         To cartesian                     PC61  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC61  29
# DETERMINE BOX SIZE FROM COORDINATES:                                  PC61  30
DO I=1,3#                                                               PC61  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC61  32
A2=x:(I,1) ; A3=A2#                    A2, a3 are min & max of x(i)     PC61  33
DO IAT=1,NUMATM#                                                        PC61  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC61  35
AA=x:(I,IAT)#                                                           PC61  36
ifvo:(AA) NEXT#                                                         PC61  37
IF(AA<A2) A2=AA#                                                        PC61  38
IF(AA>A3) A3=AA#                                                        PC61  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC61  40
ABOX0(I)=A2#                                                            PC61  41
ABOX1(I)=A3#                                                            PC61  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC61  43
#                                                                       PC61  44
################## loop over all the space group operators              PC61  45
DO NTV=1,NSYMOP#                                                        PC61  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC61  47
DO IROW=1,3 ; DO ICOL=1,3#                                              PC61  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PC61  49
KDUM=3*(IROW-1)+ICOL#                                                   PC61  50
RC(ICOL,IROW)=rotx:(KDUM,NTV)#                                          PC61  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PC61  52
# # # # # # # # # # #                                                   PC61  53
# LOOP+/-NUC=NUMBER UNIT CELLS IN EACH DIRECTION (DEFAULT=2)            PC61  54
FOR (IX=-NUC ; IX<=NUC ; IX=IX+1) $(#                                   PC61  55
FOR (IY=-NUC ; IY<=NUC ; IY=IY+1) $(#                                   PC61  56
FOR (IZ=-NUC ; IZ<=NUC ; IZ=IZ+1) $(#                                   PC61  57
IF(IZ==0 & IY==0 & IX==0 & NTV==1) NEXT# Already have the identity      PC61  58
#                                                                       PC61  59
#  MAKE TC FROM T AND IX,IY,IZ AND UNIT                                 PC61  60
DO I=1,3  $(  TCF(I)=tx:(I,NTV)  $)#                                    PC61  61
TCF(1)=TCF(1)+FLOAT(IX)#                                                PC61  62
TCF(2)=TCF(2)+FLOAT(IY)#                                                PC61  63
TCF(3)=TCF(3)+FLOAT(IZ)#                                                PC61  64
CALL PC68(FTOC,TCF,TC)#                                                 PC61  65
#                                                                       PC61  66
######### TEST this symop                                               PC61  67
SAVE=.FALSE.#                                                           PC61  68
DO IAT=1,NUMATM#                       All atoms                        PC61  69
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PC61  70
DO IT=1,3 $( XYZ(IT)=x:(IT,IAT) $)#                                     PC61  71
CALL PC68(RC,XYZ,XYZT)#                Rotate xyz                       PC61  72
DO IT=1,3 $( XYZT(IT)=XYZT(IT)+TC(IT) $)# Translate                     PC61  73
IF(PC69(XYZT,BOX))#                                                     PC61  74
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PC61  75
xeq:(SAVE)#                            Save this operator               PC61  76
BREAK#                                                                  PC61  77
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PC61  78
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PC61  79
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PC61  80
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PC61  81
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PC61  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC61  83
#                                                                       PC61  84
# TRANSFORM COORDINATES TO FRACTIONAL                                   PC61  85
DO IAT=1,NUMATM#                                                        PC61  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PC61  87
DO IT=1,3 $( XYZ(IT)=x:(IT,IAT) $)#                                     PC61  88
CALL PC68(CTOF,XYZ,x:(1,IAT))#         To fractional                    PC61  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PC61  90
RETURN#                                                                 PC61  91
#                                                                       PC61  92
procedure:(SAVE)#                                                       PC61  93
NLAT=NLAT+1#                                                            PC61  94
IF(NLAT > maxlat:) iquit:(PC6101)#     Too many sym ops are             PC61  95
#                                      Being generated                  PC61  96
IT=0 ; DO I=1,3 $( DO J=1,3 $( IT=IT+1#                                 PC61  97
rot:(IT,NLAT)=RC(J,I)#                                                  PC61  98
$) $)#                                                                  PC61  99
CALL PC68(CTOF,TC,t:(1,NLAT))#         Backtransform translation        PC61 100
endproc:(SAVE)#                                                         PC61 101
#                                                                       PC61 102
END#                                                                    PC61 103
systemheader:(PC69)#                                                    PC69   1
#=============================================================#         PC69   2
# PC69: LOGICAL FUNCTION  I N S I D E                                   PC69   3
#         .TRUE. IF POINT XYZ IS INSIDE BOX                             PC69   4
#=============================================================#         PC69   5
FUNCTION PC69(XYZ,BOXO)#                                                PC69   6
LOGICAL PC69#                                                           PC69   7
REAL XYZ(3),BOXO(3,2)#                                                  PC69   8
PC69=.FALSE.#                                                           PC69   9
#                                                                       PC69  10
DO I=1,3 $(#                                                            PC69  11
IF(XYZ(I)<BOXO(I,1))  RETURN#                                           PC69  12
IF(XYZ(I)>BOXO(I,2))  RETURN#                                           PC69  13
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC69  14
PC69=.TRUE.#                                                            PC69  15
#                                                                       PC69  16
RETURN#                                                                 PC69  17
END#                                                                    PC69  18
systemheader:(PC67)#                                                    PC67   1
####################################################################### PC67   2
SUBROUTINE PC67(A,B,C)#                Matrix times matrix              PC67   3
#                                                                       PC67   4
REAL A(3,3),B(3,3),C(3,3)#                                              PC67   5
#                                                                       PC67   6
DO I=1,3 ; DO J=1,3#                                                    PC67   7
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC67   8
T=0.#                                                                   PC67   9
DO K=1,3; T=T+A(I,K)*B(K,J)#                                            PC67  10
C(I,J)=T#                                                               PC67  11
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC67  12
RETURN#                                                                 PC67  13
END#                                                                    PC67  14
systemheader:(PC68)#                                                    PC68   1
####################################################################### PC68   2
SUBROUTINE PC68(A,B,C)#                Matrix times vector              PC68   3
#                                                                       PC68   4
REAL A(3,3),B(3),C(3),D(3)#                                             PC68   5
DO I=1,3#                                                               PC68   6
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC68   7
D(I)=0.0#                                                               PC68   8
DO J=1,3; D(I)=D(I)+A(J,I)*B(J)#                                        PC68   9
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC68  10
DO I=1,3; C(I)=D(I)#                                                    PC68  11
#                                                                       PC68  12
RETURN#                                                                 PC68  13
END#                                                                    PC68  14
#                                                                       PC68  15
systemheader:(PC70)#                   Pre-cedar copy out bdf info      PC70   1
####################################################################### PC70   2
SUBROUTINE PC70#                                                        PC70   3
#                                                                       PC70   4
#   WRITTEN BY KDW APRIL 1986                                           PC70   5
#                                                                       PC70   6
include:(AACOMN)#                                                       PC70   7
include:(PCCOMN)#                                                       PC70   8
INTEGER IPT,PSIZE,IPTO#                Packet pointers                  PC70   9
#                                                                       PC70  10
IF(NEIBOR==no:)#                       Finding neighbor not perform     PC70  11
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PC70  12
copyfile:(1,2,incr:(lrslav:),endrecord:)#                               PC70  13
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PC70  14
ELSE#                                                                   PC70  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PC70  16
#                                                                       PC70  17
#READWPKT:(1,ENDRECORD:,PSIZE,IPT,0)                                    PC70  18
writepkt:(NEIFIL,endrecord:,PSIZE,IPT)#                                 PC70  19
#                                                                       PC70  20
#   PROCESS LRSYMM WITH INTERMOLECULAR SYMMETRY OPERATORS               PC70  21
#                                                                       PC70  22
REPEAT#                                                                 PC70  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PC70  24
readwpkt:(NEIFIL,lrcell:,PSIZE,IPT,0)#                                  PC70  25
IF(IPT<=0)BREAK#                                                        PC70  26
writepkt:(2,lrcell:,PSIZE,IPTO)#                                        PC70  27
movereal:(QX(IPT+1),1,QX(IPTO+1),1,PSIZE,0)#                            PC70  28
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PC70  29
readwpkt:(NEIFIL,lrsymm:,PSIZE,IPT,0)#                                  PC70  30
writepkt:(2,lrsymm:,12,IPTO)#          Pc70                             PC70  31
movereal:(QX(IPT+1),1,QX(IPTO+1),1,12,0)# Pc70                          PC70  32
QX(IPTO+7)=FLOAT(NLAT)#                Pc70                             PC70  33
I=STARSY#                              Transfer xtal symmetry opera     PC70  34
DO J=1,NSYMOP#                                                          PC70  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PC70  36
writepkt:(2,lrsymm:,12,IPTO)#                                           PC70  37
movereal:(QX(I+1),1,QX(IPTO+1),1,12,0)# Move the symop to qx            PC70  38
I=I+12#                                                                 PC70  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PC70  40
I=STARMX#                              Transfer neighbor symmetry       PC70  41
DO J=1,NLAT#                                                            PC70  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PC70  43
writepkt:(2,lrsymm:,12,IPTO)#                                           PC70  44
movereal:(QX(I+1),1,QX(IPTO+1),1,12,0)# Move the symop to qx            PC70  45
I=I+12#                                                                 PC70  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PC70  47
#   COPY REST OF RECORDS                                                PC70  48
DO I=incr:(lrsymm:),lrslav:#                                            PC70  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PC70  50
REPEAT#                                                                 PC70  51
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PC70  52
readwpkt:(NEIFIL,I,PSIZE,IPT,0)#                                        PC70  53
IF(IPT<=0) BREAK#                                                       PC70  54
writepkt:(2,I,PSIZE,IPTO)#                                              PC70  55
movereal:(QX(IPT+1),1,QX(IPTO+1),1,PSIZE,0)#                            PC70  56
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PC70  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PC70  58
copyfile:(1,2,incr:(lrslav:),endrecord:)#                               PC70  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PC70  60
RETURN#                                                                 PC70  61
END#                                                                    PC70  62
pmacro:([no:])#                                                         PC70  63
