systemheader:(PD    )#                                                  PD     1
####################################################################### PD     2
#                                                                     # PD     3
#                            *** PROATM ***                           # PD     4
#                                                                     # PD     5
#  THE PROGRAM PROATM LOADS ATOM PARAMETERS IN THE FORM DEFINED       # PD     6
#  BY THE PROTEIN DATA BANK AT BROOKHAVEN.  IT STORES THE INFORMATION # PD     7
#  GIVEN IN PDB SCALE1, SCALE2, SCALE3, ATOM, HETATM, SIGATM,         # PD     8
#  ANISOU, AND SIGUIJ LINES (CARD IMAGES).  IT ALSO DEFINES           # PD     9
#  LINES WHICH ARE BASED ON FREE FORMAT INPUT OF XTAL, BUT CONTAIN    # PD    10
#  THE SAME INFORMATION IN PROAT , PROHET, PROSGA, PROUIJ, AND        # PD    11
#  PROSGU INPUT LINES.  THE LINES IN EITHER FORM ARE LOADED IN THE    # PD    12
#  ORDER ENCOUNTERED INTO LRATOM OF THE OUTPUT BINARY DATA FILE.      # PD    13
#  THE PROCESS IS A MERGING PROCESS FOR LRATOM BASED ON ATOM SERIAL   # PD    14
#  NUMBER.  A UNIQUE XTAL ATOM NAME (ID NO. 14, 8 CHARACTERS) IS      # PD    15
#  FORMED FROM THE SCATTERING FACTOR NAME AND THE PDB SERIAL NUMBER.  # PD    16
#  ALL THE ORIGINAL ATOM NAME INFORMATION IS RETAINED IN LRATOM.      # PD    17
#  PROVISION IS MADE FOR DELETING ATOMS, IN ORDER, AS WELL AS ADDING  # PD    18
#  ATOMS TO LRATOM.                                                   # PD    19
#  IN ADDITION, AS THE ATOMS ARE LOADED, THE SEQUENCE INFORMATION IS  # PD    20
#  GATHERED AND STORED IN LRSEQU:.                                    # PD    21
#                             J.M. STEWART U.W.A. PERTH NOV 1986      # PD    22
#                                          N.r.l. washington d.c. 1989# PD    23
####################################################################### PD    24
#                                                                       PD    25
include:(XMACRO)#                                                       PD    26
#                                                                       PD    27
macro:(mxwdim:,incr:(arith:(decr:(mxchim:),/,mxchwd:)))#                PD    28
macro:(numchains:,25)#                 Maximum number of chains         PD    29
#                                                                       PD    30
extrude:(PDCOMN)#                                                       PD    31
INTEGER ACTPAR#    ## ACTUAL NUMBER OF PARAMETERS GOING TO BDF IN       PD    32
#                  ## THE CURRENT RUN.                                  PD    33
REAL   ATEPSQ#     ## EIGHT PI SQUARED.                                 PD    34
REAL   ATWTS(16)#  ## ATOMIC WEIGHTS FOR DENSITY CALC.                  PD    35
REAL   BCUT#       ## ISO T.F.S GREATER THAN THIS U ARE B'S!            PD    36
REAL   BDFDEL#     ## SIGNAL FOR BDF ATOM DELETION IN PD41              PD    37
REAL   BETOB(6)#   ## BETA TO B CONVERSION FACTORS                      PD    38
INTEGER BMAX#      ## MAXIMUM ACTIVE ITEM IN ATOM BUFFERS               PD    39
INTEGER B1ORU2#    ## =1 IF B TEMP FACTS, =2 IF U TEMP FACTS OUTPUT     PD    40
REAL   BTOBET(6)#  ## B TO BETA CONVERSION FACTORS                      PD    41
REAL   ORTHTF(12)# ## ORTHOGONAL TO FRACTIONAL ATOM COORDINATES         PD    42
REAL   PDBTFC(3)#  ## CONVERSION FROM ANISO TO ISO ALA PROT DAT BASE    PD    43
REAL   ROT(9)#     ## ROTATION MATRIX FOR SPECIAL SYM OPERATOR          PD    44
REAL   TRANS(3)#   ## SPECIAL SYMOP TRANSLATION VECTOR                  PD    45
REAL   FTORTH(12)# ## FRACTIONAL TO ORTHOGNAL ATOM COORDINATES          PD    46
REAL   CELPD(6)#   ## DIRECT UNIT CELL PARAMETERS                       PD    47
string:(CHAINI,3)# ## Current chain identifier                          PD    48
string:(CHAOLD,3)# ## Chain identifier for checking                     PD    49
string:(CHACNM,arith:(12,*,numchains:))# ## Residue names C terminal    PD    50
INTEGER CHACTR(numchains:)# ## Residue pointer for C terminal           PD    51
string:(CHANNM,arith:(12,*,numchains:))# ## Residue names N terminal    PD    52
INTEGER CHANTR(numchains:)# ## Residue pointer for N terminal           PD    53
INTEGER CHANUM#    ## Count of chains identified                        PD    54
string:(BDFID,8)#  ## CHAR ARRAY TO HOLD XTAL ATOM NAME FROM FILE A     PD    55
REAL    CVOL#      ## UNIT CELL VOLUME                                  PD    56
string:(DATID,144)## DATA SET NAMES 12 CHARS PER NAME                   PD    57
REAL    DEFAUL(43)## DEFAULT VALUES FOR ALL PARAMETERS TO BE STORED     PD    58
#                  ## LRATOM: THESE VALUES WILL BE SUBSTITUTED FOR      PD    59
#                  ## ANY VOID INPUT FIELDS ON THE INPUT LINES          PD    60
INTEGER DELETE#    ## SIGNAL ATOMS TO BE DELETED                        PD    61
INTEGER DOP(43)#   ## SIGNAL WORD SHOWING WHICH PARAMETERS FROM INPU    PD    62
REAL INDEXP(43)#   ## INDEX NUMBERS OF LRATOM, EXCEPT 14, ATOM ID       PD    63
REAL BUFBDF(43)#   ## UNPACKED PARAMETERS FROM INPUT BDF                PD    64
REAL BUFLIN(43)#   ## DECODED PARAMETERS FROM LINE INPUT STREAM         PD    65
REAL BUFOUT(43)#   ## UNPACKED, READIED PARAMETERS FOR OUTPUT BDF       PD    66
REAL DIROUT(43)#   ## NEWLY PREPARED DIRECTORY PACKET FOR O/P BDF       PD    67
REAL DEFOUT(43)#   ## DEFAULT VALUES FOR REQUIRED OUTPUT NOT INPUT      PD    68
INTEGER RELBDF(44)## OFFSETS FOR INPUT BDF PACKETS                      PD    69
INTEGER RELOUT(43)## OFFSETS FOR OUTPUT BDF PACKETS                     PD    70
INTEGER RELLIN(43)## OFFSETS FOR INPUT LINE QUANTITIES                  PD    71
INTEGER WNTBDF(43)## WANT LIST FOR INPUT BDF                            PD    72
REAL  DSETN#       ## CURRENT DATA SET NUMBER                           PD    73
INTEGER ENDBDF# ## SIGNAL END OF lratom: ON FILE A ENCOUNTERED          PD    74
INTEGER ENDLIN# ## SIGNAL END LINE ENCOUNTERED IN INPUT STREAM          PD    75
INTEGER FIELD#     ## CURRENT INPUT FIELD IN PD51                       PD    76
string:(FUNAME,320)## SET LINE FUNCTIONS                                PD    77
INTEGER INATOM#    ## COUNT OF NUMBER OF ATOMS LOADED DURING RUN        PD    78
INTEGER INNEW#     ## COUNT OF NEW ATOMS INPUT DURING RUN.              PD    79
INTEGER INREPL#    ## COUNT OF ATOMS WHICH REPLACE ATOMS IN FILE.       PD    80
INTEGER INBEFO#    ## COUNT OF ATOMS RECEIVED FROM THE INPUT BDF.       PD    81
INTEGER INORTH#    ## SIGNAL LOADING OF ORTHOGONAL TO FRACTIONAL XYZS   PD    82
INTEGER INOUT#     ## COUNT OF ATOMS WRITTEN TO THE OUTPUT FILE.        PD    83
INTEGER INDELE#    ## COUNT OF ATOMS DELETED                            PD    84
INTEGER INGEN(3)#  ## COUNTS OF SCALE, EXTINC, AND UOV INPUT            PD    85
INTEGER INGENP(3)# ## OFFSETS IN QX ARRAY TO REACH DATASET NAME         PD    86
INTEGER INGENM(3)# ## MARKS, MARKE, MARKB FOR LOOPS ON GENERAL P        PD    87
INTEGER INGENS(3)# ## STEPS,  STEPE,  STEPB FOR SCALE, EXTINC, UOV      PD    88
INTEGER INSERT#    ## FLAG FOR INSERTION FUNCTION DURING ATOM LOAD      PD    89
INTEGER INSERO#    ## OVERALL INSERTION COUNT                           PD    90
INTEGER ICENT#     ## CENTRICITY FLAG                                   PD    91
string:(IDTES,8)#  ## INPUT FIELD FOR TESTS OF SCATTERING FACTOR TYPE   PD    92
INTEGER LENFUN#    ## LENGTH OF FUNCTION LIST IN PD51                   PD    93
INTEGER LNATNM#    ## LENGTH OF ATOM NAMES IN CHARACTERS                PD    94
INTEGER LTYPE#     ## CRYSTAL LATTICE TYPE SIGNAL                       PD    95
INTEGER LOAD#      ## SIGNAL IF ATOMS TO BE LOADED                      PD    96
INTEGER MARKB#     ## START OV OVERALL B STORAGE                        PD    97
INTEGER MARKE#     ## START OF EXTINCTION FACTOR STORAGE                PD    98
INTEGER MARKR#     ## START ARRAY FOR RESIDUE SEQUENCE INFO LRSEQU:     PD    99
INTEGER MARKS#     ## START OF SCALE FACTOR STORAGE (F REL)             PD   100
INTEGER MX24#      ## MAXIMUM NUMBER OF WORDS TO HOLD 24 CHARACTERS ^   PD   101
INTEGER MX12#      ## MAXIMUM NUMBER OF WORDS TO HOLD 12 CHARACTERS     PD   102
INTEGER MX16#      ## MAXIMUM NUMBER OF WORDS TO HOLD 16 CHARACTERS     PD   103
INTEGER MXGLOB#    ## MAXIMUM NUMBER OF SCALE FACTORS PER RUN           PD   104
INTEGER MXDATS#    ## MAXIMUM NUMBER OF DATA GROUPS PER RUN             PD   105
INTEGER NCSFN(16)# ## NUMBER OF CHARACTERS IN EACH SCAT FAC NAME        PD   106
INTEGER NDSET#     ## NUMBER OF DIFFERENT DATA SETS IN BDF              PD   107
INTEGER NDSETN#    ## THE NUMBER OF CHARACTERS IN THE DATA SET NAME     PD   108
INTEGER NLINES#    ## THE NUMBER OF DIFFERENT KINDS OF ATOM PARAM       PD   109
#                  ## INPUT LINES THAT THE PROGRAM KNOWS ABOUT          PD   110
INTEGER NRESID#    ## TOTAL NUMBER OF RESIDUES ENCOUNTERED              PD   111
INTEGER NSFMX#     ## NUMBER OF CHARACTERS IN LONGEST SCAT FAC NAME     PD   112
INTEGER NSFNAM#    ## TOTAL NUMBER OF CHARACTERS IN THE SF NAME TBL     PD   113
INTEGER NSFTOT#    ## TOTAL NUMBER OF SCATTERING FACTOR TYPES           PD   114
string:(NEWID,24)# ## CHAR ARRAY FOR XTAL ATOM ID FORMED FROM INPUT ^   PD   115
string:(OUTID,24)## HOLDING ARRAY FOR XTAL ATOM NAME FOR OUTPUT BDF ^   PD   116
REAL    ODENS#     ## Observed cell density                             PD   117
INTEGER  STEPB#    ## PER UOV                                           PD   118
INTEGER  STEPS#    ## PER F REL SCALE FACTOR                            PD   119
INTEGER PMAXP#     ## MAXIMUM POSSIBLE NUMBER OF DIFFERENT PARAMETER    PD   120
#                  ## PER ATOM.                                         PD   121
INTEGER POLSPG(3)# ## POLAR SPACE GROUP SIGNALS                         PD   122
INTEGER PRINT#     ## SIGNAL TO TELL IF ATOMS ARE TO BE PRINTED         PD   123
INTEGER PUNCH#     ## SIGNAL TO TELL IF PROTEIN DATA BANK LINES OUT     PD   124
string:(RESABB,308)## TABLE OF PROTEIN DATA BASE RESIDUE NAMES          PD   125
string:(RESCHK,5)# ## CHECK RESIDUE SERIAL NO. & INSERTION CODES        PD   126
string:(RESNUM,5)# ## CURRENT RESIDUE SERIAL NO. & INSERTION CODES      PD   127
string:(RESNAM,4)# ## CURRENT RESIDUE NAME AS 3 OR 4 CHARS E.G. LYS     PD   128
string:(RESBUF,16)## BUFFER FOR lrsequ: RESIDUE SEQUENCE RECORD         PD   129
INTEGER PSIZO#     ## SIZE OF lratom: OUTPUT PACKETS                    PD   130
REAL    SCATNO#    ## POINTER TO CURRENT SCAT FAC DURING LOADING        PD   131
REAL    SERLIN#    ## SERIAL NUMBER OF ATOM FROM LINE INPUT             PD   132
REAL    SERBDF#    ## SERIAL NUMBER OF ATOM FROM BDF ON FILE A          PD   133
string:(SFNAME,96)## ARRAY OF SCAT FACTOR NAMES 6CH/NAME                PD   134
REAL    SHIFT(3)#  ## SHIFT OF ATOM COORDS (REVERSE IF SHIFT(1)=100)    PD   135
INTEGER SIGPCH#    ## SIGNAL THAT SIGMA LINES SHOULD BE PUNCHED         PD   136
INTEGER STEPR#     ## NUMBER OF WORDS PER RESIDUE RECORD PACKET         PD   137
INTEGER  STOPR#    ## END OF RESIDUE SEQUENCE INFORMATION               PD   138
INTEGER  STOPX#    ## END OF SPECIAL POSITION CONSTRAINTS               PD   139
REAL    SYMFAC#    ## SCALE CELL CONTENTS..NSYM*CELL TYPE               PD   140
INTEGER SYMIN#    ## SIGNAL SYMOP LINE ACTIVE                           PD   141
REAL    TATOMS(16)## TOTAL ATOMS OF EACH TYPE IN WHOLE CELL             PD   142
REAL    TFCON(18)# ## FIRST SIX GIVE BETA TO UIJ BY MULTIPLY            PD   143
#                  ## SECOND SIX; BETA TO BIJ                           PD   144
#                  ## THIRD BETA TO BETA                                PD   145
INTEGER TFTYPE#    ## SIGNAL SHOWING TYP OF TEMPERATURE FACTORS         PD   146
#                  ## BEING LOADED 0=OVERALL, 1=INDISO,                 PD   147
#                  ## 2=IND ANISO, 3=MIXED INDIVIDUAL                   PD   148
INTEGER TOTRES#    ## TOTAL CHARACTERS IN RESIDUE NAME ABBREVIATIONS    PD   149
REAL    UTOUIJ(6)# ## Convert U to U IJ by multiply                     PD   150
#                                                                       PD   151
COMMON/COMIPD/ ACTPAR,B1ORU2,DOP   ,NCSFN ,NSFMX ,NSFNAM,NSFTOT, $#     PD   152
NDSETN,MX24   ,MX12   ,MX16   ,PRINT ,PUNCH ,$#                         PD   153
CHACTR,CHANTR,CHANUM,DELETE,POLSPG,LENFUN,LNATNM,$#                     PD   154
INATOM,INBEFO,INDELE,INREPL,INORTH,INOUT,INNEW,FIELD,  $#               PD   155
MARKB ,MARKE ,MARKR ,MARKS , STEPB,STEPS ,INGEN ,INGENM,INGENP,INGENS,$#PD   156
NDSET ,NRESID,TFTYPE,MXGLOB,MXDATS,PMAXP ,STEPR ,STOPR ,STOPX,$#        PD   157
INSERT,INSERO,SIGPCH,BMAX  ,ENDBDF,ENDLIN,PSIZO ,NLINES,$#              PD   158
ICENT ,LTYPE ,LOAD  ,SYMIN ,TOTRES,$#                                   PD   159
RELBDF,RELOUT,RELLIN,WNTBDF#                                            PD   160
#                                                                       PD   161
COMMON/COMFPD/ATEPSQ,BETOB ,BTOBET,CELPD ,DEFAUL,DSETN ,$#              PD   162
SCATNO,TFCON ,INDEXP,ODENS ,PDBTFC,ROT   ,TRANS ,BCUT  ,$#              PD   163
ATWTS ,ORTHTF,FTORTH,SERLIN,SERBDF,SYMFAC,TATOMS,CVOL,SHIFT ,$#         PD   164
BUFBDF,BUFLIN,BUFOUT,DIROUT,DEFOUT,BDFDEL,UTOUIJ#                       PD   165
#                                                                       PD   166
COMMON/COMCPD/BDFID,NEWID,OUTID,SFNAME,DATID ,IDTES,FUNAME,$#           PD   167
CHACNM,CHANNM,CHAINI,CHAOLD,RESABB,RESCHK,RESNUM,RESNAM,RESBUF#         PD   168
endext:#                                                                PD   169
#                                                                       PD   170
systemheader:(PD00)#                   Load protein data bank atoms     PD00   1
# ################################################################## #  PD00   2
#                                                                    #  PD00   3
#                               PD00                                 #  PD00   4
#                                                                    #  PD00   5
# ################################################################## #  PD00   6
SUBROUTINE PD00#                       J.m. stewart nov 1986            PD00   7
include:(AACOMN)#                                                       PD00   8
include:(PDCOMN)#                                                       PD00   9
#                                                                       PD00  10
#  BECAUSE OF THE STRANGE PROTEIN DATA BANK INPUT LINES THE             PD00  11
#  XTAL SYNTAX CHECKING MESSAGES MUST BE SHUT OFF.                      PD00  12
#                                                                       PD00  13
SYNTXF=1#                              Turn off input line checks       PD00  14
CALL PD11## READ PRELIMINARY DATA AND INSTRUCTIONS READ AND COPY BDF    PD00  15
IF(LOAD==yes:)## PROGRAM MAY BE RUN SIMPLY TO PRINT OR PUNCH PDB DAT    PD00  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PD00  17
CALL PD21## LOAD INITIAL RECORDS OF THE BDF FOR CELL, SYMMETRY, ETC.    PD00  18
CALL PD31## SET UP LOGICAL RECORD lratom: ARRANGEMENT                   PD00  19
CALL PD41## WRITE LOGICAL RECORD lratom: AND INPUT NEW ATOM LINES       PD00  20
#        ## AND WRITE MERGED ATOMS TO FILE H. NO ATOMS KEPT IN MEMORY   PD00  21
CALL PD81## FINISH OFF THE LOADING OF THE OUTPUT BDF.                   PD00  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PD00  23
CALL PD91## READ ATOMS TO OUTPUT TO PRNT/PNCH/FILE B                    PD00  24
SYNTXF=0#                              Restore line input checks        PD00  25
IF(QUITF!=' ')iquit:(PD0001)#          Die if errors detected           PD00  26
#                                                                       PD00  27
RETURN#                                                                 PD00  28
END#                                                                    PD00  29
systemheader:(PD05)#                                                    PD05   1
# ################################################################## #  PD05   2
#                                                                    #  PD05   3
#                               PD05                                 #  PD05   4
#                                                                    #  PD05   5
# ################################################################## #  PD05   6
SUBROUTINE PD05(NCH1)#                                                  PD05   7
###IMPLICIT NONE#                                                       PD05   8
include:(AACOMN)#                                                       PD05   9
include:(PDCOMN)#                                                       PD05  10
#                                                                       PD05  11
# SUBROUTINE TO FIND SCATTERING FACTOR POINTER FROM                     PD05  12
# ATOM NAME AND TABLE OF SCATTERING FACTOR NAMES.                       PD05  13
# SEARCH IS FROM LONGEST TO SHORTEST SF NAME IN ORDER                   PD05  14
# NOT TO BE CONFUSED BETWEEN THE LIKES OF CU AND C.                     PD05  15
#                       J.M.STEWART SEPT 1984                           PD05  16
#                                                                       PD05  17
INTEGER J#                             Loop index                       PD05  18
INTEGER KEY#                           Signal returned by compchar:     PD05  19
INTEGER NCH1#                          Chars in whole atom name         PD05  20
INTEGER NCH2#                          Number of chars to search        PD05  21
chardata:(PD52,[0123456789() ])#                                        PD05  22
datastuff:#                                                             PD05  23
#                                                                       PD05  24
#                                      ******** identify atom type      PD05  25
NCH2=MIN0(NCH1,NSFMX)#                 Limit atom id to max             PD05  26
FOR(J=NCH2;J>=1;J=J-1)#                Vary atom id lengths             PD05  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PD05  28
compchar:(NEWID,J,PD52,1,1,1,NPD52,KEY)# Test for allowed character     PD05  29
IF(KEY==0) BREAK#                      Exit on unallowed character      PD05  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PD05  31
movechar:(BLANK,1,IDTES,1,6,1)#        Clear s.f. id for test           PD05  32
movechar:(NEWID,1,IDTES,1,J,0)#        Move in whole or part id         PD05  33
compchar:(IDTES,1,SFNAME,1,6,6,NSFNAM,KEY)# Test for match with sf      PD05  34
IF(KEY==0) iquit:(PD0510)#             No ff                            PD05  35
SCATNO=FLOAT(KEY)#                     Store scat factor                PD05  36
NCH1=J#                                Remember length                  PD05  37
#                                                                       PD05  38
RETURN#                                                                 PD05  39
END#                                                                    PD05  40
systemheader:(PD08)#                   Matrix inversion                 PD08   1
###############################################################         PD08   2
#                                                                       PD08   3
#                             PD08                                      PD08   4
#                                                                       PD08   5
###############################################################         PD08   6
SUBROUTINE PD08(A,AI)#                 W. dreissig 10/85                PD08   7
###IMPLICIT NONE#                                                       PD08   8
#                                                                       PD08   9
## 3*3-MATRIX INVERSION                                                 PD08  10
#                                                                       PD08  11
REAL     A(3,3)#                       Matrix                           PD08  12
REAL     AI(3,3)#                      Inverted matrix                  PD08  13
REAL     DET#                          Determinant of a                 PD08  14
INTEGER  I,J,K,L,M,N#                  Indices                          PD08  15
#                                                                       PD08  16
DO I=1,3#                              Outer loop                       PD08  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PD08  18
K=1+MOD(I+1,3)#                                                         PD08  19
M=1+MOD(I+3,3)#                                                         PD08  20
DO J=1,3#                              Inner loop                       PD08  21
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PD08  22
L=1+MOD(J+1,3)#                                                         PD08  23
N=1+MOD(J+3,3)#                                                         PD08  24
AI(I,J)=A(L,K)*A(N,M)-A(L,M)*A(N,K)#   Determinant of adjunct           PD08  25
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PD08  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PD08  27
DET=0.0#                               Initialize determinant           PD08  28
DO I=1,3; DET=DET+A(I,1)*AI(1,I)#      Determinant                      PD08  29
IF(DET<=small:) iquit:(PD0801)#        Check against singular           PD08  30
DO I=1,3#                              Outer loop                       PD08  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PD08  32
DO J=1,3; AI(I,J)=AI(I,J)/DET#         Inverse matrix                   PD08  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PD08  34
#                                                                       PD08  35
RETURN#                                                                 PD08  36
END#                                                                    PD08  37
systemheader:(PD11)#                                                    PD11   1
# ################################################################## #  PD11   2
#                                                                    #  PD11   3
#                               PD11                                 #  PD11   4
#                                                                    #  PD11   5
# ################################################################## #  PD11   6
SUBROUTINE PD11#                       J.m. stewart uwa nov 1986        PD11   7
include:(AACOMN)#                                                       PD11   8
include:(PDCOMN)#                                                       PD11   9
#                                                                       PD11  10
# PROGRAM TO LOAD ATOM COORDINATES FOR MACROMOLECULAR STRUCTURES        PD11  11
# INTO LRATOM OF THE BDF.  COORDINATES ARE ACCEPTED IN PROTEIN          PD11  12
# DATA BANK FORMAT (BROOKHAVEN) AS WELL AS AN XTAL FREE FORMAT          PD11  13
# VARIENT.  NO SORTING, NO CHECKING SPECIAL POSITIONS.                  PD11  14
#                                                                       PD11  15
# TFTYPE    OVE        0    *****   OVERALL TEMPERATURE FACTOR          PD11  16
#           ISO        1            INDIVIDUAL ISOTROPIC TF             PD11  17
#           ANI        2            INDIVIDUAL ANISOTROPIC TF           PD11  18
#           MIX        3            INDIVIDUAL MIXED TF                 PD11  19
#           PRI        YES:         PRINT FLAG                          PD11  20
#           NOP        NO:          PRINT FLAG                          PD11  21
#           APR        YES:(ENDBDF) A-PRIORI RUN IGNORE LRATOM ON BDF   PD11  22
#           MER        NO:(ENDBDF)  MERGE ATOMS FROM BDF AND LINES      PD11  23
#           PCH        YES:         PUNCH PROTEIN DATA BANK ATOMS       PD11  24
#           NPC        NO:          DO NOT PUNCH PDB ATOMS              PD11  25
#           LOD        YES:         LOAD ATOMS AND CREATE MERGED BDF    PD11  26
#           NOL        NO:          BYPASS LOADING AND GO FOR PRIN/PUN  PD11  27
#                                                                       PD11  28
INTEGER I,J,K,L,M,N#                                                    PD11  29
INTEGER IP,PSIZ,JPT#                   Packet copy pointers             PD11  30
INTEGER KEY#                           Pointer for string match         PD11  31
INTEGER NLONG#                         Number of characters in long     PD11  32
REAL MAT(3,3),INVMAT(3,3)#             For orth to fractional xyz       PD11  33
INTEGER STEPE#                         No. of words for extinction      PD11  34
#                                                                       PD11  35
string:(DATS,12)#                      Data set names temp store        PD11  36
string:(LONGLI,179)#                   Names of input lines             PD11  37
#                                                                       PD11  38
# DATA INPUT LINES RECOGNIZED BY PROATM                                 PD11  39
#                                                                       PD11  40
chardata:(PD10, END    ATOM   PROAT  HETATM $#                          PD11  41
PROHET SIGATM PROSGA ANISOU PROANI SIGUIJ PROSGU DEFAUL SYMOP  )#       PD11  42
chardata:(PDAA,PROATI PROATE PROATD PROLOD SCALE  EXTINC UOV    $#      PD11  43
LABEL  SHIFT  SCALE1 SCALE2 SCALE3 )#                                   PD11  44
#                                                                       PD11  45
# OPTION CODES RECOGNIZED BY PROATM                                     PD11  46
#                                                                       PD11  47
chardata:(PD12,OVE BIS UIS ANI MIX PRI NOP APR MER PCH NPC LOD $#       PD11  48
NOL DSN BCU SIG )#                                                      PD11  49
#                                                                       PD11  50
#  THE FOLLOWING DATA STATEMENT DEFINES THE ATOM PARAMETERS             PD11  51
#  LOADED BY =PROATM= AND THE ORDER THAT VARIABLES ARE STORED           PD11  52
#  IN THE EXPANDED INTERMEDIATE BUFFERS.  ALL ACTIVITY OF WHAT          PD11  53
#  DATA ITEMS ARE PLACED IN THE OUTPUT BDF IS CONTROLLED BY             PD11  54
#  YES: AND NO: FLAGS IN THE ARRAY 'DOP' (DO PARAMETER).                PD11  55
#                                                                       PD11  56
chardata:(PD15,X  Y  Z  U  U1 U2 U3 U4 U5 U6 POPAPPRSQSEQSETCHNSQN$#    PD11  57
RESSFTTFTSX SY SZ SPPSU SAPSU1SU2SU3SU4SU5SU6)#                         PD11  58
#  THE FOLLOWING ARRAY GIVES THE INDEX NUMBERS OF LRATOM: IN            PD11  59
#  THE SAME ORDER.                                                      PD11  60
realdata:(DEXNUM,[1.,2.,3.,4.,5.,6.,7.,8.,9.,10.,11.,12.,#              PD11  61
16.,15.,17.,18.,20.,19.,22.,23.,101.,102.,103.,111.,104.,112.,#         PD11  62
105.,106.,107.,108.,109.,110.])#                                        PD11  63
# NOTE THAT THE ITEMS DESIGNATED RES, SEQ, CHN, SQN, AND RES ARE DUE    PD11  64
# TO THE PROTEIN DATA BANK REQUIREMENTS.                                PD11  65
# POSITION IN DOP   LRATOM PACKET ID  PURPOSE                           PD11  66
# RSQ   13                 16         3 LEAST SIG DIG RESIDUE SEQ NO.   PD11  67
#                                     4TH IS INSERTION OF RESIDUES CODE PD11  68
# SEQ   14                 15         CHAR 1 REMOTNESS INDICATOR        PD11  69
#                                     CHAR 2 BRANCH DESIGNATOR          PD11  70
#                                     CHAR 3 SUB-BRANCH DESIGNATOR      PD11  71
#                                     CHAR 4 ALTERNATE LOCATION INDIC   PD11  72
# CHN   16                 18         3 CHAR CHAIN ID (ONLY 1ST PDB)    PD11  73
#                                     CHAR 4 MOST SIG DIG RES SEQ NO.   PD11  74
# RES   18                 19         RESIDUE NAME                      PD11  75
# SQN   17                 20         ATOM SEQUENCE NUMBER              PD11  76
#                                                                       PD11  77
# DURING PROCESSING OF THE INPUT ATOM PARAMETERS ALL POSSIBLE           PD11  78
# QUANTITIES ARE TAKEN FROM BOTH INPUT LINES AND THE INPUT BDF          PD11  79
# ON FILE A.  THE PROCESS IS KEYED TO THE ATOM SERIAL NUMBER AS         PD11  80
# DEFINED BY THE PROTEIN DATA BANK.  ALL THE POSSIBLE QUANTITIES        PD11  81
# REGARDLESS OF HOW COMPACT IN THE INPUT BDF, ARE SPREAD OUT INTO       PD11  82
# ARRAYS BUFLIN AND BUFBFD IN EXACTLY THE SAME PATTERN AS SET FORTH     PD11  83
# IN DATA STATEMENTS PD15 AND DEXNUM.  THEN, DEPENDING ON THE           PD11  84
# QUANTITIES DIRECTED BY THE USER TO BE LOADED, THEY ARE TRANSFERRED    PD11  85
# TO BUFOUT.  ANY MISSING QUANTITIES ARE SUPPLIED FROM ARRAY DEFAUL.    PD11  86
# FINALLY JUST THOSE QUANTITIES SPECIFIED BY THE YES:/NO: SIGNALS       PD11  87
# IN THE DOP ARRAY ARE WRITTEN TO THE OUTPUT BDF ON FILE H IN THE       PD11  88
# FIRST PASS THEN COPIED TO FILE B IN PD91 IN A SECOND PASS WHICH       PD11  89
# GETS THE SEQUENCE DATA GATHERED IN THE FIRST PASS INTO LRSEQU:        PD11  90
#                                                                       PD11  91
chardata:(PD19, THERMAL DISPLACEMENT TYPE                          )#   PD11  92
chardata:(PD20, ZACH TYP1 TYP2 GEN  ISO  ANIS GAUS LORE )#              PD11  93
chardata:(PD22, PROATM CALCULATION PARAMETERS)#                         PD11  94
chardata:(PD23,OVERALL ISOTROPIC     INDIVIDUAL ISOTROPIC  $#           PD11  95
INDIVIDUAL ANISOTROPICINDIVIDUAL MIXED      )#                          PD11  96
chardata:(PD24,-)#                                                      PD11  97
chardata:(PD25,PARENT      )#                                           PD11  98
chardata:(PD26, MERGE ATOMS FROM FILE A WITH THOSE FROM $#              PD11  99
INPUT LINES.)#                                                          PD11 100
chardata:(PD27,[ APRIORI RUN, DISCARD ANY ATOMS IN FILE A.])#           PD11 101
chardata:(PD28, PRINT MERGED ATOM LIST)#                                PD11 102
chardata:(PD29, PUNCH PROTEIN DATA BANK ATOM PARAMETER LINES)#          PD11 103
chardata:(PD30, LOAD ATOMS TO FILE B USING FILE H FOR SCRATCH)#         PD11 104
chardata:(PD31, BYPASS LOADING PROCESS)#                                PD11 105
chardata:(PD32, PUNCH ATOM SIGMAS IF PRESENT IN FILE)#                  PD11 106
chardata:(PD33, DO NOT PUNCH ATOM SIGMAS )#                             PD11 107
chardata:(TRASH,[*])#                  For clearing test strings        PD11 108
realdata:(AP,78.956835)#               Set eight pi squared for t.f     PD11 109
intdata:(NINPAR,32)#                                                    PD11 110
datastuff:#                                                             PD11 111
#                                                                       PD11 112
# LIST OF INPUT LINE NAMES INTO ONE CHARACTER ARRAY.                    PD11 113
#                                                                       PD11 114
movechar:(PD10,1,LONGLI,1,NPD10,0)#                                     PD11 115
movechar:(PDAA,1,LONGLI,NPD10+1,NPDAA,0)#                               PD11 116
NLONG=NPD10+NPDAA#                     Set up the total chars           PD11 117
ATEPSQ=AP#                             Move 8*pi**2 to common           PD11 118
#                                                                       PD11 119
#  SET UP THE TOTAL NUMBER OF PARAMETERS EXCLUSIVE OF XTAL ATOM NAMES   PD11 120
#  ------------------------------------------------------------------   PD11 121
#                                                                       PD11 122
PMAXP=NINPAR#                          Set maximum parameters           PD11 123
MXGLOB=64#                             Set max no. of scales etc.       PD11 124
MXDATS=10#                             Set max no. of data sets         PD11 125
DO I=1,3;   SHIFT(I)=0.#               Zero xyz shifts                  PD11 126
DO I=1,12#                             Clear orthogonalizing mats       PD11 127
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PD11 128
ORTHTF(I)=0.0 ; FTORTH(I)=0.0#                                          PD11 129
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PD11 130
#                                                                       PD11 131
#    SET UP COUNTS OF GENERAL PARAMETER INPUT LINES SCALE, EXTINC,      PD11 132
# AND UOV.  ALSO SET VALUES THAT SKIP ACROSS DATA TO DATA SET NAMES.    PD11 133
#                                                                       PD11 134
INGEN(1)=0;INGEN(2)=0;INGEN(3)=0#                                       PD11 135
INGENP(1)=2;INGENP(2)=16;INGENP(3)=1#                                   PD11 136
TFTYPE=0#                              Set the default to overall       PD11 137
B1ORU2=2#                              Assume u temp factor output      PD11 138
PRINT=yes:#                            Set to print atoms in pd10       PD11 139
PUNCH=no:#                             No pdb atom lines to punch       PD11 140
LOAD=yes:#                             Atom loading in run              PD11 141
ENDBDF=no:#                            Lratom: on bdf has atoms         PD11 142
INSERT=no:#                            Insertion not in progress        PD11 143
DSETN=1.0#                             Assume parent data set           PD11 144
ENDLIN=no:#                            Input stream has atoms           PD11 145
SYMIN=no:#                             Shut off symop line activity     PD11 146
INORTH=no:#                            Signal no orth to fract matr     PD11 147
SIGPCH=no:#                            Signal punch no sigmas           PD11 148
NLINES=4#                              Set the number of different      PD11 149
#                                 KINDS OF ATOM PARAMETER INPUT LINES.  PD11 150
BCUT=0.6332574#                        U's above this are b's!          PD11 151
#                                                                       PD11 152
#    SCAN THE PROATM LINE FOR INSTRUCTIONS                              PD11 153
#    -------------------------------------                              PD11 154
#                                                                       PD11 155
FOR(K=1;BUFIN(K)<voidflg:;K=K+1)#      Loop over input fields           PD11 156
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PD11 157
stringlim:(K,N,M)#                     Pick out the string              PD11 158
compchar:(CHRIN,N,PD12,1,3,4,NPD12,KEY)# Look for a match in the lis    PD11 159
IF(KEY==0) iquit:(PD1104,K)#                                            PD11 160
IF(KEY==1) TFTYPE=KEY-1#               Set temperature factor type      PD11 161
ELSE IF(KEY==2)#                       Individual b temp factor         PD11 162
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PD11 163
TFTYPE=KEY-1#                          Set temperature factor type      PD11 164
B1ORU2=1#                              Remember to output b temp fa     PD11 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PD11 166
ELSE IF(KEY>=3&KEY<=5) TFTYPE=KEY-2#   Set temperature factor type      PD11 167
ELSE IF(KEY==7) PRINT=no:#             Shut off the printing            PD11 168
ELSE IF(KEY==8) ENDBDF=yes:#           Set for apriori load             PD11 169
ELSE IF(KEY==10) PUNCH=yes:#           Set to punch pdb atoms           PD11 170
ELSE IF(KEY==13)LOAD=no:#              Shut off loading process         PD11 171
ELSE IF(KEY==14)#                      Data set number                  PD11 172
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PD11 173
IF(BUFIN(K+1)>0.0&BUFIN(K+1)<=12.0)#   In range?                        PD11 174
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PD11 175
DSETN=BUFIN(K+1) ; K=K+1#              Take it and skip field           PD11 176
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PD11 177
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PD11 178
ELSE IF((KEY==15)&(BUFIN(K+1)>=0.0)) BCUT=BUFIN(K+1)# Set u-b boundar   PD11 179
ELSE IF(KEY==16) SIGPCH=yes:#          User wants sigmas punched        PD11 180
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PD11 181
#                                                                       PD11 182
#    SET THE PARAMETERS TO LOAD SIGNALS TO DEFAULT VALUES               PD11 183
#    -----------------------------------------------------              PD11 184
#                                                                       PD11 185
FOR(J=1;J<=PMAXP;J=J+1)#               Clear the signals                PD11 186
DOP(J)=no:#                            Say no to everything             PD11 187
#                                                                       PD11 188
#    SET UP FOR X,Y,Z, SF TYPE AND PDB STUFF AS A MINIMUM               PD11 189
#    --------------------------------------------------------------     PD11 190
#                                                                       PD11 191
DOP(1)=yes:;DOP(2)=yes:;DOP(3)=yes:;DOP(19)=yes:# X, y, z, & sft        PD11 192
DOP(13)=yes:;DOP(14)=yes:;DOP(16)=yes:;DOP(17)=yes:;DOP(18)=yes:#       PD11 193
DOP(11)=yes:#                          Population parameter             PD11 194
IF(TFTYPE==3)#                         Test if mixed tfs                PD11 195
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PD11 196
DOP(4)=yes:;DOP(5)=yes:;DOP(6)=yes:;DOP(7)=yes:# Turn on all t.f.       PD11 197
DOP(8)=yes:;DOP(9)=yes:;DOP(16)=yes:;DOP(10)=yes:# Parameters           PD11 198
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PD11 199
ELSE IF(TFTYPE==2)#                    Individ aniso?                   PD11 200
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PD11 201
DOP(5)=yes:;DOP(6)=yes:;DOP(7)=yes:;DOP(8)=yes:# Turn on anisos         PD11 202
DOP(9)=yes:;DOP(10)=yes:#                                               PD11 203
DOP(4)=yes:#                           Protein data bank says iso t     PD11 204
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PD11 205
ELSE IF(TFTYPE==1)#                    Individ isotropic?               PD11 206
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PD11 207
DOP(4)=yes:#                           Set loading of isotropic b       PD11 208
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PD11 209
#                                                                       PD11 210
#    SET UP IO BUFFERS FOR FILES A AND B                                PD11 211
#    -----------------------------------                                PD11 212
#                                                                       PD11 213
FILEXT(IOUNIT(8))='XX1'#               Set up scratch file on h         PD11 214
IOMARK(1)=QXSTR#                       Get io buffer for file a         PD11 215
IOMARK(2)=IOMARK(1)+bdfbuf:#           Get io buffer for file b         PD11 216
IOMARK(8)=IOMARK(2)+bdfbuf:#           Get io buffer for file h         PD11 217
#                                                                       PD11 218
#    SET THE NUMBER OF WORDS TO HOLD 24, 16, AND 12 CHARACTERS          PD11 219
#    ---------------------------------------------------------          PD11 220
#                                                                       PD11 221
MX24=incr:(arith:(23,/,mxchwd:))#                                       PD11 222
LNATNM=24#                             Set length of xtal atom name     PD11 223
MX12=incr:(arith:(11,/,mxchwd:))#                                       PD11 224
MX16=incr:(arith:(15,/,mxchwd:))#                                       PD11 225
#                                                                       PD11 226
#    SET UP STORAGE POINTERS FOR INPUT PARAMETERS                       PD11 227
#    --------------------------------------------                       PD11 228
#                                                                       PD11 229
MARKS=IOMARK(8)+bdfbuf:#                                                PD11 230
STEPS=MX12+2#                                                           PD11 231
INGENM(1)=MARKS;INGENS(1)=STEPS#       Space for scale factors          PD11 232
MARKE=MARKS+MXGLOB*STEPS#                                               PD11 233
STEPE=MX12+INGENP(2)#                                                   PD11 234
INGENM(2)=MARKE;INGENS(2)=STEPE#       Space for extinction fctrs       PD11 235
MARKB=MARKE+MXDATS*STEPE#                                               PD11 236
STEPB=MX12+1#                                                           PD11 237
INGENM(3)=MARKB;INGENS(3)=STEPB#       Space for overall t.f.s          PD11 238
incrqx:(MARKR,MARKB+MXDATS*STEPB,PD1102)# Qx up to start lrsequ: bu     PD11 239
STEPR=MX16#                            Set packet size for lrsequ:      PD11 240
STOPR=MARKR ; NRESID=0 ; movechar:(BLANK,1,RESCHK,1,5,1)# Residue che   PD11 241
#                                                                       PD11 242
movechar:(TRASH,1,CHAOLD,1,3,1)#       Clear chain id checker           PD11 243
CHANUM=0 ; DO I=1,numchains:#          Clear terminal c & n counts      PD11 244
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PD11 245
CHACTR(I)=0 ; CHANTR(I)=0#                                              PD11 246
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PD11 247
#                                                                       PD11 248
#     PRINT OUT THE SUMMARY OF CALCULATION TO BE DONE                   PD11 249
#    ------------------------------------------------                   PD11 250
#                                                                       PD11 251
movechar:(PD24,1,CHROT,2,NPD22-1,1)#                                    PD11 252
writeline:(2,PD22,NPD22,2,3)#                                           PD11 253
K=TFTYPE*22+1#                                                          PD11 254
movechar:(PD23,K,PD19,28,22,0)#                                         PD11 255
writeline:(1,PD19,NPD19,3,3)#                                           PD11 256
IF(ENDBDF==no:) writeline:(1,PD26,NPD26,3,3)# Get any atoms in file a   PD11 257
ELSE            writeline:(1,PD27,NPD27,3,3)# A-priori load             PD11 258
IF(PRINT==yes:) writeline:(1,PD28,NPD28,3,3)# Say print atoms           PD11 259
IF(PUNCH==yes:) writeline:(1,PD29,NPD29,3,3)# Say punch 'em             PD11 260
IF(LOAD==yes:)  writeline:(1,PD30,NPD30,3,3)# Say load 'em              PD11 261
ELSE            writeline:(1,PD31,NPD31,3,3)# No load in force          PD11 262
IF(SIGPCH==yes:) writeline:(1,PD32,NPD32,3,3)# Say punch 'em            PD11 263
ELSE            writeline:(1,PD33,NPD33,3,3)# No punch of sigmas        PD11 264
#                                                                       PD11 265
INATOM=0#                              Set count of atoms input to      PD11 266
INOUT=0#                               Set number of atoms in outpu     PD11 267
INREPL=0#                              Set number of atoms replaced     PD11 268
INBEFO=0#                              Set number of atoms from bdf     PD11 269
INNEW=0#                               Set number of atoms from inp     PD11 270
INDELE=0#                              Set number of deleted atoms      PD11 271
INSERO=0#                              8et number of inserted atoms     PD11 272
IF(LOAD==yes:)#                        Is loading to be done?           PD11 273
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PD11 274
copyfile:(1,8,1,decr:(lrlabl:))#       Copy hist rec up to lrlabl:      PD11 275
#                                                                       PD11 276
#  UPDATE LABEL RECORD ON BDF IF NEED BE                                PD11 277
#  -------------------------------------                                PD11 278
#                                                                       PD11 279
REPEAT#                                Copy old labels forward          PD11 280
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PD11 281
readwpkt:(1,lrlabl:,PSIZ,IP,0)#                                         PD11 282
IF(IP<=0)BREAK#                        Stop when input drained          PD11 283
writepkt:(8,lrlabl:,PSIZ,JPT)#                                          PD11 284
movereal:(QX,IP+1,QX,JPT+1,PSIZ,1)#    Copy old records across          PD11 285
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PD11 286
readline:(LONGLI,NLONG)#               Get next input image             PD11 287
WHILE(LINID==21)#                      Add on to logical record lrl     PD11 288
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PD11 289
writepkt:(8,lrlabl:,mxwdim:,JPT)#                                       PD11 290
movector:(CHRIN,1,QX(JPT+1),1,mxchim:,0)# Put new labels in bdf         PD11 291
readline:(LONGLI,NLONG)#               Keep reading input               PD11 292
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PD11 293
copyfile:(1,8,incr:(lrlabl:),decr:(lrcell:))#                           PD11 294
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PD11 295
ELSE readline:(LONGLI,NLONG)#          Better be an end line            PD11 296
#                                                                       PD11 297
#   READ INPUT =PROLOD= LINES                                           PD11 298
#   ------------------------                                            PD11 299
#                                                                       PD11 300
REPEAT#                                Loop over global input           PD11 301
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PD11 302
IF(LINID<17) BREAK#                                                     PD11 303
IF(LINID==17)#                         Test for a prolod line           PD11 304
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PD11 305
K=0#                                   Set field pointer to start       PD11 306
REPEAT#                                Look for param name match        PD11 307
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PD11 308
K=K+1#                                 Advance field pointer            PD11 309
ifvo:(BUFIN(K))BREAK#                  Until first void field           PD11 310
IF(BUFIN(K)<(voidflg:))#               Search the character mnemoni     PD11 311
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PD11 312
stringlim:(K,N,M)#                     Pick out the string              PD11 313
M=MIN0(IABS(M-N),3)#                   Find the number of chars         PD11 314
compchar:(CHRIN,N,PD15,1,M,3,NPD15,KEY)# Try to match one               PD11 315
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PD11 316
ELSE#                                  Treat numeric fields             PD11 317
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PD11 318
FOR(KEY=1;KEY<=NINPAR;KEY=KEY+1)#                                       PD11 319
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PD11 320
ifeq:(BUFIN(K),DEXNUM(KEY))BREAK#      Only good index nums             PD11 321
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PD11 322
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PD11 323
IF(KEY==0\KEY>NINPAR) iquit:(-PD1105,K)#                                PD11 324
ELSE DOP(KEY)=1#                       Turn on the parameter            PD11 325
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PD11 326
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PD11 327
#                                                                       PD11 328
#    PROCESS =SHIFT= LINE                                               PD11 329
#    --------------------                                               PD11 330
#                                                                       PD11 331
ELSE IF(LINID==22)#                    Test for shift xyz line          PD11 332
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PD11 333
ifvo:(BUFIN(1)) SHIFT(1)=100.#         Flag for xyz inversion           PD11 334
ELSE DO I=1,3#                         Else assume as origin shift      PD11 335
ifnv:(BUFIN(I)) SHIFT(I)=BUFIN(I)#     Store general xyz shift          PD11 336
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PD11 337
#                                                                       PD11 338
#    PROCESS SCALE, EXTINC, UOV LINES                                   PD11 339
#    -------------------------------                                    PD11 340
#                                                                       PD11 341
ELSE IF((LINID>=18)&(LINID<=20))#      Treat scale,extinc,bov           PD11 342
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PD11 343
IF(LINID==18)#                         Scale line                       PD11 344
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PD11 345
J=INGEN(1)*STEPS+MARKS#                Treat a scale line               PD11 346
QX(J+1)=1.0 ; QX(J+2)=1.0#             Set default values               PD11 347
IF(BUFIN(1)>small:) QX(J+1)=BUFIN(1)#                                   PD11 348
IF(BUFIN(2)>small:) QX(J+2)=BUFIN(2)#                                   PD11 349
J=J+INGENP(1) ; K=3#                   Set for fetching data set na     PD11 350
INGEN(1)=INGEN(1)+1#                   Count up lines in                PD11 351
IF(INGEN(1)>MXGLOB) iquit:(PD1108)#    Die if not enough space          PD11 352
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PD11 353
#                                                                       PD11 354
ELSE IF(LINID==19)#                    Treat extinction line            PD11 355
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PD11 356
J=INGEN(2)*STEPE +MARKE#               Point to extinction              PD11 357
FOR(K=1;K<=INGENP(2);K=K+1) QX(J+K)=0.# Put away ext factors            PD11 358
ifch:(BUFIN(1))#                       Extinction type                  PD11 359
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PD11 360
stringlim:(1,K,L);L=MIN0(4,L-K)#       What type of extinction?         PD11 361
compchar:(CHRIN,K,PD20,2,L,5,20,I)#    Compare ext. types               PD11 362
IF(I==0) iquit:(PD1103)#               Wrong type                       PD11 363
QX(J+1)=FLOAT(I-1)#                    0/1/2/3=zach/bc1/bc2/bcgen       PD11 364
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PD11 365
ifch:(BUFIN(2))#                       Iso or aniso                     PD11 366
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PD11 367
stringlim:(2,K,L);L=MIN0(4,L-K)#       Read field 2                     PD11 368
compchar:(CHRIN,K,PD20,22,L,5,10,I)#   Iso or aniso                     PD11 369
IF(I==0) iquit:(PD1103)#               Wrong code                       PD11 370
IF(I==2) QX(J+1)=QX(J+1)+3.#           Anisotropic types                PD11 371
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PD11 372
ifch:(BUFIN(3))#                       Gauss or lorentz                 PD11 373
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PD11 374
stringlim:(3,K,L);L=MIN0(4,L-K)#       Read field 3                     PD11 375
compchar:(CHRIN,K,PD20,32,L,5,10,I)#   Gauss or lorentz                 PD11 376
IF(I==0) iquit:(PD1103)#               Wrong code                       PD11 377
QX(J+2)=FLOAT(I-1)#                    Distribution type                PD11 378
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PD11 379
ifnm:(BUFIN(4)) QX(J+3)=BUFIN(4)#      Store away iso g ext value       PD11 380
ifnm:(BUFIN(5)) QX(J+4)=BUFIN(5)#      Store away iso rho ext value     PD11 381
J=J+INGENP(2);    K=17#                Incr pointer                     PD11 382
INGEN(2)=INGEN(2)+1#                                                    PD11 383
IF(INGEN(2)>MXDATS) iquit:(PD1109)#                                     PD11 384
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PD11 385
#                                                                       PD11 386
ELSE IF(LINID==20)#                    Treat bov                        PD11 387
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PD11 388
J=INGEN(3)*STEPB+MARKB#                                                 PD11 389
QX(J+1)=0.12665#                       Store b=10.0 as default u valu   PD11 390
IF(BUFIN(1)>=0.0) QX(J+1)=BUFIN(1)#    Take other values                PD11 391
INGEN(3)=INGEN(3)+1#                                                    PD11 392
IF(INGEN(3)>MXDATS) iquit:(PD1110)#                                     PD11 393
J=J+INGENP(3) ; K=2#                                                    PD11 394
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PD11 395
#                                                                       PD11 396
#    SET DATA SET NAME IN B, SCALE, OR EXT ARRAY AS APPROPRIATE         PD11 397
#    ----------------------------------------------------------         PD11 398
#                                                                       PD11 399
movechar:(PD25,1,DATS,1,NPD25,0)#                                       PD11 400
IF(BUFIN(K)<(voidflg:))#                                                PD11 401
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PD11 402
stringlim:(K,N,M)#                                                      PD11 403
M=MIN0(M-N,12)#                                                         PD11 404
movechar:(BLANK,1,DATS,1,12,1)#        Clear to blanks                  PD11 405
movechar:(CHRIN,N,DATS,1,M,0)#                                          PD11 406
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PD11 407
movector:(DATS,1,QX(J+1),1,12,0)#                                       PD11 408
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PD11 409
#                                                                       PD11 410
#  LOAD ORTHOGNAL TO FRACTIONAL TRANSFORMATION MATRIX                   PD11 411
#  --------------------------------------------------                   PD11 412
#                                                                       PD11 413
ELSE IF((LINID>=23)&(LINID<=25))#      The three scale lines            PD11 414
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 PD11 415
IF(LINID==23) K=1#                     Set pointer                      PD11 416
ELSE IF(LINID==24) K=5#                                                 PD11 417
ELSE K=9#                                                               PD11 418
IF(BUFIN(4)<=voidflg:) BUFIN(4)=0.0#   Set translation if void          PD11 419
DO J=1,4#                              Loop over fields                 PD11 420
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 PD11 421
IF(BUFIN(J)<=voidflg:) iquit:(PD1107)# Demand matrix elements           PD11 422
ORTHTF(K)=BUFIN(J)#                    Take any number                  PD11 423
K=K+1#                                                                  PD11 424
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 PD11 425
IF(K>12)#                              When all loaded find inv         PD11 426
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 PD11 427
L=0 ; DO K=1,3#                        Put in form needed by pd08       PD11 428
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 PD11 429
DO J=1,3#                                                               PD11 430
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 PD11 431
L=L+1#                                 Advance across 1-d array         PD11 432
MAT(K,J)=ORTHTF(L)#                    Move matrix element              PD11 433
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 PD11 434
L=L+1#                                 Skip translation                 PD11 435
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 PD11 436
CALL PD08(MAT,INVMAT)#                 Find inverse matrix              PD11 437
L=0 ; DO K=1,3#                        Copy back to common store        PD11 438
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 PD11 439
DO J=1,3#                                                               PD11 440
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 PD11 441
L=L+1 ; FTORTH(L)=INVMAT(K,J)#         Move matrix element              PD11 442
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 PD11 443
L=L+1#                                                                  PD11 444
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 PD11 445
DO K=1,3#                              Get inverse translation          PD11 446
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 PD11 447
L=4*K ; FTORTH(L)=0.0#                 Zero vector element              PD11 448
DO J=1,3#                              Row multiply                     PD11 449
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 PD11 450
M=J*4 ; FTORTH(L)=FTORTH(L)-INVMAT(K,J)*ORTHTF(M)# Input vector         PD11 451
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 PD11 452
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 PD11 453
INORTH=yes:#                           Signal matrix loaded             PD11 454
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 PD11 455
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 PD11 456
#                                                                       PD11 457
readline:(LONGLI,NLONG)#                                                PD11 458
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PD11 459
#                                                                       PD11 460
#  TRANSFER THE LRATOM: INDEX PACKET NUMBERS TO A COMMON ARRAY          PD11 461
#  -----------------------------------------------------------          PD11 462
#                                                                       PD11 463
DO J=1,NINPAR ; INDEXP(J)=DEXNUM(J)#   Set the packet numbers           PD11 464
#                                                                       PD11 465
RETURN#                                                                 PD11 466
END#                                                                    PD11 467
systemheader:(PD21)#                                                    PD21   1
#################################################################       PD21   2
#                                                               #       PD21   3
#                        PD21                                   #       PD21   4
#                                                               #       PD21   5
#################################################################       PD21   6
SUBROUTINE PD21#                       J.m. stewart nov 1986            PD21   7
###IMPLICIT NONE#                                                       PD21   8
include:(AACOMN)#                                                       PD21   9
include:(PDCOMN)#                                                       PD21  10
#                                                                       PD21  11
#    THIS SUBROUTINE TREATS THE PRELIMINARY RECORDS OF THE INPUT        PD21  12
# AND OUTPUT BINARY DATA FILES.  CELL CONSTANTS, SYMMETRY OPERATIONS    PD21  13
# SCALE FACTORS, DATA SET NAMES, SCATTERING FACTOR NAMES ARE READ.      PD21  14
# THE TEMPERATURE FACTOR CONVERSION FACTORS ARE FORMED.                 PD21  15
#                                                                       PD21  16
INTEGER PSIZ,IP,IPP,IPR,J,K,I,M,L,JJ,MM,LL#                             PD21  17
INTEGER INGRPS## MAX NUMBER OF SCALE FACTORS IN LARGEST DATASET         PD21  18
INTEGER NDATS# ## NUMBER OF DISTINCT DATA SETS IN INPUT LINES           PD21  19
INTEGER IHIT#  ## INTEGER VALUE OF DATA SET INDEX                       PD21  20
INTEGER IWANT(70)## HEADER PACKET REQUEST NUMBERS FOR INDEXPKT:         PD21  21
INTEGER IREL(71)# ## ADDRESS OFFSETS WHICH COME BACK FROM INDEXPKT:     PD21  22
INTEGER KEYL(4)#  ## KEYS FOR PROMPTING INDEXPKT:                       PD21  23
INTEGER KEY#   ## INDEX RETURNED BY COMPCHAR: WITH DATASET POINTER      PD21  24
INTEGER DSETS(10)## NUMBER OF SCALE FACTORS IN EACH DATASET             PD21  25
REAL    DSET#    ## HOLDING WORD FOR DATA SET CHECKING                  PD21  26
string:(DSNAME,12)#                    Holding string for dataset n     PD21  27
INTEGER IWNT(3)#                       Wish list,pointer for indexp     PD21  28
#                                                                       PD21  29
chardata:(PD23, SCATTERING FACTOR  NO. IN CELL  ATOMIC WEIGHTS)#        PD21  30
chardata:(PD25, STRUCTURE FACTOR SCALE                           )#     PD21  31
chardata:(PD26,         B OVERALL  DATA SET)#                           PD21  32
chardata:(PD27, EXTINCTION FACTOR  DATA SET  LRDSET INDEX)#             PD21  33
chardata:(PD28, DATASET              NOT FOUND IN BDF $#                PD21  34
AS USED AS A GENERAL PARAMETER REFERENCE.)#                             PD21  35
chardata:(PD29, DATA SET NAMES)#                                        PD21  36
chardata:(PD30,[    J    S(J,1)    S(J,2)    S(J,3)    U(J)    $#       PD21  37
ORTHOGONAL TO FRACTIONAL SCALING])#                                     PD21  38
chardata:(PD31,[    J  INS(J,1)  INS(J,2)  INS(J,3)  INU(J)    $#       PD21  39
FRACTIONAL TO ORTHOGONAL SCALING])#                                     PD21  40
realdata:(FMT,[50413.,150942.,250942.,350942.,450942.])#                PD21  41
realdata:(FM0,[180622.,280413.,381053.,181261.])#                       PD21  42
realdata:(FM1,[440413.,400413.,361051.])#                               PD21  43
intdata:(IR,[0,0,0,0])#                                                 PD21  44
datastuff:#                                                             PD21  45
#                                                                       PD21  46
#    PICK UP UNIT CELL PARAMETERS FOR T.F. CONVERSIONS LATER ON         PD21  47
#    ---------------------------------------------------------          PD21  48
#                                                                       PD21  49
J=0#                                                                    PD21  50
REPEAT#                                                                 PD21  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PD21  52
readwpkt:(1,lrcell:,PSIZ,IP,0)#                                         PD21  53
IF(IP<=0) BREAK#                                                        PD21  54
writepkt:(8,lrcell:,PSIZ,IPP)#                                          PD21  55
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#                                     PD21  56
J=J+1#                                                                  PD21  57
IF(J==1)#                                                               PD21  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PD21  59
movereal:(QX,IP+1,CELPD,1,6,0)#                                         PD21  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PD21  61
#                                                                       PD21  62
#    BUILD THE VARIOUS VECTORS WHICH WILL SERVE TO TRANSFORM B TO BETA  PD21  63
#    UIJ TO BETA AND BACK AND BIJ TO BETA.                              PD21  64
#                                                                       PD21  65
ELSE IF(J==3)#                         Watch for reciprocal cell fa     PD21  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PD21  67
BTOBET(1)=0.25*QX(IP+1)**2#            Astar squared over four          PD21  68
BTOBET(2)=0.25*QX(IP+2)**2#            Bstar squared over four          PD21  69
BTOBET(3)=0.25*QX(IP+3)**2#            Cstar squared over four          PD21  70
BTOBET(4)=0.25*QX(IP+1)*QX(IP+2)*QX(IP+6)# A* b* cos(gamma*)/4          PD21  71
BTOBET(5)=0.25*QX(IP+1)*QX(IP+3)*QX(IP+5)#                              PD21  72
BTOBET(6)=0.25*QX(IP+2)*QX(IP+3)*QX(IP+4)#                              PD21  73
#                                                                       PD21  74
### BETA TO UIJ BY MULTIPLY   UIJ TO BETA BY DIVIDE                     PD21  75
#                                                                       PD21  76
TFCON(1)=1.0/(ATEPSQ*BTOBET(1))#                                        PD21  77
TFCON(2)=1.0/(ATEPSQ*BTOBET(2))#                                        PD21  78
TFCON(3)=1.0/(ATEPSQ*BTOBET(3))#                                        PD21  79
TFCON(4)=4./(ATEPSQ*(QX(IP+1)*QX(IP+2)))# Leave out the cos(gamma*)     PD21  80
TFCON(5)=4./(ATEPSQ*(QX(IP+1)*QX(IP+3)))# Leave out the cos(beta*)      PD21  81
TFCON(6)=4./(ATEPSQ*(QX(IP+2)*QX(IP+3)))# Leave out the cos(alpha*)     PD21  82
#                                                                       PD21  83
# MAKE UP U TO U(IJ) CONVERSION FACTORS                                 PD21  84
#                                                                       PD21  85
UTOUIJ(1)=1.0 ; UTOUIJ(2)=1.0 ; UTOUIJ(3)=1.0# Diagonals unchanged      PD21  86
UTOUIJ(4)=QX(IP+6) ; UTOUIJ(5)=QX(IP+5)# But,                           PD21  87
UTOUIJ(6)=QX(IP+4)#                    Off diagonals by cos(ang*)       PD21  88
#                                                                       PD21  89
#  MAKE UP THE SCALING FACTORS REQUIRED BY THE PROTEIN DATA BANK FOR    PD21  90
# THE PREPARATION OF U ISOTROPIC 'EQUIVALENT' TO THE U(I,J).            PD21  91
#                                                                       PD21  92
PDBTFC(1)=QX(IP+1)*QX(IP+2)*CELPD(1)*CELPD(2)*CELPD(6)# A*b*abcos(g)    PD21  93
PDBTFC(2)=QX(IP+1)*QX(IP+3)*CELPD(1)*CELPD(3)*CELPD(5)# A*c*accos(b)    PD21  94
PDBTFC(3)=QX(IP+2)*QX(IP+3)*CELPD(2)*CELPD(3)*CELPD(4)# B*c*bccos(a)    PD21  95
#                                                                       PD21  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PD21  97
ELSE IF(J==6)#                         Packet with misc cell data       PD21  98
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PD21  99
CVOL=QX(IP+1);ODENS=QX(IP+2)#          Pick density and cell volume     PD21 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PD21 101
ELSE IF(J==9)#                         Look for orth to fractional      PD21 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PD21 103
DO K=1,9#                              Nine elements in packet          PD21 104
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PD21 105
IF(INORTH==yes:)QX(IPP+K)=ORTHTF(K)#   Put out new values               PD21 106
ELSE            ORTHTF(K)=QX(IP+K)#    Or accept old values             PD21 107
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PD21 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PD21 109
ELSE IF(J==10)#                        Last three elements              PD21 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PD21 111
IF(INORTH==yes:)#                                                       PD21 112
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PD21 113
QX(IPP+1)=ORTHTF(10);QX(IPP+2)=ORTHTF(11);QX(IPP+3)=ORTHTF(12)#         PD21 114
DO K=4,9 ; QX(IPP+K)=0.0#              Clear the rest                   PD21 115
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PD21 116
ELSE#                                                                   PD21 117
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PD21 118
ORTHTF(10)=QX(IP+1);ORTHTF(11)=QX(IP+2);ORTHTF(12)=QX(IP+3)#            PD21 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PD21 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PD21 121
ELSE IF(J==11)#                        Look for fractional to orth      PD21 122
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PD21 123
DO K=1,9#                              Nine elements in packet          PD21 124
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PD21 125
IF(INORTH==yes:)QX(IPP+K)=FTORTH(K)#   Put out new values               PD21 126
ELSE            FTORTH(K)=QX(IP+K)#    Or accept old values             PD21 127
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PD21 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PD21 129
ELSE IF(J==12)#                        Last three elements              PD21 130
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PD21 131
IF(INORTH==yes:)#                                                       PD21 132
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PD21 133
QX(IPP+1)=FTORTH(10);QX(IPP+2)=FTORTH(11);QX(IPP+3)=FTORTH(12)#         PD21 134
DO K=4,9 ; QX(IPP+K)=0.0#              Clear the rest                   PD21 135
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PD21 136
ELSE#                                  Take from file                   PD21 137
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PD21 138
FTORTH(10)=QX(IP+1);FTORTH(11)=QX(IP+2);FTORTH(12)=QX(IP+3)#            PD21 139
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PD21 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PD21 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PD21 142
IF(J<9)#                               Must increase lrcell:            PD21 143
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PD21 144
IF(INORTH==no:) iquit:(PD2101)#        Must have matrix to do it        PD21 145
writepkt:(8,lrcell:,PSIZ,IPP)#                                          PD21 146
DO K=1,9 ; QX(IPP+K)=ORTHTF(K)#                                         PD21 147
writepkt:(8,lrcell:,PSIZ,IPP)#                                          PD21 148
DO K=1,9 ; IF(K<4) QX(IPP+K)=ORTHTF(K+9) ; ELSE QX(IPP+K)=0.0#          PD21 149
writepkt:(8,lrcell:,PSIZ,IPP)#                                          PD21 150
DO K=1,9 ; QX(IPP+K)=FTORTH(K)#                                         PD21 151
writepkt:(8,lrcell:,PSIZ,IPP)#                                          PD21 152
DO K=1,9 ; IF(K<4) QX(IPP+K)=FTORTH(K+9) ; ELSE QX(IPP+K)=0.0#          PD21 153
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PD21 154
#                                                                       PD21 155
writeline:(1,BLANK,1,3,3)#             Write a blank line               PD21 156
LINRM=8 ; K=0 ; DO J=1,3#              Place matrices on view           PD21 157
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PD21 158
DO L=1,4#                                                               PD21 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PD21 160
K=K+1 ; ncodefld:(ORTHTF,K,CHROT,FMT(L+1),1)#                           PD21 161
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PD21 162
ncodefld:(FLOAT(J),1,CHROT,FMT(1),1)#                                   PD21 163
writeline:(1,PD30,NPD30,1,3)#                                           PD21 164
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PD21 165
#                                                                       PD21 166
writeline:(1,BLANK,1,3,3)#             Write a blank line               PD21 167
LINRM=8 ; K=0 ; DO J=1,3#              Place matrices on view           PD21 168
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PD21 169
DO L=1,4#                                                               PD21 170
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PD21 171
K=K+1 ; ncodefld:(FTORTH,K,CHROT,FMT(L+1),1)#                           PD21 172
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PD21 173
ncodefld:(FLOAT(J),1,CHROT,FMT(1),1)#                                   PD21 174
writeline:(1,PD31,NPD31,1,3)#                                           PD21 175
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PD21 176
copyfile:(1,8,incr:(lrcell:),decr:(lrsymm:))#                           PD21 177
#                                                                       PD21 178
#    ENTER SYMMETRY INFORMATION                                         PD21 179
#    --------------------------                                         PD21 180
#                                                                       PD21 181
readwpkt:(1,lrsymm:,PSIZ,IP,0)#                                         PD21 182
writepkt:(8,lrsymm:,PSIZ,IPP)#                                          PD21 183
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Move the packet to output        PD21 184
LTYPE=NINT(QX(IP+1))#                  Get out the lattice type         PD21 185
ICENT=NINT(QX(IP+2))#                  Get out centric code             PD21 186
SYMFAC=QX(IP+3)#                       Get out number equiv.pos.        PD21 187
IF(LTYPE>7) LTYPE=LTYPE-7#             Remove centric bias              PD21 188
POLSPG(1)=0;POLSPG(2)=0#               Set polar space group            PD21 189
POLSPG(3)=0#                           Axis signals to no               PD21 190
REPEAT#                                                                 PD21 191
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PD21 192
readwpkt:(1,lrsymm:,PSIZ,IP,0)#                                         PD21 193
IF(IP<=0) BREAK#                                                        PD21 194
writepkt:(8,lrsymm:,PSIZ,IPP)#                                          PD21 195
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#                                     PD21 196
IF(ICENT==1)#                          Check acentric space grps        PD21 197
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PD21 198
POLSPG(1)=POLSPG(1)+NINT(QX(IP+1))#    For polar axes                   PD21 199
POLSPG(2)=POLSPG(2)+NINT(QX(IP+5))#    For polar axes                   PD21 200
POLSPG(3)=POLSPG(3)+NINT(QX(IP+9))#    For polar axes                   PD21 201
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PD21 202
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PD21 203
copyfile:(1,8,incr:(lrsymm:),decr:(lrscat:))# Copy to lrscat:           PD21 204
#                                                                       PD21 205
#    PICK UP THE SCATTERING FACTOR NAMES FROM LRSCAT:                   PD21 206
#    ------------------------------------------------                   PD21 207
#                                                                       PD21 208
NSFTOT=0#                              Set count of sf types to zer     PD21 209
NSFMX=0#                               Set length of longest sf nam     PD21 210
J=1; LINRM=4#                          Set start of character table     PD21 211
IWNT(1)=11;IWNT(2)=1;IWNT(3)=2#        Set requests for lrscat:         PD21 212
KEYL(1)=1;KEYL(2)=3;KEYL(3)=0;KEYL(4)=0# Set search limits              PD21 213
indexpkt:(1,lrscat:,PSIZ,IP,8,KEYL,IWNT,IR)# Read directory of lrscat   PD21 214
IF(KEYL(4)<=0) iquit:(PD2102)#         No form factors                  PD21 215
writeline:(1,BLANK,1,3,3)#             Write a space                    PD21 216
REPEAT#                                Read all of them                 PD21 217
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PD21 218
readwpkt:(1,lrscat:,PSIZ,IP,0)#                                         PD21 219
IF(IP<=0) BREAK#                                                        PD21 220
writepkt:(8,lrscat:,PSIZ,IPP)#         Move packet to output on nfb     PD21 221
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Move the contents across         PD21 222
NSFTOT=NSFTOT+1#                       Count up s.f. types              PD21 223
IPR=IP+IR(1)#                                                           PD21 224
movertoc:(QX(IPR),1,SFNAME,J,6,0)#                                      PD21 225
movechar:(SFNAME,J,CHROT,6,6,0)#                                        PD21 226
IPR=IP+IR(2)#                          Fid pointer to numatom count     PD21 227
IF(IPR>IP) TATOMS(NSFTOT)=QX(IPR)#     Pull out count by atom type      PD21 228
ELSE       TATOMS(NSFTOT)=0.#          Set it to zero if none           PD21 229
ncodefld:(TATOMS(NSFTOT),1,CHROT,270712.,1)#                            PD21 230
IPR=IP+IR(3)#                          Find pointer to at wts.          PD21 231
IF(IPR>IP) ATWTS(NSFTOT)=QX(IPR)#      Pull out atomic weight           PD21 232
ELSE       ATWTS(NSFTOT)=0.#           Or zero if nothing there         PD21 233
ncodefld:(ATWTS(NSFTOT),1,CHROT,430732.,1)#                             PD21 234
writeline:(0,PD23,NPD23,1,3)#                                           PD21 235
I=J#                                                                    PD21 236
FOR(K=1;K<=6;K=K+1)#                                                    PD21 237
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PD21 238
compchar:(SFNAME,I,BLANK,1,1,1,1,KEY)# Look for the first blank         PD21 239
IF(KEY==0) I=I+1#                                                       PD21 240
ELSE BREAK#                                                             PD21 241
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PD21 242
K=K-1#                                 Set actual count of characte     PD21 243
NSFMX=MAX0(NSFMX,K)#                                                    PD21 244
NCSFN(NSFTOT)=K#                                                        PD21 245
J=J+6#                                                                  PD21 246
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PD21 247
NSFNAM=6*NSFTOT#                       Get total characters in name     PD21 248
copyfile:(1,8,incr:(lrscat:),decr:(lrddef:))#                           PD21 249
#                                                                       PD21 250
#    PICK UP DATA SET NAMES FROM LOGICAL RECORD LRDDEF:.                PD21 251
#    --------------------------------------------------                 PD21 252
#                                                                       PD21 253
NDSET=0#                                                                PD21 254
NDSETN=0#                                                               PD21 255
writeline:(1,PD29,NPD29,3,3)#                                           PD21 256
J=1#                                                                    PD21 257
REPEAT#                                                                 PD21 258
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PD21 259
readwpkt:(1,lrddef:,PSIZ,IP,0)#                                         PD21 260
IF(IP<=0) BREAK#                                                        PD21 261
writepkt:(8,lrddef:,PSIZ,IPP)#                                          PD21 262
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#                                     PD21 263
NDSET=NDSET+1#                                                          PD21 264
NDSETN=NDSETN+12#                                                       PD21 265
movertoc:(QX(IP+1),1,DATID,J,12,0)#                                     PD21 266
movechar:(DATID,J,CHROT,2,12,0)#                                        PD21 267
writeline:(0,0,0,1,3)#                                                  PD21 268
J=J+12#                                                                 PD21 269
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PD21 270
#                                                                       PD21 271
#                                                                       PD21 272
#    THIS SECTION OF CODE CHANGES THE DATA SET NAMES SUPPLIED ON        PD21 273
# EXTINC, AND/OR UOV INPUT LINES TO INTEGERS WHICH POINT TO THE         PD21 274
# DATASET NAME IN LRDDEF:.  THIS IS DONE IN ORDER TO FACILITATE SORTING PD21 275
# THE VARIOUS GENERAL PARAMETERS INTO THE CORRECT PACKETS IN THE BDF.   PD21 276
#                                                                       PD21 277
DO J=1,3#                              Loop over the three kinds of     PD21 278
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PD21 279
FOR(K=1;K<=INGEN(J);K=K+1)#            Lop over any lines loaded        PD21 280
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PD21 281
L=(K-1)*INGENS(J)+INGENM(J)+INGENP(J)# Calculate the qx address         PD21 282
movertoc:(QX(L+1),1,DSNAME,1,12,0)#    Move character string to tem     PD21 283
compchar:(DSNAME,1,DATID,1,12,12,NDSETN,KEY)# Compare it with file      PD21 284
IF(KEY>0)QX(L+1)=FLOAT(KEY)#           Set data set pointer             PD21 285
ELSE#                                                                   PD21 286
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PD21 287
movechar:(DSNAME,1,PD28,10,12,0)#                                       PD21 288
writeline:(1,PD28,NPD28,3,3)#                                           PD21 289
iquit:(PD2103)#                        Cant identify dataset name       PD21 290
QX(L+1)=1.0#                           Set to 1 as default              PD21 291
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PD21 292
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PD21 293
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PD21 294
#                                                                       PD21 295
#   PROCESS SCALE INFO FOR OUTPUT                                       PD21 296
#   -----------------------------                                       PD21 297
#                                                                       PD21 298
IF(INGEN(1)>0)#                        Test for scale lines input       PD21 299
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 PD21 300
DO K=1,10; DSETS(K)=0#                 Clear counts of scales/datas     PD21 301
INGRPS=0 ; NDATS=0#                    Clear number of groups and d     PD21 302
FOR(K=1;K<=INGEN(1);K=K+1)#            Loop over all scale items        PD21 303
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 PD21 304
L=(K-1)*INGENS(1)+INGENM(1)+INGENP(1)# Get qx offset                    PD21 305
IF(QX(L+1)<0.) BREAK#                  Dont repeat those already co     PD21 306
NDATS=NDATS+1#                         Count data sets                  PD21 307
FOR(J=1;J<=INGEN(1);J=J+1)#            Loop for comparison              PD21 308
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 PD21 309
M=(J-1)*INGENS(1)+INGENM(1)+INGENP(1)# Get qx offset                    PD21 310
IF(ABS(QX(L+1)-QX(M+1))<small:)#       Do they match...                 PD21 311
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 PD21 312
IHIT=NINT(QX(L+1))#                    Get data set number              PD21 313
DSETS(IHIT)=DSETS(IHIT)+1#             Count data sets                  PD21 314
INGRPS=MAX0(INGRPS,DSETS(IHIT))#       Find the dataset with the mo     PD21 315
QX(M+1)=-QX(M+1)#                      Turn off the rematch possibi     PD21 316
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 PD21 317
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 PD21 318
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 PD21 319
#                                                                       PD21 320
#   UPDATE SCALE FACTORS IN BDF                                         PD21 321
#   ---------------------------                                         PD21 322
#                                                                       PD21 323
IWANT(1)=1; IWANT(2)=100#              Set datset and sclg idnums       PD21 324
DO I=1,64 ; IWANT(I+2)=100+I#          Set scale idnums                 PD21 325
KEYL(1)=1;KEYL(2)=66;KEYL(3)=0;KEYL(4)=0# Set indexpkt params           PD21 326
indexpkt:(1,lrexpl:,PSIZ,IP,8,KEYL,IWANT,IREL)#                         PD21 327
IF((IP<=0)\(KEYL(4)<=0)) iquit:(PD2110)# Data set number missing        PD21 328
IF(IREL(2)==0) iquit:(PD2111)#         Scale factor missing             PD21 329
LINRM=3#                               Set up to list scales            PD21 330
#                                                                       PD21 331
REPEAT#                                                                 PD21 332
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 PD21 333
readwpkt:(1,lrexpl:,PSIZ,IP,0)#        Read packets dataset by data     PD21 334
IF(IP<=0) BREAK#                                                        PD21 335
writepkt:(8,lrexpl:,KEYL(4),IPP,0)#                                     PD21 336
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Move the existing stuff          PD21 337
#                                                                       PD21 338
K=IREL(1)+IP;DSET=QX(K)#               Find dataset pointer             PD21 339
LL=IP+IREL(2);LL=NINT(QX(LL))#         Get pointer to max scale #       PD21 340
FOR(K=1;K<=INGEN(1);K=K+1)#            Loop over stored scale facto     PD21 341
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 PD21 342
M=(K-1)*INGENS(1)+INGENM(1)#           Make storage pointer             PD21 343
ifne:(DSET,ABS(QX(M+3))) NEXT#         Skip if incorrect                PD21 344
FOR(J=1;J<=LL;J=J+1)#                  Loop over bdf scl groups         PD21 345
IF(J==NINT(QX(M+2))) BREAK#            Exit on match                    PD21 346
IF(J>LL) NEXT#                         Skip if no match found           PD21 347
J=IPP+IREL(J+2); QX(J)=QX(M+1)#        Put scale factor into op buf     PD21 348
ncodefld:(DSET,1,PD25,FM1(1),1)#       Encode data set number           PD21 349
ncodefld:(QX(M+2),1,PD25,FM1(2),2)#    Scale group & scale factor       PD21 350
ncodefld:(QX(M+1),1,PD25,FM1(3),1)#    Scale factor                     PD21 351
writeline:(1,PD25,NPD25,3,3)#          Print it all                     PD21 352
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 PD21 353
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 PD21 354
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 PD21 355
ELSE copyfile:(1,8,lrexpl:,lrexpl:)#   Just copy it if no scales        PD21 356
copyfile:(1,8,incr:(lrexpl:),decr:(lrdset:))# Copy to lrdset:           PD21 357
#                                                                       PD21 358
#    UPDATE LOGICAL RECORD LRDSET:                                      PD21 359
#    ----------------------------                                       PD21 360
#                                                                       PD21 361
DO J=1,4;  KEYL(J)=0#                  Reset indexpkt search limits     PD21 362
IF((INGEN(2)>0)\(INGEN(3)>0))#         Test if uov or extinc active ^   PD21 363
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 PD21 364
KEYL(3)=1 ; IWANT(1)=1 ; IP=1#         Get dataset pointer              PD21 365
IF(INGEN(3)>0)#                        Test for uov                     PD21 366
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 PD21 367
KEYL(3)=KEYL(3)+1#                     Set up to put away uov           PD21 368
IWANT(2)=2 ; IP=2#                                                      PD21 369
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 PD21 370
IF(INGEN(2)>0)#                        Test if extinc to be stored      PD21 371
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 PD21 372
KEYL(3)=KEYL(3)+INGENP(2); K=IP+INGENP(2)-1# Set up to put away extin   PD21 373
DO J=IP,K; IWANT(J+1)=J-IP+101#        Set extinc idnums                PD21 374
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 PD21 375
indexpkt:(1,lrdset:,PSIZ,IP,8,KEYL,IWANT,IREL)#                         PD21 376
IF(IP<=0) iquit:(PD2112)#              Die if no record on file         PD21 377
LINRM =3#                              Set up heading                   PD21 378
#                                                                       PD21 379
REPEAT#                                                                 PD21 380
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 PD21 381
readwpkt:(1,lrdset:,PSIZ,IP,0)#                                         PD21 382
IF(IP<=0) BREAK#                                                        PD21 383
writepkt:(8,lrdset:,KEYL(4),IPP,0)#                                     PD21 384
movereal:(QX,IP+1,QX,IPP+1,PSIZ,1)#    Move the existing stuff          PD21 385
#                                                                       PD21 386
IF(IREL(1)<=0) iquit:(PD2113)#         Die if no dataset info           PD21 387
K=IREL(1)+IP#                          Find it in the input             PD21 388
DSET=QX(K); L=1#                       Get data set and pointer         PD21 389
IF(INGEN(3)>0)#                        Any bov.....                     PD21 390
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 PD21 391
L=2#                                                                    PD21 392
IF(IREL(2)>0)#                         Test if uov present              PD21 393
FOR(K=1;K<=INGEN(3);K=K+1)#                                             PD21 394
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 PD21 395
M=(K-1)*INGENS(3)+INGENM(3)#           Make uov offset pointer          PD21 396
ifne:(DSET,QX(M+2)) NEXT#              Skip wrong data set              PD21 397
J=IPP+IREL(2)#                                                          PD21 398
QX(J)=QX(M+1)#                         Move in the uov                  PD21 399
LINRM=3; writeline:(1,PD26,NPD26,3,3)# Print bov header                 PD21 400
BUFOT(1)=ATEPSQ*QX(M+1)#               Change uov to bov for print      PD21 401
ncodefld:(BUFOT,1,CHROT,FM0(1),1)#     Put out the uov as bov           PD21 402
ncodefld:(DSET,1,CHROT,FM0(2),1)#      Put out the dataset              PD21 403
writeline:(1,0,0,1,3)#                                                  PD21 404
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 PD21 405
#                                                                       PD21 406
IF(INGEN(2)>0)#                        How about extinc......           PD21 407
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 PD21 408
FOR(K=1;K<=INGEN(2);K=K+1)#                                             PD21 409
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 PD21 410
M=(K-1)*INGENS(2)+INGENM(2)+1#         Find pointer to extinc           PD21 411
ifne:(DSET,QX(M+INGENP(2))) NEXT#      Skip wrong datsets               PD21 412
LINRM=4; writeline:(1,PD27,NPD27,3,3)# Force extinction header          PD21 413
DO J=1,INGENP(2)#                                                       PD21 414
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 PD21 415
I=L+J;  IF(IREL(I)<1) NEXT#            Skip absent parameters           PD21 416
JJ=IPP+IREL(I) ; MM=M+J-1#             Offset etc.                      PD21 417
QX(JJ)=QX(MM)#                         Move extinction factor           PD21 418
IF(ABS(QX(MM))<=small:) NEXT#          Don't list zero params           PD21 419
ncodefld:(FLOAT(J+100),1,CHROT,FM0(3),1)# Insert parameter number       PD21 420
ncodefld:(QX(MM),1,CHROT,FM0(4),1)#    Put out the extinc               PD21 421
ncodefld:(DSET,1,CHROT,FM0(2),1)#      Put out the dataset              PD21 422
writeline:(0,0,0,1,3)#                 Print extinction param.          PD21 423
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 PD21 424
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 PD21 425
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 PD21 426
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 PD21 427
#                                                                       PD21 428
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 PD21 429
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 PD21 430
ELSE copyfile:(1,8,lrdset:,lrdset:)#                                    PD21 431
#                                                                       PD21 432
RETURN#                                                                 PD21 433
END#                                                                    PD21 434
systemheader:(PD31)#                   Set up lratom controls           PD31   1
#################################################################       PD31   2
#                                                               #       PD31   3
#                        PD31                                   #       PD31   4
#                                                               #       PD31   5
#################################################################       PD31   6
SUBROUTINE PD31#                       J.m. stewart nov 1986            PD31   7
###IMPLICIT NONE#                                                       PD31   8
include:(AACOMN)#                                                       PD31   9
include:(PDCOMN)#                                                       PD31  10
#                                                                       PD31  11
INTEGER KEY(4)#       ## KEYS FOR INDEXPKT: SEARCH                      PD31  12
INTEGER J,M#          ## LOOP INDICES AND LOCAL POINTERS                PD31  13
INTEGER IP#           ## PACKET POINTER RETURNED FROM READ              PD31  14
INTEGER LPAK#         ## lratom: INPUT PACKET SIZE                      PD31  15
INTEGER IPO#        ## OUPUT PACKET POINTER                             PD31  16
REAL FMT#              ## VARIABLE FORMAT FOR PACKET HEADERS            PD31  17
#                                                                       PD31  18
chardata:(PD4A, ATOM PARAMETER RECORD IN INPUT BDF IS VOID.)#           PD31  19
chardata:(PD4B, THE ATOM RECORD ON THE INPUT BDF CONTAINS THE $#        PD31  20
FOLLOWING ID NUMBERS....)#                                              PD31  21
chardata:(PD4C,[ OUTPUT LRATOM PACKET...])#                             PD31  22
#                                                                       PD31  23
#  THE FOLLOWING ARRAY SETS UP PARAMETER VALUES TO USE IF SOME          PD31  24
#  INPUT SOURCE IS VOID.  THIS IS A RISKY BUSINESS, HOPEFULLY           PD31  25
#  THE USER WILL SUPPLY REASONABLE ONES OF HIS/HER OWN ON DEFAUL LINES  PD31  26
#  -------------------------------------------------------------------  PD31  27
#                                                                       PD31  28
realdata:(FAUX,[0.,0.,0.,.15198,0.,0.,0.,0.,0.,0.,1.,1.,$#              PD31  29
0.,0.,1.,0.,99999.,0.,1.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,$#         PD31  30
0.,0.])#                                                                PD31  31
#                                                                       PD31  32
# THE FOLLOWING TABLE IS TAKEN FROM THE LIST OF ABBREVIATIONS           PD31  33
# TO BE USED AS RESIDUE NAMES IN THE PROTEIN DATA BANK.  THEY           PD31  34
# ARE LOADED INTO COMMON HERE AND USED IN PD45 TO CHECK LINE            PD31  35
# INPUT.                                                                PD31  36
#                                                                       PD31  37
chardata:(PD31L,    UNK ACE FOR HOH H2O WAT OH2 HEM SUL FEO CAL )#      PD31  38
chardata:(PD31M,ABU ACD ALA ALB ALI ARG ARO ASN ASP ASX )#              PD31  39
chardata:(PD31N,BAS BET CYS CYH CSH CSS CYX GLN GLU GLX GLY )#          PD31  40
chardata:(PD31O,HIS HSE HYL HYP ILE ILU LEU LYS MET ORN PCA )#          PD31  41
chardata:(PD31P,PGA PHE PHE PRO PRZ SAR SER TAU THR THY TRP )#          PD31  42
chardata:(PD31Q,TRY TYR VAL   A 1MA   C 5MC OMC   G 1MG 2MG )#          PD31  43
chardata:(PD31R,M2G 7MG OMG  YG   I   T   U  +U H2U 5MU PSU )#          PD31  44
chardata:(STAR,[*])#                                                    PD31  45
datastuff:#                                                             PD31  46
#                                                                       PD31  47
#  SET UP THE DEFAULT VALUES IN COMMON STORAGE                          PD31  48
#  -------------------------------------------                          PD31  49
#                                                                       PD31  50
movereal:(FAUX,1,DEFAUL,1,PMAXP,0)#                                     PD31  51
movector:(STAR,1,DEFAUL(13),1,4,1)#    Some are packed characters       PD31  52
movector:(STAR,1,DEFAUL(14),1,4,1)#    And so are some others           PD31  53
DEFAUL(15)=DSETN#                      Put data set number in           PD31  54
DO J=1,6;DEFAUL(J+4)=DEFAUL(4)*UTOUIJ(J)# Make proper default u(ij)     PD31  55
#                                                                       PD31  56
#  SET UP THE RESIDUE NAME TABLE                                        PD31  57
#  -----------------------------                                        PD31  58
#                                                                       PD31  59
movechar:(PD31L,1,RESABB,1,NPD31L,0)#                                   PD31  60
TOTRES=NPD31L#                                                          PD31  61
movechar:(PD31M,1,RESABB,TOTRES+1,NPD31M,0)#                            PD31  62
TOTRES=TOTRES+NPD31M#                                                   PD31  63
movechar:(PD31N,1,RESABB,TOTRES+1,NPD31N,0)#                            PD31  64
TOTRES=TOTRES+NPD31N#                                                   PD31  65
movechar:(PD31O,1,RESABB,TOTRES+1,NPD31O,0)#                            PD31  66
TOTRES=TOTRES+NPD31O#                                                   PD31  67
movechar:(PD31P,1,RESABB,TOTRES+1,NPD31P,0)#                            PD31  68
TOTRES=TOTRES+NPD31P#                                                   PD31  69
movechar:(PD31Q,1,RESABB,TOTRES+1,NPD31Q,0)#                            PD31  70
TOTRES=TOTRES+NPD31Q#                                                   PD31  71
movechar:(PD31R,1,RESABB,TOTRES+1,NPD31R,0)#                            PD31  72
TOTRES=TOTRES+NPD31R#                                                   PD31  73
#                                                                       PD31  74
# COPY THE FILE UP TO JUST BEFORE THE ATOM PARAMETER RECORD             PD31  75
# ---------------------------------------------------------             PD31  76
#                                                                       PD31  77
copyfile:(1,8,incr:(lrdset:),decr:(lratom:))# Copy stuff between        PD31  78
#                                                                       PD31  79
# SET UP THE INPUT WANT LIST BASED ON THE OUTPUT HEADER PACKET.         PD31  80
#                                                                       PD31  81
DO J=1,MX24#                           Loop over name words             PD31  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PD31  83
WNTBDF(J)=14#                          Call for atom names              PD31  84
RELOUT(J)=J#                           Make offset for output           PD31  85
DIROUT(J)=14#                          Start index packet               PD31  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PD31  87
#                                                                       PD31  88
M=MX24+1#                              Set pointer to header packet ^   PD31  89
#                                                                       PD31  90
DO J=1,PMAXP#                          Loop over output packet          PD31  91
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PD31  92
RELOUT(J+MX24)=0#                      Initialize output offsets        PD31  93
WNTBDF(J+MX24)=NINT(INDEXP(J))#        Want everything, expect none ^   PD31  94
IF(DOP(J)==yes:)#                      Which parameters are to do?      PD31  95
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PD31  96
RELOUT(J+MX24)=M#                      Keep track of offset for o/p ^   PD31  97
DIROUT(M)=INDEXP(J)#                   Set up id numper in o/p pkt      PD31  98
BMAX=J#                                Remember how far we got          PD31  99
M=M+1#                                                                  PD31 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PD31 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PD31 102
PSIZO=M-1#                             Remember packet size             PD31 103
#                                                                       PD31 104
# SET INDEXPKT: CONTROLS, EVERYTHING IS OPTIONAL.                       PD31 105
#                                                                       PD31 106
KEY(1)=MX24; KEY(2)=PMAXP+MX24; KEY(3)=PMAXP+MX24; KEY(4)=0#            PD31 107
indexpkt:(1,lratom:,LPAK,IP,0,KEY,WNTBDF,RELBDF)# Get relative pointe   PD31 108
#                                                                       PD31 109
# TEST IF THE RECORD IS DEVOID OF ATOMS.                                PD31 110
#                                                                       PD31 111
IF(IP<=0)#                                                              PD31 112
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PD31 113
writeline:(1,PD4A,NPD4A,3,3)#          Report to user                   PD31 114
ENDBDF=yes:#                           Forget that source               PD31 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PD31 116
ELSE#                                  Atoms already in bdf             PD31 117
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PD31 118
writeline:(1,BLANK,1,3,3)#             Take a couple of spaces          PD31 119
LINRM=3 ; FMT=50413.#                  At least three lines please      PD31 120
DO J=1,LPAK#                           Loop over directory packet       PD31 121
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PD31 122
ncodefld:(QX(IP+J),1,CHROT,FMT,1)#     Encode id number                 PD31 123
FMT=FMT+50000.#                                                         PD31 124
IF(FMT>800000.\J==LPAK)#               Time to print?                   PD31 125
writeline:(0,PD4B,NPD4B,1,3);FMT=50413.# Report it out                  PD31 126
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PD31 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PD31 128
#                                                                       PD31 129
#  WRITE THE HEADER PACKET TO FILE H                                    PD31 130
#  ---------------------------------                                    PD31 131
#                                                                       PD31 132
writepkt:(8,lratom:,PSIZO,IPO)#                                         PD31 133
movereal:(DIROUT,1,QX,IPO+1,PSIZO,0)#                                   PD31 134
LINRM=4 ; FMT=50413.#                                                   PD31 135
DO J=1,PSIZO#                                                           PD31 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PD31 137
ncodefld:(QX(IPO+J),1,CHROT,FMT,1) ; FMT=FMT+50000.0#                   PD31 138
IF(FMT>800000.0\J==PSIZO)#                                              PD31 139
writeline:(0,PD4C,NPD4C,1,3) ; FMT=50413.#                              PD31 140
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PD31 141
#                                                                       PD31 142
RETURN#                                                                 PD31 143
END#                                                                    PD31 144
systemheader:(PD41)#                   Control entry of atom data       PD41   1
#################################################################       PD41   2
#                                                               #       PD41   3
#                        PD41                                   #       PD41   4
#                                                               #       PD41   5
#################################################################       PD41   6
SUBROUTINE PD41#                       J.m.stewart nov 1986             PD41   7
###IMPLICIT NONE#                                                       PD41   8
include:(AACOMN)#                                                       PD41   9
include:(PDCOMN)#                                                       PD41  10
#                                                                       PD41  11
INTEGER K,J#                           Indices                          PD41  12
INTEGER HIT#                           Signal for test of atom name     PD41  13
INTEGER NCH1#                          Number of chars in sf name       PD41  14
INTEGER NUMPLA#                                                         PD41  15
REAL FMS#                              Variable format for bdfid        PD41  16
REAL SERSPE,SER#                       Spec ser number for insert       PD41  17
string:(RESTST,3)#                     Searching last c terminal grou   PD41  18
chardata:(PD41A, NUMBER OF ATOMS TREATED  FROM BDF  FROM LINES  $#      PD41  19
REPLACED  DELETED  INSERTED  TO OUTPUT BDF )#                           PD41  20
chardata:(NUMS,0123456789 )#           The numbers and a blank          PD41  21
realdata:(FMT,[240613.,340613.,460613.,560613.,650613.,740613.,$#       PD41  22
890613.])#                                                              PD41  23
chardata:(PD41M,CHN)#                                                   PD41  24
chardata:(PD41O,CTR)#                                                   PD41  25
datastuff:#                                                             PD41  26
#                                                                       PD41  27
DELETE=no:#                            Turn off deletion flag           PD41  28
SERLIN=0. ; SERBDF=0.#                 Set serial numbers null          PD41  29
IF(ENDBDF==yes:) SERBDF=1000000.0#     Make it big or it will loop      PD41  30
#                                                                       PD41  31
#  LOAD THE LINE INPUT BUFFER                                           PD41  32
#  --------------------------                                           PD41  33
#                                                                       PD41  34
CALL PD42#                             Read next line                   PD41  35
#                                                                       PD41  36
#  LOAD THE INPUT BDF BUFFER                                            PD41  37
#  -------------------------                                            PD41  38
#                                                                       PD41  39
IF(ENDBDF==no:) CALL PD43#             Read next packet from file a     PD41  40
#                                                                       PD41  41
#  LOOP OVER ALL INPUT FROM BOTH SOURCES                                PD41  42
#  -------------------------------------                                PD41  43
#                                                                       PD41  44
REPEAT#                                Generate new lratom              PD41  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PD41  46
#                                                                       PD41  47
#  THIS BLOCK ADVANCES THE BDF BUFFER                                   PD41  48
#                                                                       PD41  49
IF(SERBDF<SERLIN)#                     Need to take from input bdf?     PD41  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PD41  51
INBEFO=INBEFO+1#                       Count the bdf atom               PD41  52
movereal:(BUFBDF,1,BUFOUT,1,BMAX,0)#   Transfer buffer                  PD41  53
movechar:(BDFID,1,OUTID,1,LNATNM,0)#   Move xtal atom name              PD41  54
CALL PD44#                             Write to file h                  PD41  55
IF(ENDBDF==no:) CALL PD43#             Reload the input buffer          PD41  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PD41  57
#                                                                       PD41  58
#  THIS BLOCK ADVANCES THE LINE INPUT BUFFER                            PD41  59
#                                                                       PD41  60
ELSE IF(SERBDF>SERLIN)#                Need to insert from line?        PD41  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PD41  62
IF(DELETE==yes:)#                      No match, can't delete           PD41  63
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PD41  64
iquit:(-PD4101.) ; DELETE=no:#         Complain and shut it off         PD41  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PD41  66
ELSE#                                  Not trying to delete             PD41  67
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PD41  68
INNEW=INNEW+1#                         Count the new ones               PD41  69
movereal:(BUFLIN,1,BUFOUT,1,BMAX,0)#   Transfer line to output          PD41  70
movechar:(NEWID,1,OUTID,1,LNATNM,0)#   Xtal atom name                   PD41  71
CALL PD44#                             Write to file h                  PD41  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PD41  73
IF(ENDLIN==no:) CALL PD42#             Reload line buffer               PD41  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PD41  75
#                                                                       PD41  76
#  THESE BLOCKS DEAL WITH THE COMPLICATED CASES WHERE SERBDF=SERLIN     PD41  77
#                                                                       PD41  78
ELSE IF((SERBDF==SERLIN)&(INSERT==yes:))# Insertion in list?            PD41  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PD41  80
SER=0.0#                               Keep count of how many           PD41  81
INBEFO=INBEFO+1#                       Count the bdf atom               PD41  82
movereal:(BUFBDF,1,BUFOUT,1,BMAX,0)#   Transfer buffer                  PD41  83
movechar:(BDFID,1,OUTID,1,LNATNM,0)#   Move xtal atom name              PD41  84
CALL PD44#                             Write marker atom to bdf         PD41  85
IF(ENDBDF==no:) CALL PD43#             Reload the input buffer          PD41  86
CALL PD42#                             Eat the marker line              PD41  87
REPEAT#                                Pump in the line buffer          PD41  88
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PD41  89
IF(INSERT==no:) BREAK#                 Until end encountered            PD41  90
movereal:(BUFLIN,1,BUFOUT,1,BMAX,0)#   Move line to output buffer       PD41  91
movechar:(NEWID,1,OUTID,1,LNATNM,0)#   Xtal atom name to output         PD41  92
CALL PD44#                             Send new atom to output          PD41  93
INSERO=INSERO+1;SER=SER+1.0#           Keep place marked                PD41  94
CALL PD42#                             Reload buffer                    PD41  95
IF(ENDLIN==yes:) iquit:(PD4103)#       Lines must not be exhausted      PD41  96
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PD41  97
REPEAT#                                Move and modify bdf stuff        PD41  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PD41  99
IF(SERBDF>SERLIN) BREAK#               Marker serial exceeded?          PD41 100
SERSPE=SERBDF+SER#                     Make augmented serial no.        PD41 101
BUFBDF(17)=SERSPE#                     Make new serial number           PD41 102
INBEFO=INBEFO+1#                       Count the bdf atom               PD41 103
NCH1=1 ; compchar:(BDFID,2,NUMS,1,1,1,NNUMS,HIT)# Test for a number     PD41 104
IF(HIT==0) NCH1=2#                     Must be a two char s.f. id       PD41 105
NUMPLA=MIN0(6-NCH1,INT(ALOG10(SERSPE))+1)# Make right number of place   PD41 106
movechar:(BLANK,1,BDFID,NCH1+1,6-NCH1,1)# Blast old serial number       PD41 107
FMS=10000.0*FLOAT(NCH1+NUMPLA)+110.0*FLOAT(NUMPLA)+3.0# Build format    PD41 108
ncodefld:(SERSPE,1,BDFID,FMS,1)#       Place it as characters in id     PD41 109
movechar:(BDFID,1,OUTID,1,LNATNM,0)#   Move xtal atom name              PD41 110
movereal:(BUFBDF,1,BUFOUT,1,BMAX,0)#   Transfer buffer                  PD41 111
CALL PD44#                             Write to file h                  PD41 112
CALL PD43#                             Reload the input buffer          PD41 113
IF(ENDBDF==yes:) BREAK#                End file here means break        PD41 114
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PD41 115
IF(ENDLIN==no:) CALL PD42#             Reload line input buffer         PD41 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PD41 117
ELSE IF((SERBDF==SERLIN)&(DELETE==yes:))# Marked for deletion           PD41 118
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PD41 119
DELETE=no:#                            Cancel deletion                  PD41 120
IF(BDFDEL>SERBDF)#                     More than one?                   PD41 121
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PD41 122
REPEAT#                                Ditch them all                   PD41 123
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PD41 124
INDELE=INDELE+1;CALL PD43#             Move across bdf                  PD41 125
IF(ENDBDF==yes:\SERBDF>BDFDEL) BREAK#                                   PD41 126
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PD41 127
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PD41 128
ELSE IF(ENDBDF==no:)#                                                   PD41 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PD41 130
INDELE=INDELE+1;CALL PD43#             Reload input bdf buffer          PD41 131
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PD41 132
IF(ENDLIN==no:) CALL PD42#             Reload line input buffer         PD41 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PD41 134
ELSE#                                  Replacement of one atom          PD41 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PD41 136
INREPL=INREPL+1#                       Count replaced atoms             PD41 137
movereal:(BUFLIN,1,BUFOUT,1,BMAX,0)#   Move line to output buffer       PD41 138
compchar:(BDFID,1,NEWID,1,LNATNM,LNATNM,LNATNM,HIT)# Better be the sa   PD41 139
IF(HIT==0) iquit:(-PD4102)#            Or else                          PD41 140
movechar:(BDFID,1,OUTID,1,LNATNM,0)#   Xtal atom name to output         PD41 141
CALL PD44#                             Write file h                     PD41 142
IF(ENDBDF==no:) CALL PD43#             Reload input bdf buffer          PD41 143
IF(ENDLIN==no:) CALL PD42#             Reload line input buffer         PD41 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PD41 145
IF(ENDBDF==yes:&ENDLIN==yes:) BREAK#   Quit when all input ends         PD41 146
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PD41 147
#                                                                       PD41 148
#  RECORD THE C TERMINAL RESIDUE OF THE LAST CHAIN                      PD41 149
#  -----------------------------------------------                      PD41 150
#                                                                       PD41 151
FOR(K=NRESID;K>1;K=K-1)#               Scan back for the terminal c     PD41 152
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PD41 153
J=(K-1)*STEPR+MARKR#                   Point to previous residues       PD41 154
movertoc:(QX(J+1),10,RESTST,1,3,0)#    Pull back residue type           PD41 155
compchar:(PD41M,1,RESTST,1,3,3,NPD41M,HIT)# Look for last "chn"         PD41 156
IF(HIT==1)#                            Get a match                      PD41 157
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PD41 158
CHACTR(CHANUM)=K#                      And mark it "ctr"                PD41 159
movector:(PD41O,1,QX(J+1),10,NPD41O,0)#                                 PD41 160
movertoc:(QX(J+1),1,CHACNM,12*(CHANUM-1)+1,12,0)# And keep name         PD41 161
BREAK#                                                                  PD41 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PD41 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PD41 164
#                                                                       PD41 165
#  SUMMARIZE THE ATOMS LOADED BY GROUPS                                 PD41 166
#  ------------------------------------                                 PD41 167
#                                                                       PD41 168
INATOM=INBEFO+INNEW+INREPL+INDELE+INSERO# Get summary count             PD41 169
BUFOT(1)=FLOAT(INATOM);BUFOT(2)=FLOAT(INBEFO)#                          PD41 170
BUFOT(3)=FLOAT(INNEW+INREPL+INSERO)#                                    PD41 171
BUFOT(4)=FLOAT(INREPL);BUFOT(5)=FLOAT(INDELE)#                          PD41 172
BUFOT(6)=FLOAT(INSERO);BUFOT(7)=FLOAT(INOUT)#                           PD41 173
ncodefld:(BUFOT,1,CHROT,FMT,7)#                                         PD41 174
writeline:(1,PD41A,NPD41A,2,3)#                                         PD41 175
#                                                                       PD41 176
RETURN#                                                                 PD41 177
END#                                                                    PD41 178
systemheader:(PD42)#                   Input atom param. lines          PD42   1
#################################################################       PD42   2
#                                                               #       PD42   3
#                        PD42                                   #       PD42   4
#                                                               #       PD42   5
#################################################################       PD42   6
SUBROUTINE PD42#                       J.m.stewart nov 1986             PD42   7
###IMPLICIT NONE#                                                       PD42   8
include:(AACOMN)#                                                       PD42   9
include:(PDCOMN)#                                                       PD42  10
#                                                                       PD42  11
INTEGER J,K,L,M#                       Misc. index registers            PD42  12
INTEGER FIRST,LAST#                    Signal first time atom           PD42  13
INTEGER DEFLIN#                        Signal processing of defaul      PD42  14
INTEGER HIT#                           Signal for matching lists        PD42  15
REAL SERNEW#                           Checking serial numbers from i   PD42  16
intdata:(JJ,[1])#                      Out of stream index register     PD42  17
string:(SNEAKY,87)#                    Buffer for chrin altering        PD42  18
#                                                                       PD42  19
chardata:(PD11, END    ATOM   PROAT  HETATM $#                          PD42  20
PROHET SIGATM PROSGA ANISOU PROANI SIGUIJ $#                            PD42  21
PROSGU DEFAUL SYMOP  PROATI PROATE PROATD )#                            PD42  22
intdata:(PUTAWA,[0,0,0,0,0,20,20,4,4,26,26])# Point to buffer locs      PD42  23
intdata:(MXITMS,[0,0,0,0,0,5,6,6,6,6,6])# Maximum items in line         PD42  24
# THE DATA STATEMENTS TFSHF AND ATSHF SET THE BEGINNING COLUMNS FOR     PD42  25
# REAL AND IMPLIED FIELDS IN THE PROTEIN DATA BANK ATOM AND ANISOU      PD42  26
# LINES.  TFNCH AND ATNCH SHOW THE COLUMN SPANS OF EACH FIELD.          PD42  27
# TESE LINES ALLOW THE CONVERSION OF THE COLUMN FORMATTED INPUT OF      PD42  28
# THE PDB TO BE TRANSFORMED TO FIELD INPUT OF XTAL.                     PD42  29
intdata:(TFSHF,[15,16,17,18,22,23,27,29,36,43,50,57,64,80])# Fields     PD42  30
intdata:(ATSHF,[15,16,17,18,22,23,27,31,39,47,55,61,68,80])# Fields     PD42  31
intdata:(TFNCH,[1,1,1,3,1,4,1,7,7,7,7,7,7,1])# Field widths             PD42  32
intdata:(ATNCH,[1,1,1,3,1,4,1,8,8,8,6,6,3,1])# Field widths             PD42  33
chardata:(PD12,0)#                                                      PD42  34
chardata:(PD13,[        ])#            Eight blanks                     PD42  35
datastuff:#                                                             PD42  36
#                                                                       PD42  37
#                                                                       PD42  38
#                                                                       PD42  39
movechar:(BLANK,1,NEWID,1,LNATNM,1)#   Clear line input atom name       PD42  40
DEFLIN=no:#                            No defaul line in process        PD42  41
movereal:(DEFAUL,1,BUFLIN,1,PMAXP,0)#  Clear the buffer to defaults     PD42  42
#                                                                       PD42  43
#     TREAT INPUT LINES TILL AN END LINE IS ENCOUNTERED, THEN STOP      PD42  44
#     ------------------------------------------------------------   -  PD42  45
#                                                                       PD42  46
REPEAT#                                                                 PD42  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PD42  48
IF(LINID==1)#                          Check end line in buffer         PD42  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PD42  50
ENDLIN=yes:; SERLIN=1000000.0 ; BREAK# Thats it for line input          PD42  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PD42  52
#                                                                       PD42  53
# PICK UP PROATI, PROATE, PROATD ATOM EDITING LINES.                    PD42  54
# --------------------------------------------------                    PD42  55
#                                                                       PD42  56
IF(LINID>13)#                          Test for editing lines           PD42  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PD42  58
IF((BUFIN(1)>0.0)&(BUFIN(1)<100000.0))# Must fit in pdb col limits      PD42  59
SERNEW=FLOAT(NINT(BUFIN(1)))#          Accept face value given          PD42  60
ELSE SERNEW=1000000.0#                 Or else force to end of file     PD42  61
IF(SERNEW<=SERLIN) iquit:(PD4201)#     No use if already passed atom    PD42  62
SERLIN=SERNEW#                         Accept the atom serial number    PD42  63
IF(LINID==14) INSERT=yes:#             Set function to insert atoms     PD42  64
ELSE IF(LINID==15) INSERT=no:#         Stop inserting atoms             PD42  65
ELSE#                                  Set for atom deletion            PD42  66
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PD42  67
DELETE=yes: ; BDFDEL=0.0#              Set function to delete one ato   PD42  68
IF(BUFIN(2)>SERNEW) BDFDEL=BUFIN(2)#   Or more, if so specified         PD42  69
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PD42  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PD42  71
#                                                                       PD42  72
#  TEST IF INPUT LINE IS FROM PROTEIN DATA BASE.  IF SO ADD             PD42  73
#  SOME BLANKS TO BE SURE THAT THERE ARE FIELD SEPARATORS               PD42  74
#  THEN DECODE AGAIN.  THE INPUT BUFFER WILL BE JUST LIKE               PD42  75
#  THE XTAL DEFINED LINES.                                              PD42  76
#  ---------------------------------------------------------            PD42  77
#                                                                       PD42  78
IF((LINID<12)&(MOD(LINID,2)==0))#      If its a pdb line                PD42  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PD42  80
movechar:(BLANK,1,SNEAKY,1,87,1)#      Clear intermediate buffer        PD42  81
movechar:(CHRIN,1,SNEAKY,1,CHRMAX,0)#  Save what was input              PD42  82
movechar:(BLANK,1,CHRIN,1,80,1)#       Blast the input buffer           PD42  83
M=1 ; K=0#                             Set column managers              PD42  84
IF(LINID<8)#                           Test for atom type lines         PD42  85
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PD42  86
DO J=1,70#                             Scan the pdb line                PD42  87
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PD42  88
K=K+1#                                 Advance output column            PD42  89
IF(J==ATSHF(M))#                       Need a space added               PD42  90
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PD42  91
compchar:(SNEAKY,J,PD13,1,ATNCH(M),ATNCH(M),ATNCH(M),HIT)#              PD42  92
IF(HIT!=0) movechar:(PD12,1,SNEAKY,J,NPD12,1)# Prevent void fields      PD42  93
M=M+1 ; K=K+1#                         Yes, advance pointers            PD42  94
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PD42  95
movechar:(SNEAKY,J,CHRIN,K,1,0)#       Character by character           PD42  96
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PD42  97
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PD42  98
ELSE#                                  Temperature factor lines         PD42  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PD42 100
DO J=1,70#                             Scan the other kind of pdb l     PD42 101
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PD42 102
K=K+1#                                 Advance output column            PD42 103
IF(J==TFSHF(M))#                       Test columns to get blanks       PD42 104
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PD42 105
compchar:(SNEAKY,J,PD13,1,TFNCH(M),TFNCH(M),TFNCH(M),HIT)#              PD42 106
IF(HIT!=0) movechar:(PD12,1,SNEAKY,J,NPD12,1)# Prevent void fields      PD42 107
M=M+1 ; K=K+1#                         Skip on                          PD42 108
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PD42 109
movechar:(SNEAKY,J,CHRIN,K,1,0)#       One by one                       PD42 110
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PD42 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PD42 112
#                                                                       PD42 113
#  NOW TURN ON THE SYNTAX CHECKING AND DECODE THE PDB LINE              PD42 114
#  -------------------------------------------------------              PD42 115
#                                                                       PD42 116
SYNTXF=0 ; dcodefld: ; SYNTXF=1#       Translate data                   PD42 117
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PD42 118
#                                                                       PD42 119
IF(LINID>5&LINID<12)#                  Non atom lines                   PD42 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PD42 121
IF(MOD(LINID,2)==0) M=9#               Pdb lines start further over     PD42 122
ELSE M=1#                              Xtal lines start right away      PD42 123
DO J=1,MXITMS(LINID)#                  Do appropriate no of params      PD42 124
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PD42 125
M=M+1 ; K=J+PUTAWA(LINID)#             Get pointers right               PD42 126
IF(BUFIN(M)<=voidflg:) BUFLIN(K)=DEFAUL(K)# Avoid trash                 PD42 127
ELSE movepakwd:(BUFIN(M),BUFLIN(K))#   Move to expanded line buffer     PD42 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PD42 129
IF(LINID>7&LINID<12)#                  Check for anisotropic t.f.s      PD42 130
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PD42 131
IF(LINID<10)#                          Check for anisou or proani       PD42 132
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PD42 133
BUFLIN(4)=(BUFLIN(5)+BUFLIN(6)+BUFLIN(7)+$# Force u input to u          PD42 134
BUFLIN(8)*PDBTFC(1)+BUFLIN(9)*PDBTFC(2)+$# Equivalent as per pdb        PD42 135
BUFLIN(10)*PDBTFC(3))/30000.0#         Requirements                     PD42 136
IF(TFTYPE>0) BUFLIN(20)=2.0#           Set t.f. type                    PD42 137
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PD42 138
IF(LINID<10) M=4 ; ELSE M=26#          Uij or sigma uij                 PD42 139
DO J=1,6#                              Scale u(i,j)                     PD42 140
BUFLIN(J+M)=0.0001*BUFLIN(J+M)#        Pdb wants factor 10e+4           PD42 141
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PD42 142
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PD42 143
ELSE IF(LINID<6)#                      Some kind of atom line input     PD42 144
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PD42 145
#                                                                       PD42 146
#  CALL PD45 TO DECONVOLUTE THE INPUT PARAMETERS, PARTICULARLY          PD42 147
#  THE ATOM NAME PROBLEM.                                               PD42 148
#  -----------------------------------------------------------          PD42 149
#                                                                       PD42 150
CALL PD45#                                                              PD42 151
IF(TFTYPE>0) BUFLIN(20)=1.0#           Say tf is isotropic              PD42 152
DO J=1,6 ; BUFLIN(J+4)=BUFLIN(4)*UTOUIJ(J)# Make equiv aniso in case    PD42 153
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PD42 154
#                                                                       PD42 155
#   CHECK IF DEFAUL LINE ENCOUNTERED                                    PD42 156
#   --------------------------------                                    PD42 157
#                                                                       PD42 158
ELSE IF(LINID==12)#                                                     PD42 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PD42 160
IF(DEFLIN==no:)#                       Test if first encounter          PD42 161
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PD42 162
JJ=1 ; DEFLIN=yes:#                    Start count of dop signals       PD42 163
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PD42 164
K=0#                                   Set input field pointer          PD42 165
FOR(J=JJ;J<=BMAX;J=J+1)#                                                PD42 166
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PD42 167
IF(DOP(J)>0)#                          Test for treated parameters      PD42 168
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PD42 169
K=K+1#                                 Up input field                   PD42 170
IF(BUFIN(K)>voidflg:) DEFAUL(J)=BUFIN(K)#                               PD42 171
ELSE IF(BUFIN(K)<voidflg:)#            Res or seq items                 PD42 172
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PD42 173
IF(J==13\J==14)#                       Be sure!                         PD42 174
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PD42 175
stringlim:(K,FIRST,LAST)#              Find the characters              PD42 176
movector:(CHRIN,FIRST,DEFAUL(J),1,MIN0(LAST-FIRST,4),0)#                PD42 177
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PD42 178
ELSE#                                  Give up at first void            PD42 179
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PD42 180
JJ=J ; BREAK#                          Remember last item position      PD42 181
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PD42 182
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PD42 183
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PD42 184
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PD42 185
readline:(PD11,NPD11) ; NEXT#          Read in the next line            PD42 186
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PD42 187
#                                                                       PD42 188
#    TEST FOR SYMOP INPUT LINE                                          PD42 189
#    -------------------------                                          PD42 190
#                                                                       PD42 191
ELSE IF(LINID==13)#                                                     PD42 192
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PD42 193
SYMIN=yes:#                            Note the input line              PD42 194
DO L=1,9#                                                               PD42 195
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PD42 196
IF((BUFIN(L)>=(-1.0))&(BUFIN(L)<=1.0))#                                 PD42 197
ROT(L)=BUFIN(L)#                                                        PD42 198
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PD42 199
DO J=1,3#                                                               PD42 200
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PD42 201
IF((BUFIN(J+9)>=(-5.))&(BUFIN(J+9)<=5.0))#                              PD42 202
TRANS(J)=BUFIN(J+9)#                                                    PD42 203
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PD42 204
readline:(PD11,NPD11) ; NEXT#          Read in the next line            PD42 205
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PD42 206
#                                                                       PD42 207
#                                                                       PD42 208
readline:(PD11,NPD11)#                 Read in the next line            PD42 209
IF(LINID<6\LINID>13) BREAK#            Come back later                  PD42 210
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PD42 211
#                                                                       PD42 212
RETURN#                                                                 PD42 213
END#                                                                    PD42 214
systemheader:(PD43)#                   Load input bdf buffer            PD43   1
#################################################################       PD43   2
#                                                               #       PD43   3
#                        PD43                                   #       PD43   4
#                                                               #       PD43   5
#################################################################       PD43   6
SUBROUTINE PD43#                       J.m.stewart nov 1986             PD43   7
###IMPLICIT NONE#                                                       PD43   8
include:(AACOMN)#                                                       PD43   9
include:(PDCOMN)#                                                       PD43  10
#                                                                       PD43  11
CHARACTER TEMPCH#                                                       PD43  12
INTEGER LPAK,IP,J,K#                   Packet indices                   PD43  13
#                                                                       PD43  14
#  LOAD UP THE ITEM BUFFER FROM THE INPUT BDF BUFFER                    PD43  15
# --------------------------------------------------                    PD43  16
#                                                                       PD43  17
readwpkt:(1,lratom:,LPAK,IP,0)#        Read next packet                 PD43  18
IF(IP<=0)#                             Signal done with bdf             PD43  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PD43  20
ENDBDF=yes: ; SERBDF=1000000.0#        Two different ways               PD43  21
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PD43  22
ELSE#                                  Else transfer data               PD43  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PD43  24
K=IP+RELBDF(1)#                        Point to xtal atom name          PD43  25
movertoc:(QX(K),1,BDFID,1,LNATNM,0)#   Pull out xtal atom name          PD43  26
DO J=1,BMAX#                           Loop as far as need be           PD43  27
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PD43  28
IF(RELBDF(J+MX24)>0)#                  Is item in input?                PD43  29
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PD43  30
K=IP+RELBDF(J+MX24)#                   Get offset                       PD43  31
movepakwd:(QX(K),BUFBDF(J))#           Move word to item buffer         PD43  32
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PD43  33
ELSE movepakwd:(DEFAUL(J),BUFBDF(J))#  Or store default value           PD43  34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PD43  35
SERBDF=BUFBDF(17)#                     Pull out serial number           PD43  36
movechar:(BLANK,1,RESNUM,1,5,1)#       Blank res number                 PD43  37
movertoc:(BUFBDF(13),4,RESNUM,1,1,0)#  Get sig dig of residue serial    PD43  38
movertoc:(BUFBDF(13),1,RESNUM,2,3,0)#  Get rest of residue serial no.   PD43  39
movertoc:(BUFBDF(16),4,TEMPCH,1,1,0)#  Get insertion character          PD43  40
IF(TEMPCH!='.')$#                      Null insert code left as blank   PD43  41
movertoc:(BUFBDF(16),4,RESNUM,5,1,0)#  Get non-null insertion char      PD43  42
movertoc:(BUFBDF(16),1,CHAINI,1,3,0)#  Get chain id                     PD43  43
movertoc:(BUFBDF(18),1,TEMPCH,1,1,0)#  Get char from res name           PD43  44
movertoc:(BUFBDF(18),1,RESNAM,1,4,0)#  Get residue name                 PD43  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PD43  46
RETURN#                                                                 PD43  47
END#                                                                    PD43  48
systemheader:(PD44)#                   Write out new lratom buffer      PD44   1
#################################################################       PD44   2
#                                                               #       PD44   3
#                        PD44                                   #       PD44   4
#                                                               #       PD44   5
#################################################################       PD44   6
SUBROUTINE PD44#                       J.m.stewart nov 1986             PD44   7
include:(AACOMN)#                      June 1989                        PD44   8
include:(PDCOMN)#                                                       PD44   9
#                                                                       PD44  10
INTEGER HIT,CHIT,HITHET,NHIT#          Test on match                    PD44  11
INTEGER L#                             Index                            PD44  12
REAL    HOLDA(3,3)#                    Betas half operated upon         PD44  13
REAL    HOLDB(3,3)#                    Betas transformed                PD44  14
REAL    HOLDC(3)#                      X, y, z transformed              PD44  15
INTEGER IPO#                           Output pointer                   PD44  16
string:(RESTYP,3)#                     Residue type to mark chain lin   PD44  17
string:(RESTST,3)#                     Residue type; find c term atom   PD44  18
intdata:(J,[0])#                       Local index                      PD44  19
intdata:(JJ,[0])#                      Local index                      PD44  20
intdata:(K,[0])#                       Local index                      PD44  21
intdata:(KK,[0])#                      Local index                      PD44  22
intdata:(M,[0])#                       Local index                      PD44  23
intdata:(INDEXB,[5,8,9,8,6,10,9,10,7])#                                 PD44  24
chardata:(PD44F,[ AT RESIDUE (             ) THE MOST SIG DIG OF $#     PD44  25
RESIDUE SEQUENCE NUMBER WILL BE LOST FROM LRSEQU.])#                    PD44  26
chardata:(PD44G,_HT)#                  Heteroatom signal                PD44  27
chardata:(PD44M,CHN)#                                                   PD44  28
chardata:(PD44N,NTR)#                                                   PD44  29
chardata:(PD44O,CTR)#                                                   PD44  30
chardata:(PD44P,HET)#                                                   PD44  31
datastuff:#                                                             PD44  32
#                                                                       PD44  33
#  IF COORDINATES TO BE PASSED THROUGH CENTER OR TRANSLATED, DO IT NOW  PD44  34
#  -------------------------------------------------------------------  PD44  35
#                                                                       PD44  36
DO K=1,3#                              Loop over x, y, and z            PD44  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PD44  38
IF(SHIFT(1)>99.0)#                     Center signal in farce           PD44  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PD44  40
BUFOUT(K)=-BUFOUT(K)#                  Pass through center              PD44  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PD44  42
ELSE#                                  Translate em                     PD44  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PD44  44
BUFOUT(K)=BUFOUT(K)+SHIFT(K)#                                           PD44  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PD44  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PD44  47
#                                                                       PD44  48
#   TRANSFORM ATOM IF SYMOP SEARCH REQUESTED                            PD44  49
#   ----------------------------------------                            PD44  50
#                                                                       PD44  51
IF(SYMIN==yes:)#                                                        PD44  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PD44  53
HOLDC(1)=ROT(1)*BUFOUT(1)+ROT(2)*BUFOUT(2)+ROT(3)*BUFOUT(3)#            PD44  54
HOLDC(2)=ROT(4)*BUFOUT(1)+ROT(5)*BUFOUT(2)+ROT(6)*BUFOUT(3)#            PD44  55
HOLDC(3)=ROT(7)*BUFOUT(1)+ROT(8)*BUFOUT(2)+ROT(9)*BUFOUT(3)#            PD44  56
DO J=1,3#                                                               PD44  57
BUFOUT(J)=FLOAT(NINT((HOLDC(J)+TRANS(J))*8192.))/8192.# Add translati   PD44  58
#                                                                       PD44  59
IF(TFTYPE>=2)#                                                          PD44  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PD44  61
DO J=1,6 ; BUFOUT(J+4)=BUFOUT(J+4)/TFCON(J)# Convert uij to betaij      PD44  62
DO J=1,3#                                                               PD44  63
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PD44  64
DO K=1,3#                                                               PD44  65
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PD44  66
HOLDA(J,K)=0.#                                                          PD44  67
JJ=J-3;  KK=(K-1)*3#                   Set array pointer                PD44  68
DO M=1,3#                                                               PD44  69
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PD44  70
L=INDEXB(KK+M);   JJ=JJ+3#                                              PD44  71
IF((ABS(BUFOUT(L))>small:)&(ABS(ROT(JJ))>small:))#                      PD44  72
HOLDA(J,K)=ROT(JJ)*BUFOUT(L)+HOLDA(J,K)#                                PD44  73
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PD44  74
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PD44  75
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PD44  76
DO J=1,3#                                                               PD44  77
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PD44  78
DO K=1,3#                                                               PD44  79
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PD44  80
HOLDB(J,K)=0.#                                                          PD44  81
KK=K-3#                                Set array pointer                PD44  82
DO M=1,3#                                                               PD44  83
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PD44  84
KK=KK+3#                               Incr array pointer               PD44  85
IF((ABS(HOLDA(J,M))>small:)&(ABS(ROT(KK))>small:))#                     PD44  86
HOLDB(J,K)=HOLDA(J,M)*ROT(KK)+HOLDB(J,K)# Rot transpose                 PD44  87
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PD44  88
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PD44  89
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PD44  90
DO J=1,3#                              Store back the transformed t     PD44  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PD44  92
JJ=J-3#                                Set array pointer                PD44  93
DO K=J,3#                                                               PD44  94
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PD44  95
JJ=JJ+3;    L=INDEXB(JJ)#                                               PD44  96
BUFOUT(L)=HOLDB(J,K)#                                                   PD44  97
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PD44  98
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PD44  99
DO J=1,6 ; BUFOUT(J+4)=BUFOUT(J+4)*TFCON(J)# Convert betaij to uij      PD44 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PD44 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PD44 102
#                                                                       PD44 103
#  ACCUMULATE THE COUNT AND NAMES OF ALL THE RESIDUES ENCOUNTERED       PD44 104
#  --------------------------------------------------------------       PD44 105
#                                                                       PD44 106
NHIT=no:#                              Next residue not an n terminal   PD44 107
compchar:(RESNUM,1,RESCHK,1,5,5,5,HIT)# See if this is a new residue    PD44 108
IF(HIT==0)#                            If no match, it is.              PD44 109
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PD44 110
#                                                                       PD44 111
#  KEEP TRACK OF RESIDUES THAT CONSTITUTE C AND N TERMINAL RESIDUES     PD44 112
#  ----------------------------------------------------------------     PD44 113
#                                                                       PD44 114
compchar:(PD44G,1,OUTID,1,3,1,LNATNM,HITHET)# Check for hetero atoms    PD44 115
movechar:(PD44M,1,RESTYP,1,NPD44M,0)#  Mark residue type as " chn"      PD44 116
compchar:(CHAOLD,1,CHAINI,1,3,3,3,CHIT)# Test if chain changes here     PD44 117
IF(CHIT==0)#                           If zero it does                  PD44 118
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PD44 119
IF(HITHET==0)#                         Only if not treating hetro       PD44 120
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PD44 121
CHANUM=CHANUM+1#                       Count up chains                  PD44 122
CHANTR(CHANUM)=NRESID+1 ; NHIT=yes:#   Record new n terminal            PD44 123
movechar:(CHAINI,1,CHAOLD,1,3,0)#      Remember chain id                PD44 124
movechar:(PD44N,1,RESTYP,1,NPD44N,0)#  Mark residue type as "ntr"       PD44 125
IF(CHANUM>1)#                          Is there a c terminal too?       PD44 126
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PD44 127
FOR(K=NRESID;K>1;K=K-1)#               Scan back for the terminal c     PD44 128
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PD44 129
J=(K-1)*STEPR+MARKR#                   Point to previous residues       PD44 130
movertoc:(QX(J+1),10,RESTST,1,3,0)#    Pull back residue type           PD44 131
compchar:(PD44M,1,RESTST,1,3,3,3,HIT)# Look for last "chn"              PD44 132
IF(HIT==1)#                            Get a match                      PD44 133
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PD44 134
CHACTR(CHANUM-1)=K#                    Keep pointer to it               PD44 135
movector:(PD44O,1,QX(J+1),10,NPD44O,0)# And mark it "ctr"               PD44 136
movertoc:(QX(J+1),1,CHACNM,12*(CHANUM-2)+1,12,0)# And keep name         PD44 137
BREAK#                                                                  PD44 138
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PD44 139
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PD44 140
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PD44 141
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PD44 142
ELSE iquit:(PD4401)#                   Hetero atoms are different       PD44 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PD44 144
IF(HITHET!=0) movechar:(PD44P,1,RESTYP,1,NPD44P,0)# Residue type "het   PD44 145
#                                                                       PD44 146
J=NRESID*STEPR+MARKR ; NRESID=NRESID+1# Count it and store it           PD44 147
movechar:(RESNUM,1,RESCHK,1,5,0)#      Remember the new number          PD44 148
movechar:(RESNAM,1,RESBUF,1,4,0)#      Pack up the residue name 4 byt   PD44 149
movechar:(RESNUM,1,RESBUF,5,5,0)#      Four dig + ins. code 5 bytes     PD44 150
movechar:(RESTYP,1,RESBUF,10,3,0)#     Pack up the residue type 3 byt   PD44 151
movechar:(CHAINI,1,RESBUF,14,3,0)#     Save chain id 3 bytes            PD44 152
movechar:(BLANK,1,RESBUF,13,1,1)#      Blank spare character  1 byte    PD44 153
incrqx:(STOPR,STOPR+STEPR,PD4404)#     Get space for packet             PD44 154
movector:(RESBUF,1,QX(J+1),1,16,0)#    And store for pd91 write         PD44 155
IF(NHIT==yes:) movechar:(RESBUF,1,CHANNM,12*(CHANUM-1)+1,12,0)# & pri   PD44 156
compchar:(RESNUM,1,BLANK,1,1,1,1,HIT)# Make sure no overflow            PD44 157
IF(HIT!=1)#                            Trouble if not blank in 1        PD44 158
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PD44 159
movechar:(RESNUM,1,PD44F,15,5,0)#                                       PD44 160
movechar:(RESNAM,1,PD44F,22,4,0)#                                       PD44 161
writeline:(0,PD44F,NPD44F,3,3)#        Warn user                        PD44 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PD44 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PD44 164
#                                                                       PD44 165
# THE ITEMS WHICH ARE WRITTEN TO THE BDF ON FILE H ARE STORED IN        PD44 166
# SPREAD OUT FORM ACCORDING TO THE DATA STATEMENTS SET UP IN PD11.      PD44 167
# WHICH ARE SELECTED FOR OUTPUT IS UNDER USER CONTROL.  THE XTAL        PD44 168
# ATOM NAME IS TREATED AS A SPECIAL CASE AND IS PLACED ON THE           PD44 169
# FRONT OF THE PACKET.                                                  PD44 170
#                                                                       PD44 171
#  WRITE OUT THE PREPARED ATOM DATA TO FILE H                           PD44 172
#  ------------------------------------------                           PD44 173
#                                                                       PD44 174
INOUT=INOUT+1#                         Count atoms going to output      PD44 175
writepkt:(8,lratom:,PSIZO,IPO)#                                         PD44 176
movector:(OUTID,1,QX(IPO+1),1,LNATNM,0)# Move xtal atom name            PD44 177
DO J=1,BMAX#                           Move data to output              PD44 178
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PD44 179
IF(RELOUT(J+MX24)>0)#                  Only those items scheduled       PD44 180
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PD44 181
K=IPO+RELOUT(J+MX24)#                  Get offset                       PD44 182
movepakwd:(BUFOUT(J),QX(K))#           Move item                        PD44 183
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PD44 184
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PD44 185
RETURN#                                                                 PD44 186
END#                                                                    PD44 187
systemheader:(PD45)#                   Treat atom input                 PD45   1
#################################################################       PD45   2
#                                                               #       PD45   3
#                        PD45                                   #       PD45   4
#                                                               #       PD45   5
#################################################################       PD45   6
SUBROUTINE PD45#                       J.m. stewart nov 1986            PD45   7
###IMPLICIT NONE#                                                       PD45   8
include:(AACOMN)#                                                       PD45   9
include:(PDCOMN)#                                                       PD45  10
#                                                                       PD45  11
#  THIS SUBROUTINE TREATS THE ATOM, HETATM, PROAT , AND PROHET          PD45  12
#  INPUT LINES. THE MAIN WORK IS FORMING THE UNIQUE XTAL ATOM           PD45  13
#  NAME FROM THE SCATTERING FACTOR NAME AND THE PROTEIN DATA            PD45  14
#  BASE ATOM SERIAL NUMBER.  THE SUBFIELDS DEFINED IN THE PDB           PD45  15
#  ATOM NAMES ARE ALSO SCREENED.  THE INPUT BUFFER CONTAINS             PD45  16
#  THE DATA ABOUT EACH ATOM IN THE FOLLOWING ORDER, WHICH IS            PD45  17
#  THE SAME ORDER AS SPECIFIED IN THE PROTEIN DATA BASE AUG 85          PD45  18
#  ------------------------------------------------------------         PD45  19
#                                                                       PD45  20
# FIELD COLS,PDB FMT   DESCRIPTION OF ITEM                              PD45  21
#   1    7-11    I5    ATOM SERIAL NUMBER                               PD45  22
#   2   13-14    A2    SCATTERING FACTOR NAME*                          PD45  23
#   3   15       A1    REMOTNESS CODE*                                  PD45  24
#   4   16       I1    BRANCH DESIGNATOR*                               PD45  25
#   5   17       A1    ALTERNATE LOCATION INDICATOR                     PD45  26
#   6   18-20    A3    RESIDUE NAME                                     PD45  27
#   7   22       A1    CHAIN IDENTIFIER                                 PD45  28
#   8   23-26    I4    RESIDUE SEQUENCE NUMBER                          PD45  29
#   9   27       A1    CODE FOR INSERTION OF RESIDUES                   PD45  30
#  10   31-38    F8.3  ORTHOGONAL ANGSTROM X COORDINATE                 PD45  31
#  11   39-46    F8.3  ORTHOGONAL ANGSTROM Y COORDINATE                 PD45  32
#  12   47-54    F8.3  ORTHOGONAL ANGSTROM Z COORDINATE                 PD45  33
#  13   55-60    F6.2  OCCUPANCY (POPULATION PARAMETER)                 PD45  34
#  14   61-66    F6.2  TEMPERATURE FACTOR, U                            PD45  35
#  15   68-70    I3    FOOTNOTE NUMBER                                  PD45  36
#  16   -----    F6.3  ANOMOLOUS POPULATION PARAMETER(XTAL ONLY)        PD45  37
# * NOTE THAT FIELDS 2, 3, AND 4 ARE TREATED AS ONE A4 FIELD BY THE PDB PD45  38
#                                                                       PD45  39
# THE XTAL ATOM ID (PKT ID 14) IS FORMED FROM THE SCATTERING            PD45  40
# FACTOR NAME, LIMITED TO TWO CHARACTERS BY THE PDB, FOLLOWED BY        PD45  41
# THE SERIAL NUMBER WITH THE REMOTNESS CODE AND BRANCH DESIGNATOR       PD45  42
# IN CHARACTERS 7 AND 8.  FOR HETERO-ATOMS HT IS PLACED IN 7 AND 8.     PD45  43
# A VERY UGLY AND INTERESTING KLUDGE EXISTS IN THE PDB.                 PD45  44
# HYDROGEN ATOMS REQUIRE A SUB-BRANCH DESIGNATOR BECAUSE THERE CAN BE   PD45  45
# UP TO THREE OF THEM ON ANY CARBON ATOM.  WHERE DID THE PDB AUTHORS    PD45  46
# PUT THIS ADDITIONAL INTEGER?? WHY RIGHT IN FRONT OF THE H IN COLUMN   PD45  47
# 14,THAT'S WHERE! SO SPECIAL CODING IS NEEDED TO DETECT NUMBERS ON     PD45  48
# THE FRONT OF THE SCATTERING FACTOR NAME FIELD.                        PD45  49
#                                                                       PD45  50
#                                                                       PD45  51
INTEGER BRANCH#                        Pointer to character 'branch     PD45  52
INTEGER HIT#                           Signal compare characters        PD45  53
INTEGER FIRST#                         First character in chrin fie     PD45  54
INTEGER I,J,K#                         Pointers and such                PD45  55
INTEGER LAST#                          Last + 1 character               PD45  56
INTEGER NCH1#                          Chars in synthetic atom id       PD45  57
REAL SERNEW#                           For development of serlin        PD45  58
#                                                                       PD45  59
intdata:(NCHIN,[1])#                   Number of chars, first-last      PD45  60
chardata:(PD45A, ATOM SEQUENCE NUMBER ERROR AT...)#                     PD45  61
chardata:(PD45B, ABGDEZHXT_)#          Remotness indicator              PD45  62
chardata:(PD45D, 0123456789)#          Branch designator                PD45  63
string:(REMIND,1)#                                                      PD45  64
string:(BRNDES,1)#                                                      PD45  65
string:(SUBBRN,1)#                     Sub-branch designator            PD45  66
chardata:(PD45E, INCORRECT MNEMONIC FOR THREE LETTER RESIDUE $#         PD45  67
NAME        IN LINE...)#                                                PD45  68
chardata:(PD45G, THE ONLY KINDS OF SCATTERING FACTOR NAMES $#           PD45  69
WHICH CAN START WITH A NUMBER ARE HYDROGENS.)#                          PD45  70
chardata:(PD45M,[_HT])#                Hetero atom mark in atom id      PD45  71
chardata:(PD45N,[A])#                  Default chain identifier         PD45  72
datastuff:#                                                             PD45  73
#                                                                       PD45  74
#  PLACE THE CONTENTS OF THE INPUT LINE, SCREENED, INTO LINE BUFFER     PD45  75
#  ----------------------------------------------------------------     PD45  76
#                                                                       PD45  77
SERNEW=SERLIN+1.0#                     Advance atom serial number       PD45  78
IF(BUFIN(1)>0.0&BUFIN(1)<100000.0)#    Must fit in pdb columns          PD45  79
SERNEW=FLOAT(NINT(BUFIN(1)))#          Accept his/her desires           PD45  80
IF(SERNEW<=SERLIN)#                    But its gotta go on, not bac     PD45  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PD45  82
writeline:(0,PD45A,NPD45A,3,3)#        Blast sequence error             PD45  83
writeline:(0,CHRIN,CHRMAX,3,3)#        Show blasted input line          PD45  84
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PD45  85
SERLIN=SERNEW#                         Accept new serial number         PD45  86
BUFLIN(17)=SERLIN#                     And save it in buffer            PD45  87
#                                                                       PD45  88
#  SET UP SCATTERING FACTOR TYPE IN ORDER TO BUILD XTAL ATOM NAME       PD45  89
#  --------------------------------------------------------------       PD45  90
#                                                                       PD45  91
SCATNO=1.0#                            Default to s.f. 1                PD45  92
movechar:(BLANK,1,SUBBRN,1,1,1)#       Blank out sub-branch designato   PD45  93
IF(BUFIN(2)>=voidflg:) iquit:(-PD4501)# Must have characters            PD45  94
ELSE#                                  Check s.f. characters            PD45  95
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PD45  96
stringlim:(2,FIRST,LAST)#              Get string limits                PD45  97
NCHIN=LAST-FIRST#                      Get no. of characters            PD45  98
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PD45  99
IF(NCHIN>2) iquit:(PD4502)#            No grossly bad sf ids please     PD45 100
IF(NCHIN==2)#                          May be a hydrogen                PD45 101
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PD45 102
compchar:(CHRIN,FIRST,PD45D,3,1,1,9,HIT)# Check for a lead number       PD45 103
IF(HIT!=0)#                            And if ones there                PD45 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PD45 105
compchar:(CHRIN,FIRST+1,PD45B,8,1,1,1,HIT)# It better be a hydrogen     PD45 106
IF(HIT!=0)#                            So it is                         PD45 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PD45 108
movechar:(CHRIN,FIRST,SUBBRN,1,1,0)#   Save no. as sub-branch           PD45 109
NCHIN=1 ; FIRST=FIRST+1#               And point to 'h'                 PD45 110
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PD45 111
ELSE#                                  Complain about s.f. name         PD45 112
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PD45 113
writeline:(0,PD45G,NPD45G,3,3)#        It just shouldn't be             PD45 114
writeline:(0,CHRIN,CHRMAX,3,3)#                                         PD45 115
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PD45 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PD45 117
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PD45 118
#                                                                       PD45 119
# THE FOLLOWING THREE WORDS HOLD THE PACKED UP CHARACTERS FOR THE       PD45 120
# LEAST SIG FIGS OF THE RESIDUE SEQUENCE NUMBER, 13,1-3, AND THE        PD45 121
# INSERTION OF RESIDUE CODE 13,4, THE REMOTNESS CODE, 14,1, THE         PD45 122
# BRANCH DESIGNATOR, 14,2, THE SUB-BRANCH DESIGNATOR, 14,3, THE         PD45 123
# ALTERNATE LOCATION INDICATOR, 14,4, THE CHAIN IDENTIFIER,             PD45 124
# 16,1-3, AND THE MOST SIG FIG OF THE RESIDUE SEQUENCE NUMBER 16,4,     PD45 125
# AND THE RESIDUE NAME IN 18,1-4.                                       PD45 126
#                                                                       PD45 127
movector:(BLANK,1,BUFLIN(13),1,4,1)#   Clear codes to blanks            PD45 128
movector:(BLANK,1,BUFLIN(14),1,4,1)#   And the rest                     PD45 129
movector:(BLANK,1,BUFLIN(16),1,4,1)#   And the rest                     PD45 130
movector:(BLANK,1,BUFLIN(18),1,4,1)#   And the rest                     PD45 131
movechar:(CHRIN,FIRST,NEWID,1,NCHIN,0)# Start building xtal atom id     PD45 132
NCH1=NCHIN#                            Count chars in synthetic id      PD45 133
CALL PD05(NCH1)#                       Check s.f. name                  PD45 134
IF(NCH1<NCHIN)#                        If pd05 is cutting back          PD45 135
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PD45 136
movechar:(BLANK,1,NEWID,1,LNATNM,1)#   Blank new xtal atom name         PD45 137
movechar:(CHRIN,FIRST,NEWID,1,NCH1,0)# And rebuild xtal name            PD45 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PD45 139
BUFLIN(19)=AMAX1(1.0,SCATNO)#          Save the scat fact type          PD45 140
#                                                                       PD45 141
#  TREAT REMOTNESS INDICATOR                                            PD45 142
#  -------------------------                                            PD45 143
#                                                                       PD45 144
movechar:(BLANK,1,REMIND,1,1,1)#       Save to use in xtal name         PD45 145
IF(BUFIN(3)>=1.0&BUFIN(3)<=9.0)#       Heteroatoms can have numbers     PD45 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PD45 147
HIT=2+NINT(BUFIN(3))#                  Set pointer to character         PD45 148
movector:(PD45D,HIT,BUFLIN(14),1,1,0)# Save remotness indicator         PD45 149
movechar:(PD45D,HIT,REMIND,1,1,1)#     Save to use in xtal name         PD45 150
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PD45 151
ELSE IF(BUFIN(3)<voidflg:)#            Go for remotness indicator cha   PD45 152
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PD45 153
stringlim:(3,FIRST,LAST)#                                               PD45 154
IF(LINID==4\LINID==5)#                 Heteroatoms allow any characte   PD45 155
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PD45 156
movector:(CHRIN,FIRST,BUFLIN(14),1,1,0)# Save as remotness indicator    PD45 157
movechar:(CHRIN,FIRST,REMIND,1,1,1)#   Save to use in xtal name         PD45 158
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PD45 159
ELSE#                                  But main chain atoms are fussy   PD45 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PD45 161
compchar:(CHRIN,FIRST,PD45B,2,1,1,NPD45B,HIT)# Must be pdb allowed ch   PD45 162
movector:(PD45B,HIT+1,BUFLIN(14),1,1,0)# Save remotness indicator       PD45 163
movechar:(PD45B,HIT+1,REMIND,1,1,1)#   Save to use in xtal name         PD45 164
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PD45 165
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PD45 166
#                                                                       PD45 167
#  SET UP BRANCH DESIGNATOR                                             PD45 168
#  ------------------------                                             PD45 169
#                                                                       PD45 170
IF(BUFIN(4)<voidflg:)#                 Test for characters              PD45 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PD45 172
stringlim:(4,FIRST,LAST)#                                               PD45 173
movechar:(CHRIN,FIRST,BRNDES,1,1,0)#   Take only one                    PD45 174
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PD45 175
ELSE#                                  May be numbers                   PD45 176
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PD45 177
BRANCH=1#                              Assume no branch designator      PD45 178
IF(BUFIN(4)>=1.0&BUFIN(4)<=9.0)#                                        PD45 179
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PD45 180
BRANCH=MIN0(NINT(BUFIN(4))+2,NPD45D)#                                   PD45 181
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PD45 182
movechar:(PD45D,BRANCH,BRNDES,1,1,0)#                                   PD45 183
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PD45 184
movector:(BRNDES,1,BUFLIN(14),2,1,0)#  Save for xtal atom name          PD45 185
movector:(SUBBRN,1,BUFLIN(14),3,1,0)#  Save subbranch designator        PD45 186
#                                                                       PD45 187
#  TREAT LOCATION INDICATOR                                             PD45 188
#  ------------------------                                             PD45 189
#                                                                       PD45 190
IF(BUFIN(5)<voidflg:)#                 Should be characters             PD45 191
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PD45 192
stringlim:(5,FIRST,LAST)#              Alternate location indicator     PD45 193
movector:(CHRIN,FIRST,BUFLIN(14),4,1,0)# Store it                       PD45 194
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PD45 195
ELSE movector:(PD45D,1,BUFLIN(14),4,1,0)# Or blank it                   PD45 196
#                                                                       PD45 197
#  TREAT THE RESIDUE NAME,  CHECK AGAINST LIST GIVEN IN PDB             PD45 198
#  ------------------------------------------------------               PD45 199
#                                                                       PD45 200
movechar:(BLANK,1,RESNAM,1,4,1)#       Blank out the residue name       PD45 201
IF(BUFIN(6)<voidflg:)#                 Check for characters             PD45 202
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PD45 203
stringlim:(6,FIRST,LAST)#              Find string                      PD45 204
J=MAX0(3,MIN0(LAST-FIRST,4))#          Take up to 4 chars               PD45 205
compchar:(CHRIN,FIRST,RESABB,1,J,4,TOTRES,HIT)# Search legitimates      PD45 206
IF(LAST-FIRST>4\HIT==0)#               Wary of spellings not pdb's      PD45 207
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PD45 208
movechar:(CHRIN,FIRST,PD45E,51,J,0)#   Show erroneous characters        PD45 209
writeline:(0,PD45E,NPD45E,3,3)#        As cautionary message to         PD45 210
writeline:(0,CHRIN,CHRMAX,3,3)#        User                             PD45 211
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PD45 212
movechar:(CHRIN,FIRST,RESNAM,1,J,0)#   Save users as residue name       PD45 213
movector:(RESNAM,1,BUFLIN(18),1,J,0)#  And place in buffer too          PD45 214
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PD45 215
movechar:(BLANK,1,CHAINI,1,3,1)#       Blank out chain id               PD45 216
IF(BUFIN(7)<voidflg:)#                 Test and store chain id          PD45 217
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PD45 218
stringlim:(7,FIRST,LAST)#                                               PD45 219
J=MIN0(3,LAST-FIRST)#                                                   PD45 220
movector:(CHRIN,FIRST,BUFLIN(16),1,J,0)# Save chain identifier          PD45 221
movechar:(CHRIN,FIRST,CHAINI,1,J,1)#   Two ways against the middle      PD45 222
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PD45 223
ELSE#                                  Check for numeric chain id       PD45 224
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PD45 225
IF(BUFIN(7)>0.0&BUFIN(7)<=9.0)#        Translate chain id nos. to cha   PD45 226
ncodefld:(BUFIN(7),1,CHAINI,10113.,1)# Single diget, left justified     PD45 227
ELSE IF(BUFIN(7)>=10.0&BUFIN(7)<=99.0)#                                 PD45 228
ncodefld:(BUFIN(7),1,CHAINI,20213.,1)# Double digit ditto               PD45 229
ELSE IF(BUFIN(7)>=100.0&BUFIN(7)<=999.0)#                               PD45 230
ncodefld:(BUFIN(7),1,CHAINI,30313.,1)# Triple digit                     PD45 231
ELSE movechar:(PD45N,1,CHAINI,1,NPD45N,0)# Default to the letter "a"    PD45 232
movector:(CHAINI,1,BUFLIN(16),1,3,0)#                                   PD45 233
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PD45 234
#                                                                       PD45 235
# SET UP RESIDUE SEQUENCE NUMBER AND RESIDUE INSERTION CODE             PD45 236
# ---------------------------------------------------------             PD45 237
#                                                                       PD45 238
movechar:(BLANK,1,RESNUM,1,5,1)#       Blank out the residue name       PD45 239
IF(BUFIN(8)>=1.0&BUFIN(8)<=9999.0)#    Must fit pdb restriction         PD45 240
ncodefld:(BUFIN(8),1,RESNUM,40413.,1)# Make resnum into characters      PD45 241
IF(BUFIN(9)<voidflg:)#                 Insertion of residues code       PD45 242
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PD45 243
stringlim:(9,FIRST,LAST)#                                               PD45 244
movechar:(CHRIN,FIRST,RESNUM,5,1,0)#   Combine the insert resid code    PD45 245
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PD45 246
movector:(RESNUM,2,BUFLIN(13),1,4,0)#  Least sig digs of residue        PD45 247
movector:(RESNUM,1,BUFLIN(16),4,1,0)#  Most sig dig of residue          PD45 248
#                                                                       PD45 249
#  TRANSFORM COORDINATES FROM ORTHOGNAL ANGSTROMS TO FRACTIONAL         PD45 250
#  ------------------------------------------------------------         PD45 251
#                                                                       PD45 252
DO J=10,12 ; IF(BUFIN(J)<(-1000.0)\BUFIN(J)>1000.0) BUFIN(J)=0.0#       PD45 253
K=1 ; DO J=1,12,4#                     Loop over transformation         PD45 254
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PD45 255
BUFLIN(K)=ORTHTF(J  )*BUFIN(10)+ORTHTF(J+1)*BUFIN(11)+$#                PD45 256
          ORTHTF(J+2)*BUFIN(12)+ORTHTF(J+3)#                            PD45 257
K=K+1#                                                                  PD45 258
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PD45 259
#                                                                       PD45 260
#  POPULATION PARAMETER AND ANOMOLUS POPULATION PARAMETER               PD45 261
#  ------------------------------------------------------               PD45 262
#                                                                       PD45 263
BUFLIN(11)=1.0 ; BUFLIN(12)=0.0#       Defaults                         PD45 264
IF(BUFIN(13)>0.0&BUFIN(13)<2.0) BUFLIN(11)=BUFIN(13)# Take pop param    PD45 265
IF(BUFIN(16)>=0.0&BUFIN(16)<2.0)BUFLIN(12)=BUFIN(16)# Take anomolus p   PD45 266
#                                                                       PD45 267
#  INDIVIDUAL ISOTROPIC U,  CONVERT B AS NECESSARY.                     PD45 268
#  ------------------------------------------------                     PD45 269
#                                                                       PD45 270
IF(BUFIN(14)<0.0) BUFLIN(4)=.0126651#  Default to b of ten as u         PD45 271
ELSE IF(BUFIN(14)>BCUT) BUFLIN(4)=BUFIN(14)/ATEPSQ# Big ones as b       PD45 272
ELSE BUFLIN(4)=BUFIN(14)#              It is u so take it already!      PD45 273
DO J=1,6 ; DEFAUL(J+4)=BUFLIN(4)*UTOUIJ(J)# Set default aniso           PD45 274
#                                                                       PD45 275
#  BUILD A SYNTHETIC ATOM NAME FROM ALL KNOWN RESIDUE INFORMATION       PD45 276
#  --------------------------------------------------------------       PD45 277
#                                                                       PD45 278
## The plan is: <scattering factor ID>_<residue number>_<remotness      PD45 279
## indicator><branch designator><subbranch indicator>_<chain            PD45 280
## Identity>_<residue name>                                             PD45 281
##                                                                      PD45 282
NCH1=NCH1+1 ; movechar:(PD45B,11,NEWID,NCH1,1,0)# Underscore one        PD45 283
DO I=1,4#                              Move in residue number           PD45 284
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PD45 285
compchar:(RESNUM,I,PD45D,1,1,1,NPD45D,HIT)# Look out for blanks         PD45 286
IF(HIT==1) NEXT#                       Ditch blanks                     PD45 287
NCH1=NCH1+1#                           Count non-blank byte             PD45 288
movechar:(RESNUM,I,NEWID,NCH1,1,0)#    Move next byte of residue numb   PD45 289
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PD45 290
IF(LINID==4\LINID==5)#                 Test for hetero atoms            PD45 291
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PD45 292
movechar:(PD45M,1,NEWID,NCH1+1,NPD45M,0)# Hetatms get special mark      PD45 293
NCH1=NCH1+NPD45M#                      Count up characters added        PD45 294
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PD45 295
ELSE#                                  Non hetro atom                   PD45 296
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PD45 297
NCH1=NCH1+1 ; movechar:(PD45B,11,NEWID,NCH1,1,0)# Underscore two    ^   PD45 298
compchar:(REMIND,1,PD45D,1,1,1,NPD45D,HIT)# Check remotness indicator   PD45 299
IF(HIT!=1)#                            Take anything but blanks         PD45 300
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PD45 301
NCH1=NCH1+1 ; movechar:(REMIND,1,NEWID,NCH1,1,0)# Remotness indicator   PD45 302
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PD45 303
compchar:(BRNDES,1,PD45D,1,1,1,NPD45D,HIT)# Check branch designator     PD45 304
IF(HIT!=1)#                            Take anything but blanks         PD45 305
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PD45 306
NCH1=NCH1+1 ; movechar:(BRNDES,1,NEWID,NCH1,1,0)# Branch designator ^   PD45 307
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PD45 308
compchar:(SUBBRN,1,PD45D,1,1,1,NPD45D,HIT)# Check sub-branch designat   PD45 309
IF(HIT!=1)#                            Take anything but blanks         PD45 310
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PD45 311
NCH1=NCH1+1 ; movechar:(SUBBRN,1,NEWID,NCH1,1,0)# Sub-branch designat   PD45 312
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PD45 313
NCH1=NCH1+1 ; movechar:(PD45B,11,NEWID,NCH1,1,0)# Underscore three      PD45 314
NCH1=NCH1+1 ; movechar:(CHAINI,1,NEWID,NCH1,1,0)# Chain identity        PD45 315
NCH1=NCH1+1 ; movechar:(PD45B,11,NEWID,NCH1,1,0)# Underscore four       PD45 316
DO I=1,4#                              Move in residue name             PD45 317
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 PD45 318
compchar:(RESNAM,I,PD45D,1,1,1,NPD45D,HIT)# Look out for blanks         PD45 319
IF(HIT==1) NEXT#                       Ditch blanks                     PD45 320
NCH1=NCH1+1#                           Count non-blank byte             PD45 321
movechar:(RESNAM,I,NEWID,NCH1,1,0)#    Move next byte of residue name   PD45 322
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 PD45 323
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PD45 324
IF(NCH1>LNATNM) iquit:(-PD4504)#       Atom id got too long             PD45 325
#                                                                       PD45 326
RETURN#                                                                 PD45 327
END#                                                                    PD45 328
systemheader:(PD81)#                                                    PD81   1
# ################################################################## #  PD81   2
#                                                                    #  PD81   3
#                               PD81                                 #  PD81   4
#                                                                    #  PD81   5
# ################################################################## #  PD81   6
SUBROUTINE PD81#                       J.m. stewart uwa dec 1986        PD81   7
###IMPLICIT NONE#                                                       PD81   8
include:(AACOMN)#                                                       PD81   9
include:(PDCOMN)#                                                       PD81  10
#                                                                       PD81  11
INTEGER IX,K,KK,J#                     Little indices for pointing      PD81  12
INTEGER JPT#                           Packet pointer for write         PD81  13
INTEGER PKSIZE#                        Lrcons: packet size              PD81  14
REAL    PAKHED(20)#                    Lrcons: packet header packet     PD81  15
REAL    PAKFMT(20)#                    Format to print index of lrc     PD81  16
INTEGER RECCOP#                        Record to begin final copy a     PD81  17
#                                                                       PD81  18
chardata:(PD45, CONSTRAINT LOGICAL RECORD PACKET HEADER....)#           PD81  19
chardata:(PD52, SPACE GROUP AXIS X IS POLAR.)#                          PD81  20
chardata:(PD53,ABC)#                                                    PD81  21
realdata:(FMTWD,413.)#                                                  PD81  22
realdata:(NUL,0.)#                                                      PD81  23
realdata:(PAKNUM,[2.,5.,12.,13.,3.,4.])#                                PD81  24
datastuff:#                                                             PD81  25
#                                                                       PD81  26
PKSIZE=2*MX24#                         Set packet size                  PD81  27
copyfile:(1,8,incr:(lratom:),decr:(lrcons:))# Copy between              PD81  28
RECCOP=lrcons:#                        Assume no constraints            PD81  29
IF(POLSPG(1)+POLSPG(2)+POLSPG(3)>0)#   If polar axes                    PD81  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PD81  31
DO J=1,20#                             Set up lrcons: packet header     PD81  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PD81  33
FMTWD=FMTWD+40000. ; PAKFMT(J)=FMTWD#                                   PD81  34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PD81  35
KK=MX24#                               Pick up number of words          PD81  36
DO K=1,MX24#                           To hold twenty four characters   PD81  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PD81  38
PAKHED(K)=1.0#                         Subject atom                     PD81  39
KK=KK+1#                                                                PD81  40
PAKHED(KK)=11.0#                       Atom to which it is related      PD81  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PD81  42
DO K=1,6#                                                               PD81  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PD81  44
PKSIZE=PKSIZE+1#                                                        PD81  45
PAKHED(PKSIZE) =PAKNUM(K)#             Put away the index numbers       PD81  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PD81  47
writepkt:(8,lrcons:,PKSIZE,JPT)#       Get a packet pointer             PD81  48
movereal:(PAKHED,1,QX,JPT+1,PKSIZE,0)#                                  PD81  49
ncodefld:(PAKHED,1,CHROT,PAKFMT,PKSIZE)#                                PD81  50
writeline:(1,PD45,NPD45,2,3)#          Dump packet header to user       PD81  51
#                                                                       PD81  52
#   SET UP SPECIAL CONSTRAINT PACKETS FOR POLAR AXES                    PD81  53
#   RESTRICTION TYPE IS 4.0.  PARAMETER NUMBERS ARE                     PD81  54
#   1 FOR A AXIS, 2 FOR B AXIS, 3 FOR C AXIS.                           PD81  55
#                                                                       PD81  56
IF(ICENT==1)#                          Test for acentric                PD81  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PD81  58
DO K=1,3#                              Loop over a, b, and c            PD81  59
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PD81  60
IF(POLSPG(K)>0)#                       If not zero its polar            PD81  61
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PD81  62
writepkt:(8,lrcons:,PKSIZE,JPT)#       Write another packet             PD81  63
KK=JPT+1#                                                               PD81  64
movector:(BLANK,1,QX(KK),1,LNATNM,1)#  Put blanks for name              PD81  65
KK=KK+MX24#                            Move across name                 PD81  66
movector:(BLANK,1,QX(KK),1,LNATNM,1)#  Blanks again                     PD81  67
KK=KK+MX24#                            And jump again                   PD81  68
IX=PKSIZE-2*MX24#                      Calc how many more               PD81  69
movereal:(NUL,1,QX(KK),1,IX,1)#        Zero the lot                     PD81  70
QX(KK)=FLOAT(K)#                       Set axis for parameter           PD81  71
QX(KK+1)=4.0#                          Set polar axis signal            PD81  72
movechar:(PD53,K,PD52,19,1,0)#         Move axis symbol                 PD81  73
writeline:(1,PD52,NPD52,3,3)#          Tell about polar axis            PD81  74
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PD81  75
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PD81  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PD81  77
RECCOP=incr:(lrcons:)#                 Set to copy rest of bdf          PD81  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PD81  79
copyfile:(1,8,RECCOP,decr:(lrrefl:))#  Copy all the rest of bdf         PD81  80
writepkt:(8,endrecord:,3,JPT)#         End off scratch file             PD81  81
RETURN#                                                                 PD81  82
END#                                                                    PD81  83
systemheader:(PD91)#                   Op constraints lrcons            PD91   1
# ################################################################## #  PD91   2
#                                                                    #  PD91   3
#                               PD91                                 #  PD91   4
#                                                                    #  PD91   5
# ################################################################## #  PD91   6
SUBROUTINE PD91#                       J.m. stewart uwa dec 1986        PD91   7
include:(AACOMN)#                      Nrl june 1989                    PD91   8
include:(PDCOMN)#                                                       PD91   9
#                                                                       PD91  10
# THE PURPOSE OF THIS ROUTINE IS TO PRINT AND/OR PUNCH ATOM             PD91  11
# PARAMETERS IN PROTEIN DATA BANK FORM.  BERNSTEIN ET.AL.               PD91  12
# J. MOL. BIOL. 112, 535-42 (1977).                                     PD91  13
# THE FORMATS USED HERE ARE TAKEN FROM THE AUGUST 1985 INTODUCTION.     PD91  14
#                                                                       PD91  15
# THE OUTPUT MAY CONSIST OF THE FOLLOWING ITEMS GIVEN HERE IN THE       PD91  16
# ORDER DEFINED IN THE DATA STATEMENTS OF ROUTINE PD11.  SHOWN ARE      PD91  17
# THE SEQUENCE NUMBER FROM PD11, THE MNEMONIC FROM PD11, THE BINARY     PD91  18
# DATA FILE PACKET NUMBER, FOLLOWED IN A FEW CASES BY CHARACTER         PD91  19
# POSITIONS WITHIN BUFFER WORDS, THE PRINT FORMAT USED IN PD91 IN       PD91  20
# XTAL NCODEFLD NOTATION, AND A SHORT DESCRIPTION OF THE QUANTITY.      PD91  21
#                                                                       PD91  22
# NO. MNEM PKT ID FMT      DESCRIPTION                                  PD91  23
#  1  X      1     460832. X FRACT IN FILE ORTH ANG IN PDB              PD91  24
#  2  Y      2     550832. Y                                            PD91  25
#  3  Z      3     640832. Z                                            PD91  26
#  4  U      4     760632. B IN BDF U   IN PDB DEPENDING ON OPTION      PD91  27
#     B            760612. IF B USED IN PDB                             PD91  28
#  5  U11    5     930713. BETA 11 IN BDF U 11 IN FILE                  PD91  29
#  6  U22    6    1000713.      22                                      PD91  30
#  7  U33    7    1070713.      33                                      PD91  31
#  8  U12    8    1140713.      12                                      PD91  32
#  9  U13    9    1210713.      13                                      PD91  33
# 10  U23   10    1280713.      23                                      PD91  34
# 11  POP   11     700632. POPULATION PARAMETER OR OCCUPANCY            PD91  35
# 12  APP   12     850632. ANAOMOLUS POP PARAM, UNDEFINED IN PDB        PD91  36
# 13  RSQ   16,1-3 CH33-35 LEAST SIG DIGS RESIDUE SEQ NO.               PD91  37
# 13  RSQ   16,4   CH37    INSERTION OF RESIDUE CODE                    PD91  38
# 14  SEQ   15,1   CH21    REMOTNESS INDICATOR                          PD91  39
# 14  SEQ   15,2   CH22    BRANCH DESIGNATOR                            PD91  40
# 14  SEQ   15,3   CH      SUB-BRANCH DESIGNATOR(FOR H'S)               PD91  41
# 14  SEQ   15,4   CH24    ALTERNATE LOCATION INDICATOR                 PD91  42
# 15  SET   17     NOT O/P DATA SET TO WHICH ATOM BELONGS               PD91  43
# 16  CHN   18,1-3 CH30    CHAIN IDENTIFIER UP TO 3 CHARS               PD91  44
#                          BUT LIMITED TO 1 BY PDB SPECS                PD91  45
# 16  CHN   18,4   CH32    MOST SIG DIG OF RESIDUE SEQUENCE NUMBER      PD91  46
# 17  SQN   20     150513. ATOM SERIAL NUMBER                           PD91  47
# 18  RES   19     CH26-28 RESIDUE NAME                                 PD91  48
# 19  SFT   22     NOT O/P SCATTERING FACTOR TYPE, OUTPUT IN ATOM NAME  PD91  49
# 20  TFT   23     NOT O/P ATOM TEMPERATURE FACTOR TYPE                 PD91  50
# 21  SX   101     460832. SIGMA X                                      PD91  51
# 22  SY   102     550832. SIGMA Y                                      PD91  52
# 23  SZ   103     640832. SIGMA Z                                      PD91  53
# 24  SPP  111     700632. SIGMA POP PARAM                              PD91  54
# 25  SU   104     760632. SIGMA U                                      PD91  55
#     SB   104     760612. SIGMA B IF REQUESTED BY BIS OPTION           PD91  56
# 26  SAP  112     850632. SIGMA ANOM POP PARAM                         PD91  57
# 27  SU1  105     930713. SIGMA U11 OR BETA 11 DEPENDING ON PLACE      PD91  58
# 28  SU2  106    1000713.        22                                    PD91  59
# 29  SU3  107    1070713.        33                                    PD91  60
# 30  SU4  108    1140713.        12                                    PD91  61
# 31  SU5  109    1210713.        13                                    PD91  62
# 32  SU6  110    1280713.        23                                    PD91  63
#                                                                       PD91  64
INTEGER HIT#  ## FLAG FOR USE WITH COMPCHAR: MACRO                      PD91  65
INTEGER HETAT## SIGNAL FOR HETERO-ATOMS                                 PD91  66
INTEGER MAXLEN## MAXIMUM LENGTH OF AN OUTPUT LINE                       PD91  67
INTEGER NUMCHA## Recount of number of chains from stored residue list   PD91  68
INTEGER ANYSIG## SIGNAL IF ANY SIGMAS IN BDF                            PD91  69
INTEGER LPAK,IP,KEY(4),IWNT(4),IR(6),IPR# For file reading              PD91  70
INTEGER LX,LY,LZ#                      X,y,z pointers                   PD91  71
INTEGER ANOFF,SANOFF#                  Aniso tf and sigma offset        PD91  72
INTEGER I,J,K,M,L#                     Index registers                  PD91  73
INTEGER INFILE,OUTFIL,JPT#             Files for copying straight       PD91  74
INTEGER ONRES#                         Count of residues                PD91  75
INTEGER SLAVPT#                        Pointer to slave flag            PD91  76
REAL X(9)#                             Temporary param store            PD91  77
string:(CURRES,5)#                     Current residue                  PD91  78
string:(RESCOD,4)#                     Current residue code             PD91  79
string:(PUNBUF,80)## BUFFER FOR PUNCH LINES                             PD91  80
string:(ATMBUF,132)## BUFFER FOR ATOMIC PARAMETERS                      PD91  81
string:(SIGBUF,132)## BUFFER FOR SIGMAS OF ATOMIC PARAMETERS            PD91  82
#                                                                       PD91  83
# THE FOLLOWING TABLES ARE SET TO ALLOW THE COMPRESSION OF              PD91  84
# THE PRINT OUTPUT BUFFERS INTO THE PDF PUNCH LINES                     PD91  85
#                                                                       PD91  86
intdata:(FROM,[11,19,24,26,30,32,37,39,48,57,65,71,77,87,94,$#          PD91  87
101,108,115,122])#                                                      PD91  88
intdata:(TO,  [ 7,13,17,18,22,23,27,31,39,47,55,61,68,29,36,$#          PD91  89
 43, 50, 57, 64])#                                                      PD91  90
intdata:(NUMB,[ 5, 4, 1, 3, 1, 4, 1, 8, 8, 8, 6, 6, 3, 7, 7,$#          PD91  91
  7,  7,  7,  7])#                                                      PD91  92
intdata:(SIGLIN,[21])#                                                  PD91  93
intdata:(ATMVOID,no:)#                                                  PD91  94
realdata:(SERNUM,[0])#                                                  PD91  95
realdata:(FMT,[460832.,550832.,640832.,760632.,930713.,1000713.,$#      PD91  96
1070713.,1140713.,1210713.,1280713.,700632.,850632.,0.,0.,0.,0.,$#      PD91  97
150513.,0.,0.,0.,460832.,550832.,640832.,700632.,760632.,$#             PD91  98
850632.,930713.,1000713.,1070713.,1140713.,1210713.,1280713.])#         PD91  99
chardata:(ATOMI,                         )# For printing atom names ^   PD91 100
chardata:(PD91A, ATOM ID    SER   NAME A RES C RSEQ I   $#              PD91 101
X ORTH   Y ORTH   Z ORTH   POP    U   FN   APP    $#                    PD91 102
U11    U22    U33    U12    U13    U23)#                                PD91 103
chardata:(PD91B,[HT])#                 Heteroatom signal                PD91 104
chardata:(PD91C,[ATOM  ])#             Protein data bank line names     PD91 105
chardata:(PD91D,[HETATM])#                                              PD91 106
chardata:(PD91E,[SIGATM])#                                              PD91 107
chardata:(PD91F,[ANISOU])#                                              PD91 108
chardata:(PD91G,[SIGUIJ])#                                              PD91 109
chardata:(PD91H, NO ATOMS IN BINARY DATA FILE )#                        PD91 110
chardata:(PD91K,         RESIDUES COUNTED DURING LOADING OF ATOMS.)#    PD91 111
chardata:(PD91L, TABLE OF RESIDUE NUMBERS, INSERTION CODES, AND $#      PD91 112
NAMES.)#                                                                PD91 113
chardata:(PD91Q, CHAIN           N TERMINAL RESIDUE          $#         PD91 114
..   C TERMINAL RESIDUE            ..)#                                 PD91 115
chardata:(PD91Z, ** notice: PDB CONTAINS VOID ATOMIC COORDINATES-$#     PD91 116
WILL CAUSE ERROR IF PDB INPUT TO PROATM.)#                              PD91 117
chardata:(TRASH,[*])#                  To clear test character string   PD91 118
#                                                                       PD91 119
datastuff:#                                                             PD91 120
movechar:(TRASH,1,CHAOLD,1,3,1) ; NUMCHA=0# Prepare chain search        PD91 121
IF(B1ORU2==1)#                         Were indiv b's to be output?     PD91 122
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PD91 123
FMT(4)=760612.#                        Fmt for individ b in pdb         PD91 124
FMT(25)=760612.#                       Fmt for sig individ b in pdb     PD91 125
movechar:('B',1,PD91A,75,1,0)#         Change header on output          PD91 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PD91 127
ANOFF=MX24+4 ; SANOFF=MX24+26#         Get offsets in dop array         PD91 128
ONRES=0#                               Zero residue count               PD91 129
movechar:(BLANK,1,CURRES,1,5,1)#       Blank out residue                PD91 130
movechar:(BLANK,1,RESCOD,1,4,1)#       Blank out residue code           PD91 131
IF(LOAD==no:)#                         If no loading then file a        PD91 132
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PD91 133
INFILE=1 ; OUTFIL=0#                   Set file signals                 PD91 134
#                                                                       PD91 135
# SET UP TO INPUT BINARY DATA FILE FROM INPUT FILE A.                   PD91 136
# THIS WILL BE FRESHLY MADE IF THIS IS A RUN OF LOAD==YES:              PD91 137
#                                                                       PD91 138
#                                                                       PD91 139
#    PICK UP UNIT CELL PARAMETERS FOR T.F. CONVERSIONS LATER ON         PD91 140
#                                                                       PD91 141
J=0#                                                                    PD91 142
REPEAT#                                                                 PD91 143
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PD91 144
readwpkt:(1,lrcell:,LPAK,IP,0)#                                         PD91 145
IF(IP<=0) BREAK#                                                        PD91 146
J=J+1#                                                                  PD91 147
IF(J==1)#                                                               PD91 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PD91 149
movereal:(QX,IP+1,CELPD,1,6,0)#                                         PD91 150
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PD91 151
ELSE IF(J==3)#                         Watch for reciprocal cell fa     PD91 152
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PD91 153
BTOBET(1)=0.25*QX(IP+1)**2#            Astar squared over four          PD91 154
BTOBET(2)=0.25*QX(IP+2)**2#            Bstar squared over four          PD91 155
BTOBET(3)=0.25*QX(IP+3)**2#            Cstar squared over four          PD91 156
BTOBET(4)=0.25*QX(IP+1)*QX(IP+2)*QX(IP+6)# A* b* cos(gamma*)/4          PD91 157
BTOBET(5)=0.25*QX(IP+1)*QX(IP+3)*QX(IP+5)#                              PD91 158
BTOBET(6)=0.25*QX(IP+2)*QX(IP+3)*QX(IP+4)#                              PD91 159
TFCON(1)=1.0/(ATEPSQ*BTOBET(1))#                                        PD91 160
TFCON(2)=1.0/(ATEPSQ*BTOBET(2))#                                        PD91 161
TFCON(3)=1.0/(ATEPSQ*BTOBET(3))#                                        PD91 162
TFCON(4)=4./(ATEPSQ*(QX(IP+1)*QX(IP+2)))# Leave out the cos(gamma*)     PD91 163
TFCON(5)=4./(ATEPSQ*(QX(IP+1)*QX(IP+3)))# Leave out the cos(beta*)      PD91 164
TFCON(6)=4./(ATEPSQ*(QX(IP+2)*QX(IP+3)))# Leave out the cos(alpha*)     PD91 165
PDBTFC(1)=QX(IP+1)*QX(IP+2)*CELPD(1)*CELPD(2)*CELPD(6)# A*b*abcos(g)    PD91 166
PDBTFC(2)=QX(IP+1)*QX(IP+3)*CELPD(1)*CELPD(3)*CELPD(5)# A*c*accos(b)    PD91 167
PDBTFC(3)=QX(IP+2)*QX(IP+3)*CELPD(2)*CELPD(3)*CELPD(4)# B*c*bccos(a)    PD91 168
#                                                                       PD91 169
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PD91 170
ELSE IF(J==6)#                         Packet with misc cell data       PD91 171
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PD91 172
CVOL=QX(IP+1);ODENS=QX(IP+2)#          Pick density and cell volume     PD91 173
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PD91 174
ELSE IF(J==9&INORTH==no:)#             Look for orth to fractional      PD91 175
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PD91 176
DO K=1,9 ; ORTHTF(K)=QX(IP+K)#         Accept old values                PD91 177
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PD91 178
ELSE IF(J==10&INORTH==no:)#            Last three elements              PD91 179
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PD91 180
ORTHTF(10)=QX(IP+1);ORTHTF(11)=QX(IP+2);ORTHTF(12)=QX(IP+3)#            PD91 181
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PD91 182
ELSE IF(J==11&INORTH==no:)#            Look for fractional to orth      PD91 183
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PD91 184
DO K=1,9 ; FTORTH(K)=QX(IP+K)#         Or accept old values             PD91 185
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PD91 186
ELSE IF(J==12&INORTH==no:)#            Last three elements              PD91 187
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PD91 188
FTORTH(10)=QX(IP+1);FTORTH(11)=QX(IP+2);FTORTH(12)=QX(IP+3)#            PD91 189
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PD91 190
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PD91 191
IF(J<9&INORTH==no:) iquit:(PD9105)#    Must have transformations        PD91 192
DO J=1,MX24 ; WNTBDF(J)=14#            Xtal atom names                  PD91 193
M=MX24#                                Set to get anything else         PD91 194
DO J=1,PMAXP#                          Loop over all possible           PD91 195
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PD91 196
M=M+1#                                                                  PD91 197
WNTBDF(M)=INDEXP(J)#                   Set up want list                 PD91 198
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PD91 199
#                                                                       PD91 200
#    PICK UP THE SCATTERING FACTOR NAMES FROM LRSCAT:                   PD91 201
#    ------------------------------------------------                   PD91 202
#                                                                       PD91 203
NSFTOT=0#                              Set count of sf types to zer     PD91 204
NSFMX=0#                               Set length of longest sf nam     PD91 205
J=1#                                   Set start of character table     PD91 206
IWNT(1)=11;IWNT(2)=1;IWNT(3)=2#        Set requests for lrscat:         PD91 207
KEY(1)=1;KEY(2)=3;KEY(3)=0;KEY(4)=0#   Set search limits                PD91 208
indexpkt:(1,lrscat:,LPAK,IP,0,KEY,IWNT,IR)# Read directory of lrscat    PD91 209
IF(KEY(4)<=0) iquit:(PD9106)#          No form factors                  PD91 210
REPEAT#                                Read all of them                 PD91 211
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PD91 212
readwpkt:(1,lrscat:,LPAK,IP,0)#                                         PD91 213
IF(IP<=0) BREAK#                                                        PD91 214
NSFTOT=NSFTOT+1#                       Count up s.f. types              PD91 215
IPR=IP+IR(1)#                                                           PD91 216
movertoc:(QX(IPR),1,SFNAME,J,6,0)#                                      PD91 217
I=J#                                                                    PD91 218
FOR(K=1;K<=6;K=K+1)#                                                    PD91 219
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PD91 220
compchar:(SFNAME,I,BLANK,1,1,1,1,HIT)# Look for the first blank         PD91 221
IF(HIT==0) I=I+1#                                                       PD91 222
ELSE BREAK#                                                             PD91 223
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PD91 224
K=K-1#                                 Set actual count of characte     PD91 225
NSFMX=MAX0(NSFMX,K)#                                                    PD91 226
NCSFN(NSFTOT)=K#                                                        PD91 227
J=J+6#                                                                  PD91 228
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PD91 229
NSFNAM=6*NSFTOT#                       Get total chars in all sfs       PD91 230
REPEAT#                                Loop over sequence information   PD91 231
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PD91 232
readwpkt:(1,lrsequ:,LPAK,IP,0)#                                         PD91 233
IF(IP<=0) BREAK#                                                        PD91 234
J=NRESID*STEPR+MARKR ; NRESID=NRESID+1#                                 PD91 235
incrqx:(STOPR,J+STEPR,PD9107)#                                          PD91 236
movereal:(QX,IP+1,QX,J+1,STEPR,0)#                                      PD91 237
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PD91 238
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PD91 239
ELSE#                                  Stuff must be on file h          PD91 240
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PD91 241
copyfile:(8,2,1,decr:(lrsequ:))#       Copy up to lrsequ:               PD91 242
#                                                                       PD91 243
# PUMP OUT THE SEQUENCE INFORMATION GARNERED IN THE FIRST PASS          PD91 244
# ------------------------------------------------------------          PD91 245
#                                                                       PD91 246
INFILE=8 ; OUTFIL=2#                   Set files appropriately          PD91 247
BUFOT(1)=FLOAT(NRESID) ; ncodefld:(BUFOT,1,PD91K,70613.,1) ; L=1#       PD91 248
writeline:(2,PD91K,NPD91K,3,3)#        Tell how many residues           PD91 249
K=MARKR-STEPR#                         Set pointer to sequence data     PD91 250
FOR(J=1;J<=NRESID;J=J+1)#              Loop over all residues           PD91 251
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PD91 252
K=K+STEPR#                             Advance through stored pkts      PD91 253
#                                                                       PD91 254
# THIS PACKET CONTAINS THE RESIDUE NAME IN BYTES 1-4 LEFT JUSTIFIED,    PD91 255
# THE RESIDUE SEQUENCE NUMBER AS THREE BYTES FOLLOWED BY THE CODE FOR   PD91 256
# INSERTION OF RESIDUES IN BYTES 5-9, THE RESIDUE TYPE CODE IN          PD91 257
# BYTES 10-12, AND THE CHAIN IDENTIFIER IN BYTES 14-16. THE RESIDUE     PD91 258
# TYPE CODE IS NTR FOR N TERMINAL RESIDUES, CTR FOR C TERMINAL, AND     PD91 259
# CHN # FOR CHAIN RESIDUES BETWEEN N AND C TERMINAL.                    PD91 260
# HETERO ATOMS ARE IN THIS LIST MARKED HET IN BYTES 14-16.              PD91 261
#                                                                       PD91 262
writepkt:(OUTFIL,lrsequ:,STEPR,JPT)#                                    PD91 263
movereal:(QX,K+1,QX,JPT+1,STEPR,0)#    Move pkt from store to file      PD91 264
movertoc:(QX(K+1),14,CHAINI,1,3,0)#    Get chain id for checking        PD91 265
compchar:(CHAINI,1,CHAOLD,1,3,3,3,HIT)# Check for changed chain id      PD91 266
IF(HIT==0)#                            Zero means it changes here       PD91 267
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PD91 268
NUMCHA=NUMCHA+1#                       Recount chains                   PD91 269
IF(L>1)#                               See if print line to be cleare   PD91 270
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PD91 271
L=1 ; writeline:(0,PD91L,NPD91L,1,3)#  Put out a line                   PD91 272
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PD91 273
movechar:(CHAINI,1,PD91Q,8,3,0) ; movechar:(CHAINI,1,CHAOLD,1,3,0)#     PD91 274
movertoc:(CHANNM,12*(NUMCHA-1)+1,PD91Q,37,4,0)# Get n term residue      PD91 275
movertoc:(CHANNM,12*(NUMCHA-1)+5,PD91Q,42,5,0)# Name and number         PD91 276
movertoc:(CHACNM,12*(NUMCHA-1)+1,PD91Q,70,4,0)# And for c terminal      PD91 277
movertoc:(CHACNM,12*(NUMCHA-1)+5,PD91Q,75,5,0)# The same info           PD91 278
writeline:(1,PD91Q,NPD91Q,3,3)#                                         PD91 279
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PD91 280
IF(L>120)#                             Twelve residues per line         PD91 281
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PD91 282
L=1 ; writeline:(0,PD91L,NPD91L,1,3)#  Put out a line                   PD91 283
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PD91 284
movertoc:(QX(K+1),1,CHROT,L+1,8,0) ; L=L+10# Fill print line            PD91 285
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PD91 286
writeline:(0,PD91L,NPD91L,1,3)#                                         PD91 287
copyfile:(8,2,incr:(lrsequ:),decr:(lratom:))# Copy up to lratom:        PD91 288
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PD91 289
WNTBDF(PMAXP+MX24+1)=215#              Need atom slave flag             PD91 290
KEY(1)=MX24 ; KEY(2)=PMAXP+MX24+1;KEY(3)=PMAXP+MX24+1;KEY(4)=0#         PD91 291
indexpkt:(INFILE,lratom:,LPAK,IP,OUTFIL,KEY,WNTBDF,RELBDF)# Whats the   PD91 292
#                                                                       PD91 293
# ACCEPT THAT WHATS THERE IS WHATS TO BE DONE                           PD91 294
# -------------------------------------------                           PD91 295
#                                                                       PD91 296
M=MX24 ; DO J=1,PMAXP#                                                  PD91 297
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PD91 298
M=M+1 ; IF(RELBDF(J+MX24)>0) DOP(J)=yes:#                               PD91 299
ELSE DOP(J)=no:#                                                        PD91 300
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PD91 301
#                                                                       PD91 302
IF(IP<=0)#                             Anything there?                  PD91 303
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PD91 304
writeline:(1,PD91H,NPD91H,3,1)#        Complain                         PD91 305
iquit:(PD9101)#                        Complain bitterly                PD91 306
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PD91 307
#                                                                       PD91 308
IF(TFTYPE>1) MAXLEN=NPD91A#            Mixed or anisotropic t.f.        PD91 309
ELSE MAXLEN=85#                        No anisotropic t.f.              PD91 310
ANYSIG=no:#                            Assume no sigmas                 PD91 311
DO J=SIGLIN,PMAXP#                     Loop over sigma data             PD91 312
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PD91 313
IF(DOP(J)==no:) NEXT#                                                   PD91 314
ANYSIG=yes: ; BREAK#                   Must do sigmas                   PD91 315
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PD91 316
writeline:(1,0,0,3,3)#                 Blank line                       PD91 317
LINRM=10#                              Force heading first atom         PD91 318
#                                                                       PD91 319
#  LOOP OVER ALL THE ATOMS IN LRATOM:                                   PD91 320
#  ----------------------------------                                   PD91 321
#                                                                       PD91 322
REPEAT#                                                                 PD91 323
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PD91 324
readwpkt:(INFILE,lratom:,LPAK,IP,0)#   Read atom packets from bdf       PD91 325
IF(IP<=0) BREAK#                       Quit when done                   PD91 326
IF(OUTFIL!=0)#                         Are we loading this run?         PD91 327
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PD91 328
writepkt:(OUTFIL,lratom:,LPAK,JPT)#    Set up output pkt                PD91 329
movereal:(QX,IP+1,QX,JPT+1,LPAK,0)#    Move scratch to file b           PD91 330
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PD91 331
SLAVPT=RELBDF(MX24+PMAXP+1)#           Pointer to slave flag in bdf ^   PD91 332
IF(SLAVPT>0)#                                                           PD91 333
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PD91 334
ifeq:(QX(IP+SLAVPT),-9.) NEXT#         Not output slave atoms           PD91 335
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PD91 336
HETAT=no:#                             Assume regular atom              PD91 337
movechar:(BLANK,1,ATMBUF,1,132,1)#     Clear line buffer                PD91 338
movechar:(BLANK,1,SIGBUF,1,132,1)#     Clear sigma line buffer          PD91 339
K=IP+RELBDF(1)#                        Point to xtal atom id            PD91 340
movertoc:(QX(K),1,ATOMI,2,LNATNM,0)#   Atom name for complete printin   PD91 341
compchar:(PD91B,1,ATMBUF,2,2,1,9,HIT)# Look for heteroatom signal       PD91 342
IF(HIT!=0)#                            Test if hetatom                  PD91 343
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PD91 344
HETAT=yes: ; movechar:(PD91B,2,ATMBUF,16,1,1)# Flag it                  PD91 345
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PD91 346
#                                                                       PD91 347
#  CONVERT THE ATOMIC PARAMETERS FROM XTAL STORAGE BASIS TO PDF BASIS   PD91 348
#  ------------------------------------------------------------------   PD91 349
#                                                                       PD91 350
LX=IP+RELBDF(MX24+1);LY=IP+RELBDF(MX24+2);LZ=IP+RELBDF(MX24+3);K=0# ^   PD91 351
ifvo:(QX(LX)) ATMVOID=yes:#                                             PD91 352
ELSE#                                                                   PD91 353
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PD91 354
DO J=1,12,4#                           Convert fract to orthog          PD91 355
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 PD91 356
K=K+1#                                                                  PD91 357
X(K)=FTORTH(J  )*QX(LX)+FTORTH(J+1)*QX(LY)+$#                           PD91 358
     FTORTH(J+2)*QX(LZ)+FTORTH(J+3)#                                    PD91 359
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 PD91 360
QX(LX)=X(1) ; QX(LY)=X(2) ; QX(LZ)=X(3)# Back to orthogonal x,y,z       PD91 361
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PD91 362
IF(RELBDF(MX24+4)>0 & B1ORU2==1)#      Only convert indiv u back to ^   PD91 363
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 PD91 364
L=IP+RELBDF(MX24+4) ; QX(L)=QX(L)*ATEPSQ# Indiv b if so requested       PD91 365
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 PD91 366
DO J=1,6#                              Make u x 10e4                    PD91 367
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 PD91 368
IF(RELBDF(J+ANOFF)>0&DOP(J+ANOFF)==yes:)# Make sure they're there       PD91 369
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 PD91 370
L=IP+RELBDF(J+ANOFF);QX(L)=QX(L)*10000.0# Pdb scaling                   PD91 371
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 PD91 372
IF(RELBDF(J+SANOFF)>0&DOP(J+SANOFF)==yes:)# Sigmas too                  PD91 373
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 PD91 374
L=IP+RELBDF(J+SANOFF);QX(L)=QX(L)*10000.0# Pdb scaling                  PD91 375
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 PD91 376
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 PD91 377
#                                                                       PD91 378
DO J=1,PMAXP#                          Loop over all parameters         PD91 379
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 PD91 380
## Despite serial number's existence in lratom:, renumber it for pdb    PD91 381
IF (J==17)#                            Atom serial number is a must     PD91 382
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 PD91 383
SERNUM=SERNUM+1#                       Just use sequential numbering    PD91 384
ncodefld:(SERNUM,1,ATMBUF,FMT(J),1)#   Put it out on atom line          PD91 385
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 PD91 386
ELSE IF(DOP(J)==yes:&RELBDF(MX24+J)>0)# Only dealing with whats there   PD91 387
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 PD91 388
K=IP+RELBDF(J+MX24)#                   Point to item in input buffer    PD91 389
IF(FMT(J)>0)#                          Test that its a real item        PD91 390
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 PD91 391
IF(J<SIGLIN) ncodefld:(QX(K),1,ATMBUF,FMT(J),1)# An atom item           PD91 392
ELSE         ncodefld:(QX(K),1,SIGBUF,FMT(J),1)# A sigma item           PD91 393
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 PD91 394
ELSE IF(J==13)#                        Test for residue word            PD91 395
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 PD91 396
movertoc:(QX(K),1,ATMBUF,33,3,0)#      Move low resid seq no.           PD91 397
movertoc:(QX(K),4,ATMBUF,37,1,0)#      Insertion of residues code       PD91 398
movechar:(ATMBUF,33,RESCHK,2,3,0)#     Hold for residue check           PD91 399
movechar:(ATMBUF,37,RESCHK,5,1,0)#     Also insertion code              PD91 400
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 PD91 401
ELSE IF(J==14)#                        Sequence characters?             PD91 402
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 PD91 403
movertoc:(QX(K),1,ATMBUF,21,2,0)#      Remotness and branch             PD91 404
movertoc:(QX(K),4,ATMBUF,24,1,0)#      Alternate location               PD91 405
movertoc:(QX(K),3,ATMBUF,19,1,0)#      Sub-branch desinator on h atom   PD91 406
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 PD91 407
ELSE IF(J==16)#                        Chain id & most sig dig of res   PD91 408
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 PD91 409
ifne:(QX(K),0.0)#                      Ensure non-null values put out   PD91 410
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 PD91 411
movertoc:(QX(K),4,ATMBUF,37,1,0)#      Insertion of residue code        PD91 412
movechar:(ATMBUF,32,RESCHK,1,1,0)#     Save for check                   PD91 413
movertoc:(QX(K),1,ATMBUF,30,1,0)#      Chain identifier                 PD91 414
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 PD91 415
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 PD91 416
ELSE IF(J==18)#                        Is residue name in pkt?          PD91 417
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 PD91 418
movertoc:(QX(K),1,RESCOD,1,4,0)#       Pull out residue name            PD91 419
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 PD91 420
ELSE IF (J==19)#                       Scattering factor type           PD91 421
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 PD91 422
L=NINT(QX(K))#                         Get s.f. pointer                 PD91 423
IF(NCSFN(L)==1) movechar:(SFNAME,(L-1)*6+1,ATMBUF,20,1,0)#              PD91 424
ELSE           movechar:(SFNAME,(L-1)*6+1,ATMBUF,19,2,0)#               PD91 425
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 PD91 426
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 PD91 427
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 PD91 428
#                                                                       PD91 429
#  PICK UP RESIDUE NAME FROM LRSEQU: IN MARKR ARRAY                     PD91 430
#  ------------------------------------------------                     PD91 431
#                                                                       PD91 432
compchar:(RESCHK,1,CURRES,1,5,5,5,HIT)# Watch for change in seq         PD91 433
IF(HIT==0)#                            No match = change                PD91 434
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 PD91 435
J=ONRES*STEPR+MARKR#                                                    PD91 436
ONRES=ONRES+1#                                                          PD91 437
movertoc:(QX(J+1),1,RESCOD,1,4,0)#     Recall residue code              PD91 438
movechar:(RESCHK,1,CURRES,1,5,0)#      Remember the new seq no.         PD91 439
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 PD91 440
movechar:(RESCOD,1,ATMBUF,26,4,0)#     Copy res code to print           PD91 441
#                                                                       PD91 442
#  PRINT LINES PREPARED, PRINT SIGMAS RIGHT UNDER CORRESPONDING PARAMS  PD91 443
#  -------------------------------------------------------------------- PD91 444
#                                                                       PD91 445
IF(PRINT==yes:)#                       Are we printing?                 PD91 446
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 PD91 447
movechar:(ATOMI,1,CHROT,1,NATOMI,0)#   Move long atom name              PD91 448
writeline:(0,PD91A,MAXLEN,1,3)#        Write out name                   PD91 449
movechar:(ATMBUF,1,CHROT,1,MAXLEN,0)#  Move all parameters              PD91 450
writeline:(0,PD91A,MAXLEN,1,3)#        Write parameters below           PD91 451
IF(ANYSIG==yes:&SIGPCH==yes:)#         Are sigmas to be output?         PD91 452
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 PD91 453
movechar:(SIGBUF,1,CHROT,1,MAXLEN,0)#                                   PD91 454
writeline:(0,PD91A,MAXLEN,1,3)#                                         PD91 455
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 PD91 456
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 PD91 457
#                                                                       PD91 458
#  NOW IS THE TIME TO PUNCH OUT THE PROTEIN DATA BANK                   PD91 459
#  --------------------------------------------------                   PD91 460
#                                                                       PD91 461
IF(PUNCH==yes:)#                       Is it?                           PD91 462
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 PD91 463
movechar:(ATMBUF,1,SIGBUF,1,37,0)#     Get the common stuff across      PD91 464
movechar:(BLANK,1,PUNBUF,1,80,1)#      Clear the punch buffer           PD91 465
IF(HETAT==no:) movechar:(PD91C,1,PUNBUF,1,NPD91C,0)# Atom               PD91 466
ELSE           movechar:(PD91D,1,PUNBUF,1,NPD91D,0)# Hetatm             PD91 467
DO L=1,13 ; movechar:(ATMBUF,FROM(L),PUNBUF,TO(L),NUMB(L),0)# Squish    PD91 468
writepch:(PUNBUF,80)#                  Send data for atom or hetatm     PD91 469
IF(ANYSIG==yes:)#                                                       PD91 470
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 PD91 471
movechar:(BLANK,1,PUNBUF,1,80,1)#      Reclear the punch buffer         PD91 472
movechar:(PD91E,1,PUNBUF,1,NPD91E,0)#  Sigatm                           PD91 473
DO L=1,13 ; movechar:(SIGBUF,FROM(L),PUNBUF,TO(L),NUMB(L),0)#           PD91 474
writepch:(PUNBUF,80)#                  Send data for sigatm             PD91 475
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 PD91 476
IF(TFTYPE>1)#                          Any aniso?                       PD91 477
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 PD91 478
movechar:(BLANK,1,PUNBUF,1,80,1)#      Clear it again                   PD91 479
movechar:(PD91F,1,PUNBUF,1,NPD91F,0)#  Anisou                           PD91 480
DO L=1,7 ; movechar:(ATMBUF,FROM(L),PUNBUF,TO(L),NUMB(L),0)#            PD91 481
DO L=14,19 ; movechar:(ATMBUF,FROM(L),PUNBUF,TO(L),NUMB(L),0)#          PD91 482
writepch:(PUNBUF,80)#                  Send data for anisou             PD91 483
IF(ANYSIG==yes:)#                                                       PD91 484
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 PD91 485
movechar:(PD91G,1,PUNBUF,1,NPD91G,0)#  Siguij                           PD91 486
DO L=14,19 ; movechar:(SIGBUF,FROM(L),PUNBUF,TO(L),NUMB(L),0)#          PD91 487
writepch:(PUNBUF,80)#                  Send data for siguij             PD91 488
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 PD91 489
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 PD91 490
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 PD91 491
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PD91 492
#                                                                       PD91 493
IF(LOAD==no:) rewindbdf:(1)#           If only reading set to front     PD91 494
ELSE#                                  Must finish off file             PD91 495
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 PD91 496
copyfile:(8,2,incr:(lratom:),decr:(lrrefl:))# Get everthing off file    PD91 497
readwpkt:(8,endrecord:,LPAK,IP,0)#     Finish off file                  PD91 498
copyfile:(1,2,lrrefl:,endrecord:)#     And get the rest of file a       PD91 499
#                                                                       PD91 500
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 PD91 501
IF(ATMVOID==yes:) writeline:(1,PD91Z,NPD91Z,3,1)# Void coordinates      PD91 502
RETURN#                                                                 PD91 503
END#                                                                    PD91 504
pmacro:([no:])#                        Purge xtal system macros         PD91 505
