systemheader:(PO    )#                                                  PO     1
####################################################################### PO     2
##      Copyright (C) 2000, The Xtal System, The University of        # PO     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # PO     4
## Distributed under the GNU General Public Licence as published by   # PO     5
## the Free Software Foundation, in the hope that it will be useful   # PO     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # PO     7
## for more details.                                                  # PO     8
##                                                                    # PO     9
##                           *** POWGEN ***                           # PO    10
##                                                                    # PO    11
##   Calculate powder pattern based on the measured, if possible.     # PO    12
##   Some minor attributes of the pattern can be adjusted.            # PO    13
##   Optionally fires up a graphics interface to view and manipulate  # PO    14
##   pattern details for plotting etc.                                # PO    15
##   This program should support up to ten phases and  arrangement    # PO    16
##   of up to 16 graphs on one page. Multiple pages can be printed    # PO    17
##   from within the graphical mode.                                  # PO    18
##                                   Doug du Boulay Feb 2000          # PO    19
####################################################################### PO    20
#                                                                       PO    21
include:(XMACRO)## built from RIETVD                                    PO    22
#                                                                       PO    23
ifsel:(VMS)#                           Obscure vms-ism                  PO    24
macro:(vms:,%REF($1))#                 Pass strings by reference        PO    25
ifsel:#                                                                 PO    26
macro:(vms:,$1)#                       Not by descriptor!               PO    27
endsel:#                                                                PO    28
#                                                                       PO    29
macro:(pd:,   ifelse:(mxbtwd:,32,DOUBLE PRECISION,REAL))#               PO    30
macro:(sg:,   ifelse:(pd:,REAL,$1,SNGL($1)))#                           PO    31
macro:(db:,   ifelse:(pd:,REAL,$1,DBLE($1)))#                           PO    32
macro:(float:,ifelse:(pd:,REAL,FLOAT($1),DBLE($1)))#                    PO    33
macro:(nint:, ifelse:(pd:,REAL,NINT($1),IDNINT($1)))#                   PO    34
macro:(dabs:, ifelse:(pd:,REAL,ABS($1),DBLE(ABS($1))))#                 PO    35
#                                                                       PO    36
macro:(maxs:,4000)## Current limit for display sites.                   PO    37
macro:(miv:,9)#                        Maximum index value              PO    38
macro:(maxgn:,16)#                     Max num of simultaneous graphs   PO    39
macro:(maxpha:,10)#                    Maximum no of phases allowed     PO    40
macro:(lrppha:,3)#                                                      PO    41
macro:(lrpwav:,4)#                                                      PO    42
macro:(lrplim:,5)#                                                      PO    43
macro:(lrppat:,6)#                                                      PO    44
macro:(fo:,13)#                        Form factor offset in ioda2:     PO    45
macro:(m72:,incr:(arith:(71,/,mxchwd:)))#                               PO    46
macro:(utob:,78.95684)#                                                 PO    47
macro:(setflg:,IF(I==0)$2=$3;ELSEIF(CHRIN(J^J+1)=="$1")$2=ABS($3-1))#   PO    48
macro:(setint:,IF(I==0)$2=$3;ELSEIF(CHRIN(J^J+1)=="$1")#                PO    49
$(ifnm:(BUFIN(I+1))$($2=NINT(BUFIN(I+1));I=I+1$);ELSE $2=$4$))#         PO    50
macro:(setval:,IF(I==0)$2=$3;ELSEIF(CHRIN(J^J+1)=="$1")#                PO    51
$(ifnm:(BUFIN(I+1))$($2=BUFIN(I+1);I=I+1$);ELSE $2=$4$))#               PO    52
macro:(setkey:,KEY(1)=$1;KEY(2)=$2;KEY(3)=$3;KEY(4)=$4)#                PO    53
macro:(swap:,$(Q1=QX($1);QX($1)=QX($2);QX($2)=Q1$))#                    PO    54
#                                                                       PO    55
macro:(mcell:,MCELL(NPH))#             Start of cell parameters         PO    56
macro:(ncell:,NCELL(NPH))#             Step  of cell parameters         PO    57
macro:(lcell:,LCELL(NPH))#             Last  of cell parameters         PO    58
macro:(msymm:,MSYMM(NPH))#             Start of symmetry data           PO    59
macro:(nsymm:,NSYMM(NPH))#             Step  of symmetry data           PO    60
macro:(lsymm:,LSYMM(NPH))#             Last  of symmetry data           PO    61
macro:(mscat:,MSCAT(NPH))#             Start of atom type data          PO    62
macro:(nscat:,NSCAT(NPH))#             Step  of atom type data          PO    63
macro:(lscat:,LSCAT(NPH))#             Last  of atom type data          PO    64
macro:(mpeak:,MPEAK(NPH))#             Start of peak definition data    PO    65
macro:(npeak:,NPEAK(NPH))#             Step  of peak definition data    PO    66
macro:(lpeak:,LPEAK(NPH))#             Last  of peak definition data    PO    67
macro:(matom:,MATOM(NPH))#             Start of atom data               PO    68
macro:(natom:,NATOM(NPH))#             Step  of atom data               PO    69
macro:(latom:,LATOM(NPH))#             Last  of atom data               PO    70
macro:(mcons:,MCONS(NPH))#             Start of atom constraints        PO    71
macro:(ncons:,NCONS(NPH))#             Step  of atom constraints        PO    72
macro:(lcons:,LCONS(NPH))#             Last  of atom constraints        PO    73
macro:(mflag:,MFLAG(NPH))#             Start of matrix definition       PO    74
macro:(nflag:,NFLAG(NPH))#             Step  of matrix definition       PO    75
macro:(lflag:,LFLAG(NPH))#             Last  of matrix definition       PO    76
macro:(dset:,DATSET(NPH))#             Data set for current phase       PO    77
macro:(temp:,ADISP(NPH))#              Atomic displacement params ove   PO    78
macro:(scal:,SKF(NPH))#                Sf scale for current phase       PO    79
macro:(scalflg:,REFSKF(NPH))#          Refine flag for scale factor     PO    80
macro:(span:,PKSPAN(NPH))#             Peak span for current phase      PO    81
macro:(pkprofnr:,PRFNUM(NPH))#         Peak profile function number     PO    82
#                                                                       PO    83
macro:(cell:,[MCELL(NPH)ifelse:($1,,+1,+$1)])# Define gen list pointe   PO    84
macro:(dcp:,[QX(cell:($1)   )])#       Direct cell parameters           PO    85
macro:(dce:,[QX(cell:($1)+ 9)])#       Direct cell esd's                PO    86
macro:(dmt:,[QX(cell:($1)+18)])#       Direct metric tensor             PO    87
macro:(rcp:,[QX(cell:($1)+27)])#       Recipr cell parameters           PO    88
macro:(rmt:,[QX(cell:($1)+36)])#       Recipr metric tensor             PO    89
macro:(tcf:,[QX(cell:($1)+45)])#       Transform orth to fract          PO    90
macro:(tfc:,[QX(cell:($1)+54)])#       Transform fract to orth          PO    91
macro:(stc:,[QX(cell:($1)+63)])#       Stol calc coeffts                PO    92
macro:(cub:,[QX(cell:($1)+72)])#       Transform u to beta              PO    93
macro:(cbu:,[QX(cell:($1)+81)])#       Transform beta to u              PO    94
#                                                                       PO    95
macro:(atom:,[ifelse:($1,,IA,$1)])#    Define gen list pointer          PO    96
macro:(ml:,[QX(atom:($1)+ 1)])#        Define multiplicity  +1          PO    97
macro:(sf:,[QX(atom:($1)+ 2)])#        Define scat fact num +2          PO    98
macro:(dp:,[QX(atom:($1)+ 3)])#        Define thermal dptype+3          PO    99
macro:(dr:,[QX(atom:($1)+ 5)])#        Define disp f' real  +5          PO   100
macro:(di:,[QX(atom:($1)+ 6)])#        Define disp f" imag  +6          PO   101
macro:(xf:,[QX(atom:($1)+ 7)])#        Define fractional x  +7          PO   102
macro:(yf:,[QX(atom:($1)+ 8)])#        Define fractional y  +8          PO   103
macro:(zf:,[QX(atom:($1)+ 9)])#        Define fractional z  +9          PO   104
macro:(ub:,[QX(atom:($1)+10)])#        Define isotropic  u/b+10         PO   105
macro:(pp:,[QX(atom:($1)+17)])#        Define population pp +17         PO   106
macro:(na:,[QX(atom:($1)+18)])#        Define atom label    +18         PO   107
#                                                                       PO   108
macro:(w8c:,incr:(arith:(7,/,mxchwd:)))#                                PO   109
macro:(w24c:,incr:(arith:(23,/,mxchwd:)))#                              PO   110
#                                                                       PO   111
############################X11 GRAPHICS MACROS######################## PO   112
#                                                                       PO   113
#                                                                       PO   114
macro:(copypage:,)#                                                     PO   115
macro:(mapwindow:, ;)#                                                  PO   116
macro:(tcllinkd:,CALL XLINKD($1,vms:($2)))#                             PO   117
macro:(tcllinki:,CALL XLINKI($1,vms:($2)))#                             PO   118
macro:(tcleval:, CALL XTCLEV(vms:($1)))#                                PO   119
macro:(tclevalrint:,CALL XEVALI($1,vms:($2)))# Return int result        PO   120
macro:(tclevalreal:,CALL XEVALF($1,vms:($2)))# Return real result       PO   121
macro:(tclgetsval:,CALL XGSVAL(vms:($1),vms:($2),$3))#                  PO   122
#                                                                       PO   123
#  TCL/TK VARIABLES                                                     PO   124
macro:(gtitleentry:,"GraphTitle")#                                      PO   125
#                                                                       PO   126
#MACRO:(MAPWINDOW:,$(WI=$1;CALL XMAPWN(WI) $))# REFRESH WINDOW ON SCREE PO   127
#MACRO:(COPYPAGE:,CALL XCOPY($1,$2,$3,$4,$5,$6,$7,$8))# COPY PAGE TO PA PO   128
#                                                                       PO   129
# WATCH OUT FOR THESE OBSCURE VMS STRING PASSING REQUIREMENTS           PO   130
macro:(xmouse:,             CALL XBNDME($1,$2,vms:($3)))#               PO   131
macro:(xcontact:,               CALL XCONT($1,vms:($2)))#               PO   132
macro:(getwid:,        CALL XGETID(WINDOW($1),vms:($2)))#               PO   133
macro:(xstart:,             CALL XSTART($1,$2,vms:($3)))#               PO   134
#macro:(requstrg:,$(WI=WIN;  CALL XGETST(WI,$1,vms:($2))# Get string 
#IF(WI==0)iquit:(PO0001) $))#                                         
macro:(text:, CALL XTEXT($1,$2,0.0,VTC,VTS,$4,vms:($3)))# Obnoxious     PO   137
#                                                                       PO   138
macro:(xinit:,$(BASEWIN=0#             Contact the x server             PO   139
xcontact:(BASEWIN,"powgen.tcl")#       Get screen dimensions            PO   140
IF(BASEWIN>0) iquit:(PO0000)$))#       Unable to spawn windows and in   PO   141
macro:(xfinish:, CALL XFINIS())#       Break current programs connect   PO   142
macro:(attach:,$(DBUF=$1;xstart:(DBUF,WINDOW($2),$3)#                   PO   143
IF(WINDOW($2)==0) iquit:(PO0002)$))#   Bail out if can't open wndo      PO   144
macro:(canvaspectl:,CALL XLASPC(WINDOW($1),ASPECT($1)))#                PO   145
macro:(canvaspects:,CALL XSASPC(WINDOW($1),$2))#                        PO   146
macro:(scrollvarls:,CALL XSCROL(WINDOW($1),$2,$3,$4,$5))# Set/link      PO   147
macro:(erasepage:,  CALL XCLEAR(WINDOW($1),$2))#                        PO   148
macro:(close:,      CALL XCLOSE($1))#                                   PO   149
macro:(awaitview:,  CALL XVIEW( WINDOW($1)))#                           PO   150
#                                                                       PO   151
macro:(probecanvas:,CALL XPROBE(WINDOW($1)))# Debugging only            PO   152
#                                                                       PO   153
macro:(buffswap:,IF(DBUF==yes:)CALL XBFCPY(WINDOW($1)))# Copy back bu   PO   154
macro:(spawn:, )#                                                       PO   155
macro:(requpick:,  $(WI=WINDOW($1);CALL XGETSG(WI,WIGLEV,$2)$))#        PO   156
#IF(WI==0)IQUIT:(PO0001) $))#                                           PO   157
macro:(requlocr:,  $(WI=$1;CALL XGETXY(WI,$2,$3)# Request mouse posn    PO   158
IF(WI==0)iquit:(PO0001) $))#                                            PO   159
macro:(setcanvas:, $(WI=WINDOW($1);CALL XSETPG(WI,$2)$))# Set current   PO   160
macro:(auxrefresh:,$(WI=WINDOW($1);CALL XADARC(WI,$2)$))# Aux refresh   PO   161
macro:(auxresize:, $(WI=WINDOW($1);CALL XADARZ(WI,$2)$))# Aux resize    PO   162
macro:(unmapwin:,  $(WI=WINDOW($1);CALL XUNMAP(WI)$))# Hide window on   PO   163
macro:(auxxscrollcmd:,$(WI=WINDOW($1);CALL XADASC(WI,$2,1)$))# Reg up   PO   164
macro:(auxyscrollcmd:,$(WI=WINDOW($1);CALL XADASC(WI,$2,2)$))# Reg up   PO   165
#                                                                       PO   166
macro:(colormap:,     CALL XGETMC(MINCOL,MAXCOL))# Get numb of open c   PO   167
macro:(setcolor:,     CALL XDEFC($1,$2,$3,$4))# Colour index $1         PO   168
macro:(defcmap:,      CALL XSTDC())#   Load default colormap            PO   169
macro:(xerase:,       CALL XERASE($1,$2))#                              PO   170
macro:(setgcxor:,     CALL XGCXOR(1) )#                                 PO   171
macro:(setgcxcopy:,   CALL XGCXOR(0))#                                  PO   172
macro:(settimer:,     CALL XSETTM(50,1,PG97) )# 50 milliseconds         PO   173
macro:(disabletimer:, CALL XDESTM(1) )#                                 PO   174
macro:(freealltimers:,CALL XFRETM() )#                                  PO   175
macro:(xflush:,       CALL FLUSHX())#                                   PO   176
#                                                                       PO   177
macro:(segcreat:,CALL XSMAKE($1))#     Create a segment                 PO   178
macro:(segclose:,CALL XSCLOS())#       Close a segment                  PO   179
macro:(segdetec:,CALL XSSETD($1,1))#   Set segment detectable           PO   180
macro:(segundet:,CALL XSSETD($1,0))#   Set segment undetectable         PO   181
macro:(segdelet:,CALL XSDEL($1))#      Delete segment                   PO   182
macro:(fillcolr:,CALL XSETFC($1))#     Define fill color                PO   183
macro:(fillstyl:,CALL XSETFS($1))#     Define fill style                PO   184
macro:(filltype:,XFT=$1)#              Define fill area type            PO   185
macro:(fillarea:,$(IF(XFT==1)CALL XFILL($1,$2,$3)#                      PO   186
ELSE        CALL XLINES($1,$2,$3,3)$))# Draw fill area                  PO   187
macro:(linedraw:,CALL XLINES($1,$2,$3,3))# Polyline                     PO   188
macro:(drawgtext:,CALL XTEXT($1,$2,$5,$3,$4,$6,$7))#                    PO   189
macro:(drawwtext:,$(TSZ=$4*RTSC#                                        PO   190
CALL XTEXT($1,$2,$5,$3,TSZ,$6,$7)$))#                                   PO   191
macro:(graphtext:,$(#                                                   PO   192
IF(VUTYPE==2) printext:($1,$2,$3,$4,$5,$6,$7)# Print text               PO   193
ELSE         drawgtext:($1,$2,$3,$4,$5,$6,$7)# Print text               PO   194
$))#                                                                    PO   195
#                                                                       PO   196
macro:(getfval:,CALL XGETFV($1,$2))#                                    PO   197
macro:(setfval:,CALL XSETFV($1,$2))#                                    PO   198
macro:(getival:,CALL XGETIV($1,$2))#                                    PO   199
macro:(setival:,CALL XSETIV($1,$2))#                                    PO   200
#                                                                       PO   201
#                                                                       PO   202
######################Convenience graphics rendering macros ########### PO   203
#                              ID NUMBERS FOR WINDOW/CANVAS ATTRIBUTES  PO   204
macro:(mainwin:,  1)#                  Toplevel main window             PO   205
macro:(legendwin:,2)#                  Toplevel main window             PO   206
macro:(legendc:,  3)#                  Rendering canvas for legend      PO   207
macro:(graphc:,   4)#                  Rendering canvas for graph       PO   208
macro:(abscissac:, 5)#                 Rendering canvas for abscissa    PO   209
macro:(ordinatec:,6)#                  Rendering canvas for ordinate    PO   210
macro:(quitwin:,7)#                    Toplevel quit window             PO   211
macro:(maxwin:, quitwin:)#             Maximum num of windows used      PO   212
#                                                                       PO   213
macro:(bgcol:,15)#                                                      PO   214
macro:(scalefixed:,0)#                                                  PO   215
macro:(tscale:,860.)#                  Text 1pt font - 860pix screen    PO   216
macro:(rws11:,1./(.650*tscale:))#      Relative window scale            PO   217
macro:(rws50:,1./150.)#                New graph text scale             PO   218
#                                                                       PO   219
macro:(segplus:,$(IF(VUTYPE!=2)$(SEGSUM=SEGSUM+1;segcreat:(SEGSUM)$)$))#PO   220
macro:(segend:, $(IF(VUTYPE!=2)segclose:(SEGSUM)$))# Close segment      PO   221
macro:(linecolr:,$(CURLC=$1;IF(VUTYPE!=2)CALL XSETLC($1)$))# Polyline   PO   222
macro:(linesize:,$(CURLS=$1;IF(VUTYPE!=2)CALL XSETLW($1)$))# Polyline   PO   223
#MACRO:(LINESTYL:,$(IF(VUTYPE!=2)CALL XSETLS($1)$))#     DEFINE LINE ST PO   224
macro:(linestyl:, )#                   Define as no-op                  PO   225
#########################Graphics dump macros                           PO   226
macro:(up:,3.)#                                                         PO   227
macro:(dn:,2.)#                                                         PO   228
macro:(printinit:,CALL PO96(0.,0.,0.,0.,0.,0.,1,' '))# Start of ppp f   PO   229
macro:(printnewf:,CALL PO96(0.,0.,0.,0.,0.,0.,2,' '))# Ppp new frame    PO   230
macro:(printscal:,CALL PO96($1,$2,$1/2.,$1/2.,0.,0.,6,' '))# Frame sc   PO   231
#MACRO:(PRINTSCAL:,CALL PO96($1,$2,$1/2.,$1/2.,($1-$3)/2.,$#            PO   232
#($2-$4)/2.,6,' '))# FRAME SCALE                                        PO   233
macro:(printfini:,CALL PO96(0.,0.,0.,0.,0.,0.,10,' '))# Last ppp reco   PO   234
macro:(printline:,CALL PO95($1,$2,$3,CURLC,CURLS))# Print line segmen   PO   235
macro:(printext:,$(#                                                    PO   236
CALL PO96($1,$2,0.,0.,FLOAT($3),up:,3,' ')# Color change for text       PO   237
CALL PO96($1,$2,$4,$5,FLOAT($6),0.,5,$7) $) )# Local plotting for now   PO   238
######################END OF GRAPHICS MACROS########################### PO   239
#                                                                       PO   240
## macros for ARANGE variable                                           PO   241
macro:(literal:,   0)#                                                  PO   242
macro:(horizoptim:,1)#                                                  PO   243
macro:(vertoptim:, 2)#                                                  PO   244
macro:(asspecif:,  3)#                                                  PO   245
#                                                                       PO   246
## macros for SCREEN array                                              PO   247
#                                                                       PO   248
macro:(sxdim:,1)#                      Users screen width in pixels     PO   249
macro:(sydim:,2)#                      Users screen height in pixels    PO   250
macro:(intxdim:,3)#                    Screen interface x dimension     PO   251
macro:(intydim:,4)#                    Screen interface y dimension     PO   252
#                                                                       PO   253
## macros for PIXMAP                                                    PO   254
macro:(pwid:,1)#                       Pixmap width                     PO   255
macro:(phit:,2)#                       Pixmap width                     PO   256
#                                                                       PO   257
## macros for PRPAGE attributes                                         PO   258
#                                                                       PO   259
macro:(a4:,1)#                         Screen x dimension               PO   260
macro:(usletter:,2)#                   Screen y dimension               PO   261
macro:(landscape:,0)#                  Landscape page orientation(act   PO   262
macro:(portrait:,1)#                   Portrait page orientation (nor   PO   263
macro:(inches:,1.000)#                 Inches to inches conversion      PO   264
macro:(cms:,   2.541)#                 Centimetres to inches conversi   PO   265
macro:(point:, 72.00)#                 Point to inches conversion       PO   266
#                                                                       PO   267
macro:(prptype:,   1)#                 Type of page 0=asis/1=a4/2=usl   PO   268
macro:(prporient:, 2)#                 Page orientation 0=asis/1=port   PO   269
macro:(prpscale:,  3)#                 Units to scale page to inches    PO   270
macro:(prxdim:,    4)#                 X dimension                      PO   271
macro:(prydim:,    5)#                 Y dimension                      PO   272
macro:(praspect:,  6)#                 Printed page aspect ratio        PO   273
macro:(prlmargin:, 7)#                 Left   margin                    PO   274
macro:(prrmargin:, 8)#                 Right  margin                    PO   275
macro:(prtmargin:, 9)#                 Top    margin                    PO   276
macro:(prbmargin:,10)#                 Bottom margin                    PO   277
macro:(prdiborder:,11)#                Draw inner border                PO   278
macro:(prdoborder:,12)#                Draw outer border                PO   279
#                                                                       PO   280
#   MACROS FOR SCROLL BAR POINTERS                                      PO   281
#                                                                       PO   282
macro:(sccentre:,1)#                   Fractional centre of scroll ba   PO   283
macro:(scwidth:,2)#                    Relative width of screen (0 -    PO   284
#                                                                       PO   285
#   MACROS FOR ZOOM  POINTERS                                           PO   286
#                                                                       PO   287
macro:(zoomx:,1)#                      Horizontal zoom factor           PO   288
macro:(zoomy:,2)#                      Vertical zoom factor             PO   289
macro:(prpage:,maxgn:+1)#              Preview page zoom factors        PO   290
#                                                                       PO   291
#   MACROS FOR CURVE  POINTERS                                          PO   292
#                                                                       PO   293
macro:(twothet:,1)#                                                     PO   294
macro:(yobs:,   2)#                                                     PO   295
macro:(yobssig:,3)#                                                     PO   296
macro:(ybackgd:,4)#                                                     PO   297
macro:(ycaltot:,5)#                                                     PO   298
macro:(ydelta:, 6)#                                                     PO   299
macro:(ycalph:,7)#                     Ycal for phase 1                 PO   300
macro:(ycalobs:,arith:(6,+,maxpha:))#  Ycal obs calculated phase 1-1
#                                                                       PO   301
#                                                                       PO   302
#                                                                       PO   303
macro:(curve:,    [ifelse:($2,,[PT,$1],[$1,$2])])# Define gen list po   PO   304
macro:(cvdisplay:, [CURVE(curve:($1,$2), 1)])# Display curve line       PO   305
macro:(cvdispln:,  [CURVE(curve:($1,$2), 2)])# Display curve line       PO   306
macro:(cvdispmk:,  [CURVE(curve:($1,$2), 3)])# Display curve marker     PO   307
macro:(cvlncolor:, [CURVE(curve:($1,$2), 4)])# Color of curve           PO   308
macro:(cvmkcolor:, [CURVE(curve:($1,$2), 5)])# Color of marker          PO   309
macro:(cvauxscal:, [CURVE(curve:($1,$2), 6)])# Auxilliary scale facto   PO   310
macro:(cvphascal:, [CURVE(curve:($1,$2), 7)])# Scale factor of phase    PO   311
macro:(cvdivbysig:,[CURVE(curve:($1,$2), 8)])# Divide this curve by s   PO   312
macro:(cvshift:,   [CURVE(curve:($1,$2), 9)])# Displacement of curve    PO   313
macro:(cvshx:,     [CURVE(curve:($1,$2),10)])# X displacement of curv   PO   314
macro:(cvshy:,     [CURVE(curve:($1,$2),11)])# Y displacement of curv   PO   315
macro:(cvxmin:,    [CURVE(curve:($1,$2),12)])# Minimum x of curve       PO   316
macro:(cvymin:,    [CURVE(curve:($1,$2),13)])# Minimum y of curve       PO   317
macro:(cvxmax:,    [CURVE(curve:($1,$2),14)])# Maximum x of curve       PO   318
macro:(cvymax:,    [CURVE(curve:($1,$2),15)])# Maximum y of curve       PO   319
macro:(cvlinewd:,  [CURVE(curve:($1,$2),16)])# Grid has this line wid   PO   320
macro:(cvlinest:,  [CURVE(curve:($1,$2),17)])# Grid has this line sty   PO   321
macro:(cvlinedl:,  [CURVE(curve:($1,$2),18)])# Dash length              PO   322
macro:(cvlinebl:,  [CURVE(curve:($1,$2),19)])# Break length             PO   323
macro:(cvmarkerst:,[CURVE(curve:($1,$2),20)])# Grid has this marker s   PO   324
macro:(cvconlintop:,[CURVE(curve:($1,$2),21)])# Grid has this marker    PO   325
macro:(cvconlinbot:,[CURVE(curve:($1,$2),22)])# Grid has this marker    PO   326
macro:(cvpredatlin:,[CURVE(curve:($1,$2),23)])# Include pre-data line   PO   327
macro:(cvposdatlin:,[CURVE(curve:($1,$2),24)])# Include post-data lin   PO   328
macro:(cvpredatlev:,[CURVE(curve:($1,$2),25)])# Level of pre dat line   PO   329
macro:(cvposdatlev:,[CURVE(curve:($1,$2),26)])# Level of post dat lin   PO   330
macro:(cvexczoninc:,[CURVE(curve:($1,$2),27)])# Do add exclusion zone   PO   331
macro:(cvexczonlin:,[CURVE(curve:($1,$2),28)])# Do draw line ?          PO   332
macro:(cvexcdatlev:,[CURVE(curve:($1,$2),29)])# Y level for excluded    PO   333
macro:(cvnullev:,  [CURVE(curve:($1,$2),30)])# Set null level           PO   334
macro:(cvlabchars:,[CURVE(curve:($1,$2),31)])# Curve label has this m   PO   335
#                                                                       PO   336
#   MACROS FOR AXES (ABSCISSA/ORDINATE) POINTERS                        PO   337
#                                                                       PO   338
macro:(axis:,       [ifelse:($2,,[PT,$1],[$1,$2])])# Define gen list    PO   339
macro:(axdisplay:,  [AXES(axis:($1,$2),1)])# Display axis (yes/no)      PO   340
macro:(axtype:,     [AXES(axis:($1,$2),2)])# Lin/log/sqrt or twotheta   PO   341
macro:(axscale:,    [AXES(axis:($1,$2),3)])# Scale factor for diving    PO   342
macro:(axauto:,     [AXES(axis:($1,$2),4)])# Automatic calibration ye   PO   343
macro:(ax0posn:,    [AXES(axis:($1,$2),5)])# (top &\bottom)             PO   344
macro:(ax1posn:,    [AXES(axis:($1,$2),6)])# (top &\bottom)             PO   345
macro:(axlt0posn:,  [AXES(axis:($1,$2),7)])# Labelld tick mark(bot )    PO   346
macro:(axlt1posn:,  [AXES(axis:($1,$2),8)])# Labelled tick mark (top)   PO   347
macro:(axcolor:,    [AXES(axis:($1,$2),9)])# Color of axis              PO   348
macro:(axlinest:,   [AXES(axis:($1,$2),10)])# Line style of axis        PO   349
macro:(axlinewd:,   [AXES(axis:($1,$2),11)])# Line width of axis        PO   350
macro:(axmin:,      [AXES(axis:($1,$2),12)])# Minimum value             PO   351
macro:(axmax:,      [AXES(axis:($1,$2),13)])# Maximum value             PO   352
macro:(axbtick:,    [AXES(axis:($1,$2),14)])# Number of big ticks       PO   353
macro:(axfbtick:,   [AXES(axis:($1,$2),15)])# First big tick mark       PO   354
macro:(axlbtick:,   [AXES(axis:($1,$2),16)])# Last big tick mark        PO   355
macro:(axbticks:,   [AXES(axis:($1,$2),17)])# Big tick mark spacing     PO   356
macro:(axsbtick:,   [AXES(axis:($1,$2),18)])# Big tick mark size        PO   357
macro:(axbticklw:,  [AXES(axis:($1,$2),19)])# Big tick mark line widt   PO   358
macro:(axfmtick:,   [AXES(axis:($1,$2),20)])# First medium tick mark    PO   359
macro:(axlmtick:,   [AXES(axis:($1,$2),21)])# Last medium tick mark     PO   360
macro:(axmticks:,   [AXES(axis:($1,$2),22)])# Medium tick mark spacin   PO   361
macro:(axsmtick:,   [AXES(axis:($1,$2),23)])# Medium tick mark size     PO   362
macro:(axmticklw:,  [AXES(axis:($1,$2),24)])# Medium tick mark line w   PO   363
macro:(axfstick:,   [AXES(axis:($1,$2),25)])# First small tick mark     PO   364
macro:(axlstick:,   [AXES(axis:($1,$2),26)])# Last small tick mark      PO   365
macro:(axsticks:,   [AXES(axis:($1,$2),27)])# Small tick mark spacing   PO   366
macro:(axsstick:,   [AXES(axis:($1,$2),28)])# Small tick mark size      PO   367
macro:(axsticklw:,  [AXES(axis:($1,$2),29)])# Small tick mark line wi   PO   368
macro:(axfltick:,   [AXES(axis:($1,$2),30)])# First labelled tick mar   PO   369
macro:(axlltick:,   [AXES(axis:($1,$2),31)])# Last labelled tick mark   PO   370
macro:(axlticks:,   [AXES(axis:($1,$2),32)])# Labelled tick mark spac   PO   371
macro:(axlticsize:, [AXES(axis:($1,$2),33)])# Size of labelled tick m   PO   372
macro:(axlticangl:, [AXES(axis:($1,$2),34)])# Angle of labelled tick    PO   373
macro:(axlticcol:,  [AXES(axis:($1,$2),35)])# Labelled tick mark text   PO   374
macro:(axlcentredigit:,[AXES(axis:($1,$2),36)])#                        PO   375
macro:(axlnumdecplac:, [AXES(axis:($1,$2),37)])#                        PO   376
macro:(axldispxcent:,  [AXES(axis:($1,$2),38)])#                        PO   377
macro:(axldispycent:,  [AXES(axis:($1,$2),39)])#                        PO   378
#                                                                       PO   379
macro:(axtlabel:,  [AXES(axis:($1,$2),40)])# Yes/no                     PO   380
macro:(axtcolor:,  [AXES(axis:($1,$2),41)])# Color of axis label text   PO   381
macro:(axtangle:,  [AXES(axis:($1,$2),42)])# Angle of axis label text   PO   382
macro:(axtxorigin:,[AXES(axis:($1,$2),43)])# X origin of axis label t   PO   383
macro:(axtyorigin:,[AXES(axis:($1,$2),44)])# Y origin of axis label t   PO   384
macro:(axtsize:,   [AXES(axis:($1,$2),45)])# Size of axis label text    PO   385
macro:(axtcharnum:,[AXES(axis:($1,$2),46)])# Num of chars in axis tit   PO   386
#                                                                       PO   387
#   MACROS FOR LEGEND  POINTERS                                         PO   388
macro:(legend:,    [ifelse:($1,,PT,$1)])# Define gen list pointer       PO   389
macro:(ledisplay:, [LEGEND(legend:($1), 1)])# Display the legend        PO   390
macro:(letitle:,   [LEGEND(legend:($1), 2)])# Title with legend (yes/   PO   391
macro:(leboxed:,   [LEGEND(legend:($1), 3)])# Display legend in box     PO   392
macro:(leboxlw:,   [LEGEND(legend:($1), 4)])# Display legend box line   PO   393
macro:(leshaded:,  [LEGEND(legend:($1), 5)])# A box with shadinga(yes   PO   394
macro:(lexorigin:, [LEGEND(legend:($1), 6)])# X origin of legend        PO   395
macro:(leyorigin:, [LEGEND(legend:($1), 7)])# Y origin of legend        PO   396
macro:(lewidth:,   [LEGEND(legend:($1), 8)])# Width of legend box       PO   397
macro:(leheight:,  [LEGEND(legend:($1), 9)])# Height of legend box      PO   398
macro:(leelements:,[LEGEND(legend:($1),10)])# Num of elements in lege   PO   399
#                                                                       PO   400
#   MACROS FOR GRID  POINTERS                                           PO   401
macro:(grid:,     [ifelse:($1,,PT,$1)])# Define gen list pointer        PO   402
macro:(grxdisplay:,[GRID(grid:($1),1)])# Display grid                   PO   403
macro:(grydisplay:,[GRID(grid:($1),2)])# Display grid                   PO   404
macro:(grxtied:,   [GRID(grid:($1),3)])# Display grid                   PO   405
macro:(grytied:,   [GRID(grid:($1),4)])# Display grid                   PO   406
macro:(grcolor:,  [GRID(grid:($1),5)])# Color of grid                   PO   407
macro:(grlinewd:, [GRID(grid:($1),6)])# Line width of grid              PO   408
macro:(grlinest:, [GRID(grid:($1),7)])# Line style of grid              PO   409
macro:(grlinedl:, [GRID(grid:($1),8)])# Dash length of grid             PO   410
macro:(grlinebl:, [GRID(grid:($1),9)])# Break length of grid            PO   411
macro:(grvlines:, [GRID(grid:($1),10)])# Num of verticle grid lines     PO   412
macro:(grhlines:, [GRID(grid:($1),11)])# Num of horizontal grid lines   PO   413
#                                                                       PO   414
#   MACROS FOR GTITLE  POINTERS                                         PO   415
macro:(gtitle:,   [ifelse:($1,,PT,$1)])# Define gen list pointer        PO   416
macro:(tidisplay:,[GTITLE(gtitle:($1),1)])# Display title (yes/no)      PO   417
macro:(tixorigin:,[GTITLE(gtitle:($1),2)])# X origin of title           PO   418
macro:(tiyorigin:,[GTITLE(gtitle:($1),3)])# Y origin of title           PO   419
macro:(tiangle:,  [GTITLE(gtitle:($1),4)])# Angle of title to horizon   PO   420
macro:(tisize:,   [GTITLE(gtitle:($1),5)])# Title text size             PO   421
macro:(ticolor:,  [GTITLE(gtitle:($1),6)])# Color of text               PO   422
macro:(tichars:,  [GTITLE(gtitle:($1),7)])# Number of chars in title    PO   423
#MACRO:(TITEXT:,   [GTITLE(GTITLE:($1),20)])# THE 72 TEXT CHARS         PO   424
#                                                                       PO   425
#   MACROS FOR HKLBAR  POINTERS                                         PO   426
#   ---------------------------                                         PO   427
#                                                                       PO   428
macro:(hklbar:,[ifelse:($2,,[PT,$1],[$1,$2])])# Define gen list point   PO   429
macro:(hbdisplay:, [HKLBAR(hklbar:($1,$2), 1)])# Display hklbars(yes/   PO   430
macro:(hbymin:,    [HKLBAR(hklbar:($1,$2), 2)])# Min y val to add       PO   431
macro:(hbsize:,    [HKLBAR(hklbar:($1,$2), 3)])# Min y val to add       PO   432
macro:(hbshift:,   [HKLBAR(hklbar:($1,$2), 4)])# Displace curve (yes/   PO   433
macro:(hbxoffset:, [HKLBAR(hklbar:($1,$2), 5)])# X=0 offset of hkl ba   PO   434
macro:(hbyoffset:, [HKLBAR(hklbar:($1,$2), 6)])# Y offset of hkl bars   PO   435
macro:(hblabel:,   [HKLBAR(hklbar:($1,$2), 7)])# Label hklbars (yes/n   PO   436
macro:(hbfontsize:,[HKLBAR(hklbar:($1,$2), 8)])# Hkl label fontsize     PO   437
macro:(hbangle:,   [HKLBAR(hklbar:($1,$2), 9)])# Angle of labels to h   PO   438
macro:(hblabymin:, [HKLBAR(hklbar:($1,$2),10)])# Min y val to label     PO   439
macro:(hblabshx:,  [HKLBAR(hklbar:($1,$2),11)])# X displa of hkl lab    PO   440
macro:(hblabshy:,  [HKLBAR(hklbar:($1,$2),12)])# Y displa of hkl lab    PO   441
#                                                                       PO   442
#   MACROS FOR GRAPH  POINTERS                                          PO   443
#   --------------------------                                          PO   444
#                                                                       PO   445
macro:(graph:,       [ifelse:($1,,PT,$1)])# Define gen list pointer     PO   446
macro:(gptinvoked:,  [GRAPH(graph:($1), 1)])# This graph has been inv   PO   447
macro:(gptxindex:,   [GRAPH(graph:($1), 2)])# X index of this graph i   PO   448
macro:(gptyindex:,   [GRAPH(graph:($1), 3)])# Y index of this graph i   PO   449
macro:(gptcalxorg:,  [GRAPH(graph:($1), 4)])# Calculated x origin of    PO   450
macro:(gptcalyorg:,  [GRAPH(graph:($1), 5)])# Calculated x origin of    PO   451
macro:(gptcalwidth:, [GRAPH(graph:($1), 6)])# Calculated width of blo   PO   452
macro:(gptcalheight:,[GRAPH(graph:($1), 7)])# Calculated height of bl   PO   453
macro:(gptuspxorg:,  [GRAPH(graph:($1), 8)])# User specified x origin   PO   454
macro:(gptuspyorg:,  [GRAPH(graph:($1), 9)])# User specified x origin   PO   455
macro:(gptuspwidth:, [GRAPH(graph:($1),10)])# User specified width of   PO   456
macro:(gptuspheight:,[GRAPH(graph:($1),11)])# User specified height o   PO   457
macro:(gptbaspect:,  [GRAPH(graph:($1),12)])# Preserved block aspect    PO   458
macro:(gptgxorigin:, [GRAPH(graph:($1),13)])# Relative x origin of gr   PO   459
macro:(gptgyorigin:, [GRAPH(graph:($1),14)])# Relative y origin of gr   PO   460
macro:(gptgwidth:,   [GRAPH(graph:($1),15)])# Relative width of graph   PO   461
macro:(gptgheight:,  [GRAPH(graph:($1),16)])# Relative height of grap   PO   462
macro:(gptgaspect:,  [GRAPH(graph:($1),17)])# Aspect ratio of graph     PO   463
macro:(gptgboxed:,   [GRAPH(graph:($1),18)])# Is graph boxed            PO   464
macro:(gptbodisp:,   [GRAPH(graph:($1),19)])# Display border            PO   465
macro:(gptbocolor:,  [GRAPH(graph:($1),20)])# Color of border           PO   466
macro:(gptbolinewd:, [GRAPH(graph:($1),21)])# Line width of border      PO   467
macro:(gptbolinest:, [GRAPH(graph:($1),22)])# Line style of border      PO   468
macro:(gptbolinedl:, [GRAPH(graph:($1),23)])# Dash length of border     PO   469
macro:(gptbolinebl:, [GRAPH(graph:($1),24)])# Break length of border    PO   470
#                                                                       PO   471
######################END OF DISPLAY STRUCTURE MACROS ################# PO   472
#                                                                       PO   473
extrude:(POCOMN)#                                                       PO   474
INTEGER $#                                                              PO   475
MCELL(maxpha:),#                       Start of cell parameters         PO   476
NCELL(maxpha:),#                       Step  of cell parameters         PO   477
LCELL(maxpha:),#                       Last  of cell parameters         PO   478
MSYMM(maxpha:),#                       Start of symmetry data           PO   479
NSYMM(maxpha:),#                       Step  of symmetry data           PO   480
LSYMM(maxpha:),#                       Last  of symmetry data           PO   481
MSCAT(maxpha:),#                       Start of atom type data          PO   482
NSCAT(maxpha:),#                       Step  of atom type data          PO   483
LSCAT(maxpha:),#                       Last  of atom type data          PO   484
MPEAK(maxpha:),#                       Start of peak definition dat     PO   485
NPEAK(maxpha:),#                       Step  of peak definition dat     PO   486
LPEAK(maxpha:),#                       Last  of peak definition dat     PO   487
MATOM(maxpha:),#                       Start of atom data               PO   488
NATOM(maxpha:),#                       Step  of atom data               PO   489
LATOM(maxpha:),#                       Last  of atom data               PO   490
MCONS(maxpha:),#                       Start of atom constraints        PO   491
NCONS(maxpha:),#                       Step  of atom constraints        PO   492
LCONS(maxpha:),#                       Last  of atom constraints        PO   493
MFLAG(maxpha:),#                       Start of refinement flags        PO   494
NFLAG(maxpha:),#                       Step  of refinement flags        PO   495
LFLAG(maxpha:)#                        Last  of refinement flags        PO   496
#                                                                       PO   497
INTEGER$#                                                               PO   498
APPDSP,#      ## Apply dispersion corr signal                           PO   499
AUTSKF,#      ## Auto scale the pattern                                 PO   500
BDFSCF,#      ## flag for scat fact on bdf (0=no,1=yes)                 PO   501
BDFADJ,#      ## flag to adjust output bdf if params change             PO   502
FIRREF(arith:(maxpha:,+,1)),## First reflection number for nth phase    PO   503
FLGCP,#       ## flag for calculation of pattern only                   PO   504
FLGBAC,#      ## Overall ref flag background (no/yes)                   PO   505
FLGCEL,#      ## Overall ref flag cell (no/yes)                         PO   506
FLGPOF,#      ## Overall ref flag pref orient (no/yes)                  PO   507
FLGPRO,#      ## Overall ref flag peak profile (pasymm,hwidth)(no/ye)   PO   508
FLGPOP,#      ## overall ref flag site population (no/yes)              PO   509
FLGTDP,#      ## overall ref flag thermal displ parameters (no/yes)     PO   510
FLGSKF,#      ## overall ref flag scale factors  (no/yes)               PO   511
FLGUOV,#      ## overall ref flag overall thermal displ par (no/yes)    PO   512
FLGZER,#      ## overall ref flag zero corr  (no/yes)                   PO   513
HIHKL,#       ## highest angle hkl in active pattern list               PO   514
HKLPAK,#      ## Reflection record, lrrefl:, o/p packet size            PO   515
IBAC,#        ## Presence of backgound data (no/yes)                    PO   516
IREFL,#       ## Current pointer of sorted reflection list              PO   517
IREFMX,#      ## Mamimum reflection for mem/iodac1 cutoff               PO   518
IREL(101),#   ## Relative pointers for io packet                        PO   519
IWNT(100),#   ## To specify wanted items in directory packets           PO   520
KEY(4),#      ## Group codes for indexpkt:                              PO   521
LISTMX,#      ## List matrix and vector after last cycle (no/yes)       PO   522
LISTEP,#      ## List step data after last cycle                        PO   523
LISTRF,#      ## List n reflections after last cycle                    PO   524
LOHKL,#       ## Lowest angle hkl in active pattern list                PO   525
LTMTRX,#      ## Rcode=2 ls contribution 0=none,2=yes if Fo>Fc          PO   526
LSMODE,#      ## Least-Squares MODE 0=Rietveld 1=DLS 2=Powgen           PO   527
MARKF,#       ## Start of general pattern parameters                    PO   528
MCONTR,#      ## maximum nr of reflections overlapping on one step      PO   529
VARMAX,#      ## Maximum number of variables (gen + any one phase)      PO   530
MDMATX,LDMATX,## Start/end of derivative matrix area                    PO   531
MDVECT,LDVECT,## Start/end of derivative vector area                    PO   532
MDTEMP,LDTEMP,## Start/end of derivative temporary area                 PO   533
NCY,#         ## Number of current refinement cycle                     PO   534
NCYCLE,#      ## Number of refinement cycles                            PO   535
NEXCLR,#      ## Number of excluded pattern regions                     PO   536
NEWM,#        ## New end of defined memory marker                       PO   537
NEWPAK,#      ## Number of words in new direct access buffer            PO   538
NONPOS,#      ## Dp test if -ve: 0=reset dp;1=message;2=terminat        PO   539
NPEAKF,#      ## Number of peak shape functions                         PO   540
NPH,#         ## Current phase number                                   PO   541
NPHASE,#      ## Total number of phases                                 PO   542
NREFL,#       ## Total number of reflections in all phases              PO   543
NSCF,#        ## Number of scattering factors                           PO   544
NSKIP,#       ## Number of pattern steps skipped in refinement          PO   545
NUCELL,#      ## Flag that cell parameters have changed (no/yes)        PO   546
NUMVAR(maxpha:),## Number of variables per phase                        PO   547
PACK,#        ## Packet size of bdf record                              PO   548
VARPAT,#      ## Number of pattern variables refined (zer & bac)        PO   549
PNTIND,#      ## powder point (PPOINT) index                            PO   550
POLSPG(3),#   ## Packed polar axis flags                                PO   551
PRFNUM(maxpha:),## Peak profile function number (peak,peakf lines)      PO   552
PSHFLN(10),#  ## Number of 5-value entries per peak shape funct         PO   553
PSHFPT(10),#  ## Pointer to start of each peak shape function           PO   554
PUNCH,#       ## Flag to write updated parameters to file PCH           PO   555
QXPHPT(maxpha:),## First qx location for phase                          PO   556
RADTYP,#      ## Radiation: 1=neutron,2=electron,3=xray                 PO   557
REFBAC(5),#   ## refinement flag background params                      PO   558
ISCOBS,#      ## reflection intensity observed
REFCEL(maxpha:,6),## Refinement flags for cell parameters               PO   559
REFPOF(maxpha:),# ## Refinement flag pref orient parameter              PO   560
REFPRO(maxpha:,6),## Refinement flags - profile hwidth, asymm, mix      PO   561
REFSKF(maxpha:),# ## Refine flag phase scale factors                    PO   562
REFUOV(maxpha:),# ## Refinement flag overall thermal disp parameter     PO   563
SFCALC(maxpha:),# ## Flag that phase needs SF recalculating             PO   564
REFZER(2),#   ## Refinement flag zero corrections                       PO   565
RSCODE,#      ## Restraint restrictions (0=soft;1=bound;2=both)         PO   566
TERMNT,#      ## Stop refinement: 0=no;1=when decrease in R<.01         PO   567
VARTOT,#      ## Total number of variables refined                      PO   568
WAVSEL,#      ## User selected wavelength                               PO   569
WTSCHM#       ## Step weight option (0/1/2 = unit/file/variance-1)      PO   570
#                                                                       PO   571
REAL$#                                                                  PO   572
BUF(100),#    ## Reflection record buffer / cell esd calc scratch       PO   573
CC,#          ## Start of first constraint list                         PO   574
CNTBAC,#      ## Observed step background intensity                     PO   575
CNTOBS,#      ## Observed step intensity                                PO   576
CNTWHT,#      ## Observed step intensity weight (sqrt(WT))              PO   577
CNTSIG,#      ## Observed step reciprocal esd                           PO   578
CALOBS,#      ## Calculated observed intensity for phase - from irel
DAMPPR,#      ## Profile shift damping factor                           PO   579
DAMPST,#      ## Structure shift damping factor                         PO   580
DATSET(maxpha:),#  ## Data set per phase                                PO   581
DELTA,#       ## Powder pattern step Iobs-Icalc                         PO   582
DSCF,#        ## Sine theta over lambda interval for s.f.               PO   583
EXCLRL(10),#  ## Excluded 2theta regions of pattern low                 PO   584
EXCLRH(10),#  ## Excluded 2theta regions of pattern high                PO   585
EXTV,#        ## Extinction var (r* in zachariasen's formula)           PO   586
GOF,#         ## goodness of fit = w*(yo-yc)**2/(nobs-varmax)           PO   587
HWDMAX,#      ## maximum halfwidth foe all reflections                  PO   588
LAMBDA,#      ## Radiation wavelength                                   PO   589
LAMDA1,LAMDA2,## Wavelengths alpha1,2                                   PO   590
LAMRAT,#      ## Intensity ratio alpha2/alpha1                          PO   591
LISTCM,#      ## List correlation matrix elements > q                   PO   592
LISTPR,#      ## List poor reflns with wY > q                           PO   593
PARBAC(5),#   ## background params                                      PO   594
PARPOF(maxpha:),## prefer orient parameter                              PO   595
PARPRO(maxpha:,6),## peak profile (hwidth, asymmetry, mix)              PO   596
PARZER(2),#   ## zero correction params                                 PO   597
PEAKSP,#      ## Peak span override value                               PO   598
PKSPAN(10),#  ## Span of peak in half widths                            PO   599
POLRA,#       ## Polarization ratio for LP factor                       PO   600
PSHFST(10),#  ## Peak shape function reciprocal step size               PO   601
RSTORE(100),# ## Summary of refinement index values (10 cycles)         PO   602
RSUMS(80),#   ## R factor sums                                          PO   603
SOEMAX,#      ## shift/error maximum per cycle                          PO   604
SKF(maxpha:),## phase scale factors                                     PO   605
ADISP(maxpha:),## phase temp scaling factor                             PO   606
TT,#          ## Current pattern two theta value                        PO   607
TTMINL,#      ## Min 2 theta input limits                               PO   608
TTMAXL,#      ## Max 2 theta input limits                               PO   609
TTMINP,#      ## Min 2 theta of pattern                                 PO   610
TTMAXP,#      ## Max 2 theta of pattern                                 PO   611
TTMINR,#      ## Min 2 theta of reflections                             PO   612
TTMAXR,#      ## Max 2 theta of reflections                             PO   613
TTSTEP,#      ## Pattern step size in 2theta                            PO   614
UOV(maxpha:),## Overall thermal displacement factors                    PO   615
UOVSH,#       ## uov shift                                              PO   616
UOVSD,#       ## uov std dev                                            PO   617
VOL,#         ## Volume of unit cell in direct space                    PO   618
POFVEC(maxpha:,3),## preferred orientation vector (u,v,w)               PO   619
WAVLEN(maxpha:,8),## Stored wavelength(s)                               PO   620
WEIGHT,#       ## Step weight                                           PO   621
YMIN,#         ## users requested global minimum Intensity              PO   622
YMAX#         ## users requested global maximum Intensity               PO   623
#                                                                       PO   624
INTEGER$#     ## Integer graphics common                                PO   625
APPDONE,#     ## Application is finished (yes/no)                       PO   626
BASEWIN,#     ## Base level window Id                                   PO   627
DBUF,#        ## double buffering on canvas (yes/no)                    PO   628
SCREEN(10),#  ## Screen properties                                      PO   629
GRINT,#       ## Graphical interface yes/no flag                        PO   630
GRINDX(arith:(miv:,+,1),arith:(miv:,+,1)),#  ## Index to graph block    PO   631
LEGINV,#      ##                                                        PO   632
MINCOL,#      ## Smallest available color element                       PO   633
MAXCOL,#      ## Maximum color index available                          PO   634
XFT,#         ## X11 fill type 1\0                                      PO   635
FRAMCT,#      ## Count of dumped printplot frames                       PO   636
ARANGE,#      ## How to arrange the graphic blocks                      PO   637
CURPLT,#      ## Currently open graph block                             PO   638
VUTYPE,#      ## Current viewing type (0-only one/1-all/2-print)        PO   639
SEGSUM,#      ## Sum the segments in graph subwindow                    PO   640
WIGLEV,#      ## Widget level from toplevel hierarchy                   PO   641
CURLC#        ## Curent line color                                      PO   642
#                                                                       PO   643
REAL $#        ## Floating point graphics common                        PO   644
#PIXMAP(4,2),# ## Pixmap dimensions                                     PO   645
CURLS,#       ## Current line width setting                             PO   646
COLMAP(2),#    ## two Graphical interface colormap specs                PO   647
RELHIT,#      ## Relative hight                                         PO   648
RELWID,#      ## Relative width                                         PO   649
RELXOR,#      ## Relative x origin                                      PO   650
RELYOR,#      ## Relative y origin                                      PO   651
RELSCF,#      ## Relative scale factor                                  PO   652
RTSC,#        ## Relative text scale                                    PO   653
ZOOM(   arith:(maxgn:,+,1),2),## Horizontal scroll bar states - all g   PO   654
HSCROLL(arith:(maxgn:,+,1),2),## Horizontal scroll bar state            PO   655
VSCROLL(arith:(maxgn:,+,1),2),## Vertical scroll bar state              PO   656
GRAPH(  maxgn:,30),## Title info for each graph                         PO   657
ASPECT(maxwin:),##                                                      PO   658
AXES(   maxgn:,2,50),## Ordinate and abscissa information for each gr   PO   659
GRID(   maxgn:,20),## Grid info for each graph                          PO   660
CURVE(  maxgn:,arith:(maxpha:,+,6),40),## Information about every cur   PO   661
PPOINT( arith:(arith:(2,*,maxpha:),+,6),maxs:)## points to be plotted
##PPOINT( arith:(maxpha:,+,6),maxs:)## Intensities of phases to be plot   PO   662
#                                                                       PO   663
DOUBLE PRECISION $#  ## Double precision graphics common                PO   664
PRPAGE(20),#        ## Constraints on the output page                   PO   665
LOCATE( maxgn:,4),# ## Position of graph on relative page               PO   666
LEGEND( maxgn:,20),## Legend info for each graph                        PO   667
GTITLE( maxgn:,20),## Title info for each graph                         PO   668
HKLBAR( maxgn:,maxpha:,40)## Information about HKLbars                  PO   669
#                                                                       PO   670
CHARACTER TITLET(maxgn:)*72## Graph title label                         PO   671
CHARACTER ABSLAB(maxgn:)*72## Graph abscissa label                      PO   672
CHARACTER ORDLAB(maxgn:)*72## Graph ordinate  label                     PO   673
CHARACTER CRVLAB(arith:(maxpha:,+,6))*72## Legend labels for curves     PO   674
#                                                                       PO   675
CHARACTER PHASE(maxpha:)*6#            Phase id string                  PO   676
CHARACTER PFILES(5)*3#                 Powder filename extensions       PO   677
CHARACTER SAVEID*6#                    Original compound id string      PO   678
#                                                                       PO   679
pointer:$#                                                              PO   680
WINDOW(maxwin:),#  ## Id nums for main windows                          PO   681
WI,#          ## temp variable 1                                        PO   682
WJ,#          ## temp variable 2                                        PO   683
WIN#                                                                    PO   684
#                                                                       PO   685
COMMON/COMIPO/MCELL,NCELL,LCELL,MSYMM,NSYMM,LSYMM,#                     PO   686
MSCAT,NSCAT,LSCAT,MPEAK,NPEAK,LPEAK,MATOM,NATOM,LATOM,#                 PO   687
MCONS,NCONS,LCONS,MFLAG,NFLAG,LFLAG,APPDSP,BDFSCF,FLGCP,#               PO   688
FLGBAC,FLGCEL,FLGPOF,FLGPRO,FLGPOP,FLGTDP,FLGSKF,FLGUOV,FLGZER,#        PO   689
HIHKL,HKLPAK,IBAC,IREFL,IREL,IWNT,KEY,LISTMX,LISTEP,LISTRF,LOHKL,#      PO   690
IREFMX,LTMTRX,LSMODE,FIRREF,QXPHPT,PNTIND,BDFADJ,#                      PO   691
MARKF,MCONTR,VARMAX,MDMATX,LDMATX,MDVECT,LDVECT,MDTEMP,LDTEMP,#         PO   692
NCY,NCYCLE,NEXCLR,NEWM,NEWPAK,NONPOS,NPEAKF,NPH,NPHASE,NREFL,#          PO   693
NSCF,NSKIP,NUCELL,NUMVAR,PACK,VARPAT,POLSPG,PRFNUM,PSHFLN,PSHFPT,#      PO   694
PUNCH,RADTYP,REFBAC,REFCEL,REFPOF,REFPRO,REFSKF,REFUOV,REFZER,#         PO   695
RSCODE,TERMNT,VARTOT,WAVSEL,WTSCHM,XFT,SFCALC,AUTSKF,ISCOBS
#                                                                       PO   697
COMMON/COMFPO/BUF,CC,CNTBAC,CNTOBS,CNTWHT,CNTSIG,#                      PO   698
DAMPPR,DAMPST,DATSET,DELTA,DSCF,EXCLRL,EXCLRH,GOF,EXTV,HWDMAX,#         PO   699
LAMBDA,LAMDA1,LAMDA2,LAMRAT,LISTCM,LISTPR,ADISP,#                       PO   700
PARBAC,PARPOF,PARPRO,PARZER,PEAKSP,PKSPAN,POLRA,PSHFST,RSUMS,#          PO   701
RSTORE,SKF,SOEMAX,TT,TTMINL,TTMAXL,TTMINP,TTMAXP,TTMINR,TTMAXR,#        PO   702
TTSTEP,UOV,UOVSH,UOVSD,POFVEC,VOL,WEIGHT,WAVLEN,YMIN,YMAX,CALOBS#  
#                                                                       PO   704
COMMON/COMCPO/PHASE,SAVEID,PFILES#                                      PO   705
#                                                                       PO   706
COMMON/COMPPO/WINDOW,WI,WJ,WIN#                                         PO   707
#                                                                       PO   708
COMMON/IGRAPH/APPDONE,BASEWIN,MAXCOL,CURLC,MINCOL,DBUF,WIGLEV,#         PO   709
SCREEN,GRINDX,CURPLT,VUTYPE,ARANGE,FRAMCT,SEGSUM,GRINT,LEGINV#          PO   710
#                                                                       PO   711
COMMON/FGRAPH/CURLS,PPOINT,COLMAP,ASPECT,GRAPH,GRID,AXES,CURVE,#        PO   712
RELHIT,RELWID,RELXOR,RELYOR,RELSCF,RTSC,ZOOM,HSCROLL,VSCROLL#           PO   713
#                                                                       PO   714
COMMON/DGRAPH/PRPAGE,LOCATE,#                                           PO   715
LEGEND,GTITLE,HKLBAR#                                                   PO   716
#                                                                       PO   717
COMMON/CGRAPH/TITLET,ABSLAB,ORDLAB,CRVLAB#                              PO   718
#                                                                       PO   719
endext:#                                                                PO   720
#                                                                       PO   721
systemheader:(PO00)#                   Calculate and disp powd patt     PO00   1
####################################################################    PO00   2
#                                                                  #    PO00   3
#                                PO00                              #    PO00   4
#                                                                  #    PO00   5
####################################################################    PO00   6
SUBROUTINE PO00#                                                        PO00   7
include:(AACOMN)#                                                       PO00   8
include:(POCOMN)#                                                       PO00   9
#                                                                       PO00  10
REAL SCALE#                                                             PO00  11
INTEGER SEGNUM#                                                         PO00  12
chardata:(PO1, PHASE PEAK HWIDTH PASYMM ORIENT $#                       PO00  13
SELECT CONSTR NOREF RESTR )#                                            PO00  14
chardata:(PO2, BLOCK BLKBRD GRAPH EXCLR HKLBAR AXIS $#                  PO00  15
AXLAB TICKMK GRID GTITLE TITEXT LEGEND TRACE TRCTXT )#                  PO00  16
chardata:(PO3, END )#                                                   PO00  17
datastuff:#                                                             PO00  18
#                                                                       PO00  19
CALL PO01#                             Process exampp line options      PO00  20
CALL PO02#                             Initialise all graphical varia   PO00  21
CALL PO05#                             Enter general pattern options    PO00  22
#                                                                       PO00  23
#   READ CONTROL LINES                                                  PO00  24
#   ------------------                                                  PO00  25
#                                                                       PO00  26
NPH=-1#                                                                 PO00  27
REPEAT#                                Read controls and act on them    PO00  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO00  29
readline:(PO1,-NPO1)#                  Check for phase control line     PO00  30
IF(LINID>0\NPH==0)#                    Phase specific control           PO00  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO00  32
FOR(NPH=1;LINID<10;NPH=NPH+1)#         Loop over crystal phases         PO00  33
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO00  34
CALL PO10#                             Read cell/symm/expl/dset bdf     PO00  35
CALL PO11#                             Read atom/cons bdf and lines     PO00  36
CALL PO14#                             Print parameter summary          PO00  37
CALL PO15#                             Copy lrrefl: to ioda1:           PO00  38
CALL PO16#                             Sort hkl on 2th dac: to aux:     PO00  39
IF(LINID<=0)BREAK#                                                      PO00  40
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO00  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO00  42
ELSE#                                  Not a phase control line         PO00  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO00  44
readline:(PO2,-NPO2)#                  Check for graph control line     PO00  45
IF(LINID>0)CALL PO07#                  Output graph specific controls   PO00  46
ELSE#                                  Not an exampp control line       PO00  47
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO00  48
readline:(PO1,-NPO3)#                  Check for  end line              PO00  49
IF(NPH!=-1) BREAK#                     Done reading controls            PO00  50
NPH=NPH+1#                             Haven't read default phase inf   PO00  51
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO00  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO00  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO00  54
#                                                                       PO00  55
#   READ IN THE POWDER FILE                                             PO00  56
#   -----------------------                                             PO00  57
#                                                                       PO00  58
CALL PO20#                             Read powder pattern file if ex   PO00  59
CALL PO21#                             Data displayability checks 
#                                                                       PO00  60
#   IF NOT USING THE .POT FILE THEN CALCULATE A PATTERN                 PO00  61
#   ---------------------------------------------------                 PO00  62
#                                                                       PO00  63
IF(PFILES(1)!='POT')#                  No rietvd .pot file              PO00  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO00  65
DO NPH=1,NPHASE#                       For each separate phase          PO00  66
CALL PO22#                             Calculate separate patterns      PO00  67
CALL PO30#                             Pre sum IOBS sing crys data
IF(AUTSKF!=0)#                                                          PO00  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO00  69
CALL PO29(SCALE)#                      Rescale calculated patterns      PO00  70
CALL PO31(0,SCALE)#                    Apply newscale to all primary    PO00  71
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO00  72
CALL PO30#                             Sum total calculated pattern     PO00  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO00  74
ELSE CALL PO32#                        Load pot or pat file into memo   PO00  75
LISTRF=0#                              No need to print refs any more   PO00  76
#                                                                       PO00  77
#    PREPROCESS GRAPHING INFORMATION                                    PO00  78
#    -------------------------------                                    PO00  79
#                                                                       PO00  80
CALL PO27#                             Autocalibrate graph Y max
CALL PO33(0)#                          Validate all graph axes          PO00  81
CALL PO34#                             Validate all graph block locat   PO00  82
#                                                                       PO00  83
#    IS A DIRECT PLOT IS EXPECTED                                       PO00  84
#    ----------------------------                                       PO00  85
#                                                                       PO00  86
IF(GRINT==no:)CALL PO36(2)#            No graphic int so print dump     PO00  87
#                                                                       PO00  88
ELSE#                                  Graphical interface is require   PO00  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PO00  90
xinit:#                                Initialise x server              PO00  91
CURPLT=1#                              Current graph block              PO00  92
CALL PO50#                             Initialise graphics device       PO00  93
CALL PO35#                             Plot first graph                 PO00  94
APPDONE=no:#                           Have not finished yet            PO00  95
WHILE(APPDONE==no:)#                   Loop until exit requested        PO00  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PO00  97
requpick:(graphc:,SEGNUM)#             Detect user input                PO00  98
IF(SEGNUM<0) APPDONE=yes:#                                              PO00  99
#                                                                       PO00 100
#  FOR THE MAIN GRAPH WINDOW                                            PO00 101
#  -------------------------                                            PO00 102
#                                                                       PO00 103
ELSEIF(WI==WINDOW(mainwin:))#          An event in the main window      PO00 104
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PO00 105
IF    (WIGLEV==0)#                     Main window widgets              PO00 106
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PO00 107
IF(SEGNUM>0&SEGNUM<6)  CALL PO71(SEGNUM)# Next graph buttons            PO00 108
IF(SEGNUM==6)          CALL PO68#      Title string updates             PO00 109
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PO00 110
ELSEIF(WIGLEV==1)#                     File menu widgets                PO00 111
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PO00 112
IF    (SEGNUM==2&VUTYPE==0)CALL PO36(1)# Preview output page            PO00 113
ELSEIF(SEGNUM==2&VUTYPE!=0)CALL PO35#  Switch back to single plot       PO00 114
ELSEIF(SEGNUM==3)      CALL PO36(2)#   Dump output page to plot file    PO00 115
ELSEIF(SEGNUM==4)      CALL PO69#      Page setup                       PO00 116
ELSEIF(SEGNUM==5)      CALL PO70#      Rearrange graphs                 PO00 117
ELSEIF(SEGNUM==6)      ;## Punch .PCH files for RT input                PO00 118
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PO00 119
ELSEIF(WIGLEV==2)#                     Edit menu widgets                PO00 120
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PO00 121
IF    (SEGNUM==1)      ;#              Display edit grid window         PO00 122
ELSEIF(SEGNUM==2)      ;#              Display edit axes window         PO00 123
ELSEIF(SEGNUM==3)      CALL PO55#      Edited hkl marker attribs        PO00 124
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PO00 125
ELSEIF(WIGLEV==3)#                     Plot menu widgets                PO00 126
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PO00 127
IF    (SEGNUM==1)      ;#              Change lin/log/sqrt plot style   PO00 128
ELSEIF(SEGNUM==2)      CALL PO58#      Change the plot range            PO00 129
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PO00 130
ELSEIF(WIGLEV==4)#                     Recalculate menu widgets         PO00 131
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PO00 132
IF    (SEGNUM==1)      CALL PO59#      Change background params + rec   PO00 133
ELSEIF(SEGNUM==2)      CALL PO60#      Change the peak shape profile    PO00 134
ELSEIF(SEGNUM==3)      CALL PO61#      Update tk shape for phase        PO00 135
ELSEIF(SEGNUM==4)      CALL PO62#      Rescale phase(s)                 PO00 136
ELSEIF(SEGNUM==5)      CALL PO63#      Update tk scale for phase        PO00 137
ELSEIF(SEGNUM==6)      CALL PO64#      Apply temp factor to phase(s)    PO00 138
ELSEIF(SEGNUM==7)      CALL PO65#      Update tk temp factor for phas   PO00 139
ELSEIF(SEGNUM==8)      CALL PO66#      Two theta offsets                PO00 140
ELSEIF(SEGNUM==9)      ;#              Update preferred orientation     PO00 141
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PO00 142
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PO00 143
#                                                                       PO00 144
#  FOR THE SECONDARY LEGEND WINDOW (MOSTLY ALWAYS ACTIVE)               PO00 145
#  ------------------------------------------------------               PO00 146
#                                                                       PO00 147
ELSEIF(WI==WINDOW(legendwin:))#        Legend window                    PO00 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PO00 149
IF(WIGLEV==0)#                         The main legend window widgets   PO00 150
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PO00 151
IF    (SEGNUM==1)      CALL PO56#      Update the legend variables      PO00 152
ELSEIF(SEGNUM==3)      CALL PO57#      Update fortran from legend var   PO00 153
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PO00 154
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PO00 155
#                                                                       PO00 156
#                                                                       PO00 157
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PO00 158
xfinish:#                              Terminate all windows and inte   PO00 159
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PO00 160
closedac:(ioda2:)#                     Close sorted refl file           PO00 161
closedac:(ioda1:)#                     Close aux refln list             PO00 162
IF(PFILES(1)!=' ')
readwpkt:(3,endrecord:,PACK,IP,0)#     finish powder file
#                                                                       PO00 163
#    CLOSE OF THE OUTPUT .PPP FILE IF REQUIRED                          PO00 164
#    -----------------------------------------                          PO00 165
#                                                                       PO00 166
IF(FRAMCT>0)#                                                           PO00 167
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PO00 168
printfini:#                            Write last record in ppp file    PO00 169
IF(GRINT==yes:)#                       Reentrantly stream prevue?       PO00 170
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PO00 171
FILEXT(iofm1:)='PO0'#                  Re-entrant plotx fmt file        PO00 172
openfmt:(iofm1:,' ')#                  Open the file                    PO00 173
writefmt:(iofm1:,'(A)','PREVUE ppp')#                                   PO00 174
LINFLG=1#                              Ensure another line is read      PO00 175
IF((CHRIN(1^4)!='END ')&(CHREOF!=1))#  Next inpt line isn't end or eo   PO00 176
writefmt:(iofm1:,'(A)',CHRIP(1^80))#   Write header to file             PO00 177
closefmt:(iofm1:)#                                                      PO00 178
linestream:('PO0')#                                                     PO00 179
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PO00 180
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PO00 181
#### writepkt:(4,endrecord:,1,IP)# Close output pattern file ???        PO00 182
#                                                                       PO00 183
RETURN#                                                                 PO00 184
END#                                                                    PO00 185
systemheader:(PO01)#                   Process the exampp line          PO01   1
# ####################################################################  PO01   2
#                                                                       PO01   3
#                               PO01                                    PO01   4
#                                                                       PO01   5
# ####################################################################  PO01   6
SUBROUTINE PO01#                                                        PO01   7
#                                                                       PO01   8
macro:(auxfiles:,5)#                   Num auxilliary powder files+1    PO01   9
include:(AACOMN)#                                                       PO01  10
include:(POCOMN)#                                                       PO01  11
#                                                                       PO01  12
INTEGER    I,J,K,FILE,FCNT#                                             PO01  13
#                                                                       PO01  14
chardata:(PO0,' noyes')#                                                PO01  15
chardata:(PO1,' POWGEN Control Parameters-')#                           PO01  16
chardata:(PO2,' Apply dispersion parameters              ')#            PO01  17
chardata:(PO3,' Proceeding using .PAT file               ')#            PO01  18
chardata:(PO4,' Warning --- No powder file encountered   ')#            PO01  19
chardata:(PO5,' Auxilliary powder phase in file .xxx     ')#            PO01  20
chardata:(POM,' Overall peak span in halfwidths          ')#            PO01  21
chardata:(POQ,' Step weight option                       ')#            PO01  22
chardata:(POR,' unit filesigma')#                                       PO01  23
chardata:(POS,' Step skip value                          ')#            PO01  24
chardata:(POT,' Calc pattern only, no refinement         ')#            PO01  25
datastuff:#                                                             PO01  26
#                                                                       PO01  27
#       SET UP AND REQUEST FILE BUFFERS                                 PO01  28
#       -------------------------------                                 PO01  29
#                                                                       PO01  30
FILEXT(IOUNIT(3))='POT'#               Default - assume rt ouput        PO01  31
FILEXT(IOUNIT(4))='PPP'#               Powder pattern plot file         PO01  32
FILEXT(ioda1:)='XX5'#                  Scratch unsorted refln data      PO01  33
FILEXT(ioda2:)='XX6'#                  Scratch sorted refln data        PO01  34
#                                                                       PO01  35
IOMARK(1)=QXSTR#                       Buffer inpu1 archive bdf(s)      PO01  36
IOMARK(2)=IOMARK(1)+bdfbuf:#           Buffer output archive bdf(s)     PO01  37
IOMARK(3)=IOMARK(2)+bdfbuf:#           Buffer input powder pattern      PO01  38
IOMARK(4)=IOMARK(3)+bdfbuf:#           Buffer output powder pattern     PO01  39
incrqx:(MARKF,IOMARK(4)+bdfbuf:,PO015)# Start tth distrib array         PO01  40
COLMAP(1)=0.5; COLMAP(2)=1.0#          Brightness and saturation        PO01  41
DO FCNT=2,auxfiles:;PFILES(FCNT)=' '#  Initialise powder file array     PO01  42
FCNT=1;             PFILES(FCNT)='POT'# Assume rt .pot file as defaul   PO01  43
#                                                                       PO01  44
#     EXTRACT DATA FROM RIETVD LINE AND SET DEFAULT VALUES              PO01  45
#     ----------------------------------------------------              PO01  46
#                                                                       PO01  47
FLGCP=1#
FOR(I=0;I>=0;I=I+1)#                   Loop over input fields           PO01  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO01  49
stringlim:(I,J,K)#                     Get string limits                PO01  50
#                                                                       PO01  51
setflg:(NG,GRINT,yes:)#                No use of graphical interface    PO01  52
setflg:(ND,APPDSP,yes:)#               No application dispersion        PO01  53
setval:(PS,PEAKSP,  3.,  12.)#         Set peak span override value     PO01  54
setflg:(PC,PUNCH,no:)#                 Punch new pars after last cycl   PO01  55
setflg:(BD,BDFADJ,no:)#                Adjust output bdfs for phases    PO01  56
setint:(SK,NSKIP ,1,2)#                Pattern skip factor              PO01  57
setint:(PR,LISTRF,0,999999)#           List all reflections             PO01  58
setint:(LI,ARANGE,0,0)#                Use graphical interface          PO01  59
setint:(HO,ARANGE,0,1)#                Use graphical interface          PO01  60
setint:(VO,ARANGE,0,2)#                Use graphical interface          PO01  61
setint:(AS,ARANGE,0,3)#                Use graphical interface          PO01  62
IF (I==0);#                            do nothing
ELSEIF(CHRIN(J^J+1)=='CM')#            Graphical interface colormap p   PO01  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO01  64
ifnm:(BUFIN(I+1))COLMAP(1)=BUFIN(I+1)# The hue parameter                PO01  65
ifnm:(BUFIN(I+2))COLMAP(2)=BUFIN(I+2)# The brightness parameter         PO01  66
I=I+2#                                                                  PO01  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO01  68
ELSEIF(CHRIN(J^J+1)=='PA')PFILES(1)='PAT'# Specified a .pat file        PO01  69
ELSEIF(CHRIN(J^J+2)=='PO')PFILES(1)='POT'# Specified the .pot file      PO01  70
ELSEIF(CHRIN(J^J+1)=='AP')#            Test for auxilliary powder fil   PO01  71
ifch:(BUFIN(I+1))#                     Test for filename extension st   PO01  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO01  73
IF(FCNT >auxfiles:-1)iquit:(PO0115,I)# More than four aux powder file   PO01  74
stringlim:(I+1,J,K)#                   Get string limits                PO01  75
FCNT=FCNT+1;PFILES(FCNT)=CHRIN(J^J+3)# Get first three characters       PO01  76
I=I+1#                                                                  PO01  77
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO01  78
#                                                                       PO01  79
ifvo:(BUFIN(I+1)) BREAK#               Exit when field void             PO01  80
ifnm:(BUFIN(I+1)) iquit:(PO0110,I+1)#  Must be char string              PO01  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO01  82
#                                                                       PO01  83
#        PRINT CONTROL PARAMETERS                                       PO01  84
#        ------------------------                                       PO01  85
#                                                                       PO01  86
LINRM=12#                              Ensure print space 12 lines      PO01  87
movechar:(PO1,NPO1,CHROT,2,NPO1-2,1)#  Insert header underline          PO01  88
writeline:(1,PO1,NPO1-1,2,3)#          Print header                     PO01  89
movechar:(PO0,FLGCP*3+1,POT,38,3,0)#   Insert calc pattern only         PO01  90
writeline:(0,POT,NPOT,3,3)#            Print calc pattern only          PO01  91
ncodefld:(FLOAT(NCYCLE),1,PO2,400513.,1)# Format refine cycles          PO01  92
writeline:(0,PO2,NPO2,3,3)#            Print refine cycles              PO01  93
ncodefld:(PEAKSP,1,POM,400612.,1)#     Format peak span override        PO01  94
writeline:(0,POM,NPOM,3,3)#            Print peak span override         PO01  95
movechar:(POR,WTSCHM*5+1,POQ,36,5,0)#  Insert step wt option flag       PO01  96
writeline:(0,POQ,NPOQ,3,3)#            Print step wt option flag        PO01  97
ncodefld:(FLOAT(NSKIP),1,POS,400613.,1)# Format step skip value         PO01  98
writeline:(0,POS,NPOS,3,3)#            Print step skip value            PO01  99
movechar:(PO0,APPDSP*3+1,PO2,38,3,0)#  Insert apply disp flag           PO01 100
writeline:(0,PO2,NPO2,3,3)#            Print apply disp flag            PO01 101
#                                                                       PO01 102
#   DECIDE WHICH SOURCE PATTERN FILE TO USE - IF ANY                    PO01 103
#   ------------------------------------------------                    PO01 104
#                                                                       PO01 105
FILEXT(IOUNIT(3))=PFILES(1)#           Default - assume rt ouput        PO01 106
#opendac:(IOUNIT(3),0,FILE,' ')#                                        PO01 107
inquirefile:(IOUNIT(3),FILE,' ')
IF(FILE!=yes:)#                        No .pot file was found           PO01 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO01 109
FILEXT(IOUNIT(5))='PAT'#               Reset the filename to pat        PO01 110
inquirefile:(IOUNIT(3),FILE,' ')
#opendac:(IOUNIT(3),0,FILE,' ')#       Test for initial pat file        PO01 111
IF(FILE!=yes:)#                                                         PO01 112
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO01 113
PFILES(1)=' '#                         No powder file available         PO01 114
writeline:(0,PO4,NPO4,3,3)#            Print warning message            PO01 115
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO01 116
ELSE PFILES(1)='PAT'#                  the .pat file was available
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO01 117
IF(FILE==yes:)#                        A source powder file was found   PO01 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO01 119
movechar:(PFILES(1),1,PO3,20,3,0)#     Insert file name                 PO01 120
writeline:(0,PO3,NPO3,3,3)#            Print powder file used           PO01 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO01 122
#                                                                       PO01 123
#     LIST AUXILLIARY (INCOMENSURATE?) POWDER FILES                     PO01 124
#     ---------------------------------------------                     PO01 125
#                                                                       PO01 126
DO I=2,auxfiles:#                                                       PO01 127
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO01 128
IF(PFILES(I)==' ')BREAK#                                                PO01 129
movechar:(PFILES(I),1,PO5,35,3,0)#     Insert file name                 PO01 130
writeline:(0,PO5,NPO5,3,3)#            Print powder file used           PO01 131
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO01 132
#                                                                       PO01 133
LEGINV=no:#                                                             PO01 134
#                                                                       PO01 135
RETURN#                                                                 PO01 136
END#                                                                    PO01 137
systemheader:(PO02)#                   Enter pattern parameters         PO02   1
# ############################################################# #       PO02   2
#                                                               #       PO02   3
#                              PO02                             #       PO02   4
#                                                               #       PO02   5
# ############################################################# #       PO02   6
SUBROUTINE PO02#                                                        PO02   7
include:(AACOMN)#                                                       PO02   8
include:(POCOMN)#                                                       PO02   9
#                                                                       PO02  10
INTEGER I,N,M,NCHAR,PT#                                                 PO02  11
#                                                                       PO02  12
#                                                                       PO02  13
CRVLAB(1)='TWOTHETA  ';CRVLAB(2)='Y obs     '#                          PO02  14
CRVLAB(3)='%s(Y obs) ';CRVLAB(4)='BackGd    '#                          PO02  15
CRVLAB(5)='Y cal tot ';CRVLAB(6)='Yobs-Ycal '#                          PO02  16
CRVLAB(7)='Phase xx  '#                                                 PO02  17
DO I=7,arith:(maxpha:,+,6)#            Loop over possible phases        PO02  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO02  19
CRVLAB(I)=CRVLAB(7)#                   Phase id string                  PO02  20
ncodefld:(FLOAT(I-6),1,CRVLAB(I),80213.,1)# Encode phase number         PO02  21
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO02  22
#                                                                       PO02  23
#     SET UP THE FORMATS FOR DEFAULT OUTPUT PAPER SIZE                  PO02  24
#     ------------------------------------------------                  PO02  25
#                                                                       PO02  26
PRPAGE(prpscale:) =inches:#            Default scale is in inches       PO02  27
PRPAGE(prptype:)  =float:(a4:)#        Default paper type is a4         PO02  28
PRPAGE(prporient:)=float:(landscape:)# Default paper orientation        PO02  29
IF(nint:(PRPAGE(prptype:))==a4:)#      If a4 paper size                 PO02  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO02  31
PRPAGE(praspect:)=1.4142857D00#        Page aspect ratio                PO02  32
PRPAGE(prydim:)  =8.2644D00*PRPAGE(prpscale:)# Output paper page heig   PO02  33
PRPAGE(prxdim:)  =PRPAGE(prydim:)*PRPAGE(praspect:)# Output paper pag   PO02  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO02  35
ELSEIF(nint:(PRPAGE(prptype:))==usletter:)# If u.s. letter size         PO02  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO02  37
PRPAGE(prydim:)  = 8.5D00*PRPAGE(prpscale:)# Output paper page height   PO02  38
PRPAGE(prxdim:)  =11.0D00*PRPAGE(prpscale:)# Output paper page width    PO02  39
PRPAGE(praspect:)=PRPAGE(prxdim:)/PRPAGE(prydim:)# Page aspect ratio    PO02  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO02  41
PRPAGE(prlmargin:)=0.5D00*PRPAGE(prpscale:)# One inch margins (chosen   PO02  42
PRPAGE(prrmargin:)=0.5D00*PRPAGE(prpscale:)# One inch margins (chosen   PO02  43
PRPAGE(prtmargin:)=0.5D00*PRPAGE(prpscale:)# One inch margins (chosen   PO02  44
PRPAGE(prbmargin:)=0.5D00*PRPAGE(prpscale:)# One inch margins (chosen   PO02  45
PRPAGE(prdiborder:)=float:(no:)#      Draw inner border                PO02  46
PRPAGE(prdoborder:)=float:(no:)#      Draw outer border                PO02  47
#                                                                       PO02  48
#    INITIALISE GRAPH DISPLAY DEFAULTS                                  PO02  49
#    ---------------------------------                                  PO02  50
#                                                                       PO02  51
DO N=mxcout:,60,-1;IF(TITLE(N^N)!=' ')BREAK# Find shortest string       PO02  52
NCHAR=N+1#                             Num of non-trailing blank char   PO02  53
DO PT=1,maxgn:#                        Cycle over all permitted graph   PO02  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO02  55
# GRAPH TITLES                                                          PO02  56
tidisplay:=FLOAT(yes:)#                Do display title                 PO02  57
tixorigin:=0.1D00#                     Title x origin location          PO02  58
tiyorigin:=0.92D00#                    Title y origin location          PO02  59
tiangle:  =0.0D00#                     Angle of title to horizontal     PO02  60
tisize:   =0.06D00#                    Fractional size of title text    PO02  61
ticolor:  =1.D00#                      Color of title text              PO02  62
IF(NCHAR<=60)#                         No text in title                 PO02  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO02  64
tichars: = 6.D00#                      Six characters in the compid     PO02  65
TITLET(PT)(1^6)=TITLE(9^14)#           Save the compid as the title     PO02  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO02  67
ELSE#                                  The title text is non-null       PO02  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO02  69
tichars:  =float:(NCHAR-60)#           Num chars of title text          PO02  70
TITLET(PT)(1^NCHAR-60)=TITLE(63^NCHAR)# Save text for each graph        PO02  71
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO02  72
#                                                                       PO02  73
# THE ABSCISSA                                                          PO02  74
#                                                                       PO02  75
axdisplay:(1)     =float:(yes:)#       Do display                       PO02  76
axtype:(1)        =1.D00#              Linear =1 log = 2 sqrt = 3       PO02  77
axscale:(1)       =1.D00#              Unit scale factor                PO02  78
axauto:(1)        =float:(yes:)#       Auto recalibrate                 PO02  79
ax0posn:(1)       =float:(yes:)#       Bottom=0 top=1                   PO02  80
ax1posn:(1)       =float:(yes:)#       Bottom=0 top=1                   PO02  81
axcolor:(1)       =1.0D00#             Red color for axis               PO02  82
axlinest:(1)      =1.0D00#             Solid line style for axis        PO02  83
axlinewd:(1)      =1.5D00#             Heavy line width for axis        PO02  84
axmin:(1)         =0.D00#              Min 2theta                       PO02  85
axmax:(1)         =-180.D00#            Max 2theta                       PO02  86
axbtick:(1)       =10.D00#             About ten big tick marks         PO02  87
axfbtick:(1)      =0.D00#              Big tick marks start at 0        PO02  88
axlbtick:(1)      =180.D00#            Big tick marks finish at 180     PO02  89
axbticks:(1)      =20.D00#             20 degree spacing  on big        PO02  90
axsbtick:(1)      =0.05D00#            5 percent of graph dimensions    PO02  91
axbticklw:(1)     =1.2D00#             Big tick has heavier line widt   PO02  92
axfmtick:(1)      =0.D00#              Medium tick marks start at 0     PO02  93
axlmtick:(1)      =180.D00#            Medium tick marks finish at 18   PO02  94
axmticks:(1)      =10.D00#             Medium tick mark spacing is 10   PO02  95
axsmtick:(1)      =0.035D00#           3.5 percent of graph dimension   PO02  96
axmticklw:(1)     =1.0D00#             Medium line width                PO02  97
axfstick:(1)      =0.D00#              Small tick marks start at 0      PO02  98
axlstick:(1)      =180.D00#            Small tick marks go to 180 deg   PO02  99
axsticks:(1)      =2.D00#              2 degree tick mark spacing       PO02 100
axsstick:(1)      =0.025D00#           2.5 percent of graph dimension   PO02 101
axsticklw:(1)     =1.0D00#             Small line width                 PO02 102
axfltick:(1)      =20.D00#             Start at 20 degrees              PO02 103
axlltick:(1)      =180.D00#            Finish at 180                    PO02 104
axlticks:(1)      =20.D00#             20 degree step size              PO02 105
axlticsize:(1)    =0.02D00#            Size of text                     PO02 106
axlticangl:(1)    =0.0D00#             Angle of text                    PO02 107
axlticcol:(1)     =7.0D00#             White on black                   PO02 108
axtlabel:(1)      =float:(yes:)#       Label the axis                   PO02 109
axtangle:(1)      =0.0D00#             Angle of axis label text         PO02 110
axtcolor:(1)      =1.0D00#             Color of axis label text         PO02 111
axtxorigin:(1)    =0.5D00#             X origin of axis label           PO02 112
axtyorigin:(1)    =0.015D00#           Y origin of axis label           PO02 113
axtsize:(1)       =0.04D00#            Fractional size of axis label    PO02 114
axtcharnum:(1)    =7.0D00#             Number of characters             PO02 115
ABSLAB(PT)        ='2%q(^o)'#                                           PO02 116
axlcentredigit:(1)=0.D00#              Centre on decimal place          PO02 117
axlnumdecplac:(1) =0.D00#              Zero decimal places for degree   PO02 118
axldispxcent:(1)  =0.0D00#             Zero x displacement              PO02 119
axldispycent:(1)  =.05D00#             Displacement down by % of widt   PO02 120
#                                                                       PO02 121
#   THE ORDINATE                                                        PO02 122
#                                                                       PO02 123
axdisplay:(2)      =float:(yes:)#      Do display                       PO02 124
axtype:(2)         =1.D00#             Twotheta =1  (dspacing = 2??)    PO02 125
axscale:(2)        =1.D00#             Unit scale factor                PO02 126
axauto:(2)         =float:(yes:)#      Auto recalibrate                 PO02 127
ax0posn:(2)        =float:(yes:)#      Draw on left                     PO02 128
ax1posn:(2)        =float:(yes:)#      Draw on right                    PO02 129
axlinest:(2)       =1.0D00#            Solid line style for axis        PO02 130
axcolor:(2)        =1.0D00#            Red color for axis               PO02 131
axlinewd:(2)       =1.5D00#            Heavy line width for axis        PO02 132
axmin:(2)          =-1000.D00#         Min intensity                    PO02 133
axmax:(2)          =-10000.D00#        Max intensity -auto calc flag
axbtick:(2)        =11.D00#            Big tick marks start at 0        PO02 135
axfbtick:(2)       =-1000.D00#         Big tick marks start at 0        PO02 136
axlbtick:(2)       =10000.D00#         Big tick marks finish at 180     PO02 137
axbticks:(2)       = 1000.D00#         20 degree spacing  on big        PO02 138
axsbtick:(2)       =0.05D00#           5 percent of graph dimensions    PO02 139
axbticklw:(2)      =1.2D00#            Big tick has heavier line widt   PO02 140
axfmtick:(2)       =-1000.D00#         Medium tick marks start at 0     PO02 141
axlmtick:(2)       =10000.D00#         Medium tick marks finish at 18   PO02 142
axmticks:(2)       =  500.D00#         Medium tick mark spacing is 10   PO02 143
axsmtick:(2)       =0.035D00#          3.5 percent of graph dimension   PO02 144
axmticklw:(2)      =1.0D00#            Medium line width                PO02 145
axfstick:(2)       =-1000.D00#         Small tick marks start at 0      PO02 146
axlstick:(2)       =10000.D00#         Small tick marks go to 180 deg   PO02 147
axsticks:(2)       =  100.D00#         2 degree tick mark spacing       PO02 148
axsstick:(2)       =0.025D00#          2.5 percent of graph dimension   PO02 149
axsticklw:(2)      =1.0D00#            Small line width                 PO02 150
axfltick:(2)       =-1000.D00#         Start at 20 degrees              PO02 151
axlltick:(2)       =10000.D00#         Finish at 180                    PO02 152
axlticks:(2)       = 1000.D00#         20 degree step size              PO02 153
axlticsize:(2)     =.02D00#            Size of text                     PO02 154
axlticangl:(2)     =0.0D00#            Angle of text                    PO02 155
axlticcol:(2)      =7.0D00#            White on black                   PO02 156
axtlabel:(2)       =float:(yes:)#      Label the axis                   PO02 157
axtangle:(2)       =90.D00#            Angle of axis label text         PO02 158
axtcolor:(2)       =1.0D00#            Color of axis label text         PO02 159
axtxorigin:(2)     =0.05D00#           X origin of axis label           PO02 160
axtyorigin:(2)     =0.25D00#           Y origin of axis label           PO02 161
axtsize:(2)        =0.04D00#           Fractional size of axis label    PO02 162
axtcharnum:(2)     =9.0D00#            Number of characters             PO02 163
ORDLAB(PT)         = 'Intensity'#                                       PO02 164
axlcentredigit:(2) =0.D00#             Centre on decimal place          PO02 165
axlnumdecplac:(2)  =0.D00#             Zero decimal places for intens   PO02 166
axldispxcent:(2)   =0.045D00#          X displacement to edge of tick   PO02 167
axldispycent:(2)   =0.003D00#          Displacement up by % of width    PO02 168
#                                                                       PO02 169
ledisplay:   =float:(yes:)#            Do display the legend            PO02 170
letitle:     =float:(yes:)#            Include the legend title         PO02 171
leboxed:     =float:(yes:)#            Display the legend in a box      PO02 172
leboxlw:     =1.0D00#                  Legend box line width            PO02 173
leshaded:    =1.0D00#                  Legend box has background shad   PO02 174
lexorigin:   =1.0D00#                  On right hand side               PO02 175
leyorigin:   =0.05D00#                 At bottom of graph               PO02 176
lewidth:     =0.3D00#                  Width of legend                  PO02 177
leheight:    =0.7D00#                  Height of legend box             PO02 178
leelements:  =6.0D00#                  First six graphs                 PO02 179
#                                                                       PO02 180
grxdisplay:  =FLOAT(yes:)#             Do display a grid                PO02 181
grydisplay:  =FLOAT(yes:)#             Do display a grid                PO02 182
grxtied:     =FLOAT(yes:)#             Assume tied to axes              PO02 183
grytied:     =FLOAT(yes:)#             Assume tied to axes              PO02 184
grcolor:     = 1.0E00#                 Grid has this color              PO02 185
grlinewd:    = 1.0E00#                 Grid has this line width         PO02 186
grlinest:    = 3.0E00#                 Grid has this line style         PO02 187
grlinedl:    = 1.0E00#                 Dash length                      PO02 188
grlinebl:    = 1.0E00#                 Break length                     PO02 189
grvlines:    = 5.0E00#                 Num of vertical lines            PO02 190
grhlines:    = 6.0E00#                 Num of horizontal lines          PO02 191
#                                                                       PO02 192
ZOOM(PT,zoomx:)      =1.0#             Initially x magnification x1     PO02 193
ZOOM(PT,zoomy:)      =1.0#             Initially y magnification x1     PO02 194
HSCROLL(PT,sccentre:)=0.5#             Centred scroll bar               PO02 195
HSCROLL(PT,scwidth:) =1.0#             Maximum coverage of page         PO02 196
VSCROLL(PT,sccentre:)=0.5#             Centred scroll bar               PO02 197
VSCROLL(PT,scwidth:) =1.0#             Maximum coverage of page         PO02 198
#                                                                       PO02 199
gptinvoked:  =FLOAT(no:)#              This graph is not invoked        PO02 200
gptxindex:   =0.00#                    Grindx pointer x                 PO02 201
gptyindex:   =0.00#                    Grindx pointer y                 PO02 202
gptcalxorg:  =0.00#                    Calculated xorigin block on pa   PO02 203
gptcalyorg:  =0.00#                    Calculated xorigin block on pa   PO02 204
gptcalwidth: =0.800#                   Relative width of block          PO02 205
gptcalheight:=0.56500#                 Relative height of block         PO02 206
gptuspxorg:  =0.000#                   User specified xorigin block o   PO02 207
gptuspyorg:  =0.200#                   User specified yorigin block o   PO02 208
gptuspwidth: =0.800#                   Relative width of block          PO02 209
gptuspheight:=0.56500#                 Relative height of block         PO02 210
gptbaspect:  =1.414200#                Block aspect ratio               PO02 211
#                                      Relative to current block canvas PO02 212
gptgxorigin:=0.1500#                   Relative xorigin of graph        PO02 213
gptgyorigin:=0.1500#                   Relative y origin of graph       PO02 214
gptgwidth:  =1.0000#                   Relative width of graph          PO02 215
gptgheight: =0.70700#                  Relative height of graph         PO02 216
gptgaspect: =1.4142#                   Graph aspect ratio               PO02 217
gptgboxed:  =FLOAT(yes:)#              Display graph in box             PO02 218
gptbodisp:  =FLOAT(no:)#               Display border                   PO02 219
gptbocolor: =2.00#                     Color of border                  PO02 220
gptbolinewd:=1.000#                    Line width of border             PO02 221
gptbolinest:=2.000#                    Line style of border             PO02 222
gptbolinedl:=0.0500#                   Dash length of border            PO02 223
gptbolinebl:=0.0500#                   Break length of border           PO02 224
#                                                                       PO02 225
DO M=1,maxpha:#                        Cycle over all possible phases   PO02 226
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO02 227
cvdisplay:(M) =FLOAT(no:)#             Display curve at all             PO02 228
cvdispln:(M)  =FLOAT(no:)#             Display curve line               PO02 229
cvdispmk:(M)  =FLOAT(no:)#             Display curve marker             PO02 230
cvlncolor:(M) =FLOAT(20+2*M)#          Color of curve                   PO02 231
cvmkcolor:(M) =FLOAT(20+2*M)#          Color of marker                  PO02 232
cvauxscal:(M) =1.0#                    Auxilliary scale factor          PO02 233
cvphascal:(M) =1.0#                    Phase scale factor               PO02 234
cvdivbysig:(M)=FLOAT(no:)#             Divide this curve by sigma       PO02 235
cvshift:(M)   =FLOAT(no:)#             Displacement of curve            PO02 236
cvshx:(M)     =0.0E00#                 X displacement of curve          PO02 237
cvshy:(M)     =0.0E00#                 Y displacement of curve          PO02 238
cvxmin:(M)    =0.0E00#                 Minimum x of curve               PO02 239
cvymin:(M)    =0.0E00#                 Minimum y of curve               PO02 240
cvxmax:(M)    =0.0E00#                 Maximum x of curve               PO02 241
cvymax:(M)    =0.0E00#                 Maximum y of curve               PO02 242
cvlinewd:(M)  =1.0E00#                 Grid has this line width (1.0)   PO02 243
cvlinest:(M)  =1.0E00#                 Grid has this line style (soli   PO02 244
cvlinedl:(M)  =1.0E00#                 Dash length                      PO02 245
cvlinebl:(M)  =1.0E00#                 Break length                     PO02 246
cvnullev:(M)  =0.01E00#                Set null level                   PO02 247
cvmarkerst:(M)= FLOAT(M)#              Grid has this marker style       PO02 248
cvconlintop:(M)=FLOAT(no:)#            Grid has this marker style       PO02 249
cvconlinbot:(M)=FLOAT(no:)#            Grid has this marker style       PO02 250
cvpredatlin:(M)=FLOAT(yes:)#           Include pre-data line            PO02 251
cvposdatlin:(M)=FLOAT(yes:)#           Include post-data line           PO02 252
cvpredatlev:(M)=100.E00#               Level of pre dat line            PO02 253
cvposdatlev:(M)=200.E00#               Level of post dat line           PO02 254
cvlabchars:(M)= 10.E00#                Curve label has this many char   PO02 255
#                                                                       PO02 256
# FOR EACH PHASE AND EACH BLOCK SET SENSIBLE HKLBARS                    PO02 257
#                                                                       PO02 258
#                                                                       PO02 259
hbdisplay:(M)=float:(no:)#             Display hklbars(yes/no)          PO02 260
hbymin:(M)=-1.0D00#                    Min y val of reflection          PO02 261
hbsize:(M)=0.05D00#                    Size of bars to show             PO02 262
hbshift:(M)=float:(yes:)#              Displace curve (yes/no)          PO02 263
hbxoffset:(M)=0.000D00#                X=0 offset of hkl bars           PO02 264
hbyoffset:(M)=0.015D00#                Y offset of hkl bars             PO02 265
hblabel:(M)=float:(no:)#               Label hklbars (yes/no)           PO02 266
hbfontsize:(M)=.01D00#                 Small hkl label fontsize         PO02 267
hbangle:(M)=90.0D00#                   Angle of labels to horiz         PO02 268
hblabymin:(M)=30.D00#                  Min y val to label               PO02 269
hblabshx:(M)=0.0D00#                   X displa of hkl lab              PO02 270
hblabshy:(M)=0.0D00#                   Y displa of hkl lab              PO02 271
#                                                                       PO02 272
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO02 273
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO02 274
DO M=1,miv:+1;DO N=1,miv:+1;GRINDX(M,N)=0# All index entries are null   PO02 275
IF(PFILES(1)!=' ')$(DO PT=1,maxgn:;cvdisplay:(yobs:)=FLOAT(yes:)$)#    
ELSE $(DO PT=1,maxgn:;cvdisplay:(ycaltot:)=FLOAT(yes:)$)#    
GRINDX(5,5) =1#                        Centre graph block 1 into indx   PO02 277
GRINDX(10,5)=1;GRINDX(5,10)=1#         Count vert/horiz entries         PO02 278
gptinvoked:(1)=FLOAT(yes:)#            Graph 1 is being invoked         PO02 279
gptxindex:(1) =5.000#                  Grindx pointer x                 PO02 280
gptyindex:(1) =5.000#                  Grindx pointer y                 PO02 281
HSCROLL(prpage:,sccentre:)=0.5#        Centred scroll bar               PO02 282
HSCROLL(prpage:,scwidth:) =1.0#        Maximum coverage of page         PO02 283
VSCROLL(prpage:,sccentre:)=0.5#        Centred scroll bar               PO02 284
VSCROLL(prpage:,scwidth:) =1.0#        Maximum coverage of page         PO02 285
ZOOM(prpage:,zoomx:)      =1.0#        Unitary x zoom                   PO02 286
ZOOM(prpage:,zoomy:)      =1.0#        Unitary y zoom                   PO02 287
#                                                                       PO02 288
RETURN#                                                                 PO02 289
END#                                                                    PO02 290
systemheader:(PO05)#                   Enter pattern parameters         PO05   1
# ############################################################# #       PO05   2
#                                                               #       PO05   3
#                              PO05                             #       PO05   4
#                                                               #       PO05   5
# ############################################################# #       PO05   6
SUBROUTINE PO05#                                                        PO05   7
#                                                                       PO05   8
include:(AACOMN)#                                                       PO05   9
include:(POCOMN)#                                                       PO05  10
#                                                                       PO05  11
INTEGER    LF#                                                          PO05  12
INTEGER    FUNCNR#                                                      PO05  13
INTEGER    I,J,K,L,M,N#                                                 PO05  14
INTEGER    PT#                                                          PO05  15
#                                                                       PO05  16
chardata:(PO1, LIMITS WAVLEN BACKGR PEAKF PEAKSH EXCLTT $#              PO05  17
NOREF ZERO DISPLA SCALE XLABEL YLABEL GRAPH SCREEN)#                    PO05  18
chardata:(PO2,' Preset Pattern Parameters-')#                           PO05  19
chardata:(PO3,' Preset two theta min/max                         ')#    PO05  20
chardata:(PO5,' Two theta zero correction ')#                           PO05  21
chardata:(PO6,' Wavelength of pattern data             ')#              PO05  22
chardata:(PO7,' Polarization ratio for Lp              ')#              PO05  23
chardata:(PO8,' Background parameters ')#                               PO05  24
chardata:(PO9,' 2theta exclusion limits                          ')#    PO05  25
chardata:(POA,' Peak shape function  Lines  Pkspan  1/step')#           PO05  26
chardata:(POB,MO CU )#                                                  PO05  27
chardata:(POC,B1 B2 B3 B4 B5 Z1 Z2 )#                                   PO05  28
chardata:(POD,' Background source - ')#                                 PO05  29
chardata:(POE,'file values  calculated ')#                              PO05  30
chardata:(POF,LIN LOG SQR )#                                            PO05  31
chardata:(POG,OBS CAL BAC DIF HKL GRI SHI )#                            PO05  32
realdata:(FMT,[400532.,500532.,600532.,700532.,800532.])#               PO05  33
datastuff:#                                                             PO05  34
#                                                                       PO05  35
#    SET DEFAULT PARAMETERS                                             PO05  36
#    -----------------------                                            PO05  37
#                                                                       PO05  38
IBAC=FLGBAC#                           Force bg calc if refined         PO05  39
NEXCLR=0#                              Two theta exclusion zones        PO05  40
TTMINL=0.0; TTMAXL=-180.0; TTSTEP=.02#  Default tth limits               PO05  41
TTMINR=1000.; TTMAXR=0.#               Start refln 2theta limits        PO05  42
LAMDA1=1.540598; LAMDA2=0.#            Set default cu alpha1/2          PO05  43
LAMBDA=1.540598#                       Set default rad to cu            PO05  44
RADTYP=3#
HWDMAX=0.;    NREFL=0#                 Half width max                   PO05  45
POLRA=0.915; LAMRAT=0.5#               Polarization, intens ratios      PO05  46
NPEAKF=0#                              Nr of peak shape functions       PO05  47
PT=1#                                  First plot                       PO05  48
AUTSKF=1#                              Au                               PO05  49
WAVSEL=no:#                            Assume use first phase wavelen   PO05  50
DO I=1,10; PKSPAN(I)=10.0#             Set default peak span (hwd ths   PO05  51
DO I=1,10; PSHFPT(I)=0#                Pkshp table pointer array        PO05  52
DO I=1,10; PSHFLN(I)=0#                Pkshp table length array         PO05  53
DO I=1,10; PSHFST(I)=0.0#              Pkshp table stepsz array         PO05  54
DO I=1,10; EXCLRL(I)=0.0#              Two theta exclusion limit lo     PO05  55
DO I=1,10; EXCLRH(I)=0.0#              Two theta exclusion limit hi     PO05  56
DO I=1,2;  PARZER(I)=0.0#              Default zero corrections         PO05  57
DO I=1,2;  REFZER(I)=FLGZER#           Default zero pt refinement       PO05  58
DO I=1,5;  PARBAC(I)=0.0#              Default background params        PO05  59
DO I=1,5;  REFBAC(I)=FLGBAC#           Default background refinement    PO05  60
DO I=1,maxpha:;SFCALC(I)=no:#          Not initialy, unless needed...   PO05  61
DO I=1,maxpha:;ADISP(I)=0.0#           Not initialy, unless needed...   PO05  62
LF=MARKF;    NEWM=MARKF#               Peak shape array markers         PO05  63
#                                                                       PO05  64
#   LOOP OVER GENERAL PARAMETER LINES                                   PO05  65
#   ---------------------------------                                   PO05  66
#                                                                       PO05  67
readline:(PO1,-NPO1)#                  Read next input line and retai   PO05  68
REPEAT#                                Loop over pattern lines          PO05  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO05  70
IF(LINID==0) BREAK#                    Exit when not recognised         PO05  71
#                                                                       PO05  72
IF(LINID==1)#                          ******** limits ************     PO05  73
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO05  74
ifnv:(BUFIN(1)) TTMINL=BUFIN(1)#       Preset min two theta limit       PO05  75
ifnv:(BUFIN(2)) TTMAXL=BUFIN(2)#       Preset max two theta limit       PO05  76
ifnv:(BUFIN(3)) TTSTEP=BUFIN(3)#       Two theta step (pattern)         PO05  77
ifnv:(BUFIN(4))   YMIN=BUFIN(4)#       Minimum requested intensity      PO05  78
ifnv:(BUFIN(5))   YMAX=BUFIN(5)#       Maximum requested intensity      PO05  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO05  80
#                                                                       PO05  81
ELSE IF(LINID==2)#                     ********* wavlen ************    PO05  82
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO05  83
WAVSEL=yes:#                                                            PO05  84
ifnm:(BUFIN(1)) LAMDA1=BUFIN(1)#       Set to value on line             PO05  85
ifch:(BUFIN(1))#                       String code encountered          PO05  86
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO05  87
stringlim:(1,J,K)#                     Get string limits                PO05  88
compchar:(CHRIN,J,POB,1,2,3,NPOB,K)#   Test for cu, mo                  PO05  89
IF(K==0) iquit:(PO0510)#               Unknown wavelength               PO05  90
IF(K==1) LAMDA1=0.70926#               Set to mo k alpha value          PO05  91
ELSE     LAMDA1=1.540598#              Set to cu k alpha value          PO05  92
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO05  93
LAMBDA=LAMDA1#                         Working wavelength               PO05  94
ifnv:(BUFIN(2)) LAMDA2=BUFIN(2)#       Wavelength alpha2                PO05  95
ifnv:(BUFIN(3)) LAMRAT=BUFIN(3)#       Alpha1/2 int ratio               PO05  96
ifnv:(BUFIN(4)) POLRA =BUFIN(4)#       Polarisation ratio               PO05  97
ifch:(BUFIN(5))#                                                        PO05  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO05  99
stringlim:(I,M,N)#                     Get string position              PO05 100
IF     (CHRIN(M^M+1)=='E') RADTYP=2#   Electrons                        PO05 102
ELSE IF(CHRIN(M^M+1)=='N') RADTYP=1#   Neutrons                         PO05 103
ELSE IF(CHRIN(M^M+1)=='MO')RADTYP=3#   
ELSE IF(CHRIN(M^M+1)=='CU')RADTYP=4#   
ELSE IF(CHRIN(M^M+1)=='AG')RADTYP=5#   
ELSE                       RADTYP=6#   Synchrotron x-rays               PO05 104
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO05 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO05 106
#                                                                       PO05 107
ELSE IF(LINID==3)#                     ********* backgr ***********     PO05 108
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO05 109
IBAC=yes:#                             Set backgr flag                  PO05 110
DO I=1,5; ifnm:(BUFIN(I)) PARBAC(I)=BUFIN(I)# Background parameters     PO05 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO05 112
#                                                                       PO05 113
ELSE IF(LINID==4)#                     ******** peakf *************     PO05 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO05 115
IF(NPEAKF>=10) iquit:(PO2301)#         Up to 10 pkshp fns allowed       PO05 116
NPEAKF=NPEAKF+1#                       Count nr pkshp functions         PO05 117
ifnm:(BUFIN(1)) FUNCNR=BUFIN(1)#       Current pkshp function number    PO05 118
ELSE            FUNCNR=1#              Default function counter =1      PO05 119
ifnm:(BUFIN(2)) PEAKSP=BUFIN(2)#       Store peak span                  PO05 120
IF(PEAKSP>0.) PKSPAN(FUNCNR)=PEAKSP#   Override with input value        PO05 121
span:=MAX(span:,PKSPAN(FUNCNR))#       Get maximum peak span            PO05 122
IF(FUNCNR>10) iquit:(PO2301)#          Up to 10 pkshp fns allowed       PO05 123
PSHFPT(FUNCNR)=LF#                     Start address for function       PO05 124
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO05 125
#                                                                       PO05 126
ELSE IF(LINID==5)#                     ******** peaksh ************     PO05 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PO05 128
incrqx:(NEWM,LF+5,PO2302)#             Space for one pkshp fn entry     PO05 129
PSHFLN(FUNCNR)=PSHFLN(FUNCNR)+1#       Count lines for function         PO05 130
QX(LF+1)=BUFIN(1)#                     Ri - delta 2theta/halfwidth      PO05 131
QX(LF+2)=BUFIN(2)#                     Fsi - symmetric part             PO05 132
QX(LF+3)=BUFIN(3)#                     Fai - asymmetric part            PO05 133
QX(LF+4)=BUFIN(4)#                     Dfsi - deriv. of sym. part       PO05 134
QX(LF+5)=BUFIN(5)#                     Dasi - deriv. of asym. part      PO05 135
LF=NEWM#                               5 items per entry increment      PO05 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PO05 137
#                                                                       PO05 138
ELSE IF(LINID==6)#                     ******** excltt ************     PO05 139
FOR(I=1;BUFIN(I)>voidflg:;I=I+2)#      Loop over pairs of limits        PO05 140
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PO05 141
NEXCLR=NEXCLR+1#                       Count the exclusion limits       PO05 142
IF(NEXCLR>10) iquit:(PO2310)#          Exclude zones exceeded           PO05 143
EXCLRL(NEXCLR)=BUFIN(I)#               Store 2theta excl low limit      PO05 144
EXCLRH(NEXCLR)=BUFIN(I+1)#             Store 2theta excl high limit     PO05 145
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PO05 146
#                                                                       PO05 147
ELSE IF(LINID==7)#                     ******** noref ************      PO05 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PO05 149
FOR(I=1;BUFIN(I)<voidflg:;I=I+1)#      5 bac, 2 zer pars possible       PO05 150
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PO05 151
stringlim:(I,N,M)#                     Take first 2 chars in field      PO05 152
compchar:(CHRIN,N,POC,1,2,3,NPOC,K)#   B1 b2 b3 b4 b5 z1 z2             PO05 153
IF(K==0) iquit:(PO0540,I)#             Unknown pattern param            PO05 154
IF(K<6) REFBAC(K)=0#                   Noref background parameters      PO05 155
ELSE    REFZER(K-5)=0#                 Noref pattern zero parameters    PO05 156
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PO05 157
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PO05 158
#                                                                       PO05 159
ELSE IF(LINID==8)#                     ********* zero ***********       PO05 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PO05 161
DO I=1,2; ifnm:(BUFIN(I)) PARZER(I)=BUFIN(I)# Zero point parameters     PO05 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PO05 163
#                                                                       PO05 164
readline:(PO1,-NPO1)#                  Read next input line and retai   PO05 165
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO05 166
#                                                                       PO05 167
#                                                                       PO05 204
DO I=1,NPEAKF#                         Loop peak functions              PO05 206
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PO05 207
J=PSHFPT(I); IF(J==0) NEXT#            Skip undefined functions         PO05 208
L=PSHFLN(I); K=J+(L-1)*5#              Pt to last entry                 PO05 209
PSHFST(I)=FLOAT(L-1)/QX(K+1)#          Nsteps/range = 1/stepsz          PO05 210
$)
#                                                                       PO05 225
SAVEID=COMPID#                         Save the original compid         PO05 227
#                                                                       PO05 228
RETURN#                                                                 PO05 229
END#                                                                    PO05 230
systemheader:(PO07)#                   Control line check               PO07   1
####################################################################    PO07   2
#                                                                  #    PO07   3
#                               PO07                               #    PO07   4
#                                                                  #    PO07   5
####################################################################    PO07   6
SUBROUTINE PO07#                                                        PO07   7
include:(AACOMN)#                                                       PO07   8
include:(POCOMN)#                                                       PO07   9
#                                                                       PO07  10
INTEGER PT,GR,I,J,K,L,TR#                                               PO07  11
INTEGER LINE,AXIS#                                                      PO07  12
chardata:(PO1, BLOCK BLKBRD GRAPH EXCLR HKLBAR AXIS $#                  PO07  13
AXSLAB TICKMK GRID GTITLE TITEXT LEGEND TRACE TRCTXT )#                 PO07  14
chardata:(PO2, TTH OBS SIG BAK CAL DEL PH1 PH2 PH3 PH4 PH5 $#           PO07  15
PH6 PH7 PH8 PH9 PH10 )#                                                 PO07  16
chardata:(PO3, TOP BOT TAB )#                                           PO07  17
chardata:(PO4, LEF RIT LAR )#                                           PO07  18
chardata:(PO5, LOG LIN SQR )#                                           PO07  19
chardata:(PO6, X Y )#                                                   PO07  20
#CHARDATA:(PO7, AXES FRAC )#                                            PO07  21
datastuff:#                                                             PO07  22
#                                                                       PO07  23
PT=1#                                  Assume plot number one           PO07  24
GR=-1#                                 Assume plot number one           PO07  25
REPEAT#                                                                 PO07  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO07  27
IF(LINID<=0) BREAK#                    Unrecognised control             PO07  28
#                                                                       PO07  29
ELSEIF(LINID==1)#                      -------a graph block line        PO07  30
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO07  31
IF(GR==0)#                             First graph was not numbered     PO07  32
DO I=PT+1,maxgn:#                      Cycle over the rest of the gra   PO07  33
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO07  34
DO J=1,20;   GRID(I,J)=  GRID(PT,J)#   Copy grid settings               PO07  35
DO J=1,20; LEGEND(I,J)=LEGEND(PT,J)#   Copy legend settings             PO07  36
DO J=1,20; GTITLE(I,J)=GTITLE(PT,J)#   Copy grid settings               PO07  37
DO J=2,20;  GRAPH(I,J)= GRAPH(PT,J)#   Copy grid settings               PO07  38
DO J=1,50;DO K=1,2;         AXES(I,K,J)=AXES(PT,K,J)# Copy axes setti   PO07  39
DO J=1,40;DO K=1,6+maxpha:;CURVE(I,K,J)=CURVE(PT,K,J)# Copy curve set   PO07  40
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO07  41
ifnm:(BUFIN(1))#                       If graph block number is prese   PO07  42
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO07  43
PT=NINT(BUFIN(1))#                     Get the graph block number       PO07  44
gptinvoked:=FLOAT(yes:)#                                                PO07  45
GR=PT#                                 Set graph pointer                PO07  46
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO07  47
ELSE GR=GR+1#                          Add one to the graph counter     PO07  48
IF(PT>maxgn:\PT<1)iquit:(PO0701)#      Graph number out of range        PO07  49
ifnm:(BUFIN(2))gptxindex:   =ABS(BUFIN(2))#                             PO07  50
ifnm:(BUFIN(3))gptyindex:   =ABS(BUFIN(3))#                             PO07  51
ifnm:(BUFIN(4))gptuspxorg:  =   (BUFIN(4))#                             PO07  52
ifnm:(BUFIN(5))gptuspyorg:  =   (BUFIN(5))#                             PO07  53
ifnm:(BUFIN(6))gptuspwidth: =ABS(BUFIN(6))#                             PO07  54
ifnm:(BUFIN(7))gptuspheight:=ABS(BUFIN(7))#                             PO07  55
ifnm:(BUFIN(8))gptbaspect:  =ABS(BUFIN(8))#                             PO07  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO07  57
#                                                                       PO07  58
#                                                                       PO07  59
ELSEIF(LINID==2)#                      -------a block border line       PO07  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO07  61
gptbodisp:  =FLOAT(yes:)#              Ensure boredr is plotted         PO07  62
ifnm:(BUFIN(1))gptbocolor:  =ABS(BUFIN(1))# Graph border color          PO07  63
ifnm:(BUFIN(2))gptbolinewd: =ABS(BUFIN(2))#                             PO07  64
ifnm:(BUFIN(3))gptbolinest: =ABS(BUFIN(3))#                             PO07  65
ifnm:(BUFIN(4))gptbolinedl: =ABS(BUFIN(4))#                             PO07  66
ifnm:(BUFIN(5))gptbolinebl: =ABS(BUFIN(5))#                             PO07  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO07  68
#                                                                       PO07  69
#                                                                       PO07  70
ELSEIF(LINID==3)#                      -------a graph line              PO07  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO07  72
ifch:(BUFIN(1))#                       Test for log lin sqr flag        PO07  73
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO07  74
stringlim:(1,J,K)#                     Get string limits                PO07  75
compchar:(CHRIN,J,PO5,1,4,4,NPO5,L)#   Compare strings                  PO07  76
IF(L>=1&L<=3)axtype:(2)=float:(L)#     Ordinate y is 1, 2 or 3          PO07  77
ELSE         axtype:(2)=FLOAT(1)#      Assume linear                    PO07  78
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO07  79
ifnm:(BUFIN(2))gptgxorigin: =  (BUFIN(2))# Graph x origin               PO07  80
ifnm:(BUFIN(3))gptgyorigin: =  (BUFIN(3))# Graph y origin               PO07  81
ifnm:(BUFIN(4))gptgwidth:   =ABS(BUFIN(4))# Graph width                 PO07  82
ifnm:(BUFIN(5))gptgheight:  =ABS(BUFIN(5))# Graph height                PO07  83
ifnm:(BUFIN(6))gptgaspect:  =ABS(BUFIN(6))# Graph aspect ratio          PO07  84
ifch:(BUFIN(7))gptgboxed:   =FLOAT(no:)# No box around graph            PO07  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO07  86
#                                                                       PO07  87
#                                                                       PO07  88
ELSEIF(LINID==4)#                      -------an exclusion region lin   PO07  89
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PO07  90
TR=0#                                                                   PO07  91
ifch:(BUFIN(1))#                       Test for specific phase/trace    PO07  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PO07  93
stringlim:(1,J,K)#                                                      PO07  94
compchar:(CHRIN,J,PO2,1,4,4,NPO2,TR)#  Test for cu, mo                  PO07  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PO07  96
LINE=no:#                              Assume no line requested         PO07  97
ifch:(BUFIN(2))#                       Test bufin two for yes flag      PO07  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PO07  99
stringlim:(2,J,K)#                     Get string limits                PO07 100
IF(CHRIN(J^J)=='L')LINE=yes:#          A yes is identified              PO07 101
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PO07 102
IF(TR>0&TR<6+maxpha:)#                 A curve trace was specified      PO07 103
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PO07 104
cvexczoninc:(TR)=float:(yes:)#         Include exclusion zone on curv   PO07 105
cvexczonlin:(TR)=float:(LINE)#         Draw the exclusion line          PO07 106
ifnm:(BUFIN(3))cvexcdatlev:(TR)=db:(BUFIN(2))# Get the ordinate level   PO07 107
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PO07 108
ELSE DO TR=2,6+maxpha:#                Cycle over all possible traces   PO07 109
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PO07 110
cvexczoninc:(TR)=float:(yes:)#         Include exclusion zone on curv   PO07 111
cvexczonlin:(TR)=float:(LINE)#         Draw the exclusion line          PO07 112
ifnm:(BUFIN(3))cvexcdatlev:(TR)=db:(BUFIN(2))#                          PO07 113
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PO07 114
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PO07 115
#                                                                       PO07 116
#                                                                       PO07 117
ELSEIF(LINID==5)#                      -------a hkl bar line            PO07 118
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PO07 119
#                                                                       PO07 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PO07 121
#                                                                       PO07 122
#                                                                       PO07 123
ELSEIF(LINID==6)#                      -------an axis line              PO07 124
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PO07 125
AXIS=1#                                Assume the x axis                PO07 126
ifch:(BUFIN(1))#                                                        PO07 127
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PO07 128
stringlim:(1,J,K)#                     Get string limits                PO07 129
IF(CHRIN(J^J)=='Y')AXIS=2#             Change to y axis                 PO07 130
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PO07 131
ifnm:(BUFIN(2))axmin:(AXIS)=db:(BUFIN(2))#                              PO07 132
ifnm:(BUFIN(3))axmax:(AXIS)=db:(BUFIN(3))#                              PO07 133
ifch:(BUFIN(4))#                                                        PO07 134
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PO07 135
ax1posn:(AXIS)=float:(no:)#            Not at top                       PO07 136
ax0posn:(AXIS)=float:(no:)#            Not at bottom                    PO07 137
stringlim:(4,J,K)#                     Get string limits                PO07 138
IF(AXIS==1)compchar:(CHRIN,J,PO3,1,3,4,NPO3,L)# Compare top bot or ta   PO07 139
ELSE       compchar:(CHRIN,J,PO4,1,3,4,NPO4,L)# Compare top bot or ta   PO07 140
IF    (L==1)ax1posn:(AXIS)=float:(yes:)# Draw at top                    PO07 141
ELSEIF(L==2)ax0posn:(AXIS)=float:(yes:)# Draw at bottom                 PO07 142
ELSEIF(L==3)#                          Draw at top and bottom           PO07 143
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PO07 144
ax1posn:(AXIS)=float:(no:)#            Draw at top                      PO07 145
ax0posn:(AXIS)=float:(no:)#            Draw at bottom                   PO07 146
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PO07 147
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PO07 148
ifnm:(BUFIN(5))   axtsize:(AXIS)=dabs:(BUFIN(5))# Size axis text labe   PO07 149
ifnm:(BUFIN(6))axtxorigin:(AXIS)= db:(BUFIN(6))# X origin of axis tex   PO07 150
ifnm:(BUFIN(7))axtyorigin:(AXIS)= db:(BUFIN(7))# Y origin of axis tex   PO07 151
ifnm:(BUFIN(8))  axtangle:(AXIS)= db:(BUFIN(8))# Angle of axis text l   PO07 152
ifch:(BUFIN(9))#                       Tick mark labels at top/bot      PO07 153
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PO07 154
axlt1posn:(AXIS)=float:(no:)#          Not at top                       PO07 155
axlt0posn:(AXIS)=float:(no:)#          Not at bottom                    PO07 156
stringlim:(9,J,K)#                     Get string limits                PO07 157
IF(AXIS==1)compchar:(CHRIN,J,PO3,1,3,4,NPO3,L)# Compare top bot or ta   PO07 158
ELSE       compchar:(CHRIN,J,PO4,1,3,4,NPO4,L)# Compare top bot or ta   PO07 159
IF    (L==1)axlt1posn:(AXIS)=float:(yes:)# Draw at top                  PO07 160
ELSEIF(L==2)axlt0posn:(AXIS)=float:(yes:)# Draw at bottom               PO07 161
ELSEIF(L==3)#                          Draw at top and bottom           PO07 162
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PO07 163
axlt1posn:(AXIS)=float:(no:)#          Draw at top                      PO07 164
axlt0posn:(AXIS)=float:(no:)#          Draw at bottom                   PO07 165
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PO07 166
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PO07 167
ifnm:(BUFIN(10)) axlnumdecplac:(AXIS)=db:(BUFIN(10))#                   PO07 168
ifnm:(BUFIN(11))axlcentredigit:(AXIS)=db:(BUFIN(11))#                   PO07 169
ifnm:(BUFIN(12))  axldispxcent:(AXIS)=db:(BUFIN(12))#                   PO07 170
ifnm:(BUFIN(13))  axldispxcent:(AXIS)=db:(BUFIN(13))#                   PO07 171
ifnm:(BUFIN(14))    axlticsize:(AXIS)=db:(BUFIN(14))#                   PO07 172
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PO07 173
#                                                                       PO07 174
#                                                                       PO07 175
ELSEIF(LINID==7)#                      -------an axis text line         PO07 176
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PO07 177
AXIS=1#                                Assume the x axis                PO07 178
K=8#                                                                    PO07 179
ifch:(BUFIN(1))#                       Test for x/y marker              PO07 180
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PO07 181
stringlim:(1,J,K)#                     Get string limits                PO07 182
IF(CHRIN(J^J)=='Y')AXIS=2#             Change to y axis                 PO07 183
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PO07 184
axtlabel:(AXIS)=float:(yes:)#          Abscissa label exists            PO07 185
DO I=mxchim:,K,-1;IF(CHRIP(I^I)!=' ')BREAK# Find first non blank        PO07 186
IF(AXIS==1)ABSLAB(PT)=CHRIP(K^I)#      Copy to abscissa label list      PO07 187
ELSE       ORDLAB(PT)=CHRIP(K^I)#      Copy to ordinate label list      PO07 188
axtcharnum:(AXIS)=float:(I-7)#         Get number of characters(-8+1)   PO07 189
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PO07 190
#                                                                       PO07 191
#                                                                       PO07 192
#ELSEIF(LINID==8) ;#                   -------A TICK MARK LINE          PO07 193
#$(                                                                     PO07 194
#TICKMK                                                                 PO07 195
#$)                                                                     PO07 196
#                                                                       PO07 197
#                                                                       PO07 198
ELSEIF(LINID==9)#                      -------a grid line               PO07 199
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PO07 200
grxdisplay:=FLOAT(yes:)#               Change to y axis                 PO07 201
grydisplay:=FLOAT(yes:)#               Change to y axis                 PO07 202
grxtied:=FLOAT(yes:)#                  Assume tied to axes              PO07 203
grytied:=FLOAT(yes:)#                  Assume tied to axes              PO07 204
DO I=1,2#                                                               PO07 205
ifch:(BUFIN(I))#                                                        PO07 206
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PO07 207
stringlim:(I,J,K)#                     Get string limits                PO07 208
IF(CHRIN(J^J)=='N'&I==1)grxdisplay:=FLOAT(no:)# Change to               PO07 209
IF(CHRIN(J^J)=='N'&I==2)grydisplay:=FLOAT(no:)# Change to               PO07 210
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PO07 211
DO I=3,4#                                                               PO07 212
ifch:(BUFIN(I))#                                                        PO07 213
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PO07 214
stringlim:(I,J,K)#                     Get string limits                PO07 215
compchar:(CHRIN,J,PO6,1,4,5,NPO6,L)#   Compare top bot or tab           PO07 216
IF    (L==2&I==3) grxtied:=FLOAT(no:)#                                  PO07 217
ELSEIF(L==2&I==4) grytied:=FLOAT(no:)#                                  PO07 218
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PO07 219
ifnm:(BUFIN(5))  grvlines:=ABS(BUFIN(5))#                               PO07 220
ifnm:(BUFIN(6))  grhlines:=ABS(BUFIN(6))#                               PO07 221
ifnm:(BUFIN(7))   grcolor:=ABS(BUFIN(7))#                               PO07 222
ifnm:(BUFIN(8))  grlinest:=ABS(BUFIN(8))#                               PO07 223
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PO07 224
#                                                                       PO07 225
#                                                                       PO07 226
ELSEIF(LINID==10)#                     -------a graph title line        PO07 227
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PO07 228
ifnm:(BUFIN(1))tixorigin: = db:(BUFIN(1))# X origin of graph title      PO07 229
ifnm:(BUFIN(2))tiyorigin: = db:(BUFIN(2))# Y origin of graph title      PO07 230
ifnm:(BUFIN(3))  tiangle: = db:(BUFIN(3))# Angle of graph title text    PO07 231
ifnm:(BUFIN(4))   tisize: =dabs:(BUFIN(4))# Size of graph title text    PO07 232
ifnm:(BUFIN(5))  ticolor: =dabs:(BUFIN(5))# Color of graph title text   PO07 233
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PO07 234
#                                                                       PO07 235
#                                                                       PO07 236
ELSEIF(LINID==11)#                     -------a graph title text line   PO07 237
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PO07 238
tidisplay:=float:(yes:)#               Display title                    PO07 239
DO I=mxchim:,8,-1;IF(CHRIP(I^I)!=' ')BREAK# Find first non blank        PO07 240
TITLET(PT)=CHRIP(8^I)#                                                  PO07 241
tichars:=float:(I-7)#                  Get number of characters(-8+1)   PO07 242
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PO07 243
#                                                                       PO07 244
#                                                                       PO07 245
ELSEIF(LINID==12) ;#                   -------a legend line             PO07 246
ELSEIF(LINID==13)#                     -------a curve trace line        PO07 247
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PO07 248
TR=2#                                                                   PO07 249
ifch:(BUFIN(1))#                       Test for a phase identifier      PO07 250
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 PO07 251
stringlim:(1,J,K)#                                                      PO07 252
compchar:(CHRIN,J,PO2,2,3,4,NPO2,TR)#  Test for cu, mo                  PO07 253
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 PO07 254
IF(TR<=0)iquit:(PO0703,1)#             Unidentified trace type          PO07 255
cvdisplay:(TR)=FLOAT(yes:)#                                             PO07 256
ifnm:(BUFIN(2))cvlncolor:(TR)=(BUFIN(2))#                               PO07 257
ifnm:(BUFIN(2))cvmkcolor:(TR)=(BUFIN(2))#                               PO07 258
ifnm:(BUFIN(3))    cvshx:(TR)=(BUFIN(3))#                               PO07 259
ifnm:(BUFIN(4))    cvshy:(TR)=(BUFIN(4))#                               PO07 260
ifnm:(BUFIN(3))  cvshift:(TR)=FLOAT(yes:)#                              PO07 261
ifnm:(BUFIN(4))  cvshift:(TR)=FLOAT(yes:)#                              PO07 262
ifnm:(BUFIN(5))cvauxscal:(TR)=(BUFIN(5))#                               PO07 263
ifch:(BUFIN(6))#                                                        PO07 264
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 PO07 265
stringlim:(6,J,K)#                                                      PO07 266
IF(CHRIN(J^J)=='Y')cvdivbysig:(TR)=FLOAT(yes:)#                         PO07 267
ELSE               cvdivbysig:(TR)=FLOAT(no:)#                          PO07 268
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 PO07 269
ifnm:(BUFIN(7))  cvlinedl:(TR)=(BUFIN(7))#                              PO07 270
ifnm:(BUFIN(8))  cvlinebl:(TR)=(BUFIN(8))#                              PO07 271
ifnm:(BUFIN(7))  cvlinest:(TR)=2.E00#                                   PO07 272
ifnm:(BUFIN(8))  cvlinest:(TR)=2.E00#                                   PO07 273
ifnm:(BUFIN(9))cvmarkerst:(TR)=(BUFIN(9))#                              PO07 274
ifch:(BUFIN(10))#                                                       PO07 275
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 PO07 276
stringlim:(10,J,K)#                                                     PO07 277
IF(CHRIN(J^J)=='Y')cvpredatlin:(TR)=FLOAT(yes:)#                        PO07 278
ELSE               cvpredatlin:(TR)=FLOAT(no:)#                         PO07 279
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 PO07 280
ifnm:(BUFIN(11))cvpredatlev:(TR)=(BUFIN(11))#                           PO07 281
ifch:(BUFIN(12))#                                                       PO07 282
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 PO07 283
stringlim:(12,J,K)#                                                     PO07 284
IF(CHRIN(J^J)=='Y')cvposdatlin:(TR)=FLOAT(yes:)#                        PO07 285
ELSE               cvposdatlin:(TR)=FLOAT(no:)#                         PO07 286
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 PO07 287
ifnm:(BUFIN(13))cvposdatlev:(TR)=(BUFIN(13))#                           PO07 288
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PO07 289
#                                                                       PO07 290
#                                                                       PO07 291
ELSEIF(LINID==14) ;#                   -------a trace text line         PO07 292
#                                                                       PO07 293
readline:(PO1,-NPO1)#                  Check for phase control line     PO07 294
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO07 295
#                                                                       PO07 296
#                                                                       PO07 297
IF(GR<1)#                              Apply graph one to all graphs    PO07 298
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 PO07 299
DO I=PT+1,maxgn:#                      Cycle over the rest of the gra   PO07 300
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 PO07 301
DO J=1,20;   GRID(I,J)=  GRID(PT,J)#   Copy grid settings               PO07 302
DO J=1,20; LEGEND(I,J)=LEGEND(PT,J)#   Copy legend settings             PO07 303
DO J=1,20; GTITLE(I,J)=GTITLE(PT,J)#   Copy grid settings               PO07 304
DO J=2,20;  GRAPH(I,J)= GRAPH(PT,J)#   Copy grid settings               PO07 305
DO J=1,50;DO K=1,2;         AXES(I,K,J)=AXES(PT,K,J)# Copy axes setti   PO07 306
DO J=1,40;DO K=1,6+maxpha:;CURVE(I,K,J)=CURVE(PT,K,J)# Copy curve set   PO07 307
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 PO07 308
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 PO07 309
#                                                                       PO07 310
#                                                                       PO07 311
RETURN#                                                                 PO07 312
END#                                                                    PO07 313
systemheader:(PO10)#                   Enter cell, symm, expl, dset     PO10   1
####################################################################    PO10   2
#                                                                  #    PO10   3
#                               PO10                               #    PO10   4
#                                                                  #    PO10   5
####################################################################    PO10   6
SUBROUTINE PO10#                                                        PO10   7
#                                                                       PO10   8
include:(AACOMN)#                                                       PO10   9
include:(POCOMN)#                                                       PO10  10
#                                                                       PO10  11
INTEGER IP,I,J,K,M,N#                                                   PO10  12
INTEGER ISCF,MARK,LPAK,IPT#                                             PO10  13
#                                                                       PO10  14
chardata:(PO1, PHASE PEAK HWIDTH PASYMM ORIENT $#                       PO10  15
SELECT CONSTR NOREF RESTR END )#                                        PO10  16
datastuff:#                                                             PO10  17
#                                                                       PO10  18
#   START OF NEW CRYSTAL PHASE                                          PO10  19
#   --------------------------                                          PO10  20
#                                                                       PO10  21
IF(NPH>maxpha:) iquit:(PO1000)#        Max phases -- ip error?          PO10  22
#                                                                       PO10  23
#    STORE DEFAULT PARAMETERS                                           PO10  24
#    ------------------------                                           PO10  25
#                                                                       PO10  26
PHASE(NPH)=SAVEID#                     Compid is default phase          PO10  27
SFCALC(NPH)=yes:#                      Structure factor calc needed     PO10  28
dset:=1.#                              Default dataset number           PO10  30
scal:=1.#                              Default sf scale per phase       PO10  31
scalflg:=FLGSKF#                       Default refine scale factor      PO10  32
PARPOF(NPH)=0.0#                       Preferred orient parameter       PO10  33
DO I=1,3;  POFVEC(NPH,I)=0.0#          Preferred orient vector          PO10  34
DO I=1,6;  REFPRO(NPH,I)=FLGPRO#       Peak profile refinement flags    PO10  35
DO I=2,6;  PARPRO(NPH,I)=0.0#          Peak profile parameters          PO10  36
PARPRO(NPH,1)=0.01#                    Default hwifth u parameter       PO10  37
pkprofnr:=11.#                         Default gaussian peak profile    PO10  38
#                                                                       PO10  39
#                                                                       PO10  40
IF(LINID==1)#                          ******** phase ***********       PO10  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO10  42
DO I=1,2#                              Loop input fields                PO10  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO10  44
ifvo:(BUFIN(I)) BREAK#                 Exit on blank                    PO10  45
ifch:(BUFIN(I))#                       If char string                   PO10  46
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO10  47
stringlim:(I,J,K)#                     Get string limits                PO10  48
PHASE(NPH)=CHRIP(J^K)#                 Store new phase code             PO10  49
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO10  50
ELSE#                                  Its a number                     PO10  51
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO10  52
scal:=BUFIN(I)#                        Store phase scale                PO10  53
AUTSKF=no:#                            No autoscaling required          PO10  54
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO10  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO10  56
ifnm:(BUFIN(3)) ADISP(NPH)=MIN(1.,MAX(BUFIN(3),0.0))# Temp disper sca   PO10  57
readline:(PO1,-NPO1)#                  Read another input line          PO10  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO10  59
#                                                                       PO10  60
#      OPEN THE APPROPRIATE ARCHIVE BDF                                 PO10  61
#      --------------------------------                                 PO10  62
#                                                                       PO10  63
COMPID=PHASE(NPH)#                     Set current compid               PO10  64
CRVLAB(6+NPH)(10^)=PHASE(NPH)#         Phase id string          
mcell:=NEWM;  ncell:=9#                Start of cell data               PO10  65
incrqx:(NEWM,NEWM+100,PO1001)#         Memory for cell data             PO10  66
#                                                                       PO10  67
#      READ LRCELL: DATA                                                PO10  68
#      -----------------                                                PO10  69
#                                                                       PO10  70
DO I=1,8#                              Loop over cell packets           PO10  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO10  72
readwpkt:(1,lrcell:,PACK,IP,0)#        Cell information                 PO10  73
IF(IP<=0) iquit:(PO1002)#              Insufficient cell packets        PO10  74
IF(I==1) movereal:(QX,IP+1,dcp:,1,9,0)# Direct cell parameters          PO10  75
IF(I==2) movereal:(QX,IP+1,dce:,1,9,0)# Direct cell esd's               PO10  76
IF(I==3) movereal:(QX,IP+1,rcp:,1,9,0)# Reciprocal cell parameters      PO10  77
IF(I==4) movereal:(QX,IP+1,tfc:,1,9,0)# Transformation fract to cart    PO10  78
IF(I==5) movereal:(QX,IP+1,tcf:,1,9,0)# Transformation cart to fract    PO10  79
IF(I==7) movereal:(QX,IP+1,dmt:,1,9,0)# Dmt direct metric tensor        PO10  80
IF(I==8) movereal:(QX,IP+1,rmt:,1,9,0)# Rmt recipr metric tensor        PO10  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO10  82
DO I=1,3#                              Loop over axes/angles            PO10  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO10  84
cub:(I)=.25*rcp:(I)**2#                Conversion u to beta             PO10  85
cbu:(I)=1.266515/cub:(I)#              Conversion beta to 100*u         PO10  86
dcp:(I+6)=360.*dcp:(I+6)#              Dcp cycles to deg                PO10  87
rcp:(I+6)=360.*rcp:(I+6)#              Rcp cycles to deg                PO10  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO10  89
cub:(4)=.25*rcp:(1)*rcp:(2)*rcp:(6)#   Conversion u to beta             PO10  90
cub:(5)=.25*rcp:(1)*rcp:(3)*rcp:(5)#   Conversion u to beta             PO10  91
cub:(6)=.25*rcp:(2)*rcp:(3)*rcp:(4)#   Conversion u to beta             PO10  92
cbu:(4)=5.06606/(rcp:(1)*rcp:(2))#     Conversion beta to u             PO10  93
cbu:(5)=5.06606/(rcp:(1)*rcp:(3))#     Conversion beta to u             PO10  94
cbu:(6)=5.06606/(rcp:(2)*rcp:(3))#     Conversion beta to u             PO10  95
DO I=1,3#                              Sine theta conversion            PO10  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO10  97
stc:(I)  =cub:(I)#                     .25*(a*)sq etc.                  PO10  98
stc:(I+3)=2.*cub:(I+3)#                .5*(a*)(b*)(cosc*) etc.          PO10  99
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO10 100
#                                                                       PO10 101
#     READ LRSYMM: DATA                                                 PO10 102
#     -----------------                                                 PO10 103
#                                                                       PO10 104
lcell:=NEWM;   MARK=NEWM#              End of cell data                 PO10 105
msymm:=MARK;   nsymm:=12#              Start of symmetry packets        PO10 106
FOR(;MARK>0;MARK=NEWM)#                Loop over rot. matrices          PO10 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PO10 108
readwpkt:(1,lrsymm:,PACK,IP,0)#        Read next symmetry packet        PO10 109
IF(IP<=0) BREAK#                       Exit after last packet           PO10 110
incrqx:(NEWM,MARK+nsymm:,PO1004)#      Get memory                       PO10 111
movereal:(QX,IP+1,QX,MARK+1,12,0)#     Move rotation matrix+vector      PO10 112
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PO10 113
#                                                                       PO10 114
#    SET CELL REFINEMENT PARAMETERS                                     PO10 115
#    ------------------------------                                     PO10 116
#                                                                       PO10 117
I=msymm:;  N=QX(I+9);   M=QX(I+10)#    Extract crystal system & axis    PO10 118
J=MOD(M,3)+1;   K=MOD(J,3)+1#          Get alternative axes             PO10 119
DO I=1,6; REFCEL(NPH,I)=0#             Set all cell par noref           PO10 120
#IF(FLGCEL==YES:)#                      IF CELL REFINED                 PO10 121
#$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8 PO10 122
#IF(N==1)      DO I=1,6; REFCEL(NPH,I)=1# TRI REFINE ALL PARAMETERS     PO10 123
#IF(N==2\N==3) DO I=1,3; REFCEL(NPH,I)=1# MON/ORT REFINE A B C          PO10 124
#IF(N==2\N==6) REFCEL(NPH,M+3)=1#       MON/RHOM REFINE UNIQUE ANGLE    PO10 125
#IF(N==6)      REFCEL(NPH,J+3)=M+13#    RHOM DEPENDENT ANGLE            PO10 126
#IF(N==6)      REFCEL(NPH,K+3)=M+13#    RHOM DEPENDENT ANGLE            PO10 127
#IF(N==4\N==5\N==7)#                    FOR TET/TRIG/HEX                PO10 128
#$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9 PO10 129
#REFCEL(NPH,M)=1; REFCEL(NPH,J)=1; REFCEL(NPH,K)=J+10# TWO CELL LENGTH  PO10 130
#$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9 PO10 131
#IF(N==6\N==8)#                         FOR RHOM/CUB                    PO10 132
#$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1 PO10 133
#REFCEL(NPH,1)=1; REFCEL(NPH,2)=11; REFCEL(NPH,3)=11# ONE CELL LENGTH   PO10 134
#$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1 PO10 135
#$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8 PO10 136
#                                                                       PO10 137
#     READ LRSCAT: DATA                                                 PO10 138
#     -----------------                                                 PO10 139
#                                                                       PO10 140
lsymm:=NEWM;    MARK=NEWM#             Save end of scat factors         PO10 141
mscat:=MARK#                           Start of scat factors            PO10 142
IWNT(1)=NINT(dset:)+20;  IWNT(3)=100#  Set real ad & ff idnums          PO10 143
IWNT(2)=NINT(dset:)+60;  IWNT(4)=10#   Set imag ad & neut ff            PO10 144
IWNT(5)=11 ;  IWNT(6)=7; IWNT(7)=1#    Set sf name idnum                PO10 145
setkey:(1,7,0,0)#                      Set search signals               PO10 146
indexpkt:(1,lrscat:,PACK,IP,0,KEY,IWNT,IREL)# Get pointers              PO10 147
IF(IP<=0) iquit:(PO1005)#              No lrscat packet there           PO10 148
#                                                                       PO10 149
FOR(I=IP+IREL(3);I<=IP+PACK;I=I+1)#    Loop over ff list                PO10 150
IF((QX(I)<99.5)\(QX(I)>299.5)) BREAK#  Exit after last ff               PO10 151
IF(IREL(3)>0) ISCF=I-IP-IREL(3)#       Count contiguous ff              PO10 152
ELSE          ISCF=0#                  Ff table not present             PO10 153
IF(IREL(4)>0) ISCF=1#                  Count neutron ff                 PO10 154
IF(IREL(3)>0) DSCF=(QX(I-1)-QX(I-2))*.01# Set st/l interval             PO10 155
nscat:=ISCF+5;   NSCF=0#               Set stored packet size           PO10 156
#                                                                       PO10 157
FOR(J=MARK;J>0;J=NEWM)#                Loop over each atom type         PO10 158
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PO10 159
readwpkt:(1,lrscat:,LPAK,IP,0)#        Get packet pointer               PO10 160
IF(IP<=0) BREAK#                       Exit after last packet           PO10 161
incrqx:(NEWM,J+nscat:,PO1008)#         Get packet memory                PO10 162
movereal:(QX(IP+IREL(5)),1,QX,J+1,2,0)# Store scat fac name             PO10 163
I=IP+IREL(7); IF(I>IP) ifnv:(QX(I)) QX(J+3)=QX(I)# Get atoms/cell       PO10 164
I=IP+IREL(1); IF(I>IP) ifnv:(QX(I)) QX(J+4)=QX(I)# Get real disp        PO10 165
I=IP+IREL(2); IF(I>IP) ifnv:(QX(I)) QX(J+5)=QX(I)# Get imag disp        PO10 166
I=IP+IREL(4); IF(I>IP) ifnv:(QX(I)) QX(J+6)=QX(I)# Store neutron ff     PO10 167
IF(ISCF>1)DO I=1,ISCF; QX(J+I+5)=QX(IP+IREL(3)+I-1)# Store scat fact    PO10 168
IF(IREL(6)>0) BDFSCF=NINT(QX(IP+IREL(6)))# Lrrefl: ff flag present      PO10 169
ELSE          BDFSCF=no:#              Ff are not in lrrefl:            PO10 170
NSCF=NSCF+1#                           Count atom types                 PO10 171
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PO10 172
#                                                                       PO10 173
#     READ LREXPL: DATA                                                 PO10 174
#     -----------------                                                 PO10 175
#                                                                       PO10 176
IWNT(1)=1;  IWNT(2)=94#                Set radiation type               PO10 177
DO I=1,7;IWNT(2+I)=I+1#                Get radiation wavelength info    PO10 178
setkey:(2,9,0,0)#                      Set search signals               PO10 179
indexpkt:(1,lrexpl:,PACK,IP,0,KEY,IWNT,IREL)# Search directory          PO10 180
IF(IP<=0) iquit:(PO1010)#              Lrexpl: not there                PO10 181
REPEAT#                                Loop over lrexpl pkts            PO10 182
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PO10 183
readwpkt:(1,lrexpl:,PACK,IP,0)#        Read lrexpl: packet              PO10 184
IF(IP<=0) BREAK#                       Lr ended too soon                PO10 185
ifne:(dset:,QX(IP+IREL(1))) NEXT#      Skip incorrect datasets          PO10 186
DO I=1,8#                              For all wavelength params        PO10 187
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PO10 188
IPT=IP+IREL(1+I)#                      Save radiation type              PO10 189
IF(IPT>IP)WAVLEN(NPH,I)=QX(IPT)#       And all wavelength info          PO10 190
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PO10 191
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PO10 192
IF(WAVSEL==no:&NPH==1)#                Wavelength not specif requeste   PO10 193
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PO10 194
RADTYP=NINT(WAVLEN(1,1))#              Radiation type
LAMBDA=WAVLEN(1,2)#                    Mean wavelength                  PO10 196
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PO10 197
#                                                                       PO10 198
#     READ LRDSET: DATA                                                 PO10 199
#     -----------------                                                 PO10 200
#                                                                       PO10 201
IWNT(1)=1;  IWNT(2)=2#                 Set uov                          PO10 202
setkey:(2,0,0,0)#                      Set search signals               PO10 203
indexpkt:(1,lrdset:,PACK,IP,0,KEY,IWNT,IREL)# Search directory          PO10 204
IF(IP<=0) iquit:(PO1011)#              Lrdset: not there                PO10 205
REPEAT#                                Loop over lrdset pkts            PO10 206
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PO10 207
readwpkt:(1,lrdset:,PACK,IP,0)#        Read lrdset: packet              PO10 208
IF(IP<=0) BREAK#                       Lr ended too soon                PO10 209
ifne:(dset:,QX(IP+IREL(1))) NEXT#      Skip incorrect datasets          PO10 210
UOV(NPH)=(QX(IP+IREL(2)))#             Store uov                        PO10 211
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PO10 212
#                                                                       PO10 213
#    STORE PREFERRED ORIENT & PEAK PROFILE PARAMETERS                   PO10 214
#    ------------------------------------------------                   PO10 215
#                                                                       PO10 216
lscat:=NEWM;     MARK=NEWM#            End of atom type data            PO10 217
mpeak:=MARK;     npeak:=16#            Start of halfwidth parameters    PO10 218
incrqx:(NEWM,MARK+npeak:,PO1022)#      Get memory for halfwidth         PO10 219
DO I=1,npeak:;  QX(MARK+I)=0.0#        Default values                   PO10 220
#                                                                       PO10 221
REPEAT#                                Loop over peak option lines      PO10 222
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PO10 223
#                                                                       PO10 224
IF(LINID==2)#                          ********** peak **********       PO10 225
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PO10 226
QX(MARK+1)=pkprofnr:#                  Default profile function         PO10 227
QX(MARK+2)=PEAKSP#                     Default peak span                PO10 228
QX(MARK+11)=PARPRO(NPH,6)#             Default mixing parameter         PO10 229
ifnm:(BUFIN(1)) QX(MARK+1)=BUFIN(1)#   Store peak shape function id     PO10 230
ifch:(BUFIN(1))#                                                        PO10 231
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PO10 232
stringlim:(1,J,K)#                     Get string limits                PO10 233
IF(CHRIP(J^J)=='v') QX(MARK+1)=12.#    Pseudo-voigt                     PO10 234
IF(CHRIP(J^J)=='g') QX(MARK+1)=11.#    Gaussian                         PO10 235
IF(CHRIP(J^J)=='l') QX(MARK+1)=10.#    Lorentzian                       PO10 236
IF((QX(MARK+1)<10.)\(QX(MARK+1)>12.)) iquit:(PO1030)# Unknown peakfn    PO10 237
QX(MARK+11)=QX(MARK+1)-10.#            Default mixing parameter         PO10 238
IF(CHRIP(J^J)=='v') QX(MARK+11)=0.5#   Default mixing parameter         PO10 239
IF(CHRIP(J^J)!='v') REFPRO(NPH,6)=no:# Force noref mix                  PO10 240
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PO10 241
ifnm:(BUFIN(2)) QX(MARK+2)=BUFIN(2)#   Store peak span                  PO10 242
ifnm:(BUFIN(3)) QX(MARK+11)=BUFIN(3)#  Store mixing parameter           PO10 243
span:=QX(MARK+2)#                      Store peak span                  PO10 244
PARPRO(NPH,6)=QX(MARK+11)#             Store mix                        PO10 245
pkprofnr:=QX(MARK+1)#                  Store function id                PO10 246
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PO10 247
#                                                                       PO10 248
ELSE IF(LINID==3)#                     ********** hwidth **********     PO10 249
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PO10 250
DO I=1,3; ifnm:(BUFIN(I)) PARPRO(NPH,I)=BUFIN(I)# Loop over the field   PO10 251
DO I=1,3; QX(MARK+I+2)=PARPRO(NPH,I)#  Store half width params u v w    PO10 252
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PO10 253
#                                                                       PO10 254
ELSE IF(LINID==4)#                     ********** pasymm **********     PO10 255
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PO10 256
DO I=1,2; ifnm:(BUFIN(I)) PARPRO(NPH,I+3)=BUFIN(I)# Loop over the fie   PO10 257
DO I=1,2; QX(MARK+I+5)=PARPRO(NPH,I+3)# Store peak asym params hw1 hw   PO10 258
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PO10 259
#                                                                       PO10 260
ELSE IF(LINID==5)#                     ********** orient **********     PO10 261
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PO10 262
ifnm:(BUFIN(1)) PARPOF(NPH)=BUFIN(1)#  Preferred orient factor          PO10 263
QX(MARK+8)=PARPOF(NPH)#                Store pref orient factor         PO10 264
DO I=1,3; ifnm:(BUFIN(I+1)) POFVEC(NPH,I)=BUFIN(I+1)# Pof vector        PO10 265
DO I=1,3; QX(MARK+I+8)=POFVEC(NPH,I)#  Store pof vector uvw             PO10 266
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PO10 267
ELSE BREAK#                            Exit if not peak parameter       PO10 268
#                                                                       PO10 269
LINFLG=ABS(LINFLG)#                    Done with last line, try next    PO10 270
readline:(PO1,-NPO1)#                  Read next line                   PO10 271
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PO10 272
#                                                                       PO10 273
RETURN#                                                                 PO10 274
END#                                                                    PO10 275
systemheader:(PO11)#                   Enter atom data                  PO11   1
####################################################################    PO11   2
#                                                                  #    PO11   3
#                               PO11                               #    PO11   4
#                                                                  #    PO11   5
####################################################################    PO11   6
SUBROUTINE PO11#                                                        PO11   7
include:(AACOMN)#                                                       PO11   8
include:(POCOMN)#                                                       PO11   9
#                                                                       PO11  10
INTEGER I,J,K,JJ#                                                       PO11  11
INTEGER MARK,IP,IA,ID,ISEL,ISEQ#                                        PO11  12
string:(NAME1,24)#                                                      PO11  13
string:(NAME2,24)#                                                      PO11  14
string:(LABEL,24)#                                                      PO11  15
chardata:(PO1, PHASE PEAK HWIDTH PASYMM ORIENT $#                       PO11  16
SELECT CONSTR NOREF RESTR END )#                                        PO11  17
datastuff:#                                                             PO11  18
#                                                                       PO11  19
#    READ LRATOM: DATA                                                  PO11  20
#    -----------------                                                  PO11  21
#                                                                       PO11  22
lpeak:=NEWM;   MARK=NEWM#              End of width packets             PO11  23
matom:=MARK;   natom:=w24c:+17#        Start of atom packets            PO11  24
IWNT(1)=17#                            Request dataset pointer          PO11  25
IWNT(2)=21#                            Request atom multiplicity        PO11  26
IWNT(3)=22#                            Request scat fact number         PO11  27
IWNT(4)=23#                            Request tf type                  PO11  28
IWNT(5)=24#                            Request atom group key           PO11  29
IWNT(6)=25#                            Spare (used for f')              PO11  30
IWNT(7)=26#                            Spare (used for f'')             PO11  31
DO I=1,11;    IWNT(I+ 7)=I#            Request x y z u uij pop          PO11  32
DO I=1,w24c:; IWNT(I+18)=14#           Request atom label               PO11  33
setkey:(0,natom:+1,0,0)#               Set search signals               PO11  34
indexpkt:(1,lratom:,PACK,IP,0,KEY,IWNT,IREL)# Search directory          PO11  35
ISEL=no:;  JJ=0#                       Initialise atom selection        PO11  36
#                                                                       PO11  37
FOR(IA=MARK;IA>0;IA=NEWM)#             Loop over atom packets           PO11  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO11  39
readwpkt:(1,lratom:,PACK,IP,0)#        Read an atom packet              PO11  40
IF(IP<=0) BREAK#                       End of logical record            PO11  41
IF(IREL(1)>0) ifne:(dset:,QX(IP+IREL(1))) NEXT# Check dataset           PO11  42
#                                                                       PO11  43
WHILE(LINID==6&ISEL==no:)#             ******** select *************    PO11  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO11  45
ifvo:(BUFIN(JJ+1))#                    Test if end of data              PO11  46
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO11  47
LINFLG=ABS(LINFLG)#                    Done with last line, try next    PO11  48
readline:(PO1,-NPO1)#                  Read the next line               PO11  49
ISEQ=no:;  JJ=0;  NEXT#                Reset select pointers            PO11  50
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO11  51
JJ=JJ+1#                               Incr field pointer               PO11  52
ifnm:(BUFIN(JJ)) iquit:(PO1105)#       Number in select line            PO11  53
stringlim:(JJ,J,K)#                    Get string limits                PO11  54
DO J=I,K-1; IF(CHRIP(I^I)=='/') BREAK# Search for separator             PO11  55
NAME1=CHRIP(I^J-1)#                    Store first name                 PO11  56
IF(J<K) NAME2=CHRIP(J+1^K-1)#          Store second name                PO11  57
ELSE    NAME2=' '#                     Blank if no 2nd name             PO11  58
ISEQ=yes:#                             Set sequence flag                PO11  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO11  60
movertoc:(QX(IP+IREL(19)),1,LABEL,1,24,0)# Store atom label             PO11  61
IF(ISEL!=no:)#                         Is select in force?              PO11  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO11  63
IF(J<K)#                               Is it a single label             PO11  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO11  65
IF(NAME1!=LABEL) NEXT#                 Skip if no match                 PO11  66
ISEL=no:#                              Reset the selection flag         PO11  67
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO11  68
ELSE#                                  It is a sequence of labels       PO11  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO11  70
IF(ISEL==1)#                           Find first label in sequence     PO11  71
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO11  72
IF(NAME1!=LABEL) NEXT#                 Skip if no match                 PO11  73
ISEL=2#                                Reset as start of sequence       PO11  74
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO11  75
ELSE IF(NAME2==LABEL) ISEL=no:#        Find last label in sequence      PO11  76
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO11  77
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO11  78
#                                                                       PO11  79
incrqx:(NEWM,IA+natom:,PO1130)#        Get atom packet memory           PO11  80
QX(IA+17)=1.0#                         default pop/pp: if missing
DO I=1,natom:; IF(IREL(I+1)>0)#        Loop over requested atom data    PO11  81
movereal:(QX,IP+IREL(I+1),QX,IA+I,1,0)# Store atom data word            PO11  82
ID=mscat:+nscat:*(NINT(sf:)-1)+4#      Point to scat factor table       PO11  83
dr:=QX(ID);    di:=QX(ID+1)#           Store dispersion terms           PO11  84
ifeq:(dp:,2.)  QX(IA+10  )=voidflg:#   Void uiso if aniso dp            PO11  85
ELSE DO I=1,6; QX(IA+10+I)=voidflg:#   Void uij if uiso                 PO11  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO11  87
#                                                                       PO11  88
#    INPUT CONSTRAINTS FROM LRCONS:                                     PO11  89
#    ------------------------------                                     PO11  90
#                                                                       PO11  91
latom:=NEWM;    MARK=NEWM#             End of atom packets              PO11  92
mcons:=NEWM;    ncons:=8#              Start of constraints data        PO11  93
DO I=1,3; IWNT(I  )=I#                 Subj labl/par/mul                PO11  94
DO I=1,3; IWNT(I+3)=I+10#              Ref  labl/par/mul                PO11  95
DO I=1,2; IWNT(I+6)=I+3#               Constant q & type                PO11  96
setkey:(8,0,0,0)#                      Set search signals               PO11  97
indexpkt:(1,lrcons:,PACK,IP,0,KEY,IWNT,IREL)# Search directory          PO11  98
IF(IP>0)#                              If constraints present           PO11  99
FOR(J=MARK;J>0;J=NEWM)#                Loop all the packets             PO11 100
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PO11 101
readwpkt:(1,lrcons:,PACK,IP,0)#        Read next constraint pkt         PO11 102
IF(IP<=0) BREAK#                       End of logical record            PO11 103
incrqx:(NEWM,J+8,PO1130)#              Get constraints packet           PO11 104
DO I=1,8; movereal:(QX,IP+IREL(I),QX,J+I,1,0)# Store constraints        PO11 105
IF(QX(J+2)>3.) QX(J+2)=QX(J+2)+1.#     Shift uij 4-9 to 5-10            PO11 106
IF(QX(J+5)>3.) QX(J+5)=QX(J+5)+1.#     Shift uij 4-9 to 5-10            PO11 107
movertoc:(QX(IP+IREL(1)),1,NAME1,1,24,0)# Store subj atom name          PO11 108
movertoc:(QX(IP+IREL(4)),1,NAME2,1,24,0)# Store ref  atom name          PO11 109
I=0#                                   Reset atom count                 PO11 110
FOR(IA=matom:;IA<latom:;IA=IA+natom:)# Loop atoms                       PO11 111
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PO11 112
I=I+1#                                 Count atoms                      PO11 113
movertoc:(na:,1,LABEL,1,24,0)#         Store atom label                 PO11 114
IF(NAME1==LABEL) QX(J+1)=FLOAT(I)#     Store atom pointer               PO11 115
IF(NAME2==LABEL) QX(J+4)=FLOAT(I)#     Store atom pointer               PO11 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PO11 117
ifeq:(QX(J+8),3.) QX(J+5)=QX(J+2)#     Set parameters same for noref    PO11 118
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PO11 119
#                                                                       PO11 120
RETURN#                                                                 PO11 121
END#                                                                    PO11 122
systemheader:(PO14)#                   Output of initial param          PO14   1
#################################################################       PO14   2
#                                                               #       PO14   3
#                               PO14                            #       PO14   4
#                                                               #       PO14   5
#################################################################       PO14   6
SUBROUTINE PO14#                                                        PO14   7
include:(AACOMN)#                                                       PO14   8
include:(POCOMN)#                                                       PO14   9
#                                                                       PO14  10
INTEGER I,J,M,IA,IS#                                                    PO14  11
REAL JUNK(7)#                                                           PO14  12
#                                                                       PO14  13
chardata:(PO1,' Phase N : XXXXXX-')#                                    PO14  14
chardata:(PO2," Atom      x/a     y/b     z/c     U       $#            PO14  15
U11     U22     U33     U12     U13     U23     pop")#                  PO14  16
chardata:(PO4,' Scale factor                              ')#           PO14  17
chardata:(PO5,' U overall                                 ')#           PO14  18
chardata:(PO6,' Mixing parameter                          ')#           PO14  19
realdata:(FMTC,[300742.,400742.,500742.,600742.,700742.,800742.])#      PO14  20
realdata:(FMTB,[400413.,450413.,500413.])#                              PO14  21
realdata:(FMTA,[140742.,220742.,300742.,380742.,460742.,540742.,#       PO14  22
620742.,700742.,780742.,860742.,940742.])#                              PO14  23
datastuff:#                                                             PO14  24
#                                                                       PO14  25
#   PRINT PHASE-DEPENDENT PARAMETERS                                    PO14  26
#   --------------------------------                                    PO14  27
#                                                                       PO14  28
LINRM=8#                               Force necessary space            PO14  29
movechar:(PO1,NPO1,CHROT,2,7,1)#       Insert underline header          PO14  30
movechar:(PHASE(NPH),1,PO1,12,6,0)#    Insert phase name                PO14  31
ncodefld:(FLOAT(NPH),1,PO1,80113.,1)#  Format phase number              PO14  32
writeline:(1,PO1,NPO1-1,2,3)#          Initial header                   PO14  33
#                                                                       PO14  34
ncodefld:(dcp:,1,CHROT,FMTC,3)#        ********* cell ************      PO14  35
ncodefld:(dcp:,7,CHROT,FMTC(4),3)#     Encode angles                    PO14  36
CHROT(2^16)='Cell parameters'#         Insert cell header               PO14  37
DO I=1,6#                              Loop cell refine flags           PO14  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO14  39
M=NINT(FMTC(I))/10000+1#               Letter position                  PO14  40
IF(REFCEL(NPH,I)==0)      CHROT(M^M)='n'# Noref this par                PO14  41
ELSE IF(REFCEL(NPH,I)==1) CHROT(M^M)='r'# Flag as ref                   PO14  42
ELSE                      CHROT(M^M)='c'# Flag as constrained           PO14  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO14  44
writeline:(0,0,0,1,3)#                 Print cell param values          PO14  45
#                                                                       PO14  46
JUNK(1)=FLOAT(pkprofnr:)#              ******** peak function ******    PO14  47
ncodefld:(JUNK,1,CHROT,300213.,1)#     Print as an integer              PO14  48
CHROT(2^28)='Peak shape function number'# Insert header                 PO14  49
writeline:(0,0,0,1,3)#                 Print peak function number       PO14  50
#                                                                       PO14  51
ncodefld:(span:,1,CHROT,300512.,1)#    ******** peak span ******        PO14  52
CHROT(2^16)='Peak span value'#         Insert header                    PO14  53
writeline:(0,0,0,1,3)#                 Print peak function number       PO14  54
#                                                                       PO14  55
JUNK(1)=PARPRO(NPH,6)#                                                  PO14  56
ncodefld:(JUNK,1,PO6,FMTC,1)#          ******** mixing param *******    PO14  57
IF(REFPRO(NPH,6)==yes:) PO6(31^31)='r'# Flag as ref                     PO14  58
ELSE                    PO6(31^31)='n'# Flag as ref                     PO14  59
writeline:(0,PO6,NPO6,3,3)#            Print mixing param               PO14  60
#                                                                       PO14  61
DO I=1,3; JUNK(I)=PARPRO(NPH,I)#                                        PO14  62
ncodefld:(JUNK,1,CHROT,FMTC,3)#        ******* half width **********    PO14  63
CHROT(2^22)='Half width parameters'#   Insert header                    PO14  64
DO I=1,3#                              Loop hwidth refine flags         PO14  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO14  66
M=NINT(FMTC(I))/10000+1#               Letter position                  PO14  67
IF(REFPRO(NPH,I)==1) CHROT(M^M)='r'#   Flag as ref                      PO14  68
ELSE                 CHROT(M^M)='n'#   Flag as noref                    PO14  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO14  70
writeline:(0,0,0,1,3)#                 Print half width values          PO14  71
#                                                                       PO14  72
DO I=1,2; JUNK(I)=PARPRO(NPH,I+3)#                                      PO14  73
ncodefld:(JUNK,1,CHROT,FMTC,2)#        ******** asymmetry **********    PO14  74
CHROT(2^22)='Peak asymmetry factors'#  Insert header                    PO14  75
IF(REFPRO(NPH,4)==yes:) CHROT(31^31)='r'# Insert ref flag               PO14  76
ELSE                    CHROT(31^31)='n'# Insert noref flag             PO14  77
IF(REFPRO(NPH,5)==yes:) CHROT(41^41)='r'# Insert ref flag               PO14  78
ELSE                    CHROT(41^41)='n'# Insert noref flag             PO14  79
writeline:(0,0,0,1,3)#                 Print peak asymmetry parameter   PO14  80
#                                                                       PO14  81
JUNK(1)=PARPOF(NPH)#                                                    PO14  82
CHROT(2^29)='Preferred orientation factor'# Insert header               PO14  83
IF(REFPOF(NPH)==yes:) CHROT(41^41)='r'# Insert ref flag                 PO14  84
ELSE                  CHROT(41^41)='n'# Insert noref flag               PO14  85
ncodefld:(JUNK,1,CHROT,400742.,1)#     ******** orient *************    PO14  86
writeline:(0,0,0,1,3)#                 Print pref orient parameters     PO14  87
CHROT(2^29)='Preferred orientation vector'# Insert header               PO14  88
DO I=1,3; JUNK(I)=POFVEC(NPH,I)#                                        PO14  89
CHROT(36^36)='<'#                      Insert bracket                   PO14  90
CHROT(51^51)='>'#                      Insert bracket                   PO14  91
ncodefld:(JUNK,1,CHROT,FMTB,3)#        ******** orient *************    PO14  92
writeline:(0,0,0,1,3)#                 Print pref orient parameters     PO14  93
#                                                                       PO14  94
ncodefld:(scal:,1,PO4,FMTC,1)#         ******** scale *************     PO14  95
IF(REFSKF(NPH)==yes:) PO4(31^31)='r'#  Flag as ref                      PO14  96
ELSE                  PO4(31^31)='n'#  Flag as noref                    PO14  97
writeline:(0,PO4,NPO4,3,3)#            Print scale                      PO14  98
#                                                                       PO14  99
ncodefld:(UOV,NPH,PO5,FMTC,1)#         ******** uov *******             PO14 100
IF(REFUOV(NPH)==yes:) PO5(31^31)='r'#  Flag as ref                      PO14 101
ELSE                  PO5(31^31)='n'#  Flag as noref                    PO14 102
writeline:(0,PO5,NPO5,3,3)#            Print uov                        PO14 103
#                                                                       PO14 104
PRVOID=0; LINRM=6; IS=mflag:+nflag:#   ********* atom ***********       PO14 105
CC=FLOAT(MCONS(1)-1)#                  Set start of first constraints   PO14 106
FOR(IA=matom:;IA<latom:;IA=IA+natom:)# Loop over the atoms              PO14 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO14 108
movertoc:(na:,1,CHROT,2,8,0)#          Insert atom name                 PO14 109
ncodefld:(xf:,1,CHROT,FMTA,11)#        Format atom parameters           PO14 110
ifvo:(ub:) ub:=UOV(NPH)*utob:#         ^   convert u to b values        PO14 111
ELSE       ub:=ub:*utob:#              Convert u to b values            PO14 112
IS=IS+nflag:;   J=7#                   Incr noref array pointer#        PO14 113
DO I=1,11#                             Loop parameters x to pop         PO14 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO14 115
J=J+8#                                 Incr flag pointer                PO14 116
ifvo:(QX(IA+6+I)) NEXT#                Skip void parameters             PO14 117
ifeq:(QX(IS+I),0.)   CHROT(J^J)='n'#   Flag as noref                    PO14 118
ELSE IF(QX(IS+I)>CC) CHROT(J^J)='c'#   Active parameter & constr        PO14 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO14 120
writeline:(0,PO2,NPO2,1,3)#            Print atom line                  PO14 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO14 122
#                                                                       PO14 123
RETURN#                                                                 PO14 124
END#                                                                    PO14 125
systemheader:(PO15)#                   Process reflection data          PO15   1
# ####################################################################  PO15   2
#                                                                       PO15   3
#                               PO15                                    PO15   4
#                                                                       PO15   5
# ####################################################################  PO15   6
SUBROUTINE PO15#                                                        PO15   7
#                                                                       PO15   8
include:(AACOMN)#                                                       PO15   9
include:(POCOMN)#                                                       PO15  10
#                                                                       PO15  11
INTEGER I,J,KK,M#                                                       PO15  12
INTEGER IP#                            Ip packet pointer                PO15  13
REAL    POFMAG#                        Pof vector magn squared          PO15  14
REAL    THETA#                         Scattering angle                 PO15  15
REAL    SINTH,COSTH,TANTH#             Sin,cos,tan theta                PO15  16
REAL    STOL#                          Sin theta / lambda               PO15  17
REAL    COS2TH#                        Cos 2theta                       PO15  18
REAL    FAC#                                                            PO15  19
#                                                                       PO15  20
#         SET REFLECTION DEFAULTS                                       PO15  21
#         -----------------------                                       PO15  22
#                                                                       PO15  23
FIRREF(NPH)=NREFL+1#                   Point to first refln for phase   PO15  24
POFMAG=0.0;   KK=0#                    Point to metric tensor           PO15  25
DO I=1,3;  DO J=1,3#                   Preferred orientation vector     PO15  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO15  27
KK=KK+1#                               Sum rmt*(uvw)                    PO15  28
POFMAG=POFMAG+rmt:(KK)*POFVEC(NPH,I)*POFVEC(NPH,J)# /pofvec/**2         PO15  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO15  30
#                                                                       PO15  31
# SET UP REQUIRED ITEMS                                                 PO15  32
# ---------------------                                                 PO15  33
#                                                                       PO15  34
M=NINT(dset:)*1000#                    Data set bias for idnums         PO15  35
DO I=1,3; IWNT(I)=1#                   Hkl; spares for h,k,l            PO15  36
IWNT(4)=2#                             Sine theta/lambda                PO15  37
IWNT(5)=3#                             Multiplicity                     PO15  38
DO I=1,NSCF; IWNT(I+5)=I+500#          Ask for scat factors             PO15  39
DO I=1,3;IWNT(5+NSCF+I)=M+298+I*2#     irel,f2rel,frel
IWNT(9+NSCF)=M+204#                    lp factor for irel
HKLPAK=fo:+NSCF#                       Words in dir access file         PO15  40
opendac:(ioda1:,3,100,' ')#            Open direct access file          PO15  41
IF(NPH==1) opendac:(ioda2:,3,100,' ')# Open direct access file  
#                                                                       PO15  43
setkey:(5,5+NSCF+4,0,0)#               Set search signals     
indexpkt:(1,lrrefl:,PACK,IP,0,KEY,IWNT,IREL)# Get refln pointers        PO15  45
#
J=5+NSCF
ISCOBS=0#                              No Single crystal observed int
IF(IREL(J+2)>0)                 ISCOBS=2# use f^2
ELSEIF(IREL(J+3)>0)             ISCOBS=3# use f
ELSEIF(IREL(J+1)>0&IREL(J+4)>0) ISCOBS=1# use irel
ELSEIF(IREL(J+1)>0&IREL(J+4)>0) ISCOBS=-1# fudge from irel
IF(ISCOBS==-1) 
write(6,*)"Warning: treating un-RLP-corrected irel as f2rl!"
#
#                                                                       PO15  46
REPEAT#                                Loop over lrrefl: packets        PO15  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO15  48
readwpkt:(1,lrrefl:,PACK,IP,0)#        Point to next ip packet          PO15  49
IF(IP<=0) BREAK#                       Seek end of record               PO15  50
gethkl:(IP+IREL(1),BUF)#               Get hkl indices                  PO15  51
intunpak:(QX(IP+IREL(5)),I,0,5)#       Reflection multiplicity          PO15  52
BUF(4)=FLOAT(I)#                       Store multiplicity               PO15  53
STOL=QX(IP+IREL(4))#                   Get sin theta on lambda          PO15  54
SINTH=LAMBDA*STOL#                     Sin theta                        PO15  55
IF(ABS(SINTH)>1.000000) NEXT#          Reflection outside sphere        PO15  56
NREFL=NREFL+1#                         Count the reflections            PO15  57
THETA=ASIN(SINTH)#                     Theta in radians                 PO15  58
COSTH=COS(THETA)#                      Cos theta                        PO15  59
ifeq:(COSTH,0.0)
$(
write(6,*)"WARNING max theta=90deg tantheta is wrong watchout."
TANTH=1000.#                     Tan theta                        PO15  60
$)
ELSE TANTH=SINTH/COSTH#                Tan theta                        PO15  60
COS2TH=COS(2.*THETA)#                  Cos 2 theta                      PO15  61
TT=114.591559*THETA#                   Two theta in degrees             PO15  62
TTMINR=MIN(TTMINR,TT)#                 Get min 2 theta hkl              PO15  63
TTMAXR=MAX(TTMAXR,TT)#                 Get max 2 theta hkl              PO15  64
#ifeq:(TTMAXR,TT)
#write(6,*)BUF(1),BUF(2),BUF(3),THETA,TTMAXR,TT,LAMBDA,STOL
BUF(5)=TT#                             Two theta in degrees             PO15  65
#                                                                       PO15  66
BUF(6)=.5*SINTH**2*COSTH*(1.+POLRA)/(1.+POLRA*COS2TH**2)# 1/lp          PO15  67
#                                                                       PO15  68
BUF(7)=.5*SQRT(PARPRO(NPH,1)$#                                          PO15  69
+       PARPRO(NPH,2)*TANTH+PARPRO(NPH,3)*TANTH**2)# Hwidth             PO15  70
HWDMAX=MAX(HWDMAX,BUF(7))#             Save max hwidth                  PO15  71
#                                                                       PO15  72
BUF(8)=PARPRO(NPH,4)+PARPRO(NPH,5)*TT# Peak asymmetry                   PO15  73
#                                                                       PO15  74
FAC=rmt:(1)*POFVEC(NPH,1)*BUF(1)$#     Calc angle delta between         PO15  75
+   rmt:(5)*POFVEC(NPH,2)*BUF(2)$#     Pref orient vector and           PO15  76
+   rmt:(9)*POFVEC(NPH,3)*BUF(3)$#     Scattering vector                PO15  77
+   rmt:(2)*(POFVEC(NPH,1)*BUF(2)+POFVEC(NPH,2)*BUF(1))$#               PO15  78
+   rmt:(3)*(POFVEC(NPH,1)*BUF(3)+POFVEC(NPH,3)*BUF(1))$#               PO15  79
+   rmt:(6)*(POFVEC(NPH,2)*BUF(3)+POFVEC(NPH,3)*BUF(2))#                PO15  80
ifeq:(POFMAG,0.) FAC=0.#               Zero divide                      PO15  81
ELSE FAC=FAC*FAC/(POFMAG*4.*STOL**2)#  Pofmag=/pofvec/**2               PO15  82
BUF(9)=EXP(PARPOF(NPH)*(2.*FAC-1.))#   Exp(cos(2*delta))                PO15  83
#                                                                       PO15  84
#BUF(10)=FLOAT(NPH)#                   Put phase nr in op buffer        PO15  85
#                                                                       PO15  86
DO I=1,NSCF#                           Loop over atom types             PO15  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO15  88
IF(IREL(I+5)>0) BUF(I+fo:)=QX(IP+IREL(I+5))# Extract interpol scat fa   PO15  89
ELSE#                                  Else get sf from sf table        PO15  90
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO15  91
J=mscat:+(I-1)*nscat:+6#               Point to scat factor table       PO15  92
IF(RADTYP>1) BUF(I+fo:)=QX(J+NINT(STOL/DSCF))# Store electron/xray ff   PO15  93
ELSE         BUF(I+fo:)=QX(J+1)#       Store neutron ff                 PO15  94
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO15  95
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO15  96
J=5+NSCF
I=IREL(J+4)
IF(ISCOBS!= 0)
$(
BUF(10)=QX(IP+IREL(J+ABS(ISCOBS)))#    f2rl /fudged irel
IF(ISCOBS== 3) BUF(10)=BUF(10)*BUF(10)# convert frel to f2rel
RLPF=BUF(6)#                           just calculated lp factor   
if(I>0)ifnv:(QX(IP+I))RLPF=QX(IP+I)#   use archived by default
IF(ISCOBS== 1) BUF(10)=BUF(10)*RLPF#   convert irel to f2rl
$)
#                                                                       PO15  97
writedac:(ioda1:,,NREFL,(BUF(I),I=1,HKLPAK))# Write direct access fil   PO15  98
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO15  99
FIRREF(NPH+1)=NREFL+1#                 Set first refln for next phase   PO15 100
readwpkt:(1,endrecord:,PACK,IP,0)#     Close off i/p bdf                PO15 101
#                                                                       PO15 102
RETURN#                                                                 PO15 103
END#                                                                    PO15 104
systemheader:(PO16)#                   Sort refls on tth to fil ioda2   PO16   1
######################################################################  PO16   2
#                                                                       PO16   3
#                               PO16                                    PO16   4
#                                                                       PO16   5
######################################################################  PO16   6
SUBROUTINE PO16#                                                        PO16   7
#                                                                       PO16   8
include:(AACOMN)#                                                       PO16   9
include:(POCOMN)#                                                       PO16  10
#                                                                       PO16  11
INTEGER I,II,J,K,L,K2#                                                  PO16  12
INTEGER NREF,MARK#                                                      PO16  13
#                                                                       PO16  14
#    READ REFLN FILE AND STORE PACKED 2THETA/NREFL                      PO16  15
#    ---------------------------------------------                      PO16  16
#                                                                       PO16  17
NPHASE=NPH#                            Correct the number of phases     PO16  18
#                                                                       PO16  19
NREF=NREFL-FIRREF(NPH)+1#              Number of reflection in phase    PO16  20
J=NEWM#                                Set start of sort indices        PO16  21
incrqx:(I,NEWM+NREF*2,PO1601)#         Memory for sort indices          PO16  22
DO I=FIRREF(NPH),NREFL#                Loop over refl packets           PO16  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO16  24
readdac:(ioda1:,,I,(BUF(K),K=1,HKLPAK))# Read next refln                PO16  25
QX(J+1)=BUF(5)#                        Store twotheta                   PO16  26
QX(J+2)=FLOAT(I)#                      Store reflection number          PO16  27
J=J+2#                                 Incr qx pointer                  PO16  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO16  29
#                                                                       PO16  30
#    SORT THE STORED PACKED 2THETA/NREFL                                PO16  31
#    -----------------------------------                                PO16  32
#                                                                       PO16  33
MARK=NEWM#                             Set start of sort indices        PO16  34
K=FIRREF(NPH)#                         Loop over refl packets           PO16  35
DO I=1  ,2*NREF,2#                     Loop over refl packets           PO16  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO16  37
II=I#                                  Get starting packet              PO16  38
DO J=I+2,2*NREF,2#                     Loop over refl packets           PO16  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO16  40
IF (QX(MARK+J)>=QX(MARK+II)) NEXT#     Compare twotheta angles          PO16  41
II=J#                                  Out of sequence so  save         PO16  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO16  43
K2=NINT(QX(MARK+II+1))#                Next smallest reflection numbe   PO16  44
QX(MARK+II)  = QX(MARK+I)#             Copy old twotheta to new pos     PO16  45
QX(MARK+II+1)= QX(MARK+I+1)#           Copy old ref num to new pos      PO16  46
readdac:( ioda1:,,K2,(BUF(L),L=1,HKLPAK))# Read from unsorted file      PO16  47
writedac:(ioda2:,,K,(BUF(L),L=1,HKLPAK))# Write to sorted file          PO16  48
K=K+1#                                                                  PO16  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO16  50
#                                                                       PO16  51
qxmemory:(MARK); NEWM=MARK#            Set memory back to pre-sort      PO16  52
closedac:(ioda1:)#                     Close unsorted file              PO16  53
#                                                                       PO16  54
#    IT USED TO CALCULATE THE NUMBER OF VARIABLES AND                   PO16  55
#    SOME DERIVATIVE STUFF HERE                                         PO16  56
#                                                                       PO16  57
RETURN#                                                                 PO16  58
END#                                                                    PO16  59
systemheader:(PO20)#                   Read powder pattern              PO20   1
######################################################################  PO20   2
#                                                                       PO20   3
#                               PO20                                    PO20   4
#                                                                       PO20   5
######################################################################  PO20   6
SUBROUTINE PO20#                                                        PO20   7
#                                                                       PO20   8
include:(AACOMN)#                                                       PO20   9
include:(POCOMN)#                                                       PO20  10
#                                                                       PO20  11
INTEGER I,IP#                                                           PO20  12
INTEGER IRAD
REAL YOMIN,YOMAX#                                                       PO20  13
REAL YCMIN,YCMAX#                                                       PO20  14
REAL OFFSET#                                                            PO20  15
REAL TMP(7)
chardata:(PO0,' Powder pattern information:')#                          PO20  16
chardata:(PO1,' Pre-set two theta min/max                         ')#   PO20  17
chardata:(PO2,' Pattern two theta min/max                         ')#   PO20  18
chardata:(PO3,' HKL bdf two theta min/max                         ')#   PO20  19
chardata:(PO4,' Overall two theta min/max                         ')#   PO20  20
chardata:(PO5,'-')#                                                     PO20  21
chardata:(PO6,' Overall two theta stepsize                        ')#   PO20  22
chardata:(PO7,' WARNING - Radiation types differ!')#                    PO20  23
chardata:(PO8,' Radtyp Alpha1 Alpha2 Iratio Pratio LpCorr DivSlit ')#   PO20  24
chardata:(PO9,' Observed intensity min/max                        ')#   PO20  25
chardata:(POA,' Calculated intensity min/max                      ')#   PO20  26
realdata:(FMT,[50213.,140642.,210642.,280642.,350642.,390213.,#         PO20  27
470213.])#                                                              PO20  28

chardata:(PO12,' Preset Pattern Parameters-')#                           PO05  19
chardata:(PO13,' Preset two theta min/max                         ')#    PO05  20
chardata:(PO15,' Two theta zero correction ')#                           PO05  21
chardata:(PO16,' Wavelength of pattern data             ')#              PO05  22
chardata:(PO17,' Polarization ratio for Lp              ')#              PO05  23
chardata:(PO18,' Background parameters ')#                               PO05  24
chardata:(PO19,' 2theta exclusion limits                          ')#    PO05  25
chardata:(PO1A,' Peak shape function  Lines  Pkspan  1/step')#           PO05  26
chardata:(PO1D,' Background source - ')#                                 PO05  29
chardata:(PO1E,'file values  calculated ')#                              PO05  30
realdata:(FMT1,[400532.,500532.,600532.,700532.,800532.])#               PO05  33

datastuff:#                                                             PO20  29
#                                                                       PO20  30
#    READ POWDER PATTERN FILE (.PAT)                                    PO20  31
#    ------------------------                                           PO20  32
#                                                                       PO20  33
IF(PFILES(1)!=' ')#                    Powder pattern file exists       PO20  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO20  37
#COPYFILE:(3,4,1,DECR:(LRPWAV:))#       COPY TO WAVLEN RECORD           PO20  38
readwpkt:(3,lrpwav:,PACK,IP,0)#        Read wavlen packet               PO20  39
IF(IP<=0) iquit:(PO2005)#              Record missing                   PO20  40
#WRITEPKT:(4,LRPWAV:,PACK,IPO)#         PT TO POW PAT O/P PKT           PO20  41
#MOVEREAL:(QX,IP+1,QX,IPO+1,PACK,1)#    COPY RECORD                     PO20  42
DO I=1,7;TMP(I)=QX(IP+I)#
readwpkt:(3,lrplim:,PACK,IP,0)#        Read limits packet               PO20  47
IF(IP<=0) iquit:(PO2010)#              Record missing                   PO20  48
#WRITEPKT:(4,LRPLIM:,PACK,IPO)#         PT TO POW PAT O/P PKT           PO20  49
#MOVEREAL:(QX,IP+1,QX,IPO+1,PACK,1)#    COPY RECORD                     PO20  50
TTMINP=QX(IP+1)#                       Two theta min - pattern          PO20  51
TTMAXP=QX(IP+2)#                       Two theta max - pattern          PO20  52
TTSTEP=QX(IP+3)*FLOAT(NSKIP)#          Two theta stepsize               PO20  53
YOMIN=QX(IP+4)#                        Obs intensity minimum            PO20  54
YOMAX=QX(IP+5)#                        Obs intensity maximum            PO20  55
YCMIN=QX(IP+6)#                        Cal intensity minimum            PO20  56
YCMAX=QX(IP+7)#                        Cal intensity maximum            PO20  57
YMIN=MIN(YCMIN,YOMIN)#                                                  PO20  58
YMAX=MAX(YCMAX,YOMAX)#                                                  PO20  59
IF(TTMAXL<0.0 & TTMAXP>0.5) TTMAXL=TTMAXP# redefine preset
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO20  60
ELSE#                                                                   PO20  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO20  62
IF(TTMAXL<0.0 & TTMAXR>0.5) TTMAXL=TTMAXR# redefine preset
TTMINP=0.0#                            Two theta min - pattern          PO20  63
TTMAXP=TTMAXL#                         Two theta max - pattern          PO20  64
TTSTEP=0.05#                           Two theta stepsize               PO20  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO20  66
#
#
#
#
LINRM=8#                               Ensure print space 12 lines      PO05 171
movechar:(PO12,NPO12,CHROT,2,NPO12-2,1)#  Insert header underline          PO05 172
writeline:(1,PO12,NPO12-1,2,3)#        Print header                     PO05 173
ncodefld:(LAMBDA,1,PO16,400952.,1)#    Encode wavelength for msg        PO05 174
writeline:(0,PO16,NPO16,3,3)#          Write wavlen                     PO05 175
ncodefld:(POLRA,1,PO17,400952.,1)#     Encode polariz ratio for msg     PO05 176
writeline:(0,PO17,NPO17,3,3)#          Write polra                      PO05 177
ncodefld:(TTMINL,1,PO13,400932.,1)#    Encode min preset 2theta limit   PO05 178
ncodefld:(TTMAXL,1,PO13,500932.,1)#    Encode max preset 2theta limit
writeline:(0,PO13,NPO13,3,3)#          Write the line#               
#                                                                       PO05 181
movechar:(PO15,1,CHROT,1,NPO15,0)#      Insert tth zero corrections# 
ncodefld:(PARZER,1,CHROT,FMT1,2)#       Encode tth zero corrections   
DO I=1,2#                              Loop zero refine flags           PO05 184
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PO05 185
M=NINT(FMT1(I))/10000+1#                Letter position                  PO05 186
IF(REFZER(I)==0) CHROT(M^M)='n'#       Noref this par                   PO05 187
IF(REFZER(I)==1) CHROT(M^M)='r'#       Flag as ref                      PO05 188
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PO05 189
writeline:(0,0,0,1,3)#                 Print zero param values          PO05 190
#                                                                       PO05 191
movechar:(PO18,1,CHROT,1,NPO18,0)#       Format background parameters
ncodefld:(PARBAC,1,CHROT,FMT1,5)#       Format background parameters 
DO I=1,5#                              Loop bg refine flags             PO05 194
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PO05 195
M=NINT(FMT1(I))/10000+1#                Letter position                  PO05 196
IF(REFBAC(I)==0) CHROT(M^M)='n'#       Noref this par                   PO05 197
IF(REFBAC(I)==1) CHROT(M^M)='r'#       Flag as ref                      PO05 198
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PO05 199
writeline:(0,0,0,1,3)#                 Print bg param values            PO05 200
movechar:(PO1D,1,CHROT,1,NPO1D,0)#       Background source           
movechar:(PO1E,IBAC*12+1,CHROT,22,12,0)# File or calc                
writeline:(0,0,0,1,3)#                 Print bg source                  PO05 203
#                                                                       PO05 204
IF(NPEAKF>0) writeline:(0,PO1A,NPO1A,3,3)# Table heading & parameters
DO I=1,NPEAKF#                         Loop peak functions              PO05 206
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PO05 207
J=PSHFPT(I); IF(J==0) NEXT#            Skip undefined functions         PO05 208
L=PSHFLN(I); K=J+(L-1)*5#              Pt to last entry                 PO05 209
PSHFST(I)=FLOAT(L-1)/QX(K+1)#          Nsteps/range = 1/stepsz          PO05 210
ncodefld:(FLOAT(I),1,CHROT,210213.,1)# Encode func nr                   PO05 211
ncodefld:(FLOAT(PSHFLN(I)),1,CHROT,270413.,1)# Func table length        PO05 212
ncodefld:(QX(K+1),1,CHROT,350722.,1)#  Func table range                 PO05 213
ncodefld:(PSHFST(I),1,CHROT,440732.,1)# Func table 1/stepsz             PO05 214
writeline:(0,0,0,1,3)#                 Table heading & parameters       PO05 215
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PO05 216
#                                                                       PO05 217
IF(NEXCLR>0) writeline:(1,PO19,NPO19,3,3)# Table heading & parameters
DO I=1,NEXCLR#                         Loop over 2theta excl regions    PO05 219
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PO05 220
ncodefld:(EXCLRL(I),1,CHROT,400932.,1)# Format the lower 2theta limit   PO05 221
ncodefld:(EXCLRH(I),1,CHROT,500932.,1)# Format the higher 2theta limi   PO05 222
writeline:(0,0,0,1,3)#                 Write exclusion limits           PO05 223
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PO05 224
#                                                                       PO20  67
#    REPORT ALL 2THETA LIMITS                                           PO20  68
#    ------------------------                                           PO20  69
#                                                                       PO20  70
movechar:(PO5,1,CHROT,2,NPO0,1)#       Insert underline header          PO20  34
writeline:(1,PO0,NPO0,2,3)#            Header line                      PO20  35
IF(NINT(TMP(1))!=RADTYP) writeline:(1,PO7,NPO7,3,3)# Warning line             
ncodefld:(TMP,1,CHROT,FMT,7)#          Radiation info                   PO20  45
writeline:(1,PO8,NPO8,2,3)#            Radiation info                   PO20  46

LINRM=5;   OFFSET=PEAKSP*HWDMAX#       Get 2theta offset                PO20  71
ncodefld:(TTMINL,1,PO1,400932.,1)#     Pattern file minimum             PO20  72
ncodefld:(ABS(TTMAXL),1,PO1,500932.,1)# Pattern file maximum -ive dflt
writeline:(1,PO1,NPO1,3,3)#            Report limits                    PO20  74
ncodefld:(TTMINP,1,PO2,400932.,1)#     Requested 2th minimum            PO20  75
ncodefld:(TTMAXP,1,PO2,500932.,1)#     Requested 2th maximum            PO20  76
writeline:(0,PO2,NPO2,3,3)#            Report limits                    PO20  77
ncodefld:(TTMINR,1,PO3,400932.,1)#     Refl 2th minimum refln data      PO20  78
ncodefld:(TTMAXR,1,PO3,500932.,1)#     Refl 2th maximum refln data      PO20  79
writeline:(0,PO3,NPO3,3,3)#            Report limits                    PO20  80
TTMINP=MAX(TTMINP,TTMINL)#             Composite 2th minimum            PO20  81
TTMAXP=MIN(TTMAXP,TTMAXR-OFFSET)#      Composite 2th maximum      
IF(TTMAXL>TTMINP) TTMAXP=MIN(TTMAXP,TTMAXL)# if not -ive maxl default
ncodefld:(TTMINP,1,PO4,400932.,1)#     Composite 2th minimum            PO20  83
ncodefld:(TTMAXP,1,PO4,500932.,1)#     Composite 2th maximum            PO20  84
writeline:(0,PO4,NPO4,3,3)#            Report limits                    PO20  85
ncodefld:(TTSTEP,1,PO6,400932.,1)#     Two theta stepsize               PO20  86
writeline:(0,PO6,NPO6,3,3)#            Report step                      PO20  87
ncodefld:(YOMIN,1,PO9,400922.,1)#      Obs intensity minimum            PO20  88
ncodefld:(YOMAX,1,PO9,500922.,1)#      Obs intensity maximum            PO20  89
IF(PFILES(1)!=' ')writeline:(0,PO9,NPO9,3,3)# Report min max intensit   PO20  90
ncodefld:(YCMIN,1,POA,400922.,1)#      Cal intensity minimum            PO20  91
ncodefld:(YCMAX,1,POA,500922.,1)#      Cal intensity maximum            PO20  92
writeline:(0,POA,NPOA,3,3)#            Report min max calcd intensity   PO20  93
IF(TTMINP>TTMAXP) iquit:(PO2015)#      Limits will not work             PO20  94
#                                                                       PO20  95
RETURN#                                                                 PO20  96
END#                                                                    PO20  97
systemheader:(PO21)#                   Decision making
######################################################################  PO22   2
#                                                                       PO22   3
#                               PO21   
#                                                                       PO22   5
######################################################################  PO22   6
SUBROUTINE PO21#                                                        PO22   7
include:(AACOMN)#                                                       PO22   8
include:(POCOMN)#                                                       PO22   9
#
# This is crude - just to get it working
# need some checks to disable these overrides
IF(PFILES(1)!=' ')# input pattern exists
$(
DO PT=1,maxgn:;if(axmax:(1)<0.0) axmax:(1)=db:(TTMAXP)# pattern  max  
DO PT=1,maxgn:;cvdisplay:(yobs:)=FLOAT(yes:)
$)
ELSE#                                  no input pattern 
$(
DO PT=1,maxgn:;if(axmax:(1)<0.0) axmax:(1)=db:(TTMAXR)# hkl max 
IF(ISCOBS==0)#                         no single crystal measured intensities
$(
DO PT=1,maxgn:;cvdisplay:(ycaltot:)=FLOAT(yes:)# Display calculated, if possible
$)
ELSE#                                  fudged observed pattern
$(
DO PT=1,maxgn:;cvdisplay:(yobs:)=FLOAT(yes:)# display it
$)
$)
#
RETURN#                                                                 PO20  96
END#                                                                    PO20  97
systemheader:(PO22)#                   Process powder pattern steps     PO22   1
######################################################################  PO22   2
#                                                                       PO22   3
#                               PO22   (RT50)                           PO22   4
#                                                                       PO22   5
######################################################################  PO22   6
SUBROUTINE PO22#                                                        PO22   7
include:(AACOMN)#                                                       PO22   8
include:(POCOMN)#                                                       PO22   9
#                                                                       PO22  10
INTEGER I,J#                                                            PO22  11
INTEGER ISKIP,NSTPO,IP#                                                 PO22  12
INTEGER IPAT#                                                           PO22  13
REAL TTLAST,TT1,STPOW#                                                  PO22  14
#                                                                       PO22  15
LINRM=6#                               Heading control                  PO22  16
MCONTR=0#                              Max overlapping refls/step       PO22  17
ISKIP=0;   NSTPO=0#                    Reset skip and step count        PO22  18
TTLAST=TTMINP-TTSTEP#                  Set initial pattern values       PO22  19
DO I=1,80; RSUMS(I)=0.; RSUMS(58)=-1.# Clear statistics array           PO22  20
NEWPAK=20#                
opendac:(ioda1:,3,NEWPAK*mxchwd:,' ')# Open new dir access file         PO22  21
PNTIND=1#                              Index first ppoint rec           PO22  22
LOHKL=1;   HIHKL=0#                    Reset active window              PO22  23
NEWPAK=20#                             Stored packet size               PO22  24
IREFMX=(QXMAX-NEWM)/NEWPAK-1#          Truncate at max refs permitted   PO22  25
IREFMX=MIN(IREFMX,FIRREF(NPH+1)-FIRREF(NPH)+1)# Max refs required       PO22  26
QXCUR=NEWM#                            Reset                            PO22  27
incrqx:(I,NEWM+IREFMX*NEWPAK,PO2201)#  Reserve and clear in advance     PO22  28
IF(PFILES(1)==' ')IPAT=no:#            Reading the .pat file            PO22  29
ELSE IPAT=yes:#                                                         PO22  30
#                                                                       PO22  31
IREFL=FIRREF(NPH)-1#                   Precursor to first reflection    PO22  32
#                                                                       PO22  33
#   STEP THROUGH POWDER PATTERN                                         PO22  34
#   ---------------------------                                         PO22  35
#                                                                       PO22  36
TT1=TTMINP#                            Initialise                       PO22  37
REPEAT#                                Loop over pattern steps          PO22  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO22  39
IF(IPAT==yes:)#                                                         PO22  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO22  41
readwpkt:(3,lrppat:,PACK,IP,0)#        Read step in powder pattern      PO22  42
IF(IP<=0) BREAK#                       Exit if finished                 PO22  43
TT1=QX(IP+1)#                          Get two theta                    PO22  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO22  45
TT=TT1+PARZER(1)+PARZER(2)*TT1#        Apply zero corr                  PO22  46
#                                                                       PO22  47
IF(TT<TTMINP) GOTO 100#                Skip steps below min 2theta      PO22  48
IF(TT>TTMAXP) BREAK#                   Exit when above max 2theta       PO22  49
ISKIP=ISKIP+1#                                                          PO22  50
IF(ISKIP>NSKIP) GOTO 100#              Use nskip'th steps only          PO22  51
ISKIP=0#                               Accept step, reset skip counte   PO22  52
DO J=1,NEXCLR#                         Loop over exclusion regions      PO22  53
IF(TT>=EXCLRL(J)&TT<=EXCLRH(J)) GOTO 100# Skip if in excl region        PO22  54
#                                                                       PO22  55
IF(IPAT==yes:)#                                                         PO22  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO22  57
CNTOBS=QX(IP+2)#                       Extract observed intensity       PO22  58
CNTSIG=QX(IP+3)#                       Extract std deviation            PO22  59
CNTWHT=QX(IP+4)#                       Extract weight                   PO22  60
CNTBAC=QX(IP+6)#                       Extract background intensity     PO22  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO22  62
ELSE#                                  Fudge the .pat file data         PO22  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO22  64
CNTOBS=0.0#                            Initialise observed intensity    PO22  65
CNTSIG=1.0#                            Initialise std deviation         PO22  66
CNTWHT=1.0#                            Initialise weight                PO22  67
CNTBAC=0.0#                            Initialise background intensit   PO22  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO22  69
IF(CNTSIG<=0.00001) CNTSIG=1.0#        Prevent zero divide              PO22  70
NSTPO=NSTPO+1#                         Count number of steps            PO22  71
STPOW=TT-TTLAST;    TTLAST=TT#         Get step width to last step      PO22  72
IF(STPOW<TTSTEP*5.) TTSTEP=STPOW#      Reset step, not on gaps          PO22  73
TT=TT+PARZER(1)+TT*PARZER(2)#          Zero correct to twotheta         PO22  74
#                                                                       PO22  75
IF(NPH==1)#                                                             PO22  76
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO22  77
PPOINT(1,PNTIND) = TT#                 Save two theta                   PO22  78
PPOINT(2,PNTIND) = CNTOBS#             Save obs step count with bg      PO22  79
PPOINT(3,PNTIND) = CNTSIG#             Save obs step sigma              PO22  80
IF(IBAC==yes:)#                        Backgrd params supplied          PO22  81
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO22  82
CNTBAC=0.#                                                              PO22  83
DO I=1,5#                              Loop over backgd parameters      PO22  84
CNTBAC=CNTBAC+PARBAC(I)*(TT**(I-1))#   Calculate backgrd                PO22  85
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO22  86
PPOINT(4,PNTIND) = CNTBAC#             Obs step background              PO22  87
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO22  88
ELSE CNTBAC=PPOINT(4,PNTIND)#          Recover previous background      PO22  89
#                                                                       PO22  90
CALL PO23#                             Cull reflns from active list     PO22  91
IF(IPAT!=yes:&ISCOBS!=0) CALL PO26#    Use sin crys obs intensity
CALL PO24#                             Add reflns to active list        PO22  92
#
#
CALL PO25#                             Calc pow int from active list    PO22  93
100 IF(IPAT==no:) TT1= TT1+TTSTEP#     Increment two theta by stepsz    PO22  94
PNTIND=PNTIND+1#                       Next profile point               PO22  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO22  96
#                                                                       PO22  97
PNTIND=PNTIND-1#                       Next profile point               PO22  98
TT=180.0#                              Set max tth possible             PO22  99
CALL PO23#                             Purge active refl list           PO22 100
SFCALC(NPH)=no:#                       No need to recalc sf now         PO22 101
IF(IPAT==yes:)rewindbdf:(3)#           Rewind the powder pattern        PO22 102
#                                                                       PO22 103
RETURN#                                                                 PO22 104
END#                                                                    PO22 105
systemheader:(PO23)#                   Drop refls, write bdf, list      PO23   1
######################################################################  PO23   2
#                                                                       PO23   3
#                               PO23                                    PO23   4
#                                                                       PO23   5
######################################################################  PO23   6
SUBROUTINE PO23#                                                        PO23   7
include:(AACOMN)#                                                       PO23   8
include:(POCOMN)#                                                       PO23   9
#                                                                       PO23  10
INTEGER I,IR,IS#                                                        PO23  11
REAL    TTH,HWH,TSPAN#                                                  PO23  12
REAL    RMUL#                                                           PO23  13
REAL    RLPF#                                                           PO23  14
REAL    POWFAC#                                                         PO23  15
REAL    FCAL#      ## calculated f                                      PO23  16
REAL    FDIF#      ## Rel-cal difference for f                          PO23  17
REAL    FOBS#      ## integrated peak int reduced to absolute f         PO23  18
REAL    F2OBS#     ## integrated peak int reduced to observed f2        PO23  19
REAL    ICAL#      ## calculated i = rmult * f**2                       PO23  20
REAL    IDIF#      ## Rel-cal difference for i                          PO23  21
REAL    IOBS#      ## integrated peak int scaled to yobs/ycal           PO23  22
#                                                                       PO23  23
chardata:(PO231,   H  K  L 2THETA PH HFWID MLT  1/LP$#                  PO23  24
    FOBS    FCAL   IOBS   ICAL  IO-IC   POWFAC)#                        PO23  25
##    FOBS    FCAL  IO-IC   IOBS   ICAL   ACAL   BCAL$#                 PO23  26
## PSF HWGP   FWHM  PEAKAS  PREFOR#                                     PO23  27
realdata:(FMT,[40313.,70313.,100313.,#                                  PO23  28
170622.,200113.,260532.,290213.,360632.,#                               PO23  29
440722.,520722.,590613.,660613.,730613.,800622.,870622.,#               PO23  30
900213.,950313.,1030632.,1100632.,1170632.])#                           PO23  31
datastuff:#                                                             PO23  32
#                                                                       PO23  33
#    SCAN REFLECTIONS CONTRIBUTING TO PREVIOUS STPO                     PO23  34
#    ----------------------------------------------                     PO23  35
#                                                                       PO23  36
IF(LOHKL>HIHKL)RETURN#                 No cull on empty list            PO23  37
DO IR=LOHKL,HIHKL#                     Loop current active hkl number   PO23  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO23  39
IF(IR>IREFMX)#                                                          PO23  40
readdac:(ioda1:,,IR-IREFMX,(BUF(I),I=1,NEWPAK))# Read active refln fi   PO23  41
ELSE#                                                                   PO23  42
movereal:(QX,NEWM+(IR-1)*NEWPAK+1,BUF,1,NEWPAK,0)# Read from mem        PO23  43
TTH=BUF(5); HWH=BUF(7)#                2theta and halfwidth             PO23  44
#NPH=NINT(BUF(10))#                    PHASE NUMBER                     PO23  45
TSPAN=span:*HWH#                       Calc window width                PO23  46
IS=IR#                                                                  PO23  47
IF(TTH>=TT-TSPAN) BREAK#               Exit if still in active list     PO23  48
IS=IR+1#                               Drop lowest 2theta hkl           PO23  49
#                                                                       PO23  50
#  PROCESS LOW 2THETA HKL NOT CONTRIBUTING TO CURRENT STPO              PO23  51
#  -------------------------------------------------------              PO23  52
#                                                                       PO23  53
RMUL=BUF(4)#                           Refl multiplicity                PO23  54
RLPF=BUF(6)#                           1/lp powder                      PO23  55
FCAL=BUF(11)#                          F(cal) hkl                       PO23  56
POWFAC=BUF(12)#                        Skf*mult*1/lp*pof                PO23  57
ICAL=BUF(14)#                          I(cal) powder                    PO23  58
IOBS=0.; IDIF=0.; F2OBS=0.#            Reset observed values            PO23  59
FOBS=0.; FDIF=0.#                                                       PO23  60
#                                                                       PO23  61
#   CALC INTEGRATED IOBS                                                PO23  62
#   --------------------                                                PO23  63
#                                                                       PO23  64
IF(TTH-TSPAN>TTMINP&TTH+TSPAN<TTMAXP)# Check if full peak in pattern    PO23  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO23  66
IOBS=BUF(16)#                          Iobs built in rt54               PO23  67
F2OBS=IOBS/POWFAC#                     F**2 (obs)                       PO23  68
IF(F2OBS>0.)FOBS=SQRT(F2OBS)#          F(obs)                           PO23  69
ELSE        FOBS=0.#                                                    PO23  70
IDIF=IOBS-ICAL#                        Delta (f**2 * rmult)             PO23  71
FDIF=FOBS-FCAL#                        Delta f                          PO23  72
RSUMS(NPH  )=RSUMS(NPH  )+IOBS#        Sum obs i                        PO23  73
RSUMS(NPH+10)=RSUMS(NPH+10)+ABS(IDIF)# Sum delta i                      PO23  74
RSUMS(NPH+20)=RSUMS(NPH+20)+FOBS#      Sum obs f                        PO23  75
RSUMS(NPH+30)=RSUMS(NPH+30)+ABS(FDIF)# Sum delta f                      PO23  76
RSUMS(NPH+40)=RSUMS(NPH+40)+1.#        Sum number reflections           PO23  77
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO23  78
#                                                                       PO23  79
#    LIST REFLECTION DATA IF REQUESTED                                  PO23  80
#    ---------------------------------                                  PO23  81
#                                                                       PO23  82
IF(LISTRF==0) NEXT#                    Skip if no listing requested     PO23  83
BUFOT(1)=BUF(1)#                       Store h                          PO23  84
BUFOT(2)=BUF(2)#                       Store k                          PO23  85
BUFOT(3)=BUF(3)#                       Store l                          PO23  86
BUFOT(4)=TTH#                          Store two theta                  PO23  87
BUFOT(5)=BUF(10)#                      Store phase number               PO23  88
BUFOT(6)=HWH#                          Store halfwidth                  PO23  89
BUFOT(7)=RMUL#                         Store refl multiplicity          PO23  90
BUFOT(8)=RLPF#                         Store 1/lp                       PO23  91
BUFOT(9)=FOBS#                         Store f obs                      PO23  92
BUFOT(10)=FCAL#                        Store f calc                     PO23  93
BUFOT(11)=IOBS#                        Store i obs                      PO23  94
BUFOT(12)=ICAL#                        Store i calc                     PO23  95
BUFOT(13)=IDIF#                        Store i dif                      PO23  96
BUFOT(14)=POWFAC#                      Store powder scale factor        PO23  97
ncodefld:(BUFOT,1,CHROT,FMT,14)#       Format last 14 items             PO23  98
writeline:(0,PO231,NPO231,1,3)#        Print output items               PO23  99
LISTRF=LISTRF-1#                       Decrement lines printed          PO23 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO23 101
LOHKL=IS#                              Reset lohkl after drop           PO23 102
#                                                                       PO23 103
RETURN#                                                                 PO23 104
END#                                                                    PO23 105
systemheader:(PO24)#                   Add hkl contributing to patter   PO24   1
######################################################################  PO24   2
#                                                                       PO24   3
#                               PO24   (RT52)                           PO24   4
#                                                                       PO24   5
######################################################################  PO24   6
SUBROUTINE PO24#                                                        PO24   7
include:(AACOMN)#                                                       PO24   8
include:(POCOMN)#                                                       PO24   9
#                                                                       PO24  10
REAL    A,B,C,S#   ## Structure factor components                       PO24  11
REAL    ACAL,BCAL# ## Total structure factor components                 PO24  12
REAL    ANOD,BNOD# ## Dispersion free sf components                     PO24  13
REAL    ADIS,BDIS# ## Dispersion+ sf components                         PO24  14
REAL    AH,AK,AL#  ## Local h,k,l                                       PO24  15
REAL    BH,BK,BL#  ## Equiv h,k,l                                       PO24  16
REAL    DA,DB#     ## Real & imag dispersion components                 PO24  17
REAL    EQV(500)#  ## Space for generated reflections                   PO24  18
REAL    FAC#       ## Multiplication factor                             PO24  19
REAL    FAC1,FAC2# ## Real & imag scattering components                 PO24  20
INTEGER I,J,IA#    ## General indices                                   PO24  21
REAL    FCAL,ICAL# ## Calculated reflection str factor, intensity       PO24  22
INTEGER IMAG#      ## Imag=2: imaginary part of s.f. is present :       PO24  23
REAL    RLPF#      ## lp factor                                         PO24  24
INTEGER MEQV#      ## End of parameter array                            PO24  25
REAL    POF#      ## Preferred orientation factor                       PO24  26
REAL    RMUL#      ## Reflection multiplicity                           PO24  27
REAL    STOL#      ## Sin(theta/lambda)                                 PO24  28
REAL    STL2#      ## Sin(theta/lambda) squared                         PO24  29
REAL    SCOS,SSIN# ## Cos/sin summation of fc                           PO24  30
REAL    HWH#                                                            PO24  31
REAL    TTH#                                                            PO24  32
REAL    AMUL#                                                           PO24  33
REAL    POWFAC#                                                         PO24  34
REAL    DERFAC#                                                         PO24  35
REAL    DEPOMP#                                                         PO24  36
INTEGER ICEN,IC,IS,M#                                                   PO24  37
REAL    P,T,FF#                                                         PO24  38
#                                                                       PO24  39
realdata:(P2,6.28319); realdata:(PI180,0.01745329252)#                  PO24  40
datastuff:#                                                             PO24  41
#                                                                       PO24  42
#   ADD HIGH TWO THETA HKL CONTRIBUTING TO STEP                         PO24  43
#   -------------------------------------------                         PO24  44
#                                                                       PO24  45
M=VARMAX+1#                            Define skip factor for derivs    PO24  46
REPEAT#                                Loop over new reflections        PO24  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO24  48
IREFL=IREFL+1#                         Increment reflection count       PO24  49
IF(IREFL>=FIRREF(NPH+1))BREAK#         Out of refs for phase            PO24  50
readdac:(ioda2:,,IREFL,(BUF(I),I=1,HKLPAK))# Read refln file            PO24  51
#                                                                       PO24  52
#NPH=NINT(BUF(10))#                     PHASE NUMBER                    PO24  53
HWH=BUF(7);              TTH=BUF(5)#   Reflection halfwidth & 2theta    PO24  54
IF(TTH<TT-span:*HWH) NEXT#             Test if active list reached ye   PO24  55
IF(TTH>TT+span:*HWH)#                  Test if active region exceeded   PO24  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO24  57
IREFL=IREFL-1;  BREAK#                 Reset refln pointer and exit     PO24  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO24  59
#                                                                       PO24  60
#   SKIP STRUCTURE FACTOR CALCULATION, BUT BUILD ACTIVE LIST            PO24  61
#   --------------------------------------------------------            PO24  62
#                                                                       PO24  63
IF(SFCALC(NPH)==no:)#                  Regenerate from previous cycle   PO24  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO24  65
ICAL= BUF(13)#                         Calc powder structure factor     PO24  66
BUF(14)=ICAL#                                                           PO24  67
BUF(13)=0.0#                           Reserve for profile fn           PO24  68
##BUF(15)=ICAL*LAMBDA/(PI180*STOL*COS(TTH/114.591559))# Cell deriv fact PO24  69
movereal:(0.,1,BUF,16,5,2)#            Zero slots for iobs sum          PO24  70
HIHKL=HIHKL+1#                                                          PO24  71
IF(HIHKL>IREFMX)#                      Too many reflections             PO24  72
writedac:(ioda1:,,HIHKL-IREFMX,(BUF(I),I=1,NEWPAK))# Write additional   PO24  73
ELSE#                                                                   PO24  74
movereal:(BUF,1,QX,NEWM+(HIHKL-1)*NEWPAK+1,NEWPAK,0)# Dump buf          PO24  75
NEXT#                                                                   PO24  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO24  77
#                                                                       PO24  78
#   NEW REFLECTION IN ACTIVE LIST                                       PO24  79
#   -----------------------------                                       PO24  80
#                                                                       PO24  81
AH=BUF(1); AK=BUF(2); AL=BUF(3)#       Store hkl as real variables      PO24  82
IF(NUCELL==yes:)#                      If cell has changed              PO24  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO24  84
STOL=SQRT(stc:(1)*AH*AH+stc:(2)*AK*AK $# Calc sin theta/lambda          PO24  85
+         stc:(3)*AL*AL+stc:(4)*AH*AK $# Calc sin theta/lambda          PO24  86
+         stc:(5)*AH*AL+stc:(6)*AK*AL)# Calc sin theta/lambda           PO24  87
TTH=114.591559*ASIN(STOL*LAMBDA)#      Two theta                        PO24  88
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO24  89
ELSE STOL=SIN(TTH/114.591559)/LAMBDA#  Calc sin theta on lambda         PO24  90
STL2=STOL*STOL#                        Calc st/l **2                    PO24  91
#                                                                       PO24  92
AMUL=QX(msymm:+6)#                     Sf general multiplicity          PO24  93
RMUL=BUF(4)#                           Refl multiplicity                PO24  94
RLPF=BUF(6)#                           Extract lp factor                PO24  95
POF=BUF(9)#                            Preferred orient factor          PO24  96
POWFAC=scal:*RMUL*POF/RLPF#            Powder factor                    PO24  97
DERFAC=2.*POWFAC#                      Derivative factor                PO24  98
DEPOMP=-STL2*DERFAC/cub:(1)#           For tf derivative                PO24  99
ICEN=NINT(QX(msymm:+2))#               Centro flag (0=cent;1=nonc)      PO24 100
IF(APPDSP==yes:) IMAG=2#               Must be two components           PO24 101
ELSE             IMAG=ICEN+1#          Set imaginary flag               PO24 102
IC=mflag:+nflag:#                      Skip profile and cell lists      PO24 103
IS=MDTEMP+1#                           Set derive temp area             PO24 104
#DO II=MDTEMP+1,LDTEMP; QX(II)=0.##                                     PO24 105
#                                                                       PO24 106
J=-10#                                 **** generate hkl equivalents    PO24 107
FOR(I=msymm:+nsymm:;I<lsymm:;I=I+nsymm:)# Loop over symm matrices       PO24 108
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO24 109
J=J+10#                                Incr parameter array             PO24 110
BH=AH*QX(I+1)+AK*QX(I+2)+AL*QX(I+3)#   Equivalent h                     PO24 111
BK=AH*QX(I+4)+AK*QX(I+5)+AL*QX(I+6)#   Equivalent k                     PO24 112
BL=AH*QX(I+7)+AK*QX(I+8)+AL*QX(I+9)#   Equivalent l                     PO24 113
EQV(J+1)=P2*BH#                        Store h*2pi                      PO24 114
EQV(J+2)=P2*BK#                        Store k*2pi                      PO24 115
EQV(J+3)=P2*BL#                        Store l*2pi                      PO24 116
EQV(J+4)=P2*(AH*QX(I+10)+AK*QX(I+11)+AL*QX(I+12))# Phase shift          PO24 117
IF(FLGTDP==no:) NEXT#                  Skip if tdp not refined @@       PO24 118
EQV(J+5)= BH*BH#                       Store new h**2                   PO24 119
EQV(J+6)= BK*BK#                       Store new k**2                   PO24 120
EQV(J+7)= BL*BL#                       Store new l**2                   PO24 121
EQV(J+8)= BH*BK*2.#                    Store new h*k*2                  PO24 122
EQV(J+9)= BH*BL*2.#                    Store new h*l*2                  PO24 123
EQV(J+10)=BK*BL*2.#                    Store new k*l*2                  PO24 124
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO24 125
MEQV=J#                                Save last equiv hkl pointer      PO24 126
ANOD=0.; ADIS=0.;  A=0.#               Zero real fc components          PO24 127
BNOD=0.; BDIS=0.;  B=0.#               Zero imag fc components          PO24 128
#                                                                       PO24 129
#     LOOP OVER ALL ATOMS                                               PO24 130
#     -------------------                                               PO24 131
#                                                                       PO24 132
FOR(IA=matom:;IA<latom:;IA=IA+natom:)# Loop over atoms list             PO24 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO24 134
SCOS=0.;   SSIN=0.#                    Zero fc components               PO24 135
IC=IC+nflag:#                          Point to constraint list         PO24 136
#                                                                       PO24 137
DO J=0,MEQV,10#                        ********** equiv indices         PO24 138
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO24 139
P=EQV(J+1)*xf:+EQV(J+2)*yf:+EQV(J+3)*zf:+EQV(J+4)# H*x+k*y+l*z+phi      PO24 140
S=SIN(P);      C=COS(P)#               Sin and cos (hx+ky+lz+phi)       PO24 141
IF(dp:>1.5)#                           Anisotropic temp.fact.           PO24 142
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PO24 143
T=0.; DO I=1,6; T=T+EQV(J+I+4)*QX(IA+I+4)# Sum h*h*u11 etc.             PO24 144
T=EXP(-T);   S=T*S;    C=T*C#          Calc tf*sin tf*cos               PO24 145
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PO24 146
IF(ICEN==1) SSIN=SSIN+S; SCOS=SCOS+C#  Sum real components              PO24 147
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO24 148
#                                                                       PO24 149
#   CALC COMPONENTS WHICH ARE SYMMETRY INDPOENDENT                      PO24 150
#   ----------------------------------------------                      PO24 151
#                                                                       PO24 152
FAC=ml:*pp:*AMUL#                      Sitemult*pop*cellmul             PO24 153
IF(dp:<1.5) FAC=FAC*EXP(-STL2*ub:)#    Apply isotropic tf               PO24 154
FF=BUF(NINT(sf:)+fo:)#                 Get form factor this atom        PO24 155
FAC1=FAC*FF;    FAC2=0.#               Disp-free structure factor       PO24 156
IF(ICEN==1) B=FAC1*SSIN; A=FAC1*SCOS#  Form components of fc            PO24 157
IF(ICEN==1) BNOD=BNOD+B; ANOD=ANOD+A#  Sum non-dispersion terms         PO24 158
#                                                                       PO24 159
IF(APPDSP==yes:)#                      If dispersion applied            PO24 160
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PO24 161
FAC1=FAC*(dr:+FF)#                     Calc real scattering             PO24 162
FAC2=FAC*(di:)#                        Calc imag scattering             PO24 163
DA=FAC*(SCOS*dr:-SSIN*di:)#            Calc real disp. contribution     PO24 164
DB=FAC*(SSIN*dr:+SCOS*di:)#            Calc imag disp. contribution     PO24 165
ADIS=ADIS+DA;   BDIS=BDIS+DB#          Sum dispersion terms             PO24 166
A=A+DA;         B=B+DB#                Calc total sf terms              PO24 167
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PO24 168

$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO24 169
#                                                                       PO24 170
#    CALCULATE STRUCTURE FACTOR                                         PO24 171
#    --------------------------                                         PO24 172
#                                                                       PO24 173
ACAL=ANOD+ADIS;  BCAL=BNOD+BDIS#       Sum total sf components          PO24 174
IF(IMAG==1) FCAL=ABS(ACAL)#            If centrosymmetric               PO24 175
ELSE        FCAL=SQRT(ACAL*ACAL+BCAL*BCAL)# If noncentrosymmetric       PO24 176
ICAL=FCAL*FCAL*POWFAC#                 Calculated powder intensity      PO24 177
#                                                                       PO24 178
#   SAVE PARAMS IN ACTIVE REFLN BUFFER                                  PO24 179
#   ----------------------------------                                  PO24 180
#                                                                       PO24 181
BUF(11)=FCAL#                          Calculated structure factor      PO24 182
BUF(12)=POWFAC#                        Powder factor                    PO24 183
BUF(13)=ICAL#                          Set profile functn               PO24 184
writedac:(ioda2:,,IREFL,(BUF(I),I=1,HKLPAK))# Rewrite refln             PO24 185
BUF(13)=0.0#                           Reserve for profile fn           PO24 186
BUF(14)=ICAL#                          Calc powder structure factor     PO24 187
IF(ICAL >1.0E+15)
BUF(15)=ICAL*LAMBDA/(PI180*STOL*COS(TTH/114.591559))# Cell deriv fact   PO24 188
movereal:(0.,1,BUF,16,5,2)#            Zero slots for iobs sum          PO24 189
HIHKL=HIHKL+1#                                                          PO24 190
IF(HIHKL>IREFMX)#                      Too many reflections             PO24 191
writedac:(ioda1:,,HIHKL-IREFMX,(BUF(I),I=1,NEWPAK))# Write additional   PO24 192
ELSE#                                                                   PO24 193
movereal:(BUF,1,QX,NEWM+(HIHKL-1)*NEWPAK+1,NEWPAK,0)# Dump buf          PO24 194
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO24 195

#                                                                       PO24 196
RETURN#                                                                 PO24 197
END#                                                                    PO24 198
#                                                                       PO24 199
#                                                                       PO24 200
#                                                                       PO24 201
systemheader:(PO25)#                   Sum contributions to patt step   PO25   1
######################################################################  PO25   2
#                                                                       PO25   3
#                               PO25                                    PO25   4
#                                                                       PO25   5
######################################################################  PO25   6
SUBROUTINE PO25#                                                        PO25   7
include:(AACOMN)#                                                       PO25   8
include:(POCOMN)#                                                       PO25   9
#                                                                       PO25  10
REAL    BACGRD# ## background intensity, file or calculated             PO25  11
REAL    CNBCAL# ## calculated counts, no background                     PO25  12
REAL    CNBOBS# ## observed counts, no background                       PO25  13
REAL    CNTCAL# ## calculated step intensity (calculated counts)        PO25  14
REAL    DELTTH# ## distance between step and refl 2theta angles         PO25  15
REAL    DERCEL# ## derivative factor for cell parameters                PO25  16
REAL    DFSI#   ## value of symm der of pk shp function                 PO25  17
REAL    DFAI#   ## value of asymm der of pk shp function                PO25  18
REAL    DELTAW# ## weighted yobs-ycal                                   PO25  19
REAL    FAC1,FAC2,FAC3## multiplication factors in der calculation      PO25  20
INTEGER FLG#    ## flag to indicate pointer outside pk fn limits        PO25  21
REAL    FSI#    ## value of symm part of pk shp function                PO25  22
REAL    FAI#    ## value of asymm part of pk shp function               PO25  23
REAL    HWH#    ## Half width of a reflection peak                      PO25  24
INTEGER J,K,L#                                                          PO25  25
REAL    FCAL#   ## F                                                    PO25  26
REAL    ICAL#   ## Icalc = F**2 * m * otherfactors                      PO25  27
REAL    IOBS#   ## Iobs = 'observed' refl int, sum of peak contr        PO25  28
REAL    JCAL#   ## scaled intensity of a contributing refl              PO25  29
INTEGER NCONTR# ## nr of contributing reflections to a step             PO25  30
INTEGER NB#     ## nr of background parameters refined                  PO25  31
REAL    PAS#    ## Peak asymmetry of a reflection peak                  PO25  32
REAL    POF#    ## Preferred orientation factor                         PO25  33
REAL    PRFABS# ## position on peak profile (abs value)                 PO25  34
REAL    PRFSIG# ## position on peak profile                             PO25  35
REAL    PRFSGN# ## position on peak profile (-or+ = left/right)         PO25  36
REAL    PRFVAL# ## profile function value                               PO25  37
REAL    QRI#    ## 1/stepsize in pk shp function                        PO25  38
REAL    RATIO#  ## 2 theta diff / funcstep                              PO25  39
INTEGER REFLAG# ## flag to signal reflection at current step            PO25  40
REAL    SCALE#  ## scale obs intensity of a contributing refl           PO25  41
REAL    STOL#   ## F                                                    PO25  42
REAL    TTH#    ## 2 theta of a reflection                              PO25  43
INTEGER I#                                                              PO25  44
INTEGER IR,IC,IS,IB#                                                    PO25  45
REAL TANT#                                                              PO25  46
REAL FACDEL#                                                            PO25  47
REAL FACTTH#                                                            PO25  48
REAL FACASY#                                                            PO25  49
REAL FACHWD#                                                            PO25  50
REAL FAC4,FAC5,FAC6#                                                    PO25  51
REAL GPART,LPART,MIX#                                                   PO25  52
#                                                                       PO25  53
realdata:(PI,3.1415926); realdata:(G,2.7726); realdata:(C,0.939439)#    PO25  54
datastuff:#                                                             PO25  55
#                                                                       PO25  56
NCONTR=0#                              Contributing refl counter        PO25  57
REFLAG=0#                              Set reflection position flag     PO25  58
#                                                                       PO25  59
# BACKGROUND - CALCULATE AND BUILD DERIVATIVE                           PO25  60
# -------------------------------------------                           PO25  61
#                                                                       PO25  62
NB=0#                                                                   PO25  63
BACGRD=CNTBAC#                         Use file value for bacgrd        PO25  64
CNBOBS=CNTOBS-BACGRD#                  Strip background contrib         PO25  65
CNBCAL=0.#                             Calculated counts, no bac        PO25  66
#                                                                       PO25  67
#    LOOP ALL REFLNS CONTRIBUTING TO THIS PATTERN STPO                  PO25  68
#    -------------------------------------------------                  PO25  69
#                                                                       PO25  70
IF(LOHKL>HIHKL) GO TO 10#              No contributors, treat backgr    PO25  71
DO IR=LOHKL,HIHKL#                     Loop lowest to highest 2theta    PO25  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO25  73
IF(IR>IREFMX)#                                                          PO25  74
readdac:(ioda1:,,IR-IREFMX,(BUF(I),I=1,NEWPAK))# Read refln file        PO25  75
ELSE#                                                                   PO25  76
movereal:(QX,NEWM+(IR-1)*NEWPAK+1,BUF,1,NEWPAK,0)# Read from mem        PO25  77
#                                                                       PO25  78
NCONTR=NCONTR+1#                       Refl counter                     PO25  79
#                                                                       PO25  80
TTH   =BUF(5)#                         2 theta of this i-th refl        PO25  81
HWH   =BUF(7)#                         Half width                       PO25  82
PAS   =BUF(8)#                         Peak asymmetry                   PO25  83
POF   =BUF(9)#                         Preferred orient factor          PO25  84
#NPH   =NINT(BUF(10))#                  PHASE NUMBER                     PO25  85
FCAL  =BUF(11)#                        Calc refl intensity              PO25  86
ICAL  =BUF(14)#                        Calc refl intensity              PO25  87
DERCEL=BUF(15)#                        Derivative for cell parameters   PO25  88
IOBS  =BUF(16)#                        'observed' refl intensity        PO25  89

#                                                                       PO25  90
DELTTH=TT-TTH#                         Delta of step and refl angles    PO25  91
IF(ABS(DELTTH)<=TTSTEP)REFLAG=REFLAG+10**(NPH-1)# Set refl/phase indi   PO25  92
TANT=TAN(TT/114.591559)#               Tan theta                        PO25  93
STOL=SIN(TTH/114.591559)/LAMBDA#       Sin theta / lambda               PO25  94
#                                                                       PO25  95
#    APPLY PEAK PROFILE SHAPE FUNCTION                                  PO25  96
#    ---------------------------------                                  PO25  97
#                                                                       PO25  98
PRFVAL=0.; FLG=no:#                    Default & limit flag             PO25  99
PRFSIG=DELTTH/HWH#                     Nr hwidths from hkl 2theta       PO25 100
PRFSGN=SIGN(1.,PRFSIG)#                Left or right side of profile    PO25 101
PRFABS=ABS(PRFSIG)#                    Abs nr of hwidths from centre    PO25 102
#                                                                       PO25 103
IF(pkprofnr:<10)#                      Baerlocher & hepp's function     PO25 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO25 105
L     =PSHFLN(pkprofnr:)#              Nr of 5-value entries in table   PO25 106
J     =PSHFPT(pkprofnr:)#              Point to func array (markf)      PO25 107
QRI   =PSHFST(pkprofnr:)#              1/stepsize in func table         PO25 108
K=INT(PRFABS*QRI)+1#                   Step nr in func                  PO25 109
IF(K>=L) FLG=yes:#                     Outside function step limits     PO25 110
K=J+5*(K-1)#                           Lower step of func interval      PO25 111
RATIO=QRI*(PRFABS-QX(K+1))#            Hw diff / funcstepsz             PO25 112
FSI = QX(K+2)+RATIO*(QX(K+7)-QX(K+2))# Interpolate symm func            PO25 113
FAI =(QX(K+3)+RATIO*(QX(K+8)-QX(K+3)))*PRFSGN# Interpol asymm func      PO25 114
DFSI=(QX(K+4)+RATIO*(QX(K+9)-QX(K+4)))*PRFSGN# Interpol symm der        PO25 115
DFAI= QX(K+5)+RATIO*(QX(K+10)-QX(K+5))# Interpolate asymm der           PO25 116
FAC1=   1.-PAS*FAI#                    Apply peak asymmetry             PO25 117
FAC2=   FAC1*DFSI-PAS*FSI*DFAI#        Der prffunc wrt deltth           PO25 118
PRFVAL= FSI*FAC1/HWH#                  Profile function value           PO25 119
FACDEL= FAC2/(HWH*HWH)#                For zero corr                    PO25 120
FACTTH= -FACDEL#                       For cell                         PO25 121
FACASY= -FSI*FAI/HWH#                  For pasymm                       PO25 122
##FACHWD= -FSI*FACTTH + FAC1*PRFSIG#     For hwidth                     PO25 123
FACHWD= -PRFVAL/HWH#                   For hwidth                       PO25 124
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO25 125
#                                                                       PO25 126
ELSE#                                  Pseudo-voigt function            PO25 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO25 128
FAC1= 1./(1.+PRFSIG*PRFSIG)#                                            PO25 129
FAC2= -DELTTH*FAC1*FAC1/(PI*HWH*HWH*HWH)# Dl/ddel                       PO25 130
FAC3= -0.5*PRFSIG*FAC2 - 0.5/(PI*HWH*HWH*FAC1)# Dl/dsig                 PO25 131
FAC4= EXP(-0.25*G*PRFSIG*PRFSIG)#                                       PO25 132
FAC5= -0.25*C*G*PRFSIG*FAC4/(HWH*HWH)# Dg/ddel                          PO25 133
FAC6= -0.5*PRFSIG*FAC5 - 0.25*C*FAC4/(HWH*HWH)# Dg/dsig                 PO25 134
GPART= 0.5*C*FAC4/HWH#                 Gaussian part                    PO25 135
#WRITE(6,*) "MIXING PARAM",PRFSIG,PARPRO(NPH,6),GPART,HWH               PO25 136
LPART= 1./(PI*HWH)*FAC1#               Lorentzian part                  PO25 137
MIX=   PARPRO(NPH,6)#                  Mixing par                       PO25 138
PRFVAL= MIX*LPART + (1.-MIX)*GPART#    P-voigt prof func value          PO25 139
FACDEL= MIX*FAC2 + (1.-MIX)*FAC5#      For zero corr                    PO25 140
FACTTH= -FACDEL#                       For cell                         PO25 141
FACASY= -PRFVAL*PRFSGN*4.0*DELTTH*DELTTH# For pasymm                    PO25 142
FACHWD= MIX*FAC3 + (1.-MIX)*FAC6#      For hwidth                       PO25 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO25 144
#                                                                       PO25 145
IF(FLG==yes:) NEXT#                    Invalid fn lookup                PO25 146
JCAL=ICAL*PRFVAL#                      Step contr=icalc*proffunc        PO25 147
CNBCAL=CNBCAL+JCAL#                    Sum calc'd step intensity        PO25 148
BUF(17)=JCAL#                          Save jcal for iobs sum           PO25 149
BUF(13)=PRFVAL#                        Profile function value           PO25 150
IF(IR>IREFMX)#                         Too many reflections             PO25 151
writedac:(ioda1:,,IR-IREFMX,(BUF(I),I=1,NEWPAK))# Write additional re   PO25 152
ELSE#                                                                   PO25 153
movereal:(BUF,1,QX,NEWM+(IR-1)*NEWPAK+1,NEWPAK,0)# Dump buf             PO25 154
#                                                                       PO25 155
#   SUM SCALED DERIVATIVES IN SCRATCH LIST                              PO25 156
#   --------------------------------------                              PO25 157
#                                                                       PO25 158
#IF(NCY<=NCYCLE)#                       FOR ALL CYCLES EXCEPT LAST      PO25 159
IF(1==2)#                              For all cycles except last       PO25 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO25 161
IC=mflag:;  IS=MDTEMP+NB+1;  IB=1#     Set cons/scr/buffer pointers     PO25 162
#                                                                       PO25 163
DO I=1,2#                              Loop over zero corr parameters   PO25 164
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO25 165
IF(REFZER(I)==no:) NEXT#               Skip if not used                 PO25 166
IF(I==1) QX(IS)=QX(IS)+ICAL*FACDEL#    Zero correction 1                PO25 167
ELSE     QX(IS)=QX(IS)+ICAL*FACDEL*TTH# Zero correction 2               PO25 168
IS=IS+1#                               Incr scratch pointers            PO25 169
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO25 170
#                                                                       PO25 171
FOR(I=1;I<NPH;I=I+1)#                  Sum if nph gt 1                  PO25 172
IS=IS+NUMVAR(I)#                       Point in deriv scratch array     PO25 173
#                                                                       PO25 174
DO I=1,9#                              Loop over genl parameters        PO25 175
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO25 176
IF(QX(IC+I)<0.5) NEXT#                 Skip if not used                 PO25 177
IF(I==1) QX(IS)=QX(IS)+ICAL/scal:#     Sum scale der                    PO25 178
IF(I==2) QX(IS)=QX(IS)+ICAL*POF#       Sum pof der                      PO25 179
IF(I==3) QX(IS)=QX(IS)+ICAL*FACHWD*0.5/HWH# Sum hwidth u                PO25 180
IF(I==4) QX(IS)=QX(IS)+ICAL*FACHWD*0.5*TANT/HWH# Sum hwidth v           PO25 181
IF(I==5) QX(IS)=QX(IS)+ICAL*FACHWD*0.5*TANT*TANT/HWH# Sum hwidth w      PO25 182
IF(I==6) QX(IS)=QX(IS)+ICAL*FACASY#    Sum pasymm x                     PO25 183
IF(I==7) QX(IS)=QX(IS)+ICAL*FACASY/TANT# Sum pasymm y                   PO25 184
IF(I==8) QX(IS)=QX(IS)+ICAL*(LPART-GPART)# Sum mix                      PO25 185
IF(I==9) QX(IS)=QX(IS)-FCAL*STOL*STOL# Sum uov                          PO25 186
IS=IS+1#                               Incr scr pointers                PO25 187
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO25 188
#                                                                       PO25 189
IC=mflag:+nflag:#                      Point to cell noref flags        PO25 190
DO I=1,3#                              Loop cell lengths                PO25 191
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO25 192
IF(QX(IC+I)<0.5) NEXT#                 Skip if parameter is noref       PO25 193
#IF(QX(IC+I)>10.) L=IS +NINT(QX(IC+I))-11# IF DPOENDENT PARAMETER       PO25 194
#ELSE             L=IS#            POINT TO SCRATCH STORAGE             PO25 195
#QX(L)=QX(L)-DERCEL*BUF(I)*BUF(I)*FACTTH# SUM DERIV WPO LENGTHS         PO25 196
QX(IS)=QX(IS)+FACTTH*DERCEL*BUF(I)*BUF(I)# Sum deriv wrt lengths        PO25 197
IS=IS+1#                               Incr scratch element pointer     PO25 198
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO25 199
DO I=4,6#                              Loop cell angles                 PO25 200
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PO25 201
IF(QX(IC+I)<0.5) NEXT#                 Skip if parameter is noref       PO25 202
J=MOD(I,3)+1;   K=MOD(J,3)+1#          Get alternative axes             PO25 203
#IF(QX(IC+I)>10.) L=IS+NINT(QX(IC+I))-11# IF DPOENDENT PARAMETER        PO25 204
#ELSE             L=IS#            POINT TO SCRATCH STORAGE             PO25 205
#QX(L)=QX(L)-DERCEL*BUF(J)*BUF(K)*FACTTH# SUM DERIV WPO ANGLES          PO25 206
QX(IS)=QX(IS)+FACTTH*DERCEL*BUF(J)*BUF(K)# Sum deriv wrt angles         PO25 207
IS=IS+1#                               Incr scratch element pointer     PO25 208
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PO25 209
#                                                                       PO25 210
#IB=21#                                                                 PO25 211
#FOR(IC=MFLAG:+NFLAG:*2;IC<LFLAG:;IC=IC+NFLAG:)# LOOP NOREF FLAGS       PO25 212
#DO I=1,11#                             LOOP OVER STRUCTURE PARAMS      PO25 213
#$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1 PO25 214
#IF(QX(IC+I)<0.5) NEXT#                 SKIP NOREFS                     PO25 215
#IF(QX(IC+I)>CC) NEXT#                  SKIP CONSTRAINTS                PO25 216
#QX(IS)=QX(IS)-BUF(IB)*PRFVAL#          SUM STRUCT PARAMS               PO25 217
#IS=IS+1;  IB=IB+1#                     INCR SCR/BUFFER POINTERS        PO25 218
#$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1 PO25 219
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO25 220
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO25 221
MCONTR=MAX0(MCONTR,NCONTR)#            Max overlapping refls            PO25 222
#                                                                       PO25 223
#     CALCULATE OBSERVED INTENSITY                                      PO25 224
#     ----------------------------                                      PO25 225
## i.e. scale obs to cal intensity, then build iobs for each of the     PO25 226
## overlapping reflections by integrating over its peak                 PO25 227
#                                                                       PO25 228
IF(CNBCAL>0.&CNBOBS>0.)#               Ycal and yobs > zero             PO25 229
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PO25 230
SCALE=CNBOBS/CNBCAL#                   Scale to yobs                    PO25 231
DO IR=LOHKL,HIHKL#                     Loop lowest to highest 2theta    PO25 232
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PO25 233
IF(IR>IREFMX)#                                                          PO25 234
readdac:(ioda1:,,IR-IREFMX,(BUF(I),I=1,NEWPAK))# Read refln file        PO25 235
ELSE#                                                                   PO25 236
movereal:(QX,NEWM+(IR-1)*NEWPAK+1,BUF,1,NEWPAK,0)# Read from mem        PO25 237
IOBS=BUF(16)#                          Sum iobs so far                  PO25 238
JCAL=BUF(17)#                          Ical*prfval                      PO25 239
IOBS=IOBS+JCAL*SCALE*TTSTEP#           Sum iobs+(scl*ical*ttstep)       PO25 240
BUF(16)=IOBS#                          Build iobs                       PO25 241
IF(IR>IREFMX)#                         Too many reflections             PO25 242
writedac:(ioda1:,,IR-IREFMX,(BUF(I),I=1,NEWPAK))# Write additional re   PO25 243
ELSE#                                                                   PO25 244
movereal:(BUF,1,QX,NEWM+(IR-1)*NEWPAK+1,NEWPAK,0)# Dump buf             PO25 245
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PO25 246
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PO25 247
#                                                                       PO25 248
#     ADD BACKGROUND TO CALCULATED INTENSITY                            PO25 249
#     --------------------------------------                            PO25 250
#                                                                       PO25 251
10 CONTINUE#                           No contributors join here        PO25 252
CNTCAL=CNBCAL+BACGRD#                  Add background                   PO25 253
#IF(FLGCP==YES:)CNTOBS=CNTCAL#         POWGEN - GENERATE YOBS VALUE     PO25 254
DELTA=CNTOBS-CNTCAL#                   Yobs - ycal                      PO25 255
IF(WTSCHM==0)WEIGHT=1.0#               Unit stepweight                  PO25 256
IF(WTSCHM==1)WEIGHT=CNTWHT#            Stepweight from pattern          PO25 257
IF(WTSCHM==2)WEIGHT=1.0/(CNTSIG*CNTSIG)# Stepweight = 1/sigsq           PO25 258
DELTAW=DELTA*WEIGHT#                                                    PO25 259
#                                                                       PO25 260
#     LOAD INTENSITIES INTO PLOTTING ARRAY                              PO25 261
#     ------------------                                                PO25 262
#                                                                       PO25 263
K=NPH+6#                               Pointer to phase in point arra   PO25 264
PPOINT(K,PNTIND)=CNBCAL#               Cal step count for phase with    PO25 265
#                                                                       PO25 266
#   KEEP PATTERN STATISTICS                                             PO25 267
#   -----------------------                                             PO25 268
#                                                                       PO25 269
FAC1=DELTA*DELTA*WEIGHT#               Weighted delta**2                PO25 270
IF(FAC1<=0.)FAC2=0.#                                                    PO25 271
ELSE        FAC2=SQRT(FAC1)#           Delta/sigma                      PO25 272
RSUMS(51)=RSUMS(51)+ABS(DELTA)#        Sum delta                        PO25 273
RSUMS(52)=RSUMS(52)+CNTOBS#            Sum yobs                         PO25 274
RSUMS(53)=RSUMS(53)+CNTCAL#            Sum ycal                         PO25 275
RSUMS(54)=RSUMS(54)+FAC1#              Sum weighted delta**2            PO25 276
RSUMS(55)=RSUMS(55)+CNTOBS*CNTOBS*WEIGHT# Sum wt*(yobs)**2              PO25 277
IF(RSUMS(58)>-1.)#                     All except first step            PO25 278
RSUMS(56)=RSUMS(56)+(FAC2-RSUMS(58))**2# Sum diff**2 for d-stat         PO25 279
RSUMS(57)=RSUMS(57)+1.#                Sum nr of observations           PO25 280
RSUMS(58)=FAC2#                        Save this delta/sigma            PO25 281
IF(NCONTR>0)#                          Only when peaks are present      PO25 282
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PO25 283
RSUMS(59)=RSUMS(59)+ABS(CNBOBS-CNBCAL)# Sum delta                       PO25 284
RSUMS(60)=RSUMS(60)+CNBOBS#            Sum yobs no bgd                  PO25 285
RSUMS(61)=RSUMS(61)+1.#                Sum nr of observations           PO25 286
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PO25 287
#                                                                       PO25 288
RETURN#                                                                 PO25 289
END#                                                                    PO25 290
systemheader:(PO26)#                   Sum contributions to CALOBS
######################################################################  PO25   2
#                                                                       PO25   3
#                               PO26                                    PO25   4
#                                                                       PO25   5
######################################################################  PO25   6
SUBROUTINE PO26#                                                        PO25   7
include:(AACOMN)#                                                       PO25   8
include:(POCOMN)#                                                       PO25   9
#                                                                       PO25  10
REAL    BACGRD# ## background intensity, file or calculated             PO25  11
REAL    CNBCAL# ## calculated counts, no background                     PO25  12
REAL    CNBOBS# ## observed counts, no background                       PO25  13
REAL    CNTCAL# ## calculated step intensity (calculated counts)        PO25  14
REAL    DELTTH# ## distance between step and refl 2theta angles         PO25  15
REAL    DERCEL# ## derivative factor for cell parameters                PO25  16
REAL    DFSI#   ## value of symm der of pk shp function                 PO25  17
REAL    DFAI#   ## value of asymm der of pk shp function                PO25  18
REAL    DELTAW# ## weighted yobs-ycal                                   PO25  19
REAL    FAC1,FAC2,FAC3## multiplication factors in der calculation      PO25  20
INTEGER FLG#    ## flag to indicate pointer outside pk fn limits        PO25  21
REAL    FSI#    ## value of symm part of pk shp function                PO25  22
REAL    FAI#    ## value of asymm part of pk shp function               PO25  23
REAL    HWH#    ## Half width of a reflection peak                      PO25  24
INTEGER J,K,L#                                                          PO25  25
REAL    FCAL#   ## F                                                    PO25  26
REAL    ICAL#   ## Icalc = F**2 * m * otherfactors                      PO25  27
REAL    IOBS#   ## Iobs = 'observed' refl int, sum of peak contr        PO25  28
REAL    JCAL#   ## scaled intensity of a contributing refl              PO25  29
INTEGER NCONTR# ## nr of contributing reflections to a step             PO25  30
INTEGER NB#     ## nr of background parameters refined                  PO25  31
REAL    PAS#    ## Peak asymmetry of a reflection peak                  PO25  32
REAL    POF#    ## Preferred orientation factor                         PO25  33
REAL    PRFABS# ## position on peak profile (abs value)                 PO25  34
REAL    PRFSIG# ## position on peak profile                             PO25  35
REAL    PRFSGN# ## position on peak profile (-or+ = left/right)         PO25  36
REAL    PRFVAL# ## profile function value                               PO25  37
REAL    QRI#    ## 1/stepsize in pk shp function                        PO25  38
REAL    RATIO#  ## 2 theta diff / funcstep                              PO25  39
INTEGER REFLAG# ## flag to signal reflection at current step            PO25  40
REAL    SCALE#  ## scale obs intensity of a contributing refl           PO25  41
REAL    STOL#   ## F                                                    PO25  42
REAL    TTH#    ## 2 theta of a reflection                              PO25  43
INTEGER I#                                                              PO25  44
INTEGER IR,IC,IS,IB#                                                    PO25  45
REAL TANT#                                                              PO25  46
REAL FACDEL#                                                            PO25  47
REAL FACTTH#                                                            PO25  48
REAL FACASY#                                                            PO25  49
REAL FACHWD#                                                            PO25  50
REAL FAC4,FAC5,FAC6#                                                    PO25  51
REAL GPART,LPART,MIX#                                                   PO25  52
#                                                                       PO25  53
realdata:(PI,3.1415926); realdata:(G,2.7726); realdata:(C,0.939439)#    PO25  54
datastuff:#                                                             PO25  55
#                                                                       PO25  56
#                                                                       PO25  59
# BACKGROUND - CALCULATE AND BUILD DERIVATIVE                           PO25  60
# -------------------------------------------                           PO25  61
#                                                                       PO25  62
CALOBS=0.0#
NB=0#                                                                   PO25  63
BACGRD=CNTBAC#                         Use file value for bacgrd        PO25  64
CNBOBS=CNTOBS-BACGRD#                  Strip background contrib         PO25  65
#                                                                       PO25  67
#    LOOP ALL REFLNS CONTRIBUTING TO THIS PATTERN STEP                  PO25  68
#    -------------------------------------------------                  PO25  69
#                                                                       PO25  70
IF(LOHKL>HIHKL) RETURN#                No contributors, treat backgr    PO25  71
DO IR=LOHKL,HIHKL#                     Loop lowest to highest 2theta    PO25  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO25  73
IF(IR>IREFMX)#                                                          PO25  74
readdac:(ioda1:,,IR-IREFMX,(BUF(I),I=1,NEWPAK))# Read refln file        PO25  75
ELSE#                                                                   PO25  76
movereal:(QX,NEWM+(IR-1)*NEWPAK+1,BUF,1,NEWPAK,0)# Read from mem        PO25  77
#                                                                       PO25  78
#                                                                       PO25  80
RMUL  =BUF(4)#
TTH   =BUF(5)#                         2 theta of this i-th refl        PO25  81
RLPF  =BUF(6)#
HWH   =BUF(7)#                         Half width                       PO25  82
PAS   =BUF(8)#                         Peak asymmetry                   PO25  83
POF   =BUF(9)#                         Preferred orient factor          PO25  84
IOBS  =BUF(10)#                        'observed' refl intensity        PO25  89
#NPH   =NINT(BUF(10))#                 PHASE NUMBER                     PO25  85
FCAL  =BUF(11)#                        Calc refl intensity              PO25  86
ICAL  =BUF(14)#                        Calc refl intensity              PO25  87
DERCEL=BUF(15)#                        Derivative for cell parameters   PO25  88
POWFAC=RMUL*POF/RLPF#                  F^2 mult factor
IOBS=IOBS*POWFAC#                      what about a rescale ???
#                                                                       PO25  90
DELTTH=TT-TTH#                         Delta of step and refl angles    PO25  91
TANT=TAN(TT/114.591559)#               Tan theta                        PO25  93
STOL=SIN(TTH/114.591559)/LAMBDA#       Sin theta / lambda               PO25  94
#                                                                       PO25  95
#    APPLY PEAK PROFILE SHAPE FUNCTION                                  PO25  96
#    ---------------------------------                                  PO25  97
#                                                                       PO25  98
PRFVAL=0.; FLG=no:#                    Default & limit flag             PO25  99
PRFSIG=DELTTH/HWH#                     Nr hwidths from hkl 2theta       PO25 100
PRFSGN=SIGN(1.,PRFSIG)#                Left or right side of profile    PO25 101
PRFABS=ABS(PRFSIG)#                    Abs nr of hwidths from centre    PO25 102
#                                                                       PO25 103
IF(pkprofnr:<10)#                      Baerlocher & hepp's function     PO25 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO25 105
L     =PSHFLN(pkprofnr:)#              Nr of 5-value entries in table   PO25 106
J     =PSHFPT(pkprofnr:)#              Point to func array (markf)      PO25 107
QRI   =PSHFST(pkprofnr:)#              1/stepsize in func table         PO25 108
K=INT(PRFABS*QRI)+1#                   Step nr in func                  PO25 109
IF(K>=L) FLG=yes:#                     Outside function step limits     PO25 110
K=J+5*(K-1)#                           Lower step of func interval      PO25 111
RATIO=QRI*(PRFABS-QX(K+1))#            Hw diff / funcstepsz             PO25 112
FSI = QX(K+2)+RATIO*(QX(K+7)-QX(K+2))# Interpolate symm func            PO25 113
FAI =(QX(K+3)+RATIO*(QX(K+8)-QX(K+3)))*PRFSGN# Interpol asymm func      PO25 114
DFSI=(QX(K+4)+RATIO*(QX(K+9)-QX(K+4)))*PRFSGN# Interpol symm der        PO25 115
DFAI= QX(K+5)+RATIO*(QX(K+10)-QX(K+5))# Interpolate asymm der           PO25 116
FAC1=   1.-PAS*FAI#                    Apply peak asymmetry             PO25 117
FAC2=   FAC1*DFSI-PAS*FSI*DFAI#        Der prffunc wrt deltth           PO25 118
PRFVAL= FSI*FAC1/HWH#                  Profile function value           PO25 119
FACDEL= FAC2/(HWH*HWH)#                For zero corr                    PO25 120
FACTTH= -FACDEL#                       For cell                         PO25 121
FACASY= -FSI*FAI/HWH#                  For pasymm                       PO25 122
##FACHWD= -FSI*FACTTH + FAC1*PRFSIG#     For hwidth                     PO25 123
FACHWD= -PRFVAL/HWH#                   For hwidth                       PO25 124
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO25 125
#                                                                       PO25 126
ELSE#                                  Pseudo-voigt function            PO25 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO25 128
FAC1= 1./(1.+PRFSIG*PRFSIG)#                                            PO25 129
FAC2= -DELTTH*FAC1*FAC1/(PI*HWH*HWH*HWH)# Dl/ddel                       PO25 130
FAC3= -0.5*PRFSIG*FAC2 - 0.5/(PI*HWH*HWH*FAC1)# Dl/dsig                 PO25 131
FAC4= EXP(-0.25*G*PRFSIG*PRFSIG)#                                       PO25 132
FAC5= -0.25*C*G*PRFSIG*FAC4/(HWH*HWH)# Dg/ddel                          PO25 133
FAC6= -0.5*PRFSIG*FAC5 - 0.25*C*FAC4/(HWH*HWH)# Dg/dsig                 PO25 134
GPART= 0.5*C*FAC4/HWH#                 Gaussian part                    PO25 135
#WRITE(6,*) "MIXING PARAM",PRFSIG,PARPRO(NPH,6),GPART,HWH               PO25 136
LPART= 1./(PI*HWH)*FAC1#               Lorentzian part                  PO25 137
MIX=   PARPRO(NPH,6)#                  Mixing par                       PO25 138
PRFVAL= MIX*LPART + (1.-MIX)*GPART#    P-voigt prof func value          PO25 139
FACDEL= MIX*FAC2 + (1.-MIX)*FAC5#      For zero corr                    PO25 140
FACTTH= -FACDEL#                       For cell                         PO25 141
FACASY= -PRFVAL*PRFSGN*4.0*DELTTH*DELTTH# For pasymm                    PO25 142
FACHWD= MIX*FAC3 + (1.-MIX)*FAC6#      For hwidth                       PO25 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO25 144
#                                                                       PO25 145
IF(FLG==yes:) NEXT#                    Invalid fn lookup                PO25 146
#
#     CALCULATE OBSERVED INTENSITY                                      PO25 224
#     ----------------------------                                      PO25 225
## i.e. scale obs to cal intensity, then build iobs for each of the     PO25 226
## overlapping reflections by integrating over its peak                 PO25 227
SCALE=1.0#
#JOBS=IOBS*PRFVAL#                     Step contr=icalc*proffunc        PO25 147
CALOBS=CALOBS+IOBS*PRFVAL*SCALE*TTSTEP# Sum iobs+(scl*ical*ttstep)  
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO25 221
#                                                                       PO25 248
#     LOAD INTENSITIES INTO PLOTTING ARRAY                              PO25 261
#     ------------------                                                PO25 262
#                                                                       PO25 263
PPOINT(ycalobs:+NPH,PNTIND)=CALOBS#    Cal step count for phase with    PO25 265
#                                                                       PO25 266
#                                                                       PO25 288
RETURN#                                                                 PO25 289
END#                                                                    PO25 290
systemheader:(PO27)#                   Auto calc intensity range
####################################################################### PO29   2
#                                                                     # PO29   3
#                          PO27                                       # PO29   4
#                                                                     # PO29   5
####################################################################### PO29   6
SUBROUTINE PO27#                                                        PO29   7
include:(AACOMN)#                                                       PO29   8
include:(POCOMN)#                                                       PO29   9
#                                                                       PO29  10
REAL SCALE#                                                             PO29  11
INTEGER I#                                                              PO29  12
REAL CTOTNB#                                                            PO29  13
REAL CAL,OBS,OBSNB#                                                     PO29  14
REAL CMAX,OMAX,CTOT#                                                    PO29  15
#                                                                       PO29  16
# FIND MAXIMUM PLOTTABLE POINT
# ----------------------------
#
CMAX=0.0
OMAX=0.0
DO I=1,PNTIND#                                                          PO29  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO29  27
CMAX=MAX(CMAX,PPOINT(5,I))#       Maximum ctot 
OMAX=MAX(OMAX,PPOINT(2,I))#       Maximum observed 
$)
#
YMAX=MAX(CMAX,OMAX)#                   Absolute plot maximum
if(YMAX<1.0)YMAX=9000.#                dummy default
#
YL=LOG10(YMAX)
TYL=AINT(YL)
YD=YL-TYL#
if(YL-TYL>LOG10(5.)) YMAX=   10.**(TYL+1)# 100.,1000.,10000 ...
if(YL-TYL>LOG10(2.5))YMAX=5.0*10.**TYL#  50.,500.,5000. ...
ELSE                 YMAX=2.5*10.**TYL# 
YMIN=-YMAX/10.#                       ten percent -ive
#
# APPLY NEW DEFAULTS IF NO USER INPUT
#
DO PT=1,maxgn:;if(axmax:(2)<0.0)#     using preset defaults
$(
axmax:(2)=db:(YMAX)#                  set pattern  max  
axmin:(2)=db:(YMIN)#                  set pattern  min  
$)
##                                                                      PO29  62
RETURN#                                                                 PO29  63
END#                                                                    PO29  64
systemheader:(PO28)#                   Apply overall temperature fact   PO28   1
####################################################################### PO28   2
#                                                                     # PO28   3
#                          PO28                                       # PO28   4
#                                                                     # PO28   5
####################################################################### PO28   6
SUBROUTINE PO28(PH,TEMP)#                                               PO28   7
include:(AACOMN)#                                                       PO28   8
include:(POCOMN)#                                                       PO28   9
#                                                                       PO28  10
INTEGER PH#                                                             PO28  11
REAL TEMP#                                                              PO28  12
INTEGER I,PHL#                                                          PO28  13
INTEGER FIRST,LAST#                                                     PO28  14
INTEGER FREFL,LREFL#                                                    PO28  15
REAL    STOL,OTEMP,TFAC#                                                PO28  16
#                                                                       PO28  17
PHL=PH#                                Don't modify this parameter      PO28  18
IF (PHL==0) $(FIRST=1  ;LAST=NPHASE$)#                                  PO28  19
ELSE        $(FIRST=PHL;LAST=PHL$)#                                     PO28  20
#                                                                       PO28  21
DO PHL=FIRST,LAST#                     Cycle over graph plots           PO28  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO28  23
OTEMP=ADISP(PHL)#                      Old/original scale factor        PO28  24
ADISP(PHL)=TEMP#                       New scale                        PO28  25
TFAC =OTEMP-TEMP#                      Modification factor              PO28  26
FREFL=FIRREF(PHL)#                     First reflection                 PO28  27
LREFL=FIRREF(PHL+1)-1#                 Last reflection                  PO28  28
DO IREFL=FREFL,LREFL#                  Loop all phase reflections       PO28  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO28  30
readdac:(ioda2:,,IREFL,(BUF(I),I=1,HKLPAK))# Read refln file            PO28  31
STOL=SIN(BUF(5)/114.591559)/LAMBDA#    Sin theta / lambda               PO28  32
BUF(13)=BUF(13)*EXP(TFAC*STOL*STOL)#   Recalibrate ical                 PO28  33
writedac:(ioda2:,,IREFL,(BUF(I),I=1,HKLPAK))# Read refln file           PO28  34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO28  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO28  36
#                                                                       PO28  37
RETURN#                                                                 PO28  38
END#                                                                    PO28  39
systemheader:(PO29)#                   Calculate total and difference   PO29   1
####################################################################### PO29   2
#                                                                     # PO29   3
#                          PO29                                       # PO29   4
#                                                                     # PO29   5
####################################################################### PO29   6
SUBROUTINE PO29(SCALE)#                                                 PO29   7
include:(AACOMN)#                                                       PO29   8
include:(POCOMN)#                                                       PO29   9
#                                                                       PO29  10
REAL SCALE#                                                             PO29  11
INTEGER I,J,J1#                                                         PO29  12
REAL CTOTNB#                                                            PO29  13
REAL CAL,OBS,OBSNB#                                                     PO29  14
REAL CMAX,OMAX,CTOT#                                                    PO29  15
#                                                                       PO29  16
SCALE=1.0#                                                              PO29  17
IF    (AUTSKF==0)     SCALE=1.0#       Do nothing except diff           PO29  18
ELSEIF(PFILES(1)==' '&ISCOBS==0) SCALE=1.0# No pat to scale against 
ELSE#                                                                   PO29  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO29  21
CMAX=0.#                                                                PO29  22
OMAX=0.#                                                                PO29  23
CAL=0.#                                                                 PO29  24
OBS=0.#                                                                 PO29  25
DO I=1,PNTIND#                                                          PO29  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO29  27
CTOTNB=0.#                             Initialize for tt point          PO29  28
OBSNB=PPOINT(2,I)-PPOINT(4,I)#         Remove the background from obs   PO29  29
DO J=1,NPHASE#                         For every phase                  PO29  30
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO29  31
CTOTNB=CTOTNB+ PPOINT(6+J,I)#          Sum all calculated intensities   PO29  32
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO29  33
CAL=CAL+CTOTNB#                        Sum up the total                 PO29  34
CMAX=MAX(CMAX,CTOTNB)#                 Maximum ctot - no bak            PO29  35
OMAX=MAX(OMAX,OBSNB)#                  Maximum observed - no bak        PO29  36
OBS=OBS+OBSNB#                         Sum up the observed              PO29  37
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO29  38
IF    (AUTSKF==1)#                     Max cal height = obs height      PO29  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO29  40
ifeq:(CMAX,0.0)     SCALE=1.0#                   
ELSE ifeq:(OMAX,0.0)SCALE=1.0#                   
ELSE                SCALE=OMAX/CMAX#             
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO29  43
ELSEIF(AUTSKF==2)#                     Total cal area = obs area        PO29  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO29  45
ifeq:(CAL,0.0)      SCALE=1.0#                    
ELSE ifeq:(OBS,0.0) SCALE=1.0#                    
ELSE                SCALE=OBS/CAL#                
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO29  48
ELSE#                                  Default scale calc               PO29  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO29  50
ifeq:(CMAX,0.0)     SCALE=1.0#                  
ELSE ifeq:(OMAX,0.0)SCALE=1.0#                 
ELSE                SCALE=OMAX/CMAX#          
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO29  53
#                                                                       PO29  54
#  RESCALE ALL                                                          PO29  55
#  -----------                                                          PO29  56
#                                                                       PO29  57
J1=6+NPHASE#                                                            PO29  58
DO I=1,PNTIND;DO J=7,J1#               For every point for everyphase   PO29  59
PPOINT(J,I)=PPOINT(J,I)*SCALE#         Rescale calculated               PO29  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO29  61
##                                                                      PO29  62
RETURN#                                                                 PO29  63
END#                                                                    PO29  64
systemheader:(PO30)#                   Calculate ftot,fobs-fcal         PO30   1
####################################################################### PO30   2
#                                                                     # PO30   3
#                          PO30                                       # PO30   4
#                                                                     # PO30   5
####################################################################### PO30   6
SUBROUTINE PO30#                                                        PO30   7
include:(AACOMN)#                                                       PO30   8
include:(POCOMN)#                                                       PO30   9
#                                                                       PO30  10
INTEGER J1,I,J#                                                         PO30  11
REAL CTOTNB#                                                            PO30  12
REAL OTOTNB#                                                            PO30  12
#                                                                       PO30  13
J1=6+NPHASE#                                                            PO30  14
IPAT=yes:#                             Assume we have a pattern
IF(PFILES(1)==' ') IPAT=no:#           No pattern supplied
DO I=1,PNTIND#                                                          PO30  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO30  16
CTOTNB=0.#                             Initialize for tt point          PO30  17
OTOTNB=0.#
DO J=7,J1#                             For every phase                  PO30  18
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO30  19
CTOTNB=CTOTNB+ PPOINT(J,I)#            Sum all calculated intensities   PO30  20
OTOTNB=OTOTNB+ PPOINT(J+maxpha:,I)#    Sum all calculated intensities   PO30  20
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO30  21
IF(IPAT==no:) PPOINT(yobs:,I)=OTOTNB+PPOINT(ybackgd:,I)#Obsint+back  
#write(6,*) PPOINT(1,I),PPOINT(yobs:,I),PPOINT(ycaltot:,I)#
PPOINT(ycaltot:,I)=CTOTNB+PPOINT(ybackgd:,I)# Calint + back 
PPOINT(ydelta:,I)=PPOINT(yobs:,I)-PPOINT(ycaltot:,I)#Obs+back-caltot+back
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO30  24
#                                                                       PO30  25
RETURN#                                                                 PO30  26
END#                                                                    PO30  27
systemheader:(PO31)#                   Reapply scale factors            PO31   1
####################################################################### PO31   2
#                                                                     # PO31   3
#                          PO31                                       # PO31   4
#                                                                     # PO31   5
####################################################################### PO31   6
SUBROUTINE PO31(PH,SCALE)#                                              PO31   7
include:(AACOMN)#                                                       PO31   8
include:(POCOMN)#                                                       PO31   9
#                                                                       PO31  10
INTEGER PH#                                                             PO31  11
INTEGER PHL#                                                            PO31  12
REAL SCALE#                                                             PO31  13
INTEGER I,FIRST,LAST#                                                   PO31  14
INTEGER FREFL,LREFL#                                                    PO31  15
REAL    OSKAL,SKAL#                                                     PO31  16
#                                                                       PO31  17
PHL=PH#                                Don't modify this parameter      PO31  18
IF (PHL==0) $(FIRST=1;LAST=NPHASE$)#                                    PO31  19
ELSE       $(FIRST=PHL;LAST=PHL$)#                                      PO31  20
DO PHL=FIRST,LAST#                     Cycle over graph plots           PO31  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO31  22
OSKAL  =SKF(PHL)#                      Old/original scale factor        PO31  23
SKF(PHL)=SCALE#                        New scale                        PO31  24
#                                                                       PO31  25
# LOOP OVER ALL REFLECTIONS FOR PHASE                                   PO31  26
FREFL=FIRREF(PHL)#                     First reflection                 PO31  27
LREFL=FIRREF(PHL+1)-1#                 Last reflection                  PO31  28
#                                                                       PO31  29
IF (OSKAL<=9.9E-30) RETURN#            Best i can do                    PO31  30
SKAL=SCALE/OSKAL#                      Modification factor              PO31  31
DO IREFL=FREFL,LREFL#                  Loop current active hkl number   PO31  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO31  33
readdac:(ioda2:,,IREFL,(BUF(I),I=1,HKLPAK))# Read refln file            PO31  34
BUF(12)=BUF(12)*SKAL#                  Recalibrate powder factor        PO31  35
BUF(13)=BUF(13)*SKAL#                  Recalibrate ical                 PO31  36
writedac:(ioda2:,,IREFL,(BUF(I),I=1,HKLPAK))# Read refln file           PO31  37
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO31  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO31  39
#                                                                       PO31  40
RETURN#                                                                 PO31  41
END#                                                                    PO31  42
systemheader:(PO32)#                   Load secondary pot file into m   PO32   1
####################################################################### PO32   2
#                                                                     # PO32   3
#                          PO32                                       # PO32   4
#                                                                     # PO32   5
####################################################################### PO32   6
SUBROUTINE PO32#                                                        PO32   7
include:(AACOMN)#                                                       PO32   8
include:(POCOMN)#                                                       PO32   9
#                                                                       PO32  10
INTEGER IP#                                                             PO32  11
chardata:(PO3101," WARNING --- POINTS EXCEED POINT ARRAY SIZE       ")# PO32  12
datastuff:#                                                             PO32  13
#                                                                       PO32  14
PNTIND= 1#                             Begin from first entry           PO32  15
REPEAT#                                Read up to maxs: pattern entri   PO32  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO32  17
readwpkt:(3,lrppat:,PACK,IP,0)#        Read step packet                 PO32  18
IF(IP<=0\PNTIND>maxs:) BREAK#          Finished or out of space         PO32  19
PPOINT(1,PNTIND) = QX(IP+1)#           Two theta                        PO32  20
PPOINT(2,PNTIND) = QX(IP+2)#           Obs step count                   PO32  21
PPOINT(3,PNTIND) = QX(IP+3)#           Obs step sigma                   PO32  22
PPOINT(4,PNTIND) = QX(IP+6)#           Obs step background              PO32  23
PPOINT(5,PNTIND) = QX(IP+5)#           Cal step count all phases        PO32  24
PPOINT(6,PNTIND) = QX(IP+2)-QX(IP+5)#  Del=obs-cal step count all pha   PO32  25
PPOINT(7,PNTIND) = QX(IP+5)#           Cal step count for phase 1       PO32  26
PNTIND = PNTIND+1#                                                      PO32  27
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO32  28
PNTIND=PNTIND-1#                                                        PO32  29
IF(PNTIND>maxs:)#                      Exceeded available memory        PO32  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO32  31
writeline:(0,PO3101,NPO3101,3,1)#      Prolly should quit and recompi   PO32  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO32  33
#                                                                       PO32  34
RETURN#                                                                 PO32  35
END#                                                                    PO32  36
systemheader:(PO33)#                   Preprocess axes                  PO33   1
####################################################################### PO33   2
#                                                                     # PO33   3
#                          PO33                                       # PO33   4
#                                                                     # PO33   5
####################################################################### PO33   6
SUBROUTINE PO33(GR)#                                                    PO33   7
include:(POCOMN)#                                                       PO33   8
INTEGER PT,GR#                                                          PO33   9
INTEGER GRMIN,GRMAX,I,J,K,POW1,POW2#                                    PO33  10
REAL LVAL,FVAL,DVAL,LARGE#                                              PO33  11
REAL TMP#                                                               PO33  12
REAL RANGE,BGVAL,SMVAL#                                                 PO33  13
realdata:(UNITS,[1,1.5,2.0,2.5,5.])#                                    PO33  14
datastuff:#                                                             PO33  15
#                                                                       PO33  16
GRMIN=GR;GRMAX=GR#                     Set first and last plots         PO33  17
IF(GR==0)#                             Flag to cycle over all plots     PO33  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO33  19
GRMIN=1;GRMAX=maxgn:#                  Set first and last plots         PO33  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO33  21
#                                                                       PO33  22
DO PT=GRMIN,GRMAX#                     Cycle over specified graphs      PO33  23
DO I=1,2#                              Cycle over both axes             PO33  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO33  25
IF(axmax:(I)<axmin:(I))#               An error so swap axes limits     PO33  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO33  27
TMP=axmin:(I)#                                                          PO33  28
axmin:(I)=axmax:(I)#                   Reset min value                  PO33  29
axmax:(I)=axmin:(I)#                   Reset max value                  PO33  30
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO33  31
IF(I==1&axmin:(1)<0.0)  axmin:(1)=0.0# Min value not sensible           PO33  32
IF(I==1&axmax:(1)>180.0)axmax:(1)=180.0# Max value not sensible         PO33  33
IF (NINT(axauto:(I))==no:)NEXT#        Skip if auto not applied         PO33  34
IF (axtype:(I)==1)#                    Linear axis                      PO33  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO33  36
RANGE=axmax:(I)-axmin:(I)#                                              PO33  37
LARGE=RANGE/axbtick:(I)#               Assume axbtick: approx 10        PO33  38
POW1=NINT(LOG10(LARGE)-1.0)#                                            PO33  39
POW2=NINT(LOG10(LARGE)+1.0)#                                            PO33  40
DO J=POW1,POW2#                                                         PO33  41
DO K=1,5;IF(UNITS(K)*10.**J >LARGE) GOTO10#                             PO33  42
10 CONTINUE#                                                            PO33  43
BGVAL=UNITS(K)*10.**J#                 Big unit value                   PO33  44
IF(K!=1)SMVAL=UNITS(K-1)*10.**J#       Small unit value                 PO33  45
ELSE    SMVAL=UNITS(5)*10.**(J-1)#     Small unit value                 PO33  46
DVAL=BGVAL#                            Round up                         PO33  47
ifne:(FLOAT(NINT(UNITS(K))),UNITS(K))# Not aesthetically pleasing       PO33  48
IF (BGVAL-LARGE>LARGE-SMVAL)DVAL=SMVAL# Round down                      PO33  49
#                                                                       PO33  50
FVAL=DVAL*FLOAT(NINT(axmin:(I)/DVAL))# Get first value                  PO33  51
IF(FVAL<axmin:(I))FVAL=FLOAT(NINT(axmin:(I)/DVAL)+1)*DVAL#              PO33  52
LVAL=FVAL+FLOAT(NINT((axmax:(I)-FVAL)/DVAL)+1)*DVAL# Get last value     PO33  53
IF(LVAL>axmax:(I))LVAL=LVAL-DVAL#                                       PO33  54
#                                                                       PO33  55
axlbtick:(I)=LVAL#                     Set last big tick mark           PO33  56
axfbtick:(I)=FVAL#                     Set first big tick mark          PO33  57
axbticks:(I)=DVAL#                     Set big tick mark spacing        PO33  58
#                                                                       PO33  59
#   LABELLED TICK MARKS                                                 PO33  60
#   -------------------                                                 PO33  61
#                                                                       PO33  62
axfltick:(I)=FVAL#                     First labelled tick mark         PO33  63
axlltick:(I)=LVAL#                     First labelled tick mark         PO33  64
axlticks:(I)=2*DVAL#                   First labelled tick mark         PO33  65
#                                                                       PO33  66
#  SET MEDIUM TICK MARKS                                                PO33  67
#  ---------------------                                                PO33  68
#                                                                       PO33  69
axmticks:(I)=DVAL#                     Same spacing as for large tick   PO33  70
axfmtick:(I)=FVAL-DVAL/2.0#            Subtract half tick spacing       PO33  71
IF(axfmtick:(I)<axmin:(I))axfmtick:(I)=FVAL+DVAL/2.0#                   PO33  72
axlmtick:(I)=LVAL+DVAL/2.0#            Add half large tick mark spaci   PO33  73
IF(axlmtick:(I)>axmax:(I))axlmtick:(I)=LVAL-DVAL/2.0#                   PO33  74
#                                                                       PO33  75
#  SET SMALL TICK MARKS                                                 PO33  76
#  ---------------------                                                PO33  77
#                                                                       PO33  78
axsticks:(I)=DVAL/10.#                 Same spacing as for large tick   PO33  79
axfstick:(I)=FVAL-DVAL#                Subtract one large tick mark s   PO33  80
REPEAT#                                                                 PO33  81
IF(axfstick:(I)<axmin:(I))axfstick:(I)=axfstick:(I)+axsticks:(I)#       PO33  82
ELSE BREAK#                                                             PO33  83
axlstick:(I)=LVAL+DVAL#                Add half large tick mark spaci   PO33  84
REPEAT#                                                                 PO33  85
IF(axlstick:(I)>axmax:(I))axlstick:(I)=axlstick:(I)-axsticks:(I)#       PO33  86
ELSE BREAK#                                                             PO33  87
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO33  88
IF (I==2&axtype:(I)==2);#              Logarithmic                      PO33  89
IF (I==2&axtype:(I)==3);#              Square root                      PO33  90
#                                                                       PO33  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO33  92
#                                                                       PO33  93
RETURN#                                                                 PO33  94
END#                                                                    PO33  95
systemheader:(PO34)#                   Preprocess graphic block posit   PO34   1
####################################################################### PO34   2
#                                                                     # PO34   3
#                          PO34                                       # PO34   4
#                                                                     # PO34   5
####################################################################### PO34   6
SUBROUTINE PO34#                                                        PO34   7
include:(POCOMN)#                                                       PO34   8
INTEGER PT#                                                             PO34   9
INTEGER I,J,K,L#                                                        PO34  10
INTEGER GXMAX,GXMIN,GYMAX,GYMIN#                                        PO34  11
INTEGER HNUM,VNUM,DIM#                                                  PO34  12
INTEGER ICNT,NCNT#                                                      PO34  13
#                                                                       PO34  14
ICNT=0;NCNT=0#                         Initialise invoked graph count   PO34  15
DO PT=1,maxgn:;IF(NINT(gptinvoked:)==yes:)ICNT=ICNT+1# Count invoked    PO34  16
#                                                                       PO34  17
DO I=1,miv:+1;DO J=1,miv:+1;GRINDX(I,J)=0# Initialise graph array to    PO34  18
DO PT=1,maxgn:#                        Test to see if graphs are inde   PO34  19
IF(NINT(gptinvoked:)==yes:)#           This graph block is invoked      PO34  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO34  21
IF(gptxindex:<=0.\gptxindex:>FLOAT(miv:))gptxindex:=0.# Rationalise x   PO34  22
IF(gptyindex:<=0.\gptyindex:>FLOAT(miv:))gptyindex:=0.# Rationalise y   PO34  23
I=NINT(gptxindex:);J=NINT(gptyindex:)# Get index pointers               PO34  24
IF(I!=0&J!=0&GRINDX(J,I)==0)GRINDX(J,I)=PT# Register this graph         PO34  25
ELSE $(#                                                                PO34  26
NCNT=NCNT+1#                                                            PO34  27
gptxindex:=0.;gptyindex:=0.#           Reset the x and y indices        PO34  28
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO34  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO34  30
#                                                                       PO34  31
IF(NCNT<=0)GOTO 100#                   All invoked graphs are indexed   PO34  32
DO J=1,miv:;GRINDX(miv:+1,J)=0#        Cycle over grindx columns        PO34  33
DO I=1,miv:#                           Cycle over grindx rows           PO34  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO34  35
GRINDX(I,miv:+1)=0#                    Initialise to 0                  PO34  36
DO J=1,miv:#                           Cycle over grindx columns        PO34  37
IF(GRINDX(I,J)!=0)#                    Non zero index entry             PO34  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO34  39
GRINDX(I,miv:+1)=GRINDX(I,miv:+1)+1#   Sum occupied rows                PO34  40
GRINDX(miv:+1,J)=GRINDX(miv:+1,J)+1#   Sum occupied columns             PO34  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO34  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO34  43
DO I=1,miv:;IF(GRINDX(miv:+1,I)!=0) BREAK# Break at first non zero su   PO34  44
GXMIN=I#                               Minimum index entry              PO34  45
DO I=miv:,GXMIN,-1;IF(GRINDX(miv:+1,I)!=0) BREAK# Break at first non    PO34  46
GXMAX=I#                               Maximum index entry              PO34  47
DO I=1,miv:;IF(GRINDX(I,miv:+1)!=0) BREAK# Break at first non zero su   PO34  48
GYMIN=I#                               Minimum index entry              PO34  49
DO I=miv:,GYMIN,-1;IF(GRINDX(I,miv:+1)!=0) BREAK# Break at first zero   PO34  50
GYMAX=I#                               Maximum index entry              PO34  51
HNUM=0#                                Initialise horiz num to 0        PO34  52
DO I=1,miv:;IF(GRINDX(miv:+1,I)!=0)HNUM=HNUM+1# Increment horiz numbe   PO34  53
VNUM=0#                                Initialise vert num to 0         PO34  54
DO I=1,miv:;IF(GRINDX(I,miv:+1)!=0)VNUM=VNUM+1# Increment vert number   PO34  55
#                                                                       PO34  56
#    OK, WE NOW HAVE THE MINX,MAXX,MINY,MAXY,HNUM,VNUM                  PO34  57
#    -------------------------------------------------                  PO34  58
#                                                                       PO34  59
#IF(PRPAGE(PRASPECT:)<1.0);#           MUST BE A PORTRAIT PAGE          PO34  60
#ELSE ;#                               EITHER AS IS OR LANDSCAPE        PO34  61
IF    (ICNT>maxgn:)iquit:(PO3401)#     Too many graphs                  PO34  62
ELSEIF(ICNT>16)DIM=4#                  Use a 5x5 model                  PO34  63
ELSEIF(ICNT>9)DIM=3#                   Use a 4x4 model                  PO34  64
ELSEIF(ICNT>4)DIM=2#                   Use a 3x3 model                  PO34  65
ELSE          DIM=1#                   Assume a 2x2 model               PO34  66
GXMIN=(GXMIN+GXMAX)/2 -DIM/2#          Take average as x centre         PO34  67
GYMIN=(GYMIN+GYMAX)/2 -DIM/2#          Take average as y centre         PO34  68
GXMIN=MAX(1,GXMIN)#                    Obtain minimum x value           PO34  69
GYMIN=MAX(1,GYMIN)#                    Obtain minimum y value           PO34  70
GXMAX=GXMIN+DIM      ;GYMAX=GYMIN+DIM# Calculate maximum x/y values     PO34  71
GXMAX=MIN(GXMAX,miv:);GYMAX=MIN(GYMAX,miv:)# Check for index limits     PO34  72
GXMIN=GXMAX-DIM      ;GYMIN=GYMAX-DIM# Reset minimum values according   PO34  73
#                                                                       PO34  74
PT=1#                                  Begin with first graph           PO34  75
DO I=GXMIN,GXMAX#                      Cycle over possible horiz bloc   PO34  76
DO J=GYMIN,GYMAX#                      Cycle over possible vert block   PO34  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO34  78
IF(GRINDX(J,I)!=0)NEXT#                Check if spot available          PO34  79
REPEAT#                                Check remaining graph blocks     PO34  80
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO34  81
IF(PT>maxgn:)GOTO 100#                 Assigned all graphs              PO34  82
IF(NINT(gptinvoked:)==yes:)#           Igraph pt is invoked             PO34  83
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO34  84
K=NINT(gptxindex:);L=NINT(gptyindex:)# Get index pointers               PO34  85
IF(K==0\L==0)#                         An unassigned graph              PO34  86
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PO34  87
gptxindex:=float:(I);gptyindex:=float:(J)#                              PO34  88
GRINDX(J,I)=PT#                        Set index to graph number        PO34  89
BREAK#                                 Break from the repeat loop       PO34  90
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PO34  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO34  92
PT=PT+1#                               Jump to next graph               PO34  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO34  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO34  95
#                                                                       PO34  96
100CONTINUE#                           All invoked graphs are indexed   PO34  97
RETURN#                                                                 PO34  98
END#                                                                    PO34  99
systemheader:(PO35)#                   Single graphic block plot inte   PO35   1
####################################################################### PO35   2
#                                                                     # PO35   3
#                          PO35                                       # PO35   4
#                                                                     # PO35   5
####################################################################### PO35   6
SUBROUTINE PO35#                                                        PO35   7
#INCLUDE:(AACOMN)#                                                      PO35   8
include:(POCOMN)#                                                       PO35   9
#                                                                       PO35  10
INTEGER PT,PH#                                                          PO35  11
INTEGER I,NC#                                                           PO35  12
REAL BLKASP#                                                            PO35  13
string:(TEXT,100)#                                                      PO35  14
datastuff:#                                                             PO35  15
#                                                                       PO35  16
VUTYPE=0#                              Single plot mode                 PO35  17
#                                                                       PO35  18
#   RESIZE  AND REPOSITION THE SCROLL BAR                               PO35  19
#   -------------------------------------                               PO35  20
#                                                                       PO35  21
setcanvas:(graphc:,0)#                 Load wi array                    PO35  22
erasepage:(graphc:,1)#                 Erase and delete segments        PO35  23
BLKASP=gptbaspect:(CURPLT)#            Graph block aspect ratio         PO35  24
canvaspects:(graphc:,BLKASP)#          Set desired aspect ratio         PO35  25
#                                   RESIZE SCROLL BARS                  PO35  26
TEXT='set horizmag '#                                                   PO35  27
ncodefld:(ZOOM(CURPLT,zoomx:),1,TEXT,301032.,1)# Encode the number in   PO35  28
tcleval:(TEXT)#                                                         PO35  29
TEXT='set vertmag  '#                                                   PO35  30
ncodefld:(ZOOM(CURPLT,zoomy:),1,TEXT,301032.,1)# Encode the number in   PO35  31
tcleval:(TEXT)#                                                         PO35  32
scrollvarls:(graphc:,#                                                  PO35  33
ZOOM(CURPLT,zoomx:),ZOOM(CURPLT,zoomy:),#                               PO35  34
HSCROLL(CURPLT,sccentre:),VSCROLL(CURPLT,sccentre:))# Widget dimens     PO35  35
#                                                                       PO35  36
#                                                                       PO35  37
#   PREDETERMINE SCALE FACTORS AND TRANSLATIONS                         PO35  38
#   -------------------------------------------                         PO35  39
#                                                                       PO35  40
#    ASSUMES PIXMAP DIMENSIONS ARE  1.0* 1.4 OR 1.4*1.0  FOR E.G.       PO35  41
RELXOR=0.0#                            Set relative block origin        PO35  42
RELYOR=0.0#                            Set relative block origin        PO35  43
RELSCF=1.0#                            Relative scale factor            PO35  44
#                                                                       PO35  45
setcanvas:(graphc:,0)#                                                  PO35  46
SEGSUM=0#                              Initialise segment sum           PO35  47
RTSC=rws11:#                                                            PO35  48
CALL PO38(CURPLT)#                     Draw current graph block plot    PO35  49
#                                                                       PO35  50
#   ADD THE ACTUAL CURVES TO THE GRAPH PLOT                             PO35  51
#   ---------------------------------------                             PO35  52
#                                                                       PO35  53
DO I=2,6+maxpha:#                      Cycle over all phases but twot   PO35  54
IF(NINT(cvdisplay:(CURPLT,I))==yes:)#  Do plot this curve               PO35  55
CALL PO39(I,CURPLT)#                   Call plotting subroutine         PO35  56
#                                                                       PO35  57
#   ADD THE HKLBARS TO THE PLOT IF REQUIRED                             PO35  58
#   ---------------------------------------                             PO35  59
#                                                                       PO35  60
#   UPDATE VALUES IN TCL INCASE SOMEONE WANTS TO CHANGE THEM!           PO35  61
#                                                                       PO35  62
PT=CURPLT;PH=1#                                                         PO35  63
setival:(nint:(hbdisplay:(PT,PH)),'hklbSettings(Amarkers)')#            PO35  64
####setival:(MRANGE,'hklbSettings(AmRange)')                            PO35  65
####setival:(LRANGE,'hklbSettings(AlRange)')                            PO35  66
###hbshift:(PT,PH)   =float:(yes:)#    displace curve (yes/no)          PO35  67
setfval:(sg:(hbymin:(PT,PH)),     'hklbSettings(AmImin)')#              PO35  68
setfval:(sg:(hbsize:(PT,PH)),     'hklbSettings(AmSize)')#              PO35  69
setfval:(sg:(hbyoffset:(PT,PH)),  'hklbSettings(Amyoff)')#              PO35  70
setfval:(sg:(hbxoffset:(PT,PH)),  'hklbSettings(Amxoff)')#              PO35  71
setival:(nint:(hblabel:(PT,PH)),  'hklbSettings(Alabels)')#             PO35  72
setfval:(sg:(hblabymin:(PT,PH)),  'hklbSettings(AlImin)')#              PO35  73
setfval:(sg:(hbfontsize:(PT,PH)), 'hklbSettings(AlSize)')#              PO35  74
setfval:(sg:(hbangle:(PT,PH)),    'hklbSettings(AlAngle)')#             PO35  75
setfval:(sg:(hblabshx:(PT,PH)),   'hklbSettings(Alxoff)')#              PO35  76
setfval:(sg:(hblabshy:(PT,PH)),   'hklbSettings(Alyoff)')#              PO35  77
#                                                                       PO35  78
#                                                                       PO35  79
#                                                                       PO35  80
#                                                                       PO35  81
DO I=1,NPHASE#                         Cycle over all phases but twot   PO35  82
IF(nint:(hbdisplay:(CURPLT,I))!=no:\#  Do plot the hkl bars             PO35  83
nint:(hblabel:(CURPLT,I))  !=no:)#     Do plot the hkl labels           PO35  84
CALL PO40(I,CURPLT)#                   Call plotting subroutine         PO35  85
#                                                                       PO35  86
#    DISPLAY TITLE IN TITLE SUBWINDOW                                   PO35  87
#    --------------------------------                                   PO35  88
#                                                                       PO35  89
TEXT='set GraphNumber     '#                                            PO35  90
ncodefld:(FLOAT(CURPLT),1,TEXT,200213.,1)# Encode the number in text    PO35  91
tcleval:(TEXT)#                                                         PO35  92
NC=nint:(tichars:(CURPLT))#            Num of chars in title text       PO35  93
TEXT(1^NC)=TITLET(CURPLT)#                                              PO35  94
TEXT='set GraphTitle "'//TITLET(CURPLT)(1^NC)//'"'#                     PO35  95
tcleval:(TEXT)#                                                         PO35  96
#                                                                       PO35  97
#                                                                       PO35  98
# DON'T PRE-EMT THE ABSCISSA AND ORDINATE EXPOSE EVENTS                 PO35  99
# OR THE LEGEND EXPOSE EVENTS. THEY HAVE FREE ASPECT RATIOS             PO35 100
# AND WILL SURELY BE IN CORRECT UNTIL THE RESIZE EVENTS HAVE BEEN       PO35 101
# HANDLED                                                               PO35 102
#CALL PO41(CURPLT)#                       CONSTRUCT ABSCISSA PIXMAP     PO35 103
#CALL PO42(CURPLT)#                       CONSTRUCT ORDINATE PIXMAP     PO35 104
CALL POA4#                                                              PO35 105
#                                                                       PO35 106
CALL PO56#                             Update the tk legend vars        PO35 107
#                                                                       PO35 108
setfval:((axmin:(CURPLT,1)),'plotRange(Axmin)')#                        PO35 109
setfval:((axmax:(CURPLT,1)),'plotRange(Axmax)')#                        PO35 110
setfval:((axmin:(CURPLT,2)),'plotRange(Aymin)')#                        PO35 111
setfval:((axmax:(CURPLT,2)),'plotRange(Aymax)')#                        PO35 112
#
setival:(CURPLT,'applyTo(AGnum)')
setival:(NINT(gptxindex:(CURPLT)),'applyTo(AXpos)')
setival:(NINT(gptyindex:(CURPLT)),'applyTo(AYpos)')
#                                                                       PO35 113
#                                                                       PO35 114
RETURN#                                                                 PO35 115
END#                                                                    PO35 116
systemheader:(PO36)#                   Preview/paper-printing subrout   PO36   1
####################################################################### PO36   2
#                                                                     # PO36   3
#                          PO36                                       # PO36   4
#                                                                     # PO36   5
####################################################################### PO36   6
SUBROUTINE PO36(FLAG)#                                                  PO36   7
include:(AACOMN)#                                                       PO36   8
include:(POCOMN)#                                                       PO36   9
#                                                                       PO36  10
INTEGER I#                                                              PO36  11
INTEGER FLAG#                          Paper preview=1/print=2          PO36  12
INTEGER PT#                            Graph counter                    PO36  13
REAL XO,YO#                            Page offsets                     PO36  14
REAL PW,PH,WID,HIT#                    Page and page free space width   PO36  15
REAL PAGASP,BLKASP,FSPASP#             Aspect ratios                    PO36  16
REAL U(5),V(5)#                                                         PO36  17
string:(TEXT,100)#                                                      PO36  18
#                                                                       PO36  19
#   IF PRINTING INITIALISE THE PRINTING DEVICE                          PO36  20
#   ------------------------------------------                          PO36  21
#                                                                       PO36  22
# INPUT PACKET -- AUTO CENTER AND SCALE (6)                             PO36  23
#                                                                       PO36  24
#     WORD 1       FRAME WIDTH                                          PO36  25
#     WORD 2       FRAME HEIGHT                                         PO36  26
#     WORD 3       STEREO FLAG (2=YES 1=NO)                             PO36  27
#     WORD 4       INTERNAL SCALE                                       PO36  28
#     WORD 5       MAXIMUM X-SPAN OF SUBJECT                            PO36  29
#     WORD 6       MAXIMUM Y-SPAN OF SUBJECT                            PO36  30
#                                                                       PO36  31
VUTYPE=FLAG#                           Flag=1=preview/2=print           PO36  32
PW=sg:(PRPAGE(prxdim:))#               Page width always in inches      PO36  33
PH=sg:(PRPAGE(prydim:))#               Page height always in inches     PO36  34
WID=sg:(PRPAGE(prxdim:)-PRPAGE(prlmargin:)-PRPAGE(prrmargin:))# Free    PO36  35
HIT=sg:(PRPAGE(prydim:)-PRPAGE(prtmargin:)-PRPAGE(prbmargin:))# Free    PO36  36
#                                                                       PO36  37
IF(FLAG==2)#                           This is a printing routine       PO36  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO36  39
IF(FRAMCT==0)#                         Initialise the plotting device   PO36  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO36  41
printinit:#                            Start of plot                    PO36  42
printscal:(PW,PH,WID,HIT)#             Printed page boundaries inches   PO36  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO36  44
ELSE#                                  No longer initialising           PO36  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO36  46
printnewf:#                            Frame advance(if print called    PO36  47
printscal:(PW,PH,WID,HIT)#             Printed page boundaries inches   PO36  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO36  49
FRAMCT=FRAMCT+1#                       Record number of frames plotte   PO36  50
XO=sg:(PRPAGE(prlmargin:))#            X origin in units of inches      PO36  51
YO=sg:(PRPAGE(prbmargin:))#            Y origin in units of inches      PO36  52
linestyl:(NINT(gptbolinest:))#         Line style is solid              PO36  53
linecolr:(NINT(gptbocolor:))#          Set line colour                  PO36  54
linesize:(     gptbolinewd:)#          Set current line size            PO36  55
IF (nint:(PRPAGE(prdoborder:))==yes:)# Do we display outer border       PO36  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO36  57
U(1)=0.0#                              Page x origin                    PO36  58
U(2)=U(1)+PW#                          Page width                       PO36  59
U(3)=U(2);U(4)=U(1);U(5)=U(1)#                                          PO36  60
V(1)=0.0;V(2)=V(1)#                    Page y origin                    PO36  61
V(3)=V(1)+PH#                          Page height                      PO36  62
V(4)=V(3);V(5)=V(1)#                                                    PO36  63
printline:(5,U,V)#                     Dump line movements to file      PO36  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO36  65
IF (nint:(PRPAGE(prdiborder:))==yes:)# Do we display outer border       PO36  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO36  67
U(1)=XO#                               Page x origin                    PO36  68
U(2)=U(1)+WID#                         Page width                       PO36  69
U(3)=U(2);U(4)=U(1);U(5)=U(1)#                                          PO36  70
V(1)=YO;V(2)=V(1)#                     Page y origin                    PO36  71
V(3)=V(1)+HIT#                         Page height                      PO36  72
V(4)=V(3);V(5)=V(1)#                                                    PO36  73
printline:(5,U,V)#                     Dump line movements to file      PO36  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO36  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO36  76
#                                                                       PO36  77
#     IS A PREVIEW SO INITIALISE THE BACKGROUND PIXMAPS                 PO36  78
#     -------------------------------------------------                 PO36  79
#                                                                       PO36  80
ELSE#                                  Must be a preview so resize pi   PO36  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO36  82
#                                                                       PO36  83
erasepage:(graphc:,1)#                 Erase and delete segments        PO36  84
PAGASP=sg:(PRPAGE(praspect:))#         Printed page aspect ratio        PO36  85
canvaspects:(graphc:,PAGASP)#          Set desired aspect ratio         PO36  86
#                                                                       PO36  87
TEXT='set horizmag '#                  Encode the number in text stri   PO36  88
ncodefld:(ZOOM(CURPLT,zoomx:),1,TEXT,301032.,1)#                        PO36  89
tcleval:(TEXT)#                                                         PO36  90
TEXT='set vertmag '#                   Encode the number in text stri   PO36  91
ncodefld:(ZOOM(CURPLT,zoomy:),1,TEXT,301032.,1)#                        PO36  92
tcleval:(TEXT)#                                                         PO36  93
scrollvarls:(graphc:,#                                                  PO36  94
ZOOM(prpage:,zoomx:),ZOOM(prpage:,zoomy:),#                             PO36  95
HSCROLL(prpage:,sccentre:),VSCROLL(prpage:,sccentre:))# Widget dimens   PO36  96
#                                                                       PO36  97
#                                                                       PO36  98
erasepage:(abscissac:,1)#              Erase and delete segments        PO36  99
erasepage:(ordinatec:,1)#              Erase and delete segments        PO36 100
#                                                                       PO36 101
#    SET SCALES AND ORIGINS FOR PREVIEWING                              PO36 102
#    -------------------------------------                              PO36 103
#                                                                       PO36 104
XO=sg:(PRPAGE(prlmargin:)/PRPAGE(prxdim:))*PAGASP# Free space x origi   PO36 105
YO=sg:(PRPAGE(prbmargin:)/PRPAGE(prydim:))*1.0# Free space y origin     PO36 106
WID=WID/PW*PAGASP#                     Pixmap free width wrt free hei   PO36 107
HIT=HIT/PH*1.0#                        Pixmap free height wrt free he   PO36 108
#                                                                       PO36 109
#     ERASE THE LEGEND SUBWINDOW                                        PO36 110
#     -------------------------                                         PO36 111
#                                                                       PO36 112
erasepage:(legendc:,1)#                                                 PO36 113
#                                                                       PO36 114
#     SET THE DRAWING SURFACE TO THE GRAPH PLOT                         PO36 115
#     -------------------------                                         PO36 116
#                                                                       PO36 117
setcanvas:(graphc:,0)#                                                  PO36 118
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO36 119
#                                                                       PO36 120
#     INVOKE GRAPH PLACEMENT ALGORITHMS TO UPDATE GRAPH POINTERS        PO36 121
#     ----------------------------------------------------------        PO36 122
#                                                                       PO36 123
CALL PO37#                                                              PO36 124
#                                                                       PO36 125
#     COMMENCE TO DRAW ALL GRAPHICS BLOCKS                              PO36 126
#     ------------------------------------                              PO36 127
#                                                                       PO36 128
SEGSUM=0#                              Initialise segment sum           PO36 129
DO PT=1,maxgn:#                        Cycle over graph plots           PO36 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO36 131
IF(NINT(gptinvoked:)==no:)NEXT#        This graph is not invoked        PO36 132
#                                                                       PO36 133
IF(ARANGE==asspecif:)#                 Arrange graphs as  user specif   PO36 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PO36 135
RELXOR=XO+gptuspxorg:  *WID#           Get users x origin               PO36 136
RELYOR=YO+gptuspyorg:  *HIT#           Get users x origin               PO36 137
RELWID=   gptuspwidth: *WID#           Get users specified width        PO36 138
RELHIT=   gptuspheight:*HIT#           Get users specified width        PO36 139
RELSCF=RELHIT#                         Relative scalefactor             PO36 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PO36 141
ELSE#                                  Arrange graphs as calculated     PO36 142
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PO36 143
RELXOR=XO+gptcalxorg:  *WID#           Get calculated x origin          PO36 144
RELYOR=YO+gptcalyorg:  *HIT#           Get calculated x origin          PO36 145
RELWID=   gptcalwidth: *WID#           Get calculated width             PO36 146
RELHIT=   gptcalheight:*HIT#           Get calculated height            PO36 147
RELSCF=RELHIT#                         Relative scalefactor             PO36 148
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PO36 149
#                                                                       PO36 150
#    BASED ON ASPECT RATIO FIT BLOCK INTO FREE SPACE SET ASIDE FOR IT   PO36 151
#    ----------------------------------------------------------------   PO36 152
#                                                                       PO36 153
FSPASP=RELWID/RELHIT#                  Free block space aspectratio     PO36 154
BLKASP=gptbaspect:#                    Preserved aspect ratio of a bl   PO36 155
IF(FSPASP<BLKASP)#                     Limiting dimension is width      PO36 156
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PO36 157
RELXOR=RELXOR#                         Same absolute x origin           PO36 158
RELYOR=RELYOR+(1.0-FSPASP/BLKASP)*RELSCF/2.0# New y origin              PO36 159
RELWID=RELWID#                         No change in relative width      PO36 160
RELHIT=RELWID/BLKASP#                  Relative height decreases        PO36 161
RELSCF=RELWID/BLKASP#                  New reduced length scale facto   PO36 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PO36 163
ELSE#                                  Limiting dimension is height     PO36 164
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PO36 165
RELXOR=RELXOR+(FSPASP-BLKASP)*RELSCF/2.0# New x origin                  PO36 166
RELYOR=RELYOR#                         Same absolute y origin           PO36 167
RELHIT=RELHIT#                         No change to height              PO36 168
RELWID=RELHIT*BLKASP#                  Relative width becomes smaller   PO36 169
RELSCF=RELHIT#                         No change to scale factor        PO36 170
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PO36 171
#                                                                       PO36 172
CALL PO38(PT)#                         Print graph                      PO36 173
#                                                                       PO36 174
IF(VUTYPE==2)#                         Actually plot the graph trace    PO36 175
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PO36 176
DO I=2,6+maxpha:#                      Cycle over all phases but twot   PO36 177
IF(NINT(cvdisplay:(I))==yes:)#         Do plot this curve               PO36 178
CALL PO39(I,PT)#                       Call plotting subroutine         PO36 179
#                                                                       PO36 180
DO I=1,NPHASE#                         Cycle over all phases but twot   PO36 181
IF(nint:(hbdisplay:(I))!=no:\#         Do plot the hkl bars             PO36 182
   nint:(hblabel:(I))  !=no:)#         Do plot the hkl labels           PO36 183
CALL PO40(I,PT)#                       Call plotting subroutine         PO36 184
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PO36 185
#                                                                       PO36 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO36 187
#                                                                       PO36 188
RETURN#                                                                 PO36 189
END#                                                                    PO36 190
systemheader:(PO37)#                   Configure page blocks            PO37   1
####################################################################### PO37   2
#                                                                     # PO37   3
#                          PO37                                       # PO37   4
#                                                                     # PO37   5
####################################################################### PO37   6
SUBROUTINE PO37#                                                        PO37   7
include:(AACOMN)#                                                       PO37   8
include:(POCOMN)#                                                       PO37   9
#                                                                       PO37  10
INTEGER I,J,N#                                                          PO37  11
INTEGER GXMAX,GXMIN,GYMAX,GYMIN#                                        PO37  12
INTEGER HNUM,VNUM#                                                      PO37  13
INTEGER XI,YI#                                                          PO37  14
INTEGER PT#                                                             PO37  15
#REAL    WIDTH(MIV:),HEIGHT(MIV:)#                                      PO37  16
REAL    WID,HIT,AVWID,AVHIT#                                            PO37  17
#                                                                       PO37  18
#                                                                       PO37  19
IF (ARANGE==asspecif:)GOTO 100#        User has specified all locatio   PO37  20
DO J=1,miv:;GRINDX(miv:+1,J)=0#        Cycle over grindx columns        PO37  21
DO I=1,miv:#                           Cycle over grindx rows           PO37  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO37  23
GRINDX(I,miv:+1)=0#                    Initialise to 0                  PO37  24
DO J=1,miv:#                           Cycle over grindx columns        PO37  25
IF(GRINDX(I,J)!=0)#                    Non zero index entry             PO37  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO37  27
GRINDX(I,miv:+1)=GRINDX(I,miv:+1)+1#   Sum occupied rows                PO37  28
GRINDX(miv:+1,J)=GRINDX(miv:+1,J)+1#   Sum occupied columns             PO37  29
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO37  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO37  31
#                                                                       PO37  32
DO I=1,miv:;IF(GRINDX(miv:+1,I)!=0) BREAK# Break at first non zero su   PO37  33
GXMIN=I#                               Minimum index entry              PO37  34
DO I=miv:,GXMIN,-1;IF(GRINDX(miv:+1,I)!=0) BREAK# Break at first non    PO37  35
GXMAX=I#                               Maximum index entry              PO37  36
DO I=1,miv:;IF(GRINDX(I,miv:+1)!=0) BREAK# Break at first non zero su   PO37  37
GYMIN=I#                               Minimum index entry              PO37  38
DO I=miv:,GYMIN,-1;IF(GRINDX(I,miv:+1)!=0) BREAK# Break at first zero   PO37  39
GYMAX=I#                               Maximum index entry              PO37  40
HNUM=0#                                Initialise horiz num to 0        PO37  41
DO I=1,miv:;IF(GRINDX(miv:+1,I)!=0)HNUM=HNUM+1# Increment horiz numbe   PO37  42
VNUM=0#                                Initialise vert num to 0         PO37  43
DO I=1,miv:;IF(GRINDX(I,miv:+1)!=0)VNUM=VNUM+1# Increment vert number   PO37  44
#                                                                       PO37  45
IF(HNUM==0\VNUM==0) GOTO 100#          No graph blocks so exit          PO37  46
#                                                                       PO37  47
#                                       Totally scale independent!      PO37  48
WID=1.0#                                                                PO37  49
HIT=1.0#                               Whole height units of height     PO37  50
#                                                                       PO37  51
IF(ARANGE==literal:)#                  Literal placement as in index    PO37  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO37  53
AVWID=WID/FLOAT(HNUM)#                 Fractional width per block       PO37  54
AVHIT=HIT/FLOAT(VNUM)#                 Fractional height per block      PO37  55
DO PT=1,maxgn:#                        Loop over all invoked graphs     PO37  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO37  57
IF(NINT(gptinvoked:)!=yes:)NEXT#       Graph not invoked                PO37  58
XI=NINT(gptxindex:)#                   X index pointer                  PO37  59
YI=NINT(gptyindex:)#                   Y index pointer                  PO37  60
gptcalwidth:=AVWID#                    Average width                    PO37  61
gptcalheight:=AVHIT#                   Average height                   PO37  62
gptcalxorg:=(XI-GXMIN)*AVWID#          Literal x origin                 PO37  63
gptcalyorg:=(YI-GYMIN)*AVHIT#          Literal y origin                 PO37  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO37  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO37  66
#                                                                       PO37  67
ELSEIF(ARANGE==horizoptim:)#           Equal horizontal spacing         PO37  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO37  69
AVHIT=HIT/FLOAT(VNUM)#                 Height per block                 PO37  70
DO PT=1,maxgn:#                        Loop over all invoked graphs     PO37  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO37  72
IF(NINT(gptinvoked:)!=yes:)NEXT#       Graph not invoked                PO37  73
XI=NINT(gptxindex:)#                   X index pointer                  PO37  74
YI=NINT(gptyindex:)#                   Y index pointer                  PO37  75
AVWID=WID/FLOAT(GRINDX(YI,miv:+1))#    Average width in this row        PO37  76
gptcalheight:=AVHIT#                   Average height                   PO37  77
gptcalwidth:=AVWID#                    Average width                    PO37  78
N=0#                                   Find any blank rows between ma   PO37  79
DO I=GYMIN,GYMAX;IF(GRINDX(I,miv:+1)!=0)# A non null entry in  column   PO37  80
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO37  81
IF(I==YI) BREAK#                       Stop at current graph  gr        PO37  82
N=N+1#                                 Number of graphs before curren   PO37  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO37  84
gptcalyorg:=FLOAT(N)*AVHIT#            Optimal y origin                 PO37  85
N=0#                                   Optimse graphs across row        PO37  86
DO I=1,miv:;IF(GRINDX(YI,I)!=0)#       A non null entry in row          PO37  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PO37  88
IF(I==XI) BREAK#                       Up to the current graph          PO37  89
N=N+1#                                 Number of graphs before curren   PO37  90
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PO37  91
gptcalxorg:=FLOAT(N)*AVWID#            Determine literal x origin       PO37  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO37  93
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO37  94
#                                                                       PO37  95
ELSEIF(ARANGE==vertoptim:)#            Equal horizontal spacing         PO37  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PO37  97
AVWID=WID/float:(HNUM)#                Width per block                  PO37  98
DO PT=1,maxgn:#                        Loop over all invoked graphs     PO37  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PO37 100
IF(NINT(gptinvoked:)!=yes:)NEXT#       Graph not invoked                PO37 101
XI=NINT(gptxindex:)#                   X index pointer                  PO37 102
YI=NINT(gptyindex:)#                   Y index pointer                  PO37 103
AVHIT=HIT/float:(GRINDX(miv:+1,XI))#   Average width in this row        PO37 104
gptcalwidth: =AVWID#                   Average width                    PO37 105
gptcalheight:=AVHIT#                   Average height                   PO37 106
N=0#                                   Find any blank columns between   PO37 107
DO I=GXMIN,GXMAX;IF(GRINDX(miv:+1,I)!=0)# A non null entry in  row      PO37 108
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PO37 109
IF(I==XI) BREAK#                       Stop at current graph  gr        PO37 110
N=N+1#                                 Number of graphs before curren   PO37 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PO37 112
gptcalxorg:=float:(N)*AVWID#           Optimal x origin                 PO37 113
N=0#                                   Number of graph across row       PO37 114
DO I=1,miv:;IF(GRINDX(I,XI)!=0)#       A non null entry in column       PO37 115
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PO37 116
IF(I==YI) BREAK#                       Up to the current graph          PO37 117
N=N+1#                                 Number of graphs before curren   PO37 118
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PO37 119
gptcalyorg:=float:(N)*AVHIT#           Optimal y origin                 PO37 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PO37 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PO37 122
#                                                                       PO37 123
100 CONTINUE#                                                           PO37 124
RETURN#                                                                 PO37 125
END#                                                                    PO37 126
systemheader:(PO38)#                   Plot the graph border            PO38   1
####################################################################### PO38   2
#                                                                     # PO38   3
#                          PO38                                       # PO38   4
#                                                                     # PO38   5
####################################################################### PO38   6
SUBROUTINE PO38(PT)#                                                    PO38   7
include:(AACOMN)#                                                       PO38   8
include:(POCOMN)#                                                       PO38   9
#                                                                       PO38  10
INTEGER PT#                            The graph to be plotted          PO38  11
INTEGER COLR,NCHAR#                    Text string plotting data        PO38  12
INTEGER VLINES,HLINES#                 Number of grid lines             PO38  13
REAL    XO1,YO1,WID,HIT#               Graph dimensions                 PO38  14
REAL    XO,YO,THETA,SIZE#              Text string plotting data        PO38  15
REAL    XOR,YOR,SCF#                   Origin offsets and scalefactor   PO38  16
REAL    DELX,DELY#                     Grid spacing                     PO38  17
REAL    U(100),V(100)#                                                  PO38  18
INTEGER CENDIG,DELDIG,NUM,NUN,NDP#                                      PO38  19
INTEGER I,J,K,L,I1,I2#                                                  PO38  20
REAL    AMIN,AMAX,ASCF#                                                 PO38  21
REAL    FMT#                                                            PO38  22
REAL    TSIZE#                                                          PO38  23
REAL    FT,LT,TS,ACNUM,CHAWID,ABSDIS,TSCAL,DISPX,DISPY#                 PO38  24
string:(TEXT,72)#                                                       PO38  25
datastuff:#                                                             PO38  26
#                                                                       PO38  27
#    DETERMINE APPROPRIATE SCALE FACTORS AND ORIGINS                    PO38  28
#    -----------------------------------------------                    PO38  29
#                                                                       PO38  30
XOR=RELXOR#                            Block  x origin is 0             PO38  31
YOR=RELYOR#                            Block  y origin is 0             PO38  32
SCF=RELSCF#                            Relative scale factor            PO38  33
#                                                                       PO38  34
#    BEGIN DRAWING THE GRAPHIC BLOCK WITH THE TITLE                     PO38  35
#    ----------------------------------------------                     PO38  36
#                                                                       PO38  37
segplus:#                              Begin new segment                PO38  38
IF(nint:(tidisplay:)==yes:)#           Do we include title              PO38  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO38  40
TEXT=' '#                                                               PO38  41
XO   =XOR+ tixorigin:*SCF#             X origin of title text           PO38  42
YO   =YOR+ tiyorigin:*SCF#             Y origin of title text           PO38  43
THETA=     tiangle:#                   Angle to horizontal of title t   PO38  44
SIZE =     tisize:*SCF#                Text size of title               PO38  45
COLR =nint:(ticolor:)#                 Colr of title text               PO38  46
NCHAR=nint:(tichars:)#                 Num of chars in title text       PO38  47
TEXT=TITLET(PT)#                                                        PO38  48
graphtext:(XO,YO,COLR,SIZE,THETA,NCHAR,TEXT)# Print text                PO38  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO38  50
segend:#                               End this segment                 PO38  51
#                                                                       PO38  52
DO I=1,2#                              Cycle over both axes             PO38  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO38  54
segplus:#                              Begin new segment                PO38  55
IF (NINT(axtlabel:(I))==yes:)#         Do we include abscissa label     PO38  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO38  57
XO   =XOR+ axtxorigin:(I)*SCF#                                          PO38  58
YO   =YOR+ axtyorigin:(I)*SCF#                                          PO38  59
THETA=     axtangle:(I)#                                                PO38  60
SIZE =     axtsize:(I)*SCF#                                             PO38  61
COLR =NINT(axtcolor:(I))#                                               PO38  62
NCHAR=NINT(axtcharnum:(I))#                                             PO38  63
IF(I==1)TEXT=ABSLAB(PT)#                                                PO38  64
ELSE    TEXT=ORDLAB(PT)#                                                PO38  65
graphtext:(XO,YO,COLR,SIZE,THETA,NCHAR,TEXT)# Print text                PO38  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO38  67
segend:#                               End this segment                 PO38  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO38  69
#                                                                       PO38  70
#      DRAW GRAPH BLOCK BORDER                                          PO38  71
#      -----------------------                                          PO38  72
#                                                                       PO38  73
segplus:#                              Begin new segment                PO38  74
IF (NINT(gptbodisp:)==yes:)#           Do we display border             PO38  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO38  76
linestyl:(NINT(gptbolinest:))#         Line style is solid              PO38  77
linecolr:(NINT(gptbocolor:))#          Set line colour                  PO38  78
linesize:(     gptbolinewd:)#          Set current line size            PO38  79
U(1)=XOR+0.0005*SCF#                   X origin                         PO38  80
U(2)=XOR+gptbaspect:*SCF*0.9995#       X                                PO38  81
U(3)=U(2);U(4)=U(1);U(5)=U(1)#                                          PO38  82
V(1)=YOR+0.0005*SCF;V(2)=V(1)#         Y origin                         PO38  83
V(3)=YOR+0.9995*SCF#                                                    PO38  84
V(4)=V(3);V(5)=V(1)#                                                    PO38  85
IF(VUTYPE==2) printline:(5,U,V)#       Dump line movements to file      PO38  86
ELSE          linedraw:(5,U,V)#        Print line movements to screen   PO38  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO38  88
segend:#                               End this segment                 PO38  89
#                                                                       PO38  90
#     GET GRAPH DIMENSION POINTERS                                      PO38  91
#     ----------------------------                                      PO38  92
#                                                                       PO38  93
XO1=XOR+gptgxorigin:*SCF#              Absolute x origin of graph       PO38  94
YO1=YOR+gptgyorigin:*SCF#              Absolute y origin of graph       PO38  95
HIT=    gptgheight: *SCF#              Absolute height of graph         PO38  96
WID=    gptgheight:*gptgaspect:*SCF#   Absolute width of graph          PO38  97
#                                                                       PO38  98
#     DRAW GRID LINES                                                   PO38  99
#     ---------------                                                   PO38 100
#                                                                       PO38 101
segplus:#                              Begin new segment                PO38 102
IF (NINT(grxdisplay:)==yes:)#          Do we include abscissa label     PO38 103
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO38 104
linestyl:(NINT(grlinest:))#            Line style is solid              PO38 105
linecolr:(NINT(grcolor:))#             Set line colour                  PO38 106
linesize:(     grlinewd:)#             Set current line size            PO38 107
VLINES=NINT(grvlines:)#                Number of vertical lines         PO38 108
HLINES=NINT(grhlines:)#                Number of vertical lines         PO38 109
IF(VLINES>0)#                                                           PO38 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO38 111
DELX=WID/float:(VLINES+1)#             Absolute spacing of lines        PO38 112
DO I=1,VLINES#                                                          PO38 113
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO38 114
U(1)=XO1+ FLOAT(I)*DELX#               X start is a fraction of graph   PO38 115
U(2)=U(1)#                             X finish = x start               PO38 116
V(1)=YO1#                              Y start is y origin of graph     PO38 117
V(2)=YO1+HIT#                          Y finish is graph height         PO38 118
IF(VUTYPE==2) printline:(2,U,V)#       Dump line movements to file      PO38 119
ELSE          linedraw:(2,U,V)#        Print line movements to screen   PO38 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO38 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO38 122
IF(HLINES>0)#                          Some horizontal lines on graph   PO38 123
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PO38 124
DELY=HIT/FLOAT(HLINES+1)#              Absolute spacing of lines        PO38 125
DO I=1,HLINES#                                                          PO38 126
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PO38 127
U(1)=XO1#                              X start is at graph x origin     PO38 128
U(2)=XO1+WID#                          X finish is graph width          PO38 129
V(1)=YO1+FLOAT(I)*DELY#                Y start is fraction of graph h   PO38 130
V(2)=V(1)#                             Y finish = y start               PO38 131
IF(VUTYPE==2) printline:(2,U,V)#       Dump line movements to file      PO38 132
ELSE          linedraw:(2,U,V)#        Print line movements to screen   PO38 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PO38 134
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PO38 135
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO38 136
segend:#                               End this segment                 PO38 137
#                                                                       PO38 138
#     DRAW BOTH AXES                                                    PO38 139
#     --------------                                                    PO38 140
#                                                                       PO38 141
DO L=1,2#                              Cycle over both axes             PO38 142
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PO38 143
segplus:#                              Begin new segment                PO38 144
IF(NINT(axdisplay:(L))==yes:)#         Do we display abscissa           PO38 145
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PO38 146
linestyl:(NINT(axlinest:(L)))#         Line style is solid              PO38 147
linecolr:(NINT(axcolor:(L)))#          Set line colour                  PO38 148
linesize:(     axlinewd:(L))#          Set current line size            PO38 149
I1=1;I2=0#                             Initialise                       PO38 150
IF(NINT(ax0posn:(L))==yes:)I1=0#       Draw axis at bottom              PO38 151
IF(NINT(ax1posn:(L))==yes:)I2=1#       Draw axis at top                 PO38 152
IF(NINT(gptgboxed:)==yes:)#            Draw lines at top and bottom     PO38 153
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PO38 154
I1=0 ; I2=1#                           Draw top and bottom lines        PO38 155
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PO38 156
#                                                                       PO38 157
DO I=I1,I2#                            Cycle over top and bottom        PO38 158
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PO38 159
IF(L==1)#                              The abscissa                     PO38 160
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PO38 161
U(1)=XO1;U(2)= XO1+WID#                X position of axis               PO38 162
V(1)=YO1+FLOAT(I)*HIT#                 Y start of axis                  PO38 163
V(2)=V(1)#                             Y finish of axis                 PO38 164
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PO38 165
ELSE#                                  The ordinate                     PO38 166
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PO38 167
U(1)=XO1+FLOAT(I)*WID#                 X start of axis                  PO38 168
U(2)=U(1)#                             X finish of axis                 PO38 169
V(1)=YO1;V(2)= YO1+HIT#                Y position of axis               PO38 170
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PO38 171
IF(VUTYPE==2) printline:(2,U,V)#       Dump line movements to file      PO38 172
ELSE          linedraw:(2,U,V)#        Print line movements to screen   PO38 173
AMIN=axmin:(L)#                        Min value of abscissa            PO38 174
AMAX=axmax:(L)#                        Max value of abscissa            PO38 175
IF(L==1) ASCF=WID/(AMAX-AMIN)#         Axis scale factor (contains sc   PO38 176
ELSE     ASCF=HIT/(AMAX-AMIN)#         Ordinate scale factor            PO38 177
#                                                                       PO38 178
# IF BOXED BUT NOT THIS AXIS THEN NEXT                                  PO38 179
#                                                                       PO38 180
DO K=1,3#                              Cycle over three types of tick   PO38 181
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PO38 182
IF(K==1)#                              First type is big tick mark      PO38 183
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PO38 184
FT=       axfbtick:(L)#                First big tick mark              PO38 185
LT=       axlbtick:(L)#                Last big tick mark               PO38 186
TS=       axbticks:(L)#                Big tick mark spacing            PO38 187
TSIZE=    axsbtick:(L)*HIT#            Size of big tick marks           PO38 188
linesize:(axbticklw:(L))#              Set tick mark line width         PO38 189
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PO38 190
ELSEIF(K==2)#                          Second type is medium tick mar   PO38 191
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PO38 192
FT=       axfmtick:(L)#                First medium tick mark           PO38 193
LT=       axlmtick:(L)#                Last medium tick mark            PO38 194
TS=       axmticks:(L)#                Medium tick mark spacing         PO38 195
TSIZE=    axsmtick:(L)*HIT#            Size of medium tick marks        PO38 196
linesize:(axmticklw:(L))#              Set tick mark line width         PO38 197
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PO38 198
ELSEIF(K==3)#                          Third type is small tick mark    PO38 199
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PO38 200
FT=       axfstick:(L)#                First small tick mark            PO38 201
LT=       axlstick:(L)#                Last small tick mark             PO38 202
TS=       axsticks:(L)#                Small tick mark spacing          PO38 203
TSIZE=    axsstick:(L)*HIT#            Size of small tick marks         PO38 204
linesize:(axsticklw:(L))#              Set tick mark line width         PO38 205
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PO38 206
IF(L==1)#                              The abscissa                     PO38 207
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PO38 208
V(1)=YO1+FLOAT(I)*HIT#                 Starting y position              PO38 209
V(2)=V(1)+ 2.*(FLOAT(I)-0.5)*TSIZE#    Ending y position                PO38 210
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PO38 211
ELSE#                                  The ordinate                     PO38 212
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PO38 213
U(1)=XO1+FLOAT(I)*WID#                 Starting x position              PO38 214
U(2)=U(1)+ 2.*(FLOAT(I)-0.5)*TSIZE#    Ending x position                PO38 215
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PO38 216
NUM = NINT((LT-FT)/TS)+1#              Number of big tick marks         PO38 217
DO J=1,NUM#                            Cycle over big ticks             PO38 218
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PO38 219
IF(L==1)#                              The abscissa                     PO38 220
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PO38 221
U(1)=XO1+(FT-AMIN +FLOAT(J-1)*TS)*ASCF# Get the x position              PO38 222
U(2)=U(1)#                             Same x position                  PO38 223
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PO38 224
ELSE#                                  The ordinate                     PO38 225
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PO38 226
V(1)=YO1+(FT-AMIN +FLOAT(J-1)*TS)*ASCF# Get the y position              PO38 227
V(2)=V(1)#                             Same y position                  PO38 228
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PO38 229
IF(VUTYPE==2) printline:(2,U,V)#       Dump line movements to file      PO38 230
ELSE          linedraw:(2,U,V)#        Print line movements to screen   PO38 231
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PO38 232
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PO38 233
#                                                                       PO38 234
# IF BOXED AND BOTH AXES BUT NO LABELS ON THIS AXIS THEN NEXT           PO38 235
#CYCLE OVER TICK MARK LABELS                                            PO38 236
#                                                                       PO38 237
FT=     axfltick:(L)#                  First labelled tick mark         PO38 238
LT=     axlltick:(L)#                  Last labelled tick mark          PO38 239
TS=     axlticks:(L)#                  Labelled tick mark spacing       PO38 240
#TSIZE = AXLTICSIZE:(L)*HIT#  SIZE OF LABELLED TICK TEXT                PO38 241
TSIZE = axlticsize:(L)*HIT#            Size of labelled tick text       PO38 242
THETA = axlticangl:(L)#                Angle of labelled tick text      PO38 243
TSCAL = axscale:(L)#                   Scale factor for numbers         PO38 244
COLR  = NINT(axlticcol:(L))#           Color of tick mark labels        PO38 245
DISPX = axldispxcent:(L)*WID#          The displacement of label cent   PO38 246
DISPY = axldispycent:(L)*HIT#          The displacement of label cent   PO38 247
CHAWID= 0.7*TSIZE#                     Width of characters              PO38 248
#                                                                       PO38 249
NUM = NINT((LT-FT)/TS)+1#              Number of tick mark labels       PO38 250
DO J=1,NUM#                            Cycle over tick mark labels      PO38 251
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PO38 252
ACNUM =(FT+FLOAT(J-1)*TS)/TSCAL#       Actual scaled number             PO38 253
IF (FT+FLOAT(J-1)*TS >axmax:(L))BREAK#                                  PO38 254
ABSDIS=(FT-AMIN +FLOAT(J-1)*TS)*ASCF#  Absolute displacement of axis    PO38 255
#                                                                       PO38 256
ifne:(ACNUM,0.0,.000001)#              If it equals zero there is tro   PO38 257
NUN=NINT(AINT(LOG10(ABS(ACNUM))))+1#   Number of unit places of most    PO38 258
ELSE NUN=1#                            Only one unit place for zero     PO38 259
NDP=NINT(axlnumdecplac:(L))#           Get number of decimal places r   PO38 260
IF(NDP<0 & NUN<-NDP)NDP=NUN+NDP#       Not ndp but n digits total       PO38 261
IF(ACNUM<0.0)NUN=NUN+1#                Add one place for negative sig   PO38 262
IF(NUN>0 )#                            Number is larger than 1.0        PO38 263
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PO38 264
NCHAR=NUN+1+NDP#                       Number of characters in number   PO38 265
IF(NDP>1)FMT=FLOAT(NCHAR)*10100.+FLOAT(NDP)*10.+2.# Decimal numbers     PO38 266
ELSE     FMT=FLOAT(NCHAR)*10100.+        1.*10.+3.# An exact integral   PO38 267
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PO38 268
ELSE#                                  Number is less than 1.0          PO38 269
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PO38 270
NCHAR= 1-NDP#                          One for dplace + ndp chars       PO38 271
FMT=FLOAT(NCHAR)*10100.-FLOAT(NDP)*10. +2.# Decimal numbers             PO38 272
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PO38 273
TEXT=' '#                              Erase string                     PO38 274
ncodefld:(ACNUM,1,TEXT,FMT,1)#         Encode the number in the strin   PO38 275
CENDIG=NINT(axlcentredigit:(L))#                                        PO38 276
IF(NUN<CENDIG)DELDIG=0#                Align to left column             PO38 277
ELSE          DELDIG=CENDIG-NUN#       Number of characters to be dis   PO38 278
IF(L==1)#                              The abscissa                     PO38 279
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 PO38 280
XO=XO1+ABSDIS+DISPX+DELDIG*CHAWID#     Get the x position               PO38 281
IF(I==0)YO=YO1-DISPY-TSIZE#            Displace below                   PO38 282
ELSE    YO=YO1+DISPY+HIT#              Displace above                   PO38 283
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 PO38 284
ELSE#                                  The ordinate axis                PO38 285
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 PO38 286
IF(I==0)XO=XO1-   DISPX+DELDIG*CHAWID# Displace to left                 PO38 287
ELSE    XO=XO1+2.*DISPX+DELDIG*CHAWID+WID# Displace numbers to right    PO38 288
YO=YO1+ABSDIS+DISPY#                   Get the y position               PO38 289
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 PO38 290
graphtext:(XO,YO,COLR,TSIZE,THETA,NCHAR,TEXT)# Print text               PO38 291
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PO38 292
#                                                                       PO38 293
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PO38 294
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PO38 295
segend:#                               End this segment                 PO38 296
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PO38 297
#                                                                       PO38 298
# DRAW LEGEND                                                           PO38 299
#                                                                       PO38 300
RETURN#                                                                 PO38 301
END#                                                                    PO38 302
systemheader:(PO39)#                   Actually plot the curves         PO39   1
####################################################################### PO39   2
#                                                                     # PO39   3
#                          PO39                                       # PO39   4
#                                                                     # PO39   5
####################################################################### PO39   6
SUBROUTINE PO39(TR,PT)#                                                 PO39   7
include:(AACOMN)#                                                       PO39   8
include:(POCOMN)#                                                       PO39   9
INTEGER TR,PT#                         The trace and the graphic bloc   PO39  10
INTEGER GRYSTY,GRXSTY#                                                  PO39  11
INTEGER I1,I2,J,JJ,K#                                                   PO39  12
INTEGER PNTCNT#                                                         PO39  13
INTEGER STAGE#                                                          PO39  14
INTEGER FPT,LPT,PNT,PPT,PP1#                                            PO39  15
INTEGER PRELIN,POSLIN,STOP,DUMP,EXCZON,EXCLIN,DBSIG# Boolean flags      PO39  16
INTEGER EXCCNT#                                                         PO39  17
INTEGER EXCD(50)#                                                       PO39  18
INTEGER LINSTY#                                                         PO39  19
INTEGER MAXIM,MINIM#                                                    PO39  20
INTEGER DP#                                                             PO39  21
REAL    EXCLEV,NULLEV,PRELEV,POSLEV#   Fixed trace levels               PO39  22
REAL    LINLEN#                                                         PO39  23
REAL    U(100),V(100)#                 Coordinates of trace             PO39  24
REAL    PRELX(2),PRELY(2),POSLX(2),POSLY(2)#                            PO39  25
REAL    EXCLX(50),EXCLY(50)#           Assumes 10 exclusion zones       PO39  26
REAL    SCEXCL(10),SCEXCH(10)#         Assumes 10 exclusion zones       PO39  27
REAL    XP(5),YP(5)#                                                    PO39  28
REAL    DL(2)#                         Dash/break lengths               PO39  29
REAL    A,A1,A2,XMAX,XMIN,YYMAX,YYMIN#                                  PO39  30
REAL    X1,Y1,X2,Y2,XPA,YPA,XPB,YPB#                                    PO39  31
REAL    CRVSCF#                        Trace scale factor               PO39  32
REAL    AMIN,AMAX,OMIN,OMAX#                                            PO39  33
REAL    XOR,YOR,HIT,WID#                                                PO39  34
REAL    DX,DY#                                                          PO39  35
REAL    SIG1,SIG2#                                                      PO39  36
REAL    ASCF#                                                           PO39  37
REAL    UDX,UDY#                                                        PO39  38
REAL    SCAMAX,SCAMIN,SCOMIN,SCOMAX#                                    PO39  39
REAL    OSCF#                                                           PO39  40
REAL    SCX1,SCY1,SCX2,SCY2#                                            PO39  41
REAL    SRES#                                                           PO39  42
REAL    PCNT#                                                           PO39  43
REAL    SL,DSL,FRACS#                                                   PO39  44
REAL    VAL#                                                            PO39  45
#                                                                       PO39  46
#     GET GRAPH DIMENSION POINTERS                                      PO39  47
#     ----------------------------                                      PO39  48
#                                                                       PO39  49
XOR=RELXOR+gptgxorigin:*RELSCF#        Absolute x origin of graph       PO39  50
YOR=RELYOR+gptgyorigin:*RELSCF#        Absolute y origin of graph       PO39  51
HIT=       gptgheight: *RELSCF#        Absolute height of graph         PO39  52
WID=gptgheight:*gptgaspect:*RELSCF#    Absolute width of graph          PO39  53
#                                                                       PO39  54
#     GET SPECIFICS FOR DRAWING THIS TRACE                              PO39  55
#     ------------------------------------                              PO39  56
#                                                                       PO39  57
GRYSTY=NINT(axtype:(2))#               Style of graph yaxis  lin/log/   PO39  58
GRXSTY=NINT(axtype:(1))#               Style of graph xaxis twotheta/   PO39  59
IF(GRXSTY!=1) GOTO 100#                D-spacing style is not support   PO39  60
DX=0.0;DY=0.0#                         Initialise curve shifts          PO39  61
IF(NINT(cvshift:(TR))==yes:)#          Apply curve shifts               PO39  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO39  63
DX=cvshx:(TR)*WID#                     Shift of curve from origin % o   PO39  64
DY=cvshy:(TR)*HIT#                     Shift of curve from origin % o   PO39  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO39  66
CRVSCF=cvauxscal:(TR)*cvphascal:(TR)#  Auxilliary curve scale factors   PO39  67
linestyl:(1)#                          Basic x11 line style is solid    PO39  68
linecolr:(NINT(cvlncolor:(TR)))#       Set linecolor                    PO39  69
linesize:(     cvlinewd:(TR))#         Set linewidth                    PO39  70
LINSTY=   NINT(cvlinest:(TR))#         Type of line (1=continous)       PO39  71
DBSIG=    NINT(cvdivbysig:(TR))#       Divide by sigma flag             PO39  72
DL(1)=cvlinedl:(TR)*HIT#               Dash length                      PO39  73
DL(2)=cvlinebl:(TR)*HIT#               Break length                     PO39  74
DP=1#                                  Initialise dash length pointer   PO39  75
IF(LINSTY==1)LINLEN=9.9E+20#           A very long line                 PO39  76
ELSE         LINLEN=DL(1)#             Line length is dash length       PO39  77
NULLEV=cvnullev:(TR)#                  Curve null nevel                 PO39  78
IF(NULLEV<=0.00001&GRYSTY!=1)NULLEV=0.001# Is null level valid          PO39  79
#                                                                       PO39  80
#    GET AMAX, AMIN AND OMIN, OMAX AND GET DIMENSIONAL SCALE FACTOR     PO39  81
#    --------------------------------------------------------------     PO39  82
#                                                                       PO39  83
ASCF=WID/(axmax:(1)-axmin:(1))#        Absisca scale factor (assumed    PO39  84
UDX=DX/ASCF#                           Unscaled dx                      PO39  85
AMAX=axmax:(1)-UDX#                    Abssisca maximum                 PO39  86
AMIN=axmin:(1)-UDX#                    Absissca minimum                 PO39  87
SCAMAX=XOR+WID#                        Scaled abscissa maximum          PO39  88
SCAMIN=XOR#                            Scaled abscissa minimum          PO39  89
#                                                                       PO39  90
OMIN=axmin:(2)#                        Min value of ordinate            PO39  91
OMAX=axmax:(2)#                        Max value of ordinate            PO39  92
IF(GRYSTY==2)#                         Logarithmic graph                PO39  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO39  94
IF(OMIN<NULLEV)OMIN=LOG10(NULLEV)#     Set ordinate minimum             PO39  95
ELSE           OMIN=LOG10(OMIN)#       Min value from axes settings     PO39  96
OMAX=LOG10(OMAX)#                      Max value from axes settings     PO39  97
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO39  98
ELSEIF(GRYSTY==3)#                     Square root graph                PO39  99
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO39 100
IF(OMIN<NULLEV)OMIN=SQRT(NULLEV)#      Set ordinate minimum             PO39 101
ELSE           OMIN=SQRT(OMIN)#        Min value of abscissa            PO39 102
OMAX=SQRT(OMAX)#                       Max value of abscissa            PO39 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO39 104
OSCF=HIT/(OMAX-OMIN)#                  Ordinate scale factor            PO39 105
UDY=DY/OSCF#                           Unscaled axis shift dy           PO39 106
OMIN=OMIN-UDY#                         Shifted omin                     PO39 107
OMAX=OMAX-UDY#                         Shifted omax                     PO39 108
SCOMIN=YOR#                            Scaled ordinate minimum          PO39 109
SCOMAX=YOR+HIT#                        Scaled ordinate maximum          PO39 110
#                                                                       PO39 111
#     GET EXCLUSION ZONE LEVELS                                         PO39 112
#     -------------------------                                         PO39 113
#                                                                       PO39 114
IF(NINT(cvexczoninc:(TR))==yes:)#      Get exclusion zone levels        PO39 115
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO39 116
EXCZON=yes:#                           Discontinuity at exclusion zon   PO39 117
EXCCNT=0#                              Count irrelevant exclusion zon   PO39 118
DO J=1,NEXCLR#                         Cycle over exclusion regions     PO39 119
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO39 120
SCEXCL(J)=XOR+DX+(EXCLRL(J)-AMIN)*ASCF# Scale lower bound               PO39 121
SCEXCH(J)=XOR+DX+(EXCLRH(J)-AMIN)*ASCF# Scale upper bound               PO39 122
IF ((SCEXCL(J)<AMIN &SCEXCH(J)<AMIN)\#                                  PO39 123
(SCEXCL(J)>AMAX &SCEXCH(J)>AMAX))#                                      PO39 124
EXCCNT=EXCCNT+1#                       Count irrelevant exclusion zon   PO39 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO39 126
IF(EXCCNT>=NEXCLR)EXCZON=no:#          No exclusion zones               PO39 127
IF(NINT(cvexczonlin:(TR))==yes:)#      Do draw exclusion zone line      PO39 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO39 129
EXCLIN=yes:#                           Draw in specific exclusion zon   PO39 130
VAL=cvexcdatlev:(TR)*CRVSCF#           Scaled level                     PO39 131
IF(GRYSTY!=1)    VAL=MAX(VAL,NULLEV)#  Avoid floating point errors      PO39 132
IF    (GRYSTY==2)VAL=LOG10(VAL)#       Logarithmic graph                PO39 133
ELSEIF(GRYSTY==3)VAL= SQRT(VAL)#       Square root graph                PO39 134
EXCLEV=YOR+DY+(VAL-OMIN)*OSCF#         Exclusion zone y value           PO39 135
IF(EXCLEV<SCOMIN\EXCLEV>SCOMAX)EXCLIN=no:# Exclusion zone y level is    PO39 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO39 137
ELSE EXCLIN=no:#                       Do not draw in exclusion zone    PO39 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO39 139
ELSE EXCZON=no:#                       No checks for exclusion zones    PO39 140
#                                                                       PO39 141
#    IDENTIFY FIRST AND LAST POINTS WITHIN REQUESTED PLOT RANGE         PO39 142
#    ------------------------------------------------                   PO39 143
#                                                                       PO39 144
FPT=1#                                 First element of ppoint array    PO39 145
REPEAT#                                Locate first element >amin       PO39 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO39 147
IF(PPOINT(twothet:,FPT)>=AMIN \ FPT>PNTIND) BREAK# Found or out of el   PO39 148
FPT=FPT+1#                                                              PO39 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO39 150
LPT=PNTIND#                            Initialise last point            PO39 151
REPEAT#                                Locate last element <amax        PO39 152
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PO39 153
IF(PPOINT(twothet:,LPT)<=AMAX \ LPT==1) BREAK# Found or out of elemen   PO39 154
LPT=LPT-1#                             Decrement last point             PO39 155
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PO39 156
#                                                                       PO39 157
#    DO WE INCLUDE THE PREDATA LINE                                     PO39 158
#    ------------------------------------                               PO39 159
#                                                                       PO39 160
IF(FPT==1&NINT(cvpredatlin:(TR))==yes:)# Have to include the pre data   PO39 161
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PO39 162
PRELIN=yes:#                           Include pre data line            PO39 163
VAL=cvpredatlev:(TR)*CRVSCF#           Scaled level                     PO39 164
IF    (GRYSTY==2)VAL=LOG10(VAL)#       Logarithmic graph                PO39 165
ELSEIF(GRYSTY==3)VAL= SQRT(VAL)#       Suare root  graph                PO39 166
PRELEV= YOR+(VAL+UDY-OMIN)*OSCF#       Pre-data y value                 PO39 167
IF(PRELEV<SCOMIN\PRELEV>SCOMAX)PRELIN=no:# No pre-data line now         PO39 168
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PO39 169
ELSE PRELIN=no:#                       No pre-data line                 PO39 170
IF(PRELIN==yes:)#                      Construct pre data line segmen   PO39 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PO39 172
PRELX(1)=axmin:(1)-UDX#                Set first x value                PO39 173
PRELY(1)=PRELEV#                       Set first y level                PO39 174
PRELX(2)=PPOINT(twothet:,FPT)#         Set second x coordinate          PO39 175
PRELY(2)=PRELEV#                       Set second y level               PO39 176
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PO39 177
#                                                                       PO39 178
#    DO WE INCLUDE THE POSTDATA LINE                                    PO39 179
#    ------------------------------------                               PO39 180
#                                                                       PO39 181
IF(PPOINT(twothet:,PNTIND)<AMAX &#     Last data point before abss ma   PO39 182
NINT(cvposdatlin:(TR))==yes:)#         Must include the post data lin   PO39 183
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PO39 184
POSLIN=yes:#                           Include post data line segment   PO39 185
VAL=cvposdatlev:(TR)*CRVSCF#           Scaled level                     PO39 186
IF    (GRYSTY==2)VAL=LOG10(VAL)#       Logarithmic graph                PO39 187
ELSEIF(GRYSTY==3)VAL= SQRT(VAL)#       Square root  graph               PO39 188
POSLEV= YOR+(VAL+UDY-OMIN)*OSCF#       Post-data y value                PO39 189
IF(POSLEV<SCOMIN\POSLEV>SCOMAX)POSLIN=no:# No post-data line            PO39 190
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PO39 191
ELSE POSLIN=no:#                       No post-data line                PO39 192
IF(POSLIN==yes:)#                      Construct post data line segme   PO39 193
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PO39 194
POSLX(1)=PPOINT(twothet:,PNTIND)#      Set first x value                PO39 195
# TEST ALSO FOR TERMINAL SKIP  POSITION                                 PO39 196
POSLY(1)=POSLEV#                       Set first y level                PO39 197
POSLX(2)=AMAX#                         Set second x coordinate          PO39 198
POSLY(2)=POSLEV#                       Set second y level               PO39 199
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PO39 200
#                                                                       PO39 201
#     PREPARE THE FIRST POINT FOR SEGMENT PLOTTING                      PO39 202
#     --------------------------------------------                      PO39 203
#                                                                       PO39 204
IF(PRELIN==yes:)#                      First point is in prelx array    PO39 205
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PO39 206
X1=PRELX(1)#                           First x component of pre data    PO39 207
Y1=PRELY(1)#                           First y component of pre data    PO39 208
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PO39 209
ELSEIF(FPT<=PNTIND)#                   Graph begins partway thru data   PO39 210
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PO39 211
IF(PPOINT(twothet:,FPT-1)<=AMIN)X1=AMIN# Set x1 to min value            PO39 212
ELSE X1=PPOINT(twothet:,FPT-1)#        Minimum x1 by default            PO39 213
IF(DBSIG==no:\PPOINT(yobssig:,FPT-1)<=0.0)SIG1=1.0# Make sigma unity    PO39 214
ELSE SIG1=ABS(PPOINT(yobssig:,FPT-1))# Ensure positive if not non-      PO39 215
IF(DBSIG==no:\PPOINT(yobssig:,FPT)<=0.0)SIG2=1.0# Make sigma unity      PO39 216
ELSE SIG2=ABS(PPOINT(yobssig:,FPT))#   Ensure positive if not non-nu    PO39 217
A=(X1-PPOINT(twothet:,FPT-1))/$#       Fractional part of the x axis    PO39 218
(PPOINT(twothet:,FPT)-PPOINT(twothet:,FPT-1))#                          PO39 219
Y1=(1-A)*PPOINT(TR,FPT-1)*SIG1+A*PPOINT(TR,FPT)*SIG2# Corresponding y   PO39 220
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PO39 221
ELSEIF(POSLIN==yes:)#                  Begin after all data finished    PO39 222
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PO39 223
X1=POSLX(1)#                           First  x component of post dat   PO39 224
Y1=POSLY(1)#                           First  y componet of  post dat   PO39 225
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PO39 226
#                                                                       PO39 227
VAL=Y1*CRVSCF#                         Get scaled y value               PO39 228
SCX1=XOR+DX+(X1-AMIN)*ASCF#            Simple linear two theta          PO39 229
IF    (GRYSTY==2)VAL=LOG10(VAL)#       Logarithmic graph                PO39 230
ELSEIF(GRYSTY==3)VAL= SQRT(VAL)#       Square root graph                PO39 231
SCY1=YOR+DY+(VAL-OMIN)*OSCF#           New y point                      PO39 232
segplus:#                              Begin new segment                PO39 233
DUMP=no:#                              Do not dump initially            PO39 234
SRES=0.0#                              Initially residual segment is    PO39 235
PNTCNT=1#                              Add first point to buffer        PO39 236
PCNT=0#                                                                 PO39 237
U(PNTCNT)=SCX1#                                                         PO39 238
V(PNTCNT)=SCY1#                                                         PO39 239
IF(PRELIN==yes:) STAGE=1#              The predata stage                PO39 240
ELSE STAGE=2#                                                           PO39 241
PNT=FPT#                                                                PO39 242
STOP=no:#                                                               PO39 243
#                                                                       PO39 244
#    CYCLE OVER ALL POINTS WITHIN THE REQUESTED PLOT RANGE              PO39 245
#    -----------------------------------------------------              PO39 246
#                                                                       PO39 247
REPEAT#                                                                 PO39 248
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PO39 249
IF     (STAGE==2)#                     Graph begins partway thru data   PO39 250
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PO39 251
X2=PPOINT(twothet:,PNT)#               Get the new x value              PO39 252
IF(DBSIG==no:\PPOINT(yobssig:,PNT)<=0.0)SIG2=1.0# Make sigma unity      PO39 253
ELSE SIG2=ABS(PPOINT(yobssig:,PNT))#   Ensure positive if not non-nul   PO39 254
Y2=PPOINT(TR,PNT)*SIG2#                                                 PO39 255
PNT=PNT+NSKIP#                         Increment pointer                PO39 256
IF(LPT<PNTIND&PNT>LPT)STOP=yes:#                                        PO39 257
ELSEIF(PNT>PNTIND)#                    At limit of measured data        PO39 258
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PO39 259
IF(POSLIN==yes:)STAGE=3#               Change stages                    PO39 260
ELSE STOP=yes:#                        Otherwise stop at end of this    PO39 261
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PO39 262
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PO39 263
ELSEIF(STAGE==1)#                      Examine pre-curve data           PO39 264
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PO39 265
X2=PRELX(2)#                           Get the next x value             PO39 266
Y2=PRELY(2)#                           Get the next y value             PO39 267
STAGE=2#                               Change stages                    PO39 268
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PO39 269
ELSEIF(STAGE==3)#                      Examine pre-curve data           PO39 270
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PO39 271
PCNT=PCNT+1#                           Get next data point              PO39 272
X2=POSLX(PCNT)#                        Get the next x value             PO39 273
Y2=POSLY(PCNT)#                        Get the next y value             PO39 274
IF(PCNT >=2) STOP=yes:#                Terminate graph                  PO39 275
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PO39 276
#                                                                       PO39 277
VAL=Y2*CRVSCF#                                                          PO39 278
IF    (GRYSTY==2)VAL=LOG10(VAL)#       Logarithmic                      PO39 279
ELSEIF(GRYSTY==3)VAL= SQRT(VAL)#       Sqrt                             PO39 280
SCX2=XOR+DX+(X2 -AMIN)*ASCF#                                            PO39 281
SCY2=YOR+DY+(VAL-OMIN)*OSCF#                                            PO39 282
#                                                                       PO39 283
#     MAKE CHECKS FOR EXCLUSION ZONE BOUNDARIES                         PO39 284
#     -----------------------------------------                         PO39 285
#                                                                       PO39 286
EXCLX(1)=SCX1#                                                          PO39 287
EXCLY(1)=SCY1#                                                          PO39 288
EXCCNT=1#                                                               PO39 289
IF(EXCZON==yes:)#                      Include exclusion zones          PO39 290
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PO39 291
#                                                                       PO39 292
DO J=1,NEXCLR#                         Search for first exclude high    PO39 293
IF(SCX1<SCEXCH(J)&SCX2>SCEXCH(J))BREAK# Iether out of zones or found    PO39 294
#                                                                       PO39 295
IF(J!=NEXCLR\ (SCX1<SCEXCH(NEXCLR)&SCX2>SCEXCH(NEXCLR)))#               PO39 296
IF(SCEXCL(J)<SCX1)#                    A false start 1/2 of exclusion   PO39 297
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PO39 298
EXCLY(1)=EXCLEV#                       Set first y level                PO39 299
EXCD(1)=no:#                           No dump as yet                   PO39 300
IF(EXCLIN==yes:) EXCLX(1)=SCX1#        Draw exclusion line from amin    PO39 301
ELSE#                                                                   PO39 302
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PO39 303
EXCLX(1)=SCEXCH(J)#                    First point begins at exclude    PO39 304
EXCLY(1)=SCY1#                         Set first y level                PO39 305
### should interpolate the y value between x1 and x2                    PO39 306
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PO39 307
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PO39 308
#                                                                       PO39 309
DO JJ=J,NEXCLR#                        Search for next exclude low      PO39 310
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PO39 311
IF(SCEXCL(JJ)>SCX2) BREAK#                                              PO39 312
IF(SCEXCL(JJ)>EXCLX(EXCCNT)&SCEXCL(JJ)<SCX2)# Encounted lower level     PO39 313
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PO39 314
EXCCNT=EXCCNT+1#                                                        PO39 315
EXCLX(EXCCNT)=SCEXCL(JJ)#              Get x coordinate                 PO39 316
EXCLY(EXCCNT)=SCY1#                    Interpolate#      set first y    PO39 317
EXCD(EXCCNT)=no:#                      Do not dump line at this point   PO39 318
IF (EXCLIN==yes:)#                     Include exclusion zone line      PO39 319
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PO39 320
EXCCNT=EXCCNT+1#                       Increment pre data point count   PO39 321
EXCLX(EXCCNT)=SCEXCL(JJ)#              Get x coordinate                 PO39 322
EXCLY(EXCCNT)=EXCLEV#                  Set first y level                PO39 323
EXCD(EXCCNT)=no:#                      Do not dump line at this point   PO39 324
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PO39 325
ELSE EXCD(EXCCNT)=yes:#                Dump line at this point          PO39 326
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PO39 327
IF(SCEXCH(JJ)>EXCLX(EXCCNT)&SCEXCH(JJ)<SCX2)# High side of exclusion    PO39 328
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PO39 329
IF (EXCLIN==yes:)#                     Include exclusion zone line      PO39 330
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 PO39 331
EXCCNT=EXCCNT+1#                       Increment point counter          PO39 332
EXCLX(EXCCNT)=SCEXCH(JJ)#              Get x coordinate                 PO39 333
EXCLY(EXCCNT)=EXCLEV#                  Set y level                      PO39 334
EXCD(EXCCNT)=no:#                      Do not dump line at this point   PO39 335
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 PO39 336
EXCCNT=EXCCNT+1#                                                        PO39 337
EXCLX(EXCCNT)=SCEXCH(JJ)#              Get x coordinate                 PO39 338
EXCLY(EXCCNT)=EXCLEV#                  Set y level                      PO39 339
EXCD(EXCCNT)=no:#                      Do not dump line at this point   PO39 340
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PO39 341
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PO39 342
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PO39 343
#                                                                       PO39 344
EXCCNT=EXCCNT+1#                                                        PO39 345
EXCLX(EXCCNT)=SCX2#                                                     PO39 346
EXCLY(EXCCNT)=SCY2#                    Or interpolated value            PO39 347
#                                                                       PO39 348
#    CHECK ALL LINE SEGMENTS FOR GRAPH BOUNDARIES                       PO39 349
#    --------------------------------------------                       PO39 350
#                                                                       PO39 351
I1=0#                                  Start at first point             PO39 352
REPEAT#                                                                 PO39 353
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 PO39 354
I1=I1+1#                               Get next point in list           PO39 355
IF(I1>=EXCCNT)BREAK#                   Have                             PO39 356
I2=I1+1#                               Next point in list               PO39 357
PPT=1#                                 Initialise point array marker    PO39 358
XP(PPT)=EXCLX(I1);YP(PPT)=EXCLY(I1)#   Load first point                 PO39 359
IF    (EXCLY(I1)>SCOMAX&EXCLY(I2)>SCOMAX&# Both greater                 PO39 360
NINT(cvconlintop:(TR))==no:)NEXT#      And no greater than line         PO39 361
ELSEIF(EXCLY(I1)<SCOMIN&EXCLY(I2)<SCOMIN&# Both lesser                  PO39 362
NINT(cvconlinbot:(TR))==no:)NEXT#      And no lesser than line          PO39 363
ELSEIF(EXCLY(I1)>SCOMAX\EXCLY(I1)<SCOMIN\# Test if point one valid      PO39 364
EXCLY(I2)>SCOMAX\EXCLY(I2)<SCOMIN)#    Test if point two valid          PO39 365
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 PO39 366
ifne:(EXCLY(I2),EXCLY(I1))#            Perfect horizontal line          PO39 367
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 PO39 368
A1=(SCOMAX-EXCLY(I1))/(EXCLY(I2)-EXCLY(I1))#                            PO39 369
A2=(SCOMIN-EXCLY(I1))/(EXCLY(I2)-EXCLY(I1))#                            PO39 370
MAXIM=no: ;MINIM=no:#                  Initialise tests                 PO39 371
IF(A1>=0.0&A1<=1.0)#                   Valid intermediate point exist   PO39 372
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 PO39 373
YYMAX=SCOMAX#                                                           PO39 374
XMAX=(1-A1)*EXCLX(I1)+A1*EXCLX(I2)#                                     PO39 375
MAXIM=yes:#                                                             PO39 376
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 PO39 377
IF(A2>=0.0&A2<=1.0)#                   Valid intermediate point exist   PO39 378
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 PO39 379
YYMIN=SCOMIN#                                                           PO39 380
XMIN=(1-A2)*EXCLX(I1)+A2*EXCLX(I2)#                                     PO39 381
MINIM=yes:#                                                             PO39 382
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 PO39 383
#                                                                       PO39 384
IF(MAXIM==yes: & MINIM==yes:)#         Two intermediate point scenari   PO39 385
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 PO39 386
PPT=3#                                                                  PO39 387
IF(XMAX >XMIN)#                        Twotheta sequence                PO39 388
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 PO39 389
XP(2)=XMIN ;YP(2)=YYMIN#                                                PO39 390
XP(3)=XMAX ;YP(3)=YYMAX#                                                PO39 391
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 PO39 392
ELSE#                                                                   PO39 393
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 PO39 394
XP(2)=XMAX ;YP(2)=YYMAX#                                                PO39 395
XP(3)=XMIN ;YP(3)=YYMIN#                                                PO39 396
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 PO39 397
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 PO39 398
ELSEIF(MAXIM==yes:)#                   One point above max & one belo   PO39 399
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 PO39 400
PPT=2#                                                                  PO39 401
XP(2)=XMAX ;YP(2)=YYMAX#                                                PO39 402
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 PO39 403
ELSEIF(MINIM==yes:)#                   One point above min & one poin   PO39 404
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 PO39 405
XP(2)=XMIN ;YP(2)=YYMIN#                                                PO39 406
PPT=2#                                                                  PO39 407
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 PO39 408
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 PO39 409
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 PO39 410
PPT=PPT+1#                             Load last point                  PO39 411
XP(PPT)=EXCLX(I2);YP(PPT)=EXCLY(I2)#   Load last point                  PO39 412
#                                                                       PO39 413
# FILTER AND TEST FOR VALID SEGMENTS                                    PO39 414
# ----------------------------------                                    PO39 415
#                                                                       PO39 416
PP1=1#                                                                  PO39 417
DO K=1,PPT#                            Loop over all (4) points         PO39 418
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 PO39 419
IF    (YP(K)>SCOMAX)YP(K)=SCOMAX#      Make point maximum               PO39 420
ELSEIF(YP(K)<SCOMIN)YP(K)=SCOMIN#      Make point minimum               PO39 421
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 PO39 422
IF(PPT>2)#                             An extreme value is present      PO39 423
DO K=1,2#                              Test for continuity              PO39 424
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 PO39 425
IF(K==1)J=2#                           Test points one and two          PO39 426
ELSE    J=PPT#                         Test last two points             PO39 427
IF((YP(J-1)>=SCOMAX&YP(J)>=SCOMAX&NINT(cvconlintop:(TR))==no:)\#        PO39 428
(YP(J-1)<=SCOMIN&YP(J)<=SCOMIN&NINT(cvconlinbot:(TR))==no:))#           PO39 429
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 PO39 430
IF(K==1)#                              First point                      PO39 431
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 PO39 432
PP1=2; PNTCNT=1; SRES=0.0#             Hopefully there was a previous   PO39 433
U(PNTCNT)=XP(2);V(PNTCNT)=YP(2)#       Reset first point                PO39 434
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 PO39 435
ELSE#                                  Last point                       PO39 436
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 PO39 437
PPT=PPT-1 ; DUMP=yes:#                 Definitely need to dump          PO39 438
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 PO39 439
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 PO39 440
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 PO39 441
#                                                                       PO39 442
#     DISSECT SEGMENT INTO COMPONENTS IF DASHED LINES ARE REQUIRED      PO39 443
#     ------------------------------------------------------------      PO39 444
#                                                                       PO39 445
DO K=PP1,PPT-1#                        Cycle over parts of the segmen   PO39 446
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 PO39 447
XPA= XP(K)  ;YPA=YP(K)#                Starting coords                  PO39 448
XPB= XP(K+1);YPB=YP(K+1)#              Finish coords                    PO39 449
#                                                                       PO39 450
#   DETERMINE ARC LENGTHS                                               PO39 451
#   ---------------------                                               PO39 452
#                                                                       PO39 453
SL=SQRT((XPB-XPA)**2 +(YPB-YPA)**2)#   Length of new segment            PO39 454
IF(SRES+SL>LINLEN)#                    New segment is longer than per   PO39 455
REPEAT#                                Cycle over small dashes and br   PO39 456
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 PO39 457
DSL=LINLEN-SRES#                       Component of sl                  PO39 458
FRACS=DSL/SL#                          Fraction of sl                   PO39 459
U(PNTCNT)=U(PNTCNT)+FRACS*(XPB-U(PNTCNT))# Add x value to buffer        PO39 460
V(PNTCNT)=V(PNTCNT)+FRACS*(YPB-V(PNTCNT))# Add x value to buffer        PO39 461
SRES=SL-DSL#                           Line segment minus prev top up   PO39 462
IF(DP==1)#                             Line segment is a dash           PO39 463
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 PO39 464
IF(VUTYPE==2) printline:(PNTCNT,U,V)#  Dump line movements to file      PO39 465
ELSE          linedraw:(PNTCNT,U,V)#   Print line movements to screen   PO39 466
PNTCNT=1#                                                               PO39 467
DP=2#                                  Line segment becomes a break     PO39 468
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 PO39 469
ELSE#                                  Current line segment is a brea   PO39 470
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 PO39 471
U(1)=U(PNTCNT)#                        Shift new starting x value in    PO39 472
V(1)=V(PNTCNT)#                        Shift new starting y value in    PO39 473
PNTCNT=2#                              Reset the pntcnt and no line d   PO39 474
DP=1#                                  Line segment becomes a dash      PO39 475
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 PO39 476
LINLEN=DL(DP)#                         Set new line segment length      PO39 477
IF(SRES<LINLEN)BREAK#                  Residual line is to short so n   PO39 478
SL=SRES ; SRES=0.0#                    New segment length and residua   PO39 479
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 PO39 480
ELSE SRES=SRES+SL#                                                      PO39 481
PNTCNT=PNTCNT+1#                                                        PO39 482
U(PNTCNT)= XPB#                                                         PO39 483
V(PNTCNT)= YPB#                                                         PO39 484
#                                                                       PO39 485
#      PENULTIMATE PRINT                                                PO39 486
#      -----------------                                                PO39 487
#                                                                       PO39 488
IF(K==PPT-1&I1==EXCCNT-1&STOP==yes:)DUMP=yes:# At last data point       PO39 489
IF(PNTCNT==100)#                       Continue from 100th point        PO39 490
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 PO39 491
IF(VUTYPE==2) printline:(PNTCNT,U,V)#  Dump line movements to file      PO39 492
ELSE          linedraw:(PNTCNT,U,V)#   Print line movements to screen   PO39 493
U(1)= U(PNTCNT)#                       Save the last point  x coord     PO39 494
V(1)= V(PNTCNT)#                       Save the last point y coord      PO39 495
PNTCNT=1#                                                               PO39 496
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 PO39 497
IF(DUMP==yes:)#                        Dumped the segments, no contin   PO39 498
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 PO39 499
IF(VUTYPE==2) printline:(PNTCNT,U,V)#  Dump line movements to file      PO39 500
ELSE          linedraw:(PNTCNT,U,V)#   Print line movements to screen   PO39 501
PNTCNT=0#                              Begin again from zero            PO39 502
SRES=0.0#                              Reset residual segment length    PO39 503
DUMP=no:#                              Reset the dump flag              PO39 504
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 PO39 505
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 PO39 506
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 PO39 507
50CONTINUE#                                                             PO39 508
SCX1=SCX2#                                                              PO39 509
SCY1=SCY2#                                                              PO39 510
IF(STOP==yes:) BREAK#                                                   PO39 511
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PO39 512
#                                                                       PO39 513
segend:#                               Close this segment               PO39 514
#                                                                       PO39 515
100 CONTINUE#                                                           PO39 516
RETURN#                                                                 PO39 517
END#                                                                    PO39 518
systemheader:(PO40)#                   Actually plot the hklbars        PO40   1
####################################################################### PO40   2
#                                                                     # PO40   3
#                          PO40                                       # PO40   4
#                                                                     # PO40   5
####################################################################### PO40   6
SUBROUTINE PO40(TR,PT)#                                                 PO40   7
include:(AACOMN)#                                                       PO40   8
include:(POCOMN)#                                                       PO40   9
#                                                                       PO40  10
INTEGER TR,PT#                         The trace and the graphic bloc   PO40  11
INTEGER TRC#                                                            PO40  12
INTEGER I,J,K,IP,IR,LREFL,COLR#                                         PO40  13
REAL XOR,YOR,SCF,HIT,WID#                                               PO40  14
REAL GRYSTY,GRXSTY#                                                     PO40  15
REAL DX,DY,X1,Y1#                                                       PO40  16
INTEGER HBDISP,HBLABL#                                                  PO40  17
REAL HBSIZE,HBFSZ,HBANGL,HBLYMIN#                                       PO40  18
REAL HBYMIN#                                                            PO40  19
REAL ASCF,UDX,AMAX,AMIN#                                                PO40  20
REAL U(2),V(2),HKL(3)#                                                  PO40  21
string:(TEXT,11)#                                                       PO40  22
realdata:(FMT,[30313.,60313.,90313.])#                                  PO40  23
datastuff:#                                                             PO40  24
#                                                                       PO40  25
#     GET GRAPH DIMENSION POINTERS                                      PO40  26
#     ----------------------------                                      PO40  27
#                                                                       PO40  28
TRC=TR+6#                                                               PO40  29
XOR=RELXOR+gptgxorigin:*RELSCF#        Absolute x origin of graph       PO40  30
YOR=RELYOR+gptgyorigin:*RELSCF#        Absolute y origin of graph       PO40  31
SCF=RELSCF#                            Relative scale factor            PO40  32
HIT=       gptgheight: *RELSCF#        Absolute height of graph         PO40  33
WID=gptgheight:*gptgaspect:*RELSCF#    Absolute width of graph          PO40  34
#                                                                       PO40  35
#     GET SPECIFICS FOR DRAWING THIS TRACE                              PO40  36
#     ------------------------------------                              PO40  37
#                                                                       PO40  38
GRYSTY=NINT(axtype:(2))#               Style of graph yaxis  lin/log/   PO40  39
GRXSTY=NINT(axtype:(1))#               Style of graph xaxis twotheta/   PO40  40
IF(GRXSTY!=1) GOTO 100#                D-spacing style is not support   PO40  41
#                                                                       PO40  42
DX=0.0;DY=0.0#                         Initialise curve shifts          PO40  43
#IF(NINT(CVSHIFT:(TRC))==YES:)# APPLY CURVE SHIFTS                      PO40  44
#$(                                                                     PO40  45
#DX=CVSHX:(TRC)*WID#      SHIFT OF CURVE FROM ORIGIN % OF GRAPH         PO40  46
#DY=CVSHY:(TRC)*HIT#      SHIFT OF CURVE FROM ORIGIN % OF GRAPH         PO40  47
#$)                                                                     PO40  48
IF(nint:(hbshift:(TR))==yes:)#         Apply curve shifts               PO40  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO40  50
DX=DX+hbxoffset:(TR)*WID#              Shift of curve from origin % o   PO40  51
DY=DY+hbyoffset:(TR)*HIT#              Shift of curve from origin % o   PO40  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO40  53
#                                                                       PO40  54
#    GET AMAX, AMIN AND OMIN, OMAX AND GET DIMENSIONAL SCALE FACTOR     PO40  55
#    --------------------------------------------------------------     PO40  56
#                                                                       PO40  57
ASCF=WID/(axmax:(1)-axmin:(1))#        Absisca scale factor (assumed    PO40  58
UDX=DX/ASCF#                           Unscaled dx                      PO40  59
AMAX=axmax:(1)-UDX#                    Abssisca maximum                 PO40  60
AMIN=axmin:(1)-UDX#                    Absissca minimum                 PO40  61
#                                                                       PO40  62
#                                                                       PO40  63
TEXT=' '#                              Initialize blank                 PO40  64
HBDISP=nint:(hbdisplay:(TR))#          Get common local vars            PO40  65
HBYMIN=hbymin:(TR)#                                                     PO40  66
HBSIZE=hbsize:(TR)#                                                     PO40  67
HBLABL=nint:(hblabel:(TR))#                                             PO40  68
HBLYMIN=hblabymin:(TR)#                                                 PO40  69
HBFSZ=hbfontsize:(TR)*SCF#                                              PO40  70
HBANGL=hbangle:(TR)#                                                    PO40  71
linestyl:(1)#                          Basic x11 line style is solid    PO40  72
linecolr:(NINT(cvlncolor:(TRC)))#      Set linecolor                    PO40  73
linesize:(     cvlinewd:(TRC))#        Set linewidth                    PO40  74
segplus:#                                                               PO40  75
#                                                                       PO40  76
LREFL=FIRREF(TR+1)#                    Precursor to next phase          PO40  77
IP=NEWM-NEWPAK#                        Before first packet              PO40  78
IF(HBDISP==yes:)#                                                       PO40  79
FOR(IR=FIRREF(TR)-1;IR<LREFL;IR=IR+1)# For all phase reflections        PO40  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO40  81
IF(IR>IREFMX)#                         Out of memory storage            PO40  82
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO40  83
readdac:(ioda1:,,IR-IREFMX,(BUF(I),I=1,NEWPAK))# Read active refln fi   PO40  84
IF(BUF(14)<HBYMIN)NEXT#                Ignore ical too weak reflectio   PO40  85
X1=BUF(5)#                             Scattering angle                 PO40  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO40  87
ELSE#                                  In memory storage                PO40  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO40  89
IP=IP+NEWPAK#                          Step to next reflection          PO40  90
IF(QX(IP+14)<HBYMIN)NEXT#              Ignore ical too weak reflectio   PO40  91
X1=QX(IP+5)#                           Scattering angle                 PO40  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO40  93
#                                                                       PO40  94
IF(X1<AMIN)       NEXT#                Skip out of range                PO40  95
IF(X1>AMAX)       BREAK#               No need to continue              PO40  96
U(1)=XOR+DX+(X1-AMIN)*ASCF#            Simple linear two theta          PO40  97
V(1)=YOR+DY#                           New y point                      PO40  98
U(2)=U(1)#                             Simple linear two theta          PO40  99
V(2)=V(1)+HBSIZE*HIT#                  New y point                      PO40 100
IF(VUTYPE==2) printline:(2,U,V)#       Dump line movements to file      PO40 101
ELSE          linedraw:(2,U,V)#        Print line movements to screen   PO40 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO40 103
segend:#                                                                PO40 104
#                                                                       PO40 105
#  DRAW HKL LABELS ON SELECTIVE REFS                                    PO40 106
#  ---------------------------------                                    PO40 107
#                                                                       PO40 108
segplus:#                                                               PO40 109
COLR= NINT(cvlncolor:(TRC))#           Get linecolor                    PO40 110
#COLR= 7#           GET LINECOLOR                                       PO40 111
IP=NEWM-NEWPAK#                        Before first packet              PO40 112
IF(HBLABL==yes:)#                                                       PO40 113
FOR(IR=FIRREF(TR)-1;IR<LREFL;IR=IR+1)# For all phase reflections        PO40 114
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO40 115
IF(IR>IREFMX)#                         Out of memory storage            PO40 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO40 117
readdac:(ioda1:,,IR-IREFMX,(BUF(I),I=1,NEWPAK))# Read active refln fi   PO40 118
IF(BUF(14)<HBLYMIN)NEXT#               Ignore ical too weak reflectio   PO40 119
DO I=1,3;HKL(I)=BUF(I)#                Get hkl                          PO40 120
X1=BUF(5)#                             Scattering angle                 PO40 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO40 122
ELSE#                                  In memory storage                PO40 123
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO40 124
IP=IP+NEWPAK#                          Step to next reflection          PO40 125
IF(QX(IP+14)<HBLYMIN)NEXT#             Ignore ical too weak reflectio   PO40 126
DO I=1,3;HKL(I)=QX(IP+I)#              Get hkl                          PO40 127
X1=QX(IP+5)#                           Scattering angle                 PO40 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO40 129
#                                                                       PO40 130
IF(X1<AMIN)       NEXT#                Skip out of range                PO40 131
IF(X1>AMAX)       BREAK#               No need to continue              PO40 132
X1=XOR+DX+(X1-AMIN)*ASCF#              Simple linear two theta          PO40 133
Y1=YOR+DY+HBSIZE*HIT#                  New y point                      PO40 134
ncodefld:(HKL,1,TEXT,FMT,3)#           Build the string                 PO40 135
DO I=7,1,-3#                                                            PO40 136
IF(TEXT(I^I+1)=='  ')TEXT(I^9)=TEXT(I+1^9+1)# Reduce 2 to 1 space       PO40 137
IF(TEXT(1^1)==' ')I=2#                                                  PO40 138
ELSE I=1#                                                               PO40 139
DO J=9,I,-1;IF(TEXT(J^J)!=' ')BREAK#                                    PO40 140
K=J-I+1#                                                                PO40 141
TEXT(1^K)=TEXT(I^J)#                                                    PO40 142
graphtext:(X1,Y1,COLR,HBFSZ,HBANGL,K,TEXT)# Draw text                   PO40 143
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO40 144
segend:#                                                                PO40 145
#                                                                       PO40 146
100 CONTINUE#                                                           PO40 147
RETURN#                                                                 PO40 148
END#                                                                    PO40 149
systemheader:(PO41)#                   Plot the abscisca axis           PO41   1
####################################################################### PO41   2
#                                                                     # PO41   3
#                          PO41                                       # PO41   4
#                                                                     # PO41   5
####################################################################### PO41   6
SUBROUTINE PO41(PT)#                                                    PO41   7
include:(AACOMN)#                                                       PO41   8
include:(POCOMN)#                                                       PO41   9
#                                                                       PO41  10
INTEGER PT#                            The graph to be plotted          PO41  11
INTEGER COLR,NCHAR#                    Text string plotting data        PO41  12
REAL    XO1,WID,HIT#                   Graph dimensions                 PO41  13
REAL    XO,YO,THETA#                   Text string plotting data        PO41  14
REAL    XOR,SCF#                       Origin offsets and scalefactor   PO41  15
REAL    U(2),V(2)#                                                      PO41  16
INTEGER CENDIG,DELDIG,NUN,NDP#                                          PO41  17
INTEGER I,J#                                                            PO41  18
REAL    ACNUM,CHAWID#                                                   PO41  19
REAL    AMIN,AMAX,ASCF#                                                 PO41  20
REAL    FMT#                                                            PO41  21
REAL    TSIZE#                                                          PO41  22
INTEGER TYPE#                                                           PO41  23
REAL HSCF#                                                              PO41  24
REAL ZX,CX,WINASP,BLKASP,XOFF#                                          PO41  25
REAL PBMIN,PBMAX,PAMIN,PAMAX,PARNGE,DVAL,DP,UNITS#                      PO41  26
REAL VMIN,V1,DMVAL,DSVAL,P1,X,FUDGE,PX#                                 PO41  27
string:(TEXT,20)#                                                       PO41  28
realdata:(UTAB,[1.0,1.5,2.0,2.5,4.,5.,10.])#                            PO41  29
datastuff:#                                                             PO41  30
#                                                                       PO41  31
#  ZOOMED, TRANSLATED SHIFTED BLOCK PARAMETERS                          PO41  32
#  -------------------------------------------                          PO41  33
#                                                                       PO41  34
ZX=ZOOM(PT,zoomx:)#                    Get horizontal zoom factor       PO41  35
CX=HSCROLL(PT,sccentre:)#                                               PO41  36
WINASP=ASPECT(graphc:)#                Scaled relative to height        PO41  37
BLKASP=gptbaspect:#                    Graph block aspect ratio         PO41  38
XOFF=WINASP/2.-BLKASP*ZX*CX#           Offset for drawing zoomed tran   PO41  39
#                                                                       PO41  40
#     GET GRAPH DIMENSION POINTERS                                      PO41  41
#     ----------------------------                                      PO41  42
#                                      In terms of blkasp scale         PO41  43
XOR=RELXOR#                            Block  x origin is 0             PO41  44
SCF=RELSCF#                            Relative scale factor            PO41  45
XO1=      XOR+ gptgxorigin: *SCF#      X origin of graph in blkasp sc   PO41  46
HIT=            gptgheight: *SCF#      Height of graph in blkasp scal   PO41  47
WID=gptgaspect:*gptgheight: *SCF#      Width of graph in blkasp scale   PO41  48
#                                                                       PO41  49
PBMIN=  XO1     *ZX+XOFF#              Location of first point          PO41  50
PBMAX= (XO1+WID)*ZX+XOFF#              Location of last graph point     PO41  51
PBMIN=MAX(PBMIN,0.)#                   Can only display from 0          PO41  52
PBMAX=MIN(PBMAX,WINASP)#               To width (winasp) of window      PO41  53
COVFRAC=(PBMAX-PBMIN)/WINASP+0.0001
PBMIN=(PBMIN-XOFF)/ZX#                 Convert back to graph dims       PO41  54
PBMAX=(PBMAX-XOFF)/ZX#                 Convert back to graph dims       PO41  55
IF(PBMAX<XO1\PBMIN>XO1+WID) RETURN#    Off the map                      PO41  56
#                                                                       PO41  57
#    GRAPH COORDINATES                                                  PO41  58
#    -----------------                                                  PO41  59
#                                                                       PO41  60
AMIN=axmin:(1)#                        Min value of abscissa            PO41  61
AMAX=axmax:(1)#                        Max value of abscissa            PO41  62
ASCF=WID/(AMAX-AMIN)#                  Axis scale factor (contains sc   PO41  63
PAMIN=AMIN+(PBMIN-XO1)/ASCF#           Min value considered for displ   PO41  64
PAMAX=AMIN+(PBMAX-XO1)/ASCF#           Max val considered for display   PO41  65
#                                                                       PO41  66
PARNGE=PAMAX-PAMIN#                                                     PO41  67
DVAL=PARNGE/AINT(COVFRAC*6.)#          Look for six tick intervals      PO41  68

DP=LOG10(DVAL)#                        Get decimal places               PO41  69
IF(DP>=0.)DP= AINT(DP)#                1-9.9 ->0; 10.-99.9 ->1          PO41  70
ELSEIF(AINT(DP)==DP)DP=AINT(DP)#       .1 ->-1; .01->-2 etc             PO41  71
ELSE      DP=-1.+AINT(DP)#             .11-0.99 ->-1; .011-.1-> -2      PO41  72
UNITS=10.**(DP)#                                                        PO41  73
DVAL=UNITS*AINT(DVAL/UNITS)#           Rounded to nearest units         PO41  74
VMIN=1.E+6#                                                             PO41  75
DO I=1,7#                                                               PO41  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO41  77
V1=ABS(PARNGE/(UTAB(I)*UNITS)-5.)#                                      PO41  78
IF(V1>VMIN)NEXT#                                                        PO41  79
VMIN=V1#                                                                PO41  80
J=I#                                                                    PO41  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO41  82
DVAL=UTAB(J)*UNITS#                    Units to use                     PO41  83
IF(J==2\J==4)#                         Ugly units                       PO41  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO41  85
DMVAL=DVAL#                            No medium ticks                  PO41  86
DSVAL=DVAL/5.#                         Just 4 small ticks               PO41  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO41  88
ELSE#                                  Nicer units                      PO41  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO41  90
DMVAL=DVAL/2.#                         1 medium tick                    PO41  91
DSVAL=DVAL/10.#                        9 small ticks                    PO41  92
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO41  93
P1=AINT(PAMIN/DVAL)*DVAL#              Truncate to lower value          PO41  94
IF(PAMIN<0.)P1=P1-DVAL#                Go one lower if negative         PO41  95
DO NDP=0,8#                            Get multiplicative               PO41  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO41  97
X=DVAL*(10.**(NDP))#                                                    PO41  98
ifeq:(X,ANINT(X)) BREAK#               Round                            PO41  99
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO41 100
#                                                                       PO41 101
#  PARAMS FOR ABSSISCA PIXMAP                                           PO41 102
#  --------------------------                                           PO41 103
#                                                                       PO41 104
setcanvas:(abscissac:,0)#                                               PO41 105
erasepage:(abscissac:,1)#              Erase and delete segments        PO41 106
segplus:#                              Begin new segment                PO41 107
CHAWID= 0.7*TSIZE#                     Width of characters              PO41 108
COLR=7#                                                                 PO41 109
TSIZE=0.5#                                                              PO41 110
HSCF=ASPECT(abscissac:)/ASPECT(graphc:)#                                PO41 111
#                                                                       PO41 112
linestyl:(1)#                          Line style is solid              PO41 113
linecolr:(1)#                          Set line colour                  PO41 114
linesize:(1.5)#                        Set current line size            PO41 115
V(1)=0.90#                                                              PO41 116
V(2)=V(1)#                             Y finish of axis                 PO41 117
U(1)=(PBMIN*ZX+XOFF)*HSCF#                                              PO41 118
U(2)=(PBMAX*ZX+XOFF)*HSCF#                                              PO41 119
linedraw:(2,U,V)#                      Print line movements to screen   PO41 120
#                                                                       PO41 121
#                                                                       PO41 122
FUDGE=PAMAX/1000.#                                                      PO41 123
FOR(PX=P1;PX<=PAMAX+FUDGE;PX=PX+DSVAL)#                                 PO41 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO41 125
IF(PX<PAMIN)NEXT#                                                       PO41 126
ifeq:(     ANINT(PX/DVAL ),PX/DVAL ,.0001)TYPE=3# Large  tick mark      PO41 127
ELSE ifeq:(ANINT(PX/DMVAL),PX/DMVAL,.001)TYPE=2# Medium tick mark       PO41 128
ELSE                              TYPE=1# Small  tick mark              PO41 129
U(1)=(((PX-AMIN)*ASCF+XO1)*ZX+XOFF)*HSCF#                               PO41 130
U(2)=U(1)#                             Same x position                  PO41 131
V(1)=0.9#                                                               PO41 132
V(2)=V(1)-FLOAT(TYPE)*0.15#                                             PO41 133
linedraw:(2,U,V)#                      Print line movements to screen   PO41 134
#                                                                       PO41 135
IF(TYPE!=3)NEXT#                       Only label large ticks           PO41 136
ACNUM=PX#                                                               PO41 137
ifne:(ACNUM,0.0,.000001)#              If it equals zero there is tro   PO41 138
NUN=NINT(AINT(LOG10(ABS(ACNUM))))+1#   Number of unit places of most    PO41 139
ELSE NUN=1#                            Only one unit place for zero     PO41 140
IF(NDP<0 & NUN<-NDP)NDP=NUN+NDP#       Not ndp but n digits total       PO41 141
IF(ACNUM<0.0)NUN=NUN+1#                Add one place for negative sig   PO41 142
IF(NUN>0 )#                            Number is larger than 1.0        PO41 143
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO41 144
NCHAR=NUN+1+NDP#                       Number of characters in number   PO41 145
IF(NDP>0)FMT=FLOAT(NCHAR)*10100.+FLOAT(NDP)*10.+2.# Decimal numbers     PO41 146
ELSE     FMT=FLOAT(NCHAR)*10100.+        1.*10.+3.# An exact integral   PO41 147
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO41 148
ELSE#                                  Number is less than 1.0          PO41 149
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO41 150
NCHAR= 1-NDP#                          One for dplace + ndp chars       PO41 151
FMT=FLOAT(NCHAR)*10100.-FLOAT(NDP)*10. +2.# Decimal numbers             PO41 152
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO41 153
TEXT=' '#                              Erase string                     PO41 154
ncodefld:(ACNUM,1,TEXT,FMT,1)#         Encode the number in the strin   PO41 155
CENDIG=0#                              Centre on decimal                PO41 156
IF(NUN<CENDIG)DELDIG=0#                Align to left column             PO41 157
ELSE          DELDIG=CENDIG-NUN#       Number of characters to be dis   PO41 158
XO=U(1)+DELDIG*CHAWID#                 Get the x position               PO41 159
YO=V(2)-TSIZE/2.#                      Displace below                   PO41 160
drawgtext:(XO,YO,COLR,TSIZE,THETA,NCHAR,TEXT)# Print text               PO41 161
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO41 162
#                                                                       PO41 163
segend:#                               End this segment                 PO41 164
#                                                                       PO41 165
RETURN#                                                                 PO41 166
END#                                                                    PO41 167
systemheader:(PO42)#                   Plot the abscisca axis           PO42   1
####################################################################### PO42   2
#                                                                     # PO42   3
#                          PO42                                       # PO42   4
#                                                                     # PO42   5
####################################################################### PO42   6
SUBROUTINE PO42(PT)#                                                    PO42   7
include:(AACOMN)#                                                       PO42   8
include:(POCOMN)#                                                       PO42   9
#                                                                       PO42  10
INTEGER PT#                            The graph to be plotted          PO42  11
INTEGER COLR,NCHAR#                    Text string plotting data        PO42  12
REAL    YO1,HIT#                       Graph dimensions                 PO42  13
REAL    XO,YO,THETA#                   Text string plotting data        PO42  14
REAL    YOR,SCF#                       Origin offsets and scalefactor   PO42  15
REAL    U(2),V(2)#                                                      PO42  16
INTEGER CENDIG,DELDIG,NUN,NDP#                                          PO42  17
INTEGER I,J#                                                            PO42  18
REAL    ACNUM,CHAWID#                                                   PO42  19
REAL    AMIN,AMAX,ASCF#                                                 PO42  20
REAL    FMT#                                                            PO42  21
REAL    TSIZE#                                                          PO42  22
INTEGER TYPE#                                                           PO42  23
REAL ZY,CY,WINASP,BLKASP,YOFF,PBMIN,PBMAX,PAMIN,PAMAX#                  PO42  24
REAL PARNGE,DVAL,DP,UNITS,VMIN,V1,DMVAL,DSVAL,P1,X,VSCF,PX#             PO42  25
REAL FUDGE#                                                             PO42  26
string:(TEXT,20)#                                                       PO42  27
realdata:(UTAB,[1.0,1.5,2.0,2.5,4.,5.,10.])#                            PO42  28
datastuff:#                                                             PO42  29
#                                                                       PO42  30
#  ZOOMED, TRANSLATED SHIFTED BLOCK PARAMETERS                          PO42  31
#  -------------------------------------------                          PO42  32
#                                                                       PO42  33
ZY=ZOOM(PT,zoomy:)#                    Get horizontal zoom factor       PO42  34
CY=VSCROLL(PT,sccentre:)#                                               PO42  35
WINASP=ASPECT(graphc:)#                Scaled relative to height        PO42  36
BLKASP=gptbaspect:#                    Graph block aspect ratio         PO42  37
#                                                                       PO42  38
YOFF=WINASP/2.-BLKASP*ZY*CY#           Offset for drawing zoomed tran   PO42  39
YOFF=1./2.-1.*ZY*CY#                   Offset for drawing zoomed tran   PO42  40
#                                                                       PO42  41
#     GET GRAPH DIMENSION POINTERS                                      PO42  42
#     ----------------------------                                      PO42  43
#                                      In terms of blkasp scale         PO42  44
YOR=RELYOR#                            Block  x origin is 0             PO42  45
SCF=RELSCF#                            Relative scale factor            PO42  46
YO1=      YOR+ gptgyorigin: *SCF#      X origin of graph in blkasp sc   PO42  47
HIT=            gptgheight: *SCF#      Height of graph in blkasp scal   PO42  48
#                                                                       PO42  49
PBMIN=  YO1     *ZY+YOFF#              Location of first point          PO42  50
PBMAX= (YO1+HIT)*ZY+YOFF#              Location of last graph point     PO42  51
PBMIN=MAX(PBMIN,0.)#                   Can only display from 0          PO42  52
PBMAX=MIN(PBMAX,1.)#                   To width (winasp) of window      PO42  53
COVFRAC=(PBMAX-PBMIN)+0.0001
PBMIN=(PBMIN-YOFF)/ZY#                 Convert back to graph dims       PO42  54
PBMAX=(PBMAX-YOFF)/ZY#                 Convert back to graph dims       PO42  55
IF(PBMAX<YO1\PBMIN>YO1+HIT) RETURN#    Off the map                      PO42  56
#                                                                       PO42  57
#    GRAPH COORDINATES                                                  PO42  58
#    -----------------                                                  PO42  59
#                                                                       PO42  60
AMIN=axmin:(2)#                        Min value of ordinate            PO42  61
AMAX=axmax:(2)#                        Max value of ordinate            PO42  62
ASCF=HIT/(AMAX-AMIN)#                  Axis scale factor (contains sc   PO42  63
PAMIN=AMIN+(PBMIN-YO1)/ASCF#           Min value considered for displ   PO42  64
PAMAX=AMIN+(PBMAX-YO1)/ASCF#           Max val considered for display   PO42  65
#                                                                       PO42  66
#                                                                       PO42  67
PARNGE=PAMAX-PAMIN#                                                     PO42  68
DVAL=PARNGE/AINT(COVFRAC*4.)#          Look for four tick intervals      PO41  68
DP=LOG10(DVAL)#                        Get decimal places               PO42  70
IF(DP>=0.)DP= AINT(DP)#                1-9.9 ->0; 10.-99.9 ->1          PO42  71
ELSEIF(AINT(DP)==DP)DP=AINT(DP)#       .1 ->-1; .01->-2 etc             PO42  72
ELSE      DP=-1.+AINT(DP)#             .11-0.99 ->-1; .011-.1-> -2      PO42  73
UNITS=10.**(DP)#                                                        PO42  74
DVAL=UNITS*AINT(DVAL/UNITS)#           Rounded to nearest units         PO42  75
VMIN=1.E+6#                                                             PO42  76
DO I=1,7#                                                               PO42  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO42  78
V1=ABS(PARNGE/(UTAB(I)*UNITS)-5.)#                                      PO42  79
IF(V1>VMIN)NEXT#                                                        PO42  80
VMIN=V1#                                                                PO42  81
J=I#                                                                    PO42  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO42  83
DVAL=UTAB(J)*UNITS#                    Units to use                     PO42  84
IF(J==2\J==4)#                         Ugly units                       PO42  85
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO42  86
DMVAL=DVAL#                            No medium ticks                  PO42  87
DSVAL=DVAL/5.#                         Just 4 small ticks               PO42  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO42  89
ELSE#                                  Nicer units                      PO42  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO42  91
DMVAL=DVAL/2.#                         1 medium tick                    PO42  92
DSVAL=DVAL/10.#                        9 small ticks                    PO42  93
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO42  94
P1=AINT(PAMIN/DVAL)*DVAL#              Truncate to lower value          PO42  95
IF(PAMIN<0.)P1=P1-DVAL#                Go one lower if negative         PO42  96
DO NDP=0,8#                            Get multiplicative               PO42  97
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO42  98
X=DVAL*(10.**(NDP))#                                                    PO42  99
ifeq:(X,ANINT(X)) BREAK#               Round                            PO42 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO42 101
#                                                                       PO42 102
#  PARAMS FOR ORDINATE PIXMAP                                           PO42 103
#  --------------------------                                           PO42 104
#                                                                       PO42 105
setcanvas:(ordinatec:,0)#                                               PO42 106
erasepage:(ordinatec:,1)#              Erase and delete segments        PO42 107
segplus:#                              Begin new segment                PO42 108
TSIZE=0.020#                                                            PO42 109
CHAWID= 0.7*TSIZE#                     Width of characters              PO42 110
COLR=7#                                                                 PO42 111
#HSCF=PIXASP/WINASP*1.05#                                               PO42 112
#VSCF=ASPECT(ORDINATEC:)/ASPECT(GRAPHC:)*1.05#                          PO42 113
VSCF=1.0#                                                               PO42 114
THETA=90.#                                                              PO42 115
#                                                                       PO42 116
linestyl:(1)#                          Line style is solid              PO42 117
linecolr:(1)#                          Set line colour                  PO42 118
linesize:(1.5)#                        Set current line size            PO42 119
U(1)=0.95*ASPECT(ordinatec:)#                                           PO42 120
U(2)=U(1)#                             Y finish of axis                 PO42 121
V(1)=(PBMIN*ZY+YOFF)*VSCF#                                              PO42 122
V(2)=(PBMAX*ZY+YOFF)*VSCF#                                              PO42 123
linedraw:(2,U,V)#                      Print line movements to screen   PO42 124
#                                                                       PO42 125
FUDGE=ABS(PAMAX)/1000.#                                                 PO42 126
FOR(PX=P1;PX<=PAMAX+FUDGE;PX=PX+DSVAL)#                                 PO42 127
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO42 128
IF(PX<PAMIN)NEXT#                                                       PO42 129
ifeq:(     ANINT(PX/DVAL ),PX/DVAL ,.0001)TYPE=3# Large  tick mark      PO42 130
ELSE ifeq:(ANINT(PX/DMVAL),PX/DMVAL,.001)TYPE=2# Medium tick mark       PO42 131
ELSE                              TYPE=1# Small  tick mark              PO42 132
U(1)=0.95*ASPECT(ordinatec:)#                                           PO42 133
U(2)=U(1)-FLOAT(TYPE)*0.01#                                             PO42 134
V(1)=(((PX-AMIN)*ASCF+YO1)*ZY+YOFF)*VSCF#                               PO42 135
V(2)=V(1)#                             Same y position                  PO42 136
linedraw:(2,U,V)#                      Print line movements to screen   PO42 137
#                                                                       PO42 138
IF(TYPE!=3)NEXT#                       Only label large ticks           PO42 139
ACNUM=PX#                                                               PO42 140
ifne:(ACNUM,0.0,.000001)#              If it equals zero there is tro   PO42 141
NUN=NINT(AINT(LOG10(ABS(ACNUM))))+1#   Number of unit places of most    PO42 142
ELSE NUN=1#                            Only one unit place for zero     PO42 143
IF(NDP<0 & NUN<-NDP)NDP=NUN+NDP#       Not ndp but n digits total       PO42 144
IF(ACNUM<0.0)NUN=NUN+1#                Add one place for negative sig   PO42 145
IF(NUN>0 )#                            Number is larger than 1.0        PO42 146
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO42 147
NCHAR=NUN+1+NDP#                       Number of characters in number   PO42 148
IF(NDP>0)FMT=FLOAT(NCHAR)*10100.+FLOAT(NDP)*10.+2.# Decimal numbers     PO42 149
ELSE     FMT=FLOAT(NCHAR)*10100.+        1.*10.+3.# An exact integral   PO42 150
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO42 151
ELSE#                                  Number is less than 1.0          PO42 152
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO42 153
NCHAR= 1-NDP#                          One for dplace + ndp chars       PO42 154
FMT=FLOAT(NCHAR)*10100.-FLOAT(NDP)*10. +2.# Decimal numbers             PO42 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO42 156
TEXT=' '#                              Erase string                     PO42 157
ncodefld:(ACNUM,1,TEXT,FMT,1)#         Encode the number in the strin   PO42 158
CENDIG=0#                              Centre on decimal                PO42 159
IF(NUN<CENDIG)DELDIG=0#                Align to left column             PO42 160
ELSE          DELDIG=CENDIG-NUN#       Number of characters to be dis   PO42 161
XO=U(2)+TSIZE/2.#                      Displace below                   PO42 162
YO=V(1)+DELDIG*CHAWID#                 Get the x position               PO42 163
drawgtext:(XO,YO,COLR,TSIZE,THETA,NCHAR,TEXT)# Print text               PO42 164
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO42 165
#                                                                       PO42 166
segend:#                               End this segment                 PO42 167
#                                                                       PO42 168
RETURN#                                                                 PO42 169
END#                                                                    PO42 170
systemheader:(PO50)#                   Initiate graphics screen         PO50   1
####################################################################### PO50   2
#                                                                     # PO50   3
#                          PO50                                       # PO50   4
#                                                                     # PO50   5
####################################################################### PO50   6
SUBROUTINE PO50#                                                        PO50   7
include:(AACOMN)#                                                       PO50   8
include:(POCOMN)#                                                       PO50   9
#                                                                       PO50  10
EXTERNAL POA0,POA1,POA3,POA4,POA5,POA7#                                 PO50  11
INTEGER LNBLNK#                        Function returning int           PO50  12
INTEGER I,FIRST,NC#                                                     PO50  13
INTEGER ISTYLE#                                                         PO50  14
INTEGER PT#                                                             PO50  15
REAL    X(2)#                                                           PO50  16
string:(TEXT,100)#                                                      PO50  17
realdata:(FMT,[170113.,190113.])#                                       PO50  18
datastuff:#                                                             PO50  19
#                                                                       PO50  20
#    INITIALISE BACKGROUND PIXMAPS TO AN ARBITRARY SIZE                 PO50  21
#    --------------------------------------------------                 PO50  22
#                                                                       PO50  23
CALL PO90#                             Set colormaps                    PO50  24
#                                                                       PO50  25
getwid:(mainwin:,    ".powgen")#                                        PO50  26
getwid:(legendwin:,  ".legendW")#                                       PO50  27
getwid:(quitwin:,    ".quit")#                                          PO50  28
attach:(0,legendc:,  ".powgen.legend")#                                 PO50  29
attach:(1,graphc:,   ".powgen.graph")#                                  PO50  30
attach:(1,abscissac:,".powgen.abscissa")#                               PO50  31
attach:(1,ordinatec:,".powgen.ordinate")#                               PO50  32
#                                                                       PO50  33
canvaspectl:(graphc:)#                 Link aspect variable to graph    PO50  34
canvaspectl:(abscissac:)#              Link aspect variable to abscis   PO50  35
canvaspectl:(ordinatec:)#              Link aspect variable to ordina   PO50  36
canvaspectl:(legendc:)#                Link aspect variable to legend   PO50  37
#                                                                       PO50  38
auxxscrollcmd:(graphc:,POA0)#          Recalculate the abscissa:        PO50  39
auxyscrollcmd:(graphc:,POA1)#          Recalculate the ordinate:        PO50  40
# AUXREFRESH:( GRAPHC:,POA2)#          NOT REQUIRED YET                 PO50  41
auxresize:(   legendc:,POA3)#          Reset the aspect ratio           PO50  42
auxrefresh:(  legendc:,POA4)#          No back buff so do own drawing   PO50  43
auxresize:(  abscissac:,POA5)#         Recalculate the abscissa:        PO50  44
#AUXREFRESH:( ABSCISSAC:,POA6)#         DOUBLE BUFFERED - NOT REQUIRED  PO50  45
auxresize:( ordinatec:,POA7)#          Recalculate the ordinate:        PO50  46
#AUXREFRESH:(ORDINATEC:,POA8)#         UNUSED - REFRESHED ON DEMAND     PO50  47
#AWAITVIEW:(LEGENDC:)#                                                  PO50  48
#                                                                       PO50  49
tcllinkd:(PRPAGE(prptype:)  ,"pageSettings(Atype)")#                    PO50  50
tcllinkd:(PRPAGE(prporient:),"pageSettings(Aorientation)")#             PO50  51
tcllinkd:(PRPAGE(prpscale:) ,"pageSettings(Ascale)")#                   PO50  52
tcllinkd:(PRPAGE(prxdim:)   ,"pageSettings(Awidth)")#                   PO50  53
tcllinkd:(PRPAGE(prydim:)   ,"pageSettings(Aheight)")#                  PO50  54
tcllinkd:(PRPAGE(prlmargin:),"pageSettings(Aleft)")#                    PO50  55
tcllinkd:(PRPAGE(prrmargin:),"pageSettings(Aright)")#                   PO50  56
tcllinkd:(PRPAGE(prtmargin:),"pageSettings(Atop)")#                     PO50  57
tcllinkd:(PRPAGE(prbmargin:),"pageSettings(Abottom)")#                  PO50  58
tcllinki:(ARANGE,"arrangeBlocks(AStyle)")#                              PO50  59
#                                                                       PO50  60
#TCLLINKD:(ZOOM(CURPLT,ZOOMX:),      "HORIZMAG")                        PO50  61
#TCLLINKD:(HSCROLL(CURPLT,SCCENTRE:),"HORIZCENT")                       PO50  62
#TCLLINKD:(ZOOM(CURPLT,ZOOMY:),      "VERTMAG")                         PO50  63
#TCLLINKD:(VSCROLL(CURPLT,SCCENTRE:),"VERTCENT")                        PO50  64
#                                                                       PO50  65
#     INITIATE SCROLL BAR WIDGETS AND VALUES                            PO50  66
#     --------------------------------------                            PO50  67
#                                                                       PO50  68
HSCROLL(CURPLT,scwidth:)=1.0#          Relative width                   PO50  69
HSCROLL(CURPLT,sccentre:)=0.5#         Centre graph in subwin           PO50  70
VSCROLL(CURPLT,scwidth:) =1.0#         Relative height                  PO50  71
VSCROLL(CURPLT,sccentre:)=0.5#         Centre graph in subwin           PO50  72
#                                                                       PO50  73
TEXT='set horizmag '#                                                   PO50  74
ncodefld:(ZOOM(CURPLT,zoomx:),1,TEXT,301032.,1)# Encode the number in   PO50  75
tcleval:(TEXT)#                                                         PO50  76
TEXT='set vertmag  '#                                                   PO50  77
ncodefld:(ZOOM(CURPLT,zoomy:),1,TEXT,301032.,1)# Encode the number in   PO50  78
tcleval:(TEXT)#                                                         PO50  79
scrollvarls:(graphc:,ZOOM(CURPLT,zoomx:),ZOOM(CURPLT,zoomy:),$#         PO50  80
HSCROLL(CURPLT,sccentre:),VSCROLL(CURPLT,sccentre:))# Widget dimens     PO50  81
#                                                                       PO50  82
#  PREPARE FOR THE TK LEGEND /TRACES WINDOW                             PO50  83
#  ----------------------------------------                             PO50  84
#                                                                       PO50  85
DO I=2,6+NPHASE#                       Cycle over all phases but twot   PO50  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO50  87
NC=LNBLNK(CRVLAB(I))#                                                   PO50  88
TEXT='lappend legendSettings(Traces) "'//CRVLAB(I)(1^NC)//'"'#          PO50  89
tcleval:(TEXT)#                                                         PO50  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO50  91
#                                                                       PO50  92
FIRST=0#                                                                PO50  93
DO I=1,6+NPHASE#                       Cycle over all phases but twot   PO50  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO50  95
IF(NINT(cvdisplay:(CURPLT,I))!=yes:)NEXT#                               PO50  96
FIRST=I#                                                                PO50  97
BREAK#                                                                  PO50  98
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO50  99
#                                                                       PO50 100
IF(FIRST>0)#                                                            PO50 101
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO50 102
TEXT='set legendSettings(Aactive)     '#                                PO50 103
ncodefld:(FLOAT(FIRST-2),1,TEXT,320213.,1)# Ratmac number - 2           PO50 104
tcleval:(TEXT)#                                                         PO50 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO50 106
#                                                                       PO50 107
#  SUPPLY TK PHASESHAPE FUNC WITH PRESET DEFAULT PHASE IDS              PO50 108
#  -------------------------------------------------------              PO50 109
#                                                                       PO50 110
DO I=7,6+NPHASE#                       Cycle over all phases but twot   PO50 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO50 112
NC=LNBLNK(CRVLAB(I))#                                                   PO50 113
TEXT='lappend peakShape(Phases) "'//CRVLAB(I)(1^NC)//'"'#               PO50 114
tcleval:(TEXT)#                                                         PO50 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO50 116
I=0#                                   First phase set in tk            PO50 117
setival:(I,          'peakShape(APhase)')#                              PO50 118
I=1#                                                                    PO50 119
ISTYLE=PRFNUM(I)-10#                                                    PO50 120
IF(ISTYLE<0)ISTYLE=ISTYLE+12#                                           PO50 121
setival:(ISTYLE,'peakShape(AStyle)')#  Style of first phase shape fun   PO50 122
setfval:(PARPRO(I,1),'peakShape(Ahwidth)')# Half width                  PO50 123
setfval:(PARPRO(I,2),'peakShape(Apsh2)')#                               PO50 124
setfval:(PARPRO(I,3),'peakShape(Apsh3)')#                               PO50 125
setfval:(PARPRO(I,4),'peakShape(Apsh4)')#                               PO50 126
setfval:(PARPRO(I,5),'peakShape(Apsh5)')#                               PO50 127
setfval:(PARPRO(I,6),'peakShape(Amixing)')# Mixing parameter            PO50 128
IF (PRFNUM(I)<10)#                                                      PO50 129
setival:(PSHFLN(I),'PeakShape(ABHnum)')# Nr of 5-value entries in tab   PO50 130
##J     =PSHFPT(pkprofnr:)#              Point to func array (markf)    PO50 131
##QRI   =PSHFST(pkprofnr:)#              1/stepsize in func table       PO50 132
#                                                                       PO50 133
#  SUPPLY TK WITH THE BACKGROUND PARAMS                                 PO50 134
#  ------------------------------------                                 PO50 135
#                                                                       PO50 136
setival:(IBAC,     'backGround(AStyle)')#                               PO50 137
setfval:(PARBAC(1),'backGround(Ap1)')#                                  PO50 138
setfval:(PARBAC(2),'backGround(Ap2)')#                                  PO50 139
setfval:(PARBAC(3),'backGround(Ap3)')#                                  PO50 140
setfval:(PARBAC(4),'backGround(Ap4)')#                                  PO50 141
setfval:(PARBAC(5),'backGround(Ap5)')#                                  PO50 142
#                                                                       PO50 143
#  SUPPLY TK WITH SCALE FACTOR INFO                                     PO50 144
#  --------------------------------                                     PO50 145
#                                                                       PO50 146
DO I=7,6+NPHASE#                       Cycle over all phases but twot   PO50 147
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO50 148
NC=LNBLNK(CRVLAB(I))#                                                   PO50 149
TEXT='lappend scaleFactor(Phases) "'//CRVLAB(I)(1^NC)//'"'#             PO50 150
tcleval:(TEXT)#                                                         PO50 151
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO50 152
I=0#                                   First phase set in tk            PO50 153
setival:(I,     'scaleFactor(APhase)')# Set label                       PO50 154
setfval:(SKF(1),'scaleFactor(AScale)')# Set scale                       PO50 155
#                                                                       PO50 156
#  SUPPLY TK WITH TEMP SCALE INFO                                       PO50 157
#  ------------------------------                                       PO50 158
#                                                                       PO50 159
DO I=7,6+NPHASE#                       Cycle over all phases but twot   PO50 160
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO50 161
NC=LNBLNK(CRVLAB(I))#                                                   PO50 162
TEXT='lappend overallDisp(Phases) "'//CRVLAB(I)(1^NC)//'"'#             PO50 163
tcleval:(TEXT)#                                                         PO50 164
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO50 165
I=0#                                   First phase set in tk            PO50 166
setival:(I,     'overallDisp(APhase)')# Set label                       PO50 167
setfval:(ADISP(1),'overallDisp(AScale)')# Set scale                     PO50 168
#                                                                       PO50 169
#  SUPPLY TK WITH Zero offset info
#  ------------------------------                                       PO50 171
#                                                                       PO50 172
setfval:(PARZER(1),'zeroOffset(Ap1)')
setfval:(PARZER(2),'zeroOffset(Ap2)')
I=1#                                   assume valid zero offsets
ifeq:(PARZER(1),0.0)
ifeq:(PARZER(2),0.0,1.E-7)I=0#         no zero offsets
setival:(I,'zeroOffset(AStyle)')
#
#  SUPPLY TK WITH INVOKED BLOCKS                                        PO50 170
#  ------------------------------                                       PO50 171
#                                                                       PO50 172
TEXT='arrangeBlocks("Ax,y")'#                                           PO50 173
DO PT=1,maxgn:#                        Cycle over graph plots           PO50 174
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO50 175
IF(NINT(gptinvoked:)==no:)NEXT#        This graph is not invoked        PO50 176
X(1)=gptxindex: ; X(2)=gptyindex:#                                      PO50 177
ncodefld:(X,1,TEXT,FMT,2)#                                              PO50 178
setival:(PT,TEXT)#                                                      PO50 179
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO50 180
#                                                                       PO50 181
RETURN#                                                                 PO50 182
END#                                                                    PO50 183
systemheader:(PO55)#                   Hkl markers                      PO55   1
####################################################################### PO55   2
#                                                                     # PO55   3
#                          PO55                                       # PO55   4
#                                                                     # PO55   5
####################################################################### PO55   6
SUBROUTINE PO55#                                                        PO55   7
include:(AACOMN)#                                                       PO55   8
include:(POCOMN)#                                                       PO55   9
#                                                                       PO55  10
INTEGER FIRST,LAST#                                                     PO55  11
INTEGER PT,PH#                                                          PO55  12
INTEGER IAP, HBON,MRANGE,LRANGE,HBLAB#                                  PO55  13
REAL    HBYMIN,HBYOFF,HBXOFF,HBSIZE#                                    PO55  14
REAL    HBLSZ,HBLAG,HBLMIN,HBLXOF,HBLYOF#                               PO55  15
#                                                                       PO55  16
# MADE A CONSCIOUS DECISION HERE TO RENDER ALL PHASES                   PO55  17
# WITH SAME CRITERIA - COULD BE CHANGED IN THE FUTURE...?               PO55  18
#                                                                       PO55  19
FIRST=1;LAST=maxgn:#                   Assume applying to all           PO55  20
getival:(IAP,'applyTo(AGraph)')#                                        PO55  21
IF(IAP==0) $(FIRST=CURPLT;LAST=FIRST$)# Only apply to current           PO55  22
#                                                                       PO55  23
getival:(HBON,  'hklbSettings(Amarkers)')#                              PO55  24
getival:(MRANGE,'hklbSettings(AmRange)')#                               PO55  25
getival:(LRANGE,'hklbSettings(AlRange)')#                               PO55  26
getfval:(HBSIZE,'hklbSettings(AmSize)')#                                PO55  27
getfval:(HBYMIN,'hklbSettings(AmImin)')#                                PO55  28
getfval:(HBYOFF,'hklbSettings(Amyoff)')#                                PO55  29
getfval:(HBXOFF,'hklbSettings(Amxoff)')#                                PO55  30
getival:(HBLAB, 'hklbSettings(Alabels)')#                               PO55  31
getfval:(HBLSZ, 'hklbSettings(AlSize)')#                                PO55  32
getfval:(HBLMIN,'hklbSettings(AlImin)')#                                PO55  33
getfval:(HBLAG, 'hklbSettings(AlAngle)')#                               PO55  34
getfval:(HBLXOF,'hklbSettings(Alxoff)')#                                PO55  35
getfval:(HBLYOF,'hklbSettings(Alyoff)')#                                PO55  36
#                                                                       PO55  37
DO PT=FIRST,LAST#                      Cycle over graph plots           PO55  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO55  39
DO PH=1,NPHASE#                        Cycle over graph phases          PO55  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO55  41
hbdisplay:(PT,PH) =float:(HBON)#                                        PO55  42
hbshift:(PT,PH)   =float:(yes:)#       Displace curve (yes/no)          PO55  43
hbymin:(PT,PH)    =db:(HBYMIN)#        Min y val of reflection          PO55  44
hbsize:(PT,PH)    =db:(HBSIZE)#        Size of bars to show             PO55  45
hbshift:(PT,PH)   =float:(yes:)#       Displace curve (yes/no)          PO55  46
hbxoffset:(PT,PH) =db:(HBXOFF)#        X=0 offset of hkl bars           PO55  47
hbyoffset:(PT,PH) =db:(HBYOFF)#        Y offset of hkl bars             PO55  48
hblabel:(PT,PH)   =float:(HBLAB)#      Label hklbars (yes/no)           PO55  49
IF (LRANGE==0)#                        Label all                        PO55  50
hblabymin:(PT,PH) =db:(-9.D+9)#        Min y val to label               PO55  51
ELSE hblabymin:(PT,PH)= db:(HBLMIN)#   Min y val to label               PO55  52
hbfontsize:(PT,PH)=db:(HBLSZ)#         Small hkl label fontsize         PO55  53
hbangle:(PT,PH)   =db:(HBLAG)#         Angle of labels to horiz         PO55  54
hblabshx:(PT,PH)  =db:(HBLXOF)#        X displa of hkl lab              PO55  55
hblabshy:(PT,PH)  =db:(HBLYOF)#                                         PO55  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO55  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO55  58
#                                                                       PO55  59
IF    (VUTYPE==0) CALL PO35#           Redraw single plot               PO55  60
ELSEIF(VUTYPE!=0) CALL PO36(1)#        Redraw the page                  PO55  61
#                                                                       PO55  62
RETURN#                                                                 PO55  63
END#                                                                    PO55  64
systemheader:(PO56)#                   Update the legend menu           PO56   1
####################################################################### PO56   2
#                                                                     # PO56   3
#                          PO56                                       # PO56   4
#                                                                     # PO56   5
####################################################################### PO56   6
SUBROUTINE PO56#                       Update the tk elements for tra   PO56   7
include:(POCOMN)#                                                       PO56   8
#                                                                       PO56   9
INTEGER I#                                                              PO56  10
string:(TEXT,100)#                                                      PO56  11
#                                                                       PO56  12
#  IF THE MENU IS REFRESHED THEN THE TK VARS HAVE TO BE UPDATED         PO56  13
#                                                                       PO56  14
I=-10#                                 Dummy value                      PO56  15
getival:(I,'legendSettings(Aactive)')#                                  PO56  16
I=I+2#                                                                  PO56  17
IF(I>0 & I<=6+NPHASE)#                                                  PO56  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO56  19
setival:(NINT(cvdisplay:(CURPLT,I)),'legendSettings(AtInvoke)')#        PO56  20
setival:(NINT(cvlncolor:(CURPLT,I)),'legendSettings(Acolor)')#          PO56  21
setival:(NINT(cvdispln:(CURPLT,I)),'legendSettings(AlStyle)')#          PO56  22
setival:(NINT(cvdispmk:(CURPLT,I)),'legendSettings(AlMark)')#           PO56  23
setfval:((cvlinewd:(CURPLT,I)),'legendSettings(AlThick)')#              PO56  24
setfval:((cvshx:(CURPLT,I)),'legendSettings(AxOffset)')#                PO56  25
setfval:((cvshy:(CURPLT,I)),'legendSettings(AyOffset)')#                PO56  26
#                                                                       PO56  27
#MACRO:(CVMKCOLOR:, [CURVE(CURVE:($1,$2), 5)])# COLOR OF MARKER         PO56  28
#MACRO:(CVLINEST:,  [CURVE(CURVE:($1,$2),17)])# GRID HAS THIS LINE STYL PO56  29
#MACRO:(CVLINEDL:,  [CURVE(CURVE:($1,$2),18)])# DASH LENGTH             PO56  30
#MACRO:(CVLINEBL:,  [CURVE(CURVE:($1,$2),19)])# BREAK LENGTH            PO56  31
#                                                                       PO56  32
# UPDATE THE DISPLAY VARS                                               PO56  33
TEXT='LegendConfig .legendW fortran'#                                   PO56  34
tcleval:(TEXT)#                                                         PO56  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO56  36
RETURN#                                                                 PO56  37
END#                                                                    PO56  38
systemheader:(PO57)#                   If legend trace selected has c   PO57   1
####################################################################### PO57   2
#                                                                     # PO57   3
#                          PO57                                       # PO57   4
#                                                                     # PO57   5
####################################################################### PO57   6
SUBROUTINE PO57#                       Update the tk elements for tra   PO57   7
#INCLUDE:(AACOMN)#                                                      PO57   8
include:(POCOMN)#                                                       PO57   9
#                                                                       PO57  10
INTEGER NC#                                                             PO57  11
INTEGER I,INV,ICO,ILS,IMS#                                              PO57  12
INTEGER IAP,PT,PH#                                                      PO57  13
INTEGER FIRST,LAST#                                                     PO57  14
REAL THIK,XOFF,YOFF#                                                    PO57  15
#                                                                       PO57  16
#  IF THE LEGENDMENU IS MODIFIED THEN THE FORTRAN VARS HAVE TO BE UPDAT PO57  17
#                                                                       PO57  18
getival:(I,'legendSettings(Aactive)')#                                  PO57  19
I=I+2#                                                                  PO57  20
IF(I<0 \I>6+NPHASE) RETURN#            Nothing sensible edited          PO57  21
#                                                                       PO57  22
getival:(INV,'legendSettings(AtInvoke)')#                               PO57  23
getival:(ICO,'legendSettings(Acolor)')#                                 PO57  24
getival:(ILS,'legendSettings(AlStyle)')#                                PO57  25
getival:(IMS,'legendSettings(AlMark)')#                                 PO57  26
getfval:(THIK,'legendSettings(AlThick)')#                               PO57  27
getfval:(XOFF,'legendSettings(AxOffset)')#                              PO57  28
getfval:(YOFF,'legendSettings(AyOffset)')#                              PO57  29
CRVLAB(I)=' '#                         Erase previous label             PO57  30
tclgetsval:('legendSettings(Tphase)',CRVLAB(I),NC)#                     PO57  31
#                                                                       PO57  32
FIRST=1;LAST=maxgn:#                   Assume applying to all           PO57  33
getival:(IAP,'applyTo(AGraph)')#                                        PO57  34
IF(IAP==0) $(FIRST=CURPLT;LAST=FIRST$)# Only apply to current           PO57  35
#                                                                       PO57  36
#write(6,*) "LEGEND ",FIRST,LAST,NPHASE,I
DO PT=FIRST,LAST#                      Cycle over graph plots           PO57  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO57  38
DO PH=1,NPHASE#                        Cycle over graph phases          PO57  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO57  40
cvdisplay:(PT,I)= FLOAT(INV)#                                           PO57  41
cvlncolor:(PT,I)= FLOAT(ICO)#                                           PO57  42
cvdispln:(PT,I) = FLOAT(ILS)#                                           PO57  43
cvdispmk:(PT,I) = FLOAT(IMS)#                                           PO57  44
cvlinewd:(PT,I) = (THIK)#                                               PO57  45
ifne:(cvshx:(PT,I),XOFF)cvshift:(PT,I)=float(yes:)
ifne:(cvshy:(PT,I),YOFF)cvshift:(PT,I)=float(yes:)
cvshx:(PT,I)    = (XOFF)#                                               PO57  46
cvshy:(PT,I)    = (YOFF)#                                               PO57  47
#                                                                       PO57  48
#CVMKCOLOR:, [CURVE(CURVE:($1,$2), 5)])# COLOR OF MARKER                PO57  49
#CVLINEST:,  [CURVE(CURVE:($1,$2),17)])# GRID HAS THIS LINE STYLE       PO57  50
#CVLINEDL:,  [CURVE(CURVE:($1,$2),18)])# DASH LENGTH                    PO57  51
#CVLINEBL:,  [CURVE(CURVE:($1,$2),19)])# BREAK LENGTH                   PO57  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO57  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO57  54
#                                                                       PO57  55
CALL PO35#                             Update the display also          PO57  56
#                                                                       PO57  57
#                                                                       PO57  58
RETURN#                                                                 PO57  59
END#                                                                    PO57  60
systemheader:(PO58)#                   Plot range has changed           PO58   1
####################################################################### PO58   2
#                                                                     # PO58   3
#                          PO58                                       # PO58   4
#                                                                     # PO58   5
####################################################################### PO58   6
SUBROUTINE PO58#                       Update the tk elements for tra   PO58   7
include:(POCOMN)#                                                       PO58   8
#                                                                       PO58   9
INTEGER PT#                                                             PO58  10
INTEGER FIRST,LAST,IAP#                                                 PO58  11
REAL XMIN,XMAX,YLMIN,YLMAX#                                             PO58  12
REAL TMP#                                                               PO58  13
#                                                                       PO58  14
#                                                                       PO58  15
getfval:(XMIN,'plotRange(Axmin)')#                                      PO58  16
getfval:(XMAX,'plotRange(Axmax)')#                                      PO58  17
getfval:(YLMIN,'plotRange(Aymin)')#                                     PO58  18
getfval:(YLMAX,'plotRange(Aymax)')#                                     PO58  19
IF(XMIN>=XMAX)$(TMP=XMIN;XMIN=XMAX;XMAX=TMP$)#                          PO58  20
IF(XMIN<0.)  XMIN=0.#                                                   PO58  21
IF(XMIN>180.)XMIN=0.#                                                   PO58  22
IF(XMAX<0.)  XMAX=90.#                                                  PO58  23
IF(XMAX>180.)XMAX=180.#                                                 PO58  24
IF(YLMIN>=YLMAX)$(TMP=YLMIN;YLMIN=YLMAX;YLMAX=TMP$)#                    PO58  25
#                                                                       PO58  26
#                                                                       PO58  27
FIRST=1;LAST=maxgn:#                   Assume applying to all           PO58  28
getival:(IAP,'applyTo(AGraph)')#                                        PO58  29
IF(IAP==0) $(FIRST=CURPLT;LAST=FIRST$)# Only apply to current           PO58  30
#                                                                       PO58  31
DO PT=FIRST,LAST#                      Cycle over graph plots           PO58  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO58  33
axmin:(1) =db:(XMIN)#                                                   PO58  34
axmax:(1) =db:(XMAX)#                                                   PO58  35
axmin:(2) =db:(YLMIN)#                                                  PO58  36
axmax:(2) =db:(YLMAX)#                                                  PO58  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO58  38
#                                                                       PO58  39
IF (IAP==0)  CALL PO33(CURPLT)#        Validate all graph axes          PO58  40
ELSE         CALL PO33(0)#             Validate axes for current        PO58  41
CALL PO35#                             Update the display also          PO58  42
#                                                                       PO58  43
#                                                                       PO58  44
RETURN#                                                                 PO58  45
END#                                                                    PO58  46
systemheader:(PO59)#                   Change the background            PO59   1
####################################################################### PO59   2
#                                                                     # PO59   3
#                          PO59                                       # PO59   4
#                                                                     # PO59   5
####################################################################### PO59   6
SUBROUTINE PO59#                       Update the tk elements for tra   PO59   7
include:(POCOMN)#                                                       PO59   8
#                                                                       PO59   9
#  RETRIEVE THE BACKGROUND PARAMS FROM TK                               PO59  10
#  --------------------------------------                               PO59  11
#                                                                       PO59  12
getival:(IBAC,     'backGround(AStyle)')#                               PO59  13
getfval:(PARBAC(1),'backGround(Ap1)')#                                  PO59  14
getfval:(PARBAC(2),'backGround(Ap2)')#                                  PO59  15
getfval:(PARBAC(3),'backGround(Ap3)')#                                  PO59  16
getfval:(PARBAC(4),'backGround(Ap4)')#                                  PO59  17
getfval:(PARBAC(5),'backGround(Ap5)')#                                  PO59  18
#                                                                       PO59  19
DO NPH=1,NPHASE#                       For each separate phase          PO59  20
CALL PO22#                             Calculate separate patterns      PO59  21
CALL PO30#                             Sum ical = tot pattern           PO59  22
#                                                                       PO59  23
CALL PO35#                             Replot the current graph         PO59  24
#                                                                       PO59  25
RETURN#                                                                 PO59  26
END#                                                                    PO59  27
systemheader:(PO60)#                   Update shape params and recalc   PO60   1
####################################################################### PO60   2
#                                                                     # PO60   3
#                          PO60                                       # PO60   4
#                                                                     # PO60   5
####################################################################### PO60   6
SUBROUTINE PO60#                       Update the tk elements for tra   PO60   7
include:(AACOMN)#                                                       PO60   8
include:(POCOMN)#                                                       PO60   9
INTEGER I#                                                              PO60  10
REAL P1,P2,P3,P4,P5,P6#                                                 PO60  11
REAL TTR,TH,TANTH#                                                      PO60  12
INTEGER PSTYL#                                                          PO60  13
INTEGER FIRST,LAST,IAP#                                                 PO60  14
INTEGER FREFL,LREFL#                                                    PO60  15
#                                                                       PO60  16
#  RETRIEVE THE PEAK SHAPE PARAMS FROM TK                               PO60  17
#  --------------------------------------                               PO60  18
#                                                                       PO60  19
getival:(I,'peakShape(APhase)')#                                        PO60  20
IF(I<0\I>=NPHASE)RETURN#                                                PO60  21
I=I+1#                                                                  PO60  22
FIRST=1;LAST=NPHASE#                   Assume applying to all           PO64  21
getival:(IAP,'applyToPhase(CPhase)')#                                   PO60  24
IF(IAP==0) $(FIRST=I;LAST=FIRST$)#     Only apply to current            PO60  25
#                                                                       PO60  26
#  CHECK FOR "APPLY TO ALL PHASES"                                      PO60  27
#                                                                       PO60  28
#                                                                       PO60  29
getival:(PSTYL,'peakShape(AStyle)')#                                    PO60  30
IF(PSTYL>2)PSTYL=PSTYL-12#                                              PO60  31
PSTYL=PSTYL+10#                                                         PO60  32
getfval:(P1,'peakShape(Ahwidth)')#                                      PO60  33
getfval:(P2,'peakShape(Apsh2)')#                                        PO60  34
getfval:(P3,'peakShape(Apsh3)')#                                        PO60  35
getfval:(P4,'peakShape(Apsh4)')#                                        PO60  36
getfval:(P5,'peakShape(Apsh5)')#                                        PO60  37
getfval:(P6,'peakShape(Amixing)')#                                      PO60  38
#IF (PRFNUM(I)<10)                                                      PO60  39
#GETIVAL:(PSHFLN(I,1),'PEAKSHAPE(ABHNUM)')# NR OF 5-VALUE ENTRIES IN TA PO60  40
#                                                                       PO60  41
#                                                                       PO60  42
DO NPH=FIRST,LAST#                     Cycle over graph plots           PO60  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO60  44
PRFNUM(NPH)  =PSTYL#                                                    PO60  45
PARPRO(NPH,1)=P1#                                                       PO60  46
PARPRO(NPH,2)=P2#                                                       PO60  47
PARPRO(NPH,3)=P3#                                                       PO60  48
PARPRO(NPH,4)=P4#                                                       PO60  49
PARPRO(NPH,5)=P5#                                                       PO60  50
PARPRO(NPH,6)=P6#                                                       PO60  51
# LOOP OVER ALL REFLECTIONS FOR PHASE                                   PO60  52
# AND RECALCULATE PROFILE FUNCTIONS                                     PO60  53
FREFL=FIRREF(NPH)#                     First reflection                 PO60  54
LREFL=FIRREF(NPH+1)-1#                 Last reflection                  PO60  55
#                                                                       PO60  56
DO IREFL=FREFL,LREFL#                  Loop current active hkl number   PO60  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO60  58
readdac:(ioda2:,,IREFL,(BUF(I),I=1,HKLPAK))# Read refln file            PO60  59
TTR=BUF(5)/57.29578#                   Two theta in radians             PO60  60
TH=TTR/2.#                             Theta in radians                 PO60  61
TANTH=TAN(TH)#                         Theta had better be <pi/2!       PO60  62
BUF(7)=.5*SQRT(PARPRO(NPH,1)$#                                          PO60  63
+       PARPRO(NPH,2)*TANTH+PARPRO(NPH,3)*TANTH**2)# Hwidth             PO60  64
HWDMAX=MAX(HWDMAX,BUF(7))#             Save max hwidth                  PO60  65
#                                                                       PO60  66
BUF(8)=PARPRO(NPH,4)+PARPRO(NPH,5)*TT# Peak asymmetry                   PO60  67
writedac:(ioda2:,,IREFL,(BUF(I),I=1,HKLPAK))# Read refln file           PO60  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO60  69
CALL PO22#                             Calculate separate patterns      PO60  70
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO60  71
#                                                                       PO60  72
CALL PO30#                             Sum ical = tot pattern           PO60  73
CALL PO35#                             Replot the current graph         PO60  74
#                                                                       PO60  75
RETURN#                                                                 PO60  76
END#                                                                    PO60  77
systemheader:(PO61)#                   Swapping phases for shape func   PO61   1
####################################################################### PO61   2
#                                                                     # PO61   3
#                          PO61                                       # PO61   4
#                                                                     # PO61   5
####################################################################### PO61   6
SUBROUTINE PO61#                       Update the tk elements for pha   PO61   7
include:(POCOMN)#                                                       PO61   8
INTEGER I#                                                              PO61   9
INTEGER ISTYLE
string:(TEXT,100)#                                                      PO61  10
#                                                                       PO61  11
I=0#                                   First phase set in tk            PO61  12
getival:(I,'peakShape(APhase)')#       Tcl/tk phase pointer             PO61  13
I=I+1#                                 Fortran phas pointer             PO61  14
IF(I<1 \ I>NPHASE) RETURN#             Avoid potential junk             PO61  15
ISTYLE=PRFNUM(I)-10#                                                    PO50 120
IF(ISTYLE<0)ISTYLE=ISTYLE+12#                                           PO50 121
setival:(ISTYLE,     'peakShape(AStyle)')# Style of phase shape func
setfval:(PARPRO(I,1),'peakShape(Ahwidth)')# Half width                  PO61  17
setfval:(PARPRO(I,2),'peakShape(Apsh2)')#                               PO61  18
setfval:(PARPRO(I,3),'peakShape(Apsh3)')#                               PO61  19
setfval:(PARPRO(I,4),'peakShape(Apsh4)')#                               PO61  20
setfval:(PARPRO(I,5),'peakShape(Apsh5)')#                               PO61  21
setfval:(PARPRO(I,6),'peakShape(Amixing)')# Mixing parameter            PO61  22
#IF (PRFNUM(1,1)<10)#                                                   PO61  23
#SETIVAL:(PSHFLN(1,1),'PEAKSHAPE(ABHNUM)')# NR OF 5-VALUE ENTRIES IN TA PO61  24
#                                                                       PO61  25
TEXT='PeakShapeConfig .pshape init'#   Initialize dsplay vars           PO61  26
tcleval:(TEXT)#                                                         PO61  27
TEXT='PeakShapeConfig .pshape style'#  Readjust conditional settings    PO61  28
tcleval:(TEXT)#                                                         PO61  29
#                                                                       PO61  30
RETURN#                                                                 PO61  31
END#                                                                    PO61  32
systemheader:(PO62)#                   Update scale param and recalc    PO62   1
####################################################################### PO62   2
#                                                                     # PO62   3
#                          PO62                                       # PO62   4
#                                                                     # PO62   5
####################################################################### PO62   6
SUBROUTINE PO62#                       Update the tk elements for tra   PO62   7
include:(AACOMN)#                                                       PO62   8
include:(POCOMN)#                                                       PO62   9
#                                                                       PO62  10
INTEGER I#                                                              PO62  11
INTEGER FIRST,LAST,IAP#                                                 PO62  12
REAL SCALE,OSKAL#                                                       PO62  13
#                                                                       PO62  14
#  RETRIEVE THE SCALE PARAM FROM TK                                     PO62  15
#  --------------------------------                                     PO62  16
#                                                                       PO62  17
getival:(I,'scaleFactor(APhase)')#                                      PO62  18
I=I+1#                                                                  PO62  19
IF(I<1\I>NPHASE)RETURN#                                                 PO62  20
FIRST=1;LAST=NPHASE#                   Assume applying to all           PO62  21
#FIRST=1;LAST=maxgn:#                  Assume applying to all           PO62  21
getival:(IAP,'applyToPhase(APhase)')#                                   PO62  22
IF (IAP==0) $(FIRST=I;LAST=FIRST$)#    Only apply to current            PO62  23
getfval:(SCALE,'scaleFactor(AScale)')# Style of first phase shape fun   PO62  24
DO NPH=FIRST,LAST#                     Cycle over graph plots           PO62  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO62  26
CALL PO31(NPH,SCALE)#                  Rescale only current             PO62  27
CALL PO22#                             Calculate separate patterns      PO62  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO62  29
CALL PO30#                             Sum ical = tot pattern           PO62  30
CALL PO35#                             Replot the current graph         PO62  31
#                                                                       PO62  32
RETURN#                                                                 PO62  33
END#                                                                    PO62  34
systemheader:(PO63)#                   Swapping phases for scale func   PO63   1
####################################################################### PO63   2
#                                                                     # PO63   3
#                          PO63                                       # PO63   4
#                                                                     # PO63   5
####################################################################### PO63   6
SUBROUTINE PO63#                       Update the tk elements for pha   PO63   7
include:(POCOMN)#                                                       PO63   8
INTEGER I#                                                              PO63   9
string:(TEXT,100)#                                                      PO63  10
#                                                                       PO63  11
I=0#                                   First phase set in tk            PO63  12
getival:(I,'scaleFactor(APhase)')#     Tcl/tk phase pointer             PO63  13
I=I+1#                                 Fortran phas pointer             PO63  14
IF(I<1 \ I>NPHASE) RETURN#             Avoid potential junk             PO63  15
NPH=I#                                                                  PO63  16
setfval:(scal:,  'scaleFactor(AScale)')# Style of first phase shape f   PO63  17
#                                                                       PO63  18
TEXT='ScaleFactorConfig .scales init'# Initialize display vars          PO63  19
tcleval:(TEXT)#                                                         PO63  20
#                                                                       PO63  21
RETURN#                                                                 PO63  22
END#                                                                    PO63  23
systemheader:(PO64)#                   Update scale param and recalc    PO64   1
####################################################################### PO64   2
#                                                                     # PO64   3
#                          PO64                                       # PO64   4
#                                                                     # PO64   5
####################################################################### PO64   6
SUBROUTINE PO64#                       Update the tk elements for tra   PO64   7
include:(AACOMN)#                                                       PO64   8
include:(POCOMN)#                                                       PO64   9
#                                                                       PO64  10
INTEGER I#                                                              PO64  11
INTEGER FIRST,LAST,IAP#                                                 PO64  12
REAL SCALE,OSKAL#                                                       PO64  13
#                                                                       PO64  14
#  RETRIEVE THE SCALE PARAM FROM TK                                     PO64  15
#  --------------------------------                                     PO64  16
#                                                                       PO64  17
getival:(I,'overallDisp(APhase)')#                                      PO64  18
I=I+1#                                                                  PO64  19
IF(I<1\I>NPHASE)RETURN#                                                 PO64  20
FIRST=1;LAST=NPHASE#                   Assume applying to all           PO64  21
getival:(IAP,'applyToPhase(APhase)')#                                   PO64  22
IF (IAP==0) $(FIRST=I;LAST=FIRST$)#    Only apply to current            PO64  23
getfval:(SCALE,'overallDisp(AScale)')# Style of first phase shape fun   PO64  24
DO NPH=FIRST,LAST#                     Cycle over graph plots           PO64  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO64  26
CALL PO28(NPH,SCALE)#                  Rescale temp factors for curre   PO64  27
CALL PO22#                             Calculate separate patterns      PO64  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO64  29
CALL PO30#                             Sum ical = tot pattern           PO64  30
CALL PO35#                             Replot the current graph         PO64  31
#                                                                       PO64  32
RETURN#                                                                 PO64  33
END#                                                                    PO64  34
systemheader:(PO65)#                   Swapping phases for scale func   PO65   1
####################################################################### PO65   2
#                                                                     # PO65   3
#                          PO65                                       # PO65   4
#                                                                     # PO65   5
####################################################################### PO65   6
SUBROUTINE PO65#                       Update the tk elements for pha   PO65   7
include:(POCOMN)#                                                       PO65   8
INTEGER I#                                                              PO65   9
string:(TEXT,100)#                                                      PO65  10
#                                                                       PO65  11
I=0#                                   First phase set in tk            PO65  12
getival:(I,'overallDisp(APhase)')#     Tcl/tk phase pointer             PO65  13
I=I+1#                                 Fortran phas pointer             PO65  14
IF(I<1 \ I>NPHASE) RETURN#             Avoid potential junk             PO65  15
NPH=I#                                                                  PO65  16
setfval:(ADISP(NPH),  'overallDisp(AScale)')# Style of first phase sh   PO65  17
TEXT='OverallDispConfig .ovdisp init'# Initialize display vars          PO65  18
tcleval:(TEXT)#                                                         PO65  19
#                                                                       PO65  20
RETURN#                                                                 PO65  21
END#                                                                    PO65  22
systemheader:(PO66)#                   Swapping phases for scale func   PO65   1
####################################################################### PO65   2
#                                                                     # PO65   3
#                          PO66                                       # PO65   4
#                                                                     # PO65   5
####################################################################### PO65   6
SUBROUTINE PO66#                       Update the tk elements for pha   PO65   7
include:(POCOMN)#                                                       PO65   8
INTEGER IMODE
#
getival:(IMODE,'zeroOffset(AStyle)')
IF(IMODE==0)
$(
PARZER(1)=0.;PARZER(2)=0.#     ignore tcl values
$)
ELSE
$(
getfval:(PARZER(1),'zeroOffset(Ap1)')
getfval:(PARZER(2),'zeroOffset(Ap2)')
$)
DO NPH=1,NPHASE; CALL PO22#            Calculate separate patterns      PO62  28
CALL PO30#                             Sum ical = tot pattern           PO64  30
CALL PO35#                             Replot the current graph         PO64  31
#
RETURN#                                                                 PO65  21
END#                                                                    PO65  22
systemheader:(PO68)#                   String updates                   PO68   1
####################################################################### PO68   2
#                                                                     # PO68   3
#                          PO68                                       # PO68   4
#                                                                     # PO68   5
####################################################################### PO68   6
SUBROUTINE PO68#                                                        PO68   7
#INCLUDE:(AACOMN)#                                                      PO68   8
include:(POCOMN)#                                                       PO68   9
INTEGER NC#                                                             PO68  10
#                                                                       PO68  11
tclgetsval:("GraphTitle",TITLET(CURPLT),NC)#                            PO68  12
tichars:(CURPLT)=float:(NC)#                                            PO68  13
#                                                                       PO68  14
CALL PO35#                             Redisplay current                PO68  15
#                                                                       PO68  16
RETURN#                                                                 PO68  17
END#                                                                    PO68  18
systemheader:(PO69)#                   Setup page size orientation      PO69   1
####################################################################### PO69   2
#                                                                     # PO69   3
#                          PO69                                       # PO69   4
#                                                                     # PO69   5
####################################################################### PO69   6
SUBROUTINE PO69#                       And margins                      PO69   7
#INCLUDE:(AACOMN)#                                                      PO69   8
include:(POCOMN)#                                                       PO69   9
#                                                                       PO69  10
IF(VUTYPE==1) CALL PO36(1)#            Refresh screen image             PO69  11
#                                                                       PO69  12
RETURN#                                                                 PO69  13
END#                                                                    PO69  14
systemheader:(PO70)#                   Add new graph to output page     PO70   1
####################################################################### PO70   2
#                                                                     # PO70   3
#                          PO70                                       # PO70   4
#                                                                     # PO70   5
####################################################################### PO70   6
SUBROUTINE PO70#                                                        PO70   7
include:(AACOMN)#                                                       PO70   8
include:(POCOMN)#                                                       PO70   9
#                                                                       PO70  10
INTEGER NUM,STATE,TMPSTA,TMPNUM,NEW#                                    PO70  11
INTEGER XI,YI#                                                          PO70  12
INTEGER SEQNUM,TYPE#                                                    PO70  13
INTEGER II(maxgn:)#                                                     PO70  14
INTEGER JJ(maxgn:)#                                                     PO70  15
INTEGER I,J,K,L#                                                        PO70  16
INTEGER COPY(maxgn:)#                                                   PO70  17
REAL    X(2)#                                                           PO70  18
string:(TEXT,50)#                                                       PO70  19
string:(TEXT2,50)#                                                      PO70  20
realdata:(FMT,[170113.,190113.])#                                       PO70  21
datastuff:#                                                             PO70  22
#                                                                       PO70  23
TEXT ='arrangeBlocks("Ax,y")'#         Actual entry                     PO70  24
DO I=1,maxgn:#                         Erase all details                PO70  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO70  26
II(I)=0;JJ(I)=0;COPY(I)=0#                                              PO70  27
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO70  28
#                                                                       PO70  29
DO I=1,miv:#                           Cycle over grindx rows           PO70  30
DO J=1,miv:#                           Cycle over grindx columns        PO70  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO70  32
X(1)=FLOAT(I);X(2)=FLOAT(J)#                                            PO70  33
ncodefld:(X,1,TEXT,FMT,2)#                                              PO70  34
getival:(K,TEXT)#                      Get the invoked block            PO70  35
IF(K==0) NEXT#                                                          PO70  36
IF(K<1\K>maxgn:)#                      Out of permitted range           PO70  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO70  38
L=0#                                                                    PO70  39
setival:(L,TEXT)#                      Erase again                      PO70  40
NEXT#                                                                   PO70  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO70  42
IF (II(K)==0 & JJ(K)==0)#              No doubling up yet!              PO70  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO70  44
II(K)=I;#                                                               PO70  45
JJ(K)=J;#                                                               PO70  46
IF(K<10)TEXT2='arrangeBlocks("Fx")'#   Coppied from                     PO70  47
ELSE    TEXT2='arrangeBlocks("Fxx")'#  Coppied from                     PO70  48
IF(K<10)ncodefld:(FLOAT(K),1,TEXT2,170113.,1)#                          PO70  49
ELSE    ncodefld:(FLOAT(K),1,TEXT2,180223.,1)#                          PO70  50
getival:(L,TEXT2)#                     Get the source block for copyi   PO70  51
COPY(K)=L#                             Save the source                  PO70  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO70  53
ELSE#                                  Block k invoked more than once   PO70  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PO70  55
##  Just use the first or Revert to original???                         PO70  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PO70  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO70  58
#                                                                       PO70  59
#  ADD OR DELETE THE GRAPH BLOCKS                                       PO70  60
#  ------------------------------                                       PO70  61
#                                                                       PO70  62
DO I=1,maxgn:#                         Erase all details                PO70  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PO70  64
IF(II(I)==0)#                          Not invoked so switch off        PO70  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PO70  66
gptinvoked:(I)=FLOAT(no:)#             Switch off                       PO70  67
IF(I==CURPLT) CURPLT=0#                No longer current                PO70  68
NEXT#                                                                   PO70  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PO70  70
gptinvoked:(I)=FLOAT(yes:)#                                             PO70  71
gptxindex:(I) =FLOAT(II(I))#           X index of relative graph        PO70  72
gptyindex:(I) =FLOAT(JJ(I))#           Y index of relative graph        PO70  73
IF(I==COPY(I))NEXT#                    Don't copy self                  PO70  74
IF(COPY(I)<1\COPY(I)>maxgn:)NEXT#      Copy all attributes from         PO70  75
DO J=3,30;          GRAPH(I,J)  =GRAPH(COPY(I),J)# Graph blk info       PO70  76
DO J=1,20;          GRID(I,J)   =GRID(COPY(I),J)# Grid info             PO70  77
DO J=1,2;DO K=1,50; AXES(I,J,K) =AXES(COPY(I),J,K)# Axes info           PO70  78
DO J=1,20;           LEGEND(I,J)=LEGEND(COPY(I),J)# Legend info         PO70  79
DO J=1,20;           GTITLE(I,J)=GTITLE(COPY(I),J)# Title info          PO70  80
DO J=1,arith:(maxpha:,+,6)#                                             PO70  81
DO K=1,40;               CURVE(I,J,K) =CURVE(COPY(I),J,K)# Every curv   PO70  82
DO J=1,maxpha:;DO K=1,40;HKLBAR(I,J,K)=HKLBAR(COPY(I),J,K)# Hklbars     PO70  83
TITLET(I)=TITLET(COPY(I))#             Graph title label                PO70  84
ABSLAB(I)=ABSLAB(COPY(I))#             Graph abscissa label             PO70  85
ORDLAB(I)=ORDLAB(COPY(I))#             Graph ordinate  label            PO70  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PO70  87
#                                                                       PO70  88
#  REDO THE DISPLAY ACCORDINGLY                                         PO70  89
#  ----------------------------                                         PO70  90
#                                                                       PO70  91
IF(CURPLT==0)#                         No current plot                  PO70  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PO70  93
DO I=1,maxgn:;IF(NINT(gptinvoked:(I))==yes:)BREAK#                      PO70  94
IF(I<=maxgn:)CURPLT=I#                 Got a new current - or none      PO70  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PO70  96
#                                                                       PO70  97
# NOTE THE ARANGE MENT METHOD IS A LINKED VARIABLE SO NOT ACCESSED HERE PO70  98
CALL PO34#                             Validate all graph block locat   PO70  99
IF(VUTYPE==0) CALL PO35#               Make new graph visible           PO70 100
IF(VUTYPE==1) CALL PO36(1)#            Redisplay graphs                 PO70 101
TEXT='BlockArrangeConfig .arrangeb init'#                               PO70 102
tcleval:(TEXT)#                        Update the tcl display table     PO70 103
#                                                                       PO70 104
RETURN#                                                                 PO70 105
END#                                                                    PO70 106
systemheader:(PO71)#                   Step to next graph block         PO71   1
####################################################################### PO71   2
#                                                                     # PO71   3
#                          PO71                                       # PO71   4
#                                                                     # PO71   5
####################################################################### PO71   6
SUBROUTINE PO71(SEQNUM)#                                                PO71   7
include:(POCOMN)#                                                       PO71   8
#                                                                       PO71   9
INTEGER XI,YI,PLT#                                                      PO71  10
INTEGER SEQNUM#                                                         PO71  11
INTEGER OLDPLT
#                                                                       PO71  12
OLDPLT=CURPLT#
IF (SEQNUM <5)#                                                         PO71  13
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO71  14
XI=NINT(gptxindex:(CURPLT))#           X index of relative graph        PO71  15
YI=NINT(gptyindex:(CURPLT))#           Y index of relative graph        PO71  16
IF    (SEQNUM==1)YI=YI-1#              Next graph below                 PO71  17
ELSEIF(SEQNUM==2)XI=XI+1#              Next graph to right              PO71  18
ELSEIF(SEQNUM==3)YI=YI+1#              Next graph above                 PO71  19
ELSEIF(SEQNUM==4)XI=XI-1#              Next graph to left               PO71  20
IF(XI>0 & XI<=miv: & YI>0 & YI<=miv:)# Within grindx limits             PO71  21
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO71  22
IF(GRINDX(YI,XI)!=0) CURPLT=GRINDX(YI,XI)# Step to next plot            PO71  23
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO71  24
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO71  25
ELSE#                                  Get next graph in sequence       PO71  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO71  27
PLT=CURPLT#                            Counter variable                 PO71  28
REPEAT#                                Cycle through plots              PO71  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO71  30
PLT=MOD(PLT+1,maxgn:+1)#               Increment plot counter by one    PO71  31
IF(PLT==0)PLT=1#                       No zero plot exists              PO71  32
IF(NINT(gptinvoked:(PLT))==yes:\PLT==CURPLT)BREAK# Next invoked         PO71  33
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO71  34
CURPLT=PLT#                            Reset the curplt pointer         PO71  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO71  36
IF(OLDPLT!=CURPLT) CALL PO35#          Plot the new graph if changed 
#                                                                       PO71  38
RETURN#                                                                 PO71  39
END#                                                                    PO71  40
#                                                                       PO71  41
systemheader:(PO90)#                   Initialise color map             PO90   1
####################################################################### PO90   2
#                                                                     # PO90   3
#                          PO90                                       # PO90   4
#                                                                     # PO90   5
####################################################################### PO90   6
SUBROUTINE PO90#                                                        PO90   7
include:(AACOMN)#                                                       PO90   8
include:(POCOMN)#                                                       PO90   9
#                                                                       PO90  10
INTEGER I,J#                                                            PO90  11
INTEGER COLS,COL#                                                       PO90  12
REAL V1,V2,V3,THETA,RGB(3)#                                             PO90  13
#                                                                       PO90  14
COLS=64#                               Intended color variation         PO90  15
IF(COLMAP(1)<0.0\COLMAP(1)>1.0)COLMAP(1)=0.5# Maximum color variation   PO90  16
IF(COLMAP(2)<0.0\COLMAP(2)>1.0)COLMAP(2)=1.0# And average brightness    PO90  17
V1=0.0;V2=1.0#                         Initialise min max values        PO90  18
IF(COLMAP(1)<0.5)V2=    2.*COLMAP(1)#  New maximum value                PO90  19
ELSE             V1=-1.+2.*COLMAP(1)#  New minimum value                PO90  20
V1=V1+ (1.-COLMAP(2))*(V2-V1)/2.#      Minimum value                    PO90  21
V2=V2- (1.-COLMAP(2))*(V2-V1)/2.#      Maximum value                    PO90  22
V3=(V2-V1)#                            Range of color intensities       PO90  23
#                                                                       PO90  24
colormap:(MINCOL,MAXCOL)#              Get number of open color cells   PO90  25
IF (MINCOL<=1& MAXCOL >8)defcmap:#     Load default 8 colormap          PO90  26
IF (MINCOL<=1& MAXCOL >20)#            Add 11 shades of grey            PO90  27
DO I=1,11#                             Add grey levels for window bac   PO90  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO90  29
RGB(1)=V1+FLOAT(I-1)/10.*V3#           Determine the grey value         PO90  30
setcolor:(7+I,RGB(1),RGB(1),RGB(1))#   Set the colors of grey           PO90  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO90  32
#                                                                       PO90  33
IF (MAXCOL>20)#                        Also enough room for graph col   PO90  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO90  35
COL=MIN(MAXCOL-20,COLS)#               Take whatever is available       PO90  36
DO I=1,COL#                            Cycle over graph colors          PO90  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO90  38
THETA=6.283183*FLOAT(I-1)/FLOAT(COL+1)# Theta increment                 PO90  39
RGB(1)=(1.0+COS(THETA))/2.#            The red setting                  PO90  40
RGB(2)=(1.0+COS(THETA-2.0943951))/2.#  The green setting                PO90  41
RGB(3)=(1.0+COS(THETA+2.0943951))/2.#  The blue setting                 PO90  42
DO J=1,3#                              Test each color                  PO90  43
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PO90  44
IF    (RGB(J)>0.75)RGB(J)=V1+V3*1.0#   Maximise this color              PO90  45
ELSEIF(RGB(J)<0.25)RGB(J)=V1+V3*0.0#   Minimise this color              PO90  46
ELSE               RGB(J)=V1+V3*(2.*RGB(J)-0.5)# Ramp this color        PO90  47
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PO90  48
setcolor:(20+I,RGB(1),RGB(2),RGB(3))#  Add entry to colormap            PO90  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO90  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO90  51
#                                                                       PO90  52
RETURN#                                                                 PO90  53
END#                                                                    PO90  54
systemheader:(PO95)#                   Print dump of line arrays        PO95   1
# ############################################################### #     PO95   2
#                                                                 #     PO95   3
#                          PO95                                   #     PO95   4
#                                                                 #     PO95   5
# ############################################################### #     PO95   6
SUBROUTINE PO95(N,X,Y,C,S)#                                             PO95   7
INTEGER I,N#                                                            PO95   8
INTEGER C#                                                              PO95   9
REAL S,COL,X(*),Y(*)#                                                   PO95  10
IF(C>=20) COL=FLOAT((C-20)/8 +1)#      Get 3 bit color of lines         PO95  11
ELSE  COL=FLOAT(C)#                    Color is 3 bit color             PO95  12
## Ideally should get linesize also, but that is unsupported in plotx   PO95  13
CALL          PO96(X(1),Y(1),0.,0.,0., up:,3," ")# Move to first poin   PO95  14
DO I=1,N;CALL PO96(X(I),Y(I),0.,0.,COL,dn:,3," ")# Cycle over points    PO95  15
CALL          PO96(X(N),Y(N),0.,0.,COL,up:,3," ")# Pen up at last poi   PO95  16
RETURN#                                                                 PO95  17
END#                                                                    PO95  18
systemheader:(PO96)#                   Dump of plot file                PO96   1
# ############################################################### #     PO96   2
#                                                                 #     PO96   3
#                          PO96                                   #     PO96   4
#                                                                 #     PO96   5
# ############################################################### #     PO96   6
SUBROUTINE PO96(P1,P2,P3,P4,P5,P6,KEY,NCHARS)# R. olthof-hazekamp       PO96   7
include:(AACOMN)#                                                       PO96   8
#                                                                       PO96   9
string:(NCHARS,*)#   ## text string                                     PO96  10
REAL    P1,P2,P3,P4,P5,P6## Parameters                                  PO96  11
INTEGER KEY#      ## 1=start of plot                                    PO96  12
#                 ## 2=FRAME ADVANCE SIGNAL                             PO96  13
#                 ## 3=PEN MOVEMENT                                     PO96  14
#                 ## 4=DRAW NUMBER                                      PO96  15
#                 ## 5=DRAW CHARACTER STRING                            PO96  16
#                 ## 6=PLOT SCALE                                       PO96  17
#                 ## 10=END OF PLOT                                     PO96  18
# INPUT PACKET CONTENTS                                                 PO96  19
# PEN MOVEMENT (3)                                                      PO96  20
#     WORD 1       DX PLOT MOVEMENT                                     PO96  21
#     WORD 2       DY PLOT MOVEMENT                                     PO96  22
#     WORD 3       X  PLOT MOVEMENT                                     PO96  23
#     WORD 4       Y  PLOT MOVEMENT                                     PO96  24
#     WORD 5       SUBJECT (COLOR) INDEX                                PO96  25
#     WORD 6       PEN UP/DOWN FLAG (3/2)                               PO96  26
# DRAW NUMBER  (4)                                                      PO96  27
#     WORD 1       X START OF NUMBER STRING                             PO96  28
#     WORD 2       Y START OF NUMBER STRING                             PO96  29
#     WORD 3       HEIGHT OF SYMBOLS IN INCHES                          PO96  30
#     WORD 4       NUMBER                                               PO96  31
#     WORD 5       ANGLE TO X-AXIS IN DEGREES                           PO96  32
#     WORD 6       NUMBER OF DIGITS AFTER DECIMAL PX.                   PO96  33
# DRAW CHARACTER (5)                                                    PO96  34
#     WORD 1       X START OF CHARACTER STRING                          PO96  35
#     WORD 2       Y START OF CHARACTER STRING                          PO96  36
#     WORD 3       HEIGHT OF SYMBOLS IN INCHES                          PO96  37
#     WORD 4       ANGLE TO X-AXIS IN DEGREES                           PO96  38
#     WORD 5       NUMBER OF CHARACTERS IN STRING (<73)                 PO96  39
#     WORD 6       DRAW OR SKIP BLANKS                                  PO96  40
#                                                                       PO96  41
# ---------------------------------------------------------------       PO96  42
INTEGER N,M,L#                                                          PO96  43
INTEGER I#        ##                                                    PO96  44
INTEGER IP#       ## Pointer in output buffer                           PO96  45
CHARACTER*100 BUF#                                                      PO96  46
datastuff:#                                                             PO96  47
#                                                                       PO96  48
writepkt:(4,23,7,IP)#                  Init for new packet              PO96  49
QX(IP+1)=P1#                           Parameter 1                      PO96  50
QX(IP+2)=P2#                           Parameter 2                      PO96  51
QX(IP+3)=P3#                           Parameter 3                      PO96  52
QX(IP+4)=P4#                           Parameter 4                      PO96  53
QX(IP+5)=P5#                           Parameter 5                      PO96  54
QX(IP+6)=P6#                           Parameter 6                      PO96  55
QX(IP+7)=FLOAT(KEY)#                   Function key                     PO96  56
#                                                                       PO96  57
IF(KEY==5)#                            Character string                 PO96  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PO96  59
QX(IP+6)=0.#                           Dummy                            PO96  60
N=NINT(P5);   M=7*mxchwd:#             Nr of words in string            PO96  61
BUF=' '#                               Blank initialy                   PO96  62
FOR(I=0;I<N;I=I+M)#                    Loop over packets                PO96  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PO96  64
writepkt:(4,23,7,IP)#                  Init for next packet             PO96  65
L=MIN0(M,N-I)#                         Length of packet                 PO96  66
BUF(1^M)=NCHARS(I+1^I+L)#              Blank the buffer                 PO96  67
movector:(BUF,1,QX(IP+1),1,M,0)#       Move buffer to packet            PO96  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PO96  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PO96  70
IF(KEY==10)#                           End plot                         PO96  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PO96  72
writepkt:(4,23,7,IP)#                                                   PO96  73
writepkt:(4,endrecord:,7,IP)#          Write last record                PO96  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PO96  75
#                                                                       PO96  76
RETURN#                                                                 PO96  77
END#                                                                    PO96  78
####################################################################### PO96  79
#                                                                     # PO96  80
#              ROUTINES WHICH FOLLOW ARE TK/X11 CALLBACKS             # PO96  81
#                                                                     # PO96  82
####################################################################### PO96  83
#                                                                       PO96  84
# THERE IS NO CURRENT NEED FOR A AUXREFCOMND: CALLBACK FOR GRAPHC:      PO96  85
#                                                                       PO96  86
systemheader:(POA0)#                   Refreshing the main graph        POA0   1
# ############################################################### #     POA0   2
#                                                                 #     POA0   3
#                          POA0       AUXXSCROLLCMD:(GRAPHC:,POA0)#     POA0   4
#                                                                 #     POA0   5
# ############################################################### #     POA0   6
SUBROUTINE POA0(MAG,XC)#               Tklib callback                   POA0   7
include:(POCOMN)#                                                       POA0   8
REAL MAG,XC#                           Magnification and plot centre    POA0   9
IF(VUTYPE!=0)RETURN#                   Plot is a preview plot           POA0  10
CALL PO41(CURPLT)#                     Regenerate the abscissa          POA0  11
buffswap:(abscissac:)#                                                  POA0  12
#  THIS ROUTINE IS CALLED WHENEVER THE X SCROLLBAR LINKED TO            POA0  13
#  THE GRAPHC: CANVAS ARE MOVED. AT THIS TIME, WE HAVE TO               POA0  14
#  RECALCULATE THE AUXILLIARY AXES.                                     POA0  15
#                                                                       POA0  16
RETURN#                                                                 POA0  17
END#                                                                    POA0  18
systemheader:(POA1)#                   Refreshing the main graph        POA1   1
# ############################################################### #     POA1   2
#                                                                 #     POA1   3
#                          POA1       AUXYSCROLLCMD:(GRAPHC:,POA1)#     POA1   4
#                                                                 #     POA1   5
# ############################################################### #     POA1   6
SUBROUTINE POA1(MAG,YC)#               Tklib callback                   POA1   7
include:(POCOMN)#                                                       POA1   8
REAL MAG,YC#                           Magnification and plot centre    POA1   9
#  THIS ROUTINE IS CALLED WHENEVER THE Y SCROLLBAR LINKED TO            POA1  10
#  THE GRAPHC: CANVAS IS MOVED. AT THIS TIME, WE HAVE TO                POA1  11
#  RECALCULATE THE AUXILLIARY AXES.                                     POA1  12
IF(VUTYPE!=0)RETURN#                   Plot is a preview plot           POA1  13
CALL PO42(CURPLT)#                     Regenerate the ordinate          POA1  14
buffswap:(ordinatec:)#                                                  POA1  15
#                                                                       POA1  16
RETURN#                                                                 POA1  17
END#                                                                    POA1  18
systemheader:(POA2)#                   Refreshing the main graph        POA2   1
# ############################################################### #     POA2   2
#                                                                 #     POA2   3
#                          POA2       AUXREFCOMND:(GRAPHC:,POA2)#       POA2   4
#                                                                 #     POA2   5
# ############################################################### #     POA2   6
#SUBROUTINE POA1#                       TKLIB CALLBACK WITH NO ARGS     POA2   7
#INCLUDE:(POCOMN)#                                                      POA2   8
#  THIS IS JUST A PLACEHOLDER                                           POA2   9
#  ANY TKLIB EXPOSE EVENTS REQUIRING EXTRA REFRESHING SHOULD BE         POA2  10
#  ADDED HERE.                                                          POA2  11
#                                                                       POA2  12
#RETURN#                                                                POA2  13
#END#                                                                   POA2  14
systemheader:(POA3)#                                                    POA3   1
# ############################################################### #     POA3   2
#                                                                 #     POA3   3
#                          POA3  AUXRESIZE:(LEGENDC:,  POA3)#           POA3   4
#                                                                 #     POA3   5
# ############################################################### #     POA3   6
SUBROUTINE POA3(WIDTH,HEIGHT)#         Tklib callback with no args      POA3   7
include:(POCOMN)#                                                       POA3   8
INTEGER WIDTH,HEIGHT#                  Ignore - use linked aspect       POA3   9
canvaspects:(legendc:,ASPECT(legendc:))# Reset aspect ratio             POA3  10
RETURN#                                                                 POA3  11
END#                                                                    POA3  12
systemheader:(POA4)#                                                    POA4   1
# ############################################################### #     POA4   2
#                                                                 #     POA4   3
#                          POA4  AUXREFRESH:(LEGENDC:,  POA4)#          POA4   4
#                                                                 #     POA4   5
# ############################################################### #     POA4   6
SUBROUTINE POA4#                       Tklib callback with no args      POA4   7
include:(POCOMN)#                                                       POA4   8
INTEGER LNBLNK#                        Function returning int           POA4   9
INTEGER I,NC,ICOL#                                                      POA4  10
REAL YI,Y,TSZ#                                                          POA4  11
#                                                                       POA4  12
IF(VUTYPE!=0)RETURN#                   No legend on a preview plot      POA4  13
#                                                                       POA4  14
#   DISPLAY LEGEND IN BOX                                               POA4  15
#   ---------------------                                               POA4  16
#                                                                       POA4  17
setcanvas:(legendc:,0)#                                                 POA4  18
erasepage:(legendc:,1)#                Erase subwindow, delete segme    POA4  19
segcreat:(1)#                          Create graph number text segm    POA4  20
#IP= 6+NPHASE#                                                          POA4  21
YI= 1.0/((7+NPHASE)*2.)#                                                POA4  22
Y=0.05+YI#                                                              POA4  23
RTSC=1.0/((7+NPHASE)*2.)/2.2#                                           POA4  24
DO I=2,6+NPHASE#                                                        POA4  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  POA4  26
IF(NINT(cvdisplay:(CURPLT,I))!=yes:)NEXT# No display curve line         POA4  27
NC=LNBLNK(CRVLAB(I))#                                                   POA4  28
ICOL=NINT(cvlncolor:(CURPLT,I))#       Set linecolor for trace          POA4  29
drawwtext:(0.02,Y,ICOL,1.,0.,NC,CRVLAB(I))# Add title text string to    POA4  30
Y=Y+YI#                                                                 POA4  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  POA4  32
segclose:#                             Finish the segment               POA4  33
#                                                                       POA4  34
RETURN#                                                                 POA4  35
END#                                                                    POA4  36
systemheader:(POA5)#                   Resizing the abscissa            POA5   1
# ############################################################### #     POA5   2
#                                                                 #     POA5   3
#                          POA5 AUXRESIZE:(ABSCISSAC:, POA5)#           POA5   4
#                                                                 #     POA5   5
# ############################################################### #     POA5   6
SUBROUTINE POA5(WIDTH,HEIGHT)#         Tklib callback with 2 args       POA5   7
include:(POCOMN)#                                                       POA5   8
INTEGER WIDTH,HEIGHT#                  Ignore - use linked aspect       POA5   9
canvaspects:(abscissac:,ASPECT(abscissac:))# Reset aspect ratio         POA5  10
IF(VUTYPE!=0)RETURN#                   Plot is a preview plot           POA5  11
CALL PO41(CURPLT)#                     Regenerate the abscissa          POA5  12
RETURN#                                                                 POA5  13
END#                                                                    POA5  14
systemheader:(POA6)#                   Refreshing the abscissa          POA6   1
# ############################################################### #     POA6   2
#                                                                 #     POA6   3
#                          POA6 AUXREFCOMND:(ABSCISSAC:, POA6)#         POA6   4
#                                                                 #     POA6   5
# ############################################################### #     POA6   6
SUBROUTINE POA6#                       Tklib callback with no args      POA6   7
include:(POCOMN)#                                                       POA6   8
#  REDUNDANT OWING TO SEGMENT STORAGE AND BUFFERING                     POA6   9
#IF(VUTYPE!=0)RETURN#                   PLOT IS A PREVIEW PLOT          POA6  10
#CALL PO41(CURPLT)#                     REGENERATE THE ABSCISSA         POA6  11
RETURN#                                                                 POA6  12
END#                                                                    POA6  13
systemheader:(POA7)#                   Resizing the ordinate            POA7   1
# ############################################################### #     POA7   2
#                                                                 #     POA7   3
#                          POA7 AUXRESIZE:(ORDINATEC:, POA7)#           POA7   4
#                                                                 #     POA7   5
# ############################################################### #     POA7   6
SUBROUTINE POA7(WIDTH,HEIGHT)#         Tklib callback with 2 args       POA7   7
include:(POCOMN)#                                                       POA7   8
INTEGER WIDTH,HEIGHT#                  Ignore - use linked aspect       POA7   9
canvaspects:(ordinatec:,ASPECT(ordinatec:))# Reset aspect ratio         POA7  10
IF(VUTYPE!=0)RETURN#                   Plot is a preview plot           POA7  11
CALL PO42(CURPLT)#                     Regenerate the ordinate          POA7  12
#                                      In background pixmap             POA7  13
RETURN#                                                                 POA7  14
END#                                                                    POA7  15
systemheader:(POA8)#                   Refreshing the main graph        POA8   1
################################################################# #     POA8   2
#                                                                 #     POA8   3
#                          POA8   AUXREFCOMND:(ORDINATEC:,POA8)#        POA8   4
#                                                                 #     POA8   5
################################################################# #     POA8   6
SUBROUTINE POA8#                       Tklib callback with no args      POA8   7
include:(POCOMN)#                                                       POA8   8
#                                                                       POA8   9
# THIS MAY BE REDUNDANT BECAUSE ITS DOUBLE BUFFERED                     POA8  10
# SO TKLIB WILL HANDLE THE BUFFER SWAPPING                              POA8  11
#                                                                       POA8  12
#                                                                       POA8  13
#IF(VUTYPE!=0)RETURN#                   PLOT IS A PREVIEW PLOT          POA8  14
#CALL PO42(CURPLT)#                     REGENERATE THE ORDINATE         POA8  15
RETURN#                                                                 POA8  16
END#                                                                    POA8  17
#                                                                       POA8  18
pmacro:([no:])## Purge xtal system macros#########                      POA8  19
