systemheader:(QF    )#                                                  QF     1
##   version: Nov93                                                             
######################################################################  QF     2
#                                                                    #  QF     3
#                            ***PROLSQ***                            #  QF     4
#                                                                    #  QF     5
#   THE XTAL VERSION OF PROLSQ IS A RECODING OF THE VERSION SET UP   #  QF     6
# BY BARRY FINZEL.  THE PROGRAM IS BASED ON THE ORIGINAL CODE OF     #  QF     7
# JOHN KONNERT AND WAYNE HENDRICKSON WITH INPUT AND MODIFICATIONS BY #  QF     8
# ANITA SIELECKI, JANET SMITH, STEVEN SHERIFF, AND PERHAPS OTHERS.   #  QF     9
#                              J.M. STEWART, NRL, OCTOBER 1987       #  QF    10
#                                                                    #  QF    11
# SEE: RESTRAINED LEAST SQUARES; HENDRICKSON,W.A. & KONNERT,J.H.     #  QF    12
# IN COMPUTING IN CRYSTALLOGRAPHY   EDITED BY DIAMOND,R.,            #  QF    13
# RAMASESHAM,S. & VENKATESAN,K. (1980)                               #  QF    14
######################################################################  QF    15
#                                                                       QF    16
include:(XMACRO)#                                                       QF    17
#                                                                       QF    18
macro:(qmxgrp:,40)#                    Maximum no. of residue names     QF    19
macro:(nw9c:,incr:(arith:(9,/,mxchwd:)))# No. of words to hold 9 char   QF    20
macro:(mxwd6c:,incr:(arith:(5,/,mxchwd:)))# Max words to hold 6 chars   QF    21
#                                                                       QF    22
extrude:(QFCOMN)#                                                       QF    23
INTEGER ANOM## Signal that anomolous scatterers present                 QF    24
INTEGER ATIREL(21)## Offsets for atomic parameters in lratom:           QF    25
INTEGER B1ORU2## Temperature factors out as B/U 1/2                     QF    26
INTEGER DOPOP## Signal if any refinement on population param no:/yes:   QF    27
INTEGER DOUG## Absolute number of first encountered refl. to list       QF    28
INTEGER EXRFI## File designator for scratching f(calc) sample           QF    29
#               NOT CONTRIBUTED TO LEAST-SQUARES PROCESS.               QF    30
INTEGER FFT## Signal that the derivatives prepared by fast fourier      QF    31
INTEGER GETPK## Pointer for unpacking records from file F of PROTIN     QF    32
INTEGER IAAS(250)## Serial number pointers to anomalous atoms           QF    33
INTEGER IAS## Number of atoms which have large f''                      QF    34
INTEGER IANISB##                                                        QF    35
INTEGER IATMN## Three times the number of atoms plus one 3*na+1         QF    36
INTEGER IATMR##                                                         QF    37
INTEGER IBET1## 3*na+2, same as iatmn+1                                 QF    38
INTEGER IBETN## 3*na+1+nbet, same as iatmn+nbet. nbet = no. tfs.        QF    39
INTEGER ICHIP## Chiral center print 0/1/2 ov/worst/all stats            QF    40
INTEGER IDALIZ## Refinement to fit idealized geometry yes:/no:          QF    41
INTEGER IDERIV## Communicate no. deriv's QF37 to QF38                   QF    42
INTEGER IDISK##                                                         QF    43
INTEGER IFFF## Flag if scat factors to be taken from lrrefl or lrscat   QF    44
INTEGER IFOFC##                                                         QF    45
INTEGER IHYDP## H bond contact print 0/1 restrained/all bonds           QF    46
INTEGER INBDF## File used for input binary data file (file a)           QF    47
INTEGER IPOSTV## Used in trig table look-up. large multiple of 1024     QF    48
INTEGER IPX,IPY,IPZ##                                                   QF    49
INTEGER IREFR##                                                         QF    50
INTEGER IRTEST## Signal for r test of param shift damping no:/yes:      QF    51
INTEGER IRTESX## Signal for r test of excluded reflections no:/yes:     QF    52
INTEGER ISCG## Scale group to wich current reflection belongs           QF    53
INTEGER ISQNO##                                                         QF    54
INTEGER ISYSR##                                                         QF    55
INTEGER ITEM## No. of items in archive array for lrrefl:                QF    56
INTEGER ITORP## Torsion print 0/1 overall/all stats                     QF    57
INTEGER JABN## No. of tf shift damping values to test                   QF    58
INTEGER JAQN## No. of parameter shift damping values to test            QF    59
INTEGER JFAS(250)## Serial number pointers to anomalous atoms           QF    60
INTEGER JMTRX## No. of words in dirivative matrix array                 QF    61
INTEGER KFWGT## Weight scheme to apply to struct facts 1/2/3/4/5        QF    62
INTEGER KIAT(15)##                                                      QF    63
INTEGER KILLDV## Signal calc of derivs in QF62 as yes:/no: kill them    QF    64
INTEGER L2,L3## Function of lgx, lgy, & lgz                             QF    65
INTEGER LGX,LGY,LGZ## Constraint of origin signals 0/1 do not/do        QF    66
INTEGER LISLOC## Count of extent of printed list of atoms               QF    67
INTEGER LISTA## Parameter shift print 0/1/>1 no/all/selected            QF    68
INTEGER LISTF## Sf print 0/1/n no/all/(every nth)                       QF    69
INTEGER LISTIT## Signal if atom coordinates are listed on input         QF    70
INTEGER LQ## Control of scale of lagrange multipliers in cg             QF    71
INTEGER LRANI## Designator for logical record for aniso t.f.s           QF    72
INTEGER LRCHI## Designator for logical record for chiral centers        QF    73
INTEGER LRDIS## Designator for logical record for distance restraints   QF    74
INTEGER LRPLA## Designator for logical record for plane restraints      QF    75
INTEGER LRSYM## Designator for logical record for symmetry restraints   QF    76
INTEGER LRTOR## Designator for logical record for torsion restraints    QF    77
INTEGER LRVDW## Designator for logical record for vdWaals restraints    QF    78
INTEGER MARKA## Atom array xf,yf,zf,sftype,b,q,signal, atom id(9 char   QF    79
INTEGER MARKD## Distance array                                          QF    80
INTEGER MARKE## Anisotropic tf stuff                                    QF    81
INTEGER MARKM## Dirivative matrix array (of normal equations)           QF    82
INTEGER MARKT## Scratch tablet array                                    QF    83
INTEGER MARKU## Dv array                                                QF    84
INTEGER MARKV## V array                                                 QF    85
INTEGER MARK2## Scattering factor names table                           QF    86
INTEGER MARK3## Tables of scattering factors from lrscat:               QF    87
INTEGER N1,N2,N3##                                                      QF    88
INTEGER NA## Total no. of atoms loaded and to be treated                QF    89
INTEGER NACIDS## Total number of residue names and synonyms from PROT   QF    90
INTEGER NAS## No. of atoms with anomalous scattering                    QF    91
INTEGER NATQN## Checksum of atoms for testing File A and G are relate   QF    92
INTEGER NAXES## No. of thermal ellipsoid restraint specifications       QF    93
INTEGER NBET## No. of tfs (b) 1/na/3*na for overall/iso/aniso           QF    94
INTEGER NCHR## No. of chiral centers to be restrained                   QF    95
INTEGER NCYCCG## No. of conjugant gradient cycles in run                QF    96
INTEGER NDAMP## No. of parameter shift damping factors                  QF    97
INTEGER NDMIN## No. of shells for statistics as f(resolution)           QF    98
INTEGER NDIS## No. of restrained distances                              QF    99
INTEGER NEUT## Flag for x-ray/neutron data no:/yes:                     QF   100
INTEGER NHBD##                                                          QF   101
INTEGER NKILL## No. of atoms to be left unrefined                       QF   102
INTEGER NLINEC## Total characters in input line id codes                QF   103
INTEGER NNAP## Some kind of count of planes restraints                  QF   104
INTEGER NOBS## No. of observations (reflections)                        QF   105
INTEGER NOCC## No. of variable occupancy factors                        QF   106
INTEGER NPLN## No. of planar groups to be restrained                    QF   107
INTEGER NRJDSK## Count of sample of reflections written to RFILE        QF   108
INTEGER NRKDSK## Count of sample of reflections written to EXRFI        QF   109
INTEGER NS## No. of space group symmetry operations                     QF   110
INTEGER NSAMPL## Select every nth reflection for r testing              QF   111
INTEGER NSAMPS## Starting with this reflection                          QF   112
INTEGER NSAMPX## Select every nth reflection for r exclusion testing    QF   113
INTEGER NSAMPY## Starting with this reflection                          QF   114
INTEGER NSCATT## No. of different scattering factor types               QF   115
INTEGER NSCF## Count of number of entries in s.f. tables from lrscat:   QF   116
INTEGER NSCL## No. of scale factor groups                               QF   117
INTEGER NSF## No. of different scale factor groups (64 max)             QF   118
INTEGER NSYM(2)## No. of special symmetry restraints; 2 groups          QF   119
INTEGER NTOR## No. of restrained torsion angles                         QF   120
INTEGER NTYP## No. of different scattering factor types                 QF   121
INTEGER NV## No. of parameters to be varied in run                      QF   122
INTEGER NVDW## No. of possible contact restraints                       QF   123
INTEGER NVL## Total number of variables being refined                   QF   124
INTEGER OUTBDF## File used for output binary data file (file b)         QF   125
INTEGER PNCHIT## Signal if new atomic coordinates are to be punched     QF   126
INTEGER PSIZ6## Packet sizes for records from file F                    QF   127
INTEGER REPORT## Refinement to fit diffraction data yes:/no:            QF   128
INTEGER RFILE## File designator for scratching f(calc) sample           QF   129
INTEGER SCLIN(64)## Scale lines in input signals                        QF   130
INTEGER SCRBDF## File to scratch a BDF with updated reflection info     QF   131
INTEGER SETISO## Signal to cause refined ov tf to set ind tfs no:/yes   QF   132
INTEGER SOLMOD## No:/yes: use solvent modification routine qf63 (amor   QF   133
INTEGER STEPA## Atom array xf,yf,zf,sftype,b,q,                         QF   134
#               REFINEMENT SIGNAL & ATOM ID(9 CHARS)                    QF   135
INTEGER STEPD## Distance array                                          QF   136
INTEGER STEPE## Anisotropic tf stuff                                    QF   137
INTEGER STEPM## Dirivative matrix array                                 QF   138
INTEGER STEPT## Scratch tablet array                                    QF   139
INTEGER STEPU## Dv array                                                QF   140
INTEGER STEPV## V array                                                 QF   141
INTEGER STOPA## Atom array xf,yf,zf,sftype,b,q, atom id(9 chars)        QF   142
INTEGER STOPD## Distance array                                          QF   143
INTEGER STOPE## Anisotropic tf stuff                                    QF   144
INTEGER STOPM## Dirivative matrix array                                 QF   145
INTEGER STOPT## Scratch tablet array                                    QF   146
INTEGER STOPU## Dv array                                                QF   147
INTEGER STOPV## V array                                                 QF   148
INTEGER TFTYPE## Temperature factor type 0/1/2 ovr/iso/aniso            QF   149
INTEGER TINFIL## File used for communication with program PROTIN (QN)   QF   150
#                                                                       QF   151
REAL    A## The real part of the calculated structure factor            QF   152
REAL    A0##                                                            QF   153
REAL    AANGL,BANGL,GANGL## Alpha, beta, & gamma of direct unit cell    QF   154
REAL    ADI(16),ADR(16)## Imag. & real dispersion fact's from lrscat:   QF   155
REAL    AEDGE,BEDGE,CEDGE## a, b , & c of direct unit cell              QF   156
REAL    AFSIG,BFSIG##                                                   QF   157
REAL    ANGLE## Communicate angles between QF37 and QF38                QF   158
REAL    APC## Amorphous solvent modelling parameters                    QF   159
REAL    ARCH(20)## List of quantities to be archived from lrrefl:       QF   160
REAL    ASTAR,BSTAR,CSTAR## a*, b*, c* of reciprocal unit cell          QF   161
REAL    B## The imaginary part of the calculated structure factor       QF   162
REAL    B0##                                                            QF   163
REAL    B11,B12,B13,B22,B23,B33## Overall aniso exponential scale       QF   164
REAL    BDEL## Temperature factor shift weight                          QF   165
REAL    BDIAG## Sum of (dFc/dB)**2 for overall T.F.                     QF   166
REAL    BPC## Amorphous solvent modelling parameters                    QF   167
REAL    BVEC## Sum of delta(F)*(dFc/dB) for overall T.F. correction     QF   168
REAL    CA,CB,CG## Cosines of direct cell angles                        QF   169
REAL    COSAR,COSBR,COSGR## Cosines of reciprocal cell angles           QF   170
REAL    CTB(1024)## Cosine table over full circle 0 to 2pi radians      QF   171
REAL    DAMP(11)## Shift damping factors for atomic parameters          QF   172
REAL    DBCUT## Control b shift print >dbcut listed                     QF   173
REAL    DEGTOR## Conversion factor, degrees to radians                  QF   174
REAL    DINC(4)## Modification factors for van der waals contacts       QF   175
REAL    DK## Overall fc scale factor shift                              QF   176
REAL    DMIN(7)## Resolution limits, in angst., for statistics          QF   177
REAL    DQCUT## Control pop param print >dqcut listed                   QF   178
REAL    DSCUT## Control restrained distance print see w.u.              QF   179
REAL    DSNM## Data set number to be used in this run                   QF   180
REAL    DSTL## Sin theta over lambda interval for scat fact's tables    QF   181
REAL    DT## Overall temperature factor shift                           QF   182
REAL    DVPCUT## Control x,y,z shift print  >dvpcut printed             QF   183
REAL    ETB(1024)## Table of e**(-x) values for table lookup            QF   184
REAL    FAII(16)##                                                      QF   185
REAL    FII(16)## Reflection by reflection scat. fact's from bdf        QF   186
REAL    FIIMOD(16)## Scattering factors modified by solvent in qf63     QF   187
REAL    FMIN## Lower fobs cutoff for use in refinement                  QF   188
REAL    G(3,3)## Fract to orth atomic coord transformation              QF   189
REAL    GT(3,3)## Fract to orth atomic coord transformation transpose   QF   190
REAL    H(3)## The miller indices of the current reflection as reals    QF   191
REAL    KBOFFD## Sum of (dFc/dB)*(dFc/dK) for scale T.F. correlation    QF   192
REAL    KDIAG## Sum of (dFc/dK)**2  for scale factor correction         QF   193
REAL    KVEC## Sum of delta(F)*(dFc/dK) for scale factor correction     QF   194
REAL    OIXX,OIXY,OIXZ,OIYY,OIYZ,OIZZ## Orth to fract atomic coord      QF   195
REAL    ORXX,ORXY,ORXZ,ORYY,ORYZ,ORZZ## Fract to orth atomic coord      QF   196
REAL    PB## Amorphous solvent modelling parameters                     QF   197
REAL    PDEL## x,y,z parameter shift weights                            QF   198
REAL    PI## Pi, ratio of the diameter to the circumference             QF   199
REAL    PISQ8## Eight pi squared                                        QF   200
REAL    PK## Amorphous solvent modelling parameters                     QF   201
REAL    PLCUT## Control restrained planar group print see w.u.          QF   202
REAL    REJF## Flag for the rejection of reflections based on rcode     QF   203
REAL    RTODEG## Convert radians to degrees with this factor            QF   204
REAL    QBAR## Lagrange multiplier scaler; function of 'lq' in qf73     QF   205
REAL    QDEL## Population parameter shift weight                        QF   206
REAL    QXH,QYH,QYK,QZH,QZK,QZL## Orthoganalization of recip lat vect   QF   207
REAL    RHO## Sine squared theta/lambda squared; current reflection     QF   208
REAL    S(3,3,24),T(3,24),ASI(3,3,24)## Symmetry operation matrices     QF   209
REAL    SC(64)## F(calc) scale factors (1/frel scale factors)           QF   210
REAL    SCTM## Temporary storage for current reflection F(calc) scale   QF   211
REAL    SCLEST## Scale factor estimate from sum(fO)/sum(fc)             QF   212
REAL    SHFTK(11)## Shift damping factor for r tests                    QF   213
REAL    SIGB1## Thermal restraint weights                               QF   214
REAL    SIGB2## Thermal restraint weights                               QF   215
REAL    SIGB3## Thermal restraint weights                               QF   216
REAL    SIGB4## Thermal restraint weights                               QF   217
REAL    SIGB5## Thermal restraint weights                               QF   218
REAL    SIGB6## Thermal restraint weights                               QF   219
REAL    SIGB7## Thermal restraint weights                               QF   220
REAL    SIGB8## Thermal restraint weights                               QF   221
REAL    SIGC## Weight for scale factor restraints                       QF   222
REAL    SIGD1## Weight for bonded distance     type code 1              QF   223
REAL    SIGD2## Weight for angle distance      type code 2              QF   224
REAL    SIGD3## Weight for planar 1-4 distance type code 3              QF   225
REAL    SIGD4## Weight for h-bonded distance   type code 4              QF   226
REAL    SIGD5## Weight for h-bonded angle      type code 5              QF   227
REAL    SIGD6## Weight for h-bond, metal       type code 6              QF   228
REAL    SIGD7## Weight for coordination etc.   type code 7              QF   229
REAL    SIGMIN## Set less-thans fobs<sigmin*sigma(fobs)                 QF   230
REAL    SIGP## Weight for planar group restraints                       QF   231
REAL    SIGSB1## Thermal restraint weights type code 1=tight            QF   232
REAL    SIGSB2## Thermal restraint weights type code 2=medium           QF   233
REAL    SIGSB3## Thermal restraint weights type code 3=loose            QF   234
REAL    SIGSP1## Positional restraint weights type code 1=tight         QF   235
REAL    SIGSP2## Positional restraint weights type code 2=medium        QF   236
REAL    SIGSP3## Positional restraint weights type code 3=loose         QF   237
REAL    SIGT1## Sigma torsion ang (e.g. phi, psi of reg sec str)        QF   238
REAL    SIGT2## Sigma planar ang (e.g. omega)                           QF   239
REAL    SIGT3## Sigma staggered ang (e.g. chi)                          QF   240
REAL    SIGT4## Sigma orthonormal ang (e.g. chi 2 of aromatics)         QF   241
REAL    SIGV## Weight for van der waals restraints                      QF   242
REAL    SMAX## Upper limit of sin(theta)/lambda to use                  QF   243
REAL    SMIN## Lower limit of sin(theta)/lambda to use                  QF   244
REAL    SOLV## Amorphous solvent modelling parameters                   QF   245
REAL    STB(1024)## 1024 place sine table over full circle 0 to 2pi     QF   246
REAL    TDIR(4,3)## Communicate dirivateves between QF37 and QF38       QF   247
REAL    TMCUT## Control multiple torsion contact print                  QF   248
REAL    TO## Overall isotropic temperature factor                       QF   249
REAL    TSCUT## Control single torsion contact print                    QF   250
REAL    TUPI## Two times the number pi                                  QF   251
REAL    UB## Amorphous solvent modelling parameters                     QF   252
REAL    UK## Amorphous solvent modelling parameters                     QF   253
REAL    WBSKAL## Associated with temperature factor refinement          QF   254
REAL    WBSUM##                                                         QF   255
REAL    WCSKAL## Associated with chi angle refinement                   QF   256
REAL    WDSKAL## Associated with distance refinement                    QF   257
REAL    WPSKAL## Associated with planarity refinement                   QF   258
REAL    WPSUM##                                                         QF   259
REAL    WQSUM##                                                         QF   260
REAL    WSSKAL## Associated with shift limitation during refin          QF   261
REAL    WTSKAL## Associated with torsion angle refinement               QF   262
REAL    WVSKAL## Associated with van der waals refinement               QF   263
REAL    YC## The calculated structure factor developed in qf61/62       QF   264
REAL    YO## The observed structure factor on a relative scale          QF   265
REAL    ZX(3,4)## Communicate coordinates from QF37 to QF38             QF   266
string:(INLINE,176)## Input line ids                                    QF   267
string:(MCOD,qmxgrp:)## One character synonyms for residue names        QF   268
string:(NAMES,arith:(4,*,qmxgrp:))## Table of 4 char residue names      QF   269
#                                                                       QF   270
COMMON/COMIQF/$#                       Common for integers              QF   271
ANOM  ,ATIREL,B1ORU2,DOPOP ,DOUG  ,EXRFI ,FFT   ,GETPK ,IAAS  ,$#       QF   272
IAS   ,IANISB,IATMN ,IATMR ,IBET1 ,IBETN ,$#                            QF   273
ICHIP ,IDISK ,IDALIZ,IDERIV,IFFF  ,IFOFC ,IHYDP ,INBDF ,IPOSTV,$#       QF   274
IPX   ,IPY   ,IPZ   ,IREFR ,IRTEST,IRTESX,$#                            QF   275
ISCG  ,ISQNO ,ISYSR ,ITEM  ,$#                                          QF   276
ITORP ,JABN  ,JAQN  ,JFAS  ,$#                                          QF   277
JMTRX ,KFWGT ,KIAT  ,KILLDV,$#                                          QF   278
L2    ,L3    ,LGX   ,LGY   ,LGZ   ,LISLOC,LISTA ,LISTF ,LISTIT,$#       QF   279
LQ    ,LRANI ,LRCHI ,LRDIS ,LRPLA ,LRSYM ,LRTOR ,LRVDW ,$##             QF   280
MARKA ,MARKD ,MARKE ,MARKM ,MARKT ,MARKU ,MARKV ,MARK2 ,MARK3#          QF   281
#                                                                       QF   282
COMMON/COMJQF/$#                       Common for integers continued    QF   283
N1    ,N2    ,N3    ,NA    ,NACIDS,NAS   ,NATQN ,NAXES ,NBET  ,$#       QF   284
NCHR  ,NCYCCG,NDAMP ,NDMIN ,NDIS  ,NEUT  ,NHBD  ,$#                     QF   285
NKILL ,NLINEC,NNAP  ,NOBS  ,NOCC  ,NPLN  ,NRJDSK,NRKDSK,NS    ,$#       QF   286
NSAMPL,NSAMPS,NSAMPX,NSAMPY,NSCATT,NSCF  ,NSCL  ,NSF   ,NSYM  ,$#       QF   287
NTOR  ,NTYP  ,NV    ,NVDW  ,NVL   ,OUTBDF,PNCHIT,PSIZ6 ,REPORT,$#       QF   288
RFILE,SCLIN  ,SCRBDF,SETISO,SOLMOD,STEPA ,STEPD ,STEPE ,STEPM ,$#       QF   289
STEPT ,STEPU ,STEPV ,STOPA ,STOPD ,STOPE ,STOPM ,STOPT ,STOPU ,$#       QF   290
STOPV ,TFTYPE,TINFIL##                                                  QF   291
#                                                                       QF   292
COMMON/COMFQF/$#                       Common for reals                 QF   293
A     ,A0    ,AANGL ,AEDGE ,ADI   ,ADR   ,ANGLE ,ARCH  ,$#              QF   294
AFSIG ,BFSIG ,APC   ,ASTAR ,BSTAR ,CSTAR ,B     ,BANGL ,$#              QF   295
BDIAG ,BDEL  ,BEDGE ,BVEC  ,B0    ,$#                                   QF   296
B11   ,B12   ,B13   ,B22   ,B23   ,B33   ,BPC   ,CA    ,$#              QF   297
CB    ,CG    ,CEDGE ,COSAR ,COSBR ,COSGR ,CTB   ,DAMP  ,$#              QF   298
DBCUT ,DEGTOR,DINC  ,DK    ,DMIN  ,DQCUT ,DSCUT ,$#                     QF   299
DSNM  ,DSTL  ,DT    ,DVPCUT,ETB   ,FAII  ,FII   ,FIIMOD,$#              QF   300
FMIN  ,G     ,GT    ,GANGL ,H     ,KBOFFD,KDIAG ,KVEC  ,$#              QF   301
OIXX  ,OIXY  ,OIXZ  ,OIYY  ,OIYZ  ,OIZZ  ,$#                            QF   302
ORXX  ,ORXY  ,ORXZ  ,ORYY  ,ORYZ  ,ORZZ#                                QF   303
COMMON/COMGQF/$#                       Common for reals continued       QF   304
PB    ,PDEL  ,PI    ,PISQ8 ,PK    ,PLCUT ,QBAR  ,QDEL  ,$#              QF   305
QXH   ,QYH   ,QYK   ,$#                                                 QF   306
QZH   ,QZK   ,QZL   ,REJF  ,RHO   ,RTODEG,S     ,T     ,$#              QF   307
ASI   ,SC    ,SCLEST,SCTM  ,SHFTK ,$#                                   QF   308
SIGB1 ,SIGB2 ,SIGB3 ,SIGB4 ,SIGB5 ,SIGB6 ,$#                            QF   309
SIGB7 ,SIGB8 ,SIGC  ,SIGD1 ,SIGD2 ,SIGD3 ,SIGD4 ,SIGD5 ,$#              QF   310
SIGD6 ,SIGD7 ,SIGMIN,SIGP  ,SIGSB1,SIGSB2,SIGSB3,SIGSP1,$#              QF   311
SIGSP2,SIGSP3,SIGT1 ,SIGT2 ,SIGT3 ,SIGT4 ,SIGV  ,SMAX  ,$#              QF   312
SMIN  ,SOLV  ,STB   ,TDIR  ,TMCUT ,TO    ,TSCUT ,TUPI  ,UB    ,$#       QF   313
UK    ,WBSKAL,WBSUM ,WCSKAL,WDSKAL,WPSKAL,WPSUM ,$#                     QF   314
WQSUM ,WSSKAL,WTSKAL,WVSKAL,YC    ,YO    ,ZX#   ##                      QF   315
#                                                                       QF   316
COMMON/COMCQF/ INLINE,MCOD  ,NAMES#                                     QF   317
endext:#                                                                QF   318
#                                                                       QF   319
systemheader:(QF00)## Subroutine sequence driver                        QF00   1
####################################################################    QF00   2
#                                                                  #    QF00   3
#                                QF00                              #    QF00   4
#                                                                  #    QF00   5
####################################################################    QF00   6
SUBROUTINE QF00#                       Modeled on prolsq main           QF00   7
#                                        J. m. stewart oct 1987         QF00   8
include:(AACOMN)#                                                       QF00   9
include:(QFCOMN)#                                                       QF00  10
#                                                                       QF00  11
#                                                                       QF00  12
#    DATA ON THE PROLSQ LINE IS PICKED UP IN QF10.                      QF00  13
#    ALL DATA LINES EXCEPT 'NOREF' ARE READ IN QF10.                    QF00  14
#    LINE READING CEASES WHEN AN END LINE IS ENCOUNTERED                QF00  15
#    IN QF12, THEN ALL INPUT LINE READING IS COMPLETED.                 QF00  16
#    ----------------------------------------------------               QF00  17
#                                                                       QF00  18
CALL QF10#                             Read prolsq and input lines      QF00  19
CALL QF11#                             Read bdf up to atoms             QF00  20
CALL QF12#                             Read bdf for atoms to refl       QF00  21
CALL QF22#                             Initialize memory and tables     QF00  22
IF(IDALIZ==yes:) CALL QF31#            Set up restraints                QF00  23
#                                                                       QF00  24
IF(IRTEST==yes:)#                      R value survey to be done?       QF00  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF00  26
rewindbdf:(TINFIL)#                    To front of communication file   QF00  27
copyfile:(TINFIL,RFILE,1,1)#           Header for scratch file in qf6   QF00  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF00  29
IF(IRTESX==yes:)#                      Some reflns to be excluded?      QF00  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF00  31
rewindbdf:(TINFIL)#                    To front of communication file   QF00  32
copyfile:(TINFIL,EXRFI,1,1)#           Header record only go to qf61    QF00  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF00  34
readwpkt:(TINFIL,endrecord:,PSIZ6,GETPK,0)# Close file f, from protin   QF00  35
#                                                                       QF00  36
IF(REPORT==no:&IDALIZ==yes:) CALL QF51# Model idealization no s.f.      QF00  37
#                                                                       QF00  38
# STRUCTURE FACTORS WILL BE COMPUTED ON DEMAND                          QF00  39
# --------------------------------------------                          QF00  40
IF(REPORT==yes:)#                      Are they demanded?               QF00  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF00  42
IF(FFT==no:) CALL QF61#                Do struct facts & maybe derivs   QF00  43
ELSE CALL QF66#                        Fetch them from fft file         QF00  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF00  45
ELSE#                                  Must complete file copy          QF00  46
copyfile:(INBDF,SCRBDF,lrrefl:,endrecord:)# Finish off scratch          QF00  47
IF(REPORT==yes:\IDALIZ==yes:)#         Refinement goes on               QF00  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF00  49
L2=LGX+LGY ; L3=L2+LGZ ; NVL=NV+L3#    Find total number of variables   QF00  50
CALL QF71$#                            Solve by conjugate gradient      QF00  51
(QX(MARKM+1),QX(MARKT+3*NVL+1),$#      Sending the storage addresses    QF00  52
QX(MARKT+2*NVL+1),QX(MARKT+NVL+1),$#   By means of calling sequence     QF00  53
QX(MARKV+1),QX(MARKT+1),QX(MARKU+1))#  Address specifications           QF00  54
CALL QF81#                             Update atomic parameters         QF00  55
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF00  56
#                                                                       QF00  57
KILLDV=yes:#                           Shut off all dirivative calcs    QF00  58
IF(REPORT==yes:) CALL QF91#            Report r values                  QF00  59
#                                                                       QF00  60
RETURN#                                                                 QF00  61
END#                                                                    QF00  62
systemheader:(QF01)## Write restraint headings                          QF01   1
####################################################################    QF01   2
#                                                                  #    QF01   3
#                                QF01                              #    QF01   4
#                                                                  #    QF01   5
####################################################################    QF01   6
SUBROUTINE QF01(RESTYP,NRESTY)#        J.m. stewart jun. 1988           QF01   7
#                                                                       QF01   8
include:(AACOMN)#                                                       QF01   9
INTEGER MAXOUT#                        Maximum characters in heading    QF01  10
INTEGER NRESTY#                        No. of characters in restyp      QF01  11
string:(RESTYP,*)#                                                      QF01  12
chardata:(QF01A,-)#                    Page separator characters        QF01  13
chardata:(QF01B, ******                            $#                   QF01  14
RESTRAINT INFORMATION ****** )#                                         QF01  15
datastuff:#                                                             QF01  16
LINRM=10#                              Enough lines to make pretty      QF01  17
MAXOUT=prtcmax:-2#                     Find current o/p line width      QF01  18
movechar:(QF01A,1,CHROT,2,MAXOUT,NQF01A)# A line of minuses             QF01  19
writeline:(1,0,0,1,4)#                                                  QF01  20
movechar:(QF01B,1,CHROT,1,MIN0(NQF01B,MAXOUT),0)#                       QF01  21
movechar:(RESTYP,1,CHROT,9,MIN0(NRESTY,26),0)#                          QF01  22
movechar:(TITLE,40,CHROT,63,MAX0(0,MAXOUT-63),0)#                       QF01  23
writeline:(0,0,0,1,4)#                                                  QF01  24
movechar:(QF01A,1,CHROT,2,MAXOUT,NQF01A)# A line of minuses             QF01  25
writeline:(0,0,0,1,4)#                                                  QF01  26
#                                                                       QF01  27
RETURN#                                                                 QF01  28
END#                                                                    QF01  29
systemheader:(QF05)## Calculate 3x3 determinant                         QF05   1
####################################################################    QF05   2
#                                                                  #    QF05   3
#                                QF05                              #    QF05   4
#                                                                  #    QF05   5
####################################################################    QF05   6
REAL FUNCTION QF05(A)#                 J.m. stewart dec. 1987           QF05   7
#                                                                       QF05   8
#                                                                       QF05   9
REAL A(9)## Elements of the matrix as                                   QF05  10
##           1,1;2,1;3,1;1,2;2,2;3,2;1,3;2,3;3,3                        QF05  11
QF05=A(1)*(A(5)*A(9)-A(8)*A(6))-$#                                      QF05  12
A(4)*(A(2)*A(9)-A(8)*A(3))+$#                                           QF05  13
A(7)*(A(2)*A(6)-A(5)*A(3))#                                             QF05  14
RETURN#                                                                 QF05  15
END#                                                                    QF05  16
systemheader:(QF06)## Cross product                                     QF06   1
####################################################################    QF06   2
#                                                                  #    QF06   3
#                                QF06                              #    QF06   4
#                                                                  #    QF06   5
####################################################################    QF06   6
SUBROUTINE QF06(A,B,C)#                J.m. stewart dec. 1987           QF06   7
#                                                                       QF06   8
REAL A(3),B(3),C(3)## Vector a will be b x c                            QF06   9
A(1)=B(2)*C(3)-B(3)*C(2) ; A(2)=B(3)*C(1)-B(1)*C(3)#                    QF06  10
A(3)=B(1)*C(2)-B(2)*C(1)#                                               QF06  11
RETURN#                                                                 QF06  12
END#                                                                    QF06  13
systemheader:(QF10)## Read instruction input lines                      QF10   1
####################################################################    QF10   2
#                                                                  #    QF10   3
#                                QF10                              #    QF10   4
#                                                                  #    QF10   5
####################################################################    QF10   6
SUBROUTINE QF10#                                                        QF10   7
#                                      J. m. stewart dec 1987           QF10   8
include:(AACOMN)#                                                       QF10   9
include:(QFCOMN)#                                                       QF10  10
#                                                                       QF10  11
INTEGER I,K,J,JP#                      Loop indices                     QF10  12
INTEGER IARC#                          Count archive params             QF10  13
INTEGER NMDS#                          Data set number x 1000           QF10  14
#                                                                       QF10  15
chardata:(QF10A,NCY POP TFS LAG XRF NXR NGE GEO ANO NOA $#              QF10  16
OVA ISO ANI DSN ORX ORY ORZ PCH FFT )# Options list on prolsq line      QF10  17
chardata:(QF10B,FMIN SMIN SMAX SIGM DMAX DMIN )# Reflim options         QF10  18
chardata:(QF10C, PRINT  XXXXXX REFLIM STATS  )# Input lines             QF10  19
chardata:(QF10D,WGTREF WGTTOR WGTDIS WGTB   WGTPLA WGTCHI WGTCON $#     QF10  20
WGTSHF WGTSYM )#                       Input lines continued            QF10  21
chardata:(QF10E,SCALE UOV    SCANIS SOLMOD $#                           QF10  22
DAMPSH XXXXXX XXXXXX RTEST  XXXXXX ARCHIV NOREF  END    )# End input    QF10  23
chardata:(QF11B, ***SUMMARY OF PROLSQ SETUP PARAMETERS***)#             QF10  24
chardata:(QF11C, CONJUGATE GRADIENT CYCLES               )#             QF10  25
chardata:(QF11D, STRUCTURE FACTOR LISTING CONTROL        )#             QF10  26
chardata:(QF11E, PARAMETER SHIFT LISTING CONTROL         )#             QF10  27
chardata:(QF11F, LAGRANGE MULTIPLIER SCALE FACTOR        )#             QF10  28
chardata:(QF11G, REFINEMENT TO FIT DIFFRACTION DATA      )#             QF10  29
chardata:(QF11H, REFINEMENT TO FIT IDEALIZED STRUC.      )#             QF10  30
chardata:(QF11I, ANOMALOUS SCATTERING                    )#             QF10  31
chardata:(QF11J, TEMPERATURE FACTOR TYPE                 )#             QF10  32
chardata:(QF11K,STOR NTOR WCHI ACHI NCHI HBON NHBO DISC PLAN $#         QF10  33
BCUT POPC CTOR MTOR FLIS ALIS ILIS PARC LFIR )#                         QF10  34
chardata:(QF11L,FMIN SMIN SMAX SIGM SAMP )#                             QF10  35
chardata:(QF11M,   OV ISO)#                                             QF10  36
chardata:(QF11N,  IND ISO)#                                             QF10  37
chardata:(QF11O,IND ANISO)#                                             QF10  38
chardata:(QF11P,YES)#                                                   QF10  39
chardata:(QF11Q, NO)#                                                   QF10  40
chardata:(QF11R, REFINE POP. PARAMS NOT EQUAL TO 1.0     )#             QF10  41
chardata:(QF11S, SET ALL ATOM IND ISO TF TO OV VALUE     )#             QF10  42
#                                                                       QF10  43
#                                                                       QF10  44
#                                                                       QF10  45
datastuff:#                                                             QF10  46
PI=2.0*ASIN(1.0) ; TUPI=2.0*PI## Pi to max word accuracy                QF10  47
DEGTOR=TUPI/360.0 ; RTODEG=1.0/DEGTOR ; PISQ8=8.0*PI**2#                QF10  48
#                                                                       QF10  49
#                                                                       QF10  50
#  SET UP ALL LINE IDENTITIES FOR CONTROL OF INPUT                      QF10  51
#  -----------------------------------------------                      QF10  52
#                                                                       QF10  53
NLINEC=1#                                                               QF10  54
movechar:(QF10C,1,INLINE,NLINEC,NQF10C,0) ; NLINEC=NLINEC+NQF10C#       QF10  55
movechar:(QF10D,1,INLINE,NLINEC,NQF10D,0) ; NLINEC=NLINEC+NQF10D#       QF10  56
movechar:(QF10E,1,INLINE,NLINEC,NQF10E,0) ; NLINEC=NLINEC+NQF10E#       QF10  57
NLINEC=NLINEC-1#                       Set inclusive count              QF10  58
#                                                                       QF10  59
#----SET UP DEFAULT CONTROL PROLSQ PARAMETERS                           QF10  60
#    ----------------------------------------                           QF10  61
NCYCCG=50 ; LQ=10 ; REPORT=yes: ; IDALIZ=yes: ; DOPOP=no:#              QF10  62
ANOM=no: ; TFTYPE=0 ; NKILL=0 ; SETISO=no:#                             QF10  63
NAS=0 ; DSNM=1.0 ; NSCL=1 ; NEUT=no: ; NTYP=0 ; FFT=no:#                QF10  64
ITEM=0 ; IFFF=0 ; REJF=2.0 ; LQ=10 ; LGX=0 ; LGY=0 ; LGZ=0#             QF10  65
PNCHIT=no: ; B1ORU2=1#                                                  QF10  66
#                                                                       QF10  67
#----SET UP DEFAULT CONTROL PRINT PARAMETERS                            QF10  68
#    ---------------------------------------                            QF10  69
ITORP=0 ; ICHIP=0 ; IHYDP=0 ; DSCUT=5.0 ; PLCUT=2.00 ; DOUG=10#         QF10  70
DVPCUT=0.1 ; DBCUT=2.0 ; DQCUT=0.25 ; TSCUT=0.1 ; TMCUT=0.1#            QF10  71
LISTF=0 ; LISTA=2 ; LISLOC=99999 ; LISTIT=no:#                          QF10  72
#                                                                       QF10  73
#----SET UP DEFAULT CONTROL REFLIM & STATS PARAMETERS                   QF10  74
#    ----------------------------------------                           QF10  75
FMIN=0.0 ; SMIN=0.0 ; SMAX=1.5 ; SIGMIN=0.0 ; NSAMPL=1#                 QF10  76
NDMIN=7 ; DMIN(1)=5.0 ; DMIN(2)=3.0 ; DMIN(3)=2.5# Finzel's shells      QF10  77
DMIN(4)=2.0 ; DMIN(5)=1.7 ; DMIN(6)=1.5 ; DMIN(7)=1.3#                  QF10  78
#                                                                       QF10  79
#----SET UP DEFAULT CONTROL WGTREF, WGTTOR & WGTDIS PARAMETERS          QF10  80
#    ---------------------------------------------------------          QF10  81
KFWGT=1 ; AFSIG=4.0 ; BFSIG=0.0#       Wgtref parameters                QF10  82
WTSKAL=1.0 ; SIGT1=15.0 ; SIGT2=3.0#   Wgttor                           QF10  83
SIGT3=15.0 ; SIGT4=20.0#                                                QF10  84
WDSKAL=1.0 ; SIGD1=0.03 ; SIGD2=0.04 ; SIGD3=0.05# Wgtdis               QF10  85
SIGD4=0.1 ; SIGD5=0.08 ; SIGD6=0.0 ; SIGD7=0.0#                         QF10  86
#                                                                       QF10  87
#----SET UP DEFAULT CONTROL WGTB, WGTPLA, WGTCHI                        QF10  88
#    WGTCON, WGTSHF & WGTSYM PARAMETERS                                 QF10  89
#    -------------------------------------------                        QF10  90
WBSKAL=1.0 ; SIGB1=1.0 ; SIGB2=1.5 ; SIGB3=1.0# Wgtb                    QF10  91
SIGB4=1.5 ; SIGB5=0.5 ; SIGB6=1.0 ; SIGB7=0.0 ; SIGB8=0.0#              QF10  92
WPSKAL=1.0 ; SIGP=0.02 ; WCSKAL=1.0 ; SIGC=0.15# Wgtpla & wgtchi        QF10  93
WVSKAL=1.0 ; SIGV=0.5 ; DINC(1)=-0.3 ; DINC(2)=0.0# Wgtcon              QF10  94
DINC(3)=-0.2 ; ; DINC(4)=0.0#                                           QF10  95
PDEL=0.2 ; BDEL=3.0 ; QDEL=0.1#        Wgtshf                           QF10  96
SIGSP1=0.05 ; SIGSP2=0.5 ; SIGSP3=2.0#                                  QF10  97
SIGSB1=0.5 ; SIGSB2=1.0 ; SIGSB3=0.0#                                   QF10  98
WSSKAL=1.0#                            Wgtsym                           QF10  99
#                                                                       QF10 100
#----SET UP DEFAULTS FOR F CALC SCALE FACTORS AND OVERALL T.F.          QF10 101
#    ---------------------------------------------------------          QF10 102
TO=5.01 ; DO J=1,64#                                                    QF10 103
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF10 104
SC(J)=1.0 ; SCLIN(J)=no:#                                               QF10 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF10 106
#                                                                       QF10 107
#----SET UP DEFAULT CONTROL SCANIS & SOLMOD PARAMETERS                  QF10 108
#    -------------------------------------------------                  QF10 109
B11=0.0 ; B12=0.0 ; B13=0.0 ; B22=0.0 ; B23=0.0 ; B33=0.0# Scanis       QF10 110
PK=1.0 ; PB=0.0 ; UK=1.0 ; UB=0.0 ; SOLV=0.0# Solmod                    QF10 111
#                                                                       QF10 112
#----SET UP DEFAULT CONTROL DAMPSH PARAMETERS                           QF10 113
#    ----------------------------------------                           QF10 114
#                                                                       QF10 115
JP=0 ; NDAMP=11 ; DO J=1,NDAMP#                                         QF10 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF10 117
DAMP(J)=0.5#                           Parameter shift damping factor   QF10 118
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF10 119
#                                                                       QF10 120
#----SET UP DEFAULT VALUES FOR RTEST INPUT LINE                         QF10 121
#    ------------------------------------------                         QF10 122
#                                                                       QF10 123
IRTEST=no: ; IRTESX=no: ; JABN=1 ; JAQN=1 ; DO J=1,11 ; SHFTK(J)=0.5#   QF10 124
NRJDSK=0 ; NRKDSK=0 ; NSAMPL=100000 ; NSAMPX=0 ;  NSAMPS=0 ; NSAMPY=0#  QF10 125
#                                                                       QF10 126
#----READ ASSORTED CONTROL INFORMATION FROM PROLSQ INPUT LINE           QF10 127
#    --------------------------------------------------------           QF10 128
#                                                                       QF10 129
FOR(K=1;BUFIN(K)<voidflg:;K=K+1)#      Loop over input fields           QF10 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF10 131
stringlim:(K,I,J)#                     Find character string            QF10 132
compchar:(CHRIN,I,QF10A,1,3,4,NQF10A,J)# Search options list            QF10 133
IF(J==0) iquit:(QF1001,K)#             It must be valid                 QF10 134
IF(J==1)#                              Conjugent gradient cycles        QF10 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF10 136
IF(BUFIN(K+1)>0.0)#                                                     QF10 137
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF10 138
NCYCCG=NINT(BUFIN(K+1)) ; K=K+1#       Take users cycles                QF10 139
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF10 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF10 141
ELSE IF(J==2) DOPOP=yes:#              Allow refinement of pop params   QF10 142
ELSE IF(J==3) SETISO=yes:#             Replace all ind tf with b ov     QF10 143
ELSE IF(J==4)#                         Lagrange mult scale              QF10 144
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF10 145
IF(BUFIN(K+1)>0.0) LQ=NINT(BUFIN(K+1)) ; K=K+1#                         QF10 146
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF10 147
ELSE IF(J==5) REPORT=yes:#             Fit diffraction data             QF10 148
ELSE IF(J==6) REPORT=no:#              Do not fit diffraction data      QF10 149
ELSE IF(J==7) IDALIZ=no:#              Do not fit idealized geometry    QF10 150
ELSE IF(J==8) IDALIZ=yes:#             Fit idealized geometry           QF10 151
ELSE IF(J==9) ANOM=yes:#               Apply anomalous dispersion       QF10 152
ELSE IF(J==10) ANOM=no:#               Kill anomalous dispersion        QF10 153
ELSE IF(J==11) TFTYPE=0#               Overall tf                       QF10 154
ELSE IF(J==12) TFTYPE=1#               Individual isotropic tf          QF10 155
ELSE IF(J==13) TFTYPE=2#               Individual anisotropic tf        QF10 156
ELSE IF(J==14)#                        Data set number                  QF10 157
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF10 158
IF(BUFIN(K+1)>0.0) DSNM=BUFIN(K+1) ; K=K+1# Take data set specified     QF10 159
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF10 160
#                                      Origin constraint signals        QF10 161
ELSE IF(J==15) LGX=1#                  Take x constraint                QF10 162
ELSE IF(J==16) LGY=1#                  Take y constraint                QF10 163
ELSE IF(J==17) LGZ=1#                  Take z constraint                QF10 164
ELSE IF (J==18) PNCHIT=yes:#           Set to 'punch' pdb atom params   QF10 165
ELSE IF (J==19) FFT=yes:#              Use fft to calc struct facts     QF10 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF10 167
#                                                                       QF10 168
#-----REPORT OUT RUN PARAMETERS FROM PROLSQ INPUT LINE                  QF10 169
#     ------------------------------------------------                  QF10 170
#                                                                       QF10 171
LINRM=5 ; writeline:(1,QF11B,NQF11B,3,3)# Heading                       QF10 172
ncodefld:(FLOAT(NCYCCG),1,QF11C,400613.,1)#                             QF10 173
writeline:(1,QF11C,NQF11C,3,3)#        Cong grad cycles                 QF10 174
ncodefld:(FLOAT(LQ),1,QF11F,400613.,1)#                                 QF10 175
writeline:(1,QF11F,NQF11F,3,3)#        Lagrange mult scale              QF10 176
IF(REPORT==no:)    movechar:(QF11Q,1,QF11G,38,NQF11Q,0)#                QF10 177
ELSE               movechar:(QF11P,1,QF11G,38,NQF11P,0)#                QF10 178
#                                                                       QF10 179
writeline:(1,QF11G,NQF11G,3,3)#        Ref uses diffraction data        QF10 180
IF(IDALIZ==no:)    movechar:(QF11Q,1,QF11H,38,NQF11Q,0)#                QF10 181
ELSE               movechar:(QF11P,1,QF11H,38,NQF11P,0)#                QF10 182
writeline:(1,QF11H,NQF11H,3,3)#        Ref uses idealization data       QF10 183
IF(DOPOP==no: )    movechar:(QF11Q,1,QF11R,38,NQF11Q,0)#                QF10 184
ELSE               movechar:(QF11P,1,QF11R,38,NQF11P,0)#                QF10 185
writeline:(1,QF11R,NQF11R,3,3)#        Ref pop parms different from 1   QF10 186
IF(SETISO==no: )   movechar:(QF11Q,1,QF11S,38,NQF11Q,0)#                QF10 187
ELSE               movechar:(QF11P,1,QF11S,38,NQF11P,0)#                QF10 188
writeline:(1,QF11S,NQF11S,3,3)#        Set ind iso tfs to overall val   QF10 189
IF(ANOM==no:)      movechar:(QF11Q,1,QF11I,38,NQF11Q,0)#                QF10 190
ELSE               movechar:(QF11P,1,QF11I,38,NQF11P,0)#                QF10 191
writeline:(1,QF11I,NQF11I,3,3)#        Anomalous dispersion             QF10 192
IF(TFTYPE==0)      movechar:(QF11M,1,QF11J,32,NQF11M,0)#                QF10 193
ELSE IF(TFTYPE==1) movechar:(QF11N,1,QF11J,32,NQF11N,0)#                QF10 194
ELSE               movechar:(QF11O,1,QF11J,32,NQF11O,0)#                QF10 195
writeline:(1,QF11J,NQF11J,3,3)#        Tf type                          QF10 196
#                                                                       QF10 197
#----SET UP DEFAULTS FOR ARCHIV INPUT LINE AND CONTENTS OF LRREFL:      QF10 198
#    DEFAULTS ARE FC, A, B, A DISP, B DISP,A EXT, B EXT, PHASE, AND     QF10 199
#    DISPERSION CORRECTED F RELATIVE.                                   QF10 200
#    -------------------------------------------------------------      QF10 201
NMDS=NINT(1000.0*DSNM)#                Scale data set number            QF10 202
DO I=1,7;  ARCH(I)=-FLOAT(NMDS+I+799)# Generate archive list            QF10 203
ARCH(8)=-FLOAT(NMDS+700)#              Generate archive list, phase     QF10 204
ARCH(9)=-FLOAT(NMDS+701)#              Archive ad-correct frel          QF10 205
IARC=0;   ITEM=9#                      Reset archive parameters         QF10 206
#                                                                       QF10 207
#-----READ INPUT LINES FOR MISCELLANEOUS DATA                           QF10 208
#     ---------------------------------------                           QF10 209
#                                                                       QF10 210
REPEAT#                                                                 QF10 211
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF10 212
readline:(INLINE,NLINEC)#                                               QF10 213
IF(LINID>22) BREAK#                    Qf10 lines treated, move on      QF10 214
ELSE IF(LINID==1)#                     Print input line encountered     QF10 215
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF10 216
#                                                                       QF10 217
K=0#                                   Set to scan over print line      QF10 218
#                                                                       QF10 219
REPEAT#                                Loop over input fields           QF10 220
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF10 221
K=K+1 ; IF(BUFIN(K)>=voidflg:) BREAK#  Quit at first non-alpha field    QF10 222
stringlim:(K,I,J)#                     Find character string            QF10 223
compchar:(CHRIN,I,QF11K,1,3,5,NQF11K,J)# Search options list            QF10 224
IF(J==0) iquit:(QF1002,K)#             It must be valid                 QF10 225
IF(J==1) ITORP=1#                      Print torsion angles             QF10 226
ELSE IF(J==2) ITORP=0#                                                  QF10 227
ELSE IF(J==3) ICHIP=1#                 Print worst chiral stats         QF10 228
ELSE IF(J==4) ICHIP=2#                 Print all chiral stats           QF10 229
ELSE IF(J==5) ICHIP=0#                                                  QF10 230
ELSE IF(J==6) IHYDP=1#                 Print all possible h bonds       QF10 231
ELSE IF(J==7) IHYDP=0#                                                  QF10 232
ELSE IF(J==8)#                         Print restrained distances       QF10 233
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF10 234
IF(BUFIN(K+1)>0.0) DSCUT=BUFIN(K+1) ; K=K+1#                            QF10 235
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF10 236
ELSE IF(J==9)#                         Print restrained planar groups   QF10 237
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF10 238
IF(BUFIN(K+1)>0.0) PLCUT=BUFIN(K+1) ; K=K+1#                            QF10 239
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF10 240
ELSE IF(J==10)#                        Print t.f. parameter shifts      QF10 241
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF10 242
IF(BUFIN(K+1)>0.0) DBCUT=BUFIN(K+1) ; K=K+1#                            QF10 243
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF10 244
ELSE IF(J==11)#                        Print pop param parameter shif   QF10 245
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF10 246
IF(BUFIN(K+1)>(-1.0)) DQCUT=BUFIN(K+1) ; K=K+1#                         QF10 247
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF10 248
ELSE IF(J==12)#                        Print torsion contacts           QF10 249
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF10 250
IF(BUFIN(K+1)>0.0) TSCUT=BUFIN(K+1) ; K=K+1#                            QF10 251
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF10 252
ELSE IF(J==13)#                        Print multiple torsion contact   QF10 253
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF10 254
IF(BUFIN(K+1)>0.0) TMCUT=BUFIN(K+1) ; K=K+1#                            QF10 255
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF10 256
ELSE IF(J==14)#                        Structure factor listing         QF10 257
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QF10 258
IF(BUFIN(K+1)>0.0) LISTF=NINT(BUFIN(K+1)) ; K=K+1#                      QF10 259
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QF10 260
ELSE IF(J==15)#                        Parameter shifts listing         QF10 261
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QF10 262
IF(BUFIN(K+1)>0.0) LISTA=NINT(BUFIN(K+1)) ; K=K+1#                      QF10 263
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QF10 264
ELSE IF(J==16)#                        Control of input atom listing    QF10 265
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QF10 266
LISTIT=yes: ; IF(BUFIN(K+1)>0.0)#      Turn on listing                  QF10 267
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QF10 268
LISLOC=NINT(BUFIN(K+1)) ; K=K+1#       Limit list if user desires       QF10 269
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QF10 270
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QF10 271
ELSE IF(J==17)#                        Print x,y,z parameter shifts     QF10 272
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QF10 273
IF(BUFIN(K+1)>0.0) DVPCUT=BUFIN(K+1) ; K=K+1#                           QF10 274
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QF10 275
ELSE IF(J==18)#                        Print 'doug' reflections         QF10 276
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QF10 277
IF(BUFIN(K+1)>=0.0) DOUG=NINT(BUFIN(K+1)) ; K=K+1#                      QF10 278
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QF10 279
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF10 280
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF10 281
ELSE IF(LINID==3)#                     Reflim input line encountered    QF10 282
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QF10 283
K=0#                                   Set to scan over reflim line     QF10 284
#                                                                       QF10 285
REPEAT#                                Loop over input fields           QF10 286
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QF10 287
K=K+1 ; IF(BUFIN(K)>=voidflg:) BREAK#  Quit at first non-alpha field    QF10 288
stringlim:(K,I,J)#                     Find character string            QF10 289
compchar:(CHRIN,I,QF10B,1,4,5,NQF10B,J)# Search options list            QF10 290
IF(J==0) iquit:(QF1004,K)#             It must be valid                 QF10 291
IF(J==1)#                              Limit on f minimum               QF10 292
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QF10 293
IF(BUFIN(K+1)>0.0)FMIN=BUFIN(K+1) ; K=K+1# Take users f minimum         QF10 294
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QF10 295
ELSE IF(J==2)#                         Sin(theta)/lambda min            QF10 296
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QF10 297
IF(BUFIN(K+1)>0.0) SMIN=BUFIN(K+1) ; K=K+1#                             QF10 298
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QF10 299
ELSE IF(J==3)#                         Sin(theta)/lambda max            QF10 300
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 QF10 301
IF(BUFIN(K+1)>0.0) SMAX=BUFIN(K+1) ; K=K+1#                             QF10 302
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 QF10 303
ELSE IF(J==4)#                         Less-than setter                 QF10 304
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 QF10 305
IF(BUFIN(K+1)>0.0) SIGMIN=BUFIN(K+1) ; K=K+1#                           QF10 306
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 QF10 307
ELSE IF(J==5)#                         D maximum setter (smin)          QF10 308
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 QF10 309
IF(BUFIN(K+1)>0.0) SMIN=0.5/BUFIN(K+1) ; K=K+1#                         QF10 310
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 QF10 311
ELSE IF(J==6)#                         D minimum setter (smax)          QF10 312
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 QF10 313
IF(BUFIN(K+1)>0.0) SMAX=0.5/BUFIN(K+1) ; K=K+1#                         QF10 314
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 QF10 315
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QF10 316
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QF10 317
ELSE IF(LINID==4)#                     Stats input line encountered     QF10 318
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 QF10 319
NDMIN=0#                               Count how many shells            QF10 320
FOR(J=1;J<=7;J=J+1)#                                                    QF10 321
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 QF10 322
ifvo:(BUFIN(J)) BREAK ; NDMIN=NDMIN+1# Count and take up to 7 limits    QF10 323
DMIN(J)=AMAX1(0.01,BUFIN(J))#          Take d spacing mins for stats    QF10 324
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 QF10 325
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 QF10 326
ELSE IF(LINID==5)#                     Wgtref input line encountered    QF10 327
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 QF10 328
IF(BUFIN(1)>0.5&BUFIN(1)<5.1) KFWGT=NINT(BUFIN(1))# Sf weight scheme    QF10 329
IF(BUFIN(2)>0.0) AFSIG=BUFIN(2)#       Indep. a term for sf weights     QF10 330
IF(BUFIN(3)>-5000.0) BFSIG=BUFIN(3)#   Indep. b term for sf weights     QF10 331
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 QF10 332
ELSE IF(LINID==6)#                     Wgttor input line encountered    QF10 333
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 QF10 334
IF(BUFIN(1)>0.0&BUFIN(1)<1.1) WTSKAL=BUFIN(1)# Wgt torsn ang restrnts   QF10 335
IF(BUFIN(2)>0.0) SIGT1=BUFIN(2);IF(BUFIN(3)>0.0) SIGT2=BUFIN(3)#        QF10 336
IF(BUFIN(4)>0.0) SIGT3=BUFIN(4);IF(BUFIN(5)>0.0) SIGT4=BUFIN(5)#        QF10 337
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 QF10 338
ELSE IF(LINID==7)#                     Wgtdis input line encountered    QF10 339
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 QF10 340
IF(BUFIN(1)>0.0&BUFIN(1)<1.1) WDSKAL=BUFIN(1)# Distance restraints      QF10 341
IF(BUFIN(2)>0.0) SIGD1=BUFIN(2);IF(BUFIN(3)>0.0) SIGD2=BUFIN(3)#        QF10 342
IF(BUFIN(4)>0.0) SIGD3=BUFIN(4);IF(BUFIN(5)>0.0) SIGD4=BUFIN(5)#        QF10 343
IF(BUFIN(6)>0.0) SIGD5=BUFIN(6);IF(BUFIN(7)>0.0) SIGD6=BUFIN(7)#        QF10 344
IF(BUFIN(8)>0.0) SIGD7=BUFIN(8)#                                        QF10 345
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 QF10 346
ELSE IF(LINID==8)#                     Wgtb input line encountered      QF10 347
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 QF10 348
IF(BUFIN(1)>0.0&BUFIN(1)<1.1) WBSKAL=BUFIN(1)# Temp fact restraints     QF10 349
IF(BUFIN(2)>0.0) SIGB1=BUFIN(2);IF(BUFIN(3)>0.0) SIGB2=BUFIN(3)#        QF10 350
IF(BUFIN(4)>0.0) SIGB3=BUFIN(4);IF(BUFIN(5)>0.0) SIGB4=BUFIN(5)#        QF10 351
IF(BUFIN(6)>0.0) SIGB5=BUFIN(6);IF(BUFIN(7)>0.0) SIGB6=BUFIN(7)#        QF10 352
IF(BUFIN(8)>0.0) SIGB7=BUFIN(8);IF(BUFIN(9)>0.0) SIGB8=BUFIN(9)#        QF10 353
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 QF10 354
ELSE IF(LINID==9)#                     Wgtpla input line encountered    QF10 355
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 QF10 356
IF(BUFIN(1)>0.0&BUFIN(1)<1.1) WPSKAL=BUFIN(1)# Plane restraints         QF10 357
IF(BUFIN(2)>0.0) SIGP=BUFIN(2)#                                         QF10 358
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 QF10 359
ELSE IF(LINID==10)#                    Wgtchi input line encountered    QF10 360
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 QF10 361
IF(BUFIN(1)>0.0&BUFIN(1)<1.1) WCSKAL=BUFIN(1)# Chi restraints           QF10 362
IF(BUFIN(2)>0.0) SIGC=BUFIN(2)#                                         QF10 363
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 QF10 364
ELSE IF(LINID==11)#                    Wgtcon input line encountered    QF10 365
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 QF10 366
IF(BUFIN(1)>0.0&BUFIN(1)<1.1) WVSKAL=BUFIN(1)# V'der waals restraints   QF10 367
IF(BUFIN(2)>0.0) SIGV=BUFIN(2)#                                         QF10 368
IF(BUFIN(3)>-1.5&BUFIN(3)<=0.0) DINC(1)=BUFIN(3)# Get factors to be     QF10 369
IF(BUFIN(4)>-1.50&BUFIN(4)<=0.0) DINC(2)=BUFIN(4)# Added to dvdw whic   QF10 370
IF(BUFIN(5)>-1.50&BUFIN(5)<=0.0) DINC(3)=BUFIN(5)# Is read from proti   QF10 371
IF(BUFIN(6)>-1.50&BUFIN(6)<=0.0) DINC(4)=BUFIN(6)# File in qf36         QF10 372
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 QF10 373
ELSE IF(LINID==12)#                    Wgtshf input line encountered    QF10 374
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 QF10 375
IF(BUFIN(1)>0.0) PDEL=BUFIN(1)#        Set atom param shift weights     QF10 376
IF(BUFIN(2)>0.0) BDEL=BUFIN(2);IF(BUFIN(3)>0.0) QDEL=BUFIN(3)#          QF10 377
IF(BUFIN(4)>0.0) SIGSP1=BUFIN(4);IF(BUFIN(5)>0.0) SIGSP2=BUFIN(5)#      QF10 378
IF(BUFIN(6)>0.0) SIGSP3=BUFIN(6);IF(BUFIN(7)>0.0) SIGSB1=BUFIN(7)#      QF10 379
IF(BUFIN(8)>0.0) SIGSB2=BUFIN(8);IF(BUFIN(9)>0.0) SIGSB3=BUFIN(9)#      QF10 380
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 QF10 381
ELSE IF(LINID==13)#                    Wgtsym input line encountered    QF10 382
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 QF10 383
IF(BUFIN(1)>0.0&BUFIN(1)<1.1) WSSKAL=BUFIN(1)# Symmetry restraints      QF10 384
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 QF10 385
ELSE IF(LINID==14)#                    Scale input line encountered     QF10 386
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 QF10 387
#    THE SC ARRAY CONTAINS F(CALC) SCALE FACTORS-MUST CONVERT XTAL ONES QF10 388
I=1#                                   Default scale group              QF10 389
IF(BUFIN(2)>=1.0&BUFIN(2)<=64.0) I=NINT(BUFIN(2))# Or take              QF10 390
IF(BUFIN(1)>0.0)#                      Convert f(rel) scale factor      QF10 391
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 QF10 392
SC(I)=1.0/BUFIN(1) ; SCLIN(I)=yes:#    Take, convert, and remember it   QF10 393
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 QF10 394
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 QF10 395
ELSE IF(LINID==15)#                    Bov input line encountered       QF10 396
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 QF10 397
#                                                                       QF10 398
IF(BUFIN(1)>0.2&BUFIN(1)<40.0) TO=BUFIN(1)# Take overall b              QF10 399
ELSE IF(BUFIN(1)<=0.2&BUFIN(1)>=0.0) TO=78.9568*BUFIN(1)# Convert u     QF10 400
#                                                                       QF10 401
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 QF10 402
ELSE IF(LINID==16)#                    Scanis input line encountered    QF10 403
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 QF10 404
IF(BUFIN(1)>0.0) B11=BUFIN(1) ; IF(BUFIN(2)>(-10.0)) B12=BUFIN(2)#      QF10 405
IF(BUFIN(4)>0.0) B22=BUFIN(4) ; IF(BUFIN(3)>(-10.0)) B13=BUFIN(3)#      QF10 406
IF(BUFIN(6)>0.0) B33=BUFIN(6) ; IF(BUFIN(5)>(-10.0)) B23=BUFIN(5)#      QF10 407
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 QF10 408
ELSE IF(LINID==17)#                    Solmod input line encountered    QF10 409
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 QF10 410
IF(BUFIN(1)>0.0) PK=BUFIN(1) ; IF(BUFIN(2)>(-10.0)) PB=BUFIN(2)#        QF10 411
IF(BUFIN(3)>0.0) UK=BUFIN(3) ; IF(BUFIN(4)>(-10.0)) UB=BUFIN(4)#        QF10 412
IF(BUFIN(5)>0.0) SOLV=BUFIN(5) ; SOLMOD=yes:#                           QF10 413
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 QF10 414
ELSE IF(LINID==18)#                    Dampsh input line encountered    QF10 415
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 QF10 416
I=0 ; REPEAT#                          Loop till no more damping fact   QF10 417
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 QF10 418
I=I+1 ; IF(BUFIN(I)<=0.0\JP>=NDAMP) BREAK#                              QF10 419
JP=JP+1#                                                                QF10 420
DAMP(JP)=AMAX1(0.0,AMIN1(BUFIN(I),4.0))# Accept the param damping fac   QF10 421
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 QF10 422
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 QF10 423
ELSE IF(LINID==21)#                    Rtest input line encountered     QF10 424
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 QF10 425
IRTEST=yes:#                           Say yes to r testing             QF10 426
NSAMPL=NINT(AMIN1(1000.0,AMAX1(BUFIN(1),1.0)))# Set sampling frequenc   QF10 427
NSAMPX=NINT(AMIN1(1000.0,AMAX1(BUFIN(2),0.0)))# Set sampling frequenc   QF10 428
NSAMPS=NINT(AMIN1(1000.0,AMAX1(BUFIN(3),0.0)))# Set sampling start      QF10 429
NSAMPY=NINT(AMIN1(1000.0,AMAX1(BUFIN(4),0.0)))# Set sampling start      QF10 430
IF(NSAMPX>0) IRTESX=yes:#              Also do exclusion r test         QF10 431
JAQN=NINT(AMIN1(7.0,AMAX1(BUFIN(5),1.0)))# Set number of coord. shift   QF10 432
JABN=NINT(AMIN1(4.0,AMAX1(BUFIN(6),1.0)))# Set number of t.f. shifts    QF10 433
FOR(J=1;J<=JAQN+JABN;J=J+1)#           Scan over input fields           QF10 434
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 QF10 435
IF(BUFIN(J+6)>0.05&BUFIN(J+6)<5.0)#    Take in shift dampers to use     QF10 436
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 QF10 437
SHFTK(J)=BUFIN(J+6)#                   Save damper supplied             QF10 438
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 QF10 439
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 QF10 440
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 QF10 441
ELSE IF(LINID==23)#                    Archiv input line encountered    QF10 442
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 QF10 443
IARC=1#                                Set archive ip flag              QF10 444
DO J=1,30#                             Loop over input fields           QF10 445
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 QF10 446
ifvo:(BUFIN(J)) BREAK#                 Exit after last idnum            QF10 447
FOR(I=1;I<=ITEM;I=I+1)#                Loop over archive list           QF10 448
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 QF10 449
ifeq:(BUFIN(J),ARCH(I)) BREAK#         Exit if delete on list           QF10 450
ifne:(BUFIN(J),(-ARCH(I))) NEXT#       Exit if not reverse              QF10 451
ARCH(I)=-ARCH(I)#                      Change delete to add             QF10 452
BREAK#                                 Exit after update                QF10 453
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 QF10 454
IF((I<=ITEM)\(BUFIN(J)>0.)) NEXT#      Set if preset or illegal         QF10 455
ITEM=ITEM+1#                           Incr archive list                QF10 456
ARCH(ITEM)=BUFIN(J)#                   Add delete to archive            QF10 457
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 QF10 458
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 QF10 459
#                                                                       QF10 460
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF10 461
IF(IARC==0)#                           Test if archive input            QF10 462
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 QF10 463
ARCH(1)=-ARCH(1);  ARCH(8)=-ARCH(8)#   Default fc & phase add items     QF10 464
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 QF10 465
#                                                                       QF10 466
ncodefld:(FLOAT(LISTF),1,QF11D,400613.,1)#                              QF10 467
writeline:(1,QF11D,NQF11D,3,3)#        Sf listing control               QF10 468
ncodefld:(FLOAT(LISTA),1,QF11E,400613.,1)#                              QF10 469
writeline:(1,QF11E,NQF11E,3,3)#        Param shift listing              QF10 470
#                                                                       QF10 471
RETURN#                                                                 QF10 472
END#                                                                    QF10 473
systemheader:(QF11)## Read bdf through lrsymm:                          QF11   1
####################################################################    QF11   2
#                                                                  #    QF11   3
#                                QF11                              #    QF11   4
#                                                                  #    QF11   5
####################################################################    QF11   6
SUBROUTINE QF11#                       J.m. stewart october 1987        QF11   7
#                                                                       QF11   8
#-----BASED UPON PROFFT BY BARRY FINZEL                                 QF11   9
#                                                                       QF11  10
include:(AACOMN)#                                                       QF11  11
include:(QFCOMN)#                                                       QF11  12
#                                                                       QF11  13
INTEGER DISP#                          Dispersion factor signal         QF11  14
INTEGER I,IS,J,J2,K,L,LPAK#            Loop indices                     QF11  15
INTEGER ICNT#                                                           QF11  16
INTEGER ISCF#                                                           QF11  17
INTEGER LTYP#                          Lattice type code                QF11  18
INTEGER NROT,NSYMOP#                   No. rotation matrices & symops   QF11  19
INTEGER NRSZ#                                                           QF11  20
REAL SINAR,SINBR#                      Sine alpha* & beta*              QF11  21
REAL SG#                               Sine of gamma                    QF11  22
REAL Z(3,3),ZI(3,3)## Temporary matrices                                QF11  23
REAL SCP(64)## Scale factor pointers                                    QF11  24
INTEGER PSIZ,IP,IPO,KEY(4),IWNT(10),IREL(11)## Bdf i/o control          QF11  25
datastuff:#                                                             QF11  26
#                                                                       QF11  27
#    SET UP STORAGE TO READ AND WRITE BINARY DATA FILES                 QF11  28
#    --------------------------------------------------                 QF11  29
#  FILE A IS INPUT BDF, FILE B IS OUTPUT BDF, FILE E IS USED AS A       QF11  30
#  SCRATCH BDF COPY OF A FOR REFLECTION CALCULATION RESULTS.  ONCE THE  QF11  31
#  NEW ATOMIC PARAMETERS ARE KNOWN THEY ARE WRITTEN TO FILE B AND FILE  QF11  32
#  IS COPIED TO FILE B TO GIVE AN UPDATED OUTPUT BDF. FILE F IS CONTRAI QF11  33
#  FILE FROM PROTIN AND AT THE END, COUNTS OF RESTRAINTS FROM PROTIN FO QF11  34
#  SETTING UP ARRAYS, FILE H IS USED TO SCRATCH A SUBSET OF REFLECTIONS QF11  35
#  FOR A SAMPLE R VALUE REPORT AND FILE G FOR A SUBSET OF EXCLUDED      QF11  36
#  REFLECTIONS WHICH ARE READ AND REPORTED FROM QF92.                   QF11  37
#                                                                       QF11  38
IOMARK(1)=QXSTR; INBDF=1#              Set up filea input bdf           QF11  39
IOMARK(2)=IOMARK(1)+bdfbuf: ; OUTBDF=2# Set up fileb output bdf         QF11  40
IOMARK(5)=IOMARK(2)+bdfbuf: ; SCRBDF=5# Set up filee scratch bdf        QF11  41
FILEXT(IOUNIT(5))='XX3'#               File e scratch of reflections    QF11  42
IOMARK(6)=IOMARK(5)+bdfbuf: ; TINFIL=6# Set up filef for protin stuff   QF11  43
J=IOMARK(6)+bdfbuf:#                   Anticipate next mark             QF11  44
FILEXT(IOUNIT(6))='PRT'#               Spec file extension for protin   QF11  45
IF(IRTEST==yes:)#                      Doing an r survey?               QF11  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF11  47
IOMARK(8)=J ; RFILE=8#                 Set up file h i/o buffer         QF11  48
J=J+bdfbuf:#                           Advance the mark again           QF11  49
FILEXT(IOUNIT(8))='XX1'#               File extension for r survey      QF11  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF11  51
IF(IRTESX==yes:)#                      Doing an exclusionary r survey   QF11  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF11  53
IOMARK(7)=J ; EXRFI=7#                 Set up file g i/o buffer         QF11  54
J=J+bdfbuf:#                           Advance the mark again           QF11  55
FILEXT(IOUNIT(7))='XX2'#               File extension excluded refs     QF11  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF11  57
MARK2=J#                               Find where buffers end           QF11  58
incrqx:(I,MARK2,QF1104)#                                                QF11  59
#                                                                       QF11  60
#----SET UP I/O PARAMETERS FOR CONTROL OF COMMUNICATIONS FROM PROTIN    QF11  61
#    ---------------------------------------------------------------    QF11  62
#                                                                       QF11  63
# THE CELL, SYMMETRY AND ATOMIC COORDINATES ARE READ FROM FILE A.       QF11  64
# THE RESTRAINT INFORMATION IS READ FROM FILE F AND THE COUNTS          QF11  65
# OF ALL THE VARIOUS RESTRAINTS ARE FROM THE END OF FILE F.             QF11  66
# THE LOGICAL RECORDS OF ALL BUT THE SPECIAL SYMMETRY RESTRAINTS        QF11  67
# ARE STRAIGHTFORWARD PACKETS. THE RECORDS WHICH ARE READ HERE ARE      QF11  68
# WRITTEN BY SUBROUTINES QN06 THROUGH QN10. THE WRITES FOR THE          QF11  69
# SPECIAL SYMMETRY WERE DONE FROM QN66 ; FOR ANISO T.F. IN QN68.        QF11  70
#                                                 Read in               QF11  71
LRDIS=31## Set logical record no.# distances         QF32               QF11  72
LRPLA=32## Set logical record no.# planar groups     QF33               QF11  73
LRCHI=33## Set logical record no.# chiral centers    QF35               QF11  74
LRVDW=34## Set logical record no.# vdWaals distances QF36               QF11  75
LRTOR=35## Set logical record no.# torsion angles    QF37               QF11  76
LRSYM=36## Set logical record no.# special symmetry  QF39               QF11  77
LRANI=37## Set logical record no.# aniso t.f.        QF45               QF11  78
#                                                                       QF11  79
#    TAKE IN THE COUNTS OF RESTRAINTS PLACED ON FILE F BY PROTIN        QF11  80
#    -----------------------------------------------------------        QF11  81
#                                                                       QF11  82
readwpkt:(TINFIL,41,PSIZ,IP,0)#        Read communication file          QF11  83
NATQN=NINT(QX(IP+1))#                  Get no. of atoms as a checksum   QF11  84
NDIS=NINT(QX(IP+2))#                   Restraints on distances          QF11  85
NPLN=NINT(QX(IP+3))#                   Restraints on planes             QF11  86
NCHR=NINT(QX(IP+4))#                   Restraints on chiral cntrs       QF11  87
NVDW=NINT(QX(IP+5))#                   Restraints on vdwaals dists      QF11  88
NTOR=NINT(QX(IP+7))#                   Restraints on torsion angles     QF11  89
NSYM(1)=NINT(QX(IP+8))#                Restraints on special symmetry   QF11  90
NSYM(2)=NINT(QX(IP+9))#                Restraints on special symmetry   QF11  91
NAXES=NINT(QX(IP+10))#                 Restraints on aniso temp. fact   QF11  92
NOCC=NINT(QX(IP+11))#                  Restraints on variable occupan   QF11  93
IF(DOPOP==no:) NOCC=0#                 No pop param unless explicit     QF11  94
NACIDS=0 ; REPEAT#                     Get in residue names and synon   QF11  95
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF11  96
readwpkt:(TINFIL,42,PSIZ,IP,0)#        Each pkt has one residue         QF11  97
IF(IP<=0) BREAK#                       Quit when all read               QF11  98
movertoc:(QX(IP+1),1,NAMES,4*NACIDS+1,4,0)# Get name                    QF11  99
NACIDS=NACIDS+1 ; movertoc:(QX(IP+1),5,MCOD,NACIDS,1,1,0)# & synonym    QF11 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF11 101
rewindbdf:(TINFIL)#                    ,endrecord:,psiz,ip,0)# finish   QF11 102
#                                                                       QF11 103
#    BEGIN READING OF INPUT BINARY DATA FILE; CELL DIMENSIONS FIRST     QF11 104
#    --------------------------------------------------------------     QF11 105
#                                                                       QF11 106
copyfile:(INBDF,SCRBDF,1,decr:(lrcell:))# Copy history to scratch       QF11 107
FOR(K=1;;K=K+1)#                       Loop over lrcell packets         QF11 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF11 109
readwpkt:(INBDF,lrcell:,PSIZ,IP,0)#    Read in cell record              QF11 110
IF(IP<=0) BREAK#                       Exit after last record           QF11 111
writepkt:(SCRBDF,lrcell:,PSIZ,IPO,0)#  Write cell record                QF11 112
movereal:(QX,IP+1,QX,IPO+1,PSIZ,0)#    Copy it across to output buf     QF11 113
IF(K==1)#                              Direct cell constants?           QF11 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF11 115
AEDGE=QX(IP+1) ; BEDGE=QX(IP+2) ; CEDGE=QX(IP+3)# Get a, b , and c      QF11 116
CA=QX(IP+4) ; CB=QX(IP+5) ; CG=QX(IP+6)# Get cosines                    QF11 117
AANGL=360.*QX(IP+7) ; BANGL=360.*QX(IP+8) ; GANGL=360.*QX(IP+9)#        QF11 118
#                                                                       QF11 119
#    DETERMINE ORTHOGONALIZATION MATRIX                                 QF11 120
#    ----------------------------------                                 QF11 121
SG=SQRT(1.0-CG**2)#                    Sine of gamma                    QF11 122
ORXX=AEDGE ; ORXY=BEDGE*CG ;ORXZ=CEDGE*CB ; ORYY=BEDGE*SG#              QF11 123
ORYZ=CEDGE*(CA-CB*CG)/SG#                                               QF11 124
ORZZ=CEDGE*SQRT(1.-CA**2-CB**2-CG**2+2.*CA*CB*CG)/SG#                   QF11 125
G(1,1)=ORXX ; G(1,2)=ORXY ; G(1,3)=ORXZ; G(2,1)=0.0# Fract to orth      QF11 126
G(2,2)=ORYY ; G(2,3)=ORYZ ; G(3,1)=0.0 ; G(3,2)=0.0; G(3,3)=ORZZ#       QF11 127
GT(1,1)=ORXX; GT(1,2)=0.0 ; GT(1,3)=0.0# Fract to orth transpose        QF11 128
GT(2,1)=ORXY; GT(2,2)=ORYY; GT(2,3)=0.0#                                QF11 129
GT(3,1)=ORXZ; GT(3,2)=ORYZ; GT(3,3)=ORZZ#                               QF11 130
#                                                                       QF11 131
#    DETERMINE DEORTHOGONALIZATION MATRIX                               QF11 132
#    ------------------------------------                               QF11 133
OIXX=1.0/ORXX ; OIXY=-ORXY/(ORXX*ORYY)#                                 QF11 134
OIXZ=(ORXY*ORYZ-ORYY*ORXZ)/(ORXX*ORYY*ORZZ)#                            QF11 135
OIYY=1.0/ORYY ; OIYZ=-ORYZ/(ORYY*ORZZ) ; OIZZ=1.0/ORZZ#                 QF11 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF11 137
ELSE IF(K==3)#                         Reciprocal cell constants?       QF11 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF11 139
ASTAR=QX(IP+1) ; BSTAR=QX(IP+2) ; CSTAR=QX(IP+3)# Get a*, b*, & c*      QF11 140
COSAR=QX(IP+4) ; COSBR=QX(IP+5) ; COSGR=QX(IP+6)# Get cosines           QF11 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF11 142
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF11 143
#                                                                       QF11 144
copyfile:(INBDF,SCRBDF,incr:(lrcell:),decr:(lrsymm:))#                  QF11 145
#                                                                       QF11 146
#   EXTRACT SYMMETRY INFORMATION (LRSYMM)                               QF11 147
#   ------------------------------------                                QF11 148
#                                                                       QF11 149
readwpkt:(INBDF,lrsymm:,PSIZ,IP,0)#    Read first packet of symops      QF11 150
writepkt:(SCRBDF,lrsymm:,PSIZ,IPO,0)#  Write symmetry record            QF11 151
movereal:(QX,IP+1,QX,IPO+1,PSIZ,0)#    Copy it across to output buf     QF11 152
LTYP=NINT(QX(IP+1))#                   Get out lattice type             QF11 153
ICNT=NINT(QX(IP+2))#                   Get out centro flag (nc=1)       QF11 154
NS=NINT(QX(IP+3)) ; NSYMOP=0#          Get out total symop count        QF11 155
NROT=NINT(QX(IP+4))#                   Extract number of matrices       QF11 156
NRSZ=NINT(QX(IP+5))#                   Extract no. same pattern zer     QF11 157
LTYP=LTYP-(1-ICNT)*7#                  Reduce ltyp to modulo 7          QF11 158
REPEAT#                                Loop over symop packets          QF11 159
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF11 160
readwpkt:(INBDF,lrsymm:,PSIZ,IP,0)#    Point to next packet             QF11 161
IF(IP<=0) BREAK#                       Exit after last packet           QF11 162
writepkt:(SCRBDF,lrsymm:,PSIZ,IPO,0)#  Write symmetry record            QF11 163
movereal:(QX,IP+1,QX,IPO+1,PSIZ,0)#    Copy it across to output buf     QF11 164
NSYMOP=NSYMOP+1 ; L=IP#                Count up the symops as well      QF11 165
DO J=1,3#                              Loop over rows                   QF11 166
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF11 167
DO I=1,3#                              Loop over columns                QF11 168
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF11 169
L=L+1 ; S(I,J,NSYMOP)=QX(L)#           Store the rotation of symop      QF11 170
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF11 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF11 172
DO I=1,3#                              Loop over vector                 QF11 173
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF11 174
L=L+1 ; T(I,NSYMOP)=QX(L)#             Save the components              QF11 175
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF11 176
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF11 177
#                                                                       QF11 178
#    THE FOLLOWING STEPS ARE FROM PROLSQ SUBROUTINE SYMMIN              QF11 179
#    -----------------------------------------------------              QF11 180
#                                                                       QF11 181
SINAR=SQRT(1.0-COSAR**2) ; SINBR=SQRT(1.0-COSBR**2)# Get sines          QF11 182
#                                                                       QF11 183
#    ORTHOGONALIZATION TRANSFORMATION IN REAL SPACE                     QF11 184
#    ----------------------------------------------                     QF11 185
Z(1,1)=1.0 ; Z(1,2)=CG ; Z(1,3)=CB ; Z(2,1)=0.0#                        QF11 186
Z(2,2)=SG ; Z(2,3)=-COSAR*SQRT(1.0-CB**2) ; Z(3,1)=0.0#                 QF11 187
Z(3,2)=0.0 ; Z(3,3)=SINAR*SQRT(1.0-CB**2)#                              QF11 188
#                                                                       QF11 189
#    DEORTHOGONALIZATION TRANSFORMATION:  Z-INVERSE                     QF11 190
#    ----------------------------------------------                     QF11 191
ZI(1,1)=1.0 ; ZI(1,2)=-Z(1,2)/Z(2,2)#                                   QF11 192
ZI(1,3)=(Z(1,2)*Z(2,3)-Z(1,3)*Z(2,2))/(Z(2,2)*Z(3,3))#                  QF11 193
ZI(2,1)=0.0 ; ZI(2,2)=1.0/Z(2,2) ; ZI(2,3)=-Z(2,3)/(Z(2,2)*Z(3,3))#     QF11 194
ZI(3,1)=0.0 ; ZI(3,2)=0.0 ; ZI(3,3)=1.0/Z(3,3)#                         QF11 195
DO IS=1,NS#                            Matrix product of z*s*z-invers   QF11 196
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF11 197
DO I=1,3#                                                               QF11 198
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF11 199
DO J=1,3#                                                               QF11 200
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF11 201
ASI(I,J,IS)=0.0#                                                        QF11 202
DO K=1,3#                                                               QF11 203
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF11 204
DO L=1,3;ASI(I,J,IS) = ASI(I,J,IS) + Z(I,K)*S(K,L,IS)*ZI(L,J)#          QF11 205
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF11 206
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF11 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF11 208
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF11 209
#                                                                       QF11 210
#    ORTHOGONALIZATION TRANSFORMATION FOR RECIPROCAL LATTICE VECTORS    QF11 211
#    ---------------------------------------------------------------    QF11 212
#                                                                       QF11 213
QXH=ASTAR*SINBR*SG ; QYH=-ASTAR*SINBR*CG ; QYK=BSTAR*SINAR#             QF11 214
QZH=ASTAR*COSBR ; QZK=BSTAR*COSAR ; QZL=CSTAR#                          QF11 215
copyfile:(INBDF,SCRBDF,incr:(lrsymm:),decr:(lrscat:))# Copy to scatt.   QF11 216
#                                                                       QF11 217
#   ENTER SCATT. FACTOR & ATOM SUMMARY (LR LRSCAT:)                     QF11 218
#   ---------------------------------------                             QF11 219
#                                                                       QF11 220
incrqx:(MARK3,MARK2+arith:(16,*,mxwd6c:),QF1106)# Room for 16 sf ty     QF11 221
ISCF=mxwd6c:#                          Allow for 6 char. per name       QF11 222
J2=MARK2#                              Set marker for first sf name     QF11 223
IWNT(1)=NINT(DSNM+20.);  IWNT(3)=100#  Set real ad & ff idnums          QF11 224
IWNT(2)=NINT(DSNM+60.);  IWNT(4)=10#   Set imag ad & neut ff            QF11 225
IWNT(5)=11 ;  IWNT(6)=7#               Set sf name idnum                QF11 226
IWNT(7)=1#                             Set atom number idnum            QF11 227
KEY(1)=0;  KEY(2)=7;  KEY(3)=0#        Set search delimiters            QF11 228
KEY(4) = 0#                                                             QF11 229
indexpkt:(INBDF,lrscat:,LPAK,IP,SCRBDF,KEY,IWNT,IREL)## Get pointers    QF11 230
IF((IREL(1)==0)&(IREL(2)==0)) DISP=no:# No dispersion values            QF11 231
IF(IREL(4)!=0) NEUT=yes:#              Must be neutron data             QF11 232
#                                                                       QF11 233
FOR(I=IP+IREL(3);I<=IP+LPAK;I=I+1)#    Loop over ff list                QF11 234
IF((QX(I)<99.5)\(QX(I)>299.5)) BREAK#  Exit after last ff               QF11 235
IF(IREL(3)>0) NSCF=I-IP-IREL(3)#       Count contiguous ff              QF11 236
ELSE      NSCF=0#                      Ff table present                 QF11 237
IF(NEUT==yes:) NSCF=1#                 Count neutron ff                 QF11 238
IF(IREL(3)>0) DSTL=(QX(I-1)-QX(I-2))*.01# Set st/l interval             QF11 239
#                                                                       QF11 240
NTYP=0#                                Zero count of atom types         QF11 241
FOR(J=MARK3;J>0;J=J+NSCF)#             Loop over each atom type         QF11 242
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF11 243
readwpkt:(INBDF,lrscat:,LPAK,IP,0)#    Get packet pointer               QF11 244
IF(IP<=0) BREAK#                       Exit after last packet           QF11 245
writepkt:(SCRBDF,lrscat:,LPAK,IPO)#    Get output pointer               QF11 246
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy packet                      QF11 247
L=IP+IREL(5)#                          Set pointer for sf name          QF11 248
movereal:(QX,L,QX,J2+1,ISCF,1)#        Move sf name to mark2 array      QF11 249
J2=J2+ISCF#                            Advance sf name pointer          QF11 250
incrqx:(MARKA,J+NSCF,QF1106)#          Expand qx if space left          QF11 251
NTYP=NTYP+1#                           Count atom types                 QF11 252
ADR(NTYP)=0.;   ADI(NTYP)=0.#          Zero dispersion values           QF11 253
I=IP+IREL(1); IF(I>IP) ADR(NTYP)=QX(I)# Get real dispersion             QF11 254
I=IP+IREL(2); IF(I>IP) ADI(NTYP)=QX(I)# Get imag dispersion             QF11 255
I=IP+IREL(6); IF(I>IP) IFFF=NINT(QX(I))# Get refl ff flag               QF11 256
I=IP+IREL(4)#                          Point to neutron ff              QF11 257
IF(NEUT==yes:) QX(MARKA)=QX(I)#        Store neutron ff                 QF11 258
ELSE IF(IREL(3)>0)#                    If xray ff present               QF11 259
FOR(I=J;I<MARKA;I=I+1)#                Loop over sf data points         QF11 260
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF11 261
K=IP+IREL(3)+I-J#                      Point to each ff value           QF11 262
QX(I+1)=QX(K)#                         Store each ff value              QF11 263
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF11 264
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF11 265
copyfile:(INBDF,SCRBDF,incr:(lrscat:),decr:(lrexpl:))# Copy to experm   QF11 266
#                                                                       QF11 267
#   ENTER SCALE INFORMATION (LR LREXPL:)                                QF11 268
#   ------------------------------                                      QF11 269
#                                                                       QF11 270
IWNT(1)=1;   IWNT(2)=100#              Set data set & nscl idnums       QF11 271
KEY(1)=1;  KEY(2)=2;  KEY(3)=0#        Set search delimiters            QF11 272
KEY(4)=0#                              Set update mode                  QF11 273
indexpkt:(INBDF,lrexpl:,PSIZ,IP,SCRBDF,KEY,IWNT,IREL)# Get pointers     QF11 274
NSCL=1#                                Default no. of scale groups      QF11 275
FOR(I=IP+1;I<=IP+PSIZ;I=I+1)#          Loop over directory              QF11 276
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QF11 277
IF((QX(I)<100.9)\(QX(I)>164.1)) NEXT#  Skip if not scale idnm           QF11 278
J=NINT(QX(I))-100#                     Get group number of scale        QF11 279
SCP(J)=FLOAT(I-IP)#                    Store relative position          QF11 280
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QF11 281
REPEAT#                                Loop over data sets              QF11 282
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QF11 283
readwpkt:(INBDF,lrexpl:,PSIZ,IP,0)#    Get packet pointer               QF11 284
IF(IP<=0) BREAK#                       Exit after last packet           QF11 285
writepkt:(SCRBDF,lrexpl:,PSIZ,IPO)#    Get o/p buffer pointer           QF11 286
movereal:(QX,IP+1,QX,IPO+1,PSIZ,1)#    Copy the packet                  QF11 287
I=IP+IREL(1); IF(I==IP) NEXT#          Get index of data set no.        QF11 288
ifne:(DSNM,QX(I)) NEXT#                Skip unwanted data set           QF11 289
I=IP+IREL(2); IF(I>IP) NSCL=NINT(QX(I))# Number of scales               QF11 290
FOR(I=1;I<=NSCL;I=I+1)#                Loop over scale factors          QF11 291
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QF11 292
J=IP+NINT(SCP(I))#                     Point to scale location          QF11 293
IF(J>IP&SCLIN(I)==no:)#                                                 QF11 294
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QF11 295
SC(I)=1.0/QX(J)#                       Store f(calc) scale in table     QF11 296
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QF11 297
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QF11 298
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QF11 299
#                                                                       QF11 300
#   ENTER OVERALL TEMPERATURE FACTOR INFORMATION (LR LRDSET:            QF11 301
#   --------------------------------------------------------            QF11 302
#                                                                       QF11 303
IWNT(1)=1;   IWNT(2)=2#                Set data set & t.f. idnums       QF11 304
KEY(1)=1;  KEY(2)=2;  KEY(3)=0#        Set search delimiters            QF11 305
KEY(4)=0#                              Set update mode                  QF11 306
indexpkt:(INBDF,lrdset:,PSIZ,IP,SCRBDF,KEY,IWNT,IREL)# Get pointers     QF11 307
REPEAT#                                Loop over data sets              QF11 308
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QF11 309
readwpkt:(INBDF,lrdset:,PSIZ,IP,0)#    Get packet pointer               QF11 310
IF(IP<=0) BREAK#                       Exit after last packet           QF11 311
writepkt:(SCRBDF,lrdset:,PSIZ,IPO)#    Get o/p buffer pointer           QF11 312
movereal:(QX,IP+1,QX,IPO+1,PSIZ,1)#    Copy the packet                  QF11 313
I=IP+IREL(1); IF(I==IP) NEXT#          Get index of data set no.        QF11 314
ifne:(DSNM,QX(I)) NEXT#                Skip unwanted data set           QF11 315
I=IP+IREL(2)#                                                           QF11 316
#                                                                       QF11 317
# ONLY LOAD THE T.F. IF THERE WAS NONE LOADED FROM UOV INPUT LINE       QF11 318
# ---------------------------------------------------------------       QF11 319
#                                                                       QF11 320
IF(I>IP)#                              Test that there is one in bdf    QF11 321
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QF11 322
ifeq:(TO,5.01) TO=QX(I)*PISQ8#         Get overall b from overall u     QF11 323
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QF11 324
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QF11 325
copyfile:(INBDF,SCRBDF,incr:(lrdset:),decr:(lratom:))#                  QF11 326
#                                                                       QF11 327
RETURN#                                                                 QF11 328
END#                                                                    QF11 329
systemheader:(QF12)## Load atomic coordinates                           QF12   1
####################################################################    QF12   2
#                                                                  #    QF12   3
#                                QF12                              #    QF12   4
#                                                                  #    QF12   5
####################################################################    QF12   6
SUBROUTINE QF12#                                                        QF12   7
#                                           J.m. stewart 1988           QF12   8
# TAKEN OVER FROM SUBROUTINE ATOMIN OF PROGRAM PROTIN                   QF12   9
# ---------------------------------------------------                   QF12  10
#                                                                       QF12  11
include:(AACOMN)#                                                       QF12  12
include:(QFCOMN)#                                                       QF12  13
#                                                                       QF12  14
string:(ATCHK,9)#                      Check atom name for noref        QF12  15
string:(ATNAM,9)#                      Check atom name for noref        QF12  16
REAL BISO#                             Iso b factor                     QF12  17
string:(CHAIN,27)## Table of chain identifiers from bdf                 QF12  18
string:(CHAINI,3)## Chain identifier from bdf                           QF12  19
INTEGER I,IHIT,IPUT,J,JPT,K,L#         Indices of various sorts         QF12  20
INTEGER IACID,ICHAIN,IRES#             Residue counters                 QF12  21
string:(IDATM,4)#                      Protin atom id                   QF12  22
string:(IDGRP,3)#                                                       QF12  23
intdata:(IPOW,[1000,100,10,1])#        Conversion factors               QF12  24
INTEGER IPT,PSIZ,IWNT(20),KEY(4)#      For i/o operations               QF12  25
INTEGER JCHAIN## Total characters in table chain                        QF12  26
string:(LABEL,9)#                      Protin combined atom id          QF12  27
REAL Q#                                Population parameter             QF12  28
string:(RESCOD,4)## Residue code in ascii from bdf                      QF12  29
INTEGER RESI(4)## Residue character to integer conversion               QF12  30
string:(RESNAM,4)## Residue name in ascii from bdf                      QF12  31
string:(RESSEQ,4)## Residue sequence no. in ascii from bdf              QF12  32
INTEGER SFTYPE## Scattering factor type pointer                         QF12  33
string:(XIDATM,24)## Xtal bdf atom id                                   QF12  34
REAL XF,YF,ZF#                         Atomic coordinates               QF12  35
chardata:(CNTS,1234567890)#            The integers to deasciify        QF12  36
chardata:(DEUT,D)#                     Symbol for deuterium             QF12  37
chardata:(DISOR,DIS )#                                                  QF12  38
chardata:(HYDR,H)#                     Symbol for hydrogen              QF12  39
chardata:(QF12A, ERROR IN ATOM XXXXXXXX.  RESIDUE NAME XXX $#           QF12  40
IS NOT IN THE TABLE OF STANDARD GROUPS.)#                               QF12  41
chardata:(QF12B,[ ATOM NAME XXXXXXXX, ID XXXX, GIVEN FOR RESIDUE $#     QF12  42
XXXX NO. XXXX IS NOT AMONG THOSE IN THE TABLE.  ATOM OMITTED.])#        QF12  43
chardata:(QF12C,[ A DUPLICATE OF ATOM XXXXXXXX, ID XXXX, $#             QF12  44
FOR RESIDUE XXXX XXXX HAS BEEN DETECTED.  ATOM OMITTED.])#              QF12  45
chardata:(QF12D, -----ATOMIC COORDINATES----- )#                        QF12  46
chardata:(QF12E, ONE OR MORE OF THE FOLLOWING ARRAYS ARE full: )#       QF12  47
chardata:(QF12F,[  RESIDUE ATOMS   RESIDUE NAMES    CHAIN NAMES ])#     QF12  48
chardata:(QF12G,[ POSSIBLE FOUND  POSSIBLE FOUND  POSSIBLE FOUND])#     QF12  49
chardata:(QF12H,  ATOM  NAME  CHN RESIDUE    SF        X        $#      QF12  50
Y        Z        B      POP   CHN  ATOM LABEL )#                       QF12  51
chardata:(QF12I, RESIDUE III OF CHAIN II IS MISSING****)#               QF12  52
chardata:(QF12J, THE FOLLOWING ATOMS ARE MISSING FROM $#                QF12  53
THE INPUT ATOMIC COORDINATES )#                                         QF12  54
chardata:(QF12K, RESIDUE      ACID      NO.        )#                   QF12  55
realdata:(FMTA,[60513.,170213.,250313.,310313.,$#                       QF12  56
440942.,530942.,620942.,700832.,780832.])#                              QF12  57
realdata:(FMT5,[120313.,240213.])#                                      QF12  58
realdata:(FMTL,[10113.,50333.])#                                        QF12  59
realdata:(FMT,[90513.,150513.,250513.,310513.,410513.,470513.])#        QF12  60
datastuff:#                                                             QF12  61
#                                                                       QF12  62
#                                                                       QF12  63
#----READ ATOMIC COORDINATES                                            QF12  64
IQZERO=-1 ; INOW=0 ; NOWCHN=0 ;  JCHAIN=0 ; NA=0# Initialize            QF12  65
movechar:(BLANK,1,CHAIN,1,27,1)#       Clear chain identifiers          QF12  66
#                                                                       QF12  67
#  SET UP TO READ ATOMIC DATA FROM BDF ON FILEA                         QF12  68
#  --------------------------------------------                         QF12  69
#                                                                       QF12  70
IWNT(1)=14#                            Ask for atom id                  QF12  71
IWNT(2)=15#                            Ask for residue code             QF12  72
IWNT(3)=16#                            Ask for residue sequence         QF12  73
IWNT(4)=18#                            Chain id & most sig dig res se   QF12  74
IWNT(5)=19#                            Ask for residue name             QF12  75
IWNT(6)=1 ; IWNT(7)=2 ; IWNT(8)=3#     Ask for x,y,z                    QF12  76
IWNT(9)=22#                            Scattering factor pointer        QF12  77
IWNT(10)=4 ; IWNT(11)=11#              Ask for u and pop param          QF12  78
KEY(1)=9#                              The first six are manditory      QF12  79
KEY(2)=11#                             U and pop are optional           QF12  80
KEY(3)=0 ; KEY(4)=0#                                                    QF12  81
indexpkt:(INBDF,lratom:,PSIZ,IPT,SCRBDF,KEY,IWNT,ATIREL)# Find pointe   QF12  82
IF(KEY(4)<=0) iquit:(QF1202)#          No atoms means no run            QF12  83
STEPA=arith:(7,+,nw9c:)#               Set number of items per atom     QF12  84
STEPE=21#                              Set step for case anisotropic    QF12  85
incrqx:(I,MARKA+NATQN*STEPA,QF1201)#   Must have enough memory          QF12  86
IPUT=MARKA-STEPA; LINRM=10#            Set up to store atom name/coor   QF12  87
IF(LISTIT==yes:)#                      Check if listing is to be done   QF12  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF12  89
LINRM=15 ; writeline:(1,QF12D,NQF12D,3,3) ; LINRM=13#                   QF12  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF12  91
#                                                                       QF12  92
#  READ IN THE ATOMIC COORDINATES FROM FILE A                           QF12  93
#  STORE THESE DATA IN THE MARKA ARRAY IN=(NA-1)*STEPA+MARKA            QF12  94
#  X PARAMETER AS FRACTIONS OF THE CELL QX(IN+1)                        QF12  95
#  Y PARAMETER AS FRACTIONS OF THE CELL QX(IN+2)                        QF12  96
#  Z PARAMETER AS FRACTIONS OF THE CELL QX(IN+3)                        QF12  97
#    SCATTERING FACTOR POINTER          QX(IN+4)                        QF12  98
#  B PARAMETER AS DEBYE-WALLER FACTOR   QX(IN+5)                        QF12  99
#  Q POPULATION PARAMETER AS FRACTION   QX(IN+6)                        QF12 100
#    REFINEMENT SIGNAL AS REF/NOREF 0/1 QX(IN+7)                        QF12 101
#    9 CHARACTER ATOM NAME STARTS IN    QX(IN+8)                        QF12 102
#  STEPA IS 7 + THE NUMBER OF WORDS TO HOLD 9 CHARACTERS                QF12 103
#  -------------------------------------------------------------        QF12 104
#                                                                       QF12 105
REPEAT#                                Read in atomic coordinates       QF12 106
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF12 107
readwpkt:(INBDF,lratom:,PSIZ,IPT,0)#   Read atom coordinates            QF12 108
IF(IPT<=0) BREAK#                      Quit when all atoms loaded       QF12 109
writepkt:(SCRBDF,lratom:,PSIZ,JPT)#    Make a copy in file c            QF12 110
movereal:(QX,IPT+1,QX,JPT+1,PSIZ,0)#   Copy everything across           QF12 111
IPUT=IPUT+STEPA#                       Advance storage array pointer    QF12 112
NA=NA+1#                               Count up atoms read in           QF12 113
XF=QX(IPT+ATIREL(6));YF=QX(IPT+ATIREL(7));ZF=QX(IPT+ATIREL(8))# =x,y,   QF12 114
IF(ATIREL(10)>0) BISO=PISQ8*QX(IPT+ATIREL(10))# Set isotropic temp      QF12 115
ELSE             BISO=TO#              Store overall b                  QF12 116
IF(ATIREL(11)>0) Q=QX(IPT+ATIREL(11));ELSE Q=1.0# Set population para   QF12 117
ifeq:(Q,1.0) Q=-1.0#                   Set pop par as not refined       QF12 118
SFTYPE=NINT(QX(IPT+ATIREL(9)))#        Set scattering factor pointer    QF12 119
#                                                                       QF12 120
# BY TAKING THE SCATTERING FACTOR NAME FROM THE XTAL ATOM NAME AND      QF12 121
# THE REMOTNESS INDICATOR AND BRANCH DESIGNATOR FROM THE RESIDUE CODES  QF12 122
# IT IS POSSIBLE TO CONSTRUCT THE PROTIN ATOM IDENTIFIER IN THE SAME    QF12 123
# FORM AS THE RESIDUE IDENTIFIERS DEFINED IN THE CONSTRAINT LINES       QF12 124
# RESTRM, RESIDU, AND RESLNK.                                           QF12 125
#                                                                       QF12 126
movertoc:(QX(IPT+ATIREL(1)),1,XIDATM,1,24,0)# Get xtal atom id          QF12 127
movertoc:(QX(IPT+ATIREL(2)),1,RESCOD,1,4,0)# Get residue codes          QF12 128
movechar:(BLANK,1,IDATM,1,4,1)#        Blank out protin atom id         QF12 129
movechar:(XIDATM,1,IDATM,1,2,0)#       Get scat fact name               QF12 130
compchar:(IDATM,2,CNTS,1,1,1,NCNTS,K)# Is second char a number?         QF12 131
IF(K==0) movechar:(RESCOD,1,IDATM,3,2,0)# No number this one            QF12 132
ELSE movechar:(RESCOD,1,IDATM,2,2,0)#  This one is, bury it.            QF12 133
movertoc:(QX(IPT+ATIREL(5)),1,RESNAM,1,4,0)# Get residue name           QF12 134
movechar:(RESNAM,1,IDGRP,1,3,0)#       Chop off last character          QF12 135
movertoc:(QX(IPT+ATIREL(3)),1,RESSEQ,2,3,0)# Get least digs of res no   QF12 136
movertoc:(QX(IPT+ATIREL(4)),4,RESSEQ,1,1,0)# Get most sig dig of res    QF12 137
DO I=1,4#                              Translate from ascii to intege   QF12 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF12 139
compchar:(RESSEQ,I,CNTS,1,1,1,NCNTS-1,K) ; RESI(I)=K*IPOW(I)# Convert   QF12 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF12 141
IRES=RESI(1)+RESI(2)+RESI(3)+RESI(4)#  Combine decimal places           QF12 142
movertoc:(QX(IPT+ATIREL(4)),1,CHAINI,1,3,0)# Get chain identity         QF12 143
IF(JCHAIN>0)#                          Beyond the first one?            QF12 144
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF12 145
compchar:(CHAINI,1,CHAIN,JCHAIN-2,3,3,3,I)# No, then match name         QF12 146
IF(I==0)#                              But if no match add to list      QF12 147
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF12 148
movechar:(CHAINI,1,CHAIN,JCHAIN+1,3,0);JCHAIN=JCHAIN+3;ICHAIN=JCHAIN/3# QF12 149
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF12 150
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF12 151
ELSE#                                  The very first one starts list   QF12 152
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF12 153
movechar:(CHAINI,1,CHAIN,1,3,0);JCHAIN=3;ICHAIN=1#                      QF12 154
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF12 155
#                                                                       QF12 156
# TAKE THE FRACTIONAL ATOM COORDINATES AND STORE THEM IN THE            QF12 157
# MARKA ARRAY FOR FUTURE USE.                                           QF12 158
# ----------------------------------------------------------            QF12 159
#                                                                       QF12 160
QX(IPUT+1)=XF#                         Store away the atomic co-ordin   QF12 161
QX(IPUT+2)=YF ; QX(IPUT+3)=ZF#                                          QF12 162
QX(IPUT+4)=FLOAT(SFTYPE)#              The scattering factor type       QF12 163
QX(IPUT+5)=BISO ; QX(IPUT+6)=Q#        Store temp and pop params        QF12 164
QX(IPUT+7)=0.0## Turn on refinement. this is a signal set with NOREF.   QF12 165
#                                                                       QF12 166
#----ENCODE CHAIN 1 ONLY IF OTHER NON-DISORDER CHAINS EXIST             QF12 167
movechar:(BLANK,1,LABEL,1,9,1)#        Blank out the 9 chr name         QF12 168
BUFOT(1)=FLOAT(ICHAIN) ; BUFOT(2)=FLOAT(IRES)#                          QF12 169
ncodefld:(BUFOT,1,LABEL,FMTL,2)#                                        QF12 170
compchar:(RESNAM,1,NAMES,1,4,4,4*NACIDS,IACID)# Search for synonym      QF12 171
IF(IACID==0)#                          If not four is it three?         QF12 172
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF12 173
compchar:(RESNAM,1,NAMES,1,3,4,4*NACIDS,IACID)# Search for synonym      QF12 174
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF12 175
IF(IACID==0) iquit:(QF1204)#           No match at all no run           QF12 176
movechar:(MCOD,IACID,LABEL,2,1,0)#     Get one character synonym        QF12 177
movechar:(IDATM,1,LABEL,6,4,0)#                                         QF12 178
IF(ICHAIN==1) movechar:(BLANK,1,LABEL,1,1,1)#                           QF12 179
movector:(LABEL,1,QX(IPUT+8),1,9,0)#   Store atom name                  QF12 180
IF(LISTIT==yes:)#                                                       QF12 181
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF12 182
BUFOT(1)=FLOAT(NA) ; BUFOT(2)=FLOAT(ICHAIN)#                            QF12 183
BUFOT(3)=FLOAT(IRES) ; BUFOT(5)=QX(IPUT+1) ; BUFOT(6)=QX(IPUT+2)#       QF12 184
BUFOT(7)=QX(IPUT+3)#                                                    QF12 185
BUFOT(8)=QX(IPUT+5) ; BUFOT(9)=ABS(QX(IPUT+6))#                         QF12 186
BUFOT(4)=FLOAT(SFTYPE)#                                                 QF12 187
ncodefld:(BUFOT,1,CHROT,FMTA,9)#                                        QF12 188
movechar:(IDATM,1,CHROT,9,4,0)#                                         QF12 189
movechar:(RESNAM,1,CHROT,19,4,0)#                                       QF12 190
movechar:(CHAINI,1,CHROT,81,3,0)#                                       QF12 191
movertoc:(QX(IPUT+8),2,CHROT,85,8,0)#                                   QF12 192
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QF12 193
writeline:(0,QF12H,NQF12H,1,3)#                                         QF12 194
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF12 195
#                                                                       QF12 196
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF12 197
#                                                                       QF12 198
copyfile:(INBDF,SCRBDF,incr:(lratom:),decr:(lrrefl:))# Up to reflecti   QF12 199
#                                                                       QF12 200
STOPA=STEPA+IPUT#                      Keep track of end of atoms       QF12 201
IF(NA!=NATQN) iquit:(QF1203)#          Atoms in file a and g differ!    QF12 202
REPEAT#                                Get the noref lines, if any      QF12 203
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF12 204
IF(LINID==25) BREAK#                   Only to 'end' line               QF12 205
ELSE IF(LINID==24)#                    Noref input line encountered     QF12 206
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF12 207
K=0 ; REPEAT#                          Loop over atom names in line     QF12 208
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF12 209
K=K+1 ; IF(BUFIN(K)>=voidflg:) BREAK#  Quit at first void field         QF12 210
stringlim:(K,I,J) ; J=MIN0(9,J-I)#     Point to name string             QF12 211
movechar:(BLANK,1,ATCHK,1,9,1)#        Blank out whole atom name        QF12 212
movechar:(BUFIN,I,ATCHK,1,J,0)#        Save input characters in atchk   QF12 213
L=MARKA-STEPA ; DO J=1,NA#             Search for atom in array         QF12 214
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF12 215
L=L+STEPA ; movertoc:(QX(L+8),1,ATNAM,1,9,0)#                           QF12 216
compchar:(ATNAM,1,ATCHK,1,1,9,9,IHIT)#                                  QF12 217
IF(IHIT!=0)#                           Got a match?                     QF12 218
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF12 219
QX(L+7)=1.0 ; NKILL=NKILL+1 ; BREAK#   Yes!                             QF12 220
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF12 221
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF12 222
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF12 223
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF12 224
ELSE iquit:(QF1205)#                   Noref & end are all we'll take   QF12 225
readline:(INLINE,NLINEC)#              Read another input line          QF12 226
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF12 227
RETURN#                                                                 QF12 228
END#                                                                    QF12 229
systemheader:(QF22)## Establish control & memory                        QF22   1
####################################################################    QF22   2
#                                                                  #    QF22   3
#                                QF22                              #    QF22   4
#                                                                  #    QF22   5
####################################################################    QF22   6
SUBROUTINE QF22#                                                        QF22   7
#                                       J.m. stewart 1988               QF22   8
include:(AACOMN)#                                                       QF22   9
include:(QFCOMN)#                                                       QF22  10
#                                                                       QF22  11
REAL ARGE,ARGE1#                                                        QF22  12
INTEGER I,IQZERO#                      Loop index & pointer             QF22  13
INTEGER NO#                                                             QF22  14
REAL TWPIOV#                           Two pi over 1024                 QF22  15
#                                                                       QF22  16
chardata:(QF22A, ATOMS DISTS PLANES CHI CN $#                           QF22  17
POSS CONT TORS ANG SYM1 SYM2 T ELIPS $#                                 QF22  18
VAR OCC  VARIABLES MATRIX ELEMENTS)#                                    QF22  19
realdata:(FMT1,[60513.,120513.,190513.,260513.,360513.,450513.,$#       QF22  20
500513.,550513.,620513.,700513.,810513.,930813.])#                      QF22  21
datastuff:#                                                             QF22  22
#                                                                       QF22  23
#    SET REFINEMENT CONTROL PARAMETERS                                  QF22  24
#    ---------------------------------                                  QF22  25
#                                                                       QF22  26
IF(IDALIZ==yes:&REPORT==no:)#          Ideal only                       QF22  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF22  28
NOCC=0 ; TFTYPE=0#                     Shut off pp force ov tf ref      QF22  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF22  30
IF(TFTYPE==0)#                         Test if overall tf               QF22  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF22  32
NV=3*NA+NOCC+2 ; NBET=1 ; JMTRX=6*NA+9*NDIS+NOCC+2# Set for ovrall      QF22  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF22  34
ELSE IF(TFTYPE==1)#                    Test individual isotropic tf     QF22  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF22  36
NV=4*NA+NOCC+1 ; NBET=NA ; JMTRX=7*NA+10*NDIS+NOCC+1# Set ind iso       QF22  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF22  38
IATMN=3*NA+1 ; IBET1=IATMN+1 ; IBETN=IATMN+NBET ; IQZERO=NA-NOCC#       QF22  39
BUFOT(1)=FLOAT(NA) ; BUFOT(2)=FLOAT(NDIS) ; BUFOT(3)=FLOAT(NPLN)#       QF22  40
BUFOT(4)=FLOAT(NCHR) ; BUFOT(5)=FLOAT(NVDW) ; BUFOT(6)=FLOAT(NTOR)#     QF22  41
BUFOT(7)=FLOAT(NSYM(1)) ; BUFOT(8)=FLOAT(NSYM(2))#                      QF22  42
BUFOT(9)=FLOAT(NAXES) ; BUFOT(10)=FLOAT(NOCC)#                          QF22  43
BUFOT(11)=FLOAT(NV) ; BUFOT(12)=FLOAT(JMTRX)#                           QF22  44
ncodefld:(BUFOT,1,CHROT,FMT1,12) ; writeline:(1,QF22A,NQF22A,2,3)#      QF22  45
#                                                                       QF22  46
#    SET UP STORAGE ARRAYS FOR THE REFINEMENT PROCESS                   QF22  47
#    ------------------------------------------------                   QF22  48
#                                                                       QF22  49
MARKU=STOPA+1 ; STEPU=1#               Set up auxillary vector          QF22  50
incrqx:(MARKV,MARKU+STEPU*NV,QF2201)#                                   QF22  51
STOPU=MARKV-1 ; STEPV=1#               Set up vector                    QF22  52
incrqx:(MARKM,MARKV+STEPV*NV,QF2202)#                                   QF22  53
STOPV=MARKM-1 ; STEPM=1#               Set up sparse matrix of diriv    QF22  54
#                                                                       QF22  55
#  THIS IS AN INTERESTING KLUDGE.  BECAUSE THE SIZE OF THE MATRIX       QF22  56
#  MAY INCREASE WHEN ALL THE CONSTRAINTS ARE FOUND AND IN PLACE         QF22  57
#  FIFTY PERCENT MORE STORAGE IS SOUGHT THAN THE FIRST ESTIMATE         QF22  58
#  FROM ATOMS, ETC. DICTATE.  THE REMAINING STORAGE IS DIVIDED          QF22  59
#  BETWEEN 'SCRATCH' STORAGE AND POINTERS TO ATOMS INVOLVED IN          QF22  60
#  DISTANCE RESTRAINTS.                                                 QF22  61
#  ------------------------------------------------------------------   QF22  62
#                                                                       QF22  63
incrqx:(MARKT,MARKM+STEPM*(JMTRX+JMTRX/2),QF2203)#                      QF22  64
#                                                                       QF22  65
# THE ACTUAL VALUE OF STEPT DEPENDS UPON THE SUBROUTINE IN WHICH THE    QF22  66
# 'SCRATCH' ARRAY IN MARKT IS BEING USED.  CAVEAT TWIDDLER!             QF22  67
#                                                                       QF22  68
STOPM=MARKT-1 ; STEPT=1 ; STEPD=3#     Set up scratch tablet array      QF22  69
incrqx:(MARKD,MARKT+(QXMAX-MARKT-1)/2-5000,QF2205)#                     QF22  70
#                                                                       QF22  71
STOPT=MARKD-1#                         Set up table of distances        QF22  72
incrqx:(STOPD,MARKD+(QXMAX-MARKT-1)/2-5000,QF2204)#                     QF22  73
STOPD=STOPD-1#                                                          QF22  74
#                                                                       QF22  75
#    SET UP TRIG TABLES, EXPONENTIAL TABLES, CLEAR VECTOR & MATRIX      QF22  76
#    -------------------------------------------------------------      QF22  77
#                                                                       QF22  78
NO=0#                                  Number of observations to 0      QF22  79
TWPIOV=TUPI/1024.#                     Two pi divided by table entrie   QF22  80
DO I=1,1024#                           Set up all entries               QF22  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF22  82
ARGE1=FLOAT(I-1)*0.01 ; ETB(I)=EXP(-ARGE1)# Exponential table e-x       QF22  83
ARGE=FLOAT(I-1)*TWPIOV ; CTB(I)=COS(ARGE) ; STB(I)=SIN(ARGE)# Cos/sin   QF22  84
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF22  85
IPOSTV=arith:(1024,*,2048)#            Ipostv, large mult of 1024       QF22  86
DO I=MARKM,STOPM ; QX(I+1)=0.0#        Clear the sparse matrix of n.e   QF22  87
DO I=MARKV,STOPV ; QX(I+1)=0.0#        Clear the vector                 QF22  88
#                                                                       QF22  89
RETURN#                                                                 QF22  90
END#                                                                    QF22  91
systemheader:(QF31)## Drive subr'nes to apply restraint information     QF31   1
####################################################################    QF31   2
#                                                                  #    QF31   3
#                                QF31                              #    QF31   4
#                                                                  #    QF31   5
####################################################################    QF31   6
SUBROUTINE QF31## Dissected from PROLSQ main routine of J. Konnert,     QF31   7
#                  W. HENDRICKSON, AND OTHERS, INCL. B. FINZEL, FROM    QF31   8
#                   WHOM THE CODE WAS OBTAINED.                         QF31   9
#                                         J.m. stewart 1988             QF31  10
include:(AACOMN)#                                                       QF31  11
include:(QFCOMN)#                                                       QF31  12
#                                                                       QF31  13
REAL AUGMNT#                                                            QF31  14
INTEGER I,IA,IK,IQ,IX,K,L#             Loop indices & pointers          QF31  15
INTEGER NBIS#                                                           QF31  16
REAL SHIFTM(3)## Shift magnitudes on a, b, & c                          QF31  17
chardata:(QF31A,DISTANCE)#                                              QF31  18
chardata:(QF31B,PLANE)#                                                 QF31  19
chardata:(QF31C,CHIRAL CENTER)#                                         QF31  20
chardata:(QF31D,NON-BONDED CONTACT)#                                    QF31  21
chardata:(QF31E, ACTUAL CONTACTS  HYDROGEN BONDS  TOTAL DISTANCES  $#   QF31  22
MATRIX ELEMENTS)#                                                       QF31  23
realdata:(FM440,[120913.,280913.,420913.,630913.])#                     QF31  24
chardata:(QF31F,ISOTROPIC THERMAL FACTOR)#                              QF31  25
chardata:(QF31G,ANISOTROPIC THERMAL FACTOR)#                            QF31  26
chardata:(QF31H,TORSION ANGLE)#                                         QF31  27
chardata:(QF31I,NON-CRYSTAL SYMMETRY)#                                  QF31  28
chardata:(QF31J,OCCUPANCY)#                                             QF31  29
chardata:(QF31K,SHIFT MAGNITUDE)#                                       QF31  30
chardata:(QF31L,          ON A       ON B       ON C)#                  QF31  31
chardata:(QF31M,[ POSITIONAL SHIFT MAGNITUDE RESTRAINTS $#              QF31  32
(CELL DIM/PDEL)**2 ])#                                                  QF31  33
realdata:(FM01,[141031.,251031.,361031.])#                              QF31  34
datastuff:#                                                             QF31  35
#                                                                       QF31  36
#    APPLY SHIFT MAGNITUDE RESTRAINTS ON POSITIONS                      QF31  37
#    ---------------------------------------------                      QF31  38
IF(PDEL>0.0)#                                                           QF31  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF31  40
CALL QF01(QF31K,NQF31K)#               Announce shift magnitude         QF31  41
SHIFTM(1)=(AEDGE/PDEL)**2 ;SHIFTM(2)=(BEDGE/PDEL)**2#                   QF31  42
SHIFTM(3)=(CEDGE/PDEL)**2#                                              QF31  43
ncodefld:(SHIFTM,1,CHROT,FM01,3) ; writeline:(1,QF31L,NQF31L,2,4)#      QF31  44
writeline:(1,QF31M,NQF31M,3,4)#        Explain values to user           QF31  45
DO IA=1,NA#                            Loop over all atoms              QF31  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF31  47
I=6*IA+MARKM ; QX(I-4)=SHIFTM(1)#      Store in matrix                  QF31  48
QX(I-1)=SHIFTM(2) ; QX(I+1)=SHIFTM(3)#                                  QF31  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF31  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF31  51
#                                                                       QF31  52
#    APPLY DISTANCE RESTRAINTS                                          QF31  53
#    -------------------------                                          QF31  54
CALL QF01(QF31A,NQF31A)#               Announce distance                QF31  55
CALL QF32#                             Call disref                      QF31  56
#                                                                       QF31  57
#    APPLY PLANE RESTRAINTS                                             QF31  58
#    ----------------------                                             QF31  59
CALL QF01(QF31B,NQF31B)#               Announce plane                   QF31  60
CALL QF33#                             Call plnref(nplat)               QF31  61
#                                                                       QF31  62
#    APPLY CHIRAL CENTER RESTRAINTS                                     QF31  63
#    ------------------------------                                     QF31  64
CALL QF01(QF31C,NQF31C)#               Announce chiral center           QF31  65
CALL QF35#                             Call chiref                      QF31  66
#                                                                       QF31  67
#    APPLY NON-BONDED CONTACT RESTRAINTS                                QF31  68
#    -----------------------------------                                QF31  69
CALL QF01(QF31D,NQF31D)#               Announce non-bonded contact      QF31  70
CALL QF36#                             Call vdwref                      QF31  71
NBIS=NDIS ; NDIS=NDIS+NVDW#            Reset matrix limits              QF31  72
IF(TFTYPE==0) JMTRX=6*NA+9*NDIS+NOCC+2#                                 QF31  73
ELSE IF(TFTYPE==1) JMTRX=7*NA+9*NDIS+NBIS+NHBD+NOCC+1#                  QF31  74
ELSE IF(TFTYPE==2) JMTRX=12*NA+9*NDIS+9*NBIS+NOCC+1#                    QF31  75
BUFOT(1)=FLOAT(NVDW) ; BUFOT(2)=FLOAT(NHBD)#                            QF31  76
BUFOT(3)=FLOAT(NDIS) ; BUFOT(4)=FLOAT(JMTRX)#                           QF31  77
ncodefld:(BUFOT,1,CHROT,FM440,4) ; writeline:(2,QF31E,NQF31E,2,3)#      QF31  78
#                                                                       QF31  79
#    COMPUTE CONFORMATIONAL TORSION ANGLES AND APPLY RESTRAINTS         QF31  80
#    ----------------------------------------------------------         QF31  81
IF(NTOR!=0)#                                                            QF31  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF31  83
CALL QF01(QF31H,NQF31H)#               Announce tortion angle           QF31  84
CALL QF37#                             Call torref(ntor)                QF31  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF31  86
#                                                                       QF31  87
#    APPLY SHIFT MAGNITUDE RESTRAINTS ON THERMAL FACTORS                QF31  88
IF(TFTYPE!=0&BDEL>0.0)#                                                 QF31  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF31  90
L=6*NA+9*NDIS+1 ; AUGMNT=1.0/BDEL**2#                                   QF31  91
IF(TFTYPE!=1)#                         Anisotropic?                     QF31  92
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF31  93
DO IX=1,3#                                                              QF31  94
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF31  95
K=2*IX-1/IX ; DO IA=1,NA#                                               QF31  96
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF31  97
IK=6*(IA-1)+K+MARKM ; QX(L+IK)=AUGMNT#                                  QF31  98
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF31  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF31 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF31 101
ELSE#                                  Isotropic                        QF31 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF31 103
DO IA=1,NA ; QX(L+IA+MARKM)=AUGMNT#                                     QF31 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF31 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF31 106
#                                                                       QF31 107
#    APPLY NON-CRYSTALLOGRAPHIC SYMMETRY RESTRAINTS                     QF31 108
#    ----------------------------------------------                     QF31 109
IF(NSYM(1)!=0)#                                                         QF31 110
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF31 111
CALL QF01(QF31I,NQF31I)#               Announce no-crystal symmetry     QF31 112
CALL QF39#                             Call symref(nsym)                QF31 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF31 114
#                                                                       QF31 115
#    APPLY THERMAL FACTOR RESTRAINTS                                    QF31 116
#    -------------------------------                                    QF31 117
#                                                                       QF31 118
IF(TFTYPE==1)#                         Test if isotropic                QF31 119
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF31 120
CALL QF01(QF31F,NQF31F)#               Announce isotropic temp fact     QF31 121
CALL QF43#                             Call bref(beta)                  QF31 122
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF31 123
ELSE IF(TFTYPE==2)#                    Test if anisotropic              QF31 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF31 125
CALL QF01(QF31G,NQF31G)#               Announce anisotropic temp fact   QF31 126
CALL QF44#                             Call teref(naxes)                QF31 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF31 128
#                                                                       QF31 129
#    APPLY SHIFT MAGNITUDE RESTRAINTS ON OCCUPANCY FACTORS              QF31 130
#    -----------------------------------------------------              QF31 131
IF(NOCC!=0&QDEL>0.0)#                                                   QF31 132
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF31 133
CALL QF01(QF31J,NQF31J)#               Announce occupancy factor        QF31 134
IF(TFTYPE==0) L=6*NA+9*NDIS+3#         For overall isotropic            QF31 135
ELSE IF(TFTYPE==1) L=7*NA+9*NDIS+NBIS+NHBD+1# For individual istropic   QF31 136
ELSE L=12*NA+9*NDIS+9*NBIS+1#          For individual anisotropic       QF31 137
DO IQ=1,NOCC ; QX(L+IQ+MARKM)=1.0/QDEL**2#                              QF31 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF31 139
#                                                                       QF31 140
RETURN#                                                                 QF31 141
END#                                                                    QF31 142
systemheader:(QF32)## Set up distance restraints                        QF32   1
####################################################################    QF32   2
#                                                                  #    QF32   3
#                                QF32                              #    QF32   4
#                                                                  #    QF32   5
####################################################################    QF32   6
SUBROUTINE QF32#                       Subroutine disref                QF32   7
#                                         W. hendrickson                QF32   8
include:(AACOMN)#                                                       QF32   9
include:(QFCOMN)#                                                       QF32  10
#                                                                       QF32  11
REAL ARG#                                                               QF32  12
REAL AVGR#                                                              QF32  13
REAL DEL#                                                               QF32  14
REAL DIR(6)#                                                            QF32  15
REAL DIST(8)#                                                           QF32  16
REAL DS#                                                                QF32  17
REAL DSUM(8)#                                                           QF32  18
REAL DX,DY,DZ#                                                          QF32  19
INTEGER I,IP,IPD,IPP,IPT,IWT#          Loop indices & pointers          QF32  20
INTEGER J,JK,JND,JNT,JO,JPR,JPRP,JT#   Loop indices & pointers          QF32  21
INTEGER J2,J5,J5S,J10#                 Loop indices & pointers          QF32  22
INTEGER K,M,MM#                        Loop indices & pointers          QF32  23
INTEGER NATT,NCLASS,NWTD#              Counts                           QF32  24
INTEGER N,NDP,NN,NTP,N5,N5P#           Loop indices & pointers          QF32  25
INTEGER NSUM(8)#                                                        QF32  26
REAL RMSD(8)#                                                           QF32  27
REAL SIGD(8)#                                                           QF32  28
REAL SUMR#                                                              QF32  29
REAL WTT#                                                               QF32  30
REAL WWTT(8)#                                                           QF32  31
chardata:(TWO,TWO )#                                                    QF32  32
chardata:(FIVE,FIVE)#                                                   QF32  33
chardata:(TEN,TEN )#                                                    QF32  34
chardata:(QF32A,        DISTANCES DEVIATE FROM IDEALITY BY MORE $#      QF32  35
THAN      * SIGMA.)#                                                    QF32  36
chardata:(QF32B, LIST OF DISTANCES DEVIATING BY MORE THAN      * $#     QF32  37
SIGMA follows:)#                                                        QF32  38
chardata:(QF32C,   ATOM(I) ATOM(J)  IDEAL MODEL   ATOM(I) ATOM(J)  $#   QF32  39
IDEAL MODEL   ATOM(I) ATOM(J)  IDEAL MODEL   ATOM(I) ATOM(J)  $#        QF32  40
IDEAL MODEL)#                                                           QF32  41
realdata:(FM50,[250632.,310632.,560632.,620632.,870632.,930632.,$#      QF32  42
1180632.,1240632.])#                                                    QF32  43
chardata:(QF32D, SUM(WGT*DELTA**2) =                 $#                 QF32  44
AVG(WGT*DELTA**2) =          FOR DISTANCES)#                            QF32  45
realdata:(FM55,[361471.,640732.])#                                      QF32  46
chardata:(QF32E,[ TYPE    1/WGT   NO. AV DIST  RMS DEL  SIGMA  $#       QF32  47
DISTANCE TYPE])#                                                        QF32  48
chardata:(QF323,[        ROOT])#                                        QF32  49
realdata:(FM409,[50413.,140632.,190513.,260732.,350832.,420632.])#      QF32  50
chardata:(QF32G, BOND DISTANCE)#                                        QF32  51
chardata:(QF32H, ANGLE DISTANCE)#                                       QF32  52
chardata:(QF32I, PLANAR 1-4 DISTANCE)#                                  QF32  53
chardata:(QF32J, X-H BOND DISTANCE)#                                    QF32  54
chardata:(QF32K, X-H ANGLE DISTANCE)#                                   QF32  55
chardata:(QF32L,[ METAL COORD., ETC.])#                                 QF32  56
chardata:(QF321,[ HYDROGEN BOND])#                                      QF32  57
chardata:(QF32M,  ESTIMATED BOND ANGLE values: AVERAGE $#               QF32  58
ANGLE =          RMS DEVIATION =       )#                               QF32  59
chardata:(QF32N,[ >>>>>>>>>>>>>>>>>>>>>>>> BOND DISTANCE RESTRAINTS $#  QF32  60
<<<<<<<<<<<<<<<<<<<<<<<<<])#                                            QF32  61
realdata:(FM430,[530732.,780732.])#                                     QF32  62
intdata:(POINT,[4,12,35,43,66,74,97,105])#                              QF32  63
datastuff:#                                                             QF32  64
#                                                                       QF32  65
# IN QF32 THE MARKD AND MARKT ARRAYS ARE USED TO STORE DISTANCE         QF32  66
# CONSTRAINTS AS FOLLOWS:                                               QF32  67
#  MARKD   OLD NO(N)     NEW QX(MARKD+(N-1)*STEPD+1) ALIAS NE(N)        QF32  68
#  MARKD   OLD NT(N)     NEW QX(MARKD+(N-1)*STEPD+2) ALIAS NZ(N)        QF32  69
#  MARKD   OLD NWTB(N)   NEW QX(MARKD+(N-1)*STEPD+3)                    QF32  70
#  MARKT   OLD DIS(N)    NEW QX(MARKT+(N-1)*STEPT+1)                    QF32  71
#  MARKT   OLD DISA(N)   NEW QX(MARKT+(N-1)*STEPT+2)                    QF32  72
#  MARKT   OLD NWTD(N)   NEW QX(MARKT+(N-1)*STEPT+3)                    QF32  73
#  MARKT   OLD LO(N)     NEW QX(MARKT+(N-1)*STEPT+4)                    QF32  74
#  MARKT   OLD LT(N)     NEW QX(MARKT+(N-1)*STEPT+5)                    QF32  75
STEPT=5#                               Set markt step                   QF32  76
#                                                                       QF32  77
SUMR=0.0 ; NATT = 6*NA + 2#            Initialize                       QF32  78
#                                                                       QF32  79
#    SET THE DISTANCE WEIGHTING SCHEME                                  QF32  80
#    ---------------------------------                                  QF32  81
NCLASS=7 ; SIGD(1)=SIGD1 ; SIGD(2)=SIGD2 ; SIGD(3)=SIGD3#               QF32  82
SIGD(4)=SIGD4 ; SIGD(5)=SIGD5 ; SIGD(6)=SIGD6 ; SIGD(7)=SIGD7#          QF32  83
SIGD(8)=0.0 ; DO I=1,NCLASS#                                            QF32  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF32  85
DIST(I)=0.0 ; DSUM(I)=0.0 ; NSUM(I)=0 ; WWTT(I)=0.0#                    QF32  86
IF(SIGD(I)>0.0) WWTT(I)=WDSKAL/SIGD(I)#                                 QF32  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF32  88
#                                                                       QF32  89
#     READ THE DISTANCE RESTRAINT INFORMATION                           QF32  90
#     ---------------------------------------                           QF32  91
#                                                                       QF32  92
N=0 ; NTP=MARKT-STEPT ; NDP=MARKD-STEPD# Prepare pointers               QF32  93
REPEAT#                                Loop over all packets            QF32  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF32  95
readwpkt:(TINFIL,LRDIS,PSIZ6,GETPK,0)# Read distance constraints        QF32  96
IF(GETPK<=0) BREAK#                    Stop when all packets loaded     QF32  97
N=N+1 ; NDP=NDP+STEPD ; NTP=NTP+STEPT# Advance storage pointers         QF32  98
IF(NTP+STEPT>STOPT\NDP+STEPD>STOPD) iquit:(QF3201)# Check out of ar     QF32  99
IF(N!=NINT(QX(GETPK+1))) iquit:(QF3202)# Check sync of counts           QF32 100
QX(NDP+1)=QX(GETPK+2) ; QX(NDP+2)=QX(GETPK+3)# Old no and nt            QF32 101
QX(NDP+3)=QX(GETPK+6)#                 Old nwtb                         QF32 102
QX(NTP+1)=QX(GETPK+4) ; QX(NTP+3)=QX(GETPK+5)# Old dis and nwtd         QF32 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF32 104
IF(NDIS!=N) iquit:(QF3203)## 1st and 2ond count on File F must agre     QF32 105
#                                                                       QF32 106
#    CYCLE OVER DISTANCES                                               QF32 107
#    --------------------                                               QF32 108
JNT=MARKT-STEPT ; JND=MARKD-STEPD ; DO JN=1,NDIS#                       QF32 109
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF32 110
JNT=JNT+STEPT ; JND=JND+STEPD#                                          QF32 111
IWT=NINT(QX(JNT+3)) ; WTT=WWTT(IWT)#   Iwt=nwtd(jn)                     QF32 112
N5=NINT(QX(JND+1)) ; N5P=(N5-1)*STEPA+MARKA# N5=no(jn)                  QF32 113
J5=NINT(QX(JND+2)) ; J5P=(J5-1)*STEPA+MARKA# J5=nt(jn)                  QF32 114
#                                                                       QF32 115
#    CALCULATE THIS DISTANCE AND ITS DERIVATIVES                        QF32 116
#    -------------------------------------------                        QF32 117
DX=(QX(N5P+1)-QX(J5P+1))*AEDGE ; DY=(QX(N5P+2)-QX(J5P+2))*BEDGE#        QF32 118
DZ=(QX(N5P+3)-QX(J5P+3))*CEDGE#                                         QF32 119
QX(JNT+2)=SQRT(DX**2+DY**2+DZ**2+2.0*$# Disa(jn)                        QF32 120
(DY*DZ*CA+DX*DZ*CB+DX*DY*CG))#                                          QF32 121
DS=WTT*(QX(JNT+1)-QX(JNT+2))#          Ds=wtt*(dis(jn)-disa(jn))        QF32 122
SUMR=SUMR+DS*DS#                                                        QF32 123
DIST(IWT)=DIST(IWT)+QX(JNT+2)#                                          QF32 124
DSUM(IWT)=DSUM(IWT)+(QX(JNT+1)-QX(JNT+2))**2#                           QF32 125
NSUM(IWT)=NSUM(IWT)+1#                                                  QF32 126
DIR(1)=AEDGE*(DX+DZ*CB+DY*CG)/AMAX1(0.01,QX(JNT+2))#                    QF32 127
DIR(2)=BEDGE*(DZ*CA+DY+DX*CG)/AMAX1(0.01,QX(JNT+2))#                    QF32 128
DIR(3)=CEDGE*(DY*CA+DX*CB+DZ)/AMAX1(0.01,QX(JNT+2))#                    QF32 129
DIR(4)=-DIR(1) ; DIR(5)=-DIR(2) ; DIR(6)=-DIR(3)#                       QF32 130
DO JK=1,6 ; DIR(JK)=DIR(JK)*WTT#                                        QF32 131
#                                                                       QF32 132
#    INCREMENT MATRIX ELEMENTS WITHIN ATOM BLOCKS                       QF32 133
#    --------------------------------------------                       QF32 134
N=6*(N5-1)+2+MARKM ; M=6*(J5-1)+2+MARKM#                                QF32 135
DO JT=1,3 ; DO JO=JT,3#                                                 QF32 136
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF32 137
QX(N)=QX(N)+DIR(JT)*DIR(JO) ; QX(M)=QX(M)+DIR(JT+3)*DIR(JO+3)#          QF32 138
N=N+1 ; M=M+1#                                                          QF32 139
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF32 140
#                                                                       QF32 141
#    INCREMENT VECTOR ELEMENTS                                          QF32 142
NN=3*(N5-1)+2+MARKV ; MM=3*(J5-1)+2+MARKV ; DO JT=1,3#                  QF32 143
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF32 144
QX(NN)=QX(NN)+DS*DIR(JT) ; QX(MM)=QX(MM)+DS*DIR(JT+3)#                  QF32 145
NN=NN+1 ; MM=MM+1#                                                      QF32 146
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF32 147
#                                                                       QF32 148
#    INCREMENT MATRIX ELEMENTS WITHIN DISTANCE BLOCKS                   QF32 149
#    ------------------------------------------------                   QF32 150
J=NATT+9*(JN-1)+MARKM ; DO JT=1,3 ; DO JO=4,6#                          QF32 151
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF32 152
QX(J)=QX(J)+DIR(JT)*DIR(JO) ; J=J+1#                                    QF32 153
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF32 154
#    END OF CYCLE OVER DISTANCES                                        QF32 155
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF32 156
#                                                                       QF32 157
#    PRINT OUT THE DISTANCES AND DISCREPANCY AVERAGES                   QF32 158
#    ------------------------------------------------                   QF32 159
J2=0 ; J5S=0 ; J10=0 ; JPR=0#                                           QF32 160
IPD=MARKD-STEPD ; IPT=MARKT-STEPT ; DO I=1,NDIS#                        QF32 161
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF32 162
IPT=IPT+STEPT ; IPD=IPD+STEPD#                                          QF32 163
DEL=ABS(QX(IPT+1)-QX(IPT+2))#          Del=abs(dis(i)-disa(i))          QF32 164
NWTD=NINT(QX(IPT+3))#                                                   QF32 165
IF(DEL>2.0*SIGD(NWTD))J2=J2+1#                                          QF32 166
IF(DEL>5.0*SIGD(NWTD))J5S=J5S+1#                                        QF32 167
IF(DEL>10.0*SIGD(NWTD))J10=J10+1#                                       QF32 168
IF(DEL<=DSCUT*SIGD(NWTD)) NEXT#                                         QF32 169
JPRP=JPR*STEPT+MARKT ; JPR=JPR+1#                                       QF32 170
QX(JPRP+1)=QX(IPT+1)#                  Dis(jpr)=dis(i)                  QF32 171
QX(JPRP+2)=QX(IPT+2)#                  Disa(jpr)=disa(i)                QF32 172
QX(JPRP+4)=QX(IPD+1)#                  Lo(jpr)=no(i)                    QF32 173
QX(JPRP+5)=QX(IPD+2)#                  Lt(jpr)=nt(i)                    QF32 174
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF32 175
LINRM=10 ; writeline:(4,QF32N,NQF32N,3,3)# Mark section of output       QF32 176
BUFOT(1)=FLOAT(J2) ; ncodefld:(BUFOT,1,QF32A,70613.,1)#                 QF32 177
movechar:(TWO,1,QF32A,54,NTWO,0)#                                       QF32 178
writeline:(1,QF32A,NQF32A,3,3)#                                         QF32 179
BUFOT(1)=FLOAT(J5S) ; ncodefld:(BUFOT,1,QF32A,70613.,1)#                QF32 180
movechar:(FIVE,1,QF32A,54,NFIVE,0)#                                     QF32 181
writeline:(1,QF32A,NQF32A,3,3)#                                         QF32 182
BUFOT(1)=FLOAT(J10) ; ncodefld:(BUFOT,1,QF32A,70613.,1)#                QF32 183
movechar:(TEN,1,QF32A,54,NTEN,0)#                                       QF32 184
writeline:(1,QF32A,NQF32A,3,3)#                                         QF32 185
#                                                                       QF32 186
IF(JPR>0)#                                                              QF32 187
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF32 188
#                                                                       QF32 189
ncodefld:(DSCUT,1,QF32B,460302.,1) ; writeline:(1,QF32B,NQF32B,3,3)#    QF32 190
LINRM=10 ; K=0#                                                         QF32 191
DO I=1,JPR#                                                             QF32 192
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF32 193
IF(K>7)#                                                                QF32 194
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF32 195
ncodefld:(BUFOT,1,CHROT,FM50,K) ; writeline:(0,QF32C,NQF32C,1,3) ; K=0# QF32 196
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF32 197
IP=(I-1)*STEPT+MARKT ; BUFOT(K+1)=QX(IP+1)# Dis(i)                      QF32 198
BUFOT(K+2)=QX(IP+2)#                   Disa(i)                          QF32 199
IPP=(NINT(QX(IP+4))-1)*STEPA+MARKA#                                     QF32 200
movertoc:(QX(IPP+8),2,CHROT,POINT(K+1),8,0)# Atom name 1                QF32 201
IPP=(NINT(QX(IP+5))-1)*STEPA+MARKA#                                     QF32 202
movertoc:(QX(IPP+8),2,CHROT,POINT(K+2),8,0) ; K=K+2# Atom name 2        QF32 203
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF32 204
ncodefld:(BUFOT,1,CHROT,FM50,K) ; writeline:(0,QF32C,NQF32C,1,3)#       QF32 205
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF32 206
AVGR=SUMR/FLOAT(MAX0(1,NDIS))#                                          QF32 207
BUFOT(1)=SUMR ; BUFOT(2)=AVGR ; ncodefld:(BUFOT,1,QF32D,FM55,2)#        QF32 208
writeline:(1,QF32D,NQF32D,3,3) ; LINRM=6#                               QF32 209
writeline:(1,QF323,NQF323,3,3) ; DO I=1,NCLASS#                         QF32 210
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF32 211
RMSD(I)=0.0 ; IF(NSUM(I)>0)#                                            QF32 212
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF32 213
RMSD(I)=SQRT(DSUM(I)/FLOAT(NSUM(I))) ; DIST(I)=DIST(I)/FLOAT(NSUM(I))#  QF32 214
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF32 215
BUFOT(1)=FLOAT(I) ; BUFOT(2)=1.0/AMAX1(0.1,WWTT(I))#                    QF32 216
BUFOT(3)=FLOAT(NSUM(I))#                                                QF32 217
BUFOT(4)=DIST(I) ; BUFOT(5)=RMSD(I) ; BUFOT(6)=SIGD(I)#                 QF32 218
ncodefld:(BUFOT,1,CHROT,FM409,6)#                                       QF32 219
IF(WWTT(I)<0.1) movechar:(BLANK,1,CHROT,9,6,1)# Blank bad sigma         QF32 220
IF(I==1) movechar:(QF32G,1,CHROT,46,NQF32G,0)#                          QF32 221
ELSE IF(I==2) movechar:(QF32H,1,CHROT,46,NQF32H,0)#                     QF32 222
ELSE IF(I==3) movechar:(QF32I,1,CHROT,46,NQF32I,0)#                     QF32 223
ELSE IF(I==4) movechar:(QF32J,1,CHROT,46,NQF32J,0)#                     QF32 224
ELSE IF(I==5) movechar:(QF32K,1,CHROT,46,NQF32K,0)#                     QF32 225
ELSE IF(I==6) movechar:(QF32L,1,CHROT,46,NQF32L,0)#                     QF32 226
ELSE IF(I==7) movechar:(QF321,1,CHROT,46,NQF321,0)#                     QF32 227
writeline:(0,QF32E,NQF32E,1,3)#                                         QF32 228
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF32 229
#                                                                       QF32 230
#    ESTIMATE BOND ANGLE VALUES AVERAGE TAU AND SIGMA TAU               QF32 231
#    ----------------------------------------------------               QF32 232
BUFOT(1)=ACOS(1.0-0.5*(DIST(2)/DIST(1))**2) ; BUFOT(2)=0.0#             QF32 233
ARG=RMSD(2)**2-((DIST(2)/DIST(1))*RMSD(1))**2#                          QF32 234
IF(ARG>0.0)#                                                            QF32 235
BUFOT(2)=(DIST(2)*SQRT(ARG)/(SIN(BUFOT(1))*DIST(1)**2))*RTODEG#         QF32 236
BUFOT(1)=BUFOT(1)*RTODEG#                                               QF32 237
ncodefld:(BUFOT,1,QF32M,FM430,2) ; writeline:(1,QF32M,NQF32M,3,4)#      QF32 238
#                                                                       QF32 239
WPSUM=WPSUM+SUMR#                                                       QF32 240
#                                                                       QF32 241
RETURN#                                                                 QF32 242
END#                                                                    QF32 243
systemheader:(QF33)## Set up plane restraints                           QF33   1
####################################################################    QF33   2
#                                                                  #    QF33   3
#                                QF33                              #    QF33   4
#                                                                  #    QF33   5
####################################################################    QF33   6
SUBROUTINE QF33#                       Subroutine plnref(nnap)          QF33   7
#                                            W. hendrickson             QF33   8
include:(AACOMN)#                                                       QF33   9
include:(QFCOMN)#                                                       QF33  10
#                                                                       QF33  11
string:(ATNAM,4)#                                                       QF33  12
REAL AVGR#                                                              QF33  13
REAL D#                                                                 QF33  14
REAL DEL(20)#                                                           QF33  15
REAL DIR(3)#                                                            QF33  16
REAL DS#                                                                QF33  17
REAL GM(3,3)#                                                           QF33  18
INTEGER I,IA,III#                      Loop indices & pointers          QF33  19
INTEGER IHIT#                          Signal find                      QF33  20
INTEGER IHITP#                         Signal planes with big sd        QF33  21
INTEGER ISAR#                                                           QF33  22
INTEGER ISPEP#                                                          QF33  23
INTEGER J,JA,JJ,J1,J2,K,KA,LTP#        Loop indices & pointers          QF33  24
INTEGER LAT(20)#                                                        QF33  25
INTEGER NAP,NN,NNAPA,NNAPP,NUMPA,NUMPP# Loop indices & pointers         QF33  26
string:(PEPNAM,1)#                                                      QF33  27
REAL RMSD#                                                              QF33  28
REAL SSUM#                                                              QF33  29
REAL SUMD#                                                              QF33  30
REAL SUMR#                                                              QF33  31
REAL SUMSA#                                                             QF33  32
REAL SUMSP#                                                             QF33  33
REAL VM(3)#                                                             QF33  34
REAL WTT#                                                               QF33  35
REAL X(3,20)#                                                           QF33  36
chardata:(PLNTY,PEPTIDE  AROMATIC)#                                     QF33  37
chardata:(OXYGE,O   )#                                                  QF33  38
chardata:(PEPS,WYHF)## List of peptides w=trp;y=tyr;h=his;f=phe         QF33  39
chardata:(QF33A, ---EQUATION OF THE PLANE---    RMS     $#              QF33  40
-----DEVIATIONS OF INDIVIDUAL ATOMS-----)#                              QF33  41
chardata:(QF33B,    N RESIDUE    M1     M2     M3    D   $#             QF33  42
DEVIATION  ATOM   DEL  ...   ...)#                                      QF33  43
realdata:(FM105,[50413.,200722.,270722.,340722.,410722.,490822.])#      QF33  44
realdata:(FM106,[620622.,730622.,840622.,950622.,1060622.,$#            QF33  45
1170622.,1270622.])#                                                    QF33  46
chardata:(QF33C,     FOR                 PLANAR GROUPS  $#              QF33  47
INVOLVING       ATOMS THE RMS DEVIATION FROM $#                         QF33  48
PLANARITY =          ANGSTROMS.)#                                       QF33  49
realdata:(FM200,[150513.,540513.,1040842.])#                            QF33  50
chardata:(QF33D,[ SUM(WGT*DELTA**2) =               $#                  QF33  51
AVG(WGT*DELTA**2) =        FOR PLANES])#                                QF33  52
realdata:(FM130,[341471.,610732.])#                                     QF33  53
chardata:(QF33E,[  ROOT 1/WGT =        RMS DELTA =         $#           QF33  54
SIGMA =        RESTRAINTS =       FOR PLANES])#                         QF33  55
realdata:(FM140,[200632.,390632.,550632.,750613.])#                     QF33  56
chardata:(QF33F, NO PLANES HAVE AN RMS DEVIATION GREATER THAN $#        QF33  57
XX.XXX*XX.XXX = XX.XXXXX ANGSTROMS.)#                                   QF33  58
chardata:(QF33G,[ >>>>>>>>>>>>>>>>>>>>>>>> PLANARITY RESTRAINTS $#      QF33  59
<<<<<<<<<<<<<<<<<<<<<<<<<])#           Cha dir                          QF33  60
realdata:(FM141,[520632.,590632.,700852.])#                             QF33  61
datastuff:#                                                             QF33  62
#                                                                       QF33  63
SUMR=0.0 ; SSUM=0.0 ; NNAP=0 ; IHITP=no:# Initialize                    QF33  64
LINRM=10 ; writeline:(4,QF33G,NQF33G,3,3)#                              QF33  65
NNAPP=0#                               No. of peptide plane atoms       QF33  66
SUMSP=0.0#                             Sum of (dev.)**2, peptide plan   QF33  67
NNAPA=0#                               No. aromatic plane groups        QF33  68
SUMSA=0.0#                             Sum of (dev.)**2, aromatic pla   QF33  69
NUMPP=0#                               Number of peptide planes         QF33  70
NUMPA=0#                               Number of aromatic planes        QF33  71
WTT=WPSKAL/SIGP#                                                        QF33  72
#                                                                       QF33  73
writeline:(1,QF33A,NQF33A,3,4)#                                         QF33  74
#                                                                       QF33  75
#    CALCULATE THE CELL NORMALIZATION MATRIX                            QF33  76
#    ---------------------------------------                            QF33  77
#      CALL RECIP(A1,A2,A3,AL,BE,GA,B1,B2,B3,COSA,COSB,COSC)            QF33  78
GM(1,1)=ASTAR**2 ; GM(1,2)=ASTAR*BSTAR*COSGR#                           QF33  79
GM(1,3)=ASTAR*CSTAR*COSBR ; GM(2,1)=GM(1,2) ; GM(2,2)=BSTAR**2#         QF33  80
GM(2,3)=BSTAR*CSTAR*COSAR ; GM(3,1)=GM(1,3) ; GM(3,2)=GM(2,3)#          QF33  81
GM(3,3)=CSTAR**2#                                                       QF33  82
#                                                                       QF33  83
#    CYCLE OVER ALL PLANES OF THE STRUCTURE                             QF33  84
#    --------------------------------------                             QF33  85
DO III=1,NPLN#                                                          QF33  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF33  87
ISAR=0 ; ISPEP=0#                                                       QF33  88
#                                                                       QF33  89
#     READ A PLANE SPECIFICATION RECORD                                 QF33  90
#     ---------------------------------                                 QF33  91
readwpkt:(TINFIL,LRPLA,PSIZ6,GETPK,0)# Read planes constraints          QF33  92
IF(III!=NINT(QX(GETPK+1))\GETPK<=0) iquit:(QF3301)# Rec's must sync     QF33  93
NAP=NINT(QX(GETPK+2)) ; DO IA=1,NAP ; LAT(IA)=NINT(QX(GETPK+IA+2))#     QF33  94
#                                                                       QF33  95
#    DETECT PEPTIDE AND AROMATIC PLANES                                 QF33  96
#    ----------------------------------                                 QF33  97
LTP=(LAT(3)-1)*STEPA+MARKA ; movertoc:(QX(LTP+8),6,ATNAM,1,4,0)#        QF33  98
compchar:(ATNAM,1,OXYGE,1,NOXYGE,NOXYGE,NOXYGE,IHIT)#                   QF33  99
IF(NAP<=6&IHIT==1)#                    Can't be peptide                 QF33 100
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF33 101
ISPEP=1 ; NUMPP=NUMPP+1#                                                QF33 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF33 103
ELSE#                                                                   QF33 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF33 105
#                                                                       QF33 106
#    THOSE PLANES WITH MORE THAN 4 MEMBERS THAT ARE NOT PEPTIDES        QF33 107
#    ARE TESTED TO SEE IF THEY ARE AROMATIC SIDE-CHAIN PLANES           QF33 108
#    -----------------------------------------------------------        QF33 109
LTP=(LAT(1)-1)*STEPA+MARKA ; movertoc:(QX(LTP+8),2,PEPNAM,1,1,0)#       QF33 110
compchar:(PEPNAM,1,PEPS,1,1,1,NPEPS,IHIT)#                              QF33 111
IF(IHIT!=0)#                           If trp, tyr, his, or phe count   QF33 112
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF33 113
ISAR=1 ; NUMPA=NUMPA+1#                                                 QF33 114
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF33 115
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF33 116
#                                                                       QF33 117
#    CALCULATE THE EQUATION OF THIS PLANE                               QF33 118
#    ------------------------------------                               QF33 119
DO J=1,NAP#                                                             QF33 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF33 121
KA=(LAT(J)-1)*STEPA+MARKA#                                              QF33 122
X(1,J)=QX(KA+1) ; X(2,J)=QX(KA+2) ; X(3,J)=QX(KA+3)#                    QF33 123
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF33 124
CALL QF34(NAP,X,VM,D,GM)#              Call plane(nap,x,vm,d,g)         QF33 125
#                                                                       QF33 126
#    CALCULATE DEVIATIONS FROM THE PLANE AND DERIVATIVES                QF33 127
#    ---------------------------------------------------                QF33 128
SUMD=0.0 ; DO JA=1,NAP#                                                 QF33 129
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF33 130
DEL(JA)=0.0 ; DO I=1,3#                                                 QF33 131
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF33 132
DIR(I)=WTT*VM(I) ; DEL(JA)=DEL(JA)+VM(I)*X(I,JA)#                       QF33 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF33 134
DEL(JA)=DEL(JA)-D ; DS=WTT*DEL(JA)#                                     QF33 135
SUMR=SUMR+DS**2 ; SUMD=SUMD+DEL(JA)**2#                                 QF33 136
#                                                                       QF33 137
#    INCREMENT MATRIX ELEMENTS WITHIN ATOM BLOCKS                       QF33 138
#    --------------------------------------------                       QF33 139
KA=LAT(JA) ; NN=6*(KA-1)+2+MARKM ; DO J1=1,3 ; DO J2=J1,3#              QF33 140
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF33 141
QX(NN)=QX(NN)+DIR(J1)*DIR(J2) ; NN=NN+1#                                QF33 142
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF33 143
#                                                                       QF33 144
#    INCREMENT VECTOR ELEMENTS                                          QF33 145
#    -------------------------                                          QF33 146
NN=3*(KA-1)+2+MARKV ; DO JJ=1,3#                                        QF33 147
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF33 148
QX(NN)=QX(NN)-DS*DIR(JJ) ; NN=NN+1#                                     QF33 149
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF33 150
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF33 151
#                                                                       QF33 152
#    PRINT OUT DEVIATION FOR THIS PLANE                                 QF33 153
#    ----------------------------------                                 QF33 154
SSUM=SSUM+SUMD ; NNAP=NNAP+NAP#                                         QF33 155
SUMSP=FLOAT(ISPEP)*SUMD+SUMSP ; SUMSA=FLOAT(ISAR)*SUMD+SUMSA#           QF33 156
NNAPP=FLOAT(ISPEP)*NAP+NNAPP ; NNAPA=FLOAT(ISAR)*NAP+NNAPA#             QF33 157
RMSD=SQRT(SUMD/FLOAT(NAP))#                                             QF33 158
#                                                                       QF33 159
#    OUPUT ONLY THOSE PLANES WHOSE ATOMS HAVE AN RMS DEVIATION          QF33 160
#    GREATER THAN (PLCUT*SIGP) WHERE PLCUT AND SIGP ARE INPUT.          QF33 161
#    ---------------------------------------------------------          QF33 162
IF(RMSD>=PLCUT*SIGP)#                                                   QF33 163
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF33 164
IHITP=yes:#                            Signal a hit                     QF33 165
#                                                                       QF33 166
#    OUTPUT ATOM NAMES INSTEAD OF NUMBERS                               QF33 167
#    ------------------------------------                               QF33 168
LTP=(LAT(1)-1)*STEPA+MARKA ; movertoc:(QX(LTP+8),2,CHROT,7,4,0)#        QF33 169
BUFOT(1)=FLOAT(III) ; BUFOT(2)=VM(1) ; BUFOT(3)=VM(2)#                  QF33 170
BUFOT(4)=VM(3) ; BUFOT(5)=D ; BUFOT(6)=RMSD#                            QF33 171
ncodefld:(BUFOT,1,CHROT,FM105,6)#                                       QF33 172
K=0 ; DO I=1,NAP#                                                       QF33 173
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF33 174
IF(K>6)#                                                                QF33 175
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF33 176
ncodefld:(BUFOT,1,CHROT,FM106,K);writeline:(0,QF33B,NQF33B,1,4);K=0#    QF33 177
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF33 178
LTP=(LAT(1)-1)*STEPA+MARKA;movertoc:(QX(LTP+8),6,CHROT,K*11+53,4,0)#    QF33 179
K=K+1 ; BUFOT(K)=DEL(I)#                                                QF33 180
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF33 181
ncodefld:(BUFOT,1,CHROT,FM106,K);writeline:(0,QF33B,NQF33B,1,4)#        QF33 182
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF33 183
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF33 184
#                                                                       QF33 185
#    PROCESSING OF PLANES IS COMPLETED                                  QF33 186
#    ---------------------------------                                  QF33 187
IF(IHITP==no:)#                        Tell that no planes bad          QF33 188
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF33 189
BUFOT(1)=PLCUT ; BUFOT(2)=SIGP ; BUFOT(3)=PLCUT*SIGP#                   QF33 190
ncodefld:(BUFOT,1,QF33F,FM141,3) ; writeline:(1,QF33F,NQF33F,3,3)#      QF33 191
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF33 192
AVGR=SUMR/FLOAT(NNAP) ; RMSD = SQRT(SSUM/FLOAT(NNAP))#                  QF33 193
BUFOT(1)=SUMR ; BUFOT(2)=AVGR#                                          QF33 194
ncodefld:(BUFOT,1,QF33D,FM130,2) ; writeline:(1,QF33D,NQF33D,3,3)#      QF33 195
BUFOT(1)=1.0/AMAX1(0.1,WTT) ; BUFOT(2)=RMSD#                            QF33 196
BUFOT(3)=SIGP ; BUFOT(4)=FLOAT(NNAP)#                                   QF33 197
ncodefld:(BUFOT,1,QF33E,FM140,4) ; writeline:(1,QF33E,NQF33E,3,3)#      QF33 198
#                                                                       QF33 199
IF(NNAPP!=0) RMSD=SQRT(SUMSP/FLOAT(NNAPP))#                             QF33 200
ELSE         RMSD=0.0#                                                  QF33 201
BUFOT(1)=FLOAT(NUMPP) ; BUFOT(2)=FLOAT(NNAPP)#                          QF33 202
BUFOT(3)=RMSD ; ncodefld:(BUFOT,1,QF33C,FM200,3)#                       QF33 203
movechar:(PLNTY,1,QF33C,17,8,0) ; writeline:(1,QF33C,NQF33C,3,3)#       QF33 204
IF(NNAPA!=0) RMSD=SQRT(SUMSA/FLOAT(NNAPA))#                             QF33 205
ELSE RMSD=0.0#                                                          QF33 206
BUFOT(1)=FLOAT(NUMPA) ; BUFOT(2)=FLOAT(NNAPA)#                          QF33 207
BUFOT(3)=RMSD ; ncodefld:(BUFOT,1,QF33C,FM200,3)#                       QF33 208
movechar:(PLNTY,10,QF33C,17,8,0) ; writeline:(1,QF33C,NQF33C,3,3)#      QF33 209
#                                                                       QF33 210
WPSUM=WPSUM+SUMR#                                                       QF33 211
#                                                                       QF33 212
RETURN#                                                                 QF33 213
END#                                                                    QF33 214
systemheader:(QF34)## Schomaker least-squares plane from points         QF34   1
####################################################################    QF34   2
#                                                                  #    QF34   3
#                                QF34                              #    QF34   4
#                                                                  #    QF34   5
####################################################################    QF34   6
SUBROUTINE QF34(N,X,VM,D,GM)## SUBROUTINE PLANE(N,X,VM,D,GM)            QF34   7
#                                  J. KONNERT W. HENDRICKSON            QF34   8
#                                                                       QF34   9
#    FIT A LEAST-SQUARES PLANE TO A SET OF POINTS                       QF34  10
#    PROCEDURE OF SCHOMAKER ET AL.(ACTA CRYST.,12,600,1959)             QF34  11
#    ------------------------------------------------------             QF34  12
#                                                                       QF34  13
include:(AACOMN)#                                                       QF34  14
include:(QFCOMN)#                                                       QF34  15
#                                                                       QF34  16
REAL ADJ(3,3)#                                                          QF34  17
REAL BV(3)#                                                             QF34  18
REAL D#                                                                 QF34  19
REAL GM(3,3)#                                                           QF34  20
INTEGER I,J,K,KK,NNN#                                                   QF34  21
REAL ORM#                                                               QF34  22
REAL RATIO1,RATIO2,RATIO3#                                              QF34  23
REAL RAT12,RAT13#                                                       QF34  24
REAL SN#                                                                QF34  25
REAL VM(3)#                                                             QF34  26
REAL VMI(3)#                                                            QF34  27
REAL VM1#                                                               QF34  28
REAL X(3,20)#                                                           QF34  29
REAL XS(3)#                                                             QF34  30
REAL XXS(3,3)#                                                          QF34  31
REAL ZB(3,3)#                                                           QF34  32
REAL ZA(3,3)#                                                           QF34  33
realdata:(ZIP,[1.0E-5])#                                                QF34  34
intdata:(MM,[10])#                                                      QF34  35
datastuff:#                                                             QF34  36
#                                                                       QF34  37
SN=FLOAT(N) ; DO I=1,3#                Set up the a matrix              QF34  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF34  39
XS(I)=0.0 ; DO K=1,N ; XS(I)=XS(I)+X(I,K)#                              QF34  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF34  41
DO I=1,3 ; DO J=1,3#                                                    QF34  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF34  43
XXS(I,J)=0.0 ; DO K=1,N ; XXS(I,J)=XXS(I,J)+X(I,K)*X(J,K)#              QF34  44
ZA(I,J)=XXS(I,J)-XS(I)*XS(J)/SN#                                        QF34  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF34  46
#                                                                       QF34  47
#     EVALUATE MATRIX B=ADJ(A)*G                                        QF34  48
ADJ(1,1)=ZA(2,2)*ZA(3,3)-ZA(2,3)*ZA(3,2)#                               QF34  49
ADJ(2,1)=ZA(3,1)*ZA(2,3)-ZA(2,1)*ZA(3,3)#                               QF34  50
ADJ(3,1)=ZA(2,1)*ZA(3,2)-ZA(3,1)*ZA(2,2)#                               QF34  51
ADJ(1,2)=ZA(3,2)*ZA(1,3)-ZA(1,2)*ZA(3,3)#                               QF34  52
ADJ(2,2)=ZA(1,1)*ZA(3,3)-ZA(3,1)*ZA(1,3)#                               QF34  53
ADJ(3,2)=ZA(3,1)*ZA(1,2)-ZA(1,1)*ZA(3,2)#                               QF34  54
ADJ(1,3)=ZA(1,2)*ZA(2,3)-ZA(1,3)*ZA(2,2)#                               QF34  55
ADJ(2,3)=ZA(2,1)*ZA(1,3)-ZA(1,1)*ZA(2,3)#                               QF34  56
ADJ(3,3)=ZA(1,1)*ZA(2,2)-ZA(2,1)*ZA(1,2)#                               QF34  57
DO I=1,3 ; DO J=1,3#                                                    QF34  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF34  59
ZB(I,J)=0.0 ; DO K=1,3 ; ZB(I,J)=ZB(I,J)+ADJ(I,K)*GM(K,J)#              QF34  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF34  61
#                                                                       QF34  62
#     CHOOSE THE LARGEST COLUMN VECTOR OF B AS THE INITIAL SOLUTION     QF34  63
BV(1)=ZB(1,1)**2+ZB(2,1)**2+ZB(3,1)**2#                                 QF34  64
BV(2)=ZB(1,2)**2+ZB(2,2)**2+ZB(3,2)**2#                                 QF34  65
BV(3)=ZB(1,3)**2+ZB(2,3)**2+ZB(3,3)**2#                                 QF34  66
KK=1 ; IF(BV(2)>BV( 1)) KK=2 ; IF(BV(3)>BV(KK)) KK=3#                   QF34  67
VM1=ZB(1,KK) ; DO I=1,3 ; VMI(I)=ZB(I,KK)/VM1#                          QF34  68
#                                                                       QF34  69
#    SOLVE TO CONVERGENCE BY ITERATION OF M(I)=B*M(I-1)                 QF34  70
DO NNN=1,MM#                                                            QF34  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF34  72
VM(1)=ZB(1,1)*VMI(1)+ZB(1,2)*VMI(2)+ZB(1,3)*VMI(3)#                     QF34  73
VM(2)=ZB(2,1)*VMI(1)+ZB(2,2)*VMI(2)+ZB(2,3)*VMI(3)#                     QF34  74
VM(3)=ZB(3,1)*VMI(1)+ZB(3,2)*VMI(2)+ZB(3,3)*VMI(3)#                     QF34  75
RATIO1=VM(1)/VMI(1) ; RATIO2=VM(2)/VMI(2) ; RATIO3=VM(3)/VMI(3)#        QF34  76
RAT12=ABS(RATIO2/RATIO1-1.0) ; RAT13=ABS(RATIO3/RATIO1-1.0)#            QF34  77
IF(RAT12<ZIP&RAT13<ZIP) BREAK#                                          QF34  78
DO I=1,3 ; VMI(I)=VM(I)/VM(1)#                                          QF34  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF34  80
#                                                                       QF34  81
# NORMALIZE SOLUTION VECTOR; EVALUATE D (PLANE TO ORIGIN DISTANCE)      QF34  82
ORM=0.0 ; DO I=1,3 ; DO J=1,3 ; ORM=ORM+VM(I)*VM(J)*GM(I,J)#            QF34  83
ORM=SQRT(ORM) ; DO I=1,3 ; VM(I)=VM(I)/ORM#                             QF34  84
D=(VM(1)*XS(1)+VM(2)*XS(2)+VM(3)*XS(3))/SN#                             QF34  85
#                                                                       QF34  86
RETURN#                                                                 QF34  87
END#                                                                    QF34  88
systemheader:(QF35)## Set up chiral center restraints                   QF35   1
####################################################################    QF35   2
#                                                                  #    QF35   3
#                                QF35                              #    QF35   4
#                                                                  #    QF35   5
####################################################################    QF35   6
SUBROUTINE QF35#                       Subroutine chiref                QF35   7
#                                          W. hendrickson               QF35   8
include:(AACOMN)#                                                       QF35   9
include:(QFCOMN)#                                                       QF35  10
#                                                                       QF35  11
REAL AVGR#                                                              QF35  12
REAL DELV#                                                              QF35  13
REAL DIR(4,3)#                                                          QF35  14
REAL DS#                                                                QF35  15
REAL DX,DY,DZ#                                                          QF35  16
INTEGER I,IA,IC,ICK,ICKP,ICP,ID,IP,IPP,IQ,IX# Loop indices & pointers   QF35  17
INTEGER IAMBAD#                                                         QF35  18
INTEGER IATOM(4)#                                                       QF35  19
INTEGER IDIST(6)#                                                       QF35  20
INTEGER J,JA,JX,K,L,L1,M,NN#           Loop indices & pointers          QF35  21
REAL QF05#                             3x3 determinant function         QF35  22
REAL RMSD#                                                              QF35  23
REAL SUMD,SUMR#                                                         QF35  24
REAL VIDEAL,VOBS#                                                       QF35  25
REAL WTT#                                                               QF35  26
REAL ZA(3,3)#                                                           QF35  27
REAL ZB(3,3)#                                                           QF35  28
chardata:(ASTR,[*])#                                                    QF35  29
chardata:(QF35A, CENTRAL  CHIRAL VOLUME    CENTRAL  CHIRAL $#           QF35  30
VOLUME    CENTRAL  CHIRAL VOLUME    CENTRAL  CHIRAL $#                  QF35  31
VOLUME    CENTRAL  CHIRAL VOLUME   )#                                   QF35  32
chardata:(QF35B,   ATOM    IDEAL MODEL       ATOM    IDEAL $#           QF35  33
MODEL       ATOM    IDEAL MODEL       ATOM    IDEAL $#                  QF35  34
MODEL       ATOM    IDEAL MODEL    )#                                   QF35  35
realdata:(FM125,[160622.,220622.,420622.,480622.,680622.,740622.,$#     QF35  36
940622.,1000622.,1200622.,1260622.])#                                   QF35  37
realdata:(FM130,[341471.,620732.])#                                     QF35  38
realdata:(FM140,[220632.,410632.,550632.,770613.])#                     QF35  39
chardata:(QF35C,[ SUM(WGT*DELTA**2) =                $#                 QF35  40
AVG(WGT*DELTA**2) =         FOR CHIRAL CENTERS])#                       QF35  41
chardata:(QF35D,[  ROOT 1/WGT =          RMS DELTA =       $#           QF35  42
SIGMA =        DELTA > 1.0 =        FOR CHIRAL CENTERS])#               QF35  43
chardata:(QF35E,[ >>>>>>>>>>>>>>>>>>>>>>>> CHIRAL CENTER RESTRAINTS $#  QF35  44
<<<<<<<<<<<<<<<<<<<<<<<<<])#                                            QF35  45
datastuff:#                                                             QF35  46
# IN THIS ROUTINE THE OLD VARIABLES VI, VIO, VM, VMO, LA, & LAO WERE    QF35  47
# WERE ALL IN THE 'SCRATCH' COMMON ARRAY. HERE THEY ARE ALL IN THE      QF35  48
# MARKT ARRAY AS +1, +2, +3, +4, +5, & +6 TO (I-1)*STEPT+MARKT.         QF35  49
STEPT=6#                               Set step for routine             QF35  50
L1=6*NA+1 ; SUMR=0.0 ; SUMD=0.0 ; WTT=WCSKAL/SIGC#                      QF35  51
LINRM=10 ; writeline:(4,QF35E,NQF35E,3,3)# Write heading                QF35  52
#                                                                       QF35  53
#    CYCLE OVER ALL CHIRAL CENTERS                                      QF35  54
#    -----------------------------                                      QF35  55
DO IC=1,NCHR#                                                           QF35  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF35  57
ICP=(IC-1)*STEPT+MARKT#                                                 QF35  58
#                                                                       QF35  59
#    READ A CHIRAL CENTER CONSTRAINT SPECIFICATION RECORD               QF35  60
#    ----------------------------------------------------               QF35  61
readwpkt:(TINFIL,LRCHI,PSIZ6,GETPK,0)# Read chiral constraints          QF35  62
IF(IC!=NINT(QX(GETPK+1))\GETPK<=0) iquit:(QF3501)# Rec's must sync!     QF35  63
DO I=1,4 ; IATOM(I)=NINT(QX(GETPK+I+1))#                                QF35  64
DO I=1,6 ; IDIST(I)=NINT(QX(GETPK+I+5))#                                QF35  65
VIDEAL=QX(GETPK+12)#                                                    QF35  66
#                                                                       QF35  67
#    CALCULATE THE MODEL CHIRAL VOLUME                                  QF35  68
#    ---------------------------------                                  QF35  69
IA=(IATOM(1)-1)*STEPA+MARKA ; DO I=1,3#                                 QF35  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF35  71
IQ=(IATOM(I+1)-1)*STEPA+MARKA ; DX=QX(IQ+1)-QX(IA+1)#                   QF35  72
DY=QX(IQ+2)-QX(IA+2)#                                                   QF35  73
DZ=QX(IQ+3)-QX(IA+3) ;ZA(I,1)=ORXX*DX+ORXY*DY+ORXZ*DZ#                  QF35  74
ZA(I,2)=ORYY*DY+ORYZ*DZ ; ZA(I,3)=ORZZ*DZ#                              QF35  75
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF35  76
#                                                                       QF35  77
#    SAVE DATA FOR LISTING                                              QF35  78
VOBS=QF05(ZA)#                         Get determinant                  QF35  79
QX(ICP+1)=VIDEAL#                      Vi(ic)=videal                    QF35  80
QX(ICP+3)=VOBS#                        Vm(ic)=vobs                      QF35  81
QX(ICP+5)=FLOAT(IATOM(1))#             La(ic)=iatom(1)                  QF35  82
#                                                                       QF35  83
#    CALCULATE RESIDUAL                                                 QF35  84
#    ------------------                                                 QF35  85
DELV=VIDEAL-VOBS ; DS=WTT*DELV ; SUMR=SUMR+DS**2 ; SUMD=SUMD+DELV**2#   QF35  86
#                                                                       QF35  87
#    CALCULATE DERIVATIVES                                              QF35  88
DO IA=1,3 ; DO IX=1,3#                                                  QF35  89
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF35  90
DO J=1,3#                                                               QF35  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF35  92
DO I=1,3 ; ZB(I,J)=ZA(I,J)#                                             QF35  93
ZB(IA,J)=GT(IX,J)#                     Gt is t'pose of fract to orth    QF35  94
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF35  95
DIR(IA+1,IX)=WTT*QF05(ZB)#             Get determinant                  QF35  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF35  97
DO IX=1,3#                                                              QF35  98
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF35  99
DIR(1,IX)=-(DIR(2,IX)+DIR(3,IX)+DIR(4,IX))#                             QF35 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF35 101
#                                                                       QF35 102
#    INCREMENT MATRIX ELEMENTS WITHIN ATOM BLOCKS                       QF35 103
DO IA=1,4#                                                              QF35 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF35 105
IQ=IATOM(IA) ; NN=6*(IQ-1)+1+MARKM ; DO I=1,3 ; DO J=I,3#               QF35 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF35 107
NN=NN+1 ; QX(NN)=QX(NN)+DIR(IA,I)*DIR(IA,J)#                            QF35 108
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF35 109
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF35 110
#                                                                       QF35 111
#    INCREMENT MATRIX ELEMENTS WITHIN DISTANCE BLOCKS                   QF35 112
#    ------------------------------------------------                   QF35 113
M=0 ; DO IA=1,3#                                                        QF35 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF35 115
L=IA+1 ; DO JA=L,4#                                                     QF35 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF35 117
M=M+1 ; ID=IDIST(M) ; IF(ID>=0)#                                        QF35 118
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF35 119
NN=L1+9*(ID-1)+MARKM ; DO IX=1,3 ; DO JX=1,3#                           QF35 120
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF35 121
NN=NN+1 ; QX(NN)=QX(NN)+DIR(IA,IX)*DIR(JA,JX)#                          QF35 122
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF35 123
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF35 124
ELSE#                                                                   QF35 125
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF35 126
ID=-ID ; NN=L1+9*(ID-1)+MARKM ; DO JX=1,3 ; DO IX=1,3#                  QF35 127
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF35 128
NN=NN+1 ; QX(NN)=QX(NN)+DIR(IA,IX)*DIR(JA,JX)#                          QF35 129
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF35 130
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF35 131
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF35 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF35 133
#                                                                       QF35 134
#    INCREMENT VECTOR ELEMENTS                                          QF35 135
#    -------------------------                                          QF35 136
DO IA=1,4#                                                              QF35 137
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF35 138
IQ=IATOM(IA) ; NN=3*(IQ-1)+1+MARKV ; DO IX=1,3#                         QF35 139
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF35 140
NN=NN+1 ; QX(NN)=QX(NN)+DS*DIR(IA,IX)#                                  QF35 141
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF35 142
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF35 143
#    END OF LOOP OVER CHIRAL CENTERS                                    QF35 144
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF35 145
#                                                                       QF35 146
#    PRINT OUT CHIRAL VOLUMES AND DISCREPANCY AVERAGES                  QF35 147
#    -------------------------------------------------                  QF35 148
#                                                                       QF35 149
#    THREE OUTPUT OPTIONS SELECTED BY ICHIP:                            QF35 150
#    ICHIP=0    PRINT OVERALL STATS ONLY                                QF35 151
#         =1    PRINT BAD CASES ONLY  ( SEE BELOW )                     QF35 152
#         =2    PRINT DATA FOR ALL CHIRAL CENTERS                       QF35 153
#    BAD CHIRAL CENTERS ARE THOSE WHOSE CHIRAL VOLUME DIFFERS           QF35 154
#    BY MORE THAN 1.0 FROM THE IDEAL VALUE. THIS IS ABOUT               QF35 155
#    A 40% DISCREPANCY FOR ALPHA CARBON CENTERS.                        QF35 156
#                                                                       QF35 157
writeline:(1,QF35A,NQF35A,3,4) ; writeline:(0,QF35B,NQF35B,3,4)#        QF35 158
IF(ICHIP!=0)#                                                           QF35 159
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF35 160
LINRM=6 ; IAMBAD=0 ; DO IC=1,NCHR#                                      QF35 161
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QF35 162
#     IF(ABS(VI(IC)-VM(IC))<1.0) NEXT ; IAMBAD=IAMBAD+1#                QF35 163
IF(ABS(QX(ICP+1)-QX(ICP+3))<1.0) NEXT ; IAMBAD=IAMBAD+1#                QF35 164
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QF35 165
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF35 166
IF(ICHIP!=1)#                                                           QF35 167
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QF35 168
K=0 ; DO I=1,NCHR#                                                      QF35 169
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QF35 170
IP=(I-1)*STEPT+MARKT ; IF(K>4)#        Is line full?                    QF35 171
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QF35 172
ncodefld:(BUFOT,1,CHROT,FM125,10);writeline:(0,QF35B,NQF35B,1,4);K=0#   QF35 173
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QF35 174
BUFOT(2*K+1)=QX(IP+1) ; BUFOT(2*K+2)=QX(IP+3) ; K=K+1#                  QF35 175
IPP=(NINT(QX(IP+5))-1)*STEPA+MARKA#    Point to atom                    QF35 176
movertoc:(QX(IPP+8),1,CHROT,(K-1)*26+2,8,0)#                            QF35 177
IF(ABS(QX(I+1)-QX(IP+3))>=1.0)#                                         QF35 178
movechar:(ASTR,1,CHROT,(K-1)*26+23,NASTR,0)#                            QF35 179
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QF35 180
ncodefld:(BUFOT,1,CHROT,FM125,2*K);writeline:(0,QF35B,NQF35B,1,4)#      QF35 181
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QF35 182
ELSE IF(IAMBAD!=0)#                                                     QF35 183
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QF35 184
LINRM=6 ; ICK=0 ; DO I=1,NCHR#                                          QF35 185
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QF35 186
IP=(I-1)*STEPT+MARKT#                                                   QF35 187
IF(ABS(QX(IP+1)-QX(IP+3))<1.0) NEXT#                                    QF35 188
ICKP=ICK*STEPT+MARKT ; ICK=1+ICK#                                       QF35 189
QX(ICKP+2)=QX(IP+1)#                   Vio(ick)=vi(i)                   QF35 190
QX(ICKP+4)=QX(IP+3)#                   Vmo(ick)=vm(i)                   QF35 191
QX(ICKP+6)=QX(IP+5)#                   Lao(ick)=la(i)                   QF35 192
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QF35 193
K=0 ; DO I=1,IAMBAD#                                                    QF35 194
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QF35 195
IP=(I-1)*STEPT+MARKT#                                                   QF35 196
IF(K>4)#                               Is line full?                    QF35 197
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QF35 198
ncodefld:(BUFOT,1,CHROT,FM125,10);writeline:(0,QF35B,NQF35B,1,4);K=0#   QF35 199
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QF35 200
BUFOT(2*K+1)=QX(IP+2) ; BUFOT(2*K+2)=QX(IP+4) ; K=K+1#                  QF35 201
IPP=(NINT(QX(IP+6))-1)*STEPA+MARKA#    Point to atom                    QF35 202
movertoc:(QX(IPP+8),1,CHROT,(K-1)*26+2,8,0)# Move atom name             QF35 203
IF(ABS(QX(IP+2)-QX(IP+4))>=1.0)#                                        QF35 204
movechar:(ASTR,1,CHROT,(K-1)*26+23,NASTR,0)#                            QF35 205
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QF35 206
ncodefld:(BUFOT,1,CHROT,FM125,2*K);writeline:(0,QF35B,NQF35B,1,4)#      QF35 207
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QF35 208
AVGR=SUMR/FLOAT(NCHR) ; RMSD=SQRT(SUMD/FLOAT(NCHR))#                    QF35 209
WPSUM=WPSUM+SUMR#                                                       QF35 210
BUFOT(1)=SUMR ; BUFOT(2)=AVGR ; ncodefld:(BUFOT,1,QF35C,FM130,2)#       QF35 211
writeline:(1,QF35C,NQF35C,3,3)#                                         QF35 212
BUFOT(1)=1.0/AMAX1(0.1,WTT) ; BUFOT(2)=RMSD#                            QF35 213
BUFOT(3)=SIGC ; BUFOT(4)=IAMBAD#                                        QF35 214
ncodefld:(BUFOT,1,QF35D,FM140,4) ; writeline:(1,QF35D,NQF35D,3,3)#      QF35 215
#                                                                       QF35 216
RETURN#                                                                 QF35 217
END#                                                                    QF35 218
systemheader:(QF36)## Set up van der Waals restraints                   QF36   1
####################################################################    QF36   2
#                                                                  #    QF36   3
#                                QF36                              #    QF36   4
#                                                                  #    QF36   5
####################################################################    QF36   6
SUBROUTINE QF36#                       Subroutine vdwref                QF36   7
#                                           W. hendrickson              QF36   8
include:(AACOMN)#                                                       QF36   9
include:(QFCOMN)#                                                       QF36  10
#                                                                       QF36  11
REAL CONTCT#                                                            QF36  12
REAL DDR#                                                               QF36  13
REAL DELTA#                                                             QF36  14
REAL DIR(6)#                                                            QF36  15
REAL DIR1,DIR2,DIR3#                                                    QF36  16
REAL DISFN#                                                             QF36  17
REAL DOBS#                                                              QF36  18
REAL DS#                                                                QF36  19
REAL DSUM(4)#                                                           QF36  20
REAL DVDW#                                                              QF36  21
REAL DX,DY,DZ#                                                          QF36  22
INTEGER I,IA,ICONT,ID,IDIS,IHB,IHBD,IHIT#                               QF36  23
INTEGER II,IIA,IID,IIDIS,IIDIT,IIID,IIT#                                QF36  24
INTEGER IJ,IJA,IJHB,IJHT#                                               QF36  25
INTEGER INEED,INEEDD,INEEDT,ISYM,ISYMOP,IVDW#                           QF36  26
INTEGER IUCX,IUCY,IUCZ#                                                 QF36  27
INTEGER J,JA,JHB,JK,JO,JP,JS,JT,JV#                                     QF36  28
INTEGER K,KS,KTYP#                                                      QF36  29
INTEGER LTYP,L1,M,MM#                                                   QF36  30
INTEGER N,NCLASS,NCONT,NEXP,NN,NWTD#                                    QF36  31
INTEGER JSYMOP(192)#                                                    QF36  32
INTEGER NSUM(4)#                                                        QF36  33
INTEGER FIRST#                                                          QF36  34
REAL RMSD(4)#                                                           QF36  35
REAL SUMR#                                                              QF36  36
REAL TXYZ(3)#                                                           QF36  37
REAL UCTRNS(3)#                                                         QF36  38
REAL WTT#                                                               QF36  39
REAL XYZ(3)#                                                            QF36  40
realdata:(FM42,[50513.,100512.,150512.,200512.,250512.,300512.,$#       QF36  41
350512.,400512.,450512.,500512.,560622.,620622.,680622.])#              QF36  42
chardata:(QF36A,   **** SINGLE-TORSION CONTACTS ****    )#              QF36  43
chardata:(QF36B,  **** MULTIPLE-TORSION CONTACTS ****   )#              QF36  44
chardata:(QF36C, *** POSSIBLE X...Y HYDROGEN BONDS ***  )#              QF36  45
chardata:(QF36D, *** POSSIBLE X-H.Y HYDROGEN BONDS ***  )#              QF36  46
chardata:(QF36E, THE FOLLOWING SYMMETRY CONTACTS ARE $#                 QF36  47
RELATED TO THE )#                                                       QF36  48
chardata:(QF36F, PRINCIPAL MOLECULE BY THE INDICATED $#                 QF36  49
TRANSFORMATION )#                                                       QF36  50
realdata:(ALLOW,[0.0,0.0,0.3,0.4])#                                     QF36  51
chardata:(QF36G,[ ATOM(I) HAS BEEN TRANSFORMED BY OPERATOR     $#       QF36  52
AND TRANSLATED BY           UNIT CELLS])#                               QF36  53
realdata:(FM46,[450313.,670313.,700313.,730313.])#                      QF36  54
realdata:(FM50,[250632.,310632.,560632.,630632.,870632.,940632.,$#      QF36  55
1180632.,1250632.])#                                                    QF36  56
chardata:(QF36H,[   ATOM(I) ATOM(J)  IDEAL MODEL   $#                   QF36  57
ATOM(I) ATOM(J)  IDEAL MODEL   ATOM(I) ATOM(J)  IDEAL MODEL   $#        QF36  58
ATOM(I) ATOM(J)  IDEAL MODEL])#                                         QF36  59
intdata:(PUTNAM,[3,12,34,43,65,74,96,105])#                             QF36  60
realdata:(FM66,[450413.,1230522.])#                                     QF36  61
chardata:(QF36I,[ RESTRAINTS HAVE NOT BEEN APPLIED FOR THE     $#       QF36  62
POSSIBLE HYDROGEN BONDS WITH DISTANCES IN THE RANGE $#                  QF36  63
(IDEAL < D < IDEAL +      )])#                                          QF36  64
realdata:(FM55,[341471.,610732.])#                                      QF36  65
chardata:(QF36J,[ SUM(WGT*DELTA**2) =               $#                  QF36  66
AVG(WGT*DELTA**2) =        FOR NON-BONDED CONTACTS])#                   QF36  67
chardata:(QF36K,         ROOT          RMS)#                            QF36  68
chardata:(QF36L,[  TYPE  (1/WGT)**  NUMBER  DELTA   SIGMA    DINC   $#  QF36  69
CONTACT TYPE])#                                                         QF36  70
realdata:(FM409,[50413.,130632.,240613.,320832.,$#                      QF36  71
400832.,480832.])#                                                      QF36  72
chardata:(QF36N, SINGLE-TORSION CONTACT)#                               QF36  73
chardata:(QF36O, MULTIPLE-TORSION CONTACT)#                             QF36  74
chardata:(QF36P,[ POSSIBLE (X....Y) H-BOND])#                           QF36  75
chardata:(QF36Q,[ POSSIBLE (X-H..Y) H-BOND])#                           QF36  76
chardata:(QF36R, BOND CONTACTS  VANDERWAAL CONTACTS  TYPE 1 $#          QF36  77
H-BONDS  TYPE 2 H-BONDS  TYPE 3 H-BONDS)#                               QF36  78
realdata:(FM77,[140613.,340613.,480613.,640613.,800613.])#              QF36  79
chardata:(QF36S,       R11  R12  R13  R21  R22  R23  R31  $#            QF36  80
R32  R33    T1    T2    T3)#                                            QF36  81
chardata:(QF36T,[ >>>>>>>>>>>>>>>>>>>>>>>> NON-BONDING DISTANCE $#      QF36  82
RESTRAINTS <<<<<<<<<<<<<<<<<<<<<<<<<])#                                 QF36  83
chardata:(QF36U,[ ATOMS NO.        AND        ARE ESSENTIALLY $#        QF36  84
COINCIDENT... WHY?  RUN CONTINUES ***********WARNING***********])#      QF36  85
realdata:(FMDO,[170613.,280613.])#                                      QF36  86
datastuff:#                                                             QF36  87
#                                                                       QF36  88
# STORAGE OF THE DISTANCE INFORMATION GOES INTO THE MARKD ARRAY         QF36  89
# IN STEPS OF STEPD. IN TERMS OF THE ORIGINAL VARIABLES THE             QF36  90
# FOLLOWING EQUIVALENCE HOLDS, WHERE IJHB=STEPD*(JHB-1)+MARKD:          QF36  91
# QX(IJHB+1) IS NO(JHB), ALIAS NE(JHB). QX(IJHB+2) IS NT(JHB)           QF36  92
# ALIAS NZ(JHB) IN OTHER SUBROUTINES.  QX(IJHB+3) IS NWTB(JHB)          QF36  93
# STORAGE OF THE 'SCRATCH' INFORMATION GOES INTO THE MARKT ARRAY        QF36  94
# IN STEPS OF STEPT. IN TERMS OF THE ORIGINAL VARIABLES THE             QF36  95
# FOLLOWING EQUIVALENCE HOLDS, WHERE IJHT=STEPT*(JHT-1)+MARKT:          QF36  96
# QX(IJHT+1) IS DIS(JHT)    QX(IJHT+2) IS DISA(JHT)                     QF36  97
# QX(IJHT+3) IS NWTD(JHT) AND/OR LO(JHT)                                QF36  98
# QX(IJHT+4) IS LT(JHT)     QX(IJHT+5) IS ISYM(JHT)                     QF36  99
#                                                                       QF36 100
SUMR=0.0 ; NEXP=2 ; L1=6*NA+9*NDIS+1 ; IVDW=0 ; IHB=0#                  QF36 101
JV=0 ; NCONT=0 ; NHBD=0 ; STEPT=5#                                      QF36 102
ncodefld:(FLOAT(NEXP),1,QF36L,180113.,1)# Put sigma to wt exp in head   QF36 103
LINRM=10 ; writeline:(4,QF36T,NQF36T,3,3)# Head listing                 QF36 104
#                                                                       QF36 105
#     SET THE DISTANCE WEIGHTING SCHEME                                 QF36 106
NCLASS=4 ; DO I=1,NCLASS#                                               QF36 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF36 108
DSUM(I)=0.0 ; NSUM(I)=0#                                                QF36 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF36 110
WTT=WVSKAL/(SIGV**NEXP)#                                                QF36 111
#                                                                       QF36 112
#     READ THE DISTANCE INFORMATION                                     QF36 113
#     -----------------------------                                     QF36 114
IF(NVDW!=0)#                                                            QF36 115
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF36 116
DO I=1,NVDW#                                                            QF36 117
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF36 118
readwpkt:(TINFIL,LRVDW,PSIZ6,GETPK,0)# Read van der waals constraints   QF36 119
IF(I!=NINT(QX(GETPK+1))\GETPK<=0) iquit:(QF3601)# Rec's must sync!      QF36 120
IA=NINT(QX(GETPK+2)) ; JA=NINT(QX(GETPK+3))#                            QF36 121
LTYP=NINT(QX(GETPK+5)) ; DVDW=QX(GETPK+4)#                              QF36 122
IIA=STEPA*(IA-1)+MARKA ; IJA=STEPA*(JA-1)+MARKA ; KTYP=MOD(LTYP,10)#    QF36 123
#                                                                       QF36 124
#     DETERMINE SYMMETRY OPERATOR, IF ANY                               QF36 125
IHIT=no: ; ISYMOP=LTYP/10 ; IF(ISYMOP!=0)#                              QF36 126
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF36 127
UCTRNS(3)=FLOAT(MOD(ISYMOP    ,10)-5)#                                  QF36 128
UCTRNS(2)=FLOAT(MOD(ISYMOP/10 ,10)-5)#                                  QF36 129
UCTRNS(1)=FLOAT(MOD(ISYMOP/100,10)-5)#                                  QF36 130
JS=ISYMOP/1000 ; IF(NCONT!=0)#                                          QF36 131
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF36 132
DO KS=1,NCONT#                                                          QF36 133
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF36 134
ICONT=KS ; IF(JSYMOP(KS)==ISYMOP)#                                      QF36 135
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF36 136
IHIT=yes: ; BREAK#                                                      QF36 137
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF36 138
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF36 139
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF36 140
IF(IHIT==no:)#                                                          QF36 141
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF36 142
NCONT=NCONT+1 ; ICONT=NCONT ; JSYMOP(ICONT)=ISYMOP#                     QF36 143
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF36 144
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF36 145
#                                                                       QF36 146
#     DETERMINE IF SYMMETRY-RELATED CONTACT, PICK UP X, Y, AND Z        QF36 147
XYZ(1)=QX(IIA+1) ; XYZ(2)=QX(IIA+2) ; XYZ(3)=QX(IIA+3)#                 QF36 148
IF(ISYMOP>0)#                                                           QF36 149
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF36 150
DO J=1,3#                                                               QF36 151
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF36 152
TXYZ(J)=T(J,JS)+UCTRNS(J)#                                              QF36 153
DO K=1,3 ; TXYZ(J)=TXYZ(J)+S(J,K,JS)*XYZ(K)#                            QF36 154
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF36 155
DO J=1,3 ; XYZ(J)=TXYZ(J)#                                              QF36 156
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF36 157
#                                                                       QF36 158
#     CALCULATE THE INTERATOMIC DISTANCE FOR THIS POSSIBLE CONTACT      QF36 159
DX=(XYZ(1)-QX(IJA+1))*AEDGE ; DY=(XYZ(2)-QX(IJA+2))*BEDGE#              QF36 160
DZ=(XYZ(3)-QX(IJA+3))*CEDGE#                                            QF36 161
DOBS=SQRT(DX**2+DY**2+DZ**2+2.0*(DY*DZ*CA+DX*DZ*CB+DX*DY*CG))#          QF36 162
#                                                                       QF36 163
#     IS THIS INDEED A CONTACT                                          QF36 164
CONTCT=DVDW+DINC(KTYP) ; IF(DOBS>=CONTCT)#                              QF36 165
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF36 166
#                                                                       QF36 167
#     SAVE FOR POSSIBLE H-BOND LIST IF CONTCT<DOBS<DVDW                 QF36 168
IF(KTYP<3\DOBS>(CONTCT+ALLOW(KTYP))) NEXT#                              QF36 169
IHB=IHB+1 ; JHB=NDIS-IHB ; IJHB=STEPD*(NDIS+IHB-1)+MARKD#               QF36 170
IJHT=STEPT*(JHB-1)+MARKT#                                               QF36 171
IF(IJHB+STEPD>STOPD\IJHT+STEPT>STOPT) iquit:(QF3601)# Stop if out-o     QF36 172
QX(IJHT+1)=CONTCT#                     Dis(jhb)=contct                  QF36 173
QX(IJHT+2)=DOBS#                       Disa(jhb)=dobs                   QF36 174
QX(IJHT+3)=FLOAT(IA)#                  Lo(jhb)=ia                       QF36 175
QX(IJHT+4)=FLOAT(JA)#                  Lt(jhb)=ja                       QF36 176
QX(IJHT+5)=FLOAT(ICONT)#               Isym(jhb)=icont                  QF36 177
QX(IJHB+3)=FLOAT(KTYP)#                Nwtb(ndis+ihb)=ktyp              QF36 178
NEXT#                                                                   QF36 179
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF36 180
#                                                                       QF36 181
IVDW=IVDW+1 ; IDIS=NDIS+IVDW ; IIDIS=STEPD*(IDIS-1)+MARKD#              QF36 182
IIDIT=STEPT*(IDIS-1)+MARKT#                                             QF36 183
IF(IIDIS+STEPD>STOPD\IIDIT+STEPT>STOPT) iquit:(QF3601)# Stop if out     QF36 184
#                                                                       QF36 185
#     SAVE CHARACTERISTIC PARAMETERS OF THIS CONTACT                    QF36 186
QX(IIDIS+1)=FLOAT(IA)#                 No(idis)=ia                      QF36 187
QX(IIDIS+2)=FLOAT(JA)#                 Nt(idis) = ja                    QF36 188
QX(IIDIT+5)=FLOAT(ICONT)#              Isym(idis) = icont               QF36 189
QX(IIDIT+1)=CONTCT#                    Dis (idis) = contct              QF36 190
QX(IIDIT+2)=DOBS#                      Disa(idis) = dobs                QF36 191
QX(IIDIT+3)=FLOAT(KTYP)#               Nwtd(idis) = ktyp                QF36 192
#                                                                       QF36 193
#     CALCULATE DERIVATIVES AND RESIDUALS FOR THIS CONTACT              QF36 194
DELTA=CONTCT-DOBS ; DS=WTT*DELTA**NEXP ; SUMR=SUMR+DS*DS#               QF36 195
DSUM(KTYP)=DSUM(KTYP)+DELTA**2 ; NSUM(KTYP)=NSUM(KTYP)+1#               QF36 196
IF(ABS(DOBS)<0.0001)#                  Protect-warn of coincident ato   QF36 197
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF36 198
BUFOT(1)=FLOAT(IA) ; BUFOT(2)=FLOAT(JA)# At least point to culprets     QF36 199
ncodefld:(BUFOT,1,QF36U,FMDO,2) ; writeline:(0,QF36U,NQF36U,3,3)#       QF36 200
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF36 201
DISFN=(NEXP*DELTA**(NEXP-1))/AMAX1(DOBS,0.0001)#                        QF36 202
DIR(1)=AEDGE*(DX    + DZ*CB + DY*CG)*DISFN#                             QF36 203
DIR(2)=BEDGE*(DZ*CA + DY    + DX*CG)*DISFN#                             QF36 204
DIR(3)=CEDGE*(DY*CA + DX*CB + DZ   )*DISFN#                             QF36 205
DIR(4)=-DIR(1) ; DIR(5)=-DIR(2) ; DIR(6)=-DIR(3)#                       QF36 206
#                                                                       QF36 207
#     IF SYMMETRY-RELATED CONTACT CALCULATE DERIVATIVE ON ATOM IA       QF36 208
IF(ISYMOP>0&ISYMOP!=1555)#                                              QF36 209
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF36 210
DIR1=DIR(1) ; DIR2=DIR(2) ; DIR3=DIR(3) ; DO J=1,3#                     QF36 211
DIR(J)=S(1,J,JS)*DIR1+S(2,J,JS)*DIR2+S(3,J,JS)*DIR3#                    QF36 212
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF36 213
#                                                                       QF36 214
#     APPLY WEIGHT TO DERIVATIVES                                       QF36 215
DO JK=1,6 ; DIR(JK)=DIR(JK)*WTT#                                        QF36 216
#                                                                       QF36 217
#     INCREMENT MATRIX ELEMENTS WITHIN ATOM BLOCKS                      QF36 218
N=6*(IA-1)+2+MARKM ; M=6*(JA-1)+2+MARKM#                                QF36 219
DO JT=1,3 ; DO JO=JT,3#                                                 QF36 220
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF36 221
QX(N)=QX(N)+DIR(JT)*DIR(JO) ; QX(M)=QX(M)+DIR(JT+3)*DIR(JO+3)#          QF36 222
N=N+1 ; M=M+1#                                                          QF36 223
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF36 224
#                                                                       QF36 225
#     INCREMENT VECTOR ELEMENTS                                         QF36 226
NN=3*(IA-1)+2+MARKV ; MM=3*(JA-1)+2+MARKV#                              QF36 227
DO JT=1,3#                                                              QF36 228
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF36 229
QX(NN)=QX(NN)+DS*DIR(JT);QX(MM)=QX(MM)+DS*DIR(JT+3);NN=NN+1;MM=MM+1#    QF36 230
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF36 231
#                                                                       QF36 232
#     INCREMENT MATRIX ELEMENTS WITHIN DISTANCE BLOCKS                  QF36 233
IF((ISYMOP!=0)&(IA==JA))#                                               QF36 234
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF36 235
JV=JV+9 ; NEXT#                                                         QF36 236
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF36 237
DO JT=1,3 ; DO JO=4,6#                                                  QF36 238
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QF36 239
JV=JV+1 ; QX(MARKM+L1+JV)=QX(MARKM+L1+JV)+DIR(JT)*DIR(JO)#              QF36 240
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QF36 241
#                                                                       QF36 242
#     END OF CYCLE OVER DISTANCES                                       QF36 243
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF36 244
#                                                                       QF36 245
#     PRINT OUT CONTACT LISTS                                           QF36 246
NCONT=NCONT+1 ; DO JS=1,NCONT#                                          QF36 247
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QF36 248
FIRST=no:#                                                              QF36 249
IF(JS==2)#                                                              QF36 250
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QF36 251
writeline:(1,QF36E,NQF36E,3,4) ; writeline:(0,QF36F,NQF36F,3,4)#        QF36 252
writeline:(0,QF36S,NQF36S,3,4) ; DO KS=1,NS#                            QF36 253
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QF36 254
BUFOT(1)=FLOAT(KS) ; K=1 ; DO J=1,3 ; DO I=1,3#                         QF36 255
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QF36 256
K=K+1 ; BUFOT(K)=S(I,J,KS)#                                             QF36 257
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QF36 258
DO I=1,3#                                                               QF36 259
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QF36 260
K=K+1 ; BUFOT(K)=T(I,KS)#                                               QF36 261
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QF36 262
ncodefld:(BUFOT,1,CHROT,FM42,K) ; writeline:(0,QF36S,NQF36F,1,4)#       QF36 263
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QF36 264
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QF36 265
KS=JS-1 ; IF(KS>=1)#                                                    QF36 266
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QF36 267
IOP=JSYMOP(KS)/1000 ; IUCX=MOD(JSYMOP(KS)/100,10)-5#                    QF36 268
IUCY=MOD(JSYMOP(KS)/10,10)-5 ; IUCZ=MOD(JSYMOP(KS),10)-5#               QF36 269
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QF36 270
DO KTYP=1,4#                                                            QF36 271
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QF36 272
J=0 ; DO I=1,IVDW#                                                      QF36 273
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QF36 274
ID=NDIS+I ; IIT=STEPT*(ID-1)+MARKT ; IID=STEPD*(ID-1)+MARKD#            QF36 275
ISYM=NINT(QX(IIT+5)) ; NWTD=NINT(QX(IIT+3))#                            QF36 276
IF((ISYM!=KS)\(KTYP!=NWTD)) NEXT#                                       QF36 277
#                                                                       QF36 278
#     SELECT FOR OUTPUT ACCORDING TO INPUT CRITERIA                     QF36 279
DDR=(QX(IIT+1)-QX(IIT+2))/AMAX1(QX(IIT+2),0.0001)# Ddr=(dis-disa)/dis   QF36 280
IF((KTYP==1&DDR<=TSCUT)\(KTYP==2&DDR<=TMCUT)) NEXT#                     QF36 281
#                                                                       QF36 282
IJ=STEPT*J+MARKT ; J=J+1#                                               QF36 283
QX(IJ+1)=QX(IIT+1)#                    Dis(j) = dis(id)                 QF36 284
QX(IJ+2)=QX(IIT+2)#                    Disa(j) = disa(id)               QF36 285
QX(IJ+3)=QX(IID+1)#                    Lo(j) = no(id)                   QF36 286
QX(IJ+4)=QX(IID+2)#                    Lt(j) = nt(id)                   QF36 287
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QF36 288
IF(J>0)#                                                                QF36 289
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QF36 290
IF((JS!=1)&(FIRST==no:))#                                               QF36 291
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 QF36 292
FIRST=yes:#                                                             QF36 293
BUFOT(1)=FLOAT(IOP) ; BUFOT(2)=FLOAT(IUCX) ; BUFOT(3)=FLOAT(IUCY)#      QF36 294
BUFOT(4)=FLOAT(IUCZ) ; ncodefld:(BUFOT,1,QF36G,FM46,4)#                 QF36 295
writeline:(0,QF36G,NQF36G,3,4)#                                         QF36 296
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 QF36 297
IF(KTYP==1) writeline:(1,QF36A,NQF36A,3,4)#                             QF36 298
ELSE IF(KTYP==2) writeline:(1,QF36B,NQF36B,3,4)#                        QF36 299
ELSE IF(KTYP==3) writeline:(1,QF36C,NQF36C,3,4)#                        QF36 300
ELSE IF(KTYP==4) writeline:(1,QF36D,NQF36D,3,4)#                        QF36 301
LINRM=5 ;  K=0 ;DO I=1,J#                                               QF36 302
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 QF36 303
II=STEPT*(I-1)+MARKT ; IF(K>6)#                                         QF36 304
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 QF36 305
ncodefld:(BUFOT,1,CHROT,FM50,8)#                                        QF36 306
writeline:(0,QF36H,NQF36H,1,4) ; K=0#                                   QF36 307
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 QF36 308
IJ=(NINT(QX(II+3))-1)*STEPA+MARKA#     Point to atom(i)                 QF36 309
movertoc:(QX(IJ+8),2,CHROT,PUTNAM(K+1),8,0)# Fetch atom name            QF36 310
IJ=(NINT(QX(II+4))-1)*STEPA+MARKA#     Point to atom(j)                 QF36 311
movertoc:(QX(IJ+8),2,CHROT,PUTNAM(K+2),8,0)# Fetch atom name            QF36 312
BUFOT(K+1)=QX(II+1) ; BUFOT(K+2)=QX(II+2) ; K=K+2# Ideal & model dist   QF36 313
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 QF36 314
IF(K>0)#                                                                QF36 315
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 QF36 316
ncodefld:(BUFOT,1,CHROT,FM50,K)#                                        QF36 317
writeline:(0,QF36H,NQF36H,1,4)#                                         QF36 318
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 QF36 319
#                                                                       QF36 320
#     APPEND A LIST OF HYDROGEN-BONDED ATOM PAIRS TO THE LIST OF        QF36 321
#     DISTANCES TO BE USED FOR POTENTIAL RESTRAINT OF THERMAL           QF36 322
#     THERMAL PARAMETER DIFFERENCES BETWEEN THESE ATOMS.  THIS          QF36 323
#     FIRST GROUP ARE PAIRS WHOSE INTERATOMIC DISTANCE IS ARE           QF36 324
#     RESTRAINED BECAUSE CONTACT IS TOO SHORT EVEN FOR AN H-BOND.       QF36 325
#                                                                       QF36 326
IF(KTYP>2)#                                                             QF36 327
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 QF36 328
INEED=NDIS+IVDW+NHBD+IHBD#                                              QF36 329
INEEDT=INEED*STEPT ; INEEDD=INEED*STEPD#                                QF36 330
IF(INEEDD>STOPD\INEEDT>STOPT)#                                          QF36 331
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 QF36 332
BUFOT(1)=FLOAT(NDIS) ; BUFOT(2)=FLOAT(IVDW)#                            QF36 333
BUFOT(3)=FLOAT(NHBD) ; BUFOT(4)=FLOAT(IHBD)#                            QF36 334
ncodefld:(BUFOT,1,CHROT,FM77,4) ; writeline:(1,QF36R,NQF36R,2,4)#       QF36 335
iquit:(QF3602)#                        Not enough storage available     QF36 336
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 QF36 337
IHBD=J ; DO I=1,IHBD#                                                   QF36 338
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 QF36 339
II=STEPT*(I-1)+MARKT ; ID=NDIS+IVDW+NHBD+I ; IID=STEPD*(ID-1)+MARKD#    QF36 340
QX(IID+1)=QX(II+3)#                    No(id) = lo(i)                   QF36 341
QX(IID+2)=QX(II+4)#                    Nt(id) = lt(i)                   QF36 342
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 QF36 343
NHBD=NHBD+IHBD#                                                         QF36 344
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 QF36 345
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QF36 346
#                                                                       QF36 347
#     LIST UNRESTRAINED ALLOWED HYDROGEN BONDS                          QF36 348
IF(KTYP>=3&IHB>0)#                                                      QF36 349
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 QF36 350
JHB=0 ; DO J=1,IHB#                                                     QF36 351
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 QF36 352
ID=NDIS-J ; IID=STEPT*(ID-1)+MARKT ; IIID=STEPD*(NDIS+J-1)+MARKD#       QF36 353
IF(NINT(QX(IID+5))!=KS) NEXT ; IF(KTYP!=NINT(QX(IIID+3))) NEXT#         QF36 354
IJHB=STEPT*JHB+MARKT ; JHB=JHB+1#                                       QF36 355
QX(IJHB+1)=QX(IID+1)#                  Dis(jhb) = dis(id)               QF36 356
QX(IJHB+2)=QX(IID+2)#                  Disa(jhb) = disa(id)             QF36 357
QX(IJHB+3)=QX(IID+3)#                  Lo(jhb) = lo(id)                 QF36 358
QX(IJHB+4)=QX(IID+4)#                  Lt(jhb) = lt(id)                 QF36 359
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 QF36 360
IF(JHB!=0)#                                                             QF36 361
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 QF36 362
#                                                                       QF36 363
#     APPEND THESE POTENTIAL H-BONDED PAIRS TO THE LIST AS WELL         QF36 364
#     FOR LATER THERMAL PARAMETER DIFFERENCE RESTRAINT.                 QF36 365
#     THIS GROUP ARE PAIRS WHOSE INTERATOMIC DISTANCE IS ARE NOT        QF36 366
#     RESTRAINED BECAUSE CONTACT IS LONGER THAN THE MINIMUM             QF36 367
#     CONTACT DISTANCE.                                                 QF36 368
#                                                                       QF36 369
INEED=NDIS+IVDW+NHBD+JHB#                                               QF36 370
INEEDT=INEED*STEPT ; INEEDD=INEED*STEPD#                                QF36 371
IF(INEEDD>STOPD\INEEDT>STOPT)#                                          QF36 372
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 QF36 373
BUFOT(1)=FLOAT(NDIS) ; BUFOT(2)=FLOAT(IVDW)#                            QF36 374
BUFOT(3)=FLOAT(NHBD) ; BUFOT(4)=FLOAT(IHBD)#                            QF36 375
BUFOT(5)=FLOAT(JHB)#                                                    QF36 376
ncodefld:(BUFOT,1,CHROT,FM77,5) ; writeline:(1,QF36R,NQF36R,2,4)#       QF36 377
iquit:(QF3602)#                        Not enough storage available     QF36 378
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 QF36 379
DO J=1,JHB#                                                             QF36 380
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 QF36 381
ID=NDIS+IVDW+NHBD+J ; IID=(ID-1)*STEPD+MARKD#                           QF36 382
JP=(J-1)*STEPT+MARKT ; QX(IID+1)=QX(JP+3)# No(id)=lo(j)                 QF36 383
QX(IID+2)=QX(JP+4)#                    Nt(id)=lt(j)#                    QF36 384
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 QF36 385
NHBD=NHBD+JHB ; IF(IHYDP!=0)#                                           QF36 386
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 QF36 387
IF((JS!=1)&(FIRST==no:))#                                               QF36 388
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 QF36 389
FIRST=yes: ; BUFOT(1)=FLOAT(IOP) ; BUFOT(2)=FLOAT(IUCX)#                QF36 390
BUFOT(3)=FLOAT(IUCY) ; BUFOT(4)=FLOAT(IUCZ)#                            QF36 391
ncodefld:(BUFOT,1,QF36G,FM46,4)#                                        QF36 392
writeline:(0,QF36G,NQF36G,3,4)#                                         QF36 393
IF(NSUM(KTYP)==0)#                                                      QF36 394
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 QF36 395
IF(KTYP==1) writeline:(1,QF36A,NQF36A,3,4)#                             QF36 396
ELSE IF(KTYP==2) writeline:(1,QF36B,NQF36B,3,4)#                        QF36 397
ELSE IF(KTYP==3) writeline:(1,QF36C,NQF36C,3,4)#                        QF36 398
ELSE IF(KTYP==4) writeline:(1,QF36D,NQF36D,3,4)#                        QF36 399
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 QF36 400
BUFOT(1)=FLOAT(JHB) ; BUFOT(2)=ALLOW(KTYP)#                             QF36 401
ncodefld:(BUFOT,1,QF36I,FM66,2);writeline:(1,QF36I,NQF36I,3,4)#         QF36 402
LINRM=5 ;  K=0 ;DO I=1,JHB#                                             QF36 403
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 QF36 404
II=STEPT*(I-1)+MARKT ; IF(K>6)#                                         QF36 405
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 QF36 406
ncodefld:(BUFOT,1,CHROT,FM50,8)#                                        QF36 407
writeline:(0,QF36H,NQF36H,1,4) ; K=0#                                   QF36 408
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 QF36 409
IJ=(NINT(QX(II+3))-1)*STEPA+MARKA#     Point to atom(i)                 QF36 410
movertoc:(QX(IJ+8),2,CHROT,PUTNAM(K+1),8,0)# Fetch atom name            QF36 411
IJ=(NINT(QX(II+4))-1)*STEPA+MARKA#     Point to atom(j)                 QF36 412
movertoc:(QX(IJ+8),2,CHROT,PUTNAM(K+2),8,0)# Fetch atom name            QF36 413
BUFOT(K+1)=QX(II+1) ; BUFOT(K+2)=QX(II+2) ; K=K+2#                      QF36 414
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 QF36 415
IF(K>0)#                                                                QF36 416
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 QF36 417
ncodefld:(BUFOT,1,CHROT,FM50,K)#                                        QF36 418
writeline:(0,QF36H,NQF36H,1,4)#                                         QF36 419
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 QF36 420
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 QF36 421
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 QF36 422
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 QF36 423
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 QF36 424
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QF36 425
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QF36 426
#                                                                       QF36 427
#     PRINT OUT DISCREPANCY AVERAGES                                    QF36 428
BUFOT(1)=SUMR ; BUFOT(2)=SUMR/FLOAT(MAX0(1,IVDW))# Sum and average      QF36 429
ncodefld:(BUFOT,1,QF36J,FM55,2) ; writeline:(1,QF36J,NQF36J,3,3)#       QF36 430
writeline:(1,QF36K,NQF36K,3,3) ; LINRM=3#                               QF36 431
DO I=1,NCLASS#                                                          QF36 432
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 QF36 433
RMSD(I)=0.0 ; IF(NSUM(I)!=0) RMSD(I)=SQRT(DSUM(I)/FLOAT(NSUM(I)))#      QF36 434
BUFOT(1)=FLOAT(I); BUFOT(2)=1.0/AMAX1(0.1,WTT); BUFOT(3)=FLOAT(NSUM(I))#QF36 435
BUFOT(4)=RMSD(I) ; BUFOT(5)=SIGV ; BUFOT(6)=DINC(I)#                    QF36 436
ncodefld:(BUFOT,1,CHROT,FM409,6)#                                       QF36 437
IF(I==1) movechar:(QF36N,1,CHROT,51,NQF36N,0)#                          QF36 438
ELSE IF(I==2) movechar:(QF36O,1,CHROT,51,NQF36O,0)#                     QF36 439
ELSE IF(I==3) movechar:(QF36P,1,CHROT,51,NQF36P,0)#                     QF36 440
ELSE IF(I==4) movechar:(QF36Q,1,CHROT,51,NQF36Q,0)#                     QF36 441
writeline:(0,QF36L,NQF36L,1,3)#                                         QF36 442
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 QF36 443
#                                                                       QF36 444
#     ESTABLISH WEIGHT CLASS 8 FOR THERMAL RESTRAINT OF H-BOND PAIRS    QF36 445
DO I=1,NHBD#                                                            QF36 446
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 QF36 447
ID=NDIS+IVDW+I ; IID=STEPD*(ID-1)+MARKD ; QX(IID+3)=8.0# Nwtb(id)=8     QF36 448
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 QF36 449
NVDW=IVDW ; WPSUM=WPSUM+SUMR#                                           QF36 450
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF36 451
BUFOT(1)=FLOAT(NDIS) ; BUFOT(2)=FLOAT(IVDW)#                            QF36 452
BUFOT(3)=FLOAT(NHBD) ; BUFOT(4)=FLOAT(IHBD)#                            QF36 453
BUFOT(5)=FLOAT(JHB)#                                                    QF36 454
ncodefld:(BUFOT,1,CHROT,FM77,5) ; writeline:(1,QF36R,NQF36R,2,4)#       QF36 455
#                                                                       QF36 456
RETURN#                                                                 QF36 457
END#                                                                    QF36 458
systemheader:(QF37)## Set up the torsion angle restraints               QF37   1
####################################################################    QF37   2
#                                                                  #    QF37   3
#                                QF37                              #    QF37   4
#                                                                  #    QF37   5
####################################################################    QF37   6
SUBROUTINE QF37#                       Subroutine torref(ntor)          QF37   7
#                                    W. HENDRICKSON                     QF37   8
include:(AACOMN)#                                                       QF37   9
include:(QFCOMN)#                                                       QF37  10
#                                                                       QF37  11
# TORSION ANGLES IN THE IUPAC-IUB CONVENTION (BIOCHEM.9,3471,1970)      QF37  12
# ----------------------------------------------------------------      QF37  13
#                                                                       QF37  14
REAL AVGR#                                                              QF37  15
REAL DEL,DELT#                                                          QF37  16
REAL DS#                                                                QF37  17
REAL DSUM(8)#                                                           QF37  18
INTEGER IA,IANG,ID,III,INOW,IQ,IQP,IRES,ISKAL,IWT,IX#                   QF37  19
INTEGER J,JA,JX#                                                        QF37  20
INTEGER IATOM(4)#                                                       QF37  21
INTEGER IANGLE(8)#                                                      QF37  22
INTEGER IDIST(6)#                                                       QF37  23
INTEGER ITARGT(8)#                                                      QF37  24
INTEGER L,LPAR,L1#                                                      QF37  25
INTEGER M#                                                              QF37  26
INTEGER NANG,NCLASS,NN,NTWIST#                                          QF37  27
INTEGER NSUM(8)#                                                        QF37  28
string:(RESIDU,4)#                                                      QF37  29
REAL RMSD(8)#                                                           QF37  30
REAL RPAR#                                                              QF37  31
REAL SIGD(8)#                                                           QF37  32
REAL SUMW#                                                              QF37  33
REAL TAG#                                                               QF37  34
REAL TARGET#                                                            QF37  35
REAL WTT#                                                               QF37  36
REAL WWTT(8)#                                                           QF37  37
realdata:(FM400,[341471.,610732.])#                                     QF37  38
chardata:(QF37A, SUM(WGT*DELTA**2) =               AVG(WGT*DELTA**2) $# QF37  39
=        FOR TORSION ANGLES)#                                           QF37  40
chardata:(QF37B,         ROOT          RMS)#                            QF37  41
chardata:(QF37C,[  TYPE  1/WGT NUMBER  DELTA   SIGMA  TORSION TYPE])#   QF37  42
realdata:(FM409,[50513.,130612.,190613.,270812.,350812.])#              QF37  43
realdata:(FM425,[60513.,180513.])#                                      QF37  44
chardata:(QF37E, PRESPECIFIED)#                                         QF37  45
chardata:(QF37F,[ PLANAR (0,180)])#                                     QF37  46
chardata:(QF37G,[ STAGGERED (+/-60,180)])#                              QF37  47
chardata:(QF37H,[ ORTHONORMAL (+/-90)])#                                QF37  48
chardata:(QF37I,       OF THE      CONFORMATIONAL TORSION $#            QF37  49
ANGLES ARE RESTRAINED)#                                                 QF37  50
chardata:(QF37J,   RESIDUE   PHI         PSI        OMEGA        $#     QF37  51
CHI        CHI1        CHI2        CHI3        CHI4        CHI5)#       QF37  52
chardata:(QF37K,[ >>>>>>>>>>>>>>>>>>>>>>>> TORSION ANGLE RESTRAINTS $#  QF37  53
<<<<<<<<<<<<<<<<<<<<<<<<<])#                                            QF37  54
realdata:(FM125,[140413.,260413.,380413.,500413.,620413.,740413.,$#     QF37  55
860413.,980413.])#                                                      QF37  56
realdata:(FM126,[190413.,310413.,430413.,550413.,670413.,790413.,$#     QF37  57
910413.,1030413.])#                                                     QF37  58
datastuff:#                                                             QF37  59
#      CHARACTER*4 IBLANK,RESIDU                                        QF37  60
#      DATA IBLANK /'    '/                                             QF37  61
L1=6*NA+1 ; SUMW=0.0 ; ISKAL=1#        Initialize                       QF37  62
ifeq:(WTSKAL,0.0) ISKAL=0#                                              QF37  63
LINRM=10 ; writeline:(4,QF37K,NQF37K,3,3)# Write heading                QF37  64
DO IA=1,4 ; DO IX=1,3 ;  TDIR(IA,IX)=0.0#                               QF37  65
#     SET THE DISTANCE WEIGHTING SCHEME                                 QF37  66
SIGD(1)=SIGT1 ; SIGD(2)=SIGT2 ; SIGD(3)=SIGT3 ; SIGD(4)=SIGT4#          QF37  67
NCLASS=4 ; DO I=1,NCLASS#                                               QF37  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF37  69
DSUM(I)=0.0 ; NSUM(I)=0 ; WWTT(I)=WTSKAL/SIGD(I)#                       QF37  70
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF37  71
#                                                                       QF37  72
#     WRITE OUT THE LIST HEADING                                        QF37  73
IF(ITORP!=0) LINRM=5#                                                   QF37  74
#     CYCLE OVER TORSION ANGLES                                         QF37  75
NTWIST=0 ; INOW=0 ; DO III=1,NTOR#                                      QF37  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF37  77
#                                                                       QF37  78
#     READ A TORSION IDENTIFICATION RECORD                              QF37  79
#     ------------------------------------                              QF37  80
readwpkt:(TINFIL,LRTOR,PSIZ6,GETPK,0)# Read torsion constraints         QF37  81
IF(III!=NINT(QX(GETPK+1))\GETPK<=0) iquit:(QF3701)# Rec's must sync     QF37  82
IRES=NINT(QX(GETPK+2)) ; IANG=NINT(QX(GETPK+3))#                        QF37  83
DO I=1,4 ; IATOM(I)=NINT(QX(GETPK+I+3))#                                QF37  84
DO I=1,6 ; IDIST(I)=NINT(QX(GETPK+I+7))#                                QF37  85
IWT=NINT(QX(GETPK+14)) ; TAG=QX(GETPK+15)#                              QF37  86
REPEAT#                                                                 QF37  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF37  88
IF(IRES!=INOW)#                                                         QF37  89
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF37  90
#     INITIALIZE FOR A NEW RESIDUE                                      QF37  91
INOW=IRES ; DO I=1,8#                                                   QF37  92
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF37  93
IANGLE(I)=500 ; ITARGT(I)=500#                                          QF37  94
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF37  95
movechar:(IATOM(2),2,RESIDU,1,4,0)#    Residu=atom(iatom(2))(2^5)#      QF37  96
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF37  97
ELSE#                                                                   QF37  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF37  99
NANG=IANG#                                                              QF37 100
#     CALCULATE THIS CONFORMATION ANGLE AND ITS DERIVATIVES             QF37 101
DO IA=1,4#                                                              QF37 102
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF37 103
IQ=IATOM(IA) ; IQP=(IQ-1)*STEPA+MARKA#                                  QF37 104
ZX(1,IA)=ORXX*QX(IQP+1)+ORXY*QX(IQP+2)+ORXZ*QX(IQP+3)#                  QF37 105
ZX(2,IA)=               ORYY*QX(IQP+2)+ORYZ*QX(IQP+3)#                  QF37 106
ZX(3,IA)=                              ORZZ*QX(IQP+3)#                  QF37 107
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF37 108
IDERIV=ISKAL*IWT ; CALL QF38#          Call torshn                      QF37 109
IANGLE(IANG)=NINT(ANGLE)#                                               QF37 110
IF(IWT!=0)#                                                             QF37 111
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF37 112
#     PREPARE FOR A RESTRAINT                                           QF37 113
WTT=WWTT(IWT)#                                                          QF37 114
#      GO TO(25,30,35,40,40),IWT                                        QF37 115
IF(IWT==1)#                                                             QF37 116
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF37 117
#     PRESPECIFIED ANGLE                                                QF37 118
TARGET=TAG ; DEL=TAG-ANGLE#                                             QF37 119
IF(ABS(DEL)>180.0) TARGET=TAG-SIGN(360.0,DEL)#                          QF37 120
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF37 121
#     PLANAR (0,+/-180)                                                 QF37 122
ELSE IF(IWT==2)#                                                        QF37 123
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF37 124
TARGET=TAG ; ifeq:(TAG,180.0) TARGET=SIGN(180.0,ANGLE)#                 QF37 125
IF(IANG!=3&ABS(ANGLE)<90.0) TARGET=0.0#                                 QF37 126
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF37 127
#     STAGGERED (+/-60,+/-180)                                          QF37 128
ELSE IF (IWT==3)#                                                       QF37 129
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF37 130
IF(ABS(ANGLE)<120.0) TARGET=SIGN(60.0,ANGLE)#                           QF37 131
IF(ABS(ANGLE)>=120.0) TARGET=SIGN(180.0,ANGLE)#                         QF37 132
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF37 133
#     ORTHONORMAL (+/-90)                                               QF37 134
ELSE TARGET=SIGN(90.0,ANGLE)#                                           QF37 135
ITARGT(IANG)=NINT(TARGET)#                                              QF37 136
#     CALCULATE RESIDUAL AND WEIGHT DERIVATIVES                         QF37 137
DELT=TARGET-ANGLE ; DS=WTT*DELT#                                        QF37 138
DO IA=1,4 ; DO IX=1,3#                                                  QF37 139
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF37 140
TDIR(IA,IX)=WTT*TDIR(IA,IX)#                                            QF37 141
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF37 142
#     COMPILE STATISTICS                                                QF37 143
SUMW=SUMW+DS**2 ; DSUM(IWT)=DSUM(IWT)+DELT**2#                          QF37 144
NSUM(IWT)=NSUM(IWT)+1 ; NTWIST=NTWIST+1#                                QF37 145
#     INCREMENT MATRIX ELEMENTS WITHIN ATOM BLOCKS                      QF37 146
DO IA=1,4#                                                              QF37 147
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF37 148
IQ=IATOM(IA) ; NN=6*(IQ-1)+1+MARKM ; DO I=1,3 ; DO J=I,3#               QF37 149
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF37 150
NN=NN+1 ; QX(NN)=QX(NN)+TDIR(IA,I)*TDIR(IA,J)#                          QF37 151
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF37 152
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF37 153
#     INCREMENT MATRIX ELEMENTS WITHIN DISTANCE BLOCKS                  QF37 154
M=0 ; DO IA=1,3#                                                        QF37 155
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF37 156
L=IA+1 ; DO JA=L,4#                                                     QF37 157
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF37 158
M=M+1 ; ID=IDIST(M) ; IF(ID==0) NEXT#                                   QF37 159
IF(ID>=0)#                                                              QF37 160
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QF37 161
NN=L1+9*(ID-1)+MARKM ; DO IX=1,3 ; DO JX=1,3#                           QF37 162
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QF37 163
NN=NN+1 ; QX(NN)=QX(NN)+TDIR(IA,IX)*TDIR(JA,JX)#                        QF37 164
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QF37 165
NEXT#                                                                   QF37 166
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QF37 167
ELSE#                                                                   QF37 168
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QF37 169
ID=-ID ; NN=L1+9*(ID-1)+MARKM ; DO JX=1,3 ; DO IX=1,3#                  QF37 170
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QF37 171
NN=NN+1 ; QX(NN)=QX(NN)+TDIR(IA,IX)*TDIR(JA,JX)#                        QF37 172
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QF37 173
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QF37 174
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF37 175
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF37 176
#     INCREMENT VECTOR ELEMENTS                                         QF37 177
DO IA=1,4#                                                              QF37 178
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QF37 179
IQ=IATOM(IA) ; NN=3*(IQ-1)+1+MARKV ; DO IX=1,3#                         QF37 180
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QF37 181
NN=NN+1 ; QX(NN)=QX(NN)+DS*TDIR(IA,IX)#                                 QF37 182
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QF37 183
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QF37 184
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF37 185
#     IF THIS IS NOT THE LAST, GO FOR ANOTHER                           QF37 186
IF(III!=NTOR) BREAK#                                                    QF37 187
#     LIST THE CONFORMATION ANGLES FOR THE PREVIOUS RESIDUE             QF37 188
IF(ITORP!=0)#                                                           QF37 189
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QF37 190
DO I=1,NANG#                                                            QF37 191
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QF37 192
IF(IANGLE(I)!=500)#                                                     QF37 193
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QF37 194
ncodefld:(FLOAT(IANGLE(I)),1,CHROT,FM125(I),1)#                         QF37 195
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QF37 196
IF(ITARGT(I)!=500)#                                                     QF37 197
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QF37 198
ncodefld:(FLOAT(ITARGT(I)),1,CHROT,FM126(I),1)#                         QF37 199
movechar:(LPAR,1,CHROT,(I-1)*12+15,1,1)#                                QF37 200
movechar:(RPAR,1,CHROT,(I-1)*12+20,1,1)#                                QF37 201
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QF37 202
movechar:(RESIDU,1,CHROT,4,4,1) ; writeline:(0,QF37J,NQF37J,1,4)#       QF37 203
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QF37 204
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QF37 205
BREAK#                                                                  QF37 206
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF37 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF37 208
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF37 209
#                                                                       QF37 210
#     LISTING                                                           QF37 211
AVGR=SUMW/FLOAT(NTWIST)#                                                QF37 212
BUFOT(1)=SUMW ; BUFOT(2)=AVGR ; ncodefld:(BUFOT,1,QF37A,FM400,2)#       QF37 213
writeline:(1,QF37A,NQF37A,3,3) ; writeline:(1,QF37B,NQF37B,3,3)#        QF37 214
LINRM=3#                                                                QF37 215
DO I=1,NCLASS#                                                          QF37 216
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 QF37 217
RMSD(I)=0.0 ; IF(NSUM(I)!=0) RMSD(I)=SQRT(DSUM(I)/FLOAT(NSUM(I)))#      QF37 218
BUFOT(1)=FLOAT(I) ; BUFOT(2)=1.0/AMAX1(0.01,WWTT(I))#                   QF37 219
BUFOT(3)=FLOAT(NSUM(I))#                                                QF37 220
BUFOT(4)=RMSD(I) ; BUFOT(5)=SIGD(I) ; ncodefld:(BUFOT,1,CHROT,FM409,5)# QF37 221
IF(I==1) movechar:(QF37E,1,CHROT,37,NQF37E,0)#                          QF37 222
ELSE IF(I==2) movechar:(QF37F,1,CHROT,37,NQF37F,0)#                     QF37 223
ELSE IF(I==3) movechar:(QF37G,1,CHROT,37,NQF37G,0)#                     QF37 224
ELSE IF(I==2) movechar:(QF37H,1,CHROT,37,NQF37H,0)#                     QF37 225
writeline:(0,QF37C,NQF37C,1,3)#                                         QF37 226
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 QF37 227
BUFOT(1)=FLOAT(NTWIST) ; BUFOT(2)=FLOAT(NTOR)#                          QF37 228
ncodefld:(BUFOT,1,QF37I,FM425,2) ; writeline:(1,QF37I,NQF37I,3,3)#      QF37 229
#                                                                       QF37 230
WPSUM=WPSUM+SUMW ; NTOR=NTWIST#                                         QF37 231
#                                                                       QF37 232
RETURN#                                                                 QF37 233
END#                                                                    QF37 234
systemheader:(QF38)## More torsion angles                               QF38   1
####################################################################    QF38   2
#                                                                  #    QF38   3
#                                QF38                              #    QF38   4
#                                                                  #    QF38   5
####################################################################    QF38   6
SUBROUTINE QF38#                       Subroutine torshn                QF38   7
#                                        W. hendrickson                 QF38   8
include:(AACOMN)#                                                       QF38   9
include:(QFCOMN)#                                                       QF38  10
#                                                                       QF38  11
#                                                                       QF38  12
REAL ADOTB#                                                             QF38  13
REAL DADP(3,3,4),DBDP(3,3,4),DWDP(3,3,4)#                               QF38  14
REAL DIRDEN#                                                            QF38  15
REAL DSDP#                                                              QF38  16
REAL DTDP#                                                              QF38  17
REAL DWMAG(3,4),DRDX(3)#                                                QF38  18
REAL D1(3),D2(3),D3(3)#                                                 QF38  19
INTEGER I,IA,IX,J,JX#                  Loop indices & pointers          QF38  20
REAL QF05#                             3x3 determinant function         QF38  21
REAL U(3),V(3),W(3)#                                                    QF38  22
REAL WMAG#                                                              QF38  23
REAL ZA(3),ZB(3)#                                                       QF38  24
REAL ZQ(3,3)#                                                           QF38  25
REAL ZS,ZT#                                                             QF38  26
#                                                                       QF38  27
DO I=1,3## Form triad of interatomic vectors                            QF38  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF38  29
U(I)=ZX(I,1)-ZX(I,2) ; V(I)=ZX(I,4)-ZX(I,3) ; W(I)=ZX(I,3)-ZX(I,2)#     QF38  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF38  31
CALL QF06(ZA,U,W)#                     Find a = u.cross.w               QF38  32
CALL QF06(ZB,V,W)#                     Find b = v.cross.w               QF38  33
WMAG=SQRT(W(1)**2+W(2)**2+W(3)**2)#    Find |w|                         QF38  34
DO J=1,3## (a.cross.b).dot.w = |a|*|b|*|w|*sin(angle)                   QF38  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF38  36
ZQ(1,J)=ZA(J) ; ZQ(2,J)=ZB(J) ; ZQ(3,J)=W(J)#                           QF38  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF38  38
ZS=QF05(ZQ)#                           Get determinant                  QF38  39
#    (A.DOT.B)*|W| = |A|*|B|*|W|*COS(ANGLE)                             QF38  40
ZT=(ZA(1)*ZB(1)+ZA(2)*ZB(2)+ZA(3)*ZB(3))*WMAG#                          QF38  41
ANGLE=ATAN2(ZS,ZT)*RTODEG#             Torsion angle in degrees         QF38  42
IF(IDERIV!=0)#                         If derivatives are needed        QF38  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF38  44
DIRDEN=(ZS**2+ZT**2)*DEGTOR#                                            QF38  45
#    COMPUTE PARTIAL DERIVATIVES OF A, B AND W W.R.T. PARAMETERS        QF38  46
DO IX=1,3#                                                              QF38  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF38  48
DO JX=1,3 ; DRDX(JX)=G(JX,IX)#         Get three cross products         QF38  49
CALL QF06(D1,DRDX,W) ; CALL QF06(D2,U,DRDX) ; CALL QF06(D3,V,DRDX)#     QF38  50
DO JX=1,3#                                                              QF38  51
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF38  52
DADP(JX,IX,1)=D1(JX) ; DADP(JX,IX,2)=-D1(JX)-D2(JX)#                    QF38  53
DADP(JX,IX,3)=D2(JX) ; DBDP(JX,IX,2)=-D3(JX)#                           QF38  54
DBDP(JX,IX,3)=D3(JX)-D1(JX) ; DBDP(JX,IX,4)=D1(JX)#                     QF38  55
DWDP(JX,IX,2)=-DRDX(JX) ; DWDP(JX,IX,3)=DRDX(JX)#                       QF38  56
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF38  57
DWMAG(IX,3)=(W(1)*DRDX(1)+W(2)*DRDX(2)+W(3)*DRDX(3))/WMAG#              QF38  58
DWMAG(IX,2)=-DWMAG(IX,3)#                                               QF38  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF38  60
#     COMPUTE DERIVATIVES FROM PARTIALS BY THE CHAIN RULE               QF38  61
DO IX=1,3 ; DO IA=1,4#                                                  QF38  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF38  63
DSDP=0.0 ; DTDP=0.0 ; IF(IA!=4)#                                        QF38  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF38  65
DO JX=1,3#                             Contribution of partials of a    QF38  66
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF38  67
ZQ(1,JX)=DADP(JX,IX,IA) ; ZQ(2,JX)=ZB(JX) ; ZQ(3,JX)=W(JX)#             QF38  68
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF38  69
DSDP=QF05(ZQ)#                         Get determinant                  QF38  70
ADOTB=(DADP(1,IX,IA)*ZB(1)+DADP(2,IX,IA)*ZB(2)+DADP(3,IX,IA)*ZB(3))#    QF38  71
DTDP=ADOTB*WMAG#                                                        QF38  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF38  73
IF(IA!=1\IA==4)#                                                        QF38  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF38  75
DO JX=1,3#                             Contribution of partials of b    QF38  76
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF38  77
ZQ(1,JX)=ZA(JX) ; ZQ(2,JX)=DBDP(JX,IX,IA) ; ZQ(3,JX)=W(JX)#             QF38  78
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF38  79
DSDP=DSDP+QF05(ZQ)#                    Get determinant                  QF38  80
ADOTB=(ZA(1)*DBDP(1,IX,IA)+ZA(2)*DBDP(2,IX,IA)+ZA(3)*DBDP(3,IX,IA))#    QF38  81
DTDP=DTDP+ADOTB*WMAG ; IF(IA!=4)#                                       QF38  82
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF38  83
DO JX=1,3#                             Contribution of partials of w    QF38  84
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF38  85
ZQ(2,JX)=ZB(JX) ; ZQ(3,JX)=DWDP(JX,IX,IA)#                              QF38  86
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF38  87
DSDP=DSDP+QF05(ZQ) ; DTDP=DTDP+(ZT/WMAG)*DWMAG(IX,IA)#                  QF38  88
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF38  89
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF38  90
TDIR(IA,IX)=(ZT*DSDP-ZS*DTDP)/DIRDEN#  Complete derivative              QF38  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF38  92
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF38  93
#                                                                       QF38  94
RETURN#                                                                 QF38  95
END#                                                                    QF38  96
systemheader:(QF39)## Non-crystallographic symmetry constraints         QF39   1
####################################################################    QF39   2
#                                                                  #    QF39   3
#                                QF39                              #    QF39   4
#                                                                  #    QF39   5
####################################################################    QF39   6
SUBROUTINE QF39#                       Subroutine symref(nsym)          QF39   7
#                                        W. hendrickson                 QF39   8
include:(AACOMN)#                                                       QF39   9
include:(QFCOMN)#                                                       QF39  10
#                                                                       QF39  11
# THE VARIABLES INDX(QQA),IDATM(QQA,4),DELTA(QQA,4) ARE NOW             QF39  12
# STORED IN THE MARKT ARRAY IN THE FOLLOWING WAY:                       QF39  13
# OLD IDATM(N,1)      NEW QX((N-1)*STEPT+MARKT+1)                       QF39  14
# OLD IDATM(N,2)      NEW QX((N-1)*STEPT+MARKT+2)                       QF39  15
# OLD IDATM(N,3)      NEW QX((N-1)*STEPT+MARKT+3)                       QF39  16
# OLD IDATM(N,4)      NEW QX((N-1)*STEPT+MARKT+4)                       QF39  17
# OLD INDX(N)         NEW QX((N-1)*STEPT+MARKT+4) YES! EQUIVALENCE!     QF39  18
# OLD DELTA(N,1)      NEW QX((N-1)*STEPT+MARKT+5)                       QF39  19
# OLD DELTA(N,2)      NEW QX((N-1)*STEPT+MARKT+6)                       QF39  20
# OLD DELTA(N,3)      NEW QX((N-1)*STEPT+MARKT+7)                       QF39  21
# OLD DELTA(N,4)      NEW QX((N-1)*STEPT+MARKT+8)                       QF39  22
#                                                                       QF39  23
# OLD XA(N)           NEW QX((N-1)*STEPT+MARKT+1)                       QF39  24
# OLD YA(N)           NEW QX((N-1)*STEPT+MARKT+2)                       QF39  25
# OLD ZA(N)           NEW QX((N-1)*STEPT+MARKT+3)                       QF39  26
# OLD XB(N)           NEW QX((N-1)*STEPT+MARKT+4)                       QF39  27
# OLD YB(N)           NEW QX((N-1)*STEPT+MARKT+5)                       QF39  28
# OLD ZB(N)           NEW QX((N-1)*STEPT+MARKT+6)                       QF39  29
# OLD XC(N)           NEW QX((N-1)*STEPT+MARKT+7)                       QF39  30
# OLD YC(N)           NEW QX((N-1)*STEPT+MARKT+8)                       QF39  31
# OLD ZC(N)           NEW QX((N-1)*STEPT+MARKT+9)                       QF39  32
# OLD KI(N)           NEW QX((N-1)*STEPT+MARKT+10)                      QF39  33
# OLD IWT(N)          NEW QX((N-1)*STEPT+MARKT+11)                      QF39  34
# OLD IAT(N,1)        NEW QX((N-1)*STEPT+MARKT+12)                      QF39  35
# OLD IAT(N,2)        NEW QX((N-1)*STEPT+MARKT+13)                      QF39  36
# OLD IAT(N,3)        NEW QX((N-1)*STEPT+MARKT+14)                      QF39  37
# OLD IAT(N,4)        NEW QX((N-1)*STEPT+MARKT+15)                      QF39  38
#     EQUIVALENCE (INDX(1),XB(1)),(IDATM(1,1),XA(1)),(DELTA(1,1),YB(1)) QF39  39
#                                                                       QF39  40
REAL AVGB,AVGP#                                                         QF39  41
REAL BB(4)#                                                             QF39  42
REAL BBAR#                                                              QF39  43
REAL BS#                                                                QF39  44
REAL CHI#                                                               QF39  45
REAL DB(4)#                                                             QF39  46
REAL DD(4)#                                                             QF39  47
REAL DEL(4,6)#                                                          QF39  48
REAL DETR#                                                              QF39  49
REAL DS#                                                                QF39  50
REAL DX(3,4),DDX(3,4)#                                                  QF39  51
INTEGER I,IA,IAP,IGROUP,II,III,IJ,IP#                                   QF39  52
INTEGER IS,ISP,ISPP,IWTT,IX#                                            QF39  53
INTEGER J,JX#                                                           QF39  54
INTEGER K,KNOWNR,KP#                                                    QF39  55
INTEGER L,L1#                                                           QF39  56
INTEGER MM#                                                             QF39  57
INTEGER MISFIT(4)#                                                      QF39  58
INTEGER NCHN#                                                           QF39  59
INTEGER NSW(6)#                                                         QF39  60
REAL PHI,PSI#                                                           QF39  61
REAL P1,P2,P3#                                                          QF39  62
REAL QF05#                             3x3 determinant function         QF39  63
REAL QG(3,3)#                                                           QF39  64
REAL QR(3,3),QT(3)#                                                     QF39  65
####REAL R#                                                             Nov93001
REAL RX(3,4)#                                                           QF39  67
REAL RXBAR(4)#                                                          QF39  68
REAL SIGS(6)#                                                           QF39  69
REAL SUMB,SUMP#                                                         QF39  70
REAL TCHI#                                                              QF39  71
REAL TX,TY,TZ#                         Equivalenced to qt(1),(2),(3)    QF39  72
REAL U(3,3,4),V(3,4)#                                                   QF39  73
REAL WBB#                                                               QF39  74
REAL WT,WTT(6)#                                                         QF39  75
REAL XF(3,4)#                                                           QF39  76
#     CHARACTER*2 ID(4) ! CORRECTION FROM I*4 SUGGESTION OF ALEX WLODAW QF39  77
chardata:(ID,ABCDEFGH)#                                                 QF39  78
EQUIVALENCE (TX,QT(1)),(TY,QT(2)),(TZ,QT(3))#                           QF39  79
chardata:(QF39A, ---- TRANSFORMATION FROM CHAIN    TO CHAIN   ----)#    QF39  80
chardata:(QF39B,[    DET(R) =         ])#                               QF39  81
chardata:(QF39C,[   N     R(N,1)    R(N,2)    R(N,3)      T(N)])#       QF39  82
chardata:(QF39D,   PHI =         PSI =         CHI =         $#         QF39  83
TCHI =         )#                                                       QF39  84
chardata:(QF39E, DEVIATIONS FROM SUPERPOSABILITY -->       POSITIONS $# QF39  85
IN CHAIN    DEVIATE BY MORE THAN TWO SIGMA FROM THE AVERAGE POSITION)#  QF39  86
realdata:(FM40,[150622.,290622.,430622.,580622.])#                      QF39  87
realdata:(FM35,[60313.,160852.,261052.,361052.,461052.])#               QF39  88
chardata:(QF39F,  ATOM   DELTA  ATOM   DELTA  ATOM   DELTA  ATOM   $#   QF39  89
DELTA  ATOM   DELTA  ATOM   DELTA  ATOM   DELTA  ATOM   DELTA)#         QF39  90
realdata:(FM210,[140422.,280422.,420422.,560422.,700422.,$#             QF39  91
840422.,980422.,1120422.])#                                             QF39  92
realdata:(FM220,[351471.,630732.])#                                     QF39  93
chardata:(QF39G,[ SUM(WGT*DELTAP**2) =               $#                 QF39  94
AVG(WGT*DELTAP**2) =       FOR POSITIONAL SPECIAL SYMMETRY])#           QF39  95
chardata:(QF39H,[ SUM(WGT*DELTAB**2) =               $#                 QF39  96
AVG(WGT*DELTAB**2) =       FOR THERMAL SPECIAL SYMMETERY])#             QF39  97
chardata:(QF39I,          ROOT                  RMS     RMS     $#      QF39  98
RMS     RMS)#                                                           QF39  99
chardata:(QF39J,[  TYPE   1/WGT NUMBER  SIGMA   DELTA1  DELTA2  $#      QF39 100
DELTA3  DELTA4   LEVEL OF RESTRAINT])#                                  QF39 101
realdata:(FM250,[50413.,140612.,200613.,280832.,360832.,440832.,$#      QF39 102
520832.,590832.])#                                                      QF39 103
chardata:(QF39L, TIGHT POSITIONAL RESTRAINT)#                           QF39 104
chardata:(QF39M,[ MEDIUM POSITIONAL RESTRAINT])#                        QF39 105
chardata:(QF39N,[ LOOSE POSITIONAL RESTRAINT])#                         QF39 106
chardata:(QF39O, TIGHT THERMAL RESTRAINT)#                              QF39 107
chardata:(QF39P,[ MEDIUM THERMAL RESTRAINT])#                           QF39 108
chardata:(QF39Q,[ LOOSE THERMAL RESTRAINT])#                            QF39 109
chardata:(QF39R,[ >>>>>>>>>>>>>>>>>>>>>>>> SPECIAL SYMMETRY $#          QF39 110
RESTRAINTS <<<<<<<<<<<<<<<<<<<<<<<<<])#                                 QF39 111
datastuff:#                                                             QF39 112
#                                                                       QF39 113
STEPT=15#                                                               QF39 114
L1=6*NA+9*NDIS+1 ; SIGS(1)=SIGSP1 ; SIGS(2)=SIGSP2# Initialize          QF39 115
SIGS(3)=SIGSP3 ; SIGS(4)=SIGSB1 ; SIGS(5)=SIGSB2 ; SIGS(6)=SIGSB3#      QF39 116
DO I=1,6 ; WTT(I)=WSSKAL/SIGS(I)#                                       QF39 117
LINRM=10 ; writeline:(4,QF39R,NQF39R,3,3)# Write a heading              QF39 118
#                                                                       QF39 119
#    READ THE HEADER RECORD FOR A SYMMETRY GROUP                        QF39 120
#    -------------------------------------------                        QF39 121
DO IGROUP=1,2#                                                          QF39 122
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF39 123
NS=NSYM(IGROUP) ; IF(NS==0) NEXT#                                       QF39 124
readwpkt:(TINFIL,LRSYM,PSIZ6,GETPK,0)# Special symmetry constraints     QF39 125
IF(GETPK<=0) iquit:(QF3901)#           Rec's must sync!                 QF39 126
NCHN=NINT(QX(GETPK+1)) ; KNOWNR=NINT(QX(GETPK+2))#                      QF39 127
DO K=1,NCHN#                                                            QF39 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF39 129
movertoc:(QX(GETPK+3),(K-1)*2+1,ID,(K-1)*2+1,2,0)#                      QF39 130
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF39 131
IF(KNOWNR!=0)#                                                          QF39 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF39 133
DO K=1,NCHN#                                                            QF39 134
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF39 135
readwpkt:(TINFIL,LRSYM,PSIZ6,GETPK,0)# Special symmetry constraints     QF39 136
IF(GETPK<=0) iquit:(QF3901)#           Rec's must sync!                 QF39 137
IJ=GETPK ; DO I=1,3 ; DO J=1,3#                                         QF39 138
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF39 139
IJ=IJ+1 ; QR(I,J)=QX(IJ)#                                               QF39 140
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF39 141
DO I=1,3#                                                               QF39 142
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF39 143
IJ=IJ+1 ; QT(I)=QX(IJ)#                                                 QF39 144
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF39 145
DETR=QF05(QR) ; DO I=1,3#                                               QF39 146
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF39 147
V(I,K)=QT(I) ; DO J=1,3#                                                QF39 148
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF39 149
U(I,J,K)=0.0 ; DO L=1,3 ; U(I,J,K)=U(I,J,K)+QR(I,L)*QG(L,J)#            QF39 150
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF39 151
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF39 152
movechar:(ID,K,QF39A,34,2,0) ; movechar:(ID,1,QF39A,34,2,0)#            QF39 153
writeline:(1,QF39A,NQF39A,3,4);LINRM=5;writeline:(1,QF39C,NQF39C,3,4)#  QF39 154
DO J=1,3#                                                               QF39 155
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF39 156
BUFOT(1)=FLOAT(J) ; BUFOT(2)=QR(J,1) ; BUFOT(3)=QR(J,2)#                QF39 157
BUFOT(4)=QR(J,3) ; BUFOT(5)=QT(J)#                                      QF39 158
ncodefld:(BUFOT,1,CHROT,FM35,5)#                                        QF39 159
writeline:(0,0,0,1,4)#                                                  QF39 160
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF39 161
ncodefld:(DETR,1,QF39B,200952.,1) ; writeline:(1,QF39B,NQF39B,3,4)#     QF39 162
#                                                                       QF39 163
CALL QF40(QR,PHI,PSI,CHI)#              Call polar                      Nov93002
P1=PHI/DEGTOR ; P2=PSI/DEGTOR ; P3=CHI/DEGTOR#                          QF39 165
TCHI=SIN(PSI)*COS(PHI)*TX+COS(PSI)*TY-SIN(PSI)*SIN(PHI)*TZ#             QF39 166
BUFOT(1)=P1 ; BUFOT(2)=P2 ; BUFOT(3)=P3 ; BUFOT(4)=TCHI#                QF39 167
ncodefld:(BUFOT,1,QF39D,FM40,4) ; writeline:(1,QF39D,NQF39D,3,4)#       QF39 168
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF39 169
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF39 170
#     READ THE ATOM EQUIVALENCES FOR THIS SYMMETRY GROUP                QF39 171
#     --------------------------------------------------                QF39 172
ISP=MARKT-STEPT ; DO IS=1,NS#                                           QF39 173
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF39 174
readwpkt:(TINFIL,LRSYM,PSIZ6,GETPK,0)# Special symmetry constraints     QF39 175
IF(IS!=NINT(QX(GETPK+1))\GETPK<=0) iquit:(QF3901)# Rec's must sync!     QF39 176
ISP=ISP+STEPT ; QX(ISP+11)=QX(GETPK+2)#                                 QF39 177
DO K=1,NCHN ; QX(ISP+K+11)=QX(GETPK+K+2)#                               QF39 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF39 179
#     FIND THE SYMMETRY TRANSFORMATIONS IF NEEDED                       QF39 180
#     -------------------------------------------                       QF39 181
IF(KNOWNR!=1)#                                                          QF39 182
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF39 183
DO IS=1,NS#                                                             QF39 184
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF39 185
#          KI(IS)=1 ; IF(IWT(IS)!=1) KI(IS)=0#                          QF39 186
ISP=(IS-1)*STEPT+MARKT ; QX(ISP+10)=1.0#                                QF39 187
IF(NINT(QX(ISP+1))!=1) QX(ISP+10)=0.0#                                  QF39 188
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF39 189
L=-1 ; DO K=1,NCHN#                                                     QF39 190
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF39 191
L=L+2#                                                                  QF39 192
movechar:(ID,L,QF39A,34,2,0) ; movechar:(ID,1,QF39A,34,2,0)#            QF39 193
writeline:(1,QF39A,NQF39A,3,4)#                                         QF39 194
#                                                                       QF39 195
DO IS=1,NS#                                                             QF39 196
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF39 197
ISP=(IS-1)*STEPT+MARKT#                                                 QF39 198
QX(ISP+4)=QX(ISP+K+11)#                Indx(is)=iat(is,k)#              QF39 199
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF39 200
DO IS=1,NS#                                                             QF39 201
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF39 202
ISP=(IS-1)*STEPT+MARKT#                                                 QF39 203
ISPP=(NINT(QX(ISP+4))-1)*STEPA+MARKA#  X,y,z from atom array            QF39 204
QX(ISP+7)=QX(ISPP+1) ; QX(ISP+8)=QX(ISPP+2) ; QX(ISP+9)=QX(ISPP+3)#     QF39 205
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF39 206
IF(K==1)#                                                               QF39 207
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF39 208
DO IS=1,NS#                            Deorthogonalize coordinates      QF39 209
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QF39 210
ISP=(IS-1)*STEPT+MARKT#                                                 QF39 211
QX(ISP+1)=ORXX*QX(ISP+7) ; QX(ISP+1)=QX(ISP+1)+ORXY*QX(ISP+8)#          QF39 212
QX(ISP+1)=QX(ISP+1)+ORXZ*QX(ISP+9)#    Get transformed x                QF39 213
QX(ISP+2)=ORYY*QX(ISP+8) ; QX(ISP+2)=QX(ISP+2)+ORYZ*QX(ISP+9)# Y        QF39 214
QX(ISP+3)=ORZZ*QX(ISP+9)#              And z                            QF39 215
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QF39 216
DO I=1,3#                                                               QF39 217
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QF39 218
QT(I)=0.0 ; DO J=1,3#                                                   QF39 219
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QF39 220
QR(I,J)=0.0 ; IF(I==J) QR(I,J)=1.0#                                     QF39 221
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QF39 222
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QF39 223
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF39 224
ELSE#                                                                   QF39 225
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QF39 226
DO IS=1,NS#                                                             QF39 227
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QF39 228
ISP=(IS-1)*STEPT+MARKT#                                                 QF39 229
QX(ISP+4)=ORXX*QX(ISP+7) ; QX(ISP+4)=QX(ISP+4)+ORXY*QX(ISP+8)#          QF39 230
QX(ISP+4)=QX(ISP+4)+ORXZ*QX(ISP+9)#    Get transformed x                QF39 231
QX(ISP+5)=ORYY*QX(ISP+8) ; QX(ISP+5)=QX(ISP+5)+ORYZ*QX(ISP+9)# Y        QF39 232
QX(ISP+6)=ORZZ*QX(ISP+9)#              And z                            QF39 233
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QF39 234
CALL QF41(NS,QR,QT)#                   Call toss                        QF39 235
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QF39 236
DO I=1,3#                                                               QF39 237
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QF39 238
V(I,K)=QT(I) ; DO J=1,3#                                                QF39 239
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QF39 240
U(I,J,K)=0.0 ; DO L=1,3#                                                QF39 241
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QF39 242
U(I,J,K)=U(I,J,K)+QR(I,L)*G(L,J)#                                       QF39 243
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QF39 244
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QF39 245
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QF39 246
DETR=QF05(QR)#                         Get determinant of qr            QF39 247
LINRM=5;writeline:(1,QF39C,NQF39C,3,4)#                                 QF39 248
DO J=1,3#                                                               QF39 249
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QF39 250
BUFOT(1)=FLOAT(J) ; BUFOT(2)=QR(J,1) ; BUFOT(3)=QR(J,2)#                QF39 251
BUFOT(4)=QR(J,3) ; BUFOT(5)=QT(J)#                                      QF39 252
ncodefld:(BUFOT,1,CHROT,FM35,5)#                                        QF39 253
writeline:(0,0,0,1,4)#                                                  QF39 254
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QF39 255
ncodefld:(DETR,1,QF39B,200952.,1) ; writeline:(1,QF39B,NQF39B,3,4)#     QF39 256
CALL QF40(QR,PHI,PSI,CHI)#             Call polar                       QF39 257
P1=PHI*RTODEG ; P2=PSI*RTODEG ; P3=CHI*RTODEG#                          QF39 258
TCHI=SIN(PSI)*COS(PHI)*TX+COS(PSI)*TY-SIN(PSI)*SIN(PHI)*TZ#             QF39 259
BUFOT(1)=P1 ; BUFOT(2)=P2 ; BUFOT(3)=P3 ; BUFOT(4)=TCHI#                QF39 260
ncodefld:(BUFOT,1,QF39D,FM40,4) ; writeline:(1,QF39D,NQF39D,3,4)#       QF39 261
#                                                                       QF39 262
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF39 263
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF39 264
#    INITIALIZE STATISTICAL SUMS FOR THIS SYMMETRY GROUP                QF39 265
SUMP=0.0 ; SUMB=0.0 ; DO I=1,6#                                         QF39 266
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QF39 267
NSW(I)=0 ; DO K=1,NCHN#                                                 QF39 268
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 QF39 269
DEL(K,I)=0.0 ; MISFIT(K)=0#                                             QF39 270
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 QF39 271
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QF39 272
#     CYCLE REFINEMENT OVER ALL ATOM EQUIVALENCES                       QF39 273
ISP=MARKT-STEPT ; DO IS=1,NS#                                           QF39 274
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 QF39 275
ISP=ISP+STEPT ; IWTT=NINT(QX(ISP+11))#                                  QF39 276
WT=WTT(IWTT) ; WBB=WTT(IWTT+3)**2#                                      QF39 277
#     FIND THE INDIVIDUAL AND AVERAGE TRANSFORMED POSITIONS             QF39 278
BBAR=0.0 ; DO IX=1,3 ; RXBAR(IX)=0.0#                                   QF39 279
DO K=1,NCHN#                                                            QF39 280
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 QF39 281
IA=NINT(QX(ISP+K+11)) ; IAP=(IA-1)*STEPA+MARKA#                         QF39 282
XF(1,K)=QX(IAP+1) ; XF(2,K)=QX(IAP+2) ; XF(3,K)=QX(IAP+3)#              QF39 283
DO IX=1,3#                                                              QF39 284
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 QF39 285
RX(IX,K)=V(IX,K) ; DO JX=1,3 ; RX(IX,K)=RX(IX,K)+U(IX,JX,K)*XF(JX,K)#   QF39 286
RXBAR(IX)=RXBAR(IX)+RX(IX,K)#                                           QF39 287
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 QF39 288
IF(TFTYPE==0) NEXT#                                                     QF39 289
IAP=(IA-1)*STEPA+MARKA#                Point to atom in storage         QF39 290
# BBAR=BBAR+BETA(IA) ; BB(K)=BETA(IA)# HAVE TO FIND TEMPERATURE FACTORS QF39 291
BBAR=BBAR+QX(IAP+5) ; BB(K)=QX(IAP+5)#                                  QF39 292
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 QF39 293
DO IX=1,3 ; RXBAR(IX)=RXBAR(IX)/FLOAT(NCHN)#                            QF39 294
BBAR=BBAR/FLOAT(NCHN)#                                                  QF39 295
#     FIND DEVIATIONS FROM COMMON SUPERPOSABILITY                       QF39 296
DO K=1,NCHN#                                                            QF39 297
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 QF39 298
DD(K)=0.0 ; DO IX=1,3#                                                  QF39 299
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 QF39 300
DX(IX,K)=RX(IX,K)-RXBAR(IX) ; DD(K)=DD(K)+DX(IX,K)**2#                  QF39 301
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 QF39 302
DD(K)=SQRT(DD(K)) ; IF(TFTYPE==0) NEXT ; DB(K)=BB(K)-BBAR#              QF39 303
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 QF39 304
#     FIND DERIVATIVES FOR SUPERPOSITION                                QF39 305
DO K=1,NCHN#                                                            QF39 306
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 QF39 307
DO IX=1,3#                                                              QF39 308
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 QF39 309
DDX(IX,K)=0.0 ; DO JX=1,3 ; DDX(IX,K)=DDX(IX,K)+U(JX,IX,K)*DX(JX,K)#    QF39 310
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 QF39 311
DO IX=1,3 ; DDX(IX,K)=DDX(IX,K)/DD(K)#                                  QF39 312
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 QF39 313
#     ACCUMULATE STATISTICS AND APPLY WEIGHTING                         QF39 314
NSW(IWTT)=NSW(IWTT)+1#                                                  QF39 315
DO K=1,NCHN#                                                            QF39 316
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 QF39 317
DS=DD(K)**2 ; SUMP=SUMP+DS*WT**2 ; DEL(K,IWTT)=DEL(K,IWTT)+DS#          QF39 318
IF(TFTYPE!=0)#                                                          QF39 319
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 QF39 320
BS=DB(K)**2 ; SUMB=SUMB+BS*WBB ; DEL(K,IWTT+3)=DEL(K,IWTT+3)+BS#        QF39 321
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 QF39 322
IF(ABS(DD(K))>=2.0*SIGS(IWTT))#                                         QF39 323
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 QF39 324
KP=(MISFIT(K)-1)*STEPT+MARKT ; MISFIT(K)=MISFIT(K)+1#                   QF39 325
QX(KP+K)=QX(KP+K+11)#                  Idatm(misfit(k),k)=iat(is,k)     QF39 326
QX(KP+K+4)=DD(K)#                      Delta(misfit(k),k)=dd(k)         QF39 327
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 QF39 328
DO IX=1,3 ; DDX(IX,K)=WT*DDX(IX,K) ; DD(K)=WT*DD(K)#                    QF39 329
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 QF39 330
#     ACCUMULATE NORMAL EQUATION SUMS                                   QF39 331
ISP=(IS-1)*STEPT+MARKT#                                                 QF39 332
DO K=1,NCHN#                                                            QF39 333
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 QF39 334
IA=NINT(QX(ISP+K+11))#                 Ia=iat(is,k)                     QF39 335
#     INCREMENT ELEMENTS OF THE RIGHT-HAND-SIDE VECTOR                  QF39 336
M0=3*(IA-1)+1#                                                          QF39 337
DO IX=1,3 ; QX(M0+IX+MARKV)=QX(M0+IX+MARKV)-DDX(IX,K)*DD(K)#            QF39 338
IF(TFTYPE!=0) QX(IATMN+IA+MARKV)=QX(IATMN+IA+MARKV)-DB(K)*WBB#          QF39 339
#     INCREMENT MATRIX ELEMENTS WITHIN ATOM BLOCKS                      QF39 340
MM=6*(IA-1)+2+MARKM ; DO IX=1,3 ; DO JX=IX,3#                           QF39 341
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 QF39 342
QX(MM)=QX(MM)+DDX(IX,K)*DDX(JX,K) ; MM=MM+1#                            QF39 343
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 QF39 344
IF(TFTYPE!=0) QX(L1+IA+MARKM)=QX(L1+IA+MARKM)+WBB#                      QF39 345
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 QF39 346
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 QF39 347
#     PRINT OUT DEVIANT EQUIVALENCES AND DISCREPANCY AVERAGES           QF39 348
L=-1 ; DO K=1,NCHN#                                                     QF39 349
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 QF39 350
L=L+2;BUFOT(1)=FLOAT(MISFIT(K)) ; movechar:(ID,L,QF39E,64,2,0)#         QF39 351
ncodefld:(BUFOT,1,QF39E,420613.,1);writeline:(1,QF39E,NQF39E,3,4)#      QF39 352
MK=MISFIT(K) ; IF(MK!=0)#                                               QF39 353
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 QF39 354
II=0 ; DO I=1,MK#                                                       QF39 355
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 QF39 356
IF(II>7)#                                                               QF39 357
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 QF39 358
ncodefld:(BUFOT,1,CHROT,FM210,II);writeline:(0,QF39F,NQF39F,1,4);II=0#  QF39 359
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 QF39 360
II=II+1 ; IP=(I-1)*STEPT+MARKT#                                         QF39 361
III=(NINT(QX(IP+K))-1)*STEPA+MARKA#                                     QF39 362
movertoc:(QX(III+8),2,CHROT,(II-1)*14+3,8,0)#                           QF39 363
BUFOT(II)=QX(III+K+4)#                 Delta(i,k)                       QF39 364
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 QF39 365
ncodefld:(BUFOT,1,CHROT,FM220,II);writeline:(0,QF39F,NQF39F,1,4);II=0#  QF39 366
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 QF39 367
IF(NCHN==2) BREAK#                                                      QF39 368
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 QF39 369
AVGP=SUMP/FLOAT(NCHN*NS) ; BUFOT(1)=SUMP ; BUFOT(2)=AVGP#               QF39 370
ncodefld:(BUFOT,1,QF39G,FM220,2) ; writeline:(1,QF39G,NQF39G,3,3)#      QF39 371
IF(TFTYPE!=0)#                                                          QF39 372
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 QF39 373
AVGB=SUMB/FLOAT(NCHN*NS) ; BUFOT(1)=SUMB ; BUFOT(2)=AVGB#               QF39 374
ncodefld:(BUFOT,1,QF39H,FM220,2) ; writeline:(1,QF39H,NQF39H,3,3)#      QF39 375
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 QF39 376
writeline:(1,QF39I,NQF39I,3,3) ; LINRM=6#                               QF39 377
DO I=1,6#                                                               QF39 378
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 QF39 379
IF(TFTYPE==0&I>3) BREAK#                                                QF39 380
IF(I>3) NSW(I)=NSW(I-3)#                                                QF39 381
IF(NSW(I)!=0)#                                                          QF39 382
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 QF39 383
DO K=1,NCHN ; DEL(K,I)=SQRT(DEL(K,I)/FLOAT(NSW(I)))#                    QF39 384
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 QF39 385
BUFOT(1)=FLOAT(I) ; BUFOT(2)=1.0/AMAX1(0.01,WTT(I))#                    QF39 386
BUFOT(3)=FLOAT(NSW(I))#                                                 QF39 387
BUFOT(4)=SIGS(I) ; DO K=1,NCHN ; BUFOT(K+4)=DEL(K,I)#                   QF39 388
ncodefld:(BUFOT,1,CHROT,FM250,NCHN+4)#                                  QF39 389
IF(I==1) movechar:(QF39L,1,CHROT,59,NQF39L,0)#                          QF39 390
ELSE IF(I==2) movechar:(QF39M,1,CHROT,62,NQF39M,0)#                     QF39 391
ELSE IF(I==3) movechar:(QF39N,1,CHROT,62,NQF39N,0)#                     QF39 392
ELSE IF(I==4) movechar:(QF39O,1,CHROT,62,NQF39O,0)#                     QF39 393
ELSE IF(I==5) movechar:(QF39P,1,CHROT,62,NQF39P,0)#                     QF39 394
ELSE IF(I==6) movechar:(QF39Q,1,CHROT,62,NQF39Q,0)#                     QF39 395
writeline:(0,QF39J,NQF39J,1,3)#                                         QF39 396
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 QF39 397
WPSUM=WPSUM+SUMP ; WBSUM=WBSUM+SUMB#                                    QF39 398
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF39 399
#                                                                       QF39 400
RETURN#                                                                 QF39 401
END#                                                                    QF39 402
systemheader:(QF40)## Make polar coordinates from cartesian             QF40   1
####################################################################    QF40   2
#                                                                  #    QF40   3
#                                QF40                              #    QF40   4
#                                                                  #    QF40   5
####################################################################    QF40   6
SUBROUTINE QF40(R,PHI,PSI,CHI)## SUBROUTINE POLAR(R,PHI,PSI,CHI)        QF40   7
#                                        W. hendrickson                 QF40   8
REAL CHI,PHI,PSI#                                                       QF40   9
REAL R(3,3)#                                                            QF40  10
realdata:(PI,[3.14159265])#                                             QF40  11
realdata:(PIOVR2,[1.5707963])#                                          QF40  12
realdata:(ZILCH,[0.0000001])#                                           QF40  13
datastuff:#                                                             QF40  14
IF(ABS(R(1,2)-R(2,1))<ZILCH&ABS(R(2,3)-R(3,2))<ZILCH)#                  QF40  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF40  16
IF(ABS(R(1,3)-R(3,1))>=ZILCH)#                                          QF40  17
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF40  18
PHI=0. ; PSI=0. ; CHI=ATAN2(R(3,1),R(1,1))#                             QF40  19
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF40  20
ELSE IF(R(1,2)<=ZILCH&R(2,3)<=ZILCH)#                                   QF40  21
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF40  22
PHI=0. ; PSI=0. ; CHI=0.#                                               QF40  23
IF(R(1,1)<=0.\R(2,2)<=0.\R(3,3)<=0.) CHI=PI#                            QF40  24
ELSE IF(R(2,2)<=0.) PSI=PIOVR2#                                         QF40  25
ELSE IF(R(3,3)<=0.) PHI=PIOVR2#                                         QF40  26
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF40  27
ELSE#                                                                   QF40  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF40  29
PHI=ATAN2(-R(2,3),R(1,2)) ; CHI=PI#                                     QF40  30
IF(R(1,2)<=ZILCH\R(2,3)<=ZILCH) PSI=ATAN2((R(1,2)-R(2,3)),(R(2,2)+1.0))#QF40  31
ELSE IF(ABS(PHI)<0.10\ABS(PHI)>3.00) PSI=ATAN2(R(3,1)/COS(PHI),R(2,3))# QF40  32
ELSE PSI=ATAN2(R(3,1)/SIN(PHI),-R(1,2))#                                QF40  33
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF40  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF40  35
ELSE#                                                                   QF40  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF40  37
PHI=ATAN2((R(2,1)-R(1,2)),(R(2,3)-R(3,2)))#                             QF40  38
IF(ABS(PHI)<0.10\ABS(PHI)>3.00)#                                        QF40  39
PSI=ATAN2(((R(2,3)-R(3,2))/COS(PHI)),(R(3,1)-R(1,3)))#                  QF40  40
ELSE PSI=ATAN2(((R(2,1)-R(1,2))/SIN(PHI)),(R(3,1)-R(1,3)))#             QF40  41
IF(ABS(PSI)>0.10&ABS(PSI)<3.00)#                                        QF40  42
CHI=ATAN2(((R(3,1)-R(1,3))/COS(PSI)),(R(1,1)+R(2,2)+R(3,3)-1.))#        QF40  43
ELSE IF(ABS(PHI)<0.10\ABS(PHI)>3.00)#                                   QF40  44
CHI=ATAN2(((R(2,3)-R(3,2))/(SIN(PSI)*COS(PHI))),$#                      QF40  45
(R(1,1)+R(2,2)+R(3,3)-1.0))#                                            QF40  46
ELSE CHI=ATAN2(((R(2,1)-R(1,2))/(SIN(PSI)*SIN(PHI))),$#                 QF40  47
(R(1,1)+R(2,2)+R(3,3)-1.0))#                                            QF40  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF40  49
RETURN#                                                                 QF40  50
END#                                                                    QF40  51
systemheader:(QF41)## To refine torsion angles                          QF41   1
####################################################################    QF41   2
#                                                                  #    QF41   3
#                                QF41                              #    QF41   4
#                                                                  #    QF41   5
####################################################################    QF41   6
SUBROUTINE QF41(NTAB,QR,QT)## SUBROUTINE TOSS(NTAB,R,T,ISYSW)           QF41   7
#                                        W. hendrickson                 QF41   8
include:(AACOMN)#                                                       QF41   9
include:(QFCOMN)#                                                       QF41  10
#                                                                       QF41  11
REAL C1,C2,C3,C4,C5,C6#                                                 QF41  12
REAL D(18),DD#                                                          QF41  13
REAL GQ(18,18)#                                                         QF41  14
INTEGER I,IC,II,IX#                                                     QF41  15
INTEGER J,JX#                                                           QF41  16
INTEGER KONVRG#                                                         QF41  17
INTEGER M,MATCH,MN,MN0,N,NV1#                                           QF41  18
REAL QF05#                             3x3 deterninant function         QF41  19
REAL QR(3,3),QT(3)#                                                     QF41  20
REAL RMS#                                                               QF41  21
REAL SIGR(3,3),SIGT(3)#                                                 QF41  22
REAL SUMSQR#                                                            QF41  23
#      COMMON /SCRTCH/ XA(QQA,3),XB(QQA,3),XC(QQA,3),KI(QQA)            QF41  24
# OLD XA(N,1)          NEW QX((N-1)*STEPT+MARKT+1)                      QF41  25
# OLD XA(N,2)          NEW QX((N-1)*STEPT+MARKT+2)                      QF41  26
# OLD XA(N,3)          NEW QX((N-1)*STEPT+MARKT+3)                      QF41  27
# OLD XB(N,1)          NEW QX((N-1)*STEPT+MARKT+4)                      QF41  28
# OLD XB(N,2)          NEW QX((N-1)*STEPT+MARKT+5)                      QF41  29
# OLD XB(N,3)          NEW QX((N-1)*STEPT+MARKT+6)                      QF41  30
# OLD XC(N,1)          NEW QX((N-1)*STEPT+MARKT+7)                      QF41  31
# OLD XC(N,2)          NEW QX((N-1)*STEPT+MARKT+8)                      QF41  32
# OLD XC(N,3)          NEW QX((N-1)*STEPT+MARKT+9)                      QF41  33
# OLD KI(N)            NEW QX((N-1)*STEPT+MARKT+10)                     QF41  34
# OLD TEMP(N)          NEW QX((N-1)*STEPT+MARKT+16)                     QF41  35
#      DIMENSION TEMP(QQA)                                              QF41  36
intdata:(NCYCLE,[10])#                                                  QF41  37
realdata:(FM230,[200632.,330513.,610213.])#                             QF41  38
chardata:(QF41A,   RMS DELTA =       FOR THE      TYPE 1 $#             QF41  39
EQUIVALENCES AFTER   TOSS CYCLES)#                                      QF41  40
datastuff:#                                                             QF41  41
#                                                                       QF41  42
#     INITIALIZE FOR THE UNCONDITIONAL MINIMIZATION                     QF41  43
#     ---------------------------------------------                     QF41  44
#                                                                       QF41  45
NV1=12 ; DO M=1,NV1#                                                    QF41  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF41  47
D(M)=0 ; DO N=1,NV1 ; GQ(M,N)=0#                                        QF41  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF41  49
DO I=1,3#                                                               QF41  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF41  51
SIGT(I)=0.0 ; DO J=1,3 ; SIGR(I,J)=0.0#                                 QF41  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF41  53
#                                                                       QF41  54
#     PREPARE RIGHT-HAND-SIDE SUMS FOR INITIAL MINIMIZATION             QF41  55
#     -----------------------------------------------------             QF41  56
M=0 ; DO IX=1,3 ; DO JX=1,3#                                            QF41  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF41  58
M=M+1 ; DO I=1,NTAB#                                                    QF41  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF41  60
#     D(M) = D(M) + KI(I)*XA(I,IX)*XB(I,JX)                             QF41  61
II=(I-1)*STEPT+MARKT#                                                   QF41  62
#TEMP(I)=KI(I)*XA(I,IX) ; TEMP(I)=TEMP(I)*XB(I,JX) ; D(M)=D(M)+TEMP(I)# QF41  63
QX(II+16)=QX(II+10)*QX(II+IX) ; QX(II+16)=QX(II+16)*QX(II+JX+3)#        QF41  64
D(M)=D(M)+QX(II+16)#                                                    QF41  65
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF41  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF41  67
DO IX=1,3#                                                              QF41  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF41  69
M=M+1 ; DO I=1,NTAB#                                                    QF41  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF41  71
II=(I-1)*STEPT+MARKT#                                                   QF41  72
#     D(M) = D(M) + KI(I)*XA(I,IX)                                      QF41  73
#TEMP(I)=KI(I)*XA(I,IX) ; D(M)=D(M)+TEMP(I)#                            QF41  74
QX(II+16)=QX(II+10)*QX(II+IX) ; D(M)=D(M)+QX(II+16)#                    QF41  75
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF41  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF41  77
#                                                                       QF41  78
#     PREPARE MATRIX ELEMENT SUMS                                       QF41  79
#     ---------------------------                                       QF41  80
#                                                                       QF41  81
DO IX=1,3 ; DO JX=IX,3 ; DO I=1,NTAB#                                   QF41  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF41  83
II=(I-1)*STEPT+MARKT#                                                   QF41  84
#     SIGR(IX,JX) = SIGR(IX,JX) + KI(I)*XB(I,IX)*XB(I,JX)               QF41  85
#TEMP(I)=KI(I)*XB(I,IX) ; TEMP(I)=TEMP(I)*XB(I,JX)#                     QF41  86
QX(II+16)=QX(II+10)*QX(II+IX+3) ; QX(II+16)=QX(II+16)*QX(II+JX+3)#      QF41  87
SIGR(IX,JX)=SIGR(IX,JX)+QX(II+16)#                                      QF41  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF41  89
DO IX=1,3 ; DO I=1,NTAB#                                                QF41  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF41  91
II=(I-1)*STEPT+MARKT#                                                   QF41  92
#     SIGT(IX) = SIGT(IX) + KI(I)*XB(I,IX)                              QF41  93
#TEMP(I)=KI(I)*XB(I,IX) ; SIGT(IX)=SIGT(IX)+TEMP(I)#                    QF41  94
QX(II+16)=QX(II+10)*QX(II+IX+3) ; SIGT(IX)=SIGT(IX)+QX(II+16)#          QF41  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF41  96
SIGR(2,1)=SIGR(1,2) ; SIGR(3,1)=SIGR(1,3) ; SIGR(3,2)=SIGR(2,3)#        QF41  97
#                                                                       QF41  98
#     COUNT THE ACTIVE EQUIVALENCES                                     QF41  99
#     -----------------------------                                     QF41 100
#                                                                       QF41 101
MATCH=0 ; DO I=1,NTAB#                                                  QF41 102
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF41 103
II=(I-1)*STEPT+MARKT ; MATCH=MATCH+NINT(QX(II+10))# Add ki(i)           QF41 104
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF41 105
#                                                                       QF41 106
#     SET UP THE NORMAL EQUATIONS                                       QF41 107
#     ---------------------------                                       QF41 108
#                                                                       QF41 109
MN=1 ; REPEAT#                                                          QF41 110
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF41 111
MN0=3*(MN-1) ; DO I=1,3#                                                QF41 112
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF41 113
M=MN0+I ; GQ(M,MN+9)=SIGT(I) ; GQ(MN+9,M)=SIGT(I) ; DO J=1,3#           QF41 114
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF41 115
N=MN0+J ; GQ(M,N)=SIGR(I,J)#                                            QF41 116
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF41 117
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF41 118
GQ(MN+9,MN+9)=MATCH ; MN=MN+1 ; IF(MN>3) BREAK#                         QF41 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF41 120
#                                                                       QF41 121
#     INVERT THE MATRIX AND OBTAIN NEW PARAMETERS                       QF41 122
#     -------------------------------------------                       QF41 123
#                                                                       QF41 124
CALL QF42(G,D,NV1,18)#                 Call matinv(g,d,nv,18)           QF41 125
C1=D(1)**2+D(2)**2+D(3)**2 ; C2=D(4)**2+D(5)**2+D(6)**2#                QF41 126
C3=D(7)**2+D(8)**2+D(9)**2 ; C4=D(4)*D(7)+D(5)*D(8)+D(6)*D(9)#          QF41 127
C5=D(7)*D(1)+D(8)*D(2)+D(9)*D(3) ; C6=D(1)*D(4)+D(2)*D(5)+D(3)*D(6)#    QF41 128
QR(1,1)=D(1) ; QR(1,2)=D(2) ; QR(1,3)=D(3) ; QR(2,1)=D(4)#              QF41 129
QR(2,2)=D(5) ; QR(2,3)=D(6) ; QR(3,1)=D(7) ; QR(3,2)=D(8)#              QF41 130
QR(3,3)=D(9) ; QT(1)=D(10) ; QT(2)=D(11) ; QT(3)=D(12)#                 QF41 131
#                                                                       QF41 132
#     ORTHOGONAL TRANSFORMATION CONSTRAINTS BY NON-LINEAR LEAST-SQUARES QF41 133
NV1=18 ; KONVRG=0 ; DO IC=1,NCYCLE#                                     QF41 134
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF41 135
#                                                                       QF41 136
#     INITIALIZE FOR THIS CYCLE                                         QF41 137
#     -------------------------                                         QF41 138
#                                                                       QF41 139
DO M=1,NV1#                                                             QF41 140
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF41 141
D(M)=0 ; DO N=1,NV1 ; GQ(M,N)=0#                                        QF41 142
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF41 143
#                                                                       QF41 144
#     FIND THE CURRENT TRANSFORMED SET OF POSITIONS                     QF41 145
#     ---------------------------------------------                     QF41 146
#                                                                       QF41 147
DO IX=1,3#                                                              QF41 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF41 149
DO I=1,NTAB#                                                            QF41 150
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF41 151
II=(I-1)*STEPT+MARKT ; QX(II+IX+6)=QT(IX)# Xc(i,ix)=qt(ix)              QF41 152
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF41 153
DO JX=1,3 ; DO I=1,NTAB#                                                QF41 154
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QF41 155
II=(I-1)*STEPT+MARKT#                                                   QF41 156
#     XC(I,IX) = XC(I,IX) + R(IX,JX)*XB(I,JX)                           QF41 157
#TEMP(I)=R(IX,JX)*XB(I,JX) ; XC(I,IX)=XC(I,IX)+TEMP(I)#                 QF41 158
QX(II+16)=QR(IX,JX)*QX(II+JX+3) ; QX(II+IX+6)=QX(II+IX+6)+QX(II+16)#    QF41 159
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QF41 160
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF41 161
#                                                                       QF41 162
#     PREPARE RIGHT-HAND-SIDE SUMS FOR THIS ITERATION                   QF41 163
#     -----------------------------------------------                   QF41 164
#                                                                       QF41 165
M=0 ; DO IX=1,3 ; DO JX=1,3#                                            QF41 166
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QF41 167
M=M+1 ; DO I=1,NTAB#                                                    QF41 168
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QF41 169
II=(I-1)*STEPT+MARKT#                                                   QF41 170
#     D(M) = D(M) + KI(I)*(XA(I,IX)-XC(I,IX))*XB(I,JX)                  QF41 171
#TEMP(I)=XA(I,IX)-XC(I,IX) ; TEMP(I)=KI(I)*TEMP(I)#                     QF41 172
#TEMP(I)=TEMP(I)*XB(I,JX) ; D(M)=D(M)+TEMP(I)#                          QF41 173
QX(II+16)=QX(II+IX)-QX(II+IX+6)#                                        QF41 174
QX(II+16)=QX(II+10)*QX(II+16)#                                          QF41 175
QX(II+16)=QX(II+16)*QX(II+JX+3)#                                        QF41 176
D(M)=D(M)+QX(II+16)#                                                    QF41 177
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QF41 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QF41 179
DO IX=1,3#                                                              QF41 180
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QF41 181
M=M+1 ; DO I=1,NTAB#                                                    QF41 182
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QF41 183
II=(I-1)*STEPT+MARKT#                                                   QF41 184
#     D(M) = D(M) + KI(I)*(XA(I,IX)-XC(I,IX))                           QF41 185
#TEMP(I)=XA(I,IX)-XC(I,IX) ; TEMP(I)=KI(I)*TEMP(I) ; D(M)=D(M)+TEMP(I)# QF41 186
QX(II+16)=QX(II+IX)-QX(II+IX+6)#                                        QF41 187
QX(II+16)=QX(II+10)*QX(II+16)#                                          QF41 188
D(M)=D(M)+QX(II+16)#                                                    QF41 189
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QF41 190
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QF41 191
#                                                                       QF41 192
#     CONSTRAINT CONTRIBUTIONS TO RIGHT-HAND-SIDE VECTOR                QF41 193
#     --------------------------------------------------                QF41 194
#                                                                       QF41 195
D(13)=1.0-C1 ; D(14)=1.0-C2 ; D(15)=1.0-C3#                             QF41 196
D(16)=-C4 ; D(17)=-C5 ; D(18)=-C6#                                      QF41 197
#                                                                       QF41 198
#     SET UP THE NORMAL EQUATIONS                                       QF41 199
#     ---------------------------                                       QF41 200
#                                                                       QF41 201
MN=1 ; REPEAT#                                                          QF41 202
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QF41 203
MN0=3*(MN-1) ; DO I=1,3#                                                QF41 204
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QF41 205
M=MN0+I;GQ(M,MN+9)=SIGT(I);GQ(MN+9,M)=SIGT(I);GQ(M,MN+12)=2.*QR(MN,I)#  QF41 206
GQ(MN+12,M)=2.*QR(MN,I) ; GQ(16,I+3)=QR(3,I) ; GQ(16,I+6)=QR(2,I)#      QF41 207
GQ(17,I  )=QR(3,I) ; GQ(17,I+6)=QR(1,I) ; GQ(18,I  )=QR(2,I)#           QF41 208
GQ(18,I+3)=QR(1,I) ; GQ(I+3,16)=QR(3,I) ; GQ(I+6,16)=QR(2,I)#           QF41 209
GQ(I  ,17)=QR(3,I) ; GQ(I+6,17)=QR(1,I) ; GQ(I  ,18)=QR(2,I)#           QF41 210
GQ(I+3,18)=QR(1,I) ; DO J=1,3#                                          QF41 211
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QF41 212
N=MN0+J ; GQ(M,N)=SIGR(I,J)#                                            QF41 213
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QF41 214
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QF41 215
GQ(MN+9,MN+9)=MATCH ; MN=MN+1 ; IF(MN>3) BREAK#                         QF41 216
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QF41 217
#                                                                       QF41 218
#     INVERT THE MATRIX AND OBTAIN NEW PARAMETERS                       QF41 219
#     -------------------------------------------                       QF41 220
#                                                                       QF41 221
CALL QF42(GQ,D,NV1,18)#                Call matinv(gq,d,nv,18)          QF41 222
QR(1,1)=QR(1,1)+D(1) ; QR(1,2)=QR(1,2)+D(2) ; QR(1,3)=QR(1,3)+D(3)#     QF41 223
QR(2,1)=QR(2,1)+D(4) ; QR(2,2)=QR(2,2)+D(5) ; QR(2,3)=QR(2,3)+D(6)#     QF41 224
QR(3,1)=QR(3,1)+D(7) ; QR(3,2)=QR(3,2)+D(8) ; QR(3,3)=QR(3,3)+D(9)#     QF41 225
QT(1)=QT(1)+D(10) ; QT(2)=QT(2)+D(11) ; QT(3)=QT(3)+D(12)#              QF41 226
IF(KONVRG!=0) BREAK#                                                    QF41 227
C1=QR(1,1)**2+QR(1,2)**2+QR(1,3)**2#                                    QF41 228
C2=QR(2,1)**2+QR(2,2)**2+QR(2,3)**2#                                    QF41 229
C3=QR(3,1)**2+QR(3,2)**2+QR(3,3)**2#                                    QF41 230
C4=QR(2,1)*QR(3,1)+QR(2,2)*QR(3,2)+QR(2,3)*QR(3,3)#                     QF41 231
C5=QR(3,1)*QR(1,1)+QR(3,2)*QR(1,2)+QR(3,3)*QR(1,3)#                     QF41 232
C6=QR(1,1)*QR(2,1)+QR(1,2)*QR(2,2)+QR(1,3)*QR(2,3)#                     QF41 233
DD=QF05(QR) ; IF(ABS(ABS(DD)-1.0)<0.00005) KONVRG=IC#                   QF41 234
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF41 235
SUMSQR=0.0 ; DO IX=1,3 ; DO I=1,NTAB#                                   QF41 236
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QF41 237
II=(I-1)*STEPT+MARKT#                                                   QF41 238
#     SUMSQR = SUMSQR + KI(I)*(XA(I,IX)-XC(I,IX))**2                    QF41 239
#TEMP(I)=XA(I,IX)-XC(I,IX) ; TEMP(I)=TEMP(I)**2#                        QF41 240
#TEMP(I)=KI(I)*TEMP(I) ; SUMSQR=SUMSQR+TEMP(I)#                         QF41 241
QX(II+16)=QX(II+IX)-QX(II+IX+6)#                                        QF41 242
QX(II+16)=QX(II+16)**2#                                                 QF41 243
QX(II+16)=QX(II+10)*QX(II+16)#                                          QF41 244
SUMSQR=SUMSQR+QX(II+16)#                                                QF41 245
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QF41 246
RMS=SQRT(SUMSQR/FLOAT(MATCH))#                                          QF41 247
BUFOT(1)=RMS ; BUFOT(2)=FLOAT(MATCH) ; BUFOT(3)=FLOAT(KONVRG)#          QF41 248
ncodefld:(BUFOT,1,QF41A,FM230,3) ; writeline:(0,QF41A,NQF41A,3,3)#      QF41 249
#                                                                       QF41 250
RETURN#                                                                 QF41 251
END#                                                                    QF41 252
systemheader:(QF42)## Matrix inversion                                  QF42   1
####################################################################    QF42   2
#                                                                  #    QF42   3
#                                QF42                              #    QF42   4
#                                                                  #    QF42   5
####################################################################    QF42   6
SUBROUTINE QF42(QA,QB,N1,M1)## SUBROUTINE MATINV(A,B,N1,M1)             QF42   7
#                                       J. konnert w. hendrickson       QF42   8
#                                                                       QF42   9
#   MATRIX INVERSION WITH ACCOMPANYING SOLUTION OF LINEAR EQUATIONS     QF42  10
#   ---------------------------------------------------------------     QF42  11
#                                                                       QF42  12
include:(AACOMN)#                                                       QF42  13
#                                                                       QF42  14
REAL AMAX#                                                              QF42  15
INTEGER I,ICOLUM,ID,IROW#                                               QF42  16
INTEGER INDEX(31,3)#                                                    QF42  17
INTEGER J,JCOLUM,JROW#                                                  QF42  18
INTEGER L,L1,M,M1,N,N1#                                                 QF42  19
REAL PIVOT#                                                             QF42  20
REAL QA(M1,M1),QB(M1,1)#                                                QF42  21
REAL QT#                                                                QF42  22
REAL SWAP#                                                              QF42  23
#                                                                       QF42  24
M=0 ; M=1 ; N=N1 ; DO J=1,N ; INDEX(J,3)=0# Initialization              QF42  25
DO I=1,N#                              Search for pivot element         QF42  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF42  27
AMAX=0.0 ; DO J=1,N#                                                    QF42  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF42  29
IF(INDEX(J,3)==1) NEXT#                                                 QF42  30
DO K=1,N#                                                               QF42  31
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF42  32
IF(INDEX(K,3)==1) NEXT#                                                 QF42  33
ELSE IF(INDEX(K,3)>1) iquit:(QF4201)#                                   QF42  34
ELSE IF((AMAX-ABS(QA(J,K)))>=0.0) NEXT#                                 QF42  35
IROW=J ; ICOLUM=K ; AMAX=ABS(QA(J,K))#                                  QF42  36
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF42  37
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF42  38
INDEX(ICOLUM,3)=INDEX(ICOLUM,3)+1 ; INDEX(I,1)=IROW ; INDEX(I,2)=ICOLUM#QF42  39
#                                                                       QF42  40
#     INTERCHANGE ROWS TO PUT PIVOT ELEMENT ON DIAGONAL                 QF42  41
#     -------------------------------------------------                 QF42  42
#                                                                       QF42  43
IF((IROW-ICOLUM)!=0)#                                                   QF42  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF42  45
DO L=1,N#                                                               QF42  46
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF42  47
SWAP=QA(IROW,L) ; QA(IROW,L)=QA(ICOLUM,L) ; QA(ICOLUM,L)=SWAP#          QF42  48
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF42  49
IF(M>0)#                                                                QF42  50
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF42  51
DO L=1,M#                                                               QF42  52
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF42  53
SWAP=QB(IROW,L) ; QB(IROW,L)=QB(ICOLUM,L) ; QB(ICOLUM,L)=SWAP#          QF42  54
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF42  55
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF42  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF42  57
#                                                                       QF42  58
#     DIVIDE PIVOT ROW BY PIVOT ELEMENT                                 QF42  59
#     ---------------------------------                                 QF42  60
#                                                                       QF42  61
PIVOT=QA(ICOLUM,ICOLUM) ; QA(ICOLUM,ICOLUM)=1.0#                        QF42  62
DO L=1,N ; QA(ICOLUM,L)=QA(ICOLUM,L)/PIVOT#                             QF42  63
IF(M>0) DO L=1,M ; QB(ICOLUM,L)=QB(ICOLUM,L)/PIVOT#                     QF42  64
#                                                                       QF42  65
#     REDUCE NON-PIVOT ROWS                                             QF42  66
#     ---------------------                                             QF42  67
#                                                                       QF42  68
DO L1=1,N#                                                              QF42  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF42  70
IF((L1-ICOLUM)==0) NEXT#                                                QF42  71
QT=QA(L1,ICOLUM) ; QA(L1,ICOLUM)=0.0#                                   QF42  72
DO L=1,N ; QA(L1,L)=QA(L1,L)-QA(ICOLUM,L)*QT#                           QF42  73
IF(M>0) DO L=1,M ; QB(L1,L)=QB(L1,L)-QB(ICOLUM,L)*QT#                   QF42  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF42  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF42  76
#                                                                       QF42  77
#     INTERCHANGE COLUMNS                                               QF42  78
#     -------------------                                               QF42  79
#                                                                       QF42  80
DO I=1,N#                                                               QF42  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF42  82
L=N+1-I ; IF((INDEX(L,1)-INDEX(L,2))==0) NEXT#                          QF42  83
JROW=INDEX(L,1) ; JCOLUM=INDEX(L,2) ; DO K=1,N#                         QF42  84
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF42  85
SWAP=QA(K,JROW) ; QA(K,JROW)=QA(K,JCOLUM) ; QA(K,JCOLUM)=SWAP#          QF42  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF42  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF42  88
DO K = 1,N ; IF(INDEX(K,3)!=1) iquit:(QF4201)#                          QF42  89
#                                                                       QF42  90
ID=1#                                                                   QF42  91
#                                                                       QF42  92
RETURN#                                                                 QF42  93
END#                                                                    QF42  94
systemheader:(QF43)## Set isotropic t.f.s                               QF43   1
####################################################################    QF43   2
#                                                                  #    QF43   3
#                                QF43                              #    QF43   4
#                                                                  #    QF43   5
####################################################################    QF43   6
SUBROUTINE QF43#                       Subroutine bref(beta)            QF43   7
#                                        W. hendrickson                 QF43   8
include:(AACOMN)#                                                       QF43   9
include:(QFCOMN)#                                                       QF43  10
#                                                                       QF43  11
REAL AVGR#                                                              QF43  12
REAL BBAR#                                                              QF43  13
REAL BSUM(8)#                                                           QF43  14
REAL DELB#                                                              QF43  15
REAL DSUM(8)#                                                           QF43  16
INTEGER I,ID,IDP,IHB,IO,IOP,IT,ITP,IWT#                                 QF43  17
INTEGER L1,NCLASS,NDIS2#                                                QF43  18
INTEGER NSUM(8)#                                                        QF43  19
REAL RMSD(8)#                                                           QF43  20
REAL RMSU#                                                              QF43  21
REAL SIGU(8)#                                                           QF43  22
REAL SIGD(8)#                                                           QF43  23
REAL SUMW#                                                              QF43  24
REAL WTT,WWTT(8)#                                                       QF43  25
realdata:(FM55,[341471.,610732.])#                                      QF43  26
chardata:(QF43A,[ SUM(WGT*DELTA**2) =               AVG(WGT*DELTA**2) $#QF43  27
=        FOR ISOTROPIC THERMAL FACTORS])#                               QF43  28
chardata:(QF43B,          ROOT          RMS            MEAN      $#     QF43  29
RMS   SIGMA)#                                                           QF43  30
chardata:(QF43C,[  TYPE   1/WGT NUMBER  DELTA   SIGMA  \DELB\    $#     QF43  31
DELU     U    THERMAL FACTOR TYPE])#                                    QF43  32
realdata:(FM70,[50413.,140732.,200613.,280832.,360832.,$#               QF43  33
440832.,520842.,600842.])#                                              QF43  34
chardata:(QF43E, MAIN-CHAIN BOND)#                                      QF43  35
chardata:(QF43F, MAIN-CHAIN ANGLE)#                                     QF43  36
chardata:(QF43G, SIDE-CHAIN BOND)#                                      QF43  37
chardata:(QF43H, SIDE-CHAIN ANGLE)#                                     QF43  38
chardata:(QF43I, X-H BOND)#                                             QF43  39
chardata:(QF43J, X-H ANGLE)#                                            QF43  40
chardata:(QF43K, METAL COORD. ETC.)#                                    QF43  41
chardata:(QF43L, HYDROGEN BOND)#                                        QF43  42
chardata:(QF43Q,[ >>>>>>>>>>>>>>>>>>>>>>>> THERMAL $#                   QF43  43
PARAMETER RESTRAINTS <<<<<<<<<<<<<<<<<<<<<<<<<])#                       QF43  44
datastuff:#                                                             QF43  45
#                                                                       QF43  46
SUMW=0.0 ; L1=6*NA+9*NDIS+1 ; L2=7*NA+9*NDIS+1# Initialize              QF43  47
LINRM=10 ; writeline:(4,QF43Q,NQF43Q,3,3)#                              QF43  48
NCLASS=8 ; SIGD(1)=SIGB1 ; SIGD(2)=SIGB2# Set distance weight scheme    QF43  49
SIGD(3)=SIGB3 ; SIGD(4)=SIGB4 ; SIGD(5)=SIGB5 ; SIGD(6)=SIGB6#          QF43  50
SIGD(7)=SIGB7 ; SIGD(8)=SIGB8#                                          QF43  51
DO I=1,NCLASS#                                                          QF43  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF43  53
SIGU(I)=SQRT(SIGD(I)/PISQ8) ; BSUM(I)=0.0 ; DSUM(I)=0.0#                QF43  54
NSUM(I)=0 ; WWTT(I)=0.0 ; IF(SIGD(I)<=0.0) NEXT#                        QF43  55
WWTT(I)=WBSKAL/SIGD(I)#                                                 QF43  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF43  57
NDIS2=NDIS-NVDW ; IDP=MARKD-STEPD#                                      QF43  58
IF(NDIS2>0)#                           Only if ndis2 sensible           QF43  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF43  60
DO ID=1,NDIS2#                         Cycle over distances             QF43  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF43  62
IDP=IDP+STEPD ; IWT=NINT(QX(IDP+3))#                                    QF43  63
IF(IWT==0) NEXT#                       Iwt=nwtb(id) in original pgm     QF43  64
WTT=WWTT(IWT)**2 ; IO=NINT(QX(IDP+1))# Io=no(id)                        QF43  65
IT=NINT(QX(IDP+2))#                    It=nt(id)                        QF43  66
IOP=(IO-1)*STEPA+MARKA ; ITP=(IT-1)*STEPA+MARKA# Point into atom stor   QF43  67
DELB=QX(IOP+5)-QX(ITP+5)#              Delb=beta(io)-beta(it)           QF43  68
SUMW=SUMW+WTT*DELB**2#                 Compile statistics               QF43  69
DSUM(IWT)=DSUM(IWT)+DELB**2 ; BSUM(IWT)=BSUM(IWT)+ABS(DELB)#            QF43  70
NSUM(IWT)=NSUM(IWT)+1#                                                  QF43  71
#     INCREMENT THE ON-DIAGONAL MATRIX ELEMENTS                         QF43  72
QX(L1+IO+MARKM)=QX(L1+IO+MARKM)+WTT#                                    QF43  73
QX(L1+IT+MARKM)=QX(L1+IT+MARKM)+WTT#                                    QF43  74
#    INCREMENT THE OFF-DIAGONAL MATRIX ELEMENTS                         QF43  75
QX(L2+ID+MARKM)=QX(L2+ID+MARKM)-WTT#                                    QF43  76
#     INCREMENT THE VECTOR ELEMENTS                                     QF43  77
QX(IATMN+IO+MARKV)=QX(IATMN+IO+MARKV)-DELB*WTT#                         QF43  78
QX(IATMN+IT+MARKV)=QX(IATMN+IT+MARKV)+DELB*WTT#                         QF43  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF43  80
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF43  81
#     CYCLE OVER H-BOND DISTANCES                                       QF43  82
L3=7*NA+9*NDIS+(NDIS-NVDW)+1#                                           QF43  83
IF(NHBD>0)#                            Only if there are some           QF43  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF43  85
DO IHB=1,NHBD#                                                          QF43  86
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF43  87
ID=NDIS+IHB ; IDP=(ID-1)*STEPD+MARKD ; IWT=NINT(QX(IDP+3))# Iwt=nwtb(   QF43  88
IF(IWT==0) NEXT ; WTT=WWTT(IWT)**2#                                     QF43  89
#     COMPILE STATISTICS                                                QF43  90
IO=NINT(QX(IDP+1)) ; IT=NINT(QX(IDP+2))# Io=no(id) ; it=nt(id)          QF43  91
IOP=(IO-1)*STEPA+MARKA ; ITP=(IT-1)*STEPA+MARKA# Point into atom stor   QF43  92
DELB=QX(IOP+5)-QX(ITP+5)#              Delb=beta(io)-beta(it)           QF43  93
SUMW=SUMW+WTT*DELB**2#                                                  QF43  94
DSUM(IWT)=DSUM(IWT)+DELB**2 ; BSUM(IWT)=BSUM(IWT)+ABS(DELB)#            QF43  95
NSUM(IWT)=NSUM(IWT)+1#                                                  QF43  96
#     INCREMENT THE ON-DIAGONAL MATRIX ELEMENTS                         QF43  97
QX(L1+IO+MARKM)=QX(L1+IO+MARKM)+WTT#                                    QF43  98
QX(L1+IT+MARKM)=QX(L1+IT+MARKM)+WTT#                                    QF43  99
#    INCREMENT THE OFF-DIAGONAL MATRIX ELEMENTS                         QF43 100
QX(L3+IHB+MARKM)=QX(L3+IHB+MARKM)-WTT#                                  QF43 101
#     INCREMENT THE VECTOR ELEMENTS                                     QF43 102
QX(IATMN+IO+MARKV)=QX(IATMN+IO+MARKV)-DELB*WTT#                         QF43 103
QX(IATMN+IT+MARKV)=QX(IATMN+IT+MARKV)+DELB*WTT#                         QF43 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF43 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF43 106
#                                                                       QF43 107
#     LISTING                                                           QF43 108
AVGR=SUMW/FLOAT(NDIS2+NHBD)#                                            QF43 109
BUFOT(1)=SUMW ; BUFOT(2)=AVGR ; ncodefld:(BUFOT,1,QF43A,FM55,2)#        QF43 110
writeline:(1,QF43A,NQF43A,3,3)#                                         QF43 111
LINRM=8 ; writeline:(1,QF43B,NQF43B,3,3) ; LINRM=6#                     QF43 112
DO I=1,NCLASS#                                                          QF43 113
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF43 114
RMSD(I)=0.0 ; BBAR=0.0 ; RMSU=0.0 ; IF(NSUM(I)!=0)#                     QF43 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF43 116
RMSD(I)=SQRT(DSUM(I)/FLOAT(NSUM(I)))#                                   QF43 117
RMSU=SQRT(BSUM(I)/(FLOAT(NSUM(I))*PISQ8))#                              QF43 118
BBAR=BSUM(I)/FLOAT(NSUM(I))#                                            QF43 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF43 120
BUFOT(1)=FLOAT(I);BUFOT(2)=1.0/AMAX1(0.01,WWTT(I))#                     QF43 121
BUFOT(3)=FLOAT(NSUM(I)) ; BUFOT(4)=RMSD(I);BUFOT(5)=SIGD(I)#            QF43 122
BUFOT(6)=BBAR;BUFOT(7)=RMSU ; BUFOT(8)=SIGU(I)#                         QF43 123
ncodefld:(BUFOT,1,CHROT,FM70,8)#                                        QF43 124
IF(I==1) movechar:(QF43E,1,CHROT,59,NQF43E,0)#                          QF43 125
ELSE IF(I==2) movechar:(QF43F,1,CHROT,59,NQF43F,0)#                     QF43 126
ELSE IF(I==3) movechar:(QF43G,1,CHROT,59,NQF43G,0)#                     QF43 127
ELSE IF(I==4) movechar:(QF43H,1,CHROT,59,NQF43H,0)#                     QF43 128
ELSE IF(I==5) movechar:(QF43I,1,CHROT,59,NQF43I,0)#                     QF43 129
ELSE IF(I==6) movechar:(QF43J,1,CHROT,59,NQF43J,0)#                     QF43 130
ELSE IF(I==7) movechar:(QF43K,1,CHROT,59,NQF43K,0)#                     QF43 131
ELSE IF(I==8) movechar:(QF43L,1,CHROT,59,NQF43L,0)#                     QF43 132
writeline:(0,QF43C,NQF43C,1,3)#                                         QF43 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF43 134
#                                                                       QF43 135
WBSUM=WBSUM+SUMW#                                                       QF43 136
RETURN#                                                                 QF43 137
END#                                                                    QF43 138
systemheader:(QF44)## Set thermal parameter restraints                  QF44   1
####################################################################    QF44   2
#                                                                  #    QF44   3
#                                QF44                              #    QF44   4
#                                                                  #    QF44   5
####################################################################    QF44   6
SUBROUTINE QF44#                       Subroutine teref(naxes)          QF44   7
#                                                                       QF44   8
include:(AACOMN)#                                                       QF44   9
include:(QFCOMN)#                                                       QF44  10
#                                                                       QF44  11
REAL ABSDUU#                                                            QF44  12
REAL AO(3,6),AT(3,6)#                                                   QF44  13
REAL AVGR#                                                              QF44  14
REAL CODIR#                                                             QF44  15
REAL COSSQ#                                                             QF44  16
REAL CO4TH#                                                             QF44  17
REAL DIR(6)#                                                            QF44  18
REAL DSUM(8)#                                                           QF44  19
REAL D0,D0SQ#                                                           QF44  20
REAL DUU#                                                               QF44  21
REAL DX,DY,DZ#                                                          QF44  22
REAL EO(3,3),ET(3,3)#                                                   QF44  23
INTEGER I,IA,IAP,IAPP,IDB,ID,IDP,IE#                                    QF44  24
INTEGER II,IID,IJ,IK,IO,IOUT,IT,IWT,IX#                                 QF44  25
INTEGER J,JX#                                                           QF44  26
INTEGER K,KO,KT#                                                        QF44  27
INTEGER LID,L1#                                                         QF44  28
INTEGER MV,NBIS,NCLASS,NO,NT#                                           QF44  29
INTEGER NSUM(8)#                                                        QF44  30
REAL RMSD(8)#                                                           QF44  31
REAL RMSV#                                                              QF44  32
REAL SIGD(8)#                                                           QF44  33
REAL SINSQ#                                                             QF44  34
REAL SUMW#                                                              QF44  35
REAL UUO,UUT#                                                           QF44  36
REAL VARI#                                                              QF44  37
REAL VD(3),V(3,6)#                                                      QF44  38
REAL VSUM#                                                              QF44  39
REAL WTT#                                                               QF44  40
REAL WV#                                                                QF44  41
REAL WWTT(8)#                                                           QF44  42
chardata:(QF44A,       DISTANCE FLUCTUATION VARIANCES EXCEED SIGMA)#    QF44  43
chardata:(QF44B,[    ATOM(I) ATOM(J)    D  RMS V    ATOM(I) $#          QF44  44
ATOM(J)    D  RMS V    ATOM(I) ATOM(J)    D  RMS V    ATOM(I) $#        QF44  45
ATOM(J)    D  RMS V])#                                                  QF44  46
realdata:(FM103,[250522.,310632.,560522.,620632.,870522.,930632.,$#     QF44  47
1180522.,1240632.])#                                                    QF44  48
chardata:(QF44C,[ SUM(WGT*DELTA**2) =               $#                  QF44  49
AVG(WGT*DELTA**2) =        FOR ANISOTROPIC T.F.])#                      QF44  50
realdata:(FM55,[341471.,600732.])#                                      QF44  51
chardata:(QF44D,       ROOT          RMS    SIGMA)#                     QF44  52
chardata:(QF44E,  TYPE  WGT NUMBER  DEL D     U    T.F. TYPE)#          QF44  53
realdata:(FM409,[50413.,110602.,170613.,250832.,330832.])#              QF44  54
chardata:(QF44G, MAIN-CHAIN BOND)#                                      QF44  55
chardata:(QF44H, MAIN-CHAIN ANGLE)#                                     QF44  56
chardata:(QF44I, SIDE-CHAIN BOND)#                                      QF44  57
chardata:(QF44J, SIDE-CHAIN ANGLE)#                                     QF44  58
chardata:(QF44K, X-H BOND)#                                             QF44  59
chardata:(QF44L, X-H ANGLE)#                                            QF44  60
chardata:(QF44M, METAL COORD. ETC.)#                                    QF44  61
chardata:(QF44N, HYROGEN BOND)#                                         QF44  62
realdata:(FM120,[80713.,210613.])#                                      QF44  63
chardata:(QF44P,         OF THE       DISTANCES ARE ALSO $#             QF44  64
THERMAL RESTRAINTS)#                                                    QF44  65
chardata:(QF44Q,[ >>>>>>>>>>>>>>>>>>>>>>>> THERMAL $#                   QF44  66
PARAMETER RESTRAINTS <<<<<<<<<<<<<<<<<<<<<<<<<])#                       QF44  67
datastuff:#                                                             QF44  68
# THE OLD ARRAYS XA, IDOUT, ROOT, AND DOUT ARE NOW IN THE MARKE ARRAY   QF44  69
# OLD XA(N,1)     NEW QX((N-1)*STEPE+MARKE+16), YES, SIXTEEN            QF44  70
# OLD XA(N,2)     NEW QX((N-1)*STEPE+MARKE+17)                          QF44  71
# OLD XA(N,3)     NEW QX((N-1)*STEPE+MARKE+18)                          QF44  72
# OLD IDOUT(N)    NEW QX((N-1)*STEPE+MARKE+1)                           QF44  73
# OLD ROOT(N)     NEW QX((N-1)*STEPE+MARKE+2)                           QF44  74
# OLD DOUT(N)     NEW QX((N-1)*STEPE+MARKE+3)                           QF44  75
#                                                                       QF44  76
#                                                                       QF44  77
SUMW=0.0 ; IDB=0 ; L1=6*NA+9*NDIS+1 ; L2=12*NA+9*NDIS+1# Initialize     QF44  78
LINRM=10 ; writeline:(4,QF44Q,NQF44Q,3,3)# Write heading                QF44  79
NCLASS=8#                              Set the distance weighting sch   QF44  80
SIGD(1)=SIGB1 ; SIGD(2)=SIGB2 ; SIGD(3)=SIGB3 ; SIGD(4)=SIGB4#          QF44  81
SIGD(5)=SIGB5 ; SIGD(6)=SIGB6 ; SIGD(7)=SIGB7 ; SIGD(8)=SIGB8#          QF44  82
DO I=1,NCLASS#                                                          QF44  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF44  84
DSUM(I)=0.0 ; NSUM(I)=0 ; WWTT(I)=0.0 ; IF(SIGD(I)<=0.0) NEXT#          QF44  85
WWTT(I)=WBSKAL/(SIGD(I)/SQRT(3.0))**2#                                  QF44  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF44  87
IOUT=0## Prepare the orthogonalization matrix                           QF44  88
IAP=MARKA-STEPA ; IAPP=MARKE-STEPE#                                     QF44  89
DO IA=1,NA## Convert positions to the cartesian system                  QF44  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF44  91
IAP=IAP+STEPA ; IAPP=IAPP+MARKE#                                        QF44  92
#XA(IA,1)=ORXX*XYZ1(IA)+ORXY*XYZ2(IA)+ORXZ*XYZ3(IA)#                    QF44  93
#XA(IA,2)=              ORYY*XYZ2(IA)+ORYZ*XYZ3(IA)#                    QF44  94
#XA(IA,3)=                            ORZZ*XYZ3(IA)#                    QF44  95
QX(IAPP+16)=ORXX*QX(IAP+1)+ORXY*QX(IAP+2)+ORXZ*QX(IAP+3)#               QF44  96
QX(IAPP+17)=               ORYY*QX(IAP+2)+ORYZ*QX(IAP+3)#               QF44  97
QX(IAPP+18)=                              ORZZ*QX(IAP+3)#               QF44  98
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF44  99
CALL QF45## Call ellips(na,naxes) establish ellips orientat             QF44 100
NBIS=NDIS-NVDW ; IDP=MARKD-STEPD ; DO ID=1,NBIS# Cycle over distances   QF44 101
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF44 102
IDP=IDP+STEPD ; IWT=NINT(QX(IDP+3))#   Iwt=nwtb(id)                     QF44 103
IF(IWT==0) NEXT ; IDB=IDB+1 ; WTT=WWTT(IWT)#                            QF44 104
IID=(ID-1)*STEPD+MARKD ; IO=(NINT(QX(IID+1))-1)*STEPE+MARKE#            QF44 105
IT=(NINT(QX(IID+2))-1)*STEPE+MARKE#                                     QF44 106
#     SPECIFY THE BOND DIRECTION AND DISTANCE                           QF44 107
#DX=XA(IO,1)-XA(IT,1) ; DY=XA(IO,2)-XA(IT,2) ; DZ=XA(IO,3)-XA(IT,3)#    QF44 108
DX=QX(IO+16)-QX(IT+16);DY=QX(IO+17)-QX(IT+17);DZ=QX(IO+18)-QX(IT+18)#   QF44 109
D0SQ=DX**2+DY**2+DZ**2 ; D0=SQRT(D0SQ)#                                 QF44 110
VD(1)=DX/D0 ; VD(2)=DY/D0 ; VD(3)=DZ/D0#                                QF44 111
#     GET THE ELLIPSOID DIRECTIONS FOR THIS ATOM PAIR                   QF44 112
DO IE=1,3 ; DO JX=1,3#                                                  QF44 113
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF44 114
# THIS IS A VERY SERIOUS PROBLEM WHICH MUST BE RESOLVED!!!!!!!!         QF44 115
#EO(JX,IE)=E(IO,JX,IE) ; ET(JX,IE)=E(IT,JX,IE)#                         QF44 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF44 117
#     SPECIFY THE RESTRAINT DIRECTIONS                                  QF44 118
DO IX=1,3 ; DO IE=1,3#                                                  QF44 119
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF44 120
V(IX,IE  )=EO(IX,IE) ; V(IX,IE+3)=ET(IX,IE)#                            QF44 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF44 122
MV=6 ; VSUM=0.0 ; NSUM(IWT)=NSUM(IWT)+1#                                QF44 123
DO K=1,MV#                             Cycle over the restraint direc   QF44 124
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF44 125
DO I=1,3#                              Evaluate beta cofactors          QF44 126
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF44 127
AO(I,K)=0.0 ; AT(I,K)=0.0#                                              QF44 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF44 129
DO J=1,3 ; DO I=1,3#                                                    QF44 130
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF44 131
AO(I,K)=AO(I,K)+EO(J,I)*V(J,K) ; AT(I,K)=AT(I,K)+ET(J,I)*V(J,K)#        QF44 132
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF44 133
DO I=1,3#                                                               QF44 134
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF44 135
AO(I,K)=AO(I,K)**2/PISQ8 ; AT(I,K)=AT(I,K)**2/PISQ8#                    QF44 136
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF44 137
#     EVALUATE MEAN-SQUARE DISPLACEMENTS                                QF44 138
#UUO=BETA(IO,1)*AO(1,K)+BETA(IO,2)*AO(2,K)+BETA(IO,3)*AO(3,K)#          QF44 139
#UUT=BETA(IT,1)*AT(1,K)+BETA(IT,2)*AT(2,K)+BETA(IT,3)*AT(3,K)#          QF44 140
UUO=0.; UUT=0.## <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<********        QF44 141
DUU=UUO-UUT ; ABSDUU=ABS(DUU) ; SGNDUU=SIGN(1.0,DUU)#                   QF44 142
#     EVALUATE GEOMETRIC COFACTORS, THE VARIANCE AND ITS DERIVATIVES    QF44 143
COSSQ=(VD(1)*V(1,K)+VD(2)*V(2,K)+VD(3)*V(3,K))**2#                      QF44 144
SINSQ=1.0-COSSQ ; CO4TH=(0.5*SINSQ**2-3.0*COSSQ*SINSQ)/D0SQ#            QF44 145
VARI=COSSQ*ABSDUU+CO4TH*ABSDUU**2 ; WV=WTT*VARI#                        QF44 146
CODIR=WTT*SGNDUU*(COSSQ+2.0*ABSDUU*CO4TH)#                              QF44 147
DO I=1,3#                                                               QF44 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF44 149
DIR(I  )= AO(I,K)*CODIR ; DIR(I+3)=-AT(I,K)*CODIR#                      QF44 150
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF44 151
#     COMPILE STATISTICS                                                QF44 152
SUMW=SUMW+WV**2 ; DSUM(IWT)=DSUM(IWT)+VARI ; VSUM=VSUM+VARI#            QF44 153
#     INCREMENT MATRIX ELEMENTS WITHIN ATOM BLOCKS                      QF44 154
KO=6*(IO-1)+L1+MARKM ; KT=6*(IT-1)+L1+MARKM#                            QF44 155
DO I=1,3 ; DO J=I,3#                                                    QF44 156
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF44 157
IJ=I+J-1/I ; QX(KO+IJ)=QX(KO+IJ)+DIR(I)*DIR(J)#                         QF44 158
QX(KT+IJ)=QX(KT+IJ)+DIR(I+3)*DIR(J+3)#                                  QF44 159
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF44 160
LID=9*(ID-1)+L2+MARKM## Increment matrix elements within distance blo   QF44 161
DO I=1,3 ; DO J=1,3#                                                    QF44 162
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF44 163
IJ=3*(I-1)+J ; QX(LID+IJ)=QX(LID+IJ)+DIR(I)*DIR(J+3)#                   QF44 164
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF44 165
KO=3*(IO-1)+IATMN+MARKV ; KT=3*(IT-1)+IATMN+MARKV# Increment vector e   QF44 166
DO I=1,3#                                                               QF44 167
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF44 168
QX(KO+I)=QX(KO+I)-WV*DIR(I) ; QX(KT+I)=QX(KT+I)-WV*DIR(I+3)#            QF44 169
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF44 170
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF44 171
#                                                                       QF44 172
RMSV=SQRT(VSUM/2) ; IF(RMSV<SIGD(IWT)) NEXT# Accumulate data on devia   QF44 173
II=IOUT*STEPE+MARKE#                                                    QF44 174
IOUT=IOUT+1 ; QX(II+1)=FLOAT(ID)#      Idout(iout)=id                   QF44 175
QX(II+2)=RMSV#                         Root(iout)=rmsv                  QF44 176
QX(II+3)=D0#                           Dout(iout)=d0                    QF44 177
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF44 178
#                                                                       QF44 179
#    LISTING                                                            QF44 180
#                                                                       QF44 181
ncodefld:(FLOAT(IOUT),1,QF44A,60513.,1)#                                QF44 182
writeline:(1,QF44A,NQF44A,3,4) ; LINRM=5#                               QF44 183
IF(IOUT!=0)#                                                            QF44 184
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF44 185
K=0 ; DO I=1,IOUT#                                                      QF44 186
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF44 187
IF(K>6)#                                                                QF44 188
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF44 189
ncodefld:(BUFOT,1,CHROT,FM103,K)#                                       QF44 190
writeline:(0,QF44B,NQF44B,1,4) ; K=0#                                   QF44 191
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF44 192
IJ=(I-1)*STEPE+MARKE#                                                   QF44 193
BUFOT(K+1)=QX(IJ+1)#                   Dout(i)                          QF44 194
BUFOT(K+2)=QX(IJ+2) ; K=K+2#           Root(i)                          QF44 195
IK=(NINT(QX(IJ+1))-1)*STEPD+MARKD ; NO=NINT(QX(IK+1))#                  QF44 196
II=(NO-1)*STEPA+MARKA#                                                  QF44 197
movertoc:(QX(II+8),2,CHROT,I*36+5,8,0)#                                 QF44 198
NT=NINT(QX(IK+2)) ; II=(NT-1)*STEPA+MARKA#                              QF44 199
movertoc:(QX(II+8),2,CHROT,I*36+13,8,0)#                                QF44 200
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF44 201
ncodefld:(BUFOT,1,CHROT,FM103,K)#                                       QF44 202
writeline:(0,QF44B,NQF44B,1,4) ; K=0#                                   QF44 203
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF44 204
AVGR=SUMW/FLOAT(IDB)#                                                   QF44 205
BUFOT(1)=SUMW ; BUFOT(2)=AVGR ; ncodefld:(BUFOT,1,QF44C,FM55,2)#        QF44 206
writeline:(1,QF44C,NQF44C,3,3)#                                         QF44 207
LINRM=8 ; writeline:(1,QF44D,NQF44D,3,3) ; LINRM=6#                     QF44 208
DO I=1,NCLASS#                                                          QF44 209
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QF44 210
RMSD(I)=0.0 ; IF(NSUM(I)!=0) ; RMSD(I)=SQRT(DSUM(I)/(2*NSUM(I)))#       QF44 211
BUFOT(1)=FLOAT(I) ; BUFOT(2)=WWTT(I) ; BUFOT(3)=FLOAT(NSUM(I))#         QF44 212
BUFOT(4)=RMSD(I) ; BUFOT(5)=SIGD(I)#                                    QF44 213
ncodefld:(BUFOT,1,CHROT,FM409,5)#                                       QF44 214
IF(I==1) movechar:(QF44G,1,CHROT,35,NQF44G,0)#                          QF44 215
ELSE IF(I==2) movechar:(QF44H,1,CHROT,35,NQF44H,0)#                     QF44 216
ELSE IF(I==3) movechar:(QF44I,1,CHROT,35,NQF44I,0)#                     QF44 217
ELSE IF(I==4) movechar:(QF44J,1,CHROT,35,NQF44J,0)#                     QF44 218
ELSE IF(I==5) movechar:(QF44K,1,CHROT,35,NQF44K,0)#                     QF44 219
ELSE IF(I==6) movechar:(QF44L,1,CHROT,35,NQF44L,0)#                     QF44 220
ELSE IF(I==7) movechar:(QF44M,1,CHROT,35,NQF44M,0)#                     QF44 221
ELSE IF(I==8) movechar:(QF44N,1,CHROT,35,NQF44N,0)#                     QF44 222
writeline:(0,QF44E,NQF44E,1,3)#                                         QF44 223
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QF44 224
BUFOT(1)=FLOAT(IDB) ; BUFOT(2)=FLOAT(NBIS)#                             QF44 225
ncodefld:(BUFOT,1,QF44P,FM120,2) ; writeline:(1,QF44P,NQF44P,3,3)#      QF44 226
#                                                                       QF44 227
WBSUM=WBSUM+SUMW#                                                       QF44 228
RETURN#                                                                 QF44 229
END#                                                                    QF44 230
systemheader:(QF45)## Store anisotropic t.f.s                           QF45   1
####################################################################    QF45   2
#                                                                  #    QF45   3
#                                QF45                              #    QF45   4
#                                                                  #    QF45   5
####################################################################    QF45   6
SUBROUTINE QF45#                                                        QF45   7
#                                                                       QF45   8
include:(AACOMN)#                                                       QF45   9
include:(QFCOMN)#                                                       QF45  10
#     SUBROUTINE ELLIPS(NA,NAXES)                                       QF45  11
#                                                                       QF45  12
#    THIS SUBROUTINE PLACES THE ORIGINAL THREE AND TWO DIMENSIONAL      QF45  13
#    ARRAYS FOR THE STORAGE OF ANISOTROPIC TEMPERATURE FACTOR           QF45  14
#    PARAMETERS IN THE QX ARRAY ACCORDING TO THE FOLLOWING SCHEME.      QF45  15
#    E1(1,1)=P(1) IN IA+1;E1(1,2)=P(2) IN IA+2;E1(1,3)=P(3) IN IA+3     QF45  16
#    E2(1,1)=S(1) IN IA+4;E2(1,2)=S(2) IN IA+5;E2(1,3)=S(3) IN IA+6     QF45  17
#    E3(1,1)=T(1) IN IA+7;E3(1,2)=T(2) IN IA+8;E3(1,3)=T(3) IN IA+9     QF45  18
#    THE POINTERS IPO, IPT, ISO, IST IN IA+10 THROUGH 13                QF45  19
#    THE DP AND DS VALUES IN IA+14 AND IA+15; THE XA(1),XA(2), AND      QF45  20
#    XA(3) IN IA+16, IA+17, AND IA+18.                                  QF45  21
#    BETA(1), BETA(2), BETA(3) IN IA+19, IA+20, IA+21.                  QF45  22
#    ALL IN THE MARKE REGION OF THE QX ARRAY.                           QF45  23
INTEGER IPO,IPT,ISO,IST## Pointers to direction specifying atoms        QF45  24
INTEGER IA,J,K## pointers in loops                                      QF45  25
REAL PV(3),SV(3),TV(3)## Temporary vector storage                       QF45  26
#                                                                       QF45  27
#    CLEAR THE WHOLE ARRAY EXCEPT XA AT END.                            QF45  28
DO IA=MARKE,STOPE,STEPE ; DO J=1,15 ; QX(IA+J)=0.0#                     QF45  29
#                                                                       QF45  30
#    READ IN THE DIRECTION SPECIFYING ATOMS FROM PROTIN FILE            QF45  31
#    -------------------------------------------------------            QF45  32
IF(NAXES>0)#                           But only if there are some       QF45  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF45  34
DO K=1,NAXES#                                                           QF45  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF45  36
readwpkt:(TINFIL,LRANI,PSIZ6,GETPK,0)# Aisotropic t.f. constraints      QF45  37
IF(GETPK<=0) iquit:(QF4501)#           Rec's must sync!                 QF45  38
IA=NINT(QX(GETPK+1)) ; J=(IA-1)*STEPE+MARKE ; QX(J+10)=QX(GETPK+2)#     QF45  39
QX(J+11)=QX(GETPK+3) ; QX(J+12)=QX(GETPK+4) ; QX(J+13)=QX(GETPK+5)#     QF45  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF45  41
#                                                                       QF45  42
J=MARKE-STEPE ; DO IA=1,NA#            Loop over all atoms              QF45  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF45  44
J=J+STEPE#                             Advance to next atom in turn     QF45  45
QX(J+1)=1.0 ; QX(J+5)=1.0#             Set p(1) & s(2) to default       QF45  46
IF(QX(J+10)>0.0)#                      Test if atom from protin         QF45  47
IPO=NINT(QX(J+10)) ; IPT=NINT(QX(J+11))# Retreive pointers              QF45  48
ISO=NINT(QX(J+12)) ; IST=NINT(QX(J+13))#                                QF45  49
DO K=1,3#                                                               QF45  50
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF45  51
PV(K)=QX(J+IPT+K-1)-QX(J+IPO+K-1);SV(K)=QX(J+IST+K-1)-QX(J+ISO+K-1)#    QF45  52
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF45  53
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF45  54
#    SET THE FIRST ELLIPSOID AXIS PARALLEL TO P                         QF45  55
DO K=1,3 ; QX(J+14)=QX(J+14)+PV(K)**2 ; QX(J+14)=SQRT(QX(J+14))#        QF45  56
DO K=1,3#                                                               QF45  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF45  58
PV(K)=PV(K)/QX(J+14) ; QX(J+K)=PV(K)#  Form and save p vector           QF45  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF45  60
#    SET THE THIRD ELLIPSOID AXIS PARALLEL TO P CROSS S                 QF45  61
TV(1)=PV(2)*SV(3)-PV(3)*SV(2) ; TV(2)=PV(3)*SV(1)-PV(1)*SV(3)#          QF45  62
TV(3)=PV(1)*SV(2)-PV(2)*SV(1)#                                          QF45  63
DO K=1,3 ; QX(J+15)=QX(J+15)+TV(K)**2 ; QX(J+15)=SQRT(QX(J+15))#        QF45  64
DO K=1,3#                                                               QF45  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF45  66
TV(K)=TV(K)/QX(J+15) ; QX(J+K+6)=TV(K)# Form and save t vector          QF45  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF45  68
#    SET THE SECOND ELLIPSOID AXES PARALLEL TO T CROSS P                QF45  69
#    I.E. NORMAL TO P IN THE DIRECTION OF S                             QF45  70
QX(J+4)=TV(2)*PV(3)-TV(3)*PV(2) ; QX(J+5)=TV(3)*PV(1)-TV(1)*PV(3)#      QF45  71
QX(J+6)=TV(1)*PV(2)-TV(2)*PV(1)## Form and save s(1), s(2) & s(3)       QF45  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF45  73
RETURN#                                                                 QF45  74
END#                                                                    QF45  75
systemheader:(QF51)## Set model idealization, no structure factors      QF51   1
####################################################################    QF51   2
#                                                                  #    QF51   3
#                                QF51                              #    QF51   4
#                                                                  #    QF51   5
####################################################################    QF51   6
SUBROUTINE QF51#                                                        QF51   7
#                                                                       QF51   8
include:(AACOMN)#                                                       QF51   9
include:(QFCOMN)#                                                       QF51  10
INTEGER L#                             Pointer into vector              QF51  11
#                                                                       QF51  12
#    PREPARE FOR MODEL IDEALIZATION WITHOUT STRUCTURE FACTOR            QF51  13
#    REFINEMENT                                                         QF51  14
#    -------------------------------------------------------            QF51  15
#                                                                       QF51  16
chardata:(QF51A, MODEL IDEALIZATION WITHOUT STRUCTURE FACTOR $#         QF51  17
REFINEMENT)#                                                            QF51  18
datastuff:#                                                             QF51  19
writeline:(1,QF51A,NQF51A,3,3)#        Say whats up                     QF51  20
QX(MARKM+1)=1.0#                       Set scale factor                 QF51  21
L=6*NA+9*NDIS+1+MARKM ; QX(L+1)=1.0 ; QX(L+2)=0.0#                      QF51  22
# RECOGNIZE THAT WITH NO STRUCTURE FACTOR CALCULATION THE SCALE AND     QF51  23
# OVERALL TEMPERATURE FACTOR CANNOT BE SHIFTED.                         QF51  24
QX(MARKV+1)=0.0 ; QX(MARKV+IBET1)=0.0 ; DT=0.0 ; DK=0.0#                QF51  25
RETURN#                                                                 QF51  26
END#                                                                    QF51  27
systemheader:(QF61)## Drive structure factor calculation                QF61   1
####################################################################    QF61   2
#                                                                  #    QF61   3
#                                QF61                              #    QF61   4
#                                                                  #    QF61   5
####################################################################    QF61   6
SUBROUTINE QF61## SUBROUTINE SFREF(NO)                                  QF61   7
#                                      J.  konnert  w. hendrickson      QF61   8
#                                                                       QF61   9
include:(AACOMN)#                                                       QF61  10
include:(QFCOMN)#                                                       QF61  11
#                                                                       QF61  12
REAL A11,A12,A22##                                                      QF61  13
REAL AVG,AVGDEL##                                                       QF61  14
REAL B1,B2##                                                            QF61  15
REAL CODE##                                                             QF61  16
REAL D## D spacing for current reflection                               QF61  17
REAL DY## Delta F of current reflection                                 QF61  18
INTEGER EXCLUD## Flag for signalling exclusion of a subset              QF61  19
REAL FORMQ## Temp storage for interpolated scattering factor            QF61  20
INTEGER I,IA,IA3,IA6,ID,IDP,IEXT## Loop indices & pointers              QF61  21
INTEGER IHBD,IHBDP,IJ,INDEX,IXO,IXT#   Loop indices & pointers          QF61  22
INTEGER IHKL(4)##                                                       QF61  23
INTEGER IREL(67),IWNT(66),KEY(4),LPAK,IP,JP## I/o quantities            QF61  24
INTEGER IRF## Offset pointer to f relative                              QF61  25
INTEGER IRH## Offset pointer to h,k,l packed word                       QF61  26
INTEGER IRJ## Offset pointer to reflection code                         QF61  27
INTEGER IRL## Offset pointer to sin theta over lambda                   QF61  28
INTEGER IRS## Offset pointer to scale factor pointer                    QF61  29
INTEGER IRSF## Offset pointer to sigma f relative                       QF61  30
INTEGER IRX## Offset pointer to extinction factor                       QF61  31
INTEGER J,JJ,JJJ,K,KIA## Loop indices & pointers                        QF61  32
INTEGER L,LIA## Loop indices & pointers                                 QF61  33
INTEGER N,NE,NDEL,NDIS2,NMDS## Loop indices & pointers                  QF61  34
INTEGER NDOUG## Count of reflections printed out                        QF61  35
INTEGER NODISA,NPAK,NUSED,NZ## Loop indices and pointers                QF61  36
INTEGER NZCT(7)#                                                        QF61  37
INTEGER POUT,JPSCR## Scratch file pkt size and pointer                  QF61  38
REAL PHIC## Reflection phase in cycles                                  QF61  39
REAL RS,RSNUM## R value and sum                                         QF61  40
REAL RSHL,RSPH##                                                        QF61  41
REAL RZDEN,RZNUM## R value sums                                         QF61  42
REAL SAVG##                                                             QF61  43
REAL SCDEN,SCNUM## Rescale factor & sums                                QF61  44
REAL SIG,SIGAPP,SIGDEL##                                                QF61  45
REAL SIGYOA## Sigma f observed                                          QF61  46
REAL SQRTW##                                                            QF61  47
INTEGER STACKO## Pointer to lrrefl output stack item                    QF61  48
REAL STHOL## Sin(theta)/lambda                                          QF61  49
REAL WDY## Weighted delta f                                             QF61  50
REAL WRZDEN,WRZNUM## Sums for weighted R factor                         QF61  51
REAL XE## Phase of reflection in degrees                                QF61  52
REAL ZDN,ZNM##                                                          QF61  53
REAL ZNUM(7),ZDEN(7),ZSIG(7),ZAPP(7)#                                   QF61  54
chardata:(WTLAB,[DELTA MODEL     MAX(DATA,DELTA) $#                     QF61  55
GIVEN SIG(DATA) SCALED SIG(DATA)SQRT(DAT2+DEL2) ])#                     QF61  56
chardata:(QF61A,[    H   K   L  FATE  STOL       F(REL)  $#             QF61  57
F(CALC)     PHI      A        B   REL-CALC   SIGAPP])#                  QF61  58
realdata:(FM79,[50413.,90413.,130413.,250642.,380922.,$#                QF61  59
470922.,550912.,640922.,730922.,820922.,900732.])#                      QF61  60
chardata:(QF61B, AGREEMENT FACTORS BASED ON PARAMETERS BEFORE $#        QF61  61
THIS CYCLE)#                                                            QF61  62
chardata:(QF61C,[ SUM(WGT*DELTA**2) =               $#                  QF61  63
AVG(WGT*DELTA**2) =        ])#                                          QF61  64
chardata:(QF61D,                    $#                                  QF61  65
NUMERATOR   DENOMINATOR     R)#                                         QF61  66
chardata:(QF61E, STANDARD R-FACTOR)#                                    QF61  67
realdata:(FM40,[341471.,620732.])#                                      QF61  68
realdata:(FM42,[290912.,430912.,490532.])#                              QF61  69
chardata:(QF61F,[  R = SUM(\FO-FC\)/SUM(FO)])#                          QF61  70
chardata:(QF61G, ERROR R-FACTOR)#                                       QF61  71
chardata:(QF61H,[  R = SUM(SIG(FO))/SUM(FO)])#                          QF61  72
chardata:(QF61I, WEIGHTED R-FACTOR)#                                    QF61  73
chardata:(QF61J,[  R = SQRT(SUM(W*(FO-FC)**2))/SQRT(SUM(W*FO**2))])#    QF61  74
chardata:(QF61K,      REFLECTIONS    INCLUDED FOR  EXCLUDED FOR)#       QF61  75
chardata:(QF612,     USED  REJECTED  R SURVEY      R SURVEY)#           QF61  76
realdata:(FMTFR,[90713.,190713.,290713.,430713.])#                      QF61  77
chardata:(QF61L,[          IS THE AVERAGE \FO-FC\ DISCREPANCY])#        QF61  78
chardata:(QF61P, ---------- RESOLUTION BREAKDOWN ----------)#           QF61  79
chardata:(QF61Q,[  DMIN    REFS     <SIGF>/DATA    <SIGF>/USED   $#     QF61  80
<FO-FC>    R SHELL   R SPHERE])#                                        QF61  81
realdata:(FM840,[60522.,140813.,301022.,451022.,551032.,$#              QF61  82
651032.,771032.])#                                                      QF61  83
chardata:(QF61R,  ALL)#                                                 QF61  84
realdata:(FM852,[140813.,770932.])#                                     QF61  85
realdata:(FM855,[250612.,370712.])#                                     QF61  86
chardata:(QF61S,[ MODELED DELTA  = (      ) + (       )*(S-1/6)])#      QF61  87
chardata:(QF61T,[ FITTED <FO-FC> = (      ) + (       )*(S-1/6)])#      QF61  88
chardata:(QF61U, SIGF USED ARE FROM THE                  )#             QF61  89
chardata:(QF61V, REFINEMENT BASED ON STRUCTURE FACTOR CALCULATION)#     QF61  90
chardata:(QF61W,[ EXTINCTION NOT APPLIED (FACTOR NOT ON BDF)])#         QF61  91
chardata:(QF61X,REJ)#                                                   QF61  92
chardata:(QF61Y,USE)#                                                   QF61  93
chardata:(QF611,XCL)#                                                   QF61  94
realdata:(PI2,[6.2831853])#            Two pi                           QF61  95
chardata:(QF613,[ >>>>>>>>>>>>>>>>>>>>>>>> REFLECTIONS, R VALUES $#     QF61  96
AND CONJUGATE GRADIENT SOLUTION SUMMARY <<<<<<<<<<<<<<<<<<<<<<<<<])#    QF61  97
datastuff:#                                                             QF61  98
LINCT=0 ; writeline:(4,QF613,NQF613,3,3)# Write section heading         QF61  99
IF(REPORT==yes:) writeline:(1,QF61V,NQF61V,3,3)# Tell activity to com   QF61 100
NUSED=0 ; NDOUG=0 ; NODISA=1 ; RSNUM=0.0 ; RZNUM=0.0 ; RZDEN=0.0#       QF61 101
WRZNUM=0.0 ; WRZDEN=0.0 ; SCNUM=0.0 ; SCDEN=0.0 ; NREJCT=0#             QF61 102
BDIAG=0.0 ; BVEC=0.0 ; KBOFFD = 0.0 ; KDIAG=0.0 ; KVEC=0.0#             QF61 103
DO I=1,7#                                                               QF61 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF61 105
ZNUM(I)=0.0 ; ZDEN(I)=0.0 ; ZSIG(I)=0.0 ; ZAPP(I)=0.0 ; NZCT(I)=0.0#    QF61 106
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF61 107
LINRM=10 ; KILLDV=no: ; IF(REPORT==no:) KILLDV=yes:#                    QF61 108
NMDS=NINT(1000.0*DSNM)#                Scale and fix dataset number     QF61 109
POUT=NTYP+9#                           Set scratch file packet size     QF61 110
#                                                                       QF61 111
#   SEARCH LR LRREFL: POINTERS & CONSTRUCT O/P                          QF61 112
#   -------------------------------------------                         QF61 113
#                                                                       QF61 114
DO I=1,NTYP;  IWNT(I)=500+I#           Set scat.fac. idnums             QF61 115
IWNT(NTYP+1)=NMDS+304#                 Set frel idnum                   QF61 116
IWNT(NTYP+2)=NMDS+308#                 Set jcode idnum                  QF61 117
IWNT(NTYP+3)=NMDS+309#                 Set nscl idnum                   QF61 118
IWNT(NTYP+4)=NMDS+202#                 Set extf idnum                   QF61 119
IWNT(NTYP+5)=1 ; IWNT(NTYP+6)=2#       Set hkl and stol idnums          QF61 120
IWNT(NTYP+7)=NMDS+305#                 Set sigma frel                   QF61 121
DO I=1,ITEM#                           Loop over archive list           QF61 122
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF61 123
J=NTYP+7+I#                            Get want pointer                 QF61 124
IWNT(J)=NINT(ARCH(I))#                 Add archive list to want list    QF61 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF61 126
KEY(1)=0;     KEY(2)=NTYP+7#           Set search delimiters            QF61 127
KEY(4)=1;     KEY(3)=NTYP+7+ITEM#      Set search delimiters            QF61 128
indexpkt:(INBDF,lrrefl:,LPAK,IP,SCRBDF,KEY,IWNT,IREL)# Get pointers     QF61 129
NPAK=KEY(4)#                           Set output paksize               QF61 130
#                                                                       QF61 131
IF(NSCF==0)#                           Test if scatfac table exist      QF61 132
DO I=1,NTYP#                           Loop over atom types             QF61 133
IF(IREL(I)==0) iquit:(QF6101)#         No ff......6101                  QF61 134
#                                                                       QF61 135
# REVISE WANT LIST ARRAY TO CONTROL ARCHIVING SET UP IN QF10            QF61 136
# ----------------------------------------------------------            QF61 137
#                                                                       QF61 138
DO I=1,ITEM;  IWNT(I)=NINT(ARCH(I))#   Relocate archive list            QF61 139
FOR(I=KEY(2);I<KEY(3);I=I+1)#          Loop over irel deletes           QF61 140
IF(IREL(I+1)>9999) BREAK#              Exit no more                     QF61 141
NDEL=MAX0(0,NPAK-LPAK+I-KEY(2))#       Diff i/p to o/p packet           QF61 142
#                                                                       QF61 143
IRF=IREL(NTYP+1);  IRJ=IREL(NTYP+2)#   Frel & jcode pointers            QF61 144
IRS=IREL(NTYP+3);  IRX=IREL(NTYP+4)#   Scale & ext pointers             QF61 145
IRH=IREL(NTYP+5);  IRL=IREL(NTYP+6)#   Hkl and stol pointers            QF61 146
IRSF=IREL(NTYP+7)#                     Sigma f pointer                  QF61 147
IF(IRX==0)#                            Ext. consts not on bdf           QF61 148
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF61 149
writeline:(1,QF61W,NQF61W,3,3)#        Tell user ext. turned off        QF61 150
writeline:(1,0,0,1,3)#                 Blank line                       QF61 151
IEXT=no:#                              Turn off extinction              QF61 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF61 153
#                                                                       QF61 154
#                                                                       QF61 155
LINRM=4 ; REPEAT#                      Loop over reflections            QF61 156
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF61 157
#                                                                       QF61 158
#  READ  REFLECTION PACKETS FROM FILE A                                 QF61 159
#  ------------------------------------                                 QF61 160
#                                                                       QF61 161
readwpkt:(INBDF,lrrefl:,LPAK,IP,0)#    Point to input packet            QF61 162
IF(IP<=0) BREAK#                       Exit after last packet           QF61 163
#                                                                       QF61 164
# SETUP OUTPUT PACKET ACCORDING TO ARCHIVE SCHEME SET ABOVE & IN QF10   QF61 165
# -------------------------------------------------------------------   QF61 166
#                                                                       QF61 167
writepkt:(SCRBDF,lrrefl:,NPAK,JP)#     Point to output packet           QF61 168
STACKO=JP+1;   L=KEY(2)+1#             Set initial pointers             QF61 169
DO I=1,LPAK#                           Loop over input packet           QF61 170
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF61 171
J=IP+I#                                Point to output items            QF61 172
movepakwd:(QX(J),QX(STACKO))#          Move i/p to o/p                  QF61 173
IF(IREL(L)==I) L=L+1#                  Delete item & incr               QF61 174
ELSE           STACKO=STACKO+1#        Tranfer item & incr              QF61 175
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF61 176
movereal:(0.0,1,QX,STACKO,NDEL,2)#     Zero add-on area                 QF61 177
#                                                                       QF61 178
#  EXTRACT F-RELATIVE AND OTHER REFLECTION DATA                         QF61 179
#  --------------------------------------------                         QF61 180
#                                                                       QF61 181
STHOL=QX(IP+IRL)#                      Extract st/l                     QF61 182
RHO=STHOL**2#                          Get (st/l) squared               QF61 183
IF(IRF==0) YO=0.#                      Default value for frel           QF61 184
ELSE YO=QX(IP+IRF)#                    Frel is on bdisf                 QF61 185
IF(IRSF==0) SIGYOA=0.#                 Default value for sig(frel)      QF61 186
ELSE SIGYOA=QX(IP+IRSF)#               Sig(frel) is on bdisf            QF61 187
IF(IRS==0) ISCG=1#                     Point to scale one               QF61 188
ELSE       ISCG=NINT(QX(IP+IRS))#      Point to scale group             QF61 189
SCTM=SC(ISCG)#                         Hold the current ref fc scale    QF61 190
CODE=1.0 ; IF(IRJ>0) CODE=QX(IP+IRJ)#  Extract reflection code          QF61 191
gethkl:(IP+IRH,H)#                     Extract signed h,k,l             QF61 192
#                                                                       QF61 193
#     CHECK FOR ACCEPTABLE REFLECTIONS; REJECT IF FOLLOWING "TRUE"      QF61 194
#     ------------------------------------------------------------      QF61 195
#                                                                       QF61 196
IF(STHOL<SMIN\STHOL>SMAX\YO<FMIN\YO<SIGMIN*SIGYOA\CODE>REJF\CODE<1.0)#  QF61 197
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF61 198
YC=0.0 ; A=0.0 ; B=0.0 ; NREJCT=NREJCT+1# Reset all calculated values   QF61 199
# TEST WHETHER OR NOT REFLECTIONS ARE TO BE PRINTED                     QF61 200
IF(LISTF==1\(LISTF!=0&MOD(NUSED,LISTF)==0)\NDOUG<DOUG)#                 QF61 201
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF61 202
DO I=1,3 ; BUFOT(I)=H(I) ; movechar:(QF61X,1,CHROT,16,NQF61X,0)#        QF61 203
BUFOT(4)=STHOL ; BUFOT(5)=YO ; NDOUG=NDOUG+1#                           QF61 204
ncodefld:(BUFOT,1,CHROT,FM79,5) ; writeline:(0,QF61A,NQF61A,1,3)#       QF61 205
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF61 206
#                                                                       QF61 207
#  PLACE DUMMY RESULTS OF VOIDFLG: FOR ALL CALCULATED QUANTITIES        QF61 208
#  -------------------------------------------------------------        QF61 209
#                                                                       QF61 210
YC=voidflg:#                           Void f calculated                QF61 211
A=voidflg:#                            Void a calculated                QF61 212
B=voidflg:#                            Void b calculated                QF61 213
PHIC=voidflg:#                         Void calculated phase            QF61 214
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF61 215
#                                                                       QF61 216
#  REFLECTION IS WITHIN THE SUBSET TO HAVE STRUCTURE FACTOR CALCULATED  QF61 217
#  -------------------------------------------------------------------  QF61 218
#                                                                       QF61 219
ELSE#                                  Calculate structure factor       QF61 220
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF61 221
NUSED=NUSED+1#                         Count reflection as included     QF61 222
DO I=1,3 ; IHKL(I)=NINT(H(I))#         Miller indices as integers       QF61 223
#                                                                       QF61 224
DO L=1,NTYP#                           Loop over scat. factors          QF61 225
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF61 226
IF(NEUT==yes:) J=MARK3+L#              Point to neutron ff              QF61 227
ELSE IF(IREL(L)>0)#                    Are form factors in lrrefl?      QF61 228
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF61 229
J=IP+IREL(L)#                          Get ff pointers to buffer        QF61 230
FII(L)=QX(J) ; FIIMOD(L)=FII(L)#       Store scatt. factor by atom ty   QF61 231
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF61 232
ELSE#                                  Get f fact from tlu              QF61 233
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF61 234
JJJ=INT(STHOL/DSTL)#                   Find interval of ff table        QF61 235
DELST=DSTL*FLOAT(JJJ)-STHOL#           Get delta stol                   QF61 236
JJ=JJJ+(L-1)*NSCF+MARK3#               Point to ff table entry          QF61 237
FORMQ=QX(JJ+1)+(QX(JJ+1)-QX(JJ+2))*DELST/DSTL# Linear interpolation     QF61 238
FII(L)=FORMQ ; FIIMOD(L)=FORMQ#        Store scatt. factor by atom ty   QF61 239
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF61 240
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF61 241
#                                                                       QF61 242
#    ADD ANALYTIC AMORPHOUS SOLVENT APPROXIMATION AND                   QF61 243
#    PARTIAL FC CONTRIBUTIONS                                           QF61 244
#    ------------------------------------------------                   QF61 245
#                                                                       QF61 246
IF(SOLMOD==yes:) CALL QF63#            Call amorph                      QF61 247
#                                                                       QF61 248
#    SELECT REFLECTIONS FOR RTEST                                       QF61 249
#    DATA NEEDED ARE H, YO, SIGYOA, STHOL, FII(), PARTIAL FCS           QF61 250
#    --------------------------------------------------------           QF61 251
#                                                                       QF61 252
EXCLUD=no:#                            Do not exclude refln from l-s    QF61 253
IF(IRTEST==yes:&MOD(NUSED+NSAMPS,NSAMPL)==0)# Use refln in r survey?    QF61 254
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF61 255
#                                                                       QF61 256
# FOR A SELECTED SAMPLE OF REFLECTIONS WRITE A SCRATCH FILE FOR USE BY  QF61 257
# QF92 TO DO A SURVEY OF R VALUES BY VARYING THE SHIFTS FROM FULL AMNT. QF61 258
# --------------------------------------------------------------------  QF61 259
#                                                                       QF61 260
NRJDSK=NRJDSK+1#                       Count reflns in sample           QF61 261
writepkt:(RFILE,27,POUT,JPSCR)#        Write a reflection               QF61 262
DO I=1,3 ; QX(JPSCR+I)=H(I)#           Store indices                    QF61 263
QX(JPSCR+4)=FLOAT(ISCG)#               Store signal                     QF61 264
QX(JPSCR+5)=YO ; QX(JPSCR+6)=SIGYOA ; QX(JPSCR+7)=STHOL#                QF61 265
QX(JPSCR+8)=APC ; QX(JPSCR+9)=BPC#                                      QF61 266
DO I=1,NTYP ; QX(JPSCR+I+9)=FII(I)#    Store scattering factors         QF61 267
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF61 268
ELSE IF(IRTESX==yes:&MOD(NUSED+NSAMPY,NSAMPX)==0)# Exclude from l-s?    QF61 269
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF61 270
#                                                                       QF61 271
# FOR A SELECTED SAMPLE OF REFLECTIONS WRITE A SCRATCH FILE FOR USE BY  QF61 272
# QF92 TO DO A SURVEY OF R VALUES FOR REFLECTIONS EXCLUDED FROM         QF61 273
# THE BUILDING OF THE LEAST-SQUARES MATRIX AND VECTOR.  THIS IS AN      QF61 274
# ACID TEST OF THE REFINEMENT PROCESS. IT WAS SUGGESTED BY              QF61 275
# JOHN KONNERT AS A MEANS OF CHECKING THE QUALITY OF A REFINEMENT.      QF61 276
# --------------------------------------------------------------------  QF61 277
#                                                                       QF61 278
NRKDSK=NRKDSK+1#                       Count excluded reflns            QF61 279
EXCLUD=yes:#                           And signal no to matrix contri   QF61 280
writepkt:(EXRFI,27,POUT,JPSCR)#        Write a reflection               QF61 281
DO I=1,3 ; QX(JPSCR+I)=H(I)#           Store indices                    QF61 282
QX(JPSCR+4)=FLOAT(ISCG)#               Store signal                     QF61 283
QX(JPSCR+5)=YO ; QX(JPSCR+6)=SIGYOA ; QX(JPSCR+7)=STHOL#                QF61 284
QX(JPSCR+8)=APC ; QX(JPSCR+9)=BPC#                                      QF61 285
DO I=1,NTYP ; QX(JPSCR+I+9)=FII(I)#    Store scattering factors         QF61 286
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF61 287
#                                                                       QF61 288
#    CODE FOR SELECTING AND GENERATING REFLECTION WEIGHTS               QF61 289
#    ----------------------------------------------------               QF61 290
#                                                                       QF61 291
IF(KFWGT!=3&KFWGT!=4) SIGDEL=AMAX1(0.0,AFSIG+BFSIG*(STHOL-0.1666667))#  QF61 292
IF(KFWGT==1) SIGAPP=SIGDEL#                                             QF61 293
ELSE IF(KFWGT==2) SIGAPP=AMAX1(SIGYOA,SIGDEL)#                          QF61 294
ELSE IF(KFWGT==3) SIGAPP=SIGYOA#                                        QF61 295
ELSE IF(KFWGT==4) SIGAPP=AFSIG*SIGYOA#                                  QF61 296
ELSE IF(KFWGT==5) SIGAPP=SQRT(SIGYOA**2+SIGDEL**2)#                     QF61 297
SQRTW=1.0/AMAX1(SIGAPP,0.01)#                                           QF61 298
#                                                                       QF61 299
#   CALCULATE STRUCTURE FACTOR AND DIRIVATIVES FOR THIS REFLECTION      QF61 300
#   --------------------------------------------------------------      QF61 301
#                                                                       QF61 302
CALL QF62#                             Call calc                        QF61 303
#                                                                       QF61 304
#    GET REFLECTION PHASE IN CYCLES AND DEGREES                         QF61 305
#    ------------------------------------------                         QF61 306
#                                                                       QF61 307
PHIC=AMOD(ATAN2(B,A)/PI2+1.000001,1.0) ; XE=PHIC*360.0#                 QF61 308
#                                                                       QF61 309
#    INCREMENT AGREEMENT FACTOR SUMS                                    QF61 310
#    -------------------------------                                    QF61 311
#                                                                       QF61 312
DY=YO-YC ; WDY=SQRTW*DY ; RSNUM=RSNUM+SIGYOA ; RZNUM=RZNUM+ABS(DY)#     QF61 313
RZDEN=RZDEN+ABS(YO) ; WRZNUM=WRZNUM+WDY**2#                             QF61 314
WRZDEN=WRZDEN+(SQRTW*YO)**2#                                            QF61 315
SCNUM=SCNUM+YO*YC ; SCDEN=SCDEN+YC*YC ; D=0.5/STHOL#                    QF61 316
#                                                                       QF61 317
# MAKE SUMS FOR SCALE FACTOR-OVERALL TEMPERATURE FACTOR SHIFTS          QF61 318
# ------------------------------------------------------------          QF61 319
#                                                                       QF61 320
KDIAG=KDIAG+(YC/SCTM)**2 ; BDIAG=BDIAG+(RHO*YC)**2# Diagonal elements   QF61 321
KBOFFD=KBOFFD-(RHO*YC**2)/SCTM#        Off diagonal element             QF61 322
KVEC=KVEC+DY*YC/SCTM#                  Vector component for scale       QF61 323
BVEC=BVEC-DY*RHO*YC#                   Vector component for ov. t. f.   QF61 324
DO I=1,NDMIN#                          Partition by d value resolutio   QF61 325
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF61 326
N=I ; IF(D>DMIN(I)) BREAK#             Find the d value region          QF61 327
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF61 328
ZNUM(N)=ZNUM(N)+ABS(DY) ; ZDEN(N)=ZDEN(N)+YO ; ZSIG(N)=ZSIG(N)+SIGYOA#  QF61 329
ZAPP(N)=ZAPP(N)+SIGAPP ; NZCT(N)=NZCT(N)+1#                             QF61 330
#                                                                       QF61 331
#    LISTING OF REFLECTION INFORMATION                                  QF61 332
#    ---------------------------------                                  QF61 333
#                                                                       QF61 334
IF(LISTF==1\(LISTF!=0&MOD(NUSED,LISTF)==0)\NDOUG<DOUG)# List criteria   QF61 335
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF61 336
DO I=1,3 ; BUFOT(I)=H(I) ; NDOUG=NDOUG+1#                               QF61 337
IF(EXCLUD==no:) movechar:(QF61Y,1,CHROT,16,NQF61Y,0)# Mark as used      QF61 338
ELSE movechar:(QF611,1,CHROT,16,NQF611,0)# Mark as excluded             QF61 339
BUFOT(4)=STHOL ; BUFOT(5)=YO ; BUFOT(6)=YC ; BUFOT(7)=XE#               QF61 340
BUFOT(8)=A ; BUFOT(9)=B ; BUFOT(10)=DY ; BUFOT(11)=SIGAPP#              QF61 341
ncodefld:(BUFOT,1,CHROT,FM79,11) ; writeline:(0,QF61A,NQF61A,1,3)#      QF61 342
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF61 343
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF61 344
#                                                                       QF61 345
# AT THIS POINT THE OUTPUT PACKET MUST RECEIVE THE CALCULATED           QF61 346
# QUANTITIES.  THE ARCHIVE SCHEME SET UP IN QF10 COMES INTO PLAY.  THE  QF61 347
# ITEMS POSSIBLE TO ARCHIVE ARE, IN ORDER, SHOWN IN THE ASSIGNMENT      QF61 348
# STATEMENTS WHICH FOLLOW.  WHETHER OR NOT THE ITEMS ARE TRANSFERED TO  QF61 349
# THE OUTPUT BDFIS DETERMINED BY THE SIGN OF THE SIGNAL LIST IN THE     QF61 350
# IWNT ARRAY.   THIS IS SET NEAR THE BEGINNING OF QF61.  THE TWIDDLERS  QF61 351
# CAVEAT IS HEREBY INVOKED!                                             QF61 352
# --------------------------------------------------------------------  QF61 353
#                                                                       QF61 354
ARCH(1)=YC#                            Fc without dispersion            QF61 355
ARCH(2)=A#                             Real part of fc w/o disp         QF61 356
ARCH(3)=B#                             Imaginary parf fc w/o disp       QF61 357
ARCH(4)=voidflg:#                      Real dispersion component        QF61 358
ARCH(5)=voidflg:#                      Imaginary dispersion component   QF61 359
ARCH(6)=voidflg:#                      Real fc no extinction            QF61 360
ARCH(7)=voidflg:#                      Imaginary fc no extinction       QF61 361
ARCH(8)=PHIC#                          Phase in cycles                  QF61 362
ARCH(9)=YO## TEMPORARY CLUDGE!!!!!!   F rel corr'd for dispersion       QF61 363
DO I=1,ITEM#                           Loop over the archive list       QF61 364
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF61 365
IF(IWNT(I)<0) NEXT#                    Skip all minuses, they're out    QF61 366
QX(STACKO)=ARCH(I)#                    But, stack out the rest          QF61 367
STACKO=STACKO+1#                       At the end of the packet         QF61 368
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF61 369
#                                                                       QF61 370
# CHECK TO SEE IF THE CURRENT REFLECTION IS TO BE CONTRIBUTED TO THE    QF61 371
# DERIVATIVE MATRIX.                                                    QF61 372
# ------------------------------------------------------------------    QF61 373
#                                                                       QF61 374
IF(REPORT==yes:&EXCLUD==no:)#          Contrib refln to least-squares   QF61 375
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QF61 376
#                                                                       QF61 377
#    APPLY REFLECTION WEIGHTING TO DERIVATIVES                          QF61 378
#    -----------------------------------------                          QF61 379
#                                                                       QF61 380
DO K=MARKU,STOPU ; QX(K+1)=QX(K+1)*SQRTW# Dv(k) = dv(k)*sqrtw           QF61 381
#                                                                       QF61 382
#    CONTRIBUTE TO THE MATRIX ELEMENT FOR THE SCALE FACTOR              QF61 383
#    -----------------------------------------------------              QF61 384
#                                                                       QF61 385
QX(MARKM+1)=QX(MARKM+1)+QX(MARKU+1)**2# Am(1)=am(1)+dv(1)*dv(1)         QF61 386
#                                                                       QF61 387
#    CONTRIBUTE FC TO 6 MATRIX ELEMENTS PER ATOM WITHIN ATOM BLOCKS     QF61 388
#    THESE CONSIST OF SUMS OF THE PARTIAL DIRIVATIVES OF F CALC         QF61 389
#    WITH RESPECT TO THE POSITIONAL PARAMETERS.  IN THE ORDER..         QF61 390
#    DX**2, DX*DY, DX*DZ, DY**2, DY*DZ, & DZ**2                         QF61 391
#    --------------------------------------------------------------     QF61 392
#                                                                       QF61 393
IA3=MARKU-2 ; IA6=MARKM-5 ; DO IA=1,NA# Remember, scale factor first    QF61 394
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QF61 395
IA3=IA3+3 ; IA6=IA6+6#                                                  QF61 396
QX(IA6+1)=QX(IA6+1)+QX(IA3+1)**2## DIRIVATIVE W.R.T. X SQUARED          QF61 397
QX(IA6+2)=QX(IA6+2)+QX(IA3+1)*QX(IA3+2)## "     "    X*Y                QF61 398
QX(IA6+3)=QX(IA6+3)+QX(IA3+1)*QX(IA3+3)## "     "    X*Z                QF61 399
QX(IA6+4)=QX(IA6+4)+QX(IA3+2)**2## "     "    Y SQUARED                 QF61 400
QX(IA6+5)=QX(IA6+5)+QX(IA3+2)*QX(IA3+3)## "     "    Y*Z                QF61 401
QX(IA6+6)=QX(IA6+6)+QX(IA3+3)**2## "     "    Z SQUARED                 QF61 402
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QF61 403
#                                                                       QF61 404
#    DISTANCE CONSTRAINTS INTO THE MATRIX AT 9 PER SPECIFIED DISTANCE   QF61 405
#    ----------------------------------------------------------------   QF61 406
#                                                                       QF61 407
IF(NODISA==0)## Bypass section if structure factor effect not wanted    QF61 408
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QF61 409
L=6*NA+1 ; IDP=MARKD-STEPD ; INDEX=MARKM+6*NA+1 ; DO ID=1,NDIS#         QF61 410
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QF61 411
IDP=IDP+STEPD ; DO IXO=1,3 ; DO IXT=1,3#                                QF61 412
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QF61 413
INDEX=INDEX+1#                         Increment matrix pointer         QF61 414
NE=3*NINT(QX(IDP+1))+IXO+MARKU ; NZ=3*NINT(QX(IDP+2))+IXT+MARKU#        QF61 415
QX(INDEX)=QX(INDEX)+QX(NE-2)*QX(NZ-2)# Product of constraint factors    QF61 416
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QF61 417
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QF61 418
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QF61 419
#                                                                       QF61 420
#    HAVE WE OVERALL OR INDIVIDUAL TEMPERATURE FACTORS                  QF61 421
#    -------------------------------------------------                  QF61 422
#                                                                       QF61 423
L=6*NA+9*NDIS+1 ; IF(TFTYPE==0)#       Test for overall                 QF61 424
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QF61 425
#                                                                       QF61 426
#    INCREMENT MATRIX ELEMENTS FOR OVERALL B VALUE                      QF61 427
#    ---------------------------------------------                      QF61 428
#                                                                       QF61 429
L=L+1#                                                                  QF61 430
QX(L+MARKM)=QX(L+MARKM)+QX(IBET1+MARKU)**2# Am(l)=am(l)+dv(ibet1)**2    QF61 431
L=L+1#                                                                  QF61 432
QX(L+MARKM)=QX(L+MARKM)+QX(MARKU+1)*QX(IBET1+MARKU)# "="+dv(1)*dv(ibe   QF61 433
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QF61 434
ELSE IF(TFTYPE==1)#                                                     QF61 435
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QF61 436
#                                                                       QF61 437
#    INCREMENT MATRIX ELEMENTS FOR INDIVIDUAL ISOTROPIC B VALUES        QF61 438
#    AM(L+I) = AM(L+I) + DV(IATMN+I)**2                                 QF61 439
#    ------------------------------------------------------------       QF61 440
#                                                                       QF61 441
DO I=1,NA#                                                              QF61 442
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QF61 443
QX(L+I+MARKM)=QX(L+I+MARKM)+QX(IATMN+I+MARKU)**2#                       QF61 444
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QF61 445
IF(NODISA==0)#                                                          QF61 446
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QF61 447
L=L+NA ; NDIS2=NDIS-NVDW ; IDP=MARKD-STEPD ; DO ID=1,NDIS2#             QF61 448
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QF61 449
NE=NINT(QX(IDP+1)) ; NZ=NINT(QX(IDP+2))#                                QF61 450
#    AM(L+ID) = AM(L+ID) + DV(NE(ID)+IATMN)*DV(NZ(ID)+IATMN)            QF61 451
QX(L+ID+MARKM)=QX(L+ID+MARKM)+QX(NE+IATMN+MARKU)*$#                     QF61 452
QX(NZ+IATMN+MARKU)#                                                     QF61 453
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QF61 454
L=L+NDIS2 ; DO ID=1,NHBD#                                               QF61 455
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 QF61 456
IHBD=NDIS+ID ; IHBDP=(IHBD-1)*STEPD+MARKD#                              QF61 457
NE=NINT(QX(IHBDP+1)) ; NZ=NINT(QX(IHBDP+2))#                            QF61 458
#    AM(L+ID) = AM(L+ID) + DV(NE(IHBD)+IATMN)*DV(NZ(IHBD)+IATMN)        QF61 459
QX(L+ID+MARKM)=QX(L+ID+MARKM)+QX(NE+IATMN+MARKU)*$#                     QF61 460
QX(NZ+IATMN+MARKU)#                                                     QF61 461
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 QF61 462
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QF61 463
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QF61 464
ELSE IF(TFTYPE==2)#                    Increment for aniso t.f.s        QF61 465
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 QF61 466
DO I=1,3 ; DO J=I,3#                                                    QF61 467
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 QF61 468
IJ=I+J-1/I ; DO IA=1,NA#                                                QF61 469
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 QF61 470
KIA=IATMN+3*(IA-1) ; LIA=L+6*(IA-1)#                                    QF61 471
QX(LIA+IJ+MARKM)=QX(LIA+IJ+MARKU)*QX(KIA+J+MARKU)#                      QF61 472
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 QF61 473
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 QF61 474
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 QF61 475
#                                                                       QF61 476
#    INCREMENT MATRIX ELEMENTS FOR OCCUPANCY FACTORS                    QF61 477
#    -----------------------------------------------                    QF61 478
#                                                                       QF61 479
IF(NOCC!=0)#                                                            QF61 480
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 QF61 481
IF(TFTYPE==1) L=7*NA+9*NDIS+NDIS-NVDW+NHBD+1#                           QF61 482
DO I=1,NOCC#                                                            QF61 483
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 QF61 484
QX(L+I+MARKM)=QX(L+I+MARKM)+QX(IBETN+I+MARKU)**2#                       QF61 485
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 QF61 486
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 QF61 487
#                                                                       QF61 488
#    CONTRIBUTE THE DIRVATIVES TIMES DELTA F TO THE VECTOR ELEMENTS     QF61 489
#    --------------------------------------------------------------     QF61 490
#                                                                       QF61 491
DO N=1,NV#                                                              QF61 492
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 QF61 493
QX(N+MARKV)=QX(N+MARKV)+QX(N+MARKU)*WDY#                                QF61 494
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 QF61 495
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QF61 496
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF61 497
#                                                                       QF61 498
#     ALL REFLECTIONS DONE                                              QF61 499
#     --------------------                                              QF61 500
#                                                                       QF61 501
copyfile:(INBDF,SCRBDF,incr:(lrrefl:),endrecord:)# Finish off scratch   QF61 502
#                                                                       QF61 503
#  IF SAMPLE OF REFLECTIONS FOR R TEST IN QF92; END FILE AND REWIND     QF61 504
#  ----------------------------------------------------------------     QF61 505
#                                                                       QF61 506
IF(IRTEST==yes:) writepkt:(RFILE,endrecord:,3,JP)# End r survey file    QF61 507
IF(IRTESX==yes:) writepkt:(EXRFI,endrecord:,3,JP)# End r exclusion      QF61 508
#                                                                       QF61 509
#   COMPUTE AND REPORT R VALUES FOR THE STRUCTURE FACTORS CALCULATED    QF61 510
#   ----------------------------------------------------------------    QF61 511
#                                                                       QF61 512
NOBS=NUSED## Compute and put out agreement factors                      QF61 513
SIG=WRZNUM ; AVG=SIG/FLOAT(NOBS)#                                       QF61 514
WPSUM=WPSUM+WRZNUM ; WBSUM=WBSUM+WRZNUM#                                QF61 515
WQSUM=WQSUM+WRZNUM ; WRZNUM=SQRT(WRZNUM) ; WRZDEN=SQRT(WRZDEN)#         QF61 516
RZ=RZNUM/RZDEN ; WRZ=WRZNUM/WRZDEN#                                     QF61 517
RS=RSNUM/RZDEN ; AVGDEL=RZNUM/FLOAT(NOBS)#                              QF61 518
LINRM=15 ; writeline:(1,QF61B,NQF61B,3,3)# Write agreement heading      QF61 519
BUFOT(1)=SIG ; BUFOT(2)=AVG ; ncodefld:(BUFOT,1,QF61C,FM40,2)#          QF61 520
writeline:(1,QF61C,NQF61C,3,3)#        Sum of weighted deltas           QF61 521
BUFOT(1)=RZNUM ; BUFOT(2)=RZDEN ; BUFOT(3)=RZ#                          QF61 522
ncodefld:(BUFOT,1,CHROT,FM42,3)#                                        QF61 523
movechar:(QF61E,1,CHROT,2,NQF61E,0)#                                    QF61 524
movechar:(QF61F,1,CHROT,52,NQF61F,0)#                                   QF61 525
writeline:(1,QF61D,NQF61D,2,3)#        Standard r factor report         QF61 526
BUFOT(1)=WRZNUM ; BUFOT(2)=WRZDEN ; BUFOT(3)=WRZ#                       QF61 527
ncodefld:(BUFOT,1,CHROT,FM42,3)#                                        QF61 528
movechar:(QF61I,1,CHROT,2,NQF61I,0)#                                    QF61 529
movechar:(QF61J,1,CHROT,52,NQF61J,0)#                                   QF61 530
writeline:(0,0,0,1,3)#                 Weighted r factor report         QF61 531
BUFOT(1)=RSNUM ; BUFOT(2)=RZDEN ; BUFOT(3)=RS#                          QF61 532
ncodefld:(BUFOT,1,CHROT,FM42,3)#                                        QF61 533
movechar:(QF61G,1,CHROT,2,NQF61G,0)#                                    QF61 534
movechar:(QF61H,1,CHROT,52,NQF61H,0)#                                   QF61 535
writeline:(0,0,0,1,3)#                 Error r factor report            QF61 536
#                                                                       QF61 537
#    REPORT REFLECTIONS USED AND AVERAGE F(REL)-F(CALC) VALUE           QF61 538
#    --------------------------------------------------------           QF61 539
#                                                                       QF61 540
BUFOT(1)=FLOAT(NUSED) ; BUFOT(2)=FLOAT(NREJCT)# Report reflections      QF61 541
BUFOT(3)=FLOAT(NRJDSK) ; BUFOT(4)=FLOAT(NRKDSK)# Survey reflections     QF61 542
LINRK=5 ; writeline:(1,QF61K,NQF61K,1,3)#                               QF61 543
ncodefld:(BUFOT,1,CHROT,FMTFR,4);writeline:(1,QF612,NQF612,2,3)#        QF61 544
ncodefld:(AVGDEL,1,QF61L,90822.,1) ; writeline:(1,QF61L,NQF61L,3,3)#    QF61 545
#                                                                       QF61 546
#    RESOLUTION BREAKDOWN OF R VALUES                                   QF61 547
#    --------------------------------                                   QF61 548
#                                                                       QF61 549
LINRM=6 ; writeline:(1,QF61P,NQF61P,3,3) ; LINRM=3#                     QF61 550
A11=0.0 ; A12=0.0 ; A22=0.0 ; B1=0.0 ; B2=0.0 ; ZNM=0.0 ; ZDN=0.0#      QF61 551
DO I=1,NDMIN#                                                           QF61 552
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 QF61 553
RSHL=0.0 ; RSPH=0.0 ; AVGDEL=0.0 ; IF(ZDEN(I)!=0.0&NZCT(I)!=0)#         QF61 554
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 QF61 555
RSHL=ZNUM(I)/ZDEN(I) ; AVGDEL=ZNUM(I)/FLOAT(NZCT(I))#                   QF61 556
ZSIG(I)=ZSIG(I)/FLOAT(NZCT(I)) ; ZAPP(I)=ZAPP(I)/FLOAT(NZCT(I))#        QF61 557
ZNM=ZNM+ZNUM(I) ; ZDN=ZDN+ZDEN(I) ; RSPH=ZNM/ZDN#                       QF61 558
IF(I==1) SAVG=(((.5/DMIN(1))**3+SMIN**3)/2.0)**0.33333#                 QF61 559
ELSE SAVG=(((.5/DMIN(I))**3+(.5/DMIN(I-1))**3)/2.0)**0.33333#           QF61 560
SAVG=SAVG-0.1666667 ; A11=A11+1.0 ; A12=A12+SAVG#                       QF61 561
A22=A22+SAVG**2 ; B1=B1+AVGDEL ; B2=B2+AVGDEL*SAVG#                     QF61 562
BUFOT(1)=DMIN(I) ; BUFOT(2)=FLOAT(NZCT(I)) ; BUFOT(3)=ZSIG(I)#          QF61 563
BUFOT(4)=ZAPP(I) ; BUFOT(5)=AVGDEL ; BUFOT(6)=RSHL#                     QF61 564
BUFOT(7)=RSPH ; ncodefld:(BUFOT,1,CHROT,FM840,7)#                       QF61 565
writeline:(0,QF61Q,NQF61Q,1,3)#                                         QF61 566
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 QF61 567
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 QF61 568
SCLEST=SCNUM/AMAX1(0.001,SCDEN)#       Recalculate fc scale factor      QF61 569
BUFOT(1)=FLOAT(NOBS) ; BUFOT(2)=RZ#                                     QF61 570
ncodefld:(BUFOT,1,CHROT,FM852,2) ; movechar:(QF61R,1,CHROT,2,NQF61R,0)# QF61 571
writeline:(1,QF61Q,NQF61Q,1,3)#        No. of observatios and r overa   QF61 572
BUFOT(1)=AFSIG ; BUFOT(2)=BFSIG ; ncodefld:(BUFOT,1,QF61S,FM855,2)#     QF61 573
writeline:(1,QF61S,NQF61S,3,3)#        Report modeled deltas            QF61 574
IF(A11>=2.0)#                                                           QF61 575
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 QF61 576
AFSIG=(B1*A22-B2*A12)/(A11*A22-A12*A12)#                                QF61 577
BFSIG=(B1-A11*AFSIG)/A12#                                               QF61 578
BUFOT(1)=AFSIG ; BUFOT(2)=BFSIG ; ncodefld:(BUFOT,1,QF61T,FM855,2)#     QF61 579
writeline:(1,QF61T,NQF61T,3,3)#        Report fitted fo-fc              QF61 580
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 QF61 581
movechar:(WTLAB,(KFWGT-1)*16+1,QF61U,25,16,0)#                          QF61 582
writeline:(1,QF61U,NQF61U,3,3)#        Report weighting scheme used     QF61 583
RETURN#                                                                 QF61 584
END#                                                                    QF61 585
systemheader:(QF62)## Calculation of structure factors                  QF62   1
####################################################################    QF62   2
#                                                                  #    QF62   3
#                                QF62                              #    QF62   4
#                                                                  #    QF62   5
####################################################################    QF62   6
SUBROUTINE QF62#                       Subroutine calc                  QF62   7
#                                      J. konnert  w. hendrickson       QF62   8
include:(AACOMN)#                                                       QF62   9
include:(QFCOMN)#                                                       QF62  10
#                                                                       QF62  11
#    SUBROUTINE CALC **CALCULATE STRUCTURE FACTORS AND DERIVATIVES      QF62  12
#                    **SPACE GROUP GENERAL                              QF62  13
#                                                                       QF62  14
REAL AII(25),BII(25)#                                                   QF62  15
REAL HS(3)#                                                             QF62  16
INTEGER I,IA,II,IS,I3,IQZERO,JF#       Loop indices & pointers          QF62  17
INTEGER NTFI##                                                          QF62  18
INTEGER NFI##                                                           QF62  19
INTEGER NTF##                                                           QF62  20
INTEGER NCOS1,NSIN1##                                                   QF62  21
INTEGER NAAA,NBBB##                                                     QF62  22
INTEGER NAA,NBB##                                                       QF62  23
INTEGER NDADX1,NDADX2,NDADX3##                                          QF62  24
INTEGER NDBDX1,NDBDX2,NDBDX3##                                          QF62  25
INTEGER NCOB1,NCOB2,NCOB3##                                             QF62  26
INTEGER NDADB1,NDADB2,NDADB3##                                          QF62  27
INTEGER NDBDB1,NDBDB2,NDBDB3##                                          QF62  28
REAL RATIO#                                                             QF62  29
REAL RHONEG#                                                            QF62  30
REAL SQRTAB#                                                            QF62  31
#REAL SQTO#                                                             QF62  32
REAL TFO#                                                               QF62  33
REAL TRANS#                                                             QF62  34
#                                                                       QF62  35
#    INITIALIZE                                                         QF62  36
NTFI=MARKT ; NTF=NTFI+NA ; NFI=NTF+NA ; NCOS1=NFI+NA ; NSIN1=NCOS1+NA#  QF62  37
NAAA=NSIN1+NA ; NBBB=NAAA+NA ; NAA=NBBB+NA ; NBB=NAA+NA#                QF62  38
NDADX1=NBB+NA ; NDADX2=NDADX1+NA ; NDADX3=NDADX2+NA#                    QF62  39
NDBDX1=NDADX3+NA ; NDBDX2=NDBDX1+NA ; NDBDX3=NDBDX2+NA#                 QF62  40
NDADB1=NDBDX3+NA ; NDADB2=NDADB1+NA ; NDADB3=NDADB2+NA#                 QF62  41
NDBDB1=NDADB3+NA ; NDBDB2=NDBDB1+NA ; NDBDB3=NDBDB2+NA#                 QF62  42
NCOB1=NDBDB3+NA ; NCOB2=NCOB1+NA ; NCOB3=NCOB2+NA#                      QF62  43
DO IA=1,NA#                                                             QF62  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF62  45
QX(IA+NAAA)=0.0 ; QX(IA+NBBB)=0.0#                                      QF62  46
QX(IA+NDADX1)=0.0 ; QX(IA+NDADX2)=0.0 ; QX(IA+NDADX3)=0.0#              QF62  47
QX(IA+NDBDX1)=0.0 ; QX(IA+NDBDX2)=0.0 ; QX(IA+NDBDX3)=0.0#              QF62  48
QX(IA+NDADB1)=0.0 ; QX(IA+NDADB2)=0.0 ; QX(IA+NDADB3)=0.0#              QF62  49
QX(IA+NDBDB1)=0.0 ; QX(IA+NDBDB2)=0.0 ; QX(IA+NDBDB3)=0.0#              QF62  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF62  51
#    BEGIN WITH SOLVENT SCATTERING CONTRIBUTION                         QF62  52
A=A0 ; B=B0#                                                            QF62  53
#                                                                       QF62  54
#    OBTAIN THE SCATTERING FACTOR                                       QF62  55
#    ----------------------------                                       QF62  56
#                                                                       QF62  57
J=MARKA-STEPA ; DO I=1,NA#             Include the occupancy factor     QF62  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF62  59
J=J+STEPA ; QX(NFI+I)=FIIMOD(NINT(QX(J+4)))*ABS(QX(J+6))#               QF62  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF62  61
IF(TFTYPE==1)#                         Individual isotropic t.f.?       QF62  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF62  63
J=MARKA-STEPA ; DO IA=1,NA#                                             QF62  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF62  65
J=J+STEPA ; QX(IA+NAA)=QX(J+5)*RHO#    B*sin**2(theta)/lambda**         QF62  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF62  67
CALL QF64(QX(NTF+1),QX(NAA+1),NA)#     Call expv(tf,arg,na)             QF62  68
#    COMPUTE THE TEMPERATURE AND SCATTERING FACTOR PRODUCTS             QF62  69
DO IA=1,NA ; QX(IA+NTFI)=QX(IA+NTF)*QX(IA+NFI)# Tfi(ia)=tf(ia)*fi(ia)   QF62  70
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF62  71
ELSE#                                  Overall isotropic thermal fact   QF62  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF62  73
TFO = EXP(-TO*RHO)#                                                     QF62  74
DO IA=1,NA ; QX(IA+NTFI)=TFO*QX(IA+NFI)# Tfi(ia)=tfo*fi(ia)             QF62  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF62  76
#    GRAND CYCLE OVER SYMMETRY EQUIVALENTS                              QF62  77
DO IS=1,NS#                                                             QF62  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF62  79
#                                                                       QF62  80
#    PERFORM SYMMETRY TRANSFORMATIONS AND COMPUTE TRIGONOMETRIC FACTORS QF62  81
#    NOTE THAT H.DOT.(S*X) = (S-TRANSPOSE*H).DOT.X                      QF62  82
TRANS=0.0 ; DO I=1,3#                                                   QF62  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF62  84
TRANS=TRANS+H(I)*T(I,IS) ; HS(I)=0.0#                                   QF62  85
DO J=1,3 ; HS(I)=HS(I)+H(J)*S(J,I,IS)#                                  QF62  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF62  87
J=MARKA-STEPA ; DO IA=1,NA#            Loop over all atoms              QF62  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF62  89
J=J+STEPA#                                                              QF62  90
#    GET H*X' + K*Y' + L*Z' + T                                         QF62  91
QX(IA+NAA)=TRANS+HS(1)*QX(J+1)+HS(2)*QX(J+2)+HS(3)*QX(J+3)#             QF62  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF62  93
CALL QF65(QX(NCOS1+1),QX(NAA+1),NA)#   Call trig(cos1,arg,na)           QF62  94
DO IA=1,NA#                            Compute s.f. contributions       QF62  95
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF62  96
QX(IA+NAA)=QX(IA+NTFI)*QX(IA+NCOS1)#   Aa(ia) = tfi(ia)*cos1(ia)        QF62  97
QX(IA+NBB)=QX(IA+NTFI)*QX(IA+NSIN1)#   Bb(ia) = tfi(ia)*sin1(ia)        QF62  98
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF62  99
#    INCLUDE IMAGINARY COMPONENTS OF ANOMALOUS SCATTERING IF REQUIRED   QF62 100
IF(NAS>0)#                                                              QF62 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF62 102
DO IAS=1,NAS#                                                           QF62 103
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF62 104
#  JFAS AND IAAS ARE IN SERIOUS TROUBLE!!!!!!!!                         QF62 105
IA=IAAS(IAS) ; JF=JFAS(IAS) ; RATIO=FAII(JF)/FII(JF)#                   QF62 106
AII(IAS)=-RATIO*QX(IA+NBB) ; BII(IAS)=RATIO*QX(IA+NAA)#                 QF62 107
QX(IA+NAA)=QX(IA+NAA)+AII(IAS) ; QX(IA+NBB)=QX(IA+NBB)+BII(IAS)#        QF62 108
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF62 109
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF62 110
#    COMPUTE A AND B                                                    QF62 111
DO IA=1,NA#                                                             QF62 112
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF62 113
QX(IA+NAAA)=QX(IA+NAAA)+QX(IA+NAA) ; QX(IA+NBBB)=QX(IA+NBBB)+QX(IA+NBB)#QF62 114
A=A+QX(IA+NAA) ; B=B+QX(IA+NBB)#                                        QF62 115
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF62 116
#    COMPUTE POSITIONAL DERIVATIVES WITH RESPECT TO A AND B             QF62 117
IF(KILLDV==yes:) NEXT#                                                  QF62 118
DO I=1,3 ; HS(I)=TUPI*HS(I)#                                            QF62 119
DO IA=1,NA#                                                             QF62 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF62 121
#      DADX(IA,IX) = DADX(IA,IX) - HS(IX)*BB(IA)                        QF62 122
#      DBDX(IA,IX) = DBDX(IA,IX) + HS(IX)*AA(IA)                        QF62 123
QX(NDADX1+IA)=QX(NDADX1+IA)-HS(1)*QX(NBB+IA)#                           QF62 124
QX(NDADX2+IA)=QX(NDADX2+IA)-HS(2)*QX(NBB+IA)#                           QF62 125
QX(NDADX3+IA)=QX(NDADX3+IA)-HS(3)*QX(NBB+IA)#                           QF62 126
QX(NDBDX1+IA)=QX(NDBDX1+IA)+HS(1)*QX(NAA+IA)#                           QF62 127
QX(NDBDX2+IA)=QX(NDBDX2+IA)+HS(2)*QX(NAA+IA)#                           QF62 128
QX(NDBDX3+IA)=QX(NDBDX3+IA)+HS(3)*QX(NAA+IA)#                           QF62 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF62 130
#    CORRECT FOR CONTRIBUTIONS OF ANOMALOUS SCATTERING                  QF62 131
#    FINALLY CORRECTED 12-31-86...SS                                    QF62 132
IF(NAS>0)#                                                              QF62 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF62 134
DO IAS=1,NAS#                                                           QF62 135
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF62 136
IA=IAAS(IAS)#                                                           QF62 137
#      DADX(IA,IX) = DADX(IA,IX) - HS(IX)*BII(IAS)                      QF62 138
#      DBDX(IA,IX) = DBDX(IA,IX) + HS(IX)*AII(IAS)                      QF62 139
QX(NDADX1+IA)=QX(NDADX1+IA)-HS(1)*BII(IAS)#                             QF62 140
QX(NDADX2+IA)=QX(NDADX2+IA)-HS(2)*BII(IAS)#                             QF62 141
QX(NDADX3+IA)=QX(NDADX3+IA)-HS(3)*BII(IAS)#                             QF62 142
QX(NDBDX1+IA)=QX(NDBDX1+IA)+HS(1)*AII(IAS)#                             QF62 143
QX(NDBDX2+IA)=QX(NDBDX2+IA)+HS(2)*AII(IAS)#                             QF62 144
QX(NDBDX3+IA)=QX(NDBDX3+IA)+HS(3)*AII(IAS)#                             QF62 145
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF62 146
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF62 147
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF62 148
#                                                                       QF62 149
# COMPUTE THE REAL AND IMAGINARY PARTS OF FC INCLUDING SCALE FACTOR     QF62 150
SQRTAB=SQRT(A**2+B**2);YC=SCTM*SQRTAB;A=SCTM*A;B=SCTM*B#                QF62 151
#                                                                       QF62 152
#    SKIP DERIVATIVES IF NOT NEEDED                                     QF62 153
IF(KILLDV==no:)#                                                        QF62 154
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF62 155
CA=A/AMAX1(SQRTAB,0.00001) ; CB=B/AMAX1(SQRTAB,0.00001)#                QF62 156
QX(MARKU+1)=YC/SCTM#                   Dv(1) = f/sc(iq)                 QF62 157
#                                                                       QF62 158
#    COMPUTE POSITIONAL DERIVATIVES WITH RESPECT TO F                   QF62 159
DO I=1,NA#                                                              QF62 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QF62 161
I3=3*I+MARKU#                                                           QF62 162
#      DV(I3-1) = CA*DADX(I,1) + CB*DBDX(I,1)                           QF62 163
#      DV(I3  ) = CA*DADX(I,2) + CB*DBDX(I,2)                           QF62 164
#      DV(I3+1) = CA*DADX(I,3) + CB*DBDX(I,3)                           QF62 165
QX(I3-1)=CA*QX(I+NDADX1)+CB*QX(I+NDBDX1)#                               QF62 166
QX(I3  )=CA*QX(I+NDADX2)+CB*QX(I+NDBDX2)#                               QF62 167
QX(I3+1)=CA*QX(I+NDADX3)+CB*QX(I+NDBDX3)#                               QF62 168
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QF62 169
#                                                                       QF62 170
#    COMPUTE THERMAL DERIVATIVES WITH RESPECT TO F                      QF62 171
IF(TFTYPE==0) QX(IBET1+MARKU)=-RHO*YC# Dv(ibet1)=-rho*f;overall         QF62 172
ELSE#                                  Individual isotropic             QF62 173
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QF62 174
#     DV(IATMN+I) = RHONEG*(CA*AAA(I)+CB*BBB(I))                        QF62 175
RHONEG=-RHO ; DO I=1,NA#                                                QF62 176
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QF62 177
QX(IATMN+I+MARKU)=RHONEG*(CA*QX(I+NAAA)+CB*QX(I+NBBB))#                 QF62 178
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QF62 179
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QF62 180
#                                                                       QF62 181
#    COMPUTE OCCUPANCY FACTOR DERIVATIVES WITH RESPECT TO F             QF62 182
IF(NOCC!=0)#                                                            QF62 183
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QF62 184
#    DV(IBETN+I)=(CA*AAA(I+IQZERO)+CB*BBB(I+IQZERO))/QOCC(I+IQZERO)     QF62 185
I=0 ; J=MARKA-STEPA#                   Set vector and atom array ptrs   QF62 186
IQZERO=NA-NOCC ; DO II=1,NA#           Search for atoms with pop para   QF62 187
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QF62 188
J=J+STEPA#                             Point to atom parameters         QF62 189
IF(QX(J+6)>0.0&I<NOCC)#                Test if this one refined         QF62 190
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QF62 191
I=I+1#                                 Advance pnter to vector elemen   QF62 192
QX(IBETN+I+MARKU)=(CA*QX(I+IQZERO+NAAA)+CB*QX(I+IQZERO+NBBB))/$#        QF62 193
QX(J+6)#                               Diriv of population parameter    QF62 194
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QF62 195
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QF62 196
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QF62 197
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF62 198
#                                                                       QF62 199
RETURN#                                                                 QF62 200
END#                                                                    QF62 201
systemheader:(QF63)## Ucsd amorphous solvent contribution               QF63   1
####################################################################    QF63   2
#                                                                  #    QF63   3
#                                QF63                              #    QF63   4
#                                                                  #    QF63   5
####################################################################    QF63   6
SUBROUTINE QF63#                       Subroutine amorph                QF63   7
#                                          B. c. finzel feb 1981        QF63   8
include:(AACOMN)#                                                       QF63   9
include:(QFCOMN)#                                                       QF63  10
INTEGER I#                                                              QF63  11
REAL FACTOR#                                                            QF63  12
REAL USOLV#                                                             QF63  13
#                                                                       QF63  14
#     SUBROUTINE ADDED 2-26-81 B C FINZEL TO APPLY UCSD AMORPHOUS       QF63  15
#     SOLVENT AND PARTIAL FC CONTRIBUTIONS TO A REFLECTION.             QF63  16
#                                                                       QF63  17
A0=0.0 ; B0=0.0 ; USOLV=1.0-UK/EXP(UB*RHO)#                             QF63  18
DO I=1,NTYP ; FIIMOD(I) = FII(I)*USOLV#                                 QF63  19
IF(PK>0.0)#                                                             QF63  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF63  21
FACTOR=PK/EXP(PB*RHO) ; A0=APC*FACTOR ; B0=BPC*FACTOR#                  QF63  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF63  23
RETURN#                                                                 QF63  24
END#                                                                    QF63  25
systemheader:(QF64)## Exp(-x) by table look-up                          QF64   1
####################################################################    QF64   2
#                                                                  #    QF64   3
#                                QF64                              #    QF64   4
#                                                                  #    QF64   5
####################################################################    QF64   6
SUBROUTINE QF64(EXPL,ARG,N)## SUBROUTINE EXPV(EXPL,ARG,N)               QF64   7
#                                         J. konnert                    QF64   8
include:(AACOMN)#                                                       QF64   9
include:(QFCOMN)#                                                       QF64  10
#                                                                       QF64  11
#   EXPONENTIAL EVALUATION BY TABLE LOOK-UP                             QF64  12
#   ---------------------------------------                             QF64  13
#                                                                       QF64  14
REAL EXPL(*),ARG(*)#                                                    QF64  15
INTEGER I,N,INDEX#                                                      QF64  16
DO I=1,N#                                                               QF64  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF64  18
INDEX=INT(100.0*ARG(I)+1.5)#                                            QF64  19
INDEX=MIN0(INDEX,1024);EXPL(I)=ETB(INDEX)#                              QF64  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF64  21
RETURN#                                                                 QF64  22
END#                                                                    QF64  23
systemheader:(QF65)## Trig function tlu                                 QF65   1
####################################################################    QF65   2
#                                                                  #    QF65   3
#                                QF65                              #    QF65   4
#                                                                  #    QF65   5
####################################################################    QF65   6
SUBROUTINE QF65(COSSIN,ARG,N)## SUBROUTINE TRIG(COSSIN,ARG,N)           QF65   7
#                                       J. konnert                      QF65   8
include:(AACOMN)#                                                       QF65   9
include:(QFCOMN)#                                                       QF65  10
#                                                                       QF65  11
#    SINE & COSINE EVALUATION BY TABLE LOOK-UP                          QF65  12
#    -----------------------------------------                          QF65  13
#                                                                       QF65  14
REAL COSSIN(*),ARG(*)## cossin is cos for first n entries sin beyond    QF65  15
INTEGER I,N,INDEX#                                                      QF65  16
intdata:(MSK,[1023])#                  Data msk /z000003ff/             QF65  17
datastuff:#                                                             QF65  18
#                                                                       QF65  19
DO I=1,N#                                                               QF65  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF65  21
INDEX=NINT(1024.0*ARG(I))+IPOSTV#      Fractions of cell made positiv   QF65  22
INDEX=and:(INDEX,MSK)#                 And modulo 1024                  QF65  23
COSSIN(I)=CTB(INDEX+1) ; COSSIN(I+N)=STB(INDEX+1)# Tlu cos and sin      QF65  24
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF65  25
RETURN#                                                                 QF65  26
END#                                                                    QF65  27
systemheader:(QF66)## Structure factor by FFT                           QF66   1
####################################################################    QF66   2
#                                                                  #    QF66   3
#                                QF64                              #    QF66   4
#                                                                  #    QF66   5
####################################################################    QF66   6
SUBROUTINE QF66##                                                       QF66   7
#                                         J. m. stewart march 1989      QF66   8
include:(AACOMN)#                                                       QF66   9
include:(QFCOMN)#                                                       QF66  10
#                                                                       QF66  11
#   READ THE FILE WITH THE VALUES OF FC AND THE DERIVATIVES AND         QF66  12
#   CONTRIBUTE TO THE DERIVATIVE MATRIX AND VECTOR.                     QF66  13
#   -----------------------------------------------------------         QF66  14
#                                                                       QF66  15
RETURN#                                                                 QF66  16
END#                                                                    QF66  17
systemheader:(QF71)## Drive refinement and print snapshot               QF71   1
####################################################################    QF71   2
#                                                                  #    QF71   3
#                                QF71                              #    QF71   4
#                                                                  #    QF71   5
####################################################################    QF71   6
SUBROUTINE QF71(AM,AII,FV,P,V,SK,DV)#                                   QF71   7
#      SUBROUTINE CGSOLV(NCYCCG,DK,DT,NKILL,KILL) J. KONNERT 1974       QF71   8
#                                                                       QF71   9
# THE CONJUGATE GRADIENT METHOD USED IN THIS ROUTINE IS BASED ON        QF71  10
# THE PAPER BY HESTENES & STIEFEL "METHODS OF CONJUGATE GRADIENTS       QF71  11
# FOR SOLVING LINEAR SYSTEMS" JOURNAL OF RESEARCH OF THE NATIONAL       QF71  12
# BUREAU OF STANDARDS VOL. 49, NO. 6, DECEMBER 1952 RES. PAPER 2379.    QF71  13
#                                                                       QF71  14
# THE APPLICATION TO CRYSTALLOGRAPHIC LEAST SQUARES REFINEMENT WAS      QF71  15
# MADE BY JOHN KONNERT OF THE NAVAL RESEARC LABORATORY, THE ORIGINAL    QF71  16
# AUTHOR OF THESE SUBROUTINES.  THEY ARE DESCRIBED IN THE PAPER         QF71  17
# "A RESTRAINED-PARAMETER STRUCTURE-FACTOR LEAST-SQUARES REFINEMENT     QF71  18
# PROCEDURE FOR LARGE ASYMMETRIC UNITS." ACTA CRYST.(1976), A32 614     QF71  19
# JULY 1976.  COMMENTS BELOW ARE IN REFERENCE TO THIS PAPER.            QF71  20
#                                                                       QF71  21
include:(AACOMN)#                                                       QF71  22
include:(QFCOMN)#                                                       QF71  23
#                                                                       QF71  24
#                                                                       QF71  25
REAL AII(*)##                                                           QF71  26
REAL AL## Result of eqn. 7 Konnert in ACta                              QF71  27
REAL AM(*)## The derivative matrix, capital a in eqn. 2                 QF71  28
REAL EPSLON## Number to test magnitude of r vector getting small        QF71  29
REAL DEN## Denominator of eqn. 7                                        QF71  30
REAL DUM,DUM0,DUM1,DUM2## Temp storage for numerators and denominator   QF71  31
#                        IN EQUATIONS 6 THROUGH 11                      QF71  32
REAL DV(*)## Estimate of shifts -  Konnert's "x" of  eqn 8              QF71  33
REAL FV(*)## Vector result of am*p for denom of eqn. 7                  QF71  34
INTEGER I,II,III#                      Loop indices                     QF71  35
INTEGER K1,L,L1,N#                     Loop indices                     QF71  36
INTEGER KEEPGO#                        Signal to keep iterating         QF71  37
INTEGER NINC#                                                           QF71  38
INTEGER NDUMP#                         Limit extent of dumped atom in   QF71  39
REAL DTNUM,DTDENO#                     Protect overall tf shift         QF71  40
REAL P(*)## Most current estimate of the shifts.                        QF71  41
#                       THE P OF EQNS. 7, 8, 9, & 11                    QF71  42
## RMSA is a measure of the root mean square value of the diuagonal     QF71  43
## elements of the A matrix.  RMSR is the rms value of the elements     QF71  44
## of the R vector.  These values are used in a non-transparent way     QF71  45
## in the denominator of the calculation of shifts in the NEXT cycle    QF71  46
## so that when the value of RMSR falls to a small number relative to   QF71  47
## the machine register acurracy iteration must be stopped or divide    QF71  48
## overflow or divergence will occur.  RMSX and RMSDX are the rms       QF71  49
## values of the shift and delta shift vectors.  When RMSDX gets small  QF71  50
## the solution has converged and the process can be discontinued.      QF71  51
## RMSDXO is the previous cycle value of RMSDX and is used to monitor   QF71  52
## convergence.                                                         QF71  53
REAL RMSA,RMSR,RMSX,RMSDXO#                                             QF71  54
REAL RMSDX## Statistic on the rms value of "x" vector elements          QF71  55
REAL SK(*)## Scale factor to make all diagonal elements of              QF71  56
#                       THE DERIVATIVE MATRIX EQUAL.                    QF71  57
REAL V(*)## Prod. of residue (delta f) * derivatives.                   QF71  58
#                       DURING THE ITERATIONS THE VECTOR R. AFTER THE   QF71  59
#                       CYCLES V IS THE ESTIMATE OF THE DIAGONAL ELEMEN QF71  60
#                       OF THE INVERSE OF THE DERIVATIVE MATRIX.        QF71  61
#                                                                       QF71  62
chardata:(QF71A, DIAGNOSTIC SAMPLE OF MATRIX AND VECTOR ELEMENTS)#      QF71  63
chardata:(QF71B, F CALC MATRIX AND VECTOR ELEMENTS FOR THE $#           QF71  64
FIRST 20 ATOMS)#                                                        QF71  65
chardata:(QF71C,             DX**2       DX*DY       DX*DZ       $#     QF71  66
DY**2       DY*DZ       DZ**2       DX*FC       DY*FC       DZ*FC)#     QF71  67
chardata:(QF71D,                                 PROGRESS OF THE CG $#  QF71  68
SOLUTION FOR A SAMPLE OF SCALED PARAMETER SHIFTS)#                      QF71  69
chardata:(QF71E,[           RMS ROOT $#                                 QF71  70
MN     RMS            VARIABLE SAMPLE OF ELEMENTS OF "X" VECTOR])#      QF71  71
chardata:(QF71F,[   CYCLE SHIFT INVERSE DELTA(X)    $#                  QF71  72
.                               $#                                      QF71  73
.                             X(NVL)   ])#                              QF71  74
chardata:(QF71G,            MATRIX       VECTOR                      )# QF71  75
chardata:(QF71H, FC SCALE SHIFT )#                                      QF71  76
chardata:(QF71I, OVERALL B SHIFT)#                                      QF71  77
chardata:(QF71J, MATRIX ELEMENTS FOR DISTANCE CONSTRAINTS FOR THE $#    QF71  78
FIRST 20 DISTANCES)#                                                    QF71  79
chardata:(QF71K,              ME1         ME2         ME3         $#    QF71  80
ME4         ME5         ME6         ME7         ME8         ME9)#       QF71  81
chardata:(QF71L, MATRIX ELEMENTS FOR INDIVIDUAL ISOTROPIC $#            QF71  82
THERMAL PARAMETERS)#                                                    QF71  83
chardata:(QF71M, ATOM   DB**2 )#                                        QF71  84
chardata:(QF71N, VECTOR ELEMENTS, 9 PER LINE)#                          QF71  85
realdata:(FMT20,[60513.])#                                              QF71  86
realdata:(FMT30,[181231.,301231.,421231.,541231.,661231.,$#             QF71  87
781231.,901231.,1021231.,1141231.])#                                    QF71  88
realdata:(FMT15,[60313.,140752.,220852.,300852.,380852.,460852.,$#      QF71  89
540852.,620852.,700852.,780852.,860852.,940852.,1020852.])#             QF71  90
realdata:(FMQFF,[380713.,460813.,540813.,620813.,700813.,780813.,$#     QF71  91
860813.,940813.])#                                                      QF71  92
datastuff:#                                                             QF71  93
EPSLON=1.0E-mxsgfp:## Small number to gaurd divide ovfl                 QF71  94
#                                                                       QF71  95
#   CALCULATE THE SHIFT IN FC SCALE AND OVERALL TF                      QF71  96
#   ----------------------------------------------                      QF71  97
#                                                                       QF71  98
DTDENO=KDIAG*BDIAG-KBOFFD**2#          Calculate denominator for dt     QF71  99
DTNUM=KDIAG*BVEC-KVEC*KBOFFD#          Calculate numerator for dt       QF71 100
IF(ABS(DTNUM)>4.0*ABS(DTDENO))$#       Stop shifts > 4.0 in b           QF71 101
DT=SIGN(1.0,DTDENO*DTNUM)#             Move correct direction by 1.0    QF71 102
ELSE DT=DTNUM/DTDENO#                  Calc overall t. f. shift         QF71 103
DK=(KVEC-KBOFFD*DT)/AMAX1(KDIAG,1.0)#  F calc scale factor              QF71 104
I=6*NA+9*NDIS+2#                       Point to overall temp.fac.       QF71 105
#                                                                       QF71 106
#                                                                       QF71 107
#     PUT OUT A SAMPLE OF THE MATRIX AND VECTOR ELEMENTS                QF71 108
#     --------------------------------------------------                QF71 109
#                                                                       QF71 110
#   SET UP DUMP LIMITS IN TERMS OF NUMBER OF ATOMS                      QF71 111
NDUMP=MIN0(NA,50)#                     Limit number of lines            QF71 112
IF(PPRIOR>4)#                          Dump only if high priority       QF71 113
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF71 114
LINRM=6 ; writeline:(2,QF71A,NQF71A,3,5)#                               QF71 115
movechar:(QF71H,1,QF71G,32,NQF71H,0)#                                   QF71 116
BUFOT(1)=QX(MARKM+1) ; BUFOT(2)=QX(MARKV+1)#                            QF71 117
BUFOT(3)=DK ; ncodefld:(BUFOT,1,CHROT,FMT30,3)#                         QF71 118
writeline:(1,QF71G,NQF71G,2,5)#        Report scale factor              QF71 119
BUFOT(1)=QX(MARKM+I) ; BUFOT(2)=QX(IBET1+MARKV)#                        QF71 120
BUFOT(3)=DT ; ncodefld:(BUFOT,1,CHROT,FMT30,3)#                         QF71 121
movechar:(QF71I,1,QF71G,33,NQF71I,0)#                                   QF71 122
writeline:(1,QF71G,NQF71G,1,5)#        Report temperature factor        QF71 123
LINRM=22 ; writeline:(1,QF71B,NQF71B,3,5) ; LINRM=2# Head matrix dump   QF71 124
K1=2+MARKM ; L1=2+MARKV ; DO I=1,NDUMP# Sample some matrix & vector     QF71 125
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF71 126
ncodefld:(FLOAT(I),1,CHROT,FMT20,1)#   Get matrix and vector elements   QF71 127
ncodefld:(QX,K1,CHROT,FMT30,6)#        Having to do with x,y,z params   QF71 128
ncodefld:(QX,L1,CHROT,FMT30(7),3) ; writeline:(0,QF71C,NQF71C,1,5)#     QF71 129
K1=K1+6 ; L1=L1+3#                                                      QF71 130
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF71 131
K1=6*NA+2+MARKM ; NDUMP=MIN0(100,NDIS)#                                 QF71 132
LINRM=4 ; writeline:(1,QF71J,NQF71J,3,5) ; LINRM=2# Dump some distanc   QF71 133
DO I=1,NDUMP#                          Matrix in dist constr region     QF71 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF71 135
ncodefld:(FLOAT(I),1,CHROT,FMT20,1)#                                    QF71 136
ncodefld:(QX,K1,CHROT,FMT30,9)#                                         QF71 137
writeline:(0,QF71K,NQF71K,1,5) ; K1=K1+9#                               QF71 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF71 139
IF(TFTYPE==1)#                         Dump isotropic t.f. elements     QF71 140
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF71 141
LINRM=5 ; writeline:(1,QF71L,NQF71L,3,5) ; LINRM=2#                     QF71 142
K1=6*NA+9*NDIS+MARKM+1 ; NDUMP=MIN0(NA,50)#                             QF71 143
DO I=1,NDUMP#                          Loop over atoms                  QF71 144
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF71 145
ncodefld:(FLOAT(I),1,CHROT,FMT20,1)#                                    QF71 146
ncodefld:(QX,K1+I,CHROT,FMT30,1)#      Pick up db**2 sums               QF71 147
writeline:(0,QF71M,NQF71M,1,5)#                                         QF71 148
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF71 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF71 150
NDUMP=MIN0(200,NV) ; writeline:(1,QF71N,NQF71N,3,5) ; L1=0#             QF71 151
FOR(I=1;I<=NDUMP;I=I+1)#                                                QF71 152
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF71 153
IF(L1>=9)#                                                              QF71 154
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF71 155
ncodefld:(FLOAT(I-L1),1,CHROT,FMT20,1)#                                 QF71 156
L1=0 ; writeline:(0,QF71N,NQF71N,1,5)#                                  QF71 157
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF71 158
L1=L1+1 ; ncodefld:(QX,MARKV+I,CHROT,FMT30(L1),1)# Get vector element   QF71 159
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF71 160
ncodefld:(FLOAT(I-L1),1,CHROT,FMT20,1)#                                 QF71 161
writeline:(0,QF71N,NQF71N,1,5)#                                         QF71 162
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF71 163
#                                                                       QF71 164
#     PREP FOR ORIGIN SPEC BY LAGRANGE MULTIPLIER CONSTRAINTS           QF71 165
#     -------------------------------------------------------           QF71 166
#                                                                       QF71 167
L2=LGX+LGY ; L3=L2+LGZ ; NVL=NV+L3#                                     QF71 168
#                                                                       QF71 169
#     INITIALIZE AND SCALE FOR THE C-G SOLUTION                         QF71 170
#     -----------------------------------------                         QF71 171
#                                                                       QF71 172
RMSDXO=1.0E20 ; NINC=NV/7 ; CALL QF73(AM,SK,DV,V)# Call scale           QF71 173
IF(NKILL>0) CALL QF72#                 Call freeze(kill)                QF71 174
DUM1=0.0 ; DO N=1,NVL#                                                  QF71 175
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF71 176
AII(N)=0.0 ; DV(N)=0.0 ; P(N)=V(N)#                                     QF71 177
DUM1=DUM1+V(N)**2#                     Get numerator of jk eqn. 7       QF71 178
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF71 179
IF(PPRIOR>2)#                          Print at priority 3 +            QF71 180
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF71 181
LINRM=10 ; writeline:(1,QF71D,NQF71D,3,3)#                              QF71 182
writeline:(1,QF71E,NQF71E,3,3) ; LINRM=2#                               QF71 183
DO I=1,8 ; BUFOT(I)=FLOAT((I-1)*NINC+1)# Build heading                  QF71 184
ncodefld:(BUFOT,1,QF71F,FMQFF,8)#                                       QF71 185
movechar:(QF71H,5,QF71F,34,5,0)#       Overwrite "1" with "scale"       QF71 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF71 187
#                                                                       QF71 188
#     PERFORM THE C-G ITERATIONS                                        QF71 189
#     --------------------------                                        QF71 190
#                                                                       QF71 191
DO N=1,NCYCCG#                                                          QF71 192
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF71 193
# DO CUSTOM MATRIX MULTIPLY OF DERIVATIVE MATRIX, A, BY VECTOR, P       QF71 194
# ---------------------------------------------------------------       QF71 195
#                                                                       QF71 196
CALL QF74(AM,P,FV,SK)#                 Call  matmul                     QF71 197
DUM=DUM1 ; DEN=0.0#                                                     QF71 198
DO L=1,NVL ; DEN=DEN+P(L)*FV(L)#       Get denominator of eqn 7         QF71 199
AL=DUM/DEN#                            Get result of eqn. 7             QF71 200
DUM0=0.0 ; DUM1=0.0 ; DUM2=0.0 ; RMSDX=0.0 ; DO L=1,NVL#                QF71 201
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF71 202
DV(L)=DV(L)+AL*P(L)#                   Jk eqn. 8, shift est., x vecto   QF71 203
RMSDX=RMSDX+(AL*P(L))**2#              Statistic on mag of x elements   QF71 204
V(L)=V(L)-AL*FV(L)#                    Jk eqn. 9  r vector              QF71 205
AII(L)=AII(L)+(P(L)**2)/DEN#           Est. inv. matrix diag. element   QF71 206
DUM0=DUM0+AII(L) ; DUM1=DUM1+V(L)**2 ; DUM2=DUM2+DV(L)**2#              QF71 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF71 208
RMSX=SQRT(DUM2/FLOAT(NVL)) ; RMSR=SQRT(DUM1/FLOAT(NVL))#                QF71 209
RMSA=SQRT(ABS(DUM0/FLOAT(NVL)))#                                        QF71 210
RMSDX=SQRT(RMSDX/FLOAT(NVL))#          Find rms delta(x)                QF71 211
IF((RMSDXO-RMSDX)/RMSX>0.1)#           Test for convergence of shifts   QF71 212
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF71 213
KEEPGO=yes: ; RMSDXO=RMSDX#            Assume we'll keep going          QF71 214
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF71 215
ELSE#                                  Convergence achieved             QF71 216
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF71 217
KEEPGO=no:#                            Stop the iterations              QF71 218
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF71 219
B=DUM1/DUM#                            Jk eqn. 10                       QF71 220
DO L=1,NVL ; P(L)=V(L)+B*P(L)#         Jk eqn. 11                       QF71 221
IF(PPRIOR>2)#                          Dump at high priority            QF71 222
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF71 223
BUFOT(1)=FLOAT(N) ; BUFOT(2)=RMSX ; BUFOT(3)=RMSA ; BUFOT(4)=RMSDX#     QF71 224
II=4 ; DO I=1,NV,NINC#                                                  QF71 225
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF71 226
II=II+1 ; BUFOT(II)=DV(I)#                                              QF71 227
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF71 228
BUFOT(II+1)=DV(NVL) ; III=MIN0(II+4,13)#                                QF71 229
ncodefld:(BUFOT,1,CHROT,FMT15,III) ; writeline:(0,QF71F,NQF71F,1,3)#    QF71 230
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF71 231
IF(RMSR<EPSLON\KEEPGO==no:) BREAK#     Stop r too small or converged    QF71 232
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF71 233
#                                                                       QF71 234
#     RESCALE THE SOLUTION VECTOR AND DIAGONAL INVERSE MATRIX ELEMENTS  QF71 235
#     ----------------------------------------------------------------  QF71 236
#                                                                       QF71 237
DO I=1,NV#                                                              QF71 238
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF71 239
V(I)=AII(I)*SK(I)**2## Get a scaled estimate of inv. matrix elements    QF71 240
DV(I)=DV(I)*SK(I)## Get the final scaled shifts from the iterations     QF71 241
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF71 242
#                                                                       QF71 243
RETURN#                                                                 QF71 244
END#                                                                    QF71 245
systemheader:(QF72)## Freeze the positions of designated atoms          QF72   1
####################################################################    QF72   2
#                                                                  #    QF72   3
#                                QF72                              #    QF72   4
#                                                                  #    QF72   5
####################################################################    QF72   6
SUBROUTINE QF72#                       Subroutine freeze(kill)          QF72   7
#                            W. HENDRICKSON J. KONNERT 1974             QF72   8
# THE "KILL" SIGNALS ARE NOW THE 7TH ITEM IN THE MARKA ARRAY.           QF72   9
#                                      J.m. stewart dec 1987            QF72  10
include:(AACOMN)#                                                       QF72  11
include:(QFCOMN)#                                                       QF72  12
#                                                                       QF72  13
INTEGER I,J,J1,J3,K,K1,K2#             Loop indices and pointers        QF72  14
INTEGER L1,L6,L9#                      Loop indices and pointers        QF72  15
INTEGER NATT#                          6*(no. of atoms) + 2             QF72  16
#                                                                       QF72  17
#   SUBROUTINE FREEZE(KILL) STOP REFINEMENT OF SELECTED ATOMS           QF72  18
#    FREEZE ELEMENTS OF DESIGNATED ATOMS IN THE ATOM BLOCKS             QF72  19
#                                                                       QF72  20
DO I=1,NA#                                                              QF72  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF72  22
K=(I-1)*STEPA+MARKA ; IF(NINT(QX(K+7))!=0)#                             QF72  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF72  24
L1=6*(I-1)+2+MARKM ; L6=L1+5+MARKM ; DO L=L1,L6 ; QX(L)=0.0#            QF72  25
J1=3*(I-1)+2+MARKV ; J3=J1+2+MARKV ; DO J=J1,J3 ; QX(J)=0.0#            QF72  26
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF72  27
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF72  28
#                                                                       QF72  29
#    FREEZE ELEMENTS OF DESIGNATED ATOMS IN THE DISTANCE BLOCKS         QF72  30
NATT=6*NA+2 ; DO J=1,NDIS#                                              QF72  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF72  32
K=(J-1)*STEPD+MARKD ; K1=(NINT(QX(K+1))-1)*STEPA+MARKA#                 QF72  33
K2=(NINT(QX(K+2))-1)*STEPA+MARKA#                                       QF72  34
IF(NINT(QX(K1+7))==0&NINT(QX(K2+7))==0) NEXT#                           QF72  35
L1=NATT+9*(J-1)+MARKM ; L9=L1+8+MARKM ; DO L=L1,L9 ; QX(L)=0.0#         QF72  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF72  37
#                                                                       QF72  38
RETURN#                                                                 QF72  39
END#                                                                    QF72  40
systemheader:(QF73)## Find scale parameters                             QF73   1
####################################################################    QF73   2
#                                                                  #    QF73   3
#                                QF73                              #    QF73   4
#                                                                  #    QF73   5
####################################################################    QF73   6
SUBROUTINE QF73(AM,SK,DV,V)#           Subroutine scale                 QF73   7
#                                  J KONNERT, W HENDRICKSON 1974        QF73   8
# A SUBROUTINE TO ENSURE RAPID CONVERGENCE BY FINDING AN OPTIMUM        QF73   9
# SCALING VECTOR WHICH WILL EQUALIZE THE DIAGONAL MATRIX ELEMENTS       QF73  10
# DURING THE CONJUGATE GRADIENT PROCEEDURE.                             QF73  11
#                                                                       QF73  12
include:(AACOMN)#                                                       QF73  13
include:(QFCOMN)#                                                       QF73  14
#                                                                       QF73  15
REAL ABAR#                                                              QF73  16
REAL AM(*)#                            The derivative matrix            QF73  17
REAL DV(*)#                            Vector of diag. matrix elem.     QF73  18
INTEGER I,IA,IA3,IA6,ID,IDP,IHB,IJ,IO,IQ,IT# Loop indices               QF73  19
INTEGER KO,KT,L#                       Loop indices                     QF73  20
INTEGER NBIS#                                                           QF73  21
REAL SK(*)#                            Vector of scale factors          QF73  22
REAL V(*)#                             Vector product of derivatives    QF73  23
#                                     TIMES THE RESIDUES (DELTA F)      QF73  24
#                                                                       QF73  25
ABAR=0.0#                              Initialize                       QF73  26
#                                                                       QF73  27
#     SET UP A VECTOR OF DIAGONAL MATRIX ELEMENTS                       QF73  28
#     -------------------------------------------                       QF73  29
#                                                                       QF73  30
DV(1)=AM(1)#                           Scale factor                     QF73  31
DO IA=1,NA#                            Positional parameters            QF73  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF73  33
DV(3*IA-1)=AM(6*IA-4) ; DV(3*IA  )=AM(6*IA-1) ; DV(3*IA+1)=AM(6*IA+1)#  QF73  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF73  35
L=6*NA+9*NDIS+1#                       Thermal parameters               QF73  36
IF(TFTYPE==0) DV(IBET1)=AM(L+1)#       Overall isotropic t.f.           QF73  37
ELSE IF(TFTYPE==1)#                    Individual isotropic t.f.        QF73  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF73  39
DO IA=1,NA ; DV(IATMN+IA)=AM(L+IA)#                                     QF73  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF73  41
IF(NOCC!=0)#                                                            QF73  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF73  43
IF(TFTYPE==0) L=L+2#                                                    QF73  44
ELSE IF(TFTYPE==1) L=L+NA+NDIS-NVDW+NHBD#                               QF73  45
DO IQ=1,NOCC ; DV(IBETN+IQ)=AM(L+IQ)#                                   QF73  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF73  47
#                                                                       QF73  48
#     FIND SCALING FACTORS THAT EQUALIZE DIAGONAL MATRIX ELEMENTS       QF73  49
#     -----------------------------------------------------------       QF73  50
#                                                                       QF73  51
DO I=1,NV ; ABAR=ABAR+DV(I)#                                            QF73  52
ABAR=ABAR/FLOAT(NV) ; DO I=1,NV ; SK(I)=SQRT(ABS(ABAR/DV(I)))#          QF73  53
QBAR=ABAR/FLOAT(LQ)#                                                    QF73  54
#                                                                       QF73  55
#     SCALE THE MATRIX ELEMENTS                                         QF73  56
#     -------------------------                                         QF73  57
#                                                                       QF73  58
AM(1)=AM(1)*SK(1)**2#                  Scale factor                     QF73  59
DO IA=1,NA#                            Atom blocks                      QF73  60
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF73  61
IA6=6*IA ; IA3=3*IA#                                                    QF73  62
AM(IA6-4)=AM(IA6-4)*SK(IA3-1) ; AM(IA6-4)=AM(IA6-4)*SK(IA3-1)#          QF73  63
AM(IA6-3)=AM(IA6-3)*SK(IA3-1) ; AM(IA6-3)=AM(IA6-3)*SK(IA3  )#          QF73  64
AM(IA6-2)=AM(IA6-2)*SK(IA3-1) ; AM(IA6-2)=AM(IA6-2)*SK(IA3+1)#          QF73  65
AM(IA6-1)=AM(IA6-1)*SK(IA3  ) ; AM(IA6-1)=AM(IA6-1)*SK(IA3  )#          QF73  66
AM(IA6  )=AM(IA6  )*SK(IA3  ) ; AM(IA6  )=AM(IA6  )*SK(IA3+1)#          QF73  67
AM(IA6+1)=AM(IA6+1)*SK(IA3+1) ; AM(IA6+1)=AM(IA6+1)*SK(IA3+1)#          QF73  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF73  69
IDP=MARKD-STEPD ; DO ID=1,NDIS#        Distance blocks                  QF73  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF73  71
IDP=IDP+STEPD ; KO=3*(NINT(QX(IDP+1))-1)+1#                             QF73  72
KT=3*(NINT(QX(IDP+2))-1)+1 ; L=6*NA+9*(ID-1)+1#                         QF73  73
DO I=1,3 ; DO J=1,3#                                                    QF73  74
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF73  75
IJ=3*(I-1)+J ; AM(L+IJ)=AM(L+IJ)*SK(KO+I)*SK(KT+J)#                     QF73  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF73  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF73  78
L=6*NA+9*NDIS+1#                       Thermal parameters               QF73  79
IF(TFTYPE==0)#                         Overall t.f.                     QF73  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF73  81
AM(L+1)=AM(L+1)*SK(IBET1)**2 ; AM(L+2)=AM(L+2)*SK(IBET1)*SK(1)#         QF73  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF73  83
ELSE IF(TFTYPE==1)#                                                     QF73  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF73  85
DO IA=1,NA#                                                             QF73  86
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF73  87
AM(L+IA)=AM(L+IA)*SK(IATMN+IA) ; AM(L+IA)=AM(L+IA)*SK(IATMN+IA)#        QF73  88
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF73  89
L=L+NA ; NBIS=NDIS-NVDW ; IDP=MARKD-STEPD ; DO ID=1,NBIS#               QF73  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF73  91
IDP=IDP+STEPD#                                                          QF73  92
IO=NINT(QX(IDP+1))#                    Io=no(id)                        QF73  93
IT=NINT(QX(IDP+2))#                    It=nt(id)                        QF73  94
AM(L+ID)=AM(L+ID)*SK(IATMN+IO)*SK(IATMN+IT)#                            QF73  95
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF73  96
#     INCLUDE RESTRAINT ON H-BONDED THERMAL PARAMETER DIFFERENCES       QF73  97
#     -----------------------------------------------------------       QF73  98
#                                                                       QF73  99
L=L+NBIS ; DO IHB=1,NHBD#                                               QF73 100
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF73 101
ID=NDIS+IHB ; IDP=(ID-1)*STEPD+MARKD#                                   QF73 102
IO=NINT(QX(IDP+1))#                    Io=no(id)                        QF73 103
IT=NINT(QX(IDP+2))#                    It=nt(id)                        QF73 104
AM(L+IHB)=AM(L+IHB)*SK(IATMN+IO)*SK(IATMN+IT)#                          QF73 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF73 106
L=L-NBIS#                                                               QF73 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF73 108
IF(NOCC!=0)#                                                            QF73 109
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF73 110
IF(TFTYPE==0) L=L+2#                                                    QF73 111
ELSE IF(TFTYPE==1) L=L+NBIS+NHBD#                                       QF73 112
DO IQ=1,NOCC#                                                           QF73 113
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF73 114
AM(L+IQ)=AM(L+IQ)*SK(IBETN+IQ) ; AM(L+IQ)=AM(L+IQ)*SK(IBETN+IQ)#        QF73 115
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF73 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF73 117
DO I=1,NV ; V(I)=V(I)*SK(I)#           Scale the vector elements        QF73 118
RETURN#                                                                 QF73 119
END#                                                                    QF73 120
systemheader:(QF74)## Prolsq specific matrix multiplier                 QF74   1
####################################################################    QF74   2
#                                                                  #    QF74   3
#                                QF74                              #    QF74   4
#                                                                  #    QF74   5
####################################################################    QF74   6
SUBROUTINE QF74(AM,P,FV,SK)#           Subroutine matmul                QF74   7
#                                      J. konnert 1974                  QF74   8
include:(AACOMN)#                                                       QF74   9
include:(QFCOMN)#                                                       QF74  10
#                                                                       QF74  11
REAL AM(*)#                            Derivative matrix                QF74  12
REAL FV(*)#                            Vector a*p of eqn 7              QF74  13
INTEGER I,IA,ID,IDP,IHB,IK,IO,IQ#      Loop indices                     QF74  14
INTEGER J,JK,JKP,J5#                   Loop indices                     QF74  15
INTEGER L,LK,M,M5,N,NBIS,N5#           Loop indices                     QF74  16
REAL P(*)#                             Vector p of eqn 7                QF74  17
REAL SK(*)#                            Vector of scale factors          QF74  18
#                                                                       QF74  19
DO N=1,NVL ; FV(N)=0.#                 Initialize                       QF74  20
FV(1)=AM(1)*P(1)#                      F=a*p for scale factor           QF74  21
#     F=A*P OVER MATRIX ELEMENTS WITHIN ATOM BLOCKS                     QF74  22
J=-1 ; L=2 ; DO N=1,NA#                                                 QF74  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF74  24
J=J+3 ; J5=J+2 ; DO IK=J,J5 ; DO LK=IK,J5#                              QF74  25
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF74  26
FV(IK)=FV(IK)+AM(L)*P(LK)#                                              QF74  27
IF(IK-LK!=0) FV(LK)=FV(LK)+AM(L)*P(IK) ; L=L+1#                         QF74  28
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF74  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF74  30
#                                                                       QF74  31
#     F=A*P OVER MATRIX ELEMENTS WITHIN DISTANCE BLOCKS                 QF74  32
#     -------------------------------------------------                 QF74  33
#                                                                       QF74  34
JKP=MARKD-STEPD ; DO JK=1,NDIS#                                         QF74  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF74  36
JKP=JKP+STEPD ; N=3*(NINT(QX(JKP+1))-1)+2#                              QF74  37
M=3*(NINT(QX(JKP+2))-1)+2 ; M5=M+2 ; N5=N+2#                            QF74  38
DO IK=N,N5 ; DO LK=M,M5#                                                QF74  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF74  40
FV(IK)=FV(IK)+AM(L)*P(LK) ; FV(LK)=FV(LK)+AM(L)*P(IK) ; L=L+1#          QF74  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF74  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF74  43
#                                                                       QF74  44
#     F=A*P FOR TEMPERATURE FACTORS                                     QF74  45
#     -----------------------------                                     QF74  46
#                                                                       QF74  47
L=6*NA+9*NDIS+1#                                                        QF74  48
#                                                                       QF74  49
#     OVERALL ISOTROPIC B-VALUE                                         QF74  50
#     -------------------------                                         QF74  51
#                                                                       QF74  52
IF(TFTYPE==0)#                                                          QF74  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF74  54
L=L+1 ; FV(IBET1)=AM(L)*P(IBET1) ; L=L+1#                               QF74  55
FV(1)=FV(1)+AM(L)*P(IBET1) ; FV(IBET1)=FV(IBET1)+AM(L)*P(1)#            QF74  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF74  57
ELSE IF(TFTYPE==1)#                                                     QF74  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF74  59
DO I=1,NA ; FV(IATMN+I)=AM(L+I)*P(IATMN+I)#                             QF74  60
L=L+NA ; NBIS=NDIS-NVDW ; IDP=MARKD-STEPD ; DO ID=1,NBIS#               QF74  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF74  62
IDP=IDP+STEPD ; IO=NINT(QX(IDP+1)) ; IT=NINT(QX(IDP+2))#                QF74  63
FV(IATMN+IO)=FV(IATMN+IO)+AM(L+ID)*P(IATMN+IT)#                         QF74  64
FV(IATMN+IT)=FV(IATMN+IT)+AM(L+ID)*P(IATMN+IO)#                         QF74  65
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF74  66
#                                                                       QF74  67
#     INCLUDE CONTRIBUTION OF H-BONDED PAIR THERMAL PARAMETER DIFFERENC QF74  68
#     ----------------------------------------------------------------- QF74  69
#                                                                       QF74  70
DO IHB=1,NHBD#                                                          QF74  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF74  72
ID=NDIS+IHB ; IDP=(ID-1)*STEPD+MARKD#                                   QF74  73
IO=NINT(QX(IDP+1)) ; IT=NINT(QX(IDP+2))#                                QF74  74
FV(IATMN+IO)=FV(IATMN+IO)+AM(L+NBIS+IHB)*P(IATMN+IT)#                   QF74  75
FV(IATMN+IT)=FV(IATMN+IT)+AM(L+NBIS+IHB)*P(IATMN+IO)#                   QF74  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF74  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF74  78
#                                                                       QF74  79
#     OCCUPANCY FACTORS                                                 QF74  80
#     -----------------                                                 QF74  81
#                                                                       QF74  82
IF(NOCC!=0)#                                                            QF74  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF74  84
IF(TFTYPE==1) L=L+NBIS+NHBD#                                            QF74  85
DO IQ=1,NOCC ; FV(IBETN+IQ)=AM(L+IQ)*P(IBETN+IQ)#                       QF74  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF74  87
#                                                                       QF74  88
#     F=A*P FOR LAGRANGE MULTIPLIERS                                    QF74  89
#     ------------------------------                                    QF74  90
#                                                                       QF74  91
IF(L3!=0)#                                                              QF74  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF74  93
#                                                                       QF74  94
#     X-ORIGIN SPECIFICATION                                            QF74  95
#     ----------------------                                            QF74  96
#                                                                       QF74  97
IF(LGX!=0)#                                                             QF74  98
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF74  99
DO IA=1,NA#                                                             QF74 100
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF74 101
FV(3*IA-1)=FV(3*IA-1)+QBAR*SK(3*IA-1)*P(NV+ 1)#                         QF74 102
FV(NV+1)=FV(NV+1)+QBAR*SK(3*IA-1)*P(3*IA-1)#                            QF74 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF74 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF74 105
#                                                                       QF74 106
#     Y-ORIGIN SPECIFICATION                                            QF74 107
#     ----------------------                                            QF74 108
#                                                                       QF74 109
IF(LGY!=0)#                                                             QF74 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF74 111
DO IA=1,NA#                                                             QF74 112
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF74 113
FV(3*IA)=FV(3*IA)+QBAR*SK(3*IA)*P(NV+L2)#                               QF74 114
FV(NV+L2)=FV(NV+L2)+QBAR*SK(3*IA)*P(3*IA)#                              QF74 115
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF74 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF74 117
#                                                                       QF74 118
#     Z-ORIGIN SPECIFICATION                                            QF74 119
#     ----------------------                                            QF74 120
#                                                                       QF74 121
IF(LGZ!=0)#                                                             QF74 122
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF74 123
DO IA=1,NA#                                                             QF74 124
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF74 125
FV(3*IA+1)=FV(3*IA+1)+QBAR*SK(3*IA+1)*P(NV+L3)#                         QF74 126
FV(NV+L3)=FV(NV+L3)+QBAR*SK(3*IA+1)*P(3*IA+1)#                          QF74 127
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF74 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF74 129
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF74 130
RETURN#                                                                 QF74 131
END#                                                                    QF74 132
systemheader:(QF81)## Output updated coordinates                        QF81   1
####################################################################    QF81   2
#                                                                  #    QF81   3
#                                QF81                              #    QF81   4
#                                                                  #    QF81   5
####################################################################    QF81   6
SUBROUTINE QF81#                                                        QF81   7
#                                       J.m. stewart feb. 1989          QF81   8
include:(AACOMN)#                                                       QF81   9
include:(QFCOMN)#                                                       QF81  10
#                                                                       QF81  11
REAL ADELB#                            Shift in iso b                   QF81  12
REAL BANG,BAVG,BBAR,BMEAN,BNORM,BOUT#  Variables to do with b iso       QF81  13
REAL DVA,DVB,DVC,DVP#                  Sums for param shift stats       QF81  14
INTEGER I,IA,IAP,IP,IPRNT#             Misc. pointers                   QF81  15
INTEGER J,JP,K,KP,IQZERO#              More misc. pointers              QF81  16
INTEGER M,N,NP,NPP#                    Even more misc. pointers         QF81  17
INTEGER NPA,NPU,NPV#                   Counts of params for stats       QF81  18
INTEGER NREF#                          Number of reflections            QF81  19
REAL OCCNCY#                           Population parameter             QF81  20
REAL PANG,SANG#                        Sums for shift stats             QF81  21
REAL POPAVG,POPMAG#                    Find average population shift    QF81  22
REAL QNORM,PNORM,DENOM#                Refinement agreement stats.      QF81  23
REAL SVA,SVB,SVC,SVP#                  Sums for param shift stats       QF81  24
REAL XANG,XAVG,XBAR#                   Variables to do with x params    QF81  25
REAL YANG,YAVG,YBAR#                   Variables to do with y params    QF81  26
REAL ZANG,ZAVG,ZBAR#                   Variables to do with z params    QF81  27
realdata:(FM650,[50413.,251032.,351032.,451032.,$#                      QF81  28
530832.,610832.,680732.,750732.,820732.,890732.,960732.,1030732.])#     QF81  29
realdata:(FM670,[50413.,251032.,351032.,451032.,$#                      QF81  30
530832.,610832.,680722.,750732.,820732.,890732.,$#                      QF81  31
960732.,1030732.,1100732.])#                                            QF81  32
realdata:(FM671,[50413.,251032.,351032.,451032.,$#                      QF81  33
530832.,610832.,890722.,960732.,1030732.])#                             QF81  34
realdata:(FM685,[250942.,351042.,451042.,680732.,820732.])#             QF81  35
realdata:(FM686,[250942.,351042.,451042.,890732.])#                     QF81  36
realdata:(FM690,[251042.,351042.,451042.,530842.,$#                     QF81  37
610842.,680732.,820722.])#                                              QF81  38
chardata:(QF81A,    N   ATOM          DX        DY        DZ  $#        QF81  39
RMS SHIFT  SIGS     DB   SIGB      B     DP   SIGP    POP)#             QF81  40
chardata:(QF81B,    N   ATOM          DX        DY        DZ    $#      QF81  41
DB11   DB22   DB33   DB12   DB13   DB23     DP   SIGP    POP)#          QF81  42
chardata:(QF81C, MEAN SHIFTS)#                                          QF81  43
chardata:(QF81D,FRACTIONAL)#                                            QF81  44
chardata:(QF81E,ANGSTROMS)#                                             QF81  45
chardata:(QF81F, RMS SHIFTS)#                                           QF81  46
chardata:(QF81G,                CORRELATED  DIAGONAL)#                  QF81  47
chardata:(QF81H,FC SCALE SHIFT)#                                        QF81  48
chardata:(QF81I,B SHIFT)#                                               QF81  49
chardata:(QF81J, **********UNDAMPED COORDINATE SHIFT $#                 QF81  50
INFORMATION IN ANGSTROMS**********)#                                    QF81  51
chardata:(QF81K, SHIFTS DETERMINED IN THIS RUN WILL BE DAMPED BY...)#   QF81  52
chardata:(QF81L,    X      Y      Z      B      POP    B11    $#        QF81  53
B22    B33    B12    B13    B23)#                                       QF81  54
realdata:(FM81L,[80742.,150742.,220742.,290742.,360742.,430742.,$#      QF81  55
500742.,570742.,640742.,710742.,780742.])#                              QF81  56
chardata:(QF81M,[ >>>>>>>>>>>>>>>>>>>>>>>> SUMMARY OF SHIFTS $#         QF81  57
CALCULATED IN REFINEMENT RUN <<<<<<<<<<<<<<<<<<<<<<<<<])#               QF81  58
datastuff:#                                                             QF81  59
#                                                                       QF81  60
#                                                                       QF81  61
#    PUNCH OUT THE DECK OF PARAMETER SHIFTS AND WRITE UPDATED BDF       QF81  62
#    ------------------------------------------------------------       QF81  63
#                                                                       QF81  64
CALL QF83#                                                              QF81  65
#                                                                       QF81  66
LINRM=13 ; writeline:(4,QF81M,NQF81M,3,3)# Head the section             QF81  67
writeline:(1,QF81K,NQF81K,3,3)#        Head the shift listing       q   QF81  68
ncodefld:(DAMP,1,CHROT,FM81L,NDAMP) ; writeline:(0,QF81L,NQF81L,2,3)#   QF81  69
writeline:(1,QF81J,NQF81J,3,3)#                                         QF81  70
LINRM=3 ; NREF=NOBS ; IF(IDALIZ==1) NREF=NV#                            QF81  71
#    ESTIMATE STANDARD DEVIATIONS FROM THE INVERSE MATRIX               QF81  72
IF(REPORT==yes:) DENOM=FLOAT(NREF);ELSE DENOM=0.# Build denominator     QF81  73
IF(IDALIZ==yes:) DENOM=DENOM+FLOAT(NDIS+NNAP+NCHR+NTOR)# Incl restrai   QF81  74
DENOM=AMAX1(1.0,DENOM-FLOAT(NV))#      Protect overflow                 QF81  75
PNORM=WPSUM/DENOM#                     Get coordinate normal factor     QF81  76
IF(REPORT==yes:) DENOM=FLOAT(NREF);ELSE DENOM=0.# Build denominator     QF81  77
IF(IDALIZ==yes:) DENOM=DENOM+FLOAT(NDIS+NVDW+NHBD)# Incl restraints     QF81  78
DENOM=AMAX1(1.0,DENOM-FLOAT(NV))#      Protect overflow                 QF81  79
BNORM=WBSUM/DENOM#                     Get t.f. normalization           QF81  80
QNORM=WQSUM/AMAX1(1.0,FLOAT(NREF))#                                     QF81  81
IP=MARKV-STEPV ; DO I=1,IATMN#                                          QF81  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF81  83
IP=IP+STEPV ; QX(IP+1)=SQRT(ABS(PNORM*QX(IP+1)))#                       QF81  84
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF81  85
IF(TFTYPE!=0)#                         Individual t.f.s?                QF81  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF81  87
IP=MARKV+(IBET1-2)*STEPV ; DO I=IBET1,IBETN#                            QF81  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF81  89
IP=IP+STEPV ; QX(IP+1)=SQRT(ABS(BNORM*QX(IP+1)))#                       QF81  90
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF81  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF81  92
IF(NOCC!=0) DO I=1,NOCC#               Occupancy?                       QF81  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF81  94
J=IBETN+I ; JP=(J-1)*STEPV+MARKV ; QX(JP+1)=SQRT(ABS(QNORM*QX(JP+1)))#  QF81  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF81  96
#                                                                       QF81  97
#    LIST THE PARAMETER SHIFTS                                          QF81  98
#    -------------------------                                          QF81  99
XBAR=0.0 ; YBAR=0.0 ; ZBAR=0.0 ; BBAR=0.0#                              QF81 100
XAVG=0.0 ; YAVG=0.0 ; ZAVG=0.0 ; BAVG=0.0 ; POPAVG=0.0 ; POPMAG=0.0#    QF81 101
BMEAN=0.0 ; PANG=0.0 ; SANG=0.0 ; BANG=0.0#                             QF81 102
K=2 ; DO N=1,NA#                                                        QF81 103
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF81 104
KP=(K-1)*STEPU+MARKU#                                                   QF81 105
XBAR=XBAR+QX(KP+1)**2 ; YBAR=YBAR+QX(KP+2)**2 ; ZBAR=ZBAR+QX(KP+3)**2#  QF81 106
XAVG=XAVG+QX(KP+1)    ; YAVG=YAVG+QX(KP+2)    ; ZAVG=ZAVG+QX(KP+3)#     QF81 107
K=K+3#                                                                  QF81 108
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF81 109
IF(TFTYPE!=0)#                                                          QF81 110
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF81 111
IF(TFTYPE==1)#                         For isotropic temp facts         QF81 112
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF81 113
IAP=MARKA-STEPA ; DO IA=1,NA#          Loop over all atoms              QF81 114
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF81 115
#  BMEAN=BMEAN+BETA(IA,IE)#                                             QF81 116
IAP=IAP+STEPA ; BMEAN=BMEAN+QX(IAP+5)#                                  QF81 117
BMEAN=BMEAN#                           Needs fixing!!!!!!!!!!!!!!!!!!   QF81 118
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF81 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF81 120
ELSE IF(TFTYPE==2)#                    For anisotropic temp facts       QF81 121
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF81 122
IAP=MARKA-STEPA ; DO IA=1,NA#          Loop over all atoms              QF81 123
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF81 124
#  BMEAN=BMEAN+BETA(IA,IE)#                                             QF81 125
IAP=IAP+STEPA ; BMEAN=BMEAN+QX(IAP+5)# Needs fixing!!!!!!!!!!!!!!!!!!   QF81 126
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF81 127
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF81 128
NP=STEPV*(IATMN-1)+MARKV ; NPP=STEPU*(IATMN-1)+MARKU ; DO I=1,NBET#     QF81 129
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF81 130
N=IATMN+I ; NP=NP+STEPV ; NPP=NPP+STEPU#                                QF81 131
BBAR=BBAR+QX(NPP+1)**2;BAVG=BAVG+QX(NPP+1);BANG=BANG+QX(NP+1)**2#       QF81 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF81 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF81 134
#                                                                       QF81 135
IQZERO=NA-NOCC; NPA=MARKA-STEPA; DO N=1,NA# Look at all atom shifts     QF81 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF81 137
#DVA=DV(3*N-1)*AEDGE ; DVB=DV(3*N  )*BEDGE ; DVC=DV(3*N+1)*CEDGE#       QF81 138
NPU=3*(N-1)+MARKU ; NPA=NPA+STEPA#                                      QF81 139
DVA=QX(NPU+2)*AEDGE ; DVB=QX(NPU+3)*BEDGE ; DVC=QX(NPU+4)*CEDGE#        QF81 140
#SVA=V(3*N-1)*AEDGE ; SVB=V(3*N  )*BEDGE ; SVC=V(3*N+1)*CEDGE#          QF81 141
NPV=3*(N-1)+MARKV#                                                      QF81 142
SVA=QX(NPV+2)*AEDGE ; SVB=QX(NPV+3)*BEDGE ; SVC=QX(NPV+4)*CEDGE#        QF81 143
DVP=DVA**2+DVB**2+DVC**2+2.0*(DVB*DVC*CA+DVA*DVC*CB+DVA*DVB*CG)#        QF81 144
SVP=SVA**2+SVB**2+SVC**2+2.0*(SVB*SVC*CA+SVA*SVC*CB+SVA*SVB*CG)#        QF81 145
PANG=PANG+DVP; SANG=SANG+SVP; DVP=SQRT(ABS(DVP)); SVP=SQRT(ABS(SVP))#   QF81 146
IF(LISTA==0) NEXT#                                                      QF81 147
ELSE IF(LISTA>1)IPRNT=0#                                                QF81 148
ELSE IPRNT=1#                                                           QF81 149
# PUT X, Y, & Z SHIFTS IN PRINT BUFFER                                  QF81 150
BUFOT(1)=FLOAT(N) ; BUFOT(2)=DVA ; BUFOT(3)=DVB ; BUFOT(4)=DVC#         QF81 151
BUFOT(5)=DVP ; BUFOT(6)=SVP#                                            QF81 152
movertoc:(QX(NPA+8),1,CHROT,7,9,0)#    Get atom name for list           QF81 153
IF(DVP>=DVPCUT) IPRNT=1#                                                QF81 154
IF(TFTYPE==1)#                         Individual isotropic b's         QF81 155
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF81 156
BUFOT(7)=QX(MARKU+IATMN+N)#            Isotropic t.f. shifts for prin   QF81 157
BUFOT(8)=QX(MARKV+IATMN+N) ; BUFOT(9)=QX(NPA+5)# Sigma and b itself     QF81 158
# TEST IF THE SHIFT IS BIG ENOUGH TO WARRENT A BLATHER                  QF81 159
IF(ABS(QX(MARKU+IATMN+N))/AMAX1(0.01,QX(NPA+5))>=DBCUT) IPRNT = 1#      QF81 160
IF(NOCC>0&QX(NPA+6)>0.0)#              Is population refined?           QF81 161
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF81 162
M=N-IQZERO#                                                             QF81 163
POPMAG=POPMAG+ABS(QX(MARKU+M+IBETN))#  Build magnitude of pop shifts    QF81 164
POPAVG=POPAVG+QX(MARKU+M+IBETN)#       Build statistic on pop shifts    QF81 165
# TEST IF POPULATION PARAMETER SHIFT SHOULD BE REPORTED                 QF81 166
IF(ABS(QX(MARKU+M+IBETN))/AMAX1(0.01,ABS(QX(NPA+6)))>=DQCUT) IPRNT = 1# QF81 167
#                                                                       QF81 168
IF(IPRNT==0) NEXT#                     Test for printing 'on'           QF81 169
BUFOT(10)=QX(MARKU+IBETN+M)#           Population param shift to prin   QF81 170
BUFOT(11)=QX(MARKV+IBETN+M) ; BUFOT(12)=ABS(QX(NPA+6))# Sigma & pp      QF81 171
ncodefld:(BUFOT,1,CHROT,FM650,12)#                                      QF81 172
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF81 173
#                                                                       QF81 174
ELSE#                                  No population parameter          QF81 175
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF81 176
IF(IPRNT==0) NEXT#                     Test for printing 'on'           QF81 177
ncodefld:(BUFOT,1,CHROT,FM650,9)#                                       QF81 178
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF81 179
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF81 180
ELSE IF(TFTYPE>=2)#                    Ind. anisotropic b's             QF81 181
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF81 182
BUFOT(8)=QX(MARKU+IATMN+3*N-2)#        Aniso t.f. shifts ***obsolete*   QF81 183
BUFOT(10)=QX(MARKU+IATMN+3*N-1) ; BUFOT(7)=QX(NPA+5)# ***obsolete**     QF81 184
BUFOT(12)=QX(MARKU+IATMN+3*N)#         ***obsolete**                    QF81 185
BUFOT(11)=QX(NPA+7) ; BUFOT(9)=ABS(QX(NPA+6))# ***obsolete**            QF81 186
DO I=1,3#                              ***obsolete**                    QF81 187
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QF81 188
ADELB=ABS(QX(MARKV+3*N+IATMN+I-3))#    ***obsolete**                    QF81 189
IF(ADELB/QX(NPA+4+I)>=DBCUT) IPRNT=1#  ***obsolete**                    QF81 190
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QF81 191
IF(NOCC>0&QX(NPA+6)>0.0)#              Is population refined?           QF81 192
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QF81 193
POPMAG=POPMAG+ABS(QX(MARKU+M+IBETN))#  Build magnitude of pop shifts    QF81 194
POPAVG=POPAVG+QX(MARKU+M+IBETN)#       Build statistic on pop shifts    QF81 195
# TEST IF POULATION SHIFT WARRENTS REPORTING                            QF81 196
IF(ABS(QX(MARKU+IBETN+M))/AMAX1(0.01,ABS(QX(NPA+6)))>=DQCUT) IPRNT = 1# QF81 197
#                                                                       QF81 198
IF(IPRNT==0) NEXT#                     Test for printing 'on'           QF81 199
BUFOT(13)=QX(MARKU+IBETN+M)#           Pp shift to output               QF81 200
BUFOT(14)=QX(MARKV+IBETN+M) ; BUFOT(15)=ABS(QX(NPA+6))# Population pa   QF81 201
ncodefld:(BUFOT,1,CHROT,FM670,15)#                                      QF81 202
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QF81 203
ELSE#                                  No population parameter          QF81 204
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QF81 205
#                                                                       QF81 206
IF(IPRNT==0) NEXT#                     Test for printing 'on'           QF81 207
ncodefld:(BUFOT,1,CHROT,FM670,12)#     Anisotropic shifts only          QF81 208
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QF81 209
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF81 210
#                                                                       QF81 211
ELSE#                                  Overall b                        QF81 212
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QF81 213
IF(NOCC>0&QX(NPA+6)>0.0)#              Is population refined?           QF81 214
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QF81 215
POPMAG=POPMAG+ABS(QX(MARKU+M+IBETN))#  Build magnitude of pop shifts    QF81 216
POPAVG=POPAVG+QX(MARKU+M+IBETN)#       Build statistic on pop shifts    QF81 217
# TEST IF POULATION SHIFT WARRENTS REPORTING                            QF81 218
IF(ABS(QX(MARKU+IBETN+M))/AMAX1(0.01,ABS(QX(NPA+6)))>=DQCUT) IPRNT =1#  QF81 219
IF(IPRNT==0) NEXT#                     Test for printing 'on'           QF81 220
BUFOT(7)=QX(MARKU+IBETN+M)#            Pp shift to output               QF81 221
BUFOT(8)=QX(MARKV+IBETN+M) ; BUFOT(9)=ABS(QX(NPA+6))# Sig pop & pop     QF81 222
ncodefld:(BUFOT,1,CHROT,FM671,9)#                                       QF81 223
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QF81 224
ELSE#                                  No pop param for this guy        QF81 225
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QF81 226
IF(IPRNT==0) NEXT#                     Test for printing 'on'           QF81 227
ncodefld:(BUFOT,1,CHROT,FM650,6)#      X,y,z only overall isotropic     QF81 228
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QF81 229
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QF81 230
writeline:(0,QF81A,NQF81A,1,3)#        Print the atomic parameters      QF81 231
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF81 232
#                                                                       QF81 233
IF(NOCC>0)#                            If any atoms have pop params     QF81 234
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QF81 235
POPAVG=POPAVG/FLOAT(NOCC)#             Find average pp shift            QF81 236
POPMAG=POPMAG/FLOAT(NOCC)#             Find |average pp shift|          QF81 237
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QF81 238
XAVG=XAVG/FLOAT(NA) ; YAVG=YAVG/FLOAT(NA)#                              QF81 239
ZAVG=ZAVG/FLOAT(NA) ; BAVG=BAVG/FLOAT(MAX0(1,NBET))#                    QF81 240
IF(TFTYPE==0) BAVG=DT#                 Take overall shift               QF81 241
XANG=AEDGE*XAVG ; YANG=BEDGE*YAVG ; ZANG=CEDGE*ZAVG#                    QF81 242
BMEAN=BMEAN/FLOAT(MAX0(1,NBET)) ; IF(TFTYPE==0) BMEAN=TO#               QF81 243
#                                                                       QF81 244
# WRITE OUT MEAN SHIFTS FOR THIS RUN                                    QF81 245
# ----------------------------------                                    QF81 246
#                                                                       QF81 247
movechar:(BLANK,1,CHROT,1,mxchln:,1)#                                   QF81 248
movechar:(QF81A,13,CHROT,13,NQF81A-12,0)#                               QF81 249
writeline:(1,0,0,1,3)#                                                  QF81 250
BUFOT(1)=XAVG ; BUFOT(2)=YAVG ; BUFOT(3)=ZAVG# Fractional scale         QF81 251
BUFOT(4)=POPAVG#                       Average pop shift                QF81 252
ncodefld:(BUFOT,1,CHROT,FM686,4);movechar:(QF81D,1,CHROT,2,NQF81D,0)#   QF81 253
writeline:(1,QF81C,NQF81C,2,3)#                                         QF81 254
BUFOT(1)=XANG#                         Mean shifts on angstrom scale    QF81 255
BUFOT(2)=YANG ; BUFOT(3)=ZANG ; BUFOT(4)=BAVG ; BUFOT(5)=BMEAN#         QF81 256
ncodefld:(BUFOT,1,CHROT,FM685,5)#                                       QF81 257
movechar:(QF81E,1,CHROT,2,NQF81E,0) ; writeline:(0,0,0,1,3)##           QF81 258
XBAR=SQRT(ABS(XBAR/FLOAT(NA))) ; YBAR=SQRT(ABS(YBAR/FLOAT(NA)))#        QF81 259
ZBAR=SQRT(ABS(ZBAR/FLOAT(NA)))#                                         QF81 260
BBAR=SQRT(ABS(BBAR/FLOAT(MAX0(1,NBET))))#                               QF81 261
XANG=AEDGE*XBAR ; YANG=BEDGE*YBAR ; ZANG=CEDGE*ZBAR#                    QF81 262
PANG=SQRT(ABS(PANG/FLOAT(NA))) ; SANG=SQRT(ABS(SANG/FLOAT(NA)))#        QF81 263
BANG=SQRT(ABS(BANG/FLOAT(MAX0(1,NBET))))#                               QF81 264
# WRITE OUT RMS SHIFTS FOR THIS RUN                                     QF81 265
BUFOT(1)=XBAR ; BUFOT(2)=YBAR ; BUFOT(3)=ZBAR# Fractional shifts        QF81 266
BUFOT(4)=POPMAG#                       Population parameter             QF81 267
ncodefld:(BUFOT,1,CHROT,FM686,4);movechar:(QF81D,1,CHROT,2,NQF81D,0)#   QF81 268
writeline:(1,QF81F,NQF81F,2,3)#                                         QF81 269
BUFOT(1)=XANG#                         Angstrom basis                   QF81 270
BUFOT(2)=YANG ; BUFOT(3)=ZANG ; BUFOT(4)=PANG ; BUFOT(5)=SANG#          QF81 271
BUFOT(6)=BBAR ; BUFOT(7)=BANG#                                          QF81 272
ncodefld:(BUFOT,1,CHROT,FM690,7)#                                       QF81 273
movechar:(QF81E,1,CHROT,2,NQF81E,0) ; writeline:(0,0,0,1,3)##           QF81 274
#                                                                       QF81 275
BUFOT(1)=DK ; BUFOT(2)=QX(MARKU+1)#    Write out scale factor           QF81 276
movechar:(QF81H,1,CHROT,2,NQF81H,0)#                                    QF81 277
ncodefld:(BUFOT,1,CHROT,FM685,2) ; writeline:(1,QF81G,NQF81G,2,3)#      QF81 278
QX(MARKU+1)=QX(MARKU+1)+DK#            Dv(1)=dv(1)+dk store new scale   QF81 279
#                                                                       QF81 280
BUFOT(1)=DT#                           Write out ovrl t.f. shift        QF81 281
movechar:(QF81I,1,CHROT,2,NQF81I,0)#                                    QF81 282
ncodefld:(BUFOT,1,CHROT,FM685,1) ; writeline:(0,0,0,1,3)#               QF81 283
#                                                                       QF81 284
IF(REPORT==no:\IDALIZ==yes:)#                                           QF81 285
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QF81 286
#     THE FOLLOWING IS HALF TRANSLATED.  NEEDS WORK!!!!!!!!!!!!!!!!     QF81 287
#     IF(TFTYPE.EQ.2) CALL QF82(0,B11,B22,B33,B12,B13,B23)# BCNVRT      QF81 288
OCCNCY = 1.0#                                                           QF81 289
IP=MARKA-STEPA ; DO I=1,NA#                                             QF81 290
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QF81 291
IP=IP+STEPA ; XANG=AEDGE*QX(IP+1)#                                      QF81 292
YANG=BEDGE*QX(IP+2) ; ZANG=CEDGE*QX(IP+3)#                              QF81 293
IF(NOCC>0) OCCNCY=ABS(QX(IP+6))#       Get population parameter         QF81 294
IF(TFTYPE<2)#                          Test if isotropic                QF81 295
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QF81 296
BOUT=QX(IP+5)#                         Get temperature factor           QF81 297
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QF81 298
ELSE IF(TFTYPE==2)#                    Test if anisotropic              QF81 299
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 QF81 300
# NOT COMPLETE******************************************************    QF81 301
#     BOUT = (BETA(I,1) + BETA(I,2) + BETA(I,3))/3                      QF81 302
#     CALL QF82(I,B11,B22,B33,B12,B13,B23)#     BCNVRT                  QF81 303
#     WRITE(IXYZB) I,ATOM(I),XANG,YANG,ZANG,BOUT,OCCNCY,                QF81 304
#    $     BETA(I,1),BETA(I,2),BETA(I,3),B11,B22,B33,B12,B13,B23        QF81 305
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 QF81 306
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QF81 307
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QF81 308
#                                                                       QF81 309
RETURN#                                                                 QF81 310
END#                                                                    QF81 311
systemheader:(QF82)## Convert temperature factors                       QF82   1
####################################################################    QF82   2
#                                                                  #    QF82   3
#                                QF82                              #    QF82   4
#                                                                  #    QF82   5
####################################################################    QF82   6
SUBROUTINE QF82(IA,QB11,QB22,QB33,QB12,QB13,QB23)#                      QF82   7
#     SUBROUTINE BCNVRT(IA,B11,B22,B33,B12,B13,B23)                     QF82   8
#                                       W. hendrickson                  QF82   9
include:(AACOMN)#                                                       QF82  10
include:(QFCOMN)#                                                       QF82  11
INTEGER IA,IAA#                        Pointer to atom                  QF82  12
INTEGER I,IE,J,K,L#                    Loop indicies                    QF82  13
REAL QB11,QB22,QB33,QB12,QB13,QB23#    Aniso t.f.s                      QF82  14
REAL Q(3,3),Z(3,3)#                    Temporary arrays                 QF82  15
#                                                                       QF82  16
#     INITIALIZE THE ORTHOGONALIZATION MATRIX                           QF82  17
#     ---------------------------------------                           QF82  18
#                                                                       QF82  19
IF(IA==0)#                                                              QF82  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF82  21
Q(1,1)=0.5*QXH;Q(1,2)=0.0;Q(1,3)=0.0;Q(2,1)=0.5*QYH;Q(2,2)=0.5*QYK#     QF82  22
Q(2,3)=0.0 ; Q(3,1)=0.5*QZH ; Q(3,2)=0.5*QZK ; Q(3,3)=0.5*QZL#          QF82  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF82  24
ELSE#                                                                   QF82  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF82  26
#                                                                       QF82  27
#     CONVERT THIS SET OF PRINCIPLE-AXES B'S TO CRYSTAL-AXES BETA'S     QF82  28
#     -------------------------------------------------------------     QF82  29
#                                                                       QF82  30
IAA=(IA-1)*STEPE+MARKE ; DO I=1,3 ; DO J=I,3#                           QF82  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF82  32
Z(I,J)=0.0 ; DO K=1,3 ; DO L=1,3 ; DO IE=1,3#                           QF82  33
#    Z(I,J)=Z(I,J)+BETA(IA,IE)*E(IA,K,IE)*E(IA,L,IE)*Q(K,I)*Q(L,J)      QF82  34
#THIS IS UNDOUBTEDLY NOT RIGHT!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! QF82  35
Z(I,J)=Z(I,J)+QX(IAA+IE)*QX(IAA+K+IE-1)*QX(IAA+L+IE-1)*Q(K,I)*Q(L,J)#   QF82  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF82  37
QB11=Z(1,1) ; QB12=Z(1,2) ; QB13=Z(1,3)#                                QF82  38
QB22=Z(2,2) ; QB23=Z(2,3) ; QB33=Z(3,3)#                                QF82  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF82  40
RETURN#                                                                 QF82  41
END#                                                                    QF82  42
systemheader:(QF83)## Update BDF with new atom coordinates              QF83   1
####################################################################    QF83   2
#                                                                  #    QF83   3
#                                QF83                              #    QF83   4
#                                                                  #    QF83   5
####################################################################    QF83   6
SUBROUTINE QF83#                                                        QF83   7
#                                        J.m. stewart feb. 1989         QF83   8
include:(AACOMN)#                                                       QF83   9
include:(QFCOMN)#                                                       QF83  10
#                                                                       QF83  11
#                                                                       QF83  12
#  READ IN THE ATOMIC COORDINATES FROM FILE C, ADD SHIFTS TO            QF83  13
#  THE ORIGINAL COORDINATES, AND PUT THEM OUT IN FILE B AND ON          QF83  14
#  THE "PUNCH" IN PROTEIN DATA BANK, PDB, FORM.                         QF83  15
#  -----------------------------------------------------------          QF83  16
#                                                                       QF83  17
#                                                                       QF83  18
# THE PURPOSE OF THIS ROUTINE IS TO UPDATE THE BDF WITH THE CORRECTED   QF83  19
# ATOMIC PARAMETERS AND TO PRINT AND/OR PUNCH THE ATOM                  QF83  20
# PARAMETERS IN PROTEIN DATA BANK FORM.  BERNSTEIN ET.AL.               QF83  21
# J. MOL. BIOL. 112, 535-42 (1977).                                     QF83  22
# THE FORMATS USED HERE ARE TAKEN FROM THE AUGUST 1985 INTODUCTION.     QF83  23
#                                                                       QF83  24
# THIS CODE WAS TAKEN LARGELY FROM SUBROUTINE PD91 (PROATM)             QF83  25
# THE OUTPUT MAY CONSIST OF THE FOLLOWING ITEMS GIVEN HERE IN THE       QF83  26
# ORDER DEFINED IN THE DATA STATEMENTS OF ROUTINE PD11.  SHOWN ARE      QF83  27
# THE SEQUENCE NUMBER FROM PD11, THE MNEMONIC FROM PD11, THE BINARY     QF83  28
# DATA FILE PACKET NUMBER, FOLLOWED IN A FEW CASES BY CHARACTER         QF83  29
# POSITIONS WITHIN BUFFER WORDS, THE PRINT FORMAT USED IN QF83 IN       QF83  30
# XTAL NCODEFLD NOTATION, AND A SHORT DESCRIPTION OF THE QUANTITY.      QF83  31
#                                                                       QF83  32
# NO. MNEM PKT ID FMT      DESCRIPTION                                  QF83  33
#  1  X      1     460832. X FRACT IN FILE ORTH ANG IN PDB              QF83  34
#  2  Y      2     550832. Y                                            QF83  35
#  3  Z      3     640832. Z                                            QF83  36
#  4  U      4     760632. B IN BDF U   IN PDB DEPENDING ON OPTION      QF83  37
#     B            760612. IF B USED IN PDB                             QF83  38
#  5  U11    5     930713. BETA 11 IN BDF U 11 IN FILE                  QF83  39
#  6  U22    6    1000713.      22                                      QF83  40
#  7  U33    7    1070713.      33                                      QF83  41
#  8  U12    8    1140713.      12                                      QF83  42
#  9  U13    9    1210713.      13                                      QF83  43
# 10  U23   10    1280713.      23                                      QF83  44
# 11  POP   11     700632. POPULATION PARAMETER OR OCCUPANCY            QF83  45
# 12  APP   12     850632. ANAOMOLUS POP PARAM, UNDEFINED IN PDB        QF83  46
# 13  RSQ   16,1-3 CH33-35 LEAST SIG DIGS RESIDUE SEQ NO.               QF83  47
# 13  RSQ   16,4   CH37    INSERTION OF RESIDUE CODE                    QF83  48
# 14  SEQ   15,1   CH21    REMOTNESS INDICATOR                          QF83  49
# 14  SEQ   15,2   CH22    BRANCH DESIGNATOR                            QF83  50
# 14  SEQ   15,3   CH      SUB-BRANCH DESIGNATOR(FOR H'S)               QF83  51
# 14  SEQ   15,4   CH24    ALTERNATE LOCATION INDICATOR                 QF83  52
# 15  SET   17     NOT O/P DATA SET TO WHICH ATOM BELONGS               QF83  53
# 16  CHN   18,1-3 CH30    CHAIN IDENTIFIER UP TO 3 CHARS               QF83  54
#                          BUT LIMITED TO 1 BY PDB SPECS                QF83  55
# 16  CHN   18,4   CH32    MOST SIG DIG OF RESIDUE SEQUENCE NUMBER      QF83  56
# 17  SQN   20     150513. ATOM SERIAL NUMBER                           QF83  57
# 18  RES   19     CH26-28 RESIDUE NAME                                 QF83  58
# 19  SFT   22     NOT O/P SCATTERING FACTOR TYPE, OUTPUT IN ATOM NAME  QF83  59
# 20  TFT   23     NOT O/P ATOM TEMPERATURE FACTOR TYPE                 QF83  60
# 21  SX   101     460832. SIGMA X                                      QF83  61
# 22  SY   102     550832. SIGMA Y                                      QF83  62
# 23  SZ   103     640832. SIGMA Z                                      QF83  63
# 24  SPP  111     700632. SIGMA POP PARAM                              QF83  64
# 25  SU   104     760632. SIGMA U                                      QF83  65
#     SB   104     760612. SIGMA B IF REQUESTED BY BIS OPTION           QF83  66
# 26  SAP  112     850632. SIGMA ANOM POP PARAM                         QF83  67
# 27  SU1  105     930713. SIGMA U11 OR BETA 11 DEPENDING ON PLACE      QF83  68
# 28  SU2  106    1000713.        22                                    QF83  69
# 29  SU3  107    1070713.        33                                    QF83  70
# 30  SU4  108    1140713.        12                                    QF83  71
# 31  SU5  109    1210713.        13                                    QF83  72
# 32  SU6  110    1280713.        23                                    QF83  73
#                                                                       QF83  74
#                                                                       QF83  75
INTEGER ANOFF,SANOFF## Aniso tf and sigma offset                        QF83  76
INTEGER ANYSIG#    ## Signal if any sigmas in bdf                       QF83  77
string:(ATMBUF,132)## Buffer for atomic parameters                      QF83  78
REAL    BTOBET(6)# ## B to beta conversion factors                      QF83  79
REAL    CELPD(6)#  ## Direct unit cell parameters                       QF83  80
string:(CURRES,5)# ## Current residue                                   QF83  81
REAL    CVOL#      ## Unit cell volume                                  QF83  82
INTEGER DOP(43)#   ## Signal word showing which parameters from input   QF83  83
REAL   FTORTH(12)# ## Fractional to orthognal atom coordinates          QF83  84
INTEGER HIT#       ## Flag for use with compchar: macro                 QF83  85
INTEGER HETAT#     ## Signal for hetero-atoms                           QF83  86
INTEGER I,J,K,M,L# ## Index registers                                   QF83  87
INTEGER IATM#      ## Pointer into marka array of QX, atom parameters   QF83  88
REAL INDEXP(43)#   ## INDEX NUMBERS OF LRATOM, EXCEPT 14, ATOM ID       QF83  89
INTEGER INORTH#    ## Signal loading of orthogonalization matrix        QF83  90
INTEGER IPOP#      ## pointer to vector elements for population param   QF83  91
INTEGER LPAK,IP,JPT,IR(6),IPR#         For file reading /writing        QF83  92
INTEGER LX,LY,LZ#  ## X,y,z pointers                                    QF83  93
INTEGER MAXLEN#    ## Maximum length of an output line                  QF83  94
INTEGER MX24#      ## Maximum number of words to hold 24 characters     QF83  95
INTEGER NATOM,NPTP## Pointers to atoms                                  QF83  96
INTEGER NCSFN(16)# ## Number of characters in each scat fac name        QF83  97
INTEGER NRESID#    ## Total number of residues encountered              QF83  98
INTEGER NSFMX#     ## Number of characters in longest scat fac name     QF83  99
INTEGER NSFNAM#    ## Total number of characters in the sf name tbl     QF83 100
INTEGER NSFTOT#    ## Total number of scattering factor types           QF83 101
INTEGER ONRES#     ## Count of residues                                 QF83 102
REAL   ORTHTF(12)# ## Orthogonal to fractional atom coordinates         QF83 103
REAL   PDBTFC(3)#  ## Conversion from aniso to iso ala prot dat base    QF83 104
INTEGER PMAXP#     ## Maximum possible number of different parameter    QF83 105
#                  ## per atom.                                         QF83 106
INTEGER PSIZ,IPO,KEY(4),IWNT(10),IREL(11)## Bdf i/o control             QF83 107
string:(PUNBUF,80)## Buffer for punch lines                             QF83 108
REAL Q#            ## Population parameter                              QF83 109
INTEGER RELBDF(44)## Offsets for input bdf packets                      QF83 110
string:(RESCHK,5)# ## CHECK RESIDUE SERIAL NO. & INSERTION CODES        QF83 111
string:(RESCOD,4)# ## Current residue code                              QF83 112
REAL SCP(64)## Scale factor pointers                                    QF83 113
string:(SFNAME,96)## Array of scat factor names 6 ch/name               QF83 114
string:(SIGBUF,132)## Buffer for sigmas of atomic parameters            QF83 115
INTEGER SLAVPT#    ## Pointer to slave flag                             QF83 116
INTEGER STEPR#     ## Number of words per residue record packet         QF83 117
REAL    TFCON(18)# ## First six give beta to uij by multiply            QF83 118
#                  ## second six; beta to bij                           QF83 119
#                  ## third beta to beta                                QF83 120
INTEGER WNTBDF(43)## Want list for input bdf                            QF83 121
REAL    X(9)#       ## Temporary param store                            QF83 122
REAL    XF,YF,ZF,BISO,POPQ## Atomic parameters, local for buffering     QF83 123
#                                                                       QF83 124
#  THE FOLLOWING DATA STATEMENT DEFINES THE ATOM PARAMETERS             QF83 125
#  LOADED BY =PROATM= AND THE ORDER THAT VARIABLES ARE STORED           QF83 126
#  IN THE EXPANDED INTERMEDIATE BUFFERS.  ALL ACTIVITY OF WHAT          QF83 127
#  DATA ITEMS ARE PLACED IN THE OUTPUT BDF IS CONTROLLED BY             QF83 128
#  YES: AND NO: FLAGS IN THE ARRAY 'DOP' (DO PARAMETER).                QF83 129
#                                                                       QF83 130
#CHARDATA:(PD15,X  Y  Z  U  U1 U2 U3 U4 U5 U6 POPAPPRSQSEQSETCHNSQN$#   QF83 131
#RESSFTTFTSX SY SZ SPPSU SAPSU1SU2SU3SU4SU5SU6)#                        QF83 132
#  THE FOLLOWING ARRAY GIVES THE INDEX NUMBERS OF LRATOM: IN            QF83 133
#  THE SAME ORDER.                                                      QF83 134
realdata:(DEXNUM,[1.,2.,3.,4.,5.,6.,7.,8.,9.,10.,11.,12.,#              QF83 135
16.,15.,17.,18.,20.,19.,22.,23.,101.,102.,103.,111.,104.,112.,#         QF83 136
105.,106.,107.,108.,109.,110.])#                                        QF83 137
# NOTE THAT THE ITEMS DESIGNATED RES, SEQ, CHN, SQN, AND RES ARE DUE    QF83 138
# TO THE PROTEIN DATA BANK REQUIREMENTS.                                QF83 139
#                                                                       QF83 140
intdata:(NINPAR,32)#                                                    QF83 141
#                                                                       QF83 142
# THE FOLLOWING TABLES ARE SET TO ALLOW THE COMPRESSION OF              QF83 143
# THE PRINT OUTPUT BUFFERS INTO THE PDF PUNCH LINES                     QF83 144
#                                                                       QF83 145
intdata:(FROM,[11,19,24,26,30,32,37,39,48,57,65,71,77,87,94,$#          QF83 146
101,108,115,122])#                                                      QF83 147
intdata:(TQ,  [ 7,13,17,18,22,23,27,31,39,47,55,61,68,29,36,$#          QF83 148
 43, 50, 57, 64])#                                                      QF83 149
intdata:(NUMB,[ 5, 4, 1, 3, 1, 4, 1, 8, 8, 8, 6, 6, 3, 7, 7,$#          QF83 150
  7,  7,  7,  7])#                                                      QF83 151
intdata:(SIGLIN,[21])#                                                  QF83 152
intdata:(ATMVOI,no:)#                                                   QF83 153
realdata:(SERNUM,[0])#                                                  QF83 154
realdata:(FMT,[460832.,550832.,640832.,760632.,930713.,1000713.,$#      QF83 155
1070713.,1140713.,1210713.,1280713.,700632.,850632.,0.,0.,0.,0.,$#      QF83 156
150513.,0.,0.,0.,460832.,550832.,640832.,700632.,760632.,$#             QF83 157
850632.,930713.,1000713.,1070713.,1140713.,1210713.,1280713.])#         QF83 158
realdata:(FMTS,[60213.,230632.,330632.,490632.,660632.])#               QF83 159
chardata:(QF83A, ATOM ID    SER   NAME A RES C RSEQ I   $#              QF83 160
X ORTH   Y ORTH   Z ORTH   POP    U   FN   APP    $#                    QF83 161
U11    U22    U33    U12    U13    U23)#                                QF83 162
chardata:(QF83B,[HT])#                 Heteroatom signal                QF83 163
chardata:(QF83C,[ATOM  ])#             Protein data bank line names     QF83 164
chardata:(QF83D,[HETATM])#                                              QF83 165
chardata:(QF83E,[SIGATM])#                                              QF83 166
chardata:(QF83F,[ANISOU])#                                              QF83 167
chardata:(QF83G,[SIGUIJ])#                                              QF83 168
chardata:(QF83H, NO ATOMS IN BINARY DATA FILE )#                        QF83 169
chardata:(QF83K,         RESIDUES COUNTED DURING LOADING OF ATOMS.)#    QF83 170
chardata:(QF83L, TABLE OF RESIDUE NUMBERS, INSERTION CODES, AND $#      QF83 171
NAMES.)#                                                                QF83 172
chardata:(QF83M, UPDATED OVERALL B = XXX.XX  U = X.XXXXX  )#            QF83 173
chardata:(QF83S, INPUT OVERALL   B = XXX.XX  DELTA B = XXX.XXX )#       QF83 174
chardata:(QF83N,[ GROUP   INPUT FC SCALE     SHIFT    NEW FC $#         QF83 175
SCALE   NEW FREL SCALE])#                                               QF83 176
chardata:(QF83P,REMARK UPDATED COORDINATES FROM PROLSQ  XXXXXXXX $#     QF83 177
AT XXXXXXXX ON XXX )#                                                   QF83 178
chardata:(QF83Q,REMARK FOR COMPOUND WITH IDENTITY XXXXXX )#             QF83 179
chardata:(QF83Z, ** notice: PDB CONTAINS VOID ATOMIC COORDINATES-$#     QF83 180
WILL CAUSE ERROR IF PDB INPUT TO PROATM.)#                              QF83 181
chardata:(QF833,[ >>>>>>>>>>>>>>>>>>>>>>>> UPDATED PARAMETERS OF THE $# QF83 182
TRIAL STRUCTURE <<<<<<<<<<<<<<<<<<<<<<<<])#                             QF83 183
chardata:(QF835,[ GROUP  CURRENT FC   ESTIMATED FC  ESTIMATED FREL])#   QF83 184
chardata:(QF834,[ ESTIMATED SCALE FACTORS FROM $#                       QF83 185
SUM(FO*FC)/SUM(FC**2) FOR COMPARISON WITH LS RESULT SHOWN ABOVE])#      QF83 186
realdata:(FMT1Z,[60313.,180842.,330842.,490842.])#                      QF83 187
#                                                                       QF83 188
string:(DATE,8)#                                                        QF83 189
string:(TIME,8)#                                                        QF83 190
string:(MACH,3)#                                                        QF83 191
datastuff:#                                                             QF83 192
NATOM=0#                               Set count of atoms in bdf        QF83 193
MX24=incr:(arith:(23,/,mxchwd:))#      N0. of words to hold 24 char     QF83 194
INORTH=no:#                            Load coord orth'ization matrix   QF83 195
STEPR=MX24#                            Set step in words for residues   QF83 196
PMAXP=NINPAR#                          Set max no. atom parameters      QF83 197
#  SET UP "PUNCH" FILE BY MARKING WITH A REMARK LINE                    QF83 198
#  -------------------------------------------------                    QF83 199
#                                                                       QF83 200
IF(PNCHIT==yes:)#                      Test if user wants ascii file    QF83 201
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF83 202
movechar:(BLANK,1,PUNBUF,1,80,1)#      Blank out the buffer             QF83 203
movechar:(QF83P,1,PUNBUF,1,NQF83P,0)#  Set up remark line               QF83 204
getdate:(DATE) ; gettime:(TIME) ; movechar:(TITLE,53,MACH,1,3,0)#       QF83 205
movechar:(DATE,1,PUNBUF,41,8,0) ; movechar:(TIME,1,PUNBUF,53,8,0)#      QF83 206
movechar:(MACH,1,PUNBUF,65,3,0) ; writepch:(PUNBUF,80)#                 QF83 207
movechar:(BLANK,1,PUNBUF,1,80,1)#      Blank out the buffer again       QF83 208
movechar:(QF83Q,1,PUNBUF,1,NQF83Q,0)#  Put out compound id              QF83 209
movechar:(TITLE,9,PUNBUF,35,6,0) ; writepch:(PUNBUF,80)#                QF83 210
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF83 211
# B1ORU2 =1 IF B TEMP FACTS, =2 IF U TEMP FACTS OUTPUT                  QF83 212
IF(B1ORU2==1)#                         Were indiv b's to be output?     QF83 213
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF83 214
FMT(4)=760612.#                        Fmt for individ b in pdb         QF83 215
FMT(25)=760612.#                       Fmt for sig individ b in pdb     QF83 216
movechar:('B',1,QF83A,75,1,0)#         Change header on output          QF83 217
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF83 218
ANOFF=MX24+4 ; SANOFF=MX24+26#         Get offsets in dop array         QF83 219
ONRES=0#                               Zero residue count               QF83 220
movechar:(BLANK,1,CURRES,1,5,1)#       Blank out residue                QF83 221
movechar:(BLANK,1,RESCOD,1,4,1)#       Blank out residue code           QF83 222
#                                                                       QF83 223
#  TRANSFER THE LRATOM: INDEX PACKET NUMBERS TO A COMMON ARRAY          QF83 224
#  -----------------------------------------------------------          QF83 225
#                                                                       QF83 226
DO J=1,NINPAR ; INDEXP(J)=DEXNUM(J)#   Set the packet numbers           QF83 227
#                                                                       QF83 228
#                                                                       QF83 229
# SET UP TO INPUT BINARY DATA FILE FROM INPUT FILE C.                   QF83 230
# AND WRITE NEW FILE B                                                  QF83 231
# ---------------------------------------------------                   QF83 232
#                                                                       QF83 233
copyfile:(SCRBDF,OUTBDF,1,decr:(lrcell:))#                              QF83 234
#                                                                       QF83 235
#    PICK UP UNIT CELL PARAMETERS FOR T.F. CONVERSIONS LATER ON         QF83 236
#    ----------------------------------------------------------         QF83 237
J=0#                                                                    QF83 238
REPEAT#                                                                 QF83 239
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF83 240
readwpkt:(SCRBDF,lrcell:,LPAK,IP,0)#                                    QF83 241
IF(IP<=0) BREAK#                                                        QF83 242
writepkt:(OUTBDF,lrcell:,LPAK,JPT); movereal:(QX,IP+1,QX,JPT+1,LPAK,0)# QF83 243
J=J+1#                                                                  QF83 244
IF(J==1)#                                                               QF83 245
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF83 246
movereal:(QX,IP+1,CELPD,1,6,0)#                                         QF83 247
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF83 248
ELSE IF(J==3)#                         Watch for reciprocal cell fa     QF83 249
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF83 250
BTOBET(1)=0.25*QX(IP+1)**2#            Astar squared over four          QF83 251
BTOBET(2)=0.25*QX(IP+2)**2#            Bstar squared over four          QF83 252
BTOBET(3)=0.25*QX(IP+3)**2#            Cstar squared over four          QF83 253
BTOBET(4)=0.25*QX(IP+1)*QX(IP+2)*QX(IP+6)# A* b* cos(gamma*)/4          QF83 254
BTOBET(5)=0.25*QX(IP+1)*QX(IP+3)*QX(IP+5)#                              QF83 255
BTOBET(6)=0.25*QX(IP+2)*QX(IP+3)*QX(IP+4)#                              QF83 256
TFCON(1)=1.0/(PISQ8*BTOBET(1))#                                         QF83 257
TFCON(2)=1.0/(PISQ8*BTOBET(2))#                                         QF83 258
TFCON(3)=1.0/(PISQ8*BTOBET(3))#                                         QF83 259
TFCON(4)=4./(PISQ8*(QX(IP+1)*QX(IP+2)))# Leave out the cos(gamma*)      QF83 260
TFCON(5)=4./(PISQ8*(QX(IP+1)*QX(IP+3)))# Leave out the cos(beta*)       QF83 261
TFCON(6)=4./(PISQ8*(QX(IP+2)*QX(IP+3)))# Leave out the cos(alpha*)      QF83 262
PDBTFC(1)=QX(IP+1)*QX(IP+2)*CELPD(1)*CELPD(2)*CELPD(6)# A*b*abcos(g)    QF83 263
PDBTFC(2)=QX(IP+1)*QX(IP+3)*CELPD(1)*CELPD(3)*CELPD(5)# A*c*accos(b)    QF83 264
PDBTFC(3)=QX(IP+2)*QX(IP+3)*CELPD(2)*CELPD(3)*CELPD(4)# B*c*bccos(a)    QF83 265
#                                                                       QF83 266
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF83 267
ELSE IF(J==6)#                         Packet with misc cell data       QF83 268
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF83 269
CVOL=QX(IP+1)#                         Pick cell volume                 QF83 270
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF83 271
ELSE IF(J==9&INORTH==no:)#             Look for orth to fractional      QF83 272
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF83 273
DO K=1,9 ; ORTHTF(K)=QX(IP+K)#         Accept old values                QF83 274
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF83 275
ELSE IF(J==10&INORTH==no:)#            Last three elements              QF83 276
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF83 277
ORTHTF(10)=QX(IP+1);ORTHTF(11)=QX(IP+2);ORTHTF(12)=QX(IP+3)#            QF83 278
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF83 279
ELSE IF(J==11&INORTH==no:)#            Look for fractional to orth      QF83 280
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF83 281
DO K=1,9 ; FTORTH(K)=QX(IP+K)#         Or accept old values             QF83 282
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF83 283
ELSE IF(J==12&INORTH==no:)#            Last three elements              QF83 284
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF83 285
FTORTH(10)=QX(IP+1);FTORTH(11)=QX(IP+2);FTORTH(12)=QX(IP+3)#            QF83 286
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF83 287
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF83 288
copyfile:(SCRBDF,OUTBDF,incr:(lrcell:),decr:(lrscat:))# Advance files   QF83 289
IF(J<9&INORTH==no:) iquit:(QF9105)#    Must have transformations        QF83 290
DO J=1,MX24 ; WNTBDF(J)=14#            Xtal atom name                   QF83 291
M=MX24#                                Set to get anything else         QF83 292
DO J=1,PMAXP#                          Loop over all possible           QF83 293
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF83 294
M=M+1#                                                                  QF83 295
WNTBDF(M)=NINT(INDEXP(J))#             Set up want list                 QF83 296
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF83 297
#                                                                       QF83 298
#    PICK UP THE SCATTERING FACTOR NAMES FROM LRSCAT:                   QF83 299
#    ------------------------------------------------                   QF83 300
#                                                                       QF83 301
NSFTOT=0#                              Set count of sf types to zer     QF83 302
NSFMX=0#                               Set length of longest sf nam     QF83 303
J=1#                                   Set start of character table     QF83 304
IWNT(1)=11;IWNT(2)=1;IWNT(3)=2#        Set requests for lrscat:         QF83 305
KEY(1)=1;KEY(2)=3;KEY(3)=0;KEY(4)=0#   Set search limits                QF83 306
indexpkt:(SCRBDF,lrscat:,LPAK,IP,OUTBDF,KEY,IWNT,IR)# Read directory    QF83 307
IF(KEY(4)<=0) iquit:(QF9106)#          No form factors                  QF83 308
REPEAT#                                Read all of them                 QF83 309
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF83 310
readwpkt:(SCRBDF,lrscat:,LPAK,IP,0)#                                    QF83 311
IF(IP<=0) BREAK#                                                        QF83 312
writepkt:(OUTBDF,lrscat:,LPAK,JPT); movereal:(QX,IP+1,QX,JPT+1,LPAK,0)# QF83 313
NSFTOT=NSFTOT+1#                       Count up s.f. types              QF83 314
IPR=IP+IR(1)#                                                           QF83 315
movertoc:(QX(IPR),1,SFNAME,J,6,0)#                                      QF83 316
I=J#                                                                    QF83 317
FOR(K=1;K<=6;K=K+1)#                                                    QF83 318
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF83 319
compchar:(SFNAME,I,BLANK,1,1,1,1,HIT)# Look for the first blank         QF83 320
IF(HIT==0) I=I+1#                                                       QF83 321
ELSE BREAK#                                                             QF83 322
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF83 323
K=K-1#                                 Set actual count of characte     QF83 324
NSFMX=MAX0(NSFMX,K)#                                                    QF83 325
NCSFN(NSFTOT)=K#                                                        QF83 326
J=J+6#                                                                  QF83 327
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF83 328
NSFNAM=6*NSFTOT#                       Get total chars in all sfs       QF83 329
copyfile:(SCRBDF,OUTBDF,incr:(lrscat:),decr:(lrsequ:))# Move forward    QF83 330
#                                                                       QF83 331
# PUMP OUT THE SEQUENCE INFORMATION GARNERED IN PROATM                  QF83 332
# ----------------------------------------------------                  QF83 333
#                                                                       QF83 334
L=1 ; NRESID=0#                        Set pointer to sequence data     QF83 335
REPEAT#                                Loop over sequence information   QF83 336
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF83 337
readwpkt:(SCRBDF,lrsequ:,LPAK,IP,0)#                                    QF83 338
IF(IP<=0) BREAK#                                                        QF83 339
writepkt:(OUTBDF,lrsequ:,LPAK,JPT); movereal:(QX,IP+1,QX,JPT+1,LPAK,0)# QF83 340
movereal:(QX,IP+1,QX,NRESID*STEPR+MARKT+1,STEPR,0)#                     QF83 341
NRESID=NRESID+1#                                                        QF83 342
IF(L>120)#                             Twelve residues per line         QF83 343
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF83 344
L=1 ; writeline:(0,QF83L,NQF83L,1,4)#  Put out a line                   QF83 345
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF83 346
movertoc:(QX(IP+1),1,CHROT,L+1,8,0) ; L=L+10# Fill print line           QF83 347
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF83 348
writeline:(0,QF83L,NQF83L,1,4)#                                         QF83 349
BUFOT(1)=FLOAT(NRESID) ; ncodefld:(BUFOT,1,QF83K,70613.,1) ; L=1#       QF83 350
writeline:(0,QF83K,NQF83K,3,4)#        Tell how many residues           QF83 351
#                                                                       QF83 352
copyfile:(SCRBDF,OUTBDF,incr:(lrsequ:),decr:(lrexpl:))# Copy to expl    QF83 353
#                                                                       QF83 354
#   ENTER SCALE INFORMATION (LR LREXPL:)                                QF83 355
#   ------------------------------                                      QF83 356
#                                                                       QF83 357
IWNT(1)=1;   IWNT(2)=100#              Set data set & nscl idnums       QF83 358
KEY(1)=1;  KEY(2)=2;  KEY(3)=0#        Set search delimiters            QF83 359
KEY(4)=0#                              Set update mode                  QF83 360
indexpkt:(SCRBDF,lrexpl:,PSIZ,IP,OUTBDF,KEY,IWNT,IREL)# Get pointers    QF83 361
NSCL=1#                                Default no. of scale groups      QF83 362
FOR(I=IP+1;I<=IP+PSIZ;I=I+1)#          Loop over directory              QF83 363
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF83 364
IF((QX(I)<100.9)\(QX(I)>164.1)) NEXT#  Skip if not scale idnm           QF83 365
J=NINT(QX(I))-100#                     Get group number of scale        QF83 366
SCP(J)=FLOAT(I-IP)#                    Store relative position          QF83 367
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF83 368
REPEAT#                                Loop over data sets              QF83 369
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QF83 370
readwpkt:(SCRBDF,lrexpl:,PSIZ,IP,0)#   Get packet pointer               QF83 371
IF(IP<=0) BREAK#                       Exit after last packet           QF83 372
writepkt:(OUTBDF,lrexpl:,PSIZ,IPO)#    Get o/p buffer pointer           QF83 373
movereal:(QX,IP+1,QX,IPO+1,PSIZ,1)#    Copy the packet                  QF83 374
I=IP+IREL(1); IF(I==IP) NEXT#          Get index of data set no.        QF83 375
ifne:(DSNM,QX(I)) NEXT#                Skip unwanted data set           QF83 376
I=IP+IREL(2); IF(I>IP) NSCL=NINT(QX(I))# Number of scales               QF83 377
FOR(I=1;I<=NSCL;I=I+1)#                Loop over scale factors          QF83 378
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QF83 379
J=IPO+NINT(SCP(I))#                    Point to scale location          QF83 380
IF(J>IPO)#                             If a scale for this group        QF83 381
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QF83 382
QX(J)=1.0/(SC(I)+DK)#                  Store f(rel) scale in file       QF83 383
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QF83 384
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QF83 385
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QF83 386
#                                                                       QF83 387
#   ENTER OVERALL TEMPERATURE FACTOR INFORMATION (LR LRDSET:            QF83 388
#   --------------------------------------------------------            QF83 389
#                                                                       QF83 390
IWNT(1)=1;   IWNT(2)=2#                Set data set & t.f. idnums       QF83 391
KEY(1)=1;  KEY(2)=2;  KEY(3)=0#        Set search delimiters            QF83 392
KEY(4)=0#                              Set update mode                  QF83 393
indexpkt:(SCRBDF,lrdset:,PSIZ,IP,OUTBDF,KEY,IWNT,IREL)# Get pointers    QF83 394
REPEAT#                                Loop over data sets              QF83 395
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QF83 396
readwpkt:(SCRBDF,lrdset:,PSIZ,IP,0)#   Get packet pointer               QF83 397
IF(IP<=0) BREAK#                       Exit after last packet           QF83 398
writepkt:(OUTBDF,lrdset:,PSIZ,IPO)#    Get o/p buffer pointer           QF83 399
movereal:(QX,IP+1,QX,IPO+1,PSIZ,1)#    Copy the packet                  QF83 400
I=IP+IREL(1); IF(I==IP) NEXT#          Get index of data set no.        QF83 401
ifne:(DSNM,QX(I)) NEXT#                Skip unwanted data set           QF83 402
I=IPO+IREL(2)#                                                          QF83 403
IF(I>IPO) QX(I)=AMAX1(0.0,TO+DT)/PISQ8# Updated overall t.f. into bdf   QF83 404
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QF83 405
#                                                                       QF83 406
#  PRINT OUT UPDATED F RELATIVE SCALE FACTORS AND THE OVERALL T.F.      QF83 407
#  ---------------------------------------------------------------      QF83 408
#                                                                       QF83 409
LINRM=10 ; writeline:(1,QF833,NQF833,3,3)#                              QF83 410
BUFOT(1)=AMAX1(0.0,TO) ; ncodefld:(BUFOT,1,QF83S,270622.,1)#            QF83 411
BUFOT(1)=DT ; ncodefld:(BUFOT,1,QF83S,460732.,1)#                       QF83 412
writeline:(1,QF83S,NQF83S,3,3)#                                         QF83 413
BUFOT(1)=AMAX1(0.0,TO+DT) ; ncodefld:(BUFOT,1,QF83M,270622.,1)#         QF83 414
BUFOT(1)=AMAX1(0.0,TO+DT)/PISQ8 ; ncodefld:(BUFOT,1,QF83M,400852.,1)#   QF83 415
writeline:(1,QF83M,NQF83M,3,3)#                                         QF83 416
writeline:(1,QF83N,NQF83N,3,3)#                                         QF83 417
FOR(J=1;J<=NSCL;J=J+1)#                Loop over all scale groups       QF83 418
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QF83 419
BUFOT(1)=FLOAT(J) ; BUFOT(2)=SC(J) ; BUFOT(3)=DK ; BUFOT(4)=SC(J)+DK#   QF83 420
BUFOT(5)=1.0/AMAX1(0.001,(SC(J)+DK))#                                   QF83 421
ncodefld:(BUFOT,1,CHROT,FMTS,5) ; writeline:(0,0,0,1,3)#                QF83 422
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QF83 423
LINRM=5 ; writeline:(1,QF834,NQF834,3,3)# Est'ed scales for compariso   QF83 424
writeline:(0,QF835,NQF835,3,3)#        Report sum fo/sum fc scales      QF83 425
DO J=1,NSCL#                           Loop over all scale groups       QF83 426
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QF83 427
BUFOT(1)=FLOAT(J) ; BUFOT(2)=SC(J)#    Get group and present fc scale   QF83 428
BUFOT(3)=SCLEST*BUFOT(2) ; BUFOT(4)=1.0/AMAX1(0.001,BUFOT(3))# Get ne   QF83 429
ncodefld:(BUFOT,1,CHROT,FMT1Z,4) ; writeline:(0,0,0,1,3)#               QF83 430
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QF83 431
copyfile:(SCRBDF,OUTBDF,incr:(lrdset:),decr:(lratom:))# Go to lratom    QF83 432
#                                                                       QF83 433
WNTBDF(PMAXP+MX24+1)=215#              Need atom slave flag             QF83 434
KEY(1)=MX24; KEY(2)=PMAXP+MX24+1;KEY(3)=PMAXP+MX24+1;KEY(4)=0#          QF83 435
indexpkt:(SCRBDF,lratom:,LPAK,IP,OUTBDF,KEY,WNTBDF,RELBDF)# Get point   QF83 436
#                                                                       QF83 437
# ACCEPT THAT WHATS THERE IS WHATS TO BE DONE                           QF83 438
# -------------------------------------------                           QF83 439
#                                                                       QF83 440
M=MX24 ; DO J=1,PMAXP#                                                  QF83 441
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QF83 442
M=M+1 ; IF(RELBDF(M)>0) DOP(J)=yes:#   Set to do the parameters in bd   QF83 443
ELSE DOP(J)=no:#                                                        QF83 444
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QF83 445
#                                                                       QF83 446
IF(IP<=0)#                             Anything there?                  QF83 447
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QF83 448
writeline:(1,QF83H,NQF83H,3,1)#        Complain                         QF83 449
iquit:(QF8301)#                        Complain bitterly                QF83 450
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QF83 451
#                                                                       QF83 452
IF(TFTYPE>1) MAXLEN=NQF83A#            Mixed or anisotropic t.f.        QF83 453
ELSE MAXLEN=85#                        No anisotropic t.f.              QF83 454
ANYSIG=no:#                            Assume no sigmas                 QF83 455
DO J=SIGLIN,PMAXP#                     Loop over sigma data             QF83 456
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QF83 457
IF(DOP(J)==no:) NEXT#                                                   QF83 458
ANYSIG=yes: ; BREAK#                   Must do sigmas                   QF83 459
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QF83 460
writeline:(1,0,0,3,3)#                 Blank line                       QF83 461
LINRM=10#                              Force heading first atom         QF83 462
#                                                                       QF83 463
#  LOOP OVER ALL THE ATOMS IN LRATOM:                                   QF83 464
#  ----------------------------------                                   QF83 465
#                                                                       QF83 466
IPOP=0 ; IATM=MARKA-STEPA#             Set pop param & atom pointers    QF83 467
REPEAT#                                                                 QF83 468
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QF83 469
readwpkt:(SCRBDF,lratom:,LPAK,IP,0)#   Read atom packets from bdf       QF83 470
IF(IP<=0) BREAK#                       Quit when done                   QF83 471
NATOM=NATOM+1#                         Count an atom as coming in       QF83 472
IATM=IATM+STEPA#                       Advance atom array pointer       QF83 473
writepkt:(OUTBDF,lratom:,LPAK,JPT)#    Set up output pkt                QF83 474
movereal:(QX,IP+1,QX,JPT+1,LPAK,0)#    Move atoms to file b             QF83 475
SLAVPT=RELBDF(MX24+PMAXP+1)#           Pointer to slave flag in bdf     QF83 476
IF(SLAVPT>0)#                                                           QF83 477
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 QF83 478
IF( QX(IP+SLAVPT)==-9.) NEXT#          Not output slave atoms           QF83 479
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 QF83 480
HETAT=no:#                             Assume regular atom              QF83 481
movechar:(BLANK,1,ATMBUF,1,132,1)#     Clear line buffer                QF83 482
movechar:(BLANK,1,SIGBUF,1,132,1)#     Clear sigma line buffer          QF83 483
K=IP+RELBDF(1)#                        Point to xtal atom id            QF83 484
movertoc:(QX(K),1,ATMBUF,2,8,0)#       Move atom name                   QF83 485
compchar:(QF83B,1,ATMBUF,2,2,1,9,HIT)# Look for heteroatom signal       QF83 486
IF(HIT!=0)#                            Test if hetatom                  QF83 487
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 QF83 488
HETAT=yes: ; movechar:(QF83B,2,ATMBUF,16,1,1)# Flag it                  QF83 489
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 QF83 490
#                                                                       QF83 491
#  CONVERT THE ATOMIC PARAMETERS FROM XTAL STORAGE BASIS TO PDF BASIS   QF83 492
#  BUT, FIRST APPLY THE SHIFTS DETERMINED IN PROLSQ                     QF83 493
#  ------------------------------------------------------------------   QF83 494
#                                                                       QF83 495
LX=IP+RELBDF(MX24+1);LY=IP+RELBDF(MX24+2);LZ=IP+RELBDF(MX24+3)#         QF83 496
XF=QX(LX);YF=QX(LY);ZF=QX(LZ)#         Get old x,y,z                    QF83 497
IF(RELBDF(MX24+4)>0) BISO=PISQ8*QX(IP+RELBDF(MX24+4))# B from u         QF83 498
ELSE BISO=TO#                          Iso b                            QF83 499
IF(RELBDF(MX24+11)>0) POPQ=QX(IP+RELBDF(MX24+11));ELSE Q=1.0# Pop par   QF83 500
NPTP=(NATOM-1)*3+MARKU#                Get pointer into shift vector    QF83 501
IF(QX(LX)!=voidflg:)#                                                   QF83 502
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 QF83 503
QX(LX)=XF+DAMP(1)*QX(NPTP+2)#          Store away corrected x           QF83 504
QX(JPT+RELBDF(MX24+1))=QX(LX)#         In both input and output buffe   QF83 505
QX(LY)=YF+DAMP(2)*QX(NPTP+3)#          Then y                           QF83 506
QX(LZ)=ZF+DAMP(3)*QX(NPTP+4)#          And zed                          QF83 507
QX(JPT+RELBDF(MX24+2))=QX(LY) ; QX(JPT+RELBDF(MX24+3))=QX(LZ)#          QF83 508
IF(RELBDF(MX24+4)>0)#                  And is it in the bdf?            QF83 509
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 QF83 510
IF(TFTYPE==1)#                         Isotropic t. f. refined?         QF83 511
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 QF83 512
# SHIFT IND. ISOTROPIC B FACTORS BUT DO NOT LET THEM FALL BELOW 1.0!    QF83 513
QX(IP+RELBDF(MX24+4))=AMAX1(1.0,BISO+DAMP(4)*QX(IATMN+NATOM+MARKU))#    QF83 514
QX(JPT+RELBDF(MX24+4))=QX(IP+RELBDF(MX24+4))/PISQ8# Also to file b as   QF83 515
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 QF83 516
ELSE IF(SETISO==yes:)#                 Isotropic not refined; set ov?   QF83 517
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 QF83 518
QX(IP+RELBDF(MX24+4))=TO+DT#           Make a new individual isotropi   QF83 519
QX(JPT+RELBDF(MX24+4))=(TO+DT)/PISQ8#  Also as u forcing all to ov tf   QF83 520
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 QF83 521
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 QF83 522
IF(NOCC>0)#                            Any pop params refined?          QF83 523
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 QF83 524
IF(QX(IATM+6)>0.0&IPOP<NOCC)#          And this one is one of them      QF83 525
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 QF83 526
IPOP=IPOP+1#                           Advance pointer into vector      QF83 527
IF(RELBDF(MX24+11)>0)#                 And store, if in bdf, the pp     QF83 528
QX(IP+RELBDF(MX24+11))=AMAX1(0.0,POPQ+DAMP(5)*QX(MARKU+IBETN+IPOP))#    QF83 529
QX(JPT+RELBDF(MX24+11))=QX(IP+RELBDF(MX24+11))# And in file b           QF83 530
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 QF83 531
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 QF83 532
#                                                                       QF83 533
K=0 ; DO J=1,12,4#                     Convert fract to orthog          QF83 534
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 QF83 535
K=K+1#                                                                  QF83 536
X(K)=FTORTH(J  )*QX(LX)+FTORTH(J+1)*QX(LY)+$#                           QF83 537
     FTORTH(J+2)*QX(LZ)+FTORTH(J+3)#                                    QF83 538
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 QF83 539
QX(LX)=X(1) ; QX(LY)=X(2) ; QX(LZ)=X(3)# Back to orthogonal x,y,z       QF83 540
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 QF83 541
#                                                                       QF83 542
ELSE ATMVOI=yes:#                                                       QF83 543
IF(RELBDF(MX24+4)>0 & B1ORU2==2)#      Only convert indiv b back to     QF83 544
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 QF83 545
L=IP+RELBDF(MX24+4) ; QX(L)=QX(L)/PISQ8# Indiv u if requested           QF83 546
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 QF83 547
DO J=1,6#                              Betas back to u x 10e4           QF83 548
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 QF83 549
IF(RELBDF(J+ANOFF)>0&DOP(J+ANOFF)==yes:)# Make sure they're there       QF83 550
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 QF83 551
L=IP+RELBDF(J+ANOFF);QX(L)=QX(L)*TFCON(J)*10000.0# Pdb scaling          QF83 552
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 QF83 553
IF(RELBDF(J+SANOFF)>0&DOP(J+SANOFF)==yes:)# Sigmas too                  QF83 554
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 QF83 555
L=IP+RELBDF(J+SANOFF);QX(L)=QX(L)*TFCON(J)*10000.0# Pdb scaling         QF83 556
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 QF83 557
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 QF83 558
#                                                                       QF83 559
DO J=1,PMAXP#                          Loop over all parameters         QF83 560
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 QF83 561
## Despite serial number's existence in lratom:, renumber it for pdb    QF83 562
IF (J==17)#                            Atom serial number is a must     QF83 563
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 QF83 564
SERNUM=SERNUM+1#                       Just use sequential numbering    QF83 565
ncodefld:(SERNUM,1,ATMBUF,FMT(J),1)#   Put it out on atom line          QF83 566
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 QF83 567
ELSE IF(DOP(J)==yes:&RELBDF(MX24+J)>0)# Only dealing with whats ther    QF83 568
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 QF83 569
K=IP+RELBDF(J+MX24)#                   Point to item in input buffe     QF83 570
IF(FMT(J)>0)#                          Test that its a real item        QF83 571
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 QF83 572
IF(J<SIGLIN) ncodefld:(QX(K),1,ATMBUF,FMT(J),1)# An atom item           QF83 573
ELSE         ncodefld:(QX(K),1,SIGBUF,FMT(J),1)# A sigma item           QF83 574
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 QF83 575
ELSE IF(J==13)#                        Test for residue word            QF83 576
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 QF83 577
movertoc:(QX(K),1,ATMBUF,33,3,0)#      Move low resid seq no.           QF83 578
movertoc:(QX(K),4,ATMBUF,37,1,0)#      Insertion of residues code       QF83 579
movechar:(ATMBUF,33,RESCHK,2,3,0)#     Hold for residue check           QF83 580
movechar:(ATMBUF,37,RESCHK,5,1,0)#     Also insertion code              QF83 581
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 QF83 582
ELSE IF(J==14)#                        Sequence characters?             QF83 583
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 QF83 584
movertoc:(QX(K),1,ATMBUF,21,2,0)#      Remotness and branch             QF83 585
movertoc:(QX(K),4,ATMBUF,24,1,0)#      Alternate location               QF83 586
movertoc:(QX(K),3,ATMBUF,19,1,0)#      Sub-branch desinator on h atom   QF83 587
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 QF83 588
ELSE IF(J==16)#                        Chain id & most sig dig of res   QF83 589
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 QF83 590
IF(QX(K)!=0.0)#                        Ensure non-null values put out   QF83 591
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 QF83 592
movertoc:(QX(K),4,ATMBUF,37,1,0)#      Insertion of residue code        QF83 593
movechar:(ATMBUF,32,RESCHK,1,1,0)#     Save for check                   QF83 594
movertoc:(QX(K),1,ATMBUF,30,1,0)#      Chain identifier                 QF83 595
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 QF83 596
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 QF83 597
ELSE IF(J==18)#                        Is residue name in pkt?          QF83 598
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 QF83 599
movertoc:(QX(K),1,RESCOD,1,4,0)#       Pull out residue name            QF83 600
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 QF83 601
ELSE IF (J==19)#                       Scattering factor type           QF83 602
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 QF83 603
L=NINT(QX(K))#                         Get s.f. pointer                 QF83 604
IF(NCSFN(L)==1) movechar:(SFNAME,(L-1)*6+1,ATMBUF,20,1,0)#              QF83 605
ELSE           movechar:(SFNAME,(L-1)*6+1,ATMBUF,19,2,0)#               QF83 606
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 QF83 607
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 QF83 608
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 QF83 609
#                                                                       QF83 610
#  PICK UP RESIDUE NAME FROM LRSEQU: IN MARKT ARRAY                     QF83 611
#  ------------------------------------------------                     QF83 612
#                                                                       QF83 613
compchar:(RESCHK,1,CURRES,1,5,5,5,HIT)# Watch for change in seq         QF83 614
IF(HIT==0)#                            No match = change                QF83 615
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 QF83 616
J=ONRES*STEPR+MARKT#                                                    QF83 617
ONRES=ONRES+1#                                                          QF83 618
movertoc:(QX(J+1),1,RESCOD,1,4,0)#     Recall residue code              QF83 619
movechar:(RESCHK,1,CURRES,1,5,0)#      Remember the new seq no.         QF83 620
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 QF83 621
movechar:(RESCOD,1,ATMBUF,26,4,0)#     Copy res code to print           QF83 622
#                                                                       QF83 623
#  PRINT LINES PREPARED, PRINT SIGMAS RIGHT UNDER CORRESPONDING PARAMS  QF83 624
#  -------------------------------------------------------------------- QF83 625
#                                                                       QF83 626
IF(LISTA==1)#                          Are we printing?                 QF83 627
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 QF83 628
movechar:(ATMBUF,1,CHROT,1,MAXLEN,0)#                                   QF83 629
writeline:(0,QF83A,MAXLEN,1,3)#                                         QF83 630
IF(ANYSIG==yes:)#                                                       QF83 631
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 QF83 632
movechar:(SIGBUF,1,CHROT,1,MAXLEN,0)#                                   QF83 633
writeline:(0,QF83A,MAXLEN,1,3)#                                         QF83 634
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 QF83 635
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 QF83 636
#                                                                       QF83 637
#  NOW IS THE TIME TO PUNCH OUT THE PROTEIN DATA BANK                   QF83 638
#  --------------------------------------------------                   QF83 639
#                                                                       QF83 640
IF(PNCHIT==yes:)#                      Is it?                           QF83 641
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 QF83 642
movechar:(ATMBUF,1,SIGBUF,1,37,0)#     Get the common stuff across      QF83 643
movechar:(BLANK,1,PUNBUF,1,80,1)#      Clear the punch buffer           QF83 644
IF(HETAT==no:) movechar:(QF83C,1,PUNBUF,1,NQF83C,0)# Atom               QF83 645
ELSE           movechar:(QF83D,1,PUNBUF,1,NQF83D,0)# Hetatm             QF83 646
DO L=1,13 ; movechar:(ATMBUF,FROM(L),PUNBUF,TQ(L),NUMB(L),0)# Squish    QF83 647
writepch:(PUNBUF,80)#                  Send data for atom or hetatm     QF83 648
IF(ANYSIG==yes:)#                                                       QF83 649
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 QF83 650
movechar:(BLANK,1,PUNBUF,1,80,1)#      Reclear the punch buffer         QF83 651
movechar:(QF83E,1,PUNBUF,1,NQF83E,0)#  Sigatm                           QF83 652
DO L=1,13 ; movechar:(SIGBUF,FROM(L),PUNBUF,TQ(L),NUMB(L),0)#           QF83 653
writepch:(PUNBUF,80)#                  Send data for sigatm             QF83 654
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 QF83 655
IF(TFTYPE>1)#                          Any aniso?                       QF83 656
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 QF83 657
movechar:(BLANK,1,PUNBUF,1,80,1)#      Clear it again                   QF83 658
movechar:(QF83F,1,PUNBUF,1,NQF83F,0)#  Anisou                           QF83 659
DO L=1,7 ; movechar:(ATMBUF,FROM(L),PUNBUF,TQ(L),NUMB(L),0)#            QF83 660
DO L=14,19 ; movechar:(ATMBUF,FROM(L),PUNBUF,TQ(L),NUMB(L),0)#          QF83 661
writepch:(PUNBUF,80)#                  Send data for anisou             QF83 662
IF(ANYSIG==yes:)#                                                       QF83 663
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 QF83 664
movechar:(QF83G,1,PUNBUF,1,NQF83G,0)#  Siguij                           QF83 665
DO L=14,19 ; movechar:(SIGBUF,FROM(L),PUNBUF,TQ(L),NUMB(L),0)#          QF83 666
writepch:(PUNBUF,80)#                  Send data for siguij             QF83 667
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 QF83 668
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 QF83 669
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 QF83 670
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QF83 671
#                                                                       QF83 672
copyfile:(SCRBDF,OUTBDF,incr:(lratom:),endrecord:)# Get rest of scrat   QF83 673
IF(ATMVOI==yes:) writeline:(1,QF83Z,NQF83Z,3,1)# Void coordinates       QF83 674
#                                                                       QF83 675
RETURN#                                                                 QF83 676
END#                                                                    QF83 677
systemheader:(QF91)## Survey 'R' values of sample reflections           QF91   1
####################################################################    QF91   2
#                                                                  #    QF91   3
#                                QF91                              #    QF91   4
#                                                                  #    QF91   5
####################################################################    QF91   6
SUBROUTINE QF91## Taken from PROLSQ main program                        QF91   7
#                                     B. FINZEL 1984 J. STEWART 1989    QF91   8
include:(AACOMN)#                                                       QF91   9
include:(QFCOMN)#                                                       QF91  10
INTEGER I#                             Loop index                       QF91  11
chardata:(QF91A, R-VALUE SURVEY REQUESTED)#                             QF91  12
chardata:(QF91B, NO R-VALUE SURVEY REQUESTED IN THIS RUN.)#             QF91  13
realdata:(FMT,[90513.,190513.,300522.,350522.,400522.,$#                QF91  14
450522.,500522.,550522.,600522.,650522.,700522.,750522.])#              QF91  15
chardata:(QF91C, COUNT OF    COUNT OF   )#                              QF91  16
chardata:(QF91D, XYZ CYCLES  B CYCLES       $#                          QF91  17
--  SHIFT CYCLE FACTORS  --)#                                           QF91  18
chardata:(QF91E,[ MODULUS OF REFLECTIONS SELECTED =      ,  $#          QF91  19
HENCE           REFLECTIONS USED IN SURVEY.])#                          QF91  20
chardata:(QF91F,[ R-VALUE SURVEY OF EXCLUDED REFLECTIONS REQUESTED.])#  QF91  21
chardata:(QF91H,[ NO R-VALUE SURVEY OF EXCLUDED REFLECTIONS REQUESTED $#QF91  22
IN THIS RUN.])#                                                         QF91  23
realdata:(FMT2,[400513.,560613.])#                                      QF91  24
chardata:(QF91G,[ >>>>>>>>>>>>>>>>>>>>>>>> R VALUES SURVEY SECTION $#   QF91  25
<<<<<<<<<<<<<<<<<<<<<<<<<])#                                            QF91  26
datastuff:#                                                             QF91  27
#                                                                       QF91  28
#    CALCULATE R FOR SAMPLE REFLECTIONS                                 QF91  29
#    ----------------------------------                                 QF91  30
#                                                                       QF91  31
IF(IRTEST==yes:)#                      Do r test?                       QF91  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF91  33
LINRM=10 ; writeline:(4,QF91G,NQF91G,3,3)# Write a separator heading    QF91  34
writeline:(1,QF91A,NQF91A,3,3)#                                         QF91  35
BUFOT(1)=FLOAT(NSAMPL) ; BUFOT(2)=FLOAT(NRJDSK)#                        QF91  36
ncodefld:(BUFOT,1,QF91E,FMT2,2);writeline:(0,QF91E,NQF91E,3,3)#         QF91  37
# PARAMETERS LOADED IN QF10 BY READING OF 'RTEST' INPUT LINE.           QF91  38
LINRM=5;writeline:(1,QF91C,NQF91C,3,3)#                                 QF91  39
writeline:(0,QF91D,NQF91D,3,3)#                                         QF91  40
BUFOT(1)=FLOAT(JAQN) ; BUFOT(2)=FLOAT(JABN)#                            QF91  41
DO I=1,JABN+JAQN ; BUFOT(I+2)=SHFTK(I)#                                 QF91  42
ncodefld:(BUFOT,1,CHROT,FMT,JABN+JAQN+2);writeline:(0,0,0,1,3)#         QF91  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF91  44
ELSE#                                  No r test this run               QF91  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF91  46
writeline:(1,QF91B,NQF91B,3,3)#                                         QF91  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF91  48
IF(IRTESX==yes:)#                      Excluded reflection r test?      QF91  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF91  50
writeline:(1,QF91F,NQF91F,3,3)#                                         QF91  51
BUFOT(1)=FLOAT(NSAMPX) ; BUFOT(2)=FLOAT(NRKDSK)#                        QF91  52
ncodefld:(BUFOT,1,QF91E,FMT2,2);writeline:(0,QF91E,NQF91E,3,3)#         QF91  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF91  54
ELSE#                                  No r test this run               QF91  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF91  56
writeline:(1,QF91H,NQF91H,3,3)#                                         QF91  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF91  58
IF(IRTEST==yes:\IRTESX==yes:) CALL QF92#                                QF91  59
RETURN#                                                                 QF91  60
END#                                                                    QF91  61
systemheader:(QF92)## Calc structure factor on a limited set & do R     QF92   1
####################################################################    QF92   2
#                                                                  #    QF92   3
#                                QF92                              #    QF92   4
#                                                                  #    QF92   5
####################################################################    QF92   6
SUBROUTINE QF92## SUBROUTINE RTEST(JAQN,JABN,SHFTK,ISQNO)               QF92   7
#                                      B. finzel 1984                   QF92   8
#                                      J. stewart feb. 1989             QF92   9
include:(AACOMN)#                                                       QF92  10
include:(QFCOMN)#                                                       QF92  11
#                                                                       QF92  12
#       MODIFIED THIS ROUTINE EXTENSIVELY TO MAKE USE OF A LIMITED      QF92  13
#       REFLECTION LIST CREATED FOR THE R-TEST.  BCF.                   QF92  14
#       FURTHER MODIFIED TO ALLOW DIFFERENT USER CONTROL. JMS           QF92  15
#       ----------------------------------------------------------      QF92  16
#                                                                       QF92  17
REAL D#                                D spacing of reflection          QF92  18
REAL DV#                               F obs - f calc = delta f         QF92  19
INTEGER I,II,IP,J,JK,JPSCR,N#          Misc. pointers                   QF92  20
INTEGER IPUT#                          Signal no. of item in a line     QF92  21
INTEGER ITOT#                          Total reflns in a group          QF92  22
INTEGER NZCT(5)#                       Counts of refs by d spacing      QF92  23
INTEGER POUT#                          Scratch file packet size         QF92  24
REAL QDAMB,QDAMP#                      T.f. & positional test r shift   QF92  25
REAL RR,RVALUE,RZDEN,RZNUM#            Sums etc. for r value calcs      QF92  26
REAL RVALU(10)#                        Table of r values by resolutio   QF92  27
REAL SCALE,SCDEN,SCNUM#                Scale factor calcs               QF92  28
REAL SIGYO#                            Sigma f observed                 QF92  29
REAL STHOL#                            Reflection sin(theta)/lambda     QF92  30
REAL ZNUM(5),ZDEN(5)#                  More r sums by d spacing         QF92  31
chardata:(QF92A, F CALC SCALE =         )#                              QF92  32
chardata:(QF92B, POSITIONAL SHIFT DAMPING =         $#                  QF92  33
THERMAL SHIFT DAMPING =       )#                                        QF92  34
realdata:(FM100,[340632.,660632.])#                                     QF92  35
chardata:(QF92C, - - - - - - RESOLUTION BREAKDOWN - - - - - -)#         QF92  36
chardata:(QF92D,  DMIN     ZNUM      ZDEN      REFS       R     $#      QF92  37
F CALC SCALE)#                                                          QF92  38
chardata:(QF92E,ALL)#                                                   QF92  39
chardata:(QF92F, *************************************************)#    QF92  40
chardata:(QF92G,NONE)#                                                  QF92  41
chardata:(QF92H, CALCULATED SHIFTS ARE MULTIPLIED BY DAMPING FACTORS $# QF92  42
AND ADDED TO THE ORIGINAL PARAMETERS.)#                                 QF92  43
chardata:(QF92I, SURVEY OF R VALUES FOR A SUBSET OF        $#           QF92  44
REFLECTIONS EXCLUDED FROM LEAST-SQUARES.)#                              QF92  45
realdata:(FM840,[60522.,150902.,251002.,351013.,451032.,551052.])#      QF92  46
realdata:(QDMIN,[5.0,3.0,2.5,2.0,1.0])#                                 QF92  47
datastuff:#                                                             QF92  48
IF(IRTEST==yes:)#                      Doing r survey?                  QF92  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QF92  50
#                                                                       QF92  51
#     SUCCESSIVELY APPLY DAMPED SHIFTS                                  QF92  52
#     --------------------------------                                  QF92  53
#                                                                       QF92  54
IF(TFTYPE==0) SC(1)=SC(1)+QX(MARKU+1)#                                  QF92  55
ncodefld:(SC,1,QF92A,220632.,1)#       Encode scale factor              QF92  56
writeline:(1,QF92A,NQF92A,3,3)#                                         QF92  57
writeline:(1,QF92F,NQF92F,3,3)#        Underline it                     QF92  58
DO JK=1,JABN+JAQN#                     Loop over all shift cycles       QF92  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QF92  60
DO I=1,5#                              Initialize this cycle            QF92  61
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QF92  62
ZNUM(I)=0.0 ; ZDEN(I)=0.0 ; NZCT(I)=0#                                  QF92  63
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QF92  64
RZNUM=0.0 ; RZDEN=0.0 ; SCNUM=0.0 ; SCDEN=0.0#                          QF92  65
#                                                                       QF92  66
IF(JK<=JAQN)#                          Which cycle is this              QF92  67
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QF92  68
#                                                                       QF92  69
#     POSITIONAL SHIFTS. SHIFT X, Y AND Z BY CALCULATED DELTA X, Y AND  QF92  70
#     Z TIMES A SHIFT FACTOR.                                           QF92  71
#     ----------------------------------------------------------------  QF92  72
QDAMP=SHFTK(JK) ; QDAMB=1.0#           Set shifts for cycle             QF92  73
IP=MARKA-STEPA ; DO I=1,NA#                                             QF92  74
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QF92  75
IP=IP+STEPA ; II=3*I+MARKU#                                             QF92  76
QX(IP+1)=QX(IP+1)+QX(II  )*QDAMP ; QX(IP+2)=QX(IP+2)+QX(II+1)*QDAMP#    QF92  77
QX(IP+3)=QX(IP+3)+QX(II+2)*QDAMP#                                       QF92  78
QX(IP+5)=QX(IP+5)+QX(MARKU+IATMN+I)*QDAMB# Shift the temperature fact   QF92  79
QX(IP+5)=AMAX1(QX(IP+5),2.0)#          Keep your bees up                QF92  80
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QF92  81
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QF92  82
#                                                                       QF92  83
#    THERMAL PARAMETER SHIFTS.  RESET X, Y AND Z TO FULL SHIFT AND      QF92  84
#    VARY B BY REMAINING SHFTK FACTORS                                  QF92  85
#    -------------------------------------------------------------      QF92  86
ELSE#                                  The rest of the cycles for b     QF92  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QF92  88
QDAMB=SHFTK(JK) ; QDAMP=1.0#           Thermal-factor shifts            QF92  89
IF(TFTYPE!=2)#                         Isotropic                        QF92  90
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QF92  91
IP=MARKA-STEPA#                        Point to atoms                   QF92  92
DO I=1,NA#                                                              QF92  93
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QF92  94
IP=IP+STEPA ; II=3*I+MARKU#                                             QF92  95
QX(IP+1)=QX(IP+1)+QX(II  )*QDAMP ; QX(IP+2)=QX(IP+2)+QX(II+1)*QDAMP#    QF92  96
QX(IP+3)=QX(IP+3)+QX(II+2)*QDAMP#                                       QF92  97
QX(IP+5)=QX(IP+5)+QX(MARKU+IATMN+I)*QDAMB# Shift the temperature fact   QF92  98
QX(IP+5)=AMAX1(QX(IP+5),2.0)#          Keep your bees up                QF92  99
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QF92 100
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QF92 101
ELSE#                                  Anisotropic                      QF92 102
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QF92 103
DO I=1,NA#                                                              QF92 104
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QF92 105
# USE STEPE MARKE TO FIX!!!!!!!!!!!!!!!!!!!                             QF92 106
#BETA(I,1)=BETA(I,1)+QX(MARKV+3*I+IATMN-2)*SKSH# TROUBLE!!!!!!!!!!!     QF92 107
#BETA(I,2)=BETA(I,2)+QX(MARKV+3*I+IATMN-1)*SKSH# TROUBLE!!!!!!!!        QF92 108
#BETA(I,3)=BETA(I,3)+QX(MARKV+3*I+IATMN  )*SKSH# TROUBLE!!!!!!!         QF92 109
DO J=1,3#                                                               QF92 110
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QF92 111
# BETA(I,J)=AMAX1(BETA(I,J),2.0)#  TROUBLE!!!!!!!!!!!!!!!               QF92 112
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QF92 113
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QF92 114
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QF92 115
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QF92 116
#     CALCULATE STRUCTURE FACTORS                                       QF92 117
#     ---------------------------                                       QF92 118
#                                                                       QF92 119
REPEAT#                                Loop over a reflection sample    QF92 120
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QF92 121
#                                                                       QF92 122
# READ IN A TRUNCATED, ABBREVIATED FILE OF REFLECTIONS SELECTED         QF92 123
# IN QF61 FOR THE PURPOSE OF CALCULATING THIS SAMPLE OF R VALUES        QF92 124
#                                                                       QF92 125
readwpkt:(RFILE,27,POUT,JPSCR,0)#      Read scratch reflections         QF92 126
IF(JPSCR<=0) BREAK#                    Stop when all read               QF92 127
DO I=1,3 ; H(I)=QX(JPSCR+I)#           Store indices                    QF92 128
YO=QX(JPSCR+5) ; SIGYO=QX(JPSCR+6) ; STHOL=QX(JPSCR+7)#                 QF92 129
APC=QX(JPSCR+8) ; BPC=QX(JPSCR+9)#                                      QF92 130
RHO=STHOL**2#                          Get sin(theta)/lambda squared    QF92 131
DO I=1,NTYP#                           Put scattering factors in arra   QF92 132
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QF92 133
FII(I)=QX(JPSCR+I+9)#                  Store scattering factors         QF92 134
FIIMOD(I)=FII(I)#                      Store modifiable s.f.s           QF92 135
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QF92 136
#                                                                       QF92 137
#     ADD ANALYTIC AMORPHOUS SOLVENT APPROXIMATION                      QF92 138
#     AND PARTIAL FC CONTRIBUTIONS                                      QF92 139
#     --------------------------------------------                      QF92 140
#                                                                       QF92 141
IF(SOLMOD==yes:) CALL QF63#            Call amorph                      QF92 142
#                                                                       QF92 143
#     CALCULATE STRUCTURE FACTORS                                       QF92 144
#                                                                       QF92 145
CALL QF62#                             Call calc                        QF92 146
#                                                                       QF92 147
DV=YO-YC ; RZNUM=RZNUM+ABS(DV) ; RZDEN=RZDEN+YO#                        QF92 148
SCNUM=SCNUM+YO*YC ; SCDEN=SCDEN+YC**2 ; D= 0.5/AMAX1(0.001,STHOL)#      QF92 149
DO I=1,5#                                                               QF92 150
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QF92 151
N=I ; IF(D>QDMIN(I)) BREAK#                                             QF92 152
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QF92 153
ZNUM(N)=ZNUM(N)+ABS(DV) ; ZDEN(N)=ZDEN(N)+YO ; NZCT(N)=NZCT(N)+1#       QF92 154
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QF92 155
#REWINDBDF:(RFILE)## This, used with bdfclose: would be preferable      QF92 156
readwpkt:(RFILE,endrecord:,POUT,JPSCR,0)# Rewind and close .xx1         QF92 157
#                                                                       QF92 158
#    RESTORE COORDINATES FROM LOCATION DURING LAST RUN                  QF92 159
#    -------------------------------------------------                  QF92 160
#                                                                       QF92 161
IF(JK<=JAQN)#                          Positional parameter shifts?     QF92 162
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QF92 163
IP=MARKA-STEPA ; DO I=1,NA#                                             QF92 164
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QF92 165
IP=IP+STEPA ; II=3*I+MARKU#                                             QF92 166
QX(IP+1)=QX(IP+1)-QX(II  )*QDAMP ; QX(IP+2)=QX(IP+2)-QX(II+1)*QDAMP#    QF92 167
QX(IP+3)=QX(IP+3)-QX(II+2)*QDAMP#                                       QF92 168
QX(IP+5)=QX(IP+5)-QX(MARKU+IATMN+I)*QDAMB# Shift the temperature fact   QF92 169
QX(IP+5)=AMAX1(QX(IP+5),2.0)#          Keep your bees up                QF92 170
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QF92 171
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QF92 172
ELSE#                                  Thermal parameters               QF92 173
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QF92 174
IF(TFTYPE!=2)#                         Isotropic                        QF92 175
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QF92 176
IP=MARKA-STEPA#                        Point to atoms                   QF92 177
DO I=1,NA#                                                              QF92 178
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QF92 179
IP=IP+STEPA ; II=3*I+MARKU#                                             QF92 180
QX(IP+1)=QX(IP+1)-QX(II  )*QDAMP ; QX(IP+2)=QX(IP+2)-QX(II+1)*QDAMP#    QF92 181
QX(IP+3)=QX(IP+3)-QX(II+2)*QDAMP#                                       QF92 182
QX(IP+5)=QX(IP+5)-QX(MARKU+IATMN+I)*QDAMB# Shift the temperature fact   QF92 183
QX(IP+5)=AMAX1(QX(IP+5),2.0)#          Keep your bees up                QF92 184
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QF92 185
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QF92 186
ELSE#                                  Anisotropic                      QF92 187
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QF92 188
DO I=1,NA#                                                              QF92 189
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QF92 190
# USE STEPE MARKE TO FIX!!!!!!!!!!!!!!!!!!!                             QF92 191
#BETA(I,1)=BETA(I,1)+QX(MARKV+3*I+IATMN-2)*SKSH# TROUBLE!!!!!!!!!!!     QF92 192
#BETA(I,2)=BETA(I,2)+QX(MARKV+3*I+IATMN-1)*SKSH# TROUBLE!!!!!!!!        QF92 193
#BETA(I,3)=BETA(I,3)+QX(MARKV+3*I+IATMN  )*SKSH# TROUBLE!!!!!!!         QF92 194
DO J=1,3#                                                               QF92 195
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QF92 196
# BETA(I,J)=AMAX1(BETA(I,J),2.0)#  TROUBLE!!!!!!!!!!!!!!!               QF92 197
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QF92 198
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QF92 199
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QF92 200
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QF92 201
#                                                                       QF92 202
#     OUTPUT R-VALUES                                                   QF92 203
#     ---------------                                                   QF92 204
LINRM=5 ; ITOT=0#                                                       QF92 205
BUFOT(1)=QDAMP ; BUFOT(2)=QDAMB ; ncodefld:(BUFOT,1,QF92B,FM100,2)#     QF92 206
writeline:(1,QF92B,NQF92B,3,3) ; writeline:(1,QF92H,NQF92H,3,3)#        QF92 207
writeline:(1,QF92C,NQF92C,3,3) ; LINRM=3#                               QF92 208
DO I=1,5#                                                               QF92 209
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QF92 210
IPUT=4 ; movechar:(QF92G,1,CHROT,41,NQF92G,0)# Assume no refs present   QF92 211
IF(ZDEN(I)>0.001)#                     Protect against divide overflo   QF92 212
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QF92 213
IPUT=5 ; RVALUE=ZNUM(I)/ZDEN(I) ;BUFOT(5)=RVALUE#                       QF92 214
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QF92 215
BUFOT(1)=QDMIN(I) ; BUFOT(2)=ZNUM(I) ; BUFOT(3)=ZDEN(I)#                QF92 216
ITOT=ITOT+NZCT(I) ; BUFOT(4)=FLOAT(NZCT(I))#                            QF92 217
ncodefld:(BUFOT,1,CHROT,FM840,IPUT) ; writeline:(0,QF92D,NQF92D,1,3)#   QF92 218
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QF92 219
IPUT=3 ; movechar:(QF92G,1,CHROT,41,NQF92G,0)# Assume no refs present   QF92 220
RVALU(JK)=99.0#                        In case divide will overflow     QF92 221
IF(RZDEN>0.001)#                                                        QF92 222
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QF92 223
RR=RZNUM/RZDEN ; RVALU(JK)=RR ; IPUT=4 ; BUFOT(4)=RR#                   QF92 224
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QF92 225
SCALE=SCNUM/AMAX1(0.001,SCDEN)#                                         QF92 226
BUFOT(1)=RZNUM ; BUFOT(2)=RZDEN ; BUFOT(3)=FLOAT(ITOT)#                 QF92 227
ncodefld:(BUFOT,1,CHROT,FM840(2),IPUT)#                                 QF92 228
BUFOT(1)=SCALE#                                                         QF92 229
ncodefld:(BUFOT,1,CHROT,FM840(6),1)#                                    QF92 230
movechar:(QF92E,1,CHROT,3,NQF92E,0)#                                    QF92 231
writeline:(1,QF92D,NQF92D,1,3) ; writeline:(1,QF92F,NQF92F,3,3)#        QF92 232
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QF92 233
#BDFCLOSE:(RFILE)## Close the scratch file .XX1 doesn't work 3/12/92    QF92 234
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QF92 235
IF(IRTESX==yes:)#                      Excluded reflection r test?      QF92 236
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QF92 237
DO I=1,5#                              Initialize this cycle            QF92 238
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 QF92 239
ZNUM(I)=0.0 ; ZDEN(I)=0.0 ; NZCT(I)=0#                                  QF92 240
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 QF92 241
RZNUM=0.0 ; RZDEN=0.0 ; SCNUM=0.0 ; SCDEN=0.0 ; ITOT=0 ; LINRM=5#       QF92 242
IP=MARKA-STEPA ; DO I=1,NA#                                             QF92 243
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 QF92 244
IP=IP+STEPA ; II=3*I+MARKU#            Shift parameters for last hit    QF92 245
QX(IP+1)=QX(IP+1)+QX(II  ) ; QX(IP+2)=QX(IP+2)+QX(II+1)#                QF92 246
QX(IP+3)=QX(IP+3)+QX(II+2) ; QX(IP+5)=QX(IP+5)+QX(MARKU+IATMN+I)#       QF92 247
QX(IP+5)=AMAX1(QX(IP+5),2.0)#          Keep your bees up                QF92 248
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 QF92 249
#                                                                       QF92 250
#     CALCULATE STRUCTURE FACTORS YET AGAIN                             QF92 251
#     -------------------------------------                             QF92 252
#                                                                       QF92 253
REPEAT#                                Loop over a reflection sample    QF92 254
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 QF92 255
#                                                                       QF92 256
# READ IN A TRUNCATED, ABBREVIATED FILE OF REFLECTIONS SELECTED         QF92 257
# IN QF61 FOR THE PURPOSE OF CALCULATING THIS SAMPLE OF R VALUES.       QF92 258
# THESE REFLECTIONS WERE NOT CONTRIBUTED TO THE LEAST SQUARES           QF92 259
# PROCESS IN ORDER TO CHECK THE QUALITY OF THE REFINEMENT.              QF92 260
#                                                                       QF92 261
readwpkt:(EXRFI,27,POUT,JPSCR,0)#      Read scratch reflections         QF92 262
IF(JPSCR<=0) BREAK#                    Stop when all read               QF92 263
DO I=1,3 ; H(I)=QX(JPSCR+I)#           Store indices                    QF92 264
YO=QX(JPSCR+5) ; SIGYO=QX(JPSCR+6) ; STHOL=QX(JPSCR+7)#                 QF92 265
APC=QX(JPSCR+8) ; BPC=QX(JPSCR+9)#                                      QF92 266
RHO=STHOL**2#                          Get sin(theta)/lambda squared    QF92 267
DO I=1,NTYP#                           Put scattering factors in arra   QF92 268
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 QF92 269
FII(I)=QX(JPSCR+I+9)#                  Store scattering factors         QF92 270
FIIMOD(I)=FII(I)#                      Store modifiable s.f.s           QF92 271
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 QF92 272
#                                                                       QF92 273
#     ADD ANALYTIC AMORPHOUS SOLVENT APPROXIMATION                      QF92 274
#     AND PARTIAL FC CONTRIBUTIONS                                      QF92 275
#     --------------------------------------------                      QF92 276
#                                                                       QF92 277
IF(SOLMOD==yes:) CALL QF63#            Call amorph                      QF92 278
#                                                                       QF92 279
#     CALCULATE STRUCTURE FACTORS                                       QF92 280
#                                                                       QF92 281
CALL QF62#                             Call calc                        QF92 282
#                                                                       QF92 283
DV=YO-YC ; RZNUM=RZNUM+ABS(DV) ; RZDEN=RZDEN+YO#                        QF92 284
SCNUM=SCNUM+YO*YC ; SCDEN=SCDEN+YC**2 ; D= 0.5/AMAX1(0.001,STHOL)#      QF92 285
DO I=1,5#                                                               QF92 286
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 QF92 287
N=I ; IF(D>QDMIN(I)) BREAK#                                             QF92 288
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 QF92 289
ZNUM(N)=ZNUM(N)+ABS(DV) ; ZDEN(N)=ZDEN(N)+YO ; NZCT(N)=NZCT(N)+1#       QF92 290
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 QF92 291
readwpkt:(EXRFI,endrecord:,POUT,JPSCR,0)# Read endrecord & close file   QF92 292
#                                                                       QF92 293
#     OUTPUT R-VALUES                                                   QF92 294
#     ---------------                                                   QF92 295
ncodefld:(FLOAT(NRKDSK),1,QF92I,420613.,1)#                             QF92 296
writeline:(1,QF92I,NQF92I,3,3) ; writeline:(1,QF92C,NQF92C,3,3)#        QF92 297
DO I=1,5#                                                               QF92 298
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 QF92 299
IPUT=4 ; movechar:(QF92G,1,CHROT,41,NQF92G,0)# Assume no refs present   QF92 300
IF(ZDEN(I)>0.001)#                     Protect against divide overflo   QF92 301
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 QF92 302
IPUT=5 ; RVALUE=ZNUM(I)/ZDEN(I) ;BUFOT(5)=RVALUE#                       QF92 303
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 QF92 304
BUFOT(1)=QDMIN(I) ; BUFOT(2)=ZNUM(I) ; BUFOT(3)=ZDEN(I)#                QF92 305
ITOT=ITOT+NZCT(I) ; BUFOT(4)=FLOAT(NZCT(I))#                            QF92 306
ncodefld:(BUFOT,1,CHROT,FM840,IPUT) ; writeline:(0,QF92D,NQF92D,1,3)#   QF92 307
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 QF92 308
IPUT=3 ; movechar:(QF92G,1,CHROT,41,NQF92G,0)# Assume no refs present   QF92 309
RVALU(JK)=99.0#                        In case divide will overflow     QF92 310
IF(RZDEN>0.001)#                                                        QF92 311
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 QF92 312
RR=RZNUM/RZDEN ; RVALU(JK)=RR ; IPUT=4 ; BUFOT(4)=RR#                   QF92 313
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 QF92 314
SCALE=SCNUM/AMAX1(0.001,SCDEN)#                                         QF92 315
BUFOT(1)=RZNUM ; BUFOT(2)=RZDEN ; BUFOT(3)=FLOAT(ITOT)#                 QF92 316
ncodefld:(BUFOT,1,CHROT,FM840(2),IPUT)#                                 QF92 317
BUFOT(1)=SCALE#                                                         QF92 318
ncodefld:(BUFOT,1,CHROT,FM840(6),1)#                                    QF92 319
movechar:(QF92E,1,CHROT,3,NQF92E,0)#                                    QF92 320
writeline:(1,QF92D,NQF92D,1,3) ; writeline:(1,QF92F,NQF92F,3,3)#        QF92 321
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QF92 322
#                                                                       QF92 323
RETURN#                                                                 QF92 324
END#                                                                    QF92 325
pmacro:([no:])#                                                         QF92 326
