systemheader:(QN    )#                                                  QN     1
##   version: Aug93                                                             
######################################################################  QN     2
#                                                                    #  QN     3
#                            ***PROTIN***                            #  QN     4
#                                                                    #  QN     5
#   THE XTAL VERSION OF PROTIN IS A RECODING OF THE VERSION SET UP   #  QN     6
# BY BARRY FINZEL AND STEVEN SHERIFF.  THE PROGRAM IS ESSENTIALLY    #  QN     7
# THE CODE OF WAYNE HENDRICKSON WITH INPUT AND MODIFICATIONS BY      #  QN     8
# ANITA SIELECKI, ALEX WLODAWER, AND JANET SMITH.  THIS EDITION      #  QN     9
# WAS TRANSLATED INTO RATMAC WITH INPUT IN THE XTAL STYLE USING      #  QN    10
# XTAL BINARY DATA FILES FOR INPUT AND OUTPUT OF ALL DATA.           #  QN    11
#                              J.M. STEWART, NRL, APRIL 1987         #  QN    12
#                                                                    #  QN    13
######################################################################  QN    14
#                                                                       QN    15
include:(XMACRO)#                                                       QN    16
#                                                                       QN    17
macro:(nw5c:,incr:(arith:(5,/,mxchwd:)))# No. of words to hold 5 chrs   QN    18
#                                                                       QN    19
#----MACROS TO SET THE DIMENSIONS OF ARRAYS USED IN PROTIN              QN    20
#    -----------------------------------------------------              QN    21
#                                                                       QN    22
#----DEFINITIONS:                                                       QN    23
#---- QMXGRP:-MAXIMUM NUMBER OF IDEAL GROUPS                            QN    24
#---- QMXPLN:-MAXIMUM NUMBER OF IDEAL PLANAR GROUPS                     QN    25
#---- QMXDST:-MAXIMUM NUMBER OF DISTANCES IN ANY IDEAL GROUP            QN    26
#              MUST BE 185 WITHOUT HYDROGENS, OR 250 WITH               QN    27
#---- QMXATM:-MAXIMUM NUMBER OF ATOMS IN ANY IDEAL GROUP                QN    28
#---- QMXRES:-MAXIMUM NUMBER OF RESIDUES                                QN    29
#---- QMXCHN:-MAXIMUM NUMBER OF CHAINS                                  QN    30
#---- QMXCH2:-QMXCHN:*(QMXCHN:-1)/2                                     QN    31
#---- QMXCHT:-MAXIMUM NUMBER OF CHAIN TYPES                             QN    32
#---- Q2MXCT:-TWICE THE MAXIMUM NUMBER OF CHAIN TYPES                   QN    33
#---- QMXDIC:-MAXIMUM NUMBER OF INTER-CHAIN SPECIAL DISTANCES           QN    34
#---- QMXDIG:-MAXIMUM NUMBER OF INTRA-CHAIN SPECIAL DISTANCES           QN    35
#---- QMXSYM:-MAXIMUM NUMBER OF ROTATION AND TRANSLATION OPERATORS      QN    36
#---- QMXAT4:-4*QMXATM: FOR STEPPING IN IDS ARRAY                       QN    37
#---- QMXDSS:-MAXIMUM NUMBER OF DISULPHIDE LINKAGES                     QN    38
#PARAMETER (QMXGRP:=40 , QMXPLN:=45 , QMXDST:=250)#                     QN    39
ifsel:(IBM)#                                                            QN    40
macro:(qmxgrp:,25)#                                                     QN    41
ifsel:#                                                                 QN    42
macro:(qmxgrp:,50)#                                                     QN    43
endsel:#                                                                QN    44
macro:(qmxpln:,45)#                                                     QN    45
macro:(qmxdst:,250)#                                                    QN    46
#PARAMETER (QMXATM:=50 , QMXRES:=999)#                                  QN    47
macro:(qmxatm:,50)#                                                     QN    48
macro:(qmxat4:,arith:(4,*,qmxatm:))#                                    QN    49
macro:(qmxres:,999)#                                                    QN    50
#PARAMETER (QMXCHN:=4 , QMXCH2:=QMXCHN:*(QMXCHN:-1)/2)#                 QN    51
macro:(qmxchn:,7)#                                                      QN    52
macro:(qmxch2:,arith:(qmxchn:,*,arith:(decr:(qmxchn:),/,2)))#           QN    53
#PARAMETER (QMXCHT:=3 , Q2MXCT:=2*QMXCHT:)#                             QN    54
macro:(qmxcht:,4)#                                                      QN    55
macro:(q2mxct:,arith:(2,*,qmxcht:))#                                    QN    56
#PARAMETER (QMXDIC:=20 , QMXDIG:=500)#                                  QN    57
macro:(qmxdic:,20)#                                                     QN    58
macro:(qmxdig:,500)#                                                    QN    59
#PARAMETER (QMXSYM:=192)#                                               QN    60
macro:(qmxsym:,192)#                                                    QN    61
#PARAMETER (QMXDSS:=25)                                                 QN    62
macro:(qmxdss:,25)#                                                     QN    63
#                                                                       QN    64
#                                                                       QN    65
extrude:(QNCOMN)#                                                       QN    66
string:(MCOD,qmxgrp:)## Single letter synonym for a residue name        QN    67
string:(IDCHN,arith:(3,*,qmxchn:))## Chain identities                   QN    68
string:(IDL,320)## Name for an atom in a 'link' residue                 QN    69
string:(IDS,arith:(4,*,arith:(qmxgrp:,*,qmxatm:)))# Id side chain atm   QN    70
string:(INLINE,268)#                   Names of input lines expected    QN    71
string:(NAMCTR,arith:(4,*,qmxchn:))## Name of C terminal residue        QN    72
string:(NAMEL,80)## Names of 'link' residues                            QN    73
string:(NAMEM,40)## Names of 'main' residues                            QN    74
string:(NAMES,arith:(4,*,qmxgrp:))## Names of 'side chain' residues     QN    75
string:(NAMNTR,arith:(4,*,qmxchn:))## Name of N terminal residue        QN    76
string:(FRSTPQ,9)## Atom name for occupancy                             QN    77
string:(SAVCH,80)## Holding for CHRIN line input at 'ideals' reading    QN    78
#                                                                       QN    79
INTEGER DEFAUL## Signal source of restraint information yes:=profil:    QN    80
INTEGER FILEA,FILEF## Communications files to PROLSQ                    QN    81
INTEGER IACIDT(q2mxct:)##                                               QN    82
INTEGER IATM(qmxgrp:,qmxdst:)##                                         QN    83
INTEGER IBMAX##                                                         QN    84
INTEGER ICDIS2(qmxdic:,qmxch2:)##                                       QN    85
INTEGER ICDIST(qmxdic:,qmxch2:)##                                       QN    86
INTEGER ICENTR(qmxres:,qmxchn:)##                                       QN    87
INTEGER ICHCEN(qmxchn:)##                                               QN    88
INTEGER ICHNSS(qmxdss:)## Pointers for disulphide linkages              QN    89
INTEGER ICHR(8,4)##                                                     QN    90
INTEGER ICHTYP(qmxchn:)## Pointers to chains                            QN    91
INTEGER ICODE(4,qmxsym:),ICODEI(4,qmxsym:)##                            QN    92
INTEGER ICONFO(qmxres:,qmxchn:)##                                       QN    93
INTEGER ICRABS(8)##                                                     QN    94
INTEGER IDACD(qmxres:,qmxchn:)##                                        QN    95
INTEGER IDCHR(8)##                                                      QN    96
INTEGER IDCIS(6,qmxcht:)##                                              QN    97
INTEGER IDISTZ(qmxres:,qmxchn:),JDISTZ(qmxres:,qmxchn:)##               QN    98
INTEGER IGDIS2(qmxdig:,qmxcht:)##                                       QN    99
INTEGER IGDIST(qmxdig:,qmxcht:)##                                       QN   100
INTEGER IHATOM##                                                        QN   101
INTEGER IMAINT(q2mxct:)##                                               QN   102
INTEGER IPLN(qmxpln:,17)##                                              QN   103
INTEGER IQZERO##                                                        QN   104
INTEGER IRESSS(qmxdss:)## Pointers for disulphide linkages              QN   105
INTEGER IREST(q2mxct:)##                                                QN   106
INTEGER ISID1##                                                         QN   107
INTEGER ISKIPC(qmxchn:)##                                               QN   108
INTEGER ISKIQN(qmxchn:)##                                               QN   109
INTEGER ITWIST(12,qmxgrp:)##                                            QN   110
INTEGER IVDW(qmxgrp:,qmxdst:)##                                         QN   111
INTEGER JATM(qmxgrp:,qmxdst:)##                                         QN   112
INTEGER JCHNSS(qmxdss:)## Pointers for disulphide linkages              QN   113
INTEGER JRESSS(qmxdss:)## Pointers for disulphide linkages              QN   114
INTEGER JVDW(qmxgrp:,qmxdst:)##                                         QN   115
INTEGER KBWT(qmxgrp:,qmxdst:)##                                         QN   116
INTEGER KCHR(8,6)##                                                     QN   117
INTEGER KDWT(qmxgrp:,qmxdst:)##                                         QN   118
INTEGER KHIDST(5,6,qmxgrp:)##                                           QN   119
INTEGER KHIWGT(5,qmxgrp:)##                                             QN   120
INTEGER KNDACD(qmxpln:)##                                               QN   121
INTEGER KPLN(qmxpln:,91)##                                              QN   122
INTEGER KPS(qmxgrp:,qmxatm:,4)##                                        QN   123
INTEGER KRESMP(qmxcht:)##                                               QN   124
INTEGER KRESMX(qmxchn:)##                                               QN   125
INTEGER KS(qmxgrp:,qmxatm:)## Scatt fact no. for an atom in a resid     QN   126
INTEGER KTYP(qmxgrp:,qmxdst:)##                                         QN   127
INTEGER LISTIT## Signal to listing atom coordinates  yes:/no:           QN   128
INTEGER LISGEN## Signal to list samples of output; no. of lines per     QN   129
INTEGER LRANI## Designator for logical record for aniso t.f.s           QN   130
INTEGER LRCHI## Designator for logical record for chiral centers        QN   131
INTEGER LRDIS## Designator for logical record for distance restraints   QN   132
INTEGER LRPLA## Designator for logical record for plane restraints      QN   133
INTEGER LRSYM## Designator for logical record for symmetry restraints   QN   134
INTEGER LRTOR## Designator for logical record for torsion restraints    QN   135
INTEGER LRVDW## Designator for logical record for vdWaals restraints    QN   136
INTEGER MANDST(3,6,10)##                                                QN   137
INTEGER MANZIP(3,6,10)##                                                QN   138
INTEGER MARKA## Pointer to start of atom array                          QN   139
INTEGER MARKB## Pointer to start of box array                           QN   140
INTEGER MARKS## Pointer to start of symop array                         QN   141
INTEGER MAXGRP##                                                        QN   142
INTEGER MNABOR(6,10)##                                                  QN   143
INTEGER MOTHRZ(qmxchn:)## Link table of disorder chains to mothers      QN   144
INTEGER NACIDP##                                                        QN   145
INTEGER NACIDS## Total number of 'side chain' residues                  QN   146
INTEGER NACIDT## NACIDS + NTRMS                                         QN   147
INTEGER NAPEP##                                                         QN   148
INTEGER NATOMM(10)## No. of atoms in 'main' residues                    QN   149
INTEGER NATOMS(qmxgrp:)## No. of atoms in 'side chain' residues         QN   150
INTEGER NAXES##                                                         QN   151
INTEGER NB(3)##                                                         QN   152
INTEGER NCELL,NSYMOP,NSYMC##                                            QN   153
INTEGER NCHAIN## Count of the number of main chains                     QN   154
INTEGER NCHIS(qmxgrp:)##                                                QN   155
INTEGER NCHR##                                                          QN   156
INTEGER NCHTYP## No. of terminal peptides                               QN   157
INTEGER NDIC(qmxch2:)##                                                 QN   158
INTEGER NDIG(qmxcht:)##                                                 QN   159
INTEGER NDISTM(10)##                                                    QN   160
INTEGER NDISTS(qmxgrp:)##                                               QN   161
INTEGER NIDEAL##                                                        QN   162
INTEGER NLINEC## Number of characters in INLINE array                   QN   163
INTEGER NOCC## Count of atoms with population params < 1.0              QN   164
INTEGER NOAT(qmxatm:,qmxres:,qmxchn:)## Point ideal group for each at   QN   165
INTEGER NOATOM## No. of atoms to be treated                             QN   166
INTEGER NOCHRL## No. of restraints on chiral centers                    QN   167
INTEGER NODIST## No. of restraints on distances                         QN   168
INTEGER NOSPDS## No. of special distances                               QN   169
INTEGER NONOW##                                                         QN   170
INTEGER NOPLAN## No. of restraints on planar moieties                   QN   171
INTEGER NOTOR## No. of restraints on torsion angles                     QN   172
INTEGER NOVDW## No. of restraints on vdWaals contacts                   QN   173
INTEGER NPAIRS(qmxpln:)##                                               QN   174
INTEGER NPLATS(qmxpln:)##                                               QN   175
INTEGER NRESCH(qmxchn:)## Number of residues per chain                  QN   176
INTEGER NRESID## Total number of residues loaded                        QN   177
INTEGER NSS## Count of number of disulphide linkages                    QN   178
INTEGER NSYMM(2)##                                                      QN   179
INTEGER NTCHAN## Count of number of chains including alternates         QN   180
INTEGER NTRMS## Twice the number of terminal peptides                   QN   181
INTEGER NUMHET## Number of hetero atoms loaded                          QN   182
INTEGER NVDWS(qmxgrp:)##                                                QN   183
INTEGER NXY##                                                           QN   184
INTEGER NXYZ##                                                          QN   185
INTEGER PKANI## Packet size for aniso t.f. restraints                   QN   186
INTEGER PKCHI## Packet size for chiral centers restraints               QN   187
INTEGER PKDIS## Packet size for distance restraints                     QN   188
INTEGER PKPLA## Packet size for planes restraints                       QN   189
INTEGER PKSYM## Packet size for special symmetry restraints             QN   190
INTEGER PKTOR## Packet size for torsion angle restraints                QN   191
INTEGER PKVDW## Packet size for van der Waals dist. restraints          QN   192
INTEGER RESEQU(qmxres:,qmxchn:)## Equivalence table for res. seq. no.   QN   193
INTEGER SAVID## LINID of line in CHRIN at time of 'ideals' file readi   QN   194
INTEGER SAVINP## Usual input file for lines                             QN   195
INTEGER SAVNCH## Number of fields in saved line                         QN   196
INTEGER STEPA## Items per atom in atom array                            QN   197
INTEGER STEPS## Items per symop in symop array                          QN   198
INTEGER STOPA## Pointer to end of atom array                            QN   199
INTEGER STOPB## Pointer to end of box array                             QN   200
INTEGER STOPS## Pointer to end of symop array                           QN   201
INTEGER TOTRES## Total residues: main, standard, prosthetic and linki   QN   202
LOGICAL ZMAIN(qmxres:,qmxchn:)##                                        QN   203
REAL    ATPISQ## 8pi sqd  for converting u to b                         QN   204
REAL    BOVER## overall tdp as b                                        QN   205
REAL    DSET## data set                                                 QN   206
REAL    DB##                                                            QN   207
REAL    DIST(qmxgrp:,qmxdst:)##                                         QN   208
REAL    DNBC(qmxgrp:,qmxdst:)##                                         QN   209
REAL    DVDW(28,28)##                                                   QN   210
REAL    OIXX,OIXY,OIXZ,OIYY,OIYZ,OIZZ##                                 QN   211
REAL    ORXX,ORXY,ORXZ,ORYY,ORYZ,ORZZ##                                 QN   212
REAL    PHIPSI(2,15)##                                                  QN   213
REAL    RADCHN(qmxchn:)##                                               QN   214
REAL    RADIUS(qmxres:,qmxchn:)##                                       QN   215
REAL    SAVBUF(20)## Place to save xtal's bufin                         QN   216
REAL    VCHR(8)##                                                       QN   217
REAL    VDWCUT## Distance to define a van der Walls                     QN   218
REAL    XL(5,8,2)## X coord's 'link' residue atoms                      QN   219
REAL    XS(qmxgrp:,qmxatm:)## X coord's 'side chain' residue atoms      QN   220
REAL    XYZMIN(3),XYZMAX(3)## Limits of coord's on protein atoms        QN   221
REAL    YL(5,8,2)## Y coord's 'link' residue atoms                      QN   222
REAL    YS(qmxgrp:,qmxatm:)## Y coord's 'side chain' residue atoms      QN   223
REAL    ZL(5,8,2)## Z coord's 'link' residue atoms                      QN   224
REAL    ZS(qmxgrp:,qmxatm:)## Z coord's 'side chain' residue atoms      QN   225
#                                                                       QN   226
COMMON/COMCQN/MCOD  ,IDCHN ,IDL   ,IDS   ,$#                            QN   227
INLINE,NAMCTR,NAMEL ,NAMEM ,NAMES ,NAMNTR,FRSTPQ,SAVCH##                QN   228
#                                                                       QN   229
COMMON/COMFQN/ATPISQ,BOVER ,DB    ,DIST  ,DNBC  ,DVDW  ,DSET,$#         QN   230
OIXX  ,OIXY  ,OIXZ  ,OIYY  ,OIYZ  ,OIZZ  ,$#                            QN   231
ORXX  ,ORXY  ,ORXZ  ,ORYY  ,ORYZ  ,ORZZ  ,$#                            QN   232
PHIPSI,RADCHN,RADIUS,SAVBUF,VCHR  ,VDWCUT,XL    ,$#                     QN   233
XS    ,XYZMIN,XYZMAX,YL    ,YS    ,ZL    ,ZS#    ##                     QN   234
#                                                                       QN   235
COMMON/COMLQN/ZMAIN#                                                    QN   236
#                                                                       QN   237
COMMON/COMIQN/IACIDT,IATM  ,IBMAX ,ICDIS2,$#                            QN   238
ICDIST,ICENTR,ICHCEN,ICHNSS,ICHR  ,ICHTYP,ICODE ,ICODEI,ICONFO,$#       QN   239
MAXGRP,ICRABS,IDACD ,IDCHR ,IDCIS ,IDISTZ,JDISTZ,$#                     QN   240
IGDIS2,IGDIST,IHATOM,IMAINT,$#                                          QN   241
IPLN  ,IQZERO,IRESSS,IREST ,ISID1 ,ISKIPC,ISKIQN,$#                     QN   242
ITWIST,IVDW  ,JATM  ,JCHNSS,JRESSS,JVDW#                                QN   243
COMMON/COMJQN/KBWT  ,KCHR  ,KDWT  ,KHIDST,KHIWGT,$#                     QN   244
KNDACD,KPLN  ,KPS   ,$#                                                 QN   245
KRESMP,KRESMX,KS    ,KTYP  ,MANDST,MANZIP,MARKA ,MARKB ,MARKS ,$#       QN   246
MNABOR,MOTHRZ,NACIDP,$#                                                 QN   247
NACIDS,NACIDT,NAPEP ,NATOMM,NATOMS,NAXES ,$#                            QN   248
NB    ,NCELL ,NLINEC,NSYMOP,NSYMC ,NSYMM ,$#                            QN   249
NCHAIN,NCHIS ,NCHR  ,NCHTYP,NDIC  ,NDIG  ,$#                            QN   250
NDISTM,NDISTS,NIDEAL,$#                                                 QN   251
LISGEN,LISTIT,NOAT  ,NOATOM,NOCC  ,NOCHRL,NODIST,NOSPDS,$#              QN   252
NONOW ,NOPLAN,NOTOR ,NOVDW ,NPAIRS,NPLATS,NRESCH,NRESID,NSS   ,$#       QN   253
NTCHAN,NTRMS ,NUMHET,NVDWS ,NXY   ,NXYZ# ##                             QN   254
COMMON/COMKQN/$#                                                        QN   255
DEFAUL,FILEA ,FILEF ,$#                                                 QN   256
LRANI ,LRCHI ,LRDIS ,LRPLA ,LRSYM ,LRTOR ,LRVDW ,$##                    QN   257
PKANI ,PKCHI ,PKDIS ,PKPLA ,PKSYM ,PKTOR ,PKVDW ,RESEQU,$#              QN   258
SAVID ,SAVINP,SAVNCH,STEPA ,STEPS ,STOPA ,STOPB ,STOPS ,TOTRES#         QN   259
endext:#                                                                QN   260
#                                                                       QN   261
systemheader:(QN00)## Control of subroutine sequence & summary print    QN00   1
####################################################################    QN00   2
#                                                                  #    QN00   3
#                                QN00                              #    QN00   4
#                                                                  #    QN00   5
####################################################################    QN00   6
SUBROUTINE QN00#                       J.m. stewart july 1989           QN00   7
#                                                                       QN00   8
include:(AACOMN)#                                                       QN00   9
include:(QNCOMN)#                                                       QN00  10
#                                                                       QN00  11
#                                                                       QN00  12
#          DATA ON THE PROTIN LINE IS PICKED UP IN QN19. IN QN19        QN00  13
#          THE LIST OF EXPECTED INPUT LINE IDENTITIES IS                QN00  14
#          PLACED IN THE COMMON ARRAY INLINE.  LINE READING TAKES       QN00  15
#          PLACE IN THE SUBROUTINES AS SET FORTH BELOW. WHEN AN         QN00  16
#          END LINE IS ENCOUNTERED ALL INPUT LINE READING CEASES.       QN00  17
#    QN19  READS LINES 1-5, DISULB,ALTCHN,FIRSTP,XXXXXX,SPCPEP          QN00  18
CALL QN19#                                                              QN00  19
#                                                                       QN00  20
#----SET UP THE DICTIONARIES OF IDEAL VALUES FROM IDEAL DATA            QN00  21
#    -------------------------------------------------------            QN00  22
#                                                                       QN00  23
#    QN21  READS LINES 6-9, RESTRM,RESLNK,RESIDU,RESIDE                 QN00  24
CALL QN21#                             Call residu                      QN00  25
IF(IHATOM==2) CALL QN22#               Call shrink                      QN00  26
#    QN23  READS LINES 10-12, DISRES,DISLNK,DISTRM                      QN00  27
CALL QN23#                             Call distns                      QN00  28
#    QN24  READS LINES 13-16, PLARES,PLALNK,PLATRM,PLAPRO               QN00  29
CALL QN24#                             Call planes                      QN00  30
#    QN25  READS LINE 17, CHIRAL                                        QN00  31
CALL QN25#                             Call chiral                      QN00  32
#    QN26  READS LINES 18-22, VDWDIS,VDWRES,VDWLNK,VDWTRM,VDWCON        QN00  33
CALL QN26#                             Call vdwaal                      QN00  34
#    QN27  READS LINES 23-25, TORRES,TORTRM,SECSTR                      QN00  35
#          AND ALSO CHIWGT,NEIGHB,CHIDIS AS SUB-LINES SET IN QN27       QN00  36
CALL QN27#                             Call torshn                      QN00  37
#    QN28  READS LINES 26 & 27 ELLTRM & ELLRES                          QN00  38
CALL QN28#                             Call ellips                      QN00  39
#----LOAD ATOMIC COORDINATES                                            QN00  40
CALL QN40## CALL ATOMIN                                                 QN00  41
CALL QN45## CALL CENTRD                                                 QN00  42
#----DETERMINE INTERATOMIC DISTANCES                                    QN00  43
#    QN51  READS LINES 28-30,  INTERD,INTRAD,SPCDIS                     QN00  44
IF(DEFAUL==yes:)#                      Reload input buffer if 'ideals   QN00  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN00  46
LINID=SAVID ; movechar:(SAVCH,1,CHRIN,1,80,0)# Was read from aux inpu   QN00  47
DO J=1,SAVNCH ; BUFIN(J)=SAVBUF(J)#    Refill bufin as if nothing       QN00  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN00  49
CALL QN51## call dsttab(nodist,ieofin,idcis)                            QN00  50
#----DETERMINE PLANAR GROUPS                                            QN00  51
#    QN52 READS LINE 31, SPCPLA                                         QN00  52
CALL QN52## call plntab(noplan,ieofin,kresmp,iskiQN,iskipc)             QN00  53
#----DETERMINE CHIRAL CENTERS                                           QN00  54
CALL QN53## call cctab(nochrl)                                          QN00  55
#----DETERMINE POSSIBLE INTRA-MOLECULAR VDW CONTACTS                    QN00  56
CALL QN54## call vdwinr(novdw,nonow,isid1,vdwcut)                       QN00  57
#    QN55  READS LINE 32, EXCON                                         QN00  58
CALL QN55## call sdsort (ieofin)                                        QN00  59
CALL QN56## call vdwbtr(novdw,nonow,ihatom,isid1,vdwcut)                QN00  60
# DETERMINE POSSIBLE SYMMETRY-RELATED VDW CONTACTS                      QN00  61
CALL QN61## Call moldst (vdwcut)                                        QN00  62
CALL QN63## Call cube (vdwcut)                                          QN00  63
CALL QN64## Call symdcb (novdw,nonow,natp1,ihatom,vdwcut)               QN00  64
#----DETERMINE CONFORMATIONAL TORSION ANGLES                            QN00  65
#    QN65  READS LINE 33,  SECSEL                                       QN00  66
CALL QN65## Call tortab (notor,ieofin,idcis)                            QN00  67
#----DETERMINE NON-CRYSTALLOGRAPHIC SYMMETRIES                          QN00  68
#    QN66  READS LINES 34-36,  SPCSYM,SYMOP,SYMWGT                      QN00  69
CALL QN66## Call ncstab (nsymm,ieofin,idchn)                            QN00  70
#----DETERMINE THERMAL ELLIPSOID SPECIFIERS                             QN00  71
CALL QN68## Call tetab                                                  QN00  72
#                                                                       QN00  73
#----LIST SUMMARY COUNTS FOR INPUT TO LEAST-SQUARES REFINEMENT          QN00  74
#    AND FINISH OFF FILE F FOR COMMUNICATION TO PROLSQ                  QN00  75
#                                                                       QN00  76
CALL QN99#                                                              QN00  77
#                                                                       QN00  78
IF(QUITF!=' ') iquit:(QN0001)#         Die if other errors              QN00  79
#                                                                       QN00  80
RETURN#                                                                 QN00  81
END#                                                                    QN00  82
systemheader:(QN02)## Establish type of van der Waals contacts          QN02   1
####################################################################    QN02   2
#                                                                  #    QN02   3
#                                QN02                              #    QN02   4
#                                                                  #    QN02   5
####################################################################    QN02   6
SUBROUTINE QN02(IACID,IATOM,IRES,ICHAIN,IRESC,JACID,JATOM,$#            QN02   7
JRES,JCHAIN,JRESC,LTYP,DISV)#                                           QN02   8
include:(AACOMN)#                                                       QN02   9
include:(QNCOMN)#                                                       QN02  10
#                                                                       QN02  11
#    SUBROUTINE VDWTYP(IACID,IATOM,IRES,ICHAIN,IRESC,JACID,JATOM,       QN02  12
#   $ JRES,JCHAIN,JRESC,IHATOM,LTYP,DISV)                               QN02  13
#                                                                       QN02  14
#----DETERMINE TYPE OF VAN DER WAALS CONTACTS                           QN02  15
#                                                                       QN02  16
string:(ID,4)#                         For matching residue names       QN02  17
string:(JD,4)#                                                          QN02  18
chardata:(NUMS,123)#                                                    QN02  19
realdata:(FMT,[380113.,430313.,530113.,580113.])#                       QN02  20
chardata:(QN02A, POSSIBLE NON-BONDED CONTACT BETWEEN I XXXXXXXX $#      QN02  21
AND I XIIIXXXX )#                                                       QN02  22
datastuff:#                                                             QN02  23
#                                                                       QN02  24
#----FIND THIS VAN DER WAALS CONTACT DISTANCE                           QN02  25
IERROR=0 ; IA=NOAT(IATOM,IRES,ICHAIN)#                                  QN02  26
IAA=MARKA+(IA-1)*STEPA#                                                 QN02  27
movertoc:(QX(IAA+5),1,ID,1,4,0)#                                        QN02  28
JA=NOAT(JATOM,JRES,JCHAIN) ; IK=KS(IACID,IATOM)#                        QN02  29
JAA=MARKA+(JA-1)*STEPA#                                                 QN02  30
movertoc:(QX(JAA+5),1,JD,1,4,0)#                                        QN02  31
JK=KS(JACID,JATOM) ; DISV=DVDW(IK,JK) ; LTYP=2#                         QN02  32
#                                                                       QN02  33
#----IS THIS A POTENTIAL HYDROGEN-BONDING X....Y PAIR                   QN02  34
IF(IK!=7&IK!=8) GO TO 120#                                              QN02  35
IF(JK!=7&JK!=8) GO TO 120#                                              QN02  36
IF(JRES>JRESC\IRES>IRESC) GO TO 110#                                    QN02  37
IF(IATOM==4&JATOM==4) GO TO 190#                                        QN02  38
IF(IATOM==1&JATOM==1) GO TO 190#                                        QN02  39
110 LTYP=3#                                                             QN02  40
GO TO 190#                                                              QN02  41
#                                                                       QN02  42
#----IS THIS A POTENTIAL HYDROGEN-BONDING X-H..Y PAIR                   QN02  43
120 IF(IHATOM==0) GO TO 190#                                            QN02  44
IF(IK!=1) GO TO 150#                                                    QN02  45
IF(JK!=7&JK!=8) GO TO 150#                                              QN02  46
IAN=NATOMS(IACID)#                                                      QN02  47
DO IAI=1,IAN#                                                           QN02  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN02  49
KK=KS(IACID,IAI)#                                                       QN02  50
IF((KK<6\KK>8)&(KK!=16)) NEXT#                                          QN02  51
compchar:(ID,2,IDS,(IACID-1)*qmxat4:+(IAI-1)*4+2,2,2,2,K)#              QN02  52
IF(K==1) GO TO 180#                    When second characters match     QN02  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN02  54
DO IAI=1,IAN#                                                           QN02  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN02  56
KK=KS(IACID,IAI)#                                                       QN02  57
IF((KK<6\KK>8)&(KK!=16)) NEXT#                                          QN02  58
compchar:(ID,3,IDS,(IACID-1)*qmxat4:+(IAI-1)*4+3,1,1,1,K)#              QN02  59
IF(K==1) GO TO 180#                    When third characters match      QN02  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN02  61
KK=KS(IACID,1)#                                                         QN02  62
compchar:(ID,3,NUMS,1,1,1,NNUMS,K) ; IF(K!=0) GO TO 180#                QN02  63
IERROR=1#                                                               QN02  64
GO TO 190#                                                              QN02  65
#                                                                       QN02  66
#----IS THIS A POTENTIAL HYDROGEN-BONDING X..H-Y PAIR                   QN02  67
150 IF(IK!=7&IK!=8) GO TO 190#                                          QN02  68
IF(JK!=1) GO TO 190#                                                    QN02  69
JAN=NATOMS(JACID)#                                                      QN02  70
DO JAI=1,JAN#                                                           QN02  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN02  72
KK=KS(JACID,JAI)#                                                       QN02  73
IF((KK<6\KK>8)&(KK!=16)) NEXT#                                          QN02  74
compchar:(JD,2,IDS,(JACID-1)*qmxat4:+(JAI-1)*4+2,2,2,2,K)#              QN02  75
IF(K==1) GO TO 180#                    When second characters match     QN02  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN02  77
DO JAI=1,JAN#                                                           QN02  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN02  79
KK=KS(JACID,JAI)#                                                       QN02  80
IF((KK<6\KK>8)&(KK!=16)) NEXT#                                          QN02  81
compchar:(JD,3,IDS,(JACID-1)*qmxat4:+(JAI-1)*4+3,1,1,1,K)#              QN02  82
IF(K==1) GO TO 180#                    When third characters match      QN02  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN02  84
KK=KS(JACID,1)#                                                         QN02  85
compchar:(JD,3,NUMS,1,1,1,NNUMS,K) ; IF(K!=0) GO TO 180#                QN02  86
IERROR=1#                                                               QN02  87
GO TO 190#                                                              QN02  88
#                                                                       QN02  89
#----IS THE MOTHER ATOM AN OXYGEN OR NITROGEN?                          QN02  90
180 CONTINUE#                                                           QN02  91
IF(KK==7\KK==8) LTYP=4#                                                 QN02  92
190 CONTINUE#                                                           QN02  93
IF(IERROR!=0)#                         Error message                    QN02  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN02  95
BUFOT(1)=FLOAT(ICHAIN) ; BUFOT(2)=FLOAT(IRES)#                          QN02  96
BUFOT(3)=FLOAT(JCHAIN) ; BUFOT(4)=FLOAT(IRES)#                          QN02  97
ncodefld:(BUFOT,1,QN02A,FMT,4)#                                         QN02  98
movechar:(ID,1,QN02A,44,4,0);movechar:(JD,1,QN02A,59,4,0)#              QN02  99
writeline:(0,QN02A,NQN02A,3,4)#                                         QN02 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN02 101
RETURN#                                                                 QN02 102
END#                                                                    QN02 103
systemheader:(QN03)## Function to produce a 3X3 determinant             QN03   1
####################################################################    QN03   2
#                                                                  #    QN03   3
#                                QN03                              #    QN03   4
#                                                                  #    QN03   5
####################################################################    QN03   6
REAL FUNCTION QN03(A)#                                                  QN03   7
#                                                                       QN03   8
#     FUNCTION DET3(A)                                                  QN03   9
DIMENSION A(3,3)#                                                       QN03  10
QN03=A(1,1)*(A(2,2)*A(3,3)-A(2,3)*A(3,2))$#                             QN03  11
-A(1,2)*(A(2,1)*A(3,3)-A(2,3)*A(3,1))$#                                 QN03  12
+A(1,3)*(A(2,1)*A(3,2)-A(2,2)*A(3,1))#                                  QN03  13
RETURN#                                                                 QN03  14
END#                                                                    QN03  15
systemheader:(QN04)## Input line character string checking              QN04   1
####################################################################    QN04   2
#                                                                  #    QN04   3
#                                QN04                              #    QN04   4
#                                                                  #    QN04   5
####################################################################    QN04   6
SUBROUTINE QN04(GRQNM,IN,NCH)#                                          QN04   7
#                                                                       QN04   8
include:(AACOMN)#                                                       QN04   9
INTEGER IN,I,J,NCH##                                                    QN04  10
string:(GRQNM,24)## String for comparison                               QN04  11
IF(BUFIN(IN)>=voidflg:) iquit:(QN2301,IN)# Must be char's               QN04  12
stringlim:(IN,I,J) ; J=MIN0(J-I,NCH)#  Get limits of string             QN04  13
movechar:(BLANK,1,GRQNM,1,NCH,1)#      Blank out residue name           QN04  14
movechar:(CHRIN,I,GRQNM,1,J,0)#        Take in new residue name         QN04  15
RETURN#                                                                 QN04  16
END#                                                                    QN04  17
systemheader:(QN05)## Input line character string identifier            QN05   1
####################################################################    QN05   2
#                                                                  #    QN05   3
#                                QN05                              #    QN05   4
#                                                                  #    QN05   5
####################################################################    QN05   6
SUBROUTINE QN05(GRQNM,IPOINT,LIST,MAXCH,NCH)#                           QN05   7
#                                                                       QN05   8
include:(AACOMN)#                                                       QN05   9
INTEGER IPOINT## Pointer to found name in list; 0 if missing            QN05  10
INTEGER MAXCH## Total number of characters in list                      QN05  11
INTEGER NCH## Number of characters in each 'name' in list               QN05  12
INTEGER I,J## Local indices                                             QN05  13
string:(LIST,400)## List of 'names' to be searched                      QN05  14
string:(GRQNM,24)## 'name' sought in list                               QN05  15
string:(CMQNM,24)## Temporary storage of 'name' in list to search       QN05  16
chardata:(QN05A, EXPECTED NAMES IN INPUT LINE.....)#                    QN05  17
datastuff:#                                                             QN05  18
IPOINT=0 ; J=0 ; DO I=1,MAXCH,NCH#     Search prev'sly loaded residue   QN05  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN05  20
movechar:(LIST,I,CMQNM,1,NCH,0)#       Pick up old name                 QN05  21
compchar:(GRQNM,1,CMQNM,1,NCH,NCH,NCH,IHIT)# Check against new name     QN05  22
J=J+1 ; IF(IHIT==0) NEXT#              No match, keep checking          QN05  23
ELSE#                                  Hit it                           QN05  24
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN05  25
IPOINT=J ; BREAK#                      Remember it and go out           QN05  26
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN05  27
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN05  28
IF(IPOINT==0)#                                                          QN05  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN05  30
LINRM=2 ; DO I=1,MAXCH,NCH#            List out the allowed ones        QN05  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN05  32
movechar:(LIST,I,CHROT,2,NCH,0)#       Blather names                    QN05  33
writeline:(0,QN05A,NQN05A,1,1)#                                         QN05  34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN05  35
iquit:(QN0501)#                        It simply has to be there        QN05  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN05  37
RETURN#                                                                 QN05  38
END#                                                                    QN05  39
systemheader:(QN06)#                   Write distance restraints        QN06   1
####################################################################    QN06   2
#                                                                  #    QN06   3
#                                QN06                              #    QN06   4
#                                                                  #    QN06   5
####################################################################    QN06   6
SUBROUTINE QN06(IA,JA,DISTP,KDWTP,KBWTP)#                               QN06   7
#                                                                       QN06   8
include:(AACOMN)#                                                       QN06   9
include:(QNCOMN)#                                                       QN06  10
INTEGER IA,JA,KDWTP,KBWTP## Variables for distance                      QN06  11
REAL DISTP## restraints                                                 QN06  12
INTEGER PUTPK#                         Packet pointer                   QN06  13
writepkt:(FILEF,LRDIS,PKDIS,PUTPK)#                                     QN06  14
QX(PUTPK+1)=FLOAT(NODIST) ; QX(PUTPK+2)=FLOAT(IA)#                      QN06  15
QX(PUTPK+3)=FLOAT(JA) ; QX(PUTPK+4)=DISTP#                              QN06  16
QX(PUTPK+5)=FLOAT(KDWTP) ; QX(PUTPK+6)=FLOAT(KBWTP)#                    QN06  17
RETURN#                                                                 QN06  18
END#                                                                    QN06  19
systemheader:(QN07)#                   Write plane restraints           QN07   1
####################################################################    QN07   2
#                                                                  #    QN07   3
#                                QN07                              #    QN07   4
#                                                                  #    QN07   5
####################################################################    QN07   6
SUBROUTINE QN07(NA,LAT)#                                                QN07   7
#                                                                       QN07   8
include:(AACOMN)#                                                       QN07   9
include:(QNCOMN)#                                                       QN07  10
INTEGER NA,LAT(*)## Variables for planes                                QN07  11
INTEGER PUTPK,I#                       Packet pointers                  QN07  12
writepkt:(FILEF,LRPLA,PKPLA,PUTPK)#                                     QN07  13
QX(PUTPK+1)=FLOAT(NOPLAN) ; QX(PUTPK+2)=FLOAT(NA)#                      QN07  14
DO I=1,NA ; QX(PUTPK+I+2)=FLOAT(LAT(I))#                                QN07  15
RETURN#                                                                 QN07  16
END#                                                                    QN07  17
systemheader:(QN08)## Write chiral centers restraints                   QN08   1
####################################################################    QN08   2
#                                                                  #    QN08   3
#                                QN08                              #    QN08   4
#                                                                  #    QN08   5
####################################################################    QN08   6
SUBROUTINE QN08(LAT,LPR,V)#                                             QN08   7
#                                                                       QN08   8
include:(AACOMN)#                                                       QN08   9
include:(QNCOMN)#                                                       QN08  10
INTEGER LAT(*),LPR(*)## Variables for chiral centers                    QN08  11
REAL V## restraints                                                     QN08  12
INTEGER PUTPK,I#                       Packet pointers                  QN08  13
writepkt:(FILEF,LRCHI,PKCHI,PUTPK)#                                     QN08  14
QX(PUTPK+1)=FLOAT(NOCHRL)#                                              QN08  15
DO I=1,4 ; QX(PUTPK+I+1)=FLOAT(LAT(I))#                                 QN08  16
DO I=1,6 ; QX(PUTPK+I+5)=FLOAT(LPR(I))#                                 QN08  17
QX(PUTPK+12)=V#                                                         QN08  18
RETURN#                                                                 QN08  19
END#                                                                    QN08  20
systemheader:(QN09)## Write van der Waals distance restraints           QN09   1
####################################################################    QN09   2
#                                                                  #    QN09   3
#                                QN09                              #    QN09   4
#                                                                  #    QN09   5
####################################################################    QN09   6
SUBROUTINE QN09(IA,JA,DNBCP,KTYPP)#                                     QN09   7
#                                                                       QN09   8
include:(AACOMN)#                                                       QN09   9
include:(QNCOMN)#                                                       QN09  10
INTEGER IA,JA,KTYPP## Variables for van der Waals                       QN09  11
REAL DNBCP## distance restraints                                        QN09  12
INTEGER PUTPK#                         Packet pointer                   QN09  13
writepkt:(FILEF,LRVDW,PKVDW,PUTPK)#                                     QN09  14
QX(PUTPK+1)=FLOAT(NOVDW) ; QX(PUTPK+2)=FLOAT(IA)#                       QN09  15
QX(PUTPK+3)=FLOAT(JA) ; QX(PUTPK+4)=DNBCP#                              QN09  16
QX(PUTPK+5)=FLOAT(KTYPP)#                                               QN09  17
RETURN#                                                                 QN09  18
END#                                                                    QN09  19
systemheader:(QN10)## Write torsion angle restraints                    QN10   1
####################################################################    QN10   2
#                                                                  #    QN10   3
#                                QN10                              #    QN10   4
#                                                                  #    QN10   5
####################################################################    QN10   6
SUBROUTINE QN10(IRES,IANG,KAT,LPR,IWT,TAG)#                             QN10   7
#                                                                       QN10   8
include:(AACOMN)#                                                       QN10   9
include:(QNCOMN)#                                                       QN10  10
INTEGER IRES,IANG,KAT(*),LPR(*)## Variables for torsion                 QN10  11
REAL TAG## angle restraints                                             QN10  12
INTEGER PUTPK,I#                       Packet pointer                   QN10  13
writepkt:(FILEF,LRTOR,PKTOR,PUTPK)#                                     QN10  14
QX(PUTPK+1)=FLOAT(NOTOR) ; QX(PUTPK+2)=FLOAT(IRES)#                     QN10  15
QX(PUTPK+3)=FLOAT(IANG) ; QX(PUTPK+14)=FLOAT(IWT)#                      QN10  16
QX(PUTPK+15)=TAG#                                                       QN10  17
DO I=1,4 ; QX(PUTPK+I+3)=FLOAT(KAT(I))#                                 QN10  18
DO I=1,6 ; QX(PUTPK+I+7)=FLOAT(LPR(I))#                                 QN10  19
RETURN#                                                                 QN10  20
END#                                                                    QN10  21
systemheader:(QN11)#                   Residues external to internal    QN11   1
####################################################################    QN11   2
#                                                                  #    QN11   3
#                                QN11                              #    QN11   4
#                                                                  #    QN11   5
####################################################################    QN11   6
SUBROUTINE QN11(INBFR,ICHN,POINT)#     J.m. stewart june 1989           QN11   7
#                                                                       QN11   8
include:(AACOMN)#                                                       QN11   9
include:(QNCOMN)#                                                       QN11  10
INTEGER POINT## Integer that points to residue in internal tables       QN11  11
INTEGER ICHN## Chain number                                             QN11  12
INTEGER INBFR## BUFIN(?) that is to be screened and translated          QN11  13
INTEGER J,J1## Indices                                                  QN11  14
IF(BUFIN(INBFR)<=0.0) iquit:(-QN1101,INBFR)# Must be number!            QN11  15
POINT=NINT(BUFIN(INBFR))#              Take external number             QN11  16
J1=no: ; FOR(J=1;J<=NRESCH(ICHN);J=J+1)# Loop over residues             QN11  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN11  18
IF(POINT==RESEQU(J,ICHN))#             Look for match in table          QN11  19
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN11  20
POINT=J ; J1=yes: ; BREAK#             Got it, reset to internal        QN11  21
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN11  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN11  23
IF(J1==no:) iquit:(-QN1102,INBFR)#     It has to be there or die        QN11  24
RETURN#                                                                 QN11  25
END#                                                                    QN11  26
systemheader:(QN12)#                   Chains external to internal      QN12   1
####################################################################    QN12   2
#                                                                  #    QN12   3
#                                QN12                              #    QN12   4
#                                                                  #    QN12   5
####################################################################    QN12   6
SUBROUTINE QN12(INBFR,POINT)#          J.m. stewart june 1989           QN12   7
#                                                                       QN12   8
include:(AACOMN)#                                                       QN12   9
include:(QNCOMN)#                                                       QN12  10
INTEGER POINT## Integer that points to residue in internal tables       QN12  11
INTEGER INBFR## BUFIN(?) that is to be screened and translated          QN12  12
INTEGER J## Indices                                                     QN12  13
string:(CHAINI,3)#                     For chain id as characters       QN12  14
ifvo:(BUFIN(INBFR)) iquit:(-QN1201,INBFR)# Must not be void!            QN12  15
ELSE IF(BUFIN(INBFR)<voidflg:)#        Check characters                 QN12  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN12  17
stringlim:(INBFR,I,J);J=MIN0(3,J-I)#                                    QN12  18
movechar:(BLANK,1,CHAINI,1,3,1)#       Blank out the id                 QN12  19
movechar:(CHRIN,I,CHAINI,1,J,0)#       Take the user name               QN12  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN12  21
ELSE#                                  Put number into characters       QN12  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN12  23
movechar:(BLANK,1,CHAINI,1,3,1)#       Blank out chain id               QN12  24
IF(BUFIN(INBFR)>=0.0&BUFIN(1)<=9.0)#   Generate a left justified        QN12  25
ncodefld:(BUFIN(INBFR),1,CHAINI,10113.,1)# Character string from the    QN12  26
ELSE IF(BUFIN(INBFR)>=10.0&BUFIN(INBFR)<=99.0)# Number supplied         QN12  27
ncodefld:(BUFIN(INBFR),1,CHAINI,20213.,1)# Numbers outside 0 through    QN12  28
ELSE IF(BUFIN(INBFR)>=100.0&BUFIN(INBFR)<=999.0)# Are left as blank     QN12  29
ncodefld:(BUFIN(INBFR),1,CHAINI,30313.,1)#                              QN12  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN12  31
compchar:(CHAINI,1,IDCHN,1,3,3,NCHAIN*3,POINT)# Search table            QN12  32
IF(POINT==0) iquit:(-QN1202,INBFR)#    It has to be there or di         QN12  33
RETURN#                                                                 QN12  34
END#                                                                    QN12  35
systemheader:(QN19)## Read control lines and BDF through lrsymm:        QN19   1
####################################################################    QN19   2
#                                                                  #    QN19   3
#                                QN19                              #    QN19   4
#                                                                  #    QN19   5
####################################################################    QN19   6
SUBROUTINE QN19#                       J.m. stewart june 1987           QN19   7
#                                                                       QN19   8
include:(AACOMN)#                                                       QN19   9
include:(QNCOMN)#                                                       QN19  10
#                                                                       QN19  11
#-----COMBINATION OF PROTIN MAIN PROGRAM AND CARDIN                     QN19  12
#                                                                       QN19  13
chardata:(CNTS,1234567890)#            The integers to deasciify        QN19  14
chardata:(QN19A,VDW NAP ATL HAT NEU CEL GNL DSN )# Options              QN19  15
chardata:(QN19B, DISULB ALTCHN FIRSTP XXXXXX SPCPEP $#                  QN19  16
RESTRM RESLNK RESIDU RESIDE DISRES DISLNK DISTRM )# Input lines         QN19  17
chardata:(QN19C,PLARES PLALNK PLATRM PLAPRO CHIRAL VDWDIS VDWRES $#     QN19  18
VDWLNK VDWTRM VDWCON TORRES TORTRM SECSTR )# Input lines continued      QN19  19
chardata:(QN19D,ELLTRM ELLRES INTERD INTRAD SPCDIS SPCPLA EXCON  $#     QN19  20
SECSEL SPCSYM SYMOP  SYMWGT END    )#  Input lines concluded            QN19  21
chardata:(QN11B, CONDITIONS SET FOR PROTIN RUN )#                       QN19  22
chardata:(QN11C, VAN DER WAALS LIMIT XX.XXX ANGSTROMS )#                QN19  23
chardata:(QN11D, NUMBER OF MAIN CHAIN ATOMS IN A PLANE I )#             QN19  24
chardata:(QN11E, LIST PROTEIN ATOMS         )#                          QN19  25
chardata:(QN11F, NEUTRON DATA BEING TREATED )#                          QN19  26
chardata:(QN11G, HYDROGEN ATOM SIGNAL I )#                              QN19  27
chardata:(QN11H, NUMBER OF UNIT CELLS TO SEARCH II )#                   QN19  28
chardata:(QN11I, DISULPHIDE LINKAGES TRANSLATED TO INTERNAL POINTERS )# QN19  29
chardata:(QN11J,    A       B       C     ALPHA    BETA   GAMMA  $#     QN19  30
NO. CELLS  NO. SYMOPS )#                                                QN19  31
chardata:(QN11K,[ MATRICES FOR CONVERSION OF FRACTIONAL TO ORTHOGONAL $#QN19  32
AND ORTHOGONAL TO FRACTIONAL ATOM COORDINATES - X,Y,Z])#                QN19  33
chardata:(QN11L, LIST UP TO IIII LINES OF EACH TYPE OF CONSTRAINT $#    QN19  34
DATA IF PRINT PRIORITY FOUR OR HIGHER)#                                 QN19  35
chardata:(QN11M, ALTERNATE CHAINS IN TERMS OF INTERNAL CHAIN POINTERS)# QN19  36
chardata:(QN11N, CHAIN     )#                                           QN19  37
chardata:(QN19M,CHNNTRCTRHET)## Residues: chain, N term, C term, hete   QN19  38
chardata:(QN19P,         RESIDUES CONSISTING OF    CHAINS COUNTED $#    QN19  39
DURING LOADING OF SEQUENCE DATA.)#                                      QN19  40
chardata:(QN19Q, TABLE OF RESIDUE NAMES AND SEQUENCE NUMBERS)#          QN19  41
chardata:(QN19R,YES)#                                                   QN19  42
chardata:(QN19S,NO)#                                                    QN19  43
chardata:(QN19T,***)#                  To clear strings for compare     QN19  44
chardata:(QN19U,        B OVERALL  DATA SET)#                           QN19  45
realdata:(FMT1,[210213.,260413.,290213.,340413.])#                      QN19  46
realdata:(FMT2,[360513.,410513.,470213.])#                              QN19  47
realdata:(FMT3,[360513.,410513.,460513.,510513.,560513.,610513.,$#      QN19  48
660513.,710513.,760513.,810513.,860513.,910513.,960513.,1010513.,$#     QN19  49
1060513.,1110513.,1160513.])#                                           QN19  50
realdata:(FMT4,[80732.,160732.,240732.,310622.,390622.,470622.,$#       QN19  51
540413.,640313.])#                                                      QN19  52
realdata:(FMT5,[121052.,251052.,381052.,561052.,691052.,821052.])#      QN19  53
realdata:(FMRS,[70613.,340213.])#                                       QN19  54
INTEGER HIT,HITT#                      Signals for compchar: matching   QN19  55
INTEGER PSIZ,IP#                       I/o quantities                   QN19  56
INTEGER KEYL(4),IWANT(4),IREL(5)#                                       QN19  57
intdata:(IPOW,[1000,100,10,1])#        Conversion factors               QN19  58
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              QN19  59
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              QN19  60
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              QN19  61
realdata:(TR21,[.3333333,.5])#                                          QN19  62
realdata:(TR22,[.6666667,0.])#                                          QN19  63
realdata:(TR23,[.6666667,.5])#                                          QN19  64
string:(CHAINI,3)#                     Hold chain ids for testing       QN19  65
string:(CHAOLD,3)#                     Hold chain ids for testing       QN19  66
string:(CHATYP,3)#                     Hold residue type for testing    QN19  67
INTEGER RESNUM## Integer translation of user's residue sequence no.     QN19  68
string:(RESSEQ,4)## Residue sequence no. in ascii from BDF              QN19  69
datastuff:#                                                             QN19  70
#                                                                       QN19  71
#                                                                       QN19  72
TUPI=ACOS(-1.0) ; ATPISQ=8.0*TUPI**2#  Get pi and 8pi**2                QN19  73
TUPI=2.0*TUPI ; DEGTOR=TUPI/360.#      Universal constants              QN19  74
#                                                                       QN19  75
#----READ ASSORTED CONTROL INFORMATION FROM PROTIN INPUT LINE           QN19  76
#    --------------------------------------------------------           QN19  77
#                                                                       QN19  78
NSS=0 ; NCELL=3 ; IHATOM=0 ; VDWCUT=5.0# Defaults                       QN19  79
LISTIT=no: ; NAPEP=5 ; NEUT=no: ; NZCHN=0#                              QN19  80
LISGEN=0 ; DEFAUL=no: ; DSET=1.0#                                       QN19  81
#                                                                       QN19  82
#   READ INSTRUCTIONS FROM PROTIN INPUT LINE                            QN19  83
#   ----------------------------------------                            QN19  84
#                                                                       QN19  85
FOR(K=1;BUFIN(K)<voidflg:;K=K+1)#      Loop over input fields           QN19  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN19  87
stringlim:(K,I,J)#                     Find character string            QN19  88
compchar:(CHRIN,I,QN19A,1,2,4,NQN19A,J)# Search options list            QN19  89
IF(J==0) iquit:(QN1903)#               It must be valid                 QN19  90
IF(J==1)#                              Test for van der waals limit     QN19  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN19  92
IF(BUFIN(K+1)>0.0)#                                                     QN19  93
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN19  94
VDWCUT=BUFIN(K+1) ; K=K+1#             Take users cut point             QN19  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN19  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN19  97
ELSE IF(J==2)#                         Test no. main chain restrained   QN19  98
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN19  99
IF(BUFIN(K+1)>0.0)#                                                     QN19 100
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN19 101
NAPEP=NINT(BUFIN(K+1)) ; K=K+1#        Take users number                QN19 102
IF(NAPEP<4\NAPEP>6) iquit:(QN1904)#    But check it out                 QN19 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN19 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN19 105
ELSE IF(J==3) LISTIT=yes:#             Check extent of listing to be    QN19 106
ELSE IF(J==4) IHATOM=2#                Expect hydrogen atoms/x-ray      QN19 107
ELSE IF(J==5)#                         Test if neutrons                 QN19 108
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN19 109
NEUT=yes: ; IF(IHATOM>0) IHATOM=1#     Also set for h's                 QN19 110
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN19 111
ELSE IF(J==6)#                         Test for unit cells to search    QN19 112
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN19 113
IF(BUFIN(K+1)>0.0)#                                                     QN19 114
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN19 115
NCELL=NINT(AMAX1(1.0,BUFIN(K+1))) ; K=K+1# Take users cut point         QN19 116
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN19 117
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN19 118
ELSE IF(J==7)#                         Test for general info listing    QN19 119
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN19 120
IF(BUFIN(K+1)>0.0)#                    Number in next field?            QN19 121
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN19 122
LISGEN=NINT(BUFIN(K+1)) ; K=K+1#                                        QN19 123
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN19 124
ELSE LISGEN=9999#                      Go for broke if not given        QN19 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN19 126
ELSE IF(J==8)#                         Test for data set number         QN19 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN19 128
IF(BUFIN(K+1)>0.0)#                    Number in next field?            QN19 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN19 130
DSET=BUFIN(K+1) ; K=K+1#               Accept data set number           QN19 131
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN19 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN19 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN19 134
#                                                                       QN19 135
#----SET UP I/O PARAMETERS FOR CONTROL OF COMMUNICATIONS TO PROLSQ      QN19 136
#    -------------------------------------------------------------      QN19 137
#                                                                       QN19 138
# THE CELL, SYMMETRY AND ATOMIC COORDINATES ARE READ FROM FILE A.       QN19 139
# THE RESTRAINT INFORMATION IS WRITTEN TO FILE F WITH THE COUNTS        QN19 140
# OF ALL THE VARIOUS RESTRAINTS ON THE END.  UNFORTUNATELY THIS         QN19 141
# MEANS THAT PROLSQ HAS TO SKIP TO THE END TO GET STARTED, BUT IT       QN19 142
# SAVES SCRATCH FILES AND SIMPLIFIES THE USERS LIFE.                    QN19 143
# THE LOGICAL RECORDS OF ALL BUT THE SPECIAL SYMMETRY RESTRAINTS        QN19 144
# ARE STRAIGHTFORWARD PACKETS. AND ARE WRITTEN FROM SUBROUTINES         QN19 145
# QN06 THROUGH QN10. THE WRITES FOR LRSYM ARE DONE FROM QN66.           QN19 146
FILEA=1 ; FILEF=6## Set file pointers                                   QN19 147
PKDIS=6  ; LRDIS=31## Set packet size & rec # distances         QN06    QN19 148
PKPLA=19 ; LRPLA=32## Set packet size & rec # planar groups     QN07    QN19 149
PKCHI=12 ; LRCHI=33## Set packet size & rec # chiral centers    QN08    QN19 150
PKVDW=5  ; LRVDW=34## Set packet size & rec # vdWaals distances QN09    QN19 151
PKTOR=15 ; LRTOR=35## Set packet size & rec # torsion angles    QN10    QN19 152
PKSYM=19 ; LRSYM=36## Set packet size & rec # special symmetry  QN66    QN19 153
PKANI=5  ; LRANI=37## Set packet size & rec # ANISO T.F.        QN68    QN19 154
#                                                                       QN19 155
#  SET UP ALL LINE IDENTITIES FOR CONSTRAINT INPUT                      QN19 156
#  -----------------------------------------------                      QN19 157
#                                                                       QN19 158
NLINEC=1#                                                               QN19 159
movechar:(QN19B,1,INLINE,NLINEC,NQN19B,0) ; NLINEC=NLINEC+NQN19B#       QN19 160
movechar:(QN19C,1,INLINE,NLINEC,NQN19C,0) ; NLINEC=NLINEC+NQN19C#       QN19 161
movechar:(QN19D,1,INLINE,NLINEC,NQN19D,0) ; NLINEC=NLINEC+NQN19D#       QN19 162
NLINEC=NLINEC-1#                       Set inclusive count              QN19 163
DO IACID=1,qmxgrp:#                    Initialize arrays                QN19 164
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN19 165
NATOMS(IACID)=0 ; NDISTS(IACID)=0#                                      QN19 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN19 167
movechar:(BLANK,1,IDS,1,$#                                              QN19 168
arith:(4,*,arith:(qmxatm:,*,qmxgrp:)),1)# Clear residue atom names      QN19 169
movechar:(BLANK,1,NAMEL,1,20,1)#       Clear link residue names         QN19 170
movechar:(BLANK,1,NAMEM,1,40,1)#       Clear main residue names         QN19 171
movechar:(BLANK,1,NAMES,1,arith:(4,*,qmxgrp:),1)# Clear side chains     QN19 172
movechar:(BLANK,1,MCOD,1,qmxgrp:,1)#   Clear residue synonyms           QN19 173
movechar:(BLANK,1,IDCHN,1,arith:(3,*,qmxchn:),1)# Chain names           QN19 174
movechar:(BLANK,1,IDL,1,320,1)#        Clear atom in link names         QN19 175
DO ICHAIN=1,qmxchn:#                                                    QN19 176
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN19 177
ISKIQN(ICHAIN)=0; ISKIPC(ICHAIN)=0#    Zero counts of chain related     QN19 178
KRESMX(ICHAIN)=0; NRESCH(ICHAIN)=0#    Quantities                       QN19 179
DO IRES=1,qmxres:#                                                      QN19 180
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN19 181
IDACD(IRES,ICHAIN)=0 ; ZMAIN(IRES,ICHAIN)=.FALSE.# And residue by       QN19 182
DO IATOM=1,qmxatm: ; NOAT(IATOM,IRES,ICHAIN)=0# Chain quantities        QN19 183
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN19 184
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN19 185
NOATOM=0 ; NODIST=0 ; NOPLAN=0 ; NOCHRL=0 ; NOVDW=0# Initialize count   QN19 186
NOSPDS=0 ; NONOW=0 ; NOTOR=0 ; NSYMM(1)=0 ; NSYMM(2)=0 ; NAXES=0#       QN19 187
TUPI=6.2831853 ; DEGTOR=TUPI/360.#     Universal constants              QN19 188
#                                                                       QN19 189
#----SET UP STORAGE TO READ INPUT BINARY DATA FILE                      QN19 190
#    ---------------------------------------------                      QN19 191
#                                                                       QN19 192
FILEXT(IOUNIT(FILEF))='PRT'#           Set extension for communicatio   QN19 193
IOMARK(FILEA)=QXSTR#                   Set up bdf input buffer          QN19 194
IOMARK(FILEF)=IOMARK(FILEA)+bdfbuf:#   Set up file f output buffer      QN19 195
MARKS=IOMARK(FILEF)+bdfbuf:#           Incr for file f buffer           QN19 196
incrqx:(I,MARKS,QN1901)#               Exp qx                           QN19 197
#                                                                       QN19 198
#                                                                       QN19 199
# BEGIN READING OF INPUT BINARY DATA FILE                               QN19 200
# -----------------------------------------                             QN19 201
#                                                                       QN19 202
copyfile:(FILEA,FILEF,1,decr:(lrcell:))# Copy history to file f         QN19 203
FOR(K=1;;K=K+1)#                       Loop over lrcell packets         QN19 204
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN19 205
readwpkt:(FILEA,lrcell:,PSIZ,IP,0)#    Read in cell record              QN19 206
IF(IP<=0) BREAK#                       Exit after last record           QN19 207
IF(K==1)#                                                               QN19 208
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN19 209
A1=QX(IP+1) ; A2=QX(IP+2) ; A3=QX(IP+3)# Get a, b , and c               QN19 210
ALPHA=360.*QX(IP+7) ; BETA=360.*QX(IP+8) ; GAMMA=360.*QX(IP+9)#         QN19 211
#                                                                       QN19 212
#----DETERMINE ORTHOGONALIZATION MATRIX                                 QN19 213
CA=COS(ALPHA*DEGTOR) ; CB=COS(BETA *DEGTOR)#                            QN19 214
CG=COS(GAMMA*DEGTOR) ; SG=SIN(GAMMA*DEGTOR)#                            QN19 215
ORXX=A1 ; ORXY=A2*CG ;ORXZ=A3*CB ; ORYY=A2*SG#                          QN19 216
ORYZ=A3*(CA-CB*CG)/SG#                                                  QN19 217
ORZZ=A3*SQRT(1.-CA**2-CB**2-CG**2+2.*CA*CB*CG)/SG#                      QN19 218
#                                                                       QN19 219
#----DETERMINE DEORTHOGONALIZATION MATRIX                               QN19 220
OIXX=1.0/ORXX ; OIXY=-ORXY/(ORXX*ORYY)#                                 QN19 221
OIXZ=(ORXY*ORYZ-ORYY*ORXZ)/(ORXX*ORYY*ORZZ)#                            QN19 222
OIYY=1.0/ORYY ; OIYZ=-ORYZ/(ORYY*ORZZ) ; OIZZ=1.0/ORZZ#                 QN19 223
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN19 224
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN19 225
#                                                                       QN19 226
#   EXTRACT SYMMETRY INFORMATION (LRSYMM)                               QN19 227
#   ------------------------------------                                QN19 228
#                                                                       QN19 229
readwpkt:(FILEA,lrsymm:,PSIZ,IP,0)#    Read first packet of symop r     QN19 230
LTYP=NINT(QX(IP+1))#                   Get out lattice type             QN19 231
ICNT=NINT(QX(IP+2))#                   Get out centro flag (nc=1)       QN19 232
NSYM=NINT(QX(IP+3)) ; NSYMOP=0#        Get out total symop count        QN19 233
NROT=NINT(QX(IP+4))#                   Extract number of matrices       QN19 234
NRSZ=NINT(QX(IP+5))#                   Extract no. same pattern zer     QN19 235
LTYP=LTYP-(1-ICNT)*7#                  Reduce ltyp to modulo 7          QN19 236
STEPS=12#                              Twelve numbers per symop         QN19 237
incrqx:(STOPS,MARKS+NSYM*STEPS,QN1902)# Incr qx........                 QN19 238
FOR(J=MARKS;;J=J+STEPS)#               Loop over symop packets          QN19 239
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN19 240
readwpkt:(FILEA,lrsymm:,PSIZ,IP,0)#    Point to next packet             QN19 241
IF(IP<=0) BREAK#                       Exit after last packet           QN19 242
NSYMOP=NSYMOP+1#                       Count up the symops as well      QN19 243
movereal:(QX,IP+1,QX,J+1,STEPS,1)#     Store 12-element symops          QN19 244
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN19 245
MARKA=J#                               Mark tentative start of atoms    QN19 246
K=MARKA#                               Set symm matrix pointer          QN19 247
IF(ICNT==0)#                           Test if centrosymmetric          QN19 248
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN19 249
NSYMOP=2*NSYMOP#                       Double for centric groups        QN19 250
FOR(J=MARKS;J<MARKA;J=J+1)#            Loop over symm matrices          QN19 251
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN19 252
K=K+1#                                 Incr storage pointer             QN19 253
QX(K)=-QX(J+1)#                        Store inverse element            QN19 254
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN19 255
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN19 256
N=K#                                   Store temp end marker            QN19 257
IF(LTYP>1)#                            Test if sg centered              QN19 258
FOR(J=MARKS;J<N;J=J+STEPS)#            Loop over symm matrices          QN19 259
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QN19 260
NSYMOP=NSYMOP+1#                       Count up the ones from centeri   QN19 261
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            QN19 262
QX(K+10)=QX(J+10)+TR11(LTYP-1)#        Transfer t1                      QN19 263
QX(K+11)=QX(J+11)+TR12(LTYP-1)#        Transfer t2                      QN19 264
QX(K+12)=QX(J+12)+TR13(LTYP-1)#        Transfer t3                      QN19 265
K=K+STEPS#                             Incr storage pointer             QN19 266
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               QN19 267
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            QN19 268
QX(K+10)=QX(J+10)+TR21(LTYP-2)#        Transfer t1                      QN19 269
QX(K+11)=QX(J+11)+TR22(LTYP-2)#        Transfer t2                      QN19 270
QX(K+12)=QX(J+12)+TR23(LTYP-2)#        Transfer t3                      QN19 271
K=K+STEPS#                             Incr storage pointer             QN19 272
IF(LTYP!=4) NEXT#                      Skip if not f-centre             QN19 273
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            QN19 274
QX(K+10)=QX(J+10)+0.5#                 Transfer t1                      QN19 275
QX(K+11)=QX(J+11)+0.5#                 Transfer t2                      QN19 276
QX(K+12)=QX(J+12)+0.0#                 Transfer t3                      QN19 277
K=K+STEPS#                             Incr storage pointer             QN19 278
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QN19 279
MARKA=K#                               Mark start of atom array in qx   QN19 280
#                                                                       QN19 281
#  GET CHAIN INFORMATION SUPPLIED IN LRSEQU OF BDF                      QN19 282
#  -----------------------------------------------                      QN19 283
#                                                                       QN19 284
NRESID=0 ; NTCHAN=0 ; NCHTYP=0 ; L=1#  Zero counts                      QN19 285
movechar:(QN19T,1,CHAOLD,1,NQN19T,0)#  Reset old chain id to *          QN19 286
REPEAT#                                Loop over all residues           QN19 287
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QN19 288
readwpkt:(FILEA,lrsequ:,PSIZ,IP,0)#    Read in sequence record          QN19 289
IF(IP<=0) BREAK#                       Exit after last packet           QN19 290
NRESID=NRESID+1#                       Count residue groups             QN19 291
movertoc:(QX(IP+1),5,RESSEQ,1,4,0)#    Get residue sequence no.         QN19 292
RESNUM=0 ; DO I=1,4#                   Translate ascii to integer       QN19 293
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QN19 294
compchar:(RESSEQ,I,CNTS,1,1,1,9,K);RESNUM=RESNUM+K*IPOW(I)# Ascii/int   QN19 295
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QN19 296
#                                                                       QN19 297
# READ OUT THE SEQUENCE INFORMATION GARNERED IN THE PROATM PROGRAM      QN19 298
# ----------------------------------------------------------------      QN19 299
#                                                                       QN19 300
movertoc:(QX(IP+1),10,CHATYP,1,3,0)#   Get residue type for checking    QN19 301
movertoc:(QX(IP+1),14,CHAINI,1,3,0)#   Get chain id for checking        QN19 302
compchar:(CHAINI,1,CHAOLD,1,3,3,3,HIT)# Check for changed chain id      QN19 303
IF(HIT==0)#                            Zero means it changes here       QN19 304
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QN19 305
IF(NTCHAN==0)#                         For first write chain heading    QN19 306
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QN19 307
writeline:(1,QN19Q,NQN19Q,3,3) ; HIT=1# Heading & signal chain print    QN19 308
movechar:(CHAINI,1,QN11N,8,3,0) ; writeline:(1,QN11N,NQN11N,3,3)#       QN19 309
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QN19 310
NTCHAN=NTCHAN+1 ; NCHTYP=NCHTYP+1#     Recount chains two ways          QN19 311
ICHTYP(NTCHAN)=NTCHAN ; MOTHRZ(NTCHAN)=NTCHAN# Record chains            QN19 312
movechar:(CHAINI,1,CHAOLD,1,3,0)#      Remember new name for compare    QN19 313
movechar:(CHAINI,1,IDCHN,3*(NTCHAN-1)+1,3,0)# Put new name in table     QN19 314
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QN19 315
NRESCH(NTCHAN)=NRESCH(NTCHAN)+1#       Keep track of residues per cha   QN19 316
RESEQU(NRESCH(NTCHAN),NTCHAN)=RESNUM#  Save in equivalence table        QN19 317
KRESMX(NTCHAN)=NRESCH(NTCHAN)#         Keep track of maximum residue    QN19 318
compchar:(CHATYP,1,QN19M,1,3,3,NQN19M,HITT)# Check residue type         QN19 319
IF(HITT==2)#                           Itsa n terminal group            QN19 320
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QN19 321
IREST(2*(NTCHAN-1)+1)=NRESCH(NTCHAN)#  Point to residue in chain        QN19 322
IMAINT(2*(NTCHAN-1)+1)=3#              Set "namino"                     QN19 323
movertoc:(QX(IP+1),1,NAMNTR,4*(NTCHAN-1)+1,4,0)# Remember residue nam   QN19 324
KRESMP(NTCHAN)=NRESCH(NTCHAN)#         No. of residues to c terminal    QN19 325
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QN19 326
IF(HITT==3)#                           Itsa c terminal group            QN19 327
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 QN19 328
IREST(2*(NTCHAN-1)+2)=NRESCH(NTCHAN)#  Point to residue in chain        QN19 329
IMAINT(2*(NTCHAN-1)+2)=2#              Set "cterm"                      QN19 330
movertoc:(QX(IP+1),1,NAMCTR,4*(NTCHAN-1)+1,4,0)# Remember residue nam   QN19 331
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 QN19 332
IF(L>120\HIT==0)#                      Twelve residues per line         QN19 333
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 QN19 334
L=1 ; writeline:(0,0,0,1,3)#           Put out a line                   QN19 335
IF(HIT==0)#                            Write chain heading on change    QN19 336
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 QN19 337
movechar:(CHAINI,1,QN11N,8,3,0) ; writeline:(1,QN11N,NQN11N,3,3)#       QN19 338
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 QN19 339
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 QN19 340
movertoc:(QX(IP+1),1,CHROT,L+1,8,0) ; L=L+10# Fill print line           QN19 341
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QN19 342
writeline:(0,0,0,1,3)#                 Dump last line                   QN19 343
BUFOT(1)=FLOAT(NRESID) ; BUFOT(2)=FLOAT(NCHTYP)# Say resid's & chains   QN19 344
ncodefld:(BUFOT,1,QN19P,FMRS,2) ; writeline:(1,QN19P,NQN19P,3,3)#       QN19 345
NTRMS=2*NCHTYP#                        Set search count used in qn21!   QN19 346
NCHAIN=NTCHAN#                         Set main and alt chain counts    QN19 347
#                                                                       QN19 348
# GET OUT B OVERALL FROM LRDSET                                         QN19 349
# -----------------------------                                         QN19 350
#                                                                       QN19 351
BOVER=10.0#                            Default if no ov'll t.f.in bdf   QN19 352
DO J=1,4;  KEYL(J)=0#                  Reset indexpkt search limits     QN19 353
KEYL(3)=1 ; IWANT(1)=1#                Get dataset pointer              QN19 354
KEYL(3)=KEYL(3)+1#                     Set up to put away uov           QN19 355
IWANT(2)=2#                            U overall idnum                  QN19 356
indexpkt:(FILEA,lrdset:,PSIZ,IP,0,KEYL,IWANT,IREL)# Get header packet   QN19 357
IF(IP<=0\IREL(1)<=0) iquit:(QN1912)#   Die if no record on file         QN19 358
LINRM=3#                               Set up heading                   QN19 359
#                                                                       QN19 360
REPEAT#                                                                 QN19 361
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 QN19 362
readwpkt:(FILEA,lrdset:,PSIZ,IP,0)#    Read packets by data set         QN19 363
IF(IP<=0) BREAK#                       To end of all data sets          QN19 364
ifne:(DSET,QX(IREL(1)+IP)) NEXT#       Get right data set               QN19 365
IF(IREL(2)>0)#                         Test if uov present              QN19 366
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 QN19 367
BOVER=ATPISQ*QX(IP+IREL(2))#           Move in the bov                  QN19 368
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 QN19 369
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 QN19 370
#                                                                       QN19 371
#-----REPORT OUT RUN PARAMETERS FROM PROTIN INPUT LINE                  QN19 372
#     ------------------------------------------------                  QN19 373
#                                                                       QN19 374
LINRM=5 ; writeline:(1,QN11B,NQN11B,3,3)# Heading                       QN19 375
ncodefld:(VDWCUT,1,QN11C,270632.,1)#                                    QN19 376
writeline:(1,QN11C,NQN11C,3,3)#        Van der waals cut point          QN19 377
ncodefld:(FLOAT(NAPEP),1,QN11D,400113.,1)#                              QN19 378
writeline:(1,QN11D,NQN11D,3,3)#        Constrained to a plane           QN19 379
IF(NEUT==yes:) writeline:(1,QN11F,NQN11F,3,3)# Neutron data             QN19 380
ncodefld:(FLOAT(IHATOM),1,QN11G,230113.,1)#                             QN19 381
writeline:(1,QN11G,NQN11G,3,3)#        Hydrogen atm switch              QN19 382
ncodefld:(FLOAT(NCELL),1,QN11H,340213.,1)#                              QN19 383
writeline:(1,QN11H,NQN11H,3,3)#        Unit cell search                 QN19 384
IF(LISTIT==yes:) movechar:(QN19R,1,QN11E,26,NQN19R,0)#                  QN19 385
ELSE movechar:(QN19S,1,QN11E,10,NQN19S,0)#                              QN19 386
writeline:(1,QN11E,NQN11E,3,3)#        Atom listing situation           QN19 387
ncodefld:(FLOAT(LISGEN),1,QN11L,160413.,1)#                             QN19 388
writeline:(1,QN11L,NQN11L,3,3)#        General listing situation        QN19 389
LINRM=3; writeline:(1,QN19U,NQN19U,3,3)# Print bov header               QN19 390
ncodefld:(BOVER,1,CHROT,180622.,1)#    Put out the uov as bov           QN19 391
ncodefld:(DSET,1,CHROT,280413.,1)#     Put out the dataset              QN19 392
writeline:(1,0,0,1,3)#                                                  QN19 393
#                                                                       QN19 394
#-----READ INPUT LINES FOR MISCELLANEOUS DATA                           QN19 395
#     ---------------------------------------                           QN19 396
#                                                                       QN19 397
REPEAT#                                                                 QN19 398
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 QN19 399
readline:(INLINE,NLINEC)#              Load the input line buffer       QN19 400
IF(LINID>=28)#                         Test id beyond 'ideals' lines    QN19 401
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 QN19 402
SAVID=LINID ; movechar:(CHRIN,1,SAVCH,1,80,0)# Save for qn51 and late   QN19 403
SAVNCH=20#                             Keep character count             QN19 404
DO J=1,SAVNCH ; SAVBUF(J)=BUFIN(J)#    Keep translated buffer           QN19 405
openfmt:(iofm1:,prorest:)#             Open the 'ideals' file           QN19 406
IOIN2=ioinp: ; ioinp:=iofm1:#          Make 'ideals' file line input    QN19 407
#                                      Of standard restraint data       QN19 408
DEFAUL=yes:#                           Signal that 'ideals' data need   QN19 409
readline:(INLINE,NLINEC)#              Start loading the 'ideals' fil   QN19 410
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 QN19 411
IF(LINID>5) BREAK#                     Qn19 lines treated, move on      QN19 412
#                                                                       QN19 413
#                                                                       QN19 414
#----READ IDENTIFIERS FOR DISULFIDE BRIDGES                             QN19 415
#    (UNIQUE SET FOR INTRACHAIN, ALL FOR INTERCHAIN)                    QN19 416
ELSE IF(LINID==1)#                                                      QN19 417
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 QN19 418
IF(NSS>=qmxdss:) iquit:(QN1910)#       Too many disulphide linkages     QN19 419
NSS=NSS+1#                             Count the disulb line            QN19 420
CALL QN12(1,ICHNSS(NSS))#              Get chain pointer on one side    QN19 421
CALL QN11(2,ICHNSS(NSS),IRESSS(NSS))#  Residue pointer on first side    QN19 422
CALL QN12(3,JCHNSS(NSS))#              Get chain pointer on other sid   QN19 423
CALL QN11(4,JCHNSS(NSS),JRESSS(NSS))#  Residue pointer on other side    QN19 424
IF(LISGEN>0)#                          Listing everthing?               QN19 425
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 QN19 426
LINRM=10#                                                               QN19 427
BUFOT(1)= FLOAT(ICHNSS(NSS)) ; BUFOT(2)= FLOAT(IRESSS(NSS))#            QN19 428
BUFOT(3)= FLOAT(JCHNSS(NSS)) ; BUFOT(4)= FLOAT(JRESSS(NSS))#            QN19 429
movechar:(INLINE,(LINID-1)*7+2,CHROT,2,6,0)#                            QN19 430
ncodefld:(BUFOT,1,CHROT,FMT1,4) ; writeline:(0,QN11I,NQN11I,2,4)#       QN19 431
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 QN19 432
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 QN19 433
ELSE IF(LINID==2)#                     Altchn input line                QN19 434
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 QN19 435
I=0 ; REPEAT#                          Loop over input fields           QN19 436
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 QN19 437
I=I+1 ; ifvo:(BUFIN(I)) BREAK#         Until a void occurs              QN19 438
CALL QN12(I,JZ)#                       Get chain pointer                QN19 439
NZCHN=NZCHN+1#                         Count up altchn input lines      QN19 440
IF(NCHAIN+ NZCHN>qmxchn:) iquit:(QN1905)# Space used up?                QN19 441
MOTHRZ(NCHAIN+ NZCHN)=JZ#              Pointer to chain it belongs to   QN19 442
IF(LISGEN>0)#                          Listing everthing?               QN19 443
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 QN19 444
BUFOT(1)= FLOAT(JZ)#                                                    QN19 445
movechar:(INLINE,(LINID-1)*7+2,CHROT,2,6,0)#                            QN19 446
ncodefld:(BUFOT,1,CHROT,350313.,1) ; writeline:(0,QN11M,NQN11M,2,4)#    QN19 447
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 QN19 448
IF(ICHTYP(NCHAIN+ NZCHN)!=0) NEXT#                                      QN19 449
movechar:(IDCHN,(JZ-1)*3+1,IDCHN,(NCHAIN+ NZCHN-1)*3,3,0)#              QN19 450
ICHTYP(NCHAIN+ NZCHN)=ICHTYP(JZ)#                                       QN19 451
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 QN19 452
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 QN19 453
ELSE IF(LINID==3)#                     Check on firstp input line       QN19 454
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 QN19 455
IF(BUFIN(1)>=voidflg:) iquit:(QN1906)# Gotta have characters            QN19 456
movechar:(BLANK,1,FRSTPQ,1,9,1)#                                        QN19 457
stringlim:(1,I,J) ; J=MIN0(J-I,9)#                                      QN19 458
movechar:(CHRIN,I,FRSTPQ,1,J,0)#       Copy the atom id                 QN19 459
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 QN19 460
#                                                                       QN19 461
ELSE IF(LINID==5)#                     Check for spcpep input line      QN19 462
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 QN19 463
#                                                                       QN19 464
#----READ IDENTIFIERS FOR CIS PEPTIDES                                  QN19 465
#    ---------------------------------                                  QN19 466
#                                                                       QN19 467
CALL QN12(1,ICH)#                      Get chain pointer from chain i   QN19 468
CALL QN11(2,ICH,KRESMP(ICH))#          Get internal residue pointer     QN19 469
# THE FOLLOWING FIELDS ARE: 3) NO. OF CIS PEPTIDE BONDS IN CHAIN ICH    QN19 470
# 4) RESIDUE NO. FOR FIRST CIS PEPTIDE  5)---> UNDEFINED                QN19 471
DO I=4,10#                                                              QN19 472
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 QN19 473
ifvo:(BUFIN(I)) BREAK ; CALL QN11(I,ICH,IDCIS(I-2,ICH))# Store int.     Aug93001
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 QN19 475
NC1=IDCIS(1,ICH)+1#                                                     QN19 476
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 QN19 477
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 QN19 478
IF(LISGEN>0)#                          Listing everthing?               QN19 479
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 QN19 480
LINRM=5 ; BUFOT(1)= A1 ; BUFOT(2)= A2#                                  QN19 481
BUFOT(3)= A3 ; BUFOT(4)= ALPHA#                                         QN19 482
BUFOT(5)= BETA ; BUFOT(6)= GAMMA#                                       QN19 483
BUFOT(7)= FLOAT(NCELL) ; BUFOT(8)= FLOAT(NSYMOP)#                       QN19 484
ncodefld:(BUFOT,1,CHROT,FMT4,8);writeline:(1,QN11J,NQN11J,2,4)#         QN19 485
BUFOT(1)=ORXX;BUFOT(2)=ORXY;BUFOT(3)=ORXZ#                              QN19 486
BUFOT(4)=OIXX;BUFOT(5)=OIXY;BUFOT(6)=OIXZ#                              QN19 487
LINRM=5 ; ncodefld:(BUFOT,1,CHROT,FMT5,6)#                              QN19 488
writeline:(1,QN11K,NQN11K,1,4)#                                         QN19 489
BUFOT(1)=0.0;BUFOT(2)=ORYY;BUFOT(3)=ORYZ#                               QN19 490
BUFOT(4)=0.0;BUFOT(5)=OIYY;BUFOT(6)=OIYZ#                               QN19 491
ncodefld:(BUFOT,1,CHROT,FMT5,6);writeline:(1,QN11K,NQN11K,1,4)#         QN19 492
BUFOT(1)=0.0;BUFOT(2)=0.0;BUFOT(3)=ORZZ#                                QN19 493
BUFOT(4)=0.0;BUFOT(5)=0.0;BUFOT(6)=OIZZ#                                QN19 494
ncodefld:(BUFOT,1,CHROT,FMT5,6);writeline:(1,QN11K,NQN11K,1,4)#         QN19 495
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 QN19 496
RETURN#                                                                 QN19 497
END#                                                                    QN19 498
systemheader:(QN21)## Set up a dictionary of residues                   QN21   1
####################################################################    QN21   2
#                                                                  #    QN21   3
#                                QN21                              #    QN21   4
#                                                                  #    QN21   5
####################################################################    QN21   6
SUBROUTINE QN21#                                                        QN21   7
#                                                                       QN21   8
include:(AACOMN)#                                                       QN21   9
include:(QNCOMN)#                                                       QN21  10
#                                                                       QN21  11
#     SUBROUTINE RESIDU (NIDEAL) #----ESTABLISH STANDARD GROUPS         QN21  12
#                                                                       QN21  13
string:(ATNAM,4)## Atom name from input on way to storage               QN21  14
INTEGER I,J## Volatile indices                                          QN21  15
INTEGER IACID## Count of residues                                       QN21  16
INTEGER IHIT## Signal for various tests                                 QN21  17
INTEGER IM,IS,IT## Loop indices                                         QN21  18
INTEGER IMAIN## Count of main chain residues                            QN21  19
INTEGER IPEP## Count of peptide linkage residues                        QN21  20
INTEGER IATOM## Relative position of atom in residue                    QN21  21
string:(IDM,480)## Strings to identify main chain residues              QN21  22
INTEGER KM(10,12)## Scattering factor type, main chains                 QN21  23
INTEGER NA,NM,NS## More loop indices                                    QN21  24
INTEGER NATOML(5)## Numbers of atoms in linking residues                QN21  25
string:(PRERES,4)## Name of residue being treated                       QN21  26
string:(RESI,4)## Name of residue in latest input line                  QN21  27
REAL XM(10,12),YM(10,12),ZM(10,12)## Coordinates of main chain res      QN21  28
chardata:(ATSYM,HDXXXCNOXXXXXXXSXXXXXXF)## Short list of atom symbols   QN21  29
chardata:(GLY,GLY )#                   Glycine is a special case, 0 a   QN21  30
chardata:(IZN,N)#                      Those in the backbone            QN21  31
chardata:(IZC,C)#                                                       QN21  32
chardata:(BLUNK,    )#                                                  QN21  33
chardata:(QN21A, -----DICTIONARY OF STANDARD GROUPS----- )#             QN21  34
chardata:(QN21B,  NO. RESIDUE ATOM      X         Y         $#          QN21  35
Z      TYPE)#                                                           QN21  36
realdata:(FMTCO,[301052.,401052.,501052.,550513.])#                     QN21  37
datastuff:#                                                             QN21  38
IMAIN=0 ; IACID=0 ; IPEP=0 ; TOTRES=0# Zero the counts of residues      QN21  39
movechar:(BLANK,1,PRERES,1,4,1)#       Clear the previous name          QN21  40
IF(LINID<6) iquit:(QN2113)#            Input line order error           QN21  41
#                                                                       QN21  42
#     LOOP OVER THE RESTRM, RESLNK, RESIDU & RESIDE INPUT LINES         QN21  43
#     ---------------------------------------------------------         QN21  44
#                                                                       QN21  45
REPEAT#                                Read in parameters of residues   QN21  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN21  47
IF(LINID>9) BREAK#                     Quit when all residues loaded    QN21  48
movechar:(BLANK,1,RESI,1,4,1)#         Blank out the residue name       QN21  49
IF(BUFIN(1)>=voidflg:) iquit:(QN2101,1)# Must have residue name         QN21  50
stringlim:(1,I,J) ; J=MIN0(4,J-1)#     Take first four chars            QN21  51
movechar:(CHRIN,I,RESI,1,J,0)#         Bring in the residue name        QN21  52
compchar:(RESI,1,PRERES,1,4,4,4,IHIT)# See if new residue               QN21  53
IF(IHIT==0)#                           When no match it is              QN21  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN21  55
movechar:(RESI,1,PRERES,1,4,0)#        Remember the new residue name    QN21  56
IF(LINID==6)#                          Test for restrm input line       QN21  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN21  58
IMAIN=IMAIN+1 ; TOTRES=TOTRES+1 ; IF(IMAIN>10) iquit:(QN2102)#          QN21  59
NATOMM(IMAIN)= 0 ; movechar:(RESI,1,NAMEM,4*(IMAIN-1)+1,4,0)#           QN21  60
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN21  61
ELSE IF(LINID==7)#                     Test for reslnk input line       QN21  62
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN21  63
IPEP=IPEP+1 ; TOTRES=TOTRES+1 ; IF(IPEP>5) iquit:(QN2103)#              QN21  64
NATOML(IPEP)=0 ; movechar:(RESI,1,NAMEL,4*(IPEP-1)+1,4,0)#              QN21  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN21  66
ELSE#                                  Must be residu or reside line    QN21  67
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN21  68
IACID=IACID+1 ; NACIDS=IACID ; TOTRES=TOTRES+1# Count up standard gro   QN21  69
IF(IACID>qmxgrp:) iquit:(QN2104)#      Die if insufficient storage      QN21  70
NATOMS(IACID)=0 ; movechar:(RESI,1,NAMES,4*(IACID-1)+1,4,0)#            QN21  71
IF(LINID==9) NACIDP=IACID#             Mark the last amino acid         QN21  72
movechar:(BLANK,1,MCOD,IACID,1,1)#     Initialize the synonym           QN21  73
IF(BUFIN(7)<voidflg:)#                 Test for a character there       QN21  74
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN21  75
stringlim:(7,I,J) ; movechar:(CHRIN,I,MCOD,IACID,1,0)# Save it          QN21  76
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN21  77
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN21  78
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN21  79
#    GLYCINE IS A SPECIAL CASE BECAUSE IT HAS NO ATOMS IN ADDITION      QN21  80
#    TO THOSE IN THE BACKBONE.....                                      QN21  81
#    -------------------------------------------------------------      QN21  82
compchar:(RESI,1,GLY,1,4,4,NGLY,IHIT)#                                  QN21  83
IF(IHIT==0)#                           Take care of all other residue   QN21  84
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN21  85
#                                                                       QN21  86
#    GET THE PARAMETERS OF THE RESIDUE FOR STORAGE                      QN21  87
#    ---------------------------------------------                      QN21  88
#                                                                       QN21  89
movechar:(BLANK,1,ATNAM,1,4,1)#        Blank out the atom name          QN21  90
IF(BUFIN(2)>=voidflg:) iquit:(QN2105,2)# Must have an atom name         QN21  91
stringlim:(2,I,J) ; J=MIN0(4,J-1)#     Take first four chars            QN21  92
movechar:(CHRIN,I,ATNAM,1,J,0)#        Bring in the atom name           QN21  93
IF(BUFIN(8)>0.0) KATM=NINT(BUFIN(8))#  Take user scatt fac no.          QN21  94
ELSE#                                  Analyze atom name                QN21  95
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN21  96
compchar:(ATNAM,1,ATSYM,1,1,1,NATSYM,KATM)# First char in list?         QN21  97
IF(KATM==0) iquit:(QN2108,8)#          Can't do it all                  QN21  98
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN21  99
IF(BUFIN(3)<(-10.)\BUFIN(3)>10.) iquit:(QN2106,3)# Test x coord.        QN21 100
XX=BUFIN(3)#                           Take the coordinate to store     QN21 101
IF(BUFIN(4)<(-10.)\BUFIN(4)>10.) iquit:(QN2106,4)# Test y coord.        QN21 102
YY=BUFIN(4)#                           Take the coordinate to store     QN21 103
IF(BUFIN(5)<(-10.)\BUFIN(5)>10.) iquit:(QN2106,5)# Test z coord.        QN21 104
ZZ=BUFIN(5)#                           Take the coordinate to store     QN21 105
IF(BUFIN(6)<(-7.)\BUFIN(6)>50.) iquit:(QN2107,6)# Test atom point       QN21 106
IATOM=NINT(BUFIN(6)) ; J=IABS(IATOM)#  Take the relative atom pointer   QN21 107
IF(LINID==6)#                          Put away restrm data             QN21 108
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN21 109
NATOMM(IMAIN)=MAX0(NATOMM(IMAIN),IABS(IATOM))# Save largest atom no.    QN21 110
movechar:(ATNAM,1,IDM,(IMAIN-1)*48+(J-1)*4+1,4,0)# Save the atom name   QN21 111
XM(IMAIN,J)=XX ; YM(IMAIN,J)=YY ; ZM(IMAIN,J)=ZZ# The coordinates       QN21 112
KM(IMAIN,J)=KATM#                      The scattering factor pointer    QN21 113
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN21 114
ELSE IF(LINID==7)#                     Put away linking residues        QN21 115
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN21 116
NATOML(IPEP)=MAX0(NATOML(IPEP),IABS(IATOM))# Save far out atom pointe   QN21 117
I=2 ; IF(IATOM<0) I=1#                 Deal with previous residue no.   QN21 118
movechar:(ATNAM,1,IDL,(IPEP-1)*64+(J-1)*8+(I-1)*4+1,4,0)#               QN21 119
XL(IPEP,J,I)=XX ; YL(IPEP,J,I)=YY ; ZL(IPEP,J,I)=ZZ# The coordinates    QN21 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN21 121
ELSE#                                  Put away regular residues        QN21 122
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN21 123
NATOMS(IACID)=MAX0(NATOMS(IACID),IABS(IATOM))# Save largest atom no.    QN21 124
movechar:(ATNAM,1,IDS,(IACID-1)*qmxat4:+(J-1)*4+1,4,0)# Atom name       QN21 125
XS(IACID,J)=XX ; YS(IACID,J)=YY ; ZS(IACID,J)=ZZ# The coordinates       QN21 126
KS(IACID,J)=KATM#                      The scattering factor pointer    QN21 127
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN21 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN21 129
ELSE#                                                                   QN21 130
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN21 131
NATOMS(IACID)=4#                       Glycine is a very special case   QN21 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN21 133
readline:(INLINE,NLINEC)#              Suck in the next lines           QN21 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN21 135
#                                                                       QN21 136
#****GROUP AND ATOM READING IS COMPLETED                                QN21 137
MATMS=NATOMM(1)#                       Count no. of main chain atoms    QN21 138
#                                                                       QN21 139
#   SET POINTERS FOR THE C AND N TERMINAL RESIDUES AND MAKE SURE        QN21 140
#   THEY ARE IN THE TABLE OF STANDARD GROUPS                            QN21 141
#   ------------------------------------------------------------        QN21 142
#                                                                       QN21 143
J=0 ; DO I=1,NTRMS,2#                  Loop over terminal groups        QN21 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN21 145
J=J+1#                                 Both n and c                     QN21 146
compchar:(NAMNTR,4*(J-1)+1,NAMES,1,4,4,4*NACIDS,IACIDN)# Residue name   QN21 147
IACIDT(I)=IACIDN#                      Put pointer n term in table      QN21 148
IF(IACIDN==0\IACIDN>NACIDS) iquit:(QN2109)# One way\other gotta kno     QN21 149
compchar:(NAMCTR,4*(J-1)+1,NAMES,1,4,4,4*NACIDS,IACIDC)# Residue name   QN21 150
IACIDT(I+1)=IACIDC#                    Put pointer to c term in table   QN21 151
IF(IACIDC==0\IACIDC>NACIDS) iquit:(QN2110)# One way\other gotta kno     QN21 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN21 153
#                                                                       QN21 154
#    FORM THE N-TERMINAL AND C-TERMINAL RESIDUES                        QN21 155
#    -------------------------------------------                        QN21 156
#                                                                       QN21 157
DO I=1,NTRMS#                                                           QN21 158
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN21 159
DO IATOM=1,MATMS#                                                       QN21 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN21 161
movechar:(IDM,(IMAINT(I)-1)*48+(IATOM-1)*4+1,$# Transfer main chain n   QN21 162
IDS,(NACIDS+I-1)*qmxat4:+(IATOM-1)*4+1,4,0)#                            QN21 163
XS(NACIDS+I,IATOM)=XM(IMAINT(I),IATOM)# Transfer main chain coordinat   QN21 164
YS(NACIDS+I,IATOM)=YM(IMAINT(I),IATOM)#                                 QN21 165
ZS(NACIDS+I,IATOM)=ZM(IMAINT(I),IATOM)#                                 QN21 166
KS(NACIDS+I,IATOM)=KM(IMAINT(I),IATOM)# And scattering factor type      QN21 167
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN21 168
NS=NATOMS(IACIDT(I))#                                                   QN21 169
DO IATOM=1,NS#                                                          QN21 170
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN21 171
compchar:(IDS,(IACIDT(I)-1)*qmxat4:+(IATOM-1)*4+1,$#                    QN21 172
BLUNK,1,NBLUNK,NBLUNK,NBLUNK,IHIT)#                                     QN21 173
IF(IHIT==1) NEXT#                      If the identity is blank skip    QN21 174
movechar:(IDS,(IACIDT(I)-1)*qmxat4:+(IATOM-1)*4+1,$#                    QN21 175
IDS,(NACIDS+I-1)*qmxat4:+(IATOM-1)*4+1,4,0)#                            QN21 176
XS(NACIDS+I,IATOM)=XS(IACIDT(I),IATOM)#                                 QN21 177
YS(NACIDS+I,IATOM)=YS(IACIDT(I),IATOM)#                                 QN21 178
ZS(NACIDS+I,IATOM)=ZS(IACIDT(I),IATOM)#                                 QN21 179
KS(NACIDS+I,IATOM)=KS(IACIDT(I),IATOM)#                                 QN21 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN21 181
NM=NATOMM(IMAINT(I)) ; NN=NS+NM-MATMS#                                  QN21 182
IF(NM>MATMS)#                                                           QN21 183
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN21 184
IS=MATMS+1#                                                             QN21 185
DO IM=IS,NM#                                                            QN21 186
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN21 187
IATOM=NS+IM-MATMS#                                                      QN21 188
movechar:(IDM,(IMAINT(I)-1)*48+(IM-1)*4+1,$#                            QN21 189
IDS,(NACIDS+I-1)*qmxat4:+(IATOM-1)*4+1,4,0)#                            QN21 190
XS(NACIDS+I,IATOM)=XM(IMAINT(I),IM)#                                    QN21 191
YS(NACIDS+I,IATOM)=YM(IMAINT(I),IM)#                                    QN21 192
ZS(NACIDS+I,IATOM)=ZM(IMAINT(I),IM)#                                    QN21 193
KS(NACIDS+I,IATOM)=KM(IMAINT(I),IM)#                                    QN21 194
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN21 195
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN21 196
NATOMS(NACIDS+I)=NN#                   Save count of atoms in term gr   QN21 197
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN21 198
NACIDT=NACIDS+NTRMS#                                                    QN21 199
#                                                                       QN21 200
#----CONJUGATE MAIN CHAIN TO SIDE CHAIN ATOMS FOR INTERNAL RESIDUES     QN21 201
#    --------------------------------------------------------------     QN21 202
#                                                                       QN21 203
DO IACID=1,NACIDP#                                                      QN21 204
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN21 205
DO IATOM=1,MATMS#                                                       QN21 206
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN21 207
compchar:(IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,$#                        QN21 208
BLUNK,1,NBLUNK,NBLUNK,NBLUNK,IHIT)#    Test for blank atom name         QN21 209
IF(IHIT==0) NEXT#                      If identity is not blank skip    QN21 210
movechar:(IDM,(IATOM-1)*4+1,$#         Otherwise take first main atom   QN21 211
IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,4,0)#                               QN21 212
XS(IACID,IATOM)=XM(1,IATOM) ; YS(IACID,IATOM)=YM(1,IATOM)#              QN21 213
ZS(IACID,IATOM)=ZM(1,IATOM) ; KS(IACID,IATOM)=KM(1,IATOM)#              QN21 214
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN21 215
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN21 216
DO IPEP=1,5#                           Store names of link atoms        QN21 217
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QN21 218
NA=NATOML(IPEP) ; NATOMS(NACIDT+IPEP)=NA#                               QN21 219
movechar:(NAMEL,4*(IPEP-1)+1,NAMES,4*(NACIDT+IPEP-1)+1,4,0)#            QN21 220
IF(IPEP<=2) IACID=1#                   ******bad news bear!!!!!!!!!!    QN21 221
IF(IPEP>2) IACID=15#                   ******bad news bear!!!!!!!!!!    QN21 222
IF(IPEP==5) IACID=5#                   ******bad news bear!!!!!!!!!!    QN21 223
NA=NATOMS(IACID)#                                                       QN21 224
DO IATOM=1,NA#                                                          QN21 225
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QN21 226
movechar:(IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,$#                        QN21 227
IDS,(NACIDT+IPEP-1)*qmxat4:+(IATOM-1)*4+1,4,0)#                         QN21 228
KS(NACIDT+IPEP,IATOM)=KS(IACID,IATOM)#                                  QN21 229
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QN21 230
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QN21 231
DO IT=1,NTRMS#                                                          QN21 232
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QN21 233
movechar:(MCOD,IACIDT(IT),MCOD,NACIDS+IT,1,0)#                          QN21 234
movechar:(NAMES,4*(IACIDT(IT)-1)+1,NAMES,4*(NACIDS+IT-1)+1,3,0)#        QN21 235
IF(MOD(IT,2)==0) movechar:(IZC,1,NAMES,4*(NACIDS+IT-1)+4,NIZC,0)# Its   QN21 236
ELSE movechar:(IZN,1,NAMES,4*(NACIDS+IT-1)+4,NIZN,0)# Its nitrogen      QN21 237
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QN21 238
#                                                                       QN21 239
#   SET LIST DICTIONARY OF STD GRPS                                     QN21 240
#   -------------------------------                                     QN21 241
#                                                                       QN21 242
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN21 243
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QN21 244
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN21A,NQN21A,3,4) ; LINRM=3#     QN21 245
DO I=1,NACIDT#                                                          QN21 246
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QN21 247
LISLOC=LISLOC-1 ; IF(LISLOC<0) BREAK#  Quit if thats all user wants     QN21 248
NA=NATOMS(I)#                                                           QN21 249
BUFOT(1)=FLOAT(I) ; ncodefld:(BUFOT,1,CHROT,40313.,1)#                  QN21 250
movechar:(NAMES,4*(I-1)+1,CHROT,7,4,0)#                                 QN21 251
DO J=1,NA#                             Loop over all atoms in group     QN21 252
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QN21 253
movechar:(MCOD,I,CHROT,12,1,0)#        Get single letter for residue    QN21 254
BUFOT(1)=XS(I,J) ; BUFOT(2)=YS(I,J) ; BUFOT(3)=ZS(I,J)# Get coordinat   QN21 255
BUFOT(4)=FLOAT(KS(I,J)) ; ncodefld:(BUFOT,1,CHROT,FMTCO,4)#             QN21 256
movechar:(IDS,(I-1)*qmxat4:+(J-1)*4+1,CHROT,15,4,0)#                    QN21 257
writeline:(0,QN21B,NQN21B,1,4)#                                         QN21 258
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QN21 259
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QN21 260
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QN21 261
#                                                                       QN21 262
RETURN#                                                                 QN21 263
END#                                                                    QN21 264
systemheader:(QN22)## Adjust H - heavy atom distances                   QN22   1
####################################################################    QN22   2
#                                                                  #    QN22   3
#                                QN22                              #    QN22   4
#                                                                  #    QN22   5
####################################################################    QN22   6
SUBROUTINE QN22#                                                        QN22   7
#                                                                       QN22   8
include:(AACOMN)#                                                       QN22   9
include:(QNCOMN)#                                                       QN22  10
#                                                                       QN22  11
#     SUBROUTINE SHRINK (NIDEAL)                                        QN22  12
#                                                                       QN22  13
#----SHRINK HYDROGEN-C,N,O,S DISTANCES FOR X-RAY REFINEMENT             QN22  14
#                                                                       QN22  15
string:(IDATM,4)#                                                       QN22  16
REAL HXAGE(28)#                                                         QN22  17
chardata:(NUMS,123)#                                                    QN22  18
chardata:(QN22A, NO PARENT ATOM FOUND FOR HYDROGEN      )#              QN22  19
datastuff:#                                                             QN22  20
DO I=1,28 ; HXAGE(I)=1.0#              Define shrinkage factors         QN22  21
HXAGE(6)=1.00/1.10 ; HXAGE(7)=0.95/1.05#                                QN22  22
HXAGE(8)=0.90/1.00 ; HXAGE(16)= 1.20/1.30#                              QN22  23
NG=NACIDT+5#                           Identify parent atoms of h       QN22  24
DO IACID=1,NG#                                                          QN22  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN22  26
NA=NATOMS(IACID)#                                                       QN22  27
DO IATOM=1,NA#                                                          QN22  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN22  29
IF(KS(IACID,IATOM)!=1) NEXT#                                            QN22  30
movechar:(IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,IDATM,1,4,0)#             QN22  31
DO I=1,NA#                                                              QN22  32
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN22  33
KA=I ; KSAT=KS(IACID,KA)#                                               QN22  34
IF(KSAT<6\(KSAT>8&KSAT!=16)) NEXT#                                      QN22  35
compchar:(IDATM,2,IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+2,2,2,2,K)#         QN22  36
IF(K!=0) GO TO 150#                    Scan for match on second char    QN22  37
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN22  38
DO I=1,NA#                                                              QN22  39
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN22  40
KA=I ; KSAT=KS(IACID,KA)#                                               QN22  41
IF(KSAT<6\(KSAT>8&KSAT!=16)) NEXT#                                      QN22  42
compchar:(IDATM,3,IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+3,1,1,1,K)#         QN22  43
IF(K!=0) GO TO 150#                    Scan for match on third char     QN22  44
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN22  45
KA=1#                                                                   QN22  46
compchar:(IDATM,3,NUMS,1,1,1,NNUMS,K)#                                  QN22  47
IF(K==0)#                              Scan for numbers 1,2 or 3        QN22  48
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN22  49
movechar:(IDATM,1,QN22A,36,4,0);writeline:(1,QN22A,NQN22A,3,1)#         QN22  50
iquit:(QN2111)#                        No parent atom found             QN22  51
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN22  52
150 CONTINUE#                                                           QN22  53
KK=KS(IACID,KA)#                                                        QN22  54
IF(IACID<=NACIDT)## SHRINK HYDROGEN POSITION ALONG THE H-X BOND         QN22  55
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN22  56
#                                                                       QN22  57
#....RESIDUES AND SIDE GROUPS                                           QN22  58
XH=XS(IACID,IATOM) ; YH=YS(IACID,IATOM) ; ZH=ZS(IACID,IATOM)#           QN22  59
XP=XS(IACID,KA) ; YP=YS(IACID,KA) ; ZP=ZS(IACID,KA)#                    QN22  60
XS(IACID,IATOM)=XP+HXAGE(KK)*(XH-XP)#                                   QN22  61
YS(IACID,IATOM)=YP+HXAGE(KK)*(YH-YP)#                                   QN22  62
ZS(IACID,IATOM)=ZP+HXAGE(KK)*(ZH-ZP)#                                   QN22  63
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN22  64
ELSE#                                  Link groups                      QN22  65
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN22  66
IPEP=IACID-NACIDT#                                                      QN22  67
DO IRES=1,2#                                                            QN22  68
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN22  69
compchar:(IDATM,1,IDL,(IPEP-1)*64+(IATOM-1)*8+(IRES-1)*4+1,4,4,4,K)#    QN22  70
IF(K==0) NEXT#                                                          QN22  71
XH=XL(IPEP,IATOM,IRES) ; YH=YL(IPEP,IATOM,IRES)#                        QN22  72
ZH=ZL(IPEP,IATOM,IRES) ; XP=XL(IPEP,KA,IRES)#                           QN22  73
YP=YL(IPEP,KA,IRES) ; ZP=ZL(IPEP,KA,IRES)#                              QN22  74
XL(IPEP,IATOM,IRES)=XP+HXAGE(KK)*(XH-XP)#                               QN22  75
YL(IPEP,IATOM,IRES)=YP+HXAGE(KK)*(YH-YP)#                               QN22  76
ZL(IPEP,IATOM,IRES)=ZP+HXAGE(KK)*(ZH-ZP)#                               QN22  77
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN22  78
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN22  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN22  80
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN22  81
RETURN#                                                                 QN22  82
END#                                                                    QN22  83
systemheader:(QN23)## Set up idealized inter-atom distances             QN23   1
####################################################################    QN23   2
#                                                                  #    QN23   3
#                                QN23                              #    QN23   4
#                                                                  #    QN23   5
####################################################################    QN23   6
SUBROUTINE QN23#                                                        QN23   7
#                                                                       QN23   8
include:(AACOMN)#                                                       QN23   9
include:(QNCOMN)#                                                       QN23  10
#                                                                       QN23  11
#     SUBROUTINE DISTNS (NIDEAL)                                        QN23  12
#                                                                       QN23  13
#----ESTABLISH IDEAL DISTANCES                                          QN23  14
#                                                                       QN23  15
INTEGER IPEP## Count of 'link' residues                                 QN23  16
INTEGER I,J## Volatile indices                                          QN23  17
INTEGER IHIT## For a test signal                                        QN23  18
string:(GRQNM,4)## Temporary storage of residue name                    QN23  19
chardata:(DASH,-)#                                                      QN23  20
chardata:(QN23A, ATOM NO. IIII FOR DISTANCE NO. IIII OF $#              QN23  21
RESIDUE XXXX EXCEEDS THE HIGHEST ATOM NO. IIII FOR THAT RESIDUE.)#      QN23  22
chardata:(QN23B, -----DICTIONARY OF DISTANCE RESTRAINTS----- )#         QN23  23
chardata:(QN23C,  RESIDUE     AT1  AT2 WT DIST   AT1  AT2 WT $#         QN23  24
DIST   AT1  AT2 WT DIST   AT1  AT2 WT DIST   AT1  AT2 WT DIST   $#      QN23  25
AT1  AT2 WT DIST    )#                                                  QN23  26
realdata:(FMT,[140413.,360413.,860413.])#                               QN23  27
INTEGER MATM(10,20)##                                                   QN23  28
INTEGER NATM(10,20)##                                                   QN23  29
INTEGER LDWT(10,20)##                                                   QN23  30
INTEGER LBWT(10,20)##                                                   QN23  31
datastuff:#                                                             QN23  32
#                                                                       QN23  33
#----INTERATOMIC DISTANCE FUNCTION                                      QN23  34
DIJ(X1,Y1,Z1,X2,Y2,Z2)=SQRT((X1-X2)**2+(Y1-Y2)**2+(Z1-Z2)**2)#          QN23  35
IF(LINID<10) iquit:(QN2313)#           Input line order error           QN23  36
REPEAT#                                Read the group identifier card   QN23  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN23  38
IF(LINID>12) BREAK#                                                     QN23  39
CALL QN04(GRQNM,1,4)#                  Fetch residue name from field    QN23  40
IF(LINID==12)#                         Terminal residue?                QN23  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN23  42
CALL QN05(GRQNM,IMAIN,NAMEM,40,4)#     Search prev'sly loaded residue   QN23  43
I=0 ; J=-2#                            Prepare to load distance info    QN23  44
REPEAT#                                Scan over the rest of the line   QN23  45
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN23  46
J=J+4 ; ifvo:(BUFIN(J)) BREAK#         Quit scanning on first void      QN23  47
IF(BUFIN(J)<voidflg:)#                 Reload buffer if character hit   QN23  48
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN23  49
IHIT=LINID#                            Save current line identity       QN23  50
readline:(INLINE,NLINEC)#              Read a new line                  QN23  51
IF(IHIT!=LINID) iquit:(QN2303)#        Identity can't change            QN23  52
J=2#                                   Reset input field pointer        QN23  53
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN23  54
I=I+1#                                 Count the constraints            QN23  55
MATM(IMAIN,I)=NINT(AMAX1(BUFIN(J),0.0))# Pick up origin atom no.        QN23  56
NATM(IMAIN,I)=NINT(AMAX1(BUFIN(J+1),0.0))# Pick up terminus atom no.    QN23  57
LDWT(IMAIN,I)=NINT(AMAX1(BUFIN(J+2),0.0))# Distance restraint code      QN23  58
LBWT(IMAIN,I)=NINT(AMAX1(BUFIN(J+3),0.0))# Pick up weight to restrain   QN23  59
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN23  60
NDISTM(IMAIN)=I#                       Keep track of total number       QN23  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN23  62
ELSE IF(LINID==11)#                    Dislnk input line?               QN23  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN23  64
CALL QN05(GRQNM,IPEP,NAMEL,20,4)#      Search prev'sly loaded residue   QN23  65
I=0 ; J=-2#                            Prepare to load distance info    QN23  66
REPEAT#                                Scan over the rest of the line   QN23  67
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN23  68
J=J+4 ; ifvo:(BUFIN(J)) BREAK#         Quit scanning on first void      QN23  69
IF(BUFIN(J)<voidflg:)#                 Reload buffer if character hit   QN23  70
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN23  71
IHIT=LINID#                            Save current line identity       QN23  72
readline:(INLINE,NLINEC)#              Read a new line                  QN23  73
IF(IHIT!=LINID) iquit:(QN2303)#        Identity can't change            QN23  74
J=2#                                   Reset input field pointer        QN23  75
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN23  76
I=I+1 ; IHIT=NACIDT+IPEP#              Count the constraints            QN23  77
IATM(IHIT,I)=NINT(AMAX1(BUFIN(J),0.0))# Pick up origin atom no.         QN23  78
JATM(IHIT,I)=NINT(AMAX1(BUFIN(J+1),0.0))# Pick up terminus atom no.     QN23  79
KDWT(IHIT,I)=NINT(AMAX1(BUFIN(J+2),0.0))# Distance restraint code       QN23  80
KBWT(IHIT,I)=NINT(AMAX1(BUFIN(J+3),0.0))# Pick up weight to restrain    QN23  81
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN23  82
NDISTS(IHIT)=I#                        Keep track of total number       QN23  83
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN23  84
ELSE IF(LINID==10)#                    Regular old chain residue?       QN23  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN23  86
CALL QN05(GRQNM,IACID,NAMES,4*NACIDS,4)# Search prev'sly loaded resid   QN23  87
I=0 ; J=-2#                            Prepare to load distance info    QN23  88
REPEAT#                                Scan over the rest of the line   QN23  89
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN23  90
J=J+4 ; ifvo:(BUFIN(J)) BREAK#         Quit scanning on first void      QN23  91
IF(BUFIN(J)<voidflg:)#                 Reload buffer if character hit   QN23  92
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN23  93
IHIT=LINID#                            Save current line identity       QN23  94
readline:(INLINE,NLINEC)#              Read a new line                  QN23  95
IF(IHIT!=LINID) iquit:(QN2303)#        Identity can't change            QN23  96
J=2#                                   Reset input field pointer        QN23  97
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN23  98
I=I+1#                                 Count the constraints            QN23  99
IATM(IACID,I)=NINT(AMAX1(BUFIN(J),0.0))# Pick up origin atom no.        QN23 100
JATM(IACID,I)=NINT(AMAX1(BUFIN(J+1),0.0))# Pick up terminus atom no.    QN23 101
KDWT(IACID,I)=NINT(AMAX1(BUFIN(J+2),0.0))# Distance restraint code      QN23 102
KBWT(IACID,I)=NINT(AMAX1(BUFIN(J+3),0.0))# Pick up weight to restrain   QN23 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN23 104
NDISTS(IACID)=I#                       Keep track of total number       QN23 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN23 106
readline:(INLINE,NLINEC)#              Refresh input buffer             QN23 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN23 108
#                                                                       QN23 109
MATMS=NATOMM(1)#                                                        QN23 110
DO I=1,NTRMS## MAKE THE DISTANCE CATALOG FOR THE TERMINAL RESIDUES      QN23 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN23 112
ND=NDISTS(IACIDT(I))#                                                   QN23 113
IF(ND!=0)#                                                              QN23 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN23 115
DO IDIST=1,ND#                                                          QN23 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN23 117
IATM(NACIDS+I,IDIST)=IATM(IACIDT(I),IDIST)#                             QN23 118
JATM(NACIDS+I,IDIST)=JATM(IACIDT(I),IDIST)#                             QN23 119
KDWT(NACIDS+I,IDIST)=KDWT(IACIDT(I),IDIST)#                             QN23 120
KBWT(NACIDS+I,IDIST)=KBWT(IACIDT(I),IDIST)#                             QN23 121
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN23 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN23 123
NM=NDISTM(IMAINT(I)) ; INC=NATOMS(IACIDT(I))-MATMS#                     QN23 124
NDISTS(NACIDS+I)=ND+NM ; IF(NM==0) NEXT#                                QN23 125
DO IM=1,NM#                                                             QN23 126
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN23 127
IDIST=ND+IM#                                                            QN23 128
IATM(NACIDS+I,IDIST)=MATM(IMAINT(I),IM)#                                QN23 129
JATM(NACIDS+I,IDIST)=NATM(IMAINT(I),IM)#                                QN23 130
KDWT(NACIDS+I,IDIST)=LDWT(IMAINT(I),IM)#                                QN23 131
KBWT(NACIDS+I,IDIST)=LBWT(IMAINT(I),IM)#                                QN23 132
IF(IATM(NACIDS+I,IDIST)>MATMS)#                                         QN23 133
IATM(NACIDS+I,IDIST)=IATM(NACIDS+I,IDIST)+INC#                          QN23 134
IF(JATM(NACIDS+I,IDIST)>MATMS)#                                         QN23 135
JATM(NACIDS+I,IDIST)=JATM(NACIDS+I,IDIST)+INC#                          QN23 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN23 137
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN23 138
#                                                                       QN23 139
#----PREPARE THE CATALOG OF IDEAL DISTANCES                             QN23 140
DO IACID=1,NACIDT#                     Intra-residue distances          QN23 141
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN23 142
ND=NDISTS(IACID) ; NA=NATOMS(IACID)#                                    QN23 143
IF(ND==0) NEXT#                                                         QN23 144
DO IDIST=1,ND#                                                          QN23 145
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN23 146
IA=IATM(IACID,IDIST) ; JA=JATM(IACID,IDIST)#                            QN23 147
IF(IA>NA\JA>NA)#                                                        QN23 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN23 149
movechar:(NAMES,4*(IACID-1)+1,QN23A,49,4,0)#                            QN23 150
IF(IA>NA) BUFOT(1)=FLOAT(IA) ; IF(JA>NA) BUFOT(1)=FLOAT(JA)#            QN23 151
BUFOT(2)=FLOAT(IDIST);BUFOT(3)=FLOAT(NA)#                               QN23 152
ncodefld:(BUFOT,1,QN23A,FMT,3);writeline:(1,QN23A,NQN23A,3,1)#          QN23 153
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN23 154
DIST(IACID,IDIST)=DIJ(XS(IACID,IA),YS(IACID,IA),ZS(IACID,IA),$#         QN23 155
XS(IACID,JA),YS(IACID,JA),ZS(IACID,JA))#                                QN23 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN23 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN23 158
DO IPEP=1,5#                           Inter-residue or link distance   QN23 159
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN23 160
LINK=NACIDT+IPEP ; ND=NDISTS(LINK)#                                     QN23 161
IF(ND<=0) NEXT#                                                         QN23 162
DO IDIST=1,ND#                                                          QN23 163
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN23 164
IA=IATM(LINK,IDIST) ; JA=JATM(LINK,IDIST)#                              QN23 165
DIST(LINK,IDIST)=DIJ(XL(IPEP,IA,2),YL(IPEP,IA,2),ZL(IPEP,IA,2),$#       QN23 166
XL(IPEP,JA,1),YL(IPEP,JA,1),ZL(IPEP,JA,1))#                             QN23 167
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN23 168
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN23 169
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN23 170
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN23 171
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN23B,NQN23B,3,4) ; LINRM=3#     QN23 172
NG=NACIDT+5#                                                            QN23 173
DO I=1,NG#                                                              QN23 174
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QN23 175
LISLOC=LISLOC-1 ; IF(LISLOC<0) BREAK#  Quit if thats all user wants     QN23 176
ND=NDISTS(I)#                                                           QN23 177
IF(ND==0)#                                                              QN23 178
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QN23 179
ncodefld:(FLOAT(I),1,CHROT,40313.,1)#                                   QN23 180
movechar:(NAMES,4*(I-1)+1,CHROT,7,4,0)#                                 QN23 181
writeline:(0,QN23C,NQN23C,1,4)#                                         QN23 182
NEXT#                                                                   QN23 183
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QN23 184
K=15 ; FM1=250213.0 ; FM2=300522.0 ; DO IG=1,ND#                        QN23 185
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QN23 186
IF(K>=129)#                                                             QN23 187
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QN23 188
writeline:(0,QN23C,NQN23C,1,4);K=15;FM1=250213.0;FM2=300522.0#          QN23 189
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QN23 190
ncodefld:(FLOAT(I),1,CHROT,40313.,1)#                                   QN23 191
movechar:(NAMES,4*(I-1)+1,CHROT,7,4,0)#                                 QN23 192
movechar:(DASH,1,CHROT,K+4,NDASH,0)#                                    QN23 193
movechar:(IDS,(I-1)*qmxat4:+(IATM(I,IG)-1)*4+1,CHROT,K,4,0)#            QN23 194
movechar:(IDS,(I-1)*qmxat4:+(JATM(I,IG)-1)*4+1,CHROT,K+5,4,0)#          QN23 195
ncodefld:(DIST(I,IG),1,CHROT,FM2,1)#                                    QN23 196
ncodefld:(FLOAT(KDWT(I,IG)),1,CHROT,FM1,1)#                             QN23 197
FM1=FM1+190000. ; FM2=FM2+190000. ; K=K+19#                             QN23 198
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QN23 199
writeline:(0,QN23C,NQN23C,1,4)#                                         QN23 200
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QN23 201
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN23 202
RETURN#                                                                 QN23 203
END#                                                                    QN23 204
systemheader:(QN24)## Set up idealized planer moieties                  QN24   1
####################################################################    QN24   2
#                                                                  #    QN24   3
#                                QN24                              #    QN24   4
#                                                                  #    QN24   5
####################################################################    QN24   6
SUBROUTINE QN24#                                                        QN24   7
#                                                                       QN24   8
include:(AACOMN)#                                                       QN24   9
include:(QNCOMN)#                                                       QN24  10
#                                                                       QN24  11
# SUBROUTINE PLANES (NIDEAL,NAPEP)# ESTABLISH PLANAR IDEAL GROUPS       QN24  12
#                                                                       QN24  13
string:(IDGRP,4)#                                                       QN24  14
INTEGER INBUF(17)#                                                      QN24  15
chardata:(QN24A, PLALNL )#                                              QN24  16
chardata:(QN24B, -----DICTIONARY OF PLANAR GROUPS----- )#               QN24  17
chardata:(QN24C, NO. RESIDUE ATOMS IN PLANE....... )#                   QN24  18
datastuff:#                                                             QN24  19
NG=qmxpln: ; NP=0 ; IPRO=TOTRES#       Initialize                       QN24  20
DO IP=1,NG ; NPLATS(IP)=0#                                              QN24  21
KINDMX=0 ; MATMS=NATOMM(1)#                                             QN24  22
IF(LINID<13) iquit:(QN2413)#           Input line order error           QN24  23
#                                                                       QN24  24
#   THIS ROUTINE READS PLARES, PLALNK, PLATRM, PLAPRO & PLALNL LINES    QN24  25
#   ----------------------------------------------------------------    QN24  26
#                                                                       QN24  27
REPEAT#                                Read the plane specifications    QN24  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN24  29
IF(LINID>16) BREAK#                                                     QN24  30
CALL QN04(IDGRP,1,4)#                  Find residue name                QN24  31
IF(LINID==15)#                         Platrm line?                     QN24  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN24  33
CALL QN05(IDGRP,IMAIN,NAMEM,40,4)#     Convert residue name to pointe   QN24  34
NA=0 ; REPEAT#                         Loop over input fields           QN24  35
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN24  36
IF(BUFIN(NA+2)<=voidflg:) BREAK#                                        QN24  37
INBUF(NA+1)=NINT(BUFIN(NA+2)) ; NA=NA+1#                                QN24  38
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN24  39
NCNO=NA#                               The no. of non-h is the no.      QN24  40
IT=0#                                                                   QN24  41
REPEAT#                                                                 QN24  42
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN24  43
IF(IT>0&IT<=NTRMS)#                                                     QN24  44
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN24  45
IACID=NACIDS+IT ; INC=NATOMS(IACIDT(IT))-MATMS#                         QN24  46
NPLATS(IACID)=NA#                                                       QN24  47
IF(NA>0)#                                                               QN24  48
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN24  49
DO I=1,NA#                                                              QN24  50
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN24  51
IPLN(IACID,I)=INBUF(I)#                                                 QN24  52
IF(IPLN(IACID,I)>MATMS) IPLN(IACID,I)=IPLN(IACID,I)+INC#                QN24  53
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN24  54
ND=NDISTS(IACID) ; KIND=IACID ; KINDMX=MAX0(KINDMX,KIND)#               QN24  55
CALL QN29(IACID,ND,NCNO,M,KIND)#       Call pairs#                      QN24  56
NPAIRS(IACID)=M#                                                        QN24  57
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN24  58
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN24  59
IT1=IT+1#                                                               QN24  60
IF(IT1>NTRMS) BREAK#                                                    QN24  61
DO IT=IT1,NTRMS ; IF(IMAIN==IMAINT(IT)) BREAK#                          QN24  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN24  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN24  64
ELSE IF(LINID==14)#                    Plalnk line for link group?      QN24  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN24  66
NA=0 ; REPEAT#                         Bring in the input quantities    QN24  67
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN24  68
IF(BUFIN(NA+2)<=voidflg:) BREAK#       Until the first void field       QN24  69
INBUF(NA+1)=NINT(BUFIN(NA+2)) ; NA=NA+1# Counting as they come in       QN24  70
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN24  71
NCNO=NA#                               Rember the number of atoms       QN24  72
IF(NA>6\NA<3) iquit:(QN2401)#                                           QN24  73
NP=NA*(NA-1)/2 ; LINK1=NACIDT+1#                                        QN24  74
readline:(QN24A,NQN24A)#               Read a plalnl input line.        QN24  75
DO IP=1,NP#                                                             QN24  76
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN24  77
IF(BUFIN(IP)<=voidflg:) KPLN(LINK1,IP)=0#                               QN24  78
ELSE KPLN(LINK1,IP)=NINT(BUFIN(IP))#                                    QN24  79
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN24  80
DO IPEP=1,4#                                                            QN24  81
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN24  82
LINK=NACIDT+IPEP ; NPLATS(LINK)=NAPEP# Napep is a control parameter     QN24  83
NPAIRS(LINK)=NAPEP*(NAPEP-1)/2#        Which was read in qn19           QN24  84
IF(IPEP>2&NAPEP!=4)#                                                    QN24  85
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN24  86
NPLATS(LINK)=NA ; NPAIRS(LINK)=NP#                                      QN24  87
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN24  88
DO I=1,NA ; IPLN(LINK,I)=INBUF(I)#                                      QN24  89
DO IP=1,NP ; KPLN(LINK,IP)=KPLN(LINK1,IP)#                              QN24  90
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN24  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN24  92
#                                                                       QN24  93
#  TREATMENT FOR MULTI-PLANAR PROSTHETIC GROUP, PLARES OR PLAPRO LINES  QN24  94
# --------------------------------------------------------------------  QN24  95
#                                                                       QN24  96
ELSE IF(LINID==13\LINID==16)#          Plares or plapro lines in inpu   QN24  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN24  98
CALL QN05(IDGRP,IACID,NAMES,4*NACIDS,4)# Screen residue, get pointer    QN24  99
NA=0 ; REPEAT#                         Loop over input fields           QN24 100
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN24 101
IF(BUFIN(NA+2)<=voidflg:) BREAK#                                        QN24 102
INBUF(NA+1)=NINT(BUFIN(NA+2)) ; NA=NA+1#                                QN24 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN24 104
NCNO=NA ; KIND=IACID ; KINDMX=MAX0(KINDMX,KIND)#                        QN24 105
IF(LINID==16)#                         Check for plapro (heme groups)   QN24 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN24 107
IPRO=IPRO+1 ; KIND=IPRO ; KINDMX=MAX0(KINDMX,KIND)#                     QN24 108
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN24 109
#                                                                       QN24 110
#   STORE THE TYPE OF RESIDUE THIS PLANE IS DEFINED FOR                 QN24 111
#   ---------------------------------------------------                 QN24 112
#                                                                       QN24 113
KNDACD(KIND)=IACID ; NPLATS(KIND)=NA#                                   QN24 114
IF(NA>0)#                                                               QN24 115
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN24 116
DO I=1,NA ; IPLN(KIND,I)=INBUF(I)#                                      QN24 117
ND=NDISTS(IACID)#                                                       QN24 118
CALL QN29(IACID,ND,NCNO,M,KIND)#       Call pairs#                      QN24 119
NPAIRS(KIND)=M#                                                         QN24 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN24 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN24 122
readline:(INLINE,NLINEC)#              Reload line input buffer         QN24 123
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN24 124
#                                                                       QN24 125
#  LIST THE PLANAR GROUP SPECIFICATIONS                                 QN24 126
#  ------------------------------------                                 QN24 127
#                                                                       QN24 128
NG=NACIDT+4 ; MAXGRP=MAX0(NG,KINDMX)#                                   QN24 129
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN24 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN24 131
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN24B,NQN24B,3,4) ; LINRM=3#     QN24 132
DO I=1,MAXGRP#                                                          QN24 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN24 134
LISLOC=LISLOC-1 ; IF(LISLOC<0) BREAK#  Quit if thats all user wants     QN24 135
#IF(I>NG&I<=QMXGRP:) NEXT#                                              QN24 136
NP=NPLATS(I)#                                                           QN24 137
IF(NP==0)#                                                              QN24 138
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN24 139
ncodefld:(FLOAT(I),1,CHROT,40313.,1)#                                   QN24 140
movechar:(NAMES,4*(I-1)+1,CHROT,7,4,0)#                                 QN24 141
writeline:(0,QN24C,NQN24C,1,4) ; NEXT#                                  QN24 142
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN24 143
#                                                                       QN24 144
#----RETRIEVE THE TYPE OF RESIDUE THIS PLANE IS DEFINED FOR             QN24 145
IF(KNDACD(I)==0) KNDACD(I)=I#                                           QN24 146
J=KNDACD(I)#                                                            QN24 147
K=13 ; DO IP=1,NP#                                                      QN24 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN24 149
IF(K>=113)#                                                             QN24 150
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QN24 151
writeline:(0,QN24C,NQN24C,1,4) ; K=13#                                  QN24 152
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QN24 153
ncodefld:(FLOAT(I),1,CHROT,40313.,1)#                                   QN24 154
movechar:(NAMES,4*(J-1)+1,CHROT,7,4,0)#                                 QN24 155
movechar:(IDS,(J-1)*qmxat4:+(IPLN(I,IP)-1)*4+1,CHROT,K,4,0)#            QN24 156
K=K+5#                                                                  QN24 157
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN24 158
writeline:(0,QN24C,NQN24C,1,4)#                                         QN24 159
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN24 160
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN24 161
#                                                                       QN24 162
RETURN#                                                                 QN24 163
END#                                                                    QN24 164
systemheader:(QN25)## Set up chiral centers                             QN25   1
####################################################################    QN25   2
#                                                                  #    QN25   3
#                                QN25                              #    QN25   4
#                                                                  #    QN25   5
####################################################################    QN25   6
SUBROUTINE QN25#                                                        QN25   7
#                                                                       QN25   8
include:(AACOMN)#                                                       QN25   9
include:(QNCOMN)#                                                       QN25  10
#                                                                       QN25  11
#      SUBROUTINE CHIRAL (NIDEAL)# ESTABLISH IDEAL CHIRAL CENTERS       QN25  12
#                                                                       QN25  13
string:(IDGRP,4)#                                                       QN25  14
REAL A(3,3)#                                                            QN25  15
chardata:(QN25A, -----DICTIONARY OF CHIRAL CENTERS----- )#              QN25  16
chardata:(QN25B, CENTER NUMBER 1 SPECIFIES THE ALPHA-CARBON $#          QN25  17
CENTER FOR ALL HANDED AMINO ACIDS.)#                                    QN25  18
chardata:(QN25C,[ ICRABS code: 1=ABSOLUTE SPECIFICATION BY $#           QN25  19
IDEAL GROUP ])#                                                         QN25  20
chardata:(QN25D, 0=MAGNITUDE SPECIFICATION BY IDEAL GROUP $#            QN25  21
SIGN SPECIFICATION BY MODEL)#                                           QN25  22
chardata:(QN25E,[ NO. RESIDUE ICRABS CENT SURROUNDING ATOMS $#          QN25  23
CHIRAL VOLUME (SIGN GIVES HANDEDNESS) ])#                               QN25  24
datastuff:#                                                             QN25  25
IC=0#                                                                   QN25  26
IF(LINID<17) iquit:(QN2513)#           Input line order error           QN25  27
#                                                                       QN25  28
#  READ CHIRAL CENTER SPECIFICATION LINES                               QN25  29
#  --------------------------------------                               QN25  30
#                                                                       QN25  31
REPEAT#                                                                 QN25  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN25  33
IF(LINID>17) BREAK#                                                     QN25  34
CALL QN04(IDGRP,1,4) ; CALL QN05(IDGRP,IACID,NAMES,4*NACIDS,4)#         QN25  35
IC=IC+1#                                                                QN25  36
IF(IC>8) iquit:(QN2501)#                                                QN25  37
IHAND=NINT(AMIN1(1.0,AMAX1(0.0,BUFIN(2))))# Get handedness signal 0/1   QN25  38
ICRABS(IC)=IHAND ; IDCHR(IC)=IACID#    Store center type and            QN25  39
DO IA=1,4 ; ICHR(IC,IA)=NINT(AMAX1(1.0,BUFIN(IA+2)))# Atom id numbers   QN25  40
ND=NDISTS(IACID) ; M=0#                Identify associated              QN25  41
DO I=1,3#                              Distance location numbers        QN25  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN25  43
L=I+1 ; DO J=L,4#                                                       QN25  44
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN25  45
M=M+1 ; IP=ICHR(IC,I) ; JP=ICHR(IC,J)#                                  QN25  46
DO IG=1,ND#                                                             QN25  47
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN25  48
IF(IP==IATM(IACID,IG)&JP==JATM(IACID,IG))#                              QN25  49
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN25  50
KCHR(IC,M)=IG ; BREAK#                                                  QN25  51
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN25  52
IF(IP!=JATM(IACID,IG)\JP!=IATM(IACID,IG)) NEXT#                         QN25  53
KCHR(IC,M)=-IG ; BREAK#                                                 QN25  54
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN25  55
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN25  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN25  57
#                                                                       QN25  58
#    EVALUATE THE IDEAL CHIRAL VOLUME (TRIPLE SCALAR PRODUCT)           QN25  59
#    --------------------------------------------------------           QN25  60
#                                                                       QN25  61
IA=ICHR(IC,1)#                                                          QN25  62
DO I=1,3#                                                               QN25  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN25  64
IG=ICHR(IC,I+1) ; A(I,1)=XS(IACID,IG)-XS(IACID,IA)#                     QN25  65
A(I,2)=YS(IACID,IG)-YS(IACID,IA);A(I,3)=ZS(IACID,IG)-ZS(IACID,IA)#      QN25  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN25  67
VCHR(IC)=QN03(A)#                      Use function det3                QN25  68
readline:(INLINE,NLINEC)#              Reload input line buffer         QN25  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN25  70
NCHR=IC#                                                                QN25  71
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN25  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN25  73
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN25A,NQN25A,3,4) ; LINRM=3#     QN25  74
#                                                                       QN25  75
#  LIST THE CHIRAL CENTER DICTIONARY                                    QN25  76
#  ---------------------------------                                    QN25  77
#                                                                       QN25  78
DO IC=1,NCHR#                                                           QN25  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN25  80
LISLOC=LISLOC-1 ; IF(LISLOC<0) BREAK#  Quit if thats all user wants     QN25  81
IACID=IDCHR(IC)#                                                        QN25  82
K=21 ; DO I=1,4#                                                        QN25  83
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN25  84
movechar:(IDS,(IACID-1)*qmxat4:+(ICHR(IC,I)-1)*4+1,CHROT,K,4,0)#        QN25  85
K=K+4#                                                                  QN25  86
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN25  87
ncodefld:(FLOAT(IC),1,CHROT,40313.,1)#                                  QN25  88
ncodefld:(VCHR(IC),1,CHROT,471032.,1)#                                  QN25  89
ncodefld:(FLOAT(ICRABS(IC)),1,CHROT,190313.,1)#                         QN25  90
movechar:(NAMES,4*(IACID-1)+1,CHROT,9,4,0)#                             QN25  91
writeline:(0,QN25E,NQN25E,1,4)#                                         QN25  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN25  93
writeline:(1,QN25B,NQN25B,3,4)#                                         QN25  94
writeline:(0,QN25C,NQN25C,3,4)#                                         QN25  95
writeline:(0,QN25D,NQN25D,3,4)#                                         QN25  96
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN25  97
RETURN#                                                                 QN25  98
END#                                                                    QN25  99
systemheader:(QN26)## Set up idealized van der Waals distances          QN26   1
####################################################################    QN26   2
#                                                                  #    QN26   3
#                                QN26                              #    QN26   4
#                                                                  #    QN26   5
####################################################################    QN26   6
SUBROUTINE QN26#                                                        QN26   7
#                                                                       QN26   8
include:(AACOMN)#                                                       QN26   9
include:(QNCOMN)#                                                       QN26  10
#     ESTABLISH IDEAL VAN DER WAALS CONTACTS                            QN26  11
#     SUBROUTINE VDWAAL (NIDEAL)#                                       QN26  12
#                                                                       QN26  13
string:(IDGRP,4)#                                                       QN26  14
string:(LABEL,12)#                                                      QN26  15
INTEGER MATM(10,20),NATM(10,20),LTYP(10,20)#                            QN26  16
chardata:(QN26A, VDWCON )#                                              QN26  17
chardata:(DASH,-)#                                                      QN26  18
chardata:(QN26C, ATOM NO. IIII FOR DISTANCE NO. IIII OF $#              QN26  19
RESIDUE XXXX EXCEEDS THE HIGHEST ATOM NO. IIII FOR THAT RESIDUE.)#      QN26  20
chardata:(QN26D, -----DICTIONARY OF POTENTIAL CONTACT $#                QN26  21
RESTRAINTS----- )#                                                      QN26  22
chardata:(QN26E, SPECIES  CODE  VAN DER WAALS CONTACT DISTANCE )#       QN26  23
chardata:(QN26F, -----VAN DER WAALS CONTACT DISTANCE----- )#            QN26  24
chardata:(QN26G, NO. RESIDUE   ATOMS TYPE   ATOMS TYPE   ATOMS $#       QN26  25
TYPE   ATOMS TYPE   ATOMS TYPE   ATOMS TYPE   ATOMS TYPE   $#           QN26  26
ATOMS TYPE  )#                                                          QN26  27
realdata:(FMT,[140413.,360413.,860413.])#                               QN26  28
datastuff:#                                                             QN26  29
#                                                                       QN26  30
#----MODIFY THE ATOM TYPE IDENTIFIER FOR CARBONYL CARBONS FROM 6 TO 3,  QN26  31
#---- WHICH ARE GIVEN A DIFFERENT VDW RADIUS THAN OTHER CARBONS         QN26  32
DO IACID=1,NACIDP ;  KS(IACID,3)=3#                                     QN26  33
NTL=NTRMS+4#                                                            QN26  34
DO I=1,NTL ;  KS(NACIDS+I,3)=3#                                         QN26  35
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN26  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN26  37
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN26F,NQN26F,3,4) ; LINRM=3#     QN26  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN26  39
#----ESTABLISH THE TABLE OF VAN DER WAALS CONTACT DISTANCES             QN26  40
DO I=1,28 ; DO J=1,28 ; DVDW(I,J)=0.0#                                  QN26  41
IF(LINID<18) iquit:(QN2613)#           Input line order error           QN26  42
REPEAT#                                                                 QN26  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN26  44
IF(LINID>18) BREAK#                    Move onto next input line grou   QN26  45
CALL QN04(LABEL,1,12)#                 Get van der waals distances      QN26  46
KATM=NINT(AMIN1(28.0,AMAX1(1.0,BUFIN(2))))# Atom code                   QN26  47
VDWDST=AMAX1(1.30,BUFIN(3))#           Van der waals distance           QN26  48
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Quit if thats all user wants     QN26  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN26  50
ncodefld:(FLOAT(KATM),1,CHROT,160313.,1)#                               QN26  51
ncodefld:(VDWDST,1,CHROT,261022.,1)#                                    QN26  52
movechar:(LABEL,1,CHROT,2,12,0) ; writeline:(0,QN26E,NQN26E,1,4)#       QN26  53
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN26  54
DVDW(KATM,KATM)=VDWDST#                                                 QN26  55
readline:(INLINE,NLINEC)#              Refill input line buffer         QN26  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN26  57
DO I=1,28 ; DO J=1,28 ; DVDW(I,J)=0.5*(DVDW(I,I)+DVDW(J,J))#            QN26  58
REPEAT#                                Read the group identifier line   QN26  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN26  60
IF(LINID>22) BREAK#                    Get out for torres and beyond    QN26  61
CALL QN04(IDGRP,1,4)#                  Get the residue id               QN26  62
IF(LINID==21)#                         Is this a vdwtrm?                QN26  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN26  64
CALL QN05(IDGRP,IMAIN,NAMEM,40,4)#     Screen name to get pointer       QN26  65
ND=NINT(AMAX1(0.0,BUFIN(2)))#          Get datum count                  QN26  66
NDISTM(IMAIN)=ND#                                                       QN26  67
IF(ND==0) GO TO 101 ; I=0#                                              QN26  68
REPEAT#                                Loop over vdwcon lines           QN26  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN26  70
J=-1 ; readline:(QN26A,NQN26A)#                                         QN26  71
REPEAT#                                Loop over vdwcon data            QN26  72
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN26  73
I=I+1 ; J=J+3 ; MATM(IMAIN,I)=NINT(BUFIN(J))#                           QN26  74
NATM(IMAIN,I)=NINT(BUFIN(J+1)) ; LTYP(IMAIN,I)=NINT(BUFIN(J+2))#        QN26  75
IF(BUFIN(J+3)<=voidflg:) BREAK#                                         QN26  76
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN26  77
IF(I>=ND) BREAK#                                                        QN26  78
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN26  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN26  80
ELSE IF(LINID==20)#                    Link group?                      QN26  81
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN26  82
ND=NINT(AMAX1(0.0,BUFIN(2)))#                                           QN26  83
MD=NINT(AMAX1(0.0,BUFIN(3)))#          Get datum counts                 QN26  84
NVDWS(NACIDT+1)=ND ; NVDWS(NACIDT+2)=ND#                                QN26  85
NVDWS(NACIDT+3)=MD ; NVDWS(NACIDT+4)=MD ; IF(ND==0) GO TO 101#          QN26  86
IPEP4=NACIDT+4 ; IF(MD==0) GO TO 101 ; I=0#                             QN26  87
REPEAT#                                Loop over vdwcon lines           QN26  88
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN26  89
J=-1 ; readline:(QN26A,NQN26A)#                                         QN26  90
REPEAT#                                Loop over vdwcon data            QN26  91
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN26  92
I=I+1 ; J=J+3 ; IVDW(IPEP4,I)=NINT(BUFIN(J))#                           QN26  93
JVDW(IPEP4,I)=NINT(BUFIN(J+1)) ; KTYP(IPEP4,I)=NINT(BUFIN(J+2))#        QN26  94
IF(BUFIN(J+3)<=voidflg:) BREAK#                                         QN26  95
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN26  96
IF(I>=MD) BREAK#                                                        QN26  97
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN26  98
DO I=1,3#                                                               QN26  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN26 100
IPEP=NACIDT+I ; IF(ND==0) GO TO 101#                                    QN26 101
ND=NVDWS(IPEP)#                                                         QN26 102
DO IG=1,ND#                                                             QN26 103
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN26 104
IVDW(IPEP,IG)=IVDW(IPEP4,IG) ; JVDW(IPEP,IG)=JVDW(IPEP4,IG)#            QN26 105
KTYP(IPEP,IG)=KTYP(IPEP4,IG)#                                           QN26 106
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN26 107
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN26 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN26 109
ELSE IF(LINID==19)#                    Internal residue?                QN26 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN26 111
CALL QN05(IDGRP,IACID,NAMES,4*NACIDS,4)# Screen name to get pointer     QN26 112
ND=NINT(AMAX1(0.0,BUFIN(2)))#                                           QN26 113
MD=NINT(AMAX1(0.0,BUFIN(3)))#          Get datum counts                 QN26 114
NVDWS(IACID)=ND ; IF(ND==0) GO TO 101 ; I=0#                            QN26 115
REPEAT#                                Loop over vdwcon lines           QN26 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN26 117
J=-1 ; readline:(QN26A,NQN26A)#                                         QN26 118
REPEAT#                                Loop over vdwcon data            QN26 119
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN26 120
I=I+1 ; J=J+3 ; IVDW(IACID,I)=NINT(BUFIN(J))#                           QN26 121
JVDW(IACID,I)=NINT(BUFIN(J+1)) ; KTYP(IACID,I)=NINT(BUFIN(J+2))#        QN26 122
IF(BUFIN(J+3)<=voidflg:) BREAK#                                         QN26 123
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN26 124
IF(I>=ND) BREAK#                                                        QN26 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN26 126
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN26 127
ELSE IF(LINID==22) iquit:(QN2601)#     Vdwcon line out of order         QN26 128
101 CONTINUE ; readline:(INLINE,NLINEC)# Refresh the line input buffe   QN26 129
#                                                                       QN26 130
#----READING OF CONTACT IDENTIFIERS IS COMPLETED                        QN26 131
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN26 132
MATMS=NATOMM(1)## Make the contacts catalog for the terminal residues   QN26 133
DO I=1,NTRMS#                                                           QN26 134
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN26 135
ND=NVDWS(IACIDT(I))#                                                    QN26 136
IF(ND!=0)#                                                              QN26 137
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN26 138
DO IDIST=1,ND#                                                          QN26 139
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN26 140
IVDW(NACIDS+I,IDIST)=IVDW(IACIDT(I),IDIST)#                             QN26 141
JVDW(NACIDS+I,IDIST)=JVDW(IACIDT(I),IDIST)#                             QN26 142
KTYP(NACIDS+I,IDIST)=KTYP(IACIDT(I),IDIST)#                             QN26 143
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN26 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN26 145
NM=NDISTM(IMAINT(I)) ; INC=NATOMS(IACIDT(I))-MATMS#                     QN26 146
IF(NM!=0)#                                                              QN26 147
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN26 148
DO IM=1,NM#                                                             QN26 149
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN26 150
IDIST=ND+IM#                                                            QN26 151
IVDW(NACIDS+I,IDIST)=MATM(IMAINT(I),IM)#                                QN26 152
JVDW(NACIDS+I,IDIST)=NATM(IMAINT(I),IM)#                                QN26 153
KTYP(NACIDS+I,IDIST)=LTYP(IMAINT(I),IM)#                                QN26 154
IF(IVDW(NACIDS+I,IDIST)>MATMS)#                                         QN26 155
IVDW(NACIDS+I,IDIST)=IVDW(NACIDS+I,IDIST)+INC#                          QN26 156
IF(JVDW(NACIDS+I,IDIST)>MATMS)#                                         QN26 157
JVDW(NACIDS+I,IDIST)=JVDW(NACIDS+I,IDIST)+INC#                          QN26 158
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN26 159
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN26 160
#                                                                       QN26 161
#....ADD POTENTIAL CONTACTS BETWEEN TERMINAL ATOMS AND SIDE-CHAIN ATOMS QN26 162
NA=NATOMS(IACIDT(I)) ; MA=NATOMS(NACIDS+I) ; MI=NA+1#                   QN26 163
NMS=INC*(MA-NA) ; NVDWS(NACIDS+I)=ND+NM+NMS#                            QN26 164
IF(NMS!=0)#                                                             QN26 165
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QN26 166
IT=MATMS+1#                                                             QN26 167
DO MM=MI,MA#                                                            QN26 168
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QN26 169
DO NN=IT,NA#                                                            QN26 170
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QN26 171
IDIST=IDIST+1 ; IVDW(NACIDS+I,IDIST)=MM#                                QN26 172
JVDW(NACIDS+I,IDIST)=NN ; KTYP(NACIDS+I,IDIST)=2#                       QN26 173
IF(NN==IT) KTYP(NACIDS+I,IDIST)=1#                                      QN26 174
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QN26 175
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QN26 176
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QN26 177
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN26 178
#                                                                       QN26 179
#----PREPARE THE CATALOG OF POTENTIAL VAN DER WAALS CONTACT DISTANCES   QN26 180
NG=NACIDT+4#                                                            QN26 181
DO IACID=1,NG#                                                          QN26 182
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QN26 183
ND=NVDWS(IACID) ; NA=NATOMS(IACID)#                                     QN26 184
IF(IACID>NACIDT) NA=NATOMS(1)#                                          QN26 185
IF(IACID>NACIDT+2) NA=NATOMS(15)#                                       QN26 186
IF(ND==0) NEXT#                                                         QN26 187
DO IDIST=1,ND#                                                          QN26 188
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QN26 189
IA=IVDW(IACID,IDIST) ; JA=JVDW(IACID,IDIST)#                            QN26 190
IF(IA>NA\JA>NA)#                                                        QN26 191
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QN26 192
movechar:(NAMES,4*(IACID-1)+1,QN26C,49,4,0);BUFOT(1)=FLOAT(IA)#         QN26 193
BUFOT(2)=FLOAT(IDIST);BUFOT(3)=FLOAT(NA)#                               QN26 194
ncodefld:(BUFOT,1,QN26C,FMT,3);writeline:(1,QN26C,NQN26C,3,1)#          QN26 195
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QN26 196
IK=KS(IACID,IA);JK=KS(IACID,JA);DNBC(IACID,IDIST)=DVDW(IK,JK)#          QN26 197
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QN26 198
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QN26 199
#                                                                       QN26 200
#  LIST THE DISTANCE RESTRAINTS                                         QN26 201
#  ----------------------------                                         QN26 202
#                                                                       QN26 203
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN26 204
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 QN26 205
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN26D,NQN26D,3,4) ; LINRM=3#     QN26 206
DO I=1,NG#                                                              QN26 207
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 QN26 208
LISLOC=LISLOC-1 ; IF(LISLOC<0) BREAK#  Quit if thats all user wants     QN26 209
ND=NVDWS(I)#                                                            QN26 210
IF(ND==0)#                                                              QN26 211
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 QN26 212
movechar:(NAMES,4*(I-1)+1,CHROT,7,4,0)#                                 QN26 213
ncodefld:(FLOAT(I),1,CHROT,40313.,1)#                                   QN26 214
writeline:(0,QN26G,NQN26G,1,4) ; NEXT#                                  QN26 215
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 QN26 216
K=15 ; FM1=250213.0 ; DO IG=1,ND#                                       QN26 217
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 QN26 218
IF(K>=119)#                                                             QN26 219
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 QN26 220
writeline:(0,QN26D,NQN26D,1,4) ; K=15 ; FM1=250213.0#                   QN26 221
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 QN26 222
movechar:(NAMES,4*(I-1)+1,CHROT,7,4,0)#                                 QN26 223
ncodefld:(FLOAT(I),1,CHROT,40313.,1)#                                   QN26 224
movechar:(IDS,(I-1)*qmxat4:+(IVDW(I,IG)-1)*4+1,CHROT,K,4,0)#            QN26 225
movechar:(DASH,1,CHROT,K+4,NDASH,0)#                                    QN26 226
movechar:(IDS,(I-1)*qmxat4:+(JVDW(I,IG)-1)*4+1,CHROT,K+5,4,0)#          QN26 227
ncodefld:(FLOAT(KTYP(I,IG)),1,CHROT,FM1,1) ; K=K+13 ; FM1=FM1+130000.#  QN26 228
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 QN26 229
writeline:(0,QN26G,NQN26G,1,4)#                                         QN26 230
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 QN26 231
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 QN26 232
DO IACID=1,NACIDP ; KS(IACID,3)=6## RESTORE CARBONYL ATOM TYPE TO 6     QN26 233
DO I=1,NTL ; KS(NACIDS+I,3)=6#                                          QN26 234
#                                                                       QN26 235
RETURN#                                                                 QN26 236
END#                                                                    QN26 237
systemheader:(QN27)## Set up idealized torsion angles                   QN27   1
####################################################################    QN27   2
#                                                                  #    QN27   3
#                                QN27                              #    QN27   4
#                                                                  #    QN27   5
####################################################################    QN27   6
SUBROUTINE QN27#                                                        QN27   7
#                                                                       QN27   8
include:(AACOMN)#                                                       QN27   9
include:(QNCOMN)#                                                       QN27  10
#                                                                       QN27  11
#    SUBROUTINE TORSHN (NIDEAL)# ESTABLISH IDEAL TORSION ANGLES         QN27  12
#                                                                       QN27  13
string:(IDGRP,4)#                                                       QN27  14
string:(SECSTR,30)#                                                     QN27  15
string:(REFER,40)#                                                      QN27  16
INTEGER INBUF(12),MTWIST(6,10)#                                         QN27  17
chardata:(DASH,[-])#                                                    QN27  18
chardata:(QN27A, CHIWGT NEIGHB CHIDIS )#                                QN27  19
chardata:(QN27B, -----DICTIONARY OF CONFORMATIONAL TORSION $#           QN27  20
ANGLES----- )#                                                          QN27  21
chardata:(QN27C, NO. RESIDUE          PHI   PSI  $#                     QN27  22
OMEGA                     CHI1  CHI2  CHI3  CHI4  CHI5 )#               QN27  23
chardata:(QN27D, -----DICTIONARY OF SECONDARY STRUCTURES----- )#        QN27  24
chardata:(QN27E,      STRUCTURAL ELEMENT                  $#            QN27  25
CODE     PHI     PSI )#                                                 QN27  26
chardata:(QN27F,    -     -     -     -     -)#                         QN27  27
realdata:(FMT4,[450513.,540912.,620812.])#                              QN27  28
datastuff:#                                                             QN27  29
DO I=1,NACIDS ; NCHIS(I)=-1#           Initialize                       QN27  30
IF(LINID<23) iquit:(QN2713)#           Input line order error           QN27  31
REPEAT#                                Read torsion specifications      QN27  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN27  33
IF(LINID>24) BREAK#                                                     QN27  34
CALL QN04(IDGRP,1,4)#                  Get residue name                 QN27  35
IF(LINID==23)#                         Is this a torres line?           QN27  36
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN27  37
CALL QN05(IDGRP,IACID,NAMES,4*NACIDS,4)# Get pointer from name          QN27  38
DO IA=1,12 ; INBUF(IA)=0#              Zero input buffer                QN27  39
NA=0 ; REPEAT#                         Get atoms to which chis apply    QN27  40
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN27  41
IF(BUFIN(NA+2)<=voidflg:) BREAK#       Quit at first void field         QN27  42
NA=NA+1 ; INBUF(NA)=NINT(AMAX1(0.0,BUFIN(NA+1)))#                       QN27  43
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN27  44
NCHI=NA-7#                             Get chis from no. of fields      QN27  45
DO IA=1,NA ; ITWIST(IA,IACID)=INBUF(IA)# Identify atoms                 QN27  46
NCHIS(IACID)=NCHI ; IF(NCHI>0)#                                         QN27  47
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN27  48
#                                                                       QN27  49
#....ESTABLISH THE CHI-ANGLE WEIGHTING SCHEME                           QN27  50
readline:(QN27A,NQN27A)#                                                QN27  51
IF(LINID!=1) iquit:(QN2702)#           Must be a chiwgt line            QN27  52
DO ICHI=1,NCHI ; KHIWGT(ICHI,IACID)=NINT(AMAX1(0.0,BUFIN(ICHI+1)))#     QN27  53
ND=NDISTS(IACID)#                      Identify associated distances    QN27  54
DO ICHI=1,NCHI#                                                         QN27  55
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN27  56
MP=0 ; DO I=1,3#                                                        QN27  57
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN27  58
L=I+1 ; DO J=L,4#                                                       QN27  59
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN27  60
MP=MP+1;IP=ITWIST(I+ICHI+3,IACID);JP=ITWIST(J+ICHI+3,IACID)#            QN27  61
KHIDST(ICHI,MP,IACID)=0#                                                QN27  62
DO IG=1,ND#                                                             QN27  63
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN27  64
IF(IP==IATM(IACID,IG)&JP==JATM(IACID,IG))#                              QN27  65
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN27  66
KHIDST(ICHI,MP,IACID)=IG ; BREAK#                                       QN27  67
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN27  68
IF(IP!=JATM(IACID,IG)\JP!=IATM(IACID,IG)) NEXT#                         QN27  69
KHIDST(ICHI,MP,IACID)=-IG#                                              QN27  70
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN27  71
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN27  72
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN27  73
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN27  74
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN27  75
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN27  76
ELSE IF(LINID==24)#                    Terminal group tortrm line?      QN27  77
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN27  78
CALL QN05(IDGRP,IMAIN,NAMEM,40,4)#     Get pointer from name            QN27  79
NA=0 ; REPEAT#                         Get atoms to which chis apply    QN27  80
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN27  81
IF(BUFIN(NA+2)<=voidflg:) BREAK#       Quit at first void field         QN27  82
NA=NA+1 ; INBUF(NA)=NINT(AMAX1(0.0,BUFIN(NA+1)))#                       QN27  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN27  84
IF(NA!=6) iquit:(QN2703)#              Bad tortrm input line            QN27  85
DO IA=1,NA ; MTWIST(IA,IMAIN)=INBUF(IA)# Identify atoms                 QN27  86
#                                                                       QN27  87
#....IDENTIFY ASSOCIATED DISTANCES                                      QN27  88
readline:(QN27A,NQN27A)#                                                QN27  89
IF(LINID!=2) iquit:(QN2704)#           Must have a neighb line          QN27  90
DO IA=1,6 ; MNABOR(IA,IMAIN)=NINT(AMAX1(-500.0,BUFIN(IA+1)))#           QN27  91
readline:(QN27A,NQN27A)#                                                QN27  92
IF(LINID!=3) iquit:(QN2705)#           Must have a chidis line          QN27  93
I=0 ; DO IANG=1,3 ; DO IP=1,6#                                          QN27  94
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN27  95
I=I+1 ; MANDST(IANG,IP,IMAIN)=NINT(AMAX1(-500.0,BUFIN(I+1)))#           QN27  96
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN27  97
DO IANG=1,3## Set up a directory of inter/intra residue linkage types   QN27  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN27  99
MP=0 ; DO I=1,3#                                                        QN27 100
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN27 101
L=I+1 ; DO J=L,4#                                                       QN27 102
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN27 103
MP=MP+1 ; IA=I+IANG-1 ; JA=J+IANG-1#                                    QN27 104
MANZIP(IANG,MP,IMAIN)=MNABOR(IA,IMAIN)+MNABOR(JA,IMAIN)+2#              QN27 105
IF(MNABOR(IA,IMAIN)==5) MANZIP(IANG,MP,IMAIN)=5#                        QN27 106
IF(MNABOR(JA,IMAIN)==5) MANZIP(IANG,MP,IMAIN)=5#                        QN27 107
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN27 108
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN27 109
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN27 110
#                                                                       QN27 111
#....REPAIR RESIDUE IDENTIFIERS FOR TERMINAL UNITS                      QN27 112
DO IA=1,6 ; IF(MNABOR(IA,IMAIN)==5) MNABOR(IA,IMAIN)=0#                 QN27 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN27 114
readline:(INLINE,NLINEC)#              Get in next input line           QN27 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN27 116
MATMS=NATOMM(1)#                       Form the terminal groups         QN27 117
DO IT=1,NTRMS#                                                          QN27 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN27 119
INC=NATOMS(IACIDT(IT))-MATMS#                                           QN27 120
DO IA=1,6#                                                              QN27 121
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN27 122
ITWIST(IA,NACIDS+IT)=MTWIST(IA,IMAINT(IT))#                             QN27 123
IF(ITWIST(IA,NACIDS+IT)>MATMS)#                                         QN27 124
ITWIST(IA,NACIDS+IT)=ITWIST(IA,NACIDS+IT)+INC#                          QN27 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN27 126
NCHI=NCHIS(IACIDT(IT))#                                                 QN27 127
NCHIS(NACIDS+IT)=NCHI#                                                  QN27 128
IF(NCHI==0) NEXT#                                                       QN27 129
NA=NCHI+7#                                                              QN27 130
DO IA=7,NA ; ITWIST(IA,NACIDS+IT)=ITWIST(IA,IACIDT(IT))#                QN27 131
DO ICHI=1,NCHI#                                                         QN27 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN27 133
KHIWGT(ICHI,NACIDS+IT)=KHIWGT(ICHI,IACIDT(IT))#                         QN27 134
DO IP=1,6#                                                              QN27 135
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN27 136
KHIDST(ICHI,IP,NACIDS+IT)=KHIDST(ICHI,IP,IACIDT(IT))#                   QN27 137
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN27 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN27 139
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN27 140
#                                                                       QN27 141
# LIST THE TORSION ATOM SPECIFICATIONS                                  QN27 142
# ------------------------------------                                  QN27 143
#                                                                       QN27 144
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN27 145
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN27 146
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN27B,NQN27B,3,4) ; LINRM=3#     QN27 147
DO J=1,NACIDT#                                                          QN27 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QN27 149
LISLOC=LISLOC-1 ; IF(LISLOC<0) BREAK#  Quit if thats all user wants     QN27 150
movechar:(NAMES,4*(J-1)+1,CHROT,7,4,0)#                                 QN27 151
ncodefld:(FLOAT(J),1,CHROT,40313.,1)#                                   QN27 152
IF(NCHIS(J)<0)#                                                         QN27 153
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QN27 154
writeline:(0,QN27C,NQN27C,1,4) ; NEXT#                                  QN27 155
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QN27 156
movechar:(QN27F,1,CHROT,15,NQN27F,0)#                                   QN27 157
K=0 ; DO I=1,6#                                                         QN27 158
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QN27 159
IF(ITWIST(I,J)!=0) movechar:(IDS,$#                                     QN27 160
(J-1)*qmxat4:+(ITWIST(I,J)-1)*4+1,CHROT,6*(I-1)+15,4,0)#                QN27 161
IF(ITWIST(I,J)==0) movechar:(BLANK,1,CHROT,6*(I-1)+15,4,1)#             QN27 162
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QN27 163
IF(NCHIS(J)<=0)#                                                        QN27 164
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QN27 165
writeline:(0,QN27C,NQN27C,1,4) ; NEXT#                                  QN27 166
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QN27 167
NA=NCHIS(J)+9#                                                          QN27 168
movechar:(IDS,(J-1)*qmxat4:+(ITWIST(2,J)-1)*4+1,CHROT,52,4,0)#          QN27 169
movechar:(IDS,(J-1)*qmxat4:+(ITWIST(3,J)-1)*4+1,CHROT,59,4,0)#          QN27 170
movechar:(DASH,1,CHROT,56,NDASH,0)#                                     QN27 171
DO I=9,NA#                                                              QN27 172
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QN27 173
movechar:(DASH,1,CHROT,6*(I-9)+62,NDASH,0)#                             QN27 174
movechar:(IDS,(J-1)*qmxat4:+(ITWIST(I-2,J)-1)*4+1,$#                    QN27 175
CHROT,6*(I-9)+65,4,0)#                                                  QN27 176
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QN27 177
writeline:(0,QN27C,NQN27C,1,4) ; NEXT#                                  QN27 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QN27 179
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN27 180
#                                                                       QN27 181
#  READ IDEAL CONFORMATIONS FOR ELEMENTS OF SECONDARY STRUCTURE         QN27 182
#  ------------------------------------------------------------         QN27 183
#                                                                       QN27 184
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN27 185
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QN27 186
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN27D,NQN27D,3,4) ; LINRM=3#     QN27 187
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QN27 188
REPEAT#                                                                 QN27 189
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 QN27 190
IF(LINID>25) BREAK#                                                     QN27 191
movechar:(BLANK,1,SECSTR,1,30,1)#      Clear label to blanks            QN27 192
IF(BUFIN(1)<voidflg:)#                 It must be characters            QN27 193
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 QN27 194
stringlim:(1,I,J) ; J=MIN0(J-I,30) ; movechar:(CHRIN,I,SECSTR,1,J,0)#   QN27 195
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 QN27 196
KODE=NINT(AMAX1(1.0,BUFIN(2)))#                                         QN27 197
PHI=AMIN1(180.0,AMAX1(-180.0,BUFIN(3)))#                                QN27 198
PSI=AMIN1(180.0,AMAX1(-180.0,BUFIN(4)))#                                QN27 199
movechar:(BLANK,1,REFER,1,40,1)#       Clear reference to blanks        QN27 200
IF(BUFIN(5)<voidflg:)#                 It must be characters            QN27 201
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 QN27 202
stringlim:(5,I,J) ; J=MIN0(J-I,40) ; movechar:(CHRIN,I,REFER,1,J,0)#    QN27 203
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 QN27 204
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN27 205
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 QN27 206
movechar:(SECSTR,1,CHROT,8,30,0) ; BUFOT(1)=FLOAT(KODE)#                QN27 207
BUFOT(2)=PHI ; BUFOT(3)=PSI ; ncodefld:(BUFOT,1,CHROT,FMT4,4)#          QN27 208
movechar:(REFER,1,CHROT,65,40,0)#                                       QN27 209
writeline:(0,QN27E,NQN27E,1,4)#                                         QN27 210
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 QN27 211
PHIPSI(1,KODE)=PHI ; PHIPSI(2,KODE)=PSI#                                QN27 212
readline:(INLINE,NLINEC)#              Refresh the input line buffer    QN27 213
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 QN27 214
RETURN#                                                                 QN27 215
END#                                                                    QN27 216
systemheader:(QN28)## Set up ideal 3-param'r elipsoids ; aniso t.f.     QN28   1
####################################################################    QN28   2
#                                                                  #    QN28   3
#                                QN28                              #    QN28   4
#                                                                  #    QN28   5
####################################################################    QN28   6
SUBROUTINE QN28#                                                        QN28   7
#                                                                       QN28   8
include:(AACOMN)#                                                       QN28   9
include:(QNCOMN)#                                                       QN28  10
#                                                                       QN28  11
#----ESTABLISH IDEAL 3-PARAMETER ELLIPSOIDS FOR ANISOTROPIC B'S         QN28  12
#     SUBROUTINE ELLIPS (NIDEAL)                                        QN28  13
#                                                                       QN28  14
string:(IDGRP,4)#                                                       QN28  15
INTEGER MPS(10,10,4)#                                                   QN28  16
chardata:(QN28A, -----DICTIONARY OF ELLIPSOID ORIENTATION $#            QN28  17
SPECIFICATIONS----- )#                                                  QN28  18
chardata:(QN28B, )#                                                     QN28  19
chardata:(DASH,[-])#                                                    QN28  20
chardata:(LETP,[P()])#                                                  QN28  21
chardata:(LETS,[,S()])#                                                 QN28  22
chardata:(CLOSE,[)(])#                                                  QN28  23
intdata:(IOFF,[2,7,15,20])#                                             QN28  24
datastuff:#                                                             QN28  25
#                                                                       QN28  26
#----NOTE: NEGATIVE ATOM SPECIFIER NUMBERS REFER TO PREVIOUS RESIDUES.  QN28  27
#----REFERENCES TO FOLLOWING RESIDUES ARE FORBIDDEN.                    QN28  28
DO IACID=1,NACIDT;DO IA=1,50;DO JA=1,4;KPS(IACID,IA,JA)=0# Initialize   QN28  29
IF(LINID<26) iquit:(QN2813)#           Input line order error           QN28  30
REPEAT#                                Read a group identifier card     QN28  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN28  32
IF(LINID>27) BREAK#                                                     QN28  33
CALL QN04(IDGRP,1,4)#                  Get residue name from input li   QN28  34
IF(LINID==27)#                         Is this an ellres line?          QN28  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN28  36
#                                                                       QN28  37
#----ELLIPSOID SPECIFICATIONS FOR PEPTIDE SIDE CHAINS AND OTHER GROUPS  QN28  38
CALL QN05(IDGRP,IACID,NAMES,4*NACIDS,4)# Get pointer from name          QN28  39
I=-4 ; REPEAT#                                                          QN28  40
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN28  41
I=I+5 ; IF(BUFIN(I+1)<=voidflg:) BREAK#                                 QN28  42
IATOM=NINT(AMAX1(1.0,BUFIN(I+1)))#                                      QN28  43
KPS(IACID,IATOM,1)=NINT(AMAX1(1.0,BUFIN(I+2)))#                         QN28  44
KPS(IACID,IATOM,2)=NINT(AMAX1(1.0,BUFIN(I+3)))#                         QN28  45
KPS(IACID,IATOM,3)=NINT(AMAX1(1.0,BUFIN(I+4)))#                         QN28  46
KPS(IACID,IATOM,4)=NINT(AMAX1(1.0,BUFIN(I+5)))#                         QN28  47
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN28  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN28  49
#                                                                       QN28  50
#----ELLIPSOID SPECIFICATIONS FOR MAIN CHAIN AND TERMINAL GROUPS        QN28  51
ELSE IF(LINID==26)#                    Elltrm line?                     QN28  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN28  53
CALL QN05(IDGRP,IMAIN,NAMEM,40,4)#     Get pointer from name            QN28  54
I=-4 ; REPEAT#                                                          QN28  55
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN28  56
I=I+5 ; IF(BUFIN(I+1)<=voidflg:) BREAK#                                 QN28  57
IATOM=NINT(AMAX1(1.0,BUFIN(I+1)))#                                      QN28  58
MPS(IMAIN,IATOM,1)=NINT(AMAX1(1.0,BUFIN(I+2)))#                         QN28  59
MPS(IMAIN,IATOM,2)=NINT(AMAX1(1.0,BUFIN(I+3)))#                         QN28  60
MPS(IMAIN,IATOM,3)=NINT(AMAX1(1.0,BUFIN(I+4)))#                         QN28  61
MPS(IMAIN,IATOM,4)=NINT(AMAX1(1.0,BUFIN(I+5)))#                         QN28  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN28  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN28  64
readline:(INLINE,NLINEC)#              New line into input buffer       QN28  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN28  66
#                                                                       QN28  67
#----READING IS FINISHED.  CONJUGATE MAIN CHAIN TO SIDE CHAIN ATOMS     QN28  68
MATMS=NATOMM(1)#                                                        QN28  69
DO IACID=1,NACIDP ; DO IATOM=1,MATMS ; DO JA=1,4#                       QN28  70
KPS(IACID,IATOM,JA)=MPS(1,IATOM,JA)#                                    QN28  71
DO IT=1,NTRMS## FORM THE SPECIFICATIONS FOR TERMINAL RESIDUES           QN28  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN28  73
DO IATOM=1,MATMS ; DO JA=1,4#          Main-chain atoms                 QN28  74
KPS(NACIDS+IT,IATOM,JA)=MPS(IMAINT(IT),IATOM,JA)#                       QN28  75
NS1=MATMS+1 ; NSN=NATOMS(IACIDT(IT))#  Side-chain atoms                 QN28  76
IF(NS1<=NSN)#                                                           QN28  77
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN28  78
DO IATOM=NS1,NSN ; DO JA=1,4#                                           QN28  79
KPS(NACIDS+IT,IATOM,JA)=KPS(IACIDT(IT),IATOM,JA)#                       QN28  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN28  81
NT1=MATMS+1 ; NTN=NATOMM(IMAINT(IT))#  Extra terminal group atoms       QN28  82
IF(NT1<=NTN)#                                                           QN28  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN28  84
DO MATOM=NT1,NTN#                                                       QN28  85
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN28  86
IATOM=NSN+MATOM-MATMS#                                                  QN28  87
DO JA=1,4#                                                              QN28  88
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN28  89
JATOM=MPS(IMAINT(IT),MATOM,JA)#                                         QN28  90
IF(JATOM>MATMS) JATOM=NSN+JATOM-MATMS#                                  QN28  91
KPS(NACIDS+IT,IATOM,JA)=JATOM#                                          QN28  92
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN28  93
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN28  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN28  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN28  96
#                                                                       QN28  97
# LIST THE ELLIPOSID ORIENTATION SPECIFICATIONS                         QN28  98
# ---------------------------------------------                         QN28  99
#                                                                       QN28 100
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN28 101
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN28 102
LISLOC=LISGEN ; LINRM=5#               Set up for heading print-out     QN28 103
DO I=1,NACIDT#                                                          QN28 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN28 105
NA=NATOMS(I)#                                                           QN28 106
ncodefld:(FLOAT(I),1,CHROT,40313.,1)#                                   QN28 107
movechar:(NAMES,4*(I-1)+1,CHROT,7,4,0) ; K=23#                          QN28 108
DO IA=1,NA#                                                             QN28 109
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN28 110
IF(K>=113)#                                                             QN28 111
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN28 112
writeline:(0,QN28A,NQN28A,1,4) ; K=23#                                  QN28 113
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN28 114
movechar:(IDS,(I-1)*qmxat4:+(IABS(IA)-1)*4+1,CHROT,18,4,0)#             QN28 115
DO JA=1,4#                                                              QN28 116
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN28 117
KA=KPS(I,IA,JA)#                                                        QN28 118
IF(JA==1)#                                                              QN28 119
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN28 120
movechar:(LETP,1,CHROT,K,2,0)#                                          QN28 121
movechar:(DASH,1,CHROT,K+6,NDASH,0)#                                    QN28 122
movechar:(CLOSE,1,CHROT,K+11,NCLOSE,0)#                                 QN28 123
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN28 124
ELSE IF(JA==3)#                                                         QN28 125
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN28 126
movechar:(LETS,1,CHROT,K+12,3,0)#                                       QN28 127
movechar:(DASH,1,CHROT,K+19,NDASH,0)#                                   QN28 128
movechar:(CLOSE,1,CHROT,K+25,NCLOSE,0)#                                 QN28 129
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN28 130
IF(KA==0) movechar:(BLANK,1,CHROT,K+IOFF(JA),4,1)#                      QN28 131
ELSE movechar:(IDS,(I-1)*qmxat4:+(IABS(KA)-1)*4+1,$#                    QN28 132
CHROT,K+IOFF(JA),4,0)#                                                  QN28 133
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN28 134
K=K+30#                                                                 QN28 135
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN28 136
writeline:(0,QN28B,NQN28B,1,4)#                                         QN28 137
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN28 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN28 139
RETURN#                                                                 QN28 140
END#                                                                    QN28 141
systemheader:(QN29)## Identify atom pairs in planar groups              QN29   1
####################################################################    QN29   2
#                                                                  #    QN29   3
#                                QN29                              #    QN29   4
#                                                                  #    QN29   5
####################################################################    QN29   6
SUBROUTINE QN29(IACID,ND,NA,M,KIND)#                                    QN29   7
#                                                                       QN29   8
include:(AACOMN)#                                                       QN29   9
include:(QNCOMN)#                                                       QN29  10
#                                                                       QN29  11
#****IDENTIFY ATOM PAIRS WITHIN THE PLANAR GROUP                        QN29  12
#     SUBROUTINE PAIRS(IACID,ND,IATM,JATM,NA,IPLN,KPLN,M,KIND)          QN29  13
#                                                                       QN29  14
M=0 ; DO J=2,NA#                                                        QN29  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN29  16
K=J-1 ; DO I=1,K#                                                       QN29  17
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN29  18
M=M+1 ; IP=IPLN(KIND,I) ; JP=IPLN(KIND,J)#                              QN29  19
KPLN(KIND,M)=0 ; DO IG=1,ND#                                            QN29  20
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN29  21
IF(IP==IATM(IACID,IG)&JP==JATM(IACID,IG))#                              QN29  22
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN29  23
KPLN(KIND,M)=IG ; BREAK#                                                QN29  24
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN29  25
IF(IP!=JATM(IACID,IG)\JP!=IATM(IACID,IG)) NEXT#                         QN29  26
KPLN(KIND,M)=-IG#                                                       QN29  27
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN29  28
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN29  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN29  30
RETURN#                                                                 QN29  31
END#                                                                    QN29  32
systemheader:(QN40)## Load atomic parameters from file A                QN40   1
####################################################################    QN40   2
#                                                                  #    QN40   3
#                                QN40                              #    QN40   4
#                                                                  #    QN40   5
####################################################################    QN40   6
SUBROUTINE QN40#                                                        QN40   7
#                                                                       QN40   8
# TAKEN OVER FROM SUBROUTINE ATOMIN OF PROGRAM PROTIN                   QN40   9
# ---------------------------------------------------                   QN40  10
#                                                                       QN40  11
include:(AACOMN)#                                                       QN40  12
include:(QNCOMN)#                                                       QN40  13
INTEGER IPT,PSIZ,IWNT(20),IREL(21),KEY(4)# For i/o operations           QN40  14
LOGICAL ZCHAIN#                                                         QN40  15
string:(CHAIN,arith:(3,*,qmxchn:))## Chain identifiers from BDF         QN40  16
string:(CHAINI,3)## Chain identifier from BDF                           QN40  17
string:(LABEL,9)#                                                       QN40  18
string:(IDATM,4)#                                                       QN40  19
string:(IDGRP,3)#                                                       QN40  20
intdata:(IPOW,[1000,100,10,1])#        Conversion factors               QN40  21
string:(JDATM,4)##                                                      QN40  22
INTEGER HIT#                           Missing atom signal              QN40  23
INTEGER HITHET#                        Hetero atom signal               QN40  24
INTEGER JCHAIN## Total characters in table CHAIN                        QN40  25
string:(MDGRP,1)## Single letter residue name code from table           QN40  26
INTEGER OLDRES## Old residue number from BDF for checking               QN40  27
string:(RESCOD,4)## Residue code in ascii from BDF                      QN40  28
string:(RESNAM,4)## Residue name in ascii from BDF                      QN40  29
INTEGER RESNUM## Integer translation of user's residue sequence no.     QN40  30
string:(RESSEQ,4)## Residue sequence no. in ascii from BDF              QN40  31
string:(XIDATM,24)## XTAL BDF atom ID                                   QN40  32
chardata:(CNTS,1234567890_)#           The integers to deasciify        QN40  33
chardata:(DISOR,DIS )#                                                  QN40  34
chardata:(HYDR,H)#                     Symbol for hydrogen              QN40  35
chardata:(DEUT,D)#                     Symbol for deuterium             QN40  36
chardata:(OXT,OXT)#                    Symbol for a c terminal oxygen   QN40  37
chardata:(HT,HT)#                      Symbol for a hetro atom          QN40  38
chardata:(QN40A, ERROR IN ATOM XXXXXXXXXXXXXXXXXXXXXXXX.  RESIDUE $#    QN40  39
NAME XXX IS NOT IN THE TABLE OF STANDARD GROUPS)#                       QN40  40
chardata:(QN40B,[ ATOM NAME XXXXXXXXXXXXXXXXXXXXXXXX, ID XXXX, GIVEN $# QN40  41
FOR RESIDUE XXXX NO. XXXX (XXXX) IS NOT IN "IDEALS" TABLE.  $#          QN40  42
ATOM OMITTED.])#                                                        QN40  43
chardata:(QN40C,[ A DUPLICATE OF ATOM XXXXXXXXXXXXXXXXXXXXXXXX, $#      QN40  44
ID XXXX, FOR RESIDUE XXXX XXXX HAS BEEN DETECTED.  ATOM OMITTED.])#     QN40  45
chardata:(QN40D, -----ATOMIC COORDINATES----- )#                        QN40  46
chardata:(QN40E, ONE OR MORE OF THE FOLLOWING ARRAYS ARE full: )#       QN40  47
chardata:(QN40F,[  RESIDUE ATOMS   RESIDUE NAMES    CHAIN NAMES ])#     QN40  48
chardata:(QN40G,[ POSSIBLE FOUND  POSSIBLE FOUND  POSSIBLE FOUND])#     QN40  49
chardata:(QN40H,  ATOM  NAME                   CHN RESIDUE    $#        QN40  50
SF        X        Y        Z        B      POP   CHN LABEL )#          QN40  51
chardata:(QN40I, RESIDUE III OF CHAIN II IS NOT IN THE TABLE OF $#      QN40  52
IDEAL GROUPS)#                                                          QN40  53
chardata:(QN40J, THE FOLLOWING IDEAL MODEL ATOMS ARE MISSING $#         QN40  54
FROM THE TRIAL STRUCTURE)#                                              QN40  55
chardata:(QN40K,[ ATOM AAAA OF RESIDUE NUMBER        (    )])#          QN40  56
chardata:(QN40L, NONE FOUND, APPARENTLY ALL GROUPS ARE COMPLETE. )#     QN40  57
realdata:(FMTA,[60513.,340213.,420313.,450313.,480313.,$#               QN40  58
610942.,700942.,790942.,870832.,950832.])#                              QN40  59
realdata:(FMT5,[120313.,240213.])#                                      QN40  60
realdata:(FMTL,[10113.,50333.])#                                        QN40  61
realdata:(FMT,[90513.,150513.,250513.,310513.,410513.,470513.])#        QN40  62
datastuff:#                                                             QN40  63
#                                                                       QN40  64
#                                                                       QN40  65
#  INITIALIZE COUNT AND SIGNALS                                         QN40  66
IQZERO=-1 ; INOW=0 ; NOWCHN=0 ;  JCHAIN=0 ; NOCC=0# Initialize          QN40  67
NRESID=0 ; NRESCN=0 ; OLDRES=-1 ; NUMHET=0# Count residues & heteros    QN40  68
#                                                                       QN40  69
#  SET UP TO READ ATOMIC DATA FROM BDF ON FILEA                         QN40  70
#  --------------------------------------------                         QN40  71
#                                                                       QN40  72
IWNT(1)=14#                            Ask for atom id                  QN40  73
IWNT(2)=15#                            Ask for residue code             QN40  74
IWNT(3)=16#                            Ask for residue sequence         QN40  75
IWNT(4)=18#                            Chain id & most sig dig res se   QN40  76
IWNT(5)=19#                            Ask for residue name             QN40  77
IWNT(6)=1 ; IWNT(7)=2 ; IWNT(8)=3#     Ask for x,y,z                    QN40  78
IWNT(9)=4 ; IWNT(10)=11#               Ask for u and pop param          QN40  79
KEY(1)=8#                              The first six are manditory      QN40  80
KEY(2)=10#                             U and pop are optional           QN40  81
KEY(3)=0 ; KEY(4)=0#                                                    QN40  82
indexpkt:(FILEA,lratom:,PSIZ,IPT,0,KEY,IWNT,IREL)#                      QN40  83
IF(KEY(4)<=0) iquit:(QN4013)#          No atoms means no run            QN40  84
STEPA=5 ; IPUT=MARKA-STEPA; LINRM=10#  Set up to store atom name/coor   QN40  85
LISLOC=0 ; IF(LISTIT==yes:)#           Check if listing is to be done   QN40  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN40  87
LISLOC=99999 ; LINRM=5 ; writeline:(1,QN40D,NQN40D,3,4) ; LINRM=3#      QN40  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN40  89
REPEAT#                                Read an atomic coordinates       QN40  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN40  91
readwpkt:(FILEA,lratom:,PSIZ,IPT,0)#   Read atom coordinates            QN40  92
IF(IPT<=0) BREAK#                      Quit when all atoms loaded       QN40  93
IPUT=IPUT+STEPA#                       Point to next atom storage       QN40  94
incrqx:(K,IPUT+STEPA,QN4001)#          Must have enough memory          QN40  95
XF=QX(IPT+IREL(6)) ; YF=QX(IPT+IREL(7)) ; ZF=QX(IPT+IREL(8))# = x,y,z   QN40  96
IF(IREL(9)>0) B=ATPISQ*QX(IPT+IREL(9))# Pick up ind. iso. t.f.          QN40  97
ELSE          B=BOVER#                 Set isotropic temp factor        QN40  98
IF(IREL(10)>0) Q=QX(IPT+IREL(10));ELSE Q=1.0# Set population paramete   QN40  99
IF(Q<1.0) NOCC=NOCC+1#                 Count the atoms with pop param   QN40 100
#                                                                       QN40 101
# BY TAKING THE SCATTERING FACTOR NAME FROM THE XTAL ATOM NAME AND      QN40 102
# THE REMOTNESS INDICATOR AND BRANCH DESIGNATOR FROM THE RESIDUE CODES  QN40 103
# IT IS POSSIBLE TO CONSTRUCT THE PROTIN ATOM IDENTIFIER IN THE SAME    QN40 104
# FORM AS THE RESIDUE IDENTIFIERS DEFINED IN THE CONSTRAINT LINES       QN40 105
# RESTRM, RESIDU, AND RESLNK.                                           QN40 106
#                                                                       QN40 107
movertoc:(QX(IPT+IREL(1)),1,XIDATM,1,24,0)# Get xtal atom id            QN40 108
compchar:(HT,1,XIDATM,1,2,1,23,HITHET)# Hetero atom?                    QN40 109
IF(HITHET!=0) NUMHET=NUMHET+1#         Count hetero atoms for record    QN40 110
movertoc:(QX(IPT+IREL(2)),1,RESCOD,1,4,0)# Get residue codes            QN40 111
movechar:(BLANK,1,IDATM,1,4,1)#        Blank out protin atom id         QN40 112
movechar:(XIDATM,1,IDATM,1,2,0)#       Get scat fact name               QN40 113
compchar:(IDATM,2,CNTS,1,1,1,NCNTS,K)# Is second char a number?         QN40 114
IF(K==0) movechar:(RESCOD,1,IDATM,3,2,0)# No number this one            QN40 115
ELSE movechar:(RESCOD,1,IDATM,2,2,0)#  This one is, bury it.            QN40 116
movertoc:(QX(IPT+IREL(5)),1,RESNAM,1,4,0)# Get residue name             QN40 117
movechar:(RESNAM,1,IDGRP,1,3,0)#       Chop off last character          QN40 118
movertoc:(QX(IPT+IREL(3)),1,RESSEQ,2,3,0)# Get residue seq. no.         QN40 119
movertoc:(QX(IPT+IREL(4)),4,RESSEQ,1,1,0)# Get most sig. dig. of "      QN40 120
movertoc:(QX(IPT+IREL(4)),1,CHAINI,1,3,0)# Get chain identity           QN40 121
IF(JCHAIN>0)#                          See if this is the first one     QN40 122
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN40 123
compchar:(CHAINI,1,CHAIN,1,3,3,JCHAIN,ICHAIN)# No, then match name      QN40 124
IF(ICHAIN==0)#                         But if no match add to list      QN40 125
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN40 126
movechar:(CHAINI,1,CHAIN,JCHAIN+1,3,0);JCHAIN=JCHAIN+3;ICHAIN=JCHAIN/3# QN40 127
NRESCN=0#                              Reset number of residue in cha   QN40 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN40 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN40 130
ELSE#                                  The very first one starts list   QN40 131
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN40 132
movechar:(CHAINI,1,CHAIN,1,3,0);JCHAIN=3;ICHAIN=1#                      QN40 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN40 134
RESNUM=0 ; DO I=1,4#                   Translate ascii to integer       QN40 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN40 136
compchar:(RESSEQ,I,CNTS,1,1,1,9,K);RESNUM=RESNUM+K*IPOW(I)# Ascii/int   QN40 137
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN40 138
IF(RESNUM!=OLDRES)#                    No match means new residue       QN40 139
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN40 140
NRESID=NRESID+1 ; OLDRES=RESNUM ; NRESCN=NRESCN+1# Count 'n save        QN40 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN40 142
IF(Q<0.0&IQZERO<0) IQZERO=NOATOM#      Note beginning of partial atom   QN40 143
IF((IQZERO<0)&(LABEL==FRSTPQ)) IQZERO=NOATOM-1#                         QN40 144
IF(Q<0.0) Q=-Q#                        Screen population parameter      QN40 145
ifeq:(Q,0.0) Q=1.0#                                                     QN40 146
ICH=ICHTYP(ICHAIN);IRESN=IREST(2*(ICH-1)+1);IRESC=IREST(2*(ICH-1)+2)#   QN40 147
IF(NRESID!=INOW\ICHAIN!=NOWCHN)#       Chain or residue change?         QN40 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN40 149
#                                                                       QN40 150
#   A NEW RESIDUE HAS BEEN ENCOUNTERED                                  QN40 151
#   ----------------------------------                                  QN40 152
#                                                                       QN40 153
IHIT=no:#                              Is it a terminal group?          QN40 154
IF(NRESCN==IRESN)#                                                      QN40 155
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN40 156
IACID=NACIDS+2*(ICH-1)+1 ; IHIT=yes:#  Note n terminal in passing       QN40 157
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN40 158
ELSE IF(NRESCN==IRESC)#                Note c terminal in passing       QN40 159
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN40 160
IACID=NACIDS+2*(ICH-1)+2 ; IHIT=yes:#                                   QN40 161
KRESMP(ICH)=NRESCN#                    Saving for loops in qn52         QN40 162
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN40 163
#                                                                       QN40 164
#  FIND THE GROUP IDENTIFIER NUMBER FOR AN INTERNAL RESIDUE             QN40 165
#  --------------------------------------------------------             QN40 166
#                                                                       QN40 167
ELSE#                                                                   QN40 168
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN40 169
compchar:(RESNAM,1,NAMES,1,4,4,arith:(4,*,qmxgrp:),$#                   QN40 170
IACID)#                                Find which residue this is       QN40 171
IF(IACID==0)#                          Must have a recognized residue   QN40 172
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN40 173
movechar:(XIDATM,1,QN40A,16,24,0) ; movechar:(IDGRP,1,QN40A,56,3,0)#    QN40 174
writeline:(1,QN40A,NQN40A,3,1)#                                         QN40 175
iquit:(QN4002)#                                                         QN40 176
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN40 177
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN40 178
INOW=NRESCN;NOWCHN=ICHAIN#             Set this residue and chain       QN40 179
movechar:(MCOD,IACID,MDGRP,1,1,0)#                                      QN40 180
IF(NRESCN>KRESMX(ICHAIN)) KRESMX(ICHAIN)=NRESCN#                        QN40 181
IDACD(NRESCN,ICHAIN)=IACID#                                             QN40 182
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN40 183
NA=NATOMS(IACID) ; movechar:(IDATM,1,JDATM,1,4,0)#                      QN40 184
IF(NA>qmxatm:\NRESCN>qmxres:\ICHAIN>qmxchn:)# Array overflow?           QN40 185
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN40 186
LINRM=5;writeline:(1,QN40E,NQN40E,3,1);writeline:(0,QN40F,NQN40F,3,1)#  QN40 187
BUFOT(1)=qmxatm:;BUFOT(3)=qmxres:;BUFOT(5)=qmxchn:#                     QN40 188
BUFOT(2)=NA;BUFOT(4)=NRESCN;BUFOT(6)=ICHAIN#                            QN40 189
ncodefld:(BUFOT,1,CHROT,FMT,6) ; writeline:(0,QN40G,NQN40G,2,1)#        QN40 190
iquit:(QN4005)#                        No space, no run.                QN40 191
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN40 192
#                                                                       QN40 193
#  NOW CHECK THAT THE ATOMS OF THE RESIDUE ARE THERE AND NAMED RIGHT    QN40 194
#  -----------------------------------------------------------------    QN40 195
#                                                                       QN40 196
IF(IHATOM==1)#                         Find this atom in the std. gro   QN40 197
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN40 198
compchar:(IDATM,1,DEUT,1,1,1,1,NDEUT,K)# Is it deuterium?               QN40 199
IF(K==1) movechar:(HYDR,1,JDATM,1,NHYDR,0)# Cover the d with an h       QN40 200
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN40 201
IHIT=no:#                                                               QN40 202
FOR(IATOM=1;IATOM<=NA;IATOM=IATOM+1)#  Loop over atoms in residue       QN40 203
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN40 204
compchar:(JDATM,1,IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,4,4,4,K)#         QN40 205
IF(K!=0)#                              Test if atom acceptible          QN40 206
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN40 207
IHIT=yes: ; BREAK#                                                      QN40 208
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN40 209
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN40 210
#                                                                       QN40 211
#  EXCEPT THE EXCEPTIONAL CASES                                         QN40 212
#  ----------------------------                                         QN40 213
#                                                                       QN40 214
compchar:(IDATM,1,OXT,1,3,3,3,K)#      C terminal oxygen?               QN40 215
IF(IHIT==no:&K==0&HITHET==0)#          Zap unacceptible atoms           QN40 216
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN40 217
movechar:(XIDATM,1,QN40B,12,24,0) ; movechar:(IDATM,1,QN40B,41,4,0)#    QN40 218
movechar:(RESNAM,1,QN40B,65,4,0) ; movechar:(RESSEQ,1,QN40B,80,4,0)#    QN40 219
ncodefld:(FLOAT(NRESID),1,QN40B,770413.,1)#                             QN40 220
writeline:(0,QN40B,NQN40B,3,1) ; IPUT=IPUT-STEPA ; NEXT#                QN40 221
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN40 222
ELSE IF(NOAT(IATOM,NRESCN,ICHAIN)>0)#                                   QN40 223
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN40 224
movechar:(XIDATM,1,QN40C,22,24,0) ; movechar:(IDATM,1,QN40C,51,4,0)#    QN40 225
movechar:(RESNAM,1,QN40C,69,4,0)#                                       QN40 226
ncodefld:(FLOAT(NRESID),1,QN40C,770413.,1)#                             QN40 227
writeline:(0,QN40C,NQN40C,3,1) ; IPUT=IPUT-STEPA ; NEXT#                QN40 228
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN40 229
#                                                                       QN40 230
#----IS THIS A DISORDERED MAIN CHAIN ATOM ?                             QN40 231
IF(ICHAIN>NCHAIN&NRESCN<=IRESC&(IATOM<=4 \ $#                           QN40 232
(IHATOM!=0&IATOM<=6))) ZMAIN(NRESCN,ICHAIN)=.TRUE.#                     QN40 233
NOATOM=NOATOM+1 ; NOAT(IATOM,NRESCN,ICHAIN)=NOATOM# Assign an atom no   QN40 234
#                                                                       QN40 235
# CONVERT THE FRACTIONAL ATOM COORDINATES TO ORTHOGONAL ANGSTROM        QN40 236
# COORDINATES AND STORE THEM IN THE MARKA ARRAY FOR FUTURE USE.         QN40 237
# --------------------------------------------------------------        QN40 238
#                                                                       QN40 239
QX(IPUT+1)=XF*ORXX+YF*ORXY+ZF*ORXZ#    Store away the atomic co-ordin   QN40 240
QX(IPUT+2)=        YF*ORYY+ZF*ORYZ#                                     QN40 241
QX(IPUT+3)=                ZF*ORZZ#                                     QN40 242
QX(IPUT+4)=0.0 ; movector:(IDATM,1,QX(IPUT+5),1,4,0)#                   QN40 243
#                                                                       QN40 244
#----ADD THIS ATOM RECORD TO THE DATA TAPE                              QN40 245
KSATM=KS(IACID,IATOM)#                                                  QN40 246
compchar:(IDATM,1,DEUT,1,1,1,NDEUT1,K)# Test for deuterium              QN40 247
IF(K==1) KSATM=2#                                                       QN40 248
#                                                                       QN40 249
#----ENCODE CHAIN 1 ONLY IF OTHER NON-DISORDER CHAINS EXIST             QN40 250
BUFOT(1)=FLOAT(ICHAIN) ; BUFOT(2)=FLOAT(NRESID)#                        QN40 251
ncodefld:(BUFOT,1,LABEL,FMTL,2)#                                        QN40 252
movechar:(MCOD,IACID,LABEL,2,1,0)#                                      QN40 253
movechar:(IDATM,1,LABEL,6,4,0)#                                         QN40 254
IF(ICHAIN==1&NCHAIN==1) movechar:(BLANK,1,LABEL,1,1,1)#                 QN40 255
IF(LISTIT==yes:)#                                                       QN40 256
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN40 257
BUFOT(1)=FLOAT(NOATOM) ; BUFOT(2)=FLOAT(ICHAIN)#                        QN40 258
BUFOT(3)=FLOAT(NRESID) ; BUFOT(4)=FLOAT(IATOM)#                         QN40 259
BUFOT(6)=QX(IPUT+1) ; BUFOT(7)=QX(IPUT+2)#                              QN40 260
BUFOT(8)=QX(IPUT+3)#                                                    QN40 261
BUFOT(9)=B ; BUFOT(10)=Q ; BUFOT(5)=FLOAT(KSATM)#                       QN40 262
ncodefld:(BUFOT,1,CHROT,FMTA,10)#                                       QN40 263
movechar:(XIDATM,1,CHROT,8,24,0)#                                       QN40 264
movechar:(RESNAM,1,CHROT,36,4,0)#                                       QN40 265
movechar:(IDCHN,1,CHROT,98,3,0)#                                        QN40 266
movechar:(LABEL,2,CHROT,102,8,0)#                                       QN40 267
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN40 268
writeline:(0,QN40H,NQN40H,1,4)#                                         QN40 269
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN40 270
#                                                                       QN40 271
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN40 272
DO I=1,NCHAIN#                         Initialize for missing atom se   QN40 273
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN40 274
ISKIQN(I)=0 ; ISKIPC(I)=0#                                              QN40 275
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN40 276
# CHECK TO SEE IF ANY RESIDUES ARE MISSING ANY STANDARD GROUP ATOMS     QN40 277
LINRM=5 ; writeline:(1,QN40J,NQN40J,3,2)# Tell user about check         QN40 278
HIT=no: ; LINRM=3 ; ZCHAIN=.FALSE.#    Assume none will be hit          QN40 279
DO ICHAIN=1,NTCHAN#                    Search chains for missing atom   QN40 280
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QN40 281
ICH=ICHTYP(ICHAIN)#                    Pick up pointer to chain         QN40 282
IRESN=IREST(2*(ICH-1)+1)#              Pointer to n terminal group      QN40 283
IRESC=IREST(2*(ICH-1)+2)#              Pointer to c terminal group      QN40 284
IRESMX=KRESMX(ICHAIN)#                 Pointer to end of all groups     QN40 285
IF(ICHAIN>NCHAIN) ZCHAIN=.TRUE.#       Flag beyond n terminal           QN40 286
DO IRES=IRESN,IRESMX#                  Loop over all residues in chai   QN40 287
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QN40 288
IACID=IDACD(IRES,ICHAIN)#              Get pointer to residue's group   QN40 289
IF(IACID==0)#                          Test if not defined              QN40 290
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QN40 291
IF(IRES<=IRESC)#                       Is it before the c terminal?     QN40 292
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QN40 293
IF(!ZCHAIN)#                           And beyond n terminal?           QN40 294
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QN40 295
BUFOT(1)=FLOAT(IRES) ; BUFOT(2)=FLOAT(ICHAIN)# Not in the table!        QN40 296
ncodefld:(BUFOT,1,QN40I,FMT5,2) ; writeline:(1,QN40I,NQN40I,3,2)#       QN40 297
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QN40 298
IDACD(IRES,ICHAIN)=1 ; NEXT## DEFINE PROTEIN RESIDUE TYPE AS ALA        QN40 299
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QN40 300
IDACD(IRES,ICHAIN)=22 ; NEXT## DEFINE NON-PROTEIN RESIDUE TYPE AS WAT   QN40 301
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QN40 302
compchar:(NAMES,4*(IACID-1)+1,DISOR,1,4,4,NDISOR,K)# Disorder special   QN40 303
IF(K!=0) NEXT#                                                          QN40 304
IF(ZCHAIN) NEXT#                                                        QN40 305
NA=NATOMS(IACID)#                      Get the ideal number of atoms    QN40 306
DO IATOM=1,NA#                         Loop over atoms                  QN40 307
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QN40 308
IF(NOAT(IATOM,IRES,ICHAIN)>0) NEXT#    Skip when atom are there o.k.    QN40 309
movechar:(IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,QN40K,7,4,0)#             QN40 310
movechar:(NAMES,4*(IACID-1)+1,QN40K,38,4,0)# Otherwise barf             QN40 311
ncodefld:(FLOAT(IRES),1,QN40K,350613.,1)# Otherwise, point to atom in   QN40 312
writeline:(0,QN40K,NQN40K,3,2) ; HIT=yes:# Residue that is missing      QN40 313
IF(IRES==IRESN) ISKIQN(ICHAIN)=1#                                       QN40 314
IF(IRES==IRESC) ISKIPC(ICHAIN)=1#                                       QN40 315
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QN40 316
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QN40 317
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QN40 318
IF(HIT==no:) writeline:(0,QN40L,NQN40L,3,2)# Report all atoms found     QN40 319
#                                                                       QN40 320
readwpkt:(FILEA,endrecord:,PSIZ,IPT,0)# End reading bdf                 QN40 321
#                                                                       QN40 322
#  KEEP TRACK OF END OF ATOMS.  MUST HAVE ENOUGH MEMORY TO HOLD A       QN40 323
#  SCRATCH ATOM DURING SYMMETRY OPERATIONS IN VAN DER WAAL SEARCH.      QN40 324
#  ---------------------------------------------------------------      QN40 325
#                                                                       QN40 326
incrqx:(STOPA,IPUT+STEPA,QN4001)#      For qn50 and beyond              QN40 327
RETURN#                                                                 QN40 328
END#                                                                    QN40 329
systemheader:(QN45)## Find central atom and residue radius              QN45   1
####################################################################    QN45   2
#                                                                  #    QN45   3
#                                QN45                              #    QN45   4
#                                                                  #    QN45   5
####################################################################    QN45   6
SUBROUTINE QN45#                                                        QN45   7
#                                                                       QN45   8
include:(AACOMN)#                                                       QN45   9
include:(QNCOMN)#                                                       QN45  10
#                                                                       QN45  11
#----FIND THE CENTRAL ATOM AND RADIUS OF EACH RESIDUE                   QN45  12
#     SUBROUTINE CENTRD                                                 QN45  13
#                                                                       QN45  14
INTEGER NCHCEN(qmxchn:)#                                                QN45  15
LOGICAL ZCHAIN#                                                         QN45  16
REAL XCHCEN(qmxchn:),YCHCEN(qmxchn:),ZCHCEN(qmxchn:)#                   QN45  17
#                                                                       QN45  18
#----INTERATOMIC DISTANCE FUNCTION                                      QN45  19
DISIJ(I,J)=$#                                                           QN45  20
SQRT((QX(I+1)-QX(J+1))**2+(QX(I+2)-QX(J+2))**2+(QX(I+3)-QX(J+3))**2)#   QN45  21
DO IX=1,3## INITIALIZE FOR MOLECULAR BOUNDS SEARCH                      QN45  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN45  23
XYZMIN(IX)=100000. ; XYZMAX(IX)=-100000.#                               QN45  24
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN45  25
IF(NTCHAN<=0) iquit:(QN4501)#          Must be at least one chain       QN45  26
ZCHAIN=.FALSE. ; DO ICHAIN=1,NTCHAN#   Loop over each chain             QN45  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN45  28
ICH=ICHTYP(ICHAIN) ; IRESN=IREST(2*(ICH-1)+1)#                          QN45  29
IRESMX=KRESMX(ICHAIN) ; KCHAIN=MOTHRZ(ICHAIN)#                          QN45  30
IF(ICHAIN>NCHAIN) ZCHAIN=.TRUE.#                                        QN45  31
XCHCEN(ICHAIN)=0.0 ; YCHCEN(ICHAIN)=0.0# Set to find chain centroid     QN45  32
ZCHCEN(ICHAIN)=0.0 ; NCHCEN(ICHAIN)=0#                                  QN45  33
DO IRES=IRESN,IRESMX#                  Loop over each residue in chai   QN45  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN45  35
IACID=IDACD(IRES,ICHAIN)#                                               QN45  36
IF(IACID<1)#                                                            QN45  37
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN45  38
ICENTR(IRES,ICHAIN)=0 ; RADIUS(IRES,ICHAIN)=0.0 ; NEXT#                 QN45  39
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN45  40
NA=NATOMS(IACID)#                                                       QN45  41
IF(NA<1)#                                                               QN45  42
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN45  43
ICENTR(IRES,ICHAIN)=0 ; RADIUS(IRES,ICHAIN)=0.0 ; NEXT#                 QN45  44
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN45  45
IF(ZCHAIN)#                                                             QN45  46
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN45  47
N=0 ; DO I=1,NA ; N=N+NOAT(I,IRES,ICHAIN)#                              QN45  48
IF(N<1)#                                                                QN45  49
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN45  50
ICENTR(IRES,ICHAIN)=0 ; RADIUS(IRES,ICHAIN)=0.0 ; NEXT#                 QN45  51
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN45  52
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN45  53
XBAR=0.0 ; YBAR=0.0 ; ZBAR=0.0 ; NBAR=0# Set to find residue centroid   QN45  54
DO IATOM=1,NA#                         Loop over each atom in residue   QN45  55
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN45  56
IA=NOAT(IATOM,IRES,ICHAIN)#                                             QN45  57
IF(IA<=0) NEXT#                                                         QN45  58
IAA=(IA-1)*STEPA+MARKA#                Get pointer into atomic array    QN45  59
XBAR=XBAR+QX(IAA+1) ; YBAR=YBAR+QX(IAA+2)#                              QN45  60
ZBAR=ZBAR+QX(IAA+3) ; NBAR=NBAR+1#                                      QN45  61
XYZMIN(1)=AMIN1(XYZMIN(1),QX(IAA+1))#  Search for molecular bounds on   QN45  62
XYZMIN(2)=AMIN1(XYZMIN(2),QX(IAA+2))#  Search for molecular bounds on   QN45  63
XYZMIN(3)=AMIN1(XYZMIN(3),QX(IAA+3))#  Search for molecular bounds on   QN45  64
XYZMAX(1)=AMAX1(XYZMAX(1),QX(IAA+1))#  Search for molecular bounds on   QN45  65
XYZMAX(2)=AMAX1(XYZMAX(2),QX(IAA+2))#  Search for molecular bounds on   QN45  66
XYZMAX(3)=AMAX1(XYZMAX(3),QX(IAA+3))#  Search for molecular bounds on   QN45  67
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN45  68
XCHCEN(KCHAIN)=XCHCEN(KCHAIN)+XBAR#    Sum for chain centroid           QN45  69
YCHCEN(KCHAIN)=YCHCEN(KCHAIN)+YBAR;ZCHCEN(KCHAIN)=ZCHCEN(KCHAIN)+ZBAR#  QN45  70
NCHCEN(KCHAIN)=NCHCEN(KCHAIN)+NBAR#                                     QN45  71
IF(NBAR!=0)#                           Find the residue centroid        QN45  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN45  73
XBAR=XBAR/NBAR ; YBAR=YBAR/NBAR ; ZBAR=ZBAR/NBAR#                       QN45  74
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN45  75
DMIN=100. ; IMIN=0#                    Find atom nearest centroid       QN45  76
DO IATOM=1,NA#                                                          QN45  77
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN45  78
IA=NOAT(IATOM,IRES,ICHAIN) ; IF(IA<=0) NEXT#                            QN45  79
IAA=(IA-1)*STEPA+MARKA#                Get pointer into atomic array    QN45  80
DISTO=SQRT((QX(IAA+1)-XBAR)**2+(QX(IAA+2)-YBAR)**2+(QX(IAA+3)-ZBAR)**2)#QN45  81
IF(DMIN<DISTO) NEXT#                                                    QN45  82
DMIN=DISTO ; IMIN=IA ; IMINA=IAA#                                       QN45  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN45  84
DMAX=0.0#                              Find radius of this residue      QN45  85
DO IATOM=1,NA#                                                          QN45  86
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN45  87
IA=NOAT(IATOM,IRES,ICHAIN)#                                             QN45  88
IF(IA<=0) NEXT#                                                         QN45  89
IAA=(IA-1)*STEPA+MARKA#                Get pointer into atomic array    QN45  90
DISTO=DISIJ(IMINA,IAA) ; DMAX=AMAX1(DMAX,DISTO)#                        QN45  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN45  92
ICENTR(IRES,ICHAIN)=IMIN ; RADIUS(IRES,ICHAIN)=DMAX#                    QN45  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN45  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN45  95
DO ICHAIN=1,NTCHAN#                    Loop over chains                 QN45  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN45  97
ICH=ICHTYP(ICHAIN) ; IRESN=IREST(2*(ICH-1)+1)#                          QN45  98
IRESMX=KRESMX(ICHAIN) ; KCHAIN=MOTHRZ(ICHAIN)#                          QN45  99
IF(ICHAIN>NCHAIN)#                                                      QN45 100
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN45 101
IMIN=ICHCEN(KCHAIN) ; DMAX=RADCHN(KCHAIN)#                              QN45 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN45 103
ELSE#                                                                   QN45 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN45 105
IF(NCHCEN(ICHAIN)==0) NEXT#                                             QN45 106
XCHCEN(ICHAIN)=XCHCEN(ICHAIN)/FLOAT(NCHCEN(ICHAIN))#                    QN45 107
YCHCEN(ICHAIN)=YCHCEN(ICHAIN)/FLOAT(NCHCEN(ICHAIN))#                    QN45 108
ZCHCEN(ICHAIN)=ZCHCEN(ICHAIN)/FLOAT(NCHCEN(ICHAIN))#                    QN45 109
DMIN=1000. ; DO IRES=IRESN,IRESMX#     Loop over residues               QN45 110
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN45 111
IF(ICENTR(IRES,ICHAIN)==0) NEXT#                                        QN45 112
IA=ICENTR(IRES,ICHAIN);IAA=(IA-1)*STEPA+MARKA# Get pointer to atom ar   QN45 113
DISTO=SQRT((QX(IAA+1)-XCHCEN(ICHAIN))**2+$#                             QN45 114
(QX(IAA+2)-YCHCEN(ICHAIN))**2+$#                                        QN45 115
(QX(IAA+3)-ZCHCEN(ICHAIN))**2)-RADIUS(IRES,ICHAIN)#                     QN45 116
IF(DMIN<DISTO) NEXT#                                                    QN45 117
IACID=IDACD(IRES,ICHAIN) ; NA=NATOMS(IACID)#                            QN45 118
DO IATOM=1,NA## FIND THE ATOM NEAREST THE CHAIN CENTROID                QN45 119
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN45 120
IA=NOAT(IATOM,IRES,ICHAIN) ; IF(IA<=0) NEXT#                            QN45 121
IAA=(IA-1)*STEPA+MARKA#                Get pointer into atomic array    QN45 122
DISTO=SQRT((QX(IAA+1)-XCHCEN(ICHAIN))**2+$#                             QN45 123
(QX(IAA+2)-YCHCEN(ICHAIN))**2+$#                                        QN45 124
(QX(IAA+3)-ZCHCEN(ICHAIN))**2)#                                         QN45 125
IF(DMIN<DISTO) NEXT#                                                    QN45 126
DMIN=DISTO ; IMIN=IA ; IMINA=IAA#                                       QN45 127
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN45 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN45 129
DMAX=0.0## INITIALIZE FOR FINDING THE RADIUS OF THIS CHAIN              QN45 130
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN45 131
DO IRES=IRESN,IRESMX#                  Loop over residues               QN45 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN45 133
IA=ICENTR(IRES,ICHAIN);IAA=(IA-1)*STEPA+MARKA# Get pointer to atom      QN45 134
DISTO=DISIJ(IMINA,IAA)+RADIUS(IRES,ICHAIN)#                             QN45 135
IF(DMAX>DISTO) NEXT#                                                    QN45 136
IACID=IDACD(IRES,ICHAIN) ; NA=NATOMS(IACID)#                            QN45 137
DO IATOM=1,NA## LOOP OVER ATOMS TO FIND MOST DISTANT ATOM FOR RADIUS    QN45 138
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN45 139
IA=NOAT(IATOM,IRES,ICHAIN) ; IF(IA<=0) NEXT#                            QN45 140
IAA=(IA-1)*STEPA+MARKA#                Get pointer into atomic array    QN45 141
DISTO=DISIJ(IMINA,IAA) ; DMAX=AMAX1(DMAX,DISTO)#                        QN45 142
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN45 143
ICHCEN(KCHAIN)=IMIN ; RADCHN(KCHAIN)=DMAX#                              QN45 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN45 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN45 146
IF(NTCHAN!=NCHAIN)## PUT CENT & RAD OF MOTHER CHAIN IN DISORDER CHAIN   QN45 147
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN45 148
JZCHN=NCHAIN+1#                                                         QN45 149
DO ICHAIN=JZCHN,NTCHAN#                                                 QN45 150
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN45 151
KCHAIN=MOTHRZ(ICHAIN) ; ICHCEN(ICHAIN)=ICHCEN(KCHAIN)#                  QN45 152
RADCHN(ICHAIN)=RADCHN(KCHAIN)#                                          QN45 153
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN45 154
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN45 155
RETURN#                                                                 QN45 156
END#                                                                    QN45 157
systemheader:(QN51)## Find interatomic distances; write constraints     QN51   1
####################################################################    QN51   2
#                                                                  #    QN51   3
#                                QN51                              #    QN51   4
#                                                                  #    QN51   5
####################################################################    QN51   6
SUBROUTINE QN51#                                                        QN51   7
#                                                                       QN51   8
include:(AACOMN)#                                                       QN51   9
include:(QNCOMN)#                                                       QN51  10
#                                                                       QN51  11
#----PREPARE THE TABLE OF DISTANCES                                     QN51  12
#    SUBROUTINE DSTTAB (NODIST,IEOFIN,IDCIS)                            QN51  13
#                                                                       QN51  14
LOGICAL ZCHAIN,ZLINK#                                                   QN51  15
chardata:(STAR,*)#                                                      QN51  16
string:(ISTAR,1)#                                                       QN51  17
chardata:(HD,HD)#                                                       QN51  18
chardata:(TO,TO)#                                                       QN51  19
chardata:(QN51A, -----INTERATOMIC DISTANCES------ )#                    QN51  20
chardata:(QN51B, DIST NO. ATOM POINTERS RESIDUE  ATOM    $#             QN51  21
RESIDUE  ATOM   IDEAL   ACTUAL  DWT  BWT *DIF>0.2A )#                   QN51  22
realdata:(FMTO,[90613.,160513.,230513.,320413.,490413.,620832.,$#       QN51  23
710832.,760413.,810413.])#                                              QN51  24
realdata:(FMTP,[160513.,230513.,320513.,490513.,621032.,$#              QN51  25
760513.,810513.])#                                                      QN51  26
datastuff:#                                                             QN51  27
#                                                                       QN51  28
#----INTERATOMIC DISTANCE FUNCTION                                      QN51  29
DISIJ(I,J)=$#                                                           QN51  30
SQRT((QX(I+1)-QX(J+1))**2+(QX(I+2)-QX(J+2))**2+(QX(I+3)-QX(J+3))**2)#   QN51  31
K15=32768## Initialize for special inter-group distances                QN51  32
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN51  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN51  34
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN51A,NQN51A,3,4) ; LINRM=3#     QN51  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN51  36
DO ICH=1,NCHTYP ; NDIG(ICH)=0#                                          QN51  37
NPR=(NTCHAN*(NTCHAN-1))/2#                                              QN51  38
DO IPR=1,NPR ; NDIC(IPR)=0#                                             QN51  39
ZCHAIN=.FALSE. ; DO ICHAIN=1,NTCHAN#   Loop over chains                 QN51  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN51  41
ICH=ICHTYP(ICHAIN) ; IRESN=IREST(2*(ICH-1)+1)#                          QN51  42
IRESC=IREST(2*(ICH-1)+2) ; IACIDC=IACIDT(2*(ICH-1)+2)#                  QN51  43
IRESMX=KRESMX(ICHAIN) ; NCIS=IDCIS(1,ICH)+1#                            QN51  44
IF(ICHAIN>NCHAIN) ZCHAIN=.TRUE.#                                        QN51  45
IZCHAN=MOTHRZ(ICHAIN)#                                                  QN51  46
DO IRES=IRESN,IRESMX#                  Loop over residues               QN51  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN51  48
IDISTZ(IRES,ICHAIN)=NODIST ; ZLINK=.FALSE.#                             QN51  49
IF(ZCHAIN)#                                                             QN51  50
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN51  51
IF(IRES!=IRESN)#                                                        QN51  52
IF(ZMAIN(IRES-1,ICHAIN)&!ZMAIN(IRES,ICHAIN)) ZLINK=.TRUE.#              QN51  53
IF(!ZLINK)#                                                             QN51  54
IF(ICENTR(IRES,ICHAIN)==0) NEXT#                                        QN51  55
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN51  56
IACID=IDACD(IRES,ICHAIN) ; ND=NDISTS(IACID)#                            QN51  57
IF(ND!=0)#                                                              QN51  58
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN51  59
DO IDIST=1,ND#                         Intra-residue distances          QN51  60
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN51  61
IATOM=IATM(IACID,IDIST);IA=NOAT(IATOM,IRES,ICHAIN)#                     QN51  62
JATOM=JATM(IACID,IDIST);JA=NOAT(JATOM,IRES,ICHAIN)#                     QN51  63
IAA=(IA-1)*STEPA+MARKA;JAA=(JA-1)*STEPA+MARKA#                          QN51  64
IF(ZCHAIN)#                                                             QN51  65
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN51  66
IF(IA<=0&JA<=0) NEXT#                                                   QN51  67
compchar:(IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,HD,1,1,1,NHD,K)#          QN51  68
IF(K!=0)#                                                               QN51  69
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN51  70
IA=NOAT(IATOM,IRES,IZCHAN) ; IAA=(IA-1)*STEPA+MARKA#                    QN51  71
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN51  72
compchar:(IDS,(IACID-1)*qmxat4:+(JATOM-1)*4+1,HD,1,1,1,NHD,K)#          QN51  73
IF(K!=0)#                                                               QN51  74
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN51  75
JA=NOAT(JATOM,IRES,IZCHAN) ; JAA=(JA-1)*STEPA+MARKA#                    QN51  76
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN51  77
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN51  78
IF(IA<=0\JA<=0) NEXT#                                                   QN51  79
NODIST=NODIST+1#                                                        QN51  80
#                                                                       QN51  81
#    WRITE OUT A PACKET WITH A DISTANCE RESTRAINT                       QN51  82
#    --------------------------------------------                       QN51  83
#                                                                       QN51  84
CALL QN06(IA,JA,DIST(IACID,IDIST),KDWT(IACID,IDIST),KBWT(IACID,IDIST))# QN51  85
movechar:(BLANK,1,ISTAR,1,1,1) ; DISTO=DISIJ(IAA,JAA)#                  QN51  86
ABSDEL=ABS(DISTO-DIST(IACID,IDIST))#                                    QN51  87
IF(ABSDEL>0.20) movechar:(STAR,1,ISTAR,1,NSTAR,1)#                      QN51  88
LISLOC=LISLOC-1 ; IF(LISLOC<0) NEXT#   Skip if thats all user wants     QN51  89
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN51  90
BUFOT(1)=FLOAT(NODIST) ; BUFOT(2)=FLOAT(IA) ; BUFOT(3)=FLOAT(JA)#       QN51  91
BUFOT(4)=FLOAT(IRES) ; BUFOT(5)=FLOAT(IRES)#                            QN51  92
BUFOT(6)=DIST(IACID,IDIST) ; BUFOT(7)=DISTO#                            QN51  93
BUFOT(8)=FLOAT(KDWT(IACID,IDIST)) ; BUFOT(9)=FLOAT(KBWT(IACID,IDIST))#  QN51  94
ncodefld:(BUFOT,1,CHROT,FMTO,9); movechar:(ISTAR,1,CHROT,75,1,0)#       QN51  95
movechar:(TO,1,CHROT,39,NTO,0)#                                         QN51  96
movertoc:(QX(IAA+5),1,CHROT,34,4,0)#                                    QN51  97
movertoc:(QX(JAA+5),1,CHROT,51,4,0)#                                    QN51  98
movechar:(NAMES,4*(IACID-1)+1,CHROT,25,4,0)#                            QN51  99
movechar:(NAMES,4*(IACID-1)+1,CHROT,42,4,0)#                            QN51 100
writeline:(0,QN51B,NQN51B,1,4)#                                         QN51 101
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN51 102
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN51 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN51 104
JDISTZ(IRES,ICHAIN)=NODIST#            Inter-residue or link distance   QN51 105
IF(IRES==IRESN\IRES>IRESC) NEXT#                                        QN51 106
KCIS=0#                                                                 QN51 107
IF(NCIS>1)#                                                             QN51 108
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN51 109
DO ICIS=2,NCIS#                                                         QN51 110
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN51 111
IF(IRES!=IDCIS(ICIS,ICH)) NEXT#                                         QN51 112
KCIS=1 ; BREAK#                                                         QN51 113
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN51 114
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN51 115
KPRO=0 ; IF(IACID==15) KPRO=1#         ******bad news bear!!!!!!!!!!    QN51 116
IF(IRES==IRESC&IACIDC==15) KPRO=1#                                      QN51 117
IPEP=2*KPRO+KCIS+1 ; LINK=NACIDT+IPEP#                                  QN51 118
ND=NDISTS(LINK) ; JRES=IRES-1 ; JACID=IDACD(JRES,ICHAIN)#               QN51 119
DO IDIST=1,ND#                                                          QN51 120
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN51 121
IATOM=IATM(LINK,IDIST) ; IA=NOAT(IATOM,IRES,ICHAIN)#                    QN51 122
JATOM=JATM(LINK,IDIST) ; JA=NOAT(JATOM,JRES,ICHAIN)#                    QN51 123
IAA=(IA-1)*STEPA+MARKA;JAA=(JA-1)*STEPA+MARKA#                          QN51 124
IF(ZCHAIN)#                                                             QN51 125
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN51 126
IF(IA<=0&JA<=0) NEXT#                                                   QN51 127
compchar:(IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,HD,1,1,1,NHD,K)#          QN51 128
IF(K!=0)#                                                               QN51 129
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN51 130
IA=NOAT(IATOM,IRES,IZCHAN) ; IAA=(IA-1)*STEPA+MARKA#                    QN51 131
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN51 132
compchar:(IDS,(IACID-1)*qmxat4:+(JATOM-1)*4+1,HD,1,1,1,NHD,K)#          QN51 133
IF(K!=0)#                                                               QN51 134
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN51 135
JA=NOAT(JATOM,IRES,IZCHAN) ; JAA=(JA-1)*STEPA+MARKA#                    QN51 136
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN51 137
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN51 138
IF(IA<=0\JA<=0) NEXT#                                                   QN51 139
NODIST=NODIST+1#                                                        QN51 140
#                                                                       QN51 141
#    WRITE OUT A PACKET WITH A DISTANCE RESTRAINT                       QN51 142
#    --------------------------------------------                       QN51 143
#                                                                       QN51 144
CALL QN06(IA,JA,DIST(LINK,IDIST),KDWT(LINK,IDIST),KBWT(LINK,IDIST))#    QN51 145
movechar:(BLANK,1,ISTAR,1,NSTAR,1) ; DISTO=DISIJ(IAA,JAA)#              QN51 146
ABSDEL=ABS(DISTO-DIST(LINK,IDIST))#                                     QN51 147
IF(ABSDEL>0.20) movechar:(STAR,1,ISTAR,1,NSTAR,1)#                      QN51 148
LISLOC=LISLOC-1 ; IF(LISLOC<0) NEXT#   Skip if thats all user wants     QN51 149
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN51 150
BUFOT(1)=FLOAT(NODIST) ; BUFOT(2)=FLOAT(IA) ; BUFOT(3)=FLOAT(JA)#       QN51 151
BUFOT(4)=FLOAT(IRES) ; BUFOT(5)=FLOAT(JRES)#                            QN51 152
BUFOT(6)=DIST(LINK,IDIST) ; BUFOT(7)=DISTO#                             QN51 153
BUFOT(8)=FLOAT(KDWT(LINK,IDIST)) ; BUFOT(9)=FLOAT(KBWT(LINK,IDIST))#    QN51 154
ncodefld:(BUFOT,1,CHROT,FMTO,9); movechar:(ISTAR,1,CHROT,75,1,0)#       QN51 155
movechar:(TO,1,CHROT,39,NTO,0)#                                         QN51 156
movertoc:(QX(IAA+5),1,CHROT,34,4,0)#                                    QN51 157
movertoc:(QX(JAA+5),1,CHROT,51,4,0)#                                    QN51 158
movechar:(NAMES,4*(IACID-1)+1,CHROT,25,4,0)#                            QN51 159
movechar:(NAMES,4*(IACID-1)+1,CHROT,42,4,0)#                            QN51 160
writeline:(0,QN51B,NQN51B,1,4)#                                         QN51 161
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN51 162
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN51 163
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN51 164
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN51 165
IF(NSS!=0)#                            Disulfide bridge dist's if any   QN51 166
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN51 167
LINK=NACIDT+5 ; ND=NDISTS(LINK)#                                        QN51 168
DO ISS=1,NSS## Loop over unique intrachain & all interchain disulfide   QN51 169
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN51 170
ICHN=ICHNSS(ISS) ; JCHN=JCHNSS(ISS)#                                    QN51 171
IRES=IRESSS(ISS) ; JRES=JRESSS(ISS)#                                    QN51 172
IPR=0 ; IF(ICHN==JCHN) ICH=ICHTYP(ICHN)#                                QN51 173
IF(ICHN!=JCHN) IPR=((ICHN-1)*(2*NTCHAN-ICHN))/2+(JCHN-ICHN)#            QN51 174
DO IDIST=1,ND## Find distances for this specific bridge                 QN51 175
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN51 176
IATOM=IATM(LINK,IDIST) ; JATOM=JATM(LINK,IDIST)#                        QN51 177
DO ICHAIN=1,NTCHAN#                                                     QN51 178
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QN51 179
IZCHAN=MOTHRZ(ICHAIN) ; JZCHAN=MOTHRZ(JCHN)#                            QN51 180
IF(IPR<=0)#                                                             QN51 181
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QN51 182
IF(ICHTYP(ICHAIN)!=ICH) NEXT#                                           QN51 183
ICHN=ICHAIN ; JCHN=ICHAIN ; JZCHAN=MOTHRZ(JCHN)#                        QN51 184
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QN51 185
IA=NOAT(IATOM,IRES,ICHN) ; NZ=0#                                        QN51 186
IF(IA<=0&ICHN>NCHAIN)#                                                  QN51 187
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QN51 188
IA=NOAT(IATOM,IRES,IZCHAN) ; NZ=NZ+1#                                   QN51 189
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QN51 190
IF(IA<=0)#                                                              QN51 191
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QN51 192
IF(IPR>0) BREAK#                                                        QN51 193
ELSE NEXT#                                                              QN51 194
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QN51 195
JA=NOAT(JATOM,JRES,JCHN)#                                               QN51 196
IF(JA<=0&JCHN>NCHAIN)#                                                  QN51 197
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QN51 198
JA=NOAT(JATOM,JRES,JZCHAN) ; NZ=NZ+1#                                   QN51 199
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QN51 200
IF(JA>0)#                                                               QN51 201
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QN51 202
IF(NZ!=2)#                                                              QN51 203
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 QN51 204
NODIST=NODIST+1#                                                        QN51 205
#                                                                       QN51 206
#    WRITE OUT A PACKET WITH A DISTANCE RESTRAINT                       QN51 207
#    --------------------------------------------                       QN51 208
#                                                                       QN51 209
CALL QN06(IA,JA,DIST(LINK,IDIST),KDWT(LINK,IDIST),KBWT(LINK,IDIST))#    QN51 210
IAA=(IA-1)*STEPA+MARKA;JAA=(JA-1)*STEPA+MARKA#                          QN51 211
movechar:(BLANK,1,ISTAR,1,NSTAR,1) ; DISTO=DISIJ(IAA,JAA)#              QN51 212
ABSDEL=ABS(DISTO-DIST(LINK,IDIST))#                                     QN51 213
IF(ABSDEL>0.20) movechar:(STAR,1,ISTAR,1,NSTAR,1)#                      QN51 214
LISLOC=LISLOC-1 ; IF(LISLOC<0) NEXT#   Skip if thats all user wants     QN51 215
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 QN51 216
BUFOT(1)=FLOAT(NODIST) ; BUFOT(2)=FLOAT(IA) ; BUFOT(3)=FLOAT(JA)#       QN51 217
BUFOT(4)=FLOAT(IRES) ; BUFOT(5)=FLOAT(JRES)#                            QN51 218
BUFOT(6)=DIST(LINK,IDIST) ; BUFOT(7)=DISTO#                             QN51 219
BUFOT(8)=FLOAT(KDWT(LINK,IDIST)) ; BUFOT(9)=FLOAT(KBWT(LINK,IDIST))#    QN51 220
ncodefld:(BUFOT,1,CHROT,FMTO,9); movechar:(ISTAR,1,CHROT,75,1,0)#       QN51 221
movechar:(TO,1,CHROT,39,NTO,0)#                                         QN51 222
movertoc:(QX(IAA+5),1,CHROT,34,4,0)#                                    QN51 223
movertoc:(QX(JAA+5),1,CHROT,51,4,0)#                                    QN51 224
movechar:(NAMES,4*(IACID-1)+1,CHROT,25,4,0)#                            QN51 225
movechar:(NAMES,4*(IACID-1)+1,CHROT,42,4,0)#                            QN51 226
writeline:(0,QN51B,NQN51B,1,4)#                                         QN51 227
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 QN51 228
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 QN51 229
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QN51 230
IF(IPR>0) BREAK#                                                        QN51 231
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QN51 232
#                                                                       QN51 233
#----SAVE DISTANCE IDENTIFIERS FOR CONTACT EXCLUSION                    QN51 234
IPACK1=IRES*K15+JRES ; IPACK2=IATOM*K15+JATOM#                          QN51 235
IF(IPR<=0)#                                                             QN51 236
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 QN51 237
IF(IRES>JRES)#                         Intra-chain distance             QN51 238
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 QN51 239
IPACK1=JRES*K15+IRES ; IPACK2=JATOM*K15+IATOM#                          QN51 240
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 QN51 241
NDIG(ICH)=NDIG(ICH)+1 ; IGDIST(NDIG(ICH),ICH)=IPACK1#                   QN51 242
IGDIS2(NDIG(ICH),ICH)=IPACK2#                                           QN51 243
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 QN51 244
ELSE#                                  Inter-chain distance             QN51 245
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 QN51 246
NDIC(IPR)=NDIC(IPR)+1 ; ICDIST(NDIC(IPR),IPR)=IPACK1#                   QN51 247
ICDIS2(NDIC(IPR),IPR)=IPACK2#                                           QN51 248
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 QN51 249
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN51 250
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN51 251
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN51 252
#                                                                       QN51 253
#----EXTERNALLY DESIGNATED DISTANCES                                    QN51 254
IF(LINID<28) iquit:(QN5113)#           Input line order error           QN51 255
REPEAT## Read an inter/intra-chain identifier line                      QN51 256
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 QN51 257
IF(LINID>30) BREAK#                    Beyond interd, intrad, spcdis?   QN51 258
IF(LINID<30)#                          Interd intrad?                   QN51 259
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 QN51 260
CALL QN12(1,ICHN)#                     Get chain pointer                QN51 261
IZCHAN=MOTHRZ(ICHN)#                   Associate with main chain        QN51 262
ICH=ICHN#                                                               QN51 263
IF(LINID==28)#                         Intered?                         QN51 264
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 QN51 265
CALL QN12(2,JCHN)#                     Get chain pointer                QN51 266
JZCHAN=MOTHRZ(JCHN)#                   Associate main chain pointer     QN51 267
IGORC=1 ; IPR=((ICHN-1)*(2*NTCHAN-ICHN))/2+(JCHN-ICHN)#                 QN51 268
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 QN51 269
ELSE#                                  Inter chain so both the same     QN51 270
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 QN51 271
IGORC=0 ; JCHN=ICHN ; JZCHN=IZCHAN ; IPR=((ICHN-1)*(2*NTCHAN-ICHN))/2#  QN51 272
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 QN51 273
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 QN51 274
# READ A DISTANCE IDENTIFIER LINE                                       QN51 275
ELSE IF(LINID==30)#                    Spcdis line?                     QN51 276
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 QN51 277
CALL QN11(1,ICHN,IRES)#                Get internal residue pointer     QN51 278
IF(BUFIN(2)<1.0\BUFIN(4)<1.0) iquit:(QN5101)# Die if no spec on lin     QN51 279
IATOM=NINT(BUFIN(2))#                  Get atom in residue 1            QN51 280
CALL QN11(3,JCHN,JRES)#                Get internal residue pointer 2   QN51 281
JATOM=NINT(BUFIN(4))#                  Get atom in residue 2            QN51 282
IF(BUFIN(5)<1.0\BUFIN(6)<0.0) iquit:(QN5101)# Die if no data in fie     QN51 283
DIJ=BUFIN(5) ; LDWT=NINT(AMIN1(6.0,AMAX1(0.0,BUFIN(6))))#               QN51 284
LBWT=NINT(AMIN1(6.0,AMAX1(0.0,BUFIN(7))))#                              QN51 285
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Quit if thats all user wants     QN51 286
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 QN51 287
BUFOT(3)=FLOAT(IRES) ; BUFOT(1)=FLOAT(IATOM) ; BUFOT(4)=FLOAT(JRES)#    QN51 288
BUFOT(2)=FLOAT(JATOM) ; BUFOT(5)=DIJ#                                   QN51 289
BUFOT(6)=FLOAT(LDWT) ; BUFOT(7)=FLOAT(LBWT)#                            QN51 290
ncodefld:(BUFOT,1,CHROT,FMTP,7)#                                        QN51 291
movechar:(TO,1,CHROT,39,NTO,0)#                                         QN51 292
IAA=(IATOM-1)+STEPA+MARKA ; JAA=(JATOM-1)+STEPA+MARKA#                  QN51 293
movertoc:(QX(IAA+5),1,CHROT,34,4,0)#                                    QN51 294
movertoc:(QX(JAA+5),1,CHROT,51,4,0)#                                    QN51 295
movechar:(NAMES,4*(IACID-1)+1,CHROT,25,4,0)#                            QN51 296
movechar:(NAMES,4*(IACID-1)+1,CHROT,42,4,0)#                            QN51 297
writeline:(0,QN51B,NQN51B,1,4)#                                         QN51 298
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 QN51 299
DO ICHAIN=1,NTCHAN#                                                     QN51 300
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 QN51 301
IF(IGORC!=1)#                                                           QN51 302
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 QN51 303
IF(ICHTYP(ICHAIN)!=ICH) NEXT#                                           QN51 304
ICHN=ICHAIN;IZCHAN=MOTHRZ(ICHN);JCHN=ICHAIN;JZCHAN=MOTHRZ(JCHN)#        QN51 305
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 QN51 306
IA=NOAT(IATOM,IRES,ICHN) ; NZ=0#                                        QN51 307
IF(IA<=0&ICHN>NCHAIN)#                                                  QN51 308
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 QN51 309
IA=NOAT(IATOM,IRES,IZCHAN) ; NZ=NZ+1#                                   QN51 310
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 QN51 311
IF(IA>0)#                                                               QN51 312
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 QN51 313
JA=NOAT(JATOM,JRES,JCHN)#                                               QN51 314
IF(JA<=0&JCHN>NCHAIN)#                                                  QN51 315
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 QN51 316
JA=NOAT(JATOM,JRES,JZCHAN) ; NZ=NZ+1#                                   QN51 317
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 QN51 318
IF(JA>0)#                                                               QN51 319
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 QN51 320
IF(NZ!=2)#                                                              QN51 321
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 QN51 322
NODIST=NODIST+1 ; NOSPDS=NOSPDS+1#     Also note distance is special    QN51 323
#                                                                       QN51 324
#    WRITE OUT A PACKET WITH A DISTANCE RESTRAINT                       QN51 325
#    --------------------------------------------                       QN51 326
#                                                                       QN51 327
CALL QN06(IA,JA,DIJ,LDWT,LBWT)#                                         QN51 328
IAA=(IA-1)*STEPA+MARKA;JAA=(JA-1)*STEPA+MARKA#                          QN51 329
movechar:(BLANK,1,ISTAR,1,NSTAR,1)#                                     QN51 330
DISTO=DISIJ(IAA,JAA) ; ABSDEL=ABS(DISTO-DIJ)#                           QN51 331
IF(ABSDEL>0.20) movechar:(STAR,1,ISTAR,1,NSTAR,1)#                      QN51 332
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Quit if thats all user wants     QN51 333
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 QN51 334
BUFOT(1)=FLOAT(NODIST) ; BUFOT(2)=FLOAT(IA) ; BUFOT(3)=FLOAT(JA)#       QN51 335
BUFOT(4)=FLOAT(IRES) ; BUFOT(5)=FLOAT(JRES)#                            QN51 336
BUFOT(6)=DIJ ; BUFOT(7)=DISTO#                                          QN51 337
BUFOT(8)=FLOAT(LDWT) ; BUFOT(9)=FLOAT(LBWT)#                            QN51 338
ncodefld:(BUFOT,1,CHROT,FMTO,9); movechar:(ISTAR,1,CHROT,75,1,0)#       QN51 339
movechar:(TO,1,CHROT,39,NTO,0)#                                         QN51 340
movertoc:(QX(IAA+5),1,CHROT,34,4,0)#                                    QN51 341
movertoc:(QX(JAA+5),1,CHROT,51,4,0)#                                    QN51 342
movechar:(NAMES,4*(IACID-1)+1,CHROT,25,4,0)#                            QN51 343
movechar:(NAMES,4*(IACID-1)+1,CHROT,42,4,0)#                            QN51 344
writeline:(0,QN51B,NQN51B,1,4)#                                         QN51 345
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 QN51 346
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 QN51 347
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 QN51 348
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 QN51 349
IF(IGORC==1) BREAK#                                                     QN51 350
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 QN51 351
#                                                                       QN51 352
#....SAVE DISTANCE IDENTIFIERS FOR CONTACTS EXCLUSION                   QN51 353
IPACK1=IRES*K15+JRES ; IPACK2=IATOM*K15+JATOM#                          QN51 354
IF(IGORC!=1)#                                                           QN51 355
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 QN51 356
IF(IRES>JRES)#                                                          QN51 357
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 QN51 358
IPACK1=JRES*K15+IRES ; IPACK2=JATOM*K15+IATOM#                          QN51 359
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 QN51 360
NDIG(ICH)=NDIG(ICH)+1#                 Intra-chain distance             QN51 361
IF(NDIG(ICH)>qmxdig:)#                                                  QN51 362
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 QN51 363
iquit:(QN5109)#                        Out of room                      QN51 364
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 QN51 365
IGDIST(NDIG(ICH),ICH)=IPACK1 ; IGDIS2(NDIG(ICH),ICH)=IPACK2#            QN51 366
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 QN51 367
ELSE#                                  Inter-chain distance             QN51 368
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 QN51 369
NDIC(IPR)=NDIC(IPR)+1#                                                  QN51 370
IF(NDIC(IPR)>qmxdic:)#                                                  QN51 371
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 QN51 372
iquit:(QN5110)#                        Out of room                      QN51 373
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 QN51 374
ICDIST(NDIC(IPR),IPR)=IPACK1 ; ICDIS2(NDIC(IPR),IPR)=IPACK2#            QN51 375
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 QN51 376
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 QN51 377
readline:(INLINE,NLINEC)#              New line into input buffer       QN51 378
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 QN51 379
RETURN#                                                                 QN51 380
END#                                                                    QN51 381
systemheader:(QN52)## Find planar groups and write constraints          QN52   1
####################################################################    QN52   2
#                                                                  #    QN52   3
#                                QN52                              #    QN52   4
#                                                                  #    QN52   5
####################################################################    QN52   6
SUBROUTINE QN52#                                                        QN52   7
#                                                                       QN52   8
include:(AACOMN)#                                                       QN52   9
include:(QNCOMN)#                                                       QN52  10
#                                                                       QN52  11
#----PREPARE THE TABLE OF PLANAR GROUPS                                 QN52  12
#    SUBROUTINE PLNTAB (NOPLAN,IEOFIN,KRESMP,ISKIQN,ISKIPC)             QN52  13
#                                                                       QN52  14
INTEGER LAT(17),LPR(91),KSPCHN(12),KSPRES(12),KSPATM(12)#               QN52  15
LOGICAL ZCHAIN,ZLINK#                                                   QN52  16
string:(NAME,4)#                                                        QN52  17
string:(IDATM,4)#                                                       QN52  18
chardata:(JNTRM,NTRM)#                                                  QN52  19
chardata:(JCTRM,CTRM)#                                                  QN52  20
chardata:(JLINK,LINK)#                                                  QN52  21
chardata:(IHD,HD)#                                                      QN52  22
chardata:(ISTAR,*)#                                                     QN52  23
chardata:(STAR,*)#                                                      QN52  24
chardata:(QN52A, -----PLANAR GROUPS FROM ACTUAL PROTEIN ATOMS $#        QN52  25
LOADED----- )#                                                          QN52  26
chardata:(QN52B,      RESIDUE        ATOM--NO. ATOM--NO. ATOM--NO. $#   QN52  27
ATOM--NO. ATOM--NO. ATOM--NO. ATOM--NO. ATOM--NO. ATOM--NO. ATOM--NO.)# QN52  28
chardata:(QN52C, ****THE PLANAR TERMINAL GROUP OF XXXX III $#           QN52  29
HAS NOT BEEN SPECIFIED SINCE )#                                         QN52  30
chardata:(QN52D,     MISSING SIDE-CHAIN ATOMS OBFUSCATE THE LOCATION $# QN52  31
OF NEEDED ATOM-PAIRS. )#                                                QN52  32
chardata:(QN52E,   NO. PLANE                                 )#         QN52  33
realdata:(FMT1,[60513.,200413.,300413.,400413.,500413.,600413.,$#       QN52  34
700413.,800413.,900413.,1000413.,1100413.,1200413.,1300413.])#          QN52  35
realdata:(FMT2,[50313.,90413.,130413.,170413.,210413.,250413.,$#        QN52  36
290413.,330413.,370413.,410413.,450413.,490413.,530413.,570413.,$#      QN52  37
610413.,650413.,690413.,730413.,770413.,810413.,850413.])#              QN52  38
datastuff:#                                                             QN52  39
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN52  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN52  41
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN52A,NQN52A,3,4) ; LINRM=3#     QN52  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN52  43
ZCHAIN=.FALSE. ; DO ICHAIN=1,NTCHAN#   Loop over chains                 QN52  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN52  45
ICH=ICHTYP(ICHAIN) ; IRESN=IREST(2*(ICH-1)+1)#                          QN52  46
IRESC=IREST(2*(ICH-1)+2) ; IACIDN=IACIDT(2*(ICH-1)+1)#                  QN52  47
IACIDC=IACIDT(2*(ICH-1)+2) ; IRESMP=KRESMP(ICH)#                        QN52  48
IF(ICHAIN>NCHAIN) ZCHAIN=.TRUE. ; IZCHAN=MOTHRZ(ICHAIN)#                QN52  49
DO IRES=IRESN,IRESC#                   Loop over residues               QN52  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN52  51
ZLINK=.FALSE.#                                                          QN52  52
IF(ZCHAIN)#                                                             QN52  53
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN52  54
IF(IRES!=IRESN)#                                                        QN52  55
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN52  56
IF(ZMAIN(IRES-1,ICHAIN)&!ZMAIN(IRES,ICHAIN)) ZLINK=.TRUE.#              QN52  57
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN52  58
IF(!ZLINK)#                                                             QN52  59
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN52  60
IF(ICENTR(IRES,ICHAIN)==0) NEXT#                                        QN52  61
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN52  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN52  63
IDZ=IDISTZ(IRES,ICHAIN) ; IACID=IDACD(IRES,ICHAIN)#                     QN52  64
IF(ZLINK) IACID=IDACD(IRES,IZCHAN)#                                     QN52  65
IF(IRES!=IRESN&IRES!=IRESC) GO TO 1440# Planar terminal groups          QN52  66
NA=NPLATS(IACID)#                                                       QN52  67
IF(NA<=0) GO TO 1440#                                                   QN52  68
JA=0 ; NZ=0#                                                            QN52  69
DO IA=1,NA#                            Loop over atoms                  QN52  70
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN52  71
IATOM=IPLN(IACID,IA)#                                                   QN52  72
movechar:(IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,IDATM,1,4,0)#             QN52  73
NIA=NOAT(IATOM,IRES,ICHAIN)#                                            QN52  74
IF(NIA<=0)#                                                             QN52  75
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN52  76
compchar:(IDATM,1,IHD,1,1,1,NHD,K) ; IF(K!=0) NEXT#                     QN52  77
IF(!ZCHAIN) GO TO 1440#                                                 QN52  78
NIA=NOAT(IATOM,IRES,IZCHAN) ; NZ=NZ+1#                                  QN52  79
IF(NIA<=0) GO TO 1440#                                                  QN52  80
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN52  81
JA=JA+1 ; LAT(JA)=NIA#                                                  QN52  82
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN52  83
NA=JA ; IF(NZ>=NA) GO TO 1440#                                          QN52  84
IF((IRES==IRESN&ISKIQN(ICHAIN)==1)\$#                                   QN52  85
(IRES==IRESC&ISKIPC(ICHAIN)==1))#                                       QN52  86
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN52  87
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN52  88
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN52  89
movechar:(NAMES,4*(IACID-1)+1,QN52C,35,4,0)#                            QN52  90
ncodefld:(FLOAT(IRES),1,QN52C,420313.,1)#                               QN52  91
writeline:(1,QN52C,NQN52C,3,2) ; writeline:(1,QN52D,NQN52D,3,2)#        QN52  92
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN52  93
GO TO 1440#                                                             QN52  94
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN52  95
NP=NPAIRS(IACID)#                                                       QN52  96
DO IP=1,NP#                                                             QN52  97
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN52  98
KP=KPLN(IACID,IP)#                                                      QN52  99
IF(KP<0) LPR(IP)=KP-IDZ#                                                QN52 100
ELSE IF(KP==0) LPR(IP)=0#                                               QN52 101
ELSE  LPR(IP)=KP+IDZ#                                                   QN52 102
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN52 103
NOPLAN=NOPLAN+1#                                                        QN52 104
#                                                                       QN52 105
#    WRITE OUT A PACKET WITH A PLANE RESTRAINT                          QN52 106
#    -----------------------------------------                          QN52 107
#                                                                       QN52 108
CALL QN07(NA,LAT)#                                                      QN52 109
# THE ORIGINAL PROGRAM WROTE OUT THE FOLLOWING LIST.  PROLSQ            QN52 110
# DOES NOT USE THE NP OR LPR ARRAY.                                     QN52 111
# WRITE()NOPLAN,NA,(LAT(IA),IA=1,NA),NP,(LPR(IP),IP=1,NP)#              QN52 112
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN52 113
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN52 114
IF(IRES==IRESN) movechar:(JNTRM,1,NAME,1,NJNTRM,0)#                     QN52 115
IF(IRES==IRESC) movechar:(JCTRM,1,NAME,1,NJCTRM,0)#                     QN52 116
BUFOT(1)=FLOAT(NOPLAN) ; BUFOT(2)=FLOAT(IRES)#                          QN52 117
movechar:(NAME,1,CHROT,8,4,0)#                                          QN52 118
NQ=MIN0(NA,10) ; DO IA=1,NQ#                                            QN52 119
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN52 120
BUFOT(IA+2)=FLOAT(LAT(IA))#                                             QN52 121
movechar:(IDS,(IACID-1)*qmxat4:+(LAT(IA)-1)*4+1,$#                      QN52 122
CHROT,(IA-1)*10+22,4,0)#                                                QN52 123
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN52 124
ncodefld:(BUFOT,1,CHROT,FMT1,NA+2) ; writeline:(0,QN52B,NQN52B,1,4)#    QN52 125
IF(NA>NQ)#                             Fold long lines                  QN52 126
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN52 127
DO IA=NQ+1,NA#                                                          QN52 128
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN52 129
BUFOT(IA-NQ)=FLOAT(LAT(IA))#                                            QN52 130
movechar:(IDS,(IACID-1)*qmxat4:+(LAT(IA)-1)*4+1,$#                      QN52 131
CHROT,(IA-NQ-1)*10+22,4,0)#                                             QN52 132
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN52 133
ncodefld:(BUFOT,1,CHROT,FMT1(3),JA-NA);writeline:(0,QN52B,NQN52B,1,4)#  QN52 134
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN52 135
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN52 136
GO TO 1440#                                                             QN52 137
#                                                                       QN52 138
#----PLANAR INTER-RESIDUE LINKS                                         QN52 139
#----ASSUMES THE FIRST 3 ATOMS FROM RES(I-1), ATOMS 4(& 5) FROM RES(I   QN52 140
1440 IF(IRES==IRESN) GO TO 1580#                                        QN52 141
LINK=NACIDT+1 ; NA=NPLATS(LINK) ; KINK=LINK#                            QN52 142
IF(IACID==15) KINK=NACIDT+3#           ******bad news bear!!!!!!!!!!    QN52 143
IF(IRES==IRESC&IACIDC==15) KINK=NACIDT+3# ******bad news bear!!!!!!!!   QN52 144
NA=NPLATS(KINK) ; NZ=0#                                                 QN52 145
DO IA=1,NA#                            Loop over atoms                  QN52 146
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN52 147
IATOM=IPLN(LINK,IA)#                                                    QN52 148
IF(IA<4)#                                                               QN52 149
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN52 150
LAT(IA)=NOAT(IATOM,IRES-1,ICHAIN)#                                      QN52 151
IF(LAT(IA)>0) NEXT#                                                     QN52 152
IF(!ZCHAIN) GO TO 1580#                                                 QN52 153
LAT(IA)=NOAT(IATOM,IRES-1,IZCHAN) ; NZ=NZ+1#                            QN52 154
IF(LAT(IA)<=0) GO TO 1580#                                              QN52 155
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN52 156
ELSE#                                                                   QN52 157
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN52 158
LAT(IA)=NOAT(IATOM,IRES,ICHAIN)#                                        QN52 159
IF(LAT(IA)>0) NEXT#                                                     QN52 160
IF(IA==6&IACID!=15&!ZLINK)#                                             QN52 161
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN52 162
NA=5 ; BREAK#                                                           QN52 163
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN52 164
IF(!ZCHAIN) GO TO 1580#                                                 QN52 165
LAT(IA)=NOAT(IATOM,IRES,IZCHAN) ; NZ=NZ+1#                              QN52 166
IF(LAT(IA)<=0) GO TO 1580#                                              QN52 167
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN52 168
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN52 169
IF(NZ>=NA) GO TO 1580#                                                  QN52 170
NP=NPAIRS(KINK) ; ND=NDISTS(IACID)#                                     QN52 171
IF(ND>0)#                                                               QN52 172
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN52 173
NDRES=ND#                                                               QN52 174
DO IDIST=1,NDRES#                                                       QN52 175
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QN52 176
IATOM=IATM(IACID,IDIST) ; IA=NOAT(IATOM,IRES,ICHAIN)#                   QN52 177
JATOM=JATM(IACID,IDIST) ; JA=NOAT(JATOM,IRES,ICHAIN)#                   QN52 178
IF(IA<=0&JA<=0)#                                                        QN52 179
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QN52 180
ND=ND-1 ; NEXT#                                                         QN52 181
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QN52 182
IF(IA<=0&ZCHAIN) IA=NOAT(IATOM,IRES,IZCHAN)#                            QN52 183
IF(JA<=0&ZCHAIN) JA=NOAT(JATOM,IRES,IZCHAN)#                            QN52 184
IF(IA<=0\JA<=0) ND=ND-1#                                                QN52 185
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QN52 186
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN52 187
DO IP=1,NP#                                                             QN52 188
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QN52 189
IZERO=IDZ+ND#                                                           QN52 190
IF(IP<4)#                                                               QN52 191
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QN52 192
IZERO=IDISTZ(IRES-1,ICHAIN)#                                            QN52 193
IF(ZMAIN(IRES,ICHAIN)&!ZMAIN(IRES-1,ICHAIN))#                           QN52 194
IZERO=IDISTZ(IRES-1,IZCHAN)#                                            QN52 195
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QN52 196
IF(IP==10\IP>=14)#                                                      QN52 197
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QN52 198
IZERO=IDZ ; IF(ZLINK) IZERO=IDISTZ(IRES,IZCHAN)#                        QN52 199
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QN52 200
KP=KPLN(LINK,IP)#                                                       QN52 201
IF(KP<0) LPR(IP)=KP-IZERO#                                              QN52 202
ELSE IF(KP==0) LPR(IP)=0#                                               QN52 203
ELSE LPR(IP)=KP+IZERO#                                                  QN52 204
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QN52 205
NOPLAN=NOPLAN+1#                                                        QN52 206
#                                                                       QN52 207
#    WRITE OUT A PACKET WITH A PLANE RESTRAINT                          QN52 208
#    -----------------------------------------                          QN52 209
#                                                                       QN52 210
CALL QN07(NA,LAT)#                                                      QN52 211
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN52 212
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QN52 213
movechar:(JLINK,1,NAME,1,NJLINK,0)#                                     QN52 214
BUFOT(1)=FLOAT(NOPLAN) ; BUFOT(2)=FLOAT(IRES)#                          QN52 215
movechar:(NAME,1,CHROT,8,4,0)#                                          QN52 216
NQ=MIN0(NA,10) ; DO IA=1,NQ#                                            QN52 217
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 QN52 218
BUFOT(IA+2)=FLOAT(LAT(IA))#                                             QN52 219
movechar:(IDS,(IACID-1)*qmxat4:+(LAT(IA)-1)*4+1,$#                      QN52 220
CHROT,(IA-1)*10+22,4,0)#                                                QN52 221
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 QN52 222
ncodefld:(BUFOT,1,CHROT,FMT1,NA+2) ; writeline:(0,QN52B,NQN52B,1,4)#    QN52 223
IF(NA>NQ)#                             Fold long lines                  QN52 224
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 QN52 225
DO IA=NQ+1,NA#                                                          QN52 226
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 QN52 227
BUFOT(IA-NQ)=FLOAT(LAT(IA))#                                            QN52 228
movechar:(IDS,(IACID-1)*qmxat4:+(LAT(IA)-1)*4+1,$#                      QN52 229
CHROT,(IA-NQ-1)*10+22,4,0)#                                             QN52 230
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 QN52 231
ncodefld:(BUFOT,1,CHROT,FMT1(3),JA-NA);writeline:(0,QN52B,NQN52B,1,4)#  QN52 232
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 QN52 233
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QN52 234
1580 CONTINUE#                                                          QN52 235
IF(IRES==IRESN) IACID=IACIDN#          Planar side-chain groups         QN52 236
IF(IRES==IRESC) IACID=IACIDC ; NA=NPLATS(IACID)#                        QN52 237
IF(NA<=0) NEXT#                                                         QN52 238
JA=0 ; NZ=0#                                                            QN52 239
DO IA=1,NA#                            Loop over atoms                  QN52 240
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 QN52 241
IATOM=IPLN(IACID,IA)#                                                   QN52 242
movechar:(IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,IDATM,1,4,0)#             QN52 243
NIA=NOAT(IATOM,IRES,ICHAIN)#                                            QN52 244
IF(NIA<=0)#                                                             QN52 245
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 QN52 246
compchar:(IDATM,1,IHD,1,1,1,NHD,K) ; IF(K!=0) NEXT#                     QN52 247
IF(!ZCHAIN) GO TO 1670#                                                 QN52 248
NIA=NOAT(IATOM,IRES,IZCHAN) ; NZ=NZ+1#                                  QN52 249
IF(NIA<=0) GO TO 1670#                                                  QN52 250
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 QN52 251
JA=JA+1 ; LAT(JA)=NIA#                                                  QN52 252
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 QN52 253
NA=JA ; IF(NZ>=NA) GO TO 1670#                                          QN52 254
NP=NPAIRS(IACID)#                                                       QN52 255
DO IP=1,NP#                                                             QN52 256
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 QN52 257
KP=KPLN(IACID,IP)#                                                      QN52 258
IF(KP!=0)#                                                              QN52 259
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 QN52 260
IF(ZCHAIN)#                                                             QN52 261
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 QN52 262
KPMAG=ISIGN(KP,1) ; DO IDIST=1,KPMAG#                                   QN52 263
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 QN52 264
IATOM=IATM(IACID,IDIST) ; IA=NOAT(IATOM,IRES,ICHAIN)#                   QN52 265
JATOM=JATM(IACID,IDIST) ; JA=NOAT(JATOM,IRES,ICHAIN)#                   QN52 266
IF(IA<=0&JA<=0)#                                                        QN52 267
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 QN52 268
KP=KP-ISIGN(1,KP)#                                                      QN52 269
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 QN52 270
ELSE IF(IA<=0)#                                                         QN52 271
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 QN52 272
IA=NOAT(IATOM,IRES,IZCHAN)#                                             QN52 273
IF(JA<=0) JA=NOAT(JATOM,IRES,IZCHAN)#                                   QN52 274
IF(IA<=0\JA<=0) KP=KP-ISIGN(1,KP)#                                      QN52 275
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 QN52 276
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 QN52 277
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 QN52 278
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 QN52 279
IF(KP>0) LPR(IP)=KP+IDZ#                                                QN52 280
ELSE IF(KP==0) LPR(IP)=KP-IDZ#                                          QN52 281
ELSE LPR(IP)=0#                                                         QN52 282
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 QN52 283
NOPLAN=NOPLAN+1#                                                        QN52 284
#                                                                       QN52 285
#    WRITE OUT A PACKET WITH A PLANE RESTRAINT                          QN52 286
#    -----------------------------------------                          QN52 287
#                                                                       QN52 288
CALL QN07(NA,LAT)#                                                      QN52 289
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN52 290
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 QN52 291
BUFOT(1)=FLOAT(NOPLAN) ; BUFOT(2)=FLOAT(IRES)#                          QN52 292
movechar:(NAMES,4*(IACID-1)+1,CHROT,8,4,0)#                             QN52 293
NQ=MIN0(NA,10) ; DO IA=1,NQ#                                            QN52 294
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 QN52 295
BUFOT(IA+2)=FLOAT(LAT(IA))#                                             QN52 296
movechar:(IDS,(IACID-1)*qmxat4:+(LAT(IA)-1)*4+1,$#                      QN52 297
CHROT,(IA-1)*10+22,4,0)#                                                QN52 298
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 QN52 299
ncodefld:(BUFOT,1,CHROT,FMT1,NA+2) ; writeline:(0,QN52B,NQN52B,1,4)#    QN52 300
IF(NA>NQ)#                             Fold long lines                  QN52 301
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 QN52 302
DO IA=NQ+1,NA#                                                          QN52 303
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 QN52 304
BUFOT(IA-NQ)=FLOAT(LAT(IA))#                                            QN52 305
movechar:(IDS,(IACID-1)*qmxat4:+(LAT(IA)-1)*4+1,$#                      QN52 306
CHROT,(IA-NQ-1)*10+22,4,0)#                                             QN52 307
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 QN52 308
ncodefld:(BUFOT,1,CHROT,FMT1(3),JA-NA);writeline:(0,QN52B,NQN52B,1,4)#  QN52 309
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 QN52 310
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 QN52 311
1670 CONTINUE#                                                          QN52 312
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN52 313
IF(IRESMP<=0) NEXT## PLANAR ELEMENTS OF A MULTI-PLANAR PROSTHETIC GRO   QN52 314
IRES=IRESMP ; IACID=IDACD(IRES,ICHAIN)#                                 QN52 315
KIND1=MAXGRP+1 ; KINDN=qmxpln:#                                         QN52 316
#                                                                       QN52 317
#----SKIP PLANES DEFINED FOR PROSTHETIC GROUPS OTHER THAN THE ONE       QN52 318
DO KIND=KIND1,KINDN#                   Defined for this chain.          QN52 319
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 QN52 320
IF(IACID!=KNDACD(KIND)) NEXT#                                           QN52 321
NA=NPLATS(KIND)#                                                        QN52 322
IF(NA<=0) NEXT#                                                         QN52 323
JA=0 ; NZ=0 ; IHIT=no:#                                                 QN52 324
DO IA=1,NA#                                                             QN52 325
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 QN52 326
IATOM=IPLN(KIND,IA)#                                                    QN52 327
movechar:(IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,IDATM,1,4,0)#             QN52 328
KATOM=NOAT(IATOM,IRES,ICHAIN)#                                          QN52 329
IF(KATOM<1)#                                                            QN52 330
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 QN52 331
compchar:(IDATM,1,IHD,1,1,1,NHD,K) ; IF(K!=0) NEXT#                     QN52 332
IF(!ZCHAIN)#                                                            QN52 333
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 QN52 334
IHIT=yes: ; BREAK#                                                      QN52 335
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 QN52 336
KATOM=NOAT(IATOM,IRES,IZCHAN) ; NZ=NZ+1#                                QN52 337
IF(KATOM<=0)#                                                           QN52 338
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 QN52 339
IHIT=yes: ; BREAK#                                                      QN52 340
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 QN52 341
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 QN52 342
JA=JA+1 ; LAT(JA)=KATOM#                                                QN52 343
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 QN52 344
IF(IHIT==yes:) NEXT#                                                    QN52 345
NA=MIN0(JA,10)#                                                         QN52 346
IF(NZ>=NA) NEXT#                                                        QN52 347
NP=NPAIRS(KIND)#                                                        QN52 348
DO IP=1,NP#                                                             QN52 349
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 QN52 350
KP=KPLN(KIND,IP)#                                                       QN52 351
IF(KP>0) LPR(IP)=KP+IDZ#                                                QN52 352
ELSE IF(KP==0) LPR(IP)=0#                                               QN52 353
ELSE LPR(IP)=KP-IDZ#                                                    QN52 354
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 QN52 355
NOPLAN=NOPLAN+1#                                                        QN52 356
#                                                                       QN52 357
#    WRITE OUT A PACKET WITH A PLANE RESTRAINT                          QN52 358
#    -----------------------------------------                          QN52 359
#                                                                       QN52 360
CALL QN07(JA,LAT)#                                                      QN52 361
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN52 362
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 QN52 363
BUFOT(1)=FLOAT(NOPLAN) ; BUFOT(2)=FLOAT(IRES)#                          QN52 364
movechar:(NAMES,4*(IACID-1)+1,CHROT,8,4,0)#                             QN52 365
DO IA=1,NA#                                                             QN52 366
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 QN52 367
BUFOT(IA+2)=FLOAT(LAT(IA))#                                             QN52 368
movechar:(IDS,(IACID-1)*qmxat4:+(LAT(IA)-1)*4+1,$#                      QN52 369
CHROT,(IA-1)*10+22,4,0)#                                                QN52 370
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 QN52 371
ncodefld:(BUFOT,1,CHROT,FMT1,NA+2) ; writeline:(0,QN52B,NQN52B,1,4)#    QN52 372
IF(JA>NA)#                             Fold long lines                  QN52 373
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 QN52 374
DO IA=NA+1,JA#                                                          QN52 375
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 QN52 376
BUFOT(IA-NA)=FLOAT(LAT(IA))#                                            QN52 377
movechar:(IDS,(IACID-1)*qmxat4:+(LAT(IA)-1)*4+1,$#                      QN52 378
CHROT,(IA-NA-1)*10+22,4,0)#                                             QN52 379
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 QN52 380
ncodefld:(BUFOT,1,CHROT,FMT1(3),JA-NA);writeline:(0,QN52B,NQN52B,1,4)#  QN52 381
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 QN52 382
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 QN52 383
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 QN52 384
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN52 385
IF(LINID<31) iquit:(QN5213)#           Input line order error           QN52 386
IF(LISLOC>=0) LINRM=5#                 Force heading if listing         QN52 387
REPEAT#                                                                 QN52 388
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 QN52 389
IF(LINID>31) BREAK#                    Seek spcpla input lines          QN52 390
IA=-2 ; NA=0#                                                           QN52 391
REPEAT#                                                                 QN52 392
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 QN52 393
IA=IA+3 ; IF(BUFIN(IA)<=voidflg:) BREAK#                                QN52 394
NA=NA+1 ; KSPCHN(NA)=NINT(AMAX1(0.0,BUFIN(IA)))#                        QN52 395
KSPRES(NA)=NINT(AMAX1(0.0,BUFIN(IA+1)))#                                QN52 396
KSPATM(NA)=NINT(AMAX1(0.0,BUFIN(IA+2)))#                                QN52 397
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 QN52 398
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN52 399
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 QN52 400
BUFOT(1)=FLOAT(NA) ; K=2 ; DO IA=1,NA#                                  QN52 401
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 QN52 402
BUFOT(K+1)=FLOAT(KSPCHN(IA));BUFOT(K+2)=FLOAT(KSPRES(IA))#              QN52 403
BUFOT(K+3)=FLOAT(KSPATM(IA));K=K+3#                                     QN52 404
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 QN52 405
ncodefld:(BUFOT,1,CHROT,FMT2,3*NA+1);writeline:(0,QN52E,NQN52E,1,4)#    QN52 406
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 QN52 407
NP=0#                                                                   QN52 408
IF(KSPCHN(1)==0) KSPCHN(1)=1#                                           QN52 409
DO IA=2,NA#                                                             QN52 410
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 QN52 411
IF(KSPCHN(IA)==0) KSPCHN(IA)=KSPCHN(IA-1)#                              QN52 412
IF(KSPRES(IA)==0) KSPRES(IA)=KSPRES(IA-1)#                              QN52 413
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 QN52 414
JA=0 ; IHIT=no:#                                                        QN52 415
DO IA=1,NA#                                                             QN52 416
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 57 QN52 417
IATOM=KSPATM(IA) ; IRES=KSPRES(IA)#                                     QN52 418
ICHAIN=KSPCHN(IA) ; IACID=IDACD(IRES,ICHAIN)#                           QN52 419
movechar:(IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,IDATM,1,4,0)#             QN52 420
NIA=NOAT(IATOM,IRES,ICHAIN)#                                            QN52 421
IF(NIA<1)#                                                              QN52 422
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 58 QN52 423
compchar:(IDATM,1,IHD,1,1,1,NHD,K) ; IF(K!=0) NEXT#                     QN52 424
IHIT=yes: ; BREAK#                                                      QN52 425
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 58 QN52 426
JA=JA+1 ; LAT(JA)=NIA#                                                  QN52 427
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 57 QN52 428
IF(IHIT==no:)#                                                          QN52 429
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 59 QN52 430
NA=MIN0(JA,10) ; NOPLAN=NOPLAN+1#                                       QN52 431
#                                                                       QN52 432
#    WRITE OUT A PACKET WITH A PLANE RESTRAINT                          QN52 433
#    -----------------------------------------                          QN52 434
#                                                                       QN52 435
CALL QN07(JA,LAT)#                                                      QN52 436
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN52 437
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 60 QN52 438
BUFOT(1)=FLOAT(NOPLAN) ; BUFOT(2)=FLOAT(IRES)#                          QN52 439
movechar:(NAMES,4*(IACID-1)+1,CHROT,8,4,0)#                             QN52 440
DO IA=1,NA#                                                             QN52 441
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 61 QN52 442
BUFOT(IA+2)=FLOAT(LAT(IA))#                                             QN52 443
movechar:(IDS,(IACID-1)*qmxat4:+(LAT(IA)-1)*4+1,$#                      QN52 444
CHROT,(IA-1)*10+22,4,0)#                                                QN52 445
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 61 QN52 446
ncodefld:(BUFOT,1,CHROT,FMT1,NA+2) ; writeline:(0,QN52B,NQN52B,1,4)#    QN52 447
IF(JA>NA)#                             Fold long lines                  QN52 448
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 62 QN52 449
DO IA=NA+1,JA ; BUFOT(IA-NA)=FLOAT(LAT(IA))#                            QN52 450
movechar:(IDS,(IACID-1)*qmxat4:+(LAT(IA)-1)*4+1,$#                      QN52 451
CHROT,(IA-NA-1)*10+22,4,0)#                                             QN52 452
ncodefld:(BUFOT,1,CHROT,FMT1(3),JA-NA);writeline:(0,QN52B,NQN52B,1,4)#  QN52 453
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 62 QN52 454
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 60 QN52 455
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 59 QN52 456
readline:(INLINE,NLINEC)#              Input the next input line        QN52 457
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 QN52 458
RETURN#                                                                 QN52 459
END#                                                                    QN52 460
systemheader:(QN53)## Find chiral centers and write constraints         QN53   1
####################################################################    QN53   2
#                                                                  #    QN53   3
#                                QN53                              #    QN53   4
#                                                                  #    QN53   5
####################################################################    QN53   6
SUBROUTINE QN53#                                                        QN53   7
#                                                                       QN53   8
include:(AACOMN)#                                                       QN53   9
include:(QNCOMN)#                                                       QN53  10
#                                                                       QN53  11
#----PREPARE THE TABLE OF CHIRAL CENTERS                                QN53  12
#     SUBROUTINE CCTAB (NOCHRL)                                         QN53  13
#                                                                       QN53  14
INTEGER LAT(4),LPR(6)#                                                  QN53  15
LOGICAL ZCHAIN#                                                         QN53  16
REAL A(3,3)#                                                            QN53  17
chardata:(QN53A, -----CHIRAL CENTERS----- )#                            QN53  18
chardata:(QN53B,   NO. RESIDUE       ATOM    ATOM    ATOM    $#         QN53  19
ATOM    CONSTRAINTS                              V   V MODEL )#         QN53  20
realdata:(FMT1,[60513.,150413.,210413.,290413.,370413.,450413.,$#       QN53  21
570613.,630613.,690613.,750613.,810613.,870613.,970832.,1050832.])#     QN53  22
datastuff:#                                                             QN53  23
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN53  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN53  25
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN53A,NQN53A,3,4) ; LINRM=3#     QN53  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN53  27
ZCHAIN=.FALSE. ; DO ICHAIN=1,NTCHAN#   Loop over chains                 QN53  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN53  29
ICH=ICHTYP(ICHAIN) ; IRESN=IREST(2*(ICH-1)+1)#                          QN53  30
IRESC=IREST(2*(ICH-1)+2) ; IACIDN=IACIDT(2*(ICH-1)+1)#                  QN53  31
IACIDC=IACIDT(2*(ICH-1)+2) ; IRESMX=KRESMX(ICHAIN)#                     QN53  32
IF(ICHAIN>NCHAIN) ZCHAIN=.TRUE.#                                        QN53  33
IZCHAN=MOTHRZ(ICHAIN)#                                                  QN53  34
DO IRES=IRESN,IRESMX#                  Loop over residues               QN53  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN53  36
IF(ZCHAIN)#                                                             QN53  37
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN53  38
IF(ICENTR(IRES,ICHAIN)==0) NEXT#                                        QN53  39
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN53  40
KACID=IDACD(IRES,ICHAIN) ; IACID=KACID#                                 QN53  41
IF(IRES==IRESN) IACID=IACIDN#                                           QN53  42
IF(IRES==IRESC) IACID=IACIDC#                                           QN53  43
IDZ=IDISTZ(IRES,ICHAIN)#                                                QN53  44
#                                      ******bad news bear!!!!!!!!!!    QN53  45
IF(IACID==8) NEXT#                     Skip if a glycine residue        QN53  46
DO IC=1,NCHR#                          Loop over possible centers       QN53  47
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN53  48
IF(IC<2)#                                                               QN53  49
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN53  50
IF(IRES>IRESC) NEXT#                   Prep for an alpha-carbon cente   QN53  51
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN53  52
ELSE IF(IACID!=IDCHR(IC)) NEXT## Prep a side-chain or extra-grp cntr    QN53  53
NZ=0 ; IHIT=no:#                       Find atom ident. numbers         QN53  54
DO IA=1,4#                                                              QN53  55
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN53  56
IATOM=ICHR(IC,IA)#                                                      QN53  57
IF(LISLOC>0)#                          Don't move unless writing        QN53  58
movechar:(IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,$#                        QN53  59
CHROT,8*(IA-1)+22,4,0)#                                                 QN53  60
NIA=NOAT(IATOM,IRES,ICHAIN)#                                            QN53  61
IF(NIA<1)#                                                              QN53  62
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN53  63
IF(!ZCHAIN) IHIT=yes:#                                                  QN53  64
ELSE#                                                                   QN53  65
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN53  66
NIA=NOAT(IATOM,IRES,IZCHAN) ; NZ=NZ+1#                                  QN53  67
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN53  68
IF(NIA<=0\IHIT==yes:)#                                                  QN53  69
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN53  70
IHIT=yes: ; BREAK#                                                      QN53  71
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN53  72
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN53  73
LAT(IA)=NIA#                                                            QN53  74
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN53  75
IF(NZ==4\IHIT==yes:) NEXT#                                              QN53  76
DO IP=1,6## Find distance identifications of all atom pairs             QN53  77
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN53  78
KP=KCHR(IC,IP) ; IDZZ=IDZ#                                              QN53  79
IF(KP!=0)#                                                              QN53  80
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN53  81
IF(ZCHAIN)#                                                             QN53  82
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN53  83
KPMAG=ISIGN(KP,1) ; IATOM=IATM(IACID,KPMAG)#                            QN53  84
IA=NOAT(IATOM,IRES,ICHAIN) ; JATOM=JATM(IACID,KPMAG)#                   QN53  85
JA=NOAT(JATOM,IRES,ICHAIN)#                                             QN53  86
IF(IA<1&JA<1)#                                                          QN53  87
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN53  88
IDZZ=IDISTZ(IRES,IZCHAN)#                                               QN53  89
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN53  90
#                                                                       QN53  91
ELSE#                                                                   QN53  92
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN53  93
DO IDIST=1,KPMAG#                                                       QN53  94
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN53  95
IATOM=IATM(IACID,IDIST) ; IA=NOAT(IATOM,IRES,ICHAIN)#                   QN53  96
JATOM=JATM(IACID,IDIST) ; JA=NOAT(JATOM,IRES,ICHAIN)#                   QN53  97
IF(IA<1&JA<1)#                                                          QN53  98
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN53  99
KP=KP-ISIGN(1,KP)#                                                      QN53 100
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN53 101
ELSE#                                                                   QN53 102
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN53 103
IF(IA<=0) IA=NOAT(IATOM,IRES,IZCHAN)#                                   QN53 104
IF(JA<=0) JA=NOAT(JATOM,IRES,IZCHAN)#                                   QN53 105
IF(IA<=0\JA<=0) KP=KP-ISIGN(1,KP)#                                      QN53 106
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN53 107
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN53 108
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN53 109
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN53 110
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN53 111
IF(KP<0) LPR(IP)=KP-IDZZ#                                               QN53 112
ELSE IF(KP>0) LPR(IP)=KP+IDZZ#                                          QN53 113
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN53 114
V=VCHR(IC) ; IA=LAT(1)## Find the model hand and apply if called        QN53 115
IAA=(IA-1)*STEPA+MARKA#                                                 QN53 116
DO I=1,3#                                                               QN53 117
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN53 118
IG=LAT(I+1) ; IGA=(IG-1)*STEPA+MARKA ; A(I,1)=QX(IGA+1)-QX(IAA+1)#      QN53 119
A(I,2)=QX(IGA+2)-QX(IAA+2) ; A(I,3)=QX(IGA+3)-QX(IAA+3)#                QN53 120
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN53 121
VMODEL=QN03(A)#                        Use function det3                QN53 122
IF(ICRABS(IC)==0) V=SIGN(V,VMODEL)#                                     QN53 123
NOCHRL=NOCHRL+1#                       List this chiral center          QN53 124
#                                                                       QN53 125
#    WRITE OUT A PACKET WITH A CHIRAL CENTER RESTRAINT                  QN53 126
#    -------------------------------------------------                  QN53 127
#                                                                       QN53 128
CALL QN08(LAT,LPR,V)#                                                   QN53 129
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN53 130
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN53 131
BUFOT(1)=FLOAT(NOCHRL) ; BUFOT(2)=FLOAT(IRES)#                          QN53 132
movechar:(NAMES,4*(KACID-1)+1,CHROT,8,4,0)#                             QN53 133
DO IA=1,4 ; BUFOT(IA+2)=FLOAT(LAT(IA))#                                 QN53 134
DO IP=1,6 ; BUFOT(IP+6)=FLOAT(LPR(IP))#                                 QN53 135
BUFOT(13)=V ; BUFOT(14)=VMODEL#                                         QN53 136
ncodefld:(BUFOT,1,CHROT,FMT1,14) ; writeline:(0,QN53B,NQN53B,1,4)#      QN53 137
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN53 138
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN53 139
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN53 140
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN53 141
#                                                                       QN53 142
#----MODIFY THE ATOM TYPE IDENTIFIER FOR CARBONYL CARBONS FROM 6 TO 3   QN53 143
DO IACID=1,NACIDP ; KS(IACID,3)=3#                                      QN53 144
DO IT=1,NTRMS ; KS(NACIDS+IT,3)=3#                                      QN53 145
#----FIND THE ATOM NUMBER OF FIRST SIDE-CHAIN ATOMS                     QN53 146
ISID1=NATOMM(1)+1#                                                      QN53 147
#                                                                       QN53 148
RETURN#                                                                 QN53 149
END#                                                                    QN53 150
systemheader:(QN54)## Find vdWaal's contacts and write constraints      QN54   1
####################################################################    QN54   2
#                                                                  #    QN54   3
#                                QN54                              #    QN54   4
#                                                                  #    QN54   5
####################################################################    QN54   6
SUBROUTINE QN54#                                                        QN54   7
#                                                                       QN54   8
include:(AACOMN)#                                                       QN54   9
include:(QNCOMN)#                                                       QN54  10
#                                                                       QN54  11
#----PREPARE THE TABLE OF POSSIBLE VAN DER WAALS                        QN54  12
#    WITHIN RESIDUE CONTACTS                                            QN54  13
#     SUBROUTINE VDWINR (NOVDW,NONOW,ISID1,VDWCUT)                      QN54  14
#                                                                       QN54  15
LOGICAL ZCHAIN,ZLINK#                                                   QN54  16
string:(ATNAM,4)#                                                       QN54  17
chardata:(ICB,CB  )#                                                    QN54  18
chardata:(STAR,*)#                                                      QN54  19
chardata:(ISTAR,*)#                                                     QN54  20
chardata:(IHD,HD)#                                                      QN54  21
chardata:(QN54A, -----POSSIBLE VAN DER WAALS CONTACTS----- )#           QN54  22
chardata:(QN54B,CONTACT NO.   ATOM AT NO.       RESIDUE ATOM AT $#      QN54  23
NO.        RESIDUE   IDEAL DIST  OBSERVED    CONSTRAINT)#               QN54  24
realdata:(FMTO,[120613.,240613.,320613.,510613.,590613.,740832.,$#      QN54  25
840832.,900413.])#                                                      QN54  26
datastuff:#                                                             QN54  27
#                                                                       QN54  28
#----INTERATOMIC DISTANCE FUNCTION                                      QN54  29
DISIJ(I,J)=$#                                                           QN54  30
SQRT((QX(I+1)-QX(J+1))**2+(QX(I+2)-QX(J+2))**2+(QX(I+3)-QX(J+3))**2)#   QN54  31
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN54  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN54  33
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN54A,NQN54A,3,4) ; LINRM=3#     QN54  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN54  35
ZCHAIN=.FALSE.## Check potential intra-residue and link contacts        QN54  36
DO ICHAIN=1,NTCHAN#                                                     QN54  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN54  38
ICH=ICHTYP(ICHAIN) ; IRESN=IREST(2*(ICH-1)+1)#                          QN54  39
IRESC=IREST(2*(ICH-1)+2) ; IACIDC=IACIDT(2*(ICH-1)+2)#                  QN54  40
IRESMX=KRESMX(ICHAIN)#                                                  QN54  41
IF(ICHAIN>NCHAIN) ZCHAIN=.TRUE.#                                        QN54  42
IZCHAN=MOTHRZ(ICHAIN)#                                                  QN54  43
DO IRES=IRESN,IRESMX#                  Loop over residues               QN54  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN54  45
ZLINK=.FALSE.#                                                          QN54  46
IF(IRES!=IRESN)#                                                        QN54  47
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN54  48
IF(ZMAIN(IRES-1,ICHAIN)&!ZMAIN(IRES,ICHAIN)) ZLINK=.TRUE.#              QN54  49
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN54  50
IF(ZCHAIN&(!ZLINK))#                                                    QN54  51
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN54  52
IF(ICENTR(IRES,ICHAIN)==0) NEXT#                                        QN54  53
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN54  54
IACID=IDACD(IRES,ICHAIN) ; ND=NVDWS(IACID)#                             QN54  55
IF(ND!=0)#                                                              QN54  56
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN54  57
DO IDIST=1,ND#                         Intra-residue contacts           QN54  58
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN54  59
IATOM=IVDW(IACID,IDIST) ; IA=NOAT(IATOM,IRES,ICHAIN)#                   QN54  60
JATOM=JVDW(IACID,IDIST) ; JA=NOAT(JATOM,IRES,ICHAIN)#                   QN54  61
IF(ZCHAIN)#                                                             QN54  62
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN54  63
IF(IA<=0&JA<=0) NEXT#                                                   QN54  64
compchar:(IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,IHD,1,1,1,NIHD,K)#        QN54  65
IF(IA<=0&K==0) IA=NOAT(IATOM,IRES,IZCHAN)#                              QN54  66
compchar:(IDS,(IACID-1)*qmxat4:+(JATOM-1)*4+1,IHD,1,1,1,NIHD,K)#        QN54  67
IF(JA<=0&K==0) JA=NOAT(JATOM,IRES,IZCHAN)#                              QN54  68
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN54  69
IF(IA<=0\JA<=0) NEXT#                                                   QN54  70
IAA=(IA-1)*STEPA+MARKA ; JAA=(JA-1)*STEPA+MARKA#                        QN54  71
DISTO=DISIJ(IAA,JAA)#                                                   QN54  72
IF((DISTO>=VDWCUT)\(IAA==JAA)) NEXT#                                    QN54  73
NOVDW=NOVDW+1#                                                          QN54  74
#                                                                       QN54  75
#    WRITE OUT A PACKET WITH A VAN DER WAALS DISTANCE RESTRAINT         QN54  76
#    ----------------------------------------------------------         QN54  77
#                                                                       QN54  78
CALL QN09(IA,JA,DNBC(IACID,IDIST),KTYP(IACID,IDIST))#                   QN54  79
movechar:(BLANK,1,ISTAR,1,1,1) ; ABSDEL=DNBC(IACID,IDIST)-DISTO#        QN54  80
IF(ABSDEL>0.0) NONOW=NONOW+1#                                           QN54  81
IF(ABSDEL>0.50) movechar:(STAR,1,ISTAR,1,NSTAR,1)#                      QN54  82
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN54  83
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN54  84
BUFOT(1)=FLOAT(NOVDW) ; BUFOT(2)=FLOAT(IA) ; BUFOT(3)=FLOAT(IRES)#      QN54  85
BUFOT(4)=FLOAT(JA) ; BUFOT(5)=FLOAT(IRES)#                              QN54  86
BUFOT(6)=DNBC(IACID,IDIST) ; BUFOT(7)=DISTO#                            QN54  87
BUFOT(8)=FLOAT(KTYP(IACID,IDIST))#                                      QN54  88
ncodefld:(BUFOT,1,CHROT,FMTO,8); movechar:(ISTAR,1,CHROT,69,1,0)#       QN54  89
IAA=(IA-1)*STEPA+MARKA ; movertoc:(QX(IAA+5),1,CHROT,14,4,0)#           QN54  90
JAA=(JA-1)*STEPA+MARKA ; movertoc:(QX(JAA+5),1,CHROT,41,4,0)#           QN54  91
movechar:(NAMES,4*(IACID-1)+1,CHROT,34,4,0)#                            QN54  92
movechar:(NAMES,4*(IACID-1)+1,CHROT,62,4,0)#                            QN54  93
writeline:(0,QN54B,NQN54B,1,4)#                                         QN54  94
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN54  95
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN54  96
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN54  97
IF(IRES==IRESN\IRES>IRESC) NEXT## LINK CONTACTS BETW'N ADJACENT RESID   QN54  98
LINK=NACIDT+1#                                                          QN54  99
IF(IACID==15) LINK=NACIDT+3#           ******bad news bear!!!!!!!!!!    QN54 100
IF(IRES==IRESC&IACIDC==15) LINK=NACIDT+3# ******bad news bear!!!!!!!!   QN54 101
ND=NVDWS(LINK) ; JRES=IRES-1#                                           QN54 102
JACID=IDACD(JRES,ICHAIN)#                                               QN54 103
DO IDIST=1,ND#                                                          QN54 104
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN54 105
IATOM=IVDW(LINK,IDIST) ; IA=NOAT(IATOM,IRES,ICHAIN)#                    QN54 106
JATOM=JVDW(LINK,IDIST) ; JA=NOAT(JATOM,JRES,ICHAIN)#                    QN54 107
IF(ZCHAIN)#                                                             QN54 108
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN54 109
IF(IA<=0&JA<=0) NEXT#                                                   QN54 110
compchar:(IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,IHD,1,1,1,NIHD,K)#        QN54 111
IF(IA<=0&K==0) IA=NOAT(IATOM,IRES,IZCHAN)#                              QN54 112
compchar:(IDS,(JACID-1)*qmxat4:+(JATOM-1)*4+1,IHD,1,1,1,NIHD,K)#        QN54 113
IF(JA<=0&K==0) JA=NOAT(JATOM,IRES,IZCHAN)#                              QN54 114
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN54 115
IF(IA<=0\JA<=0) NEXT#                                                   QN54 116
IAA=(IA-1)*STEPA+MARKA ; movertoc:(QX(IAA+5),1,ATNAM,1,4,0)#            QN54 117
compchar:(ATNAM,1,ICB,1,4,4,NICB,K)#                                    QN54 118
IF(IRES==IRESC&IATOM==ISID1&K==0) NEXT#                                 QN54 119
JAA=(JA-1)*STEPA+MARKA ; movertoc:(QX(IAA+5),1,ATNAM,1,4,0)#            QN54 120
compchar:(ATNAM,1,ICB,1,4,4,NICB,K)#                                    QN54 121
IF((JRES==IRESN&JATOM==ISID1&K==0)\(IAA==JAA)) NEXT#                    QN54 122
DISTO=DISIJ(IAA,JAA)#                                                   QN54 123
IF(DISTO>=VDWCUT) NEXT#                                                 QN54 124
NOVDW=NOVDW+1#                                                          QN54 125
DISV=DVDW(KS(IACID,IATOM),KS(IDACD(JRES,ICHAIN),JATOM))#                QN54 126
#                                                                       QN54 127
#    WRITE OUT A PACKET WITH A VAN DER WAALS DISTANCE RESTRAINT         QN54 128
#    ----------------------------------------------------------         QN54 129
#                                                                       QN54 130
CALL QN09(IA,JA,DISV,KTYP(LINK,IDIST))#                                 QN54 131
movechar:(BLANK,1,ISTAR,1,1,1) ; ABSDEL=DISV-DISTO#                     QN54 132
IF(ABSDEL>0.0) NONOW=NONOW+1#                                           QN54 133
IF(ABSDEL>0.50) movechar:(STAR,1,ISTAR,1,NSTAR,1)#                      QN54 134
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN54 135
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN54 136
BUFOT(1)=FLOAT(NOVDW) ; BUFOT(2)=FLOAT(IA) ; BUFOT(3)=FLOAT(IRES)#      QN54 137
BUFOT(4)=FLOAT(JA) ; BUFOT(5)=FLOAT(JRES)#                              QN54 138
BUFOT(6)=DISV ; BUFOT(7)=DISTO#                                         QN54 139
BUFOT(8)=FLOAT(KTYP(LINK,IDIST))#                                       QN54 140
ncodefld:(BUFOT,1,CHROT,FMTO,8); movechar:(ISTAR,1,CHROT,69,1,0)#       QN54 141
movechar:(TO,1,CHROT,38,NTO,0)#                                         QN54 142
IAA=(IA-1)*STEPA+MARKA ; movertoc:(QX(IAA+5),1,CHROT,14,4,0)#           QN54 143
JAA=(JA-1)*STEPA+MARKA ; movertoc:(QX(JAA+5),1,CHROT,41,4,0)#           QN54 144
movechar:(NAMES,4*(IACID-1)+1,CHROT,34,4,0)#                            QN54 145
movechar:(NAMES,4*(JACID-1)+1,CHROT,62,4,0)#                            QN54 146
writeline:(0,QN54B,NQN54B,1,4)#                                         QN54 147
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN54 148
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN54 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN54 150
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN54 151
RETURN#                                                                 QN54 152
END#                                                                    QN54 153
systemheader:(QN55)## Find special contact distances and write as vdW   QN55   1
####################################################################    QN55   2
#                                                                  #    QN55   3
#                                QN55                              #    QN55   4
#                                                                  #    QN55   5
####################################################################    QN55   6
SUBROUTINE QN55#                                                        QN55   7
#                                                                       QN55   8
include:(AACOMN)#                                                       QN55   9
include:(QNCOMN)#                                                       QN55  10
#                                                                       QN55  11
#----SORT THE SPECIAL INTER-GROUP DISTANCES FOR CONTACTS EXCLUSION      QN55  12
#     SUBROUTINE SDSORT (IEOFIN)                                        QN55  13
#                                                                       QN55  14
chardata:(QN55A, -----SPECIAL INTER-GROUP DISTANCES----- )#             QN55  15
chardata:(QN55B, PT1 RES1 AT1 PT2 RES2 AT2)#                            QN55  16
realdata:(FMT1,[50313.,90413.,130413.,170313.,210413.,250413.])#        QN55  17
intdata:(K15,[32768])#                                                  QN55  18
datastuff:#                                                             QN55  19
IF(LINID==32)#                                                          QN55  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN55  21
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN55  22
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN55  23
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN55A,NQN55A,3,4) ; LINRM=3#     QN55  24
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN55  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN55  26
NPR=(NTCHAN*(NTCHAN-1))/2#             Initialize                       QN55  27
IF(LINID<32) iquit:(QN5513)#           Input line order error           QN55  28
#                                                                       QN55  29
#----ADDITIONAL SPECIAL DISTANCES, E.G. BETWEEN WATER ATOM AND          QN55  30
#----DISCRETE DISORDER CONFORMER ATOM                                   QN55  31
REPEAT#                                                                 QN55  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN55  33
IF(LINID>32) BREAK#                    Look for an excon line           QN55  34
CALL QN12(1,ICH) ; CALL QN12(2,IRES)#  Get chain and residue pointers   QN55  35
IATOM=NINT(AMAX1(0.0,BUFIN(3)))#       Get atom order number atom 1     QN55  36
CALL QN12(1,JCH) ; CALL QN12(2,JRES)#  Get chain and residue pointers   QN55  37
JATOM=NINT(AMAX1(0.0,BUFIN(6)))#       Get atom order number atom 2     QN55  38
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN55  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN55  40
BUFOT(1)=FLOAT(ICH) ; BUFOT(2)=FLOAT(IRES) ; BUFOT(3)=FLOAT(IATOM)#     QN55  41
BUFOT(4)=FLOAT(JCH) ; BUFOT(5)=FLOAT(JRES) ; BUFOT(6)=FLOAT(JATOM)#     QN55  42
ncodefld:(BUFOT,1,CHROT,FMT1,6) ; writeline:(0,QN55B,NQN55B,1,4)#       QN55  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN55  44
IPR=((ICH-1)*(2*NTCHAN-ICH))/2+(JCH-ICH)#                               QN55  45
#                                                                       QN55  46
#----SAVE DISTANCE IDENTIFIERS FOR CONTACT EXCLUSION                    QN55  47
IPACK1=IRES*K15+JRES ; IPACK2=IATOM*K15+JATOM#                          QN55  48
IF(ICH==JCH)#                                                           QN55  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN55  50
IF(IRES>JRES)#                         Intra-chain distance             QN55  51
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN55  52
IPACK1=JRES*K15+IRES ; IPACK2=JATOM*K15+IATOM#                          QN55  53
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN55  54
NDIG(ICH)=NDIG(ICH)+1#                                                  QN55  55
IF(NDIG(ICH)>qmxdig:) iquit:(QN5501)#  Out of room                      QN55  56
IGDIST(NDIG(ICH),ICH)=IPACK1 ; IGDIS2(NDIG(ICH),ICH)=IPACK2#            QN55  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN55  58
ELSE#                                  Inter-chain distance             QN55  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN55  60
NDIC(IPR)=NDIC(IPR)+1#                                                  QN55  61
IF(NDIC(IPR)>qmxdic:) iquit:(QN5501)#  Out of room                      QN55  62
ICDIST(NDIC(IPR),IPR)=IPACK1 ; ICDIS2(NDIC(IPR),IPR)=IPACK2#            QN55  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN55  64
readline:(INLINE,NLINEC)#              Bring in next input line         QN55  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN55  66
DO ICH=1,NCHTYP#                       Sort intra-chain distances       QN55  67
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN55  68
NGD=NDIG(ICH)#                                                          QN55  69
IF(NGD==0) NEXT#                                                        QN55  70
DO I=1,NGD#                                                             QN55  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN55  72
DO J=I,NGD#                                                             QN55  73
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN55  74
IF(I==J) NEXT#                                                          QN55  75
IF(IGDIST(I,ICH)<IGDIST(J,ICH)) NEXT#                                   QN55  76
IF((IGDIST(I,ICH)==IGDIST(J,ICH)) & $#                                  QN55  77
(IGDIS2(I,ICH)<IGDIS2(J,ICH))) NEXT#                                    QN55  78
ITEMP=IGDIST(I,ICH) ; ITEM2=IGDIS2(I,ICH)#                              QN55  79
IGDIST(I,ICH)=IGDIST(J,ICH) ; IGDIS2(I,ICH)=IGDIS2(J,ICH)#              QN55  80
IGDIST(J,ICH)=ITEMP ; IGDIS2(J,ICH)=ITEM2#                              QN55  81
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN55  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN55  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN55  84
DO IPR=1,NPR#                          Sort inter-chain distances       QN55  85
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN55  86
NGD=NDIC(IPR)#                                                          QN55  87
IF(NGD==0) NEXT#                                                        QN55  88
DO I=1,NGD#                                                             QN55  89
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN55  90
DO J=I,NGD#                                                             QN55  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN55  92
IF(I==J) NEXT#                                                          QN55  93
IF(ICDIST(I,IPR)<ICDIST(J,IPR)) NEXT#                                   QN55  94
IF((ICDIST(I,IPR)==ICDIST(J,IPR)) & $#                                  QN55  95
(ICDIS2(I,IPR)<ICDIS2(J,IPR))) NEXT#                                    QN55  96
ITEMP=ICDIST(I,IPR) ; ITEM2=ICDIS2(I,IPR)#                              QN55  97
ICDIST(I,IPR)=ICDIST(J,IPR) ; ICDIS2(I,IPR)=ICDIS2(J,IPR)#              QN55  98
ICDIST(J,IPR)=ITEMP ; ICDIS2(J,IPR)=ITEM2#                              QN55  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN55 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN55 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN55 102
RETURN#                                                                 QN55 103
END#                                                                    QN55 104
systemheader:(QN56)## Search for van der Waal's contacts                QN56   1
####################################################################    QN56   2
#                                                                  #    QN56   3
#                                QN56                              #    QN56   4
#                                                                  #    QN56   5
####################################################################    QN56   6
SUBROUTINE QN56#                                                        QN56   7
#                                                                       QN56   8
include:(AACOMN)#                                                       QN56   9
include:(QNCOMN)#                                                       QN56  10
#                                                                       QN56  11
#----PREPARE TABLE OF POSSIBLE VAN DER WAALS BETWEEN RESIDUE CONTACTS   QN56  12
#     SUBROUTINE VDWBTR (NOVDW,NONOW,IHATOM,ISID1,VDWCUT)               QN56  13
#                                                                       QN56  14
LOGICAL ZCHAIN,ZCHILD#                                                  QN56  15
string:(ISTAR,1)#                                                       QN56  16
string:(NAME,4)#                                                        QN56  17
chardata:(ICB,CB  )#                                                    QN56  18
chardata:(ICD,CD  )#                                                    QN56  19
chardata:(DISOR,DIS )#                                                  QN56  20
chardata:(STAR,*)#                                                      QN56  21
intdata:(K15,[32768])#                                                  QN56  22
chardata:(QN56A, -----POSSIBLE VAN DER WAALS BETWEEN RESIDUE $#         QN56  23
CONTACTS----- )#                                                        QN56  24
chardata:(QN56B,CONTACT NO.  ATOM AT NO.         RESID  ATOM AT $#      QN56  25
NO.            RESID  IDEAL DIST  OBSERVED   CONSTRAINT)#               QN56  26
realdata:(FMTO,[120613.,240613.,320613.,510613.,590613.,740832.,$#      QN56  27
840832.,900413.])#                                                      QN56  28
datastuff:#                                                             QN56  29
#                                                                       QN56  30
#----INTERATOMIC DISTANCE FUNCTION                                      QN56  31
DISIJ(I,J)=$#                                                           QN56  32
SQRT((QX(I+1)-QX(J+1))**2+(QX(I+2)-QX(J+2))**2+(QX(I+3)-QX(J+3))**2)#   QN56  33
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN56  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN56  35
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN56A,NQN56A,3,4) ; LINRM=3#     QN56  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN56  37
IHIT=no: ; ZCHAIN=.FALSE.#             Initialize                       QN56  38
DO ICHAIN=1,NTCHAN## Check for possible inter-residue contacts          QN56  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN56  40
ICH=ICHTYP(ICHAIN) ; IRESN=IREST(2*(ICH-1)+1)#                          QN56  41
IRESC=IREST(2*(ICH-1)+2) ; IRESMX=KRESMX(ICHAIN)#                       QN56  42
NGD=NDIG(ICH) ; IF(ICHAIN>NCHAIN) ZCHAIN=.TRUE.#                        QN56  43
DO JCHAIN=ICHAIN,NTCHAN#               Need contact only one directio   QN56  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN56  45
JCH=ICHTYP(JCHAIN) ; JRESN=IREST(2*(JCH-1)+1)#                          QN56  46
JRESC=IREST(2*(JCH-1)+2) ; JRESMX=KRESMX(JCHAIN)#                       QN56  47
IPR=((ICHAIN-1)*(2*NTCHAN-ICHAIN))/2+(JCHAIN-ICHAIN)#                   QN56  48
IF(JCHAIN!=ICHAIN) NGD=NDIC(IPR) ; IGD=1#                               QN56  49
DO IRES=IRESN,IRESMX#                  Loop over first chains' residu   QN56  50
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN56  51
IF(ICENTR(IRES,ICHAIN)==0) NEXT#                                        QN56  52
DO JRES=JRESN,JRESMX#                  Loop over second chains' resid   QN56  53
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN56  54
IF(ICENTR(JRES,JCHAIN)==0) NEXT#                                        QN56  55
ZCHILD=.FALSE.#                                                         QN56  56
#                                                                       QN56  57
#----DETERMINE IF THIS IS A CONTACT BETWEEN A MOTHER RESIDUE WITH A     QN56  58
#---- DISORDER MATE AND A DISORDER RESIDUE OF SECOND CHAIN              QN56  59
IF(JCHAIN>NCHAIN)#                                                      QN56  60
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN56  61
IF(ICHAIN!=JCHAIN)#                                                     QN56  62
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN56  63
IF(MOTHRZ(ICHAIN)==MOTHRZ(JCHAIN))#                                     QN56  64
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN56  65
IHIT=no:#                                                               QN56  66
DO KCHAIN=1,NTCHAN#                                                     QN56  67
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN56  68
IF(MOTHRZ(KCHAIN)==KCHAIN) NEXT#                                        QN56  69
IF(MOTHRZ(ICHAIN)!=MOTHRZ(KCHAIN)) NEXT#                                QN56  70
IF(ICENTR(IRES,KCHAIN)!=0)#                                             QN56  71
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN56  72
IHIT=yes: ; BREAK#                                                      QN56  73
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN56  74
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN56  75
IF(IHIT==yes:) NEXT#                                                    QN56  76
ZCHILD=.TRUE.#                                                          QN56  77
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN56  78
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN56  79
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN56  80
NABORS=0#                              Det'n if resid's are neighbors   QN56  81
IF(ZCHILD\JCHAIN==ICHAIN)#                                              QN56  82
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN56  83
IF(!ZCHILD&JRES<=IRES) NEXT#                                            QN56  84
IF(IRES<IRESC&IABS(JRES-IRES)==1) NABORS=1#                             QN56  85
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN56  86
#----SKIP CONTACTS FOR DISORDER GROUPS                                  QN56  87
IACID=IDACD(IRES,ICHAIN) ; JACID=IDACD(JRES,JCHAIN)#                    QN56  88
compchar:(NAMES,4*(IACID-1)+1,DISOR,1,4,4,NDISOR,K)#                    QN56  89
compchar:(NAMES,4*(JACID-1)+1,DISOR,1,4,4,NDISOR,L)#                    QN56  90
IF(K!=0\L!=0) NEXT#                                                     QN56  91
#----SKIP IF INTER-CENTROID DISTANCE OBVIATES POSSIBLE CONTACT          QN56  92
IA=ICENTR(IRES,ICHAIN) ; JA=ICENTR(JRES,JCHAIN)#                        QN56  93
IAA=(IA-1)*STEPA+MARKA ; JAA=(JA-1)*STEPA+MARKA#                        QN56  94
DISTO=DISIJ(IAA,JAA)#                                                   QN56  95
IF(DISTO>RADIUS(IRES,ICHAIN)+RADIUS(JRES,JCHAIN)+VDWCUT) NEXT#          QN56  96
#----COMPARE ALL THE ATOM-PAIRS OF THIS RESIDUE-PAIR                    QN56  97
IAN=NATOMS(IACID) ; JAN=NATOMS(JACID)#                                  QN56  98
DO IATOM=1,IAN#                                                         QN56  99
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN56 100
IHIT=no:#                                                               QN56 101
DO JATOM=1,JAN#                                                         QN56 102
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN56 103
#----SKIP IF IN MAIN-CHAIN LINK OF NEIGHBORING RESIDUES                 QN56 104
IF(NABORS!=0)#                                                          QN56 105
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN56 106
compchar:(IDS,(IACID-1)*qmxat4:+(IATOM-1)*4+1,ICB,1,4,4,NICB,K)#        QN56 107
IF(IRES!=IRESN\IATOM!=ISID1\K!=0)#                                      QN56 108
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN56 109
compchar:(IDS,(JACID-1)*qmxat4:+(JATOM-1)*4+1,ICB,1,4,4,NICB,K)#        QN56 110
IF(JRES!=JRESC\JATOM!=ISID1\K!=0)#                                      QN56 111
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN56 112
IF(IATOM<=ISID1&JATOM<=ISID1) NEXT#                                     QN56 113
IF(JACID==15)#                         ******bad news bear!!!!!!!!!!    QN56 114
$(#                                    9>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN56 115
JA=NOAT(JATOM,JRES,JCHAIN)#                                             QN56 116
IF(JA<=0) NEXT#                                                         QN56 117
JAA=(JA-1)*STEPA+MARKA#                                                 QN56 118
movertoc:(QX(JAA+5),1,NAME,1,4,0)#     Get atom name                    QN56 119
compchar:(NAME,1,ICD,1,4,4,NICD,K)#    See if it is 'cd  '              QN56 120
IF(K!=0&IATOM<=ISID1) NEXT#                                             QN56 121
$)#                                    9<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN56 122
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN56 123
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN56 124
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN56 125
IA=NOAT(IATOM,IRES,ICHAIN) ; IF(IA<=0) NEXT# Distance check             QN56 126
JA=NOAT(JATOM,JRES,JCHAIN) ; IF(JA<=0) NEXT#                            QN56 127
IAA=(IA-1)*STEPA+MARKA ; JAA=(JA-1)*STEPA+MARKA#                        QN56 128
DISTO=DISIJ(IAA,JAA) ; IF(DISTO>=VDWCUT) NEXT#                          QN56 129
IF(IGD<=NGD)## Skip if this is a special inter-group distance           QN56 130
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN56 131
IPACK1=IRES*K15+JRES ; IPACK2=IATOM*K15+JATOM ; IHIT=no:#               QN56 132
REPEAT#                                                                 QN56 133
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN56 134
IF(JCHAIN!=ICHAIN)#                                                     QN56 135
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN56 136
IF(IPACK1<ICDIST(IGD,IPR)) BREAK#                                       QN56 137
IF(IPACK1>ICDIST(IGD,IPR))#                                             QN56 138
$(#                                    9>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QN56 139
IGD=IGD+1 ; NEXT#                                                       QN56 140
$)#                                    9<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QN56 141
IF(IPACK2<ICDIS2(IGD,IPR)) BREAK#                                       QN56 142
IF(IPACK2==ICDIS2(IGD,IPR))#                                            QN56 143
$(#                                    9>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QN56 144
IGD=IGD+1 ; IHIT=yes: ; BREAK#                                          QN56 145
$)#                                    9<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QN56 146
IGD=IGD+1 ; NEXT#                                                       QN56 147
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN56 148
IF(IPACK1<IGDIST(IGD,ICH)) BREAK#      Intra-chain distances            QN56 149
IF(IPACK1>IGDIST(IGD,ICH))#                                             QN56 150
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QN56 151
IGD=IGD+1 ; NEXT#                                                       QN56 152
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QN56 153
IF(IPACK2<IGDIS2(IGD,ICH)) BREAK#                                       QN56 154
IF(IPACK2==IGDIS2(IGD,ICH))#                                            QN56 155
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QN56 156
IGD=IGD+1 ; IHIT=yes: ; BREAK#                                          QN56 157
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QN56 158
IGD=IGD+1#                                                              QN56 159
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN56 160
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN56 161
IF(IHIT==yes:) NEXT#                                                    QN56 162
#                                                                       QN56 163
#----FIND THIS VAN DER WAALS CONTACT DISTANCE                           QN56 164
#CALL VDWTYP (IACID,IATOM,IRES,ICHAIN,IRESC,JACID,JATOM,JRES,           QN56 165
#     $ JCHAIN,JRESC,IHATOM,LTYP,DISV)                                  QN56 166
CALL QN02(IACID,IATOM,IRES,ICHAIN,IRESC,JACID,JATOM,JRES,#              QN56 167
JCHAIN,JRESC,LTYP,DISV)#                                                QN56 168
NOVDW=NOVDW+1#                         Listing                          QN56 169
#                                                                       QN56 170
#    WRITE OUT A PACKET WITH A VAN DER WAALS DISTANCE RESTRAINT         QN56 171
#    ----------------------------------------------------------         QN56 172
#                                                                       QN56 173
CALL QN09(IA,JA,DISV,LTYP)#                                             QN56 174
movechar:(BLANK,1,ISTAR,1,1,1) ; ABSDEL=DISV-DISTO#                     QN56 175
IF(ABSDEL>0.0) NONOW=NONOW+1#                                           QN56 176
IF(ABSDEL>0.50) movechar:(STAR,1,ISTAR,1,NSTAR,1)#                      QN56 177
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN56 178
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QN56 179
BUFOT(1)=FLOAT(NOVDW) ; BUFOT(2)=FLOAT(IA) ; BUFOT(3)=FLOAT(IRES)#      QN56 180
BUFOT(4)=FLOAT(JA) ; BUFOT(5)=FLOAT(JRES)#                              QN56 181
BUFOT(6)=DISV ; BUFOT(7)=DISTO#                                         QN56 182
BUFOT(8)=FLOAT(LTYP)#                                                   QN56 183
ncodefld:(BUFOT,1,CHROT,FMTO,8); movechar:(ISTAR,1,CHROT,69,1,0)#       QN56 184
IAA=(IA-1)*STEPA+MARKA ; movertoc:(QX(IAA+5),1,CHROT,14,4,0)#           QN56 185
JAA=(JA-1)*STEPA+MARKA ; movertoc:(QX(JAA+5),1,CHROT,41,4,0)#           QN56 186
movechar:(NAMES,4*(IACID-1)+1,CHROT,34,4,0)#                            QN56 187
movechar:(NAMES,4*(IACID-1)+1,CHROT,62,4,0)#                            QN56 188
writeline:(0,QN56B,NQN56B,1,4)#                                         QN56 189
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QN56 190
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN56 191
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN56 192
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN56 193
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN56 194
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN56 195
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN56 196
RETURN#                                                                 QN56 197
END#                                                                    QN56 198
systemheader:(QN61)## Check for contacts through space group symmetry   QN61   1
####################################################################    QN61   2
#                                                                  #    QN61   3
#                                QN61                              #    QN61   4
#                                                                  #    QN61   5
####################################################################    QN61   6
SUBROUTINE QN61#                                                        QN61   7
#                                                                       QN61   8
include:(AACOMN)#                                                       QN61   9
include:(QNCOMN)#                                                       QN61  10
#                                                                       QN61  11
#----DETERMINE WHICH SYMMETRY RELATED MOLECULES MIGHT BE CONTACTS       QN61  12
#     SUBROUTINE MOLDST (VDWCUT)                                        QN61  13
#                                                                       QN61  14
REAL TXYZ(3),RSYMI(3,3),TSYMI(3),TCEN(3),TCEN2(3)#                      QN61  15
REAL RSYM(3,3),TSYM(3),RSYMO(3,3),TSYMO(3)#                             QN61  16
NSYMC=0 ; ISTAR=1 ; ISTOP=2*NCELL+1 ; IOFF=NCELL+1# Initialize          QN61  17
DO I=1,qmxsym:#                        Initialize arrays                QN61  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN61  19
DO J=1,4#                                                               QN61  20
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN61  21
ICODE (J,I)=0 ; ICODEI(J,I)=0#                                          QN61  22
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN61  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN61  24
DO IS=1,NSYMOP## Loop over crystallographic operators                   QN61  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN61  26
ISA=(IS-1)*STEPS+MARKS#                                                 QN61  27
RSYM(1,1)=QX(ISA+1);RSYM(1,2)=QX(ISA+4);RSYM(1,3)=QX(ISA+7)#            QN61  28
RSYM(2,1)=QX(ISA+2);RSYM(2,2)=QX(ISA+5);RSYM(2,3)=QX(ISA+8)#            QN61  29
RSYM(3,1)=QX(ISA+3);RSYM(3,2)=QX(ISA+6);RSYM(3,3)=QX(ISA+9)#            QN61  30
TSYM(1)=QX(ISA+10);TSYM(2)=QX(ISA+11);TSYM(3)=QX(ISA+12)#               QN61  31
DO IX=ISTAR,ISTOP## Loop over unit cell translations                    QN61  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN61  33
TXYZ(1)=FLOAT(IX-IOFF)#                                                 QN61  34
DO IY=ISTAR,ISTOP#                                                      QN61  35
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN61  36
TXYZ(2)=FLOAT(IY-IOFF)#                                                 QN61  37
DO IZ=ISTAR,ISTOP#                                                      QN61  38
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN61  39
TXYZ(3)=FLOAT(IZ-IOFF)#                                                 QN61  40
#                                                                       QN61  41
#----TEST FOR THE IDENTITY ROTATION AND ALL ZERO TRANSLATIONS           QN61  42
#                                                                       QN61  43
IF((IS==1)&((IX-IOFF)==0)&((IY-IOFF)==0)&$#                             QN61  44
((IZ-IOFF)==0)) NEXT#                  Exclude unitary operator         QN61  45
#                                                                       QN61  46
#----COMPARE CURRENT OPERATOR WITH ALREADY DETERMINED OPERATORS         QN61  47
IF(NSYMC!=0)#                                                           QN61  48
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN61  49
IHIT=no:#                                                               QN61  50
DO JS=1,NSYMC#                                                          QN61  51
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN61  52
IHIT1=no:#                                                              QN61  53
IF(IS!=ICODEI(1,JS)) NEXT#                                              QN61  54
DO I=1,3#                                                               QN61  55
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN61  56
IF(NINT(TXYZ(I))!=ICODEI(I+1,JS))#                                      QN61  57
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN61  58
IHIT1=yes: ; BREAK#                                                     QN61  59
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN61  60
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN61  61
IF(IHIT1==yes:) NEXT#                                                   QN61  62
IHIT=yes: ; BREAK#                                                      QN61  63
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN61  64
IF(IHIT==yes:)NEXT#                                                     QN61  65
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN61  66
DO ICHAIN=1,NCHAIN#                    Loop over first chain            QN61  67
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN61  68
IA=ICHCEN(ICHAIN);IAA=(IA-1)*STEPA+MARKA#                               QN61  69
TCEN(1)=OIXX*QX(IAA+1)+OIXY*QX(IAA+2)+OIXZ*QX(IAA+3)# Make x fraction   QN61  70
TCEN(2)=               OIYY*QX(IAA+2)+OIYZ*QX(IAA+3)# Make y fraction   QN61  71
TCEN(3)=                              OIZZ*QX(IAA+3)# Make z fraction   QN61  72
DO I=1,3## Perform symmetry transformation on first center              QN61  73
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN61  74
TCEN2(I)=TSYM(I)+TXYZ(I)#                                               QN61  75
DO J=1,3#                                                               QN61  76
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN61  77
TCEN2(I)=TCEN2(I)+RSYM(I,J)*TCEN(J)#                                    QN61  78
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN61  79
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN61  80
#                                                                       QN61  81
#----ORTHOGONALIZE THE SYMMETRY-RELATED FIRST CENTER                    QN61  82
TCEN(1)=ORXX*TCEN2(1)+ORXY*TCEN2(2)+ORXZ*TCEN2(3)#                      QN61  83
TCEN(2)=              ORYY*TCEN2(2)+ORYZ*TCEN2(3)#                      QN61  84
TCEN(3)=                            ORZZ*TCEN2(3)#                      QN61  85
DO JCHAIN=1,NCHAIN#                    Loop over second chain           QN61  86
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN61  87
JA=ICHCEN(JCHAIN) ; JAA=(JA-1)*STEPA+MARKA#                             QN61  88
#                                                                       QN61  89
#----DETERMINE DISTANCE BETWEEN CENTERS                                 QN61  90
DOBS=SQRT((TCEN(1)-QX(JAA+1))**2+(TCEN(2)-QX(JAA+2))**2$#               QN61  91
+(TCEN(3)-QX(JAA+3))**2)-RADCHN(ICHAIN)-RADCHN(JCHAIN)#                 QN61  92
IF(DOBS>VDWCUT) NEXT#                                                   QN61  93
#                                                                       QN61  94
#----MAKE SURE WE HAVE NOT EXCEEDED MAXIMUM NUMBER OF OPERATORS         QN61  95
NSYMC=NSYMC+1#                                                          QN61  96
IF(NSYMC>qmxsym:)#                                                      QN61  97
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN61  98
iquit:(QN6101)#                        Too many symops                  QN61  99
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN61 100
#                                                                       QN61 101
#----ADD A NEW OPERATOR TO THE LIST                                     QN61 102
ICODE(1,NSYMC)=IS ; ICODE(2,NSYMC)=NINT(TXYZ(1))#                       QN61 103
ICODE(3,NSYMC)=NINT(TXYZ(2)) ; ICODE(4,NSYMC)=NINT(TXYZ(3))#            QN61 104
#                                                                       QN61 105
#----DETERMINE INVERSE OF CURRENT OPERATION                             QN61 106
#    CALL MATIN3 (RSYM(1,1,IS),RSYMI)                                   QN61 107
CALL QN62(RSYM(1,1),RSYMI)#                                             QN61 108
DO I=1,3#                                                               QN61 109
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN61 110
TSYMI(I)=0.0#                                                           QN61 111
DO J=1,3 ; TSYMI(I)=TSYMI(I)-RSYMI(I,J)*(TSYM(J)+TXYZ(J))#              QN61 112
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN61 113
#                                                                       QN61 114
#----COMPARE OPERATOR INVERSE WITH BASIC OPERATORS                      QN61 115
#                                                                       QN61 116
DO KZ=1,NSYMOP#                                                         QN61 117
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN61 118
KZA=(KZ-1)*STEPS+MARKS#                                                 QN61 119
RSYMO(1,1)=QX(KZA+1);RSYMO(1,2)=QX(KZA+4);RSYMO(1,3)=QX(KZA+7)#         QN61 120
RSYMO(2,1)=QX(KZA+2);RSYMO(2,2)=QX(KZA+5);RSYMO(2,3)=QX(KZA+8)#         QN61 121
RSYMO(3,1)=QX(KZA+3);RSYMO(3,2)=QX(KZA+6);RSYMO(3,3)=QX(KZA+9)#         QN61 122
TSYMO(1)=QX(KZA+10);TSYMO(2)=QX(KZA+11);TSYMO(3)=QX(KZA+12)#            QN61 123
DEL=0.0 ; IHIT=no:#                                                     QN61 124
DO I=1,3#                                                               QN61 125
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN61 126
IF(AMOD(ABS(TSYMI(I)-TSYMO(I)),1.0)>=0.001)#                            QN61 127
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN61 128
IHIT=yes: ; BREAK#                                                      QN61 129
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN61 130
DO J=1,3 ; DEL=DEL+ABS(RSYMO(I,J)-RSYMI(I,J))#                          QN61 131
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN61 132
IF(IHIT==yes:) NEXT#                                                    QN61 133
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN61 134
IF(DEL<0.001)#                         This is the inverse of operato   QN61 135
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QN61 136
ICODEI(1,NSYMC)=KZ ; ICODEI(2,NSYMC)=NINT(TSYMI(1)-TSYMO(1))#           QN61 137
ICODEI(3,NSYMC)=NINT(TSYMI(2)-TSYMO(2))#                                QN61 138
ICODEI(4,NSYMC)=NINT(TSYMI(3)-TSYMO(3))#                                QN61 139
GO TO 2870#                                                             QN61 140
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QN61 141
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN61 142
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN61 143
#----END OF CHAIN LOOPS                                                 QN61 144
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN61 145
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN61 146
#----END OF UNIT TRANSLATION LOOPS                                      QN61 147
2870 CONTINUE#                                                          QN61 148
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN61 149
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN61 150
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN61 151
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN61 152
RETURN#                                                                 QN61 153
END#                                                                    QN61 154
systemheader:(QN62)## Invert 3X3 matrix                                 QN62   1
####################################################################    QN62   2
#                                                                  #    QN62   3
#                                QN62                              #    QN62   4
#                                                                  #    QN62   5
####################################################################    QN62   6
SUBROUTINE QN62(AA,BB)#                                                 QN62   7
#                                                                       QN62   8
#----INVERT A 3X3 MATRIX                                                QN62   9
#     SUBROUTINE MATIN3(AA,BB)                                          QN62  10
#                                                                       QN62  11
REAL AA(3,3),BB(3,3)#                                                   QN62  12
#                                                                       QN62  13
#----CALCULATE ADJOINT MATRIX, I.E. MATRIX OF COFACTORS                 QN62  14
DO I=1,3#                                                               QN62  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN62  16
J=I+1 ; IF(J>3) J=1 ; K=J+1 ; IF(K>3) K=1#                              QN62  17
DO L=1,3#                                                               QN62  18
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN62  19
M=L+1 ; IF(M>3) M=1 ; N=M+1 ; IF(N>3) N=1#                              QN62  20
BB(L,I)=AA(J,M)*AA(K,N)-AA(J,N)*AA(K,M)#                                QN62  21
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN62  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN62  23
DET=0.0#                               Calculate determinant of matri   QN62  24
DO I=1,3 ; DET=DET+AA(1,I)*BB(I,1)#                                     QN62  25
ifeq:(DET,0.0) iquit:(QN6201)#         Blasted singular matrix!         QN62  26
DO I=1,3 ; DO J=1,3 ; BB(I,J)=BB(I,J)/DET# Calculate inverse elements   QN62  27
RETURN#                                                                 QN62  28
END#                                                                    QN62  29
systemheader:(QN63)## Place atoms in boxes                              QN63   1
####################################################################    QN63   2
#                                                                  #    QN63   3
#                                QN63                              #    QN63   4
#                                                                  #    QN63   5
####################################################################    QN63   6
SUBROUTINE QN63#                                                        QN63   7
#                                                                       QN63   8
include:(AACOMN)#                                                       QN63   9
include:(QNCOMN)#                                                       QN63  10
#                                                                       QN63  11
#                                                                       QN63  12
#----DIVIDE ATOMS INTO BOXES                                            QN63  13
#     SUBROUTINE CUBE (VDWCUT)                                          QN63  14
#                                                                       QN63  15
#----MARKB ARRAY CONTAINS NUMBER OF ATOMS IN THIS BOX AND BELOW         QN63  16
#----MARKA ARRAY, FOURTH ITEM, CONTAINS PACKED IBX, ICHAIN,             QN63  17
#    IRES, AND IATOM.                                                   QN63  18
#                                                                       QN63  19
chardata:(QN63A, BECAUSE OF STORAGE LIMITATION THE NUMBER OF $#         QN63  20
BOXES USED IN QN63 WERE REDUCED FROM IIIII TO IIIII.)#                  QN63  21
chardata:(QN63B,    LOWEST    HIGHEST COORDINATES   NO. OF BOXES    $#  QN63  22
MAXIMUM BOX INDEX )#                                                    QN63  23
realdata:(FMT1,[870513.,960513.])#                                      QN63  24
realdata:(FMT2,[111032.,211032.,430513.,640713.])#                      QN63  25
datastuff:#                                                             QN63  26
IBMAX=0 ; DB=VDWCUT+0.01#              Db=dimension of box              QN63  27
MARKB=STOPA#                                                            QN63  28
REPEAT## Determine number of boxes in each direction                    QN63  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN63  30
DO I=1,3 ; NB(I)=INT((XYZMAX(I)-XYZMIN(I))/DB)+1#                       QN63  31
#                                                                       QN63  32
#----DETERMINE NUMBER OF BOXES IN XY PLANE AND TOTAL NO OF BOXES        QN63  33
NXY=NB(1)*NB(2) ; NBX=NB(3)*NXY#                                        QN63  34
STOPB=MARKB+NBX+2#                     And remember where they end      QN63  35
IF(STOPB<=QXMAX) BREAK#                If space enough, go on           QN63  36
#                                                                       QN63  37
#----TOO MANY BOXES; INCREASE BOX SIZE AND REDETERMINE NUMBER OF BOXES  QN63  38
DBNEW=DB*1.4142136#                                                     QN63  39
DO I=1,3 ; NB(I)=NINT((XYZMAX(I)-XYZMIN(I))/DBNEW)+1#                   QN63  40
BUFOT(1)=FLOAT(NBX);BUFOT(2)=FLOAT(NB(1)*NB(2)*NB(3))#                  QN63  41
ncodefld:(BUFOT,1,QN63A,FMT1,2)#                                        QN63  42
writeline:(1,QN63A,NQN63A,3,1)#        Warn of action taken             QN63  43
DB=DBNEW#                                                               QN63  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN63  45
qxmemory:(STOPB)#                      Try for the memory               QN63  46
DO ICHAIN=1,NTCHAN#                    Loop over chains                 QN63  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN63  48
ICH=ICHTYP(ICHAIN);IRESN=IREST(2*(ICH-1)+1);IRESMX=KRESMX(ICHAIN)#      QN63  49
DO IRES=IRESN,IRESMX#                  Loop over each residue in chai   QN63  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN63  51
IF(ICENTR(IRES,ICHAIN)==0) NEXT#                                        QN63  52
IACID=IDACD(IRES,ICHAIN) ; IAN=NATOMS(IACID)#                           QN63  53
DO IATOM=1,IAN#                        Loop over each atom in residue   QN63  54
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN63  55
IA=NOAT(IATOM,IRES,ICHAIN) ; IF(IA<=0) NEXT#                            QN63  56
IAA=(IA-1)*STEPA+MARKA#                Point to atomic data             QN63  57
IX=INT((QX(IAA+1)-XYZMIN(1))/DB)+1## Box no. in each dir'n for this a   QN63  58
IY=INT((QX(IAA+2)-XYZMIN(2))/DB) ; IZ=INT((QX(IAA+3)-XYZMIN(3))/DB)#    QN63  59
IBX=IZ*NXY+IY*NB(1)+IX ; IBMAX=MAX0(IBX,IBMAX)# Dtn box number for at   QN63  60
#                                                                       QN63  61
#----STORE NUMBER OF ATOMS IN EACH BOX AND BOX NO OF EACH ATOM          QN63  62
#KEYBOX(IBX+2)=KEYBOX(IBX+2)+1 ; IBOX(IA)=IBX#                          QN63  63
QX(MARKB+IBX+2)=QX(MARKB+IBX+2)+1.0#   Count number of atoms            QN63  64
intpak:(IBX,QX(IAA+4),18,11)#          Pack up box number               QN63  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN63  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN63  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN63  68
#                                                                       QN63  69
#----STORE TOTAL ATOMS IN THIS BOX AND THOSE OF LOWER NUMBER            QN63  70
#DO I=1,NBX ; KEYBOX(I+2)=KEYBOX(I+1)+KEYBOX(I+2)#                      QN63  71
DO I=1,NBX ; QX(MARKB+I+2)=QX(MARKB+I+2)+QX(MARKB+I+1)#                 QN63  72
DO ICHAIN=1,NTCHAN#                    Loop over chains                 QN63  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN63  74
ICH=ICHTYP(ICHAIN);IRESN=IREST(2*(ICH-1)+1);IRESMX=KRESMX(ICHAIN)#      QN63  75
DO IRES=IRESN,IRESMX#                  Loop over each residue in chai   QN63  76
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN63  77
IF(ICENTR(IRES,ICHAIN)==0) NEXT#                                        QN63  78
IACID=IDACD(IRES,ICHAIN) ; IAN=NATOMS(IACID)#                           QN63  79
DO IATOM=1,IAN#                        Loop over each atom in residue   QN63  80
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN63  81
IA=NOAT(IATOM,IRES,ICHAIN) ; IF(IA<=0) NEXT#                            QN63  82
IAA=(IA-1)*STEPA+MARKA#                                                 QN63  83
#IBX=IBOX(IA)#                                                          QN63  84
intunpak:(QX(IAA+4),IBX,18,11)#                                         QN63  85
#                                                                       QN63  86
#----RELATE ATOM NUMBER IN COORDINATE ARRAYS TO ATOM NUMBER BY BOX      QN63  87
#---- EFFECT OF THIS LOOP IS TO MOVE THE TOTAL NUMBER OF ATOMS IN THIS  QN63  88
#---- BOX AND THOSE OF LOWER NUMBER FROM QX(MARKB+IBX+2) TO             QN63  89
#     QX(MARKB+IBX+1)                                                   QN63  90
#---- KEY IS AN ATOM NUMBER RELATED MONOTONICALLY TO BOX NUMBER         QN63  91
#KEY=KEYBOX(IBX+1)+1 ; KEYBOX(IBX+1)=KEY#                               QN63  92
KEY=NINT(QX(MARKB+IBX+1)+1) ; QX(MARKB+IBX+1)=FLOAT(KEY)#               QN63  93
#IATMBX(KEY)=((ICHAIN*K15)+IRES)*K8+IATOM#                              QN63  94
KEYA=(KEY-1)*STEPA+MARKA#              Point to atom storage place      QN63  95
intpak:(IATOM,QX(KEYA+4),0,8)#         Pack up residue atom number      QN63  96
intpak:(IRES,QX(KEYA+4),8,7)#          Pack up residue number           QN63  97
intpak:(ICHAIN,QX(KEYA+4),15,3)#       Pack up chain number             QN63  98
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN63  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN63 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN63 101
#                                                                       QN63 102
#----REPORT INDEX OF LARGEST BOX USED AND MAXIMUM BOX INDEX             QN63 103
LINRM=8 ; DO I=1,3#                                                     QN63 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN63 105
BUFOT(1)=XYZMIN(I) ; BUFOT(2)=XYZMAX(I) ; BUFOT(3)=FLOAT(NB(I))#        QN63 106
BUFOT(4)=FLOAT(IBMAX) ; ncodefld:(BUFOT,1,CHROT,FMT2,4)#                QN63 107
writeline:(1,QN63B,NQN63B,1,4)#                                         QN63 108
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN63 109
RETURN#                                                                 QN63 110
END#                                                                    QN63 111
systemheader:(QN64)## Check symmetry related contacts                   QN64   1
####################################################################    QN64   2
#                                                                  #    QN64   3
#                                QN64                              #    QN64   4
#                                                                  #    QN64   5
####################################################################    QN64   6
SUBROUTINE QN64#                                                        QN64   7
#                                                                       QN64   8
include:(AACOMN)#                                                       QN64   9
include:(QNCOMN)#                                                       QN64  10
#                                                                       QN64  11
#----DETERMINE WHICH ATOMS OF POTENTIAL SYMMETRY-RELATED CONTACT        QN64  12
#---- ACTUALLY CONTACT MOLECULE                                         QN64  13
#    SUBROUTINE SYMDCB (NOVDW,NONOW,NATP1,IHATOM,VDWCUT)                QN64  14
#                                                                       QN64  15
#----QX(MARKB+IBX) CONTAINS NUMBER OF ATOMS IN THIS BOX AND BELOW       QN64  16
#----FOURTH ITEM IN MARKA ARRAY CONTAINS THE PACKED UP ATOM NUMBER      QN64  17
#----OF ORDER IN WHICH ATOMS ARE STORED IN THE COORDINATE ARRAYS.       QN64  18
#                                                                       QN64  19
INTEGER NCONT(2,20),JCODE(20)#                                          QN64  20
REAL CHNCEN(3),RESCEN(3)#                                               QN64  21
REAL RS(3,3),TS(3),XYZTMP(3),XYZTM2(3),XTEM(3)##                        QN64  22
chardata:(DISOR,DIS )#                                                  QN64  23
chardata:(ISTAR, )#                                                     QN64  24
chardata:(STAR,*)#                                                      QN64  25
chardata:(COMMA,[,])#                                                   QN64  26
chardata:(QN64A, -----POSSIBLE VAN DER WAALS SYMMETRY CONTACTS----- )#  QN64  27
chardata:(QN64B, -----SUMMARY OF SYMMETRY-RELATED CONTACTS $#           QN64  28
FUNDAMENTAL SYMMETRY OPERATORS----- )#                                  QN64  29
chardata:(QN64C,       SYMMETRY TRANSFORMATIONS SEARCHED EXHAUSTIVELY )#QN64  30
chardata:(QN64D,     IS    OPERATOR  S   TX TY TZ    $#                 QN64  31
INVERSE  S   TX TY TZ    CONTACTS POTENTIAL NOW )#                      QN64  32
chardata:(QN64E,CONTACT NO.  ATOM AT NO.         RESID  ATOM AT $#      QN64  33
NO.            RESID  IDEAL DIST  OBSERVED   CONSTRAINT)#               QN64  34
chardata:(QN64F,[ SYMOP       R(1,J)        R(2,J)        $#            QN64  35
R(3,J)         T1      T2      T3])#                                    QN64  36
realdata:(FMTO,[120613.,240613.,320613.,510613.,590613.,740832.,$#      QN64  37
840832.,900413.,970613.])#                                              QN64  38
realdata:(FMT2,[60513.,120413.,160413.,200413.,260413.,300413.,$#       QN64  39
340413.,400413.,440413.,480413.,600842.,680842.,760842.])#              QN64  40
realdata:(FMT3,[60513.,220613.,260313.,290313.,320313.,470613.,$#       QN64  41
510313.,540313.,570313.,690413.,760413.])#                              QN64  42
datastuff:#                                                             QN64  43
NRAN=1; ICONT=1;#                      Nran=no of nearest boxes         QN64  44
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN64  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN64  46
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN64A,NQN64A,3,4) ; LINRM=3#     QN64  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN64  48
#                                                                       QN64  49
#----LOOP OVER SYMMETRY OPERATORS WITHIN RANGE OF CENTRAL MOLECULE      QN64  50
DO IS=1,NSYMC#                                                          QN64  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN64  52
NOCONT=0 ; NONOWC=0#                                                    QN64  53
ISYMOP=10000*ICODE(1,IS)+1000*(ICODE(2,IS)+5)+$#                        QN64  54
100*(ICODE(3,IS)+5)+10*(ICODE(4,IS)+5)#                                 QN64  55
JS=ICODE(1,IS)#                                                         QN64  56
JSA=(JS-1)*STEPS+MARKS#                                                 QN64  57
DO I=1,3#                                                               QN64  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN64  59
TS(I)=QX(JSA+I+9)+FLOAT(ICODE(I+1,IS))# Get translation vector          QN64  60
RS(I,1)=QX(JSA+I) ; RS(I,2)=QX(JSA+I+3) ; RS(I,3)=QX(JSA+I+6)# Rotati   QN64  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN64  62
DO ICHAIN=1,NTCHAN#                    Loop over chains                 QN64  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN64  64
ICH=ICHTYP(ICHAIN) ; IRESN=IREST(2*(ICH-1)+1)#                          QN64  65
IRESC=IREST(2*(ICH-1)+2) ; IRESMX=KRESMX(ICHAIN)#                       QN64  66
IA=ICHCEN(ICHAIN) ; CHNRAD=RADCHN(ICHAIN)#                              QN64  67
IAA=(IA-1)*STEPA+MARKA#                Point to atom in marka array     QN64  68
#                                                                       QN64  69
#----DEORTHOGONALIZE THE CHAIN CENTER                                   QN64  70
XYZTMP(1)=OIXX*QX(IAA+1)+OIXY*QX(IAA+2)+OIXZ*QX(IAA+3)#                 QN64  71
XYZTMP(2)=               OIYY*QX(IAA+2)+OIYZ*QX(IAA+3)#                 QN64  72
XYZTMP(3)=                              OIZZ*QX(IAA+3)#                 QN64  73
DO I=1,3## Perform symmetry transformation on chain center              QN64  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN64  75
XYZTM2(I)=TS(I)#                                                        QN64  76
DO J=1,3 ; XYZTM2(I)=XYZTM2(I)+RS(I,J)*XYZTMP(J)#                       QN64  77
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN64  78
#                                                                       QN64  79
#----ORTHOGONALIZE THE SYMMETRY-RELATED CHAIN CENTER                    QN64  80
CHNCEN(1)=ORXX*XYZTM2(1)+ORXY*XYZTM2(2)+ORXZ*XYZTM2(3)#                 QN64  81
CHNCEN(2)=               ORYY*XYZTM2(2)+ORYZ*XYZTM2(3)#                 QN64  82
CHNCEN(3)=                              ORZZ*XYZTM2(3)#                 QN64  83
IHIT=no:## Determine if contact possible with central molecule          QN64  84
DO I=1,3#                                                               QN64  85
IF((CHNCEN(I)<(XYZMIN(I)-VDWCUT-CHNRAD))\$#                             QN64  86
(CHNCEN(I)>(XYZMAX(I)+VDWCUT+CHNRAD)))#                                 QN64  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN64  88
IHIT=yes: ; BREAK#                                                      QN64  89
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN64  90
IF(IHIT==yes:) NEXT#                                                    QN64  91
DO IRES=IRESN,IRESMX#                  Loop over residues in chain      QN64  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN64  93
IF(ICENTR(IRES,ICHAIN)==0) NEXT#                                        QN64  94
IA=ICENTR(IRES,ICHAIN) ; RESRAD=RADIUS(IRES,ICHAIN)#                    QN64  95
IAA=(IA-1)*STEPA+MARKA#                Point to atom in qx array        QN64  96
#                                                                       QN64  97
#----DEORTHOGONALIZE THE RESIDUE CENTER                                 QN64  98
XYZTMP(1)=OIXX*QX(IAA+1)+OIXY*QX(IAA+2)+OIXZ*QX(IAA+3)#                 QN64  99
XYZTMP(2)=               OIYY*QX(IAA+2)+OIYZ*QX(IAA+3)#                 QN64 100
XYZTMP(3)=                              OIZZ*QX(IAA+3)#                 QN64 101
DO I=1,3## Perform symmetry transformation on residue center            QN64 102
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN64 103
XYZTM2(I)=TS(I)#                                                        QN64 104
DO J=1,3 ; XYZTM2(I)=XYZTM2(I)+RS(I,J)*XYZTMP(J)#                       QN64 105
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN64 106
#                                                                       QN64 107
#----ORTHOGONALIZE THE SYMMETRY-RELATED RESIDUE CENTER                  QN64 108
RESCEN(1)=ORXX*XYZTM2(1)+ORXY*XYZTM2(2)+ORXZ*XYZTM2(3)#                 QN64 109
RESCEN(2)=               ORYY*XYZTM2(2)+ORYZ*XYZTM2(3)#                 QN64 110
RESCEN(3)=                              ORZZ*XYZTM2(3)#                 QN64 111
IHIT=no:## Determine if contact possible with central molecule          QN64 112
DO I=1,3 ; IF((RESCEN(I)<(XYZMIN(I)-VDWCUT-RESRAD))\$#                  QN64 113
(RESCEN(I)>(XYZMAX(I)+VDWCUT+RESRAD)))#                                 QN64 114
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN64 115
IHIT=yes: ; BREAK#                                                      QN64 116
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN64 117
IF(IHIT==yes:) NEXT#                                                    QN64 118
#                                                                       QN64 119
#----ATOMS IN THIS RESIDUE ARE POTENTIALLY IN CONTACT                   QN64 120
IACID=IDACD(IRES,ICHAIN) ; IAN=NATOMS(IACID)#                           QN64 121
DO IATOM=1,IAN#                                                         QN64 122
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN64 123
IA=NOAT(IATOM,IRES,ICHAIN) ; IF(IA<=0) NEXT#                            QN64 124
IAA=(IA-1)*STEPA+MARKA#                                                 QN64 125
#                                                                       QN64 126
#----DEORTHOGONALIZE THIS ATOM'S COORDINATES                            QN64 127
XYZTMP(1)=OIXX*QX(IAA+1)+OIXY*QX(IAA+2)+OIXZ*QX(IAA+3)#                 QN64 128
XYZTMP(2)=               OIYY*QX(IAA+2)+OIYZ*QX(IAA+3)#                 QN64 129
XYZTMP(3)=                              OIZZ*QX(IAA+3)#                 QN64 130
DO I=1,3#                              Apply symmetry transformation    QN64 131
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN64 132
XYZTM2(I)=TS(I)#                                                        QN64 133
DO J=1,3 ; XYZTM2(I)=XYZTM2(I)+RS(I,J)*XYZTMP(J)#                       QN64 134
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN64 135
#                                                                       QN64 136
#----ORTHOGONALIZE THE SYMMETRY-RELATED ATOMIC COORDINATES              QN64 137
XTEM(1)=ORXX*XYZTM2(1)+ORXY*XYZTM2(2)+ORXZ*XYZTM2(3)#                   QN64 138
XTEM(2)=               ORYY*XYZTM2(2)+ORYZ*XYZTM2(3)#                   QN64 139
XTEM(3)=                              ORZZ*XYZTM2(3)#                   QN64 140
#                                                                       QN64 141
#----DETERMINE IF CONTACT POSSIBLE WITH CENTRAL MOLECULE                QN64 142
IF((XTEM(1)<(XYZMIN(1)-VDWCUT))\$#     Check x coordinate               QN64 143
(XTEM(1)>(XYZMAX(1)+VDWCUT))\$#                                         QN64 144
(XTEM(2)<(XYZMIN(2)-VDWCUT))\$#        Check y coordinate               QN64 145
(XTEM(2)>(XYZMAX(2)+VDWCUT))\$#                                         QN64 146
(XTEM(3)<(XYZMIN(3)-VDWCUT))\$#        Check z coordinate               QN64 147
(XTEM(3)>(XYZMAX(3)+VDWCUT))) NEXT#                                     QN64 148
#                                                                       QN64 149
#----GET POINTERS TO BOX FOR THIS ATOM                                  QN64 150
IX=INT((XTEM(1)-XYZMIN(1))/DB)+1#      For x                            QN64 151
IY=INT((XTEM(2)-XYZMIN(2))/DB)+1#      For y                            QN64 152
IZ=INT((XTEM(3)-XYZMIN(3))/DB)+1#      For z                            QN64 153
#                                                                       QN64 154
#----NUMBER OF BOXES IN X                                               QN64 155
IXL=IX-NRAN; IF(IXL<1) IXL=1; IXU=IX+NRAN; IF(IXU>NB(1)) IXU=NB(1)#     QN64 156
#                                                                       QN64 157
#----NUMBER OF BOXES IN Y                                               QN64 158
IYL=IY-NRAN; IF(IYL<1) IYL=1; IYU=IY+NRAN; IF(IYU>NB(2)) IYU=NB(2)#     QN64 159
#                                                                       QN64 160
#----NUMBER OF BOXES IN Z                                               QN64 161
IZL=IZ-NRAN; IF(IZL<1) IZL=1; IZU=IZ+NRAN; IF(IZU>NB(3)) IZU=NB(3)#     QN64 162
#                                                                       QN64 163
#----FIND LOWEST AND HIGHEST ATOM NUMBERS BY BOXES (STORED IN IATMBX) O QN64 164
#----ATOMS POTENTIALLY IN CONTACT WITH BOX FOR CURRENT ATOM             QN64 165
#----COUNT BOXES IN PLANES                                              QN64 166
DO IZINDX=IZL,IZU#                                                      QN64 167
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN64 168
KZ=(IZINDX-1)*NXY#                                                      QN64 169
DO IYINDX=IYL,IYU#                     Count boxes in lines             QN64 170
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN64 171
KY=(IYINDX-1)*NB(1) ; KXL=KZ+KY+IXL ; KXU=KZ+KY+IXU#                    QN64 172
#                                                                       QN64 173
#----FIRST ATOM IN BOX KXL+1 AND LAST ATOM OF BOX KXU+1                 QN64 174
#JKEYLO=KEYBOX(KXL)+1 ; JKEYHI=KEYBOX(KXU+1)#                           QN64 175
JKEYLO=NINT(QX(MARKB+KXL))+1 ; JKEYHI=NINT(QX(MARKB+KXU+1))#            QN64 176
#                                                                       QN64 177
#----ARE ANY ATOMS IN BOXES KXL+1 THROUGH KXU+1?                        QN64 178
IF(JKEYHI<JKEYLO) NEXT#                                                 QN64 179
DO JKEY=JKEYLO,JKEYHI## Loop over all atoms in appropriate boxes        QN64 180
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN64 181
#JATOM=MOD(IATMBX(JKEY),K8) ; JRES=MOD(IATMBX(JKEY)/K8,K15)#            QN64 182
#JCHAIN=IATMBX(JKEY)/K23#                                               QN64 183
JKEYA=(JKEY-1)*STEPA+MARKA ; intunpak:(QX(JKEYA+4),JATOM,0,8)#          QN64 184
intunpak:(QX(JKEYA+4),JRES,8,7) ; intunpak:(QX(JKEYA+4),JCHAIN,15,3)#   QN64 185
JA=NOAT(JATOM,JRES,JCHAIN) ; JAA=(JA-1)*STEPA+MARKA#                    QN64 186
DISTO=SQRT((XTEM(1)-QX(JAA+1))**2+(XTEM(2)-QX(JAA+2))**2+$#             QN64 187
(XTEM(3)-QX(JAA+3))**2)#               Find the distance between atom   QN64 188
IF(DISTO>VDWCUT) NEXT#                                                  QN64 189
#                                                                       QN64 190
#----SKIP CONTACTS FOR DISORDER GROUPS                                  QN64 191
IF((ICHAIN>NCHAIN)&(JCHAIN>NCHAIN)&(ICHAIN!=JCHAIN)) NEXT#              QN64 192
JACID=IDACD(JRES,JCHAIN)#                                               QN64 193
compchar:(NAMES,4*(IACID-1)+1,DISOR,1,4,4,NDISOR,K)#                    QN64 194
compchar:(NAMES,4*(JACID-1)+1,DISOR,1,4,4,NDISOR,L)#                    QN64 195
IF(K!=0\L!=0) NEXT#                    Skip if disordered flag on       QN64 196
#                                                                       QN64 197
#----GET C-TERMINAL RESIDUE OF CHAINS                                   QN64 198
IRESC=IREST(2*(ICHTYP(ICHAIN)-1)+2)#                                    QN64 199
JRESC=IREST(2*(ICHTYP(JCHAIN)-1)+2)#                                    QN64 200
#                                                                       QN64 201
#----FIND THIS VAN DER WAALS CONTACT DISTANCE                           QN64 202
#    CALL VDWTYP (IACID,IATOM,IRES,ICHAIN,IRESC,JACID,JATOM,JRES,       QN64 203
#        $ JCHAIN,JRESC,IHATOM,LTYP,DISV)                               QN64 204
CALL QN02(IACID,IATOM,IRES,ICHAIN,IRESC,JACID,JATOM,JRES,$#             QN64 205
JCHAIN,JRESC,LTYP,DISV)#                                                QN64 206
LTYP=LTYP+ISYMOP#                                                       QN64 207
NOVDW=NOVDW+1 ; NOCONT=NOCONT+1#       Listing                          QN64 208
#                                                                       QN64 209
#    WRITE OUT A PACKET WITH A VAN DER WAALS DISTANCE RESTRAINT         QN64 210
#    ----------------------------------------------------------         QN64 211
#                                                                       QN64 212
CALL QN09(IA,JA,DISV,LTYP)#                                             QN64 213
movechar:(BLANK,1,ISTAR,1,NISTAR,1) ; ABSDEL=DISV-DISTO#                QN64 214
IF(ABSDEL>0.0)#                                                         QN64 215
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN64 216
NONOW=NONOW+1 ; NONOWC=NONOWC+1#                                        QN64 217
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN64 218
IF(ABSDEL>0.50) movechar:(STAR,1,ISTAR,1,NSTAR,1) ; LTYP=LTYP-ISYMOP#   QN64 219
LISLOC=LISLOC-1 ; IF(LISLOC>=0)#       Skip if thats all user wants     QN64 220
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN64 221
BUFOT(1)=FLOAT(NOVDW) ; BUFOT(2)=FLOAT(IA) ; BUFOT(3)=FLOAT(JA)#        QN64 222
BUFOT(4)=FLOAT(IRES) ; BUFOT(5)=FLOAT(JRES)#                            QN64 223
BUFOT(6)=DISV ; BUFOT(7)=DISTO#                                         QN64 224
BUFOT(8)=FLOAT(LTYP) ; BUFOT(9)=FLOAT(ICONT)#                           QN64 225
ncodefld:(BUFOT,1,CHROT,FMTO,9); movechar:(ISTAR,1,CHROT,69,1,0)#       QN64 226
movechar:(TO,1,CHROT,38,NTO,0)#                                         QN64 227
IAA=(IA-1)*STEPA+MARKA ; movertoc:(QX(IAA+5),1,CHROT,14,4,0)#           QN64 228
JAA=(JA-1)*STEPA+MARKA ; movertoc:(QX(JAA+5),1,CHROT,41,4,0)#           QN64 229
movechar:(NAMES,4*(IACID-1)+1,CHROT,34,4,0)#                            QN64 230
movechar:(NAMES,4*(IACID-1)+1,CHROT,62,4,0)#                            QN64 231
writeline:(0,QN64E,NQN64E,1,4)#                                         QN64 232
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN64 233
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN64 234
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN64 235
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN64 236
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN64 237
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN64 238
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN64 239
IF(NOCONT>0)#                          Summary of contacts for operat   QN64 240
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN64 241
JCODE(ICONT)=IS ; NCONT(1,ICONT)=NOCONT#                                QN64 242
NCONT(2,ICONT)=NONOWC ; ICONT=ICONT+1#                                  QN64 243
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN64 244
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN64 245
LISLOC=0 ; IF(LISGEN>0)#               Check if listing is to be done   QN64 246
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN64 247
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN64B,NQN64B,3,4) ; LINRM=3#     QN64 248
DO IS=1,NSYMOP#                                                         QN64 249
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN64 250
ISA=(IS-1)*STEPS+MARKS ; BUFOT(1)=FLOAT(IS)#                            QN64 251
DO I=1,3#                                                               QN64 252
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN64 253
J=(I-1)*3+1 ; BUFOT(J+1)=QX(ISA+I) ; BUFOT(J+2)=QX(ISA+I+3)#            QN64 254
BUFOT(J+3) = QX(ISA+I+6) ; BUFOT(I+10)=QX(ISA+I+9)#                     QN64 255
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN64 256
ncodefld:(BUFOT,1,CHROT,FMT2,13) ; writeline:(0,QN64F,NQN64F,1,4)#      QN64 257
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN64 258
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN64 259
ncodefld:(FLOAT(NSYMC),1,QN64C,60513.,1)#                               QN64 260
writeline:(1,QN64C,NQN64C,3,4)#        No. symops searched              QN64 261
ICONT=ICONT-1## Report summary of potential symmetry-related contacts   QN64 262
IF(LISGEN>0)#                          Check if listing is to be done   QN64 263
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QN64 264
LINRM=5#                                                                QN64 265
DO JS=1,ICONT#                                                          QN64 266
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QN64 267
IS=JCODE(JS) ; BUFOT(1)=FLOAT(JS)#                                      QN64 268
DO I=1,4#                                                               QN64 269
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QN64 270
BUFOT(I+1)=FLOAT(ICODE(I,IS)) ; BUFOT(I+5)=FLOAT(ICODEI(I,IS))#         QN64 271
IF(I<3) BUFOT(I+9)=FLOAT(NCONT(I,JS))#                                  QN64 272
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QN64 273
ncodefld:(BUFOT,1,CHROT,FMT3,11);movechar:(COMMA,1,CHROT,23,NCOMMA,0)#  QN64 274
movechar:(COMMA,1,CHROT,48,NCOMMA,0) ; writeline:(0,QN64D,NQN64D,1,4)#  QN64 275
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QN64 276
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QN64 277
RETURN#                                                                 QN64 278
END#                                                                    QN64 279
systemheader:(QN65)## Set table of conformational torsion angles        QN65   1
####################################################################    QN65   2
#                                                                  #    QN65   3
#                                QN65                              #    QN65   4
#                                                                  #    QN65   5
####################################################################    QN65   6
SUBROUTINE QN65#                                                        QN65   7
#                                                                       QN65   8
include:(AACOMN)#                                                       QN65   9
include:(QNCOMN)#                                                       QN65  10
#                                                                       QN65  11
#----PREPARE THE TABLE OF CONFORMATIONAL TORSION ANGLES                 QN65  12
#     SUBROUTINE TORTAB (NOTOR,IEOFIN,IDCIS)                            QN65  13
#                                                                       QN65  14
INTEGER MOTHER(17)#                                                     QN65  15
INTEGER LAT(17),LPR(91),IZIP(5),KAT(4)#                                 QN65  16
LOGICAL ZCHAIN,ZLINK#                                                   QN65  17
REAL XTOR(3,4)#                                                         QN65  18
chardata:(QN65A,[ CHAIN  INITIAL & FINAL RESIDUE & CODE IN $#           QN65  19
SECSEL LINE])#                                                          QN65  20
chardata:(QN65B, RESIDUE   N CHI  ATOMS DEFINING TORSION ANGLE $#       QN65  21
RESTRAINTS AS POINTER/IDEAL NAME)#                                      QN65  22
chardata:(QN65C, -----TORSION ANGLES----- )#                            QN65  23
chardata:(QN65D, CHAIN     )#                                           QN65  24
realdata:(FMT1,[60413.,150513.,230513.,380513.])#                       QN65  25
realdata:(FMT2,[120513.,150213.])#                                      QN65  26
realdata:(FMT3,[90513.,130413.,570613.,630613.,690613.,750613.,$#       QN65  27
810613.,870613.,950813.,1010612.])#                                     QN65  28
datastuff:#                                                             QN65  29
LISLOC=0 ; IF(LISGEN>0)#               Control listing; protect trees   QN65  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN65  31
LISLOC=LISGEN ; LINRM=5#                                                QN65  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN65  33
DO ICHAIN=1,NTCHAN## Read in any backbone specifications                QN65  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN65  35
ICH=ICHTYP(ICHAIN) ; IRESMX=KRESMX(ICHAIN)#                             QN65  36
DO IRES=1,IRESMX ; ICONFO(IRES,ICHAIN)=0#                               QN65  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN65  38
IF(LINID<33) iquit:(QN6513)#           Input line order error           QN65  39
LINRM=5#                                                                QN65  40
REPEAT#                                                                 QN65  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN65  42
IF(LINID>33) BREAK#                    Seek secsel lines                QN65  43
CALL QN12(1,ICH)#                      Find pointer to chain            QN65  44
CALL QN11(2,ICH,IRES1) ; CALL QN11(3,ICH,IRES2)# Find residue pointer   QN65  45
KODE=NINT(AMAX1(0.0,BUFIN(4)))#        Get code for structure type      QN65  46
IF(LISLOC>0)#                                                           QN65  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN65  48
LISLOC=LISLOC-1 ; ncodefld:(BUFIN,1,CHROT,FMT1,4)#                      QN65  49
writeline:(0,QN65A,NQN65A,1,4)#                                         QN65  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN65  51
DO ICHAIN=1,NTCHAN#                                                     QN65  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN65  53
IF(ICHTYP(ICHAIN)!=ICH) NEXT#                                           QN65  54
DO IRES=IRES1,IRES2 ; ICONFO(IRES,ICHAIN)=KODE#                         QN65  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN65  56
readline:(INLINE,NLINEC)#              Refresh input buffer             QN65  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN65  58
ZCHAIN=.FALSE. ; DO ICHAIN=1,NTCHAN#   Loop over chains                 QN65  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN65  60
IF(LISLOC>0)#                                                           QN65  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN65  62
LINRM=5 ; ncodefld:(FLOAT(ICHAIN),1,QN65D,100213.,1)#                   QN65  63
writeline:(1,QN65D,NQN65D,3,4) ; LINRM=5#                               QN65  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN65  65
ICH=ICHTYP(ICHAIN) ; IRESN=IREST(2*(ICH-1)+1)#                          QN65  66
IRESC=IREST(2*(ICH-1)+2) ; NCIS=IDCIS(1,ICH)+1#                         QN65  67
IF(ICHAIN>NCHAIN) ZCHAIN=.TRUE. ; IZCHAN=MOTHRZ(ICHAIN)#                QN65  68
DO IRES=IRESN,IRESC#                   Loop over each residue in chai   QN65  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN65  70
ZLINK=.FALSE.#                                                          QN65  71
IF(ZCHAIN)#                                                             QN65  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN65  73
IF(IRES!=IRESN)#                                                        QN65  74
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN65  75
IF(ZMAIN(IRES-1,ICHAIN)&!ZMAIN(IRES,ICHAIN)) ZLINK=.TRUE.#              QN65  76
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN65  77
IF(IRES!=IRESC)#                                                        QN65  78
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN65  79
IF(ZMAIN(IRES+1,ICHAIN)&!ZMAIN(IRES,ICHAIN)) ZLINK=.TRUE.#              QN65  80
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN65  81
IF(!ZLINK)#                                                             QN65  82
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN65  83
IF(ICENTR(IRES,ICHAIN)==0) NEXT#                                        QN65  84
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN65  85
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN65  86
IACID=IDACD(IRES,ICHAIN)## Identify the required main chain atoms       QN65  87
IF(ZCHAIN&(ICENTR(IRES,ICHAIN)==0)) IACID=IDACD(IRES,IZCHAN)#           QN65  88
IMAIN=1#                                                                QN65  89
IF(IRES==IRESN) IMAIN=IMAINT(2*(ICH-1)+1)#                              QN65  90
IF(IRES==IRESC) IMAIN=IMAINT(2*(ICH-1)+2)#                              QN65  91
DO IA=1,6#                                                              QN65  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN65  93
MOTHER(IA)=0#                                                           QN65  94
IF(ITWIST(IA,IACID)==0)#                                                QN65  95
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN65  96
LAT(IA)=0 ; NEXT#                                                       QN65  97
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN65  98
LAT(IA)=NOAT(ITWIST(IA,IACID),IRES+MNABOR(IA,IMAIN),ICHAIN)#            QN65  99
IF(LAT(IA)>0\!ZCHAIN) NEXT#                                             QN65 100
LAT(IA)=NOAT(ITWIST(IA,IACID),IRES+MNABOR(IA,IMAIN),IZCHAN)#            QN65 101
MOTHER(IA)=1#                                                           QN65 102
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN65 103
NCHI=NCHIS(IACID)## Identify required side chain atoms                  QN65 104
IF(NCHI!=0)#                                                            QN65 105
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN65 106
IBRIDG=0 ; KACID=IACID## Is this a bridging cysteine residue?           QN65 107
IF(IRES==IRESN) KACID=IACIDT(2*(ICH-1)+1)#                              QN65 108
IF(IRES==IRESC) KACID=IACIDT(2*(ICH-1)+2)#                              QN65 109
IF(KACID==5)#                          ******bad news bear!!!!!!!!!!    QN65 110
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN65 111
IF(NSS!=0)#                                                             QN65 112
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN65 113
IBRIDG=1#                                                               QN65 114
DO ISS=1,NSS#                                                           QN65 115
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN65 116
IF(ICHNSS(ISS)==JCHNSS(ISS))#                                           QN65 117
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN65 118
IF(ICHNSS(ISS)!=ICHTYP(ICHAIN)) NEXT#  Intrachain check                 QN65 119
JCHAIN=ICHAIN ; JZCHAN=MOTHRZ(JCHAIN)#                                  QN65 120
JRES=JRESSS(ISS)#                                                       QN65 121
IF(IRESSS(ISS)==IRES) GO TO 3470#                                       QN65 122
JRES=IRESSS(ISS)#                                                       QN65 123
IF(JRESSS(ISS)==IRES) GO TO 3470#                                       QN65 124
NEXT#                                                                   QN65 125
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN65 126
#                                                                       QN65 127
#....INTERCHAIN CHECK                                                   QN65 128
JCHAIN=JCHNSS(ISS) ; JZCHAN=MOTHRZ(JCHAIN) ; JRES=JRESSS(ISS)#          QN65 129
IF(ICHNSS(ISS)==ICHAIN&IRESSS(ISS)==IRES) GO TO 3470#                   QN65 130
JCHAIN=ICHNSS(ISS) ; JZCHAN=MOTHRZ(JCHAIN) ; JRES=IRESSS(ISS)#          QN65 131
IF(JCHNSS(ISS)==ICHAIN&JRESSS(ISS)==IRES) GO TO 3470#                   QN65 132
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN65 133
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN65 134
IBRIDG=0 ; NCHI=1#                                                      QN65 135
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN65 136
3470 CONTINUE#                                                          QN65 137
NA=NCHI+7#                             Specify atom string              QN65 138
DO IA=7,NA#                                                             QN65 139
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN65 140
MOTHER(IA)=0#                                                           QN65 141
IF(IBRIDG!=1\IA<9)#                                                     QN65 142
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QN65 143
IATOM=NOAT(ITWIST(IA,IACID),IRES,ICHAIN)#                               QN65 144
IF(IATOM<1&ZCHAIN)#                                                     QN65 145
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QN65 146
IATOM=NOAT(ITWIST(IA,IACID),IRES,IZCHAN) ; MOTHER(IA)=1#                QN65 147
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QN65 148
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QN65 149
ELSE#                                                                   QN65 150
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QN65 151
IATOM=NOAT(ITWIST(IA,IACID),JRES,JCHAIN)#                               QN65 152
IF(IATOM<1&ZCHAIN)#                                                     QN65 153
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QN65 154
IATOM=NOAT(ITWIST(IA,IACID),JRES,JZCHAN) ; MOTHER(IA)=1#                QN65 155
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QN65 156
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QN65 157
IF(IATOM==0)#                                                           QN65 158
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 QN65 159
NA=IA-1 ; NCHI=NA-7 ; IF(NA==7) NA=6 ; BREAK#                           QN65 160
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 QN65 161
LAT(IA)=IATOM#                                                          QN65 162
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN65 163
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN65 164
IF(LISLOC>0)#                                                           QN65 165
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 QN65 166
IF(NCHI==0) NA=6#                      Get torsion angle atom ident's   QN65 167
FMTR=2090413.0 ; DO I=1,NA#                                             QN65 168
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 QN65 169
IF(LAT(I)==0) movechar:(BLANK,1,CHROT,8*(I-1)+21,4,1)#                  QN65 170
IF(LAT(I)!=0)#                         Pick up atom name                QN65 171
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 QN65 172
IAA=(LAT(I)-1)*STEPA+MARKA;movertoc:(QX(IAA+5),1,CHROT,8*(I-1)+21,4,0)# QN65 173
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 QN65 174
ncodefld:(FLOAT(LAT(I)),1,CHROT,FMTR,1) ; FMTR=FMTR+80000.0#            QN65 175
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 QN65 176
#----LIST THE TORSION ANGLE IDENTIFICATIONS FOR THIS RESIDUE            QN65 177
LISLOC=LISLOC-1 ; movechar:(MCOD,IACID,CHROT,2,1,0)# Get residue abbr   QN65 178
movechar:(NAMES,4*(IACID-1)+1,CHROT,4,4,0)# Get residue name            QN65 179
BUFOT(1)=FLOAT(IRES);BUFOT(2)=FLOAT(NCHI)#                              QN65 180
ncodefld:(BUFOT,1,CHROT,FMT2,2) ; writeline:(0,QN65B,NQN65B,1,4)##      QN65 181
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 QN65 182
#                                                                       QN65 183
#----SET UP FOR MAIN-CHAIN ANGLES AND RESTRAINTS                        QN65 184
NANG=NCHI+3 ; KODE=ICONFO(IRES,ICHAIN)#                                 QN65 185
DO IANG=1,3#                                                            QN65 186
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 QN65 187
NZ=0 ; DO JA=1,4#                      Atom specifications              QN65 188
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 QN65 189
KAT(JA)=LAT(JA+IANG-1) ; IF(KAT(JA)==0) GO TO 3690#                     QN65 190
NZ=NZ+MOTHER(JA+IANG-1)#                                                QN65 191
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 QN65 192
IF(NZ==4) GO TO 3690#                                                   QN65 193
#                                                                       QN65 194
#----DISTANCE SPECIFICATIONS                                            QN65 195
IZIP(1)=JDISTZ(IRES,ICHAIN) ; IZIP(2)=IDISTZ(IRES,ICHAIN)#              QN65 196
IF(ZLINK) IZIP(2)=IDISTZ(IRES,IZCHAN)#                                  QN65 197
IF(IRES!=IRESC)#                                                        QN65 198
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 QN65 199
IZIP(3)=JDISTZ(IRES+1,ICHAIN) ; IZIP(4)=IDISTZ(IRES+1,ICHAIN)#          QN65 200
IF(ZCHAIN&!ZMAIN(IRES+1,ICHAIN)) IZIP(4)=IDISTZ(IRES+1,IZCHAN)#         QN65 201
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 QN65 202
IZIP(5)=IZIP(1)-NDISTM(IMAIN)#                                          QN65 203
DO IP=1,6#                                                              QN65 204
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 QN65 205
KP=MANDST(IANG,IP,IMAIN) ; KZ=MANZIP(IANG,IP,IMAIN)#                    QN65 206
IF(KP<0) LPR(IP)=KP-IZIP(KZ)#                                           QN65 207
ELSE IF (KP==0) LPR(IP)=0#                                              QN65 208
ELSE LPR(IP)=KP+IZIP(KZ)#                                               QN65 209
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 QN65 210
IF(IANG!=3)#                           Restraint specifications         QN65 211
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 QN65 212
#                                                                       QN65 213
#....PHI OR PSI                                                         QN65 214
IF(KODE<0)#                                                             QN65 215
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 QN65 216
IWT=1 ; DO IA=1,4#                                                      QN65 217
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 QN65 218
IAA=(KAT(IA)-1)*STEPA+MARKA#           Point to atom in qx array        QN65 219
XTOR(1,IA)=QX(IAA+1);XTOR(2,IA)=QX(IAA+2);XTOR(3,IA)=QX(IAA+3)#         QN65 220
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 QN65 221
TAG=QN67(XTOR)#                        Use function tangle              QN65 222
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 QN65 223
ELSE IF(KODE==0)#                                                       QN65 224
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 QN65 225
TAG=0.0 ; IWT=0#                                                        QN65 226
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 QN65 227
ELSE TAG=PHIPSI(IANG,KODE)#                                             QN65 228
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 QN65 229
ELSE#                                  Omega                            QN65 230
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 QN65 231
IWT=2 ; TAG=180.0#                                                      QN65 232
IF(NCIS>1)#                                                             QN65 233
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 QN65 234
DO ICIS=2,NCIS#                                                         QN65 235
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 QN65 236
IF(IRES+1!=IDCIS(ICIS,ICH)) NEXT#                                       QN65 237
TAG=0.0 ; BREAK#                                                        QN65 238
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 QN65 239
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 QN65 240
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 QN65 241
NOTOR=NOTOR+1#                         Write-out                        QN65 242
#                                                                       QN65 243
#    WRITE OUT A PACKET WITH A TORSION ANGLE RESTRAINT                  QN65 244
#    -------------------------------------------------                  QN65 245
#                                                                       QN65 246
CALL QN10(IRES,IANG,KAT,LPR,IWT,TAG)#                                   QN65 247
IF(LISTIT==yes:)#                                                       QN65 248
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 QN65 249
FMTR=220413.0 ; DO I=1,4#              Get atom ident's                 QN65 250
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 QN65 251
IF(KAT(I)==0) movechar:(BLANK,1,CHROT,8*(I-1)+23,4,1)#                  QN65 252
IF(KAT(I)!=0)#                         Pick up atom name                QN65 253
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 QN65 254
IAA=(KAT(I)-1)*STEPA+MARKA;movertoc:(QX(IAA+5),1,CHROT,8*(I-1)+23,4,0)# QN65 255
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 QN65 256
ncodefld:(FLOAT(KAT(I)),1,CHROT,FMTR,1) ; FMTR=FMTR+80000.0#            QN65 257
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 QN65 258
BUFOT(1)=FLOAT(NOTOR);BUFOT(2)=FLOAT(IANG)#                             QN65 259
BUFOT(9)=FLOAT(IWT);BUFOT(10)=TAG#                                      QN65 260
DO I=1,6 ; BUFOT(I+2)=FLOAT(LPR(I))#                                    QN65 261
ncodefld:(BUFOT,1,CHROT,FMT3,10) ; writeline:(0,QN65C,NQN65C,1,4)##     QN65 262
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 QN65 263
3690 CONTINUE#                                                          QN65 264
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 QN65 265
IF(NCHI==0) NEXT## SET UP FOR SIDE-CHAIN ANGLES AND RESTRAINTS          QN65 266
LAT(5)=LAT(2) ; LAT(6)=LAT(3)#                                          QN65 267
MOTHER(5)=MOTHER(2) ; MOTHER(6)=MOTHER(3)#                              QN65 268
DO IANG=4,NANG#                        Atom specifications              QN65 269
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 QN65 270
ICHI=IANG-3 ; NZ=0 ; IHIT=no:#                                          QN65 271
DO JA=1,4#                                                              QN65 272
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 QN65 273
KAT(JA)=LAT(JA+IANG)#                                                   QN65 274
IF(KAT(JA)==0)#                                                         QN65 275
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 QN65 276
IHIT=yes: ; BREAK#                                                      QN65 277
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 QN65 278
NZ=NZ+MOTHER(JA+IANG)#                                                  QN65 279
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 QN65 280
IF(NZ==4\IHIT==yes:) NEXT#                                              QN65 281
IACID=IDACD(IRES,ICHAIN);IZERO=IDISTZ(IRES,ICHAIN)# Distance spec's     QN65 282
DO IP=1,6#                                                              QN65 283
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 QN65 284
KP=KHIDST(ICHI,IP,IACID) ; IZZERO=IZERO#                                QN65 285
IF(KP!=0&ZCHAIN)#                                                       QN65 286
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 QN65 287
KPMAG=ISIGN(KP,1) ; IATOM=IATM(IACID,KPMAG)#                            QN65 288
IA=NOAT(IATOM,IRES,ICHAIN) ; JATOM=JATM(IACID,KPMAG)#                   QN65 289
JA=NOAT(JATOM,IRES,ICHAIN)#                                             QN65 290
IF(IA<1&JA<1) IZZERO=IDISTZ(IRES,IZCHAN)#                               QN65 291
ELSE#                                                                   QN65 292
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 QN65 293
DO IDIST=1,KPMAG#                                                       QN65 294
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 QN65 295
IATOM=IATM(IACID,IDIST) ; IA=NOAT(IATOM,IRES,ICHAIN)#                   QN65 296
JATOM=JATM(IACID,IDIST) ; JA=NOAT(JATOM,IRES,ICHAIN)#                   QN65 297
IF(IA<1&JA<1)#                                                          QN65 298
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 QN65 299
KP=KP-ISIGN(1,KP) ; NEXT#                                               QN65 300
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 QN65 301
IF(IA<=0) IA=NOAT(IATOM,IRES,IZCHAN)#                                   QN65 302
IF(JA<=0) JA=NOAT(JATOM,IRES,IZCHAN)#                                   QN65 303
IF(IA<=0\JA<=0) KP=KP-ISIGN(1,KP)#                                      QN65 304
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 QN65 305
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 QN65 306
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 QN65 307
IF(KP<0) LPR(IP)=KP-IZZERO#                                             QN65 308
ELSE IF(KP==0) LPR(IP)=0#                                               QN65 309
ELSE LPR(IP)=KP+IZZERO#                                                 QN65 310
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 QN65 311
IWT=KHIWGT(ICHI,IACID) ; TAG=0.0#      Restraint specifications         QN65 312
IF(IWT==2) TAG=180.0 ; IF(IWT==3) TAG=60.0 ; IF(IWT==4) TAG=90.0#       QN65 313
NOTOR=NOTOR+1#                         Write-out                        QN65 314
#                                                                       QN65 315
#    WRITE OUT A PACKET WITH A TORSION ANGLE RESTRAINT                  QN65 316
#    -------------------------------------------------                  QN65 317
#                                                                       QN65 318
CALL QN10(IRES,IANG,KAT,LPR,IWT,TAG)#                                   QN65 319
IF(LISTIT==yes:)#                                                       QN65 320
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 QN65 321
FMTR=220413.0 ; DO I=1,4#              Get atom ident's                 QN65 322
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 QN65 323
IF(KAT(I)==0) movechar:(BLANK,1,CHROT,8*(I-1)+23,4,1)#                  QN65 324
IF(KAT(I)!=0)#                         Pick up atom name                QN65 325
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 QN65 326
IAA=(KAT(I)-1)*STEPA+MARKA;movertoc:(QX(IAA+5),1,CHROT,8*(I-1)+23,4,0)# QN65 327
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 QN65 328
ncodefld:(FLOAT(KAT(I)),1,CHROT,FMTR,1) ; FMTR=FMTR+80000.0#            QN65 329
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 QN65 330
BUFOT(1)=FLOAT(NOTOR);BUFOT(2)=FLOAT(IANG)#                             QN65 331
BUFOT(9)=FLOAT(IWT);BUFOT(10)=TAG#                                      QN65 332
DO I=1,6 ; BUFOT(I+2)=FLOAT(LPR(I))#                                    QN65 333
ncodefld:(BUFOT,1,CHROT,FMT3,10) ; writeline:(0,QN65C,NQN65C,1,4)##     QN65 334
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 QN65 335
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 QN65 336
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN65 337
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN65 338
RETURN#                                                                 QN65 339
END#                                                                    QN65 340
systemheader:(QN66)## Set up table of non-crystallographic symmetries   QN66   1
####################################################################    QN66   2
#                                                                  #    QN66   3
#                                QN66                              #    QN66   4
#                                                                  #    QN66   5
####################################################################    QN66   6
SUBROUTINE QN66#                                                        QN66   7
#                                                                       QN66   8
include:(AACOMN)#                                                       QN66   9
include:(QNCOMN)#                                                       QN66  10
#                                                                       QN66  11
#----PREPARE THE TABLE OF NON-CRYSTALLOGRAPHIC SYMMETRIES               QN66  12
#    SUBROUTINE NCSTAB (NSYMM,IEOFIN,IDCHN)                             QN66  13
#                                                                       QN66  14
INTEGER ICHSYM(qmxchn:),KODSYM(qmxres:),LAT(17)#                        QN66  15
INTEGER ISYM1(5),ISYM2(5),KODA(5),IWGHT(6,2)#                           QN66  16
INTEGER PUTPK#                         Packet pointer for file f        QN66  17
REAL R(3,3),T(3)#                                                       QN66  18
chardata:(QN66A, -----NON-CRYSTALLOGRAPHIC SYMMETRIES----- )#           QN66  19
chardata:(QN66B, -----NON-CRYSTALLOGRAPHIC SYMMETRIES----- )#           QN66  20
chardata:(QN66C,[ R(1,1) R(1,2) R(1,3)  R(2,1) R(2,2) R(2,3)  $#        QN66  21
R(3,1) R(3,2) R(3,3)     T(1)     T(2)     T(3) ])#                     QN66  22
chardata:(QN66D, -----NON-CRYSTALLOGRAPHIC SYMMETRIES----- )#           QN66  23
realdata:(FMT1,[60513.,110513.])#                                       QN66  24
realdata:(FMT2,[50413.,120413.,190413.,270413.,340413.,410413.,$#       QN66  25
490413.,560413.,630413.,750842.,840842.,930842.])#                      QN66  26
realdata:(FMT3,[60513.,110513.,180513.,270513.,360513.,450513.])#       QN66  27
intdata:(KNOWNR,[0])#                  Set no. of non-cry syms to 0     QN66  28
datastuff:#                                                             QN66  29
IGROUP=0 ; LINRM=4#                                                     QN66  30
IF(LINID<34) iquit:(QN6613)#           Input line order error           QN66  31
IF(LINID<37)#                          There must be lines 34-36        QN66  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN66  33
IF(NCHTYP!=NCHAIN)#                    ??????????????????????????????   QN66  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN66  35
writeline:(1,QN66A,NQN66A,3,4) ; LINRM=10#                              QN66  36
REPEAT#                                                                 QN66  37
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN66  38
IF(LINID>36) BREAK#                    When end is hit, quit.           QN66  39
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN66  40
#                                                                       QN66  41
#----IDENTIFY CHAINS RELATED BY SYMMETRY AND KNOWN TRANSFORMATIONS      QN66  42
IF(LINID==34)#                         A spcsym line?                   QN66  43
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN66  44
IGROUP=IGROUP+1 ; IF(IGROUP>2) BREAK#                                   QN66  45
NCHN=0#                                                                 QN66  46
REPEAT#                                                                 QN66  47
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN66  48
ifvo:(BUFIN(NCHN+1)) BREAK#                                             QN66  49
NCHN=NCHN+1#                           Count chains related             QN66  50
CALL QN12(NCHN,ICHSYM(NCHN))#          Get chain                        QN66  51
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN66  52
FMT=160513.0 ; BUFOT(1)=FLOAT(NCHN) ; BUFOT(2)=FLOAT(KNOWNR)#           QN66  53
ncodefld:(BUFOT,1,CHROT,FMT1,2)#                                        QN66  54
DO I=1,NCHN#                                                            QN66  55
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN66  56
BUFOT(3)=FLOAT(ICHSYM(I)) ; ncodefld:(BUFOT,3,CHROT,FMT,1)#             QN66  57
FMT=FMT+50000.0#                                                        QN66  58
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN66  59
writeline:(0,QN66B,NQN66B,1,4)#                                         QN66  60
#                                                                       QN66  61
#    WRITE OUT A SUB-PACKET WITH SOME SPECIAL SYMMETRY RESTRAINT INFO   QN66  62
#    ----------------------------------------------------------------   QN66  63
#                                                                       QN66  64
writepkt:(FILEF,LRSYM,PKSYM,PUTPK)#    Write header sub-packet          QN66  65
QX(PUTPK+1)=FLOAT(NCHN) ; QX(PUTPK+2)=FLOAT(KNOWNR)#                    QN66  66
DO I=1,NCHN#                                                            QN66  67
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN66  68
movector:(IDCHN,(ICHSYM(I)-1)*3+1,QX(PUTPK+3),(I-1)*3+1,3,0)#           QN66  69
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN66  70
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN66  71
ELSE IF(LINID==35)#                    Symop line?                      QN66  72
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN66  73
ICHN=0 ; DO I=1,3#                                                      QN66  74
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN66  75
ICHN=ICHN+1 ; T(I)=BUFIN(ICHN+3)#                                       QN66  76
DO J=1,3#                                                               QN66  77
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN66  78
ICHN=ICHN+1 ; R(I,J)=BUFIN(ICHN-1)#                                     QN66  79
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN66  80
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN66  81
DO I=1,3#                                                               QN66  82
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 QN66  83
BUFOT(I+9)=T(I) ; DO J=1,3 ; BUFOT(J+3*(I-1))=R(I,J)#                   QN66  84
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 QN66  85
ncodefld:(BUFOT,1,FMT2,CHROT,12)#                                       QN66  86
writeline:(0,QN66C,NQN66C,1,4)#                                         QN66  87
#                                                                       QN66  88
#    WRITE OUT A SUB-PACKET WITH SOME SPECIAL SYMMETRY RESTRAINT INFO   QN66  89
#    ----------------------------------------------------------------   QN66  90
#                                                                       QN66  91
writepkt:(FILEF,LRSYM,PKSYM,PUTPK)#    Write header sub-packet          QN66  92
IJ=PUTPK ; DO I=1,3 ; DO J=1,3#        Put out rotation matrix          QN66  93
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 QN66  94
IJ=IJ+1 ; QX(IJ)=R(I,J)#                                                QN66  95
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 QN66  96
DO I=1,3#                              And translation vector           QN66  97
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 QN66  98
IJ=IJ+1 ; QX(IJ)=T(I)#                                                  QN66  99
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 QN66 100
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN66 101
ELSE IF(LINID==36)#                    Read weighting weakenings        QN66 102
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 QN66 103
NSPANS=0 ; I=-2#                                                        QN66 104
REPEAT#                                Pull stuff from symwgt line      QN66 105
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 QN66 106
IF(BUFIN(I+3)<=voidflg:) BREAK#                                         QN66 107
NSPANS=NSPANS+1 ; I=I+3#                                                QN66 108
CALL QN11(I,NCHN,ISYM1(NSPANS))#                                        QN66 109
CALL QN11(I+1,NCHN,ISYM2(NSPANS))#     Get groups within chains         QN66 110
KODA(NSPANS)=MAX0(1,MIN0(3,NINT(BUFIN(I+2))))# Take sym weight          QN66 111
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 QN66 112
DO ISQN=1,NSPANS#                                                       QN66 113
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 QN66 114
IRES1=ISYM1(ISQN) ; IRES2=ISYM2(ISQN)#                                  QN66 115
DO IRES=IRES1,IRES2 ; KODSYM(IRES)=KODA(ISQN)#                          QN66 116
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 QN66 117
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 QN66 118
NOSYM=0## Establish the atom equivalences for this symmetry class       QN66 119
DO IRES=IRESN,IRESMX#                                                   QN66 120
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 QN66 121
IACID=IDACD(IRES,ICHSYM(1)) ; NA=NATOMS(IACID)#                         QN66 122
IWMAIN=IWGHT(KODSYM(IRES),1) ; IWSIDE=IWGHT(KODSYM(IRES),2)#            QN66 123
DO IATOM=1,NA#                                                          QN66 124
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 QN66 125
IHIT=no:#                                                               QN66 126
DO ICHN=1,NCHN#                                                         QN66 127
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 QN66 128
ICHAIN=ICHSYM(ICHN) ; IA=NOAT(IATOM,IRES,ICHAIN)#                       QN66 129
IF(IA<=0)#                                                              QN66 130
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 QN66 131
IHIT=yes: ; BREAK#                                                      QN66 132
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 QN66 133
LAT(ICHN)=IA#                                                           QN66 134
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 QN66 135
IF(IHIT==yes:) NEXT#                                                    QN66 136
NOSYM=NOSYM+1 ; IF(IATOM<=4) IWT=IWMAIN#                                QN66 137
IF(IATOM>4) IWT=IWSIDE#                                                 QN66 138
#                                                                       QN66 139
#    WRITE OUT A SUB-PACKET WITH SOME SPECIAL SYMMETRY RESTRAINT INFO   QN66 140
#    ----------------------------------------------------------------   QN66 141
#                                                                       QN66 142
writepkt:(FILEF,LRSYM,PKSYM,PUTPK)#    Write header sub-packet          QN66 143
QX(PUTPK+1)=FLOAT(NOSYM) ; QX(PUTPK+2)=FLOAT(IWT)#                      QN66 144
DO I=1,NCHN ; QX(PUTPK+I+2)=FLOAT(LAT(I))#                              QN66 145
IF(LISTIT==no:) NEXT#                                                   QN66 146
BUFOT(1)=FLOAT(NOSYM) ; BUFOT(2)=FLOAT(IWT)#                            QN66 147
DO I=1,NCHN#                                                            QN66 148
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 QN66 149
BUFOT(I+2)=FLOAT(LAT(I)) ; IIAA=(LAT(I)-1)*STEPA+MARKA#                 QN66 150
movertoc:(QX(IIAA+5),1,CHROT,9*(I-1)+19,4,0)#                           QN66 151
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 QN66 152
ncodefld:(BUFOT,1,CHROT,FMT3,NCHN+2) ; writeline:(0,QN66D,NQN66D,1,4)#  QN66 153
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 QN66 154
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 QN66 155
NSYMM(IGROUP)=NOSYM#                                                    QN66 156
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN66 157
readline:(INLINE,NLINEC)#              New line into input buffer       QN66 158
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN66 159
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN66 160
IF(ICHSYM(1)<1) iquit:(QN6601)#        Must have loaded something       QN66 161
IRESN=IREST(2*(ICHTYP(ICHSYM(1))-1)+1)# Initialize the weighting sche   QN66 162
IRESMX=KRESMX(ICHSYM(1))#                                               QN66 163
DO IRES=IRESN,IRESMX ; KODSYM(IRES)=1#                                  QN66 164
M=0 ; DO I=1,3#                                                         QN66 165
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 QN66 166
DO J=I,3#                                                               QN66 167
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 QN66 168
M=M+1 ; IWGHT(M,1)=I ; IWGHT(M,2)=J#                                    QN66 169
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 QN66 170
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 QN66 171
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN66 172
RETURN#                                                                 QN66 173
END#                                                                    QN66 174
systemheader:(QN67)## Function to calculate torsion angles              QN67   1
####################################################################    QN67   2
#                                                                  #    QN67   3
#                                QN67                              #    QN67   4
#                                                                  #    QN67   5
####################################################################    QN67   6
REAL FUNCTION QN67(X)#                                                  QN67   7
#                                                                       QN67   8
#     FUNCTION TANGLE (X)                                               QN67   9
REAL X(3,4),Q(3,3),U(3),V(3),W(3),A(3),B(3)#                            QN67  10
realdata:(DEGTOR,[0.017453293])#                                        QN67  11
datastuff:#                                                             QN67  12
#                                                                       QN67  13
DO I=1,3#                              Form triad of interatomic vect   QN67  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN67  15
U(I)=X(I,1)-X(I,2) ; V(I)=X(I,4)-X(I,3) ; W(I)=X(I,3)-X(I,2)#           QN67  16
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN67  17
A(1)=U(2)*W(3)-U(3)*W(2)#              Find a=u.cross.w                 QN67  18
A(2)=U(3)*W(1)-U(1)*W(3) ; A(3)=U(1)*W(2)-U(2)*W(1)#                    QN67  19
B(1)=V(2)*W(3)-V(3)*W(2)#              Find b=v.cross.w                 QN67  20
B(2)=V(3)*W(1)-V(1)*W(3) ; B(3)=V(1)*W(2)-V(2)*W(1)#                    QN67  21
WMAG=SQRT(W(1)**2+W(2)**2+W(3)**2)#    Find magnitude of w              QN67  22
DO J=1,3## (A.CROSS.B).DOT.W=|A|*|B|*|W|*SIN(ANGLE)                     QN67  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN67  24
Q(1,J)=A(J) ; Q(2,J)=B(J) ; Q(3,J)=W(J)#                                QN67  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN67  26
S=QN03(Q)#                             Use function det3                QN67  27
T=(A(1)*B(1)+A(2)*B(2)+A(3)*B(3))*WMAG# (a.dot.b)*|w|=|a|*|b|*|w|*cos   QN67  28
QN67= ATAN2(S,T)/DEGTOR#               Torsion angle in degrees         QN67  29
RETURN#                                                                 QN67  30
END#                                                                    QN67  31
systemheader:(QN68)## Set up thermal elipsoid specifiers                QN68   1
####################################################################    QN68   2
#                                                                  #    QN68   3
#                                QN68                              #    QN68   4
#                                                                  #    QN68   5
####################################################################    QN68   6
SUBROUTINE QN68#                                                        QN68   7
#                                                                       QN68   8
include:(AACOMN)#                                                       QN68   9
include:(QNCOMN)#                                                       QN68  10
#                                                                       QN68  11
#----PREPARE THE TABLE OF THERMAL ELLIPSOID SPECIFIERS                  QN68  12
#     SUBROUTINE TETAB (NAXES)                                          QN68  13
#                                                                       QN68  14
INTEGER PUTPK#                                                          QN68  15
INTEGER LAT(17)#                                                        QN68  16
LOGICAL ZCHAIN#                                                         QN68  17
chardata:(QN68A, -----THERMAL ELLIPSOID SPECIFIERS----- )#              QN68  18
chardata:(QN68D,   NO. RESIDUE--NO.  ATOM--NO.  ATOM--NO.  $#           QN68  19
ATOM--NO.  ATOM--NO.  ATOM--NO.)#                                       QN68  20
realdata:(FMT3,[60513.,190513.,310513.,420513.,530513.,640513.,$#       QN68  21
750513.])#                                                              QN68  22
datastuff:#                                                             QN68  23
LISLOC=0 ; IF(LISGEN>0)#                                                QN68  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN68  25
LISLOC=LISGEN ; LINRM=5 ; writeline:(1,QN68A,NQN68A,3,4); LINRM=3#      QN68  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN68  27
ZCHAIN=.FALSE. ; DO ICHAIN=1,NTCHAN#   Loop over chains                 QN68  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN68  29
ICH=ICHTYP(ICHAIN) ; IRESN=IREST(2*(ICH-1)+1)#                          QN68  30
IRESMX=KRESMX(ICHAIN) ; IF(ICHAIN>NCHAIN) ZCHAIN=.TRUE.#                QN68  31
IZCHAN=MOTHRZ(ICHAIN)#                                                  QN68  32
DO IRES=IRESN,IRESMX#                  Loop over each residue in chai   QN68  33
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  QN68  34
IF(ZCHAIN)#                                                             QN68  35
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  QN68  36
IF(ICENTR(IRES,ICHAIN)==0) NEXT#                                        QN68  37
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  QN68  38
#                                                                       QN68  39
#----LOOP OVER EACH ATOM (IF IT EXISTS) IN RESIDUE                      QN68  40
IACID=IDACD(IRES,ICHAIN)#                                               QN68  41
IATMN=NATOMS(IACID)#                                                    QN68  42
DO IATOM=1,IATMN#                                                       QN68  43
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  QN68  44
IA=NOAT(IATOM,IRES,ICHAIN) ; IF(IA<=0) NEXT#                            QN68  45
LAT(1)=IA#                                                              QN68  46
IHIT=no:;DO JA=1,4## Find specifiers (if they exist) for this atom      QN68  47
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  QN68  48
KA=KPS(IACID,IATOM,JA)#                                                 QN68  49
IF(KA==0)#                                                              QN68  50
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  QN68  51
IHIT=yes: ; BREAK#                                                      QN68  52
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  QN68  53
IF(KA>=0)#                                                              QN68  54
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  QN68  55
LA=NOAT(KA,IRES,ICHAIN)#                                                QN68  56
IF(LA<=0&ZCHAIN) LA=NOAT(KA,IRES,IZCHAN)#                               QN68  57
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  QN68  58
ELSE#                                                                   QN68  59
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  QN68  60
LA=NOAT(-KA,IRES-1,ICHAIN)#                                             QN68  61
IF(LA<=0&ZCHAIN) LA=NOAT(-KA,IRES-1,IZCHAN)#                            QN68  62
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  QN68  63
IF(LA<=0)#                                                              QN68  64
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 QN68  65
IHIT=yes: ; BREAK#                                                      QN68  66
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 QN68  67
LAT(JA+1)=LA#                                                           QN68  68
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  QN68  69
IF(IHIT==yes:) NEXT#                                                    QN68  70
NAXES=NAXES+1#                                                          QN68  71
#                                                                       QN68  72
#    WRITE OUT A SUB-PACKET WITH SOME ANISOTROPIC T.F. RESTRAINT INFO   QN68  73
#    ----------------------------------------------------------------   QN68  74
#                                                                       QN68  75
writepkt:(FILEF,LRANI,PKANI,PUTPK)#    Write header sub-packet          QN68  76
DO I=1,5 ; QX(PUTPK+I)=FLOAT(LAT(I))#                                   QN68  77
LISLOC=LISLOC-1 ; IF(LISLOC<0) NEXT#   Skip if thats all user wants     QN68  78
BUFOT(1)=FLOAT(NAXES) ; BUFOT(2)=FLOAT(IRES)#                           QN68  79
movechar:(NAMES,4*(IRES-1)+1,CHROT,10,4,0)#                             QN68  80
DO I=1,5#                                                               QN68  81
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 QN68  82
BUFOT(I+2)=FLOAT(LAT(I)) ; IIAA=(LAT(I)-1)*STEPA+MARKA#                 QN68  83
movertoc:(QX(IIAA+5),1,CHROT,11*(I-1)+23,4,0)#                          QN68  84
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 QN68  85
ncodefld:(BUFOT,1,CHROT,FMT3,7) ; writeline:(0,QN68D,NQN68D,1,4)#       QN68  86
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  QN68  87
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  QN68  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN68  89
RETURN#                                                                 QN68  90
END#                                                                    QN68  91
systemheader:(QN99)## Control of subroutine sequence & summary print    QN99   1
####################################################################    QN99   2
#                                                                  #    QN99   3
#                                QN99                              #    QN99   4
#                                                                  #    QN99   5
####################################################################    QN99   6
SUBROUTINE QN99#                                                        QN99   7
#                                                                       QN99   8
include:(AACOMN)#                                                       QN99   9
include:(QNCOMN)#                                                       QN99  10
#                                                                       QN99  11
chardata:(QN99Z, -------------------------- $#                          QN99  12
***** SUMMARY COUNTS ***** --------------------------)#                 QN99  13
chardata:(QN99A,          ATOMS)#                                       QN99  14
chardata:(QN99B,          DISTANCES)#                                   QN99  15
chardata:(QN99C,          PLANES)#                                      QN99  16
chardata:(QN99D,          CHIRAL CENTERS)#                              QN99  17
chardata:(QN99E,          POSSIBLE CONTACTS)#                           QN99  18
chardata:(QN99F,          PRESENT CONTACTS)#                            QN99  19
chardata:(QN99G,          TORSION ANGLES)#                              QN99  20
chardata:(QN99H,[          SYMMETRY EQUIVALENCES (1)])#                 QN99  21
chardata:(QN99I,[          SYMMETRY EQUIVALENCES (2)])#                 QN99  22
chardata:(QN99J,          THERMAL ELLIPSOID SPECIFIERS)#                QN99  23
chardata:(QN99K,          VARIABLE OCCUPANCY FACTORS)#                  QN99  24
chardata:(QN99L,          HETERO ATOMS)#                                QN99  25
chardata:(QN99M,          RESIDUES)#                                    QN99  26
chardata:(QN99N,          CHAINS)#                                      QN99  27
chardata:(QN99O,          ALTERNATE CHAINS)#                            QN99  28
chardata:(QN99P,          RESIDUES IN CHAIN    )#                       QN99  29
chardata:(QN99Q,[          SPECIAL DISTANCES (A SUBSET OF $#            QN99  30
DISTANCES)])#                                                           QN99  31
chardata:(QN99R,[          DISULPHIDE LINKAGES (A SUBSET OF $#          QN99  32
DISTANCES AND TORSION ANGLES)])#                                        QN99  33
realdata:(FMTCH,[90413.,300213.])#                                      QN99  34
datastuff:#                                                             QN99  35
#                                                                       QN99  36
#----FINISH OFF THE FILE WHICH COMMUNICATES THE RESTRAINTS              QN99  37
#    INFORMATION BETWEEN PROTIN AND PROLSQ.  FILE F HAS THE             QN99  38
#    CONSTRAINT INFORMATION FIRST WITH THE TOTAL COUNTS OF              QN99  39
#    EACH CLASS OF CONSTRAINT IN THE FINAL RECORDS.                     QN99  40
#                                                                       QN99  41
writepkt:(FILEF,41,11,IP)#             Prepare to write counts          QN99  42
#                                                                       QN99  43
#----LIST SUMMARY COUNTS FOR INPUT TO LEAST-SQUARES REFINEMENT          QN99  44
#                                                                       QN99  45
IF(IQZERO<0) IQZERO=NOATOM#                                             QN99  46
writeline:(1,QN99Z,NQN99Z,3,2)#        Write heading                    QN99  47
BUFOT(1)=FLOAT(NOATOM) ; ncodefld:(BUFOT,1,QN99A,90613.,1)#             QN99  48
QX(IP+1)=BUFOT(1) ; writeline:(1,QN99A,NQN99A,3,2)# Number of atoms     QN99  49
BUFOT(1)=FLOAT(NODIST) ; ncodefld:(BUFOT,1,QN99B,90613.,1)#             QN99  50
QX(IP+2)=BUFOT(1) ; writeline:(1,QN99B,NQN99B,3,2)# Total distances     QN99  51
BUFOT(1)=FLOAT(NOSPDS) ; ncodefld:(BUFOT,1,QN99Q,90613.,1)#             QN99  52
writeline:(1,QN99Q,NQN99Q,3,2)#        Special distances                QN99  53
BUFOT(1)=FLOAT(NSS) ; ncodefld:(BUFOT,1,QN99R,90613.,1)# Qn9            QN99  54
writeline:(1,QN99R,NQN99R,3,2)#        Disulphide linkages              QN99  55
BUFOT(1)=FLOAT(NOPLAN) ; ncodefld:(BUFOT,1,QN99C,90613.,1)#             QN99  56
QX(IP+3)=BUFOT(1) ; writeline:(1,QN99C,NQN99C,3,2)# No. of planes       QN99  57
BUFOT(1)=FLOAT(NOCHRL) ; ncodefld:(BUFOT,1,QN99D,90613.,1)#             QN99  58
QX(IP+4)=BUFOT(1) ; writeline:(1,QN99D,NQN99D,3,2)# No. chiral center   QN99  59
BUFOT(1)=FLOAT(NOVDW) ; ncodefld:(BUFOT,1,QN99E,90613.,1)#              QN99  60
QX(IP+5)=BUFOT(1) ; writeline:(1,QN99E,NQN99E,3,2)# Van der waals       QN99  61
BUFOT(1)=FLOAT(NONOW) ; ncodefld:(BUFOT,1,QN99F,90613.,1)#              QN99  62
QX(IP+6)=BUFOT(1) ; writeline:(1,QN99F,NQN99F,3,2)# 'present' contact   QN99  63
BUFOT(1)=FLOAT(NOTOR) ; ncodefld:(BUFOT,1,QN99G,90613.,1)#              QN99  64
QX(IP+7)=BUFOT(1) ; writeline:(1,QN99G,NQN99G,3,2)# No. torsion angle   QN99  65
BUFOT(1)=FLOAT(NSYMM(1)) ; ncodefld:(BUFOT,1,QN99H,90613.,1)#           QN99  66
QX(IP+8)=BUFOT(1) ; writeline:(1,QN99H,NQN99H,3,2)# Special symmetry    QN99  67
BUFOT(1)=FLOAT(NSYMM(2)) ; ncodefld:(BUFOT,1,QN99I,90613.,1)#           QN99  68
QX(IP+9)=BUFOT(1) ; writeline:(1,QN99I,NQN99I,3,2)#                     QN99  69
BUFOT(1)=FLOAT(NAXES) ; ncodefld:(BUFOT,1,QN99J,90613.,1)#              QN99  70
QX(IP+10)=BUFOT(1) ; writeline:(1,QN99J,NQN99J,3,2)# Thermal ellipsoi   QN99  71
BUFOT(1)=FLOAT(NOCC) ; ncodefld:(BUFOT,1,QN99K,90613.,1)#               QN99  72
QX(IP+11)=BUFOT(1) ; writeline:(1,QN99K,NQN99K,3,2)# Atoms with pop p   QN99  73
BUFOT(1)=FLOAT(NUMHET) ; ncodefld:(BUFOT,1,QN99L,90613.,1)#             QN99  74
writeline:(1,QN99L,NQN99L,3,2)#        Number of hetero atoms           QN99  75
BUFOT(1)=FLOAT(NRESID) ; ncodefld:(BUFOT,1,QN99M,90613.,1)#             QN99  76
writeline:(1,QN99M,NQN99M,3,2)#        Total number of residue/groups   QN99  77
BUFOT(1)=FLOAT(NCHAIN) ; ncodefld:(BUFOT,1,QN99N,90613.,1)#             QN99  78
writeline:(1,QN99N,NQN99N,3,2)#        Number of chains                 QN99  79
BUFOT(1)=FLOAT(NTCHAN-NCHAIN) ; ncodefld:(BUFOT,1,QN99O,90613.,1)#      QN99  80
writeline:(1,QN99O,NQN99O,3,2)#        Number of alternate chains       QN99  81
IF(NCHAIN>1) ; DO J=1,NCHAIN#          For multi chain substances       QN99  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  QN99  83
BUFOT(1)=FLOAT(NRESCH(J)) ; BUFOT(2)=FLOAT(J)# Residues/chain           QN99  84
ncodefld:(BUFOT,1,QN99P,FMTCH,2) ; writeline:(1,QN99P,NQN99P,3,2)#      QN99  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  QN99  86
#                                                                       QN99  87
#   PLACE THE EQUIVALENCE TABLE FOR RESIDUE NAMES AND THE               QN99  88
#   ONE CHARACTER SYNONYM, MCOD, IN FILE F.                             QN99  89
#   -----------------------------------------------------               QN99  90
#                                                                       QN99  91
DO J=1,NACIDS#                         Loop over all acids              QN99  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  QN99  93
writepkt:(FILEF,42,nw5c:,IP)#          Get packet for 5 chars           QN99  94
movector:(NAMES,(J-1)*4+1,QX(IP+1),1,4,0)# Put out 'real' name          QN99  95
movector:(MCOD,J,QX(IP+1),5,1,0)#      Put out synonym                  QN99  96
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  QN99  97
writepkt:(FILEF,endrecord:,3,IP)#      End off file f                   QN99  98
#                                                                       QN99  99
RETURN#                                                                 QN99 100
END#                                                                    QN99 101
pmacro:([no:])#                                                         QN99 102
