systemheader:(RT    )#
#######################################################################
##                                                                    #
##                           *** RIETVD ***                           #
##                                                                    #
##   RIETVD refines atomic parameters by applying the structure       #
##   least squares approach of Rietveld to powder diffraction         #
##   intensity profile data.                                          #
##                                                                    #
#######################################################################
#
include:(XMACRO)#
#
macro:(maxpha:,10)#                    Maximum no of phases allowed
macro:(lrppha:,3)#
macro:(lrplim:,4)#
macro:(lrppat:,5)#
macro:(utob:,78.95684)#
macro:(setflg:,IF(I==0)$2=$3;ELSEIF(CHRIN(J^J+1)=="$1")$2=ABS($3-1))#
macro:(setint:,IF(I==0)$2=$3;ELSEIF(CHRIN(J^J+1)=="$1")#
$(ifnm:(BUFIN(I+1))$($2=NINT(BUFIN(I+1));I=I+1$);ELSE $2=$4$))#
macro:(setval:,IF(I==0)$2=$3;ELSEIF(CHRIN(J^J+1)=="$1")#
$(ifnm:(BUFIN(I+1))$($2=BUFIN(I+1);I=I+1$);ELSE $2=$4$))#
macro:(setkey:,KEY(1)=$1;KEY(2)=$2;KEY(3)=$3;KEY(4)=$4)#
macro:(swap:,$(Q1=QX($1);QX($1)=QX($2);QX($2)=Q1$))#
#
macro:(mcell:,MCELL(NPH))#             Start of cell parameters
macro:(ncell:,NCELL(NPH))#             Step  of cell parameters
macro:(lcell:,LCELL(NPH))#             Last  of cell parameters
macro:(msymm:,MSYMM(NPH))#             Start of symmetry data
macro:(nsymm:,NSYMM(NPH))#             Step  of symmetry data
macro:(lsymm:,LSYMM(NPH))#             Last  of symmetry data
macro:(mscat:,MSCAT(NPH))#             Start of atom type data
macro:(nscat:,NSCAT(NPH))#             Step  of atom type data
macro:(lscat:,LSCAT(NPH))#             Last  of atom type data
macro:(mpeak:,MPEAK(NPH))#             Start of peak definition data
macro:(npeak:,NPEAK(NPH))#             Step  of peak definition data
macro:(lpeak:,LPEAK(NPH))#             Last  of peak definition data
macro:(matom:,MATOM(NPH))#             Start of atom data
macro:(natom:,NATOM(NPH))#             Step  of atom data
macro:(latom:,LATOM(NPH))#             Last  of atom data
macro:(mcons:,MCONS(NPH))#             Start of atom constraints
macro:(ncons:,NCONS(NPH))#             Step  of atom constraints
macro:(lcons:,LCONS(NPH))#             Last  of atom constraints
macro:(mflag:,MFLAG(NPH))#             Start of matrix definition
macro:(nflag:,NFLAG(NPH))#             Step  of matrix definition
macro:(lflag:,LFLAG(NPH))#             Last  of matrix definition
macro:(dset:,DATSET(NPH))#             Data set for current phase
macro:(scal:,SKF(NPH))#                Sf scale for current phase
macro:(scalflg:,REFSKF(NPH))#          Refine flag for scale factor
macro:(span:,PKSPAN(NPH))#             Peak span for current phase
macro:(pkprofnr:,PRFNUM(NPH))#         Peak profile function number
#
macro:(cell:,[MCELL(NPH)ifelse:($1,,+1,+$1)])# Define gen list pointe
macro:(dcp:,[QX(cell:($1)   )])#       Direct cell parameters
macro:(dce:,[QX(cell:($1)+ 9)])#       Direct cell esd's
macro:(dmt:,[QX(cell:($1)+18)])#       Direct metric tensor
macro:(rcp:,[QX(cell:($1)+27)])#       Recipr cell parameters
macro:(rmt:,[QX(cell:($1)+36)])#       Recipr metric tensor
macro:(tcf:,[QX(cell:($1)+45)])#       Transform orth to fract
macro:(tfc:,[QX(cell:($1)+54)])#       Transform fract to orth
macro:(stc:,[QX(cell:($1)+63)])#       Stol calc coeffts
macro:(cub:,[QX(cell:($1)+72)])#       Transform u to beta
macro:(cbu:,[QX(cell:($1)+81)])#       Transform beta to u
#
macro:(atom:,[ifelse:($1,,IA,$1)])#    Define gen list pointer
macro:(ml:,[QX(atom:($1)+ 1)])#        Define multiplicity  +1
macro:(sf:,[QX(atom:($1)+ 2)])#        Define scat fact num +2
macro:(dp:,[QX(atom:($1)+ 3)])#        Define thermal dptype+3
macro:(dr:,[QX(atom:($1)+ 5)])#        Define disp f' real  +5
macro:(di:,[QX(atom:($1)+ 6)])#        Define disp f" imag  +6
macro:(xf:,[QX(atom:($1)+ 7)])#        Define fractional x  +7
macro:(yf:,[QX(atom:($1)+ 8)])#        Define fractional y  +8
macro:(zf:,[QX(atom:($1)+ 9)])#        Define fractional z  +9
macro:(ub:,[QX(atom:($1)+10)])#        Define isotropic  u/b+10
macro:(pp:,[QX(atom:($1)+17)])#        Define population pp +17
macro:(na:,[QX(atom:($1)+18)])#        Define atom label    +18
#
macro:(w8c:,incr:(arith:(7,/,mxchwd:)))#
macro:(w24c:,incr:(arith:(23,/,mxchwd:)))#
#
extrude:(RTCOMN)#
INTEGER $#
MCELL(maxpha:),#                       Start of cell parameters
NCELL(maxpha:),#                       Step  of cell parameters
LCELL(maxpha:),#                       Last  of cell parameters
MSYMM(maxpha:),#                       Start of symmetry data
NSYMM(maxpha:),#                       Step  of symmetry data
LSYMM(maxpha:),#                       Last  of symmetry data
MSCAT(maxpha:),#                       Start of atom type data
NSCAT(maxpha:),#                       Step  of atom type data
LSCAT(maxpha:),#                       Last  of atom type data
MPEAK(maxpha:),#                       Start of peak definition dat     a
NPEAK(maxpha:),#                       Step  of peak definition dat     a
LPEAK(maxpha:),#                       Last  of peak definition dat     a
MATOM(maxpha:),#                       Start of atom data
NATOM(maxpha:),#                       Step  of atom data
LATOM(maxpha:),#                       Last  of atom data
MCONS(maxpha:),#                       Start of atom constraints
NCONS(maxpha:),#                       Step  of atom constraints
LCONS(maxpha:),#                       Last  of atom constraints
MFLAG(maxpha:),#                       Start of refinement flags
NFLAG(maxpha:),#                       Step  of refinement flags
LFLAG(maxpha:)#                        Last  of refinement flags
#
INTEGER$#
APPDSP,#      ## Apply dispersion corr signal
BDFSCF,#      ## flag for scat fact on bdf (0=no,1=yes)
FLGCP,#       ## flag for calculation of pattern only
FLGBAC,#      ## Overall ref flag background (no/yes)
FLGCEL,#      ## Overall ref flag cell (no/yes
FLGPOF,#      ## Overall ref flag pref orient (no/yes)
FLGPRO,#      ## Overall ref flag peak profile (pasymm,hwidth) (no/ye
FLGPOP,#      ## overall ref flag site population (no/yes)
FLGTDP,#      ## overall ref flag thermal displ parameters (no/yes)
FLGSKF,#      ## overall ref flag scale factors  (no/yes)
FLGUOV,#      ## overall ref flag overall thermal displ par (no/yes)
FLGZER,#      ## overall ref flag zero corr  (no/yes)
HIHKL,#       ## highest angle hkl in active pattern list
HKLPAK,#      ## Reflection record, lrrefl:, o/p packet size
IBAC,#        ## Presence of backgound data (no/yes)
IREFL,#       ## Current pointer of sorted reflection list
IREL(101),#   ## Relative pointers for io packet
IWNT(100),#   ## To specify wanted items in directory packets
KEY(4),#      ## Group codes for indexpkt:
LISTMX,#      ## List matrix and vector after last cycle (no/yes)
LISTEP,#      ## List step data after last cycle
LISTRF,#      ## List n reflections after last cycle
LOHKL,#       ## Lowest angle hkl in active pattern list
LTMTRX,#      ## Rcode=2 ls contribution 0=none,2=yes if Fo>Fc
LSMODE,#      ## Least-Squares MODE 0=Rietveld 1=DLS 2=Powgen
MARKF,#       ## Start of general pattern parameters
MCONTR,#      ## maximum nr of reflections overlapping on one step
VARMAX,#      ## Maximum number of variables (gen + any one phase)
MDMATX,LDMATX,## Start/end of derivative matrix area
MDVECT,LDVECT,## Start/end of derivative vector area
MDTEMP,LDTEMP,## Start/end of derivative temporary area
NCY,#         ## Number of current refinement cycle
NCYCLE,#      ## Number of refinement cycles
NEXCLR,#      ## Number of excluded pattern regions
NEWM,#        ## New end of defined memory marker
NEWPAK,#      ## Number of words in new direct access buffer
NONPOS,#      ## Dp test if -ve: 0=reset dp;1=message;2=terminat
NPEAKF,#      ## Number of peak shape functions
NPH,#         ## Current phase number
NPHASE,#      ## Total number of phases
NREFL,#       ## Total number of reflections in all phases
NSCF,#        ## Number of scattering factors
NSKIP,#       ## Number of pattern steps skipped in refinement
NUCELL,#      ## Flag that cell parameters have changed (no/yes)
NUMVAR(maxpha:),## Number of variables per phase
PACK,#        ## Packet size of bdf record
VARPAT,#      ## Number of pattern variables refined (zer & bac)
POLSPG(3),#   ## Packed polar axis flags
PRFNUM(maxpha:),## Peak profile function number (peak,peakf lines)
PSHFLN(10),#  ## Number of 5-value entries per peak shape funct
PSHFPT(10),#  ## Pointer to start of each peak shape function
PUNCH,#       ## Flag to write updated parameters to file PCH
RADTYP,#      ## Radiation: 1=neutron,2=electron,3=xray
REFBAC(5),#   ## refinement flag background params
REFCEL(maxpha:,6),## Refinement flags for cell parameters
REFPOF(maxpha:),# ## Refinement flag pref orient parameter
REFPRO(maxpha:,6),## Refinement flags - profile hwidth, asymm, mix
REFSKF(maxpha:),# ## Refine flag phase scale factors
REFUOV(maxpha:),# ## Refinement flag overall thermal disp parameter
REFZER(2),#   ## Refinement flag zero corrections
RSCODE,#      ## Restraint restrictions (0=soft;1=bound;2=both)
TERMNT,#      ## Stop refinement: 0=no;1=when decrease in R<.01
VARTOT,#      ## Total number of variables refined
WTSCHM#       ## Step weight option (0/1/2 = unit/file/variance-1)
#
REAL$#
BUF(100),#    ## Reflection record buffer / cell esd calc scratch
CC,#          ## Start of first constraint list
CNTBAC,#      ## Observed step background intensity
CNTOBS,#      ## Observed step intensity
CNTWHT,#      ## Observed step intensity weight (sqrt(WT))
CNTSIG,#      ## Observed step reciprocal esd
DAMPPR,#      ## Profile shift damping factor
DAMPST,#      ## Structure shift damping factor
DATSET(maxpha:),#  ## Data set per phase
DELTA,#       ## Powder pattern step Iobs-Icalc
DSCF,#        ## Sine theta over lambda interval for s.f.
EXCLRL(10),#  ## Excluded 2theta regions of pattern low
EXCLRH(10),#  ## Excluded 2theta regions of pattern high
EXTV,#        ## Extinction var (r* in zachariasen's formula)
GOF,#         ## goodness of fit = w*(yo-yc)**2/(nobs-varmax)
HWDMAX,#      ## maximum halfwidth foe all reflections
LAMBDA,#      ## Radiation wavelength
LISTCM,#      ## List correlation matrix elements > q
LISTPR,#      ## List poor reflns with wY > q
PARBAC(5),#   ## background params
PARPOF(maxpha:),## prefer orient parameter
PARPRO(maxpha:,6),## peak profile (hwidth, asymmetry, mix)
PARZER(2),#   ## zero correction params
PEAKSP,#      ## Peak span override value
PKSPAN(10),#  ## Span of peak in half widths
POLRA,#       ## Polarization ratio for LP factor
PSHFST(10),#  ## Peak shape function reciprocal step size
RSTORE(100),# ## Summary of refinement index values (10 cycles)
RSUMS(80),#   ## R factor sums
SOEMAX,#      ## shift/error maximum per cycle
SKF(maxpha:),## phase scale factors
TT,#          ## Current pattern two theta value
TTMINL,#      ## Min 2 theta input limits
TTMAXL,#      ## Max 2 theta input limits
TTMINP,#      ## Min 2 theta of pattern
TTMAXP,#      ## Max 2 theta of pattern
TTMINR,#      ## Min 2 theta of reflections
TTMAXR,#      ## Max 2 theta of reflections
TTSTEP,#      ## Pattern step size in 2theta
UOV(maxpha:),## Overall thermal displacement factors
UOVSH,#       ## uov shift
UOVSD,#       ## uov std dev
VOL,#         ## Volume of unit cell in direct space
POFVEC(maxpha:,3),## preferred orientation vector (u,v,w)
WEIGHT#       ## Step weight
#
CHARACTER PHASE(maxpha:)*6#            Phase id string
CHARACTER SAVEID*6#                    Original compound id string
#
COMMON/COMIRT/MCELL,NCELL,LCELL,MSYMM,NSYMM,LSYMM,#
MSCAT,NSCAT,LSCAT,MPEAK,NPEAK,LPEAK,MATOM,NATOM,LATOM,#
MCONS,NCONS,LCONS,MFLAG,NFLAG,LFLAG,APPDSP,BDFSCF,FLGCP,#
FLGBAC,FLGCEL,FLGPOF,FLGPRO,FLGPOP,FLGTDP,FLGSKF,FLGUOV,FLGZER,#
HIHKL,HKLPAK,IBAC,IREFL,IREL,IWNT,KEY,LISTMX,LISTEP,LISTRF,LOHKL,#
LTMTRX,LSMODE,#
MARKF,MCONTR,VARMAX,MDMATX,LDMATX,MDVECT,LDVECT,MDTEMP,LDTEMP,#
NCY,NCYCLE,NEXCLR,NEWM,NEWPAK,NONPOS,NPEAKF,NPH,NPHASE,NREFL,#
NSCF,NSKIP,NUCELL,NUMVAR,PACK,VARPAT,POLSPG,PRFNUM,PSHFLN,PSHFPT,#
PUNCH,RADTYP,REFBAC,REFCEL,REFPOF,REFPRO,REFSKF,REFUOV,REFZER,#
RSCODE,TERMNT,VARTOT,WTSCHM#
#
COMMON/COMFRT/BUF,CC,CNTBAC,CNTOBS,CNTWHT,CNTSIG,#
DAMPPR,DAMPST,DATSET,DELTA,DSCF,#
EXCLRL,EXCLRH,GOF,EXTV,HWDMAX,LAMBDA,LISTCM,LISTPR,#
PARBAC,PARPOF,PARPRO,PARZER,PEAKSP,PKSPAN,POLRA,PSHFST,RSUMS,#
RSTORE,SKF,SOEMAX,TT,TTMINL,TTMAXL,TTMINP,TTMAXP,TTMINR,TTMAXR,#
TTSTEP,UOV,UOVSH,UOVSD,POFVEC,VOL,WEIGHT#
#
COMMON/COMCRT/PHASE,SAVEID#
endext:#
#
systemheader:(RT00)#                   Rietveld powder refinement
####################################################################
#                                                                  #
#                                RT00                              #
#                                                                  #
####################################################################
SUBROUTINE RT00#
#
include:(AACOMN)#
include:(RTCOMN)#
#
CALL RT10#                             Process rietvd line options
CALL RT20#                             Enter general pattern options
FOR(NPH=1;LINID<10;NPH=NPH+1)#         Loop over crystal phases
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
CALL RT30#                             Read cell/symm/expl/dset bdf
CALL RT31#                             Read atom/cons bdf and lines
CALL RT32#                             Process constr/noref lines
CALL RT33#                             Define ls matrix storage
CALL RT34#                             Print parameter summary
CALL RT35#                             Copy lrrefl: to ioda1:
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
CALL RT40#                             Sort hkl on 2th dac: to aux:
CALL RT45#                             Read powder pattern file
FOR(NCY=1;NCY<=NCYCLE;NCY=NCY+1)#      Loop over refinement cycles
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
CALL RT50#                             Treat diffraction pattern
CALL RT60#                             Treat restraint observations
CALL RT70(0)#                          Output of sums and discrepan
IF(FLGCP==yes:)BREAK#
CALL RT80#                             Matrix inversion
CALL RT90#                             Update general and group par
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
CALL RT70(1)#                          Final o/p of sums & discrepan
CALL RT99#                             Write o/p bdf's & quit
closedac:(ioda2:)#                     Close sorted refl file
#
RETURN#
END#
systemheader:(RT10)#                   Process the rietvd line
# ####################################################################
#
#                               RT10
#
# ####################################################################
SUBROUTINE RT10#
#
include:(AACOMN)#
include:(RTCOMN)#
#
INTEGER    I,K,L#
#
chardata:(RT0,' noyes')#
chardata:(RT1,' RIETVD Control Parameters-')#
chardata:(RT2,' Number of refinement cycles              ')#
chardata:(RT3,' Apply dispersion parameters              ')#
chardata:(RT7,' Contribute to ls only if w|dY|<          ')#
chardata:(RTA,' Refine occupancy (population)            ')#
chardata:(RTD,' Shift damping factor overall             ')#
chardata:(RTE,' Shift damping factor profile             ')#
chardata:(RTG,' Refine peak profile parameters           ')#
chardata:(RTH,' Refine cell parameters                   ')#
chardata:(RTI,' Refine zero corrections                  ')#
chardata:(RTJ,' Refine background                        ')#
chardata:(RTK,' Refine preferred orientation             ')#
chardata:(RTL,' Refine indiv thermal displ pars          ')#
chardata:(RTM,' Overall peak span in halfwidths          ')#
chardata:(RTN,' Refine scale factors                     ')#
chardata:(RTP,' Refine overall thermal displ pars        ')#
chardata:(RTQ,' Step weight option                       ')#
chardata:(RTR,' unit filesigma')#
chardata:(RTS,' Step skip value                          ')#
chardata:(RTT,' Calc pattern only, no refinement         ')#
datastuff:#
#
#       SET UP AND REQUEST FILE BUFFERS
#       -------------------------------
#
FILEXT(IOUNIT(3))='PAT'#               Powder pattern in
FILEXT(IOUNIT(4))='POT'#               Powder pattern out
FILEXT(ioda1:)='XX5'#                  Scratch unsorted refln data
FILEXT(ioda2:)='XX6'#                  Scratch sorted refln data
#
IOMARK(1)=QXSTR#                       Buffer inpu1 archive bdf(s)
IOMARK(2)=IOMARK(1)+bdfbuf:#           Buffer output archive bdf(s)
IOMARK(3)=IOMARK(2)+bdfbuf:#           Buffer input powder pattern
IOMARK(4)=IOMARK(3)+bdfbuf:#           Buffer output powder pattern
incrqx:(MARKF,IOMARK(4)+bdfbuf:,RT105)# Start tth distrib array
#
#     EXTRACT DATA FROM RIETVD LINE AND SET DEFAULT VALUES
#     ----------------------------------------------------
#
FOR(I=0;I>=0;I=I+1)#                   Loop over input fields
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
stringlim:(I,J,K)#                     Get string limits
#
setflg:(LM,LISTMX,no:)#                List matrix after last cycle
setflg:(LS,LISTEP,no:)#                List steps after last cycle
setflg:(ND,APPDSP,yes:)#               No application dispersion
setflg:(RU,FLGUOV,no:)#                Refine uov (overall tdp's)
setflg:(NT,FLGTDP,yes:)#               No refinement of thermal dp's
setflg:(NS,FLGSKF,yes:)#               No refinement of sf scales
setflg:(RO,FLGPOP,no:)#                Refine occupancy (population)
setflg:(RC,FLGCEL,no:)#                Refine cell
setflg:(RP,FLGPOF,no:)#                Refine preferred orientation
setflg:(RH,FLGPRO,no:)#                Refine peak profile parameters
setflg:(RB,FLGBAC,no:)#                Refine background
setflg:(RZ,FLGZER,no:)#                Refine zero corrections
setflg:(TC,TERMNT,no:)#                Terminate if convergence reach
setflg:(PC,PUNCH,no:)#                 Punch new pars after last cycl
setflg:(CP,FLGCP,no:)#                 Calc pattern only, no refineme
#
setint:(CY,NCYCLE,1,1)#                Max ls cycles
setint:(SK,NSKIP ,1,2)#                Pattern skip factor
setint:(LI,LISTRF,0,99999)#            List reflns after last cycle
setint:(WT,WTSCHM,0,1)#                Select step weight option
#
setval:(MR,RFMTRX,1.E8, 100.)#         Matrix refln inclusion <q
setval:(SD,DAMPST, 1.0,  0.5)#         Structure damping factor
setval:(PD,DAMPPR, 1.0,  0.5)#         Profile   damping factor
setval:(LR,LISTPR,1.E8,  10.)#         List poor reflections if >q
setval:(LC,LISTCM,1.E8,  0.5)#         List corr matrix if >q
setval:(PS,PEAKSP,  3.,  12.)#         Set peak span override value
#
ifvo:(BUFIN(I+1)) BREAK#               Exit when field void
ifnm:(BUFIN(I+1)) iquit:(RT1010,I+1)#  Must be char string
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
#
#        PRINT CONTROL PARAMETERS
#        ------------------------
#
LINRM=12#                              Ensure print space 12 lines
movechar:(RT1,NRT1,CHROT,2,NRT1-2,1)#  Insert header underline
writeline:(1,RT1,NRT1-1,2,3)#          Print header
movechar:(RT0,FLGCP*3+1,RTT,38,3,0)#   Insert calc pattern only
IF(FLGCP==yes:)#
writeline:(0,RTT,NRTT,3,3)#            Print calc pattern only
ncodefld:(FLOAT(NCYCLE),1,RT2,400513.,1)# Format refine cycles
writeline:(0,RT2,NRT2,3,3)#            Print refine cycles
movechar:(RT0,FLGZER*3+1,RTI,38,3,0)#  Insert refine zero corr
writeline:(0,RTI,NRTI,3,3)#            Print refine zero corr
movechar:(RT0,FLGBAC*3+1,RTJ,38,3,0)#  Insert refine background
writeline:(0,RTJ,NRTJ,3,3)#            Print refine background
movechar:(RT0,FLGSKF*3+1,RTN,38,3,0)#  Insert refine scales
writeline:(0,RTN,NRTN,3,3)#            Print refine scales
movechar:(RT0,FLGPRO*3+1,RTG,38,3,0)#  Insert refine profile
writeline:(0,RTG,NRTG,3,3)#            Print refine profile
movechar:(RT0,FLGCEL*3+1,RTH,38,3,0)#  Insert refine cell
writeline:(0,RTH,NRTH,3,3)#            Print refine cell
movechar:(RT0,FLGTDP*3+1,RTL,38,3,0)#  Insert refine tdp's
writeline:(0,RTL,NRTL,3,3)#            Print refine tdp's
movechar:(RT0,FLGUOV*3+1,RTP,38,3,0)#  Insert refine uov
writeline:(0,RTP,NRTP,3,3)#            Print refine uov
movechar:(RT0,FLGPOP*3+1,RTA,38,3,0)#  Insert refine population
writeline:(0,RTA,NRTA,3,3)#            Print refine population
movechar:(RT0,FLGPOF*3+1,RTK,38,3,0)#  Insert refine pref orient
writeline:(0,RTK,NRTK,3,3)#            Print refine pref orient
ncodefld:(DAMPST,1,RTD,400612.,1)#     Format damping structure
writeline:(0,RTD,NRTD,3,3)#            Print damping structure
ncodefld:(DAMPPR,1,RTE,400612.,1)#     Format damping profile
writeline:(0,RTE,NRTE,3,3)#            Print damping profile
ncodefld:(PEAKSP,1,RTM,400612.,1)#     Format peak span override
writeline:(0,RTM,NRTM,3,3)#            Print peak span override
movechar:(RTR,WTSCHM*5+1,RTQ,36,5,0)#  Insert step wt option flag
writeline:(0,RTQ,NRTQ,3,3)#            Print step wt option flag
ncodefld:(NSKIP,1,RTS,400613.,1)#      Format step skip value
writeline:(0,RTS,NRTS,3,3)#            Print step skip value
movechar:(RT0,APPDSP*3+1,RT3,38,3,0)#  Insert apply disp flag
writeline:(0,RT3,NRT3,3,3)#            Print apply disp flag
ncodefld:(RFMATX,1,RT7,400702.,1)#     Format contribute ls
IF(RFMTRX<1.E7)writeline:(0,RT7,NRT7,3,3)# Print contribute l
#
RETURN#
END#
systemheader:(RT20)#                   Enter pattern parameters
# ############################################################# #
#                                                               #
#                              RT20                             #
#                                                               #
# ############################################################# #
SUBROUTINE RT20#
#
include:(AACOMN)#
include:(RTCOMN)#
#
INTEGER    LF#
INTEGER    FUNCNR#
#
chardata:(RT1, LIMITS WAVLEN BACKGR PEAKF PEAKSH EXCLTT $#
NOREF ZERO )#
chardata:(RT2,' Preset Pattern Parameters-')#
chardata:(RT3,' Preset two theta min/max                         ')#
chardata:(RT5,' Two theta zero correction ')#
chardata:(RT6,' Wavelength of pattern data             ')#
chardata:(RT7,' Polarization ratio for Lp              ')#
chardata:(RT8,' Background parameters ')#
chardata:(RT9,' 2theta exclusion limits                          ')#
chardata:(RTA,' Peak shape function  Lines  Pkspan  1/step')#
chardata:(RTB,MO CU )#
chardata:(RTC,B1 B2 B3 B4 B5 Z1 Z2 )#
realdata:(FMT,[400532.,500532.,600532.,700532.,800532.])#
datastuff:#
#
#    SET DEFAULT PARAMETERS
#    -----------------------
#
IBAC=no:; NEXCLR=0#                    Two theta exclusion zones
TTMINL=0.0; TTMAXL=180.0; TTSTEP=.02#  Default tth limits
TTMINR=1000.; TTMAXR=0.#               Start refln 2theta limits
LAMBDA=1.540598;    SPAN=0.#           Set default rad to cu
HWDMAX=0.;    NREFL=0#                 Half width max
POLRA=0.915#                           Default polarization ratio
NPEAKF=0#                              Nr of peak shape functions
DO I=1,10; PSHFPT(I)=0#                Pkshp table pointer array
DO I=1,10; PSHFLN(I)=0#                Pkshp table length array
DO I=1,10; PSHFST(I)=0.0#              Pkshp table stepsz array
DO I=1,10; EXCLRL(I)=0.0#              Two theta exclusion limit lo
DO I=1,10; EXCLRH(I)=0.0#              Two theta exclusion limit hi
DO I=1,2;  PARZER(I)=0.0#              Default zero corrections
DO I=1,2;  REFZER(I)=FLGZER#           Default zero pt refinement
DO I=1,5;  PARBAC(I)=0.0#              Default background params
DO I=1,5;  REFBAC(I)=FLGBAC#           Default background refinement
LF=MARKF;    NEWM=MARKF#               Peak shape array markers
#
#   LOOP OVER GENERAL PARAMETER LINES
#   ---------------------------------
#
REPEAT#                                Loop over pattern lines
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
readline:(RT1,-NRT1)#                  Read next input line
IF(LINID==0) BREAK#                    Exit when not recognised
#
IF(LINID==1)#                          ******** limits ************
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
ifnv:(BUFIN(1)) TTMINL=BUFIN(1)#       Preset min two theta limit
ifnv:(BUFIN(2)) TTMAXL=BUFIN(2)#       Preset max two theta limit
ifnv:(BUFIN(3)) TTSTEP=BUFIN(3)#       Two theta step (pattern)
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
#
ELSE IF(LINID==2)#                     ********* wavlen ************
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
ifnm:(BUFIN(1)) LAMBDA=BUFIN(1)#       Set to value on line
ifch:(BUFIN(1))#                       String code encountered
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
stringlim:(1,J,K)#                     Get string limits
compchar:(CHRIN,J,RTB,1,2,3,NRTB,K)#   Test for cu, mo
IF(K==0) iquit:(RT2010)#               Unknown wavelength
IF(K==1) LAMBDA=0.70926#               Set to mo k alpha value
ELSE     LAMBDA=1.540598#              Set to cu k alpha value
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
ifnm:(BUFIN(2)) POLRA=BUFIN(2)#        Set polarisation ratio
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
#
ELSE IF(LINID==3)#                     ********* backgr ***********
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5
IBAC=yes:#                             Set backgr flag
DO I=1,5; ifnm:(BUFIN(I)) PARBAC(I)=BUFIN(I)# Background parameters
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5
#
ELSE IF(LINID==4)#                     ******** peakf *************
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6
IF(NPEAKF>=10) iquit:(RT2301)#         Up to 10 pkshp fns allowed
NPEAKF=NPEAKF+1#                       Count nr pkshp functions
ifnm:(BUFIN(1)) FUNCNR=BUFIN(1)#       Current pkshp function number
ELSE            FUNCNR=1#              Default function counter =1
ifnm:(BUFIN(2)) PEAKSP=BUFIN(2)#       Store peak span
IF(PEAKSP>0.) PKSPAN(FUNCNR)=PEAKSP#   Override with input value
span:=MAX(span:,PKSPAN(FUNCNR))#       Get maximum peak span
IF(FUNCNR>10) iquit:(RT2301)#          Up to 10 pkshp fns allowed
PSHFPT(FUNCNR)=LF#                     Start address for function
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6
#
ELSE IF(LINID==5)#                     ******** peaksh ************
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7
incrqx:(NEWM,LF+5,RT2302)#             Space for one pkshp fn entry
PSHFLN(FUNCNR)=PSHFLN(FUNCNR)+1#       Count lines for function
QX(LF+1)=BUFIN(1)#                     Ri - delta 2theta/halfwidth
QX(LF+2)=BUFIN(2)#                     Fsi - symmetric part
QX(LF+3)=BUFIN(3)#                     Fai - asymmetric part
QX(LF+4)=BUFIN(4)#                     Dfsi - deriv. of sym. part
QX(LF+5)=BUFIN(5)#                     Dasi - deriv. of asym. part
LF=NEWM#                               5 items per entry increment
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7
#
ELSE IF(LINID==6)#                     ******** excltt ************
FOR(I=1;BUFIN(I)>voidflg:;I=I+2)#      Loop over pairs of limits
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8
NEXCLR=NEXCLR+1#                       Count the exclusion limits
IF(NEXCLR>10) iquit:(RT2310)#          Exclude zones exceeded
EXCLRL(NEXCLR)=BUFIN(I)#               Store 2theta excl low limit
EXCLRH(NEXCLR)=BUFIN(I+1)#             Store 2theta excl high limit
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8
#
ELSE IF(LINID==7)#                     ******** noref ************
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9
FOR(I=1;BUFIN(I)<voidflg:;I=I+1)#      5 bac, 2 zer pars possible
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10
stringlim:(I,N,M)#                     Take first 2 chars in field
compchar:(CHRIN,N,RTC,1,2,3,NRTC,K)#   B1 b2 b3 b4 b5 z1 z2
IF(K==0) iquit:(RT2040,I)#             Unknown pattern param
IF(K<6) REFBAC(K)=0#                   Noref background parameters
ELSE    REFZER(K-5)=0#                 Noref pattern zero parameters
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9
#
ELSE IF(LINID==8)#                     ********* zero ***********
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11
DO I=1,2; ifnm:(BUFIN(I)) PARZER(I)=BUFIN(I)# Zero point parameters
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11
#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
#
LINRM=8#                               Ensure print space 12 lines
movechar:(RT2,NRT2,CHROT,2,NRT2-2,1)#  Insert header underline
writeline:(1,RT2,NRT2-1,2,3)#          Print header
ncodefld:(LAMBDA,1,RT6,400952.,1)#     Encode wavelength for msg
writeline:(0,RT6,NRT6,3,3)#            Write wavlen
ncodefld:(POLRA,1,RT7,400952.,1)#      Encode polariz ratio for msg
writeline:(0,RT7,NRT7,3,3)#            Write polra
ncodefld:(TTMINL,1,RT3,400932.,1)#     Encode min preset 2theta limit
ncodefld:(TTMAXL,1,RT3,500932.,1)#     Encode max preset 2theta limit
writeline:(0,RT3,NRT3,3,3)#            Write the line#
#
movechar:(RT5,1,CHROT,1,NRT5,0)#       Insert tth zero corrections#
ncodefld:(PARZER,1,CHROT,FMT,2)#       Encode tth zero corrections
DO I=1,2#                              Loop cell refine flags
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12
M=NINT(FMT(I))/10000+1#                Letter position
IF(REFZER(I)==0) CHROT(M^M)='n'#       Noref this par
IF(REFZER(I)==1) CHROT(M^M)='r'#       Flag as ref
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12
writeline:(0,0,0,1,3)#                 Print cell param values
#
movechar:(RT8,1,CHROT,1,NRT8,0)#       Format background parameters
ncodefld:(PARBAC,1,CHROT,FMT,5)#       Format background parameters
DO I=1,5#                              Loop cell refine flags
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13
M=NINT(FMT(I))/10000+1#                Letter position
IF(REFBAC(I)==0) CHROT(M^M)='n'#       Noref this par
IF(REFBAC(I)==1) CHROT(M^M)='r'#       Flag as ref
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13
writeline:(0,0,0,1,3)#                 Print cell param values
#
IF(NPEAKF>0) writeline:(0,RTA,NRTA,3,3)# Table heading & parameters
DO I=1,NPEAKF#                         Loop peak functions
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14
J=PSHFPT(I); IF(J==0) NEXT#            Skip undefined functions
L=PSHFLN(I); K=J+(L-1)*5#              Pt to last entry
PSHFST(I)=FLOAT(L-1)/QX(K+1)#          Nsteps/range = 1/stepsz
ncodefld:(FLOAT(I),1,CHROT,210213.,1)# Encode func nr
ncodefld:(FLOAT(PSHFLN(I)),1,CHROT,270413.,1)# Func table length
ncodefld:(QX(K+1),1,CHROT,350722.,1)#  Func table range
ncodefld:(PSHFST(I),1,CHROT,440732.,1)# Func table 1/stepsz
writeline:(0,0,0,1,3)#                 Table heading & parameters
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14
#
IF(NEXCLR>0) writeline:(1,RT9,NRT9,3,3)# Table heading & parameters
DO I=1,NEXCLR#                         Loop over 2theta excl regions
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15
ncodefld:(EXCLRL(I),1,CHROT,400932.,1)# Format the lower 2theta limit
ncodefld:(EXCLRH(I),1,CHROT,500932.,1)# Format the higher 2theta limi
writeline:(0,0,0,1,3)#                 Write exclusion limits
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15
#
##PEAKSP=SPAN#                           Save maximum peak span value
SAVEID=COMPID#                         Save the original compid
#
RETURN#
END#
systemheader:(RT30)#                   Enter cell, symm, expl, dset
####################################################################
#                                                                  #
#                               RT30                               #
#                                                                  #
####################################################################
SUBROUTINE RT30#
#
include:(AACOMN)#
include:(RTCOMN)#
#
INTEGER I,J,K,M,N#
#
chardata:(RT1, PHASE PEAK HWIDTH PASYMM ORIENT $#
SELECT CONSTR NOREF RESTR END )#
datastuff:#
#
#   START OF NEW CRYSTAL PHASE
#   --------------------------
#
IF(NPH>maxpha:) iquit:(RT3000)#        Max phases -- ip error?
#
#    STORE DEFAULT PARAMETERS
#    ------------------------
#
PHASE(NPH)=SAVEID#                     Compid is default phase
dset:=1.#                              Default dataset number
scal:=1.#                              Default sf scale per phase
scalflg:=FLGSKF#                       Default refine scale factor
REFUOV(NPH)=FLGUOV#                    Default noref uov
REFPOF(NPH)=FLGPOF#                    Default noref preferred orient
PARPOF(NPH)=0.0#                       Preferred orient parameter
DO I=1,3;  POFVEC(NPH,I)=0.0#          Preferred orient vector
DO I=1,6;  REFPRO(NPH,I)=FLGPRO#       Peak profile refinement flags
DO I=2,6;  PARPRO(NPH,I)=0.0#          Peak profile parameters
PARPRO(NPH,1)=.01#                     Default hwifth u parameter
pkprofnr:=11.#                         Default gaussian peak profile
#
readline:(RT1,NRT1)#                   Read another input line
#
IF(LINID==1)#                          ******** phase ***********
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
DO I=1,2#                              Loop input fields
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
ifvo:(BUFIN(I)) BREAK#                 Exit on blank
ifch:(BUFIN(I))#                       If char string
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
stringlim:(I,J,K)#                     Get string limits
PHASE(NPH)=CHRIP(J^K)#                 Store new phase code
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
ELSE scal:=BUFIN(I)#                   Store phase scale
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
readline:(RT1,NRT1)#                   Read another input line
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
#
#      OPEN THE APPROPRIATE ARCHIVE BDF
#      --------------------------------
#
COMPID=PHASE(NPH)#                     Set current compid
mcell:=NEWM;  ncell:=9#                Start of cell data
incrqx:(NEWM,NEWM+100,RT3001)#         Memory for cell data
readwpkt:(1,lrlabl:,PACK,IP,0)#        Enter bdf history
#
#      READ LRCELL: DATA
#      -----------------
#
DO I=1,8#                              Loop over cell packets
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
readwpkt:(1,lrcell:,PACK,IP,0)#        Cell information
IF(IP<=0) iquit:(RT3002)#              Insufficient cell packets
IF(I==1) movereal:(QX,IP+1,dcp:,1,9,0)# Direct cell parameters
IF(I==2) movereal:(QX,IP+1,dce:,1,9,0)# Direct cell esd's
IF(I==3) movereal:(QX,IP+1,rcp:,1,9,0)# Reciprocal cell parameters
IF(I==4) movereal:(QX,IP+1,tfc:,1,9,0)# Transformation fract to cart
IF(I==5) movereal:(QX,IP+1,tcf:,1,9,0)# Transformation cart to fract
IF(I==7) movereal:(QX,IP+1,dmt:,1,9,0)# Dmt direct metric tensor
IF(I==8) movereal:(QX,IP+1,rmt:,1,9,0)# Rmt recipr metric tensor
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
DO I=1,3#                              Loop over axes/angles
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5
cub:(I)=.25*rcp:(I)**2#                Conversion u to beta
cbu:(I)=1.266515/cub:(I)#              Conversion beta to 100*u
dcp:(I+6)=360.*dcp:(I+6)#              Dcp cycles to deg
rcp:(I+6)=360.*rcp:(I+6)#              Rcp cycles to deg
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5
cub:(4)=.25*rcp:(1)*rcp:(2)*rcp:(6)#   Conversion u to beta
cub:(5)=.25*rcp:(1)*rcp:(3)*rcp:(5)#   Conversion u to beta
cub:(6)=.25*rcp:(2)*rcp:(3)*rcp:(4)#   Conversion u to beta
cbu:(4)=5.06606/(rcp:(1)*rcp:(2))#     Conversion beta to u
cbu:(5)=5.06606/(rcp:(1)*rcp:(3))#     Conversion beta to u
cbu:(6)=5.06606/(rcp:(2)*rcp:(3))#     Conversion beta to u
DO I=1,3#                              Sine theta conversion
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6
stc:(I)  =cub:(I)#                     .25*(a*)sq etc.
stc:(I+3)=2.*cub:(I+3)#                .5*(a*)(b*)(cosc*) etc.
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6
#
#     READ LRSYMM: DATA
#     -----------------
#
lcell:=NEWM;   MARK=NEWM#              End of cell data
msymm:=MARK;   nsymm:=12#              Start of symmetry packets
FOR(;MARK>0;MARK=NEWM)#                Loop over rot. matrices
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7
readwpkt:(1,lrsymm:,PACK,IP,0)#        Read next symmetry packet
IF(IP<=0) BREAK#                       Exit after last packet
incrqx:(NEWM,MARK+nsymm:,RT3004)#      Get memory
movereal:(QX,IP+1,QX,MARK+1,12,0)#     Move rotation matrix+vector
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7
#
#    SET CELL REFINEMENT PARAMETERS
#    ------------------------------
#
I=msymm:;  N=QX(I+9);   M=QX(I+10)#    Extract crystal system & axis
J=MOD(M,3)+1;   K=MOD(J,3)+1#          Get alternative axes
DO I=1,6; REFCEL(NPH,I)=0#             Set all cell par noref
IF(FLGCEL==yes:)#                      If cell refined
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8
IF(N==1)      DO I=1,6; REFCEL(NPH,I)=1# Tri refine all parameters
IF(N==2\N==3) DO I=1,3; REFCEL(NPH,I)=1# Mon/ort refine a b c
IF(N==2\N==6) REFCEL(NPH,M+3)=1#       Mon/rhom refine unique angle
IF(N==6)      REFCEL(NPH,J+3)=M+13#    Rhom dependent angle
IF(N==6)      REFCEL(NPH,K+3)=M+13#    Rhom dependent angle
IF(N==4\N==5\N==7)#                    For tet/trig/hex
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9
REFCEL(NPH,M)=1; REFCEL(NPH,J)=1; REFCEL(NPH,K)=J+10# Two cell length
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9
IF(N==6\N==8)#                         For rhom/cub
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10
REFCEL(NPH,1)=1; REFCEL(NPH,2)=11; REFCEL(NPH,3)=11# One cell length
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8
#
#     READ LRSCAT: DATA
#     -----------------
#
lsymm:=NEWM;    MARK=NEWM#             Save end of scat factors
mscat:=MARK#                           Start of scat factors
IWNT(1)=NINT(dset:)+20;  IWNT(3)=100#  Set real ad & ff idnums
IWNT(2)=NINT(dset:)+60;  IWNT(4)=10#   Set imag ad & neut ff
IWNT(5)=11 ;  IWNT(6)=7; IWNT(7)=1#    Set sf name idnum
setkey:(1,7,0,0)#                      Set search signals
indexpkt:(1,lrscat:,PACK,IP,0,KEY,IWNT,IREL)# Get pointers
IF(IP<=0) iquit:(RT3005)#              No lrscat packet there
#
FOR(I=IP+IREL(3);I<=IP+PACK;I=I+1)#    Loop over ff list
IF((QX(I)<99.5)\(QX(I)>299.5)) BREAK#  Exit after last ff
IF(IREL(3)>0) ISCF=I-IP-IREL(3)#       Count contiguous ff
ELSE          ISCF=0#                  Ff table not present
IF(IREL(4)>0) ISCF=1#                  Count neutron ff
IF(IREL(3)>0) DSCF=(QX(I-1)-QX(I-2))*.01# Set st/l interval
nscat:=ISCF+5;   NSCF=0#               Set stored packet size
#
FOR(J=MARK;J>0;J=NEWM)#                Loop over each atom type
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11
readwpkt:(1,lrscat:,LPAK,IP,0)#        Get packet pointer
IF(IP<=0) BREAK#                       Exit after last packet
incrqx:(NEWM,J+nscat:,RT3008)#         Get packet memory
movereal:(QX(IP+IREL(5)),1,QX,J+1,2,0)# Store scat fac name
I=IP+IREL(7); IF(I>IP) ifnv:(QX(I)) QX(J+3)=QX(I)# Get atoms/cell
I=IP+IREL(1); IF(I>IP) ifnv:(QX(I)) QX(J+4)=QX(I)# Get real disp
I=IP+IREL(2); IF(I>IP) ifnv:(QX(I)) QX(J+5)=QX(I)# Get imag disp
I=IP+IREL(4); IF(I>IP) ifnv:(QX(I)) QX(J+6)=QX(I)# Store neutron ff
IF(ISCF>1)DO I=1,ISCF; QX(J+I+5)=QX(IP+IREL(3)+I-1)# Store scat fact
IF(IREL(6)>0) BDFSCF=NINT(QX(IP+IREL(6)))# Lrrefl: ff flag present
ELSE          BDFSCF=no:#              Ff are not in lrrefl:
NSCF=NSCF+1#                           Count atom types
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11
#
#     READ LREXPL: DATA
#     -----------------
#
IWNT(1)=1;  IWNT(2)=94#                Set radiation type
setkey:(2,0,0,0)#                      Set search signals
indexpkt:(1,lrexpl:,PACK,IP,0,KEY,IWNT,IREL)# Search directory
IF(IP<=0) iquit:(RT3010)#              Lrexpl: not there
REPEAT#                                Loop over lrexpl pkts
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12
readwpkt:(1,lrexpl:,PACK,IP,0)#        Read lrexpl: packet
IF(IP<=0) BREAK#                       Lr ended too soon
ifne:(dset:,QX(IP+IREL(1))) NEXT#      Skip incorrect datasets
RADTYP=NINT(QX(IP+IREL(2)))#           Store rad (1=neu,2=el;3=x)
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12
#
#     READ LRDSET: DATA
#     -----------------
#
IWNT(1)=1;  IWNT(2)=2#                 Set uov
setkey:(2,0,0,0)#                      Set search signals
indexpkt:(1,lrdset:,PACK,IP,0,KEY,IWNT,IREL)# Search directory
IF(IP<=0) iquit:(RT3011)#              Lrdset: not there
REPEAT#                                Loop over lrdset pkts
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13
readwpkt:(1,lrdset:,PACK,IP,0)#        Read lrdset: packet
IF(IP<=0) BREAK#                       Lr ended too soon
ifne:(dset:,QX(IP+IREL(1))) NEXT#      Skip incorrect datasets
UOV(NPH)=(QX(IP+IREL(2)))#             Store uov
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13
#
#    STORE PREFERRED ORIENT & PEAK PROFILE PARAMETERS
#    ------------------------------------------------
#
lscat:=NEWM;     MARK=NEWM#            End of atom type data
mpeak:=MARK;     npeak:=16#            Start of halfwidth parameters
incrqx:(NEWM,MARK+npeak:,RT3022)#      Get memory for halfwidth
DO I=1,npeak:;  QX(MARK+I)=0.0#        Default values
#
REPEAT#                                Loop over peak option lines
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14
#
IF(LINID==2)#                          ********** peak **********
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15
QX(MARK+1)=pkprofnr:#                  Default profile function
QX(MARK+2)=PEAKSP#                     Default peak span
QX(MARK+11)=PARPRO(NPH,6)#             Default mixing parameter
ifnm:(BUFIN(1)) QX(MARK+1)=BUFIN(1)#   Store peak shape function id
ifch:(BUFIN(1))#
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16
stringlim:(1,J,K)#                     Get string limits
IF(CHRIP(J^J)=='v') QX(MARK+1)=12.#    Pseudo-voigt
IF(CHRIP(J^J)=='g') QX(MARK+1)=11.#    Gaussian
IF(CHRIP(J^J)=='l') QX(MARK+1)=10.#    Lorentzian
IF((QX(MARK+1)<10.)\(QX(MARK+1)>12.)) iquit:(RT3030)# Unknown peakfn
QX(MARK+11)=QX(MARK+1)-10.#            Default mixing parameter
IF(CHRIP(J^J)=='v') QX(MARK+11)=0.5#   Default mixing parameter
IF(CHRIP(J^J)!='v') REFPRO(NPH,6)=no:# Force noref mix
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16
ifnm:(BUFIN(2)) QX(MARK+2)=BUFIN(2)#   Store peak span
ifnm:(BUFIN(3)) QX(MARK+11)=BUFIN(3)#  Store mixing parameter
span:=QX(MARK+2)#                      Store peak span
PARPRO(NPH,6)=QX(MARK+11)#             Store mix
pkprofnr:=QX(MARK+1)#                  Store function id
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15
#
ELSE IF(LINID==3)#                     ********** hwidth **********
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17
DO I=1,3; ifnm:(BUFIN(I)) PARPRO(NPH,I)=BUFIN(I)# Loop over the field
DO I=1,3; QX(MARK+I+2)=PARPRO(NPH,I)#  Store half width params u v w
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17
#
ELSE IF(LINID==4)#                     ********** pasymm **********
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18
DO I=1,2; ifnm:(BUFIN(I)) PARPRO(NPH,I+3)=BUFIN(I)# Loop over the fie
DO I=1,2; QX(MARK+I+5)=PARPRO(NPH,I+3)# Store peak asym params hw1 hw
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18
#
ELSE IF(LINID==5)#                     ********** orient **********
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19
ifnm:(BUFIN(1)) PARPOF(NPH)=BUFIN(1)#  Preferred orient factor
QX(MARK+8)=PARPOF(NPH)#                Store pref orient factor
DO I=1,3; ifnm:(BUFIN(I+1)) POFVEC(NPH,I)=BUFIN(I+1)# Pof vector
DO I=1,3; QX(MARK+I+8)=POFVEC(NPH,I)#  Store pof vector uvw
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19
ELSE BREAK#                            Exit if not peak parameter
readline:(RT1,NRT1)#                   Read next line
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14
#
RETURN#
END#
systemheader:(RT31)#                   Enter atom data
####################################################################
#                                                                  #
#                               RT31                               #
#                                                                  #
####################################################################
SUBROUTINE RT31#
include:(AACOMN)#
include:(RTCOMN)#
#
string:(NAME1,24)#
string:(NAME2,24)#
string:(LABEL,24)#
chardata:(RT1, PHASE PEAK HWIDTH PASYMM ORIENT $#
SELECT CONSTR NOREF RESTR END )#
datastuff:#
#
#    READ LRATOM: DATA
#    -----------------
#
lpeak:=NEWM;   MARK=NEWM#              End of width packets
matom:=MARK;   natom:=w24c:+17#        Start of atom packets
IWNT(1)=17#                            Request dataset pointer
IWNT(2)=21#                            Request atom multiplicity
IWNT(3)=22#                            Request scat fact number
IWNT(4)=23#                            Request tf type
IWNT(5)=24#                            Request atom group key
IWNT(6)=25#                            Spare (used for f')
IWNT(7)=26#                            Spare (used for f'')
DO I=1,11;    IWNT(I+ 7)=I#            Request x y z u uij pop
DO I=1,w24c:; IWNT(I+18)=14#           Request atom label
setkey:(0,natom:+1,0,0)#               Set search signals
indexpkt:(1,lratom:,PACK,IP,0,KEY,IWNT,IREL)# Search directory
ISEL=no:;  JJ=0#                       Initialise atom selection
#
FOR(IA=MARK;IA>0;IA=NEWM)#             Loop over atom packets
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
readwpkt:(1,lratom:,PACK,IP,0)#        Read an atom packet
IF(IP<=0) BREAK#                       End of logical record
IF(IREL(1)>0) ifne:(dset:,QX(IP+IREL(1))) NEXT# Check dataset
#
WHILE(LINID==6&ISEL==no:)#             ******** select *************
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
ifvo:(BUFIN(JJ+1))#                    Test if end of data
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
readline:(RT1,NRT1)#                   Read the next line
ISEQ=no:;  JJ=0;  NEXT#                Reset select pointers
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
JJ=JJ+1#                               Incr field pointer
ifnm:(BUFIN(JJ)) iquit:(RT3105)#       Number in select line
stringlim:(JJ,J,K)#                    Get string limits
DO J=I,K-1; IF(CHRIP(I^I)=='/') BREAK# Search for separator
NAME1=CHRIP(I^J-1)#                    Store first name
IF(J<K) NAME2=CHRIP(J+1^K-1)#          Store second name
ELSE    NAME2=' '#                     Blank if no 2nd name
ISEQ=yes:#                             Set sequence flag
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
movertoc:(QX(IP+IREL(19)),1,LABEL,1,24,0)# Store atom label
IF(ISEL!=no:)#                         Is select in force?
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
IF(J<K)#                               Is it a single label
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5
IF(NAME1!=LABEL) NEXT#                 Skip if no match
ISEL=no:#                              Reset the selection flag
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5
ELSE#                                  It is a sequence of labels
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6
IF(ISEL==1)#                           Find first label in sequence
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7
IF(NAME1!=LABEL) NEXT#                 Skip if no match
ISEL=2#                                Reset as start of sequence
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7
ELSE IF(NAME2==LABEL) ISEL=no:#        Find last label in sequence
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
#
incrqx:(NEWM,IA+natom:,RT3130)#        Get atom packet memory
DO I=1,natom:; IF(IREL(I+1)>0)#        Loop over requested atom data
movereal:(QX,IP+IREL(I+1),QX,IA+I,1,0)# Store atom data word
ID=mscat:+nscat:*(NINT(sf:)-1)+4#      Point to scat factor table
dr:=QX(ID);    di:=QX(ID+1)#           Store dispersion terms
ifeq:(dp:,2.)  QX(IA+10  )=voidflg:#   Void uiso if aniso dp
ELSE DO I=1,6; QX(IA+10+I)=voidflg:#   Void uij if uiso
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
#
#    INPUT CONSTRAINTS FROM LRCONS:
#    ------------------------------
#
latom:=NEWM;    MARK=NEWM#             End of atom packets
mcons:=NEWM;    ncons:=8#              Start of constraints data
DO I=1,3; IWNT(I  )=I#                 Subj labl/par/mul
DO I=1,3; IWNT(I+3)=I+10#              Ref  labl/par/mul
DO I=1,2; IWNT(I+6)=I+3#               Constant q & type
setkey:(8,0,0,0)#                      Set search signals
indexpkt:(1,lrcons:,PACK,IP,0,KEY,IWNT,IREL)# Search directory
IF(IP>0)#                              If constraints present
FOR(J=MARK;J>0;J=NEWM)#                Loop all the packets
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8
readwpkt:(1,lrcons:,PACK,IP,0)#        Read next constraint pkt
IF(IP<=0) BREAK#                       End of logical record
incrqx:(NEWM,J+8,RT3130)#              Get constraints packet
DO I=1,8; movereal:(QX,IP+IREL(I),QX,J+I,1,0)# Store constraints
IF(QX(J+2)>3.) QX(J+2)=QX(J+2)+1.#     Shift uij 4-9 to 5-10
IF(QX(J+5)>3.) QX(J+5)=QX(J+5)+1.#     Shift uij 4-9 to 5-10
movertoc:(QX(IP+IREL(1)),1,NAME1,1,24,0)# Store subj atom name
movertoc:(QX(IP+IREL(4)),1,NAME2,1,24,0)# Store ref  atom name
I=0#                                   Reset atom count
FOR(IA=matom:;IA<latom:;IA=IA+natom:)# Loop atoms
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9
I=I+1#                                 Count atoms
movertoc:(na:,1,LABEL,1,24,0)#         Store atom label
IF(NAME1==LABEL) QX(J+1)=FLOAT(I)#     Store atom pointer
IF(NAME2==LABEL) QX(J+4)=FLOAT(I)#     Store atom pointer
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9
ifeq:(QX(J+8),3.) QX(J+5)=QX(J+2)#     Set parameters same for noref
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8
#
RETURN#
END#
systemheader:(RT32)#                   Enter constr and noref lines
###################################################################
#                                                                 #
#                            RT32                                 #
#                                                                 #
###################################################################
SUBROUTINE RT32#
include:(AACOMN)#
include:(RTCOMN)#
#
INTEGER I,J,K,L,N,M#
#
string:(NAME1,24)#
string:(NAME2,24)#
string:(LABEL,24)#
string:(SFT,128)#
string:(C,1)#
chardata:(NUM,0123456789.)#
chardata:(RT1, PHASE PEAK HWIDTH PASYMM ORIENT $#
SELECT CONSTR NOREF RESTR END )#
chardata:(RT2,X  Y  Z  U  U11U22U33U12U13U23POP )#
chardata:(RT3,SKFUOVPOF )#
chardata:(RT4,A  B  C  AL BE GA )#
chardata:(RT5,U  V  W  X  Y  MIX )#
datastuff:#
#
#    STORE SCAT FACTOR TABLE
#    -----------------------
#
J=1#                                   Start scat factor pointer
FOR(I=mscat:;I<lscat:;I=I+nscat:)#     Loop over scat factors
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
movertoc:(QX(I+1),1,SFT,J,8,0)#        Form scat fact table
J=J+8#                                 Incr scat factor pointer
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
#
#   ENTER CONSTRAINT LINES
#   ======================
##  EXAMPLE: X(C3)=1.+.5*X(C1)
##           subpar(subatm)=Q+refmul*refpar(refatm)
#    QX()      +2     +1   +7   +6    +5      +4
#
FOR(IC=NEWM;LINID==7;IC=NEWM)#         Loop over constr lines
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
JC=7; CHRIN='constr  '#                Character counter
#
FOR(I=7;I<=CHRMAX;I=I+1)#              Scan the constr line
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
C=CHRIP(I^I)#                          Extract the character
IF(C==' ') NEXT#                       Skip blanks
IF(C==':') BREAK#                      Exit if colon encountered
JC=JC+1#                               Incr output char pointer
IF(C=='(')#                            Test start of atom part
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
FOR(J=I+1;CHRIP(J^J)!=')'&J<=CHRMAX;J=J+1)# Loop over atom label
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5
JC=JC+1;   CHRIN(JC^JC)=CHRIP(J^J)#    Transfer label char
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5
JC=JC+1;   I=J#                        Incr output char pointer
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
ELSE IF(C=='+'\C=='-')#                For sign characters
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6
JC=JC+1#                               Incr output counter
IF(INDEX(NUM,CHRIP(I+1^I+1))>0) CHRIN(JC^JC)=C# Transfer sign char
ELSE#
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7
CHRIN(JC^JC+2)=C//'1 '; JC=JC+3#       This is the multiplier
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6
ELSE IF(C=='='\C=='*');#               For operator character
ELSE CHRIN(JC^JC)=C#                   Transfer character
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
#
CHRIP=CHRIN#                           Transfer stripped constr to bu
upcase:(CHRIP,CHRIN,CHRMAX); dcodefld:# Restore and apply decode
incrqx:(NEWM,IC+8,RT3210)#             One more constraint packet
QX(IC+8)=1.0#                          Flag as constraint packet
#
ifnm:(BUFIN(1)) iquit:(RT3215)#        Not param code
stringlim:(1,M,N)#                     Subject parameter
compchar:(CHRIN,M,RT2,1,N-M,3,NRT2,K)# Identify
IF(K==0) iquit:(RT3216)#               Param not in list
QX(IC+2)=FLOAT(K)#                     Store parameter number
#
ifnm:(BUFIN(2)) iquit:(RT3217)#        Not atom label
stringlim:(2,M,N)#                     Subject atom label
NAME1=CHRIP(M^N-1)#                    Store subj atom label
#
QX(IC+3)=1.0#                          Subj multipler
ifch:(BUFIN(3)) JC=3#                  Test if constant present
ELSE#                                  Constant is present
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8
QX(IC+7)=BUFIN(3);  JC=4#              Constraint constant q
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8
ifch:(BUFIN(JC)) QX(IC+6)=1.0#         Default multipler is 1.0
ELSE#                                  Multiplier is present
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9
QX(IC+6)=BUFIN(JC); JC=JC+1#           Constraint ref multiplier
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9
#
ifnm:(BUFIN(JC)) iquit:(RT3218)#       Not param code
stringlim:(JC,M,N)#                    Reference parameter
compchar:(CHRIN,M,RT2,1,N-M,3,NRT2,K)# Identify
IF(K==0) iquit:(RT3219)#               Param not in list
QX(IC+5)=FLOAT(K)#                     Store parameter number
#
ifnm:(BUFIN(JC+1)) iquit:(RT3220)#     Not atom label
stringlim:(JC+1,M,N)#                  Reference atom label
NAME2=CHRIP(M^N-1)#                    Store ref  atom label
J=0#                                   Set atom count
FOR(IA=matom:;IA<latom:;IA=IA+natom:)# Loop atoms list
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10
J=J+1#                                 Set atom count
movertoc:(na:,1,LABEL,1,24,0)#         Store atom label
IF(NAME1==LABEL) QX(IC+1)=FLOAT(J)#    Store subj atom pointer
IF(NAME2==LABEL) QX(IC+4)=FLOAT(J)#    Store ref  atom pointer
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10
readline:(RT1,NRT1)#                   Read next line
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
#
#    ENTER NOREF LINES
#    -----------------
##   Examples: NOREF C C1 X(C) X(C1) (X/Z)(C1/C10) POP(Ni)
##             noref prof v w y mix
##             noref cell c
#
FOR(IC=NEWM;LINID==8;IC=NEWM)#         Loop over noref lines
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11
stringlim:(1,N,M);   JC=0#             Get first string limits
#
IF(CHRIN(N^N+3)=='CELL')#              ********** cell ************
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12
IF(FLGCEL==no:) NEXT#                  Ignore noref if not refined
ifvo:(BUFIN(2)) DO I=1,6; REFCEL(NPH,I)=no:# Noref a b c al be ga
FOR(I=2;BUFIN(I)<voidflg:;I=I+1)#      Max of 6 params possible
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13
stringlim:(I,N,M)#                     Take first 3 chars in field
compchar:(CHRIN,N,RT4,1,2,3,NRT4,K)#   Cell param names
IF(K==0) iquit:(RT3234,I)#             Unknown cell param
REFCEL(NPH,K)=0#                       Noref parameter (1 to 6)
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12
#
ELSE IF(CHRIN(N^N+3)=='PROF')#         ********** prof *************
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14
IF(FLGPRO==no:) NEXT#                  Ignore noref if not refined
ifvo:(BUFIN(2)) DO I=1,6; REFPRO(NPH,I)=no:# Noref u v w x y mix
FOR(I=2;BUFIN(I)<voidflg:;I=I+1)#      Max of 6 params possible
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15
stringlim:(I,N,M)#                     Take first char in field
compchar:(CHRIN,N,RT5,1,1,3,NRT5,K)#   Peak profile param names
IF(K==0) iquit:(RT3235,I)#             Unknown prof param
REFPRO(NPH,K)=0#                       Noref profile parameters
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14
#
ELSE#                                  *** atom & general params ***
FOR(NF=1;BUFIN(NF)<voidflg:;NF=NF+1)#  Loop over line fields
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16
JC=0;   NA=0;   NP=0#                  Set char and param counts
stringlim:(NF,N,M)#                    Take first 3 chars in field
IF(CHRIN(N^N)==':') BREAK#             Exit if ':' encountered
compchar:(CHRIN,N,RT3,1,3,3,NRT3,K)#   Look for skf uov pof
IF(K>0)#                               Found general param name
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17
IF(K==1) REFSKF(NPH)=no:#              Noref skf
IF(K==2) REFUOV(NPH)=no:#              Noref uov
IF(K==3) REFPOF(NPH)=no:#              Noref pof
NEXT#
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17
incrqx:(NEWM,IC+ncons:,RT3210)#        One more constraint packet
QX(IC+8)=3.#                           Signal noref
FOR(I=N;I<M;I=I+1)#                    Loop chars in string
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18
IF(CHRIP(I^I)=='(') NEXT#              Skip leading parenthesis
JC=JC+1; IF(JC==1) J=I#                Store 1st char position
C=CHRIP(I+1^I+1)#                      Get next character
IF(C!='('&C!=')'&C!='/'&C!=' ') NEXT#  Test for next delimitor
I=I+1#                                 Incr over the delimitor
compchar:(CHRIN,J,RT2,1,I-J,3,NRT2,K)# Look for param names
IF(K>0)#                               Test if a parameter
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19
NP=NP+1; ; IF(NP>2) iquit:(RT3230)#    Incr parameter count
QX(IC+NP*3-1)=FLOAT(K)#                Store parameter number x-pp
JC=0;   NEXT#                          Skip to next string
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19
NA=NA+1; IF(NA>2) iquit:(RT3231)#      Count atom labels
NAME1=CHRIP(J^I-1)#                    Store atom label
FOR(IA=matom:;IA<latom:;IA=IA+natom:)# Loop atoms
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20
movertoc:(na:,1,LABEL,1,24,0)#         Store atom label
IF(NAME1==LABEL) BREAK#                Exit if match found
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20
IF(IA<latom:)#                         Atom label has been matched
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21
QX(IC+NA*3-2)=FLOAT((IA-matom:)/natom:+1)# Store atom number
JC=0;   NEXT#                          Skip to next string
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21
label:(NAME1,K,L,SFT,N)#               Test if a scat factor
IF(K==L&N>0)#                          This is a scat factor only
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22
QX(IC+1)=FLOAT(N); QX(IC+8)=2.#        Set atom type noref
JC=0;   NEXT#                          Skip to next string
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22
iquit:(RT3240,NF)#                     String not recognised
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16
ifeq:(QX(IC+4),0.) QX(IC+4)=QX(IC+1)#  Set same atom numbers
ifeq:(QX(IC+2),0.)#                    Was parameter set
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23
QX(IC+2)=1.; QX(IC+5)=11.#             Assume all paramters
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23
ELSE ifeq:(QX(IC+5),0.) QX(IC+5)=QX(IC+2)# Set same as subj parameter
readline:(RT1,NRT1)#                   Get next input line
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11
#
SYNTXF=0#                              Turn syntax flag on again
#
RETURN#
END#
systemheader:(RT33)#                   Convert constr to refine flags
####################################################################
#                                                                  #
#                             RT33                                 #
#                                                                  #
####################################################################
SUBROUTINE RT33#
include:(AACOMN)#
include:(RTCOMN)#
#
INTEGER I,J,N#
#
#   DEFINE REFINEMENT FLAGS FOR GENERAL VARIABLES
#   ---------------------------------------------
#
lcons:=NEWM;    MARK=NEWM#             End of constraints
mflag:=MARK;    nflag:=11#             Start of matrix elements
incrqx:(NEWM,MARK+nflag:,RT3305)#      General param packet 1
QX(MARK+1)=FLOAT(REFSKF(NPH))#         Phase scale refine flag
QX(MARK+2)=FLOAT(REFPOF(NPH))#         Pref orient refine flag
DO I=1,6; QX(MARK+I+2)=FLOAT(REFPRO(NPH,I))# Profile refine flags
QX(MARK+9)=FLOAT(REFUOV(NPH))#         Uov refine flag
DO I=1,2; QX(MARK+I+9)=0.0#            Spare
MARK=NEWM#                             Incr memory pointer
incrqx:(NEWM,MARK+nflag:,RT3305)#      General param packet 2
DO I=1,6; QX(MARK+I  )=FLOAT(REFCEL(NPH,I))# Cell param ref flags
DO I=1,5; QX(MARK+I+6)=0.0#            Spare
MARK=NEWM#                             Incr memory pointer
#
#   DEFINE REFINEMENT FLAGS FOR ATOMIC VARIABLES
#   --------------------------------------------
#
FOR(IA=matom:;IA<latom:;IA=IA+natom:)# Loop over the atoms
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
incrqx:(NEWM,MARK+nflag:,RT3305)#      Get atom matrix packet
DO I=1, 3;      QX(MARK+I)=1.#         Set x,y,z refinements
DO I=4,10;      QX(MARK+I)=FLOAT(FLGTDP)# Set tdp refinements
ifeq:(dp:,2.)   QX(MARK+4)=0.#         If anisotropic noref u
ELSE DO I=5,10; QX(MARK+I)=0.#         If isotropic noref uij
IF(FLGPOP==no:) QX(MARK+11)=0.#        Noref pop if not refined
#IF(REFPOL>0)    QX(MARK+REFPOL)=0.##Noref polar axis if required ??
MARK=NEWM#                             Reset matrix pointer
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
lflag:=NEWM#                           Mark the end of the matrix
#
#    APPLY CONSTRAINTS TO REFINEMENT FLAGS
#    -------------------------------------
#
N=mflag:+nflag:#                       Pt to 1st atom noref flag
FOR(IC=mcons:;IC<lcons:;IC=IC+ncons:)# Loop over atom constraints
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
ifeq:(QX(IC+8),3.)#                    ******* noref atom **********
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
IA=NINT(QX(IC+1)); IP=NINT(QX(IC+2))#  Get subj atom and parameter
JA=NINT(QX(IC+4)); JP=NINT(QX(IC+5))#  Get ref atom and parameter
DO I=IA,JA; DO J=IP,JP; QX(N+I*11+J)=0.# Loop noref parameters
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
ELSE ifeq:(QX(IC+8),2.)#               ******* noref type **********
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
IP=NINT(QX(IC+2)); JP=NINT(QX(IC+5))#  Get parameter numbers
I=0#                                   Reset atom count
FOR(IA=matom:;IA<latom:;IA=IA+natom:)# Loop over the atoms
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5
I=I+1#                                 Count atoms
ifne:(sf:,QX(IC+1)) NEXT#              Skip if wrong scat factor
DO J=IP,JP; QX(N+I*11+J)=0.#           Loop noref parameters
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
ELSE#                                  ******* constraint *********
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6
IA=NINT(QX(IC+1))*11; IP=NINT(QX(IC+2))# Get subj atom and parameter
JA=NINT(QX(IC+4))*11; JP=NINT(QX(IC+5))# Get ref atom and parameter
ifeq:(QX(N+JA+JP),1.) QX(N+IA+IP)=FLOAT(IC)# Addr of constraint pakt
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
#
RETURN#
END#
systemheader:(RT34)#                   Output of initial param
#################################################################
#                                                               #
#                               RT34                            #
#                                                               #
#################################################################
SUBROUTINE RT34#
include:(AACOMN)#
include:(RTCOMN)#
#
INTEGER M,IA,IS#
REAL JUNK(7)#
#
chardata:(RT1,' Phase N : XXXXXX-')#
chardata:(RT3," Atom      x/a     y/b     z/c     U       $#
U11     U22     U33     U12     U13     U23     pop")#
chardata:(RT4,' Scale factor                              ')#
chardata:(RT5,' U overall                                 ')#
chardata:(RT6,' Mixing parameter                          ')#
realdata:(FMTC,[300742.,400742.,500742.,600742.,700742.,800742.])#
realdata:(FMTB,[400413.,450413.,500413.])#
realdata:(FMTA,[140742.,220742.,300742.,380742.,460742.,540742.,#
620742.,700742.,780742.,860742.,940742.])#
datastuff:#
#
#   PRINT PHASE-DEPENDENT PARAMETERS
#   --------------------------------
#
LINRM=8#                               Force necessary space
movechar:(RT1,NRT1,CHROT,2,7,1)#       Insert underline header
movechar:(PHASE(NPH),1,RT1,12,6,0)#    Insert phase name
ncodefld:(FLOAT(NPH),1,RT1,80113.,1)#  Format phase number
writeline:(1,RT1,NRT1-1,2,3)#          Initial header
#
ncodefld:(dcp:,1,CHROT,FMTC,3)#        ********* cell ************
ncodefld:(dcp:,7,CHROT,FMTC(4),3)#     Encode angles
CHROT(2^16)='Cell parameters'#         Insert cell header
DO I=1,6#                              Loop cell refine flags
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
M=NINT(FMTC(I))/10000+1#               Letter position
IF(REFCEL(NPH,I)==0)      CHROT(M^M)='n'# Noref this par
ELSE IF(REFCEL(NPH,I)==1) CHROT(M^M)='r'# Flag as ref
ELSE                      CHROT(M^M)='c'# Flag as constrained
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
writeline:(0,0,0,1,3)#                 Print cell param values
#
JUNK(1)=FLOAT(pkprofnr:)#              ******** peak function ******
ncodefld:(JUNK,1,CHROT,300213.,1)#     Print as an integer
CHROT(2^28)='Peak shape function number'# Insert header
writeline:(0,0,0,1,3)#                 Print peak function number
#
ncodefld:(span:,1,CHROT,300512.,1)#    ******** peak span ******
CHROT(2^16)='Peak span value'#         Insert header
writeline:(0,0,0,1,3)#                 Print peak function number
#
JUNK(1)=PARPRO(NPH,6)#
ncodefld:(JUNK,1,RT6,FMTC,1)#          ******** mixing param *******
IF(REFPRO(NPH,6)==yes:) RT6(31^31)='r'# Flag as ref
ELSE                    RT6(31^31)='n'# Flag as ref
writeline:(0,RT6,NRT6,3,3)#            Print mixing param
#
DO I=1,3; JUNK(I)=PARPRO(NPH,I)#
ncodefld:(JUNK,1,CHROT,FMTC,3)#        ******* half width **********
CHROT(2^22)='Half width parameters'#   Insert header
DO I=1,3#                              Loop hwidth refine flags
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
M=NINT(FMTC(I))/10000+1#               Letter position
IF(REFPRO(NPH,I)==1) CHROT(M^M)='r'#   Flag as ref
ELSE                 CHROT(M^M)='n'#   Flag as noref
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
writeline:(0,0,0,1,3)#                 Print half width values
#
DO I=1,2; JUNK(I)=PARPRO(NPH,I+3)#
ncodefld:(JUNK,1,CHROT,FMTC,2)#        ******** asymmetry **********
CHROT(2^22)='Peak asymmetry factors'#  Insert header
IF(REFPRO(NPH,4)==yes:) CHROT(31^31)='r'# Insert ref flag
ELSE                    CHROT(31^31)='n'# Insert noref flag
IF(REFPRO(NPH,5)==yes:) CHROT(41^41)='r'# Insert ref flag
ELSE                    CHROT(41^41)='n'# Insert noref flag
writeline:(0,0,0,1,3)#                 Print peak asymmetry parameter
#
JUNK(1)=PARPOF(NPH)#
CHROT(2^29)='Preferred orientation factor'# Insert header
IF(REFPOF(NPH)==yes:) CHROT(41^41)='r'# Insert ref flag
ELSE                  CHROT(41^41)='n'# Insert noref flag
ncodefld:(JUNK,1,CHROT,400742.,1)#     ******** orient *************
writeline:(0,0,0,1,3)#                 Print pref orient parameters
CHROT(2^29)='Preferred orientation vector'# Insert header
DO I=1,3; JUNK(I)=POFVEC(NPH,I)#
CHROT(36^36)='<'#                      Insert bracket
CHROT(51^51)='>'#                      Insert bracket
ncodefld:(JUNK,1,CHROT,FMTB,3)#        ******** orient *************
writeline:(0,0,0,1,3)#                 Print pref orient parameters
#
ncodefld:(scal:,1,RT4,FMTC,1)#         ******** scale *************
IF(REFSKF(NPH)==yes:) RT4(31^31)='r'#  Flag as ref
ELSE                  RT4(31^31)='n'#  Flag as noref
writeline:(0,RT4,NRT4,3,3)#            Print scale
#
ncodefld:(UOV,NPH,RT5,FMTC,1)#         ******** uov *******
IF(REFUOV(NPH)==yes:) RT5(31^31)='r'#  Flag as ref
ELSE                  RT5(31^31)='n'#  Flag as noref
writeline:(0,RT5,NRT5,3,3)#            Print uov
#
PRVOID=0; LINRM=6; IS=mflag:+nflag:#   ********* atom ***********
CC=FLOAT(MCONS(1)-1)#                  Set start of first constraints
FOR(IA=matom:;IA<latom:;IA=IA+natom:)# Loop over the atoms
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
movertoc:(na:,1,CHROT,2,8,0)#          Insert atom name
ncodefld:(xf:,1,CHROT,FMTA,11)#        Format atom parameters
ub:=ub:*utob:#                         Convert u to b values
IS=IS+nflag:;   J=7#                   Incr noref array pointer#
DO I=1,11#                             Loop parameters x to pop
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
J=J+8#                                 Incr flag pointer
ifvo:(QX(IA+6+I)) NEXT#                Skip void parameters
ifeq:(QX(IS+I),0.)   CHROT(J^J)='n'#   Flag as noref
ELSE IF(QX(IS+I)>CC) CHROT(J^J)='c'#   Active parameter & constr
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
writeline:(0,RT3,NRT3,1,3)#            Print atom line
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
#
RETURN#
END#
systemheader:(RT35)#                   Process reflection data
# ####################################################################
#
#                               RT35
#
# ####################################################################
SUBROUTINE RT35#
#
include:(AACOMN)#
include:(RTCOMN)#
#
INTEGER I,KK,M#
INTEGER IP#                            Ip packet pointer
REAL    POFMAG#                        Pof vector magn squared
REAL    SINTH,COSTH,TANTH#             Sin,cos,tan theta
REAL    STOL#                          Sin theta / lambda
REAL    COS2TH#                        Cos 2theta
#
#         SET REFLECTION DEFAULTS
#         -----------------------
#
POFMAG=0.0;   KK=0#                    Point to metric tensor
DO I=1,3;  DO J=1,3#                   Preferred orientation vector
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
KK=KK+1#                               Sum rmt*(uvw)
POFMAG=POFMAG+rmt:(KK)*POFVEC(NPH,I)*POFVEC(NPH,J)# /pofvec/**2
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
#
# SET UP REQUIRED ITEMS
# ---------------------
#
M=NINT(dset:)*1000#                    Data set bias for idnums
DO I=1,3; IWNT(I)=1#                   Hkl; spares for h,k,l
IWNT(4)=2#                             Sine theta/lambda
IWNT(5)=3#                             Multiplicity
DO I=1,NSCF; IWNT(I+5)=I+500#          Ask for scat factors
HKLPAK=10+NSCF#                        Words in dir access file
###opendac:(ioda1:,3,HKLPAK*mxchwd:,' ')# Open direct access file
opendac:(ioda1:,3,100,' ')#            Open direct access file
#
setkey:(5,5+NSCF,0,0)#                 Set search signals
indexpkt:(1,lrrefl:,PACK,IP,0,KEY,IWNT,IREL)# Get refln pointers
#
REPEAT#                                Loop over lrrefl: packets
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
readwpkt:(1,lrrefl:,PACK,IP,0)#        Point to next ip packet
IF(IP<=0) BREAK#                       Seek end of record
NREFL=NREFL+1#                         Count the reflections
gethkl:(IP+IREL(1),BUF)#               Get hkl indices
intunpak:(QX(IP+IREL(5)),I,0,5)#       Reflection multiplicity
BUF(4)=FLOAT(I)#                       Store multiplicity
STOL=QX(IP+IREL(4))#                   Get sin theta on lambda
SINTH=LAMBDA*STOL#                     Sin theta
THETA=ASIN(SINTH)#                     Theta in radians
COSTH=COS(THETA)#                      Cos theta
TANTH=SINTH/COSTH#                     Tan theta
COS2TH=COS(2.*THETA)#                  Cos 2 theta
TT=114.591559*THETA#                   Two theta in degrees
TTMINR=MIN(TTMINR,TT)#                 Get min 2 theta hkl
TTMAXR=MAX(TTMAXR,TT)#                 Get max 2 theta hkl
BUF(5)=TT#                             Two theta in degrees
#
BUF(6)=.5*SINTH**2*COSTH*(1.+POLRA)/(1.+POLRA*COS2TH**2)# 1/lp
#
BUF(7)=.5*SQRT(PARPRO(NPH,1)$#
+       PARPRO(NPH,2)*TANTH+PARPRO(NPH,3)*TANTH**2)# Hwidth
HWDMAX=MAX(HWDMAX,BUF(7))#             Save max hwidth
#
BUF(8)=PARPRO(NPH,4)+PARPRO(NPH,5)*TT# Peak asymmetry
#
FAC=rmt:(1)*POFVEC(NPH,1)*BUF(1)$#     Calc angle delta between
+   rmt:(5)*POFVEC(NPH,2)*BUF(2)$#     Pref orient vector and
+   rmt:(9)*POFVEC(NPH,3)*BUF(3)$#     Scattering vector
+   rmt:(2)*(POFVEC(NPH,1)*BUF(2)+POFVEC(NPH,2)*BUF(1))$#
+   rmt:(3)*(POFVEC(NPH,1)*BUF(3)+POFVEC(NPH,3)*BUF(1))$#
+   rmt:(6)*(POFVEC(NPH,2)*BUF(3)+POFVEC(NPH,3)*BUF(2))#
ifeq:(POFMAG,0.) FAC=0.#               Zero divide
ELSE FAC=FAC*FAC/(POFMAG*4.*STOL**2)#  Pofmag=/pofvec/**2
BUF(9)=EXP(PARPOF(NPH)*(2.*FAC-1.))#   Exp(cos(2*delta))
#
BUF(10)=FLOAT(NPH)#                    Put phase nr in op buffer
#
DO I=1,NSCF#                           Loop over atom types
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
IF(IREL(I+5)>0) BUF(I+10)=QX(IP+IREL(I+5))# Extract interpol scat fac
ELSE#                                  Else get sf from sf table
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
J=mscat:+(I-1)*nscat:+6#               Point to scat factor table
IF(RADTYP>1) BUF(I+10)=QX(J+NINT(STOL/DSCF))# Store electron/xray ff
ELSE         BUF(I+10)=QX(J+1)#        Store neutron ff
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
#
writedac:(ioda1:,,NREFL,(BUF(I),I=1,HKLPAK))# Write direct access fil
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
readwpkt:(1,endrecord:,PACK,IP,0)#     Close off i/p bdf
#
RETURN#
END#
systemheader:(RT40)#                   Sort refls on tth to fil ioda2
######################################################################
#
#                               RT40
#
######################################################################
SUBROUTINE RT40#
#
include:(AACOMN)#
include:(RTCOMN)#
#
INTEGER I,J,K,M#
#
#    READ REFLN FILE AND STORE PACKED 2THETA/NREFL
#    ---------------------------------------------
#
NPHASE=NPH-1#                          Correct the number of phases
ncodefld:(FLOAT(NREFL),1,CHROT,350713.,1)# Print total reflections
CHROT(2^28)='Total number of reflections'# Insert header
writeline:(0,0,0,1,3)#                 Print total reflections
IF(NREFL>16383) iquit:(RT4001)#        Too many reflns for 14 bits
J=NEWM#                                Set start of sort indices
incrqx:(I,J+NREFL,RT4005)#             Memory for sort indices
DO I=1,NREFL#                          Loop over refl packets
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
readdac:(ioda1:,,I,(BUF(K),K=1,HKLPAK))# Read next refln
J=J+1#                                 Incr qx pointer
intpak:(I,QX(J),0,14)#                 Refln number bits  13 to 00
intpak:(NINT(BUF(5)*1000.),QX(J),14,18)# 2theta*1000 bits 31 to 14
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
#
#    SORT THE STORED PACKED 2THETA/NREFL
#    -----------------------------------
#
opendac:(ioda2:,3,100,' ')#            Open direct access file
MARK=NEWM#                             Set start of sort indices
DO I=1,NREFL#                          Loop over refl packets
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
movepakwd:(QX(MARK+I),QQ);  II=I#      Get starting packed 2th/nrefl
DO J=I+1,NREFL#                        Loop over refl packets
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
compakwd:(QQ,LT,QX(MARK+J),NEXT)#      Check for the smallest
movepakwd:(QX(MARK+J),QQ);  II=J#      Save smallest packed 2th/nrefl
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
movepakwd:(QX(MARK+I),QX(MARK+II))#    Save unsorted packed 2th/nrefl
intunpak:(QQ,K,0,14)#                  Extract the refln number
readdac:(ioda1:,,K,(BUF(L),L=1,HKLPAK))# Read unsorted file
writedac:(ioda2:,,I,(BUF(L),L=1,HKLPAK))# Write  sorted file
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
qxmemory:(MARK); NEWM=MARK#            Set memory back to pre-sort
closedac:(ioda1:)#                     Close unsorted file
#
# STORE CONSTR VECTORS & SETUP DERIVATIVE MATRIX REQUIREMENTS
# -----------------------------------------------------------
#
M=0; VARMAX=0#                         Zero total nr of variables
IF(REFZER(1)>0)M=M+1#                  Count active zer variables
IF(REFZER(2)>0)M=M+1#                  Count active zer variables
DO I=1,5#                              Loop over background parameter
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
IF(REFBAC(I)>0)M=M+1#                  Count active bgd variables
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
VARPAT=M#                              Total pattern vars bac+zer
DO NPH=1,NPHASE#                       Loop over phases
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5
N=0#                                   Reset variable count
DO J=mflag:+1,lflag:#                  Loop over refinement flags
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6
IF(QX(J)<1.) NEXT#                     Skip if not refined
IF(QX(J)>CC)#                          Constrained
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7
I=NINT(QX(J))#                         Get address of constraint pack
K=NINT(QX(I+4)); L=NINT(QX(I+5))#      Atom and param numbers
QX(I+3)=QX(mflag:+(K+1)*nflag:+L)#     Store vector number in word 3
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7
ELSE#                                  Refined
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8
N=N+1; QX(J)=FLOAT(N)#                 Count active variables
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6
NUMVAR(NPH)=N;  VARMAX=MAX(VARMAX,N)#  Number of variables per phase
M=M+N#                                 Total number of variables
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5
VARTOT=M#                              Total nr variables
IF(VARTOT>VARMAX*2) iquit:(RT4010)#    Too little temp der storage
MDMATX=NEWM;   LDMATX=MDMATX+M*(M+1)/2# Set deriv matrix marker
MDVECT=LDMATX; LDVECT=MDVECT+M#        Set deriv vector marker
MDTEMP=LDVECT; LDTEMP=MDTEMP+VARMAX*2# Start of scratch area
incrqx:(I,LDTEMP,RT4020)#              Get matrices and scratch area
#
#
RETURN#
END#
systemheader:(RT45)#                   Read powder pattern
######################################################################
#
#                               RT45
#
######################################################################
SUBROUTINE RT45#
#
include:(AACOMN)#
include:(RTCOMN)#
#
INTEGER I,J,K,M#
chardata:(RT0,' Powder pattern information:')#
chardata:(RT1,' Pre-set two theta min/max                         ')#
chardata:(RT2,' Pattern two theta min/max                         ')#
chardata:(RT3,' HKL bdf two theta min/max                         ')#
chardata:(RT4,' Overall two theta min/max                         ')#
chardata:(RT5,'-')#
chardata:(RT6,' Overall two theta stepsize                        ')#
datastuff:#
#
#    READ POWDER PATTERN FILE (.PAT)
#    ------------------------
#
copyfile:(3,4,1,decr:(lrplim:))#       Copy to limits record
readwpkt:(3,lrplim:,PACK,IP,0)#        Read limits packet
IF(IP<=0) iquit:(RT4105)#              Record 21 missing
writepkt:(4,lrplim:,PACK,IPO)#         Pt to pow pat o/p pkt
movereal:(QX,IP+1,QX,IPO+1,PACK,1)#    Copy record
movechar:(RT5,1,CHROT,2,NRT0,1)#       Insert underline header
writeline:(1,RT0,NRT0,2,3)#            Header line
TTMINP=QX(IP+1)#                       Two theta min - pattern
TTMAXP=QX(IP+2)#                       Two theta max - pattern
TTSTEP=QX(IP+3)*FLOAT(NSKIP)#          Two theta stepsize
#
#    REPORT ALL 2THETA LIMITS
#    ------------------------
#
LINRM=5;   OFFSET=PEAKSP*HWDMAX#       Get 2theta offset
ncodefld:(TTMINL,1,RT1,400932.,1)#     Pattern file minimum
ncodefld:(TTMAXL,1,RT1,500932.,1)#     Pattern file maximum
writeline:(1,RT1,NRT1,3,3)#            Report limits
ncodefld:(TTMINP,1,RT2,400932.,1)#     Requested 2th minimum
ncodefld:(TTMAXP,1,RT2,500932.,1)#     Requested 2th maximum
writeline:(0,RT2,NRT2,3,3)#            Report limits
ncodefld:(TTMINR,1,RT3,400932.,1)#     Refl 2th minimum refln data
ncodefld:(TTMAXR,1,RT3,500932.,1)#     Refl 2th maximum refln data
writeline:(0,RT3,NRT3,3,3)#            Report limits
TTMINP=MAX(TTMINP,TTMINL)#             Composite 2th minimum
TTMAXP=MIN(TTMAXP,TTMAXL,TTMAXR-OFFSET)# Composite 2th maximum
ncodefld:(TTMINP,1,RT4,400932.,1)#     Composite 2th minimum
ncodefld:(TTMAXP,1,RT4,500932.,1)#     Composite 2th maximum
writeline:(0,RT4,NRT4,3,3)#            Report limits
ncodefld:(TTSTEP,1,RT6,400932.,1)#     Two theta stepsize
writeline:(0,RT6,NRT6,3,3)#            Report step
IF(TTMINP>TTMAXP) iquit:(RT4012)#      Limits will not work
#
RETURN#
END#
systemheader:(RT50)#                   Process powder pattern steps
######################################################################
#
#                               RT50
#
######################################################################
SUBROUTINE RT50#
include:(AACOMN)#
include:(RTCOMN)#
#
LINRM=6#                               Heading control
MCONTR=0#                              Max overlapping refls/step
ISKIP=0;   NSTEP=0;  IREFL=0#          Reset skip and step count
TTLAST=0.; NEWPAK=20+VARMAX*2#         Set initial pattern values
LOHKL=1;   HIHKL=0#                    Reset active window
DO I=1,80; RSUMS(I)=0.; RSUMS(58)=-1.# Clear statistics array
opendac:(ioda1:,3,NEWPAK*mxchwd:,' ')# Open new dir access file
#
#   STEP THROUGH POWDER PATTERN
#   ---------------------------
#
REPEAT#                                Loop over pattern steps
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
readwpkt:(3,lrppat:,PACK,IP,0)#        Read step in powder pattern
IF(IP<=0) BREAK#                       Exit if finished
#
TT=QX(IP+1)+PARZER(1)+PARZER(2)*TT#    Get 2theta, apply zero corr
#
IF(TT<TTMINP)#                         Skip steps below min 2theta
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
IF(NCY!=NCYCLE) NEXT#                  Skip on all but last cycle
ELSE#
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
writepkt:(4,lrppat:,PACK,IPO)#         Pt to pow pat o/p pkt
movereal:(QX,IP+1,QX,IPO+1,PACK,1); NEXT# Copy record
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
#
IF(TT>TTMAXP)#                         Exit when above max 2theta
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
IF(NCY!=NCYCLE) BREAK#                 Break on all but last cycle
ELSE#
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5
writepkt:(4,lrppat:,PACK,IP0)#         Pt to pow pat o/p pkt
movereal:(QX,IP+1,QX,IPO+1,PACK,1); NEXT# Copy record
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
#
ISKIP=ISKIP+1#
IF(ISKIP>NSKIP)#                       Use nskip'th steps only
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6
IF(NCY!=NCYCLE) NEXT#                  Skip on all but last cycle
ELSE#
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7
writepkt:(4,lrppat:,PACK,IPO)#         Pt to pow pat o/p pkt
movereal:(QX,IP+1,QX,IPO+1,PACK,1); NEXT# Copy record
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6
ISKIP=0#                               Accept step, reset skip counte
#
DO J=1,NEXCLR#                         Loop over exclusion regions
IF(TT>=EXCLRL(J)&TT<=EXCLRH(J))#       Skip if in excl region
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8
IF(NCY!=NCYCLE) NEXT#                  Skip on all but last cycle
ELSE#
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9
writepkt:(4,lrppat:,PACK,IPO)#         Pt to pow pat o/p pkt
movereal:(QX,IP+1,QX,IPO+1,PACK,1); NEXT# Copy record
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8
#
CNTOBS=QX(IP+2)#                       Extract observed intensity
CNTSIG=QX(IP+3)#                       Extract std deviation
CNTWHT=QX(IP+4)#                       Extract weight
CNTBAC=QX(IP+6)#                       Extract background intensity
IF(CNTSIG<=0.00001) CNTSIG=1.0#        Prevent zero divide
NSTEP=NSTEP+1#                         Count number of steps
STEPW=TT-TTLAST;    TTLAST=TT#         Get step width to last step
IF(STEPW<TTSTEP*5.) TTSTEP=STEPW#      Reset step, not on gaps
TT=TT+PARZER(1)+TT*PARZER(2)#          Zero correct to twotheta
#
CALL RT51#                             Cull reflns from active list
CALL RT52#                             Add  reflns to   active list
CALL RT54#                             Calc pow int from active list
CALL RT55#                             Build matrix, vector
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
#
TT=180.0#                              Set max tth possible
CALL RT51#                             Purge active refl list
rewindbdf:(3)#                         Rewind the powder pattern
IF(NCY==NCYCLE) writepkt:(4,endrecord:,1,IP)# Close output pattern fi
#
RETURN#
END#
systemheader:(RT51)#                   Drop refls, write bdf, list
######################################################################
#
#                               RT51
#
######################################################################
SUBROUTINE RT51#
include:(AACOMN)#
include:(RTCOMN)#
#
REAL    FCAL#      ## calculated f
REAL    FDIF#      ## Rel-cal difference for f
REAL    FOBS#      ## integrated peak int reduced to absolute f
REAL    F2CAL#     ## calculated f2
REAL    F2OBS#     ## integrated peak int reduced to observed f2
REAL    ICAL#      ## calculated i = rmult * f**2
REAL    IDIF#      ## Rel-cal difference for i
REAL    IOBS#      ## integrated peak int scaled to yobs/ycal
#
chardata:(RT511,   H  K  L 2THETA PH HFWID MLT  1/LP$#
    FOBS    FCAL   IOBS   ICAL  IO-IC   POWFAC)#
##    FOBS    FCAL  IO-IC   IOBS   ICAL   ACAL   BCAL$#
## PSF HWGP   FWHM  PEAKAS  PREFOR)#
realdata:(FMT,[40313.,70313.,100313.,#
170622.,200113.,260532.,290213.,360632.,#
440722.,520722.,590613.,660613.,730613.,800622.,870622.,#
900213.,950313.,1030632.,1100632.,1170632.])#
datastuff:#
#
#    SCAN REFLECTIONS CONTRIBUTING TO PREVIOUS STEP
#    ----------------------------------------------
#
IF(LOHKL>HIHKL)RETURN#                 No cull on empty file
DO IR=LOHKL,HIHKL#                     Loop current active hkl number
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
readdac:(ioda1:,,IR,(BUF(I),I=1,NEWPAK))# Read active refln file
TTH=BUF(5); HWH=BUF(7)#                2theta and halfwidth
NPH=BUF(10)#                           Phase number
TSPAN=span:*HWH#                       Calc window width
IS=IR#
IF(TTH>=TT-TSPAN) BREAK#               Exit if still in active list
IS=IR+1#                               Drop lowest 2theta hkl
#
#  PROCESS LOW 2THETA HKL NOT CONTRIBUTING TO CURRENT STEP
#  -------------------------------------------------------
#
RMUL=BUF(4)#                           Refl multiplicity
RLPF=BUF(6)#                           1/lp powder
FCAL=BUF(11)#                          F(cal) hkl
POWFAC=BUF(12)#                        Skf*mult*1/lp*pof
ICAL=BUF(14)#                          I(cal) powder
IOBS=0.; IDIF=0.; F2OBS=0.#            Reset observed values
FOBS=0.; FDIF=0.#
#
#   CALC INTEGRATED IOBS
#   --------------------
#
IF(TTH-TSPAN>TTMINP&TTH+TSPAN<TTMAXP)# Check if full peak in pattern
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
IOBS=BUF(16)#                          Iobs built in rt54
F2OBS=IOBS/POWFAC#                     F**2 (obs)
IF(F2OBS>0.)FOBS=SQRT(F2OBS)#          F(obs)
ELSE        FOBS=0.#
IDIF=IOBS-ICAL#                        Delta (f**2 * rmult)
FDIF=FOBS-FCAL#                        Delta f
RSUMS(NPH  )=RSUMS(NPH  )+IOBS#        Sum obs i
RSUMS(NPH+10)=RSUMS(NPH+10)+ABS(IDIF)# Sum delta i
RSUMS(NPH+20)=RSUMS(NPH+20)+FOBS#      Sum obs f
RSUMS(NPH+30)=RSUMS(NPH+30)+ABS(FDIF)# Sum delta f
RSUMS(NPH+40)=RSUMS(NPH+40)+1.#        Sum number reflections
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
#
#    LIST REFLECTION DATA IF REQUESTED
#    ---------------------------------
#
IF(LISTRF==0) NEXT#                    Skip if no listing requested
BUFOT(1)=BUF(1)#                       Store h
BUFOT(2)=BUF(2)#                       Store k
BUFOT(3)=BUF(3)#                       Store l
BUFOT(4)=TTH#                          Store two theta
BUFOT(5)=BUF(10)#                      Store phase number
BUFOT(6)=HWH#                          Store halfwidth
BUFOT(7)=RMUL#                         Store refl multiplicity
BUFOT(8)=RLPF#                         Store 1/lp
BUFOT(9)=FOBS#                         Store f obs
BUFOT(10)=FCAL#                        Store f calc
BUFOT(11)=IOBS#                        Store i obs
BUFOT(12)=ICAL#                        Store i calc
BUFOT(13)=IDIF#                        Store i dif
BUFOT(14)=POWFAC#                      Store powder scale factor
ncodefld:(BUFOT,1,CHROT,FMT,14)#       Format last 14 items
writeline:(0,RT511,NRT511,1,3)#        Print output items
LISTRF=LISTRF-1#                       Decrement lines printed
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
LOHKL=IS#                              Reset lohkl after drop
#
RETURN#
END#
systemheader:(RT52)#                   Add hkl contributing to patter
######################################################################
#
#                               RT52
#
######################################################################
SUBROUTINE RT52#
include:(AACOMN)#
include:(RTCOMN)#
#
REAL    A,B,C,S#   ## Structure factor components
REAL    ACAL,BCAL# ## Total structure factor components
REAL    ANOD,BNOD# ## Dispersion free sf components
REAL    AH,AK,AL#  ## Local h,k,l
REAL    BH,BK,BL#  ## Equiv h,k,l
REAL    DA,DB#     ## Real & imag dispersion components
REAL    DELA(10)#  ## Real derivative components
REAL    DELB(10)#  ## Imag derivative components
REAL    DERCEL#    ## Cell parameter derivative factor
REAL    EQV(500)#  ## Space for generated reflections
REAL    FAC#       ## Multiplication factor
REAL    FAC1,FAC2# ## Real & imag scattering components
INTEGER I,J,K,L#   ## General indices
REAL    FCAL,ICAL# ## Calculated reflection str factor, intensity
INTEGER IMAG#      ## Imag=2: imaginary part of s.f. is present :
REAL    RLPF#      ## lp factor
INTEGER MEQV#      ## End of parameter array
REAL    POF#      ## Preferred orientation factor
REAL    RMUL#      ## Reflection multiplicity
REAL    STOL#      ## Sin(theta/lambda)
REAL    STL2#      ## Sin(theta/lambda) squared
REAL    SCOS,SSIN# ## Cos/sin summation of fc
#
realdata:(P2,6.28319); realdata:(PI180,0.01745329252)#
datastuff:#
#
#   ADD HIGH TWO THETA HKL CONTRIBUTING TO STEP
#   -------------------------------------------
#
M=VARMAX+1#                            Define skip factor for derivs
REPEAT#                                Loop over new reflections
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
IREFL=IREFL+1; IF(IREFL>NREFL) BREAK#  Count the next refln
readdac:(ioda2:,,IREFL,(BUF(I),I=1,HKLPAK))# Read refln file
#
NPH=NINT(BUF(10))#                     Phase number
HWH=BUF(7);              TTH=BUF(5)#   Reflection halfwidth & 2theta
IF(TTH<TT-span:*HWH) NEXT#             Test if active list reached ye
IF(TTH>TT+span:*HWH)#                  Test if active region exceeded
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
IREFL=IREFL-1;  BREAK#                 Reset refln pointer and exit
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
#
#   NEW REFLECTION IN ACTIVE LIST
#   -----------------------------
#
AH=BUF(1); AK=BUF(2); AL=BUF(3)#       Store hkl as real variables
IF(NUCELL==yes:)#                      If cell has changed
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
STOL=SQRT(stc:(1)*AH*AH+stc:(2)*AK*AK $# Calc sin theta/lambda
+         stc:(3)*AL*AL+stc:(4)*AH*AK $# Calc sin theta/lambda
+         stc:(5)*AH*AL+stc:(6)*AK*AL)# Calc sin theta/lambda
TTH=114.591559*ASIN(STOL*LAMBDA)#      Two theta
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
ELSE STOL=SIN(TTH/114.591559)/LAMBDA#  Calc sin theta on lambda
STL2=STOL*STOL#                        Calc st/l **2
#
AMUL=QX(msymm:+6)#                     Sf general multiplicity
RMUL=BUF(4)#                           Refl multiplicity
RLPF=BUF(6)#                           Extract lp factor
POF=BUF(9)#                            Preferred orient factor
POWFAC=scal:*RMUL*POF/RLPF#            Powder factor
DERFAC=2.*POWFAC#                      Derivative factor
DERTMP=-STL2*DERFAC/cub:(1)#           For tf derivative
ICEN=NINT(QX(msymm:+2))#               Centro flag (0=cent;1=nonc)
IF(APPDSP==yes:) IMAG=2#               Must be two components
ELSE             IMAG=ICEN+1#          Set imaginary flag
IC=mflag:+nflag:#                      Skip profile and cell lists
IS=MDTEMP+1#                           Set derive temp area
DO II=MDTEMP+1,LDTEMP; QX(II)=0.##
#
J=-10#                                 **** generate hkl equivalents
FOR(I=msymm:+nsymm:;I<lsymm:;I=I+nsymm:)# Loop over symm matrices
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
J=J+10#                                Incr parameter array
BH=AH*QX(I+1)+AK*QX(I+2)+AL*QX(I+3)#   Equivalent h
BK=AH*QX(I+4)+AK*QX(I+5)+AL*QX(I+6)#   Equivalent k
BL=AH*QX(I+7)+AK*QX(I+8)+AL*QX(I+9)#   Equivalent l
EQV(J+1)=P2*BH#                        Store h*2pi
EQV(J+2)=P2*BK#                        Store k*2pi
EQV(J+3)=P2*BL#                        Store l*2pi
EQV(J+4)=P2*(AH*QX(I+10)+AK*QX(I+11)+AL*QX(I+12))# Phase shift
IF(FLGTDP==no:) NEXT#                  Skip if tdp not refined
EQV(J+5)= BH*BH#                       Store new h**2
EQV(J+6)= BK*BK#                       Store new k**2
EQV(J+7)= BL*BL#                       Store new l**2
EQV(J+8)= BH*BK*2.#                    Store new h*k*2
EQV(J+9)= BH*BL*2.#                    Store new h*l*2
EQV(J+10)=BK*BL*2.#                    Store new k*l*2
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
MEQV=J#                                Save last equiv hkl pointer
ANOD=0.; ADIS=0.;  A=0.#               Zero real fc components
BNOD=0.; BDIS=0.;  B=0.#               Zero imag fc components
#
#     LOOP OVER ALL ATOMS
#     -------------------
#
FOR(IA=matom:;IA<latom:;IA=IA+natom:)# Loop over atoms list
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5
SCOS=0.;   SSIN=0.#                    Zero fc components
DO I=1,10; DELA(I)=0.#                 Zero real deriv sums
DO I=1,10; DELB(I)=0.#                 Zero imag deriv sums
IC=IC+nflag:#                          Point to constraint list
#
DO J=0,MEQV,10#                        ********** equiv indices
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6
P=EQV(J+1)*xf:+EQV(J+2)*yf:+EQV(J+3)*zf:+EQV(J+4)# H*x+k*y+l*z+phi
S=SIN(P);      C=COS(P)#               Sin and cos (hx+ky+lz+phi)
IF(dp:>1.5)#                           Anisotropic temp.fact.
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7
T=0.; DO I=1,6; T=T+EQV(J+I+4)*QX(IA+I+4)# Sum h*h*u11 etc.
T=EXP(-T);   S=T*S;    C=T*C#          Calc tf*sin tf*cos
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7
IF(ICEN==1) SSIN=SSIN+S; SCOS=SCOS+C#  Sum real components
#                                     *********** SUM DERIVATIVES
DO I=1,3#                              Loop over x,y,z parameters
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8
IF(QX(IC+I)<0.5) NEXT#                 Skip noref parameter
IF(ICEN==1)#                           Test if noncentrosym
DELB(I)=DELB(I)+EQV(I+J)*C#            Sum real components
DELA(I)=DELA(I)-EQV(I+J)*S#            Sum imag components
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8
IF(dp:>1.5) DO I=5,10#                 Loop anisotropic uij
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9
IF(QX(IC+I)<0.5) NEXT#                 Skip noref parameter
IF(ICEN==1)#                           Test if noncentrosym
DELB(I)=DELB(I)-EQV(I+J)*S#            Sum imag components
DELA(I)=DELA(I)-EQV(I+J)*C#            Sum real components
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6
#
#   CALC COMPONENTS WHICH ARE SYMMETRY INDEPENDENT
#   ----------------------------------------------
#
FAC=ml:*pp:*AMUL#                      Sitemult*pop*cellmul
IF(dp:<1.5) FAC=FAC*EXP(-STL2*ub:)#    Apply isotropic tf
FF=BUF(NINT(sf:)+10)#                  Get form factor this atom
FAC1=FAC*FF;    FAC2=0.#               Disp-free structure factor
IF(ICEN==1) B=FAC1*SSIN; A=FAC1*SCOS#  Form components of fc
IF(ICEN==1) BNOD=BNOD+B; ANOD=ANOD+A#  Sum non-dispersion terms
#
IF(APPDSP==yes:)#                      If dispersion applied
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10
FAC1=FAC*(dr:+FF)#                     Calc real scattering
FAC2=FAC*(di:)#                        Calc imag scattering
DA=FAC*(SCOS*dr:-SSIN*di:)#            Calc real disp. contribution
DB=FAC*(SSIN*dr:+SCOS*di:)#            Calc imag disp. contribution
ADIS=ADIS+DA;   BDIS=BDIS+DB#          Sum dispersion terms
A=A+DA;         B=B+DB#                Calc total sf terms
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10
#
#    ACCUMULATE ATOM X,Y,Z,U,PP DERIVATIVES
#    --------------------------------------
#
FAC1=FAC1*DERFAC;  FAC2=FAC2*DERFAC#   Apply derivative factor
DO I=1,11#                             Loop over atom parameters
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11
IF(QX(IC+I)<0.5) NEXT#                 Skip noref parameter
IF(I==4)#                              If isotropic dp
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12
DB=B*DERTMP;    DA=A*DERTMP#           Isotropic dp derivatives
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12
ELSE IF(I==11)#                        If population parameter
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13
DB=B*DERFAC/pp:; DA=A*DERFAC/pp:#      Population derivatives
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13
ELSE#                                  Xyz or anisotropic dp
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14
DB=FAC1*DELB(I)+FAC2*DELA(I)#          Calc deriv b
DA=FAC1*DELA(I)-FAC2*DELB(I)#          Calc deriv a
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14
IF(QX(IC+I)>CC)#                       Test if constrained parameter
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15
J=NINT(QX(IC+I))#                      Constraint pkt pointer
IR=NINT(QX(J+3))+MDTEMP#               Ref par address
#QX(IR+1)=QX(IR+1)+QX(J+7)*DA#          SUM REAL TERM
#IF(IMAG==2)#                           ARE IMAG COMPONENTS REQUIRED
#QX(IR+M)=QX(IR+M)+QX(J+7)*DB#          SUM IMAG TERM
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15
ELSE#                                  Else unconstrained
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16
QX(IS+1)=QX(IS+1)+DA#                  Sum real term
IF(IMAG==2)#                           Are imag components required
QX(IS+M)=QX(IS+M)+DB#                  Sum imag term
IS=IS+1#                               Incr deriv scratch storage
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5
#
#    CALCULATE STRUCTURE FACTOR
#    --------------------------
#
ACAL=ANOD+ADIS;  BCAL=BNOD+BDIS#       Sum total sf components
IF(IMAG==1) FCAL=ABS(ACAL)#            If centrosymmetric
ELSE        FCAL=SQRT(ACAL*ACAL+BCAL*BCAL)# If noncentrosymmetric
ICAL=FCAL*FCAL*POWFAC#                 Calculated powder intensity
#
#   FORM GENERAL DERIVATIVES
#   ------------------------
#
DO I=MDTEMP,IS#                        Converge derivative components
QX(I+1)=A*QX(I+1)+B*QX(I+M)#           Combine real & imag terms <<<<   !!
#
#   SAVE DERIVS IN ACTIVE REFLN BUFFER
#   ----------------------------------
#
BUF(11)=FCAL#                          Calculated structure factor
BUF(12)=POWFAC#                        Powder factor
BUF(13)=0.0#                           Reserve for profile fn
BUF(14)=ICAL#                          Calc powder structure factor
BUF(15)=ICAL*LAMBDA/(PI180*STOL*COS(TTH/114.591559))# Cell deriv fact
movereal:(0.,1,BUF,16,5,2)#            Zero slots for iobs sum
movereal:(QX,MDTEMP+1,BUF,21,LDTEMP-MDTEMP,0)# Derivs to refln buffer
HIHKL=HIHKL+1#                         Count added reflections
writedac:(ioda1:,,HIHKL,(BUF(I),I=1,NEWPAK))# Write additional reflec   n
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
#
RETURN#
END#
systemheader:(RT54)#                   Sum contributions to patt step
######################################################################
#
#                               RT54
#
######################################################################
SUBROUTINE RT54#
include:(AACOMN)#
include:(RTCOMN)#
#
REAL    BACGRD# ## background intensity, file or calculated
REAL    CNBCAL# ## calculated counts, no background
REAL    CNBOBS# ## observed counts, no background
REAL    CNTCAL# ## calculated step intensity (calculated counts)
REAL    DELTTH# ## distance between step and refl 2theta angles
REAL    DERCEL# ## derivative factor for cell parameters
REAL    DFSI#   ## value of symm der of pk shp function
REAL    DFAI#   ## value of asymm der of pk shp function
REAL    DELTAW# ## weighted yobs-ycal
REAL    FAC1,FAC2,FAC3## multiplication factors in der calculation
INTEGER FLG#    ## flag to indicate pointer outside pk fn limits
REAL    FSI#    ## value of symm part of pk shp function
REAL    FAI#    ## value of asymm part of pk shp function
REAL    HWH#    ## Half width of a reflection peak
INTEGER J,K,L#
REAL    ICAL#   ## Icalc = F**2 * m * otherfactors
REAL    IOBS#   ## Iobs = 'observed' refl int, sum of peak contr
REAL    JCAL#   ## scaled intensity of a contributing refl
INTEGER NCONTR# ## nr of contributing reflections to a step
INTEGER NB#     ## nr of background parameters refined
REAL    PAS#    ## Peak asymmetry of a reflection peak
REAL    POF#    ## Preferred orientation factor
REAL    PRFABS# ## position on peak profile (abs value)
REAL    PRFSIG# ## position on peak profile
REAL    PRFSGN# ## position on peak profile (-or+ = left/right)
REAL    PRFVAL# ## profile function value
REAL    QRI#    ## 1/stepsize in pk shp function
REAL    RATIO#  ## 2 theta diff / funcstep
INTEGER REFLAG# ## flag to signal reflection at current step
REAL    SCALE#  ## scale obs intensity of a contributing refl
REAL    TTH#    ## 2 theta of a reflection
#
chardata:(RT541,     TTH  NCONTR  YOBS     YCAL     IDIF$#
      WHT     W*D    PHASE)#
realdata:(PI,3.1415926); realdata:(G,2.7726); realdata:(C,0.939439)#
datastuff:#
#
# ZERO DERIVATIVE ARRAY AND COUNTERS
# ----------------------------------
#
DO I=MDTEMP,LDTEMP; QX(I)=0.#          Zero deriv scratch area
NCONTR=0#                              Contributing refl counter
REFLAG=0#                              Set reflection position flag
#
# BACKGROUND - CALCULATE AND BUILD DERIVATIVE
# -------------------------------------------
#
BACGRD=0.0; NB=0#
IF(IBAC==no:)BACGRD=CNTBAC#            Use file value for bacgrd
ELSE#                                  Backgrd params supplied
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
DO I=1,5#                              Loop over backgd parameters
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
BACGRD=BACGRD+PARBAC(I)*(TT**(I-1))#   Calculate backgrd
IF(NCY==NCYCLE) NEXT#                  For all cycles except last
IF(REFBAC(I)==no:) NEXT#               Skip if not used
NB=NB+1#                               Incr nr bg pars refined
IS=MDTEMP+NB#                          Set scratch pointer
QX(IS)=QX(IS)+TT**(I-1)#               I-th bgd correction
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
CNBOBS=CNTOBS-BACGRD#                  Strip background contrib
CNBCAL=0.#                             Calculated counts, no bac
#
#    LOOP ALL REFLNS CONTRIBUTING TO THIS PATTERN STEP
#    -------------------------------------------------
#
IF(LOHKL>HIHKL) GO TO 10#              No contributors, treat backgr
DO IR=LOHKL,HIHKL#                     Loop lowest to highest 2theta
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
readdac:(ioda1:,,IR,(BUF(I),I=1,NEWPAK))# Read refln file
#
NCONTR=NCONTR+1#                       Refl counter
#
TTH   =BUF(5)#                         2 theta of this i-th refl
HWH   =BUF(7)#                         Half width
PAS   =BUF(8)#                         Peak asymmetry
POF   =BUF(9)#                         Preferred orient factor
NPH   =NINT(BUF(10))#                  Phase number
ICAL  =BUF(14)#                        Calc refl intensity
DERCEL=BUF(15)#                        Derivative for cell parameters
IOBS  =BUF(16)#                        'observed' refl intensity
#
DELTTH=TT-TTH#                         Delta of step and refl angles
IF(ABS(DELTTH)<=TTSTEP)REFLAG=REFLAG+10**(NPH-1)# Set refl/phase indi
TANT=TAN(TT/114.591559)#               Tan theta
#
#    APPLY PEAK PROFILE SHAPE FUNCTION
#    ---------------------------------
#
PRFVAL=0.; FLG=no:#                    Default & limit flag
PRFSIG=DELTTH/HWH#                     Nr hwidths from hkl 2theta
PRFSGN=SIGN(1.,PRFSIG)#                Left or right side of profile
PRFABS=ABS(PRFSIG)#                    Abs nr of hwidths from centre
#
IF(pkprofnr:<10)#                      Baerlocher & hepp's function
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
L     =PSHFLN(pkprofnr:)#              Nr of 5-value entries in table
J     =PSHFPT(pkprofnr:)#              Point to func array (markf)
QRI   =PSHFST(pkprofnr:)#              1/stepsize in func table
K=INT(PRFABS*QRI)+1#                   Step nr in func
IF(K>=L) FLG=yes:#                     Outside function step limits
K=J+5*(K-1)#                           Lower step of func interval
RATIO=QRI*(PRFABS-QX(K+1))#            Hw diff / funcstepsz
FSI = QX(K+2)+RATIO*(QX(K+7)-QX(K+2))# Interpolate symm func
FAI =(QX(K+3)+RATIO*(QX(K+8)-QX(K+3)))*PRFSGN# Interpol asymm func
DFSI=(QX(K+4)+RATIO*(QX(K+9)-QX(K+4)))*PRFSGN# Interpol symm der
DFAI= QX(K+5)+RATIO*(QX(K+10)-QX(K+5))# Interpolate asymm der
FAC1=   1.-PAS*FAI#                    Apply peak asymmetry
FAC2=   FAC1*DFSI-PAS*FSI*DFAI#        Der prffunc wrt deltth
PRFVAL= FSI*FAC1/HWH#                  Profile function value
FACDEL= FAC2/(HWH*HWH)#                For zero corr
FACTTH= -FACDEL#                       For cell
FACASY= -FSI*FAI/HWH#                  For pasymm
FACHWD= -FSI*FACTTH + FAC1*PRFSIG#     For hwidth
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
#
ELSE#                                  Pseudo-voigt function
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5
FAC1= 1./(1.+PRFSIG*PRFSIG)#
FAC2= -DELTTH*FAC1*FAC1/(PI*HWH*HWH*HWH)# Dl/ddel
FAC3= -0.5*PRFSIG*FAC2 - 0.5/(PI*HWH*HWH*FAC1)# Dl/dsig
FAC4= EXP(-0.25*G*PRFSIG*PRFSIG)#
FAC5= -0.25*C*G*PRFSIG*FAC4/(HWH*HWH)# Dg/ddel
FAC6= -0.5*PRFSIG*FAC5 - 0.25*C*FAC4/(HWH*HWH)# Dg/dsig
GPART= 0.5*C*FAC4/HWH#                 Gaussian part
LPART= 1./(PI*HWH*FAC1)#               Lorentzian part
MIX=   PARPRO(NPH,6)#                  Mixing par
PRFVAL= MIX*LPART + (1.-MIX)*GPART#    P-voigt prof func value
FACDEL= MIX*FAC2 + (1.-MIX)*FAC5#      For zero corr
FACTTH= -FACDEL#                       For cell
FACASY= -PRFVAL*PRFSGN*4.0*DELTTH*DELTTH# For pasymm
FACHWD= MIX*FAC3 + (1.-MIX)*FAC6#      For hwidth
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5
#
IF(FLG==yes:) NEXT#                    Invalid fn lookup
JCAL=ICAL*PRFVAL#                      Step contr=icalc*proffunc
CNBCAL=CNBCAL+JCAL#                    Sum calc'd step intensity
BUF(17)=JCAL#                          Save jcal for iobs sum
BUF(13)=PRFVAL#                        Profile function value
writedac:(ioda1:,,IR,(BUF(I),I=1,NEWPAK))# Save jcal this reflection
#
#   SUM SCALED DERIVATIVES IN SCRATCH LIST
#   --------------------------------------
#
IF(NCY<NCYCLE)#                        For all cycles except last
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6
IC=mflag:;  IS=MDTEMP+NB+1;  IB=1#     Set cons/scr/buffer pointers
#
DO I=1,2#                              Loop over zero corr parameters
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7
IF(REFZER(I)==no:) NEXT#               Skip if not used
IF(I==1) QX(IS)=QX(IS)+ICAL*FACDEL#    Zero correction 1
ELSE     QX(IS)=QX(IS)+ICAL*FACDEL*TTH# Zero correction 2
IS=IS+1#                               Incr scratch pointers
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7
#
do i=1,nph-1; IS=IS+NUMVAR(I)#         Point in deriv scratch array
#
DO I=1,9#                              Loop over genl parameters
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8
IF(QX(IC+I)<0.5) NEXT#                 Skip if not used
IF(I==1) QX(IS)=QX(IS)+ICAL/scal:#     Sum scale der
IF(I==2) QX(IS)=QX(IS)+ICAL*POF#       Sum pof der
IF(I==3) QX(IS)=QX(IS)+ICAL*FACHWD*0.5*TANT*TANT/HWH# Sum hwidth u
IF(I==4) QX(IS)=QX(IS)+ICAL*FACHWD*0.5*TANT/HWH# Sum hwidth v
IF(I==5) QX(IS)=QX(IS)+ICAL*FACHWD*0.5/HWH# Sum hwidth w
IF(I==6) QX(IS)=QX(IS)+ICAL*FACASY#    Sum pasymm a1
IF(I==7) QX(IS)=QX(IS)+ICAL*FACHWD/TANT# Sum pasymm a2
IF(I==8) QX(IS)=QX(IS)+ICAL*(LPART-GPART)# Sum mix
IF(I==9) QX(IS)=QX(IS)+ICAL*(ZZZZ)#    Sum uov
IS=IS+1#                               Incr scr pointers
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8
#
IC=mflag:+nflag:#                      Point to cell noref flags
DO I=1,3#                              Loop cell lengths
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9
IF(QX(IC+I)<0.5) NEXT#                 Skip if parameter is noref
#IF(QX(IC+I)>10.) L=IS +NINT(QX(IC+I))-11# IF DEPENDENT PARAMETER
#ELSE             L=IS#            POINT TO SCRATCH STORAGE
#QX(L)=QX(L)-DERCEL*BUF(I)*BUF(I)*FACTTH# SUM DERIV WRT LENGTHS
QX(IS)=QX(IS)+FACTTH*DERCEL*BUF(I)*BUF(I)# Sum deriv wrt lengths
IS=IS+1#                               Incr scratch element pointer
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9
DO I=4,6#                              Loop cell angles
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10
IF(QX(IC+I)<0.5) NEXT#                 Skip if parameter is noref
J=MOD(I,3)+1;   K=MOD(J,3)+1#          Get alternative axes
#IF(QX(IC+I)>10.) L=IS+NINT(QX(IC+I))-11# IF DEPENDENT PARAMETER
#ELSE             L=IS#            POINT TO SCRATCH STORAGE
#QX(L)=QX(L)-DERCEL*BUF(J)*BUF(K)*FACTTH# SUM DERIV WRT ANGLES
QX(IS)=QX(IS)+FACTTH*DERCEL*BUF(J)*BUF(K)# Sum deriv wrt angles
IS=IS+1#                               Incr scratch element pointer
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10
#
IB=21#
FOR(IC=mflag:+nflag:*2;IC<lflag:;IC=IC+nflag:)# Loop noref flags
DO I=1,11#                             Loop over structure params
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11
IF(QX(IC+I)<0.5) NEXT#                 Skip norefs
IF(QX(IC+I)>CC) NEXT#                  Skip constraints
QX(IS)=QX(IS)-BUF(IB)*PRFVAL#          Sum struct params
IS=IS+1;  IB=IB+1#                     Incr scr/buffer pointers
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
MCONTR=MAX0(MCONTR,NCONTR)#            Max overlapping refls
#
#     CALCULATE OBSERVED INTENSITY
#     ----------------------------
## i.e. scale obs to cal intensity, then build iobs for each of the
## overlapping reflections by integrating over its peak
#
IF(CNBCAL>0.&CNBOBS>0.)#               Ycal and yobs > zero
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12
SCALE=CNBOBS/CNBCAL#                   Scale to yobs
DO IR=LOHKL,HIHKL#                     Loop lowest to highest 2theta
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13
readdac:(ioda1:,,IR,(BUF(I),I=1,NEWPAK))# Read refln file
IOBS=BUF(16)#                          Sum iobs so far
JCAL=BUF(17)#                          Ical*prfval
IOBS=IOBS+JCAL*SCALE*TTSTEP#           Sum iobs+(scl*ical*ttstep)
BUF(16)=IOBS#                          Build iobs
writedac:(ioda1:,,IR,(BUF(I),I=1,NEWPAK))# Save iobs till next step
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12
#
#     ADD BACKGROUND TO CALCULATED INTENSITY
#     --------------------------------------
#
10 CONTINUE#                           No contributors join here
CNTCAL=CNBCAL+BACGRD#                  Add background
#IF(FLGCP==YES:)CNTOBS=CNTCAL#         POWGEN - GENERATE YOBS VALUE
DELTA=CNTOBS-CNTCAL#                   Yobs - ycal
IF(WTSCHM==0)WEIGHT=1.0#               Unit stepweight
IF(WTSCHM==1)WEIGHT=CNTWHT#            Stepweight from pattern
IF(WTSCHM==2)WEIGHT=1.0/(CNTSIG*CNTSIG)# Stepweight = 1/sigsq
DELTAW=DELTA*WEIGHT#
#
#     WRITE PATTERN FILE (.POT)
#     ------------------
#
IF(NCY==NCYCLE)#                       Last cycle only
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14
writepkt:(4,lrppat:,PACK,IP)#          Pt to pow pat o/p pkt
QX(IP+1)=TT#                           Two theta
QX(IP+2)=CNTOBS#                       Obs step count
QX(IP+3)=CNTWHT#                       Obs step weight
QX(IP+4)=CNTSIG#                       Obs step sigma
QX(IP+5)=CNTCAL#                       Calc step count
QX(IP+6)=CNTBAC#                       Background step count
QX(IP+7)=FLOAT(REFLAG)#                Refl/phase indicator
#
#    PRINT STEP INFORMATION
#    ----------------------
#
IF(LISTEP==yes:)#                      List step quantities
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15
ncodefld:(TT,1,CHROT,80622.,1)#        Step angle (tth)
ncodefld:(FLOAT(NCONTR),1,CHROT,130313.,1)# Total nr of contributors
ncodefld:(CNTOBS,1,CHROT,220813.,1)#   Observed intensity
ncodefld:(CNTCAL,1,CHROT,310813.,1)#   Calculated intensity
ncodefld:(DELTA,1,CHROT,400813.,1)#    Difference
ncodefld:(WEIGHT,1,CHROT,490822.,1)#   Observation weight
ncodefld:(DELTAW,1,CHROT,580813.,1)#   Weighted difference
IF(REFLAG>0)#                          At least one contributor
ncodefld:(FLOAT(REFLAG),1,CHROT,650413.,1)# Coded id of contributors
writeline:(0,RT541,NRT541,1,3)#
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14
#
#   KEEP PATTERN STATISTICS
#   -----------------------
#
FAC1=DELTA*DELTA*WEIGHT#               Weighted delta**2
IF(FAC1<=0.)FAC2=0.#
ELSE        FAC2=SQRT(FAC1)#           Delta/sigma
RSUMS(51)=RSUMS(51)+ABS(DELTA)#        Sum delta
RSUMS(52)=RSUMS(52)+CNTOBS#            Sum yobs
RSUMS(53)=RSUMS(53)+CNTCAL#            Sum ycal
RSUMS(54)=RSUMS(54)+FAC1#              Sum weighted delta**2
RSUMS(55)=RSUMS(55)+CNTOBS*CNTOBS*WEIGHT# Sum wt*(yobs)**2
IF(RSUMS(58)>-1.)#                     All except first step
RSUMS(56)=RSUMS(56)+(FAC2-RSUMS(58))**2# Sum diff**2 for d-stat
RSUMS(57)=RSUMS(57)+1.#                Sum nr of observations
RSUMS(58)=FAC2#                        Save this delta/sigma
IF(NCONTR>0)#                          Only when peaks are present
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16
RSUMS(59)=RSUMS(59)+ABS(CNBOBS-CNBCAL)# Sum delta
RSUMS(60)=RSUMS(60)+CNBOBS#            Sum yobs no bgd
RSUMS(61)=RSUMS(61)+1.#                Sum nr of observations
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16
#
RETURN#
END#
#
systemheader:(RT55)#                   Build matrix and vector
# ####################################################################
#
#                               RT55
#
# ####################################################################
SUBROUTINE RT55#
include:(AACOMN)#
include:(RTCOMN)#
#
## delta,weight = (yobs-ycalc); weight for each step
INTEGER LM# ## DERIVATIVE MATRIX POINTER
INTEGER LV# ## DERIVATIVE VECTOR POINTER
INTEGER LT# ## DERIVATIVE TEMPORARY AREA POINTER
INTEGER K,L,JJ,LL#
#
#    BUILD DERIVATIVE MATRICES
#    -------------------------
#
LM=MDMATX; LV=MDVECT; LT=MDTEMP#       Start array markers
DO K=1,VARTOT#                         Loop over total nr variables
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
JJ=LT+1;  A=WEIGHT*QX(JJ)#             Get element, insert weight
DO L=JJ,LDTEMP#                        Loop over core elements
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
LM=LM+1;  QX(LM)=QX(LM)+A*QX(L)#       Form matrix block
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
LV=LV+1;  QX(LV)=QX(LV)+A*DELTA#       Form diff vector
LT=LT+1#                               Incr temp area pointer
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
#
RETURN#
END#
#
systemheader:(RT60)#                   Treat restraints
# ############################################################# #
#                                                               #
#                              RT60                             #
#                                                               #
# ############################################################# #
SUBROUTINE RT60#
#
chardata:(RT601, ****** RESTRAINTS NOT YET IMPLEMENTED *******)#
datastuff:#
#
#WRITELINE:(0,RT601,NRT601,3,3)#        RESTR NOT READY
#
RETURN#
END#
#
systemheader:(RT70)#                   Sums and discrepancies
# ####################################################################
#
#                               RT70
#
# ####################################################################
SUBROUTINE RT70(FLG)#
include:(RTCOMN)#
include:(AACOMN)#
#
INTEGER I,J,K,FLG,NC#                  Index vars, final prt flg, sum
REAL NVAR,NOBS,NPOBS# ## all variables, all steps, peak steps
REAL D,Q,DQ,Q1,Q2#    ## D-statistic variables
chardata:(RT701, STRUCTURE FACTOR SUMS BEFORE CYCLE  1)#
chardata:(RT702, PHASE )#
chardata:(RT703,[ SUM/IOBS/ SUM/FOBS/ SUM/DELTAI/ $#
SUM/DELTAF/ REDUCED CHI-SQUARE TEST (S, G OF F) SIGMA(CHI)])#
chardata:(RT704, R-FACTORS)#
chardata:(RT705,NUMBER OF CONTRIBUTING REFLECTIONS)#
chardata:(RT706,AFTER )#
chardata:(RT707, STRUCTURE FACTORS CALCULATED FOR ...)#
chardata:(RT708, APPLIED TO LEAST SQUARES MATRIX ...)#
chardata:(RT709,NUMBER OF VARIABLES)#
chardata:(RT70A, POWDER PATTERN SUMS  )#
chardata:(RT70B,NUMBER OF OBSERVATIONS)#
chardata:(RT70C, STEP COUNTS (YC) CALCULATED FOR ...)#
chardata:(RT70D,NOBS - PEAK AREAS ONLY)#
chardata:(RT70E,[$#
RB - BRAGG INTENSITIES M*F**2$#
RF - F-VALUES$#
RP - PROFILE$#
RWP - WEIGHTED PROFILE$#
RE - EXPECTED$#
RPP - PROFILE (PEAKS ONLY)])#
chardata:(RT70F,[SUM(YO-YC) SUM(W*(YO-YC)**2) SUM(W*YO**2)$#
 SUM(YO)])#
chardata:(RT70G,[SQRT(SUM(W*D**2)/(NOBS-NVAR))])#
chardata:(RT70H,[LINEAR SCALING RATIO - SUM(YC)/SUM(YO)])#
chardata:(RT70I, REFINEMENT TERMINATED - CHECK RWP)#
chardata:(RT70J, DURBIN-WATSON D-STATISTIC ANALYSIS)$#
chardata:(RT70K,[MAXIMUM S/E])#
chardata:(RT70L, REFINEMENT INDEX SUMMARY)#
chardata:(RT70M,[ CYCLE    RP     RWP      RR      S       RB$#
      RF      D  MAX(S/E)  RPP])#
chardata:(RT70N,[ SIGNIFICANCE LIMITS FOR D = .......,Q =])#
chardata:(RT70P,POSITIVENEGATIVE)#
chardata:(RT70Q, THUS SERIAL CORRELATION PRESENT = NONE    )#
chardata:(RT70R,MAX NR CONTRIBUTING REFLS PER STEP)#
#
realdata:(FMT1,[501022.,601022.,701022.,#
801022.,901022.,1001022.])#
realdata:(FMT2,[501032.,601032.,701032.,#
801032.,901032.,1001032.])#
realdata:(FMT3,[500613.,600613.,700613.,#
800613.,900613.,1000613.])#
realdata:(FMT4,[40213.,120732.,200732.,280732.,360732.,#
440732.,520732.,600732.,680732.,760732.])#
datastuff:#
#
## SUMS AND REFINEMENT INDICATORS
## ------------------------------
##
## SUMS stored in RSUMS array:
##
## RSUMS(51)-(61) pattern step count & restraint quantities
## 51 sum yo-yc
## 52 sum yo (step count observed)
## 53 sum yc (step count calculated)
## 54 sum w*(yo-yc)**2   (w=weight=1/sigma**2)
## 55 sum w*(yo)**2
## 56 sum ((del/sig)now - (del/sig)old)**2 ) (for d-statistic)
## 57 sum observations (total steps)
## 58 previous delta/sigma = sqrt(w*(yo-yc)**2)
##
## RSUMS(59)-(61) peak area quantities only
## 59 sum yo-yc
## 60 sum yo - bgd (net step count observed)
## 61 sum observations (total steps over peaks)
##
## 62 sum w*(rp-rc)**2 (restraints)
## 63 sum w*(rp)**2    (restraints)
##
## RSUMS(1)-(50) structure factor quantities for up to 10 phases
##  0 + phasenr  sum io  (mult*fo**2,' bragg intensities')
## 10 + phasenr  sum io-ic
## 20 + phasenr  sum fo  (fobs, 'observed' structure factor)
## 30 + phasenr  sum fo-fc
## 40 + phasenr  sum reflections
##
## BUFOT(1)-(10) printer buffer for rb and rf and then
##
## 1 s = g of f = chi    2 sigma(chi)
## 3 r(expected)         4 linear scaling ratio s(yc)/s(yo)
##
## RSTORE array - Refinement indicators store
## Stored for up to 10 cycles ; j=10*(cyclenr-1)
##
## j+1 Rp  R(profile)
##   2 Rwp R(weighted profile)
##   3 Rr  R(restraints)
##   4 S(total) = G of F = sqrt(chi**2) (incl. restraints)
##   5 Rb  R(bragg intensities)
##   6 Rf  R(F-values)
##   7 D   Durbin-Watson d-statistic
##   8 S/E maximum shift/esd
##   9 Rpp R(profile, peaks only)
#
#    PRINT STRUCTURE FACTOR SUMMARY
#    ------------------------------
#
LINRM= 6#
NC=NCY#                                Current cycle number
IF(FLG==1)#                            Final print out
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
NC=NCYCLE#                             After last cycle
ncodefld:(FLOAT(NC),1,RT701,380213.,1)# Encode cycle nr
movechar:(RT706,1,RT701,24,6,0)#       After
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
NC=MIN0(NC,10)#                        Rsums array pointer & limit
J=10*(NC-1)#                           Offset in rstore array
#
movechar:(RT704,3,CHROT,2,36,1)#       Underline
writeline:(1,RT701,NRT701,2,1)#        Sums and discrepancy
writeline:(0,RT707,NRT707,3,3)#        Print sf header
movechar:(RT702,2,CHROT,2,NRT702,0)#   Phase
DO I=1,NPHASE#
movechar:(PHASE(I),1,CHROT,35+10*I,6,0)# Phase name
writeline:(0,0,0,1,1)#                 Write header
movechar:(RT705,1,CHROT,2,NRT705,0)#   Number of reflections
ncodefld:(RSUMS,41,CHROT,FMT3,NPHASE)# Format nr reflections
writeline:(0,0,0,1,1)#                 Number of reflections
#
movechar:(RT703,2,CHROT,2,9,0)#        Sum /iobs/
ncodefld:(RSUMS,1,CHROT,FMT1,NPHASE)#  Sum /iobs/
writeline:(0,0,0,1,1)#                 Sum /iobs/
#
movechar:(RT703,22,CHROT,2,11,0)#      Sum /deltai/
ncodefld:(RSUMS,11,CHROT,FMT1,NPHASE)# Sum /deltai/
writeline:(0,0,0,1,1)#                 Sum /deltai/
#
movechar:(RT703,12,CHROT,2,9,0)#       Sum /fobs/
ncodefld:(RSUMS,21,CHROT,FMT1,NPHASE)# Sum /fobs/
writeline:(0,0,0,1,1)#                 Sum /fobs/
#
movechar:(RT703,34,CHROT,2,11,0)#      Sum /deltaf/
ncodefld:(RSUMS,31,CHROT,FMT1,NPHASE)# Sum /deltaf/
writeline:(0,0,0,1,1)#                 Sum /deltaf/
#
writeline:(0,RT704,NRT704,3,1)#        R-factors heading
movechar:(RT70E,1,CHROT,5,29,0)#       Rb-factor
#
DO I=1,NPHASE#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
IF(ABS(RSUMS(I))>small:) $#            Sum(iobs)
BUFOT(I)=RSUMS(I+10)/RSUMS(I)#         Rb=s(delta)/s(obs)
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
RSTORE(J+5)=BUFOT(1)#                  Summarize rb of 1st phase
ncodefld:(BUFOT,1,CHROT,FMT2,NPHASE)#  Rb-factor
writeline:(0,0,0,1,1)#                 Rb-factor
#
movechar:(RT70E,30,CHROT,5,13,0)#      Rf-factor
DO I=1,NPHASE#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
IF(ABS(RSUMS(I+20))>small:) $#         Sum(fobs)
BUFOT(I)=RSUMS(I+30)/RSUMS(I+20)#      Rf=s(delta)/s(obs)
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
RSTORE(J+6)=BUFOT(1)#                  Summarize rf of 1st phase
ncodefld:(BUFOT,1,CHROT,FMT2,NPHASE)#  Rf-factor
writeline:(0,0,0,1,1)#                 Rf-factor
#
# POWDER PATTERN R-VALUES
# -----------------------
#
NOBS=RSUMS(57); NPOBS=RSUMS(61)#       Nr observations
NVAR=FLOAT(VARTOT)#                    Nr variables
IF(ABS(RSUMS(52))>small:) $#           Sum y(obs)
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
RSTORE(J+1)=RSUMS(51)/RSUMS(52)#       Rp=s(delta)/s(obs)
BUFOT(4)=RSUMS(53)/RSUMS(52)#          Lin.sc.ratio=s(cal)/s(obs)
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
IF(ABS(RSUMS(60))>small:) $#           Sum y(obs)
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5
RSTORE(J+9)=RSUMS(59)/RSUMS(60)#       Rpp=s(delta)/s(obs) (peaks)
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5
IF(ABS(RSUMS(55))>small:) $#           Sum(w*obs**2)
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6
RSTORE(J+2)=SQRT(RSUMS(54)/RSUMS(55))# Rwp=sqrt(s(wdsq)/swo**2)
BUFOT(3)=SQRT((NOBS-NVAR)/RSUMS(55))#  Re=sqrt((n-m)/swo**2))
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6
IF((NOBS-NVAR)>small:) $#              For chi-square
BUFOT(1)=SQRT(RSUMS(54)/(NOBS-NVAR))#  Swd/(n-m)
IF(NOBS<small:) BUFOT(1)=0.#           Null if no refine
BUFOT(2)=BUFOT(1)/SQRT(2.*(NOBS-NVAR))# Calc sigma chi squ
GOF=BUFOT(1)#                          Save swd/(n-m) for st.dev
RSTORE(J+4)=BUFOT(1)#                  S total (incl restraints)
IF(ABS(RSUMS(54))>small:) $#           Sum(w*del**2)
RSTORE(J+7)=RSUMS(56)/RSUMS(54)#       D-statistic
#
#    PRINT POWDER PATTERN SUMMARY
#    ----------------------------
#
LINRM= 6#
movechar:(RT70A,2,CHROT,2,21,0)#       Powder pattern sums
movechar:(RT701,24,CHROT,24,15,0)#     Before/after cycle nr
writeline:(1,0,0,1,1)#
movechar:(RT704,3,CHROT,2,36,1)#       Underline
writeline:(0,0,0,1,1)#
#
writeline:(0,RT70C,NRT70C,3,3)#        Print sf header
movechar:(RT70B,1,CHROT,2,NRT70B,0)#   Number of observations
ncodefld:(NOBS,1,CHROT,FMT3,1)#        Format numb observations
writeline:(0,0,0,1,1)#                 Number of observations
#
movechar:(RT70D,1,CHROT,2,NRT70D,0)#   Number of obs -peak areas
ncodefld:(NPOBS,1,CHROT,FMT3,1)#       Format nobs -peak areas
writeline:(0,0,0,1,1)#                 Nobs -peak areas
#
movechar:(RT709,1,CHROT,2,NRT709,0)#   Number of variables
ncodefld:(NVAR,1,CHROT,FMT3,1)#        Number of variables
writeline:(0,0,0,1,1)#                 Number of variables
#
movechar:(RT70R,1,CHROT,2,NRT70R,0)#   Number of contributors
ncodefld:(FLOAT(MCONTR),1,CHROT,FMT3,1)# Number of contributors
writeline:(0,0,0,1,1)#                 Number of contributors
#
movechar:(RT70F,1,CHROT,2,10,0)#       Sum /yo-yc/
ncodefld:(RSUMS,51,CHROT,FMT1,1)#
writeline:(0,0,0,1,1)#
#
movechar:(RT70F,43,CHROT,2,7,0)#       Sum /yo/
ncodefld:(RSUMS,52,CHROT,FMT1,1)#
writeline:(0,0,0,1,1)#
#
movechar:(RT70F,12,CHROT,2,17,0)#      Sum /w*(yo-yc)**2/
ncodefld:(RSUMS,54,CHROT,FMT1,1)#
writeline:(0,0,0,1,1)#
#
movechar:(RT70F,30,CHROT,2,12,0)#      Sum /w*yo**2/
ncodefld:(RSUMS,55,CHROT,FMT1,1)#
writeline:(0,0,0,1,1)#
#
writeline:(0,RT704,NRT704,3,1)#        R-factors heading
movechar:(RT70E,43,CHROT,5,12,0)#      Rp-factor
ncodefld:(RSTORE,J+1,CHROT,FMT2,1)#
writeline:(0,0,0,1,1)#
movechar:(RT70E,90,CHROT,5,26,0)#      Rpp-factor
ncodefld:(RSTORE,J+9,CHROT,FMT2,1)#
writeline:(0,0,0,1,1)#
movechar:(RT70E,55,CHROT,5,22,0)#      Rwp-factor
ncodefld:(RSTORE,J+2,CHROT,FMT2,1)#
writeline:(0,0,0,1,1)#
movechar:(RT70E,77,CHROT,5,13,0)#      Re-factor
ncodefld:(BUFOT,3,CHROT,FMT2,1)#
writeline:(0,0,0,1,1)#
#
movechar:(RT703,46,CHROT,2,35,0)#      Red chi-square test
writeline:(0,0,0,1,1)#
movechar:(RT70G,1,CHROT,5,NRT70G,0)#   Definition of s
ncodefld:(BUFOT,1,CHROT,FMT2,1)#       Value of s
writeline:(0,0,0,1,1)#                 Chi-square
#
movechar:(RT703,82,CHROT,5,10,0)#      Insert sigma chi head
ncodefld:(BUFOT,2,CHROT,FMT2,1)#       Format sigma chi square
writeline:(0,0,0,1,1)#                 Print sigma chi square
#
movechar:(RT70H,1,CHROT,2,NRT70H,0)#   Linear scaling ratio
ncodefld:(BUFOT,4,CHROT,FMT2,1)#       Sum(ycal)/sum(yobs)
writeline:(0,0,0,1,1)#
#
movechar:(RT70J,2,CHROT,2,25,0)#       D-statistic
ncodefld:(RSTORE,J+7,CHROT,FMT2,1)#
writeline:(0,0,0,1,1)#
#
movechar:(RT70K,1,CHROT,2,NRT70K,0)#   Max s/e
ncodefld:(RSTORE,J+8,CHROT,FMT2,1)#
writeline:(0,0,0,1,1)#
#
IF(TERMNT==yes:)#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7
IF(RSTORE(J+2)<=0.01)#                 Rwp not smaller
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8
NCY=NCYCLE#                            Terminate
writeline:(0,RT70I,NRT70I,3,1)#        Refinement terminated
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7
#
# REFINEMENT INDEX SUMMARY & D-STATISTIC ANALYSIS
# -----------------------------------------------
#
IF(FLG==1)#                            Skip till last pass thru here
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9
LINRM=NC+4#                            Space for l.s. index summary
movechar:(RT704,3,CHROT,2,NRT70L-1,1)# Underline
writeline:(1,RT70L,NRT70L,2,1)#        Summary heading
writeline:(0,RT70M,NRT70M,3,1)#        Index heading
DO I=1,NC#                             All cycles
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10
J=10*I-9#                              Rstore array pointer
ncodefld:(FLOAT(I),1,CHROT,FMT4(1),1)# Cycle nr
ncodefld:(RSTORE,J,CHROT,FMT4(2),9)#   All 9 indices
writeline:(0,0,0,1,1)#
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10
#
LINRM=4#                               Space for d-analysis
I=NC*10-3; D=RSTORE(I)#                D from last cycle
Q=(NOBS-1.)/(NOBS-NVAR)-3.0902/SQRT(NOBS+2.)#
Q=Q+Q#                                 Durbin-watson d-statistic
DQ=ABS(2.0-Q)#                         Difference from 2
Q1=2.0-DQ; Q2=2.0+DQ#                  Signif limits for d
movechar:(RT704,3,CHROT,2,NRT70J-1,1)# Underline
writeline:(1,RT70J,NRT70J,2,1)#        Summary heading
movechar:(RT70N,26,CHROT,2,3,0)#       D
movechar:(RT70N,38,CHROT,18,3,0)#      Q
ncodefld:(D,1,CHROT,FMT4(2),1)#        Value of d
ncodefld:(Q,1,CHROT,FMT4(4),1)#        Value of q
writeline:(0,0,0,1,1)#
movechar:(RT70N,2,CHROT,2,36,0)#       Significance limits
ncodefld:(Q1,1,CHROT,FMT4(5),1)#       Value of q1
ncodefld:(Q2,1,CHROT,FMT4(6),1)#       Value of q2
writeline:(0,0,0,1,1)#
IF(D<Q1)movechar:(RT70P,1,RT70Q,36,8,0)# Pos serial correlation
IF(D>Q2)movechar:(RT70P,9,RT70Q,36,8,0)# Neg serial correlation
writeline:(0,RT70Q,NRT70Q,3,1)#        Serial correl message
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9
#
RETURN#
END#
systemheader:(RT80)#                   Matrix inversion
#####################################################################
#
#                               RT80
#
#####################################################################
SUBROUTINE RT80#
include:(AACOMN)#
include:(RTCOMN)#
#
REAL    FACT#      ## Factor for st.dev.
INTEGER I,J,K,P#
INTEGER LLM,LLMK,LLMP,LLMKK,LLMKP,LLMKJ,LLMPP,LLMPJ#
INTEGER LLV,LLVK,LLVP,LLT#
REAL    Q#
#
#       MATRIX INVERSION
#       ----------------
#
IF(LISTMX==yes:&NCY==NCYCLE) CALL RT81(1)# Prt direct matrix and vect
#
IF(FLGUOV==yes:&NPHASE==1)#            Skf-b correlation
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
K=VARPAT#                              Skip zer and bac vars
DO J=mflag:+1,mflag:+8#                Test skf pof pro mix
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
IF(QX(J)<1.\QX(J)>CC) NEXT#            Skip if not refined
K=K+1#                                 Count active variables
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
LLM=MDMATX+VARPAT+1#                   Point to skf deriv
LLV=MDVECT+K+1#                        Point to uov vect
UOVSH=QX(LLV)/QX(LLM)#                 Shift(bov) from 1*1 matrix
UOVSD=GOF/QX(LLM)#                     Sd(bov) from 1*1 matrix
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
#
LLM=MDMATX; LLV=MDVECT; LLT=MDTEMP#
LLMK=LLM#
DO K=1,VARTOT#                         Loop over all variables
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
LLMKK=LLMK+K;LLVK=LLV+K#
LLMP=LLM#
FOR(P=1;P<K;P=P+1)#                    Loop over 1 row
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
LLMPP=LLMP+P;LLMPK=LLMP+K;LLVP=LLV+P#
Q=QX(LLMPK)*QX(LLMPP)#
DO J=K,VARTOT#
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5
LLMKJ=LLMK+J;LLMPJ=LLMP+J#
QX(LLMKJ)=QX(LLMKJ)-Q*QX(LLMPJ)#
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5
QX(LLVK)=QX(LLVK)-Q*QX(LLVP)#
LLMP=LLMP+VARTOT-P#
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
ifne:(QX(LLMKK),0.) QX(LLMKK)=1./QX(LLMKK)#
LLMK=LLMK+VARTOT-K#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
LLM=LLMK#
FOR(K=VARTOT;K>=1;K=K-1)#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6
LLMKK=LLMK+K;LLVK=LLV+K#
QX(LLVK)=QX(LLVK)*QX(LLMKK)#
LLMP=LLM#
FOR(P=VARTOT;P>K;P=P-1)#
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7
LLMPP=LLMP+P;LLMKP=LLMK+P#
LLVP=LLV+P;LLTP=LLT+P#
QX(LLTP)=QX(LLMKK)*QX(LLMKP)#
QX(LLMKP)=-QX(LLTP)*QX(LLMPP)#
FOR(J=P+1;J<=VARTOT;J=J+1)#
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8
LLMPJ=LLMP+J;LLMKJ=LLMK+J;LLTJ=LLT+J#
QX(LLMKP)=QX(LLMKP)-QX(LLTJ)*QX(LLMPJ)#
QX(LLMKJ)=QX(LLMKJ)-QX(LLTP)*QX(LLMPJ)#
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8
QX(LLVK)=QX(LLVK)-QX(LLTP)*QX(LLVP)#
LLMP=LLMP-VARTOT+P-1#
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7
FOR(J=K+1;J<=VARTOT;J=J+1)#
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9
LLMKJ=LLMK+J;LLTJ=LLT+J#
QX(LLMKK)=QX(LLMKK)-QX(LLTJ)*QX(LLMKJ)#
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9
LLMK=LLMK-VARTOT+K-1#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6
LLM=LLM+VARTOT; LLV=LLV+VARTOT#
IF(LISTMX==yes:&NCY==NCYCLE) CALL RT81(2)# Prt inverted matrix, shift
#
## CALCULATE ST.DEV. AND MOVE INTO mdtemp-ARRAY
#
LLM=MDMATX+1; LLT=MDTEMP+1#
DO K=1,VARTOT#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10
QX(LLT)=SQRT(ABS(QX(LLM)*GOF))#        Sqrt(absval*sum(w*dsq)/(n-m))
LLM=LLM+VARTOT-K+1;LLT=LLT+1#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10
RETURN#
END#
#
systemheader:(RT81)#                   Print matrix
# ####################################################################
#
#                               RT81
#
# ####################################################################
SUBROUTINE RT81(KK)#
include:(AACOMN)#
include:(RTCOMN)#
#
INTEGER I,J,K,L,M,N#                   General integers
REAL    FORM(13)#                      Output format
INTEGER KK#                            Kk=1 direct kk=2 inverted
INTEGER LLM#                           List pointers
INTEGER MW#                            Max words in a line
#
chardata:(RT811,DIRECT MATRIX  INVERTED MATRIX VECTOR BLOCK)#
chardata:(RT812, ROW    )#
datastuff:#
#
#     SETUP PRINT PARAMETERS
#     ----------------------
#
MW=prtcmax:/10#                        No. of items per line
DO K=1,MW;  FORM(K)=FLOAT(K*100000+931)# Generate output format
#
#    PRINT MATRIX
#    ------------
#
K=KK*15-14#                            Point to matrix type
movechar:(RT811,K,CHROT,2,15,0)#       Insert matrix type
LINRM=8;   writeline:(1,0,0,1,3)#      Print matrix header
M=VARTOT;    LLM=MDMATX#               Element count  & pointer
#
DO K=1,M#                              Loop over elements
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
ncodefld:(FLOAT(K),1,RT812,80313.,1)#  Format row
writeline:(0,RT812,NRT812,3,3)#        Print row header
DO J=K,M,MW#                           Loop over row
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
I=MIN0(MW,M-J+1)#                      Limit length of line
ncodefld:(QX,LLM+J,CHROT,FORM,I,0)#    Format output line
writeline:(0,0,0,1,3)#                 Print output line
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
LLM=LLM+M-K#                           Update list11 pointer
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
#
#    LIST VECTOR
#    -----------
#
movechar:(RT811,32,CHROT,2,6,0)#       Insert vector header
LINRM=4;    writeline:(1,0,0,1,3)#     Print vector header
FOR(K=MDVECT;K<MDTEMP;K=K+MW)#         Loop over vector elements
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
I=MIN0(MW,MDTEMP-K)#                   Limit length of line
ncodefld:(QX,K+1,CHROT,FORM,I,0)#      Format vector line
writeline:(0,0,0,1,3)#                 Print vector line
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
#
RETURN#
END#
#
systemheader:(RT90)#                   Update and print parameters
# ####################################################################
#
#                               RT90
#
# ####################################################################
SUBROUTINE RT90#
#
include:(AACOMN)#
include:(RTCOMN)#
#
string:(OUTL,80)#
INTEGER I,J,K,L,M,N## General indices
INTEGER II,JJ#   ## General indices
INTEGER LLV,LLT## List indices
#
chardata:(RT901,-)#
chardata:(RT902,[ PARAMETERS AFTER CYCLE    ])#
chardata:(RT903, CUMULATIVE LEAST SQUARES CYCLES = XXXXX)#
chardata:(RT904,BETA UIJ SUIJ REMARK EXTINC   2 *4 *17  )#
chardata:(RT905,ZERO  BACKGRPHASE PEAK  HWIDTHPASYMMORIENT)#
chardata:(RT906, PHASE )#
realdata:(FMT,[240852.,320852.,400852.,480852.,560852.,640852.])#
datastuff:#
#
LLV=MDVECT+1; LLT=MDTEMP+1#            Start list12/13 pointers
BUFOT(1)=FLOAT(NCY)#                   Store cycle number
ncodefld:(FLOAT(NCY),1,RT902,260213.,1)# Format cycle number
movechar:(RT901,1,CHROT,2,NRT902-1,1)# Underline header
writeline:(1,RT902,NRT902,2,3)#        Parameters after cycle ..
SOEMAX=0.0#
#
#    PATTERN PARAMETERS
#    ------------------
#
IF(FLGBAC==yes:)CALL RT93(1,1,5,DAMPPR,20,LLV,LLT)# Background
IF(FLGZER==yes:)CALL RT93(2,1,2,DAMPPR,25,LLV,LLT)# Zero
#
#    PUNCH NEW PARAMETERS
#    --------------------
#
IF(PUNCH==yes:&NCY==NCYCLE)#           Punch remark-card if requ.
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
movechar:(BLANK,1,OUTL,1,80,1)#        Blank out punch buffer
movechar:(RT904,15,OUTL,1,6,0)#        Insert remark code
movechar:(TITLE,9,OUTL,10,17,0)#       Insert program,comp and date
movechar:(RT903,22,OUTL,40,5,0)#       Insert cycle
ncodefld:(FLOAT(NCY),1,OUTL,480313.,1)# Insert cycle number
writepch:(OUTL,80)#                    Punch out remark card
movechar:(RT905,1,OUTL,1,6,0)#         Insert zero
ncodefld:(PARZER,1,OUTL,FMT,2)#        Insert zero pars
writepch:(OUTL,80)#                    Punch out remark card
movechar:(RT905,7,OUTL,1,6,0)#         Insert backgr
ncodefld:(PARBAC,1,OUTL,FMT,5)#        Insert bac pars
writepch:(OUTL,80)#                    Punch out remark card
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
#
#    LOOP OVER THE PHASES PRESENT
#    ----------------------------
#
DO NPH=1,NPHASE#                       Loop over all phases
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
movechar:(RT906,2,CHROT,2,NRT906,0)#   Phase
movechar:(PHASE(NPH),1,CHROT,10,6,0)#  Phase name
writeline:(1,0,0,1,3)#                 Write header
IF(FLGSKF==yes:)CALL RT93(3,NPH,NPH,DAMPST,11,LLV,LLT)# Scale
IF(FLGPOF==yes:)CALL RT93(4,NPH,NPH,DAMPST,13,LLV,LLT)# Pref orient
IF(FLGPRO==yes:)CALL RT93(5,1,6,DAMPPR,14,LLV,LLT)# Profile
IF(FLGUOV==yes:)CALL RT93(6,NPH,NPH,DAMPST,12,LLV,LLT)# Uov
IF(FLGCEL==yes:)#                      Cell parameters
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
CALL RT91(LLV)#                        Calc shifts & esds
CALL RT93(7,1,6,DAMPST,27,1,1)#        Print cell params
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
#
IF(PUNCH==yes:&NCY==NCYCLE)#           Punch if required
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
movechar:(BLANK,1,OUTL,1,80,1)#        Blank out punch buffer
movechar:(RT904,15,OUTL,1,6,0)#        Insert remark code
movechar:(TITLE,9,OUTL,10,17,0)#       Insert program,comp and date
movechar:(RT903,22,OUTL,40,5,0)#       Insert cycle
ncodefld:(FLOAT(NCY),1,OUTL,480313.,1)# Insert cycle number
writepch:(OUTL,80)#                    Punch out remark card
movechar:(RT905,13,OUTL,1,6,0)#        Insert phase
movechar:(PHASE(NPH),1,OUTL,8,6,0)#    Insert phase name
ncodefld:(scal:,1,OUTL,200941.,1)#     Insert scale
writepch:(OUTL,80)#                    Punch out remark card
movechar:(RT905,19,OUTL,1,6,0)#        Insert peak
ncodefld:(FLOAT(pkprofnr:),1,OUTL,100313.,1)# Insert peakfn nr
ncodefld:(span:,1,OUTL,FMT,1)#         Insert peak span
ncodefld:(PARPRO(NPH,6),1,OUTL,200842.,1)# Insert mix par
writepch:(OUTL,80)#                    Punch out remark card
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
#
CALL RT94(LLV,LLT)#                    Update and print atoms
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
I=8+10*(MIN0(NCY,10)-1)#               Store for up to 10 cycles
RSTORE(I)=SOEMAX#                      Save s/e max in summary array
RETURN#
END#
#
systemheader:(RT91)#                   Calc new cell pars & esds
#################################################################
#                                                               #
#                               RT91                            #
#                                                               #
#################################################################
SUBROUTINE RT91(LLV)#
#
include:(AACOMN)#
include:(RTCOMN)#
#
INTEGER I,J,K,L,M,N#
INTEGER JJ,KK,LL,MM#
INTEGER IC#                            Crystal system code
INTEGER LLM,MMM# ## pointers in the matrix
INTEGER PARNUM(6)## Parameter numbers of the cell parameters
INTEGER VAR#     ## serial number of a variable
REAL    B(3)#    ## Temp in matrix  inversion
REAL    FAC#     ## Temp factor
REAL    VC(36)#  ## VAR/COV MATRIX OF THE RMT
realdata:(RTOD,57.29578)#
realdata:(DTOR,.0174533)#
REAL    FORM(6)#                       Output format
chardata:(RT911,DIRECT CELL VARIANCE-COVARIANCE MATRIX)#
datastuff:#
movereal:(0.,1,BUF,1,100,2)#
movereal:(0.,1,VC,1,36,2)#
#
# STORE THE CELL PARAMETER NUMBERS AND APPLY SHIFTS
# -------------------------------------------------
#
DO I=1,6#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
PARNUM(I)=0#                           Default noref or constr
J=REFCEL(NPH,I)#                       Ref code
IF(J==1)#                              Refine
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
PARNUM(I)=LLV-MDVECT#                  Param serial number
stc:(I)=stc:(I)+QX(LLV)*DAMPPR#        Apply shift
LLV=LLV+1#                             Incr par nr
NUCELL=yes:#                           Changed cell flag
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
ELSE IF(J>1) stc:(I)=stc:(J-10)#       Constrained
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
#
# GET RECIPR METRIC TENSOR FROM THE REFINED STOL COEFFTS
# ------------------------------------------------------
#
rmt:(1)=4.*stc:(1)#
rmt:(5)=4.*stc:(2)#
rmt:(9)=4.*stc:(3)#
rmt:(2)=2.*stc:(4)#
rmt:(3)=2.*stc:(5)#
rmt:(6)=2.*stc:(6)#
rmt:(4)=rmt:(2)#
rmt:(7)=rmt:(3)#
rmt:(8)=rmt:(6)#
#
# FORM THE DIRECT METRIC TENSOR
# ------------------------------
#
DO I=1,9; dmt:(I)=rmt:(I)#             Copy to direct tensor
DO I=1,3#                              Invert the tensor
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
B(3)=1.0/dmt:(1)#
B(1)=dmt:(2)*B(3)#
B(2)=dmt:(3)*B(3)#
dmt:(3)=-dmt:(4)*B(3)#
dmt:(1)=dmt:(5)-dmt:(4)*B(1)#
dmt:(2)=dmt:(6)-dmt:(4)*B(2)#
dmt:(6)=-dmt:(7)*B(3)#
dmt:(4)=dmt:(8)-dmt:(7)*B(1)#
dmt:(5)=dmt:(9)-dmt:(7)*B(2)#
dmt:(7)=B(1)#
dmt:(8)=B(2)#
dmt:(9)=B(3)#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
#
# STORE OLD CELL PARAMETERS (WITH ANGLES IN DEG) IN BUF(1)-BUF(6)
# -------------------------
#
DO I=1,3#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
BUF(I)=dcp:(I)#                        Edges
BUF(I+3)=dcp:(I+6)#                    Angles in deg
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
#
# CALCULATE THE DIRECT CELL CONSTANTS
# -----------------------------------
#
dcp:(1)=SQRT(dmt:(1))#                 A
dcp:(2)=SQRT(dmt:(5))#                 B
dcp:(3)=SQRT(dmt:(9))#                 C
dcp:(4)=dmt:(6)/(dcp:(2)*dcp:(3))#     Cos(alpha)
dcp:(5)=dmt:(3)/(dcp:(1)*dcp:(3))#     Cos(beta)
dcp:(6)=dmt:(2)/(dcp:(1)*dcp:(2))#     Cos(gamma)
#
# TREAT ROUNDING OFF ERRORS
# -------------------------
#
I=msymm:; IC=QX(I+9); M=QX(I+10)#      Crystal system & axis
IF(IC==7)#                             Hexagonal
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5
dcp:(4)=0.; dcp:(5)=0.; dcp:(6)=-.5#
dmt:(2)=dcp:(1)*dcp:(2)*dcp:(6)#
dmt:(3)=0. ; dmt:(6)=0.#
dmt:(4)=dmt:(2); dmt:(7)=dmt:(3); dmt:(8)=dmt:(6)#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5
ELSE IF(IC==2&M==1)#                   Monoclinic first setting
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6
dcp:(4)=0.; dcp:(5)=0.#
dmt:(3)=0.; dmt:(6)=0.#
dmt:(4)=dmt:(2); dmt:(7)=dmt:(3); dmt:(8)=dmt:(6)#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6
ELSE IF(IC==2&M==2)#                   Monoclinic 2nd setting
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7
dcp:(4)=0.; dcp:(6)=0.#
dmt:(2)=0.; dmt:(6)=0.#
dmt:(4)=dmt:(2); dmt:(7)=dmt:(3); dmt:(8)=dmt:(6)#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7
ELSE IF(IC==2&M==3)#                   Monoclinic 3rd setting
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8
dcp:(5)=0.; dcp:(6)=0.#
dmt:(2)=0.; dmt:(3)=0.#
dmt:(4)=dmt:(2); dmt:(7)=dmt:(3); dmt:(8)=dmt:(6)#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8
#
# STORE NEW CELL PARAMETERS (WITH ANGLES IN DEG) IN BUF(7) -BUF(12)
# -------------------------
#
DO I=1,3#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9
BUF(I+6)=dcp:(I)#                      Cell edges
dcp:(I+6)=RTOD*ACOS(dcp:(I+3))#        Calc angles in deg
BUF(I+9)=dcp:(I+6)#                    Store angles in deg
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9
#
# CALCULATE THE RECIPROCAL CELL CONSTANTS
# ---------------------------------------
#
rcp:(1)=SQRT(rmt:(1))#                 A*
rcp:(2)=SQRT(rmt:(5))#                 B*
rcp:(3)=SQRT(rmt:(9))#                 C*
rcp:(4)=rmt:(6)/(rcp:(2)*rcp:(3))#     Cos(alpha*)
rcp:(5)=rmt:(3)/(rcp:(1)*rcp:(3))#     Cos(beta*)
rcp:(6)=rmt:(2)/(rcp:(1)*rcp:(2))#     Cos(gamma*)
rcp:(7)=ACOS(rcp:(4))/DTOR#            Alpha*
rcp:(8)=ACOS(rcp:(5))/DTOR#            Beta*
rcp:(9)=ACOS(rcp:(6))/DTOR#            Gamma*
#
# CALC THE TRANSFORMATION MATRIX (FRACT TO ORTHOG)
# ------------------------------------------------
#
tfc:(1)=dcp:(1)*SQRT(1.0-dcp:(5)**2)$#
              *SQRT(1.0-rcp:(6)**2)#   A.sin(beta).sin(gamma*)
tfc:(2)=-dcp:(1)*rcp:(6)$#
               *SQRT(1.0-dcp:(5)**2)#  -a.sin(beta).cos(gamma*)
tfc:(3)=dcp:(1)*dcp:(5)#               A.cos(beta)
tfc:(4)=0.0#
tfc:(5)=dcp:(2)*SQRT(1.0-dcp:(4)**2)#  B.sin(alpha)
tfc:(6)=dcp:(2)*dcp:(4)#               B.cos(alpha)
tfc:(7)=0.0#
tfc:(8)=0.0#
tfc:(9)=dcp:(3)#
#
# CALC THE INVERSE TRANSFORMATION MATRIX
# --------------------------------------
#
DO I=1,9; tcf:(I)=tfc:(I)#             Copy to inverse matrix
DO I=1,3#                              Invert the matrix
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10
B(3)=1.0/tcf:(1)#
B(1)=tcf:(2)*B(3)#
B(2)=tcf:(3)*B(3)#
tcf:(3)=-tcf:(4)*B(3)#
tcf:(1)=tcf:(5)-tcf:(4)*B(1)#
tcf:(2)=tcf:(6)-tcf:(4)*B(2)#
tcf:(6)=-tcf:(7)*B(3)#
tcf:(4)=tcf:(8)-tcf:(7)*B(1)#
tcf:(5)=tcf:(9)-tcf:(7)*B(2)#
tcf:(7)=B(1)#
tcf:(8)=B(2)#
tcf:(9)=B(3)#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10
tcf:(4)=tcf:(2)#
tcf:(7)=tcf:(3)#
tcf:(8)=tcf:(6)#
tcf:(2)=0.0#
tcf:(3)=0.0#
tcf:(6)=0.0#
#
# CALCULATE THE CELL VOLUME
# -------------------------
#
VOL=SQRT(1.0+2.0*dcp:(4)*dcp:(5)*dcp:(6)$#
    -dcp:(4)**2-dcp:(5)**2-dcp:(6)**2)#
VOL=VOL*dcp:(1)*dcp:(2)*dcp:(3)#
IF(VOL<=0.) iquit:(RT9110)#            Non-positive cell vol
VOL=VOL*VOL#                           Cell vol squared for ext
#
# EXTRACT THE VAR-COVAR MATRIX OF THE RMT, STORE IT IN VC
# --------------------------------------------------------
#
M=-6#                                  Vc-array pointer
DO I=1,6#                              Loop over the cell params
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11
M=M+7#                                 Incr vc pointer
LLM=MDMATX#                            Start of matrix array
VAR=PARNUM(I)#                         Get var nr of cell param
IF(VAR<=0)NEXT#                        Noref param
#
# SEARCH VAR-COVAR MATRIX FOR DIAGONAL ELEMENT CORRESPONDING TO VAR
#
K=VAR-1#                               (var-1)
MMM=LLM+K*VARTOT-(K*(K-1))/2#          Posn of diag element - 1
#
# LOAD VARIANCE AND COVARIANCES OF VARIABLE
#
J=-1#
DO L=I,6#
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12
J=J+1#
N=REFCEL(NPH,L)#                       Ref key, 1=ref, >10=constr
IF(N<=0) NEXT#                         Noref, no contrib
ELSE IF(N==1) MMM=MMM+1#               Ref, incr pointer
VC(M+J)=QX(MMM)#                       Ref or constr, load var/covar
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11
#
# COMPLETE MATRIX FOR CONSTRAINT ELEMENTS
#
M=-6#
DO I=1,6#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13
M=M+7#
IF(REFCEL(NPH,I)<10) NEXT#             On constr only
J=M - I#
DO L=I,6; VC(J+L)=VC(J+L-6)#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13
#
IF(IC==7)#                             Hexagonal
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14
VC(4)=VC(2)/2.#                        Calculate vc
VC(10)=VC(4)#                          For
VC(16)=VC(3)/2.#                       Astar*bstar*gammastar
VC(22)=VC(2)/4.#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14
#
DO I=1,6#                              Fill lower half of var-cov mat
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15
J=I+1#
DO K=J,6; VC(6*K+I-6)=VC(6*I+K-6)#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15
#
# COMPUTE ESD S OF THE CELL PARAMETERS
# ------------------------------------
#
# COMPUTE THE DERIVATIVES OF THE DMT WRT THE RMT
#
DO I=1,3#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16
K=I#
DO J=I,15,6#
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17
BUF(J+53)=-dmt:(K)**2#
K=K+3#
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16
L=19#
DO I=4,6#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18
J=1#
K=I-5#
IF(K>0) J=2#
BUF(I+53)=-dmt:(J)*dmt:(I-J-1)#
BUF(I+59)=-dmt:(J+3)*dmt:(I-J+2)#
BUF(I+65)=-dmt:(J+6)*dmt:(I-J+5)#
BUF(L+53)=2.0*BUF(I+53)#
BUF(L+54)=2.0*BUF(I+59)#
BUF(L+55)=2.0*BUF(I+65)#
L=L+6#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18
BUF(75)=-dmt:(2)**2-dmt:(1)*dmt:(5)#
BUF(82)=-dmt:(3)**2-dmt:(1)*dmt:(9)#
BUF(89)=-dmt:(6)**2-dmt:(5)*dmt:(9)#
BUF(76)=-dmt:(2)*dmt:(3)-dmt:(1)*dmt:(6)#
BUF(77)=-dmt:(2)*dmt:(6)-dmt:(5)*dmt:(3)#
BUF(83)=-dmt:(3)*dmt:(6)-dmt:(9)*dmt:(2)#
BUF(81)=BUF(76)#
BUF(87)=BUF(77)#
BUF(88)=BUF(83)#
#
# CORRECT THE DERIVATIVES FOR THE FACTOR IN VAR-COVAR
# MATRIX OF THE RMT
#
DO I=1,36,7 ; BUF(I+53)=2.0*BUF(I+53)#
DO I=1,36   ; BUF(I+53)=2.0*BUF(I+53)#
#
# BUF(I), I=54-89 CONTAINS THE DERIVATIVES OF THE DMT
# ELEMENTS WRT THE RMT ELEMENTS.
# COMPUTE THE VAR-COVAR MATRIX OF THE DMT
#
JJ=1; N=6#
DO I=1,36#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19
IF(N<I)#
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20
JJ=JJ+1; N=N+6#
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20
KK=I-N+6; LL=0#
IF(JJ>=KK)#
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21
DO J=JJ,36,6#
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22
LL=LL+1; MM=0#
DO K=KK,36,6#
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23
MM=MM+1; L=6*(LL-1)+MM#
BUF(I+17)=BUF(I+17)+BUF(J+53)*BUF(K+53)*VC(L)#
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21
ELSE#
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24
L=6*(KK-1)+JJ#
BUF(I+17)=BUF(L+17)#
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19
#
# COMPUTE DIRECT CELL DERIVATIVES WRT DMT
# ---------------------------------------
#
DO I=1,36; BUF(I+53)=0.0#
J=1; DO I=1,15,7#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25
BUF(I+53)=0.5/dcp:(J)#
J=J+1#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25
BUF(57)=-0.5*dcp:(6)/dmt:(1)#
BUF(58)=-0.5*dcp:(5)/dmt:(1)#
BUF(65)=-0.5*dcp:(4)/dmt:(5)#
BUF(63)=-0.5*dcp:(6)/dmt:(5)#
BUF(70)=-0.5*dcp:(5)/dmt:(9)#
BUF(71)=-0.5*dcp:(4)/dmt:(9)#
BUF(75)=1./(dcp:(1)*dcp:(2))#
BUF(82)=1./(dcp:(1)*dcp:(3))#
BUF(89)=1./(dcp:(2)*dcp:(3))#
#
# COMPUTE THE VAR-COVAR MATRIX OF THE DIRECT CELL
# -----------------------------------------------
#
DO I=1,36; VC(I)=0.0#
JJ=1 ; N=6#
DO I=1,36#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26
IF(N<I)#
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27
JJ=JJ+1; N=N+6#
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27
KK=I-N+6 ; LL=0#
IF(JJ<=KK)#
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28
DO J=JJ,36,6#
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29
LL=LL+1; MM=0#
DO K=KK,36,6#
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30
MM=MM+1; L=6*(LL-1)+MM#
VC(I)=VC(I)+BUF(J+53)*BUF(K+53)*BUF(L+17)#
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28
ELSE#
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31
L=6*(KK-1)+JJ; VC(I)=VC(L)#
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26
#
# TREAT ROUNDING-OFF ERRORS IN VAR-COVAR OF COS OF ANGLES
# -------------------------------------------------------
#
DO I=4,6#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32
K=0#
DO J=I,36,6#
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33
K=K+1#
IF(ABS(VC(J))<small:)#
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34
VC(J)=0.0#
L=6*(I-1)+K ; VC(L)=0.0#
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32
#
# COMPUTE ESD S OF THE DIRECT CELL VECTORS AND ANGLES
# ---------------------------------------------------
#
J=0; DO I=1,36,7#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35
J=J+1#
IF (VC(I)<=0.0) VC(I)=1.E-12#
dce:(J)=SQRT(VC(I))#                   Calc esd's
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35
#
# COMPUTE ANGLE VARIANCES
# -----------------------
#
DO I=4,6#
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36
FAC=DTOR*dcp:(I+3)#                    Angle in rad
FAC=SIN(FAC)#                          Sin angle
dce:(I+3)=RTOD*dce:(I)/FAC#            Angle var from cos var
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36
#
# LIST VARIANCE/COVARIANCE MATRIX
# -------------------------------
#
IF(LISTMX==no:)RETURN#
LINRM=8;#
DO K=1,6; FORM(K)=FLOAT(K*100000+931)# Generate output format
writeline:(1,RT911,NRT911,3,3)#        Print matrix header
L=0#                                   Pointer in vc-array
DO K=1,6#                              Vc-array size
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37
I=7-K#                                 Limit length of line
DO J=1,I; BUFOT(J)=VC(J+L)#            Get elements from vc array
ncodefld:(BUFOT,1,CHROT,FORM,I,0)#     Format output line
writeline:(0,0,0,1,3)#                 Print output line
L=L+7#                                 Update pointer along diagonal
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37
#
RETURN#
END#
systemheader:(RT93)#                   Print output lines
# ####################################################################
#
#                               RT93
#
# ####################################################################
SUBROUTINE RT93(ID,NPAR,MPAR,FAC,IDAT,LLV,LLT)#
include:(AACOMN)#
include:(RTCOMN)#
#
INTEGER I,J,K,L,II## General indices
INTEGER ID#                            Type of variable flag
INTEGER NPAR,MPAR#                     Beg,end pts in var array
INTEGER IDAT#                          Pt in header array
INTEGER REF#                           Refine flag
#
chardata:(RT931,X/AY/BZ/CU11U22U33U12U13U23POPSKFUOVPOF$#
 U  V  W  X  Y MIXBG1BG2BG3BG4BG5ZC1ZC2 A  B  C AL BE GA )#
chardata:(RT934,-OLD SHF NEW ERR ATOMS/E)#
chardata:(RT93A, ZERO CORRECTIONS)#
chardata:(RT93B, PROFILE PARAMETERS)#
chardata:(RT93C, SCALE FACTOR CORRECTION)#
chardata:(RT93D, CELL PARAMETERS)#
chardata:(RT93F,[ BACKGROUND CORRECTION = SUM(BGI*2TH**(I-1))])#
chardata:(RT93H, PHASE NUMBER    )#
chardata:(RT93I, PREFERRED ORIENTATION PARAMETER)#
chardata:(RT93J, OVERALL THERMAL DISPLACEMENT PARAMETER)#
realdata:(FORM,[220752.,321052.,421052.,521042.,621042.,721042.,#
821042.,921042.,1021042.,1121042.,1221042.,1321042.])#
realdata:(FORE,[220941.,320941.,420941.,520941.,620941.,720941.,#
820941.,920941.,1020941.,1120941.,1220941.,1320941.])#
datastuff:#
#
movereal:(voidflg:,1,BUFOT,1,mxfdln:,2)# Zero op field buffer
LINRM=8#
IF(ID==1)writeline:(1,RT93F,NRT93F,3,3)# Background header
IF(ID==2)writeline:(1,RT93A,NRT93A,3,3)# Zero cor header
IF(ID==3)writeline:(1,RT93C,NRT93C,3,3)# Scale cor header
IF(ID==4)writeline:(1,RT93I,NRT93I,3,3)# Pof cor header
IF(ID==5)writeline:(1,RT93B,NRT93B,3,3)# Profile cor header
IF(ID==6)writeline:(1,RT93J,NRT93J,3,3)# Uov cor header
IF(ID==7)writeline:(1,RT93D,NRT93D,3,3)# Cell cor header
#
DO I=NPAR,MPAR#                        Loop over param per line
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
REF=no:#                               Reset refine
II=(I+IDAT)*3-5; K=NINT(FORM(I))/10000+1# Ptrs for headers & refcodes
movechar:(RT931,II,CHROT,K-4,3,0)#     Insert param code in header
IF(ID==1)BUFOT(I)=PARBAC(I)#           Store old value
IF(ID==2)BUFOT(I)=PARZER(I)#           Store old value
IF(ID==3)BUFOT(I)=SKF(I)#              Store old value
IF(ID==4)BUFOT(I)=PARPOF(I)#           Store old value
IF(ID==5)BUFOT(I)=PARPRO(NPH,I)#       Store old value
IF(ID==6)BUFOT(I)=UOV(I)#              Store old value
IF(ID==7)BUFOT(I)=BUF(I)#              Store old value
BUFOT(I+24)=BUFOT(I)#                  Default as old value
IF(ID==1)REF=REFBAC(I)#                Set ref flag
IF(ID==2)REF=REFZER(I)#                Set ref flag
IF(ID==3)REF=REFSKF(I)#                Set ref flag
IF(ID==4)REF=REFPOF(I)#                Set ref flag
IF(ID==5)REF=REFPRO(NPH,I)#            Set ref flag
IF(ID==6)REF=REFUOV(I)#                Set ref flag
IF(ID==7)REF=REFCEL(NPH,I)#            Set ref flag
#
IF(REF==yes:&ID<=6)#                   Gen par is refined variable
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
BUFOT(I+12)=QX(LLV)#                   Store shift
BUFOT(I+24)=BUFOT(I)+FAC*QX(LLV)#      Calculate new par value
BUFOT(I+36)=QX(LLT)#                   Store std deviation
IF(ID==1)PARBAC(I)=BUFOT(I+24)#        Store new value
IF(ID==2)PARZER(I)=BUFOT(I+24)#        Store new value
IF(ID==3)SKF(I)=BUFOT(I+24)#           Store new value
IF(ID==4)PARPOF(I)=BUFOT(I+24)#        Store new value
IF(ID==5)PARPRO(NPH,I)=BUFOT(I+24)#    Store new value
IF(ID==6)UOV(I)=BUFOT(I+24)#           Store new value
LLV=LLV+1;     LLT=LLT+1#              Incr list pointers
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
#
IF(REF==yes:&ID==7)#                   Cell par is refined var
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
BUFOT(I+12)=BUF(I+6)-BUF(I)#           Store shift
BUFOT(I+24)=BUF(I+6)#                  Store new par value
IF(I<=3)BUFOT(I+36)=dce:(I)#           Store edge std deviation
ELSE    BUFOT(I+36)=dce:(I+3)#         Store angle std deviation
LLT=LLT+1#                             Incr list pointer
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
#
IF(REF>10&ID==7)#                      Cell par is constrained var
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
J=REF-10#                              Constrained pointer
BUFOT(I+12)=BUF(J+6)-BUF(J)#           Store shift
BUFOT(I+24)=BUF(J+6)#                  Store new par value
IF(I<=3)BUFOT(I+36)=dce:(J)#           Store edge std deviation
ELSE    BUFOT(I+36)=dce:(J+3)#         Store angle std deviation
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
writeline:(1,CHROT,K,3,3)#             Write sub-header line
#
DO I=1,4#                              Write output lines
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5
K=I*4-2;   L=(I-1)*12+1#               Point output items
movechar:(RT934,K,CHROT,11,4,0)#       Insert headers
DO J=NPAR,MPAR#                        Loop over parameters
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6
IF((I==1)\(BUFOT(J+36)>-.1))#          Test if old or refined
IF(ID==3)ncodefld:(BUFOT,L,CHROT,FORE(J),1)# E-format skf value
ELSE     ncodefld:(BUFOT,L,CHROT,FORM(J),1)# F-format values
L=L+1#                                 Incr parameter pointer
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6
writeline:(0,0,0,1,3)#                 Write a line
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5
movechar:(RT934,22,CHROT,11,3,0)#      Insert 's/e' header
DO J=NPAR,MPAR#                        Loop over number parameters
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7
IF(BUFOT(J+36)<small:) NEXT#           Skip if invariant
FAC=ABS(BUFOT(J+12)/BUFOT(J+36))#      Calc shift/std dev
SOEMAX=AMAX1(SOEMAX,FAC)#              Save s/e max
ncodefld:(A,1,CHROT,FORM(J),1)#        Format shift/stdev
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7
writeline:(0,0,0,1,3)#                 Print shift/stdev line
#
RETURN#
END#
systemheader:(RT94)#                   Update & print atom parameters
# ####################################################################
#
#                               RT94
#
# ####################################################################
SUBROUTINE RT94(LLV,LLT)#
include:(AACOMN)#
include:(RTCOMN)#
#
string:(OUTL,80)#
INTEGER I,J,K,L,II## General indices
INTEGER IA#                            Atom index
INTEGER IC#                            Constraints index
chardata:(RT941," Atom              x/a     y/b     z/c     U$#
       U11     U22     U33     U12     U13     U23     pop")#
chardata:(RT942, OLD SHF NEW ERR S/EATOM)#
chardata:(RT945, UIJ MATRIX FOR ATOM          NOT $#
POSITIVE DEFINITE -- SHIFTS MULTIPLIED BY         )#
realdata:(FMTA,[220742.,300742.,380742.,460742.,540742.,#
620742.,700742.,780742.,860742.,940742.,1020732.])#
datastuff:#
#
LINRM=6; IC=mflag:+nflag:#             Pointer in noref array
#
# LOOP OVER THE ATOMS
# -------------------
#
FOR(IA=matom:;IA<latom:;IA=IA+natom:)# Loop over the atoms
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1
movereal:(voidflg:,1,BUFOT,1,mxfdln:,2)# Zero op field buffer
movereal:(xf:,1, BUFOT,1,11,0)#        X to pop
movereal:(BUFOT,1,BUFOT,25,11,1)#      Set unshifted new values
#
# TRANSFER SHIFTS AND ESD'S
# -------------------------
#
L=no:#                                 Refine flag
IC=IC+nflag:; J=15#                    Incr noref array pointer#
DO I=1,11#                             Loop over atom parameters
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2
J=J+8#                                 Incr flag pointer
IF(QX(IC+I)<0.5) CHROT(J^J)='n'#       Flag as noref
ELSE IF(QX(IC+I)>CC)#                  Constrained parameter
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3
CHROT(J^J)='c'#                        Constr
K=NINT(QX(IC+I))#                      Get constraint packet addr
IR=NINT(QX(K+3))+VARPAT+(NPH-1)*NUMVAR(NPH)# Get ref vect addr
movereal:(QX,IR+MDVECT,BUFOT,12+I,1,0)# Put shifts in print buffer
movereal:(QX,IR+MDTEMP,BUFOT,36+I,1,0)# Put stdev. in print buffer
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3
ELSE#                                  Refined par
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4
L=yes:#                                Refine flag
CHROT(J^J)='r'#                        Refined parameter
movereal:(QX,LLV,BUFOT,12+I,1,0)#      Put shifts in print buffer
movereal:(QX,LLT,BUFOT,36+I,1,0)#      Put stdev. in print buffer
QX(IA+6+I)=QX(IA+6+I)+DAMPST*BUFOT(I+12)# Calculate new parameters
BUFOT(I+24)=QX(IA+6+I)#                Store new values
LLV=LLV+1;    LLT=LLT+1#               Incr shift & stdev lists
CALL RT96(IE)#                         Test thermal displ params
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2
#
# LIST SHIFTS AND NEW PARAMETERS
# ------------------------------
#
DO LI=1,4#                             Loop over print lines
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5
I=(LI-1)*12#                           Bufot pointer
movechar:(RT942,LI*4-3,CHROT,10,4,0)#  Insert line header
BUFOT(I+4)=BUFOT(I+4)/utob:#           Convert b to u
DO K=5,10; BUFOT(I+K)=BUFOT(I+K)*cbu:(K-4)# Convert to uij
DO J=1,11#                             Loop over parameters
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6
IF(BUFOT(J)<-99.) NEXT#                Test if a printable par
IF(LI==1)#                             Encode old  values
ncodefld:(BUFOT,J,CHROT,FMTA(J),1)#    Format values
IF(LI>1 & QX(IC+J)>0.5)#               Encode other lines if refined
ncodefld:(BUFOT,I+J,CHROT,FMTA(J),1)#  Format values
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6
IF(LI==1)#                             Old par line
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7
movertoc:(na:,1,CHROT,2,8,0)#          Insert atom name
writeline:(1,RT941,NRT941,1,3)#        Print atom line
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7
IF(LI>1&L==yes:) writeline:(0,0,0,1,3)# Lines 2-4 if ref
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5
movechar:(RT942,17,CHROT,10,4,0)#      Insert s/e line header
DO J=1,11#                             Loop over parameters
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8
IF(BUFOT(J+36)<small:) NEXT#           Skip if invariant
B=ABS(BUFOT(J+12)/BUFOT(J+36))#        Calc shift/std dev
SOEMAX=AMAX1(SOEMAX,B)#                Save s/e max
ncodefld:(B,1,CHROT,FMTA(J),1)#        Format shift/stdev
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8
IF(L==yes:)writeline:(0,0,0,1,3)#      Print shift/stdev line
IF(IE>0)#                              Test for error message
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9
movertoc:(na:,1,RT945,22,8,0)#         Move at atom name for print
writeline:(0,RT945,NRT945,3,3)#        Tell of non-pos. definite
IF(IE==2) iquit:(-RT9420)#             Bad matrix.......163620
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9
IF(PUNCH==yes:&NCY==NCYCLE)#           Punch if requested
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10
movechar:(RT942,1,OUTL,1,80,2)#        Blankout punch buffer
movechar:(RT942,22,OUTL,1,4,0)#        Insert 'atom' string
movertoc:(na:,1,OUTL,6,8,0)#           Insert atom name
ncodefld:(BUFOT,25,OUTL,FMTA,8)#       Format atom params
writepch:(OUTL,80)#                    Punch atom line
IF(DP<1.5) NEXT#                       Skip if not aniso tf
movechar:(RT942,1,OUTL,1,80,2)#        Blankout punch buffer
movechar:(RT942,26,OUTL,1,3,0)#        Insert 'uij' string
movertoc:(na:,1,OUTL,6,8,0)#           Insert atom name
DO J=1,6; BUFOT(J)=QX(IA+J+10)*cbu:(J)# Convert to uij
ncodefld:(BUFOT,1,OUTL,FMTA,6)#        Copy to output
writepch:(OUTL,80)#                    Punch 'uij'-card
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10
#
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1
RETURN#
END#
systemheader:(RT96)#                   Test for non-pos. definite
# ####################################################################
#
#                               RT96
#
# ####################################################################
SUBROUTINE RT96(IE)#
#
INTEGER IE#
IE=0#
RETURN#
END#
systemheader:(RT99)#                   Write o/p bdf's & quit
# ####################################################################
#
#                               RT99
#
# ####################################################################
SUBROUTINE RT99#
#
chardata:(RT991, ****** QUITTING TIME *******)#
datastuff:#
writeline:(0,RT991,NRT991,3,3)#
RETURN#
END#
#
pmacro:([no:])#                        Purge xtal system macros
